(module html-query-parser
   (export hqbgl:the-grammar
	   (hqbgl:fields html-query)
           (hqbgl:this-field nom fields-a-list)))

(define (unHex hexadecimal-string)
   (string (integer->char (string->integer hexadecimal-string 16))))

(define hqbgl:the-grammar
   (let ((fields-list '())
	 (field-name "")
	 (field-value ""))
      (regular-grammar ()
	 ((when (not (rgc-context? 'val))
	     (+ (or #\newline #\&)))
	  (ignore))
	 ((when (not (rgc-context? 'val))
	  (: (* (out "=%&")) "="))
	  (set! field-name
		(string-append
		 field-name
		 (the-substring 0 (-fx (the-length) 1))))
	  (rgc-context 'val)
	  (ignore))
	 ((when (not (rgc-context? 'val))
	   (: (* (out "=%&")) "%" xdigit xdigit))
	  (set! field-name
		(string-append
		 field-name
		 (the-substring 0
				(-fx (the-length) 3))
		 (unHex (the-substring (-fx (the-length) 2)
				       (the-length)))))
	  (ignore))
	 
	 ((when (rgc-context? 'val)
	  (+ (or #\newline #\&)))
	  (set! fields-list (cons (cons field-name field-value) fields-list))
	  (set! field-name "")
	  (set! field-value "")
	  (rgc-context)
	  (ignore))
	 ((when (rgc-context? 'val)
	   (: (* (out "&%+")) #\% xdigit xdigit))
	  (set! field-value
		(string-append
		 field-value
		 (the-substring 0
				(-fx (the-length) 3))
		 (unHex (the-substring (-fx (the-length) 2)
				       (the-length)))))
	  (ignore))
	 ((when (rgc-context? 'val)
	   (: (* (out "&%+")) "+"))
	  (set! field-value (string-append
			   field-value
			   (the-substring 0 (-fx (the-length) 1))
			   " "))
	  (ignore))
	 ((when (rgc-context? 'val)
	   (* (out "&%+")))
	  (set! field-value (string-append field-value (the-string)))
	  (set! fields-list (cons (cons field-name field-value) fields-list))
	  (set! field-name "")
	  (set! field-value "")
	  (rgc-context)
	  (ignore))

	 (else (reverse fields-list)))))

(define (hqbgl:fields html-query)
   (let ((p (open-input-string html-query)))
      (read/rp hqbgl:the-grammar p)))

(define (hqbgl:this-field the-name fields-a-list)
   (let ((result (assoc the-name fields-a-list)))
      (if result (cdr result)
	          result)))
