;*---------------------------------------------------------------------*/
;*    A practical implementation for the Scheme programming language   */
;*                                                                     */
;*                                    ,--^,                            */
;*                              _ ___/ /|/                             */
;*                          ,;'( )__, ) '                              */
;*                         ;;  //   L__.                               */
;*                         '   \\   /  '                               */
;*                              ^   ^                                  */
;*                                                                     */
;*               Copyright (c) 1992-1999 Manuel Serrano                */
;*                                                                     */
;*     Bug descriptions, use reports, comments or suggestions are      */
;*     welcome. Send them to                                           */
;*       bigloo@kaolin.unice.fr                                        */
;*       http://kaolin.unice.fr/bigloo                                 */
;*                                                                     */
;*   This program is free software; you can redistribute it            */
;*   and/or modify it under the terms of the GNU General Public        */
;*   License as published by the Free Software Foundation; either      */
;*   version 2 of the License, or (at your option) any later version.  */
;*                                                                     */
;*   This program is distributed in the hope that it will be useful,   */
;*   but WITHOUT ANY WARRANTY; without even the implied warranty of    */
;*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     */
;*   GNU General Public License for more details.                      */
;*                                                                     */
;*   You should have received a copy of the GNU General Public         */
;*   License along with this program; if not, write to the Free        */
;*   Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,   */
;*   MA 02111-1307, USA.                                               */
;*---------------------------------------------------------------------*/
;*=====================================================================*/
;*    serrano/prgm/project/bdk/kbdb/src/Bee/binvoke.scm                */
;*    -------------------------------------------------------------    */
;*    Author      :  Manuel Serrano                                    */
;*    Creation    :  Wed Jul 28 06:57:54 1999                          */
;*    Last change :  Mon Aug  2 18:36:12 1999 (serrano)                */
;*    -------------------------------------------------------------    */
;*    Invoking the Bee.                                                */
;*=====================================================================*/

;*---------------------------------------------------------------------*/
;*    The module                                                       */
;*---------------------------------------------------------------------*/
(module bee_invoke
   (import engine_param)
   (export (bee-call   command::bstring . args)
	   (bee-notify command::bstring . args)))

;*---------------------------------------------------------------------*/
;*    bee-call ...                                                     */
;*    -------------------------------------------------------------    */
;*    Call a service from the Bee.                                     */
;*---------------------------------------------------------------------*/
(define (bee-call fun . args)
   ;; first, we construct the command line
   (let ((cmd (match-case args
		 (()
		  (string-append "(" fun ")"))
		 (else
		  (let loop ((cmd (reverse args))
			     (res ")"))
		     (if (null? cmd)
			 (string-append "(" fun " " res)
			 (loop (cdr cmd)
			       (string-append "\"" (car cmd) "\" " res))))))))
      ;; emit the request
      (fprint *bout* cmd)
      ;; read the reply
      (read *bin*)))
	 
;*---------------------------------------------------------------------*/
;*    bee-notify ...                                                   */
;*    -------------------------------------------------------------    */
;*    Call a service from the Bee.                                     */
;*---------------------------------------------------------------------*/
(define (bee-notify fun . args)
   ;; first, we construct the command line
   (let ((cmd (match-case args
		 (()
		  (string-append "(" fun ")"))
		 (else
		  (let loop ((cmd (reverse args))
			     (res ")"))
		     (if (null? cmd)
			 (string-append "(" fun " " res)
			 (loop (cdr cmd)
			       (string-append (car cmd) " " res))))))))
      ;; emit the request
      (fprint *bout* cmd)))
	 
