;*---------------------------------------------------------------------*/
;*    A practical implementation for the Scheme programming language   */
;*                                                                     */
;*                                    ,--^,                            */
;*                              _ ___/ /|/                             */
;*                          ,;'( )__, ) '                              */
;*                         ;;  //   L__.                               */
;*                         '   \\   /  '                               */
;*                              ^   ^                                  */
;*                                                                     */
;*               Copyright (c) 1992-1999 Manuel Serrano                */
;*                                                                     */
;*     Bug descriptions, use reports, comments or suggestions are      */
;*     welcome. Send them to                                           */
;*       bigloo@kaolin.unice.fr                                        */
;*       http://kaolin.unice.fr/bigloo                                 */
;*                                                                     */
;*   This program is free software; you can redistribute it            */
;*   and/or modify it under the terms of the GNU General Public        */
;*   License as published by the Free Software Foundation; either      */
;*   version 2 of the License, or (at your option) any later version.  */
;*                                                                     */
;*   This program is distributed in the hope that it will be useful,   */
;*   but WITHOUT ANY WARRANTY; without even the implied warranty of    */
;*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     */
;*   GNU General Public License for more details.                      */
;*                                                                     */
;*   You should have received a copy of the GNU General Public         */
;*   License along with this program; if not, write to the Free        */
;*   Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,   */
;*   MA 02111-1307, USA.                                               */
;*---------------------------------------------------------------------*/
;*=====================================================================*/
;*    serrano/prgm/project/bdk/kbdb/kbdb/Command/mangle.scm            */
;*    -------------------------------------------------------------    */
;*    Author      :  Manuel Serrano                                    */
;*    Creation    :  Wed Jul 28 09:29:59 1999                          */
;*    Last change :  Tue Aug  3 15:10:44 1999 (serrano)                */
;*    -------------------------------------------------------------    */
;*    The mangle/demangle user facility. We provide the use with this  */
;*    facility mostly for bdb debug purposes.                          */
;*=====================================================================*/

;*---------------------------------------------------------------------*/
;*    The module                                                       */
;*---------------------------------------------------------------------*/
(module command_mangle
   (import tools_error
	   tools_io
	   patient_mangling
	   patient_invoke
	   command_command
	   command_parse
	   gdb_invoke
	   engine_param))

;*---------------------------------------------------------------------*/
;*    mangle-command-parse ...                                         */
;*---------------------------------------------------------------------*/
(define (mangle-command-parse base cmd-list source::bstring level::int env)
   (match-case cmd-list
      (()
       (bdb-error base "missing argument" source))
      ((?fun)
       (let* ((cmd (string-append "\"" fun "\""))
	      (mgl (patient-call base cmd)))
	  (if mgl
	      (begin
		 (console-echo mgl)
		 (console-newline))
	      (bdb-error base "Can't find variable" fun))))
      ((?fun ?local)
       (let* ((base (string-append base "2"))
	      (cmd  (string-append "\"" fun "\", \"" local "\""))
	      (mgl  (patient-call base cmd)))
	  (if mgl
	      (begin
		 (console-echo mgl)
		 (console-newline))
	      (bdb-error base "Can't find variables " local))))
      ((?- ?- . ?rest)
       (parse-error "Junk at end of arguments." (car rest) source 2))))
 
;*---------------------------------------------------------------------*/
;*    The mangle command                                               */
;*---------------------------------------------------------------------*/
(bind-toplevel-command! "mangle"
			3
			(lambda (cmd-list source level env)
			   (mangle-command-parse "bdb_mangle"
						 cmd-list
						 source
						 level
						 env))
			"Display the C name for a Bigloo identifier.")
(bind-toplevel-command! "demangle"
			3
			(lambda (cmd-list source level env)
			   (mangle-command-parse "bdb_demangle"
						 cmd-list
						 source
						 level
						 env))
			"Display the Bigloo name for a C identifier.")

