;*---------------------------------------------------------------------*/
;*    A practical implementation for the Scheme programming language   */
;*                                                                     */
;*                                    ,--^,                            */
;*                              _ ___/ /|/                             */
;*                          ,;'( )__, ) '                              */
;*                         ;;  //   L__.                               */
;*                         '   \\   /  '                               */
;*                              ^   ^                                  */
;*                                                                     */
;*               Copyright (c) 1992-1999 Manuel Serrano                */
;*                                                                     */
;*     Bug descriptions, use reports, comments or suggestions are      */
;*     welcome. Send them to                                           */
;*       bigloo@kaolin.unice.fr                                        */
;*       http://kaolin.unice.fr/bigloo                                 */
;*                                                                     */
;*   This program is free software; you can redistribute it            */
;*   and/or modify it under the terms of the GNU General Public        */
;*   License as published by the Free Software Foundation; either      */
;*   version 2 of the License, or (at your option) any later version.  */
;*                                                                     */
;*   This program is distributed in the hope that it will be useful,   */
;*   but WITHOUT ANY WARRANTY; without even the implied warranty of    */
;*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     */
;*   GNU General Public License for more details.                      */
;*                                                                     */
;*   You should have received a copy of the GNU General Public         */
;*   License along with this program; if not, write to the Free        */
;*   Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,   */
;*   MA 02111-1307, USA.                                               */
;*---------------------------------------------------------------------*/
;*=====================================================================*/
;*    serrano/prgm/project/bdk/kbdb/kbdb/Command/quit.scm              */
;*    -------------------------------------------------------------    */
;*    Author      :  Manuel Serrano                                    */
;*    Creation    :  Tue Jul 27 11:02:35 1999                          */
;*    Last change :  Mon Aug 23 17:56:31 1999 (serrano)                */
;*    -------------------------------------------------------------    */
;*    The quit & kill commands                                         */
;*=====================================================================*/

;*---------------------------------------------------------------------*/
;*    The module                                                       */
;*---------------------------------------------------------------------*/
(module command_quit
   (import command_command
	   command_parse
	   engine_param
	   engine_engine
	   (console-echo tools_io)
	   (gdb-call-for-output gdb_invoke)
	   (gdb-reset-stack! gdb_annotate)))

;*---------------------------------------------------------------------*/
;*    the Quit command                                                 */
;*---------------------------------------------------------------------*/
(bind-toplevel-command! "quit"
			1
			(make-stop-parse
			 (lambda (_)
			    ;; we always kill the running process before...
			    (gdb-call-for-output "kill")
			    ;; quitting bdb
			    (bdb-exit 0)))
			"Exit Bdb.")
	 		
;*---------------------------------------------------------------------*/
;*    the Kill command                                                 */
;*---------------------------------------------------------------------*/
(bind-toplevel-command! "kill"
			1
			(lambda (cmd-list source level env)
			   (console-echo (gdb-call-for-output source))
			   (gdb-reset-stack!))
			"Kill execution of program being debugged.")
