;*---------------------------------------------------------------------*/
;*    A practical implementation for the Scheme programming language   */
;*                                                                     */
;*                                    ,--^,                            */
;*                              _ ___/ /|/                             */
;*                          ,;'( )__, ) '                              */
;*                         ;;  //   L__.                               */
;*                         '   \\   /  '                               */
;*                              ^   ^                                  */
;*                                                                     */
;*               Copyright (c) 1992-1999 Manuel Serrano                */
;*                                                                     */
;*     Bug descriptions, use reports, comments or suggestions are      */
;*     welcome. Send them to                                           */
;*       bigloo@kaolin.unice.fr                                        */
;*       http://kaolin.unice.fr/bigloo                                 */
;*                                                                     */
;*   This program is free software; you can redistribute it            */
;*   and/or modify it under the terms of the GNU General Public        */
;*   License as published by the Free Software Foundation; either      */
;*   version 2 of the License, or (at your option) any later version.  */
;*                                                                     */
;*   This program is distributed in the hope that it will be useful,   */
;*   but WITHOUT ANY WARRANTY; without even the implied warranty of    */
;*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     */
;*   GNU General Public License for more details.                      */
;*                                                                     */
;*   You should have received a copy of the GNU General Public         */
;*   License along with this program; if not, write to the Free        */
;*   Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,   */
;*   MA 02111-1307, USA.                                               */
;*---------------------------------------------------------------------*/
;*=====================================================================*/
;*    serrano/prgm/project/bdk/kbdb/src/Command/run.scm                */
;*    -------------------------------------------------------------    */
;*    Author      :  Manuel Serrano                                    */
;*    Creation    :  Fri Aug  6 06:37:14 1999                          */
;*    Last change :  Tue Aug 31 09:16:27 1999 (serrano)                */
;*    -------------------------------------------------------------    */
;*    The run command                                                  */
;*=====================================================================*/

;*---------------------------------------------------------------------*/
;*    The module                                                       */
;*---------------------------------------------------------------------*/
(module command_run
   (include "Engine/hooks.sch")
   (import  command_command
	    command_parse
	    engine_param
	    engine_engine
	    tools_io
	    patient_server
	    gdb_invoke)
   (export  (add-run-hook! ::procedure)))

;*---------------------------------------------------------------------*/
;*    *run-hooks* ...                                                  */
;*---------------------------------------------------------------------*/
(define *run-hooks* '())

;*---------------------------------------------------------------------*/
;*    add-run-hook! ...                                                */
;*---------------------------------------------------------------------*/
(define (add-run-hook! fun::procedure)
   (set! *run-hooks* (cons fun *run-hooks*)))

;*---------------------------------------------------------------------*/
;*    run-parser ...                                                   */
;*---------------------------------------------------------------------*/
(define (run-parser cmd-list source level env)
   ;; we have to reset the Bdb server
   (close-server!)
   ;; we have to execute all the run hooks
   (run-hooks *run-hooks*)
   ;; and then we can issue the command
   (console-echo (gdb-call-for-output source)))

;*---------------------------------------------------------------------*/
;*    *help-run* ...                                                   */
;*---------------------------------------------------------------------*/
(define *help-run*
   "Start debugged program.  You may specify arguments to give it.
Args may include \"*\", or \"[...]\"; they are expanded using \"sh\".
Input and output redirection with \">\", \"<\", or \">>\" are also allowed.

With no arguments, uses arguments last specified (with \"run\" or \"set args\").
To cancel previous arguments and run with no arguments,
use \"set args\" without arguments.")

;*---------------------------------------------------------------------*/
;*    the Quit command                                                 */
;*---------------------------------------------------------------------*/
(bind-toplevel-command! "run"
			1
			run-parser
			*help-run*)

