;*---------------------------------------------------------------------*/
;*    A practical implementation for the Scheme programming language   */
;*                                                                     */
;*                                    ,--^,                            */
;*                              _ ___/ /|/                             */
;*                          ,;'( )__, ) '                              */
;*                         ;;  //   L__.                               */
;*                         '   \\   /  '                               */
;*                              ^   ^                                  */
;*                                                                     */
;*               Copyright (c) 1992-1999 Manuel Serrano                */
;*                                                                     */
;*     Bug descriptions, use reports, comments or suggestions are      */
;*     welcome. Send them to                                           */
;*       bigloo@kaolin.unice.fr                                        */
;*       http://kaolin.unice.fr/bigloo                                 */
;*                                                                     */
;*   This program is free software; you can redistribute it            */
;*   and/or modify it under the terms of the GNU General Public        */
;*   License as published by the Free Software Foundation; either      */
;*   version 2 of the License, or (at your option) any later version.  */
;*                                                                     */
;*   This program is distributed in the hope that it will be useful,   */
;*   but WITHOUT ANY WARRANTY; without even the implied warranty of    */
;*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     */
;*   GNU General Public License for more details.                      */
;*                                                                     */
;*   You should have received a copy of the GNU General Public         */
;*   License along with this program; if not, write to the Free        */
;*   Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,   */
;*   MA 02111-1307, USA.                                               */
;*---------------------------------------------------------------------*/
;*=====================================================================*/
;*    serrano/prgm/project/bdk/kbdb/src/Tools/error.scm                */
;*    -------------------------------------------------------------    */
;*    Author      :  Manuel Serrano                                    */
;*    Creation    :  Tue Jul 27 09:50:03 1999                          */
;*    Last change :  Wed Sep 15 16:57:33 1999 (serrano)                */
;*    -------------------------------------------------------------    */
;*    A simple ad-hoc error routine                                    */
;*=====================================================================*/

;*---------------------------------------------------------------------*/
;*    The module                                                       */
;*---------------------------------------------------------------------*/
(module tools_error
   (import engine_param
	   tools_io)
   (export (bdb-error        obj proc msg)
	   (bdb-notify-error obj proc msg)))

;*---------------------------------------------------------------------*/
;*    bdb-error ...                                                    */
;*---------------------------------------------------------------------*/
(define (bdb-error obj proc msg)
   (bdb-notify-error obj proc msg))

;*---------------------------------------------------------------------*/
;*    bdb-notify-error ...                                             */
;*---------------------------------------------------------------------*/
(define (bdb-notify-error obj proc msg)
   (define (shape obj)
      (if (string? obj)
	  obj
	  (let ((port (open-output-string)))
	     (write obj port)
	     (close-output-port port))))
   (let ((proc (shape proc))
	 (msg  (shape msg))
	 (obj  (shape obj)))
      (console-error (string-append obj ": " proc " `" msg #"'.\n"))))
