;*---------------------------------------------------------------------*/
;*    A practical implementation for the Scheme programming language   */
;*                                                                     */
;*                                    ,--^,                            */
;*                              _ ___/ /|/                             */
;*                          ,;'( )__, ) '                              */
;*                         ;;  //   L__.                               */
;*                         '   \\   /  '                               */
;*                              ^   ^                                  */
;*                                                                     */
;*               Copyright (c) 1992-1999 Manuel Serrano                */
;*                                                                     */
;*     Bug descriptions, use reports, comments or suggestions are      */
;*     welcome. Send them to                                           */
;*       bigloo@kaolin.unice.fr                                        */
;*       http://kaolin.unice.fr/bigloo                                 */
;*                                                                     */
;*   This program is free software; you can redistribute it            */
;*   and/or modify it under the terms of the GNU General Public        */
;*   License as published by the Free Software Foundation; either      */
;*   version 2 of the License, or (at your option) any later version.  */
;*                                                                     */
;*   This program is distributed in the hope that it will be useful,   */
;*   but WITHOUT ANY WARRANTY; without even the implied warranty of    */
;*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     */
;*   GNU General Public License for more details.                      */
;*                                                                     */
;*   You should have received a copy of the GNU General Public         */
;*   License along with this program; if not, write to the Free        */
;*   Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,   */
;*   MA 02111-1307, USA.                                               */
;*---------------------------------------------------------------------*/
;*=====================================================================*/
;*    serrano/prgm/project/bigloo/bdb/Lib/dump.scm                     */
;*    -------------------------------------------------------------    */
;*    Author      :  Manuel Serrano                                    */
;*    Creation    :  Tue Aug  3 10:13:43 1999                          */
;*    Last change :  Tue Aug  3 11:35:25 1999 (serrano)                */
;*    -------------------------------------------------------------    */
;*    The graphical dump of a heap. This produces a pixmap             */
;*    representing the heap. Each memory word is represented by one    */
;*    pixel in that image.                                             */
;*=====================================================================*/

;*---------------------------------------------------------------------*/
;*    The module                                                       */
;*---------------------------------------------------------------------*/
(module __bdb_dump

   (extern (bdb-dump-heap::int (::string ::int ::int) "bdb_dump_heap"))
   
   (export (gc-dump-heap file-name::bstring width::int depth::int)))

;*---------------------------------------------------------------------*/
;*    gc-dump-heap ...                                                 */
;*    -------------------------------------------------------------    */
;*    The parameter of DUMP are:                                       */
;*       FILE-NAME: the file to be produced.                           */
;*       WIDTH: the horizontal width of the pixmap.                    */
;*       DEPTH: the depth of the pixmap.                               */
;*---------------------------------------------------------------------*/
(define (gc-dump-heap file-name width depth)
   (bdb-dump-heap file-name width depth))
