;*---------------------------------------------------------------------*/
;*    A practical implementation for the Scheme programming language   */
;*                                                                     */
;*                                    ,--^,                            */
;*                              _ ___/ /|/                             */
;*                          ,;'( )__, ) '                              */
;*                         ;;  //   L__.                               */
;*                         '   \\   /  '                               */
;*                              ^   ^                                  */
;*                                                                     */
;*               Copyright (c) 1992-1999 Manuel Serrano                */
;*                                                                     */
;*     Bug descriptions, use reports, comments or suggestions are      */
;*     welcome. Send them to                                           */
;*       bigloo@kaolin.unice.fr                                        */
;*       http://kaolin.unice.fr/bigloo                                 */
;*                                                                     */
;*   This program is free software; you can redistribute it            */
;*   and/or modify it under the terms of the GNU General Public        */
;*   License as published by the Free Software Foundation; either      */
;*   version 2 of the License, or (at your option) any later version.  */
;*                                                                     */
;*   This program is distributed in the hope that it will be useful,   */
;*   but WITHOUT ANY WARRANTY; without even the implied warranty of    */
;*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     */
;*   GNU General Public License for more details.                      */
;*                                                                     */
;*   You should have received a copy of the GNU General Public         */
;*   License along with this program; if not, write to the Free        */
;*   Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,   */
;*   MA 02111-1307, USA.                                               */
;*---------------------------------------------------------------------*/
;*=====================================================================*/
;*    serrano/prgm/project/bmacs/cee/cee-hook.el                       */
;*    -------------------------------------------------------------    */
;*    Author      :  Manuel Serrano                                    */
;*    Creation    :  Tue Nov 17 08:49:24 1998                          */
;*    Last change :  Tue Nov 24 16:54:14 1998 (serrano)                */
;*    -------------------------------------------------------------    */
;*    The CEE hook that sets up all the CEE configuration.             */
;*=====================================================================*/

;*---------------------------------------------------------------------*/
;*    The module                                                       */
;*---------------------------------------------------------------------*/
(provide 'cee-hook)
(require 'font-lock)
(require 'cee-indent)
(require 'cee-keymap)
(require 'cee-toolbar)
(require 'cee-flock)
(require 'ude-autoload)
(require 'ude-config)
(require 'ude-custom)
(require 'dbg-autoload)

;*---------------------------------------------------------------------*/
;*    cee-docline ...                                                  */
;*---------------------------------------------------------------------*/
(defun cee-docline ()
  (interactive)
  (setq ude-info-file-list cee-info-file-list)
  (ude-info-docline (cee-font-lock-get-info-keywords)))

;*---------------------------------------------------------------------*/
;*    cee-docline-init ...                                             */
;*    -------------------------------------------------------------    */
;*    Initialize the docline system, that is, tell Ude to use          */
;*    info with the Bigloo page.                                       */
;*---------------------------------------------------------------------*/
(defun cee-docline-init ()
  (setq ude-docline (function ude-info-docline)))
  
;*---------------------------------------------------------------------*/
;*    cee-hook ...                                                     */
;*---------------------------------------------------------------------*/
(defun cee-hook ()
  ;; we setup the project root directory
  (ude-auto-set-root-directory)
  ;; docline initialization
  (cee-docline-init)
  ;; the key binding
  (cee-keymap-init)
  ;; parenthesis blinking init
  (ude-paren-init)
  ;; profiling
  (setq ude-profile-highlight-buffer 'cee-profile-highlight-buffer)
  ;; starting font-lock
  (if ude-font-lock-p
      (font-lock-mode t))
  ;; the toolbar
  (cee-toolbar-init)
  ;; the cee hook
  (run-hooks 'cee-hook))
 
