/*===========================================================================*/
/*   (Ast/alphatize.scm)                                                     */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;


static obj_t method_init_76_ast_alphatize();
extern obj_t make_box_202_ast_node;
extern obj_t funcall_ast_node;
extern long add_inlined_method__244___object(obj_t, obj_t, long);
extern node_bglt known_app_ly__node_26_ast_apply(obj_t, obj_t, node_bglt, node_bglt, obj_t);
extern obj_t fail_ast_node;
extern obj_t box_ref_242_ast_node;
extern obj_t sequence_ast_node;
extern obj_t let_var_6_ast_node;
extern obj_t var_ast_node;
extern obj_t closure_ast_node;
static obj_t _location__189_ast_alphatize = BUNSPEC;
extern obj_t pragma_ast_node;
extern obj_t set_ex_it_116_ast_node;
static obj_t _alphatize2090_ast_alphatize(obj_t, obj_t, obj_t, obj_t, obj_t);
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t module_initialization_70_ast_alphatize(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_ast_sexp(long, char *);
extern obj_t module_initialization_70_ast_local(long, char *);
extern obj_t module_initialization_70_ast_apply(long, char *);
extern obj_t module_initialization_70_ast_app(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern local_bglt make_local_svar_140_ast_local(obj_t, type_bglt);
extern long class_num_218___object(obj_t);
extern obj_t let_fun_218_ast_node;
extern obj_t fun_ast_var;
static obj_t imported_modules_init_94_ast_alphatize();
extern bool_t correct_arity_app__187_ast_app(variable_bglt, obj_t);
extern obj_t app_ly_162_ast_node;
extern obj_t add_generic__110___object(obj_t, obj_t);
static node_bglt do_alphatize_126_ast_alphatize(node_bglt);
extern obj_t app_ast_node;
extern obj_t append_2_18___r4_pairs_and_lists_6_3(obj_t, obj_t);
static obj_t library_modules_init_112_ast_alphatize();
static obj_t _do_alphatize_default1563_199_ast_alphatize(obj_t, obj_t);
extern obj_t atom_ast_node;
extern obj_t cast_ast_node;
static obj_t toplevel_init_63_ast_alphatize();
extern obj_t jump_ex_it_184_ast_node;
extern obj_t open_input_string(obj_t);
extern obj_t kwote_ast_node;
extern obj_t use_variable__4_ast_sexp(variable_bglt, obj_t, obj_t);
extern local_bglt make_local_sfun_184_ast_local(obj_t, type_bglt, sfun_bglt);
extern node_bglt alphatize_ast_alphatize(obj_t, obj_t, obj_t, node_bglt);
extern obj_t sfun_ast_var;
extern obj_t setq_ast_node;
extern obj_t box_set__221_ast_node;
extern obj_t variable_ast_var;
static node_bglt do_alphatize_default1563_175_ast_alphatize(node_bglt);
static obj_t _do_alphatize2091_253_ast_alphatize(obj_t, obj_t);
extern obj_t shape_tools_shape(obj_t);
extern obj_t internal_error_43_tools_error(obj_t, obj_t, obj_t);
extern local_bglt make_local_sexit_184_ast_local(obj_t, type_bglt, sexit_bglt);
extern obj_t sexit_ast_var;
extern obj_t _classes__134___object;
extern obj_t select_ast_node;
extern obj_t read___reader(obj_t);
extern node_bglt make_app_node_80_ast_app(obj_t, obj_t, var_bglt, obj_t);
static obj_t require_initialization_114_ast_alphatize = BUNSPEC;
extern obj_t conditional_ast_node;
static obj_t cnst_init_137_ast_alphatize();
extern obj_t user_error_location_137_tools_error(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t get_location_95_ast_alphatize(obj_t);
static obj_t __cnst[4];

DEFINE_EXPORT_PROCEDURE(alphatize_env_10_ast_alphatize, _alphatize2090_ast_alphatize2102, _alphatize2090_ast_alphatize, 0L, 4);
DEFINE_STATIC_GENERIC(do_alphatize_env_178_ast_alphatize, _do_alphatize2091_253_ast_alphatize2103, _do_alphatize2091_253_ast_alphatize, 0L, 1);
DEFINE_STATIC_PROCEDURE(do_alphatize_default1563_env_176_ast_alphatize, _do_alphatize_default1563_199_ast_alphatize2104, _do_alphatize_default1563_199_ast_alphatize, 0L, 1);
DEFINE_STRING(string2097_ast_alphatize, string2097_ast_alphatize2105, "DO-ALPHATIZE-DEFAULT1563 SET! VALUE LOCATION ", 45);
DEFINE_STRING(string2096_ast_alphatize, string2096_ast_alphatize2106, "No method for this object", 25);
DEFINE_STRING(string2095_ast_alphatize, string2095_ast_alphatize2107, "wrong number of argument(s)", 27);
DEFINE_STRING(string2094_ast_alphatize, string2094_ast_alphatize2108, "Illegal application", 19);
DEFINE_STRING(string2093_ast_alphatize, string2093_ast_alphatize2109, "Illegal alphatization", 21);
DEFINE_STRING(string2092_ast_alphatize, string2092_ast_alphatize2110, "alphatize", 9);



/* module-initialization */
obj_t 
module_initialization_70_ast_alphatize(long checksum_2689, char *from_2690)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_ast_alphatize))
	{
	   require_initialization_114_ast_alphatize =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_ast_alphatize();
	   cnst_init_137_ast_alphatize();
	   imported_modules_init_94_ast_alphatize();
	   method_init_76_ast_alphatize();
	   toplevel_init_63_ast_alphatize();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_ast_alphatize()
{
   AN_OBJECT;
   {	/* Ast/alphatize.scm 14 */
      module_initialization_70___object(((long) 0), "AST_ALPHATIZE");
      module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "AST_ALPHATIZE");
      module_initialization_70___reader(((long) 0), "AST_ALPHATIZE");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_ast_alphatize()
{
   AN_OBJECT;
   {	/* Ast/alphatize.scm 14 */
      {		/* Ast/alphatize.scm 14 */
	 obj_t cnst_port_138_2682;
	 cnst_port_138_2682 =
	    open_input_string(string2097_ast_alphatize);
	 {
	    long i_2683;
	    i_2683 = ((long) 3);
	  loop_2684:
	    {	/* Ast/alphatize.scm 14 */
	       bool_t test2098_2685;
	       test2098_2685 =
		  (i_2683 == ((long) -1));
	       if (test2098_2685)
		 {	/* Ast/alphatize.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Ast/alphatize.scm 14 */
		    {	/* Ast/alphatize.scm 14 */
		       obj_t arg2099_2686;
		       {	/* Ast/alphatize.scm 14 */
			  obj_t list2100_2687;
			  list2100_2687 =
			     MAKE_PAIR(cnst_port_138_2682, BNIL);
			  arg2099_2686 =
			     read___reader(list2100_2687);
		       }
		       CNST_TABLE_SET(i_2683, arg2099_2686);
		    }
		    {	/* Ast/alphatize.scm 14 */
		       int aux_2688;
		       {	/* Ast/alphatize.scm 14 */
			  long aux_2708;
			  aux_2708 =
			     (i_2683 - ((long) 1));
			  aux_2688 =
			     (int) (aux_2708);
		       }
		       {
			  long i_2711;
			  i_2711 =
			     (long) (aux_2688);
			  i_2683 = i_2711;
			  goto loop_2684;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_ast_alphatize()
{
   AN_OBJECT;
   {	/* Ast/alphatize.scm 14 */
      _location__189_ast_alphatize = BFALSE;
      return BUNSPEC;
   }
}



/* alphatize */
node_bglt 
alphatize_ast_alphatize(obj_t what__148_15, obj_t by__251_16, obj_t loc_17, node_bglt node_18)
{
   AN_OBJECT;
   {	/* Ast/alphatize.scm 37 */
      {
	 obj_t ll1437_748;
	 obj_t ll1438_749;
	 ll1437_748 = what__148_15;
	 ll1438_749 = by__251_16;
       lname1439_750:
	 if (
	    NULLP(ll1437_748))
	   {	/* Ast/alphatize.scm 39 */
	      ((bool_t) 1);
	   }
	 else
	   {	/* Ast/alphatize.scm 39 */
	      {		/* Ast/alphatize.scm 40 */
		 obj_t by_753;
		 by_753 =
		    CAR(ll1438_749);
		 {	/* Ast/alphatize.scm 40 */
		    variable_bglt obj_1647;
		    {	/* Ast/alphatize.scm 40 */
		       obj_t aux_2716;
		       aux_2716 =
			  CAR(ll1437_748);
		       obj_1647 =
			  (variable_bglt) (aux_2716);
		    }
		    ((((variable_bglt) CREF(obj_1647))->fast_alpha_7) = ((obj_t) by_753), BUNSPEC);
		 }
	      }
	      {
		 obj_t ll1438_2722;
		 obj_t ll1437_2720;
		 ll1437_2720 =
		    CDR(ll1437_748);
		 ll1438_2722 =
		    CDR(ll1438_749);
		 ll1438_749 = ll1438_2722;
		 ll1437_748 = ll1437_2720;
		 goto lname1439_750;
	      }
	   }
      }
      _location__189_ast_alphatize = loc_17;
      {		/* Ast/alphatize.scm 44 */
	 node_bglt res_756;
	 res_756 =
	    do_alphatize_126_ast_alphatize(node_18);
	 {
	    obj_t l1440_757;
	    l1440_757 = what__148_15;
	  lname1441_758:
	    if (
	       PAIRP(l1440_757))
	      {		/* Ast/alphatize.scm 46 */
		 {	/* Ast/alphatize.scm 47 */
		    variable_bglt obj_1653;
		    {	/* Ast/alphatize.scm 47 */
		       obj_t aux_2727;
		       aux_2727 =
			  CAR(l1440_757);
		       obj_1653 =
			  (variable_bglt) (aux_2727);
		    }
		    ((((variable_bglt) CREF(obj_1653))->fast_alpha_7) = ((obj_t) BUNSPEC), BUNSPEC);
		 }
		 {
		    obj_t l1440_2731;
		    l1440_2731 =
		       CDR(l1440_757);
		    l1440_757 = l1440_2731;
		    goto lname1441_758;
		 }
	      }
	    else
	      {		/* Ast/alphatize.scm 46 */
		 ((bool_t) 1);
	      }
	 }
	 return res_756;
      }
   }
}



/* _alphatize2090 */
obj_t 
_alphatize2090_ast_alphatize(obj_t env_2672, obj_t what__148_2673, obj_t by__251_2674, obj_t loc_2675, obj_t node_2676)
{
   AN_OBJECT;
   {	/* Ast/alphatize.scm 37 */
      {		/* Ast/alphatize.scm 37 */
	 node_bglt aux_2733;
	 aux_2733 =
	    alphatize_ast_alphatize(what__148_2673, by__251_2674, loc_2675,
	    (node_bglt) (node_2676));
	 return
	    (obj_t) (aux_2733);
      }
   }
}



/* get-location */
obj_t 
get_location_95_ast_alphatize(obj_t node_19)
{
   AN_OBJECT;
   {	/* Ast/alphatize.scm 59 */
      {		/* Ast/alphatize.scm 60 */
	 bool_t test_2737;
	 {	/* Ast/alphatize.scm 60 */
	    obj_t arg1623_763;
	    {	/* Ast/alphatize.scm 60 */
	       node_bglt obj_1656;
	       obj_1656 =
		  (node_bglt) (node_19);
	       arg1623_763 =
		  (((node_bglt) CREF(obj_1656))->loc);
	    }
	    if (
	       STRUCTP(arg1623_763))
	      {		/* ./Ieee/equiv.scm 5508 */
		 obj_t aux_2744;
		 obj_t aux_2742;
		 aux_2744 =
		    CNST_TABLE_REF(((long) 0));
		 aux_2742 =
		    STRUCT_KEY(arg1623_763);
		 test_2737 =
		    (aux_2742 == aux_2744);
	      }
	    else
	      {		/* ./Tools/location.sch 650 */
		 test_2737 = ((bool_t) 0)
		    ;
	      }
	 }
	 if (test_2737)
	   {	/* Ast/alphatize.scm 61 */
	      node_bglt obj_1665;
	      obj_1665 =
		 (node_bglt) (node_19);
	      return
		 (((node_bglt) CREF(obj_1665))->loc);
	   }
	 else
	   {	/* Ast/alphatize.scm 60 */
	      return _location__189_ast_alphatize;
	   }
      }
   }
}



/* method-init */
obj_t 
method_init_76_ast_alphatize()
{
   AN_OBJECT;
   {	/* Ast/alphatize.scm 14 */
      add_generic__110___object(do_alphatize_env_178_ast_alphatize, do_alphatize_default1563_env_176_ast_alphatize);
      add_inlined_method__244___object(do_alphatize_env_178_ast_alphatize, atom_ast_node, ((long) 0));
      add_inlined_method__244___object(do_alphatize_env_178_ast_alphatize, var_ast_node, ((long) 1));
      add_inlined_method__244___object(do_alphatize_env_178_ast_alphatize, closure_ast_node, ((long) 2));
      add_inlined_method__244___object(do_alphatize_env_178_ast_alphatize, kwote_ast_node, ((long) 3));
      add_inlined_method__244___object(do_alphatize_env_178_ast_alphatize, sequence_ast_node, ((long) 4));
      add_inlined_method__244___object(do_alphatize_env_178_ast_alphatize, app_ast_node, ((long) 5));
      add_inlined_method__244___object(do_alphatize_env_178_ast_alphatize, app_ly_162_ast_node, ((long) 6));
      add_inlined_method__244___object(do_alphatize_env_178_ast_alphatize, funcall_ast_node, ((long) 7));
      add_inlined_method__244___object(do_alphatize_env_178_ast_alphatize, pragma_ast_node, ((long) 8));
      add_inlined_method__244___object(do_alphatize_env_178_ast_alphatize, cast_ast_node, ((long) 9));
      add_inlined_method__244___object(do_alphatize_env_178_ast_alphatize, setq_ast_node, ((long) 10));
      add_inlined_method__244___object(do_alphatize_env_178_ast_alphatize, conditional_ast_node, ((long) 11));
      add_inlined_method__244___object(do_alphatize_env_178_ast_alphatize, fail_ast_node, ((long) 12));
      add_inlined_method__244___object(do_alphatize_env_178_ast_alphatize, select_ast_node, ((long) 13));
      add_inlined_method__244___object(do_alphatize_env_178_ast_alphatize, make_box_202_ast_node, ((long) 14));
      add_inlined_method__244___object(do_alphatize_env_178_ast_alphatize, box_ref_242_ast_node, ((long) 15));
      add_inlined_method__244___object(do_alphatize_env_178_ast_alphatize, box_set__221_ast_node, ((long) 16));
      add_inlined_method__244___object(do_alphatize_env_178_ast_alphatize, let_fun_218_ast_node, ((long) 17));
      add_inlined_method__244___object(do_alphatize_env_178_ast_alphatize, let_var_6_ast_node, ((long) 18));
      add_inlined_method__244___object(do_alphatize_env_178_ast_alphatize, set_ex_it_116_ast_node, ((long) 19));
      {		/* Ast/alphatize.scm 14 */
	 long aux_2770;
	 aux_2770 =
	    add_inlined_method__244___object(do_alphatize_env_178_ast_alphatize, jump_ex_it_184_ast_node, ((long) 20));
	 return
	    BINT(aux_2770);
      }
   }
}



/* do-alphatize */
node_bglt 
do_alphatize_126_ast_alphatize(node_bglt node_20)
{
   AN_OBJECT;
   {	/* Ast/alphatize.scm 67 */
      {
	 obj_t method1697_1094;
	 obj_t class1702_1095;
	 {	/* Ast/alphatize.scm 67 */
	    obj_t arg1705_1092;
	    obj_t arg1706_1093;
	    {	/* Ast/alphatize.scm 67 */
	       object_bglt obj_1872;
	       obj_1872 =
		  (object_bglt) (node_20);
	       {	/* ./Llib/object.scm 2926 */
		  obj_t pre_method_105_1873;
		  pre_method_105_1873 =
		     PROCEDURE_REF(do_alphatize_env_178_ast_alphatize, ((long) 2));
		  if (
		     INTEGERP(pre_method_105_1873))
		    {	/* ./Llib/object.scm 2927 */
		       PROCEDURE_SET(do_alphatize_env_178_ast_alphatize, ((long) 2), BUNSPEC);
		       arg1705_1092 = pre_method_105_1873;
		    }
		  else
		    {	/* ./Llib/object.scm 2914 */
		       long obj_class_num_177_1878;
		       obj_class_num_177_1878 =
			  TYPE(obj_1872);
		       {	/* ./Llib/object.scm 2915 */
			  obj_t arg1176_1879;
			  arg1176_1879 =
			     PROCEDURE_REF(do_alphatize_env_178_ast_alphatize, ((long) 1));
			  {	/* ./Llib/object.scm 2738 */
			     long arg1177_1883;
			     {	/* ./Llib/object.scm 2738 */
				long arg1178_1884;
				arg1178_1884 =
				   OBJECT_TYPE;
				arg1177_1883 =
				   (obj_class_num_177_1878 - arg1178_1884);
			     }
			     arg1705_1092 =
				VECTOR_REF(arg1176_1879, arg1177_1883);
			  }
		       }
		    }
	       }
	    }
	    {	/* Ast/alphatize.scm 67 */
	       object_bglt object_1889;
	       object_1889 =
		  (object_bglt) (node_20);
	       {	/* ./Llib/object.scm 2695 */
		  long arg1179_1890;
		  {	/* ./Llib/object.scm 2695 */
		     long arg1180_1891;
		     long arg1181_1892;
		     arg1180_1891 =
			TYPE(object_1889);
		     arg1181_1892 =
			OBJECT_TYPE;
		     arg1179_1890 =
			(arg1180_1891 - arg1181_1892);
		  }
		  {	/* ./Llib/object.scm 2695 */
		     obj_t vector_1896;
		     vector_1896 = _classes__134___object;
		     arg1706_1093 =
			VECTOR_REF(vector_1896, arg1179_1890);
		  }
	       }
	    }
	    {	/* Ast/alphatize.scm 67 */
	       obj_t aux_2788;
	       method1697_1094 = arg1705_1092;
	       class1702_1095 = arg1706_1093;
	       {

		  if (
		     INTEGERP(method1697_1094))
		    {	/* Ast/alphatize.scm 67 */
		       switch (
			  (long) CINT(method1697_1094))
			 {
			 case ((long) 0):

			    {	/* Ast/alphatize.scm 73 */
			       atom_bglt node_1101;
			       node_1101 =
				  (atom_bglt) (node_20);
			       {	/* Ast/alphatize.scm 74 */
				  atom_bglt new1443_1103;
				  {	/* Ast/alphatize.scm 74 */
				     obj_t arg1709_1104;
				     type_bglt arg1711_1105;
				     obj_t arg1712_1106;
				     arg1709_1104 =
					get_location_95_ast_alphatize(
					(obj_t) (node_1101));
				     arg1711_1105 =
					(((atom_bglt) CREF(node_1101))->type);
				     arg1712_1106 =
					(((atom_bglt) CREF(node_1101))->value);
				     {	/* Ast/alphatize.scm 73 */
					atom_bglt res2055_1910;
					{	/* ./Ast/node.scm 881 */
					   atom_bglt new1202_1903;
					   new1202_1903 =
					      ((atom_bglt) BREF(GC_MALLOC(sizeof(struct atom))));
					   {	/* ./Ast/node.scm 881 */
					      long arg1666_1904;
					      arg1666_1904 =
						 class_num_218___object(atom_ast_node);
					      {		/* ./Ast/node.scm 881 */
						 obj_t obj_1908;
						 obj_1908 =
						    (obj_t) (new1202_1903);
						 (((obj_t) CREF(obj_1908))->header = MAKE_HEADER(arg1666_1904, 0), BUNSPEC);
					      }
					   }
					   {	/* ./Ast/node.scm 881 */
					      object_bglt aux_2800;
					      aux_2800 =
						 (object_bglt) (new1202_1903);
					      OBJECT_WIDENING_SET(aux_2800, BFALSE);
					   }
					   ((((atom_bglt) CREF(new1202_1903))->loc) = ((obj_t) arg1709_1104), BUNSPEC);
					   ((((atom_bglt) CREF(new1202_1903))->type) = ((type_bglt) arg1711_1105), BUNSPEC);
					   ((((atom_bglt) CREF(new1202_1903))->value) = ((obj_t) arg1712_1106), BUNSPEC);
					   res2055_1910 = new1202_1903;
					}
					new1443_1103 = res2055_1910;
				     }
				  }
				  {	/* Ast/alphatize.scm 73 */

				     aux_2788 =
					(obj_t) (new1443_1103);
				  }
			       }
			    }
			    break;
			 case ((long) 1):

			    {	/* Ast/alphatize.scm 80 */
			       var_bglt node_1107;
			       node_1107 =
				  (var_bglt) (node_20);
			       {	/* Ast/alphatize.scm 80 */
				  variable_bglt var_1108;
				  var_1108 =
				     (((var_bglt) CREF(node_1107))->variable);
				  {	/* Ast/alphatize.scm 80 */
				     obj_t alpha_1109;
				     alpha_1109 =
					(((variable_bglt) CREF(var_1108))->fast_alpha_7);
				     {	/* Ast/alphatize.scm 81 */

					if (
					   (alpha_1109 == BUNSPEC))
					  {	/* Ast/alphatize.scm 83 */
					     {	/* Ast/alphatize.scm 84 */
						obj_t aux_2812;
						{	/* Ast/alphatize.scm 84 */
						   node_bglt obj_1915;
						   obj_1915 =
						      (node_bglt) (node_1107);
						   aux_2812 =
						      (((node_bglt) CREF(obj_1915))->loc);
						}
						use_variable__4_ast_sexp(var_1108, aux_2812,
						   CNST_TABLE_REF(((long) 1)));
					     }
					     {	/* Ast/alphatize.scm 85 */
						var_bglt new1445_1114;
						{	/* Ast/alphatize.scm 85 */
						   obj_t arg1716_1115;
						   type_bglt arg1717_1116;
						   variable_bglt arg1718_1117;
						   arg1716_1115 =
						      get_location_95_ast_alphatize(
						      (obj_t) (node_1107));
						   arg1717_1116 =
						      (((var_bglt) CREF(node_1107))->type);
						   arg1718_1117 =
						      (((var_bglt) CREF(node_1107))->variable);
						   {	/* Ast/alphatize.scm 85 */
						      var_bglt res2056_1928;
						      {		/* ./Ast/node.scm 886 */
							 var_bglt new1210_1921;
							 new1210_1921 =
							    ((var_bglt) BREF(GC_MALLOC(sizeof(struct var))));
							 {	/* ./Ast/node.scm 886 */
							    long arg1664_1922;
							    arg1664_1922 =
							       class_num_218___object(var_ast_node);
							    {	/* ./Ast/node.scm 886 */
							       obj_t obj_1926;
							       obj_1926 =
								  (obj_t) (new1210_1921);
							       (((obj_t) CREF(obj_1926))->header = MAKE_HEADER(arg1664_1922, 0), BUNSPEC);
							    }
							 }
							 {	/* ./Ast/node.scm 886 */
							    object_bglt aux_2825;
							    aux_2825 =
							       (object_bglt) (new1210_1921);
							    OBJECT_WIDENING_SET(aux_2825, BFALSE);
							 }
							 ((((var_bglt) CREF(new1210_1921))->loc) = ((obj_t) arg1716_1115), BUNSPEC);
							 ((((var_bglt) CREF(new1210_1921))->type) = ((type_bglt) arg1717_1116), BUNSPEC);
							 ((((var_bglt) CREF(new1210_1921))->variable) = ((variable_bglt) arg1718_1117), BUNSPEC);
							 res2056_1928 = new1210_1921;
						      }
						      new1445_1114 = res2056_1928;
						   }
						}
						{	/* Ast/alphatize.scm 85 */

						   aux_2788 =
						      (obj_t) (new1445_1114);
						}
					     }
					  }
					else
					  {	/* Ast/alphatize.scm 86 */
					     bool_t test1719_1118;
					     test1719_1118 =
						is_a__118___object(alpha_1109, variable_ast_var);
					     if (test1719_1118)
					       {	/* Ast/alphatize.scm 86 */
						  {	/* Ast/alphatize.scm 87 */
						     obj_t aux_2834;
						     {	/* Ast/alphatize.scm 87 */
							node_bglt obj_1930;
							obj_1930 =
							   (node_bglt) (node_1107);
							aux_2834 =
							   (((node_bglt) CREF(obj_1930))->loc);
						     }
						     use_variable__4_ast_sexp(
							(variable_bglt) (alpha_1109), aux_2834,
							CNST_TABLE_REF(((long) 1)));
						  }
						  {	/* Ast/alphatize.scm 88 */
						     bool_t test1722_1121;
						     {	/* ./Ast/var.scm 778 */
							obj_t aux_2840;
							{	/* Ast/alphatize.scm 88 */
							   value_bglt aux_2841;
							   {	/* Ast/alphatize.scm 88 */
							      variable_bglt obj_1931;
							      obj_1931 =
								 (variable_bglt) (alpha_1109);
							      aux_2841 =
								 (((variable_bglt) CREF(obj_1931))->value);
							   }
							   aux_2840 =
							      (obj_t) (aux_2841);
							}
							test1722_1121 =
							   is_a__118___object(aux_2840, fun_ast_var);
						     }
						     if (test1722_1121)
						       {	/* Ast/alphatize.scm 90 */
							  obj_t arg1723_1122;
							  type_bglt arg1724_1123;
							  arg1723_1122 =
							     get_location_95_ast_alphatize(
							     (obj_t) (node_1107));
							  {	/* Ast/alphatize.scm 91 */
							     variable_bglt obj_1933;
							     obj_1933 =
								(variable_bglt) (alpha_1109);
							     arg1724_1123 =
								(((variable_bglt) CREF(obj_1933))->type);
							  }
							  {	/* Ast/alphatize.scm 89 */
							     closure_bglt res2057_1944;
							     {	/* Ast/alphatize.scm 89 */
								variable_bglt variable_1936;
								variable_1936 =
								   (variable_bglt) (alpha_1109);
								{	/* ./Ast/node.scm 891 */
								   closure_bglt new1218_1937;
								   new1218_1937 =
								      ((closure_bglt) BREF(GC_MALLOC(sizeof(struct closure))));
								   {	/* ./Ast/node.scm 891 */
								      long arg1662_1938;
								      arg1662_1938 =
									 class_num_218___object(closure_ast_node);
								      {		/* ./Ast/node.scm 891 */
									 obj_t obj_1942;
									 obj_1942 =
									    (obj_t) (new1218_1937);
									 (((obj_t) CREF(obj_1942))->header = MAKE_HEADER(arg1662_1938, 0), BUNSPEC);
								      }
								   }
								   {	/* ./Ast/node.scm 891 */
								      object_bglt aux_2856;
								      aux_2856 =
									 (object_bglt) (new1218_1937);
								      OBJECT_WIDENING_SET(aux_2856, BFALSE);
								   }
								   ((((closure_bglt) CREF(new1218_1937))->loc) = ((obj_t) arg1723_1122), BUNSPEC);
								   ((((closure_bglt) CREF(new1218_1937))->type) = ((type_bglt) arg1724_1123), BUNSPEC);
								   ((((closure_bglt) CREF(new1218_1937))->variable) = ((variable_bglt) variable_1936), BUNSPEC);
								   res2057_1944 = new1218_1937;
								}
							     }
							     aux_2788 =
								(obj_t) (res2057_1944);
							  }
						       }
						     else
						       {	/* Ast/alphatize.scm 94 */
							  var_bglt new1448_1126;
							  {	/* Ast/alphatize.scm 94 */
							     obj_t arg1726_1127;
							     type_bglt arg1727_1128;
							     arg1726_1127 =
								get_location_95_ast_alphatize(
								(obj_t) (node_1107));
							     arg1727_1128 =
								(((var_bglt) CREF(node_1107))->type);
							     {	/* Ast/alphatize.scm 93 */
								var_bglt res2058_1956;
								{	/* Ast/alphatize.scm 93 */
								   variable_bglt variable_1948;
								   variable_1948 =
								      (variable_bglt) (alpha_1109);
								   {	/* ./Ast/node.scm 886 */
								      var_bglt new1210_1949;
								      new1210_1949 =
									 ((var_bglt) BREF(GC_MALLOC(sizeof(struct var))));
								      {		/* ./Ast/node.scm 886 */
									 long arg1664_1950;
									 arg1664_1950 =
									    class_num_218___object(var_ast_node);
									 {	/* ./Ast/node.scm 886 */
									    obj_t obj_1954;
									    obj_1954 =
									       (obj_t) (new1210_1949);
									    (((obj_t) CREF(obj_1954))->header = MAKE_HEADER(arg1664_1950, 0), BUNSPEC);
									 }
								      }
								      {		/* ./Ast/node.scm 886 */
									 object_bglt aux_2871;
									 aux_2871 =
									    (object_bglt) (new1210_1949);
									 OBJECT_WIDENING_SET(aux_2871, BFALSE);
								      }
								      ((((var_bglt) CREF(new1210_1949))->loc) = ((obj_t) arg1726_1127), BUNSPEC);
								      ((((var_bglt) CREF(new1210_1949))->type) = ((type_bglt) arg1727_1128), BUNSPEC);
								      ((((var_bglt) CREF(new1210_1949))->variable) = ((variable_bglt) variable_1948), BUNSPEC);
								      res2058_1956 = new1210_1949;
								   }
								}
								new1448_1126 = res2058_1956;
							     }
							  }
							  {	/* Ast/alphatize.scm 93 */

							     aux_2788 =
								(obj_t) (new1448_1126);
							  }
						       }
						  }
					       }
					     else
					       {	/* Ast/alphatize.scm 96 */
						  bool_t test1730_1131;
						  test1730_1131 =
						     is_a__118___object(alpha_1109, atom_ast_node);
						  if (test1730_1131)
						    {	/* Ast/alphatize.scm 96 */
						       {	/* Ast/alphatize.scm 97 */
							  atom_bglt duplicated1449_1132;
							  duplicated1449_1132 =
							     (atom_bglt) (alpha_1109);
							  {	/* Ast/alphatize.scm 97 */
							     atom_bglt new1450_1133;
							     {	/* Ast/alphatize.scm 97 */
								obj_t arg1731_1134;
								type_bglt arg1732_1135;
								obj_t arg1733_1136;
								arg1731_1134 =
								   (((atom_bglt) CREF(duplicated1449_1132))->loc);
								arg1732_1135 =
								   (((atom_bglt) CREF(duplicated1449_1132))->type);
								arg1733_1136 =
								   (((atom_bglt) CREF(duplicated1449_1132))->value);
								{	/* Ast/alphatize.scm 97 */
								   atom_bglt res2059_1971;
								   {	/* ./Ast/node.scm 881 */
								      atom_bglt new1202_1964;
								      new1202_1964 =
									 ((atom_bglt) BREF(GC_MALLOC(sizeof(struct atom))));
								      {		/* ./Ast/node.scm 881 */
									 long arg1666_1965;
									 arg1666_1965 =
									    class_num_218___object(atom_ast_node);
									 {	/* ./Ast/node.scm 881 */
									    obj_t obj_1969;
									    obj_1969 =
									       (obj_t) (new1202_1964);
									    (((obj_t) CREF(obj_1969))->header = MAKE_HEADER(arg1666_1965, 0), BUNSPEC);
									 }
								      }
								      {		/* ./Ast/node.scm 881 */
									 object_bglt aux_2888;
									 aux_2888 =
									    (object_bglt) (new1202_1964);
									 OBJECT_WIDENING_SET(aux_2888, BFALSE);
								      }
								      ((((atom_bglt) CREF(new1202_1964))->loc) = ((obj_t) arg1731_1134), BUNSPEC);
								      ((((atom_bglt) CREF(new1202_1964))->type) = ((type_bglt) arg1732_1135), BUNSPEC);
								      ((((atom_bglt) CREF(new1202_1964))->value) = ((obj_t) arg1733_1136), BUNSPEC);
								      res2059_1971 = new1202_1964;
								   }
								   new1450_1133 = res2059_1971;
								}
							     }
							     {	/* Ast/alphatize.scm 97 */

								aux_2788 =
								   (obj_t) (new1450_1133);
							     }
							  }
						       }
						    }
						  else
						    {	/* Ast/alphatize.scm 96 */
						       {	/* Ast/alphatize.scm 99 */
							  obj_t arg1736_1139;
							  arg1736_1139 =
							     shape_tools_shape(
							     (obj_t) (node_1107));
							  aux_2788 =
							     internal_error_43_tools_error(string2092_ast_alphatize, string2093_ast_alphatize, arg1736_1139);
						       }
						    }
					       }
					  }
				     }
				  }
			       }
			    }
			    break;
			 case ((long) 2):

			    {	/* Ast/alphatize.scm 107 */
			       closure_bglt node_1140;
			       node_1140 =
				  (closure_bglt) (node_20);
			       {	/* Ast/alphatize.scm 107 */
				  variable_bglt var_1141;
				  {	/* Ast/alphatize.scm 107 */
				     var_bglt obj_1972;
				     obj_1972 =
					(var_bglt) (node_1140);
				     var_1141 =
					(((var_bglt) CREF(obj_1972))->variable);
				  }
				  {	/* Ast/alphatize.scm 107 */
				     obj_t alpha_1142;
				     alpha_1142 =
					(((variable_bglt) CREF(var_1141))->fast_alpha_7);
				     {	/* Ast/alphatize.scm 108 */

					if (
					   (alpha_1142 == BUNSPEC))
					  {	/* Ast/alphatize.scm 110 */
					     {	/* Ast/alphatize.scm 111 */
						obj_t aux_2904;
						{	/* Ast/alphatize.scm 111 */
						   node_bglt obj_1976;
						   obj_1976 =
						      (node_bglt) (node_1140);
						   aux_2904 =
						      (((node_bglt) CREF(obj_1976))->loc);
						}
						use_variable__4_ast_sexp(var_1141, aux_2904,
						   CNST_TABLE_REF(((long) 1)));
					     }
					     {	/* Ast/alphatize.scm 112 */
						closure_bglt new1452_1147;
						{	/* Ast/alphatize.scm 112 */
						   obj_t arg1740_1148;
						   type_bglt arg1741_1149;
						   variable_bglt arg1742_1150;
						   arg1740_1148 =
						      get_location_95_ast_alphatize(
						      (obj_t) (node_1140));
						   arg1741_1149 =
						      (((closure_bglt) CREF(node_1140))->type);
						   arg1742_1150 =
						      (((closure_bglt) CREF(node_1140))->variable);
						   {	/* Ast/alphatize.scm 112 */
						      closure_bglt res2060_1989;
						      {		/* ./Ast/node.scm 891 */
							 closure_bglt new1218_1982;
							 new1218_1982 =
							    ((closure_bglt) BREF(GC_MALLOC(sizeof(struct closure))));
							 {	/* ./Ast/node.scm 891 */
							    long arg1662_1983;
							    arg1662_1983 =
							       class_num_218___object(closure_ast_node);
							    {	/* ./Ast/node.scm 891 */
							       obj_t obj_1987;
							       obj_1987 =
								  (obj_t) (new1218_1982);
							       (((obj_t) CREF(obj_1987))->header = MAKE_HEADER(arg1662_1983, 0), BUNSPEC);
							    }
							 }
							 {	/* ./Ast/node.scm 891 */
							    object_bglt aux_2917;
							    aux_2917 =
							       (object_bglt) (new1218_1982);
							    OBJECT_WIDENING_SET(aux_2917, BFALSE);
							 }
							 ((((closure_bglt) CREF(new1218_1982))->loc) = ((obj_t) arg1740_1148), BUNSPEC);
							 ((((closure_bglt) CREF(new1218_1982))->type) = ((type_bglt) arg1741_1149), BUNSPEC);
							 ((((closure_bglt) CREF(new1218_1982))->variable) = ((variable_bglt) arg1742_1150), BUNSPEC);
							 res2060_1989 = new1218_1982;
						      }
						      new1452_1147 = res2060_1989;
						   }
						}
						{	/* Ast/alphatize.scm 112 */

						   aux_2788 =
						      (obj_t) (new1452_1147);
						}
					     }
					  }
					else
					  {	/* Ast/alphatize.scm 113 */
					     bool_t test1743_1151;
					     test1743_1151 =
						is_a__118___object(alpha_1142, variable_ast_var);
					     if (test1743_1151)
					       {	/* Ast/alphatize.scm 113 */
						  {	/* Ast/alphatize.scm 114 */
						     obj_t aux_2926;
						     {	/* Ast/alphatize.scm 114 */
							node_bglt obj_1991;
							obj_1991 =
							   (node_bglt) (node_1140);
							aux_2926 =
							   (((node_bglt) CREF(obj_1991))->loc);
						     }
						     use_variable__4_ast_sexp(
							(variable_bglt) (alpha_1142), aux_2926,
							CNST_TABLE_REF(((long) 1)));
						  }
						  {	/* Ast/alphatize.scm 116 */
						     closure_bglt new1454_1155;
						     {	/* Ast/alphatize.scm 116 */
							obj_t arg1746_1156;
							type_bglt arg1747_1157;
							arg1746_1156 =
							   get_location_95_ast_alphatize(
							   (obj_t) (node_1140));
							arg1747_1157 =
							   (((closure_bglt) CREF(node_1140))->type);
							{	/* Ast/alphatize.scm 115 */
							   closure_bglt res2061_2003;
							   {	/* Ast/alphatize.scm 115 */
							      variable_bglt variable_1995;
							      variable_1995 =
								 (variable_bglt) (alpha_1142);
							      {		/* ./Ast/node.scm 891 */
								 closure_bglt new1218_1996;
								 new1218_1996 =
								    ((closure_bglt) BREF(GC_MALLOC(sizeof(struct closure))));
								 {	/* ./Ast/node.scm 891 */
								    long arg1662_1997;
								    arg1662_1997 =
								       class_num_218___object(closure_ast_node);
								    {	/* ./Ast/node.scm 891 */
								       obj_t obj_2001;
								       obj_2001 =
									  (obj_t) (new1218_1996);
								       (((obj_t) CREF(obj_2001))->header = MAKE_HEADER(arg1662_1997, 0), BUNSPEC);
								    }
								 }
								 {	/* ./Ast/node.scm 891 */
								    object_bglt aux_2940;
								    aux_2940 =
								       (object_bglt) (new1218_1996);
								    OBJECT_WIDENING_SET(aux_2940, BFALSE);
								 }
								 ((((closure_bglt) CREF(new1218_1996))->loc) = ((obj_t) arg1746_1156), BUNSPEC);
								 ((((closure_bglt) CREF(new1218_1996))->type) = ((type_bglt) arg1747_1157), BUNSPEC);
								 ((((closure_bglt) CREF(new1218_1996))->variable) = ((variable_bglt) variable_1995), BUNSPEC);
								 res2061_2003 = new1218_1996;
							      }
							   }
							   new1454_1155 = res2061_2003;
							}
						     }
						     {	/* Ast/alphatize.scm 115 */

							aux_2788 =
							   (obj_t) (new1454_1155);
						     }
						  }
					       }
					     else
					       {	/* Ast/alphatize.scm 113 */
						  {	/* Ast/alphatize.scm 119 */
						     obj_t arg1751_1161;
						     arg1751_1161 =
							shape_tools_shape(
							(obj_t) (node_1140));
						     aux_2788 =
							internal_error_43_tools_error(string2092_ast_alphatize, string2093_ast_alphatize, arg1751_1161);
						  }
					       }
					  }
				     }
				  }
			       }
			    }
			    break;
			 case ((long) 3):

			    {	/* Ast/alphatize.scm 127 */
			       kwote_bglt node_1162;
			       node_1162 =
				  (kwote_bglt) (node_20);
			       {	/* Ast/alphatize.scm 127 */
				  kwote_bglt new1456_1164;
				  {	/* Ast/alphatize.scm 127 */
				     obj_t arg1752_1165;
				     type_bglt arg1753_1166;
				     obj_t arg1754_1167;
				     arg1752_1165 =
					get_location_95_ast_alphatize(
					(obj_t) (node_1162));
				     arg1753_1166 =
					(((kwote_bglt) CREF(node_1162))->type);
				     arg1754_1167 =
					(((kwote_bglt) CREF(node_1162))->value);
				     {	/* Ast/alphatize.scm 127 */
					kwote_bglt res2062_2016;
					{	/* ./Ast/node.scm 894 */
					   kwote_bglt new1225_2009;
					   new1225_2009 =
					      ((kwote_bglt) BREF(GC_MALLOC(sizeof(struct kwote))));
					   {	/* ./Ast/node.scm 894 */
					      long arg1660_2010;
					      arg1660_2010 =
						 class_num_218___object(kwote_ast_node);
					      {		/* ./Ast/node.scm 894 */
						 obj_t obj_2014;
						 obj_2014 =
						    (obj_t) (new1225_2009);
						 (((obj_t) CREF(obj_2014))->header = MAKE_HEADER(arg1660_2010, 0), BUNSPEC);
					      }
					   }
					   {	/* ./Ast/node.scm 894 */
					      object_bglt aux_2959;
					      aux_2959 =
						 (object_bglt) (new1225_2009);
					      OBJECT_WIDENING_SET(aux_2959, BFALSE);
					   }
					   ((((kwote_bglt) CREF(new1225_2009))->loc) = ((obj_t) arg1752_1165), BUNSPEC);
					   ((((kwote_bglt) CREF(new1225_2009))->type) = ((type_bglt) arg1753_1166), BUNSPEC);
					   ((((kwote_bglt) CREF(new1225_2009))->value) = ((obj_t) arg1754_1167), BUNSPEC);
					   res2062_2016 = new1225_2009;
					}
					new1456_1164 = res2062_2016;
				     }
				  }
				  {	/* Ast/alphatize.scm 127 */

				     aux_2788 =
					(obj_t) (new1456_1164);
				  }
			       }
			    }
			    break;
			 case ((long) 4):

			    {	/* Ast/alphatize.scm 133 */
			       sequence_bglt node_1168;
			       node_1168 =
				  (sequence_bglt) (node_20);
			       {	/* Ast/alphatize.scm 134 */
				  sequence_bglt new1458_1170;
				  {	/* Ast/alphatize.scm 134 */
				     obj_t arg1755_1171;
				     type_bglt arg1756_1172;
				     obj_t arg1758_1173;
				     obj_t arg1759_1174;
				     obj_t arg1760_1175;
				     arg1755_1171 =
					get_location_95_ast_alphatize(
					(obj_t) (node_1168));
				     arg1756_1172 =
					(((sequence_bglt) CREF(node_1168))->type);
				     arg1758_1173 =
					(((sequence_bglt) CREF(node_1168))->side_effect__165);
				     arg1759_1174 =
					(((sequence_bglt) CREF(node_1168))->key);
				     {	/* Ast/alphatize.scm 135 */
					obj_t l1459_1176;
					l1459_1176 =
					   (((sequence_bglt) CREF(node_1168))->nodes);
					if (
					   NULLP(l1459_1176))
					  {	/* Ast/alphatize.scm 135 */
					     arg1760_1175 = BNIL;
					  }
					else
					  {	/* Ast/alphatize.scm 135 */
					     obj_t head1461_1178;
					     {	/* Ast/alphatize.scm 135 */
						node_bglt arg1768_1189;
						{	/* Ast/alphatize.scm 135 */
						   node_bglt aux_2975;
						   {	/* Ast/alphatize.scm 135 */
						      obj_t aux_2976;
						      aux_2976 =
							 CAR(l1459_1176);
						      aux_2975 =
							 (node_bglt) (aux_2976);
						   }
						   arg1768_1189 =
						      do_alphatize_126_ast_alphatize(aux_2975);
						}
						{	/* ./Ieee/pair-list.scm 5689 */
						   obj_t aux_2980;
						   aux_2980 =
						      (obj_t) (arg1768_1189);
						   head1461_1178 =
						      MAKE_PAIR(aux_2980, BNIL);
						}
					     }
					     {
						obj_t l1459_1179;
						obj_t tail1462_1180;
						l1459_1179 =
						   CDR(l1459_1176);
						tail1462_1180 = head1461_1178;
					      lname1460_1181:
						if (
						   NULLP(l1459_1179))
						  {	/* Ast/alphatize.scm 135 */
						     arg1760_1175 = head1461_1178;
						  }
						else
						  {	/* Ast/alphatize.scm 135 */
						     obj_t newtail1463_1184;
						     {	/* Ast/alphatize.scm 135 */
							node_bglt arg1765_1186;
							{	/* Ast/alphatize.scm 135 */
							   node_bglt aux_2985;
							   {	/* Ast/alphatize.scm 135 */
							      obj_t aux_2986;
							      aux_2986 =
								 CAR(l1459_1179);
							      aux_2985 =
								 (node_bglt) (aux_2986);
							   }
							   arg1765_1186 =
							      do_alphatize_126_ast_alphatize(aux_2985);
							}
							{	/* ./Ieee/pair-list.scm 5689 */
							   obj_t aux_2990;
							   aux_2990 =
							      (obj_t) (arg1765_1186);
							   newtail1463_1184 =
							      MAKE_PAIR(aux_2990, BNIL);
							}
						     }
						     SET_CDR(tail1462_1180, newtail1463_1184);
						     {
							obj_t tail1462_2996;
							obj_t l1459_2994;
							l1459_2994 =
							   CDR(l1459_1179);
							tail1462_2996 = newtail1463_1184;
							tail1462_1180 = tail1462_2996;
							l1459_1179 = l1459_2994;
							goto lname1460_1181;
						     }
						  }
					     }
					  }
				     }
				     {	/* Ast/alphatize.scm 133 */
					sequence_bglt res2063_2047;
					{	/* ./Ast/node.scm 899 */
					   sequence_bglt new1234_2038;
					   new1234_2038 =
					      ((sequence_bglt) BREF(GC_MALLOC(sizeof(struct sequence))));
					   {	/* ./Ast/node.scm 899 */
					      long arg1658_2039;
					      arg1658_2039 =
						 class_num_218___object(sequence_ast_node);
					      {		/* ./Ast/node.scm 899 */
						 obj_t obj_2045;
						 obj_2045 =
						    (obj_t) (new1234_2038);
						 (((obj_t) CREF(obj_2045))->header = MAKE_HEADER(arg1658_2039, 0), BUNSPEC);
					      }
					   }
					   {	/* ./Ast/node.scm 899 */
					      object_bglt aux_3002;
					      aux_3002 =
						 (object_bglt) (new1234_2038);
					      OBJECT_WIDENING_SET(aux_3002, BFALSE);
					   }
					   ((((sequence_bglt) CREF(new1234_2038))->loc) = ((obj_t) arg1755_1171), BUNSPEC);
					   ((((sequence_bglt) CREF(new1234_2038))->type) = ((type_bglt) arg1756_1172), BUNSPEC);
					   ((((sequence_bglt) CREF(new1234_2038))->side_effect__165) = ((obj_t) arg1758_1173), BUNSPEC);
					   ((((sequence_bglt) CREF(new1234_2038))->key) = ((obj_t) arg1759_1174), BUNSPEC);
					   ((((sequence_bglt) CREF(new1234_2038))->nodes) = ((obj_t) arg1760_1175), BUNSPEC);
					   res2063_2047 = new1234_2038;
					}
					new1458_1170 = res2063_2047;
				     }
				  }
				  {	/* Ast/alphatize.scm 133 */

				     aux_2788 =
					(obj_t) (new1458_1170);
				  }
			       }
			    }
			    break;
			 case ((long) 5):

			    {	/* Ast/alphatize.scm 143 */
			       app_bglt node_1192;
			       node_1192 =
				  (app_bglt) (node_20);
			       {	/* Ast/alphatize.scm 144 */
				  app_bglt new1465_1194;
				  {	/* Ast/alphatize.scm 144 */
				     obj_t arg1771_1195;
				     type_bglt arg1772_1196;
				     obj_t arg1773_1197;
				     obj_t arg1774_1198;
				     obj_t arg1775_1199;
				     obj_t arg1776_1200;
				     obj_t arg1777_1201;
				     arg1771_1195 =
					get_location_95_ast_alphatize(
					(obj_t) (node_1192));
				     arg1772_1196 =
					(((app_bglt) CREF(node_1192))->type);
				     arg1773_1197 =
					(((app_bglt) CREF(node_1192))->side_effect__165);
				     arg1774_1198 =
					(((app_bglt) CREF(node_1192))->key);
				     {	/* Ast/alphatize.scm 145 */
					node_bglt var_1202;
					{	/* Ast/alphatize.scm 145 */
					   node_bglt aux_3017;
					   {	/* Ast/alphatize.scm 145 */
					      var_bglt aux_3018;
					      aux_3018 =
						 (((app_bglt) CREF(node_1192))->fun);
					      aux_3017 =
						 (node_bglt) (aux_3018);
					   }
					   var_1202 =
					      do_alphatize_126_ast_alphatize(aux_3017);
					}
					{	/* Ast/alphatize.scm 146 */
					   bool_t test1778_1203;
					   test1778_1203 =
					      is_a__118___object(
					      (obj_t) (var_1202), closure_ast_node);
					   if (test1778_1203)
					     {	/* Ast/alphatize.scm 147 */
						var_bglt duplicated1466_1204;
						duplicated1466_1204 =
						   (var_bglt) (var_1202);
						{	/* Ast/alphatize.scm 147 */
						   var_bglt new1467_1205;
						   {	/* Ast/alphatize.scm 147 */
						      obj_t arg1779_1206;
						      type_bglt arg1780_1207;
						      variable_bglt arg1781_1208;
						      arg1779_1206 =
							 (((var_bglt) CREF(duplicated1466_1204))->loc);
						      arg1780_1207 =
							 (((var_bglt) CREF(duplicated1466_1204))->type);
						      arg1781_1208 =
							 (((var_bglt) CREF(duplicated1466_1204))->variable);
						      {		/* Ast/alphatize.scm 147 */
							 var_bglt res2064_2066;
							 {	/* ./Ast/node.scm 886 */
							    var_bglt new1210_2059;
							    new1210_2059 =
							       ((var_bglt) BREF(GC_MALLOC(sizeof(struct var))));
							    {	/* ./Ast/node.scm 886 */
							       long arg1664_2060;
							       arg1664_2060 =
								  class_num_218___object(var_ast_node);
							       {	/* ./Ast/node.scm 886 */
								  obj_t obj_2064;
								  obj_2064 =
								     (obj_t) (new1210_2059);
								  (((obj_t) CREF(obj_2064))->header = MAKE_HEADER(arg1664_2060, 0), BUNSPEC);
							       }
							    }
							    {	/* ./Ast/node.scm 886 */
							       object_bglt aux_3033;
							       aux_3033 =
								  (object_bglt) (new1210_2059);
							       OBJECT_WIDENING_SET(aux_3033, BFALSE);
							    }
							    ((((var_bglt) CREF(new1210_2059))->loc) = ((obj_t) arg1779_1206), BUNSPEC);
							    ((((var_bglt) CREF(new1210_2059))->type) = ((type_bglt) arg1780_1207), BUNSPEC);
							    ((((var_bglt) CREF(new1210_2059))->variable) = ((variable_bglt) arg1781_1208), BUNSPEC);
							    res2064_2066 = new1210_2059;
							 }
							 new1467_1205 = res2064_2066;
						      }
						   }
						   {	/* Ast/alphatize.scm 147 */

						      arg1775_1199 =
							 (obj_t) (new1467_1205);
						   }
						}
					     }
					   else
					     {	/* Ast/alphatize.scm 146 */
						arg1775_1199 =
						   (obj_t) (var_1202);
					     }
					}
				     }
				     {	/* Ast/alphatize.scm 149 */
					obj_t l1468_1210;
					l1468_1210 =
					   (((app_bglt) CREF(node_1192))->args);
					if (
					   NULLP(l1468_1210))
					  {	/* Ast/alphatize.scm 149 */
					     arg1776_1200 = BNIL;
					  }
					else
					  {	/* Ast/alphatize.scm 149 */
					     obj_t head1470_1212;
					     {	/* Ast/alphatize.scm 149 */
						node_bglt arg1790_1223;
						{	/* Ast/alphatize.scm 149 */
						   node_bglt aux_3044;
						   {	/* Ast/alphatize.scm 149 */
						      obj_t aux_3045;
						      aux_3045 =
							 CAR(l1468_1210);
						      aux_3044 =
							 (node_bglt) (aux_3045);
						   }
						   arg1790_1223 =
						      do_alphatize_126_ast_alphatize(aux_3044);
						}
						{	/* ./Ieee/pair-list.scm 5689 */
						   obj_t aux_3049;
						   aux_3049 =
						      (obj_t) (arg1790_1223);
						   head1470_1212 =
						      MAKE_PAIR(aux_3049, BNIL);
						}
					     }
					     {
						obj_t l1468_1213;
						obj_t tail1471_1214;
						l1468_1213 =
						   CDR(l1468_1210);
						tail1471_1214 = head1470_1212;
					      lname1469_1215:
						if (
						   NULLP(l1468_1213))
						  {	/* Ast/alphatize.scm 149 */
						     arg1776_1200 = head1470_1212;
						  }
						else
						  {	/* Ast/alphatize.scm 149 */
						     obj_t newtail1472_1218;
						     {	/* Ast/alphatize.scm 149 */
							node_bglt arg1787_1220;
							{	/* Ast/alphatize.scm 149 */
							   node_bglt aux_3054;
							   {	/* Ast/alphatize.scm 149 */
							      obj_t aux_3055;
							      aux_3055 =
								 CAR(l1468_1213);
							      aux_3054 =
								 (node_bglt) (aux_3055);
							   }
							   arg1787_1220 =
							      do_alphatize_126_ast_alphatize(aux_3054);
							}
							{	/* ./Ieee/pair-list.scm 5689 */
							   obj_t aux_3059;
							   aux_3059 =
							      (obj_t) (arg1787_1220);
							   newtail1472_1218 =
							      MAKE_PAIR(aux_3059, BNIL);
							}
						     }
						     SET_CDR(tail1471_1214, newtail1472_1218);
						     {
							obj_t tail1471_3065;
							obj_t l1468_3063;
							l1468_3063 =
							   CDR(l1468_1213);
							tail1471_3065 = newtail1472_1218;
							tail1471_1214 = tail1471_3065;
							l1468_1213 = l1468_3063;
							goto lname1469_1215;
						     }
						  }
					     }
					  }
				     }
				     arg1777_1201 =
					(((app_bglt) CREF(node_1192))->stack_info_255);
				     {	/* Ast/alphatize.scm 143 */
					app_bglt res2065_2099;
					{	/* Ast/alphatize.scm 143 */
					   var_bglt fun_2085;
					   fun_2085 =
					      (var_bglt) (arg1775_1199);
					   {	/* ./Ast/node.scm 903 */
					      app_bglt new1248_2088;
					      new1248_2088 =
						 ((app_bglt) BREF(GC_MALLOC(sizeof(struct app))));
					      {		/* ./Ast/node.scm 903 */
						 long arg1656_2089;
						 arg1656_2089 =
						    class_num_218___object(app_ast_node);
						 {	/* ./Ast/node.scm 903 */
						    obj_t obj_2097;
						    obj_2097 =
						       (obj_t) (new1248_2088);
						    (((obj_t) CREF(obj_2097))->header = MAKE_HEADER(arg1656_2089, 0), BUNSPEC);
						 }
					      }
					      {		/* ./Ast/node.scm 903 */
						 object_bglt aux_3073;
						 aux_3073 =
						    (object_bglt) (new1248_2088);
						 OBJECT_WIDENING_SET(aux_3073, BFALSE);
					      }
					      ((((app_bglt) CREF(new1248_2088))->loc) = ((obj_t) arg1771_1195), BUNSPEC);
					      ((((app_bglt) CREF(new1248_2088))->type) = ((type_bglt) arg1772_1196), BUNSPEC);
					      ((((app_bglt) CREF(new1248_2088))->side_effect__165) = ((obj_t) arg1773_1197), BUNSPEC);
					      ((((app_bglt) CREF(new1248_2088))->key) = ((obj_t) arg1774_1198), BUNSPEC);
					      ((((app_bglt) CREF(new1248_2088))->fun) = ((var_bglt) fun_2085), BUNSPEC);
					      ((((app_bglt) CREF(new1248_2088))->args) = ((obj_t) arg1776_1200), BUNSPEC);
					      ((((app_bglt) CREF(new1248_2088))->stack_info_255) = ((obj_t) arg1777_1201), BUNSPEC);
					      res2065_2099 = new1248_2088;
					   }
					}
					new1465_1194 = res2065_2099;
				     }
				  }
				  {	/* Ast/alphatize.scm 143 */

				     aux_2788 =
					(obj_t) (new1465_1194);
				  }
			       }
			    }
			    break;
			 case ((long) 6):

			    {	/* Ast/alphatize.scm 155 */
			       app_ly_162_bglt node_1226;
			       node_1226 =
				  (app_ly_162_bglt) (node_20);
			       {	/* Ast/alphatize.scm 155 */
				  node_bglt fun_1227;
				  node_bglt arg_1228;
				  fun_1227 =
				     do_alphatize_126_ast_alphatize(
				     (((app_ly_162_bglt) CREF(node_1226))->fun));
				  arg_1228 =
				     do_alphatize_126_ast_alphatize(
				     (((app_ly_162_bglt) CREF(node_1226))->arg));
				  {	/* Ast/alphatize.scm 157 */
				     bool_t test1793_1229;
				     test1793_1229 =
					is_a__118___object(
					(obj_t) (fun_1227), closure_ast_node);
				     if (test1793_1229)
				       {	/* Ast/alphatize.scm 158 */
					  obj_t arg1795_1231;
					  var_bglt arg1796_1232;
					  obj_t arg1797_1233;
					  arg1795_1231 =
					     get_location_95_ast_alphatize(
					     (obj_t) (node_1226));
					  {	/* Ast/alphatize.scm 160 */
					     var_bglt duplicated1473_1234;
					     duplicated1473_1234 =
						(var_bglt) (fun_1227);
					     {	/* Ast/alphatize.scm 160 */
						var_bglt new1474_1235;
						{	/* Ast/alphatize.scm 160 */
						   obj_t arg1798_1236;
						   type_bglt arg1800_1237;
						   variable_bglt arg1801_1238;
						   arg1798_1236 =
						      (((var_bglt) CREF(duplicated1473_1234))->loc);
						   arg1800_1237 =
						      (((var_bglt) CREF(duplicated1473_1234))->type);
						   arg1801_1238 =
						      (((var_bglt) CREF(duplicated1473_1234))->variable);
						   {	/* Ast/alphatize.scm 160 */
						      var_bglt res2066_2116;
						      {		/* ./Ast/node.scm 886 */
							 var_bglt new1210_2109;
							 new1210_2109 =
							    ((var_bglt) BREF(GC_MALLOC(sizeof(struct var))));
							 {	/* ./Ast/node.scm 886 */
							    long arg1664_2110;
							    arg1664_2110 =
							       class_num_218___object(var_ast_node);
							    {	/* ./Ast/node.scm 886 */
							       obj_t obj_2114;
							       obj_2114 =
								  (obj_t) (new1210_2109);
							       (((obj_t) CREF(obj_2114))->header = MAKE_HEADER(arg1664_2110, 0), BUNSPEC);
							    }
							 }
							 {	/* ./Ast/node.scm 886 */
							    object_bglt aux_3102;
							    aux_3102 =
							       (object_bglt) (new1210_2109);
							    OBJECT_WIDENING_SET(aux_3102, BFALSE);
							 }
							 ((((var_bglt) CREF(new1210_2109))->loc) = ((obj_t) arg1798_1236), BUNSPEC);
							 ((((var_bglt) CREF(new1210_2109))->type) = ((type_bglt) arg1800_1237), BUNSPEC);
							 ((((var_bglt) CREF(new1210_2109))->variable) = ((variable_bglt) arg1801_1238), BUNSPEC);
							 res2066_2116 = new1210_2109;
						      }
						      new1474_1235 = res2066_2116;
						   }
						}
						{	/* Ast/alphatize.scm 160 */

						   arg1796_1232 = new1474_1235;
						}
					     }
					  }
					  arg1797_1233 =
					     CNST_TABLE_REF(((long) 1));
					  {	/* Ast/alphatize.scm 158 */
					     node_bglt aux_3109;
					     aux_3109 =
						known_app_ly__node_26_ast_apply(BNIL, arg1795_1231,
						(node_bglt) (arg1796_1232), arg_1228, arg1797_1233);
					     aux_2788 =
						(obj_t) (aux_3109);
					  }
				       }
				     else
				       {	/* Ast/alphatize.scm 164 */
					  app_ly_162_bglt new1476_1240;
					  {	/* Ast/alphatize.scm 164 */
					     obj_t arg1802_1241;
					     type_bglt arg1803_1242;
					     arg1802_1241 =
						get_location_95_ast_alphatize(
						(obj_t) (node_1226));
					     arg1803_1242 =
						(((app_ly_162_bglt) CREF(node_1226))->type);
					     {	/* Ast/alphatize.scm 163 */
						app_ly_162_bglt res2067_2130;
						{	/* ./Ast/node.scm 912 */
						   app_ly_162_bglt new1261_2122;
						   new1261_2122 =
						      ((app_ly_162_bglt) BREF(GC_MALLOC(sizeof(struct app_ly_162))));
						   {	/* ./Ast/node.scm 912 */
						      long arg1654_2123;
						      arg1654_2123 =
							 class_num_218___object(app_ly_162_ast_node);
						      {		/* ./Ast/node.scm 912 */
							 obj_t obj_2128;
							 obj_2128 =
							    (obj_t) (new1261_2122);
							 (((obj_t) CREF(obj_2128))->header = MAKE_HEADER(arg1654_2123, 0), BUNSPEC);
						      }
						   }
						   {	/* ./Ast/node.scm 912 */
						      object_bglt aux_3120;
						      aux_3120 =
							 (object_bglt) (new1261_2122);
						      OBJECT_WIDENING_SET(aux_3120, BFALSE);
						   }
						   ((((app_ly_162_bglt) CREF(new1261_2122))->loc) = ((obj_t) arg1802_1241), BUNSPEC);
						   ((((app_ly_162_bglt) CREF(new1261_2122))->type) = ((type_bglt) arg1803_1242), BUNSPEC);
						   ((((app_ly_162_bglt) CREF(new1261_2122))->fun) = ((node_bglt) fun_1227), BUNSPEC);
						   ((((app_ly_162_bglt) CREF(new1261_2122))->arg) = ((node_bglt) arg_1228), BUNSPEC);
						   res2067_2130 = new1261_2122;
						}
						new1476_1240 = res2067_2130;
					     }
					  }
					  {	/* Ast/alphatize.scm 163 */

					     aux_2788 =
						(obj_t) (new1476_1240);
					  }
				       }
				  }
			       }
			    }
			    break;
			 case ((long) 7):

			    {	/* Ast/alphatize.scm 175 */
			       funcall_bglt node_1247;
			       node_1247 =
				  (funcall_bglt) (node_20);
			       {	/* Ast/alphatize.scm 175 */
				  node_bglt fun_1248;
				  obj_t args_1249;
				  fun_1248 =
				     do_alphatize_126_ast_alphatize(
				     (((funcall_bglt) CREF(node_1247))->fun));
				  {	/* Ast/alphatize.scm 176 */
				     obj_t l1477_1276;
				     l1477_1276 =
					(((funcall_bglt) CREF(node_1247))->args);
				     if (
					NULLP(l1477_1276))
				       {	/* Ast/alphatize.scm 176 */
					  args_1249 = BNIL;
				       }
				     else
				       {	/* Ast/alphatize.scm 176 */
					  obj_t head1479_1278;
					  {	/* Ast/alphatize.scm 176 */
					     node_bglt arg1841_1289;
					     {	/* Ast/alphatize.scm 176 */
						node_bglt aux_3134;
						{	/* Ast/alphatize.scm 176 */
						   obj_t aux_3135;
						   aux_3135 =
						      CAR(l1477_1276);
						   aux_3134 =
						      (node_bglt) (aux_3135);
						}
						arg1841_1289 =
						   do_alphatize_126_ast_alphatize(aux_3134);
					     }
					     {	/* ./Ieee/pair-list.scm 5689 */
						obj_t aux_3139;
						aux_3139 =
						   (obj_t) (arg1841_1289);
						head1479_1278 =
						   MAKE_PAIR(aux_3139, BNIL);
					     }
					  }
					  {
					     obj_t l1477_1279;
					     obj_t tail1480_1280;
					     l1477_1279 =
						CDR(l1477_1276);
					     tail1480_1280 = head1479_1278;
					   lname1478_1281:
					     if (
						NULLP(l1477_1279))
					       {	/* Ast/alphatize.scm 176 */
						  args_1249 = head1479_1278;
					       }
					     else
					       {	/* Ast/alphatize.scm 176 */
						  obj_t newtail1481_1284;
						  {	/* Ast/alphatize.scm 176 */
						     node_bglt arg1836_1286;
						     {	/* Ast/alphatize.scm 176 */
							node_bglt aux_3144;
							{	/* Ast/alphatize.scm 176 */
							   obj_t aux_3145;
							   aux_3145 =
							      CAR(l1477_1279);
							   aux_3144 =
							      (node_bglt) (aux_3145);
							}
							arg1836_1286 =
							   do_alphatize_126_ast_alphatize(aux_3144);
						     }
						     {	/* ./Ieee/pair-list.scm 5689 */
							obj_t aux_3149;
							aux_3149 =
							   (obj_t) (arg1836_1286);
							newtail1481_1284 =
							   MAKE_PAIR(aux_3149, BNIL);
						     }
						  }
						  SET_CDR(tail1480_1280, newtail1481_1284);
						  {
						     obj_t tail1480_3155;
						     obj_t l1477_3153;
						     l1477_3153 =
							CDR(l1477_1279);
						     tail1480_3155 = newtail1481_1284;
						     tail1480_1280 = tail1480_3155;
						     l1477_1279 = l1477_3153;
						     goto lname1478_1281;
						  }
					       }
					  }
				       }
				  }
				  {	/* Ast/alphatize.scm 177 */
				     bool_t test1808_1250;
				     test1808_1250 =
					is_a__118___object(
					(obj_t) (fun_1248), closure_ast_node);
				     if (test1808_1250)
				       {	/* Ast/alphatize.scm 178 */
					  bool_t test1809_1251;
					  {	/* Ast/alphatize.scm 178 */
					     variable_bglt aux_3160;
					     {	/* Ast/alphatize.scm 178 */
						var_bglt obj_2146;
						obj_2146 =
						   (var_bglt) (fun_1248);
						aux_3160 =
						   (((var_bglt) CREF(obj_2146))->variable);
					     }
					     test1809_1251 =
						correct_arity_app__187_ast_app(aux_3160,
						CDR(args_1249));
					  }
					  if (test1809_1251)
					    {	/* Ast/alphatize.scm 180 */
					       obj_t arg1811_1253;
					       var_bglt arg1812_1254;
					       obj_t arg1813_1255;
					       arg1811_1253 =
						  get_location_95_ast_alphatize(
						  (obj_t) (node_1247));
					       {	/* Ast/alphatize.scm 182 */
						  var_bglt duplicated1482_1256;
						  duplicated1482_1256 =
						     (var_bglt) (fun_1248);
						  {	/* Ast/alphatize.scm 182 */
						     var_bglt new1483_1257;
						     {	/* Ast/alphatize.scm 182 */
							obj_t arg1814_1258;
							type_bglt arg1815_1259;
							variable_bglt arg1816_1260;
							arg1814_1258 =
							   (((var_bglt) CREF(duplicated1482_1256))->loc);
							arg1815_1259 =
							   (((var_bglt) CREF(duplicated1482_1256))->type);
							arg1816_1260 =
							   (((var_bglt) CREF(duplicated1482_1256))->variable);
							{	/* Ast/alphatize.scm 182 */
							   var_bglt res2068_2161;
							   {	/* ./Ast/node.scm 886 */
							      var_bglt new1210_2154;
							      new1210_2154 =
								 ((var_bglt) BREF(GC_MALLOC(sizeof(struct var))));
							      {		/* ./Ast/node.scm 886 */
								 long arg1664_2155;
								 arg1664_2155 =
								    class_num_218___object(var_ast_node);
								 {	/* ./Ast/node.scm 886 */
								    obj_t obj_2159;
								    obj_2159 =
								       (obj_t) (new1210_2154);
								    (((obj_t) CREF(obj_2159))->header = MAKE_HEADER(arg1664_2155, 0), BUNSPEC);
								 }
							      }
							      {		/* ./Ast/node.scm 886 */
								 object_bglt aux_3176;
								 aux_3176 =
								    (object_bglt) (new1210_2154);
								 OBJECT_WIDENING_SET(aux_3176, BFALSE);
							      }
							      ((((var_bglt) CREF(new1210_2154))->loc) = ((obj_t) arg1814_1258), BUNSPEC);
							      ((((var_bglt) CREF(new1210_2154))->type) = ((type_bglt) arg1815_1259), BUNSPEC);
							      ((((var_bglt) CREF(new1210_2154))->variable) = ((variable_bglt) arg1816_1260), BUNSPEC);
							      res2068_2161 = new1210_2154;
							   }
							   new1483_1257 = res2068_2161;
							}
						     }
						     {	/* Ast/alphatize.scm 182 */

							arg1812_1254 = new1483_1257;
						     }
						  }
					       }
					       arg1813_1255 =
						  CDR(args_1249);
					       {	/* Ast/alphatize.scm 180 */
						  node_bglt aux_3183;
						  aux_3183 =
						     make_app_node_80_ast_app(BNIL, arg1811_1253, arg1812_1254, arg1813_1255);
						  aux_2788 =
						     (obj_t) (aux_3183);
					       }
					    }
					  else
					    {	/* Ast/alphatize.scm 184 */
					       obj_t arg1817_1261;
					       obj_t arg1821_1264;
					       arg1817_1261 =
						  get_location_95_ast_alphatize(
						  (obj_t) (node_1247));
					       arg1821_1264 =
						  shape_tools_shape(
						  (obj_t) (node_1247));
					       aux_2788 =
						  user_error_location_137_tools_error(arg1817_1261, string2094_ast_alphatize, string2095_ast_alphatize, arg1821_1264, BNIL);
					    }
				       }
				     else
				       {	/* Ast/alphatize.scm 189 */
					  funcall_bglt new1485_1269;
					  {	/* Ast/alphatize.scm 189 */
					     obj_t arg1825_1270;
					     type_bglt arg1826_1271;
					     obj_t arg1830_1274;
					     arg1825_1270 =
						get_location_95_ast_alphatize(
						(obj_t) (node_1247));
					     arg1826_1271 =
						(((funcall_bglt) CREF(node_1247))->type);
					     arg1830_1274 =
						(((funcall_bglt) CREF(node_1247))->strength);
					     {	/* Ast/alphatize.scm 188 */
						funcall_bglt res2069_2179;
						{	/* ./Ast/node.scm 919 */
						   funcall_bglt new1272_2170;
						   new1272_2170 =
						      ((funcall_bglt) BREF(GC_MALLOC(sizeof(struct funcall))));
						   {	/* ./Ast/node.scm 919 */
						      long arg1652_2171;
						      arg1652_2171 =
							 class_num_218___object(funcall_ast_node);
						      {		/* ./Ast/node.scm 919 */
							 obj_t obj_2177;
							 obj_2177 =
							    (obj_t) (new1272_2170);
							 (((obj_t) CREF(obj_2177))->header = MAKE_HEADER(arg1652_2171, 0), BUNSPEC);
						      }
						   }
						   {	/* ./Ast/node.scm 919 */
						      object_bglt aux_3199;
						      aux_3199 =
							 (object_bglt) (new1272_2170);
						      OBJECT_WIDENING_SET(aux_3199, BFALSE);
						   }
						   ((((funcall_bglt) CREF(new1272_2170))->loc) = ((obj_t) arg1825_1270), BUNSPEC);
						   ((((funcall_bglt) CREF(new1272_2170))->type) = ((type_bglt) arg1826_1271), BUNSPEC);
						   ((((funcall_bglt) CREF(new1272_2170))->fun) = ((node_bglt) fun_1248), BUNSPEC);
						   ((((funcall_bglt) CREF(new1272_2170))->args) = ((obj_t) args_1249), BUNSPEC);
						   ((((funcall_bglt) CREF(new1272_2170))->strength) = ((obj_t) arg1830_1274), BUNSPEC);
						   res2069_2179 = new1272_2170;
						}
						new1485_1269 = res2069_2179;
					     }
					  }
					  {	/* Ast/alphatize.scm 188 */

					     aux_2788 =
						(obj_t) (new1485_1269);
					  }
				       }
				  }
			       }
			    }
			    break;
			 case ((long) 8):

			    {	/* Ast/alphatize.scm 197 */
			       pragma_bglt node_1292;
			       node_1292 =
				  (pragma_bglt) (node_20);
			       {	/* Ast/alphatize.scm 198 */
				  pragma_bglt new1487_1294;
				  {	/* Ast/alphatize.scm 198 */
				     obj_t arg1844_1295;
				     type_bglt arg1845_1296;
				     obj_t arg1846_1297;
				     obj_t arg1847_1298;
				     obj_t arg1848_1299;
				     obj_t arg1849_1300;
				     arg1844_1295 =
					get_location_95_ast_alphatize(
					(obj_t) (node_1292));
				     arg1845_1296 =
					(((pragma_bglt) CREF(node_1292))->type);
				     arg1846_1297 =
					(((pragma_bglt) CREF(node_1292))->side_effect__165);
				     arg1847_1298 =
					(((pragma_bglt) CREF(node_1292))->key);
				     arg1848_1299 =
					(((pragma_bglt) CREF(node_1292))->format);
				     {	/* Ast/alphatize.scm 199 */
					obj_t l1488_1301;
					l1488_1301 =
					   (((pragma_bglt) CREF(node_1292))->args);
					if (
					   NULLP(l1488_1301))
					  {	/* Ast/alphatize.scm 199 */
					     arg1849_1300 = BNIL;
					  }
					else
					  {	/* Ast/alphatize.scm 199 */
					     obj_t head1490_1303;
					     {	/* Ast/alphatize.scm 199 */
						node_bglt arg1857_1314;
						{	/* Ast/alphatize.scm 199 */
						   node_bglt aux_3218;
						   {	/* Ast/alphatize.scm 199 */
						      obj_t aux_3219;
						      aux_3219 =
							 CAR(l1488_1301);
						      aux_3218 =
							 (node_bglt) (aux_3219);
						   }
						   arg1857_1314 =
						      do_alphatize_126_ast_alphatize(aux_3218);
						}
						{	/* ./Ieee/pair-list.scm 5689 */
						   obj_t aux_3223;
						   aux_3223 =
						      (obj_t) (arg1857_1314);
						   head1490_1303 =
						      MAKE_PAIR(aux_3223, BNIL);
						}
					     }
					     {
						obj_t l1488_1304;
						obj_t tail1491_1305;
						l1488_1304 =
						   CDR(l1488_1301);
						tail1491_1305 = head1490_1303;
					      lname1489_1306:
						if (
						   NULLP(l1488_1304))
						  {	/* Ast/alphatize.scm 199 */
						     arg1849_1300 = head1490_1303;
						  }
						else
						  {	/* Ast/alphatize.scm 199 */
						     obj_t newtail1492_1309;
						     {	/* Ast/alphatize.scm 199 */
							node_bglt arg1854_1311;
							{	/* Ast/alphatize.scm 199 */
							   node_bglt aux_3228;
							   {	/* Ast/alphatize.scm 199 */
							      obj_t aux_3229;
							      aux_3229 =
								 CAR(l1488_1304);
							      aux_3228 =
								 (node_bglt) (aux_3229);
							   }
							   arg1854_1311 =
							      do_alphatize_126_ast_alphatize(aux_3228);
							}
							{	/* ./Ieee/pair-list.scm 5689 */
							   obj_t aux_3233;
							   aux_3233 =
							      (obj_t) (arg1854_1311);
							   newtail1492_1309 =
							      MAKE_PAIR(aux_3233, BNIL);
							}
						     }
						     SET_CDR(tail1491_1305, newtail1492_1309);
						     {
							obj_t tail1491_3239;
							obj_t l1488_3237;
							l1488_3237 =
							   CDR(l1488_1304);
							tail1491_3239 = newtail1492_1309;
							tail1491_1305 = tail1491_3239;
							l1488_1304 = l1488_3237;
							goto lname1489_1306;
						     }
						  }
					     }
					  }
				     }
				     {	/* Ast/alphatize.scm 197 */
					pragma_bglt res2070_2213;
					{	/* ./Ast/node.scm 930 */
					   pragma_bglt new1284_2203;
					   new1284_2203 =
					      ((pragma_bglt) BREF(GC_MALLOC(sizeof(struct pragma))));
					   {	/* ./Ast/node.scm 930 */
					      long arg1650_2204;
					      arg1650_2204 =
						 class_num_218___object(pragma_ast_node);
					      {		/* ./Ast/node.scm 930 */
						 obj_t obj_2211;
						 obj_2211 =
						    (obj_t) (new1284_2203);
						 (((obj_t) CREF(obj_2211))->header = MAKE_HEADER(arg1650_2204, 0), BUNSPEC);
					      }
					   }
					   {	/* ./Ast/node.scm 930 */
					      object_bglt aux_3245;
					      aux_3245 =
						 (object_bglt) (new1284_2203);
					      OBJECT_WIDENING_SET(aux_3245, BFALSE);
					   }
					   ((((pragma_bglt) CREF(new1284_2203))->loc) = ((obj_t) arg1844_1295), BUNSPEC);
					   ((((pragma_bglt) CREF(new1284_2203))->type) = ((type_bglt) arg1845_1296), BUNSPEC);
					   ((((pragma_bglt) CREF(new1284_2203))->side_effect__165) = ((obj_t) arg1846_1297), BUNSPEC);
					   ((((pragma_bglt) CREF(new1284_2203))->key) = ((obj_t) arg1847_1298), BUNSPEC);
					   ((((pragma_bglt) CREF(new1284_2203))->format) = ((obj_t) arg1848_1299), BUNSPEC);
					   ((((pragma_bglt) CREF(new1284_2203))->args) = ((obj_t) arg1849_1300), BUNSPEC);
					   res2070_2213 = new1284_2203;
					}
					new1487_1294 = res2070_2213;
				     }
				  }
				  {	/* Ast/alphatize.scm 197 */

				     aux_2788 =
					(obj_t) (new1487_1294);
				  }
			       }
			    }
			    break;
			 case ((long) 9):

			    {	/* Ast/alphatize.scm 205 */
			       cast_bglt node_1317;
			       node_1317 =
				  (cast_bglt) (node_20);
			       {	/* Ast/alphatize.scm 206 */
				  cast_bglt new1494_1319;
				  {	/* Ast/alphatize.scm 206 */
				     obj_t arg1860_1320;
				     type_bglt arg1861_1321;
				     node_bglt arg1862_1322;
				     arg1860_1320 =
					get_location_95_ast_alphatize(
					(obj_t) (node_1317));
				     arg1861_1321 =
					(((cast_bglt) CREF(node_1317))->type);
				     arg1862_1322 =
					do_alphatize_126_ast_alphatize(
					(((cast_bglt) CREF(node_1317))->arg));
				     {	/* Ast/alphatize.scm 205 */
					cast_bglt res2071_2226;
					{	/* ./Ast/node.scm 935 */
					   cast_bglt new1295_2219;
					   new1295_2219 =
					      ((cast_bglt) BREF(GC_MALLOC(sizeof(struct cast))));
					   {	/* ./Ast/node.scm 935 */
					      long arg1648_2220;
					      arg1648_2220 =
						 class_num_218___object(cast_ast_node);
					      {		/* ./Ast/node.scm 935 */
						 obj_t obj_2224;
						 obj_2224 =
						    (obj_t) (new1295_2219);
						 (((obj_t) CREF(obj_2224))->header = MAKE_HEADER(arg1648_2220, 0), BUNSPEC);
					      }
					   }
					   {	/* ./Ast/node.scm 935 */
					      object_bglt aux_3265;
					      aux_3265 =
						 (object_bglt) (new1295_2219);
					      OBJECT_WIDENING_SET(aux_3265, BFALSE);
					   }
					   ((((cast_bglt) CREF(new1295_2219))->loc) = ((obj_t) arg1860_1320), BUNSPEC);
					   ((((cast_bglt) CREF(new1295_2219))->type) = ((type_bglt) arg1861_1321), BUNSPEC);
					   ((((cast_bglt) CREF(new1295_2219))->arg) = ((node_bglt) arg1862_1322), BUNSPEC);
					   res2071_2226 = new1295_2219;
					}
					new1494_1319 = res2071_2226;
				     }
				  }
				  {	/* Ast/alphatize.scm 205 */

				     aux_2788 =
					(obj_t) (new1494_1319);
				  }
			       }
			    }
			    break;
			 case ((long) 10):

			    {	/* Ast/alphatize.scm 213 */
			       setq_bglt node_1324;
			       node_1324 =
				  (setq_bglt) (node_20);
			       {	/* Ast/alphatize.scm 213 */
				  var_bglt v_1325;
				  v_1325 =
				     (((setq_bglt) CREF(node_1324))->var);
				  {	/* Ast/alphatize.scm 213 */
				     variable_bglt var_1326;
				     var_1326 =
					(((var_bglt) CREF(v_1325))->variable);
				     {	/* Ast/alphatize.scm 214 */
					obj_t alpha_1327;
					alpha_1327 =
					   (((variable_bglt) CREF(var_1326))->fast_alpha_7);
					{	/* Ast/alphatize.scm 215 */

					   if (
					      (alpha_1327 == BUNSPEC))
					     {	/* Ast/alphatize.scm 217 */
						{	/* Ast/alphatize.scm 218 */
						   obj_t aux_3278;
						   {	/* Ast/alphatize.scm 218 */
						      node_bglt obj_2232;
						      obj_2232 =
							 (node_bglt) (node_1324);
						      aux_3278 =
							 (((node_bglt) CREF(obj_2232))->loc);
						   }
						   use_variable__4_ast_sexp(var_1326, aux_3278,
						      CNST_TABLE_REF(((long) 2)));
						}
						{	/* Ast/alphatize.scm 220 */
						   setq_bglt new1496_1332;
						   {	/* Ast/alphatize.scm 220 */
						      obj_t arg1867_1333;
						      type_bglt arg1868_1334;
						      var_bglt arg1869_1335;
						      node_bglt arg1870_1336;
						      arg1867_1333 =
							 get_location_95_ast_alphatize(
							 (obj_t) (node_1324));
						      arg1868_1334 =
							 (((setq_bglt) CREF(node_1324))->type);
						      {		/* Ast/alphatize.scm 221 */
							 var_bglt new1498_1338;
							 {	/* Ast/alphatize.scm 221 */
							    obj_t arg1871_1339;
							    type_bglt arg1872_1340;
							    variable_bglt arg1873_1341;
							    arg1871_1339 =
							       get_location_95_ast_alphatize(
							       (obj_t) (node_1324));
							    arg1872_1340 =
							       (((var_bglt) CREF(v_1325))->type);
							    arg1873_1341 =
							       (((var_bglt) CREF(v_1325))->variable);
							    {	/* Ast/alphatize.scm 221 */
							       var_bglt res2072_2246;
							       {	/* ./Ast/node.scm 886 */
								  var_bglt new1210_2239;
								  new1210_2239 =
								     ((var_bglt) BREF(GC_MALLOC(sizeof(struct var))));
								  {	/* ./Ast/node.scm 886 */
								     long arg1664_2240;
								     arg1664_2240 =
									class_num_218___object(var_ast_node);
								     {	/* ./Ast/node.scm 886 */
									obj_t obj_2244;
									obj_2244 =
									   (obj_t) (new1210_2239);
									(((obj_t) CREF(obj_2244))->header = MAKE_HEADER(arg1664_2240, 0), BUNSPEC);
								     }
								  }
								  {	/* ./Ast/node.scm 886 */
								     object_bglt aux_3294;
								     aux_3294 =
									(object_bglt) (new1210_2239);
								     OBJECT_WIDENING_SET(aux_3294, BFALSE);
								  }
								  ((((var_bglt) CREF(new1210_2239))->loc) = ((obj_t) arg1871_1339), BUNSPEC);
								  ((((var_bglt) CREF(new1210_2239))->type) = ((type_bglt) arg1872_1340), BUNSPEC);
								  ((((var_bglt) CREF(new1210_2239))->variable) = ((variable_bglt) arg1873_1341), BUNSPEC);
								  res2072_2246 = new1210_2239;
							       }
							       new1498_1338 = res2072_2246;
							    }
							 }
							 {	/* Ast/alphatize.scm 221 */

							    arg1869_1335 = new1498_1338;
							 }
						      }
						      arg1870_1336 =
							 do_alphatize_126_ast_alphatize(
							 (((setq_bglt) CREF(node_1324))->value));
						      {		/* Ast/alphatize.scm 219 */
							 setq_bglt res2073_2260;
							 {	/* ./Ast/node.scm 940 */
							    setq_bglt new1304_2252;
							    new1304_2252 =
							       ((setq_bglt) BREF(GC_MALLOC(sizeof(struct setq))));
							    {	/* ./Ast/node.scm 940 */
							       long arg1646_2253;
							       arg1646_2253 =
								  class_num_218___object(setq_ast_node);
							       {	/* ./Ast/node.scm 940 */
								  obj_t obj_2258;
								  obj_2258 =
								     (obj_t) (new1304_2252);
								  (((obj_t) CREF(obj_2258))->header = MAKE_HEADER(arg1646_2253, 0), BUNSPEC);
							       }
							    }
							    {	/* ./Ast/node.scm 940 */
							       object_bglt aux_3306;
							       aux_3306 =
								  (object_bglt) (new1304_2252);
							       OBJECT_WIDENING_SET(aux_3306, BFALSE);
							    }
							    ((((setq_bglt) CREF(new1304_2252))->loc) = ((obj_t) arg1867_1333), BUNSPEC);
							    ((((setq_bglt) CREF(new1304_2252))->type) = ((type_bglt) arg1868_1334), BUNSPEC);
							    ((((setq_bglt) CREF(new1304_2252))->var) = ((var_bglt) arg1869_1335), BUNSPEC);
							    ((((setq_bglt) CREF(new1304_2252))->value) = ((node_bglt) arg1870_1336), BUNSPEC);
							    res2073_2260 = new1304_2252;
							 }
							 new1496_1332 = res2073_2260;
						      }
						   }
						   {	/* Ast/alphatize.scm 219 */

						      aux_2788 =
							 (obj_t) (new1496_1332);
						   }
						}
					     }
					   else
					     {	/* Ast/alphatize.scm 223 */
						bool_t test1875_1343;
						test1875_1343 =
						   is_a__118___object(alpha_1327, variable_ast_var);
						if (test1875_1343)
						  {	/* Ast/alphatize.scm 223 */
						     {	/* Ast/alphatize.scm 224 */
							obj_t aux_3316;
							{	/* Ast/alphatize.scm 224 */
							   node_bglt obj_2262;
							   obj_2262 =
							      (node_bglt) (node_1324);
							   aux_3316 =
							      (((node_bglt) CREF(obj_2262))->loc);
							}
							use_variable__4_ast_sexp(
							   (variable_bglt) (alpha_1327), aux_3316,
							   CNST_TABLE_REF(((long) 2)));
						     }
						     {	/* Ast/alphatize.scm 226 */
							setq_bglt new1500_1347;
							{	/* Ast/alphatize.scm 226 */
							   obj_t arg1879_1348;
							   type_bglt arg1880_1349;
							   var_bglt arg1881_1350;
							   node_bglt arg1882_1351;
							   arg1879_1348 =
							      get_location_95_ast_alphatize(
							      (obj_t) (node_1324));
							   arg1880_1349 =
							      (((setq_bglt) CREF(node_1324))->type);
							   {	/* Ast/alphatize.scm 228 */
							      var_bglt new1502_1353;
							      {		/* Ast/alphatize.scm 228 */
								 obj_t arg1883_1354;
								 type_bglt arg1884_1355;
								 arg1883_1354 =
								    get_location_95_ast_alphatize(
								    (obj_t) (node_1324));
								 arg1884_1355 =
								    (((var_bglt) CREF(v_1325))->type);
								 {	/* Ast/alphatize.scm 227 */
								    var_bglt res2074_2275;
								    {	/* Ast/alphatize.scm 227 */
								       variable_bglt variable_2267;
								       variable_2267 =
									  (variable_bglt) (alpha_1327);
								       {	/* ./Ast/node.scm 886 */
									  var_bglt new1210_2268;
									  new1210_2268 =
									     ((var_bglt) BREF(GC_MALLOC(sizeof(struct var))));
									  {	/* ./Ast/node.scm 886 */
									     long arg1664_2269;
									     arg1664_2269 =
										class_num_218___object(var_ast_node);
									     {	/* ./Ast/node.scm 886 */
										obj_t obj_2273;
										obj_2273 =
										   (obj_t) (new1210_2268);
										(((obj_t) CREF(obj_2273))->header = MAKE_HEADER(arg1664_2269, 0), BUNSPEC);
									     }
									  }
									  {	/* ./Ast/node.scm 886 */
									     object_bglt aux_3333;
									     aux_3333 =
										(object_bglt) (new1210_2268);
									     OBJECT_WIDENING_SET(aux_3333, BFALSE);
									  }
									  ((((var_bglt) CREF(new1210_2268))->loc) = ((obj_t) arg1883_1354), BUNSPEC);
									  ((((var_bglt) CREF(new1210_2268))->type) = ((type_bglt) arg1884_1355), BUNSPEC);
									  ((((var_bglt) CREF(new1210_2268))->variable) = ((variable_bglt) variable_2267), BUNSPEC);
									  res2074_2275 = new1210_2268;
								       }
								    }
								    new1502_1353 = res2074_2275;
								 }
							      }
							      {		/* Ast/alphatize.scm 227 */

								 arg1881_1350 = new1502_1353;
							      }
							   }
							   arg1882_1351 =
							      do_alphatize_126_ast_alphatize(
							      (((setq_bglt) CREF(node_1324))->value));
							   {	/* Ast/alphatize.scm 225 */
							      setq_bglt res2075_2289;
							      {		/* ./Ast/node.scm 940 */
								 setq_bglt new1304_2281;
								 new1304_2281 =
								    ((setq_bglt) BREF(GC_MALLOC(sizeof(struct setq))));
								 {	/* ./Ast/node.scm 940 */
								    long arg1646_2282;
								    arg1646_2282 =
								       class_num_218___object(setq_ast_node);
								    {	/* ./Ast/node.scm 940 */
								       obj_t obj_2287;
								       obj_2287 =
									  (obj_t) (new1304_2281);
								       (((obj_t) CREF(obj_2287))->header = MAKE_HEADER(arg1646_2282, 0), BUNSPEC);
								    }
								 }
								 {	/* ./Ast/node.scm 940 */
								    object_bglt aux_3345;
								    aux_3345 =
								       (object_bglt) (new1304_2281);
								    OBJECT_WIDENING_SET(aux_3345, BFALSE);
								 }
								 ((((setq_bglt) CREF(new1304_2281))->loc) = ((obj_t) arg1879_1348), BUNSPEC);
								 ((((setq_bglt) CREF(new1304_2281))->type) = ((type_bglt) arg1880_1349), BUNSPEC);
								 ((((setq_bglt) CREF(new1304_2281))->var) = ((var_bglt) arg1881_1350), BUNSPEC);
								 ((((setq_bglt) CREF(new1304_2281))->value) = ((node_bglt) arg1882_1351), BUNSPEC);
								 res2075_2289 = new1304_2281;
							      }
							      new1500_1347 = res2075_2289;
							   }
							}
							{	/* Ast/alphatize.scm 225 */

							   aux_2788 =
							      (obj_t) (new1500_1347);
							}
						     }
						  }
						else
						  {	/* Ast/alphatize.scm 223 */
						     {	/* Ast/alphatize.scm 232 */
							obj_t arg1889_1360;
							arg1889_1360 =
							   shape_tools_shape(
							   (obj_t) (node_1324));
							aux_2788 =
							   internal_error_43_tools_error(string2092_ast_alphatize, string2093_ast_alphatize, arg1889_1360);
						     }
						  }
					     }
					}
				     }
				  }
			       }
			    }
			    break;
			 case ((long) 11):

			    {	/* Ast/alphatize.scm 240 */
			       conditional_bglt node_1361;
			       node_1361 =
				  (conditional_bglt) (node_20);
			       {	/* Ast/alphatize.scm 241 */
				  conditional_bglt new1504_1363;
				  {	/* Ast/alphatize.scm 241 */
				     obj_t arg1890_1364;
				     type_bglt arg1891_1365;
				     obj_t arg1892_1366;
				     obj_t arg1893_1367;
				     node_bglt arg1894_1368;
				     node_bglt arg1895_1369;
				     node_bglt arg1896_1370;
				     arg1890_1364 =
					get_location_95_ast_alphatize(
					(obj_t) (node_1361));
				     arg1891_1365 =
					(((conditional_bglt) CREF(node_1361))->type);
				     arg1892_1366 =
					(((conditional_bglt) CREF(node_1361))->side_effect__165);
				     arg1893_1367 =
					(((conditional_bglt) CREF(node_1361))->key);
				     arg1894_1368 =
					do_alphatize_126_ast_alphatize(
					(((conditional_bglt) CREF(node_1361))->test));
				     arg1895_1369 =
					do_alphatize_126_ast_alphatize(
					(((conditional_bglt) CREF(node_1361))->true));
				     arg1896_1370 =
					do_alphatize_126_ast_alphatize(
					(((conditional_bglt) CREF(node_1361))->false));
				     {	/* Ast/alphatize.scm 240 */
					conditional_bglt res2076_2314;
					{	/* ./Ast/node.scm 947 */
					   conditional_bglt new1317_2303;
					   new1317_2303 =
					      ((conditional_bglt) BREF(GC_MALLOC(sizeof(struct conditional))));
					   {	/* ./Ast/node.scm 947 */
					      long arg1643_2304;
					      arg1643_2304 =
						 class_num_218___object(conditional_ast_node);
					      {		/* ./Ast/node.scm 947 */
						 obj_t obj_2312;
						 obj_2312 =
						    (obj_t) (new1317_2303);
						 (((obj_t) CREF(obj_2312))->header = MAKE_HEADER(arg1643_2304, 0), BUNSPEC);
					      }
					   }
					   {	/* ./Ast/node.scm 947 */
					      object_bglt aux_3372;
					      aux_3372 =
						 (object_bglt) (new1317_2303);
					      OBJECT_WIDENING_SET(aux_3372, BFALSE);
					   }
					   ((((conditional_bglt) CREF(new1317_2303))->loc) = ((obj_t) arg1890_1364), BUNSPEC);
					   ((((conditional_bglt) CREF(new1317_2303))->type) = ((type_bglt) arg1891_1365), BUNSPEC);
					   ((((conditional_bglt) CREF(new1317_2303))->side_effect__165) = ((obj_t) arg1892_1366), BUNSPEC);
					   ((((conditional_bglt) CREF(new1317_2303))->key) = ((obj_t) arg1893_1367), BUNSPEC);
					   ((((conditional_bglt) CREF(new1317_2303))->test) = ((node_bglt) arg1894_1368), BUNSPEC);
					   ((((conditional_bglt) CREF(new1317_2303))->true) = ((node_bglt) arg1895_1369), BUNSPEC);
					   ((((conditional_bglt) CREF(new1317_2303))->false) = ((node_bglt) arg1896_1370), BUNSPEC);
					   res2076_2314 = new1317_2303;
					}
					new1504_1363 = res2076_2314;
				     }
				  }
				  {	/* Ast/alphatize.scm 240 */

				     aux_2788 =
					(obj_t) (new1504_1363);
				  }
			       }
			    }
			    break;
			 case ((long) 12):

			    {	/* Ast/alphatize.scm 250 */
			       fail_bglt node_1374;
			       node_1374 =
				  (fail_bglt) (node_20);
			       {	/* Ast/alphatize.scm 251 */
				  fail_bglt new1506_1376;
				  {	/* Ast/alphatize.scm 251 */
				     obj_t arg1900_1377;
				     type_bglt arg1901_1378;
				     node_bglt arg1902_1379;
				     node_bglt arg1903_1380;
				     node_bglt arg1904_1381;
				     arg1900_1377 =
					get_location_95_ast_alphatize(
					(obj_t) (node_1374));
				     arg1901_1378 =
					(((fail_bglt) CREF(node_1374))->type);
				     arg1902_1379 =
					do_alphatize_126_ast_alphatize(
					(((fail_bglt) CREF(node_1374))->proc));
				     arg1903_1380 =
					do_alphatize_126_ast_alphatize(
					(((fail_bglt) CREF(node_1374))->msg));
				     arg1904_1381 =
					do_alphatize_126_ast_alphatize(
					(((fail_bglt) CREF(node_1374))->obj));
				     {	/* Ast/alphatize.scm 250 */
					fail_bglt res2077_2333;
					{	/* ./Ast/node.scm 956 */
					   fail_bglt new1331_2324;
					   new1331_2324 =
					      ((fail_bglt) BREF(GC_MALLOC(sizeof(struct fail))));
					   {	/* ./Ast/node.scm 956 */
					      long arg1641_2325;
					      arg1641_2325 =
						 class_num_218___object(fail_ast_node);
					      {		/* ./Ast/node.scm 956 */
						 obj_t obj_2331;
						 obj_2331 =
						    (obj_t) (new1331_2324);
						 (((obj_t) CREF(obj_2331))->header = MAKE_HEADER(arg1641_2325, 0), BUNSPEC);
					      }
					   }
					   {	/* ./Ast/node.scm 956 */
					      object_bglt aux_3397;
					      aux_3397 =
						 (object_bglt) (new1331_2324);
					      OBJECT_WIDENING_SET(aux_3397, BFALSE);
					   }
					   ((((fail_bglt) CREF(new1331_2324))->loc) = ((obj_t) arg1900_1377), BUNSPEC);
					   ((((fail_bglt) CREF(new1331_2324))->type) = ((type_bglt) arg1901_1378), BUNSPEC);
					   ((((fail_bglt) CREF(new1331_2324))->proc) = ((node_bglt) arg1902_1379), BUNSPEC);
					   ((((fail_bglt) CREF(new1331_2324))->msg) = ((node_bglt) arg1903_1380), BUNSPEC);
					   ((((fail_bglt) CREF(new1331_2324))->obj) = ((node_bglt) arg1904_1381), BUNSPEC);
					   res2077_2333 = new1331_2324;
					}
					new1506_1376 = res2077_2333;
				     }
				  }
				  {	/* Ast/alphatize.scm 250 */

				     aux_2788 =
					(obj_t) (new1506_1376);
				  }
			       }
			    }
			    break;
			 case ((long) 13):

			    {	/* Ast/alphatize.scm 260 */
			       select_bglt node_1385;
			       node_1385 =
				  (select_bglt) (node_20);
			       {	/* Ast/alphatize.scm 261 */
				  select_bglt new1508_1387;
				  {	/* Ast/alphatize.scm 261 */
				     obj_t arg1909_1388;
				     type_bglt arg1910_1389;
				     obj_t arg1912_1390;
				     obj_t arg1913_1391;
				     node_bglt arg1914_1392;
				     obj_t arg1915_1393;
				     type_bglt arg1916_1394;
				     arg1909_1388 =
					get_location_95_ast_alphatize(
					(obj_t) (node_1385));
				     arg1910_1389 =
					(((select_bglt) CREF(node_1385))->type);
				     arg1912_1390 =
					(((select_bglt) CREF(node_1385))->side_effect__165);
				     arg1913_1391 =
					(((select_bglt) CREF(node_1385))->key);
				     arg1914_1392 =
					do_alphatize_126_ast_alphatize(
					(((select_bglt) CREF(node_1385))->test));
				     {	/* Ast/alphatize.scm 263 */
					obj_t l1509_1396;
					l1509_1396 =
					   (((select_bglt) CREF(node_1385))->clauses);
					if (
					   NULLP(l1509_1396))
					  {	/* Ast/alphatize.scm 263 */
					     arg1915_1393 = BNIL;
					  }
					else
					  {	/* Ast/alphatize.scm 263 */
					     obj_t head1511_1398;
					     head1511_1398 =
						MAKE_PAIR(BNIL, BNIL);
					     {
						obj_t l1509_1399;
						obj_t tail1512_1400;
						l1509_1399 = l1509_1396;
						tail1512_1400 = head1511_1398;
					      lname1510_1401:
						if (
						   NULLP(l1509_1399))
						  {	/* Ast/alphatize.scm 263 */
						     arg1915_1393 =
							CDR(head1511_1398);
						  }
						else
						  {	/* Ast/alphatize.scm 264 */
						     obj_t newtail1513_1403;
						     {	/* Ast/alphatize.scm 264 */
							obj_t arg1921_1405;
							{	/* Ast/alphatize.scm 264 */
							   obj_t clause_1407;
							   clause_1407 =
							      CAR(l1509_1399);
							   {	/* Ast/alphatize.scm 264 */
							      obj_t arg1923_1408;
							      node_bglt arg1924_1409;
							      arg1923_1408 =
								 CAR(clause_1407);
							      {		/* Ast/alphatize.scm 265 */
								 node_bglt aux_3423;
								 {	/* Ast/alphatize.scm 265 */
								    obj_t aux_3424;
								    aux_3424 =
								       CDR(clause_1407);
								    aux_3423 =
								       (node_bglt) (aux_3424);
								 }
								 arg1924_1409 =
								    do_alphatize_126_ast_alphatize(aux_3423);
							      }
							      {		/* ./Ieee/pair-list.scm 5689 */
								 obj_t aux_3428;
								 aux_3428 =
								    (obj_t) (arg1924_1409);
								 arg1921_1405 =
								    MAKE_PAIR(arg1923_1408, aux_3428);
							      }
							   }
							}
							newtail1513_1403 =
							   MAKE_PAIR(arg1921_1405, BNIL);
						     }
						     SET_CDR(tail1512_1400, newtail1513_1403);
						     {
							obj_t tail1512_3435;
							obj_t l1509_3433;
							l1509_3433 =
							   CDR(l1509_1399);
							tail1512_3435 = newtail1513_1403;
							tail1512_1400 = tail1512_3435;
							l1509_1399 = l1509_3433;
							goto lname1510_1401;
						     }
						  }
					     }
					  }
				     }
				     arg1916_1394 =
					(((select_bglt) CREF(node_1385))->item_type_130);
				     {	/* Ast/alphatize.scm 260 */
					select_bglt res2078_2373;
					{	/* ./Ast/node.scm 963 */
					   select_bglt new1343_2362;
					   new1343_2362 =
					      ((select_bglt) BREF(GC_MALLOC(sizeof(struct select))));
					   {	/* ./Ast/node.scm 963 */
					      long arg1639_2363;
					      arg1639_2363 =
						 class_num_218___object(select_ast_node);
					      {		/* ./Ast/node.scm 963 */
						 obj_t obj_2371;
						 obj_2371 =
						    (obj_t) (new1343_2362);
						 (((obj_t) CREF(obj_2371))->header = MAKE_HEADER(arg1639_2363, 0), BUNSPEC);
					      }
					   }
					   {	/* ./Ast/node.scm 963 */
					      object_bglt aux_3441;
					      aux_3441 =
						 (object_bglt) (new1343_2362);
					      OBJECT_WIDENING_SET(aux_3441, BFALSE);
					   }
					   ((((select_bglt) CREF(new1343_2362))->loc) = ((obj_t) arg1909_1388), BUNSPEC);
					   ((((select_bglt) CREF(new1343_2362))->type) = ((type_bglt) arg1910_1389), BUNSPEC);
					   ((((select_bglt) CREF(new1343_2362))->side_effect__165) = ((obj_t) arg1912_1390), BUNSPEC);
					   ((((select_bglt) CREF(new1343_2362))->key) = ((obj_t) arg1913_1391), BUNSPEC);
					   ((((select_bglt) CREF(new1343_2362))->test) = ((node_bglt) arg1914_1392), BUNSPEC);
					   ((((select_bglt) CREF(new1343_2362))->clauses) = ((obj_t) arg1915_1393), BUNSPEC);
					   ((((select_bglt) CREF(new1343_2362))->item_type_130) = ((type_bglt) arg1916_1394), BUNSPEC);
					   res2078_2373 = new1343_2362;
					}
					new1508_1387 = res2078_2373;
				     }
				  }
				  {	/* Ast/alphatize.scm 260 */

				     aux_2788 =
					(obj_t) (new1508_1387);
				  }
			       }
			    }
			    break;
			 case ((long) 14):

			    {	/* Ast/alphatize.scm 272 */
			       make_box_202_bglt node_1411;
			       node_1411 =
				  (make_box_202_bglt) (node_20);
			       {	/* Ast/alphatize.scm 273 */
				  make_box_202_bglt new1515_1413;
				  {	/* Ast/alphatize.scm 273 */
				     obj_t arg1926_1414;
				     type_bglt arg1927_1415;
				     obj_t arg1928_1416;
				     obj_t arg1929_1417;
				     node_bglt arg1930_1418;
				     arg1926_1414 =
					get_location_95_ast_alphatize(
					(obj_t) (node_1411));
				     arg1927_1415 =
					(((make_box_202_bglt) CREF(node_1411))->type);
				     arg1928_1416 =
					(((make_box_202_bglt) CREF(node_1411))->side_effect__165);
				     arg1929_1417 =
					(((make_box_202_bglt) CREF(node_1411))->key);
				     arg1930_1418 =
					do_alphatize_126_ast_alphatize(
					(((make_box_202_bglt) CREF(node_1411))->value));
				     {	/* Ast/alphatize.scm 272 */
					make_box_202_bglt res2079_2392;
					{	/* ./Ast/node.scm 1002 */
					   make_box_202_bglt new1407_2383;
					   new1407_2383 =
					      ((make_box_202_bglt) BREF(GC_MALLOC(sizeof(struct make_box_202))));
					   {	/* ./Ast/node.scm 1002 */
					      long arg1629_2384;
					      arg1629_2384 =
						 class_num_218___object(make_box_202_ast_node);
					      {		/* ./Ast/node.scm 1002 */
						 obj_t obj_2390;
						 obj_2390 =
						    (obj_t) (new1407_2383);
						 (((obj_t) CREF(obj_2390))->header = MAKE_HEADER(arg1629_2384, 0), BUNSPEC);
					      }
					   }
					   {	/* ./Ast/node.scm 1002 */
					      object_bglt aux_3464;
					      aux_3464 =
						 (object_bglt) (new1407_2383);
					      OBJECT_WIDENING_SET(aux_3464, BFALSE);
					   }
					   ((((make_box_202_bglt) CREF(new1407_2383))->loc) = ((obj_t) arg1926_1414), BUNSPEC);
					   ((((make_box_202_bglt) CREF(new1407_2383))->type) = ((type_bglt) arg1927_1415), BUNSPEC);
					   ((((make_box_202_bglt) CREF(new1407_2383))->side_effect__165) = ((obj_t) arg1928_1416), BUNSPEC);
					   ((((make_box_202_bglt) CREF(new1407_2383))->key) = ((obj_t) arg1929_1417), BUNSPEC);
					   ((((make_box_202_bglt) CREF(new1407_2383))->value) = ((node_bglt) arg1930_1418), BUNSPEC);
					   res2079_2392 = new1407_2383;
					}
					new1515_1413 = res2079_2392;
				     }
				  }
				  {	/* Ast/alphatize.scm 272 */

				     aux_2788 =
					(obj_t) (new1515_1413);
				  }
			       }
			    }
			    break;
			 case ((long) 15):

			    {	/* Ast/alphatize.scm 280 */
			       box_ref_242_bglt node_1420;
			       node_1420 =
				  (box_ref_242_bglt) (node_20);
			       {	/* Ast/alphatize.scm 281 */
				  box_ref_242_bglt new1517_1422;
				  {	/* Ast/alphatize.scm 281 */
				     obj_t arg1932_1423;
				     type_bglt arg1933_1424;
				     obj_t arg1934_1425;
				     obj_t arg1935_1426;
				     node_bglt arg1936_1427;
				     arg1932_1423 =
					get_location_95_ast_alphatize(
					(obj_t) (node_1420));
				     arg1933_1424 =
					(((box_ref_242_bglt) CREF(node_1420))->type);
				     arg1934_1425 =
					(((box_ref_242_bglt) CREF(node_1420))->side_effect__165);
				     arg1935_1426 =
					(((box_ref_242_bglt) CREF(node_1420))->key);
				     {	/* Ast/alphatize.scm 282 */
					node_bglt aux_3479;
					{	/* Ast/alphatize.scm 282 */
					   var_bglt aux_3480;
					   aux_3480 =
					      (((box_ref_242_bglt) CREF(node_1420))->var);
					   aux_3479 =
					      (node_bglt) (aux_3480);
					}
					arg1936_1427 =
					   do_alphatize_126_ast_alphatize(aux_3479);
				     }
				     {	/* Ast/alphatize.scm 280 */
					box_ref_242_bglt res2080_2411;
					{	/* Ast/alphatize.scm 280 */
					   var_bglt var_2401;
					   var_2401 =
					      (var_bglt) (arg1936_1427);
					   {	/* ./Ast/node.scm 1006 */
					      box_ref_242_bglt new1419_2402;
					      new1419_2402 =
						 ((box_ref_242_bglt) BREF(GC_MALLOC(sizeof(struct box_ref_242))));
					      {		/* ./Ast/node.scm 1006 */
						 long arg1627_2403;
						 arg1627_2403 =
						    class_num_218___object(box_ref_242_ast_node);
						 {	/* ./Ast/node.scm 1006 */
						    obj_t obj_2409;
						    obj_2409 =
						       (obj_t) (new1419_2402);
						    (((obj_t) CREF(obj_2409))->header = MAKE_HEADER(arg1627_2403, 0), BUNSPEC);
						 }
					      }
					      {		/* ./Ast/node.scm 1006 */
						 object_bglt aux_3489;
						 aux_3489 =
						    (object_bglt) (new1419_2402);
						 OBJECT_WIDENING_SET(aux_3489, BFALSE);
					      }
					      ((((box_ref_242_bglt) CREF(new1419_2402))->loc) = ((obj_t) arg1932_1423), BUNSPEC);
					      ((((box_ref_242_bglt) CREF(new1419_2402))->type) = ((type_bglt) arg1933_1424), BUNSPEC);
					      ((((box_ref_242_bglt) CREF(new1419_2402))->side_effect__165) = ((obj_t) arg1934_1425), BUNSPEC);
					      ((((box_ref_242_bglt) CREF(new1419_2402))->key) = ((obj_t) arg1935_1426), BUNSPEC);
					      ((((box_ref_242_bglt) CREF(new1419_2402))->var) = ((var_bglt) var_2401), BUNSPEC);
					      res2080_2411 = new1419_2402;
					   }
					}
					new1517_1422 = res2080_2411;
				     }
				  }
				  {	/* Ast/alphatize.scm 280 */

				     aux_2788 =
					(obj_t) (new1517_1422);
				  }
			       }
			    }
			    break;
			 case ((long) 16):

			    {	/* Ast/alphatize.scm 288 */
			       box_set__221_bglt node_1429;
			       node_1429 =
				  (box_set__221_bglt) (node_20);
			       {	/* Ast/alphatize.scm 289 */
				  box_set__221_bglt new1519_1431;
				  {	/* Ast/alphatize.scm 289 */
				     obj_t arg1938_1432;
				     type_bglt arg1939_1433;
				     node_bglt arg1940_1434;
				     node_bglt arg1941_1435;
				     arg1938_1432 =
					get_location_95_ast_alphatize(
					(obj_t) (node_1429));
				     arg1939_1433 =
					(((box_set__221_bglt) CREF(node_1429))->type);
				     {	/* Ast/alphatize.scm 290 */
					node_bglt aux_3502;
					{	/* Ast/alphatize.scm 290 */
					   var_bglt aux_3503;
					   aux_3503 =
					      (((box_set__221_bglt) CREF(node_1429))->var);
					   aux_3502 =
					      (node_bglt) (aux_3503);
					}
					arg1940_1434 =
					   do_alphatize_126_ast_alphatize(aux_3502);
				     }
				     arg1941_1435 =
					do_alphatize_126_ast_alphatize(
					(((box_set__221_bglt) CREF(node_1429))->value));
				     {	/* Ast/alphatize.scm 288 */
					box_set__221_bglt res2081_2427;
					{	/* Ast/alphatize.scm 288 */
					   var_bglt var_2417;
					   var_2417 =
					      (var_bglt) (arg1940_1434);
					   {	/* ./Ast/node.scm 1010 */
					      box_set__221_bglt new1430_2419;
					      new1430_2419 =
						 ((box_set__221_bglt) BREF(GC_MALLOC(sizeof(struct box_set__221))));
					      {		/* ./Ast/node.scm 1010 */
						 long arg1625_2420;
						 arg1625_2420 =
						    class_num_218___object(box_set__221_ast_node);
						 {	/* ./Ast/node.scm 1010 */
						    obj_t obj_2425;
						    obj_2425 =
						       (obj_t) (new1430_2419);
						    (((obj_t) CREF(obj_2425))->header = MAKE_HEADER(arg1625_2420, 0), BUNSPEC);
						 }
					      }
					      {		/* ./Ast/node.scm 1010 */
						 object_bglt aux_3514;
						 aux_3514 =
						    (object_bglt) (new1430_2419);
						 OBJECT_WIDENING_SET(aux_3514, BFALSE);
					      }
					      ((((box_set__221_bglt) CREF(new1430_2419))->loc) = ((obj_t) arg1938_1432), BUNSPEC);
					      ((((box_set__221_bglt) CREF(new1430_2419))->type) = ((type_bglt) arg1939_1433), BUNSPEC);
					      ((((box_set__221_bglt) CREF(new1430_2419))->var) = ((var_bglt) var_2417), BUNSPEC);
					      ((((box_set__221_bglt) CREF(new1430_2419))->value) = ((node_bglt) arg1941_1435), BUNSPEC);
					      res2081_2427 = new1430_2419;
					   }
					}
					new1519_1431 = res2081_2427;
				     }
				  }
				  {	/* Ast/alphatize.scm 288 */

				     aux_2788 =
					(obj_t) (new1519_1431);
				  }
			       }
			    }
			    break;
			 case ((long) 17):

			    {	/* Ast/alphatize.scm 297 */
			       let_fun_218_bglt node_1438;
			       node_1438 =
				  (let_fun_218_bglt) (node_20);
			       {	/* Ast/alphatize.scm 297 */
				  obj_t old_locals_255_1439;
				  old_locals_255_1439 =
				     (((let_fun_218_bglt) CREF(node_1438))->locals);
				  {	/* Ast/alphatize.scm 297 */
				     obj_t new_locals_179_1440;
				     if (
					NULLP(old_locals_255_1439))
				       {	/* Ast/alphatize.scm 298 */
					  new_locals_179_1440 = BNIL;
				       }
				     else
				       {	/* Ast/alphatize.scm 298 */
					  obj_t head1522_1499;
					  head1522_1499 =
					     MAKE_PAIR(BNIL, BNIL);
					  {
					     obj_t l1520_1500;
					     obj_t tail1523_1501;
					     l1520_1500 = old_locals_255_1439;
					     tail1523_1501 = head1522_1499;
					   lname1521_1502:
					     if (
						NULLP(l1520_1500))
					       {	/* Ast/alphatize.scm 298 */
						  new_locals_179_1440 =
						     CDR(head1522_1499);
					       }
					     else
					       {	/* Ast/alphatize.scm 299 */
						  obj_t newtail1524_1504;
						  {	/* Ast/alphatize.scm 299 */
						     local_bglt arg1984_1506;
						     {	/* Ast/alphatize.scm 299 */
							obj_t l_1508;
							l_1508 =
							   CAR(l1520_1500);
							{	/* Ast/alphatize.scm 299 */
							   sfun_bglt aux_3537;
							   type_bglt aux_3534;
							   obj_t aux_3531;
							   {	/* Ast/alphatize.scm 299 */
							      value_bglt aux_3538;
							      {		/* Ast/alphatize.scm 301 */
								 local_bglt obj_2437;
								 obj_2437 =
								    (local_bglt) (l_1508);
								 aux_3538 =
								    (((local_bglt) CREF(obj_2437))->value);
							      }
							      aux_3537 =
								 (sfun_bglt) (aux_3538);
							   }
							   {	/* Ast/alphatize.scm 300 */
							      local_bglt obj_2436;
							      obj_2436 =
								 (local_bglt) (l_1508);
							      aux_3534 =
								 (((local_bglt) CREF(obj_2436))->type);
							   }
							   {	/* Ast/alphatize.scm 299 */
							      local_bglt obj_2435;
							      obj_2435 =
								 (local_bglt) (l_1508);
							      aux_3531 =
								 (((local_bglt) CREF(obj_2435))->id);
							   }
							   arg1984_1506 =
							      make_local_sfun_184_ast_local(aux_3531, aux_3534, aux_3537);
							}
						     }
						     {	/* ./Ieee/pair-list.scm 5689 */
							obj_t aux_3543;
							aux_3543 =
							   (obj_t) (arg1984_1506);
							newtail1524_1504 =
							   MAKE_PAIR(aux_3543, BNIL);
						     }
						  }
						  SET_CDR(tail1523_1501, newtail1524_1504);
						  {
						     obj_t tail1523_3549;
						     obj_t l1520_3547;
						     l1520_3547 =
							CDR(l1520_1500);
						     tail1523_3549 = newtail1524_1504;
						     tail1523_1501 = tail1523_3549;
						     l1520_1500 = l1520_3547;
						     goto lname1521_1502;
						  }
					       }
					  }
				       }
				     {	/* Ast/alphatize.scm 298 */

					{
					   obj_t ll1525_1441;
					   obj_t ll1526_1442;
					   ll1525_1441 = old_locals_255_1439;
					   ll1526_1442 = new_locals_179_1440;
					 lname1527_1443:
					   if (
					      NULLP(ll1525_1441))
					     {	/* Ast/alphatize.scm 303 */
						((bool_t) 1);
					     }
					   else
					     {	/* Ast/alphatize.scm 303 */
						{	/* Ast/alphatize.scm 304 */
						   obj_t old_1445;
						   obj_t new_1446;
						   old_1445 =
						      CAR(ll1525_1441);
						   new_1446 =
						      CAR(ll1526_1442);
						   {	/* Ast/alphatize.scm 304 */
						      value_bglt old_sfun_249_1447;
						      {		/* Ast/alphatize.scm 304 */
							 local_bglt obj_2446;
							 obj_2446 =
							    (local_bglt) (old_1445);
							 old_sfun_249_1447 =
							    (((local_bglt) CREF(obj_2446))->value);
						      }
						      {		/* Ast/alphatize.scm 304 */
							 obj_t old_args_130_1448;
							 {	/* Ast/alphatize.scm 305 */
							    sfun_bglt obj_2447;
							    obj_2447 =
							       (sfun_bglt) (old_sfun_249_1447);
							    old_args_130_1448 =
							       (((sfun_bglt) CREF(obj_2447))->args);
							 }
							 {	/* Ast/alphatize.scm 305 */
							    obj_t new_args_235_1449;
							    if (
							       NULLP(old_args_130_1448))
							      {		/* Ast/alphatize.scm 306 */
								 new_args_235_1449 = BNIL;
							      }
							    else
							      {		/* Ast/alphatize.scm 306 */
								 obj_t head1530_1473;
								 head1530_1473 =
								    MAKE_PAIR(BNIL, BNIL);
								 {
								    obj_t l1528_1474;
								    obj_t tail1531_1475;
								    l1528_1474 = old_args_130_1448;
								    tail1531_1475 = head1530_1473;
								  lname1529_1476:
								    if (
								       NULLP(l1528_1474))
								      {		/* Ast/alphatize.scm 306 */
									 new_args_235_1449 =
									    CDR(head1530_1473);
								      }
								    else
								      {		/* Ast/alphatize.scm 307 */
									 obj_t newtail1532_1478;
									 {	/* Ast/alphatize.scm 307 */
									    local_bglt arg1965_1480;
									    {	/* Ast/alphatize.scm 307 */
									       obj_t l_1482;
									       l_1482 =
										  CAR(l1528_1474);
									       {	/* Ast/alphatize.scm 307 */
										  type_bglt aux_3568;
										  obj_t aux_3565;
										  {	/* Ast/alphatize.scm 308 */
										     local_bglt obj_2455;
										     obj_2455 =
											(local_bglt) (l_1482);
										     aux_3568 =
											(((local_bglt) CREF(obj_2455))->type);
										  }
										  {	/* Ast/alphatize.scm 307 */
										     local_bglt obj_2454;
										     obj_2454 =
											(local_bglt) (l_1482);
										     aux_3565 =
											(((local_bglt) CREF(obj_2454))->id);
										  }
										  arg1965_1480 =
										     make_local_svar_140_ast_local(aux_3565, aux_3568);
									       }
									    }
									    {	/* ./Ieee/pair-list.scm 5689 */
									       obj_t aux_3572;
									       aux_3572 =
										  (obj_t) (arg1965_1480);
									       newtail1532_1478 =
										  MAKE_PAIR(aux_3572, BNIL);
									    }
									 }
									 SET_CDR(tail1531_1475, newtail1532_1478);
									 {
									    obj_t tail1531_3578;
									    obj_t l1528_3576;
									    l1528_3576 =
									       CDR(l1528_1474);
									    tail1531_3578 = newtail1532_1478;
									    tail1531_1475 = tail1531_3578;
									    l1528_1474 = l1528_3576;
									    goto lname1529_1476;
									 }
								      }
								 }
							      }
							    {	/* Ast/alphatize.scm 310 */
							       node_bglt new_body_215_1451;
							       {	/* Ast/alphatize.scm 311 */
								  node_bglt aux_3579;
								  {	/* Ast/alphatize.scm 311 */
								     obj_t aux_3584;
								     {	/* Ast/alphatize.scm 310 */
									sfun_bglt obj_2461;
									obj_2461 =
									   (sfun_bglt) (old_sfun_249_1447);
									aux_3584 =
									   (((sfun_bglt) CREF(obj_2461))->body);
								     }
								     aux_3579 =
									(node_bglt) (aux_3584);
								  }
								  new_body_215_1451 =
								     alphatize_ast_alphatize(
								     append_2_18___r4_pairs_and_lists_6_3(old_locals_255_1439, old_args_130_1448),
								     append_2_18___r4_pairs_and_lists_6_3(new_locals_179_1440, new_args_235_1449),
								     get_location_95_ast_alphatize(
									(obj_t) (node_1438)), aux_3579);
							       }
							       {	/* Ast/alphatize.scm 311 */
								  sfun_bglt new_sfun_134_1452;
								  {	/* Ast/alphatize.scm 315 */
								     sfun_bglt duplicated1533_1454;
								     duplicated1533_1454 =
									(sfun_bglt) (old_sfun_249_1447);
								     {	/* Ast/alphatize.scm 315 */
									sfun_bglt new1534_1455;
									{	/* Ast/alphatize.scm 315 */
									   long arg1946_1456;
									   obj_t arg1948_1457;
									   obj_t arg1949_1458;
									   obj_t arg1950_1459;
									   bool_t arg1951_1460;
									   obj_t arg1952_1461;
									   obj_t arg1953_1462;
									   obj_t arg1956_1465;
									   obj_t arg1957_1466;
									   obj_t arg1958_1467;
									   arg1946_1456 =
									      (((sfun_bglt) CREF(duplicated1533_1454))->arity);
									   arg1948_1457 =
									      (((sfun_bglt) CREF(duplicated1533_1454))->side_effect__165);
									   arg1949_1458 =
									      (((sfun_bglt) CREF(duplicated1533_1454))->predicate_of_78);
									   arg1950_1459 =
									      (((sfun_bglt) CREF(duplicated1533_1454))->stack_allocator_172);
									   arg1951_1460 =
									      (((sfun_bglt) CREF(duplicated1533_1454))->top__138);
									   arg1952_1461 =
									      (((sfun_bglt) CREF(duplicated1533_1454))->the_closure_238);
									   arg1953_1462 =
									      (((sfun_bglt) CREF(duplicated1533_1454))->property);
									   arg1956_1465 =
									      (((sfun_bglt) CREF(duplicated1533_1454))->class);
									   arg1957_1466 =
									      (((sfun_bglt) CREF(duplicated1533_1454))->dsssl_keywords_243);
									   arg1958_1467 =
									      (((sfun_bglt) CREF(duplicated1533_1454))->loc);
									   {	/* Ast/alphatize.scm 315 */
									      sfun_bglt res2082_2500;
									      {		/* Ast/alphatize.scm 315 */
										 obj_t body_2480;
										 body_2480 =
										    (obj_t) (new_body_215_1451);
										 {	/* ./Ast/var.scm 792 */
										    sfun_bglt new1127_2484;
										    new1127_2484 =
										       ((sfun_bglt) BREF(GC_MALLOC(sizeof(struct sfun))));
										    {	/* ./Ast/var.scm 792 */
										       long arg1683_2485;
										       arg1683_2485 =
											  class_num_218___object(sfun_ast_var);
										       {	/* ./Ast/var.scm 792 */
											  obj_t obj_2498;
											  obj_2498 =
											     (obj_t) (new1127_2484);
											  (((obj_t) CREF(obj_2498))->header = MAKE_HEADER(arg1683_2485, 0), BUNSPEC);
										       }
										    }
										    {	/* ./Ast/var.scm 792 */
										       object_bglt aux_3605;
										       aux_3605 =
											  (object_bglt) (new1127_2484);
										       OBJECT_WIDENING_SET(aux_3605, BFALSE);
										    }
										    ((((sfun_bglt) CREF(new1127_2484))->arity) = ((long) arg1946_1456), BUNSPEC);
										    ((((sfun_bglt) CREF(new1127_2484))->side_effect__165) = ((obj_t) arg1948_1457), BUNSPEC);
										    ((((sfun_bglt) CREF(new1127_2484))->predicate_of_78) = ((obj_t) arg1949_1458), BUNSPEC);
										    ((((sfun_bglt) CREF(new1127_2484))->stack_allocator_172) = ((obj_t) arg1950_1459), BUNSPEC);
										    ((((sfun_bglt) CREF(new1127_2484))->top__138) = ((bool_t) arg1951_1460), BUNSPEC);
										    ((((sfun_bglt) CREF(new1127_2484))->the_closure_238) = ((obj_t) arg1952_1461), BUNSPEC);
										    ((((sfun_bglt) CREF(new1127_2484))->property) = ((obj_t) arg1953_1462), BUNSPEC);
										    ((((sfun_bglt) CREF(new1127_2484))->args) = ((obj_t) new_args_235_1449), BUNSPEC);
										    ((((sfun_bglt) CREF(new1127_2484))->body) = ((obj_t) body_2480), BUNSPEC);
										    ((((sfun_bglt) CREF(new1127_2484))->class) = ((obj_t) arg1956_1465), BUNSPEC);
										    ((((sfun_bglt) CREF(new1127_2484))->dsssl_keywords_243) = ((obj_t) arg1957_1466), BUNSPEC);
										    ((((sfun_bglt) CREF(new1127_2484))->loc) = ((obj_t) arg1958_1467), BUNSPEC);
										    res2082_2500 = new1127_2484;
										 }
									      }
									      new1534_1455 = res2082_2500;
									   }
									}
									{	/* Ast/alphatize.scm 315 */

									   new_sfun_134_1452 = new1534_1455;
									}
								     }
								  }
								  {	/* Ast/alphatize.scm 315 */

								     {	/* Ast/alphatize.scm 318 */
									bool_t arg1945_1453;
									{	/* Ast/alphatize.scm 318 */
									   local_bglt obj_2501;
									   obj_2501 =
									      (local_bglt) (old_1445);
									   arg1945_1453 =
									      (((local_bglt) CREF(obj_2501))->user__32);
									}
									{	/* Ast/alphatize.scm 318 */
									   local_bglt obj_2502;
									   obj_2502 =
									      (local_bglt) (new_1446);
									   ((((local_bglt) CREF(obj_2502))->user__32) = ((bool_t) arg1945_1453), BUNSPEC);
									}
								     }
								     {	/* Ast/alphatize.scm 319 */
									local_bglt obj_2504;
									value_bglt val1083_2505;
									obj_2504 =
									   (local_bglt) (new_1446);
									val1083_2505 =
									   (value_bglt) (new_sfun_134_1452);
									((((local_bglt) CREF(obj_2504))->value) = ((value_bglt) val1083_2505), BUNSPEC);
								     }
								  }
							       }
							    }
							 }
						      }
						   }
						}
						{
						   obj_t ll1526_3629;
						   obj_t ll1525_3627;
						   ll1525_3627 =
						      CDR(ll1525_1441);
						   ll1526_3629 =
						      CDR(ll1526_1442);
						   ll1526_1442 = ll1526_3629;
						   ll1525_1441 = ll1525_3627;
						   goto lname1527_1443;
						}
					     }
					}
					{	/* Ast/alphatize.scm 323 */
					   let_fun_218_bglt new1536_1488;
					   {	/* Ast/alphatize.scm 323 */
					      obj_t arg1971_1489;
					      type_bglt arg1972_1490;
					      obj_t arg1973_1491;
					      obj_t arg1974_1492;
					      node_bglt arg1977_1494;
					      arg1971_1489 =
						 get_location_95_ast_alphatize(
						 (obj_t) (node_1438));
					      arg1972_1490 =
						 (((let_fun_218_bglt) CREF(node_1438))->type);
					      arg1973_1491 =
						 (((let_fun_218_bglt) CREF(node_1438))->side_effect__165);
					      arg1974_1492 =
						 (((let_fun_218_bglt) CREF(node_1438))->key);
					      arg1977_1494 =
						 alphatize_ast_alphatize(old_locals_255_1439, new_locals_179_1440,
						 get_location_95_ast_alphatize(
						    (obj_t) (node_1438)),
						 (((let_fun_218_bglt) CREF(node_1438))->body));
					      {		/* Ast/alphatize.scm 322 */
						 let_fun_218_bglt res2083_2528;
						 {	/* ./Ast/node.scm 972 */
						    let_fun_218_bglt new1358_2518;
						    new1358_2518 =
						       ((let_fun_218_bglt) BREF(GC_MALLOC(sizeof(struct let_fun_218))));
						    {	/* ./Ast/node.scm 972 */
						       long arg1637_2519;
						       arg1637_2519 =
							  class_num_218___object(let_fun_218_ast_node);
						       {	/* ./Ast/node.scm 972 */
							  obj_t obj_2526;
							  obj_2526 =
							     (obj_t) (new1358_2518);
							  (((obj_t) CREF(obj_2526))->header = MAKE_HEADER(arg1637_2519, 0), BUNSPEC);
						       }
						    }
						    {	/* ./Ast/node.scm 972 */
						       object_bglt aux_3644;
						       aux_3644 =
							  (object_bglt) (new1358_2518);
						       OBJECT_WIDENING_SET(aux_3644, BFALSE);
						    }
						    ((((let_fun_218_bglt) CREF(new1358_2518))->loc) = ((obj_t) arg1971_1489), BUNSPEC);
						    ((((let_fun_218_bglt) CREF(new1358_2518))->type) = ((type_bglt) arg1972_1490), BUNSPEC);
						    ((((let_fun_218_bglt) CREF(new1358_2518))->side_effect__165) = ((obj_t) arg1973_1491), BUNSPEC);
						    ((((let_fun_218_bglt) CREF(new1358_2518))->key) = ((obj_t) arg1974_1492), BUNSPEC);
						    ((((let_fun_218_bglt) CREF(new1358_2518))->locals) = ((obj_t) new_locals_179_1440), BUNSPEC);
						    ((((let_fun_218_bglt) CREF(new1358_2518))->body) = ((node_bglt) arg1977_1494), BUNSPEC);
						    res2083_2528 = new1358_2518;
						 }
						 new1536_1488 = res2083_2528;
					      }
					   }
					   {	/* Ast/alphatize.scm 322 */

					      aux_2788 =
						 (obj_t) (new1536_1488);
					   }
					}
				     }
				  }
			       }
			    }
			    break;
			 case ((long) 18):

			    {	/* Ast/alphatize.scm 334 */
			       let_var_6_bglt node_1512;
			       node_1512 =
				  (let_var_6_bglt) (node_20);
			       {	/* Ast/alphatize.scm 334 */
				  obj_t old_locals_255_1513;
				  {	/* Ast/alphatize.scm 334 */
				     obj_t l1537_1561;
				     l1537_1561 =
					(((let_var_6_bglt) CREF(node_1512))->bindings);
				     if (
					NULLP(l1537_1561))
				       {	/* Ast/alphatize.scm 334 */
					  old_locals_255_1513 = BNIL;
				       }
				     else
				       {	/* Ast/alphatize.scm 334 */
					  obj_t head1539_1563;
					  {	/* ./Ieee/pair-list.scm 5689 */
					     obj_t aux_3658;
					     {	/* ./Ieee/pair-list.scm 5701 */
						obj_t aux_3659;
						aux_3659 =
						   CAR(l1537_1561);
						aux_3658 =
						   CAR(aux_3659);
					     }
					     head1539_1563 =
						MAKE_PAIR(aux_3658, BNIL);
					  }
					  {
					     obj_t l1537_1564;
					     obj_t tail1540_1565;
					     l1537_1564 =
						CDR(l1537_1561);
					     tail1540_1565 = head1539_1563;
					   lname1538_1566:
					     if (
						NULLP(l1537_1564))
					       {	/* Ast/alphatize.scm 334 */
						  old_locals_255_1513 = head1539_1563;
					       }
					     else
					       {	/* Ast/alphatize.scm 334 */
						  obj_t newtail1541_1569;
						  {	/* ./Ieee/pair-list.scm 5689 */
						     obj_t aux_3665;
						     {	/* ./Ieee/pair-list.scm 5701 */
							obj_t aux_3666;
							aux_3666 =
							   CAR(l1537_1564);
							aux_3665 =
							   CAR(aux_3666);
						     }
						     newtail1541_1569 =
							MAKE_PAIR(aux_3665, BNIL);
						  }
						  SET_CDR(tail1540_1565, newtail1541_1569);
						  {
						     obj_t tail1540_3673;
						     obj_t l1537_3671;
						     l1537_3671 =
							CDR(l1537_1564);
						     tail1540_3673 = newtail1541_1569;
						     tail1540_1565 = tail1540_3673;
						     l1537_1564 = l1537_3671;
						     goto lname1538_1566;
						  }
					       }
					  }
				       }
				  }
				  {	/* Ast/alphatize.scm 334 */
				     obj_t new_locals_179_1514;
				     if (
					NULLP(old_locals_255_1513))
				       {	/* Ast/alphatize.scm 335 */
					  new_locals_179_1514 = BNIL;
				       }
				     else
				       {	/* Ast/alphatize.scm 335 */
					  obj_t head1544_1547;
					  head1544_1547 =
					     MAKE_PAIR(BNIL, BNIL);
					  {
					     obj_t l1542_1548;
					     obj_t tail1545_1549;
					     l1542_1548 = old_locals_255_1513;
					     tail1545_1549 = head1544_1547;
					   lname1543_1550:
					     if (
						NULLP(l1542_1548))
					       {	/* Ast/alphatize.scm 335 */
						  new_locals_179_1514 =
						     CDR(head1544_1547);
					       }
					     else
					       {	/* Ast/alphatize.scm 340 */
						  obj_t newtail1546_1552;
						  {	/* Ast/alphatize.scm 340 */
						     local_bglt arg2009_1554;
						     {	/* Ast/alphatize.scm 340 */
							obj_t l_1556;
							l_1556 =
							   CAR(l1542_1548);
							{	/* Ast/alphatize.scm 340 */
							   local_bglt var_1557;
							   {	/* Ast/alphatize.scm 340 */
							      type_bglt aux_3685;
							      obj_t aux_3682;
							      {		/* Ast/alphatize.scm 341 */
								 local_bglt obj_2551;
								 obj_2551 =
								    (local_bglt) (l_1556);
								 aux_3685 =
								    (((local_bglt) CREF(obj_2551))->type);
							      }
							      {		/* Ast/alphatize.scm 340 */
								 local_bglt obj_2550;
								 obj_2550 =
								    (local_bglt) (l_1556);
								 aux_3682 =
								    (((local_bglt) CREF(obj_2550))->id);
							      }
							      var_1557 =
								 make_local_svar_140_ast_local(aux_3682, aux_3685);
							   }
							   {	/* Ast/alphatize.scm 342 */
							      bool_t arg2011_1558;
							      {		/* Ast/alphatize.scm 342 */
								 local_bglt obj_2552;
								 obj_2552 =
								    (local_bglt) (l_1556);
								 arg2011_1558 =
								    (((local_bglt) CREF(obj_2552))->user__32);
							      }
							      ((((local_bglt) CREF(var_1557))->user__32) = ((bool_t) arg2011_1558), BUNSPEC);
							   }
							   arg2009_1554 = var_1557;
							}
						     }
						     {	/* ./Ieee/pair-list.scm 5689 */
							obj_t aux_3692;
							aux_3692 =
							   (obj_t) (arg2009_1554);
							newtail1546_1552 =
							   MAKE_PAIR(aux_3692, BNIL);
						     }
						  }
						  SET_CDR(tail1545_1549, newtail1546_1552);
						  {
						     obj_t tail1545_3698;
						     obj_t l1542_3696;
						     l1542_3696 =
							CDR(l1542_1548);
						     tail1545_3698 = newtail1546_1552;
						     tail1545_1549 = tail1545_3698;
						     l1542_1548 = l1542_3696;
						     goto lname1543_1550;
						  }
					       }
					  }
				       }
				     {	/* Ast/alphatize.scm 335 */
					obj_t new_bindings_102_1515;
					{	/* Ast/alphatize.scm 345 */
					   obj_t ll1547_1527;
					   ll1547_1527 =
					      (((let_var_6_bglt) CREF(node_1512))->bindings);
					   if (
					      NULLP(ll1547_1527))
					     {	/* Ast/alphatize.scm 345 */
						new_bindings_102_1515 = BNIL;
					     }
					   else
					     {	/* Ast/alphatize.scm 345 */
						obj_t head1549_1530;
						head1549_1530 =
						   MAKE_PAIR(BNIL, BNIL);
						{
						   obj_t ll1547_1531;
						   obj_t ll1548_1532;
						   obj_t tail1550_1533;
						   ll1547_1531 = ll1547_1527;
						   ll1548_1532 = new_locals_179_1514;
						   tail1550_1533 = head1549_1530;
						 lname1552_1534:
						   if (
						      NULLP(ll1547_1531))
						     {	/* Ast/alphatize.scm 345 */
							new_bindings_102_1515 =
							   CDR(head1549_1530);
						     }
						   else
						     {	/* Ast/alphatize.scm 346 */
							obj_t newtail1551_1536;
							{	/* Ast/alphatize.scm 346 */
							   obj_t arg2002_1539;
							   {	/* Ast/alphatize.scm 346 */
							      obj_t new_local_166_1542;
							      new_local_166_1542 =
								 CAR(ll1548_1532);
							      {		/* Ast/alphatize.scm 346 */
								 node_bglt arg2004_1543;
								 {	/* Ast/alphatize.scm 346 */
								    node_bglt aux_3707;
								    {	/* Ast/alphatize.scm 346 */
								       obj_t aux_3708;
								       {	/* ./Ieee/pair-list.scm 5707 */
									  obj_t aux_3709;
									  aux_3709 =
									     CAR(ll1547_1531);
									  aux_3708 =
									     CDR(aux_3709);
								       }
								       aux_3707 =
									  (node_bglt) (aux_3708);
								    }
								    arg2004_1543 =
								       do_alphatize_126_ast_alphatize(aux_3707);
								 }
								 {	/* ./Ieee/pair-list.scm 5689 */
								    obj_t aux_3714;
								    aux_3714 =
								       (obj_t) (arg2004_1543);
								    arg2002_1539 =
								       MAKE_PAIR(new_local_166_1542, aux_3714);
								 }
							      }
							   }
							   newtail1551_1536 =
							      MAKE_PAIR(arg2002_1539, BNIL);
							}
							SET_CDR(tail1550_1533, newtail1551_1536);
							{
							   obj_t tail1550_3723;
							   obj_t ll1548_3721;
							   obj_t ll1547_3719;
							   ll1547_3719 =
							      CDR(ll1547_1531);
							   ll1548_3721 =
							      CDR(ll1548_1532);
							   tail1550_3723 = newtail1551_1536;
							   tail1550_1533 = tail1550_3723;
							   ll1548_1532 = ll1548_3721;
							   ll1547_1531 = ll1547_3719;
							   goto lname1552_1534;
							}
						     }
						}
					     }
					}
					{	/* Ast/alphatize.scm 345 */

					   {	/* Ast/alphatize.scm 350 */
					      let_var_6_bglt new1554_1517;
					      {		/* Ast/alphatize.scm 350 */
						 obj_t arg1989_1518;
						 type_bglt arg1990_1519;
						 obj_t arg1991_1520;
						 obj_t arg1992_1521;
						 node_bglt arg1994_1523;
						 bool_t arg1995_1524;
						 arg1989_1518 =
						    get_location_95_ast_alphatize(
						    (obj_t) (node_1512));
						 arg1990_1519 =
						    (((let_var_6_bglt) CREF(node_1512))->type);
						 arg1991_1520 =
						    (((let_var_6_bglt) CREF(node_1512))->side_effect__165);
						 arg1992_1521 =
						    (((let_var_6_bglt) CREF(node_1512))->key);
						 arg1994_1523 =
						    alphatize_ast_alphatize(old_locals_255_1513, new_locals_179_1514,
						    get_location_95_ast_alphatize(
						       (obj_t) (node_1512)),
						    (((let_var_6_bglt) CREF(node_1512))->body));
						 arg1995_1524 =
						    (((let_var_6_bglt) CREF(node_1512))->removable__42);
						 {	/* Ast/alphatize.scm 349 */
						    let_var_6_bglt res2084_2600;
						    {	/* ./Ast/node.scm 979 */
						       let_var_6_bglt new1373_2589;
						       new1373_2589 =
							  ((let_var_6_bglt) BREF(GC_MALLOC(sizeof(struct let_var_6))));
						       {	/* ./Ast/node.scm 979 */
							  long arg1635_2590;
							  arg1635_2590 =
							     class_num_218___object(let_var_6_ast_node);
							  {	/* ./Ast/node.scm 979 */
							     obj_t obj_2598;
							     obj_2598 =
								(obj_t) (new1373_2589);
							     (((obj_t) CREF(obj_2598))->header = MAKE_HEADER(arg1635_2590, 0), BUNSPEC);
							  }
						       }
						       {	/* ./Ast/node.scm 979 */
							  object_bglt aux_3738;
							  aux_3738 =
							     (object_bglt) (new1373_2589);
							  OBJECT_WIDENING_SET(aux_3738, BFALSE);
						       }
						       ((((let_var_6_bglt) CREF(new1373_2589))->loc) = ((obj_t) arg1989_1518), BUNSPEC);
						       ((((let_var_6_bglt) CREF(new1373_2589))->type) = ((type_bglt) arg1990_1519), BUNSPEC);
						       ((((let_var_6_bglt) CREF(new1373_2589))->side_effect__165) = ((obj_t) arg1991_1520), BUNSPEC);
						       ((((let_var_6_bglt) CREF(new1373_2589))->key) = ((obj_t) arg1992_1521), BUNSPEC);
						       ((((let_var_6_bglt) CREF(new1373_2589))->bindings) = ((obj_t) new_bindings_102_1515), BUNSPEC);
						       ((((let_var_6_bglt) CREF(new1373_2589))->body) = ((node_bglt) arg1994_1523), BUNSPEC);
						       ((((let_var_6_bglt) CREF(new1373_2589))->removable__42) = ((bool_t) arg1995_1524), BUNSPEC);
						       res2084_2600 = new1373_2589;
						    }
						    new1554_1517 = res2084_2600;
						 }
					      }
					      {		/* Ast/alphatize.scm 349 */

						 aux_2788 =
						    (obj_t) (new1554_1517);
					      }
					   }
					}
				     }
				  }
			       }
			    }
			    break;
			 case ((long) 19):

			    {	/* Ast/alphatize.scm 361 */
			       set_ex_it_116_bglt node_1577;
			       node_1577 =
				  (set_ex_it_116_bglt) (node_20);
			       {	/* Ast/alphatize.scm 361 */
				  variable_bglt old_var_137_1578;
				  {	/* Ast/alphatize.scm 361 */
				     var_bglt arg2042_1608;
				     arg2042_1608 =
					(((set_ex_it_116_bglt) CREF(node_1577))->var);
				     old_var_137_1578 =
					(((var_bglt) CREF(arg2042_1608))->variable);
				  }
				  {	/* Ast/alphatize.scm 361 */
				     value_bglt old_exit_224_1579;
				     {	/* Ast/alphatize.scm 362 */
					local_bglt obj_2603;
					obj_2603 =
					   (local_bglt) (old_var_137_1578);
					old_exit_224_1579 =
					   (((local_bglt) CREF(obj_2603))->value);
				     }
				     {	/* Ast/alphatize.scm 363 */
					obj_t alpha_hdlg_201_1581;
					{	/* Ast/alphatize.scm 364 */
					   variable_bglt obj_2605;
					   {	/* Ast/alphatize.scm 364 */
					      obj_t aux_3754;
					      {		/* Ast/alphatize.scm 363 */
						 sexit_bglt obj_2604;
						 obj_2604 =
						    (sexit_bglt) (old_exit_224_1579);
						 aux_3754 =
						    (((sexit_bglt) CREF(obj_2604))->handler);
					      }
					      obj_2605 =
						 (variable_bglt) (aux_3754);
					   }
					   alpha_hdlg_201_1581 =
					      (((variable_bglt) CREF(obj_2605))->fast_alpha_7);
					}
					{	/* Ast/alphatize.scm 364 */
					   local_bglt new_var_21_1582;
					   {	/* Ast/alphatize.scm 365 */
					      obj_t arg2037_1601;
					      type_bglt arg2038_1602;
					      sexit_bglt arg2039_1603;
					      {		/* Ast/alphatize.scm 365 */
						 local_bglt obj_2606;
						 obj_2606 =
						    (local_bglt) (old_var_137_1578);
						 arg2037_1601 =
						    (((local_bglt) CREF(obj_2606))->id);
					      }
					      {		/* Ast/alphatize.scm 366 */
						 local_bglt obj_2607;
						 obj_2607 =
						    (local_bglt) (old_var_137_1578);
						 arg2038_1602 =
						    (((local_bglt) CREF(obj_2607))->type);
					      }
					      {		/* Ast/alphatize.scm 367 */
						 sexit_bglt duplicated1555_1604;
						 duplicated1555_1604 =
						    (sexit_bglt) (old_exit_224_1579);
						 {	/* Ast/alphatize.scm 367 */
						    sexit_bglt new1556_1605;
						    {	/* Ast/alphatize.scm 367 */
						       bool_t arg2041_1607;
						       arg2041_1607 =
							  (((sexit_bglt) CREF(duplicated1555_1604))->detached__120);
						       {	/* Ast/alphatize.scm 367 */
							  sexit_bglt res2085_2617;
							  {	/* ./Ast/var.scm 841 */
							     sexit_bglt new1179_2611;
							     new1179_2611 =
								((sexit_bglt) BREF(GC_MALLOC(sizeof(struct sexit))));
							     {	/* ./Ast/var.scm 841 */
								long arg1673_2612;
								arg1673_2612 =
								   class_num_218___object(sexit_ast_var);
								{	/* ./Ast/var.scm 841 */
								   obj_t obj_2615;
								   obj_2615 =
								      (obj_t) (new1179_2611);
								   (((obj_t) CREF(obj_2615))->header = MAKE_HEADER(arg1673_2612, 0), BUNSPEC);
								}
							     }
							     {	/* ./Ast/var.scm 841 */
								object_bglt aux_3769;
								aux_3769 =
								   (object_bglt) (new1179_2611);
								OBJECT_WIDENING_SET(aux_3769, BFALSE);
							     }
							     ((((sexit_bglt) CREF(new1179_2611))->handler) = ((obj_t) alpha_hdlg_201_1581), BUNSPEC);
							     ((((sexit_bglt) CREF(new1179_2611))->detached__120) = ((bool_t) arg2041_1607), BUNSPEC);
							     res2085_2617 = new1179_2611;
							  }
							  new1556_1605 = res2085_2617;
						       }
						    }
						    {	/* Ast/alphatize.scm 367 */

						       arg2039_1603 = new1556_1605;
						    }
						 }
					      }
					      new_var_21_1582 =
						 make_local_sexit_184_ast_local(arg2037_1601, arg2038_1602, arg2039_1603);
					   }
					   {	/* Ast/alphatize.scm 365 */
					      node_bglt old_body_129_1583;
					      old_body_129_1583 =
						 (((set_ex_it_116_bglt) CREF(node_1577))->body);
					      {		/* Ast/alphatize.scm 370 */

						 {	/* Ast/alphatize.scm 371 */
						    bool_t arg2024_1584;
						    {	/* Ast/alphatize.scm 371 */
						       local_bglt obj_2619;
						       obj_2619 =
							  (local_bglt) (old_var_137_1578);
						       arg2024_1584 =
							  (((local_bglt) CREF(obj_2619))->user__32);
						    }
						    ((((local_bglt) CREF(new_var_21_1582))->user__32) = ((bool_t) arg2024_1584), BUNSPEC);
						 }
						 {	/* Ast/alphatize.scm 373 */
						    set_ex_it_116_bglt new1558_1586;
						    {	/* Ast/alphatize.scm 373 */
						       obj_t arg2025_1587;
						       type_bglt arg2026_1588;
						       var_bglt arg2027_1589;
						       node_bglt arg2028_1590;
						       arg2025_1587 =
							  get_location_95_ast_alphatize(
							  (obj_t) (node_1577));
						       arg2026_1588 =
							  (((set_ex_it_116_bglt) CREF(node_1577))->type);
						       {	/* Ast/alphatize.scm 374 */
							  var_bglt duplicated1559_1591;
							  duplicated1559_1591 =
							     (((set_ex_it_116_bglt) CREF(node_1577))->var);
							  {	/* Ast/alphatize.scm 375 */
							     var_bglt new1560_1592;
							     {	/* Ast/alphatize.scm 375 */
								obj_t arg2029_1593;
								type_bglt arg2030_1594;
								arg2029_1593 =
								   get_location_95_ast_alphatize(
								   (obj_t) (node_1577));
								arg2030_1594 =
								   (((var_bglt) CREF(duplicated1559_1591))->type);
								{	/* Ast/alphatize.scm 374 */
								   var_bglt res2086_2635;
								   {	/* Ast/alphatize.scm 374 */
								      variable_bglt variable_2627;
								      variable_2627 =
									 (variable_bglt) (new_var_21_1582);
								      {		/* ./Ast/node.scm 886 */
									 var_bglt new1210_2628;
									 new1210_2628 =
									    ((var_bglt) BREF(GC_MALLOC(sizeof(struct var))));
									 {	/* ./Ast/node.scm 886 */
									    long arg1664_2629;
									    arg1664_2629 =
									       class_num_218___object(var_ast_node);
									    {	/* ./Ast/node.scm 886 */
									       obj_t obj_2633;
									       obj_2633 =
										  (obj_t) (new1210_2628);
									       (((obj_t) CREF(obj_2633))->header = MAKE_HEADER(arg1664_2629, 0), BUNSPEC);
									    }
									 }
									 {	/* ./Ast/node.scm 886 */
									    object_bglt aux_3791;
									    aux_3791 =
									       (object_bglt) (new1210_2628);
									    OBJECT_WIDENING_SET(aux_3791, BFALSE);
									 }
									 ((((var_bglt) CREF(new1210_2628))->loc) = ((obj_t) arg2029_1593), BUNSPEC);
									 ((((var_bglt) CREF(new1210_2628))->type) = ((type_bglt) arg2030_1594), BUNSPEC);
									 ((((var_bglt) CREF(new1210_2628))->variable) = ((variable_bglt) variable_2627), BUNSPEC);
									 res2086_2635 = new1210_2628;
								      }
								   }
								   new1560_1592 = res2086_2635;
								}
							     }
							     {	/* Ast/alphatize.scm 374 */

								arg2027_1589 = new1560_1592;
							     }
							  }
						       }
						       {	/* Ast/alphatize.scm 377 */
							  obj_t arg2032_1596;
							  obj_t arg2033_1597;
							  obj_t arg2034_1598;
							  {	/* Ast/alphatize.scm 377 */
							     obj_t list2035_1599;
							     {	/* Ast/alphatize.scm 377 */
								obj_t aux_3797;
								aux_3797 =
								   (obj_t) (old_var_137_1578);
								list2035_1599 =
								   MAKE_PAIR(aux_3797, BNIL);
							     }
							     arg2032_1596 = list2035_1599;
							  }
							  {	/* Ast/alphatize.scm 378 */
							     obj_t list2036_1600;
							     {	/* Ast/alphatize.scm 378 */
								obj_t aux_3800;
								aux_3800 =
								   (obj_t) (new_var_21_1582);
								list2036_1600 =
								   MAKE_PAIR(aux_3800, BNIL);
							     }
							     arg2033_1597 = list2036_1600;
							  }
							  arg2034_1598 =
							     get_location_95_ast_alphatize(
							     (obj_t) (node_1577));
							  arg2028_1590 =
							     alphatize_ast_alphatize(arg2032_1596, arg2033_1597, arg2034_1598, old_body_129_1583);
						       }
						       {	/* Ast/alphatize.scm 372 */
							  set_ex_it_116_bglt res2087_2650;
							  {	/* ./Ast/node.scm 988 */
							     set_ex_it_116_bglt new1386_2642;
							     new1386_2642 =
								((set_ex_it_116_bglt) BREF(GC_MALLOC(sizeof(struct set_ex_it_116))));
							     {	/* ./Ast/node.scm 988 */
								long arg1633_2643;
								arg1633_2643 =
								   class_num_218___object(set_ex_it_116_ast_node);
								{	/* ./Ast/node.scm 988 */
								   obj_t obj_2648;
								   obj_2648 =
								      (obj_t) (new1386_2642);
								   (((obj_t) CREF(obj_2648))->header = MAKE_HEADER(arg1633_2643, 0), BUNSPEC);
								}
							     }
							     {	/* ./Ast/node.scm 988 */
								object_bglt aux_3810;
								aux_3810 =
								   (object_bglt) (new1386_2642);
								OBJECT_WIDENING_SET(aux_3810, BFALSE);
							     }
							     ((((set_ex_it_116_bglt) CREF(new1386_2642))->loc) = ((obj_t) arg2025_1587), BUNSPEC);
							     ((((set_ex_it_116_bglt) CREF(new1386_2642))->type) = ((type_bglt) arg2026_1588), BUNSPEC);
							     ((((set_ex_it_116_bglt) CREF(new1386_2642))->var) = ((var_bglt) arg2027_1589), BUNSPEC);
							     ((((set_ex_it_116_bglt) CREF(new1386_2642))->body) = ((node_bglt) arg2028_1590), BUNSPEC);
							     res2087_2650 = new1386_2642;
							  }
							  new1558_1586 = res2087_2650;
						       }
						    }
						    {	/* Ast/alphatize.scm 372 */

						       aux_2788 =
							  (obj_t) (new1558_1586);
						    }
						 }
					      }
					   }
					}
				     }
				  }
			       }
			    }
			    break;
			 case ((long) 20):

			    {	/* Ast/alphatize.scm 386 */
			       jump_ex_it_184_bglt node_1609;
			       node_1609 =
				  (jump_ex_it_184_bglt) (node_20);
			       {	/* Ast/alphatize.scm 387 */
				  jump_ex_it_184_bglt new1562_1611;
				  {	/* Ast/alphatize.scm 387 */
				     obj_t arg2043_1612;
				     type_bglt arg2044_1613;
				     node_bglt arg2045_1614;
				     node_bglt arg2046_1615;
				     arg2043_1612 =
					get_location_95_ast_alphatize(
					(obj_t) (node_1609));
				     arg2044_1613 =
					(((jump_ex_it_184_bglt) CREF(node_1609))->type);
				     arg2045_1614 =
					do_alphatize_126_ast_alphatize(
					(((jump_ex_it_184_bglt) CREF(node_1609))->exit));
				     arg2046_1615 =
					do_alphatize_126_ast_alphatize(
					(((jump_ex_it_184_bglt) CREF(node_1609))->value));
				     {	/* Ast/alphatize.scm 386 */
					jump_ex_it_184_bglt res2088_2666;
					{	/* ./Ast/node.scm 995 */
					   jump_ex_it_184_bglt new1396_2658;
					   new1396_2658 =
					      ((jump_ex_it_184_bglt) BREF(GC_MALLOC(sizeof(struct jump_ex_it_184))));
					   {	/* ./Ast/node.scm 995 */
					      long arg1631_2659;
					      arg1631_2659 =
						 class_num_218___object(jump_ex_it_184_ast_node);
					      {		/* ./Ast/node.scm 995 */
						 obj_t obj_2664;
						 obj_2664 =
						    (obj_t) (new1396_2658);
						 (((obj_t) CREF(obj_2664))->header = MAKE_HEADER(arg1631_2659, 0), BUNSPEC);
					      }
					   }
					   {	/* ./Ast/node.scm 995 */
					      object_bglt aux_3830;
					      aux_3830 =
						 (object_bglt) (new1396_2658);
					      OBJECT_WIDENING_SET(aux_3830, BFALSE);
					   }
					   ((((jump_ex_it_184_bglt) CREF(new1396_2658))->loc) = ((obj_t) arg2043_1612), BUNSPEC);
					   ((((jump_ex_it_184_bglt) CREF(new1396_2658))->type) = ((type_bglt) arg2044_1613), BUNSPEC);
					   ((((jump_ex_it_184_bglt) CREF(new1396_2658))->exit) = ((node_bglt) arg2045_1614), BUNSPEC);
					   ((((jump_ex_it_184_bglt) CREF(new1396_2658))->value) = ((node_bglt) arg2046_1615), BUNSPEC);
					   res2088_2666 = new1396_2658;
					}
					new1562_1611 = res2088_2666;
				     }
				  }
				  {	/* Ast/alphatize.scm 386 */

				     aux_2788 =
					(obj_t) (new1562_1611);
				  }
			       }
			    }
			    break;
			 default:
			  case_else1703_1098:
			    if (
			       PROCEDUREP(method1697_1094))
			      {		/* Ast/alphatize.scm 67 */
				 aux_2788 =
				    PROCEDURE_ENTRY(method1697_1094) (method1697_1094,
				    (obj_t) (node_20), BEOA)
				    ;
			      }
			    else
			      {		/* Ast/alphatize.scm 67 */
				 obj_t fun1696_1090;
				 fun1696_1090 =
				    PROCEDURE_REF(do_alphatize_env_178_ast_alphatize, ((long) 0));
				 aux_2788 =
				    PROCEDURE_ENTRY(fun1696_1090) (fun1696_1090,
				    (obj_t) (node_20), BEOA);
			      }
			 }
		    }
		  else
		    {	/* Ast/alphatize.scm 67 */
		       goto case_else1703_1098;
		    }
	       }
	       return
		  (node_bglt) (aux_2788);
	    }
	 }
      }
   }
}



/* _do-alphatize2091 */
obj_t 
_do_alphatize2091_253_ast_alphatize(obj_t env_2677, obj_t node_2678)
{
   AN_OBJECT;
   {	/* Ast/alphatize.scm 67 */
      {		/* Ast/alphatize.scm 67 */
	 node_bglt aux_3850;
	 aux_3850 =
	    do_alphatize_126_ast_alphatize(
	    (node_bglt) (node_2678));
	 return
	    (obj_t) (aux_3850);
      }
   }
}



/* do-alphatize-default1563 */
node_bglt 
do_alphatize_default1563_175_ast_alphatize(node_bglt node_21)
{
   AN_OBJECT;
   {	/* Ast/alphatize.scm 14 */
      FAILURE(
	 CNST_TABLE_REF(((long) 3)), string2096_ast_alphatize,
	 (obj_t) (node_21));
   }
}



/* _do-alphatize-default1563 */
obj_t 
_do_alphatize_default1563_199_ast_alphatize(obj_t env_2679, obj_t node_2680)
{
   AN_OBJECT;
   {	/* Ast/alphatize.scm 14 */
      {		/* Ast/alphatize.scm 14 */
	 node_bglt aux_3857;
	 aux_3857 =
	    do_alphatize_default1563_175_ast_alphatize(
	    (node_bglt) (node_2680));
	 return
	    (obj_t) (aux_3857);
      }
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_ast_alphatize()
{
   AN_OBJECT;
   {	/* Ast/alphatize.scm 14 */
      module_initialization_70_type_type(((long) 0), "AST_ALPHATIZE");
      module_initialization_70_ast_var(((long) 0), "AST_ALPHATIZE");
      module_initialization_70_ast_node(((long) 0), "AST_ALPHATIZE");
      module_initialization_70_tools_error(((long) 0), "AST_ALPHATIZE");
      module_initialization_70_tools_shape(((long) 0), "AST_ALPHATIZE");
      module_initialization_70_type_cache(((long) 0), "AST_ALPHATIZE");
      module_initialization_70_ast_sexp(((long) 0), "AST_ALPHATIZE");
      module_initialization_70_ast_local(((long) 0), "AST_ALPHATIZE");
      module_initialization_70_ast_apply(((long) 0), "AST_ALPHATIZE");
      return
	 module_initialization_70_ast_app(((long) 0), "AST_ALPHATIZE");
   }
}
