/*===========================================================================*/
/*   (Ast/app.scm)                                                           */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;


extern char *number__string_214___r4_numbers_6_5(obj_t, obj_t);
static obj_t method_init_76_ast_app();
extern obj_t funcall_ast_node;
static node_bglt wrong_number_of_arguments_4_ast_app(obj_t, obj_t, node_bglt, obj_t);
extern obj_t string_append(obj_t, obj_t);
extern obj_t _nb_error_on_pass__70_tools_error;
extern obj_t find_location_loc_243_tools_location(obj_t, obj_t);
extern obj_t mark_symbol_non_user__17_ast_ident(obj_t);
extern obj_t let_var_6_ast_node;
extern obj_t var_ast_node;
extern obj_t closure_ast_node;
extern node_bglt application__node_43_ast_app(obj_t, obj_t, obj_t, obj_t);
extern obj_t gensym___r4_symbols_6_4;
static long check_user_app_174_ast_app(node_bglt, obj_t);
extern obj_t notify_assert_fail_37___eval(obj_t, obj_t, obj_t);
extern bool_t is_a__118___object(obj_t, obj_t);
static node_bglt clean_user_node__130_ast_app(node_bglt);
extern obj_t module_initialization_70_ast_app(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_tools_location(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_ast_sexp(long, char *);
extern obj_t module_initialization_70_ast_ident(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___eval(long, char *);
extern obj_t module_initialization_70___evenv(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_symbols_6_4(long, char *);
extern obj_t module_initialization_70___r4_numbers_6_5(long, char *);
extern obj_t module_initialization_70___r4_numbers_6_5_fixnum(long, char *);
static obj_t make_fx_app_node_213_ast_app(obj_t, var_bglt, obj_t);
extern long list_length(obj_t);
extern long class_num_218___object(obj_t);
extern obj_t define_primop_ref__105___evenv(obj_t, obj_t);
extern obj_t fun_ast_var;
static obj_t imported_modules_init_94_ast_app();
extern obj_t unbind_primop__163___evenv(obj_t);
extern bool_t correct_arity_app__187_ast_app(variable_bglt, obj_t);
extern obj_t cfun_ast_var;
extern obj_t app_ast_node;
extern obj_t append_2_18___r4_pairs_and_lists_6_3(obj_t, obj_t);
static obj_t library_modules_init_112_ast_app();
static obj_t _application__node1710_204_ast_app(obj_t, obj_t, obj_t, obj_t, obj_t);
static node_bglt make_va_app_node_0_ast_app(long, obj_t, obj_t, var_bglt, obj_t);
extern obj_t atom_ast_node;
extern node_bglt sexp__node_235_ast_sexp(obj_t, obj_t, obj_t, obj_t);
extern obj_t open_input_string(obj_t);
extern bool_t _fx_134___r4_numbers_6_5_fixnum(long, long);
static obj_t _correct_arity_app_1709_117_ast_app(obj_t, obj_t, obj_t);
extern obj_t string_to_bstring(char *);
extern node_bglt error_sexp__node_157_ast_sexp(obj_t, obj_t, obj_t);
static obj_t _make_app_node1711_197_ast_app(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t make_the_app_69_ast_app(obj_t, obj_t, obj_t);
static obj_t make_args_list_220_ast_app(obj_t);
extern obj_t read___reader(obj_t);
extern node_bglt make_app_node_80_ast_app(obj_t, obj_t, var_bglt, obj_t);
extern obj_t ____74_type_cache;
static obj_t require_initialization_114_ast_app = BUNSPEC;
static obj_t cnst_init_137_ast_app();
extern obj_t reverse__39___r4_pairs_and_lists_6_3(obj_t);
static obj_t __cnst[17];

DEFINE_EXPORT_PROCEDURE(make_app_node_env_134_ast_app, _make_app_node1711_197_ast_app1721, _make_app_node1711_197_ast_app, 0L, 4);
DEFINE_EXPORT_PROCEDURE(application__node_env_37_ast_app, _application__node1710_204_ast_app1722, _application__node1710_204_ast_app, 0L, 4);
DEFINE_EXPORT_PROCEDURE(correct_arity_app__env_151_ast_app, _correct_arity_app_1709_117_ast_app1723, _correct_arity_app_1709_117_ast_app, 0L, 2);
DEFINE_STRING(string1716_ast_app, string1716_ast_app1724, "FOREIGN C-CONS (\"/home/tahoe2/serrano/tmp/bigloo/comptime/Ast/app.scm\" . 8282) (BEGIN (VAR? L-VAR)) (L-VAR) L-VAR LIST \077\077\077 ARG (LAMBDA L L) LET FUN VALUE (QUOTE ()) APP @ QUOTE ", 177);
DEFINE_STRING(string1715_ast_app, string1715_ast_app1725, "Illegal application: ", 21);
DEFINE_STRING(string1714_ast_app, string1714_ast_app1726, " provided", 9);
DEFINE_STRING(string1713_ast_app, string1713_ast_app1727, " or more arg(s) expected, ", 26);
DEFINE_STRING(string1712_ast_app, string1712_ast_app1728, " arg(s) expected, ", 18);



/* module-initialization */
obj_t 
module_initialization_70_ast_app(long checksum_1579, char *from_1580)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_ast_app))
	{
	   require_initialization_114_ast_app =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_ast_app();
	   cnst_init_137_ast_app();
	   imported_modules_init_94_ast_app();
	   method_init_76_ast_app();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_ast_app()
{
   AN_OBJECT;
   {	/* Ast/app.scm 14 */
      module_initialization_70___r4_numbers_6_5(((long) 0), "AST_APP");
      module_initialization_70___r4_symbols_6_4(((long) 0), "AST_APP");
      module_initialization_70___eval(((long) 0), "AST_APP");
      module_initialization_70___object(((long) 0), "AST_APP");
      module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "AST_APP");
      module_initialization_70___evenv(((long) 0), "AST_APP");
      module_initialization_70___r4_numbers_6_5_fixnum(((long) 0), "AST_APP");
      module_initialization_70___reader(((long) 0), "AST_APP");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_ast_app()
{
   AN_OBJECT;
   {	/* Ast/app.scm 14 */
      {		/* Ast/app.scm 14 */
	 obj_t cnst_port_138_1572;
	 cnst_port_138_1572 =
	    open_input_string(string1716_ast_app);
	 {
	    long i_1573;
	    i_1573 = ((long) 16);
	  loop_1574:
	    {	/* Ast/app.scm 14 */
	       bool_t test1717_1575;
	       test1717_1575 =
		  (i_1573 == ((long) -1));
	       if (test1717_1575)
		 {	/* Ast/app.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Ast/app.scm 14 */
		    {	/* Ast/app.scm 14 */
		       obj_t arg1718_1576;
		       {	/* Ast/app.scm 14 */
			  obj_t list1719_1577;
			  list1719_1577 =
			     MAKE_PAIR(cnst_port_138_1572, BNIL);
			  arg1718_1576 =
			     read___reader(list1719_1577);
		       }
		       CNST_TABLE_SET(i_1573, arg1718_1576);
		    }
		    {	/* Ast/app.scm 14 */
		       int aux_1578;
		       {	/* Ast/app.scm 14 */
			  long aux_1602;
			  aux_1602 =
			     (i_1573 - ((long) 1));
			  aux_1578 =
			     (int) (aux_1602);
		       }
		       {
			  long i_1605;
			  i_1605 =
			     (long) (aux_1578);
			  i_1573 = i_1605;
			  goto loop_1574;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* correct-arity-app? */
bool_t 
correct_arity_app__187_ast_app(variable_bglt var_1, obj_t args_2)
{
   AN_OBJECT;
   {	/* Ast/app.scm 32 */
      {		/* Ast/app.scm 33 */
	 long nb_args_51_722;
	 nb_args_51_722 =
	    list_length(args_2);
	 {	/* Ast/app.scm 34 */
	    long arity_723;
	    {	/* Ast/app.scm 35 */
	       fun_bglt obj_1296;
	       {	/* Ast/app.scm 35 */
		  value_bglt aux_1608;
		  aux_1608 =
		     (((variable_bglt) CREF(var_1))->value);
		  obj_1296 =
		     (fun_bglt) (aux_1608);
	       }
	       arity_723 =
		  (((fun_bglt) CREF(obj_1296))->arity);
	    }
	    {	/* Ast/app.scm 35 */

	       if (
		  (arity_723 == ((long) -1)))
		 {	/* Ast/app.scm 37 */
		    return ((bool_t) 1);
		 }
	       else
		 {	/* Ast/app.scm 37 */
		    if (
		       (arity_723 >= ((long) 0)))
		      {		/* Ast/app.scm 39 */
			 return
			    _fx_134___r4_numbers_6_5_fixnum(arity_723, nb_args_51_722);
		      }
		    else
		      {		/* Ast/app.scm 39 */
			 {	/* ./Ieee/fixnum.scm 7127 */
			    long aux_1617;
			    {	/* ./Ieee/fixnum.scm 7199 */
			       long aux_1620;
			       long aux_1618;
			       aux_1620 =
				  (nb_args_51_722 + ((long) 1));
			       aux_1618 =
				  NEG(arity_723);
			       aux_1617 =
				  (aux_1618 - aux_1620);
			    }
			    return
			       (aux_1617 <= ((long) 0));
			 }
		      }
		 }
	    }
	 }
      }
   }
}



/* _correct-arity-app?1709 */
obj_t 
_correct_arity_app_1709_117_ast_app(obj_t env_1557, obj_t var_1558, obj_t args_1559)
{
   AN_OBJECT;
   {	/* Ast/app.scm 32 */
      {		/* Ast/app.scm 32 */
	 bool_t aux_1624;
	 aux_1624 =
	    correct_arity_app__187_ast_app(
	    (variable_bglt) (var_1558), args_1559);
	 return
	    BBOOL(aux_1624);
      }
   }
}



/* clean-user-node! */
node_bglt 
clean_user_node__130_ast_app(node_bglt node_3)
{
   AN_OBJECT;
   {	/* Ast/app.scm 50 */
      {
	 node_bglt walk_730;
	 walk_730 = node_3;
       loop_731:
	 {	/* Ast/app.scm 52 */
	    bool_t test1451_732;
	    test1451_732 =
	       is_a__118___object(
	       (obj_t) (walk_730), let_var_6_ast_node);
	    if (test1451_732)
	      {		/* Ast/app.scm 52 */
		 {
		    obj_t l1437_733;
		    {	/* Ast/app.scm 56 */
		       let_var_6_bglt obj_1309;
		       obj_1309 =
			  (let_var_6_bglt) (walk_730);
		       l1437_733 =
			  (((let_var_6_bglt) CREF(obj_1309))->bindings);
		    }
		  lname1438_734:
		    if (
		       PAIRP(l1437_733))
		      {		/* Ast/app.scm 54 */
			 {	/* Ast/app.scm 55 */
			    local_bglt obj_1313;
			    {	/* Ast/app.scm 55 */
			       obj_t aux_1633;
			       {	/* ./Ieee/pair-list.scm 5701 */
				  obj_t aux_1634;
				  aux_1634 =
				     CAR(l1437_733);
				  aux_1633 =
				     CAR(aux_1634);
			       }
			       obj_1313 =
				  (local_bglt) (aux_1633);
			    }
			    ((((local_bglt) CREF(obj_1313))->user__32) = ((bool_t) ((bool_t) 0)), BUNSPEC);
			 }
			 {
			    obj_t l1437_1639;
			    l1437_1639 =
			       CDR(l1437_733);
			    l1437_733 = l1437_1639;
			    goto lname1438_734;
			 }
		      }
		    else
		      {		/* Ast/app.scm 54 */
			 ((bool_t) 1);
		      }
		 }
		 {
		    node_bglt walk_1643;
		    {	/* Ast/app.scm 57 */
		       let_var_6_bglt obj_1316;
		       obj_1316 =
			  (let_var_6_bglt) (walk_730);
		       walk_1643 =
			  (((let_var_6_bglt) CREF(obj_1316))->body);
		    }
		    walk_730 = walk_1643;
		    goto loop_731;
		 }
	      }
	    else
	      {		/* Ast/app.scm 52 */
		 return node_3;
	      }
	 }
      }
   }
}



/* application->node */
node_bglt 
application__node_43_ast_app(obj_t exp_4, obj_t stack_5, obj_t loc_6, obj_t site_7)
{
   AN_OBJECT;
   {	/* Ast/app.scm 66 */
      {
	 obj_t exp_814;
	 {	/* Ast/app.scm 84 */
	    obj_t loc_742;
	    loc_742 =
	       find_location_loc_243_tools_location(exp_4, loc_6);
	    {	/* Ast/app.scm 84 */
	       obj_t err_nb_106_743;
	       err_nb_106_743 = _nb_error_on_pass__70_tools_error;
	       {	/* Ast/app.scm 85 */
		  node_bglt fun_744;
		  fun_744 =
		     sexp__node_235_ast_sexp(
		     CAR(exp_4), stack_5, loc_742,
		     CNST_TABLE_REF(((long) 2)));
		  {	/* Ast/app.scm 86 */
		     bool_t fun_err__19_745;
		     {	/* Ast/app.scm 87 */
			long n1_1318;
			long n2_1319;
			n1_1318 =
			   (long) CINT(_nb_error_on_pass__70_tools_error);
			n2_1319 =
			   (long) CINT(err_nb_106_743);
			fun_err__19_745 =
			   (n1_1318 > n2_1319);
		     }
		     {	/* Ast/app.scm 87 */

			{	/* Ast/app.scm 88 */
			   bool_t test1457_746;
			   {	/* Ast/app.scm 88 */
			      bool_t test_1653;
			      exp_814 = exp_4;
			      {
				 obj_t exp_816;
				 exp_816 = exp_814;
			       loop_817:
				 if (
				    NULLP(exp_816))
				   {	/* Ast/app.scm 72 */
				      test_1653 = ((bool_t) 1)
					 ;
				   }
				 else
				   {

				      {		/* Ast/app.scm 74 */
					 obj_t e_105_50_823;
					 e_105_50_823 =
					    CAR(exp_816);
					 if (
					    PAIRP(e_105_50_823))
					   {	/* Ast/app.scm 74 */
					      bool_t test_1659;
					      {		/* ./Ieee/equiv.scm 5508 */
						 obj_t aux_1662;
						 obj_t aux_1660;
						 aux_1662 =
						    CNST_TABLE_REF(((long) 0));
						 aux_1660 =
						    CAR(e_105_50_823);
						 test_1659 =
						    (aux_1660 == aux_1662);
					      }
					      if (test_1659)
						{	/* Ast/app.scm 74 */
						   {
						      obj_t exp_1665;
						      exp_1665 =
							 CDR(exp_816);
						      exp_816 = exp_1665;
						      goto loop_817;
						   }
						}
					      else
						{	/* Ast/app.scm 74 */
						   obj_t cdr_111_186_826;
						   cdr_111_186_826 =
						      CDR(e_105_50_823);
						   {	/* Ast/app.scm 74 */
						      bool_t test_1668;
						      {		/* ./Ieee/equiv.scm 5508 */
							 obj_t aux_1671;
							 obj_t aux_1669;
							 aux_1671 =
							    CNST_TABLE_REF(((long) 1));
							 aux_1669 =
							    CAR(e_105_50_823);
							 test_1668 =
							    (aux_1669 == aux_1671);
						      }
						      if (test_1668)
							{	/* Ast/app.scm 74 */
							   if (
							      PAIRP(cdr_111_186_826))
							     {	/* Ast/app.scm 74 */
								obj_t cdr_113_28_829;
								cdr_113_28_829 =
								   CDR(cdr_111_186_826);
								{	/* Ast/app.scm 74 */
								   bool_t test_1677;
								   {	/* ./Ieee/symbol.scm 6015 */
								      obj_t aux_1678;
								      aux_1678 =
									 CAR(cdr_111_186_826);
								      test_1677 =
									 SYMBOLP(aux_1678);
								   }
								   if (test_1677)
								     {	/* Ast/app.scm 74 */
									if (
									   PAIRP(cdr_113_28_829))
									  {	/* Ast/app.scm 74 */
									     bool_t test_1683;
									     {	/* ./Ieee/symbol.scm 6015 */
										obj_t aux_1684;
										aux_1684 =
										   CAR(cdr_113_28_829);
										test_1683 =
										   SYMBOLP(aux_1684);
									     }
									     if (test_1683)
									       {	/* Ast/app.scm 74 */
										  bool_t test_1687;
										  {	/* ./Ieee/equiv.scm 5508 */
										     obj_t aux_1688;
										     aux_1688 =
											CDR(cdr_113_28_829);
										     test_1687 =
											(aux_1688 == BNIL);
										  }
										  if (test_1687)
										    {	/* Ast/app.scm 74 */
										       {
											  obj_t exp_1691;
											  exp_1691 =
											     CDR(exp_816);
											  exp_816 = exp_1691;
											  goto loop_817;
										       }
										    }
										  else
										    {	/* Ast/app.scm 74 */
										     tag_104_254_822:
										       {	/* Ast/app.scm 82 */
											  bool_t _ortest_1439_845;
											  _ortest_1439_845 =
											     is_a__118___object(
											     CAR(exp_816), atom_ast_node);
											  if (_ortest_1439_845)
											    {	/* Ast/app.scm 82 */
											       test_1653 = _ortest_1439_845
												  ;
											    }
											  else
											    {	/* Ast/app.scm 82 */
											       test_1653 =
												  is_a__118___object(
												  CAR(exp_816), var_ast_node)
												  ;
											    }
										       }
										    }
									       }
									     else
									       {	/* Ast/app.scm 74 */
										  goto tag_104_254_822;
									       }
									  }
									else
									  {	/* Ast/app.scm 74 */
									     goto tag_104_254_822;
									  }
								     }
								   else
								     {	/* Ast/app.scm 74 */
									goto tag_104_254_822;
								     }
								}
							     }
							   else
							     {	/* Ast/app.scm 74 */
								goto tag_104_254_822;
							     }
							}
						      else
							{	/* Ast/app.scm 74 */
							   goto tag_104_254_822;
							}
						   }
						}
					   }
					 else
					   {	/* Ast/app.scm 74 */
					      {
						 obj_t exp_1698;
						 exp_1698 =
						    CDR(exp_816);
						 exp_816 = exp_1698;
						 goto loop_817;
					      }
					   }
				      }
				   }
			      }
			      if (test_1653)
				{	/* Ast/app.scm 88 */
				   test1457_746 =
				      is_a__118___object(
				      (obj_t) (fun_744), var_ast_node);
				}
			      else
				{	/* Ast/app.scm 88 */
				   test1457_746 = ((bool_t) 0);
				}
			   }
			   if (test1457_746)
			     {	/* Ast/app.scm 89 */
				obj_t args_747;
				args_747 =
				   CDR(exp_4);
				{	/* Ast/app.scm 89 */
				   long delta_748;
				   delta_748 =
				      check_user_app_174_ast_app(fun_744, args_747);
				   {	/* Ast/app.scm 90 */

				      {		/* Ast/app.scm 92 */
					 bool_t test1458_749;
					 test1458_749 =
					    is_a__118___object(
					    (obj_t) (fun_744), var_ast_node);
					 if (test1458_749)
					   {	/* Ast/app.scm 92 */
					      if (
						 (delta_748 == ((long) 0)))
						{	/* Ast/app.scm 94 */
						   return
						      make_app_node_80_ast_app(stack_5, loc_742,
						      (var_bglt) (fun_744), args_747);
						}
					      else
						{	/* Ast/app.scm 94 */
						   return
						      wrong_number_of_arguments_4_ast_app(exp_4, loc_742, fun_744, args_747);
						}
					   }
					 else
					   {	/* Ast/app.scm 92 */
					      return
						 sexp__node_235_ast_sexp(
						 CNST_TABLE_REF(((long) 3)), stack_5, loc_742,
						 CNST_TABLE_REF(((long) 4)));
					   }
				      }
				   }
				}
			     }
			   else
			     {
				obj_t old_args_130_751;
				obj_t new_args_235_752;
				obj_t bindings_753;
				old_args_130_751 =
				   CDR(exp_4);
				new_args_235_752 = BNIL;
				bindings_753 = BNIL;
			      loop_754:
				if (
				   NULLP(old_args_130_751))
				  {	/* Ast/app.scm 102 */
				     {	/* Ast/app.scm 103 */
					obj_t old_fun_147_759;
					old_fun_147_759 =
					   CAR(exp_4);
					{	/* Ast/app.scm 109 */
					   bool_t test1465_761;
					   test1465_761 =
					      is_a__118___object(
					      (obj_t) (fun_744), var_ast_node);
					   if (test1465_761)
					     {	/* Ast/app.scm 110 */
						node_bglt node_762;
						{	/* Ast/app.scm 110 */
						   obj_t arg1466_763;
						   arg1466_763 =
						      make_the_app_69_ast_app(new_args_235_752, bindings_753, old_fun_147_759);
						   node_762 =
						      sexp__node_235_ast_sexp(arg1466_763, stack_5, loc_742, site_7);
						}
						return
						   clean_user_node__130_ast_app(node_762);
					     }
					   else
					     {	/* Ast/app.scm 115 */
						obj_t new_fun_115_764;
						{	/* Ast/app.scm 115 */
						   obj_t arg1479_778;
						   arg1479_778 =
						      PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4,
						      CNST_TABLE_REF(((long) 5)), BEOA);
						   new_fun_115_764 =
						      mark_symbol_non_user__17_ast_ident(arg1479_778);
						}
						{	/* Ast/app.scm 115 */
						   obj_t lexp_765;
						   {	/* Ast/app.scm 116 */
						      obj_t arg1467_767;
						      obj_t arg1469_768;
						      arg1467_767 =
							 CNST_TABLE_REF(((long) 6));
						      {		/* Ast/app.scm 116 */
							 obj_t arg1470_769;
							 obj_t arg1471_770;
							 {	/* Ast/app.scm 116 */
							    obj_t arg1472_771;
							    {	/* Ast/app.scm 116 */
							       obj_t arg1474_773;
							       {	/* ./Ieee/pair-list.scm 5689 */
								  obj_t aux_1730;
								  if (fun_err__19_745)
								    {	/* Ast/app.scm 116 */
								       aux_1730 =
									  CNST_TABLE_REF(((long) 7))
									  ;
								    }
								  else
								    {	/* Ast/app.scm 116 */
								       aux_1730 = old_fun_147_759
									  ;
								    }
								  arg1474_773 =
								     MAKE_PAIR(aux_1730, BNIL);
							       }
							       arg1472_771 =
								  MAKE_PAIR(new_fun_115_764, arg1474_773);
							    }
							    arg1470_769 =
							       MAKE_PAIR(arg1472_771, BNIL);
							 }
							 {	/* Ast/app.scm 119 */
							    obj_t arg1477_776;
							    arg1477_776 =
							       make_the_app_69_ast_app(new_args_235_752, bindings_753, new_fun_115_764);
							    arg1471_770 =
							       MAKE_PAIR(arg1477_776, BNIL);
							 }
							 arg1469_768 =
							    MAKE_PAIR(arg1470_769, arg1471_770);
						      }
						      lexp_765 =
							 MAKE_PAIR(arg1467_767, arg1469_768);
						   }
						   {	/* Ast/app.scm 116 */
						      node_bglt node_766;
						      node_766 =
							 sexp__node_235_ast_sexp(lexp_765, stack_5, loc_742, site_7);
						      {		/* Ast/app.scm 120 */

							 return
							    clean_user_node__130_ast_app(node_766);
						      }
						   }
						}
					     }
					}
				     }
				  }
				else
				  {	/* Ast/app.scm 122 */
				     bool_t test_1742;
				     {	/* Ast/app.scm 122 */
					bool_t test_1743;
					{	/* ./Ieee/symbol.scm 6015 */
					   obj_t aux_1744;
					   aux_1744 =
					      CAR(old_args_130_751);
					   test_1743 =
					      SYMBOLP(aux_1744);
					}
					if (test_1743)
					  {	/* Ast/app.scm 122 */
					     test_1742 = ((bool_t) 1)
						;
					  }
					else
					  {	/* ./Llib/bigloo.scm 945 */
					     obj_t aux_1747;
					     aux_1747 =
						CAR(old_args_130_751);
					     test_1742 =
						CNSTP(aux_1747);
					  }
				     }
				     if (test_1742)
				       {	/* Ast/app.scm 122 */
					  {	/* Ast/app.scm 124 */
					     obj_t arg1497_796;
					     obj_t arg1498_797;
					     arg1497_796 =
						CDR(old_args_130_751);
					     {	/* ./Ieee/pair-list.scm 5689 */
						obj_t aux_1751;
						aux_1751 =
						   CAR(old_args_130_751);
						arg1498_797 =
						   MAKE_PAIR(aux_1751, new_args_235_752);
					     }
					     {
						obj_t new_args_235_1755;
						obj_t old_args_130_1754;
						old_args_130_1754 = arg1497_796;
						new_args_235_1755 = arg1498_797;
						new_args_235_752 = new_args_235_1755;
						old_args_130_751 = old_args_130_1754;
						goto loop_754;
					     }
					  }
				       }
				     else
				       {	/* Ast/app.scm 122 */
					  {	/* Ast/app.scm 128 */
					     obj_t new_arg_128_799;
					     {	/* Ast/app.scm 128 */
						obj_t arg1508_807;
						arg1508_807 =
						   PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4,
						   CNST_TABLE_REF(((long) 8)), BEOA);
						new_arg_128_799 =
						   mark_symbol_non_user__17_ast_ident(arg1508_807);
					     }
					     {	/* Ast/app.scm 129 */
						obj_t arg1500_800;
						obj_t arg1501_801;
						obj_t arg1502_802;
						arg1500_800 =
						   CDR(old_args_130_751);
						arg1501_801 =
						   MAKE_PAIR(new_arg_128_799, new_args_235_752);
						{	/* Ast/app.scm 131 */
						   obj_t arg1503_803;
						   {	/* Ast/app.scm 131 */
						      obj_t list1505_805;
						      {		/* Ast/app.scm 131 */
							 obj_t arg1506_806;
							 {	/* Ast/app.scm 131 */
							    obj_t aux_1762;
							    aux_1762 =
							       CAR(old_args_130_751);
							    arg1506_806 =
							       MAKE_PAIR(aux_1762, BNIL);
							 }
							 list1505_805 =
							    MAKE_PAIR(new_arg_128_799, arg1506_806);
						      }
						      arg1503_803 = list1505_805;
						   }
						   arg1502_802 =
						      MAKE_PAIR(arg1503_803, bindings_753);
						}
						{
						   obj_t bindings_1769;
						   obj_t new_args_235_1768;
						   obj_t old_args_130_1767;
						   old_args_130_1767 = arg1500_800;
						   new_args_235_1768 = arg1501_801;
						   bindings_1769 = arg1502_802;
						   bindings_753 = bindings_1769;
						   new_args_235_752 = new_args_235_1768;
						   old_args_130_751 = old_args_130_1767;
						   goto loop_754;
						}
					     }
					  }
				       }
				  }
			     }
			}
		     }
		  }
	       }
	    }
	 }
      }
   }
}



/* make-the-app */
obj_t 
make_the_app_69_ast_app(obj_t new_args_235_1571, obj_t bindings_1570, obj_t fun_779)
{
   AN_OBJECT;
   {	/* Ast/app.scm 104 */
      if (
	 PAIRP(bindings_1570))
	{	/* Ast/app.scm 106 */
	   obj_t arg1482_782;
	   obj_t arg1483_783;
	   arg1482_782 =
	      CNST_TABLE_REF(((long) 6));
	   {	/* Ast/app.scm 106 */
	      obj_t arg1484_784;
	      obj_t arg1485_785;
	      arg1484_784 =
		 reverse__39___r4_pairs_and_lists_6_3(bindings_1570);
	      {		/* Ast/app.scm 107 */
		 obj_t arg1486_786;
		 {	/* Ast/app.scm 107 */
		    obj_t arg1489_788;
		    {	/* Ast/app.scm 107 */
		       obj_t arg1490_789;
		       arg1490_789 =
			  reverse__39___r4_pairs_and_lists_6_3(new_args_235_1571);
		       arg1489_788 =
			  append_2_18___r4_pairs_and_lists_6_3(arg1490_789, BNIL);
		    }
		    arg1486_786 =
		       MAKE_PAIR(fun_779, arg1489_788);
		 }
		 arg1485_785 =
		    MAKE_PAIR(arg1486_786, BNIL);
	      }
	      arg1483_783 =
		 MAKE_PAIR(arg1484_784, arg1485_785);
	   }
	   return
	      MAKE_PAIR(arg1482_782, arg1483_783);
	}
      else
	{	/* Ast/app.scm 108 */
	   obj_t arg1493_791;
	   {	/* Ast/app.scm 108 */
	      obj_t arg1494_792;
	      arg1494_792 =
		 reverse__39___r4_pairs_and_lists_6_3(new_args_235_1571);
	      arg1493_791 =
		 append_2_18___r4_pairs_and_lists_6_3(arg1494_792, BNIL);
	   }
	   return
	      MAKE_PAIR(fun_779, arg1493_791);
	}
   }
}



/* _application->node1710 */
obj_t 
_application__node1710_204_ast_app(obj_t env_1560, obj_t exp_1561, obj_t stack_1562, obj_t loc_1563, obj_t site_1564)
{
   AN_OBJECT;
   {	/* Ast/app.scm 66 */
      {		/* Ast/app.scm 66 */
	 node_bglt aux_1784;
	 aux_1784 =
	    application__node_43_ast_app(exp_1561, stack_1562, loc_1563, site_1564);
	 return
	    (obj_t) (aux_1784);
      }
   }
}



/* wrong-number-of-arguments */
node_bglt 
wrong_number_of_arguments_4_ast_app(obj_t exp_8, obj_t loc_9, node_bglt fun_10, obj_t args_11)
{
   AN_OBJECT;
   {	/* Ast/app.scm 136 */
      {		/* Ast/app.scm 137 */
	 variable_bglt var_849;
	 {	/* Ast/app.scm 137 */
	    var_bglt obj_1394;
	    obj_1394 =
	       (var_bglt) (fun_10);
	    var_849 =
	       (((var_bglt) CREF(obj_1394))->variable);
	 }
	 {	/* Ast/app.scm 137 */
	    value_bglt fun_850;
	    fun_850 =
	       (((variable_bglt) CREF(var_849))->value);
	    {	/* Ast/app.scm 138 */
	       long nb_args_51_851;
	       nb_args_51_851 =
		  list_length(args_11);
	       {	/* Ast/app.scm 139 */
		  long arity_852;
		  {	/* Ast/app.scm 141 */
		     bool_t test1559_871;
		     test1559_871 =
			is_a__118___object(
			(obj_t) (fun_850), fun_ast_var);
		     if (test1559_871)
		       {	/* Ast/app.scm 141 */
			  {	/* Ast/app.scm 142 */
			     fun_bglt obj_1397;
			     obj_1397 =
				(fun_bglt) (fun_850);
			     arity_852 =
				(((fun_bglt) CREF(obj_1397))->arity);
			  }
		       }
		     else
		       {	/* Ast/app.scm 141 */
			  arity_852 = ((long) -1);
		       }
		  }
		  {	/* Ast/app.scm 140 */
		     obj_t expect_853;
		     if (
			(arity_852 >= ((long) 0)))
		       {	/* Ast/app.scm 146 */
			  {	/* Ast/app.scm 147 */
			     obj_t aux_1798;
			     {	/* Ast/app.scm 147 */
				char *aux_1799;
				aux_1799 =
				   number__string_214___r4_numbers_6_5(
				   BINT(arity_852), BNIL);
				aux_1798 =
				   string_to_bstring(aux_1799);
			     }
			     expect_853 =
				string_append(aux_1798, string1712_ast_app);
			  }
		       }
		     else
		       {	/* Ast/app.scm 146 */
			  {	/* Ast/app.scm 150 */
			     obj_t aux_1804;
			     {	/* Ast/app.scm 150 */
				char *aux_1805;
				{	/* Ast/app.scm 150 */
				   obj_t aux_1806;
				   {	/* Ast/app.scm 150 */
				      long aux_1807;
				      {		/* ./Ieee/fixnum.scm 7217 */
					 long aux_1808;
					 aux_1808 =
					    (arity_852 + ((long) 1));
					 aux_1807 =
					    NEG(aux_1808);
				      }
				      aux_1806 =
					 BINT(aux_1807);
				   }
				   aux_1805 =
				      number__string_214___r4_numbers_6_5(aux_1806, BNIL);
				}
				aux_1804 =
				   string_to_bstring(aux_1805);
			     }
			     expect_853 =
				string_append(aux_1804, string1713_ast_app);
			  }
		       }
		     {	/* Ast/app.scm 145 */
			obj_t provide_854;
			{	/* Ast/app.scm 152 */
			   obj_t aux_1815;
			   {	/* Ast/app.scm 152 */
			      char *aux_1816;
			      aux_1816 =
				 number__string_214___r4_numbers_6_5(
				 BINT(nb_args_51_851), BNIL);
			      aux_1815 =
				 string_to_bstring(aux_1816);
			   }
			   provide_854 =
			      string_append(aux_1815, string1714_ast_app);
			}
			{	/* Ast/app.scm 152 */

			   {	/* Ast/app.scm 154 */
			      obj_t arg1540_855;
			      {		/* Ast/app.scm 154 */
				 obj_t arg1543_857;
				 arg1543_857 =
				    string_append(expect_853, provide_854);
				 arg1540_855 =
				    string_append(string1715_ast_app, arg1543_857);
			      }
			      return
				 error_sexp__node_157_ast_sexp(arg1540_855, exp_8, loc_9);
			   }
			}
		     }
		  }
	       }
	    }
	 }
      }
   }
}



/* make-app-node */
node_bglt 
make_app_node_80_ast_app(obj_t stack_12, obj_t loc_13, var_bglt var_14, obj_t args_15)
{
   AN_OBJECT;
   {	/* Ast/app.scm 161 */
      {		/* Ast/app.scm 162 */
	 value_bglt fun_872;
	 {	/* Ast/app.scm 162 */
	    variable_bglt arg1571_889;
	    arg1571_889 =
	       (((var_bglt) CREF(var_14))->variable);
	    fun_872 =
	       (((variable_bglt) CREF(arg1571_889))->value);
	 }
	 {	/* Ast/app.scm 163 */
	    bool_t test1560_873;
	    {	/* Ast/app.scm 163 */
	       bool_t test1566_885;
	       test1566_885 =
		  is_a__118___object(
		  (obj_t) (fun_872), fun_ast_var);
	       if (test1566_885)
		 {	/* Ast/app.scm 164 */
		    bool_t test_1829;
		    {	/* ./Ieee/fixnum.scm 7133 */
		       long aux_1830;
		       {	/* Ast/app.scm 164 */
			  fun_bglt obj_1406;
			  obj_1406 =
			     (fun_bglt) (fun_872);
			  aux_1830 =
			     (((fun_bglt) CREF(obj_1406))->arity);
		       }
		       test_1829 =
			  (aux_1830 >= ((long) 0));
		    }
		    if (test_1829)
		      {		/* Ast/app.scm 164 */
			 test1560_873 = ((bool_t) 1);
		      }
		    else
		      {		/* Ast/app.scm 164 */
			 test1560_873 =
			    is_a__118___object(
			    (obj_t) (fun_872), cfun_ast_var);
		      }
		 }
	       else
		 {	/* Ast/app.scm 163 */
		    test1560_873 = ((bool_t) 1);
		 }
	    }
	    if (test1560_873)
	      {		/* Ast/app.scm 166 */
		 obj_t args_874;
		 {
		    obj_t args_875;
		    obj_t res_876;
		    args_875 = args_15;
		    res_876 = BNIL;
		  loop_877:
		    if (
		       NULLP(args_875))
		      {		/* Ast/app.scm 168 */
			 args_874 =
			    reverse__39___r4_pairs_and_lists_6_3(res_876);
		      }
		    else
		      {		/* Ast/app.scm 170 */
			 obj_t a_879;
			 obj_t loc_880;
			 a_879 =
			    CAR(args_875);
			 loc_880 =
			    find_location_loc_243_tools_location(args_875, loc_13);
			 {	/* Ast/app.scm 172 */
			    obj_t arg1562_881;
			    obj_t arg1563_882;
			    arg1562_881 =
			       CDR(args_875);
			    {	/* Ast/app.scm 173 */
			       node_bglt arg1564_883;
			       arg1564_883 =
				  sexp__node_235_ast_sexp(a_879, stack_12, loc_880,
				  CNST_TABLE_REF(((long) 4)));
			       {	/* ./Ieee/pair-list.scm 5689 */
				  obj_t aux_1845;
				  aux_1845 =
				     (obj_t) (arg1564_883);
				  arg1563_882 =
				     MAKE_PAIR(aux_1845, res_876);
			       }
			    }
			    {
			       obj_t res_1849;
			       obj_t args_1848;
			       args_1848 = arg1562_881;
			       res_1849 = arg1563_882;
			       res_876 = res_1849;
			       args_875 = args_1848;
			       goto loop_877;
			    }
			 }
		      }
		 }
		 {	/* Ast/app.scm 175 */
		    obj_t aux_1850;
		    aux_1850 =
		       make_fx_app_node_213_ast_app(loc_13, var_14, args_874);
		    return
		       (node_bglt) (aux_1850);
		 }
	      }
	    else
	      {		/* Ast/app.scm 176 */
		 long aux_1853;
		 {	/* Ast/app.scm 176 */
		    fun_bglt obj_1415;
		    obj_1415 =
		       (fun_bglt) (fun_872);
		    aux_1853 =
		       (((fun_bglt) CREF(obj_1415))->arity);
		 }
		 return
		    make_va_app_node_0_ast_app(aux_1853, stack_12, loc_13, var_14, args_15);
	      }
	 }
      }
   }
}



/* _make-app-node1711 */
obj_t 
_make_app_node1711_197_ast_app(obj_t env_1565, obj_t stack_1566, obj_t loc_1567, obj_t var_1568, obj_t args_1569)
{
   AN_OBJECT;
   {	/* Ast/app.scm 161 */
      {		/* Ast/app.scm 161 */
	 node_bglt aux_1857;
	 aux_1857 =
	    make_app_node_80_ast_app(stack_1566, loc_1567,
	    (var_bglt) (var_1568), args_1569);
	 return
	    (obj_t) (aux_1857);
      }
   }
}



/* make-fx-app-node */
obj_t 
make_fx_app_node_213_ast_app(obj_t loc_16, var_bglt var_17, obj_t args_18)
{
   AN_OBJECT;
   {	/* Ast/app.scm 181 */
      {		/* Ast/app.scm 182 */
	 variable_bglt v_890;
	 v_890 =
	    (((var_bglt) CREF(var_17))->variable);
	 {	/* Ast/app.scm 183 */
	    bool_t test1572_891;
	    {	/* ./Ast/var.scm 630 */
	       obj_t aux_1862;
	       {	/* Ast/app.scm 183 */
		  value_bglt aux_1863;
		  aux_1863 =
		     (((variable_bglt) CREF(v_890))->value);
		  aux_1862 =
		     (obj_t) (aux_1863);
	       }
	       test1572_891 =
		  is_a__118___object(aux_1862, fun_ast_var);
	    }
	    if (test1572_891)
	      {		/* Ast/app.scm 184 */
		 type_bglt arg1576_893;
		 var_bglt arg1578_895;
		 arg1576_893 =
		    (((variable_bglt) CREF(v_890))->type);
		 {	/* Ast/app.scm 187 */
		    bool_t test1580_897;
		    test1580_897 =
		       is_a__118___object(
		       (obj_t) (var_17), closure_ast_node);
		    if (test1580_897)
		      {		/* Ast/app.scm 188 */
			 var_bglt new1442_899;
			 {	/* Ast/app.scm 188 */
			    obj_t arg1581_900;
			    type_bglt arg1582_901;
			    variable_bglt arg1583_902;
			    arg1581_900 =
			       (((var_bglt) CREF(var_17))->loc);
			    arg1582_901 =
			       (((var_bglt) CREF(var_17))->type);
			    arg1583_902 =
			       (((var_bglt) CREF(var_17))->variable);
			    {	/* Ast/app.scm 188 */
			       var_bglt res1706_1434;
			       {	/* ./Ast/node.scm 738 */
				  var_bglt new1210_1427;
				  new1210_1427 =
				     ((var_bglt) BREF(GC_MALLOC(sizeof(struct var))));
				  {	/* ./Ast/node.scm 738 */
				     long arg1675_1428;
				     arg1675_1428 =
					class_num_218___object(var_ast_node);
				     {	/* ./Ast/node.scm 738 */
					obj_t obj_1432;
					obj_1432 =
					   (obj_t) (new1210_1427);
					(((obj_t) CREF(obj_1432))->header = MAKE_HEADER(arg1675_1428, 0), BUNSPEC);
				     }
				  }
				  {	/* ./Ast/node.scm 738 */
				     object_bglt aux_1879;
				     aux_1879 =
					(object_bglt) (new1210_1427);
				     OBJECT_WIDENING_SET(aux_1879, BFALSE);
				  }
				  ((((var_bglt) CREF(new1210_1427))->loc) = ((obj_t) arg1581_900), BUNSPEC);
				  ((((var_bglt) CREF(new1210_1427))->type) = ((type_bglt) arg1582_901), BUNSPEC);
				  ((((var_bglt) CREF(new1210_1427))->variable) = ((variable_bglt) arg1583_902), BUNSPEC);
				  res1706_1434 = new1210_1427;
			       }
			       new1442_899 = res1706_1434;
			    }
			 }
			 {	/* Ast/app.scm 188 */

			    arg1578_895 = new1442_899;
			 }
		      }
		    else
		      {		/* Ast/app.scm 187 */
			 arg1578_895 = var_17;
		      }
		 }
		 {	/* Ast/app.scm 184 */
		    app_bglt res1707_1453;
		    {	/* Ast/app.scm 184 */
		       obj_t key_1438;
		       key_1438 =
			  BINT(((long) -1));
		       {	/* ./Ast/node.scm 755 */
			  app_bglt new1248_1442;
			  new1248_1442 =
			     ((app_bglt) BREF(GC_MALLOC(sizeof(struct app))));
			  {	/* ./Ast/node.scm 755 */
			     long arg1666_1443;
			     arg1666_1443 =
				class_num_218___object(app_ast_node);
			     {	/* ./Ast/node.scm 755 */
				obj_t obj_1451;
				obj_1451 =
				   (obj_t) (new1248_1442);
				(((obj_t) CREF(obj_1451))->header = MAKE_HEADER(arg1666_1443, 0), BUNSPEC);
			     }
			  }
			  {	/* ./Ast/node.scm 755 */
			     object_bglt aux_1890;
			     aux_1890 =
				(object_bglt) (new1248_1442);
			     OBJECT_WIDENING_SET(aux_1890, BFALSE);
			  }
			  ((((app_bglt) CREF(new1248_1442))->loc) = ((obj_t) loc_16), BUNSPEC);
			  ((((app_bglt) CREF(new1248_1442))->type) = ((type_bglt) arg1576_893), BUNSPEC);
			  ((((app_bglt) CREF(new1248_1442))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
			  ((((app_bglt) CREF(new1248_1442))->key) = ((obj_t) key_1438), BUNSPEC);
			  ((((app_bglt) CREF(new1248_1442))->fun) = ((var_bglt) arg1578_895), BUNSPEC);
			  ((((app_bglt) CREF(new1248_1442))->args) = ((obj_t) args_18), BUNSPEC);
			  ((((app_bglt) CREF(new1248_1442))->stack_info_255) = ((obj_t) BUNSPEC), BUNSPEC);
			  res1707_1453 = new1248_1442;
		       }
		    }
		    return
		       (obj_t) (res1707_1453);
		 }
	      }
	    else
	      {		/* Ast/app.scm 191 */
		 obj_t arg1585_904;
		 obj_t arg1587_906;
		 obj_t arg1588_907;
		 arg1585_904 = ____74_type_cache;
		 {	/* ./Ieee/pair-list.scm 5689 */
		    obj_t aux_1901;
		    aux_1901 =
		       (obj_t) (var_17);
		    arg1587_906 =
		       MAKE_PAIR(aux_1901, args_18);
		 }
		 arg1588_907 =
		    CNST_TABLE_REF(((long) 9));
		 {	/* Ast/app.scm 191 */
		    funcall_bglt res1708_1470;
		    {	/* Ast/app.scm 191 */
		       type_bglt type_1457;
		       node_bglt fun_1458;
		       type_1457 =
			  (type_bglt) (arg1585_904);
		       fun_1458 =
			  (node_bglt) (var_17);
		       {	/* ./Ast/node.scm 771 */
			  funcall_bglt new1272_1461;
			  new1272_1461 =
			     ((funcall_bglt) BREF(GC_MALLOC(sizeof(struct funcall))));
			  {	/* ./Ast/node.scm 771 */
			     long arg1662_1462;
			     arg1662_1462 =
				class_num_218___object(funcall_ast_node);
			     {	/* ./Ast/node.scm 771 */
				obj_t obj_1468;
				obj_1468 =
				   (obj_t) (new1272_1461);
				(((obj_t) CREF(obj_1468))->header = MAKE_HEADER(arg1662_1462, 0), BUNSPEC);
			     }
			  }
			  {	/* ./Ast/node.scm 771 */
			     object_bglt aux_1911;
			     aux_1911 =
				(object_bglt) (new1272_1461);
			     OBJECT_WIDENING_SET(aux_1911, BFALSE);
			  }
			  ((((funcall_bglt) CREF(new1272_1461))->loc) = ((obj_t) loc_16), BUNSPEC);
			  ((((funcall_bglt) CREF(new1272_1461))->type) = ((type_bglt) type_1457), BUNSPEC);
			  ((((funcall_bglt) CREF(new1272_1461))->fun) = ((node_bglt) fun_1458), BUNSPEC);
			  ((((funcall_bglt) CREF(new1272_1461))->args) = ((obj_t) arg1587_906), BUNSPEC);
			  ((((funcall_bglt) CREF(new1272_1461))->strength) = ((obj_t) arg1588_907), BUNSPEC);
			  res1708_1470 = new1272_1461;
		       }
		    }
		    return
		       (obj_t) (res1708_1470);
		 }
	      }
	 }
      }
   }
}



/* make-va-app-node */
node_bglt 
make_va_app_node_0_ast_app(long arity_19, obj_t stack_20, obj_t loc_21, var_bglt var_22, obj_t args_23)
{
   AN_OBJECT;
   {	/* Ast/app.scm 200 */
      {
	 obj_t old_args_130_910;
	 long arity_911;
	 obj_t f_args_123_912;
	 old_args_130_910 = args_23;
	 arity_911 = arity_19;
	 f_args_123_912 = BNIL;
       loop_913:
	 if (
	    (arity_911 == ((long) -1)))
	   {	/* Ast/app.scm 209 */
	      obj_t l_arg_48_915;
	      {		/* Ast/app.scm 209 */
		 obj_t arg1605_934;
		 arg1605_934 =
		    PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4,
		    CNST_TABLE_REF(((long) 10)), BEOA);
		 l_arg_48_915 =
		    mark_symbol_non_user__17_ast_ident(arg1605_934);
	      }
	      {		/* Ast/app.scm 209 */
		 obj_t l_exp_15_916;
		 {	/* Ast/app.scm 210 */
		    obj_t arg1596_925;
		    obj_t arg1597_926;
		    arg1596_925 =
		       CNST_TABLE_REF(((long) 6));
		    {	/* Ast/app.scm 210 */
		       obj_t arg1598_927;
		       obj_t arg1599_928;
		       {	/* Ast/app.scm 210 */
			  obj_t arg1600_929;
			  {	/* Ast/app.scm 210 */
			     obj_t arg1602_931;
			     {	/* Ast/app.scm 210 */
				obj_t arg1603_932;
				arg1603_932 =
				   make_args_list_220_ast_app(old_args_130_910);
				arg1602_931 =
				   MAKE_PAIR(arg1603_932, BNIL);
			     }
			     arg1600_929 =
				MAKE_PAIR(l_arg_48_915, arg1602_931);
			  }
			  arg1598_927 =
			     MAKE_PAIR(arg1600_929, BNIL);
		       }
		       arg1599_928 =
			  MAKE_PAIR(l_arg_48_915, BNIL);
		       arg1597_926 =
			  MAKE_PAIR(arg1598_927, arg1599_928);
		    }
		    l_exp_15_916 =
		       MAKE_PAIR(arg1596_925, arg1597_926);
		 }
		 {	/* Ast/app.scm 210 */
		    node_bglt l_node_207_917;
		    l_node_207_917 =
		       sexp__node_235_ast_sexp(l_exp_15_916, stack_20, loc_21,
		       CNST_TABLE_REF(((long) 4)));
		    {	/* Ast/app.scm 212 */
		       node_bglt l_var_28_918;
		       {	/* Ast/app.scm 213 */
			  let_var_6_bglt obj_1485;
			  obj_1485 =
			     (let_var_6_bglt) (l_node_207_917);
			  l_var_28_918 =
			     (((let_var_6_bglt) CREF(obj_1485))->body);
		       }
		       {	/* Ast/app.scm 213 */
			  obj_t app_919;
			  {	/* Ast/app.scm 216 */
			     obj_t arg1594_923;
			     {	/* Ast/app.scm 216 */
				obj_t arg1595_924;
				{	/* ./Ieee/pair-list.scm 5689 */
				   obj_t aux_1938;
				   aux_1938 =
				      (obj_t) (l_var_28_918);
				   arg1595_924 =
				      MAKE_PAIR(aux_1938, f_args_123_912);
				}
				arg1594_923 =
				   reverse__39___r4_pairs_and_lists_6_3(arg1595_924);
			     }
			     app_919 =
				make_fx_app_node_213_ast_app(loc_21, var_22, arg1594_923);
			  }
			  {	/* Ast/app.scm 214 */

			     {	/* Ast/app.scm 217 */
				bool_t test1591_920;
				test1591_920 =
				   is_a__118___object(
				   (obj_t) (l_var_28_918), var_ast_node);
				if (test1591_920)
				  {	/* Ast/app.scm 217 */
				     BUNSPEC;
				  }
				else
				  {	/* Ast/app.scm 217 */
				     {	/* Ast/app.scm 217 */
					obj_t arg1592_921;
					obj_t arg1593_922;
					arg1592_921 =
					   CNST_TABLE_REF(((long) 11));
					{	/* Ast/app.scm 217 */
					   obj_t aux_1947;
					   aux_1947 =
					      (obj_t) (l_var_28_918);
					   arg1593_922 =
					      __EVMEANING_ADDRESS(aux_1947);
					}
					define_primop_ref__105___evenv(arg1592_921, arg1593_922);
				     }
				     notify_assert_fail_37___eval(
					CNST_TABLE_REF(((long) 12)),
					CNST_TABLE_REF(((long) 13)),
					CNST_TABLE_REF(((long) 14)));
				     unbind_primop__163___evenv(
					CNST_TABLE_REF(((long) 11)));
				  }
			     }
			     {	/* Ast/app.scm 218 */
				let_var_6_bglt obj_1489;
				node_bglt val1371_1490;
				obj_1489 =
				   (let_var_6_bglt) (l_node_207_917);
				val1371_1490 =
				   (node_bglt) (app_919);
				((((let_var_6_bglt) CREF(obj_1489))->body) = ((node_bglt) val1371_1490), BUNSPEC);
			     }
			     return
				clean_user_node__130_ast_app(l_node_207_917);
			  }
		       }
		    }
		 }
	      }
	   }
	 else
	   {	/* Ast/app.scm 220 */
	      obj_t arg1606_935;
	      long arg1607_936;
	      obj_t arg1608_937;
	      arg1606_935 =
		 CDR(old_args_130_910);
	      arg1607_936 =
		 (arity_911 + ((long) 1));
	      {		/* Ast/app.scm 222 */
		 node_bglt arg1609_938;
		 arg1609_938 =
		    sexp__node_235_ast_sexp(
		    CAR(old_args_130_910), stack_20, loc_21,
		    CNST_TABLE_REF(((long) 4)));
		 {	/* ./Ieee/pair-list.scm 5689 */
		    obj_t aux_1966;
		    aux_1966 =
		       (obj_t) (arg1609_938);
		    arg1608_937 =
		       MAKE_PAIR(aux_1966, f_args_123_912);
		 }
	      }
	      {
		 obj_t f_args_123_1971;
		 long arity_1970;
		 obj_t old_args_130_1969;
		 old_args_130_1969 = arg1606_935;
		 arity_1970 = arg1607_936;
		 f_args_123_1971 = arg1608_937;
		 f_args_123_912 = f_args_123_1971;
		 arity_911 = arity_1970;
		 old_args_130_910 = old_args_130_1969;
		 goto loop_913;
	      }
	   }
      }
   }
}



/* make-args-list */
obj_t 
make_args_list_220_ast_app(obj_t args_941)
{
   AN_OBJECT;
   {	/* Ast/app.scm 201 */
      if (
	 NULLP(args_941))
	{	/* Ast/app.scm 202 */
	   return
	      CNST_TABLE_REF(((long) 3));
	}
      else
	{	/* Ast/app.scm 204 */
	   obj_t arg1614_944;
	   obj_t arg1615_945;
	   {	/* Ast/app.scm 204 */
	      obj_t arg1616_946;
	      obj_t arg1617_947;
	      arg1616_946 =
		 CNST_TABLE_REF(((long) 1));
	      {		/* Ast/app.scm 204 */
		 obj_t arg1618_948;
		 obj_t arg1619_949;
		 arg1618_948 =
		    CNST_TABLE_REF(((long) 15));
		 {	/* ./Ieee/pair-list.scm 5689 */
		    obj_t aux_1977;
		    aux_1977 =
		       CNST_TABLE_REF(((long) 16));
		    arg1619_949 =
		       MAKE_PAIR(aux_1977, BNIL);
		 }
		 arg1617_947 =
		    MAKE_PAIR(arg1618_948, arg1619_949);
	      }
	      arg1614_944 =
		 MAKE_PAIR(arg1616_946, arg1617_947);
	   }
	   {	/* Ast/app.scm 204 */
	      obj_t arg1620_950;
	      obj_t arg1621_951;
	      arg1620_950 =
		 CAR(args_941);
	      {		/* Ast/app.scm 204 */
		 obj_t arg1622_952;
		 arg1622_952 =
		    make_args_list_220_ast_app(
		    CDR(args_941));
		 arg1621_951 =
		    MAKE_PAIR(arg1622_952, BNIL);
	      }
	      arg1615_945 =
		 MAKE_PAIR(arg1620_950, arg1621_951);
	   }
	   return
	      MAKE_PAIR(arg1614_944, arg1615_945);
	}
   }
}



/* check-user-app */
long 
check_user_app_174_ast_app(node_bglt fun_24, obj_t args_25)
{
   AN_OBJECT;
   {	/* Ast/app.scm 230 */
      {		/* Ast/app.scm 231 */
	 bool_t test1625_956;
	 test1625_956 =
	    is_a__118___object(
	    (obj_t) (fun_24), var_ast_node);
	 if (test1625_956)
	   {	/* Ast/app.scm 237 */
	      variable_bglt var_957;
	      {		/* Ast/app.scm 237 */
		 var_bglt obj_1513;
		 obj_1513 =
		    (var_bglt) (fun_24);
		 var_957 =
		    (((var_bglt) CREF(obj_1513))->variable);
	      }
	      {		/* Ast/app.scm 237 */
		 value_bglt fun_958;
		 fun_958 =
		    (((variable_bglt) CREF(var_957))->value);
		 {	/* Ast/app.scm 238 */
		    long nb_args_51_959;
		    nb_args_51_959 =
		       list_length(args_25);
		    {	/* Ast/app.scm 239 */
		       long arity_960;
		       {	/* Ast/app.scm 241 */
			  bool_t test1633_968;
			  test1633_968 =
			     is_a__118___object(
			     (obj_t) (fun_958), fun_ast_var);
			  if (test1633_968)
			    {	/* Ast/app.scm 241 */
			       {	/* Ast/app.scm 242 */
				  fun_bglt obj_1516;
				  obj_1516 =
				     (fun_bglt) (fun_958);
				  arity_960 =
				     (((fun_bglt) CREF(obj_1516))->arity);
			       }
			    }
			  else
			    {	/* Ast/app.scm 241 */
			       arity_960 = ((long) -1);
			    }
		       }
		       {	/* Ast/app.scm 240 */

			  if (
			     (arity_960 == ((long) -1)))
			    {	/* Ast/app.scm 246 */
			       return ((long) 0);
			    }
			  else
			    {	/* Ast/app.scm 246 */
			       if (
				  (arity_960 >= ((long) 0)))
				 {	/* Ast/app.scm 248 */
				    return
				       (arity_960 - nb_args_51_959);
				 }
			       else
				 {	/* Ast/app.scm 248 */
				    {	/* Ast/app.scm 251 */
				       bool_t test_2005;
				       {	/* ./Ieee/fixnum.scm 7127 */
					  long aux_2006;
					  {	/* ./Ieee/fixnum.scm 7199 */
					     long aux_2009;
					     long aux_2007;
					     aux_2009 =
						(nb_args_51_959 + ((long) 1));
					     aux_2007 =
						NEG(arity_960);
					     aux_2006 =
						(aux_2007 - aux_2009);
					  }
					  test_2005 =
					     (aux_2006 <= ((long) 0));
				       }
				       if (test_2005)
					 {	/* Ast/app.scm 251 */
					    return ((long) 0);
					 }
				       else
					 {	/* Ast/app.scm 251 */
					    return ((long) 1);
					 }
				    }
				 }
			    }
		       }
		    }
		 }
	      }
	   }
	 else
	   {	/* Ast/app.scm 231 */
	      return ((long) 0);
	   }
      }
   }
}



/* method-init */
obj_t 
method_init_76_ast_app()
{
   AN_OBJECT;
   {	/* Ast/app.scm 14 */
      return BUNSPEC;
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_ast_app()
{
   AN_OBJECT;
   {	/* Ast/app.scm 14 */
      module_initialization_70_type_type(((long) 0), "AST_APP");
      module_initialization_70_ast_var(((long) 0), "AST_APP");
      module_initialization_70_ast_node(((long) 0), "AST_APP");
      module_initialization_70_tools_error(((long) 0), "AST_APP");
      module_initialization_70_tools_location(((long) 0), "AST_APP");
      module_initialization_70_tools_shape(((long) 0), "AST_APP");
      module_initialization_70_type_cache(((long) 0), "AST_APP");
      module_initialization_70_ast_sexp(((long) 0), "AST_APP");
      return
	 module_initialization_70_ast_ident(((long) 0), "AST_APP");
   }
}
