/*===========================================================================*/
/*   (Ast/apply.scm)                                                         */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;


static obj_t method_init_76_ast_apply();
extern long add_inlined_method__244___object(obj_t, obj_t, long);
extern node_bglt known_app_ly__node_26_ast_apply(obj_t, obj_t, node_bglt, node_bglt, obj_t);
extern obj_t find_location_loc_243_tools_location(obj_t, obj_t);
static obj_t make_fun_frame_37_ast_apply(fun_bglt);
extern obj_t type_type_type;
extern obj_t mark_symbol_non_user__17_ast_ident(obj_t);
extern obj_t let_var_6_ast_node;
extern obj_t var_ast_node;
extern node_bglt application__node_43_ast_app(obj_t, obj_t, obj_t, obj_t);
extern obj_t gensym___r4_symbols_6_4;
static obj_t make_fun_frame_default1465_206_ast_apply(fun_bglt);
static obj_t _applycation__node_33_ast_apply(obj_t, obj_t, obj_t, obj_t, obj_t);
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t module_initialization_70_ast_apply(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_tools_location(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_ast_sexp(long, char *);
extern obj_t module_initialization_70_ast_local(long, char *);
extern obj_t module_initialization_70_ast_app(long, char *);
extern obj_t module_initialization_70_ast_ident(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_symbols_6_4(long, char *);
extern node_bglt applycation__node_122_ast_apply(obj_t, obj_t, obj_t, obj_t);
extern obj_t _unsafe_arity__240_engine_param;
extern local_bglt make_local_svar_140_ast_local(obj_t, type_bglt);
extern long class_num_218___object(obj_t);
extern obj_t fun_ast_var;
static obj_t imported_modules_init_94_ast_apply();
static obj_t loop__120_ast_apply(obj_t, node_bglt, obj_t, obj_t, local_bglt, type_bglt, obj_t, obj_t);
extern obj_t app_ly_162_ast_node;
extern obj_t cfun_ast_var;
extern obj_t add_generic__110___object(obj_t, obj_t);
extern obj_t app_ast_node;
extern obj_t append_2_18___r4_pairs_and_lists_6_3(obj_t, obj_t);
static obj_t library_modules_init_112_ast_apply();
static obj_t toplevel_init_63_ast_apply();
extern node_bglt sexp__node_235_ast_sexp(obj_t, obj_t, obj_t, obj_t);
static obj_t _known_app_ly__node_80_ast_apply(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t open_input_string(obj_t);
extern obj_t sfun_ast_var;
extern node_bglt error_sexp__node_157_ast_sexp(obj_t, obj_t, obj_t);
static obj_t loop_ast_apply(node_bglt, obj_t, obj_t, local_bglt, type_bglt, obj_t, obj_t, obj_t);
extern obj_t shape_tools_shape(obj_t);
extern obj_t _classes__134___object;
extern obj_t read___reader(obj_t);
static obj_t _make_fun_frame_157_ast_apply(obj_t, obj_t);
static let_var_6_bglt fx_known_app_ly__node_158_ast_apply(obj_t, obj_t, node_bglt, node_bglt, obj_t, obj_t);
extern obj_t ____74_type_cache;
static obj_t require_initialization_114_ast_apply = BUNSPEC;
static obj_t _make_fun_frame_default1465_198_ast_apply(obj_t, obj_t);
static let_var_6_bglt va_known_app_ly__node_104_ast_apply(obj_t, obj_t, node_bglt, node_bglt, obj_t, obj_t);
static obj_t cnst_init_137_ast_apply();
extern obj_t reverse__39___r4_pairs_and_lists_6_3(obj_t);
static obj_t __cnst[14];

DEFINE_EXPORT_PROCEDURE(known_app_ly__node_env_252_ast_apply, _known_app_ly__node_80_ast_apply1834, _known_app_ly__node_80_ast_apply, 0L, 5);
DEFINE_STATIC_GENERIC(make_fun_frame_env_121_ast_apply, _make_fun_frame_157_ast_apply1835, _make_fun_frame_157_ast_apply, 0L, 1);
DEFINE_STATIC_PROCEDURE(make_fun_frame_default1465_env_227_ast_apply, _make_fun_frame_default1465_198_ast_apply1836, _make_fun_frame_default1465_198_ast_apply, 0L, 1);
DEFINE_EXPORT_PROCEDURE(applycation__node_env_238_ast_apply, _applycation__node_33_ast_apply1837, _applycation__node_33_ast_apply, 0L, 4);
DEFINE_STRING(string1829_ast_apply, string1829_ast_apply1838, "MAKE-FUN-FRAME-DEFAULT1465 AUX SET! BEGIN CAR QUOTE FAILURE CDR NULL? IF WRITE RUNNER VALUE APPLY ", 98);
DEFINE_STRING(string1828_ast_apply, string1828_ast_apply1839, "No method for this object", 25);
DEFINE_STRING(string1827_ast_apply, string1827_ast_apply1840, "apply", 5);
DEFINE_STRING(string1826_ast_apply, string1826_ast_apply1841, "Too many arguments provided", 27);
DEFINE_STRING(string1825_ast_apply, string1825_ast_apply1842, "Illegal `apply' form", 20);



/* module-initialization */
obj_t 
module_initialization_70_ast_apply(long checksum_1880, char *from_1881)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_ast_apply))
	{
	   require_initialization_114_ast_apply =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_ast_apply();
	   cnst_init_137_ast_apply();
	   imported_modules_init_94_ast_apply();
	   method_init_76_ast_apply();
	   toplevel_init_63_ast_apply();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_ast_apply()
{
   AN_OBJECT;
   {	/* Ast/apply.scm 14 */
      module_initialization_70___object(((long) 0), "AST_APPLY");
      module_initialization_70___r4_symbols_6_4(((long) 0), "AST_APPLY");
      module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "AST_APPLY");
      module_initialization_70___reader(((long) 0), "AST_APPLY");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_ast_apply()
{
   AN_OBJECT;
   {	/* Ast/apply.scm 14 */
      {		/* Ast/apply.scm 14 */
	 obj_t cnst_port_138_1873;
	 cnst_port_138_1873 =
	    open_input_string(string1829_ast_apply);
	 {
	    long i_1874;
	    i_1874 = ((long) 13);
	  loop_1875:
	    {	/* Ast/apply.scm 14 */
	       bool_t test1830_1876;
	       test1830_1876 =
		  (i_1874 == ((long) -1));
	       if (test1830_1876)
		 {	/* Ast/apply.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Ast/apply.scm 14 */
		    {	/* Ast/apply.scm 14 */
		       obj_t arg1831_1877;
		       {	/* Ast/apply.scm 14 */
			  obj_t list1832_1878;
			  list1832_1878 =
			     MAKE_PAIR(cnst_port_138_1873, BNIL);
			  arg1831_1877 =
			     read___reader(list1832_1878);
		       }
		       CNST_TABLE_SET(i_1874, arg1831_1877);
		    }
		    {	/* Ast/apply.scm 14 */
		       int aux_1879;
		       {	/* Ast/apply.scm 14 */
			  long aux_1900;
			  aux_1900 =
			     (i_1874 - ((long) 1));
			  aux_1879 =
			     (int) (aux_1900);
		       }
		       {
			  long i_1903;
			  i_1903 =
			     (long) (aux_1879);
			  i_1874 = i_1903;
			  goto loop_1875;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_ast_apply()
{
   AN_OBJECT;
   {	/* Ast/apply.scm 14 */
      return BUNSPEC;
   }
}



/* applycation->node */
node_bglt 
applycation__node_122_ast_apply(obj_t exp_1, obj_t stack_2, obj_t loc_3, obj_t site_4)
{
   AN_OBJECT;
   {	/* Ast/apply.scm 31 */
      {
	 obj_t proc_727;
	 obj_t arg_728;
	 if (
	    PAIRP(exp_1))
	   {	/* Ast/apply.scm 32 */
	      obj_t cdr_109_69_733;
	      cdr_109_69_733 =
		 CDR(exp_1);
	      {		/* Ast/apply.scm 32 */
		 bool_t test_1908;
		 {	/* ./Ieee/equiv.scm 5508 */
		    obj_t aux_1911;
		    obj_t aux_1909;
		    aux_1911 =
		       CNST_TABLE_REF(((long) 0));
		    aux_1909 =
		       CAR(exp_1);
		    test_1908 =
		       (aux_1909 == aux_1911);
		 }
		 if (test_1908)
		   {	/* Ast/apply.scm 32 */
		      if (
			 PAIRP(cdr_109_69_733))
			{	/* Ast/apply.scm 32 */
			   obj_t cdr_113_28_736;
			   cdr_113_28_736 =
			      CDR(cdr_109_69_733);
			   if (
			      PAIRP(cdr_113_28_736))
			     {	/* Ast/apply.scm 32 */
				bool_t test_1919;
				{	/* ./Ieee/equiv.scm 5508 */
				   obj_t aux_1920;
				   aux_1920 =
				      CDR(cdr_113_28_736);
				   test_1919 =
				      (aux_1920 == BNIL);
				}
				if (test_1919)
				  {	/* Ast/apply.scm 32 */
				     obj_t aux_1923;
				     proc_727 =
					CAR(cdr_109_69_733);
				     arg_728 =
					CAR(cdr_113_28_736);
				     {	/* Ast/apply.scm 34 */
					obj_t loc_745;
					loc_745 =
					   find_location_loc_243_tools_location(exp_1, loc_3);
					{	/* Ast/apply.scm 34 */
					   node_bglt proc_746;
					   {	/* Ast/apply.scm 37 */
					      obj_t arg1493_758;
					      obj_t arg1494_759;
					      arg1493_758 =
						 find_location_loc_243_tools_location(proc_727, loc_745);
					      arg1494_759 =
						 CNST_TABLE_REF(((long) 0));
					      proc_746 =
						 sexp__node_235_ast_sexp(proc_727, stack_2, arg1493_758, arg1494_759);
					   }
					   {	/* Ast/apply.scm 35 */
					      node_bglt arg_747;
					      {		/* Ast/apply.scm 41 */
						 obj_t arg1490_756;
						 obj_t arg1491_757;
						 arg1490_756 =
						    find_location_loc_243_tools_location(arg_728, loc_745);
						 arg1491_757 =
						    CNST_TABLE_REF(((long) 1));
						 arg_747 =
						    sexp__node_235_ast_sexp(arg_728, stack_2, arg1490_756, arg1491_757);
					      }
					      {		/* Ast/apply.scm 39 */

						 {	/* Ast/apply.scm 43 */
						    bool_t test1481_748;
						    {	/* Ast/apply.scm 43 */
						       bool_t test1486_753;
						       test1486_753 =
							  is_a__118___object(
							  (obj_t) (proc_746), var_ast_node);
						       if (test1486_753)
							 {	/* ./Ast/var.scm 658 */
							    obj_t aux_1934;
							    {	/* Ast/apply.scm 43 */
							       value_bglt aux_1935;
							       {	/* Ast/apply.scm 43 */
								  variable_bglt arg1489_755;
								  {	/* Ast/apply.scm 43 */
								     var_bglt obj_1368;
								     obj_1368 =
									(var_bglt) (proc_746);
								     arg1489_755 =
									(((var_bglt) CREF(obj_1368))->variable);
								  }
								  aux_1935 =
								     (((variable_bglt) CREF(arg1489_755))->value);
							       }
							       aux_1934 =
								  (obj_t) (aux_1935);
							    }
							    test1481_748 =
							       is_a__118___object(aux_1934, fun_ast_var);
							 }
						       else
							 {	/* Ast/apply.scm 43 */
							    test1481_748 = ((bool_t) 0);
							 }
						    }
						    if (test1481_748)
						      {		/* Ast/apply.scm 44 */
							 node_bglt aux_1942;
							 aux_1942 =
							    known_app_ly__node_26_ast_apply(stack_2, loc_745, proc_746, arg_747, site_4);
							 aux_1923 =
							    (obj_t) (aux_1942);
						      }
						    else
						      {		/* Ast/apply.scm 45 */
							 obj_t arg1483_750;
							 arg1483_750 = ____74_type_cache;
							 {	/* Ast/apply.scm 45 */
							    app_ly_162_bglt res1808_1383;
							    {	/* Ast/apply.scm 45 */
							       type_bglt type_1372;
							       type_1372 =
								  (type_bglt) (arg1483_750);
							       {	/* ./Ast/node.scm 792 */
								  app_ly_162_bglt new1261_1375;
								  new1261_1375 =
								     ((app_ly_162_bglt) BREF(GC_MALLOC(sizeof(struct app_ly_162))));
								  {	/* ./Ast/node.scm 792 */
								     long arg1719_1376;
								     arg1719_1376 =
									class_num_218___object(app_ly_162_ast_node);
								     {	/* ./Ast/node.scm 792 */
									obj_t obj_1381;
									obj_1381 =
									   (obj_t) (new1261_1375);
									(((obj_t) CREF(obj_1381))->header = MAKE_HEADER(arg1719_1376, 0), BUNSPEC);
								     }
								  }
								  {	/* ./Ast/node.scm 792 */
								     object_bglt aux_1950;
								     aux_1950 =
									(object_bglt) (new1261_1375);
								     OBJECT_WIDENING_SET(aux_1950, BFALSE);
								  }
								  ((((app_ly_162_bglt) CREF(new1261_1375))->loc) = ((obj_t) loc_745), BUNSPEC);
								  ((((app_ly_162_bglt) CREF(new1261_1375))->type) = ((type_bglt) type_1372), BUNSPEC);
								  ((((app_ly_162_bglt) CREF(new1261_1375))->fun) = ((node_bglt) proc_746), BUNSPEC);
								  ((((app_ly_162_bglt) CREF(new1261_1375))->arg) = ((node_bglt) arg_747), BUNSPEC);
								  res1808_1383 = new1261_1375;
							       }
							    }
							    aux_1923 =
							       (obj_t) (res1808_1383);
							 }
						      }
						 }
					      }
					   }
					}
				     }
				     return
					(node_bglt) (aux_1923);
				  }
				else
				  {	/* Ast/apply.scm 32 */
				   tag_102_241_730:
				     {	/* Ast/apply.scm 51 */
					obj_t arg1496_761;
					arg1496_761 =
					   find_location_loc_243_tools_location(exp_1, loc_3);
					return
					   error_sexp__node_157_ast_sexp(string1825_ast_apply, exp_1, arg1496_761);
				     }
				  }
			     }
			   else
			     {	/* Ast/apply.scm 32 */
				goto tag_102_241_730;
			     }
			}
		      else
			{	/* Ast/apply.scm 32 */
			   goto tag_102_241_730;
			}
		   }
		 else
		   {	/* Ast/apply.scm 32 */
		      goto tag_102_241_730;
		   }
	      }
	   }
	 else
	   {	/* Ast/apply.scm 32 */
	      goto tag_102_241_730;
	   }
      }
   }
}



/* _applycation->node */
obj_t 
_applycation__node_33_ast_apply(obj_t env_1843, obj_t exp_1844, obj_t stack_1845, obj_t loc_1846, obj_t site_1847)
{
   AN_OBJECT;
   {	/* Ast/apply.scm 31 */
      {		/* Ast/apply.scm 31 */
	 node_bglt aux_1963;
	 aux_1963 =
	    applycation__node_122_ast_apply(exp_1844, stack_1845, loc_1846, site_1847);
	 return
	    (obj_t) (aux_1963);
      }
   }
}



/* known-app-ly->node */
node_bglt 
known_app_ly__node_26_ast_apply(obj_t stack_9, obj_t loc_10, node_bglt proc_11, node_bglt arg_12, obj_t site_13)
{
   AN_OBJECT;
   {	/* Ast/apply.scm 101 */
      {		/* Ast/apply.scm 102 */
	 value_bglt fun_762;
	 {	/* Ast/apply.scm 102 */
	    variable_bglt arg1499_767;
	    {	/* Ast/apply.scm 102 */
	       var_bglt obj_1384;
	       obj_1384 =
		  (var_bglt) (proc_11);
	       arg1499_767 =
		  (((var_bglt) CREF(obj_1384))->variable);
	    }
	    fun_762 =
	       (((variable_bglt) CREF(arg1499_767))->value);
	 }
	 {	/* Ast/apply.scm 102 */
	    long arity_763;
	    {	/* Ast/apply.scm 103 */
	       fun_bglt obj_1386;
	       obj_1386 =
		  (fun_bglt) (fun_762);
	       arity_763 =
		  (((fun_bglt) CREF(obj_1386))->arity);
	    }
	    {	/* Ast/apply.scm 103 */
	       obj_t frame_764;
	       frame_764 =
		  make_fun_frame_37_ast_apply(
		  (fun_bglt) (fun_762));
	       {	/* Ast/apply.scm 104 */

		  if (
		     (arity_763 > ((long) 0)))
		    {	/* Ast/apply.scm 106 */
		       {	/* Ast/apply.scm 107 */
			  let_var_6_bglt aux_1975;
			  aux_1975 =
			     fx_known_app_ly__node_158_ast_apply(stack_9, loc_10, proc_11, arg_12, frame_764, site_13);
			  return
			     (node_bglt) (aux_1975);
		       }
		    }
		  else
		    {	/* Ast/apply.scm 106 */
		       if (
			  (arity_763 == ((long) 0)))
			 {	/* Ast/apply.scm 108 */
			    {	/* Ast/apply.scm 117 */
			       obj_t arg1500_1397;
			       {	/* Ast/apply.scm 117 */
				  obj_t list1501_1398;
				  {	/* Ast/apply.scm 117 */
				     obj_t aux_1980;
				     aux_1980 =
					(obj_t) (proc_11);
				     list1501_1398 =
					MAKE_PAIR(aux_1980, BNIL);
				  }
				  arg1500_1397 = list1501_1398;
			       }
			       return
				  sexp__node_235_ast_sexp(arg1500_1397, stack_9, loc_10, site_13);
			    }
			 }
		       else
			 {	/* Ast/apply.scm 108 */
			    {	/* Ast/apply.scm 111 */
			       let_var_6_bglt aux_1984;
			       aux_1984 =
				  va_known_app_ly__node_104_ast_apply(stack_9, loc_10, proc_11, arg_12, frame_764, site_13);
			       return
				  (node_bglt) (aux_1984);
			    }
			 }
		    }
	       }
	    }
	 }
      }
   }
}



/* _known-app-ly->node */
obj_t 
_known_app_ly__node_80_ast_apply(obj_t env_1848, obj_t stack_1849, obj_t loc_1850, obj_t proc_1851, obj_t arg_1852, obj_t site_1853)
{
   AN_OBJECT;
   {	/* Ast/apply.scm 101 */
      {		/* Ast/apply.scm 101 */
	 node_bglt aux_1987;
	 aux_1987 =
	    known_app_ly__node_26_ast_apply(stack_1849, loc_1850,
	    (node_bglt) (proc_1851),
	    (node_bglt) (arg_1852), site_1853);
	 return
	    (obj_t) (aux_1987);
      }
   }
}



/* fx-known-app-ly->node */
let_var_6_bglt 
fx_known_app_ly__node_158_ast_apply(obj_t stack_20, obj_t loc_21, node_bglt proc_22, node_bglt arg_23, obj_t frame_24, obj_t site_25)
{
   AN_OBJECT;
   {	/* Ast/apply.scm 138 */
      {		/* Ast/apply.scm 139 */
	 local_bglt runner_770;
	 type_bglt type_771;
	 {	/* Ast/apply.scm 139 */
	    obj_t arg1611_881;
	    {	/* Ast/apply.scm 139 */
	       obj_t arg1612_882;
	       arg1612_882 =
		  PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4,
		  CNST_TABLE_REF(((long) 2)), BEOA);
	       arg1611_881 =
		  mark_symbol_non_user__17_ast_ident(arg1612_882);
	    }
	    runner_770 =
	       make_local_svar_140_ast_local(arg1611_881,
	       (type_bglt) (____74_type_cache));
	 }
	 type_771 =
	    (((node_bglt) CREF(proc_22))->type);
	 {	/* Ast/apply.scm 142 */
	    obj_t val1084_1405;
	    val1084_1405 =
	       CNST_TABLE_REF(((long) 3));
	    ((((local_bglt) CREF(runner_770))->access) = ((obj_t) val1084_1405), BUNSPEC);
	 }
	 {	/* Ast/apply.scm 143 */
	    obj_t arg1505_775;
	    obj_t arg1506_776;
	    {	/* Ast/apply.scm 146 */
	       obj_t arg1508_777;
	       {	/* ./Ieee/pair-list.scm 5689 */
		  obj_t aux_2003;
		  obj_t aux_2001;
		  aux_2003 =
		     (obj_t) (arg_23);
		  aux_2001 =
		     (obj_t) (runner_770);
		  arg1508_777 =
		     MAKE_PAIR(aux_2001, aux_2003);
	       }
	       {	/* Ast/apply.scm 146 */
		  obj_t list1509_778;
		  list1509_778 =
		     MAKE_PAIR(arg1508_777, BNIL);
		  arg1505_775 = list1509_778;
	       }
	    }
	    arg1506_776 =
	       loop__120_ast_apply(site_25, proc_22, frame_24, stack_20, runner_770, type_771, loc_21, frame_24);
	    {	/* Ast/apply.scm 143 */
	       let_var_6_bglt res1815_1577;
	       {	/* Ast/apply.scm 143 */
		  obj_t key_1562;
		  node_bglt body_1564;
		  key_1562 =
		     BINT(((long) -1));
		  body_1564 =
		     (node_bglt) (arg1506_776);
		  {	/* ./Ast/node.scm 859 */
		     let_var_6_bglt new1373_1566;
		     new1373_1566 =
			((let_var_6_bglt) BREF(GC_MALLOC(sizeof(struct let_var_6))));
		     {	/* ./Ast/node.scm 859 */
			long arg1700_1567;
			arg1700_1567 =
			   class_num_218___object(let_var_6_ast_node);
			{	/* ./Ast/node.scm 859 */
			   obj_t obj_1575;
			   obj_1575 =
			      (obj_t) (new1373_1566);
			   (((obj_t) CREF(obj_1575))->header = MAKE_HEADER(arg1700_1567, 0), BUNSPEC);
			}
		     }
		     {	/* ./Ast/node.scm 859 */
			object_bglt aux_2014;
			aux_2014 =
			   (object_bglt) (new1373_1566);
			OBJECT_WIDENING_SET(aux_2014, BFALSE);
		     }
		     ((((let_var_6_bglt) CREF(new1373_1566))->loc) = ((obj_t) loc_21), BUNSPEC);
		     ((((let_var_6_bglt) CREF(new1373_1566))->type) = ((type_bglt) type_771), BUNSPEC);
		     ((((let_var_6_bglt) CREF(new1373_1566))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
		     ((((let_var_6_bglt) CREF(new1373_1566))->key) = ((obj_t) key_1562), BUNSPEC);
		     ((((let_var_6_bglt) CREF(new1373_1566))->bindings) = ((obj_t) arg1505_775), BUNSPEC);
		     ((((let_var_6_bglt) CREF(new1373_1566))->body) = ((node_bglt) body_1564), BUNSPEC);
		     ((((let_var_6_bglt) CREF(new1373_1566))->removable__42) = ((bool_t) ((bool_t) 1)), BUNSPEC);
		     res1815_1577 = new1373_1566;
		  }
	       }
	       return res1815_1577;
	    }
	 }
      }
   }
}



/* loop' */
obj_t 
loop__120_ast_apply(obj_t site_1872, node_bglt proc_1871, obj_t frame_1870, obj_t stack_1869, local_bglt runner_1868, type_bglt type_1867, obj_t loc_1866, obj_t locals_779)
{
   AN_OBJECT;
   {	/* Ast/apply.scm 147 */
      if (
	 NULLP(locals_779))
	{	/* Ast/apply.scm 149 */
	   node_bglt app_782;
	   {	/* Ast/apply.scm 151 */
	      obj_t arg1549_815;
	      obj_t arg1550_816;
	      {		/* Ast/apply.scm 151 */
		 obj_t arg1551_817;
		 {	/* Ast/apply.scm 151 */
		    obj_t arg1552_818;
		    if (
		       NULLP(frame_1870))
		      {		/* Ast/apply.scm 151 */
			 arg1552_818 = BNIL;
		      }
		    else
		      {		/* Ast/apply.scm 151 */
			 obj_t head1441_822;
			 head1441_822 =
			    MAKE_PAIR(BNIL, BNIL);
			 {
			    obj_t l1439_823;
			    obj_t tail1442_824;
			    l1439_823 = frame_1870;
			    tail1442_824 = head1441_822;
			  lname1440_825:
			    if (
			       NULLP(l1439_823))
			      {		/* Ast/apply.scm 151 */
				 arg1552_818 =
				    CDR(head1441_822);
			      }
			    else
			      {		/* Ast/apply.scm 152 */
				 obj_t newtail1443_827;
				 {	/* Ast/apply.scm 152 */
				    var_bglt arg1557_829;
				    {	/* Ast/apply.scm 152 */
				       obj_t local_831;
				       local_831 =
					  CAR(l1439_823);
				       {	/* Ast/apply.scm 152 */
					  type_bglt arg1560_833;
					  {	/* Ast/apply.scm 154 */
					     local_bglt obj_1416;
					     obj_1416 =
						(local_bglt) (local_831);
					     arg1560_833 =
						(((local_bglt) CREF(obj_1416))->type);
					  }
					  {	/* Ast/apply.scm 152 */
					     var_bglt res1809_1427;
					     {	/* Ast/apply.scm 152 */
						variable_bglt variable_1419;
						variable_1419 =
						   (variable_bglt) (local_831);
						{	/* ./Ast/node.scm 766 */
						   var_bglt new1210_1420;
						   new1210_1420 =
						      ((var_bglt) BREF(GC_MALLOC(sizeof(struct var))));
						   {	/* ./Ast/node.scm 766 */
						      long arg1729_1421;
						      arg1729_1421 =
							 class_num_218___object(var_ast_node);
						      {		/* ./Ast/node.scm 766 */
							 obj_t obj_1425;
							 obj_1425 =
							    (obj_t) (new1210_1420);
							 (((obj_t) CREF(obj_1425))->header = MAKE_HEADER(arg1729_1421, 0), BUNSPEC);
						      }
						   }
						   {	/* ./Ast/node.scm 766 */
						      object_bglt aux_2040;
						      aux_2040 =
							 (object_bglt) (new1210_1420);
						      OBJECT_WIDENING_SET(aux_2040, BFALSE);
						   }
						   ((((var_bglt) CREF(new1210_1420))->loc) = ((obj_t) loc_1866), BUNSPEC);
						   ((((var_bglt) CREF(new1210_1420))->type) = ((type_bglt) arg1560_833), BUNSPEC);
						   ((((var_bglt) CREF(new1210_1420))->variable) = ((variable_bglt) variable_1419), BUNSPEC);
						   res1809_1427 = new1210_1420;
						}
					     }
					     arg1557_829 = res1809_1427;
					  }
				       }
				    }
				    {	/* ./Ieee/pair-list.scm 5689 */
				       obj_t aux_2046;
				       aux_2046 =
					  (obj_t) (arg1557_829);
				       newtail1443_827 =
					  MAKE_PAIR(aux_2046, BNIL);
				    }
				 }
				 SET_CDR(tail1442_824, newtail1443_827);
				 {
				    obj_t tail1442_2052;
				    obj_t l1439_2050;
				    l1439_2050 =
				       CDR(l1439_823);
				    tail1442_2052 = newtail1443_827;
				    tail1442_824 = tail1442_2052;
				    l1439_823 = l1439_2050;
				    goto lname1440_825;
				 }
			      }
			 }
		      }
		    arg1551_817 =
		       append_2_18___r4_pairs_and_lists_6_3(arg1552_818, BNIL);
		 }
		 {	/* ./Ieee/pair-list.scm 5689 */
		    obj_t aux_2054;
		    aux_2054 =
		       (obj_t) (proc_1871);
		    arg1549_815 =
		       MAKE_PAIR(aux_2054, arg1551_817);
		 }
	      }
	      arg1550_816 =
		 CNST_TABLE_REF(((long) 1));
	      app_782 =
		 application__node_43_ast_app(arg1549_815, stack_1869, loc_1866, arg1550_816);
	   }
	   if (
	      CBOOL(_unsafe_arity__240_engine_param))
	     {	/* Ast/apply.scm 160 */
		return
		   (obj_t) (app_782);
	     }
	   else
	     {	/* Ast/apply.scm 163 */
		obj_t arg1511_783;
		{	/* Ast/apply.scm 163 */
		   obj_t arg1512_784;
		   obj_t arg1513_785;
		   arg1512_784 =
		      CNST_TABLE_REF(((long) 4));
		   {	/* Ast/apply.scm 163 */
		      obj_t arg1514_786;
		      obj_t arg1515_787;
		      {		/* Ast/apply.scm 163 */
			 obj_t arg1516_788;
			 obj_t arg1517_789;
			 arg1516_788 =
			    CNST_TABLE_REF(((long) 5));
			 {	/* Ast/apply.scm 163 */
			    obj_t arg1519_790;
			    {	/* Ast/apply.scm 163 */
			       obj_t arg1521_792;
			       obj_t arg1522_793;
			       arg1521_792 =
				  CNST_TABLE_REF(((long) 6));
			       {	/* Ast/apply.scm 164 */
				  var_bglt arg1523_794;
				  {	/* Ast/apply.scm 164 */
				     type_bglt arg1527_797;
				     arg1527_797 =
					(((local_bglt) CREF(runner_1868))->type);
				     {	/* Ast/apply.scm 164 */
					var_bglt res1810_1446;
					{	/* Ast/apply.scm 164 */
					   variable_bglt variable_1438;
					   variable_1438 =
					      (variable_bglt) (runner_1868);
					   {	/* ./Ast/node.scm 766 */
					      var_bglt new1210_1439;
					      new1210_1439 =
						 ((var_bglt) BREF(GC_MALLOC(sizeof(struct var))));
					      {		/* ./Ast/node.scm 766 */
						 long arg1729_1440;
						 arg1729_1440 =
						    class_num_218___object(var_ast_node);
						 {	/* ./Ast/node.scm 766 */
						    obj_t obj_1444;
						    obj_1444 =
						       (obj_t) (new1210_1439);
						    (((obj_t) CREF(obj_1444))->header = MAKE_HEADER(arg1729_1440, 0), BUNSPEC);
						 }
					      }
					      {		/* ./Ast/node.scm 766 */
						 object_bglt aux_2071;
						 aux_2071 =
						    (object_bglt) (new1210_1439);
						 OBJECT_WIDENING_SET(aux_2071, BFALSE);
					      }
					      ((((var_bglt) CREF(new1210_1439))->loc) = ((obj_t) loc_1866), BUNSPEC);
					      ((((var_bglt) CREF(new1210_1439))->type) = ((type_bglt) arg1527_797), BUNSPEC);
					      ((((var_bglt) CREF(new1210_1439))->variable) = ((variable_bglt) variable_1438), BUNSPEC);
					      res1810_1446 = new1210_1439;
					   }
					}
					arg1523_794 = res1810_1446;
				     }
				  }
				  {	/* ./Ieee/pair-list.scm 5689 */
				     obj_t aux_2077;
				     aux_2077 =
					(obj_t) (arg1523_794);
				     arg1522_793 =
					MAKE_PAIR(aux_2077, BNIL);
				  }
			       }
			       arg1519_790 =
				  MAKE_PAIR(arg1521_792, arg1522_793);
			    }
			    arg1517_789 =
			       MAKE_PAIR(arg1519_790, BNIL);
			 }
			 arg1514_786 =
			    MAKE_PAIR(arg1516_788, arg1517_789);
		      }
		      {		/* Ast/apply.scm 169 */
			 obj_t arg1529_799;
			 {	/* Ast/apply.scm 169 */
			    obj_t arg1530_800;
			    {	/* Ast/apply.scm 169 */
			       obj_t arg1533_802;
			       obj_t arg1534_803;
			       arg1533_802 =
				  CNST_TABLE_REF(((long) 7));
			       {	/* Ast/apply.scm 169 */
				  obj_t arg1536_805;
				  {	/* Ast/apply.scm 169 */
				     obj_t arg1539_807;
				     {	/* Ast/apply.scm 171 */
					obj_t arg1540_808;
					{	/* Ast/apply.scm 171 */
					   obj_t arg1543_810;
					   obj_t arg1544_811;
					   arg1543_810 =
					      CNST_TABLE_REF(((long) 8));
					   {	/* Ast/apply.scm 171 */
					      obj_t arg1545_812;
					      {		/* Ast/apply.scm 171 */
						 obj_t aux_2085;
						 {	/* Ast/apply.scm 171 */
						    variable_bglt aux_2086;
						    {	/* Ast/apply.scm 171 */
						       var_bglt obj_1455;
						       obj_1455 =
							  (var_bglt) (proc_1871);
						       aux_2086 =
							  (((var_bglt) CREF(obj_1455))->variable);
						    }
						    aux_2085 =
						       (obj_t) (aux_2086);
						 }
						 arg1545_812 =
						    shape_tools_shape(aux_2085);
					      }
					      arg1544_811 =
						 MAKE_PAIR(arg1545_812, BNIL);
					   }
					   arg1540_808 =
					      MAKE_PAIR(arg1543_810, arg1544_811);
					}
					arg1539_807 =
					   MAKE_PAIR(arg1540_808, BNIL);
				     }
				     arg1536_805 =
					MAKE_PAIR(string1826_ast_apply, arg1539_807);
				  }
				  arg1534_803 =
				     MAKE_PAIR(string1827_ast_apply, arg1536_805);
			       }
			       arg1530_800 =
				  MAKE_PAIR(arg1533_802, arg1534_803);
			    }
			    arg1529_799 =
			       MAKE_PAIR(arg1530_800, BNIL);
			 }
			 {	/* ./Ieee/pair-list.scm 5689 */
			    obj_t aux_2098;
			    aux_2098 =
			       (obj_t) (app_782);
			    arg1515_787 =
			       MAKE_PAIR(aux_2098, arg1529_799);
			 }
		      }
		      arg1513_785 =
			 MAKE_PAIR(arg1514_786, arg1515_787);
		   }
		   arg1511_783 =
		      MAKE_PAIR(arg1512_784, arg1513_785);
		}
		{	/* Ast/apply.scm 162 */
		   node_bglt aux_2103;
		   aux_2103 =
		      sexp__node_235_ast_sexp(arg1511_783, stack_1869, loc_1866, site_1872);
		   return
		      (obj_t) (aux_2103);
		}
	     }
	}
      else
	{	/* Ast/apply.scm 175 */
	   obj_t arg1565_838;
	   obj_t arg1566_839;
	   {	/* Ast/apply.scm 179 */
	      obj_t arg1567_840;
	      {		/* Ast/apply.scm 179 */
		 obj_t arg1569_842;
		 node_bglt arg1571_843;
		 arg1569_842 =
		    CAR(locals_779);
		 {	/* Ast/apply.scm 181 */
		    obj_t arg1572_844;
		    obj_t arg1573_845;
		    {	/* Ast/apply.scm 181 */
		       obj_t arg1576_846;
		       obj_t arg1577_847;
		       arg1576_846 =
			  CNST_TABLE_REF(((long) 9));
		       {	/* Ast/apply.scm 182 */
			  var_bglt arg1578_848;
			  {	/* Ast/apply.scm 182 */
			     type_bglt arg1581_851;
			     arg1581_851 =
				(((local_bglt) CREF(runner_1868))->type);
			     {	/* Ast/apply.scm 182 */
				var_bglt res1811_1488;
				{	/* Ast/apply.scm 182 */
				   variable_bglt variable_1480;
				   variable_1480 =
				      (variable_bglt) (runner_1868);
				   {	/* ./Ast/node.scm 766 */
				      var_bglt new1210_1481;
				      new1210_1481 =
					 ((var_bglt) BREF(GC_MALLOC(sizeof(struct var))));
				      {		/* ./Ast/node.scm 766 */
					 long arg1729_1482;
					 arg1729_1482 =
					    class_num_218___object(var_ast_node);
					 {	/* ./Ast/node.scm 766 */
					    obj_t obj_1486;
					    obj_1486 =
					       (obj_t) (new1210_1481);
					    (((obj_t) CREF(obj_1486))->header = MAKE_HEADER(arg1729_1482, 0), BUNSPEC);
					 }
				      }
				      {		/* ./Ast/node.scm 766 */
					 object_bglt aux_2114;
					 aux_2114 =
					    (object_bglt) (new1210_1481);
					 OBJECT_WIDENING_SET(aux_2114, BFALSE);
				      }
				      ((((var_bglt) CREF(new1210_1481))->loc) = ((obj_t) loc_1866), BUNSPEC);
				      ((((var_bglt) CREF(new1210_1481))->type) = ((type_bglt) arg1581_851), BUNSPEC);
				      ((((var_bglt) CREF(new1210_1481))->variable) = ((variable_bglt) variable_1480), BUNSPEC);
				      res1811_1488 = new1210_1481;
				   }
				}
				arg1578_848 = res1811_1488;
			     }
			  }
			  {	/* ./Ieee/pair-list.scm 5689 */
			     obj_t aux_2120;
			     aux_2120 =
				(obj_t) (arg1578_848);
			     arg1577_847 =
				MAKE_PAIR(aux_2120, BNIL);
			  }
		       }
		       arg1572_844 =
			  MAKE_PAIR(arg1576_846, arg1577_847);
		    }
		    arg1573_845 =
		       CNST_TABLE_REF(((long) 1));
		    arg1571_843 =
		       sexp__node_235_ast_sexp(arg1572_844, stack_1869, loc_1866, arg1573_845);
		 }
		 {	/* ./Ieee/pair-list.scm 5689 */
		    obj_t aux_2126;
		    aux_2126 =
		       (obj_t) (arg1571_843);
		    arg1567_840 =
		       MAKE_PAIR(arg1569_842, aux_2126);
		 }
	      }
	      {		/* Ast/apply.scm 178 */
		 obj_t list1568_841;
		 list1568_841 =
		    MAKE_PAIR(arg1567_840, BNIL);
		 arg1565_838 = list1568_841;
	      }
	   }
	   {	/* Ast/apply.scm 189 */
	      bool_t test_2130;
	      {		/* ./Ieee/pair-list.scm 5912 */
		 obj_t aux_2131;
		 aux_2131 =
		    CDR(locals_779);
		 test_2130 =
		    NULLP(aux_2131);
	      }
	      if (test_2130)
		{	/* Ast/apply.scm 189 */
		   arg1566_839 =
		      loop__120_ast_apply(site_1872, proc_1871, frame_1870, stack_1869, runner_1868, type_1867, loc_1866,
		      CDR(locals_779));
		}
	      else
		{	/* Ast/apply.scm 192 */
		   obj_t arg1585_855;
		   obj_t arg1586_856;
		   {	/* Ast/apply.scm 192 */
		      obj_t arg1587_857;
		      obj_t arg1588_858;
		      arg1587_857 =
			 CNST_TABLE_REF(((long) 10));
		      {		/* Ast/apply.scm 193 */
			 obj_t arg1589_859;
			 obj_t arg1590_860;
			 {	/* Ast/apply.scm 193 */
			    obj_t arg1591_861;
			    obj_t arg1592_862;
			    arg1591_861 =
			       CNST_TABLE_REF(((long) 11));
			    {	/* Ast/apply.scm 193 */
			       var_bglt arg1593_863;
			       obj_t arg1594_864;
			       {	/* Ast/apply.scm 193 */
				  type_bglt arg1596_866;
				  arg1596_866 =
				     (((local_bglt) CREF(runner_1868))->type);
				  {	/* Ast/apply.scm 193 */
				     var_bglt res1812_1510;
				     {	/* Ast/apply.scm 193 */
					variable_bglt variable_1502;
					variable_1502 =
					   (variable_bglt) (runner_1868);
					{	/* ./Ast/node.scm 766 */
					   var_bglt new1210_1503;
					   new1210_1503 =
					      ((var_bglt) BREF(GC_MALLOC(sizeof(struct var))));
					   {	/* ./Ast/node.scm 766 */
					      long arg1729_1504;
					      arg1729_1504 =
						 class_num_218___object(var_ast_node);
					      {		/* ./Ast/node.scm 766 */
						 obj_t obj_1508;
						 obj_1508 =
						    (obj_t) (new1210_1503);
						 (((obj_t) CREF(obj_1508))->header = MAKE_HEADER(arg1729_1504, 0), BUNSPEC);
					      }
					   }
					   {	/* ./Ast/node.scm 766 */
					      object_bglt aux_2144;
					      aux_2144 =
						 (object_bglt) (new1210_1503);
					      OBJECT_WIDENING_SET(aux_2144, BFALSE);
					   }
					   ((((var_bglt) CREF(new1210_1503))->loc) = ((obj_t) loc_1866), BUNSPEC);
					   ((((var_bglt) CREF(new1210_1503))->type) = ((type_bglt) arg1596_866), BUNSPEC);
					   ((((var_bglt) CREF(new1210_1503))->variable) = ((variable_bglt) variable_1502), BUNSPEC);
					   res1812_1510 = new1210_1503;
					}
				     }
				     arg1593_863 = res1812_1510;
				  }
			       }
			       {	/* Ast/apply.scm 197 */
				  obj_t arg1598_868;
				  {	/* Ast/apply.scm 197 */
				     obj_t arg1600_870;
				     obj_t arg1601_871;
				     arg1600_870 =
					CNST_TABLE_REF(((long) 6));
				     {	/* Ast/apply.scm 198 */
					var_bglt arg1602_872;
					{	/* Ast/apply.scm 198 */
					   type_bglt arg1605_875;
					   arg1605_875 =
					      (((local_bglt) CREF(runner_1868))->type);
					   {	/* Ast/apply.scm 198 */
					      var_bglt res1813_1522;
					      {		/* Ast/apply.scm 198 */
						 variable_bglt variable_1514;
						 variable_1514 =
						    (variable_bglt) (runner_1868);
						 {	/* ./Ast/node.scm 766 */
						    var_bglt new1210_1515;
						    new1210_1515 =
						       ((var_bglt) BREF(GC_MALLOC(sizeof(struct var))));
						    {	/* ./Ast/node.scm 766 */
						       long arg1729_1516;
						       arg1729_1516 =
							  class_num_218___object(var_ast_node);
						       {	/* ./Ast/node.scm 766 */
							  obj_t obj_1520;
							  obj_1520 =
							     (obj_t) (new1210_1515);
							  (((obj_t) CREF(obj_1520))->header = MAKE_HEADER(arg1729_1516, 0), BUNSPEC);
						       }
						    }
						    {	/* ./Ast/node.scm 766 */
						       object_bglt aux_2157;
						       aux_2157 =
							  (object_bglt) (new1210_1515);
						       OBJECT_WIDENING_SET(aux_2157, BFALSE);
						    }
						    ((((var_bglt) CREF(new1210_1515))->loc) = ((obj_t) loc_1866), BUNSPEC);
						    ((((var_bglt) CREF(new1210_1515))->type) = ((type_bglt) arg1605_875), BUNSPEC);
						    ((((var_bglt) CREF(new1210_1515))->variable) = ((variable_bglt) variable_1514), BUNSPEC);
						    res1813_1522 = new1210_1515;
						 }
					      }
					      arg1602_872 = res1813_1522;
					   }
					}
					{	/* ./Ieee/pair-list.scm 5689 */
					   obj_t aux_2163;
					   aux_2163 =
					      (obj_t) (arg1602_872);
					   arg1601_871 =
					      MAKE_PAIR(aux_2163, BNIL);
					}
				     }
				     arg1598_868 =
					MAKE_PAIR(arg1600_870, arg1601_871);
				  }
				  arg1594_864 =
				     MAKE_PAIR(arg1598_868, BNIL);
			       }
			       {	/* ./Ieee/pair-list.scm 5689 */
				  obj_t aux_2168;
				  aux_2168 =
				     (obj_t) (arg1593_863);
				  arg1592_862 =
				     MAKE_PAIR(aux_2168, arg1594_864);
			       }
			    }
			    arg1589_859 =
			       MAKE_PAIR(arg1591_861, arg1592_862);
			 }
			 {	/* Ast/apply.scm 202 */
			    obj_t arg1607_877;
			    arg1607_877 =
			       loop__120_ast_apply(site_1872, proc_1871, frame_1870, stack_1869, runner_1868, type_1867, loc_1866,
			       CDR(locals_779));
			    arg1590_860 =
			       MAKE_PAIR(arg1607_877, BNIL);
			 }
			 arg1588_858 =
			    MAKE_PAIR(arg1589_859, arg1590_860);
		      }
		      arg1585_855 =
			 MAKE_PAIR(arg1587_857, arg1588_858);
		   }
		   arg1586_856 =
		      CNST_TABLE_REF(((long) 1));
		   {	/* Ast/apply.scm 191 */
		      node_bglt aux_2178;
		      aux_2178 =
			 sexp__node_235_ast_sexp(arg1585_855, stack_1869, loc_1866, arg1586_856);
		      arg1566_839 =
			 (obj_t) (aux_2178);
		   }
		}
	   }
	   {	/* Ast/apply.scm 175 */
	      let_var_6_bglt res1814_1558;
	      {		/* Ast/apply.scm 175 */
		 obj_t key_1543;
		 node_bglt body_1545;
		 key_1543 =
		    BINT(((long) -1));
		 body_1545 =
		    (node_bglt) (arg1566_839);
		 {	/* ./Ast/node.scm 859 */
		    let_var_6_bglt new1373_1547;
		    new1373_1547 =
		       ((let_var_6_bglt) BREF(GC_MALLOC(sizeof(struct let_var_6))));
		    {	/* ./Ast/node.scm 859 */
		       long arg1700_1548;
		       arg1700_1548 =
			  class_num_218___object(let_var_6_ast_node);
		       {	/* ./Ast/node.scm 859 */
			  obj_t obj_1556;
			  obj_1556 =
			     (obj_t) (new1373_1547);
			  (((obj_t) CREF(obj_1556))->header = MAKE_HEADER(arg1700_1548, 0), BUNSPEC);
		       }
		    }
		    {	/* ./Ast/node.scm 859 */
		       object_bglt aux_2187;
		       aux_2187 =
			  (object_bglt) (new1373_1547);
		       OBJECT_WIDENING_SET(aux_2187, BFALSE);
		    }
		    ((((let_var_6_bglt) CREF(new1373_1547))->loc) = ((obj_t) loc_1866), BUNSPEC);
		    ((((let_var_6_bglt) CREF(new1373_1547))->type) = ((type_bglt) type_1867), BUNSPEC);
		    ((((let_var_6_bglt) CREF(new1373_1547))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
		    ((((let_var_6_bglt) CREF(new1373_1547))->key) = ((obj_t) key_1543), BUNSPEC);
		    ((((let_var_6_bglt) CREF(new1373_1547))->bindings) = ((obj_t) arg1565_838), BUNSPEC);
		    ((((let_var_6_bglt) CREF(new1373_1547))->body) = ((node_bglt) body_1545), BUNSPEC);
		    ((((let_var_6_bglt) CREF(new1373_1547))->removable__42) = ((bool_t) ((bool_t) 1)), BUNSPEC);
		    res1814_1558 = new1373_1547;
		 }
	      }
	      return
		 (obj_t) (res1814_1558);
	   }
	}
   }
}



/* va-known-app-ly->node */
let_var_6_bglt 
va_known_app_ly__node_104_ast_apply(obj_t stack_26, obj_t loc_27, node_bglt proc_28, node_bglt arg_29, obj_t frame_30, obj_t site_31)
{
   AN_OBJECT;
   {	/* Ast/apply.scm 223 */
      {		/* Ast/apply.scm 224 */
	 obj_t frame_1865;
	 frame_1865 =
	    MAKE_CELL(frame_30);
	 {	/* Ast/apply.scm 224 */
	    local_bglt runner_883;
	    type_bglt type_884;
	    {	/* Ast/apply.scm 224 */
	       obj_t arg1687_969;
	       {	/* Ast/apply.scm 224 */
		  obj_t arg1688_970;
		  arg1688_970 =
		     PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4,
		     CNST_TABLE_REF(((long) 2)), BEOA);
		  arg1687_969 =
		     mark_symbol_non_user__17_ast_ident(arg1688_970);
	       }
	       runner_883 =
		  make_local_svar_140_ast_local(arg1687_969,
		  (type_bglt) (____74_type_cache));
	    }
	    type_884 =
	       (((node_bglt) CREF(proc_28))->type);
	    {	/* Ast/apply.scm 227 */
	       bool_t test1613_885;
	       {	/* Ast/apply.scm 227 */
		  obj_t obj_1579;
		  obj_1579 =
		     CELL_REF(frame_1865);
		  test1613_885 =
		     PAIRP(obj_1579);
	       }
	       if (test1613_885)
		 {	/* Ast/apply.scm 228 */
		    obj_t val1084_1581;
		    val1084_1581 =
		       CNST_TABLE_REF(((long) 3));
		    ((((local_bglt) CREF(runner_883))->access) = ((obj_t) val1084_1581), BUNSPEC);
		 }
	       else
		 {	/* Ast/apply.scm 227 */
		    BUNSPEC;
		 }
	    }
	    {	/* Ast/apply.scm 229 */
	       obj_t arg1617_889;
	       obj_t arg1618_890;
	       {	/* Ast/apply.scm 232 */
		  obj_t arg1619_891;
		  {	/* ./Ieee/pair-list.scm 5689 */
		     obj_t aux_2211;
		     obj_t aux_2209;
		     aux_2211 =
			(obj_t) (arg_29);
		     aux_2209 =
			(obj_t) (runner_883);
		     arg1619_891 =
			MAKE_PAIR(aux_2209, aux_2211);
		  }
		  {	/* Ast/apply.scm 232 */
		     obj_t list1620_892;
		     list1620_892 =
			MAKE_PAIR(arg1619_891, BNIL);
		     arg1617_889 = list1620_892;
		  }
	       }
	       arg1618_890 =
		  loop_ast_apply(proc_28, frame_1865, stack_26, runner_883, type_884, loc_27,
		  CELL_REF(frame_1865), BNIL);
	       {	/* Ast/apply.scm 229 */
		  let_var_6_bglt res1823_1748;
		  {	/* Ast/apply.scm 229 */
		     obj_t key_1733;
		     node_bglt body_1735;
		     key_1733 =
			BINT(((long) -1));
		     body_1735 =
			(node_bglt) (arg1618_890);
		     {	/* ./Ast/node.scm 859 */
			let_var_6_bglt new1373_1737;
			new1373_1737 =
			   ((let_var_6_bglt) BREF(GC_MALLOC(sizeof(struct let_var_6))));
			{	/* ./Ast/node.scm 859 */
			   long arg1700_1738;
			   arg1700_1738 =
			      class_num_218___object(let_var_6_ast_node);
			   {	/* ./Ast/node.scm 859 */
			      obj_t obj_1746;
			      obj_1746 =
				 (obj_t) (new1373_1737);
			      (((obj_t) CREF(obj_1746))->header = MAKE_HEADER(arg1700_1738, 0), BUNSPEC);
			   }
			}
			{	/* ./Ast/node.scm 859 */
			   object_bglt aux_2222;
			   aux_2222 =
			      (object_bglt) (new1373_1737);
			   OBJECT_WIDENING_SET(aux_2222, BFALSE);
			}
			((((let_var_6_bglt) CREF(new1373_1737))->loc) = ((obj_t) loc_27), BUNSPEC);
			((((let_var_6_bglt) CREF(new1373_1737))->type) = ((type_bglt) type_884), BUNSPEC);
			((((let_var_6_bglt) CREF(new1373_1737))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
			((((let_var_6_bglt) CREF(new1373_1737))->key) = ((obj_t) key_1733), BUNSPEC);
			((((let_var_6_bglt) CREF(new1373_1737))->bindings) = ((obj_t) arg1617_889), BUNSPEC);
			((((let_var_6_bglt) CREF(new1373_1737))->body) = ((node_bglt) body_1735), BUNSPEC);
			((((let_var_6_bglt) CREF(new1373_1737))->removable__42) = ((bool_t) ((bool_t) 1)), BUNSPEC);
			res1823_1748 = new1373_1737;
		     }
		  }
		  return res1823_1748;
	       }
	    }
	 }
      }
   }
}



/* loop */
obj_t 
loop_ast_apply(node_bglt proc_1863, obj_t frame_1862, obj_t stack_1861, local_bglt runner_1860, type_bglt type_1859, obj_t loc_1858, obj_t locals_893, obj_t old_894)
{
   AN_OBJECT;
   {	/* Ast/apply.scm 233 */
      if (
	 NULLP(locals_893))
	{	/* Ast/apply.scm 235 */
	   if (
	      NULLP(old_894))
	     {	/* Ast/apply.scm 238 */
		obj_t aux_1864;
		{	/* Ast/apply.scm 238 */
		   obj_t list1623_898;
		   {	/* Ast/apply.scm 238 */
		      obj_t aux_2236;
		      aux_2236 =
			 (obj_t) (runner_1860);
		      list1623_898 =
			 MAKE_PAIR(aux_2236, BNIL);
		   }
		   aux_1864 = list1623_898;
		}
		CELL_SET(frame_1862, aux_1864);
	     }
	   else
	     {	/* Ast/apply.scm 239 */
		obj_t arg1624_899;
		{	/* ./Ieee/pair-list.scm 5689 */
		   obj_t aux_2239;
		   aux_2239 =
		      (obj_t) (runner_1860);
		   arg1624_899 =
		      MAKE_PAIR(aux_2239, BNIL);
		}
		SET_CDR(old_894, arg1624_899);
	     }
	   {	/* Ast/apply.scm 240 */
	      type_bglt arg1626_901;
	      var_bglt arg1628_903;
	      obj_t arg1629_904;
	      {		/* Ast/apply.scm 242 */
		 variable_bglt arg1630_905;
		 {	/* Ast/apply.scm 242 */
		    var_bglt obj_1592;
		    obj_1592 =
		       (var_bglt) (proc_1863);
		    arg1630_905 =
		       (((var_bglt) CREF(obj_1592))->variable);
		 }
		 arg1626_901 =
		    (((variable_bglt) CREF(arg1630_905))->type);
	      }
	      {		/* Ast/apply.scm 243 */
		 var_bglt duplicated1452_906;
		 duplicated1452_906 =
		    (var_bglt) (proc_1863);
		 {	/* Ast/apply.scm 243 */
		    var_bglt new1453_907;
		    {	/* Ast/apply.scm 243 */
		       obj_t arg1631_908;
		       type_bglt arg1632_909;
		       variable_bglt arg1633_910;
		       arg1631_908 =
			  (((var_bglt) CREF(duplicated1452_906))->loc);
		       arg1632_909 =
			  (((var_bglt) CREF(duplicated1452_906))->type);
		       arg1633_910 =
			  (((var_bglt) CREF(duplicated1452_906))->variable);
		       {	/* Ast/apply.scm 243 */
			  var_bglt res1816_1607;
			  {	/* ./Ast/node.scm 766 */
			     var_bglt new1210_1600;
			     new1210_1600 =
				((var_bglt) BREF(GC_MALLOC(sizeof(struct var))));
			     {	/* ./Ast/node.scm 766 */
				long arg1729_1601;
				arg1729_1601 =
				   class_num_218___object(var_ast_node);
				{	/* ./Ast/node.scm 766 */
				   obj_t obj_1605;
				   obj_1605 =
				      (obj_t) (new1210_1600);
				   (((obj_t) CREF(obj_1605))->header = MAKE_HEADER(arg1729_1601, 0), BUNSPEC);
				}
			     }
			     {	/* ./Ast/node.scm 766 */
				object_bglt aux_2254;
				aux_2254 =
				   (object_bglt) (new1210_1600);
				OBJECT_WIDENING_SET(aux_2254, BFALSE);
			     }
			     ((((var_bglt) CREF(new1210_1600))->loc) = ((obj_t) arg1631_908), BUNSPEC);
			     ((((var_bglt) CREF(new1210_1600))->type) = ((type_bglt) arg1632_909), BUNSPEC);
			     ((((var_bglt) CREF(new1210_1600))->variable) = ((variable_bglt) arg1633_910), BUNSPEC);
			     res1816_1607 = new1210_1600;
			  }
			  new1453_907 = res1816_1607;
		       }
		    }
		    {	/* Ast/apply.scm 243 */

		       arg1628_903 = new1453_907;
		    }
		 }
	      }
	      {		/* Ast/apply.scm 244 */
		 obj_t l1454_911;
		 l1454_911 =
		    CELL_REF(frame_1862);
		 if (
		    NULLP(l1454_911))
		   {	/* Ast/apply.scm 244 */
		      arg1629_904 = BNIL;
		   }
		 else
		   {	/* Ast/apply.scm 244 */
		      obj_t head1456_913;
		      head1456_913 =
			 MAKE_PAIR(BNIL, BNIL);
		      {
			 obj_t l1454_914;
			 obj_t tail1457_915;
			 l1454_914 = l1454_911;
			 tail1457_915 = head1456_913;
		       lname1455_916:
			 if (
			    NULLP(l1454_914))
			   {	/* Ast/apply.scm 244 */
			      arg1629_904 =
				 CDR(head1456_913);
			   }
			 else
			   {	/* Ast/apply.scm 245 */
			      obj_t newtail1458_918;
			      {		/* Ast/apply.scm 245 */
				 var_bglt arg1637_920;
				 {	/* Ast/apply.scm 245 */
				    obj_t local_922;
				    local_922 =
				       CAR(l1454_914);
				    {	/* Ast/apply.scm 245 */
				       type_bglt arg1640_924;
				       {	/* Ast/apply.scm 247 */
					  local_bglt obj_1614;
					  obj_1614 =
					     (local_bglt) (local_922);
					  arg1640_924 =
					     (((local_bglt) CREF(obj_1614))->type);
				       }
				       {	/* Ast/apply.scm 245 */
					  var_bglt res1817_1625;
					  {	/* Ast/apply.scm 245 */
					     variable_bglt variable_1617;
					     variable_1617 =
						(variable_bglt) (local_922);
					     {	/* ./Ast/node.scm 766 */
						var_bglt new1210_1618;
						new1210_1618 =
						   ((var_bglt) BREF(GC_MALLOC(sizeof(struct var))));
						{	/* ./Ast/node.scm 766 */
						   long arg1729_1619;
						   arg1729_1619 =
						      class_num_218___object(var_ast_node);
						   {	/* ./Ast/node.scm 766 */
						      obj_t obj_1623;
						      obj_1623 =
							 (obj_t) (new1210_1618);
						      (((obj_t) CREF(obj_1623))->header = MAKE_HEADER(arg1729_1619, 0), BUNSPEC);
						   }
						}
						{	/* ./Ast/node.scm 766 */
						   object_bglt aux_2274;
						   aux_2274 =
						      (object_bglt) (new1210_1618);
						   OBJECT_WIDENING_SET(aux_2274, BFALSE);
						}
						((((var_bglt) CREF(new1210_1618))->loc) = ((obj_t) loc_1858), BUNSPEC);
						((((var_bglt) CREF(new1210_1618))->type) = ((type_bglt) arg1640_924), BUNSPEC);
						((((var_bglt) CREF(new1210_1618))->variable) = ((variable_bglt) variable_1617), BUNSPEC);
						res1817_1625 = new1210_1618;
					     }
					  }
					  arg1637_920 = res1817_1625;
				       }
				    }
				 }
				 {	/* ./Ieee/pair-list.scm 5689 */
				    obj_t aux_2280;
				    aux_2280 =
				       (obj_t) (arg1637_920);
				    newtail1458_918 =
				       MAKE_PAIR(aux_2280, BNIL);
				 }
			      }
			      SET_CDR(tail1457_915, newtail1458_918);
			      {
				 obj_t tail1457_2286;
				 obj_t l1454_2284;
				 l1454_2284 =
				    CDR(l1454_914);
				 tail1457_2286 = newtail1458_918;
				 tail1457_915 = tail1457_2286;
				 l1454_914 = l1454_2284;
				 goto lname1455_916;
			      }
			   }
		      }
		   }
	      }
	      {		/* Ast/apply.scm 240 */
		 app_bglt res1818_1649;
		 {	/* Ast/apply.scm 240 */
		    obj_t key_1634;
		    key_1634 =
		       BINT(((long) -1));
		    {	/* ./Ast/node.scm 783 */
		       app_bglt new1248_1638;
		       new1248_1638 =
			  ((app_bglt) BREF(GC_MALLOC(sizeof(struct app))));
		       {	/* ./Ast/node.scm 783 */
			  long arg1721_1639;
			  arg1721_1639 =
			     class_num_218___object(app_ast_node);
			  {	/* ./Ast/node.scm 783 */
			     obj_t obj_1647;
			     obj_1647 =
				(obj_t) (new1248_1638);
			     (((obj_t) CREF(obj_1647))->header = MAKE_HEADER(arg1721_1639, 0), BUNSPEC);
			  }
		       }
		       {	/* ./Ast/node.scm 783 */
			  object_bglt aux_2292;
			  aux_2292 =
			     (object_bglt) (new1248_1638);
			  OBJECT_WIDENING_SET(aux_2292, BFALSE);
		       }
		       ((((app_bglt) CREF(new1248_1638))->loc) = ((obj_t) loc_1858), BUNSPEC);
		       ((((app_bglt) CREF(new1248_1638))->type) = ((type_bglt) arg1626_901), BUNSPEC);
		       ((((app_bglt) CREF(new1248_1638))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
		       ((((app_bglt) CREF(new1248_1638))->key) = ((obj_t) key_1634), BUNSPEC);
		       ((((app_bglt) CREF(new1248_1638))->fun) = ((var_bglt) arg1628_903), BUNSPEC);
		       ((((app_bglt) CREF(new1248_1638))->args) = ((obj_t) arg1629_904), BUNSPEC);
		       ((((app_bglt) CREF(new1248_1638))->stack_info_255) = ((obj_t) BUNSPEC), BUNSPEC);
		       res1818_1649 = new1248_1638;
		    }
		 }
		 return
		    (obj_t) (res1818_1649);
	      }
	   }
	}
      else
	{	/* Ast/apply.scm 250 */
	   obj_t arg1646_929;
	   node_bglt arg1647_930;
	   {	/* Ast/apply.scm 254 */
	      obj_t arg1648_931;
	      {		/* Ast/apply.scm 254 */
		 obj_t arg1650_933;
		 node_bglt arg1651_934;
		 arg1650_933 =
		    CAR(locals_893);
		 {	/* Ast/apply.scm 256 */
		    obj_t arg1652_935;
		    obj_t arg1653_936;
		    {	/* Ast/apply.scm 256 */
		       obj_t arg1654_937;
		       obj_t arg1655_938;
		       arg1654_937 =
			  CNST_TABLE_REF(((long) 9));
		       {	/* Ast/apply.scm 257 */
			  var_bglt arg1656_939;
			  {	/* Ast/apply.scm 257 */
			     type_bglt arg1659_942;
			     arg1659_942 =
				(((local_bglt) CREF(runner_1860))->type);
			     {	/* Ast/apply.scm 257 */
				var_bglt res1819_1662;
				{	/* Ast/apply.scm 257 */
				   variable_bglt variable_1654;
				   variable_1654 =
				      (variable_bglt) (runner_1860);
				   {	/* ./Ast/node.scm 766 */
				      var_bglt new1210_1655;
				      new1210_1655 =
					 ((var_bglt) BREF(GC_MALLOC(sizeof(struct var))));
				      {		/* ./Ast/node.scm 766 */
					 long arg1729_1656;
					 arg1729_1656 =
					    class_num_218___object(var_ast_node);
					 {	/* ./Ast/node.scm 766 */
					    obj_t obj_1660;
					    obj_1660 =
					       (obj_t) (new1210_1655);
					    (((obj_t) CREF(obj_1660))->header = MAKE_HEADER(arg1729_1656, 0), BUNSPEC);
					 }
				      }
				      {		/* ./Ast/node.scm 766 */
					 object_bglt aux_2311;
					 aux_2311 =
					    (object_bglt) (new1210_1655);
					 OBJECT_WIDENING_SET(aux_2311, BFALSE);
				      }
				      ((((var_bglt) CREF(new1210_1655))->loc) = ((obj_t) loc_1858), BUNSPEC);
				      ((((var_bglt) CREF(new1210_1655))->type) = ((type_bglt) arg1659_942), BUNSPEC);
				      ((((var_bglt) CREF(new1210_1655))->variable) = ((variable_bglt) variable_1654), BUNSPEC);
				      res1819_1662 = new1210_1655;
				   }
				}
				arg1656_939 = res1819_1662;
			     }
			  }
			  {	/* ./Ieee/pair-list.scm 5689 */
			     obj_t aux_2317;
			     aux_2317 =
				(obj_t) (arg1656_939);
			     arg1655_938 =
				MAKE_PAIR(aux_2317, BNIL);
			  }
		       }
		       arg1652_935 =
			  MAKE_PAIR(arg1654_937, arg1655_938);
		    }
		    arg1653_936 =
		       CNST_TABLE_REF(((long) 1));
		    arg1651_934 =
		       sexp__node_235_ast_sexp(arg1652_935, stack_1861, loc_1858, arg1653_936);
		 }
		 {	/* ./Ieee/pair-list.scm 5689 */
		    obj_t aux_2323;
		    aux_2323 =
		       (obj_t) (arg1651_934);
		    arg1648_931 =
		       MAKE_PAIR(arg1650_933, aux_2323);
		 }
	      }
	      {		/* Ast/apply.scm 253 */
		 obj_t list1649_932;
		 list1649_932 =
		    MAKE_PAIR(arg1648_931, BNIL);
		 arg1646_929 = list1649_932;
	      }
	   }
	   {	/* Ast/apply.scm 265 */
	      obj_t arg1661_944;
	      obj_t arg1662_945;
	      {		/* Ast/apply.scm 265 */
		 obj_t arg1663_946;
		 obj_t arg1664_947;
		 arg1663_946 =
		    CNST_TABLE_REF(((long) 10));
		 {	/* Ast/apply.scm 266 */
		    obj_t arg1665_948;
		    obj_t arg1666_949;
		    {	/* Ast/apply.scm 266 */
		       obj_t arg1667_950;
		       obj_t arg1669_951;
		       arg1667_950 =
			  CNST_TABLE_REF(((long) 11));
		       {	/* Ast/apply.scm 266 */
			  var_bglt arg1670_952;
			  obj_t arg1671_953;
			  {	/* Ast/apply.scm 266 */
			     type_bglt arg1673_955;
			     arg1673_955 =
				(((local_bglt) CREF(runner_1860))->type);
			     {	/* Ast/apply.scm 266 */
				var_bglt res1820_1681;
				{	/* Ast/apply.scm 266 */
				   variable_bglt variable_1673;
				   variable_1673 =
				      (variable_bglt) (runner_1860);
				   {	/* ./Ast/node.scm 766 */
				      var_bglt new1210_1674;
				      new1210_1674 =
					 ((var_bglt) BREF(GC_MALLOC(sizeof(struct var))));
				      {		/* ./Ast/node.scm 766 */
					 long arg1729_1675;
					 arg1729_1675 =
					    class_num_218___object(var_ast_node);
					 {	/* ./Ast/node.scm 766 */
					    obj_t obj_1679;
					    obj_1679 =
					       (obj_t) (new1210_1674);
					    (((obj_t) CREF(obj_1679))->header = MAKE_HEADER(arg1729_1675, 0), BUNSPEC);
					 }
				      }
				      {		/* ./Ast/node.scm 766 */
					 object_bglt aux_2335;
					 aux_2335 =
					    (object_bglt) (new1210_1674);
					 OBJECT_WIDENING_SET(aux_2335, BFALSE);
				      }
				      ((((var_bglt) CREF(new1210_1674))->loc) = ((obj_t) loc_1858), BUNSPEC);
				      ((((var_bglt) CREF(new1210_1674))->type) = ((type_bglt) arg1673_955), BUNSPEC);
				      ((((var_bglt) CREF(new1210_1674))->variable) = ((variable_bglt) variable_1673), BUNSPEC);
				      res1820_1681 = new1210_1674;
				   }
				}
				arg1670_952 = res1820_1681;
			     }
			  }
			  {	/* Ast/apply.scm 270 */
			     obj_t arg1675_957;
			     {	/* Ast/apply.scm 270 */
				obj_t arg1677_959;
				obj_t arg1678_960;
				arg1677_959 =
				   CNST_TABLE_REF(((long) 6));
				{	/* Ast/apply.scm 270 */
				   var_bglt arg1679_961;
				   {	/* Ast/apply.scm 270 */
				      type_bglt arg1682_964;
				      arg1682_964 =
					 (((local_bglt) CREF(runner_1860))->type);
				      {		/* Ast/apply.scm 270 */
					 var_bglt res1821_1693;
					 {	/* Ast/apply.scm 270 */
					    variable_bglt variable_1685;
					    variable_1685 =
					       (variable_bglt) (runner_1860);
					    {	/* ./Ast/node.scm 766 */
					       var_bglt new1210_1686;
					       new1210_1686 =
						  ((var_bglt) BREF(GC_MALLOC(sizeof(struct var))));
					       {	/* ./Ast/node.scm 766 */
						  long arg1729_1687;
						  arg1729_1687 =
						     class_num_218___object(var_ast_node);
						  {	/* ./Ast/node.scm 766 */
						     obj_t obj_1691;
						     obj_1691 =
							(obj_t) (new1210_1686);
						     (((obj_t) CREF(obj_1691))->header = MAKE_HEADER(arg1729_1687, 0), BUNSPEC);
						  }
					       }
					       {	/* ./Ast/node.scm 766 */
						  object_bglt aux_2348;
						  aux_2348 =
						     (object_bglt) (new1210_1686);
						  OBJECT_WIDENING_SET(aux_2348, BFALSE);
					       }
					       ((((var_bglt) CREF(new1210_1686))->loc) = ((obj_t) loc_1858), BUNSPEC);
					       ((((var_bglt) CREF(new1210_1686))->type) = ((type_bglt) arg1682_964), BUNSPEC);
					       ((((var_bglt) CREF(new1210_1686))->variable) = ((variable_bglt) variable_1685), BUNSPEC);
					       res1821_1693 = new1210_1686;
					    }
					 }
					 arg1679_961 = res1821_1693;
				      }
				   }
				   {	/* ./Ieee/pair-list.scm 5689 */
				      obj_t aux_2354;
				      aux_2354 =
					 (obj_t) (arg1679_961);
				      arg1678_960 =
					 MAKE_PAIR(aux_2354, BNIL);
				   }
				}
				arg1675_957 =
				   MAKE_PAIR(arg1677_959, arg1678_960);
			     }
			     arg1671_953 =
				MAKE_PAIR(arg1675_957, BNIL);
			  }
			  {	/* ./Ieee/pair-list.scm 5689 */
			     obj_t aux_2359;
			     aux_2359 =
				(obj_t) (arg1670_952);
			     arg1669_951 =
				MAKE_PAIR(aux_2359, arg1671_953);
			  }
		       }
		       arg1665_948 =
			  MAKE_PAIR(arg1667_950, arg1669_951);
		    }
		    {	/* Ast/apply.scm 274 */
		       obj_t arg1684_966;
		       arg1684_966 =
			  loop_ast_apply(proc_1863, frame_1862, stack_1861, runner_1860, type_1859, loc_1858,
			  CDR(locals_893), locals_893);
		       arg1666_949 =
			  MAKE_PAIR(arg1684_966, BNIL);
		    }
		    arg1664_947 =
		       MAKE_PAIR(arg1665_948, arg1666_949);
		 }
		 arg1661_944 =
		    MAKE_PAIR(arg1663_946, arg1664_947);
	      }
	      arg1662_945 =
		 CNST_TABLE_REF(((long) 1));
	      arg1647_930 =
		 sexp__node_235_ast_sexp(arg1661_944, stack_1861, loc_1858, arg1662_945);
	   }
	   {	/* Ast/apply.scm 250 */
	      let_var_6_bglt res1822_1729;
	      {		/* Ast/apply.scm 250 */
		 obj_t key_1714;
		 key_1714 =
		    BINT(((long) -1));
		 {	/* ./Ast/node.scm 859 */
		    let_var_6_bglt new1373_1718;
		    new1373_1718 =
		       ((let_var_6_bglt) BREF(GC_MALLOC(sizeof(struct let_var_6))));
		    {	/* ./Ast/node.scm 859 */
		       long arg1700_1719;
		       arg1700_1719 =
			  class_num_218___object(let_var_6_ast_node);
		       {	/* ./Ast/node.scm 859 */
			  obj_t obj_1727;
			  obj_1727 =
			     (obj_t) (new1373_1718);
			  (((obj_t) CREF(obj_1727))->header = MAKE_HEADER(arg1700_1719, 0), BUNSPEC);
		       }
		    }
		    {	/* ./Ast/node.scm 859 */
		       object_bglt aux_2375;
		       aux_2375 =
			  (object_bglt) (new1373_1718);
		       OBJECT_WIDENING_SET(aux_2375, BFALSE);
		    }
		    ((((let_var_6_bglt) CREF(new1373_1718))->loc) = ((obj_t) loc_1858), BUNSPEC);
		    ((((let_var_6_bglt) CREF(new1373_1718))->type) = ((type_bglt) type_1859), BUNSPEC);
		    ((((let_var_6_bglt) CREF(new1373_1718))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
		    ((((let_var_6_bglt) CREF(new1373_1718))->key) = ((obj_t) key_1714), BUNSPEC);
		    ((((let_var_6_bglt) CREF(new1373_1718))->bindings) = ((obj_t) arg1646_929), BUNSPEC);
		    ((((let_var_6_bglt) CREF(new1373_1718))->body) = ((node_bglt) arg1647_930), BUNSPEC);
		    ((((let_var_6_bglt) CREF(new1373_1718))->removable__42) = ((bool_t) ((bool_t) 1)), BUNSPEC);
		    res1822_1729 = new1373_1718;
		 }
	      }
	      return
		 (obj_t) (res1822_1729);
	   }
	}
   }
}



/* method-init */
obj_t 
method_init_76_ast_apply()
{
   AN_OBJECT;
   {	/* Ast/apply.scm 14 */
      add_generic__110___object(make_fun_frame_env_121_ast_apply, make_fun_frame_default1465_env_227_ast_apply);
      add_inlined_method__244___object(make_fun_frame_env_121_ast_apply, sfun_ast_var, ((long) 0));
      {		/* Ast/apply.scm 14 */
	 long aux_2388;
	 aux_2388 =
	    add_inlined_method__244___object(make_fun_frame_env_121_ast_apply, cfun_ast_var, ((long) 1));
	 return
	    BINT(aux_2388);
      }
   }
}



/* make-fun-frame */
obj_t 
make_fun_frame_37_ast_apply(fun_bglt fun_5)
{
   AN_OBJECT;
   {	/* Ast/apply.scm 58 */
      {
	 obj_t method1763_1301;
	 obj_t class1768_1302;
	 {	/* Ast/apply.scm 58 */
	    obj_t arg1771_1299;
	    obj_t arg1772_1300;
	    {	/* Ast/apply.scm 58 */
	       object_bglt obj_1786;
	       obj_1786 =
		  (object_bglt) (fun_5);
	       {	/* ./Llib/object.scm 2926 */
		  obj_t pre_method_105_1787;
		  pre_method_105_1787 =
		     PROCEDURE_REF(make_fun_frame_env_121_ast_apply, ((long) 2));
		  if (
		     INTEGERP(pre_method_105_1787))
		    {	/* ./Llib/object.scm 2927 */
		       PROCEDURE_SET(make_fun_frame_env_121_ast_apply, ((long) 2), BUNSPEC);
		       arg1771_1299 = pre_method_105_1787;
		    }
		  else
		    {	/* ./Llib/object.scm 2914 */
		       long obj_class_num_177_1792;
		       obj_class_num_177_1792 =
			  TYPE(obj_1786);
		       {	/* ./Llib/object.scm 2915 */
			  obj_t arg1176_1793;
			  arg1176_1793 =
			     PROCEDURE_REF(make_fun_frame_env_121_ast_apply, ((long) 1));
			  {	/* ./Llib/object.scm 2738 */
			     long arg1177_1797;
			     {	/* ./Llib/object.scm 2738 */
				long arg1178_1798;
				arg1178_1798 =
				   OBJECT_TYPE;
				arg1177_1797 =
				   (obj_class_num_177_1792 - arg1178_1798);
			     }
			     arg1771_1299 =
				VECTOR_REF(arg1176_1793, arg1177_1797);
			  }
		       }
		    }
	       }
	    }
	    {	/* Ast/apply.scm 58 */
	       object_bglt object_1803;
	       object_1803 =
		  (object_bglt) (fun_5);
	       {	/* ./Llib/object.scm 2695 */
		  long arg1179_1804;
		  {	/* ./Llib/object.scm 2695 */
		     long arg1180_1805;
		     long arg1181_1806;
		     arg1180_1805 =
			TYPE(object_1803);
		     arg1181_1806 =
			OBJECT_TYPE;
		     arg1179_1804 =
			(arg1180_1805 - arg1181_1806);
		  }
		  {	/* ./Llib/object.scm 2695 */
		     obj_t vector_1810;
		     vector_1810 = _classes__134___object;
		     arg1772_1300 =
			VECTOR_REF(vector_1810, arg1179_1804);
		  }
	       }
	    }
	    method1763_1301 = arg1771_1299;
	    class1768_1302 = arg1772_1300;
	    {

	       if (
		  INTEGERP(method1763_1301))
		 {	/* Ast/apply.scm 58 */
		    switch (
		       (long) CINT(method1763_1301))
		      {
		      case ((long) 0):

			 {	/* Ast/apply.scm 64 */
			    sfun_bglt fun_1308;
			    fun_1308 =
			       (sfun_bglt) (fun_5);
			    {	/* Ast/apply.scm 64 */
			       long arity_1309;
			       arity_1309 =
				  (((sfun_bglt) CREF(fun_1308))->arity);
			       {
				  obj_t formals_1310;
				  obj_t locals_1311;
				  formals_1310 =
				     (((sfun_bglt) CREF(fun_1308))->args);
				  locals_1311 = BNIL;
				loop_1312:
				  if (
				     NULLP(formals_1310))
				    {	/* Ast/apply.scm 68 */
				       return
					  reverse__39___r4_pairs_and_lists_6_3(locals_1311);
				    }
				  else
				    {	/* Ast/apply.scm 70 */
				       bool_t test_2413;
				       {	/* Ast/apply.scm 70 */
					  bool_t test_2414;
					  {	/* ./Ieee/pair-list.scm 5912 */
					     obj_t aux_2415;
					     aux_2415 =
						CDR(formals_1310);
					     test_2414 =
						NULLP(aux_2415);
					  }
					  if (test_2414)
					    {	/* Ast/apply.scm 70 */
					       test_2413 =
						  (arity_1309 < ((long) 0))
						  ;
					    }
					  else
					    {	/* Ast/apply.scm 70 */
					       test_2413 = ((bool_t) 0)
						  ;
					    }
				       }
				       if (test_2413)
					 {	/* Ast/apply.scm 70 */
					    return
					       reverse__39___r4_pairs_and_lists_6_3(locals_1311);
					 }
				       else
					 {	/* Ast/apply.scm 70 */
					    {	/* Ast/apply.scm 73 */
					       obj_t arg1779_1317;
					       obj_t arg1780_1318;
					       arg1779_1317 =
						  CDR(formals_1310);
					       {	/* Ast/apply.scm 74 */
						  local_bglt arg1781_1319;
						  {	/* Ast/apply.scm 74 */
						     obj_t arg1782_1320;
						     obj_t arg1783_1321;
						     {	/* Ast/apply.scm 74 */
							obj_t arg1784_1322;
							arg1784_1322 =
							   PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4,
							   CNST_TABLE_REF(((long) 12)), BEOA);
							arg1782_1320 =
							   mark_symbol_non_user__17_ast_ident(arg1784_1322);
						     }
						     {	/* Ast/apply.scm 75 */
							bool_t test1785_1323;
							test1785_1323 =
							   is_a__118___object(
							   CAR(formals_1310), type_type_type);
							if (test1785_1323)
							  {	/* Ast/apply.scm 75 */
							     arg1783_1321 =
								CAR(formals_1310);
							  }
							else
							  {	/* Ast/apply.scm 77 */
							     local_bglt obj_1824;
							     {	/* Ast/apply.scm 77 */
								obj_t aux_2429;
								aux_2429 =
								   CAR(formals_1310);
								obj_1824 =
								   (local_bglt) (aux_2429);
							     }
							     {	/* ./Ast/var.scm 615 */
								type_bglt aux_2432;
								aux_2432 =
								   (((local_bglt) CREF(obj_1824))->type);
								arg1783_1321 =
								   (obj_t) (aux_2432);
							     }
							  }
						     }
						     arg1781_1319 =
							make_local_svar_140_ast_local(arg1782_1320,
							(type_bglt) (arg1783_1321));
						  }
						  {	/* ./Ieee/pair-list.scm 5689 */
						     obj_t aux_2437;
						     aux_2437 =
							(obj_t) (arg1781_1319);
						     arg1780_1318 =
							MAKE_PAIR(aux_2437, locals_1311);
						  }
					       }
					       {
						  obj_t locals_2441;
						  obj_t formals_2440;
						  formals_2440 = arg1779_1317;
						  locals_2441 = arg1780_1318;
						  locals_1311 = locals_2441;
						  formals_1310 = formals_2440;
						  goto loop_1312;
					       }
					    }
					 }
				    }
			       }
			    }
			 }
			 break;
		      case ((long) 1):

			 {	/* Ast/apply.scm 84 */
			    cfun_bglt fun_1328;
			    fun_1328 =
			       (cfun_bglt) (fun_5);
			    {	/* Ast/apply.scm 84 */
			       long arity_1329;
			       arity_1329 =
				  (((cfun_bglt) CREF(fun_1328))->arity);
			       {
				  obj_t types_1330;
				  obj_t locals_1331;
				  types_1330 =
				     (((cfun_bglt) CREF(fun_1328))->args_type_205);
				  locals_1331 = BNIL;
				loop_1332:
				  if (
				     NULLP(types_1330))
				    {	/* Ast/apply.scm 88 */
				       return
					  reverse__39___r4_pairs_and_lists_6_3(locals_1331);
				    }
				  else
				    {	/* Ast/apply.scm 90 */
				       bool_t test_2448;
				       {	/* Ast/apply.scm 90 */
					  bool_t test_2449;
					  {	/* ./Ieee/pair-list.scm 5912 */
					     obj_t aux_2450;
					     aux_2450 =
						CDR(types_1330);
					     test_2449 =
						NULLP(aux_2450);
					  }
					  if (test_2449)
					    {	/* Ast/apply.scm 90 */
					       test_2448 =
						  (arity_1329 < ((long) 0))
						  ;
					    }
					  else
					    {	/* Ast/apply.scm 90 */
					       test_2448 = ((bool_t) 0)
						  ;
					    }
				       }
				       if (test_2448)
					 {	/* Ast/apply.scm 90 */
					    return
					       reverse__39___r4_pairs_and_lists_6_3(locals_1331);
					 }
				       else
					 {	/* Ast/apply.scm 90 */
					    {	/* Ast/apply.scm 93 */
					       obj_t arg1794_1337;
					       obj_t arg1795_1338;
					       arg1794_1337 =
						  CDR(types_1330);
					       {	/* Ast/apply.scm 94 */
						  local_bglt arg1796_1339;
						  {	/* Ast/apply.scm 94 */
						     obj_t arg1797_1340;
						     obj_t arg1798_1341;
						     {	/* Ast/apply.scm 94 */
							obj_t arg1800_1342;
							arg1800_1342 =
							   PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4,
							   CNST_TABLE_REF(((long) 12)), BEOA);
							arg1797_1340 =
							   mark_symbol_non_user__17_ast_ident(arg1800_1342);
						     }
						     arg1798_1341 =
							CAR(types_1330);
						     arg1796_1339 =
							make_local_svar_140_ast_local(arg1797_1340,
							(type_bglt) (arg1798_1341));
						  }
						  {	/* ./Ieee/pair-list.scm 5689 */
						     obj_t aux_2463;
						     aux_2463 =
							(obj_t) (arg1796_1339);
						     arg1795_1338 =
							MAKE_PAIR(aux_2463, locals_1331);
						  }
					       }
					       {
						  obj_t locals_2467;
						  obj_t types_2466;
						  types_2466 = arg1794_1337;
						  locals_2467 = arg1795_1338;
						  locals_1331 = locals_2467;
						  types_1330 = types_2466;
						  goto loop_1332;
					       }
					    }
					 }
				    }
			       }
			    }
			 }
			 break;
		      default:
		       case_else1769_1305:
			 if (
			    PROCEDUREP(method1763_1301))
			   {	/* Ast/apply.scm 58 */
			      return
				 PROCEDURE_ENTRY(method1763_1301) (method1763_1301,
				 (obj_t) (fun_5), BEOA);
			   }
			 else
			   {	/* Ast/apply.scm 58 */
			      obj_t fun1762_1297;
			      fun1762_1297 =
				 PROCEDURE_REF(make_fun_frame_env_121_ast_apply, ((long) 0));
			      return
				 PROCEDURE_ENTRY(fun1762_1297) (fun1762_1297,
				 (obj_t) (fun_5), BEOA);
			   }
		      }
		 }
	       else
		 {	/* Ast/apply.scm 58 */
		    goto case_else1769_1305;
		 }
	    }
	 }
      }
   }
}



/* _make-fun-frame */
obj_t 
_make_fun_frame_157_ast_apply(obj_t env_1854, obj_t fun_1855)
{
   AN_OBJECT;
   {	/* Ast/apply.scm 58 */
      return
	 make_fun_frame_37_ast_apply(
	 (fun_bglt) (fun_1855));
   }
}



/* make-fun-frame-default1465 */
obj_t 
make_fun_frame_default1465_206_ast_apply(fun_bglt fun_6)
{
   AN_OBJECT;
   {	/* Ast/apply.scm 14 */
      FAILURE(
	 CNST_TABLE_REF(((long) 13)), string1828_ast_apply,
	 (obj_t) (fun_6));
   }
}



/* _make-fun-frame-default1465 */
obj_t 
_make_fun_frame_default1465_198_ast_apply(obj_t env_1856, obj_t fun_1857)
{
   AN_OBJECT;
   {	/* Ast/apply.scm 14 */
      return
	 make_fun_frame_default1465_206_ast_apply(
	 (fun_bglt) (fun_1857));
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_ast_apply()
{
   AN_OBJECT;
   {	/* Ast/apply.scm 14 */
      module_initialization_70_type_type(((long) 0), "AST_APPLY");
      module_initialization_70_ast_var(((long) 0), "AST_APPLY");
      module_initialization_70_ast_node(((long) 0), "AST_APPLY");
      module_initialization_70_engine_param(((long) 0), "AST_APPLY");
      module_initialization_70_tools_error(((long) 0), "AST_APPLY");
      module_initialization_70_tools_location(((long) 0), "AST_APPLY");
      module_initialization_70_tools_shape(((long) 0), "AST_APPLY");
      module_initialization_70_type_cache(((long) 0), "AST_APPLY");
      module_initialization_70_ast_sexp(((long) 0), "AST_APPLY");
      module_initialization_70_ast_local(((long) 0), "AST_APPLY");
      module_initialization_70_ast_app(((long) 0), "AST_APPLY");
      return
	 module_initialization_70_ast_ident(((long) 0), "AST_APPLY");
   }
}
