/*===========================================================================*/
/*   (Ast/build.scm)                                                         */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;


extern obj_t append___r4_pairs_and_lists_6_3(obj_t);
static obj_t method_init_76_ast_build();
extern obj_t current_error_port;
extern obj_t inline_methods__72_object_inline();
extern obj_t _nb_error_on_pass__70_tools_error;
extern obj_t find_location_loc_243_tools_location(obj_t, obj_t);
extern obj_t unit__defs_135_ast_unit(obj_t);
extern obj_t leave_function_170_tools_error();
extern obj_t check_to_be_define_14_ast_find_gdefs_13();
extern obj_t verbose_tools_speek(obj_t, obj_t);
extern obj_t module_initialization_70_ast_build(long, char *);
extern obj_t module_initialization_70_tools_speek(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_engine_pass(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_ast_unit(long, char *);
extern obj_t module_initialization_70_ast_sexp(long, char *);
extern obj_t module_initialization_70_ast_env(long, char *);
extern obj_t module_initialization_70_ast_find_gdefs_13(long, char *);
extern obj_t module_initialization_70_ast_remove(long, char *);
extern obj_t module_initialization_70_ast_local(long, char *);
extern obj_t module_initialization_70_object_inline(long, char *);
extern obj_t module_initialization_70_tools_args(long, char *);
extern obj_t module_initialization_70_tools_progn(long, char *);
extern obj_t module_initialization_70_tools_location(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_numbers_6_5(long, char *);
extern obj_t module_initialization_70___r4_output_6_10_3(long, char *);
static global_bglt sfun_def__ast_191_ast_build(global_bglt);
static obj_t _build_ast_sans_remove_171_ast_build(obj_t, obj_t);
extern obj_t display_2_122___r4_output_6_10_3(obj_t, obj_t);
static obj_t imported_modules_init_94_ast_build();
static obj_t library_modules_init_112_ast_build();
extern node_bglt sexp__node_235_ast_sexp(obj_t, obj_t, obj_t, obj_t);
extern obj_t build_ast_197_ast_build(obj_t);
extern obj_t open_input_string(obj_t);
extern obj_t string_to_bstring(char *);
extern obj_t enter_function_81_tools_error(obj_t);
extern obj_t remove_var_123_ast_remove(obj_t, obj_t);
extern obj_t internal_error_43_tools_error(obj_t, obj_t, obj_t);
extern obj_t build_ast_sans_remove_93_ast_build(obj_t);
extern bool_t _2__206___r4_numbers_6_5(obj_t, obj_t);
extern obj_t read___reader(obj_t);
extern obj_t find_location_120_tools_location(obj_t);
static obj_t require_initialization_114_ast_build = BUNSPEC;
static obj_t _build_ast_150_ast_build(obj_t, obj_t);
static obj_t cnst_init_137_ast_build();
extern obj_t _current_pass__25_engine_pass;
static obj_t __cnst[3];

DEFINE_EXPORT_PROCEDURE(build_ast_sans_remove_env_209_ast_build, _build_ast_sans_remove_171_ast_build1607, _build_ast_sans_remove_171_ast_build, 0L, 1);
DEFINE_EXPORT_PROCEDURE(build_ast_env_244_ast_build, _build_ast_150_ast_build1608, _build_ast_150_ast_build, 0L, 1);
DEFINE_STRING(string1599_ast_build, string1599_ast_build1609, " error", 6);
DEFINE_STRING(string1598_ast_build, string1598_ast_build1610, "failure during prelude hook", 27);
DEFINE_STRING(string1597_ast_build, string1597_ast_build1611, "   . ", 5);
DEFINE_STRING(string1596_ast_build, string1596_ast_build1612, "Ast", 3);
DEFINE_STRING(string1602_ast_build, string1602_ast_build1613, "VALUE PASS-STARTED AST ", 23);
DEFINE_STRING(string1601_ast_build, string1601_ast_build1614, "failure during postlude hook", 28);
DEFINE_STRING(string1600_ast_build, string1600_ast_build1615, " occured, ending ...", 20);



/* module-initialization */
obj_t 
module_initialization_70_ast_build(long checksum_1171, char *from_1172)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_ast_build))
	{
	   require_initialization_114_ast_build =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_ast_build();
	   cnst_init_137_ast_build();
	   imported_modules_init_94_ast_build();
	   method_init_76_ast_build();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_ast_build()
{
   AN_OBJECT;
   {	/* Ast/build.scm 14 */
      module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "AST_BUILD");
      module_initialization_70___r4_output_6_10_3(((long) 0), "AST_BUILD");
      module_initialization_70___r4_numbers_6_5(((long) 0), "AST_BUILD");
      module_initialization_70___reader(((long) 0), "AST_BUILD");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_ast_build()
{
   AN_OBJECT;
   {	/* Ast/build.scm 14 */
      {		/* Ast/build.scm 14 */
	 obj_t cnst_port_138_1164;
	 cnst_port_138_1164 =
	    open_input_string(string1602_ast_build);
	 {
	    long i_1165;
	    i_1165 = ((long) 2);
	  loop_1166:
	    {	/* Ast/build.scm 14 */
	       bool_t test1603_1167;
	       test1603_1167 =
		  (i_1165 == ((long) -1));
	       if (test1603_1167)
		 {	/* Ast/build.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Ast/build.scm 14 */
		    {	/* Ast/build.scm 14 */
		       obj_t arg1604_1168;
		       {	/* Ast/build.scm 14 */
			  obj_t list1605_1169;
			  list1605_1169 =
			     MAKE_PAIR(cnst_port_138_1164, BNIL);
			  arg1604_1168 =
			     read___reader(list1605_1169);
		       }
		       CNST_TABLE_SET(i_1165, arg1604_1168);
		    }
		    {	/* Ast/build.scm 14 */
		       int aux_1170;
		       {	/* Ast/build.scm 14 */
			  long aux_1190;
			  aux_1190 =
			     (i_1165 - ((long) 1));
			  aux_1170 =
			     (int) (aux_1190);
		       }
		       {
			  long i_1193;
			  i_1193 =
			     (long) (aux_1170);
			  i_1165 = i_1193;
			  goto loop_1166;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* build-ast */
obj_t 
build_ast_197_ast_build(obj_t units_1)
{
   AN_OBJECT;
   {	/* Ast/build.scm 37 */
      {		/* Ast/build.scm 38 */
	 obj_t arg1449_1109;
	 obj_t arg1450_1110;
	 arg1449_1109 =
	    CNST_TABLE_REF(((long) 0));
	 arg1450_1110 =
	    build_ast_sans_remove_93_ast_build(units_1);
	 return
	    remove_var_123_ast_remove(arg1449_1109, arg1450_1110);
      }
   }
}



/* _build-ast */
obj_t 
_build_ast_150_ast_build(obj_t env_1160, obj_t units_1161)
{
   AN_OBJECT;
   {	/* Ast/build.scm 37 */
      return
	 build_ast_197_ast_build(units_1161);
   }
}



/* build-ast-sans-remove */
obj_t 
build_ast_sans_remove_93_ast_build(obj_t units_2)
{
   AN_OBJECT;
   {	/* Ast/build.scm 45 */
      {		/* Ast/build.scm 45 */
	 obj_t list1451_701;
	 {	/* Ast/build.scm 45 */
	    obj_t arg1454_703;
	    {	/* Ast/build.scm 45 */
	       obj_t arg1456_705;
	       {	/* Ast/build.scm 45 */
		  obj_t aux_1199;
		  aux_1199 =
		     BCHAR(((unsigned char) '\n'));
		  arg1456_705 =
		     MAKE_PAIR(aux_1199, BNIL);
	       }
	       arg1454_703 =
		  MAKE_PAIR(string1596_ast_build, arg1456_705);
	    }
	    list1451_701 =
	       MAKE_PAIR(string1597_ast_build, arg1454_703);
	 }
	 verbose_tools_speek(
	    BINT(((long) 1)), list1451_701);
      }
      _nb_error_on_pass__70_tools_error =
	 BINT(((long) 0));
      _current_pass__25_engine_pass = string1596_ast_build;
      {
	 obj_t hooks_706;
	 obj_t hnames_707;
	 hooks_706 = BNIL;
	 hnames_707 = BNIL;
       loop_708:
	 if (
	    NULLP(hooks_706))
	   {	/* Ast/build.scm 45 */
	      CNST_TABLE_REF(((long) 1));
	   }
	 else
	   {	/* Ast/build.scm 45 */
	      bool_t test1461_713;
	      {		/* Ast/build.scm 45 */
		 obj_t fun1470_719;
		 fun1470_719 =
		    CAR(hooks_706);
		 {	/* Ast/build.scm 45 */
		    obj_t aux_1211;
		    aux_1211 =
		       PROCEDURE_ENTRY(fun1470_719) (fun1470_719, BEOA);
		    test1461_713 =
		       CBOOL(aux_1211);
		 }
	      }
	      if (test1461_713)
		{	/* Ast/build.scm 45 */
		   {
		      obj_t hnames_1218;
		      obj_t hooks_1216;
		      hooks_1216 =
			 CDR(hooks_706);
		      hnames_1218 =
			 CDR(hnames_707);
		      hnames_707 = hnames_1218;
		      hooks_706 = hooks_1216;
		      goto loop_708;
		   }
		}
	      else
		{	/* Ast/build.scm 45 */
		   internal_error_43_tools_error(string1596_ast_build, string1598_ast_build,
		      CAR(hnames_707));
		}
	   }
      }
      {		/* Ast/build.scm 50 */
	 obj_t defs_720;
	 {	/* Ast/build.scm 50 */
	    obj_t runner1510_773;
	    if (
	       NULLP(units_2))
	      {		/* Ast/build.scm 50 */
		 runner1510_773 = BNIL;
	      }
	    else
	      {		/* Ast/build.scm 50 */
		 obj_t head1439_759;
		 {	/* Ast/build.scm 50 */
		    obj_t arg1506_770;
		    arg1506_770 =
		       unit__defs_135_ast_unit(
		       CAR(units_2));
		    head1439_759 =
		       MAKE_PAIR(arg1506_770, BNIL);
		 }
		 {
		    obj_t l1437_760;
		    obj_t tail1440_761;
		    l1437_760 =
		       CDR(units_2);
		    tail1440_761 = head1439_759;
		  lname1438_762:
		    if (
		       NULLP(l1437_760))
		      {		/* Ast/build.scm 50 */
			 runner1510_773 = head1439_759;
		      }
		    else
		      {		/* Ast/build.scm 50 */
			 obj_t newtail1441_765;
			 {	/* Ast/build.scm 50 */
			    obj_t arg1503_767;
			    arg1503_767 =
			       unit__defs_135_ast_unit(
			       CAR(l1437_760));
			    newtail1441_765 =
			       MAKE_PAIR(arg1503_767, BNIL);
			 }
			 SET_CDR(tail1440_761, newtail1441_765);
			 {
			    obj_t tail1440_1235;
			    obj_t l1437_1233;
			    l1437_1233 =
			       CDR(l1437_760);
			    tail1440_1235 = newtail1441_765;
			    tail1440_761 = tail1440_1235;
			    l1437_760 = l1437_1233;
			    goto lname1438_762;
			 }
		      }
		 }
	      }
	    defs_720 =
	       append___r4_pairs_and_lists_6_3(runner1510_773);
	 }
	 check_to_be_define_14_ast_find_gdefs_13();
	 {	/* Ast/build.scm 54 */
	    obj_t ast_721;
	    if (
	       NULLP(defs_720))
	      {		/* Ast/build.scm 54 */
		 ast_721 = BNIL;
	      }
	    else
	      {		/* Ast/build.scm 54 */
		 obj_t head1444_743;
		 {	/* Ast/build.scm 54 */
		    global_bglt arg1496_754;
		    {	/* Ast/build.scm 54 */
		       global_bglt aux_1241;
		       {	/* Ast/build.scm 54 */
			  obj_t aux_1242;
			  aux_1242 =
			     CAR(defs_720);
			  aux_1241 =
			     (global_bglt) (aux_1242);
		       }
		       arg1496_754 =
			  sfun_def__ast_191_ast_build(aux_1241);
		    }
		    {	/* ./Ieee/pair-list.scm 5689 */
		       obj_t aux_1246;
		       aux_1246 =
			  (obj_t) (arg1496_754);
		       head1444_743 =
			  MAKE_PAIR(aux_1246, BNIL);
		    }
		 }
		 {
		    obj_t l1442_744;
		    obj_t tail1445_745;
		    l1442_744 =
		       CDR(defs_720);
		    tail1445_745 = head1444_743;
		  lname1443_746:
		    if (
		       NULLP(l1442_744))
		      {		/* Ast/build.scm 54 */
			 ast_721 = head1444_743;
		      }
		    else
		      {		/* Ast/build.scm 54 */
			 obj_t newtail1446_749;
			 {	/* Ast/build.scm 54 */
			    global_bglt arg1493_751;
			    {	/* Ast/build.scm 54 */
			       global_bglt aux_1251;
			       {	/* Ast/build.scm 54 */
				  obj_t aux_1252;
				  aux_1252 =
				     CAR(l1442_744);
				  aux_1251 =
				     (global_bglt) (aux_1252);
			       }
			       arg1493_751 =
				  sfun_def__ast_191_ast_build(aux_1251);
			    }
			    {	/* ./Ieee/pair-list.scm 5689 */
			       obj_t aux_1256;
			       aux_1256 =
				  (obj_t) (arg1493_751);
			       newtail1446_749 =
				  MAKE_PAIR(aux_1256, BNIL);
			    }
			 }
			 SET_CDR(tail1445_745, newtail1446_749);
			 {
			    obj_t tail1445_1262;
			    obj_t l1442_1260;
			    l1442_1260 =
			       CDR(l1442_744);
			    tail1445_1262 = newtail1446_749;
			    tail1445_745 = tail1445_1262;
			    l1442_744 = l1442_1260;
			    goto lname1443_746;
			 }
		      }
		 }
	      }
	    inline_methods__72_object_inline();
	    {	/* Ast/build.scm 59 */
	       bool_t test1471_723;
	       {	/* Ast/build.scm 59 */
		  long n1_1141;
		  n1_1141 =
		     (long) CINT(_nb_error_on_pass__70_tools_error);
		  test1471_723 =
		     (n1_1141 > ((long) 0));
	       }
	       if (test1471_723)
		 {	/* Ast/build.scm 59 */
		    display_2_122___r4_output_6_10_3(_nb_error_on_pass__70_tools_error, current_error_port);
		    display_2_122___r4_output_6_10_3(string1599_ast_build, current_error_port);
		    {	/* Ast/build.scm 59 */
		       char *arg1472_725;
		       {	/* Ast/build.scm 59 */
			  bool_t test1473_726;
			  {	/* Ast/build.scm 59 */
			     bool_t test1474_727;
			     {	/* Ast/build.scm 59 */
				obj_t obj_1143;
				obj_1143 = _nb_error_on_pass__70_tools_error;
				test1474_727 =
				   INTEGERP(obj_1143);
			     }
			     if (test1474_727)
			       {	/* Ast/build.scm 59 */
				  test1473_726 =
				     _2__206___r4_numbers_6_5(_nb_error_on_pass__70_tools_error,
				     BINT(((long) 1)));
			       }
			     else
			       {	/* Ast/build.scm 59 */
				  test1473_726 = ((bool_t) 0);
			       }
			  }
			  if (test1473_726)
			    {	/* Ast/build.scm 59 */
			       arg1472_725 = "s";
			    }
			  else
			    {	/* Ast/build.scm 59 */
			       arg1472_725 = "";
			    }
		       }
		       display_2_122___r4_output_6_10_3(
			  string_to_bstring(arg1472_725), current_error_port);
		    }
		    display_2_122___r4_output_6_10_3(string1600_ast_build, current_error_port);
		    WRITE_CHAR(((unsigned char) '\n'), current_error_port);
		    {	/* Ast/build.scm 59 */
		       obj_t res1595_1146;
		       exit(((long) -1));
		       res1595_1146 =
			  BINT(((long) -1));
		       return res1595_1146;
		    }
		 }
	       else
		 {
		    obj_t hooks_728;
		    obj_t hnames_729;
		    hooks_728 = BNIL;
		    hnames_729 = BNIL;
		  loop_730:
		    if (
		       NULLP(hooks_728))
		      {		/* Ast/build.scm 59 */
			 return ast_721;
		      }
		    else
		      {		/* Ast/build.scm 59 */
			 bool_t test1479_735;
			 {	/* Ast/build.scm 59 */
			    obj_t fun1487_740;
			    fun1487_740 =
			       CAR(hooks_728);
			    {	/* Ast/build.scm 59 */
			       obj_t aux_1284;
			       aux_1284 =
				  PROCEDURE_ENTRY(fun1487_740) (fun1487_740, BEOA);
			       test1479_735 =
				  CBOOL(aux_1284);
			    }
			 }
			 if (test1479_735)
			   {	/* Ast/build.scm 59 */
			      {
				 obj_t hnames_1291;
				 obj_t hooks_1289;
				 hooks_1289 =
				    CDR(hooks_728);
				 hnames_1291 =
				    CDR(hnames_729);
				 hnames_729 = hnames_1291;
				 hooks_728 = hooks_1289;
				 goto loop_730;
			      }
			   }
			 else
			   {	/* Ast/build.scm 59 */
			      return
				 internal_error_43_tools_error(_current_pass__25_engine_pass, string1601_ast_build,
				 CAR(hnames_729));
			   }
		      }
		 }
	    }
	 }
      }
   }
}



/* _build-ast-sans-remove */
obj_t 
_build_ast_sans_remove_171_ast_build(obj_t env_1162, obj_t units_1163)
{
   AN_OBJECT;
   {	/* Ast/build.scm 45 */
      return
	 build_ast_sans_remove_93_ast_build(units_1163);
   }
}



/* sfun-def->ast */
global_bglt 
sfun_def__ast_191_ast_build(global_bglt def_3)
{
   AN_OBJECT;
   {	/* Ast/build.scm 64 */
      enter_function_81_tools_error(
	 (((global_bglt) CREF(def_3))->id));
      {		/* Ast/build.scm 66 */
	 value_bglt sfun_775;
	 sfun_775 =
	    (((global_bglt) CREF(def_3))->value);
	 {	/* Ast/build.scm 66 */
	    obj_t sfun_args_174_776;
	    {	/* Ast/build.scm 67 */
	       sfun_bglt obj_1155;
	       obj_1155 =
		  (sfun_bglt) (sfun_775);
	       sfun_args_174_776 =
		  (((sfun_bglt) CREF(obj_1155))->args);
	    }
	    {	/* Ast/build.scm 67 */
	       obj_t sfun_body_exp_131_777;
	       {	/* Ast/build.scm 68 */
		  sfun_bglt obj_1156;
		  obj_1156 =
		     (sfun_bglt) (sfun_775);
		  sfun_body_exp_131_777 =
		     (((sfun_bglt) CREF(obj_1156))->body);
	       }
	       {	/* Ast/build.scm 68 */
		  obj_t def_loc_185_778;
		  def_loc_185_778 =
		     find_location_120_tools_location(
		     (((global_bglt) CREF(def_3))->src));
		  {	/* Ast/build.scm 69 */
		     node_bglt body_779;
		     {	/* Ast/build.scm 72 */
			obj_t arg1512_780;
			obj_t arg1513_781;
			arg1512_780 =
			   find_location_loc_243_tools_location(sfun_body_exp_131_777, def_loc_185_778);
			arg1513_781 =
			   CNST_TABLE_REF(((long) 2));
			body_779 =
			   sexp__node_235_ast_sexp(sfun_body_exp_131_777, sfun_args_174_776, arg1512_780, arg1513_781);
		     }
		     {	/* Ast/build.scm 70 */

			{	/* Ast/build.scm 75 */
			   sfun_bglt obj_1158;
			   obj_t val1123_1159;
			   obj_1158 =
			      (sfun_bglt) (sfun_775);
			   val1123_1159 =
			      (obj_t) (body_779);
			   ((((sfun_bglt) CREF(obj_1158))->body) = ((obj_t) val1123_1159), BUNSPEC);
			}
			leave_function_170_tools_error();
			return def_3;
		     }
		  }
	       }
	    }
	 }
      }
   }
}



/* method-init */
obj_t 
method_init_76_ast_build()
{
   AN_OBJECT;
   {	/* Ast/build.scm 14 */
      return BUNSPEC;
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_ast_build()
{
   AN_OBJECT;
   {	/* Ast/build.scm 14 */
      module_initialization_70_tools_speek(((long) 0), "AST_BUILD");
      module_initialization_70_tools_error(((long) 0), "AST_BUILD");
      module_initialization_70_engine_pass(((long) 0), "AST_BUILD");
      module_initialization_70_type_type(((long) 0), "AST_BUILD");
      module_initialization_70_ast_var(((long) 0), "AST_BUILD");
      module_initialization_70_ast_node(((long) 0), "AST_BUILD");
      module_initialization_70_ast_unit(((long) 0), "AST_BUILD");
      module_initialization_70_ast_sexp(((long) 0), "AST_BUILD");
      module_initialization_70_ast_env(((long) 0), "AST_BUILD");
      module_initialization_70_ast_find_gdefs_13(((long) 0), "AST_BUILD");
      module_initialization_70_ast_remove(((long) 0), "AST_BUILD");
      module_initialization_70_ast_local(((long) 0), "AST_BUILD");
      module_initialization_70_object_inline(((long) 0), "AST_BUILD");
      module_initialization_70_tools_args(((long) 0), "AST_BUILD");
      module_initialization_70_tools_progn(((long) 0), "AST_BUILD");
      module_initialization_70_tools_location(((long) 0), "AST_BUILD");
      return
	 module_initialization_70_tools_shape(((long) 0), "AST_BUILD");
   }
}
