/*===========================================================================*/
/*   (Ast/check-init.scm)                                                    */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;

typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct ccomp
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t producer;
     obj_t consumer;
     obj_t finalizer;
     obj_t checksummer;
  }
     *ccomp_bglt;


extern obj_t find_global_223_ast_env(obj_t, obj_t);
static obj_t method_init_76_ast_check_global_init_17();
extern obj_t make_box_202_ast_node;
extern obj_t user_warning_location_190_tools_error(obj_t, obj_t, obj_t, obj_t);
extern obj_t funcall_ast_node;
extern obj_t symbol_append_197___r4_symbols_6_4(obj_t);
extern long add_inlined_method__244___object(obj_t, obj_t, long);
extern obj_t fail_ast_node;
extern obj_t sequence_ast_node;
extern obj_t let_var_6_ast_node;
extern obj_t var_ast_node;
static obj_t _check_global_initialization_243_ast_check_global_init_17(obj_t);
extern obj_t global_ast_var;
extern obj_t pragma_ast_node;
extern obj_t set_ex_it_116_ast_node;
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t get_object_unit_72_module_class();
extern obj_t module_initialization_70_ast_check_global_init_17(long, char *);
extern obj_t module_initialization_70_ast_env(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_module_module(long, char *);
extern obj_t module_initialization_70_module_include(long, char *);
extern obj_t module_initialization_70_module_class(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_symbols_6_4(long, char *);
static bool_t check_init__71_ast_check_global_init_17(obj_t);
static obj_t _anonymous_1511__6_ast_check_global_init_17(obj_t);
static obj_t _check_init_default1462_175_ast_check_global_init_17(obj_t, obj_t);
extern obj_t let_fun_218_ast_node;
extern obj_t fun_ast_var;
static obj_t imported_modules_init_94_ast_check_global_init_17();
static obj_t _globals__25_ast_check_global_init_17 = BUNSPEC;
static obj_t check_init_229_ast_check_global_init_17(node_bglt);
extern obj_t app_ly_162_ast_node;
extern obj_t add_generic__110___object(obj_t, obj_t);
extern obj_t app_ast_node;
static obj_t library_modules_init_112_ast_check_global_init_17();
extern obj_t cast_ast_node;
static obj_t toplevel_init_63_ast_check_global_init_17();
extern obj_t check_global_initialization_113_ast_check_global_init_17();
extern obj_t jump_ex_it_184_ast_node;
extern obj_t open_input_string(obj_t);
extern obj_t sfun_ast_var;
extern obj_t setq_ast_node;
extern obj_t box_set__221_ast_node;
extern obj_t memq___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern obj_t no_warning_128_tools_error(obj_t);
static obj_t _check_init_193_ast_check_global_init_17(obj_t, obj_t);
extern obj_t _module__166_module_module;
extern obj_t _classes__134___object;
extern obj_t select_ast_node;
extern obj_t read___reader(obj_t);
static obj_t check_init_default1462_45_ast_check_global_init_17(node_bglt);
static obj_t require_initialization_114_ast_check_global_init_17 = BUNSPEC;
extern obj_t conditional_ast_node;
extern obj_t value_ast_var;
extern obj_t get_toplevel_unit_32_module_include();
static obj_t cnst_init_137_ast_check_global_init_17();
static obj_t __cnst[3];

DEFINE_EXPORT_PROCEDURE(check_global_initialization_env_39_ast_check_global_init_17, _check_global_initialization_243_ast_check_global_init_171688, _check_global_initialization_243_ast_check_global_init_17, 0L, 0);
DEFINE_STATIC_PROCEDURE(check_init_default1462_env_125_ast_check_global_init_17, _check_init_default1462_175_ast_check_global_init_171689, _check_init_default1462_175_ast_check_global_init_17, 0L, 1);
DEFINE_STATIC_GENERIC(check_init_env_218_ast_check_global_init_17, _check_init_193_ast_check_global_init_171690, _check_init_193_ast_check_global_init_17, 0L, 1);
DEFINE_STRING(string1683_ast_check_global_init_17, string1683_ast_check_global_init_171691, "DONE UNIT -INIT ", 16);
DEFINE_STRING(string1682_ast_check_global_init_17, string1682_ast_check_global_init_171692, "Variable used before initialized", 32);
DEFINE_STRING(string1681_ast_check_global_init_17, string1681_ast_check_global_init_171693, "check-init", 10);



/* module-initialization */
obj_t 
module_initialization_70_ast_check_global_init_17(long checksum_1376, char *from_1377)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_ast_check_global_init_17))
	{
	   require_initialization_114_ast_check_global_init_17 =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_ast_check_global_init_17();
	   cnst_init_137_ast_check_global_init_17();
	   imported_modules_init_94_ast_check_global_init_17();
	   method_init_76_ast_check_global_init_17();
	   toplevel_init_63_ast_check_global_init_17();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_ast_check_global_init_17()
{
   AN_OBJECT;
   {	/* Ast/check-init.scm 18 */
      module_initialization_70___r4_symbols_6_4(((long) 0), "AST_CHECK-GLOBAL-INIT");
      module_initialization_70___object(((long) 0), "AST_CHECK-GLOBAL-INIT");
      module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "AST_CHECK-GLOBAL-INIT");
      module_initialization_70___reader(((long) 0), "AST_CHECK-GLOBAL-INIT");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_ast_check_global_init_17()
{
   AN_OBJECT;
   {	/* Ast/check-init.scm 18 */
      {		/* Ast/check-init.scm 18 */
	 obj_t cnst_port_138_1369;
	 cnst_port_138_1369 =
	    open_input_string(string1683_ast_check_global_init_17);
	 {
	    long i_1370;
	    i_1370 = ((long) 2);
	  loop_1371:
	    {	/* Ast/check-init.scm 18 */
	       bool_t test1684_1372;
	       test1684_1372 =
		  (i_1370 == ((long) -1));
	       if (test1684_1372)
		 {	/* Ast/check-init.scm 18 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Ast/check-init.scm 18 */
		    {	/* Ast/check-init.scm 18 */
		       obj_t arg1685_1373;
		       {	/* Ast/check-init.scm 18 */
			  obj_t list1686_1374;
			  list1686_1374 =
			     MAKE_PAIR(cnst_port_138_1369, BNIL);
			  arg1685_1373 =
			     read___reader(list1686_1374);
		       }
		       CNST_TABLE_SET(i_1370, arg1685_1373);
		    }
		    {	/* Ast/check-init.scm 18 */
		       int aux_1375;
		       {	/* Ast/check-init.scm 18 */
			  long aux_1396;
			  aux_1396 =
			     (i_1370 - ((long) 1));
			  aux_1375 =
			     (int) (aux_1396);
		       }
		       {
			  long i_1399;
			  i_1399 =
			     (long) (aux_1375);
			  i_1370 = i_1399;
			  goto loop_1371;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_ast_check_global_init_17()
{
   AN_OBJECT;
   {	/* Ast/check-init.scm 18 */
      _globals__25_ast_check_global_init_17 = BNIL;
      return BUNSPEC;
   }
}



/* check-global-initialization */
obj_t 
check_global_initialization_113_ast_check_global_init_17()
{
   AN_OBJECT;
   {	/* Ast/check-init.scm 33 */
      {		/* Ast/check-init.scm 34 */
	 obj_t init_name_142_757;
	 {	/* Ast/check-init.scm 34 */
	    obj_t arg1527_782;
	    obj_t arg1528_783;
	    {	/* Ast/check-init.scm 34 */
	       obj_t arg1532_786;
	       arg1532_786 =
		  get_toplevel_unit_32_module_include();
	       arg1527_782 =
		  STRUCT_REF(arg1532_786, ((long) 0));
	    }
	    arg1528_783 =
	       CNST_TABLE_REF(((long) 0));
	    {	/* Ast/check-init.scm 34 */
	       obj_t list1529_784;
	       {	/* Ast/check-init.scm 34 */
		  obj_t arg1530_785;
		  arg1530_785 =
		     MAKE_PAIR(arg1528_783, BNIL);
		  list1529_784 =
		     MAKE_PAIR(arg1527_782, arg1530_785);
	       }
	       init_name_142_757 =
		  symbol_append_197___r4_symbols_6_4(list1529_784);
	    }
	 }
	 {	/* Ast/check-init.scm 34 */
	    obj_t global_758;
	    global_758 =
	       find_global_223_ast_env(init_name_142_757, BNIL);
	    {	/* Ast/check-init.scm 35 */

	       {	/* Ast/check-init.scm 36 */
		  bool_t test1507_759;
		  {	/* Ast/check-init.scm 36 */
		     bool_t test1524_779;
		     test1524_779 =
			is_a__118___object(global_758, global_ast_var);
		     if (test1524_779)
		       {	/* ./Ast/var.scm 606 */
			  obj_t aux_1410;
			  {	/* Ast/check-init.scm 36 */
			     value_bglt aux_1411;
			     {	/* Ast/check-init.scm 36 */
				global_bglt obj_1252;
				obj_1252 =
				   (global_bglt) (global_758);
				aux_1411 =
				   (((global_bglt) CREF(obj_1252))->value);
			     }
			     aux_1410 =
				(obj_t) (aux_1411);
			  }
			  test1507_759 =
			     is_a__118___object(aux_1410, sfun_ast_var);
		       }
		     else
		       {	/* Ast/check-init.scm 36 */
			  test1507_759 = ((bool_t) 0);
		       }
		  }
		  if (test1507_759)
		    {	/* Ast/check-init.scm 36 */
		       _globals__25_ast_check_global_init_17 = BNIL;
		       {	/* Ast/check-init.scm 40 */
			  obj_t unit_760;
			  unit_760 =
			     get_object_unit_72_module_class();
			  {	/* Ast/check-init.scm 41 */
			     bool_t test_1418;
			     if (
				STRUCTP(unit_760))
			       {	/* ./Ieee/equiv.scm 5508 */
				  obj_t aux_1423;
				  obj_t aux_1421;
				  aux_1423 =
				     CNST_TABLE_REF(((long) 1));
				  aux_1421 =
				     STRUCT_KEY(unit_760);
				  test_1418 =
				     (aux_1421 == aux_1423);
			       }
			     else
			       {	/* ./Ast/unit.sch 482 */
				  test_1418 = ((bool_t) 0)
				     ;
			       }
			     if (test_1418)
			       {	/* Ast/check-init.scm 42 */
				  obj_t obj_name_139_762;
				  {	/* Ast/check-init.scm 42 */
				     obj_t arg1517_773;
				     arg1517_773 =
					STRUCT_REF(unit_760, ((long) 0));
				     {	/* Ast/check-init.scm 42 */
					obj_t list1520_775;
					{	/* Ast/check-init.scm 42 */
					   obj_t arg1521_776;
					   {	/* Ast/check-init.scm 42 */
					      obj_t aux_1427;
					      aux_1427 =
						 CNST_TABLE_REF(((long) 0));
					      arg1521_776 =
						 MAKE_PAIR(aux_1427, BNIL);
					   }
					   list1520_775 =
					      MAKE_PAIR(arg1517_773, arg1521_776);
					}
					obj_name_139_762 =
					   symbol_append_197___r4_symbols_6_4(list1520_775);
				     }
				  }
				  {	/* Ast/check-init.scm 42 */
				     obj_t global_763;
				     global_763 =
					find_global_223_ast_env(obj_name_139_762, BNIL);
				     {	/* Ast/check-init.scm 43 */

					{	/* Ast/check-init.scm 44 */
					   bool_t test1509_764;
					   {	/* Ast/check-init.scm 44 */
					      bool_t test1514_770;
					      test1514_770 =
						 is_a__118___object(global_763, global_ast_var);
					      if (test1514_770)
						{	/* ./Ast/var.scm 606 */
						   obj_t aux_1435;
						   {	/* Ast/check-init.scm 44 */
						      value_bglt aux_1436;
						      {		/* Ast/check-init.scm 44 */
							 global_bglt obj_1266;
							 obj_1266 =
							    (global_bglt) (global_763);
							 aux_1436 =
							    (((global_bglt) CREF(obj_1266))->value);
						      }
						      aux_1435 =
							 (obj_t) (aux_1436);
						   }
						   test1509_764 =
						      is_a__118___object(aux_1435, sfun_ast_var);
						}
					      else
						{	/* Ast/check-init.scm 44 */
						   test1509_764 = ((bool_t) 0);
						}
					   }
					   if (test1509_764)
					     {	/* Ast/check-init.scm 52 */
						obj_t _anonymous_1511__6_1360;
						_anonymous_1511__6_1360 =
						   make_fx_procedure(_anonymous_1511__6_ast_check_global_init_17, ((long) 0), ((long) 1));
						PROCEDURE_SET(_anonymous_1511__6_1360, ((long) 0), global_763);
						no_warning_128_tools_error(_anonymous_1511__6_1360);
					     }
					   else
					     {	/* Ast/check-init.scm 44 */
						BUNSPEC;
					     }
					}
				     }
				  }
			       }
			     else
			       {	/* Ast/check-init.scm 41 */
				  BUNSPEC;
			       }
			  }
		       }
		       {	/* Ast/check-init.scm 54 */
			  node_bglt aux_1445;
			  {	/* Ast/check-init.scm 54 */
			     obj_t aux_1446;
			     {	/* Ast/check-init.scm 54 */
				sfun_bglt obj_1271;
				{	/* Ast/check-init.scm 54 */
				   value_bglt aux_1447;
				   {	/* Ast/check-init.scm 54 */
				      global_bglt obj_1270;
				      obj_1270 =
					 (global_bglt) (global_758);
				      aux_1447 =
					 (((global_bglt) CREF(obj_1270))->value);
				   }
				   obj_1271 =
				      (sfun_bglt) (aux_1447);
				}
				aux_1446 =
				   (((sfun_bglt) CREF(obj_1271))->body);
			     }
			     aux_1445 =
				(node_bglt) (aux_1446);
			  }
			  check_init_229_ast_check_global_init_17(aux_1445);
		       }
		       return (
			  _globals__25_ast_check_global_init_17 = BNIL, BUNSPEC);
		    }
		  else
		    {	/* Ast/check-init.scm 36 */
		       return BUNSPEC;
		    }
	       }
	    }
	 }
      }
   }
}



/* _check-global-initialization */
obj_t 
_check_global_initialization_243_ast_check_global_init_17(obj_t env_1361)
{
   AN_OBJECT;
   {	/* Ast/check-init.scm 33 */
      return
	 check_global_initialization_113_ast_check_global_init_17();
   }
}



/* <anonymous:1511> */
obj_t 
_anonymous_1511__6_ast_check_global_init_17(obj_t env_1362)
{
   AN_OBJECT;
   {	/* Ast/check-init.scm 50 */
      {		/* Ast/check-init.scm 52 */
	 obj_t global_1363;
	 global_1363 =
	    PROCEDURE_REF(env_1362, ((long) 0));
	 {

	    {	/* Ast/check-init.scm 51 */
	       node_bglt aux_1456;
	       {	/* Ast/check-init.scm 51 */
		  obj_t aux_1457;
		  {	/* Ast/check-init.scm 52 */
		     sfun_bglt obj_1269;
		     {	/* Ast/check-init.scm 52 */
			value_bglt aux_1458;
			{	/* Ast/check-init.scm 52 */
			   global_bglt obj_1268;
			   obj_1268 =
			      (global_bglt) (global_1363);
			   aux_1458 =
			      (((global_bglt) CREF(obj_1268))->value);
			}
			obj_1269 =
			   (sfun_bglt) (aux_1458);
		     }
		     aux_1457 =
			(((sfun_bglt) CREF(obj_1269))->body);
		  }
		  aux_1456 =
		     (node_bglt) (aux_1457);
	       }
	       return
		  check_init_229_ast_check_global_init_17(aux_1456);
	    }
	 }
      }
   }
}



/* check-init* */
bool_t 
check_init__71_ast_check_global_init_17(obj_t node__221_40)
{
   AN_OBJECT;
   {	/* Ast/check-init.scm 235 */
      {
	 obj_t l1459_787;
	 l1459_787 = node__221_40;
       lname1460_788:
	 if (
	    PAIRP(l1459_787))
	   {	/* Ast/check-init.scm 236 */
	      {		/* Ast/check-init.scm 236 */
		 node_bglt aux_1467;
		 {	/* Ast/check-init.scm 236 */
		    obj_t aux_1468;
		    aux_1468 =
		       CAR(l1459_787);
		    aux_1467 =
		       (node_bglt) (aux_1468);
		 }
		 check_init_229_ast_check_global_init_17(aux_1467);
	      }
	      {
		 obj_t l1459_1472;
		 l1459_1472 =
		    CDR(l1459_787);
		 l1459_787 = l1459_1472;
		 goto lname1460_788;
	      }
	   }
	 else
	   {	/* Ast/check-init.scm 236 */
	      return ((bool_t) 1);
	   }
      }
   }
}



/* method-init */
obj_t 
method_init_76_ast_check_global_init_17()
{
   AN_OBJECT;
   {	/* Ast/check-init.scm 18 */
      add_generic__110___object(check_init_env_218_ast_check_global_init_17, check_init_default1462_env_125_ast_check_global_init_17);
      add_inlined_method__244___object(check_init_env_218_ast_check_global_init_17, var_ast_node, ((long) 0));
      add_inlined_method__244___object(check_init_env_218_ast_check_global_init_17, sequence_ast_node, ((long) 1));
      add_inlined_method__244___object(check_init_env_218_ast_check_global_init_17, app_ast_node, ((long) 2));
      add_inlined_method__244___object(check_init_env_218_ast_check_global_init_17, app_ly_162_ast_node, ((long) 3));
      add_inlined_method__244___object(check_init_env_218_ast_check_global_init_17, funcall_ast_node, ((long) 4));
      add_inlined_method__244___object(check_init_env_218_ast_check_global_init_17, pragma_ast_node, ((long) 5));
      add_inlined_method__244___object(check_init_env_218_ast_check_global_init_17, cast_ast_node, ((long) 6));
      add_inlined_method__244___object(check_init_env_218_ast_check_global_init_17, setq_ast_node, ((long) 7));
      add_inlined_method__244___object(check_init_env_218_ast_check_global_init_17, conditional_ast_node, ((long) 8));
      add_inlined_method__244___object(check_init_env_218_ast_check_global_init_17, fail_ast_node, ((long) 9));
      add_inlined_method__244___object(check_init_env_218_ast_check_global_init_17, select_ast_node, ((long) 10));
      add_inlined_method__244___object(check_init_env_218_ast_check_global_init_17, let_fun_218_ast_node, ((long) 11));
      add_inlined_method__244___object(check_init_env_218_ast_check_global_init_17, let_var_6_ast_node, ((long) 12));
      add_inlined_method__244___object(check_init_env_218_ast_check_global_init_17, set_ex_it_116_ast_node, ((long) 13));
      add_inlined_method__244___object(check_init_env_218_ast_check_global_init_17, jump_ex_it_184_ast_node, ((long) 14));
      add_inlined_method__244___object(check_init_env_218_ast_check_global_init_17, make_box_202_ast_node, ((long) 15));
      {		/* Ast/check-init.scm 18 */
	 long aux_1491;
	 aux_1491 =
	    add_inlined_method__244___object(check_init_env_218_ast_check_global_init_17, box_set__221_ast_node, ((long) 16));
	 return
	    BINT(aux_1491);
      }
   }
}



/* check-init */
obj_t 
check_init_229_ast_check_global_init_17(node_bglt node_21)
{
   AN_OBJECT;
   {	/* Ast/check-init.scm 85 */
    check_init_229_ast_check_global_init_17:
      {
	 obj_t method1616_1131;
	 obj_t class1621_1132;
	 {	/* Ast/check-init.scm 85 */
	    obj_t arg1624_1129;
	    obj_t arg1625_1130;
	    {	/* Ast/check-init.scm 85 */
	       object_bglt obj_1277;
	       obj_1277 =
		  (object_bglt) (node_21);
	       {	/* ./Llib/object.scm 2926 */
		  obj_t pre_method_105_1278;
		  pre_method_105_1278 =
		     PROCEDURE_REF(check_init_env_218_ast_check_global_init_17, ((long) 2));
		  if (
		     INTEGERP(pre_method_105_1278))
		    {	/* ./Llib/object.scm 2927 */
		       PROCEDURE_SET(check_init_env_218_ast_check_global_init_17, ((long) 2), BUNSPEC);
		       arg1624_1129 = pre_method_105_1278;
		    }
		  else
		    {	/* ./Llib/object.scm 2914 */
		       long obj_class_num_177_1283;
		       obj_class_num_177_1283 =
			  TYPE(obj_1277);
		       {	/* ./Llib/object.scm 2915 */
			  obj_t arg1176_1284;
			  arg1176_1284 =
			     PROCEDURE_REF(check_init_env_218_ast_check_global_init_17, ((long) 1));
			  {	/* ./Llib/object.scm 2738 */
			     long arg1177_1288;
			     {	/* ./Llib/object.scm 2738 */
				long arg1178_1289;
				arg1178_1289 =
				   OBJECT_TYPE;
				arg1177_1288 =
				   (obj_class_num_177_1283 - arg1178_1289);
			     }
			     arg1624_1129 =
				VECTOR_REF(arg1176_1284, arg1177_1288);
			  }
		       }
		    }
	       }
	    }
	    {	/* Ast/check-init.scm 85 */
	       object_bglt object_1294;
	       object_1294 =
		  (object_bglt) (node_21);
	       {	/* ./Llib/object.scm 2695 */
		  long arg1179_1295;
		  {	/* ./Llib/object.scm 2695 */
		     long arg1180_1296;
		     long arg1181_1297;
		     arg1180_1296 =
			TYPE(object_1294);
		     arg1181_1297 =
			OBJECT_TYPE;
		     arg1179_1295 =
			(arg1180_1296 - arg1181_1297);
		  }
		  {	/* ./Llib/object.scm 2695 */
		     obj_t vector_1301;
		     vector_1301 = _classes__134___object;
		     arg1625_1130 =
			VECTOR_REF(vector_1301, arg1179_1295);
		  }
	       }
	    }
	    method1616_1131 = arg1624_1129;
	    class1621_1132 = arg1625_1130;
	    {

	       if (
		  INTEGERP(method1616_1131))
		 {	/* Ast/check-init.scm 85 */
		    switch (
		       (long) CINT(method1616_1131))
		      {
		      case ((long) 0):

			 {	/* Ast/check-init.scm 92 */
			    var_bglt node_1138;
			    node_1138 =
			       (var_bglt) (node_21);
			    {	/* Ast/check-init.scm 92 */
			       variable_bglt var_1139;
			       var_1139 =
				  (((var_bglt) CREF(node_1138))->variable);
			       {	/* Ast/check-init.scm 93 */
				  bool_t test1628_1140;
				  {	/* Ast/check-init.scm 93 */
				     bool_t test1633_1145;
				     test1633_1145 =
					is_a__118___object(
					(obj_t) (var_1139), global_ast_var);
				     if (test1633_1145)
				       {	/* Ast/check-init.scm 94 */
					  bool_t test1634_1146;
					  {	/* ./Ast/var.scm 592 */
					     obj_t aux_1516;
					     {	/* Ast/check-init.scm 94 */
						value_bglt aux_1517;
						{	/* Ast/check-init.scm 94 */
						   global_bglt obj_1305;
						   obj_1305 =
						      (global_bglt) (var_1139);
						   aux_1517 =
						      (((global_bglt) CREF(obj_1305))->value);
						}
						aux_1516 =
						   (obj_t) (aux_1517);
					     }
					     test1634_1146 =
						is_a__118___object(aux_1516, fun_ast_var);
					  }
					  if (test1634_1146)
					    {	/* Ast/check-init.scm 94 */
					       test1628_1140 = ((bool_t) 0);
					    }
					  else
					    {	/* Ast/check-init.scm 95 */
					       bool_t test1635_1147;
					       {	/* Ast/check-init.scm 80 */
						  obj_t aux_1523;
						  aux_1523 =
						     memq___r4_pairs_and_lists_6_3(
						     (obj_t) (var_1139), _globals__25_ast_check_global_init_17);
						  test1635_1147 =
						     CBOOL(aux_1523);
					       }
					       if (test1635_1147)
						 {	/* Ast/check-init.scm 95 */
						    test1628_1140 = ((bool_t) 0);
						 }
					       else
						 {	/* Ast/check-init.scm 96 */
						    obj_t obj2_1310;
						    obj2_1310 = _module__166_module_module;
						    {	/* ./Ieee/equiv.scm 5508 */
						       obj_t aux_1528;
						       {	/* Ast/check-init.scm 96 */
							  global_bglt obj_1308;
							  obj_1308 =
							     (global_bglt) (var_1139);
							  aux_1528 =
							     (((global_bglt) CREF(obj_1308))->module);
						       }
						       test1628_1140 =
							  (aux_1528 == obj2_1310);
						    }
						 }
					    }
				       }
				     else
				       {	/* Ast/check-init.scm 93 */
					  test1628_1140 = ((bool_t) 0);
				       }
				  }
				  if (test1628_1140)
				    {	/* Ast/check-init.scm 93 */
				       {	/* Ast/check-init.scm 98 */
					  obj_t aux_1533;
					  {	/* Ast/check-init.scm 98 */
					     node_bglt obj_1311;
					     obj_1311 =
						(node_bglt) (node_1138);
					     aux_1533 =
						(((node_bglt) CREF(obj_1311))->loc);
					  }
					  user_warning_location_190_tools_error(aux_1533, string1681_ast_check_global_init_17, string1682_ast_check_global_init_17,
					     (((variable_bglt) CREF(var_1139))->id));
				       }
				       {	/* Ast/check-init.scm 74 */
					  obj_t obj2_1315;
					  obj2_1315 = _globals__25_ast_check_global_init_17;
					  {	/* ./Ieee/pair-list.scm 5689 */
					     obj_t aux_1538;
					     aux_1538 =
						(obj_t) (var_1139);
					     return (
						_globals__25_ast_check_global_init_17 =
						MAKE_PAIR(aux_1538, obj2_1315), BUNSPEC);
					  }
				       }
				    }
				  else
				    {	/* Ast/check-init.scm 93 */
				       return BUNSPEC;
				    }
			       }
			    }
			 }
			 break;
		      case ((long) 1):

			 {	/* Ast/check-init.scm 108 */
			    sequence_bglt node_1150;
			    node_1150 =
			       (sequence_bglt) (node_21);
			    {	/* Ast/check-init.scm 108 */
			       bool_t aux_1542;
			       aux_1542 =
				  check_init__71_ast_check_global_init_17(
				  (((sequence_bglt) CREF(node_1150))->nodes));
			       return
				  BBOOL(aux_1542);
			    }
			 }
			 break;
		      case ((long) 2):

			 {	/* Ast/check-init.scm 114 */
			    app_bglt node_1152;
			    node_1152 =
			       (app_bglt) (node_21);
			    {	/* Ast/check-init.scm 115 */
			       bool_t aux_1547;
			       aux_1547 =
				  check_init__71_ast_check_global_init_17(
				  (((app_bglt) CREF(node_1152))->args));
			       return
				  BBOOL(aux_1547);
			    }
			 }
			 break;
		      case ((long) 3):

			 {	/* Ast/check-init.scm 121 */
			    app_ly_162_bglt node_1155;
			    node_1155 =
			       (app_ly_162_bglt) (node_21);
			    {	/* Ast/check-init.scm 122 */
			       obj_t arg1640_1157;
			       arg1640_1157 =
				  check_init_229_ast_check_global_init_17(
				  (((app_ly_162_bglt) CREF(node_1155))->fun));
			       {	/* Ast/check-init.scm 122 */
				  node_bglt val1231_1320;
				  val1231_1320 =
				     (node_bglt) (arg1640_1157);
				  ((((app_ly_162_bglt) CREF(node_1155))->fun) = ((node_bglt) val1231_1320), BUNSPEC);
			       }
			    }
			    {	/* Ast/check-init.scm 123 */
			       obj_t arg1642_1159;
			       arg1642_1159 =
				  check_init_229_ast_check_global_init_17(
				  (((app_ly_162_bglt) CREF(node_1155))->arg));
			       {	/* Ast/check-init.scm 123 */
				  node_bglt val1232_1323;
				  val1232_1323 =
				     (node_bglt) (arg1642_1159);
				  return
				     ((((app_ly_162_bglt) CREF(node_1155))->arg) = ((node_bglt) val1232_1323), BUNSPEC);
			       }
			    }
			 }
			 break;
		      case ((long) 4):

			 {	/* Ast/check-init.scm 129 */
			    funcall_bglt node_1161;
			    node_1161 =
			       (funcall_bglt) (node_21);
			    check_init_229_ast_check_global_init_17(
			       (((funcall_bglt) CREF(node_1161))->fun));
			    {	/* Ast/check-init.scm 131 */
			       bool_t aux_1563;
			       aux_1563 =
				  check_init__71_ast_check_global_init_17(
				  (((funcall_bglt) CREF(node_1161))->args));
			       return
				  BBOOL(aux_1563);
			    }
			 }
			 break;
		      case ((long) 5):

			 {	/* Ast/check-init.scm 137 */
			    pragma_bglt node_1165;
			    node_1165 =
			       (pragma_bglt) (node_21);
			    {	/* Ast/check-init.scm 137 */
			       bool_t aux_1568;
			       aux_1568 =
				  check_init__71_ast_check_global_init_17(
				  (((pragma_bglt) CREF(node_1165))->args));
			       return
				  BBOOL(aux_1568);
			    }
			 }
			 break;
		      case ((long) 6):

			 {	/* Ast/check-init.scm 143 */
			    cast_bglt node_1167;
			    node_1167 =
			       (cast_bglt) (node_21);
			    {
			       node_bglt node_1573;
			       node_1573 =
				  (((cast_bglt) CREF(node_1167))->arg);
			       node_21 = node_1573;
			       goto check_init_229_ast_check_global_init_17;
			    }
			 }
			 break;
		      case ((long) 7):

			 {	/* Ast/check-init.scm 85 */
			    setq_bglt node_1169;
			    node_1169 =
			       (setq_bglt) (node_21);
			    {	/* Ast/check-init.scm 152 */
			       variable_bglt var_1170;
			       {	/* Ast/check-init.scm 152 */
				  var_bglt arg1650_1172;
				  arg1650_1172 =
				     (((setq_bglt) CREF(node_1169))->var);
				  var_1170 =
				     (((var_bglt) CREF(arg1650_1172))->variable);
			       }
			       {	/* Ast/check-init.scm 153 */
				  bool_t test1649_1171;
				  test1649_1171 =
				     is_a__118___object(
				     (obj_t) (var_1170), global_ast_var);
				  if (test1649_1171)
				    {	/* Ast/check-init.scm 74 */
				       obj_t obj2_1333;
				       obj2_1333 = _globals__25_ast_check_global_init_17;
				       {	/* ./Ieee/pair-list.scm 5689 */
					  obj_t aux_1581;
					  aux_1581 =
					     (obj_t) (var_1170);
					  _globals__25_ast_check_global_init_17 =
					     MAKE_PAIR(aux_1581, obj2_1333);
				       }
				    }
				  else
				    {	/* Ast/check-init.scm 153 */
				       BUNSPEC;
				    }
			       }
			    }
			    {
			       node_bglt node_1584;
			       node_1584 =
				  (((setq_bglt) CREF(node_1169))->value);
			       node_21 = node_1584;
			       goto check_init_229_ast_check_global_init_17;
			    }
			 }
			 break;
		      case ((long) 8):

			 {	/* Ast/check-init.scm 161 */
			    conditional_bglt node_1174;
			    node_1174 =
			       (conditional_bglt) (node_21);
			    check_init_229_ast_check_global_init_17(
			       (((conditional_bglt) CREF(node_1174))->test));
			    check_init_229_ast_check_global_init_17(
			       (((conditional_bglt) CREF(node_1174))->true));
			    {
			       node_bglt node_1591;
			       node_1591 =
				  (((conditional_bglt) CREF(node_1174))->false);
			       node_21 = node_1591;
			       goto check_init_229_ast_check_global_init_17;
			    }
			 }
			 break;
		      case ((long) 9):

			 {	/* Ast/check-init.scm 170 */
			    fail_bglt node_1179;
			    node_1179 =
			       (fail_bglt) (node_21);
			    check_init_229_ast_check_global_init_17(
			       (((fail_bglt) CREF(node_1179))->proc));
			    check_init_229_ast_check_global_init_17(
			       (((fail_bglt) CREF(node_1179))->msg));
			    {
			       node_bglt node_1598;
			       node_1598 =
				  (((fail_bglt) CREF(node_1179))->obj);
			       node_21 = node_1598;
			       goto check_init_229_ast_check_global_init_17;
			    }
			 }
			 break;
		      case ((long) 10):

			 {	/* Ast/check-init.scm 179 */
			    select_bglt node_1184;
			    node_1184 =
			       (select_bglt) (node_21);
			    check_init_229_ast_check_global_init_17(
			       (((select_bglt) CREF(node_1184))->test));
			    {
			       obj_t l1451_1187;
			       {	/* Ast/check-init.scm 181 */
				  bool_t aux_1603;
				  l1451_1187 =
				     (((select_bglt) CREF(node_1184))->clauses);
				lname1452_1188:
				  if (
				     PAIRP(l1451_1187))
				    {	/* Ast/check-init.scm 181 */
				       {	/* Ast/check-init.scm 182 */
					  node_bglt aux_1606;
					  {	/* Ast/check-init.scm 182 */
					     obj_t aux_1607;
					     {	/* ./Ieee/pair-list.scm 5707 */
						obj_t aux_1608;
						aux_1608 =
						   CAR(l1451_1187);
						aux_1607 =
						   CDR(aux_1608);
					     }
					     aux_1606 =
						(node_bglt) (aux_1607);
					  }
					  check_init_229_ast_check_global_init_17(aux_1606);
				       }
				       {
					  obj_t l1451_1613;
					  l1451_1613 =
					     CDR(l1451_1187);
					  l1451_1187 = l1451_1613;
					  goto lname1452_1188;
				       }
				    }
				  else
				    {	/* Ast/check-init.scm 181 */
				       aux_1603 = ((bool_t) 1);
				    }
				  return
				     BBOOL(aux_1603);
			       }
			    }
			 }
			 break;
		      case ((long) 11):

			 {	/* Ast/check-init.scm 192 */
			    let_fun_218_bglt node_1194;
			    node_1194 =
			       (let_fun_218_bglt) (node_21);
			    {
			       node_bglt node_1618;
			       node_1618 =
				  (((let_fun_218_bglt) CREF(node_1194))->body);
			       node_21 = node_1618;
			       goto check_init_229_ast_check_global_init_17;
			    }
			 }
			 break;
		      case ((long) 12):

			 {	/* Ast/check-init.scm 199 */
			    let_var_6_bglt node_1197;
			    node_1197 =
			       (let_var_6_bglt) (node_21);
			    check_init_229_ast_check_global_init_17(
			       (((let_var_6_bglt) CREF(node_1197))->body));
			    {
			       obj_t l1455_1200;
			       {	/* Ast/check-init.scm 201 */
				  bool_t aux_1623;
				  l1455_1200 =
				     (((let_var_6_bglt) CREF(node_1197))->bindings);
				lname1456_1201:
				  if (
				     PAIRP(l1455_1200))
				    {	/* Ast/check-init.scm 201 */
				       {	/* Ast/check-init.scm 202 */
					  node_bglt aux_1626;
					  {	/* Ast/check-init.scm 202 */
					     obj_t aux_1627;
					     {	/* ./Ieee/pair-list.scm 5707 */
						obj_t aux_1628;
						aux_1628 =
						   CAR(l1455_1200);
						aux_1627 =
						   CDR(aux_1628);
					     }
					     aux_1626 =
						(node_bglt) (aux_1627);
					  }
					  check_init_229_ast_check_global_init_17(aux_1626);
				       }
				       {
					  obj_t l1455_1633;
					  l1455_1633 =
					     CDR(l1455_1200);
					  l1455_1200 = l1455_1633;
					  goto lname1456_1201;
				       }
				    }
				  else
				    {	/* Ast/check-init.scm 201 */
				       aux_1623 = ((bool_t) 1);
				    }
				  return
				     BBOOL(aux_1623);
			       }
			    }
			 }
			 break;
		      case ((long) 13):

			 {	/* Ast/check-init.scm 209 */
			    set_ex_it_116_bglt node_1207;
			    node_1207 =
			       (set_ex_it_116_bglt) (node_21);
			    {
			       node_bglt node_1638;
			       node_1638 =
				  (((set_ex_it_116_bglt) CREF(node_1207))->body);
			       node_21 = node_1638;
			       goto check_init_229_ast_check_global_init_17;
			    }
			 }
			 break;
		      case ((long) 14):

			 {	/* Ast/check-init.scm 85 */
			    jump_ex_it_184_bglt node_1209;
			    node_1209 =
			       (jump_ex_it_184_bglt) (node_21);
			    check_init_229_ast_check_global_init_17(
			       (((jump_ex_it_184_bglt) CREF(node_1209))->exit));
			    {
			       node_bglt node_1643;
			       node_1643 =
				  (node_bglt) (value_ast_var);
			       node_21 = node_1643;
			       goto check_init_229_ast_check_global_init_17;
			    }
			 }
			 break;
		      case ((long) 15):

			 {	/* Ast/check-init.scm 223 */
			    make_box_202_bglt node_1212;
			    node_1212 =
			       (make_box_202_bglt) (node_21);
			    {
			       node_bglt node_1646;
			       node_1646 =
				  (((make_box_202_bglt) CREF(node_1212))->value);
			       node_21 = node_1646;
			       goto check_init_229_ast_check_global_init_17;
			    }
			 }
			 break;
		      case ((long) 16):

			 {	/* Ast/check-init.scm 229 */
			    box_set__221_bglt node_1214;
			    node_1214 =
			       (box_set__221_bglt) (node_21);
			    {
			       node_bglt node_1649;
			       node_1649 =
				  (((box_set__221_bglt) CREF(node_1214))->value);
			       node_21 = node_1649;
			       goto check_init_229_ast_check_global_init_17;
			    }
			 }
			 break;
		      default:
		       case_else1622_1135:
			 if (
			    PROCEDUREP(method1616_1131))
			   {	/* Ast/check-init.scm 85 */
			      return
				 PROCEDURE_ENTRY(method1616_1131) (method1616_1131,
				 (obj_t) (node_21), BEOA);
			   }
			 else
			   {	/* Ast/check-init.scm 85 */
			      obj_t fun1615_1127;
			      fun1615_1127 =
				 PROCEDURE_REF(check_init_env_218_ast_check_global_init_17, ((long) 0));
			      return
				 PROCEDURE_ENTRY(fun1615_1127) (fun1615_1127,
				 (obj_t) (node_21), BEOA);
			   }
		      }
		 }
	       else
		 {	/* Ast/check-init.scm 85 */
		    goto case_else1622_1135;
		 }
	    }
	 }
      }
   }
}



/* _check-init */
obj_t 
_check_init_193_ast_check_global_init_17(obj_t env_1364, obj_t node_1365)
{
   AN_OBJECT;
   {	/* Ast/check-init.scm 85 */
      return
	 check_init_229_ast_check_global_init_17(
	 (node_bglt) (node_1365));
   }
}



/* check-init-default1462 */
obj_t 
check_init_default1462_45_ast_check_global_init_17(node_bglt node_22)
{
   AN_OBJECT;
   {	/* Ast/check-init.scm 18 */
      return
	 CNST_TABLE_REF(((long) 2));
   }
}



/* _check-init-default1462 */
obj_t 
_check_init_default1462_175_ast_check_global_init_17(obj_t env_1366, obj_t node_1367)
{
   AN_OBJECT;
   {	/* Ast/check-init.scm 18 */
      return
	 check_init_default1462_45_ast_check_global_init_17(
	 (node_bglt) (node_1367));
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_ast_check_global_init_17()
{
   AN_OBJECT;
   {	/* Ast/check-init.scm 18 */
      module_initialization_70_ast_env(((long) 0), "AST_CHECK-GLOBAL-INIT");
      module_initialization_70_ast_var(((long) 0), "AST_CHECK-GLOBAL-INIT");
      module_initialization_70_ast_node(((long) 0), "AST_CHECK-GLOBAL-INIT");
      module_initialization_70_tools_error(((long) 0), "AST_CHECK-GLOBAL-INIT");
      module_initialization_70_type_type(((long) 0), "AST_CHECK-GLOBAL-INIT");
      module_initialization_70_module_module(((long) 0), "AST_CHECK-GLOBAL-INIT");
      module_initialization_70_module_include(((long) 0), "AST_CHECK-GLOBAL-INIT");
      return
	 module_initialization_70_module_class(((long) 0), "AST_CHECK-GLOBAL-INIT");
   }
}
