/*===========================================================================*/
/*   (Ast/dump.scm)                                                          */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;


extern obj_t location_shape_18_tools_location(obj_t, obj_t);
static obj_t method_init_76_ast_dump();
extern obj_t make_box_202_ast_node;
extern obj_t funcall_ast_node;
extern obj_t symbol_append_197___r4_symbols_6_4(obj_t);
extern long add_inlined_method__244___object(obj_t, obj_t, long);
extern obj_t fail_ast_node;
extern obj_t _type_shape___78_engine_param;
extern obj_t box_ref_242_ast_node;
extern obj_t sequence_ast_node;
extern obj_t let_var_6_ast_node;
extern obj_t var_ast_node;
extern obj_t closure_ast_node;
extern obj_t create_struct(obj_t, long);
extern obj_t pragma_ast_node;
extern obj_t set_ex_it_116_ast_node;
static obj_t _node__sexp_default1484_134_ast_dump(obj_t, obj_t);
extern obj_t node__sexp_247_ast_dump(node_bglt);
extern obj_t module_initialization_70_ast_dump(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_args(long, char *);
extern obj_t module_initialization_70_tools_misc(long, char *);
extern obj_t module_initialization_70_tools_location(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_symbols_6_4(long, char *);
extern obj_t let_fun_218_ast_node;
static obj_t imported_modules_init_94_ast_dump();
extern obj_t app_ly_162_ast_node;
extern obj_t add_generic__110___object(obj_t, obj_t);
extern obj_t app_ast_node;
extern obj_t append_2_18___r4_pairs_and_lists_6_3(obj_t, obj_t);
static obj_t library_modules_init_112_ast_dump();
extern obj_t atom_ast_node;
extern obj_t cast_ast_node;
static obj_t toplevel_init_63_ast_dump();
static obj_t _node__sexp_17_ast_dump(obj_t, obj_t);
extern obj_t create_vector(long);
extern obj_t jump_ex_it_184_ast_node;
extern obj_t open_input_string(obj_t);
extern obj_t kwote_ast_node;
extern obj_t setq_ast_node;
extern obj_t box_set__221_ast_node;
extern obj_t shape_tools_shape(obj_t);
static obj_t node__sexp_default1484_49_ast_dump(node_bglt);
extern obj_t _4dots_199_tools_misc;
extern obj_t _classes__134___object;
extern obj_t select_ast_node;
extern obj_t read___reader(obj_t);
extern obj_t args_list__args__33_tools_args(obj_t, obj_t);
static obj_t require_initialization_114_ast_dump = BUNSPEC;
extern obj_t conditional_ast_node;
static obj_t cnst_init_137_ast_dump();
static obj_t __cnst[26];

DEFINE_EXPORT_GENERIC(node__sexp_env_62_ast_dump, _node__sexp_17_ast_dump1951, _node__sexp_17_ast_dump, 0L, 1);
DEFINE_STATIC_PROCEDURE(node__sexp_default1484_env_110_ast_dump, _node__sexp_default1484_134_ast_dump1952, _node__sexp_default1484_134_ast_dump, 0L, 1);
DEFINE_STRING(string1946_ast_dump, string1946_ast_dump1953, "NODE->SEXP-DEFAULT1484 BOX-SET! BOX-REF MAKE-BOX JUMP-EXIT SET-EXIT LET LABELS CASE FAILURE IF SET! CAST FREE-PRAGMA PRAGMA FUNCALL FUNCALL-EL ELIGHT FUNCALL-L LIGHT APPLY BEGIN QUOTE A-TVECTOR FUNCTION (QUOTE ()) ", 214);
DEFINE_STRING(string1945_ast_dump, string1945_ast_dump1954, "No method for this object", 25);



/* module-initialization */
obj_t 
module_initialization_70_ast_dump(long checksum_1868, char *from_1869)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_ast_dump))
	{
	   require_initialization_114_ast_dump =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_ast_dump();
	   cnst_init_137_ast_dump();
	   imported_modules_init_94_ast_dump();
	   method_init_76_ast_dump();
	   toplevel_init_63_ast_dump();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_ast_dump()
{
   AN_OBJECT;
   {	/* Ast/dump.scm 14 */
      module_initialization_70___r4_symbols_6_4(((long) 0), "AST_DUMP");
      module_initialization_70___object(((long) 0), "AST_DUMP");
      module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "AST_DUMP");
      module_initialization_70___reader(((long) 0), "AST_DUMP");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_ast_dump()
{
   AN_OBJECT;
   {	/* Ast/dump.scm 14 */
      {		/* Ast/dump.scm 14 */
	 obj_t cnst_port_138_1861;
	 cnst_port_138_1861 =
	    open_input_string(string1946_ast_dump);
	 {
	    long i_1862;
	    i_1862 = ((long) 25);
	  loop_1863:
	    {	/* Ast/dump.scm 14 */
	       bool_t test1947_1864;
	       test1947_1864 =
		  (i_1862 == ((long) -1));
	       if (test1947_1864)
		 {	/* Ast/dump.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Ast/dump.scm 14 */
		    {	/* Ast/dump.scm 14 */
		       obj_t arg1948_1865;
		       {	/* Ast/dump.scm 14 */
			  obj_t list1949_1866;
			  list1949_1866 =
			     MAKE_PAIR(cnst_port_138_1861, BNIL);
			  arg1948_1865 =
			     read___reader(list1949_1866);
		       }
		       CNST_TABLE_SET(i_1862, arg1948_1865);
		    }
		    {	/* Ast/dump.scm 14 */
		       int aux_1867;
		       {	/* Ast/dump.scm 14 */
			  long aux_1888;
			  aux_1888 =
			     (i_1862 - ((long) 1));
			  aux_1867 =
			     (int) (aux_1888);
		       }
		       {
			  long i_1891;
			  i_1891 =
			     (long) (aux_1867);
			  i_1862 = i_1891;
			  goto loop_1863;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_ast_dump()
{
   AN_OBJECT;
   {	/* Ast/dump.scm 14 */
      return BUNSPEC;
   }
}



/* method-init */
obj_t 
method_init_76_ast_dump()
{
   AN_OBJECT;
   {	/* Ast/dump.scm 14 */
      add_generic__110___object(node__sexp_env_62_ast_dump, node__sexp_default1484_env_110_ast_dump);
      add_inlined_method__244___object(node__sexp_env_62_ast_dump, atom_ast_node, ((long) 0));
      add_inlined_method__244___object(node__sexp_env_62_ast_dump, var_ast_node, ((long) 1));
      add_inlined_method__244___object(node__sexp_env_62_ast_dump, closure_ast_node, ((long) 2));
      add_inlined_method__244___object(node__sexp_env_62_ast_dump, kwote_ast_node, ((long) 3));
      add_inlined_method__244___object(node__sexp_env_62_ast_dump, sequence_ast_node, ((long) 4));
      add_inlined_method__244___object(node__sexp_env_62_ast_dump, app_ast_node, ((long) 5));
      add_inlined_method__244___object(node__sexp_env_62_ast_dump, app_ly_162_ast_node, ((long) 6));
      add_inlined_method__244___object(node__sexp_env_62_ast_dump, funcall_ast_node, ((long) 7));
      add_inlined_method__244___object(node__sexp_env_62_ast_dump, pragma_ast_node, ((long) 8));
      add_inlined_method__244___object(node__sexp_env_62_ast_dump, cast_ast_node, ((long) 9));
      add_inlined_method__244___object(node__sexp_env_62_ast_dump, setq_ast_node, ((long) 10));
      add_inlined_method__244___object(node__sexp_env_62_ast_dump, conditional_ast_node, ((long) 11));
      add_inlined_method__244___object(node__sexp_env_62_ast_dump, fail_ast_node, ((long) 12));
      add_inlined_method__244___object(node__sexp_env_62_ast_dump, select_ast_node, ((long) 13));
      add_inlined_method__244___object(node__sexp_env_62_ast_dump, let_fun_218_ast_node, ((long) 14));
      add_inlined_method__244___object(node__sexp_env_62_ast_dump, let_var_6_ast_node, ((long) 15));
      add_inlined_method__244___object(node__sexp_env_62_ast_dump, set_ex_it_116_ast_node, ((long) 16));
      add_inlined_method__244___object(node__sexp_env_62_ast_dump, jump_ex_it_184_ast_node, ((long) 17));
      add_inlined_method__244___object(node__sexp_env_62_ast_dump, make_box_202_ast_node, ((long) 18));
      add_inlined_method__244___object(node__sexp_env_62_ast_dump, box_ref_242_ast_node, ((long) 19));
      {		/* Ast/dump.scm 14 */
	 long aux_1914;
	 aux_1914 =
	    add_inlined_method__244___object(node__sexp_env_62_ast_dump, box_set__221_ast_node, ((long) 20));
	 return
	    BINT(aux_1914);
      }
   }
}



/* node->sexp */
obj_t 
node__sexp_247_ast_dump(node_bglt node_11)
{
   AN_OBJECT;
   {	/* Ast/dump.scm 27 */
      {
	 obj_t method1616_1069;
	 obj_t class1621_1070;
	 {	/* Ast/dump.scm 27 */
	    obj_t arg1624_1067;
	    obj_t arg1625_1068;
	    {	/* Ast/dump.scm 27 */
	       object_bglt obj_1492;
	       obj_1492 =
		  (object_bglt) (node_11);
	       {	/* ./Llib/object.scm 2926 */
		  obj_t pre_method_105_1493;
		  pre_method_105_1493 =
		     PROCEDURE_REF(node__sexp_env_62_ast_dump, ((long) 2));
		  if (
		     INTEGERP(pre_method_105_1493))
		    {	/* ./Llib/object.scm 2927 */
		       PROCEDURE_SET(node__sexp_env_62_ast_dump, ((long) 2), BUNSPEC);
		       arg1624_1067 = pre_method_105_1493;
		    }
		  else
		    {	/* ./Llib/object.scm 2914 */
		       long obj_class_num_177_1498;
		       obj_class_num_177_1498 =
			  TYPE(obj_1492);
		       {	/* ./Llib/object.scm 2915 */
			  obj_t arg1176_1499;
			  arg1176_1499 =
			     PROCEDURE_REF(node__sexp_env_62_ast_dump, ((long) 1));
			  {	/* ./Llib/object.scm 2738 */
			     long arg1177_1503;
			     {	/* ./Llib/object.scm 2738 */
				long arg1178_1504;
				arg1178_1504 =
				   OBJECT_TYPE;
				arg1177_1503 =
				   (obj_class_num_177_1498 - arg1178_1504);
			     }
			     arg1624_1067 =
				VECTOR_REF(arg1176_1499, arg1177_1503);
			  }
		       }
		    }
	       }
	    }
	    {	/* Ast/dump.scm 27 */
	       object_bglt object_1509;
	       object_1509 =
		  (object_bglt) (node_11);
	       {	/* ./Llib/object.scm 2695 */
		  long arg1179_1510;
		  {	/* ./Llib/object.scm 2695 */
		     long arg1180_1511;
		     long arg1181_1512;
		     arg1180_1511 =
			TYPE(object_1509);
		     arg1181_1512 =
			OBJECT_TYPE;
		     arg1179_1510 =
			(arg1180_1511 - arg1181_1512);
		  }
		  {	/* ./Llib/object.scm 2695 */
		     obj_t vector_1516;
		     vector_1516 = _classes__134___object;
		     arg1625_1068 =
			VECTOR_REF(vector_1516, arg1179_1510);
		  }
	       }
	    }
	    method1616_1069 = arg1624_1067;
	    class1621_1070 = arg1625_1068;
	    {

	       if (
		  INTEGERP(method1616_1069))
		 {	/* Ast/dump.scm 27 */
		    switch (
		       (long) CINT(method1616_1069))
		      {
		      case ((long) 0):

			 {	/* Ast/dump.scm 33 */
			    atom_bglt node_1076;
			    node_1076 =
			       (atom_bglt) (node_11);
			    {	/* Ast/dump.scm 33 */
			       bool_t test_1935;
			       {	/* ./Ieee/pair-list.scm 5912 */
				  obj_t aux_1936;
				  aux_1936 =
				     (((atom_bglt) CREF(node_1076))->value);
				  test_1935 =
				     NULLP(aux_1936);
			       }
			       if (test_1935)
				 {	/* Ast/dump.scm 33 */
				    return
				       CNST_TABLE_REF(((long) 0));
				 }
			       else
				 {	/* Ast/dump.scm 35 */
				    obj_t aux_1940;
				    {	/* Ast/dump.scm 35 */
				       node_bglt obj_1520;
				       obj_1520 =
					  (node_bglt) (node_1076);
				       aux_1940 =
					  (((node_bglt) CREF(obj_1520))->loc);
				    }
				    return
				       location_shape_18_tools_location(aux_1940,
				       (((atom_bglt) CREF(node_1076))->value));
				 }
			    }
			 }
			 break;
		      case ((long) 1):

			 {	/* Ast/dump.scm 41 */
			    var_bglt node_1081;
			    node_1081 =
			       (var_bglt) (node_11);
			    {	/* Ast/dump.scm 41 */
			       obj_t arg1632_1082;
			       obj_t arg1633_1083;
			       {	/* Ast/dump.scm 41 */
				  node_bglt obj_1522;
				  obj_1522 =
				     (node_bglt) (node_1081);
				  arg1632_1082 =
				     (((node_bglt) CREF(obj_1522))->loc);
			       }
			       {	/* Ast/dump.scm 41 */
				  obj_t aux_1948;
				  {	/* Ast/dump.scm 41 */
				     variable_bglt aux_1949;
				     aux_1949 =
					(((var_bglt) CREF(node_1081))->variable);
				     aux_1948 =
					(obj_t) (aux_1949);
				  }
				  arg1633_1083 =
				     shape_tools_shape(aux_1948);
			       }
			       return
				  location_shape_18_tools_location(arg1632_1082, arg1633_1083);
			    }
			 }
			 break;
		      case ((long) 2):

			 {	/* Ast/dump.scm 47 */
			    closure_bglt node_1085;
			    node_1085 =
			       (closure_bglt) (node_11);
			    {	/* Ast/dump.scm 47 */
			       obj_t arg1635_1086;
			       obj_t arg1636_1087;
			       {	/* Ast/dump.scm 47 */
				  node_bglt obj_1524;
				  obj_1524 =
				     (node_bglt) (node_1085);
				  arg1635_1086 =
				     (((node_bglt) CREF(obj_1524))->loc);
			       }
			       {	/* Ast/dump.scm 48 */
				  obj_t arg1637_1088;
				  obj_t arg1638_1089;
				  arg1637_1088 =
				     CNST_TABLE_REF(((long) 1));
				  {	/* Ast/dump.scm 48 */
				     obj_t arg1639_1090;
				     {	/* Ast/dump.scm 48 */
					obj_t aux_1958;
					{	/* Ast/dump.scm 48 */
					   variable_bglt aux_1959;
					   aux_1959 =
					      (((closure_bglt) CREF(node_1085))->variable);
					   aux_1958 =
					      (obj_t) (aux_1959);
					}
					arg1639_1090 =
					   shape_tools_shape(aux_1958);
				     }
				     arg1638_1089 =
					MAKE_PAIR(arg1639_1090, BNIL);
				  }
				  arg1636_1087 =
				     MAKE_PAIR(arg1637_1088, arg1638_1089);
			       }
			       return
				  location_shape_18_tools_location(arg1635_1086, arg1636_1087);
			    }
			 }
			 break;
		      case ((long) 3):

			 {	/* Ast/dump.scm 54 */
			    kwote_bglt node_1093;
			    node_1093 =
			       (kwote_bglt) (node_11);
			    {	/* Ast/dump.scm 54 */
			       obj_t arg1642_1094;
			       obj_t arg1643_1095;
			       {	/* Ast/dump.scm 54 */
				  node_bglt obj_1530;
				  obj_1530 =
				     (node_bglt) (node_1093);
				  arg1642_1094 =
				     (((node_bglt) CREF(obj_1530))->loc);
			       }
			       {	/* Ast/dump.scm 55 */
				  obj_t value_1096;
				  value_1096 =
				     (((kwote_bglt) CREF(node_1093))->value);
				  {	/* Ast/dump.scm 56 */
				     bool_t test_1970;
				     if (
					STRUCTP(value_1096))
				       {	/* ./Ieee/equiv.scm 5508 */
					  obj_t aux_1975;
					  obj_t aux_1973;
					  aux_1975 =
					     CNST_TABLE_REF(((long) 2));
					  aux_1973 =
					     STRUCT_KEY(value_1096);
					  test_1970 =
					     (aux_1973 == aux_1975);
				       }
				     else
				       {	/* ./Tvector/tvector.sch 478 */
					  test_1970 = ((bool_t) 0)
					     ;
				       }
				     if (test_1970)
				       {	/* Ast/dump.scm 57 */
					  obj_t arg1646_1098;
					  obj_t arg1647_1099;
					  arg1646_1098 =
					     CNST_TABLE_REF(((long) 3));
					  {	/* Ast/dump.scm 57 */
					     obj_t arg1648_1100;
					     {	/* Ast/dump.scm 57 */
						obj_t arg1650_1102;
						obj_t arg1651_1103;
						arg1650_1102 =
						   shape_tools_shape(
						   STRUCT_REF(value_1096, ((long) 0)));
						arg1651_1103 =
						   STRUCT_REF(value_1096, ((long) 1));
						{	/* ./Tvector/tvector.sch 478 */
						   obj_t new_1548;
						   {	/* ./Tvector/tvector.sch 478 */
						      obj_t aux_1982;
						      aux_1982 =
							 CNST_TABLE_REF(((long) 2));
						      new_1548 =
							 create_struct(aux_1982, ((long) 2));
						   }
						   STRUCT_SET(new_1548, ((long) 1), arg1651_1103);
						   STRUCT_SET(new_1548, ((long) 0), arg1650_1102);
						   arg1648_1100 = new_1548;
						}
					     }
					     arg1647_1099 =
						MAKE_PAIR(arg1648_1100, BNIL);
					  }
					  arg1643_1095 =
					     MAKE_PAIR(arg1646_1098, arg1647_1099);
				       }
				     else
				       {	/* Ast/dump.scm 59 */
					  obj_t arg1653_1105;
					  obj_t arg1654_1106;
					  arg1653_1105 =
					     CNST_TABLE_REF(((long) 3));
					  arg1654_1106 =
					     MAKE_PAIR(value_1096, BNIL);
					  arg1643_1095 =
					     MAKE_PAIR(arg1653_1105, arg1654_1106);
				       }
				  }
			       }
			       return
				  location_shape_18_tools_location(arg1642_1094, arg1643_1095);
			    }
			 }
			 break;
		      case ((long) 4):

			 {	/* Ast/dump.scm 65 */
			    sequence_bglt node_1107;
			    node_1107 =
			       (sequence_bglt) (node_11);
			    {	/* Ast/dump.scm 65 */
			       obj_t arg1655_1108;
			       obj_t arg1656_1109;
			       {	/* Ast/dump.scm 65 */
				  node_bglt obj_1567;
				  obj_1567 =
				     (node_bglt) (node_1107);
				  arg1655_1108 =
				     (((node_bglt) CREF(obj_1567))->loc);
			       }
			       {	/* Ast/dump.scm 66 */
				  obj_t arg1657_1110;
				  obj_t arg1658_1111;
				  arg1657_1110 =
				     CNST_TABLE_REF(((long) 4));
				  {	/* Ast/dump.scm 67 */
				     obj_t arg1659_1112;
				     {	/* Ast/dump.scm 67 */
					obj_t l1437_1114;
					l1437_1114 =
					   (((sequence_bglt) CREF(node_1107))->nodes);
					if (
					   NULLP(l1437_1114))
					  {	/* Ast/dump.scm 67 */
					     arg1659_1112 = BNIL;
					  }
					else
					  {	/* Ast/dump.scm 67 */
					     obj_t head1439_1116;
					     {	/* Ast/dump.scm 67 */
						obj_t arg1669_1127;
						{	/* Ast/dump.scm 67 */
						   node_bglt aux_2000;
						   {	/* Ast/dump.scm 67 */
						      obj_t aux_2001;
						      aux_2001 =
							 CAR(l1437_1114);
						      aux_2000 =
							 (node_bglt) (aux_2001);
						   }
						   arg1669_1127 =
						      node__sexp_247_ast_dump(aux_2000);
						}
						head1439_1116 =
						   MAKE_PAIR(arg1669_1127, BNIL);
					     }
					     {
						obj_t l1437_1117;
						obj_t tail1440_1118;
						l1437_1117 =
						   CDR(l1437_1114);
						tail1440_1118 = head1439_1116;
					      lname1438_1119:
						if (
						   NULLP(l1437_1117))
						  {	/* Ast/dump.scm 67 */
						     arg1659_1112 = head1439_1116;
						  }
						else
						  {	/* Ast/dump.scm 67 */
						     obj_t newtail1441_1122;
						     {	/* Ast/dump.scm 67 */
							obj_t arg1665_1124;
							{	/* Ast/dump.scm 67 */
							   node_bglt aux_2008;
							   {	/* Ast/dump.scm 67 */
							      obj_t aux_2009;
							      aux_2009 =
								 CAR(l1437_1117);
							      aux_2008 =
								 (node_bglt) (aux_2009);
							   }
							   arg1665_1124 =
							      node__sexp_247_ast_dump(aux_2008);
							}
							newtail1441_1122 =
							   MAKE_PAIR(arg1665_1124, BNIL);
						     }
						     SET_CDR(tail1440_1118, newtail1441_1122);
						     {
							obj_t tail1440_2017;
							obj_t l1437_2015;
							l1437_2015 =
							   CDR(l1437_1117);
							tail1440_2017 = newtail1441_1122;
							tail1440_1118 = tail1440_2017;
							l1437_1117 = l1437_2015;
							goto lname1438_1119;
						     }
						  }
					     }
					  }
				     }
				     arg1658_1111 =
					append_2_18___r4_pairs_and_lists_6_3(arg1659_1112, BNIL);
				  }
				  arg1656_1109 =
				     MAKE_PAIR(arg1657_1110, arg1658_1111);
			       }
			       return
				  location_shape_18_tools_location(arg1655_1108, arg1656_1109);
			    }
			 }
			 break;
		      case ((long) 5):

			 {	/* Ast/dump.scm 73 */
			    app_bglt node_1130;
			    node_1130 =
			       (app_bglt) (node_11);
			    {	/* Ast/dump.scm 73 */
			       obj_t arg1672_1131;
			       obj_t arg1673_1132;
			       {	/* Ast/dump.scm 73 */
				  node_bglt obj_1583;
				  obj_1583 =
				     (node_bglt) (node_1130);
				  arg1672_1131 =
				     (((node_bglt) CREF(obj_1583))->loc);
			       }
			       if (
				  CBOOL(_type_shape___78_engine_param))
				 {	/* Ast/dump.scm 75 */
				    obj_t arg1674_1133;
				    obj_t arg1675_1134;
				    {	/* Ast/dump.scm 75 */
				       node_bglt aux_2027;
				       {	/* Ast/dump.scm 75 */
					  var_bglt aux_2028;
					  aux_2028 =
					     (((app_bglt) CREF(node_1130))->fun);
					  aux_2027 =
					     (node_bglt) (aux_2028);
				       }
				       arg1674_1133 =
					  node__sexp_247_ast_dump(aux_2027);
				    }
				    {	/* Ast/dump.scm 76 */
				       obj_t arg1677_1136;
				       obj_t arg1678_1137;
				       {	/* Ast/dump.scm 76 */
					  obj_t v1442_1138;
					  v1442_1138 =
					     create_vector(((long) 2));
					  {	/* Ast/dump.scm 76 */
					     obj_t arg1680_1140;
					     {	/* Ast/dump.scm 77 */
						obj_t aux_2033;
						{	/* Ast/dump.scm 77 */
						   type_bglt aux_2034;
						   {	/* Ast/dump.scm 78 */
						      variable_bglt arg1682_1142;
						      {		/* Ast/dump.scm 78 */
							 var_bglt arg1683_1143;
							 arg1683_1143 =
							    (((app_bglt) CREF(node_1130))->fun);
							 arg1682_1142 =
							    (((var_bglt) CREF(arg1683_1143))->variable);
						      }
						      aux_2034 =
							 (((variable_bglt) CREF(arg1682_1142))->type);
						   }
						   aux_2033 =
						      (obj_t) (aux_2034);
						}
						arg1680_1140 =
						   shape_tools_shape(aux_2033);
					     }
					     VECTOR_SET(v1442_1138, ((long) 1), arg1680_1140);
					  }
					  {	/* Ast/dump.scm 76 */
					     obj_t arg1685_1145;
					     {	/* Ast/dump.scm 76 */
						obj_t aux_2041;
						{	/* Ast/dump.scm 76 */
						   type_bglt aux_2042;
						   {	/* Ast/dump.scm 76 */
						      node_bglt obj_1591;
						      obj_1591 =
							 (node_bglt) (node_1130);
						      aux_2042 =
							 (((node_bglt) CREF(obj_1591))->type);
						   }
						   aux_2041 =
						      (obj_t) (aux_2042);
						}
						arg1685_1145 =
						   shape_tools_shape(aux_2041);
					     }
					     VECTOR_SET(v1442_1138, ((long) 0), arg1685_1145);
					  }
					  arg1677_1136 = v1442_1138;
				       }
				       {	/* Ast/dump.scm 79 */
					  obj_t arg1687_1147;
					  {	/* Ast/dump.scm 79 */
					     obj_t l1443_1149;
					     l1443_1149 =
						(((app_bglt) CREF(node_1130))->args);
					     if (
						NULLP(l1443_1149))
					       {	/* Ast/dump.scm 79 */
						  arg1687_1147 = BNIL;
					       }
					     else
					       {	/* Ast/dump.scm 79 */
						  obj_t head1445_1151;
						  {	/* Ast/dump.scm 79 */
						     obj_t arg1696_1162;
						     {	/* Ast/dump.scm 79 */
							node_bglt aux_2051;
							{	/* Ast/dump.scm 79 */
							   obj_t aux_2052;
							   aux_2052 =
							      CAR(l1443_1149);
							   aux_2051 =
							      (node_bglt) (aux_2052);
							}
							arg1696_1162 =
							   node__sexp_247_ast_dump(aux_2051);
						     }
						     head1445_1151 =
							MAKE_PAIR(arg1696_1162, BNIL);
						  }
						  {
						     obj_t l1443_1152;
						     obj_t tail1446_1153;
						     l1443_1152 =
							CDR(l1443_1149);
						     tail1446_1153 = head1445_1151;
						   lname1444_1154:
						     if (
							NULLP(l1443_1152))
						       {	/* Ast/dump.scm 79 */
							  arg1687_1147 = head1445_1151;
						       }
						     else
						       {	/* Ast/dump.scm 79 */
							  obj_t newtail1447_1157;
							  {	/* Ast/dump.scm 79 */
							     obj_t arg1693_1159;
							     {	/* Ast/dump.scm 79 */
								node_bglt aux_2059;
								{	/* Ast/dump.scm 79 */
								   obj_t aux_2060;
								   aux_2060 =
								      CAR(l1443_1152);
								   aux_2059 =
								      (node_bglt) (aux_2060);
								}
								arg1693_1159 =
								   node__sexp_247_ast_dump(aux_2059);
							     }
							     newtail1447_1157 =
								MAKE_PAIR(arg1693_1159, BNIL);
							  }
							  SET_CDR(tail1446_1153, newtail1447_1157);
							  {
							     obj_t tail1446_2068;
							     obj_t l1443_2066;
							     l1443_2066 =
								CDR(l1443_1152);
							     tail1446_2068 = newtail1447_1157;
							     tail1446_1153 = tail1446_2068;
							     l1443_1152 = l1443_2066;
							     goto lname1444_1154;
							  }
						       }
						  }
					       }
					  }
					  arg1678_1137 =
					     append_2_18___r4_pairs_and_lists_6_3(arg1687_1147, BNIL);
				       }
				       arg1675_1134 =
					  MAKE_PAIR(arg1677_1136, arg1678_1137);
				    }
				    arg1673_1132 =
				       MAKE_PAIR(arg1674_1133, arg1675_1134);
				 }
			       else
				 {	/* Ast/dump.scm 80 */
				    obj_t arg1699_1165;
				    obj_t arg1700_1166;
				    {	/* Ast/dump.scm 80 */
				       node_bglt aux_2073;
				       {	/* Ast/dump.scm 80 */
					  var_bglt aux_2074;
					  aux_2074 =
					     (((app_bglt) CREF(node_1130))->fun);
					  aux_2073 =
					     (node_bglt) (aux_2074);
				       }
				       arg1699_1165 =
					  node__sexp_247_ast_dump(aux_2073);
				    }
				    {	/* Ast/dump.scm 81 */
				       obj_t arg1702_1168;
				       {	/* Ast/dump.scm 81 */
					  obj_t l1448_1170;
					  l1448_1170 =
					     (((app_bglt) CREF(node_1130))->args);
					  if (
					     NULLP(l1448_1170))
					    {	/* Ast/dump.scm 81 */
					       arg1702_1168 = BNIL;
					    }
					  else
					    {	/* Ast/dump.scm 81 */
					       obj_t head1450_1172;
					       {	/* Ast/dump.scm 81 */
						  obj_t arg1712_1183;
						  {	/* Ast/dump.scm 81 */
						     node_bglt aux_2081;
						     {	/* Ast/dump.scm 81 */
							obj_t aux_2082;
							aux_2082 =
							   CAR(l1448_1170);
							aux_2081 =
							   (node_bglt) (aux_2082);
						     }
						     arg1712_1183 =
							node__sexp_247_ast_dump(aux_2081);
						  }
						  head1450_1172 =
						     MAKE_PAIR(arg1712_1183, BNIL);
					       }
					       {
						  obj_t l1448_1173;
						  obj_t tail1451_1174;
						  l1448_1173 =
						     CDR(l1448_1170);
						  tail1451_1174 = head1450_1172;
						lname1449_1175:
						  if (
						     NULLP(l1448_1173))
						    {	/* Ast/dump.scm 81 */
						       arg1702_1168 = head1450_1172;
						    }
						  else
						    {	/* Ast/dump.scm 81 */
						       obj_t newtail1452_1178;
						       {	/* Ast/dump.scm 81 */
							  obj_t arg1708_1180;
							  {	/* Ast/dump.scm 81 */
							     node_bglt aux_2089;
							     {	/* Ast/dump.scm 81 */
								obj_t aux_2090;
								aux_2090 =
								   CAR(l1448_1173);
								aux_2089 =
								   (node_bglt) (aux_2090);
							     }
							     arg1708_1180 =
								node__sexp_247_ast_dump(aux_2089);
							  }
							  newtail1452_1178 =
							     MAKE_PAIR(arg1708_1180, BNIL);
						       }
						       SET_CDR(tail1451_1174, newtail1452_1178);
						       {
							  obj_t tail1451_2098;
							  obj_t l1448_2096;
							  l1448_2096 =
							     CDR(l1448_1173);
							  tail1451_2098 = newtail1452_1178;
							  tail1451_1174 = tail1451_2098;
							  l1448_1173 = l1448_2096;
							  goto lname1449_1175;
						       }
						    }
					       }
					    }
				       }
				       arg1700_1166 =
					  append_2_18___r4_pairs_and_lists_6_3(arg1702_1168, BNIL);
				    }
				    arg1673_1132 =
				       MAKE_PAIR(arg1699_1165, arg1700_1166);
				 }
			       return
				  location_shape_18_tools_location(arg1672_1131, arg1673_1132);
			    }
			 }
			 break;
		      case ((long) 6):

			 {	/* Ast/dump.scm 87 */
			    app_ly_162_bglt node_1186;
			    node_1186 =
			       (app_ly_162_bglt) (node_11);
			    {	/* Ast/dump.scm 87 */
			       obj_t arg1715_1187;
			       obj_t arg1716_1188;
			       {	/* Ast/dump.scm 87 */
				  node_bglt obj_1628;
				  obj_1628 =
				     (node_bglt) (node_1186);
				  arg1715_1187 =
				     (((node_bglt) CREF(obj_1628))->loc);
			       }
			       {	/* Ast/dump.scm 88 */
				  obj_t arg1717_1189;
				  obj_t arg1718_1190;
				  arg1717_1189 =
				     CNST_TABLE_REF(((long) 5));
				  {	/* Ast/dump.scm 88 */
				     obj_t arg1719_1191;
				     obj_t arg1720_1192;
				     arg1719_1191 =
					node__sexp_247_ast_dump(
					(((app_ly_162_bglt) CREF(node_1186))->fun));
				     {	/* Ast/dump.scm 89 */
					obj_t arg1722_1194;
					arg1722_1194 =
					   node__sexp_247_ast_dump(
					   (((app_ly_162_bglt) CREF(node_1186))->arg));
					arg1720_1192 =
					   MAKE_PAIR(arg1722_1194, BNIL);
				     }
				     arg1718_1190 =
					MAKE_PAIR(arg1719_1191, arg1720_1192);
				  }
				  arg1716_1188 =
				     MAKE_PAIR(arg1717_1189, arg1718_1190);
			       }
			       return
				  location_shape_18_tools_location(arg1715_1187, arg1716_1188);
			    }
			 }
			 break;
		      case ((long) 7):

			 {	/* Ast/dump.scm 95 */
			    funcall_bglt node_1197;
			    node_1197 =
			       (funcall_bglt) (node_11);
			    {	/* Ast/dump.scm 95 */
			       obj_t arg1725_1198;
			       obj_t arg1726_1199;
			       {	/* Ast/dump.scm 95 */
				  node_bglt obj_1637;
				  obj_1637 =
				     (node_bglt) (node_1197);
				  arg1725_1198 =
				     (((node_bglt) CREF(obj_1637))->loc);
			       }
			       {	/* Ast/dump.scm 96 */
				  obj_t arg1727_1200;
				  obj_t arg1728_1201;
				  {	/* Ast/dump.scm 96 */
				     obj_t case_value_58_1202;
				     case_value_58_1202 =
					(((funcall_bglt) CREF(node_1197))->strength);
				     {	/* Ast/dump.scm 96 */
					bool_t test_2119;
					{	/* ./Ieee/equiv.scm 5508 */
					   obj_t aux_2120;
					   aux_2120 =
					      CNST_TABLE_REF(((long) 6));
					   test_2119 =
					      (case_value_58_1202 == aux_2120);
					}
					if (test_2119)
					  {	/* Ast/dump.scm 96 */
					     arg1727_1200 =
						CNST_TABLE_REF(((long) 7));
					  }
					else
					  {	/* Ast/dump.scm 96 */
					     bool_t test_2124;
					     {	/* ./Ieee/equiv.scm 5508 */
						obj_t aux_2125;
						aux_2125 =
						   CNST_TABLE_REF(((long) 8));
						test_2124 =
						   (case_value_58_1202 == aux_2125);
					     }
					     if (test_2124)
					       {	/* Ast/dump.scm 96 */
						  arg1727_1200 =
						     CNST_TABLE_REF(((long) 9));
					       }
					     else
					       {	/* Ast/dump.scm 96 */
						  arg1727_1200 =
						     CNST_TABLE_REF(((long) 10));
					       }
					  }
				     }
				  }
				  {	/* Ast/dump.scm 103 */
				     obj_t arg1731_1205;
				     obj_t arg1732_1206;
				     arg1731_1205 =
					node__sexp_247_ast_dump(
					(((funcall_bglt) CREF(node_1197))->fun));
				     {	/* Ast/dump.scm 104 */
					obj_t arg1734_1208;
					{	/* Ast/dump.scm 104 */
					   obj_t l1453_1210;
					   l1453_1210 =
					      (((funcall_bglt) CREF(node_1197))->args);
					   if (
					      NULLP(l1453_1210))
					     {	/* Ast/dump.scm 104 */
						arg1734_1208 = BNIL;
					     }
					   else
					     {	/* Ast/dump.scm 104 */
						obj_t head1455_1212;
						{	/* Ast/dump.scm 104 */
						   obj_t arg1744_1223;
						   {	/* Ast/dump.scm 104 */
						      node_bglt aux_2135;
						      {		/* Ast/dump.scm 104 */
							 obj_t aux_2136;
							 aux_2136 =
							    CAR(l1453_1210);
							 aux_2135 =
							    (node_bglt) (aux_2136);
						      }
						      arg1744_1223 =
							 node__sexp_247_ast_dump(aux_2135);
						   }
						   head1455_1212 =
						      MAKE_PAIR(arg1744_1223, BNIL);
						}
						{
						   obj_t l1453_1213;
						   obj_t tail1456_1214;
						   l1453_1213 =
						      CDR(l1453_1210);
						   tail1456_1214 = head1455_1212;
						 lname1454_1215:
						   if (
						      NULLP(l1453_1213))
						     {	/* Ast/dump.scm 104 */
							arg1734_1208 = head1455_1212;
						     }
						   else
						     {	/* Ast/dump.scm 104 */
							obj_t newtail1457_1218;
							{	/* Ast/dump.scm 104 */
							   obj_t arg1741_1220;
							   {	/* Ast/dump.scm 104 */
							      node_bglt aux_2143;
							      {		/* Ast/dump.scm 104 */
								 obj_t aux_2144;
								 aux_2144 =
								    CAR(l1453_1213);
								 aux_2143 =
								    (node_bglt) (aux_2144);
							      }
							      arg1741_1220 =
								 node__sexp_247_ast_dump(aux_2143);
							   }
							   newtail1457_1218 =
							      MAKE_PAIR(arg1741_1220, BNIL);
							}
							SET_CDR(tail1456_1214, newtail1457_1218);
							{
							   obj_t tail1456_2152;
							   obj_t l1453_2150;
							   l1453_2150 =
							      CDR(l1453_1213);
							   tail1456_2152 = newtail1457_1218;
							   tail1456_1214 = tail1456_2152;
							   l1453_1213 = l1453_2150;
							   goto lname1454_1215;
							}
						     }
						}
					     }
					}
					arg1732_1206 =
					   append_2_18___r4_pairs_and_lists_6_3(arg1734_1208, BNIL);
				     }
				     arg1728_1201 =
					MAKE_PAIR(arg1731_1205, arg1732_1206);
				  }
				  arg1726_1199 =
				     MAKE_PAIR(arg1727_1200, arg1728_1201);
			       }
			       return
				  location_shape_18_tools_location(arg1725_1198, arg1726_1199);
			    }
			 }
			 break;
		      case ((long) 8):

			 {	/* Ast/dump.scm 110 */
			    pragma_bglt node_1226;
			    node_1226 =
			       (pragma_bglt) (node_11);
			    {	/* Ast/dump.scm 110 */
			       obj_t arg1747_1227;
			       obj_t arg1748_1228;
			       {	/* Ast/dump.scm 110 */
				  node_bglt obj_1661;
				  obj_1661 =
				     (node_bglt) (node_1226);
				  arg1747_1227 =
				     (((node_bglt) CREF(obj_1661))->loc);
			       }
			       {	/* Ast/dump.scm 111 */
				  obj_t p_1229;
				  {	/* Ast/dump.scm 111 */
				     bool_t test_2161;
				     {	/* ./Ast/node.scm 718 */
					obj_t aux_2162;
					aux_2162 =
					   (((pragma_bglt) CREF(node_1226))->side_effect__165);
					test_2161 =
					   CBOOL(aux_2162);
				     }
				     if (test_2161)
				       {	/* Ast/dump.scm 111 */
					  p_1229 =
					     CNST_TABLE_REF(((long) 11));
				       }
				     else
				       {	/* Ast/dump.scm 111 */
					  p_1229 =
					     CNST_TABLE_REF(((long) 12));
				       }
				  }
				  {	/* Ast/dump.scm 114 */
				     obj_t arg1749_1230;
				     obj_t arg1750_1231;
				     if (
					CBOOL(_type_shape___78_engine_param))
				       {	/* Ast/dump.scm 115 */
					  obj_t list1752_1233;
					  {	/* Ast/dump.scm 115 */
					     obj_t arg1753_1234;
					     {	/* Ast/dump.scm 115 */
						obj_t arg1754_1235;
						{	/* Ast/dump.scm 115 */
						   obj_t aux_2169;
						   {	/* Ast/dump.scm 115 */
						      type_bglt arg1755_1236;
						      {		/* Ast/dump.scm 115 */
							 node_bglt obj_1663;
							 obj_1663 =
							    (node_bglt) (node_1226);
							 arg1755_1236 =
							    (((node_bglt) CREF(obj_1663))->type);
						      }
						      aux_2169 =
							 (((type_bglt) CREF(arg1755_1236))->id);
						   }
						   arg1754_1235 =
						      MAKE_PAIR(aux_2169, BNIL);
						}
						arg1753_1234 =
						   MAKE_PAIR(_4dots_199_tools_misc, arg1754_1235);
					     }
					     list1752_1233 =
						MAKE_PAIR(p_1229, arg1753_1234);
					  }
					  arg1749_1230 =
					     symbol_append_197___r4_symbols_6_4(list1752_1233);
				       }
				     else
				       {	/* Ast/dump.scm 114 */
					  arg1749_1230 = p_1229;
				       }
				     {	/* Ast/dump.scm 117 */
					obj_t arg1756_1237;
					obj_t arg1758_1238;
					arg1756_1237 =
					   (((pragma_bglt) CREF(node_1226))->format);
					{	/* Ast/dump.scm 118 */
					   obj_t arg1759_1239;
					   {	/* Ast/dump.scm 118 */
					      obj_t l1458_1241;
					      l1458_1241 =
						 (((pragma_bglt) CREF(node_1226))->args);
					      if (
						 NULLP(l1458_1241))
						{	/* Ast/dump.scm 118 */
						   arg1759_1239 = BNIL;
						}
					      else
						{	/* Ast/dump.scm 118 */
						   obj_t head1460_1243;
						   {	/* Ast/dump.scm 118 */
						      obj_t arg1768_1254;
						      {		/* Ast/dump.scm 118 */
							 node_bglt aux_2181;
							 {	/* Ast/dump.scm 118 */
							    obj_t aux_2182;
							    aux_2182 =
							       CAR(l1458_1241);
							    aux_2181 =
							       (node_bglt) (aux_2182);
							 }
							 arg1768_1254 =
							    node__sexp_247_ast_dump(aux_2181);
						      }
						      head1460_1243 =
							 MAKE_PAIR(arg1768_1254, BNIL);
						   }
						   {
						      obj_t l1458_1244;
						      obj_t tail1461_1245;
						      l1458_1244 =
							 CDR(l1458_1241);
						      tail1461_1245 = head1460_1243;
						    lname1459_1246:
						      if (
							 NULLP(l1458_1244))
							{	/* Ast/dump.scm 118 */
							   arg1759_1239 = head1460_1243;
							}
						      else
							{	/* Ast/dump.scm 118 */
							   obj_t newtail1462_1249;
							   {	/* Ast/dump.scm 118 */
							      obj_t arg1765_1251;
							      {		/* Ast/dump.scm 118 */
								 node_bglt aux_2189;
								 {	/* Ast/dump.scm 118 */
								    obj_t aux_2190;
								    aux_2190 =
								       CAR(l1458_1244);
								    aux_2189 =
								       (node_bglt) (aux_2190);
								 }
								 arg1765_1251 =
								    node__sexp_247_ast_dump(aux_2189);
							      }
							      newtail1462_1249 =
								 MAKE_PAIR(arg1765_1251, BNIL);
							   }
							   SET_CDR(tail1461_1245, newtail1462_1249);
							   {
							      obj_t tail1461_2198;
							      obj_t l1458_2196;
							      l1458_2196 =
								 CDR(l1458_1244);
							      tail1461_2198 = newtail1462_1249;
							      tail1461_1245 = tail1461_2198;
							      l1458_1244 = l1458_2196;
							      goto lname1459_1246;
							   }
							}
						   }
						}
					   }
					   arg1758_1238 =
					      append_2_18___r4_pairs_and_lists_6_3(arg1759_1239, BNIL);
					}
					arg1750_1231 =
					   MAKE_PAIR(arg1756_1237, arg1758_1238);
				     }
				     arg1748_1228 =
					MAKE_PAIR(arg1749_1230, arg1750_1231);
				  }
			       }
			       return
				  location_shape_18_tools_location(arg1747_1227, arg1748_1228);
			    }
			 }
			 break;
		      case ((long) 9):

			 {	/* Ast/dump.scm 124 */
			    cast_bglt node_1258;
			    node_1258 =
			       (cast_bglt) (node_11);
			    {	/* Ast/dump.scm 125 */
			       obj_t arg1772_1260;
			       obj_t arg1773_1261;
			       {	/* Ast/dump.scm 125 */
				  obj_t arg1774_1262;
				  arg1774_1262 =
				     CNST_TABLE_REF(((long) 13));
				  {	/* Ast/dump.scm 125 */
				     obj_t list1776_1264;
				     {	/* Ast/dump.scm 125 */
					obj_t arg1777_1265;
					{	/* Ast/dump.scm 125 */
					   obj_t arg1778_1266;
					   {	/* Ast/dump.scm 125 */
					      obj_t aux_2206;
					      {		/* Ast/dump.scm 125 */
						 type_bglt arg1779_1267;
						 arg1779_1267 =
						    (((cast_bglt) CREF(node_1258))->type);
						 aux_2206 =
						    (((type_bglt) CREF(arg1779_1267))->id);
					      }
					      arg1778_1266 =
						 MAKE_PAIR(aux_2206, BNIL);
					   }
					   arg1777_1265 =
					      MAKE_PAIR(_4dots_199_tools_misc, arg1778_1266);
					}
					list1776_1264 =
					   MAKE_PAIR(arg1774_1262, arg1777_1265);
				     }
				     arg1772_1260 =
					symbol_append_197___r4_symbols_6_4(list1776_1264);
				  }
			       }
			       {	/* Ast/dump.scm 125 */
				  obj_t arg1780_1268;
				  arg1780_1268 =
				     node__sexp_247_ast_dump(
				     (((cast_bglt) CREF(node_1258))->arg));
				  arg1773_1261 =
				     MAKE_PAIR(arg1780_1268, BNIL);
			       }
			       return
				  MAKE_PAIR(arg1772_1260, arg1773_1261);
			    }
			 }
			 break;
		      case ((long) 10):

			 {	/* Ast/dump.scm 131 */
			    setq_bglt node_1271;
			    node_1271 =
			       (setq_bglt) (node_11);
			    {	/* Ast/dump.scm 131 */
			       obj_t arg1783_1272;
			       obj_t arg1784_1273;
			       {	/* Ast/dump.scm 131 */
				  node_bglt obj_1690;
				  obj_1690 =
				     (node_bglt) (node_1271);
				  arg1783_1272 =
				     (((node_bglt) CREF(obj_1690))->loc);
			       }
			       {	/* Ast/dump.scm 132 */
				  obj_t arg1785_1274;
				  obj_t arg1786_1275;
				  arg1785_1274 =
				     CNST_TABLE_REF(((long) 14));
				  {	/* Ast/dump.scm 132 */
				     obj_t arg1787_1276;
				     obj_t arg1788_1277;
				     {	/* Ast/dump.scm 132 */
					node_bglt aux_2221;
					{	/* Ast/dump.scm 132 */
					   var_bglt aux_2222;
					   aux_2222 =
					      (((setq_bglt) CREF(node_1271))->var);
					   aux_2221 =
					      (node_bglt) (aux_2222);
					}
					arg1787_1276 =
					   node__sexp_247_ast_dump(aux_2221);
				     }
				     {	/* Ast/dump.scm 133 */
					obj_t arg1790_1279;
					arg1790_1279 =
					   node__sexp_247_ast_dump(
					   (((setq_bglt) CREF(node_1271))->value));
					arg1788_1277 =
					   MAKE_PAIR(arg1790_1279, BNIL);
				     }
				     arg1786_1275 =
					MAKE_PAIR(arg1787_1276, arg1788_1277);
				  }
				  arg1784_1273 =
				     MAKE_PAIR(arg1785_1274, arg1786_1275);
			       }
			       return
				  location_shape_18_tools_location(arg1783_1272, arg1784_1273);
			    }
			 }
			 break;
		      case ((long) 11):

			 {	/* Ast/dump.scm 139 */
			    conditional_bglt node_1282;
			    node_1282 =
			       (conditional_bglt) (node_11);
			    {	/* Ast/dump.scm 139 */
			       obj_t arg1793_1283;
			       obj_t arg1794_1284;
			       {	/* Ast/dump.scm 139 */
				  node_bglt obj_1699;
				  obj_1699 =
				     (node_bglt) (node_1282);
				  arg1793_1283 =
				     (((node_bglt) CREF(obj_1699))->loc);
			       }
			       {	/* Ast/dump.scm 140 */
				  obj_t arg1795_1285;
				  obj_t arg1796_1286;
				  arg1795_1285 =
				     CNST_TABLE_REF(((long) 15));
				  {	/* Ast/dump.scm 140 */
				     obj_t arg1797_1287;
				     obj_t arg1798_1288;
				     arg1797_1287 =
					node__sexp_247_ast_dump(
					(((conditional_bglt) CREF(node_1282))->test));
				     {	/* Ast/dump.scm 141 */
					obj_t arg1801_1290;
					obj_t arg1802_1291;
					arg1801_1290 =
					   node__sexp_247_ast_dump(
					   (((conditional_bglt) CREF(node_1282))->true));
					{	/* Ast/dump.scm 142 */
					   obj_t arg1804_1293;
					   arg1804_1293 =
					      node__sexp_247_ast_dump(
					      (((conditional_bglt) CREF(node_1282))->false));
					   arg1802_1291 =
					      MAKE_PAIR(arg1804_1293, BNIL);
					}
					arg1798_1288 =
					   MAKE_PAIR(arg1801_1290, arg1802_1291);
				     }
				     arg1796_1286 =
					MAKE_PAIR(arg1797_1287, arg1798_1288);
				  }
				  arg1794_1284 =
				     MAKE_PAIR(arg1795_1285, arg1796_1286);
			       }
			       return
				  location_shape_18_tools_location(arg1793_1283, arg1794_1284);
			    }
			 }
			 break;
		      case ((long) 12):

			 {	/* Ast/dump.scm 148 */
			    fail_bglt node_1296;
			    node_1296 =
			       (fail_bglt) (node_11);
			    {	/* Ast/dump.scm 148 */
			       obj_t arg1807_1297;
			       obj_t arg1809_1298;
			       {	/* Ast/dump.scm 148 */
				  node_bglt obj_1711;
				  obj_1711 =
				     (node_bglt) (node_1296);
				  arg1807_1297 =
				     (((node_bglt) CREF(obj_1711))->loc);
			       }
			       {	/* Ast/dump.scm 149 */
				  obj_t arg1810_1299;
				  obj_t arg1811_1300;
				  arg1810_1299 =
				     CNST_TABLE_REF(((long) 16));
				  {	/* Ast/dump.scm 149 */
				     obj_t arg1812_1301;
				     obj_t arg1813_1302;
				     arg1812_1301 =
					node__sexp_247_ast_dump(
					(((fail_bglt) CREF(node_1296))->proc));
				     {	/* Ast/dump.scm 150 */
					obj_t arg1815_1304;
					obj_t arg1816_1305;
					arg1815_1304 =
					   node__sexp_247_ast_dump(
					   (((fail_bglt) CREF(node_1296))->msg));
					{	/* Ast/dump.scm 151 */
					   obj_t arg1818_1307;
					   arg1818_1307 =
					      node__sexp_247_ast_dump(
					      (((fail_bglt) CREF(node_1296))->obj));
					   arg1816_1305 =
					      MAKE_PAIR(arg1818_1307, BNIL);
					}
					arg1813_1302 =
					   MAKE_PAIR(arg1815_1304, arg1816_1305);
				     }
				     arg1811_1300 =
					MAKE_PAIR(arg1812_1301, arg1813_1302);
				  }
				  arg1809_1298 =
				     MAKE_PAIR(arg1810_1299, arg1811_1300);
			       }
			       return
				  location_shape_18_tools_location(arg1807_1297, arg1809_1298);
			    }
			 }
			 break;
		      case ((long) 13):

			 {	/* Ast/dump.scm 157 */
			    select_bglt node_1310;
			    node_1310 =
			       (select_bglt) (node_11);
			    {	/* Ast/dump.scm 157 */
			       obj_t arg1822_1311;
			       obj_t arg1823_1312;
			       {	/* Ast/dump.scm 157 */
				  node_bglt obj_1723;
				  obj_1723 =
				     (node_bglt) (node_1310);
				  arg1822_1311 =
				     (((node_bglt) CREF(obj_1723))->loc);
			       }
			       {	/* Ast/dump.scm 158 */
				  obj_t arg1824_1313;
				  obj_t arg1825_1314;
				  arg1824_1313 =
				     CNST_TABLE_REF(((long) 17));
				  {	/* Ast/dump.scm 158 */
				     obj_t arg1826_1315;
				     obj_t arg1827_1316;
				     arg1826_1315 =
					node__sexp_247_ast_dump(
					(((select_bglt) CREF(node_1310))->test));
				     {	/* Ast/dump.scm 159 */
					obj_t arg1830_1318;
					{	/* Ast/dump.scm 159 */
					   obj_t l1464_1320;
					   l1464_1320 =
					      (((select_bglt) CREF(node_1310))->clauses);
					   if (
					      NULLP(l1464_1320))
					     {	/* Ast/dump.scm 159 */
						arg1830_1318 = BNIL;
					     }
					   else
					     {	/* Ast/dump.scm 159 */
						obj_t head1466_1322;
						head1466_1322 =
						   MAKE_PAIR(BNIL, BNIL);
						{
						   obj_t l1464_1323;
						   obj_t tail1467_1324;
						   l1464_1323 = l1464_1320;
						   tail1467_1324 = head1466_1322;
						 lname1465_1325:
						   if (
						      NULLP(l1464_1323))
						     {	/* Ast/dump.scm 159 */
							arg1830_1318 =
							   CDR(head1466_1322);
						     }
						   else
						     {	/* Ast/dump.scm 160 */
							obj_t newtail1468_1327;
							{	/* Ast/dump.scm 160 */
							   obj_t arg1835_1329;
							   {	/* Ast/dump.scm 160 */
							      obj_t clause_1331;
							      clause_1331 =
								 CAR(l1464_1323);
							      {		/* Ast/dump.scm 160 */
								 obj_t arg1838_1332;
								 obj_t arg1839_1333;
								 arg1838_1332 =
								    CAR(clause_1331);
								 {	/* Ast/dump.scm 160 */
								    obj_t arg1841_1334;
								    {	/* Ast/dump.scm 160 */
								       node_bglt aux_2277;
								       {	/* Ast/dump.scm 160 */
									  obj_t aux_2278;
									  aux_2278 =
									     CDR(clause_1331);
									  aux_2277 =
									     (node_bglt) (aux_2278);
								       }
								       arg1841_1334 =
									  node__sexp_247_ast_dump(aux_2277);
								    }
								    arg1839_1333 =
								       MAKE_PAIR(arg1841_1334, BNIL);
								 }
								 arg1835_1329 =
								    MAKE_PAIR(arg1838_1332, arg1839_1333);
							      }
							   }
							   newtail1468_1327 =
							      MAKE_PAIR(arg1835_1329, BNIL);
							}
							SET_CDR(tail1467_1324, newtail1468_1327);
							{
							   obj_t tail1467_2288;
							   obj_t l1464_2286;
							   l1464_2286 =
							      CDR(l1464_1323);
							   tail1467_2288 = newtail1468_1327;
							   tail1467_1324 = tail1467_2288;
							   l1464_1323 = l1464_2286;
							   goto lname1465_1325;
							}
						     }
						}
					     }
					}
					arg1827_1316 =
					   append_2_18___r4_pairs_and_lists_6_3(arg1830_1318, BNIL);
				     }
				     arg1825_1314 =
					MAKE_PAIR(arg1826_1315, arg1827_1316);
				  }
				  arg1823_1312 =
				     MAKE_PAIR(arg1824_1313, arg1825_1314);
			       }
			       return
				  location_shape_18_tools_location(arg1822_1311, arg1823_1312);
			    }
			 }
			 break;
		      case ((long) 14):

			 {	/* Ast/dump.scm 167 */
			    let_fun_218_bglt node_1337;
			    node_1337 =
			       (let_fun_218_bglt) (node_11);
			    {	/* Ast/dump.scm 167 */
			       obj_t arg1844_1338;
			       obj_t arg1845_1339;
			       {	/* Ast/dump.scm 167 */
				  node_bglt obj_1747;
				  obj_1747 =
				     (node_bglt) (node_1337);
				  arg1844_1338 =
				     (((node_bglt) CREF(obj_1747))->loc);
			       }
			       {	/* Ast/dump.scm 168 */
				  obj_t arg1846_1340;
				  obj_t arg1847_1341;
				  arg1846_1340 =
				     CNST_TABLE_REF(((long) 18));
				  {	/* Ast/dump.scm 168 */
				     obj_t arg1848_1342;
				     obj_t arg1849_1343;
				     {	/* Ast/dump.scm 168 */
					obj_t l1469_1344;
					l1469_1344 =
					   (((let_fun_218_bglt) CREF(node_1337))->locals);
					if (
					   NULLP(l1469_1344))
					  {	/* Ast/dump.scm 168 */
					     arg1848_1342 = BNIL;
					  }
					else
					  {	/* Ast/dump.scm 168 */
					     obj_t head1471_1346;
					     head1471_1346 =
						MAKE_PAIR(BNIL, BNIL);
					     {
						obj_t l1469_1347;
						obj_t tail1472_1348;
						l1469_1347 = l1469_1344;
						tail1472_1348 = head1471_1346;
					      lname1470_1349:
						if (
						   NULLP(l1469_1347))
						  {	/* Ast/dump.scm 168 */
						     arg1848_1342 =
							CDR(head1471_1346);
						  }
						else
						  {	/* Ast/dump.scm 169 */
						     obj_t newtail1473_1351;
						     {	/* Ast/dump.scm 169 */
							obj_t arg1853_1353;
							{	/* Ast/dump.scm 169 */
							   obj_t fun_1355;
							   fun_1355 =
							      CAR(l1469_1347);
							   {	/* Ast/dump.scm 169 */
							      obj_t arg1855_1356;
							      obj_t arg1856_1357;
							      arg1855_1356 =
								 shape_tools_shape(fun_1355);
							      {		/* Ast/dump.scm 171 */
								 obj_t arg1857_1358;
								 obj_t arg1858_1359;
								 {	/* Ast/dump.scm 171 */
								    obj_t arg1859_1360;
								    long arg1860_1361;
								    {	/* Ast/dump.scm 171 */
								       obj_t l1474_1362;
								       {	/* Ast/dump.scm 172 */
									  sfun_bglt obj_1756;
									  {	/* Ast/dump.scm 172 */
									     value_bglt aux_2306;
									     {	/* Ast/dump.scm 172 */
										local_bglt obj_1755;
										obj_1755 =
										   (local_bglt) (fun_1355);
										aux_2306 =
										   (((local_bglt) CREF(obj_1755))->value);
									     }
									     obj_1756 =
										(sfun_bglt) (aux_2306);
									  }
									  l1474_1362 =
									     (((sfun_bglt) CREF(obj_1756))->args);
								       }
								       if (
									  NULLP(l1474_1362))
									 {	/* Ast/dump.scm 171 */
									    arg1859_1360 = BNIL;
									 }
								       else
									 {	/* Ast/dump.scm 171 */
									    obj_t head1476_1364;
									    {	/* Ast/dump.scm 171 */
									       obj_t arg1868_1375;
									       arg1868_1375 =
										  shape_tools_shape(
										  CAR(l1474_1362));
									       head1476_1364 =
										  MAKE_PAIR(arg1868_1375, BNIL);
									    }
									    {
									       obj_t l1474_1365;
									       obj_t tail1477_1366;
									       l1474_1365 =
										  CDR(l1474_1362);
									       tail1477_1366 = head1476_1364;
									     lname1475_1367:
									       if (
										  NULLP(l1474_1365))
										 {	/* Ast/dump.scm 171 */
										    arg1859_1360 = head1476_1364;
										 }
									       else
										 {	/* Ast/dump.scm 171 */
										    obj_t newtail1478_1370;
										    {	/* Ast/dump.scm 171 */
										       obj_t arg1865_1372;
										       arg1865_1372 =
											  shape_tools_shape(
											  CAR(l1474_1365));
										       newtail1478_1370 =
											  MAKE_PAIR(arg1865_1372, BNIL);
										    }
										    SET_CDR(tail1477_1366, newtail1478_1370);
										    {
										       obj_t tail1477_2324;
										       obj_t l1474_2322;
										       l1474_2322 =
											  CDR(l1474_1365);
										       tail1477_2324 = newtail1478_1370;
										       tail1477_1366 = tail1477_2324;
										       l1474_1365 = l1474_2322;
										       goto lname1475_1367;
										    }
										 }
									    }
									 }
								    }
								    {	/* Ast/dump.scm 173 */
								       sfun_bglt obj_1770;
								       {	/* Ast/dump.scm 173 */
									  value_bglt aux_2326;
									  {	/* Ast/dump.scm 173 */
									     local_bglt obj_1769;
									     obj_1769 =
										(local_bglt) (fun_1355);
									     aux_2326 =
										(((local_bglt) CREF(obj_1769))->value);
									  }
									  obj_1770 =
									     (sfun_bglt) (aux_2326);
								       }
								       arg1860_1361 =
									  (((sfun_bglt) CREF(obj_1770))->arity);
								    }
								    arg1857_1358 =
								       args_list__args__33_tools_args(arg1859_1360,
								       BINT(arg1860_1361));
								 }
								 {	/* Ast/dump.scm 175 */
								    obj_t arg1873_1380;
								    {	/* Ast/dump.scm 174 */
								       node_bglt aux_2333;
								       {	/* Ast/dump.scm 174 */
									  obj_t aux_2334;
									  {	/* Ast/dump.scm 175 */
									     sfun_bglt obj_1772;
									     {	/* Ast/dump.scm 175 */
										value_bglt aux_2335;
										{	/* Ast/dump.scm 175 */
										   local_bglt obj_1771;
										   obj_1771 =
										      (local_bglt) (fun_1355);
										   aux_2335 =
										      (((local_bglt) CREF(obj_1771))->value);
										}
										obj_1772 =
										   (sfun_bglt) (aux_2335);
									     }
									     aux_2334 =
										(((sfun_bglt) CREF(obj_1772))->body);
									  }
									  aux_2333 =
									     (node_bglt) (aux_2334);
								       }
								       arg1873_1380 =
									  node__sexp_247_ast_dump(aux_2333);
								    }
								    arg1858_1359 =
								       MAKE_PAIR(arg1873_1380, BNIL);
								 }
								 arg1856_1357 =
								    MAKE_PAIR(arg1857_1358, arg1858_1359);
							      }
							      arg1853_1353 =
								 MAKE_PAIR(arg1855_1356, arg1856_1357);
							   }
							}
							newtail1473_1351 =
							   MAKE_PAIR(arg1853_1353, BNIL);
						     }
						     SET_CDR(tail1472_1348, newtail1473_1351);
						     {
							obj_t tail1472_2349;
							obj_t l1469_2347;
							l1469_2347 =
							   CDR(l1469_1347);
							tail1472_2349 = newtail1473_1351;
							tail1472_1348 = tail1472_2349;
							l1469_1347 = l1469_2347;
							goto lname1470_1349;
						     }
						  }
					     }
					  }
				     }
				     {	/* Ast/dump.scm 177 */
					obj_t arg1877_1384;
					arg1877_1384 =
					   node__sexp_247_ast_dump(
					   (((let_fun_218_bglt) CREF(node_1337))->body));
					arg1849_1343 =
					   MAKE_PAIR(arg1877_1384, BNIL);
				     }
				     arg1847_1341 =
					MAKE_PAIR(arg1848_1342, arg1849_1343);
				  }
				  arg1845_1339 =
				     MAKE_PAIR(arg1846_1340, arg1847_1341);
			       }
			       return
				  location_shape_18_tools_location(arg1844_1338, arg1845_1339);
			    }
			 }
			 break;
		      case ((long) 15):

			 {	/* Ast/dump.scm 183 */
			    let_var_6_bglt node_1387;
			    node_1387 =
			       (let_var_6_bglt) (node_11);
			    {	/* Ast/dump.scm 183 */
			       obj_t arg1881_1388;
			       obj_t arg1882_1389;
			       {	/* Ast/dump.scm 183 */
				  node_bglt obj_1791;
				  obj_1791 =
				     (node_bglt) (node_1387);
				  arg1881_1388 =
				     (((node_bglt) CREF(obj_1791))->loc);
			       }
			       {	/* Ast/dump.scm 184 */
				  obj_t arg1883_1390;
				  obj_t arg1884_1391;
				  arg1883_1390 =
				     CNST_TABLE_REF(((long) 19));
				  {	/* Ast/dump.scm 184 */
				     obj_t arg1885_1392;
				     obj_t arg1886_1393;
				     {	/* Ast/dump.scm 184 */
					obj_t l1479_1394;
					l1479_1394 =
					   (((let_var_6_bglt) CREF(node_1387))->bindings);
					if (
					   NULLP(l1479_1394))
					  {	/* Ast/dump.scm 184 */
					     arg1885_1392 = BNIL;
					  }
					else
					  {	/* Ast/dump.scm 184 */
					     obj_t head1481_1396;
					     head1481_1396 =
						MAKE_PAIR(BNIL, BNIL);
					     {
						obj_t l1479_1397;
						obj_t tail1482_1398;
						l1479_1397 = l1479_1394;
						tail1482_1398 = head1481_1396;
					      lname1480_1399:
						if (
						   NULLP(l1479_1397))
						  {	/* Ast/dump.scm 184 */
						     arg1885_1392 =
							CDR(head1481_1396);
						  }
						else
						  {	/* Ast/dump.scm 185 */
						     obj_t newtail1483_1401;
						     {	/* Ast/dump.scm 185 */
							obj_t arg1890_1403;
							{	/* Ast/dump.scm 185 */
							   obj_t b_1405;
							   b_1405 =
							      CAR(l1479_1397);
							   {	/* Ast/dump.scm 185 */
							      obj_t arg1892_1406;
							      obj_t arg1893_1407;
							      arg1892_1406 =
								 shape_tools_shape(
								 CAR(b_1405));
							      {		/* Ast/dump.scm 185 */
								 obj_t arg1895_1409;
								 {	/* Ast/dump.scm 185 */
								    node_bglt aux_2370;
								    {	/* Ast/dump.scm 185 */
								       obj_t aux_2371;
								       aux_2371 =
									  CDR(b_1405);
								       aux_2370 =
									  (node_bglt) (aux_2371);
								    }
								    arg1895_1409 =
								       node__sexp_247_ast_dump(aux_2370);
								 }
								 arg1893_1407 =
								    MAKE_PAIR(arg1895_1409, BNIL);
							      }
							      arg1890_1403 =
								 MAKE_PAIR(arg1892_1406, arg1893_1407);
							   }
							}
							newtail1483_1401 =
							   MAKE_PAIR(arg1890_1403, BNIL);
						     }
						     SET_CDR(tail1482_1398, newtail1483_1401);
						     {
							obj_t tail1482_2381;
							obj_t l1479_2379;
							l1479_2379 =
							   CDR(l1479_1397);
							tail1482_2381 = newtail1483_1401;
							tail1482_1398 = tail1482_2381;
							l1479_1397 = l1479_2379;
							goto lname1480_1399;
						     }
						  }
					     }
					  }
				     }
				     {	/* Ast/dump.scm 187 */
					obj_t arg1898_1412;
					arg1898_1412 =
					   node__sexp_247_ast_dump(
					   (((let_var_6_bglt) CREF(node_1387))->body));
					arg1886_1393 =
					   MAKE_PAIR(arg1898_1412, BNIL);
				     }
				     arg1884_1391 =
					MAKE_PAIR(arg1885_1392, arg1886_1393);
				  }
				  arg1882_1389 =
				     MAKE_PAIR(arg1883_1390, arg1884_1391);
			       }
			       return
				  location_shape_18_tools_location(arg1881_1388, arg1882_1389);
			    }
			 }
			 break;
		      case ((long) 16):

			 {	/* Ast/dump.scm 193 */
			    set_ex_it_116_bglt node_1415;
			    node_1415 =
			       (set_ex_it_116_bglt) (node_11);
			    {	/* Ast/dump.scm 193 */
			       obj_t arg1901_1416;
			       obj_t arg1902_1417;
			       arg1901_1416 =
				  CNST_TABLE_REF(((long) 20));
			       {	/* Ast/dump.scm 193 */
				  obj_t arg1903_1418;
				  obj_t arg1904_1419;
				  {	/* Ast/dump.scm 193 */
				     node_bglt aux_2390;
				     {	/* Ast/dump.scm 193 */
					var_bglt aux_2391;
					aux_2391 =
					   (((set_ex_it_116_bglt) CREF(node_1415))->var);
					aux_2390 =
					   (node_bglt) (aux_2391);
				     }
				     arg1903_1418 =
					node__sexp_247_ast_dump(aux_2390);
				  }
				  {	/* Ast/dump.scm 194 */
				     obj_t arg1906_1421;
				     arg1906_1421 =
					node__sexp_247_ast_dump(
					(((set_ex_it_116_bglt) CREF(node_1415))->body));
				     arg1904_1419 =
					MAKE_PAIR(arg1906_1421, BNIL);
				  }
				  arg1902_1417 =
				     MAKE_PAIR(arg1903_1418, arg1904_1419);
			       }
			       return
				  MAKE_PAIR(arg1901_1416, arg1902_1417);
			    }
			 }
			 break;
		      case ((long) 17):

			 {	/* Ast/dump.scm 200 */
			    jump_ex_it_184_bglt node_1424;
			    node_1424 =
			       (jump_ex_it_184_bglt) (node_11);
			    {	/* Ast/dump.scm 200 */
			       obj_t arg1910_1425;
			       obj_t arg1912_1426;
			       arg1910_1425 =
				  CNST_TABLE_REF(((long) 21));
			       {	/* Ast/dump.scm 200 */
				  obj_t arg1913_1427;
				  obj_t arg1914_1428;
				  arg1913_1427 =
				     node__sexp_247_ast_dump(
				     (((jump_ex_it_184_bglt) CREF(node_1424))->exit));
				  {	/* Ast/dump.scm 201 */
				     obj_t arg1916_1430;
				     arg1916_1430 =
					node__sexp_247_ast_dump(
					(((jump_ex_it_184_bglt) CREF(node_1424))->value));
				     arg1914_1428 =
					MAKE_PAIR(arg1916_1430, BNIL);
				  }
				  arg1912_1426 =
				     MAKE_PAIR(arg1913_1427, arg1914_1428);
			       }
			       return
				  MAKE_PAIR(arg1910_1425, arg1912_1426);
			    }
			 }
			 break;
		      case ((long) 18):

			 {	/* Ast/dump.scm 207 */
			    make_box_202_bglt node_1433;
			    node_1433 =
			       (make_box_202_bglt) (node_11);
			    {	/* Ast/dump.scm 207 */
			       obj_t arg1920_1434;
			       obj_t arg1921_1435;
			       arg1920_1434 =
				  CNST_TABLE_REF(((long) 22));
			       {	/* Ast/dump.scm 207 */
				  obj_t arg1922_1436;
				  arg1922_1436 =
				     node__sexp_247_ast_dump(
				     (((make_box_202_bglt) CREF(node_1433))->value));
				  arg1921_1435 =
				     MAKE_PAIR(arg1922_1436, BNIL);
			       }
			       return
				  MAKE_PAIR(arg1920_1434, arg1921_1435);
			    }
			 }
			 break;
		      case ((long) 19):

			 {	/* Ast/dump.scm 213 */
			    box_ref_242_bglt node_1439;
			    node_1439 =
			       (box_ref_242_bglt) (node_11);
			    {	/* Ast/dump.scm 213 */
			       obj_t arg1925_1440;
			       obj_t arg1926_1441;
			       arg1925_1440 =
				  CNST_TABLE_REF(((long) 23));
			       {	/* Ast/dump.scm 213 */
				  obj_t arg1927_1442;
				  {	/* Ast/dump.scm 213 */
				     node_bglt aux_2417;
				     {	/* Ast/dump.scm 213 */
					var_bglt aux_2418;
					aux_2418 =
					   (((box_ref_242_bglt) CREF(node_1439))->var);
					aux_2417 =
					   (node_bglt) (aux_2418);
				     }
				     arg1927_1442 =
					node__sexp_247_ast_dump(aux_2417);
				  }
				  arg1926_1441 =
				     MAKE_PAIR(arg1927_1442, BNIL);
			       }
			       return
				  MAKE_PAIR(arg1925_1440, arg1926_1441);
			    }
			 }
			 break;
		      case ((long) 20):

			 {	/* Ast/dump.scm 219 */
			    box_set__221_bglt node_1445;
			    node_1445 =
			       (box_set__221_bglt) (node_11);
			    {	/* Ast/dump.scm 219 */
			       obj_t arg1930_1446;
			       obj_t arg1931_1447;
			       arg1930_1446 =
				  CNST_TABLE_REF(((long) 24));
			       {	/* Ast/dump.scm 219 */
				  obj_t arg1932_1448;
				  obj_t arg1933_1449;
				  {	/* Ast/dump.scm 219 */
				     node_bglt aux_2426;
				     {	/* Ast/dump.scm 219 */
					var_bglt aux_2427;
					aux_2427 =
					   (((box_set__221_bglt) CREF(node_1445))->var);
					aux_2426 =
					   (node_bglt) (aux_2427);
				     }
				     arg1932_1448 =
					node__sexp_247_ast_dump(aux_2426);
				  }
				  {	/* Ast/dump.scm 220 */
				     obj_t arg1935_1451;
				     arg1935_1451 =
					node__sexp_247_ast_dump(
					(((box_set__221_bglt) CREF(node_1445))->value));
				     arg1933_1449 =
					MAKE_PAIR(arg1935_1451, BNIL);
				  }
				  arg1931_1447 =
				     MAKE_PAIR(arg1932_1448, arg1933_1449);
			       }
			       return
				  MAKE_PAIR(arg1930_1446, arg1931_1447);
			    }
			 }
			 break;
		      default:
		       case_else1622_1073:
			 if (
			    PROCEDUREP(method1616_1069))
			   {	/* Ast/dump.scm 27 */
			      return
				 PROCEDURE_ENTRY(method1616_1069) (method1616_1069,
				 (obj_t) (node_11), BEOA);
			   }
			 else
			   {	/* Ast/dump.scm 27 */
			      obj_t fun1615_1065;
			      fun1615_1065 =
				 PROCEDURE_REF(node__sexp_env_62_ast_dump, ((long) 0));
			      return
				 PROCEDURE_ENTRY(fun1615_1065) (fun1615_1065,
				 (obj_t) (node_11), BEOA);
			   }
		      }
		 }
	       else
		 {	/* Ast/dump.scm 27 */
		    goto case_else1622_1073;
		 }
	    }
	 }
      }
   }
}



/* _node->sexp */
obj_t 
_node__sexp_17_ast_dump(obj_t env_1856, obj_t node_1857)
{
   AN_OBJECT;
   {	/* Ast/dump.scm 27 */
      return
	 node__sexp_247_ast_dump(
	 (node_bglt) (node_1857));
   }
}



/* node->sexp-default1484 */
obj_t 
node__sexp_default1484_49_ast_dump(node_bglt node_12)
{
   AN_OBJECT;
   {	/* Ast/dump.scm 14 */
      FAILURE(
	 CNST_TABLE_REF(((long) 25)), string1945_ast_dump,
	 (obj_t) (node_12));
   }
}



/* _node->sexp-default1484 */
obj_t 
_node__sexp_default1484_134_ast_dump(obj_t env_1858, obj_t node_1859)
{
   AN_OBJECT;
   {	/* Ast/dump.scm 14 */
      return
	 node__sexp_default1484_49_ast_dump(
	 (node_bglt) (node_1859));
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_ast_dump()
{
   AN_OBJECT;
   {	/* Ast/dump.scm 14 */
      module_initialization_70_type_type(((long) 0), "AST_DUMP");
      module_initialization_70_ast_var(((long) 0), "AST_DUMP");
      module_initialization_70_ast_node(((long) 0), "AST_DUMP");
      module_initialization_70_tools_shape(((long) 0), "AST_DUMP");
      module_initialization_70_tools_args(((long) 0), "AST_DUMP");
      module_initialization_70_tools_misc(((long) 0), "AST_DUMP");
      module_initialization_70_tools_location(((long) 0), "AST_DUMP");
      return
	 module_initialization_70_engine_param(((long) 0), "AST_DUMP");
   }
}
