/*===========================================================================*/
/*   (Ast/exit.scm)                                                          */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;


extern let_fun_218_bglt set_exit__node_102_ast_exit(obj_t, obj_t, obj_t, obj_t);
static obj_t method_init_76_ast_exit();
extern obj_t find_location_loc_243_tools_location(obj_t, obj_t);
extern obj_t mark_symbol_non_user__17_ast_ident(obj_t);
extern obj_t var_ast_node;
extern obj_t gensym___r4_symbols_6_4;
extern obj_t set_ex_it_116_ast_node;
extern obj_t module_initialization_70_ast_exit(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_ast_sexp(long, char *);
extern obj_t module_initialization_70_ast_local(long, char *);
extern obj_t module_initialization_70_ast_ident(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_tools_progn(long, char *);
extern obj_t module_initialization_70_tools_location(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_symbols_6_4(long, char *);
extern jump_ex_it_184_bglt jump_exit__node_34_ast_exit(obj_t, obj_t, obj_t, obj_t);
extern long class_num_218___object(obj_t);
static obj_t imported_modules_init_94_ast_exit();
extern obj_t normalize_progn_143_tools_progn(obj_t);
static obj_t library_modules_init_112_ast_exit();
static obj_t _jump_exit__node_209_ast_exit(obj_t, obj_t, obj_t, obj_t, obj_t);
extern node_bglt sexp__node_235_ast_sexp(obj_t, obj_t, obj_t, obj_t);
extern obj_t jump_ex_it_184_ast_node;
extern obj_t open_input_string(obj_t);
extern obj_t _exit__255_type_cache;
extern node_bglt error_sexp__node_157_ast_sexp(obj_t, obj_t, obj_t);
extern local_bglt make_local_sexit_184_ast_local(obj_t, type_bglt, sexit_bglt);
static obj_t _set_exit__node_33_ast_exit(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t sexit_ast_var;
extern obj_t read___reader(obj_t);
extern obj_t ____74_type_cache;
static obj_t require_initialization_114_ast_exit = BUNSPEC;
static obj_t cnst_init_137_ast_exit();
static obj_t __cnst[4];

DEFINE_EXPORT_PROCEDURE(set_exit__node_env_153_ast_exit, _set_exit__node_33_ast_exit1586, _set_exit__node_33_ast_exit, 0L, 4);
DEFINE_EXPORT_PROCEDURE(jump_exit__node_env_70_ast_exit, _jump_exit__node_209_ast_exit1587, _jump_exit__node_209_ast_exit, 0L, 4);
DEFINE_STRING(string1581_ast_exit, string1581_ast_exit1588, "SNIFUN VALUE LABELS HANDLING_FUNCTION ", 38);
DEFINE_STRING(string1579_ast_exit, string1579_ast_exit1589, "Illegal `set-exit' form", 23);
DEFINE_STRING(string1580_ast_exit, string1580_ast_exit1590, "Illegal `jump-exit' form", 24);



/* module-initialization */
obj_t 
module_initialization_70_ast_exit(long checksum_1255, char *from_1256)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_ast_exit))
	{
	   require_initialization_114_ast_exit =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_ast_exit();
	   cnst_init_137_ast_exit();
	   imported_modules_init_94_ast_exit();
	   method_init_76_ast_exit();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_ast_exit()
{
   AN_OBJECT;
   {	/* Ast/exit.scm 14 */
      module_initialization_70___r4_symbols_6_4(((long) 0), "AST_EXIT");
      module_initialization_70___object(((long) 0), "AST_EXIT");
      module_initialization_70___reader(((long) 0), "AST_EXIT");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_ast_exit()
{
   AN_OBJECT;
   {	/* Ast/exit.scm 14 */
      {		/* Ast/exit.scm 14 */
	 obj_t cnst_port_138_1248;
	 cnst_port_138_1248 =
	    open_input_string(string1581_ast_exit);
	 {
	    long i_1249;
	    i_1249 = ((long) 3);
	  loop_1250:
	    {	/* Ast/exit.scm 14 */
	       bool_t test1582_1251;
	       test1582_1251 =
		  (i_1249 == ((long) -1));
	       if (test1582_1251)
		 {	/* Ast/exit.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Ast/exit.scm 14 */
		    {	/* Ast/exit.scm 14 */
		       obj_t arg1583_1252;
		       {	/* Ast/exit.scm 14 */
			  obj_t list1584_1253;
			  list1584_1253 =
			     MAKE_PAIR(cnst_port_138_1248, BNIL);
			  arg1583_1252 =
			     read___reader(list1584_1253);
		       }
		       CNST_TABLE_SET(i_1249, arg1583_1252);
		    }
		    {	/* Ast/exit.scm 14 */
		       int aux_1254;
		       {	/* Ast/exit.scm 14 */
			  long aux_1273;
			  aux_1273 =
			     (i_1249 - ((long) 1));
			  aux_1254 =
			     (int) (aux_1273);
		       }
		       {
			  long i_1276;
			  i_1276 =
			     (long) (aux_1254);
			  i_1249 = i_1276;
			  goto loop_1250;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* set-exit->node */
let_fun_218_bglt 
set_exit__node_102_ast_exit(obj_t exp_1, obj_t stack_2, obj_t loc_3, obj_t site_4)
{
   AN_OBJECT;
   {	/* Ast/exit.scm 33 */
      {		/* Ast/exit.scm 36 */
	 obj_t loc_705;
	 loc_705 =
	    find_location_loc_243_tools_location(exp_1, loc_3);
	 {
	    obj_t exit_706;
	    obj_t body_707;
	    if (
	       PAIRP(exp_1))
	      {		/* Ast/exit.scm 37 */
		 obj_t cdr_128_145_712;
		 cdr_128_145_712 =
		    CDR(exp_1);
		 if (
		    PAIRP(cdr_128_145_712))
		   {	/* Ast/exit.scm 37 */
		      obj_t car_131_9_714;
		      car_131_9_714 =
			 CAR(cdr_128_145_712);
		      if (
			 PAIRP(car_131_9_714))
			{	/* Ast/exit.scm 37 */
			   bool_t test_1287;
			   {	/* ./Ieee/equiv.scm 5508 */
			      obj_t aux_1288;
			      aux_1288 =
				 CDR(car_131_9_714);
			      test_1287 =
				 (aux_1288 == BNIL);
			   }
			   if (test_1287)
			     {	/* Ast/exit.scm 37 */
				node_bglt aux_1291;
				exit_706 =
				   CAR(car_131_9_714);
				body_707 =
				   CDR(cdr_128_145_712);
				{	/* Ast/exit.scm 39 */
				   obj_t hdlg_name_179_721;
				   {	/* Ast/exit.scm 40 */
				      obj_t arg1479_753;
				      arg1479_753 =
					 PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4,
					 CNST_TABLE_REF(((long) 0)), BEOA);
				      hdlg_name_179_721 =
					 mark_symbol_non_user__17_ast_ident(arg1479_753);
				   }
				   {	/* Ast/exit.scm 39 */
				      obj_t hdlg_sexp_42_722;
				      {		/* Ast/exit.scm 41 */
					 obj_t arg1467_742;
					 obj_t arg1469_743;
					 arg1467_742 =
					    CNST_TABLE_REF(((long) 1));
					 {	/* Ast/exit.scm 41 */
					    obj_t arg1470_744;
					    obj_t arg1471_745;
					    {	/* Ast/exit.scm 41 */
					       obj_t arg1472_746;
					       {	/* Ast/exit.scm 41 */
						  obj_t arg1474_748;
						  {	/* Ast/exit.scm 41 */
						     obj_t arg1476_750;
						     arg1476_750 =
							MAKE_PAIR(BUNSPEC, BNIL);
						     arg1474_748 =
							MAKE_PAIR(BNIL, arg1476_750);
						  }
						  arg1472_746 =
						     MAKE_PAIR(hdlg_name_179_721, arg1474_748);
					       }
					       arg1470_744 =
						  MAKE_PAIR(arg1472_746, BNIL);
					    }
					    {	/* Ast/exit.scm 42 */
					       obj_t arg1477_751;
					       arg1477_751 =
						  MAKE_PAIR(hdlg_name_179_721, BNIL);
					       arg1471_745 =
						  MAKE_PAIR(arg1477_751, BNIL);
					    }
					    arg1469_743 =
					       MAKE_PAIR(arg1470_744, arg1471_745);
					 }
					 hdlg_sexp_42_722 =
					    MAKE_PAIR(arg1467_742, arg1469_743);
				      }
				      {		/* Ast/exit.scm 41 */
					 node_bglt hdlg_node_132_723;
					 hdlg_node_132_723 =
					    sexp__node_235_ast_sexp(hdlg_sexp_42_722, stack_2, loc_705, site_4);
					 {	/* Ast/exit.scm 43 */
					    obj_t hdlg_fun_73_724;
					    {	/* ./Ieee/pair-list.scm 5701 */
					       obj_t aux_1306;
					       {	/* Ast/exit.scm 44 */
						  let_fun_218_bglt obj_1131;
						  obj_1131 =
						     (let_fun_218_bglt) (hdlg_node_132_723);
						  aux_1306 =
						     (((let_fun_218_bglt) CREF(obj_1131))->locals);
					       }
					       hdlg_fun_73_724 =
						  CAR(aux_1306);
					    }
					    {	/* Ast/exit.scm 44 */
					       local_bglt exit_725;
					       {	/* Ast/exit.scm 35 */
						  sexit_bglt arg1481_1135;
						  {	/* Ast/exit.scm 35 */
						     sexit_bglt res1574_1145;
						     {	/* ./Ast/var.scm 567 */
							sexit_bglt new1179_1139;
							new1179_1139 =
							   ((sexit_bglt) BREF(GC_MALLOC(sizeof(struct sexit))));
							{	/* ./Ast/var.scm 567 */
							   long arg1549_1140;
							   arg1549_1140 =
							      class_num_218___object(sexit_ast_var);
							   {	/* ./Ast/var.scm 567 */
							      obj_t obj_1143;
							      obj_1143 =
								 (obj_t) (new1179_1139);
							      (((obj_t) CREF(obj_1143))->header = MAKE_HEADER(arg1549_1140, 0), BUNSPEC);
							   }
							}
							{	/* ./Ast/var.scm 567 */
							   object_bglt aux_1314;
							   aux_1314 =
							      (object_bglt) (new1179_1139);
							   OBJECT_WIDENING_SET(aux_1314, BFALSE);
							}
							((((sexit_bglt) CREF(new1179_1139))->handler) = ((obj_t) hdlg_fun_73_724), BUNSPEC);
							((((sexit_bglt) CREF(new1179_1139))->detached__120) = ((bool_t) ((bool_t) 0)), BUNSPEC);
							res1574_1145 = new1179_1139;
						     }
						     arg1481_1135 = res1574_1145;
						  }
						  exit_725 =
						     make_local_sexit_184_ast_local(exit_706,
						     (type_bglt) (_exit__255_type_cache), arg1481_1135);
					       }
					       {	/* Ast/exit.scm 45 */
						  node_bglt body_726;
						  {	/* Ast/exit.scm 46 */
						     obj_t arg1462_738;
						     obj_t arg1463_739;
						     obj_t arg1464_740;
						     arg1462_738 =
							normalize_progn_143_tools_progn(body_707);
						     {	/* ./Ieee/pair-list.scm 5689 */
							obj_t aux_1322;
							aux_1322 =
							   (obj_t) (exit_725);
							arg1463_739 =
							   MAKE_PAIR(aux_1322, stack_2);
						     }
						     arg1464_740 =
							CNST_TABLE_REF(((long) 2));
						     body_726 =
							sexp__node_235_ast_sexp(arg1462_738, arg1463_739, loc_705, arg1464_740);
						  }
						  {	/* Ast/exit.scm 46 */
						     set_ex_it_116_bglt exit_body_148_727;
						     {	/* Ast/exit.scm 50 */
							obj_t arg1455_732;
							var_bglt arg1456_733;
							arg1455_732 = ____74_type_cache;
							{	/* Ast/exit.scm 53 */
							   obj_t arg1459_736;
							   arg1459_736 = _exit__255_type_cache;
							   {	/* Ast/exit.scm 53 */
							      var_bglt res1575_1158;
							      {		/* Ast/exit.scm 53 */
								 type_bglt type_1149;
								 variable_bglt variable_1150;
								 type_1149 =
								    (type_bglt) (arg1459_736);
								 variable_1150 =
								    (variable_bglt) (exit_725);
								 {	/* ./Ast/node.scm 612 */
								    var_bglt new1210_1151;
								    new1210_1151 =
								       ((var_bglt) BREF(GC_MALLOC(sizeof(struct var))));
								    {	/* ./Ast/node.scm 612 */
								       long arg1539_1152;
								       arg1539_1152 =
									  class_num_218___object(var_ast_node);
								       {	/* ./Ast/node.scm 612 */
									  obj_t obj_1156;
									  obj_1156 =
									     (obj_t) (new1210_1151);
									  (((obj_t) CREF(obj_1156))->header = MAKE_HEADER(arg1539_1152, 0), BUNSPEC);
								       }
								    }
								    {	/* ./Ast/node.scm 612 */
								       object_bglt aux_1333;
								       aux_1333 =
									  (object_bglt) (new1210_1151);
								       OBJECT_WIDENING_SET(aux_1333, BFALSE);
								    }
								    ((((var_bglt) CREF(new1210_1151))->loc) = ((obj_t) loc_705), BUNSPEC);
								    ((((var_bglt) CREF(new1210_1151))->type) = ((type_bglt) type_1149), BUNSPEC);
								    ((((var_bglt) CREF(new1210_1151))->variable) = ((variable_bglt) variable_1150), BUNSPEC);
								    res1575_1158 = new1210_1151;
								 }
							      }
							      arg1456_733 = res1575_1158;
							   }
							}
							{	/* Ast/exit.scm 50 */
							   set_ex_it_116_bglt res1576_1171;
							   {	/* Ast/exit.scm 50 */
							      type_bglt type_1160;
							      type_1160 =
								 (type_bglt) (arg1455_732);
							      {		/* ./Ast/node.scm 714 */
								 set_ex_it_116_bglt new1386_1163;
								 new1386_1163 =
								    ((set_ex_it_116_bglt) BREF(GC_MALLOC(sizeof(struct set_ex_it_116))));
								 {	/* ./Ast/node.scm 714 */
								    long arg1504_1164;
								    arg1504_1164 =
								       class_num_218___object(set_ex_it_116_ast_node);
								    {	/* ./Ast/node.scm 714 */
								       obj_t obj_1169;
								       obj_1169 =
									  (obj_t) (new1386_1163);
								       (((obj_t) CREF(obj_1169))->header = MAKE_HEADER(arg1504_1164, 0), BUNSPEC);
								    }
								 }
								 {	/* ./Ast/node.scm 714 */
								    object_bglt aux_1344;
								    aux_1344 =
								       (object_bglt) (new1386_1163);
								    OBJECT_WIDENING_SET(aux_1344, BFALSE);
								 }
								 ((((set_ex_it_116_bglt) CREF(new1386_1163))->loc) = ((obj_t) loc_705), BUNSPEC);
								 ((((set_ex_it_116_bglt) CREF(new1386_1163))->type) = ((type_bglt) type_1160), BUNSPEC);
								 ((((set_ex_it_116_bglt) CREF(new1386_1163))->var) = ((var_bglt) arg1456_733), BUNSPEC);
								 ((((set_ex_it_116_bglt) CREF(new1386_1163))->body) = ((node_bglt) body_726), BUNSPEC);
								 res1576_1171 = new1386_1163;
							      }
							   }
							   exit_body_148_727 = res1576_1171;
							}
						     }
						     {	/* Ast/exit.scm 50 */

							{	/* Ast/exit.scm 61 */
							   local_bglt obj_1172;
							   obj_1172 =
							      (local_bglt) (hdlg_fun_73_724);
							   ((((local_bglt) CREF(obj_1172))->user__32) = ((bool_t) ((bool_t) 1)), BUNSPEC);
							}
							{	/* Ast/exit.scm 64 */
							   obj_t arg1451_729;
							   arg1451_729 =
							      CNST_TABLE_REF(((long) 3));
							   {	/* Ast/exit.scm 64 */
							      sfun_bglt obj_1175;
							      {		/* Ast/exit.scm 64 */
								 value_bglt aux_1354;
								 {	/* Ast/exit.scm 64 */
								    local_bglt obj_1174;
								    obj_1174 =
								       (local_bglt) (hdlg_fun_73_724);
								    aux_1354 =
								       (((local_bglt) CREF(obj_1174))->value);
								 }
								 obj_1175 =
								    (sfun_bglt) (aux_1354);
							      }
							      ((((sfun_bglt) CREF(obj_1175))->class) = ((obj_t) arg1451_729), BUNSPEC);
							   }
							}
							{	/* Ast/exit.scm 65 */
							   sfun_bglt obj_1178;
							   obj_t val1123_1179;
							   {	/* Ast/exit.scm 65 */
							      value_bglt aux_1359;
							      {		/* Ast/exit.scm 65 */
								 local_bglt obj_1177;
								 obj_1177 =
								    (local_bglt) (hdlg_fun_73_724);
								 aux_1359 =
								    (((local_bglt) CREF(obj_1177))->value);
							      }
							      obj_1178 =
								 (sfun_bglt) (aux_1359);
							   }
							   val1123_1179 =
							      (obj_t) (exit_body_148_727);
							   ((((sfun_bglt) CREF(obj_1178))->body) = ((obj_t) val1123_1179), BUNSPEC);
							}
							aux_1291 = hdlg_node_132_723;
						     }
						  }
					       }
					    }
					 }
				      }
				   }
				}
				return
				   (let_fun_218_bglt) (aux_1291);
			     }
			   else
			     {	/* Ast/exit.scm 37 */
				node_bglt aux_1368;
			      tag_121_151_709:
				aux_1368 =
				   error_sexp__node_157_ast_sexp(string1579_ast_exit, exp_1, loc_705);
				return
				   (let_fun_218_bglt) (aux_1368);
			     }
			}
		      else
			{	/* Ast/exit.scm 37 */
			   node_bglt aux_1371;
			   goto tag_121_151_709;
			   return
			      (let_fun_218_bglt) (aux_1371);
			}
		   }
		 else
		   {	/* Ast/exit.scm 37 */
		      node_bglt aux_1373;
		      goto tag_121_151_709;
		      return
			 (let_fun_218_bglt) (aux_1373);
		   }
	      }
	    else
	      {		/* Ast/exit.scm 37 */
		 node_bglt aux_1375;
		 goto tag_121_151_709;
		 return
		    (let_fun_218_bglt) (aux_1375);
	      }
	 }
      }
   }
}



/* _set-exit->node */
obj_t 
_set_exit__node_33_ast_exit(obj_t env_1238, obj_t exp_1239, obj_t stack_1240, obj_t loc_1241, obj_t site_1242)
{
   AN_OBJECT;
   {	/* Ast/exit.scm 33 */
      {		/* Ast/exit.scm 33 */
	 let_fun_218_bglt aux_1377;
	 aux_1377 =
	    set_exit__node_102_ast_exit(exp_1239, stack_1240, loc_1241, site_1242);
	 return
	    (obj_t) (aux_1377);
      }
   }
}



/* jump-exit->node */
jump_ex_it_184_bglt 
jump_exit__node_34_ast_exit(obj_t exp_5, obj_t stack_6, obj_t loc_7, obj_t site_8)
{
   AN_OBJECT;
   {	/* Ast/exit.scm 73 */
      {		/* Ast/exit.scm 74 */
	 obj_t loc_760;
	 loc_760 =
	    find_location_loc_243_tools_location(exp_5, loc_7);
	 {
	    obj_t exit_761;
	    obj_t value_762;
	    if (
	       PAIRP(exp_5))
	      {		/* Ast/exit.scm 75 */
		 obj_t cdr_146_167_767;
		 cdr_146_167_767 =
		    CDR(exp_5);
		 if (
		    PAIRP(cdr_146_167_767))
		   {	/* Ast/exit.scm 75 */
		      exit_761 =
			 CAR(cdr_146_167_767);
		      value_762 =
			 CDR(cdr_146_167_767);
		      {		/* Ast/exit.scm 77 */
			 node_bglt value_771;
			 node_bglt exit_772;
			 {	/* Ast/exit.scm 77 */
			    obj_t arg1493_777;
			    obj_t arg1494_778;
			    arg1493_777 =
			       normalize_progn_143_tools_progn(value_762);
			    arg1494_778 =
			       CNST_TABLE_REF(((long) 2));
			    value_771 =
			       sexp__node_235_ast_sexp(arg1493_777, stack_6, loc_760, arg1494_778);
			 }
			 exit_772 =
			    sexp__node_235_ast_sexp(exit_761, stack_6, loc_760,
			    CNST_TABLE_REF(((long) 2)));
			 {	/* Ast/exit.scm 79 */
			    obj_t arg1489_774;
			    arg1489_774 = ____74_type_cache;
			    {	/* Ast/exit.scm 79 */
			       jump_ex_it_184_bglt res1578_1208;
			       {	/* Ast/exit.scm 79 */
				  type_bglt type_1197;
				  type_1197 =
				     (type_bglt) (arg1489_774);
				  {	/* ./Ast/node.scm 721 */
				     jump_ex_it_184_bglt new1396_1200;
				     new1396_1200 =
					((jump_ex_it_184_bglt) BREF(GC_MALLOC(sizeof(struct jump_ex_it_184))));
				     {	/* ./Ast/node.scm 721 */
					long arg1502_1201;
					arg1502_1201 =
					   class_num_218___object(jump_ex_it_184_ast_node);
					{	/* ./Ast/node.scm 721 */
					   obj_t obj_1206;
					   obj_1206 =
					      (obj_t) (new1396_1200);
					   (((obj_t) CREF(obj_1206))->header = MAKE_HEADER(arg1502_1201, 0), BUNSPEC);
					}
				     }
				     {	/* ./Ast/node.scm 721 */
					object_bglt aux_1396;
					aux_1396 =
					   (object_bglt) (new1396_1200);
					OBJECT_WIDENING_SET(aux_1396, BFALSE);
				     }
				     ((((jump_ex_it_184_bglt) CREF(new1396_1200))->loc) = ((obj_t) loc_760), BUNSPEC);
				     ((((jump_ex_it_184_bglt) CREF(new1396_1200))->type) = ((type_bglt) type_1197), BUNSPEC);
				     ((((jump_ex_it_184_bglt) CREF(new1396_1200))->exit) = ((node_bglt) exit_772), BUNSPEC);
				     ((((jump_ex_it_184_bglt) CREF(new1396_1200))->value) = ((node_bglt) value_771), BUNSPEC);
				     res1578_1208 = new1396_1200;
				  }
			       }
			       return res1578_1208;
			    }
			 }
		      }
		   }
		 else
		   {	/* Ast/exit.scm 75 */
		      node_bglt aux_1405;
		    tag_139_224_764:
		      aux_1405 =
			 error_sexp__node_157_ast_sexp(string1580_ast_exit, exp_5, loc_760);
		      return
			 (jump_ex_it_184_bglt) (aux_1405);
		   }
	      }
	    else
	      {		/* Ast/exit.scm 75 */
		 node_bglt aux_1408;
		 goto tag_139_224_764;
		 return
		    (jump_ex_it_184_bglt) (aux_1408);
	      }
	 }
      }
   }
}



/* _jump-exit->node */
obj_t 
_jump_exit__node_209_ast_exit(obj_t env_1243, obj_t exp_1244, obj_t stack_1245, obj_t loc_1246, obj_t site_1247)
{
   AN_OBJECT;
   {	/* Ast/exit.scm 73 */
      {		/* Ast/exit.scm 73 */
	 jump_ex_it_184_bglt aux_1410;
	 aux_1410 =
	    jump_exit__node_34_ast_exit(exp_1244, stack_1245, loc_1246, site_1247);
	 return
	    (obj_t) (aux_1410);
      }
   }
}



/* method-init */
obj_t 
method_init_76_ast_exit()
{
   AN_OBJECT;
   {	/* Ast/exit.scm 14 */
      return BUNSPEC;
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_ast_exit()
{
   AN_OBJECT;
   {	/* Ast/exit.scm 14 */
      module_initialization_70_type_type(((long) 0), "AST_EXIT");
      module_initialization_70_ast_var(((long) 0), "AST_EXIT");
      module_initialization_70_ast_node(((long) 0), "AST_EXIT");
      module_initialization_70_tools_trace(((long) 0), "AST_EXIT");
      module_initialization_70_ast_sexp(((long) 0), "AST_EXIT");
      module_initialization_70_ast_local(((long) 0), "AST_EXIT");
      module_initialization_70_ast_ident(((long) 0), "AST_EXIT");
      module_initialization_70_type_cache(((long) 0), "AST_EXIT");
      module_initialization_70_tools_progn(((long) 0), "AST_EXIT");
      return
	 module_initialization_70_tools_location(((long) 0), "AST_EXIT");
   }
}
