/*===========================================================================*/
/*   (Ast/find-gdefs.scm)                                                    */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;

typedef struct ccomp
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t producer;
     obj_t consumer;
     obj_t finalizer;
     obj_t checksummer;
  }
     *ccomp_bglt;


extern obj_t find_global_defs_64_ast_find_gdefs_13(obj_t);
static obj_t method_init_76_ast_find_gdefs_13();
static obj_t _gdef_key__233_ast_find_gdefs_13 = BUNSPEC;
extern obj_t id_of_id_112_ast_ident(obj_t, obj_t);
extern obj_t create_struct(obj_t, long);
extern obj_t remprop__243___r4_symbols_6_4(obj_t, obj_t);
extern obj_t gensym___r4_symbols_6_4;
extern obj_t dsssl_defaulted_formal__174_tools_dsssl(obj_t);
extern obj_t check_to_be_define_14_ast_find_gdefs_13();
extern obj_t user_error_151_tools_error(obj_t, obj_t, obj_t, obj_t);
static obj_t bind_global_def__22_ast_find_gdefs_13(obj_t, obj_t);
static obj_t _gdefs_list__201_ast_find_gdefs_13 = BUNSPEC;
extern obj_t module_initialization_70_ast_find_gdefs_13(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_ast_ident(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_tools_dsssl(long, char *);
extern obj_t module_initialization_70_tools_args(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_module_module(long, char *);
extern obj_t module_initialization_70_tools_location(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_symbols_6_4(long, char *);
static obj_t _anonymous_1497__161_ast_find_gdefs_13(obj_t, obj_t, obj_t, obj_t);
static obj_t _anonymous_1501__153_ast_find_gdefs_13(obj_t, obj_t, obj_t, obj_t);
static obj_t _anonymous_1500__165_ast_find_gdefs_13(obj_t, obj_t, obj_t, obj_t);
static obj_t push_args_50_ast_find_gdefs_13(obj_t, obj_t, obj_t);
static obj_t imported_modules_init_94_ast_find_gdefs_13();
extern obj_t dsssl_named_constant__188_tools_dsssl(obj_t);
static obj_t library_modules_init_112_ast_find_gdefs_13();
static bool_t find_mutations__75_ast_find_gdefs_13(obj_t, obj_t);
static obj_t toplevel_init_63_ast_find_gdefs_13();
extern obj_t open_input_string(obj_t);
static obj_t _all_defined_id__238_ast_find_gdefs_13 = BUNSPEC;
static obj_t find_1_mutations__59_ast_find_gdefs_13(obj_t, obj_t);
static obj_t define_global_125_ast_find_gdefs_13(obj_t, obj_t, obj_t, obj_t);
extern int arity_tools_args(obj_t);
extern obj_t getprop___r4_symbols_6_4(obj_t, obj_t);
extern obj_t parse_id_241_ast_ident(obj_t, obj_t);
static obj_t loop_ast_find_gdefs_13(obj_t, obj_t, obj_t);
static obj_t _check_to_be_define_117_ast_find_gdefs_13(obj_t);
extern obj_t to_be_define__131_ast_find_gdefs_13(global_bglt);
static obj_t scan_ast_find_gdefs_13(obj_t, obj_t, obj_t);
extern obj_t memq___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern obj_t putprop__88___r4_symbols_6_4(obj_t, obj_t, obj_t);
extern obj_t shape_tools_shape(obj_t);
static obj_t _to_be_define_1889_86_ast_find_gdefs_13(obj_t, obj_t);
extern obj_t _module__166_module_module;
extern obj_t read___reader(obj_t);
static obj_t _find_global_defs_146_ast_find_gdefs_13(obj_t, obj_t);
static obj_t defs__list_164_ast_find_gdefs_13();
extern obj_t find_location_120_tools_location(obj_t);
static obj_t require_initialization_114_ast_find_gdefs_13 = BUNSPEC;
static obj_t _to_be_define__145_ast_find_gdefs_13 = BUNSPEC;
extern obj_t dsssl_default_formal_243_tools_dsssl(obj_t);
static obj_t cnst_init_137_ast_find_gdefs_13();
static obj_t __cnst[25];

DEFINE_EXPORT_PROCEDURE(to_be_define__env_91_ast_find_gdefs_13, _to_be_define_1889_86_ast_find_gdefs_131910, _to_be_define_1889_86_ast_find_gdefs_13, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc1894_ast_find_gdefs_13, _anonymous_1500__165_ast_find_gdefs_131911, _anonymous_1500__165_ast_find_gdefs_13, 0L, 3);
DEFINE_STATIC_PROCEDURE(proc1893_ast_find_gdefs_13, _anonymous_1501__153_ast_find_gdefs_131912, _anonymous_1501__153_ast_find_gdefs_13, 0L, 3);
DEFINE_STATIC_PROCEDURE(proc1892_ast_find_gdefs_13, _anonymous_1497__161_ast_find_gdefs_131913, _anonymous_1497__161_ast_find_gdefs_13, 0L, 3);
DEFINE_STATIC_PROCEDURE(proc1891_ast_find_gdefs_13, define_global_125_ast_find_gdefs_131914, define_global_125_ast_find_gdefs_13, 0L, 3);
DEFINE_EXPORT_PROCEDURE(find_global_defs_env_41_ast_find_gdefs_13, _find_global_defs_146_ast_find_gdefs_131915, _find_global_defs_146_ast_find_gdefs_13, 0L, 1);
DEFINE_EXPORT_PROCEDURE(check_to_be_define_env_225_ast_find_gdefs_13, _check_to_be_define_117_ast_find_gdefs_131916, _check_to_be_define_117_ast_find_gdefs_13, 0L, 0);
DEFINE_STRING(string1899_ast_find_gdefs_13, string1899_ast_find_gdefs_131917, "Illegal `define-generic' form", 29);
DEFINE_STRING(string1898_ast_find_gdefs_13, string1898_ast_find_gdefs_131918, "Illegal `define-inline' form", 28);
DEFINE_STRING(string1897_ast_find_gdefs_13, string1897_ast_find_gdefs_131919, "Illegal `lambda' form", 21);
DEFINE_STRING(string1896_ast_find_gdefs_13, string1896_ast_find_gdefs_131920, "lambda", 6);
DEFINE_STRING(string1895_ast_find_gdefs_13, string1895_ast_find_gdefs_131921, "Illegal duplicated definition", 29);
DEFINE_STRING(string1905_ast_find_gdefs_13, string1905_ast_find_gdefs_131922, "IF CASE APPLY BIND-EXIT LABELS LETREC LET SET! ASSERT QUOTE LAMBDA FREE-PRAGMA PRAGMA WRITE @ NOTHING DONE DEFINE-METHOD DEFINE-GENERIC DEFINE-INLINE DEFINE BEGIN READ DEF FIND-GDEFS ", 183);
DEFINE_STRING(string1904_ast_find_gdefs_13, string1904_ast_find_gdefs_131923, "and `.' notation", 16);
DEFINE_STRING(string1903_ast_find_gdefs_13, string1903_ast_find_gdefs_131924, "Can't use both DSSSL named constant", 35);
DEFINE_STRING(string1902_ast_find_gdefs_13, string1902_ast_find_gdefs_131925, "symbol expected", 15);
DEFINE_STRING(string1901_ast_find_gdefs_13, string1901_ast_find_gdefs_131926, "symbol or named constant expected", 33);
DEFINE_STRING(string1890_ast_find_gdefs_13, string1890_ast_find_gdefs_131927, "Can't find global definition", 28);
DEFINE_STRING(string1900_ast_find_gdefs_13, string1900_ast_find_gdefs_131928, "Illegal formal parameter", 24);



/* module-initialization */
obj_t 
module_initialization_70_ast_find_gdefs_13(long checksum_2163, char *from_2164)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_ast_find_gdefs_13))
	{
	   require_initialization_114_ast_find_gdefs_13 =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_ast_find_gdefs_13();
	   cnst_init_137_ast_find_gdefs_13();
	   imported_modules_init_94_ast_find_gdefs_13();
	   method_init_76_ast_find_gdefs_13();
	   toplevel_init_63_ast_find_gdefs_13();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_ast_find_gdefs_13()
{
   AN_OBJECT;
   {	/* Ast/find-gdefs.scm 23 */
      module_initialization_70___r4_symbols_6_4(((long) 0), "AST_FIND-GDEFS");
      module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "AST_FIND-GDEFS");
      module_initialization_70___reader(((long) 0), "AST_FIND-GDEFS");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_ast_find_gdefs_13()
{
   AN_OBJECT;
   {	/* Ast/find-gdefs.scm 23 */
      {		/* Ast/find-gdefs.scm 23 */
	 obj_t cnst_port_138_2156;
	 cnst_port_138_2156 =
	    open_input_string(string1905_ast_find_gdefs_13);
	 {
	    long i_2157;
	    i_2157 = ((long) 24);
	  loop_2158:
	    {	/* Ast/find-gdefs.scm 23 */
	       bool_t test1906_2159;
	       test1906_2159 =
		  (i_2157 == ((long) -1));
	       if (test1906_2159)
		 {	/* Ast/find-gdefs.scm 23 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Ast/find-gdefs.scm 23 */
		    {	/* Ast/find-gdefs.scm 23 */
		       obj_t arg1907_2160;
		       {	/* Ast/find-gdefs.scm 23 */
			  obj_t list1908_2161;
			  list1908_2161 =
			     MAKE_PAIR(cnst_port_138_2156, BNIL);
			  arg1907_2160 =
			     read___reader(list1908_2161);
		       }
		       CNST_TABLE_SET(i_2157, arg1907_2160);
		    }
		    {	/* Ast/find-gdefs.scm 23 */
		       int aux_2162;
		       {	/* Ast/find-gdefs.scm 23 */
			  long aux_2182;
			  aux_2182 =
			     (i_2157 - ((long) 1));
			  aux_2162 =
			     (int) (aux_2182);
		       }
		       {
			  long i_2185;
			  i_2185 =
			     (long) (aux_2162);
			  i_2157 = i_2185;
			  goto loop_2158;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_ast_find_gdefs_13()
{
   AN_OBJECT;
   {	/* Ast/find-gdefs.scm 23 */
      _to_be_define__145_ast_find_gdefs_13 = BNIL;
      _gdef_key__233_ast_find_gdefs_13 =
	 PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4,
	 CNST_TABLE_REF(((long) 0)), BEOA);
      _gdefs_list__201_ast_find_gdefs_13 = BNIL;
      return (
	 _all_defined_id__238_ast_find_gdefs_13 = BNIL, BUNSPEC);
   }
}



/* to-be-define! */
obj_t 
to_be_define__131_ast_find_gdefs_13(global_bglt global_15)
{
   AN_OBJECT;
   {	/* Ast/find-gdefs.scm 53 */
      {		/* Ast/find-gdefs.scm 54 */
	 obj_t obj2_1643;
	 obj2_1643 = _to_be_define__145_ast_find_gdefs_13;
	 {	/* ./Ieee/pair-list.scm 5689 */
	    obj_t aux_2190;
	    aux_2190 =
	       (obj_t) (global_15);
	    return (
	       _to_be_define__145_ast_find_gdefs_13 =
	       MAKE_PAIR(aux_2190, obj2_1643), BUNSPEC);
	 }
      }
   }
}



/* _to-be-define!1889 */
obj_t 
_to_be_define_1889_86_ast_find_gdefs_13(obj_t env_2126, obj_t global_2127)
{
   AN_OBJECT;
   {	/* Ast/find-gdefs.scm 53 */
      return
	 to_be_define__131_ast_find_gdefs_13(
	 (global_bglt) (global_2127));
   }
}



/* check-to-be-define */
obj_t 
check_to_be_define_14_ast_find_gdefs_13()
{
   AN_OBJECT;
   {	/* Ast/find-gdefs.scm 62 */
      {
	 obj_t l1445_743;
	 l1445_743 = _to_be_define__145_ast_find_gdefs_13;
       lname1446_744:
	 if (
	    PAIRP(l1445_743))
	   {	/* Ast/find-gdefs.scm 63 */
	      {		/* Ast/find-gdefs.scm 64 */
		 obj_t global_746;
		 global_746 =
		    CAR(l1445_743);
		 {	/* Ast/find-gdefs.scm 64 */
		    obj_t def_747;
		    {	/* Ast/find-gdefs.scm 64 */
		       obj_t aux_2198;
		       {	/* Ast/find-gdefs.scm 64 */
			  global_bglt obj_1646;
			  obj_1646 =
			     (global_bglt) (global_746);
			  aux_2198 =
			     (((global_bglt) CREF(obj_1646))->id);
		       }
		       def_747 =
			  getprop___r4_symbols_6_4(aux_2198, _gdef_key__233_ast_find_gdefs_13);
		    }
		    {	/* Ast/find-gdefs.scm 65 */
		       bool_t test_2202;
		       if (
			  STRUCTP(def_747))
			 {	/* ./Ieee/equiv.scm 5508 */
			    obj_t aux_2207;
			    obj_t aux_2205;
			    aux_2207 =
			       CNST_TABLE_REF(((long) 1));
			    aux_2205 =
			       STRUCT_KEY(def_747);
			    test_2202 =
			       (aux_2205 == aux_2207);
			 }
		       else
			 {	/* Ast/find-gdefs.scm 43 */
			    test_2202 = ((bool_t) 0)
			       ;
			 }
		       if (test_2202)
			 {	/* Ast/find-gdefs.scm 65 */
			    BUNSPEC;
			 }
		       else
			 {	/* Ast/find-gdefs.scm 66 */
			    obj_t arg1476_749;
			    obj_t arg1478_751;
			    arg1476_749 =
			       shape_tools_shape(global_746);
			    {	/* Ast/find-gdefs.scm 68 */
			       obj_t aux_2211;
			       {	/* Ast/find-gdefs.scm 68 */
				  global_bglt obj_1655;
				  obj_1655 =
				     (global_bglt) (global_746);
				  aux_2211 =
				     (((global_bglt) CREF(obj_1655))->src);
			       }
			       arg1478_751 =
				  shape_tools_shape(aux_2211);
			    }
			    {	/* Ast/find-gdefs.scm 66 */
			       obj_t list1480_753;
			       list1480_753 =
				  MAKE_PAIR(BNIL, BNIL);
			       user_error_151_tools_error(arg1476_749, string1890_ast_find_gdefs_13, arg1478_751, list1480_753);
			    }
			 }
		    }
		 }
	      }
	      {
		 obj_t l1445_2217;
		 l1445_2217 =
		    CDR(l1445_743);
		 l1445_743 = l1445_2217;
		 goto lname1446_744;
	      }
	   }
	 else
	   {	/* Ast/find-gdefs.scm 63 */
	      ((bool_t) 1);
	   }
      }
      {
	 obj_t l1447_757;
	 l1447_757 = _all_defined_id__238_ast_find_gdefs_13;
       lname1448_758:
	 if (
	    PAIRP(l1447_757))
	   {	/* Ast/find-gdefs.scm 72 */
	      remprop__243___r4_symbols_6_4(
		 CAR(l1447_757), _gdef_key__233_ast_find_gdefs_13);
	      {
		 obj_t l1447_2223;
		 l1447_2223 =
		    CDR(l1447_757);
		 l1447_757 = l1447_2223;
		 goto lname1448_758;
	      }
	   }
	 else
	   {	/* Ast/find-gdefs.scm 72 */
	      ((bool_t) 1);
	   }
      }
      _all_defined_id__238_ast_find_gdefs_13 = BNIL;
      return (
	 _to_be_define__145_ast_find_gdefs_13 = BNIL, BUNSPEC);
   }
}



/* _check-to-be-define */
obj_t 
_check_to_be_define_117_ast_find_gdefs_13(obj_t env_2128)
{
   AN_OBJECT;
   {	/* Ast/find-gdefs.scm 62 */
      return
	 check_to_be_define_14_ast_find_gdefs_13();
   }
}



/* bind-global-def! */
obj_t 
bind_global_def__22_ast_find_gdefs_13(obj_t id_17, obj_t arity_18)
{
   AN_OBJECT;
   {	/* Ast/find-gdefs.scm 101 */
      {		/* Ast/find-gdefs.scm 102 */
	 obj_t def_762;
	 {	/* Ast/find-gdefs.scm 102 */
	    obj_t access_1661;
	    access_1661 =
	       CNST_TABLE_REF(((long) 2));
	    {	/* Ast/find-gdefs.scm 43 */
	       obj_t new_1663;
	       {	/* Ast/find-gdefs.scm 43 */
		  obj_t aux_2227;
		  aux_2227 =
		     CNST_TABLE_REF(((long) 1));
		  new_1663 =
		     create_struct(aux_2227, ((long) 3));
	       }
	       STRUCT_SET(new_1663, ((long) 2), arity_18);
	       STRUCT_SET(new_1663, ((long) 1), access_1661);
	       STRUCT_SET(new_1663, ((long) 0), id_17);
	       def_762 = new_1663;
	    }
	 }
	 {	/* Ast/find-gdefs.scm 103 */
	    obj_t obj2_1680;
	    obj2_1680 = _gdefs_list__201_ast_find_gdefs_13;
	    _gdefs_list__201_ast_find_gdefs_13 =
	       MAKE_PAIR(def_762, obj2_1680);
	 }
	 {	/* Ast/find-gdefs.scm 104 */
	    obj_t obj2_1682;
	    obj2_1682 = _all_defined_id__238_ast_find_gdefs_13;
	    _all_defined_id__238_ast_find_gdefs_13 =
	       MAKE_PAIR(id_17, obj2_1682);
	 }
	 return
	    putprop__88___r4_symbols_6_4(id_17, _gdef_key__233_ast_find_gdefs_13, def_762);
      }
   }
}



/* defs->list */
obj_t 
defs__list_164_ast_find_gdefs_13()
{
   AN_OBJECT;
   {	/* Ast/find-gdefs.scm 113 */
      {
	 obj_t defs_763;
	 obj_t res_764;
	 defs_763 = _gdefs_list__201_ast_find_gdefs_13;
	 res_764 = BNIL;
       loop_765:
	 if (
	    NULLP(defs_763))
	   {	/* Ast/find-gdefs.scm 116 */
	      _gdefs_list__201_ast_find_gdefs_13 = BNIL;
	      return res_764;
	   }
	 else
	   {	/* Ast/find-gdefs.scm 120 */
	      obj_t def_767;
	      def_767 =
		 CAR(defs_763);
	      {		/* Ast/find-gdefs.scm 121 */
		 obj_t arg1488_768;
		 obj_t arg1489_769;
		 arg1488_768 =
		    CDR(defs_763);
		 {	/* Ast/find-gdefs.scm 122 */
		    obj_t arg1490_770;
		    {	/* Ast/find-gdefs.scm 122 */
		       obj_t arg1491_771;
		       obj_t arg1493_772;
		       arg1491_771 =
			  STRUCT_REF(def_767, ((long) 0));
		       {	/* ./Ieee/pair-list.scm 5689 */
			  obj_t aux_2243;
			  obj_t aux_2241;
			  aux_2243 =
			     STRUCT_REF(def_767, ((long) 2));
			  aux_2241 =
			     STRUCT_REF(def_767, ((long) 1));
			  arg1493_772 =
			     MAKE_PAIR(aux_2241, aux_2243);
		       }
		       arg1490_770 =
			  MAKE_PAIR(arg1491_771, arg1493_772);
		    }
		    arg1489_769 =
		       MAKE_PAIR(arg1490_770, res_764);
		 }
		 {
		    obj_t res_2249;
		    obj_t defs_2248;
		    defs_2248 = arg1488_768;
		    res_2249 = arg1489_769;
		    res_764 = res_2249;
		    defs_763 = defs_2248;
		    goto loop_765;
		 }
	      }
	   }
      }
   }
}



/* find-global-defs */
obj_t 
find_global_defs_64_ast_find_gdefs_13(obj_t sexp__30_19)
{
   AN_OBJECT;
   {	/* Ast/find-gdefs.scm 138 */
      {		/* Ast/find-gdefs.scm 154 */
	 obj_t define_global_125_2132;
	 define_global_125_2132 = proc1891_ast_find_gdefs_13;
	 _gdefs_list__201_ast_find_gdefs_13 = BNIL;
	 {	/* Ast/find-gdefs.scm 181 */
	    obj_t _anonymous_1497__161_2131;
	    _anonymous_1497__161_2131 = proc1892_ast_find_gdefs_13;
	    scan_ast_find_gdefs_13(sexp__30_19, define_global_125_2132, _anonymous_1497__161_2131);
	 }
	 {	/* Ast/find-gdefs.scm 185 */
	    obj_t _anonymous_1501__153_2129;
	    obj_t _anonymous_1500__165_2130;
	    _anonymous_1501__153_2129 = proc1893_ast_find_gdefs_13;
	    _anonymous_1500__165_2130 = proc1894_ast_find_gdefs_13;
	    scan_ast_find_gdefs_13(sexp__30_19, _anonymous_1500__165_2130, _anonymous_1501__153_2129);
	 }
	 return
	    defs__list_164_ast_find_gdefs_13();
      }
   }
}



/* loop */
obj_t 
loop_ast_find_gdefs_13(obj_t action_define_41_2152, obj_t action_body_250_2151, obj_t sexp__30_802)
{
   AN_OBJECT;
   {	/* Ast/find-gdefs.scm 154 */
    loop_ast_find_gdefs_13:
      if (
	 PAIRP(sexp__30_802))
	{	/* Ast/find-gdefs.scm 157 */
	   obj_t sexp_805;
	   sexp_805 =
	      CAR(sexp__30_802);
	   {
	      obj_t var_808;
	      obj_t args_809;
	      obj_t exp_810;
	      obj_t var_816;
	      obj_t exp_817;
	      if (
		 PAIRP(sexp_805))
		{	/* Ast/find-gdefs.scm 158 */
		   bool_t test_2258;
		   {	/* ./Ieee/equiv.scm 5508 */
		      obj_t aux_2261;
		      obj_t aux_2259;
		      aux_2261 =
			 CNST_TABLE_REF(((long) 3));
		      aux_2259 =
			 CAR(sexp_805);
		      test_2258 =
			 (aux_2259 == aux_2261);
		   }
		   if (test_2258)
		     {	/* Ast/find-gdefs.scm 158 */
			loop_ast_find_gdefs_13(action_define_41_2152, action_body_250_2151,
			   CDR(sexp_805));
			{
			   obj_t sexp__30_2266;
			   sexp__30_2266 =
			      CDR(sexp__30_802);
			   sexp__30_802 = sexp__30_2266;
			   goto loop_ast_find_gdefs_13;
			}
		     }
		   else
		     {	/* Ast/find-gdefs.scm 158 */
			obj_t cdr_146_167_824;
			cdr_146_167_824 =
			   CDR(sexp_805);
			{	/* Ast/find-gdefs.scm 158 */
			   bool_t test_2269;
			   {	/* ./Ieee/equiv.scm 5508 */
			      obj_t aux_2272;
			      obj_t aux_2270;
			      aux_2272 =
				 CNST_TABLE_REF(((long) 4));
			      aux_2270 =
				 CAR(sexp_805);
			      test_2269 =
				 (aux_2270 == aux_2272);
			   }
			   if (test_2269)
			     {	/* Ast/find-gdefs.scm 158 */
				if (
				   PAIRP(cdr_146_167_824))
				  {	/* Ast/find-gdefs.scm 158 */
				     obj_t car_150_99_827;
				     car_150_99_827 =
					CAR(cdr_146_167_824);
				     if (
					PAIRP(car_150_99_827))
				       {	/* Ast/find-gdefs.scm 158 */
					  var_808 =
					     CAR(car_150_99_827);
					  args_809 =
					     CDR(car_150_99_827);
					  exp_810 =
					     CDR(cdr_146_167_824);
					tag_122_225_811:
					  {	/* Ast/find-gdefs.scm 165 */
					     int arg1550_870;
					     arg1550_870 =
						arity_tools_args(args_809);
					     PROCEDURE_ENTRY(action_define_41_2152) (action_define_41_2152, var_808,
						BINT(arg1550_870), sexp_805, BEOA);
					  }
					  PROCEDURE_ENTRY(action_body_250_2151) (action_body_250_2151, args_809, exp_810, sexp_805, BEOA);
					  {
					     obj_t sexp__30_2286;
					     sexp__30_2286 =
						CDR(sexp__30_802);
					     sexp__30_802 = sexp__30_2286;
					     goto loop_ast_find_gdefs_13;
					  }
				       }
				     else
				       {	/* Ast/find-gdefs.scm 158 */
					  var_816 =
					     CAR(cdr_146_167_824);
					  exp_817 =
					     CDR(cdr_146_167_824);
					  PROCEDURE_ENTRY(action_define_41_2152) (action_define_41_2152, var_816, BFALSE, sexp_805, BEOA);
					  PROCEDURE_ENTRY(action_body_250_2151) (action_body_250_2151, BNIL, exp_817, sexp_805, BEOA);
					  {
					     obj_t sexp__30_2295;
					     sexp__30_2295 =
						CDR(sexp__30_802);
					     sexp__30_802 = sexp__30_2295;
					     goto loop_ast_find_gdefs_13;
					  }
				       }
				  }
				else
				  {	/* Ast/find-gdefs.scm 158 */
				   tag_125_98_819:
				     {	/* Ast/find-gdefs.scm 176 */
					obj_t arg1556_875;
					{	/* Ast/find-gdefs.scm 176 */
					   obj_t list1557_876;
					   list1557_876 =
					      MAKE_PAIR(sexp_805, BNIL);
					   arg1556_875 = list1557_876;
					}
					PROCEDURE_ENTRY(action_body_250_2151) (action_body_250_2151, BNIL, arg1556_875, sexp_805, BEOA);
				     }
				     {
					obj_t sexp__30_2302;
					sexp__30_2302 =
					   CDR(sexp__30_802);
					sexp__30_802 = sexp__30_2302;
					goto loop_ast_find_gdefs_13;
				     }
				  }
			     }
			   else
			     {	/* Ast/find-gdefs.scm 158 */
				bool_t test_2304;
				{	/* ./Ieee/equiv.scm 5508 */
				   obj_t aux_2307;
				   obj_t aux_2305;
				   aux_2307 =
				      CNST_TABLE_REF(((long) 5));
				   aux_2305 =
				      CAR(sexp_805);
				   test_2304 =
				      (aux_2305 == aux_2307);
				}
				if (test_2304)
				  {	/* Ast/find-gdefs.scm 158 */
				     if (
					PAIRP(cdr_146_167_824))
				       {	/* Ast/find-gdefs.scm 158 */
					  obj_t car_219_238_838;
					  car_219_238_838 =
					     CAR(cdr_146_167_824);
					  if (
					     PAIRP(car_219_238_838))
					    {
					       obj_t exp_2319;
					       obj_t args_2317;
					       obj_t var_2315;
					       var_2315 =
						  CAR(car_219_238_838);
					       args_2317 =
						  CDR(car_219_238_838);
					       exp_2319 =
						  CDR(cdr_146_167_824);
					       exp_810 = exp_2319;
					       args_809 = args_2317;
					       var_808 = var_2315;
					       goto tag_122_225_811;
					    }
					  else
					    {	/* Ast/find-gdefs.scm 158 */
					       goto tag_125_98_819;
					    }
				       }
				     else
				       {	/* Ast/find-gdefs.scm 158 */
					  goto tag_125_98_819;
				       }
				  }
				else
				  {	/* Ast/find-gdefs.scm 158 */
				     bool_t test_2321;
				     {	/* ./Ieee/equiv.scm 5508 */
					obj_t aux_2324;
					obj_t aux_2322;
					aux_2324 =
					   CNST_TABLE_REF(((long) 6));
					aux_2322 =
					   CAR(sexp_805);
					test_2321 =
					   (aux_2322 == aux_2324);
				     }
				     if (test_2321)
				       {	/* Ast/find-gdefs.scm 158 */
					  if (
					     PAIRP(cdr_146_167_824))
					    {	/* Ast/find-gdefs.scm 158 */
					       obj_t car_262_98_846;
					       car_262_98_846 =
						  CAR(cdr_146_167_824);
					       if (
						  PAIRP(car_262_98_846))
						 {
						    obj_t exp_2336;
						    obj_t args_2334;
						    obj_t var_2332;
						    var_2332 =
						       CAR(car_262_98_846);
						    args_2334 =
						       CDR(car_262_98_846);
						    exp_2336 =
						       CDR(cdr_146_167_824);
						    exp_810 = exp_2336;
						    args_809 = args_2334;
						    var_808 = var_2332;
						    goto tag_122_225_811;
						 }
					       else
						 {	/* Ast/find-gdefs.scm 158 */
						    goto tag_125_98_819;
						 }
					    }
					  else
					    {	/* Ast/find-gdefs.scm 158 */
					       goto tag_125_98_819;
					    }
				       }
				     else
				       {	/* Ast/find-gdefs.scm 158 */
					  bool_t test_2338;
					  {	/* ./Ieee/equiv.scm 5508 */
					     obj_t aux_2341;
					     obj_t aux_2339;
					     aux_2341 =
						CNST_TABLE_REF(((long) 7));
					     aux_2339 =
						CAR(sexp_805);
					     test_2338 =
						(aux_2339 == aux_2341);
					  }
					  if (test_2338)
					    {	/* Ast/find-gdefs.scm 158 */
					       if (
						  PAIRP(cdr_146_167_824))
						 {	/* Ast/find-gdefs.scm 158 */
						    obj_t car_302_55_854;
						    car_302_55_854 =
						       CAR(cdr_146_167_824);
						    if (
						       PAIRP(car_302_55_854))
						      {		/* Ast/find-gdefs.scm 158 */
							 PROCEDURE_ENTRY(action_body_250_2151) (action_body_250_2151,
							    CDR(car_302_55_854),
							    CDR(cdr_146_167_824), sexp_805, BEOA);
							 {
							    obj_t sexp__30_2353;
							    sexp__30_2353 =
							       CDR(sexp__30_802);
							    sexp__30_802 = sexp__30_2353;
							    goto loop_ast_find_gdefs_13;
							 }
						      }
						    else
						      {		/* Ast/find-gdefs.scm 158 */
							 goto tag_125_98_819;
						      }
						 }
					       else
						 {	/* Ast/find-gdefs.scm 158 */
						    goto tag_125_98_819;
						 }
					    }
					  else
					    {	/* Ast/find-gdefs.scm 158 */
					       goto tag_125_98_819;
					    }
				       }
				  }
			     }
			}
		     }
		}
	      else
		{	/* Ast/find-gdefs.scm 158 */
		   goto tag_125_98_819;
		}
	   }
	}
      else
	{	/* Ast/find-gdefs.scm 155 */
	   return
	      CNST_TABLE_REF(((long) 8));
	}
   }
}



/* scan */
obj_t 
scan_ast_find_gdefs_13(obj_t sexp__30_798, obj_t action_define_41_799, obj_t action_body_250_800)
{
   AN_OBJECT;
   {	/* Ast/find-gdefs.scm 153 */
      return
	 loop_ast_find_gdefs_13(action_define_41_799, action_body_250_800, sexp__30_798);
   }
}



/* _find-global-defs */
obj_t 
_find_global_defs_146_ast_find_gdefs_13(obj_t env_2133, obj_t sexp__30_2134)
{
   AN_OBJECT;
   {	/* Ast/find-gdefs.scm 138 */
      return
	 find_global_defs_64_ast_find_gdefs_13(sexp__30_2134);
   }
}



/* <anonymous:1501> */
obj_t 
_anonymous_1501__153_ast_find_gdefs_13(obj_t env_2135, obj_t args_2136, obj_t exp_2137, obj_t def_2138)
{
   AN_OBJECT;
   {	/* Ast/find-gdefs.scm 186 */
      {
	 obj_t args_789;
	 obj_t exp_790;
	 obj_t def_791;
	 {	/* Ast/find-gdefs.scm 187 */
	    bool_t aux_2358;
	    args_789 = args_2136;
	    exp_790 = exp_2137;
	    def_791 = def_2138;
	    {	/* Ast/find-gdefs.scm 187 */
	       obj_t arg1502_1701;
	       {	/* Ast/find-gdefs.scm 187 */
		  obj_t arg1504_1703;
		  arg1504_1703 =
		     find_location_120_tools_location(def_791);
		  arg1502_1701 =
		     push_args_50_ast_find_gdefs_13(args_789, BNIL, arg1504_1703);
	       }
	       aux_2358 =
		  find_mutations__75_ast_find_gdefs_13(exp_790, arg1502_1701);
	    }
	    return
	       BBOOL(aux_2358);
	 }
      }
   }
}



/* <anonymous:1500> */
obj_t 
_anonymous_1500__165_ast_find_gdefs_13(obj_t env_2139, obj_t x_2140, obj_t y_2141, obj_t exp_2142)
{
   AN_OBJECT;
   {	/* Ast/find-gdefs.scm 184 */
      {
	 obj_t x_785;
	 obj_t y_786;
	 obj_t exp_787;
	 x_785 = x_2140;
	 y_786 = y_2141;
	 exp_787 = exp_2142;
	 return
	    CNST_TABLE_REF(((long) 9));
      }
   }
}



/* <anonymous:1497> */
obj_t 
_anonymous_1497__161_ast_find_gdefs_13(obj_t env_2143, obj_t args_2144, obj_t exp_2145, obj_t def_2146)
{
   AN_OBJECT;
   {	/* Ast/find-gdefs.scm 181 */
      {
	 obj_t args_778;
	 obj_t exp_779;
	 obj_t def_780;
	 args_778 = args_2144;
	 exp_779 = exp_2145;
	 def_780 = def_2146;
	 return
	    CNST_TABLE_REF(((long) 9));
      }
   }
}



/* define-global */
obj_t 
define_global_125_ast_find_gdefs_13(obj_t env_2147, obj_t var_2148, obj_t arity_2149, obj_t exp_2150)
{
   AN_OBJECT;
   {	/* Ast/find-gdefs.scm 142 */
      {
	 obj_t var_878;
	 obj_t arity_879;
	 obj_t exp_880;
	 var_878 = var_2148;
	 arity_879 = arity_2149;
	 exp_880 = exp_2150;
	 {
	    obj_t pre_id_183_882;
	    if (
	       PAIRP(var_878))
	      {		/* Ast/find-gdefs.scm 142 */
		 obj_t cdr_109_69_887;
		 cdr_109_69_887 =
		    CDR(var_878);
		 {	/* Ast/find-gdefs.scm 142 */
		    bool_t test_2368;
		    {	/* ./Ieee/equiv.scm 5508 */
		       obj_t aux_2371;
		       obj_t aux_2369;
		       aux_2371 =
			  CNST_TABLE_REF(((long) 10));
		       aux_2369 =
			  CAR(var_878);
		       test_2368 =
			  (aux_2369 == aux_2371);
		    }
		    if (test_2368)
		      {		/* Ast/find-gdefs.scm 142 */
			 if (
			    PAIRP(cdr_109_69_887))
			   {	/* Ast/find-gdefs.scm 142 */
			      obj_t cdr_112_210_890;
			      cdr_112_210_890 =
				 CDR(cdr_109_69_887);
			      if (
				 PAIRP(cdr_112_210_890))
				{	/* Ast/find-gdefs.scm 142 */
				   bool_t test_2379;
				   {	/* ./Ieee/equiv.scm 5508 */
				      obj_t aux_2380;
				      aux_2380 =
					 CDR(cdr_112_210_890);
				      test_2379 =
					 (aux_2380 == BNIL);
				   }
				   if (test_2379)
				     {	/* Ast/find-gdefs.scm 142 */
					pre_id_183_882 =
					   CAR(cdr_109_69_887);
				      tag_101_79_883:
					{	/* Ast/find-gdefs.scm 145 */
					   obj_t id_898;
					   {	/* Ast/find-gdefs.scm 145 */
					      obj_t arg1572_902;
					      arg1572_902 =
						 find_location_120_tools_location(exp_880);
					      id_898 =
						 id_of_id_112_ast_ident(pre_id_183_882, arg1572_902);
					   }
					   {	/* Ast/find-gdefs.scm 145 */
					      obj_t old_def_101_899;
					      old_def_101_899 =
						 getprop___r4_symbols_6_4(id_898, _gdef_key__233_ast_find_gdefs_13);
					      {		/* Ast/find-gdefs.scm 146 */

						 {	/* Ast/find-gdefs.scm 147 */
						    bool_t test_2386;
						    if (
						       STRUCTP(old_def_101_899))
						      {		/* ./Ieee/equiv.scm 5508 */
							 obj_t aux_2391;
							 obj_t aux_2389;
							 aux_2391 =
							    CNST_TABLE_REF(((long) 1));
							 aux_2389 =
							    STRUCT_KEY(old_def_101_899);
							 test_2386 =
							    (aux_2389 == aux_2391);
						      }
						    else
						      {		/* Ast/find-gdefs.scm 43 */
							 test_2386 = ((bool_t) 0)
							    ;
						      }
						    if (test_2386)
						      {		/* Ast/find-gdefs.scm 148 */
							 obj_t list1571_901;
							 list1571_901 =
							    MAKE_PAIR(BNIL, BNIL);
							 return
							    user_error_151_tools_error(var_878, string1895_ast_find_gdefs_13, exp_880, list1571_901);
						      }
						    else
						      {		/* Ast/find-gdefs.scm 147 */
							 return
							    bind_global_def__22_ast_find_gdefs_13(id_898, arity_879);
						      }
						 }
					      }
					   }
					}
				     }
				   else
				     {
					obj_t pre_id_183_2398;
					pre_id_183_2398 = var_878;
					pre_id_183_882 = pre_id_183_2398;
					goto tag_101_79_883;
				     }
				}
			      else
				{
				   obj_t pre_id_183_2399;
				   pre_id_183_2399 = var_878;
				   pre_id_183_882 = pre_id_183_2399;
				   goto tag_101_79_883;
				}
			   }
			 else
			   {
			      obj_t pre_id_183_2400;
			      pre_id_183_2400 = var_878;
			      pre_id_183_882 = pre_id_183_2400;
			      goto tag_101_79_883;
			   }
		      }
		    else
		      {
			 obj_t pre_id_183_2401;
			 pre_id_183_2401 = var_878;
			 pre_id_183_882 = pre_id_183_2401;
			 goto tag_101_79_883;
		      }
		 }
	      }
	    else
	      {
		 obj_t pre_id_183_2402;
		 pre_id_183_2402 = var_878;
		 pre_id_183_882 = pre_id_183_2402;
		 goto tag_101_79_883;
	      }
	 }
      }
   }
}



/* find-mutations! */
bool_t 
find_mutations__75_ast_find_gdefs_13(obj_t exp__153_20, obj_t stack_21)
{
   AN_OBJECT;
   {	/* Ast/find-gdefs.scm 194 */
      {
	 obj_t l1449_905;
	 l1449_905 = exp__153_20;
       lname1450_906:
	 if (
	    PAIRP(l1449_905))
	   {	/* Ast/find-gdefs.scm 195 */
	      find_1_mutations__59_ast_find_gdefs_13(
		 CAR(l1449_905), stack_21);
	      {
		 obj_t l1449_2407;
		 l1449_2407 =
		    CDR(l1449_905);
		 l1449_905 = l1449_2407;
		 goto lname1450_906;
	      }
	   }
	 else
	   {	/* Ast/find-gdefs.scm 195 */
	      return ((bool_t) 1);
	   }
      }
   }
}



/* find-1-mutations! */
obj_t 
find_1_mutations__59_ast_find_gdefs_13(obj_t exp_22, obj_t stack_23)
{
   AN_OBJECT;
   {	/* Ast/find-gdefs.scm 200 */
    find_1_mutations__59_ast_find_gdefs_13:
      {
	 obj_t val_945;
	 obj_t clauses_946;
	 obj_t bindings_933;
	 obj_t body_934;
	 obj_t bindings_930;
	 obj_t body_931;
	 obj_t bindings_927;
	 obj_t body_928;
	 obj_t id_923;
	 obj_t module_924;
	 obj_t val_925;
	 obj_t id_920;
	 obj_t val_921;
	 if (
	    PAIRP(exp_22))
	   {	/* Ast/find-gdefs.scm 201 */
	      obj_t cdr_405_2_965;
	      cdr_405_2_965 =
		 CDR(exp_22);
	      {		/* Ast/find-gdefs.scm 201 */
		 bool_t test_2412;
		 {	/* ./Ieee/equiv.scm 5508 */
		    obj_t aux_2415;
		    obj_t aux_2413;
		    aux_2415 =
		       CNST_TABLE_REF(((long) 15));
		    aux_2413 =
		       CAR(exp_22);
		    test_2412 =
		       (aux_2413 == aux_2415);
		 }
		 if (test_2412)
		   {	/* Ast/find-gdefs.scm 201 */
		      if (
			 PAIRP(cdr_405_2_965))
			{	/* Ast/find-gdefs.scm 201 */
			   bool_t test_2420;
			   {	/* ./Ieee/equiv.scm 5508 */
			      obj_t aux_2421;
			      aux_2421 =
				 CDR(cdr_405_2_965);
			      test_2420 =
				 (aux_2421 == BNIL);
			   }
			   if (test_2420)
			     {	/* Ast/find-gdefs.scm 201 */
				return
				   CNST_TABLE_REF(((long) 8));
			     }
			   else
			     {	/* Ast/find-gdefs.scm 201 */
			      tag_373_251_962:
				{	/* Ast/find-gdefs.scm 292 */
				   obj_t caller_1218;
				   obj_t loc_1219;
				   caller_1218 =
				      CAR(exp_22);
				   loc_1219 =
				      find_location_120_tools_location(exp_22);
				   if (
				      SYMBOLP(caller_1218))
				     {	/* Ast/find-gdefs.scm 296 */
					obj_t pid_1221;
					pid_1221 =
					   parse_id_241_ast_ident(caller_1218, loc_1219);
					{	/* Ast/find-gdefs.scm 296 */
					   obj_t id_1222;
					   id_1222 =
					      CAR(pid_1221);
					   {	/* Ast/find-gdefs.scm 298 */

					      {		/* Ast/find-gdefs.scm 299 */
						 bool_t test_2431;
						 {	/* ./Ieee/equiv.scm 5508 */
						    obj_t aux_2432;
						    aux_2432 =
						       CNST_TABLE_REF(((long) 12));
						    test_2431 =
						       (id_1222 == aux_2432);
						 }
						 if (test_2431)
						   {	/* Ast/find-gdefs.scm 299 */
						      return
							 CNST_TABLE_REF(((long) 8));
						   }
						 else
						   {	/* Ast/find-gdefs.scm 299 */
						      bool_t test_2436;
						      {		/* ./Ieee/equiv.scm 5508 */
							 obj_t aux_2437;
							 aux_2437 =
							    CNST_TABLE_REF(((long) 13));
							 test_2436 =
							    (id_1222 == aux_2437);
						      }
						      if (test_2436)
							{	/* Ast/find-gdefs.scm 299 */
							   return
							      CNST_TABLE_REF(((long) 8));
							}
						      else
							{	/* Ast/find-gdefs.scm 299 */
							   bool_t test_2441;
							   {	/* ./Ieee/equiv.scm 5508 */
							      obj_t aux_2442;
							      aux_2442 =
								 CNST_TABLE_REF(((long) 14));
							      test_2441 =
								 (id_1222 == aux_2442);
							   }
							   if (test_2441)
							     {

								if (
								   PAIRP(exp_22))
								  {	/* Ast/find-gdefs.scm 305 */
								     obj_t cdr_3196_21_1234;
								     cdr_3196_21_1234 =
									CDR(exp_22);
								     if (
									PAIRP(cdr_3196_21_1234))
								       {	/* Ast/find-gdefs.scm 305 */
									  obj_t arg1783_1237;
									  arg1783_1237 =
									     CDR(cdr_3196_21_1234);
									  {	/* Ast/find-gdefs.scm 307 */
									     obj_t arg1784_2106;
									     arg1784_2106 =
										push_args_50_ast_find_gdefs_13(
										CAR(cdr_3196_21_1234), stack_23, loc_1219);
									     {	/* Ast/find-gdefs.scm 307 */
										bool_t aux_2453;
										aux_2453 =
										   find_mutations__75_ast_find_gdefs_13(arg1783_1237, arg1784_2106);
										return
										   BBOOL(aux_2453);
									     }
									  }
								       }
								     else
								       {	/* Ast/find-gdefs.scm 305 */
									tag_3189_29_1231:
									  {	/* Ast/find-gdefs.scm 309 */
									     obj_t list1785_1239;
									     list1785_1239 =
										MAKE_PAIR(BNIL, BNIL);
									     return
										user_error_151_tools_error(string1896_ast_find_gdefs_13, string1897_ast_find_gdefs_13, exp_22, list1785_1239);
									  }
								       }
								  }
								else
								  {	/* Ast/find-gdefs.scm 305 */
								     goto tag_3189_29_1231;
								  }
							     }
							   else
							     {	/* Ast/find-gdefs.scm 314 */
								bool_t aux_2458;
								aux_2458 =
								   find_mutations__75_ast_find_gdefs_13(exp_22, stack_23);
								return
								   BBOOL(aux_2458);
							     }
							}
						   }
					      }
					   }
					}
				     }
				   else
				     {	/* Ast/find-gdefs.scm 315 */
					bool_t aux_2461;
					aux_2461 =
					   find_mutations__75_ast_find_gdefs_13(exp_22, stack_23);
					return
					   BBOOL(aux_2461);
				     }
				}
			     }
			}
		      else
			{	/* Ast/find-gdefs.scm 201 */
			   goto tag_373_251_962;
			}
		   }
		 else
		   {	/* Ast/find-gdefs.scm 201 */
		      bool_t test_2464;
		      {		/* ./Ieee/equiv.scm 5508 */
			 obj_t aux_2467;
			 obj_t aux_2465;
			 aux_2467 =
			    CNST_TABLE_REF(((long) 12));
			 aux_2465 =
			    CAR(exp_22);
			 test_2464 =
			    (aux_2465 == aux_2467);
		      }
		      if (test_2464)
			{	/* Ast/find-gdefs.scm 201 */
			   if (
			      PAIRP(cdr_405_2_965))
			     {	/* Ast/find-gdefs.scm 201 */
				bool_t test_2472;
				{	/* ./Ieee/equiv.scm 5508 */
				   obj_t aux_2473;
				   aux_2473 =
				      CDR(cdr_405_2_965);
				   test_2472 =
				      (aux_2473 == BNIL);
				}
				if (test_2472)
				  {	/* Ast/find-gdefs.scm 201 */
				     return
					CNST_TABLE_REF(((long) 8));
				  }
				else
				  {	/* Ast/find-gdefs.scm 201 */
				     goto tag_373_251_962;
				  }
			     }
			   else
			     {	/* Ast/find-gdefs.scm 201 */
				goto tag_373_251_962;
			     }
			}
		      else
			{	/* Ast/find-gdefs.scm 201 */
			   bool_t test_2477;
			   {	/* ./Ieee/equiv.scm 5508 */
			      obj_t aux_2480;
			      obj_t aux_2478;
			      aux_2480 =
				 CNST_TABLE_REF(((long) 13));
			      aux_2478 =
				 CAR(exp_22);
			      test_2477 =
				 (aux_2478 == aux_2480);
			   }
			   if (test_2477)
			     {	/* Ast/find-gdefs.scm 201 */
				if (
				   PAIRP(cdr_405_2_965))
				  {	/* Ast/find-gdefs.scm 201 */
				     bool_t test_2485;
				     {	/* ./Ieee/equiv.scm 5508 */
					obj_t aux_2486;
					aux_2486 =
					   CDR(cdr_405_2_965);
					test_2485 =
					   (aux_2486 == BNIL);
				     }
				     if (test_2485)
				       {	/* Ast/find-gdefs.scm 201 */
					  return
					     CNST_TABLE_REF(((long) 8));
				       }
				     else
				       {	/* Ast/find-gdefs.scm 201 */
					  goto tag_373_251_962;
				       }
				  }
				else
				  {	/* Ast/find-gdefs.scm 201 */
				     goto tag_373_251_962;
				  }
			     }
			   else
			     {	/* Ast/find-gdefs.scm 201 */
				bool_t test_2490;
				{	/* ./Ieee/equiv.scm 5508 */
				   obj_t aux_2493;
				   obj_t aux_2491;
				   aux_2493 =
				      CNST_TABLE_REF(((long) 16));
				   aux_2491 =
				      CAR(exp_22);
				   test_2490 =
				      (aux_2491 == aux_2493);
				}
				if (test_2490)
				  {	/* Ast/find-gdefs.scm 201 */
				     if (
					PAIRP(cdr_405_2_965))
				       {	/* Ast/find-gdefs.scm 201 */
					  obj_t cdr_1401_24_986;
					  cdr_1401_24_986 =
					     CDR(cdr_405_2_965);
					  if (
					     PAIRP(cdr_1401_24_986))
					    {	/* Ast/find-gdefs.scm 211 */
					       bool_t aux_2501;
					       aux_2501 =
						  find_mutations__75_ast_find_gdefs_13(
						  CDR(cdr_1401_24_986), stack_23);
					       return
						  BBOOL(aux_2501);
					    }
					  else
					    {	/* Ast/find-gdefs.scm 201 */
					       goto tag_373_251_962;
					    }
				       }
				     else
				       {	/* Ast/find-gdefs.scm 201 */
					  goto tag_373_251_962;
				       }
				  }
				else
				  {	/* Ast/find-gdefs.scm 201 */
				     bool_t test_2505;
				     {	/* ./Ieee/equiv.scm 5508 */
					obj_t aux_2508;
					obj_t aux_2506;
					aux_2508 =
					   CNST_TABLE_REF(((long) 3));
					aux_2506 =
					   CAR(exp_22);
					test_2505 =
					   (aux_2506 == aux_2508);
				     }
				     if (test_2505)
				       {	/* Ast/find-gdefs.scm 213 */
					  bool_t aux_2511;
					  aux_2511 =
					     find_mutations__75_ast_find_gdefs_13(cdr_405_2_965, stack_23);
					  return
					     BBOOL(aux_2511);
				       }
				     else
				       {	/* Ast/find-gdefs.scm 201 */
					  bool_t test_2514;
					  {	/* ./Ieee/equiv.scm 5508 */
					     obj_t aux_2517;
					     obj_t aux_2515;
					     aux_2517 =
						CNST_TABLE_REF(((long) 17));
					     aux_2515 =
						CAR(exp_22);
					     test_2514 =
						(aux_2515 == aux_2517);
					  }
					  if (test_2514)
					    {	/* Ast/find-gdefs.scm 201 */
					       if (
						  PAIRP(cdr_405_2_965))
						 {	/* Ast/find-gdefs.scm 201 */
						    obj_t car_1702_59_995;
						    car_1702_59_995 =
						       CAR(cdr_405_2_965);
						    if (
						       SYMBOLP(car_1702_59_995))
						      {		/* Ast/find-gdefs.scm 201 */
							 id_920 = car_1702_59_995;
							 val_921 =
							    CDR(cdr_405_2_965);
							 find_mutations__75_ast_find_gdefs_13(val_921, stack_23);
							 {	/* Ast/find-gdefs.scm 216 */
							    bool_t test_2526;
							    {	/* Ast/find-gdefs.scm 216 */
							       obj_t aux_2527;
							       aux_2527 =
								  memq___r4_pairs_and_lists_6_3(id_920, stack_23);
							       test_2526 =
								  CBOOL(aux_2527);
							    }
							    if (test_2526)
							      {		/* Ast/find-gdefs.scm 216 */
								 return BUNSPEC;
							      }
							    else
							      {		/* Ast/find-gdefs.scm 217 */
								 obj_t def_1122;
								 def_1122 =
								    getprop___r4_symbols_6_4(id_920, _gdef_key__233_ast_find_gdefs_13);
								 {	/* Ast/find-gdefs.scm 218 */
								    bool_t test_2531;
								    if (
								       STRUCTP(def_1122))
								      {		/* ./Ieee/equiv.scm 5508 */
									 obj_t aux_2536;
									 obj_t aux_2534;
									 aux_2536 =
									    CNST_TABLE_REF(((long) 1));
									 aux_2534 =
									    STRUCT_KEY(def_1122);
									 test_2531 =
									    (aux_2534 == aux_2536);
								      }
								    else
								      {		/* Ast/find-gdefs.scm 43 */
									 test_2531 = ((bool_t) 0)
									    ;
								      }
								    if (test_2531)
								      {		/* ./Llib/struct.scm 1463 */
									 obj_t x_2154;
									 {	/* ./Llib/struct.scm 1463 */
									    obj_t aux_2539;
									    aux_2539 =
									       CNST_TABLE_REF(((long) 11));
									    x_2154 =
									       STRUCT_SET(def_1122, ((long) 1), aux_2539);
									 }
									 return BUNSPEC;
								      }
								    else
								      {		/* Ast/find-gdefs.scm 218 */
									 return BUNSPEC;
								      }
								 }
							      }
							 }
						      }
						    else
						      {		/* Ast/find-gdefs.scm 201 */
							 obj_t car_1727_124_999;
							 car_1727_124_999 =
							    CAR(cdr_405_2_965);
							 if (
							    PAIRP(car_1727_124_999))
							   {	/* Ast/find-gdefs.scm 201 */
							      obj_t cdr_1732_77_1001;
							      cdr_1732_77_1001 =
								 CDR(car_1727_124_999);
							      {		/* Ast/find-gdefs.scm 201 */
								 bool_t test_2547;
								 {	/* ./Ieee/equiv.scm 5508 */
								    obj_t aux_2550;
								    obj_t aux_2548;
								    aux_2550 =
								       CNST_TABLE_REF(((long) 10));
								    aux_2548 =
								       CAR(car_1727_124_999);
								    test_2547 =
								       (aux_2548 == aux_2550);
								 }
								 if (test_2547)
								   {	/* Ast/find-gdefs.scm 201 */
								      if (
									 PAIRP(cdr_1732_77_1001))
									{	/* Ast/find-gdefs.scm 201 */
									   obj_t car_1735_46_1004;
									   obj_t cdr_1736_130_1005;
									   car_1735_46_1004 =
									      CAR(cdr_1732_77_1001);
									   cdr_1736_130_1005 =
									      CDR(cdr_1732_77_1001);
									   if (
									      SYMBOLP(car_1735_46_1004))
									     {	/* Ast/find-gdefs.scm 201 */
										if (
										   PAIRP(cdr_1736_130_1005))
										  {	/* Ast/find-gdefs.scm 201 */
										     obj_t car_1741_47_1008;
										     car_1741_47_1008 =
											CAR(cdr_1736_130_1005);
										     if (
											SYMBOLP(car_1741_47_1008))
										       {	/* Ast/find-gdefs.scm 201 */
											  bool_t test_2564;
											  {	/* ./Ieee/equiv.scm 5508 */
											     obj_t aux_2565;
											     aux_2565 =
												CDR(cdr_1736_130_1005);
											     test_2564 =
												(aux_2565 == BNIL);
											  }
											  if (test_2564)
											    {	/* Ast/find-gdefs.scm 201 */
											       id_923 = car_1735_46_1004;
											       module_924 = car_1741_47_1008;
											       val_925 =
												  CDR(cdr_405_2_965);
											       find_mutations__75_ast_find_gdefs_13(val_925, stack_23);
											       {	/* Ast/find-gdefs.scm 222 */
												  bool_t test1709_1124;
												  {	/* Ast/find-gdefs.scm 222 */
												     obj_t obj2_1999;
												     obj2_1999 = _module__166_module_module;
												     test1709_1124 =
													(module_924 == obj2_1999);
												  }
												  if (test1709_1124)
												    {	/* Ast/find-gdefs.scm 223 */
												       obj_t def_1125;
												       def_1125 =
													  getprop___r4_symbols_6_4(id_923, _gdef_key__233_ast_find_gdefs_13);
												       {	/* Ast/find-gdefs.scm 224 */
													  bool_t test_2572;
													  if (
													     STRUCTP(def_1125))
													    {	/* ./Ieee/equiv.scm 5508 */
													       obj_t aux_2577;
													       obj_t aux_2575;
													       aux_2577 =
														  CNST_TABLE_REF(((long) 1));
													       aux_2575 =
														  STRUCT_KEY(def_1125);
													       test_2572 =
														  (aux_2575 == aux_2577);
													    }
													  else
													    {	/* Ast/find-gdefs.scm 43 */
													       test_2572 = ((bool_t) 0)
														  ;
													    }
													  if (test_2572)
													    {	/* ./Llib/struct.scm 1463 */
													       obj_t x_2155;
													       {	/* ./Llib/struct.scm 1463 */
														  obj_t aux_2580;
														  aux_2580 =
														     CNST_TABLE_REF(((long) 11));
														  x_2155 =
														     STRUCT_SET(def_1125, ((long) 1), aux_2580);
													       }
													       return BUNSPEC;
													    }
													  else
													    {	/* Ast/find-gdefs.scm 224 */
													       return BUNSPEC;
													    }
												       }
												    }
												  else
												    {	/* Ast/find-gdefs.scm 222 */
												       return BUNSPEC;
												    }
											       }
											    }
											  else
											    {	/* Ast/find-gdefs.scm 201 */
											       goto tag_373_251_962;
											    }
										       }
										     else
										       {	/* Ast/find-gdefs.scm 201 */
											  goto tag_373_251_962;
										       }
										  }
										else
										  {	/* Ast/find-gdefs.scm 201 */
										     goto tag_373_251_962;
										  }
									     }
									   else
									     {	/* Ast/find-gdefs.scm 201 */
										goto tag_373_251_962;
									     }
									}
								      else
									{	/* Ast/find-gdefs.scm 201 */
									   goto tag_373_251_962;
									}
								   }
								 else
								   {	/* Ast/find-gdefs.scm 201 */
								      goto tag_373_251_962;
								   }
							      }
							   }
							 else
							   {	/* Ast/find-gdefs.scm 201 */
							      goto tag_373_251_962;
							   }
						      }
						 }
					       else
						 {	/* Ast/find-gdefs.scm 201 */
						    goto tag_373_251_962;
						 }
					    }
					  else
					    {	/* Ast/find-gdefs.scm 201 */
					       bool_t test_2584;
					       {	/* ./Ieee/equiv.scm 5508 */
						  obj_t aux_2587;
						  obj_t aux_2585;
						  aux_2587 =
						     CNST_TABLE_REF(((long) 18));
						  aux_2585 =
						     CAR(exp_22);
						  test_2584 =
						     (aux_2585 == aux_2587);
					       }
					       if (test_2584)
						 {	/* Ast/find-gdefs.scm 201 */
						    if (
						       PAIRP(cdr_405_2_965))
						      {		/* Ast/find-gdefs.scm 201 */
							 bool_t aux_2592;
							 bindings_927 =
							    CAR(cdr_405_2_965);
							 body_928 =
							    CDR(cdr_405_2_965);
							 {	/* Ast/find-gdefs.scm 227 */
							    obj_t new_stack_37_1127;
							    {
							       obj_t stack_1134;
							       obj_t bindings_1135;
							       stack_1134 = stack_23;
							       bindings_1135 = bindings_927;
							     loop_1136:
							       if (
								  NULLP(bindings_1135))
								 {	/* Ast/find-gdefs.scm 230 */
								    new_stack_37_1127 = stack_1134;
								 }
							       else
								 {	/* Ast/find-gdefs.scm 232 */
								    bool_t test_2595;
								    {	/* ./Ieee/pair-list.scm 5669 */
								       obj_t aux_2596;
								       aux_2596 =
									  CAR(bindings_1135);
								       test_2595 =
									  PAIRP(aux_2596);
								    }
								    if (test_2595)
								      {		/* Ast/find-gdefs.scm 232 */
									 {	/* Ast/find-gdefs.scm 238 */
									    obj_t arg1716_1139;
									    obj_t arg1717_1140;
									    {	/* Ast/find-gdefs.scm 238 */
									       obj_t arg1718_1141;
									       {	/* Ast/find-gdefs.scm 238 */
										  obj_t arg1719_1142;
										  obj_t arg1720_1143;
										  {	/* ./Ieee/pair-list.scm 5701 */
										     obj_t aux_2599;
										     aux_2599 =
											CAR(bindings_1135);
										     arg1719_1142 =
											CAR(aux_2599);
										  }
										  arg1720_1143 =
										     find_location_120_tools_location(exp_22);
										  arg1718_1141 =
										     id_of_id_112_ast_ident(arg1719_1142, arg1720_1143);
									       }
									       arg1716_1139 =
										  MAKE_PAIR(arg1718_1141, stack_1134);
									    }
									    arg1717_1140 =
									       CDR(bindings_1135);
									    {
									       obj_t bindings_2607;
									       obj_t stack_2606;
									       stack_2606 = arg1716_1139;
									       bindings_2607 = arg1717_1140;
									       bindings_1135 = bindings_2607;
									       stack_1134 = stack_2606;
									       goto loop_1136;
									    }
									 }
								      }
								    else
								      {		/* Ast/find-gdefs.scm 232 */
									 {	/* Ast/find-gdefs.scm 233 */
									    obj_t arg1722_1145;
									    obj_t arg1723_1146;
									    {	/* Ast/find-gdefs.scm 233 */
									       obj_t arg1724_1147;
									       {	/* Ast/find-gdefs.scm 233 */
										  obj_t arg1725_1148;
										  obj_t arg1726_1149;
										  arg1725_1148 =
										     CAR(bindings_1135);
										  arg1726_1149 =
										     find_location_120_tools_location(exp_22);
										  arg1724_1147 =
										     id_of_id_112_ast_ident(arg1725_1148, arg1726_1149);
									       }
									       arg1722_1145 =
										  MAKE_PAIR(arg1724_1147, stack_1134);
									    }
									    arg1723_1146 =
									       CDR(bindings_1135);
									    {
									       obj_t bindings_2614;
									       obj_t stack_2613;
									       stack_2613 = arg1722_1145;
									       bindings_2614 = arg1723_1146;
									       bindings_1135 = bindings_2614;
									       stack_1134 = stack_2613;
									       goto loop_1136;
									    }
									 }
								      }
								 }
							    }
							    find_mutations__75_ast_find_gdefs_13(body_928, new_stack_37_1127);
							    {
							       obj_t l1451_1128;
							       l1451_1128 = bindings_927;
							     lname1452_1129:
							       if (
								  PAIRP(l1451_1128))
								 {	/* Ast/find-gdefs.scm 243 */
								    {	/* Ast/find-gdefs.scm 243 */
								       obj_t aux_2618;
								       {	/* ./Ieee/pair-list.scm 5707 */
									  obj_t aux_2619;
									  aux_2619 =
									     CAR(l1451_1128);
									  aux_2618 =
									     CDR(aux_2619);
								       }
								       find_mutations__75_ast_find_gdefs_13(aux_2618, stack_23);
								    }
								    {
								       obj_t l1451_2623;
								       l1451_2623 =
									  CDR(l1451_1128);
								       l1451_1128 = l1451_2623;
								       goto lname1452_1129;
								    }
								 }
							       else
								 {	/* Ast/find-gdefs.scm 243 */
								    aux_2592 = ((bool_t) 1);
								 }
							    }
							 }
							 return
							    BBOOL(aux_2592);
						      }
						    else
						      {		/* Ast/find-gdefs.scm 201 */
							 goto tag_373_251_962;
						      }
						 }
					       else
						 {	/* Ast/find-gdefs.scm 201 */
						    bool_t test_2628;
						    {	/* ./Ieee/equiv.scm 5508 */
						       obj_t aux_2631;
						       obj_t aux_2629;
						       aux_2631 =
							  CNST_TABLE_REF(((long) 19));
						       aux_2629 =
							  CAR(exp_22);
						       test_2628 =
							  (aux_2629 == aux_2631);
						    }
						    if (test_2628)
						      {		/* Ast/find-gdefs.scm 201 */
							 if (
							    PAIRP(cdr_405_2_965))
							   {	/* Ast/find-gdefs.scm 201 */
							      bool_t aux_2636;
							      bindings_930 =
								 CAR(cdr_405_2_965);
							      body_931 =
								 CDR(cdr_405_2_965);
							      {		/* Ast/find-gdefs.scm 245 */
								 obj_t new_stack_37_1151;
								 {
								    obj_t stack_1158;
								    obj_t bindings_1159;
								    stack_1158 = stack_23;
								    bindings_1159 = bindings_930;
								  loop_1160:
								    if (
								       NULLP(bindings_1159))
								      {		/* Ast/find-gdefs.scm 248 */
									 new_stack_37_1151 = stack_1158;
								      }
								    else
								      {		/* Ast/find-gdefs.scm 250 */
									 bool_t test_2639;
									 {	/* ./Ieee/pair-list.scm 5669 */
									    obj_t aux_2640;
									    aux_2640 =
									       CAR(bindings_1159);
									    test_2639 =
									       PAIRP(aux_2640);
									 }
									 if (test_2639)
									   {	/* Ast/find-gdefs.scm 250 */
									      {		/* Ast/find-gdefs.scm 256 */
										 obj_t arg1733_1163;
										 obj_t arg1734_1164;
										 {	/* Ast/find-gdefs.scm 256 */
										    obj_t arg1735_1165;
										    {	/* Ast/find-gdefs.scm 256 */
										       obj_t arg1736_1166;
										       obj_t arg1738_1167;
										       {	/* ./Ieee/pair-list.scm 5701 */
											  obj_t aux_2643;
											  aux_2643 =
											     CAR(bindings_1159);
											  arg1736_1166 =
											     CAR(aux_2643);
										       }
										       arg1738_1167 =
											  find_location_120_tools_location(exp_22);
										       arg1735_1165 =
											  id_of_id_112_ast_ident(arg1736_1166, arg1738_1167);
										    }
										    arg1733_1163 =
										       MAKE_PAIR(arg1735_1165, stack_1158);
										 }
										 arg1734_1164 =
										    CDR(bindings_1159);
										 {
										    obj_t bindings_2651;
										    obj_t stack_2650;
										    stack_2650 = arg1733_1163;
										    bindings_2651 = arg1734_1164;
										    bindings_1159 = bindings_2651;
										    stack_1158 = stack_2650;
										    goto loop_1160;
										 }
									      }
									   }
									 else
									   {	/* Ast/find-gdefs.scm 250 */
									      {		/* Ast/find-gdefs.scm 251 */
										 obj_t arg1740_1169;
										 obj_t arg1741_1170;
										 {	/* Ast/find-gdefs.scm 251 */
										    obj_t arg1742_1171;
										    {	/* Ast/find-gdefs.scm 251 */
										       obj_t arg1743_1172;
										       obj_t arg1744_1173;
										       arg1743_1172 =
											  CAR(bindings_1159);
										       arg1744_1173 =
											  find_location_120_tools_location(exp_22);
										       arg1742_1171 =
											  id_of_id_112_ast_ident(arg1743_1172, arg1744_1173);
										    }
										    arg1740_1169 =
										       MAKE_PAIR(arg1742_1171, stack_1158);
										 }
										 arg1741_1170 =
										    CDR(bindings_1159);
										 {
										    obj_t bindings_2658;
										    obj_t stack_2657;
										    stack_2657 = arg1740_1169;
										    bindings_2658 = arg1741_1170;
										    bindings_1159 = bindings_2658;
										    stack_1158 = stack_2657;
										    goto loop_1160;
										 }
									      }
									   }
								      }
								 }
								 find_mutations__75_ast_find_gdefs_13(body_931, new_stack_37_1151);
								 {
								    obj_t l1453_1152;
								    l1453_1152 = bindings_930;
								  lname1454_1153:
								    if (
								       PAIRP(l1453_1152))
								      {		/* Ast/find-gdefs.scm 261 */
									 {	/* Ast/find-gdefs.scm 261 */
									    obj_t aux_2662;
									    {	/* ./Ieee/pair-list.scm 5707 */
									       obj_t aux_2663;
									       aux_2663 =
										  CAR(l1453_1152);
									       aux_2662 =
										  CDR(aux_2663);
									    }
									    find_mutations__75_ast_find_gdefs_13(aux_2662, new_stack_37_1151);
									 }
									 {
									    obj_t l1453_2667;
									    l1453_2667 =
									       CDR(l1453_1152);
									    l1453_1152 = l1453_2667;
									    goto lname1454_1153;
									 }
								      }
								    else
								      {		/* Ast/find-gdefs.scm 261 */
									 aux_2636 = ((bool_t) 1);
								      }
								 }
							      }
							      return
								 BBOOL(aux_2636);
							   }
							 else
							   {	/* Ast/find-gdefs.scm 201 */
							      goto tag_373_251_962;
							   }
						      }
						    else
						      {		/* Ast/find-gdefs.scm 201 */
							 bool_t test_2672;
							 {	/* ./Ieee/equiv.scm 5508 */
							    obj_t aux_2675;
							    obj_t aux_2673;
							    aux_2675 =
							       CNST_TABLE_REF(((long) 20));
							    aux_2673 =
							       CAR(exp_22);
							    test_2672 =
							       (aux_2673 == aux_2675);
							 }
							 if (test_2672)
							   {	/* Ast/find-gdefs.scm 201 */
							      if (
								 PAIRP(cdr_405_2_965))
								{	/* Ast/find-gdefs.scm 201 */
								   bool_t aux_2680;
								   bindings_933 =
								      CAR(cdr_405_2_965);
								   body_934 =
								      CDR(cdr_405_2_965);
								   {	/* Ast/find-gdefs.scm 264 */
								      obj_t loc_1175;
								      loc_1175 =
									 find_location_120_tools_location(exp_22);
								      {		/* Ast/find-gdefs.scm 264 */
									 obj_t new_stack_37_1176;
									 {	/* Ast/find-gdefs.scm 265 */
									    obj_t arg1751_1185;
									    if (
									       NULLP(bindings_933))
									      {		/* Ast/find-gdefs.scm 265 */
										 arg1751_1185 = BNIL;
									      }
									    else
									      {		/* Ast/find-gdefs.scm 265 */
										 obj_t head1457_1188;
										 {	/* ./Ieee/pair-list.scm 5689 */
										    obj_t aux_2684;
										    {	/* ./Ieee/pair-list.scm 5701 */
										       obj_t aux_2685;
										       aux_2685 =
											  CAR(bindings_933);
										       aux_2684 =
											  CAR(aux_2685);
										    }
										    head1457_1188 =
										       MAKE_PAIR(aux_2684, BNIL);
										 }
										 {
										    obj_t l1455_1189;
										    obj_t tail1458_1190;
										    l1455_1189 =
										       CDR(bindings_933);
										    tail1458_1190 = head1457_1188;
										  lname1456_1191:
										    if (
										       NULLP(l1455_1189))
										      {		/* Ast/find-gdefs.scm 265 */
											 arg1751_1185 = head1457_1188;
										      }
										    else
										      {		/* Ast/find-gdefs.scm 265 */
											 obj_t newtail1459_1194;
											 {	/* ./Ieee/pair-list.scm 5689 */
											    obj_t aux_2691;
											    {	/* ./Ieee/pair-list.scm 5701 */
											       obj_t aux_2692;
											       aux_2692 =
												  CAR(l1455_1189);
											       aux_2691 =
												  CAR(aux_2692);
											    }
											    newtail1459_1194 =
											       MAKE_PAIR(aux_2691, BNIL);
											 }
											 SET_CDR(tail1458_1190, newtail1459_1194);
											 {
											    obj_t tail1458_2699;
											    obj_t l1455_2697;
											    l1455_2697 =
											       CDR(l1455_1189);
											    tail1458_2699 = newtail1459_1194;
											    tail1458_1190 = tail1458_2699;
											    l1455_1189 = l1455_2697;
											    goto lname1456_1191;
											 }
										      }
										 }
									      }
									    new_stack_37_1176 =
									       push_args_50_ast_find_gdefs_13(arg1751_1185, stack_23, loc_1175);
									 }
									 {	/* Ast/find-gdefs.scm 265 */

									    find_mutations__75_ast_find_gdefs_13(body_934, new_stack_37_1176);
									    {
									       obj_t l1460_1177;
									       l1460_1177 = bindings_933;
									     lname1461_1178:
									       if (
										  PAIRP(l1460_1177))
										 {	/* Ast/find-gdefs.scm 267 */
										    {	/* Ast/find-gdefs.scm 268 */
										       obj_t b_1180;
										       b_1180 =
											  CAR(l1460_1177);
										       {	/* Ast/find-gdefs.scm 268 */
											  obj_t arg1747_1181;
											  obj_t arg1748_1182;
											  {	/* ./Ieee/pair-list.scm 5707 */
											     obj_t aux_2706;
											     aux_2706 =
												CDR(b_1180);
											     arg1747_1181 =
												CDR(aux_2706);
											  }
											  {	/* Ast/find-gdefs.scm 269 */
											     obj_t aux_2709;
											     {	/* ./Ieee/pair-list.scm 5701 */
												obj_t aux_2710;
												aux_2710 =
												   CDR(b_1180);
												aux_2709 =
												   CAR(aux_2710);
											     }
											     arg1748_1182 =
												push_args_50_ast_find_gdefs_13(aux_2709, new_stack_37_1176, loc_1175);
											  }
											  find_mutations__75_ast_find_gdefs_13(arg1747_1181, arg1748_1182);
										       }
										    }
										    {
										       obj_t l1460_2715;
										       l1460_2715 =
											  CDR(l1460_1177);
										       l1460_1177 = l1460_2715;
										       goto lname1461_1178;
										    }
										 }
									       else
										 {	/* Ast/find-gdefs.scm 267 */
										    aux_2680 = ((bool_t) 1);
										 }
									    }
									 }
								      }
								   }
								   return
								      BBOOL(aux_2680);
								}
							      else
								{	/* Ast/find-gdefs.scm 201 */
								   goto tag_373_251_962;
								}
							   }
							 else
							   {	/* Ast/find-gdefs.scm 201 */
							      bool_t test_2720;
							      {		/* ./Ieee/equiv.scm 5508 */
								 obj_t aux_2723;
								 obj_t aux_2721;
								 aux_2723 =
								    CNST_TABLE_REF(((long) 14));
								 aux_2721 =
								    CAR(exp_22);
								 test_2720 =
								    (aux_2721 == aux_2723);
							      }
							      if (test_2720)
								{	/* Ast/find-gdefs.scm 201 */
								   if (
								      PAIRP(cdr_405_2_965))
								     {	/* Ast/find-gdefs.scm 201 */
									obj_t arg1630_1034;
									obj_t arg1631_1035;
									arg1630_1034 =
									   CAR(cdr_405_2_965);
									arg1631_1035 =
									   CDR(cdr_405_2_965);
									{	/* Ast/find-gdefs.scm 272 */
									   obj_t arg1763_1891;
									   {	/* Ast/find-gdefs.scm 272 */
									      obj_t arg1764_1892;
									      arg1764_1892 =
										 find_location_120_tools_location(exp_22);
									      arg1763_1891 =
										 push_args_50_ast_find_gdefs_13(arg1630_1034, stack_23, arg1764_1892);
									   }
									   {	/* Ast/find-gdefs.scm 272 */
									      bool_t aux_2732;
									      aux_2732 =
										 find_mutations__75_ast_find_gdefs_13(arg1631_1035, arg1763_1891);
									      return
										 BBOOL(aux_2732);
									   }
									}
								     }
								   else
								     {	/* Ast/find-gdefs.scm 201 */
									goto tag_373_251_962;
								     }
								}
							      else
								{	/* Ast/find-gdefs.scm 201 */
								   bool_t test_2735;
								   {	/* ./Ieee/equiv.scm 5508 */
								      obj_t aux_2738;
								      obj_t aux_2736;
								      aux_2738 =
									 CNST_TABLE_REF(((long) 21));
								      aux_2736 =
									 CAR(exp_22);
								      test_2735 =
									 (aux_2736 == aux_2738);
								   }
								   if (test_2735)
								     {	/* Ast/find-gdefs.scm 201 */
									if (
									   PAIRP(cdr_405_2_965))
									  {	/* Ast/find-gdefs.scm 201 */
									     obj_t arg1634_1039;
									     obj_t arg1635_1040;
									     arg1634_1039 =
										CAR(cdr_405_2_965);
									     arg1635_1040 =
										CDR(cdr_405_2_965);
									     {	/* Ast/find-gdefs.scm 274 */
										obj_t arg1765_1902;
										{	/* Ast/find-gdefs.scm 274 */
										   obj_t arg1766_1903;
										   {	/* Ast/find-gdefs.scm 274 */
										      obj_t arg1767_1904;
										      arg1767_1904 =
											 find_location_120_tools_location(exp_22);
										      arg1766_1903 =
											 id_of_id_112_ast_ident(arg1634_1039, arg1767_1904);
										   }
										   arg1765_1902 =
										      MAKE_PAIR(arg1766_1903, stack_23);
										}
										{	/* Ast/find-gdefs.scm 274 */
										   bool_t aux_2748;
										   aux_2748 =
										      find_mutations__75_ast_find_gdefs_13(arg1635_1040, arg1765_1902);
										   return
										      BBOOL(aux_2748);
										}
									     }
									  }
									else
									  {	/* Ast/find-gdefs.scm 201 */
									     goto tag_373_251_962;
									  }
								     }
								   else
								     {	/* Ast/find-gdefs.scm 201 */
									bool_t test_2751;
									{	/* ./Ieee/equiv.scm 5508 */
									   obj_t aux_2754;
									   obj_t aux_2752;
									   aux_2754 =
									      CNST_TABLE_REF(((long) 22));
									   aux_2752 =
									      CAR(exp_22);
									   test_2751 =
									      (aux_2752 == aux_2754);
									}
									if (test_2751)
									  {	/* Ast/find-gdefs.scm 201 */
									     if (
										PAIRP(cdr_405_2_965))
									       {	/* Ast/find-gdefs.scm 201 */
										  obj_t cdr_2916_147_1044;
										  cdr_2916_147_1044 =
										     CDR(cdr_405_2_965);
										  if (
										     PAIRP(cdr_2916_147_1044))
										    {	/* Ast/find-gdefs.scm 201 */
										       bool_t test_2762;
										       {	/* ./Ieee/equiv.scm 5508 */
											  obj_t aux_2763;
											  aux_2763 =
											     CDR(cdr_2916_147_1044);
											  test_2762 =
											     (aux_2763 == BNIL);
										       }
										       if (test_2762)
											 {	/* Ast/find-gdefs.scm 201 */
											    obj_t arg1641_1048;
											    arg1641_1048 =
											       CAR(cdr_2916_147_1044);
											    find_1_mutations__59_ast_find_gdefs_13(
											       CAR(cdr_405_2_965), stack_23);
											    {
											       obj_t exp_2769;
											       exp_2769 = arg1641_1048;
											       exp_22 = exp_2769;
											       goto find_1_mutations__59_ast_find_gdefs_13;
											    }
											 }
										       else
											 {	/* Ast/find-gdefs.scm 201 */
											    goto tag_373_251_962;
											 }
										    }
										  else
										    {	/* Ast/find-gdefs.scm 201 */
										       goto tag_373_251_962;
										    }
									       }
									     else
									       {	/* Ast/find-gdefs.scm 201 */
										  goto tag_373_251_962;
									       }
									  }
									else
									  {	/* Ast/find-gdefs.scm 201 */
									     bool_t test_2770;
									     {	/* ./Ieee/equiv.scm 5508 */
										obj_t aux_2773;
										obj_t aux_2771;
										aux_2773 =
										   CNST_TABLE_REF(((long) 23));
										aux_2771 =
										   CAR(exp_22);
										test_2770 =
										   (aux_2771 == aux_2773);
									     }
									     if (test_2770)
									       {	/* Ast/find-gdefs.scm 201 */
										  if (
										     PAIRP(cdr_405_2_965))
										    {	/* Ast/find-gdefs.scm 201 */
										       obj_t cdr_3024_193_1054;
										       cdr_3024_193_1054 =
											  CDR(cdr_405_2_965);
										       if (
											  PAIRP(cdr_3024_193_1054))
											 {	/* Ast/find-gdefs.scm 201 */
											    bool_t test_2781;
											    {	/* ./Ieee/equiv.scm 5508 */
											       obj_t aux_2782;
											       aux_2782 =
												  CDR(cdr_3024_193_1054);
											       test_2781 =
												  (aux_2782 == BNIL);
											    }
											    if (test_2781)
											      {		/* Ast/find-gdefs.scm 201 */
												 bool_t aux_2785;
												 val_945 =
												    CAR(cdr_405_2_965);
												 clauses_946 =
												    CAR(cdr_3024_193_1054);
												 find_mutations__75_ast_find_gdefs_13(val_945, stack_23);
												 {
												    obj_t l1462_1207;
												    l1462_1207 = clauses_946;
												  lname1463_1208:
												    if (
												       PAIRP(l1462_1207))
												      {		/* Ast/find-gdefs.scm 280 */
													 {	/* Ast/find-gdefs.scm 280 */
													    obj_t aux_2789;
													    {	/* ./Ieee/pair-list.scm 5707 */
													       obj_t aux_2790;
													       aux_2790 =
														  CAR(l1462_1207);
													       aux_2789 =
														  CDR(aux_2790);
													    }
													    find_mutations__75_ast_find_gdefs_13(aux_2789, stack_23);
													 }
													 {
													    obj_t l1462_2794;
													    l1462_2794 =
													       CDR(l1462_1207);
													    l1462_1207 = l1462_2794;
													    goto lname1463_1208;
													 }
												      }
												    else
												      {		/* Ast/find-gdefs.scm 280 */
													 aux_2785 = ((bool_t) 1);
												      }
												 }
												 return
												    BBOOL(aux_2785);
											      }
											    else
											      {		/* Ast/find-gdefs.scm 201 */
												 goto tag_373_251_962;
											      }
											 }
										       else
											 {	/* Ast/find-gdefs.scm 201 */
											    goto tag_373_251_962;
											 }
										    }
										  else
										    {	/* Ast/find-gdefs.scm 201 */
										       goto tag_373_251_962;
										    }
									       }
									     else
									       {	/* Ast/find-gdefs.scm 201 */
										  bool_t test_2799;
										  {	/* ./Ieee/equiv.scm 5508 */
										     obj_t aux_2802;
										     obj_t aux_2800;
										     aux_2802 =
											CNST_TABLE_REF(((long) 24));
										     aux_2800 =
											CAR(exp_22);
										     test_2799 =
											(aux_2800 == aux_2802);
										  }
										  if (test_2799)
										    {	/* Ast/find-gdefs.scm 282 */
										       bool_t aux_2805;
										       aux_2805 =
											  find_mutations__75_ast_find_gdefs_13(cdr_405_2_965, stack_23);
										       return
											  BBOOL(aux_2805);
										    }
										  else
										    {	/* Ast/find-gdefs.scm 201 */
										       bool_t test_2808;
										       {	/* ./Ieee/equiv.scm 5508 */
											  obj_t aux_2811;
											  obj_t aux_2809;
											  aux_2811 =
											     CNST_TABLE_REF(((long) 4));
											  aux_2809 =
											     CAR(exp_22);
											  test_2808 =
											     (aux_2809 == aux_2811);
										       }
										       if (test_2808)
											 {	/* Ast/find-gdefs.scm 201 */
											    if (
											       PAIRP(cdr_405_2_965))
											      {		/* Ast/find-gdefs.scm 201 */
												 obj_t arg1657_1067;
												 arg1657_1067 =
												    CDR(cdr_405_2_965);
												 {	/* Ast/find-gdefs.scm 284 */
												    obj_t arg1771_1947;
												    {	/* ./Ieee/pair-list.scm 5689 */
												       obj_t aux_2817;
												       aux_2817 =
													  CAR(cdr_405_2_965);
												       arg1771_1947 =
													  MAKE_PAIR(aux_2817, stack_23);
												    }
												    {	/* Ast/find-gdefs.scm 284 */
												       bool_t aux_2820;
												       aux_2820 =
													  find_mutations__75_ast_find_gdefs_13(arg1657_1067, arg1771_1947);
												       return
													  BBOOL(aux_2820);
												    }
												 }
											      }
											    else
											      {		/* Ast/find-gdefs.scm 201 */
												 goto tag_373_251_962;
											      }
											 }
										       else
											 {	/* Ast/find-gdefs.scm 201 */
											    bool_t test_2823;
											    {	/* ./Ieee/equiv.scm 5508 */
											       obj_t aux_2826;
											       obj_t aux_2824;
											       aux_2826 =
												  CNST_TABLE_REF(((long) 5));
											       aux_2824 =
												  CAR(exp_22);
											       test_2823 =
												  (aux_2824 == aux_2826);
											    }
											    if (test_2823)
											      {		/* Ast/find-gdefs.scm 201 */
												 if (
												    PAIRP(cdr_405_2_965))
												   {	/* Ast/find-gdefs.scm 201 */
												      obj_t arg1660_1071;
												      obj_t arg1661_1072;
												      arg1660_1071 =
													 CAR(cdr_405_2_965);
												      arg1661_1072 =
													 CDR(cdr_405_2_965);
												      {		/* Ast/find-gdefs.scm 286 */
													 obj_t list1772_1959;
													 list1772_1959 =
													    MAKE_PAIR(BNIL, BNIL);
													 return
													    user_error_151_tools_error(arg1660_1071, string1898_ast_find_gdefs_13, arg1661_1072, list1772_1959);
												      }
												   }
												 else
												   {	/* Ast/find-gdefs.scm 201 */
												      goto tag_373_251_962;
												   }
											      }
											    else
											      {		/* Ast/find-gdefs.scm 201 */
												 bool_t test_2835;
												 {	/* ./Ieee/equiv.scm 5508 */
												    obj_t aux_2838;
												    obj_t aux_2836;
												    aux_2838 =
												       CNST_TABLE_REF(((long) 6));
												    aux_2836 =
												       CAR(exp_22);
												    test_2835 =
												       (aux_2836 == aux_2838);
												 }
												 if (test_2835)
												   {	/* Ast/find-gdefs.scm 201 */
												      if (
													 PAIRP(cdr_405_2_965))
													{	/* Ast/find-gdefs.scm 201 */
													   obj_t arg1664_1076;
													   obj_t arg1665_1077;
													   arg1664_1076 =
													      CAR(cdr_405_2_965);
													   arg1665_1077 =
													      CDR(cdr_405_2_965);
													   {	/* Ast/find-gdefs.scm 288 */
													      obj_t list1773_1969;
													      list1773_1969 =
														 MAKE_PAIR(BNIL, BNIL);
													      return
														 user_error_151_tools_error(arg1664_1076, string1899_ast_find_gdefs_13, arg1665_1077, list1773_1969);
													   }
													}
												      else
													{	/* Ast/find-gdefs.scm 201 */
													   goto tag_373_251_962;
													}
												   }
												 else
												   {	/* Ast/find-gdefs.scm 201 */
												      bool_t test_2847;
												      {		/* ./Ieee/equiv.scm 5508 */
													 obj_t aux_2850;
													 obj_t aux_2848;
													 aux_2850 =
													    CNST_TABLE_REF(((long) 7));
													 aux_2848 =
													    CAR(exp_22);
													 test_2847 =
													    (aux_2848 == aux_2850);
												      }
												      if (test_2847)
													{	/* Ast/find-gdefs.scm 201 */
													   if (
													      PAIRP(cdr_405_2_965))
													     {	/* Ast/find-gdefs.scm 201 */
														obj_t car_3180_38_1081;
														car_3180_38_1081 =
														   CAR(cdr_405_2_965);
														if (
														   PAIRP(car_3180_38_1081))
														  {	/* Ast/find-gdefs.scm 201 */
														     obj_t arg1669_1083;
														     obj_t arg1670_1084;
														     arg1669_1083 =
															CDR(car_3180_38_1081);
														     arg1670_1084 =
															CDR(cdr_405_2_965);
														     {	/* Ast/find-gdefs.scm 290 */
															obj_t arg1774_1981;
															{	/* Ast/find-gdefs.scm 290 */
															   obj_t arg1775_1982;
															   arg1775_1982 =
															      find_location_120_tools_location(exp_22);
															   arg1774_1981 =
															      push_args_50_ast_find_gdefs_13(arg1669_1083, stack_23, arg1775_1982);
															}
															{	/* Ast/find-gdefs.scm 290 */
															   bool_t aux_2862;
															   aux_2862 =
															      find_mutations__75_ast_find_gdefs_13(arg1670_1084, arg1774_1981);
															   return
															      BBOOL(aux_2862);
															}
														     }
														  }
														else
														  {	/* Ast/find-gdefs.scm 201 */
														     goto tag_373_251_962;
														  }
													     }
													   else
													     {	/* Ast/find-gdefs.scm 201 */
														goto tag_373_251_962;
													     }
													}
												      else
													{	/* Ast/find-gdefs.scm 201 */
													   goto tag_373_251_962;
													}
												   }
											      }
											 }
										    }
									       }
									  }
								     }
								}
							   }
						      }
						 }
					    }
				       }
				  }
			     }
			}
		   }
	      }
	   }
	 else
	   {	/* Ast/find-gdefs.scm 201 */
	      return
		 CNST_TABLE_REF(((long) 8));
	   }
      }
   }
}



/* push-args */
obj_t 
push_args_50_ast_find_gdefs_13(obj_t expr_24, obj_t list_25, obj_t loc_26)
{
   AN_OBJECT;
   {	/* Ast/find-gdefs.scm 323 */
      {
	 obj_t expr_1240;
	 obj_t list_1241;
	 bool_t dsssl_1242;
	 expr_1240 = expr_24;
	 list_1241 = list_25;
	 dsssl_1242 = ((bool_t) 0);
       loop_1243:
	 if (
	    NULLP(expr_1240))
	   {	/* Ast/find-gdefs.scm 328 */
	      return list_1241;
	   }
	 else
	   {	/* Ast/find-gdefs.scm 328 */
	      if (
		 PAIRP(expr_1240))
		{	/* Ast/find-gdefs.scm 340 */
		   bool_t test_2870;
		   {	/* ./Ieee/symbol.scm 6015 */
		      obj_t aux_2871;
		      aux_2871 =
			 CAR(expr_1240);
		      test_2870 =
			 SYMBOLP(aux_2871);
		   }
		   if (test_2870)
		     {	/* Ast/find-gdefs.scm 340 */
			{	/* Ast/find-gdefs.scm 358 */
			   obj_t arg1789_1247;
			   obj_t arg1790_1248;
			   arg1789_1247 =
			      CDR(expr_1240);
			   {	/* Ast/find-gdefs.scm 359 */
			      obj_t arg1791_1249;
			      arg1791_1249 =
				 id_of_id_112_ast_ident(
				 CAR(expr_1240), loc_26);
			      arg1790_1248 =
				 MAKE_PAIR(arg1791_1249, list_1241);
			   }
			   {
			      obj_t list_2879;
			      obj_t expr_2878;
			      expr_2878 = arg1789_1247;
			      list_2879 = arg1790_1248;
			      list_1241 = list_2879;
			      expr_1240 = expr_2878;
			      goto loop_1243;
			   }
			}
		     }
		   else
		     {	/* Ast/find-gdefs.scm 340 */
			{	/* Ast/find-gdefs.scm 342 */
			   bool_t test1793_1251;
			   {	/* Ast/find-gdefs.scm 342 */
			      obj_t aux_2880;
			      aux_2880 =
				 dsssl_named_constant__188_tools_dsssl(
				 CAR(expr_1240));
			      test1793_1251 =
				 CBOOL(aux_2880);
			   }
			   if (test1793_1251)
			     {	/* Ast/find-gdefs.scm 342 */
				{
				   bool_t dsssl_2887;
				   obj_t expr_2885;
				   expr_2885 =
				      CDR(expr_1240);
				   dsssl_2887 = ((bool_t) 1);
				   dsssl_1242 = dsssl_2887;
				   expr_1240 = expr_2885;
				   goto loop_1243;
				}
			     }
			   else
			     {	/* Ast/find-gdefs.scm 342 */
				if (dsssl_1242)
				  {	/* Ast/find-gdefs.scm 348 */
				     bool_t test1795_1253;
				     {	/* Ast/find-gdefs.scm 348 */
					obj_t aux_2889;
					aux_2889 =
					   dsssl_defaulted_formal__174_tools_dsssl(
					   CAR(expr_1240));
					test1795_1253 =
					   CBOOL(aux_2889);
				     }
				     if (test1795_1253)
				       {	/* Ast/find-gdefs.scm 348 */
					  {	/* Ast/find-gdefs.scm 349 */
					     obj_t arg1796_1254;
					     obj_t arg1797_1255;
					     arg1796_1254 =
						CDR(expr_1240);
					     {	/* Ast/find-gdefs.scm 350 */
						obj_t arg1798_1256;
						{	/* Ast/find-gdefs.scm 350 */
						   obj_t arg1800_1257;
						   arg1800_1257 =
						      dsssl_default_formal_243_tools_dsssl(
						      CAR(expr_1240));
						   arg1798_1256 =
						      id_of_id_112_ast_ident(arg1800_1257, loc_26);
						}
						arg1797_1255 =
						   MAKE_PAIR(arg1798_1256, list_1241);
					     }
					     {
						bool_t dsssl_2901;
						obj_t list_2900;
						obj_t expr_2899;
						expr_2899 = arg1796_1254;
						list_2900 = arg1797_1255;
						dsssl_2901 = ((bool_t) 1);
						dsssl_1242 = dsssl_2901;
						list_1241 = list_2900;
						expr_1240 = expr_2899;
						goto loop_1243;
					     }
					  }
				       }
				     else
				       {	/* Ast/find-gdefs.scm 348 */
					  return
					     user_error_151_tools_error(expr_1240, string1900_ast_find_gdefs_13, string1901_ast_find_gdefs_13, BNIL);
				       }
				  }
				else
				  {	/* Ast/find-gdefs.scm 344 */
				     return
					user_error_151_tools_error(expr_1240, string1900_ast_find_gdefs_13, string1902_ast_find_gdefs_13, BNIL);
				  }
			     }
			}
		     }
		}
	      else
		{	/* Ast/find-gdefs.scm 330 */
		   if (dsssl_1242)
		     {	/* Ast/find-gdefs.scm 332 */
			return
			   user_error_151_tools_error(expr_1240, string1903_ast_find_gdefs_13, string1904_ast_find_gdefs_13, BNIL);
		     }
		   else
		     {	/* Ast/find-gdefs.scm 332 */
			if (
			   SYMBOLP(expr_1240))
			  {	/* Ast/find-gdefs.scm 336 */
			     {	/* Ast/find-gdefs.scm 339 */
				obj_t arg1809_1266;
				arg1809_1266 =
				   id_of_id_112_ast_ident(expr_1240, loc_26);
				return
				   MAKE_PAIR(arg1809_1266, list_1241);
			     }
			  }
			else
			  {	/* Ast/find-gdefs.scm 336 */
			     return
				user_error_151_tools_error(expr_1240, string1900_ast_find_gdefs_13, string1902_ast_find_gdefs_13, BNIL);
			  }
		     }
		}
	   }
      }
   }
}



/* method-init */
obj_t 
method_init_76_ast_find_gdefs_13()
{
   AN_OBJECT;
   {	/* Ast/find-gdefs.scm 23 */
      return BUNSPEC;
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_ast_find_gdefs_13()
{
   AN_OBJECT;
   {	/* Ast/find-gdefs.scm 23 */
      module_initialization_70_type_type(((long) 0), "AST_FIND-GDEFS");
      module_initialization_70_ast_var(((long) 0), "AST_FIND-GDEFS");
      module_initialization_70_ast_node(((long) 0), "AST_FIND-GDEFS");
      module_initialization_70_ast_ident(((long) 0), "AST_FIND-GDEFS");
      module_initialization_70_tools_shape(((long) 0), "AST_FIND-GDEFS");
      module_initialization_70_tools_error(((long) 0), "AST_FIND-GDEFS");
      module_initialization_70_tools_dsssl(((long) 0), "AST_FIND-GDEFS");
      module_initialization_70_tools_args(((long) 0), "AST_FIND-GDEFS");
      module_initialization_70_engine_param(((long) 0), "AST_FIND-GDEFS");
      module_initialization_70_module_module(((long) 0), "AST_FIND-GDEFS");
      return
	 module_initialization_70_tools_location(((long) 0), "AST_FIND-GDEFS");
   }
}
