/*===========================================================================*/
/*   (Ast/glo-decl.scm)                                                      */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;


extern global_bglt declare_global_scnst__70_ast_glo_decl_237(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t find_global_223_ast_env(obj_t, obj_t);
extern global_bglt declare_global_sfun__255_ast_glo_decl_237(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t method_init_76_ast_glo_decl_237();
static obj_t _declare_global_sfun_1602_57_ast_glo_decl_237(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern global_bglt bind_global__138_ast_env(obj_t, obj_t, value_bglt, obj_t, obj_t);
static obj_t _declare_global_cvar_1606_66_ast_glo_decl_237(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t user_warning_209_tools_error(obj_t, obj_t, obj_t);
extern obj_t _bdb_debug__1_engine_param;
extern obj_t global_ast_var;
extern obj_t _obj__252_type_cache;
extern global_bglt declare_global_cvar__13_ast_glo_decl_237(obj_t, obj_t, obj_t, bool_t, obj_t);
extern obj_t user_error_151_tools_error(obj_t, obj_t, obj_t, obj_t);
extern obj_t cvar_ast_var;
extern obj_t args___args_list_50_tools_args(obj_t);
extern type_bglt type_of_id_183_ast_ident(obj_t, obj_t);
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t dsssl_formals_encoding_15_tools_dsssl(obj_t);
extern obj_t module_initialization_70_ast_glo_decl_237(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_tools_args(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_dsssl(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_env(long, char *);
extern obj_t module_initialization_70_ast_ident(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_type_env(long, char *);
extern obj_t module_initialization_70_module_module(long, char *);
extern obj_t module_initialization_70_tools_location(long, char *);
extern obj_t module_initialization_70___error(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t _warning__61___error;
static obj_t _declare_global_cfun_1605_187_ast_glo_decl_237(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern long class_num_218___object(obj_t);
extern obj_t svar_ast_var;
extern obj_t scnst_ast_var;
extern obj_t module_initialization_id_110_module_module(obj_t);
static obj_t imported_modules_init_94_ast_glo_decl_237();
static obj_t _declare_global_scnst_1604_11_ast_glo_decl_237(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t cfun_ast_var;
extern obj_t dsssl_named_constant__188_tools_dsssl(obj_t);
static obj_t library_modules_init_112_ast_glo_decl_237();
extern global_bglt declare_global_svar__200_ast_glo_decl_237(obj_t, obj_t, obj_t, obj_t);
extern obj_t open_input_string(obj_t);
extern obj_t sfun_ast_var;
extern int arity_tools_args(obj_t);
extern global_bglt declare_global_cfun__81_ast_glo_decl_237(obj_t, obj_t, obj_t, obj_t, bool_t, bool_t, obj_t);
extern obj_t parse_id_241_ast_ident(obj_t, obj_t);
extern type_bglt use_foreign_type__12_type_env(obj_t, obj_t);
extern obj_t memq___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern obj_t shape_tools_shape(obj_t);
extern obj_t internal_error_43_tools_error(obj_t, obj_t, obj_t);
static obj_t _declare_global_svar_1603_56_ast_glo_decl_237(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t read___reader(obj_t);
extern obj_t find_location_120_tools_location(obj_t);
extern obj_t _lib_mode__85_engine_param;
extern obj_t ____74_type_cache;
static obj_t require_initialization_114_ast_glo_decl_237 = BUNSPEC;
static obj_t cnst_init_137_ast_glo_decl_237();
extern obj_t reverse__39___r4_pairs_and_lists_6_3(obj_t);
static obj_t __cnst[9];

DEFINE_EXPORT_PROCEDURE(declare_global_scnst__env_79_ast_glo_decl_237, _declare_global_scnst_1604_11_ast_glo_decl_2371616, _declare_global_scnst_1604_11_ast_glo_decl_237, 0L, 6);
DEFINE_EXPORT_PROCEDURE(declare_global_svar__env_68_ast_glo_decl_237, _declare_global_svar_1603_56_ast_glo_decl_2371617, _declare_global_svar_1603_56_ast_glo_decl_237, 0L, 4);
DEFINE_EXPORT_PROCEDURE(declare_global_sfun__env_194_ast_glo_decl_237, _declare_global_sfun_1602_57_ast_glo_decl_2371618, _declare_global_sfun_1602_57_ast_glo_decl_237, 0L, 6);
DEFINE_EXPORT_PROCEDURE(declare_global_cvar__env_34_ast_glo_decl_237, _declare_global_cvar_1606_66_ast_glo_decl_2371619, _declare_global_cvar_1606_66_ast_glo_decl_237, 0L, 5);
DEFINE_EXPORT_PROCEDURE(declare_global_cfun__env_226_ast_glo_decl_237, _declare_global_cfun_1605_187_ast_glo_decl_2371620, _declare_global_cfun_1605_187_ast_glo_decl_237, 0L, 7);
DEFINE_STRING(string1611_ast_glo_decl_237, string1611_ast_glo_decl_2371621, "FOREIGN A-CNST WRITE READ (EXPORT IMPORT) BIGLOO SGFUN EXPORT STATIC ", 69);
DEFINE_STRING(string1609_ast_glo_decl_237, string1609_ast_glo_decl_2371622, "Global variable redefinition", 28);
DEFINE_STRING(string1610_ast_glo_decl_237, string1610_ast_glo_decl_2371623, "Illegal type for global variable", 32);
DEFINE_STRING(string1608_ast_glo_decl_237, string1608_ast_glo_decl_2371624, "declare-global-sfun", 19);
DEFINE_STRING(string1607_ast_glo_decl_237, string1607_ast_glo_decl_2371625, "Illegal nary argument type", 26);



/* module-initialization */
obj_t 
module_initialization_70_ast_glo_decl_237(long checksum_1427, char *from_1428)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_ast_glo_decl_237))
	{
	   require_initialization_114_ast_glo_decl_237 =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_ast_glo_decl_237();
	   cnst_init_137_ast_glo_decl_237();
	   imported_modules_init_94_ast_glo_decl_237();
	   method_init_76_ast_glo_decl_237();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_ast_glo_decl_237()
{
   AN_OBJECT;
   {	/* Ast/glo-decl.scm 17 */
      module_initialization_70___object(((long) 0), "AST_GLO-DECL");
      module_initialization_70___error(((long) 0), "AST_GLO-DECL");
      module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "AST_GLO-DECL");
      module_initialization_70___reader(((long) 0), "AST_GLO-DECL");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_ast_glo_decl_237()
{
   AN_OBJECT;
   {	/* Ast/glo-decl.scm 17 */
      {		/* Ast/glo-decl.scm 17 */
	 obj_t cnst_port_138_1420;
	 cnst_port_138_1420 =
	    open_input_string(string1611_ast_glo_decl_237);
	 {
	    long i_1421;
	    i_1421 = ((long) 8);
	  loop_1422:
	    {	/* Ast/glo-decl.scm 17 */
	       bool_t test1612_1423;
	       test1612_1423 =
		  (i_1421 == ((long) -1));
	       if (test1612_1423)
		 {	/* Ast/glo-decl.scm 17 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Ast/glo-decl.scm 17 */
		    {	/* Ast/glo-decl.scm 17 */
		       obj_t arg1613_1424;
		       {	/* Ast/glo-decl.scm 17 */
			  obj_t list1614_1425;
			  list1614_1425 =
			     MAKE_PAIR(cnst_port_138_1420, BNIL);
			  arg1613_1424 =
			     read___reader(list1614_1425);
		       }
		       CNST_TABLE_SET(i_1421, arg1613_1424);
		    }
		    {	/* Ast/glo-decl.scm 17 */
		       int aux_1426;
		       {	/* Ast/glo-decl.scm 17 */
			  long aux_1446;
			  aux_1446 =
			     (i_1421 - ((long) 1));
			  aux_1426 =
			     (int) (aux_1446);
		       }
		       {
			  long i_1449;
			  i_1449 =
			     (long) (aux_1426);
			  i_1421 = i_1449;
			  goto loop_1422;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* declare-global-sfun! */
global_bglt 
declare_global_sfun__255_ast_glo_decl_237(obj_t id_1, obj_t args_2, obj_t module_3, obj_t import_4, obj_t class_5, obj_t src_exp_176_6)
{
   AN_OBJECT;
   {	/* Ast/glo-decl.scm 69 */
      {		/* Ast/glo-decl.scm 72 */
	 int arity_724;
	 arity_724 =
	    arity_tools_args(args_2);
	 {	/* Ast/glo-decl.scm 72 */
	    obj_t args_725;
	    args_725 =
	       args___args_list_50_tools_args(args_2);
	    {	/* Ast/glo-decl.scm 73 */
	       bool_t export__13_726;
	       {	/* Ast/glo-decl.scm 74 */
		  bool_t _ortest_1437_780;
		  {	/* Ast/glo-decl.scm 74 */
		     bool_t test_1453;
		     {	/* ./Ieee/equiv.scm 5508 */
			obj_t aux_1454;
			aux_1454 =
			   CNST_TABLE_REF(((long) 0));
			test_1453 =
			   (import_4 == aux_1454);
		     }
		     if (test_1453)
		       {	/* Ast/glo-decl.scm 74 */
			  _ortest_1437_780 = ((bool_t) 0);
		       }
		     else
		       {	/* Ast/glo-decl.scm 74 */
			  _ortest_1437_780 = ((bool_t) 1);
		       }
		  }
		  if (_ortest_1437_780)
		    {	/* Ast/glo-decl.scm 74 */
		       export__13_726 = _ortest_1437_780;
		    }
		  else
		    {	/* Ast/glo-decl.scm 75 */
		       long n1_1169;
		       n1_1169 =
			  (long) CINT(_bdb_debug__1_engine_param);
		       export__13_726 =
			  (n1_1169 >= ((long) 3));
		    }
	       }
	       {	/* Ast/glo-decl.scm 74 */
		  obj_t import_727;
		  {	/* Ast/glo-decl.scm 76 */
		     bool_t test1485_778;
		     {	/* Ast/glo-decl.scm 76 */
			bool_t test_1460;
			{	/* ./Ieee/equiv.scm 5508 */
			   obj_t aux_1461;
			   aux_1461 =
			      CNST_TABLE_REF(((long) 0));
			   test_1460 =
			      (import_4 == aux_1461);
			}
			if (test_1460)
			  {	/* Ast/glo-decl.scm 77 */
			     long n1_1173;
			     n1_1173 =
				(long) CINT(_bdb_debug__1_engine_param);
			     test1485_778 =
				(n1_1173 >= ((long) 3));
			  }
			else
			  {	/* Ast/glo-decl.scm 76 */
			     test1485_778 = ((bool_t) 0);
			  }
		     }
		     if (test1485_778)
		       {	/* Ast/glo-decl.scm 76 */
			  import_727 =
			     CNST_TABLE_REF(((long) 1));
		       }
		     else
		       {	/* Ast/glo-decl.scm 76 */
			  import_727 = import_4;
		       }
		  }
		  {	/* Ast/glo-decl.scm 76 */
		     obj_t loc_728;
		     loc_728 =
			find_location_120_tools_location(src_exp_176_6);
		     {	/* Ast/glo-decl.scm 80 */
			obj_t keywords_729;
			keywords_729 = BNIL;
			{	/* Ast/glo-decl.scm 81 */
			   obj_t args_type_205_730;
			   {
			      obj_t args_751;
			      obj_t res_752;
			      bool_t sgfun__91_753;
			      args_751 = args_725;
			      res_752 = BNIL;
			      {		/* ./Ieee/equiv.scm 5508 */
				 obj_t aux_1510;
				 aux_1510 =
				    CNST_TABLE_REF(((long) 2));
				 sgfun__91_753 =
				    (class_5 == aux_1510);
			      }
			    loop_754:
			      if (
				 NULLP(args_751))
				{	/* Ast/glo-decl.scm 86 */
				   {	/* Ast/glo-decl.scm 87 */
				      bool_t test_1471;
				      {		/* ./Ieee/fixnum.scm 7133 */
					 long aux_1472;
					 aux_1472 =
					    (long) (arity_724);
					 test_1471 =
					    (aux_1472 >= ((long) 0));
				      }
				      if (test_1471)
					{	/* Ast/glo-decl.scm 87 */
					   args_type_205_730 =
					      reverse__39___r4_pairs_and_lists_6_3(res_752);
					}
				      else
					{	/* Ast/glo-decl.scm 89 */
					   obj_t type_759;
					   type_759 =
					      CAR(res_752);
					   {	/* Ast/glo-decl.scm 91 */
					      bool_t test1470_760;
					      {		/* Ast/glo-decl.scm 91 */
						 obj_t obj2_1182;
						 obj2_1182 = _obj__252_type_cache;
						 test1470_760 =
						    (type_759 == obj2_1182);
					      }
					      if (test1470_760)
						{	/* Ast/glo-decl.scm 91 */
						   args_type_205_730 =
						      reverse__39___r4_pairs_and_lists_6_3(res_752);
						}
					      else
						{	/* Ast/glo-decl.scm 93 */
						   bool_t test1471_761;
						   {	/* Ast/glo-decl.scm 93 */
						      obj_t obj2_1184;
						      obj2_1184 = ____74_type_cache;
						      test1471_761 =
							 (type_759 == obj2_1184);
						   }
						   if (test1471_761)
						     {	/* Ast/glo-decl.scm 93 */
							{	/* Ast/glo-decl.scm 94 */
							   obj_t arg1472_762;
							   {	/* Ast/glo-decl.scm 94 */
							      obj_t obj1_1186;
							      obj1_1186 = _obj__252_type_cache;
							      {		/* ./Ieee/pair-list.scm 5689 */
								 obj_t aux_1482;
								 aux_1482 =
								    CDR(res_752);
								 arg1472_762 =
								    MAKE_PAIR(obj1_1186, aux_1482);
							      }
							   }
							   args_type_205_730 =
							      reverse__39___r4_pairs_and_lists_6_3(arg1472_762);
							}
						     }
						   else
						     {	/* Ast/glo-decl.scm 93 */
							{	/* Ast/glo-decl.scm 96 */
							   obj_t arg1475_765;
							   arg1475_765 =
							      shape_tools_shape(type_759);
							   args_type_205_730 =
							      user_error_151_tools_error(id_1, string1607_ast_glo_decl_237, arg1475_765, BNIL);
							}
						     }
						}
					   }
					}
				   }
				}
			      else
				{	/* Ast/glo-decl.scm 99 */
				   bool_t test1477_767;
				   {	/* Ast/glo-decl.scm 99 */
				      obj_t aux_1488;
				      aux_1488 =
					 dsssl_named_constant__188_tools_dsssl(
					 CAR(args_751));
				      test1477_767 =
					 CBOOL(aux_1488);
				   }
				   if (test1477_767)
				     {	/* Ast/glo-decl.scm 99 */
					keywords_729 =
					   dsssl_formals_encoding_15_tools_dsssl(args_751);
					{	/* Ast/glo-decl.scm 101 */
					   obj_t arg1478_768;
					   {	/* Ast/glo-decl.scm 101 */
					      obj_t obj1_1189;
					      obj1_1189 = _obj__252_type_cache;
					      arg1478_768 =
						 MAKE_PAIR(obj1_1189, res_752);
					   }
					   args_type_205_730 =
					      reverse__39___r4_pairs_and_lists_6_3(arg1478_768);
					}
				     }
				   else
				     {	/* Ast/glo-decl.scm 99 */
					{	/* Ast/glo-decl.scm 103 */
					   obj_t type_769;
					   {	/* Ast/glo-decl.scm 103 */
					      type_bglt t_772;
					      t_772 =
						 type_of_id_183_ast_ident(
						 CAR(args_751), loc_728);
					      {		/* Ast/glo-decl.scm 104 */
						 bool_t test1481_773;
						 {	/* Ast/glo-decl.scm 104 */
						    bool_t test1482_774;
						    {	/* Ast/glo-decl.scm 104 */
						       obj_t obj2_1193;
						       obj2_1193 = ____74_type_cache;
						       {	/* ./Ieee/equiv.scm 5508 */
							  obj_t aux_1498;
							  aux_1498 =
							     (obj_t) (t_772);
							  test1482_774 =
							     (aux_1498 == obj2_1193);
						       }
						    }
						    if (test1482_774)
						      {		/* Ast/glo-decl.scm 104 */
							 if (export__13_726)
							   {	/* Ast/glo-decl.scm 105 */
							      test1481_773 = export__13_726;
							   }
							 else
							   {	/* Ast/glo-decl.scm 105 */
							      test1481_773 = sgfun__91_753;
							   }
						      }
						    else
						      {		/* Ast/glo-decl.scm 104 */
							 test1481_773 = ((bool_t) 0);
						      }
						 }
						 if (test1481_773)
						   {	/* Ast/glo-decl.scm 104 */
						      type_769 = _obj__252_type_cache;
						   }
						 else
						   {	/* Ast/glo-decl.scm 104 */
						      type_769 =
							 (obj_t) (t_772);
						   }
					      }
					   }
					   {	/* Ast/glo-decl.scm 108 */
					      obj_t arg1479_770;
					      obj_t arg1480_771;
					      arg1479_770 =
						 CDR(args_751);
					      arg1480_771 =
						 MAKE_PAIR(type_769, res_752);
					      {
						 bool_t sgfun__91_1509;
						 obj_t res_1508;
						 obj_t args_1507;
						 args_1507 = arg1479_770;
						 res_1508 = arg1480_771;
						 sgfun__91_1509 = ((bool_t) 0);
						 sgfun__91_753 = sgfun__91_1509;
						 res_752 = res_1508;
						 args_751 = args_1507;
						 goto loop_754;
					      }
					   }
					}
				     }
				}
			   }
			   {	/* Ast/glo-decl.scm 82 */
			      obj_t id_type_89_731;
			      id_type_89_731 =
				 parse_id_241_ast_ident(id_1, loc_728);
			      {		/* Ast/glo-decl.scm 111 */
				 obj_t type_res_48_732;
				 type_res_48_732 =
				    CDR(id_type_89_731);
				 {	/* Ast/glo-decl.scm 112 */
				    obj_t id_733;
				    id_733 =
				       CAR(id_type_89_731);
				    {	/* Ast/glo-decl.scm 113 */
				       sfun_bglt sfun_734;
				       {	/* Ast/glo-decl.scm 114 */
					  obj_t arg1464_750;
					  arg1464_750 = keywords_729;
					  {	/* Ast/glo-decl.scm 114 */
					     sfun_bglt res1597_1227;
					     {	/* Ast/glo-decl.scm 114 */
						long arity_1199;
						obj_t predicate_of_78_1201;
						obj_t stack_allocator_172_1202;
						arity_1199 =
						   (long) (arity_724);
						predicate_of_78_1201 = BFALSE;
						stack_allocator_172_1202 = BFALSE;
						{	/* ./Ast/var.scm 1084 */
						   sfun_bglt new1127_1211;
						   new1127_1211 =
						      ((sfun_bglt) BREF(GC_MALLOC(sizeof(struct sfun))));
						   {	/* ./Ast/var.scm 1084 */
						      long arg1584_1212;
						      arg1584_1212 =
							 class_num_218___object(sfun_ast_var);
						      {		/* ./Ast/var.scm 1084 */
							 obj_t obj_1225;
							 obj_1225 =
							    (obj_t) (new1127_1211);
							 (((obj_t) CREF(obj_1225))->header = MAKE_HEADER(arg1584_1212, 0), BUNSPEC);
						      }
						   }
						   {	/* ./Ast/var.scm 1084 */
						      object_bglt aux_1521;
						      aux_1521 =
							 (object_bglt) (new1127_1211);
						      OBJECT_WIDENING_SET(aux_1521, predicate_of_78_1201);
						   }
						   ((((sfun_bglt) CREF(new1127_1211))->arity) = ((long) arity_1199), BUNSPEC);
						   ((((sfun_bglt) CREF(new1127_1211))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
						   ((((sfun_bglt) CREF(new1127_1211))->predicate_of_78) = ((obj_t) predicate_of_78_1201), BUNSPEC);
						   ((((sfun_bglt) CREF(new1127_1211))->stack_allocator_172) = ((obj_t) stack_allocator_172_1202), BUNSPEC);
						   ((((sfun_bglt) CREF(new1127_1211))->top__138) = ((bool_t) ((bool_t) 1)), BUNSPEC);
						   ((((sfun_bglt) CREF(new1127_1211))->the_closure_238) = ((obj_t) BUNSPEC), BUNSPEC);
						   ((((sfun_bglt) CREF(new1127_1211))->property) = ((obj_t) BNIL), BUNSPEC);
						   ((((sfun_bglt) CREF(new1127_1211))->args) = ((obj_t) args_type_205_730), BUNSPEC);
						   ((((sfun_bglt) CREF(new1127_1211))->body) = ((obj_t) BUNSPEC), BUNSPEC);
						   ((((sfun_bglt) CREF(new1127_1211))->class) = ((obj_t) class_5), BUNSPEC);
						   ((((sfun_bglt) CREF(new1127_1211))->dsssl_keywords_243) = ((obj_t) arg1464_750), BUNSPEC);
						   ((((sfun_bglt) CREF(new1127_1211))->loc) = ((obj_t) BUNSPEC), BUNSPEC);
						   res1597_1227 = new1127_1211;
						}
					     }
					     sfun_734 = res1597_1227;
					  }
				       }
				       {	/* Ast/glo-decl.scm 114 */
					  obj_t old_735;
					  old_735 =
					     find_global_223_ast_env(id_733, BNIL);
					  {	/* Ast/glo-decl.scm 118 */
					     global_bglt global_736;
					     global_736 =
						bind_global__138_ast_env(id_733, module_3,
						(value_bglt) (sfun_734), import_727, src_exp_176_6);
					     {	/* Ast/glo-decl.scm 119 */

						{	/* Ast/glo-decl.scm 123 */
						   bool_t test1450_737;
						   {	/* Ast/glo-decl.scm 123 */
						      bool_t test1451_738;
						      test1451_738 =
							 is_a__118___object(old_735, global_ast_var);
						      if (test1451_738)
							{	/* Ast/glo-decl.scm 124 */
							   bool_t test_1541;
							   {	/* ./Ieee/equiv.scm 5508 */
							      obj_t aux_1542;
							      {		/* Ast/glo-decl.scm 124 */
								 global_bglt obj_1229;
								 obj_1229 =
								    (global_bglt) (old_735);
								 aux_1542 =
								    (((global_bglt) CREF(obj_1229))->module);
							      }
							      test_1541 =
								 (aux_1542 == module_3);
							   }
							   if (test_1541)
							     {	/* Ast/glo-decl.scm 124 */
								test1450_737 = ((bool_t) 0);
							     }
							   else
							     {	/* Ast/glo-decl.scm 124 */
								if (
								   CBOOL(_lib_mode__85_engine_param))
								  {	/* Ast/glo-decl.scm 125 */
								     test1450_737 = ((bool_t) 0);
								  }
								else
								  {	/* Ast/glo-decl.scm 126 */
								     bool_t test_1548;
								     {	/* Ast/glo-decl.scm 126 */
									global_bglt obj_1232;
									obj_1232 =
									   (global_bglt) (old_735);
									test_1548 =
									   (((global_bglt) CREF(obj_1232))->user__32);
								     }
								     if (test_1548)
								       {	/* Ast/glo-decl.scm 127 */
									  bool_t test1454_741;
									  {	/* Ast/glo-decl.scm 127 */
									     obj_t arg1455_742;
									     arg1455_742 =
										module_initialization_id_110_module_module(module_3);
									     test1454_741 =
										(id_733 == arg1455_742);
									  }
									  if (test1454_741)
									    {	/* Ast/glo-decl.scm 127 */
									       test1450_737 = ((bool_t) 0);
									    }
									  else
									    {	/* Ast/glo-decl.scm 127 */
									       test1450_737 =
										  CBOOL(_warning__61___error);
									    }
								       }
								     else
								       {	/* Ast/glo-decl.scm 126 */
									  test1450_737 = ((bool_t) 0);
								       }
								  }
							     }
							}
						      else
							{	/* Ast/glo-decl.scm 123 */
							   test1450_737 = ((bool_t) 0);
							}
						   }
						   if (test1450_737)
						     {	/* Ast/glo-decl.scm 123 */
							user_warning_209_tools_error(string1608_ast_glo_decl_237, string1609_ast_glo_decl_237, id_733);
						     }
						   else
						     {	/* Ast/glo-decl.scm 123 */
							BUNSPEC;
						     }
						}
						{	/* Ast/glo-decl.scm 136 */
						   bool_t test1457_744;
						   {	/* Ast/glo-decl.scm 136 */
						      obj_t obj2_1236;
						      obj2_1236 = ____74_type_cache;
						      test1457_744 =
							 (type_res_48_732 == obj2_1236);
						   }
						   if (test1457_744)
						     {	/* Ast/glo-decl.scm 136 */
							if (export__13_726)
							  {	/* Ast/glo-decl.scm 138 */
							     {	/* Ast/glo-decl.scm 139 */
								type_bglt val1052_1238;
								val1052_1238 =
								   (type_bglt) (_obj__252_type_cache);
								((((global_bglt) CREF(global_736))->type) = ((type_bglt) val1052_1238), BUNSPEC);
							     }
							  }
							else
							  {	/* Ast/glo-decl.scm 138 */
							     {	/* Ast/glo-decl.scm 141 */
								type_bglt val1052_1240;
								val1052_1240 =
								   (type_bglt) (type_res_48_732);
								((((global_bglt) CREF(global_736))->type) = ((type_bglt) val1052_1240), BUNSPEC);
							     }
							  }
						     }
						   else
						     {	/* Ast/glo-decl.scm 136 */
							{	/* Ast/glo-decl.scm 137 */
							   type_bglt val1052_1242;
							   val1052_1242 =
							      (type_bglt) (type_res_48_732);
							   ((((global_bglt) CREF(global_736))->type) = ((type_bglt) val1052_1242), BUNSPEC);
							}
						     }
						}
						return global_736;
					     }
					  }
				       }
				    }
				 }
			      }
			   }
			}
		     }
		  }
	       }
	    }
	 }
      }
   }
}



/* _declare-global-sfun!1602 */
obj_t 
_declare_global_sfun_1602_57_ast_glo_decl_237(obj_t env_1387, obj_t id_1388, obj_t args_1389, obj_t module_1390, obj_t import_1391, obj_t class_1392, obj_t src_exp_176_1393)
{
   AN_OBJECT;
   {	/* Ast/glo-decl.scm 69 */
      {		/* Ast/glo-decl.scm 69 */
	 global_bglt aux_1566;
	 aux_1566 =
	    declare_global_sfun__255_ast_glo_decl_237(id_1388, args_1389, module_1390, import_1391, class_1392, src_exp_176_1393);
	 return
	    (obj_t) (aux_1566);
      }
   }
}



/* declare-global-svar! */
global_bglt 
declare_global_svar__200_ast_glo_decl_237(obj_t id_7, obj_t module_8, obj_t import_9, obj_t src_exp_176_10)
{
   AN_OBJECT;
   {	/* Ast/glo-decl.scm 148 */
      {		/* Ast/glo-decl.scm 149 */
	 obj_t id_type_89_782;
	 {	/* Ast/glo-decl.scm 149 */
	    obj_t arg1500_802;
	    arg1500_802 =
	       find_location_120_tools_location(src_exp_176_10);
	    id_type_89_782 =
	       parse_id_241_ast_ident(id_7, arg1500_802);
	 }
	 {	/* Ast/glo-decl.scm 149 */
	    obj_t type_783;
	    {	/* Ast/glo-decl.scm 150 */
	       obj_t type_792;
	       type_792 =
		  CDR(id_type_89_782);
	       {	/* Ast/glo-decl.scm 154 */
		  bool_t test_1572;
		  {	/* ./Ieee/equiv.scm 5508 */
		     obj_t aux_1576;
		     obj_t aux_1573;
		     aux_1576 =
			CNST_TABLE_REF(((long) 3));
		     {	/* Ast/glo-decl.scm 154 */
			type_bglt obj_1244;
			obj_1244 =
			   (type_bglt) (type_792);
			aux_1573 =
			   (((type_bglt) CREF(obj_1244))->class);
		     }
		     test_1572 =
			(aux_1573 == aux_1576);
		  }
		  if (test_1572)
		    {	/* Ast/glo-decl.scm 159 */
		       bool_t test1493_794;
		       {	/* Ast/glo-decl.scm 159 */
			  bool_t test1494_795;
			  {	/* Ast/glo-decl.scm 159 */
			     obj_t obj2_1248;
			     obj2_1248 = ____74_type_cache;
			     test1494_795 =
				(type_792 == obj2_1248);
			  }
			  if (test1494_795)
			    {	/* Ast/glo-decl.scm 160 */
			       obj_t _ortest_1440_796;
			       _ortest_1440_796 =
				  memq___r4_pairs_and_lists_6_3(import_9,
				  CNST_TABLE_REF(((long) 4)));
			       if (
				  CBOOL(_ortest_1440_796))
				 {	/* Ast/glo-decl.scm 160 */
				    test1493_794 =
				       CBOOL(_ortest_1440_796);
				 }
			       else
				 {	/* Ast/glo-decl.scm 161 */
				    long n1_1249;
				    n1_1249 =
				       (long) CINT(_bdb_debug__1_engine_param);
				    test1493_794 =
				       (n1_1249 > ((long) 0));
				 }
			    }
			  else
			    {	/* Ast/glo-decl.scm 159 */
			       test1493_794 = ((bool_t) 0);
			    }
		       }
		       if (test1493_794)
			 {	/* Ast/glo-decl.scm 159 */
			    type_783 = _obj__252_type_cache;
			 }
		       else
			 {	/* Ast/glo-decl.scm 159 */
			    type_783 = type_792;
			 }
		    }
		  else
		    {	/* Ast/glo-decl.scm 154 */
		       {	/* Ast/glo-decl.scm 155 */
			  obj_t arg1496_798;
			  arg1496_798 =
			     shape_tools_shape(type_792);
			  {	/* Ast/glo-decl.scm 155 */
			     obj_t list1497_799;
			     list1497_799 =
				MAKE_PAIR(____74_type_cache, BNIL);
			     type_783 =
				user_error_151_tools_error(id_7, string1610_ast_glo_decl_237, arg1496_798, list1497_799);
			  }
		       }
		    }
	       }
	    }
	    {	/* Ast/glo-decl.scm 150 */
	       obj_t import_784;
	       {	/* Ast/glo-decl.scm 165 */
		  bool_t test1490_790;
		  {	/* Ast/glo-decl.scm 165 */
		     bool_t test_1592;
		     {	/* ./Ieee/equiv.scm 5508 */
			obj_t aux_1593;
			aux_1593 =
			   CNST_TABLE_REF(((long) 0));
			test_1592 =
			   (import_9 == aux_1593);
		     }
		     if (test_1592)
		       {	/* Ast/glo-decl.scm 166 */
			  long n1_1253;
			  n1_1253 =
			     (long) CINT(_bdb_debug__1_engine_param);
			  test1490_790 =
			     (n1_1253 >= ((long) 3));
		       }
		     else
		       {	/* Ast/glo-decl.scm 165 */
			  test1490_790 = ((bool_t) 0);
		       }
		  }
		  if (test1490_790)
		    {	/* Ast/glo-decl.scm 165 */
		       import_784 =
			  CNST_TABLE_REF(((long) 1));
		    }
		  else
		    {	/* Ast/glo-decl.scm 165 */
		       import_784 = import_9;
		    }
	       }
	       {	/* Ast/glo-decl.scm 165 */
		  obj_t id_785;
		  id_785 =
		     CAR(id_type_89_782);
		  {	/* Ast/glo-decl.scm 169 */
		     svar_bglt svar_786;
		     {	/* Ast/glo-decl.scm 170 */
			svar_bglt res1598_1262;
			{	/* ./Ast/var.scm 1113 */
			   svar_bglt new1161_1257;
			   new1161_1257 =
			      ((svar_bglt) BREF(GC_MALLOC(sizeof(struct svar))));
			   {	/* ./Ast/var.scm 1113 */
			      long arg1580_1258;
			      arg1580_1258 =
				 class_num_218___object(svar_ast_var);
			      {		/* ./Ast/var.scm 1113 */
				 obj_t obj_1260;
				 obj_1260 =
				    (obj_t) (new1161_1257);
				 (((obj_t) CREF(obj_1260))->header = MAKE_HEADER(arg1580_1258, 0), BUNSPEC);
			      }
			   }
			   {	/* ./Ast/var.scm 1113 */
			      object_bglt aux_1605;
			      aux_1605 =
				 (object_bglt) (new1161_1257);
			      OBJECT_WIDENING_SET(aux_1605, BFALSE);
			   }
			   ((((svar_bglt) CREF(new1161_1257))->loc) = ((obj_t) BUNSPEC), BUNSPEC);
			   res1598_1262 = new1161_1257;
			}
			svar_786 = res1598_1262;
		     }
		     {	/* Ast/glo-decl.scm 170 */
			global_bglt global_787;
			global_787 =
			   bind_global__138_ast_env(id_785, module_8,
			   (value_bglt) (svar_786), import_784, src_exp_176_10);
			{	/* Ast/glo-decl.scm 171 */

			   {	/* Ast/glo-decl.scm 173 */
			      type_bglt val1052_1264;
			      val1052_1264 =
				 (type_bglt) (type_783);
			      ((((global_bglt) CREF(global_787))->type) = ((type_bglt) val1052_1264), BUNSPEC);
			   }
			   {	/* Ast/glo-decl.scm 175 */
			      obj_t arg1488_788;
			      {		/* Ast/glo-decl.scm 175 */
				 bool_t test_1613;
				 {	/* ./Ieee/equiv.scm 5508 */
				    obj_t aux_1614;
				    aux_1614 =
				       CNST_TABLE_REF(((long) 0));
				    test_1613 =
				       (import_784 == aux_1614);
				 }
				 if (test_1613)
				   {	/* Ast/glo-decl.scm 175 */
				      arg1488_788 =
					 CNST_TABLE_REF(((long) 5));
				   }
				 else
				   {	/* Ast/glo-decl.scm 175 */
				      arg1488_788 =
					 CNST_TABLE_REF(((long) 6));
				   }
			      }
			      ((((global_bglt) CREF(global_787))->access) = ((obj_t) arg1488_788), BUNSPEC);
			   }
			   return global_787;
			}
		     }
		  }
	       }
	    }
	 }
      }
   }
}



/* _declare-global-svar!1603 */
obj_t 
_declare_global_svar_1603_56_ast_glo_decl_237(obj_t env_1394, obj_t id_1395, obj_t module_1396, obj_t import_1397, obj_t src_exp_176_1398)
{
   AN_OBJECT;
   {	/* Ast/glo-decl.scm 148 */
      {		/* Ast/glo-decl.scm 148 */
	 global_bglt aux_1620;
	 aux_1620 =
	    declare_global_svar__200_ast_glo_decl_237(id_1395, module_1396, import_1397, src_exp_176_1398);
	 return
	    (obj_t) (aux_1620);
      }
   }
}



/* declare-global-scnst! */
global_bglt 
declare_global_scnst__70_ast_glo_decl_237(obj_t id_11, obj_t module_12, obj_t import_13, obj_t node_14, obj_t class_15, obj_t loc_16)
{
   AN_OBJECT;
   {	/* Ast/glo-decl.scm 182 */
      {		/* Ast/glo-decl.scm 183 */
	 obj_t id_type_89_803;
	 id_type_89_803 =
	    parse_id_241_ast_ident(id_11, loc_16);
	 {	/* Ast/glo-decl.scm 183 */
	    obj_t type_804;
	    {	/* Ast/glo-decl.scm 184 */
	       obj_t type_810;
	       type_810 =
		  CDR(id_type_89_803);
	       {	/* Ast/glo-decl.scm 188 */
		  bool_t test1503_811;
		  {	/* Ast/glo-decl.scm 188 */
		     obj_t obj2_1271;
		     obj2_1271 = ____74_type_cache;
		     test1503_811 =
			(type_810 == obj2_1271);
		  }
		  if (test1503_811)
		    {	/* Ast/glo-decl.scm 188 */
		       {	/* Ast/glo-decl.scm 189 */
			  obj_t arg1505_813;
			  arg1505_813 =
			     shape_tools_shape(type_810);
			  type_804 =
			     internal_error_43_tools_error(id_11, string1610_ast_glo_decl_237, arg1505_813);
		       }
		    }
		  else
		    {	/* Ast/glo-decl.scm 188 */
		       type_804 = type_810;
		    }
	       }
	    }
	    {	/* Ast/glo-decl.scm 184 */
	       obj_t id_805;
	       id_805 =
		  CAR(id_type_89_803);
	       {	/* Ast/glo-decl.scm 194 */
		  scnst_bglt scnst_806;
		  {	/* Ast/glo-decl.scm 195 */
		     scnst_bglt res1599_1283;
		     {	/* ./Ast/var.scm 1117 */
			scnst_bglt new1167_1276;
			new1167_1276 =
			   ((scnst_bglt) BREF(GC_MALLOC(sizeof(struct scnst))));
			{	/* ./Ast/var.scm 1117 */
			   long arg1578_1277;
			   arg1578_1277 =
			      class_num_218___object(scnst_ast_var);
			   {	/* ./Ast/var.scm 1117 */
			      obj_t obj_1281;
			      obj_1281 =
				 (obj_t) (new1167_1276);
			      (((obj_t) CREF(obj_1281))->header = MAKE_HEADER(arg1578_1277, 0), BUNSPEC);
			   }
			}
			{	/* ./Ast/var.scm 1117 */
			   object_bglt aux_1634;
			   aux_1634 =
			      (object_bglt) (new1167_1276);
			   OBJECT_WIDENING_SET(aux_1634, BFALSE);
			}
			((((scnst_bglt) CREF(new1167_1276))->node) = ((obj_t) node_14), BUNSPEC);
			((((scnst_bglt) CREF(new1167_1276))->class) = ((obj_t) class_15), BUNSPEC);
			((((scnst_bglt) CREF(new1167_1276))->loc) = ((obj_t) BUNSPEC), BUNSPEC);
			res1599_1283 = new1167_1276;
		     }
		     scnst_806 = res1599_1283;
		  }
		  {	/* Ast/glo-decl.scm 195 */
		     global_bglt global_807;
		     global_807 =
			bind_global__138_ast_env(id_805, module_12,
			(value_bglt) (scnst_806), import_13,
			CNST_TABLE_REF(((long) 7)));
		     {	/* Ast/glo-decl.scm 198 */

			{	/* Ast/glo-decl.scm 200 */
			   type_bglt val1052_1285;
			   val1052_1285 =
			      (type_bglt) (type_804);
			   ((((global_bglt) CREF(global_807))->type) = ((type_bglt) val1052_1285), BUNSPEC);
			}
			{	/* Ast/glo-decl.scm 202 */
			   obj_t val1054_1287;
			   val1054_1287 =
			      CNST_TABLE_REF(((long) 5));
			   ((((global_bglt) CREF(global_807))->access) = ((obj_t) val1054_1287), BUNSPEC);
			}
			return global_807;
		     }
		  }
	       }
	    }
	 }
      }
   }
}



/* _declare-global-scnst!1604 */
obj_t 
_declare_global_scnst_1604_11_ast_glo_decl_237(obj_t env_1399, obj_t id_1400, obj_t module_1401, obj_t import_1402, obj_t node_1403, obj_t class_1404, obj_t loc_1405)
{
   AN_OBJECT;
   {	/* Ast/glo-decl.scm 182 */
      {		/* Ast/glo-decl.scm 182 */
	 global_bglt aux_1647;
	 aux_1647 =
	    declare_global_scnst__70_ast_glo_decl_237(id_1400, module_1401, import_1402, node_1403, class_1404, loc_1405);
	 return
	    (obj_t) (aux_1647);
      }
   }
}



/* declare-global-cfun! */
global_bglt 
declare_global_cfun__81_ast_glo_decl_237(obj_t id_17, obj_t name_18, obj_t tres_id_18_19, obj_t targs_id_78_20, bool_t infix__163_21, bool_t macro__33_22, obj_t src_exp_176_23)
{
   AN_OBJECT;
   {	/* Ast/glo-decl.scm 209 */
      {		/* Ast/glo-decl.scm 210 */
	 int arity_814;
	 arity_814 =
	    arity_tools_args(targs_id_78_20);
	 {	/* Ast/glo-decl.scm 210 */
	    obj_t loc_815;
	    loc_815 =
	       find_location_120_tools_location(src_exp_176_23);
	    {	/* Ast/glo-decl.scm 211 */
	       type_bglt type_res_48_816;
	       type_res_48_816 =
		  use_foreign_type__12_type_env(tres_id_18_19, loc_815);
	       {	/* Ast/glo-decl.scm 212 */
		  obj_t type_args_244_817;
		  {	/* Ast/glo-decl.scm 213 */
		     obj_t l1443_824;
		     l1443_824 =
			args___args_list_50_tools_args(targs_id_78_20);
		     if (
			NULLP(l1443_824))
		       {	/* Ast/glo-decl.scm 213 */
			  type_args_244_817 = BNIL;
		       }
		     else
		       {	/* Ast/glo-decl.scm 213 */
			  obj_t head1445_826;
			  head1445_826 =
			     MAKE_PAIR(BNIL, BNIL);
			  {
			     obj_t l1443_827;
			     obj_t tail1446_828;
			     l1443_827 = l1443_824;
			     tail1446_828 = head1445_826;
			   lname1444_829:
			     if (
				NULLP(l1443_827))
			       {	/* Ast/glo-decl.scm 213 */
				  type_args_244_817 =
				     CDR(head1445_826);
			       }
			     else
			       {	/* Ast/glo-decl.scm 214 */
				  obj_t newtail1447_831;
				  {	/* Ast/glo-decl.scm 214 */
				     type_bglt arg1514_833;
				     arg1514_833 =
					use_foreign_type__12_type_env(
					CAR(l1443_827), loc_815);
				     {	/* ./Ieee/pair-list.scm 5689 */
					obj_t aux_1662;
					aux_1662 =
					   (obj_t) (arg1514_833);
					newtail1447_831 =
					   MAKE_PAIR(aux_1662, BNIL);
				     }
				  }
				  SET_CDR(tail1446_828, newtail1447_831);
				  {
				     obj_t tail1446_1668;
				     obj_t l1443_1666;
				     l1443_1666 =
					CDR(l1443_827);
				     tail1446_1668 = newtail1447_831;
				     tail1446_828 = tail1446_1668;
				     l1443_827 = l1443_1666;
				     goto lname1444_829;
				  }
			       }
			  }
		       }
		  }
		  {	/* Ast/glo-decl.scm 213 */
		     cfun_bglt cfun_818;
		     {	/* Ast/glo-decl.scm 216 */
			cfun_bglt res1600_1321;
			{	/* Ast/glo-decl.scm 216 */
			   long arity_1299;
			   obj_t predicate_of_78_1301;
			   obj_t stack_allocator_172_1302;
			   arity_1299 =
			      (long) (arity_814);
			   predicate_of_78_1301 = BFALSE;
			   stack_allocator_172_1302 = BFALSE;
			   {	/* ./Ast/var.scm 1105 */
			      cfun_bglt new1148_1308;
			      new1148_1308 =
				 ((cfun_bglt) BREF(GC_MALLOC(sizeof(struct cfun))));
			      {		/* ./Ast/var.scm 1105 */
				 long arg1582_1309;
				 arg1582_1309 =
				    class_num_218___object(cfun_ast_var);
				 {	/* ./Ast/var.scm 1105 */
				    obj_t obj_1319;
				    obj_1319 =
				       (obj_t) (new1148_1308);
				    (((obj_t) CREF(obj_1319))->header = MAKE_HEADER(arg1582_1309, 0), BUNSPEC);
				 }
			      }
			      {		/* ./Ast/var.scm 1105 */
				 object_bglt aux_1674;
				 aux_1674 =
				    (object_bglt) (new1148_1308);
				 OBJECT_WIDENING_SET(aux_1674, predicate_of_78_1301);
			      }
			      ((((cfun_bglt) CREF(new1148_1308))->arity) = ((long) arity_1299), BUNSPEC);
			      ((((cfun_bglt) CREF(new1148_1308))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
			      ((((cfun_bglt) CREF(new1148_1308))->predicate_of_78) = ((obj_t) predicate_of_78_1301), BUNSPEC);
			      ((((cfun_bglt) CREF(new1148_1308))->stack_allocator_172) = ((obj_t) stack_allocator_172_1302), BUNSPEC);
			      ((((cfun_bglt) CREF(new1148_1308))->top__138) = ((bool_t) ((bool_t) 1)), BUNSPEC);
			      ((((cfun_bglt) CREF(new1148_1308))->the_closure_238) = ((obj_t) BUNSPEC), BUNSPEC);
			      ((((cfun_bglt) CREF(new1148_1308))->args_type_205) = ((obj_t) type_args_244_817), BUNSPEC);
			      ((((cfun_bglt) CREF(new1148_1308))->macro__33) = ((bool_t) macro__33_22), BUNSPEC);
			      ((((cfun_bglt) CREF(new1148_1308))->infix__163) = ((bool_t) infix__163_21), BUNSPEC);
			      res1600_1321 = new1148_1308;
			   }
			}
			cfun_818 = res1600_1321;
		     }
		     {	/* Ast/glo-decl.scm 216 */
			global_bglt global_819;
			global_819 =
			   bind_global__138_ast_env(id_17,
			   CNST_TABLE_REF(((long) 8)),
			   (value_bglt) (cfun_818),
			   CNST_TABLE_REF(((long) 8)), src_exp_176_23);
			{	/* Ast/glo-decl.scm 220 */

			   ((((global_bglt) CREF(global_819))->name) = ((obj_t) name_18), BUNSPEC);
			   ((((global_bglt) CREF(global_819))->type) = ((type_bglt) type_res_48_816), BUNSPEC);
			   ((((global_bglt) CREF(global_819))->evaluable__248) = ((bool_t) ((bool_t) 0)), BUNSPEC);
			   return global_819;
			}
		     }
		  }
	       }
	    }
	 }
      }
   }
}



/* _declare-global-cfun!1605 */
obj_t 
_declare_global_cfun_1605_187_ast_glo_decl_237(obj_t env_1406, obj_t id_1407, obj_t name_1408, obj_t tres_id_18_1409, obj_t targs_id_78_1410, obj_t infix__163_1411, obj_t macro__33_1412, obj_t src_exp_176_1413)
{
   AN_OBJECT;
   {	/* Ast/glo-decl.scm 209 */
      {		/* Ast/glo-decl.scm 209 */
	 global_bglt aux_1693;
	 aux_1693 =
	    declare_global_cfun__81_ast_glo_decl_237(id_1407, name_1408, tres_id_18_1409, targs_id_78_1410,
	    CBOOL(infix__163_1411),
	    CBOOL(macro__33_1412), src_exp_176_1413);
	 return
	    (obj_t) (aux_1693);
      }
   }
}



/* declare-global-cvar! */
global_bglt 
declare_global_cvar__13_ast_glo_decl_237(obj_t id_24, obj_t name_25, obj_t type_id_229_26, bool_t macro__33_27, obj_t src_exp_176_28)
{
   AN_OBJECT;
   {	/* Ast/glo-decl.scm 233 */
      {		/* Ast/glo-decl.scm 234 */
	 obj_t loc_836;
	 loc_836 =
	    find_location_120_tools_location(src_exp_176_28);
	 {	/* Ast/glo-decl.scm 234 */
	    type_bglt type_837;
	    type_837 =
	       use_foreign_type__12_type_env(type_id_229_26, loc_836);
	    {	/* Ast/glo-decl.scm 235 */
	       cvar_bglt cvar_838;
	       {	/* Ast/glo-decl.scm 236 */
		  cvar_bglt res1601_1334;
		  {	/* ./Ast/var.scm 1129 */
		     cvar_bglt new1173_1329;
		     new1173_1329 =
			((cvar_bglt) BREF(GC_MALLOC(sizeof(struct cvar))));
		     {	/* ./Ast/var.scm 1129 */
			long arg1576_1330;
			arg1576_1330 =
			   class_num_218___object(cvar_ast_var);
			{	/* ./Ast/var.scm 1129 */
			   obj_t obj_1332;
			   obj_1332 =
			      (obj_t) (new1173_1329);
			   (((obj_t) CREF(obj_1332))->header = MAKE_HEADER(arg1576_1330, 0), BUNSPEC);
			}
		     }
		     {	/* ./Ast/var.scm 1129 */
			object_bglt aux_1704;
			aux_1704 =
			   (object_bglt) (new1173_1329);
			OBJECT_WIDENING_SET(aux_1704, BFALSE);
		     }
		     ((((cvar_bglt) CREF(new1173_1329))->macro__33) = ((bool_t) macro__33_27), BUNSPEC);
		     res1601_1334 = new1173_1329;
		  }
		  cvar_838 = res1601_1334;
	       }
	       {	/* Ast/glo-decl.scm 236 */
		  global_bglt global_839;
		  global_839 =
		     bind_global__138_ast_env(id_24,
		     CNST_TABLE_REF(((long) 8)),
		     (value_bglt) (cvar_838),
		     CNST_TABLE_REF(((long) 8)), src_exp_176_28);
		  {	/* Ast/glo-decl.scm 237 */

		     ((((global_bglt) CREF(global_839))->name) = ((obj_t) name_25), BUNSPEC);
		     ((((global_bglt) CREF(global_839))->type) = ((type_bglt) type_837), BUNSPEC);
		     ((((global_bglt) CREF(global_839))->evaluable__248) = ((bool_t) ((bool_t) 0)), BUNSPEC);
		     return global_839;
		  }
	       }
	    }
	 }
      }
   }
}



/* _declare-global-cvar!1606 */
obj_t 
_declare_global_cvar_1606_66_ast_glo_decl_237(obj_t env_1414, obj_t id_1415, obj_t name_1416, obj_t type_id_229_1417, obj_t macro__33_1418, obj_t src_exp_176_1419)
{
   AN_OBJECT;
   {	/* Ast/glo-decl.scm 233 */
      {		/* Ast/glo-decl.scm 233 */
	 global_bglt aux_1715;
	 aux_1715 =
	    declare_global_cvar__13_ast_glo_decl_237(id_1415, name_1416, type_id_229_1417,
	    CBOOL(macro__33_1418), src_exp_176_1419);
	 return
	    (obj_t) (aux_1715);
      }
   }
}



/* method-init */
obj_t 
method_init_76_ast_glo_decl_237()
{
   AN_OBJECT;
   {	/* Ast/glo-decl.scm 17 */
      return BUNSPEC;
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_ast_glo_decl_237()
{
   AN_OBJECT;
   {	/* Ast/glo-decl.scm 17 */
      module_initialization_70_tools_trace(((long) 0), "AST_GLO-DECL");
      module_initialization_70_tools_error(((long) 0), "AST_GLO-DECL");
      module_initialization_70_tools_args(((long) 0), "AST_GLO-DECL");
      module_initialization_70_tools_shape(((long) 0), "AST_GLO-DECL");
      module_initialization_70_tools_dsssl(((long) 0), "AST_GLO-DECL");
      module_initialization_70_engine_param(((long) 0), "AST_GLO-DECL");
      module_initialization_70_type_type(((long) 0), "AST_GLO-DECL");
      module_initialization_70_type_cache(((long) 0), "AST_GLO-DECL");
      module_initialization_70_ast_var(((long) 0), "AST_GLO-DECL");
      module_initialization_70_ast_env(((long) 0), "AST_GLO-DECL");
      module_initialization_70_ast_ident(((long) 0), "AST_GLO-DECL");
      module_initialization_70_ast_node(((long) 0), "AST_GLO-DECL");
      module_initialization_70_type_env(((long) 0), "AST_GLO-DECL");
      module_initialization_70_module_module(((long) 0), "AST_GLO-DECL");
      return
	 module_initialization_70_tools_location(((long) 0), "AST_GLO-DECL");
   }
}
