/*===========================================================================*/
/*   (Ast/glo-def.scm)                                                       */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;

typedef struct tclass
  {
     obj_t its_super_214;
     obj_t slots;
     struct global *holder;
     obj_t widening;
     long depth;
     bool_t final__12;
     obj_t constructor;
     obj_t virtual_slots_number_200;
  }
      *tclass_bglt;


extern obj_t find_global_223_ast_env(obj_t, obj_t);
extern global_bglt declare_global_scnst__70_ast_glo_decl_237(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern global_bglt declare_global_sfun__255_ast_glo_decl_237(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t method_init_76_ast_glo_def_117();
extern obj_t find_global_module_25_ast_env(obj_t, obj_t);
extern obj_t string_append(obj_t, obj_t);
extern obj_t type_type_type;
static obj_t _check_method_definition_40_ast_glo_def_117(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t id_of_id_112_ast_ident(obj_t, obj_t);
extern obj_t leave_function_170_tools_error();
extern global_bglt def_global_scnst__93_ast_glo_def_117(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t _bdb_debug__1_engine_param;
extern obj_t global_ast_var;
extern obj_t _obj__252_type_cache;
extern obj_t user_error_151_tools_error(obj_t, obj_t, obj_t, obj_t);
extern bool_t type_subclass__90_object_class(type_bglt, type_bglt);
static bool_t compatible_type__151_ast_glo_def_117(bool_t, type_bglt, type_bglt);
extern type_bglt type_of_id_183_ast_ident(obj_t, obj_t);
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t dsssl_formals_encoding_15_tools_dsssl(obj_t);
extern obj_t module_initialization_70_ast_glo_def_117(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_ast_env(long, char *);
extern obj_t module_initialization_70_ast_ident(long, char *);
extern obj_t module_initialization_70_ast_glo_decl_237(long, char *);
extern obj_t module_initialization_70_ast_remove(long, char *);
extern obj_t module_initialization_70_type_env(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_tools_args(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_location(long, char *);
extern obj_t module_initialization_70_tools_dsssl(long, char *);
extern obj_t module_initialization_70_object_class(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70___error(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_equivalence_6_2(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t _warning__61___error;
static obj_t _def_global_sfun_no_warning__185_ast_glo_def_117(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern long list_length(obj_t);
extern obj_t svar_ast_var;
extern global_bglt def_global_sfun__93_ast_glo_def_117(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t remove_var_from__148_ast_remove(obj_t, variable_bglt);
static global_bglt check_sfun_definition_109_ast_glo_def_117(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t _def_global_scnst_1695_168_ast_glo_def_117(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t imported_modules_init_94_ast_glo_def_117();
static obj_t _def_global_svar_1696_203_ast_glo_def_117(obj_t, obj_t, obj_t, obj_t, obj_t);
static global_bglt mismatch_error_84_ast_glo_def_117(global_bglt, obj_t, obj_t);
static obj_t library_modules_init_112_ast_glo_def_117();
static global_bglt check_svar_definition_92_ast_glo_def_117(obj_t, obj_t, obj_t);
extern global_bglt declare_global_svar__200_ast_glo_decl_237(obj_t, obj_t, obj_t, obj_t);
extern bool_t check_method_definition_71_ast_glo_def_117(obj_t, obj_t, obj_t, obj_t);
extern obj_t open_input_string(obj_t);
extern obj_t sfun_ast_var;
extern int arity_tools_args(obj_t);
extern obj_t parse_id_241_ast_ident(obj_t, obj_t);
extern obj_t tclass_object_class;
static obj_t _def_global_sfun_1694_30_ast_glo_def_117(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t enter_function_81_tools_error(obj_t);
extern obj_t local_ast_var;
extern obj_t shape_tools_shape(obj_t);
extern global_bglt def_global_sfun_no_warning__10_ast_glo_def_117(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t internal_error_43_tools_error(obj_t, obj_t, obj_t);
extern obj_t read___reader(obj_t);
extern global_bglt def_global_svar__184_ast_glo_def_117(obj_t, obj_t, obj_t, obj_t);
extern obj_t find_location_120_tools_location(obj_t);
extern bool_t equal__25___r4_equivalence_6_2(obj_t, obj_t);
extern obj_t ____74_type_cache;
static obj_t require_initialization_114_ast_glo_def_117 = BUNSPEC;
static obj_t cnst_init_137_ast_glo_def_117();
static obj_t __cnst[5];

DEFINE_EXPORT_PROCEDURE(def_global_svar__env_161_ast_glo_def_117, _def_global_svar_1696_203_ast_glo_def_1171712, _def_global_svar_1696_203_ast_glo_def_117, 0L, 4);
DEFINE_EXPORT_PROCEDURE(def_global_scnst__env_209_ast_glo_def_117, _def_global_scnst_1695_168_ast_glo_def_1171713, _def_global_scnst_1695_168_ast_glo_def_117, 0L, 5);
DEFINE_EXPORT_PROCEDURE(def_global_sfun__env_209_ast_glo_def_117, _def_global_sfun_1694_30_ast_glo_def_1171714, _def_global_sfun_1694_30_ast_glo_def_117, 0L, 8);
DEFINE_EXPORT_PROCEDURE(check_method_definition_env_136_ast_glo_def_117, _check_method_definition_40_ast_glo_def_1171715, _check_method_definition_40_ast_glo_def_117, 0L, 4);
DEFINE_EXPORT_PROCEDURE(def_global_sfun_no_warning__env_71_ast_glo_def_117, _def_global_sfun_no_warning__185_ast_glo_def_1171716, _def_global_sfun_no_warning__185_ast_glo_def_117, 0L, 8);
DEFINE_STRING(string1699_ast_glo_def_117, string1699_ast_glo_def_1171717, "(incompatible formal type)", 26);
DEFINE_STRING(string1698_ast_glo_def_117, string1698_ast_glo_def_1171718, "unexpected generic arg", 22);
DEFINE_STRING(string1697_ast_glo_def_117, string1697_ast_glo_def_1171719, "check-method-definition", 23);
DEFINE_STRING(string1707_ast_glo_def_117, string1707_ast_glo_def_1171720, "BIGLOO NOW SGFUN STATIC EXPORT ", 31);
DEFINE_STRING(string1706_ast_glo_def_117, string1706_ast_glo_def_1171721, "Prototype and definition don't match", 36);
DEFINE_STRING(string1705_ast_glo_def_117, string1705_ast_glo_def_1171722, " ", 1);
DEFINE_STRING(string1704_ast_glo_def_117, string1704_ast_glo_def_1171723, "(incompatible variable type)", 28);
DEFINE_STRING(string1703_ast_glo_def_117, string1703_ast_glo_def_1171724, "Illegal type for global variable", 32);
DEFINE_STRING(string1702_ast_glo_def_117, string1702_ast_glo_def_1171725, "(arity differs)", 15);
DEFINE_STRING(string1701_ast_glo_def_117, string1701_ast_glo_def_1171726, "(incompatible function type result)", 35);
DEFINE_STRING(string1700_ast_glo_def_117, string1700_ast_glo_def_1171727, "(incompatible Dsssl prototype)", 30);



/* module-initialization */
obj_t 
module_initialization_70_ast_glo_def_117(long checksum_1601, char *from_1602)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_ast_glo_def_117))
	{
	   require_initialization_114_ast_glo_def_117 =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_ast_glo_def_117();
	   cnst_init_137_ast_glo_def_117();
	   imported_modules_init_94_ast_glo_def_117();
	   method_init_76_ast_glo_def_117();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_ast_glo_def_117()
{
   AN_OBJECT;
   {	/* Ast/glo-def.scm 15 */
      module_initialization_70___object(((long) 0), "AST_GLO-DEF");
      module_initialization_70___error(((long) 0), "AST_GLO-DEF");
      module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "AST_GLO-DEF");
      module_initialization_70___reader(((long) 0), "AST_GLO-DEF");
      module_initialization_70___r4_equivalence_6_2(((long) 0), "AST_GLO-DEF");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_ast_glo_def_117()
{
   AN_OBJECT;
   {	/* Ast/glo-def.scm 15 */
      {		/* Ast/glo-def.scm 15 */
	 obj_t cnst_port_138_1594;
	 cnst_port_138_1594 =
	    open_input_string(string1707_ast_glo_def_117);
	 {
	    long i_1595;
	    i_1595 = ((long) 4);
	  loop_1596:
	    {	/* Ast/glo-def.scm 15 */
	       bool_t test1708_1597;
	       test1708_1597 =
		  (i_1595 == ((long) -1));
	       if (test1708_1597)
		 {	/* Ast/glo-def.scm 15 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Ast/glo-def.scm 15 */
		    {	/* Ast/glo-def.scm 15 */
		       obj_t arg1709_1598;
		       {	/* Ast/glo-def.scm 15 */
			  obj_t list1710_1599;
			  list1710_1599 =
			     MAKE_PAIR(cnst_port_138_1594, BNIL);
			  arg1709_1598 =
			     read___reader(list1710_1599);
		       }
		       CNST_TABLE_SET(i_1595, arg1709_1598);
		    }
		    {	/* Ast/glo-def.scm 15 */
		       int aux_1600;
		       {	/* Ast/glo-def.scm 15 */
			  long aux_1621;
			  aux_1621 =
			     (i_1595 - ((long) 1));
			  aux_1600 =
			     (int) (aux_1621);
		       }
		       {
			  long i_1624;
			  i_1624 =
			     (long) (aux_1600);
			  i_1595 = i_1624;
			  goto loop_1596;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* def-global-sfun-no-warning! */
global_bglt 
def_global_sfun_no_warning__10_ast_glo_def_117(obj_t id_1, obj_t args_2, obj_t loc_3, obj_t mod_4, obj_t class_5, obj_t src_exp_176_6, obj_t rem_7, obj_t node_8)
{
   AN_OBJECT;
   {	/* Ast/glo-def.scm 66 */
      {		/* Ast/glo-def.scm 67 */
	 obj_t warning_1360;
	 warning_1360 = _warning__61___error;
	 _warning__61___error = BFALSE;
	 {	/* Ast/glo-def.scm 69 */
	    global_bglt fun_1361;
	    fun_1361 =
	       def_global_sfun__93_ast_glo_def_117(id_1, args_2, loc_3, mod_4, class_5, src_exp_176_6, rem_7, node_8);
	    _warning__61___error = warning_1360;
	    return fun_1361;
	 }
      }
   }
}



/* _def-global-sfun-no-warning! */
obj_t 
_def_global_sfun_no_warning__185_ast_glo_def_117(obj_t env_1560, obj_t id_1561, obj_t args_1562, obj_t loc_1563, obj_t mod_1564, obj_t class_1565, obj_t src_exp_176_1566, obj_t rem_1567, obj_t node_1568)
{
   AN_OBJECT;
   {	/* Ast/glo-def.scm 66 */
      {		/* Ast/glo-def.scm 66 */
	 global_bglt aux_1627;
	 aux_1627 =
	    def_global_sfun_no_warning__10_ast_glo_def_117(id_1561, args_1562, loc_1563, mod_1564, class_1565, src_exp_176_1566, rem_1567, node_1568);
	 return
	    (obj_t) (aux_1627);
      }
   }
}



/* def-global-sfun! */
global_bglt 
def_global_sfun__93_ast_glo_def_117(obj_t id_9, obj_t args_10, obj_t locals_11, obj_t module_12, obj_t class_13, obj_t src_exp_176_14, obj_t rem_15, obj_t node_16)
{
   AN_OBJECT;
   {	/* Ast/glo-def.scm 79 */
      enter_function_81_tools_error(id_9);
      {		/* Ast/glo-def.scm 85 */
	 obj_t loc_827;
	 loc_827 =
	    find_location_120_tools_location(src_exp_176_14);
	 {	/* Ast/glo-def.scm 85 */
	    obj_t id_type_89_828;
	    id_type_89_828 =
	       parse_id_241_ast_ident(id_9, loc_827);
	    {	/* Ast/glo-def.scm 86 */
	       obj_t type_res_48_829;
	       type_res_48_829 =
		  CDR(id_type_89_828);
	       {	/* Ast/glo-def.scm 87 */
		  obj_t id_830;
		  id_830 =
		     CAR(id_type_89_828);
		  {	/* Ast/glo-def.scm 88 */
		     obj_t import_831;
		     {	/* Ast/glo-def.scm 89 */
			bool_t test1517_871;
			{	/* Ast/glo-def.scm 89 */
			   long n1_1364;
			   n1_1364 =
			      (long) CINT(_bdb_debug__1_engine_param);
			   test1517_871 =
			      (n1_1364 >= ((long) 3));
			}
			if (test1517_871)
			  {	/* Ast/glo-def.scm 89 */
			     import_831 =
				CNST_TABLE_REF(((long) 0));
			  }
			else
			  {	/* Ast/glo-def.scm 89 */
			     import_831 =
				CNST_TABLE_REF(((long) 1));
			  }
		     }
		     {	/* Ast/glo-def.scm 89 */
			obj_t old_global_82_832;
			old_global_82_832 =
			   find_global_module_25_ast_env(id_830, module_12);
			{	/* Ast/glo-def.scm 92 */
			   global_bglt global_833;
			   {	/* Ast/glo-def.scm 94 */
			      bool_t test1516_870;
			      test1516_870 =
				 is_a__118___object(old_global_82_832, global_ast_var);
			      if (test1516_870)
				{	/* Ast/glo-def.scm 94 */
				   global_833 =
				      check_sfun_definition_109_ast_glo_def_117(old_global_82_832, type_res_48_829, args_10, locals_11, class_13, src_exp_176_14);
				}
			      else
				{	/* Ast/glo-def.scm 94 */
				   global_833 =
				      declare_global_sfun__255_ast_glo_decl_237(id_830, args_10, module_12, import_831, class_13, src_exp_176_14);
				}
			   }
			   {	/* Ast/glo-def.scm 93 */
			      obj_t def_loc_185_834;
			      def_loc_185_834 =
				 find_location_120_tools_location(src_exp_176_14);
			      {		/* Ast/glo-def.scm 108 */

				 {	/* Ast/glo-def.scm 110 */
				    variable_bglt var_1367;
				    type_bglt new_type_21_1368;
				    var_1367 =
				       (variable_bglt) (global_833);
				    new_type_21_1368 =
				       (type_bglt) (type_res_48_829);
				    {	/* Ast/glo-def.scm 292 */
				       bool_t test1584_1370;
				       {	/* Ast/glo-def.scm 292 */
					  obj_t obj2_1373;
					  obj2_1373 = ____74_type_cache;
					  {	/* ./Ieee/equiv.scm 5508 */
					     obj_t aux_1648;
					     {	/* Ast/glo-def.scm 292 */
						type_bglt aux_1649;
						aux_1649 =
						   (((variable_bglt) CREF(var_1367))->type);
						aux_1648 =
						   (obj_t) (aux_1649);
					     }
					     test1584_1370 =
						(aux_1648 == obj2_1373);
					  }
				       }
				       if (test1584_1370)
					 {	/* Ast/glo-def.scm 292 */
					    ((((variable_bglt) CREF(var_1367))->type) = ((type_bglt) new_type_21_1368), BUNSPEC);
					 }
				       else
					 {	/* Ast/glo-def.scm 292 */
					    BUNSPEC;
					 }
				    }
				 }
				 {	/* Ast/glo-def.scm 112 */
				    bool_t test_1655;
				    {	/* ./Ieee/fixnum.scm 7109 */
				       long aux_1658;
				       long aux_1656;
				       {	/* Ast/glo-def.scm 112 */
					  obj_t aux_1659;
					  {	/* Ast/glo-def.scm 112 */
					     sfun_bglt obj_1377;
					     {	/* Ast/glo-def.scm 112 */
						value_bglt aux_1660;
						aux_1660 =
						   (((global_bglt) CREF(global_833))->value);
						obj_1377 =
						   (sfun_bglt) (aux_1660);
					     }
					     aux_1659 =
						(((sfun_bglt) CREF(obj_1377))->args);
					  }
					  aux_1658 =
					     list_length(aux_1659);
				       }
				       aux_1656 =
					  list_length(locals_11);
				       test_1655 =
					  (aux_1656 == aux_1658);
				    }
				    if (test_1655)
				      {		/* Ast/glo-def.scm 113 */
					 obj_t types_836;
					 {	/* Ast/glo-def.scm 113 */
					    obj_t l1466_845;
					    {	/* Ast/glo-def.scm 124 */
					       sfun_bglt obj_1381;
					       {	/* Ast/glo-def.scm 124 */
						  value_bglt aux_1666;
						  aux_1666 =
						     (((global_bglt) CREF(global_833))->value);
						  obj_1381 =
						     (sfun_bglt) (aux_1666);
					       }
					       l1466_845 =
						  (((sfun_bglt) CREF(obj_1381))->args);
					    }
					    if (
					       NULLP(l1466_845))
					      {		/* Ast/glo-def.scm 113 */
						 types_836 = BNIL;
					      }
					    else
					      {		/* Ast/glo-def.scm 113 */
						 obj_t head1468_847;
						 head1468_847 =
						    MAKE_PAIR(BNIL, BNIL);
						 {
						    obj_t l1466_848;
						    obj_t tail1469_849;
						    l1466_848 = l1466_845;
						    tail1469_849 = head1468_847;
						  lname1467_850:
						    if (
						       NULLP(l1466_848))
						      {		/* Ast/glo-def.scm 113 */
							 types_836 =
							    CDR(head1468_847);
						      }
						    else
						      {		/* Ast/glo-def.scm 115 */
							 obj_t newtail1470_852;
							 {	/* Ast/glo-def.scm 115 */
							    obj_t arg1500_854;
							    {	/* Ast/glo-def.scm 115 */
							       obj_t a_856;
							       a_856 =
								  CAR(l1466_848);
							       {	/* Ast/glo-def.scm 115 */
								  bool_t test1502_857;
								  test1502_857 =
								     is_a__118___object(a_856, local_ast_var);
								  if (test1502_857)
								    {	/* Ast/glo-def.scm 115 */
								       {	/* Ast/glo-def.scm 116 */
									  local_bglt obj_1389;
									  obj_1389 =
									     (local_bglt) (a_856);
									  {	/* ./Ast/var.scm 738 */
									     type_bglt aux_1680;
									     aux_1680 =
										(((local_bglt) CREF(obj_1389))->type);
									     arg1500_854 =
										(obj_t) (aux_1680);
									  }
								       }
								    }
								  else
								    {	/* Ast/glo-def.scm 117 */
								       bool_t test1503_858;
								       test1503_858 =
									  is_a__118___object(a_856, type_type_type);
								       if (test1503_858)
									 {	/* Ast/glo-def.scm 117 */
									    arg1500_854 = a_856;
									 }
								       else
									 {	/* Ast/glo-def.scm 117 */
									    {	/* Ast/glo-def.scm 120 */
									       obj_t arg1506_861;
									       arg1506_861 =
										  shape_tools_shape(a_856);
									       arg1500_854 =
										  internal_error_43_tools_error(string1697_ast_glo_def_117, string1698_ast_glo_def_117, arg1506_861);
									    }
									 }
								    }
							       }
							    }
							    newtail1470_852 =
							       MAKE_PAIR(arg1500_854, BNIL);
							 }
							 SET_CDR(tail1469_849, newtail1470_852);
							 {
							    obj_t tail1469_1691;
							    obj_t l1466_1689;
							    l1466_1689 =
							       CDR(l1466_848);
							    tail1469_1691 = newtail1470_852;
							    tail1469_849 = tail1469_1691;
							    l1466_848 = l1466_1689;
							    goto lname1467_850;
							 }
						      }
						 }
					      }
					 }
					 {
					    obj_t ll1471_837;
					    obj_t ll1472_838;
					    {	/* Ast/glo-def.scm 125 */
					       bool_t aux_1692;
					       ll1471_837 = locals_11;
					       ll1472_838 = types_836;
					     lname1473_839:
					       if (
						  NULLP(ll1471_837))
						 {	/* Ast/glo-def.scm 125 */
						    aux_1692 = ((bool_t) 1)
						       ;
						 }
					       else
						 {	/* Ast/glo-def.scm 125 */
						    {	/* Ast/glo-def.scm 125 */
						       variable_bglt var_1399;
						       type_bglt new_type_21_1400;
						       {	/* Ast/glo-def.scm 125 */
							  obj_t aux_1695;
							  aux_1695 =
							     CAR(ll1471_837);
							  var_1399 =
							     (variable_bglt) (aux_1695);
						       }
						       {	/* Ast/glo-def.scm 125 */
							  obj_t aux_1698;
							  aux_1698 =
							     CAR(ll1472_838);
							  new_type_21_1400 =
							     (type_bglt) (aux_1698);
						       }
						       {	/* Ast/glo-def.scm 292 */
							  bool_t test1584_1402;
							  {	/* Ast/glo-def.scm 292 */
							     obj_t obj2_1405;
							     obj2_1405 = ____74_type_cache;
							     {	/* ./Ieee/equiv.scm 5508 */
								obj_t aux_1701;
								{	/* Ast/glo-def.scm 292 */
								   type_bglt aux_1702;
								   aux_1702 =
								      (((variable_bglt) CREF(var_1399))->type);
								   aux_1701 =
								      (obj_t) (aux_1702);
								}
								test1584_1402 =
								   (aux_1701 == obj2_1405);
							     }
							  }
							  if (test1584_1402)
							    {	/* Ast/glo-def.scm 292 */
							       ((((variable_bglt) CREF(var_1399))->type) = ((type_bglt) new_type_21_1400), BUNSPEC);
							    }
							  else
							    {	/* Ast/glo-def.scm 292 */
							       BUNSPEC;
							    }
						       }
						    }
						    {
						       obj_t ll1472_1710;
						       obj_t ll1471_1708;
						       ll1471_1708 =
							  CDR(ll1471_837);
						       ll1472_1710 =
							  CDR(ll1472_838);
						       ll1472_838 = ll1472_1710;
						       ll1471_837 = ll1471_1708;
						       goto lname1473_839;
						    }
						 }
					       BBOOL(aux_1692);
					    }
					 }
				      }
				    else
				      {		/* Ast/glo-def.scm 112 */
					 BUNSPEC;
				      }
				 }
				 remove_var_from__148_ast_remove(rem_15,
				    (variable_bglt) (global_833));
				 {	/* Ast/glo-def.scm 129 */
				    sfun_bglt obj_1411;
				    {	/* Ast/glo-def.scm 129 */
				       value_bglt aux_1715;
				       aux_1715 =
					  (((global_bglt) CREF(global_833))->value);
				       obj_1411 =
					  (sfun_bglt) (aux_1715);
				    }
				    ((((sfun_bglt) CREF(obj_1411))->body) = ((obj_t) node_16), BUNSPEC);
				 }
				 {	/* Ast/glo-def.scm 131 */
				    sfun_bglt obj_1414;
				    {	/* Ast/glo-def.scm 131 */
				       value_bglt aux_1719;
				       aux_1719 =
					  (((global_bglt) CREF(global_833))->value);
				       obj_1414 =
					  (sfun_bglt) (aux_1719);
				    }
				    ((((sfun_bglt) CREF(obj_1414))->args) = ((obj_t) locals_11), BUNSPEC);
				 }
				 {	/* Ast/glo-def.scm 133 */
				    sfun_bglt obj_1417;
				    {	/* Ast/glo-def.scm 133 */
				       value_bglt aux_1723;
				       aux_1723 =
					  (((global_bglt) CREF(global_833))->value);
				       obj_1417 =
					  (sfun_bglt) (aux_1723);
				    }
				    ((((sfun_bglt) CREF(obj_1417))->loc) = ((obj_t) def_loc_185_834), BUNSPEC);
				 }
				 leave_function_170_tools_error();
				 return global_833;
			      }
			   }
			}
		     }
		  }
	       }
	    }
	 }
      }
   }
}



/* _def-global-sfun!1694 */
obj_t 
_def_global_sfun_1694_30_ast_glo_def_117(obj_t env_1569, obj_t id_1570, obj_t args_1571, obj_t locals_1572, obj_t module_1573, obj_t class_1574, obj_t src_exp_176_1575, obj_t rem_1576, obj_t node_1577)
{
   AN_OBJECT;
   {	/* Ast/glo-def.scm 79 */
      {		/* Ast/glo-def.scm 79 */
	 global_bglt aux_1728;
	 aux_1728 =
	    def_global_sfun__93_ast_glo_def_117(id_1570, args_1571, locals_1572, module_1573, class_1574, src_exp_176_1575, rem_1576, node_1577);
	 return
	    (obj_t) (aux_1728);
      }
   }
}



/* check-sfun-definition */
global_bglt 
check_sfun_definition_109_ast_glo_def_117(obj_t old_17, obj_t type_res_48_18, obj_t args_19, obj_t locals_20, obj_t class_21, obj_t src_exp_176_22)
{
   AN_OBJECT;
   {	/* Ast/glo-def.scm 141 */
      {		/* Ast/glo-def.scm 144 */
	 value_bglt old_value_175_872;
	 {	/* Ast/glo-def.scm 144 */
	    global_bglt obj_1419;
	    obj_1419 =
	       (global_bglt) (old_17);
	    old_value_175_872 =
	       (((global_bglt) CREF(obj_1419))->value);
	 }
	 {	/* Ast/glo-def.scm 146 */
	    bool_t test1518_873;
	    test1518_873 =
	       is_a__118___object(
	       (obj_t) (old_value_175_872), sfun_ast_var);
	    if (test1518_873)
	      {		/* Ast/glo-def.scm 148 */
		 bool_t test_1736;
		 {	/* ./Ieee/equiv.scm 5508 */
		    obj_t aux_1737;
		    {	/* Ast/glo-def.scm 148 */
		       sfun_bglt obj_1421;
		       obj_1421 =
			  (sfun_bglt) (old_value_175_872);
		       aux_1737 =
			  (((sfun_bglt) CREF(obj_1421))->class);
		    }
		    test_1736 =
		       (aux_1737 == class_21);
		 }
		 if (test_1736)
		   {	/* Ast/glo-def.scm 150 */
		      bool_t test1520_875;
		      {		/* Ast/glo-def.scm 150 */
			 long arg1553_917;
			 int arg1555_918;
			 {	/* Ast/glo-def.scm 150 */
			    sfun_bglt obj_1424;
			    obj_1424 =
			       (sfun_bglt) (old_value_175_872);
			    arg1553_917 =
			       (((sfun_bglt) CREF(obj_1424))->arity);
			 }
			 arg1555_918 =
			    arity_tools_args(args_19);
			 {	/* ./Ieee/fixnum.scm 7109 */
			    long aux_1744;
			    aux_1744 =
			       (long) (arg1555_918);
			    test1520_875 =
			       (arg1553_917 == aux_1744);
			 }
		      }
		      if (test1520_875)
			{	/* Ast/glo-def.scm 152 */
			   bool_t test1521_876;
			   {	/* Ast/glo-def.scm 152 */
			      type_bglt aux_1752;
			      bool_t aux_1748;
			      {		/* Ast/glo-def.scm 154 */
				 global_bglt obj_1429;
				 obj_1429 =
				    (global_bglt) (old_17);
				 aux_1752 =
				    (((global_bglt) CREF(obj_1429))->type);
			      }
			      {		/* ./Ieee/equiv.scm 5508 */
				 obj_t aux_1749;
				 aux_1749 =
				    CNST_TABLE_REF(((long) 2));
				 aux_1748 =
				    (aux_1749 == class_21);
			      }
			      test1521_876 =
				 compatible_type__151_ast_glo_def_117(aux_1748,
				 (type_bglt) (type_res_48_18), aux_1752);
			   }
			   if (test1521_876)
			     {	/* Ast/glo-def.scm 158 */
				bool_t test1522_877;
				{	/* Ast/glo-def.scm 158 */
				   obj_t arg1547_911;
				   obj_t arg1548_912;
				   {	/* Ast/glo-def.scm 158 */
				      sfun_bglt obj_1430;
				      obj_1430 =
					 (sfun_bglt) (old_value_175_872);
				      arg1547_911 =
					 (((sfun_bglt) CREF(obj_1430))->dsssl_keywords_243);
				   }
				   arg1548_912 =
				      dsssl_formals_encoding_15_tools_dsssl(args_19);
				   test1522_877 =
				      equal__25___r4_equivalence_6_2(arg1547_911, arg1548_912);
				}
				if (test1522_877)
				  {	/* Ast/glo-def.scm 161 */
				     obj_t _ortest_1474_878;
				     {
					obj_t locals_879;
					obj_t types_880;
					bool_t sub__142_881;
					{	/* Ast/glo-def.scm 162 */
					   obj_t arg1523_883;
					   bool_t arg1525_884;
					   {	/* Ast/glo-def.scm 162 */
					      obj_t l1475_885;
					      {		/* Ast/glo-def.scm 173 */
						 sfun_bglt obj_1431;
						 obj_1431 =
						    (sfun_bglt) (old_value_175_872);
						 l1475_885 =
						    (((sfun_bglt) CREF(obj_1431))->args);
					      }
					      if (
						 NULLP(l1475_885))
						{	/* Ast/glo-def.scm 162 */
						   arg1523_883 = BNIL;
						}
					      else
						{	/* Ast/glo-def.scm 162 */
						   obj_t head1477_887;
						   head1477_887 =
						      MAKE_PAIR(BNIL, BNIL);
						   {
						      obj_t l1475_888;
						      obj_t tail1478_889;
						      l1475_888 = l1475_885;
						      tail1478_889 = head1477_887;
						    lname1476_890:
						      if (
							 NULLP(l1475_888))
							{	/* Ast/glo-def.scm 162 */
							   arg1523_883 =
							      CDR(head1477_887);
							}
						      else
							{	/* Ast/glo-def.scm 164 */
							   obj_t newtail1479_892;
							   {	/* Ast/glo-def.scm 164 */
							      obj_t arg1529_894;
							      {		/* Ast/glo-def.scm 164 */
								 obj_t a_896;
								 a_896 =
								    CAR(l1475_888);
								 {	/* Ast/glo-def.scm 164 */
								    bool_t test1531_897;
								    test1531_897 =
								       is_a__118___object(a_896, local_ast_var);
								    if (test1531_897)
								      {		/* Ast/glo-def.scm 164 */
									 {	/* Ast/glo-def.scm 165 */
									    local_bglt obj_1439;
									    obj_1439 =
									       (local_bglt) (a_896);
									    {	/* ./Ast/var.scm 738 */
									       type_bglt aux_1775;
									       aux_1775 =
										  (((local_bglt) CREF(obj_1439))->type);
									       arg1529_894 =
										  (obj_t) (aux_1775);
									    }
									 }
								      }
								    else
								      {		/* Ast/glo-def.scm 166 */
									 bool_t test1532_898;
									 test1532_898 =
									    is_a__118___object(a_896, type_type_type);
									 if (test1532_898)
									   {	/* Ast/glo-def.scm 166 */
									      arg1529_894 = a_896;
									   }
									 else
									   {	/* Ast/glo-def.scm 166 */
									      {		/* Ast/glo-def.scm 169 */
										 obj_t arg1535_901;
										 arg1535_901 =
										    shape_tools_shape(a_896);
										 arg1529_894 =
										    internal_error_43_tools_error(string1697_ast_glo_def_117, string1698_ast_glo_def_117, arg1535_901);
									      }
									   }
								      }
								 }
							      }
							      newtail1479_892 =
								 MAKE_PAIR(arg1529_894, BNIL);
							   }
							   SET_CDR(tail1478_889, newtail1479_892);
							   {
							      obj_t tail1478_1786;
							      obj_t l1475_1784;
							      l1475_1784 =
								 CDR(l1475_888);
							      tail1478_1786 = newtail1479_892;
							      tail1478_889 = tail1478_1786;
							      l1475_888 = l1475_1784;
							      goto lname1476_890;
							   }
							}
						   }
						}
					   }
					   {	/* ./Ieee/equiv.scm 5508 */
					      obj_t aux_1787;
					      aux_1787 =
						 CNST_TABLE_REF(((long) 2));
					      arg1525_884 =
						 (aux_1787 == class_21);
					   }
					   locals_879 = locals_20;
					   types_880 = arg1523_883;
					   sub__142_881 = arg1525_884;
					 loop_882:
					   if (
					      NULLP(locals_879))
					     {	/* Ast/glo-def.scm 176 */
						{	/* Ast/glo-def.scm 179 */
						   global_bglt obj_1449;
						   obj_1449 =
						      (global_bglt) (old_17);
						   ((((global_bglt) CREF(obj_1449))->src) = ((obj_t) src_exp_176_22), BUNSPEC);
						}
						_ortest_1474_878 = old_17;
					     }
					   else
					     {	/* Ast/glo-def.scm 181 */
						bool_t test1537_903;
						{	/* Ast/glo-def.scm 181 */
						   type_bglt aux_1799;
						   type_bglt aux_1794;
						   {	/* Ast/glo-def.scm 181 */
						      obj_t aux_1800;
						      aux_1800 =
							 CAR(types_880);
						      aux_1799 =
							 (type_bglt) (aux_1800);
						   }
						   {	/* Ast/glo-def.scm 182 */
						      local_bglt obj_1452;
						      {		/* Ast/glo-def.scm 182 */
							 obj_t aux_1795;
							 aux_1795 =
							    CAR(locals_879);
							 obj_1452 =
							    (local_bglt) (aux_1795);
						      }
						      aux_1794 =
							 (((local_bglt) CREF(obj_1452))->type);
						   }
						   test1537_903 =
						      compatible_type__151_ast_glo_def_117(sub__142_881, aux_1794, aux_1799);
						}
						if (test1537_903)
						  {	/* Ast/glo-def.scm 181 */
						     {
							bool_t sub__142_1809;
							obj_t types_1807;
							obj_t locals_1805;
							locals_1805 =
							   CDR(locals_879);
							types_1807 =
							   CDR(types_880);
							sub__142_1809 = ((bool_t) 0);
							sub__142_881 = sub__142_1809;
							types_880 = types_1807;
							locals_879 = locals_1805;
							goto loop_882;
						     }
						  }
						else
						  {	/* Ast/glo-def.scm 181 */
						     {	/* Ast/glo-def.scm 184 */
							obj_t list1541_906;
							list1541_906 =
							   MAKE_PAIR(string1699_ast_glo_def_117, BNIL);
							{	/* Ast/glo-def.scm 184 */
							   global_bglt aux_1811;
							   aux_1811 =
							      mismatch_error_84_ast_glo_def_117(
							      (global_bglt) (old_17), src_exp_176_22, list1541_906);
							   _ortest_1474_878 =
							      (obj_t) (aux_1811);
							}
						     }
						  }
					     }
					}
				     }
				     if (
					CBOOL(_ortest_1474_878))
				       {	/* Ast/glo-def.scm 161 */
					  return
					     (global_bglt) (_ortest_1474_878);
				       }
				     else
				       {	/* Ast/glo-def.scm 161 */
					  return
					     (global_bglt) (old_17);
				       }
				  }
				else
				  {	/* Ast/glo-def.scm 158 */
				     {	/* Ast/glo-def.scm 160 */
					obj_t list1546_910;
					list1546_910 =
					   MAKE_PAIR(string1700_ast_glo_def_117, BNIL);
					return
					   mismatch_error_84_ast_glo_def_117(
					   (global_bglt) (old_17), src_exp_176_22, list1546_910);
				     }
				  }
			     }
			   else
			     {	/* Ast/glo-def.scm 152 */
				{	/* Ast/glo-def.scm 155 */
				   obj_t list1549_913;
				   list1549_913 =
				      MAKE_PAIR(string1701_ast_glo_def_117, BNIL);
				   return
				      mismatch_error_84_ast_glo_def_117(
				      (global_bglt) (old_17), src_exp_176_22, list1549_913);
				}
			     }
			}
		      else
			{	/* Ast/glo-def.scm 150 */
			   {	/* Ast/glo-def.scm 151 */
			      obj_t list1552_916;
			      list1552_916 =
				 MAKE_PAIR(string1702_ast_glo_def_117, BNIL);
			      return
				 mismatch_error_84_ast_glo_def_117(
				 (global_bglt) (old_17), src_exp_176_22, list1552_916);
			   }
			}
		   }
		 else
		   {	/* Ast/glo-def.scm 148 */
		      return
			 mismatch_error_84_ast_glo_def_117(
			 (global_bglt) (old_17), src_exp_176_22, BNIL);
		   }
	      }
	    else
	      {		/* Ast/glo-def.scm 146 */
		 return
		    mismatch_error_84_ast_glo_def_117(
		    (global_bglt) (old_17), src_exp_176_22, BNIL);
	      }
	 }
      }
   }
}



/* def-global-scnst! */
global_bglt 
def_global_scnst__93_ast_glo_def_117(obj_t id_23, obj_t module_24, obj_t node_25, obj_t class_26, obj_t loc_27)
{
   AN_OBJECT;
   {	/* Ast/glo-def.scm 195 */
      enter_function_81_tools_error(id_23);
      {		/* Ast/glo-def.scm 197 */
	 obj_t id_type_89_1456;
	 id_type_89_1456 =
	    parse_id_241_ast_ident(id_23, loc_27);
	 {	/* Ast/glo-def.scm 198 */
	    obj_t old_global_82_1458;
	    old_global_82_1458 =
	       find_global_module_25_ast_env(
	       CAR(id_type_89_1456), module_24);
	    {	/* Ast/glo-def.scm 199 */
	       global_bglt global_1459;
	       global_1459 =
		  declare_global_scnst__70_ast_glo_decl_237(id_23, module_24,
		  CNST_TABLE_REF(((long) 1)), node_25, class_26, loc_27);
	       {	/* Ast/glo-def.scm 200 */

		  remove_var_from__148_ast_remove(
		     CNST_TABLE_REF(((long) 3)),
		     (variable_bglt) (global_1459));
		  leave_function_170_tools_error();
		  return global_1459;
	       }
	    }
	 }
      }
   }
}



/* _def-global-scnst!1695 */
obj_t 
_def_global_scnst_1695_168_ast_glo_def_117(obj_t env_1578, obj_t id_1579, obj_t module_1580, obj_t node_1581, obj_t class_1582, obj_t loc_1583)
{
   AN_OBJECT;
   {	/* Ast/glo-def.scm 195 */
      {		/* Ast/glo-def.scm 195 */
	 global_bglt aux_1842;
	 aux_1842 =
	    def_global_scnst__93_ast_glo_def_117(id_1579, module_1580, node_1581, class_1582, loc_1583);
	 return
	    (obj_t) (aux_1842);
      }
   }
}



/* def-global-svar! */
global_bglt 
def_global_svar__184_ast_glo_def_117(obj_t id_28, obj_t module_29, obj_t src_exp_176_30, obj_t rem_31)
{
   AN_OBJECT;
   {	/* Ast/glo-def.scm 215 */
      {		/* Ast/glo-def.scm 216 */
	 obj_t loc_926;
	 loc_926 =
	    find_location_120_tools_location(src_exp_176_30);
	 {	/* Ast/glo-def.scm 216 */
	    obj_t id_type_89_927;
	    id_type_89_927 =
	       parse_id_241_ast_ident(id_28, loc_926);
	    {	/* Ast/glo-def.scm 217 */
	       obj_t id_id_127_928;
	       id_id_127_928 =
		  CAR(id_type_89_927);
	       {	/* Ast/glo-def.scm 218 */
		  obj_t old_global_82_929;
		  old_global_82_929 =
		     find_global_module_25_ast_env(id_id_127_928, module_29);
		  {	/* Ast/glo-def.scm 219 */
		     obj_t import_930;
		     {	/* Ast/glo-def.scm 220 */
			bool_t test1569_945;
			{	/* Ast/glo-def.scm 220 */
			   long n1_1462;
			   n1_1462 =
			      (long) CINT(_bdb_debug__1_engine_param);
			   test1569_945 =
			      (n1_1462 >= ((long) 3));
			}
			if (test1569_945)
			  {	/* Ast/glo-def.scm 220 */
			     import_930 =
				CNST_TABLE_REF(((long) 0));
			  }
			else
			  {	/* Ast/glo-def.scm 220 */
			     import_930 =
				CNST_TABLE_REF(((long) 1));
			  }
		     }
		     {	/* Ast/glo-def.scm 220 */
			obj_t type_931;
			{	/* Ast/glo-def.scm 223 */
			   obj_t type_938;
			   type_938 =
			      CDR(id_type_89_927);
			   {	/* Ast/glo-def.scm 226 */
			      bool_t test_1855;
			      {		/* ./Ieee/equiv.scm 5508 */
				 obj_t aux_1859;
				 obj_t aux_1856;
				 aux_1859 =
				    CNST_TABLE_REF(((long) 4));
				 {	/* Ast/glo-def.scm 226 */
				    type_bglt obj_1465;
				    obj_1465 =
				       (type_bglt) (type_938);
				    aux_1856 =
				       (((type_bglt) CREF(obj_1465))->class);
				 }
				 test_1855 =
				    (aux_1856 == aux_1859);
			      }
			      if (test_1855)
				{	/* Ast/glo-def.scm 226 */
				   type_931 = type_938;
				}
			      else
				{	/* Ast/glo-def.scm 227 */
				   obj_t arg1565_941;
				   arg1565_941 =
				      shape_tools_shape(type_938);
				   type_931 =
				      user_error_151_tools_error(id_id_127_928, string1703_ast_glo_def_117, arg1565_941, BNIL);
				}
			   }
			}
			{	/* Ast/glo-def.scm 223 */
			   global_bglt global_932;
			   {	/* Ast/glo-def.scm 232 */
			      bool_t test1562_937;
			      test1562_937 =
				 is_a__118___object(old_global_82_929, global_ast_var);
			      if (test1562_937)
				{	/* Ast/glo-def.scm 232 */
				   global_932 =
				      check_svar_definition_92_ast_glo_def_117(old_global_82_929, type_931, src_exp_176_30);
				}
			      else
				{	/* Ast/glo-def.scm 232 */
				   global_932 =
				      declare_global_svar__200_ast_glo_decl_237(id_28, module_29, import_930, src_exp_176_30);
				}
			   }
			   {	/* Ast/glo-def.scm 231 */
			      obj_t def_loc_185_933;
			      def_loc_185_933 =
				 find_location_120_tools_location(src_exp_176_30);
			      {		/* Ast/glo-def.scm 241 */

				 {	/* Ast/glo-def.scm 243 */
				    variable_bglt var_1469;
				    type_bglt new_type_21_1470;
				    var_1469 =
				       (variable_bglt) (global_932);
				    new_type_21_1470 =
				       (type_bglt) (type_931);
				    {	/* Ast/glo-def.scm 292 */
				       bool_t test1584_1472;
				       {	/* Ast/glo-def.scm 292 */
					  obj_t obj2_1475;
					  obj2_1475 = ____74_type_cache;
					  {	/* ./Ieee/equiv.scm 5508 */
					     obj_t aux_1871;
					     {	/* Ast/glo-def.scm 292 */
						type_bglt aux_1872;
						aux_1872 =
						   (((variable_bglt) CREF(var_1469))->type);
						aux_1871 =
						   (obj_t) (aux_1872);
					     }
					     test1584_1472 =
						(aux_1871 == obj2_1475);
					  }
				       }
				       if (test1584_1472)
					 {	/* Ast/glo-def.scm 292 */
					    ((((variable_bglt) CREF(var_1469))->type) = ((type_bglt) new_type_21_1470), BUNSPEC);
					 }
				       else
					 {	/* Ast/glo-def.scm 292 */
					    BUNSPEC;
					 }
				    }
				 }
				 {	/* Ast/glo-def.scm 245 */
				    bool_t test1559_934;
				    {	/* ./Ast/var.scm 824 */
				       obj_t aux_1878;
				       {	/* Ast/glo-def.scm 245 */
					  value_bglt aux_1879;
					  aux_1879 =
					     (((global_bglt) CREF(global_932))->value);
					  aux_1878 =
					     (obj_t) (aux_1879);
				       }
				       test1559_934 =
					  is_a__118___object(aux_1878, svar_ast_var);
				    }
				    if (test1559_934)
				      {		/* Ast/glo-def.scm 247 */
					 svar_bglt obj_1481;
					 {	/* Ast/glo-def.scm 247 */
					    value_bglt aux_1884;
					    aux_1884 =
					       (((global_bglt) CREF(global_932))->value);
					    obj_1481 =
					       (svar_bglt) (aux_1884);
					 }
					 ((((svar_bglt) CREF(obj_1481))->loc) = ((obj_t) def_loc_185_933), BUNSPEC);
				      }
				    else
				      {		/* Ast/glo-def.scm 245 */
					 BUNSPEC;
				      }
				 }
				 remove_var_from__148_ast_remove(rem_31,
				    (variable_bglt) (global_932));
				 return global_932;
			      }
			   }
			}
		     }
		  }
	       }
	    }
	 }
      }
   }
}



/* _def-global-svar!1696 */
obj_t 
_def_global_svar_1696_203_ast_glo_def_117(obj_t env_1584, obj_t id_1585, obj_t module_1586, obj_t src_exp_176_1587, obj_t rem_1588)
{
   AN_OBJECT;
   {	/* Ast/glo-def.scm 215 */
      {		/* Ast/glo-def.scm 215 */
	 global_bglt aux_1890;
	 aux_1890 =
	    def_global_svar__184_ast_glo_def_117(id_1585, module_1586, src_exp_176_1587, rem_1588);
	 return
	    (obj_t) (aux_1890);
      }
   }
}



/* check-svar-definition */
global_bglt 
check_svar_definition_92_ast_glo_def_117(obj_t old_32, obj_t type_33, obj_t src_exp_176_34)
{
   AN_OBJECT;
   {	/* Ast/glo-def.scm 255 */
      {		/* Ast/glo-def.scm 258 */
	 bool_t test1570_947;
	 {	/* ./Ast/var.scm 824 */
	    obj_t aux_1893;
	    {	/* Ast/glo-def.scm 258 */
	       value_bglt aux_1894;
	       {	/* Ast/glo-def.scm 256 */
		  global_bglt obj_1483;
		  obj_1483 =
		     (global_bglt) (old_32);
		  aux_1894 =
		     (((global_bglt) CREF(obj_1483))->value);
	       }
	       aux_1893 =
		  (obj_t) (aux_1894);
	    }
	    test1570_947 =
	       is_a__118___object(aux_1893, svar_ast_var);
	 }
	 if (test1570_947)
	   {	/* Ast/glo-def.scm 260 */
	      bool_t test1571_948;
	      {		/* Ast/glo-def.scm 260 */
		 type_bglt aux_1900;
		 {	/* Ast/glo-def.scm 260 */
		    global_bglt obj_1485;
		    obj_1485 =
		       (global_bglt) (old_32);
		    aux_1900 =
		       (((global_bglt) CREF(obj_1485))->type);
		 }
		 test1571_948 =
		    compatible_type__151_ast_glo_def_117(((bool_t) 0),
		    (type_bglt) (type_33), aux_1900);
	      }
	      if (test1571_948)
		{	/* Ast/glo-def.scm 260 */
		   return
		      (global_bglt) (old_32);
		}
	      else
		{	/* Ast/glo-def.scm 260 */
		   {	/* Ast/glo-def.scm 261 */
		      obj_t list1572_949;
		      list1572_949 =
			 MAKE_PAIR(string1704_ast_glo_def_117, BNIL);
		      return
			 mismatch_error_84_ast_glo_def_117(
			 (global_bglt) (old_32), src_exp_176_34, list1572_949);
		   }
		}
	   }
	 else
	   {	/* Ast/glo-def.scm 258 */
	      return
		 mismatch_error_84_ast_glo_def_117(
		 (global_bglt) (old_32), src_exp_176_34, BNIL);
	   }
      }
   }
}



/* compatible-type? */
bool_t 
compatible_type__151_ast_glo_def_117(bool_t sub__142_35, type_bglt new_36, type_bglt old_37)
{
   AN_OBJECT;
   {	/* Ast/glo-def.scm 268 */
      {		/* Ast/glo-def.scm 269 */
	 bool_t _ortest_1480_952;
	 {	/* Ast/glo-def.scm 269 */
	    obj_t obj2_1487;
	    obj2_1487 = ____74_type_cache;
	    {	/* ./Ieee/equiv.scm 5508 */
	       obj_t aux_1912;
	       aux_1912 =
		  (obj_t) (new_36);
	       _ortest_1480_952 =
		  (aux_1912 == obj2_1487);
	    }
	 }
	 if (_ortest_1480_952)
	   {	/* Ast/glo-def.scm 269 */
	      return _ortest_1480_952;
	   }
	 else
	   {	/* Ast/glo-def.scm 270 */
	      bool_t _ortest_1481_953;
	      {		/* ./Ieee/equiv.scm 5508 */
		 obj_t aux_1918;
		 obj_t aux_1916;
		 aux_1918 =
		    (obj_t) (new_36);
		 aux_1916 =
		    (obj_t) (old_37);
		 _ortest_1481_953 =
		    (aux_1916 == aux_1918);
	      }
	      if (_ortest_1481_953)
		{	/* Ast/glo-def.scm 270 */
		   return _ortest_1481_953;
		}
	      else
		{	/* Ast/glo-def.scm 270 */
		   if (sub__142_35)
		     {	/* Ast/glo-def.scm 272 */
			bool_t _ortest_1483_955;
			_ortest_1483_955 =
			   type_subclass__90_object_class(new_36, old_37);
			if (_ortest_1483_955)
			  {	/* Ast/glo-def.scm 272 */
			     return _ortest_1483_955;
			  }
			else
			  {	/* Ast/glo-def.scm 273 */
			     bool_t _andtest_1484_956;
			     _andtest_1484_956 =
				is_a__118___object(
				(obj_t) (new_36), tclass_object_class);
			     if (_andtest_1484_956)
			       {	/* Ast/glo-def.scm 273 */
				  obj_t obj2_1492;
				  obj2_1492 = _obj__252_type_cache;
				  {	/* ./Ieee/equiv.scm 5508 */
				     obj_t aux_1928;
				     aux_1928 =
					(obj_t) (old_37);
				     return
					(aux_1928 == obj2_1492);
				  }
			       }
			     else
			       {	/* Ast/glo-def.scm 273 */
				  return ((bool_t) 0);
			       }
			  }
		     }
		   else
		     {	/* Ast/glo-def.scm 271 */
			return ((bool_t) 0);
		     }
		}
	   }
      }
   }
}



/* mismatch-error */
global_bglt 
mismatch_error_84_ast_glo_def_117(global_bglt global_38, obj_t src_exp_176_39, obj_t add_msg_187_40)
{
   AN_OBJECT;
   {	/* Ast/glo-def.scm 278 */
      {		/* Ast/glo-def.scm 280 */
	 obj_t arg1576_958;
	 obj_t arg1577_959;
	 if (
	    PAIRP(add_msg_187_40))
	   {	/* Ast/glo-def.scm 281 */
	      obj_t arg1580_962;
	      {		/* Ast/glo-def.scm 281 */
		 obj_t aux_1933;
		 aux_1933 =
		    CAR(add_msg_187_40);
		 arg1580_962 =
		    string_append(string1705_ast_glo_def_117, aux_1933);
	      }
	      arg1576_958 =
		 string_append(string1706_ast_glo_def_117, arg1580_962);
	   }
	 else
	   {	/* Ast/glo-def.scm 280 */
	      arg1576_958 = string1706_ast_glo_def_117;
	   }
	 arg1577_959 =
	    shape_tools_shape(
	    (((global_bglt) CREF(global_38))->src));
	 {	/* Ast/glo-def.scm 280 */
	    obj_t list1578_960;
	    {	/* Ast/glo-def.scm 280 */
	       obj_t aux_1939;
	       aux_1939 =
		  (obj_t) (global_38);
	       list1578_960 =
		  MAKE_PAIR(aux_1939, BNIL);
	    }
	    {	/* Ast/glo-def.scm 280 */
	       obj_t aux_1942;
	       aux_1942 =
		  user_error_151_tools_error(arg1576_958, arg1577_959, src_exp_176_39, list1578_960);
	       return
		  (global_bglt) (aux_1942);
	    }
	 }
      }
   }
}



/* check-method-definition */
bool_t 
check_method_definition_71_ast_glo_def_117(obj_t id_43, obj_t args_44, obj_t locals_45, obj_t src_46)
{
   AN_OBJECT;
   {	/* Ast/glo-def.scm 298 */
      {		/* Ast/glo-def.scm 299 */
	 obj_t loc_968;
	 loc_968 =
	    find_location_120_tools_location(src_46);
	 {	/* Ast/glo-def.scm 299 */
	    type_bglt type_res_48_969;
	    type_res_48_969 =
	       type_of_id_183_ast_ident(id_43, loc_968);
	    {	/* Ast/glo-def.scm 300 */
	       obj_t method_id_209_970;
	       method_id_209_970 =
		  id_of_id_112_ast_ident(id_43, loc_968);
	       {	/* Ast/glo-def.scm 301 */
		  obj_t generic_971;
		  generic_971 =
		     find_global_223_ast_env(id_43, BNIL);
		  {	/* Ast/glo-def.scm 302 */

		     {	/* Ast/glo-def.scm 303 */
			bool_t test1585_972;
			test1585_972 =
			   is_a__118___object(generic_971, global_ast_var);
			if (test1585_972)
			  {	/* Ast/glo-def.scm 307 */
			     value_bglt generic_value_252_973;
			     {	/* Ast/glo-def.scm 307 */
				global_bglt obj_1504;
				obj_1504 =
				   (global_bglt) (generic_971);
				generic_value_252_973 =
				   (((global_bglt) CREF(obj_1504))->value);
			     }
			     {	/* Ast/glo-def.scm 309 */
				bool_t test1586_974;
				test1586_974 =
				   is_a__118___object(
				   (obj_t) (generic_value_252_973), sfun_ast_var);
				if (test1586_974)
				  {	/* Ast/glo-def.scm 312 */
				     bool_t test_1956;
				     {	/* ./Ieee/equiv.scm 5508 */
					obj_t aux_1960;
					obj_t aux_1957;
					aux_1960 =
					   CNST_TABLE_REF(((long) 2));
					{	/* Ast/glo-def.scm 312 */
					   sfun_bglt obj_1506;
					   obj_1506 =
					      (sfun_bglt) (generic_value_252_973);
					   aux_1957 =
					      (((sfun_bglt) CREF(obj_1506))->class);
					}
					test_1956 =
					   (aux_1957 == aux_1960);
				     }
				     if (test_1956)
				       {	/* Ast/glo-def.scm 315 */
					  bool_t test1588_976;
					  {	/* Ast/glo-def.scm 315 */
					     long arg1612_1012;
					     int arg1613_1013;
					     {	/* Ast/glo-def.scm 315 */
						sfun_bglt obj_1509;
						obj_1509 =
						   (sfun_bglt) (generic_value_252_973);
						arg1612_1012 =
						   (((sfun_bglt) CREF(obj_1509))->arity);
					     }
					     arg1613_1013 =
						arity_tools_args(args_44);
					     {	/* ./Ieee/fixnum.scm 7109 */
						long aux_1966;
						aux_1966 =
						   (long) (arg1613_1013);
						test1588_976 =
						   (arg1612_1012 == aux_1966);
					     }
					  }
					  if (test1588_976)
					    {	/* Ast/glo-def.scm 318 */
					       bool_t test1589_977;
					       {	/* Ast/glo-def.scm 318 */
						  type_bglt aux_1970;
						  {	/* Ast/glo-def.scm 318 */
						     global_bglt obj_1512;
						     obj_1512 =
							(global_bglt) (generic_971);
						     aux_1970 =
							(((global_bglt) CREF(obj_1512))->type);
						  }
						  test1589_977 =
						     compatible_type__151_ast_glo_def_117(((bool_t) 1), type_res_48_969, aux_1970);
					       }
					       if (test1589_977)
						 {	/* Ast/glo-def.scm 323 */
						    bool_t _ortest_1485_978;
						    {
						       obj_t locals_979;
						       obj_t types_980;
						       bool_t sub__142_981;
						       {	/* Ast/glo-def.scm 324 */
							  obj_t arg1590_983;
							  {	/* Ast/glo-def.scm 324 */
							     obj_t l1486_984;
							     {	/* Ast/glo-def.scm 335 */
								sfun_bglt obj_1513;
								obj_1513 =
								   (sfun_bglt) (generic_value_252_973);
								l1486_984 =
								   (((sfun_bglt) CREF(obj_1513))->args);
							     }
							     if (
								NULLP(l1486_984))
							       {	/* Ast/glo-def.scm 324 */
								  arg1590_983 = BNIL;
							       }
							     else
							       {	/* Ast/glo-def.scm 324 */
								  obj_t head1488_986;
								  head1488_986 =
								     MAKE_PAIR(BNIL, BNIL);
								  {
								     obj_t l1486_987;
								     obj_t tail1489_988;
								     l1486_987 = l1486_984;
								     tail1489_988 = head1488_986;
								   lname1487_989:
								     if (
									NULLP(l1486_987))
								       {	/* Ast/glo-def.scm 324 */
									  arg1590_983 =
									     CDR(head1488_986);
								       }
								     else
								       {	/* Ast/glo-def.scm 326 */
									  obj_t newtail1490_991;
									  {	/* Ast/glo-def.scm 326 */
									     obj_t arg1594_993;
									     {	/* Ast/glo-def.scm 326 */
										obj_t a_995;
										a_995 =
										   CAR(l1486_987);
										{	/* Ast/glo-def.scm 326 */
										   bool_t test1596_996;
										   test1596_996 =
										      is_a__118___object(a_995, local_ast_var);
										   if (test1596_996)
										     {	/* Ast/glo-def.scm 326 */
											{	/* Ast/glo-def.scm 327 */
											   local_bglt obj_1521;
											   obj_1521 =
											      (local_bglt) (a_995);
											   {	/* ./Ast/var.scm 738 */
											      type_bglt aux_1987;
											      aux_1987 =
												 (((local_bglt) CREF(obj_1521))->type);
											      arg1594_993 =
												 (obj_t) (aux_1987);
											   }
											}
										     }
										   else
										     {	/* Ast/glo-def.scm 328 */
											bool_t test1597_997;
											test1597_997 =
											   is_a__118___object(a_995, type_type_type);
											if (test1597_997)
											  {	/* Ast/glo-def.scm 328 */
											     arg1594_993 = a_995;
											  }
											else
											  {	/* Ast/glo-def.scm 328 */
											     {	/* Ast/glo-def.scm 331 */
												obj_t arg1600_1000;
												arg1600_1000 =
												   shape_tools_shape(a_995);
												arg1594_993 =
												   internal_error_43_tools_error(string1697_ast_glo_def_117, string1698_ast_glo_def_117, arg1600_1000);
											     }
											  }
										     }
										}
									     }
									     newtail1490_991 =
										MAKE_PAIR(arg1594_993, BNIL);
									  }
									  SET_CDR(tail1489_988, newtail1490_991);
									  {
									     obj_t tail1489_1998;
									     obj_t l1486_1996;
									     l1486_1996 =
										CDR(l1486_987);
									     tail1489_1998 = newtail1490_991;
									     tail1489_988 = tail1489_1998;
									     l1486_987 = l1486_1996;
									     goto lname1487_989;
									  }
								       }
								  }
							       }
							  }
							  locals_979 = locals_45;
							  types_980 = arg1590_983;
							  sub__142_981 = ((bool_t) 1);
							loop_982:
							  if (
							     NULLP(locals_979))
							    {	/* Ast/glo-def.scm 338 */
							       _ortest_1485_978 = ((bool_t) 1);
							    }
							  else
							    {	/* Ast/glo-def.scm 340 */
							       bool_t test1602_1002;
							       {	/* Ast/glo-def.scm 340 */
								  type_bglt aux_2006;
								  type_bglt aux_2001;
								  {	/* Ast/glo-def.scm 340 */
								     obj_t aux_2007;
								     aux_2007 =
									CAR(types_980);
								     aux_2006 =
									(type_bglt) (aux_2007);
								  }
								  {	/* Ast/glo-def.scm 341 */
								     local_bglt obj_1530;
								     {	/* Ast/glo-def.scm 341 */
									obj_t aux_2002;
									aux_2002 =
									   CAR(locals_979);
									obj_1530 =
									   (local_bglt) (aux_2002);
								     }
								     aux_2001 =
									(((local_bglt) CREF(obj_1530))->type);
								  }
								  test1602_1002 =
								     compatible_type__151_ast_glo_def_117(sub__142_981, aux_2001, aux_2006);
							       }
							       if (test1602_1002)
								 {	/* Ast/glo-def.scm 340 */
								    {
								       bool_t sub__142_2016;
								       obj_t types_2014;
								       obj_t locals_2012;
								       locals_2012 =
									  CDR(locals_979);
								       types_2014 =
									  CDR(types_980);
								       sub__142_2016 = ((bool_t) 0);
								       sub__142_981 = sub__142_2016;
								       types_980 = types_2014;
								       locals_979 = locals_2012;
								       goto loop_982;
								    }
								 }
							       else
								 {	/* Ast/glo-def.scm 340 */
								    {	/* Ast/glo-def.scm 343 */
								       obj_t list1605_1005;
								       list1605_1005 =
									  MAKE_PAIR(string1699_ast_glo_def_117, BNIL);
								       mismatch_error_84_ast_glo_def_117(
									  (global_bglt) (generic_971), src_46, list1605_1005);
								    }
								    _ortest_1485_978 = ((bool_t) 0);
								 }
							    }
						       }
						    }
						    if (_ortest_1485_978)
						      {		/* Ast/glo-def.scm 323 */
							 return _ortest_1485_978;
						      }
						    else
						      {		/* Ast/glo-def.scm 323 */
							 return ((bool_t) 1);
						      }
						 }
					       else
						 {	/* Ast/glo-def.scm 318 */
						    {	/* Ast/glo-def.scm 319 */
						       obj_t list1609_1009;
						       list1609_1009 =
							  MAKE_PAIR(string1701_ast_glo_def_117, BNIL);
						       mismatch_error_84_ast_glo_def_117(
							  (global_bglt) (generic_971), src_46, list1609_1009);
						    }
						    return ((bool_t) 0);
						 }
					    }
					  else
					    {	/* Ast/glo-def.scm 315 */
					       {	/* Ast/glo-def.scm 316 */
						  obj_t list1611_1011;
						  list1611_1011 =
						     MAKE_PAIR(string1702_ast_glo_def_117, BNIL);
						  mismatch_error_84_ast_glo_def_117(
						     (global_bglt) (generic_971), src_46, list1611_1011);
					       }
					       return ((bool_t) 0);
					    }
				       }
				     else
				       {	/* Ast/glo-def.scm 312 */
					  mismatch_error_84_ast_glo_def_117(
					     (global_bglt) (generic_971), src_46, BNIL);
					  return ((bool_t) 0);
				       }
				  }
				else
				  {	/* Ast/glo-def.scm 309 */
				     mismatch_error_84_ast_glo_def_117(
					(global_bglt) (generic_971), src_46, BNIL);
				     return ((bool_t) 0);
				  }
			     }
			  }
			else
			  {	/* Ast/glo-def.scm 303 */
			     return ((bool_t) 1);
			  }
		     }
		  }
	       }
	    }
	 }
      }
   }
}



/* _check-method-definition */
obj_t 
_check_method_definition_40_ast_glo_def_117(obj_t env_1589, obj_t id_1590, obj_t args_1591, obj_t locals_1592, obj_t src_1593)
{
   AN_OBJECT;
   {	/* Ast/glo-def.scm 298 */
      {		/* Ast/glo-def.scm 298 */
	 bool_t aux_2031;
	 aux_2031 =
	    check_method_definition_71_ast_glo_def_117(id_1590, args_1591, locals_1592, src_1593);
	 return
	    BBOOL(aux_2031);
      }
   }
}



/* method-init */
obj_t 
method_init_76_ast_glo_def_117()
{
   AN_OBJECT;
   {	/* Ast/glo-def.scm 15 */
      return BUNSPEC;
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_ast_glo_def_117()
{
   AN_OBJECT;
   {	/* Ast/glo-def.scm 15 */
      module_initialization_70_tools_trace(((long) 0), "AST_GLO-DEF");
      module_initialization_70_type_type(((long) 0), "AST_GLO-DEF");
      module_initialization_70_ast_var(((long) 0), "AST_GLO-DEF");
      module_initialization_70_ast_node(((long) 0), "AST_GLO-DEF");
      module_initialization_70_ast_env(((long) 0), "AST_GLO-DEF");
      module_initialization_70_ast_ident(((long) 0), "AST_GLO-DEF");
      module_initialization_70_ast_glo_decl_237(((long) 0), "AST_GLO-DEF");
      module_initialization_70_ast_remove(((long) 0), "AST_GLO-DEF");
      module_initialization_70_type_env(((long) 0), "AST_GLO-DEF");
      module_initialization_70_type_cache(((long) 0), "AST_GLO-DEF");
      module_initialization_70_tools_args(((long) 0), "AST_GLO-DEF");
      module_initialization_70_tools_error(((long) 0), "AST_GLO-DEF");
      module_initialization_70_tools_shape(((long) 0), "AST_GLO-DEF");
      module_initialization_70_tools_location(((long) 0), "AST_GLO-DEF");
      module_initialization_70_tools_dsssl(((long) 0), "AST_GLO-DEF");
      module_initialization_70_object_class(((long) 0), "AST_GLO-DEF");
      return
	 module_initialization_70_engine_param(((long) 0), "AST_GLO-DEF");
   }
}
