/*===========================================================================*/
/*   (Ast/hrtype.scm)                                                        */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;


static obj_t method_init_76_ast_hrtype();
extern obj_t make_box_202_ast_node;
extern obj_t funcall_ast_node;
extern long add_inlined_method__244___object(obj_t, obj_t, long);
extern obj_t fail_ast_node;
extern obj_t hrtype_node__16_ast_hrtype(node_bglt);
extern obj_t type_type_type;
extern obj_t box_ref_242_ast_node;
extern obj_t sequence_ast_node;
extern obj_t let_var_6_ast_node;
extern obj_t var_ast_node;
extern obj_t closure_ast_node;
extern obj_t pragma_ast_node;
extern obj_t set_ex_it_116_ast_node;
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t module_initialization_70_ast_hrtype(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_env(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_coerce_typeof(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
static obj_t _hrtype_node__default1463_76_ast_hrtype(obj_t, obj_t);
static obj_t _hrtype_node__147_ast_hrtype(obj_t, obj_t);
extern obj_t let_fun_218_ast_node;
extern type_bglt find_type_26_type_env(obj_t);
static obj_t imported_modules_init_94_ast_hrtype();
static obj_t hrtype_node__default1463_83_ast_hrtype(node_bglt);
extern obj_t app_ly_162_ast_node;
extern obj_t add_generic__110___object(obj_t, obj_t);
extern obj_t app_ast_node;
static obj_t library_modules_init_112_ast_hrtype();
extern obj_t atom_ast_node;
extern obj_t cast_ast_node;
static obj_t toplevel_init_63_ast_hrtype();
extern obj_t jump_ex_it_184_ast_node;
extern obj_t open_input_string(obj_t);
extern obj_t kwote_ast_node;
extern obj_t setq_ast_node;
extern obj_t box_set__221_ast_node;
extern obj_t local_ast_var;
extern obj_t shape_tools_shape(obj_t);
static bool_t hrtype_node___80_ast_hrtype(obj_t);
extern obj_t internal_error_43_tools_error(obj_t, obj_t, obj_t);
extern obj_t _classes__134___object;
extern obj_t select_ast_node;
extern obj_t read___reader(obj_t);
static obj_t restore_variable_type__109_ast_hrtype(variable_bglt);
static obj_t require_initialization_114_ast_hrtype = BUNSPEC;
extern obj_t conditional_ast_node;
static obj_t cnst_init_137_ast_hrtype();
static obj_t __cnst[1];

DEFINE_EXPORT_GENERIC(hrtype_node__env_165_ast_hrtype, _hrtype_node__147_ast_hrtype1681, _hrtype_node__147_ast_hrtype, 0L, 1);
DEFINE_STATIC_PROCEDURE(hrtype_node__default1463_env_245_ast_hrtype, _hrtype_node__default1463_76_ast_hrtype1682, _hrtype_node__default1463_76_ast_hrtype, 0L, 1);
DEFINE_STRING(string1676_ast_hrtype, string1676_ast_hrtype1683, "HRTYPE-NODE!-DEFAULT1463 ", 25);
DEFINE_STRING(string1675_ast_hrtype, string1675_ast_hrtype1684, "No method for this object", 25);
DEFINE_STRING(string1674_ast_hrtype, string1674_ast_hrtype1685, "Illegal argument", 16);
DEFINE_STRING(string1673_ast_hrtype, string1673_ast_hrtype1686, "Unexpected closure", 18);
DEFINE_STRING(string1672_ast_hrtype, string1672_ast_hrtype1687, "hrtype-node!", 12);



/* module-initialization */
obj_t 
module_initialization_70_ast_hrtype(long checksum_1301, char *from_1302)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_ast_hrtype))
	{
	   require_initialization_114_ast_hrtype =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_ast_hrtype();
	   cnst_init_137_ast_hrtype();
	   imported_modules_init_94_ast_hrtype();
	   method_init_76_ast_hrtype();
	   toplevel_init_63_ast_hrtype();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_ast_hrtype()
{
   AN_OBJECT;
   {	/* Ast/hrtype.scm 17 */
      module_initialization_70___object(((long) 0), "AST_HRTYPE");
      module_initialization_70___reader(((long) 0), "AST_HRTYPE");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_ast_hrtype()
{
   AN_OBJECT;
   {	/* Ast/hrtype.scm 17 */
      {		/* Ast/hrtype.scm 17 */
	 obj_t cnst_port_138_1294;
	 cnst_port_138_1294 =
	    open_input_string(string1676_ast_hrtype);
	 {
	    long i_1295;
	    i_1295 = ((long) 0);
	  loop_1296:
	    {	/* Ast/hrtype.scm 17 */
	       bool_t test1677_1297;
	       test1677_1297 =
		  (i_1295 == ((long) -1));
	       if (test1677_1297)
		 {	/* Ast/hrtype.scm 17 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Ast/hrtype.scm 17 */
		    {	/* Ast/hrtype.scm 17 */
		       obj_t arg1678_1298;
		       {	/* Ast/hrtype.scm 17 */
			  obj_t list1679_1299;
			  list1679_1299 =
			     MAKE_PAIR(cnst_port_138_1294, BNIL);
			  arg1678_1298 =
			     read___reader(list1679_1299);
		       }
		       CNST_TABLE_SET(i_1295, arg1678_1298);
		    }
		    {	/* Ast/hrtype.scm 17 */
		       int aux_1300;
		       {	/* Ast/hrtype.scm 17 */
			  long aux_1319;
			  aux_1319 =
			     (i_1295 - ((long) 1));
			  aux_1300 =
			     (int) (aux_1319);
		       }
		       {
			  long i_1322;
			  i_1322 =
			     (long) (aux_1300);
			  i_1295 = i_1322;
			  goto loop_1296;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_ast_hrtype()
{
   AN_OBJECT;
   {	/* Ast/hrtype.scm 17 */
      return BUNSPEC;
   }
}



/* hrtype-node*! */
bool_t 
hrtype_node___80_ast_hrtype(obj_t node__221_24)
{
   AN_OBJECT;
   {	/* Ast/hrtype.scm 218 */
      {
	 obj_t l1460_721;
	 l1460_721 = node__221_24;
       lname1461_722:
	 if (
	    PAIRP(l1460_721))
	   {	/* Ast/hrtype.scm 219 */
	      {		/* Ast/hrtype.scm 219 */
		 node_bglt aux_1326;
		 {	/* Ast/hrtype.scm 219 */
		    obj_t aux_1327;
		    aux_1327 =
		       CAR(l1460_721);
		    aux_1326 =
		       (node_bglt) (aux_1327);
		 }
		 hrtype_node__16_ast_hrtype(aux_1326);
	      }
	      {
		 obj_t l1460_1331;
		 l1460_1331 =
		    CDR(l1460_721);
		 l1460_721 = l1460_1331;
		 goto lname1461_722;
	      }
	   }
	 else
	   {	/* Ast/hrtype.scm 219 */
	      return ((bool_t) 1);
	   }
      }
   }
}



/* restore-variable-type! */
obj_t 
restore_variable_type__109_ast_hrtype(variable_bglt variable_25)
{
   AN_OBJECT;
   {	/* Ast/hrtype.scm 224 */
      {		/* Ast/hrtype.scm 225 */
	 type_bglt type_726;
	 type_726 =
	    (((variable_bglt) CREF(variable_25))->type);
	 {	/* Ast/hrtype.scm 226 */
	    bool_t test1510_727;
	    test1510_727 =
	       is_a__118___object(
	       (obj_t) (type_726), type_type_type);
	    if (test1510_727)
	      {		/* Ast/hrtype.scm 227 */
		 type_bglt arg1511_728;
		 arg1511_728 =
		    find_type_26_type_env(
		    (((type_bglt) CREF(type_726))->id));
		 return
		    ((((variable_bglt) CREF(variable_25))->type) = ((type_bglt) arg1511_728), BUNSPEC);
	      }
	    else
	      {		/* Ast/hrtype.scm 226 */
		 return BUNSPEC;
	      }
	 }
      }
   }
}



/* method-init */
obj_t 
method_init_76_ast_hrtype()
{
   AN_OBJECT;
   {	/* Ast/hrtype.scm 17 */
      add_generic__110___object(hrtype_node__env_165_ast_hrtype, hrtype_node__default1463_env_245_ast_hrtype);
      add_inlined_method__244___object(hrtype_node__env_165_ast_hrtype, atom_ast_node, ((long) 0));
      add_inlined_method__244___object(hrtype_node__env_165_ast_hrtype, kwote_ast_node, ((long) 1));
      add_inlined_method__244___object(hrtype_node__env_165_ast_hrtype, var_ast_node, ((long) 2));
      add_inlined_method__244___object(hrtype_node__env_165_ast_hrtype, closure_ast_node, ((long) 3));
      add_inlined_method__244___object(hrtype_node__env_165_ast_hrtype, sequence_ast_node, ((long) 4));
      add_inlined_method__244___object(hrtype_node__env_165_ast_hrtype, app_ast_node, ((long) 5));
      add_inlined_method__244___object(hrtype_node__env_165_ast_hrtype, app_ly_162_ast_node, ((long) 6));
      add_inlined_method__244___object(hrtype_node__env_165_ast_hrtype, funcall_ast_node, ((long) 7));
      add_inlined_method__244___object(hrtype_node__env_165_ast_hrtype, pragma_ast_node, ((long) 8));
      add_inlined_method__244___object(hrtype_node__env_165_ast_hrtype, cast_ast_node, ((long) 9));
      add_inlined_method__244___object(hrtype_node__env_165_ast_hrtype, setq_ast_node, ((long) 10));
      add_inlined_method__244___object(hrtype_node__env_165_ast_hrtype, conditional_ast_node, ((long) 11));
      add_inlined_method__244___object(hrtype_node__env_165_ast_hrtype, fail_ast_node, ((long) 12));
      add_inlined_method__244___object(hrtype_node__env_165_ast_hrtype, select_ast_node, ((long) 13));
      add_inlined_method__244___object(hrtype_node__env_165_ast_hrtype, let_fun_218_ast_node, ((long) 14));
      add_inlined_method__244___object(hrtype_node__env_165_ast_hrtype, let_var_6_ast_node, ((long) 15));
      add_inlined_method__244___object(hrtype_node__env_165_ast_hrtype, set_ex_it_116_ast_node, ((long) 16));
      add_inlined_method__244___object(hrtype_node__env_165_ast_hrtype, jump_ex_it_184_ast_node, ((long) 17));
      add_inlined_method__244___object(hrtype_node__env_165_ast_hrtype, make_box_202_ast_node, ((long) 18));
      add_inlined_method__244___object(hrtype_node__env_165_ast_hrtype, box_set__221_ast_node, ((long) 19));
      {		/* Ast/hrtype.scm 17 */
	 long aux_1361;
	 aux_1361 =
	    add_inlined_method__244___object(hrtype_node__env_165_ast_hrtype, box_ref_242_ast_node, ((long) 20));
	 return
	    BINT(aux_1361);
      }
   }
}



/* hrtype-node! */
obj_t 
hrtype_node__16_ast_hrtype(node_bglt node_1)
{
   AN_OBJECT;
   {	/* Ast/hrtype.scm 30 */
    hrtype_node__16_ast_hrtype:
      {
	 obj_t method1594_1060;
	 obj_t class1599_1061;
	 {	/* Ast/hrtype.scm 30 */
	    obj_t arg1602_1058;
	    obj_t arg1603_1059;
	    {	/* Ast/hrtype.scm 30 */
	       object_bglt obj_1195;
	       obj_1195 =
		  (object_bglt) (node_1);
	       {	/* ./Llib/object.scm 2926 */
		  obj_t pre_method_105_1196;
		  pre_method_105_1196 =
		     PROCEDURE_REF(hrtype_node__env_165_ast_hrtype, ((long) 2));
		  if (
		     INTEGERP(pre_method_105_1196))
		    {	/* ./Llib/object.scm 2927 */
		       PROCEDURE_SET(hrtype_node__env_165_ast_hrtype, ((long) 2), BUNSPEC);
		       arg1602_1058 = pre_method_105_1196;
		    }
		  else
		    {	/* ./Llib/object.scm 2914 */
		       long obj_class_num_177_1201;
		       obj_class_num_177_1201 =
			  TYPE(obj_1195);
		       {	/* ./Llib/object.scm 2915 */
			  obj_t arg1176_1202;
			  arg1176_1202 =
			     PROCEDURE_REF(hrtype_node__env_165_ast_hrtype, ((long) 1));
			  {	/* ./Llib/object.scm 2738 */
			     long arg1177_1206;
			     {	/* ./Llib/object.scm 2738 */
				long arg1178_1207;
				arg1178_1207 =
				   OBJECT_TYPE;
				arg1177_1206 =
				   (obj_class_num_177_1201 - arg1178_1207);
			     }
			     arg1602_1058 =
				VECTOR_REF(arg1176_1202, arg1177_1206);
			  }
		       }
		    }
	       }
	    }
	    {	/* Ast/hrtype.scm 30 */
	       object_bglt object_1212;
	       object_1212 =
		  (object_bglt) (node_1);
	       {	/* ./Llib/object.scm 2695 */
		  long arg1179_1213;
		  {	/* ./Llib/object.scm 2695 */
		     long arg1180_1214;
		     long arg1181_1215;
		     arg1180_1214 =
			TYPE(object_1212);
		     arg1181_1215 =
			OBJECT_TYPE;
		     arg1179_1213 =
			(arg1180_1214 - arg1181_1215);
		  }
		  {	/* ./Llib/object.scm 2695 */
		     obj_t vector_1219;
		     vector_1219 = _classes__134___object;
		     arg1603_1059 =
			VECTOR_REF(vector_1219, arg1179_1213);
		  }
	       }
	    }
	    method1594_1060 = arg1602_1058;
	    class1599_1061 = arg1603_1059;
	    {

	       if (
		  INTEGERP(method1594_1060))
		 {	/* Ast/hrtype.scm 30 */
		    switch (
		       (long) CINT(method1594_1060))
		      {
		      case ((long) 0):

			 return BUNSPEC;
			 break;
		      case ((long) 1):

			 return BUNSPEC;
			 break;
		      case ((long) 2):

			 return BUNSPEC;
			 break;
		      case ((long) 3):

			 {	/* Ast/hrtype.scm 54 */
			    obj_t arg1608_1073;
			    {	/* Ast/hrtype.scm 54 */
			       obj_t aux_1381;
			       {	/* Ast/hrtype.scm 54 */
				  closure_bglt aux_1382;
				  aux_1382 =
				     (closure_bglt) (node_1);
				  aux_1381 =
				     (obj_t) (aux_1382);
			       }
			       arg1608_1073 =
				  shape_tools_shape(aux_1381);
			    }
			    return
			       internal_error_43_tools_error(string1672_ast_hrtype, string1673_ast_hrtype, arg1608_1073);
			 }
			 break;
		      case ((long) 4):

			 {	/* Ast/hrtype.scm 60 */
			    sequence_bglt node_1074;
			    node_1074 =
			       (sequence_bglt) (node_1);
			    {	/* Ast/hrtype.scm 61 */
			       bool_t aux_1388;
			       aux_1388 =
				  hrtype_node___80_ast_hrtype(
				  (((sequence_bglt) CREF(node_1074))->nodes));
			       return
				  BBOOL(aux_1388);
			    }
			 }
			 break;
		      case ((long) 5):

			 {	/* Ast/hrtype.scm 67 */
			    app_bglt node_1077;
			    node_1077 =
			       (app_bglt) (node_1);
			    {	/* Ast/hrtype.scm 68 */
			       bool_t aux_1393;
			       aux_1393 =
				  hrtype_node___80_ast_hrtype(
				  (((app_bglt) CREF(node_1077))->args));
			       return
				  BBOOL(aux_1393);
			    }
			 }
			 break;
		      case ((long) 6):

			 {	/* Ast/hrtype.scm 74 */
			    app_ly_162_bglt node_1080;
			    node_1080 =
			       (app_ly_162_bglt) (node_1);
			    hrtype_node__16_ast_hrtype(
			       (((app_ly_162_bglt) CREF(node_1080))->fun));
			    {
			       node_bglt node_1400;
			       node_1400 =
				  (((app_ly_162_bglt) CREF(node_1080))->arg);
			       node_1 = node_1400;
			       goto hrtype_node__16_ast_hrtype;
			    }
			 }
			 break;
		      case ((long) 7):

			 {	/* Ast/hrtype.scm 82 */
			    funcall_bglt node_1084;
			    node_1084 =
			       (funcall_bglt) (node_1);
			    hrtype_node__16_ast_hrtype(
			       (((funcall_bglt) CREF(node_1084))->fun));
			    {	/* Ast/hrtype.scm 84 */
			       bool_t aux_1405;
			       aux_1405 =
				  hrtype_node___80_ast_hrtype(
				  (((funcall_bglt) CREF(node_1084))->args));
			       return
				  BBOOL(aux_1405);
			    }
			 }
			 break;
		      case ((long) 8):

			 {	/* Ast/hrtype.scm 90 */
			    pragma_bglt node_1088;
			    node_1088 =
			       (pragma_bglt) (node_1);
			    {	/* Ast/hrtype.scm 91 */
			       bool_t test1615_1090;
			       {	/* ./Type/type.scm 481 */
				  obj_t aux_1410;
				  {	/* Ast/hrtype.scm 91 */
				     type_bglt aux_1411;
				     aux_1411 =
					(((pragma_bglt) CREF(node_1088))->type);
				     aux_1410 =
					(obj_t) (aux_1411);
				  }
				  test1615_1090 =
				     is_a__118___object(aux_1410, type_type_type);
			       }
			       if (test1615_1090)
				 {	/* Ast/hrtype.scm 92 */
				    type_bglt arg1616_1091;
				    {	/* Ast/hrtype.scm 92 */
				       obj_t aux_1416;
				       {	/* Ast/hrtype.scm 92 */
					  type_bglt arg1618_1093;
					  arg1618_1093 =
					     (((pragma_bglt) CREF(node_1088))->type);
					  aux_1416 =
					     (((type_bglt) CREF(arg1618_1093))->id);
				       }
				       arg1616_1091 =
					  find_type_26_type_env(aux_1416);
				    }
				    ((((pragma_bglt) CREF(node_1088))->type) = ((type_bglt) arg1616_1091), BUNSPEC);
				 }
			       else
				 {	/* Ast/hrtype.scm 91 */
				    BUNSPEC;
				 }
			    }
			    {	/* Ast/hrtype.scm 93 */
			       bool_t aux_1421;
			       aux_1421 =
				  hrtype_node___80_ast_hrtype(
				  (((pragma_bglt) CREF(node_1088))->args));
			       return
				  BBOOL(aux_1421);
			    }
			 }
			 break;
		      case ((long) 9):

			 {	/* Ast/hrtype.scm 99 */
			    cast_bglt node_1096;
			    node_1096 =
			       (cast_bglt) (node_1);
			    {
			       node_bglt node_1426;
			       node_1426 =
				  (((cast_bglt) CREF(node_1096))->arg);
			       node_1 = node_1426;
			       goto hrtype_node__16_ast_hrtype;
			    }
			 }
			 break;
		      case ((long) 10):

			 {	/* Ast/hrtype.scm 106 */
			    setq_bglt node_1099;
			    node_1099 =
			       (setq_bglt) (node_1);
			    hrtype_node__16_ast_hrtype(
			       (((setq_bglt) CREF(node_1099))->value));
			    {
			       node_bglt node_1431;
			       {	/* Ast/hrtype.scm 108 */
				  var_bglt aux_1432;
				  aux_1432 =
				     (((setq_bglt) CREF(node_1099))->var);
				  node_1431 =
				     (node_bglt) (aux_1432);
			       }
			       node_1 = node_1431;
			       goto hrtype_node__16_ast_hrtype;
			    }
			 }
			 break;
		      case ((long) 11):

			 {	/* Ast/hrtype.scm 114 */
			    conditional_bglt node_1103;
			    node_1103 =
			       (conditional_bglt) (node_1);
			    hrtype_node__16_ast_hrtype(
			       (((conditional_bglt) CREF(node_1103))->test));
			    hrtype_node__16_ast_hrtype(
			       (((conditional_bglt) CREF(node_1103))->true));
			    {
			       node_bglt node_1440;
			       node_1440 =
				  (((conditional_bglt) CREF(node_1103))->false);
			       node_1 = node_1440;
			       goto hrtype_node__16_ast_hrtype;
			    }
			 }
			 break;
		      case ((long) 12):

			 {	/* Ast/hrtype.scm 123 */
			    fail_bglt node_1108;
			    node_1108 =
			       (fail_bglt) (node_1);
			    hrtype_node__16_ast_hrtype(
			       (((fail_bglt) CREF(node_1108))->proc));
			    hrtype_node__16_ast_hrtype(
			       (((fail_bglt) CREF(node_1108))->msg));
			    {
			       node_bglt node_1447;
			       node_1447 =
				  (((fail_bglt) CREF(node_1108))->obj);
			       node_1 = node_1447;
			       goto hrtype_node__16_ast_hrtype;
			    }
			 }
			 break;
		      case ((long) 13):

			 {	/* Ast/hrtype.scm 132 */
			    select_bglt node_1113;
			    node_1113 =
			       (select_bglt) (node_1);
			    hrtype_node__16_ast_hrtype(
			       (((select_bglt) CREF(node_1113))->test));
			    {
			       obj_t l1447_1116;
			       {	/* Ast/hrtype.scm 134 */
				  bool_t aux_1452;
				  l1447_1116 =
				     (((select_bglt) CREF(node_1113))->clauses);
				lname1448_1117:
				  if (
				     PAIRP(l1447_1116))
				    {	/* Ast/hrtype.scm 134 */
				       {	/* Ast/hrtype.scm 135 */
					  node_bglt aux_1455;
					  {	/* Ast/hrtype.scm 135 */
					     obj_t aux_1456;
					     {	/* ./Ieee/pair-list.scm 5707 */
						obj_t aux_1457;
						aux_1457 =
						   CAR(l1447_1116);
						aux_1456 =
						   CDR(aux_1457);
					     }
					     aux_1455 =
						(node_bglt) (aux_1456);
					  }
					  hrtype_node__16_ast_hrtype(aux_1455);
				       }
				       {
					  obj_t l1447_1462;
					  l1447_1462 =
					     CDR(l1447_1116);
					  l1447_1116 = l1447_1462;
					  goto lname1448_1117;
				       }
				    }
				  else
				    {	/* Ast/hrtype.scm 134 */
				       aux_1452 = ((bool_t) 1);
				    }
				  return
				     BBOOL(aux_1452);
			       }
			    }
			 }
			 break;
		      case ((long) 14):

			 {	/* Ast/hrtype.scm 142 */
			    let_fun_218_bglt node_1123;
			    node_1123 =
			       (let_fun_218_bglt) (node_1);
			    {
			       obj_t l1450_1125;
			       l1450_1125 =
				  (((let_fun_218_bglt) CREF(node_1123))->locals);
			     lname1451_1126:
			       if (
				  PAIRP(l1450_1125))
				 {	/* Ast/hrtype.scm 143 */
				    {	/* Ast/hrtype.scm 144 */
				       obj_t local_1129;
				       local_1129 =
					  CAR(l1450_1125);
				       {	/* Ast/hrtype.scm 144 */
					  value_bglt sfun_1130;
					  {	/* Ast/hrtype.scm 144 */
					     local_bglt obj_1252;
					     obj_1252 =
						(local_bglt) (local_1129);
					     sfun_1130 =
						(((local_bglt) CREF(obj_1252))->value);
					  }
					  {
					     obj_t args_1131;
					     {	/* Ast/hrtype.scm 145 */
						sfun_bglt obj_1253;
						obj_1253 =
						   (sfun_bglt) (sfun_1130);
						args_1131 =
						   (((sfun_bglt) CREF(obj_1253))->args);
					     }
					   loop_1132:
					     if (
						PAIRP(args_1131))
					       {	/* Ast/hrtype.scm 147 */
						  obj_t arg_1135;
						  arg_1135 =
						     CAR(args_1131);
						  {	/* Ast/hrtype.scm 149 */
						     bool_t test1639_1136;
						     test1639_1136 =
							is_a__118___object(arg_1135, type_type_type);
						     if (test1639_1136)
						       {	/* Ast/hrtype.scm 149 */
							  {	/* Ast/hrtype.scm 150 */
							     type_bglt arg1640_1137;
							     {	/* Ast/hrtype.scm 150 */
								obj_t aux_1477;
								{	/* Ast/hrtype.scm 150 */
								   type_bglt obj_1257;
								   obj_1257 =
								      (type_bglt) (arg_1135);
								   aux_1477 =
								      (((type_bglt) CREF(obj_1257))->id);
								}
								arg1640_1137 =
								   find_type_26_type_env(aux_1477);
							     }
							     {	/* ./Ieee/pair-list.scm 5890 */
								obj_t aux_1481;
								aux_1481 =
								   (obj_t) (arg1640_1137);
								SET_CAR(args_1131, aux_1481);
							     }
							  }
						       }
						     else
						       {	/* Ast/hrtype.scm 151 */
							  bool_t test1642_1139;
							  test1642_1139 =
							     is_a__118___object(arg_1135, local_ast_var);
							  if (test1642_1139)
							    {	/* Ast/hrtype.scm 151 */
							       restore_variable_type__109_ast_hrtype(
								  (variable_bglt) (arg_1135));
							    }
							  else
							    {	/* Ast/hrtype.scm 151 */
							       {	/* Ast/hrtype.scm 154 */
								  obj_t arg1646_1142;
								  arg1646_1142 =
								     shape_tools_shape(arg_1135);
								  FAILURE(string1672_ast_hrtype, string1674_ast_hrtype, arg1646_1142);
							       }
							    }
						       }
						  }
						  {
						     obj_t args_1490;
						     args_1490 =
							CDR(args_1131);
						     args_1131 = args_1490;
						     goto loop_1132;
						  }
					       }
					     else
					       {	/* Ast/hrtype.scm 146 */
						  BUNSPEC;
					       }
					  }
					  restore_variable_type__109_ast_hrtype(
					     (variable_bglt) (local_1129));
					  {	/* Ast/hrtype.scm 159 */
					     node_bglt aux_1496;
					     {	/* Ast/hrtype.scm 159 */
						obj_t aux_1497;
						{	/* Ast/hrtype.scm 159 */
						   sfun_bglt obj_1265;
						   obj_1265 =
						      (sfun_bglt) (sfun_1130);
						   aux_1497 =
						      (((sfun_bglt) CREF(obj_1265))->body);
						}
						aux_1496 =
						   (node_bglt) (aux_1497);
					     }
					     hrtype_node__16_ast_hrtype(aux_1496);
					  }
				       }
				    }
				    {
				       obj_t l1450_1502;
				       l1450_1502 =
					  CDR(l1450_1125);
				       l1450_1125 = l1450_1502;
				       goto lname1451_1126;
				    }
				 }
			       else
				 {	/* Ast/hrtype.scm 143 */
				    ((bool_t) 1);
				 }
			    }
			    {
			       node_bglt node_1505;
			       node_1505 =
				  (((let_fun_218_bglt) CREF(node_1123))->body);
			       node_1 = node_1505;
			       goto hrtype_node__16_ast_hrtype;
			    }
			 }
			 break;
		      case ((long) 15):

			 {	/* Ast/hrtype.scm 167 */
			    let_var_6_bglt node_1147;
			    node_1147 =
			       (let_var_6_bglt) (node_1);
			    {
			       obj_t l1453_1149;
			       l1453_1149 =
				  (((let_var_6_bglt) CREF(node_1147))->bindings);
			     lname1454_1150:
			       if (
				  PAIRP(l1453_1149))
				 {	/* Ast/hrtype.scm 168 */
				    {	/* Ast/hrtype.scm 169 */
				       obj_t binding_1153;
				       binding_1153 =
					  CAR(l1453_1149);
				       {	/* Ast/hrtype.scm 169 */
					  obj_t var_1154;
					  var_1154 =
					     CAR(binding_1153);
					  {	/* Ast/hrtype.scm 171 */
					     node_bglt aux_1512;
					     {	/* Ast/hrtype.scm 171 */
						obj_t aux_1513;
						aux_1513 =
						   CDR(binding_1153);
						aux_1512 =
						   (node_bglt) (aux_1513);
					     }
					     hrtype_node__16_ast_hrtype(aux_1512);
					  }
					  restore_variable_type__109_ast_hrtype(
					     (variable_bglt) (var_1154));
				       }
				    }
				    {
				       obj_t l1453_1519;
				       l1453_1519 =
					  CDR(l1453_1149);
				       l1453_1149 = l1453_1519;
				       goto lname1454_1150;
				    }
				 }
			       else
				 {	/* Ast/hrtype.scm 168 */
				    ((bool_t) 1);
				 }
			    }
			    {
			       node_bglt node_1522;
			       node_1522 =
				  (((let_var_6_bglt) CREF(node_1147))->body);
			       node_1 = node_1522;
			       goto hrtype_node__16_ast_hrtype;
			    }
			 }
			 break;
		      case ((long) 16):

			 {	/* Ast/hrtype.scm 180 */
			    set_ex_it_116_bglt node_1158;
			    node_1158 =
			       (set_ex_it_116_bglt) (node_1);
			    {	/* Ast/hrtype.scm 181 */
			       variable_bglt aux_1525;
			       {	/* Ast/hrtype.scm 181 */
				  var_bglt arg1656_1161;
				  arg1656_1161 =
				     (((set_ex_it_116_bglt) CREF(node_1158))->var);
				  aux_1525 =
				     (((var_bglt) CREF(arg1656_1161))->variable);
			       }
			       restore_variable_type__109_ast_hrtype(aux_1525);
			    }
			    hrtype_node__16_ast_hrtype(
			       (((set_ex_it_116_bglt) CREF(node_1158))->body));
			    {
			       node_bglt node_1531;
			       {	/* Ast/hrtype.scm 183 */
				  var_bglt aux_1532;
				  aux_1532 =
				     (((set_ex_it_116_bglt) CREF(node_1158))->var);
				  node_1531 =
				     (node_bglt) (aux_1532);
			       }
			       node_1 = node_1531;
			       goto hrtype_node__16_ast_hrtype;
			    }
			 }
			 break;
		      case ((long) 17):

			 {	/* Ast/hrtype.scm 189 */
			    jump_ex_it_184_bglt node_1164;
			    node_1164 =
			       (jump_ex_it_184_bglt) (node_1);
			    hrtype_node__16_ast_hrtype(
			       (((jump_ex_it_184_bglt) CREF(node_1164))->exit));
			    {
			       node_bglt node_1538;
			       node_1538 =
				  (((jump_ex_it_184_bglt) CREF(node_1164))->value);
			       node_1 = node_1538;
			       goto hrtype_node__16_ast_hrtype;
			    }
			 }
			 break;
		      case ((long) 18):

			 {	/* Ast/hrtype.scm 197 */
			    make_box_202_bglt node_1168;
			    node_1168 =
			       (make_box_202_bglt) (node_1);
			    {
			       node_bglt node_1541;
			       node_1541 =
				  (((make_box_202_bglt) CREF(node_1168))->value);
			       node_1 = node_1541;
			       goto hrtype_node__16_ast_hrtype;
			    }
			 }
			 break;
		      case ((long) 19):

			 {	/* Ast/hrtype.scm 204 */
			    box_set__221_bglt node_1171;
			    node_1171 =
			       (box_set__221_bglt) (node_1);
			    {	/* Ast/hrtype.scm 205 */
			       node_bglt aux_1544;
			       {	/* Ast/hrtype.scm 205 */
				  var_bglt aux_1545;
				  aux_1545 =
				     (((box_set__221_bglt) CREF(node_1171))->var);
				  aux_1544 =
				     (node_bglt) (aux_1545);
			       }
			       hrtype_node__16_ast_hrtype(aux_1544);
			    }
			    {
			       node_bglt node_1549;
			       node_1549 =
				  (((box_set__221_bglt) CREF(node_1171))->value);
			       node_1 = node_1549;
			       goto hrtype_node__16_ast_hrtype;
			    }
			 }
			 break;
		      case ((long) 20):

			 {	/* Ast/hrtype.scm 212 */
			    box_ref_242_bglt node_1175;
			    node_1175 =
			       (box_ref_242_bglt) (node_1);
			    {
			       node_bglt node_1552;
			       {	/* Ast/hrtype.scm 213 */
				  var_bglt aux_1553;
				  aux_1553 =
				     (((box_ref_242_bglt) CREF(node_1175))->var);
				  node_1552 =
				     (node_bglt) (aux_1553);
			       }
			       node_1 = node_1552;
			       goto hrtype_node__16_ast_hrtype;
			    }
			 }
			 break;
		      default:
		       case_else1600_1064:
			 if (
			    PROCEDUREP(method1594_1060))
			   {	/* Ast/hrtype.scm 30 */
			      return
				 PROCEDURE_ENTRY(method1594_1060) (method1594_1060,
				 (obj_t) (node_1), BEOA);
			   }
			 else
			   {	/* Ast/hrtype.scm 30 */
			      obj_t fun1593_1056;
			      fun1593_1056 =
				 PROCEDURE_REF(hrtype_node__env_165_ast_hrtype, ((long) 0));
			      return
				 PROCEDURE_ENTRY(fun1593_1056) (fun1593_1056,
				 (obj_t) (node_1), BEOA);
			   }
		      }
		 }
	       else
		 {	/* Ast/hrtype.scm 30 */
		    goto case_else1600_1064;
		 }
	    }
	 }
      }
   }
}



/* _hrtype-node! */
obj_t 
_hrtype_node__147_ast_hrtype(obj_t env_1290, obj_t node_1291)
{
   AN_OBJECT;
   {	/* Ast/hrtype.scm 30 */
      return
	 hrtype_node__16_ast_hrtype(
	 (node_bglt) (node_1291));
   }
}



/* hrtype-node!-default1463 */
obj_t 
hrtype_node__default1463_83_ast_hrtype(node_bglt node_2)
{
   AN_OBJECT;
   {	/* Ast/hrtype.scm 17 */
      FAILURE(
	 CNST_TABLE_REF(((long) 0)), string1675_ast_hrtype,
	 (obj_t) (node_2));
   }
}



/* _hrtype-node!-default1463 */
obj_t 
_hrtype_node__default1463_76_ast_hrtype(obj_t env_1292, obj_t node_1293)
{
   AN_OBJECT;
   {	/* Ast/hrtype.scm 17 */
      return
	 hrtype_node__default1463_83_ast_hrtype(
	 (node_bglt) (node_1293));
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_ast_hrtype()
{
   AN_OBJECT;
   {	/* Ast/hrtype.scm 17 */
      module_initialization_70_type_type(((long) 0), "AST_HRTYPE");
      module_initialization_70_type_env(((long) 0), "AST_HRTYPE");
      module_initialization_70_tools_shape(((long) 0), "AST_HRTYPE");
      module_initialization_70_tools_error(((long) 0), "AST_HRTYPE");
      module_initialization_70_coerce_typeof(((long) 0), "AST_HRTYPE");
      module_initialization_70_ast_var(((long) 0), "AST_HRTYPE");
      return
	 module_initialization_70_ast_node(((long) 0), "AST_HRTYPE");
   }
}
