/*===========================================================================*/
/*   (Ast/labels.scm)                                                        */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;


static obj_t method_init_76_ast_labels();
static obj_t allocate_sfuns_248_ast_labels(obj_t, obj_t);
extern obj_t find_location_loc_243_tools_location(obj_t, obj_t);
extern obj_t leave_function_170_tools_error();
static obj_t _labels__node_87_ast_labels(obj_t, obj_t, obj_t, obj_t, obj_t);
extern bool_t user_symbol__147_ast_ident(obj_t);
extern obj_t _obj__252_type_cache;
extern obj_t last_pair_93___r4_pairs_and_lists_6_3(obj_t);
extern obj_t module_initialization_70_ast_labels(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_tools_progn(long, char *);
extern obj_t module_initialization_70_tools_args(long, char *);
extern obj_t module_initialization_70_tools_location(long, char *);
extern obj_t module_initialization_70_tools_dsssl(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_ast_sexp(long, char *);
extern obj_t module_initialization_70_ast_ident(long, char *);
extern obj_t module_initialization_70_ast_local(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___dsssl(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern local_bglt make_local_svar_140_ast_local(obj_t, type_bglt);
extern long class_num_218___object(obj_t);
extern obj_t let_fun_218_ast_node;
static obj_t imported_modules_init_94_ast_labels();
extern obj_t normalize_progn_143_tools_progn(obj_t);
extern obj_t append_2_18___r4_pairs_and_lists_6_3(obj_t, obj_t);
static obj_t library_modules_init_112_ast_labels();
static obj_t toplevel_init_63_ast_labels();
extern node_bglt sexp__node_235_ast_sexp(obj_t, obj_t, obj_t, obj_t);
extern obj_t open_input_string(obj_t);
extern local_bglt make_local_sfun_184_ast_local(obj_t, type_bglt, sfun_bglt);
extern obj_t sfun_ast_var;
extern int arity_tools_args(obj_t);
extern obj_t dsssl_args___args_list_201_tools_dsssl(obj_t);
extern obj_t parse_id_241_ast_ident(obj_t, obj_t);
extern node_bglt error_sexp__node_157_ast_sexp(obj_t, obj_t, obj_t);
extern obj_t enter_function_81_tools_error(obj_t);
extern local_bglt make_user_local_svar_134_ast_local(obj_t, type_bglt);
static obj_t labels_binding_77_ast_labels(obj_t, obj_t, obj_t, obj_t);
extern let_fun_218_bglt labels__node_197_ast_labels(obj_t, obj_t, obj_t, obj_t);
extern obj_t read___reader(obj_t);
extern obj_t make_dsssl_function_prelude_58___dsssl(obj_t, obj_t, obj_t, obj_t);
extern obj_t ____74_type_cache;
static obj_t require_initialization_114_ast_labels = BUNSPEC;
static obj_t cnst_init_137_ast_labels();
extern obj_t reverse__39___r4_pairs_and_lists_6_3(obj_t);
extern local_bglt make_user_local_sfun_221_ast_local(obj_t, type_bglt, sfun_bglt);
static obj_t __cnst[2];

DEFINE_EXPORT_PROCEDURE(labels__node_env_244_ast_labels, _labels__node_87_ast_labels1631, _labels__node_87_ast_labels, 0L, 4);
extern obj_t user_error_env_101_tools_error;
DEFINE_STRING(string1626_ast_labels, string1626_ast_labels1632, "VALUE PLAIN ", 12);
DEFINE_STRING(string1625_ast_labels, string1625_ast_labels1633, "Illegal `labels' form", 21);
DEFINE_STRING(string1624_ast_labels, string1624_ast_labels1634, "Illegal `binding' form", 22);
DEFINE_STRING(string1623_ast_labels, string1623_ast_labels1635, "Illegal formal type", 19);
DEFINE_STRING(string1622_ast_labels, string1622_ast_labels1636, "Illegal `labels' expression", 27);



/* module-initialization */
obj_t 
module_initialization_70_ast_labels(long checksum_1366, char *from_1367)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_ast_labels))
	{
	   require_initialization_114_ast_labels =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_ast_labels();
	   cnst_init_137_ast_labels();
	   imported_modules_init_94_ast_labels();
	   method_init_76_ast_labels();
	   toplevel_init_63_ast_labels();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_ast_labels()
{
   AN_OBJECT;
   {	/* Ast/labels.scm 14 */
      module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "AST_LABELS");
      module_initialization_70___object(((long) 0), "AST_LABELS");
      module_initialization_70___reader(((long) 0), "AST_LABELS");
      module_initialization_70___dsssl(((long) 0), "AST_LABELS");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_ast_labels()
{
   AN_OBJECT;
   {	/* Ast/labels.scm 14 */
      {		/* Ast/labels.scm 14 */
	 obj_t cnst_port_138_1359;
	 cnst_port_138_1359 =
	    open_input_string(string1626_ast_labels);
	 {
	    long i_1360;
	    i_1360 = ((long) 1);
	  loop_1361:
	    {	/* Ast/labels.scm 14 */
	       bool_t test1627_1362;
	       test1627_1362 =
		  (i_1360 == ((long) -1));
	       if (test1627_1362)
		 {	/* Ast/labels.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Ast/labels.scm 14 */
		    {	/* Ast/labels.scm 14 */
		       obj_t arg1628_1363;
		       {	/* Ast/labels.scm 14 */
			  obj_t list1629_1364;
			  list1629_1364 =
			     MAKE_PAIR(cnst_port_138_1359, BNIL);
			  arg1628_1363 =
			     read___reader(list1629_1364);
		       }
		       CNST_TABLE_SET(i_1360, arg1628_1363);
		    }
		    {	/* Ast/labels.scm 14 */
		       int aux_1365;
		       {	/* Ast/labels.scm 14 */
			  long aux_1386;
			  aux_1386 =
			     (i_1360 - ((long) 1));
			  aux_1365 =
			     (int) (aux_1386);
		       }
		       {
			  long i_1389;
			  i_1389 =
			     (long) (aux_1365);
			  i_1360 = i_1389;
			  goto loop_1361;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_ast_labels()
{
   AN_OBJECT;
   {	/* Ast/labels.scm 14 */
      return BUNSPEC;
   }
}



/* labels->node */
let_fun_218_bglt 
labels__node_197_ast_labels(obj_t exp_15, obj_t stack_16, obj_t loc_17, obj_t site_18)
{
   AN_OBJECT;
   {	/* Ast/labels.scm 32 */
      {		/* Ast/labels.scm 33 */
	 obj_t loc_730;
	 loc_730 =
	    find_location_loc_243_tools_location(exp_15, loc_17);
	 {
	    obj_t bindings_731;
	    obj_t body_732;
	    if (
	       PAIRP(exp_15))
	      {		/* Ast/labels.scm 34 */
		 obj_t cdr_128_145_737;
		 cdr_128_145_737 =
		    CDR(exp_15);
		 if (
		    PAIRP(cdr_128_145_737))
		   {	/* Ast/labels.scm 34 */
		      obj_t car_131_9_739;
		      car_131_9_739 =
			 CAR(cdr_128_145_737);
		      if (
			 PAIRP(car_131_9_739))
			{	/* Ast/labels.scm 34 */
			   bindings_731 = car_131_9_739;
			   body_732 =
			      CDR(cdr_128_145_737);
			   {	/* Ast/labels.scm 36 */
			      obj_t locals_742;
			      locals_742 =
				 allocate_sfuns_248_ast_labels(bindings_731, loc_730);
			      {		/* Ast/labels.scm 36 */
				 obj_t new_stack_37_743;
				 new_stack_37_743 =
				    append_2_18___r4_pairs_and_lists_6_3(locals_742, stack_16);
				 {	/* Ast/labels.scm 37 */
				    node_bglt body_744;
				    {	/* Ast/labels.scm 38 */
				       obj_t arg1476_759;
				       arg1476_759 =
					  normalize_progn_143_tools_progn(body_732);
				       body_744 =
					  sexp__node_235_ast_sexp(arg1476_759, new_stack_37_743, loc_730, site_18);
				    }
				    {	/* Ast/labels.scm 38 */
				       obj_t loc_745;
				       loc_745 =
					  find_location_loc_243_tools_location(exp_15, loc_730);
				       {	/* Ast/labels.scm 42 */

					  {
					     obj_t ll1437_746;
					     obj_t ll1438_747;
					     ll1437_746 = locals_742;
					     ll1438_747 = bindings_731;
					   lname1439_748:
					     if (
						NULLP(ll1437_746))
					       {	/* Ast/labels.scm 44 */
						  ((bool_t) 1);
					       }
					     else
					       {	/* Ast/labels.scm 44 */
						  labels_binding_77_ast_labels(
						     CAR(ll1437_746),
						     CAR(ll1438_747), new_stack_37_743, loc_745);
						  {
						     obj_t ll1438_1412;
						     obj_t ll1437_1410;
						     ll1437_1410 =
							CDR(ll1437_746);
						     ll1438_1412 =
							CDR(ll1438_747);
						     ll1438_747 = ll1438_1412;
						     ll1437_746 = ll1437_1410;
						     goto lname1439_748;
						  }
					       }
					  }
					  {	/* Ast/labels.scm 48 */
					     type_bglt arg1472_755;
					     arg1472_755 =
						(((node_bglt) CREF(body_744))->type);
					     {	/* Ast/labels.scm 48 */
						let_fun_218_bglt res1616_1223;
						{	/* Ast/labels.scm 48 */
						   obj_t key_1210;
						   key_1210 =
						      BINT(((long) -1));
						   {	/* ./Ast/node.scm 763 */
						      let_fun_218_bglt new1358_1213;
						      new1358_1213 =
							 ((let_fun_218_bglt) BREF(GC_MALLOC(sizeof(struct let_fun_218))));
						      {		/* ./Ast/node.scm 763 */
							 long arg1555_1214;
							 arg1555_1214 =
							    class_num_218___object(let_fun_218_ast_node);
							 {	/* ./Ast/node.scm 763 */
							    obj_t obj_1221;
							    obj_1221 =
							       (obj_t) (new1358_1213);
							    (((obj_t) CREF(obj_1221))->header = MAKE_HEADER(arg1555_1214, 0), BUNSPEC);
							 }
						      }
						      {		/* ./Ast/node.scm 763 */
							 object_bglt aux_1420;
							 aux_1420 =
							    (object_bglt) (new1358_1213);
							 OBJECT_WIDENING_SET(aux_1420, BFALSE);
						      }
						      ((((let_fun_218_bglt) CREF(new1358_1213))->loc) = ((obj_t) loc_745), BUNSPEC);
						      ((((let_fun_218_bglt) CREF(new1358_1213))->type) = ((type_bglt) arg1472_755), BUNSPEC);
						      ((((let_fun_218_bglt) CREF(new1358_1213))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
						      ((((let_fun_218_bglt) CREF(new1358_1213))->key) = ((obj_t) key_1210), BUNSPEC);
						      ((((let_fun_218_bglt) CREF(new1358_1213))->locals) = ((obj_t) locals_742), BUNSPEC);
						      ((((let_fun_218_bglt) CREF(new1358_1213))->body) = ((node_bglt) body_744), BUNSPEC);
						      res1616_1223 = new1358_1213;
						   }
						}
						return res1616_1223;
					     }
					  }
				       }
				    }
				 }
			      }
			   }
			}
		      else
			{	/* Ast/labels.scm 34 */
			   node_bglt aux_1430;
			 tag_121_151_734:
			   aux_1430 =
			      error_sexp__node_157_ast_sexp(string1622_ast_labels, exp_15, loc_730);
			   return
			      (let_fun_218_bglt) (aux_1430);
			}
		   }
		 else
		   {	/* Ast/labels.scm 34 */
		      node_bglt aux_1433;
		      goto tag_121_151_734;
		      return
			 (let_fun_218_bglt) (aux_1433);
		   }
	      }
	    else
	      {		/* Ast/labels.scm 34 */
		 node_bglt aux_1435;
		 goto tag_121_151_734;
		 return
		    (let_fun_218_bglt) (aux_1435);
	      }
	 }
      }
   }
}



/* _labels->node */
obj_t 
_labels__node_87_ast_labels(obj_t env_1348, obj_t exp_1349, obj_t stack_1350, obj_t loc_1351, obj_t site_1352)
{
   AN_OBJECT;
   {	/* Ast/labels.scm 32 */
      {		/* Ast/labels.scm 32 */
	 let_fun_218_bglt aux_1437;
	 aux_1437 =
	    labels__node_197_ast_labels(exp_1349, stack_1350, loc_1351, site_1352);
	 return
	    (obj_t) (aux_1437);
      }
   }
}



/* allocate-sfuns */
obj_t 
allocate_sfuns_248_ast_labels(obj_t bindings_19, obj_t loc_20)
{
   AN_OBJECT;
   {	/* Ast/labels.scm 58 */
      {
	 obj_t bindings_760;
	 obj_t res_761;
	 bindings_760 = bindings_19;
	 res_761 = BNIL;
       loop_762:
	 if (
	    NULLP(bindings_760))
	   {	/* Ast/labels.scm 61 */
	      return
		 reverse__39___r4_pairs_and_lists_6_3(res_761);
	   }
	 else
	   {
	      obj_t fun_764;
	      obj_t args_765;
	      obj_t body_766;
	      {		/* Ast/labels.scm 63 */
		 obj_t e_139_15_769;
		 e_139_15_769 =
		    CAR(bindings_760);
		 if (
		    PAIRP(e_139_15_769))
		   {	/* Ast/labels.scm 63 */
		      obj_t car_146_142_771;
		      obj_t cdr_147_183_772;
		      car_146_142_771 =
			 CAR(e_139_15_769);
		      cdr_147_183_772 =
			 CDR(e_139_15_769);
		      if (
			 SYMBOLP(car_146_142_771))
			{	/* Ast/labels.scm 63 */
			   if (
			      PAIRP(cdr_147_183_772))
			     {	/* Ast/labels.scm 63 */
				fun_764 = car_146_142_771;
				args_765 =
				   CAR(cdr_147_183_772);
				body_766 =
				   CDR(cdr_147_183_772);
				{	/* Ast/labels.scm 65 */
				   obj_t loc_777;
				   loc_777 =
				      find_location_loc_243_tools_location(
				      CAR(bindings_760), loc_20);
				   {	/* Ast/labels.scm 65 */
				      obj_t id_type_89_778;
				      id_type_89_778 =
					 parse_id_241_ast_ident(fun_764, loc_777);
				      {		/* Ast/labels.scm 66 */
					 obj_t id_779;
					 id_779 =
					    CAR(id_type_89_778);
					 {	/* Ast/labels.scm 67 */
					    obj_t type_780;
					    type_780 =
					       CDR(id_type_89_778);
					    {	/* Ast/labels.scm 68 */
					       int arity_781;
					       arity_781 =
						  arity_tools_args(args_765);
					       {	/* Ast/labels.scm 69 */
						  obj_t formals_782;
						  {	/* Ast/labels.scm 70 */
						     obj_t l1441_822;
						     l1441_822 =
							dsssl_args___args_list_201_tools_dsssl(args_765);
						     if (
							NULLP(l1441_822))
						       {	/* Ast/labels.scm 70 */
							  formals_782 = BNIL;
						       }
						     else
						       {	/* Ast/labels.scm 70 */
							  obj_t head1443_824;
							  head1443_824 =
							     MAKE_PAIR(BNIL, BNIL);
							  {
							     obj_t l1441_825;
							     obj_t tail1444_826;
							     l1441_825 = l1441_822;
							     tail1444_826 = head1443_824;
							   lname1442_827:
							     if (
								NULLP(l1441_825))
							       {	/* Ast/labels.scm 70 */
								  formals_782 =
								     CDR(head1443_824);
							       }
							     else
							       {	/* Ast/labels.scm 71 */
								  obj_t newtail1445_829;
								  {	/* Ast/labels.scm 71 */
								     obj_t arg1516_831;
								     arg1516_831 =
									parse_id_241_ast_ident(
									CAR(l1441_825), loc_777);
								     newtail1445_829 =
									MAKE_PAIR(arg1516_831, BNIL);
								  }
								  SET_CDR(tail1444_826, newtail1445_829);
								  {
								     obj_t tail1444_1471;
								     obj_t l1441_1469;
								     l1441_1469 =
									CDR(l1441_825);
								     tail1444_1471 = newtail1445_829;
								     tail1444_826 = tail1444_1471;
								     l1441_825 = l1441_1469;
								     goto lname1442_827;
								  }
							       }
							  }
						       }
						  }
						  {	/* Ast/labels.scm 70 */

						     {	/* Ast/labels.scm 74 */
							bool_t test1483_783;
							{	/* Ast/labels.scm 74 */
							   bool_t test_1472;
							   {	/* ./Ieee/fixnum.scm 7133 */
							      long aux_1473;
							      aux_1473 =
								 (long) (arity_781);
							      test_1472 =
								 (aux_1473 >= ((long) 0));
							   }
							   if (test_1472)
							     {	/* Ast/labels.scm 74 */
								test1483_783 = ((bool_t) 1);
							     }
							   else
							     {	/* Ast/labels.scm 75 */
								obj_t larg_817;
								{	/* ./Ieee/pair-list.scm 5701 */
								   obj_t aux_1476;
								   aux_1476 =
								      last_pair_93___r4_pairs_and_lists_6_3(formals_782);
								   larg_817 =
								      CAR(aux_1476);
								}
								{	/* Ast/labels.scm 75 */
								   obj_t type_818;
								   type_818 =
								      CDR(larg_817);
								   {	/* Ast/labels.scm 76 */

								      {		/* Ast/labels.scm 78 */
									 bool_t test1510_819;
									 {	/* Ast/labels.scm 78 */
									    obj_t obj2_1252;
									    obj2_1252 = _obj__252_type_cache;
									    test1510_819 =
									       (type_818 == obj2_1252);
									 }
									 if (test1510_819)
									   {	/* Ast/labels.scm 78 */
									      test1483_783 = ((bool_t) 1);
									   }
									 else
									   {	/* Ast/labels.scm 80 */
									      bool_t test1511_820;
									      {		/* Ast/labels.scm 80 */
										 obj_t obj2_1254;
										 obj2_1254 = ____74_type_cache;
										 test1511_820 =
										    (type_818 == obj2_1254);
									      }
									      if (test1511_820)
										{	/* Ast/labels.scm 80 */
										   {	/* Ast/labels.scm 81 */
										      obj_t obj_1256;
										      obj_1256 = _obj__252_type_cache;
										      SET_CDR(larg_817, obj_1256);
										   }
										   test1483_783 = ((bool_t) 1);
										}
									      else
										{	/* Ast/labels.scm 80 */
										   test1483_783 = ((bool_t) 0);
										}
									   }
								      }
								   }
								}
							     }
							}
							if (test1483_783)
							  {	/* Ast/labels.scm 85 */
							     obj_t args_784;
							     if (
								NULLP(formals_782))
							       {	/* Ast/labels.scm 85 */
								  args_784 = BNIL;
							       }
							     else
							       {	/* Ast/labels.scm 85 */
								  obj_t head1448_798;
								  head1448_798 =
								     MAKE_PAIR(BNIL, BNIL);
								  {
								     obj_t l1446_799;
								     obj_t tail1449_800;
								     l1446_799 = formals_782;
								     tail1449_800 = head1448_798;
								   lname1447_801:
								     if (
									NULLP(l1446_799))
								       {	/* Ast/labels.scm 85 */
									  args_784 =
									     CDR(head1448_798);
								       }
								     else
								       {	/* Ast/labels.scm 86 */
									  obj_t newtail1450_803;
									  {	/* Ast/labels.scm 86 */
									     local_bglt arg1498_805;
									     {	/* Ast/labels.scm 86 */
										obj_t f_807;
										f_807 =
										   CAR(l1446_799);
										{	/* Ast/labels.scm 86 */
										   bool_t test1500_808;
										   test1500_808 =
										      user_symbol__147_ast_ident(
										      CAR(f_807));
										   if (test1500_808)
										     {	/* Ast/labels.scm 87 */
											type_bglt aux_1496;
											{	/* Ast/labels.scm 87 */
											   obj_t aux_1498;
											   aux_1498 =
											      CDR(f_807);
											   aux_1496 =
											      (type_bglt) (aux_1498);
											}
											arg1498_805 =
											   make_user_local_svar_134_ast_local(
											   CAR(f_807), aux_1496);
										     }
										   else
										     {	/* Ast/labels.scm 89 */
											type_bglt aux_1502;
											{	/* Ast/labels.scm 89 */
											   obj_t aux_1504;
											   aux_1504 =
											      CDR(f_807);
											   aux_1502 =
											      (type_bglt) (aux_1504);
											}
											arg1498_805 =
											   make_local_svar_140_ast_local(
											   CAR(f_807), aux_1502);
										     }
										}
									     }
									     {	/* ./Ieee/pair-list.scm 5689 */
										obj_t aux_1508;
										aux_1508 =
										   (obj_t) (arg1498_805);
										newtail1450_803 =
										   MAKE_PAIR(aux_1508, BNIL);
									     }
									  }
									  SET_CDR(tail1449_800, newtail1450_803);
									  {
									     obj_t tail1449_1514;
									     obj_t l1446_1512;
									     l1446_1512 =
										CDR(l1446_799);
									     tail1449_1514 = newtail1450_803;
									     tail1449_800 = tail1449_1514;
									     l1446_799 = l1446_1512;
									     goto lname1447_801;
									  }
								       }
								  }
							       }
							     {	/* Ast/labels.scm 85 */
								sfun_bglt sfun_785;
								{	/* Ast/labels.scm 92 */
								   obj_t arg1491_793;
								   obj_t arg1494_795;
								   arg1491_793 =
								      CNST_TABLE_REF(((long) 0));
								   arg1494_795 =
								      find_location_loc_243_tools_location(body_766, loc_777);
								   {	/* Ast/labels.scm 92 */
								      sfun_bglt res1617_1301;
								      {		/* Ast/labels.scm 92 */
									 long arity_1273;
									 obj_t predicate_of_78_1275;
									 obj_t stack_allocator_172_1276;
									 arity_1273 =
									    (long) (arity_781);
									 predicate_of_78_1275 = BFALSE;
									 stack_allocator_172_1276 = BFALSE;
									 {	/* ./Ast/var.scm 583 */
									    sfun_bglt new1127_1285;
									    new1127_1285 =
									       ((sfun_bglt) BREF(GC_MALLOC(sizeof(struct sfun))));
									    {	/* ./Ast/var.scm 583 */
									       long arg1602_1286;
									       arg1602_1286 =
										  class_num_218___object(sfun_ast_var);
									       {	/* ./Ast/var.scm 583 */
										  obj_t obj_1299;
										  obj_1299 =
										     (obj_t) (new1127_1285);
										  (((obj_t) CREF(obj_1299))->header = MAKE_HEADER(arg1602_1286, 0), BUNSPEC);
									       }
									    }
									    {	/* ./Ast/var.scm 583 */
									       object_bglt aux_1522;
									       aux_1522 =
										  (object_bglt) (new1127_1285);
									       OBJECT_WIDENING_SET(aux_1522, predicate_of_78_1275);
									    }
									    ((((sfun_bglt) CREF(new1127_1285))->arity) = ((long) arity_1273), BUNSPEC);
									    ((((sfun_bglt) CREF(new1127_1285))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
									    ((((sfun_bglt) CREF(new1127_1285))->predicate_of_78) = ((obj_t) predicate_of_78_1275), BUNSPEC);
									    ((((sfun_bglt) CREF(new1127_1285))->stack_allocator_172) = ((obj_t) stack_allocator_172_1276), BUNSPEC);
									    ((((sfun_bglt) CREF(new1127_1285))->top__138) = ((bool_t) ((bool_t) 1)), BUNSPEC);
									    ((((sfun_bglt) CREF(new1127_1285))->the_closure_238) = ((obj_t) BUNSPEC), BUNSPEC);
									    ((((sfun_bglt) CREF(new1127_1285))->property) = ((obj_t) BNIL), BUNSPEC);
									    ((((sfun_bglt) CREF(new1127_1285))->args) = ((obj_t) args_784), BUNSPEC);
									    ((((sfun_bglt) CREF(new1127_1285))->body) = ((obj_t) BUNSPEC), BUNSPEC);
									    ((((sfun_bglt) CREF(new1127_1285))->class) = ((obj_t) arg1491_793), BUNSPEC);
									    ((((sfun_bglt) CREF(new1127_1285))->dsssl_keywords_243) = ((obj_t) BNIL), BUNSPEC);
									    ((((sfun_bglt) CREF(new1127_1285))->loc) = ((obj_t) arg1494_795), BUNSPEC);
									    res1617_1301 = new1127_1285;
									 }
								      }
								      sfun_785 = res1617_1301;
								   }
								}
								{	/* Ast/labels.scm 92 */
								   local_bglt fun_786;
								   {	/* Ast/labels.scm 98 */
								      bool_t test1486_789;
								      test1486_789 =
									 user_symbol__147_ast_ident(id_779);
								      if (test1486_789)
									{	/* Ast/labels.scm 98 */
									   fun_786 =
									      make_user_local_sfun_221_ast_local(id_779,
									      (type_bglt) (type_780), sfun_785);
									}
								      else
									{	/* Ast/labels.scm 98 */
									   fun_786 =
									      make_local_sfun_184_ast_local(id_779,
									      (type_bglt) (type_780), sfun_785);
									}
								   }
								   {	/* Ast/labels.scm 98 */

								      {		/* Ast/labels.scm 101 */
									 obj_t arg1484_787;
									 obj_t arg1485_788;
									 arg1484_787 =
									    CDR(bindings_760);
									 {	/* ./Ieee/pair-list.scm 5689 */
									    obj_t aux_1544;
									    aux_1544 =
									       (obj_t) (fun_786);
									    arg1485_788 =
									       MAKE_PAIR(aux_1544, res_761);
									 }
									 {
									    obj_t res_1548;
									    obj_t bindings_1547;
									    bindings_1547 = arg1484_787;
									    res_1548 = arg1485_788;
									    res_761 = res_1548;
									    bindings_760 = bindings_1547;
									    goto loop_762;
									 }
								      }
								   }
								}
							     }
							  }
							else
							  {	/* Ast/labels.scm 74 */
							     error_sexp__node_157_ast_sexp(string1623_ast_labels,
								CAR(bindings_760), loc_777);
							     return BNIL;
							  }
						     }
						  }
					       }
					    }
					 }
				      }
				   }
				}
			     }
			   else
			     {	/* Ast/labels.scm 63 */
			      tag_138_212_768:
				error_sexp__node_157_ast_sexp(string1624_ast_labels,
				   CAR(bindings_760), loc_20);
				return BNIL;
			     }
			}
		      else
			{	/* Ast/labels.scm 63 */
			   goto tag_138_212_768;
			}
		   }
		 else
		   {	/* Ast/labels.scm 63 */
		      goto tag_138_212_768;
		   }
	      }
	   }
      }
   }
}



/* labels-binding */
obj_t 
labels_binding_77_ast_labels(obj_t local_21, obj_t binding_22, obj_t stack_23, obj_t loc_24)
{
   AN_OBJECT;
   {	/* Ast/labels.scm 116 */
      {
	 obj_t args_837;
	 obj_t body_838;
	 if (
	    PAIRP(binding_22))
	   {	/* Ast/labels.scm 117 */
	      obj_t cdr_165_174_843;
	      cdr_165_174_843 =
		 CDR(binding_22);
	      if (
		 PAIRP(cdr_165_174_843))
		{	/* Ast/labels.scm 117 */
		   args_837 =
		      CAR(cdr_165_174_843);
		   body_838 =
		      CDR(cdr_165_174_843);
		   {	/* Ast/labels.scm 119 */
		      obj_t aux_1560;
		      {		/* Ast/labels.scm 119 */
			 local_bglt obj_1312;
			 obj_1312 =
			    (local_bglt) (local_21);
			 aux_1560 =
			    (((local_bglt) CREF(obj_1312))->id);
		      }
		      enter_function_81_tools_error(aux_1560);
		   }
		   {	/* Ast/labels.scm 120 */
		      obj_t loc_848;
		      loc_848 =
			 find_location_loc_243_tools_location(binding_22, loc_24);
		      {		/* Ast/labels.scm 120 */
			 node_bglt body_849;
			 {	/* Ast/labels.scm 122 */
			    obj_t arg1530_852;
			    obj_t arg1532_853;
			    obj_t arg1533_854;
			    {	/* Ast/labels.scm 122 */
			       obj_t arg1534_855;
			       obj_t arg1535_856;
			       {	/* Ast/labels.scm 122 */
				  local_bglt obj_1313;
				  obj_1313 =
				     (local_bglt) (local_21);
				  arg1534_855 =
				     (((local_bglt) CREF(obj_1313))->id);
			       }
			       arg1535_856 =
				  normalize_progn_143_tools_progn(body_838);
			       arg1530_852 =
				  make_dsssl_function_prelude_58___dsssl(arg1534_855, args_837, arg1535_856, user_error_env_101_tools_error);
			    }
			    {	/* Ast/labels.scm 126 */
			       obj_t aux_1569;
			       {	/* Ast/labels.scm 126 */
				  sfun_bglt obj_1315;
				  {	/* Ast/labels.scm 126 */
				     value_bglt aux_1570;
				     {	/* Ast/labels.scm 126 */
					local_bglt obj_1314;
					obj_1314 =
					   (local_bglt) (local_21);
					aux_1570 =
					   (((local_bglt) CREF(obj_1314))->value);
				     }
				     obj_1315 =
					(sfun_bglt) (aux_1570);
				  }
				  aux_1569 =
				     (((sfun_bglt) CREF(obj_1315))->args);
			       }
			       arg1532_853 =
				  append_2_18___r4_pairs_and_lists_6_3(aux_1569, stack_23);
			    }
			    arg1533_854 =
			       CNST_TABLE_REF(((long) 1));
			    body_849 =
			       sexp__node_235_ast_sexp(arg1530_852, arg1532_853, loc_848, arg1533_854);
			 }
			 {	/* Ast/labels.scm 121 */

			    {	/* Ast/labels.scm 129 */
			       sfun_bglt obj_1317;
			       {	/* Ast/labels.scm 129 */
				  value_bglt aux_1578;
				  {	/* Ast/labels.scm 129 */
				     local_bglt obj_1316;
				     obj_1316 =
					(local_bglt) (local_21);
				     aux_1578 =
					(((local_bglt) CREF(obj_1316))->value);
				  }
				  obj_1317 =
				     (sfun_bglt) (aux_1578);
			       }
			       ((((sfun_bglt) CREF(obj_1317))->loc) = ((obj_t) loc_848), BUNSPEC);
			    }
			    {	/* Ast/labels.scm 130 */
			       sfun_bglt obj_1320;
			       obj_t val1123_1321;
			       {	/* Ast/labels.scm 130 */
				  value_bglt aux_1583;
				  {	/* Ast/labels.scm 130 */
				     local_bglt obj_1319;
				     obj_1319 =
					(local_bglt) (local_21);
				     aux_1583 =
					(((local_bglt) CREF(obj_1319))->value);
				  }
				  obj_1320 =
				     (sfun_bglt) (aux_1583);
			       }
			       val1123_1321 =
				  (obj_t) (body_849);
			       ((((sfun_bglt) CREF(obj_1320))->body) = ((obj_t) val1123_1321), BUNSPEC);
			    }
			    return
			       leave_function_170_tools_error();
			 }
		      }
		   }
		}
	      else
		{	/* Ast/labels.scm 117 */
		   node_bglt aux_1592;
		 tag_158_23_840:
		   aux_1592 =
		      error_sexp__node_157_ast_sexp(string1625_ast_labels, binding_22, loc_24);
		   return
		      (obj_t) (aux_1592);
		}
	   }
	 else
	   {	/* Ast/labels.scm 117 */
	      node_bglt aux_1595;
	      goto tag_158_23_840;
	      return
		 (obj_t) (aux_1595);
	   }
      }
   }
}



/* method-init */
obj_t 
method_init_76_ast_labels()
{
   AN_OBJECT;
   {	/* Ast/labels.scm 14 */
      return BUNSPEC;
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_ast_labels()
{
   AN_OBJECT;
   {	/* Ast/labels.scm 14 */
      module_initialization_70_type_type(((long) 0), "AST_LABELS");
      module_initialization_70_ast_var(((long) 0), "AST_LABELS");
      module_initialization_70_ast_node(((long) 0), "AST_LABELS");
      module_initialization_70_tools_trace(((long) 0), "AST_LABELS");
      module_initialization_70_tools_error(((long) 0), "AST_LABELS");
      module_initialization_70_tools_progn(((long) 0), "AST_LABELS");
      module_initialization_70_tools_args(((long) 0), "AST_LABELS");
      module_initialization_70_tools_location(((long) 0), "AST_LABELS");
      module_initialization_70_tools_dsssl(((long) 0), "AST_LABELS");
      module_initialization_70_type_cache(((long) 0), "AST_LABELS");
      module_initialization_70_ast_sexp(((long) 0), "AST_LABELS");
      module_initialization_70_ast_ident(((long) 0), "AST_LABELS");
      return
	 module_initialization_70_ast_local(((long) 0), "AST_LABELS");
   }
}
