/*===========================================================================*/
/*   (Ast/let.scm)                                                           */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;


static obj_t method_init_76_ast_let();
extern obj_t string_append(obj_t, obj_t);
extern obj_t find_location_loc_243_tools_location(obj_t, obj_t);
static obj_t _let__node_205_ast_let(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t sequence_ast_node;
extern obj_t let_var_6_ast_node;
extern obj_t var_ast_node;
extern node_bglt substitute__30_ast_substitute(obj_t, obj_t, node_bglt, obj_t);
extern bool_t user_symbol__147_ast_ident(obj_t);
extern obj_t _obj__252_type_cache;
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t _unspec__87_type_cache;
extern obj_t module_initialization_70_ast_let(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_tools_progn(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_location(long, char *);
extern obj_t module_initialization_70_ast_ident(long, char *);
extern obj_t module_initialization_70_ast_sexp(long, char *);
extern obj_t module_initialization_70_ast_local(long, char *);
extern obj_t module_initialization_70_ast_substitute(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern local_bglt make_local_svar_140_ast_local(obj_t, type_bglt);
extern long class_num_218___object(obj_t);
static let_var_6_bglt make_generic_let_111_ast_let(obj_t, obj_t, obj_t, obj_t);
extern obj_t let_fun_218_ast_node;
static obj_t imported_modules_init_94_ast_let();
static let_var_6_bglt let_or_letrec_20_ast_let(obj_t, let_var_6_bglt);
extern obj_t normalize_progn_143_tools_progn(obj_t);
extern obj_t append_2_18___r4_pairs_and_lists_6_3(obj_t, obj_t);
static obj_t library_modules_init_112_ast_let();
static obj_t toplevel_init_63_ast_let();
extern node_bglt sexp__node_235_ast_sexp(obj_t, obj_t, obj_t, obj_t);
extern obj_t open_input_string(obj_t);
extern obj_t use_variable__4_ast_sexp(variable_bglt, obj_t, obj_t);
extern obj_t sfun_ast_var;
static obj_t make_smart_generic_let_237_ast_let(obj_t, let_var_6_bglt, obj_t);
extern obj_t setq_ast_node;
extern obj_t parse_id_241_ast_ident(obj_t, obj_t);
extern node_bglt error_sexp__node_157_ast_sexp(obj_t, obj_t, obj_t);
extern node_bglt let__node_121_ast_let(obj_t, obj_t, obj_t, obj_t);
extern local_bglt make_user_local_svar_134_ast_local(obj_t, type_bglt);
extern obj_t _procedure__226_type_cache;
static let_fun_218_bglt let__labels_169_ast_let(obj_t, node_bglt, obj_t);
extern obj_t read___reader(obj_t);
extern obj_t ____74_type_cache;
static obj_t require_initialization_114_ast_let = BUNSPEC;
static obj_t cnst_init_137_ast_let();
extern obj_t reverse__39___r4_pairs_and_lists_6_3(obj_t);
static obj_t __cnst[5];

DEFINE_EXPORT_PROCEDURE(let__node_env_100_ast_let, _let__node_205_ast_let1761, _let__node_205_ast_let, 0L, 4);
DEFINE_STRING(string1755_ast_let, string1755_ast_let1762, "SET! WRITE LET VALUE LOCATION ", 30);
DEFINE_STRING(string1754_ast_let, string1754_ast_let1763, "Illegal form `", 14);
DEFINE_STRING(string1753_ast_let, string1753_ast_let1764, "' form", 6);



/* module-initialization */
obj_t 
module_initialization_70_ast_let(long checksum_1801, char *from_1802)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_ast_let))
	{
	   require_initialization_114_ast_let =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_ast_let();
	   cnst_init_137_ast_let();
	   imported_modules_init_94_ast_let();
	   method_init_76_ast_let();
	   toplevel_init_63_ast_let();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_ast_let()
{
   AN_OBJECT;
   {	/* Ast/let.scm 14 */
      module_initialization_70___object(((long) 0), "AST_LET");
      module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "AST_LET");
      module_initialization_70___reader(((long) 0), "AST_LET");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_ast_let()
{
   AN_OBJECT;
   {	/* Ast/let.scm 14 */
      {		/* Ast/let.scm 14 */
	 obj_t cnst_port_138_1794;
	 cnst_port_138_1794 =
	    open_input_string(string1755_ast_let);
	 {
	    long i_1795;
	    i_1795 = ((long) 4);
	  loop_1796:
	    {	/* Ast/let.scm 14 */
	       bool_t test1756_1797;
	       test1756_1797 =
		  (i_1795 == ((long) -1));
	       if (test1756_1797)
		 {	/* Ast/let.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Ast/let.scm 14 */
		    {	/* Ast/let.scm 14 */
		       obj_t arg1758_1798;
		       {	/* Ast/let.scm 14 */
			  obj_t list1759_1799;
			  list1759_1799 =
			     MAKE_PAIR(cnst_port_138_1794, BNIL);
			  arg1758_1798 =
			     read___reader(list1759_1799);
		       }
		       CNST_TABLE_SET(i_1795, arg1758_1798);
		    }
		    {	/* Ast/let.scm 14 */
		       int aux_1800;
		       {	/* Ast/let.scm 14 */
			  long aux_1820;
			  aux_1820 =
			     (i_1795 - ((long) 1));
			  aux_1800 =
			     (int) (aux_1820);
		       }
		       {
			  long i_1823;
			  i_1823 =
			     (long) (aux_1800);
			  i_1795 = i_1823;
			  goto loop_1796;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_ast_let()
{
   AN_OBJECT;
   {	/* Ast/let.scm 14 */
      return BUNSPEC;
   }
}



/* let->node */
node_bglt 
let__node_121_ast_let(obj_t exp_15, obj_t stack_16, obj_t oloc_17, obj_t site_18)
{
   AN_OBJECT;
   {	/* Ast/let.scm 31 */
      {
	 obj_t bindings_738;
	 obj_t body_736;
	 if (
	    PAIRP(exp_15))
	   {	/* Ast/let.scm 42 */
	      obj_t cdr_128_145_743;
	      cdr_128_145_743 =
		 CDR(exp_15);
	      if (
		 PAIRP(cdr_128_145_743))
		{	/* Ast/let.scm 42 */
		   bool_t test_1830;
		   {	/* ./Ieee/equiv.scm 5508 */
		      obj_t aux_1831;
		      aux_1831 =
			 CAR(cdr_128_145_743);
		      test_1830 =
			 (aux_1831 == BNIL);
		   }
		   if (test_1830)
		     {	/* Ast/let.scm 42 */
			let_var_6_bglt aux_1834;
			body_736 =
			   CDR(cdr_128_145_743);
			{	/* Ast/let.scm 45 */
			   obj_t nloc_751;
			   nloc_751 =
			      find_location_loc_243_tools_location(exp_15, oloc_17);
			   {	/* Ast/let.scm 45 */
			      obj_t bloc_752;
			      if (
				 PAIRP(body_736))
				{	/* Ast/let.scm 46 */
				   bloc_752 =
				      find_location_loc_243_tools_location(
				      CAR(body_736), nloc_751);
				}
			      else
				{	/* Ast/let.scm 46 */
				   bloc_752 = nloc_751;
				}
			      {		/* Ast/let.scm 46 */
				 node_bglt body_753;
				 {	/* Ast/let.scm 49 */
				    obj_t arg1491_760;
				    arg1491_760 =
				       normalize_progn_143_tools_progn(body_736);
				    body_753 =
				       sexp__node_235_ast_sexp(arg1491_760, stack_16, bloc_752, site_18);
				 }
				 {	/* Ast/let.scm 49 */

				    {	/* Ast/let.scm 54 */
				       type_bglt arg1485_755;
				       arg1485_755 =
					  (((node_bglt) CREF(body_753))->type);
				       {	/* Ast/let.scm 54 */
					  let_var_6_bglt res1746_1404;
					  {	/* Ast/let.scm 54 */
					     obj_t key_1389;
					     key_1389 =
						BINT(((long) -1));
					     {	/* ./Ast/node.scm 953 */
						let_var_6_bglt new1373_1393;
						new1373_1393 =
						   ((let_var_6_bglt) BREF(GC_MALLOC(sizeof(struct let_var_6))));
						{	/* ./Ast/node.scm 953 */
						   long arg1684_1394;
						   arg1684_1394 =
						      class_num_218___object(let_var_6_ast_node);
						   {	/* ./Ast/node.scm 953 */
						      obj_t obj_1402;
						      obj_1402 =
							 (obj_t) (new1373_1393);
						      (((obj_t) CREF(obj_1402))->header = MAKE_HEADER(arg1684_1394, 0), BUNSPEC);
						   }
						}
						{	/* ./Ast/node.scm 953 */
						   object_bglt aux_1848;
						   aux_1848 =
						      (object_bglt) (new1373_1393);
						   OBJECT_WIDENING_SET(aux_1848, BFALSE);
						}
						((((let_var_6_bglt) CREF(new1373_1393))->loc) = ((obj_t) nloc_751), BUNSPEC);
						((((let_var_6_bglt) CREF(new1373_1393))->type) = ((type_bglt) arg1485_755), BUNSPEC);
						((((let_var_6_bglt) CREF(new1373_1393))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
						((((let_var_6_bglt) CREF(new1373_1393))->key) = ((obj_t) key_1389), BUNSPEC);
						((((let_var_6_bglt) CREF(new1373_1393))->bindings) = ((obj_t) BNIL), BUNSPEC);
						((((let_var_6_bglt) CREF(new1373_1393))->body) = ((node_bglt) body_753), BUNSPEC);
						((((let_var_6_bglt) CREF(new1373_1393))->removable__42) = ((bool_t) ((bool_t) 0)), BUNSPEC);
						res1746_1404 = new1373_1393;
					     }
					  }
					  aux_1834 = res1746_1404;
				       }
				    }
				 }
			      }
			   }
			}
			return
			   (node_bglt) (aux_1834);
		     }
		   else
		     {	/* Ast/let.scm 42 */
			obj_t aux_1860;
			bindings_738 =
			   CAR(cdr_128_145_743);
			{	/* Ast/let.scm 61 */
			   bool_t test_1861;
			   {	/* Ast/let.scm 61 */
			      bool_t test_1862;
			      if (
				 PAIRP(bindings_738))
				{	/* Ast/let.scm 61 */
				   test_1862 = ((bool_t) 1)
				      ;
				}
			      else
				{	/* Ast/let.scm 61 */
				   test_1862 =
				      NULLP(bindings_738)
				      ;
				}
			      if (test_1862)
				{
				   obj_t bindings_774;
				   bindings_774 = bindings_738;
				 loop_775:
				   if (
				      NULLP(bindings_774))
				     {	/* Ast/let.scm 63 */
					test_1861 = ((bool_t) 0)
					   ;
				     }
				   else
				     {	/* Ast/let.scm 65 */
					obj_t binding_777;
					binding_777 =
					   CAR(bindings_774);
					{

					   if (
					      PAIRP(binding_777))
					     {	/* Ast/let.scm 66 */
						obj_t cdr_149_75_782;
						cdr_149_75_782 =
						   CDR(binding_777);
						if (
						   PAIRP(cdr_149_75_782))
						  {	/* Ast/let.scm 66 */
						     bool_t test_1874;
						     {	/* ./Ieee/equiv.scm 5508 */
							obj_t aux_1875;
							aux_1875 =
							   CDR(cdr_149_75_782);
							test_1874 =
							   (aux_1875 == BNIL);
						     }
						     if (test_1874)
						       {	/* Ast/let.scm 66 */
							  {
							     obj_t bindings_1878;
							     bindings_1878 =
								CDR(bindings_774);
							     bindings_774 = bindings_1878;
							     goto loop_775;
							  }
						       }
						     else
						       {	/* Ast/let.scm 66 */
							  test_1861 = ((bool_t) 1)
							     ;
						       }
						  }
						else
						  {	/* Ast/let.scm 66 */
						     test_1861 = ((bool_t) 1)
							;
						  }
					     }
					   else
					     {	/* Ast/let.scm 66 */
						test_1861 = ((bool_t) 1)
						   ;
					     }
					}
				     }
				}
			      else
				{	/* Ast/let.scm 61 */
				   test_1861 = ((bool_t) 1)
				      ;
				}
			   }
			   if (test_1861)
			     {	/* Ast/let.scm 71 */
				obj_t arg1495_764;
				obj_t arg1496_765;
				{	/* Ast/let.scm 71 */
				   obj_t arg1498_767;
				   {	/* Ast/let.scm 72 */
				      obj_t arg1499_768;
				      {		/* ./Ieee/symbol.scm 6021 */
					 obj_t aux_1880;
					 aux_1880 =
					    CAR(exp_15);
					 arg1499_768 =
					    SYMBOL_TO_STRING(aux_1880);
				      }
				      arg1498_767 =
					 string_append(arg1499_768, string1753_ast_let);
				   }
				   arg1495_764 =
				      string_append(string1754_ast_let, arg1498_767);
				}
				arg1496_765 =
				   find_location_loc_243_tools_location(exp_15, oloc_17);
				{	/* Ast/let.scm 71 */
				   node_bglt aux_1886;
				   aux_1886 =
				      error_sexp__node_157_ast_sexp(arg1495_764, exp_15, arg1496_765);
				   aux_1860 =
				      (obj_t) (aux_1886);
				}
			     }
			   else
			     {	/* Ast/let.scm 76 */
				obj_t arg1502_771;
				let_var_6_bglt arg1503_772;
				arg1502_771 =
				   CAR(exp_15);
				arg1503_772 =
				   make_generic_let_111_ast_let(exp_15, stack_16, oloc_17, site_18);
				aux_1860 =
				   make_smart_generic_let_237_ast_let(arg1502_771, arg1503_772, site_18);
			     }
			}
			return
			   (node_bglt) (aux_1860);
		     }
		}
	      else
		{	/* Ast/let.scm 42 */
		 tag_122_225_740:
		   {	/* Ast/let.scm 80 */
		      obj_t arg1513_789;
		      obj_t arg1514_790;
		      {		/* Ast/let.scm 80 */
			 obj_t arg1516_792;
			 {	/* Ast/let.scm 81 */
			    obj_t arg1517_793;
			    {	/* ./Ieee/symbol.scm 6021 */
			       obj_t aux_1894;
			       aux_1894 =
				  CAR(exp_15);
			       arg1517_793 =
				  SYMBOL_TO_STRING(aux_1894);
			    }
			    arg1516_792 =
			       string_append(arg1517_793, string1753_ast_let);
			 }
			 arg1513_789 =
			    string_append(string1754_ast_let, arg1516_792);
		      }
		      arg1514_790 =
			 find_location_loc_243_tools_location(exp_15, oloc_17);
		      return
			 error_sexp__node_157_ast_sexp(arg1513_789, exp_15, arg1514_790);
		   }
		}
	   }
	 else
	   {	/* Ast/let.scm 42 */
	      goto tag_122_225_740;
	   }
      }
   }
}



/* _let->node */
obj_t 
_let__node_205_ast_let(obj_t env_1788, obj_t exp_1789, obj_t stack_1790, obj_t oloc_1791, obj_t site_1792)
{
   AN_OBJECT;
   {	/* Ast/let.scm 31 */
      {		/* Ast/let.scm 31 */
	 node_bglt aux_1901;
	 aux_1901 =
	    let__node_121_ast_let(exp_1789, stack_1790, oloc_1791, site_1792);
	 return
	    (obj_t) (aux_1901);
      }
   }
}



/* make-generic-let */
let_var_6_bglt 
make_generic_let_111_ast_let(obj_t exp_19, obj_t stack_20, obj_t oloc_21, obj_t site_22)
{
   AN_OBJECT;
   {	/* Ast/let.scm 89 */
      {		/* Ast/let.scm 90 */
	 obj_t bindings_796;
	 {	/* ./Ieee/pair-list.scm 5701 */
	    obj_t aux_1904;
	    aux_1904 =
	       CDR(exp_19);
	    bindings_796 =
	       CAR(aux_1904);
	 }
	 {	/* Ast/let.scm 90 */
	    obj_t loc_797;
	    loc_797 =
	       find_location_loc_243_tools_location(exp_19, oloc_21);
	    {	/* Ast/let.scm 91 */
	       obj_t bloc_798;
	       {	/* Ast/let.scm 92 */
		  bool_t test_1908;
		  {	/* ./Ieee/pair-list.scm 5669 */
		     obj_t aux_1909;
		     {	/* ./Ieee/pair-list.scm 5707 */
			obj_t aux_1910;
			aux_1910 =
			   CDR(exp_19);
			aux_1909 =
			   CDR(aux_1910);
		     }
		     test_1908 =
			PAIRP(aux_1909);
		  }
		  if (test_1908)
		    {	/* Ast/let.scm 93 */
		       obj_t aux_1914;
		       {	/* ./Ieee/pair-list.scm 5701 */
			  obj_t aux_1915;
			  {	/* ./Ieee/pair-list.scm 5707 */
			     obj_t aux_1916;
			     aux_1916 =
				CDR(exp_19);
			     aux_1915 =
				CDR(aux_1916);
			  }
			  aux_1914 =
			     CAR(aux_1915);
		       }
		       bloc_798 =
			  find_location_loc_243_tools_location(aux_1914, BFALSE);
		    }
		  else
		    {	/* Ast/let.scm 92 */
		       bloc_798 = BFALSE;
		    }
	       }
	       {	/* Ast/let.scm 95 */
		  obj_t body_800;
		  {	/* Ast/let.scm 98 */
		     obj_t aux_1921;
		     {	/* ./Ieee/pair-list.scm 5707 */
			obj_t aux_1922;
			aux_1922 =
			   CDR(exp_19);
			aux_1921 =
			   CDR(aux_1922);
		     }
		     body_800 =
			normalize_progn_143_tools_progn(aux_1921);
		  }
		  {	/* Ast/let.scm 98 */
		     obj_t loc_bis_45_801;
		     loc_bis_45_801 =
			find_location_loc_243_tools_location(body_800, loc_797);
		     {	/* Ast/let.scm 99 */
			obj_t nloc_802;
			{	/* Ast/let.scm 100 */
			   bool_t test_1927;
			   if (
			      STRUCTP(bloc_798))
			     {	/* ./Ieee/equiv.scm 5508 */
				obj_t aux_1932;
				obj_t aux_1930;
				aux_1932 =
				   CNST_TABLE_REF(((long) 0));
				aux_1930 =
				   STRUCT_KEY(bloc_798);
				test_1927 =
				   (aux_1930 == aux_1932);
			     }
			   else
			     {	/* ./Tools/location.sch 624 */
				test_1927 = ((bool_t) 0)
				   ;
			     }
			   if (test_1927)
			     {	/* Ast/let.scm 100 */
				nloc_802 = bloc_798;
			     }
			   else
			     {	/* Ast/let.scm 100 */
				nloc_802 = loc_797;
			     }
			}
			{	/* Ast/let.scm 100 */
			   obj_t frame_803;
			   if (
			      NULLP(bindings_796))
			     {	/* Ast/let.scm 103 */
				frame_803 = BNIL;
			     }
			   else
			     {	/* Ast/let.scm 103 */
				obj_t head1440_846;
				head1440_846 =
				   MAKE_PAIR(BNIL, BNIL);
				{
				   obj_t l1438_847;
				   obj_t tail1441_848;
				   l1438_847 = bindings_796;
				   tail1441_848 = head1440_846;
				 lname1439_849:
				   if (
				      NULLP(l1438_847))
				     {	/* Ast/let.scm 103 */
					frame_803 =
					   CDR(head1440_846);
				     }
				   else
				     {	/* Ast/let.scm 104 */
					obj_t newtail1442_851;
					{	/* Ast/let.scm 104 */
					   local_bglt arg1552_853;
					   {	/* Ast/let.scm 104 */
					      obj_t var_id_112_856;
					      {		/* Ast/let.scm 104 */
						 obj_t aux_1941;
						 {	/* ./Ieee/pair-list.scm 5701 */
						    obj_t aux_1942;
						    aux_1942 =
						       CAR(l1438_847);
						    aux_1941 =
						       CAR(aux_1942);
						 }
						 var_id_112_856 =
						    parse_id_241_ast_ident(aux_1941, nloc_802);
					      }
					      {		/* Ast/let.scm 104 */
						 obj_t id_857;
						 id_857 =
						    CAR(var_id_112_856);
						 {	/* Ast/let.scm 105 */
						    obj_t type_858;
						    type_858 =
						       CDR(var_id_112_856);
						    {	/* Ast/let.scm 106 */

						       {	/* Ast/let.scm 107 */
							  bool_t test1554_859;
							  test1554_859 =
							     user_symbol__147_ast_ident(id_857);
							  if (test1554_859)
							    {	/* Ast/let.scm 107 */
							       arg1552_853 =
								  make_user_local_svar_134_ast_local(id_857,
								  (type_bglt) (type_858));
							    }
							  else
							    {	/* Ast/let.scm 107 */
							       arg1552_853 =
								  make_local_svar_140_ast_local(id_857,
								  (type_bglt) (type_858));
							    }
						       }
						    }
						 }
					      }
					   }
					   {	/* ./Ieee/pair-list.scm 5689 */
					      obj_t aux_1954;
					      aux_1954 =
						 (obj_t) (arg1552_853);
					      newtail1442_851 =
						 MAKE_PAIR(aux_1954, BNIL);
					   }
					}
					SET_CDR(tail1441_848, newtail1442_851);
					{
					   obj_t tail1441_1960;
					   obj_t l1438_1958;
					   l1438_1958 =
					      CDR(l1438_847);
					   tail1441_1960 = newtail1442_851;
					   tail1441_848 = tail1441_1960;
					   l1438_847 = l1438_1958;
					   goto lname1439_849;
					}
				     }
				}
			     }
			   {	/* Ast/let.scm 103 */
			      obj_t new_stack_37_804;
			      new_stack_37_804 =
				 append_2_18___r4_pairs_and_lists_6_3(frame_803, stack_20);
			      {		/* Ast/let.scm 111 */

				 {	/* Ast/let.scm 118 */
				    node_bglt body_805;
				    body_805 =
				       sexp__node_235_ast_sexp(body_800, new_stack_37_804, nloc_802,
				       CNST_TABLE_REF(((long) 1)));
				    {	/* Ast/let.scm 118 */
				       obj_t bstack_806;
				       {	/* Ast/let.scm 119 */
					  bool_t test_1964;
					  {	/* ./Ieee/equiv.scm 5508 */
					     obj_t aux_1967;
					     obj_t aux_1965;
					     aux_1967 =
						CNST_TABLE_REF(((long) 2));
					     aux_1965 =
						CAR(exp_19);
					     test_1964 =
						(aux_1965 == aux_1967);
					  }
					  if (test_1964)
					    {	/* Ast/let.scm 119 */
					       bstack_806 = stack_20;
					    }
					  else
					    {	/* Ast/let.scm 119 */
					       bstack_806 = new_stack_37_804;
					    }
				       }
				       {	/* Ast/let.scm 119 */
					  obj_t bindings_807;
					  if (
					     NULLP(bindings_796))
					    {	/* Ast/let.scm 120 */
					       bindings_807 = BNIL;
					    }
					  else
					    {	/* Ast/let.scm 120 */
					       obj_t head1445_823;
					       head1445_823 =
						  MAKE_PAIR(BNIL, BNIL);
					       {
						  obj_t ll1443_824;
						  obj_t ll1444_825;
						  obj_t tail1446_826;
						  ll1443_824 = bindings_796;
						  ll1444_825 = frame_803;
						  tail1446_826 = head1445_823;
						lname1448_827:
						  if (
						     NULLP(ll1443_824))
						    {	/* Ast/let.scm 120 */
						       bindings_807 =
							  CDR(head1445_823);
						    }
						  else
						    {	/* Ast/let.scm 121 */
						       obj_t newtail1447_829;
						       {	/* Ast/let.scm 121 */
							  obj_t arg1537_832;
							  {	/* Ast/let.scm 121 */
							     obj_t binding_834;
							     obj_t var_835;
							     binding_834 =
								CAR(ll1443_824);
							     var_835 =
								CAR(ll1444_825);
							     {	/* Ast/let.scm 123 */
								node_bglt arg1540_836;
								{	/* Ast/let.scm 123 */
								   obj_t arg1541_837;
								   obj_t arg1543_838;
								   obj_t arg1544_839;
								   arg1541_837 =
								      normalize_progn_143_tools_progn(
								      CDR(binding_834));
								   arg1543_838 =
								      find_location_loc_243_tools_location(binding_834, nloc_802);
								   arg1544_839 =
								      CNST_TABLE_REF(((long) 1));
								   arg1540_836 =
								      sexp__node_235_ast_sexp(arg1541_837, bstack_806, arg1543_838, arg1544_839);
								}
								{	/* ./Ieee/pair-list.scm 5689 */
								   obj_t aux_1983;
								   aux_1983 =
								      (obj_t) (arg1540_836);
								   arg1537_832 =
								      MAKE_PAIR(var_835, aux_1983);
								}
							     }
							  }
							  newtail1447_829 =
							     MAKE_PAIR(arg1537_832, BNIL);
						       }
						       SET_CDR(tail1446_826, newtail1447_829);
						       {
							  obj_t tail1446_1992;
							  obj_t ll1444_1990;
							  obj_t ll1443_1988;
							  ll1443_1988 =
							     CDR(ll1443_824);
							  ll1444_1990 =
							     CDR(ll1444_825);
							  tail1446_1992 = newtail1447_829;
							  tail1446_826 = tail1446_1992;
							  ll1444_825 = ll1444_1990;
							  ll1443_824 = ll1443_1988;
							  goto lname1448_827;
						       }
						    }
					       }
					    }
					  {	/* Ast/let.scm 120 */
					     obj_t loc_808;
					     {	/* Ast/let.scm 137 */
						obj_t loc_814;
						{	/* Ast/let.scm 137 */
						   obj_t aux_1993;
						   if (
						      PAIRP(bindings_807))
						     {	/* Ast/let.scm 140 */
							node_bglt obj_1495;
							{	/* Ast/let.scm 140 */
							   obj_t aux_1996;
							   {	/* ./Ieee/pair-list.scm 5707 */
							      obj_t aux_1997;
							      aux_1997 =
								 CAR(bindings_807);
							      aux_1996 =
								 CDR(aux_1997);
							   }
							   obj_1495 =
							      (node_bglt) (aux_1996);
							}
							aux_1993 =
							   (((node_bglt) CREF(obj_1495))->loc);
						     }
						   else
						     {	/* Ast/let.scm 139 */
							aux_1993 =
							   (((node_bglt) CREF(body_805))->loc)
							   ;
						     }
						   loc_814 =
						      find_location_loc_243_tools_location(exp_19, aux_1993);
						}
						{	/* Ast/let.scm 142 */
						   bool_t test_2004;
						   if (
						      STRUCTP(loc_814))
						     {	/* ./Ieee/equiv.scm 5508 */
							obj_t aux_2009;
							obj_t aux_2007;
							aux_2009 =
							   CNST_TABLE_REF(((long) 0));
							aux_2007 =
							   STRUCT_KEY(loc_814);
							test_2004 =
							   (aux_2007 == aux_2009);
						     }
						   else
						     {	/* ./Tools/location.sch 624 */
							test_2004 = ((bool_t) 0)
							   ;
						     }
						   if (test_2004)
						     {	/* Ast/let.scm 142 */
							loc_808 = loc_814;
						     }
						   else
						     {	/* Ast/let.scm 142 */
							loc_808 = oloc_21;
						     }
						}
					     }
					     {	/* Ast/let.scm 137 */

						{	/* Ast/let.scm 145 */
						   obj_t arg1522_810;
						   arg1522_810 = ____74_type_cache;
						   {	/* Ast/let.scm 145 */
						      let_var_6_bglt res1747_1523;
						      {		/* Ast/let.scm 145 */
							 type_bglt type_1506;
							 obj_t key_1508;
							 type_1506 =
							    (type_bglt) (arg1522_810);
							 key_1508 =
							    BINT(((long) -1));
							 {	/* ./Ast/node.scm 953 */
							    let_var_6_bglt new1373_1512;
							    new1373_1512 =
							       ((let_var_6_bglt) BREF(GC_MALLOC(sizeof(struct let_var_6))));
							    {	/* ./Ast/node.scm 953 */
							       long arg1684_1513;
							       arg1684_1513 =
								  class_num_218___object(let_var_6_ast_node);
							       {	/* ./Ast/node.scm 953 */
								  obj_t obj_1521;
								  obj_1521 =
								     (obj_t) (new1373_1512);
								  (((obj_t) CREF(obj_1521))->header = MAKE_HEADER(arg1684_1513, 0), BUNSPEC);
							       }
							    }
							    {	/* ./Ast/node.scm 953 */
							       object_bglt aux_2018;
							       aux_2018 =
								  (object_bglt) (new1373_1512);
							       OBJECT_WIDENING_SET(aux_2018, BFALSE);
							    }
							    ((((let_var_6_bglt) CREF(new1373_1512))->loc) = ((obj_t) loc_808), BUNSPEC);
							    ((((let_var_6_bglt) CREF(new1373_1512))->type) = ((type_bglt) type_1506), BUNSPEC);
							    ((((let_var_6_bglt) CREF(new1373_1512))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
							    ((((let_var_6_bglt) CREF(new1373_1512))->key) = ((obj_t) key_1508), BUNSPEC);
							    ((((let_var_6_bglt) CREF(new1373_1512))->bindings) = ((obj_t) bindings_807), BUNSPEC);
							    ((((let_var_6_bglt) CREF(new1373_1512))->body) = ((node_bglt) body_805), BUNSPEC);
							    ((((let_var_6_bglt) CREF(new1373_1512))->removable__42) = ((bool_t) ((bool_t) 1)), BUNSPEC);
							    res1747_1523 = new1373_1512;
							 }
						      }
						      return res1747_1523;
						   }
						}
					     }
					  }
				       }
				    }
				 }
			      }
			   }
			}
		     }
		  }
	       }
	    }
	 }
      }
   }
}



/* make-smart-generic-let */
obj_t 
make_smart_generic_let_237_ast_let(obj_t let_letrec_14_23, let_var_6_bglt node_let_193_24, obj_t site_25)
{
   AN_OBJECT;
   {	/* Ast/let.scm 162 */
      {
	 obj_t bindings_868;
	 obj_t fun_869;
	 obj_t value_870;
	 bindings_868 =
	    (((let_var_6_bglt) CREF(node_let_193_24))->bindings);
	 fun_869 = BNIL;
	 value_870 = BNIL;
       loop_871:
	 if (
	    NULLP(bindings_868))
	   {	/* Ast/let.scm 166 */
	      if (
		 NULLP(fun_869))
		{	/* Ast/let.scm 168 */
		   {	/* Ast/let.scm 169 */
		      let_var_6_bglt aux_2032;
		      aux_2032 =
			 let_or_letrec_20_ast_let(let_letrec_14_23, node_let_193_24);
		      return
			 (obj_t) (aux_2032);
		   }
		}
	      else
		{	/* Ast/let.scm 168 */
		   if (
		      NULLP(value_870))
		     {	/* Ast/let.scm 170 */
			{	/* Ast/let.scm 171 */
			   let_fun_218_bglt aux_2037;
			   aux_2037 =
			      let__labels_169_ast_let(fun_869,
			      (((let_var_6_bglt) CREF(node_let_193_24))->body), site_25);
			   return
			      (obj_t) (aux_2037);
			}
		     }
		   else
		     {	/* Ast/let.scm 170 */
			{	/* Ast/let.scm 174 */
			   obj_t arg1571_879;
			   arg1571_879 =
			      reverse__39___r4_pairs_and_lists_6_3(value_870);
			   ((((let_var_6_bglt) CREF(node_let_193_24))->bindings) = ((obj_t) arg1571_879), BUNSPEC);
			}
			{	/* Ast/let.scm 176 */
			   let_var_6_bglt let_880;
			   let_880 =
			      let_or_letrec_20_ast_let(let_letrec_14_23, node_let_193_24);
			   {	/* Ast/let.scm 178 */
			      let_fun_218_bglt arg1572_881;
			      arg1572_881 =
				 let__labels_169_ast_let(fun_869,
				 (((let_var_6_bglt) CREF(let_880))->body), site_25);
			      {		/* Ast/let.scm 177 */
				 node_bglt val1371_1533;
				 val1371_1533 =
				    (node_bglt) (arg1572_881);
				 ((((let_var_6_bglt) CREF(let_880))->body) = ((node_bglt) val1371_1533), BUNSPEC);
			      }
			   }
			   return
			      (obj_t) (let_880);
			}
		     }
		}
	   }
	 else
	   {	/* Ast/let.scm 181 */
	      obj_t binding_883;
	      binding_883 =
		 CAR(bindings_868);
	      {		/* Ast/let.scm 181 */
		 obj_t var_884;
		 var_884 =
		    CAR(binding_883);
		 {	/* Ast/let.scm 182 */
		    obj_t sexp_885;
		    sexp_885 =
		       CDR(binding_883);
		    {	/* Ast/let.scm 183 */

		       {	/* Ast/let.scm 184 */
			  bool_t test1574_886;
			  test1574_886 =
			     is_a__118___object(sexp_885, let_fun_218_ast_node);
			  if (test1574_886)
			    {	/* Ast/let.scm 185 */
			       obj_t locals_887;
			       {	/* Ast/let.scm 185 */
				  let_fun_218_bglt obj_1538;
				  obj_1538 =
				     (let_fun_218_bglt) (sexp_885);
				  locals_887 =
				     (((let_fun_218_bglt) CREF(obj_1538))->locals);
			       }
			       {	/* Ast/let.scm 185 */
				  node_bglt body_888;
				  {	/* Ast/let.scm 186 */
				     let_fun_218_bglt obj_1539;
				     obj_1539 =
					(let_fun_218_bglt) (sexp_885);
				     body_888 =
					(((let_fun_218_bglt) CREF(obj_1539))->body);
				  }
				  {	/* Ast/let.scm 186 */

				     {	/* Ast/let.scm 187 */
					bool_t test_2058;
					if (
					   NULLP(locals_887))
					  {	/* Ast/let.scm 187 */
					     test_2058 = ((bool_t) 1)
						;
					  }
					else
					  {	/* Ast/let.scm 187 */
					     bool_t test_2061;
					     {	/* ./Ieee/pair-list.scm 5912 */
						obj_t aux_2062;
						aux_2062 =
						   CDR(locals_887);
						test_2061 =
						   NULLP(aux_2062);
					     }
					     if (test_2061)
					       {	/* Ast/let.scm 187 */
						  test_2058 = ((bool_t) 0)
						     ;
					       }
					     else
					       {	/* Ast/let.scm 187 */
						  test_2058 = ((bool_t) 1)
						     ;
					       }
					  }
					if (test_2058)
					  {	/* Ast/let.scm 191 */
					     obj_t arg1576_890;
					     obj_t arg1577_891;
					     arg1576_890 =
						CDR(bindings_868);
					     arg1577_891 =
						MAKE_PAIR(binding_883, value_870);
					     {
						obj_t value_2068;
						obj_t bindings_2067;
						bindings_2067 = arg1576_890;
						value_2068 = arg1577_891;
						value_870 = value_2068;
						bindings_868 = bindings_2067;
						goto loop_871;
					     }
					  }
					else
					  {	/* Ast/let.scm 194 */
					     bool_t test1579_893;
					     test1579_893 =
						is_a__118___object(
						(obj_t) (body_888), var_ast_node);
					     if (test1579_893)
					       {	/* Ast/let.scm 197 */
						  bool_t test1580_896;
						  {	/* Ast/let.scm 197 */
						     bool_t test_2072;
						     {	/* ./Ieee/equiv.scm 5508 */
							obj_t aux_2078;
							obj_t aux_2073;
							aux_2078 =
							   CAR(locals_887);
							{	/* Ast/let.scm 197 */
							   variable_bglt aux_2074;
							   {	/* Ast/let.scm 195 */
							      var_bglt obj_1548;
							      obj_1548 =
								 (var_bglt) (body_888);
							      aux_2074 =
								 (((var_bglt) CREF(obj_1548))->variable);
							   }
							   aux_2073 =
							      (obj_t) (aux_2074);
							}
							test_2072 =
							   (aux_2073 == aux_2078);
						     }
						     if (test_2072)
						       {	/* Ast/let.scm 201 */
							  bool_t test_2081;
							  {	/* ./Ieee/equiv.scm 5508 */
							     obj_t aux_2085;
							     obj_t aux_2082;
							     aux_2085 =
								CNST_TABLE_REF(((long) 3));
							     {	/* Ast/let.scm 201 */
								local_bglt obj_1552;
								obj_1552 =
								   (local_bglt) (var_884);
								aux_2082 =
								   (((local_bglt) CREF(obj_1552))->access);
							     }
							     test_2081 =
								(aux_2082 == aux_2085);
							  }
							  if (test_2081)
							    {	/* Ast/let.scm 201 */
							       test1580_896 = ((bool_t) 1);
							    }
							  else
							    {	/* Ast/let.scm 202 */
							       bool_t test1589_905;
							       {	/* Ast/let.scm 203 */
								  bool_t test1590_906;
								  {	/* Ast/let.scm 203 */
								     obj_t obj2_1557;
								     obj2_1557 = _procedure__226_type_cache;
								     {	/* ./Ieee/equiv.scm 5508 */
									obj_t aux_2088;
									{	/* Ast/let.scm 203 */
									   type_bglt aux_2089;
									   {	/* Ast/let.scm 203 */
									      local_bglt obj_1555;
									      obj_1555 =
										 (local_bglt) (var_884);
									      aux_2089 =
										 (((local_bglt) CREF(obj_1555))->type);
									   }
									   aux_2088 =
									      (obj_t) (aux_2089);
									}
									test1590_906 =
									   (aux_2088 == obj2_1557);
								     }
								  }
								  if (test1590_906)
								    {	/* Ast/let.scm 203 */
								       test1589_905 = ((bool_t) 1);
								    }
								  else
								    {	/* Ast/let.scm 204 */
								       bool_t test1591_907;
								       {	/* Ast/let.scm 204 */
									  obj_t obj2_1560;
									  obj2_1560 = ____74_type_cache;
									  {	/* ./Ieee/equiv.scm 5508 */
									     obj_t aux_2095;
									     {	/* Ast/let.scm 204 */
										type_bglt aux_2096;
										{	/* Ast/let.scm 204 */
										   local_bglt obj_1558;
										   obj_1558 =
										      (local_bglt) (var_884);
										   aux_2096 =
										      (((local_bglt) CREF(obj_1558))->type);
										}
										aux_2095 =
										   (obj_t) (aux_2096);
									     }
									     test1591_907 =
										(aux_2095 == obj2_1560);
									  }
								       }
								       if (test1591_907)
									 {	/* Ast/let.scm 204 */
									    test1589_905 = ((bool_t) 1);
									 }
								       else
									 {	/* Ast/let.scm 205 */
									    obj_t obj2_1563;
									    obj2_1563 = _obj__252_type_cache;
									    {	/* ./Ieee/equiv.scm 5508 */
									       obj_t aux_2102;
									       {	/* Ast/let.scm 205 */
										  type_bglt aux_2103;
										  {	/* Ast/let.scm 205 */
										     local_bglt obj_1561;
										     obj_1561 =
											(local_bglt) (var_884);
										     aux_2103 =
											(((local_bglt) CREF(obj_1561))->type);
										  }
										  aux_2102 =
										     (obj_t) (aux_2103);
									       }
									       test1589_905 =
										  (aux_2102 == obj2_1563);
									    }
									 }
								    }
							       }
							       if (test1589_905)
								 {	/* Ast/let.scm 202 */
								    test1580_896 = ((bool_t) 0);
								 }
							       else
								 {	/* Ast/let.scm 202 */
								    test1580_896 = ((bool_t) 1);
								 }
							    }
						       }
						     else
						       {	/* Ast/let.scm 197 */
							  test1580_896 = ((bool_t) 1);
						       }
						  }
						  if (test1580_896)
						    {	/* Ast/let.scm 208 */
						       obj_t arg1581_897;
						       obj_t arg1582_898;
						       arg1581_897 =
							  CDR(bindings_868);
						       arg1582_898 =
							  MAKE_PAIR(binding_883, value_870);
						       {
							  obj_t value_2113;
							  obj_t bindings_2112;
							  bindings_2112 = arg1581_897;
							  value_2113 = arg1582_898;
							  value_870 = value_2113;
							  bindings_868 = bindings_2112;
							  goto loop_871;
						       }
						    }
						  else
						    {	/* Ast/let.scm 212 */
						       obj_t arg1584_900;
						       obj_t arg1585_901;
						       arg1584_900 =
							  CDR(bindings_868);
						       arg1585_901 =
							  MAKE_PAIR(binding_883, fun_869);
						       {
							  obj_t fun_2117;
							  obj_t bindings_2116;
							  bindings_2116 = arg1584_900;
							  fun_2117 = arg1585_901;
							  fun_869 = fun_2117;
							  bindings_868 = bindings_2116;
							  goto loop_871;
						       }
						    }
					       }
					     else
					       {	/* Ast/let.scm 215 */
						  obj_t arg1597_913;
						  obj_t arg1598_914;
						  arg1597_913 =
						     CDR(bindings_868);
						  arg1598_914 =
						     MAKE_PAIR(binding_883, value_870);
						  {
						     obj_t value_2121;
						     obj_t bindings_2120;
						     bindings_2120 = arg1597_913;
						     value_2121 = arg1598_914;
						     value_870 = value_2121;
						     bindings_868 = bindings_2120;
						     goto loop_871;
						  }
					       }
					  }
				     }
				  }
			       }
			    }
			  else
			    {	/* Ast/let.scm 218 */
			       obj_t arg1603_919;
			       obj_t arg1604_920;
			       arg1603_919 =
				  CDR(bindings_868);
			       arg1604_920 =
				  MAKE_PAIR(binding_883, value_870);
			       {
				  obj_t value_2125;
				  obj_t bindings_2124;
				  bindings_2124 = arg1603_919;
				  value_2125 = arg1604_920;
				  value_870 = value_2125;
				  bindings_868 = bindings_2124;
				  goto loop_871;
			       }
			    }
		       }
		    }
		 }
	      }
	   }
      }
   }
}



/* let-or-letrec */
let_var_6_bglt 
let_or_letrec_20_ast_let(obj_t let_letrec_14_26, let_var_6_bglt node_let_193_27)
{
   AN_OBJECT;
   {	/* Ast/let.scm 232 */
      {		/* Ast/let.scm 233 */
	 bool_t test_2127;
	 {	/* ./Ieee/equiv.scm 5508 */
	    obj_t aux_2128;
	    aux_2128 =
	       CNST_TABLE_REF(((long) 2));
	    test_2127 =
	       (let_letrec_14_26 == aux_2128);
	 }
	 if (test_2127)
	   {	/* Ast/let.scm 233 */
	      return node_let_193_27;
	   }
	 else
	   {	/* Ast/let.scm 235 */
	      obj_t bindings_923;
	      bindings_923 =
		 (((let_var_6_bglt) CREF(node_let_193_27))->bindings);
	      {		/* Ast/let.scm 235 */
		 node_bglt body_924;
		 body_924 =
		    (((let_var_6_bglt) CREF(node_let_193_27))->body);
		 {	/* Ast/let.scm 236 */
		    obj_t seq_925;
		    {	/* Ast/let.scm 237 */
		       bool_t test1624_951;
		       test1624_951 =
			  is_a__118___object(
			  (obj_t) (body_924), sequence_ast_node);
		       if (test1624_951)
			 {	/* Ast/let.scm 237 */
			    seq_925 =
			       (obj_t) (body_924);
			 }
		       else
			 {	/* Ast/let.scm 239 */
			    obj_t arg1625_952;
			    obj_t arg1626_953;
			    obj_t arg1628_955;
			    arg1625_952 =
			       (((node_bglt) CREF(body_924))->loc);
			    arg1626_953 = ____74_type_cache;
			    {	/* Ast/let.scm 241 */
			       obj_t list1629_956;
			       {	/* Ast/let.scm 241 */
				  obj_t aux_2138;
				  aux_2138 =
				     (obj_t) (body_924);
				  list1629_956 =
				     MAKE_PAIR(aux_2138, BNIL);
			       }
			       arg1628_955 = list1629_956;
			    }
			    {	/* Ast/let.scm 239 */
			       sequence_bglt res1748_1601;
			       {	/* Ast/let.scm 239 */
				  type_bglt type_1588;
				  obj_t key_1590;
				  type_1588 =
				     (type_bglt) (arg1626_953);
				  key_1590 =
				     BINT(((long) -1));
				  {	/* ./Ast/node.scm 873 */
				     sequence_bglt new1234_1592;
				     new1234_1592 =
					((sequence_bglt) BREF(GC_MALLOC(sizeof(struct sequence))));
				     {	/* ./Ast/node.scm 873 */
					long arg1706_1593;
					arg1706_1593 =
					   class_num_218___object(sequence_ast_node);
					{	/* ./Ast/node.scm 873 */
					   obj_t obj_1599;
					   obj_1599 =
					      (obj_t) (new1234_1592);
					   (((obj_t) CREF(obj_1599))->header = MAKE_HEADER(arg1706_1593, 0), BUNSPEC);
					}
				     }
				     {	/* ./Ast/node.scm 873 */
					object_bglt aux_2147;
					aux_2147 =
					   (object_bglt) (new1234_1592);
					OBJECT_WIDENING_SET(aux_2147, BFALSE);
				     }
				     ((((sequence_bglt) CREF(new1234_1592))->loc) = ((obj_t) arg1625_952), BUNSPEC);
				     ((((sequence_bglt) CREF(new1234_1592))->type) = ((type_bglt) type_1588), BUNSPEC);
				     ((((sequence_bglt) CREF(new1234_1592))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
				     ((((sequence_bglt) CREF(new1234_1592))->key) = ((obj_t) key_1590), BUNSPEC);
				     ((((sequence_bglt) CREF(new1234_1592))->nodes) = ((obj_t) arg1628_955), BUNSPEC);
				     res1748_1601 = new1234_1592;
				  }
			       }
			       seq_925 =
				  (obj_t) (res1748_1601);
			    }
			 }
		    }
		    {	/* Ast/let.scm 237 */

		       {	/* Ast/let.scm 242 */
			  node_bglt val1371_1603;
			  val1371_1603 =
			     (node_bglt) (seq_925);
			  ((((let_var_6_bglt) CREF(node_let_193_27))->body) = ((node_bglt) val1371_1603), BUNSPEC);
		       }
		       {
			  obj_t bindings_926;
			  obj_t nsequence_927;
			  bindings_926 = bindings_923;
			  {	/* Ast/let.scm 244 */
			     sequence_bglt obj_1604;
			     obj_1604 =
				(sequence_bglt) (seq_925);
			     nsequence_927 =
				(((sequence_bglt) CREF(obj_1604))->nodes);
			  }
			loop_928:
			  if (
			     NULLP(bindings_926))
			    {	/* Ast/let.scm 245 */
			       {	/* Ast/let.scm 249 */
				  sequence_bglt arg1609_931;
				  {	/* Ast/let.scm 249 */
				     obj_t arg1610_932;
				     obj_t arg1611_933;
				     {	/* Ast/let.scm 249 */
					node_bglt obj_1606;
					obj_1606 =
					   (node_bglt) (seq_925);
					arg1610_932 =
					   (((node_bglt) CREF(obj_1606))->loc);
				     }
				     arg1611_933 = ____74_type_cache;
				     {	/* Ast/let.scm 248 */
					sequence_bglt res1749_1621;
					{	/* Ast/let.scm 248 */
					   type_bglt type_1608;
					   obj_t key_1610;
					   type_1608 =
					      (type_bglt) (arg1611_933);
					   key_1610 =
					      BINT(((long) -1));
					   {	/* ./Ast/node.scm 873 */
					      sequence_bglt new1234_1612;
					      new1234_1612 =
						 ((sequence_bglt) BREF(GC_MALLOC(sizeof(struct sequence))));
					      {		/* ./Ast/node.scm 873 */
						 long arg1706_1613;
						 arg1706_1613 =
						    class_num_218___object(sequence_ast_node);
						 {	/* ./Ast/node.scm 873 */
						    obj_t obj_1619;
						    obj_1619 =
						       (obj_t) (new1234_1612);
						    (((obj_t) CREF(obj_1619))->header = MAKE_HEADER(arg1706_1613, 0), BUNSPEC);
						 }
					      }
					      {		/* ./Ast/node.scm 873 */
						 object_bglt aux_2168;
						 aux_2168 =
						    (object_bglt) (new1234_1612);
						 OBJECT_WIDENING_SET(aux_2168, BFALSE);
					      }
					      ((((sequence_bglt) CREF(new1234_1612))->loc) = ((obj_t) arg1610_932), BUNSPEC);
					      ((((sequence_bglt) CREF(new1234_1612))->type) = ((type_bglt) type_1608), BUNSPEC);
					      ((((sequence_bglt) CREF(new1234_1612))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
					      ((((sequence_bglt) CREF(new1234_1612))->key) = ((obj_t) key_1610), BUNSPEC);
					      ((((sequence_bglt) CREF(new1234_1612))->nodes) = ((obj_t) nsequence_927), BUNSPEC);
					      res1749_1621 = new1234_1612;
					   }
					}
					arg1609_931 = res1749_1621;
				     }
				  }
				  {	/* Ast/let.scm 247 */
				     node_bglt val1371_1623;
				     val1371_1623 =
					(node_bglt) (arg1609_931);
				     ((((let_var_6_bglt) CREF(node_let_193_27))->body) = ((node_bglt) val1371_1623), BUNSPEC);
				  }
			       }
			       return node_let_193_27;
			    }
			  else
			    {	/* Ast/let.scm 253 */
			       obj_t binding_936;
			       binding_936 =
				  CAR(bindings_926);
			       {	/* Ast/let.scm 253 */
				  obj_t var_937;
				  var_937 =
				     CAR(binding_936);
				  {	/* Ast/let.scm 254 */
				     obj_t val_938;
				     val_938 =
					CDR(binding_936);
				     {	/* Ast/let.scm 255 */
					obj_t loc_939;
					{	/* Ast/let.scm 256 */
					   node_bglt obj_1627;
					   obj_1627 =
					      (node_bglt) (val_938);
					   loc_939 =
					      (((node_bglt) CREF(obj_1627))->loc);
					}
					{	/* Ast/let.scm 256 */

					   {	/* Ast/let.scm 257 */
					      setq_bglt init_940;
					      {		/* Ast/let.scm 257 */
						 obj_t arg1618_945;
						 var_bglt arg1619_946;
						 arg1618_945 = _unspec__87_type_cache;
						 {	/* Ast/let.scm 259 */
						    obj_t arg1622_949;
						    arg1622_949 = ____74_type_cache;
						    {	/* Ast/let.scm 259 */
						       var_bglt res1750_1638;
						       {	/* Ast/let.scm 259 */
							  type_bglt type_1629;
							  variable_bglt variable_1630;
							  type_1629 =
							     (type_bglt) (arg1622_949);
							  variable_1630 =
							     (variable_bglt) (var_937);
							  {	/* ./Ast/node.scm 860 */
							     var_bglt new1210_1631;
							     new1210_1631 =
								((var_bglt) BREF(GC_MALLOC(sizeof(struct var))));
							     {	/* ./Ast/node.scm 860 */
								long arg1713_1632;
								arg1713_1632 =
								   class_num_218___object(var_ast_node);
								{	/* ./Ast/node.scm 860 */
								   obj_t obj_1636;
								   obj_1636 =
								      (obj_t) (new1210_1631);
								   (((obj_t) CREF(obj_1636))->header = MAKE_HEADER(arg1713_1632, 0), BUNSPEC);
								}
							     }
							     {	/* ./Ast/node.scm 860 */
								object_bglt aux_2189;
								aux_2189 =
								   (object_bglt) (new1210_1631);
								OBJECT_WIDENING_SET(aux_2189, BFALSE);
							     }
							     ((((var_bglt) CREF(new1210_1631))->loc) = ((obj_t) loc_939), BUNSPEC);
							     ((((var_bglt) CREF(new1210_1631))->type) = ((type_bglt) type_1629), BUNSPEC);
							     ((((var_bglt) CREF(new1210_1631))->variable) = ((variable_bglt) variable_1630), BUNSPEC);
							     res1750_1638 = new1210_1631;
							  }
						       }
						       arg1619_946 = res1750_1638;
						    }
						 }
						 {	/* Ast/let.scm 257 */
						    setq_bglt res1751_1651;
						    {	/* Ast/let.scm 257 */
						       type_bglt type_1640;
						       node_bglt value_1642;
						       type_1640 =
							  (type_bglt) (arg1618_945);
						       value_1642 =
							  (node_bglt) (val_938);
						       {	/* ./Ast/node.scm 914 */
							  setq_bglt new1304_1643;
							  new1304_1643 =
							     ((setq_bglt) BREF(GC_MALLOC(sizeof(struct setq))));
							  {	/* ./Ast/node.scm 914 */
							     long arg1694_1644;
							     arg1694_1644 =
								class_num_218___object(setq_ast_node);
							     {	/* ./Ast/node.scm 914 */
								obj_t obj_1649;
								obj_1649 =
								   (obj_t) (new1304_1643);
								(((obj_t) CREF(obj_1649))->header = MAKE_HEADER(arg1694_1644, 0), BUNSPEC);
							     }
							  }
							  {	/* ./Ast/node.scm 914 */
							     object_bglt aux_2201;
							     aux_2201 =
								(object_bglt) (new1304_1643);
							     OBJECT_WIDENING_SET(aux_2201, BFALSE);
							  }
							  ((((setq_bglt) CREF(new1304_1643))->loc) = ((obj_t) loc_939), BUNSPEC);
							  ((((setq_bglt) CREF(new1304_1643))->type) = ((type_bglt) type_1640), BUNSPEC);
							  ((((setq_bglt) CREF(new1304_1643))->var) = ((var_bglt) arg1619_946), BUNSPEC);
							  ((((setq_bglt) CREF(new1304_1643))->value) = ((node_bglt) value_1642), BUNSPEC);
							  res1751_1651 = new1304_1643;
						       }
						    }
						    init_940 = res1751_1651;
						 }
					      }
					      use_variable__4_ast_sexp(
						 (variable_bglt) (var_937), loc_939,
						 CNST_TABLE_REF(((long) 4)));
					      {		/* Ast/let.scm 266 */
						 node_bglt arg1614_941;
						 arg1614_941 =
						    sexp__node_235_ast_sexp(BUNSPEC, BNIL, loc_939,
						    CNST_TABLE_REF(((long) 1)));
						 {	/* ./Ieee/pair-list.scm 5896 */
						    obj_t aux_2213;
						    aux_2213 =
						       (obj_t) (arg1614_941);
						    SET_CDR(binding_936, aux_2213);
						 }
					      }
					      {		/* Ast/let.scm 267 */
						 obj_t arg1615_942;
						 obj_t arg1616_943;
						 arg1615_942 =
						    CDR(bindings_926);
						 {	/* ./Ieee/pair-list.scm 5689 */
						    obj_t aux_2217;
						    aux_2217 =
						       (obj_t) (init_940);
						    arg1616_943 =
						       MAKE_PAIR(aux_2217, nsequence_927);
						 }
						 {
						    obj_t nsequence_2221;
						    obj_t bindings_2220;
						    bindings_2220 = arg1615_942;
						    nsequence_2221 = arg1616_943;
						    nsequence_927 = nsequence_2221;
						    bindings_926 = bindings_2220;
						    goto loop_928;
						 }
					      }
					   }
					}
				     }
				  }
			       }
			    }
		       }
		    }
		 }
	      }
	   }
      }
   }
}



/* let->labels */
let_fun_218_bglt 
let__labels_169_ast_let(obj_t value_bindings_254_28, node_bglt node_29, obj_t site_30)
{
   AN_OBJECT;
   {	/* Ast/let.scm 277 */
      {		/* Ast/let.scm 279 */
	 obj_t old_funs_44_957;
	 obj_t new_funs_1_958;
	 if (
	    NULLP(value_bindings_254_28))
	   {	/* Ast/let.scm 279 */
	      old_funs_44_957 = BNIL;
	   }
	 else
	   {	/* Ast/let.scm 279 */
	      obj_t head1456_993;
	      {		/* ./Ieee/pair-list.scm 5689 */
		 obj_t aux_2226;
		 {	/* ./Ieee/pair-list.scm 5701 */
		    obj_t aux_2227;
		    aux_2227 =
		       CAR(value_bindings_254_28);
		    aux_2226 =
		       CAR(aux_2227);
		 }
		 head1456_993 =
		    MAKE_PAIR(aux_2226, BNIL);
	      }
	      {
		 obj_t l1454_994;
		 obj_t tail1457_995;
		 l1454_994 =
		    CDR(value_bindings_254_28);
		 tail1457_995 = head1456_993;
	       lname1455_996:
		 if (
		    NULLP(l1454_994))
		   {	/* Ast/let.scm 279 */
		      old_funs_44_957 = head1456_993;
		   }
		 else
		   {	/* Ast/let.scm 279 */
		      obj_t newtail1458_999;
		      {		/* ./Ieee/pair-list.scm 5689 */
			 obj_t aux_2233;
			 {	/* ./Ieee/pair-list.scm 5701 */
			    obj_t aux_2234;
			    aux_2234 =
			       CAR(l1454_994);
			    aux_2233 =
			       CAR(aux_2234);
			 }
			 newtail1458_999 =
			    MAKE_PAIR(aux_2233, BNIL);
		      }
		      SET_CDR(tail1457_995, newtail1458_999);
		      {
			 obj_t tail1457_2241;
			 obj_t l1454_2239;
			 l1454_2239 =
			    CDR(l1454_994);
			 tail1457_2241 = newtail1458_999;
			 tail1457_995 = tail1457_2241;
			 l1454_994 = l1454_2239;
			 goto lname1455_996;
		      }
		   }
	      }
	   }
	 if (
	    NULLP(value_bindings_254_28))
	   {	/* Ast/let.scm 280 */
	      new_funs_1_958 = BNIL;
	   }
	 else
	   {	/* Ast/let.scm 280 */
	      obj_t head1461_1009;
	      head1461_1009 =
		 MAKE_PAIR(BNIL, BNIL);
	      {
		 obj_t l1459_1010;
		 obj_t tail1462_1011;
		 l1459_1010 = value_bindings_254_28;
		 tail1462_1011 = head1461_1009;
	       lname1460_1012:
		 if (
		    NULLP(l1459_1010))
		   {	/* Ast/let.scm 280 */
		      new_funs_1_958 =
			 CDR(head1461_1009);
		   }
		 else
		   {	/* Ast/let.scm 281 */
		      obj_t newtail1463_1014;
		      {		/* Ast/let.scm 281 */
			 local_bglt arg1664_1016;
			 {	/* Ast/let.scm 281 */
			    obj_t binding_1018;
			    binding_1018 =
			       CAR(l1459_1010);
			    {	/* Ast/let.scm 281 */
			       obj_t ovar_1019;
			       ovar_1019 =
				  CAR(binding_1018);
			       {	/* Ast/let.scm 282 */
				  obj_t aux_1021;
				  {	/* ./Ieee/pair-list.scm 5701 */
				     obj_t aux_2251;
				     {	/* Ast/let.scm 283 */
					let_fun_218_bglt obj_1679;
					{	/* Ast/let.scm 283 */
					   obj_t aux_2252;
					   aux_2252 =
					      CDR(binding_1018);
					   obj_1679 =
					      (let_fun_218_bglt) (aux_2252);
					}
					aux_2251 =
					   (((let_fun_218_bglt) CREF(obj_1679))->locals);
				     }
				     aux_1021 =
					CAR(aux_2251);
				  }
				  {	/* Ast/let.scm 284 */
				     local_bglt new_1023;
				     {	/* Ast/let.scm 287 */
					type_bglt aux_2265;
					obj_t aux_2257;
					{	/* Ast/let.scm 287 */
					   local_bglt obj_1684;
					   obj_1684 =
					      (local_bglt) (aux_1021);
					   aux_2265 =
					      (((local_bglt) CREF(obj_1684))->type);
					}
					{	/* Ast/let.scm 284 */
					   bool_t test_2258;
					   {	/* Ast/let.scm 284 */
					      local_bglt obj_1681;
					      obj_1681 =
						 (local_bglt) (ovar_1019);
					      test_2258 =
						 (((local_bglt) CREF(obj_1681))->user__32);
					   }
					   if (test_2258)
					     {	/* Ast/let.scm 285 */
						local_bglt obj_1682;
						obj_1682 =
						   (local_bglt) (ovar_1019);
						aux_2257 =
						   (((local_bglt) CREF(obj_1682))->id);
					     }
					   else
					     {	/* Ast/let.scm 286 */
						local_bglt obj_1683;
						obj_1683 =
						   (local_bglt) (aux_1021);
						aux_2257 =
						   (((local_bglt) CREF(obj_1683))->id);
					     }
					}
					new_1023 =
					   make_local_svar_140_ast_local(aux_2257, aux_2265);
				     }
				     {	/* Ast/let.scm 287 */

					{	/* Ast/let.scm 288 */
					   value_bglt arg1666_1024;
					   {	/* Ast/let.scm 288 */
					      local_bglt obj_1685;
					      obj_1685 =
						 (local_bglt) (aux_1021);
					      arg1666_1024 =
						 (((local_bglt) CREF(obj_1685))->value);
					   }
					   ((((local_bglt) CREF(new_1023))->value) = ((value_bglt) arg1666_1024), BUNSPEC);
					}
					{	/* Ast/let.scm 289 */
					   bool_t arg1667_1025;
					   {	/* Ast/let.scm 289 */
					      bool_t _ortest_1464_1026;
					      {		/* Ast/let.scm 289 */
						 local_bglt obj_1688;
						 obj_1688 =
						    (local_bglt) (aux_1021);
						 _ortest_1464_1026 =
						    (((local_bglt) CREF(obj_1688))->user__32);
					      }
					      if (_ortest_1464_1026)
						{	/* Ast/let.scm 289 */
						   arg1667_1025 = _ortest_1464_1026;
						}
					      else
						{	/* Ast/let.scm 290 */
						   local_bglt obj_1689;
						   obj_1689 =
						      (local_bglt) (ovar_1019);
						   arg1667_1025 =
						      (((local_bglt) CREF(obj_1689))->user__32);
						}
					   }
					   ((((local_bglt) CREF(new_1023))->user__32) = ((bool_t) arg1667_1025), BUNSPEC);
					}
					{	/* Ast/let.scm 291 */
					   obj_t arg1669_1027;
					   {	/* Ast/let.scm 291 */
					      local_bglt obj_1692;
					      obj_1692 =
						 (local_bglt) (aux_1021);
					      arg1669_1027 =
						 (((local_bglt) CREF(obj_1692))->name);
					   }
					   ((((local_bglt) CREF(new_1023))->name) = ((obj_t) arg1669_1027), BUNSPEC);
					}
					arg1664_1016 = new_1023;
				     }
				  }
			       }
			    }
			 }
			 {	/* ./Ieee/pair-list.scm 5689 */
			    obj_t aux_2281;
			    aux_2281 =
			       (obj_t) (arg1664_1016);
			    newtail1463_1014 =
			       MAKE_PAIR(aux_2281, BNIL);
			 }
		      }
		      SET_CDR(tail1462_1011, newtail1463_1014);
		      {
			 obj_t tail1462_2287;
			 obj_t l1459_2285;
			 l1459_2285 =
			    CDR(l1459_1010);
			 tail1462_2287 = newtail1463_1014;
			 tail1462_1011 = tail1462_2287;
			 l1459_1010 = l1459_2285;
			 goto lname1460_1012;
		      }
		   }
	      }
	   }
	 {
	    obj_t vbindings_959;
	    obj_t nvars_960;
	    vbindings_959 = value_bindings_254_28;
	    nvars_960 = new_funs_1_958;
	  loop_961:
	    if (
	       NULLP(vbindings_959))
	      {		/* Ast/let.scm 299 */
		 node_bglt body_963;
		 body_963 =
		    substitute__30_ast_substitute(old_funs_44_957, new_funs_1_958, node_29, site_30);
		 {	/* Ast/let.scm 299 */
		    obj_t funs_964;
		    funs_964 =
		       reverse__39___r4_pairs_and_lists_6_3(new_funs_1_958);
		    {	/* Ast/let.scm 300 */
		       obj_t loc_965;
		       {	/* Ast/let.scm 301 */
			  bool_t test1636_971;
			  if (
			     PAIRP(funs_964))
			    {	/* ./Ast/var.scm 766 */
			       obj_t aux_2294;
			       {	/* Ast/let.scm 302 */
				  value_bglt aux_2295;
				  {	/* Ast/let.scm 302 */
				     local_bglt obj_1703;
				     {	/* Ast/let.scm 302 */
					obj_t aux_2296;
					aux_2296 =
					   CAR(funs_964);
					obj_1703 =
					   (local_bglt) (aux_2296);
				     }
				     aux_2295 =
					(((local_bglt) CREF(obj_1703))->value);
				  }
				  aux_2294 =
				     (obj_t) (aux_2295);
			       }
			       test1636_971 =
				  is_a__118___object(aux_2294, sfun_ast_var);
			    }
			  else
			    {	/* Ast/let.scm 301 */
			       test1636_971 = ((bool_t) 0);
			    }
			  if (test1636_971)
			    {	/* Ast/let.scm 303 */
			       node_bglt obj_1708;
			       {	/* Ast/let.scm 303 */
				  obj_t aux_2303;
				  {	/* Ast/let.scm 303 */
				     sfun_bglt obj_1707;
				     {	/* Ast/let.scm 303 */
					value_bglt aux_2304;
					{	/* Ast/let.scm 303 */
					   local_bglt obj_1706;
					   {	/* Ast/let.scm 303 */
					      obj_t aux_2305;
					      aux_2305 =
						 CAR(funs_964);
					      obj_1706 =
						 (local_bglt) (aux_2305);
					   }
					   aux_2304 =
					      (((local_bglt) CREF(obj_1706))->value);
					}
					obj_1707 =
					   (sfun_bglt) (aux_2304);
				     }
				     aux_2303 =
					(((sfun_bglt) CREF(obj_1707))->body);
				  }
				  obj_1708 =
				     (node_bglt) (aux_2303);
			       }
			       loc_965 =
				  (((node_bglt) CREF(obj_1708))->loc);
			    }
			  else
			    {	/* Ast/let.scm 301 */
			       loc_965 =
				  (((node_bglt) CREF(node_29))->loc);
			    }
		       }
		       {	/* Ast/let.scm 301 */

			  {	/* Ast/let.scm 305 */
			     type_bglt arg1632_967;
			     arg1632_967 =
				(((node_bglt) CREF(node_29))->type);
			     {	/* Ast/let.scm 305 */
				let_fun_218_bglt res1752_1727;
				{	/* Ast/let.scm 305 */
				   obj_t key_1714;
				   key_1714 =
				      BINT(((long) -1));
				   {	/* ./Ast/node.scm 946 */
				      let_fun_218_bglt new1358_1717;
				      new1358_1717 =
					 ((let_fun_218_bglt) BREF(GC_MALLOC(sizeof(struct let_fun_218))));
				      {		/* ./Ast/node.scm 946 */
					 long arg1686_1718;
					 arg1686_1718 =
					    class_num_218___object(let_fun_218_ast_node);
					 {	/* ./Ast/node.scm 946 */
					    obj_t obj_1725;
					    obj_1725 =
					       (obj_t) (new1358_1717);
					    (((obj_t) CREF(obj_1725))->header = MAKE_HEADER(arg1686_1718, 0), BUNSPEC);
					 }
				      }
				      {		/* ./Ast/node.scm 946 */
					 object_bglt aux_2320;
					 aux_2320 =
					    (object_bglt) (new1358_1717);
					 OBJECT_WIDENING_SET(aux_2320, BFALSE);
				      }
				      ((((let_fun_218_bglt) CREF(new1358_1717))->loc) = ((obj_t) loc_965), BUNSPEC);
				      ((((let_fun_218_bglt) CREF(new1358_1717))->type) = ((type_bglt) arg1632_967), BUNSPEC);
				      ((((let_fun_218_bglt) CREF(new1358_1717))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
				      ((((let_fun_218_bglt) CREF(new1358_1717))->key) = ((obj_t) key_1714), BUNSPEC);
				      ((((let_fun_218_bglt) CREF(new1358_1717))->locals) = ((obj_t) funs_964), BUNSPEC);
				      ((((let_fun_218_bglt) CREF(new1358_1717))->body) = ((node_bglt) body_963), BUNSPEC);
				      res1752_1727 = new1358_1717;
				   }
				}
				return res1752_1727;
			     }
			  }
		       }
		    }
		 }
	      }
	    else
	      {		/* Ast/let.scm 311 */
		 obj_t nvar_979;
		 nvar_979 =
		    CAR(nvars_960);
		 {	/* Ast/let.scm 312 */
		    value_bglt sfun_980;
		    {	/* Ast/let.scm 313 */
		       local_bglt obj_1730;
		       obj_1730 =
			  (local_bglt) (nvar_979);
		       sfun_980 =
			  (((local_bglt) CREF(obj_1730))->value);
		    }
		    {	/* Ast/let.scm 313 */
		       obj_t body_981;
		       {	/* Ast/let.scm 314 */
			  sfun_bglt obj_1731;
			  obj_1731 =
			     (sfun_bglt) (sfun_980);
			  body_981 =
			     (((sfun_bglt) CREF(obj_1731))->body);
		       }
		       {	/* Ast/let.scm 316 */

			  {	/* Ast/let.scm 318 */
			     node_bglt arg1643_984;
			     {	/* Ast/let.scm 318 */
				obj_t arg1644_985;
				obj_t arg1646_986;
				obj_t arg1647_987;
				{	/* ./Ieee/pair-list.scm 5689 */
				   obj_t aux_2334;
				   {	/* ./Ieee/pair-list.scm 5701 */
				      obj_t aux_2335;
				      {		/* Ast/let.scm 316 */
					 let_fun_218_bglt obj_1733;
					 {	/* Ast/let.scm 316 */
					    obj_t aux_2336;
					    {	/* ./Ieee/pair-list.scm 5707 */
					       obj_t aux_2337;
					       aux_2337 =
						  CAR(vbindings_959);
					       aux_2336 =
						  CDR(aux_2337);
					    }
					    obj_1733 =
					       (let_fun_218_bglt) (aux_2336);
					 }
					 aux_2335 =
					    (((let_fun_218_bglt) CREF(obj_1733))->locals);
				      }
				      aux_2334 =
					 CAR(aux_2335);
				   }
				   arg1644_985 =
				      MAKE_PAIR(aux_2334, old_funs_44_957);
				}
				arg1646_986 =
				   MAKE_PAIR(nvar_979, new_funs_1_958);
				arg1647_987 =
				   CNST_TABLE_REF(((long) 1));
				arg1643_984 =
				   substitute__30_ast_substitute(arg1644_985, arg1646_986,
				   (node_bglt) (body_981), arg1647_987);
			     }
			     {	/* Ast/let.scm 317 */
				sfun_bglt obj_1739;
				obj_t val1123_1740;
				obj_1739 =
				   (sfun_bglt) (sfun_980);
				val1123_1740 =
				   (obj_t) (arg1643_984);
				((((sfun_bglt) CREF(obj_1739))->body) = ((obj_t) val1123_1740), BUNSPEC);
			     }
			  }
			  {
			     obj_t nvars_2353;
			     obj_t vbindings_2351;
			     vbindings_2351 =
				CDR(vbindings_959);
			     nvars_2353 =
				CDR(nvars_960);
			     nvars_960 = nvars_2353;
			     vbindings_959 = vbindings_2351;
			     goto loop_961;
			  }
		       }
		    }
		 }
	      }
	 }
      }
   }
}



/* method-init */
obj_t 
method_init_76_ast_let()
{
   AN_OBJECT;
   {	/* Ast/let.scm 14 */
      return BUNSPEC;
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_ast_let()
{
   AN_OBJECT;
   {	/* Ast/let.scm 14 */
      module_initialization_70_type_type(((long) 0), "AST_LET");
      module_initialization_70_ast_var(((long) 0), "AST_LET");
      module_initialization_70_ast_node(((long) 0), "AST_LET");
      module_initialization_70_tools_trace(((long) 0), "AST_LET");
      module_initialization_70_type_cache(((long) 0), "AST_LET");
      module_initialization_70_tools_progn(((long) 0), "AST_LET");
      module_initialization_70_tools_shape(((long) 0), "AST_LET");
      module_initialization_70_tools_location(((long) 0), "AST_LET");
      module_initialization_70_ast_ident(((long) 0), "AST_LET");
      module_initialization_70_ast_sexp(((long) 0), "AST_LET");
      module_initialization_70_ast_local(((long) 0), "AST_LET");
      return
	 module_initialization_70_ast_substitute(((long) 0), "AST_LET");
   }
}
