/*===========================================================================*/
/*   (Ast/local.scm)                                                         */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;


static obj_t method_init_76_ast_local();
extern obj_t string_append(obj_t, obj_t);
static obj_t _clone_local_106_ast_local(obj_t, obj_t, obj_t);
static local_bglt make_new_local_222_ast_local(obj_t, type_bglt, obj_t, bool_t);
extern local_bglt clone_local_230_ast_local(local_bglt, value_bglt);
extern obj_t module_initialization_70_ast_local(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_ident(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_numbers_6_5_fixnum(long, char *);
extern local_bglt make_local_svar_140_ast_local(obj_t, type_bglt);
extern long class_num_218___object(obj_t);
extern obj_t svar_ast_var;
static obj_t imported_modules_init_94_ast_local();
static obj_t _make_user_local_svar_52_ast_local(obj_t, obj_t, obj_t);
extern obj_t id__name_228_ast_ident(obj_t);
static long _local_key__223_ast_local;
static obj_t library_modules_init_112_ast_local();
static obj_t _make_local_svar_141_ast_local(obj_t, obj_t, obj_t);
static obj_t toplevel_init_63_ast_local();
extern obj_t open_input_string(obj_t);
extern local_bglt make_local_sfun_184_ast_local(obj_t, type_bglt, sfun_bglt);
static obj_t _make_local_sexit_250_ast_local(obj_t, obj_t, obj_t, obj_t);
extern char *integer__string_135___r4_numbers_6_5_fixnum(long, obj_t);
extern obj_t string_to_bstring(char *);
extern obj_t local_id__name_204_ast_ident(obj_t);
extern obj_t local_ast_var;
extern local_bglt make_user_local_svar_134_ast_local(obj_t, type_bglt);
static obj_t _make_user_local_sfun_30_ast_local(obj_t, obj_t, obj_t, obj_t);
extern local_bglt make_local_sexit_184_ast_local(obj_t, type_bglt, sexit_bglt);
static long get_new_key_51_ast_local();
static obj_t _make_local_sfun_99_ast_local(obj_t, obj_t, obj_t, obj_t);
extern obj_t read___reader(obj_t);
static obj_t require_initialization_114_ast_local = BUNSPEC;
static obj_t cnst_init_137_ast_local();
extern local_bglt make_user_local_sfun_221_ast_local(obj_t, type_bglt, sfun_bglt);
static obj_t __cnst[2];

DEFINE_EXPORT_PROCEDURE(make_local_svar_env_143_ast_local, _make_local_svar_141_ast_local1272, _make_local_svar_141_ast_local, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_local_sfun_env_161_ast_local, _make_local_sfun_99_ast_local1273, _make_local_sfun_99_ast_local, 0L, 3);
DEFINE_EXPORT_PROCEDURE(make_local_sexit_env_161_ast_local, _make_local_sexit_250_ast_local1274, _make_local_sexit_250_ast_local, 0L, 3);
DEFINE_EXPORT_PROCEDURE(clone_local_env_253_ast_local, _clone_local_106_ast_local1275, _clone_local_106_ast_local, 0L, 2);
DEFINE_STRING(string1267_ast_local, string1267_ast_local1276, "NOW READ ", 9);
DEFINE_STRING(string1266_ast_local, string1266_ast_local1277, "_", 1);
DEFINE_EXPORT_PROCEDURE(make_user_local_svar_env_199_ast_local, _make_user_local_svar_52_ast_local1278, _make_user_local_svar_52_ast_local, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_user_local_sfun_env_4_ast_local, _make_user_local_sfun_30_ast_local1279, _make_user_local_sfun_30_ast_local, 0L, 3);



/* module-initialization */
obj_t 
module_initialization_70_ast_local(long checksum_612, char *from_613)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_ast_local))
	{
	   require_initialization_114_ast_local =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_ast_local();
	   cnst_init_137_ast_local();
	   imported_modules_init_94_ast_local();
	   method_init_76_ast_local();
	   toplevel_init_63_ast_local();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_ast_local()
{
   AN_OBJECT;
   {	/* Ast/local.scm 14 */
      module_initialization_70___object(((long) 0), "AST_LOCAL");
      module_initialization_70___r4_numbers_6_5_fixnum(((long) 0), "AST_LOCAL");
      module_initialization_70___reader(((long) 0), "AST_LOCAL");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_ast_local()
{
   AN_OBJECT;
   {	/* Ast/local.scm 14 */
      {		/* Ast/local.scm 14 */
	 obj_t cnst_port_138_605;
	 cnst_port_138_605 =
	    open_input_string(string1267_ast_local);
	 {
	    long i_606;
	    i_606 = ((long) 1);
	  loop_607:
	    {	/* Ast/local.scm 14 */
	       bool_t test1268_608;
	       test1268_608 =
		  (i_606 == ((long) -1));
	       if (test1268_608)
		 {	/* Ast/local.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Ast/local.scm 14 */
		    {	/* Ast/local.scm 14 */
		       obj_t arg1269_609;
		       {	/* Ast/local.scm 14 */
			  obj_t list1270_610;
			  list1270_610 =
			     MAKE_PAIR(cnst_port_138_605, BNIL);
			  arg1269_609 =
			     read___reader(list1270_610);
		       }
		       CNST_TABLE_SET(i_606, arg1269_609);
		    }
		    {	/* Ast/local.scm 14 */
		       int aux_611;
		       {	/* Ast/local.scm 14 */
			  long aux_631;
			  aux_631 =
			     (i_606 - ((long) 1));
			  aux_611 =
			     (int) (aux_631);
		       }
		       {
			  long i_634;
			  i_634 =
			     (long) (aux_611);
			  i_606 = i_634;
			  goto loop_607;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_ast_local()
{
   AN_OBJECT;
   {	/* Ast/local.scm 14 */
      return (
	 _local_key__223_ast_local = ((long) 0), BUNSPEC);
   }
}



/* get-new-key */
long 
get_new_key_51_ast_local()
{
   AN_OBJECT;
   {	/* Ast/local.scm 35 */
      {		/* Ast/local.scm 36 */
	 long z1_489;
	 z1_489 = _local_key__223_ast_local;
	 _local_key__223_ast_local =
	    (z1_489 + ((long) 1));
      }
      return _local_key__223_ast_local;
   }
}



/* make-new-local */
local_bglt 
make_new_local_222_ast_local(obj_t id_1, type_bglt type_2, obj_t value_3, bool_t user__32_4)
{
   AN_OBJECT;
   {	/* Ast/local.scm 44 */
      {		/* Ast/local.scm 45 */
	 long key_324;
	 key_324 =
	    get_new_key_51_ast_local();
	 {	/* Ast/local.scm 46 */
	    obj_t arg1192_326;
	    obj_t arg1195_329;
	    obj_t arg1196_330;
	    {	/* Ast/local.scm 49 */
	       obj_t arg1204_334;
	       obj_t arg1206_335;
	       arg1204_334 =
		  local_id__name_204_ast_ident(id_1);
	       {	/* Ast/local.scm 49 */
		  obj_t aux_639;
		  {	/* Ast/local.scm 49 */
		     char *aux_640;
		     aux_640 =
			integer__string_135___r4_numbers_6_5_fixnum(key_324, BNIL);
		     aux_639 =
			string_to_bstring(aux_640);
		  }
		  arg1206_335 =
		     string_append(string1266_ast_local, aux_639);
	       }
	       arg1192_326 =
		  string_append(arg1204_334, arg1206_335);
	    }
	    arg1195_329 =
	       CNST_TABLE_REF(((long) 0));
	    arg1196_330 =
	       CNST_TABLE_REF(((long) 1));
	    {	/* Ast/local.scm 46 */
	       local_bglt res1262_515;
	       {	/* Ast/local.scm 46 */
		  value_bglt value_494;
		  value_494 =
		     (value_bglt) (value_3);
		  {	/* ./Ast/var.scm 675 */
		     local_bglt new1089_501;
		     new1089_501 =
			((local_bglt) BREF(GC_MALLOC(sizeof(struct local))));
		     {	/* ./Ast/var.scm 675 */
			long arg1253_502;
			arg1253_502 =
			   class_num_218___object(local_ast_var);
			{	/* ./Ast/var.scm 675 */
			   obj_t obj_513;
			   obj_513 =
			      (obj_t) (new1089_501);
			   (((obj_t) CREF(obj_513))->header = MAKE_HEADER(arg1253_502, 0), BUNSPEC);
			}
		     }
		     {	/* ./Ast/var.scm 675 */
			object_bglt aux_652;
			aux_652 =
			   (object_bglt) (new1089_501);
			OBJECT_WIDENING_SET(aux_652, BFALSE);
		     }
		     ((((local_bglt) CREF(new1089_501))->id) = ((obj_t) id_1), BUNSPEC);
		     ((((local_bglt) CREF(new1089_501))->name) = ((obj_t) arg1192_326), BUNSPEC);
		     ((((local_bglt) CREF(new1089_501))->type) = ((type_bglt) type_2), BUNSPEC);
		     ((((local_bglt) CREF(new1089_501))->value) = ((value_bglt) value_494), BUNSPEC);
		     ((((local_bglt) CREF(new1089_501))->access) = ((obj_t) arg1195_329), BUNSPEC);
		     ((((local_bglt) CREF(new1089_501))->fast_alpha_7) = ((obj_t) BUNSPEC), BUNSPEC);
		     ((((local_bglt) CREF(new1089_501))->removable) = ((obj_t) arg1196_330), BUNSPEC);
		     ((((local_bglt) CREF(new1089_501))->occurrence) = ((long) ((long) 0)), BUNSPEC);
		     ((((local_bglt) CREF(new1089_501))->user__32) = ((bool_t) user__32_4), BUNSPEC);
		     ((((local_bglt) CREF(new1089_501))->key) = ((long) key_324), BUNSPEC);
		     res1262_515 = new1089_501;
		  }
	       }
	       return res1262_515;
	    }
	 }
      }
   }
}



/* clone-local */
local_bglt 
clone_local_230_ast_local(local_bglt local_5, value_bglt value_6)
{
   AN_OBJECT;
   {	/* Ast/local.scm 57 */
      {		/* Ast/local.scm 58 */
	 long key_339;
	 key_339 =
	    get_new_key_51_ast_local();
	 {	/* Ast/local.scm 60 */
	    local_bglt new1187_342;
	    {	/* Ast/local.scm 60 */
	       obj_t arg1212_343;
	       obj_t arg1213_344;
	       type_bglt arg1214_345;
	       obj_t arg1216_347;
	       obj_t arg1217_348;
	       obj_t arg1220_349;
	       long arg1222_350;
	       bool_t arg1223_351;
	       arg1212_343 =
		  (((local_bglt) CREF(local_5))->id);
	       {	/* Ast/local.scm 62 */
		  obj_t arg1226_353;
		  obj_t arg1227_354;
		  arg1226_353 =
		     id__name_228_ast_ident(
		     (((local_bglt) CREF(local_5))->id));
		  {	/* Ast/local.scm 62 */
		     obj_t aux_669;
		     {	/* Ast/local.scm 62 */
			char *aux_670;
			aux_670 =
			   integer__string_135___r4_numbers_6_5_fixnum(key_339, BNIL);
			aux_669 =
			   string_to_bstring(aux_670);
		     }
		     arg1227_354 =
			string_append(string1266_ast_local, aux_669);
		  }
		  arg1213_344 =
		     string_append(arg1226_353, arg1227_354);
	       }
	       arg1214_345 =
		  (((local_bglt) CREF(local_5))->type);
	       arg1216_347 =
		  (((local_bglt) CREF(local_5))->access);
	       arg1217_348 =
		  (((local_bglt) CREF(local_5))->fast_alpha_7);
	       arg1220_349 =
		  (((local_bglt) CREF(local_5))->removable);
	       arg1222_350 =
		  (((local_bglt) CREF(local_5))->occurrence);
	       arg1223_351 =
		  (((local_bglt) CREF(local_5))->user__32);
	       {	/* Ast/local.scm 60 */
		  local_bglt res1263_548;
		  {	/* ./Ast/var.scm 675 */
		     local_bglt new1089_534;
		     new1089_534 =
			((local_bglt) BREF(GC_MALLOC(sizeof(struct local))));
		     {	/* ./Ast/var.scm 675 */
			long arg1253_535;
			arg1253_535 =
			   class_num_218___object(local_ast_var);
			{	/* ./Ast/var.scm 675 */
			   obj_t obj_546;
			   obj_546 =
			      (obj_t) (new1089_534);
			   (((obj_t) CREF(obj_546))->header = MAKE_HEADER(arg1253_535, 0), BUNSPEC);
			}
		     }
		     {	/* ./Ast/var.scm 675 */
			object_bglt aux_685;
			aux_685 =
			   (object_bglt) (new1089_534);
			OBJECT_WIDENING_SET(aux_685, BFALSE);
		     }
		     ((((local_bglt) CREF(new1089_534))->id) = ((obj_t) arg1212_343), BUNSPEC);
		     ((((local_bglt) CREF(new1089_534))->name) = ((obj_t) arg1213_344), BUNSPEC);
		     ((((local_bglt) CREF(new1089_534))->type) = ((type_bglt) arg1214_345), BUNSPEC);
		     ((((local_bglt) CREF(new1089_534))->value) = ((value_bglt) value_6), BUNSPEC);
		     ((((local_bglt) CREF(new1089_534))->access) = ((obj_t) arg1216_347), BUNSPEC);
		     ((((local_bglt) CREF(new1089_534))->fast_alpha_7) = ((obj_t) arg1217_348), BUNSPEC);
		     ((((local_bglt) CREF(new1089_534))->removable) = ((obj_t) arg1220_349), BUNSPEC);
		     ((((local_bglt) CREF(new1089_534))->occurrence) = ((long) arg1222_350), BUNSPEC);
		     ((((local_bglt) CREF(new1089_534))->user__32) = ((bool_t) arg1223_351), BUNSPEC);
		     ((((local_bglt) CREF(new1089_534))->key) = ((long) key_339), BUNSPEC);
		     res1263_548 = new1089_534;
		  }
		  new1187_342 = res1263_548;
	       }
	    }
	    {	/* Ast/local.scm 60 */

	       return new1187_342;
	    }
	 }
      }
   }
}



/* _clone-local */
obj_t 
_clone_local_106_ast_local(obj_t env_584, obj_t local_585, obj_t value_586)
{
   AN_OBJECT;
   {	/* Ast/local.scm 57 */
      {		/* Ast/local.scm 57 */
	 local_bglt aux_698;
	 aux_698 =
	    clone_local_230_ast_local(
	    (local_bglt) (local_585),
	    (value_bglt) (value_586));
	 return
	    (obj_t) (aux_698);
      }
   }
}



/* make-local-svar */
local_bglt 
make_local_svar_140_ast_local(obj_t id_7, type_bglt type_8)
{
   AN_OBJECT;
   {	/* Ast/local.scm 68 */
      {		/* Ast/local.scm 69 */
	 svar_bglt arg1232_549;
	 {	/* Ast/local.scm 69 */
	    svar_bglt res1264_556;
	    {	/* ./Ast/var.scm 724 */
	       svar_bglt new1161_551;
	       new1161_551 =
		  ((svar_bglt) BREF(GC_MALLOC(sizeof(struct svar))));
	       {	/* ./Ast/var.scm 724 */
		  long arg1243_552;
		  arg1243_552 =
		     class_num_218___object(svar_ast_var);
		  {	/* ./Ast/var.scm 724 */
		     obj_t obj_554;
		     obj_554 =
			(obj_t) (new1161_551);
		     (((obj_t) CREF(obj_554))->header = MAKE_HEADER(arg1243_552, 0), BUNSPEC);
		  }
	       }
	       {	/* ./Ast/var.scm 724 */
		  object_bglt aux_707;
		  aux_707 =
		     (object_bglt) (new1161_551);
		  OBJECT_WIDENING_SET(aux_707, BFALSE);
	       }
	       ((((svar_bglt) CREF(new1161_551))->loc) = ((obj_t) BUNSPEC), BUNSPEC);
	       res1264_556 = new1161_551;
	    }
	    arg1232_549 = res1264_556;
	 }
	 return
	    make_new_local_222_ast_local(id_7, type_8,
	    (obj_t) (arg1232_549), ((bool_t) 0));
      }
   }
}



/* _make-local-svar */
obj_t 
_make_local_svar_141_ast_local(obj_t env_587, obj_t id_588, obj_t type_589)
{
   AN_OBJECT;
   {	/* Ast/local.scm 68 */
      {		/* Ast/local.scm 68 */
	 local_bglt aux_713;
	 aux_713 =
	    make_local_svar_140_ast_local(id_588,
	    (type_bglt) (type_589));
	 return
	    (obj_t) (aux_713);
      }
   }
}



/* make-user-local-svar */
local_bglt 
make_user_local_svar_134_ast_local(obj_t id_9, type_bglt type_10)
{
   AN_OBJECT;
   {	/* Ast/local.scm 74 */
      {		/* Ast/local.scm 75 */
	 svar_bglt arg1233_557;
	 {	/* Ast/local.scm 75 */
	    svar_bglt res1265_564;
	    {	/* ./Ast/var.scm 724 */
	       svar_bglt new1161_559;
	       new1161_559 =
		  ((svar_bglt) BREF(GC_MALLOC(sizeof(struct svar))));
	       {	/* ./Ast/var.scm 724 */
		  long arg1243_560;
		  arg1243_560 =
		     class_num_218___object(svar_ast_var);
		  {	/* ./Ast/var.scm 724 */
		     obj_t obj_562;
		     obj_562 =
			(obj_t) (new1161_559);
		     (((obj_t) CREF(obj_562))->header = MAKE_HEADER(arg1243_560, 0), BUNSPEC);
		  }
	       }
	       {	/* ./Ast/var.scm 724 */
		  object_bglt aux_721;
		  aux_721 =
		     (object_bglt) (new1161_559);
		  OBJECT_WIDENING_SET(aux_721, BFALSE);
	       }
	       ((((svar_bglt) CREF(new1161_559))->loc) = ((obj_t) BUNSPEC), BUNSPEC);
	       res1265_564 = new1161_559;
	    }
	    arg1233_557 = res1265_564;
	 }
	 return
	    make_new_local_222_ast_local(id_9, type_10,
	    (obj_t) (arg1233_557), ((bool_t) 1));
      }
   }
}



/* _make-user-local-svar */
obj_t 
_make_user_local_svar_52_ast_local(obj_t env_590, obj_t id_591, obj_t type_592)
{
   AN_OBJECT;
   {	/* Ast/local.scm 74 */
      {		/* Ast/local.scm 74 */
	 local_bglt aux_727;
	 aux_727 =
	    make_user_local_svar_134_ast_local(id_591,
	    (type_bglt) (type_592));
	 return
	    (obj_t) (aux_727);
      }
   }
}



/* make-local-sexit */
local_bglt 
make_local_sexit_184_ast_local(obj_t id_11, type_bglt type_12, sexit_bglt sexit_13)
{
   AN_OBJECT;
   {	/* Ast/local.scm 80 */
      return
	 make_new_local_222_ast_local(id_11, type_12,
	 (obj_t) (sexit_13), ((bool_t) 0));
   }
}



/* _make-local-sexit */
obj_t 
_make_local_sexit_250_ast_local(obj_t env_593, obj_t id_594, obj_t type_595, obj_t sexit_596)
{
   AN_OBJECT;
   {	/* Ast/local.scm 80 */
      {		/* Ast/local.scm 80 */
	 local_bglt aux_733;
	 aux_733 =
	    make_local_sexit_184_ast_local(id_594,
	    (type_bglt) (type_595),
	    (sexit_bglt) (sexit_596));
	 return
	    (obj_t) (aux_733);
      }
   }
}



/* make-local-sfun */
local_bglt 
make_local_sfun_184_ast_local(obj_t id_14, type_bglt type_15, sfun_bglt sfun_16)
{
   AN_OBJECT;
   {	/* Ast/local.scm 88 */
      return
	 make_new_local_222_ast_local(id_14, type_15,
	 (obj_t) (sfun_16), ((bool_t) 0));
   }
}



/* _make-local-sfun */
obj_t 
_make_local_sfun_99_ast_local(obj_t env_597, obj_t id_598, obj_t type_599, obj_t sfun_600)
{
   AN_OBJECT;
   {	/* Ast/local.scm 88 */
      {		/* Ast/local.scm 88 */
	 local_bglt aux_740;
	 aux_740 =
	    make_local_sfun_184_ast_local(id_598,
	    (type_bglt) (type_599),
	    (sfun_bglt) (sfun_600));
	 return
	    (obj_t) (aux_740);
      }
   }
}



/* make-user-local-sfun */
local_bglt 
make_user_local_sfun_221_ast_local(obj_t id_17, type_bglt type_18, sfun_bglt sfun_19)
{
   AN_OBJECT;
   {	/* Ast/local.scm 96 */
      return
	 make_new_local_222_ast_local(id_17, type_18,
	 (obj_t) (sfun_19), ((bool_t) 1));
   }
}



/* _make-user-local-sfun */
obj_t 
_make_user_local_sfun_30_ast_local(obj_t env_601, obj_t id_602, obj_t type_603, obj_t sfun_604)
{
   AN_OBJECT;
   {	/* Ast/local.scm 96 */
      {		/* Ast/local.scm 96 */
	 local_bglt aux_747;
	 aux_747 =
	    make_user_local_sfun_221_ast_local(id_602,
	    (type_bglt) (type_603),
	    (sfun_bglt) (sfun_604));
	 return
	    (obj_t) (aux_747);
      }
   }
}



/* method-init */
obj_t 
method_init_76_ast_local()
{
   AN_OBJECT;
   {	/* Ast/local.scm 14 */
      return BUNSPEC;
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_ast_local()
{
   AN_OBJECT;
   {	/* Ast/local.scm 14 */
      module_initialization_70_type_type(((long) 0), "AST_LOCAL");
      module_initialization_70_type_cache(((long) 0), "AST_LOCAL");
      module_initialization_70_engine_param(((long) 0), "AST_LOCAL");
      module_initialization_70_ast_var(((long) 0), "AST_LOCAL");
      return
	 module_initialization_70_ast_ident(((long) 0), "AST_LOCAL");
   }
}
