/*===========================================================================*/
/*   (Ast/lvtype.scm)                                                        */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;


static obj_t method_init_76_ast_lvtype();
extern obj_t make_box_202_ast_node;
extern obj_t funcall_ast_node;
extern long add_inlined_method__244___object(obj_t, obj_t, long);
extern obj_t fail_ast_node;
extern obj_t box_ref_242_ast_node;
extern obj_t sequence_ast_node;
extern obj_t let_var_6_ast_node;
extern obj_t var_ast_node;
extern obj_t closure_ast_node;
extern obj_t lvtype_node__58_ast_lvtype(node_bglt);
static obj_t _lvtype_node__default1463_42_ast_lvtype(obj_t, obj_t);
extern obj_t _obj__252_type_cache;
extern obj_t pragma_ast_node;
extern obj_t set_ex_it_116_ast_node;
extern obj_t module_initialization_70_ast_lvtype(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_coerce_typeof(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
static obj_t lvtype_node__default1463_35_ast_lvtype(node_bglt);
extern obj_t let_fun_218_ast_node;
static obj_t imported_modules_init_94_ast_lvtype();
extern obj_t app_ly_162_ast_node;
extern obj_t add_generic__110___object(obj_t, obj_t);
static bool_t lvtype_node___164_ast_lvtype(obj_t);
extern obj_t app_ast_node;
static obj_t library_modules_init_112_ast_lvtype();
extern obj_t atom_ast_node;
extern obj_t cast_ast_node;
static obj_t toplevel_init_63_ast_lvtype();
extern obj_t jump_ex_it_184_ast_node;
extern obj_t open_input_string(obj_t);
extern obj_t kwote_ast_node;
static obj_t _lvtype_node_1656_242_ast_lvtype(obj_t, obj_t);
extern obj_t setq_ast_node;
extern obj_t box_set__221_ast_node;
extern type_bglt typeof_coerce_typeof(node_bglt);
extern obj_t shape_tools_shape(obj_t);
extern obj_t internal_error_43_tools_error(obj_t, obj_t, obj_t);
extern obj_t _classes__134___object;
extern obj_t select_ast_node;
extern obj_t read___reader(obj_t);
static obj_t set_variable_type__9_ast_lvtype(variable_bglt, type_bglt);
extern obj_t ____74_type_cache;
static obj_t require_initialization_114_ast_lvtype = BUNSPEC;
extern obj_t conditional_ast_node;
static obj_t cnst_init_137_ast_lvtype();
static obj_t __cnst[1];

DEFINE_EXPORT_GENERIC(lvtype_node__env_81_ast_lvtype, _lvtype_node_1656_242_ast_lvtype1665, _lvtype_node_1656_242_ast_lvtype, 0L, 1);
DEFINE_STATIC_PROCEDURE(lvtype_node__default1463_env_44_ast_lvtype, _lvtype_node__default1463_42_ast_lvtype1666, _lvtype_node__default1463_42_ast_lvtype, 0L, 1);
DEFINE_STRING(string1659_ast_lvtype, string1659_ast_lvtype1667, "No method for this object", 25);
DEFINE_STRING(string1660_ast_lvtype, string1660_ast_lvtype1668, "LVTYPE-NODE!-DEFAULT1463 ", 25);
DEFINE_STRING(string1658_ast_lvtype, string1658_ast_lvtype1669, "Unexpected closure", 18);
DEFINE_STRING(string1657_ast_lvtype, string1657_ast_lvtype1670, "lvtype-node!", 12);



/* module-initialization */
obj_t 
module_initialization_70_ast_lvtype(long checksum_1265, char *from_1266)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_ast_lvtype))
	{
	   require_initialization_114_ast_lvtype =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_ast_lvtype();
	   cnst_init_137_ast_lvtype();
	   imported_modules_init_94_ast_lvtype();
	   method_init_76_ast_lvtype();
	   toplevel_init_63_ast_lvtype();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_ast_lvtype()
{
   AN_OBJECT;
   {	/* Ast/lvtype.scm 16 */
      module_initialization_70___object(((long) 0), "AST_LVTYPE");
      module_initialization_70___reader(((long) 0), "AST_LVTYPE");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_ast_lvtype()
{
   AN_OBJECT;
   {	/* Ast/lvtype.scm 16 */
      {		/* Ast/lvtype.scm 16 */
	 obj_t cnst_port_138_1258;
	 cnst_port_138_1258 =
	    open_input_string(string1660_ast_lvtype);
	 {
	    long i_1259;
	    i_1259 = ((long) 0);
	  loop_1260:
	    {	/* Ast/lvtype.scm 16 */
	       bool_t test1661_1261;
	       test1661_1261 =
		  (i_1259 == ((long) -1));
	       if (test1661_1261)
		 {	/* Ast/lvtype.scm 16 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Ast/lvtype.scm 16 */
		    {	/* Ast/lvtype.scm 16 */
		       obj_t arg1662_1262;
		       {	/* Ast/lvtype.scm 16 */
			  obj_t list1663_1263;
			  list1663_1263 =
			     MAKE_PAIR(cnst_port_138_1258, BNIL);
			  arg1662_1262 =
			     read___reader(list1663_1263);
		       }
		       CNST_TABLE_SET(i_1259, arg1662_1262);
		    }
		    {	/* Ast/lvtype.scm 16 */
		       int aux_1264;
		       {	/* Ast/lvtype.scm 16 */
			  long aux_1283;
			  aux_1283 =
			     (i_1259 - ((long) 1));
			  aux_1264 =
			     (int) (aux_1283);
		       }
		       {
			  long i_1286;
			  i_1286 =
			     (long) (aux_1264);
			  i_1259 = i_1286;
			  goto loop_1260;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_ast_lvtype()
{
   AN_OBJECT;
   {	/* Ast/lvtype.scm 16 */
      return BUNSPEC;
   }
}



/* lvtype-node*! */
bool_t 
lvtype_node___164_ast_lvtype(obj_t node__221_24)
{
   AN_OBJECT;
   {	/* Ast/lvtype.scm 199 */
      {
	 obj_t l1460_722;
	 l1460_722 = node__221_24;
       lname1461_723:
	 if (
	    PAIRP(l1460_722))
	   {	/* Ast/lvtype.scm 200 */
	      {		/* Ast/lvtype.scm 200 */
		 node_bglt aux_1290;
		 {	/* Ast/lvtype.scm 200 */
		    obj_t aux_1291;
		    aux_1291 =
		       CAR(l1460_722);
		    aux_1290 =
		       (node_bglt) (aux_1291);
		 }
		 lvtype_node__58_ast_lvtype(aux_1290);
	      }
	      {
		 obj_t l1460_1295;
		 l1460_1295 =
		    CDR(l1460_722);
		 l1460_722 = l1460_1295;
		 goto lname1461_723;
	      }
	   }
	 else
	   {	/* Ast/lvtype.scm 200 */
	      return ((bool_t) 1);
	   }
      }
   }
}



/* set-variable-type! */
obj_t 
set_variable_type__9_ast_lvtype(variable_bglt variable_25, type_bglt type_26)
{
   AN_OBJECT;
   {	/* Ast/lvtype.scm 205 */
      {		/* Ast/lvtype.scm 206 */
	 obj_t ntype_727;
	 {	/* Ast/lvtype.scm 206 */
	    bool_t test1511_730;
	    {	/* Ast/lvtype.scm 206 */
	       obj_t obj2_1173;
	       obj2_1173 = ____74_type_cache;
	       {	/* ./Ieee/equiv.scm 5508 */
		  obj_t aux_1297;
		  aux_1297 =
		     (obj_t) (type_26);
		  test1511_730 =
		     (aux_1297 == obj2_1173);
	       }
	    }
	    if (test1511_730)
	      {		/* Ast/lvtype.scm 206 */
		 ntype_727 = _obj__252_type_cache;
	      }
	    else
	      {		/* Ast/lvtype.scm 206 */
		 ntype_727 =
		    (obj_t) (type_26);
	      }
	 }
	 {	/* Ast/lvtype.scm 208 */
	    bool_t test1510_729;
	    {	/* Ast/lvtype.scm 208 */
	       obj_t obj2_1176;
	       obj2_1176 = ____74_type_cache;
	       {	/* ./Ieee/equiv.scm 5508 */
		  obj_t aux_1302;
		  {	/* Ast/lvtype.scm 208 */
		     type_bglt aux_1303;
		     aux_1303 =
			(((variable_bglt) CREF(variable_25))->type);
		     aux_1302 =
			(obj_t) (aux_1303);
		  }
		  test1510_729 =
		     (aux_1302 == obj2_1176);
	       }
	    }
	    if (test1510_729)
	      {		/* Ast/lvtype.scm 209 */
		 type_bglt val1034_1178;
		 val1034_1178 =
		    (type_bglt) (ntype_727);
		 return
		    ((((variable_bglt) CREF(variable_25))->type) = ((type_bglt) val1034_1178), BUNSPEC);
	      }
	    else
	      {		/* Ast/lvtype.scm 208 */
		 return BUNSPEC;
	      }
	 }
      }
   }
}



/* method-init */
obj_t 
method_init_76_ast_lvtype()
{
   AN_OBJECT;
   {	/* Ast/lvtype.scm 16 */
      add_generic__110___object(lvtype_node__env_81_ast_lvtype, lvtype_node__default1463_env_44_ast_lvtype);
      add_inlined_method__244___object(lvtype_node__env_81_ast_lvtype, atom_ast_node, ((long) 0));
      add_inlined_method__244___object(lvtype_node__env_81_ast_lvtype, kwote_ast_node, ((long) 1));
      add_inlined_method__244___object(lvtype_node__env_81_ast_lvtype, var_ast_node, ((long) 2));
      add_inlined_method__244___object(lvtype_node__env_81_ast_lvtype, closure_ast_node, ((long) 3));
      add_inlined_method__244___object(lvtype_node__env_81_ast_lvtype, sequence_ast_node, ((long) 4));
      add_inlined_method__244___object(lvtype_node__env_81_ast_lvtype, app_ast_node, ((long) 5));
      add_inlined_method__244___object(lvtype_node__env_81_ast_lvtype, app_ly_162_ast_node, ((long) 6));
      add_inlined_method__244___object(lvtype_node__env_81_ast_lvtype, funcall_ast_node, ((long) 7));
      add_inlined_method__244___object(lvtype_node__env_81_ast_lvtype, pragma_ast_node, ((long) 8));
      add_inlined_method__244___object(lvtype_node__env_81_ast_lvtype, cast_ast_node, ((long) 9));
      add_inlined_method__244___object(lvtype_node__env_81_ast_lvtype, setq_ast_node, ((long) 10));
      add_inlined_method__244___object(lvtype_node__env_81_ast_lvtype, conditional_ast_node, ((long) 11));
      add_inlined_method__244___object(lvtype_node__env_81_ast_lvtype, fail_ast_node, ((long) 12));
      add_inlined_method__244___object(lvtype_node__env_81_ast_lvtype, select_ast_node, ((long) 13));
      add_inlined_method__244___object(lvtype_node__env_81_ast_lvtype, let_fun_218_ast_node, ((long) 14));
      add_inlined_method__244___object(lvtype_node__env_81_ast_lvtype, let_var_6_ast_node, ((long) 15));
      add_inlined_method__244___object(lvtype_node__env_81_ast_lvtype, set_ex_it_116_ast_node, ((long) 16));
      add_inlined_method__244___object(lvtype_node__env_81_ast_lvtype, jump_ex_it_184_ast_node, ((long) 17));
      add_inlined_method__244___object(lvtype_node__env_81_ast_lvtype, make_box_202_ast_node, ((long) 18));
      add_inlined_method__244___object(lvtype_node__env_81_ast_lvtype, box_set__221_ast_node, ((long) 19));
      {		/* Ast/lvtype.scm 16 */
	 long aux_1331;
	 aux_1331 =
	    add_inlined_method__244___object(lvtype_node__env_81_ast_lvtype, box_ref_242_ast_node, ((long) 20));
	 return
	    BINT(aux_1331);
      }
   }
}



/* lvtype-node! */
obj_t 
lvtype_node__58_ast_lvtype(node_bglt node_1)
{
   AN_OBJECT;
   {	/* Ast/lvtype.scm 29 */
    lvtype_node__58_ast_lvtype:
      {
	 obj_t method1594_1061;
	 obj_t class1599_1062;
	 {	/* Ast/lvtype.scm 29 */
	    obj_t arg1602_1059;
	    obj_t arg1603_1060;
	    {	/* Ast/lvtype.scm 29 */
	       object_bglt obj_1179;
	       obj_1179 =
		  (object_bglt) (node_1);
	       {	/* ./Llib/object.scm 2926 */
		  obj_t pre_method_105_1180;
		  pre_method_105_1180 =
		     PROCEDURE_REF(lvtype_node__env_81_ast_lvtype, ((long) 2));
		  if (
		     INTEGERP(pre_method_105_1180))
		    {	/* ./Llib/object.scm 2927 */
		       PROCEDURE_SET(lvtype_node__env_81_ast_lvtype, ((long) 2), BUNSPEC);
		       arg1602_1059 = pre_method_105_1180;
		    }
		  else
		    {	/* ./Llib/object.scm 2914 */
		       long obj_class_num_177_1185;
		       obj_class_num_177_1185 =
			  TYPE(obj_1179);
		       {	/* ./Llib/object.scm 2915 */
			  obj_t arg1176_1186;
			  arg1176_1186 =
			     PROCEDURE_REF(lvtype_node__env_81_ast_lvtype, ((long) 1));
			  {	/* ./Llib/object.scm 2738 */
			     long arg1177_1190;
			     {	/* ./Llib/object.scm 2738 */
				long arg1178_1191;
				arg1178_1191 =
				   OBJECT_TYPE;
				arg1177_1190 =
				   (obj_class_num_177_1185 - arg1178_1191);
			     }
			     arg1602_1059 =
				VECTOR_REF(arg1176_1186, arg1177_1190);
			  }
		       }
		    }
	       }
	    }
	    {	/* Ast/lvtype.scm 29 */
	       object_bglt object_1196;
	       object_1196 =
		  (object_bglt) (node_1);
	       {	/* ./Llib/object.scm 2695 */
		  long arg1179_1197;
		  {	/* ./Llib/object.scm 2695 */
		     long arg1180_1198;
		     long arg1181_1199;
		     arg1180_1198 =
			TYPE(object_1196);
		     arg1181_1199 =
			OBJECT_TYPE;
		     arg1179_1197 =
			(arg1180_1198 - arg1181_1199);
		  }
		  {	/* ./Llib/object.scm 2695 */
		     obj_t vector_1203;
		     vector_1203 = _classes__134___object;
		     arg1603_1060 =
			VECTOR_REF(vector_1203, arg1179_1197);
		  }
	       }
	    }
	    method1594_1061 = arg1602_1059;
	    class1599_1062 = arg1603_1060;
	    {

	       if (
		  INTEGERP(method1594_1061))
		 {	/* Ast/lvtype.scm 29 */
		    switch (
		       (long) CINT(method1594_1061))
		      {
		      case ((long) 0):

			 return BUNSPEC;
			 break;
		      case ((long) 1):

			 return BUNSPEC;
			 break;
		      case ((long) 2):

			 return BUNSPEC;
			 break;
		      case ((long) 3):

			 {	/* Ast/lvtype.scm 53 */
			    obj_t arg1608_1074;
			    {	/* Ast/lvtype.scm 53 */
			       obj_t aux_1351;
			       {	/* Ast/lvtype.scm 53 */
				  closure_bglt aux_1352;
				  aux_1352 =
				     (closure_bglt) (node_1);
				  aux_1351 =
				     (obj_t) (aux_1352);
			       }
			       arg1608_1074 =
				  shape_tools_shape(aux_1351);
			    }
			    return
			       internal_error_43_tools_error(string1657_ast_lvtype, string1658_ast_lvtype, arg1608_1074);
			 }
			 break;
		      case ((long) 4):

			 {	/* Ast/lvtype.scm 59 */
			    sequence_bglt node_1075;
			    node_1075 =
			       (sequence_bglt) (node_1);
			    {	/* Ast/lvtype.scm 60 */
			       bool_t aux_1358;
			       aux_1358 =
				  lvtype_node___164_ast_lvtype(
				  (((sequence_bglt) CREF(node_1075))->nodes));
			       return
				  BBOOL(aux_1358);
			    }
			 }
			 break;
		      case ((long) 5):

			 {	/* Ast/lvtype.scm 66 */
			    app_bglt node_1078;
			    node_1078 =
			       (app_bglt) (node_1);
			    {	/* Ast/lvtype.scm 67 */
			       bool_t aux_1363;
			       aux_1363 =
				  lvtype_node___164_ast_lvtype(
				  (((app_bglt) CREF(node_1078))->args));
			       return
				  BBOOL(aux_1363);
			    }
			 }
			 break;
		      case ((long) 6):

			 {	/* Ast/lvtype.scm 73 */
			    app_ly_162_bglt node_1081;
			    node_1081 =
			       (app_ly_162_bglt) (node_1);
			    lvtype_node__58_ast_lvtype(
			       (((app_ly_162_bglt) CREF(node_1081))->fun));
			    {
			       node_bglt node_1370;
			       node_1370 =
				  (((app_ly_162_bglt) CREF(node_1081))->arg);
			       node_1 = node_1370;
			       goto lvtype_node__58_ast_lvtype;
			    }
			 }
			 break;
		      case ((long) 7):

			 {	/* Ast/lvtype.scm 81 */
			    funcall_bglt node_1085;
			    node_1085 =
			       (funcall_bglt) (node_1);
			    lvtype_node__58_ast_lvtype(
			       (((funcall_bglt) CREF(node_1085))->fun));
			    {	/* Ast/lvtype.scm 83 */
			       bool_t aux_1375;
			       aux_1375 =
				  lvtype_node___164_ast_lvtype(
				  (((funcall_bglt) CREF(node_1085))->args));
			       return
				  BBOOL(aux_1375);
			    }
			 }
			 break;
		      case ((long) 8):

			 {	/* Ast/lvtype.scm 89 */
			    pragma_bglt node_1089;
			    node_1089 =
			       (pragma_bglt) (node_1);
			    {	/* Ast/lvtype.scm 90 */
			       bool_t aux_1380;
			       aux_1380 =
				  lvtype_node___164_ast_lvtype(
				  (((pragma_bglt) CREF(node_1089))->args));
			       return
				  BBOOL(aux_1380);
			    }
			 }
			 break;
		      case ((long) 9):

			 {	/* Ast/lvtype.scm 96 */
			    cast_bglt node_1092;
			    node_1092 =
			       (cast_bglt) (node_1);
			    {
			       node_bglt node_1385;
			       node_1385 =
				  (((cast_bglt) CREF(node_1092))->arg);
			       node_1 = node_1385;
			       goto lvtype_node__58_ast_lvtype;
			    }
			 }
			 break;
		      case ((long) 10):

			 {	/* Ast/lvtype.scm 103 */
			    setq_bglt node_1095;
			    node_1095 =
			       (setq_bglt) (node_1);
			    lvtype_node__58_ast_lvtype(
			       (((setq_bglt) CREF(node_1095))->value));
			    {
			       node_bglt node_1390;
			       {	/* Ast/lvtype.scm 105 */
				  var_bglt aux_1391;
				  aux_1391 =
				     (((setq_bglt) CREF(node_1095))->var);
				  node_1390 =
				     (node_bglt) (aux_1391);
			       }
			       node_1 = node_1390;
			       goto lvtype_node__58_ast_lvtype;
			    }
			 }
			 break;
		      case ((long) 11):

			 {	/* Ast/lvtype.scm 111 */
			    conditional_bglt node_1099;
			    node_1099 =
			       (conditional_bglt) (node_1);
			    lvtype_node__58_ast_lvtype(
			       (((conditional_bglt) CREF(node_1099))->test));
			    lvtype_node__58_ast_lvtype(
			       (((conditional_bglt) CREF(node_1099))->true));
			    {
			       node_bglt node_1399;
			       node_1399 =
				  (((conditional_bglt) CREF(node_1099))->false);
			       node_1 = node_1399;
			       goto lvtype_node__58_ast_lvtype;
			    }
			 }
			 break;
		      case ((long) 12):

			 {	/* Ast/lvtype.scm 120 */
			    fail_bglt node_1104;
			    node_1104 =
			       (fail_bglt) (node_1);
			    lvtype_node__58_ast_lvtype(
			       (((fail_bglt) CREF(node_1104))->proc));
			    lvtype_node__58_ast_lvtype(
			       (((fail_bglt) CREF(node_1104))->msg));
			    {
			       node_bglt node_1406;
			       node_1406 =
				  (((fail_bglt) CREF(node_1104))->obj);
			       node_1 = node_1406;
			       goto lvtype_node__58_ast_lvtype;
			    }
			 }
			 break;
		      case ((long) 13):

			 {	/* Ast/lvtype.scm 129 */
			    select_bglt node_1109;
			    node_1109 =
			       (select_bglt) (node_1);
			    lvtype_node__58_ast_lvtype(
			       (((select_bglt) CREF(node_1109))->test));
			    {
			       obj_t l1447_1112;
			       {	/* Ast/lvtype.scm 131 */
				  bool_t aux_1411;
				  l1447_1112 =
				     (((select_bglt) CREF(node_1109))->clauses);
				lname1448_1113:
				  if (
				     PAIRP(l1447_1112))
				    {	/* Ast/lvtype.scm 131 */
				       {	/* Ast/lvtype.scm 132 */
					  node_bglt aux_1414;
					  {	/* Ast/lvtype.scm 132 */
					     obj_t aux_1415;
					     {	/* ./Ieee/pair-list.scm 5707 */
						obj_t aux_1416;
						aux_1416 =
						   CAR(l1447_1112);
						aux_1415 =
						   CDR(aux_1416);
					     }
					     aux_1414 =
						(node_bglt) (aux_1415);
					  }
					  lvtype_node__58_ast_lvtype(aux_1414);
				       }
				       {
					  obj_t l1447_1421;
					  l1447_1421 =
					     CDR(l1447_1112);
					  l1447_1112 = l1447_1421;
					  goto lname1448_1113;
				       }
				    }
				  else
				    {	/* Ast/lvtype.scm 131 */
				       aux_1411 = ((bool_t) 1);
				    }
				  return
				     BBOOL(aux_1411);
			       }
			    }
			 }
			 break;
		      case ((long) 14):

			 {	/* Ast/lvtype.scm 139 */
			    let_fun_218_bglt node_1119;
			    node_1119 =
			       (let_fun_218_bglt) (node_1);
			    {
			       obj_t l1450_1121;
			       l1450_1121 =
				  (((let_fun_218_bglt) CREF(node_1119))->locals);
			     lname1451_1122:
			       if (
				  PAIRP(l1450_1121))
				 {	/* Ast/lvtype.scm 140 */
				    {	/* Ast/lvtype.scm 141 */
				       node_bglt aux_1428;
				       {	/* Ast/lvtype.scm 141 */
					  obj_t aux_1429;
					  {	/* Ast/lvtype.scm 141 */
					     sfun_bglt obj_1231;
					     {	/* Ast/lvtype.scm 141 */
						value_bglt aux_1430;
						{	/* Ast/lvtype.scm 141 */
						   local_bglt obj_1230;
						   {	/* Ast/lvtype.scm 141 */
						      obj_t aux_1431;
						      aux_1431 =
							 CAR(l1450_1121);
						      obj_1230 =
							 (local_bglt) (aux_1431);
						   }
						   aux_1430 =
						      (((local_bglt) CREF(obj_1230))->value);
						}
						obj_1231 =
						   (sfun_bglt) (aux_1430);
					     }
					     aux_1429 =
						(((sfun_bglt) CREF(obj_1231))->body);
					  }
					  aux_1428 =
					     (node_bglt) (aux_1429);
				       }
				       lvtype_node__58_ast_lvtype(aux_1428);
				    }
				    {
				       obj_t l1450_1439;
				       l1450_1439 =
					  CDR(l1450_1121);
				       l1450_1121 = l1450_1439;
				       goto lname1451_1122;
				    }
				 }
			       else
				 {	/* Ast/lvtype.scm 140 */
				    ((bool_t) 1);
				 }
			    }
			    {
			       node_bglt node_1442;
			       node_1442 =
				  (((let_fun_218_bglt) CREF(node_1119))->body);
			       node_1 = node_1442;
			       goto lvtype_node__58_ast_lvtype;
			    }
			 }
			 break;
		      case ((long) 15):

			 {	/* Ast/lvtype.scm 149 */
			    let_var_6_bglt node_1130;
			    node_1130 =
			       (let_var_6_bglt) (node_1);
			    {
			       obj_t l1453_1132;
			       l1453_1132 =
				  (((let_var_6_bglt) CREF(node_1130))->bindings);
			     lname1454_1133:
			       if (
				  PAIRP(l1453_1132))
				 {	/* Ast/lvtype.scm 150 */
				    {	/* Ast/lvtype.scm 151 */
				       obj_t binding_1136;
				       binding_1136 =
					  CAR(l1453_1132);
				       {	/* Ast/lvtype.scm 151 */
					  obj_t var_1137;
					  obj_t val_1138;
					  var_1137 =
					     CAR(binding_1136);
					  val_1138 =
					     CDR(binding_1136);
					  lvtype_node__58_ast_lvtype(
					     (node_bglt) (val_1138));
					  {	/* Ast/lvtype.scm 154 */
					     type_bglt arg1638_1139;
					     arg1638_1139 =
						typeof_coerce_typeof(
						(node_bglt) (val_1138));
					     set_variable_type__9_ast_lvtype(
						(variable_bglt) (var_1137), arg1638_1139);
					  }
				       }
				    }
				    {
				       obj_t l1453_1456;
				       l1453_1456 =
					  CDR(l1453_1132);
				       l1453_1132 = l1453_1456;
				       goto lname1454_1133;
				    }
				 }
			       else
				 {	/* Ast/lvtype.scm 150 */
				    ((bool_t) 1);
				 }
			    }
			    {
			       node_bglt node_1459;
			       node_1459 =
				  (((let_var_6_bglt) CREF(node_1130))->body);
			       node_1 = node_1459;
			       goto lvtype_node__58_ast_lvtype;
			    }
			 }
			 break;
		      case ((long) 16):

			 {	/* Ast/lvtype.scm 162 */
			    set_ex_it_116_bglt node_1142;
			    node_1142 =
			       (set_ex_it_116_bglt) (node_1);
			    lvtype_node__58_ast_lvtype(
			       (((set_ex_it_116_bglt) CREF(node_1142))->body));
			    {
			       node_bglt node_1464;
			       {	/* Ast/lvtype.scm 164 */
				  var_bglt aux_1465;
				  aux_1465 =
				     (((set_ex_it_116_bglt) CREF(node_1142))->var);
				  node_1464 =
				     (node_bglt) (aux_1465);
			       }
			       node_1 = node_1464;
			       goto lvtype_node__58_ast_lvtype;
			    }
			 }
			 break;
		      case ((long) 17):

			 {	/* Ast/lvtype.scm 170 */
			    jump_ex_it_184_bglt node_1146;
			    node_1146 =
			       (jump_ex_it_184_bglt) (node_1);
			    lvtype_node__58_ast_lvtype(
			       (((jump_ex_it_184_bglt) CREF(node_1146))->exit));
			    {
			       node_bglt node_1471;
			       node_1471 =
				  (((jump_ex_it_184_bglt) CREF(node_1146))->value);
			       node_1 = node_1471;
			       goto lvtype_node__58_ast_lvtype;
			    }
			 }
			 break;
		      case ((long) 18):

			 {	/* Ast/lvtype.scm 178 */
			    make_box_202_bglt node_1150;
			    node_1150 =
			       (make_box_202_bglt) (node_1);
			    {
			       node_bglt node_1474;
			       node_1474 =
				  (((make_box_202_bglt) CREF(node_1150))->value);
			       node_1 = node_1474;
			       goto lvtype_node__58_ast_lvtype;
			    }
			 }
			 break;
		      case ((long) 19):

			 {	/* Ast/lvtype.scm 185 */
			    box_set__221_bglt node_1153;
			    node_1153 =
			       (box_set__221_bglt) (node_1);
			    {	/* Ast/lvtype.scm 186 */
			       node_bglt aux_1477;
			       {	/* Ast/lvtype.scm 186 */
				  var_bglt aux_1478;
				  aux_1478 =
				     (((box_set__221_bglt) CREF(node_1153))->var);
				  aux_1477 =
				     (node_bglt) (aux_1478);
			       }
			       lvtype_node__58_ast_lvtype(aux_1477);
			    }
			    {
			       node_bglt node_1482;
			       node_1482 =
				  (((box_set__221_bglt) CREF(node_1153))->value);
			       node_1 = node_1482;
			       goto lvtype_node__58_ast_lvtype;
			    }
			 }
			 break;
		      case ((long) 20):

			 {	/* Ast/lvtype.scm 193 */
			    box_ref_242_bglt node_1157;
			    node_1157 =
			       (box_ref_242_bglt) (node_1);
			    {
			       node_bglt node_1485;
			       {	/* Ast/lvtype.scm 194 */
				  var_bglt aux_1486;
				  aux_1486 =
				     (((box_ref_242_bglt) CREF(node_1157))->var);
				  node_1485 =
				     (node_bglt) (aux_1486);
			       }
			       node_1 = node_1485;
			       goto lvtype_node__58_ast_lvtype;
			    }
			 }
			 break;
		      default:
		       case_else1600_1065:
			 if (
			    PROCEDUREP(method1594_1061))
			   {	/* Ast/lvtype.scm 29 */
			      return
				 PROCEDURE_ENTRY(method1594_1061) (method1594_1061,
				 (obj_t) (node_1), BEOA);
			   }
			 else
			   {	/* Ast/lvtype.scm 29 */
			      obj_t fun1593_1057;
			      fun1593_1057 =
				 PROCEDURE_REF(lvtype_node__env_81_ast_lvtype, ((long) 0));
			      return
				 PROCEDURE_ENTRY(fun1593_1057) (fun1593_1057,
				 (obj_t) (node_1), BEOA);
			   }
		      }
		 }
	       else
		 {	/* Ast/lvtype.scm 29 */
		    goto case_else1600_1065;
		 }
	    }
	 }
      }
   }
}



/* _lvtype-node!1656 */
obj_t 
_lvtype_node_1656_242_ast_lvtype(obj_t env_1254, obj_t node_1255)
{
   AN_OBJECT;
   {	/* Ast/lvtype.scm 29 */
      return
	 lvtype_node__58_ast_lvtype(
	 (node_bglt) (node_1255));
   }
}



/* lvtype-node!-default1463 */
obj_t 
lvtype_node__default1463_35_ast_lvtype(node_bglt node_2)
{
   AN_OBJECT;
   {	/* Ast/lvtype.scm 16 */
      FAILURE(
	 CNST_TABLE_REF(((long) 0)), string1659_ast_lvtype,
	 (obj_t) (node_2));
   }
}



/* _lvtype-node!-default1463 */
obj_t 
_lvtype_node__default1463_42_ast_lvtype(obj_t env_1256, obj_t node_1257)
{
   AN_OBJECT;
   {	/* Ast/lvtype.scm 16 */
      return
	 lvtype_node__default1463_35_ast_lvtype(
	 (node_bglt) (node_1257));
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_ast_lvtype()
{
   AN_OBJECT;
   {	/* Ast/lvtype.scm 16 */
      module_initialization_70_type_type(((long) 0), "AST_LVTYPE");
      module_initialization_70_type_cache(((long) 0), "AST_LVTYPE");
      module_initialization_70_tools_shape(((long) 0), "AST_LVTYPE");
      module_initialization_70_tools_error(((long) 0), "AST_LVTYPE");
      module_initialization_70_coerce_typeof(((long) 0), "AST_LVTYPE");
      module_initialization_70_ast_var(((long) 0), "AST_LVTYPE");
      return
	 module_initialization_70_ast_node(((long) 0), "AST_LVTYPE");
   }
}
