/*===========================================================================*/
/*   (Ast/occur.scm)                                                         */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;


static obj_t method_init_76_ast_occur();
extern obj_t make_box_202_ast_node;
extern obj_t funcall_ast_node;
extern long add_inlined_method__244___object(obj_t, obj_t, long);
extern obj_t fail_ast_node;
extern obj_t box_ref_242_ast_node;
extern obj_t sequence_ast_node;
extern obj_t let_var_6_ast_node;
extern obj_t var_ast_node;
extern obj_t pragma_ast_node;
extern obj_t set_ex_it_116_ast_node;
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t module_initialization_70_ast_occur(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_ast_sexp(long, char *);
extern obj_t module_initialization_70_ast_env(long, char *);
extern obj_t module_initialization_70_ast_local(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
static obj_t _anonymous_1503__0_ast_occur(obj_t, obj_t);
static obj_t _occur_node_in__96_ast_occur(obj_t, obj_t, obj_t);
extern obj_t scnst_ast_var;
extern obj_t node_ast_node;
extern obj_t let_fun_218_ast_node;
static obj_t imported_modules_init_94_ast_occur();
extern obj_t app_ly_162_ast_node;
extern obj_t add_generic__110___object(obj_t, obj_t);
static obj_t _global__68_ast_occur = BUNSPEC;
extern obj_t app_ast_node;
static obj_t _occur_node__default1464_6_ast_occur(obj_t, obj_t);
static obj_t library_modules_init_112_ast_occur();
extern obj_t occur_var_108_ast_occur(obj_t);
extern obj_t occur_node_in__115_ast_occur(node_bglt, global_bglt);
extern obj_t cast_ast_node;
static obj_t toplevel_init_63_ast_occur();
extern obj_t jump_ex_it_184_ast_node;
extern obj_t open_input_string(obj_t);
extern obj_t setq_ast_node;
static obj_t _occur_node__166_ast_occur(obj_t, obj_t);
extern obj_t box_set__221_ast_node;
static bool_t occur_node___69_ast_occur(obj_t);
extern obj_t for_each_global__88_ast_env(obj_t);
static obj_t occur_node__249_ast_occur(node_bglt);
extern obj_t _classes__134___object;
extern obj_t select_ast_node;
extern obj_t read___reader(obj_t);
static obj_t _occur_var_46_ast_occur(obj_t, obj_t);
static obj_t require_initialization_114_ast_occur = BUNSPEC;
extern obj_t conditional_ast_node;
static obj_t occur_node__default1464_210_ast_occur(node_bglt);
static obj_t cnst_init_137_ast_occur();
static obj_t __cnst[1];

DEFINE_EXPORT_PROCEDURE(occur_node_in__env_172_ast_occur, _occur_node_in__96_ast_occur1679, _occur_node_in__96_ast_occur, 0L, 2);
DEFINE_STATIC_PROCEDURE(occur_node__default1464_env_38_ast_occur, _occur_node__default1464_6_ast_occur1680, _occur_node__default1464_6_ast_occur, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc1673_ast_occur, _anonymous_1503__0_ast_occur1681, _anonymous_1503__0_ast_occur, 0L, 1);
DEFINE_STATIC_GENERIC(occur_node__env_215_ast_occur, _occur_node__166_ast_occur1682, _occur_node__166_ast_occur, 0L, 1);
DEFINE_EXPORT_PROCEDURE(occur_var_env_26_ast_occur, _occur_var_46_ast_occur1683, _occur_var_46_ast_occur, 0L, 1);
DEFINE_STRING(string1674_ast_occur, string1674_ast_occur1684, "DONE ", 5);



/* module-initialization */
obj_t 
module_initialization_70_ast_occur(long checksum_1328, char *from_1329)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_ast_occur))
	{
	   require_initialization_114_ast_occur =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_ast_occur();
	   cnst_init_137_ast_occur();
	   imported_modules_init_94_ast_occur();
	   method_init_76_ast_occur();
	   toplevel_init_63_ast_occur();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_ast_occur()
{
   AN_OBJECT;
   {	/* Ast/occur.scm 14 */
      module_initialization_70___object(((long) 0), "AST_OCCUR");
      module_initialization_70___reader(((long) 0), "AST_OCCUR");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_ast_occur()
{
   AN_OBJECT;
   {	/* Ast/occur.scm 14 */
      {		/* Ast/occur.scm 14 */
	 obj_t cnst_port_138_1321;
	 cnst_port_138_1321 =
	    open_input_string(string1674_ast_occur);
	 {
	    long i_1322;
	    i_1322 = ((long) 0);
	  loop_1323:
	    {	/* Ast/occur.scm 14 */
	       bool_t test1675_1324;
	       test1675_1324 =
		  (i_1322 == ((long) -1));
	       if (test1675_1324)
		 {	/* Ast/occur.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Ast/occur.scm 14 */
		    {	/* Ast/occur.scm 14 */
		       obj_t arg1676_1325;
		       {	/* Ast/occur.scm 14 */
			  obj_t list1677_1326;
			  list1677_1326 =
			     MAKE_PAIR(cnst_port_138_1321, BNIL);
			  arg1676_1325 =
			     read___reader(list1677_1326);
		       }
		       CNST_TABLE_SET(i_1322, arg1676_1325);
		    }
		    {	/* Ast/occur.scm 14 */
		       int aux_1327;
		       {	/* Ast/occur.scm 14 */
			  long aux_1346;
			  aux_1346 =
			     (i_1322 - ((long) 1));
			  aux_1327 =
			     (int) (aux_1346);
		       }
		       {
			  long i_1349;
			  i_1349 =
			     (long) (aux_1327);
			  i_1322 = i_1349;
			  goto loop_1323;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_ast_occur()
{
   AN_OBJECT;
   {	/* Ast/occur.scm 14 */
      _global__68_ast_occur = BUNSPEC;
      return BUNSPEC;
   }
}



/* occur-var */
obj_t 
occur_var_108_ast_occur(obj_t globals_1)
{
   AN_OBJECT;
   {	/* Ast/occur.scm 27 */
      {		/* Ast/occur.scm 29 */
	 obj_t _anonymous_1503__0_1309;
	 _anonymous_1503__0_1309 = proc1673_ast_occur;
	 for_each_global__88_ast_env(_anonymous_1503__0_1309);
      }
      {
	 obj_t l1437_724;
	 {	/* Ast/occur.scm 31 */
	    bool_t aux_1352;
	    l1437_724 = globals_1;
	  lname1438_725:
	    if (
	       PAIRP(l1437_724))
	      {		/* Ast/occur.scm 31 */
		 {	/* Ast/occur.scm 32 */
		    obj_t global_727;
		    global_727 =
		       CAR(l1437_724);
		    {	/* Ast/occur.scm 39 */
		       global_bglt aux_1356;
		       aux_1356 =
			  (global_bglt) (global_727);
		       _global__68_ast_occur =
			  (obj_t) (aux_1356);
		    }
		    {	/* Ast/occur.scm 40 */
		       node_bglt aux_1359;
		       {	/* Ast/occur.scm 32 */
			  obj_t aux_1360;
			  {	/* Ast/occur.scm 32 */
			     sfun_bglt obj_1195;
			     {	/* Ast/occur.scm 32 */
				value_bglt aux_1361;
				{	/* Ast/occur.scm 32 */
				   global_bglt obj_1194;
				   obj_1194 =
				      (global_bglt) (global_727);
				   aux_1361 =
				      (((global_bglt) CREF(obj_1194))->value);
				}
				obj_1195 =
				   (sfun_bglt) (aux_1361);
			     }
			     aux_1360 =
				(((sfun_bglt) CREF(obj_1195))->body);
			  }
			  aux_1359 =
			     (node_bglt) (aux_1360);
		       }
		       occur_node__249_ast_occur(aux_1359);
		    }
		 }
		 {
		    obj_t l1437_1368;
		    l1437_1368 =
		       CDR(l1437_724);
		    l1437_724 = l1437_1368;
		    goto lname1438_725;
		 }
	      }
	    else
	      {		/* Ast/occur.scm 31 */
		 aux_1352 = ((bool_t) 1);
	      }
	    return
	       BBOOL(aux_1352);
	 }
      }
   }
}



/* _occur-var */
obj_t 
_occur_var_46_ast_occur(obj_t env_1310, obj_t globals_1311)
{
   AN_OBJECT;
   {	/* Ast/occur.scm 27 */
      return
	 occur_var_108_ast_occur(globals_1311);
   }
}



/* <anonymous:1503> */
obj_t 
_anonymous_1503__0_ast_occur(obj_t env_1312, obj_t global_1313)
{
   AN_OBJECT;
   {	/* Ast/occur.scm 29 */
      {
	 obj_t global_721;
	 global_721 = global_1313;
	 {	/* Ast/occur.scm 29 */
	    global_bglt obj_1190;
	    obj_1190 =
	       (global_bglt) (global_721);
	    return
	       ((((global_bglt) CREF(obj_1190))->occurrence) = ((long) ((long) 0)), BUNSPEC);
	 }
      }
   }
}



/* occur-node-in! */
obj_t 
occur_node_in__115_ast_occur(node_bglt node_2, global_bglt global_3)
{
   AN_OBJECT;
   {	/* Ast/occur.scm 38 */
      _global__68_ast_occur =
	 (obj_t) (global_3);
      return
	 occur_node__249_ast_occur(node_2);
   }
}



/* _occur-node-in! */
obj_t 
_occur_node_in__96_ast_occur(obj_t env_1314, obj_t node_1315, obj_t global_1316)
{
   AN_OBJECT;
   {	/* Ast/occur.scm 38 */
      return
	 occur_node_in__115_ast_occur(
	 (node_bglt) (node_1315),
	 (global_bglt) (global_1316));
   }
}



/* occur-node*! */
bool_t 
occur_node___69_ast_occur(obj_t node__221_24)
{
   AN_OBJECT;
   {	/* Ast/occur.scm 209 */
      {
	 obj_t l1461_731;
	 l1461_731 = node__221_24;
       lname1462_732:
	 if (
	    PAIRP(l1461_731))
	   {	/* Ast/occur.scm 210 */
	      {		/* Ast/occur.scm 210 */
		 node_bglt aux_1381;
		 {	/* Ast/occur.scm 210 */
		    obj_t aux_1382;
		    aux_1382 =
		       CAR(l1461_731);
		    aux_1381 =
		       (node_bglt) (aux_1382);
		 }
		 occur_node__249_ast_occur(aux_1381);
	      }
	      {
		 obj_t l1461_1386;
		 l1461_1386 =
		    CDR(l1461_731);
		 l1461_731 = l1461_1386;
		 goto lname1462_732;
	      }
	   }
	 else
	   {	/* Ast/occur.scm 210 */
	      return ((bool_t) 1);
	   }
      }
   }
}



/* method-init */
obj_t 
method_init_76_ast_occur()
{
   AN_OBJECT;
   {	/* Ast/occur.scm 14 */
      add_generic__110___object(occur_node__env_215_ast_occur, occur_node__default1464_env_38_ast_occur);
      add_inlined_method__244___object(occur_node__env_215_ast_occur, var_ast_node, ((long) 0));
      add_inlined_method__244___object(occur_node__env_215_ast_occur, sequence_ast_node, ((long) 1));
      add_inlined_method__244___object(occur_node__env_215_ast_occur, app_ast_node, ((long) 2));
      add_inlined_method__244___object(occur_node__env_215_ast_occur, app_ly_162_ast_node, ((long) 3));
      add_inlined_method__244___object(occur_node__env_215_ast_occur, funcall_ast_node, ((long) 4));
      add_inlined_method__244___object(occur_node__env_215_ast_occur, pragma_ast_node, ((long) 5));
      add_inlined_method__244___object(occur_node__env_215_ast_occur, cast_ast_node, ((long) 6));
      add_inlined_method__244___object(occur_node__env_215_ast_occur, setq_ast_node, ((long) 7));
      add_inlined_method__244___object(occur_node__env_215_ast_occur, conditional_ast_node, ((long) 8));
      add_inlined_method__244___object(occur_node__env_215_ast_occur, fail_ast_node, ((long) 9));
      add_inlined_method__244___object(occur_node__env_215_ast_occur, select_ast_node, ((long) 10));
      add_inlined_method__244___object(occur_node__env_215_ast_occur, let_fun_218_ast_node, ((long) 11));
      add_inlined_method__244___object(occur_node__env_215_ast_occur, let_var_6_ast_node, ((long) 12));
      add_inlined_method__244___object(occur_node__env_215_ast_occur, set_ex_it_116_ast_node, ((long) 13));
      add_inlined_method__244___object(occur_node__env_215_ast_occur, jump_ex_it_184_ast_node, ((long) 14));
      add_inlined_method__244___object(occur_node__env_215_ast_occur, make_box_202_ast_node, ((long) 15));
      add_inlined_method__244___object(occur_node__env_215_ast_occur, box_ref_242_ast_node, ((long) 16));
      {		/* Ast/occur.scm 14 */
	 long aux_1406;
	 aux_1406 =
	    add_inlined_method__244___object(occur_node__env_215_ast_occur, box_set__221_ast_node, ((long) 17));
	 return
	    BINT(aux_1406);
      }
   }
}



/* occur-node! */
obj_t 
occur_node__249_ast_occur(node_bglt node_4)
{
   AN_OBJECT;
   {	/* Ast/occur.scm 50 */
    occur_node__249_ast_occur:
      {
	 obj_t method1594_1066;
	 obj_t class1599_1067;
	 {	/* Ast/occur.scm 50 */
	    obj_t arg1602_1064;
	    obj_t arg1603_1065;
	    {	/* Ast/occur.scm 50 */
	       object_bglt obj_1202;
	       obj_1202 =
		  (object_bglt) (node_4);
	       {	/* ./Llib/object.scm 2926 */
		  obj_t pre_method_105_1203;
		  pre_method_105_1203 =
		     PROCEDURE_REF(occur_node__env_215_ast_occur, ((long) 2));
		  if (
		     INTEGERP(pre_method_105_1203))
		    {	/* ./Llib/object.scm 2927 */
		       PROCEDURE_SET(occur_node__env_215_ast_occur, ((long) 2), BUNSPEC);
		       arg1602_1064 = pre_method_105_1203;
		    }
		  else
		    {	/* ./Llib/object.scm 2914 */
		       long obj_class_num_177_1208;
		       obj_class_num_177_1208 =
			  TYPE(obj_1202);
		       {	/* ./Llib/object.scm 2915 */
			  obj_t arg1176_1209;
			  arg1176_1209 =
			     PROCEDURE_REF(occur_node__env_215_ast_occur, ((long) 1));
			  {	/* ./Llib/object.scm 2738 */
			     long arg1177_1213;
			     {	/* ./Llib/object.scm 2738 */
				long arg1178_1214;
				arg1178_1214 =
				   OBJECT_TYPE;
				arg1177_1213 =
				   (obj_class_num_177_1208 - arg1178_1214);
			     }
			     arg1602_1064 =
				VECTOR_REF(arg1176_1209, arg1177_1213);
			  }
		       }
		    }
	       }
	    }
	    {	/* Ast/occur.scm 50 */
	       object_bglt object_1219;
	       object_1219 =
		  (object_bglt) (node_4);
	       {	/* ./Llib/object.scm 2695 */
		  long arg1179_1220;
		  {	/* ./Llib/object.scm 2695 */
		     long arg1180_1221;
		     long arg1181_1222;
		     arg1180_1221 =
			TYPE(object_1219);
		     arg1181_1222 =
			OBJECT_TYPE;
		     arg1179_1220 =
			(arg1180_1221 - arg1181_1222);
		  }
		  {	/* ./Llib/object.scm 2695 */
		     obj_t vector_1226;
		     vector_1226 = _classes__134___object;
		     arg1603_1065 =
			VECTOR_REF(vector_1226, arg1179_1220);
		  }
	       }
	    }
	    method1594_1066 = arg1602_1064;
	    class1599_1067 = arg1603_1065;
	    {

	       if (
		  INTEGERP(method1594_1066))
		 {	/* Ast/occur.scm 50 */
		    switch (
		       (long) CINT(method1594_1066))
		      {
		      case ((long) 0):

			 {	/* Ast/occur.scm 57 */
			    var_bglt node_1073;
			    node_1073 =
			       (var_bglt) (node_4);
			    {	/* Ast/occur.scm 57 */
			       variable_bglt v_1074;
			       v_1074 =
				  (((var_bglt) CREF(node_1073))->variable);
			       {	/* Ast/occur.scm 58 */
				  value_bglt value_1075;
				  value_1075 =
				     (((variable_bglt) CREF(v_1074))->value);
				  {	/* Ast/occur.scm 59 */
				     bool_t test1606_1076;
				     {	/* Ast/occur.scm 59 */
					bool_t test1608_1078;
					test1608_1078 =
					   is_a__118___object(
					   (obj_t) (value_1075), scnst_ast_var);
					if (test1608_1078)
					  {	/* ./Ast/node.scm 673 */
					     obj_t aux_1432;
					     {	/* Ast/occur.scm 59 */
						scnst_bglt obj_1231;
						obj_1231 =
						   (scnst_bglt) (value_1075);
						aux_1432 =
						   (((scnst_bglt) CREF(obj_1231))->node);
					     }
					     test1606_1076 =
						is_a__118___object(aux_1432, node_ast_node);
					  }
					else
					  {	/* Ast/occur.scm 59 */
					     test1606_1076 = ((bool_t) 0);
					  }
				     }
				     if (test1606_1076)
				       {	/* Ast/occur.scm 60 */
					  node_bglt aux_1437;
					  {	/* Ast/occur.scm 60 */
					     obj_t aux_1438;
					     {	/* Ast/occur.scm 60 */
						scnst_bglt obj_1233;
						obj_1233 =
						   (scnst_bglt) (value_1075);
						aux_1438 =
						   (((scnst_bglt) CREF(obj_1233))->node);
					     }
					     aux_1437 =
						(node_bglt) (aux_1438);
					  }
					  occur_node__249_ast_occur(aux_1437);
				       }
				     else
				       {	/* Ast/occur.scm 59 */
					  BUNSPEC;
				       }
				  }
			       }
			       {	/* Ast/occur.scm 61 */
				  bool_t test1610_1080;
				  {	/* Ast/occur.scm 61 */
				     obj_t obj2_1235;
				     obj2_1235 = _global__68_ast_occur;
				     {	/* ./Ieee/equiv.scm 5508 */
					obj_t aux_1443;
					aux_1443 =
					   (obj_t) (v_1074);
					test1610_1080 =
					   (aux_1443 == obj2_1235);
				     }
				  }
				  if (test1610_1080)
				    {	/* Ast/occur.scm 61 */
				       return BUNSPEC;
				    }
				  else
				    {	/* Ast/occur.scm 62 */
				       long arg1611_1081;
				       {	/* ./Ieee/fixnum.scm 7193 */
					  long aux_1447;
					  aux_1447 =
					     (((variable_bglt) CREF(v_1074))->occurrence);
					  arg1611_1081 =
					     (aux_1447 + ((long) 1));
				       }
				       return
					  ((((variable_bglt) CREF(v_1074))->occurrence) = ((long) arg1611_1081), BUNSPEC);
				    }
			       }
			    }
			 }
			 break;
		      case ((long) 1):

			 {	/* Ast/occur.scm 68 */
			    sequence_bglt node_1084;
			    node_1084 =
			       (sequence_bglt) (node_4);
			    {	/* Ast/occur.scm 68 */
			       bool_t aux_1452;
			       aux_1452 =
				  occur_node___69_ast_occur(
				  (((sequence_bglt) CREF(node_1084))->nodes));
			       return
				  BBOOL(aux_1452);
			    }
			 }
			 break;
		      case ((long) 2):

			 {	/* Ast/occur.scm 74 */
			    app_bglt node_1086;
			    node_1086 =
			       (app_bglt) (node_4);
			    {	/* Ast/occur.scm 75 */
			       node_bglt aux_1457;
			       {	/* Ast/occur.scm 75 */
				  var_bglt aux_1458;
				  aux_1458 =
				     (((app_bglt) CREF(node_1086))->fun);
				  aux_1457 =
				     (node_bglt) (aux_1458);
			       }
			       occur_node__249_ast_occur(aux_1457);
			    }
			    {	/* Ast/occur.scm 76 */
			       bool_t aux_1462;
			       aux_1462 =
				  occur_node___69_ast_occur(
				  (((app_bglt) CREF(node_1086))->args));
			       return
				  BBOOL(aux_1462);
			    }
			 }
			 break;
		      case ((long) 3):

			 {	/* Ast/occur.scm 82 */
			    app_ly_162_bglt node_1090;
			    node_1090 =
			       (app_ly_162_bglt) (node_4);
			    occur_node__249_ast_occur(
			       (((app_ly_162_bglt) CREF(node_1090))->fun));
			    {
			       node_bglt node_1469;
			       node_1469 =
				  (((app_ly_162_bglt) CREF(node_1090))->arg);
			       node_4 = node_1469;
			       goto occur_node__249_ast_occur;
			    }
			 }
			 break;
		      case ((long) 4):

			 {	/* Ast/occur.scm 90 */
			    funcall_bglt node_1094;
			    node_1094 =
			       (funcall_bglt) (node_4);
			    occur_node__249_ast_occur(
			       (((funcall_bglt) CREF(node_1094))->fun));
			    {	/* Ast/occur.scm 92 */
			       bool_t aux_1474;
			       aux_1474 =
				  occur_node___69_ast_occur(
				  (((funcall_bglt) CREF(node_1094))->args));
			       return
				  BBOOL(aux_1474);
			    }
			 }
			 break;
		      case ((long) 5):

			 {	/* Ast/occur.scm 98 */
			    pragma_bglt node_1098;
			    node_1098 =
			       (pragma_bglt) (node_4);
			    {	/* Ast/occur.scm 98 */
			       bool_t aux_1479;
			       aux_1479 =
				  occur_node___69_ast_occur(
				  (((pragma_bglt) CREF(node_1098))->args));
			       return
				  BBOOL(aux_1479);
			    }
			 }
			 break;
		      case ((long) 6):

			 {	/* Ast/occur.scm 104 */
			    cast_bglt node_1100;
			    node_1100 =
			       (cast_bglt) (node_4);
			    {
			       node_bglt node_1484;
			       node_1484 =
				  (((cast_bglt) CREF(node_1100))->arg);
			       node_4 = node_1484;
			       goto occur_node__249_ast_occur;
			    }
			 }
			 break;
		      case ((long) 7):

			 {	/* Ast/occur.scm 110 */
			    setq_bglt node_1102;
			    node_1102 =
			       (setq_bglt) (node_4);
			    {	/* Ast/occur.scm 111 */
			       node_bglt aux_1487;
			       {	/* Ast/occur.scm 111 */
				  var_bglt aux_1488;
				  aux_1488 =
				     (((setq_bglt) CREF(node_1102))->var);
				  aux_1487 =
				     (node_bglt) (aux_1488);
			       }
			       occur_node__249_ast_occur(aux_1487);
			    }
			    {
			       node_bglt node_1492;
			       node_1492 =
				  (((setq_bglt) CREF(node_1102))->value);
			       node_4 = node_1492;
			       goto occur_node__249_ast_occur;
			    }
			 }
			 break;
		      case ((long) 8):

			 {	/* Ast/occur.scm 118 */
			    conditional_bglt node_1106;
			    node_1106 =
			       (conditional_bglt) (node_4);
			    occur_node__249_ast_occur(
			       (((conditional_bglt) CREF(node_1106))->test));
			    occur_node__249_ast_occur(
			       (((conditional_bglt) CREF(node_1106))->true));
			    {
			       node_bglt node_1499;
			       node_1499 =
				  (((conditional_bglt) CREF(node_1106))->false);
			       node_4 = node_1499;
			       goto occur_node__249_ast_occur;
			    }
			 }
			 break;
		      case ((long) 9):

			 {	/* Ast/occur.scm 127 */
			    fail_bglt node_1111;
			    node_1111 =
			       (fail_bglt) (node_4);
			    occur_node__249_ast_occur(
			       (((fail_bglt) CREF(node_1111))->proc));
			    occur_node__249_ast_occur(
			       (((fail_bglt) CREF(node_1111))->msg));
			    {
			       node_bglt node_1506;
			       node_1506 =
				  (((fail_bglt) CREF(node_1111))->obj);
			       node_4 = node_1506;
			       goto occur_node__249_ast_occur;
			    }
			 }
			 break;
		      case ((long) 10):

			 {	/* Ast/occur.scm 136 */
			    select_bglt node_1116;
			    node_1116 =
			       (select_bglt) (node_4);
			    occur_node__249_ast_occur(
			       (((select_bglt) CREF(node_1116))->test));
			    {
			       obj_t l1446_1119;
			       {	/* Ast/occur.scm 138 */
				  bool_t aux_1511;
				  l1446_1119 =
				     (((select_bglt) CREF(node_1116))->clauses);
				lname1447_1120:
				  if (
				     PAIRP(l1446_1119))
				    {	/* Ast/occur.scm 138 */
				       {	/* Ast/occur.scm 139 */
					  node_bglt aux_1514;
					  {	/* Ast/occur.scm 139 */
					     obj_t aux_1515;
					     {	/* ./Ieee/pair-list.scm 5707 */
						obj_t aux_1516;
						aux_1516 =
						   CAR(l1446_1119);
						aux_1515 =
						   CDR(aux_1516);
					     }
					     aux_1514 =
						(node_bglt) (aux_1515);
					  }
					  occur_node__249_ast_occur(aux_1514);
				       }
				       {
					  obj_t l1446_1521;
					  l1446_1521 =
					     CDR(l1446_1119);
					  l1446_1119 = l1446_1521;
					  goto lname1447_1120;
				       }
				    }
				  else
				    {	/* Ast/occur.scm 138 */
				       aux_1511 = ((bool_t) 1);
				    }
				  return
				     BBOOL(aux_1511);
			       }
			    }
			 }
			 break;
		      case ((long) 11):

			 {	/* Ast/occur.scm 146 */
			    let_fun_218_bglt node_1126;
			    node_1126 =
			       (let_fun_218_bglt) (node_4);
			    {
			       obj_t l1449_1128;
			       l1449_1128 =
				  (((let_fun_218_bglt) CREF(node_1126))->locals);
			     lname1450_1129:
			       if (
				  PAIRP(l1449_1128))
				 {	/* Ast/occur.scm 147 */
				    {	/* Ast/occur.scm 147 */
				       obj_t local_1132;
				       local_1132 =
					  CAR(l1449_1128);
				       {	/* Ast/occur.scm 148 */
					  local_bglt obj_1267;
					  obj_1267 =
					     (local_bglt) (local_1132);
					  ((((local_bglt) CREF(obj_1267))->occurrence) = ((long) ((long) 0)), BUNSPEC);
				       }
				       {
					  obj_t l1451_1133;
					  {	/* Ast/occur.scm 150 */
					     sfun_bglt obj_1270;
					     {	/* Ast/occur.scm 150 */
						value_bglt aux_1539;
						{	/* Ast/occur.scm 150 */
						   local_bglt obj_1269;
						   obj_1269 =
						      (local_bglt) (local_1132);
						   aux_1539 =
						      (((local_bglt) CREF(obj_1269))->value);
						}
						obj_1270 =
						   (sfun_bglt) (aux_1539);
					     }
					     l1451_1133 =
						(((sfun_bglt) CREF(obj_1270))->args);
					  }
					lname1452_1134:
					  if (
					     PAIRP(l1451_1133))
					    {	/* Ast/occur.scm 149 */
					       {	/* Ast/occur.scm 149 */
						  local_bglt obj_1273;
						  {	/* Ast/occur.scm 149 */
						     obj_t aux_1533;
						     aux_1533 =
							CAR(l1451_1133);
						     obj_1273 =
							(local_bglt) (aux_1533);
						  }
						  ((((local_bglt) CREF(obj_1273))->occurrence) = ((long) ((long) 1)), BUNSPEC);
					       }
					       {
						  obj_t l1451_1537;
						  l1451_1537 =
						     CDR(l1451_1133);
						  l1451_1133 = l1451_1537;
						  goto lname1452_1134;
					       }
					    }
					  else
					    {	/* Ast/occur.scm 149 */
					       ((bool_t) 1);
					    }
				       }
				    }
				    {
				       obj_t l1449_1544;
				       l1449_1544 =
					  CDR(l1449_1128);
				       l1449_1128 = l1449_1544;
				       goto lname1450_1129;
				    }
				 }
			       else
				 {	/* Ast/occur.scm 147 */
				    ((bool_t) 1);
				 }
			    }
			    {
			       obj_t l1453_1141;
			       l1453_1141 =
				  (((let_fun_218_bglt) CREF(node_1126))->locals);
			     lname1454_1142:
			       if (
				  PAIRP(l1453_1141))
				 {	/* Ast/occur.scm 152 */
				    {	/* Ast/occur.scm 153 */
				       obj_t local_1145;
				       local_1145 =
					  CAR(l1453_1141);
				       {	/* Ast/occur.scm 153 */
					  long old_1146;
					  {	/* Ast/occur.scm 153 */
					     local_bglt obj_1280;
					     obj_1280 =
						(local_bglt) (local_1145);
					     old_1146 =
						(((local_bglt) CREF(obj_1280))->occurrence);
					  }
					  {	/* Ast/occur.scm 154 */
					     node_bglt aux_1552;
					     {	/* Ast/occur.scm 154 */
						obj_t aux_1553;
						{	/* Ast/occur.scm 154 */
						   sfun_bglt obj_1282;
						   {	/* Ast/occur.scm 154 */
						      value_bglt aux_1554;
						      {		/* Ast/occur.scm 154 */
							 local_bglt obj_1281;
							 obj_1281 =
							    (local_bglt) (local_1145);
							 aux_1554 =
							    (((local_bglt) CREF(obj_1281))->value);
						      }
						      obj_1282 =
							 (sfun_bglt) (aux_1554);
						   }
						   aux_1553 =
						      (((sfun_bglt) CREF(obj_1282))->body);
						}
						aux_1552 =
						   (node_bglt) (aux_1553);
					     }
					     occur_node__249_ast_occur(aux_1552);
					  }
					  {	/* Ast/occur.scm 155 */
					     local_bglt obj_1283;
					     obj_1283 =
						(local_bglt) (local_1145);
					     ((((local_bglt) CREF(obj_1283))->occurrence) = ((long) old_1146), BUNSPEC);
					  }
				       }
				    }
				    {
				       obj_t l1453_1563;
				       l1453_1563 =
					  CDR(l1453_1141);
				       l1453_1141 = l1453_1563;
				       goto lname1454_1142;
				    }
				 }
			       else
				 {	/* Ast/occur.scm 152 */
				    ((bool_t) 1);
				 }
			    }
			    {
			       node_bglt node_1566;
			       node_1566 =
				  (((let_fun_218_bglt) CREF(node_1126))->body);
			       node_4 = node_1566;
			       goto occur_node__249_ast_occur;
			    }
			 }
			 break;
		      case ((long) 12):

			 {	/* Ast/occur.scm 163 */
			    let_var_6_bglt node_1151;
			    node_1151 =
			       (let_var_6_bglt) (node_4);
			    {
			       obj_t l1456_1153;
			       l1456_1153 =
				  (((let_var_6_bglt) CREF(node_1151))->bindings);
			     lname1457_1154:
			       if (
				  PAIRP(l1456_1153))
				 {	/* Ast/occur.scm 164 */
				    {	/* Ast/occur.scm 164 */
				       obj_t binding_1157;
				       binding_1157 =
					  CAR(l1456_1153);
				       {	/* Ast/occur.scm 165 */
					  local_bglt obj_1291;
					  {	/* Ast/occur.scm 165 */
					     obj_t aux_1572;
					     aux_1572 =
						CAR(binding_1157);
					     obj_1291 =
						(local_bglt) (aux_1572);
					  }
					  ((((local_bglt) CREF(obj_1291))->occurrence) = ((long) ((long) 0)), BUNSPEC);
				       }
				       {	/* Ast/occur.scm 166 */
					  node_bglt aux_1576;
					  {	/* Ast/occur.scm 166 */
					     obj_t aux_1577;
					     aux_1577 =
						CDR(binding_1157);
					     aux_1576 =
						(node_bglt) (aux_1577);
					  }
					  occur_node__249_ast_occur(aux_1576);
				       }
				    }
				    {
				       obj_t l1456_1581;
				       l1456_1581 =
					  CDR(l1456_1153);
				       l1456_1153 = l1456_1581;
				       goto lname1457_1154;
				    }
				 }
			       else
				 {	/* Ast/occur.scm 164 */
				    ((bool_t) 1);
				 }
			    }
			    {
			       node_bglt node_1584;
			       node_1584 =
				  (((let_var_6_bglt) CREF(node_1151))->body);
			       node_4 = node_1584;
			       goto occur_node__249_ast_occur;
			    }
			 }
			 break;
		      case ((long) 13):

			 {	/* Ast/occur.scm 174 */
			    set_ex_it_116_bglt node_1163;
			    node_1163 =
			       (set_ex_it_116_bglt) (node_4);
			    {	/* Ast/occur.scm 175 */
			       local_bglt obj_1298;
			       {	/* Ast/occur.scm 175 */
				  variable_bglt aux_1587;
				  {	/* Ast/occur.scm 175 */
				     var_bglt arg1659_1167;
				     arg1659_1167 =
					(((set_ex_it_116_bglt) CREF(node_1163))->var);
				     aux_1587 =
					(((var_bglt) CREF(arg1659_1167))->variable);
				  }
				  obj_1298 =
				     (local_bglt) (aux_1587);
			       }
			       ((((local_bglt) CREF(obj_1298))->occurrence) = ((long) ((long) 0)), BUNSPEC);
			    }
			    {
			       node_bglt node_1592;
			       node_1592 =
				  (((set_ex_it_116_bglt) CREF(node_1163))->body);
			       node_4 = node_1592;
			       goto occur_node__249_ast_occur;
			    }
			 }
			 break;
		      case ((long) 14):

			 {	/* Ast/occur.scm 182 */
			    jump_ex_it_184_bglt node_1169;
			    node_1169 =
			       (jump_ex_it_184_bglt) (node_4);
			    occur_node__249_ast_occur(
			       (((jump_ex_it_184_bglt) CREF(node_1169))->exit));
			    {
			       node_bglt node_1597;
			       node_1597 =
				  (((jump_ex_it_184_bglt) CREF(node_1169))->value);
			       node_4 = node_1597;
			       goto occur_node__249_ast_occur;
			    }
			 }
			 break;
		      case ((long) 15):

			 {	/* Ast/occur.scm 190 */
			    make_box_202_bglt node_1173;
			    node_1173 =
			       (make_box_202_bglt) (node_4);
			    {
			       node_bglt node_1600;
			       node_1600 =
				  (((make_box_202_bglt) CREF(node_1173))->value);
			       node_4 = node_1600;
			       goto occur_node__249_ast_occur;
			    }
			 }
			 break;
		      case ((long) 16):

			 {	/* Ast/occur.scm 196 */
			    box_ref_242_bglt node_1175;
			    node_1175 =
			       (box_ref_242_bglt) (node_4);
			    {
			       node_bglt node_1603;
			       {	/* Ast/occur.scm 196 */
				  var_bglt aux_1604;
				  aux_1604 =
				     (((box_ref_242_bglt) CREF(node_1175))->var);
				  node_1603 =
				     (node_bglt) (aux_1604);
			       }
			       node_4 = node_1603;
			       goto occur_node__249_ast_occur;
			    }
			 }
			 break;
		      case ((long) 17):

			 {	/* Ast/occur.scm 202 */
			    box_set__221_bglt node_1177;
			    node_1177 =
			       (box_set__221_bglt) (node_4);
			    {	/* Ast/occur.scm 203 */
			       node_bglt aux_1608;
			       {	/* Ast/occur.scm 203 */
				  var_bglt aux_1609;
				  aux_1609 =
				     (((box_set__221_bglt) CREF(node_1177))->var);
				  aux_1608 =
				     (node_bglt) (aux_1609);
			       }
			       occur_node__249_ast_occur(aux_1608);
			    }
			    {
			       node_bglt node_1613;
			       node_1613 =
				  (((box_set__221_bglt) CREF(node_1177))->value);
			       node_4 = node_1613;
			       goto occur_node__249_ast_occur;
			    }
			 }
			 break;
		      default:
		       case_else1600_1070:
			 if (
			    PROCEDUREP(method1594_1066))
			   {	/* Ast/occur.scm 50 */
			      return
				 PROCEDURE_ENTRY(method1594_1066) (method1594_1066,
				 (obj_t) (node_4), BEOA);
			   }
			 else
			   {	/* Ast/occur.scm 50 */
			      obj_t fun1593_1062;
			      fun1593_1062 =
				 PROCEDURE_REF(occur_node__env_215_ast_occur, ((long) 0));
			      return
				 PROCEDURE_ENTRY(fun1593_1062) (fun1593_1062,
				 (obj_t) (node_4), BEOA);
			   }
		      }
		 }
	       else
		 {	/* Ast/occur.scm 50 */
		    goto case_else1600_1070;
		 }
	    }
	 }
      }
   }
}



/* _occur-node! */
obj_t 
_occur_node__166_ast_occur(obj_t env_1317, obj_t node_1318)
{
   AN_OBJECT;
   {	/* Ast/occur.scm 50 */
      return
	 occur_node__249_ast_occur(
	 (node_bglt) (node_1318));
   }
}



/* occur-node!-default1464 */
obj_t 
occur_node__default1464_210_ast_occur(node_bglt node_5)
{
   AN_OBJECT;
   {	/* Ast/occur.scm 14 */
      return
	 CNST_TABLE_REF(((long) 0));
   }
}



/* _occur-node!-default1464 */
obj_t 
_occur_node__default1464_6_ast_occur(obj_t env_1319, obj_t node_1320)
{
   AN_OBJECT;
   {	/* Ast/occur.scm 14 */
      return
	 occur_node__default1464_210_ast_occur(
	 (node_bglt) (node_1320));
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_ast_occur()
{
   AN_OBJECT;
   {	/* Ast/occur.scm 14 */
      module_initialization_70_type_type(((long) 0), "AST_OCCUR");
      module_initialization_70_ast_var(((long) 0), "AST_OCCUR");
      module_initialization_70_ast_node(((long) 0), "AST_OCCUR");
      module_initialization_70_tools_error(((long) 0), "AST_OCCUR");
      module_initialization_70_tools_shape(((long) 0), "AST_OCCUR");
      module_initialization_70_ast_sexp(((long) 0), "AST_OCCUR");
      module_initialization_70_ast_env(((long) 0), "AST_OCCUR");
      return
	 module_initialization_70_ast_local(((long) 0), "AST_OCCUR");
   }
}
