/*===========================================================================*/
/*   (Ast/pragma.scm)                                                        */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;


static obj_t method_init_76_ast_pragma();
extern obj_t find_location_loc_243_tools_location(obj_t, obj_t);
static obj_t get_max_index_90_ast_pragma(obj_t);
extern bool_t rgc_fill_buffer(obj_t);
static obj_t _pragma_type__node_93_ast_pragma(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t pragma_ast_node;
extern node_bglt pragma_type__node_160_ast_pragma(bool_t, type_bglt, obj_t, obj_t, obj_t, obj_t);
extern obj_t module_initialization_70_ast_pragma(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_tools_location(long, char *);
extern obj_t module_initialization_70_ast_sexp(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_numbers_6_5(long, char *);
extern long list_length(obj_t);
static obj_t _anonymous_1478__75_ast_pragma(obj_t, obj_t);
extern long class_num_218___object(obj_t);
static obj_t imported_modules_init_94_ast_pragma();
static obj_t library_modules_init_112_ast_pragma();
extern obj_t rgc_buffer_substring(obj_t, int, int);
extern node_bglt sexp__node_235_ast_sexp(obj_t, obj_t, obj_t, obj_t);
extern obj_t open_input_string(obj_t);
extern node_bglt error_sexp__node_157_ast_sexp(obj_t, obj_t, obj_t);
extern obj_t string__number_104___r4_numbers_6_5(obj_t, obj_t);
extern obj_t read___reader(obj_t);
static obj_t require_initialization_114_ast_pragma = BUNSPEC;
static obj_t cnst_init_137_ast_pragma();
extern obj_t reverse__39___r4_pairs_and_lists_6_3(obj_t);
static obj_t __cnst[1];

DEFINE_STATIC_PROCEDURE(proc1625_ast_pragma, _anonymous_1478__75_ast_pragma1635, _anonymous_1478__75_ast_pragma, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pragma_type__node_env_157_ast_pragma, _pragma_type__node_93_ast_pragma1636, _pragma_type__node_93_ast_pragma, 0L, 6);
DEFINE_STRING(string1629_ast_pragma, string1629_ast_pragma1637, "Illegal range", 13);
DEFINE_STRING(string1630_ast_pragma, string1630_ast_pragma1638, "VALUE ", 6);
DEFINE_STRING(string1628_ast_pragma, string1628_ast_pragma1639, "the-substring", 13);
DEFINE_STRING(string1627_ast_pragma, string1627_ast_pragma1640, "Illegal match", 13);
DEFINE_STRING(string1626_ast_pragma, string1626_ast_pragma1641, "regular-grammar", 15);
DEFINE_STRING(string1624_ast_pragma, string1624_ast_pragma1642, "Illegal `pragma' form", 21);
DEFINE_STRING(string1623_ast_pragma, string1623_ast_pragma1643, "Wrong number of arguments in `pragma' form", 42);



/* module-initialization */
obj_t 
module_initialization_70_ast_pragma(long checksum_1352, char *from_1353)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_ast_pragma))
	{
	   require_initialization_114_ast_pragma =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_ast_pragma();
	   cnst_init_137_ast_pragma();
	   imported_modules_init_94_ast_pragma();
	   method_init_76_ast_pragma();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_ast_pragma()
{
   AN_OBJECT;
   {	/* Ast/pragma.scm 14 */
      module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "AST_PRAGMA");
      module_initialization_70___object(((long) 0), "AST_PRAGMA");
      module_initialization_70___r4_numbers_6_5(((long) 0), "AST_PRAGMA");
      module_initialization_70___reader(((long) 0), "AST_PRAGMA");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_ast_pragma()
{
   AN_OBJECT;
   {	/* Ast/pragma.scm 14 */
      {		/* Ast/pragma.scm 14 */
	 obj_t cnst_port_138_1345;
	 cnst_port_138_1345 =
	    open_input_string(string1630_ast_pragma);
	 {
	    long i_1346;
	    i_1346 = ((long) 0);
	  loop_1347:
	    {	/* Ast/pragma.scm 14 */
	       bool_t test1631_1348;
	       test1631_1348 =
		  (i_1346 == ((long) -1));
	       if (test1631_1348)
		 {	/* Ast/pragma.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Ast/pragma.scm 14 */
		    {	/* Ast/pragma.scm 14 */
		       obj_t arg1632_1349;
		       {	/* Ast/pragma.scm 14 */
			  obj_t list1633_1350;
			  list1633_1350 =
			     MAKE_PAIR(cnst_port_138_1345, BNIL);
			  arg1632_1349 =
			     read___reader(list1633_1350);
		       }
		       CNST_TABLE_SET(i_1346, arg1632_1349);
		    }
		    {	/* Ast/pragma.scm 14 */
		       int aux_1351;
		       {	/* Ast/pragma.scm 14 */
			  long aux_1371;
			  aux_1371 =
			     (i_1346 - ((long) 1));
			  aux_1351 =
			     (int) (aux_1371);
		       }
		       {
			  long i_1374;
			  i_1374 =
			     (long) (aux_1351);
			  i_1346 = i_1374;
			  goto loop_1347;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* pragma/type->node */
node_bglt 
pragma_type__node_160_ast_pragma(bool_t free_1, type_bglt type_2, obj_t exp_3, obj_t stack_4, obj_t loc_5, obj_t site_6)
{
   AN_OBJECT;
   {	/* Ast/pragma.scm 24 */
      {
	 obj_t format_703;
	 obj_t values_704;
	 if (
	    PAIRP(exp_3))
	   {	/* Ast/pragma.scm 25 */
	      obj_t cdr_109_69_709;
	      cdr_109_69_709 =
		 CDR(exp_3);
	      if (
		 PAIRP(cdr_109_69_709))
		{	/* Ast/pragma.scm 25 */
		   obj_t car_112_152_711;
		   car_112_152_711 =
		      CAR(cdr_109_69_709);
		   if (
		      STRINGP(car_112_152_711))
		     {	/* Ast/pragma.scm 25 */
			obj_t aux_1384;
			format_703 = car_112_152_711;
			values_704 =
			   CDR(cdr_109_69_709);
			{	/* Ast/pragma.scm 27 */
			   obj_t max_index_167_714;
			   obj_t loc_715;
			   max_index_167_714 =
			      get_max_index_90_ast_pragma(format_703);
			   loc_715 =
			      find_location_loc_243_tools_location(exp_3, loc_5);
			   {	/* Ast/pragma.scm 29 */
			      bool_t test_1387;
			      {		/* ./Ieee/fixnum.scm 7109 */
				 long aux_1390;
				 long aux_1388;
				 aux_1390 =
				    list_length(values_704);
				 aux_1388 =
				    (long) CINT(max_index_167_714);
				 test_1387 =
				    (aux_1388 == aux_1390);
			      }
			      if (test_1387)
				{
				   obj_t exps_717;
				   obj_t nodes_718;
				   {	/* Ast/pragma.scm 33 */
				      pragma_bglt aux_1393;
				      exps_717 = values_704;
				      nodes_718 = BNIL;
				    loop_719:
				      if (
					 NULLP(exps_717))
					{	/* Ast/pragma.scm 36 */
					   bool_t arg1455_723;
					   obj_t arg1458_726;
					   if (free_1)
					     {	/* Ast/pragma.scm 40 */
						arg1455_723 = ((bool_t) 0);
					     }
					   else
					     {	/* Ast/pragma.scm 40 */
						arg1455_723 = ((bool_t) 1);
					     }
					   arg1458_726 =
					      reverse__39___r4_pairs_and_lists_6_3(nodes_718);
					   {	/* Ast/pragma.scm 36 */
					      pragma_bglt res1616_1225;
					      {		/* Ast/pragma.scm 36 */
						 obj_t side_effect__165_1211;
						 obj_t key_1212;
						 side_effect__165_1211 =
						    BBOOL(arg1455_723);
						 key_1212 =
						    BINT(((long) -1));
						 {	/* ./Ast/node.scm 602 */
						    pragma_bglt new1284_1215;
						    new1284_1215 =
						       ((pragma_bglt) BREF(GC_MALLOC(sizeof(struct pragma))));
						    {	/* ./Ast/node.scm 602 */
						       long arg1568_1216;
						       arg1568_1216 =
							  class_num_218___object(pragma_ast_node);
						       {	/* ./Ast/node.scm 602 */
							  obj_t obj_1223;
							  obj_1223 =
							     (obj_t) (new1284_1215);
							  (((obj_t) CREF(obj_1223))->header = MAKE_HEADER(arg1568_1216, 0), BUNSPEC);
						       }
						    }
						    {	/* ./Ast/node.scm 602 */
						       object_bglt aux_1404;
						       aux_1404 =
							  (object_bglt) (new1284_1215);
						       OBJECT_WIDENING_SET(aux_1404, BFALSE);
						    }
						    ((((pragma_bglt) CREF(new1284_1215))->loc) = ((obj_t) loc_715), BUNSPEC);
						    ((((pragma_bglt) CREF(new1284_1215))->type) = ((type_bglt) type_2), BUNSPEC);
						    ((((pragma_bglt) CREF(new1284_1215))->side_effect__165) = ((obj_t) side_effect__165_1211), BUNSPEC);
						    ((((pragma_bglt) CREF(new1284_1215))->key) = ((obj_t) key_1212), BUNSPEC);
						    ((((pragma_bglt) CREF(new1284_1215))->format) = ((obj_t) format_703), BUNSPEC);
						    ((((pragma_bglt) CREF(new1284_1215))->args) = ((obj_t) arg1458_726), BUNSPEC);
						    res1616_1225 = new1284_1215;
						 }
					      }
					      aux_1393 = res1616_1225;
					   }
					}
				      else
					{	/* Ast/pragma.scm 41 */
					   obj_t arg1459_727;
					   obj_t arg1461_728;
					   arg1459_727 =
					      CDR(exps_717);
					   {	/* Ast/pragma.scm 43 */
					      node_bglt arg1462_729;
					      {		/* Ast/pragma.scm 43 */
						 obj_t arg1463_730;
						 obj_t arg1464_731;
						 obj_t arg1466_732;
						 arg1463_730 =
						    CAR(exps_717);
						 arg1464_731 =
						    find_location_loc_243_tools_location(
						    CAR(exps_717), loc_715);
						 arg1466_732 =
						    CNST_TABLE_REF(((long) 0));
						 arg1462_729 =
						    sexp__node_235_ast_sexp(arg1463_730, stack_4, arg1464_731, arg1466_732);
					      }
					      {		/* ./Ieee/pair-list.scm 5689 */
						 obj_t aux_1419;
						 aux_1419 =
						    (obj_t) (arg1462_729);
						 arg1461_728 =
						    MAKE_PAIR(aux_1419, nodes_718);
					      }
					   }
					   {
					      obj_t nodes_1423;
					      obj_t exps_1422;
					      exps_1422 = arg1459_727;
					      nodes_1423 = arg1461_728;
					      nodes_718 = nodes_1423;
					      exps_717 = exps_1422;
					      goto loop_719;
					   }
					}
				      aux_1384 =
					 (obj_t) (aux_1393);
				   }
				}
			      else
				{	/* Ast/pragma.scm 30 */
				   node_bglt aux_1425;
				   aux_1425 =
				      error_sexp__node_157_ast_sexp(string1623_ast_pragma, exp_3, loc_715);
				   aux_1384 =
				      (obj_t) (aux_1425);
				}
			   }
			}
			return
			   (node_bglt) (aux_1384);
		     }
		   else
		     {	/* Ast/pragma.scm 25 */
		      tag_102_241_706:
			return
			   error_sexp__node_157_ast_sexp(string1624_ast_pragma, exp_3, loc_5);
		     }
		}
	      else
		{	/* Ast/pragma.scm 25 */
		   goto tag_102_241_706;
		}
	   }
	 else
	   {	/* Ast/pragma.scm 25 */
	      goto tag_102_241_706;
	   }
      }
   }
}



/* _pragma/type->node */
obj_t 
_pragma_type__node_93_ast_pragma(obj_t env_1335, obj_t free_1336, obj_t type_1337, obj_t exp_1338, obj_t stack_1339, obj_t loc_1340, obj_t site_1341)
{
   AN_OBJECT;
   {	/* Ast/pragma.scm 24 */
      {		/* Ast/pragma.scm 24 */
	 node_bglt aux_1431;
	 aux_1431 =
	    pragma_type__node_160_ast_pragma(
	    CBOOL(free_1336),
	    (type_bglt) (type_1337), exp_1338, stack_1339, loc_1340, site_1341);
	 return
	    (obj_t) (aux_1431);
      }
   }
}



/* get-max-index */
obj_t 
get_max_index_90_ast_pragma(obj_t format_7)
{
   AN_OBJECT;
   {	/* Ast/pragma.scm 54 */
      {		/* Ast/pragma.scm 55 */
	 obj_t parser_735;
	 obj_t port_736;
	 {	/* Ast/pragma.scm 55 */
	    obj_t _anonymous_1478__75_1342;
	    _anonymous_1478__75_1342 = proc1625_ast_pragma;
	    parser_735 = _anonymous_1478__75_1342;
	 }
	 port_736 =
	    open_input_string(format_7);
	 {
	    obj_t exp_737;
	    obj_t max_738;
	    {	/* Ast/pragma.scm 63 */
	       obj_t arg1470_740;
	       arg1470_740 =
		  PROCEDURE_ENTRY(parser_735) (parser_735, port_736, BEOA);
	       exp_737 = arg1470_740;
	       max_738 =
		  BINT(((long) 0));
	     loop_739:
	       {	/* Ast/pragma.scm 66 */
		  bool_t test1472_742;
		  test1472_742 =
		     EOF_OBJECTP(exp_737);
		  if (test1472_742)
		    {	/* Ast/pragma.scm 66 */
		       return max_738;
		    }
		  else
		    {	/* Ast/pragma.scm 66 */
		       if (
			  CHARP(exp_737))
			 {	/* Ast/pragma.scm 68 */
			    {	/* Ast/pragma.scm 69 */
			       obj_t arg1474_744;
			       arg1474_744 =
				  PROCEDURE_ENTRY(parser_735) (parser_735, port_736, BEOA);
			       {
				  obj_t exp_1445;
				  exp_1445 = arg1474_744;
				  exp_737 = exp_1445;
				  goto loop_739;
			       }
			    }
			 }
		       else
			 {	/* Ast/pragma.scm 68 */
			    {	/* Ast/pragma.scm 71 */
			       obj_t arg1475_745;
			       arg1475_745 =
				  PROCEDURE_ENTRY(parser_735) (parser_735, port_736, BEOA);
			       {
				  obj_t max_1449;
				  obj_t exp_1448;
				  exp_1448 = arg1475_745;
				  {	/* Ast/pragma.scm 71 */
				     bool_t test_1450;
				     {	/* ./Ieee/fixnum.scm 7121 */
					long aux_1453;
					long aux_1451;
					aux_1453 =
					   (long) CINT(max_738);
					aux_1451 =
					   (long) CINT(exp_737);
					test_1450 =
					   (aux_1451 > aux_1453);
				     }
				     if (test_1450)
				       {	/* Ast/pragma.scm 71 */
					  max_1449 = exp_737;
				       }
				     else
				       {	/* Ast/pragma.scm 71 */
					  max_1449 = max_738;
				       }
				  }
				  max_738 = max_1449;
				  exp_737 = exp_1448;
				  goto loop_739;
			       }
			    }
			 }
		    }
	       }
	    }
	 }
      }
   }
}



/* <anonymous:1478> */
obj_t 
_anonymous_1478__75_ast_pragma(obj_t env_1343, obj_t input_port_219_1344)
{
   AN_OBJECT;
   {	/* Ast/pragma.scm 55 */
      {
	 obj_t input_port_219_749;
	 input_port_219_749 = input_port_219_1344;
	 {
	    long last_match_133_844;
	    long last_match_133_836;
	    long last_match_133_828;
	    long last_match_133_821;
	    long last_match_133_813;
	    long min_799;
	    int max_800;
	  _anonymous_1479__72_771:
	    RGC_START_MATCH(input_port_219_749);
	    {	/* Ast/pragma.scm 55 */
	       int match_772;
	       {	/* Ast/pragma.scm 55 */
		  long aux_1458;
		  last_match_133_821 = ((long) 2);
		_anonymous_1519__24_822:
		  {	/* Ast/pragma.scm 55 */
		     int current_char_37_823;
		     current_char_37_823 =
			RGC_BUFFER_GET_CHAR(input_port_219_749);
		     {	/* Ast/pragma.scm 55 */
			bool_t test_1460;
			{	/* ./Ieee/fixnum.scm 7109 */
			   long aux_1461;
			   aux_1461 =
			      (long) (current_char_37_823);
			   test_1460 =
			      (aux_1461 == ((long) 0));
			}
			if (test_1460)
			  {	/* Ast/pragma.scm 55 */
			     {	/* Ast/pragma.scm 55 */
				bool_t test1521_825;
				test1521_825 =
				   RGC_BUFFER_EMPTY(input_port_219_749);
				if (test1521_825)
				  {	/* Ast/pragma.scm 55 */
				     bool_t test1522_826;
				     test1522_826 =
					rgc_fill_buffer(input_port_219_749);
				     if (test1522_826)
				       {

					  goto _anonymous_1519__24_822;
				       }
				     else
				       {	/* Ast/pragma.scm 55 */
					  aux_1458 = last_match_133_821
					     ;
				       }
				  }
				else
				  {	/* Ast/pragma.scm 55 */
				     last_match_133_828 = last_match_133_821;
				   _anonymous_1524__149_829:
				     {	/* Ast/pragma.scm 55 */
					long new_match_93_830;
					RGC_STOP_MATCH(input_port_219_749);
					new_match_93_830 = ((long) 1);
					{	/* Ast/pragma.scm 55 */
					   int current_char_37_831;
					   current_char_37_831 =
					      RGC_BUFFER_GET_CHAR(input_port_219_749);
					   {	/* Ast/pragma.scm 55 */
					      bool_t test_1470;
					      {		/* ./Ieee/fixnum.scm 7109 */
						 long aux_1471;
						 aux_1471 =
						    (long) (current_char_37_831);
						 test_1470 =
						    (aux_1471 == ((long) 0));
					      }
					      if (test_1470)
						{	/* Ast/pragma.scm 55 */
						   {	/* Ast/pragma.scm 55 */
						      bool_t test1526_833;
						      test1526_833 =
							 RGC_BUFFER_EMPTY(input_port_219_749);
						      if (test1526_833)
							{	/* Ast/pragma.scm 55 */
							   bool_t test1527_834;
							   test1527_834 =
							      rgc_fill_buffer(input_port_219_749);
							   if (test1527_834)
							     {

								goto _anonymous_1524__149_829;
							     }
							   else
							     {	/* Ast/pragma.scm 55 */
								aux_1458 = new_match_93_830
								   ;
							     }
							}
						      else
							{	/* Ast/pragma.scm 55 */
							   last_match_133_836 = new_match_93_830;
							 _anonymous_1529__244_837:
							   {	/* Ast/pragma.scm 55 */
							      long new_match_93_838;
							      RGC_STOP_MATCH(input_port_219_749);
							      new_match_93_838 = ((long) 1);
							      {		/* Ast/pragma.scm 55 */
								 int current_char_37_839;
								 current_char_37_839 =
								    RGC_BUFFER_GET_CHAR(input_port_219_749);
								 {	/* Ast/pragma.scm 55 */
								    bool_t test_1480;
								    {	/* ./Ieee/fixnum.scm 7109 */
								       long aux_1481;
								       aux_1481 =
									  (long) (current_char_37_839);
								       test_1480 =
									  (aux_1481 == ((long) 0));
								    }
								    if (test_1480)
								      {		/* Ast/pragma.scm 55 */
									 {	/* Ast/pragma.scm 55 */
									    bool_t test1531_841;
									    test1531_841 =
									       RGC_BUFFER_EMPTY(input_port_219_749);
									    if (test1531_841)
									      {		/* Ast/pragma.scm 55 */
										 bool_t test1532_842;
										 test1532_842 =
										    rgc_fill_buffer(input_port_219_749);
										 if (test1532_842)
										   {

										      goto _anonymous_1529__244_837;
										   }
										 else
										   {	/* Ast/pragma.scm 55 */
										      aux_1458 = new_match_93_838
											 ;
										   }
									      }
									    else
									      {
										 long last_match_133_1488;
										 last_match_133_1488 = new_match_93_838;
										 last_match_133_836 = last_match_133_1488;
										 goto _anonymous_1529__244_837;
									      }
									 }
								      }
								    else
								      {		/* Ast/pragma.scm 55 */
									 bool_t test_1489;
									 {	/* ./Ieee/fixnum.scm 7109 */
									    long aux_1490;
									    aux_1490 =
									       (long) (current_char_37_839);
									    test_1489 =
									       (aux_1490 == ((long) 36));
									 }
									 if (test_1489)
									   {	/* Ast/pragma.scm 55 */
									      aux_1458 = new_match_93_838;
									   }
									 else
									   {	/* Ast/pragma.scm 55 */
									      {
										 long last_match_133_1493;
										 last_match_133_1493 = new_match_93_838;
										 last_match_133_836 = last_match_133_1493;
										 goto _anonymous_1529__244_837;
									      }
									   }
								      }
								 }
							      }
							   }
							}
						   }
						}
					      else
						{	/* Ast/pragma.scm 55 */
						   bool_t test_1494;
						   {	/* ./Ieee/fixnum.scm 7109 */
						      long aux_1495;
						      aux_1495 =
							 (long) (current_char_37_831);
						      test_1494 =
							 (aux_1495 == ((long) 36));
						   }
						   if (test_1494)
						     {	/* Ast/pragma.scm 55 */
							aux_1458 = new_match_93_830;
						     }
						   else
						     {	/* Ast/pragma.scm 55 */
							{
							   long last_match_133_1498;
							   last_match_133_1498 = new_match_93_830;
							   last_match_133_836 = last_match_133_1498;
							   goto _anonymous_1529__244_837;
							}
						     }
						}
					   }
					}
				     }
				  }
			     }
			  }
			else
			  {	/* Ast/pragma.scm 55 */
			     bool_t test_1499;
			     {	/* ./Ieee/fixnum.scm 7109 */
				long aux_1500;
				aux_1500 =
				   (long) (current_char_37_823);
				test_1499 =
				   (aux_1500 == ((long) 36));
			     }
			     if (test_1499)
			       {	/* Ast/pragma.scm 55 */
				  last_match_133_844 = last_match_133_821;
				_anonymous_1534__202_845:
				  {	/* Ast/pragma.scm 55 */
				     long new_match_93_846;
				     RGC_STOP_MATCH(input_port_219_749);
				     new_match_93_846 = ((long) 2);
				     {	/* Ast/pragma.scm 55 */
					int current_char_37_847;
					current_char_37_847 =
					   RGC_BUFFER_GET_CHAR(input_port_219_749);
					{	/* Ast/pragma.scm 55 */
					   bool_t test_1505;
					   {	/* ./Ieee/fixnum.scm 7109 */
					      long aux_1506;
					      aux_1506 =
						 (long) (current_char_37_847);
					      test_1505 =
						 (aux_1506 == ((long) 0));
					   }
					   if (test_1505)
					     {	/* Ast/pragma.scm 55 */
						{	/* Ast/pragma.scm 55 */
						   bool_t test1536_849;
						   {	/* Ast/pragma.scm 55 */
						      bool_t res1622_1309;
						      {		/* ./Rgc/rgc.scm 4690 */
							 bool_t _andtest_1006_1306;
							 _andtest_1006_1306 =
							    RGC_BUFFER_EMPTY(input_port_219_749);
							 if (_andtest_1006_1306)
							   {	/* ./Rgc/rgc.scm 4690 */
							      res1622_1309 =
								 rgc_fill_buffer(input_port_219_749);
							   }
							 else
							   {	/* ./Rgc/rgc.scm 4690 */
							      res1622_1309 = ((bool_t) 0);
							   }
						      }
						      test1536_849 = res1622_1309;
						   }
						   if (test1536_849)
						     {

							goto _anonymous_1534__202_845;
						     }
						   else
						     {	/* Ast/pragma.scm 55 */
							aux_1458 = new_match_93_846
							   ;
						     }
						}
					     }
					   else
					     {	/* Ast/pragma.scm 55 */
						bool_t test_1513;
						{	/* Ast/pragma.scm 55 */
						   bool_t test_1514;
						   {	/* ./Ieee/fixnum.scm 7133 */
						      long aux_1515;
						      aux_1515 =
							 (long) (current_char_37_847);
						      test_1514 =
							 (aux_1515 >= ((long) 48));
						   }
						   if (test_1514)
						     {	/* ./Ieee/fixnum.scm 7115 */
							long aux_1518;
							aux_1518 =
							   (long) (current_char_37_847);
							test_1513 =
							   (aux_1518 < ((long) 58));
						     }
						   else
						     {	/* Ast/pragma.scm 55 */
							test_1513 = ((bool_t) 0)
							   ;
						     }
						}
						if (test_1513)
						  {	/* Ast/pragma.scm 55 */
						     last_match_133_813 = new_match_93_846;
						   _anonymous_1514__231_814:
						     {	/* Ast/pragma.scm 55 */
							long new_match_93_815;
							RGC_STOP_MATCH(input_port_219_749);
							new_match_93_815 = ((long) 0);
							{	/* Ast/pragma.scm 55 */
							   int current_char_37_816;
							   current_char_37_816 =
							      RGC_BUFFER_GET_CHAR(input_port_219_749);
							   {	/* Ast/pragma.scm 55 */
							      bool_t test_1523;
							      {		/* ./Ieee/fixnum.scm 7109 */
								 long aux_1524;
								 aux_1524 =
								    (long) (current_char_37_816);
								 test_1523 =
								    (aux_1524 == ((long) 0));
							      }
							      if (test_1523)
								{	/* Ast/pragma.scm 55 */
								   {	/* Ast/pragma.scm 55 */
								      bool_t test1516_818;
								      {		/* Ast/pragma.scm 55 */
									 bool_t res1621_1273;
									 {	/* ./Rgc/rgc.scm 4690 */
									    bool_t _andtest_1006_1270;
									    _andtest_1006_1270 =
									       RGC_BUFFER_EMPTY(input_port_219_749);
									    if (_andtest_1006_1270)
									      {		/* ./Rgc/rgc.scm 4690 */
										 res1621_1273 =
										    rgc_fill_buffer(input_port_219_749);
									      }
									    else
									      {		/* ./Rgc/rgc.scm 4690 */
										 res1621_1273 = ((bool_t) 0);
									      }
									 }
									 test1516_818 = res1621_1273;
								      }
								      if (test1516_818)
									{

									   goto _anonymous_1514__231_814;
									}
								      else
									{	/* Ast/pragma.scm 55 */
									   aux_1458 = new_match_93_815
									      ;
									}
								   }
								}
							      else
								{	/* Ast/pragma.scm 55 */
								   bool_t test_1531;
								   {	/* Ast/pragma.scm 55 */
								      bool_t test_1532;
								      {		/* ./Ieee/fixnum.scm 7133 */
									 long aux_1533;
									 aux_1533 =
									    (long) (current_char_37_816);
									 test_1532 =
									    (aux_1533 >= ((long) 48));
								      }
								      if (test_1532)
									{	/* ./Ieee/fixnum.scm 7115 */
									   long aux_1536;
									   aux_1536 =
									      (long) (current_char_37_816);
									   test_1531 =
									      (aux_1536 < ((long) 58));
									}
								      else
									{	/* Ast/pragma.scm 55 */
									   test_1531 = ((bool_t) 0)
									      ;
									}
								   }
								   if (test_1531)
								     {	/* Ast/pragma.scm 55 */
									{
									   long last_match_133_1539;
									   last_match_133_1539 = new_match_93_815;
									   last_match_133_813 = last_match_133_1539;
									   goto _anonymous_1514__231_814;
									}
								     }
								   else
								     {	/* Ast/pragma.scm 55 */
									aux_1458 = new_match_93_815;
								     }
								}
							   }
							}
						     }
						  }
						else
						  {	/* Ast/pragma.scm 55 */
						     aux_1458 = new_match_93_846;
						  }
					     }
					}
				     }
				  }
			       }
			     else
			       {	/* Ast/pragma.scm 55 */
				  {
				     long last_match_133_1540;
				     last_match_133_1540 = last_match_133_821;
				     last_match_133_828 = last_match_133_1540;
				     goto _anonymous_1524__149_829;
				  }
			       }
			  }
		     }
		  }
		  match_772 =
		     (int) (aux_1458);
	       }
	       {

		  switch (
		     (long) (match_772))
		    {
		    case ((long) 2):

		       {	/* Ast/pragma.scm 55 */
			  bool_t test1491_789;
			  {	/* Ast/pragma.scm 55 */
			     int arg1495_792;
			     {	/* Ast/pragma.scm 55 */
				int res1618_1238;
				{	/* ./Rgc/rgc.scm 4612 */
				   long aux_1542;
				   aux_1542 =
				      RGC_BUFFER_LENGTH(input_port_219_749);
				   res1618_1238 =
				      (int) (aux_1542);
				}
				arg1495_792 = res1618_1238;
			     }
			     {	/* ./Ieee/fixnum.scm 7109 */
				long aux_1545;
				aux_1545 =
				   (long) (arg1495_792);
				test1491_789 =
				   (aux_1545 == ((long) 0));
			     }
			  }
			  if (test1491_789)
			    {	/* Ast/pragma.scm 55 */
			       return BCNST(256);
			    }
			  else
			    {	/* Ast/pragma.scm 55 */
			       obj_t arg1493_790;
			       {	/* Ast/pragma.scm 55 */
				  int arg1512_811;
				  {	/* Ast/pragma.scm 55 */
				     int res1620_1261;
				     {	/* ./Rgc/rgc.scm 4612 */
					long aux_1549;
					aux_1549 =
					   RGC_BUFFER_LENGTH(input_port_219_749);
					res1620_1261 =
					   (int) (aux_1549);
				     }
				     arg1512_811 = res1620_1261;
				  }
				  {	/* ./Rgc/rgc.scm 4606 */
				     int aux_1552;
				     aux_1552 =
					(int) (((long) 0));
				     arg1493_790 =
					rgc_buffer_substring(input_port_219_749, aux_1552, arg1512_811);
				  }
			       }
			       {	/* ./Ieee/string.scm 8089 */
				  unsigned char aux_1555;
				  aux_1555 =
				     STRING_REF(arg1493_790, ((long) 0));
				  return
				     BCHAR(aux_1555);
			       }
			    }
		       }
		       break;
		    case ((long) 1):

		       goto _anonymous_1479__72_771;
		       break;
		    case ((long) 0):

		       {	/* Ast/pragma.scm 57 */
			  obj_t arg1481_776;
			  {	/* Ast/pragma.scm 57 */
			     int arg1484_779;
			     {	/* Ast/pragma.scm 57 */
				int res1617_1233;
				{	/* ./Rgc/rgc.scm 4612 */
				   long aux_1558;
				   aux_1558 =
				      RGC_BUFFER_LENGTH(input_port_219_749);
				   res1617_1233 =
				      (int) (aux_1558);
				}
				arg1484_779 = res1617_1233;
			     }
			     min_799 = ((long) 1);
			     max_800 = arg1484_779;
			     {	/* Ast/pragma.scm 55 */
				bool_t test1503_802;
				if (
				   (min_799 >= ((long) 0)))
				  {	/* Ast/pragma.scm 55 */
				     bool_t test1508_807;
				     {	/* Ast/pragma.scm 55 */
					int arg1509_808;
					{	/* Ast/pragma.scm 55 */
					   int res1619_1247;
					   {	/* ./Rgc/rgc.scm 4612 */
					      long aux_1563;
					      aux_1563 =
						 RGC_BUFFER_LENGTH(input_port_219_749);
					      res1619_1247 =
						 (int) (aux_1563);
					   }
					   arg1509_808 = res1619_1247;
					}
					{	/* ./Ieee/fixnum.scm 7127 */
					   long aux_1568;
					   long aux_1566;
					   aux_1568 =
					      (long) (arg1509_808);
					   aux_1566 =
					      (long) (max_800);
					   test1508_807 =
					      (aux_1566 <= aux_1568);
					}
				     }
				     if (test1508_807)
				       {	/* ./Ieee/fixnum.scm 7133 */
					  long aux_1572;
					  aux_1572 =
					     (long) (max_800);
					  test1503_802 =
					     (aux_1572 >= min_799);
				       }
				     else
				       {	/* Ast/pragma.scm 55 */
					  test1503_802 = ((bool_t) 0);
				       }
				  }
				else
				  {	/* Ast/pragma.scm 55 */
				     test1503_802 = ((bool_t) 0);
				  }
				if (test1503_802)
				  {	/* ./Rgc/rgc.scm 4606 */
				     int aux_1576;
				     aux_1576 =
					(int) (min_799);
				     arg1481_776 =
					rgc_buffer_substring(input_port_219_749, aux_1576, max_800);
				  }
				else
				  {	/* Ast/pragma.scm 55 */
				     obj_t arg1506_805;
				     {	/* ./Ieee/pair-list.scm 5689 */
					obj_t aux_1581;
					obj_t aux_1579;
					aux_1581 =
					   BINT(max_800);
					aux_1579 =
					   BINT(min_799);
					arg1506_805 =
					   MAKE_PAIR(aux_1579, aux_1581);
				     }
				     FAILURE(string1628_ast_pragma, string1629_ast_pragma, arg1506_805);
				  }
			     }
			  }
			  return
			     string__number_104___r4_numbers_6_5(arg1481_776, BNIL);
		       }
		       break;
		    default:
		       FAILURE(string1626_ast_pragma, string1627_ast_pragma,
			  BINT(match_772));
		    }
	       }
	    }
	 }
      }
   }
}



/* method-init */
obj_t 
method_init_76_ast_pragma()
{
   AN_OBJECT;
   {	/* Ast/pragma.scm 14 */
      return BUNSPEC;
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_ast_pragma()
{
   AN_OBJECT;
   {	/* Ast/pragma.scm 14 */
      module_initialization_70_type_type(((long) 0), "AST_PRAGMA");
      module_initialization_70_ast_var(((long) 0), "AST_PRAGMA");
      module_initialization_70_ast_node(((long) 0), "AST_PRAGMA");
      module_initialization_70_tools_error(((long) 0), "AST_PRAGMA");
      module_initialization_70_tools_location(((long) 0), "AST_PRAGMA");
      return
	 module_initialization_70_ast_sexp(((long) 0), "AST_PRAGMA");
   }
}
