/*===========================================================================*/
/*   (Ast/remove.scm)                                                        */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;


static obj_t method_init_76_ast_remove();
extern obj_t make_box_202_ast_node;
extern obj_t funcall_ast_node;
extern long add_inlined_method__244___object(obj_t, obj_t, long);
extern obj_t string_append(obj_t, obj_t);
extern obj_t fail_ast_node;
static obj_t _remove_var_213_ast_remove(obj_t, obj_t, obj_t);
extern obj_t box_ref_242_ast_node;
static obj_t _remove_var_from_1738_167_ast_remove(obj_t, obj_t, obj_t);
extern obj_t sequence_ast_node;
extern obj_t let_var_6_ast_node;
extern obj_t var_ast_node;
extern obj_t _bdb_debug__1_engine_param;
extern obj_t pragma_ast_node;
extern obj_t set_ex_it_116_ast_node;
static node_bglt node_remove__162_ast_remove(node_bglt);
extern obj_t verbose_tools_speek(obj_t, obj_t);
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t module_initialization_70_ast_remove(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_tools_speek(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_effect_effect(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_ast_occur(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t remove_var_from__148_ast_remove(obj_t, variable_bglt);
extern obj_t let_fun_218_ast_node;
static obj_t imported_modules_init_94_ast_remove();
extern obj_t app_ly_162_ast_node;
extern obj_t add_generic__110___object(obj_t, obj_t);
static obj_t _node_remove__default1443_253_ast_remove(obj_t, obj_t);
extern obj_t app_ast_node;
static obj_t library_modules_init_112_ast_remove();
extern obj_t occur_var_108_ast_occur(obj_t);
extern obj_t atom_ast_node;
extern obj_t cast_ast_node;
static obj_t toplevel_init_63_ast_remove();
static obj_t _node_remove_1739_64_ast_remove(obj_t, obj_t);
extern obj_t jump_ex_it_184_ast_node;
extern obj_t open_input_string(obj_t);
extern obj_t kwote_ast_node;
extern bool_t side_effect__165_effect_effect(node_bglt);
extern obj_t setq_ast_node;
static node_bglt node_remove__default1443_179_ast_remove(node_bglt);
extern obj_t box_set__221_ast_node;
extern obj_t memq___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern obj_t shape_tools_shape(obj_t);
extern obj_t remove_var_123_ast_remove(obj_t, obj_t);
extern obj_t internal_error_43_tools_error(obj_t, obj_t, obj_t);
extern obj_t _classes__134___object;
extern obj_t select_ast_node;
extern obj_t read___reader(obj_t);
static obj_t require_initialization_114_ast_remove = BUNSPEC;
extern obj_t conditional_ast_node;
static obj_t node_remove___45_ast_remove(obj_t);
static obj_t cnst_init_137_ast_remove();
extern obj_t reverse__39___r4_pairs_and_lists_6_3(obj_t);
static obj_t __cnst[6];

DEFINE_STATIC_GENERIC(node_remove__env_197_ast_remove, _node_remove_1739_64_ast_remove1752, _node_remove_1739_64_ast_remove, 0L, 1);
DEFINE_EXPORT_PROCEDURE(remove_var_env_229_ast_remove, _remove_var_213_ast_remove1753, _remove_var_213_ast_remove, 0L, 2);
DEFINE_EXPORT_PROCEDURE(remove_var_from__env_82_ast_remove, _remove_var_from_1738_167_ast_remove1754, _remove_var_from_1738_167_ast_remove, 0L, 2);
DEFINE_STRING(string1747_ast_remove, string1747_ast_remove1755, "NODE-REMOVE!-DEFAULT1443 DONE NO-REMOVE EXPORT OK NOW ", 54);
DEFINE_STRING(string1746_ast_remove, string1746_ast_remove1756, "No method for this object", 25);
DEFINE_STRING(string1745_ast_remove, string1745_ast_remove1757, "        ", 8);
DEFINE_STRING(string1744_ast_remove, string1744_ast_remove1758, " removed", 8);
DEFINE_STRING(string1743_ast_remove, string1743_ast_remove1759, "         removing ", 18);
DEFINE_STRING(string1742_ast_remove, string1742_ast_remove1760, "already removable variable", 26);
DEFINE_STRING(string1741_ast_remove, string1741_ast_remove1761, "remove-var-from!", 16);
DEFINE_STRING(string1740_ast_remove, string1740_ast_remove1762, "/", 1);
DEFINE_STATIC_PROCEDURE(node_remove__default1443_env_112_ast_remove, _node_remove__default1443_253_ast_remove1763, _node_remove__default1443_253_ast_remove, 0L, 1);



/* module-initialization */
obj_t 
module_initialization_70_ast_remove(long checksum_1505, char *from_1506)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_ast_remove))
	{
	   require_initialization_114_ast_remove =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_ast_remove();
	   cnst_init_137_ast_remove();
	   imported_modules_init_94_ast_remove();
	   method_init_76_ast_remove();
	   toplevel_init_63_ast_remove();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_ast_remove()
{
   AN_OBJECT;
   {	/* Ast/remove.scm 16 */
      module_initialization_70___object(((long) 0), "AST_REMOVE");
      module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "AST_REMOVE");
      module_initialization_70___reader(((long) 0), "AST_REMOVE");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_ast_remove()
{
   AN_OBJECT;
   {	/* Ast/remove.scm 16 */
      {		/* Ast/remove.scm 16 */
	 obj_t cnst_port_138_1498;
	 cnst_port_138_1498 =
	    open_input_string(string1747_ast_remove);
	 {
	    long i_1499;
	    i_1499 = ((long) 5);
	  loop_1500:
	    {	/* Ast/remove.scm 16 */
	       bool_t test1748_1501;
	       test1748_1501 =
		  (i_1499 == ((long) -1));
	       if (test1748_1501)
		 {	/* Ast/remove.scm 16 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Ast/remove.scm 16 */
		    {	/* Ast/remove.scm 16 */
		       obj_t arg1749_1502;
		       {	/* Ast/remove.scm 16 */
			  obj_t list1750_1503;
			  list1750_1503 =
			     MAKE_PAIR(cnst_port_138_1498, BNIL);
			  arg1749_1502 =
			     read___reader(list1750_1503);
		       }
		       CNST_TABLE_SET(i_1499, arg1749_1502);
		    }
		    {	/* Ast/remove.scm 16 */
		       int aux_1504;
		       {	/* Ast/remove.scm 16 */
			  long aux_1524;
			  aux_1524 =
			     (i_1499 - ((long) 1));
			  aux_1504 =
			     (int) (aux_1524);
		       }
		       {
			  long i_1527;
			  i_1527 =
			     (long) (aux_1504);
			  i_1499 = i_1527;
			  goto loop_1500;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_ast_remove()
{
   AN_OBJECT;
   {	/* Ast/remove.scm 16 */
      return BUNSPEC;
   }
}



/* remove-var-from! */
obj_t 
remove_var_from__148_ast_remove(obj_t pass_1, variable_bglt var_2)
{
   AN_OBJECT;
   {	/* Ast/remove.scm 30 */
      {		/* Ast/remove.scm 31 */
	 obj_t old_723;
	 old_723 =
	    (((variable_bglt) CREF(var_2))->removable);
	 {	/* Ast/remove.scm 33 */
	    bool_t test_1530;
	    {	/* ./Ieee/equiv.scm 5508 */
	       obj_t aux_1531;
	       aux_1531 =
		  CNST_TABLE_REF(((long) 0));
	       test_1530 =
		  (old_723 == aux_1531);
	    }
	    if (test_1530)
	      {		/* Ast/remove.scm 33 */
		 {	/* Ast/remove.scm 35 */
		    global_bglt obj_1269;
		    obj_1269 =
		       (global_bglt) (var_2);
		    return
		       ((((global_bglt) CREF(obj_1269))->removable) = ((obj_t) pass_1), BUNSPEC);
		 }
	      }
	    else
	      {		/* Ast/remove.scm 33 */
		 if (
		    (old_723 == pass_1))
		   {	/* Ast/remove.scm 36 */
		      return
			 CNST_TABLE_REF(((long) 1));
		   }
		 else
		   {	/* Ast/remove.scm 38 */
		      bool_t test_1539;
		      {		/* ./Ieee/equiv.scm 5508 */
			 obj_t aux_1540;
			 aux_1540 =
			    CNST_TABLE_REF(((long) 0));
			 test_1539 =
			    (pass_1 == aux_1540);
		      }
		      if (test_1539)
			{	/* Ast/remove.scm 38 */
			   return
			      CNST_TABLE_REF(((long) 1));
			}
		      else
			{	/* Ast/remove.scm 38 */
			   {	/* Ast/remove.scm 41 */
			      obj_t arg1490_729;
			      {		/* Ast/remove.scm 43 */
				 obj_t arg1491_730;
				 obj_t arg1493_731;
				 arg1491_730 =
				    SYMBOL_TO_STRING(old_723);
				 {	/* Ast/remove.scm 43 */
				    obj_t arg1495_733;
				    arg1495_733 =
				       SYMBOL_TO_STRING(pass_1);
				    arg1493_731 =
				       string_append(string1740_ast_remove, arg1495_733);
				 }
				 arg1490_729 =
				    string_append(arg1491_730, arg1493_731);
			      }
			      return
				 internal_error_43_tools_error(string1741_ast_remove, string1742_ast_remove, arg1490_729);
			   }
			}
		   }
	      }
	 }
      }
   }
}



/* _remove-var-from!1738 */
obj_t 
_remove_var_from_1738_167_ast_remove(obj_t env_1488, obj_t pass_1489, obj_t var_1490)
{
   AN_OBJECT;
   {	/* Ast/remove.scm 30 */
      return
	 remove_var_from__148_ast_remove(pass_1489,
	 (variable_bglt) (var_1490));
   }
}



/* remove-var */
obj_t 
remove_var_123_ast_remove(obj_t pass_3, obj_t globals_4)
{
   AN_OBJECT;
   {	/* Ast/remove.scm 50 */
      occur_var_108_ast_occur(globals_4);
      {
	 obj_t globals_734;
	 obj_t res_735;
	 globals_734 = globals_4;
	 res_735 = BNIL;
       loop_736:
	 if (
	    NULLP(globals_734))
	   {	/* Ast/remove.scm 56 */
	      return
		 reverse__39___r4_pairs_and_lists_6_3(res_735);
	   }
	 else
	   {	/* Ast/remove.scm 59 */
	      obj_t global_738;
	      global_738 =
		 CAR(globals_734);
	      {		/* Ast/remove.scm 62 */
		 bool_t test_1556;
		 {	/* ./Ieee/equiv.scm 5508 */
		    obj_t aux_1560;
		    obj_t aux_1557;
		    aux_1560 =
		       CNST_TABLE_REF(((long) 2));
		    {	/* Ast/remove.scm 62 */
		       global_bglt obj_1279;
		       obj_1279 =
			  (global_bglt) (global_738);
		       aux_1557 =
			  (((global_bglt) CREF(obj_1279))->import);
		    }
		    test_1556 =
		       (aux_1557 == aux_1560);
		 }
		 if (test_1556)
		   {	/* Ast/remove.scm 62 */
		      {		/* Ast/remove.scm 63 */
			 value_bglt sfun_740;
			 {	/* Ast/remove.scm 63 */
			    global_bglt obj_1282;
			    obj_1282 =
			       (global_bglt) (global_738);
			    sfun_740 =
			       (((global_bglt) CREF(obj_1282))->value);
			 }
			 {	/* Ast/remove.scm 64 */
			    node_bglt arg1498_741;
			    {	/* Ast/remove.scm 64 */
			       node_bglt aux_1565;
			       {	/* Ast/remove.scm 64 */
				  obj_t aux_1566;
				  {	/* Ast/remove.scm 64 */
				     sfun_bglt obj_1283;
				     obj_1283 =
					(sfun_bglt) (sfun_740);
				     aux_1566 =
					(((sfun_bglt) CREF(obj_1283))->body);
				  }
				  aux_1565 =
				     (node_bglt) (aux_1566);
			       }
			       arg1498_741 =
				  node_remove__162_ast_remove(aux_1565);
			    }
			    {	/* Ast/remove.scm 64 */
			       sfun_bglt obj_1284;
			       obj_t val1123_1285;
			       obj_1284 =
				  (sfun_bglt) (sfun_740);
			       val1123_1285 =
				  (obj_t) (arg1498_741);
			       ((((sfun_bglt) CREF(obj_1284))->body) = ((obj_t) val1123_1285), BUNSPEC);
			    }
			 }
		      }
		      {		/* Ast/remove.scm 65 */
			 obj_t arg1500_743;
			 obj_t arg1501_744;
			 arg1500_743 =
			    CDR(globals_734);
			 arg1501_744 =
			    MAKE_PAIR(global_738, res_735);
			 {
			    obj_t res_1577;
			    obj_t globals_1576;
			    globals_1576 = arg1500_743;
			    res_1577 = arg1501_744;
			    res_735 = res_1577;
			    globals_734 = globals_1576;
			    goto loop_736;
			 }
		      }
		   }
		 else
		   {	/* Ast/remove.scm 68 */
		      bool_t test_1578;
		      {		/* Ast/remove.scm 68 */
			 bool_t test_1579;
			 {	/* ./Ieee/equiv.scm 5508 */
			    obj_t aux_1580;
			    {	/* Ast/remove.scm 68 */
			       global_bglt obj_1289;
			       obj_1289 =
				  (global_bglt) (global_738);
			       aux_1580 =
				  (((global_bglt) CREF(obj_1289))->removable);
			    }
			    test_1579 =
			       (aux_1580 == pass_3);
			 }
			 if (test_1579)
			   {	/* Ast/remove.scm 68 */
			      test_1578 = ((bool_t) 1)
				 ;
			   }
			 else
			   {	/* Ast/remove.scm 69 */
			      obj_t aux_1584;
			      {		/* Ast/remove.scm 69 */
				 obj_t aux_1585;
				 {	/* Ast/remove.scm 69 */
				    global_bglt obj_1292;
				    obj_1292 =
				       (global_bglt) (global_738);
				    aux_1585 =
				       (((global_bglt) CREF(obj_1292))->removable);
				 }
				 aux_1584 =
				    memq___r4_pairs_and_lists_6_3(aux_1585, pass_3);
			      }
			      test_1578 =
				 CBOOL(aux_1584);
			   }
		      }
		      if (test_1578)
			{	/* Ast/remove.scm 68 */
			   {	/* Ast/remove.scm 70 */
			      bool_t test_1590;
			      {		/* ./Ieee/fixnum.scm 7127 */
				 long aux_1591;
				 {	/* Ast/remove.scm 70 */
				    global_bglt obj_1293;
				    obj_1293 =
				       (global_bglt) (global_738);
				    aux_1591 =
				       (((global_bglt) CREF(obj_1293))->occurrence);
				 }
				 test_1590 =
				    (aux_1591 <= ((long) 0));
			      }
			      if (test_1590)
				{	/* Ast/remove.scm 70 */
				   {	/* Ast/remove.scm 73 */
				      obj_t arg1506_749;
				      arg1506_749 =
					 shape_tools_shape(global_738);
				      {		/* Ast/remove.scm 73 */
					 obj_t list1507_750;
					 {	/* Ast/remove.scm 73 */
					    obj_t arg1508_751;
					    {	/* Ast/remove.scm 73 */
					       obj_t arg1509_752;
					       {	/* Ast/remove.scm 73 */
						  obj_t aux_1596;
						  aux_1596 =
						     BCHAR(((unsigned char) '\n'));
						  arg1509_752 =
						     MAKE_PAIR(aux_1596, BNIL);
					       }
					       arg1508_751 =
						  MAKE_PAIR(arg1506_749, arg1509_752);
					    }
					    list1507_750 =
					       MAKE_PAIR(string1743_ast_remove, arg1508_751);
					 }
					 verbose_tools_speek(
					    BINT(((long) 3)), list1507_750);
				      }
				   }
				   {
				      obj_t globals_1603;
				      globals_1603 =
					 CDR(globals_734);
				      globals_734 = globals_1603;
				      goto loop_736;
				   }
				}
			      else
				{	/* Ast/remove.scm 76 */
				   value_bglt sfun_754;
				   {	/* Ast/remove.scm 76 */
				      global_bglt obj_1297;
				      obj_1297 =
					 (global_bglt) (global_738);
				      sfun_754 =
					 (((global_bglt) CREF(obj_1297))->value);
				   }
				   {	/* Ast/remove.scm 77 */
				      global_bglt obj_1298;
				      obj_t val1056_1299;
				      obj_1298 =
					 (global_bglt) (global_738);
				      val1056_1299 =
					 CNST_TABLE_REF(((long) 0));
				      ((((global_bglt) CREF(obj_1298))->removable) = ((obj_t) val1056_1299), BUNSPEC);
				   }
				   {	/* Ast/remove.scm 78 */
				      node_bglt arg1511_755;
				      {		/* Ast/remove.scm 78 */
					 node_bglt aux_1610;
					 {	/* Ast/remove.scm 78 */
					    obj_t aux_1611;
					    {	/* Ast/remove.scm 78 */
					       sfun_bglt obj_1300;
					       obj_1300 =
						  (sfun_bglt) (sfun_754);
					       aux_1611 =
						  (((sfun_bglt) CREF(obj_1300))->body);
					    }
					    aux_1610 =
					       (node_bglt) (aux_1611);
					 }
					 arg1511_755 =
					    node_remove__162_ast_remove(aux_1610);
				      }
				      {		/* Ast/remove.scm 78 */
					 sfun_bglt obj_1301;
					 obj_t val1123_1302;
					 obj_1301 =
					    (sfun_bglt) (sfun_754);
					 val1123_1302 =
					    (obj_t) (arg1511_755);
					 ((((sfun_bglt) CREF(obj_1301))->body) = ((obj_t) val1123_1302), BUNSPEC);
				      }
				   }
				   {	/* Ast/remove.scm 79 */
				      obj_t arg1513_757;
				      obj_t arg1514_758;
				      arg1513_757 =
					 CDR(globals_734);
				      arg1514_758 =
					 MAKE_PAIR(global_738, res_735);
				      {
					 obj_t res_1622;
					 obj_t globals_1621;
					 globals_1621 = arg1513_757;
					 res_1622 = arg1514_758;
					 res_735 = res_1622;
					 globals_734 = globals_1621;
					 goto loop_736;
				      }
				   }
				}
			   }
			}
		      else
			{	/* Ast/remove.scm 80 */
			   bool_t test_1623;
			   {	/* Ast/remove.scm 80 */
			      bool_t test_1624;
			      {		/* ./Ieee/fixnum.scm 7127 */
				 long aux_1625;
				 {	/* Ast/remove.scm 80 */
				    global_bglt obj_1306;
				    obj_1306 =
				       (global_bglt) (global_738);
				    aux_1625 =
				       (((global_bglt) CREF(obj_1306))->occurrence);
				 }
				 test_1624 =
				    (aux_1625 <= ((long) 0));
			      }
			      if (test_1624)
				{	/* Ast/remove.scm 81 */
				   bool_t test_1629;
				   {	/* ./Ieee/equiv.scm 5508 */
				      obj_t aux_1633;
				      obj_t aux_1630;
				      aux_1633 =
					 CNST_TABLE_REF(((long) 0));
				      {		/* Ast/remove.scm 81 */
					 global_bglt obj_1309;
					 obj_1309 =
					    (global_bglt) (global_738);
					 aux_1630 =
					    (((global_bglt) CREF(obj_1309))->removable);
				      }
				      test_1629 =
					 (aux_1630 == aux_1633);
				   }
				   if (test_1629)
				     {	/* Ast/remove.scm 82 */
					bool_t test_1636;
					{	/* ./Ieee/equiv.scm 5508 */
					   obj_t aux_1637;
					   aux_1637 =
					      CNST_TABLE_REF(((long) 3));
					   test_1636 =
					      (pass_3 == aux_1637);
					}
					if (test_1636)
					  {	/* Ast/remove.scm 82 */
					     test_1623 = ((bool_t) 0)
						;
					  }
					else
					  {	/* Ast/remove.scm 82 */
					     test_1623 = ((bool_t) 1)
						;
					  }
				     }
				   else
				     {	/* Ast/remove.scm 81 */
					test_1623 = ((bool_t) 0)
					   ;
				     }
				}
			      else
				{	/* Ast/remove.scm 80 */
				   test_1623 = ((bool_t) 0)
				      ;
				}
			   }
			   if (test_1623)
			     {	/* Ast/remove.scm 80 */
				{	/* Ast/remove.scm 84 */
				   obj_t arg1521_764;
				   arg1521_764 =
				      shape_tools_shape(global_738);
				   {	/* Ast/remove.scm 84 */
				      obj_t list1523_766;
				      {		/* Ast/remove.scm 84 */
					 obj_t arg1525_767;
					 {	/* Ast/remove.scm 84 */
					    obj_t arg1526_768;
					    {	/* Ast/remove.scm 84 */
					       obj_t arg1527_769;
					       {	/* Ast/remove.scm 84 */
						  obj_t aux_1641;
						  aux_1641 =
						     BCHAR(((unsigned char) '\n'));
						  arg1527_769 =
						     MAKE_PAIR(aux_1641, BNIL);
					       }
					       arg1526_768 =
						  MAKE_PAIR(string1744_ast_remove, arg1527_769);
					    }
					    arg1525_767 =
					       MAKE_PAIR(arg1521_764, arg1526_768);
					 }
					 list1523_766 =
					    MAKE_PAIR(string1745_ast_remove, arg1525_767);
				      }
				      verbose_tools_speek(
					 BINT(((long) 3)), list1523_766);
				   }
				}
				{
				   obj_t globals_1649;
				   globals_1649 =
				      CDR(globals_734);
				   globals_734 = globals_1649;
				   goto loop_736;
				}
			     }
			   else
			     {	/* Ast/remove.scm 80 */
				{	/* Ast/remove.scm 87 */
				   value_bglt sfun_771;
				   {	/* Ast/remove.scm 87 */
				      global_bglt obj_1315;
				      obj_1315 =
					 (global_bglt) (global_738);
				      sfun_771 =
					 (((global_bglt) CREF(obj_1315))->value);
				   }
				   {	/* Ast/remove.scm 88 */
				      node_bglt arg1529_772;
				      {		/* Ast/remove.scm 88 */
					 node_bglt aux_1653;
					 {	/* Ast/remove.scm 88 */
					    obj_t aux_1654;
					    {	/* Ast/remove.scm 88 */
					       sfun_bglt obj_1316;
					       obj_1316 =
						  (sfun_bglt) (sfun_771);
					       aux_1654 =
						  (((sfun_bglt) CREF(obj_1316))->body);
					    }
					    aux_1653 =
					       (node_bglt) (aux_1654);
					 }
					 arg1529_772 =
					    node_remove__162_ast_remove(aux_1653);
				      }
				      {		/* Ast/remove.scm 88 */
					 sfun_bglt obj_1317;
					 obj_t val1123_1318;
					 obj_1317 =
					    (sfun_bglt) (sfun_771);
					 val1123_1318 =
					    (obj_t) (arg1529_772);
					 ((((sfun_bglt) CREF(obj_1317))->body) = ((obj_t) val1123_1318), BUNSPEC);
				      }
				   }
				   {	/* Ast/remove.scm 90 */
				      obj_t arg1532_774;
				      obj_t arg1533_775;
				      arg1532_774 =
					 CDR(globals_734);
				      arg1533_775 =
					 MAKE_PAIR(global_738, res_735);
				      {
					 obj_t res_1665;
					 obj_t globals_1664;
					 globals_1664 = arg1532_774;
					 res_1665 = arg1533_775;
					 res_735 = res_1665;
					 globals_734 = globals_1664;
					 goto loop_736;
				      }
				   }
				}
			     }
			}
		   }
	      }
	   }
      }
   }
}



/* _remove-var */
obj_t 
_remove_var_213_ast_remove(obj_t env_1491, obj_t pass_1492, obj_t globals_1493)
{
   AN_OBJECT;
   {	/* Ast/remove.scm 50 */
      return
	 remove_var_123_ast_remove(pass_1492, globals_1493);
   }
}



/* node-remove*! */
obj_t 
node_remove___45_ast_remove(obj_t node__221_27)
{
   AN_OBJECT;
   {	/* Ast/remove.scm 295 */
    node_remove___45_ast_remove:
      if (
	 NULLP(node__221_27))
	{	/* Ast/remove.scm 296 */
	   return
	      CNST_TABLE_REF(((long) 4));
	}
      else
	{	/* Ast/remove.scm 296 */
	   {	/* Ast/remove.scm 299 */
	      node_bglt arg1549_789;
	      {		/* Ast/remove.scm 299 */
		 node_bglt aux_1670;
		 {	/* Ast/remove.scm 299 */
		    obj_t aux_1671;
		    aux_1671 =
		       CAR(node__221_27);
		    aux_1670 =
		       (node_bglt) (aux_1671);
		 }
		 arg1549_789 =
		    node_remove__162_ast_remove(aux_1670);
	      }
	      {		/* ./Ieee/pair-list.scm 5890 */
		 obj_t aux_1675;
		 aux_1675 =
		    (obj_t) (arg1549_789);
		 SET_CAR(node__221_27, aux_1675);
	      }
	   }
	   {
	      obj_t node__221_1678;
	      node__221_1678 =
		 CDR(node__221_27);
	      node__221_27 = node__221_1678;
	      goto node_remove___45_ast_remove;
	   }
	}
   }
}



/* method-init */
obj_t 
method_init_76_ast_remove()
{
   AN_OBJECT;
   {	/* Ast/remove.scm 16 */
      add_generic__110___object(node_remove__env_197_ast_remove, node_remove__default1443_env_112_ast_remove);
      add_inlined_method__244___object(node_remove__env_197_ast_remove, atom_ast_node, ((long) 0));
      add_inlined_method__244___object(node_remove__env_197_ast_remove, var_ast_node, ((long) 1));
      add_inlined_method__244___object(node_remove__env_197_ast_remove, kwote_ast_node, ((long) 2));
      add_inlined_method__244___object(node_remove__env_197_ast_remove, sequence_ast_node, ((long) 3));
      add_inlined_method__244___object(node_remove__env_197_ast_remove, app_ast_node, ((long) 4));
      add_inlined_method__244___object(node_remove__env_197_ast_remove, app_ly_162_ast_node, ((long) 5));
      add_inlined_method__244___object(node_remove__env_197_ast_remove, funcall_ast_node, ((long) 6));
      add_inlined_method__244___object(node_remove__env_197_ast_remove, pragma_ast_node, ((long) 7));
      add_inlined_method__244___object(node_remove__env_197_ast_remove, cast_ast_node, ((long) 8));
      add_inlined_method__244___object(node_remove__env_197_ast_remove, setq_ast_node, ((long) 9));
      add_inlined_method__244___object(node_remove__env_197_ast_remove, conditional_ast_node, ((long) 10));
      add_inlined_method__244___object(node_remove__env_197_ast_remove, fail_ast_node, ((long) 11));
      add_inlined_method__244___object(node_remove__env_197_ast_remove, select_ast_node, ((long) 12));
      add_inlined_method__244___object(node_remove__env_197_ast_remove, make_box_202_ast_node, ((long) 13));
      add_inlined_method__244___object(node_remove__env_197_ast_remove, box_ref_242_ast_node, ((long) 14));
      add_inlined_method__244___object(node_remove__env_197_ast_remove, box_set__221_ast_node, ((long) 15));
      add_inlined_method__244___object(node_remove__env_197_ast_remove, let_fun_218_ast_node, ((long) 16));
      add_inlined_method__244___object(node_remove__env_197_ast_remove, let_var_6_ast_node, ((long) 17));
      add_inlined_method__244___object(node_remove__env_197_ast_remove, set_ex_it_116_ast_node, ((long) 18));
      {		/* Ast/remove.scm 16 */
	 long aux_1700;
	 aux_1700 =
	    add_inlined_method__244___object(node_remove__env_197_ast_remove, jump_ex_it_184_ast_node, ((long) 19));
	 return
	    BINT(aux_1700);
      }
   }
}



/* node-remove! */
node_bglt 
node_remove__162_ast_remove(node_bglt node_5)
{
   AN_OBJECT;
   {	/* Ast/remove.scm 95 */
      {
	 obj_t method1627_1122;
	 obj_t class1632_1123;
	 {	/* Ast/remove.scm 95 */
	    obj_t arg1635_1120;
	    obj_t arg1636_1121;
	    {	/* Ast/remove.scm 95 */
	       object_bglt obj_1327;
	       obj_1327 =
		  (object_bglt) (node_5);
	       {	/* ./Llib/object.scm 2926 */
		  obj_t pre_method_105_1328;
		  pre_method_105_1328 =
		     PROCEDURE_REF(node_remove__env_197_ast_remove, ((long) 2));
		  if (
		     INTEGERP(pre_method_105_1328))
		    {	/* ./Llib/object.scm 2927 */
		       PROCEDURE_SET(node_remove__env_197_ast_remove, ((long) 2), BUNSPEC);
		       arg1635_1120 = pre_method_105_1328;
		    }
		  else
		    {	/* ./Llib/object.scm 2914 */
		       long obj_class_num_177_1333;
		       obj_class_num_177_1333 =
			  TYPE(obj_1327);
		       {	/* ./Llib/object.scm 2915 */
			  obj_t arg1176_1334;
			  arg1176_1334 =
			     PROCEDURE_REF(node_remove__env_197_ast_remove, ((long) 1));
			  {	/* ./Llib/object.scm 2738 */
			     long arg1177_1338;
			     {	/* ./Llib/object.scm 2738 */
				long arg1178_1339;
				arg1178_1339 =
				   OBJECT_TYPE;
				arg1177_1338 =
				   (obj_class_num_177_1333 - arg1178_1339);
			     }
			     arg1635_1120 =
				VECTOR_REF(arg1176_1334, arg1177_1338);
			  }
		       }
		    }
	       }
	    }
	    {	/* Ast/remove.scm 95 */
	       object_bglt object_1344;
	       object_1344 =
		  (object_bglt) (node_5);
	       {	/* ./Llib/object.scm 2695 */
		  long arg1179_1345;
		  {	/* ./Llib/object.scm 2695 */
		     long arg1180_1346;
		     long arg1181_1347;
		     arg1180_1346 =
			TYPE(object_1344);
		     arg1181_1347 =
			OBJECT_TYPE;
		     arg1179_1345 =
			(arg1180_1346 - arg1181_1347);
		  }
		  {	/* ./Llib/object.scm 2695 */
		     obj_t vector_1351;
		     vector_1351 = _classes__134___object;
		     arg1636_1121 =
			VECTOR_REF(vector_1351, arg1179_1345);
		  }
	       }
	    }
	    {	/* Ast/remove.scm 95 */
	       obj_t aux_1718;
	       method1627_1122 = arg1635_1120;
	       class1632_1123 = arg1636_1121;
	       {

		  if (
		     INTEGERP(method1627_1122))
		    {	/* Ast/remove.scm 95 */
		       switch (
			  (long) CINT(method1627_1122))
			 {
			 case ((long) 0):

			    {	/* Ast/remove.scm 95 */
			       atom_bglt aux_1721;
			       aux_1721 =
				  (atom_bglt) (node_5);
			       aux_1718 =
				  (obj_t) (aux_1721);
			    }
			    break;
			 case ((long) 1):

			    {	/* Ast/remove.scm 95 */
			       var_bglt aux_1724;
			       aux_1724 =
				  (var_bglt) (node_5);
			       aux_1718 =
				  (obj_t) (aux_1724);
			    }
			    break;
			 case ((long) 2):

			    {	/* Ast/remove.scm 95 */
			       kwote_bglt aux_1727;
			       aux_1727 =
				  (kwote_bglt) (node_5);
			       aux_1718 =
				  (obj_t) (aux_1727);
			    }
			    break;
			 case ((long) 3):

			    {	/* Ast/remove.scm 95 */
			       sequence_bglt node_1132;
			       node_1132 =
				  (sequence_bglt) (node_5);
			       node_remove___45_ast_remove(
				  (((sequence_bglt) CREF(node_1132))->nodes));
			       aux_1718 =
				  (obj_t) (node_1132);
			    }
			    break;
			 case ((long) 4):

			    {	/* Ast/remove.scm 95 */
			       app_bglt node_1134;
			       node_1134 =
				  (app_bglt) (node_5);
			       {	/* Ast/remove.scm 126 */
				  node_bglt arg1640_1135;
				  {	/* Ast/remove.scm 126 */
				     node_bglt aux_1735;
				     {	/* Ast/remove.scm 126 */
					var_bglt aux_1736;
					aux_1736 =
					   (((app_bglt) CREF(node_1134))->fun);
					aux_1735 =
					   (node_bglt) (aux_1736);
				     }
				     arg1640_1135 =
					node_remove__162_ast_remove(aux_1735);
				  }
				  {	/* Ast/remove.scm 126 */
				     var_bglt val1245_1356;
				     val1245_1356 =
					(var_bglt) (arg1640_1135);
				     ((((app_bglt) CREF(node_1134))->fun) = ((var_bglt) val1245_1356), BUNSPEC);
				  }
			       }
			       node_remove___45_ast_remove(
				  (((app_bglt) CREF(node_1134))->args));
			       aux_1718 =
				  (obj_t) (node_1134);
			    }
			    break;
			 case ((long) 5):

			    {	/* Ast/remove.scm 95 */
			       app_ly_162_bglt node_1138;
			       node_1138 =
				  (app_ly_162_bglt) (node_5);
			       {	/* Ast/remove.scm 134 */
				  node_bglt arg1643_1139;
				  arg1643_1139 =
				     node_remove__162_ast_remove(
				     (((app_ly_162_bglt) CREF(node_1138))->fun));
				  ((((app_ly_162_bglt) CREF(node_1138))->fun) = ((node_bglt) arg1643_1139), BUNSPEC);
			       }
			       {	/* Ast/remove.scm 135 */
				  node_bglt arg1646_1141;
				  arg1646_1141 =
				     node_remove__162_ast_remove(
				     (((app_ly_162_bglt) CREF(node_1138))->arg));
				  ((((app_ly_162_bglt) CREF(node_1138))->arg) = ((node_bglt) arg1646_1141), BUNSPEC);
			       }
			       aux_1718 =
				  (obj_t) (node_1138);
			    }
			    break;
			 case ((long) 6):

			    {	/* Ast/remove.scm 95 */
			       funcall_bglt node_1143;
			       node_1143 =
				  (funcall_bglt) (node_5);
			       {	/* Ast/remove.scm 142 */
				  node_bglt arg1648_1144;
				  arg1648_1144 =
				     node_remove__162_ast_remove(
				     (((funcall_bglt) CREF(node_1143))->fun));
				  ((((funcall_bglt) CREF(node_1143))->fun) = ((node_bglt) arg1648_1144), BUNSPEC);
			       }
			       node_remove___45_ast_remove(
				  (((funcall_bglt) CREF(node_1143))->args));
			       aux_1718 =
				  (obj_t) (node_1143);
			    }
			    break;
			 case ((long) 7):

			    {	/* Ast/remove.scm 95 */
			       pragma_bglt node_1147;
			       node_1147 =
				  (pragma_bglt) (node_5);
			       node_remove___45_ast_remove(
				  (((pragma_bglt) CREF(node_1147))->args));
			       aux_1718 =
				  (obj_t) (node_1147);
			    }
			    break;
			 case ((long) 8):

			    {	/* Ast/remove.scm 95 */
			       cast_bglt node_1149;
			       node_1149 =
				  (cast_bglt) (node_5);
			       node_remove__162_ast_remove(
				  (((cast_bglt) CREF(node_1149))->arg));
			       aux_1718 =
				  (obj_t) (node_1149);
			    }
			    break;
			 case ((long) 9):

			    {	/* Ast/remove.scm 95 */
			       setq_bglt node_1151;
			       node_1151 =
				  (setq_bglt) (node_5);
			       {	/* Ast/remove.scm 164 */
				  node_bglt arg1653_1152;
				  arg1653_1152 =
				     node_remove__162_ast_remove(
				     (((setq_bglt) CREF(node_1151))->value));
				  ((((setq_bglt) CREF(node_1151))->value) = ((node_bglt) arg1653_1152), BUNSPEC);
			       }
			       aux_1718 =
				  (obj_t) (node_1151);
			    }
			    break;
			 case ((long) 10):

			    {	/* Ast/remove.scm 95 */
			       conditional_bglt node_1154;
			       node_1154 =
				  (conditional_bglt) (node_5);
			       {	/* Ast/remove.scm 171 */
				  node_bglt arg1655_1155;
				  arg1655_1155 =
				     node_remove__162_ast_remove(
				     (((conditional_bglt) CREF(node_1154))->test));
				  ((((conditional_bglt) CREF(node_1154))->test) = ((node_bglt) arg1655_1155), BUNSPEC);
			       }
			       {	/* Ast/remove.scm 172 */
				  node_bglt arg1657_1157;
				  arg1657_1157 =
				     node_remove__162_ast_remove(
				     (((conditional_bglt) CREF(node_1154))->true));
				  ((((conditional_bglt) CREF(node_1154))->true) = ((node_bglt) arg1657_1157), BUNSPEC);
			       }
			       {	/* Ast/remove.scm 173 */
				  node_bglt arg1659_1159;
				  arg1659_1159 =
				     node_remove__162_ast_remove(
				     (((conditional_bglt) CREF(node_1154))->false));
				  ((((conditional_bglt) CREF(node_1154))->false) = ((node_bglt) arg1659_1159), BUNSPEC);
			       }
			       aux_1718 =
				  (obj_t) (node_1154);
			    }
			    break;
			 case ((long) 11):

			    {	/* Ast/remove.scm 95 */
			       fail_bglt node_1161;
			       node_1161 =
				  (fail_bglt) (node_5);
			       {	/* Ast/remove.scm 180 */
				  node_bglt arg1661_1162;
				  arg1661_1162 =
				     node_remove__162_ast_remove(
				     (((fail_bglt) CREF(node_1161))->proc));
				  ((((fail_bglt) CREF(node_1161))->proc) = ((node_bglt) arg1661_1162), BUNSPEC);
			       }
			       {	/* Ast/remove.scm 181 */
				  node_bglt arg1663_1164;
				  arg1663_1164 =
				     node_remove__162_ast_remove(
				     (((fail_bglt) CREF(node_1161))->msg));
				  ((((fail_bglt) CREF(node_1161))->msg) = ((node_bglt) arg1663_1164), BUNSPEC);
			       }
			       {	/* Ast/remove.scm 182 */
				  node_bglt arg1665_1166;
				  arg1665_1166 =
				     node_remove__162_ast_remove(
				     (((fail_bglt) CREF(node_1161))->obj));
				  ((((fail_bglt) CREF(node_1161))->obj) = ((node_bglt) arg1665_1166), BUNSPEC);
			       }
			       aux_1718 =
				  (obj_t) (node_1161);
			    }
			    break;
			 case ((long) 12):

			    {	/* Ast/remove.scm 95 */
			       select_bglt node_1168;
			       node_1168 =
				  (select_bglt) (node_5);
			       {	/* Ast/remove.scm 189 */
				  node_bglt arg1667_1169;
				  arg1667_1169 =
				     node_remove__162_ast_remove(
				     (((select_bglt) CREF(node_1168))->test));
				  ((((select_bglt) CREF(node_1168))->test) = ((node_bglt) arg1667_1169), BUNSPEC);
			       }
			       {
				  obj_t l1437_1171;
				  l1437_1171 =
				     (((select_bglt) CREF(node_1168))->clauses);
				lname1438_1172:
				  if (
				     PAIRP(l1437_1171))
				    {	/* Ast/remove.scm 190 */
				       {	/* Ast/remove.scm 191 */
					  obj_t clause_1175;
					  clause_1175 =
					     CAR(l1437_1171);
					  {	/* Ast/remove.scm 191 */
					     node_bglt arg1672_1176;
					     {	/* Ast/remove.scm 191 */
						node_bglt aux_1802;
						{	/* Ast/remove.scm 191 */
						   obj_t aux_1803;
						   aux_1803 =
						      CDR(clause_1175);
						   aux_1802 =
						      (node_bglt) (aux_1803);
						}
						arg1672_1176 =
						   node_remove__162_ast_remove(aux_1802);
					     }
					     {	/* ./Ieee/pair-list.scm 5896 */
						obj_t aux_1807;
						aux_1807 =
						   (obj_t) (arg1672_1176);
						SET_CDR(clause_1175, aux_1807);
					     }
					  }
				       }
				       {
					  obj_t l1437_1810;
					  l1437_1810 =
					     CDR(l1437_1171);
					  l1437_1171 = l1437_1810;
					  goto lname1438_1172;
				       }
				    }
				  else
				    {	/* Ast/remove.scm 190 */
				       ((bool_t) 1);
				    }
			       }
			       aux_1718 =
				  (obj_t) (node_1168);
			    }
			    break;
			 case ((long) 13):

			    {	/* Ast/remove.scm 95 */
			       make_box_202_bglt node_1179;
			       node_1179 =
				  (make_box_202_bglt) (node_5);
			       {	/* Ast/remove.scm 199 */
				  node_bglt arg1675_1180;
				  arg1675_1180 =
				     node_remove__162_ast_remove(
				     (((make_box_202_bglt) CREF(node_1179))->value));
				  ((((make_box_202_bglt) CREF(node_1179))->value) = ((node_bglt) arg1675_1180), BUNSPEC);
			       }
			       aux_1718 =
				  (obj_t) (node_1179);
			    }
			    break;
			 case ((long) 14):

			    {	/* Ast/remove.scm 95 */
			       box_ref_242_bglt node_1182;
			       node_1182 =
				  (box_ref_242_bglt) (node_5);
			       {	/* Ast/remove.scm 206 */
				  node_bglt arg1677_1183;
				  {	/* Ast/remove.scm 206 */
				     node_bglt aux_1820;
				     {	/* Ast/remove.scm 206 */
					var_bglt aux_1821;
					aux_1821 =
					   (((box_ref_242_bglt) CREF(node_1182))->var);
					aux_1820 =
					   (node_bglt) (aux_1821);
				     }
				     arg1677_1183 =
					node_remove__162_ast_remove(aux_1820);
				  }
				  {	/* Ast/remove.scm 206 */
				     var_bglt val1418_1406;
				     val1418_1406 =
					(var_bglt) (arg1677_1183);
				     ((((box_ref_242_bglt) CREF(node_1182))->var) = ((var_bglt) val1418_1406), BUNSPEC);
				  }
			       }
			       aux_1718 =
				  (obj_t) (node_1182);
			    }
			    break;
			 case ((long) 15):

			    {	/* Ast/remove.scm 95 */
			       box_set__221_bglt node_1185;
			       node_1185 =
				  (box_set__221_bglt) (node_5);
			       {	/* Ast/remove.scm 213 */
				  node_bglt arg1679_1186;
				  {	/* Ast/remove.scm 213 */
				     node_bglt aux_1829;
				     {	/* Ast/remove.scm 213 */
					var_bglt aux_1830;
					aux_1830 =
					   (((box_set__221_bglt) CREF(node_1185))->var);
					aux_1829 =
					   (node_bglt) (aux_1830);
				     }
				     arg1679_1186 =
					node_remove__162_ast_remove(aux_1829);
				  }
				  {	/* Ast/remove.scm 213 */
				     var_bglt val1428_1409;
				     val1428_1409 =
					(var_bglt) (arg1679_1186);
				     ((((box_set__221_bglt) CREF(node_1185))->var) = ((var_bglt) val1428_1409), BUNSPEC);
				  }
			       }
			       {	/* Ast/remove.scm 214 */
				  node_bglt arg1681_1188;
				  arg1681_1188 =
				     node_remove__162_ast_remove(
				     (((box_set__221_bglt) CREF(node_1185))->value));
				  ((((box_set__221_bglt) CREF(node_1185))->value) = ((node_bglt) arg1681_1188), BUNSPEC);
			       }
			       aux_1718 =
				  (obj_t) (node_1185);
			    }
			    break;
			 case ((long) 16):

			    {	/* Ast/remove.scm 221 */
			       let_fun_218_bglt node_1190;
			       node_1190 =
				  (let_fun_218_bglt) (node_5);
			       {	/* Ast/remove.scm 222 */
				  node_bglt arg1683_1192;
				  arg1683_1192 =
				     node_remove__162_ast_remove(
				     (((let_fun_218_bglt) CREF(node_1190))->body));
				  ((((let_fun_218_bglt) CREF(node_1190))->body) = ((node_bglt) arg1683_1192), BUNSPEC);
			       }
			       {
				  obj_t old_locals_255_1194;
				  obj_t new_locals_179_1195;
				  old_locals_255_1194 =
				     (((let_fun_218_bglt) CREF(node_1190))->locals);
				  new_locals_179_1195 = BNIL;
				loop_1196:
				  if (
				     NULLP(old_locals_255_1194))
				    {	/* Ast/remove.scm 225 */
				       if (
					  NULLP(new_locals_179_1195))
					 {	/* ./Ast/node.scm 871 */
					    node_bglt aux_1848;
					    aux_1848 =
					       (((let_fun_218_bglt) CREF(node_1190))->body);
					    aux_1718 =
					       (obj_t) (aux_1848);
					 }
				       else
					 {	/* Ast/remove.scm 226 */
					    {	/* Ast/remove.scm 229 */
					       obj_t arg1689_1201;
					       arg1689_1201 =
						  reverse__39___r4_pairs_and_lists_6_3(new_locals_179_1195);
					       ((((let_fun_218_bglt) CREF(node_1190))->locals) = ((obj_t) arg1689_1201), BUNSPEC);
					    }
					    aux_1718 =
					       (obj_t) (node_1190);
					 }
				    }
				  else
				    {	/* Ast/remove.scm 231 */
				       obj_t local_1202;
				       local_1202 =
					  CAR(old_locals_255_1194);
				       {	/* Ast/remove.scm 232 */
					  bool_t test_1855;
					  {	/* ./Ieee/fixnum.scm 7127 */
					     long aux_1856;
					     {	/* Ast/remove.scm 232 */
						local_bglt obj_1423;
						obj_1423 =
						   (local_bglt) (local_1202);
						aux_1856 =
						   (((local_bglt) CREF(obj_1423))->occurrence);
					     }
					     test_1855 =
						(aux_1856 <= ((long) 0));
					  }
					  if (test_1855)
					    {
					       obj_t old_locals_255_1860;
					       old_locals_255_1860 =
						  CDR(old_locals_255_1194);
					       old_locals_255_1194 = old_locals_255_1860;
					       goto loop_1196;
					    }
					  else
					    {	/* Ast/remove.scm 234 */
					       value_bglt sfun_1205;
					       {	/* Ast/remove.scm 234 */
						  local_bglt obj_1427;
						  obj_1427 =
						     (local_bglt) (local_1202);
						  sfun_1205 =
						     (((local_bglt) CREF(obj_1427))->value);
					       }
					       {	/* Ast/remove.scm 235 */
						  node_bglt arg1692_1206;
						  {	/* Ast/remove.scm 235 */
						     node_bglt aux_1864;
						     {	/* Ast/remove.scm 235 */
							obj_t aux_1865;
							{	/* Ast/remove.scm 235 */
							   sfun_bglt obj_1428;
							   obj_1428 =
							      (sfun_bglt) (sfun_1205);
							   aux_1865 =
							      (((sfun_bglt) CREF(obj_1428))->body);
							}
							aux_1864 =
							   (node_bglt) (aux_1865);
						     }
						     arg1692_1206 =
							node_remove__162_ast_remove(aux_1864);
						  }
						  {	/* Ast/remove.scm 235 */
						     sfun_bglt obj_1429;
						     obj_t val1123_1430;
						     obj_1429 =
							(sfun_bglt) (sfun_1205);
						     val1123_1430 =
							(obj_t) (arg1692_1206);
						     ((((sfun_bglt) CREF(obj_1429))->body) = ((obj_t) val1123_1430), BUNSPEC);
						  }
					       }
					       {	/* Ast/remove.scm 236 */
						  obj_t arg1694_1208;
						  obj_t arg1695_1209;
						  arg1694_1208 =
						     CDR(old_locals_255_1194);
						  arg1695_1209 =
						     MAKE_PAIR(local_1202, new_locals_179_1195);
						  {
						     obj_t new_locals_179_1876;
						     obj_t old_locals_255_1875;
						     old_locals_255_1875 = arg1694_1208;
						     new_locals_179_1876 = arg1695_1209;
						     new_locals_179_1195 = new_locals_179_1876;
						     old_locals_255_1194 = old_locals_255_1875;
						     goto loop_1196;
						  }
					       }
					    }
				       }
				    }
			       }
			    }
			    break;
			 case ((long) 17):

			    {	/* Ast/remove.scm 242 */
			       let_var_6_bglt node_1212;
			       node_1212 =
				  (let_var_6_bglt) (node_5);
			       {	/* Ast/remove.scm 243 */
				  node_bglt arg1698_1214;
				  arg1698_1214 =
				     node_remove__162_ast_remove(
				     (((let_var_6_bglt) CREF(node_1212))->body));
				  ((((let_var_6_bglt) CREF(node_1212))->body) = ((node_bglt) arg1698_1214), BUNSPEC);
			       }
			       {
				  obj_t old_bindings_65_1216;
				  obj_t new_bindings_102_1217;
				  old_bindings_65_1216 =
				     (((let_var_6_bglt) CREF(node_1212))->bindings);
				  new_bindings_102_1217 = BNIL;
				loop_1218:
				  if (
				     NULLP(old_bindings_65_1216))
				    {	/* Ast/remove.scm 246 */
				       if (
					  NULLP(new_bindings_102_1217))
					 {	/* Ast/remove.scm 247 */
					    if (
					       (((let_var_6_bglt) CREF(node_1212))->removable__42))
					      {		/* ./Ast/node.scm 878 */
						 node_bglt aux_1888;
						 aux_1888 =
						    (((let_var_6_bglt) CREF(node_1212))->body);
						 aux_1718 =
						    (obj_t) (aux_1888);
					      }
					    else
					      {		/* Ast/remove.scm 248 */
						 ((((let_var_6_bglt) CREF(node_1212))->bindings) = ((obj_t) BNIL), BUNSPEC);
						 aux_1718 =
						    (obj_t) (node_1212);
					      }
					 }
				       else
					 {	/* Ast/remove.scm 247 */
					    {	/* Ast/remove.scm 254 */
					       obj_t arg1705_1224;
					       arg1705_1224 =
						  reverse__39___r4_pairs_and_lists_6_3(new_bindings_102_1217);
					       ((((let_var_6_bglt) CREF(node_1212))->bindings) = ((obj_t) arg1705_1224), BUNSPEC);
					    }
					    aux_1718 =
					       (obj_t) (node_1212);
					 }
				    }
				  else
				    {	/* Ast/remove.scm 256 */
				       obj_t binding_1225;
				       binding_1225 =
					  CAR(old_bindings_65_1216);
				       {	/* Ast/remove.scm 256 */
					  obj_t var_1226;
					  var_1226 =
					     CAR(binding_1225);
					  {	/* Ast/remove.scm 257 */
					     node_bglt val_1227;
					     {	/* Ast/remove.scm 258 */
						node_bglt aux_1898;
						{	/* Ast/remove.scm 258 */
						   obj_t aux_1899;
						   aux_1899 =
						      CDR(binding_1225);
						   aux_1898 =
						      (node_bglt) (aux_1899);
						}
						val_1227 =
						   node_remove__162_ast_remove(aux_1898);
					     }
					     {	/* Ast/remove.scm 258 */

						{	/* Ast/remove.scm 259 */
						   bool_t test1706_1228;
						   {	/* Ast/remove.scm 259 */
						      bool_t test_1903;
						      {		/* ./Ieee/fixnum.scm 7127 */
							 long aux_1904;
							 {	/* Ast/remove.scm 259 */
							    local_bglt obj_1449;
							    obj_1449 =
							       (local_bglt) (var_1226);
							    aux_1904 =
							       (((local_bglt) CREF(obj_1449))->occurrence);
							 }
							 test_1903 =
							    (aux_1904 <= ((long) 0));
						      }
						      if (test_1903)
							{	/* Ast/remove.scm 260 */
							   bool_t test1716_1238;
							   test1716_1238 =
							      side_effect__165_effect_effect(val_1227);
							   if (test1716_1238)
							     {	/* Ast/remove.scm 260 */
								test1706_1228 = ((bool_t) 0);
							     }
							   else
							     {	/* Ast/remove.scm 261 */
								bool_t _ortest_1441_1239;
								{	/* Ast/remove.scm 261 */
								   bool_t test_1910;
								   {	/* Ast/remove.scm 261 */
								      local_bglt obj_1452;
								      obj_1452 =
									 (local_bglt) (var_1226);
								      test_1910 =
									 (((local_bglt) CREF(obj_1452))->user__32);
								   }
								   if (test_1910)
								     {	/* Ast/remove.scm 261 */
									_ortest_1441_1239 = ((bool_t) 0);
								     }
								   else
								     {	/* Ast/remove.scm 261 */
									_ortest_1441_1239 = ((bool_t) 1);
								     }
								}
								if (_ortest_1441_1239)
								  {	/* Ast/remove.scm 261 */
								     test1706_1228 = _ortest_1441_1239;
								  }
								else
								  {	/* Ast/remove.scm 262 */
								     long n1_1453;
								     n1_1453 =
									(long) CINT(_bdb_debug__1_engine_param);
								     test1706_1228 =
									(n1_1453 == ((long) 0));
								  }
							     }
							}
						      else
							{	/* Ast/remove.scm 259 */
							   test1706_1228 = ((bool_t) 0);
							}
						   }
						   if (test1706_1228)
						     {	/* Ast/remove.scm 259 */
							{	/* Ast/remove.scm 264 */
							   bool_t test1707_1229;
							   test1707_1229 =
							      is_a__118___object(
							      (obj_t) (val_1227), var_ast_node);
							   if (test1707_1229)
							     {	/* Ast/remove.scm 265 */
								variable_bglt v_1230;
								{	/* Ast/remove.scm 265 */
								   var_bglt obj_1456;
								   obj_1456 =
								      (var_bglt) (val_1227);
								   v_1230 =
								      (((var_bglt) CREF(obj_1456))->variable);
								}
								{	/* Ast/remove.scm 268 */
								   long arg1708_1231;
								   {	/* ./Ieee/fixnum.scm 7199 */
								      long aux_1922;
								      aux_1922 =
									 (((variable_bglt) CREF(v_1230))->occurrence);
								      arg1708_1231 =
									 (aux_1922 - ((long) 1));
								   }
								   ((((variable_bglt) CREF(v_1230))->occurrence) = ((long) arg1708_1231), BUNSPEC);
								}
							     }
							   else
							     {	/* Ast/remove.scm 264 */
								BUNSPEC;
							     }
							}
							{
							   obj_t old_bindings_65_1926;
							   old_bindings_65_1926 =
							      CDR(old_bindings_65_1216);
							   old_bindings_65_1216 = old_bindings_65_1926;
							   goto loop_1218;
							}
						     }
						   else
						     {	/* Ast/remove.scm 259 */
							{	/* ./Ieee/pair-list.scm 5896 */
							   obj_t aux_1928;
							   aux_1928 =
							      (obj_t) (val_1227);
							   SET_CDR(binding_1225, aux_1928);
							}
							{	/* Ast/remove.scm 272 */
							   obj_t arg1713_1235;
							   obj_t arg1714_1236;
							   arg1713_1235 =
							      CDR(old_bindings_65_1216);
							   arg1714_1236 =
							      MAKE_PAIR(binding_1225, new_bindings_102_1217);
							   {
							      obj_t new_bindings_102_1934;
							      obj_t old_bindings_65_1933;
							      old_bindings_65_1933 = arg1713_1235;
							      new_bindings_102_1934 = arg1714_1236;
							      new_bindings_102_1217 = new_bindings_102_1934;
							      old_bindings_65_1216 = old_bindings_65_1933;
							      goto loop_1218;
							   }
							}
						     }
						}
					     }
					  }
				       }
				    }
			       }
			    }
			    break;
			 case ((long) 18):

			    {	/* Ast/remove.scm 95 */
			       set_ex_it_116_bglt node_1244;
			       node_1244 =
				  (set_ex_it_116_bglt) (node_5);
			       {	/* Ast/remove.scm 279 */
				  node_bglt arg1721_1245;
				  arg1721_1245 =
				     node_remove__162_ast_remove(
				     (((set_ex_it_116_bglt) CREF(node_1244))->body));
				  ((((set_ex_it_116_bglt) CREF(node_1244))->body) = ((node_bglt) arg1721_1245), BUNSPEC);
			       }
			       {	/* Ast/remove.scm 280 */
				  bool_t test_1940;
				  {	/* ./Ieee/fixnum.scm 7127 */
				     long aux_1941;
				     {	/* Ast/remove.scm 280 */
					local_bglt obj_1473;
					{	/* Ast/remove.scm 280 */
					   variable_bglt aux_1942;
					   {	/* Ast/remove.scm 280 */
					      var_bglt arg1727_1251;
					      arg1727_1251 =
						 (((set_ex_it_116_bglt) CREF(node_1244))->var);
					      aux_1942 =
						 (((var_bglt) CREF(arg1727_1251))->variable);
					   }
					   obj_1473 =
					      (local_bglt) (aux_1942);
					}
					aux_1941 =
					   (((local_bglt) CREF(obj_1473))->occurrence);
				     }
				     test_1940 =
					(aux_1941 <= ((long) 0));
				  }
				  if (test_1940)
				    {	/* ./Ast/node.scm 887 */
				       node_bglt aux_1948;
				       aux_1948 =
					  (((set_ex_it_116_bglt) CREF(node_1244))->body);
				       aux_1718 =
					  (obj_t) (aux_1948);
				    }
				  else
				    {	/* Ast/remove.scm 280 */
				       aux_1718 =
					  (obj_t) (node_1244)
					  ;
				    }
			       }
			    }
			    break;
			 case ((long) 19):

			    {	/* Ast/remove.scm 95 */
			       jump_ex_it_184_bglt node_1252;
			       node_1252 =
				  (jump_ex_it_184_bglt) (node_5);
			       {	/* Ast/remove.scm 288 */
				  node_bglt arg1728_1253;
				  arg1728_1253 =
				     node_remove__162_ast_remove(
				     (((jump_ex_it_184_bglt) CREF(node_1252))->exit));
				  ((((jump_ex_it_184_bglt) CREF(node_1252))->exit) = ((node_bglt) arg1728_1253), BUNSPEC);
			       }
			       {	/* Ast/remove.scm 289 */
				  node_bglt arg1730_1255;
				  arg1730_1255 =
				     node_remove__162_ast_remove(
				     (((jump_ex_it_184_bglt) CREF(node_1252))->value));
				  ((((jump_ex_it_184_bglt) CREF(node_1252))->value) = ((node_bglt) arg1730_1255), BUNSPEC);
			       }
			       aux_1718 =
				  (obj_t) (node_1252);
			    }
			    break;
			 default:
			  case_else1633_1126:
			    if (
			       PROCEDUREP(method1627_1122))
			      {		/* Ast/remove.scm 95 */
				 aux_1718 =
				    PROCEDURE_ENTRY(method1627_1122) (method1627_1122,
				    (obj_t) (node_5), BEOA)
				    ;
			      }
			    else
			      {		/* Ast/remove.scm 95 */
				 obj_t fun1626_1118;
				 fun1626_1118 =
				    PROCEDURE_REF(node_remove__env_197_ast_remove, ((long) 0));
				 aux_1718 =
				    PROCEDURE_ENTRY(fun1626_1118) (fun1626_1118,
				    (obj_t) (node_5), BEOA);
			      }
			 }
		    }
		  else
		    {	/* Ast/remove.scm 95 */
		       goto case_else1633_1126;
		    }
	       }
	       return
		  (node_bglt) (aux_1718);
	    }
	 }
      }
   }
}



/* _node-remove!1739 */
obj_t 
_node_remove_1739_64_ast_remove(obj_t env_1494, obj_t node_1495)
{
   AN_OBJECT;
   {	/* Ast/remove.scm 95 */
      {		/* Ast/remove.scm 95 */
	 node_bglt aux_1972;
	 aux_1972 =
	    node_remove__162_ast_remove(
	    (node_bglt) (node_1495));
	 return
	    (obj_t) (aux_1972);
      }
   }
}



/* node-remove!-default1443 */
node_bglt 
node_remove__default1443_179_ast_remove(node_bglt node_6)
{
   AN_OBJECT;
   {	/* Ast/remove.scm 16 */
      FAILURE(
	 CNST_TABLE_REF(((long) 5)), string1746_ast_remove,
	 (obj_t) (node_6));
   }
}



/* _node-remove!-default1443 */
obj_t 
_node_remove__default1443_253_ast_remove(obj_t env_1496, obj_t node_1497)
{
   AN_OBJECT;
   {	/* Ast/remove.scm 16 */
      {		/* Ast/remove.scm 16 */
	 node_bglt aux_1979;
	 aux_1979 =
	    node_remove__default1443_179_ast_remove(
	    (node_bglt) (node_1497));
	 return
	    (obj_t) (aux_1979);
      }
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_ast_remove()
{
   AN_OBJECT;
   {	/* Ast/remove.scm 16 */
      module_initialization_70_type_type(((long) 0), "AST_REMOVE");
      module_initialization_70_ast_var(((long) 0), "AST_REMOVE");
      module_initialization_70_ast_node(((long) 0), "AST_REMOVE");
      module_initialization_70_tools_error(((long) 0), "AST_REMOVE");
      module_initialization_70_tools_speek(((long) 0), "AST_REMOVE");
      module_initialization_70_tools_shape(((long) 0), "AST_REMOVE");
      module_initialization_70_effect_effect(((long) 0), "AST_REMOVE");
      module_initialization_70_engine_param(((long) 0), "AST_REMOVE");
      return
	 module_initialization_70_ast_occur(((long) 0), "AST_REMOVE");
   }
}
