/*===========================================================================*/
/*   (Ast/shrinkify.scm)                                                     */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;


static obj_t method_init_76_ast_shrinkify();
extern obj_t make_box_202_ast_node;
extern obj_t funcall_ast_node;
static bool_t shrink_node___235_ast_shrinkify(obj_t);
extern long add_inlined_method__244___object(obj_t, obj_t, long);
extern obj_t fail_ast_node;
static obj_t _shrink_node__default1465_197_ast_shrinkify(obj_t, obj_t);
extern obj_t box_ref_242_ast_node;
static obj_t shrink_node__211_ast_shrinkify(node_bglt);
extern obj_t sequence_ast_node;
extern obj_t let_var_6_ast_node;
extern obj_t var_ast_node;
extern obj_t pragma_ast_node;
static obj_t _shrink_variable__92_ast_shrinkify(obj_t, obj_t);
extern obj_t set_ex_it_116_ast_node;
extern obj_t shrinkify__187_ast_shrinkify(obj_t);
static obj_t shrink_node__default1465_7_ast_shrinkify(node_bglt);
extern obj_t module_initialization_70_ast_shrinkify(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_ast_env(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
static obj_t shrink_variable__88_ast_shrinkify(variable_bglt);
extern long class_num_218___object(obj_t);
static obj_t _shrink_node__49_ast_shrinkify(obj_t, obj_t);
extern obj_t let_fun_218_ast_node;
static obj_t imported_modules_init_94_ast_shrinkify();
extern obj_t app_ly_162_ast_node;
extern obj_t add_generic__110___object(obj_t, obj_t);
extern obj_t app_ast_node;
static obj_t shrink_variable__default1464_124_ast_shrinkify(variable_bglt);
static obj_t library_modules_init_112_ast_shrinkify();
static obj_t _shrinkify__38_ast_shrinkify(obj_t, obj_t);
extern obj_t atom_ast_node;
extern obj_t cast_ast_node;
static obj_t toplevel_init_63_ast_shrinkify();
extern obj_t jump_ex_it_184_ast_node;
extern obj_t open_input_string(obj_t);
extern obj_t kwote_ast_node;
extern obj_t setq_ast_node;
extern obj_t box_set__221_ast_node;
static obj_t _shrink_variable__default1464_19_ast_shrinkify(obj_t, obj_t);
extern obj_t for_each_global__88_ast_env(obj_t);
extern obj_t _classes__134___object;
extern obj_t select_ast_node;
extern obj_t read___reader(obj_t);
static obj_t require_initialization_114_ast_shrinkify = BUNSPEC;
extern obj_t conditional_ast_node;
extern obj_t class_super_145___object(obj_t);
static obj_t cnst_init_137_ast_shrinkify();
static obj_t __cnst[1];

DEFINE_STATIC_GENERIC(shrink_variable__env_168_ast_shrinkify, _shrink_variable__92_ast_shrinkify1732, _shrink_variable__92_ast_shrinkify, 0L, 1);
DEFINE_STATIC_GENERIC(shrink_node__env_219_ast_shrinkify, _shrink_node__49_ast_shrinkify1733, _shrink_node__49_ast_shrinkify, 0L, 1);
DEFINE_STATIC_PROCEDURE(shrink_variable__default1464_env_55_ast_shrinkify, _shrink_variable__default1464_19_ast_shrinkify1734, _shrink_variable__default1464_19_ast_shrinkify, 0L, 1);
DEFINE_STRING(string1727_ast_shrinkify, string1727_ast_shrinkify1735, "SHRINK-NODE!-DEFAULT1465 ", 25);
DEFINE_STRING(string1726_ast_shrinkify, string1726_ast_shrinkify1736, "No method for this object", 25);
DEFINE_EXPORT_PROCEDURE(shrinkify__env_151_ast_shrinkify, _shrinkify__38_ast_shrinkify1737, _shrinkify__38_ast_shrinkify, 0L, 1);
DEFINE_STATIC_PROCEDURE(shrink_node__default1465_env_183_ast_shrinkify, _shrink_node__default1465_197_ast_shrinkify1738, _shrink_node__default1465_197_ast_shrinkify, 0L, 1);



/* module-initialization */
obj_t 
module_initialization_70_ast_shrinkify(long checksum_1496, char *from_1497)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_ast_shrinkify))
	{
	   require_initialization_114_ast_shrinkify =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_ast_shrinkify();
	   cnst_init_137_ast_shrinkify();
	   imported_modules_init_94_ast_shrinkify();
	   method_init_76_ast_shrinkify();
	   toplevel_init_63_ast_shrinkify();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_ast_shrinkify()
{
   AN_OBJECT;
   {	/* Ast/shrinkify.scm 15 */
      module_initialization_70___object(((long) 0), "AST_SHRINKIFY");
      module_initialization_70___reader(((long) 0), "AST_SHRINKIFY");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_ast_shrinkify()
{
   AN_OBJECT;
   {	/* Ast/shrinkify.scm 15 */
      {		/* Ast/shrinkify.scm 15 */
	 obj_t cnst_port_138_1489;
	 cnst_port_138_1489 =
	    open_input_string(string1727_ast_shrinkify);
	 {
	    long i_1490;
	    i_1490 = ((long) 0);
	  loop_1491:
	    {	/* Ast/shrinkify.scm 15 */
	       bool_t test1728_1492;
	       test1728_1492 =
		  (i_1490 == ((long) -1));
	       if (test1728_1492)
		 {	/* Ast/shrinkify.scm 15 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Ast/shrinkify.scm 15 */
		    {	/* Ast/shrinkify.scm 15 */
		       obj_t arg1729_1493;
		       {	/* Ast/shrinkify.scm 15 */
			  obj_t list1730_1494;
			  list1730_1494 =
			     MAKE_PAIR(cnst_port_138_1489, BNIL);
			  arg1729_1493 =
			     read___reader(list1730_1494);
		       }
		       CNST_TABLE_SET(i_1490, arg1729_1493);
		    }
		    {	/* Ast/shrinkify.scm 15 */
		       int aux_1495;
		       {	/* Ast/shrinkify.scm 15 */
			  long aux_1514;
			  aux_1514 =
			     (i_1490 - ((long) 1));
			  aux_1495 =
			     (int) (aux_1514);
		       }
		       {
			  long i_1517;
			  i_1517 =
			     (long) (aux_1495);
			  i_1490 = i_1517;
			  goto loop_1491;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_ast_shrinkify()
{
   AN_OBJECT;
   {	/* Ast/shrinkify.scm 15 */
      return BUNSPEC;
   }
}



/* shrinkify! */
obj_t 
shrinkify__187_ast_shrinkify(obj_t globals_1)
{
   AN_OBJECT;
   {	/* Ast/shrinkify.scm 25 */
      for_each_global__88_ast_env(shrink_variable__env_168_ast_shrinkify);
      {
	 obj_t l1437_722;
	 l1437_722 = globals_1;
       lname1438_723:
	 if (
	    PAIRP(l1437_722))
	   {	/* Ast/shrinkify.scm 27 */
	      {		/* Ast/shrinkify.scm 28 */
		 obj_t global_725;
		 global_725 =
		    CAR(l1437_722);
		 {
		    obj_t l1439_727;
		    {	/* Ast/shrinkify.scm 29 */
		       sfun_bglt obj_1233;
		       {	/* Ast/shrinkify.scm 29 */
			  value_bglt aux_1532;
			  {	/* Ast/shrinkify.scm 28 */
			     global_bglt obj_1232;
			     obj_1232 =
				(global_bglt) (global_725);
			     aux_1532 =
				(((global_bglt) CREF(obj_1232))->value);
			  }
			  obj_1233 =
			     (sfun_bglt) (aux_1532);
		       }
		       l1439_727 =
			  (((sfun_bglt) CREF(obj_1233))->args);
		    }
		  lname1440_728:
		    if (
		       PAIRP(l1439_727))
		      {		/* Ast/shrinkify.scm 29 */
			 {	/* Ast/shrinkify.scm 29 */
			    variable_bglt aux_1525;
			    {	/* Ast/shrinkify.scm 29 */
			       obj_t aux_1526;
			       aux_1526 =
				  CAR(l1439_727);
			       aux_1525 =
				  (variable_bglt) (aux_1526);
			    }
			    shrink_variable__88_ast_shrinkify(aux_1525);
			 }
			 {
			    obj_t l1439_1530;
			    l1439_1530 =
			       CDR(l1439_727);
			    l1439_727 = l1439_1530;
			    goto lname1440_728;
			 }
		      }
		    else
		      {		/* Ast/shrinkify.scm 29 */
			 ((bool_t) 1);
		      }
		 }
		 {	/* Ast/shrinkify.scm 30 */
		    node_bglt aux_1537;
		    {	/* Ast/shrinkify.scm 30 */
		       obj_t aux_1538;
		       {	/* Ast/shrinkify.scm 30 */
			  sfun_bglt obj_1238;
			  {	/* Ast/shrinkify.scm 30 */
			     value_bglt aux_1539;
			     {	/* Ast/shrinkify.scm 30 */
				global_bglt obj_1237;
				obj_1237 =
				   (global_bglt) (global_725);
				aux_1539 =
				   (((global_bglt) CREF(obj_1237))->value);
			     }
			     obj_1238 =
				(sfun_bglt) (aux_1539);
			  }
			  aux_1538 =
			     (((sfun_bglt) CREF(obj_1238))->body);
		       }
		       aux_1537 =
			  (node_bglt) (aux_1538);
		    }
		    shrink_node__211_ast_shrinkify(aux_1537);
		 }
	      }
	      {
		 obj_t l1437_1546;
		 l1437_1546 =
		    CDR(l1437_722);
		 l1437_722 = l1437_1546;
		 goto lname1438_723;
	      }
	   }
	 else
	   {	/* Ast/shrinkify.scm 27 */
	      ((bool_t) 1);
	   }
      }
      return globals_1;
   }
}



/* _shrinkify! */
obj_t 
_shrinkify__38_ast_shrinkify(obj_t env_1478, obj_t globals_1479)
{
   AN_OBJECT;
   {	/* Ast/shrinkify.scm 25 */
      return
	 shrinkify__187_ast_shrinkify(globals_1479);
   }
}



/* shrink-node*! */
bool_t 
shrink_node___235_ast_shrinkify(obj_t node__221_26)
{
   AN_OBJECT;
   {	/* Ast/shrinkify.scm 221 */
      {
	 obj_t l1461_736;
	 l1461_736 = node__221_26;
       lname1462_737:
	 if (
	    PAIRP(l1461_736))
	   {	/* Ast/shrinkify.scm 222 */
	      {		/* Ast/shrinkify.scm 222 */
		 node_bglt aux_1551;
		 {	/* Ast/shrinkify.scm 222 */
		    obj_t aux_1552;
		    aux_1552 =
		       CAR(l1461_736);
		    aux_1551 =
		       (node_bglt) (aux_1552);
		 }
		 shrink_node__211_ast_shrinkify(aux_1551);
	      }
	      {
		 obj_t l1461_1556;
		 l1461_1556 =
		    CDR(l1461_736);
		 l1461_736 = l1461_1556;
		 goto lname1462_737;
	      }
	   }
	 else
	   {	/* Ast/shrinkify.scm 222 */
	      return ((bool_t) 1);
	   }
      }
   }
}



/* method-init */
obj_t 
method_init_76_ast_shrinkify()
{
   AN_OBJECT;
   {	/* Ast/shrinkify.scm 15 */
      add_generic__110___object(shrink_variable__env_168_ast_shrinkify, shrink_variable__default1464_env_55_ast_shrinkify);
      add_generic__110___object(shrink_node__env_219_ast_shrinkify, shrink_node__default1465_env_183_ast_shrinkify);
      add_inlined_method__244___object(shrink_node__env_219_ast_shrinkify, atom_ast_node, ((long) 0));
      add_inlined_method__244___object(shrink_node__env_219_ast_shrinkify, var_ast_node, ((long) 1));
      add_inlined_method__244___object(shrink_node__env_219_ast_shrinkify, kwote_ast_node, ((long) 2));
      add_inlined_method__244___object(shrink_node__env_219_ast_shrinkify, sequence_ast_node, ((long) 3));
      add_inlined_method__244___object(shrink_node__env_219_ast_shrinkify, app_ast_node, ((long) 4));
      add_inlined_method__244___object(shrink_node__env_219_ast_shrinkify, app_ly_162_ast_node, ((long) 5));
      add_inlined_method__244___object(shrink_node__env_219_ast_shrinkify, funcall_ast_node, ((long) 6));
      add_inlined_method__244___object(shrink_node__env_219_ast_shrinkify, pragma_ast_node, ((long) 7));
      add_inlined_method__244___object(shrink_node__env_219_ast_shrinkify, cast_ast_node, ((long) 8));
      add_inlined_method__244___object(shrink_node__env_219_ast_shrinkify, setq_ast_node, ((long) 9));
      add_inlined_method__244___object(shrink_node__env_219_ast_shrinkify, conditional_ast_node, ((long) 10));
      add_inlined_method__244___object(shrink_node__env_219_ast_shrinkify, fail_ast_node, ((long) 11));
      add_inlined_method__244___object(shrink_node__env_219_ast_shrinkify, select_ast_node, ((long) 12));
      add_inlined_method__244___object(shrink_node__env_219_ast_shrinkify, make_box_202_ast_node, ((long) 13));
      add_inlined_method__244___object(shrink_node__env_219_ast_shrinkify, box_ref_242_ast_node, ((long) 14));
      add_inlined_method__244___object(shrink_node__env_219_ast_shrinkify, box_set__221_ast_node, ((long) 15));
      add_inlined_method__244___object(shrink_node__env_219_ast_shrinkify, let_fun_218_ast_node, ((long) 16));
      add_inlined_method__244___object(shrink_node__env_219_ast_shrinkify, let_var_6_ast_node, ((long) 17));
      add_inlined_method__244___object(shrink_node__env_219_ast_shrinkify, set_ex_it_116_ast_node, ((long) 18));
      {		/* Ast/shrinkify.scm 15 */
	 long aux_1579;
	 aux_1579 =
	    add_inlined_method__244___object(shrink_node__env_219_ast_shrinkify, jump_ex_it_184_ast_node, ((long) 19));
	 return
	    BINT(aux_1579);
      }
   }
}



/* shrink-variable! */
obj_t 
shrink_variable__88_ast_shrinkify(variable_bglt variable_2)
{
   AN_OBJECT;
   {	/* Ast/shrinkify.scm 37 */
      {
	 obj_t method1701_1216;
	 obj_t class1706_1217;
	 {	/* Ast/shrinkify.scm 37 */
	    obj_t arg1707_1214;
	    obj_t arg1708_1215;
	    {	/* Ast/shrinkify.scm 37 */
	       object_bglt obj_1243;
	       obj_1243 =
		  (object_bglt) (variable_2);
	       {	/* ./Llib/object.scm 2926 */
		  obj_t pre_method_105_1244;
		  pre_method_105_1244 =
		     PROCEDURE_REF(shrink_variable__env_168_ast_shrinkify, ((long) 2));
		  if (
		     INTEGERP(pre_method_105_1244))
		    {	/* ./Llib/object.scm 2927 */
		       PROCEDURE_SET(shrink_variable__env_168_ast_shrinkify, ((long) 2), BUNSPEC);
		       arg1707_1214 = pre_method_105_1244;
		    }
		  else
		    {	/* ./Llib/object.scm 2914 */
		       long obj_class_num_177_1249;
		       obj_class_num_177_1249 =
			  TYPE(obj_1243);
		       {	/* ./Llib/object.scm 2915 */
			  obj_t arg1176_1250;
			  arg1176_1250 =
			     PROCEDURE_REF(shrink_variable__env_168_ast_shrinkify, ((long) 1));
			  {	/* ./Llib/object.scm 2738 */
			     long arg1177_1254;
			     {	/* ./Llib/object.scm 2738 */
				long arg1178_1255;
				arg1178_1255 =
				   OBJECT_TYPE;
				arg1177_1254 =
				   (obj_class_num_177_1249 - arg1178_1255);
			     }
			     arg1707_1214 =
				VECTOR_REF(arg1176_1250, arg1177_1254);
			  }
		       }
		    }
	       }
	    }
	    {	/* Ast/shrinkify.scm 37 */
	       object_bglt object_1260;
	       object_1260 =
		  (object_bglt) (variable_2);
	       {	/* ./Llib/object.scm 2695 */
		  long arg1179_1261;
		  {	/* ./Llib/object.scm 2695 */
		     long arg1180_1262;
		     long arg1181_1263;
		     arg1180_1262 =
			TYPE(object_1260);
		     arg1181_1263 =
			OBJECT_TYPE;
		     arg1179_1261 =
			(arg1180_1262 - arg1181_1263);
		  }
		  {	/* ./Llib/object.scm 2695 */
		     obj_t vector_1267;
		     vector_1267 = _classes__134___object;
		     arg1708_1215 =
			VECTOR_REF(vector_1267, arg1179_1261);
		  }
	       }
	    }
	    method1701_1216 = arg1707_1214;
	    class1706_1217 = arg1708_1215;
	    if (
	       PROCEDUREP(method1701_1216))
	      {		/* Ast/shrinkify.scm 37 */
		 return
		    PROCEDURE_ENTRY(method1701_1216) (method1701_1216,
		    (obj_t) (variable_2), BEOA);
	      }
	    else
	      {		/* Ast/shrinkify.scm 37 */
		 obj_t fun1598_1067;
		 fun1598_1067 =
		    PROCEDURE_REF(shrink_variable__env_168_ast_shrinkify, ((long) 0));
		 return
		    PROCEDURE_ENTRY(fun1598_1067) (fun1598_1067,
		    (obj_t) (variable_2), BEOA);
	      }
	 }
      }
   }
}



/* _shrink-variable! */
obj_t 
_shrink_variable__92_ast_shrinkify(obj_t env_1480, obj_t variable_1481)
{
   AN_OBJECT;
   {	/* Ast/shrinkify.scm 37 */
      return
	 shrink_variable__88_ast_shrinkify(
	 (variable_bglt) (variable_1481));
   }
}



/* shrink-variable!-default1464 */
obj_t 
shrink_variable__default1464_124_ast_shrinkify(variable_bglt variable_3)
{
   AN_OBJECT;
   {	/* Ast/shrinkify.scm 15 */
      {		/* Ast/shrinkify.scm 38 */
	 bool_t test_1608;
	 {	/* ./Llib/object.scm 3045 */
	    bool_t test_1609;
	    {	/* ./Llib/object.scm 3045 */
	       obj_t aux_1610;
	       {	/* ./Llib/object.scm 3045 */
		  object_bglt aux_1611;
		  aux_1611 =
		     (object_bglt) (variable_3);
		  aux_1610 =
		     OBJECT_WIDENING(aux_1611);
	       }
	       test_1609 =
		  CBOOL(aux_1610);
	    }
	    if (test_1609)
	      {		/* ./Llib/object.scm 3045 */
		 test_1608 = ((bool_t) 1)
		    ;
	      }
	    else
	      {		/* ./Llib/object.scm 3045 */
		 test_1608 = ((bool_t) 0)
		    ;
	      }
	 }
	 if (test_1608)
	   {	/* Ast/shrinkify.scm 38 */
	      {		/* Ast/shrinkify.scm 39 */
		 long arg1600_1070;
		 {	/* Ast/shrinkify.scm 39 */
		    obj_t arg1601_1071;
		    {	/* Ast/shrinkify.scm 39 */
		       obj_t arg1602_1072;
		       {	/* Ast/shrinkify.scm 39 */
			  object_bglt object_1274;
			  object_1274 =
			     (object_bglt) (variable_3);
			  {	/* ./Llib/object.scm 2695 */
			     long arg1179_1275;
			     {	/* ./Llib/object.scm 2695 */
				long arg1180_1276;
				long arg1181_1277;
				arg1180_1276 =
				   TYPE(object_1274);
				arg1181_1277 =
				   OBJECT_TYPE;
				arg1179_1275 =
				   (arg1180_1276 - arg1181_1277);
			     }
			     {	/* ./Llib/object.scm 2695 */
				obj_t vector_1281;
				vector_1281 = _classes__134___object;
				arg1602_1072 =
				   VECTOR_REF(vector_1281, arg1179_1275);
			     }
			  }
		       }
		       arg1601_1071 =
			  class_super_145___object(arg1602_1072);
		    }
		    arg1600_1070 =
		       class_num_218___object(arg1601_1071);
		 }
		 {	/* Ast/shrinkify.scm 39 */
		    obj_t obj_1283;
		    obj_1283 =
		       (obj_t) (variable_3);
		    (((obj_t) CREF(obj_1283))->header = MAKE_HEADER(arg1600_1070, 0), BUNSPEC);
		 }
	      }
	      {		/* Ast/shrinkify.scm 39 */
		 object_bglt aux_1624;
		 aux_1624 =
		    (object_bglt) (variable_3);
		 OBJECT_WIDENING_SET(aux_1624, BFALSE);
	      }
	      (obj_t) (variable_3);
	   }
	 else
	   {	/* Ast/shrinkify.scm 38 */
	      BUNSPEC;
	   }
      }
      {		/* Ast/shrinkify.scm 40 */
	 bool_t test_1628;
	 {	/* ./Llib/object.scm 3045 */
	    bool_t test_1629;
	    {	/* ./Llib/object.scm 3045 */
	       obj_t aux_1630;
	       {	/* ./Llib/object.scm 3045 */
		  object_bglt aux_1631;
		  {	/* Ast/shrinkify.scm 40 */
		     value_bglt aux_1632;
		     aux_1632 =
			(((variable_bglt) CREF(variable_3))->value);
		     aux_1631 =
			(object_bglt) (aux_1632);
		  }
		  aux_1630 =
		     OBJECT_WIDENING(aux_1631);
	       }
	       test_1629 =
		  CBOOL(aux_1630);
	    }
	    if (test_1629)
	      {		/* ./Llib/object.scm 3045 */
		 test_1628 = ((bool_t) 1)
		    ;
	      }
	    else
	      {		/* ./Llib/object.scm 3045 */
		 test_1628 = ((bool_t) 0)
		    ;
	      }
	 }
	 if (test_1628)
	   {	/* Ast/shrinkify.scm 41 */
	      value_bglt o1442_1074;
	      o1442_1074 =
		 (((variable_bglt) CREF(variable_3))->value);
	      {		/* Ast/shrinkify.scm 41 */
		 long arg1604_1075;
		 {	/* Ast/shrinkify.scm 41 */
		    obj_t arg1605_1076;
		    {	/* Ast/shrinkify.scm 41 */
		       obj_t arg1606_1077;
		       {	/* Ast/shrinkify.scm 41 */
			  object_bglt object_1290;
			  object_1290 =
			     (object_bglt) (o1442_1074);
			  {	/* ./Llib/object.scm 2695 */
			     long arg1179_1291;
			     {	/* ./Llib/object.scm 2695 */
				long arg1180_1292;
				long arg1181_1293;
				arg1180_1292 =
				   TYPE(object_1290);
				arg1181_1293 =
				   OBJECT_TYPE;
				arg1179_1291 =
				   (arg1180_1292 - arg1181_1293);
			     }
			     {	/* ./Llib/object.scm 2695 */
				obj_t vector_1297;
				vector_1297 = _classes__134___object;
				arg1606_1077 =
				   VECTOR_REF(vector_1297, arg1179_1291);
			     }
			  }
		       }
		       arg1605_1076 =
			  class_super_145___object(arg1606_1077);
		    }
		    arg1604_1075 =
		       class_num_218___object(arg1605_1076);
		 }
		 {	/* Ast/shrinkify.scm 41 */
		    obj_t obj_1299;
		    obj_1299 =
		       (obj_t) (o1442_1074);
		    (((obj_t) CREF(obj_1299))->header = MAKE_HEADER(arg1604_1075, 0), BUNSPEC);
		 }
	      }
	      {		/* Ast/shrinkify.scm 41 */
		 object_bglt aux_1647;
		 aux_1647 =
		    (object_bglt) (o1442_1074);
		 OBJECT_WIDENING_SET(aux_1647, BFALSE);
	      }
	      return
		 (obj_t) (o1442_1074);
	   }
	 else
	   {	/* Ast/shrinkify.scm 40 */
	      return BUNSPEC;
	   }
      }
   }
}



/* _shrink-variable!-default1464 */
obj_t 
_shrink_variable__default1464_19_ast_shrinkify(obj_t env_1482, obj_t variable_1483)
{
   AN_OBJECT;
   {	/* Ast/shrinkify.scm 15 */
      return
	 shrink_variable__default1464_124_ast_shrinkify(
	 (variable_bglt) (variable_1483));
   }
}



/* shrink-node! */
obj_t 
shrink_node__211_ast_shrinkify(node_bglt node_4)
{
   AN_OBJECT;
   {	/* Ast/shrinkify.scm 46 */
      {
	 obj_t method1610_1083;
	 obj_t class1615_1084;
	 {	/* Ast/shrinkify.scm 46 */
	    obj_t arg1618_1081;
	    obj_t arg1619_1082;
	    {	/* Ast/shrinkify.scm 46 */
	       object_bglt obj_1301;
	       obj_1301 =
		  (object_bglt) (node_4);
	       {	/* ./Llib/object.scm 2926 */
		  obj_t pre_method_105_1302;
		  pre_method_105_1302 =
		     PROCEDURE_REF(shrink_node__env_219_ast_shrinkify, ((long) 2));
		  if (
		     INTEGERP(pre_method_105_1302))
		    {	/* ./Llib/object.scm 2927 */
		       PROCEDURE_SET(shrink_node__env_219_ast_shrinkify, ((long) 2), BUNSPEC);
		       arg1618_1081 = pre_method_105_1302;
		    }
		  else
		    {	/* ./Llib/object.scm 2914 */
		       long obj_class_num_177_1307;
		       obj_class_num_177_1307 =
			  TYPE(obj_1301);
		       {	/* ./Llib/object.scm 2915 */
			  obj_t arg1176_1308;
			  arg1176_1308 =
			     PROCEDURE_REF(shrink_node__env_219_ast_shrinkify, ((long) 1));
			  {	/* ./Llib/object.scm 2738 */
			     long arg1177_1312;
			     {	/* ./Llib/object.scm 2738 */
				long arg1178_1313;
				arg1178_1313 =
				   OBJECT_TYPE;
				arg1177_1312 =
				   (obj_class_num_177_1307 - arg1178_1313);
			     }
			     arg1618_1081 =
				VECTOR_REF(arg1176_1308, arg1177_1312);
			  }
		       }
		    }
	       }
	    }
	    {	/* Ast/shrinkify.scm 46 */
	       object_bglt object_1318;
	       object_1318 =
		  (object_bglt) (node_4);
	       {	/* ./Llib/object.scm 2695 */
		  long arg1179_1319;
		  {	/* ./Llib/object.scm 2695 */
		     long arg1180_1320;
		     long arg1181_1321;
		     arg1180_1320 =
			TYPE(object_1318);
		     arg1181_1321 =
			OBJECT_TYPE;
		     arg1179_1319 =
			(arg1180_1320 - arg1181_1321);
		  }
		  {	/* ./Llib/object.scm 2695 */
		     obj_t vector_1325;
		     vector_1325 = _classes__134___object;
		     arg1619_1082 =
			VECTOR_REF(vector_1325, arg1179_1319);
		  }
	       }
	    }
	    {	/* Ast/shrinkify.scm 46 */
	       obj_t x_1488;
	       method1610_1083 = arg1618_1081;
	       class1615_1084 = arg1619_1082;
	       {

		  if (
		     INTEGERP(method1610_1083))
		    {	/* Ast/shrinkify.scm 46 */
		       switch (
			  (long) CINT(method1610_1083))
			 {
			 case ((long) 0):

			    x_1488 = BUNSPEC;
			    break;
			 case ((long) 1):

			    x_1488 = BUNSPEC;
			    break;
			 case ((long) 2):

			    x_1488 = BUNSPEC;
			    break;
			 case ((long) 3):

			    {	/* Ast/shrinkify.scm 46 */
			       sequence_bglt node_1093;
			       node_1093 =
				  (sequence_bglt) (node_4);
			       shrink_node___235_ast_shrinkify(
				  (((sequence_bglt) CREF(node_1093))->nodes));
			       x_1488 = BUNSPEC;
			    }
			    break;
			 case ((long) 4):

			    {	/* Ast/shrinkify.scm 46 */
			       app_bglt node_1095;
			       node_1095 =
				  (app_bglt) (node_4);
			       {	/* Ast/shrinkify.scm 77 */
				  bool_t test_1674;
				  {	/* ./Llib/object.scm 3045 */
				     bool_t test_1675;
				     {	/* ./Llib/object.scm 3045 */
					obj_t aux_1676;
					{	/* ./Llib/object.scm 3045 */
					   object_bglt aux_1677;
					   aux_1677 =
					      (object_bglt) (node_1095);
					   aux_1676 =
					      OBJECT_WIDENING(aux_1677);
					}
					test_1675 =
					   CBOOL(aux_1676);
				     }
				     if (test_1675)
				       {	/* ./Llib/object.scm 3045 */
					  test_1674 = ((bool_t) 1)
					     ;
				       }
				     else
				       {	/* ./Llib/object.scm 3045 */
					  test_1674 = ((bool_t) 0)
					     ;
				       }
				  }
				  if (test_1674)
				    {	/* Ast/shrinkify.scm 77 */
				       {	/* Ast/shrinkify.scm 77 */
					  long arg1624_1098;
					  {	/* Ast/shrinkify.scm 77 */
					     obj_t arg1625_1099;
					     {	/* Ast/shrinkify.scm 77 */
						obj_t arg1626_1100;
						{	/* Ast/shrinkify.scm 77 */
						   object_bglt object_1331;
						   object_1331 =
						      (object_bglt) (node_1095);
						   {	/* ./Llib/object.scm 2695 */
						      long arg1179_1332;
						      {		/* ./Llib/object.scm 2695 */
							 long arg1180_1333;
							 long arg1181_1334;
							 arg1180_1333 =
							    TYPE(object_1331);
							 arg1181_1334 =
							    OBJECT_TYPE;
							 arg1179_1332 =
							    (arg1180_1333 - arg1181_1334);
						      }
						      {		/* ./Llib/object.scm 2695 */
							 obj_t vector_1338;
							 vector_1338 = _classes__134___object;
							 arg1626_1100 =
							    VECTOR_REF(vector_1338, arg1179_1332);
						      }
						   }
						}
						arg1625_1099 =
						   class_super_145___object(arg1626_1100);
					     }
					     arg1624_1098 =
						class_num_218___object(arg1625_1099);
					  }
					  {	/* Ast/shrinkify.scm 77 */
					     obj_t obj_1340;
					     obj_1340 =
						(obj_t) (node_1095);
					     (((obj_t) CREF(obj_1340))->header = MAKE_HEADER(arg1624_1098, 0), BUNSPEC);
					  }
				       }
				       {	/* Ast/shrinkify.scm 77 */
					  object_bglt aux_1690;
					  aux_1690 =
					     (object_bglt) (node_1095);
					  OBJECT_WIDENING_SET(aux_1690, BFALSE);
				       }
				       (obj_t) (node_1095);
				    }
				  else
				    {	/* Ast/shrinkify.scm 77 */
				       BUNSPEC;
				    }
			       }
			       {	/* Ast/shrinkify.scm 78 */
				  node_bglt aux_1694;
				  {	/* Ast/shrinkify.scm 78 */
				     var_bglt aux_1695;
				     aux_1695 =
					(((app_bglt) CREF(node_1095))->fun);
				     aux_1694 =
					(node_bglt) (aux_1695);
				  }
				  shrink_node__211_ast_shrinkify(aux_1694);
			       }
			       shrink_node___235_ast_shrinkify(
				  (((app_bglt) CREF(node_1095))->args));
			       x_1488 = BUNSPEC;
			    }
			    break;
			 case ((long) 5):

			    {	/* Ast/shrinkify.scm 46 */
			       app_ly_162_bglt node_1103;
			       node_1103 =
				  (app_ly_162_bglt) (node_4);
			       {	/* Ast/shrinkify.scm 86 */
				  bool_t test_1702;
				  {	/* ./Llib/object.scm 3045 */
				     bool_t test_1703;
				     {	/* ./Llib/object.scm 3045 */
					obj_t aux_1704;
					{	/* ./Llib/object.scm 3045 */
					   object_bglt aux_1705;
					   aux_1705 =
					      (object_bglt) (node_1103);
					   aux_1704 =
					      OBJECT_WIDENING(aux_1705);
					}
					test_1703 =
					   CBOOL(aux_1704);
				     }
				     if (test_1703)
				       {	/* ./Llib/object.scm 3045 */
					  test_1702 = ((bool_t) 1)
					     ;
				       }
				     else
				       {	/* ./Llib/object.scm 3045 */
					  test_1702 = ((bool_t) 0)
					     ;
				       }
				  }
				  if (test_1702)
				    {	/* Ast/shrinkify.scm 86 */
				       {	/* Ast/shrinkify.scm 86 */
					  long arg1630_1106;
					  {	/* Ast/shrinkify.scm 86 */
					     obj_t arg1631_1107;
					     {	/* Ast/shrinkify.scm 86 */
						obj_t arg1632_1108;
						{	/* Ast/shrinkify.scm 86 */
						   object_bglt object_1347;
						   object_1347 =
						      (object_bglt) (node_1103);
						   {	/* ./Llib/object.scm 2695 */
						      long arg1179_1348;
						      {		/* ./Llib/object.scm 2695 */
							 long arg1180_1349;
							 long arg1181_1350;
							 arg1180_1349 =
							    TYPE(object_1347);
							 arg1181_1350 =
							    OBJECT_TYPE;
							 arg1179_1348 =
							    (arg1180_1349 - arg1181_1350);
						      }
						      {		/* ./Llib/object.scm 2695 */
							 obj_t vector_1354;
							 vector_1354 = _classes__134___object;
							 arg1632_1108 =
							    VECTOR_REF(vector_1354, arg1179_1348);
						      }
						   }
						}
						arg1631_1107 =
						   class_super_145___object(arg1632_1108);
					     }
					     arg1630_1106 =
						class_num_218___object(arg1631_1107);
					  }
					  {	/* Ast/shrinkify.scm 86 */
					     obj_t obj_1356;
					     obj_1356 =
						(obj_t) (node_1103);
					     (((obj_t) CREF(obj_1356))->header = MAKE_HEADER(arg1630_1106, 0), BUNSPEC);
					  }
				       }
				       {	/* Ast/shrinkify.scm 86 */
					  object_bglt aux_1718;
					  aux_1718 =
					     (object_bglt) (node_1103);
					  OBJECT_WIDENING_SET(aux_1718, BFALSE);
				       }
				       (obj_t) (node_1103);
				    }
				  else
				    {	/* Ast/shrinkify.scm 86 */
				       BUNSPEC;
				    }
			       }
			       shrink_node__211_ast_shrinkify(
				  (((app_ly_162_bglt) CREF(node_1103))->fun));
			       shrink_node__211_ast_shrinkify(
				  (((app_ly_162_bglt) CREF(node_1103))->arg));
			       x_1488 = BUNSPEC;
			    }
			    break;
			 case ((long) 6):

			    {	/* Ast/shrinkify.scm 46 */
			       funcall_bglt node_1111;
			       node_1111 =
				  (funcall_bglt) (node_4);
			       {	/* Ast/shrinkify.scm 95 */
				  bool_t test_1727;
				  {	/* ./Llib/object.scm 3045 */
				     bool_t test_1728;
				     {	/* ./Llib/object.scm 3045 */
					obj_t aux_1729;
					{	/* ./Llib/object.scm 3045 */
					   object_bglt aux_1730;
					   aux_1730 =
					      (object_bglt) (node_1111);
					   aux_1729 =
					      OBJECT_WIDENING(aux_1730);
					}
					test_1728 =
					   CBOOL(aux_1729);
				     }
				     if (test_1728)
				       {	/* ./Llib/object.scm 3045 */
					  test_1727 = ((bool_t) 1)
					     ;
				       }
				     else
				       {	/* ./Llib/object.scm 3045 */
					  test_1727 = ((bool_t) 0)
					     ;
				       }
				  }
				  if (test_1727)
				    {	/* Ast/shrinkify.scm 95 */
				       {	/* Ast/shrinkify.scm 95 */
					  long arg1636_1114;
					  {	/* Ast/shrinkify.scm 95 */
					     obj_t arg1637_1115;
					     {	/* Ast/shrinkify.scm 95 */
						obj_t arg1638_1116;
						{	/* Ast/shrinkify.scm 95 */
						   object_bglt object_1363;
						   object_1363 =
						      (object_bglt) (node_1111);
						   {	/* ./Llib/object.scm 2695 */
						      long arg1179_1364;
						      {		/* ./Llib/object.scm 2695 */
							 long arg1180_1365;
							 long arg1181_1366;
							 arg1180_1365 =
							    TYPE(object_1363);
							 arg1181_1366 =
							    OBJECT_TYPE;
							 arg1179_1364 =
							    (arg1180_1365 - arg1181_1366);
						      }
						      {		/* ./Llib/object.scm 2695 */
							 obj_t vector_1370;
							 vector_1370 = _classes__134___object;
							 arg1638_1116 =
							    VECTOR_REF(vector_1370, arg1179_1364);
						      }
						   }
						}
						arg1637_1115 =
						   class_super_145___object(arg1638_1116);
					     }
					     arg1636_1114 =
						class_num_218___object(arg1637_1115);
					  }
					  {	/* Ast/shrinkify.scm 95 */
					     obj_t obj_1372;
					     obj_1372 =
						(obj_t) (node_1111);
					     (((obj_t) CREF(obj_1372))->header = MAKE_HEADER(arg1636_1114, 0), BUNSPEC);
					  }
				       }
				       {	/* Ast/shrinkify.scm 95 */
					  object_bglt aux_1743;
					  aux_1743 =
					     (object_bglt) (node_1111);
					  OBJECT_WIDENING_SET(aux_1743, BFALSE);
				       }
				       (obj_t) (node_1111);
				    }
				  else
				    {	/* Ast/shrinkify.scm 95 */
				       BUNSPEC;
				    }
			       }
			       shrink_node__211_ast_shrinkify(
				  (((funcall_bglt) CREF(node_1111))->fun));
			       shrink_node___235_ast_shrinkify(
				  (((funcall_bglt) CREF(node_1111))->args));
			       x_1488 = BUNSPEC;
			    }
			    break;
			 case ((long) 7):

			    {	/* Ast/shrinkify.scm 46 */
			       pragma_bglt node_1119;
			       node_1119 =
				  (pragma_bglt) (node_4);
			       {	/* Ast/shrinkify.scm 104 */
				  bool_t test_1752;
				  {	/* ./Llib/object.scm 3045 */
				     bool_t test_1753;
				     {	/* ./Llib/object.scm 3045 */
					obj_t aux_1754;
					{	/* ./Llib/object.scm 3045 */
					   object_bglt aux_1755;
					   aux_1755 =
					      (object_bglt) (node_1119);
					   aux_1754 =
					      OBJECT_WIDENING(aux_1755);
					}
					test_1753 =
					   CBOOL(aux_1754);
				     }
				     if (test_1753)
				       {	/* ./Llib/object.scm 3045 */
					  test_1752 = ((bool_t) 1)
					     ;
				       }
				     else
				       {	/* ./Llib/object.scm 3045 */
					  test_1752 = ((bool_t) 0)
					     ;
				       }
				  }
				  if (test_1752)
				    {	/* Ast/shrinkify.scm 104 */
				       {	/* Ast/shrinkify.scm 104 */
					  long arg1642_1122;
					  {	/* Ast/shrinkify.scm 104 */
					     obj_t arg1643_1123;
					     {	/* Ast/shrinkify.scm 104 */
						obj_t arg1644_1124;
						{	/* Ast/shrinkify.scm 104 */
						   object_bglt object_1379;
						   object_1379 =
						      (object_bglt) (node_1119);
						   {	/* ./Llib/object.scm 2695 */
						      long arg1179_1380;
						      {		/* ./Llib/object.scm 2695 */
							 long arg1180_1381;
							 long arg1181_1382;
							 arg1180_1381 =
							    TYPE(object_1379);
							 arg1181_1382 =
							    OBJECT_TYPE;
							 arg1179_1380 =
							    (arg1180_1381 - arg1181_1382);
						      }
						      {		/* ./Llib/object.scm 2695 */
							 obj_t vector_1386;
							 vector_1386 = _classes__134___object;
							 arg1644_1124 =
							    VECTOR_REF(vector_1386, arg1179_1380);
						      }
						   }
						}
						arg1643_1123 =
						   class_super_145___object(arg1644_1124);
					     }
					     arg1642_1122 =
						class_num_218___object(arg1643_1123);
					  }
					  {	/* Ast/shrinkify.scm 104 */
					     obj_t obj_1388;
					     obj_1388 =
						(obj_t) (node_1119);
					     (((obj_t) CREF(obj_1388))->header = MAKE_HEADER(arg1642_1122, 0), BUNSPEC);
					  }
				       }
				       {	/* Ast/shrinkify.scm 104 */
					  object_bglt aux_1768;
					  aux_1768 =
					     (object_bglt) (node_1119);
					  OBJECT_WIDENING_SET(aux_1768, BFALSE);
				       }
				       (obj_t) (node_1119);
				    }
				  else
				    {	/* Ast/shrinkify.scm 104 */
				       BUNSPEC;
				    }
			       }
			       shrink_node___235_ast_shrinkify(
				  (((pragma_bglt) CREF(node_1119))->args));
			       x_1488 =
				  (obj_t) (node_1119);
			    }
			    break;
			 case ((long) 8):

			    {	/* Ast/shrinkify.scm 46 */
			       cast_bglt node_1126;
			       node_1126 =
				  (cast_bglt) (node_4);
			       shrink_node__211_ast_shrinkify(
				  (((cast_bglt) CREF(node_1126))->arg));
			       x_1488 =
				  (obj_t) (node_1126);
			    }
			    break;
			 case ((long) 9):

			    {	/* Ast/shrinkify.scm 46 */
			       setq_bglt node_1128;
			       node_1128 =
				  (setq_bglt) (node_4);
			       shrink_node__211_ast_shrinkify(
				  (((setq_bglt) CREF(node_1128))->value));
			       x_1488 = BUNSPEC;
			    }
			    break;
			 case ((long) 10):

			    {	/* Ast/shrinkify.scm 46 */
			       conditional_bglt node_1130;
			       node_1130 =
				  (conditional_bglt) (node_4);
			       shrink_node__211_ast_shrinkify(
				  (((conditional_bglt) CREF(node_1130))->test));
			       shrink_node__211_ast_shrinkify(
				  (((conditional_bglt) CREF(node_1130))->true));
			       shrink_node__211_ast_shrinkify(
				  (((conditional_bglt) CREF(node_1130))->false));
			       x_1488 = BUNSPEC;
			    }
			    break;
			 case ((long) 11):

			    {	/* Ast/shrinkify.scm 46 */
			       fail_bglt node_1134;
			       node_1134 =
				  (fail_bglt) (node_4);
			       shrink_node__211_ast_shrinkify(
				  (((fail_bglt) CREF(node_1134))->proc));
			       shrink_node__211_ast_shrinkify(
				  (((fail_bglt) CREF(node_1134))->msg));
			       shrink_node__211_ast_shrinkify(
				  (((fail_bglt) CREF(node_1134))->obj));
			       x_1488 = BUNSPEC;
			    }
			    break;
			 case ((long) 12):

			    {	/* Ast/shrinkify.scm 46 */
			       select_bglt node_1138;
			       node_1138 =
				  (select_bglt) (node_4);
			       shrink_node__211_ast_shrinkify(
				  (((select_bglt) CREF(node_1138))->test));
			       {
				  obj_t l1447_1140;
				  l1447_1140 =
				     (((select_bglt) CREF(node_1138))->clauses);
				lname1448_1141:
				  if (
				     PAIRP(l1447_1140))
				    {	/* Ast/shrinkify.scm 145 */
				       {	/* Ast/shrinkify.scm 146 */
					  node_bglt aux_1801;
					  {	/* Ast/shrinkify.scm 146 */
					     obj_t aux_1802;
					     {	/* ./Ieee/pair-list.scm 5707 */
						obj_t aux_1803;
						aux_1803 =
						   CAR(l1447_1140);
						aux_1802 =
						   CDR(aux_1803);
					     }
					     aux_1801 =
						(node_bglt) (aux_1802);
					  }
					  shrink_node__211_ast_shrinkify(aux_1801);
				       }
				       {
					  obj_t l1447_1808;
					  l1447_1808 =
					     CDR(l1447_1140);
					  l1447_1140 = l1447_1808;
					  goto lname1448_1141;
				       }
				    }
				  else
				    {	/* Ast/shrinkify.scm 145 */
				       ((bool_t) 1);
				    }
			       }
			       x_1488 = BUNSPEC;
			    }
			    break;
			 case ((long) 13):

			    {	/* Ast/shrinkify.scm 46 */
			       make_box_202_bglt node_1147;
			       node_1147 =
				  (make_box_202_bglt) (node_4);
			       {	/* Ast/shrinkify.scm 154 */
				  bool_t test_1812;
				  {	/* ./Llib/object.scm 3045 */
				     bool_t test_1813;
				     {	/* ./Llib/object.scm 3045 */
					obj_t aux_1814;
					{	/* ./Llib/object.scm 3045 */
					   object_bglt aux_1815;
					   aux_1815 =
					      (object_bglt) (node_1147);
					   aux_1814 =
					      OBJECT_WIDENING(aux_1815);
					}
					test_1813 =
					   CBOOL(aux_1814);
				     }
				     if (test_1813)
				       {	/* ./Llib/object.scm 3045 */
					  test_1812 = ((bool_t) 1)
					     ;
				       }
				     else
				       {	/* ./Llib/object.scm 3045 */
					  test_1812 = ((bool_t) 0)
					     ;
				       }
				  }
				  if (test_1812)
				    {	/* Ast/shrinkify.scm 154 */
				       {	/* Ast/shrinkify.scm 154 */
					  long arg1661_1150;
					  {	/* Ast/shrinkify.scm 154 */
					     obj_t arg1662_1151;
					     {	/* Ast/shrinkify.scm 154 */
						obj_t arg1663_1152;
						{	/* Ast/shrinkify.scm 154 */
						   object_bglt object_1408;
						   object_1408 =
						      (object_bglt) (node_1147);
						   {	/* ./Llib/object.scm 2695 */
						      long arg1179_1409;
						      {		/* ./Llib/object.scm 2695 */
							 long arg1180_1410;
							 long arg1181_1411;
							 arg1180_1410 =
							    TYPE(object_1408);
							 arg1181_1411 =
							    OBJECT_TYPE;
							 arg1179_1409 =
							    (arg1180_1410 - arg1181_1411);
						      }
						      {		/* ./Llib/object.scm 2695 */
							 obj_t vector_1415;
							 vector_1415 = _classes__134___object;
							 arg1663_1152 =
							    VECTOR_REF(vector_1415, arg1179_1409);
						      }
						   }
						}
						arg1662_1151 =
						   class_super_145___object(arg1663_1152);
					     }
					     arg1661_1150 =
						class_num_218___object(arg1662_1151);
					  }
					  {	/* Ast/shrinkify.scm 154 */
					     obj_t obj_1417;
					     obj_1417 =
						(obj_t) (node_1147);
					     (((obj_t) CREF(obj_1417))->header = MAKE_HEADER(arg1661_1150, 0), BUNSPEC);
					  }
				       }
				       {	/* Ast/shrinkify.scm 154 */
					  object_bglt aux_1828;
					  aux_1828 =
					     (object_bglt) (node_1147);
					  OBJECT_WIDENING_SET(aux_1828, BFALSE);
				       }
				       (obj_t) (node_1147);
				    }
				  else
				    {	/* Ast/shrinkify.scm 154 */
				       BUNSPEC;
				    }
			       }
			       shrink_node__211_ast_shrinkify(
				  (((make_box_202_bglt) CREF(node_1147))->value));
			       x_1488 = BUNSPEC;
			    }
			    break;
			 case ((long) 14):

			    {	/* Ast/shrinkify.scm 46 */
			       box_ref_242_bglt node_1154;
			       node_1154 =
				  (box_ref_242_bglt) (node_4);
			       {	/* Ast/shrinkify.scm 162 */
				  bool_t test_1835;
				  {	/* ./Llib/object.scm 3045 */
				     bool_t test_1836;
				     {	/* ./Llib/object.scm 3045 */
					obj_t aux_1837;
					{	/* ./Llib/object.scm 3045 */
					   object_bglt aux_1838;
					   aux_1838 =
					      (object_bglt) (node_1154);
					   aux_1837 =
					      OBJECT_WIDENING(aux_1838);
					}
					test_1836 =
					   CBOOL(aux_1837);
				     }
				     if (test_1836)
				       {	/* ./Llib/object.scm 3045 */
					  test_1835 = ((bool_t) 1)
					     ;
				       }
				     else
				       {	/* ./Llib/object.scm 3045 */
					  test_1835 = ((bool_t) 0)
					     ;
				       }
				  }
				  if (test_1835)
				    {	/* Ast/shrinkify.scm 162 */
				       {	/* Ast/shrinkify.scm 162 */
					  long arg1666_1157;
					  {	/* Ast/shrinkify.scm 162 */
					     obj_t arg1667_1158;
					     {	/* Ast/shrinkify.scm 162 */
						obj_t arg1669_1159;
						{	/* Ast/shrinkify.scm 162 */
						   object_bglt object_1423;
						   object_1423 =
						      (object_bglt) (node_1154);
						   {	/* ./Llib/object.scm 2695 */
						      long arg1179_1424;
						      {		/* ./Llib/object.scm 2695 */
							 long arg1180_1425;
							 long arg1181_1426;
							 arg1180_1425 =
							    TYPE(object_1423);
							 arg1181_1426 =
							    OBJECT_TYPE;
							 arg1179_1424 =
							    (arg1180_1425 - arg1181_1426);
						      }
						      {		/* ./Llib/object.scm 2695 */
							 obj_t vector_1430;
							 vector_1430 = _classes__134___object;
							 arg1669_1159 =
							    VECTOR_REF(vector_1430, arg1179_1424);
						      }
						   }
						}
						arg1667_1158 =
						   class_super_145___object(arg1669_1159);
					     }
					     arg1666_1157 =
						class_num_218___object(arg1667_1158);
					  }
					  {	/* Ast/shrinkify.scm 162 */
					     obj_t obj_1432;
					     obj_1432 =
						(obj_t) (node_1154);
					     (((obj_t) CREF(obj_1432))->header = MAKE_HEADER(arg1666_1157, 0), BUNSPEC);
					  }
				       }
				       {	/* Ast/shrinkify.scm 162 */
					  object_bglt aux_1851;
					  aux_1851 =
					     (object_bglt) (node_1154);
					  OBJECT_WIDENING_SET(aux_1851, BFALSE);
				       }
				       (obj_t) (node_1154);
				    }
				  else
				    {	/* Ast/shrinkify.scm 162 */
				       BUNSPEC;
				    }
			       }
			       {	/* Ast/shrinkify.scm 163 */
				  node_bglt aux_1855;
				  {	/* Ast/shrinkify.scm 163 */
				     var_bglt aux_1856;
				     aux_1856 =
					(((box_ref_242_bglt) CREF(node_1154))->var);
				     aux_1855 =
					(node_bglt) (aux_1856);
				  }
				  shrink_node__211_ast_shrinkify(aux_1855);
			       }
			       x_1488 = BUNSPEC;
			    }
			    break;
			 case ((long) 15):

			    {	/* Ast/shrinkify.scm 46 */
			       box_set__221_bglt node_1161;
			       node_1161 =
				  (box_set__221_bglt) (node_4);
			       {	/* Ast/shrinkify.scm 170 */
				  bool_t test_1861;
				  {	/* ./Llib/object.scm 3045 */
				     bool_t test_1862;
				     {	/* ./Llib/object.scm 3045 */
					obj_t aux_1863;
					{	/* ./Llib/object.scm 3045 */
					   object_bglt aux_1864;
					   aux_1864 =
					      (object_bglt) (node_1161);
					   aux_1863 =
					      OBJECT_WIDENING(aux_1864);
					}
					test_1862 =
					   CBOOL(aux_1863);
				     }
				     if (test_1862)
				       {	/* ./Llib/object.scm 3045 */
					  test_1861 = ((bool_t) 1)
					     ;
				       }
				     else
				       {	/* ./Llib/object.scm 3045 */
					  test_1861 = ((bool_t) 0)
					     ;
				       }
				  }
				  if (test_1861)
				    {	/* Ast/shrinkify.scm 170 */
				       {	/* Ast/shrinkify.scm 170 */
					  long arg1672_1164;
					  {	/* Ast/shrinkify.scm 170 */
					     obj_t arg1673_1165;
					     {	/* Ast/shrinkify.scm 170 */
						obj_t arg1674_1166;
						{	/* Ast/shrinkify.scm 170 */
						   object_bglt object_1438;
						   object_1438 =
						      (object_bglt) (node_1161);
						   {	/* ./Llib/object.scm 2695 */
						      long arg1179_1439;
						      {		/* ./Llib/object.scm 2695 */
							 long arg1180_1440;
							 long arg1181_1441;
							 arg1180_1440 =
							    TYPE(object_1438);
							 arg1181_1441 =
							    OBJECT_TYPE;
							 arg1179_1439 =
							    (arg1180_1440 - arg1181_1441);
						      }
						      {		/* ./Llib/object.scm 2695 */
							 obj_t vector_1445;
							 vector_1445 = _classes__134___object;
							 arg1674_1166 =
							    VECTOR_REF(vector_1445, arg1179_1439);
						      }
						   }
						}
						arg1673_1165 =
						   class_super_145___object(arg1674_1166);
					     }
					     arg1672_1164 =
						class_num_218___object(arg1673_1165);
					  }
					  {	/* Ast/shrinkify.scm 170 */
					     obj_t obj_1447;
					     obj_1447 =
						(obj_t) (node_1161);
					     (((obj_t) CREF(obj_1447))->header = MAKE_HEADER(arg1672_1164, 0), BUNSPEC);
					  }
				       }
				       {	/* Ast/shrinkify.scm 170 */
					  object_bglt aux_1877;
					  aux_1877 =
					     (object_bglt) (node_1161);
					  OBJECT_WIDENING_SET(aux_1877, BFALSE);
				       }
				       (obj_t) (node_1161);
				    }
				  else
				    {	/* Ast/shrinkify.scm 170 */
				       BUNSPEC;
				    }
			       }
			       {	/* Ast/shrinkify.scm 171 */
				  node_bglt aux_1881;
				  {	/* Ast/shrinkify.scm 171 */
				     var_bglt aux_1882;
				     aux_1882 =
					(((box_set__221_bglt) CREF(node_1161))->var);
				     aux_1881 =
					(node_bglt) (aux_1882);
				  }
				  shrink_node__211_ast_shrinkify(aux_1881);
			       }
			       shrink_node__211_ast_shrinkify(
				  (((box_set__221_bglt) CREF(node_1161))->value));
			       x_1488 = BUNSPEC;
			    }
			    break;
			 case ((long) 16):

			    {	/* Ast/shrinkify.scm 179 */
			       let_fun_218_bglt node_1169;
			       node_1169 =
				  (let_fun_218_bglt) (node_4);
			       shrink_node__211_ast_shrinkify(
				  (((let_fun_218_bglt) CREF(node_1169))->body));
			       {
				  obj_t l1453_1172;
				  l1453_1172 =
				     (((let_fun_218_bglt) CREF(node_1169))->locals);
				lname1454_1173:
				  if (
				     PAIRP(l1453_1172))
				    {	/* Ast/shrinkify.scm 181 */
				       {	/* Ast/shrinkify.scm 182 */
					  obj_t local_1176;
					  local_1176 =
					     CAR(l1453_1172);
					  {	/* Ast/shrinkify.scm 182 */
					     value_bglt sfun_1177;
					     {	/* Ast/shrinkify.scm 182 */
						local_bglt obj_1455;
						obj_1455 =
						   (local_bglt) (local_1176);
						sfun_1177 =
						   (((local_bglt) CREF(obj_1455))->value);
					     }
					     shrink_variable__88_ast_shrinkify(
						(variable_bglt) (local_1176));
					     {
						obj_t l1455_1178;
						{	/* Ast/shrinkify.scm 184 */
						   sfun_bglt obj_1456;
						   obj_1456 =
						      (sfun_bglt) (sfun_1177);
						   l1455_1178 =
						      (((sfun_bglt) CREF(obj_1456))->args);
						}
					      lname1456_1179:
						if (
						   PAIRP(l1455_1178))
						  {	/* Ast/shrinkify.scm 184 */
						     {	/* Ast/shrinkify.scm 184 */
							variable_bglt aux_1900;
							{	/* Ast/shrinkify.scm 184 */
							   obj_t aux_1901;
							   aux_1901 =
							      CAR(l1455_1178);
							   aux_1900 =
							      (variable_bglt) (aux_1901);
							}
							shrink_variable__88_ast_shrinkify(aux_1900);
						     }
						     {
							obj_t l1455_1905;
							l1455_1905 =
							   CDR(l1455_1178);
							l1455_1178 = l1455_1905;
							goto lname1456_1179;
						     }
						  }
						else
						  {	/* Ast/shrinkify.scm 184 */
						     ((bool_t) 1);
						  }
					     }
					     {	/* Ast/shrinkify.scm 185 */
						node_bglt aux_1909;
						{	/* Ast/shrinkify.scm 185 */
						   obj_t aux_1910;
						   {	/* Ast/shrinkify.scm 185 */
						      sfun_bglt obj_1460;
						      obj_1460 =
							 (sfun_bglt) (sfun_1177);
						      aux_1910 =
							 (((sfun_bglt) CREF(obj_1460))->body);
						   }
						   aux_1909 =
						      (node_bglt) (aux_1910);
						}
						shrink_node__211_ast_shrinkify(aux_1909);
					     }
					  }
				       }
				       {
					  obj_t l1453_1915;
					  l1453_1915 =
					     CDR(l1453_1172);
					  l1453_1172 = l1453_1915;
					  goto lname1454_1173;
				       }
				    }
				  else
				    {	/* Ast/shrinkify.scm 181 */
				       ((bool_t) 1);
				    }
			       }
			       x_1488 = BUNSPEC;
			    }
			    break;
			 case ((long) 17):

			    {	/* Ast/shrinkify.scm 193 */
			       let_var_6_bglt node_1186;
			       node_1186 =
				  (let_var_6_bglt) (node_4);
			       shrink_node__211_ast_shrinkify(
				  (((let_var_6_bglt) CREF(node_1186))->body));
			       {
				  obj_t l1458_1189;
				  l1458_1189 =
				     (((let_var_6_bglt) CREF(node_1186))->bindings);
				lname1459_1190:
				  if (
				     PAIRP(l1458_1189))
				    {	/* Ast/shrinkify.scm 195 */
				       {	/* Ast/shrinkify.scm 195 */
					  obj_t binding_1193;
					  binding_1193 =
					     CAR(l1458_1189);
					  {	/* Ast/shrinkify.scm 196 */
					     variable_bglt aux_1924;
					     {	/* Ast/shrinkify.scm 196 */
						obj_t aux_1925;
						aux_1925 =
						   CAR(binding_1193);
						aux_1924 =
						   (variable_bglt) (aux_1925);
					     }
					     shrink_variable__88_ast_shrinkify(aux_1924);
					  }
					  {	/* Ast/shrinkify.scm 197 */
					     node_bglt aux_1929;
					     {	/* Ast/shrinkify.scm 197 */
						obj_t aux_1930;
						aux_1930 =
						   CDR(binding_1193);
						aux_1929 =
						   (node_bglt) (aux_1930);
					     }
					     shrink_node__211_ast_shrinkify(aux_1929);
					  }
				       }
				       {
					  obj_t l1458_1934;
					  l1458_1934 =
					     CDR(l1458_1189);
					  l1458_1189 = l1458_1934;
					  goto lname1459_1190;
				       }
				    }
				  else
				    {	/* Ast/shrinkify.scm 195 */
				       ((bool_t) 1);
				    }
			       }
			       x_1488 = BUNSPEC;
			    }
			    break;
			 case ((long) 18):

			    {	/* Ast/shrinkify.scm 205 */
			       set_ex_it_116_bglt node_1197;
			       node_1197 =
				  (set_ex_it_116_bglt) (node_4);
			       {	/* Ast/shrinkify.scm 206 */
				  node_bglt aux_1938;
				  {	/* Ast/shrinkify.scm 206 */
				     var_bglt aux_1939;
				     aux_1939 =
					(((set_ex_it_116_bglt) CREF(node_1197))->var);
				     aux_1938 =
					(node_bglt) (aux_1939);
				  }
				  shrink_node__211_ast_shrinkify(aux_1938);
			       }
			       shrink_node__211_ast_shrinkify(
				  (((set_ex_it_116_bglt) CREF(node_1197))->body));
			       x_1488 = BUNSPEC;
			    }
			    break;
			 case ((long) 19):

			    {	/* Ast/shrinkify.scm 46 */
			       jump_ex_it_184_bglt node_1201;
			       node_1201 =
				  (jump_ex_it_184_bglt) (node_4);
			       shrink_node__211_ast_shrinkify(
				  (((jump_ex_it_184_bglt) CREF(node_1201))->exit));
			       shrink_node__211_ast_shrinkify(
				  (((jump_ex_it_184_bglt) CREF(node_1201))->value));
			       x_1488 = BUNSPEC;
			    }
			    break;
			 default:
			  case_else1616_1087:
			    if (
			       PROCEDUREP(method1610_1083))
			      {		/* Ast/shrinkify.scm 46 */
				 x_1488 =
				    PROCEDURE_ENTRY(method1610_1083) (method1610_1083,
				    (obj_t) (node_4), BEOA);
			      }
			    else
			      {		/* Ast/shrinkify.scm 46 */
				 obj_t fun1609_1079;
				 fun1609_1079 =
				    PROCEDURE_REF(shrink_node__env_219_ast_shrinkify, ((long) 0));
				 x_1488 =
				    PROCEDURE_ENTRY(fun1609_1079) (fun1609_1079,
				    (obj_t) (node_4), BEOA);
			      }
			 }
		    }
		  else
		    {	/* Ast/shrinkify.scm 46 */
		       goto case_else1616_1087;
		    }
	       }
	       return BUNSPEC;
	    }
	 }
      }
   }
}



/* _shrink-node! */
obj_t 
_shrink_node__49_ast_shrinkify(obj_t env_1484, obj_t node_1485)
{
   AN_OBJECT;
   {	/* Ast/shrinkify.scm 46 */
      return
	 shrink_node__211_ast_shrinkify(
	 (node_bglt) (node_1485));
   }
}



/* shrink-node!-default1465 */
obj_t 
shrink_node__default1465_7_ast_shrinkify(node_bglt node_5)
{
   AN_OBJECT;
   {	/* Ast/shrinkify.scm 15 */
      FAILURE(
	 CNST_TABLE_REF(((long) 0)), string1726_ast_shrinkify,
	 (obj_t) (node_5));
   }
}



/* _shrink-node!-default1465 */
obj_t 
_shrink_node__default1465_197_ast_shrinkify(obj_t env_1486, obj_t node_1487)
{
   AN_OBJECT;
   {	/* Ast/shrinkify.scm 15 */
      return
	 shrink_node__default1465_7_ast_shrinkify(
	 (node_bglt) (node_1487));
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_ast_shrinkify()
{
   AN_OBJECT;
   {	/* Ast/shrinkify.scm 15 */
      module_initialization_70_type_type(((long) 0), "AST_SHRINKIFY");
      module_initialization_70_ast_var(((long) 0), "AST_SHRINKIFY");
      module_initialization_70_ast_node(((long) 0), "AST_SHRINKIFY");
      return
	 module_initialization_70_ast_env(((long) 0), "AST_SHRINKIFY");
   }
}
