/*===========================================================================*/
/*   (Ast/substitute.scm)                                                    */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;


static obj_t method_init_76_ast_substitute();
extern obj_t make_box_202_ast_node;
extern obj_t funcall_ast_node;
extern long add_inlined_method__244___object(obj_t, obj_t, long);
extern node_bglt known_app_ly__node_26_ast_apply(obj_t, obj_t, node_bglt, node_bglt, obj_t);
extern obj_t fail_ast_node;
extern obj_t box_ref_242_ast_node;
extern obj_t sequence_ast_node;
extern obj_t let_var_6_ast_node;
extern obj_t var_ast_node;
extern node_bglt substitute__30_ast_substitute(obj_t, obj_t, node_bglt, obj_t);
extern obj_t closure_ast_node;
extern obj_t pragma_ast_node;
extern obj_t set_ex_it_116_ast_node;
extern obj_t notify_assert_fail_37___eval(obj_t, obj_t, obj_t);
extern bool_t is_a__118___object(obj_t, obj_t);
static obj_t do_substitute___56_ast_substitute(obj_t, obj_t);
extern obj_t module_initialization_70_ast_substitute(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_ast_apply(long, char *);
extern obj_t module_initialization_70_ast_app(long, char *);
extern obj_t module_initialization_70_ast_sexp(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___eval(long, char *);
extern obj_t module_initialization_70___evenv(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern long class_num_218___object(obj_t);
extern obj_t define_primop_ref__105___evenv(obj_t, obj_t);
extern obj_t let_fun_218_ast_node;
extern obj_t fun_ast_var;
static obj_t _substitute_1755_196_ast_substitute(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t imported_modules_init_94_ast_substitute();
extern obj_t unbind_primop__163___evenv(obj_t);
extern bool_t correct_arity_app__187_ast_app(variable_bglt, obj_t);
extern obj_t app_ly_162_ast_node;
extern obj_t add_generic__110___object(obj_t, obj_t);
static obj_t _do_substitute__default1463_54_ast_substitute(obj_t, obj_t, obj_t);
extern obj_t app_ast_node;
static obj_t library_modules_init_112_ast_substitute();
extern obj_t atom_ast_node;
extern obj_t cast_ast_node;
static obj_t toplevel_init_63_ast_substitute();
extern obj_t jump_ex_it_184_ast_node;
extern obj_t open_input_string(obj_t);
extern obj_t kwote_ast_node;
extern obj_t use_variable__4_ast_sexp(variable_bglt, obj_t, obj_t);
extern obj_t setq_ast_node;
extern obj_t box_set__221_ast_node;
extern obj_t variable_ast_var;
extern obj_t memq___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern obj_t shape_tools_shape(obj_t);
static node_bglt do_substitute__default1463_209_ast_substitute(node_bglt, obj_t);
extern obj_t internal_error_43_tools_error(obj_t, obj_t, obj_t);
static obj_t _do_substitute_1756_90_ast_substitute(obj_t, obj_t, obj_t);
extern obj_t _classes__134___object;
extern obj_t select_ast_node;
extern obj_t read___reader(obj_t);
extern node_bglt make_app_node_80_ast_app(obj_t, obj_t, var_bglt, obj_t);
static node_bglt do_substitute__77_ast_substitute(node_bglt, obj_t);
static obj_t require_initialization_114_ast_substitute = BUNSPEC;
extern obj_t conditional_ast_node;
static obj_t cnst_init_137_ast_substitute();
extern obj_t user_error_location_137_tools_error(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t __cnst[15];

DEFINE_EXPORT_PROCEDURE(substitute__env_193_ast_substitute, _substitute_1755_196_ast_substitute1767, _substitute_1755_196_ast_substitute, 0L, 4);
DEFINE_STATIC_GENERIC(do_substitute__env_169_ast_substitute, _do_substitute_1756_90_ast_substitute1768, _do_substitute_1756_90_ast_substitute, 0L, 2);
DEFINE_STRING(string1762_ast_substitute, string1762_ast_substitute1769, "DO-SUBSTITUTE!-DEFAULT1463 SET! APPLY APP VALUE DONE (\"/home/tahoe2/serrano/tmp/bigloo/comptime/Ast/substitute.scm\" . 1765) (BEGIN (VARIABLE? BY)) (BY) BY (\"/home/tahoe2/serrano/tmp/bigloo/comptime/Ast/substitute.scm\" . 1649) (BEGIN (MEMQ SITE (QUOTE (VALUE APPLY APP SET!)))) (SITE) SITE (VALUE APPLY APP SET!) ", 312);
DEFINE_STRING(string1761_ast_substitute, string1761_ast_substitute1770, "No method for this object", 25);
DEFINE_STRING(string1759_ast_substitute, string1759_ast_substitute1771, "Illegal application", 19);
DEFINE_STRING(string1760_ast_substitute, string1760_ast_substitute1772, "wrong number of argument(s)", 27);
DEFINE_STRING(string1758_ast_substitute, string1758_ast_substitute1773, "Illegal substitution", 20);
DEFINE_STRING(string1757_ast_substitute, string1757_ast_substitute1774, "duplicate", 9);
DEFINE_STATIC_PROCEDURE(do_substitute__default1463_env_78_ast_substitute, _do_substitute__default1463_54_ast_substitute1775, _do_substitute__default1463_54_ast_substitute, 0L, 2);



/* module-initialization */
obj_t 
module_initialization_70_ast_substitute(long checksum_1576, char *from_1577)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_ast_substitute))
	{
	   require_initialization_114_ast_substitute =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_ast_substitute();
	   cnst_init_137_ast_substitute();
	   imported_modules_init_94_ast_substitute();
	   method_init_76_ast_substitute();
	   toplevel_init_63_ast_substitute();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_ast_substitute()
{
   AN_OBJECT;
   {	/* Ast/substitute.scm 14 */
      module_initialization_70___object(((long) 0), "AST_SUBSTITUTE");
      module_initialization_70___eval(((long) 0), "AST_SUBSTITUTE");
      module_initialization_70___evenv(((long) 0), "AST_SUBSTITUTE");
      module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "AST_SUBSTITUTE");
      module_initialization_70___reader(((long) 0), "AST_SUBSTITUTE");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_ast_substitute()
{
   AN_OBJECT;
   {	/* Ast/substitute.scm 14 */
      {		/* Ast/substitute.scm 14 */
	 obj_t cnst_port_138_1569;
	 cnst_port_138_1569 =
	    open_input_string(string1762_ast_substitute);
	 {
	    long i_1570;
	    i_1570 = ((long) 14);
	  loop_1571:
	    {	/* Ast/substitute.scm 14 */
	       bool_t test1763_1572;
	       test1763_1572 =
		  (i_1570 == ((long) -1));
	       if (test1763_1572)
		 {	/* Ast/substitute.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Ast/substitute.scm 14 */
		    {	/* Ast/substitute.scm 14 */
		       obj_t arg1764_1573;
		       {	/* Ast/substitute.scm 14 */
			  obj_t list1765_1574;
			  list1765_1574 =
			     MAKE_PAIR(cnst_port_138_1569, BNIL);
			  arg1764_1573 =
			     read___reader(list1765_1574);
		       }
		       CNST_TABLE_SET(i_1570, arg1764_1573);
		    }
		    {	/* Ast/substitute.scm 14 */
		       int aux_1575;
		       {	/* Ast/substitute.scm 14 */
			  long aux_1597;
			  aux_1597 =
			     (i_1570 - ((long) 1));
			  aux_1575 =
			     (int) (aux_1597);
		       }
		       {
			  long i_1600;
			  i_1600 =
			     (long) (aux_1575);
			  i_1570 = i_1600;
			  goto loop_1571;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_ast_substitute()
{
   AN_OBJECT;
   {	/* Ast/substitute.scm 14 */
      return BUNSPEC;
   }
}



/* substitute! */
node_bglt 
substitute__30_ast_substitute(obj_t what__148_1, obj_t by__251_2, node_bglt node_3, obj_t site_4)
{
   AN_OBJECT;
   {	/* Ast/substitute.scm 34 */
      {		/* Ast/substitute.scm 35 */
	 bool_t test_1602;
	 {	/* Ast/substitute.scm 35 */
	    obj_t aux_1603;
	    aux_1603 =
	       memq___r4_pairs_and_lists_6_3(site_4,
	       CNST_TABLE_REF(((long) 0)));
	    test_1602 =
	       CBOOL(aux_1603);
	 }
	 if (test_1602)
	   {	/* Ast/substitute.scm 35 */
	      BUNSPEC;
	   }
	 else
	   {	/* Ast/substitute.scm 35 */
	      {		/* Ast/substitute.scm 35 */
		 obj_t arg1505_747;
		 obj_t arg1506_748;
		 arg1505_747 =
		    CNST_TABLE_REF(((long) 1));
		 arg1506_748 =
		    __EVMEANING_ADDRESS(site_4);
		 define_primop_ref__105___evenv(arg1505_747, arg1506_748);
	      }
	      notify_assert_fail_37___eval(
		 CNST_TABLE_REF(((long) 2)),
		 CNST_TABLE_REF(((long) 3)),
		 CNST_TABLE_REF(((long) 4)));
	      unbind_primop__163___evenv(
		 CNST_TABLE_REF(((long) 1)));
	   }
      }
      {
	 obj_t ll1437_749;
	 obj_t ll1438_750;
	 ll1437_749 = what__148_1;
	 ll1438_750 = by__251_2;
       lname1439_751:
	 if (
	    NULLP(ll1437_749))
	   {	/* Ast/substitute.scm 37 */
	      ((bool_t) 1);
	   }
	 else
	   {	/* Ast/substitute.scm 37 */
	      {		/* Ast/substitute.scm 37 */
		 obj_t what_753;
		 obj_t by_754;
		 what_753 =
		    CAR(ll1437_749);
		 by_754 =
		    CAR(ll1438_750);
		 {	/* Ast/substitute.scm 38 */
		    bool_t test1508_755;
		    test1508_755 =
		       is_a__118___object(by_754, variable_ast_var);
		    if (test1508_755)
		      {		/* Ast/substitute.scm 38 */
			 BUNSPEC;
		      }
		    else
		      {		/* Ast/substitute.scm 38 */
			 {	/* Ast/substitute.scm 38 */
			    obj_t arg1509_756;
			    obj_t arg1510_757;
			    arg1509_756 =
			       CNST_TABLE_REF(((long) 5));
			    arg1510_757 =
			       __EVMEANING_ADDRESS(by_754);
			    define_primop_ref__105___evenv(arg1509_756, arg1510_757);
			 }
			 notify_assert_fail_37___eval(
			    CNST_TABLE_REF(((long) 6)),
			    CNST_TABLE_REF(((long) 7)),
			    CNST_TABLE_REF(((long) 8)));
			 unbind_primop__163___evenv(
			    CNST_TABLE_REF(((long) 5)));
		      }
		 }
		 {	/* Ast/substitute.scm 39 */
		    variable_bglt obj_1323;
		    obj_1323 =
		       (variable_bglt) (what_753);
		    ((((variable_bglt) CREF(obj_1323))->fast_alpha_7) = ((obj_t) by_754), BUNSPEC);
		 }
	      }
	      {
		 obj_t ll1438_1635;
		 obj_t ll1437_1633;
		 ll1437_1633 =
		    CDR(ll1437_749);
		 ll1438_1635 =
		    CDR(ll1438_750);
		 ll1438_750 = ll1438_1635;
		 ll1437_749 = ll1437_1633;
		 goto lname1439_751;
	      }
	   }
      }
      {		/* Ast/substitute.scm 42 */
	 node_bglt res_760;
	 res_760 =
	    do_substitute__77_ast_substitute(node_3, site_4);
	 {
	    obj_t l1440_761;
	    l1440_761 = what__148_1;
	  lname1441_762:
	    if (
	       PAIRP(l1440_761))
	      {		/* Ast/substitute.scm 44 */
		 {	/* Ast/substitute.scm 45 */
		    variable_bglt obj_1329;
		    {	/* Ast/substitute.scm 45 */
		       obj_t aux_1640;
		       aux_1640 =
			  CAR(l1440_761);
		       obj_1329 =
			  (variable_bglt) (aux_1640);
		    }
		    ((((variable_bglt) CREF(obj_1329))->fast_alpha_7) = ((obj_t) BUNSPEC), BUNSPEC);
		 }
		 {
		    obj_t l1440_1644;
		    l1440_1644 =
		       CDR(l1440_761);
		    l1440_761 = l1440_1644;
		    goto lname1441_762;
		 }
	      }
	    else
	      {		/* Ast/substitute.scm 44 */
		 ((bool_t) 1);
	      }
	 }
	 return res_760;
      }
   }
}



/* _substitute!1755 */
obj_t 
_substitute_1755_196_ast_substitute(obj_t env_1558, obj_t what__148_1559, obj_t by__251_1560, obj_t node_1561, obj_t site_1562)
{
   AN_OBJECT;
   {	/* Ast/substitute.scm 34 */
      {		/* Ast/substitute.scm 34 */
	 node_bglt aux_1646;
	 aux_1646 =
	    substitute__30_ast_substitute(what__148_1559, by__251_1560,
	    (node_bglt) (node_1561), site_1562);
	 return
	    (obj_t) (aux_1646);
      }
   }
}



/* do-substitute*! */
obj_t 
do_substitute___56_ast_substitute(obj_t node__221_49, obj_t site_50)
{
   AN_OBJECT;
   {	/* Ast/substitute.scm 268 */
    do_substitute___56_ast_substitute:
      if (
	 NULLP(node__221_49))
	{	/* Ast/substitute.scm 270 */
	   return
	      CNST_TABLE_REF(((long) 9));
	}
      else
	{	/* Ast/substitute.scm 272 */
	   bool_t test_1653;
	   {	/* ./Ieee/pair-list.scm 5912 */
	      obj_t aux_1654;
	      aux_1654 =
		 CDR(node__221_49);
	      test_1653 =
		 NULLP(aux_1654);
	   }
	   if (test_1653)
	     {	/* Ast/substitute.scm 272 */
		{	/* Ast/substitute.scm 273 */
		   node_bglt arg1517_768;
		   {	/* Ast/substitute.scm 273 */
		      node_bglt aux_1657;
		      {		/* Ast/substitute.scm 273 */
			 obj_t aux_1658;
			 aux_1658 =
			    CAR(node__221_49);
			 aux_1657 =
			    (node_bglt) (aux_1658);
		      }
		      arg1517_768 =
			 do_substitute__77_ast_substitute(aux_1657, site_50);
		   }
		   {	/* ./Ieee/pair-list.scm 5890 */
		      obj_t aux_1662;
		      aux_1662 =
			 (obj_t) (arg1517_768);
		      SET_CAR(node__221_49, aux_1662);
		   }
		}
		return
		   CNST_TABLE_REF(((long) 9));
	     }
	   else
	     {	/* Ast/substitute.scm 272 */
		{	/* Ast/substitute.scm 276 */
		   node_bglt arg1520_770;
		   {	/* Ast/substitute.scm 276 */
		      node_bglt aux_1666;
		      {		/* Ast/substitute.scm 276 */
			 obj_t aux_1667;
			 aux_1667 =
			    CAR(node__221_49);
			 aux_1666 =
			    (node_bglt) (aux_1667);
		      }
		      arg1520_770 =
			 do_substitute__77_ast_substitute(aux_1666,
			 CNST_TABLE_REF(((long) 10)));
		   }
		   {	/* ./Ieee/pair-list.scm 5890 */
		      obj_t aux_1672;
		      aux_1672 =
			 (obj_t) (arg1520_770);
		      SET_CAR(node__221_49, aux_1672);
		   }
		}
		{
		   obj_t node__221_1675;
		   node__221_1675 =
		      CDR(node__221_49);
		   node__221_49 = node__221_1675;
		   goto do_substitute___56_ast_substitute;
		}
	     }
	}
   }
}



/* method-init */
obj_t 
method_init_76_ast_substitute()
{
   AN_OBJECT;
   {	/* Ast/substitute.scm 14 */
      add_generic__110___object(do_substitute__env_169_ast_substitute, do_substitute__default1463_env_78_ast_substitute);
      add_inlined_method__244___object(do_substitute__env_169_ast_substitute, atom_ast_node, ((long) 0));
      add_inlined_method__244___object(do_substitute__env_169_ast_substitute, var_ast_node, ((long) 1));
      add_inlined_method__244___object(do_substitute__env_169_ast_substitute, kwote_ast_node, ((long) 2));
      add_inlined_method__244___object(do_substitute__env_169_ast_substitute, sequence_ast_node, ((long) 3));
      add_inlined_method__244___object(do_substitute__env_169_ast_substitute, app_ast_node, ((long) 4));
      add_inlined_method__244___object(do_substitute__env_169_ast_substitute, app_ly_162_ast_node, ((long) 5));
      add_inlined_method__244___object(do_substitute__env_169_ast_substitute, funcall_ast_node, ((long) 6));
      add_inlined_method__244___object(do_substitute__env_169_ast_substitute, pragma_ast_node, ((long) 7));
      add_inlined_method__244___object(do_substitute__env_169_ast_substitute, cast_ast_node, ((long) 8));
      add_inlined_method__244___object(do_substitute__env_169_ast_substitute, setq_ast_node, ((long) 9));
      add_inlined_method__244___object(do_substitute__env_169_ast_substitute, conditional_ast_node, ((long) 10));
      add_inlined_method__244___object(do_substitute__env_169_ast_substitute, fail_ast_node, ((long) 11));
      add_inlined_method__244___object(do_substitute__env_169_ast_substitute, select_ast_node, ((long) 12));
      add_inlined_method__244___object(do_substitute__env_169_ast_substitute, let_fun_218_ast_node, ((long) 13));
      add_inlined_method__244___object(do_substitute__env_169_ast_substitute, let_var_6_ast_node, ((long) 14));
      add_inlined_method__244___object(do_substitute__env_169_ast_substitute, set_ex_it_116_ast_node, ((long) 15));
      add_inlined_method__244___object(do_substitute__env_169_ast_substitute, jump_ex_it_184_ast_node, ((long) 16));
      add_inlined_method__244___object(do_substitute__env_169_ast_substitute, make_box_202_ast_node, ((long) 17));
      add_inlined_method__244___object(do_substitute__env_169_ast_substitute, box_ref_242_ast_node, ((long) 18));
      {		/* Ast/substitute.scm 14 */
	 long aux_1697;
	 aux_1697 =
	    add_inlined_method__244___object(do_substitute__env_169_ast_substitute, box_set__221_ast_node, ((long) 19));
	 return
	    BINT(aux_1697);
      }
   }
}



/* do-substitute! */
node_bglt 
do_substitute__77_ast_substitute(node_bglt node_5, obj_t site_6)
{
   AN_OBJECT;
   {	/* Ast/substitute.scm 52 */
      {
	 obj_t method1605_1105;
	 obj_t class1610_1106;
	 {	/* Ast/substitute.scm 52 */
	    obj_t arg1613_1103;
	    obj_t arg1614_1104;
	    {	/* Ast/substitute.scm 52 */
	       object_bglt obj_1356;
	       obj_1356 =
		  (object_bglt) (node_5);
	       {	/* ./Llib/object.scm 2926 */
		  obj_t pre_method_105_1357;
		  pre_method_105_1357 =
		     PROCEDURE_REF(do_substitute__env_169_ast_substitute, ((long) 2));
		  if (
		     INTEGERP(pre_method_105_1357))
		    {	/* ./Llib/object.scm 2927 */
		       PROCEDURE_SET(do_substitute__env_169_ast_substitute, ((long) 2), BUNSPEC);
		       arg1613_1103 = pre_method_105_1357;
		    }
		  else
		    {	/* ./Llib/object.scm 2914 */
		       long obj_class_num_177_1362;
		       obj_class_num_177_1362 =
			  TYPE(obj_1356);
		       {	/* ./Llib/object.scm 2915 */
			  obj_t arg1176_1363;
			  arg1176_1363 =
			     PROCEDURE_REF(do_substitute__env_169_ast_substitute, ((long) 1));
			  {	/* ./Llib/object.scm 2738 */
			     long arg1177_1367;
			     {	/* ./Llib/object.scm 2738 */
				long arg1178_1368;
				arg1178_1368 =
				   OBJECT_TYPE;
				arg1177_1367 =
				   (obj_class_num_177_1362 - arg1178_1368);
			     }
			     arg1613_1103 =
				VECTOR_REF(arg1176_1363, arg1177_1367);
			  }
		       }
		    }
	       }
	    }
	    {	/* Ast/substitute.scm 52 */
	       object_bglt object_1373;
	       object_1373 =
		  (object_bglt) (node_5);
	       {	/* ./Llib/object.scm 2695 */
		  long arg1179_1374;
		  {	/* ./Llib/object.scm 2695 */
		     long arg1180_1375;
		     long arg1181_1376;
		     arg1180_1375 =
			TYPE(object_1373);
		     arg1181_1376 =
			OBJECT_TYPE;
		     arg1179_1374 =
			(arg1180_1375 - arg1181_1376);
		  }
		  {	/* ./Llib/object.scm 2695 */
		     obj_t vector_1380;
		     vector_1380 = _classes__134___object;
		     arg1614_1104 =
			VECTOR_REF(vector_1380, arg1179_1374);
		  }
	       }
	    }
	    {	/* Ast/substitute.scm 52 */
	       obj_t aux_1715;
	       method1605_1105 = arg1613_1103;
	       class1610_1106 = arg1614_1104;
	       {

		  if (
		     INTEGERP(method1605_1105))
		    {	/* Ast/substitute.scm 52 */
		       switch (
			  (long) CINT(method1605_1105))
			 {
			 case ((long) 0):

			    {	/* Ast/substitute.scm 52 */
			       atom_bglt aux_1718;
			       aux_1718 =
				  (atom_bglt) (node_5);
			       aux_1715 =
				  (obj_t) (aux_1718);
			    }
			    break;
			 case ((long) 1):

			    {	/* Ast/substitute.scm 64 */
			       var_bglt node_1114;
			       node_1114 =
				  (var_bglt) (node_5);
			       {	/* Ast/substitute.scm 64 */
				  variable_bglt var_1116;
				  var_1116 =
				     (((var_bglt) CREF(node_1114))->variable);
				  {	/* Ast/substitute.scm 65 */

				     {
					obj_t alpha_1118;
					alpha_1118 =
					   (((variable_bglt) CREF(var_1116))->fast_alpha_7);
				      loop_1119:
					if (
					   (alpha_1118 == BUNSPEC))
					  {	/* Ast/substitute.scm 68 */
					     aux_1715 =
						(obj_t) (node_1114);
					  }
					else
					  {	/* Ast/substitute.scm 70 */
					     bool_t test1618_1121;
					     test1618_1121 =
						is_a__118___object(alpha_1118, var_ast_node);
					     if (test1618_1121)
					       {	/* Ast/substitute.scm 70 */
						  {
						     obj_t alpha_1728;
						     {	/* Ast/substitute.scm 71 */
							variable_bglt aux_1729;
							{	/* Ast/substitute.scm 71 */
							   var_bglt obj_1387;
							   obj_1387 =
							      (var_bglt) (alpha_1118);
							   aux_1729 =
							      (((var_bglt) CREF(obj_1387))->variable);
							}
							alpha_1728 =
							   (obj_t) (aux_1729);
						     }
						     alpha_1118 = alpha_1728;
						     goto loop_1119;
						  }
					       }
					     else
					       {	/* Ast/substitute.scm 72 */
						  bool_t test1620_1123;
						  test1620_1123 =
						     is_a__118___object(alpha_1118, variable_ast_var);
						  if (test1620_1123)
						    {	/* Ast/substitute.scm 72 */
						       {	/* Ast/substitute.scm 73 */
							  obj_t aux_1735;
							  {	/* Ast/substitute.scm 73 */
							     node_bglt obj_1389;
							     obj_1389 =
								(node_bglt) (node_1114);
							     aux_1735 =
								(((node_bglt) CREF(obj_1389))->loc);
							  }
							  use_variable__4_ast_sexp(
							     (variable_bglt) (alpha_1118), aux_1735, site_6);
						       }
						       {	/* Ast/substitute.scm 74 */
							  bool_t test1622_1125;
							  {	/* Ast/substitute.scm 74 */
							     bool_t test1629_1132;
							     {	/* ./Ast/var.scm 785 */
								obj_t aux_1740;
								{	/* Ast/substitute.scm 74 */
								   value_bglt aux_1741;
								   {	/* Ast/substitute.scm 74 */
								      variable_bglt obj_1390;
								      obj_1390 =
									 (variable_bglt) (alpha_1118);
								      aux_1741 =
									 (((variable_bglt) CREF(obj_1390))->value);
								   }
								   aux_1740 =
								      (obj_t) (aux_1741);
								}
								test1629_1132 =
								   is_a__118___object(aux_1740, fun_ast_var);
							     }
							     if (test1629_1132)
							       {	/* Ast/substitute.scm 74 */
								  bool_t test_1747;
								  {	/* ./Ieee/equiv.scm 5508 */
								     obj_t aux_1748;
								     aux_1748 =
									CNST_TABLE_REF(((long) 11));
								     test_1747 =
									(site_6 == aux_1748);
								  }
								  if (test_1747)
								    {	/* Ast/substitute.scm 74 */
								       test1622_1125 = ((bool_t) 0);
								    }
								  else
								    {	/* Ast/substitute.scm 74 */
								       test1622_1125 = ((bool_t) 1);
								    }
							       }
							     else
							       {	/* Ast/substitute.scm 74 */
								  test1622_1125 = ((bool_t) 0);
							       }
							  }
							  if (test1622_1125)
							    {	/* Ast/substitute.scm 76 */
							       obj_t arg1623_1126;
							       type_bglt arg1624_1127;
							       {	/* Ast/substitute.scm 76 */
								  node_bglt obj_1394;
								  obj_1394 =
								     (node_bglt) (node_1114);
								  arg1623_1126 =
								     (((node_bglt) CREF(obj_1394))->loc);
							       }
							       {	/* Ast/substitute.scm 77 */
								  node_bglt obj_1395;
								  obj_1395 =
								     (node_bglt) (node_1114);
								  arg1624_1127 =
								     (((node_bglt) CREF(obj_1395))->type);
							       }
							       {	/* Ast/substitute.scm 75 */
								  closure_bglt res1751_1406;
								  {	/* Ast/substitute.scm 75 */
								     variable_bglt variable_1398;
								     variable_1398 =
									(variable_bglt) (alpha_1118);
								     {	/* ./Ast/node.scm 898 */
									closure_bglt new1218_1399;
									new1218_1399 =
									   ((closure_bglt) BREF(GC_MALLOC(sizeof(struct closure))));
									{	/* ./Ast/node.scm 898 */
									   long arg1568_1400;
									   arg1568_1400 =
									      class_num_218___object(closure_ast_node);
									   {	/* ./Ast/node.scm 898 */
									      obj_t obj_1404;
									      obj_1404 =
										 (obj_t) (new1218_1399);
									      (((obj_t) CREF(obj_1404))->header = MAKE_HEADER(arg1568_1400, 0), BUNSPEC);
									   }
									}
									{	/* ./Ast/node.scm 898 */
									   object_bglt aux_1761;
									   aux_1761 =
									      (object_bglt) (new1218_1399);
									   OBJECT_WIDENING_SET(aux_1761, BFALSE);
									}
									((((closure_bglt) CREF(new1218_1399))->loc) = ((obj_t) arg1623_1126), BUNSPEC);
									((((closure_bglt) CREF(new1218_1399))->type) = ((type_bglt) arg1624_1127), BUNSPEC);
									((((closure_bglt) CREF(new1218_1399))->variable) = ((variable_bglt) variable_1398), BUNSPEC);
									res1751_1406 = new1218_1399;
								     }
								  }
								  aux_1715 =
								     (obj_t) (res1751_1406);
							       }
							    }
							  else
							    {	/* Ast/substitute.scm 80 */
							       obj_t arg1626_1129;
							       type_bglt arg1627_1130;
							       {	/* Ast/substitute.scm 80 */
								  node_bglt obj_1407;
								  obj_1407 =
								     (node_bglt) (node_1114);
								  arg1626_1129 =
								     (((node_bglt) CREF(obj_1407))->loc);
							       }
							       {	/* Ast/substitute.scm 81 */
								  node_bglt obj_1408;
								  obj_1408 =
								     (node_bglt) (node_1114);
								  arg1627_1130 =
								     (((node_bglt) CREF(obj_1408))->type);
							       }
							       {	/* Ast/substitute.scm 79 */
								  var_bglt res1752_1419;
								  {	/* Ast/substitute.scm 79 */
								     variable_bglt variable_1411;
								     variable_1411 =
									(variable_bglt) (alpha_1118);
								     {	/* ./Ast/node.scm 893 */
									var_bglt new1210_1412;
									new1210_1412 =
									   ((var_bglt) BREF(GC_MALLOC(sizeof(struct var))));
									{	/* ./Ast/node.scm 893 */
									   long arg1571_1413;
									   arg1571_1413 =
									      class_num_218___object(var_ast_node);
									   {	/* ./Ast/node.scm 893 */
									      obj_t obj_1417;
									      obj_1417 =
										 (obj_t) (new1210_1412);
									      (((obj_t) CREF(obj_1417))->header = MAKE_HEADER(arg1571_1413, 0), BUNSPEC);
									   }
									}
									{	/* ./Ast/node.scm 893 */
									   object_bglt aux_1777;
									   aux_1777 =
									      (object_bglt) (new1210_1412);
									   OBJECT_WIDENING_SET(aux_1777, BFALSE);
									}
									((((var_bglt) CREF(new1210_1412))->loc) = ((obj_t) arg1626_1129), BUNSPEC);
									((((var_bglt) CREF(new1210_1412))->type) = ((type_bglt) arg1627_1130), BUNSPEC);
									((((var_bglt) CREF(new1210_1412))->variable) = ((variable_bglt) variable_1411), BUNSPEC);
									res1752_1419 = new1210_1412;
								     }
								  }
								  aux_1715 =
								     (obj_t) (res1752_1419);
							       }
							    }
						       }
						    }
						  else
						    {	/* Ast/substitute.scm 83 */
						       bool_t test1632_1135;
						       test1632_1135 =
							  is_a__118___object(alpha_1118, atom_ast_node);
						       if (test1632_1135)
							 {	/* Ast/substitute.scm 83 */
							    aux_1715 = alpha_1118;
							 }
						       else
							 {	/* Ast/substitute.scm 83 */
							    {	/* Ast/substitute.scm 86 */
							       obj_t arg1635_1138;
							       arg1635_1138 =
								  shape_tools_shape(
								  (obj_t) (node_1114));
							       aux_1715 =
								  internal_error_43_tools_error(string1757_ast_substitute, string1758_ast_substitute, arg1635_1138);
							    }
							 }
						    }
					       }
					  }
				     }
				  }
			       }
			    }
			    break;
			 case ((long) 2):

			    {	/* Ast/substitute.scm 52 */
			       kwote_bglt aux_1790;
			       aux_1790 =
				  (kwote_bglt) (node_5);
			       aux_1715 =
				  (obj_t) (aux_1790);
			    }
			    break;
			 case ((long) 3):

			    {	/* Ast/substitute.scm 52 */
			       sequence_bglt node_1141;
			       node_1141 =
				  (sequence_bglt) (node_5);
			       do_substitute___56_ast_substitute(
				  (((sequence_bglt) CREF(node_1141))->nodes), site_6);
			       aux_1715 =
				  (obj_t) (node_1141);
			    }
			    break;
			 case ((long) 4):

			    {	/* Ast/substitute.scm 52 */
			       app_bglt node_1144;
			       node_1144 =
				  (app_bglt) (node_5);
			       {	/* Ast/substitute.scm 107 */
				  node_bglt arg1637_1146;
				  {	/* Ast/substitute.scm 107 */
				     node_bglt aux_1798;
				     {	/* Ast/substitute.scm 107 */
					var_bglt aux_1799;
					aux_1799 =
					   (((app_bglt) CREF(node_1144))->fun);
					aux_1798 =
					   (node_bglt) (aux_1799);
				     }
				     arg1637_1146 =
					do_substitute__77_ast_substitute(aux_1798,
					CNST_TABLE_REF(((long) 11)));
				  }
				  {	/* Ast/substitute.scm 107 */
				     var_bglt val1245_1424;
				     val1245_1424 =
					(var_bglt) (arg1637_1146);
				     ((((app_bglt) CREF(node_1144))->fun) = ((var_bglt) val1245_1424), BUNSPEC);
				  }
			       }
			       do_substitute___56_ast_substitute(
				  (((app_bglt) CREF(node_1144))->args),
				  CNST_TABLE_REF(((long) 10)));
			       aux_1715 =
				  (obj_t) (node_1144);
			    }
			    break;
			 case ((long) 5):

			    {	/* Ast/substitute.scm 115 */
			       app_ly_162_bglt node_1151;
			       node_1151 =
				  (app_ly_162_bglt) (node_5);
			       {	/* Ast/substitute.scm 116 */
				  node_bglt nfun_1154;
				  node_bglt narg_1155;
				  nfun_1154 =
				     do_substitute__77_ast_substitute(
				     (((app_ly_162_bglt) CREF(node_1151))->fun),
				     CNST_TABLE_REF(((long) 12)));
				  narg_1155 =
				     do_substitute__77_ast_substitute(
				     (((app_ly_162_bglt) CREF(node_1151))->arg),
				     CNST_TABLE_REF(((long) 10)));
				  {	/* Ast/substitute.scm 118 */
				     bool_t test1642_1156;
				     test1642_1156 =
					is_a__118___object(
					(obj_t) (nfun_1154), closure_ast_node);
				     if (test1642_1156)
				       {	/* Ast/substitute.scm 119 */
					  obj_t arg1644_1158;
					  var_bglt arg1646_1159;
					  arg1644_1158 =
					     (((app_ly_162_bglt) CREF(node_1151))->loc);
					  {	/* Ast/substitute.scm 119 */
					     var_bglt duplicated1445_1160;
					     duplicated1445_1160 =
						(var_bglt) (nfun_1154);
					     {	/* Ast/substitute.scm 119 */
						var_bglt new1446_1161;
						{	/* Ast/substitute.scm 119 */
						   obj_t arg1647_1162;
						   type_bglt arg1648_1163;
						   variable_bglt arg1649_1164;
						   arg1647_1162 =
						      (((var_bglt) CREF(duplicated1445_1160))->loc);
						   arg1648_1163 =
						      (((var_bglt) CREF(duplicated1445_1160))->type);
						   arg1649_1164 =
						      (((var_bglt) CREF(duplicated1445_1160))->variable);
						   {	/* Ast/substitute.scm 119 */
						      var_bglt res1753_1443;
						      {		/* ./Ast/node.scm 893 */
							 var_bglt new1210_1436;
							 new1210_1436 =
							    ((var_bglt) BREF(GC_MALLOC(sizeof(struct var))));
							 {	/* ./Ast/node.scm 893 */
							    long arg1571_1437;
							    arg1571_1437 =
							       class_num_218___object(var_ast_node);
							    {	/* ./Ast/node.scm 893 */
							       obj_t obj_1441;
							       obj_1441 =
								  (obj_t) (new1210_1436);
							       (((obj_t) CREF(obj_1441))->header = MAKE_HEADER(arg1571_1437, 0), BUNSPEC);
							    }
							 }
							 {	/* ./Ast/node.scm 893 */
							    object_bglt aux_1829;
							    aux_1829 =
							       (object_bglt) (new1210_1436);
							    OBJECT_WIDENING_SET(aux_1829, BFALSE);
							 }
							 ((((var_bglt) CREF(new1210_1436))->loc) = ((obj_t) arg1647_1162), BUNSPEC);
							 ((((var_bglt) CREF(new1210_1436))->type) = ((type_bglt) arg1648_1163), BUNSPEC);
							 ((((var_bglt) CREF(new1210_1436))->variable) = ((variable_bglt) arg1649_1164), BUNSPEC);
							 res1753_1443 = new1210_1436;
						      }
						      new1446_1161 = res1753_1443;
						   }
						}
						{	/* Ast/substitute.scm 119 */

						   arg1646_1159 = new1446_1161;
						}
					     }
					  }
					  {	/* Ast/substitute.scm 119 */
					     node_bglt aux_1835;
					     aux_1835 =
						known_app_ly__node_26_ast_apply(BNIL, arg1644_1158,
						(node_bglt) (arg1646_1159), narg_1155, site_6);
					     aux_1715 =
						(obj_t) (aux_1835);
					  }
				       }
				     else
				       {	/* Ast/substitute.scm 118 */
					  ((((app_ly_162_bglt) CREF(node_1151))->fun) = ((node_bglt) nfun_1154), BUNSPEC);
					  ((((app_ly_162_bglt) CREF(node_1151))->arg) = ((node_bglt) narg_1155), BUNSPEC);
					  aux_1715 =
					     (obj_t) (node_1151);
				       }
				  }
			       }
			    }
			    break;
			 case ((long) 6):

			    {	/* Ast/substitute.scm 132 */
			       funcall_bglt node_1169;
			       node_1169 =
				  (funcall_bglt) (node_5);
			       {	/* Ast/substitute.scm 133 */
				  node_bglt nfun_1172;
				  obj_t nargs_1173;
				  nfun_1172 =
				     do_substitute__77_ast_substitute(
				     (((funcall_bglt) CREF(node_1169))->fun),
				     CNST_TABLE_REF(((long) 10)));
				  {	/* Ast/substitute.scm 134 */
				     obj_t l1448_1192;
				     l1448_1192 =
					(((funcall_bglt) CREF(node_1169))->args);
				     if (
					NULLP(l1448_1192))
				       {	/* Ast/substitute.scm 134 */
					  nargs_1173 = BNIL;
				       }
				     else
				       {	/* Ast/substitute.scm 134 */
					  obj_t head1450_1194;
					  head1450_1194 =
					     MAKE_PAIR(BNIL, BNIL);
					  {
					     obj_t l1448_1195;
					     obj_t tail1451_1196;
					     l1448_1195 = l1448_1192;
					     tail1451_1196 = head1450_1194;
					   lname1449_1197:
					     if (
						NULLP(l1448_1195))
					       {	/* Ast/substitute.scm 134 */
						  nargs_1173 =
						     CDR(head1450_1194);
					       }
					     else
					       {	/* Ast/substitute.scm 134 */
						  obj_t newtail1452_1199;
						  {	/* Ast/substitute.scm 134 */
						     node_bglt arg1675_1201;
						     {	/* Ast/substitute.scm 134 */
							node_bglt aux_1853;
							{	/* Ast/substitute.scm 134 */
							   obj_t aux_1854;
							   aux_1854 =
							      CAR(l1448_1195);
							   aux_1853 =
							      (node_bglt) (aux_1854);
							}
							arg1675_1201 =
							   do_substitute__77_ast_substitute(aux_1853,
							   CNST_TABLE_REF(((long) 10)));
						     }
						     {	/* ./Ieee/pair-list.scm 5689 */
							obj_t aux_1859;
							aux_1859 =
							   (obj_t) (arg1675_1201);
							newtail1452_1199 =
							   MAKE_PAIR(aux_1859, BNIL);
						     }
						  }
						  SET_CDR(tail1451_1196, newtail1452_1199);
						  {
						     obj_t tail1451_1865;
						     obj_t l1448_1863;
						     l1448_1863 =
							CDR(l1448_1195);
						     tail1451_1865 = newtail1452_1199;
						     tail1451_1196 = tail1451_1865;
						     l1448_1195 = l1448_1863;
						     goto lname1449_1197;
						  }
					       }
					  }
				       }
				  }
				  {	/* Ast/substitute.scm 135 */
				     bool_t test1654_1174;
				     {	/* Ast/substitute.scm 135 */
					bool_t test1666_1186;
					test1666_1186 =
					   is_a__118___object(
					   (obj_t) (nfun_1172), closure_ast_node);
					if (test1666_1186)
					  {	/* Ast/substitute.scm 135 */
					     test1654_1174 = ((bool_t) 1);
					  }
					else
					  {	/* Ast/substitute.scm 136 */
					     bool_t _andtest_1453_1187;
					     _andtest_1453_1187 =
						is_a__118___object(
						(obj_t) (nfun_1172), var_ast_node);
					     if (_andtest_1453_1187)
					       {	/* ./Ast/var.scm 785 */
						  obj_t aux_1872;
						  {	/* Ast/substitute.scm 137 */
						     value_bglt aux_1873;
						     {	/* Ast/substitute.scm 137 */
							variable_bglt arg1669_1189;
							{	/* Ast/substitute.scm 137 */
							   var_bglt obj_1463;
							   obj_1463 =
							      (var_bglt) (nfun_1172);
							   arg1669_1189 =
							      (((var_bglt) CREF(obj_1463))->variable);
							}
							aux_1873 =
							   (((variable_bglt) CREF(arg1669_1189))->value);
						     }
						     aux_1872 =
							(obj_t) (aux_1873);
						  }
						  test1654_1174 =
						     is_a__118___object(aux_1872, fun_ast_var);
					       }
					     else
					       {	/* Ast/substitute.scm 136 */
						  test1654_1174 = ((bool_t) 0);
					       }
					  }
				     }
				     if (test1654_1174)
				       {	/* Ast/substitute.scm 138 */
					  bool_t test1655_1175;
					  {	/* Ast/substitute.scm 138 */
					     variable_bglt aux_1880;
					     {	/* Ast/substitute.scm 138 */
						var_bglt obj_1466;
						obj_1466 =
						   (var_bglt) (nfun_1172);
						aux_1880 =
						   (((var_bglt) CREF(obj_1466))->variable);
					     }
					     test1655_1175 =
						correct_arity_app__187_ast_app(aux_1880,
						CDR(nargs_1173));
					  }
					  if (test1655_1175)
					    {	/* Ast/substitute.scm 140 */
					       node_bglt aux_1886;
					       aux_1886 =
						  make_app_node_80_ast_app(BNIL,
						  (((funcall_bglt) CREF(node_1169))->loc),
						  (var_bglt) (nfun_1172),
						  CDR(nargs_1173));
					       aux_1715 =
						  (obj_t) (aux_1886);
					    }
					  else
					    {	/* Ast/substitute.scm 144 */
					       obj_t arg1659_1179;
					       obj_t arg1662_1182;
					       arg1659_1179 =
						  (((funcall_bglt) CREF(node_1169))->loc);
					       arg1662_1182 =
						  shape_tools_shape(
						  (obj_t) (node_1169));
					       aux_1715 =
						  user_error_location_137_tools_error(arg1659_1179, string1759_ast_substitute, string1760_ast_substitute, arg1662_1182, BNIL);
					    }
				       }
				     else
				       {	/* Ast/substitute.scm 135 */
					  ((((funcall_bglt) CREF(node_1169))->fun) = ((node_bglt) nfun_1172), BUNSPEC);
					  ((((funcall_bglt) CREF(node_1169))->args) = ((obj_t) nargs_1173), BUNSPEC);
					  aux_1715 =
					     (obj_t) (node_1169);
				       }
				  }
			       }
			    }
			    break;
			 case ((long) 7):

			    {	/* Ast/substitute.scm 52 */
			       pragma_bglt node_1204;
			       node_1204 =
				  (pragma_bglt) (node_5);
			       do_substitute___56_ast_substitute(
				  (((pragma_bglt) CREF(node_1204))->args), site_6);
			       aux_1715 =
				  (obj_t) (node_1204);
			    }
			    break;
			 case ((long) 8):

			    {	/* Ast/substitute.scm 52 */
			       cast_bglt node_1207;
			       node_1207 =
				  (cast_bglt) (node_5);
			       do_substitute__77_ast_substitute(
				  (((cast_bglt) CREF(node_1207))->arg), site_6);
			       aux_1715 =
				  (obj_t) (node_1207);
			    }
			    break;
			 case ((long) 9):

			    {	/* Ast/substitute.scm 171 */
			       setq_bglt node_1210;
			       node_1210 =
				  (setq_bglt) (node_5);
			       {	/* Ast/substitute.scm 172 */
				  node_bglt arg1679_1213;
				  {	/* Ast/substitute.scm 172 */
				     node_bglt aux_1908;
				     {	/* Ast/substitute.scm 172 */
					var_bglt aux_1909;
					aux_1909 =
					   (((setq_bglt) CREF(node_1210))->var);
					aux_1908 =
					   (node_bglt) (aux_1909);
				     }
				     arg1679_1213 =
					do_substitute__77_ast_substitute(aux_1908,
					CNST_TABLE_REF(((long) 13)));
				  }
				  {	/* Ast/substitute.scm 172 */
				     var_bglt val1302_1479;
				     val1302_1479 =
					(var_bglt) (arg1679_1213);
				     ((((setq_bglt) CREF(node_1210))->var) = ((var_bglt) val1302_1479), BUNSPEC);
				  }
			       }
			       {	/* Ast/substitute.scm 173 */
				  node_bglt arg1682_1216;
				  arg1682_1216 =
				     do_substitute__77_ast_substitute(
				     (((setq_bglt) CREF(node_1210))->value), site_6);
				  ((((setq_bglt) CREF(node_1210))->value) = ((node_bglt) arg1682_1216), BUNSPEC);
			       }
			       aux_1715 =
				  (obj_t) (node_1210);
			    }
			    break;
			 case ((long) 10):

			    {	/* Ast/substitute.scm 180 */
			       conditional_bglt node_1218;
			       node_1218 =
				  (conditional_bglt) (node_5);
			       {	/* Ast/substitute.scm 181 */
				  node_bglt arg1684_1221;
				  arg1684_1221 =
				     do_substitute__77_ast_substitute(
				     (((conditional_bglt) CREF(node_1218))->test),
				     CNST_TABLE_REF(((long) 10)));
				  ((((conditional_bglt) CREF(node_1218))->test) = ((node_bglt) arg1684_1221), BUNSPEC);
			       }
			       {	/* Ast/substitute.scm 182 */
				  node_bglt arg1687_1224;
				  arg1687_1224 =
				     do_substitute__77_ast_substitute(
				     (((conditional_bglt) CREF(node_1218))->true), site_6);
				  ((((conditional_bglt) CREF(node_1218))->true) = ((node_bglt) arg1687_1224), BUNSPEC);
			       }
			       {	/* Ast/substitute.scm 183 */
				  node_bglt arg1689_1226;
				  arg1689_1226 =
				     do_substitute__77_ast_substitute(
				     (((conditional_bglt) CREF(node_1218))->false), site_6);
				  ((((conditional_bglt) CREF(node_1218))->false) = ((node_bglt) arg1689_1226), BUNSPEC);
			       }
			       aux_1715 =
				  (obj_t) (node_1218);
			    }
			    break;
			 case ((long) 11):

			    {	/* Ast/substitute.scm 190 */
			       fail_bglt node_1228;
			       node_1228 =
				  (fail_bglt) (node_5);
			       {	/* Ast/substitute.scm 191 */
				  node_bglt arg1691_1231;
				  arg1691_1231 =
				     do_substitute__77_ast_substitute(
				     (((fail_bglt) CREF(node_1228))->proc),
				     CNST_TABLE_REF(((long) 10)));
				  ((((fail_bglt) CREF(node_1228))->proc) = ((node_bglt) arg1691_1231), BUNSPEC);
			       }
			       {	/* Ast/substitute.scm 192 */
				  node_bglt arg1694_1234;
				  arg1694_1234 =
				     do_substitute__77_ast_substitute(
				     (((fail_bglt) CREF(node_1228))->msg),
				     CNST_TABLE_REF(((long) 10)));
				  ((((fail_bglt) CREF(node_1228))->msg) = ((node_bglt) arg1694_1234), BUNSPEC);
			       }
			       {	/* Ast/substitute.scm 193 */
				  node_bglt arg1697_1237;
				  arg1697_1237 =
				     do_substitute__77_ast_substitute(
				     (((fail_bglt) CREF(node_1228))->obj),
				     CNST_TABLE_REF(((long) 10)));
				  ((((fail_bglt) CREF(node_1228))->obj) = ((node_bglt) arg1697_1237), BUNSPEC);
			       }
			       aux_1715 =
				  (obj_t) (node_1228);
			    }
			    break;
			 case ((long) 12):

			    {	/* Ast/substitute.scm 52 */
			       select_bglt node_1240;
			       node_1240 =
				  (select_bglt) (node_5);
			       {	/* Ast/substitute.scm 200 */
				  node_bglt arg1700_1242;
				  arg1700_1242 =
				     do_substitute__77_ast_substitute(
				     (((select_bglt) CREF(node_1240))->test),
				     CNST_TABLE_REF(((long) 10)));
				  ((((select_bglt) CREF(node_1240))->test) = ((node_bglt) arg1700_1242), BUNSPEC);
			       }
			       {
				  obj_t l1457_1245;
				  l1457_1245 =
				     (((select_bglt) CREF(node_1240))->clauses);
				lname1458_1246:
				  if (
				     PAIRP(l1457_1245))
				    {	/* Ast/substitute.scm 201 */
				       {	/* Ast/substitute.scm 202 */
					  obj_t clause_1249;
					  clause_1249 =
					     CAR(l1457_1245);
					  {	/* Ast/substitute.scm 202 */
					     node_bglt arg1705_1250;
					     {	/* Ast/substitute.scm 202 */
						node_bglt aux_1954;
						{	/* Ast/substitute.scm 202 */
						   obj_t aux_1955;
						   aux_1955 =
						      CDR(clause_1249);
						   aux_1954 =
						      (node_bglt) (aux_1955);
						}
						arg1705_1250 =
						   do_substitute__77_ast_substitute(aux_1954, site_6);
					     }
					     {	/* ./Ieee/pair-list.scm 5896 */
						obj_t aux_1959;
						aux_1959 =
						   (obj_t) (arg1705_1250);
						SET_CDR(clause_1249, aux_1959);
					     }
					  }
				       }
				       {
					  obj_t l1457_1962;
					  l1457_1962 =
					     CDR(l1457_1245);
					  l1457_1245 = l1457_1962;
					  goto lname1458_1246;
				       }
				    }
				  else
				    {	/* Ast/substitute.scm 201 */
				       ((bool_t) 1);
				    }
			       }
			       aux_1715 =
				  (obj_t) (node_1240);
			    }
			    break;
			 case ((long) 13):

			    {	/* Ast/substitute.scm 52 */
			       let_fun_218_bglt node_1253;
			       node_1253 =
				  (let_fun_218_bglt) (node_5);
			       {
				  obj_t l1459_1255;
				  l1459_1255 =
				     (((let_fun_218_bglt) CREF(node_1253))->locals);
				lname1460_1256:
				  if (
				     PAIRP(l1459_1255))
				    {	/* Ast/substitute.scm 210 */
				       {	/* Ast/substitute.scm 211 */
					  value_bglt fun_1260;
					  {	/* Ast/substitute.scm 211 */
					     local_bglt obj_1514;
					     {	/* Ast/substitute.scm 211 */
						obj_t aux_1969;
						aux_1969 =
						   CAR(l1459_1255);
						obj_1514 =
						   (local_bglt) (aux_1969);
					     }
					     fun_1260 =
						(((local_bglt) CREF(obj_1514))->value);
					  }
					  {	/* Ast/substitute.scm 212 */
					     node_bglt arg1711_1261;
					     {	/* Ast/substitute.scm 212 */
						node_bglt aux_1973;
						{	/* Ast/substitute.scm 212 */
						   obj_t aux_1974;
						   {	/* Ast/substitute.scm 212 */
						      sfun_bglt obj_1515;
						      obj_1515 =
							 (sfun_bglt) (fun_1260);
						      aux_1974 =
							 (((sfun_bglt) CREF(obj_1515))->body);
						   }
						   aux_1973 =
						      (node_bglt) (aux_1974);
						}
						arg1711_1261 =
						   do_substitute__77_ast_substitute(aux_1973,
						   CNST_TABLE_REF(((long) 10)));
					     }
					     {	/* Ast/substitute.scm 212 */
						sfun_bglt obj_1516;
						obj_t val1123_1517;
						obj_1516 =
						   (sfun_bglt) (fun_1260);
						val1123_1517 =
						   (obj_t) (arg1711_1261);
						((((sfun_bglt) CREF(obj_1516))->body) = ((obj_t) val1123_1517), BUNSPEC);
					     }
					  }
				       }
				       {
					  obj_t l1459_1983;
					  l1459_1983 =
					     CDR(l1459_1255);
					  l1459_1255 = l1459_1983;
					  goto lname1460_1256;
				       }
				    }
				  else
				    {	/* Ast/substitute.scm 210 */
				       ((bool_t) 1);
				    }
			       }
			       {	/* Ast/substitute.scm 215 */
				  node_bglt arg1715_1265;
				  arg1715_1265 =
				     do_substitute__77_ast_substitute(
				     (((let_fun_218_bglt) CREF(node_1253))->body), site_6);
				  ((((let_fun_218_bglt) CREF(node_1253))->body) = ((node_bglt) arg1715_1265), BUNSPEC);
			       }
			       aux_1715 =
				  (obj_t) (node_1253);
			    }
			    break;
			 case ((long) 14):

			    {	/* Ast/substitute.scm 52 */
			       let_var_6_bglt node_1267;
			       node_1267 =
				  (let_var_6_bglt) (node_5);
			       {
				  obj_t l1461_1269;
				  l1461_1269 =
				     (((let_var_6_bglt) CREF(node_1267))->bindings);
				lname1462_1270:
				  if (
				     PAIRP(l1461_1269))
				    {	/* Ast/substitute.scm 222 */
				       {	/* Ast/substitute.scm 223 */
					  obj_t binding_1273;
					  binding_1273 =
					     CAR(l1461_1269);
					  {	/* Ast/substitute.scm 223 */
					     node_bglt arg1719_1274;
					     {	/* Ast/substitute.scm 223 */
						node_bglt aux_1994;
						{	/* Ast/substitute.scm 223 */
						   obj_t aux_1995;
						   aux_1995 =
						      CDR(binding_1273);
						   aux_1994 =
						      (node_bglt) (aux_1995);
						}
						arg1719_1274 =
						   do_substitute__77_ast_substitute(aux_1994,
						   CNST_TABLE_REF(((long) 10)));
					     }
					     {	/* ./Ieee/pair-list.scm 5896 */
						obj_t aux_2000;
						aux_2000 =
						   (obj_t) (arg1719_1274);
						SET_CDR(binding_1273, aux_2000);
					     }
					  }
				       }
				       {
					  obj_t l1461_2003;
					  l1461_2003 =
					     CDR(l1461_1269);
					  l1461_1269 = l1461_2003;
					  goto lname1462_1270;
				       }
				    }
				  else
				    {	/* Ast/substitute.scm 222 */
				       ((bool_t) 1);
				    }
			       }
			       {	/* Ast/substitute.scm 225 */
				  node_bglt arg1723_1278;
				  arg1723_1278 =
				     do_substitute__77_ast_substitute(
				     (((let_var_6_bglt) CREF(node_1267))->body), site_6);
				  ((((let_var_6_bglt) CREF(node_1267))->body) = ((node_bglt) arg1723_1278), BUNSPEC);
			       }
			       aux_1715 =
				  (obj_t) (node_1267);
			    }
			    break;
			 case ((long) 15):

			    {	/* Ast/substitute.scm 52 */
			       set_ex_it_116_bglt node_1280;
			       node_1280 =
				  (set_ex_it_116_bglt) (node_5);
			       {	/* Ast/substitute.scm 232 */
				  node_bglt arg1725_1282;
				  arg1725_1282 =
				     do_substitute__77_ast_substitute(
				     (((set_ex_it_116_bglt) CREF(node_1280))->body), site_6);
				  ((((set_ex_it_116_bglt) CREF(node_1280))->body) = ((node_bglt) arg1725_1282), BUNSPEC);
			       }
			       aux_1715 =
				  (obj_t) (node_1280);
			    }
			    break;
			 case ((long) 16):

			    {	/* Ast/substitute.scm 52 */
			       jump_ex_it_184_bglt node_1284;
			       node_1284 =
				  (jump_ex_it_184_bglt) (node_5);
			       {	/* Ast/substitute.scm 239 */
				  node_bglt arg1727_1286;
				  arg1727_1286 =
				     do_substitute__77_ast_substitute(
				     (((jump_ex_it_184_bglt) CREF(node_1284))->exit),
				     CNST_TABLE_REF(((long) 11)));
				  ((((jump_ex_it_184_bglt) CREF(node_1284))->exit) = ((node_bglt) arg1727_1286), BUNSPEC);
			       }
			       {	/* Ast/substitute.scm 240 */
				  node_bglt arg1730_1289;
				  arg1730_1289 =
				     do_substitute__77_ast_substitute(
				     (((jump_ex_it_184_bglt) CREF(node_1284))->value),
				     CNST_TABLE_REF(((long) 10)));
				  ((((jump_ex_it_184_bglt) CREF(node_1284))->value) = ((node_bglt) arg1730_1289), BUNSPEC);
			       }
			       aux_1715 =
				  (obj_t) (node_1284);
			    }
			    break;
			 case ((long) 17):

			    {	/* Ast/substitute.scm 52 */
			       make_box_202_bglt node_1292;
			       node_1292 =
				  (make_box_202_bglt) (node_5);
			       {	/* Ast/substitute.scm 247 */
				  node_bglt arg1733_1294;
				  arg1733_1294 =
				     do_substitute__77_ast_substitute(
				     (((make_box_202_bglt) CREF(node_1292))->value),
				     CNST_TABLE_REF(((long) 10)));
				  ((((make_box_202_bglt) CREF(node_1292))->value) = ((node_bglt) arg1733_1294), BUNSPEC);
			       }
			       aux_1715 =
				  (obj_t) (node_1292);
			    }
			    break;
			 case ((long) 18):

			    {	/* Ast/substitute.scm 52 */
			       box_ref_242_bglt node_1297;
			       node_1297 =
				  (box_ref_242_bglt) (node_5);
			       {	/* Ast/substitute.scm 254 */
				  node_bglt arg1736_1299;
				  {	/* Ast/substitute.scm 254 */
				     node_bglt aux_2032;
				     {	/* Ast/substitute.scm 254 */
					var_bglt aux_2033;
					aux_2033 =
					   (((box_ref_242_bglt) CREF(node_1297))->var);
					aux_2032 =
					   (node_bglt) (aux_2033);
				     }
				     arg1736_1299 =
					do_substitute__77_ast_substitute(aux_2032,
					CNST_TABLE_REF(((long) 10)));
				  }
				  {	/* Ast/substitute.scm 254 */
				     var_bglt val1418_1546;
				     val1418_1546 =
					(var_bglt) (arg1736_1299);
				     ((((box_ref_242_bglt) CREF(node_1297))->var) = ((var_bglt) val1418_1546), BUNSPEC);
				  }
			       }
			       aux_1715 =
				  (obj_t) (node_1297);
			    }
			    break;
			 case ((long) 19):

			    {	/* Ast/substitute.scm 52 */
			       box_set__221_bglt node_1302;
			       node_1302 =
				  (box_set__221_bglt) (node_5);
			       {	/* Ast/substitute.scm 261 */
				  node_bglt arg1740_1304;
				  {	/* Ast/substitute.scm 261 */
				     node_bglt aux_2042;
				     {	/* Ast/substitute.scm 261 */
					var_bglt aux_2043;
					aux_2043 =
					   (((box_set__221_bglt) CREF(node_1302))->var);
					aux_2042 =
					   (node_bglt) (aux_2043);
				     }
				     arg1740_1304 =
					do_substitute__77_ast_substitute(aux_2042,
					CNST_TABLE_REF(((long) 10)));
				  }
				  {	/* Ast/substitute.scm 261 */
				     var_bglt val1428_1549;
				     val1428_1549 =
					(var_bglt) (arg1740_1304);
				     ((((box_set__221_bglt) CREF(node_1302))->var) = ((var_bglt) val1428_1549), BUNSPEC);
				  }
			       }
			       {	/* Ast/substitute.scm 262 */
				  node_bglt arg1743_1307;
				  arg1743_1307 =
				     do_substitute__77_ast_substitute(
				     (((box_set__221_bglt) CREF(node_1302))->value),
				     CNST_TABLE_REF(((long) 10)));
				  ((((box_set__221_bglt) CREF(node_1302))->value) = ((node_bglt) arg1743_1307), BUNSPEC);
			       }
			       aux_1715 =
				  (obj_t) (node_1302);
			    }
			    break;
			 default:
			  case_else1611_1109:
			    if (
			       PROCEDUREP(method1605_1105))
			      {		/* Ast/substitute.scm 52 */
				 aux_1715 =
				    PROCEDURE_ENTRY(method1605_1105) (method1605_1105,
				    (obj_t) (node_5), site_6, BEOA)
				    ;
			      }
			    else
			      {		/* Ast/substitute.scm 52 */
				 obj_t fun1604_1101;
				 fun1604_1101 =
				    PROCEDURE_REF(do_substitute__env_169_ast_substitute, ((long) 0));
				 aux_1715 =
				    PROCEDURE_ENTRY(fun1604_1101) (fun1604_1101,
				    (obj_t) (node_5), site_6, BEOA);
			      }
			 }
		    }
		  else
		    {	/* Ast/substitute.scm 52 */
		       goto case_else1611_1109;
		    }
	       }
	       return
		  (node_bglt) (aux_1715);
	    }
	 }
      }
   }
}



/* _do-substitute!1756 */
obj_t 
_do_substitute_1756_90_ast_substitute(obj_t env_1563, obj_t node_1564, obj_t site_1565)
{
   AN_OBJECT;
   {	/* Ast/substitute.scm 52 */
      {		/* Ast/substitute.scm 52 */
	 node_bglt aux_2067;
	 aux_2067 =
	    do_substitute__77_ast_substitute(
	    (node_bglt) (node_1564), site_1565);
	 return
	    (obj_t) (aux_2067);
      }
   }
}



/* do-substitute!-default1463 */
node_bglt 
do_substitute__default1463_209_ast_substitute(node_bglt node_7, obj_t site_8)
{
   AN_OBJECT;
   {	/* Ast/substitute.scm 14 */
      FAILURE(
	 CNST_TABLE_REF(((long) 14)), string1761_ast_substitute,
	 (obj_t) (node_7));
   }
}



/* _do-substitute!-default1463 */
obj_t 
_do_substitute__default1463_54_ast_substitute(obj_t env_1566, obj_t node_1567, obj_t site_1568)
{
   AN_OBJECT;
   {	/* Ast/substitute.scm 14 */
      {		/* Ast/substitute.scm 14 */
	 node_bglt aux_2074;
	 aux_2074 =
	    do_substitute__default1463_209_ast_substitute(
	    (node_bglt) (node_1567), site_1568);
	 return
	    (obj_t) (aux_2074);
      }
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_ast_substitute()
{
   AN_OBJECT;
   {	/* Ast/substitute.scm 14 */
      module_initialization_70_tools_trace(((long) 0), "AST_SUBSTITUTE");
      module_initialization_70_type_type(((long) 0), "AST_SUBSTITUTE");
      module_initialization_70_type_cache(((long) 0), "AST_SUBSTITUTE");
      module_initialization_70_ast_var(((long) 0), "AST_SUBSTITUTE");
      module_initialization_70_ast_node(((long) 0), "AST_SUBSTITUTE");
      module_initialization_70_tools_shape(((long) 0), "AST_SUBSTITUTE");
      module_initialization_70_tools_error(((long) 0), "AST_SUBSTITUTE");
      module_initialization_70_ast_apply(((long) 0), "AST_SUBSTITUTE");
      module_initialization_70_ast_app(((long) 0), "AST_SUBSTITUTE");
      return
	 module_initialization_70_ast_sexp(((long) 0), "AST_SUBSTITUTE");
   }
}
