/*===========================================================================*/
/*   (Ast/unit.scm)                                                          */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;

typedef struct ccomp
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t producer;
     obj_t consumer;
     obj_t finalizer;
     obj_t checksummer;
  }
     *ccomp_bglt;


extern obj_t find_global_223_ast_env(obj_t, obj_t);
extern obj_t find_global_defs_64_ast_find_gdefs_13(obj_t);
extern obj_t make_n_proto_123_tools_args(obj_t);
static obj_t method_init_76_ast_unit();
extern obj_t find_global_module_25_ast_env(obj_t, obj_t);
extern obj_t symbol_append_197___r4_symbols_6_4(obj_t);
static obj_t eta_expanse_111_ast_unit(obj_t, obj_t);
extern obj_t unit__defs_135_ast_unit(obj_t);
extern obj_t dsssl_find_first_formal_237_tools_dsssl(obj_t);
extern obj_t id_of_id_112_ast_ident(obj_t, obj_t);
static obj_t _unit_list__71_ast_unit = BUNSPEC;
static obj_t make_sfun_definition_61_ast_unit(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t make_sgfun_definition_102_ast_unit(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t global_ast_var;
extern obj_t gensym___r4_symbols_6_4;
extern obj_t _obj__252_type_cache;
extern obj_t args___args_list_50_tools_args(obj_t);
extern obj_t unit_initializer_id_235_ast_unit(obj_t);
extern obj_t verbose_tools_speek(obj_t, obj_t);
extern obj_t last_pair_93___r4_pairs_and_lists_6_3(obj_t);
extern bool_t is_a__118___object(obj_t, obj_t);
static obj_t normalize_progn_error_20_ast_unit(obj_t, obj_t);
static obj_t _unit_initializers_20_ast_unit(obj_t);
static obj_t make_svar_definition_154_ast_unit(obj_t, obj_t);
extern obj_t module_initialization_70_ast_unit(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_ast_find_gdefs_13(long, char *);
extern obj_t module_initialization_70_ast_glo_def_117(long, char *);
extern obj_t module_initialization_70_ast_ident(long, char *);
extern obj_t module_initialization_70_ast_env(long, char *);
extern obj_t module_initialization_70_ast_local(long, char *);
extern obj_t module_initialization_70_ast_sexp(long, char *);
extern obj_t module_initialization_70_object_generic(long, char *);
extern obj_t module_initialization_70_object_method(long, char *);
extern obj_t module_initialization_70_object_inline(long, char *);
extern obj_t module_initialization_70_tools_progn(long, char *);
extern obj_t module_initialization_70_tools_args(long, char *);
extern obj_t module_initialization_70_tools_misc(long, char *);
extern obj_t module_initialization_70_tools_speek(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_location(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_tools_dsssl(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_module_module(long, char *);
extern obj_t module_initialization_70_module_class(long, char *);
extern obj_t module_initialization_70_module_include(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___dsssl(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_symbols_6_4(long, char *);
extern obj_t module_initialization_70___r4_strings_6_7(long, char *);
extern obj_t unit_initializers_25_ast_unit();
extern local_bglt make_local_svar_140_ast_local(obj_t, type_bglt);
extern global_bglt def_global_sfun__93_ast_glo_def_117(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t toplevel___ast_181_ast_unit(obj_t, obj_t);
extern obj_t fun_ast_var;
static obj_t _unit__defs_170_ast_unit(obj_t, obj_t);
static obj_t imported_modules_init_94_ast_unit();
extern obj_t string_downcase_77___r4_strings_6_7(obj_t);
extern obj_t get_method_unit_151_module_class();
extern obj_t normalize_progn_143_tools_progn(obj_t);
extern obj_t dsssl_named_constant__188_tools_dsssl(obj_t);
extern obj_t _module_clause__117_module_module;
extern obj_t append_2_18___r4_pairs_and_lists_6_3(obj_t, obj_t);
static obj_t library_modules_init_112_ast_unit();
extern bool_t check_method_definition_71_ast_glo_def_117(obj_t, obj_t, obj_t, obj_t);
extern obj_t assq___r4_pairs_and_lists_6_3(obj_t, obj_t);
static obj_t toplevel_init_63_ast_unit();
extern obj_t unit_init_calls_56_ast_unit();
extern obj_t replace__160_tools_misc(obj_t, obj_t);
extern obj_t open_input_string(obj_t);
static obj_t declare_unit__164_ast_unit(obj_t, long);
static obj_t make_sgfun_default_250_ast_unit(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t parse_id_241_ast_ident(obj_t, obj_t);
extern node_bglt error_sexp__node_157_ast_sexp(obj_t, obj_t, obj_t);
extern obj_t add_generic_for_method_inlining__147_object_inline(obj_t);
static obj_t get_global_arity_252_ast_unit(obj_t, obj_t, obj_t);
extern local_bglt make_user_local_svar_134_ast_local(obj_t, type_bglt);
extern obj_t _compiler_debug__134_engine_param;
extern global_bglt def_global_sfun_no_warning__10_ast_glo_def_117(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t check_id_6_ast_ident(obj_t, obj_t);
static obj_t toplevel__ast_219_ast_unit(obj_t, obj_t);
extern obj_t unit_sexp__add__71_ast_unit(obj_t, obj_t);
static obj_t _unit_init_calls_204_ast_unit(obj_t);
extern obj_t _module__166_module_module;
extern obj_t _4dots_199_tools_misc;
static obj_t make_method_definition_178_ast_unit(obj_t, obj_t, obj_t, obj_t);
extern obj_t make_generic_body_233_object_generic(obj_t, obj_t, obj_t, obj_t);
extern obj_t read___reader(obj_t);
extern global_bglt def_global_svar__184_ast_glo_def_117(obj_t, obj_t, obj_t, obj_t);
extern obj_t find_location_120_tools_location(obj_t);
extern obj_t make_method_body_103_object_method(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t make_dsssl_function_prelude_58___dsssl(obj_t, obj_t, obj_t, obj_t);
extern obj_t ____74_type_cache;
static obj_t require_initialization_114_ast_unit = BUNSPEC;
extern obj_t get_toplevel_unit_32_module_include();
static obj_t _unit_initializer_id_32_ast_unit(obj_t, obj_t);
static obj_t cnst_init_137_ast_unit();
extern obj_t reverse__39___r4_pairs_and_lists_6_3(obj_t);
static obj_t _unit_sexp__add__174_ast_unit(obj_t, obj_t, obj_t);
static obj_t __cnst[25];

extern obj_t user_error_env_101_tools_error;
DEFINE_EXPORT_PROCEDURE(unit_initializer_id_env_201_ast_unit, _unit_initializer_id_32_ast_unit2127, _unit_initializer_id_32_ast_unit, 0L, 1);
DEFINE_EXPORT_PROCEDURE(unit_initializers_env_47_ast_unit, _unit_initializers_20_ast_unit2128, _unit_initializers_20_ast_unit, 0L, 0);
DEFINE_EXPORT_PROCEDURE(unit_sexp__add__env_136_ast_unit, _unit_sexp__add__174_ast_unit2129, _unit_sexp__add__174_ast_unit, 0L, 2);
DEFINE_EXPORT_PROCEDURE(unit_init_calls_env_88_ast_unit, _unit_init_calls_204_ast_unit2130, _unit_init_calls_204_ast_unit, 0L, 0);
DEFINE_STRING(string2122_ast_unit, string2122_ast_unit2131, "UNIT ADD-GENERIC! SGFUN -DEFAULT QUOTE ERROR NOW CONS* APPLY DEFINE-METHOD DEFINE-GENERIC SIFUN DEFINE-INLINE DEFINE BEGIN LAMBDA SFUN READ @ -INIT CGEN SNIFUN ::OBJ *DEBUG* SET! ", 179);
DEFINE_STRING(string2121_ast_unit, string2121_ast_unit2132, "Type `extended pair' expected for expression", 44);
DEFINE_STRING(string2119_ast_unit, string2119_ast_unit2133, "No method for this object", 25);
DEFINE_STRING(string2120_ast_unit, string2120_ast_unit2134, "cer", 3);
DEFINE_STRING(string2118_ast_unit, string2118_ast_unit2135, "Illegal '() expression", 22);
DEFINE_STRING(string2117_ast_unit, string2117_ast_unit2136, "      [", 7);
DEFINE_STRING(string2116_ast_unit, string2116_ast_unit2137, "]", 1);
DEFINE_EXPORT_PROCEDURE(unit__defs_env_18_ast_unit, _unit__defs_170_ast_unit2138, _unit__defs_170_ast_unit, 0L, 1);



/* module-initialization */
obj_t 
module_initialization_70_ast_unit(long checksum_2773, char *from_2774)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_ast_unit))
	{
	   require_initialization_114_ast_unit =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_ast_unit();
	   cnst_init_137_ast_unit();
	   imported_modules_init_94_ast_unit();
	   method_init_76_ast_unit();
	   toplevel_init_63_ast_unit();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_ast_unit()
{
   AN_OBJECT;
   {	/* Ast/unit.scm 21 */
      module_initialization_70___r4_symbols_6_4(((long) 0), "AST_UNIT");
      module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "AST_UNIT");
      module_initialization_70___object(((long) 0), "AST_UNIT");
      module_initialization_70___r4_strings_6_7(((long) 0), "AST_UNIT");
      module_initialization_70___reader(((long) 0), "AST_UNIT");
      module_initialization_70___dsssl(((long) 0), "AST_UNIT");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_ast_unit()
{
   AN_OBJECT;
   {	/* Ast/unit.scm 21 */
      {		/* Ast/unit.scm 21 */
	 obj_t cnst_port_138_2766;
	 cnst_port_138_2766 =
	    open_input_string(string2122_ast_unit);
	 {
	    long i_2767;
	    i_2767 = ((long) 24);
	  loop_2768:
	    {	/* Ast/unit.scm 21 */
	       bool_t test2123_2769;
	       test2123_2769 =
		  (i_2767 == ((long) -1));
	       if (test2123_2769)
		 {	/* Ast/unit.scm 21 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Ast/unit.scm 21 */
		    {	/* Ast/unit.scm 21 */
		       obj_t arg2124_2770;
		       {	/* Ast/unit.scm 21 */
			  obj_t list2125_2771;
			  list2125_2771 =
			     MAKE_PAIR(cnst_port_138_2766, BNIL);
			  arg2124_2770 =
			     read___reader(list2125_2771);
		       }
		       CNST_TABLE_SET(i_2767, arg2124_2770);
		    }
		    {	/* Ast/unit.scm 21 */
		       int aux_2772;
		       {	/* Ast/unit.scm 21 */
			  long aux_2795;
			  aux_2795 =
			     (i_2767 - ((long) 1));
			  aux_2772 =
			     (int) (aux_2795);
		       }
		       {
			  long i_2798;
			  i_2798 =
			     (long) (aux_2772);
			  i_2767 = i_2798;
			  goto loop_2768;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_ast_unit()
{
   AN_OBJECT;
   {	/* Ast/unit.scm 21 */
      return (
	 _unit_list__71_ast_unit = BNIL, BUNSPEC);
   }
}



/* unit-sexp*-add! */
obj_t 
unit_sexp__add__71_ast_unit(obj_t unit_19, obj_t sexp_20)
{
   AN_OBJECT;
   {	/* Ast/unit.scm 56 */
      {		/* Ast/unit.scm 57 */
	 obj_t sexp_776;
	 {	/* Ast/unit.scm 57 */
	    bool_t test1472_781;
	    {	/* Ast/unit.scm 57 */
	       bool_t test1478_787;
	       {	/* Ast/unit.scm 57 */
		  obj_t obj_1929;
		  obj_1929 = _compiler_debug__134_engine_param;
		  test1478_787 =
		     INTEGERP(obj_1929);
	       }
	       if (test1478_787)
		 {	/* Ast/unit.scm 57 */
		    long n1_1930;
		    n1_1930 =
		       (long) CINT(_compiler_debug__134_engine_param);
		    test1472_781 =
		       (n1_1930 >= ((long) 3));
		 }
	       else
		 {	/* Ast/unit.scm 57 */
		    test1472_781 = ((bool_t) 0);
		 }
	    }
	    if (test1472_781)
	      {		/* Ast/unit.scm 58 */
		 obj_t arg1473_782;
		 {	/* Ast/unit.scm 58 */
		    obj_t arg1474_783;
		    obj_t arg1475_784;
		    arg1474_783 =
		       CNST_TABLE_REF(((long) 0));
		    {	/* Ast/unit.scm 58 */
		       obj_t arg1476_785;
		       obj_t arg1477_786;
		       arg1476_785 =
			  CNST_TABLE_REF(((long) 1));
		       {	/* Ast/unit.scm 58 */
			  obj_t obj1_1932;
			  obj1_1932 = _compiler_debug__134_engine_param;
			  arg1477_786 =
			     MAKE_PAIR(obj1_1932, BNIL);
		       }
		       arg1475_784 =
			  MAKE_PAIR(arg1476_785, arg1477_786);
		    }
		    arg1473_782 =
		       MAKE_PAIR(arg1474_783, arg1475_784);
		 }
		 sexp_776 =
		    MAKE_PAIR(arg1473_782, sexp_20);
	      }
	    else
	      {		/* Ast/unit.scm 57 */
		 sexp_776 = sexp_20;
	      }
	 }
	 {	/* Ast/unit.scm 60 */
	    bool_t test_2811;
	    {	/* ./Ieee/pair-list.scm 5912 */
	       obj_t aux_2812;
	       aux_2812 =
		  STRUCT_REF(unit_19, ((long) 2));
	       test_2811 =
		  NULLP(aux_2812);
	    }
	    if (test_2811)
	      {		/* Ast/unit.scm 60 */
		 return
		    STRUCT_SET(unit_19, ((long) 2), sexp_776);
	      }
	    else
	      {		/* ./Ieee/pair-list.scm 5896 */
		 obj_t aux_2816;
		 aux_2816 =
		    last_pair_93___r4_pairs_and_lists_6_3(
		    STRUCT_REF(unit_19, ((long) 2)));
		 return
		    SET_CDR(aux_2816, sexp_776);
	      }
	 }
      }
   }
}



/* _unit-sexp*-add! */
obj_t 
_unit_sexp__add__174_ast_unit(obj_t env_2751, obj_t unit_2752, obj_t sexp_2753)
{
   AN_OBJECT;
   {	/* Ast/unit.scm 56 */
      return
	 unit_sexp__add__71_ast_unit(unit_2752, sexp_2753);
   }
}



/* unit->defs */
obj_t 
unit__defs_135_ast_unit(obj_t unit_21)
{
   AN_OBJECT;
   {	/* Ast/unit.scm 67 */
      {		/* Ast/unit.scm 68 */
	 obj_t arg1481_790;
	 {	/* Ast/unit.scm 69 */
	    obj_t arg1488_796;
	    {	/* ./Ieee/symbol.scm 6021 */
	       obj_t aux_2821;
	       aux_2821 =
		  STRUCT_REF(unit_21, ((long) 0));
	       arg1488_796 =
		  SYMBOL_TO_STRING(aux_2821);
	    }
	    arg1481_790 =
	       string_downcase_77___r4_strings_6_7(arg1488_796);
	 }
	 {	/* Ast/unit.scm 68 */
	    obj_t list1483_792;
	    {	/* Ast/unit.scm 68 */
	       obj_t arg1484_793;
	       {	/* Ast/unit.scm 68 */
		  obj_t arg1485_794;
		  {	/* Ast/unit.scm 68 */
		     obj_t arg1486_795;
		     {	/* Ast/unit.scm 68 */
			obj_t aux_2825;
			aux_2825 =
			   BCHAR(((unsigned char) '\n'));
			arg1486_795 =
			   MAKE_PAIR(aux_2825, BNIL);
		     }
		     arg1485_794 =
			MAKE_PAIR(string2116_ast_unit, arg1486_795);
		  }
		  arg1484_793 =
		     MAKE_PAIR(arg1481_790, arg1485_794);
	       }
	       list1483_792 =
		  MAKE_PAIR(string2117_ast_unit, arg1484_793);
	    }
	    verbose_tools_speek(
	       BINT(((long) 2)), list1483_792);
	 }
      }
      {		/* Ast/unit.scm 73 */
	 obj_t id_798;
	 obj_t weight_799;
	 obj_t sexp__30_800;
	 id_798 =
	    STRUCT_REF(unit_21, ((long) 0));
	 weight_799 =
	    STRUCT_REF(unit_21, ((long) 1));
	 sexp__30_800 =
	    STRUCT_REF(unit_21, ((long) 2));
	 {
	    obj_t aexp__171_801;
	    obj_t init__202_802;
	    obj_t def__173_803;
	    {	/* Ast/unit.scm 77 */
	       obj_t arg1490_805;
	       if (
		  PROCEDUREP(sexp__30_800))
		 {	/* Ast/unit.scm 77 */
		    arg1490_805 =
		       PROCEDURE_ENTRY(sexp__30_800) (sexp__30_800, BEOA);
		 }
	       else
		 {	/* Ast/unit.scm 79 */
		    obj_t arg1495_809;
		    arg1495_809 =
		       find_global_defs_64_ast_find_gdefs_13(sexp__30_800);
		    arg1490_805 =
		       toplevel___ast_181_ast_unit(sexp__30_800, arg1495_809);
		 }
	       aexp__171_801 = arg1490_805;
	       init__202_802 = BNIL;
	       def__173_803 = BNIL;
	     loop_804:
	       if (
		  NULLP(aexp__171_801))
		 {	/* Ast/unit.scm 82 */
		    if (
		       PAIRP(init__202_802))
		      {		/* Ast/unit.scm 84 */
			 global_bglt init_812;
			 {	/* Ast/unit.scm 85 */
			    obj_t arg1501_816;
			    obj_t arg1504_819;
			    obj_t arg1505_820;
			    obj_t arg1506_821;
			    {	/* Ast/unit.scm 85 */
			       obj_t arg1508_822;
			       obj_t arg1509_823;
			       arg1508_822 =
				  unit_initializer_id_235_ast_unit(id_798);
			       arg1509_823 =
				  CNST_TABLE_REF(((long) 2));
			       {	/* Ast/unit.scm 85 */
				  obj_t list1510_824;
				  {	/* Ast/unit.scm 85 */
				     obj_t arg1511_825;
				     arg1511_825 =
					MAKE_PAIR(arg1509_823, BNIL);
				     list1510_824 =
					MAKE_PAIR(arg1508_822, arg1511_825);
				  }
				  arg1501_816 =
				     symbol_append_197___r4_symbols_6_4(list1510_824);
			       }
			    }
			    arg1504_819 =
			       CNST_TABLE_REF(((long) 3));
			    arg1505_820 =
			       CNST_TABLE_REF(((long) 4));
			    {	/* Ast/unit.scm 92 */
			       obj_t arg1512_826;
			       arg1512_826 =
				  reverse__39___r4_pairs_and_lists_6_3(init__202_802);
			       arg1506_821 =
				  normalize_progn_143_tools_progn(arg1512_826);
			    }
			    init_812 =
			       def_global_sfun_no_warning__10_ast_glo_def_117(arg1501_816, BNIL, BNIL, _module__166_module_module, arg1504_819, _module_clause__117_module_module, arg1505_820, arg1506_821);
			 }
			 {	/* Ast/unit.scm 95 */
			    bool_t test1498_813;
			    {	/* Ast/unit.scm 95 */
			       obj_t arg1499_814;
			       arg1499_814 =
				  get_toplevel_unit_32_module_include();
			       test1498_813 =
				  (unit_21 == arg1499_814);
			    }
			    if (test1498_813)
			      {		/* Ast/unit.scm 95 */
				 BUNSPEC;
			      }
			    else
			      {		/* Ast/unit.scm 95 */
				 ((((global_bglt) CREF(init_812))->user__32) = ((bool_t) ((bool_t) 0)), BUNSPEC);
			      }
			 }
			 declare_unit__164_ast_unit(id_798,
			    (long) CINT(weight_799));
			 ((((global_bglt) CREF(init_812))->evaluable__248) = ((bool_t) ((bool_t) 0)), BUNSPEC);
			 {	/* Ast/unit.scm 105 */
			    obj_t arg1500_815;
			    arg1500_815 =
			       reverse__39___r4_pairs_and_lists_6_3(def__173_803);
			    {	/* ./Ieee/pair-list.scm 5689 */
			       obj_t aux_2864;
			       aux_2864 =
				  (obj_t) (init_812);
			       return
				  MAKE_PAIR(aux_2864, arg1500_815);
			    }
			 }
		      }
		    else
		      {		/* Ast/unit.scm 83 */
			 return
			    reverse__39___r4_pairs_and_lists_6_3(def__173_803);
		      }
		 }
	       else
		 {	/* Ast/unit.scm 107 */
		    bool_t test1513_827;
		    test1513_827 =
		       is_a__118___object(
		       CAR(aexp__171_801), global_ast_var);
		    if (test1513_827)
		      {		/* Ast/unit.scm 108 */
			 obj_t arg1514_828;
			 obj_t arg1515_829;
			 arg1514_828 =
			    CDR(aexp__171_801);
			 {	/* ./Ieee/pair-list.scm 5689 */
			    obj_t aux_2872;
			    aux_2872 =
			       CAR(aexp__171_801);
			    arg1515_829 =
			       MAKE_PAIR(aux_2872, def__173_803);
			 }
			 {
			    obj_t def__173_2876;
			    obj_t aexp__171_2875;
			    aexp__171_2875 = arg1514_828;
			    def__173_2876 = arg1515_829;
			    def__173_803 = def__173_2876;
			    aexp__171_801 = aexp__171_2875;
			    goto loop_804;
			 }
		      }
		    else
		      {		/* Ast/unit.scm 111 */
			 obj_t arg1517_831;
			 obj_t arg1519_832;
			 arg1517_831 =
			    CDR(aexp__171_801);
			 {	/* ./Ieee/pair-list.scm 5689 */
			    obj_t aux_2878;
			    aux_2878 =
			       CAR(aexp__171_801);
			    arg1519_832 =
			       MAKE_PAIR(aux_2878, init__202_802);
			 }
			 {
			    obj_t init__202_2882;
			    obj_t aexp__171_2881;
			    aexp__171_2881 = arg1517_831;
			    init__202_2882 = arg1519_832;
			    init__202_802 = init__202_2882;
			    aexp__171_801 = aexp__171_2881;
			    goto loop_804;
			 }
		      }
		 }
	    }
	 }
      }
   }
}



/* _unit->defs */
obj_t 
_unit__defs_170_ast_unit(obj_t env_2754, obj_t unit_2755)
{
   AN_OBJECT;
   {	/* Ast/unit.scm 67 */
      return
	 unit__defs_135_ast_unit(unit_2755);
   }
}



/* declare-unit! */
obj_t 
declare_unit__164_ast_unit(obj_t id_22, long weight_23)
{
   AN_OBJECT;
   {	/* Ast/unit.scm 123 */
      {		/* Ast/unit.scm 124 */
	 bool_t test1522_835;
	 {	/* Ast/unit.scm 124 */
	    bool_t test1538_852;
	    {	/* Ast/unit.scm 124 */
	       obj_t obj_1989;
	       obj_1989 = _unit_list__71_ast_unit;
	       test1538_852 =
		  NULLP(obj_1989);
	    }
	    if (test1538_852)
	      {		/* Ast/unit.scm 124 */
		 test1522_835 = ((bool_t) 1);
	      }
	    else
	      {		/* Ast/unit.scm 124 */
		 obj_t arg1539_853;
		 {	/* Ast/unit.scm 124 */
		    obj_t arg1540_854;
		    {	/* Ast/unit.scm 124 */
		       obj_t pair_1990;
		       pair_1990 = _unit_list__71_ast_unit;
		       arg1540_854 =
			  CAR(pair_1990);
		    }
		    arg1539_853 =
		       CDR(arg1540_854);
		 }
		 {	/* ./Ieee/fixnum.scm 7115 */
		    long aux_2888;
		    aux_2888 =
		       (long) CINT(arg1539_853);
		    test1522_835 =
		       (weight_23 < aux_2888);
		 }
	      }
	 }
	 if (test1522_835)
	   {	/* Ast/unit.scm 125 */
	      obj_t arg1523_836;
	      {		/* ./Ieee/pair-list.scm 5689 */
		 obj_t aux_2892;
		 aux_2892 =
		    BINT(weight_23);
		 arg1523_836 =
		    MAKE_PAIR(id_22, aux_2892);
	      }
	      {		/* Ast/unit.scm 125 */
		 obj_t obj2_1997;
		 obj2_1997 = _unit_list__71_ast_unit;
		 return (
		    _unit_list__71_ast_unit =
		    MAKE_PAIR(arg1523_836, obj2_1997), BUNSPEC);
	      }
	   }
	 else
	   {
	      obj_t ulist_837;
	      ulist_837 = _unit_list__71_ast_unit;
	    loop_838:
	      {		/* Ast/unit.scm 128 */
		 bool_t test_2896;
		 {	/* ./Ieee/fixnum.scm 7115 */
		    long aux_2897;
		    {	/* Ast/unit.scm 128 */
		       obj_t aux_2898;
		       {	/* ./Ieee/pair-list.scm 5707 */
			  obj_t aux_2899;
			  aux_2899 =
			     CAR(ulist_837);
			  aux_2898 =
			     CDR(aux_2899);
		       }
		       aux_2897 =
			  (long) CINT(aux_2898);
		    }
		    test_2896 =
		       (weight_23 < aux_2897);
		 }
		 if (test_2896)
		   {	/* Ast/unit.scm 128 */
		      {		/* Ast/unit.scm 129 */
			 obj_t arg1525_840;
			 {	/* ./Ieee/pair-list.scm 5689 */
			    obj_t aux_2906;
			    obj_t aux_2904;
			    aux_2906 =
			       CDR(ulist_837);
			    aux_2904 =
			       CAR(ulist_837);
			    arg1525_840 =
			       MAKE_PAIR(aux_2904, aux_2906);
			 }
			 SET_CDR(ulist_837, arg1525_840);
		      }
		      {		/* Ast/unit.scm 130 */
			 obj_t arg1528_843;
			 {	/* ./Ieee/pair-list.scm 5689 */
			    obj_t aux_2910;
			    aux_2910 =
			       BINT(weight_23);
			    arg1528_843 =
			       MAKE_PAIR(id_22, aux_2910);
			 }
			 return
			    SET_CAR(ulist_837, arg1528_843);
		      }
		   }
		 else
		   {	/* Ast/unit.scm 131 */
		      bool_t test_2914;
		      {		/* ./Ieee/pair-list.scm 5912 */
			 obj_t aux_2915;
			 aux_2915 =
			    CDR(ulist_837);
			 test_2914 =
			    NULLP(aux_2915);
		      }
		      if (test_2914)
			{	/* Ast/unit.scm 131 */
			   {	/* Ast/unit.scm 132 */
			      obj_t arg1530_845;
			      {		/* Ast/unit.scm 132 */
				 obj_t arg1532_846;
				 {	/* ./Ieee/pair-list.scm 5689 */
				    obj_t aux_2918;
				    aux_2918 =
				       BINT(weight_23);
				    arg1532_846 =
				       MAKE_PAIR(id_22, aux_2918);
				 }
				 {	/* Ast/unit.scm 132 */
				    obj_t list1533_847;
				    list1533_847 =
				       MAKE_PAIR(arg1532_846, BNIL);
				    arg1530_845 = list1533_847;
				 }
			      }
			      return
				 SET_CDR(ulist_837, arg1530_845);
			   }
			}
		      else
			{	/* Ast/unit.scm 131 */
			   {
			      obj_t ulist_2923;
			      ulist_2923 =
				 CDR(ulist_837);
			      ulist_837 = ulist_2923;
			      goto loop_838;
			   }
			}
		   }
	      }
	   }
      }
   }
}



/* unit-initializer-id */
obj_t 
unit_initializer_id_235_ast_unit(obj_t id_24)
{
   AN_OBJECT;
   {	/* Ast/unit.scm 139 */
      {		/* Ast/unit.scm 140 */
	 obj_t list1541_855;
	 {	/* Ast/unit.scm 140 */
	    obj_t arg1543_856;
	    {	/* Ast/unit.scm 140 */
	       obj_t aux_2925;
	       aux_2925 =
		  CNST_TABLE_REF(((long) 5));
	       arg1543_856 =
		  MAKE_PAIR(aux_2925, BNIL);
	    }
	    list1541_855 =
	       MAKE_PAIR(id_24, arg1543_856);
	 }
	 return
	    symbol_append_197___r4_symbols_6_4(list1541_855);
      }
   }
}



/* _unit-initializer-id */
obj_t 
_unit_initializer_id_32_ast_unit(obj_t env_2756, obj_t id_2757)
{
   AN_OBJECT;
   {	/* Ast/unit.scm 139 */
      return
	 unit_initializer_id_235_ast_unit(id_2757);
   }
}



/* unit-initializers */
obj_t 
unit_initializers_25_ast_unit()
{
   AN_OBJECT;
   {	/* Ast/unit.scm 145 */
      {		/* Ast/unit.scm 146 */
	 obj_t l1445_857;
	 l1445_857 = _unit_list__71_ast_unit;
	 if (
	    NULLP(l1445_857))
	   {	/* Ast/unit.scm 146 */
	      return BNIL;
	   }
	 else
	   {	/* Ast/unit.scm 146 */
	      obj_t head1447_859;
	      head1447_859 =
		 MAKE_PAIR(BNIL, BNIL);
	      {
		 obj_t l1445_860;
		 obj_t tail1448_861;
		 l1445_860 = l1445_857;
		 tail1448_861 = head1447_859;
	       lname1446_862:
		 if (
		    NULLP(l1445_860))
		   {	/* Ast/unit.scm 146 */
		      return
			 CDR(head1447_859);
		   }
		 else
		   {	/* Ast/unit.scm 147 */
		      obj_t newtail1449_864;
		      {		/* Ast/unit.scm 147 */
			 obj_t arg1548_866;
			 {	/* Ast/unit.scm 147 */
			    obj_t arg1550_869;
			    {	/* Ast/unit.scm 147 */
			       obj_t aux_2937;
			       {	/* ./Ieee/pair-list.scm 5701 */
				  obj_t aux_2938;
				  aux_2938 =
				     CAR(l1445_860);
				  aux_2937 =
				     CAR(aux_2938);
			       }
			       arg1550_869 =
				  unit_initializer_id_235_ast_unit(aux_2937);
			    }
			    arg1548_866 =
			       find_global_module_25_ast_env(arg1550_869, _module__166_module_module);
			 }
			 newtail1449_864 =
			    MAKE_PAIR(arg1548_866, BNIL);
		      }
		      SET_CDR(tail1448_861, newtail1449_864);
		      {
			 obj_t tail1448_2947;
			 obj_t l1445_2945;
			 l1445_2945 =
			    CDR(l1445_860);
			 tail1448_2947 = newtail1449_864;
			 tail1448_861 = tail1448_2947;
			 l1445_860 = l1445_2945;
			 goto lname1446_862;
		      }
		   }
	      }
	   }
      }
   }
}



/* _unit-initializers */
obj_t 
_unit_initializers_20_ast_unit(obj_t env_2758)
{
   AN_OBJECT;
   {	/* Ast/unit.scm 145 */
      return
	 unit_initializers_25_ast_unit();
   }
}



/* unit-init-calls */
obj_t 
unit_init_calls_56_ast_unit()
{
   AN_OBJECT;
   {	/* Ast/unit.scm 153 */
      {		/* Ast/unit.scm 154 */
	 obj_t l1450_871;
	 l1450_871 = _unit_list__71_ast_unit;
	 if (
	    NULLP(l1450_871))
	   {	/* Ast/unit.scm 154 */
	      return BNIL;
	   }
	 else
	   {	/* Ast/unit.scm 154 */
	      obj_t head1452_873;
	      head1452_873 =
		 MAKE_PAIR(BNIL, BNIL);
	      {
		 obj_t l1450_874;
		 obj_t tail1453_875;
		 l1450_874 = l1450_871;
		 tail1453_875 = head1452_873;
	       lname1451_876:
		 if (
		    NULLP(l1450_874))
		   {	/* Ast/unit.scm 154 */
		      return
			 CDR(head1452_873);
		   }
		 else
		   {	/* Ast/unit.scm 154 */
		      obj_t newtail1454_878;
		      {		/* Ast/unit.scm 154 */
			 obj_t arg1556_880;
			 {	/* Ast/unit.scm 154 */
			    obj_t arg1558_883;
			    {	/* Ast/unit.scm 154 */
			       obj_t arg1560_885;
			       obj_t arg1561_886;
			       arg1560_885 =
				  CNST_TABLE_REF(((long) 6));
			       {	/* Ast/unit.scm 154 */
				  obj_t arg1562_887;
				  obj_t arg1563_888;
				  {	/* Ast/unit.scm 154 */
				     obj_t aux_2956;
				     {	/* ./Ieee/pair-list.scm 5701 */
					obj_t aux_2957;
					aux_2957 =
					   CAR(l1450_874);
					aux_2956 =
					   CAR(aux_2957);
				     }
				     arg1562_887 =
					unit_initializer_id_235_ast_unit(aux_2956);
				  }
				  {	/* Ast/unit.scm 154 */
				     obj_t obj1_2039;
				     obj1_2039 = _module__166_module_module;
				     arg1563_888 =
					MAKE_PAIR(obj1_2039, BNIL);
				  }
				  arg1561_886 =
				     MAKE_PAIR(arg1562_887, arg1563_888);
			       }
			       arg1558_883 =
				  MAKE_PAIR(arg1560_885, arg1561_886);
			    }
			    arg1556_880 =
			       MAKE_PAIR(arg1558_883, BNIL);
			 }
			 newtail1454_878 =
			    MAKE_PAIR(arg1556_880, BNIL);
		      }
		      SET_CDR(tail1453_875, newtail1454_878);
		      {
			 obj_t tail1453_2969;
			 obj_t l1450_2967;
			 l1450_2967 =
			    CDR(l1450_874);
			 tail1453_2969 = newtail1454_878;
			 tail1453_875 = tail1453_2969;
			 l1450_874 = l1450_2967;
			 goto lname1451_876;
		      }
		   }
	      }
	   }
      }
   }
}



/* _unit-init-calls */
obj_t 
_unit_init_calls_204_ast_unit(obj_t env_2759)
{
   AN_OBJECT;
   {	/* Ast/unit.scm 153 */
      return
	 unit_init_calls_56_ast_unit();
   }
}



/* toplevel*->ast */
obj_t 
toplevel___ast_181_ast_unit(obj_t sexp__30_25, obj_t gdefs_26)
{
   AN_OBJECT;
   {	/* Ast/unit.scm 160 */
      {
	 obj_t sexp__30_890;
	 obj_t aexp__171_891;
	 sexp__30_890 = sexp__30_25;
	 aexp__171_891 = BNIL;
       loop_892:
	 if (
	    NULLP(sexp__30_890))
	   {	/* Ast/unit.scm 163 */
	      return
		 reverse__39___r4_pairs_and_lists_6_3(aexp__171_891);
	   }
	 else
	   {	/* Ast/unit.scm 165 */
	      obj_t arg1566_894;
	      obj_t arg1567_895;
	      arg1566_894 =
		 CDR(sexp__30_890);
	      {		/* Ast/unit.scm 166 */
		 obj_t arg1568_896;
		 arg1568_896 =
		    toplevel__ast_219_ast_unit(
		    CAR(sexp__30_890), gdefs_26);
		 arg1567_895 =
		    append_2_18___r4_pairs_and_lists_6_3(arg1568_896, aexp__171_891);
	      }
	      {
		 obj_t aexp__171_2979;
		 obj_t sexp__30_2978;
		 sexp__30_2978 = arg1566_894;
		 aexp__171_2979 = arg1567_895;
		 aexp__171_891 = aexp__171_2979;
		 sexp__30_890 = sexp__30_2978;
		 goto loop_892;
	      }
	   }
      }
   }
}



/* toplevel->ast */
obj_t 
toplevel__ast_219_ast_unit(obj_t sexp_27, obj_t gdefs_28)
{
   AN_OBJECT;
   {	/* Ast/unit.scm 173 */
    toplevel__ast_219_ast_unit:
      {
	 obj_t var_915;
	 obj_t var2_916;
	 obj_t module_917;
	 obj_t var_912;
	 obj_t var2_913;
	 obj_t var_905;
	 obj_t args_906;
	 obj_t exp_907;
	 obj_t var_901;
	 obj_t args_902;
	 obj_t exp_903;
	 if (
	    PAIRP(sexp_27))
	   {	/* Ast/unit.scm 174 */
	      bool_t test_2982;
	      {		/* ./Ieee/equiv.scm 5508 */
		 obj_t aux_2985;
		 obj_t aux_2983;
		 aux_2985 =
		    CNST_TABLE_REF(((long) 10));
		 aux_2983 =
		    CAR(sexp_27);
		 test_2982 =
		    (aux_2983 == aux_2985);
	      }
	      if (test_2982)
		{	/* Ast/unit.scm 174 */
		   bool_t test_2988;
		   {	/* ./Ieee/equiv.scm 5508 */
		      obj_t aux_2989;
		      aux_2989 =
			 CDR(sexp_27);
		      test_2988 =
			 (aux_2989 == BNIL);
		   }
		   if (test_2988)
		     {	/* Ast/unit.scm 174 */
			{	/* Ast/unit.scm 176 */
			   obj_t list1767_1220;
			   list1767_1220 =
			      MAKE_PAIR(sexp_27, BNIL);
			   return list1767_1220;
			}
		     }
		   else
		     {	/* Ast/unit.scm 178 */
			obj_t arg1768_2064;
			arg1768_2064 =
			   toplevel___ast_181_ast_unit(
			   CDR(sexp_27), gdefs_28);
			return
			   reverse__39___r4_pairs_and_lists_6_3(arg1768_2064);
		     }
		}
	      else
		{	/* Ast/unit.scm 174 */
		   obj_t cdr_173_176_952;
		   cdr_173_176_952 =
		      CDR(sexp_27);
		   {	/* Ast/unit.scm 174 */
		      bool_t test_2997;
		      {		/* ./Ieee/equiv.scm 5508 */
			 obj_t aux_3000;
			 obj_t aux_2998;
			 aux_3000 =
			    CNST_TABLE_REF(((long) 11));
			 aux_2998 =
			    CAR(sexp_27);
			 test_2997 =
			    (aux_2998 == aux_3000);
		      }
		      if (test_2997)
			{	/* Ast/unit.scm 174 */
			   if (
			      PAIRP(cdr_173_176_952))
			     {	/* Ast/unit.scm 174 */
				obj_t car_177_101_955;
				car_177_101_955 =
				   CAR(cdr_173_176_952);
				if (
				   PAIRP(car_177_101_955))
				  {	/* Ast/unit.scm 174 */
				     var_901 =
					CAR(car_177_101_955);
				     args_902 =
					CDR(car_177_101_955);
				     exp_903 =
					CDR(cdr_173_176_952);
				     {	/* Ast/unit.scm 180 */
					obj_t id_1222;
					{	/* Ast/unit.scm 180 */
					   obj_t arg1787_1246;
					   arg1787_1246 =
					      find_location_120_tools_location(sexp_27);
					   id_1222 =
					      id_of_id_112_ast_ident(var_901, arg1787_1246);
					}
					{	/* Ast/unit.scm 180 */
					   obj_t def_1223;
					   def_1223 =
					      assq___r4_pairs_and_lists_6_3(id_1222, gdefs_28);
					   {	/* Ast/unit.scm 181 */
					      obj_t global_1224;
					      global_1224 =
						 find_global_module_25_ast_env(id_1222, _module__166_module_module);
					      {		/* Ast/unit.scm 182 */

						 {	/* Ast/unit.scm 190 */
						    bool_t test1769_1225;
						    if (
						       PAIRP(def_1223))
						      {		/* Ast/unit.scm 191 */
							 bool_t test_3014;
							 {	/* ./Ieee/equiv.scm 5508 */
							    obj_t aux_3019;
							    obj_t aux_3015;
							    aux_3019 =
							       CNST_TABLE_REF(((long) 7));
							    {	/* ./Ieee/pair-list.scm 5701 */
							       obj_t aux_3016;
							       aux_3016 =
								  CDR(def_1223);
							       aux_3015 =
								  CAR(aux_3016);
							    }
							    test_3014 =
							       (aux_3015 == aux_3019);
							 }
							 if (test_3014)
							   {	/* Ast/unit.scm 192 */
							      bool_t _ortest_1456_1239;
							      {		/* Ast/unit.scm 192 */
								 bool_t test1783_1242;
								 test1783_1242 =
								    is_a__118___object(global_1224, global_ast_var);
								 if (test1783_1242)
								   {	/* Ast/unit.scm 192 */
								      _ortest_1456_1239 = ((bool_t) 0);
								   }
								 else
								   {	/* Ast/unit.scm 192 */
								      _ortest_1456_1239 = ((bool_t) 1);
								   }
							      }
							      if (_ortest_1456_1239)
								{	/* Ast/unit.scm 192 */
								   test1769_1225 = _ortest_1456_1239;
								}
							      else
								{	/* ./Ieee/equiv.scm 5508 */
								   obj_t aux_3028;
								   obj_t aux_3025;
								   aux_3028 =
								      CNST_TABLE_REF(((long) 7));
								   {	/* Ast/unit.scm 193 */
								      global_bglt obj_2440;
								      obj_2440 =
									 (global_bglt) (global_1224);
								      aux_3025 =
									 (((global_bglt) CREF(obj_2440))->access);
								   }
								   test1769_1225 =
								      (aux_3025 == aux_3028);
								}
							   }
							 else
							   {	/* Ast/unit.scm 191 */
							      test1769_1225 = ((bool_t) 0);
							   }
						      }
						    else
						      {		/* Ast/unit.scm 190 */
							 test1769_1225 = ((bool_t) 1);
						      }
						    if (test1769_1225)
						      {		/* Ast/unit.scm 197 */
							 obj_t arg1770_1226;
							 obj_t arg1771_1227;
							 arg1770_1226 =
							    normalize_progn_error_20_ast_unit(exp_903, sexp_27);
							 arg1771_1227 =
							    CNST_TABLE_REF(((long) 8));
							 return
							    make_sfun_definition_61_ast_unit(var_901, _module__166_module_module, args_902, arg1770_1226, sexp_27, arg1771_1227);
						      }
						    else
						      {		/* Ast/unit.scm 200 */
							 obj_t new_sexp_159_1228;
							 {	/* Ast/unit.scm 200 */
							    obj_t arg1772_1229;
							    obj_t arg1773_1230;
							    arg1772_1229 =
							       CNST_TABLE_REF(((long) 0));
							    {	/* Ast/unit.scm 200 */
							       obj_t arg1774_1231;
							       {	/* Ast/unit.scm 200 */
								  obj_t arg1775_1232;
								  {	/* Ast/unit.scm 200 */
								     obj_t arg1777_1234;
								     obj_t arg1778_1235;
								     arg1777_1234 =
									CNST_TABLE_REF(((long) 9));
								     {	/* ./Ieee/pair-list.scm 5689 */
									obj_t aux_3037;
									aux_3037 =
									   append_2_18___r4_pairs_and_lists_6_3(exp_903, BNIL);
									arg1778_1235 =
									   MAKE_PAIR(args_902, aux_3037);
								     }
								     arg1775_1232 =
									MAKE_PAIR(arg1777_1234, arg1778_1235);
								  }
								  arg1774_1231 =
								     MAKE_PAIR(arg1775_1232, BNIL);
							       }
							       arg1773_1230 =
								  MAKE_PAIR(var_901, arg1774_1231);
							    }
							    new_sexp_159_1228 =
							       MAKE_PAIR(arg1772_1229, arg1773_1230);
							 }
							 replace__160_tools_misc(sexp_27, new_sexp_159_1228);
							 return
							    make_svar_definition_154_ast_unit(var_901, sexp_27);
						      }
						 }
					      }
					   }
					}
				     }
				  }
				else
				  {	/* Ast/unit.scm 174 */
				     obj_t cdr_201_92_961;
				     cdr_201_92_961 =
					CDR(cdr_173_176_952);
				     if (
					PAIRP(cdr_201_92_961))
				       {	/* Ast/unit.scm 174 */
					  obj_t car_205_138_963;
					  car_205_138_963 =
					     CAR(cdr_201_92_961);
					  if (
					     PAIRP(car_205_138_963))
					    {	/* Ast/unit.scm 174 */
					       obj_t cdr_210_15_965;
					       cdr_210_15_965 =
						  CDR(car_205_138_963);
					       {	/* Ast/unit.scm 174 */
						  bool_t test_3056;
						  {	/* ./Ieee/equiv.scm 5508 */
						     obj_t aux_3059;
						     obj_t aux_3057;
						     aux_3059 =
							CNST_TABLE_REF(((long) 9));
						     aux_3057 =
							CAR(car_205_138_963);
						     test_3056 =
							(aux_3057 == aux_3059);
						  }
						  if (test_3056)
						    {	/* Ast/unit.scm 174 */
						       if (
							  PAIRP(cdr_210_15_965))
							 {	/* Ast/unit.scm 174 */
							    bool_t test_3064;
							    {	/* ./Ieee/equiv.scm 5508 */
							       obj_t aux_3065;
							       aux_3065 =
								  CDR(cdr_201_92_961);
							       test_3064 =
								  (aux_3065 == BNIL);
							    }
							    if (test_3064)
							      {		/* Ast/unit.scm 174 */
								 var_905 =
								    CAR(cdr_173_176_952);
								 args_906 =
								    CAR(cdr_210_15_965);
								 exp_907 =
								    CDR(cdr_210_15_965);
								 {	/* Ast/unit.scm 204 */
								    obj_t id_1247;
								    {	/* Ast/unit.scm 204 */
								       obj_t arg1798_1261;
								       arg1798_1261 =
									  find_location_120_tools_location(sexp_27);
								       id_1247 =
									  id_of_id_112_ast_ident(var_905, arg1798_1261);
								    }
								    {	/* Ast/unit.scm 204 */
								       obj_t def_1248;
								       def_1248 =
									  assq___r4_pairs_and_lists_6_3(id_1247, gdefs_28);
								       {	/* Ast/unit.scm 205 */
									  obj_t global_1249;
									  global_1249 =
									     find_global_module_25_ast_env(id_1247, _module__166_module_module);
									  {	/* Ast/unit.scm 206 */

									     {	/* Ast/unit.scm 208 */
										bool_t test1788_1250;
										{	/* Ast/unit.scm 208 */
										   bool_t test_3072;
										   {	/* ./Ieee/equiv.scm 5508 */
										      obj_t aux_3077;
										      obj_t aux_3073;
										      aux_3077 =
											 CNST_TABLE_REF(((long) 7));
										      {		/* ./Ieee/pair-list.scm 5701 */
											 obj_t aux_3074;
											 aux_3074 =
											    CDR(def_1248);
											 aux_3073 =
											    CAR(aux_3074);
										      }
										      test_3072 =
											 (aux_3073 == aux_3077);
										   }
										   if (test_3072)
										     {	/* Ast/unit.scm 209 */
											bool_t _ortest_1457_1254;
											{	/* Ast/unit.scm 209 */
											   bool_t test1794_1257;
											   test1794_1257 =
											      is_a__118___object(global_1249, global_ast_var);
											   if (test1794_1257)
											     {	/* Ast/unit.scm 209 */
												_ortest_1457_1254 = ((bool_t) 0);
											     }
											   else
											     {	/* Ast/unit.scm 209 */
												_ortest_1457_1254 = ((bool_t) 1);
											     }
											}
											if (_ortest_1457_1254)
											  {	/* Ast/unit.scm 209 */
											     test1788_1250 = _ortest_1457_1254;
											  }
											else
											  {	/* ./Ieee/equiv.scm 5508 */
											     obj_t aux_3086;
											     obj_t aux_3083;
											     aux_3086 =
												CNST_TABLE_REF(((long) 7));
											     {	/* Ast/unit.scm 210 */
												global_bglt obj_2458;
												obj_2458 =
												   (global_bglt) (global_1249);
												aux_3083 =
												   (((global_bglt) CREF(obj_2458))->access);
											     }
											     test1788_1250 =
												(aux_3083 == aux_3086);
											  }
										     }
										   else
										     {	/* Ast/unit.scm 208 */
											test1788_1250 = ((bool_t) 0);
										     }
										}
										if (test1788_1250)
										  {	/* Ast/unit.scm 214 */
										     obj_t arg1789_1251;
										     obj_t arg1790_1252;
										     arg1789_1251 =
											normalize_progn_error_20_ast_unit(exp_907, sexp_27);
										     arg1790_1252 =
											CNST_TABLE_REF(((long) 8));
										     return
											make_sfun_definition_61_ast_unit(var_905, _module__166_module_module, args_906, arg1789_1251, sexp_27, arg1790_1252);
										  }
										else
										  {	/* Ast/unit.scm 208 */
										     return
											make_svar_definition_154_ast_unit(var_905, sexp_27);
										  }
									     }
									  }
								       }
								    }
								 }
							      }
							    else
							      {		/* Ast/unit.scm 174 */
								 return
								    make_svar_definition_154_ast_unit(
								    CAR(cdr_173_176_952), sexp_27);
							      }
							 }
						       else
							 {	/* Ast/unit.scm 174 */
							    obj_t cdr_283_240_978;
							    cdr_283_240_978 =
							       CDR(cdr_173_176_952);
							    {	/* Ast/unit.scm 174 */
							       obj_t car_287_85_979;
							       car_287_85_979 =
								  CAR(cdr_283_240_978);
							       if (
								  SYMBOLP(car_287_85_979))
								 {	/* Ast/unit.scm 174 */
								    bool_t test_3103;
								    {	/* ./Ieee/equiv.scm 5508 */
								       obj_t aux_3104;
								       aux_3104 =
									  CDR(cdr_283_240_978);
								       test_3103 =
									  (aux_3104 == BNIL);
								    }
								    if (test_3103)
								      {		/* Ast/unit.scm 174 */
									 var_912 =
									    CAR(cdr_173_176_952);
									 var2_913 = car_287_85_979;
								       tag_125_98_914:
									 {	/* Ast/unit.scm 222 */
									    obj_t def_1263;
									    {	/* Ast/unit.scm 222 */
									       obj_t arg1806_1271;
									       {	/* Ast/unit.scm 222 */
										  obj_t arg1807_1272;
										  arg1807_1272 =
										     find_location_120_tools_location(sexp_27);
										  arg1806_1271 =
										     id_of_id_112_ast_ident(var_912, arg1807_1272);
									       }
									       def_1263 =
										  assq___r4_pairs_and_lists_6_3(arg1806_1271, gdefs_28);
									    }
									    {	/* Ast/unit.scm 223 */
									       bool_t test_3110;
									       {	/* ./Ieee/equiv.scm 5508 */
										  obj_t aux_3115;
										  obj_t aux_3111;
										  aux_3115 =
										     CNST_TABLE_REF(((long) 7));
										  {	/* ./Ieee/pair-list.scm 5701 */
										     obj_t aux_3112;
										     aux_3112 =
											CDR(def_1263);
										     aux_3111 =
											CAR(aux_3112);
										  }
										  test_3110 =
										     (aux_3111 == aux_3115);
									       }
									       if (test_3110)
										 {	/* Ast/unit.scm 224 */
										    obj_t arity_1265;
										    arity_1265 =
										       get_global_arity_252_ast_unit(var2_913, BFALSE, gdefs_28);
										    if (
										       INTEGERP(arity_1265))
										      {		/* Ast/unit.scm 226 */
											 obj_t def_1267;
											 def_1267 =
											    eta_expanse_111_ast_unit(sexp_27, arity_1265);
											 {
											    obj_t sexp_3122;
											    sexp_3122 = def_1267;
											    sexp_27 = sexp_3122;
											    goto toplevel__ast_219_ast_unit;
											 }
										      }
										    else
										      {		/* Ast/unit.scm 225 */
											 return
											    make_svar_definition_154_ast_unit(var_912, sexp_27);
										      }
										 }
									       else
										 {	/* Ast/unit.scm 223 */
										    return
										       make_svar_definition_154_ast_unit(var_912, sexp_27);
										 }
									    }
									 }
								      }
								    else
								      {		/* Ast/unit.scm 174 */
									 return
									    make_svar_definition_154_ast_unit(
									    CAR(cdr_173_176_952), sexp_27);
								      }
								 }
							       else
								 {	/* Ast/unit.scm 174 */
								    return
								       make_svar_definition_154_ast_unit(
								       CAR(cdr_173_176_952), sexp_27);
								 }
							    }
							 }
						    }
						  else
						    {	/* Ast/unit.scm 174 */
						       obj_t cdr_359_34_992;
						       cdr_359_34_992 =
							  CDR(cdr_173_176_952);
						       {	/* Ast/unit.scm 174 */
							  obj_t car_363_0_993;
							  car_363_0_993 =
							     CAR(cdr_359_34_992);
							  {	/* Ast/unit.scm 174 */
							     obj_t cdr_367_227_994;
							     cdr_367_227_994 =
								CDR(car_363_0_993);
							     {	/* Ast/unit.scm 174 */
								bool_t test_3133;
								{	/* ./Ieee/equiv.scm 5508 */
								   obj_t aux_3136;
								   obj_t aux_3134;
								   aux_3136 =
								      CNST_TABLE_REF(((long) 10));
								   aux_3134 =
								      CAR(car_363_0_993);
								   test_3133 =
								      (aux_3134 == aux_3136);
								}
								if (test_3133)
								  {	/* Ast/unit.scm 174 */
								     if (
									PAIRP(cdr_367_227_994))
								       {	/* Ast/unit.scm 174 */
									  bool_t test_3141;
									  {	/* ./Ieee/equiv.scm 5508 */
									     obj_t aux_3142;
									     aux_3142 =
										CDR(cdr_367_227_994);
									     test_3141 =
										(aux_3142 == BNIL);
									  }
									  if (test_3141)
									    {	/* Ast/unit.scm 174 */
									       bool_t test_3145;
									       {	/* ./Ieee/equiv.scm 5508 */
										  obj_t aux_3146;
										  aux_3146 =
										     CDR(cdr_359_34_992);
										  test_3145 =
										     (aux_3146 == BNIL);
									       }
									       if (test_3145)
										 {	/* Ast/unit.scm 174 */
										    {	/* ./Ieee/pair-list.scm 5890 */
										       obj_t aux_3151;
										       obj_t aux_3149;
										       aux_3151 =
											  CAR(cdr_367_227_994);
										       aux_3149 =
											  CDR(cdr_173_176_952);
										       SET_CAR(aux_3149, aux_3151);
										    }
										    {

										       goto toplevel__ast_219_ast_unit;
										    }
										 }
									       else
										 {	/* Ast/unit.scm 174 */
										    return
										       make_svar_definition_154_ast_unit(
										       CAR(cdr_173_176_952), sexp_27);
										 }
									    }
									  else
									    {	/* Ast/unit.scm 174 */
									       obj_t cdr_420_191_1007;
									       cdr_420_191_1007 =
										  CDR(cdr_173_176_952);
									       {	/* Ast/unit.scm 174 */
										  obj_t car_424_76_1008;
										  car_424_76_1008 =
										     CAR(cdr_420_191_1007);
										  if (
										     SYMBOLP(car_424_76_1008))
										    {	/* Ast/unit.scm 174 */
										       bool_t test_3160;
										       {	/* ./Ieee/equiv.scm 5508 */
											  obj_t aux_3161;
											  aux_3161 =
											     CDR(cdr_420_191_1007);
											  test_3160 =
											     (aux_3161 == BNIL);
										       }
										       if (test_3160)
											 {
											    obj_t var2_3166;
											    obj_t var_3164;
											    var_3164 =
											       CAR(cdr_173_176_952);
											    var2_3166 = car_424_76_1008;
											    var2_913 = var2_3166;
											    var_912 = var_3164;
											    goto tag_125_98_914;
											 }
										       else
											 {	/* Ast/unit.scm 174 */
											    return
											       make_svar_definition_154_ast_unit(
											       CAR(cdr_173_176_952), sexp_27);
											 }
										    }
										  else
										    {	/* Ast/unit.scm 174 */
										       return
											  make_svar_definition_154_ast_unit(
											  CAR(cdr_173_176_952), sexp_27);
										    }
									       }
									    }
								       }
								     else
								       {	/* Ast/unit.scm 174 */
									  obj_t cdr_495_163_1023;
									  cdr_495_163_1023 =
									     CDR(cdr_173_176_952);
									  {	/* Ast/unit.scm 174 */
									     obj_t car_499_107_1024;
									     car_499_107_1024 =
										CAR(cdr_495_163_1023);
									     if (
										SYMBOLP(car_499_107_1024))
									       {	/* Ast/unit.scm 174 */
										  bool_t test_3175;
										  {	/* ./Ieee/equiv.scm 5508 */
										     obj_t aux_3176;
										     aux_3176 =
											CDR(cdr_495_163_1023);
										     test_3175 =
											(aux_3176 == BNIL);
										  }
										  if (test_3175)
										    {
										       obj_t var2_3181;
										       obj_t var_3179;
										       var_3179 =
											  CAR(cdr_173_176_952);
										       var2_3181 = car_499_107_1024;
										       var2_913 = var2_3181;
										       var_912 = var_3179;
										       goto tag_125_98_914;
										    }
										  else
										    {	/* Ast/unit.scm 174 */
										       return
											  make_svar_definition_154_ast_unit(
											  CAR(cdr_173_176_952), sexp_27);
										    }
									       }
									     else
									       {	/* Ast/unit.scm 174 */
										  return
										     make_svar_definition_154_ast_unit(
										     CAR(cdr_173_176_952), sexp_27);
									       }
									  }
								       }
								  }
								else
								  {	/* Ast/unit.scm 174 */
								     obj_t cdr_570_13_1037;
								     cdr_570_13_1037 =
									CDR(cdr_173_176_952);
								     {	/* Ast/unit.scm 174 */
									obj_t car_574_236_1038;
									car_574_236_1038 =
									   CAR(cdr_570_13_1037);
									if (
									   SYMBOLP(car_574_236_1038))
									  {	/* Ast/unit.scm 174 */
									     bool_t test_3190;
									     {	/* ./Ieee/equiv.scm 5508 */
										obj_t aux_3191;
										aux_3191 =
										   CDR(cdr_570_13_1037);
										test_3190 =
										   (aux_3191 == BNIL);
									     }
									     if (test_3190)
									       {
										  obj_t var2_3196;
										  obj_t var_3194;
										  var_3194 =
										     CAR(cdr_173_176_952);
										  var2_3196 = car_574_236_1038;
										  var2_913 = var2_3196;
										  var_912 = var_3194;
										  goto tag_125_98_914;
									       }
									     else
									       {	/* Ast/unit.scm 174 */
										  return
										     make_svar_definition_154_ast_unit(
										     CAR(cdr_173_176_952), sexp_27);
									       }
									  }
									else
									  {	/* Ast/unit.scm 174 */
									     obj_t cdr_621_107_1048;
									     cdr_621_107_1048 =
										CDR(cdr_173_176_952);
									     {	/* Ast/unit.scm 174 */
										obj_t car_626_116_1049;
										car_626_116_1049 =
										   CAR(cdr_621_107_1048);
										{	/* Ast/unit.scm 174 */
										   obj_t cdr_631_25_1050;
										   cdr_631_25_1050 =
										      CDR(car_626_116_1049);
										   {	/* Ast/unit.scm 174 */
										      bool_t test_3202;
										      {		/* ./Ieee/equiv.scm 5508 */
											 obj_t aux_3205;
											 obj_t aux_3203;
											 aux_3205 =
											    CNST_TABLE_REF(((long) 6));
											 aux_3203 =
											    CAR(car_626_116_1049);
											 test_3202 =
											    (aux_3203 == aux_3205);
										      }
										      if (test_3202)
											{	/* Ast/unit.scm 174 */
											   if (
											      PAIRP(cdr_631_25_1050))
											     {	/* Ast/unit.scm 174 */
												obj_t car_634_73_1053;
												obj_t cdr_635_119_1054;
												car_634_73_1053 =
												   CAR(cdr_631_25_1050);
												cdr_635_119_1054 =
												   CDR(cdr_631_25_1050);
												if (
												   SYMBOLP(car_634_73_1053))
												  {	/* Ast/unit.scm 174 */
												     if (
													PAIRP(cdr_635_119_1054))
												       {	/* Ast/unit.scm 174 */
													  obj_t car_640_174_1057;
													  car_640_174_1057 =
													     CAR(cdr_635_119_1054);
													  if (
													     SYMBOLP(car_640_174_1057))
													    {	/* Ast/unit.scm 174 */
													       bool_t test_3219;
													       {	/* ./Ieee/equiv.scm 5508 */
														  obj_t aux_3220;
														  aux_3220 =
														     CDR(cdr_635_119_1054);
														  test_3219 =
														     (aux_3220 == BNIL);
													       }
													       if (test_3219)
														 {	/* Ast/unit.scm 174 */
														    bool_t test_3223;
														    {	/* ./Ieee/equiv.scm 5508 */
														       obj_t aux_3224;
														       aux_3224 =
															  CDR(cdr_621_107_1048);
														       test_3223 =
															  (aux_3224 == BNIL);
														    }
														    if (test_3223)
														      {		/* Ast/unit.scm 174 */
															 var_915 =
															    CAR(cdr_173_176_952);
															 var2_916 = car_634_73_1053;
															 module_917 = car_640_174_1057;
															 {	/* Ast/unit.scm 231 */
															    obj_t def_1273;
															    {	/* Ast/unit.scm 231 */
															       obj_t arg1813_1281;
															       {	/* Ast/unit.scm 231 */
																  obj_t arg1814_1282;
																  arg1814_1282 =
																     find_location_120_tools_location(sexp_27);
																  arg1813_1281 =
																     id_of_id_112_ast_ident(var_915, arg1814_1282);
															       }
															       def_1273 =
																  assq___r4_pairs_and_lists_6_3(arg1813_1281, gdefs_28);
															    }
															    {	/* Ast/unit.scm 232 */
															       bool_t test_3230;
															       {	/* ./Ieee/equiv.scm 5508 */
																  obj_t aux_3235;
																  obj_t aux_3231;
																  aux_3235 =
																     CNST_TABLE_REF(((long) 7));
																  {	/* ./Ieee/pair-list.scm 5701 */
																     obj_t aux_3232;
																     aux_3232 =
																	CDR(def_1273);
																     aux_3231 =
																	CAR(aux_3232);
																  }
																  test_3230 =
																     (aux_3231 == aux_3235);
															       }
															       if (test_3230)
																 {	/* Ast/unit.scm 233 */
																    obj_t arity_1275;
																    arity_1275 =
																       get_global_arity_252_ast_unit(var2_916, module_917, gdefs_28);
																    if (
																       INTEGERP(arity_1275))
																      {		/* Ast/unit.scm 235 */
																	 obj_t def_1277;
																	 def_1277 =
																	    eta_expanse_111_ast_unit(sexp_27, arity_1275);
																	 {
																	    obj_t sexp_3242;
																	    sexp_3242 = def_1277;
																	    sexp_27 = sexp_3242;
																	    goto toplevel__ast_219_ast_unit;
																	 }
																      }
																    else
																      {		/* Ast/unit.scm 234 */
																	 return
																	    make_svar_definition_154_ast_unit(var_915, sexp_27);
																      }
																 }
															       else
																 {	/* Ast/unit.scm 232 */
																    return
																       make_svar_definition_154_ast_unit(var_915, sexp_27);
																 }
															    }
															 }
														      }
														    else
														      {		/* Ast/unit.scm 174 */
															 return
															    make_svar_definition_154_ast_unit(
															    CAR(cdr_173_176_952), sexp_27);
														      }
														 }
													       else
														 {	/* Ast/unit.scm 174 */
														    return
														       make_svar_definition_154_ast_unit(
														       CAR(cdr_173_176_952), sexp_27);
														 }
													    }
													  else
													    {	/* Ast/unit.scm 174 */
													       return
														  make_svar_definition_154_ast_unit(
														  CAR(cdr_173_176_952), sexp_27);
													    }
												       }
												     else
												       {	/* Ast/unit.scm 174 */
													  return
													     make_svar_definition_154_ast_unit(
													     CAR(cdr_173_176_952), sexp_27);
												       }
												  }
												else
												  {	/* Ast/unit.scm 174 */
												     return
													make_svar_definition_154_ast_unit(
													CAR(cdr_173_176_952), sexp_27);
												  }
											     }
											   else
											     {	/* Ast/unit.scm 174 */
												return
												   make_svar_definition_154_ast_unit(
												   CAR(cdr_173_176_952), sexp_27);
											     }
											}
										      else
											{	/* Ast/unit.scm 174 */
											   return
											      make_svar_definition_154_ast_unit(
											      CAR(cdr_173_176_952), sexp_27);
											}
										   }
										}
									     }
									  }
								     }
								  }
							     }
							  }
						       }
						    }
					       }
					    }
					  else
					    {	/* Ast/unit.scm 174 */
					       obj_t cdr_787_134_1094;
					       cdr_787_134_1094 =
						  CDR(cdr_173_176_952);
					       {	/* Ast/unit.scm 174 */
						  obj_t car_791_54_1095;
						  car_791_54_1095 =
						     CAR(cdr_787_134_1094);
						  if (
						     SYMBOLP(car_791_54_1095))
						    {	/* Ast/unit.scm 174 */
						       bool_t test_3264;
						       {	/* ./Ieee/equiv.scm 5508 */
							  obj_t aux_3265;
							  aux_3265 =
							     CDR(cdr_787_134_1094);
							  test_3264 =
							     (aux_3265 == BNIL);
						       }
						       if (test_3264)
							 {
							    obj_t var2_3270;
							    obj_t var_3268;
							    var_3268 =
							       CAR(cdr_173_176_952);
							    var2_3270 = car_791_54_1095;
							    var2_913 = var2_3270;
							    var_912 = var_3268;
							    goto tag_125_98_914;
							 }
						       else
							 {	/* Ast/unit.scm 174 */
							    return
							       make_svar_definition_154_ast_unit(
							       CAR(cdr_173_176_952), sexp_27);
							 }
						    }
						  else
						    {	/* Ast/unit.scm 174 */
						       return
							  make_svar_definition_154_ast_unit(
							  CAR(cdr_173_176_952), sexp_27);
						    }
					       }
					    }
				       }
				     else
				       {	/* Ast/unit.scm 174 */
					  return
					     make_svar_definition_154_ast_unit(
					     CAR(cdr_173_176_952), sexp_27);
				       }
				  }
			     }
			   else
			     {	/* Ast/unit.scm 174 */
			      tag_133_84_944:
				{	/* Ast/unit.scm 272 */
				   obj_t list1821_1288;
				   list1821_1288 =
				      MAKE_PAIR(sexp_27, BNIL);
				   return list1821_1288;
				}
			     }
			}
		      else
			{	/* Ast/unit.scm 174 */
			   bool_t test_3278;
			   {	/* ./Ieee/equiv.scm 5508 */
			      obj_t aux_3281;
			      obj_t aux_3279;
			      aux_3281 =
				 CNST_TABLE_REF(((long) 12));
			      aux_3279 =
				 CAR(sexp_27);
			      test_3278 =
				 (aux_3279 == aux_3281);
			   }
			   if (test_3278)
			     {	/* Ast/unit.scm 174 */
				if (
				   PAIRP(cdr_173_176_952))
				  {	/* Ast/unit.scm 174 */
				     obj_t car_1016_170_1113;
				     car_1016_170_1113 =
					CAR(cdr_173_176_952);
				     if (
					PAIRP(car_1016_170_1113))
				       {	/* Ast/unit.scm 174 */
					  obj_t car_1021_175_1115;
					  car_1021_175_1115 =
					     CAR(car_1016_170_1113);
					  if (
					     PAIRP(car_1021_175_1115))
					    {	/* Ast/unit.scm 174 */
					       obj_t cdr_1026_173_1117;
					       cdr_1026_173_1117 =
						  CDR(car_1021_175_1115);
					       {	/* Ast/unit.scm 174 */
						  bool_t test_3293;
						  {	/* ./Ieee/equiv.scm 5508 */
						     obj_t aux_3296;
						     obj_t aux_3294;
						     aux_3296 =
							CNST_TABLE_REF(((long) 6));
						     aux_3294 =
							CAR(car_1021_175_1115);
						     test_3293 =
							(aux_3294 == aux_3296);
						  }
						  if (test_3293)
						    {	/* Ast/unit.scm 174 */
						       if (
							  PAIRP(cdr_1026_173_1117))
							 {	/* Ast/unit.scm 174 */
							    obj_t cdr_1030_56_1120;
							    cdr_1030_56_1120 =
							       CDR(cdr_1026_173_1117);
							    if (
							       PAIRP(cdr_1030_56_1120))
							      {		/* Ast/unit.scm 174 */
								 bool_t test_3304;
								 {	/* ./Ieee/equiv.scm 5508 */
								    obj_t aux_3305;
								    aux_3305 =
								       CDR(cdr_1030_56_1120);
								    test_3304 =
								       (aux_3305 == BNIL);
								 }
								 if (test_3304)
								   {	/* Ast/unit.scm 174 */
								      obj_t arg1694_1123;
								      obj_t arg1695_1124;
								      obj_t arg1696_1125;
								      arg1694_1123 =
									 CAR(cdr_1026_173_1117);
								      arg1695_1124 =
									 CAR(cdr_1030_56_1120);
								      arg1696_1125 =
									 CDR(car_1016_170_1113);
								      {		/* Ast/unit.scm 245 */
									 obj_t arg1815_2299;
									 obj_t arg1816_2300;
									 arg1815_2299 =
									    normalize_progn_error_20_ast_unit(
									    CDR(cdr_173_176_952), sexp_27);
									 arg1816_2300 =
									    CNST_TABLE_REF(((long) 13));
									 return
									    make_sfun_definition_61_ast_unit(arg1694_1123, arg1695_1124, arg1696_1125, arg1815_2299, sexp_27, arg1816_2300);
								      }
								   }
								 else
								   {	/* Ast/unit.scm 174 */
								      obj_t car_1050_68_1128;
								      car_1050_68_1128 =
									 CAR(cdr_173_176_952);
								      {		/* Ast/unit.scm 174 */
									 obj_t arg1698_1129;
									 obj_t arg1699_1130;
									 arg1698_1129 =
									    CAR(car_1050_68_1128);
									 arg1699_1130 =
									    CDR(car_1050_68_1128);
									 {	/* Ast/unit.scm 252 */
									    obj_t arg1817_2309;
									    obj_t arg1818_2310;
									    arg1817_2309 =
									       normalize_progn_error_20_ast_unit(
									       CDR(cdr_173_176_952), sexp_27);
									    arg1818_2310 =
									       CNST_TABLE_REF(((long) 13));
									    return
									       make_sfun_definition_61_ast_unit(arg1698_1129, _module__166_module_module, arg1699_1130, arg1817_2309, sexp_27, arg1818_2310);
									 }
								      }
								   }
							      }
							    else
							      {		/* Ast/unit.scm 174 */
								 obj_t car_1071_20_1135;
								 car_1071_20_1135 =
								    CAR(cdr_173_176_952);
								 {	/* Ast/unit.scm 174 */
								    obj_t arg1703_1136;
								    obj_t arg1704_1137;
								    arg1703_1136 =
								       CAR(car_1071_20_1135);
								    arg1704_1137 =
								       CDR(car_1071_20_1135);
								    {	/* Ast/unit.scm 252 */
								       obj_t arg1817_2319;
								       obj_t arg1818_2320;
								       arg1817_2319 =
									  normalize_progn_error_20_ast_unit(
									  CDR(cdr_173_176_952), sexp_27);
								       arg1818_2320 =
									  CNST_TABLE_REF(((long) 13));
								       return
									  make_sfun_definition_61_ast_unit(arg1703_1136, _module__166_module_module, arg1704_1137, arg1817_2319, sexp_27, arg1818_2320);
								    }
								 }
							      }
							 }
						       else
							 {	/* Ast/unit.scm 174 */
							    obj_t car_1092_36_1140;
							    car_1092_36_1140 =
							       CAR(cdr_173_176_952);
							    {	/* Ast/unit.scm 174 */
							       obj_t arg1706_1141;
							       obj_t arg1707_1142;
							       arg1706_1141 =
								  CAR(car_1092_36_1140);
							       arg1707_1142 =
								  CDR(car_1092_36_1140);
							       {	/* Ast/unit.scm 252 */
								  obj_t arg1817_2329;
								  obj_t arg1818_2330;
								  arg1817_2329 =
								     normalize_progn_error_20_ast_unit(
								     CDR(cdr_173_176_952), sexp_27);
								  arg1818_2330 =
								     CNST_TABLE_REF(((long) 13));
								  return
								     make_sfun_definition_61_ast_unit(arg1706_1141, _module__166_module_module, arg1707_1142, arg1817_2329, sexp_27, arg1818_2330);
							       }
							    }
							 }
						    }
						  else
						    {	/* Ast/unit.scm 174 */
						       obj_t car_1113_246_1145;
						       car_1113_246_1145 =
							  CAR(cdr_173_176_952);
						       {	/* Ast/unit.scm 174 */
							  obj_t arg1709_1146;
							  obj_t arg1711_1147;
							  arg1709_1146 =
							     CAR(car_1113_246_1145);
							  arg1711_1147 =
							     CDR(car_1113_246_1145);
							  {	/* Ast/unit.scm 252 */
							     obj_t arg1817_2339;
							     obj_t arg1818_2340;
							     arg1817_2339 =
								normalize_progn_error_20_ast_unit(
								CDR(cdr_173_176_952), sexp_27);
							     arg1818_2340 =
								CNST_TABLE_REF(((long) 13));
							     return
								make_sfun_definition_61_ast_unit(arg1709_1146, _module__166_module_module, arg1711_1147, arg1817_2339, sexp_27, arg1818_2340);
							  }
						       }
						    }
					       }
					    }
					  else
					    {	/* Ast/unit.scm 174 */
					       obj_t car_1134_32_1152;
					       car_1134_32_1152 =
						  CAR(cdr_173_176_952);
					       {	/* Ast/unit.scm 174 */
						  obj_t arg1715_1153;
						  obj_t arg1716_1154;
						  arg1715_1153 =
						     CAR(car_1134_32_1152);
						  arg1716_1154 =
						     CDR(car_1134_32_1152);
						  {	/* Ast/unit.scm 252 */
						     obj_t arg1817_2349;
						     obj_t arg1818_2350;
						     arg1817_2349 =
							normalize_progn_error_20_ast_unit(
							CDR(cdr_173_176_952), sexp_27);
						     arg1818_2350 =
							CNST_TABLE_REF(((long) 13));
						     return
							make_sfun_definition_61_ast_unit(arg1715_1153, _module__166_module_module, arg1716_1154, arg1817_2349, sexp_27, arg1818_2350);
						  }
					       }
					    }
				       }
				     else
				       {	/* Ast/unit.scm 174 */
					  goto tag_133_84_944;
				       }
				  }
				else
				  {	/* Ast/unit.scm 174 */
				     goto tag_133_84_944;
				  }
			     }
			   else
			     {	/* Ast/unit.scm 174 */
				bool_t test_3350;
				{	/* ./Ieee/equiv.scm 5508 */
				   obj_t aux_3353;
				   obj_t aux_3351;
				   aux_3353 =
				      CNST_TABLE_REF(((long) 14));
				   aux_3351 =
				      CAR(sexp_27);
				   test_3350 =
				      (aux_3351 == aux_3353);
				}
				if (test_3350)
				  {	/* Ast/unit.scm 174 */
				     if (
					PAIRP(cdr_173_176_952))
				       {	/* Ast/unit.scm 174 */
					  obj_t car_1218_42_1159;
					  car_1218_42_1159 =
					     CAR(cdr_173_176_952);
					  if (
					     PAIRP(car_1218_42_1159))
					    {	/* Ast/unit.scm 174 */
					       obj_t car_1223_0_1161;
					       car_1223_0_1161 =
						  CAR(car_1218_42_1159);
					       if (
						  PAIRP(car_1223_0_1161))
						 {	/* Ast/unit.scm 174 */
						    obj_t cdr_1228_61_1163;
						    cdr_1228_61_1163 =
						       CDR(car_1223_0_1161);
						    {	/* Ast/unit.scm 174 */
						       bool_t test_3365;
						       {	/* ./Ieee/equiv.scm 5508 */
							  obj_t aux_3368;
							  obj_t aux_3366;
							  aux_3368 =
							     CNST_TABLE_REF(((long) 6));
							  aux_3366 =
							     CAR(car_1223_0_1161);
							  test_3365 =
							     (aux_3366 == aux_3368);
						       }
						       if (test_3365)
							 {	/* Ast/unit.scm 174 */
							    if (
							       PAIRP(cdr_1228_61_1163))
							      {		/* Ast/unit.scm 174 */
								 obj_t cdr_1232_5_1166;
								 cdr_1232_5_1166 =
								    CDR(cdr_1228_61_1163);
								 if (
								    PAIRP(cdr_1232_5_1166))
								   {	/* Ast/unit.scm 174 */
								      bool_t test_3376;
								      {		/* ./Ieee/equiv.scm 5508 */
									 obj_t aux_3377;
									 aux_3377 =
									    CDR(cdr_1232_5_1166);
									 test_3376 =
									    (aux_3377 == BNIL);
								      }
								      if (test_3376)
									{	/* Ast/unit.scm 174 */
									   return
									      make_sgfun_definition_102_ast_unit(
									      CAR(cdr_1228_61_1163),
									      CAR(cdr_1232_5_1166),
									      CDR(car_1218_42_1159),
									      CDR(cdr_173_176_952), sexp_27, gdefs_28);
									}
								      else
									{	/* Ast/unit.scm 174 */
									   obj_t car_1251_219_1174;
									   car_1251_219_1174 =
									      CAR(cdr_173_176_952);
									   return
									      make_sgfun_definition_102_ast_unit(
									      CAR(car_1251_219_1174), _module__166_module_module,
									      CDR(car_1251_219_1174),
									      CDR(cdr_173_176_952), sexp_27, gdefs_28);
									}
								   }
								 else
								   {	/* Ast/unit.scm 174 */
								      obj_t car_1271_124_1181;
								      car_1271_124_1181 =
									 CAR(cdr_173_176_952);
								      return
									 make_sgfun_definition_102_ast_unit(
									 CAR(car_1271_124_1181), _module__166_module_module,
									 CDR(car_1271_124_1181),
									 CDR(cdr_173_176_952), sexp_27, gdefs_28);
								   }
							      }
							    else
							      {		/* Ast/unit.scm 174 */
								 obj_t car_1291_93_1186;
								 car_1291_93_1186 =
								    CAR(cdr_173_176_952);
								 return
								    make_sgfun_definition_102_ast_unit(
								    CAR(car_1291_93_1186), _module__166_module_module,
								    CDR(car_1291_93_1186),
								    CDR(cdr_173_176_952), sexp_27, gdefs_28);
							      }
							 }
						       else
							 {	/* Ast/unit.scm 174 */
							    obj_t car_1311_183_1191;
							    car_1311_183_1191 =
							       CAR(cdr_173_176_952);
							    return
							       make_sgfun_definition_102_ast_unit(
							       CAR(car_1311_183_1191), _module__166_module_module,
							       CDR(car_1311_183_1191),
							       CDR(cdr_173_176_952), sexp_27, gdefs_28);
							 }
						    }
						 }
					       else
						 {	/* Ast/unit.scm 174 */
						    obj_t car_1331_103_1198;
						    car_1331_103_1198 =
						       CAR(cdr_173_176_952);
						    return
						       make_sgfun_definition_102_ast_unit(
						       CAR(car_1331_103_1198), _module__166_module_module,
						       CDR(car_1331_103_1198),
						       CDR(cdr_173_176_952), sexp_27, gdefs_28);
						 }
					    }
					  else
					    {	/* Ast/unit.scm 174 */
					       goto tag_133_84_944;
					    }
				       }
				     else
				       {	/* Ast/unit.scm 174 */
					  goto tag_133_84_944;
				       }
				  }
				else
				  {	/* Ast/unit.scm 174 */
				     bool_t test_3410;
				     {	/* ./Ieee/equiv.scm 5508 */
					obj_t aux_3413;
					obj_t aux_3411;
					aux_3413 =
					   CNST_TABLE_REF(((long) 15));
					aux_3411 =
					   CAR(sexp_27);
					test_3410 =
					   (aux_3411 == aux_3413);
				     }
				     if (test_3410)
				       {	/* Ast/unit.scm 174 */
					  if (
					     PAIRP(cdr_173_176_952))
					    {	/* Ast/unit.scm 174 */
					       obj_t car_1381_231_1205;
					       car_1381_231_1205 =
						  CAR(cdr_173_176_952);
					       if (
						  PAIRP(car_1381_231_1205))
						 {	/* Ast/unit.scm 174 */
						    obj_t arg1753_1207;
						    obj_t arg1754_1208;
						    arg1753_1207 =
						       CAR(car_1381_231_1205);
						    arg1754_1208 =
						       CDR(car_1381_231_1205);
						    {	/* Ast/unit.scm 270 */
						       obj_t arg1820_2431;
						       arg1820_2431 =
							  normalize_progn_error_20_ast_unit(
							  CDR(cdr_173_176_952), sexp_27);
						       return
							  make_method_definition_178_ast_unit(arg1753_1207, arg1754_1208, arg1820_2431, sexp_27);
						    }
						 }
					       else
						 {	/* Ast/unit.scm 174 */
						    goto tag_133_84_944;
						 }
					    }
					  else
					    {	/* Ast/unit.scm 174 */
					       goto tag_133_84_944;
					    }
				       }
				     else
				       {	/* Ast/unit.scm 174 */
					  goto tag_133_84_944;
				       }
				  }
			     }
			}
		   }
		}
	   }
	 else
	   {	/* Ast/unit.scm 174 */
	      goto tag_133_84_944;
	   }
      }
   }
}



/* normalize-progn/error */
obj_t 
normalize_progn_error_20_ast_unit(obj_t exp_29, obj_t src_30)
{
   AN_OBJECT;
   {	/* Ast/unit.scm 277 */
      if (
	 NULLP(exp_29))
	{	/* Ast/unit.scm 279 */
	   obj_t arg1824_1291;
	   arg1824_1291 =
	      find_location_120_tools_location(src_30);
	   {	/* Ast/unit.scm 279 */
	      node_bglt aux_3429;
	      aux_3429 =
		 error_sexp__node_157_ast_sexp(string2118_ast_unit, src_30, arg1824_1291);
	      return
		 (obj_t) (aux_3429);
	   }
	}
      else
	{	/* Ast/unit.scm 278 */
	   return
	      normalize_progn_143_tools_progn(exp_29);
	}
   }
}



/* get-global-arity */
obj_t 
get_global_arity_252_ast_unit(obj_t id_31, obj_t module_32, obj_t gdefs_33)
{
   AN_OBJECT;
   {	/* Ast/unit.scm 285 */
      {		/* Ast/unit.scm 286 */
	 obj_t global_1292;
	 if (
	    SYMBOLP(module_32))
	   {	/* Ast/unit.scm 286 */
	      global_1292 =
		 find_global_module_25_ast_env(id_31, module_32);
	   }
	 else
	   {	/* Ast/unit.scm 286 */
	      global_1292 =
		 find_global_223_ast_env(id_31, BNIL);
	   }
	 {	/* Ast/unit.scm 289 */
	    bool_t test1825_1293;
	    test1825_1293 =
	       is_a__118___object(global_1292, global_ast_var);
	    if (test1825_1293)
	      {		/* Ast/unit.scm 291 */
		 bool_t test1826_1294;
		 {	/* ./Ast/var.scm 932 */
		    obj_t aux_3439;
		    {	/* Ast/unit.scm 291 */
		       value_bglt aux_3440;
		       {	/* Ast/unit.scm 291 */
			  global_bglt obj_2487;
			  obj_2487 =
			     (global_bglt) (global_1292);
			  aux_3440 =
			     (((global_bglt) CREF(obj_2487))->value);
		       }
		       aux_3439 =
			  (obj_t) (aux_3440);
		    }
		    test1826_1294 =
		       is_a__118___object(aux_3439, fun_ast_var);
		 }
		 if (test1826_1294)
		   {	/* Ast/unit.scm 292 */
		      fun_bglt obj_2490;
		      {		/* Ast/unit.scm 292 */
			 value_bglt aux_3446;
			 {	/* Ast/unit.scm 292 */
			    global_bglt obj_2489;
			    obj_2489 =
			       (global_bglt) (global_1292);
			    aux_3446 =
			       (((global_bglt) CREF(obj_2489))->value);
			 }
			 obj_2490 =
			    (fun_bglt) (aux_3446);
		      }
		      {		/* ./Ast/var.scm 934 */
			 long aux_3450;
			 aux_3450 =
			    (((fun_bglt) CREF(obj_2490))->arity);
			 return
			    BINT(aux_3450);
		      }
		   }
		 else
		   {	/* Ast/unit.scm 291 */
		      return BFALSE;
		   }
	      }
	    else
	      {		/* Ast/unit.scm 289 */
		 return BFALSE;
	      }
	 }
      }
   }
}



/* eta-expanse */
obj_t 
eta_expanse_111_ast_unit(obj_t sexp_34, obj_t arity_35)
{
   AN_OBJECT;
   {	/* Ast/unit.scm 298 */
      {		/* Ast/unit.scm 299 */
	 obj_t args_1299;
	 args_1299 =
	    make_n_proto_123_tools_args(arity_35);
	 {
	    obj_t var_1329;
	    obj_t id2_1330;
	    if (
	       PAIRP(sexp_34))
	      {		/* Ast/unit.scm 323 */
		 obj_t cdr_1489_99_1311;
		 cdr_1489_99_1311 =
		    CDR(sexp_34);
		 {	/* Ast/unit.scm 323 */
		    bool_t test_3457;
		    {	/* ./Ieee/equiv.scm 5508 */
		       obj_t aux_3460;
		       obj_t aux_3458;
		       aux_3460 =
			  CNST_TABLE_REF(((long) 11));
		       aux_3458 =
			  CAR(sexp_34);
		       test_3457 =
			  (aux_3458 == aux_3460);
		    }
		    if (test_3457)
		      {		/* Ast/unit.scm 323 */
			 if (
			    PAIRP(cdr_1489_99_1311))
			   {	/* Ast/unit.scm 323 */
			      obj_t cdr_1493_26_1314;
			      cdr_1493_26_1314 =
				 CDR(cdr_1489_99_1311);
			      if (
				 PAIRP(cdr_1493_26_1314))
				{	/* Ast/unit.scm 323 */
				   bool_t test_3468;
				   {	/* ./Ieee/equiv.scm 5508 */
				      obj_t aux_3469;
				      aux_3469 =
					 CDR(cdr_1493_26_1314);
				      test_3468 =
					 (aux_3469 == BNIL);
				   }
				   if (test_3468)
				     {	/* Ast/unit.scm 323 */
					obj_t arg1836_1317;
					obj_t arg1838_1318;
					arg1836_1317 =
					   CAR(cdr_1489_99_1311);
					arg1838_1318 =
					   CAR(cdr_1493_26_1314);
					{	/* Ast/unit.scm 325 */
					   obj_t id2_2506;
					   {	/* Ast/unit.scm 325 */
					      obj_t arg1845_2507;
					      arg1845_2507 =
						 find_location_120_tools_location(sexp_34);
					      id2_2506 =
						 id_of_id_112_ast_ident(arg1838_1318, arg1845_2507);
					   }
					   {	/* Ast/unit.scm 326 */
					      obj_t arg1844_2508;
					      var_1329 = arg1836_1317;
					      id2_1330 = id2_2506;
					      {		/* Ast/unit.scm 314 */
						 bool_t test_3476;
						 {	/* ./Ieee/fixnum.scm 7133 */
						    long aux_3477;
						    aux_3477 =
						       (long) CINT(arity_35);
						    test_3476 =
						       (aux_3477 >= ((long) 0));
						 }
						 if (test_3476)
						   {	/* Ast/unit.scm 314 */
						      {		/* Ast/unit.scm 315 */
							 obj_t arg1850_1333;
							 obj_t arg1851_1334;
							 arg1850_1333 =
							    CNST_TABLE_REF(((long) 11));
							 {	/* Ast/unit.scm 315 */
							    obj_t arg1852_1335;
							    obj_t arg1853_1336;
							    arg1852_1335 =
							       MAKE_PAIR(var_1329, args_1299);
							    {	/* Ast/unit.scm 316 */
							       obj_t arg1854_1337;
							       {	/* ./Ieee/pair-list.scm 5689 */
								  obj_t aux_3482;
								  aux_3482 =
								     append_2_18___r4_pairs_and_lists_6_3(args_1299, BNIL);
								  arg1854_1337 =
								     MAKE_PAIR(id2_1330, aux_3482);
							       }
							       arg1853_1336 =
								  MAKE_PAIR(arg1854_1337, BNIL);
							    }
							    arg1851_1334 =
							       MAKE_PAIR(arg1852_1335, arg1853_1336);
							 }
							 arg1844_2508 =
							    MAKE_PAIR(arg1850_1333, arg1851_1334);
						      }
						   }
						 else
						   {	/* Ast/unit.scm 317 */
						      bool_t test_3488;
						      {		/* ./Ieee/fixnum.scm 7109 */
							 long aux_3489;
							 aux_3489 =
							    (long) CINT(arity_35);
							 test_3488 =
							    (aux_3489 == ((long) -1));
						      }
						      if (test_3488)
							{	/* Ast/unit.scm 317 */
							   {	/* Ast/unit.scm 318 */
							      obj_t arg1858_1341;
							      obj_t arg1859_1342;
							      arg1858_1341 =
								 CNST_TABLE_REF(((long) 11));
							      {		/* Ast/unit.scm 318 */
								 obj_t arg1860_1343;
								 obj_t arg1861_1344;
								 arg1860_1343 =
								    MAKE_PAIR(var_1329, args_1299);
								 {	/* Ast/unit.scm 319 */
								    obj_t arg1862_1345;
								    {	/* Ast/unit.scm 319 */
								       obj_t arg1864_1347;
								       obj_t arg1865_1348;
								       arg1864_1347 =
									  CNST_TABLE_REF(((long) 16));
								       {	/* Ast/unit.scm 319 */
									  obj_t arg1866_1349;
									  arg1866_1349 =
									     MAKE_PAIR(args_1299, BNIL);
									  arg1865_1348 =
									     MAKE_PAIR(id2_1330, arg1866_1349);
								       }
								       arg1862_1345 =
									  MAKE_PAIR(arg1864_1347, arg1865_1348);
								    }
								    arg1861_1344 =
								       MAKE_PAIR(arg1862_1345, BNIL);
								 }
								 arg1859_1342 =
								    MAKE_PAIR(arg1860_1343, arg1861_1344);
							      }
							      arg1844_2508 =
								 MAKE_PAIR(arg1858_1341, arg1859_1342);
							   }
							}
						      else
							{	/* Ast/unit.scm 317 */
							   {	/* Ast/unit.scm 321 */
							      obj_t arg1867_1350;
							      obj_t arg1868_1351;
							      arg1867_1350 =
								 CNST_TABLE_REF(((long) 11));
							      {		/* Ast/unit.scm 321 */
								 obj_t arg1869_1352;
								 obj_t arg1870_1353;
								 arg1869_1352 =
								    MAKE_PAIR(var_1329, args_1299);
								 {	/* Ast/unit.scm 322 */
								    obj_t arg1871_1354;
								    {	/* Ast/unit.scm 322 */
								       obj_t arg1873_1356;
								       obj_t arg1874_1357;
								       arg1873_1356 =
									  CNST_TABLE_REF(((long) 16));
								       {	/* Ast/unit.scm 322 */
									  obj_t arg1875_1358;
									  {	/* Ast/unit.scm 322 */
									     obj_t arg1876_1359;
									     {	/* Ast/unit.scm 322 */
										obj_t arg1879_1361;
										obj_t arg1880_1362;
										arg1879_1361 =
										   CNST_TABLE_REF(((long) 17));
										{	/* Ast/unit.scm 322 */
										   obj_t arg1881_1363;
										   arg1881_1363 =
										      args___args_list_50_tools_args(args_1299);
										   arg1880_1362 =
										      append_2_18___r4_pairs_and_lists_6_3(arg1881_1363, BNIL);
										}
										arg1876_1359 =
										   MAKE_PAIR(arg1879_1361, arg1880_1362);
									     }
									     arg1875_1358 =
										MAKE_PAIR(arg1876_1359, BNIL);
									  }
									  arg1874_1357 =
									     MAKE_PAIR(id2_1330, arg1875_1358);
								       }
								       arg1871_1354 =
									  MAKE_PAIR(arg1873_1356, arg1874_1357);
								    }
								    arg1870_1353 =
								       MAKE_PAIR(arg1871_1354, BNIL);
								 }
								 arg1868_1351 =
								    MAKE_PAIR(arg1869_1352, arg1870_1353);
							      }
							      arg1844_2508 =
								 MAKE_PAIR(arg1867_1350, arg1868_1351);
							   }
							}
						   }
					      }
					      return
						 replace__160_tools_misc(sexp_34, arg1844_2508);
					   }
					}
				     }
				   else
				     {	/* Ast/unit.scm 323 */
					return BFALSE;
				     }
				}
			      else
				{	/* Ast/unit.scm 323 */
				   return BFALSE;
				}
			   }
			 else
			   {	/* Ast/unit.scm 323 */
			      return BFALSE;
			   }
		      }
		    else
		      {		/* Ast/unit.scm 323 */
			 return BFALSE;
		      }
		 }
	      }
	    else
	      {		/* Ast/unit.scm 323 */
		 return BFALSE;
	      }
	 }
      }
   }
}



/* make-sfun-definition */
obj_t 
make_sfun_definition_61_ast_unit(obj_t id_36, obj_t module_37, obj_t args_38, obj_t body_39, obj_t src_40, obj_t class_41)
{
   AN_OBJECT;
   {	/* Ast/unit.scm 334 */
      {		/* Ast/unit.scm 335 */
	 obj_t loc_1416;
	 loc_1416 =
	    find_location_120_tools_location(src_40);
	 {	/* Ast/unit.scm 335 */
	    obj_t locals_1417;
	    {
	       obj_t args_1421;
	       obj_t res_1422;
	       args_1421 = args_38;
	       res_1422 = BNIL;
	     loop_1423:
	       if (
		  NULLP(args_1421))
		 {	/* Ast/unit.scm 339 */
		    locals_1417 =
		       reverse__39___r4_pairs_and_lists_6_3(res_1422);
		 }
	       else
		 {	/* Ast/unit.scm 339 */
		    if (
		       PAIRP(args_1421))
		      {		/* Ast/unit.scm 350 */
			 bool_t test1936_1426;
			 {	/* Ast/unit.scm 350 */
			    obj_t aux_3521;
			    aux_3521 =
			       dsssl_named_constant__188_tools_dsssl(
			       CAR(args_1421));
			    test1936_1426 =
			       CBOOL(aux_3521);
			 }
			 if (test1936_1426)
			   {	/* Ast/unit.scm 350 */
			      {		/* Ast/unit.scm 351 */
				 obj_t arg_1427;
				 arg_1427 =
				    dsssl_find_first_formal_237_tools_dsssl(args_1421);
				 if (
				    CBOOL(arg_1427))
				   {	/* Ast/unit.scm 354 */
				      obj_t arg1937_1428;
				      {		/* Ast/unit.scm 354 */
					 local_bglt arg1938_1429;
					 arg1938_1429 =
					    make_user_local_svar_134_ast_local(arg_1427,
					    (type_bglt) (_obj__252_type_cache));
					 {	/* ./Ieee/pair-list.scm 5689 */
					    obj_t aux_3531;
					    aux_3531 =
					       (obj_t) (arg1938_1429);
					    arg1937_1428 =
					       MAKE_PAIR(aux_3531, res_1422);
					 }
				      }
				      locals_1417 =
					 reverse__39___r4_pairs_and_lists_6_3(arg1937_1428);
				   }
				 else
				   {	/* Ast/unit.scm 352 */
				      locals_1417 =
					 reverse__39___r4_pairs_and_lists_6_3(res_1422);
				   }
			      }
			   }
			 else
			   {	/* Ast/unit.scm 350 */
			      {		/* Ast/unit.scm 357 */
				 obj_t pid_1430;
				 {	/* Ast/unit.scm 357 */
				    obj_t arg1942_1436;
				    arg1942_1436 =
				       parse_id_241_ast_ident(
				       CAR(args_1421), loc_1416);
				    pid_1430 =
				       check_id_6_ast_ident(arg1942_1436, src_40);
				 }
				 {	/* Ast/unit.scm 360 */

				    {	/* Ast/unit.scm 361 */
				       obj_t arg1939_1433;
				       obj_t arg1940_1434;
				       arg1939_1433 =
					  CDR(args_1421);
				       {	/* Ast/unit.scm 362 */
					  local_bglt arg1941_1435;
					  {	/* Ast/unit.scm 362 */
					     type_bglt aux_3540;
					     {	/* Ast/unit.scm 362 */
						obj_t aux_3542;
						aux_3542 =
						   CDR(pid_1430);
						aux_3540 =
						   (type_bglt) (aux_3542);
					     }
					     arg1941_1435 =
						make_user_local_svar_134_ast_local(
						CAR(pid_1430), aux_3540);
					  }
					  {	/* ./Ieee/pair-list.scm 5689 */
					     obj_t aux_3546;
					     aux_3546 =
						(obj_t) (arg1941_1435);
					     arg1940_1434 =
						MAKE_PAIR(aux_3546, res_1422);
					  }
				       }
				       {
					  obj_t res_3550;
					  obj_t args_3549;
					  args_3549 = arg1939_1433;
					  res_3550 = arg1940_1434;
					  res_1422 = res_3550;
					  args_1421 = args_3549;
					  goto loop_1423;
				       }
				    }
				 }
			      }
			   }
		      }
		    else
		      {		/* Ast/unit.scm 341 */
			 {	/* Ast/unit.scm 342 */
			    obj_t pid_1439;
			    {	/* Ast/unit.scm 342 */
			       obj_t arg1948_1444;
			       arg1948_1444 =
				  parse_id_241_ast_ident(args_1421, loc_1416);
			       pid_1439 =
				  check_id_6_ast_ident(arg1948_1444, src_40);
			    }
			    {	/* Ast/unit.scm 344 */

			       {	/* Ast/unit.scm 348 */
				  obj_t arg1945_1442;
				  {	/* Ast/unit.scm 348 */
				     local_bglt arg1946_1443;
				     {	/* Ast/unit.scm 348 */
					type_bglt aux_3553;
					{	/* Ast/unit.scm 348 */
					   obj_t aux_3555;
					   aux_3555 =
					      CDR(pid_1439);
					   aux_3553 =
					      (type_bglt) (aux_3555);
					}
					arg1946_1443 =
					   make_user_local_svar_134_ast_local(
					   CAR(pid_1439), aux_3553);
				     }
				     {	/* ./Ieee/pair-list.scm 5689 */
					obj_t aux_3559;
					aux_3559 =
					   (obj_t) (arg1946_1443);
					arg1945_1442 =
					   MAKE_PAIR(aux_3559, res_1422);
				     }
				  }
				  locals_1417 =
				     reverse__39___r4_pairs_and_lists_6_3(arg1945_1442);
			       }
			    }
			 }
		      }
		 }
	    }
	    {	/* Ast/unit.scm 336 */
	       obj_t body_1418;
	       body_1418 =
		  make_dsssl_function_prelude_58___dsssl(id_36, args_38, body_39, user_error_env_101_tools_error);
	       {	/* Ast/unit.scm 364 */

		  {	/* Ast/unit.scm 365 */
		     global_bglt arg1932_1419;
		     arg1932_1419 =
			def_global_sfun__93_ast_glo_def_117(id_36, args_38, locals_1417, module_37, class_41, src_40,
			CNST_TABLE_REF(((long) 18)), body_1418);
		     {	/* Ast/unit.scm 365 */
			obj_t list1933_1420;
			{	/* Ast/unit.scm 365 */
			   obj_t aux_3566;
			   aux_3566 =
			      (obj_t) (arg1932_1419);
			   list1933_1420 =
			      MAKE_PAIR(aux_3566, BNIL);
			}
			return list1933_1420;
		     }
		  }
	       }
	    }
	 }
      }
   }
}



/* make-svar-definition */
obj_t 
make_svar_definition_154_ast_unit(obj_t id_42, obj_t src_43)
{
   AN_OBJECT;
   {	/* Ast/unit.scm 370 */
      def_global_svar__184_ast_glo_def_117(id_42, _module__166_module_module, src_43,
	 CNST_TABLE_REF(((long) 18)));
      {		/* Ast/unit.scm 374 */
	 obj_t arg1949_1445;
	 obj_t arg1950_1446;
	 arg1949_1445 =
	    CDR(src_43);
	 {	/* Ast/unit.scm 374 */
	    obj_t arg1951_1447;
	    {	/* Ast/unit.scm 374 */
	       obj_t arg1952_1448;
	       {	/* Ast/unit.scm 374 */
		  obj_t arg1953_1449;
		  arg1953_1449 =
		     find_location_120_tools_location(src_43);
		  arg1952_1448 =
		     parse_id_241_ast_ident(id_42, arg1953_1449);
	       }
	       arg1951_1447 =
		  check_id_6_ast_ident(arg1952_1448, src_43);
	    }
	    arg1950_1446 =
	       CAR(arg1951_1447);
	 }
	 SET_CAR(arg1949_1445, arg1950_1446);
      }
      {		/* Ast/unit.scm 375 */
	 obj_t list1954_1450;
	 list1954_1450 =
	    MAKE_PAIR(src_43, BNIL);
	 return list1954_1450;
      }
   }
}



/* make-sgfun-default */
obj_t 
make_sgfun_default_250_ast_unit(obj_t name_44, obj_t type_45, obj_t args_46, obj_t body_47, obj_t src_48, obj_t gdefs_49)
{
   AN_OBJECT;
   {	/* Ast/unit.scm 380 */
      {		/* Ast/unit.scm 382 */
	 obj_t default_tid_30_1452;
	 {	/* Ast/unit.scm 383 */
	    bool_t test1982_1482;
	    {	/* Ast/unit.scm 383 */
	       obj_t obj2_2640;
	       obj2_2640 = ____74_type_cache;
	       test1982_1482 =
		  (type_45 == obj2_2640);
	    }
	    if (test1982_1482)
	      {		/* Ast/unit.scm 383 */
		 default_tid_30_1452 = name_44;
	      }
	    else
	      {		/* Ast/unit.scm 385 */
		 obj_t list1984_1484;
		 {	/* Ast/unit.scm 385 */
		    obj_t arg1985_1485;
		    {	/* Ast/unit.scm 385 */
		       obj_t arg1986_1486;
		       {	/* Ast/unit.scm 385 */
			  obj_t aux_3580;
			  {	/* Ast/unit.scm 387 */
			     type_bglt obj_2641;
			     obj_2641 =
				(type_bglt) (type_45);
			     aux_3580 =
				(((type_bglt) CREF(obj_2641))->id);
			  }
			  arg1986_1486 =
			     MAKE_PAIR(aux_3580, BNIL);
		       }
		       arg1985_1485 =
			  MAKE_PAIR(_4dots_199_tools_misc, arg1986_1486);
		    }
		    list1984_1484 =
		       MAKE_PAIR(name_44, arg1985_1485);
		 }
		 default_tid_30_1452 =
		    symbol_append_197___r4_symbols_6_4(list1984_1484);
	      }
	 }
	 {	/* Ast/unit.scm 383 */
	    obj_t default_body_201_1453;
	    if (
	       PAIRP(body_47))
	      {		/* Ast/unit.scm 388 */
		 default_body_201_1453 =
		    normalize_progn_143_tools_progn(body_47);
	      }
	    else
	      {		/* Ast/unit.scm 390 */
		 obj_t arg1968_1470;
		 obj_t arg1969_1471;
		 arg1968_1470 =
		    CNST_TABLE_REF(((long) 19));
		 {	/* Ast/unit.scm 390 */
		    obj_t arg1970_1472;
		    obj_t arg1971_1473;
		    {	/* Ast/unit.scm 390 */
		       obj_t arg1972_1474;
		       obj_t arg1973_1475;
		       arg1972_1474 =
			  CNST_TABLE_REF(((long) 20));
		       arg1973_1475 =
			  MAKE_PAIR(name_44, BNIL);
		       arg1970_1472 =
			  MAKE_PAIR(arg1972_1474, arg1973_1475);
		    }
		    {	/* Ast/unit.scm 390 */
		       obj_t arg1976_1477;
		       {	/* Ast/unit.scm 392 */
			  obj_t arg1977_1478;
			  {	/* Ast/unit.scm 392 */
			     obj_t arg1980_1480;
			     obj_t arg1981_1481;
			     arg1980_1480 =
				CAR(args_46);
			     arg1981_1481 =
				find_location_120_tools_location(src_48);
			     arg1977_1478 =
				id_of_id_112_ast_ident(arg1980_1480, arg1981_1481);
			  }
			  arg1976_1477 =
			     MAKE_PAIR(arg1977_1478, BNIL);
		       }
		       arg1971_1473 =
			  MAKE_PAIR(string2119_ast_unit, arg1976_1477);
		    }
		    arg1969_1471 =
		       MAKE_PAIR(arg1970_1472, arg1971_1473);
		 }
		 default_body_201_1453 =
		    MAKE_PAIR(arg1968_1470, arg1969_1471);
	      }
	    {	/* Ast/unit.scm 388 */
	       obj_t form_1454;
	       {	/* Ast/unit.scm 394 */
		  obj_t tmp_1460;
		  {	/* Ast/unit.scm 394 */
		     obj_t arg1963_1465;
		     obj_t arg1964_1466;
		     arg1963_1465 =
			CNST_TABLE_REF(((long) 11));
		     {	/* Ast/unit.scm 394 */
			obj_t arg1965_1467;
			obj_t arg1966_1468;
			arg1965_1467 =
			   MAKE_PAIR(default_tid_30_1452, args_46);
			arg1966_1468 =
			   MAKE_PAIR(default_body_201_1453, BNIL);
			arg1964_1466 =
			   MAKE_PAIR(arg1965_1467, arg1966_1468);
		     }
		     tmp_1460 =
			MAKE_PAIR(arg1963_1465, arg1964_1466);
		  }
		  {	/* Ast/unit.scm 395 */
		     bool_t test1959_1461;
		     {	/* Ast/unit.scm 395 */
			obj_t obj_2664;
			obj_2664 = _module_clause__117_module_module;
			test1959_1461 =
			   EXTENDED_PAIRP(obj_2664);
		     }
		     if (test1959_1461)
		       {	/* Ast/unit.scm 396 */
			  obj_t arg1960_1462;
			  obj_t arg1961_1463;
			  obj_t arg1962_1464;
			  arg1960_1462 =
			     CAR(tmp_1460);
			  arg1961_1463 =
			     CDR(tmp_1460);
			  {	/* Ast/unit.scm 396 */
			     obj_t obj_2667;
			     obj_2667 = _module_clause__117_module_module;
			     {	/* ./Ieee/pair-list.scm 5713 */
				bool_t test1136_2668;
				test1136_2668 =
				   EXTENDED_PAIRP(obj_2667);
				if (test1136_2668)
				  {	/* ./Ieee/pair-list.scm 5713 */
				     arg1962_1464 =
					CER(obj_2667);
				  }
				else
				  {	/* ./Ieee/pair-list.scm 5713 */
				     FAILURE(string2120_ast_unit, string2121_ast_unit, obj_2667);
				  }
			     }
			  }
			  form_1454 =
			     MAKE_EXTENDED_PAIR(arg1960_1462, arg1961_1463, arg1962_1464);
		       }
		     else
		       {	/* Ast/unit.scm 395 */
			  form_1454 = tmp_1460;
		       }
		  }
	       }
	       {	/* Ast/unit.scm 394 */

		  {	/* Ast/unit.scm 399 */
		     obj_t ast_1455;
		     ast_1455 =
			toplevel__ast_219_ast_unit(form_1454, gdefs_49);
		     if (
			PAIRP(ast_1455))
		       {	/* Ast/unit.scm 402 */
			  bool_t test1956_1457;
			  test1956_1457 =
			     is_a__118___object(
			     CAR(ast_1455), global_ast_var);
			  if (test1956_1457)
			    {	/* Ast/unit.scm 403 */
			       global_bglt obj_2680;
			       {	/* Ast/unit.scm 403 */
				  obj_t aux_3621;
				  aux_3621 =
				     CAR(ast_1455);
				  obj_2680 =
				     (global_bglt) (aux_3621);
			       }
			       ((((global_bglt) CREF(obj_2680))->user__32) = ((bool_t) ((bool_t) 0)), BUNSPEC);
			    }
			  else
			    {	/* Ast/unit.scm 402 */
			       BUNSPEC;
			    }
		       }
		     else
		       {	/* Ast/unit.scm 401 */
			  BUNSPEC;
		       }
		     return ast_1455;
		  }
	       }
	    }
	 }
      }
   }
}



/* make-sgfun-definition */
obj_t 
make_sgfun_definition_102_ast_unit(obj_t id_50, obj_t module_51, obj_t args_52, obj_t body_53, obj_t src_54, obj_t gdefs_55)
{
   AN_OBJECT;
   {	/* Ast/unit.scm 409 */
      {		/* Ast/unit.scm 412 */
	 obj_t loc_1487;
	 loc_1487 =
	    find_location_120_tools_location(src_54);
	 {	/* Ast/unit.scm 412 */
	    obj_t locals_1488;
	    {
	       obj_t args_1522;
	       obj_t res_1523;
	       args_1522 = args_52;
	       res_1523 = BNIL;
	     loop_1524:
	       if (
		  NULLP(args_1522))
		 {	/* Ast/unit.scm 416 */
		    locals_1488 =
		       reverse__39___r4_pairs_and_lists_6_3(res_1523);
		 }
	       else
		 {	/* Ast/unit.scm 416 */
		    if (
		       PAIRP(args_1522))
		      {		/* Ast/unit.scm 418 */
			 {	/* Ast/unit.scm 428 */
			    obj_t pid_1527;
			    {	/* Ast/unit.scm 428 */
			       obj_t arg2016_1533;
			       arg2016_1533 =
				  parse_id_241_ast_ident(
				  CAR(args_1522), loc_1487);
			       pid_1527 =
				  check_id_6_ast_ident(arg2016_1533, src_54);
			    }
			    {	/* Ast/unit.scm 430 */

			       {	/* Ast/unit.scm 431 */
				  obj_t arg2013_1530;
				  obj_t arg2014_1531;
				  arg2013_1530 =
				     CDR(args_1522);
				  {	/* Ast/unit.scm 432 */
				     local_bglt arg2015_1532;
				     {	/* Ast/unit.scm 432 */
					type_bglt aux_3635;
					{	/* Ast/unit.scm 432 */
					   obj_t aux_3637;
					   aux_3637 =
					      CDR(pid_1527);
					   aux_3635 =
					      (type_bglt) (aux_3637);
					}
					arg2015_1532 =
					   make_user_local_svar_134_ast_local(
					   CAR(pid_1527), aux_3635);
				     }
				     {	/* ./Ieee/pair-list.scm 5689 */
					obj_t aux_3641;
					aux_3641 =
					   (obj_t) (arg2015_1532);
					arg2014_1531 =
					   MAKE_PAIR(aux_3641, res_1523);
				     }
				  }
				  {
				     obj_t res_3645;
				     obj_t args_3644;
				     args_3644 = arg2013_1530;
				     res_3645 = arg2014_1531;
				     res_1523 = res_3645;
				     args_1522 = args_3644;
				     goto loop_1524;
				  }
			       }
			    }
			 }
		      }
		    else
		      {		/* Ast/unit.scm 418 */
			 {	/* Ast/unit.scm 419 */
			    obj_t pid_1535;
			    {	/* Ast/unit.scm 419 */
			       obj_t arg2020_1540;
			       arg2020_1540 =
				  parse_id_241_ast_ident(args_1522, loc_1487);
			       pid_1535 =
				  check_id_6_ast_ident(arg2020_1540, src_54);
			    }
			    {	/* Ast/unit.scm 421 */

			       {	/* Ast/unit.scm 425 */
				  obj_t arg2018_1538;
				  {	/* Ast/unit.scm 425 */
				     local_bglt arg2019_1539;
				     {	/* Ast/unit.scm 425 */
					type_bglt aux_3648;
					{	/* Ast/unit.scm 425 */
					   obj_t aux_3650;
					   aux_3650 =
					      CDR(pid_1535);
					   aux_3648 =
					      (type_bglt) (aux_3650);
					}
					arg2019_1539 =
					   make_user_local_svar_134_ast_local(
					   CAR(pid_1535), aux_3648);
				     }
				     {	/* ./Ieee/pair-list.scm 5689 */
					obj_t aux_3654;
					aux_3654 =
					   (obj_t) (arg2019_1539);
					arg2018_1538 =
					   MAKE_PAIR(aux_3654, res_1523);
				     }
				  }
				  locals_1488 =
				     reverse__39___r4_pairs_and_lists_6_3(arg2018_1538);
			       }
			    }
			 }
		      }
		 }
	    }
	    {	/* Ast/unit.scm 413 */
	       obj_t pid_1489;
	       {	/* Ast/unit.scm 434 */
		  obj_t arg2010_1521;
		  arg2010_1521 =
		     parse_id_241_ast_ident(id_50, loc_1487);
		  pid_1489 =
		     check_id_6_ast_ident(arg2010_1521, src_54);
	       }
	       {	/* Ast/unit.scm 434 */
		  obj_t name_1490;
		  name_1490 =
		     CAR(pid_1489);
		  {	/* Ast/unit.scm 435 */
		     obj_t type_1491;
		     type_1491 =
			CDR(pid_1489);
		     {	/* Ast/unit.scm 436 */
			obj_t dname_1492;
			{	/* Ast/unit.scm 437 */
			   obj_t arg2007_1518;
			   {	/* Ast/unit.scm 437 */
			      obj_t list2008_1519;
			      {		/* Ast/unit.scm 437 */
				 obj_t arg2009_1520;
				 {	/* Ast/unit.scm 437 */
				    obj_t aux_3662;
				    aux_3662 =
				       CNST_TABLE_REF(((long) 21));
				    arg2009_1520 =
				       MAKE_PAIR(aux_3662, BNIL);
				 }
				 list2008_1519 =
				    MAKE_PAIR(name_1490, arg2009_1520);
			      }
			      arg2007_1518 =
				 symbol_append_197___r4_symbols_6_4(list2008_1519);
			   }
			   dname_1492 =
			      PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4, arg2007_1518, BEOA);
			}
			{	/* Ast/unit.scm 437 */
			   obj_t default_1493;
			   {	/* Ast/unit.scm 438 */
			      bool_t test2006_1517;
			      {		/* Ast/unit.scm 438 */
				 obj_t obj2_2697;
				 obj2_2697 = _module__166_module_module;
				 test2006_1517 =
				    (module_51 == obj2_2697);
			      }
			      if (test2006_1517)
				{	/* Ast/unit.scm 438 */
				   default_1493 =
				      make_sgfun_default_250_ast_unit(dname_1492, type_1491, args_52, body_53, src_54, gdefs_55);
				}
			      else
				{	/* Ast/unit.scm 438 */
				   default_1493 = BNIL;
				}
			   }
			   {	/* Ast/unit.scm 438 */
			      obj_t body_1494;
			      body_1494 =
				 make_generic_body_233_object_generic(id_50, locals_1488, args_52, src_54);
			      {		/* Ast/unit.scm 441 */
				 global_bglt generic_1495;
				 generic_1495 =
				    def_global_sfun__93_ast_glo_def_117(id_50, args_52, locals_1488, module_51,
				    CNST_TABLE_REF(((long) 22)), src_54,
				    CNST_TABLE_REF(((long) 18)), body_1494);
				 {	/* Ast/unit.scm 442 */

				    add_generic_for_method_inlining__147_object_inline(
				       (obj_t) (generic_1495));
				    {	/* Ast/unit.scm 459 */
				       obj_t o_unit_142_1496;
				       obj_t sexp__30_1497;
				       o_unit_142_1496 =
					  get_method_unit_151_module_class();
				       {	/* Ast/unit.scm 461 */
					  obj_t arg1989_1500;
					  {	/* Ast/unit.scm 461 */
					     obj_t arg1990_1501;
					     {	/* Ast/unit.scm 461 */
						obj_t arg1991_1502;
						{	/* Ast/unit.scm 461 */
						   obj_t arg1993_1504;
						   obj_t arg1994_1505;
						   arg1993_1504 =
						      CNST_TABLE_REF(((long) 23));
						   {	/* Ast/unit.scm 461 */
						      obj_t arg1995_1506;
						      obj_t arg1996_1507;
						      {		/* Ast/unit.scm 461 */
							 obj_t arg1997_1508;
							 obj_t arg1998_1509;
							 arg1997_1508 =
							    CNST_TABLE_REF(((long) 6));
							 {	/* Ast/unit.scm 461 */
							    obj_t arg1999_1510;
							    obj_t arg2000_1511;
							    arg1999_1510 =
							       (((global_bglt) CREF(generic_1495))->id);
							    arg2000_1511 =
							       MAKE_PAIR(module_51, BNIL);
							    arg1998_1509 =
							       MAKE_PAIR(arg1999_1510, arg2000_1511);
							 }
							 arg1995_1506 =
							    MAKE_PAIR(arg1997_1508, arg1998_1509);
						      }
						      {		/* Ast/unit.scm 463 */
							 obj_t arg2001_1512;
							 {	/* Ast/unit.scm 463 */
							    obj_t arg2003_1514;
							    obj_t arg2004_1515;
							    arg2003_1514 =
							       CNST_TABLE_REF(((long) 6));
							    {	/* Ast/unit.scm 463 */
							       obj_t arg2005_1516;
							       {	/* Ast/unit.scm 463 */
								  obj_t obj1_2705;
								  obj1_2705 = _module__166_module_module;
								  arg2005_1516 =
								     MAKE_PAIR(obj1_2705, BNIL);
							       }
							       arg2004_1515 =
								  MAKE_PAIR(dname_1492, arg2005_1516);
							    }
							    arg2001_1512 =
							       MAKE_PAIR(arg2003_1514, arg2004_1515);
							 }
							 arg1996_1507 =
							    MAKE_PAIR(arg2001_1512, BNIL);
						      }
						      arg1994_1505 =
							 MAKE_PAIR(arg1995_1506, arg1996_1507);
						   }
						   arg1991_1502 =
						      MAKE_PAIR(arg1993_1504, arg1994_1505);
						}
						{	/* Ast/unit.scm 461 */
						   obj_t list1992_1503;
						   list1992_1503 =
						      MAKE_PAIR(arg1991_1502, BNIL);
						   arg1990_1501 = list1992_1503;
						}
					     }
					     arg1989_1500 =
						append_2_18___r4_pairs_and_lists_6_3(arg1990_1501, default_1493);
					  }
					  {	/* ./Ieee/pair-list.scm 5689 */
					     obj_t aux_3694;
					     aux_3694 =
						(obj_t) (generic_1495);
					     sexp__30_1497 =
						MAKE_PAIR(aux_3694, arg1989_1500);
					  }
				       }
				       {	/* Ast/unit.scm 465 */
					  bool_t test_3697;
					  if (
					     STRUCTP(o_unit_142_1496))
					    {	/* ./Ieee/equiv.scm 5508 */
					       obj_t aux_3702;
					       obj_t aux_3700;
					       aux_3702 =
						  CNST_TABLE_REF(((long) 24));
					       aux_3700 =
						  STRUCT_KEY(o_unit_142_1496);
					       test_3697 =
						  (aux_3700 == aux_3702);
					    }
					  else
					    {	/* ./Ast/unit.sch 750 */
					       test_3697 = ((bool_t) 0)
						  ;
					    }
					  if (test_3697)
					    {	/* Ast/unit.scm 465 */
					       unit_sexp__add__71_ast_unit(o_unit_142_1496, sexp__30_1497);
					       {	/* Ast/unit.scm 469 */
						  obj_t list1988_1499;
						  list1988_1499 =
						     MAKE_PAIR(BUNSPEC, BNIL);
						  return list1988_1499;
					       }
					    }
					  else
					    {	/* Ast/unit.scm 465 */
					       return sexp__30_1497;
					    }
				       }
				    }
				 }
			      }
			   }
			}
		     }
		  }
	       }
	    }
	 }
      }
   }
}



/* make-method-definition */
obj_t 
make_method_definition_178_ast_unit(obj_t id_56, obj_t args_57, obj_t body_58, obj_t src_59)
{
   AN_OBJECT;
   {	/* Ast/unit.scm 474 */
      {		/* Ast/unit.scm 475 */
	 obj_t loc_1541;
	 loc_1541 =
	    find_location_120_tools_location(src_59);
	 {	/* Ast/unit.scm 475 */
	    obj_t locals_1542;
	    {
	       obj_t args_1549;
	       obj_t res_1550;
	       args_1549 = args_57;
	       res_1550 = BNIL;
	     loop_1551:
	       if (
		  NULLP(args_1549))
		 {	/* Ast/unit.scm 479 */
		    locals_1542 =
		       reverse__39___r4_pairs_and_lists_6_3(res_1550);
		 }
	       else
		 {	/* Ast/unit.scm 479 */
		    if (
		       PAIRP(args_1549))
		      {		/* Ast/unit.scm 481 */
			 {	/* Ast/unit.scm 490 */
			    obj_t pid_1554;
			    {	/* Ast/unit.scm 490 */
			       obj_t arg2030_1560;
			       arg2030_1560 =
				  parse_id_241_ast_ident(
				  CAR(args_1549), loc_1541);
			       pid_1554 =
				  check_id_6_ast_ident(arg2030_1560, src_59);
			    }
			    {	/* Ast/unit.scm 492 */

			       {	/* Ast/unit.scm 493 */
				  obj_t arg2027_1557;
				  obj_t arg2028_1558;
				  arg2027_1557 =
				     CDR(args_1549);
				  {	/* Ast/unit.scm 494 */
				     local_bglt arg2029_1559;
				     {	/* Ast/unit.scm 494 */
					type_bglt aux_3717;
					{	/* Ast/unit.scm 494 */
					   obj_t aux_3719;
					   aux_3719 =
					      CDR(pid_1554);
					   aux_3717 =
					      (type_bglt) (aux_3719);
					}
					arg2029_1559 =
					   make_local_svar_140_ast_local(
					   CAR(pid_1554), aux_3717);
				     }
				     {	/* ./Ieee/pair-list.scm 5689 */
					obj_t aux_3723;
					aux_3723 =
					   (obj_t) (arg2029_1559);
					arg2028_1558 =
					   MAKE_PAIR(aux_3723, res_1550);
				     }
				  }
				  {
				     obj_t res_3727;
				     obj_t args_3726;
				     args_3726 = arg2027_1557;
				     res_3727 = arg2028_1558;
				     res_1550 = res_3727;
				     args_1549 = args_3726;
				     goto loop_1551;
				  }
			       }
			    }
			 }
		      }
		    else
		      {		/* Ast/unit.scm 481 */
			 {	/* Ast/unit.scm 482 */
			    obj_t pid_1562;
			    {	/* Ast/unit.scm 482 */
			       obj_t arg2034_1567;
			       arg2034_1567 =
				  parse_id_241_ast_ident(args_1549, loc_1541);
			       pid_1562 =
				  check_id_6_ast_ident(arg2034_1567, src_59);
			    }
			    {	/* Ast/unit.scm 484 */

			       {	/* Ast/unit.scm 488 */
				  obj_t arg2032_1565;
				  {	/* Ast/unit.scm 488 */
				     local_bglt arg2033_1566;
				     {	/* Ast/unit.scm 488 */
					type_bglt aux_3730;
					{	/* Ast/unit.scm 488 */
					   obj_t aux_3732;
					   aux_3732 =
					      CDR(pid_1562);
					   aux_3730 =
					      (type_bglt) (aux_3732);
					}
					arg2033_1566 =
					   make_local_svar_140_ast_local(
					   CAR(pid_1562), aux_3730);
				     }
				     {	/* ./Ieee/pair-list.scm 5689 */
					obj_t aux_3736;
					aux_3736 =
					   (obj_t) (arg2033_1566);
					arg2032_1565 =
					   MAKE_PAIR(aux_3736, res_1550);
				     }
				  }
				  locals_1542 =
				     reverse__39___r4_pairs_and_lists_6_3(arg2032_1565);
			       }
			    }
			 }
		      }
		 }
	    }
	    {	/* Ast/unit.scm 476 */

	       {	/* Ast/unit.scm 495 */
		  bool_t test2021_1543;
		  test2021_1543 =
		     check_method_definition_71_ast_glo_def_117(id_56, args_57, locals_1542, src_59);
		  if (test2021_1543)
		    {	/* Ast/unit.scm 497 */
		       obj_t o_unit_142_1544;
		       obj_t sexp__30_1545;
		       o_unit_142_1544 =
			  get_method_unit_151_module_class();
		       sexp__30_1545 =
			  make_method_body_103_object_method(id_56, args_57, locals_1542, body_58, src_59);
		       {	/* Ast/unit.scm 499 */
			  bool_t test_3744;
			  if (
			     STRUCTP(o_unit_142_1544))
			    {	/* ./Ieee/equiv.scm 5508 */
			       obj_t aux_3749;
			       obj_t aux_3747;
			       aux_3749 =
				  CNST_TABLE_REF(((long) 24));
			       aux_3747 =
				  STRUCT_KEY(o_unit_142_1544);
			       test_3744 =
				  (aux_3747 == aux_3749);
			    }
			  else
			    {	/* ./Ast/unit.sch 750 */
			       test_3744 = ((bool_t) 0)
				  ;
			    }
			  if (test_3744)
			    {	/* Ast/unit.scm 499 */
			       unit_sexp__add__71_ast_unit(o_unit_142_1544, sexp__30_1545);
			       {	/* Ast/unit.scm 503 */
				  obj_t list2023_1547;
				  list2023_1547 =
				     MAKE_PAIR(BUNSPEC, BNIL);
				  return list2023_1547;
			       }
			    }
			  else
			    {	/* Ast/unit.scm 499 */
			       return sexp__30_1545;
			    }
		       }
		    }
		  else
		    {	/* Ast/unit.scm 496 */
		       obj_t list2024_1548;
		       list2024_1548 =
			  MAKE_PAIR(BUNSPEC, BNIL);
		       return list2024_1548;
		    }
	       }
	    }
	 }
      }
   }
}



/* method-init */
obj_t 
method_init_76_ast_unit()
{
   AN_OBJECT;
   {	/* Ast/unit.scm 21 */
      return BUNSPEC;
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_ast_unit()
{
   AN_OBJECT;
   {	/* Ast/unit.scm 21 */
      module_initialization_70_type_type(((long) 0), "AST_UNIT");
      module_initialization_70_ast_var(((long) 0), "AST_UNIT");
      module_initialization_70_ast_node(((long) 0), "AST_UNIT");
      module_initialization_70_tools_trace(((long) 0), "AST_UNIT");
      module_initialization_70_ast_find_gdefs_13(((long) 0), "AST_UNIT");
      module_initialization_70_ast_glo_def_117(((long) 0), "AST_UNIT");
      module_initialization_70_ast_ident(((long) 0), "AST_UNIT");
      module_initialization_70_ast_env(((long) 0), "AST_UNIT");
      module_initialization_70_ast_local(((long) 0), "AST_UNIT");
      module_initialization_70_ast_sexp(((long) 0), "AST_UNIT");
      module_initialization_70_object_generic(((long) 0), "AST_UNIT");
      module_initialization_70_object_method(((long) 0), "AST_UNIT");
      module_initialization_70_object_inline(((long) 0), "AST_UNIT");
      module_initialization_70_tools_progn(((long) 0), "AST_UNIT");
      module_initialization_70_tools_args(((long) 0), "AST_UNIT");
      module_initialization_70_tools_misc(((long) 0), "AST_UNIT");
      module_initialization_70_tools_speek(((long) 0), "AST_UNIT");
      module_initialization_70_tools_shape(((long) 0), "AST_UNIT");
      module_initialization_70_tools_location(((long) 0), "AST_UNIT");
      module_initialization_70_tools_error(((long) 0), "AST_UNIT");
      module_initialization_70_tools_dsssl(((long) 0), "AST_UNIT");
      module_initialization_70_engine_param(((long) 0), "AST_UNIT");
      module_initialization_70_module_module(((long) 0), "AST_UNIT");
      module_initialization_70_module_class(((long) 0), "AST_UNIT");
      module_initialization_70_module_include(((long) 0), "AST_UNIT");
      return
	 module_initialization_70_type_cache(((long) 0), "AST_UNIT");
   }
}
