/*===========================================================================*/
/*   (Ast/venv.scm)                                                          */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;


extern obj_t find_global_223_ast_env(obj_t, obj_t);
static obj_t method_init_76_ast_env();
extern obj_t find_global_module_25_ast_env(obj_t, obj_t);
extern obj_t for_each_hash_105___hash(obj_t, obj_t);
static obj_t restore_value_types__default1445_109_ast_env(value_bglt);
extern long add_inlined_method__244___object(obj_t, obj_t, long);
static obj_t _unbind_global__69_ast_env(obj_t, obj_t, obj_t);
extern obj_t hrtype_node__16_ast_hrtype(node_bglt);
extern global_bglt bind_global__138_ast_env(obj_t, obj_t, value_bglt, obj_t, obj_t);
static obj_t _set_genv__185_ast_env(obj_t, obj_t);
extern obj_t type_type_type;
extern obj_t user_warning_209_tools_error(obj_t, obj_t, obj_t);
static obj_t _initialize_genv__83_ast_env(obj_t);
extern obj_t global_ast_var;
extern obj_t user_error_151_tools_error(obj_t, obj_t, obj_t, obj_t);
extern obj_t notify_assert_fail_37___eval(obj_t, obj_t, obj_t);
extern obj_t get_hash_29___hash(obj_t, obj_t);
static obj_t _anonymous_1542__160_ast_env(obj_t, obj_t);
extern obj_t global_bucket_position_189_ast_env(obj_t, obj_t);
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t module_initialization_70_ast_env(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_type_env(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_ast_hrtype(long, char *);
extern obj_t module_initialization_70_module_module(long, char *);
extern obj_t module_initialization_70___error(long, char *);
extern obj_t module_initialization_70___hash(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___eval(long, char *);
extern obj_t module_initialization_70___evenv(long, char *);
extern obj_t module_initialization_70___r4_equivalence_6_2(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t unbind_global__45_ast_env(obj_t, obj_t);
static obj_t _get_genv_78_ast_env(obj_t);
extern obj_t _warning__61___error;
extern obj_t initialize_genv__97_ast_env();
extern long get_hash_power_number(char *, long);
extern obj_t make_hash_table_174___hash(long, obj_t, obj_t, obj_t, obj_t);
extern obj_t get_genv_41_ast_env();
extern long class_num_218___object(obj_t);
static obj_t _bind_global__219_ast_env(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t define_primop_ref__105___evenv(obj_t, obj_t);
extern obj_t node_ast_node;
static obj_t _anonymous_1453__247_ast_env(obj_t, obj_t);
extern type_bglt find_type_26_type_env(obj_t);
static obj_t imported_modules_init_94_ast_env();
extern obj_t unbind_primop__163___evenv(obj_t);
extern obj_t cfun_ast_var;
extern obj_t add_generic__110___object(obj_t, obj_t);
static obj_t library_modules_init_112_ast_env();
extern obj_t add_genv__67_ast_env(obj_t);
static obj_t _find_global_module_138_ast_env(obj_t, obj_t, obj_t);
static obj_t toplevel_init_63_ast_env();
static obj_t _restore_value_types__78_ast_env(obj_t, obj_t);
extern obj_t open_input_string(obj_t);
static obj_t _for_each_global__131_ast_env(obj_t, obj_t);
extern obj_t sfun_ast_var;
extern obj_t put_hash__129___hash(obj_t, obj_t);
static long get_hash_number_100_ast_env(obj_t);
extern obj_t local_ast_var;
extern obj_t set_genv__34_ast_env(obj_t);
extern obj_t for_each_global__88_ast_env(obj_t);
static obj_t _global_bucket_position_151_ast_env(obj_t, obj_t, obj_t);
extern obj_t shape_tools_shape(obj_t);
static obj_t _genv__8_ast_env = BUNSPEC;
extern obj_t _module__166_module_module;
static obj_t _restore_value_types__default1445_112_ast_env(obj_t, obj_t);
static obj_t restore_value_types__114_ast_env(value_bglt);
extern obj_t _classes__134___object;
static obj_t _get_hash_number_209_ast_env(obj_t, obj_t);
extern obj_t read___reader(obj_t);
static obj_t _add_genv__137_ast_env(obj_t, obj_t);
static obj_t _find_global_16_ast_env(obj_t, obj_t, obj_t);
extern obj_t _lib_mode__85_engine_param;
extern obj_t ____74_type_cache;
static obj_t require_initialization_114_ast_env = BUNSPEC;
static obj_t cnst_init_137_ast_env();
static obj_t __cnst[12];

extern obj_t car_env_2___r4_pairs_and_lists_6_3;
DEFINE_STATIC_PROCEDURE(get_hash_number_env_189_ast_env, _get_hash_number_209_ast_env1693, _get_hash_number_209_ast_env, 0L, 1);
DEFINE_EXPORT_PROCEDURE(global_bucket_position_env_214_ast_env, _global_bucket_position_151_ast_env1694, _global_bucket_position_151_ast_env, 0L, 2);
DEFINE_EXPORT_PROCEDURE(find_global_env_126_ast_env, _find_global_16_ast_env1695, va_generic_entry, _find_global_16_ast_env, -2);
extern obj_t eq__env_189___r4_equivalence_6_2;
DEFINE_STATIC_PROCEDURE(proc1679_ast_env, _anonymous_1453__247_ast_env1696, _anonymous_1453__247_ast_env, 0L, 1);
DEFINE_EXPORT_PROCEDURE(unbind_global__env_125_ast_env, _unbind_global__69_ast_env1697, _unbind_global__69_ast_env, 0L, 2);
DEFINE_EXPORT_PROCEDURE(for_each_global__env_168_ast_env, _for_each_global__131_ast_env1698, _for_each_global__131_ast_env, 0L, 1);
DEFINE_STATIC_GENERIC(restore_value_types__env_16_ast_env, _restore_value_types__78_ast_env1699, _restore_value_types__78_ast_env, 0L, 1);
DEFINE_EXPORT_PROCEDURE(initialize_genv__env_247_ast_env, _initialize_genv__83_ast_env1700, _initialize_genv__83_ast_env, 0L, 0);
DEFINE_EXPORT_PROCEDURE(bind_global__env_67_ast_env, _bind_global__219_ast_env1701, _bind_global__219_ast_env, 0L, 5);
DEFINE_STATIC_PROCEDURE(restore_value_types__default1445_env_45_ast_env, _restore_value_types__default1445_112_ast_env1702, _restore_value_types__default1445_112_ast_env, 0L, 1);
DEFINE_EXPORT_PROCEDURE(set_genv__env_70_ast_env, _set_genv__185_ast_env1703, _set_genv__185_ast_env, 0L, 1);
DEFINE_EXPORT_PROCEDURE(add_genv__env_109_ast_env, _add_genv__137_ast_env1704, _add_genv__137_ast_env, 0L, 1);
DEFINE_EXPORT_PROCEDURE(find_global_module_env_47_ast_env, _find_global_module_138_ast_env1705, _find_global_module_138_ast_env, 0L, 2);
DEFINE_EXPORT_PROCEDURE(get_genv_env_66_ast_env, _get_genv_78_ast_env1706, _get_genv_78_ast_env, 0L, 0);
DEFINE_STRING(string1688_ast_env, string1688_ast_env1707, "@ NOW READ FOREIGN (\"/home/tahoe2/serrano/tmp/bigloo/comptime/Ast/venv.scm\" . 6512) (BEGIN (OR (NULL? MODULE) (SYMBOL? (CAR MODULE)))) (MODULE) MODULE EQ? CAR GET-HASH-NUMBER THE-GLOBAL-ENVIRONMENT ", 198);
DEFINE_STRING(string1687_ast_env, string1687_ast_env1708, "Illegal non pair argument", 25);
DEFINE_STRING(string1686_ast_env, string1686_ast_env1709, "restore-value-types", 19);
DEFINE_STRING(string1685_ast_env, string1685_ast_env1710, "Illegal argument", 16);
DEFINE_STRING(string1684_ast_env, string1684_ast_env1711, "restore-value-types(sfun)", 25);
DEFINE_STRING(string1683_ast_env, string1683_ast_env1712, "Can't find global", 17);
DEFINE_STRING(string1682_ast_env, string1682_ast_env1713, "unbind-global!", 14);
DEFINE_STRING(string1681_ast_env, string1681_ast_env1714, "Illegal global redefinition", 27);
DEFINE_STRING(string1680_ast_env, string1680_ast_env1715, "Scheme declaration overrides foreign declaration", 48);



/* module-initialization */
obj_t 
module_initialization_70_ast_env(long checksum_1542, char *from_1543)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_ast_env))
	{
	   require_initialization_114_ast_env =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_ast_env();
	   cnst_init_137_ast_env();
	   imported_modules_init_94_ast_env();
	   method_init_76_ast_env();
	   toplevel_init_63_ast_env();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_ast_env()
{
   AN_OBJECT;
   {	/* Ast/venv.scm 14 */
      module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "AST_ENV");
      module_initialization_70___hash(((long) 0), "AST_ENV");
      module_initialization_70___object(((long) 0), "AST_ENV");
      module_initialization_70___eval(((long) 0), "AST_ENV");
      module_initialization_70___error(((long) 0), "AST_ENV");
      module_initialization_70___r4_equivalence_6_2(((long) 0), "AST_ENV");
      module_initialization_70___evenv(((long) 0), "AST_ENV");
      module_initialization_70___reader(((long) 0), "AST_ENV");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_ast_env()
{
   AN_OBJECT;
   {	/* Ast/venv.scm 14 */
      {		/* Ast/venv.scm 14 */
	 obj_t cnst_port_138_1535;
	 cnst_port_138_1535 =
	    open_input_string(string1688_ast_env);
	 {
	    long i_1536;
	    i_1536 = ((long) 11);
	  loop_1537:
	    {	/* Ast/venv.scm 14 */
	       bool_t test1689_1538;
	       test1689_1538 =
		  (i_1536 == ((long) -1));
	       if (test1689_1538)
		 {	/* Ast/venv.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Ast/venv.scm 14 */
		    {	/* Ast/venv.scm 14 */
		       obj_t arg1690_1539;
		       {	/* Ast/venv.scm 14 */
			  obj_t list1691_1540;
			  list1691_1540 =
			     MAKE_PAIR(cnst_port_138_1535, BNIL);
			  arg1690_1539 =
			     read___reader(list1691_1540);
		       }
		       CNST_TABLE_SET(i_1536, arg1690_1539);
		    }
		    {	/* Ast/venv.scm 14 */
		       int aux_1541;
		       {	/* Ast/venv.scm 14 */
			  long aux_1566;
			  aux_1566 =
			     (i_1536 - ((long) 1));
			  aux_1541 =
			     (int) (aux_1566);
		       }
		       {
			  long i_1569;
			  i_1569 =
			     (long) (aux_1541);
			  i_1536 = i_1569;
			  goto loop_1537;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_ast_env()
{
   AN_OBJECT;
   {	/* Ast/venv.scm 14 */
      _genv__8_ast_env =
	 CNST_TABLE_REF(((long) 0));
      return BUNSPEC;
   }
}



/* get-hash-number */
long 
get_hash_number_100_ast_env(obj_t o_1)
{
   AN_OBJECT;
   {	/* Ast/venv.scm 46 */
      {		/* Ast/venv.scm 47 */
	 obj_t arg1450_1233;
	 arg1450_1233 =
	    SYMBOL_TO_STRING(o_1);
	 {	/* ./Llib/hash.scm 1789 */
	    char *aux_1573;
	    aux_1573 =
	       BSTRING_TO_STRING(arg1450_1233);
	    return
	       get_hash_power_number(aux_1573, ((long) 12));
	 }
      }
   }
}



/* _get-hash-number */
obj_t 
_get_hash_number_209_ast_env(obj_t env_1491, obj_t o_1492)
{
   AN_OBJECT;
   {	/* Ast/venv.scm 46 */
      {		/* Ast/venv.scm 46 */
	 long aux_1576;
	 aux_1576 =
	    get_hash_number_100_ast_env(o_1492);
	 return
	    BINT(aux_1576);
      }
   }
}



/* set-genv! */
obj_t 
set_genv__34_ast_env(obj_t genv_2)
{
   AN_OBJECT;
   {	/* Ast/venv.scm 52 */
      _genv__8_ast_env = genv_2;
      {		/* Ast/venv.scm 54 */
	 obj_t s_1238;
	 s_1238 = _genv__8_ast_env;
	 STRUCT_SET(s_1238, ((long) 2), get_hash_number_env_189_ast_env);
      }
      {		/* Ast/venv.scm 55 */
	 obj_t s_1240;
	 s_1240 = _genv__8_ast_env;
	 STRUCT_SET(s_1240, ((long) 3), car_env_2___r4_pairs_and_lists_6_3);
      }
      {		/* Ast/venv.scm 56 */
	 obj_t s_1242;
	 s_1242 = _genv__8_ast_env;
	 return
	    STRUCT_SET(s_1242, ((long) 5), eq__env_189___r4_equivalence_6_2);
      }
   }
}



/* _set-genv! */
obj_t 
_set_genv__185_ast_env(obj_t env_1493, obj_t genv_1494)
{
   AN_OBJECT;
   {	/* Ast/venv.scm 52 */
      return
	 set_genv__34_ast_env(genv_1494);
   }
}



/* add-genv! */
obj_t 
add_genv__67_ast_env(obj_t genv_3)
{
   AN_OBJECT;
   {	/* Ast/venv.scm 64 */
      {		/* Ast/venv.scm 67 */
	 obj_t _anonymous_1453__247_1500;
	 _anonymous_1453__247_1500 = proc1679_ast_env;
	 return
	    for_each_hash_105___hash(_anonymous_1453__247_1500, genv_3);
      }
   }
}



/* _add-genv! */
obj_t 
_add_genv__137_ast_env(obj_t env_1501, obj_t genv_1502)
{
   AN_OBJECT;
   {	/* Ast/venv.scm 64 */
      return
	 add_genv__67_ast_env(genv_1502);
   }
}



/* <anonymous:1453> */
obj_t 
_anonymous_1453__247_ast_env(obj_t env_1503, obj_t bucket_1504)
{
   AN_OBJECT;
   {	/* Ast/venv.scm 66 */
      {
	 obj_t bucket_720;
	 {	/* Ast/venv.scm 67 */
	    bool_t aux_1585;
	    bucket_720 = bucket_1504;
	    {
	       obj_t l1437_722;
	       l1437_722 =
		  CDR(bucket_720);
	     lname1438_723:
	       if (
		  PAIRP(l1437_722))
		 {	/* Ast/venv.scm 67 */
		    {	/* Ast/venv.scm 68 */
		       obj_t new_726;
		       new_726 =
			  CAR(l1437_722);
		       {	/* Ast/venv.scm 68 */
			  obj_t id_727;
			  {	/* Ast/venv.scm 68 */
			     global_bglt obj_1247;
			     obj_1247 =
				(global_bglt) (new_726);
			     id_727 =
				(((global_bglt) CREF(obj_1247))->id);
			  }
			  {	/* Ast/venv.scm 68 */
			     obj_t module_728;
			     {	/* Ast/venv.scm 69 */
				global_bglt obj_1248;
				obj_1248 =
				   (global_bglt) (new_726);
				module_728 =
				   (((global_bglt) CREF(obj_1248))->module);
			     }
			     {	/* Ast/venv.scm 69 */
				type_bglt type_729;
				{	/* Ast/venv.scm 70 */
				   global_bglt obj_1249;
				   obj_1249 =
				      (global_bglt) (new_726);
				   type_729 =
				      (((global_bglt) CREF(obj_1249))->type);
				}
				{	/* Ast/venv.scm 70 */
				   value_bglt value_730;
				   {	/* Ast/venv.scm 71 */
				      global_bglt obj_1250;
				      obj_1250 =
					 (global_bglt) (new_726);
				      value_730 =
					 (((global_bglt) CREF(obj_1250))->value);
				   }
				   {	/* Ast/venv.scm 71 */
				      obj_t bucket_731;
				      bucket_731 =
					 get_hash_29___hash(id_727, _genv__8_ast_env);
				      {		/* Ast/venv.scm 72 */
					 obj_t type_id_229_732;
					 type_id_229_732 =
					    (((type_bglt) CREF(type_729))->id);
					 {	/* Ast/venv.scm 73 */

					    {	/* Ast/venv.scm 74 */
					       global_bglt obj_1252;
					       obj_1252 =
						  (global_bglt) (new_726);
					       ((((global_bglt) CREF(obj_1252))->library__255) = ((bool_t) ((bool_t) 1)), BUNSPEC);
					    }
					    {	/* Ast/venv.scm 76 */
					       type_bglt arg1456_733;
					       arg1456_733 =
						  find_type_26_type_env(type_id_229_732);
					       {	/* Ast/venv.scm 76 */
						  global_bglt obj_1254;
						  obj_1254 =
						     (global_bglt) (new_726);
						  ((((global_bglt) CREF(obj_1254))->type) = ((type_bglt) arg1456_733), BUNSPEC);
					       }
					    }
					    restore_value_types__114_ast_env(value_730);
					    if (
					       PAIRP(bucket_731))
					      {		/* Ast/venv.scm 82 */
						 bool_t test1458_735;
						 {	/* Ast/venv.scm 82 */
						    obj_t obj2_1258;
						    obj2_1258 = _module__166_module_module;
						    test1458_735 =
						       (module_728 == obj2_1258);
						 }
						 if (test1458_735)
						   {	/* Ast/venv.scm 82 */
						      {		/* Ast/venv.scm 83 */
							 obj_t new_bucket_15_736;
							 {	/* ./Ieee/pair-list.scm 5689 */
							    obj_t aux_1609;
							    aux_1609 =
							       CDR(bucket_731);
							    new_bucket_15_736 =
							       MAKE_PAIR(new_726, aux_1609);
							 }
							 SET_CDR(bucket_731, new_bucket_15_736);
						      }
						   }
						 else
						   {	/* Ast/venv.scm 82 */
						      {		/* Ast/venv.scm 86 */
							 obj_t arg1461_738;
							 obj_t arg1462_739;
							 arg1461_738 =
							    CDR(bucket_731);
							 {	/* ./Ieee/pair-list.scm 5689 */
							    obj_t aux_1614;
							    {	/* ./Ieee/pair-list.scm 5707 */
							       obj_t aux_1615;
							       aux_1615 =
								  CDR(bucket_731);
							       aux_1614 =
								  CDR(aux_1615);
							    }
							    arg1462_739 =
							       MAKE_PAIR(new_726, aux_1614);
							 }
							 SET_CDR(arg1461_738, arg1462_739);
						      }
						   }
					      }
					    else
					      {		/* Ast/venv.scm 80 */
						 {	/* Ast/venv.scm 81 */
						    obj_t arg1464_741;
						    {	/* Ast/venv.scm 81 */
						       obj_t list1465_742;
						       {	/* Ast/venv.scm 81 */
							  obj_t arg1466_743;
							  arg1466_743 =
							     MAKE_PAIR(new_726, BNIL);
							  list1465_742 =
							     MAKE_PAIR(id_727, arg1466_743);
						       }
						       arg1464_741 = list1465_742;
						    }
						    put_hash__129___hash(arg1464_741, _genv__8_ast_env);
						 }
					      }
					 }
				      }
				   }
				}
			     }
			  }
		       }
		    }
		    {
		       obj_t l1437_1623;
		       l1437_1623 =
			  CDR(l1437_722);
		       l1437_722 = l1437_1623;
		       goto lname1438_723;
		    }
		 }
	       else
		 {	/* Ast/venv.scm 67 */
		    aux_1585 = ((bool_t) 1);
		 }
	    }
	    return
	       BBOOL(aux_1585);
	 }
      }
   }
}



/* get-genv */
obj_t 
get_genv_41_ast_env()
{
   AN_OBJECT;
   {	/* Ast/venv.scm 140 */
      {		/* Ast/venv.scm 141 */
	 obj_t s_1275;
	 s_1275 = _genv__8_ast_env;
	 {	/* ./Llib/struct.scm 1463 */
	    obj_t aux_1627;
	    aux_1627 =
	       CNST_TABLE_REF(((long) 1));
	    STRUCT_SET(s_1275, ((long) 2), aux_1627);
	 }
      }
      {		/* Ast/venv.scm 142 */
	 obj_t s_1278;
	 s_1278 = _genv__8_ast_env;
	 {	/* ./Llib/struct.scm 1463 */
	    obj_t aux_1630;
	    aux_1630 =
	       CNST_TABLE_REF(((long) 2));
	    STRUCT_SET(s_1278, ((long) 3), aux_1630);
	 }
      }
      {		/* Ast/venv.scm 143 */
	 obj_t s_1281;
	 s_1281 = _genv__8_ast_env;
	 {	/* ./Llib/struct.scm 1463 */
	    obj_t aux_1633;
	    aux_1633 =
	       CNST_TABLE_REF(((long) 3));
	    STRUCT_SET(s_1281, ((long) 5), aux_1633);
	 }
      }
      return _genv__8_ast_env;
   }
}



/* _get-genv */
obj_t 
_get_genv_78_ast_env(obj_t env_1505)
{
   AN_OBJECT;
   {	/* Ast/venv.scm 140 */
      return
	 get_genv_41_ast_env();
   }
}



/* initialize-genv! */
obj_t 
initialize_genv__97_ast_env()
{
   AN_OBJECT;
   {	/* Ast/venv.scm 149 */
      {		/* Ast/venv.scm 150 */
	 obj_t list1468_746;
	 {	/* Ast/venv.scm 150 */
	    obj_t aux_1637;
	    aux_1637 =
	       BINT(((long) 1024));
	    list1468_746 =
	       MAKE_PAIR(aux_1637, BNIL);
	 }
	 return (
	    _genv__8_ast_env =
	    make_hash_table_174___hash(((long) 4096), get_hash_number_env_189_ast_env, car_env_2___r4_pairs_and_lists_6_3, eq__env_189___r4_equivalence_6_2, list1468_746), BUNSPEC);
      }
   }
}



/* _initialize-genv! */
obj_t 
_initialize_genv__83_ast_env(obj_t env_1506)
{
   AN_OBJECT;
   {	/* Ast/venv.scm 149 */
      return
	 initialize_genv__97_ast_env();
   }
}



/* find-global */
obj_t 
find_global_223_ast_env(obj_t id_8, obj_t module_9)
{
   AN_OBJECT;
   {	/* Ast/venv.scm 155 */
      {		/* Ast/venv.scm 156 */
	 bool_t test_1642;
	 {	/* Ast/venv.scm 156 */
	    bool_t _ortest_1441_750;
	    _ortest_1441_750 =
	       NULLP(module_9);
	    if (_ortest_1441_750)
	      {		/* Ast/venv.scm 156 */
		 test_1642 = _ortest_1441_750
		    ;
	      }
	    else
	      {		/* ./Ieee/symbol.scm 6015 */
		 obj_t aux_1645;
		 aux_1645 =
		    CAR(module_9);
		 test_1642 =
		    SYMBOLP(aux_1645);
	      }
	 }
	 if (test_1642)
	   {	/* Ast/venv.scm 156 */
	      BUNSPEC;
	   }
	 else
	   {	/* Ast/venv.scm 156 */
	      {		/* Ast/venv.scm 156 */
		 obj_t arg1470_748;
		 obj_t arg1471_749;
		 arg1470_748 =
		    CNST_TABLE_REF(((long) 4));
		 arg1471_749 =
		    __EVMEANING_ADDRESS(module_9);
		 define_primop_ref__105___evenv(arg1470_748, arg1471_749);
	      }
	      notify_assert_fail_37___eval(
		 CNST_TABLE_REF(((long) 5)),
		 CNST_TABLE_REF(((long) 6)),
		 CNST_TABLE_REF(((long) 7)));
	      unbind_primop__163___evenv(
		 CNST_TABLE_REF(((long) 4)));
	   }
      }
      {		/* Ast/venv.scm 157 */
	 obj_t bucket_752;
	 obj_t module_753;
	 bucket_752 =
	    get_hash_29___hash(id_8, _genv__8_ast_env);
	 if (
	    NULLP(module_9))
	   {	/* Ast/venv.scm 158 */
	      module_753 = BNIL;
	   }
	 else
	   {	/* Ast/venv.scm 158 */
	      module_753 =
		 CAR(module_9);
	   }
	 if (
	    PAIRP(bucket_752))
	   {	/* Ast/venv.scm 162 */
	      bool_t test_1663;
	      {		/* ./Ieee/pair-list.scm 5912 */
		 obj_t aux_1664;
		 aux_1664 =
		    CDR(bucket_752);
		 test_1663 =
		    NULLP(aux_1664);
	      }
	      if (test_1663)
		{	/* Ast/venv.scm 162 */
		   return BFALSE;
		}
	      else
		{	/* Ast/venv.scm 162 */
		   if (
		      NULLP(module_753))
		     {	/* Ast/venv.scm 164 */
			{	/* ./Ieee/pair-list.scm 5701 */
			   obj_t aux_1669;
			   aux_1669 =
			      CDR(bucket_752);
			   return
			      CAR(aux_1669);
			}
		     }
		   else
		     {	/* Ast/venv.scm 164 */
			{
			   obj_t globals_757;
			   globals_757 =
			      CDR(bucket_752);
			 loop_758:
			   if (
			      NULLP(globals_757))
			     {	/* Ast/venv.scm 169 */
				return BFALSE;
			     }
			   else
			     {	/* Ast/venv.scm 171 */
				bool_t test_1674;
				{	/* ./Ieee/equiv.scm 5508 */
				   obj_t aux_1675;
				   {	/* Ast/venv.scm 171 */
				      global_bglt obj_1300;
				      {		/* Ast/venv.scm 171 */
					 obj_t aux_1676;
					 aux_1676 =
					    CAR(globals_757);
					 obj_1300 =
					    (global_bglt) (aux_1676);
				      }
				      aux_1675 =
					 (((global_bglt) CREF(obj_1300))->module);
				   }
				   test_1674 =
				      (aux_1675 == module_753);
				}
				if (test_1674)
				  {	/* Ast/venv.scm 171 */
				     return
					CAR(globals_757);
				  }
				else
				  {	/* Ast/venv.scm 171 */
				     {
					obj_t globals_1682;
					globals_1682 =
					   CDR(globals_757);
					globals_757 = globals_1682;
					goto loop_758;
				     }
				  }
			     }
			}
		     }
		}
	   }
	 else
	   {	/* Ast/venv.scm 160 */
	      return BFALSE;
	   }
      }
   }
}



/* _find-global */
obj_t 
_find_global_16_ast_env(obj_t env_1507, obj_t id_1508, obj_t module_1509)
{
   AN_OBJECT;
   {	/* Ast/venv.scm 155 */
      return
	 find_global_223_ast_env(id_1508, module_1509);
   }
}



/* find-global/module */
obj_t 
find_global_module_25_ast_env(obj_t id_10, obj_t module_11)
{
   AN_OBJECT;
   {	/* Ast/venv.scm 179 */
      {		/* Ast/venv.scm 180 */
	 obj_t bucket_767;
	 bucket_767 =
	    get_hash_29___hash(id_10, _genv__8_ast_env);
	 if (
	    PAIRP(bucket_767))
	   {	/* Ast/venv.scm 184 */
	      bool_t test_1689;
	      {		/* ./Ieee/pair-list.scm 5912 */
		 obj_t aux_1690;
		 aux_1690 =
		    CDR(bucket_767);
		 test_1689 =
		    NULLP(aux_1690);
	      }
	      if (test_1689)
		{	/* Ast/venv.scm 184 */
		   return BFALSE;
		}
	      else
		{	/* Ast/venv.scm 184 */
		   {
		      obj_t globals_771;
		      globals_771 =
			 CDR(bucket_767);
		    loop_772:
		      if (
			 NULLP(globals_771))
			{	/* Ast/venv.scm 191 */
			   return BFALSE;
			}
		      else
			{	/* Ast/venv.scm 193 */
			   bool_t test_1695;
			   {	/* ./Ieee/equiv.scm 5508 */
			      obj_t aux_1696;
			      {		/* Ast/venv.scm 193 */
				 global_bglt obj_1316;
				 {	/* Ast/venv.scm 193 */
				    obj_t aux_1697;
				    aux_1697 =
				       CAR(globals_771);
				    obj_1316 =
				       (global_bglt) (aux_1697);
				 }
				 aux_1696 =
				    (((global_bglt) CREF(obj_1316))->module);
			      }
			      test_1695 =
				 (aux_1696 == module_11);
			   }
			   if (test_1695)
			     {	/* Ast/venv.scm 193 */
				return
				   CAR(globals_771);
			     }
			   else
			     {	/* Ast/venv.scm 193 */
				{
				   obj_t globals_1703;
				   globals_1703 =
				      CDR(globals_771);
				   globals_771 = globals_1703;
				   goto loop_772;
				}
			     }
			}
		   }
		}
	   }
	 else
	   {	/* Ast/venv.scm 182 */
	      return BFALSE;
	   }
      }
   }
}



/* _find-global/module */
obj_t 
_find_global_module_138_ast_env(obj_t env_1510, obj_t id_1511, obj_t module_1512)
{
   AN_OBJECT;
   {	/* Ast/venv.scm 179 */
      return
	 find_global_module_25_ast_env(id_1511, module_1512);
   }
}



/* bind-global! */
global_bglt 
bind_global__138_ast_env(obj_t id_12, obj_t module_13, value_bglt value_14, obj_t import_15, obj_t src_16)
{
   AN_OBJECT;
   {	/* Ast/venv.scm 212 */
      {		/* Ast/venv.scm 217 */
	 obj_t global_780;
	 {	/* Ast/venv.scm 217 */
	    obj_t list1522_809;
	    list1522_809 =
	       MAKE_PAIR(module_13, BNIL);
	    global_780 =
	       find_global_223_ast_env(id_12, list1522_809);
	 }
	 {	/* Ast/venv.scm 220 */
	    bool_t test_1709;
	    {	/* ./Ieee/equiv.scm 5508 */
	       obj_t aux_1710;
	       aux_1710 =
		  CNST_TABLE_REF(((long) 8));
	       test_1709 =
		  (module_13 == aux_1710);
	    }
	    if (test_1709)
	      {		/* Ast/venv.scm 220 */
		 BUNSPEC;
	      }
	    else
	      {		/* Ast/venv.scm 222 */
		 bool_t test1497_783;
		 test1497_783 =
		    is_a__118___object(
		    find_global_module_25_ast_env(id_12,
		       CNST_TABLE_REF(((long) 8))), global_ast_var);
		 if (test1497_783)
		   {	/* Ast/venv.scm 223 */
		      bool_t test1498_784;
		      {		/* Ast/venv.scm 223 */
			 bool_t test1499_785;
			 {	/* Ast/venv.scm 223 */
			    bool_t res1675_1328;
			    {	/* Ast/venv.scm 223 */
			       obj_t obj_1324;
			       obj_1324 = _warning__61___error;
			       if (
				  INTEGERP(obj_1324))
				 {	/* ./Ieee/number.scm 6283 */
				    res1675_1328 = ((bool_t) 1);
				 }
			       else
				 {	/* ./Ieee/number.scm 6283 */
				    res1675_1328 =
				       REALP(obj_1324);
				 }
			    }
			    test1499_785 = res1675_1328;
			 }
			 if (test1499_785)
			   {	/* Ast/venv.scm 223 */
			      long n1_1329;
			      n1_1329 =
				 (long) CINT(_warning__61___error);
			      test1498_784 =
				 (n1_1329 >= ((long) 2));
			   }
			 else
			   {	/* Ast/venv.scm 223 */
			      test1498_784 = ((bool_t) 0);
			   }
		      }
		      if (test1498_784)
			{	/* Ast/venv.scm 223 */
			   user_warning_209_tools_error(id_12, string1680_ast_env, src_16);
			}
		      else
			{	/* Ast/venv.scm 223 */
			   BUNSPEC;
			}
		   }
		 else
		   {	/* Ast/venv.scm 222 */
		      BUNSPEC;
		   }
	      }
	 }
	 {	/* Ast/venv.scm 228 */
	    bool_t test1500_786;
	    test1500_786 =
	       is_a__118___object(global_780, global_ast_var);
	    if (test1500_786)
	      {		/* Ast/venv.scm 228 */
		 if (
		    CBOOL(_lib_mode__85_engine_param))
		   {	/* Ast/venv.scm 229 */
		      return
			 (global_bglt) (global_780);
		   }
		 else
		   {	/* Ast/venv.scm 230 */
		      obj_t aux_1730;
		      aux_1730 =
			 user_error_151_tools_error(id_12, string1681_ast_env, src_16, BNIL);
		      return
			 (global_bglt) (aux_1730);
		   }
	      }
	    else
	      {		/* Ast/venv.scm 232 */
		 global_bglt new_788;
		 obj_t bucket_789;
		 {	/* Ast/venv.scm 232 */
		    obj_t arg1514_802;
		    obj_t arg1515_803;
		    arg1514_802 =
		       CNST_TABLE_REF(((long) 9));
		    arg1515_803 =
		       CNST_TABLE_REF(((long) 10));
		    {	/* Ast/venv.scm 232 */
		       global_bglt res1676_1366;
		       {	/* Ast/venv.scm 232 */
			  obj_t name_1333;
			  type_bglt type_1334;
			  bool_t library__255_1343;
			  name_1333 = BFALSE;
			  type_1334 =
			     (type_bglt) (____74_type_cache);
			  library__255_1343 =
			     CBOOL(_lib_mode__85_engine_param);
			  {	/* ./Ast/var.scm 1025 */
			     global_bglt new1063_1347;
			     new1063_1347 =
				((global_bglt) BREF(GC_MALLOC(sizeof(struct global))));
			     {	/* ./Ast/var.scm 1025 */
				long arg1624_1348;
				arg1624_1348 =
				   class_num_218___object(global_ast_var);
				{	/* ./Ast/var.scm 1025 */
				   obj_t obj_1364;
				   obj_1364 =
				      (obj_t) (new1063_1347);
				   (((obj_t) CREF(obj_1364))->header = MAKE_HEADER(arg1624_1348, 0), BUNSPEC);
				}
			     }
			     {	/* ./Ast/var.scm 1025 */
				object_bglt aux_1741;
				aux_1741 =
				   (object_bglt) (new1063_1347);
				OBJECT_WIDENING_SET(aux_1741, name_1333);
			     }
			     ((((global_bglt) CREF(new1063_1347))->id) = ((obj_t) id_12), BUNSPEC);
			     ((((global_bglt) CREF(new1063_1347))->name) = ((obj_t) name_1333), BUNSPEC);
			     ((((global_bglt) CREF(new1063_1347))->type) = ((type_bglt) type_1334), BUNSPEC);
			     ((((global_bglt) CREF(new1063_1347))->value) = ((value_bglt) value_14), BUNSPEC);
			     ((((global_bglt) CREF(new1063_1347))->access) = ((obj_t) arg1514_802), BUNSPEC);
			     ((((global_bglt) CREF(new1063_1347))->fast_alpha_7) = ((obj_t) BUNSPEC), BUNSPEC);
			     ((((global_bglt) CREF(new1063_1347))->removable) = ((obj_t) arg1515_803), BUNSPEC);
			     ((((global_bglt) CREF(new1063_1347))->occurrence) = ((long) ((long) 0)), BUNSPEC);
			     ((((global_bglt) CREF(new1063_1347))->module) = ((obj_t) module_13), BUNSPEC);
			     ((((global_bglt) CREF(new1063_1347))->import) = ((obj_t) import_15), BUNSPEC);
			     ((((global_bglt) CREF(new1063_1347))->evaluable__248) = ((bool_t) ((bool_t) 1)), BUNSPEC);
			     ((((global_bglt) CREF(new1063_1347))->library__255) = ((bool_t) library__255_1343), BUNSPEC);
			     ((((global_bglt) CREF(new1063_1347))->user__32) = ((bool_t) ((bool_t) 1)), BUNSPEC);
			     ((((global_bglt) CREF(new1063_1347))->pragma) = ((obj_t) BNIL), BUNSPEC);
			     ((((global_bglt) CREF(new1063_1347))->src) = ((obj_t) src_16), BUNSPEC);
			     res1676_1366 = new1063_1347;
			  }
		       }
		       new_788 = res1676_1366;
		    }
		 }
		 bucket_789 =
		    get_hash_29___hash(id_12, _genv__8_ast_env);
		 if (
		    PAIRP(bucket_789))
		   {	/* Ast/venv.scm 241 */
		      bool_t test1503_791;
		      {		/* Ast/venv.scm 241 */
			 obj_t obj2_1369;
			 obj2_1369 = _module__166_module_module;
			 test1503_791 =
			    (module_13 == obj2_1369);
		      }
		      if (test1503_791)
			{	/* Ast/venv.scm 241 */
			   {	/* Ast/venv.scm 242 */
			      obj_t new_bucket_15_792;
			      {		/* ./Ieee/pair-list.scm 5689 */
				 obj_t aux_1766;
				 obj_t aux_1764;
				 aux_1766 =
				    CDR(bucket_789);
				 aux_1764 =
				    (obj_t) (new_788);
				 new_bucket_15_792 =
				    MAKE_PAIR(aux_1764, aux_1766);
			      }
			      SET_CDR(bucket_789, new_bucket_15_792);
			   }
			}
		      else
			{	/* Ast/venv.scm 241 */
			   {	/* Ast/venv.scm 245 */
			      obj_t arg1505_794;
			      obj_t arg1506_795;
			      arg1505_794 =
				 CDR(bucket_789);
			      {		/* ./Ieee/pair-list.scm 5689 */
				 obj_t aux_1773;
				 obj_t aux_1771;
				 {	/* ./Ieee/pair-list.scm 5707 */
				    obj_t aux_1774;
				    aux_1774 =
				       CDR(bucket_789);
				    aux_1773 =
				       CDR(aux_1774);
				 }
				 aux_1771 =
				    (obj_t) (new_788);
				 arg1506_795 =
				    MAKE_PAIR(aux_1771, aux_1773);
			      }
			      SET_CDR(arg1505_794, arg1506_795);
			   }
			}
		   }
		 else
		   {	/* Ast/venv.scm 239 */
		      {		/* Ast/venv.scm 240 */
			 obj_t arg1509_797;
			 {	/* Ast/venv.scm 240 */
			    obj_t list1510_798;
			    {	/* Ast/venv.scm 240 */
			       obj_t arg1511_799;
			       {	/* Ast/venv.scm 240 */
				  obj_t aux_1779;
				  aux_1779 =
				     (obj_t) (new_788);
				  arg1511_799 =
				     MAKE_PAIR(aux_1779, BNIL);
			       }
			       list1510_798 =
				  MAKE_PAIR(id_12, arg1511_799);
			    }
			    arg1509_797 = list1510_798;
			 }
			 put_hash__129___hash(arg1509_797, _genv__8_ast_env);
		      }
		   }
		 return new_788;
	      }
	 }
      }
   }
}



/* _bind-global! */
obj_t 
_bind_global__219_ast_env(obj_t env_1513, obj_t id_1514, obj_t module_1515, obj_t value_1516, obj_t import_1517, obj_t src_1518)
{
   AN_OBJECT;
   {	/* Ast/venv.scm 212 */
      {		/* Ast/venv.scm 212 */
	 global_bglt aux_1784;
	 aux_1784 =
	    bind_global__138_ast_env(id_1514, module_1515,
	    (value_bglt) (value_1516), import_1517, src_1518);
	 return
	    (obj_t) (aux_1784);
      }
   }
}



/* unbind-global! */
obj_t 
unbind_global__45_ast_env(obj_t id_17, obj_t module_18)
{
   AN_OBJECT;
   {	/* Ast/venv.scm 251 */
      {		/* Ast/venv.scm 252 */
	 obj_t global_810;
	 {	/* Ast/venv.scm 252 */
	    obj_t list1540_829;
	    list1540_829 =
	       MAKE_PAIR(module_18, BNIL);
	    global_810 =
	       find_global_223_ast_env(id_17, list1540_829);
	 }
	 {	/* Ast/venv.scm 253 */
	    bool_t test1523_811;
	    test1523_811 =
	       is_a__118___object(global_810, global_ast_var);
	    if (test1523_811)
	      {		/* Ast/venv.scm 255 */
		 obj_t bucket_812;
		 bucket_812 =
		    get_hash_29___hash(id_17, _genv__8_ast_env);
		 {
		    obj_t cur_813;
		    obj_t prev_814;
		    cur_813 =
		       CDR(bucket_812);
		    prev_814 = bucket_812;
		  loop_815:
		    {	/* Ast/venv.scm 258 */
		       bool_t test_1793;
		       {	/* ./Ieee/equiv.scm 5508 */
			  obj_t aux_1794;
			  aux_1794 =
			     CAR(cur_813);
			  test_1793 =
			     (aux_1794 == global_810);
		       }
		       if (test_1793)
			 {	/* ./Ieee/pair-list.scm 5896 */
			    obj_t aux_1797;
			    aux_1797 =
			       CDR(cur_813);
			    return
			       SET_CDR(prev_814, aux_1797);
			 }
		       else
			 {
			    obj_t prev_1802;
			    obj_t cur_1800;
			    cur_1800 =
			       CDR(cur_813);
			    prev_1802 =
			       CDR(prev_814);
			    prev_814 = prev_1802;
			    cur_813 = cur_1800;
			    goto loop_815;
			 }
		    }
		 }
	      }
	    else
	      {		/* Ast/venv.scm 254 */
		 obj_t arg1534_824;
		 {	/* Ast/venv.scm 254 */
		    obj_t arg1536_826;
		    obj_t arg1537_827;
		    arg1536_826 =
		       CNST_TABLE_REF(((long) 11));
		    {	/* Ast/venv.scm 254 */
		       obj_t arg1539_828;
		       arg1539_828 =
			  MAKE_PAIR(module_18, BNIL);
		       arg1537_827 =
			  MAKE_PAIR(id_17, arg1539_828);
		    }
		    arg1534_824 =
		       MAKE_PAIR(arg1536_826, arg1537_827);
		 }
		 return
		    user_error_151_tools_error(string1682_ast_env, string1683_ast_env, arg1534_824, BNIL);
	      }
	 }
      }
   }
}



/* _unbind-global! */
obj_t 
_unbind_global__69_ast_env(obj_t env_1519, obj_t id_1520, obj_t module_1521)
{
   AN_OBJECT;
   {	/* Ast/venv.scm 251 */
      return
	 unbind_global__45_ast_env(id_1520, module_1521);
   }
}



/* for-each-global! */
obj_t 
for_each_global__88_ast_env(obj_t proc_19)
{
   AN_OBJECT;
   {	/* Ast/venv.scm 265 */
      {		/* Ast/venv.scm 266 */
	 obj_t _anonymous_1542__160_1522;
	 _anonymous_1542__160_1522 =
	    make_fx_procedure(_anonymous_1542__160_ast_env, ((long) 1), ((long) 1));
	 PROCEDURE_SET(_anonymous_1542__160_1522, ((long) 0), proc_19);
	 return
	    for_each_hash_105___hash(_anonymous_1542__160_1522, _genv__8_ast_env);
      }
   }
}



/* _for-each-global! */
obj_t 
_for_each_global__131_ast_env(obj_t env_1523, obj_t proc_1524)
{
   AN_OBJECT;
   {	/* Ast/venv.scm 265 */
      return
	 for_each_global__88_ast_env(proc_1524);
   }
}



/* <anonymous:1542> */
obj_t 
_anonymous_1542__160_ast_env(obj_t env_1525, obj_t bucket_1527)
{
   AN_OBJECT;
   {	/* Ast/venv.scm 266 */
      {		/* Ast/venv.scm 266 */
	 obj_t proc_1526;
	 proc_1526 =
	    PROCEDURE_REF(env_1525, ((long) 0));
	 {
	    obj_t bucket_831;
	    {	/* Ast/venv.scm 266 */
	       bool_t aux_1816;
	       bucket_831 = bucket_1527;
	       {
		  obj_t l1443_833;
		  l1443_833 =
		     CDR(bucket_831);
		lname1444_834:
		  if (
		     PAIRP(l1443_833))
		    {	/* Ast/venv.scm 266 */
		       PROCEDURE_ENTRY(proc_1526) (proc_1526,
			  CAR(l1443_833), BEOA);
		       {
			  obj_t l1443_1822;
			  l1443_1822 =
			     CDR(l1443_833);
			  l1443_833 = l1443_1822;
			  goto lname1444_834;
		       }
		    }
		  else
		    {	/* Ast/venv.scm 266 */
		       aux_1816 = ((bool_t) 1);
		    }
	       }
	       return
		  BBOOL(aux_1816);
	    }
	 }
      }
   }
}



/* global-bucket-position */
obj_t 
global_bucket_position_189_ast_env(obj_t id_20, obj_t module_21)
{
   AN_OBJECT;
   {	/* Ast/venv.scm 272 */
      {		/* Ast/venv.scm 273 */
	 obj_t bucket_840;
	 bucket_840 =
	    get_hash_29___hash(id_20, _genv__8_ast_env);
	 if (
	    PAIRP(bucket_840))
	   {
	      obj_t globals_842;
	      long pos_843;
	      {		/* Ast/venv.scm 276 */
		 long aux_1829;
		 globals_842 =
		    CDR(bucket_840);
		 pos_843 = ((long) 0);
	       loop_844:
		 if (
		    NULLP(globals_842))
		   {	/* Ast/venv.scm 279 */
		      aux_1829 = ((long) -1);
		   }
		 else
		   {	/* Ast/venv.scm 281 */
		      bool_t test_1832;
		      {		/* ./Ieee/equiv.scm 5508 */
			 obj_t aux_1833;
			 {	/* Ast/venv.scm 281 */
			    global_bglt obj_1409;
			    {	/* Ast/venv.scm 281 */
			       obj_t aux_1834;
			       aux_1834 =
				  CAR(globals_842);
			       obj_1409 =
				  (global_bglt) (aux_1834);
			    }
			    aux_1833 =
			       (((global_bglt) CREF(obj_1409))->module);
			 }
			 test_1832 =
			    (aux_1833 == module_21);
		      }
		      if (test_1832)
			{	/* Ast/venv.scm 281 */
			   aux_1829 = pos_843;
			}
		      else
			{	/* Ast/venv.scm 281 */
			   {
			      long pos_1841;
			      obj_t globals_1839;
			      globals_1839 =
				 CDR(globals_842);
			      pos_1841 =
				 (pos_843 + ((long) 1));
			      pos_843 = pos_1841;
			      globals_842 = globals_1839;
			      goto loop_844;
			   }
			}
		   }
		 return
		    BINT(aux_1829);
	      }
	   }
	 else
	   {	/* Ast/venv.scm 274 */
	      return
		 BINT(((long) -1));
	   }
      }
   }
}



/* _global-bucket-position */
obj_t 
_global_bucket_position_151_ast_env(obj_t env_1528, obj_t id_1529, obj_t module_1530)
{
   AN_OBJECT;
   {	/* Ast/venv.scm 272 */
      return
	 global_bucket_position_189_ast_env(id_1529, module_1530);
   }
}



/* method-init */
obj_t 
method_init_76_ast_env()
{
   AN_OBJECT;
   {	/* Ast/venv.scm 14 */
      add_generic__110___object(restore_value_types__env_16_ast_env, restore_value_types__default1445_env_45_ast_env);
      add_inlined_method__244___object(restore_value_types__env_16_ast_env, sfun_ast_var, ((long) 0));
      {		/* Ast/venv.scm 14 */
	 long aux_1849;
	 aux_1849 =
	    add_inlined_method__244___object(restore_value_types__env_16_ast_env, cfun_ast_var, ((long) 1));
	 return
	    BINT(aux_1849);
      }
   }
}



/* restore-value-types! */
obj_t 
restore_value_types__114_ast_env(value_bglt value_4)
{
   AN_OBJECT;
   {	/* Ast/venv.scm 93 */
      {
	 obj_t method1633_1183;
	 obj_t class1638_1184;
	 {	/* Ast/venv.scm 93 */
	    obj_t arg1641_1181;
	    obj_t arg1642_1182;
	    {	/* Ast/venv.scm 93 */
	       object_bglt obj_1434;
	       obj_1434 =
		  (object_bglt) (value_4);
	       {	/* ./Llib/object.scm 2926 */
		  obj_t pre_method_105_1435;
		  pre_method_105_1435 =
		     PROCEDURE_REF(restore_value_types__env_16_ast_env, ((long) 2));
		  if (
		     INTEGERP(pre_method_105_1435))
		    {	/* ./Llib/object.scm 2927 */
		       PROCEDURE_SET(restore_value_types__env_16_ast_env, ((long) 2), BUNSPEC);
		       arg1641_1181 = pre_method_105_1435;
		    }
		  else
		    {	/* ./Llib/object.scm 2914 */
		       long obj_class_num_177_1440;
		       obj_class_num_177_1440 =
			  TYPE(obj_1434);
		       {	/* ./Llib/object.scm 2915 */
			  obj_t arg1176_1441;
			  arg1176_1441 =
			     PROCEDURE_REF(restore_value_types__env_16_ast_env, ((long) 1));
			  {	/* ./Llib/object.scm 2738 */
			     long arg1177_1445;
			     {	/* ./Llib/object.scm 2738 */
				long arg1178_1446;
				arg1178_1446 =
				   OBJECT_TYPE;
				arg1177_1445 =
				   (obj_class_num_177_1440 - arg1178_1446);
			     }
			     arg1641_1181 =
				VECTOR_REF(arg1176_1441, arg1177_1445);
			  }
		       }
		    }
	       }
	    }
	    {	/* Ast/venv.scm 93 */
	       object_bglt object_1451;
	       object_1451 =
		  (object_bglt) (value_4);
	       {	/* ./Llib/object.scm 2695 */
		  long arg1179_1452;
		  {	/* ./Llib/object.scm 2695 */
		     long arg1180_1453;
		     long arg1181_1454;
		     arg1180_1453 =
			TYPE(object_1451);
		     arg1181_1454 =
			OBJECT_TYPE;
		     arg1179_1452 =
			(arg1180_1453 - arg1181_1454);
		  }
		  {	/* ./Llib/object.scm 2695 */
		     obj_t vector_1458;
		     vector_1458 = _classes__134___object;
		     arg1642_1182 =
			VECTOR_REF(vector_1458, arg1179_1452);
		  }
	       }
	    }
	    method1633_1183 = arg1641_1181;
	    class1638_1184 = arg1642_1182;
	    {

	       if (
		  INTEGERP(method1633_1183))
		 {	/* Ast/venv.scm 93 */
		    switch (
		       (long) CINT(method1633_1183))
		      {
		      case ((long) 0):

			 {	/* Ast/venv.scm 100 */
			    sfun_bglt value_1190;
			    value_1190 =
			       (sfun_bglt) (value_4);
			    {
			       obj_t args_1192;
			       args_1192 =
				  (((sfun_bglt) CREF(value_1190))->args);
			     loop_1193:
			       if (
				  PAIRP(args_1192))
				 {	/* Ast/venv.scm 103 */
				    {	/* Ast/venv.scm 104 */
				       obj_t arg_1196;
				       arg_1196 =
					  CAR(args_1192);
				       {	/* Ast/venv.scm 106 */
					  bool_t test1648_1197;
					  test1648_1197 =
					     is_a__118___object(arg_1196, type_type_type);
					  if (test1648_1197)
					    {	/* Ast/venv.scm 106 */
					       {	/* Ast/venv.scm 107 */
						  type_bglt arg1649_1198;
						  {	/* Ast/venv.scm 107 */
						     obj_t aux_1875;
						     {	/* Ast/venv.scm 107 */
							type_bglt obj_1464;
							obj_1464 =
							   (type_bglt) (arg_1196);
							aux_1875 =
							   (((type_bglt) CREF(obj_1464))->id);
						     }
						     arg1649_1198 =
							find_type_26_type_env(aux_1875);
						  }
						  {	/* ./Ieee/pair-list.scm 5890 */
						     obj_t aux_1879;
						     aux_1879 =
							(obj_t) (arg1649_1198);
						     SET_CAR(args_1192, aux_1879);
						  }
					       }
					    }
					  else
					    {	/* Ast/venv.scm 108 */
					       bool_t test1651_1200;
					       test1651_1200 =
						  is_a__118___object(arg_1196, local_ast_var);
					       if (test1651_1200)
						 {	/* Ast/venv.scm 108 */
						    {	/* Ast/venv.scm 109 */
						       type_bglt new_type_21_1201;
						       {	/* Ast/venv.scm 109 */
							  obj_t aux_1884;
							  {	/* Ast/venv.scm 109 */
							     type_bglt arg1653_1203;
							     {	/* Ast/venv.scm 109 */
								local_bglt obj_1468;
								obj_1468 =
								   (local_bglt) (arg_1196);
								arg1653_1203 =
								   (((local_bglt) CREF(obj_1468))->type);
							     }
							     aux_1884 =
								(((type_bglt) CREF(arg1653_1203))->id);
							  }
							  new_type_21_1201 =
							     find_type_26_type_env(aux_1884);
						       }
						       {	/* Ast/venv.scm 110 */
							  local_bglt obj_1470;
							  obj_1470 =
							     (local_bglt) (arg_1196);
							  ((((local_bglt) CREF(obj_1470))->type) = ((type_bglt) new_type_21_1201), BUNSPEC);
						       }
						    }
						 }
					       else
						 {	/* Ast/venv.scm 108 */
						    {	/* Ast/venv.scm 112 */
						       obj_t arg1656_1206;
						       arg1656_1206 =
							  shape_tools_shape(arg_1196);
						       FAILURE(string1684_ast_env, string1685_ast_env, arg1656_1206);
						    }
						 }
					    }
				       }
				       {
					  obj_t args_1893;
					  args_1893 =
					     CDR(args_1192);
					  args_1192 = args_1893;
					  goto loop_1193;
				       }
				    }
				 }
			       else
				 {	/* Ast/venv.scm 103 */
				    if (
				       NULLP(args_1192))
				      {		/* Ast/venv.scm 116 */
					 {	/* Ast/venv.scm 117 */
					    obj_t body_1209;
					    body_1209 =
					       (((sfun_bglt) CREF(value_1190))->body);
					    {	/* Ast/venv.scm 119 */
					       bool_t test1659_1210;
					       test1659_1210 =
						  is_a__118___object(body_1209, node_ast_node);
					       if (test1659_1210)
						 {	/* Ast/venv.scm 119 */
						    return
						       hrtype_node__16_ast_hrtype(
						       (node_bglt) (body_1209));
						 }
					       else
						 {	/* Ast/venv.scm 119 */
						    return BUNSPEC;
						 }
					    }
					 }
				      }
				    else
				      {		/* Ast/venv.scm 116 */
					 {	/* Ast/venv.scm 122 */
					    obj_t arg1662_1213;
					    arg1662_1213 =
					       shape_tools_shape(args_1192);
					    FAILURE(string1686_ast_env, string1687_ast_env, arg1662_1213);
					 }
				      }
				 }
			    }
			 }
			 break;
		      case ((long) 1):

			 {	/* Ast/venv.scm 130 */
			    cfun_bglt value_1214;
			    value_1214 =
			       (cfun_bglt) (value_4);
			    {
			       obj_t args_1216;
			       args_1216 =
				  (((cfun_bglt) CREF(value_1214))->args_type_205);
			     loop_1217:
			       if (
				  PAIRP(args_1216))
				 {	/* Ast/venv.scm 132 */
				    {	/* Ast/venv.scm 134 */
				       type_bglt arg1665_1220;
				       {	/* Ast/venv.scm 134 */
					  obj_t aux_1908;
					  {	/* Ast/venv.scm 134 */
					     type_bglt obj_1485;
					     {	/* Ast/venv.scm 134 */
						obj_t aux_1909;
						aux_1909 =
						   CAR(args_1216);
						obj_1485 =
						   (type_bglt) (aux_1909);
					     }
					     aux_1908 =
						(((type_bglt) CREF(obj_1485))->id);
					  }
					  arg1665_1220 =
					     find_type_26_type_env(aux_1908);
				       }
				       {	/* ./Ieee/pair-list.scm 5890 */
					  obj_t aux_1914;
					  aux_1914 =
					     (obj_t) (arg1665_1220);
					  SET_CAR(args_1216, aux_1914);
				       }
				    }
				    {
				       obj_t args_1917;
				       args_1917 =
					  CDR(args_1216);
				       args_1216 = args_1917;
				       goto loop_1217;
				    }
				 }
			       else
				 {	/* Ast/venv.scm 132 */
				    return BUNSPEC;
				 }
			    }
			 }
			 break;
		      default:
		       case_else1639_1187:
			 if (
			    PROCEDUREP(method1633_1183))
			   {	/* Ast/venv.scm 93 */
			      return
				 PROCEDURE_ENTRY(method1633_1183) (method1633_1183,
				 (obj_t) (value_4), BEOA);
			   }
			 else
			   {	/* Ast/venv.scm 93 */
			      obj_t fun1632_1179;
			      fun1632_1179 =
				 PROCEDURE_REF(restore_value_types__env_16_ast_env, ((long) 0));
			      return
				 PROCEDURE_ENTRY(fun1632_1179) (fun1632_1179,
				 (obj_t) (value_4), BEOA);
			   }
		      }
		 }
	       else
		 {	/* Ast/venv.scm 93 */
		    goto case_else1639_1187;
		 }
	    }
	 }
      }
   }
}



/* _restore-value-types! */
obj_t 
_restore_value_types__78_ast_env(obj_t env_1531, obj_t value_1532)
{
   AN_OBJECT;
   {	/* Ast/venv.scm 93 */
      return
	 restore_value_types__114_ast_env(
	 (value_bglt) (value_1532));
   }
}



/* restore-value-types!-default1445 */
obj_t 
restore_value_types__default1445_109_ast_env(value_bglt value_5)
{
   AN_OBJECT;
   {	/* Ast/venv.scm 14 */
      return BUNSPEC;
   }
}



/* _restore-value-types!-default1445 */
obj_t 
_restore_value_types__default1445_112_ast_env(obj_t env_1533, obj_t value_1534)
{
   AN_OBJECT;
   {	/* Ast/venv.scm 14 */
      return
	 restore_value_types__default1445_109_ast_env(
	 (value_bglt) (value_1534));
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_ast_env()
{
   AN_OBJECT;
   {	/* Ast/venv.scm 14 */
      module_initialization_70_tools_shape(((long) 0), "AST_ENV");
      module_initialization_70_engine_param(((long) 0), "AST_ENV");
      module_initialization_70_tools_error(((long) 0), "AST_ENV");
      module_initialization_70_type_type(((long) 0), "AST_ENV");
      module_initialization_70_type_cache(((long) 0), "AST_ENV");
      module_initialization_70_type_env(((long) 0), "AST_ENV");
      module_initialization_70_ast_var(((long) 0), "AST_ENV");
      module_initialization_70_ast_node(((long) 0), "AST_ENV");
      module_initialization_70_ast_hrtype(((long) 0), "AST_ENV");
      return
	 module_initialization_70_module_module(((long) 0), "AST_ENV");
   }
}
