/*===========================================================================*/
/*   (Bdb/emit.scm)                                                          */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;

typedef struct ccomp
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t producer;
     obj_t consumer;
     obj_t finalizer;
     obj_t checksummer;
  }
     *ccomp_bglt;


extern obj_t _long__149_type_cache;
extern obj_t _src_files__222_engine_param;
static obj_t method_init_76_bdb_emit();
extern obj_t make_box_202_ast_node;
extern obj_t funcall_ast_node;
extern obj_t symbol_append_197___r4_symbols_6_4(obj_t);
static obj_t bdb_sfun__59_bdb_emit(value_bglt);
static obj_t _bdb__default1496_171_bdb_emit(obj_t, obj_t);
extern long add_inlined_method__244___object(obj_t, obj_t, long);
extern obj_t fail_ast_node;
extern obj_t leave_function_170_tools_error();
static obj_t _c_port__188_bdb_emit = BUNSPEC;
extern obj_t sequence_ast_node;
extern obj_t let_var_6_ast_node;
static obj_t _emit_bdb_info1734_157_bdb_emit(obj_t, obj_t, obj_t);
extern obj_t global_ast_var;
static obj_t bdb__default1496_39_bdb_emit(node_bglt);
extern obj_t pragma_ast_node;
static obj_t _anonymous_1565__159_bdb_emit(obj_t, obj_t);
extern obj_t set_ex_it_116_ast_node;
extern obj_t unit_initializer_id_235_ast_unit(obj_t);
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t qualified_name_205_cgen_prototype(obj_t, obj_t);
extern obj_t module_initialization_70_bdb_emit(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_tools_misc(long, char *);
extern obj_t module_initialization_70_tools_location(long, char *);
extern obj_t module_initialization_70_type_env(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_ast_sexp(long, char *);
extern obj_t module_initialization_70_ast_env(long, char *);
extern obj_t module_initialization_70_ast_ident(long, char *);
extern obj_t module_initialization_70_ast_unit(long, char *);
extern obj_t module_initialization_70_module_module(long, char *);
extern obj_t module_initialization_70_module_include(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_cgen_prototype(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_symbols_6_4(long, char *);
extern obj_t module_initialization_70___r4_output_6_10_3(long, char *);
extern obj_t svar_ast_var;
static obj_t bdb_global_sfun__204_bdb_emit(obj_t);
extern obj_t display_2_122___r4_output_6_10_3(obj_t, obj_t);
extern obj_t let_fun_218_ast_node;
extern obj_t _real__144_type_cache;
static obj_t imported_modules_init_94_bdb_emit();
extern obj_t emit_bdb_info_67_bdb_emit(obj_t, obj_t);
extern obj_t app_ly_162_ast_node;
extern obj_t add_generic__110___object(obj_t, obj_t);
extern obj_t id__name_228_ast_ident(obj_t);
extern obj_t _module_clause__117_module_module;
extern obj_t app_ast_node;
static obj_t library_modules_init_112_bdb_emit();
extern obj_t cast_ast_node;
static obj_t _bdb_1735_70_bdb_emit(obj_t, obj_t);
static obj_t toplevel_init_63_bdb_emit();
extern obj_t jump_ex_it_184_ast_node;
extern obj_t open_input_string(obj_t);
extern obj_t setq_ast_node;
extern obj_t box_set__221_ast_node;
static bool_t bdb_local_variable__9_bdb_emit(obj_t);
extern obj_t enter_function_81_tools_error(obj_t);
extern obj_t for_each_global__88_ast_env(obj_t);
static obj_t bdb__20_bdb_emit(node_bglt);
static obj_t bdb___160_bdb_emit(obj_t);
extern obj_t _module__166_module_module;
extern obj_t _classes__134___object;
extern obj_t set_variable_name__102_cgen_prototype(obj_t);
extern obj_t select_ast_node;
extern obj_t read___reader(obj_t);
extern obj_t _char__84_type_cache;
extern obj_t find_location_120_tools_location(obj_t);
static obj_t bdb_emit_local_info__83_bdb_emit(obj_t);
static obj_t bdb_global_svar__1_bdb_emit(obj_t);
extern obj_t _string__3_type_cache;
static obj_t require_initialization_114_bdb_emit = BUNSPEC;
extern obj_t conditional_ast_node;
extern obj_t get_toplevel_unit_32_module_include();
static obj_t cnst_init_137_bdb_emit();
extern obj_t _int__35_type_cache;
extern obj_t _bool__149_type_cache;
static obj_t __cnst[6];

DEFINE_STATIC_GENERIC(bdb__env_49_bdb_emit, _bdb_1735_70_bdb_emit1763, _bdb_1735_70_bdb_emit, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc1749_bdb_emit, _anonymous_1565__159_bdb_emit1764, _anonymous_1565__159_bdb_emit, 0L, 1);
DEFINE_EXPORT_PROCEDURE(emit_bdb_info_env_109_bdb_emit, _emit_bdb_info1734_157_bdb_emit1765, _emit_bdb_info1734_157_bdb_emit, 0L, 2);
DEFINE_STATIC_PROCEDURE(bdb__default1496_env_230_bdb_emit, _bdb__default1496_171_bdb_emit1766, _bdb__default1496_171_bdb_emit, 0L, 1);
DEFINE_STRING(string1758_bdb_emit, string1758_bdb_emit1767, "DONE BIGLOO @ TOPLEVEL-INIT EXPORT LOCATION ", 44);
DEFINE_STRING(string1757_bdb_emit, string1757_bdb_emit1768, "     {\"", 7);
DEFINE_STRING(string1756_bdb_emit, string1756_bdb_emit1769, "     {0, 0},", 12);
DEFINE_STRING(string1755_bdb_emit, string1755_bdb_emit1770, "\"},", 3);
DEFINE_STRING(string1754_bdb_emit, string1754_bdb_emit1771, ", \"", 3);
DEFINE_STRING(string1753_bdb_emit, string1753_bdb_emit1772, "   {", 4);
DEFINE_STRING(string1752_bdb_emit, string1752_bdb_emit1773, "\", 0},", 6);
DEFINE_STRING(string1751_bdb_emit, string1751_bdb_emit1774, "\", (char *)", 11);
DEFINE_STRING(string1750_bdb_emit, string1750_bdb_emit1775, "   0};\n", 7);
DEFINE_STRING(string1748_bdb_emit, string1748_bdb_emit1776, " },", 3);
DEFINE_STRING(string1747_bdb_emit, string1747_bdb_emit1777, "0", 1);
DEFINE_STRING(string1746_bdb_emit, string1746_bdb_emit1778, "   { 0, (char *)", 16);
DEFINE_STRING(string1745_bdb_emit, string1745_bdb_emit1779, "\", 0 },", 7);
DEFINE_STRING(string1744_bdb_emit, string1744_bdb_emit1780, "\" },", 4);
DEFINE_STRING(string1743_bdb_emit, string1743_bdb_emit1781, "\", \"", 4);
DEFINE_STRING(string1742_bdb_emit, string1742_bdb_emit1782, "   {\"", 5);
DEFINE_STRING(string1741_bdb_emit, string1741_bdb_emit1783, "[] = { ", 7);
DEFINE_STRING(string1739_bdb_emit, string1739_bdb_emit1784, "} ", 2);
DEFINE_STRING(string1740_bdb_emit, string1740_bdb_emit1785, "__bdb_info", 10);
DEFINE_STRING(string1738_bdb_emit, string1738_bdb_emit1786, "   char *sname, *cname;\n", 24);
DEFINE_STRING(string1737_bdb_emit, string1737_bdb_emit1787, "static struct bdb_fun_info {\n", 29);
DEFINE_STRING(string1736_bdb_emit, string1736_bdb_emit1788, "/* bdb association table */", 27);



/* module-initialization */
obj_t 
module_initialization_70_bdb_emit(long checksum_1567, char *from_1568)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_bdb_emit))
	{
	   require_initialization_114_bdb_emit =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_bdb_emit();
	   cnst_init_137_bdb_emit();
	   imported_modules_init_94_bdb_emit();
	   method_init_76_bdb_emit();
	   toplevel_init_63_bdb_emit();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_bdb_emit()
{
   AN_OBJECT;
   {	/* Bdb/emit.scm 14 */
      module_initialization_70___r4_symbols_6_4(((long) 0), "BDB_EMIT");
      module_initialization_70___object(((long) 0), "BDB_EMIT");
      module_initialization_70___r4_output_6_10_3(((long) 0), "BDB_EMIT");
      module_initialization_70___reader(((long) 0), "BDB_EMIT");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_bdb_emit()
{
   AN_OBJECT;
   {	/* Bdb/emit.scm 14 */
      {		/* Bdb/emit.scm 14 */
	 obj_t cnst_port_138_1560;
	 cnst_port_138_1560 =
	    open_input_string(string1758_bdb_emit);
	 {
	    long i_1561;
	    i_1561 = ((long) 5);
	  loop_1562:
	    {	/* Bdb/emit.scm 14 */
	       bool_t test1759_1563;
	       test1759_1563 =
		  (i_1561 == ((long) -1));
	       if (test1759_1563)
		 {	/* Bdb/emit.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Bdb/emit.scm 14 */
		    {	/* Bdb/emit.scm 14 */
		       obj_t arg1760_1564;
		       {	/* Bdb/emit.scm 14 */
			  obj_t list1761_1565;
			  list1761_1565 =
			     MAKE_PAIR(cnst_port_138_1560, BNIL);
			  arg1760_1564 =
			     read___reader(list1761_1565);
		       }
		       CNST_TABLE_SET(i_1561, arg1760_1564);
		    }
		    {	/* Bdb/emit.scm 14 */
		       int aux_1566;
		       {	/* Bdb/emit.scm 14 */
			  long aux_1587;
			  aux_1587 =
			     (i_1561 - ((long) 1));
			  aux_1566 =
			     (int) (aux_1587);
		       }
		       {
			  long i_1590;
			  i_1590 =
			     (long) (aux_1566);
			  i_1561 = i_1590;
			  goto loop_1562;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_bdb_emit()
{
   AN_OBJECT;
   {	/* Bdb/emit.scm 14 */
      _c_port__188_bdb_emit = BUNSPEC;
      return BUNSPEC;
   }
}



/* emit-bdb-info */
obj_t 
emit_bdb_info_67_bdb_emit(obj_t globals_33, obj_t port_34)
{
   AN_OBJECT;
   {	/* Bdb/emit.scm 37 */
      _c_port__188_bdb_emit = port_34;
      WRITE_CHAR(((unsigned char) '\n'), port_34);
      WRITE_CHAR(((unsigned char) '\n'), port_34);
      display_2_122___r4_output_6_10_3(string1736_bdb_emit, port_34);
      WRITE_CHAR(((unsigned char) '\n'), port_34);
      display_2_122___r4_output_6_10_3(string1737_bdb_emit, port_34);
      display_2_122___r4_output_6_10_3(string1738_bdb_emit, port_34);
      display_2_122___r4_output_6_10_3(string1739_bdb_emit, port_34);
      display_2_122___r4_output_6_10_3(string1740_bdb_emit, port_34);
      display_2_122___r4_output_6_10_3(string1741_bdb_emit, port_34);
      WRITE_CHAR(((unsigned char) '\n'), port_34);
      {		/* Bdb/emit.scm 50 */
	 obj_t port1447_788;
	 port1447_788 = _c_port__188_bdb_emit;
	 display_2_122___r4_output_6_10_3(string1742_bdb_emit, port1447_788);
	 display_2_122___r4_output_6_10_3(_module__166_module_module, port1447_788);
	 display_2_122___r4_output_6_10_3(string1743_bdb_emit, port1447_788);
	 {	/* Bdb/emit.scm 54 */
	    obj_t arg1551_789;
	    {	/* Bdb/emit.scm 54 */
	       obj_t arg1552_790;
	       {	/* Bdb/emit.scm 54 */
		  obj_t arg1553_791;
		  {	/* Bdb/emit.scm 54 */
		     obj_t arg1555_792;
		     {	/* Bdb/emit.scm 54 */
			obj_t arg1556_793;
			arg1556_793 =
			   get_toplevel_unit_32_module_include();
			arg1555_792 =
			   STRUCT_REF(arg1556_793, ((long) 0));
		     }
		     arg1553_791 =
			unit_initializer_id_235_ast_unit(arg1555_792);
		  }
		  arg1552_790 =
		     id__name_228_ast_ident(arg1553_791);
	       }
	       arg1551_789 =
		  qualified_name_205_cgen_prototype(arg1552_790, _module__166_module_module);
	    }
	    display_2_122___r4_output_6_10_3(arg1551_789, port1447_788);
	 }
	 display_2_122___r4_output_6_10_3(string1744_bdb_emit, port1447_788);
	 WRITE_CHAR(((unsigned char) '\n'), port1447_788);
      }
      {
	 obj_t l1448_794;
	 l1448_794 = _src_files__222_engine_param;
       lname1449_795:
	 if (
	    PAIRP(l1448_794))
	   {	/* Bdb/emit.scm 57 */
	      {		/* Bdb/emit.scm 58 */
		 obj_t src_797;
		 src_797 =
		    CAR(l1448_794);
		 {	/* Bdb/emit.scm 58 */
		    obj_t port1450_798;
		    port1450_798 = _c_port__188_bdb_emit;
		    display_2_122___r4_output_6_10_3(string1742_bdb_emit, port1450_798);
		    display_2_122___r4_output_6_10_3(src_797, port1450_798);
		    display_2_122___r4_output_6_10_3(string1745_bdb_emit, port1450_798);
		    WRITE_CHAR(((unsigned char) '\n'), port1450_798);
		 }
	      }
	      {
		 obj_t l1448_1620;
		 l1448_1620 =
		    CDR(l1448_794);
		 l1448_794 = l1448_1620;
		 goto lname1449_795;
	      }
	   }
	 else
	   {	/* Bdb/emit.scm 57 */
	      ((bool_t) 1);
	   }
      }
      {		/* Bdb/emit.scm 60 */
	 obj_t port1451_800;
	 port1451_800 = _c_port__188_bdb_emit;
	 display_2_122___r4_output_6_10_3(string1746_bdb_emit, port1451_800);
	 {	/* Bdb/emit.scm 62 */
	    obj_t arg1559_801;
	    {	/* Bdb/emit.scm 62 */
	       obj_t loc_802;
	       loc_802 =
		  find_location_120_tools_location(_module_clause__117_module_module);
	       {	/* Bdb/emit.scm 63 */
		  bool_t test_1624;
		  if (
		     STRUCTP(loc_802))
		    {	/* ./Ieee/equiv.scm 5508 */
		       obj_t aux_1629;
		       obj_t aux_1627;
		       aux_1629 =
			  CNST_TABLE_REF(((long) 0));
		       aux_1627 =
			  STRUCT_KEY(loc_802);
		       test_1624 =
			  (aux_1627 == aux_1629);
		    }
		  else
		    {	/* ./Tools/location.sch 587 */
		       test_1624 = ((bool_t) 0)
			  ;
		    }
		  if (test_1624)
		    {	/* Bdb/emit.scm 63 */
		       arg1559_801 =
			  STRUCT_REF(loc_802, ((long) 2));
		    }
		  else
		    {	/* Bdb/emit.scm 63 */
		       arg1559_801 = string1747_bdb_emit;
		    }
	       }
	    }
	    display_2_122___r4_output_6_10_3(arg1559_801, port1451_800);
	 }
	 display_2_122___r4_output_6_10_3(string1748_bdb_emit, port1451_800);
	 WRITE_CHAR(((unsigned char) '\n'), port1451_800);
      }
      {
	 obj_t l1452_804;
	 l1452_804 = globals_33;
       lname1453_805:
	 if (
	    PAIRP(l1452_804))
	   {	/* Bdb/emit.scm 68 */
	      {		/* Bdb/emit.scm 68 */
		 obj_t global_807;
		 global_807 =
		    CAR(l1452_804);
		 {	/* Bdb/emit.scm 69 */
		    obj_t aux_1639;
		    {	/* Bdb/emit.scm 69 */
		       global_bglt obj_1383;
		       obj_1383 =
			  (global_bglt) (global_807);
		       aux_1639 =
			  (((global_bglt) CREF(obj_1383))->id);
		    }
		    enter_function_81_tools_error(aux_1639);
		 }
		 bdb_global_sfun__204_bdb_emit(global_807);
		 leave_function_170_tools_error();
	      }
	      {
		 obj_t l1452_1645;
		 l1452_1645 =
		    CDR(l1452_804);
		 l1452_804 = l1452_1645;
		 goto lname1453_805;
	      }
	   }
	 else
	   {	/* Bdb/emit.scm 68 */
	      ((bool_t) 1);
	   }
      }
      {		/* Bdb/emit.scm 75 */
	 obj_t _anonymous_1565__159_1548;
	 _anonymous_1565__159_1548 = proc1749_bdb_emit;
	 for_each_global__88_ast_env(_anonymous_1565__159_1548);
      }
      display_2_122___r4_output_6_10_3(string1750_bdb_emit, port_34);
      {		/* ./Ieee/output.scm 9332 */
	 unsigned char aux_1649;
	 aux_1649 =
	    WRITE_CHAR(((unsigned char) '\n'), port_34);
	 return
	    BCHAR(aux_1649);
      }
   }
}



/* _emit-bdb-info1734 */
obj_t 
_emit_bdb_info1734_157_bdb_emit(obj_t env_1549, obj_t globals_1550, obj_t port_1551)
{
   AN_OBJECT;
   {	/* Bdb/emit.scm 37 */
      return
	 emit_bdb_info_67_bdb_emit(globals_1550, port_1551);
   }
}



/* <anonymous:1565> */
obj_t 
_anonymous_1565__159_bdb_emit(obj_t env_1552, obj_t global_1553)
{
   AN_OBJECT;
   {	/* Bdb/emit.scm 74 */
      {
	 obj_t global_811;
	 global_811 = global_1553;
	 {	/* Bdb/emit.scm 75 */
	    bool_t test1566_813;
	    {	/* Bdb/emit.scm 75 */
	       bool_t test1567_814;
	       {	/* Bdb/emit.scm 75 */
		  bool_t test1569_816;
		  {	/* Bdb/emit.scm 75 */
		     bool_t test1573_819;
		     {	/* Bdb/emit.scm 75 */
			obj_t obj2_1387;
			obj2_1387 = _module__166_module_module;
			{	/* ./Ieee/equiv.scm 5508 */
			   obj_t aux_1653;
			   {	/* Bdb/emit.scm 75 */
			      global_bglt obj_1385;
			      obj_1385 =
				 (global_bglt) (global_811);
			      aux_1653 =
				 (((global_bglt) CREF(obj_1385))->module);
			   }
			   test1573_819 =
			      (aux_1653 == obj2_1387);
			}
		     }
		     if (test1573_819)
		       {	/* ./Ieee/equiv.scm 5508 */
			  obj_t aux_1661;
			  obj_t aux_1658;
			  aux_1661 =
			     CNST_TABLE_REF(((long) 1));
			  {	/* Bdb/emit.scm 76 */
			     global_bglt obj_1388;
			     obj_1388 =
				(global_bglt) (global_811);
			     aux_1658 =
				(((global_bglt) CREF(obj_1388))->import);
			  }
			  test1569_816 =
			     (aux_1658 == aux_1661);
		       }
		     else
		       {	/* Bdb/emit.scm 75 */
			  test1569_816 = ((bool_t) 0);
		       }
		  }
		  if (test1569_816)
		    {	/* Bdb/emit.scm 75 */
		       test1567_814 = ((bool_t) 1);
		    }
		  else
		    {	/* ./Ieee/fixnum.scm 7121 */
		       long aux_1665;
		       {	/* Bdb/emit.scm 77 */
			  global_bglt obj_1391;
			  obj_1391 =
			     (global_bglt) (global_811);
			  aux_1665 =
			     (((global_bglt) CREF(obj_1391))->occurrence);
		       }
		       test1567_814 =
			  (aux_1665 > ((long) 0));
		    }
	       }
	       if (test1567_814)
		 {	/* ./Ast/var.scm 758 */
		    obj_t aux_1670;
		    {	/* Bdb/emit.scm 78 */
		       value_bglt aux_1671;
		       {	/* Bdb/emit.scm 78 */
			  global_bglt obj_1394;
			  obj_1394 =
			     (global_bglt) (global_811);
			  aux_1671 =
			     (((global_bglt) CREF(obj_1394))->value);
		       }
		       aux_1670 =
			  (obj_t) (aux_1671);
		    }
		    test1566_813 =
		       is_a__118___object(aux_1670, svar_ast_var);
		 }
	       else
		 {	/* Bdb/emit.scm 75 */
		    test1566_813 = ((bool_t) 0);
		 }
	    }
	    if (test1566_813)
	      {		/* Bdb/emit.scm 75 */
		 return
		    bdb_global_svar__1_bdb_emit(global_811);
	      }
	    else
	      {		/* Bdb/emit.scm 75 */
		 return BUNSPEC;
	      }
	 }
      }
   }
}



/* bdb-global-sfun! */
obj_t 
bdb_global_sfun__204_bdb_emit(obj_t global_35)
{
   AN_OBJECT;
   {	/* Bdb/emit.scm 85 */
      {		/* Bdb/emit.scm 86 */
	 value_bglt sfun_825;
	 {	/* Bdb/emit.scm 86 */
	    global_bglt obj_1397;
	    obj_1397 =
	       (global_bglt) (global_35);
	    sfun_825 =
	       (((global_bglt) CREF(obj_1397))->value);
	 }
	 {	/* Bdb/emit.scm 86 */
	    obj_t sfun_loc_13_826;
	    {	/* Bdb/emit.scm 87 */
	       sfun_bglt obj_1398;
	       obj_1398 =
		  (sfun_bglt) (sfun_825);
	       sfun_loc_13_826 =
		  (((sfun_bglt) CREF(obj_1398))->loc);
	    }
	    {	/* Bdb/emit.scm 87 */
	       obj_t clo_827;
	       {	/* Bdb/emit.scm 88 */
		  sfun_bglt obj_1399;
		  obj_1399 =
		     (sfun_bglt) (sfun_825);
		  clo_827 =
		     (((sfun_bglt) CREF(obj_1399))->the_closure_238);
	       }
	       {	/* Bdb/emit.scm 88 */

		  {	/* Bdb/emit.scm 89 */
		     bool_t test_1684;
		     {	/* Bdb/emit.scm 89 */
			bool_t test_1685;
			if (
			   STRUCTP(sfun_loc_13_826))
			  {	/* ./Ieee/equiv.scm 5508 */
			     obj_t aux_1690;
			     obj_t aux_1688;
			     aux_1690 =
				CNST_TABLE_REF(((long) 0));
			     aux_1688 =
				STRUCT_KEY(sfun_loc_13_826);
			     test_1685 =
				(aux_1688 == aux_1690);
			  }
			else
			  {	/* ./Tools/location.sch 587 */
			     test_1685 = ((bool_t) 0)
				;
			  }
			if (test_1685)
			  {	/* Bdb/emit.scm 90 */
			     global_bglt obj_1408;
			     obj_1408 =
				(global_bglt) (global_35);
			     test_1684 =
				(((global_bglt) CREF(obj_1408))->user__32);
			  }
			else
			  {	/* Bdb/emit.scm 89 */
			     test_1684 = ((bool_t) 0)
				;
			  }
		     }
		     if (test_1684)
		       {	/* Bdb/emit.scm 89 */
			  set_variable_name__102_cgen_prototype(global_35);
			  {	/* Bdb/emit.scm 93 */
			     obj_t fname_829;
			     obj_t lnum_830;
			     obj_t id_831;
			     obj_t val_name_6_832;
			     obj_t bp_name_229_833;
			     fname_829 =
				STRUCT_REF(sfun_loc_13_826, ((long) 0));
			     lnum_830 =
				STRUCT_REF(sfun_loc_13_826, ((long) 2));
			     {	/* Bdb/emit.scm 95 */
				obj_t id_840;
				{	/* Bdb/emit.scm 95 */
				   global_bglt obj_1415;
				   obj_1415 =
				      (global_bglt) (global_35);
				   id_840 =
				      (((global_bglt) CREF(obj_1415))->id);
				}
				{	/* Bdb/emit.scm 96 */
				   bool_t test_1700;
				   {	/* ./Ieee/equiv.scm 5508 */
				      obj_t aux_1701;
				      aux_1701 =
					 CNST_TABLE_REF(((long) 2));
				      test_1700 =
					 (id_840 == aux_1701);
				   }
				   if (test_1700)
				     {	/* Bdb/emit.scm 97 */
					obj_t arg1582_842;
					arg1582_842 =
					   CNST_TABLE_REF(((long) 3));
					{	/* Bdb/emit.scm 97 */
					   obj_t list1584_844;
					   {	/* Bdb/emit.scm 97 */
					      obj_t arg1585_845;
					      {		/* Bdb/emit.scm 97 */
						 obj_t aux_1705;
						 {	/* Bdb/emit.scm 97 */
						    global_bglt obj_1418;
						    obj_1418 =
						       (global_bglt) (global_35);
						    aux_1705 =
						       (((global_bglt) CREF(obj_1418))->module);
						 }
						 arg1585_845 =
						    MAKE_PAIR(aux_1705, BNIL);
					      }
					      list1584_844 =
						 MAKE_PAIR(arg1582_842, arg1585_845);
					   }
					   id_831 =
					      symbol_append_197___r4_symbols_6_4(list1584_844);
					}
				     }
				   else
				     {	/* Bdb/emit.scm 96 */
					id_831 = id_840;
				     }
				}
			     }
			     {	/* Bdb/emit.scm 99 */
				bool_t test1586_846;
				test1586_846 =
				   is_a__118___object(clo_827, global_ast_var);
				if (test1586_846)
				  {	/* Bdb/emit.scm 100 */
				     global_bglt obj_1420;
				     obj_1420 =
					(global_bglt) (clo_827);
				     val_name_6_832 =
					(((global_bglt) CREF(obj_1420))->name);
				  }
				else
				  {	/* Bdb/emit.scm 99 */
				     val_name_6_832 =
					BINT(((long) 0));
				  }
			     }
			     {	/* Bdb/emit.scm 102 */
				global_bglt obj_1421;
				obj_1421 =
				   (global_bglt) (global_35);
				bp_name_229_833 =
				   (((global_bglt) CREF(obj_1421))->name);
			     }
			     {	/* Bdb/emit.scm 103 */
				obj_t port1455_834;
				port1455_834 = _c_port__188_bdb_emit;
				display_2_122___r4_output_6_10_3(string1742_bdb_emit, port1455_834);
				display_2_122___r4_output_6_10_3(fname_829, port1455_834);
				display_2_122___r4_output_6_10_3(string1751_bdb_emit, port1455_834);
				display_2_122___r4_output_6_10_3(lnum_830, port1455_834);
				display_2_122___r4_output_6_10_3(string1748_bdb_emit, port1455_834);
				WRITE_CHAR(((unsigned char) '\n'), port1455_834);
			     }
			     {	/* Bdb/emit.scm 104 */
				obj_t port1456_835;
				port1456_835 = _c_port__188_bdb_emit;
				display_2_122___r4_output_6_10_3(string1742_bdb_emit, port1456_835);
				display_2_122___r4_output_6_10_3(id_831, port1456_835);
				display_2_122___r4_output_6_10_3(string1752_bdb_emit, port1456_835);
				WRITE_CHAR(((unsigned char) '\n'), port1456_835);
			     }
			     {	/* Bdb/emit.scm 105 */
				bool_t test_1728;
				if (
				   INTEGERP(val_name_6_832))
				  {	/* ./Ieee/number.scm 6283 */
				     test_1728 = ((bool_t) 1)
					;
				  }
				else
				  {	/* ./Ieee/number.scm 6283 */
				     test_1728 =
					REALP(val_name_6_832)
					;
				  }
				if (test_1728)
				  {	/* Bdb/emit.scm 107 */
				     obj_t port1458_837;
				     port1458_837 = _c_port__188_bdb_emit;
				     display_2_122___r4_output_6_10_3(string1753_bdb_emit, port1458_837);
				     display_2_122___r4_output_6_10_3(val_name_6_832, port1458_837);
				     display_2_122___r4_output_6_10_3(string1754_bdb_emit, port1458_837);
				     display_2_122___r4_output_6_10_3(bp_name_229_833, port1458_837);
				     display_2_122___r4_output_6_10_3(string1755_bdb_emit, port1458_837);
				     WRITE_CHAR(((unsigned char) '\n'), port1458_837);
				  }
				else
				  {	/* Bdb/emit.scm 106 */
				     obj_t port1457_838;
				     port1457_838 = _c_port__188_bdb_emit;
				     display_2_122___r4_output_6_10_3(string1742_bdb_emit, port1457_838);
				     display_2_122___r4_output_6_10_3(val_name_6_832, port1457_838);
				     display_2_122___r4_output_6_10_3(string1743_bdb_emit, port1457_838);
				     display_2_122___r4_output_6_10_3(bp_name_229_833, port1457_838);
				     display_2_122___r4_output_6_10_3(string1755_bdb_emit, port1457_838);
				     WRITE_CHAR(((unsigned char) '\n'), port1457_838);
				  }
			     }
			     bdb_sfun__59_bdb_emit(sfun_825);
			     {	/* Bdb/emit.scm 109 */
				obj_t port1459_839;
				port1459_839 = _c_port__188_bdb_emit;
				display_2_122___r4_output_6_10_3(string1756_bdb_emit, port1459_839);
				{	/* ./Ieee/output.scm 9332 */
				   unsigned char aux_1746;
				   aux_1746 =
				      WRITE_CHAR(((unsigned char) '\n'), port1459_839);
				   return
				      BCHAR(aux_1746);
				}
			     }
			  }
		       }
		     else
		       {	/* Bdb/emit.scm 89 */
			  return BUNSPEC;
		       }
		  }
	       }
	    }
	 }
      }
   }
}



/* bdb-global-svar! */
obj_t 
bdb_global_svar__1_bdb_emit(obj_t global_36)
{
   AN_OBJECT;
   {	/* Bdb/emit.scm 114 */
      {		/* Bdb/emit.scm 115 */
	 obj_t svar_loc_189_849;
	 {	/* Bdb/emit.scm 116 */
	    svar_bglt obj_1433;
	    {	/* Bdb/emit.scm 116 */
	       value_bglt aux_1749;
	       {	/* Bdb/emit.scm 115 */
		  global_bglt obj_1432;
		  obj_1432 =
		     (global_bglt) (global_36);
		  aux_1749 =
		     (((global_bglt) CREF(obj_1432))->value);
	       }
	       obj_1433 =
		  (svar_bglt) (aux_1749);
	    }
	    svar_loc_189_849 =
	       (((svar_bglt) CREF(obj_1433))->loc);
	 }
	 {	/* Bdb/emit.scm 116 */

	    {	/* Bdb/emit.scm 117 */
	       bool_t test_1754;
	       if (
		  STRUCTP(svar_loc_189_849))
		 {	/* ./Ieee/equiv.scm 5508 */
		    obj_t aux_1759;
		    obj_t aux_1757;
		    aux_1759 =
		       CNST_TABLE_REF(((long) 0));
		    aux_1757 =
		       STRUCT_KEY(svar_loc_189_849);
		    test_1754 =
		       (aux_1757 == aux_1759);
		 }
	       else
		 {	/* ./Tools/location.sch 587 */
		    test_1754 = ((bool_t) 0)
		       ;
		 }
	       if (test_1754)
		 {	/* Bdb/emit.scm 117 */
		    set_variable_name__102_cgen_prototype(global_36);
		    {	/* Bdb/emit.scm 120 */
		       obj_t fname_851;
		       obj_t lnum_852;
		       obj_t id_853;
		       obj_t name_854;
		       fname_851 =
			  STRUCT_REF(svar_loc_189_849, ((long) 0));
		       lnum_852 =
			  STRUCT_REF(svar_loc_189_849, ((long) 2));
		       {	/* Bdb/emit.scm 122 */
			  global_bglt obj_1448;
			  obj_1448 =
			     (global_bglt) (global_36);
			  id_853 =
			     (((global_bglt) CREF(obj_1448))->id);
		       }
		       {	/* Bdb/emit.scm 123 */
			  global_bglt obj_1449;
			  obj_1449 =
			     (global_bglt) (global_36);
			  name_854 =
			     (((global_bglt) CREF(obj_1449))->name);
		       }
		       {	/* Bdb/emit.scm 124 */
			  obj_t port1460_855;
			  port1460_855 = _c_port__188_bdb_emit;
			  display_2_122___r4_output_6_10_3(string1742_bdb_emit, port1460_855);
			  display_2_122___r4_output_6_10_3(fname_851, port1460_855);
			  display_2_122___r4_output_6_10_3(string1751_bdb_emit, port1460_855);
			  display_2_122___r4_output_6_10_3(lnum_852, port1460_855);
			  display_2_122___r4_output_6_10_3(string1748_bdb_emit, port1460_855);
			  WRITE_CHAR(((unsigned char) '\n'), port1460_855);
		       }
		       {	/* Bdb/emit.scm 125 */
			  obj_t port1461_856;
			  port1461_856 = _c_port__188_bdb_emit;
			  display_2_122___r4_output_6_10_3(string1742_bdb_emit, port1461_856);
			  display_2_122___r4_output_6_10_3(id_853, port1461_856);
			  display_2_122___r4_output_6_10_3(string1743_bdb_emit, port1461_856);
			  display_2_122___r4_output_6_10_3(name_854, port1461_856);
			  display_2_122___r4_output_6_10_3(string1755_bdb_emit, port1461_856);
			  {	/* ./Ieee/output.scm 9332 */
			     unsigned char aux_1780;
			     aux_1780 =
				WRITE_CHAR(((unsigned char) '\n'), port1461_856);
			     return
				BCHAR(aux_1780);
			  }
		       }
		    }
		 }
	       else
		 {	/* Bdb/emit.scm 117 */
		    return BUNSPEC;
		 }
	    }
	 }
      }
   }
}



/* bdb-sfun! */
obj_t 
bdb_sfun__59_bdb_emit(value_bglt sfun_37)
{
   AN_OBJECT;
   {	/* Bdb/emit.scm 130 */
      {
	 obj_t l1463_858;
	 {	/* Bdb/emit.scm 132 */
	    sfun_bglt obj_1452;
	    obj_1452 =
	       (sfun_bglt) (sfun_37);
	    l1463_858 =
	       (((sfun_bglt) CREF(obj_1452))->args);
	 }
       lname1464_859:
	 if (
	    PAIRP(l1463_858))
	   {	/* Bdb/emit.scm 132 */
	      bdb_emit_local_info__83_bdb_emit(
		 CAR(l1463_858));
	      {
		 obj_t l1463_1787;
		 l1463_1787 =
		    CDR(l1463_858);
		 l1463_858 = l1463_1787;
		 goto lname1464_859;
	      }
	   }
	 else
	   {	/* Bdb/emit.scm 132 */
	      ((bool_t) 1);
	   }
      }
      {		/* Bdb/emit.scm 133 */
	 node_bglt aux_1791;
	 {	/* Bdb/emit.scm 133 */
	    obj_t aux_1792;
	    {	/* Bdb/emit.scm 133 */
	       sfun_bglt obj_1456;
	       obj_1456 =
		  (sfun_bglt) (sfun_37);
	       aux_1792 =
		  (((sfun_bglt) CREF(obj_1456))->body);
	    }
	    aux_1791 =
	       (node_bglt) (aux_1792);
	 }
	 return
	    bdb__20_bdb_emit(aux_1791);
      }
   }
}



/* bdb-local-variable? */
bool_t 
bdb_local_variable__9_bdb_emit(obj_t local_38)
{
   AN_OBJECT;
   {	/* Bdb/emit.scm 145 */
      {
	 obj_t local_867;
	 {	/* Bdb/emit.scm 159 */
	    bool_t test_1797;
	    {	/* Bdb/emit.scm 159 */
	       local_bglt obj_1457;
	       obj_1457 =
		  (local_bglt) (local_38);
	       test_1797 =
		  (((local_bglt) CREF(obj_1457))->user__32);
	    }
	    if (test_1797)
	      {		/* Bdb/emit.scm 159 */
		 local_867 = local_38;
		 {	/* Bdb/emit.scm 149 */
		    type_bglt t_869;
		    {	/* Bdb/emit.scm 149 */
		       local_bglt obj_1458;
		       obj_1458 =
			  (local_bglt) (local_867);
		       t_869 =
			  (((local_bglt) CREF(obj_1458))->type);
		    }
		    {	/* Bdb/emit.scm 150 */
		       bool_t _ortest_1465_870;
		       {	/* ./Ieee/equiv.scm 5508 */
			  obj_t aux_1804;
			  obj_t aux_1802;
			  aux_1804 =
			     CNST_TABLE_REF(((long) 4));
			  aux_1802 =
			     (((type_bglt) CREF(t_869))->class);
			  _ortest_1465_870 =
			     (aux_1802 == aux_1804);
		       }
		       if (_ortest_1465_870)
			 {	/* Bdb/emit.scm 150 */
			    return _ortest_1465_870;
			 }
		       else
			 {	/* Bdb/emit.scm 151 */
			    bool_t _ortest_1466_871;
			    {	/* Bdb/emit.scm 151 */
			       obj_t obj2_1463;
			       obj2_1463 = _int__35_type_cache;
			       {	/* ./Ieee/equiv.scm 5508 */
				  obj_t aux_1808;
				  aux_1808 =
				     (obj_t) (t_869);
				  _ortest_1466_871 =
				     (aux_1808 == obj2_1463);
			       }
			    }
			    if (_ortest_1466_871)
			      {		/* Bdb/emit.scm 151 */
				 return _ortest_1466_871;
			      }
			    else
			      {		/* Bdb/emit.scm 152 */
				 bool_t _ortest_1467_872;
				 {	/* Bdb/emit.scm 152 */
				    obj_t obj2_1465;
				    obj2_1465 = _long__149_type_cache;
				    {	/* ./Ieee/equiv.scm 5508 */
				       obj_t aux_1812;
				       aux_1812 =
					  (obj_t) (t_869);
				       _ortest_1467_872 =
					  (aux_1812 == obj2_1465);
				    }
				 }
				 if (_ortest_1467_872)
				   {	/* Bdb/emit.scm 152 */
				      return _ortest_1467_872;
				   }
				 else
				   {	/* Bdb/emit.scm 153 */
				      bool_t _ortest_1468_873;
				      {		/* Bdb/emit.scm 153 */
					 obj_t obj2_1467;
					 obj2_1467 = _bool__149_type_cache;
					 {	/* ./Ieee/equiv.scm 5508 */
					    obj_t aux_1816;
					    aux_1816 =
					       (obj_t) (t_869);
					    _ortest_1468_873 =
					       (aux_1816 == obj2_1467);
					 }
				      }
				      if (_ortest_1468_873)
					{	/* Bdb/emit.scm 153 */
					   return _ortest_1468_873;
					}
				      else
					{	/* Bdb/emit.scm 154 */
					   bool_t _ortest_1469_874;
					   {	/* Bdb/emit.scm 154 */
					      obj_t obj2_1469;
					      obj2_1469 = _real__144_type_cache;
					      {		/* ./Ieee/equiv.scm 5508 */
						 obj_t aux_1820;
						 aux_1820 =
						    (obj_t) (t_869);
						 _ortest_1469_874 =
						    (aux_1820 == obj2_1469);
					      }
					   }
					   if (_ortest_1469_874)
					     {	/* Bdb/emit.scm 154 */
						return _ortest_1469_874;
					     }
					   else
					     {	/* Bdb/emit.scm 155 */
						bool_t _ortest_1470_875;
						{	/* Bdb/emit.scm 155 */
						   obj_t obj2_1471;
						   obj2_1471 = _char__84_type_cache;
						   {	/* ./Ieee/equiv.scm 5508 */
						      obj_t aux_1824;
						      aux_1824 =
							 (obj_t) (t_869);
						      _ortest_1470_875 =
							 (aux_1824 == obj2_1471);
						   }
						}
						if (_ortest_1470_875)
						  {	/* Bdb/emit.scm 155 */
						     return _ortest_1470_875;
						  }
						else
						  {	/* Bdb/emit.scm 156 */
						     obj_t obj2_1473;
						     obj2_1473 = _string__3_type_cache;
						     {	/* ./Ieee/equiv.scm 5508 */
							obj_t aux_1828;
							aux_1828 =
							   (obj_t) (t_869);
							return
							   (aux_1828 == obj2_1473);
						     }
						  }
					     }
					}
				   }
			      }
			 }
		    }
		 }
	      }
	    else
	      {		/* Bdb/emit.scm 159 */
		 return ((bool_t) 0);
	      }
	 }
      }
   }
}



/* bdb-emit-local-info! */
obj_t 
bdb_emit_local_info__83_bdb_emit(obj_t local_39)
{
   AN_OBJECT;
   {	/* Bdb/emit.scm 164 */
      if (
	 bdb_local_variable__9_bdb_emit(local_39))
	{	/* Bdb/emit.scm 165 */
	   set_variable_name__102_cgen_prototype(local_39);
	   {	/* Bdb/emit.scm 168 */
	      obj_t id_880;
	      obj_t name_881;
	      {		/* Bdb/emit.scm 168 */
		 local_bglt obj_1474;
		 obj_1474 =
		    (local_bglt) (local_39);
		 id_880 =
		    (((local_bglt) CREF(obj_1474))->id);
	      }
	      {		/* Bdb/emit.scm 169 */
		 local_bglt obj_1475;
		 obj_1475 =
		    (local_bglt) (local_39);
		 name_881 =
		    (((local_bglt) CREF(obj_1475))->name);
	      }
	      {		/* Bdb/emit.scm 170 */
		 obj_t port1472_882;
		 port1472_882 = _c_port__188_bdb_emit;
		 display_2_122___r4_output_6_10_3(string1757_bdb_emit, port1472_882);
		 display_2_122___r4_output_6_10_3(id_880, port1472_882);
		 display_2_122___r4_output_6_10_3(string1743_bdb_emit, port1472_882);
		 display_2_122___r4_output_6_10_3(name_881, port1472_882);
		 display_2_122___r4_output_6_10_3(string1755_bdb_emit, port1472_882);
		 {	/* ./Ieee/output.scm 9332 */
		    unsigned char aux_1843;
		    aux_1843 =
		       WRITE_CHAR(((unsigned char) '\n'), port1472_882);
		    return
		       BCHAR(aux_1843);
		 }
	      }
	   }
	}
      else
	{	/* Bdb/emit.scm 165 */
	   return BUNSPEC;
	}
   }
}



/* bdb*! */
obj_t 
bdb___160_bdb_emit(obj_t nodes_57)
{
   AN_OBJECT;
   {	/* Bdb/emit.scm 302 */
      {
	 obj_t hook_883;
	 hook_883 = nodes_57;
       loop_884:
	 if (
	    NULLP(hook_883))
	   {	/* Bdb/emit.scm 304 */
	      return
		 CNST_TABLE_REF(((long) 5));
	   }
	 else
	   {	/* Bdb/emit.scm 304 */
	      {		/* Bdb/emit.scm 307 */
		 node_bglt aux_1849;
		 {	/* Bdb/emit.scm 307 */
		    obj_t aux_1850;
		    aux_1850 =
		       CAR(hook_883);
		    aux_1849 =
		       (node_bglt) (aux_1850);
		 }
		 bdb__20_bdb_emit(aux_1849);
	      }
	      {
		 obj_t hook_1854;
		 hook_1854 =
		    CDR(hook_883);
		 hook_883 = hook_1854;
		 goto loop_884;
	      }
	   }
      }
   }
}



/* method-init */
obj_t 
method_init_76_bdb_emit()
{
   AN_OBJECT;
   {	/* Bdb/emit.scm 14 */
      add_generic__110___object(bdb__env_49_bdb_emit, bdb__default1496_env_230_bdb_emit);
      add_inlined_method__244___object(bdb__env_49_bdb_emit, sequence_ast_node, ((long) 0));
      add_inlined_method__244___object(bdb__env_49_bdb_emit, pragma_ast_node, ((long) 1));
      add_inlined_method__244___object(bdb__env_49_bdb_emit, cast_ast_node, ((long) 2));
      add_inlined_method__244___object(bdb__env_49_bdb_emit, setq_ast_node, ((long) 3));
      add_inlined_method__244___object(bdb__env_49_bdb_emit, conditional_ast_node, ((long) 4));
      add_inlined_method__244___object(bdb__env_49_bdb_emit, fail_ast_node, ((long) 5));
      add_inlined_method__244___object(bdb__env_49_bdb_emit, select_ast_node, ((long) 6));
      add_inlined_method__244___object(bdb__env_49_bdb_emit, let_fun_218_ast_node, ((long) 7));
      add_inlined_method__244___object(bdb__env_49_bdb_emit, let_var_6_ast_node, ((long) 8));
      add_inlined_method__244___object(bdb__env_49_bdb_emit, set_ex_it_116_ast_node, ((long) 9));
      add_inlined_method__244___object(bdb__env_49_bdb_emit, jump_ex_it_184_ast_node, ((long) 10));
      add_inlined_method__244___object(bdb__env_49_bdb_emit, make_box_202_ast_node, ((long) 11));
      add_inlined_method__244___object(bdb__env_49_bdb_emit, box_set__221_ast_node, ((long) 12));
      add_inlined_method__244___object(bdb__env_49_bdb_emit, app_ly_162_ast_node, ((long) 13));
      add_inlined_method__244___object(bdb__env_49_bdb_emit, funcall_ast_node, ((long) 14));
      {		/* Bdb/emit.scm 14 */
	 long aux_1872;
	 aux_1872 =
	    add_inlined_method__244___object(bdb__env_49_bdb_emit, app_ast_node, ((long) 15));
	 return
	    BINT(aux_1872);
      }
   }
}



/* bdb! */
obj_t 
bdb__20_bdb_emit(node_bglt node_40)
{
   AN_OBJECT;
   {	/* Bdb/emit.scm 175 */
    bdb__20_bdb_emit:
      {
	 obj_t method1677_1227;
	 obj_t class1682_1228;
	 {	/* Bdb/emit.scm 175 */
	    obj_t arg1685_1225;
	    obj_t arg1686_1226;
	    {	/* Bdb/emit.scm 175 */
	       object_bglt obj_1480;
	       obj_1480 =
		  (object_bglt) (node_40);
	       {	/* ./Llib/object.scm 2926 */
		  obj_t pre_method_105_1481;
		  pre_method_105_1481 =
		     PROCEDURE_REF(bdb__env_49_bdb_emit, ((long) 2));
		  if (
		     INTEGERP(pre_method_105_1481))
		    {	/* ./Llib/object.scm 2927 */
		       PROCEDURE_SET(bdb__env_49_bdb_emit, ((long) 2), BUNSPEC);
		       arg1685_1225 = pre_method_105_1481;
		    }
		  else
		    {	/* ./Llib/object.scm 2914 */
		       long obj_class_num_177_1486;
		       obj_class_num_177_1486 =
			  TYPE(obj_1480);
		       {	/* ./Llib/object.scm 2915 */
			  obj_t arg1176_1487;
			  arg1176_1487 =
			     PROCEDURE_REF(bdb__env_49_bdb_emit, ((long) 1));
			  {	/* ./Llib/object.scm 2738 */
			     long arg1177_1491;
			     {	/* ./Llib/object.scm 2738 */
				long arg1178_1492;
				arg1178_1492 =
				   OBJECT_TYPE;
				arg1177_1491 =
				   (obj_class_num_177_1486 - arg1178_1492);
			     }
			     arg1685_1225 =
				VECTOR_REF(arg1176_1487, arg1177_1491);
			  }
		       }
		    }
	       }
	    }
	    {	/* Bdb/emit.scm 175 */
	       object_bglt object_1497;
	       object_1497 =
		  (object_bglt) (node_40);
	       {	/* ./Llib/object.scm 2695 */
		  long arg1179_1498;
		  {	/* ./Llib/object.scm 2695 */
		     long arg1180_1499;
		     long arg1181_1500;
		     arg1180_1499 =
			TYPE(object_1497);
		     arg1181_1500 =
			OBJECT_TYPE;
		     arg1179_1498 =
			(arg1180_1499 - arg1181_1500);
		  }
		  {	/* ./Llib/object.scm 2695 */
		     obj_t vector_1504;
		     vector_1504 = _classes__134___object;
		     arg1686_1226 =
			VECTOR_REF(vector_1504, arg1179_1498);
		  }
	       }
	    }
	    method1677_1227 = arg1685_1225;
	    class1682_1228 = arg1686_1226;
	    {

	       if (
		  INTEGERP(method1677_1227))
		 {	/* Bdb/emit.scm 175 */
		    switch (
		       (long) CINT(method1677_1227))
		      {
		      case ((long) 0):

			 {	/* Bdb/emit.scm 182 */
			    sequence_bglt node_1234;
			    node_1234 =
			       (sequence_bglt) (node_40);
			    return
			       bdb___160_bdb_emit(
			       (((sequence_bglt) CREF(node_1234))->nodes));
			 }
			 break;
		      case ((long) 1):

			 {	/* Bdb/emit.scm 189 */
			    pragma_bglt node_1237;
			    node_1237 =
			       (pragma_bglt) (node_40);
			    return
			       bdb___160_bdb_emit(
			       (((pragma_bglt) CREF(node_1237))->args));
			 }
			 break;
		      case ((long) 2):

			 {	/* Bdb/emit.scm 196 */
			    cast_bglt node_1240;
			    node_1240 =
			       (cast_bglt) (node_40);
			    {
			       node_bglt node_1899;
			       node_1899 =
				  (((cast_bglt) CREF(node_1240))->arg);
			       node_40 = node_1899;
			       goto bdb__20_bdb_emit;
			    }
			 }
			 break;
		      case ((long) 3):

			 {	/* Bdb/emit.scm 203 */
			    setq_bglt node_1243;
			    node_1243 =
			       (setq_bglt) (node_40);
			    {
			       node_bglt node_1902;
			       node_1902 =
				  (((setq_bglt) CREF(node_1243))->value);
			       node_40 = node_1902;
			       goto bdb__20_bdb_emit;
			    }
			 }
			 break;
		      case ((long) 4):

			 {	/* Bdb/emit.scm 210 */
			    conditional_bglt node_1246;
			    node_1246 =
			       (conditional_bglt) (node_40);
			    bdb__20_bdb_emit(
			       (((conditional_bglt) CREF(node_1246))->test));
			    bdb__20_bdb_emit(
			       (((conditional_bglt) CREF(node_1246))->true));
			    {
			       node_bglt node_1909;
			       node_1909 =
				  (((conditional_bglt) CREF(node_1246))->false);
			       node_40 = node_1909;
			       goto bdb__20_bdb_emit;
			    }
			 }
			 break;
		      case ((long) 5):

			 {	/* Bdb/emit.scm 219 */
			    fail_bglt node_1251;
			    node_1251 =
			       (fail_bglt) (node_40);
			    bdb__20_bdb_emit(
			       (((fail_bglt) CREF(node_1251))->proc));
			    bdb__20_bdb_emit(
			       (((fail_bglt) CREF(node_1251))->msg));
			    {
			       node_bglt node_1916;
			       node_1916 =
				  (((fail_bglt) CREF(node_1251))->obj);
			       node_40 = node_1916;
			       goto bdb__20_bdb_emit;
			    }
			 }
			 break;
		      case ((long) 6):

			 {	/* Bdb/emit.scm 228 */
			    select_bglt node_1256;
			    node_1256 =
			       (select_bglt) (node_40);
			    bdb__20_bdb_emit(
			       (((select_bglt) CREF(node_1256))->test));
			    {
			       obj_t l1480_1259;
			       {	/* Bdb/emit.scm 230 */
				  bool_t aux_1921;
				  l1480_1259 =
				     (((select_bglt) CREF(node_1256))->clauses);
				lname1481_1260:
				  if (
				     PAIRP(l1480_1259))
				    {	/* Bdb/emit.scm 230 */
				       {	/* Bdb/emit.scm 230 */
					  node_bglt aux_1924;
					  {	/* Bdb/emit.scm 230 */
					     obj_t aux_1925;
					     {	/* ./Ieee/pair-list.scm 5707 */
						obj_t aux_1926;
						aux_1926 =
						   CAR(l1480_1259);
						aux_1925 =
						   CDR(aux_1926);
					     }
					     aux_1924 =
						(node_bglt) (aux_1925);
					  }
					  bdb__20_bdb_emit(aux_1924);
				       }
				       {
					  obj_t l1480_1931;
					  l1480_1931 =
					     CDR(l1480_1259);
					  l1480_1259 = l1480_1931;
					  goto lname1481_1260;
				       }
				    }
				  else
				    {	/* Bdb/emit.scm 230 */
				       aux_1921 = ((bool_t) 1);
				    }
				  return
				     BBOOL(aux_1921);
			       }
			    }
			 }
			 break;
		      case ((long) 7):

			 {	/* Bdb/emit.scm 236 */
			    let_fun_218_bglt node_1266;
			    node_1266 =
			       (let_fun_218_bglt) (node_40);
			    {
			       obj_t l1483_1268;
			       l1483_1268 =
				  (((let_fun_218_bglt) CREF(node_1266))->locals);
			     lname1484_1269:
			       if (
				  PAIRP(l1483_1268))
				 {	/* Bdb/emit.scm 237 */
				    {	/* Bdb/emit.scm 238 */
				       value_bglt aux_1938;
				       {	/* Bdb/emit.scm 238 */
					  local_bglt obj_1525;
					  {	/* Bdb/emit.scm 238 */
					     obj_t aux_1939;
					     aux_1939 =
						CAR(l1483_1268);
					     obj_1525 =
						(local_bglt) (aux_1939);
					  }
					  aux_1938 =
					     (((local_bglt) CREF(obj_1525))->value);
				       }
				       bdb_sfun__59_bdb_emit(aux_1938);
				    }
				    {
				       obj_t l1483_1944;
				       l1483_1944 =
					  CDR(l1483_1268);
				       l1483_1268 = l1483_1944;
				       goto lname1484_1269;
				    }
				 }
			       else
				 {	/* Bdb/emit.scm 237 */
				    ((bool_t) 1);
				 }
			    }
			    {
			       node_bglt node_1947;
			       node_1947 =
				  (((let_fun_218_bglt) CREF(node_1266))->body);
			       node_40 = node_1947;
			       goto bdb__20_bdb_emit;
			    }
			 }
			 break;
		      case ((long) 8):

			 {	/* Bdb/emit.scm 246 */
			    let_var_6_bglt node_1276;
			    node_1276 =
			       (let_var_6_bglt) (node_40);
			    {
			       obj_t l1486_1278;
			       l1486_1278 =
				  (((let_var_6_bglt) CREF(node_1276))->bindings);
			     lname1487_1279:
			       if (
				  PAIRP(l1486_1278))
				 {	/* Bdb/emit.scm 247 */
				    {	/* Bdb/emit.scm 248 */
				       obj_t binding_1282;
				       binding_1282 =
					  CAR(l1486_1278);
				       {	/* Bdb/emit.scm 249 */
					  node_bglt aux_1953;
					  {	/* Bdb/emit.scm 249 */
					     obj_t aux_1954;
					     aux_1954 =
						CDR(binding_1282);
					     aux_1953 =
						(node_bglt) (aux_1954);
					  }
					  bdb__20_bdb_emit(aux_1953);
				       }
				       bdb_emit_local_info__83_bdb_emit(
					  CAR(binding_1282));
				    }
				    {
				       obj_t l1486_1960;
				       l1486_1960 =
					  CDR(l1486_1278);
				       l1486_1278 = l1486_1960;
				       goto lname1487_1279;
				    }
				 }
			       else
				 {	/* Bdb/emit.scm 247 */
				    ((bool_t) 1);
				 }
			    }
			    {
			       node_bglt node_1963;
			       node_1963 =
				  (((let_var_6_bglt) CREF(node_1276))->body);
			       node_40 = node_1963;
			       goto bdb__20_bdb_emit;
			    }
			 }
			 break;
		      case ((long) 9):

			 {	/* Bdb/emit.scm 258 */
			    set_ex_it_116_bglt node_1288;
			    node_1288 =
			       (set_ex_it_116_bglt) (node_40);
			    {
			       node_bglt node_1966;
			       node_1966 =
				  (((set_ex_it_116_bglt) CREF(node_1288))->body);
			       node_40 = node_1966;
			       goto bdb__20_bdb_emit;
			    }
			 }
			 break;
		      case ((long) 10):

			 {	/* Bdb/emit.scm 265 */
			    jump_ex_it_184_bglt node_1291;
			    node_1291 =
			       (jump_ex_it_184_bglt) (node_40);
			    bdb__20_bdb_emit(
			       (((jump_ex_it_184_bglt) CREF(node_1291))->exit));
			    {
			       node_bglt node_1971;
			       node_1971 =
				  (((jump_ex_it_184_bglt) CREF(node_1291))->value);
			       node_40 = node_1971;
			       goto bdb__20_bdb_emit;
			    }
			 }
			 break;
		      case ((long) 11):

			 {	/* Bdb/emit.scm 273 */
			    make_box_202_bglt node_1295;
			    node_1295 =
			       (make_box_202_bglt) (node_40);
			    {
			       node_bglt node_1974;
			       node_1974 =
				  (((make_box_202_bglt) CREF(node_1295))->value);
			       node_40 = node_1974;
			       goto bdb__20_bdb_emit;
			    }
			 }
			 break;
		      case ((long) 12):

			 {	/* Bdb/emit.scm 280 */
			    box_set__221_bglt node_1298;
			    node_1298 =
			       (box_set__221_bglt) (node_40);
			    {
			       node_bglt node_1977;
			       node_1977 =
				  (((box_set__221_bglt) CREF(node_1298))->value);
			       node_40 = node_1977;
			       goto bdb__20_bdb_emit;
			    }
			 }
			 break;
		      case ((long) 13):

			 {	/* Bdb/emit.scm 287 */
			    app_ly_162_bglt node_1301;
			    node_1301 =
			       (app_ly_162_bglt) (node_40);
			    bdb__20_bdb_emit(
			       (((app_ly_162_bglt) CREF(node_1301))->fun));
			    {
			       node_bglt node_1982;
			       node_1982 =
				  (((app_ly_162_bglt) CREF(node_1301))->arg);
			       node_40 = node_1982;
			       goto bdb__20_bdb_emit;
			    }
			 }
			 break;
		      case ((long) 14):

			 {	/* Bdb/emit.scm 295 */
			    funcall_bglt node_1305;
			    node_1305 =
			       (funcall_bglt) (node_40);
			    bdb__20_bdb_emit(
			       (((funcall_bglt) CREF(node_1305))->fun));
			    return
			       bdb___160_bdb_emit(
			       (((funcall_bglt) CREF(node_1305))->args));
			 }
			 break;
		      case ((long) 15):

			 {	/* Bdb/emit.scm 314 */
			    app_bglt node_1309;
			    node_1309 =
			       (app_bglt) (node_40);
			    return
			       bdb___160_bdb_emit(
			       (((app_bglt) CREF(node_1309))->args));
			 }
			 break;
		      default:
		       case_else1683_1231:
			 if (
			    PROCEDUREP(method1677_1227))
			   {	/* Bdb/emit.scm 175 */
			      return
				 PROCEDURE_ENTRY(method1677_1227) (method1677_1227,
				 (obj_t) (node_40), BEOA);
			   }
			 else
			   {	/* Bdb/emit.scm 175 */
			      obj_t fun1675_1223;
			      fun1675_1223 =
				 PROCEDURE_REF(bdb__env_49_bdb_emit, ((long) 0));
			      return
				 PROCEDURE_ENTRY(fun1675_1223) (fun1675_1223,
				 (obj_t) (node_40), BEOA);
			   }
		      }
		 }
	       else
		 {	/* Bdb/emit.scm 175 */
		    goto case_else1683_1231;
		 }
	    }
	 }
      }
   }
}



/* _bdb!1735 */
obj_t 
_bdb_1735_70_bdb_emit(obj_t env_1554, obj_t node_1555)
{
   AN_OBJECT;
   {	/* Bdb/emit.scm 175 */
      return
	 bdb__20_bdb_emit(
	 (node_bglt) (node_1555));
   }
}



/* bdb!-default1496 */
obj_t 
bdb__default1496_39_bdb_emit(node_bglt node_41)
{
   AN_OBJECT;
   {	/* Bdb/emit.scm 14 */
      return BUNSPEC;
   }
}



/* _bdb!-default1496 */
obj_t 
_bdb__default1496_171_bdb_emit(obj_t env_1556, obj_t node_1557)
{
   AN_OBJECT;
   {	/* Bdb/emit.scm 14 */
      return
	 bdb__default1496_39_bdb_emit(
	 (node_bglt) (node_1557));
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_bdb_emit()
{
   AN_OBJECT;
   {	/* Bdb/emit.scm 14 */
      module_initialization_70_type_type(((long) 0), "BDB_EMIT");
      module_initialization_70_ast_var(((long) 0), "BDB_EMIT");
      module_initialization_70_ast_node(((long) 0), "BDB_EMIT");
      module_initialization_70_tools_shape(((long) 0), "BDB_EMIT");
      module_initialization_70_tools_error(((long) 0), "BDB_EMIT");
      module_initialization_70_tools_misc(((long) 0), "BDB_EMIT");
      module_initialization_70_tools_location(((long) 0), "BDB_EMIT");
      module_initialization_70_type_env(((long) 0), "BDB_EMIT");
      module_initialization_70_type_cache(((long) 0), "BDB_EMIT");
      module_initialization_70_ast_sexp(((long) 0), "BDB_EMIT");
      module_initialization_70_ast_env(((long) 0), "BDB_EMIT");
      module_initialization_70_ast_ident(((long) 0), "BDB_EMIT");
      module_initialization_70_ast_unit(((long) 0), "BDB_EMIT");
      module_initialization_70_module_module(((long) 0), "BDB_EMIT");
      module_initialization_70_module_include(((long) 0), "BDB_EMIT");
      module_initialization_70_engine_param(((long) 0), "BDB_EMIT");
      return
	 module_initialization_70_cgen_prototype(((long) 0), "BDB_EMIT");
   }
}
