/*===========================================================================*/
/*   (Bdb/initialize.scm)                                                    */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct ccomp
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t producer;
     obj_t consumer;
     obj_t finalizer;
     obj_t checksummer;
  }
     *ccomp_bglt;

typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;


static obj_t method_init_76_bdb_initialize();
extern obj_t create_struct(obj_t, long);
extern obj_t module_initialization_70_bdb_initialize(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_speek(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_module_module(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_ast_env(long, char *);
extern obj_t module_initialization_70_ast_build(long, char *);
extern obj_t module_initialization_70_ast_lvtype(long, char *);
extern obj_t module_initialization_70_ast_glo_def_117(long, char *);
extern obj_t module_initialization_70_coerce_coerce(long, char *);
extern obj_t module_initialization_70_cnst_alloc(long, char *);
extern obj_t module_initialization_70_cnst_node(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
static obj_t imported_modules_init_94_bdb_initialize();
static obj_t _initialize_ast_73_bdb_initialize(obj_t);
extern node_bglt coerce__182_coerce_coerce(node_bglt, type_bglt);
static obj_t library_modules_init_112_bdb_initialize();
static obj_t toplevel_init_63_bdb_initialize();
extern obj_t build_ast_197_ast_build(obj_t);
extern obj_t open_input_string(obj_t);
extern obj_t initialize_ast_128_bdb_initialize();
extern obj_t _module__166_module_module;
extern obj_t read___reader(obj_t);
static obj_t require_initialization_114_bdb_initialize = BUNSPEC;
static obj_t cnst_init_137_bdb_initialize();
static obj_t __cnst[5];

DEFINE_EXPORT_PROCEDURE(initialize_ast_env_80_bdb_initialize, _initialize_ast_73_bdb_initialize1567, _initialize_ast_73_bdb_initialize, 0L, 0);
DEFINE_STRING(string1562_bdb_initialize, string1562_bdb_initialize1568, "UNIT BDB PRAGMA::OBJ QUOTE BDB-SET-MODULE-INFO! ", 48);
DEFINE_STRING(string1561_bdb_initialize, string1561_bdb_initialize1569, "((obj_t)__bdb_info)", 19);



/* module-initialization */
obj_t 
module_initialization_70_bdb_initialize(long checksum_1186, char *from_1187)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_bdb_initialize))
	{
	   require_initialization_114_bdb_initialize =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_bdb_initialize();
	   cnst_init_137_bdb_initialize();
	   imported_modules_init_94_bdb_initialize();
	   method_init_76_bdb_initialize();
	   toplevel_init_63_bdb_initialize();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_bdb_initialize()
{
   AN_OBJECT;
   {	/* Bdb/initialize.scm 14 */
      module_initialization_70___reader(((long) 0), "BDB_INITIALIZE");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_bdb_initialize()
{
   AN_OBJECT;
   {	/* Bdb/initialize.scm 14 */
      {		/* Bdb/initialize.scm 14 */
	 obj_t cnst_port_138_1179;
	 cnst_port_138_1179 =
	    open_input_string(string1562_bdb_initialize);
	 {
	    long i_1180;
	    i_1180 = ((long) 4);
	  loop_1181:
	    {	/* Bdb/initialize.scm 14 */
	       bool_t test1563_1182;
	       test1563_1182 =
		  (i_1180 == ((long) -1));
	       if (test1563_1182)
		 {	/* Bdb/initialize.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Bdb/initialize.scm 14 */
		    {	/* Bdb/initialize.scm 14 */
		       obj_t arg1564_1183;
		       {	/* Bdb/initialize.scm 14 */
			  obj_t list1565_1184;
			  list1565_1184 =
			     MAKE_PAIR(cnst_port_138_1179, BNIL);
			  arg1564_1183 =
			     read___reader(list1565_1184);
		       }
		       CNST_TABLE_SET(i_1180, arg1564_1183);
		    }
		    {	/* Bdb/initialize.scm 14 */
		       int aux_1185;
		       {	/* Bdb/initialize.scm 14 */
			  long aux_1203;
			  aux_1203 =
			     (i_1180 - ((long) 1));
			  aux_1185 =
			     (int) (aux_1203);
		       }
		       {
			  long i_1206;
			  i_1206 =
			     (long) (aux_1185);
			  i_1180 = i_1206;
			  goto loop_1181;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_bdb_initialize()
{
   AN_OBJECT;
   {	/* Bdb/initialize.scm 14 */
      return BUNSPEC;
   }
}



/* initialize-ast */
obj_t 
initialize_ast_128_bdb_initialize()
{
   AN_OBJECT;
   {	/* Bdb/initialize.scm 41 */
      {		/* Bdb/initialize.scm 43 */
	 obj_t body_735;
	 {	/* Bdb/initialize.scm 43 */
	    obj_t arg1464_748;
	    {	/* Bdb/initialize.scm 43 */
	       obj_t arg1467_750;
	       obj_t arg1469_751;
	       arg1467_750 =
		  CNST_TABLE_REF(((long) 0));
	       {	/* Bdb/initialize.scm 43 */
		  obj_t arg1470_752;
		  obj_t arg1471_753;
		  {	/* Bdb/initialize.scm 43 */
		     obj_t arg1472_754;
		     obj_t arg1473_755;
		     arg1472_754 =
			CNST_TABLE_REF(((long) 1));
		     {	/* Bdb/initialize.scm 43 */
			obj_t obj1_1129;
			obj1_1129 = _module__166_module_module;
			arg1473_755 =
			   MAKE_PAIR(obj1_1129, BNIL);
		     }
		     arg1470_752 =
			MAKE_PAIR(arg1472_754, arg1473_755);
		  }
		  {	/* Bdb/initialize.scm 44 */
		     obj_t arg1474_756;
		     {	/* Bdb/initialize.scm 44 */
			obj_t arg1476_758;
			obj_t arg1477_759;
			arg1476_758 =
			   CNST_TABLE_REF(((long) 2));
			arg1477_759 =
			   MAKE_PAIR(string1561_bdb_initialize, BNIL);
			arg1474_756 =
			   MAKE_PAIR(arg1476_758, arg1477_759);
		     }
		     arg1471_753 =
			MAKE_PAIR(arg1474_756, BNIL);
		  }
		  arg1469_751 =
		     MAKE_PAIR(arg1470_752, arg1471_753);
	       }
	       arg1464_748 =
		  MAKE_PAIR(arg1467_750, arg1469_751);
	    }
	    body_735 =
	       MAKE_PAIR(arg1464_748, BNIL);
	 }
	 {	/* Bdb/initialize.scm 45 */
	    obj_t unit_736;
	    {	/* Bdb/initialize.scm 45 */
	       obj_t id_1145;
	       id_1145 =
		  CNST_TABLE_REF(((long) 3));
	       {	/* ./Ast/unit.sch 338 */
		  obj_t new_1149;
		  {	/* ./Ast/unit.sch 338 */
		     obj_t aux_1220;
		     aux_1220 =
			CNST_TABLE_REF(((long) 4));
		     new_1149 =
			create_struct(aux_1220, ((long) 4));
		  }
		  STRUCT_SET(new_1149, ((long) 3), BTRUE);
		  STRUCT_SET(new_1149, ((long) 2), body_735);
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_1225;
		     aux_1225 =
			BINT(((long) 9));
		     STRUCT_SET(new_1149, ((long) 1), aux_1225);
		  }
		  STRUCT_SET(new_1149, ((long) 0), id_1145);
		  unit_736 = new_1149;
	       }
	    }
	    {	/* Bdb/initialize.scm 46 */
	       obj_t ast_737;
	       {	/* Bdb/initialize.scm 46 */
		  obj_t arg1462_746;
		  {	/* Bdb/initialize.scm 46 */
		     obj_t list1463_747;
		     list1463_747 =
			MAKE_PAIR(unit_736, BNIL);
		     arg1462_746 = list1463_747;
		  }
		  ast_737 =
		     build_ast_197_ast_build(arg1462_746);
	       }
	       {
		  obj_t l1445_738;
		  l1445_738 = ast_737;
		lname1446_739:
		  if (
		     PAIRP(l1445_738))
		    {	/* Bdb/initialize.scm 47 */
		       {	/* Bdb/initialize.scm 48 */
			  obj_t global_741;
			  global_741 =
			     CAR(l1445_738);
			  {	/* Bdb/initialize.scm 48 */
			     type_bglt aux_1242;
			     node_bglt aux_1234;
			     {	/* Bdb/initialize.scm 49 */
				global_bglt obj_1175;
				obj_1175 =
				   (global_bglt) (global_741);
				aux_1242 =
				   (((global_bglt) CREF(obj_1175))->type);
			     }
			     {	/* Bdb/initialize.scm 48 */
				obj_t aux_1235;
				{	/* Bdb/initialize.scm 48 */
				   sfun_bglt obj_1174;
				   {	/* Bdb/initialize.scm 48 */
				      value_bglt aux_1236;
				      {		/* Bdb/initialize.scm 48 */
					 global_bglt obj_1173;
					 obj_1173 =
					    (global_bglt) (global_741);
					 aux_1236 =
					    (((global_bglt) CREF(obj_1173))->value);
				      }
				      obj_1174 =
					 (sfun_bglt) (aux_1236);
				   }
				   aux_1235 =
				      (((sfun_bglt) CREF(obj_1174))->body);
				}
				aux_1234 =
				   (node_bglt) (aux_1235);
			     }
			     coerce__182_coerce_coerce(aux_1234, aux_1242);
			  }
		       }
		       {
			  obj_t l1445_1246;
			  l1445_1246 =
			     CDR(l1445_738);
			  l1445_738 = l1445_1246;
			  goto lname1446_739;
		       }
		    }
		  else
		    {	/* Bdb/initialize.scm 47 */
		       ((bool_t) 1);
		    }
	       }
	       return ast_737;
	    }
	 }
      }
   }
}



/* _initialize-ast */
obj_t 
_initialize_ast_73_bdb_initialize(obj_t env_1177)
{
   AN_OBJECT;
   {	/* Bdb/initialize.scm 41 */
      return
	 initialize_ast_128_bdb_initialize();
   }
}



/* method-init */
obj_t 
method_init_76_bdb_initialize()
{
   AN_OBJECT;
   {	/* Bdb/initialize.scm 14 */
      return BUNSPEC;
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_bdb_initialize()
{
   AN_OBJECT;
   {	/* Bdb/initialize.scm 14 */
      module_initialization_70_tools_trace(((long) 0), "BDB_INITIALIZE");
      module_initialization_70_tools_shape(((long) 0), "BDB_INITIALIZE");
      module_initialization_70_tools_speek(((long) 0), "BDB_INITIALIZE");
      module_initialization_70_tools_error(((long) 0), "BDB_INITIALIZE");
      module_initialization_70_engine_param(((long) 0), "BDB_INITIALIZE");
      module_initialization_70_module_module(((long) 0), "BDB_INITIALIZE");
      module_initialization_70_type_type(((long) 0), "BDB_INITIALIZE");
      module_initialization_70_type_cache(((long) 0), "BDB_INITIALIZE");
      module_initialization_70_ast_var(((long) 0), "BDB_INITIALIZE");
      module_initialization_70_ast_node(((long) 0), "BDB_INITIALIZE");
      module_initialization_70_ast_env(((long) 0), "BDB_INITIALIZE");
      module_initialization_70_ast_build(((long) 0), "BDB_INITIALIZE");
      module_initialization_70_ast_lvtype(((long) 0), "BDB_INITIALIZE");
      module_initialization_70_ast_glo_def_117(((long) 0), "BDB_INITIALIZE");
      module_initialization_70_coerce_coerce(((long) 0), "BDB_INITIALIZE");
      module_initialization_70_cnst_alloc(((long) 0), "BDB_INITIALIZE");
      return
	 module_initialization_70_cnst_node(((long) 0), "BDB_INITIALIZE");
   }
}
