/*===========================================================================*/
/*   (Bdb/spread-obj.scm)                                                    */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;


static obj_t _bdb_spread_obj__220_bdb_spread_obj_171(obj_t, obj_t);
static obj_t method_init_76_bdb_spread_obj_171();
extern obj_t make_box_202_ast_node;
extern obj_t funcall_ast_node;
extern long add_inlined_method__244___object(obj_t, obj_t, long);
extern obj_t current_error_port;
extern obj_t fail_ast_node;
extern obj_t _nb_error_on_pass__70_tools_error;
extern obj_t box_ref_242_ast_node;
extern obj_t leave_function_170_tools_error();
extern obj_t sequence_ast_node;
extern obj_t let_var_6_ast_node;
static node_bglt spread_obj_node__default1458_118_bdb_spread_obj_171(node_bglt);
static obj_t spread_obj_node___181_bdb_spread_obj_171(obj_t);
extern obj_t _bdb_debug__1_engine_param;
extern obj_t _obj__252_type_cache;
extern obj_t pragma_ast_node;
extern obj_t set_ex_it_116_ast_node;
extern obj_t verbose_tools_speek(obj_t, obj_t);
static obj_t spread_obj_fun__116_bdb_spread_obj_171(obj_t);
extern obj_t module_initialization_70_bdb_spread_obj_171(long, char *);
extern obj_t module_initialization_70_tools_speek(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_engine_pass(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_misc(long, char *);
extern obj_t module_initialization_70_type_env(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_ast_sexp(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_numbers_6_5(long, char *);
extern obj_t module_initialization_70___r4_output_6_10_3(long, char *);
static obj_t _spread_obj_node__default1458_232_bdb_spread_obj_171(obj_t, obj_t);
extern obj_t display_2_122___r4_output_6_10_3(obj_t, obj_t);
extern obj_t let_fun_218_ast_node;
static obj_t imported_modules_init_94_bdb_spread_obj_171();
extern obj_t app_ly_162_ast_node;
extern obj_t add_generic__110___object(obj_t, obj_t);
static obj_t _spread_obj_node_1679_64_bdb_spread_obj_171(obj_t, obj_t);
extern obj_t app_ast_node;
static obj_t library_modules_init_112_bdb_spread_obj_171();
extern obj_t cast_ast_node;
static obj_t toplevel_init_63_bdb_spread_obj_171();
extern obj_t jump_ex_it_184_ast_node;
extern obj_t open_input_string(obj_t);
extern obj_t setq_ast_node;
extern obj_t box_set__221_ast_node;
extern obj_t string_to_bstring(char *);
static obj_t spread_obj_node__80_bdb_spread_obj_171(node_bglt);
extern obj_t enter_function_81_tools_error(obj_t);
extern obj_t internal_error_43_tools_error(obj_t, obj_t, obj_t);
extern obj_t bdb_spread_obj__133_bdb_spread_obj_171(obj_t);
extern obj_t _classes__134___object;
extern obj_t select_ast_node;
extern bool_t _2__206___r4_numbers_6_5(obj_t, obj_t);
extern obj_t read___reader(obj_t);
extern obj_t ____74_type_cache;
static obj_t require_initialization_114_bdb_spread_obj_171 = BUNSPEC;
extern obj_t conditional_ast_node;
static obj_t cnst_init_137_bdb_spread_obj_171();
extern obj_t _current_pass__25_engine_pass;
static obj_t __cnst[2];

DEFINE_STATIC_GENERIC(spread_obj_node__env_134_bdb_spread_obj_171, _spread_obj_node_1679_64_bdb_spread_obj_1711691, _spread_obj_node_1679_64_bdb_spread_obj_171, 0L, 1);
DEFINE_STRING(string1686_bdb_spread_obj_171, string1686_bdb_spread_obj_1711692, "DONE PASS-STARTED ", 18);
DEFINE_STRING(string1685_bdb_spread_obj_171, string1685_bdb_spread_obj_1711693, "failure during postlude hook", 28);
DEFINE_STRING(string1684_bdb_spread_obj_171, string1684_bdb_spread_obj_1711694, " occured, ending ...", 20);
DEFINE_STRING(string1683_bdb_spread_obj_171, string1683_bdb_spread_obj_1711695, " error", 6);
DEFINE_STRING(string1682_bdb_spread_obj_171, string1682_bdb_spread_obj_1711696, "failure during prelude hook", 27);
DEFINE_STRING(string1681_bdb_spread_obj_171, string1681_bdb_spread_obj_1711697, "   . ", 5);
DEFINE_STRING(string1680_bdb_spread_obj_171, string1680_bdb_spread_obj_1711698, "Bdb (obj spreading)", 19);
DEFINE_STATIC_PROCEDURE(spread_obj_node__default1458_env_220_bdb_spread_obj_171, _spread_obj_node__default1458_232_bdb_spread_obj_1711699, _spread_obj_node__default1458_232_bdb_spread_obj_171, 0L, 1);
DEFINE_EXPORT_PROCEDURE(bdb_spread_obj__env_248_bdb_spread_obj_171, _bdb_spread_obj__220_bdb_spread_obj_1711700, _bdb_spread_obj__220_bdb_spread_obj_171, 0L, 1);



/* module-initialization */
obj_t 
module_initialization_70_bdb_spread_obj_171(long checksum_1329, char *from_1330)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_bdb_spread_obj_171))
	{
	   require_initialization_114_bdb_spread_obj_171 =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_bdb_spread_obj_171();
	   cnst_init_137_bdb_spread_obj_171();
	   imported_modules_init_94_bdb_spread_obj_171();
	   method_init_76_bdb_spread_obj_171();
	   toplevel_init_63_bdb_spread_obj_171();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_bdb_spread_obj_171()
{
   AN_OBJECT;
   {	/* Bdb/spread-obj.scm 14 */
      module_initialization_70___object(((long) 0), "BDB_SPREAD-OBJ");
      module_initialization_70___r4_output_6_10_3(((long) 0), "BDB_SPREAD-OBJ");
      module_initialization_70___r4_numbers_6_5(((long) 0), "BDB_SPREAD-OBJ");
      module_initialization_70___reader(((long) 0), "BDB_SPREAD-OBJ");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_bdb_spread_obj_171()
{
   AN_OBJECT;
   {	/* Bdb/spread-obj.scm 14 */
      {		/* Bdb/spread-obj.scm 14 */
	 obj_t cnst_port_138_1322;
	 cnst_port_138_1322 =
	    open_input_string(string1686_bdb_spread_obj_171);
	 {
	    long i_1323;
	    i_1323 = ((long) 1);
	  loop_1324:
	    {	/* Bdb/spread-obj.scm 14 */
	       bool_t test1687_1325;
	       test1687_1325 =
		  (i_1323 == ((long) -1));
	       if (test1687_1325)
		 {	/* Bdb/spread-obj.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Bdb/spread-obj.scm 14 */
		    {	/* Bdb/spread-obj.scm 14 */
		       obj_t arg1688_1326;
		       {	/* Bdb/spread-obj.scm 14 */
			  obj_t list1689_1327;
			  list1689_1327 =
			     MAKE_PAIR(cnst_port_138_1322, BNIL);
			  arg1688_1326 =
			     read___reader(list1689_1327);
		       }
		       CNST_TABLE_SET(i_1323, arg1688_1326);
		    }
		    {	/* Bdb/spread-obj.scm 14 */
		       int aux_1328;
		       {	/* Bdb/spread-obj.scm 14 */
			  long aux_1349;
			  aux_1349 =
			     (i_1323 - ((long) 1));
			  aux_1328 =
			     (int) (aux_1349);
		       }
		       {
			  long i_1352;
			  i_1352 =
			     (long) (aux_1328);
			  i_1323 = i_1352;
			  goto loop_1324;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_bdb_spread_obj_171()
{
   AN_OBJECT;
   {	/* Bdb/spread-obj.scm 14 */
      return BUNSPEC;
   }
}



/* bdb-spread-obj! */
obj_t 
bdb_spread_obj__133_bdb_spread_obj_171(obj_t globals_1)
{
   AN_OBJECT;
   {	/* Bdb/spread-obj.scm 29 */
      {		/* Bdb/spread-obj.scm 29 */
	 obj_t list1494_718;
	 {	/* Bdb/spread-obj.scm 29 */
	    obj_t arg1496_720;
	    {	/* Bdb/spread-obj.scm 29 */
	       obj_t arg1498_722;
	       {	/* Bdb/spread-obj.scm 29 */
		  obj_t aux_1354;
		  aux_1354 =
		     BCHAR(((unsigned char) '\n'));
		  arg1498_722 =
		     MAKE_PAIR(aux_1354, BNIL);
	       }
	       arg1496_720 =
		  MAKE_PAIR(string1680_bdb_spread_obj_171, arg1498_722);
	    }
	    list1494_718 =
	       MAKE_PAIR(string1681_bdb_spread_obj_171, arg1496_720);
	 }
	 verbose_tools_speek(
	    BINT(((long) 1)), list1494_718);
      }
      _nb_error_on_pass__70_tools_error =
	 BINT(((long) 0));
      _current_pass__25_engine_pass = string1680_bdb_spread_obj_171;
      {
	 obj_t hooks_723;
	 obj_t hnames_724;
	 hooks_723 = BNIL;
	 hnames_724 = BNIL;
       loop_725:
	 if (
	    NULLP(hooks_723))
	   {	/* Bdb/spread-obj.scm 29 */
	      CNST_TABLE_REF(((long) 0));
	   }
	 else
	   {	/* Bdb/spread-obj.scm 29 */
	      bool_t test1503_730;
	      {		/* Bdb/spread-obj.scm 29 */
		 obj_t fun1510_736;
		 fun1510_736 =
		    CAR(hooks_723);
		 {	/* Bdb/spread-obj.scm 29 */
		    obj_t aux_1366;
		    aux_1366 =
		       PROCEDURE_ENTRY(fun1510_736) (fun1510_736, BEOA);
		    test1503_730 =
		       CBOOL(aux_1366);
		 }
	      }
	      if (test1503_730)
		{	/* Bdb/spread-obj.scm 29 */
		   {
		      obj_t hnames_1373;
		      obj_t hooks_1371;
		      hooks_1371 =
			 CDR(hooks_723);
		      hnames_1373 =
			 CDR(hnames_724);
		      hnames_724 = hnames_1373;
		      hooks_723 = hooks_1371;
		      goto loop_725;
		   }
		}
	      else
		{	/* Bdb/spread-obj.scm 29 */
		   internal_error_43_tools_error(string1680_bdb_spread_obj_171, string1682_bdb_spread_obj_171,
		      CAR(hnames_724));
		}
	   }
      }
      {
	 obj_t l1437_737;
	 l1437_737 = globals_1;
       lname1438_738:
	 if (
	    PAIRP(l1437_737))
	   {	/* Bdb/spread-obj.scm 31 */
	      spread_obj_fun__116_bdb_spread_obj_171(
		 CAR(l1437_737));
	      {
		 obj_t l1437_1381;
		 l1437_1381 =
		    CDR(l1437_737);
		 l1437_737 = l1437_1381;
		 goto lname1438_738;
	      }
	   }
	 else
	   {	/* Bdb/spread-obj.scm 31 */
	      ((bool_t) 1);
	   }
      }
      {		/* Bdb/spread-obj.scm 32 */
	 bool_t test1514_743;
	 {	/* Bdb/spread-obj.scm 32 */
	    long n1_1208;
	    n1_1208 =
	       (long) CINT(_nb_error_on_pass__70_tools_error);
	    test1514_743 =
	       (n1_1208 > ((long) 0));
	 }
	 if (test1514_743)
	   {	/* Bdb/spread-obj.scm 32 */
	      display_2_122___r4_output_6_10_3(_nb_error_on_pass__70_tools_error, current_error_port);
	      display_2_122___r4_output_6_10_3(string1683_bdb_spread_obj_171, current_error_port);
	      {		/* Bdb/spread-obj.scm 32 */
		 char *arg1515_745;
		 {	/* Bdb/spread-obj.scm 32 */
		    bool_t test1516_746;
		    {	/* Bdb/spread-obj.scm 32 */
		       bool_t test1517_747;
		       {	/* Bdb/spread-obj.scm 32 */
			  obj_t obj_1210;
			  obj_1210 = _nb_error_on_pass__70_tools_error;
			  test1517_747 =
			     INTEGERP(obj_1210);
		       }
		       if (test1517_747)
			 {	/* Bdb/spread-obj.scm 32 */
			    test1516_746 =
			       _2__206___r4_numbers_6_5(_nb_error_on_pass__70_tools_error,
			       BINT(((long) 1)));
			 }
		       else
			 {	/* Bdb/spread-obj.scm 32 */
			    test1516_746 = ((bool_t) 0);
			 }
		    }
		    if (test1516_746)
		      {		/* Bdb/spread-obj.scm 32 */
			 arg1515_745 = "s";
		      }
		    else
		      {		/* Bdb/spread-obj.scm 32 */
			 arg1515_745 = "";
		      }
		 }
		 display_2_122___r4_output_6_10_3(
		    string_to_bstring(arg1515_745), current_error_port);
	      }
	      display_2_122___r4_output_6_10_3(string1684_bdb_spread_obj_171, current_error_port);
	      WRITE_CHAR(((unsigned char) '\n'), current_error_port);
	      {		/* Bdb/spread-obj.scm 32 */
		 obj_t res1677_1213;
		 exit(((long) -1));
		 res1677_1213 =
		    BINT(((long) -1));
		 return res1677_1213;
	      }
	   }
	 else
	   {
	      obj_t hooks_748;
	      obj_t hnames_749;
	      hooks_748 = BNIL;
	      hnames_749 = BNIL;
	    loop_750:
	      if (
		 NULLP(hooks_748))
		{	/* Bdb/spread-obj.scm 32 */
		   return globals_1;
		}
	      else
		{	/* Bdb/spread-obj.scm 32 */
		   bool_t test1523_755;
		   {	/* Bdb/spread-obj.scm 32 */
		      obj_t fun1529_760;
		      fun1529_760 =
			 CAR(hooks_748);
		      {		/* Bdb/spread-obj.scm 32 */
			 obj_t aux_1402;
			 aux_1402 =
			    PROCEDURE_ENTRY(fun1529_760) (fun1529_760, BEOA);
			 test1523_755 =
			    CBOOL(aux_1402);
		      }
		   }
		   if (test1523_755)
		     {	/* Bdb/spread-obj.scm 32 */
			{
			   obj_t hnames_1409;
			   obj_t hooks_1407;
			   hooks_1407 =
			      CDR(hooks_748);
			   hnames_1409 =
			      CDR(hnames_749);
			   hnames_749 = hnames_1409;
			   hooks_748 = hooks_1407;
			   goto loop_750;
			}
		     }
		   else
		     {	/* Bdb/spread-obj.scm 32 */
			return
			   internal_error_43_tools_error(_current_pass__25_engine_pass, string1685_bdb_spread_obj_171,
			   CAR(hnames_749));
		     }
		}
	   }
      }
   }
}



/* _bdb-spread-obj! */
obj_t 
_bdb_spread_obj__220_bdb_spread_obj_171(obj_t env_1316, obj_t globals_1317)
{
   AN_OBJECT;
   {	/* Bdb/spread-obj.scm 29 */
      return
	 bdb_spread_obj__133_bdb_spread_obj_171(globals_1317);
   }
}



/* spread-obj-fun! */
obj_t 
spread_obj_fun__116_bdb_spread_obj_171(obj_t var_2)
{
   AN_OBJECT;
   {	/* Bdb/spread-obj.scm 37 */
      {		/* Bdb/spread-obj.scm 38 */
	 obj_t aux_1414;
	 {	/* Bdb/spread-obj.scm 38 */
	    variable_bglt obj_1220;
	    obj_1220 =
	       (variable_bglt) (var_2);
	    aux_1414 =
	       (((variable_bglt) CREF(obj_1220))->id);
	 }
	 enter_function_81_tools_error(aux_1414);
      }
      {		/* Bdb/spread-obj.scm 39 */
	 value_bglt fun_762;
	 {	/* Bdb/spread-obj.scm 39 */
	    variable_bglt obj_1221;
	    obj_1221 =
	       (variable_bglt) (var_2);
	    fun_762 =
	       (((variable_bglt) CREF(obj_1221))->value);
	 }
	 {	/* Bdb/spread-obj.scm 39 */
	    obj_t body_763;
	    {	/* Bdb/spread-obj.scm 40 */
	       sfun_bglt obj_1222;
	       obj_1222 =
		  (sfun_bglt) (fun_762);
	       body_763 =
		  (((sfun_bglt) CREF(obj_1222))->body);
	    }
	    {	/* Bdb/spread-obj.scm 41 */
	       obj_t args_765;
	       {	/* Bdb/spread-obj.scm 42 */
		  sfun_bglt obj_1224;
		  obj_1224 =
		     (sfun_bglt) (fun_762);
		  args_765 =
		     (((sfun_bglt) CREF(obj_1224))->args);
	       }
	       {	/* Bdb/spread-obj.scm 42 */

		  {	/* Bdb/spread-obj.scm 43 */
		     bool_t test1531_766;
		     {	/* Bdb/spread-obj.scm 43 */
			obj_t obj2_1226;
			obj2_1226 = ____74_type_cache;
			{	/* ./Ieee/equiv.scm 5508 */
			   obj_t aux_1424;
			   {	/* Bdb/spread-obj.scm 43 */
			      type_bglt aux_1425;
			      {		/* Bdb/spread-obj.scm 41 */
				 variable_bglt obj_1223;
				 obj_1223 =
				    (variable_bglt) (var_2);
				 aux_1425 =
				    (((variable_bglt) CREF(obj_1223))->type);
			      }
			      aux_1424 =
				 (obj_t) (aux_1425);
			   }
			   test1531_766 =
			      (aux_1424 == obj2_1226);
			}
		     }
		     if (test1531_766)
		       {	/* Bdb/spread-obj.scm 44 */
			  variable_bglt obj_1227;
			  type_bglt val1034_1228;
			  obj_1227 =
			     (variable_bglt) (var_2);
			  val1034_1228 =
			     (type_bglt) (_obj__252_type_cache);
			  ((((variable_bglt) CREF(obj_1227))->type) = ((type_bglt) val1034_1228), BUNSPEC);
		       }
		     else
		       {	/* Bdb/spread-obj.scm 43 */
			  BUNSPEC;
		       }
		  }
		  {
		     obj_t l1440_767;
		     l1440_767 = args_765;
		   lname1441_768:
		     if (
			PAIRP(l1440_767))
		       {	/* Bdb/spread-obj.scm 45 */
			  {	/* Bdb/spread-obj.scm 46 */
			     obj_t args_770;
			     args_770 =
				CAR(l1440_767);
			     {	/* Bdb/spread-obj.scm 46 */
				bool_t test1533_771;
				{	/* Bdb/spread-obj.scm 46 */
				   obj_t obj2_1233;
				   obj2_1233 = ____74_type_cache;
				   {	/* ./Ieee/equiv.scm 5508 */
				      obj_t aux_1437;
				      {		/* Bdb/spread-obj.scm 46 */
					 type_bglt aux_1438;
					 {	/* Bdb/spread-obj.scm 46 */
					    variable_bglt obj_1231;
					    obj_1231 =
					       (variable_bglt) (args_770);
					    aux_1438 =
					       (((variable_bglt) CREF(obj_1231))->type);
					 }
					 aux_1437 =
					    (obj_t) (aux_1438);
				      }
				      test1533_771 =
					 (aux_1437 == obj2_1233);
				   }
				}
				if (test1533_771)
				  {	/* Bdb/spread-obj.scm 47 */
				     variable_bglt obj_1234;
				     type_bglt val1034_1235;
				     obj_1234 =
					(variable_bglt) (args_770);
				     val1034_1235 =
					(type_bglt) (_obj__252_type_cache);
				     ((((variable_bglt) CREF(obj_1234))->type) = ((type_bglt) val1034_1235), BUNSPEC);
				  }
				else
				  {	/* Bdb/spread-obj.scm 46 */
				     BUNSPEC;
				  }
			     }
			  }
			  {
			     obj_t l1440_1447;
			     l1440_1447 =
				CDR(l1440_767);
			     l1440_767 = l1440_1447;
			     goto lname1441_768;
			  }
		       }
		     else
		       {	/* Bdb/spread-obj.scm 45 */
			  ((bool_t) 1);
		       }
		  }
		  {	/* Bdb/spread-obj.scm 49 */
		     bool_t test1536_774;
		     {	/* Bdb/spread-obj.scm 49 */
			long n1_1237;
			n1_1237 =
			   (long) CINT(_bdb_debug__1_engine_param);
			test1536_774 =
			   (n1_1237 >= ((long) 3));
		     }
		     if (test1536_774)
		       {	/* Bdb/spread-obj.scm 49 */
			  spread_obj_node__80_bdb_spread_obj_171(
			     (node_bglt) (body_763));
		       }
		     else
		       {	/* Bdb/spread-obj.scm 49 */
			  BUNSPEC;
		       }
		  }
		  return
		     leave_function_170_tools_error();
	       }
	    }
	 }
      }
   }
}



/* spread-obj-node*! */
obj_t 
spread_obj_node___181_bdb_spread_obj_171(obj_t node__221_22)
{
   AN_OBJECT;
   {	/* Bdb/spread-obj.scm 193 */
    spread_obj_node___181_bdb_spread_obj_171:
      if (
	 NULLP(node__221_22))
	{	/* Bdb/spread-obj.scm 194 */
	   return
	      CNST_TABLE_REF(((long) 1));
	}
      else
	{	/* Bdb/spread-obj.scm 194 */
	   {	/* Bdb/spread-obj.scm 197 */
	      node_bglt aux_1458;
	      {		/* Bdb/spread-obj.scm 197 */
		 obj_t aux_1459;
		 aux_1459 =
		    CAR(node__221_22);
		 aux_1458 =
		    (node_bglt) (aux_1459);
	      }
	      spread_obj_node__80_bdb_spread_obj_171(aux_1458);
	   }
	   {
	      obj_t node__221_1463;
	      node__221_1463 =
		 CDR(node__221_22);
	      node__221_22 = node__221_1463;
	      goto spread_obj_node___181_bdb_spread_obj_171;
	   }
	}
   }
}



/* method-init */
obj_t 
method_init_76_bdb_spread_obj_171()
{
   AN_OBJECT;
   {	/* Bdb/spread-obj.scm 14 */
      add_generic__110___object(spread_obj_node__env_134_bdb_spread_obj_171, spread_obj_node__default1458_env_220_bdb_spread_obj_171);
      add_inlined_method__244___object(spread_obj_node__env_134_bdb_spread_obj_171, sequence_ast_node, ((long) 0));
      add_inlined_method__244___object(spread_obj_node__env_134_bdb_spread_obj_171, app_ast_node, ((long) 1));
      add_inlined_method__244___object(spread_obj_node__env_134_bdb_spread_obj_171, app_ly_162_ast_node, ((long) 2));
      add_inlined_method__244___object(spread_obj_node__env_134_bdb_spread_obj_171, funcall_ast_node, ((long) 3));
      add_inlined_method__244___object(spread_obj_node__env_134_bdb_spread_obj_171, pragma_ast_node, ((long) 4));
      add_inlined_method__244___object(spread_obj_node__env_134_bdb_spread_obj_171, cast_ast_node, ((long) 5));
      add_inlined_method__244___object(spread_obj_node__env_134_bdb_spread_obj_171, setq_ast_node, ((long) 6));
      add_inlined_method__244___object(spread_obj_node__env_134_bdb_spread_obj_171, conditional_ast_node, ((long) 7));
      add_inlined_method__244___object(spread_obj_node__env_134_bdb_spread_obj_171, fail_ast_node, ((long) 8));
      add_inlined_method__244___object(spread_obj_node__env_134_bdb_spread_obj_171, select_ast_node, ((long) 9));
      add_inlined_method__244___object(spread_obj_node__env_134_bdb_spread_obj_171, let_fun_218_ast_node, ((long) 10));
      add_inlined_method__244___object(spread_obj_node__env_134_bdb_spread_obj_171, let_var_6_ast_node, ((long) 11));
      add_inlined_method__244___object(spread_obj_node__env_134_bdb_spread_obj_171, set_ex_it_116_ast_node, ((long) 12));
      add_inlined_method__244___object(spread_obj_node__env_134_bdb_spread_obj_171, jump_ex_it_184_ast_node, ((long) 13));
      add_inlined_method__244___object(spread_obj_node__env_134_bdb_spread_obj_171, make_box_202_ast_node, ((long) 14));
      add_inlined_method__244___object(spread_obj_node__env_134_bdb_spread_obj_171, box_ref_242_ast_node, ((long) 15));
      {		/* Bdb/spread-obj.scm 14 */
	 long aux_1482;
	 aux_1482 =
	    add_inlined_method__244___object(spread_obj_node__env_134_bdb_spread_obj_171, box_set__221_ast_node, ((long) 16));
	 return
	    BINT(aux_1482);
      }
   }
}



/* spread-obj-node! */
obj_t 
spread_obj_node__80_bdb_spread_obj_171(node_bglt node_3)
{
   AN_OBJECT;
   {	/* Bdb/spread-obj.scm 56 */
    spread_obj_node__80_bdb_spread_obj_171:
      {
	 obj_t method1618_1108;
	 obj_t class1623_1109;
	 {	/* Bdb/spread-obj.scm 56 */
	    obj_t arg1626_1106;
	    obj_t arg1627_1107;
	    {	/* Bdb/spread-obj.scm 56 */
	       object_bglt obj_1242;
	       obj_1242 =
		  (object_bglt) (node_3);
	       {	/* ./Llib/object.scm 2926 */
		  obj_t pre_method_105_1243;
		  pre_method_105_1243 =
		     PROCEDURE_REF(spread_obj_node__env_134_bdb_spread_obj_171, ((long) 2));
		  if (
		     INTEGERP(pre_method_105_1243))
		    {	/* ./Llib/object.scm 2927 */
		       PROCEDURE_SET(spread_obj_node__env_134_bdb_spread_obj_171, ((long) 2), BUNSPEC);
		       arg1626_1106 = pre_method_105_1243;
		    }
		  else
		    {	/* ./Llib/object.scm 2914 */
		       long obj_class_num_177_1248;
		       obj_class_num_177_1248 =
			  TYPE(obj_1242);
		       {	/* ./Llib/object.scm 2915 */
			  obj_t arg1176_1249;
			  arg1176_1249 =
			     PROCEDURE_REF(spread_obj_node__env_134_bdb_spread_obj_171, ((long) 1));
			  {	/* ./Llib/object.scm 2738 */
			     long arg1177_1253;
			     {	/* ./Llib/object.scm 2738 */
				long arg1178_1254;
				arg1178_1254 =
				   OBJECT_TYPE;
				arg1177_1253 =
				   (obj_class_num_177_1248 - arg1178_1254);
			     }
			     arg1626_1106 =
				VECTOR_REF(arg1176_1249, arg1177_1253);
			  }
		       }
		    }
	       }
	    }
	    {	/* Bdb/spread-obj.scm 56 */
	       object_bglt object_1259;
	       object_1259 =
		  (object_bglt) (node_3);
	       {	/* ./Llib/object.scm 2695 */
		  long arg1179_1260;
		  {	/* ./Llib/object.scm 2695 */
		     long arg1180_1261;
		     long arg1181_1262;
		     arg1180_1261 =
			TYPE(object_1259);
		     arg1181_1262 =
			OBJECT_TYPE;
		     arg1179_1260 =
			(arg1180_1261 - arg1181_1262);
		  }
		  {	/* ./Llib/object.scm 2695 */
		     obj_t vector_1266;
		     vector_1266 = _classes__134___object;
		     arg1627_1107 =
			VECTOR_REF(vector_1266, arg1179_1260);
		  }
	       }
	    }
	    method1618_1108 = arg1626_1106;
	    class1623_1109 = arg1627_1107;
	    {

	       if (
		  INTEGERP(method1618_1108))
		 {	/* Bdb/spread-obj.scm 56 */
		    switch (
		       (long) CINT(method1618_1108))
		      {
		      case ((long) 0):

			 {	/* Bdb/spread-obj.scm 63 */
			    sequence_bglt node_1115;
			    node_1115 =
			       (sequence_bglt) (node_3);
			    return
			       spread_obj_node___181_bdb_spread_obj_171(
			       (((sequence_bglt) CREF(node_1115))->nodes));
			 }
			 break;
		      case ((long) 1):

			 {	/* Bdb/spread-obj.scm 69 */
			    app_bglt node_1117;
			    node_1117 =
			       (app_bglt) (node_3);
			    return
			       spread_obj_node___181_bdb_spread_obj_171(
			       (((app_bglt) CREF(node_1117))->args));
			 }
			 break;
		      case ((long) 2):

			 {	/* Bdb/spread-obj.scm 75 */
			    app_ly_162_bglt node_1119;
			    node_1119 =
			       (app_ly_162_bglt) (node_3);
			    spread_obj_node__80_bdb_spread_obj_171(
			       (((app_ly_162_bglt) CREF(node_1119))->fun));
			    {
			       node_bglt node_1511;
			       node_1511 =
				  (((app_ly_162_bglt) CREF(node_1119))->arg);
			       node_3 = node_1511;
			       goto spread_obj_node__80_bdb_spread_obj_171;
			    }
			 }
			 break;
		      case ((long) 3):

			 {	/* Bdb/spread-obj.scm 83 */
			    funcall_bglt node_1123;
			    node_1123 =
			       (funcall_bglt) (node_3);
			    spread_obj_node__80_bdb_spread_obj_171(
			       (((funcall_bglt) CREF(node_1123))->fun));
			    return
			       spread_obj_node___181_bdb_spread_obj_171(
			       (((funcall_bglt) CREF(node_1123))->args));
			 }
			 break;
		      case ((long) 4):

			 {	/* Bdb/spread-obj.scm 91 */
			    pragma_bglt node_1127;
			    node_1127 =
			       (pragma_bglt) (node_3);
			    return
			       spread_obj_node___181_bdb_spread_obj_171(
			       (((pragma_bglt) CREF(node_1127))->args));
			 }
			 break;
		      case ((long) 5):

			 {	/* Bdb/spread-obj.scm 97 */
			    cast_bglt node_1129;
			    node_1129 =
			       (cast_bglt) (node_3);
			    {
			       node_bglt node_1522;
			       node_1522 =
				  (((cast_bglt) CREF(node_1129))->arg);
			       node_3 = node_1522;
			       goto spread_obj_node__80_bdb_spread_obj_171;
			    }
			 }
			 break;
		      case ((long) 6):

			 {	/* Bdb/spread-obj.scm 103 */
			    setq_bglt node_1131;
			    node_1131 =
			       (setq_bglt) (node_3);
			    {
			       node_bglt node_1525;
			       node_1525 =
				  (((setq_bglt) CREF(node_1131))->value);
			       node_3 = node_1525;
			       goto spread_obj_node__80_bdb_spread_obj_171;
			    }
			 }
			 break;
		      case ((long) 7):

			 {	/* Bdb/spread-obj.scm 109 */
			    conditional_bglt node_1133;
			    node_1133 =
			       (conditional_bglt) (node_3);
			    spread_obj_node__80_bdb_spread_obj_171(
			       (((conditional_bglt) CREF(node_1133))->test));
			    spread_obj_node__80_bdb_spread_obj_171(
			       (((conditional_bglt) CREF(node_1133))->true));
			    {
			       node_bglt node_1532;
			       node_1532 =
				  (((conditional_bglt) CREF(node_1133))->false);
			       node_3 = node_1532;
			       goto spread_obj_node__80_bdb_spread_obj_171;
			    }
			 }
			 break;
		      case ((long) 8):

			 {	/* Bdb/spread-obj.scm 118 */
			    fail_bglt node_1138;
			    node_1138 =
			       (fail_bglt) (node_3);
			    spread_obj_node__80_bdb_spread_obj_171(
			       (((fail_bglt) CREF(node_1138))->proc));
			    spread_obj_node__80_bdb_spread_obj_171(
			       (((fail_bglt) CREF(node_1138))->msg));
			    {
			       node_bglt node_1539;
			       node_1539 =
				  (((fail_bglt) CREF(node_1138))->obj);
			       node_3 = node_1539;
			       goto spread_obj_node__80_bdb_spread_obj_171;
			    }
			 }
			 break;
		      case ((long) 9):

			 {	/* Bdb/spread-obj.scm 127 */
			    select_bglt node_1143;
			    node_1143 =
			       (select_bglt) (node_3);
			    spread_obj_node__80_bdb_spread_obj_171(
			       (((select_bglt) CREF(node_1143))->test));
			    {
			       obj_t l1447_1146;
			       {	/* Bdb/spread-obj.scm 129 */
				  bool_t aux_1544;
				  l1447_1146 =
				     (((select_bglt) CREF(node_1143))->clauses);
				lname1448_1147:
				  if (
				     PAIRP(l1447_1146))
				    {	/* Bdb/spread-obj.scm 129 */
				       {	/* Bdb/spread-obj.scm 130 */
					  node_bglt aux_1547;
					  {	/* Bdb/spread-obj.scm 130 */
					     obj_t aux_1548;
					     {	/* ./Ieee/pair-list.scm 5707 */
						obj_t aux_1549;
						aux_1549 =
						   CAR(l1447_1146);
						aux_1548 =
						   CDR(aux_1549);
					     }
					     aux_1547 =
						(node_bglt) (aux_1548);
					  }
					  spread_obj_node__80_bdb_spread_obj_171(aux_1547);
				       }
				       {
					  obj_t l1447_1554;
					  l1447_1554 =
					     CDR(l1447_1146);
					  l1447_1146 = l1447_1554;
					  goto lname1448_1147;
				       }
				    }
				  else
				    {	/* Bdb/spread-obj.scm 129 */
				       aux_1544 = ((bool_t) 1);
				    }
				  return
				     BBOOL(aux_1544);
			       }
			    }
			 }
			 break;
		      case ((long) 10):

			 {	/* Bdb/spread-obj.scm 137 */
			    let_fun_218_bglt node_1153;
			    node_1153 =
			       (let_fun_218_bglt) (node_3);
			    {
			       obj_t l1450_1155;
			       l1450_1155 =
				  (((let_fun_218_bglt) CREF(node_1153))->locals);
			     lname1451_1156:
			       if (
				  PAIRP(l1450_1155))
				 {	/* Bdb/spread-obj.scm 138 */
				    spread_obj_fun__116_bdb_spread_obj_171(
				       CAR(l1450_1155));
				    {
				       obj_t l1450_1563;
				       l1450_1563 =
					  CDR(l1450_1155);
				       l1450_1155 = l1450_1563;
				       goto lname1451_1156;
				    }
				 }
			       else
				 {	/* Bdb/spread-obj.scm 138 */
				    ((bool_t) 1);
				 }
			    }
			    {
			       node_bglt node_1566;
			       node_1566 =
				  (((let_fun_218_bglt) CREF(node_1153))->body);
			       node_3 = node_1566;
			       goto spread_obj_node__80_bdb_spread_obj_171;
			    }
			 }
			 break;
		      case ((long) 11):

			 {	/* Bdb/spread-obj.scm 145 */
			    let_var_6_bglt node_1162;
			    node_1162 =
			       (let_var_6_bglt) (node_3);
			    {
			       obj_t l1453_1164;
			       l1453_1164 =
				  (((let_var_6_bglt) CREF(node_1162))->bindings);
			     lname1454_1165:
			       if (
				  PAIRP(l1453_1164))
				 {	/* Bdb/spread-obj.scm 146 */
				    {	/* Bdb/spread-obj.scm 146 */
				       obj_t binding_1168;
				       binding_1168 =
					  CAR(l1453_1164);
				       {	/* Bdb/spread-obj.scm 147 */
					  obj_t variable_1169;
					  variable_1169 =
					     CAR(binding_1168);
					  {	/* Bdb/spread-obj.scm 148 */
					     bool_t test1658_1170;
					     {	/* Bdb/spread-obj.scm 148 */
						bool_t test1659_1171;
						{	/* Bdb/spread-obj.scm 148 */
						   obj_t obj2_1300;
						   obj2_1300 = ____74_type_cache;
						   {	/* ./Ieee/equiv.scm 5508 */
						      obj_t aux_1573;
						      {		/* Bdb/spread-obj.scm 148 */
							 type_bglt aux_1574;
							 {	/* Bdb/spread-obj.scm 148 */
							    variable_bglt obj_1298;
							    obj_1298 =
							       (variable_bglt) (variable_1169);
							    aux_1574 =
							       (((variable_bglt) CREF(obj_1298))->type);
							 }
							 aux_1573 =
							    (obj_t) (aux_1574);
						      }
						      test1659_1171 =
							 (aux_1573 == obj2_1300);
						   }
						}
						if (test1659_1171)
						  {	/* Bdb/spread-obj.scm 149 */
						     local_bglt obj_1301;
						     obj_1301 =
							(local_bglt) (variable_1169);
						     test1658_1170 =
							(((local_bglt) CREF(obj_1301))->user__32);
						  }
						else
						  {	/* Bdb/spread-obj.scm 148 */
						     test1658_1170 = ((bool_t) 0);
						  }
					     }
					     if (test1658_1170)
					       {	/* Bdb/spread-obj.scm 150 */
						  variable_bglt obj_1302;
						  type_bglt val1034_1303;
						  obj_1302 =
						     (variable_bglt) (variable_1169);
						  val1034_1303 =
						     (type_bglt) (_obj__252_type_cache);
						  ((((variable_bglt) CREF(obj_1302))->type) = ((type_bglt) val1034_1303), BUNSPEC);
					       }
					     else
					       {	/* Bdb/spread-obj.scm 148 */
						  BUNSPEC;
					       }
					  }
				       }
				       {	/* Bdb/spread-obj.scm 151 */
					  node_bglt aux_1586;
					  {	/* Bdb/spread-obj.scm 151 */
					     obj_t aux_1587;
					     aux_1587 =
						CDR(binding_1168);
					     aux_1586 =
						(node_bglt) (aux_1587);
					  }
					  spread_obj_node__80_bdb_spread_obj_171(aux_1586);
				       }
				    }
				    {
				       obj_t l1453_1591;
				       l1453_1591 =
					  CDR(l1453_1164);
				       l1453_1164 = l1453_1591;
				       goto lname1454_1165;
				    }
				 }
			       else
				 {	/* Bdb/spread-obj.scm 146 */
				    ((bool_t) 1);
				 }
			    }
			    {
			       node_bglt node_1594;
			       node_1594 =
				  (((let_var_6_bglt) CREF(node_1162))->body);
			       node_3 = node_1594;
			       goto spread_obj_node__80_bdb_spread_obj_171;
			    }
			 }
			 break;
		      case ((long) 12):

			 {	/* Bdb/spread-obj.scm 159 */
			    set_ex_it_116_bglt node_1176;
			    node_1176 =
			       (set_ex_it_116_bglt) (node_3);
			    {
			       node_bglt node_1597;
			       node_1597 =
				  (((set_ex_it_116_bglt) CREF(node_1176))->body);
			       node_3 = node_1597;
			       goto spread_obj_node__80_bdb_spread_obj_171;
			    }
			 }
			 break;
		      case ((long) 13):

			 {	/* Bdb/spread-obj.scm 56 */
			    jump_ex_it_184_bglt node_1178;
			    node_1178 =
			       (jump_ex_it_184_bglt) (node_3);
			    spread_obj_node__80_bdb_spread_obj_171(
			       (((jump_ex_it_184_bglt) CREF(node_1178))->exit));
			    spread_obj_node__80_bdb_spread_obj_171(
			       (((jump_ex_it_184_bglt) CREF(node_1178))->value));
			    return
			       (obj_t) (node_1178);
			 }
			 break;
		      case ((long) 14):

			 {	/* Bdb/spread-obj.scm 174 */
			    make_box_202_bglt node_1182;
			    node_1182 =
			       (make_box_202_bglt) (node_3);
			    {
			       node_bglt node_1606;
			       node_1606 =
				  (((make_box_202_bglt) CREF(node_1182))->value);
			       node_3 = node_1606;
			       goto spread_obj_node__80_bdb_spread_obj_171;
			    }
			 }
			 break;
		      case ((long) 15):

			 {	/* Bdb/spread-obj.scm 180 */
			    box_ref_242_bglt node_1184;
			    node_1184 =
			       (box_ref_242_bglt) (node_3);
			    {
			       node_bglt node_1609;
			       {	/* Bdb/spread-obj.scm 180 */
				  var_bglt aux_1610;
				  aux_1610 =
				     (((box_ref_242_bglt) CREF(node_1184))->var);
				  node_1609 =
				     (node_bglt) (aux_1610);
			       }
			       node_3 = node_1609;
			       goto spread_obj_node__80_bdb_spread_obj_171;
			    }
			 }
			 break;
		      case ((long) 16):

			 {	/* Bdb/spread-obj.scm 186 */
			    box_set__221_bglt node_1186;
			    node_1186 =
			       (box_set__221_bglt) (node_3);
			    {	/* Bdb/spread-obj.scm 187 */
			       node_bglt aux_1614;
			       {	/* Bdb/spread-obj.scm 187 */
				  var_bglt aux_1615;
				  aux_1615 =
				     (((box_set__221_bglt) CREF(node_1186))->var);
				  aux_1614 =
				     (node_bglt) (aux_1615);
			       }
			       spread_obj_node__80_bdb_spread_obj_171(aux_1614);
			    }
			    {
			       node_bglt node_1619;
			       node_1619 =
				  (((box_set__221_bglt) CREF(node_1186))->value);
			       node_3 = node_1619;
			       goto spread_obj_node__80_bdb_spread_obj_171;
			    }
			 }
			 break;
		      default:
		       case_else1624_1112:
			 if (
			    PROCEDUREP(method1618_1108))
			   {	/* Bdb/spread-obj.scm 56 */
			      return
				 PROCEDURE_ENTRY(method1618_1108) (method1618_1108,
				 (obj_t) (node_3), BEOA);
			   }
			 else
			   {	/* Bdb/spread-obj.scm 56 */
			      obj_t fun1617_1104;
			      fun1617_1104 =
				 PROCEDURE_REF(spread_obj_node__env_134_bdb_spread_obj_171, ((long) 0));
			      return
				 PROCEDURE_ENTRY(fun1617_1104) (fun1617_1104,
				 (obj_t) (node_3), BEOA);
			   }
		      }
		 }
	       else
		 {	/* Bdb/spread-obj.scm 56 */
		    goto case_else1624_1112;
		 }
	    }
	 }
      }
   }
}



/* _spread-obj-node!1679 */
obj_t 
_spread_obj_node_1679_64_bdb_spread_obj_171(obj_t env_1318, obj_t node_1319)
{
   AN_OBJECT;
   {	/* Bdb/spread-obj.scm 56 */
      return
	 spread_obj_node__80_bdb_spread_obj_171(
	 (node_bglt) (node_1319));
   }
}



/* spread-obj-node!-default1458 */
node_bglt 
spread_obj_node__default1458_118_bdb_spread_obj_171(node_bglt node_4)
{
   AN_OBJECT;
   {	/* Bdb/spread-obj.scm 14 */
      return node_4;
   }
}



/* _spread-obj-node!-default1458 */
obj_t 
_spread_obj_node__default1458_232_bdb_spread_obj_171(obj_t env_1320, obj_t node_1321)
{
   AN_OBJECT;
   {	/* Bdb/spread-obj.scm 14 */
      {		/* Bdb/spread-obj.scm 14 */
	 node_bglt aux_1634;
	 aux_1634 =
	    spread_obj_node__default1458_118_bdb_spread_obj_171(
	    (node_bglt) (node_1321));
	 return
	    (obj_t) (aux_1634);
      }
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_bdb_spread_obj_171()
{
   AN_OBJECT;
   {	/* Bdb/spread-obj.scm 14 */
      module_initialization_70_tools_speek(((long) 0), "BDB_SPREAD-OBJ");
      module_initialization_70_tools_error(((long) 0), "BDB_SPREAD-OBJ");
      module_initialization_70_engine_pass(((long) 0), "BDB_SPREAD-OBJ");
      module_initialization_70_type_type(((long) 0), "BDB_SPREAD-OBJ");
      module_initialization_70_ast_var(((long) 0), "BDB_SPREAD-OBJ");
      module_initialization_70_ast_node(((long) 0), "BDB_SPREAD-OBJ");
      module_initialization_70_tools_shape(((long) 0), "BDB_SPREAD-OBJ");
      module_initialization_70_tools_misc(((long) 0), "BDB_SPREAD-OBJ");
      module_initialization_70_type_env(((long) 0), "BDB_SPREAD-OBJ");
      module_initialization_70_type_cache(((long) 0), "BDB_SPREAD-OBJ");
      module_initialization_70_ast_sexp(((long) 0), "BDB_SPREAD-OBJ");
      return
	 module_initialization_70_engine_param(((long) 0), "BDB_SPREAD-OBJ");
   }
}
