/*===========================================================================*/
/*   (Bdb/walk.scm)                                                          */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;


static obj_t method_init_76_bdb_walk();
extern obj_t current_error_port;
extern obj_t _nb_error_on_pass__70_tools_error;
static obj_t _bdb_walk__166_bdb_walk(obj_t, obj_t);
extern obj_t verbose_tools_speek(obj_t, obj_t);
extern obj_t module_initialization_70_bdb_walk(long, char *);
extern obj_t module_initialization_70_tools_speek(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_engine_pass(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_ast_remove(long, char *);
extern obj_t module_initialization_70_bdb_initialize(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_numbers_6_5(long, char *);
extern obj_t module_initialization_70___r4_output_6_10_3(long, char *);
extern obj_t display_2_122___r4_output_6_10_3(obj_t, obj_t);
static obj_t imported_modules_init_94_bdb_walk();
extern obj_t append_2_18___r4_pairs_and_lists_6_3(obj_t, obj_t);
static obj_t library_modules_init_112_bdb_walk();
extern obj_t open_input_string(obj_t);
extern obj_t initialize_ast_128_bdb_initialize();
extern obj_t string_to_bstring(char *);
extern obj_t bdb_walk__231_bdb_walk(obj_t);
extern obj_t internal_error_43_tools_error(obj_t, obj_t, obj_t);
extern bool_t _2__206___r4_numbers_6_5(obj_t, obj_t);
extern obj_t read___reader(obj_t);
static obj_t require_initialization_114_bdb_walk = BUNSPEC;
static obj_t cnst_init_137_bdb_walk();
extern obj_t _current_pass__25_engine_pass;
static obj_t __cnst[1];

DEFINE_EXPORT_PROCEDURE(bdb_walk__env_198_bdb_walk, _bdb_walk__166_bdb_walk1564, _bdb_walk__166_bdb_walk, 0L, 1);
DEFINE_STRING(string1559_bdb_walk, string1559_bdb_walk1565, "PASS-STARTED ", 13);
DEFINE_STRING(string1558_bdb_walk, string1558_bdb_walk1566, "failure during postlude hook", 28);
DEFINE_STRING(string1557_bdb_walk, string1557_bdb_walk1567, " occured, ending ...", 20);
DEFINE_STRING(string1556_bdb_walk, string1556_bdb_walk1568, " error", 6);
DEFINE_STRING(string1555_bdb_walk, string1555_bdb_walk1569, "failure during prelude hook", 27);
DEFINE_STRING(string1554_bdb_walk, string1554_bdb_walk1570, "   . ", 5);
DEFINE_STRING(string1553_bdb_walk, string1553_bdb_walk1571, "Bdb", 3);



/* module-initialization */
obj_t 
module_initialization_70_bdb_walk(long checksum_1089, char *from_1090)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_bdb_walk))
	{
	   require_initialization_114_bdb_walk =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_bdb_walk();
	   cnst_init_137_bdb_walk();
	   imported_modules_init_94_bdb_walk();
	   method_init_76_bdb_walk();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_bdb_walk()
{
   AN_OBJECT;
   {	/* Bdb/walk.scm 14 */
      module_initialization_70___r4_output_6_10_3(((long) 0), "BDB_WALK");
      module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "BDB_WALK");
      module_initialization_70___r4_numbers_6_5(((long) 0), "BDB_WALK");
      module_initialization_70___reader(((long) 0), "BDB_WALK");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_bdb_walk()
{
   AN_OBJECT;
   {	/* Bdb/walk.scm 14 */
      {		/* Bdb/walk.scm 14 */
	 obj_t cnst_port_138_1082;
	 cnst_port_138_1082 =
	    open_input_string(string1559_bdb_walk);
	 {
	    long i_1083;
	    i_1083 = ((long) 0);
	  loop_1084:
	    {	/* Bdb/walk.scm 14 */
	       bool_t test1560_1085;
	       test1560_1085 =
		  (i_1083 == ((long) -1));
	       if (test1560_1085)
		 {	/* Bdb/walk.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Bdb/walk.scm 14 */
		    {	/* Bdb/walk.scm 14 */
		       obj_t arg1561_1086;
		       {	/* Bdb/walk.scm 14 */
			  obj_t list1562_1087;
			  list1562_1087 =
			     MAKE_PAIR(cnst_port_138_1082, BNIL);
			  arg1561_1086 =
			     read___reader(list1562_1087);
		       }
		       CNST_TABLE_SET(i_1083, arg1561_1086);
		    }
		    {	/* Bdb/walk.scm 14 */
		       int aux_1088;
		       {	/* Bdb/walk.scm 14 */
			  long aux_1108;
			  aux_1108 =
			     (i_1083 - ((long) 1));
			  aux_1088 =
			     (int) (aux_1108);
		       }
		       {
			  long i_1111;
			  i_1111 =
			     (long) (aux_1088);
			  i_1083 = i_1111;
			  goto loop_1084;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* bdb-walk! */
obj_t 
bdb_walk__231_bdb_walk(obj_t globals_1)
{
   AN_OBJECT;
   {	/* Bdb/walk.scm 29 */
      {		/* Bdb/walk.scm 29 */
	 obj_t list1438_697;
	 {	/* Bdb/walk.scm 29 */
	    obj_t arg1440_699;
	    {	/* Bdb/walk.scm 29 */
	       obj_t arg1442_701;
	       {	/* Bdb/walk.scm 29 */
		  obj_t aux_1113;
		  aux_1113 =
		     BCHAR(((unsigned char) '\n'));
		  arg1442_701 =
		     MAKE_PAIR(aux_1113, BNIL);
	       }
	       arg1440_699 =
		  MAKE_PAIR(string1553_bdb_walk, arg1442_701);
	    }
	    list1438_697 =
	       MAKE_PAIR(string1554_bdb_walk, arg1440_699);
	 }
	 verbose_tools_speek(
	    BINT(((long) 1)), list1438_697);
      }
      _nb_error_on_pass__70_tools_error =
	 BINT(((long) 0));
      _current_pass__25_engine_pass = string1553_bdb_walk;
      {
	 obj_t hooks_702;
	 obj_t hnames_703;
	 hooks_702 = BNIL;
	 hnames_703 = BNIL;
       loop_704:
	 if (
	    NULLP(hooks_702))
	   {	/* Bdb/walk.scm 29 */
	      CNST_TABLE_REF(((long) 0));
	   }
	 else
	   {	/* Bdb/walk.scm 29 */
	      bool_t test1447_709;
	      {		/* Bdb/walk.scm 29 */
		 obj_t fun1455_715;
		 fun1455_715 =
		    CAR(hooks_702);
		 {	/* Bdb/walk.scm 29 */
		    obj_t aux_1125;
		    aux_1125 =
		       PROCEDURE_ENTRY(fun1455_715) (fun1455_715, BEOA);
		    test1447_709 =
		       CBOOL(aux_1125);
		 }
	      }
	      if (test1447_709)
		{	/* Bdb/walk.scm 29 */
		   {
		      obj_t hnames_1132;
		      obj_t hooks_1130;
		      hooks_1130 =
			 CDR(hooks_702);
		      hnames_1132 =
			 CDR(hnames_703);
		      hnames_703 = hnames_1132;
		      hooks_702 = hooks_1130;
		      goto loop_704;
		   }
		}
	      else
		{	/* Bdb/walk.scm 29 */
		   internal_error_43_tools_error(string1553_bdb_walk, string1555_bdb_walk,
		      CAR(hnames_703));
		}
	   }
      }
      {		/* Bdb/walk.scm 31 */
	 obj_t value_716;
	 {	/* Bdb/walk.scm 31 */
	    obj_t arg1472_735;
	    arg1472_735 =
	       initialize_ast_128_bdb_initialize();
	    value_716 =
	       append_2_18___r4_pairs_and_lists_6_3(arg1472_735, globals_1);
	 }
	 {	/* Bdb/walk.scm 31 */
	    bool_t test1456_717;
	    {	/* Bdb/walk.scm 31 */
	       long n1_1068;
	       n1_1068 =
		  (long) CINT(_nb_error_on_pass__70_tools_error);
	       test1456_717 =
		  (n1_1068 > ((long) 0));
	    }
	    if (test1456_717)
	      {		/* Bdb/walk.scm 31 */
		 display_2_122___r4_output_6_10_3(_nb_error_on_pass__70_tools_error, current_error_port);
		 display_2_122___r4_output_6_10_3(string1556_bdb_walk, current_error_port);
		 {	/* Bdb/walk.scm 31 */
		    char *arg1457_719;
		    {	/* Bdb/walk.scm 31 */
		       bool_t test1458_720;
		       {	/* Bdb/walk.scm 31 */
			  bool_t test1459_721;
			  {	/* Bdb/walk.scm 31 */
			     obj_t obj_1070;
			     obj_1070 = _nb_error_on_pass__70_tools_error;
			     test1459_721 =
				INTEGERP(obj_1070);
			  }
			  if (test1459_721)
			    {	/* Bdb/walk.scm 31 */
			       test1458_720 =
				  _2__206___r4_numbers_6_5(_nb_error_on_pass__70_tools_error,
				  BINT(((long) 1)));
			    }
			  else
			    {	/* Bdb/walk.scm 31 */
			       test1458_720 = ((bool_t) 0);
			    }
		       }
		       if (test1458_720)
			 {	/* Bdb/walk.scm 31 */
			    arg1457_719 = "s";
			 }
		       else
			 {	/* Bdb/walk.scm 31 */
			    arg1457_719 = "";
			 }
		    }
		    display_2_122___r4_output_6_10_3(
		       string_to_bstring(arg1457_719), current_error_port);
		 }
		 display_2_122___r4_output_6_10_3(string1557_bdb_walk, current_error_port);
		 WRITE_CHAR(((unsigned char) '\n'), current_error_port);
		 {	/* Bdb/walk.scm 31 */
		    obj_t res1552_1073;
		    exit(((long) -1));
		    res1552_1073 =
		       BINT(((long) -1));
		    return res1552_1073;
		 }
	      }
	    else
	      {
		 obj_t hooks_722;
		 obj_t hnames_723;
		 hooks_722 = BNIL;
		 hnames_723 = BNIL;
	       loop_724:
		 if (
		    NULLP(hooks_722))
		   {	/* Bdb/walk.scm 31 */
		      return value_716;
		   }
		 else
		   {	/* Bdb/walk.scm 31 */
		      bool_t test1465_729;
		      {		/* Bdb/walk.scm 31 */
			 obj_t fun1471_734;
			 fun1471_734 =
			    CAR(hooks_722);
			 {	/* Bdb/walk.scm 31 */
			    obj_t aux_1157;
			    aux_1157 =
			       PROCEDURE_ENTRY(fun1471_734) (fun1471_734, BEOA);
			    test1465_729 =
			       CBOOL(aux_1157);
			 }
		      }
		      if (test1465_729)
			{	/* Bdb/walk.scm 31 */
			   {
			      obj_t hnames_1164;
			      obj_t hooks_1162;
			      hooks_1162 =
				 CDR(hooks_722);
			      hnames_1164 =
				 CDR(hnames_723);
			      hnames_723 = hnames_1164;
			      hooks_722 = hooks_1162;
			      goto loop_724;
			   }
			}
		      else
			{	/* Bdb/walk.scm 31 */
			   return
			      internal_error_43_tools_error(_current_pass__25_engine_pass, string1558_bdb_walk,
			      CAR(hnames_723));
			}
		   }
	      }
	 }
      }
   }
}



/* _bdb-walk! */
obj_t 
_bdb_walk__166_bdb_walk(obj_t env_1080, obj_t globals_1081)
{
   AN_OBJECT;
   {	/* Bdb/walk.scm 29 */
      return
	 bdb_walk__231_bdb_walk(globals_1081);
   }
}



/* method-init */
obj_t 
method_init_76_bdb_walk()
{
   AN_OBJECT;
   {	/* Bdb/walk.scm 14 */
      return BUNSPEC;
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_bdb_walk()
{
   AN_OBJECT;
   {	/* Bdb/walk.scm 14 */
      module_initialization_70_tools_speek(((long) 0), "BDB_WALK");
      module_initialization_70_tools_error(((long) 0), "BDB_WALK");
      module_initialization_70_engine_pass(((long) 0), "BDB_WALK");
      module_initialization_70_tools_shape(((long) 0), "BDB_WALK");
      module_initialization_70_engine_param(((long) 0), "BDB_WALK");
      module_initialization_70_type_type(((long) 0), "BDB_WALK");
      module_initialization_70_ast_var(((long) 0), "BDB_WALK");
      module_initialization_70_ast_node(((long) 0), "BDB_WALK");
      module_initialization_70_ast_remove(((long) 0), "BDB_WALK");
      return
	 module_initialization_70_bdb_initialize(((long) 0), "BDB_WALK");
   }
}
