/*===========================================================================*/
/*   (Callcc/walk.scm)                                                       */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;

typedef struct local_cell_149
  {
     char dummy;
  }
              *local_cell_149_bglt;


static obj_t method_init_76_callcc_walk();
extern obj_t make_box_202_ast_node;
extern obj_t funcall_ast_node;
extern long add_inlined_method__244___object(obj_t, obj_t, long);
extern obj_t current_error_port;
extern obj_t fail_ast_node;
extern obj_t _nb_error_on_pass__70_tools_error;
extern obj_t box_ref_242_ast_node;
static bool_t callcc_fun__197_callcc_walk(obj_t);
static local_bglt allocate_local_cell_184_callcc_walk();
static obj_t local_cell_149_callcc_walk = BUNSPEC;
extern obj_t sequence_ast_node;
extern obj_t let_var_6_ast_node;
extern obj_t var_ast_node;
extern obj_t callcc_walk__209_callcc_walk(obj_t);
extern object_bglt struct_object__object_93___object(object_bglt, obj_t);
extern obj_t add_method__1___object(obj_t, obj_t, obj_t);
extern obj_t global_ast_var;
extern obj_t _obj__252_type_cache;
extern obj_t pragma_ast_node;
static node_bglt callcc__192_callcc_walk(node_bglt);
extern obj_t set_ex_it_116_ast_node;
extern obj_t find_super_class_method_167___object(object_bglt, obj_t, obj_t);
extern obj_t verbose_tools_speek(obj_t, obj_t);
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t module_initialization_70_callcc_walk(long, char *);
extern obj_t module_initialization_70_tools_speek(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_engine_pass(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_ast_local(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_numbers_6_5(long, char *);
extern obj_t module_initialization_70___r4_output_6_10_3(long, char *);
static obj_t struct_object__object_local_cell1549_209_callcc_walk(obj_t, obj_t, obj_t);
extern local_bglt make_local_svar_140_ast_local(obj_t, type_bglt);
extern long class_num_218___object(obj_t);
extern obj_t display_2_122___r4_output_6_10_3(obj_t, obj_t);
extern obj_t let_fun_218_ast_node;
static obj_t imported_modules_init_94_callcc_walk();
static obj_t _callcc_walk__182_callcc_walk(obj_t, obj_t);
static bool_t celled__113_callcc_walk(variable_bglt);
static obj_t celled_bindings_3_callcc_walk(obj_t);
extern obj_t app_ly_162_ast_node;
extern obj_t add_generic__110___object(obj_t, obj_t);
extern obj_t app_ast_node;
static obj_t library_modules_init_112_callcc_walk();
extern obj_t make_struct(obj_t, long, obj_t);
extern obj_t atom_ast_node;
extern obj_t cast_ast_node;
static obj_t toplevel_init_63_callcc_walk();
static obj_t _callcc_1849_195_callcc_walk(obj_t, obj_t);
extern obj_t create_vector(long);
extern obj_t jump_ex_it_184_ast_node;
extern obj_t open_input_string(obj_t);
extern obj_t kwote_ast_node;
static make_box_202_bglt a_make_cell_117_callcc_walk(node_bglt, variable_bglt);
extern obj_t setq_ast_node;
extern obj_t box_set__221_ast_node;
extern obj_t string_to_bstring(char *);
static obj_t _callcc__default1500_14_callcc_walk(obj_t, obj_t);
extern obj_t local_ast_var;
static obj_t callcc___127_callcc_walk(obj_t);
static obj_t object__struct_local_cell1547_15_callcc_walk(obj_t, obj_t);
static node_bglt cell_formals_12_callcc_walk(obj_t, node_bglt);
extern obj_t register_class__225___object(obj_t, obj_t, obj_t, long, obj_t, obj_t, obj_t);
extern obj_t _compiler_debug__134_engine_param;
extern obj_t internal_error_43_tools_error(obj_t, obj_t, obj_t);
static obj_t object_init_111_callcc_walk();
extern obj_t _classes__134___object;
extern obj_t select_ast_node;
static obj_t _allocate_local_cell_31_callcc_walk(obj_t);
extern bool_t _2__206___r4_numbers_6_5(obj_t, obj_t);
extern obj_t read___reader(obj_t);
extern obj_t object__struct_50___object(object_bglt);
extern obj_t ____74_type_cache;
static node_bglt callcc__default1500_156_callcc_walk(node_bglt);
static obj_t require_initialization_114_callcc_walk = BUNSPEC;
extern obj_t conditional_ast_node;
static obj_t cnst_init_137_callcc_walk();
extern obj_t _current_pass__25_engine_pass;
static obj_t __cnst[7];

DEFINE_STATIC_GENERIC(callcc__env_142_callcc_walk, _callcc_1849_195_callcc_walk1864, _callcc_1849_195_callcc_walk, 0L, 1);
DEFINE_STATIC_PROCEDURE(callcc__default1500_env_108_callcc_walk, _callcc__default1500_14_callcc_walk1865, _callcc__default1500_14_callcc_walk, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc1857_callcc_walk, struct_object__object_local_cell1549_209_callcc_walk1866, struct_object__object_local_cell1549_209_callcc_walk, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc1856_callcc_walk, object__struct_local_cell1547_15_callcc_walk1867, object__struct_local_cell1547_15_callcc_walk, 0L, 1);
extern obj_t struct_object__object_env_209___object;
DEFINE_STATIC_PROCEDURE(allocate_local_cell_env_161_callcc_walk, _allocate_local_cell_31_callcc_walk1868, _allocate_local_cell_31_callcc_walk, 0L, 0);
DEFINE_EXPORT_PROCEDURE(callcc_walk__env_78_callcc_walk, _callcc_walk__182_callcc_walk1869, _callcc_walk__182_callcc_walk, 0L, 1);
DEFINE_STRING(string1859_callcc_walk, string1859_callcc_walk1870, "CALLCC!-DEFAULT1500 AUX LOCAL/CELL DONE WRITE CELL-CALLCC PASS-STARTED ", 71);
DEFINE_STRING(string1858_callcc_walk, string1858_callcc_walk1871, "No method for this object", 25);
DEFINE_STRING(string1855_callcc_walk, string1855_callcc_walk1872, "failure during postlude hook", 28);
DEFINE_STRING(string1854_callcc_walk, string1854_callcc_walk1873, " occured, ending ...", 20);
DEFINE_STRING(string1853_callcc_walk, string1853_callcc_walk1874, " error", 6);
DEFINE_STRING(string1852_callcc_walk, string1852_callcc_walk1875, "failure during prelude hook", 27);
DEFINE_STRING(string1851_callcc_walk, string1851_callcc_walk1876, "   . ", 5);
DEFINE_STRING(string1850_callcc_walk, string1850_callcc_walk1877, "Callcc", 6);
extern obj_t object__struct_env_210___object;



/* module-initialization */
obj_t 
module_initialization_70_callcc_walk(long checksum_1846, char *from_1847)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_callcc_walk))
	{
	   require_initialization_114_callcc_walk =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_callcc_walk();
	   cnst_init_137_callcc_walk();
	   imported_modules_init_94_callcc_walk();
	   object_init_111_callcc_walk();
	   method_init_76_callcc_walk();
	   toplevel_init_63_callcc_walk();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_callcc_walk()
{
   AN_OBJECT;
   {	/* Callcc/walk.scm 15 */
      module_initialization_70___object(((long) 0), "CALLCC_WALK");
      module_initialization_70___r4_output_6_10_3(((long) 0), "CALLCC_WALK");
      module_initialization_70___r4_numbers_6_5(((long) 0), "CALLCC_WALK");
      module_initialization_70___reader(((long) 0), "CALLCC_WALK");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_callcc_walk()
{
   AN_OBJECT;
   {	/* Callcc/walk.scm 15 */
      {		/* Callcc/walk.scm 15 */
	 obj_t cnst_port_138_1839;
	 cnst_port_138_1839 =
	    open_input_string(string1859_callcc_walk);
	 {
	    long i_1840;
	    i_1840 = ((long) 6);
	  loop_1841:
	    {	/* Callcc/walk.scm 15 */
	       bool_t test1860_1842;
	       test1860_1842 =
		  (i_1840 == ((long) -1));
	       if (test1860_1842)
		 {	/* Callcc/walk.scm 15 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Callcc/walk.scm 15 */
		    {	/* Callcc/walk.scm 15 */
		       obj_t arg1861_1843;
		       {	/* Callcc/walk.scm 15 */
			  obj_t list1862_1844;
			  list1862_1844 =
			     MAKE_PAIR(cnst_port_138_1839, BNIL);
			  arg1861_1843 =
			     read___reader(list1862_1844);
		       }
		       CNST_TABLE_SET(i_1840, arg1861_1843);
		    }
		    {	/* Callcc/walk.scm 15 */
		       int aux_1845;
		       {	/* Callcc/walk.scm 15 */
			  long aux_1867;
			  aux_1867 =
			     (i_1840 - ((long) 1));
			  aux_1845 =
			     (int) (aux_1867);
		       }
		       {
			  long i_1870;
			  i_1870 =
			     (long) (aux_1845);
			  i_1840 = i_1870;
			  goto loop_1841;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_callcc_walk()
{
   AN_OBJECT;
   {	/* Callcc/walk.scm 15 */
      return BUNSPEC;
   }
}



/* callcc-walk! */
obj_t 
callcc_walk__209_callcc_walk(obj_t globals_1)
{
   AN_OBJECT;
   {	/* Callcc/walk.scm 29 */
      {		/* Callcc/walk.scm 29 */
	 obj_t list1550_767;
	 {	/* Callcc/walk.scm 29 */
	    obj_t arg1552_769;
	    {	/* Callcc/walk.scm 29 */
	       obj_t arg1555_771;
	       {	/* Callcc/walk.scm 29 */
		  obj_t aux_1872;
		  aux_1872 =
		     BCHAR(((unsigned char) '\n'));
		  arg1555_771 =
		     MAKE_PAIR(aux_1872, BNIL);
	       }
	       arg1552_769 =
		  MAKE_PAIR(string1850_callcc_walk, arg1555_771);
	    }
	    list1550_767 =
	       MAKE_PAIR(string1851_callcc_walk, arg1552_769);
	 }
	 verbose_tools_speek(
	    BINT(((long) 1)), list1550_767);
      }
      _nb_error_on_pass__70_tools_error =
	 BINT(((long) 0));
      _current_pass__25_engine_pass = string1850_callcc_walk;
      {
	 obj_t hooks_772;
	 obj_t hnames_773;
	 hooks_772 = BNIL;
	 hnames_773 = BNIL;
       loop_774:
	 if (
	    NULLP(hooks_772))
	   {	/* Callcc/walk.scm 29 */
	      CNST_TABLE_REF(((long) 0));
	   }
	 else
	   {	/* Callcc/walk.scm 29 */
	      bool_t test1560_779;
	      {		/* Callcc/walk.scm 29 */
		 obj_t fun1566_785;
		 fun1566_785 =
		    CAR(hooks_772);
		 {	/* Callcc/walk.scm 29 */
		    obj_t aux_1884;
		    aux_1884 =
		       PROCEDURE_ENTRY(fun1566_785) (fun1566_785, BEOA);
		    test1560_779 =
		       CBOOL(aux_1884);
		 }
	      }
	      if (test1560_779)
		{	/* Callcc/walk.scm 29 */
		   {
		      obj_t hnames_1891;
		      obj_t hooks_1889;
		      hooks_1889 =
			 CDR(hooks_772);
		      hnames_1891 =
			 CDR(hnames_773);
		      hnames_773 = hnames_1891;
		      hooks_772 = hooks_1889;
		      goto loop_774;
		   }
		}
	      else
		{	/* Callcc/walk.scm 29 */
		   internal_error_43_tools_error(string1850_callcc_walk, string1852_callcc_walk,
		      CAR(hnames_773));
		}
	   }
      }
      {		/* Callcc/walk.scm 32 */
	 bool_t test1567_786;
	 {	/* Callcc/walk.scm 32 */
	    long n1_1411;
	    n1_1411 =
	       (long) CINT(_compiler_debug__134_engine_param);
	    test1567_786 =
	       (n1_1411 > ((long) 2));
	 }
	 if (test1567_786)
	   {	/* Callcc/walk.scm 32 */
	      _compiler_debug__134_engine_param =
		 BINT(((long) 2));
	   }
	 else
	   {	/* Callcc/walk.scm 32 */
	      BUNSPEC;
	   }
      }
      {
	 obj_t l1459_787;
	 l1459_787 = globals_1;
       lname1460_788:
	 if (
	    PAIRP(l1459_787))
	   {	/* Callcc/walk.scm 34 */
	      callcc_fun__197_callcc_walk(
		 CAR(l1459_787));
	      {
		 obj_t l1459_1903;
		 l1459_1903 =
		    CDR(l1459_787);
		 l1459_787 = l1459_1903;
		 goto lname1460_788;
	      }
	   }
	 else
	   {	/* Callcc/walk.scm 34 */
	      ((bool_t) 1);
	   }
      }
      {		/* Callcc/walk.scm 35 */
	 bool_t test1572_793;
	 {	/* Callcc/walk.scm 35 */
	    long n1_1416;
	    n1_1416 =
	       (long) CINT(_nb_error_on_pass__70_tools_error);
	    test1572_793 =
	       (n1_1416 > ((long) 0));
	 }
	 if (test1572_793)
	   {	/* Callcc/walk.scm 35 */
	      display_2_122___r4_output_6_10_3(_nb_error_on_pass__70_tools_error, current_error_port);
	      display_2_122___r4_output_6_10_3(string1853_callcc_walk, current_error_port);
	      {		/* Callcc/walk.scm 35 */
		 char *arg1573_795;
		 {	/* Callcc/walk.scm 35 */
		    bool_t test1574_796;
		    {	/* Callcc/walk.scm 35 */
		       bool_t test1575_797;
		       {	/* Callcc/walk.scm 35 */
			  obj_t obj_1418;
			  obj_1418 = _nb_error_on_pass__70_tools_error;
			  test1575_797 =
			     INTEGERP(obj_1418);
		       }
		       if (test1575_797)
			 {	/* Callcc/walk.scm 35 */
			    test1574_796 =
			       _2__206___r4_numbers_6_5(_nb_error_on_pass__70_tools_error,
			       BINT(((long) 1)));
			 }
		       else
			 {	/* Callcc/walk.scm 35 */
			    test1574_796 = ((bool_t) 0);
			 }
		    }
		    if (test1574_796)
		      {		/* Callcc/walk.scm 35 */
			 arg1573_795 = "s";
		      }
		    else
		      {		/* Callcc/walk.scm 35 */
			 arg1573_795 = "";
		      }
		 }
		 display_2_122___r4_output_6_10_3(
		    string_to_bstring(arg1573_795), current_error_port);
	      }
	      display_2_122___r4_output_6_10_3(string1854_callcc_walk, current_error_port);
	      WRITE_CHAR(((unsigned char) '\n'), current_error_port);
	      {		/* Callcc/walk.scm 35 */
		 obj_t res1834_1421;
		 exit(((long) -1));
		 res1834_1421 =
		    BINT(((long) -1));
		 return res1834_1421;
	      }
	   }
	 else
	   {
	      obj_t hooks_798;
	      obj_t hnames_799;
	      hooks_798 = BNIL;
	      hnames_799 = BNIL;
	    loop_800:
	      if (
		 NULLP(hooks_798))
		{	/* Callcc/walk.scm 35 */
		   return globals_1;
		}
	      else
		{	/* Callcc/walk.scm 35 */
		   bool_t test1580_805;
		   {	/* Callcc/walk.scm 35 */
		      obj_t fun1585_810;
		      fun1585_810 =
			 CAR(hooks_798);
		      {		/* Callcc/walk.scm 35 */
			 obj_t aux_1924;
			 aux_1924 =
			    PROCEDURE_ENTRY(fun1585_810) (fun1585_810, BEOA);
			 test1580_805 =
			    CBOOL(aux_1924);
		      }
		   }
		   if (test1580_805)
		     {	/* Callcc/walk.scm 35 */
			{
			   obj_t hnames_1931;
			   obj_t hooks_1929;
			   hooks_1929 =
			      CDR(hooks_798);
			   hnames_1931 =
			      CDR(hnames_799);
			   hnames_799 = hnames_1931;
			   hooks_798 = hooks_1929;
			   goto loop_800;
			}
		     }
		   else
		     {	/* Callcc/walk.scm 35 */
			return
			   internal_error_43_tools_error(_current_pass__25_engine_pass, string1855_callcc_walk,
			   CAR(hnames_799));
		     }
		}
	   }
      }
   }
}



/* _callcc-walk! */
obj_t 
_callcc_walk__182_callcc_walk(obj_t env_1820, obj_t globals_1821)
{
   AN_OBJECT;
   {	/* Callcc/walk.scm 29 */
      return
	 callcc_walk__209_callcc_walk(globals_1821);
   }
}



/* callcc-fun! */
bool_t 
callcc_fun__197_callcc_walk(obj_t var_2)
{
   AN_OBJECT;
   {	/* Callcc/walk.scm 40 */
      {		/* Callcc/walk.scm 41 */
	 value_bglt fun_811;
	 {	/* Callcc/walk.scm 41 */
	    variable_bglt obj_1428;
	    obj_1428 =
	       (variable_bglt) (var_2);
	    fun_811 =
	       (((variable_bglt) CREF(obj_1428))->value);
	 }
	 {	/* Callcc/walk.scm 41 */
	    obj_t body_812;
	    {	/* Callcc/walk.scm 42 */
	       sfun_bglt obj_1429;
	       obj_1429 =
		  (sfun_bglt) (fun_811);
	       body_812 =
		  (((sfun_bglt) CREF(obj_1429))->body);
	    }
	    {	/* Callcc/walk.scm 42 */
	       obj_t celled_813;
	       {	/* Callcc/walk.scm 43 */
		  obj_t aux_1940;
		  {	/* Callcc/walk.scm 43 */
		     sfun_bglt obj_1430;
		     obj_1430 =
			(sfun_bglt) (fun_811);
		     aux_1940 =
			(((sfun_bglt) CREF(obj_1430))->args);
		  }
		  celled_813 =
		     celled_bindings_3_callcc_walk(aux_1940);
	       }
	       {	/* Callcc/walk.scm 43 */

		  {
		     obj_t l1462_814;
		     l1462_814 = celled_813;
		   lname1463_815:
		     if (
			PAIRP(l1462_814))
		       {	/* Callcc/walk.scm 45 */
			  {	/* Callcc/walk.scm 46 */
			     obj_t w_b_127_817;
			     w_b_127_817 =
				CAR(l1462_814);
			     {	/* Callcc/walk.scm 46 */
				obj_t arg1588_819;
				arg1588_819 =
				   CDR(w_b_127_817);
				{	/* Callcc/walk.scm 46 */
				   local_bglt obj_1435;
				   {	/* Callcc/walk.scm 46 */
				      obj_t aux_1948;
				      aux_1948 =
					 CAR(w_b_127_817);
				      obj_1435 =
					 (local_bglt) (aux_1948);
				   }
				   ((((local_bglt) CREF(obj_1435))->fast_alpha_7) = ((obj_t) arg1588_819), BUNSPEC);
				}
			     }
			  }
			  {
			     obj_t l1462_1952;
			     l1462_1952 =
				CDR(l1462_814);
			     l1462_814 = l1462_1952;
			     goto lname1463_815;
			  }
		       }
		     else
		       {	/* Callcc/walk.scm 45 */
			  ((bool_t) 1);
		       }
		  }
		  {	/* Callcc/walk.scm 48 */
		     node_bglt arg1590_821;
		     {	/* Callcc/walk.scm 48 */
			node_bglt arg1591_822;
			arg1591_822 =
			   callcc__192_callcc_walk(
			   (node_bglt) (body_812));
			arg1590_821 =
			   cell_formals_12_callcc_walk(celled_813, arg1591_822);
		     }
		     {	/* Callcc/walk.scm 48 */
			sfun_bglt obj_1438;
			obj_t val1123_1439;
			obj_1438 =
			   (sfun_bglt) (fun_811);
			val1123_1439 =
			   (obj_t) (arg1590_821);
			((((sfun_bglt) CREF(obj_1438))->body) = ((obj_t) val1123_1439), BUNSPEC);
		     }
		  }
		  {
		     obj_t l1464_823;
		     l1464_823 = celled_813;
		   lname1465_824:
		     if (
			PAIRP(l1464_823))
		       {	/* Callcc/walk.scm 50 */
			  {	/* Callcc/walk.scm 51 */
			     local_bglt obj_1443;
			     {	/* Callcc/walk.scm 51 */
				obj_t aux_1962;
				{	/* ./Ieee/pair-list.scm 5701 */
				   obj_t aux_1963;
				   aux_1963 =
				      CAR(l1464_823);
				   aux_1962 =
				      CAR(aux_1963);
				}
				obj_1443 =
				   (local_bglt) (aux_1962);
			     }
			     ((((local_bglt) CREF(obj_1443))->fast_alpha_7) = ((obj_t) BUNSPEC), BUNSPEC);
			  }
			  {
			     obj_t l1464_1968;
			     l1464_1968 =
				CDR(l1464_823);
			     l1464_823 = l1464_1968;
			     goto lname1465_824;
			  }
		       }
		     else
		       {	/* Callcc/walk.scm 50 */
			  return ((bool_t) 1);
		       }
		  }
	       }
	    }
	 }
      }
   }
}



/* celled-bindings */
obj_t 
celled_bindings_3_callcc_walk(obj_t formals_3)
{
   AN_OBJECT;
   {	/* Callcc/walk.scm 57 */
      {
	 obj_t celled_830;
	 obj_t formals_831;
	 celled_830 = BNIL;
	 formals_831 = formals_3;
       loop_832:
	 if (
	    NULLP(formals_831))
	   {	/* Callcc/walk.scm 61 */
	      return celled_830;
	   }
	 else
	   {	/* Callcc/walk.scm 63 */
	      bool_t test_1972;
	      {		/* Callcc/walk.scm 63 */
		 variable_bglt aux_1973;
		 {	/* Callcc/walk.scm 63 */
		    obj_t aux_1974;
		    aux_1974 =
		       CAR(formals_831);
		    aux_1973 =
		       (variable_bglt) (aux_1974);
		 }
		 test_1972 =
		    celled__113_callcc_walk(aux_1973);
	      }
	      if (test_1972)
		{	/* Callcc/walk.scm 63 */
		   {	/* Callcc/walk.scm 66 */
		      local_bglt var_835;
		      {		/* Callcc/walk.scm 66 */
			 obj_t aux_1978;
			 {	/* Callcc/walk.scm 66 */
			    local_bglt obj_1449;
			    {	/* Callcc/walk.scm 66 */
			       obj_t aux_1979;
			       aux_1979 =
				  CAR(formals_831);
			       obj_1449 =
				  (local_bglt) (aux_1979);
			    }
			    aux_1978 =
			       (((local_bglt) CREF(obj_1449))->id);
			 }
			 var_835 =
			    make_local_svar_140_ast_local(aux_1978,
			    (type_bglt) (_obj__252_type_cache));
		      }
		      {		/* Callcc/walk.scm 66 */
			 obj_t o_n_168_836;
			 {	/* ./Ieee/pair-list.scm 5689 */
			    obj_t aux_1987;
			    obj_t aux_1985;
			    aux_1987 =
			       (obj_t) (var_835);
			    aux_1985 =
			       CAR(formals_831);
			    o_n_168_836 =
			       MAKE_PAIR(aux_1985, aux_1987);
			 }
			 {	/* Callcc/walk.scm 67 */

			    {	/* Callcc/walk.scm 68 */
			       local_cell_149_bglt obj1466_837;
			       obj1466_837 =
				  ((local_cell_149_bglt) (var_835));
			       {	/* Callcc/walk.scm 68 */
				  obj_t aux_1993;
				  object_bglt aux_1991;
				  {	/* Callcc/walk.scm 68 */
				     local_cell_149_bglt aux_1994;
				     {	/* Callcc/walk.scm 23 */

					aux_1994 =
					   ((local_cell_149_bglt) BREF(GC_MALLOC(sizeof(struct local_cell_149))));
				     }
				     aux_1993 =
					(obj_t) (aux_1994);
				  }
				  aux_1991 =
				     (object_bglt) (obj1466_837);
				  OBJECT_WIDENING_SET(aux_1991, aux_1993);
			       }
			       {	/* Callcc/walk.scm 68 */
				  long arg1599_839;
				  arg1599_839 =
				     class_num_218___object(local_cell_149_callcc_walk);
				  {	/* Callcc/walk.scm 68 */
				     obj_t obj_1455;
				     obj_1455 =
					(obj_t) (obj1466_837);
				     (((obj_t) CREF(obj_1455))->header = MAKE_HEADER(arg1599_839, 0), BUNSPEC);
				  }
			       }
			       obj1466_837;
			    }
			    {	/* Callcc/walk.scm 69 */
			       obj_t arg1600_840;
			       obj_t arg1601_841;
			       arg1600_840 =
				  MAKE_PAIR(o_n_168_836, celled_830);
			       arg1601_841 =
				  CDR(formals_831);
			       {
				  obj_t formals_2004;
				  obj_t celled_2003;
				  celled_2003 = arg1600_840;
				  formals_2004 = arg1601_841;
				  formals_831 = formals_2004;
				  celled_830 = celled_2003;
				  goto loop_832;
			       }
			    }
			 }
		      }
		   }
		}
	      else
		{	/* Callcc/walk.scm 63 */
		   {
		      obj_t formals_2005;
		      formals_2005 =
			 CDR(formals_831);
		      formals_831 = formals_2005;
		      goto loop_832;
		   }
		}
	   }
      }
   }
}



/* cell-formals */
node_bglt 
cell_formals_12_callcc_walk(obj_t celled_4, node_bglt body_5)
{
   AN_OBJECT;
   {	/* Callcc/walk.scm 74 */
      {		/* Callcc/walk.scm 75 */
	 bool_t test1607_847;
	 test1607_847 =
	    NULLP(celled_4);
	 if (test1607_847)
	   {	/* Callcc/walk.scm 75 */
	      return body_5;
	   }
	 else
	   {	/* Callcc/walk.scm 77 */
	      obj_t loc_848;
	      loc_848 =
		 (((node_bglt) CREF(body_5))->loc);
	      {		/* Callcc/walk.scm 78 */
		 obj_t arg1609_850;
		 obj_t arg1611_852;
		 arg1609_850 = ____74_type_cache;
		 if (test1607_847)
		   {	/* Callcc/walk.scm 82 */
		      arg1611_852 = BNIL;
		   }
		 else
		   {	/* Callcc/walk.scm 82 */
		      obj_t head1470_856;
		      head1470_856 =
			 MAKE_PAIR(BNIL, BNIL);
		      {
			 obj_t l1468_857;
			 obj_t tail1471_858;
			 l1468_857 = celled_4;
			 tail1471_858 = head1470_856;
		       lname1469_859:
			 if (
			    NULLP(l1468_857))
			   {	/* Callcc/walk.scm 82 */
			      arg1611_852 =
				 CDR(head1470_856);
			   }
			 else
			   {	/* Callcc/walk.scm 83 */
			      obj_t newtail1472_861;
			      {		/* Callcc/walk.scm 83 */
				 obj_t arg1616_863;
				 {	/* Callcc/walk.scm 83 */
				    obj_t o_n_168_865;
				    o_n_168_865 =
				       CAR(l1468_857);
				    {	/* Callcc/walk.scm 83 */
				       obj_t arg1618_866;
				       make_box_202_bglt arg1619_867;
				       arg1618_866 =
					  CDR(o_n_168_865);
				       {	/* Callcc/walk.scm 84 */
					  var_bglt arg1620_868;
					  obj_t arg1621_869;
					  {	/* Callcc/walk.scm 84 */
					     obj_t arg1623_871;
					     arg1623_871 = ____74_type_cache;
					     {	/* Callcc/walk.scm 84 */
						var_bglt res1836_1481;
						{	/* Callcc/walk.scm 84 */
						   type_bglt type_1472;
						   variable_bglt variable_1473;
						   type_1472 =
						      (type_bglt) (arg1623_871);
						   {	/* Callcc/walk.scm 84 */
						      obj_t aux_2018;
						      aux_2018 =
							 CAR(o_n_168_865);
						      variable_1473 =
							 (variable_bglt) (aux_2018);
						   }
						   {	/* ./Ast/node.scm 986 */
						      var_bglt new1210_1474;
						      new1210_1474 =
							 ((var_bglt) BREF(GC_MALLOC(sizeof(struct var))));
						      {		/* ./Ast/node.scm 986 */
							 long arg1686_1475;
							 arg1686_1475 =
							    class_num_218___object(var_ast_node);
							 {	/* ./Ast/node.scm 986 */
							    obj_t obj_1479;
							    obj_1479 =
							       (obj_t) (new1210_1474);
							    (((obj_t) CREF(obj_1479))->header = MAKE_HEADER(arg1686_1475, 0), BUNSPEC);
							 }
						      }
						      {		/* ./Ast/node.scm 986 */
							 object_bglt aux_2025;
							 aux_2025 =
							    (object_bglt) (new1210_1474);
							 OBJECT_WIDENING_SET(aux_2025, BFALSE);
						      }
						      ((((var_bglt) CREF(new1210_1474))->loc) = ((obj_t) loc_848), BUNSPEC);
						      ((((var_bglt) CREF(new1210_1474))->type) = ((type_bglt) type_1472), BUNSPEC);
						      ((((var_bglt) CREF(new1210_1474))->variable) = ((variable_bglt) variable_1473), BUNSPEC);
						      res1836_1481 = new1210_1474;
						   }
						}
						arg1620_868 = res1836_1481;
					     }
					  }
					  arg1621_869 =
					     CAR(o_n_168_865);
					  arg1619_867 =
					     a_make_cell_117_callcc_walk(
					     (node_bglt) (arg1620_868),
					     (variable_bglt) (arg1621_869));
				       }
				       {	/* ./Ieee/pair-list.scm 5689 */
					  obj_t aux_2035;
					  aux_2035 =
					     (obj_t) (arg1619_867);
					  arg1616_863 =
					     MAKE_PAIR(arg1618_866, aux_2035);
				       }
				    }
				 }
				 newtail1472_861 =
				    MAKE_PAIR(arg1616_863, BNIL);
			      }
			      SET_CDR(tail1471_858, newtail1472_861);
			      {
				 obj_t tail1471_2042;
				 obj_t l1468_2040;
				 l1468_2040 =
				    CDR(l1468_857);
				 tail1471_2042 = newtail1472_861;
				 tail1471_858 = tail1471_2042;
				 l1468_857 = l1468_2040;
				 goto lname1469_859;
			      }
			   }
		      }
		   }
		 {	/* Callcc/walk.scm 78 */
		    let_var_6_bglt res1837_1508;
		    {	/* Callcc/walk.scm 78 */
		       type_bglt type_1491;
		       obj_t key_1493;
		       type_1491 =
			  (type_bglt) (arg1609_850);
		       key_1493 =
			  BINT(((long) -1));
		       {	/* ./Ast/node.scm 1079 */
			  let_var_6_bglt new1373_1497;
			  new1373_1497 =
			     ((let_var_6_bglt) BREF(GC_MALLOC(sizeof(struct let_var_6))));
			  {	/* ./Ast/node.scm 1079 */
			     long arg1657_1498;
			     arg1657_1498 =
				class_num_218___object(let_var_6_ast_node);
			     {	/* ./Ast/node.scm 1079 */
				obj_t obj_1506;
				obj_1506 =
				   (obj_t) (new1373_1497);
				(((obj_t) CREF(obj_1506))->header = MAKE_HEADER(arg1657_1498, 0), BUNSPEC);
			     }
			  }
			  {	/* ./Ast/node.scm 1079 */
			     object_bglt aux_2049;
			     aux_2049 =
				(object_bglt) (new1373_1497);
			     OBJECT_WIDENING_SET(aux_2049, BFALSE);
			  }
			  ((((let_var_6_bglt) CREF(new1373_1497))->loc) = ((obj_t) loc_848), BUNSPEC);
			  ((((let_var_6_bglt) CREF(new1373_1497))->type) = ((type_bglt) type_1491), BUNSPEC);
			  ((((let_var_6_bglt) CREF(new1373_1497))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
			  ((((let_var_6_bglt) CREF(new1373_1497))->key) = ((obj_t) key_1493), BUNSPEC);
			  ((((let_var_6_bglt) CREF(new1373_1497))->bindings) = ((obj_t) arg1611_852), BUNSPEC);
			  ((((let_var_6_bglt) CREF(new1373_1497))->body) = ((node_bglt) body_5), BUNSPEC);
			  ((((let_var_6_bglt) CREF(new1373_1497))->removable__42) = ((bool_t) ((bool_t) 1)), BUNSPEC);
			  res1837_1508 = new1373_1497;
		       }
		    }
		    return
		       (node_bglt) (res1837_1508);
		 }
	      }
	   }
      }
   }
}



/* a-make-cell */
make_box_202_bglt 
a_make_cell_117_callcc_walk(node_bglt node_6, variable_bglt variable_7)
{
   AN_OBJECT;
   {	/* Callcc/walk.scm 94 */
      {		/* Callcc/walk.scm 96 */
	 local_bglt obj_1509;
	 obj_t val1084_1510;
	 obj_1509 =
	    (local_bglt) (variable_7);
	 val1084_1510 =
	    CNST_TABLE_REF(((long) 1));
	 ((((local_bglt) CREF(obj_1509))->access) = ((obj_t) val1084_1510), BUNSPEC);
      }
      {		/* Callcc/walk.scm 97 */
	 local_cell_149_bglt obj1476_874;
	 obj1476_874 =
	    ((local_cell_149_bglt) (variable_7));
	 {	/* Callcc/walk.scm 97 */
	    obj_t aux_2066;
	    object_bglt aux_2064;
	    {	/* Callcc/walk.scm 97 */
	       local_cell_149_bglt aux_2067;
	       {	/* Callcc/walk.scm 23 */

		  aux_2067 =
		     ((local_cell_149_bglt) BREF(GC_MALLOC(sizeof(struct local_cell_149))));
	       }
	       aux_2066 =
		  (obj_t) (aux_2067);
	    }
	    aux_2064 =
	       (object_bglt) (obj1476_874);
	    OBJECT_WIDENING_SET(aux_2064, aux_2066);
	 }
	 {	/* Callcc/walk.scm 97 */
	    long arg1626_876;
	    arg1626_876 =
	       class_num_218___object(local_cell_149_callcc_walk);
	    {	/* Callcc/walk.scm 97 */
	       obj_t obj_1513;
	       obj_1513 =
		  (obj_t) (obj1476_874);
	       (((obj_t) CREF(obj_1513))->header = MAKE_HEADER(arg1626_876, 0), BUNSPEC);
	    }
	 }
	 obj1476_874;
      }
      {		/* Callcc/walk.scm 98 */
	 obj_t arg1627_877;
	 obj_t arg1628_878;
	 arg1627_877 =
	    (((node_bglt) CREF(node_6))->loc);
	 arg1628_878 = ____74_type_cache;
	 {	/* Callcc/walk.scm 98 */
	    make_box_202_bglt res1839_1530;
	    {	/* Callcc/walk.scm 98 */
	       type_bglt type_1517;
	       obj_t key_1519;
	       type_1517 =
		  (type_bglt) (arg1628_878);
	       key_1519 =
		  BINT(((long) -1));
	       {	/* ./Ast/node.scm 1102 */
		  make_box_202_bglt new1407_1521;
		  new1407_1521 =
		     ((make_box_202_bglt) BREF(GC_MALLOC(sizeof(struct make_box_202))));
		  {	/* ./Ast/node.scm 1102 */
		     long arg1651_1522;
		     arg1651_1522 =
			class_num_218___object(make_box_202_ast_node);
		     {	/* ./Ast/node.scm 1102 */
			obj_t obj_1528;
			obj_1528 =
			   (obj_t) (new1407_1521);
			(((obj_t) CREF(obj_1528))->header = MAKE_HEADER(arg1651_1522, 0), BUNSPEC);
		     }
		  }
		  {	/* ./Ast/node.scm 1102 */
		     object_bglt aux_2081;
		     aux_2081 =
			(object_bglt) (new1407_1521);
		     OBJECT_WIDENING_SET(aux_2081, BFALSE);
		  }
		  ((((make_box_202_bglt) CREF(new1407_1521))->loc) = ((obj_t) arg1627_877), BUNSPEC);
		  ((((make_box_202_bglt) CREF(new1407_1521))->type) = ((type_bglt) type_1517), BUNSPEC);
		  ((((make_box_202_bglt) CREF(new1407_1521))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
		  ((((make_box_202_bglt) CREF(new1407_1521))->key) = ((obj_t) key_1519), BUNSPEC);
		  ((((make_box_202_bglt) CREF(new1407_1521))->value) = ((node_bglt) node_6), BUNSPEC);
		  res1839_1530 = new1407_1521;
	       }
	    }
	    return res1839_1530;
	 }
      }
   }
}



/* celled? */
bool_t 
celled__113_callcc_walk(variable_bglt var_8)
{
   AN_OBJECT;
   {	/* Callcc/walk.scm 103 */
      {		/* Callcc/walk.scm 104 */
	 bool_t _ortest_1478_881;
	 _ortest_1478_881 =
	    is_a__118___object(
	    (obj_t) (var_8), local_cell_149_callcc_walk);
	 if (_ortest_1478_881)
	   {	/* Callcc/walk.scm 104 */
	      return _ortest_1478_881;
	   }
	 else
	   {	/* ./Ieee/equiv.scm 5508 */
	      obj_t aux_2095;
	      obj_t aux_2092;
	      aux_2095 =
		 CNST_TABLE_REF(((long) 2));
	      {		/* Callcc/walk.scm 104 */
		 local_bglt obj_1532;
		 obj_1532 =
		    (local_bglt) (var_8);
		 aux_2092 =
		    (((local_bglt) CREF(obj_1532))->access);
	      }
	      return
		 (aux_2092 == aux_2095);
	   }
      }
   }
}



/* callcc*! */
obj_t 
callcc___127_callcc_walk(obj_t node__221_31)
{
   AN_OBJECT;
   {	/* Callcc/walk.scm 326 */
    callcc___127_callcc_walk:
      if (
	 NULLP(node__221_31))
	{	/* Callcc/walk.scm 327 */
	   return
	      CNST_TABLE_REF(((long) 3));
	}
      else
	{	/* Callcc/walk.scm 327 */
	   {	/* Callcc/walk.scm 330 */
	      node_bglt arg1634_885;
	      {		/* Callcc/walk.scm 330 */
		 node_bglt aux_2101;
		 {	/* Callcc/walk.scm 330 */
		    obj_t aux_2102;
		    aux_2102 =
		       CAR(node__221_31);
		    aux_2101 =
		       (node_bglt) (aux_2102);
		 }
		 arg1634_885 =
		    callcc__192_callcc_walk(aux_2101);
	      }
	      {		/* ./Ieee/pair-list.scm 5890 */
		 obj_t aux_2106;
		 aux_2106 =
		    (obj_t) (arg1634_885);
		 SET_CAR(node__221_31, aux_2106);
	      }
	   }
	   {
	      obj_t node__221_2109;
	      node__221_2109 =
		 CDR(node__221_31);
	      node__221_31 = node__221_2109;
	      goto callcc___127_callcc_walk;
	   }
	}
   }
}



/* object-init */
obj_t 
object_init_111_callcc_walk()
{
   AN_OBJECT;
   {	/* Callcc/walk.scm 15 */
      {		/* Callcc/walk.scm 15 */
	 obj_t arg1637_888;
	 obj_t arg1638_889;
	 obj_t arg1641_892;
	 arg1637_888 =
	    CNST_TABLE_REF(((long) 4));
	 arg1638_889 = local_ast_var;
	 {	/* Callcc/walk.scm 15 */
	    obj_t v1499_893;
	    v1499_893 =
	       create_vector(((long) 0));
	    arg1641_892 = v1499_893;
	 }
	 local_cell_149_callcc_walk =
	    register_class__225___object(arg1637_888, arg1638_889, allocate_local_cell_env_161_callcc_walk, ((long) 32234), BUNSPEC, BFALSE, arg1641_892);
      }
      return BUNSPEC;
   }
}



/* allocate-local/cell */
local_bglt 
allocate_local_cell_184_callcc_walk()
{
   AN_OBJECT;
   {	/* Callcc/walk.scm 23 */
      {		/* Callcc/walk.scm 23 */
	 local_bglt new1449_894;
	 new1449_894 =
	    ((local_bglt) BREF(GC_MALLOC(sizeof(struct local))));
	 {	/* Callcc/walk.scm 23 */
	    long arg1642_895;
	    arg1642_895 =
	       class_num_218___object(local_cell_149_callcc_walk);
	    {	/* Callcc/walk.scm 23 */
	       obj_t obj_1540;
	       obj_1540 =
		  (obj_t) (new1449_894);
	       (((obj_t) CREF(obj_1540))->header = MAKE_HEADER(arg1642_895, 0), BUNSPEC);
	    }
	 }
	 {	/* Callcc/walk.scm 23 */
	    object_bglt aux_2118;
	    aux_2118 =
	       (object_bglt) (new1449_894);
	    OBJECT_WIDENING_SET(aux_2118, BFALSE);
	 }
	 return new1449_894;
      }
   }
}



/* _allocate-local/cell */
obj_t 
_allocate_local_cell_31_callcc_walk(obj_t env_1822)
{
   AN_OBJECT;
   {	/* Callcc/walk.scm 23 */
      {		/* Callcc/walk.scm 23 */
	 local_bglt aux_2121;
	 aux_2121 =
	    allocate_local_cell_184_callcc_walk();
	 return
	    (obj_t) (aux_2121);
      }
   }
}



/* method-init */
obj_t 
method_init_76_callcc_walk()
{
   AN_OBJECT;
   {	/* Callcc/walk.scm 15 */
      add_generic__110___object(callcc__env_142_callcc_walk, callcc__default1500_env_108_callcc_walk);
      add_inlined_method__244___object(callcc__env_142_callcc_walk, atom_ast_node, ((long) 0));
      add_inlined_method__244___object(callcc__env_142_callcc_walk, kwote_ast_node, ((long) 1));
      add_inlined_method__244___object(callcc__env_142_callcc_walk, var_ast_node, ((long) 2));
      add_inlined_method__244___object(callcc__env_142_callcc_walk, sequence_ast_node, ((long) 3));
      add_inlined_method__244___object(callcc__env_142_callcc_walk, app_ast_node, ((long) 4));
      add_inlined_method__244___object(callcc__env_142_callcc_walk, app_ly_162_ast_node, ((long) 5));
      add_inlined_method__244___object(callcc__env_142_callcc_walk, funcall_ast_node, ((long) 6));
      add_inlined_method__244___object(callcc__env_142_callcc_walk, pragma_ast_node, ((long) 7));
      add_inlined_method__244___object(callcc__env_142_callcc_walk, cast_ast_node, ((long) 8));
      add_inlined_method__244___object(callcc__env_142_callcc_walk, setq_ast_node, ((long) 9));
      add_inlined_method__244___object(callcc__env_142_callcc_walk, conditional_ast_node, ((long) 10));
      add_inlined_method__244___object(callcc__env_142_callcc_walk, fail_ast_node, ((long) 11));
      add_inlined_method__244___object(callcc__env_142_callcc_walk, select_ast_node, ((long) 12));
      add_inlined_method__244___object(callcc__env_142_callcc_walk, let_fun_218_ast_node, ((long) 13));
      add_inlined_method__244___object(callcc__env_142_callcc_walk, let_var_6_ast_node, ((long) 14));
      add_inlined_method__244___object(callcc__env_142_callcc_walk, set_ex_it_116_ast_node, ((long) 15));
      add_inlined_method__244___object(callcc__env_142_callcc_walk, jump_ex_it_184_ast_node, ((long) 16));
      add_inlined_method__244___object(callcc__env_142_callcc_walk, make_box_202_ast_node, ((long) 17));
      add_inlined_method__244___object(callcc__env_142_callcc_walk, box_ref_242_ast_node, ((long) 18));
      add_inlined_method__244___object(callcc__env_142_callcc_walk, box_set__221_ast_node, ((long) 19));
      {		/* Callcc/walk.scm 15 */
	 obj_t object__struct_local_cell1547_15_1827;
	 object__struct_local_cell1547_15_1827 = proc1856_callcc_walk;
	 add_method__1___object(object__struct_env_210___object, local_cell_149_callcc_walk, object__struct_local_cell1547_15_1827);
      }
      {		/* Callcc/walk.scm 15 */
	 obj_t struct_object__object_local_cell1549_209_1823;
	 struct_object__object_local_cell1549_209_1823 = proc1857_callcc_walk;
	 return
	    add_method__1___object(struct_object__object_env_209___object, local_cell_149_callcc_walk, struct_object__object_local_cell1549_209_1823);
      }
   }
}



/* struct+object->object-local/cell1549 */
obj_t 
struct_object__object_local_cell1549_209_callcc_walk(obj_t env_1830, obj_t o_1831, obj_t s_1832)
{
   AN_OBJECT;
   {	/* Callcc/walk.scm 23 */
      {
	 local_cell_149_bglt o_1235;
	 obj_t s_1236;
	 {	/* Callcc/walk.scm 23 */
	    local_cell_149_bglt aux_2147;
	    o_1235 =
	       (local_cell_149_bglt) (o_1831);
	    s_1236 = s_1832;
	    {

	       {	/* Callcc/walk.scm 23 */
		  obj_t old1456_1239;
		  {	/* Callcc/walk.scm 23 */
		     obj_t next_method1548_240_1244;
		     next_method1548_240_1244 =
			find_super_class_method_167___object(
			(object_bglt) (o_1235), struct_object__object_env_209___object, local_cell_149_callcc_walk);
		     if (
			PROCEDUREP(next_method1548_240_1244))
		       {	/* Callcc/walk.scm 23 */
			  old1456_1239 =
			     PROCEDURE_ENTRY(next_method1548_240_1244) (next_method1548_240_1244,
			     (obj_t) (o_1235), s_1236, BEOA);
		       }
		     else
		       {	/* Callcc/walk.scm 23 */
			  PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method1548_240_1244);
			  {	/* Callcc/walk.scm 23 */
			     object_bglt aux_2156;
			     aux_2156 =
				struct_object__object_93___object(
				(object_bglt) (o_1235), s_1236);
			     old1456_1239 =
				(obj_t) (aux_2156);
			  }
		       }
		  }
		  {	/* Callcc/walk.scm 23 */
		     local_cell_149_bglt new1458_1241;
		     new1458_1241 =
			((local_cell_149_bglt) (old1456_1239));
		     {	/* Callcc/walk.scm 23 */
			long arg1720_1242;
			arg1720_1242 =
			   class_num_218___object(local_cell_149_callcc_walk);
			{	/* Callcc/walk.scm 23 */
			   obj_t obj_1616;
			   obj_1616 =
			      (obj_t) (new1458_1241);
			   (((obj_t) CREF(obj_1616))->header = MAKE_HEADER(arg1720_1242, 0), BUNSPEC);
			}
		     }
		     {	/* Callcc/walk.scm 23 */
			obj_t aux_2166;
			object_bglt aux_2164;
			{	/* Callcc/walk.scm 23 */
			   local_cell_149_bglt aux_2167;
			   {	/* Callcc/walk.scm 23 */

			      aux_2167 =
				 ((local_cell_149_bglt) BREF(GC_MALLOC(sizeof(struct local_cell_149))));
			   }
			   aux_2166 =
			      (obj_t) (aux_2167);
			}
			aux_2164 =
			   (object_bglt) (new1458_1241);
			OBJECT_WIDENING_SET(aux_2164, aux_2166);
		     }
		     aux_2147 = new1458_1241;
		  }
	       }
	    }
	    return
	       (obj_t) (aux_2147);
	 }
      }
   }
}



/* object->struct-local/cell1547 */
obj_t 
object__struct_local_cell1547_15_callcc_walk(obj_t env_1833, obj_t obj1453_1834)
{
   AN_OBJECT;
   {	/* Callcc/walk.scm 23 */
      {
	 local_cell_149_bglt obj1453_1227;
	 obj1453_1227 =
	    (local_cell_149_bglt) (obj1453_1834);
	 {

	    {	/* Callcc/walk.scm 23 */
	       obj_t res1454_1230;
	       {	/* Callcc/walk.scm 23 */
		  obj_t next_method1546_155_1233;
		  next_method1546_155_1233 =
		     find_super_class_method_167___object(
		     (object_bglt) (obj1453_1227), object__struct_env_210___object, local_cell_149_callcc_walk);
		  if (
		     PROCEDUREP(next_method1546_155_1233))
		    {	/* Callcc/walk.scm 23 */
		       res1454_1230 =
			  PROCEDURE_ENTRY(next_method1546_155_1233) (next_method1546_155_1233,
			  (obj_t) (obj1453_1227), BEOA);
		    }
		  else
		    {	/* Callcc/walk.scm 23 */
		       PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method1546_155_1233);
		       res1454_1230 =
			  object__struct_50___object(
			  (object_bglt) (obj1453_1227));
		    }
	       }
	       {	/* Callcc/walk.scm 23 */
		  obj_t aux1455_1231;
		  {	/* ./Llib/struct.scm 1415 */
		     obj_t aux_2183;
		     aux_2183 =
			CNST_TABLE_REF(((long) 4));
		     aux1455_1231 =
			make_struct(aux_2183, ((long) 0), BUNSPEC);
		  }
		  STRUCT_SET(res1454_1230, ((long) 0), aux1455_1231);
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_2187;
		     aux_2187 =
			STRUCT_KEY(res1454_1230);
		     STRUCT_KEY_SET(aux1455_1231, aux_2187);
		  }
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_2190;
		     aux_2190 =
			CNST_TABLE_REF(((long) 4));
		     STRUCT_KEY_SET(res1454_1230, aux_2190);
		  }
		  return res1454_1230;
	       }
	    }
	 }
      }
   }
}



/* callcc! */
node_bglt 
callcc__192_callcc_walk(node_bglt node_9)
{
   AN_OBJECT;
   {	/* Callcc/walk.scm 109 */
      {
	 obj_t method1724_1250;
	 obj_t class1729_1251;
	 {	/* Callcc/walk.scm 109 */
	    obj_t arg1732_1248;
	    obj_t arg1733_1249;
	    {	/* Callcc/walk.scm 109 */
	       object_bglt obj_1622;
	       obj_1622 =
		  (object_bglt) (node_9);
	       {	/* ./Llib/object.scm 2926 */
		  obj_t pre_method_105_1623;
		  pre_method_105_1623 =
		     PROCEDURE_REF(callcc__env_142_callcc_walk, ((long) 2));
		  if (
		     INTEGERP(pre_method_105_1623))
		    {	/* ./Llib/object.scm 2927 */
		       PROCEDURE_SET(callcc__env_142_callcc_walk, ((long) 2), BUNSPEC);
		       arg1732_1248 = pre_method_105_1623;
		    }
		  else
		    {	/* ./Llib/object.scm 2914 */
		       long obj_class_num_177_1628;
		       obj_class_num_177_1628 =
			  TYPE(obj_1622);
		       {	/* ./Llib/object.scm 2915 */
			  obj_t arg1176_1629;
			  arg1176_1629 =
			     PROCEDURE_REF(callcc__env_142_callcc_walk, ((long) 1));
			  {	/* ./Llib/object.scm 2738 */
			     long arg1177_1633;
			     {	/* ./Llib/object.scm 2738 */
				long arg1178_1634;
				arg1178_1634 =
				   OBJECT_TYPE;
				arg1177_1633 =
				   (obj_class_num_177_1628 - arg1178_1634);
			     }
			     arg1732_1248 =
				VECTOR_REF(arg1176_1629, arg1177_1633);
			  }
		       }
		    }
	       }
	    }
	    {	/* Callcc/walk.scm 109 */
	       object_bglt object_1639;
	       object_1639 =
		  (object_bglt) (node_9);
	       {	/* ./Llib/object.scm 2695 */
		  long arg1179_1640;
		  {	/* ./Llib/object.scm 2695 */
		     long arg1180_1641;
		     long arg1181_1642;
		     arg1180_1641 =
			TYPE(object_1639);
		     arg1181_1642 =
			OBJECT_TYPE;
		     arg1179_1640 =
			(arg1180_1641 - arg1181_1642);
		  }
		  {	/* ./Llib/object.scm 2695 */
		     obj_t vector_1646;
		     vector_1646 = _classes__134___object;
		     arg1733_1249 =
			VECTOR_REF(vector_1646, arg1179_1640);
		  }
	       }
	    }
	    {	/* Callcc/walk.scm 109 */
	       obj_t aux_2209;
	       method1724_1250 = arg1732_1248;
	       class1729_1251 = arg1733_1249;
	       {

		  if (
		     INTEGERP(method1724_1250))
		    {	/* Callcc/walk.scm 109 */
		       switch (
			  (long) CINT(method1724_1250))
			 {
			 case ((long) 0):

			    {	/* Callcc/walk.scm 109 */
			       atom_bglt aux_2212;
			       aux_2212 =
				  (atom_bglt) (node_9);
			       aux_2209 =
				  (obj_t) (aux_2212);
			    }
			    break;
			 case ((long) 1):

			    {	/* Callcc/walk.scm 109 */
			       kwote_bglt aux_2215;
			       aux_2215 =
				  (kwote_bglt) (node_9);
			       aux_2209 =
				  (obj_t) (aux_2215);
			    }
			    break;
			 case ((long) 2):

			    {	/* Callcc/walk.scm 127 */
			       var_bglt node_1259;
			       node_1259 =
				  (var_bglt) (node_9);
			       {	/* Callcc/walk.scm 127 */
				  variable_bglt var_1260;
				  var_1260 =
				     (((var_bglt) CREF(node_1259))->variable);
				  {
				     obj_t var_1261;
				     obj_t alpha_1262;
				     var_1261 =
					(obj_t) (var_1260);
				     alpha_1262 =
					(((variable_bglt) CREF(var_1260))->fast_alpha_7);
				   loop_1263:
				     {	/* Callcc/walk.scm 130 */
					bool_t test1737_1265;
					test1737_1265 =
					   is_a__118___object(alpha_1262, local_ast_var);
					if (test1737_1265)
					  {	/* Callcc/walk.scm 130 */
					     {	/* Callcc/walk.scm 132 */
						variable_bglt val1209_1652;
						val1209_1652 =
						   (variable_bglt) (alpha_1262);
						((((var_bglt) CREF(node_1259))->variable) = ((variable_bglt) val1209_1652), BUNSPEC);
					     }
					     {
						obj_t alpha_2225;
						obj_t var_2224;
						var_2224 = alpha_1262;
						{	/* Callcc/walk.scm 133 */
						   variable_bglt obj_1653;
						   obj_1653 =
						      (variable_bglt) (alpha_1262);
						   alpha_2225 =
						      (((variable_bglt) CREF(obj_1653))->fast_alpha_7);
						}
						alpha_1262 = alpha_2225;
						var_1261 = var_2224;
						goto loop_1263;
					     }
					  }
					else
					  {	/* Callcc/walk.scm 135 */
					     bool_t test1739_1267;
					     test1739_1267 =
						is_a__118___object(alpha_1262, local_ast_var);
					     if (test1739_1267)
					       {	/* Callcc/walk.scm 135 */
						  {	/* Callcc/walk.scm 136 */
						     variable_bglt val1209_1656;
						     val1209_1656 =
							(variable_bglt) (alpha_1262);
						     ((((var_bglt) CREF(node_1259))->variable) = ((variable_bglt) val1209_1656), BUNSPEC);
						  }
						  {	/* Callcc/walk.scm 137 */
						     node_bglt aux_2232;
						     aux_2232 =
							callcc__192_callcc_walk(
							(node_bglt) (node_1259));
						     aux_2209 =
							(obj_t) (aux_2232);
						  }
					       }
					     else
					       {	/* Callcc/walk.scm 138 */
						  bool_t test1740_1268;
						  test1740_1268 =
						     is_a__118___object(var_1261, global_ast_var);
						  if (test1740_1268)
						    {	/* Callcc/walk.scm 138 */
						       aux_2209 =
							  (obj_t) (node_1259);
						    }
						  else
						    {	/* Callcc/walk.scm 138 */
						       if (
							  celled__113_callcc_walk(
							     (variable_bglt) (var_1261)))
							 {	/* Callcc/walk.scm 140 */
							    {	/* Callcc/walk.scm 145 */
							       obj_t arg1742_1270;
							       obj_t arg1743_1271;
							       {	/* Callcc/walk.scm 145 */
								  node_bglt obj_1658;
								  obj_1658 =
								     (node_bglt) (node_1259);
								  arg1742_1270 =
								     (((node_bglt) CREF(obj_1658))->loc);
							       }
							       arg1743_1271 = ____74_type_cache;
							       {	/* Callcc/walk.scm 143 */
								  box_ref_242_bglt res1841_1673;
								  {	/* Callcc/walk.scm 143 */
								     type_bglt type_1660;
								     obj_t key_1662;
								     type_1660 =
									(type_bglt) (arg1743_1271);
								     key_1662 =
									BINT(((long) -1));
								     {	/* ./Ast/node.scm 1106 */
									box_ref_242_bglt new1419_1664;
									new1419_1664 =
									   ((box_ref_242_bglt) BREF(GC_MALLOC(sizeof(struct box_ref_242))));
									{	/* ./Ast/node.scm 1106 */
									   long arg1649_1665;
									   arg1649_1665 =
									      class_num_218___object(box_ref_242_ast_node);
									   {	/* ./Ast/node.scm 1106 */
									      obj_t obj_1671;
									      obj_1671 =
										 (obj_t) (new1419_1664);
									      (((obj_t) CREF(obj_1671))->header = MAKE_HEADER(arg1649_1665, 0), BUNSPEC);
									   }
									}
									{	/* ./Ast/node.scm 1106 */
									   object_bglt aux_2250;
									   aux_2250 =
									      (object_bglt) (new1419_1664);
									   OBJECT_WIDENING_SET(aux_2250, BFALSE);
									}
									((((box_ref_242_bglt) CREF(new1419_1664))->loc) = ((obj_t) arg1742_1270), BUNSPEC);
									((((box_ref_242_bglt) CREF(new1419_1664))->type) = ((type_bglt) type_1660), BUNSPEC);
									((((box_ref_242_bglt) CREF(new1419_1664))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
									((((box_ref_242_bglt) CREF(new1419_1664))->key) = ((obj_t) key_1662), BUNSPEC);
									((((box_ref_242_bglt) CREF(new1419_1664))->var) = ((var_bglt) node_1259), BUNSPEC);
									res1841_1673 = new1419_1664;
								     }
								  }
								  aux_2209 =
								     (obj_t) (res1841_1673);
							       }
							    }
							 }
						       else
							 {	/* Callcc/walk.scm 140 */
							    aux_2209 =
							       (obj_t) (node_1259);
							 }
						    }
					       }
					  }
				     }
				  }
			       }
			    }
			    break;
			 case ((long) 3):

			    {	/* Callcc/walk.scm 109 */
			       sequence_bglt node_1274;
			       node_1274 =
				  (sequence_bglt) (node_9);
			       callcc___127_callcc_walk(
				  (((sequence_bglt) CREF(node_1274))->nodes));
			       aux_2209 =
				  (obj_t) (node_1274);
			    }
			    break;
			 case ((long) 4):

			    {	/* Callcc/walk.scm 159 */
			       app_bglt node_1276;
			       node_1276 =
				  (app_bglt) (node_9);
			       callcc___127_callcc_walk(
				  (((app_bglt) CREF(node_1276))->args));
			       aux_2209 =
				  (obj_t) (node_1276);
			    }
			    break;
			 case ((long) 5):

			    {	/* Callcc/walk.scm 167 */
			       app_ly_162_bglt node_1279;
			       node_1279 =
				  (app_ly_162_bglt) (node_9);
			       {	/* Callcc/walk.scm 168 */
				  node_bglt arg1748_1281;
				  arg1748_1281 =
				     callcc__192_callcc_walk(
				     (((app_ly_162_bglt) CREF(node_1279))->fun));
				  ((((app_ly_162_bglt) CREF(node_1279))->fun) = ((node_bglt) arg1748_1281), BUNSPEC);
			       }
			       {	/* Callcc/walk.scm 169 */
				  node_bglt arg1750_1283;
				  arg1750_1283 =
				     callcc__192_callcc_walk(
				     (((app_ly_162_bglt) CREF(node_1279))->arg));
				  ((((app_ly_162_bglt) CREF(node_1279))->arg) = ((node_bglt) arg1750_1283), BUNSPEC);
			       }
			       aux_2209 =
				  (obj_t) (node_1279);
			    }
			    break;
			 case ((long) 6):

			    {	/* Callcc/walk.scm 176 */
			       funcall_bglt node_1285;
			       node_1285 =
				  (funcall_bglt) (node_9);
			       {	/* Callcc/walk.scm 177 */
				  node_bglt arg1752_1287;
				  arg1752_1287 =
				     callcc__192_callcc_walk(
				     (((funcall_bglt) CREF(node_1285))->fun));
				  ((((funcall_bglt) CREF(node_1285))->fun) = ((node_bglt) arg1752_1287), BUNSPEC);
			       }
			       callcc___127_callcc_walk(
				  (((funcall_bglt) CREF(node_1285))->args));
			       aux_2209 =
				  (obj_t) (node_1285);
			    }
			    break;
			 case ((long) 7):

			    {	/* Callcc/walk.scm 109 */
			       pragma_bglt node_1290;
			       node_1290 =
				  (pragma_bglt) (node_9);
			       callcc___127_callcc_walk(
				  (((pragma_bglt) CREF(node_1290))->args));
			       aux_2209 =
				  (obj_t) (node_1290);
			    }
			    break;
			 case ((long) 8):

			    {	/* Callcc/walk.scm 109 */
			       cast_bglt node_1292;
			       node_1292 =
				  (cast_bglt) (node_9);
			       callcc__192_callcc_walk(
				  (((cast_bglt) CREF(node_1292))->arg));
			       aux_2209 =
				  (obj_t) (node_1292);
			    }
			    break;
			 case ((long) 9):

			    {	/* Callcc/walk.scm 109 */
			       setq_bglt node_1294;
			       node_1294 =
				  (setq_bglt) (node_9);
			       {	/* Callcc/walk.scm 199 */
				  node_bglt arg1758_1295;
				  arg1758_1295 =
				     callcc__192_callcc_walk(
				     (((setq_bglt) CREF(node_1294))->value));
				  ((((setq_bglt) CREF(node_1294))->value) = ((node_bglt) arg1758_1295), BUNSPEC);
			       }
			       {	/* Callcc/walk.scm 200 */
				  variable_bglt var_1297;
				  {	/* Callcc/walk.scm 200 */
				     var_bglt arg1781_1324;
				     arg1781_1324 =
					(((setq_bglt) CREF(node_1294))->var);
				     var_1297 =
					(((var_bglt) CREF(arg1781_1324))->variable);
				  }
				  {
				     obj_t var_1298;
				     obj_t alpha_1299;
				     var_1298 =
					(obj_t) (var_1297);
				     alpha_1299 =
					(((variable_bglt) CREF(var_1297))->fast_alpha_7);
				   loop_1300:
				     {	/* Callcc/walk.scm 203 */
					bool_t test1761_1302;
					test1761_1302 =
					   is_a__118___object(alpha_1299, local_ast_var);
					if (test1761_1302)
					  {	/* Callcc/walk.scm 203 */
					     {	/* Callcc/walk.scm 205 */
						var_bglt arg1762_1303;
						arg1762_1303 =
						   (((setq_bglt) CREF(node_1294))->var);
						{	/* Callcc/walk.scm 205 */
						   variable_bglt val1209_1697;
						   val1209_1697 =
						      (variable_bglt) (alpha_1299);
						   ((((var_bglt) CREF(arg1762_1303))->variable) = ((variable_bglt) val1209_1697), BUNSPEC);
						}
					     }
					     {
						obj_t alpha_2305;
						obj_t var_2304;
						var_2304 = alpha_1299;
						{	/* Callcc/walk.scm 206 */
						   variable_bglt obj_1698;
						   obj_1698 =
						      (variable_bglt) (alpha_1299);
						   alpha_2305 =
						      (((variable_bglt) CREF(obj_1698))->fast_alpha_7);
						}
						alpha_1299 = alpha_2305;
						var_1298 = var_2304;
						goto loop_1300;
					     }
					  }
					else
					  {	/* Callcc/walk.scm 208 */
					     bool_t test1764_1305;
					     test1764_1305 =
						is_a__118___object(var_1298, global_ast_var);
					     if (test1764_1305)
					       {	/* Callcc/walk.scm 208 */
						  aux_2209 =
						     (obj_t) (node_1294);
					       }
					     else
					       {	/* Callcc/walk.scm 208 */
						  if (
						     celled__113_callcc_walk(
							(variable_bglt) (var_1298)))
						    {	/* Callcc/walk.scm 210 */
						       {	/* Callcc/walk.scm 213 */
							  local_bglt a_var_30_1307;
							  obj_t loc_1308;
							  a_var_30_1307 =
							     make_local_svar_140_ast_local(
							     CNST_TABLE_REF(((long) 5)),
							     (type_bglt) (_obj__252_type_cache));
							  {	/* Callcc/walk.scm 214 */
							     node_bglt obj_1700;
							     obj_1700 =
								(node_bglt) (node_1294);
							     loc_1308 =
								(((node_bglt) CREF(obj_1700))->loc);
							  }
							  {	/* Callcc/walk.scm 215 */
							     obj_t arg1767_1310;
							     obj_t arg1769_1312;
							     box_set__221_bglt arg1770_1313;
							     arg1767_1310 = ____74_type_cache;
							     {	/* Callcc/walk.scm 218 */
								obj_t arg1771_1314;
								{	/* ./Ieee/pair-list.scm 5689 */
								   obj_t aux_2321;
								   obj_t aux_2319;
								   {	/* Callcc/walk.scm 218 */
								      node_bglt aux_2322;
								      aux_2322 =
									 (((setq_bglt) CREF(node_1294))->value);
								      aux_2321 =
									 (obj_t) (aux_2322);
								   }
								   aux_2319 =
								      (obj_t) (a_var_30_1307);
								   arg1771_1314 =
								      MAKE_PAIR(aux_2319, aux_2321);
								}
								{	/* Callcc/walk.scm 218 */
								   obj_t list1772_1315;
								   list1772_1315 =
								      MAKE_PAIR(arg1771_1314, BNIL);
								   arg1769_1312 = list1772_1315;
								}
							     }
							     {	/* Callcc/walk.scm 219 */
								obj_t arg1775_1318;
								var_bglt arg1776_1319;
								var_bglt arg1777_1320;
								arg1775_1318 = ____74_type_cache;
								arg1776_1319 =
								   (((setq_bglt) CREF(node_1294))->var);
								{	/* Callcc/walk.scm 223 */
								   obj_t arg1779_1322;
								   arg1779_1322 = ____74_type_cache;
								   {	/* Callcc/walk.scm 223 */
								      var_bglt res1842_1716;
								      {		/* Callcc/walk.scm 223 */
									 type_bglt type_1707;
									 variable_bglt variable_1708;
									 type_1707 =
									    (type_bglt) (arg1779_1322);
									 variable_1708 =
									    (variable_bglt) (a_var_30_1307);
									 {	/* ./Ast/node.scm 986 */
									    var_bglt new1210_1709;
									    new1210_1709 =
									       ((var_bglt) BREF(GC_MALLOC(sizeof(struct var))));
									    {	/* ./Ast/node.scm 986 */
									       long arg1686_1710;
									       arg1686_1710 =
										  class_num_218___object(var_ast_node);
									       {	/* ./Ast/node.scm 986 */
										  obj_t obj_1714;
										  obj_1714 =
										     (obj_t) (new1210_1709);
										  (((obj_t) CREF(obj_1714))->header = MAKE_HEADER(arg1686_1710, 0), BUNSPEC);
									       }
									    }
									    {	/* ./Ast/node.scm 986 */
									       object_bglt aux_2334;
									       aux_2334 =
										  (object_bglt) (new1210_1709);
									       OBJECT_WIDENING_SET(aux_2334, BFALSE);
									    }
									    ((((var_bglt) CREF(new1210_1709))->loc) = ((obj_t) loc_1308), BUNSPEC);
									    ((((var_bglt) CREF(new1210_1709))->type) = ((type_bglt) type_1707), BUNSPEC);
									    ((((var_bglt) CREF(new1210_1709))->variable) = ((variable_bglt) variable_1708), BUNSPEC);
									    res1842_1716 = new1210_1709;
									 }
								      }
								      arg1777_1320 = res1842_1716;
								   }
								}
								{	/* Callcc/walk.scm 219 */
								   box_set__221_bglt res1843_1729;
								   {	/* Callcc/walk.scm 219 */
								      type_bglt type_1718;
								      node_bglt value_1720;
								      type_1718 =
									 (type_bglt) (arg1775_1318);
								      value_1720 =
									 (node_bglt) (arg1777_1320);
								      {		/* ./Ast/node.scm 1110 */
									 box_set__221_bglt new1430_1721;
									 new1430_1721 =
									    ((box_set__221_bglt) BREF(GC_MALLOC(sizeof(struct box_set__221))));
									 {	/* ./Ast/node.scm 1110 */
									    long arg1647_1722;
									    arg1647_1722 =
									       class_num_218___object(box_set__221_ast_node);
									    {	/* ./Ast/node.scm 1110 */
									       obj_t obj_1727;
									       obj_1727 =
										  (obj_t) (new1430_1721);
									       (((obj_t) CREF(obj_1727))->header = MAKE_HEADER(arg1647_1722, 0), BUNSPEC);
									    }
									 }
									 {	/* ./Ast/node.scm 1110 */
									    object_bglt aux_2346;
									    aux_2346 =
									       (object_bglt) (new1430_1721);
									    OBJECT_WIDENING_SET(aux_2346, BFALSE);
									 }
									 ((((box_set__221_bglt) CREF(new1430_1721))->loc) = ((obj_t) loc_1308), BUNSPEC);
									 ((((box_set__221_bglt) CREF(new1430_1721))->type) = ((type_bglt) type_1718), BUNSPEC);
									 ((((box_set__221_bglt) CREF(new1430_1721))->var) = ((var_bglt) arg1776_1319), BUNSPEC);
									 ((((box_set__221_bglt) CREF(new1430_1721))->value) = ((node_bglt) value_1720), BUNSPEC);
									 res1843_1729 = new1430_1721;
								      }
								   }
								   arg1770_1313 = res1843_1729;
								}
							     }
							     {	/* Callcc/walk.scm 215 */
								let_var_6_bglt res1844_1748;
								{	/* Callcc/walk.scm 215 */
								   type_bglt type_1731;
								   obj_t key_1733;
								   node_bglt body_1735;
								   type_1731 =
								      (type_bglt) (arg1767_1310);
								   key_1733 =
								      BINT(((long) -1));
								   body_1735 =
								      (node_bglt) (arg1770_1313);
								   {	/* ./Ast/node.scm 1079 */
								      let_var_6_bglt new1373_1737;
								      new1373_1737 =
									 ((let_var_6_bglt) BREF(GC_MALLOC(sizeof(struct let_var_6))));
								      {		/* ./Ast/node.scm 1079 */
									 long arg1657_1738;
									 arg1657_1738 =
									    class_num_218___object(let_var_6_ast_node);
									 {	/* ./Ast/node.scm 1079 */
									    obj_t obj_1746;
									    obj_1746 =
									       (obj_t) (new1373_1737);
									    (((obj_t) CREF(obj_1746))->header = MAKE_HEADER(arg1657_1738, 0), BUNSPEC);
									 }
								      }
								      {		/* ./Ast/node.scm 1079 */
									 object_bglt aux_2360;
									 aux_2360 =
									    (object_bglt) (new1373_1737);
									 OBJECT_WIDENING_SET(aux_2360, BFALSE);
								      }
								      ((((let_var_6_bglt) CREF(new1373_1737))->loc) = ((obj_t) loc_1308), BUNSPEC);
								      ((((let_var_6_bglt) CREF(new1373_1737))->type) = ((type_bglt) type_1731), BUNSPEC);
								      ((((let_var_6_bglt) CREF(new1373_1737))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
								      ((((let_var_6_bglt) CREF(new1373_1737))->key) = ((obj_t) key_1733), BUNSPEC);
								      ((((let_var_6_bglt) CREF(new1373_1737))->bindings) = ((obj_t) arg1769_1312), BUNSPEC);
								      ((((let_var_6_bglt) CREF(new1373_1737))->body) = ((node_bglt) body_1735), BUNSPEC);
								      ((((let_var_6_bglt) CREF(new1373_1737))->removable__42) = ((bool_t) ((bool_t) 1)), BUNSPEC);
								      res1844_1748 = new1373_1737;
								   }
								}
								aux_2209 =
								   (obj_t) (res1844_1748);
							     }
							  }
						       }
						    }
						  else
						    {	/* Callcc/walk.scm 210 */
						       aux_2209 =
							  (obj_t) (node_1294);
						    }
					       }
					  }
				     }
				  }
			       }
			    }
			    break;
			 case ((long) 10):

			    {	/* Callcc/walk.scm 232 */
			       conditional_bglt node_1325;
			       node_1325 =
				  (conditional_bglt) (node_9);
			       {	/* Callcc/walk.scm 233 */
				  node_bglt arg1782_1327;
				  arg1782_1327 =
				     callcc__192_callcc_walk(
				     (((conditional_bglt) CREF(node_1325))->test));
				  ((((conditional_bglt) CREF(node_1325))->test) = ((node_bglt) arg1782_1327), BUNSPEC);
			       }
			       {	/* Callcc/walk.scm 234 */
				  node_bglt arg1784_1329;
				  arg1784_1329 =
				     callcc__192_callcc_walk(
				     (((conditional_bglt) CREF(node_1325))->true));
				  ((((conditional_bglt) CREF(node_1325))->true) = ((node_bglt) arg1784_1329), BUNSPEC);
			       }
			       {	/* Callcc/walk.scm 235 */
				  node_bglt arg1786_1331;
				  arg1786_1331 =
				     callcc__192_callcc_walk(
				     (((conditional_bglt) CREF(node_1325))->false));
				  ((((conditional_bglt) CREF(node_1325))->false) = ((node_bglt) arg1786_1331), BUNSPEC);
			       }
			       aux_2209 =
				  (obj_t) (node_1325);
			    }
			    break;
			 case ((long) 11):

			    {	/* Callcc/walk.scm 242 */
			       fail_bglt node_1333;
			       node_1333 =
				  (fail_bglt) (node_9);
			       {	/* Callcc/walk.scm 243 */
				  node_bglt arg1788_1335;
				  arg1788_1335 =
				     callcc__192_callcc_walk(
				     (((fail_bglt) CREF(node_1333))->proc));
				  ((((fail_bglt) CREF(node_1333))->proc) = ((node_bglt) arg1788_1335), BUNSPEC);
			       }
			       {	/* Callcc/walk.scm 244 */
				  node_bglt arg1790_1337;
				  arg1790_1337 =
				     callcc__192_callcc_walk(
				     (((fail_bglt) CREF(node_1333))->msg));
				  ((((fail_bglt) CREF(node_1333))->msg) = ((node_bglt) arg1790_1337), BUNSPEC);
			       }
			       {	/* Callcc/walk.scm 245 */
				  node_bglt arg1792_1339;
				  arg1792_1339 =
				     callcc__192_callcc_walk(
				     (((fail_bglt) CREF(node_1333))->obj));
				  ((((fail_bglt) CREF(node_1333))->obj) = ((node_bglt) arg1792_1339), BUNSPEC);
			       }
			       aux_2209 =
				  (obj_t) (node_1333);
			    }
			    break;
			 case ((long) 12):

			    {	/* Callcc/walk.scm 252 */
			       select_bglt node_1341;
			       node_1341 =
				  (select_bglt) (node_9);
			       {	/* Callcc/walk.scm 253 */
				  node_bglt arg1794_1343;
				  arg1794_1343 =
				     callcc__192_callcc_walk(
				     (((select_bglt) CREF(node_1341))->test));
				  ((((select_bglt) CREF(node_1341))->test) = ((node_bglt) arg1794_1343), BUNSPEC);
			       }
			       {
				  obj_t l1489_1345;
				  l1489_1345 =
				     (((select_bglt) CREF(node_1341))->clauses);
				lname1490_1346:
				  if (
				     PAIRP(l1489_1345))
				    {	/* Callcc/walk.scm 254 */
				       {	/* Callcc/walk.scm 255 */
					  obj_t clause_1349;
					  clause_1349 =
					     CAR(l1489_1345);
					  {	/* Callcc/walk.scm 255 */
					     node_bglt arg1798_1350;
					     {	/* Callcc/walk.scm 255 */
						node_bglt aux_2403;
						{	/* Callcc/walk.scm 255 */
						   obj_t aux_2404;
						   aux_2404 =
						      CDR(clause_1349);
						   aux_2403 =
						      (node_bglt) (aux_2404);
						}
						arg1798_1350 =
						   callcc__192_callcc_walk(aux_2403);
					     }
					     {	/* ./Ieee/pair-list.scm 5896 */
						obj_t aux_2408;
						aux_2408 =
						   (obj_t) (arg1798_1350);
						SET_CDR(clause_1349, aux_2408);
					     }
					  }
				       }
				       {
					  obj_t l1489_2411;
					  l1489_2411 =
					     CDR(l1489_1345);
					  l1489_1345 = l1489_2411;
					  goto lname1490_1346;
				       }
				    }
				  else
				    {	/* Callcc/walk.scm 254 */
				       ((bool_t) 1);
				    }
			       }
			       aux_2209 =
				  (obj_t) (node_1341);
			    }
			    break;
			 case ((long) 13):

			    {	/* Callcc/walk.scm 263 */
			       let_fun_218_bglt node_1353;
			       node_1353 =
				  (let_fun_218_bglt) (node_9);
			       {
				  obj_t l1492_1355;
				  l1492_1355 =
				     (((let_fun_218_bglt) CREF(node_1353))->locals);
				lname1493_1356:
				  if (
				     PAIRP(l1492_1355))
				    {	/* Callcc/walk.scm 264 */
				       callcc_fun__197_callcc_walk(
					  CAR(l1492_1355));
				       {
					  obj_t l1492_2420;
					  l1492_2420 =
					     CDR(l1492_1355);
					  l1492_1355 = l1492_2420;
					  goto lname1493_1356;
				       }
				    }
				  else
				    {	/* Callcc/walk.scm 264 */
				       ((bool_t) 1);
				    }
			       }
			       {	/* Callcc/walk.scm 265 */
				  node_bglt arg1806_1361;
				  arg1806_1361 =
				     callcc__192_callcc_walk(
				     (((let_fun_218_bglt) CREF(node_1353))->body));
				  ((((let_fun_218_bglt) CREF(node_1353))->body) = ((node_bglt) arg1806_1361), BUNSPEC);
			       }
			       aux_2209 =
				  (obj_t) (node_1353);
			    }
			    break;
			 case ((long) 14):

			    {	/* Callcc/walk.scm 272 */
			       let_var_6_bglt node_1363;
			       node_1363 =
				  (let_var_6_bglt) (node_9);
			       {	/* Callcc/walk.scm 273 */
				  node_bglt arg1809_1365;
				  arg1809_1365 =
				     callcc__192_callcc_walk(
				     (((let_var_6_bglt) CREF(node_1363))->body));
				  ((((let_var_6_bglt) CREF(node_1363))->body) = ((node_bglt) arg1809_1365), BUNSPEC);
			       }
			       {
				  obj_t l1495_1367;
				  l1495_1367 =
				     (((let_var_6_bglt) CREF(node_1363))->bindings);
				lname1496_1368:
				  if (
				     PAIRP(l1495_1367))
				    {	/* Callcc/walk.scm 274 */
				       {	/* Callcc/walk.scm 275 */
					  obj_t binding_1371;
					  binding_1371 =
					     CAR(l1495_1367);
					  {	/* Callcc/walk.scm 275 */
					     obj_t var_1372;
					     var_1372 =
						CAR(binding_1371);
					     {	/* Callcc/walk.scm 277 */
						node_bglt arg1813_1374;
						{	/* Callcc/walk.scm 277 */
						   node_bglt aux_2435;
						   {	/* Callcc/walk.scm 277 */
						      obj_t aux_2436;
						      aux_2436 =
							 CDR(binding_1371);
						      aux_2435 =
							 (node_bglt) (aux_2436);
						   }
						   arg1813_1374 =
						      callcc__192_callcc_walk(aux_2435);
						}
						{	/* ./Ieee/pair-list.scm 5896 */
						   obj_t aux_2440;
						   aux_2440 =
						      (obj_t) (arg1813_1374);
						   SET_CDR(binding_1371, aux_2440);
						}
					     }
					     if (
						celled__113_callcc_walk(
						   (variable_bglt) (var_1372)))
					       {	/* Callcc/walk.scm 278 */
						  {	/* Callcc/walk.scm 280 */
						     local_bglt obj_1794;
						     type_bglt val1082_1795;
						     obj_1794 =
							(local_bglt) (var_1372);
						     val1082_1795 =
							(type_bglt) (_obj__252_type_cache);
						     ((((local_bglt) CREF(obj_1794))->type) = ((type_bglt) val1082_1795), BUNSPEC);
						  }
						  {	/* Callcc/walk.scm 282 */
						     make_box_202_bglt arg1815_1376;
						     {	/* Callcc/walk.scm 282 */
							node_bglt aux_2449;
							{	/* Callcc/walk.scm 282 */
							   obj_t aux_2450;
							   aux_2450 =
							      CDR(binding_1371);
							   aux_2449 =
							      (node_bglt) (aux_2450);
							}
							arg1815_1376 =
							   a_make_cell_117_callcc_walk(aux_2449,
							   (variable_bglt) (var_1372));
						     }
						     {	/* ./Ieee/pair-list.scm 5896 */
							obj_t aux_2455;
							aux_2455 =
							   (obj_t) (arg1815_1376);
							SET_CDR(binding_1371, aux_2455);
						     }
						  }
					       }
					     else
					       {	/* Callcc/walk.scm 278 */
						  BUNSPEC;
					       }
					  }
				       }
				       {
					  obj_t l1495_2458;
					  l1495_2458 =
					     CDR(l1495_1367);
					  l1495_1367 = l1495_2458;
					  goto lname1496_1368;
				       }
				    }
				  else
				    {	/* Callcc/walk.scm 274 */
				       ((bool_t) 1);
				    }
			       }
			       aux_2209 =
				  (obj_t) (node_1363);
			    }
			    break;
			 case ((long) 15):

			    {	/* Callcc/walk.scm 109 */
			       set_ex_it_116_bglt node_1379;
			       node_1379 =
				  (set_ex_it_116_bglt) (node_9);
			       {	/* Callcc/walk.scm 290 */
				  node_bglt arg1818_1380;
				  arg1818_1380 =
				     callcc__192_callcc_walk(
				     (((set_ex_it_116_bglt) CREF(node_1379))->body));
				  ((((set_ex_it_116_bglt) CREF(node_1379))->body) = ((node_bglt) arg1818_1380), BUNSPEC);
			       }
			       aux_2209 =
				  (obj_t) (node_1379);
			    }
			    break;
			 case ((long) 16):

			    {	/* Callcc/walk.scm 297 */
			       jump_ex_it_184_bglt node_1382;
			       node_1382 =
				  (jump_ex_it_184_bglt) (node_9);
			       {	/* Callcc/walk.scm 298 */
				  node_bglt arg1821_1384;
				  arg1821_1384 =
				     callcc__192_callcc_walk(
				     (((jump_ex_it_184_bglt) CREF(node_1382))->exit));
				  ((((jump_ex_it_184_bglt) CREF(node_1382))->exit) = ((node_bglt) arg1821_1384), BUNSPEC);
			       }
			       {	/* Callcc/walk.scm 299 */
				  node_bglt arg1823_1386;
				  arg1823_1386 =
				     callcc__192_callcc_walk(
				     (((jump_ex_it_184_bglt) CREF(node_1382))->value));
				  ((((jump_ex_it_184_bglt) CREF(node_1382))->value) = ((node_bglt) arg1823_1386), BUNSPEC);
			       }
			       aux_2209 =
				  (obj_t) (node_1382);
			    }
			    break;
			 case ((long) 17):

			    {	/* Callcc/walk.scm 109 */
			       make_box_202_bglt node_1388;
			       node_1388 =
				  (make_box_202_bglt) (node_9);
			       {	/* Callcc/walk.scm 306 */
				  node_bglt arg1825_1389;
				  arg1825_1389 =
				     callcc__192_callcc_walk(
				     (((make_box_202_bglt) CREF(node_1388))->value));
				  ((((make_box_202_bglt) CREF(node_1388))->value) = ((node_bglt) arg1825_1389), BUNSPEC);
			       }
			       aux_2209 =
				  (obj_t) (node_1388);
			    }
			    break;
			 case ((long) 18):

			    {	/* Callcc/walk.scm 109 */
			       box_ref_242_bglt aux_2480;
			       aux_2480 =
				  (box_ref_242_bglt) (node_9);
			       aux_2209 =
				  (obj_t) (aux_2480);
			    }
			    break;
			 case ((long) 19):

			    {	/* Callcc/walk.scm 319 */
			       box_set__221_bglt node_1392;
			       node_1392 =
				  (box_set__221_bglt) (node_9);
			       {	/* Callcc/walk.scm 320 */
				  node_bglt arg1827_1394;
				  arg1827_1394 =
				     callcc__192_callcc_walk(
				     (((box_set__221_bglt) CREF(node_1392))->value));
				  ((((box_set__221_bglt) CREF(node_1392))->value) = ((node_bglt) arg1827_1394), BUNSPEC);
			       }
			       aux_2209 =
				  (obj_t) (node_1392);
			    }
			    break;
			 default:
			  case_else1730_1254:
			    if (
			       PROCEDUREP(method1724_1250))
			      {		/* Callcc/walk.scm 109 */
				 aux_2209 =
				    PROCEDURE_ENTRY(method1724_1250) (method1724_1250,
				    (obj_t) (node_9), BEOA)
				    ;
			      }
			    else
			      {		/* Callcc/walk.scm 109 */
				 obj_t fun1723_1246;
				 fun1723_1246 =
				    PROCEDURE_REF(callcc__env_142_callcc_walk, ((long) 0));
				 aux_2209 =
				    PROCEDURE_ENTRY(fun1723_1246) (fun1723_1246,
				    (obj_t) (node_9), BEOA);
			      }
			 }
		    }
		  else
		    {	/* Callcc/walk.scm 109 */
		       goto case_else1730_1254;
		    }
	       }
	       return
		  (node_bglt) (aux_2209);
	    }
	 }
      }
   }
}



/* _callcc!1849 */
obj_t 
_callcc_1849_195_callcc_walk(obj_t env_1835, obj_t node_1836)
{
   AN_OBJECT;
   {	/* Callcc/walk.scm 109 */
      {		/* Callcc/walk.scm 109 */
	 node_bglt aux_2500;
	 aux_2500 =
	    callcc__192_callcc_walk(
	    (node_bglt) (node_1836));
	 return
	    (obj_t) (aux_2500);
      }
   }
}



/* callcc!-default1500 */
node_bglt 
callcc__default1500_156_callcc_walk(node_bglt node_10)
{
   AN_OBJECT;
   {	/* Callcc/walk.scm 15 */
      FAILURE(
	 CNST_TABLE_REF(((long) 6)), string1858_callcc_walk,
	 (obj_t) (node_10));
   }
}



/* _callcc!-default1500 */
obj_t 
_callcc__default1500_14_callcc_walk(obj_t env_1837, obj_t node_1838)
{
   AN_OBJECT;
   {	/* Callcc/walk.scm 15 */
      {		/* Callcc/walk.scm 15 */
	 node_bglt aux_2507;
	 aux_2507 =
	    callcc__default1500_156_callcc_walk(
	    (node_bglt) (node_1838));
	 return
	    (obj_t) (aux_2507);
      }
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_callcc_walk()
{
   AN_OBJECT;
   {	/* Callcc/walk.scm 15 */
      module_initialization_70_tools_speek(((long) 0), "CALLCC_WALK");
      module_initialization_70_tools_error(((long) 0), "CALLCC_WALK");
      module_initialization_70_engine_pass(((long) 0), "CALLCC_WALK");
      module_initialization_70_type_type(((long) 0), "CALLCC_WALK");
      module_initialization_70_ast_var(((long) 0), "CALLCC_WALK");
      module_initialization_70_ast_node(((long) 0), "CALLCC_WALK");
      module_initialization_70_tools_shape(((long) 0), "CALLCC_WALK");
      module_initialization_70_type_cache(((long) 0), "CALLCC_WALK");
      module_initialization_70_ast_local(((long) 0), "CALLCC_WALK");
      return
	 module_initialization_70_engine_param(((long) 0), "CALLCC_WALK");
   }
}
