/*===========================================================================*/
/*   (Cfa/app.scm)                                                           */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;

typedef struct approx
  {
     header_t header;
     obj_t widening;
     struct type *type;
     bool_t type_locked__184;
     obj_t allocs;
     bool_t top__138;
     long lost_stamp_114;
  }
      *approx_bglt;

typedef struct cfun_cinfo_200
  {
     struct approx *approx;
  }
              *cfun_cinfo_200_bglt;

typedef struct extern_sfun_cinfo_6
  {
     struct approx *approx;
  }
                   *extern_sfun_cinfo_6_bglt;

typedef struct intern_sfun_cinfo_192
  {
     struct approx *approx;
     long stamp;
  }
                     *intern_sfun_cinfo_192_bglt;

typedef struct scnst_cinfo_0
  {
     struct approx *approx;
  }
             *scnst_cinfo_0_bglt;

typedef struct pre_clo_env_191
  {
     char dummy;
  }
               *pre_clo_env_191_bglt;

typedef struct svar_cinfo_166
  {
     struct approx *approx;
     bool_t clo_env__87;
  }
              *svar_cinfo_166_bglt;

typedef struct cvar_cinfo_53
  {
     struct approx *approx;
  }
             *cvar_cinfo_53_bglt;

typedef struct sexit_cinfo_49
  {
     struct approx *approx;
  }
              *sexit_cinfo_49_bglt;

typedef struct reshaped_local_224
  {
     obj_t binding_value_3;
  }
                  *reshaped_local_224_bglt;

typedef struct reshaped_global_160
  {
     char dummy;
  }
                   *reshaped_global_160_bglt;

typedef struct atom_cinfo_155
  {
     struct approx *approx;
  }
              *atom_cinfo_155_bglt;

typedef struct kwote_node_102
  {
     struct node *node;
  }
              *kwote_node_102_bglt;

typedef struct kwote_cinfo_48
  {
     struct approx *approx;
  }
              *kwote_cinfo_48_bglt;

typedef struct app_ly_cinfo_234
  {
     struct approx *approx;
  }
                *app_ly_cinfo_234_bglt;

typedef struct funcall_cinfo_75
  {
     struct approx *approx;
     struct approx *va_approx_63;
     bool_t arity_error_noticed__118;
     bool_t type_error_noticed__36;
  }
                *funcall_cinfo_75_bglt;

typedef struct pragma_cinfo_220
  {
     struct approx *approx;
  }
                *pragma_cinfo_220_bglt;

typedef struct setq_cinfo_191
  {
     struct approx *approx;
  }
              *setq_cinfo_191_bglt;

typedef struct conditional_cinfo_212
  {
     struct approx *approx;
  }
                     *conditional_cinfo_212_bglt;

typedef struct fail_cinfo_75
  {
     struct approx *approx;
  }
             *fail_cinfo_75_bglt;

typedef struct select_cinfo_150
  {
     struct approx *approx;
  }
                *select_cinfo_150_bglt;

typedef struct set_ex_it_cinfo_168
  {
     struct approx *approx;
  }
                   *set_ex_it_cinfo_168_bglt;

typedef struct jump_ex_it_cinfo_139
  {
     struct approx *approx;
  }
                    *jump_ex_it_cinfo_139_bglt;

typedef struct pre_make_box_186
  {
     char dummy;
  }
                *pre_make_box_186_bglt;

typedef struct make_box_cinfo_127
  {
     struct approx *approx;
  }
                  *make_box_cinfo_127_bglt;

typedef struct make_box_o_cinfo_96
  {
     struct approx *approx;
     struct approx *value_approx_19;
  }
                   *make_box_o_cinfo_96_bglt;

typedef struct box_set__cinfo_94
  {
     struct approx *approx;
  }
                 *box_set__cinfo_94_bglt;

typedef struct box_ref_cinfo_214
  {
     struct approx *approx;
  }
                 *box_ref_cinfo_214_bglt;

typedef struct box_set__o_cinfo_6
  {
     struct approx *approx;
  }
                  *box_set__o_cinfo_6_bglt;

typedef struct box_ref_o_cinfo_98
  {
     struct approx *approx;
  }
                  *box_ref_o_cinfo_98_bglt;

typedef struct pre_make_procedure_app_60
  {
     struct variable *owner;
  }
                         *pre_make_procedure_app_60_bglt;

typedef struct pre_procedure_ref_app_85
  {
     char dummy;
  }
                        *pre_procedure_ref_app_85_bglt;

typedef struct pre_procedure_set__app_208
  {
     char dummy;
  }
                          *pre_procedure_set__app_208_bglt;

typedef struct make_procedure_app_48
  {
     struct approx *approx;
     long values_approx_len_106;
     struct approx **values_approx_79;
     long lost_stamp_114;
     bool_t x_t__142;
     bool_t x;
     bool_t t;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
  }
                     *make_procedure_app_48_bglt;

typedef struct procedure_ref_app_49
  {
     struct approx *approx;
  }
                    *procedure_ref_app_49_bglt;

typedef struct procedure_set__app_32
  {
     struct approx *approx;
  }
                     *procedure_set__app_32_bglt;

typedef struct pre_make_vector_app_251
  {
     struct variable *owner;
  }
                       *pre_make_vector_app_251_bglt;

typedef struct pre_create_vector_app_162
  {
     struct variable *owner;
  }
                         *pre_create_vector_app_162_bglt;

typedef struct pre_vector_ref_app_208
  {
     char dummy;
  }
                      *pre_vector_ref_app_208_bglt;

typedef struct pre_vector_set__app_211
  {
     char dummy;
  }
                       *pre_vector_set__app_211_bglt;

typedef struct make_vector_app_205
  {
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
     bool_t seen__39;
  }
                   *make_vector_app_205_bglt;

typedef struct create_vector_app_150
  {
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
     bool_t seen__39;
  }
                     *create_vector_app_150_bglt;

typedef struct vector_ref_app_195
  {
     struct approx *approx;
  }
                  *vector_ref_app_195_bglt;

typedef struct vector_set__app_21
  {
     struct approx *approx;
  }
                  *vector_set__app_21_bglt;

typedef struct pre_make_struct_app_218
  {
     struct variable *owner;
  }
                       *pre_make_struct_app_218_bglt;

typedef struct pre_struct_ref_app_207
  {
     char dummy;
  }
                      *pre_struct_ref_app_207_bglt;

typedef struct pre_struct_set__app_116
  {
     char dummy;
  }
                       *pre_struct_set__app_116_bglt;

typedef struct make_struct_app_214
  {
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
  }
                   *make_struct_app_214_bglt;

typedef struct struct_ref_app_73
  {
     struct approx *approx;
  }
                 *struct_ref_app_73_bglt;

typedef struct struct_set__app_162
  {
     struct approx *approx;
  }
                   *struct_set__app_162_bglt;


static obj_t method_init_76_cfa_app();
extern approx_bglt cfa_intern_sfun__162_cfa_iterate(intern_sfun_cinfo_192_bglt, obj_t);
extern long add_inlined_method__244___object(obj_t, obj_t, long);
static obj_t cfa__app2048_29_cfa_app(obj_t, obj_t);
extern obj_t cfun_cinfo_200_cfa_info;
extern obj_t add_method__1___object(obj_t, obj_t, obj_t);
static obj_t _app__default2049_225_cfa_app(obj_t, obj_t, obj_t, obj_t);
extern obj_t intern_sfun_cinfo_192_cfa_info;
extern obj_t module_initialization_70_cfa_app(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_cfa_info(long, char *);
extern obj_t module_initialization_70_cfa_info2(long, char *);
extern obj_t module_initialization_70_cfa_cfa(long, char *);
extern obj_t module_initialization_70_cfa_iterate(long, char *);
extern obj_t module_initialization_70_cfa_loose(long, char *);
extern obj_t module_initialization_70_cfa_approx(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern approx_bglt union_approx__241_cfa_approx(approx_bglt, approx_bglt);
static approx_bglt app__default2049_90_cfa_app(fun_bglt, var_bglt, obj_t);
static obj_t imported_modules_init_94_cfa_app();
extern obj_t extern_sfun_cinfo_6_cfa_info;
extern obj_t add_generic__110___object(obj_t, obj_t);
static obj_t _app__252_cfa_app(obj_t, obj_t, obj_t, obj_t);
extern obj_t app_ast_node;
static obj_t library_modules_init_112_cfa_app();
extern approx_bglt cfa__102_cfa_cfa(node_bglt);
static obj_t toplevel_init_63_cfa_app();
extern obj_t open_input_string(obj_t);
extern approx_bglt app__231_cfa_app(fun_bglt, var_bglt, obj_t);
extern obj_t shape_tools_shape(obj_t);
extern obj_t internal_error_43_tools_error(obj_t, obj_t, obj_t);
extern obj_t _classes__134___object;
extern obj_t read___reader(obj_t);
static obj_t require_initialization_114_cfa_app = BUNSPEC;
extern approx_bglt loose__226_cfa_loose(approx_bglt, obj_t);
static obj_t cnst_init_137_cfa_app();
static obj_t __cnst[1];

DEFINE_STATIC_PROCEDURE(proc2355_cfa_app, cfa__app2048_29_cfa_app2363, cfa__app2048_29_cfa_app, 0L, 1);
extern obj_t cfa__env_153_cfa_cfa;
DEFINE_STRING(string2358_cfa_app, string2358_cfa_app2364, "ALL ", 4);
DEFINE_STRING(string2357_cfa_app, string2357_cfa_app2365, "No method for this function", 27);
DEFINE_STRING(string2356_cfa_app, string2356_cfa_app2366, "app!", 4);
DEFINE_STATIC_PROCEDURE(app__default2049_env_237_cfa_app, _app__default2049_225_cfa_app2367, _app__default2049_225_cfa_app, 0L, 3);
DEFINE_EXPORT_GENERIC(app__env_198_cfa_app, _app__252_cfa_app2368, _app__252_cfa_app, 0L, 3);



/* module-initialization */
obj_t 
module_initialization_70_cfa_app(long checksum_3395, char *from_3396)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_cfa_app))
	{
	   require_initialization_114_cfa_app =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_cfa_app();
	   cnst_init_137_cfa_app();
	   imported_modules_init_94_cfa_app();
	   method_init_76_cfa_app();
	   toplevel_init_63_cfa_app();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_cfa_app()
{
   AN_OBJECT;
   {	/* Cfa/app.scm 14 */
      module_initialization_70___object(((long) 0), "CFA_APP");
      module_initialization_70___reader(((long) 0), "CFA_APP");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_cfa_app()
{
   AN_OBJECT;
   {	/* Cfa/app.scm 14 */
      {		/* Cfa/app.scm 14 */
	 obj_t cnst_port_138_3388;
	 cnst_port_138_3388 =
	    open_input_string(string2358_cfa_app);
	 {
	    long i_3389;
	    i_3389 = ((long) 0);
	  loop_3390:
	    {	/* Cfa/app.scm 14 */
	       bool_t test2359_3391;
	       test2359_3391 =
		  (i_3389 == ((long) -1));
	       if (test2359_3391)
		 {	/* Cfa/app.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Cfa/app.scm 14 */
		    {	/* Cfa/app.scm 14 */
		       obj_t arg2360_3392;
		       {	/* Cfa/app.scm 14 */
			  obj_t list2361_3393;
			  list2361_3393 =
			     MAKE_PAIR(cnst_port_138_3388, BNIL);
			  arg2360_3392 =
			     read___reader(list2361_3393);
		       }
		       CNST_TABLE_SET(i_3389, arg2360_3392);
		    }
		    {	/* Cfa/app.scm 14 */
		       int aux_3394;
		       {	/* Cfa/app.scm 14 */
			  long aux_3413;
			  aux_3413 =
			     (i_3389 - ((long) 1));
			  aux_3394 =
			     (int) (aux_3413);
		       }
		       {
			  long i_3416;
			  i_3416 =
			     (long) (aux_3394);
			  i_3389 = i_3416;
			  goto loop_3390;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_cfa_app()
{
   AN_OBJECT;
   {	/* Cfa/app.scm 14 */
      return BUNSPEC;
   }
}



/* method-init */
obj_t 
method_init_76_cfa_app()
{
   AN_OBJECT;
   {	/* Cfa/app.scm 14 */
      {		/* Cfa/app.scm 14 */
	 obj_t cfa__app2048_29_3375;
	 cfa__app2048_29_3375 = proc2355_cfa_app;
	 add_method__1___object(cfa__env_153_cfa_cfa, app_ast_node, cfa__app2048_29_3375);
      }
      add_generic__110___object(app__env_198_cfa_app, app__default2049_env_237_cfa_app);
      add_inlined_method__244___object(app__env_198_cfa_app, intern_sfun_cinfo_192_cfa_info, ((long) 0));
      add_inlined_method__244___object(app__env_198_cfa_app, extern_sfun_cinfo_6_cfa_info, ((long) 1));
      {		/* Cfa/app.scm 14 */
	 long aux_3422;
	 aux_3422 =
	    add_inlined_method__244___object(app__env_198_cfa_app, cfun_cinfo_200_cfa_info, ((long) 2));
	 return
	    BINT(aux_3422);
      }
   }
}



/* cfa!-app2048 */
obj_t 
cfa__app2048_29_cfa_app(obj_t env_3376, obj_t node_3377)
{
   AN_OBJECT;
   {	/* Cfa/app.scm 32 */
      {
	 app_bglt node_2871;
	 {	/* Cfa/app.scm 32 */
	    approx_bglt aux_3425;
	    node_2871 =
	       (app_bglt) (node_3377);
	    {	/* Cfa/app.scm 35 */
	       value_bglt arg2302_2875;
	       var_bglt arg2303_2876;
	       obj_t arg2304_2877;
	       {	/* Cfa/app.scm 35 */
		  variable_bglt arg2305_2878;
		  {	/* Cfa/app.scm 35 */
		     var_bglt arg2306_2879;
		     arg2306_2879 =
			(((app_bglt) CREF(node_2871))->fun);
		     arg2305_2878 =
			(((var_bglt) CREF(arg2306_2879))->variable);
		  }
		  arg2302_2875 =
		     (((variable_bglt) CREF(arg2305_2878))->value);
	       }
	       arg2303_2876 =
		  (((app_bglt) CREF(node_2871))->fun);
	       {	/* Cfa/app.scm 35 */
		  obj_t l2032_2880;
		  l2032_2880 =
		     (((app_bglt) CREF(node_2871))->args);
		  if (
		     NULLP(l2032_2880))
		    {	/* Cfa/app.scm 35 */
		       arg2304_2877 = BNIL;
		    }
		  else
		    {	/* Cfa/app.scm 35 */
		       obj_t head2034_2882;
		       {	/* Cfa/app.scm 35 */
			  approx_bglt arg2314_2893;
			  {	/* Cfa/app.scm 35 */
			     node_bglt aux_3433;
			     {	/* Cfa/app.scm 35 */
				obj_t aux_3434;
				aux_3434 =
				   CAR(l2032_2880);
				aux_3433 =
				   (node_bglt) (aux_3434);
			     }
			     arg2314_2893 =
				cfa__102_cfa_cfa(aux_3433);
			  }
			  {	/* ./Ieee/pair-list.scm 5689 */
			     obj_t aux_3438;
			     aux_3438 =
				(obj_t) (arg2314_2893);
			     head2034_2882 =
				MAKE_PAIR(aux_3438, BNIL);
			  }
		       }
		       {
			  obj_t l2032_2883;
			  obj_t tail2035_2884;
			  l2032_2883 =
			     CDR(l2032_2880);
			  tail2035_2884 = head2034_2882;
			lname2033_2885:
			  if (
			     NULLP(l2032_2883))
			    {	/* Cfa/app.scm 35 */
			       arg2304_2877 = head2034_2882;
			    }
			  else
			    {	/* Cfa/app.scm 35 */
			       obj_t newtail2036_2888;
			       {	/* Cfa/app.scm 35 */
				  approx_bglt arg2311_2890;
				  {	/* Cfa/app.scm 35 */
				     node_bglt aux_3443;
				     {	/* Cfa/app.scm 35 */
					obj_t aux_3444;
					aux_3444 =
					   CAR(l2032_2883);
					aux_3443 =
					   (node_bglt) (aux_3444);
				     }
				     arg2311_2890 =
					cfa__102_cfa_cfa(aux_3443);
				  }
				  {	/* ./Ieee/pair-list.scm 5689 */
				     obj_t aux_3448;
				     aux_3448 =
					(obj_t) (arg2311_2890);
				     newtail2036_2888 =
					MAKE_PAIR(aux_3448, BNIL);
				  }
			       }
			       SET_CDR(tail2035_2884, newtail2036_2888);
			       {
				  obj_t tail2035_3454;
				  obj_t l2032_3452;
				  l2032_3452 =
				     CDR(l2032_2883);
				  tail2035_3454 = newtail2036_2888;
				  tail2035_2884 = tail2035_3454;
				  l2032_2883 = l2032_3452;
				  goto lname2033_2885;
			       }
			    }
		       }
		    }
	       }
	       aux_3425 =
		  app__231_cfa_app(
		  (fun_bglt) (arg2302_2875), arg2303_2876, arg2304_2877);
	    }
	    return
	       (obj_t) (aux_3425);
	 }
      }
   }
}



/* app! */
approx_bglt 
app__231_cfa_app(fun_bglt fun_2, var_bglt var_3, obj_t args_approx_137_4)
{
   AN_OBJECT;
   {	/* Cfa/app.scm 40 */
      {
	 obj_t method2323_2906;
	 obj_t class2328_2907;
	 {	/* Cfa/app.scm 40 */
	    obj_t arg2331_2904;
	    obj_t arg2332_2905;
	    {	/* Cfa/app.scm 40 */
	       object_bglt obj_3322;
	       obj_3322 =
		  (object_bglt) (fun_2);
	       {	/* ./Llib/object.scm 2926 */
		  obj_t pre_method_105_3323;
		  pre_method_105_3323 =
		     PROCEDURE_REF(app__env_198_cfa_app, ((long) 2));
		  if (
		     INTEGERP(pre_method_105_3323))
		    {	/* ./Llib/object.scm 2927 */
		       PROCEDURE_SET(app__env_198_cfa_app, ((long) 2), BUNSPEC);
		       arg2331_2904 = pre_method_105_3323;
		    }
		  else
		    {	/* ./Llib/object.scm 2914 */
		       long obj_class_num_177_3328;
		       obj_class_num_177_3328 =
			  TYPE(obj_3322);
		       {	/* ./Llib/object.scm 2915 */
			  obj_t arg1176_3329;
			  arg1176_3329 =
			     PROCEDURE_REF(app__env_198_cfa_app, ((long) 1));
			  {	/* ./Llib/object.scm 2738 */
			     long arg1177_3333;
			     {	/* ./Llib/object.scm 2738 */
				long arg1178_3334;
				arg1178_3334 =
				   OBJECT_TYPE;
				arg1177_3333 =
				   (obj_class_num_177_3328 - arg1178_3334);
			     }
			     arg2331_2904 =
				VECTOR_REF(arg1176_3329, arg1177_3333);
			  }
		       }
		    }
	       }
	    }
	    {	/* Cfa/app.scm 40 */
	       object_bglt object_3339;
	       object_3339 =
		  (object_bglt) (fun_2);
	       {	/* ./Llib/object.scm 2695 */
		  long arg1179_3340;
		  {	/* ./Llib/object.scm 2695 */
		     long arg1180_3341;
		     long arg1181_3342;
		     arg1180_3341 =
			TYPE(object_3339);
		     arg1181_3342 =
			OBJECT_TYPE;
		     arg1179_3340 =
			(arg1180_3341 - arg1181_3342);
		  }
		  {	/* ./Llib/object.scm 2695 */
		     obj_t vector_3346;
		     vector_3346 = _classes__134___object;
		     arg2332_2905 =
			VECTOR_REF(vector_3346, arg1179_3340);
		  }
	       }
	    }
	    {	/* Cfa/app.scm 40 */
	       obj_t aux_3475;
	       method2323_2906 = arg2331_2904;
	       class2328_2907 = arg2332_2905;
	       {

		  if (
		     INTEGERP(method2323_2906))
		    {	/* Cfa/app.scm 40 */
		       switch (
			  (long) CINT(method2323_2906))
			 {
			 case ((long) 0):

			    {	/* Cfa/app.scm 40 */
			       intern_sfun_cinfo_192_bglt fun_2913;
			       fun_2913 =
				  (intern_sfun_cinfo_192_bglt) (fun_2);
			       {
				  obj_t ll2038_2917;
				  obj_t ll2039_2918;
				  {	/* Cfa/app.scm 53 */
				     sfun_bglt obj_3348;
				     obj_3348 =
					(sfun_bglt) (fun_2913);
				     ll2038_2917 =
					(((sfun_bglt) CREF(obj_3348))->args);
				  }
				  ll2039_2918 = args_approx_137_4;
				lname2040_2919:
				  if (
				     NULLP(ll2038_2917))
				    {	/* Cfa/app.scm 53 */
				       ((bool_t) 1);
				    }
				  else
				    {	/* Cfa/app.scm 53 */
				       {	/* Cfa/app.scm 54 */
					  approx_bglt aux_3493;
					  approx_bglt aux_3481;
					  {	/* Cfa/app.scm 54 */
					     obj_t aux_3494;
					     aux_3494 =
						CAR(ll2039_2918);
					     aux_3493 =
						(approx_bglt) (aux_3494);
					  }
					  {	/* Cfa/app.scm 54 */
					     svar_cinfo_166_bglt obj_3353;
					     {	/* Cfa/app.scm 54 */
						value_bglt aux_3482;
						{	/* Cfa/app.scm 54 */
						   local_bglt obj_3352;
						   {	/* Cfa/app.scm 54 */
						      obj_t aux_3483;
						      aux_3483 =
							 CAR(ll2038_2917);
						      obj_3352 =
							 (local_bglt) (aux_3483);
						   }
						   aux_3482 =
						      (((local_bglt) CREF(obj_3352))->value);
						}
						obj_3353 =
						   (svar_cinfo_166_bglt) (aux_3482);
					     }
					     {
						obj_t aux_3488;
						{	/* ./Cfa/cinfo.scm 889 */
						   object_bglt aux_3489;
						   aux_3489 =
						      (object_bglt) (obj_3353);
						   aux_3488 =
						      OBJECT_WIDENING(aux_3489);
						}
						aux_3481 =
						   (((svar_cinfo_166_bglt) CREF(aux_3488))->approx);
					     }
					  }
					  union_approx__241_cfa_approx(aux_3481, aux_3493);
				       }
				       {
					  obj_t ll2039_3500;
					  obj_t ll2038_3498;
					  ll2038_3498 =
					     CDR(ll2038_2917);
					  ll2039_3500 =
					     CDR(ll2039_2918);
					  ll2039_2918 = ll2039_3500;
					  ll2038_2917 = ll2038_3498;
					  goto lname2040_2919;
				       }
				    }
			       }
			       {	/* Cfa/app.scm 59 */
				  approx_bglt aux_3504;
				  {	/* Cfa/app.scm 59 */
				     obj_t aux_3505;
				     {	/* Cfa/app.scm 59 */
					variable_bglt aux_3506;
					aux_3506 =
					   (((var_bglt) CREF(var_3))->variable);
					aux_3505 =
					   (obj_t) (aux_3506);
				     }
				     aux_3504 =
					cfa_intern_sfun__162_cfa_iterate(fun_2913, aux_3505);
				  }
				  aux_3475 =
				     (obj_t) (aux_3504);
			       }
			    }
			    break;
			 case ((long) 1):

			    {	/* Cfa/app.scm 40 */
			       extern_sfun_cinfo_6_bglt fun_2929;
			       fun_2929 =
				  (extern_sfun_cinfo_6_bglt) (fun_2);
			       {	/* Cfa/app.scm 69 */
				  bool_t test_3512;
				  {	/* Cfa/app.scm 69 */
				     sfun_bglt obj_3357;
				     obj_3357 =
					(sfun_bglt) (fun_2929);
				     test_3512 =
					(((sfun_bglt) CREF(obj_3357))->top__138);
				  }
				  if (test_3512)
				    {
				       obj_t l2042_2934;
				       {	/* Cfa/app.scm 69 */
					  bool_t aux_3515;
					  l2042_2934 = args_approx_137_4;
					lname2043_2935:
					  if (
					     PAIRP(l2042_2934))
					    {	/* Cfa/app.scm 69 */
					       {	/* Cfa/app.scm 69 */
						  approx_bglt aux_3518;
						  {	/* Cfa/app.scm 69 */
						     obj_t aux_3519;
						     aux_3519 =
							CAR(l2042_2934);
						     aux_3518 =
							(approx_bglt) (aux_3519);
						  }
						  loose__226_cfa_loose(aux_3518,
						     CNST_TABLE_REF(((long) 0)));
					       }
					       {
						  obj_t l2042_3524;
						  l2042_3524 =
						     CDR(l2042_2934);
						  l2042_2934 = l2042_3524;
						  goto lname2043_2935;
					       }
					    }
					  else
					    {	/* Cfa/app.scm 69 */
					       aux_3515 = ((bool_t) 1);
					    }
					  BBOOL(aux_3515);
				       }
				    }
				  else
				    {	/* Cfa/app.scm 69 */
				       BUNSPEC;
				    }
			       }
			       {	/* ./Cfa/cinfo.scm 878 */
				  approx_bglt aux_3527;
				  {
				     obj_t aux_3528;
				     {	/* ./Cfa/cinfo.scm 878 */
					object_bglt aux_3529;
					aux_3529 =
					   (object_bglt) (fun_2929);
					aux_3528 =
					   OBJECT_WIDENING(aux_3529);
				     }
				     aux_3527 =
					(((extern_sfun_cinfo_6_bglt) CREF(aux_3528))->approx);
				  }
				  aux_3475 =
				     (obj_t) (aux_3527);
			       }
			    }
			    break;
			 case ((long) 2):

			    {	/* Cfa/app.scm 40 */
			       cfun_cinfo_200_bglt fun_2939;
			       fun_2939 =
				  (cfun_cinfo_200_bglt) (fun_2);
			       {	/* Cfa/app.scm 80 */
				  bool_t test_3535;
				  {	/* Cfa/app.scm 80 */
				     cfun_bglt obj_3362;
				     obj_3362 =
					(cfun_bglt) (fun_2939);
				     test_3535 =
					(((cfun_bglt) CREF(obj_3362))->top__138);
				  }
				  if (test_3535)
				    {
				       obj_t l2045_2944;
				       {	/* Cfa/app.scm 80 */
					  bool_t aux_3538;
					  l2045_2944 = args_approx_137_4;
					lname2046_2945:
					  if (
					     PAIRP(l2045_2944))
					    {	/* Cfa/app.scm 80 */
					       {	/* Cfa/app.scm 80 */
						  approx_bglt aux_3541;
						  {	/* Cfa/app.scm 80 */
						     obj_t aux_3542;
						     aux_3542 =
							CAR(l2045_2944);
						     aux_3541 =
							(approx_bglt) (aux_3542);
						  }
						  loose__226_cfa_loose(aux_3541,
						     CNST_TABLE_REF(((long) 0)));
					       }
					       {
						  obj_t l2045_3547;
						  l2045_3547 =
						     CDR(l2045_2944);
						  l2045_2944 = l2045_3547;
						  goto lname2046_2945;
					       }
					    }
					  else
					    {	/* Cfa/app.scm 80 */
					       aux_3538 = ((bool_t) 1);
					    }
					  BBOOL(aux_3538);
				       }
				    }
				  else
				    {	/* Cfa/app.scm 80 */
				       BUNSPEC;
				    }
			       }
			       {	/* ./Cfa/cinfo.scm 877 */
				  approx_bglt aux_3550;
				  {
				     obj_t aux_3551;
				     {	/* ./Cfa/cinfo.scm 877 */
					object_bglt aux_3552;
					aux_3552 =
					   (object_bglt) (fun_2939);
					aux_3551 =
					   OBJECT_WIDENING(aux_3552);
				     }
				     aux_3550 =
					(((cfun_cinfo_200_bglt) CREF(aux_3551))->approx);
				  }
				  aux_3475 =
				     (obj_t) (aux_3550);
			       }
			    }
			    break;
			 default:
			  case_else2329_2910:
			    if (
			       PROCEDUREP(method2323_2906))
			      {		/* Cfa/app.scm 40 */
				 aux_3475 =
				    PROCEDURE_ENTRY(method2323_2906) (method2323_2906,
				    (obj_t) (fun_2),
				    (obj_t) (var_3), args_approx_137_4, BEOA)
				    ;
			      }
			    else
			      {		/* Cfa/app.scm 40 */
				 obj_t fun2318_2898;
				 fun2318_2898 =
				    PROCEDURE_REF(app__env_198_cfa_app, ((long) 0));
				 aux_3475 =
				    PROCEDURE_ENTRY(fun2318_2898) (fun2318_2898,
				    (obj_t) (fun_2),
				    (obj_t) (var_3), args_approx_137_4, BEOA);
			      }
			 }
		    }
		  else
		    {	/* Cfa/app.scm 40 */
		       goto case_else2329_2910;
		    }
	       }
	       return
		  (approx_bglt) (aux_3475);
	    }
	 }
      }
   }
}



/* _app! */
obj_t 
_app__252_cfa_app(obj_t env_3380, obj_t fun_3381, obj_t var_3382, obj_t args_approx_137_3383)
{
   AN_OBJECT;
   {	/* Cfa/app.scm 40 */
      {		/* Cfa/app.scm 40 */
	 approx_bglt aux_3571;
	 aux_3571 =
	    app__231_cfa_app(
	    (fun_bglt) (fun_3381),
	    (var_bglt) (var_3382), args_approx_137_3383);
	 return
	    (obj_t) (aux_3571);
      }
   }
}



/* app!-default2049 */
approx_bglt 
app__default2049_90_cfa_app(fun_bglt fun_5, var_bglt var_6, obj_t args_approx_137_7)
{
   AN_OBJECT;
   {	/* Cfa/app.scm 14 */
      {		/* Cfa/app.scm 41 */
	 obj_t arg2321_3371;
	 {	/* Cfa/app.scm 43 */
	    obj_t arg2322_3372;
	    arg2322_3372 =
	       shape_tools_shape(
	       (obj_t) (var_6));
	    {	/* ./Ieee/pair-list.scm 5689 */
	       obj_t aux_3578;
	       aux_3578 =
		  (obj_t) (fun_5);
	       arg2321_3371 =
		  MAKE_PAIR(aux_3578, arg2322_3372);
	    }
	 }
	 {	/* Cfa/app.scm 41 */
	    obj_t aux_3581;
	    aux_3581 =
	       internal_error_43_tools_error(string2356_cfa_app, string2357_cfa_app, arg2321_3371);
	    return
	       (approx_bglt) (aux_3581);
	 }
      }
   }
}



/* _app!-default2049 */
obj_t 
_app__default2049_225_cfa_app(obj_t env_3384, obj_t fun_3385, obj_t var_3386, obj_t args_approx_137_3387)
{
   AN_OBJECT;
   {	/* Cfa/app.scm 14 */
      {		/* Cfa/app.scm 14 */
	 approx_bglt aux_3584;
	 aux_3584 =
	    app__default2049_90_cfa_app(
	    (fun_bglt) (fun_3385),
	    (var_bglt) (var_3386), args_approx_137_3387);
	 return
	    (obj_t) (aux_3584);
      }
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_cfa_app()
{
   AN_OBJECT;
   {	/* Cfa/app.scm 14 */
      module_initialization_70_tools_trace(((long) 0), "CFA_APP");
      module_initialization_70_tools_shape(((long) 0), "CFA_APP");
      module_initialization_70_tools_error(((long) 0), "CFA_APP");
      module_initialization_70_type_type(((long) 0), "CFA_APP");
      module_initialization_70_ast_var(((long) 0), "CFA_APP");
      module_initialization_70_ast_node(((long) 0), "CFA_APP");
      module_initialization_70_cfa_info(((long) 0), "CFA_APP");
      module_initialization_70_cfa_info2(((long) 0), "CFA_APP");
      module_initialization_70_cfa_cfa(((long) 0), "CFA_APP");
      module_initialization_70_cfa_iterate(((long) 0), "CFA_APP");
      module_initialization_70_cfa_loose(((long) 0), "CFA_APP");
      return
	 module_initialization_70_cfa_approx(((long) 0), "CFA_APP");
   }
}
