/*===========================================================================*/
/*   (Cfa/approx.scm)                                                        */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;

typedef struct approx
  {
     header_t header;
     obj_t widening;
     struct type *type;
     bool_t type_locked__184;
     obj_t allocs;
     bool_t top__138;
     long lost_stamp_114;
  }
      *approx_bglt;

typedef struct cfun_cinfo_200
  {
     struct approx *approx;
  }
              *cfun_cinfo_200_bglt;

typedef struct extern_sfun_cinfo_6
  {
     struct approx *approx;
  }
                   *extern_sfun_cinfo_6_bglt;

typedef struct intern_sfun_cinfo_192
  {
     struct approx *approx;
     long stamp;
  }
                     *intern_sfun_cinfo_192_bglt;

typedef struct scnst_cinfo_0
  {
     struct approx *approx;
  }
             *scnst_cinfo_0_bglt;

typedef struct pre_clo_env_191
  {
     char dummy;
  }
               *pre_clo_env_191_bglt;

typedef struct svar_cinfo_166
  {
     struct approx *approx;
     bool_t clo_env__87;
  }
              *svar_cinfo_166_bglt;

typedef struct cvar_cinfo_53
  {
     struct approx *approx;
  }
             *cvar_cinfo_53_bglt;

typedef struct sexit_cinfo_49
  {
     struct approx *approx;
  }
              *sexit_cinfo_49_bglt;

typedef struct reshaped_local_224
  {
     obj_t binding_value_3;
  }
                  *reshaped_local_224_bglt;

typedef struct reshaped_global_160
  {
     char dummy;
  }
                   *reshaped_global_160_bglt;

typedef struct atom_cinfo_155
  {
     struct approx *approx;
  }
              *atom_cinfo_155_bglt;

typedef struct kwote_node_102
  {
     struct node *node;
  }
              *kwote_node_102_bglt;

typedef struct kwote_cinfo_48
  {
     struct approx *approx;
  }
              *kwote_cinfo_48_bglt;

typedef struct app_ly_cinfo_234
  {
     struct approx *approx;
  }
                *app_ly_cinfo_234_bglt;

typedef struct funcall_cinfo_75
  {
     struct approx *approx;
     struct approx *va_approx_63;
     bool_t arity_error_noticed__118;
     bool_t type_error_noticed__36;
  }
                *funcall_cinfo_75_bglt;

typedef struct pragma_cinfo_220
  {
     struct approx *approx;
  }
                *pragma_cinfo_220_bglt;

typedef struct setq_cinfo_191
  {
     struct approx *approx;
  }
              *setq_cinfo_191_bglt;

typedef struct conditional_cinfo_212
  {
     struct approx *approx;
  }
                     *conditional_cinfo_212_bglt;

typedef struct fail_cinfo_75
  {
     struct approx *approx;
  }
             *fail_cinfo_75_bglt;

typedef struct select_cinfo_150
  {
     struct approx *approx;
  }
                *select_cinfo_150_bglt;

typedef struct set_ex_it_cinfo_168
  {
     struct approx *approx;
  }
                   *set_ex_it_cinfo_168_bglt;

typedef struct jump_ex_it_cinfo_139
  {
     struct approx *approx;
  }
                    *jump_ex_it_cinfo_139_bglt;

typedef struct pre_make_box_186
  {
     char dummy;
  }
                *pre_make_box_186_bglt;

typedef struct make_box_cinfo_127
  {
     struct approx *approx;
  }
                  *make_box_cinfo_127_bglt;

typedef struct make_box_o_cinfo_96
  {
     struct approx *approx;
     struct approx *value_approx_19;
  }
                   *make_box_o_cinfo_96_bglt;

typedef struct box_set__cinfo_94
  {
     struct approx *approx;
  }
                 *box_set__cinfo_94_bglt;

typedef struct box_ref_cinfo_214
  {
     struct approx *approx;
  }
                 *box_ref_cinfo_214_bglt;

typedef struct box_set__o_cinfo_6
  {
     struct approx *approx;
  }
                  *box_set__o_cinfo_6_bglt;

typedef struct box_ref_o_cinfo_98
  {
     struct approx *approx;
  }
                  *box_ref_o_cinfo_98_bglt;

typedef struct pre_make_procedure_app_60
  {
     struct variable *owner;
  }
                         *pre_make_procedure_app_60_bglt;

typedef struct pre_procedure_ref_app_85
  {
     char dummy;
  }
                        *pre_procedure_ref_app_85_bglt;

typedef struct pre_procedure_set__app_208
  {
     char dummy;
  }
                          *pre_procedure_set__app_208_bglt;

typedef struct make_procedure_app_48
  {
     struct approx *approx;
     long values_approx_len_106;
     struct approx **values_approx_79;
     long lost_stamp_114;
     bool_t x_t__142;
     bool_t x;
     bool_t t;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
  }
                     *make_procedure_app_48_bglt;

typedef struct procedure_ref_app_49
  {
     struct approx *approx;
  }
                    *procedure_ref_app_49_bglt;

typedef struct procedure_set__app_32
  {
     struct approx *approx;
  }
                     *procedure_set__app_32_bglt;

typedef struct pre_make_vector_app_251
  {
     struct variable *owner;
  }
                       *pre_make_vector_app_251_bglt;

typedef struct pre_create_vector_app_162
  {
     struct variable *owner;
  }
                         *pre_create_vector_app_162_bglt;

typedef struct pre_vector_ref_app_208
  {
     char dummy;
  }
                      *pre_vector_ref_app_208_bglt;

typedef struct pre_vector_set__app_211
  {
     char dummy;
  }
                       *pre_vector_set__app_211_bglt;

typedef struct make_vector_app_205
  {
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
     bool_t seen__39;
  }
                   *make_vector_app_205_bglt;

typedef struct create_vector_app_150
  {
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
     bool_t seen__39;
  }
                     *create_vector_app_150_bglt;

typedef struct vector_ref_app_195
  {
     struct approx *approx;
  }
                  *vector_ref_app_195_bglt;

typedef struct vector_set__app_21
  {
     struct approx *approx;
  }
                  *vector_set__app_21_bglt;

typedef struct pre_make_struct_app_218
  {
     struct variable *owner;
  }
                       *pre_make_struct_app_218_bglt;

typedef struct pre_struct_ref_app_207
  {
     char dummy;
  }
                      *pre_struct_ref_app_207_bglt;

typedef struct pre_struct_set__app_116
  {
     char dummy;
  }
                       *pre_struct_set__app_116_bglt;

typedef struct make_struct_app_214
  {
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
  }
                   *make_struct_app_214_bglt;

typedef struct struct_ref_app_73
  {
     struct approx *approx;
  }
                 *struct_ref_app_73_bglt;

typedef struct struct_set__app_162
  {
     struct approx *approx;
  }
                   *struct_set__app_162_bglt;


static obj_t method_init_76_cfa_approx();
extern obj_t declare_approx_sets__132_cfa_approx();
static obj_t shape_approx2038_154_cfa_approx(obj_t, obj_t);
extern obj_t symbol_append_197___r4_symbols_6_4(obj_t);
extern long add_inlined_method__244___object(obj_t, obj_t, long);
extern obj_t disable_x_t__211_cfa_procedure(approx_bglt);
static obj_t _make_type_approx_211_cfa_approx(obj_t, obj_t);
extern obj_t type_type_type;
extern obj_t var_ast_node;
extern obj_t get_allocs_52_cfa_collect();
extern obj_t get_node_atom_value_135_cfa_approx(node_bglt);
static obj_t _make_empty_approx_139_cfa_approx(obj_t);
extern obj_t set_union__206_cfa_set(obj_t, obj_t);
extern obj_t add_method__1___object(obj_t, obj_t, obj_t);
extern obj_t _obj__252_type_cache;
static obj_t _for_each_approx_alloc_106_cfa_approx(obj_t, obj_t, obj_t);
static obj_t _alloc_set__27_cfa_approx = BUNSPEC;
extern approx_bglt make_type_approx_184_cfa_approx(type_bglt);
extern approx_bglt make_empty_approx_131_cfa_approx();
extern bool_t is_a__118___object(obj_t, obj_t);
static obj_t _make_alloc_approx_59_cfa_approx(obj_t, obj_t);
extern obj_t module_initialization_70_cfa_approx(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_tools_misc(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_cfa_info(long, char *);
extern obj_t module_initialization_70_cfa_info2(long, char *);
extern obj_t module_initialization_70_cfa_collect(long, char *);
extern obj_t module_initialization_70_cfa_set(long, char *);
extern obj_t module_initialization_70_cfa_iterate(long, char *);
extern obj_t module_initialization_70_cfa_loose(long, char *);
extern obj_t module_initialization_70_cfa_procedure(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_symbols_6_4(long, char *);
extern obj_t module_initialization_70___r4_vectors_6_8(long, char *);
extern approx_bglt union_approx__241_cfa_approx(approx_bglt, approx_bglt);
extern approx_bglt make_alloc_approx_89_cfa_approx(app_bglt);
extern long class_num_218___object(obj_t);
extern obj_t list__vector_101___r4_vectors_6_8(obj_t);
extern obj_t make_set__25_cfa_set(obj_t);
extern obj_t reshaped_local_224_cfa_info;
extern obj_t node_ast_node;
static obj_t imported_modules_init_94_cfa_approx();
static obj_t _node_key_set__44_cfa_approx(obj_t, obj_t, obj_t);
extern obj_t set_extend__187_cfa_set(obj_t, obj_t);
static obj_t _make_type_alloc_approx_37_cfa_approx(obj_t, obj_t, obj_t);
static obj_t _get_node_atom_value2371_28_cfa_approx(obj_t, obj_t);
extern obj_t add_generic__110___object(obj_t, obj_t);
extern obj_t approx_set_top__187_cfa_approx(approx_bglt);
static obj_t library_modules_init_112_cfa_approx();
static obj_t _node_key_105_cfa_approx(obj_t, obj_t);
extern obj_t make_struct(obj_t, long, obj_t);
static obj_t _approx_set_type__245_cfa_approx(obj_t, obj_t, obj_t);
extern obj_t atom_ast_node;
extern obj_t for_each_approx_alloc_83_cfa_approx(obj_t, approx_bglt);
static obj_t toplevel_init_63_cfa_approx();
extern obj_t node_key_123_cfa_approx(node_effect_213_bglt);
extern obj_t open_input_string(obj_t);
extern obj_t approx_set_type__239_cfa_approx(approx_bglt, type_bglt);
static obj_t _approx_set_top__201_cfa_approx(obj_t, obj_t);
extern obj_t set__vector_66_cfa_set(obj_t);
extern obj_t approx_cfa_info;
static obj_t _declare_approx_sets__161_cfa_approx(obj_t);
static obj_t _get_node_atom_value_default2039_96_cfa_approx(obj_t, obj_t);
static obj_t _union_approx__74_cfa_approx(obj_t, obj_t, obj_t);
extern obj_t _procedure__226_type_cache;
extern obj_t _4dots_199_tools_misc;
extern obj_t _classes__134___object;
extern obj_t set_for_each_94_cfa_set(obj_t, obj_t);
extern obj_t read___reader(obj_t);
extern obj_t node_key_set__195_cfa_approx(node_effect_213_bglt, obj_t);
extern obj_t declare_set__41_cfa_set(obj_t);
extern obj_t ____74_type_cache;
static obj_t require_initialization_114_cfa_approx = BUNSPEC;
extern approx_bglt make_type_alloc_approx_134_cfa_approx(type_bglt, node_bglt);
static obj_t get_node_atom_value_default2039_253_cfa_approx(node_bglt);
extern obj_t continue_cfa__104_cfa_iterate();
static obj_t cnst_init_137_cfa_approx();
static obj_t __cnst[2];

DEFINE_EXPORT_PROCEDURE(union_approx__env_180_cfa_approx, _union_approx__74_cfa_approx2378, _union_approx__74_cfa_approx, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_empty_approx_env_91_cfa_approx, _make_empty_approx_139_cfa_approx2379, _make_empty_approx_139_cfa_approx, 0L, 0);
DEFINE_EXPORT_PROCEDURE(make_alloc_approx_env_133_cfa_approx, _make_alloc_approx_59_cfa_approx2380, _make_alloc_approx_59_cfa_approx, 0L, 1);
DEFINE_STATIC_PROCEDURE(get_node_atom_value_default2039_env_31_cfa_approx, _get_node_atom_value_default2039_96_cfa_approx2381, _get_node_atom_value_default2039_96_cfa_approx, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2372_cfa_approx, shape_approx2038_154_cfa_approx2382, shape_approx2038_154_cfa_approx, 0L, 1);
DEFINE_EXPORT_PROCEDURE(approx_set_type__env_251_cfa_approx, _approx_set_type__245_cfa_approx2383, _approx_set_type__245_cfa_approx, 0L, 2);
DEFINE_EXPORT_PROCEDURE(node_key_set__env_57_cfa_approx, _node_key_set__44_cfa_approx2384, _node_key_set__44_cfa_approx, 0L, 2);
DEFINE_EXPORT_GENERIC(get_node_atom_value_env_18_cfa_approx, _get_node_atom_value2371_28_cfa_approx2385, _get_node_atom_value2371_28_cfa_approx, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_type_alloc_approx_env_199_cfa_approx, _make_type_alloc_approx_37_cfa_approx2386, _make_type_alloc_approx_37_cfa_approx, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_type_approx_env_161_cfa_approx, _make_type_approx_211_cfa_approx2387, _make_type_approx_211_cfa_approx, 0L, 1);
DEFINE_EXPORT_PROCEDURE(node_key_env_229_cfa_approx, _node_key_105_cfa_approx2388, _node_key_105_cfa_approx, 0L, 1);
DEFINE_STRING(string2373_cfa_approx, string2373_cfa_approx2389, "(NO-ATOM-VALUE) TOP ", 20);
DEFINE_EXPORT_PROCEDURE(declare_approx_sets__env_104_cfa_approx, _declare_approx_sets__161_cfa_approx2390, _declare_approx_sets__161_cfa_approx, 0L, 0);
extern obj_t shape_env_98_tools_shape;
DEFINE_EXPORT_PROCEDURE(for_each_approx_alloc_env_245_cfa_approx, _for_each_approx_alloc_106_cfa_approx2391, _for_each_approx_alloc_106_cfa_approx, 0L, 2);
DEFINE_EXPORT_PROCEDURE(approx_set_top__env_151_cfa_approx, _approx_set_top__201_cfa_approx2392, _approx_set_top__201_cfa_approx, 0L, 1);



/* module-initialization */
obj_t 
module_initialization_70_cfa_approx(long checksum_3528, char *from_3529)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_cfa_approx))
	{
	   require_initialization_114_cfa_approx =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_cfa_approx();
	   cnst_init_137_cfa_approx();
	   imported_modules_init_94_cfa_approx();
	   method_init_76_cfa_approx();
	   toplevel_init_63_cfa_approx();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_cfa_approx()
{
   AN_OBJECT;
   {	/* Cfa/approx.scm 14 */
      module_initialization_70___r4_symbols_6_4(((long) 0), "CFA_APPROX");
      module_initialization_70___object(((long) 0), "CFA_APPROX");
      module_initialization_70___r4_vectors_6_8(((long) 0), "CFA_APPROX");
      module_initialization_70___reader(((long) 0), "CFA_APPROX");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_cfa_approx()
{
   AN_OBJECT;
   {	/* Cfa/approx.scm 14 */
      {		/* Cfa/approx.scm 14 */
	 obj_t cnst_port_138_3521;
	 cnst_port_138_3521 =
	    open_input_string(string2373_cfa_approx);
	 {
	    long i_3522;
	    i_3522 = ((long) 1);
	  loop_3523:
	    {	/* Cfa/approx.scm 14 */
	       bool_t test2374_3524;
	       test2374_3524 =
		  (i_3522 == ((long) -1));
	       if (test2374_3524)
		 {	/* Cfa/approx.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Cfa/approx.scm 14 */
		    {	/* Cfa/approx.scm 14 */
		       obj_t arg2375_3525;
		       {	/* Cfa/approx.scm 14 */
			  obj_t list2376_3526;
			  list2376_3526 =
			     MAKE_PAIR(cnst_port_138_3521, BNIL);
			  arg2375_3525 =
			     read___reader(list2376_3526);
		       }
		       CNST_TABLE_SET(i_3522, arg2375_3525);
		    }
		    {	/* Cfa/approx.scm 14 */
		       int aux_3527;
		       {	/* Cfa/approx.scm 14 */
			  long aux_3548;
			  aux_3548 =
			     (i_3522 - ((long) 1));
			  aux_3527 =
			     (int) (aux_3548);
		       }
		       {
			  long i_3551;
			  i_3551 =
			     (long) (aux_3527);
			  i_3522 = i_3551;
			  goto loop_3523;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_cfa_approx()
{
   AN_OBJECT;
   {	/* Cfa/approx.scm 14 */
      _alloc_set__27_cfa_approx = BUNSPEC;
      return BUNSPEC;
   }
}



/* declare-approx-sets! */
obj_t 
declare_approx_sets__132_cfa_approx()
{
   AN_OBJECT;
   {	/* Cfa/approx.scm 50 */
      {		/* Cfa/approx.scm 51 */
	 obj_t arg2044_2117;
	 {	/* Cfa/approx.scm 51 */
	    obj_t arg2045_2118;
	    arg2045_2118 =
	       get_allocs_52_cfa_collect();
	    arg2044_2117 =
	       list__vector_101___r4_vectors_6_8(arg2045_2118);
	 }
	 return (
	    _alloc_set__27_cfa_approx =
	    declare_set__41_cfa_set(arg2044_2117), BUNSPEC);
      }
   }
}



/* _declare-approx-sets! */
obj_t 
_declare_approx_sets__161_cfa_approx(obj_t env_3487)
{
   AN_OBJECT;
   {	/* Cfa/approx.scm 50 */
      return
	 declare_approx_sets__132_cfa_approx();
   }
}



/* node-key */
obj_t 
node_key_123_cfa_approx(node_effect_213_bglt node_1)
{
   AN_OBJECT;
   {	/* Cfa/approx.scm 56 */
      return
	 (((node_effect_213_bglt) CREF(node_1))->key);
   }
}



/* _node-key */
obj_t 
_node_key_105_cfa_approx(obj_t env_3488, obj_t node_3489)
{
   AN_OBJECT;
   {	/* Cfa/approx.scm 56 */
      return
	 node_key_123_cfa_approx(
	 (node_effect_213_bglt) (node_3489));
   }
}



/* node-key-set! */
obj_t 
node_key_set__195_cfa_approx(node_effect_213_bglt node_2, obj_t key_3)
{
   AN_OBJECT;
   {	/* Cfa/approx.scm 62 */
      return
	 ((((node_effect_213_bglt) CREF(node_2))->key) = ((obj_t) key_3), BUNSPEC);
   }
}



/* _node-key-set! */
obj_t 
_node_key_set__44_cfa_approx(obj_t env_3490, obj_t node_3491, obj_t key_3492)
{
   AN_OBJECT;
   {	/* Cfa/approx.scm 62 */
      return
	 node_key_set__195_cfa_approx(
	 (node_effect_213_bglt) (node_3491), key_3492);
   }
}



/* union-approx! */
approx_bglt 
union_approx__241_cfa_approx(approx_bglt dst_4, approx_bglt src_5)
{
   AN_OBJECT;
   {	/* Cfa/approx.scm 68 */
      approx_set_type__239_cfa_approx(dst_4,
	 (((approx_bglt) CREF(src_5))->type));
      {		/* Cfa/approx.scm 72 */
	 bool_t test2047_2120;
	 {	/* Cfa/approx.scm 72 */
	    bool_t test2048_2121;
	    {	/* Cfa/approx.scm 72 */
	       obj_t obj2_2976;
	       obj2_2976 = _procedure__226_type_cache;
	       {	/* ./Ieee/equiv.scm 5508 */
		  obj_t aux_3565;
		  {	/* Cfa/approx.scm 72 */
		     type_bglt aux_3566;
		     aux_3566 =
			(((approx_bglt) CREF(dst_4))->type);
		     aux_3565 =
			(obj_t) (aux_3566);
		  }
		  test2048_2121 =
		     (aux_3565 == obj2_2976);
	       }
	    }
	    if (test2048_2121)
	      {		/* Cfa/approx.scm 72 */
		 test2047_2120 = ((bool_t) 1);
	      }
	    else
	      {		/* Cfa/approx.scm 73 */
		 obj_t obj2_2979;
		 obj2_2979 = ____74_type_cache;
		 {	/* ./Ieee/equiv.scm 5508 */
		    obj_t aux_3571;
		    {	/* Cfa/approx.scm 73 */
		       type_bglt aux_3572;
		       aux_3572 =
			  (((approx_bglt) CREF(dst_4))->type);
		       aux_3571 =
			  (obj_t) (aux_3572);
		    }
		    test2047_2120 =
		       (aux_3571 == obj2_2979);
		 }
	      }
	 }
	 if (test2047_2120)
	   {	/* Cfa/approx.scm 72 */
	      BUNSPEC;
	   }
	 else
	   {	/* Cfa/approx.scm 72 */
	      disable_x_t__211_cfa_procedure(src_5);
	   }
      }
      if (
	 (((approx_bglt) CREF(src_5))->top__138))
	{	/* Cfa/approx.scm 76 */
	   approx_set_top__187_cfa_approx(dst_4);
	}
      else
	{	/* Cfa/approx.scm 76 */
	   BUNSPEC;
	}
      {		/* Cfa/approx.scm 78 */
	 bool_t test2052_2125;
	 {	/* Cfa/approx.scm 78 */
	    obj_t arg2053_2126;
	    arg2053_2126 =
	       (((approx_bglt) CREF(dst_4))->allocs);
	    {	/* Cfa/approx.scm 78 */
	       obj_t list2055_2128;
	       {	/* Cfa/approx.scm 78 */
		  obj_t aux_3582;
		  aux_3582 =
		     (((approx_bglt) CREF(src_5))->allocs);
		  list2055_2128 =
		     MAKE_PAIR(aux_3582, BNIL);
	       }
	       {	/* Cfa/approx.scm 78 */
		  obj_t aux_3585;
		  aux_3585 =
		     set_union__206_cfa_set(arg2053_2126, list2055_2128);
		  test2052_2125 =
		     CBOOL(aux_3585);
	       }
	    }
	 }
	 if (test2052_2125)
	   {	/* Cfa/approx.scm 78 */
	      continue_cfa__104_cfa_iterate();
	   }
	 else
	   {	/* Cfa/approx.scm 78 */
	      BUNSPEC;
	   }
      }
      return dst_4;
   }
}



/* _union-approx! */
obj_t 
_union_approx__74_cfa_approx(obj_t env_3493, obj_t dst_3494, obj_t src_3495)
{
   AN_OBJECT;
   {	/* Cfa/approx.scm 68 */
      {		/* Cfa/approx.scm 68 */
	 approx_bglt aux_3590;
	 aux_3590 =
	    union_approx__241_cfa_approx(
	    (approx_bglt) (dst_3494),
	    (approx_bglt) (src_3495));
	 return
	    (obj_t) (aux_3590);
      }
   }
}



/* approx-set-type! */
obj_t 
approx_set_type__239_cfa_approx(approx_bglt dst_6, type_bglt type_7)
{
   AN_OBJECT;
   {	/* Cfa/approx.scm 85 */
      if (
	 (((approx_bglt) CREF(dst_6))->type_locked__184))
	{	/* Cfa/approx.scm 87 */
	   return BFALSE;
	}
      else
	{	/* Cfa/approx.scm 89 */
	   bool_t test2057_2130;
	   {	/* Cfa/approx.scm 89 */
	      obj_t obj2_2985;
	      obj2_2985 = ____74_type_cache;
	      {		/* ./Ieee/equiv.scm 5508 */
		 obj_t aux_3597;
		 aux_3597 =
		    (obj_t) (type_7);
		 test2057_2130 =
		    (aux_3597 == obj2_2985);
	      }
	   }
	   if (test2057_2130)
	     {	/* Cfa/approx.scm 89 */
		return BFALSE;
	     }
	   else
	     {	/* Cfa/approx.scm 91 */
		bool_t test_3601;
		{	/* ./Ieee/equiv.scm 5508 */
		   obj_t aux_3606;
		   obj_t aux_3602;
		   aux_3606 =
		      (obj_t) (type_7);
		   {	/* Cfa/approx.scm 91 */
		      type_bglt aux_3603;
		      aux_3603 =
			 (((approx_bglt) CREF(dst_6))->type);
		      aux_3602 =
			 (obj_t) (aux_3603);
		   }
		   test_3601 =
		      (aux_3602 == aux_3606);
		}
		if (test_3601)
		  {	/* Cfa/approx.scm 91 */
		     return BFALSE;
		  }
		else
		  {	/* Cfa/approx.scm 93 */
		     bool_t test2059_2132;
		     {	/* Cfa/approx.scm 93 */
			obj_t obj2_2991;
			obj2_2991 = _obj__252_type_cache;
			{	/* ./Ieee/equiv.scm 5508 */
			   obj_t aux_3609;
			   {	/* Cfa/approx.scm 93 */
			      type_bglt aux_3610;
			      aux_3610 =
				 (((approx_bglt) CREF(dst_6))->type);
			      aux_3609 =
				 (obj_t) (aux_3610);
			   }
			   test2059_2132 =
			      (aux_3609 == obj2_2991);
			}
		     }
		     if (test2059_2132)
		       {	/* Cfa/approx.scm 93 */
			  return BFALSE;
		       }
		     else
		       {	/* Cfa/approx.scm 95 */
			  bool_t test2060_2133;
			  {	/* Cfa/approx.scm 95 */
			     obj_t obj2_2994;
			     obj2_2994 = ____74_type_cache;
			     {	/* ./Ieee/equiv.scm 5508 */
				obj_t aux_3615;
				{	/* Cfa/approx.scm 95 */
				   type_bglt aux_3616;
				   aux_3616 =
				      (((approx_bglt) CREF(dst_6))->type);
				   aux_3615 =
				      (obj_t) (aux_3616);
				}
				test2060_2133 =
				   (aux_3615 == obj2_2994);
			     }
			  }
			  if (test2060_2133)
			    {	/* Cfa/approx.scm 95 */
			       ((((approx_bglt) CREF(dst_6))->type) = ((type_bglt) type_7), BUNSPEC);
			       return
				  continue_cfa__104_cfa_iterate();
			    }
			  else
			    {	/* Cfa/approx.scm 95 */
			       {	/* Cfa/approx.scm 99 */
				  type_bglt val1437_2998;
				  val1437_2998 =
				     (type_bglt) (_obj__252_type_cache);
				  ((((approx_bglt) CREF(dst_6))->type) = ((type_bglt) val1437_2998), BUNSPEC);
			       }
			       return
				  continue_cfa__104_cfa_iterate();
			    }
		       }
		  }
	     }
	}
   }
}



/* _approx-set-type! */
obj_t 
_approx_set_type__245_cfa_approx(obj_t env_3496, obj_t dst_3497, obj_t type_3498)
{
   AN_OBJECT;
   {	/* Cfa/approx.scm 85 */
      return
	 approx_set_type__239_cfa_approx(
	 (approx_bglt) (dst_3497),
	 (type_bglt) (type_3498));
   }
}



/* approx-set-top! */
obj_t 
approx_set_top__187_cfa_approx(approx_bglt dst_8)
{
   AN_OBJECT;
   {	/* Cfa/approx.scm 105 */
      if (
	 (((approx_bglt) CREF(dst_8))->top__138))
	{	/* Cfa/approx.scm 106 */
	   return BUNSPEC;
	}
      else
	{	/* Cfa/approx.scm 106 */
	   ((((approx_bglt) CREF(dst_8))->top__138) = ((bool_t) ((bool_t) 1)), BUNSPEC);
	   return
	      continue_cfa__104_cfa_iterate();
	}
   }
}



/* _approx-set-top! */
obj_t 
_approx_set_top__201_cfa_approx(obj_t env_3499, obj_t dst_3500)
{
   AN_OBJECT;
   {	/* Cfa/approx.scm 105 */
      return
	 approx_set_top__187_cfa_approx(
	 (approx_bglt) (dst_3500));
   }
}



/* make-empty-approx */
approx_bglt 
make_empty_approx_131_cfa_approx()
{
   AN_OBJECT;
   {	/* Cfa/approx.scm 115 */
      {		/* Cfa/approx.scm 116 */
	 obj_t allocs_2138;
	 allocs_2138 =
	    make_set__25_cfa_set(_alloc_set__27_cfa_approx);
	 {	/* Cfa/approx.scm 117 */
	    obj_t arg2065_2139;
	    arg2065_2139 = ____74_type_cache;
	    {	/* Cfa/approx.scm 117 */
	       approx_bglt res2365_3016;
	       {	/* Cfa/approx.scm 117 */
		  type_bglt type_3002;
		  type_3002 =
		     (type_bglt) (arg2065_2139);
		  {	/* ./Cfa/cinfo.scm 1019 */
		     approx_bglt new1440_3007;
		     new1440_3007 =
			((approx_bglt) BREF(GC_MALLOC(sizeof(struct approx))));
		     {	/* ./Cfa/cinfo.scm 1019 */
			long arg2253_3008;
			arg2253_3008 =
			   class_num_218___object(approx_cfa_info);
			{	/* ./Cfa/cinfo.scm 1019 */
			   obj_t obj_3014;
			   obj_3014 =
			      (obj_t) (new1440_3007);
			   (((obj_t) CREF(obj_3014))->header = MAKE_HEADER(arg2253_3008, 0), BUNSPEC);
			}
		     }
		     {	/* ./Cfa/cinfo.scm 1019 */
			object_bglt aux_3641;
			aux_3641 =
			   (object_bglt) (new1440_3007);
			OBJECT_WIDENING_SET(aux_3641, BFALSE);
		     }
		     ((((approx_bglt) CREF(new1440_3007))->type) = ((type_bglt) type_3002), BUNSPEC);
		     ((((approx_bglt) CREF(new1440_3007))->type_locked__184) = ((bool_t) ((bool_t) 0)), BUNSPEC);
		     ((((approx_bglt) CREF(new1440_3007))->allocs) = ((obj_t) allocs_2138), BUNSPEC);
		     ((((approx_bglt) CREF(new1440_3007))->top__138) = ((bool_t) ((bool_t) 0)), BUNSPEC);
		     ((((approx_bglt) CREF(new1440_3007))->lost_stamp_114) = ((long) ((long) -1)), BUNSPEC);
		     res2365_3016 = new1440_3007;
		  }
	       }
	       return res2365_3016;
	    }
	 }
      }
   }
}



/* _make-empty-approx */
obj_t 
_make_empty_approx_139_cfa_approx(obj_t env_3501)
{
   AN_OBJECT;
   {	/* Cfa/approx.scm 115 */
      {		/* Cfa/approx.scm 115 */
	 approx_bglt aux_3649;
	 aux_3649 =
	    make_empty_approx_131_cfa_approx();
	 return
	    (obj_t) (aux_3649);
      }
   }
}



/* make-type-approx */
approx_bglt 
make_type_approx_184_cfa_approx(type_bglt type_9)
{
   AN_OBJECT;
   {	/* Cfa/approx.scm 124 */
      {		/* Cfa/approx.scm 125 */
	 obj_t allocs_2142;
	 allocs_2142 =
	    make_set__25_cfa_set(_alloc_set__27_cfa_approx);
	 {	/* Cfa/approx.scm 126 */
	    bool_t arg2069_2144;
	    {	/* Cfa/approx.scm 127 */
	       bool_t test2072_2147;
	       {	/* Cfa/approx.scm 127 */
		  obj_t obj2_3018;
		  obj2_3018 = ____74_type_cache;
		  {	/* ./Ieee/equiv.scm 5508 */
		     obj_t aux_3653;
		     aux_3653 =
			(obj_t) (type_9);
		     test2072_2147 =
			(aux_3653 == obj2_3018);
		  }
	       }
	       if (test2072_2147)
		 {	/* Cfa/approx.scm 127 */
		    arg2069_2144 = ((bool_t) 0);
		 }
	       else
		 {	/* Cfa/approx.scm 127 */
		    arg2069_2144 = ((bool_t) 1);
		 }
	    }
	    {	/* Cfa/approx.scm 126 */
	       approx_bglt res2366_3033;
	       {	/* ./Cfa/cinfo.scm 1019 */
		  approx_bglt new1440_3024;
		  new1440_3024 =
		     ((approx_bglt) BREF(GC_MALLOC(sizeof(struct approx))));
		  {	/* ./Cfa/cinfo.scm 1019 */
		     long arg2253_3025;
		     arg2253_3025 =
			class_num_218___object(approx_cfa_info);
		     {	/* ./Cfa/cinfo.scm 1019 */
			obj_t obj_3031;
			obj_3031 =
			   (obj_t) (new1440_3024);
			(((obj_t) CREF(obj_3031))->header = MAKE_HEADER(arg2253_3025, 0), BUNSPEC);
		     }
		  }
		  {	/* ./Cfa/cinfo.scm 1019 */
		     object_bglt aux_3661;
		     aux_3661 =
			(object_bglt) (new1440_3024);
		     OBJECT_WIDENING_SET(aux_3661, BFALSE);
		  }
		  ((((approx_bglt) CREF(new1440_3024))->type) = ((type_bglt) type_9), BUNSPEC);
		  ((((approx_bglt) CREF(new1440_3024))->type_locked__184) = ((bool_t) arg2069_2144), BUNSPEC);
		  ((((approx_bglt) CREF(new1440_3024))->allocs) = ((obj_t) allocs_2142), BUNSPEC);
		  ((((approx_bglt) CREF(new1440_3024))->top__138) = ((bool_t) ((bool_t) 0)), BUNSPEC);
		  ((((approx_bglt) CREF(new1440_3024))->lost_stamp_114) = ((long) ((long) -1)), BUNSPEC);
		  res2366_3033 = new1440_3024;
	       }
	       return res2366_3033;
	    }
	 }
      }
   }
}



/* _make-type-approx */
obj_t 
_make_type_approx_211_cfa_approx(obj_t env_3502, obj_t type_3503)
{
   AN_OBJECT;
   {	/* Cfa/approx.scm 124 */
      {		/* Cfa/approx.scm 124 */
	 approx_bglt aux_3669;
	 aux_3669 =
	    make_type_approx_184_cfa_approx(
	    (type_bglt) (type_3503));
	 return
	    (obj_t) (aux_3669);
      }
   }
}



/* make-alloc-approx */
approx_bglt 
make_alloc_approx_89_cfa_approx(app_bglt alloc_10)
{
   AN_OBJECT;
   {	/* Cfa/approx.scm 134 */
      {		/* Cfa/approx.scm 135 */
	 obj_t allocs_2148;
	 allocs_2148 =
	    make_set__25_cfa_set(_alloc_set__27_cfa_approx);
	 set_extend__187_cfa_set(allocs_2148,
	    (obj_t) (alloc_10));
	 {	/* Cfa/approx.scm 137 */
	    obj_t arg2073_2149;
	    arg2073_2149 = type_type_type;
	    {	/* Cfa/approx.scm 137 */
	       approx_bglt res2367_3048;
	       {	/* Cfa/approx.scm 137 */
		  type_bglt type_3034;
		  type_3034 =
		     (type_bglt) (arg2073_2149);
		  {	/* ./Cfa/cinfo.scm 1019 */
		     approx_bglt new1440_3039;
		     new1440_3039 =
			((approx_bglt) BREF(GC_MALLOC(sizeof(struct approx))));
		     {	/* ./Cfa/cinfo.scm 1019 */
			long arg2253_3040;
			arg2253_3040 =
			   class_num_218___object(approx_cfa_info);
			{	/* ./Cfa/cinfo.scm 1019 */
			   obj_t obj_3046;
			   obj_3046 =
			      (obj_t) (new1440_3039);
			   (((obj_t) CREF(obj_3046))->header = MAKE_HEADER(arg2253_3040, 0), BUNSPEC);
			}
		     }
		     {	/* ./Cfa/cinfo.scm 1019 */
			object_bglt aux_3681;
			aux_3681 =
			   (object_bglt) (new1440_3039);
			OBJECT_WIDENING_SET(aux_3681, BFALSE);
		     }
		     ((((approx_bglt) CREF(new1440_3039))->type) = ((type_bglt) type_3034), BUNSPEC);
		     ((((approx_bglt) CREF(new1440_3039))->type_locked__184) = ((bool_t) ((bool_t) 0)), BUNSPEC);
		     ((((approx_bglt) CREF(new1440_3039))->allocs) = ((obj_t) allocs_2148), BUNSPEC);
		     ((((approx_bglt) CREF(new1440_3039))->top__138) = ((bool_t) ((bool_t) 0)), BUNSPEC);
		     ((((approx_bglt) CREF(new1440_3039))->lost_stamp_114) = ((long) ((long) -1)), BUNSPEC);
		     res2367_3048 = new1440_3039;
		  }
	       }
	       return res2367_3048;
	    }
	 }
      }
   }
}



/* _make-alloc-approx */
obj_t 
_make_alloc_approx_59_cfa_approx(obj_t env_3504, obj_t alloc_3505)
{
   AN_OBJECT;
   {	/* Cfa/approx.scm 134 */
      {		/* Cfa/approx.scm 134 */
	 approx_bglt aux_3689;
	 aux_3689 =
	    make_alloc_approx_89_cfa_approx(
	    (app_bglt) (alloc_3505));
	 return
	    (obj_t) (aux_3689);
      }
   }
}



/* make-type-alloc-approx */
approx_bglt 
make_type_alloc_approx_134_cfa_approx(type_bglt type_11, node_bglt alloc_12)
{
   AN_OBJECT;
   {	/* Cfa/approx.scm 144 */
      {		/* Cfa/approx.scm 145 */
	 obj_t allocs_2152;
	 allocs_2152 =
	    make_set__25_cfa_set(_alloc_set__27_cfa_approx);
	 set_extend__187_cfa_set(allocs_2152,
	    (obj_t) (alloc_12));
	 {	/* Cfa/approx.scm 147 */
	    bool_t arg2078_2154;
	    {	/* Cfa/approx.scm 148 */
	       bool_t test2081_2157;
	       {	/* Cfa/approx.scm 148 */
		  obj_t obj2_3050;
		  obj2_3050 = ____74_type_cache;
		  {	/* ./Ieee/equiv.scm 5508 */
		     obj_t aux_3696;
		     aux_3696 =
			(obj_t) (type_11);
		     test2081_2157 =
			(aux_3696 == obj2_3050);
		  }
	       }
	       if (test2081_2157)
		 {	/* Cfa/approx.scm 148 */
		    arg2078_2154 = ((bool_t) 0);
		 }
	       else
		 {	/* Cfa/approx.scm 148 */
		    arg2078_2154 = ((bool_t) 1);
		 }
	    }
	    {	/* Cfa/approx.scm 147 */
	       approx_bglt res2368_3065;
	       {	/* ./Cfa/cinfo.scm 1019 */
		  approx_bglt new1440_3056;
		  new1440_3056 =
		     ((approx_bglt) BREF(GC_MALLOC(sizeof(struct approx))));
		  {	/* ./Cfa/cinfo.scm 1019 */
		     long arg2253_3057;
		     arg2253_3057 =
			class_num_218___object(approx_cfa_info);
		     {	/* ./Cfa/cinfo.scm 1019 */
			obj_t obj_3063;
			obj_3063 =
			   (obj_t) (new1440_3056);
			(((obj_t) CREF(obj_3063))->header = MAKE_HEADER(arg2253_3057, 0), BUNSPEC);
		     }
		  }
		  {	/* ./Cfa/cinfo.scm 1019 */
		     object_bglt aux_3704;
		     aux_3704 =
			(object_bglt) (new1440_3056);
		     OBJECT_WIDENING_SET(aux_3704, BFALSE);
		  }
		  ((((approx_bglt) CREF(new1440_3056))->type) = ((type_bglt) type_11), BUNSPEC);
		  ((((approx_bglt) CREF(new1440_3056))->type_locked__184) = ((bool_t) arg2078_2154), BUNSPEC);
		  ((((approx_bglt) CREF(new1440_3056))->allocs) = ((obj_t) allocs_2152), BUNSPEC);
		  ((((approx_bglt) CREF(new1440_3056))->top__138) = ((bool_t) ((bool_t) 0)), BUNSPEC);
		  ((((approx_bglt) CREF(new1440_3056))->lost_stamp_114) = ((long) ((long) -1)), BUNSPEC);
		  res2368_3065 = new1440_3056;
	       }
	       return res2368_3065;
	    }
	 }
      }
   }
}



/* _make-type-alloc-approx */
obj_t 
_make_type_alloc_approx_37_cfa_approx(obj_t env_3506, obj_t type_3507, obj_t alloc_3508)
{
   AN_OBJECT;
   {	/* Cfa/approx.scm 144 */
      {		/* Cfa/approx.scm 144 */
	 approx_bglt aux_3712;
	 aux_3712 =
	    make_type_alloc_approx_134_cfa_approx(
	    (type_bglt) (type_3507),
	    (node_bglt) (alloc_3508));
	 return
	    (obj_t) (aux_3712);
      }
   }
}



/* for-each-approx-alloc */
obj_t 
for_each_approx_alloc_83_cfa_approx(obj_t proc_14, approx_bglt approx_15)
{
   AN_OBJECT;
   {	/* Cfa/approx.scm 174 */
      return
	 set_for_each_94_cfa_set(proc_14,
	 (((approx_bglt) CREF(approx_15))->allocs));
   }
}



/* _for-each-approx-alloc */
obj_t 
_for_each_approx_alloc_106_cfa_approx(obj_t env_3509, obj_t proc_3510, obj_t approx_3511)
{
   AN_OBJECT;
   {	/* Cfa/approx.scm 174 */
      return
	 for_each_approx_alloc_83_cfa_approx(proc_3510,
	 (approx_bglt) (approx_3511));
   }
}



/* method-init */
obj_t 
method_init_76_cfa_approx()
{
   AN_OBJECT;
   {	/* Cfa/approx.scm 14 */
      {		/* Cfa/approx.scm 14 */
	 obj_t shape_approx2038_154_3512;
	 shape_approx2038_154_3512 = proc2372_cfa_approx;
	 add_method__1___object(shape_env_98_tools_shape, approx_cfa_info, shape_approx2038_154_3512);
      }
      add_generic__110___object(get_node_atom_value_env_18_cfa_approx, get_node_atom_value_default2039_env_31_cfa_approx);
      add_inlined_method__244___object(get_node_atom_value_env_18_cfa_approx, atom_ast_node, ((long) 0));
      {		/* Cfa/approx.scm 14 */
	 long aux_3724;
	 aux_3724 =
	    add_inlined_method__244___object(get_node_atom_value_env_18_cfa_approx, var_ast_node, ((long) 1));
	 return
	    BINT(aux_3724);
      }
   }
}



/* shape-approx2038 */
obj_t 
shape_approx2038_154_cfa_approx(obj_t env_3513, obj_t exp_3514)
{
   AN_OBJECT;
   {	/* Cfa/approx.scm 155 */
      {
	 approx_bglt exp_2914;
	 exp_2914 =
	    (approx_bglt) (exp_3514);
	 {	/* Cfa/approx.scm 157 */
	    obj_t type_id_229_2918;
	    {	/* Cfa/approx.scm 157 */
	       obj_t list2339_2938;
	       {	/* Cfa/approx.scm 157 */
		  obj_t arg2340_2939;
		  {	/* Cfa/approx.scm 157 */
		     obj_t aux_3727;
		     {	/* Cfa/approx.scm 157 */
			type_bglt arg2341_2940;
			arg2341_2940 =
			   (((approx_bglt) CREF(exp_2914))->type);
			aux_3727 =
			   (((type_bglt) CREF(arg2341_2940))->id);
		     }
		     arg2340_2939 =
			MAKE_PAIR(aux_3727, BNIL);
		  }
		  list2339_2938 =
		     MAKE_PAIR(_4dots_199_tools_misc, arg2340_2939);
	       }
	       type_id_229_2918 =
		  symbol_append_197___r4_symbols_6_4(list2339_2938);
	    }
	    {	/* Cfa/approx.scm 158 */
	       obj_t keys_2919;
	       keys_2919 =
		  set__vector_66_cfa_set(
		  (((approx_bglt) CREF(exp_2914))->allocs));
	       {	/* Cfa/approx.scm 158 */
		  long len_2920;
		  len_2920 =
		     VECTOR_LENGTH(keys_2919);
		  {	/* Cfa/approx.scm 160 */
		     obj_t struct_2922;
		     {	/* ./Llib/struct.scm 1415 */
			long aux_3736;
			if (
			   (((approx_bglt) CREF(exp_2914))->top__138))
			  {	/* Cfa/approx.scm 160 */
			     aux_3736 =
				(len_2920 + ((long) 1))
				;
			  }
			else
			  {	/* Cfa/approx.scm 160 */
			     aux_3736 = len_2920
				;
			  }
			struct_2922 =
			   make_struct(type_id_229_2918, aux_3736, BUNSPEC);
		     }
		     {	/* Cfa/approx.scm 161 */

			if (
			   (((approx_bglt) CREF(exp_2914))->top__138))
			  {	/* ./Llib/struct.scm 1463 */
			     obj_t aux_3743;
			     aux_3743 =
				CNST_TABLE_REF(((long) 0));
			     STRUCT_SET(struct_2922, ((long) 0), aux_3743);
			  }
			else
			  {	/* Cfa/approx.scm 162 */
			     BUNSPEC;
			  }
			{
			   long r_2924;
			   long w_2925;
			   if (
			      (((approx_bglt) CREF(exp_2914))->top__138))
			     {	/* Cfa/approx.scm 163 */
				r_2924 = ((long) 1);
			     }
			   else
			     {	/* Cfa/approx.scm 163 */
				r_2924 = ((long) 0);
			     }
			   w_2925 = ((long) 0);
			 loop_2926:
			   if (
			      (w_2925 == len_2920))
			     {	/* Cfa/approx.scm 165 */
				return struct_2922;
			     }
			   else
			     {	/* Cfa/approx.scm 165 */
				{	/* ./Llib/struct.scm 1463 */
				   obj_t aux_3748;
				   {	/* Cfa/approx.scm 168 */
				      node_effect_213_bglt node_3444;
				      {		/* Cfa/approx.scm 168 */
					 obj_t aux_3749;
					 aux_3749 =
					    VECTOR_REF(keys_2919, w_2925);
					 node_3444 =
					    (node_effect_213_bglt) (aux_3749);
				      }
				      aux_3748 =
					 (((node_effect_213_bglt) CREF(node_3444))->key);
				   }
				   STRUCT_SET(struct_2922, r_2924, aux_3748);
				}
				{
				   long w_3756;
				   long r_3754;
				   r_3754 =
				      (r_2924 + ((long) 1));
				   w_3756 =
				      (w_2925 + ((long) 1));
				   w_2925 = w_3756;
				   r_2924 = r_3754;
				   goto loop_2926;
				}
			     }
			}
		     }
		  }
	       }
	    }
	 }
      }
   }
}



/* get-node-atom-value */
obj_t 
get_node_atom_value_135_cfa_approx(node_bglt node_16)
{
   AN_OBJECT;
   {	/* Cfa/approx.scm 183 */
    get_node_atom_value_135_cfa_approx:
      {
	 obj_t method2344_2947;
	 obj_t class2349_2948;
	 {	/* Cfa/approx.scm 183 */
	    obj_t arg2352_2945;
	    obj_t arg2353_2946;
	    {	/* Cfa/approx.scm 183 */
	       object_bglt obj_3453;
	       obj_3453 =
		  (object_bglt) (node_16);
	       {	/* ./Llib/object.scm 2926 */
		  obj_t pre_method_105_3454;
		  pre_method_105_3454 =
		     PROCEDURE_REF(get_node_atom_value_env_18_cfa_approx, ((long) 2));
		  if (
		     INTEGERP(pre_method_105_3454))
		    {	/* ./Llib/object.scm 2927 */
		       PROCEDURE_SET(get_node_atom_value_env_18_cfa_approx, ((long) 2), BUNSPEC);
		       arg2352_2945 = pre_method_105_3454;
		    }
		  else
		    {	/* ./Llib/object.scm 2914 */
		       long obj_class_num_177_3459;
		       obj_class_num_177_3459 =
			  TYPE(obj_3453);
		       {	/* ./Llib/object.scm 2915 */
			  obj_t arg1176_3460;
			  arg1176_3460 =
			     PROCEDURE_REF(get_node_atom_value_env_18_cfa_approx, ((long) 1));
			  {	/* ./Llib/object.scm 2738 */
			     long arg1177_3464;
			     {	/* ./Llib/object.scm 2738 */
				long arg1178_3465;
				arg1178_3465 =
				   OBJECT_TYPE;
				arg1177_3464 =
				   (obj_class_num_177_3459 - arg1178_3465);
			     }
			     arg2352_2945 =
				VECTOR_REF(arg1176_3460, arg1177_3464);
			  }
		       }
		    }
	       }
	    }
	    {	/* Cfa/approx.scm 183 */
	       object_bglt object_3470;
	       object_3470 =
		  (object_bglt) (node_16);
	       {	/* ./Llib/object.scm 2695 */
		  long arg1179_3471;
		  {	/* ./Llib/object.scm 2695 */
		     long arg1180_3472;
		     long arg1181_3473;
		     arg1180_3472 =
			TYPE(object_3470);
		     arg1181_3473 =
			OBJECT_TYPE;
		     arg1179_3471 =
			(arg1180_3472 - arg1181_3473);
		  }
		  {	/* ./Llib/object.scm 2695 */
		     obj_t vector_3477;
		     vector_3477 = _classes__134___object;
		     arg2353_2946 =
			VECTOR_REF(vector_3477, arg1179_3471);
		  }
	       }
	    }
	    method2344_2947 = arg2352_2945;
	    class2349_2948 = arg2353_2946;
	    {

	       if (
		  INTEGERP(method2344_2947))
		 {	/* Cfa/approx.scm 183 */
		    switch (
		       (long) CINT(method2344_2947))
		      {
		      case ((long) 0):

			 {	/* Cfa/approx.scm 190 */
			    atom_bglt node_2954;
			    node_2954 =
			       (atom_bglt) (node_16);
			    return
			       (((atom_bglt) CREF(node_2954))->value);
			 }
			 break;
		      case ((long) 1):

			 {	/* Cfa/approx.scm 196 */
			    var_bglt node_2955;
			    node_2955 =
			       (var_bglt) (node_16);
			    {	/* Cfa/approx.scm 196 */
			       variable_bglt v_2956;
			       v_2956 =
				  (((var_bglt) CREF(node_2955))->variable);
			       {	/* Cfa/approx.scm 197 */
				  bool_t test2356_2957;
				  {	/* Cfa/approx.scm 197 */
				     bool_t test2358_2959;
				     test2358_2959 =
					is_a__118___object(
					(obj_t) (v_2956), reshaped_local_224_cfa_info);
				     if (test2358_2959)
				       {	/* ./Ast/node.scm 845 */
					  obj_t aux_3785;
					  {	/* Cfa/approx.scm 197 */
					     reshaped_local_224_bglt obj_3482;
					     obj_3482 =
						(reshaped_local_224_bglt) (v_2956);
					     {
						obj_t aux_3787;
						{	/* ./Cfa/cinfo.scm 1060 */
						   object_bglt aux_3788;
						   aux_3788 =
						      (object_bglt) (obj_3482);
						   aux_3787 =
						      OBJECT_WIDENING(aux_3788);
						}
						aux_3785 =
						   (((reshaped_local_224_bglt) CREF(aux_3787))->binding_value_3);
					     }
					  }
					  test2356_2957 =
					     is_a__118___object(aux_3785, node_ast_node);
				       }
				     else
				       {	/* Cfa/approx.scm 197 */
					  test2356_2957 = ((bool_t) 0);
				       }
				  }
				  if (test2356_2957)
				    {
				       node_bglt node_3794;
				       {	/* Cfa/approx.scm 198 */
					  obj_t aux_3795;
					  {	/* Cfa/approx.scm 198 */
					     reshaped_local_224_bglt obj_3484;
					     obj_3484 =
						(reshaped_local_224_bglt) (v_2956);
					     {
						obj_t aux_3797;
						{	/* ./Cfa/cinfo.scm 1060 */
						   object_bglt aux_3798;
						   aux_3798 =
						      (object_bglt) (obj_3484);
						   aux_3797 =
						      OBJECT_WIDENING(aux_3798);
						}
						aux_3795 =
						   (((reshaped_local_224_bglt) CREF(aux_3797))->binding_value_3);
					     }
					  }
					  node_3794 =
					     (node_bglt) (aux_3795);
				       }
				       node_16 = node_3794;
				       goto get_node_atom_value_135_cfa_approx;
				    }
				  else
				    {	/* Cfa/approx.scm 197 */
				       return
					  CNST_TABLE_REF(((long) 1));
				    }
			       }
			    }
			 }
			 break;
		      default:
		       case_else2350_2951:
			 if (
			    PROCEDUREP(method2344_2947))
			   {	/* Cfa/approx.scm 183 */
			      return
				 PROCEDURE_ENTRY(method2344_2947) (method2344_2947,
				 (obj_t) (node_16), BEOA);
			   }
			 else
			   {	/* Cfa/approx.scm 183 */
			      obj_t fun2343_2943;
			      fun2343_2943 =
				 PROCEDURE_REF(get_node_atom_value_env_18_cfa_approx, ((long) 0));
			      return
				 PROCEDURE_ENTRY(fun2343_2943) (fun2343_2943,
				 (obj_t) (node_16), BEOA);
			   }
		      }
		 }
	       else
		 {	/* Cfa/approx.scm 183 */
		    goto case_else2350_2951;
		 }
	    }
	 }
      }
   }
}



/* _get-node-atom-value2371 */
obj_t 
_get_node_atom_value2371_28_cfa_approx(obj_t env_3517, obj_t node_3518)
{
   AN_OBJECT;
   {	/* Cfa/approx.scm 183 */
      return
	 get_node_atom_value_135_cfa_approx(
	 (node_bglt) (node_3518));
   }
}



/* get-node-atom-value-default2039 */
obj_t 
get_node_atom_value_default2039_253_cfa_approx(node_bglt node_17)
{
   AN_OBJECT;
   {	/* Cfa/approx.scm 14 */
      return
	 CNST_TABLE_REF(((long) 1));
   }
}



/* _get-node-atom-value-default2039 */
obj_t 
_get_node_atom_value_default2039_96_cfa_approx(obj_t env_3519, obj_t node_3520)
{
   AN_OBJECT;
   {	/* Cfa/approx.scm 14 */
      return
	 get_node_atom_value_default2039_253_cfa_approx(
	 (node_bglt) (node_3520));
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_cfa_approx()
{
   AN_OBJECT;
   {	/* Cfa/approx.scm 14 */
      module_initialization_70_type_type(((long) 0), "CFA_APPROX");
      module_initialization_70_type_cache(((long) 0), "CFA_APPROX");
      module_initialization_70_tools_shape(((long) 0), "CFA_APPROX");
      module_initialization_70_tools_error(((long) 0), "CFA_APPROX");
      module_initialization_70_tools_misc(((long) 0), "CFA_APPROX");
      module_initialization_70_ast_var(((long) 0), "CFA_APPROX");
      module_initialization_70_ast_node(((long) 0), "CFA_APPROX");
      module_initialization_70_cfa_info(((long) 0), "CFA_APPROX");
      module_initialization_70_cfa_info2(((long) 0), "CFA_APPROX");
      module_initialization_70_cfa_collect(((long) 0), "CFA_APPROX");
      module_initialization_70_cfa_set(((long) 0), "CFA_APPROX");
      module_initialization_70_cfa_iterate(((long) 0), "CFA_APPROX");
      module_initialization_70_cfa_loose(((long) 0), "CFA_APPROX");
      return
	 module_initialization_70_cfa_procedure(((long) 0), "CFA_APPROX");
   }
}
