/*===========================================================================*/
/*   (Cfa/box.scm)                                                           */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;

typedef struct approx
  {
     header_t header;
     obj_t widening;
     struct type *type;
     bool_t type_locked__184;
     obj_t allocs;
     bool_t top__138;
     long lost_stamp_114;
  }
      *approx_bglt;

typedef struct cfun_cinfo_200
  {
     struct approx *approx;
  }
              *cfun_cinfo_200_bglt;

typedef struct extern_sfun_cinfo_6
  {
     struct approx *approx;
  }
                   *extern_sfun_cinfo_6_bglt;

typedef struct intern_sfun_cinfo_192
  {
     struct approx *approx;
     long stamp;
  }
                     *intern_sfun_cinfo_192_bglt;

typedef struct scnst_cinfo_0
  {
     struct approx *approx;
  }
             *scnst_cinfo_0_bglt;

typedef struct pre_clo_env_191
  {
     char dummy;
  }
               *pre_clo_env_191_bglt;

typedef struct svar_cinfo_166
  {
     struct approx *approx;
     bool_t clo_env__87;
  }
              *svar_cinfo_166_bglt;

typedef struct cvar_cinfo_53
  {
     struct approx *approx;
  }
             *cvar_cinfo_53_bglt;

typedef struct sexit_cinfo_49
  {
     struct approx *approx;
  }
              *sexit_cinfo_49_bglt;

typedef struct reshaped_local_224
  {
     obj_t binding_value_3;
  }
                  *reshaped_local_224_bglt;

typedef struct reshaped_global_160
  {
     char dummy;
  }
                   *reshaped_global_160_bglt;

typedef struct atom_cinfo_155
  {
     struct approx *approx;
  }
              *atom_cinfo_155_bglt;

typedef struct kwote_node_102
  {
     struct node *node;
  }
              *kwote_node_102_bglt;

typedef struct kwote_cinfo_48
  {
     struct approx *approx;
  }
              *kwote_cinfo_48_bglt;

typedef struct app_ly_cinfo_234
  {
     struct approx *approx;
  }
                *app_ly_cinfo_234_bglt;

typedef struct funcall_cinfo_75
  {
     struct approx *approx;
     struct approx *va_approx_63;
     bool_t arity_error_noticed__118;
     bool_t type_error_noticed__36;
  }
                *funcall_cinfo_75_bglt;

typedef struct pragma_cinfo_220
  {
     struct approx *approx;
  }
                *pragma_cinfo_220_bglt;

typedef struct setq_cinfo_191
  {
     struct approx *approx;
  }
              *setq_cinfo_191_bglt;

typedef struct conditional_cinfo_212
  {
     struct approx *approx;
  }
                     *conditional_cinfo_212_bglt;

typedef struct fail_cinfo_75
  {
     struct approx *approx;
  }
             *fail_cinfo_75_bglt;

typedef struct select_cinfo_150
  {
     struct approx *approx;
  }
                *select_cinfo_150_bglt;

typedef struct set_ex_it_cinfo_168
  {
     struct approx *approx;
  }
                   *set_ex_it_cinfo_168_bglt;

typedef struct jump_ex_it_cinfo_139
  {
     struct approx *approx;
  }
                    *jump_ex_it_cinfo_139_bglt;

typedef struct pre_make_box_186
  {
     char dummy;
  }
                *pre_make_box_186_bglt;

typedef struct make_box_cinfo_127
  {
     struct approx *approx;
  }
                  *make_box_cinfo_127_bglt;

typedef struct make_box_o_cinfo_96
  {
     struct approx *approx;
     struct approx *value_approx_19;
  }
                   *make_box_o_cinfo_96_bglt;

typedef struct box_set__cinfo_94
  {
     struct approx *approx;
  }
                 *box_set__cinfo_94_bglt;

typedef struct box_ref_cinfo_214
  {
     struct approx *approx;
  }
                 *box_ref_cinfo_214_bglt;

typedef struct box_set__o_cinfo_6
  {
     struct approx *approx;
  }
                  *box_set__o_cinfo_6_bglt;

typedef struct box_ref_o_cinfo_98
  {
     struct approx *approx;
  }
                  *box_ref_o_cinfo_98_bglt;

typedef struct pre_make_procedure_app_60
  {
     struct variable *owner;
  }
                         *pre_make_procedure_app_60_bglt;

typedef struct pre_procedure_ref_app_85
  {
     char dummy;
  }
                        *pre_procedure_ref_app_85_bglt;

typedef struct pre_procedure_set__app_208
  {
     char dummy;
  }
                          *pre_procedure_set__app_208_bglt;

typedef struct make_procedure_app_48
  {
     struct approx *approx;
     long values_approx_len_106;
     struct approx **values_approx_79;
     long lost_stamp_114;
     bool_t x_t__142;
     bool_t x;
     bool_t t;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
  }
                     *make_procedure_app_48_bglt;

typedef struct procedure_ref_app_49
  {
     struct approx *approx;
  }
                    *procedure_ref_app_49_bglt;

typedef struct procedure_set__app_32
  {
     struct approx *approx;
  }
                     *procedure_set__app_32_bglt;

typedef struct pre_make_vector_app_251
  {
     struct variable *owner;
  }
                       *pre_make_vector_app_251_bglt;

typedef struct pre_create_vector_app_162
  {
     struct variable *owner;
  }
                         *pre_create_vector_app_162_bglt;

typedef struct pre_vector_ref_app_208
  {
     char dummy;
  }
                      *pre_vector_ref_app_208_bglt;

typedef struct pre_vector_set__app_211
  {
     char dummy;
  }
                       *pre_vector_set__app_211_bglt;

typedef struct make_vector_app_205
  {
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
     bool_t seen__39;
  }
                   *make_vector_app_205_bglt;

typedef struct create_vector_app_150
  {
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
     bool_t seen__39;
  }
                     *create_vector_app_150_bglt;

typedef struct vector_ref_app_195
  {
     struct approx *approx;
  }
                  *vector_ref_app_195_bglt;

typedef struct vector_set__app_21
  {
     struct approx *approx;
  }
                  *vector_set__app_21_bglt;

typedef struct pre_make_struct_app_218
  {
     struct variable *owner;
  }
                       *pre_make_struct_app_218_bglt;

typedef struct pre_struct_ref_app_207
  {
     char dummy;
  }
                      *pre_struct_ref_app_207_bglt;

typedef struct pre_struct_set__app_116
  {
     char dummy;
  }
                       *pre_struct_set__app_116_bglt;

typedef struct make_struct_app_214
  {
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
  }
                   *make_struct_app_214_bglt;

typedef struct struct_ref_app_73
  {
     struct approx *approx;
  }
                 *struct_ref_app_73_bglt;

typedef struct struct_set__app_162
  {
     struct approx *approx;
  }
                   *struct_set__app_162_bglt;


static obj_t method_init_76_cfa_box();
extern obj_t make_box_202_ast_node;
extern obj_t _optim__89_engine_param;
static obj_t cfa__make_box_o_cinfo2056_25_cfa_box(obj_t, obj_t);
extern obj_t box_set__cinfo_94_cfa_info;
extern obj_t make_box_cinfo_127_cfa_info;
extern obj_t box_ref_242_ast_node;
static obj_t node_setup__make_box2048_85_cfa_box(obj_t, obj_t);
extern obj_t add_method__1___object(obj_t, obj_t, obj_t);
extern obj_t _obj__252_type_cache;
extern obj_t box_ref_o_cinfo_98_cfa_info;
extern approx_bglt make_type_approx_184_cfa_approx(type_bglt);
extern approx_bglt make_empty_approx_131_cfa_approx();
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t _unspec__87_type_cache;
extern obj_t module_initialization_70_cfa_box(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_cfa_info(long, char *);
extern obj_t module_initialization_70_cfa_info2(long, char *);
extern obj_t module_initialization_70_cfa_loose(long, char *);
extern obj_t module_initialization_70_cfa_setup(long, char *);
extern obj_t module_initialization_70_cfa_approx(long, char *);
extern obj_t module_initialization_70_cfa_cfa(long, char *);
extern obj_t module_initialization_70_cfa_iterate(long, char *);
extern obj_t module_initialization_70_cfa_closure(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t make_box_o_cinfo_96_cfa_info;
extern approx_bglt union_approx__241_cfa_approx(approx_bglt, approx_bglt);
static obj_t loose_alloc__make_box2062_82_cfa_box(obj_t, obj_t);
extern obj_t pre_make_box_186_cfa_info;
extern long class_num_218___object(obj_t);
static obj_t imported_modules_init_94_cfa_box();
static obj_t cfa__box_ref_o_cinfo2058_58_cfa_box(obj_t, obj_t);
extern obj_t node_setup__189_cfa_setup(node_bglt);
extern obj_t approx_set_top__187_cfa_approx(approx_bglt);
static obj_t node_setup__box_ref2054_140_cfa_box(obj_t, obj_t);
extern obj_t box_set__o_cinfo_6_cfa_info;
static obj_t library_modules_init_112_cfa_box();
extern approx_bglt cfa__102_cfa_cfa(node_bglt);
extern obj_t for_each_approx_alloc_83_cfa_approx(obj_t, approx_bglt);
static obj_t toplevel_init_63_cfa_box();
extern obj_t open_input_string(obj_t);
extern obj_t box_set__221_ast_node;
extern obj_t box_ref_cinfo_214_cfa_info;
extern obj_t shape_tools_shape(obj_t);
extern obj_t internal_error_43_tools_error(obj_t, obj_t, obj_t);
extern obj_t _classes__134___object;
extern obj_t read___reader(obj_t);
static obj_t node_setup__pre_make_box2050_241_cfa_box(obj_t, obj_t);
static obj_t stack_loose_alloc__make_box2064_58_cfa_box(obj_t, obj_t, obj_t);
static obj_t cfa__box_set__o_cinfo2060_40_cfa_box(obj_t, obj_t);
static obj_t require_initialization_114_cfa_box = BUNSPEC;
extern approx_bglt make_type_alloc_approx_134_cfa_approx(type_bglt, node_bglt);
extern approx_bglt loose__226_cfa_loose(approx_bglt, obj_t);
static obj_t _anonymous_2362__161_cfa_box(obj_t, obj_t);
extern obj_t class_super_145___object(obj_t);
static obj_t _anonymous_2350__51_cfa_box(obj_t, obj_t);
static obj_t node_setup__box_set_2052_31_cfa_box(obj_t, obj_t);
static obj_t cnst_init_137_cfa_box();
static obj_t __cnst[1];

extern obj_t loose_alloc__env_83_cfa_loose;
DEFINE_STATIC_PROCEDURE(proc2393_cfa_box, stack_loose_alloc__make_box2064_58_cfa_box2401, stack_loose_alloc__make_box2064_58_cfa_box, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2392_cfa_box, loose_alloc__make_box2062_82_cfa_box2402, loose_alloc__make_box2062_82_cfa_box, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2391_cfa_box, cfa__box_set__o_cinfo2060_40_cfa_box2403, cfa__box_set__o_cinfo2060_40_cfa_box, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2389_cfa_box, cfa__make_box_o_cinfo2056_25_cfa_box2404, cfa__make_box_o_cinfo2056_25_cfa_box, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2390_cfa_box, cfa__box_ref_o_cinfo2058_58_cfa_box2405, cfa__box_ref_o_cinfo2058_58_cfa_box, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2388_cfa_box, node_setup__box_ref2054_140_cfa_box2406, node_setup__box_ref2054_140_cfa_box, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2387_cfa_box, node_setup__box_set_2052_31_cfa_box2407, node_setup__box_set_2052_31_cfa_box, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2386_cfa_box, node_setup__pre_make_box2050_241_cfa_box2408, node_setup__pre_make_box2050_241_cfa_box, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2385_cfa_box, node_setup__make_box2048_85_cfa_box2409, node_setup__make_box2048_85_cfa_box, 0L, 1);
extern obj_t cfa__env_153_cfa_cfa;
extern obj_t stack_loose_alloc__env_147_cfa_loose;
DEFINE_STRING(string2396_cfa_box, string2396_cfa_box2410, "ALL ", 4);
DEFINE_STRING(string2395_cfa_box, string2395_cfa_box2411, "Illegal mixed of optimized and unoptimize `make-box'", 52);
DEFINE_STRING(string2394_cfa_box, string2394_cfa_box2412, "box-ref", 7);
extern obj_t node_setup__env_214_cfa_setup;



/* module-initialization */
obj_t 
module_initialization_70_cfa_box(long checksum_3471, char *from_3472)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_cfa_box))
	{
	   require_initialization_114_cfa_box =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_cfa_box();
	   cnst_init_137_cfa_box();
	   imported_modules_init_94_cfa_box();
	   method_init_76_cfa_box();
	   toplevel_init_63_cfa_box();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_cfa_box()
{
   AN_OBJECT;
   {	/* Cfa/box.scm 14 */
      module_initialization_70___object(((long) 0), "CFA_BOX");
      module_initialization_70___reader(((long) 0), "CFA_BOX");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_cfa_box()
{
   AN_OBJECT;
   {	/* Cfa/box.scm 14 */
      {		/* Cfa/box.scm 14 */
	 obj_t cnst_port_138_3464;
	 cnst_port_138_3464 =
	    open_input_string(string2396_cfa_box);
	 {
	    long i_3465;
	    i_3465 = ((long) 0);
	  loop_3466:
	    {	/* Cfa/box.scm 14 */
	       bool_t test2397_3467;
	       test2397_3467 =
		  (i_3465 == ((long) -1));
	       if (test2397_3467)
		 {	/* Cfa/box.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Cfa/box.scm 14 */
		    {	/* Cfa/box.scm 14 */
		       obj_t arg2398_3468;
		       {	/* Cfa/box.scm 14 */
			  obj_t list2399_3469;
			  list2399_3469 =
			     MAKE_PAIR(cnst_port_138_3464, BNIL);
			  arg2398_3468 =
			     read___reader(list2399_3469);
		       }
		       CNST_TABLE_SET(i_3465, arg2398_3468);
		    }
		    {	/* Cfa/box.scm 14 */
		       int aux_3470;
		       {	/* Cfa/box.scm 14 */
			  long aux_3489;
			  aux_3489 =
			     (i_3465 - ((long) 1));
			  aux_3470 =
			     (int) (aux_3489);
		       }
		       {
			  long i_3492;
			  i_3492 =
			     (long) (aux_3470);
			  i_3465 = i_3492;
			  goto loop_3466;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_cfa_box()
{
   AN_OBJECT;
   {	/* Cfa/box.scm 14 */
      return BUNSPEC;
   }
}



/* method-init */
obj_t 
method_init_76_cfa_box()
{
   AN_OBJECT;
   {	/* Cfa/box.scm 14 */
      {		/* Cfa/box.scm 14 */
	 obj_t node_setup__make_box2048_85_3427;
	 node_setup__make_box2048_85_3427 = proc2385_cfa_box;
	 add_method__1___object(node_setup__env_214_cfa_setup, make_box_202_ast_node, node_setup__make_box2048_85_3427);
      }
      {		/* Cfa/box.scm 14 */
	 obj_t node_setup__pre_make_box2050_241_3426;
	 node_setup__pre_make_box2050_241_3426 = proc2386_cfa_box;
	 add_method__1___object(node_setup__env_214_cfa_setup, pre_make_box_186_cfa_info, node_setup__pre_make_box2050_241_3426);
      }
      {		/* Cfa/box.scm 14 */
	 obj_t node_setup__box_set_2052_31_3425;
	 node_setup__box_set_2052_31_3425 = proc2387_cfa_box;
	 add_method__1___object(node_setup__env_214_cfa_setup, box_set__221_ast_node, node_setup__box_set_2052_31_3425);
      }
      {		/* Cfa/box.scm 14 */
	 obj_t node_setup__box_ref2054_140_3424;
	 node_setup__box_ref2054_140_3424 = proc2388_cfa_box;
	 add_method__1___object(node_setup__env_214_cfa_setup, box_ref_242_ast_node, node_setup__box_ref2054_140_3424);
      }
      {		/* Cfa/box.scm 14 */
	 obj_t cfa__make_box_o_cinfo2056_25_3423;
	 cfa__make_box_o_cinfo2056_25_3423 = proc2389_cfa_box;
	 add_method__1___object(cfa__env_153_cfa_cfa, make_box_o_cinfo_96_cfa_info, cfa__make_box_o_cinfo2056_25_3423);
      }
      {		/* Cfa/box.scm 14 */
	 obj_t cfa__box_ref_o_cinfo2058_58_3422;
	 cfa__box_ref_o_cinfo2058_58_3422 = proc2390_cfa_box;
	 add_method__1___object(cfa__env_153_cfa_cfa, box_ref_o_cinfo_98_cfa_info, cfa__box_ref_o_cinfo2058_58_3422);
      }
      {		/* Cfa/box.scm 14 */
	 obj_t cfa__box_set__o_cinfo2060_40_3420;
	 cfa__box_set__o_cinfo2060_40_3420 = proc2391_cfa_box;
	 add_method__1___object(cfa__env_153_cfa_cfa, box_set__o_cinfo_6_cfa_info, cfa__box_set__o_cinfo2060_40_3420);
      }
      {		/* Cfa/box.scm 14 */
	 obj_t loose_alloc__make_box2062_82_3418;
	 loose_alloc__make_box2062_82_3418 = proc2392_cfa_box;
	 add_method__1___object(loose_alloc__env_83_cfa_loose, make_box_202_ast_node, loose_alloc__make_box2062_82_3418);
      }
      {		/* Cfa/box.scm 14 */
	 obj_t stack_loose_alloc__make_box2064_58_3417;
	 stack_loose_alloc__make_box2064_58_3417 = proc2393_cfa_box;
	 return
	    add_method__1___object(stack_loose_alloc__env_147_cfa_loose, make_box_202_ast_node, stack_loose_alloc__make_box2064_58_3417);
      }
   }
}



/* stack-loose-alloc!-make-box2064 */
obj_t 
stack_loose_alloc__make_box2064_58_cfa_box(obj_t env_3428, obj_t alloc_3429, obj_t cowner_3430)
{
   AN_OBJECT;
   {	/* Cfa/box.scm 150 */
      {
	 make_box_202_bglt alloc_2986;
	 obj_t cowner_2987;
	 alloc_2986 =
	    (make_box_202_bglt) (alloc_3429);
	 cowner_2987 = cowner_3430;
	 return BUNSPEC;
      }
   }
}



/* loose-alloc!-make-box2062 */
obj_t 
loose_alloc__make_box2062_82_cfa_box(obj_t env_3431, obj_t alloc_3432)
{
   AN_OBJECT;
   {	/* Cfa/box.scm 144 */
      {
	 make_box_202_bglt alloc_2981;
	 alloc_2981 =
	    (make_box_202_bglt) (alloc_3432);
	 return BUNSPEC;
      }
   }
}



/* cfa!-box-set!/o-cinfo2060 */
obj_t 
cfa__box_set__o_cinfo2060_40_cfa_box(obj_t env_3433, obj_t node_3434)
{
   AN_OBJECT;
   {	/* Cfa/box.scm 116 */
      {
	 box_set__o_cinfo_6_bglt node_2959;
	 {	/* Cfa/box.scm 117 */
	    approx_bglt aux_3505;
	    node_2959 =
	       (box_set__o_cinfo_6_bglt) (node_3434);
	    {	/* Cfa/box.scm 118 */
	       approx_bglt box_approx_152_2963;
	       approx_bglt val_approx_22_2964;
	       {	/* Cfa/box.scm 118 */
		  node_bglt aux_3506;
		  {	/* Cfa/box.scm 118 */
		     var_bglt aux_3507;
		     {	/* Cfa/box.scm 118 */
			box_set__221_bglt obj_3410;
			obj_3410 =
			   (box_set__221_bglt) (node_2959);
			aux_3507 =
			   (((box_set__221_bglt) CREF(obj_3410))->var);
		     }
		     aux_3506 =
			(node_bglt) (aux_3507);
		  }
		  box_approx_152_2963 =
		     cfa__102_cfa_cfa(aux_3506);
	       }
	       {	/* Cfa/box.scm 119 */
		  node_bglt aux_3512;
		  {	/* Cfa/box.scm 119 */
		     box_set__221_bglt obj_3411;
		     obj_3411 =
			(box_set__221_bglt) (node_2959);
		     aux_3512 =
			(((box_set__221_bglt) CREF(obj_3411))->value);
		  }
		  val_approx_22_2964 =
		     cfa__102_cfa_cfa(aux_3512);
	       }
	       if (
		  (((approx_bglt) CREF(box_approx_152_2963))->top__138))
		 {	/* Cfa/box.scm 123 */
		    approx_bglt aux_3518;
		    aux_3518 =
		       loose__226_cfa_loose(val_approx_22_2964,
		       CNST_TABLE_REF(((long) 0)));
		    (obj_t) (aux_3518);
		 }
	       else
		 {	/* Cfa/box.scm 127 */
		    obj_t _anonymous_2362__161_3419;
		    _anonymous_2362__161_3419 =
		       make_fx_procedure(_anonymous_2362__161_cfa_box, ((long) 1), ((long) 2));
		    {	/* Cfa/box.scm 127 */
		       obj_t aux_3523;
		       aux_3523 =
			  (obj_t) (node_2959);
		       PROCEDURE_SET(_anonymous_2362__161_3419, ((long) 0), aux_3523);
		    }
		    {	/* Cfa/box.scm 127 */
		       obj_t aux_3526;
		       aux_3526 =
			  (obj_t) (val_approx_22_2964);
		       PROCEDURE_SET(_anonymous_2362__161_3419, ((long) 1), aux_3526);
		    }
		    for_each_approx_alloc_83_cfa_approx(_anonymous_2362__161_3419, box_approx_152_2963);
		 }
	    }
	    {
	       obj_t aux_3530;
	       {	/* ./Cfa/cinfo.scm 1222 */
		  object_bglt aux_3531;
		  aux_3531 =
		     (object_bglt) (node_2959);
		  aux_3530 =
		     OBJECT_WIDENING(aux_3531);
	       }
	       aux_3505 =
		  (((box_set__o_cinfo_6_bglt) CREF(aux_3530))->approx);
	    }
	    return
	       (obj_t) (aux_3505);
	 }
      }
   }
}



/* <anonymous:2362> */
obj_t 
_anonymous_2362__161_cfa_box(obj_t env_3435, obj_t box_3438)
{
   AN_OBJECT;
   {	/* Cfa/box.scm 125 */
      {		/* Cfa/box.scm 127 */
	 obj_t node_3436;
	 obj_t val_approx_22_3437;
	 node_3436 =
	    PROCEDURE_REF(env_3435, ((long) 0));
	 val_approx_22_3437 =
	    PROCEDURE_REF(env_3435, ((long) 1));
	 {
	    obj_t box_2967;
	    box_2967 = box_3438;
	    {	/* Cfa/box.scm 127 */
	       bool_t test2363_2969;
	       test2363_2969 =
		  is_a__118___object(box_2967, make_box_o_cinfo_96_cfa_info);
	       if (test2363_2969)
		 {	/* Cfa/box.scm 127 */
		    {	/* Cfa/box.scm 129 */
		       approx_bglt aux_3541;
		       {	/* Cfa/box.scm 129 */
			  approx_bglt aux_3542;
			  {	/* Cfa/box.scm 129 */
			     make_box_o_cinfo_96_bglt obj_3414;
			     obj_3414 =
				(make_box_o_cinfo_96_bglt) (box_2967);
			     {
				obj_t aux_3544;
				{	/* ./Cfa/cinfo.scm 1219 */
				   object_bglt aux_3545;
				   aux_3545 =
				      (object_bglt) (obj_3414);
				   aux_3544 =
				      OBJECT_WIDENING(aux_3545);
				}
				aux_3542 =
				   (((make_box_o_cinfo_96_bglt) CREF(aux_3544))->value_approx_19);
			     }
			  }
			  aux_3541 =
			     union_approx__241_cfa_approx(aux_3542,
			     (approx_bglt) (val_approx_22_3437));
		       }
		       return
			  (obj_t) (aux_3541);
		    }
		 }
	       else
		 {	/* Cfa/box.scm 130 */
		    bool_t test2365_2972;
		    test2365_2972 =
		       is_a__118___object(box_2967, make_box_cinfo_127_cfa_info);
		    if (test2365_2972)
		      {		/* Cfa/box.scm 130 */
			 {	/* Cfa/box.scm 131 */
			    obj_t arg2368_2975;
			    arg2368_2975 =
			       shape_tools_shape(node_3436);
			    return
			       internal_error_43_tools_error(string2394_cfa_box, string2395_cfa_box, arg2368_2975);
			 }
		      }
		    else
		      {		/* Cfa/box.scm 130 */
			 return BFALSE;
		      }
		 }
	    }
	 }
      }
   }
}



/* cfa!-box-ref/o-cinfo2058 */
obj_t 
cfa__box_ref_o_cinfo2058_58_cfa_box(obj_t env_3439, obj_t node_3440)
{
   AN_OBJECT;
   {	/* Cfa/box.scm 96 */
      {
	 box_ref_o_cinfo_98_bglt node_2939;
	 {	/* Cfa/box.scm 97 */
	    approx_bglt aux_3556;
	    node_2939 =
	       (box_ref_o_cinfo_98_bglt) (node_3440);
	    {	/* Cfa/box.scm 98 */
	       approx_bglt box_approx_152_2943;
	       {	/* Cfa/box.scm 98 */
		  node_bglt aux_3557;
		  {	/* Cfa/box.scm 98 */
		     var_bglt aux_3558;
		     {	/* Cfa/box.scm 98 */
			box_ref_242_bglt obj_3404;
			obj_3404 =
			   (box_ref_242_bglt) (node_2939);
			aux_3558 =
			   (((box_ref_242_bglt) CREF(obj_3404))->var);
		     }
		     aux_3557 =
			(node_bglt) (aux_3558);
		  }
		  box_approx_152_2943 =
		     cfa__102_cfa_cfa(aux_3557);
	       }
	       {	/* Cfa/box.scm 102 */
		  obj_t _anonymous_2350__51_3421;
		  _anonymous_2350__51_3421 =
		     make_fx_procedure(_anonymous_2350__51_cfa_box, ((long) 1), ((long) 2));
		  {	/* Cfa/box.scm 102 */
		     obj_t aux_3564;
		     aux_3564 =
			(obj_t) (node_2939);
		     PROCEDURE_SET(_anonymous_2350__51_3421, ((long) 0), aux_3564);
		  }
		  {	/* Cfa/box.scm 102 */
		     obj_t aux_3567;
		     aux_3567 =
			(obj_t) (node_2939);
		     PROCEDURE_SET(_anonymous_2350__51_3421, ((long) 1), aux_3567);
		  }
		  for_each_approx_alloc_83_cfa_approx(_anonymous_2350__51_3421, box_approx_152_2943);
	       }
	    }
	    {
	       obj_t aux_3571;
	       {	/* ./Cfa/cinfo.scm 1223 */
		  object_bglt aux_3572;
		  aux_3572 =
		     (object_bglt) (node_2939);
		  aux_3571 =
		     OBJECT_WIDENING(aux_3572);
	       }
	       aux_3556 =
		  (((box_ref_o_cinfo_98_bglt) CREF(aux_3571))->approx);
	    }
	    return
	       (obj_t) (aux_3556);
	 }
      }
   }
}



/* <anonymous:2350> */
obj_t 
_anonymous_2350__51_cfa_box(obj_t env_3441, obj_t box_3444)
{
   AN_OBJECT;
   {	/* Cfa/box.scm 100 */
      {		/* Cfa/box.scm 102 */
	 obj_t node_3442;
	 obj_t instance2043_3443;
	 node_3442 =
	    PROCEDURE_REF(env_3441, ((long) 0));
	 instance2043_3443 =
	    PROCEDURE_REF(env_3441, ((long) 1));
	 {
	    obj_t box_2945;
	    box_2945 = box_3444;
	    {	/* Cfa/box.scm 102 */
	       bool_t test2351_2947;
	       test2351_2947 =
		  is_a__118___object(box_2945, make_box_o_cinfo_96_cfa_info);
	       if (test2351_2947)
		 {	/* Cfa/box.scm 102 */
		    {	/* Cfa/box.scm 104 */
		       approx_bglt aux_3582;
		       {	/* Cfa/box.scm 104 */
			  approx_bglt aux_3590;
			  approx_bglt aux_3583;
			  {	/* Cfa/box.scm 104 */
			     make_box_o_cinfo_96_bglt obj_3407;
			     obj_3407 =
				(make_box_o_cinfo_96_bglt) (box_2945);
			     {
				obj_t aux_3592;
				{	/* ./Cfa/cinfo.scm 1219 */
				   object_bglt aux_3593;
				   aux_3593 =
				      (object_bglt) (obj_3407);
				   aux_3592 =
				      OBJECT_WIDENING(aux_3593);
				}
				aux_3590 =
				   (((make_box_o_cinfo_96_bglt) CREF(aux_3592))->value_approx_19);
			     }
			  }
			  {	/* Cfa/box.scm 104 */
			     box_ref_o_cinfo_98_bglt obj_3406;
			     obj_3406 =
				(box_ref_o_cinfo_98_bglt) (instance2043_3443);
			     {
				obj_t aux_3585;
				{	/* ./Cfa/cinfo.scm 1223 */
				   object_bglt aux_3586;
				   aux_3586 =
				      (object_bglt) (obj_3406);
				   aux_3585 =
				      OBJECT_WIDENING(aux_3586);
				}
				aux_3583 =
				   (((box_ref_o_cinfo_98_bglt) CREF(aux_3585))->approx);
			     }
			  }
			  aux_3582 =
			     union_approx__241_cfa_approx(aux_3583, aux_3590);
		       }
		       return
			  (obj_t) (aux_3582);
		    }
		 }
	       else
		 {	/* Cfa/box.scm 105 */
		    bool_t test2354_2951;
		    test2354_2951 =
		       is_a__118___object(box_2945, make_box_cinfo_127_cfa_info);
		    if (test2354_2951)
		      {		/* Cfa/box.scm 105 */
			 {	/* Cfa/box.scm 106 */
			    obj_t arg2357_2954;
			    arg2357_2954 =
			       shape_tools_shape(node_3442);
			    return
			       internal_error_43_tools_error(string2394_cfa_box, string2395_cfa_box, arg2357_2954);
			 }
		      }
		    else
		      {		/* Cfa/box.scm 105 */
			 return BFALSE;
		      }
		 }
	    }
	 }
      }
   }
}



/* cfa!-make-box/o-cinfo2056 */
obj_t 
cfa__make_box_o_cinfo2056_25_cfa_box(obj_t env_3445, obj_t node_3446)
{
   AN_OBJECT;
   {	/* Cfa/box.scm 86 */
      {
	 make_box_o_cinfo_96_bglt node_2930;
	 {	/* Cfa/box.scm 87 */
	    approx_bglt aux_3603;
	    node_2930 =
	       (make_box_o_cinfo_96_bglt) (node_3446);
	    {	/* Cfa/box.scm 89 */
	       approx_bglt init_value_approx_9_2934;
	       {	/* Cfa/box.scm 89 */
		  node_bglt aux_3604;
		  {	/* Cfa/box.scm 89 */
		     make_box_202_bglt obj_3401;
		     obj_3401 =
			(make_box_202_bglt) (node_2930);
		     aux_3604 =
			(((make_box_202_bglt) CREF(obj_3401))->value);
		  }
		  init_value_approx_9_2934 =
		     cfa__102_cfa_cfa(aux_3604);
	       }
	       {	/* Cfa/box.scm 90 */
		  approx_bglt aux_3608;
		  {
		     obj_t aux_3609;
		     {	/* ./Cfa/cinfo.scm 1219 */
			object_bglt aux_3610;
			aux_3610 =
			   (object_bglt) (node_2930);
			aux_3609 =
			   OBJECT_WIDENING(aux_3610);
		     }
		     aux_3608 =
			(((make_box_o_cinfo_96_bglt) CREF(aux_3609))->value_approx_19);
		  }
		  union_approx__241_cfa_approx(aux_3608, init_value_approx_9_2934);
	       }
	       {
		  obj_t aux_3615;
		  {	/* ./Cfa/cinfo.scm 1217 */
		     object_bglt aux_3616;
		     aux_3616 =
			(object_bglt) (node_2930);
		     aux_3615 =
			OBJECT_WIDENING(aux_3616);
		  }
		  aux_3603 =
		     (((make_box_o_cinfo_96_bglt) CREF(aux_3615))->approx);
	       }
	    }
	    return
	       (obj_t) (aux_3603);
	 }
      }
   }
}



/* node-setup!-box-ref2054 */
obj_t 
node_setup__box_ref2054_140_cfa_box(obj_t env_3447, obj_t node_3448)
{
   AN_OBJECT;
   {	/* Cfa/box.scm 72 */
      {
	 box_ref_242_bglt node_2913;
	 node_2913 =
	    (box_ref_242_bglt) (node_3448);
	 {	/* Cfa/box.scm 74 */
	    node_bglt aux_3622;
	    {	/* Cfa/box.scm 74 */
	       var_bglt aux_3623;
	       aux_3623 =
		  (((box_ref_242_bglt) CREF(node_2913))->var);
	       aux_3622 =
		  (node_bglt) (aux_3623);
	    }
	    node_setup__189_cfa_setup(aux_3622);
	 }
	 {	/* Cfa/box.scm 75 */
	    bool_t test2337_2918;
	    {	/* Cfa/box.scm 75 */
	       long n1_3386;
	       n1_3386 =
		  (long) CINT(_optim__89_engine_param);
	       test2337_2918 =
		  (n1_3386 >= ((long) 1));
	    }
	    if (test2337_2918)
	      {		/* Cfa/box.scm 76 */
		 box_ref_o_cinfo_98_bglt obj2040_2919;
		 obj2040_2919 =
		    ((box_ref_o_cinfo_98_bglt) (node_2913));
		 {	/* Cfa/box.scm 77 */
		    box_ref_o_cinfo_98_bglt arg2338_2920;
		    {	/* Cfa/box.scm 77 */
		       approx_bglt arg2339_2921;
		       arg2339_2921 =
			  make_type_approx_184_cfa_approx(
			  (type_bglt) (_obj__252_type_cache));
		       {	/* Cfa/box.scm 76 */
			  box_ref_o_cinfo_98_bglt res2378_3391;
			  {	/* ./Cfa/cinfo.scm 1223 */
			     box_ref_o_cinfo_98_bglt new1742_3389;
			     new1742_3389 =
				((box_ref_o_cinfo_98_bglt) BREF(GC_MALLOC(sizeof(struct box_ref_o_cinfo_98))));
			     ((((box_ref_o_cinfo_98_bglt) CREF(new1742_3389))->approx) = ((approx_bglt) arg2339_2921), BUNSPEC);
			     res2378_3391 = new1742_3389;
			  }
			  arg2338_2920 = res2378_3391;
		       }
		    }
		    {	/* Cfa/box.scm 76 */
		       obj_t aux_3637;
		       object_bglt aux_3635;
		       aux_3637 =
			  (obj_t) (arg2338_2920);
		       aux_3635 =
			  (object_bglt) (obj2040_2919);
		       OBJECT_WIDENING_SET(aux_3635, aux_3637);
		    }
		 }
		 {	/* Cfa/box.scm 76 */
		    long arg2340_2922;
		    arg2340_2922 =
		       class_num_218___object(box_ref_o_cinfo_98_cfa_info);
		    {	/* Cfa/box.scm 76 */
		       obj_t obj_3392;
		       obj_3392 =
			  (obj_t) (obj2040_2919);
		       (((obj_t) CREF(obj_3392))->header = MAKE_HEADER(arg2340_2922, 0), BUNSPEC);
		    }
		 }
		 return
		    (obj_t) (obj2040_2919);
	      }
	    else
	      {		/* Cfa/box.scm 75 */
		 {	/* Cfa/box.scm 79 */
		    box_ref_cinfo_214_bglt obj2041_2923;
		    obj2041_2923 =
		       ((box_ref_cinfo_214_bglt) (node_2913));
		    {	/* Cfa/box.scm 80 */
		       box_ref_cinfo_214_bglt arg2341_2924;
		       {	/* Cfa/box.scm 80 */
			  approx_bglt arg2342_2925;
			  arg2342_2925 =
			     make_type_approx_184_cfa_approx(
			     (type_bglt) (_obj__252_type_cache));
			  {	/* Cfa/box.scm 79 */
			     box_ref_cinfo_214_bglt res2379_3397;
			     {	/* ./Cfa/cinfo.scm 1221 */
				box_ref_cinfo_214_bglt new1723_3395;
				new1723_3395 =
				   ((box_ref_cinfo_214_bglt) BREF(GC_MALLOC(sizeof(struct box_ref_cinfo_214))));
				((((box_ref_cinfo_214_bglt) CREF(new1723_3395))->approx) = ((approx_bglt) arg2342_2925), BUNSPEC);
				res2379_3397 = new1723_3395;
			     }
			     arg2341_2924 = res2379_3397;
			  }
		       }
		       {	/* Cfa/box.scm 79 */
			  obj_t aux_3651;
			  object_bglt aux_3649;
			  aux_3651 =
			     (obj_t) (arg2341_2924);
			  aux_3649 =
			     (object_bglt) (obj2041_2923);
			  OBJECT_WIDENING_SET(aux_3649, aux_3651);
		       }
		    }
		    {	/* Cfa/box.scm 79 */
		       long arg2343_2926;
		       arg2343_2926 =
			  class_num_218___object(box_ref_cinfo_214_cfa_info);
		       {	/* Cfa/box.scm 79 */
			  obj_t obj_3398;
			  obj_3398 =
			     (obj_t) (obj2041_2923);
			  (((obj_t) CREF(obj_3398))->header = MAKE_HEADER(arg2343_2926, 0), BUNSPEC);
		       }
		    }
		    obj2041_2923;
		 }
		 {	/* Cfa/box.scm 81 */
		    approx_bglt aux_3657;
		    {	/* Cfa/box.scm 81 */
		       box_ref_cinfo_214_bglt obj_3400;
		       obj_3400 =
			  (box_ref_cinfo_214_bglt) (node_2913);
		       {
			  obj_t aux_3659;
			  {	/* ./Cfa/cinfo.scm 1221 */
			     object_bglt aux_3660;
			     aux_3660 =
				(object_bglt) (obj_3400);
			     aux_3659 =
				OBJECT_WIDENING(aux_3660);
			  }
			  aux_3657 =
			     (((box_ref_cinfo_214_bglt) CREF(aux_3659))->approx);
		       }
		    }
		    return
		       approx_set_top__187_cfa_approx(aux_3657);
		 }
	      }
	 }
      }
   }
}



/* node-setup!-box-set!2052 */
obj_t 
node_setup__box_set_2052_31_cfa_box(obj_t env_3449, obj_t node_3450)
{
   AN_OBJECT;
   {	/* Cfa/box.scm 59 */
      {
	 box_set__221_bglt node_2896;
	 node_2896 =
	    (box_set__221_bglt) (node_3450);
	 {	/* Cfa/box.scm 61 */
	    node_bglt aux_3666;
	    {	/* Cfa/box.scm 61 */
	       var_bglt aux_3667;
	       aux_3667 =
		  (((box_set__221_bglt) CREF(node_2896))->var);
	       aux_3666 =
		  (node_bglt) (aux_3667);
	    }
	    node_setup__189_cfa_setup(aux_3666);
	 }
	 node_setup__189_cfa_setup(
	    (((box_set__221_bglt) CREF(node_2896))->value));
	 {	/* Cfa/box.scm 63 */
	    bool_t test2328_2902;
	    {	/* Cfa/box.scm 63 */
	       long n1_3371;
	       n1_3371 =
		  (long) CINT(_optim__89_engine_param);
	       test2328_2902 =
		  (n1_3371 >= ((long) 1));
	    }
	    if (test2328_2902)
	      {		/* Cfa/box.scm 64 */
		 box_set__o_cinfo_6_bglt obj2037_2903;
		 obj2037_2903 =
		    ((box_set__o_cinfo_6_bglt) (node_2896));
		 {	/* Cfa/box.scm 65 */
		    box_set__o_cinfo_6_bglt arg2329_2904;
		    {	/* Cfa/box.scm 65 */
		       approx_bglt arg2330_2905;
		       arg2330_2905 =
			  make_type_approx_184_cfa_approx(
			  (type_bglt) (_unspec__87_type_cache));
		       {	/* Cfa/box.scm 64 */
			  box_set__o_cinfo_6_bglt res2376_3376;
			  {	/* ./Cfa/cinfo.scm 1222 */
			     box_set__o_cinfo_6_bglt new1732_3374;
			     new1732_3374 =
				((box_set__o_cinfo_6_bglt) BREF(GC_MALLOC(sizeof(struct box_set__o_cinfo_6))));
			     ((((box_set__o_cinfo_6_bglt) CREF(new1732_3374))->approx) = ((approx_bglt) arg2330_2905), BUNSPEC);
			     res2376_3376 = new1732_3374;
			  }
			  arg2329_2904 = res2376_3376;
		       }
		    }
		    {	/* Cfa/box.scm 64 */
		       obj_t aux_3683;
		       object_bglt aux_3681;
		       aux_3683 =
			  (obj_t) (arg2329_2904);
		       aux_3681 =
			  (object_bglt) (obj2037_2903);
		       OBJECT_WIDENING_SET(aux_3681, aux_3683);
		    }
		 }
		 {	/* Cfa/box.scm 64 */
		    long arg2331_2906;
		    arg2331_2906 =
		       class_num_218___object(box_set__o_cinfo_6_cfa_info);
		    {	/* Cfa/box.scm 64 */
		       obj_t obj_3377;
		       obj_3377 =
			  (obj_t) (obj2037_2903);
		       (((obj_t) CREF(obj_3377))->header = MAKE_HEADER(arg2331_2906, 0), BUNSPEC);
		    }
		 }
		 return
		    (obj_t) (obj2037_2903);
	      }
	    else
	      {		/* Cfa/box.scm 66 */
		 box_set__cinfo_94_bglt obj2038_2907;
		 obj2038_2907 =
		    ((box_set__cinfo_94_bglt) (node_2896));
		 {	/* Cfa/box.scm 67 */
		    box_set__cinfo_94_bglt arg2332_2908;
		    {	/* Cfa/box.scm 67 */
		       approx_bglt arg2333_2909;
		       arg2333_2909 =
			  make_type_approx_184_cfa_approx(
			  (type_bglt) (_unspec__87_type_cache));
		       {	/* Cfa/box.scm 66 */
			  box_set__cinfo_94_bglt res2377_3382;
			  {	/* ./Cfa/cinfo.scm 1220 */
			     box_set__cinfo_94_bglt new1713_3380;
			     new1713_3380 =
				((box_set__cinfo_94_bglt) BREF(GC_MALLOC(sizeof(struct box_set__cinfo_94))));
			     ((((box_set__cinfo_94_bglt) CREF(new1713_3380))->approx) = ((approx_bglt) arg2333_2909), BUNSPEC);
			     res2377_3382 = new1713_3380;
			  }
			  arg2332_2908 = res2377_3382;
		       }
		    }
		    {	/* Cfa/box.scm 66 */
		       obj_t aux_3697;
		       object_bglt aux_3695;
		       aux_3697 =
			  (obj_t) (arg2332_2908);
		       aux_3695 =
			  (object_bglt) (obj2038_2907);
		       OBJECT_WIDENING_SET(aux_3695, aux_3697);
		    }
		 }
		 {	/* Cfa/box.scm 66 */
		    long arg2334_2910;
		    arg2334_2910 =
		       class_num_218___object(box_set__cinfo_94_cfa_info);
		    {	/* Cfa/box.scm 66 */
		       obj_t obj_3383;
		       obj_3383 =
			  (obj_t) (obj2038_2907);
		       (((obj_t) CREF(obj_3383))->header = MAKE_HEADER(arg2334_2910, 0), BUNSPEC);
		    }
		 }
		 return
		    (obj_t) (obj2038_2907);
	      }
	 }
      }
   }
}



/* node-setup!-pre-make-box2050 */
obj_t 
node_setup__pre_make_box2050_241_cfa_box(obj_t env_3451, obj_t node_3452)
{
   AN_OBJECT;
   {	/* Cfa/box.scm 45 */
      {
	 pre_make_box_186_bglt node_2877;
	 node_2877 =
	    (pre_make_box_186_bglt) (node_3452);
	 {	/* Cfa/box.scm 47 */
	    node_bglt aux_3705;
	    {	/* Cfa/box.scm 47 */
	       make_box_202_bglt obj_3347;
	       obj_3347 =
		  (make_box_202_bglt) (node_2877);
	       aux_3705 =
		  (((make_box_202_bglt) CREF(obj_3347))->value);
	    }
	    node_setup__189_cfa_setup(aux_3705);
	 }
	 {	/* Cfa/box.scm 48 */
	    pre_make_box_186_bglt node_2882;
	    {	/* Cfa/box.scm 48 */
	       long arg2322_2891;
	       {	/* Cfa/box.scm 48 */
		  obj_t arg2323_2892;
		  {	/* Cfa/box.scm 48 */
		     obj_t arg2324_2893;
		     {	/* Cfa/box.scm 48 */
			object_bglt object_3348;
			object_3348 =
			   (object_bglt) (node_2877);
			{	/* ./Llib/object.scm 2695 */
			   long arg1179_3349;
			   {	/* ./Llib/object.scm 2695 */
			      long arg1180_3350;
			      long arg1181_3351;
			      arg1180_3350 =
				 TYPE(object_3348);
			      arg1181_3351 =
				 OBJECT_TYPE;
			      arg1179_3349 =
				 (arg1180_3350 - arg1181_3351);
			   }
			   {	/* ./Llib/object.scm 2695 */
			      obj_t vector_3355;
			      vector_3355 = _classes__134___object;
			      arg2324_2893 =
				 VECTOR_REF(vector_3355, arg1179_3349);
			   }
			}
		     }
		     arg2323_2892 =
			class_super_145___object(arg2324_2893);
		  }
		  arg2322_2891 =
		     class_num_218___object(arg2323_2892);
	       }
	       {	/* Cfa/box.scm 48 */
		  obj_t obj_3357;
		  obj_3357 =
		     (obj_t) (node_2877);
		  (((obj_t) CREF(obj_3357))->header = MAKE_HEADER(arg2322_2891, 0), BUNSPEC);
	       }
	    }
	    {	/* Cfa/box.scm 48 */
	       object_bglt aux_3718;
	       aux_3718 =
		  (object_bglt) (node_2877);
	       OBJECT_WIDENING_SET(aux_3718, BFALSE);
	    }
	    node_2882 = node_2877;
	    {	/* Cfa/box.scm 48 */

	       {	/* Cfa/box.scm 49 */
		  make_box_o_cinfo_96_bglt node_2883;
		  {	/* Cfa/box.scm 49 */
		     make_box_o_cinfo_96_bglt obj2035_2885;
		     obj2035_2885 =
			((make_box_o_cinfo_96_bglt) (node_2882));
		     {	/* Cfa/box.scm 50 */
			make_box_o_cinfo_96_bglt arg2318_2886;
			{	/* Cfa/box.scm 50 */
			   approx_bglt arg2319_2887;
			   approx_bglt arg2320_2888;
			   arg2319_2887 =
			      make_type_approx_184_cfa_approx(
			      (type_bglt) (_obj__252_type_cache));
			   arg2320_2888 =
			      make_empty_approx_131_cfa_approx();
			   {	/* Cfa/box.scm 49 */
			      make_box_o_cinfo_96_bglt res2375_3364;
			      {		/* ./Cfa/cinfo.scm 1217 */
				 make_box_o_cinfo_96_bglt new1703_3361;
				 new1703_3361 =
				    ((make_box_o_cinfo_96_bglt) BREF(GC_MALLOC(sizeof(struct make_box_o_cinfo_96))));
				 ((((make_box_o_cinfo_96_bglt) CREF(new1703_3361))->approx) = ((approx_bglt) arg2319_2887), BUNSPEC);
				 ((((make_box_o_cinfo_96_bglt) CREF(new1703_3361))->value_approx_19) = ((approx_bglt) arg2320_2888), BUNSPEC);
				 res2375_3364 = new1703_3361;
			      }
			      arg2318_2886 = res2375_3364;
			   }
			}
			{	/* Cfa/box.scm 49 */
			   obj_t aux_3730;
			   object_bglt aux_3728;
			   aux_3730 =
			      (obj_t) (arg2318_2886);
			   aux_3728 =
			      (object_bglt) (obj2035_2885);
			   OBJECT_WIDENING_SET(aux_3728, aux_3730);
			}
		     }
		     {	/* Cfa/box.scm 49 */
			long arg2321_2889;
			arg2321_2889 =
			   class_num_218___object(make_box_o_cinfo_96_cfa_info);
			{	/* Cfa/box.scm 49 */
			   obj_t obj_3365;
			   obj_3365 =
			      (obj_t) (obj2035_2885);
			   (((obj_t) CREF(obj_3365))->header = MAKE_HEADER(arg2321_2889, 0), BUNSPEC);
			}
		     }
		     node_2883 = obj2035_2885;
		  }
		  {	/* Cfa/box.scm 54 */
		     approx_bglt arg2317_2884;
		     arg2317_2884 =
			make_type_alloc_approx_134_cfa_approx(
			(type_bglt) (_obj__252_type_cache),
			(node_bglt) (node_2883));
		     {
			obj_t aux_3739;
			{	/* ./Cfa/cinfo.scm 1217 */
			   object_bglt aux_3740;
			   aux_3740 =
			      (object_bglt) (node_2883);
			   aux_3739 =
			      OBJECT_WIDENING(aux_3740);
			}
			return
			   ((((make_box_o_cinfo_96_bglt) CREF(aux_3739))->approx) = ((approx_bglt) arg2317_2884), BUNSPEC);
		     }
		  }
	       }
	    }
	 }
      }
   }
}



/* node-setup!-make-box2048 */
obj_t 
node_setup__make_box2048_85_cfa_box(obj_t env_3453, obj_t node_3454)
{
   AN_OBJECT;
   {	/* Cfa/box.scm 35 */
      {
	 make_box_202_bglt node_2865;
	 node_2865 =
	    (make_box_202_bglt) (node_3454);
	 node_setup__189_cfa_setup(
	    (((make_box_202_bglt) CREF(node_2865))->value));
	 {	/* Cfa/box.scm 38 */
	    make_box_cinfo_127_bglt obj2032_2870;
	    obj2032_2870 =
	       ((make_box_cinfo_127_bglt) (node_2865));
	    {	/* Cfa/box.scm 39 */
	       make_box_cinfo_127_bglt arg2311_2871;
	       {	/* Cfa/box.scm 39 */
		  approx_bglt arg2312_2872;
		  arg2312_2872 =
		     make_type_approx_184_cfa_approx(
		     (type_bglt) (_obj__252_type_cache));
		  {	/* Cfa/box.scm 38 */
		     make_box_cinfo_127_bglt res2374_3343;
		     {	/* ./Cfa/cinfo.scm 1216 */
			make_box_cinfo_127_bglt new1692_3341;
			new1692_3341 =
			   ((make_box_cinfo_127_bglt) BREF(GC_MALLOC(sizeof(struct make_box_cinfo_127))));
			((((make_box_cinfo_127_bglt) CREF(new1692_3341))->approx) = ((approx_bglt) arg2312_2872), BUNSPEC);
			res2374_3343 = new1692_3341;
		     }
		     arg2311_2871 = res2374_3343;
		  }
	       }
	       {	/* Cfa/box.scm 38 */
		  obj_t aux_3754;
		  object_bglt aux_3752;
		  aux_3754 =
		     (obj_t) (arg2311_2871);
		  aux_3752 =
		     (object_bglt) (obj2032_2870);
		  OBJECT_WIDENING_SET(aux_3752, aux_3754);
	       }
	    }
	    {	/* Cfa/box.scm 38 */
	       long arg2313_2873;
	       arg2313_2873 =
		  class_num_218___object(make_box_cinfo_127_cfa_info);
	       {	/* Cfa/box.scm 38 */
		  obj_t obj_3344;
		  obj_3344 =
		     (obj_t) (obj2032_2870);
		  (((obj_t) CREF(obj_3344))->header = MAKE_HEADER(arg2313_2873, 0), BUNSPEC);
	       }
	    }
	    obj2032_2870;
	 }
	 {	/* Cfa/box.scm 40 */
	    approx_bglt aux_3760;
	    {	/* Cfa/box.scm 40 */
	       make_box_cinfo_127_bglt obj_3346;
	       obj_3346 =
		  (make_box_cinfo_127_bglt) (node_2865);
	       {
		  obj_t aux_3762;
		  {	/* ./Cfa/cinfo.scm 1216 */
		     object_bglt aux_3763;
		     aux_3763 =
			(object_bglt) (obj_3346);
		     aux_3762 =
			OBJECT_WIDENING(aux_3763);
		  }
		  aux_3760 =
		     (((make_box_cinfo_127_bglt) CREF(aux_3762))->approx);
	       }
	    }
	    return
	       approx_set_top__187_cfa_approx(aux_3760);
	 }
      }
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_cfa_box()
{
   AN_OBJECT;
   {	/* Cfa/box.scm 14 */
      module_initialization_70_tools_trace(((long) 0), "CFA_BOX");
      module_initialization_70_tools_error(((long) 0), "CFA_BOX");
      module_initialization_70_tools_shape(((long) 0), "CFA_BOX");
      module_initialization_70_engine_param(((long) 0), "CFA_BOX");
      module_initialization_70_type_type(((long) 0), "CFA_BOX");
      module_initialization_70_type_cache(((long) 0), "CFA_BOX");
      module_initialization_70_ast_var(((long) 0), "CFA_BOX");
      module_initialization_70_ast_node(((long) 0), "CFA_BOX");
      module_initialization_70_cfa_info(((long) 0), "CFA_BOX");
      module_initialization_70_cfa_info2(((long) 0), "CFA_BOX");
      module_initialization_70_cfa_loose(((long) 0), "CFA_BOX");
      module_initialization_70_cfa_setup(((long) 0), "CFA_BOX");
      module_initialization_70_cfa_approx(((long) 0), "CFA_BOX");
      module_initialization_70_cfa_cfa(((long) 0), "CFA_BOX");
      module_initialization_70_cfa_iterate(((long) 0), "CFA_BOX");
      return
	 module_initialization_70_cfa_closure(((long) 0), "CFA_BOX");
   }
}
