/*===========================================================================*/
/*   (Cfa/cfa.scm)                                                           */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;

typedef struct approx
  {
     header_t header;
     obj_t widening;
     struct type *type;
     bool_t type_locked__184;
     obj_t allocs;
     bool_t top__138;
     long lost_stamp_114;
  }
      *approx_bglt;

typedef struct cfun_cinfo_200
  {
     struct approx *approx;
  }
              *cfun_cinfo_200_bglt;

typedef struct extern_sfun_cinfo_6
  {
     struct approx *approx;
  }
                   *extern_sfun_cinfo_6_bglt;

typedef struct intern_sfun_cinfo_192
  {
     struct approx *approx;
     long stamp;
  }
                     *intern_sfun_cinfo_192_bglt;

typedef struct scnst_cinfo_0
  {
     struct approx *approx;
  }
             *scnst_cinfo_0_bglt;

typedef struct pre_clo_env_191
  {
     char dummy;
  }
               *pre_clo_env_191_bglt;

typedef struct svar_cinfo_166
  {
     struct approx *approx;
     bool_t clo_env__87;
  }
              *svar_cinfo_166_bglt;

typedef struct cvar_cinfo_53
  {
     struct approx *approx;
  }
             *cvar_cinfo_53_bglt;

typedef struct sexit_cinfo_49
  {
     struct approx *approx;
  }
              *sexit_cinfo_49_bglt;

typedef struct reshaped_local_224
  {
     obj_t binding_value_3;
  }
                  *reshaped_local_224_bglt;

typedef struct reshaped_global_160
  {
     char dummy;
  }
                   *reshaped_global_160_bglt;

typedef struct atom_cinfo_155
  {
     struct approx *approx;
  }
              *atom_cinfo_155_bglt;

typedef struct kwote_node_102
  {
     struct node *node;
  }
              *kwote_node_102_bglt;

typedef struct kwote_cinfo_48
  {
     struct approx *approx;
  }
              *kwote_cinfo_48_bglt;

typedef struct app_ly_cinfo_234
  {
     struct approx *approx;
  }
                *app_ly_cinfo_234_bglt;

typedef struct funcall_cinfo_75
  {
     struct approx *approx;
     struct approx *va_approx_63;
     bool_t arity_error_noticed__118;
     bool_t type_error_noticed__36;
  }
                *funcall_cinfo_75_bglt;

typedef struct pragma_cinfo_220
  {
     struct approx *approx;
  }
                *pragma_cinfo_220_bglt;

typedef struct setq_cinfo_191
  {
     struct approx *approx;
  }
              *setq_cinfo_191_bglt;

typedef struct conditional_cinfo_212
  {
     struct approx *approx;
  }
                     *conditional_cinfo_212_bglt;

typedef struct fail_cinfo_75
  {
     struct approx *approx;
  }
             *fail_cinfo_75_bglt;

typedef struct select_cinfo_150
  {
     struct approx *approx;
  }
                *select_cinfo_150_bglt;

typedef struct set_ex_it_cinfo_168
  {
     struct approx *approx;
  }
                   *set_ex_it_cinfo_168_bglt;

typedef struct jump_ex_it_cinfo_139
  {
     struct approx *approx;
  }
                    *jump_ex_it_cinfo_139_bglt;

typedef struct pre_make_box_186
  {
     char dummy;
  }
                *pre_make_box_186_bglt;

typedef struct make_box_cinfo_127
  {
     struct approx *approx;
  }
                  *make_box_cinfo_127_bglt;

typedef struct make_box_o_cinfo_96
  {
     struct approx *approx;
     struct approx *value_approx_19;
  }
                   *make_box_o_cinfo_96_bglt;

typedef struct box_set__cinfo_94
  {
     struct approx *approx;
  }
                 *box_set__cinfo_94_bglt;

typedef struct box_ref_cinfo_214
  {
     struct approx *approx;
  }
                 *box_ref_cinfo_214_bglt;

typedef struct box_set__o_cinfo_6
  {
     struct approx *approx;
  }
                  *box_set__o_cinfo_6_bglt;

typedef struct box_ref_o_cinfo_98
  {
     struct approx *approx;
  }
                  *box_ref_o_cinfo_98_bglt;

typedef struct pre_make_procedure_app_60
  {
     struct variable *owner;
  }
                         *pre_make_procedure_app_60_bglt;

typedef struct pre_procedure_ref_app_85
  {
     char dummy;
  }
                        *pre_procedure_ref_app_85_bglt;

typedef struct pre_procedure_set__app_208
  {
     char dummy;
  }
                          *pre_procedure_set__app_208_bglt;

typedef struct make_procedure_app_48
  {
     struct approx *approx;
     long values_approx_len_106;
     struct approx **values_approx_79;
     long lost_stamp_114;
     bool_t x_t__142;
     bool_t x;
     bool_t t;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
  }
                     *make_procedure_app_48_bglt;

typedef struct procedure_ref_app_49
  {
     struct approx *approx;
  }
                    *procedure_ref_app_49_bglt;

typedef struct procedure_set__app_32
  {
     struct approx *approx;
  }
                     *procedure_set__app_32_bglt;

typedef struct pre_make_vector_app_251
  {
     struct variable *owner;
  }
                       *pre_make_vector_app_251_bglt;

typedef struct pre_create_vector_app_162
  {
     struct variable *owner;
  }
                         *pre_create_vector_app_162_bglt;

typedef struct pre_vector_ref_app_208
  {
     char dummy;
  }
                      *pre_vector_ref_app_208_bglt;

typedef struct pre_vector_set__app_211
  {
     char dummy;
  }
                       *pre_vector_set__app_211_bglt;

typedef struct make_vector_app_205
  {
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
     bool_t seen__39;
  }
                   *make_vector_app_205_bglt;

typedef struct create_vector_app_150
  {
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
     bool_t seen__39;
  }
                     *create_vector_app_150_bglt;

typedef struct vector_ref_app_195
  {
     struct approx *approx;
  }
                  *vector_ref_app_195_bglt;

typedef struct vector_set__app_21
  {
     struct approx *approx;
  }
                  *vector_set__app_21_bglt;

typedef struct pre_make_struct_app_218
  {
     struct variable *owner;
  }
                       *pre_make_struct_app_218_bglt;

typedef struct pre_struct_ref_app_207
  {
     char dummy;
  }
                      *pre_struct_ref_app_207_bglt;

typedef struct pre_struct_set__app_116
  {
     char dummy;
  }
                       *pre_struct_set__app_116_bglt;

typedef struct make_struct_app_214
  {
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
  }
                   *make_struct_app_214_bglt;

typedef struct struct_ref_app_73
  {
     struct approx *approx;
  }
                 *struct_ref_app_73_bglt;

typedef struct struct_set__app_162
  {
     struct approx *approx;
  }
                   *struct_set__app_162_bglt;


static obj_t method_init_76_cfa_cfa();
extern obj_t box_set__cinfo_94_cfa_info;
extern long add_inlined_method__244___object(obj_t, obj_t, long);
extern obj_t make_box_cinfo_127_cfa_info;
static obj_t _cfa_variable_value_approx_165_cfa_cfa(obj_t, obj_t);
extern obj_t conditional_cinfo_212_cfa_info;
extern obj_t sequence_ast_node;
extern obj_t let_var_6_ast_node;
extern obj_t var_ast_node;
extern obj_t global_loose__8_cfa_loose(global_bglt, approx_bglt);
extern obj_t closure_ast_node;
extern obj_t global_ast_var;
extern obj_t _obj__252_type_cache;
extern obj_t set_ex_it_cinfo_168_cfa_info;
extern obj_t cvar_cinfo_53_cfa_info;
extern obj_t jump_ex_it_cinfo_139_cfa_info;
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t fail_cinfo_75_cfa_info;
extern obj_t intern_sfun_cinfo_192_cfa_info;
extern obj_t module_initialization_70_cfa_cfa(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_cfa_info(long, char *);
extern obj_t module_initialization_70_cfa_info2(long, char *);
extern obj_t module_initialization_70_cfa_loose(long, char *);
extern obj_t module_initialization_70_cfa_approx(long, char *);
extern obj_t module_initialization_70_cfa_app(long, char *);
extern obj_t module_initialization_70_cfa_funcall(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern approx_bglt union_approx__241_cfa_approx(approx_bglt, approx_bglt);
static obj_t _cfa__186_cfa_cfa(obj_t, obj_t);
extern obj_t select_cinfo_150_cfa_info;
extern obj_t let_fun_218_ast_node;
static obj_t imported_modules_init_94_cfa_cfa();
extern obj_t scnst_cinfo_0_cfa_info;
extern obj_t add_generic__110___object(obj_t, obj_t);
extern obj_t approx_set_top__187_cfa_approx(approx_bglt);
extern obj_t pragma_cinfo_220_cfa_info;
static obj_t _cfa__default2059_140_cfa_cfa(obj_t, obj_t);
static obj_t library_modules_init_112_cfa_cfa();
extern approx_bglt cfa__102_cfa_cfa(node_bglt);
extern obj_t cfa_variable_value_approx_39_cfa_cfa(value_bglt);
extern obj_t kwote_node_102_cfa_info;
extern obj_t cast_ast_node;
static obj_t toplevel_init_63_cfa_cfa();
extern obj_t open_input_string(obj_t);
static approx_bglt cfa__default2059_241_cfa_cfa(node_bglt);
extern obj_t kwote_cinfo_48_cfa_info;
extern obj_t box_ref_cinfo_214_cfa_info;
static obj_t _cfa_variable_value_approx_default2071_57_cfa_cfa(obj_t, obj_t);
extern obj_t shape_tools_shape(obj_t);
extern obj_t setq_cinfo_191_cfa_info;
extern obj_t internal_error_43_tools_error(obj_t, obj_t, obj_t);
extern obj_t _classes__134___object;
extern obj_t read___reader(obj_t);
static obj_t cfa_variable_value_approx_default2071_70_cfa_cfa(value_bglt);
extern obj_t sexit_cinfo_49_cfa_info;
extern obj_t app_ly_cinfo_234_cfa_info;
extern obj_t svar_cinfo_166_cfa_info;
extern obj_t ____74_type_cache;
static obj_t require_initialization_114_cfa_cfa = BUNSPEC;
extern approx_bglt loose__226_cfa_loose(approx_bglt, obj_t);
static obj_t cnst_init_137_cfa_cfa();
extern obj_t atom_cinfo_155_cfa_info;
static obj_t __cnst[2];

DEFINE_EXPORT_GENERIC(cfa__env_153_cfa_cfa, _cfa__186_cfa_cfa2475, _cfa__186_cfa_cfa, 0L, 1);
DEFINE_STATIC_PROCEDURE(cfa__default2059_env_180_cfa_cfa, _cfa__default2059_140_cfa_cfa2476, _cfa__default2059_140_cfa_cfa, 0L, 1);
DEFINE_STRING(string2469_cfa_cfa, string2469_cfa_cfa2477, "No method for this object", 25);
DEFINE_STRING(string2470_cfa_cfa, string2470_cfa_cfa2478, "CFA-VARIABLE-VALUE-APPROX-DEFAULT2071 ALL ", 42);
DEFINE_STRING(string2468_cfa_cfa, string2468_cfa_cfa2479, "cfa!:no method for this ast", 27);
DEFINE_STRING(string2467_cfa_cfa, string2467_cfa_cfa2480, "Unexpected closure", 18);
DEFINE_STRING(string2466_cfa_cfa, string2466_cfa_cfa2481, "cfa!", 4);
DEFINE_EXPORT_GENERIC(cfa_variable_value_approx_env_230_cfa_cfa, _cfa_variable_value_approx_165_cfa_cfa2482, _cfa_variable_value_approx_165_cfa_cfa, 0L, 1);
DEFINE_STATIC_PROCEDURE(cfa_variable_value_approx_default2071_env_79_cfa_cfa, _cfa_variable_value_approx_default2071_57_cfa_cfa2483, _cfa_variable_value_approx_default2071_57_cfa_cfa, 0L, 1);



/* module-initialization */
obj_t 
module_initialization_70_cfa_cfa(long checksum_3572, char *from_3573)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_cfa_cfa))
	{
	   require_initialization_114_cfa_cfa =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_cfa_cfa();
	   cnst_init_137_cfa_cfa();
	   imported_modules_init_94_cfa_cfa();
	   method_init_76_cfa_cfa();
	   toplevel_init_63_cfa_cfa();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_cfa_cfa()
{
   AN_OBJECT;
   {	/* Cfa/cfa.scm 14 */
      module_initialization_70___object(((long) 0), "CFA_CFA");
      module_initialization_70___reader(((long) 0), "CFA_CFA");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_cfa_cfa()
{
   AN_OBJECT;
   {	/* Cfa/cfa.scm 14 */
      {		/* Cfa/cfa.scm 14 */
	 obj_t cnst_port_138_3565;
	 cnst_port_138_3565 =
	    open_input_string(string2470_cfa_cfa);
	 {
	    long i_3566;
	    i_3566 = ((long) 1);
	  loop_3567:
	    {	/* Cfa/cfa.scm 14 */
	       bool_t test2471_3568;
	       test2471_3568 =
		  (i_3566 == ((long) -1));
	       if (test2471_3568)
		 {	/* Cfa/cfa.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Cfa/cfa.scm 14 */
		    {	/* Cfa/cfa.scm 14 */
		       obj_t arg2472_3569;
		       {	/* Cfa/cfa.scm 14 */
			  obj_t list2473_3570;
			  list2473_3570 =
			     MAKE_PAIR(cnst_port_138_3565, BNIL);
			  arg2472_3569 =
			     read___reader(list2473_3570);
		       }
		       CNST_TABLE_SET(i_3566, arg2472_3569);
		    }
		    {	/* Cfa/cfa.scm 14 */
		       int aux_3571;
		       {	/* Cfa/cfa.scm 14 */
			  long aux_3590;
			  aux_3590 =
			     (i_3566 - ((long) 1));
			  aux_3571 =
			     (int) (aux_3590);
		       }
		       {
			  long i_3593;
			  i_3593 =
			     (long) (aux_3571);
			  i_3566 = i_3593;
			  goto loop_3567;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_cfa_cfa()
{
   AN_OBJECT;
   {	/* Cfa/cfa.scm 14 */
      return BUNSPEC;
   }
}



/* method-init */
obj_t 
method_init_76_cfa_cfa()
{
   AN_OBJECT;
   {	/* Cfa/cfa.scm 14 */
      add_generic__110___object(cfa__env_153_cfa_cfa, cfa__default2059_env_180_cfa_cfa);
      add_inlined_method__244___object(cfa__env_153_cfa_cfa, atom_cinfo_155_cfa_info, ((long) 0));
      add_inlined_method__244___object(cfa__env_153_cfa_cfa, kwote_cinfo_48_cfa_info, ((long) 1));
      add_inlined_method__244___object(cfa__env_153_cfa_cfa, kwote_node_102_cfa_info, ((long) 2));
      add_inlined_method__244___object(cfa__env_153_cfa_cfa, var_ast_node, ((long) 3));
      add_inlined_method__244___object(cfa__env_153_cfa_cfa, closure_ast_node, ((long) 4));
      add_generic__110___object(cfa_variable_value_approx_env_230_cfa_cfa, cfa_variable_value_approx_default2071_env_79_cfa_cfa);
      add_inlined_method__244___object(cfa_variable_value_approx_env_230_cfa_cfa, svar_cinfo_166_cfa_info, ((long) 0));
      add_inlined_method__244___object(cfa_variable_value_approx_env_230_cfa_cfa, scnst_cinfo_0_cfa_info, ((long) 1));
      add_inlined_method__244___object(cfa_variable_value_approx_env_230_cfa_cfa, cvar_cinfo_53_cfa_info, ((long) 2));
      add_inlined_method__244___object(cfa_variable_value_approx_env_230_cfa_cfa, sexit_cinfo_49_cfa_info, ((long) 3));
      add_inlined_method__244___object(cfa_variable_value_approx_env_230_cfa_cfa, intern_sfun_cinfo_192_cfa_info, ((long) 4));
      add_inlined_method__244___object(cfa__env_153_cfa_cfa, sequence_ast_node, ((long) 5));
      add_inlined_method__244___object(cfa__env_153_cfa_cfa, app_ly_cinfo_234_cfa_info, ((long) 6));
      add_inlined_method__244___object(cfa__env_153_cfa_cfa, pragma_cinfo_220_cfa_info, ((long) 7));
      add_inlined_method__244___object(cfa__env_153_cfa_cfa, cast_ast_node, ((long) 8));
      add_inlined_method__244___object(cfa__env_153_cfa_cfa, setq_cinfo_191_cfa_info, ((long) 9));
      add_inlined_method__244___object(cfa__env_153_cfa_cfa, conditional_cinfo_212_cfa_info, ((long) 10));
      add_inlined_method__244___object(cfa__env_153_cfa_cfa, fail_cinfo_75_cfa_info, ((long) 11));
      add_inlined_method__244___object(cfa__env_153_cfa_cfa, select_cinfo_150_cfa_info, ((long) 12));
      add_inlined_method__244___object(cfa__env_153_cfa_cfa, let_fun_218_ast_node, ((long) 13));
      add_inlined_method__244___object(cfa__env_153_cfa_cfa, let_var_6_ast_node, ((long) 14));
      add_inlined_method__244___object(cfa__env_153_cfa_cfa, set_ex_it_cinfo_168_cfa_info, ((long) 15));
      add_inlined_method__244___object(cfa__env_153_cfa_cfa, jump_ex_it_cinfo_139_cfa_info, ((long) 16));
      add_inlined_method__244___object(cfa__env_153_cfa_cfa, make_box_cinfo_127_cfa_info, ((long) 17));
      add_inlined_method__244___object(cfa__env_153_cfa_cfa, box_set__cinfo_94_cfa_info, ((long) 18));
      {		/* Cfa/cfa.scm 14 */
	 long aux_3621;
	 aux_3621 =
	    add_inlined_method__244___object(cfa__env_153_cfa_cfa, box_ref_cinfo_214_cfa_info, ((long) 19));
	 return
	    BINT(aux_3621);
      }
   }
}



/* cfa! */
approx_bglt 
cfa__102_cfa_cfa(node_bglt node_1)
{
   AN_OBJECT;
   {	/* Cfa/cfa.scm 34 */
      {
	 obj_t method2375_2920;
	 obj_t class2380_2921;
	 {	/* Cfa/cfa.scm 34 */
	    obj_t arg2383_2918;
	    obj_t arg2384_2919;
	    {	/* Cfa/cfa.scm 34 */
	       object_bglt obj_3418;
	       obj_3418 =
		  (object_bglt) (node_1);
	       {	/* ./Llib/object.scm 2926 */
		  obj_t pre_method_105_3419;
		  pre_method_105_3419 =
		     PROCEDURE_REF(cfa__env_153_cfa_cfa, ((long) 2));
		  if (
		     INTEGERP(pre_method_105_3419))
		    {	/* ./Llib/object.scm 2927 */
		       PROCEDURE_SET(cfa__env_153_cfa_cfa, ((long) 2), BUNSPEC);
		       arg2383_2918 = pre_method_105_3419;
		    }
		  else
		    {	/* ./Llib/object.scm 2914 */
		       long obj_class_num_177_3424;
		       obj_class_num_177_3424 =
			  TYPE(obj_3418);
		       {	/* ./Llib/object.scm 2915 */
			  obj_t arg1176_3425;
			  arg1176_3425 =
			     PROCEDURE_REF(cfa__env_153_cfa_cfa, ((long) 1));
			  {	/* ./Llib/object.scm 2738 */
			     long arg1177_3429;
			     {	/* ./Llib/object.scm 2738 */
				long arg1178_3430;
				arg1178_3430 =
				   OBJECT_TYPE;
				arg1177_3429 =
				   (obj_class_num_177_3424 - arg1178_3430);
			     }
			     arg2383_2918 =
				VECTOR_REF(arg1176_3425, arg1177_3429);
			  }
		       }
		    }
	       }
	    }
	    {	/* Cfa/cfa.scm 34 */
	       object_bglt object_3435;
	       object_3435 =
		  (object_bglt) (node_1);
	       {	/* ./Llib/object.scm 2695 */
		  long arg1179_3436;
		  {	/* ./Llib/object.scm 2695 */
		     long arg1180_3437;
		     long arg1181_3438;
		     arg1180_3437 =
			TYPE(object_3435);
		     arg1181_3438 =
			OBJECT_TYPE;
		     arg1179_3436 =
			(arg1180_3437 - arg1181_3438);
		  }
		  {	/* ./Llib/object.scm 2695 */
		     obj_t vector_3442;
		     vector_3442 = _classes__134___object;
		     arg2384_2919 =
			VECTOR_REF(vector_3442, arg1179_3436);
		  }
	       }
	    }
	    {	/* Cfa/cfa.scm 34 */
	       obj_t aux_3639;
	       method2375_2920 = arg2383_2918;
	       class2380_2921 = arg2384_2919;
	       {

		  if (
		     INTEGERP(method2375_2920))
		    {	/* Cfa/cfa.scm 34 */
		       switch (
			  (long) CINT(method2375_2920))
			 {
			 case ((long) 0):

			    {	/* Cfa/cfa.scm 41 */
			       atom_cinfo_155_bglt node_2927;
			       node_2927 =
				  (atom_cinfo_155_bglt) (node_1);
			       {	/* ./Cfa/cinfo.scm 1184 */
				  approx_bglt aux_3643;
				  {
				     obj_t aux_3644;
				     {	/* ./Cfa/cinfo.scm 1184 */
					object_bglt aux_3645;
					aux_3645 =
					   (object_bglt) (node_2927);
					aux_3644 =
					   OBJECT_WIDENING(aux_3645);
				     }
				     aux_3643 =
					(((atom_cinfo_155_bglt) CREF(aux_3644))->approx);
				  }
				  aux_3639 =
				     (obj_t) (aux_3643);
			       }
			    }
			    break;
			 case ((long) 1):

			    {	/* Cfa/cfa.scm 48 */
			       kwote_cinfo_48_bglt node_2929;
			       node_2929 =
				  (kwote_cinfo_48_bglt) (node_1);
			       {	/* ./Cfa/cinfo.scm 1186 */
				  approx_bglt aux_3651;
				  {
				     obj_t aux_3652;
				     {	/* ./Cfa/cinfo.scm 1186 */
					object_bglt aux_3653;
					aux_3653 =
					   (object_bglt) (node_2929);
					aux_3652 =
					   OBJECT_WIDENING(aux_3653);
				     }
				     aux_3651 =
					(((kwote_cinfo_48_bglt) CREF(aux_3652))->approx);
				  }
				  aux_3639 =
				     (obj_t) (aux_3651);
			       }
			    }
			    break;
			 case ((long) 2):

			    {	/* Cfa/cfa.scm 55 */
			       kwote_node_102_bglt knode_2931;
			       knode_2931 =
				  (kwote_node_102_bglt) (node_1);
			       {	/* Cfa/cfa.scm 58 */
				  approx_bglt aux_3659;
				  {	/* Cfa/cfa.scm 58 */
				     node_bglt aux_3660;
				     {
					obj_t aux_3661;
					{	/* ./Cfa/cinfo.scm 1185 */
					   object_bglt aux_3662;
					   aux_3662 =
					      (object_bglt) (knode_2931);
					   aux_3661 =
					      OBJECT_WIDENING(aux_3662);
					}
					aux_3660 =
					   (((kwote_node_102_bglt) CREF(aux_3661))->node);
				     }
				     aux_3659 =
					cfa__102_cfa_cfa(aux_3660);
				  }
				  aux_3639 =
				     (obj_t) (aux_3659);
			       }
			    }
			    break;
			 case ((long) 3):

			    {	/* Cfa/cfa.scm 64 */
			       var_bglt node_2934;
			       node_2934 =
				  (var_bglt) (node_1);
			       {	/* Cfa/cfa.scm 65 */
				  value_bglt aux_3669;
				  {	/* Cfa/cfa.scm 65 */
				     variable_bglt arg2389_2937;
				     arg2389_2937 =
					(((var_bglt) CREF(node_2934))->variable);
				     aux_3669 =
					(((variable_bglt) CREF(arg2389_2937))->value);
				  }
				  aux_3639 =
				     cfa_variable_value_approx_39_cfa_cfa(aux_3669);
			       }
			    }
			    break;
			 case ((long) 4):

			    {	/* Cfa/cfa.scm 71 */
			       obj_t arg2392_2941;
			       {	/* Cfa/cfa.scm 71 */
				  obj_t aux_3673;
				  {	/* Cfa/cfa.scm 71 */
				     closure_bglt aux_3674;
				     aux_3674 =
					(closure_bglt) (node_1);
				     aux_3673 =
					(obj_t) (aux_3674);
				  }
				  arg2392_2941 =
				     shape_tools_shape(aux_3673);
			       }
			       aux_3639 =
				  internal_error_43_tools_error(string2466_cfa_cfa, string2467_cfa_cfa, arg2392_2941);
			    }
			    break;
			 case ((long) 5):

			    {	/* Cfa/cfa.scm 121 */
			       sequence_bglt node_2942;
			       node_2942 =
				  (sequence_bglt) (node_1);
			       {
				  obj_t n_2944;
				  obj_t approx_2945;
				  n_2944 =
				     (((sequence_bglt) CREF(node_2942))->nodes);
				  approx_2945 = BUNSPEC;
				loop_2946:
				  if (
				     NULLP(n_2944))
				    {	/* Cfa/cfa.scm 124 */
				       aux_3639 = approx_2945
					  ;
				    }
				  else
				    {	/* Cfa/cfa.scm 126 */
				       obj_t arg2395_2949;
				       approx_bglt arg2396_2950;
				       arg2395_2949 =
					  CDR(n_2944);
				       {	/* Cfa/cfa.scm 126 */
					  node_bglt aux_3683;
					  {	/* Cfa/cfa.scm 126 */
					     obj_t aux_3684;
					     aux_3684 =
						CAR(n_2944);
					     aux_3683 =
						(node_bglt) (aux_3684);
					  }
					  arg2396_2950 =
					     cfa__102_cfa_cfa(aux_3683);
				       }
				       {
					  obj_t approx_3689;
					  obj_t n_3688;
					  n_3688 = arg2395_2949;
					  approx_3689 =
					     (obj_t) (arg2396_2950);
					  approx_2945 = approx_3689;
					  n_2944 = n_3688;
					  goto loop_2946;
				       }
				    }
			       }
			    }
			    break;
			 case ((long) 6):

			    {	/* Cfa/cfa.scm 132 */
			       app_ly_cinfo_234_bglt node_2952;
			       node_2952 =
				  (app_ly_cinfo_234_bglt) (node_1);
			       {	/* Cfa/cfa.scm 133 */
				  approx_bglt arg2398_2954;
				  obj_t arg2399_2955;
				  {	/* Cfa/cfa.scm 133 */
				     node_bglt aux_3693;
				     {	/* Cfa/cfa.scm 133 */
					app_ly_162_bglt obj_3453;
					obj_3453 =
					   (app_ly_162_bglt) (node_2952);
					aux_3693 =
					   (((app_ly_162_bglt) CREF(obj_3453))->arg);
				     }
				     arg2398_2954 =
					cfa__102_cfa_cfa(aux_3693);
				  }
				  arg2399_2955 =
				     CNST_TABLE_REF(((long) 0));
				  loose__226_cfa_loose(arg2398_2954, arg2399_2955);
			       }
			       {	/* Cfa/cfa.scm 134 */
				  approx_bglt arg2401_2957;
				  obj_t arg2402_2958;
				  {	/* Cfa/cfa.scm 134 */
				     node_bglt aux_3699;
				     {	/* Cfa/cfa.scm 134 */
					app_ly_162_bglt obj_3454;
					obj_3454 =
					   (app_ly_162_bglt) (node_2952);
					aux_3699 =
					   (((app_ly_162_bglt) CREF(obj_3454))->fun);
				     }
				     arg2401_2957 =
					cfa__102_cfa_cfa(aux_3699);
				  }
				  arg2402_2958 =
				     CNST_TABLE_REF(((long) 0));
				  loose__226_cfa_loose(arg2401_2957, arg2402_2958);
			       }
			       {	/* ./Cfa/cinfo.scm 1187 */
				  approx_bglt aux_3705;
				  {
				     obj_t aux_3706;
				     {	/* ./Cfa/cinfo.scm 1187 */
					object_bglt aux_3707;
					aux_3707 =
					   (object_bglt) (node_2952);
					aux_3706 =
					   OBJECT_WIDENING(aux_3707);
				     }
				     aux_3705 =
					(((app_ly_cinfo_234_bglt) CREF(aux_3706))->approx);
				  }
				  aux_3639 =
				     (obj_t) (aux_3705);
			       }
			    }
			    break;
			 case ((long) 7):

			    {	/* Cfa/cfa.scm 141 */
			       pragma_cinfo_220_bglt node_2960;
			       node_2960 =
				  (pragma_cinfo_220_bglt) (node_1);
			       {
				  obj_t l2043_2962;
				  {	/* Cfa/cfa.scm 142 */
				     pragma_bglt obj_3456;
				     obj_3456 =
					(pragma_bglt) (node_2960);
				     l2043_2962 =
					(((pragma_bglt) CREF(obj_3456))->args);
				  }
				lname2044_2963:
				  if (
				     PAIRP(l2043_2962))
				    {	/* Cfa/cfa.scm 142 */
				       {	/* Cfa/cfa.scm 142 */
					  approx_bglt arg2406_2967;
					  obj_t arg2407_2968;
					  {	/* Cfa/cfa.scm 142 */
					     node_bglt aux_3715;
					     {	/* Cfa/cfa.scm 142 */
						obj_t aux_3716;
						aux_3716 =
						   CAR(l2043_2962);
						aux_3715 =
						   (node_bglt) (aux_3716);
					     }
					     arg2406_2967 =
						cfa__102_cfa_cfa(aux_3715);
					  }
					  arg2407_2968 =
					     CNST_TABLE_REF(((long) 0));
					  loose__226_cfa_loose(arg2406_2967, arg2407_2968);
				       }
				       {
					  obj_t l2043_3722;
					  l2043_3722 =
					     CDR(l2043_2962);
					  l2043_2962 = l2043_3722;
					  goto lname2044_2963;
				       }
				    }
				  else
				    {	/* Cfa/cfa.scm 142 */
				       ((bool_t) 1);
				    }
			       }
			       {	/* ./Cfa/cinfo.scm 1193 */
				  approx_bglt aux_3726;
				  {
				     obj_t aux_3727;
				     {	/* ./Cfa/cinfo.scm 1193 */
					object_bglt aux_3728;
					aux_3728 =
					   (object_bglt) (node_2960);
					aux_3727 =
					   OBJECT_WIDENING(aux_3728);
				     }
				     aux_3726 =
					(((pragma_cinfo_220_bglt) CREF(aux_3727))->approx);
				  }
				  aux_3639 =
				     (obj_t) (aux_3726);
			       }
			    }
			    break;
			 case ((long) 8):

			    {	/* Cfa/cfa.scm 149 */
			       cast_bglt node_2970;
			       node_2970 =
				  (cast_bglt) (node_1);
			       {	/* Cfa/cfa.scm 150 */
				  approx_bglt aux_3734;
				  aux_3734 =
				     cfa__102_cfa_cfa(
				     (((cast_bglt) CREF(node_2970))->arg));
				  aux_3639 =
				     (obj_t) (aux_3734);
			       }
			    }
			    break;
			 case ((long) 9):

			    {	/* Cfa/cfa.scm 156 */
			       setq_cinfo_191_bglt node_2973;
			       node_2973 =
				  (setq_cinfo_191_bglt) (node_1);
			       {	/* Cfa/cfa.scm 157 */
				  approx_bglt var_approx_58_2975;
				  {	/* Cfa/cfa.scm 157 */
				     node_bglt aux_3739;
				     {	/* Cfa/cfa.scm 157 */
					var_bglt aux_3740;
					{	/* Cfa/cfa.scm 157 */
					   setq_bglt obj_3462;
					   obj_3462 =
					      (setq_bglt) (node_2973);
					   aux_3740 =
					      (((setq_bglt) CREF(obj_3462))->var);
					}
					aux_3739 =
					   (node_bglt) (aux_3740);
				     }
				     var_approx_58_2975 =
					cfa__102_cfa_cfa(aux_3739);
				  }
				  {	/* Cfa/cfa.scm 157 */
				     approx_bglt val_approx_22_2976;
				     {	/* Cfa/cfa.scm 158 */
					node_bglt aux_3745;
					{	/* Cfa/cfa.scm 158 */
					   setq_bglt obj_3463;
					   obj_3463 =
					      (setq_bglt) (node_2973);
					   aux_3745 =
					      (((setq_bglt) CREF(obj_3463))->value);
					}
					val_approx_22_2976 =
					   cfa__102_cfa_cfa(aux_3745);
				     }
				     {	/* Cfa/cfa.scm 158 */
					variable_bglt v_2977;
					{	/* Cfa/cfa.scm 159 */
					   var_bglt arg2411_2979;
					   {	/* Cfa/cfa.scm 159 */
					      setq_bglt obj_3464;
					      obj_3464 =
						 (setq_bglt) (node_2973);
					      arg2411_2979 =
						 (((setq_bglt) CREF(obj_3464))->var);
					   }
					   v_2977 =
					      (((var_bglt) CREF(arg2411_2979))->variable);
					}
					{	/* Cfa/cfa.scm 159 */

					   union_approx__241_cfa_approx(var_approx_58_2975, val_approx_22_2976);
					   {	/* Cfa/cfa.scm 163 */
					      bool_t test2410_2978;
					      test2410_2978 =
						 is_a__118___object(
						 (obj_t) (v_2977), global_ast_var);
					      if (test2410_2978)
						{	/* Cfa/cfa.scm 163 */
						   global_loose__8_cfa_loose(
						      (global_bglt) (v_2977), var_approx_58_2975);
						}
					      else
						{	/* Cfa/cfa.scm 163 */
						   BUNSPEC;
						}
					   }
					   {	/* ./Cfa/cinfo.scm 1194 */
					      approx_bglt aux_3758;
					      {
						 obj_t aux_3759;
						 {	/* ./Cfa/cinfo.scm 1194 */
						    object_bglt aux_3760;
						    aux_3760 =
						       (object_bglt) (node_2973);
						    aux_3759 =
						       OBJECT_WIDENING(aux_3760);
						 }
						 aux_3758 =
						    (((setq_cinfo_191_bglt) CREF(aux_3759))->approx);
					      }
					      aux_3639 =
						 (obj_t) (aux_3758);
					   }
					}
				     }
				  }
			       }
			    }
			    break;
			 case ((long) 10):

			    {	/* Cfa/cfa.scm 170 */
			       conditional_cinfo_212_bglt node_2982;
			       node_2982 =
				  (conditional_cinfo_212_bglt) (node_1);
			       {	/* Cfa/cfa.scm 171 */
				  node_bglt aux_3766;
				  {	/* Cfa/cfa.scm 171 */
				     conditional_bglt obj_3468;
				     obj_3468 =
					(conditional_bglt) (node_2982);
				     aux_3766 =
					(((conditional_bglt) CREF(obj_3468))->test);
				  }
				  cfa__102_cfa_cfa(aux_3766);
			       }
			       {	/* Cfa/cfa.scm 172 */
				  approx_bglt then_approx_125_2985;
				  approx_bglt else_approx_184_2986;
				  {	/* Cfa/cfa.scm 172 */
				     node_bglt aux_3770;
				     {	/* Cfa/cfa.scm 172 */
					conditional_bglt obj_3469;
					obj_3469 =
					   (conditional_bglt) (node_2982);
					aux_3770 =
					   (((conditional_bglt) CREF(obj_3469))->true);
				     }
				     then_approx_125_2985 =
					cfa__102_cfa_cfa(aux_3770);
				  }
				  {	/* Cfa/cfa.scm 173 */
				     node_bglt aux_3774;
				     {	/* Cfa/cfa.scm 173 */
					conditional_bglt obj_3470;
					obj_3470 =
					   (conditional_bglt) (node_2982);
					aux_3774 =
					   (((conditional_bglt) CREF(obj_3470))->false);
				     }
				     else_approx_184_2986 =
					cfa__102_cfa_cfa(aux_3774);
				  }
				  {	/* Cfa/cfa.scm 174 */
				     approx_bglt aux_3778;
				     {
					obj_t aux_3779;
					{	/* ./Cfa/cinfo.scm 1195 */
					   object_bglt aux_3780;
					   aux_3780 =
					      (object_bglt) (node_2982);
					   aux_3779 =
					      OBJECT_WIDENING(aux_3780);
					}
					aux_3778 =
					   (((conditional_cinfo_212_bglt) CREF(aux_3779))->approx);
				     }
				     union_approx__241_cfa_approx(aux_3778, then_approx_125_2985);
				  }
				  {	/* Cfa/cfa.scm 175 */
				     approx_bglt aux_3785;
				     {
					obj_t aux_3786;
					{	/* ./Cfa/cinfo.scm 1195 */
					   object_bglt aux_3787;
					   aux_3787 =
					      (object_bglt) (node_2982);
					   aux_3786 =
					      OBJECT_WIDENING(aux_3787);
					}
					aux_3785 =
					   (((conditional_cinfo_212_bglt) CREF(aux_3786))->approx);
				     }
				     union_approx__241_cfa_approx(aux_3785, else_approx_184_2986);
				  }
				  {	/* ./Cfa/cinfo.scm 1195 */
				     approx_bglt aux_3792;
				     {
					obj_t aux_3793;
					{	/* ./Cfa/cinfo.scm 1195 */
					   object_bglt aux_3794;
					   aux_3794 =
					      (object_bglt) (node_2982);
					   aux_3793 =
					      OBJECT_WIDENING(aux_3794);
					}
					aux_3792 =
					   (((conditional_cinfo_212_bglt) CREF(aux_3793))->approx);
				     }
				     aux_3639 =
					(obj_t) (aux_3792);
				  }
			       }
			    }
			    break;
			 case ((long) 11):

			    {	/* Cfa/cfa.scm 182 */
			       fail_cinfo_75_bglt node_2991;
			       node_2991 =
				  (fail_cinfo_75_bglt) (node_1);
			       {	/* Cfa/cfa.scm 183 */
				  approx_bglt arg2419_2993;
				  obj_t arg2420_2994;
				  {	/* Cfa/cfa.scm 183 */
				     node_bglt aux_3800;
				     {	/* Cfa/cfa.scm 183 */
					fail_bglt obj_3474;
					obj_3474 =
					   (fail_bglt) (node_2991);
					aux_3800 =
					   (((fail_bglt) CREF(obj_3474))->proc);
				     }
				     arg2419_2993 =
					cfa__102_cfa_cfa(aux_3800);
				  }
				  arg2420_2994 =
				     CNST_TABLE_REF(((long) 0));
				  loose__226_cfa_loose(arg2419_2993, arg2420_2994);
			       }
			       {	/* Cfa/cfa.scm 184 */
				  approx_bglt arg2422_2996;
				  obj_t arg2423_2997;
				  {	/* Cfa/cfa.scm 184 */
				     node_bglt aux_3806;
				     {	/* Cfa/cfa.scm 184 */
					fail_bglt obj_3475;
					obj_3475 =
					   (fail_bglt) (node_2991);
					aux_3806 =
					   (((fail_bglt) CREF(obj_3475))->msg);
				     }
				     arg2422_2996 =
					cfa__102_cfa_cfa(aux_3806);
				  }
				  arg2423_2997 =
				     CNST_TABLE_REF(((long) 0));
				  loose__226_cfa_loose(arg2422_2996, arg2423_2997);
			       }
			       {	/* Cfa/cfa.scm 185 */
				  approx_bglt arg2425_2999;
				  obj_t arg2426_3000;
				  {	/* Cfa/cfa.scm 185 */
				     node_bglt aux_3812;
				     {	/* Cfa/cfa.scm 185 */
					fail_bglt obj_3476;
					obj_3476 =
					   (fail_bglt) (node_2991);
					aux_3812 =
					   (((fail_bglt) CREF(obj_3476))->obj);
				     }
				     arg2425_2999 =
					cfa__102_cfa_cfa(aux_3812);
				  }
				  arg2426_3000 =
				     CNST_TABLE_REF(((long) 0));
				  loose__226_cfa_loose(arg2425_2999, arg2426_3000);
			       }
			       {	/* ./Cfa/cinfo.scm 1196 */
				  approx_bglt aux_3818;
				  {
				     obj_t aux_3819;
				     {	/* ./Cfa/cinfo.scm 1196 */
					object_bglt aux_3820;
					aux_3820 =
					   (object_bglt) (node_2991);
					aux_3819 =
					   OBJECT_WIDENING(aux_3820);
				     }
				     aux_3818 =
					(((fail_cinfo_75_bglt) CREF(aux_3819))->approx);
				  }
				  aux_3639 =
				     (obj_t) (aux_3818);
			       }
			    }
			    break;
			 case ((long) 12):

			    {	/* Cfa/cfa.scm 192 */
			       select_cinfo_150_bglt node_3002;
			       node_3002 =
				  (select_cinfo_150_bglt) (node_1);
			       {	/* Cfa/cfa.scm 193 */
				  node_bglt aux_3826;
				  {	/* Cfa/cfa.scm 193 */
				     select_bglt obj_3478;
				     obj_3478 =
					(select_bglt) (node_3002);
				     aux_3826 =
					(((select_bglt) CREF(obj_3478))->test);
				  }
				  cfa__102_cfa_cfa(aux_3826);
			       }
			       {	/* Cfa/cfa.scm 194 */
				  approx_bglt res_approx_73_3005;
				  {
				     obj_t aux_3830;
				     {	/* ./Cfa/cinfo.scm 1197 */
					object_bglt aux_3831;
					aux_3831 =
					   (object_bglt) (node_3002);
					aux_3830 =
					   OBJECT_WIDENING(aux_3831);
				     }
				     res_approx_73_3005 =
					(((select_cinfo_150_bglt) CREF(aux_3830))->approx);
				  }
				  {
				     obj_t cls_3006;
				     {	/* Cfa/cfa.scm 195 */
					approx_bglt aux_3835;
					{	/* Cfa/cfa.scm 195 */
					   select_bglt obj_3480;
					   obj_3480 =
					      (select_bglt) (node_3002);
					   cls_3006 =
					      (((select_bglt) CREF(obj_3480))->clauses);
					}
				      loop_3007:
					if (
					   NULLP(cls_3006))
					  {	/* Cfa/cfa.scm 196 */
					     aux_3835 = res_approx_73_3005
						;
					  }
					else
					  {	/* Cfa/cfa.scm 198 */
					     approx_bglt new_approx_178_3010;
					     {	/* Cfa/cfa.scm 198 */
						node_bglt aux_3838;
						{	/* Cfa/cfa.scm 198 */
						   obj_t aux_3839;
						   {	/* ./Ieee/pair-list.scm 5707 */
						      obj_t aux_3840;
						      aux_3840 =
							 CAR(cls_3006);
						      aux_3839 =
							 CDR(aux_3840);
						   }
						   aux_3838 =
						      (node_bglt) (aux_3839);
						}
						new_approx_178_3010 =
						   cfa__102_cfa_cfa(aux_3838);
					     }
					     union_approx__241_cfa_approx(res_approx_73_3005, new_approx_178_3010);
					     {
						obj_t cls_3846;
						cls_3846 =
						   CDR(cls_3006);
						cls_3006 = cls_3846;
						goto loop_3007;
					     }
					  }
					aux_3639 =
					   (obj_t) (aux_3835);
				     }
				  }
			       }
			    }
			    break;
			 case ((long) 13):

			    {	/* Cfa/cfa.scm 206 */
			       let_fun_218_bglt node_3014;
			       node_3014 =
				  (let_fun_218_bglt) (node_1);
			       {	/* Cfa/cfa.scm 207 */
				  approx_bglt aux_3852;
				  aux_3852 =
				     cfa__102_cfa_cfa(
				     (((let_fun_218_bglt) CREF(node_3014))->body));
				  aux_3639 =
				     (obj_t) (aux_3852);
			       }
			    }
			    break;
			 case ((long) 14):

			    {	/* Cfa/cfa.scm 213 */
			       let_var_6_bglt node_3017;
			       node_3017 =
				  (let_var_6_bglt) (node_1);
			       {
				  obj_t l2052_3019;
				  l2052_3019 =
				     (((let_var_6_bglt) CREF(node_3017))->bindings);
				lname2053_3020:
				  if (
				     PAIRP(l2052_3019))
				    {	/* Cfa/cfa.scm 215 */
				       {	/* Cfa/cfa.scm 216 */
					  obj_t binding_3023;
					  binding_3023 =
					     CAR(l2052_3019);
					  {	/* Cfa/cfa.scm 216 */
					     obj_t var_3024;
					     var_3024 =
						CAR(binding_3023);
					     {	/* Cfa/cfa.scm 216 */
						approx_bglt var_approx_58_3025;
						{	/* Cfa/cfa.scm 217 */
						   svar_cinfo_166_bglt obj_3491;
						   {	/* Cfa/cfa.scm 217 */
						      value_bglt aux_3861;
						      {		/* Cfa/cfa.scm 217 */
							 variable_bglt obj_3490;
							 obj_3490 =
							    (variable_bglt) (var_3024);
							 aux_3861 =
							    (((variable_bglt) CREF(obj_3490))->value);
						      }
						      obj_3491 =
							 (svar_cinfo_166_bglt) (aux_3861);
						   }
						   {
						      obj_t aux_3865;
						      {		/* ./Cfa/cinfo.scm 1168 */
							 object_bglt aux_3866;
							 aux_3866 =
							    (object_bglt) (obj_3491);
							 aux_3865 =
							    OBJECT_WIDENING(aux_3866);
						      }
						      var_approx_58_3025 =
							 (((svar_cinfo_166_bglt) CREF(aux_3865))->approx);
						   }
						}
						{	/* Cfa/cfa.scm 217 */
						   approx_bglt val_approx_22_3026;
						   {	/* Cfa/cfa.scm 218 */
						      node_bglt aux_3870;
						      {		/* Cfa/cfa.scm 218 */
							 obj_t aux_3871;
							 aux_3871 =
							    CDR(binding_3023);
							 aux_3870 =
							    (node_bglt) (aux_3871);
						      }
						      val_approx_22_3026 =
							 cfa__102_cfa_cfa(aux_3870);
						   }
						   {	/* Cfa/cfa.scm 218 */

						      {		/* Cfa/cfa.scm 219 */
							 type_bglt vtype_3027;
							 type_bglt atype_3028;
							 {	/* Cfa/cfa.scm 219 */
							    variable_bglt obj_3493;
							    obj_3493 =
							       (variable_bglt) (var_3024);
							    vtype_3027 =
							       (((variable_bglt) CREF(obj_3493))->type);
							 }
							 atype_3028 =
							    (((approx_bglt) CREF(val_approx_22_3026))->type);
							 union_approx__241_cfa_approx(var_approx_58_3025, val_approx_22_3026);
							 {	/* Cfa/cfa.scm 230 */
							    bool_t test2437_3029;
							    {	/* Cfa/cfa.scm 230 */
							       bool_t test2438_3030;
							       {	/* Cfa/cfa.scm 230 */
								  obj_t obj2_3496;
								  obj2_3496 = ____74_type_cache;
								  {	/* ./Ieee/equiv.scm 5508 */
								     obj_t aux_3879;
								     aux_3879 =
									(obj_t) (vtype_3027);
								     test2438_3030 =
									(aux_3879 == obj2_3496);
								  }
							       }
							       if (test2438_3030)
								 {	/* Cfa/cfa.scm 230 */
								    test2437_3029 = ((bool_t) 0);
								 }
							       else
								 {	/* Cfa/cfa.scm 231 */
								    bool_t test2439_3031;
								    {	/* Cfa/cfa.scm 231 */
								       obj_t obj2_3498;
								       obj2_3498 = _obj__252_type_cache;
								       {	/* ./Ieee/equiv.scm 5508 */
									  obj_t aux_3883;
									  aux_3883 =
									     (obj_t) (vtype_3027);
									  test2439_3031 =
									     (aux_3883 == obj2_3498);
								       }
								    }
								    if (test2439_3031)
								      {		/* Cfa/cfa.scm 231 */
									 test2437_3029 = ((bool_t) 0);
								      }
								    else
								      {		/* Cfa/cfa.scm 232 */
									 bool_t test2440_3032;
									 {	/* Cfa/cfa.scm 232 */
									    obj_t obj2_3500;
									    obj2_3500 = ____74_type_cache;
									    {	/* ./Ieee/equiv.scm 5508 */
									       obj_t aux_3887;
									       aux_3887 =
										  (obj_t) (atype_3028);
									       test2440_3032 =
										  (aux_3887 == obj2_3500);
									    }
									 }
									 if (test2440_3032)
									   {	/* Cfa/cfa.scm 232 */
									      test2437_3029 = ((bool_t) 0);
									   }
									 else
									   {	/* Cfa/cfa.scm 233 */
									      bool_t test_3891;
									      {		/* ./Ieee/equiv.scm 5508 */
										 obj_t aux_3894;
										 obj_t aux_3892;
										 aux_3894 =
										    (obj_t) (vtype_3027);
										 aux_3892 =
										    (obj_t) (atype_3028);
										 test_3891 =
										    (aux_3892 == aux_3894);
									      }
									      if (test_3891)
										{	/* Cfa/cfa.scm 233 */
										   test2437_3029 = ((bool_t) 0);
										}
									      else
										{	/* Cfa/cfa.scm 233 */
										   test2437_3029 = ((bool_t) 1);
										}
									   }
								      }
								 }
							    }
							    if (test2437_3029)
							      {		/* Cfa/cfa.scm 230 */
								 approx_set_top__187_cfa_approx(val_approx_22_3026);
								 {	/* Cfa/cfa.scm 236 */
								    approx_bglt aux_3899;
								    aux_3899 =
								       loose__226_cfa_loose(val_approx_22_3026,
								       CNST_TABLE_REF(((long) 0)));
								    (obj_t) (aux_3899);
								 }
							      }
							    else
							      {		/* Cfa/cfa.scm 230 */
								 BUNSPEC;
							      }
							 }
						      }
						   }
						}
					     }
					  }
				       }
				       {
					  obj_t l2052_3903;
					  l2052_3903 =
					     CDR(l2052_3019);
					  l2052_3019 = l2052_3903;
					  goto lname2053_3020;
				       }
				    }
				  else
				    {	/* Cfa/cfa.scm 215 */
				       ((bool_t) 1);
				    }
			       }
			       {	/* Cfa/cfa.scm 238 */
				  approx_bglt aux_3906;
				  aux_3906 =
				     cfa__102_cfa_cfa(
				     (((let_var_6_bglt) CREF(node_3017))->body));
				  aux_3639 =
				     (obj_t) (aux_3906);
			       }
			    }
			    break;
			 case ((long) 15):

			    {	/* Cfa/cfa.scm 244 */
			       set_ex_it_cinfo_168_bglt node_3038;
			       node_3038 =
				  (set_ex_it_cinfo_168_bglt) (node_1);
			       {	/* Cfa/cfa.scm 245 */
				  approx_bglt arg2446_3040;
				  obj_t arg2447_3041;
				  {	/* Cfa/cfa.scm 245 */
				     node_bglt aux_3911;
				     {	/* Cfa/cfa.scm 245 */
					set_ex_it_116_bglt obj_3505;
					obj_3505 =
					   (set_ex_it_116_bglt) (node_3038);
					aux_3911 =
					   (((set_ex_it_116_bglt) CREF(obj_3505))->body);
				     }
				     arg2446_3040 =
					cfa__102_cfa_cfa(aux_3911);
				  }
				  arg2447_3041 =
				     CNST_TABLE_REF(((long) 0));
				  loose__226_cfa_loose(arg2446_3040, arg2447_3041);
			       }
			       {	/* ./Cfa/cinfo.scm 1198 */
				  approx_bglt aux_3917;
				  {
				     obj_t aux_3918;
				     {	/* ./Cfa/cinfo.scm 1198 */
					object_bglt aux_3919;
					aux_3919 =
					   (object_bglt) (node_3038);
					aux_3918 =
					   OBJECT_WIDENING(aux_3919);
				     }
				     aux_3917 =
					(((set_ex_it_cinfo_168_bglt) CREF(aux_3918))->approx);
				  }
				  aux_3639 =
				     (obj_t) (aux_3917);
			       }
			    }
			    break;
			 case ((long) 16):

			    {	/* Cfa/cfa.scm 252 */
			       jump_ex_it_cinfo_139_bglt node_3043;
			       node_3043 =
				  (jump_ex_it_cinfo_139_bglt) (node_1);
			       {	/* Cfa/cfa.scm 253 */
				  node_bglt aux_3925;
				  {	/* Cfa/cfa.scm 253 */
				     jump_ex_it_184_bglt obj_3507;
				     obj_3507 =
					(jump_ex_it_184_bglt) (node_3043);
				     aux_3925 =
					(((jump_ex_it_184_bglt) CREF(obj_3507))->exit);
				  }
				  cfa__102_cfa_cfa(aux_3925);
			       }
			       {	/* Cfa/cfa.scm 254 */
				  approx_bglt val_approx_22_3046;
				  {	/* Cfa/cfa.scm 254 */
				     node_bglt aux_3929;
				     {	/* Cfa/cfa.scm 254 */
					jump_ex_it_184_bglt obj_3508;
					obj_3508 =
					   (jump_ex_it_184_bglt) (node_3043);
					aux_3929 =
					   (((jump_ex_it_184_bglt) CREF(obj_3508))->value);
				     }
				     val_approx_22_3046 =
					cfa__102_cfa_cfa(aux_3929);
				  }
				  loose__226_cfa_loose(val_approx_22_3046,
				     CNST_TABLE_REF(((long) 0)));
				  {	/* ./Cfa/cinfo.scm 1199 */
				     approx_bglt aux_3935;
				     {
					obj_t aux_3936;
					{	/* ./Cfa/cinfo.scm 1199 */
					   object_bglt aux_3937;
					   aux_3937 =
					      (object_bglt) (node_3043);
					   aux_3936 =
					      OBJECT_WIDENING(aux_3937);
					}
					aux_3935 =
					   (((jump_ex_it_cinfo_139_bglt) CREF(aux_3936))->approx);
				     }
				     aux_3639 =
					(obj_t) (aux_3935);
				  }
			       }
			    }
			    break;
			 case ((long) 17):

			    {	/* Cfa/cfa.scm 262 */
			       make_box_cinfo_127_bglt node_3048;
			       node_3048 =
				  (make_box_cinfo_127_bglt) (node_1);
			       {	/* Cfa/cfa.scm 264 */
				  approx_bglt arg2451_3050;
				  obj_t arg2452_3051;
				  {	/* Cfa/cfa.scm 264 */
				     node_bglt aux_3943;
				     {	/* Cfa/cfa.scm 264 */
					make_box_202_bglt obj_3510;
					obj_3510 =
					   (make_box_202_bglt) (node_3048);
					aux_3943 =
					   (((make_box_202_bglt) CREF(obj_3510))->value);
				     }
				     arg2451_3050 =
					cfa__102_cfa_cfa(aux_3943);
				  }
				  arg2452_3051 =
				     CNST_TABLE_REF(((long) 0));
				  loose__226_cfa_loose(arg2451_3050, arg2452_3051);
			       }
			       {	/* ./Cfa/cinfo.scm 1203 */
				  approx_bglt aux_3949;
				  {
				     obj_t aux_3950;
				     {	/* ./Cfa/cinfo.scm 1203 */
					object_bglt aux_3951;
					aux_3951 =
					   (object_bglt) (node_3048);
					aux_3950 =
					   OBJECT_WIDENING(aux_3951);
				     }
				     aux_3949 =
					(((make_box_cinfo_127_bglt) CREF(aux_3950))->approx);
				  }
				  aux_3639 =
				     (obj_t) (aux_3949);
			       }
			    }
			    break;
			 case ((long) 18):

			    {	/* Cfa/cfa.scm 271 */
			       box_set__cinfo_94_bglt node_3053;
			       node_3053 =
				  (box_set__cinfo_94_bglt) (node_1);
			       {	/* Cfa/cfa.scm 272 */
				  node_bglt aux_3957;
				  {	/* Cfa/cfa.scm 272 */
				     var_bglt aux_3958;
				     {	/* Cfa/cfa.scm 272 */
					box_set__221_bglt obj_3512;
					obj_3512 =
					   (box_set__221_bglt) (node_3053);
					aux_3958 =
					   (((box_set__221_bglt) CREF(obj_3512))->var);
				     }
				     aux_3957 =
					(node_bglt) (aux_3958);
				  }
				  cfa__102_cfa_cfa(aux_3957);
			       }
			       {	/* Cfa/cfa.scm 273 */
				  approx_bglt arg2455_3056;
				  obj_t arg2456_3057;
				  {	/* Cfa/cfa.scm 273 */
				     node_bglt aux_3963;
				     {	/* Cfa/cfa.scm 273 */
					box_set__221_bglt obj_3513;
					obj_3513 =
					   (box_set__221_bglt) (node_3053);
					aux_3963 =
					   (((box_set__221_bglt) CREF(obj_3513))->value);
				     }
				     arg2455_3056 =
					cfa__102_cfa_cfa(aux_3963);
				  }
				  arg2456_3057 =
				     CNST_TABLE_REF(((long) 0));
				  loose__226_cfa_loose(arg2455_3056, arg2456_3057);
			       }
			       {	/* ./Cfa/cinfo.scm 1207 */
				  approx_bglt aux_3969;
				  {
				     obj_t aux_3970;
				     {	/* ./Cfa/cinfo.scm 1207 */
					object_bglt aux_3971;
					aux_3971 =
					   (object_bglt) (node_3053);
					aux_3970 =
					   OBJECT_WIDENING(aux_3971);
				     }
				     aux_3969 =
					(((box_set__cinfo_94_bglt) CREF(aux_3970))->approx);
				  }
				  aux_3639 =
				     (obj_t) (aux_3969);
			       }
			    }
			    break;
			 case ((long) 19):

			    {	/* Cfa/cfa.scm 280 */
			       box_ref_cinfo_214_bglt node_3059;
			       node_3059 =
				  (box_ref_cinfo_214_bglt) (node_1);
			       {	/* Cfa/cfa.scm 281 */
				  node_bglt aux_3977;
				  {	/* Cfa/cfa.scm 281 */
				     var_bglt aux_3978;
				     {	/* Cfa/cfa.scm 281 */
					box_ref_242_bglt obj_3515;
					obj_3515 =
					   (box_ref_242_bglt) (node_3059);
					aux_3978 =
					   (((box_ref_242_bglt) CREF(obj_3515))->var);
				     }
				     aux_3977 =
					(node_bglt) (aux_3978);
				  }
				  cfa__102_cfa_cfa(aux_3977);
			       }
			       {	/* ./Cfa/cinfo.scm 1208 */
				  approx_bglt aux_3983;
				  {
				     obj_t aux_3984;
				     {	/* ./Cfa/cinfo.scm 1208 */
					object_bglt aux_3985;
					aux_3985 =
					   (object_bglt) (node_3059);
					aux_3984 =
					   OBJECT_WIDENING(aux_3985);
				     }
				     aux_3983 =
					(((box_ref_cinfo_214_bglt) CREF(aux_3984))->approx);
				  }
				  aux_3639 =
				     (obj_t) (aux_3983);
			       }
			    }
			    break;
			 default:
			  case_else2381_2924:
			    if (
			       PROCEDUREP(method2375_2920))
			      {		/* Cfa/cfa.scm 34 */
				 aux_3639 =
				    PROCEDURE_ENTRY(method2375_2920) (method2375_2920,
				    (obj_t) (node_1), BEOA)
				    ;
			      }
			    else
			      {		/* Cfa/cfa.scm 34 */
				 obj_t fun2354_2884;
				 fun2354_2884 =
				    PROCEDURE_REF(cfa__env_153_cfa_cfa, ((long) 0));
				 aux_3639 =
				    PROCEDURE_ENTRY(fun2354_2884) (fun2354_2884,
				    (obj_t) (node_1), BEOA);
			      }
			 }
		    }
		  else
		    {	/* Cfa/cfa.scm 34 */
		       goto case_else2381_2924;
		    }
	       }
	       return
		  (approx_bglt) (aux_3639);
	    }
	 }
      }
   }
}



/* _cfa! */
obj_t 
_cfa__186_cfa_cfa(obj_t env_3557, obj_t node_3558)
{
   AN_OBJECT;
   {	/* Cfa/cfa.scm 34 */
      {		/* Cfa/cfa.scm 34 */
	 approx_bglt aux_4002;
	 aux_4002 =
	    cfa__102_cfa_cfa(
	    (node_bglt) (node_3558));
	 return
	    (obj_t) (aux_4002);
      }
   }
}



/* cfa!-default2059 */
approx_bglt 
cfa__default2059_241_cfa_cfa(node_bglt node_2)
{
   AN_OBJECT;
   {	/* Cfa/cfa.scm 14 */
      {		/* Cfa/cfa.scm 35 */
	 obj_t arg2356_3520;
	 arg2356_3520 =
	    shape_tools_shape(
	    (obj_t) (node_2));
	 {	/* Cfa/cfa.scm 35 */
	    obj_t aux_4008;
	    aux_4008 =
	       internal_error_43_tools_error(string2468_cfa_cfa,
	       (obj_t) (node_2), arg2356_3520);
	    return
	       (approx_bglt) (aux_4008);
	 }
      }
   }
}



/* _cfa!-default2059 */
obj_t 
_cfa__default2059_140_cfa_cfa(obj_t env_3559, obj_t node_3560)
{
   AN_OBJECT;
   {	/* Cfa/cfa.scm 14 */
      {		/* Cfa/cfa.scm 14 */
	 approx_bglt aux_4012;
	 aux_4012 =
	    cfa__default2059_241_cfa_cfa(
	    (node_bglt) (node_3560));
	 return
	    (obj_t) (aux_4012);
      }
   }
}



/* cfa-variable-value-approx */
obj_t 
cfa_variable_value_approx_39_cfa_cfa(value_bglt value_8)
{
   AN_OBJECT;
   {	/* Cfa/cfa.scm 76 */
      {
	 obj_t method2358_2891;
	 obj_t class2363_2892;
	 {	/* Cfa/cfa.scm 76 */
	    obj_t arg2366_2889;
	    obj_t arg2367_2890;
	    {	/* Cfa/cfa.scm 76 */
	       object_bglt obj_3521;
	       obj_3521 =
		  (object_bglt) (value_8);
	       {	/* ./Llib/object.scm 2926 */
		  obj_t pre_method_105_3522;
		  pre_method_105_3522 =
		     PROCEDURE_REF(cfa_variable_value_approx_env_230_cfa_cfa, ((long) 2));
		  if (
		     INTEGERP(pre_method_105_3522))
		    {	/* ./Llib/object.scm 2927 */
		       PROCEDURE_SET(cfa_variable_value_approx_env_230_cfa_cfa, ((long) 2), BUNSPEC);
		       arg2366_2889 = pre_method_105_3522;
		    }
		  else
		    {	/* ./Llib/object.scm 2914 */
		       long obj_class_num_177_3527;
		       obj_class_num_177_3527 =
			  TYPE(obj_3521);
		       {	/* ./Llib/object.scm 2915 */
			  obj_t arg1176_3528;
			  arg1176_3528 =
			     PROCEDURE_REF(cfa_variable_value_approx_env_230_cfa_cfa, ((long) 1));
			  {	/* ./Llib/object.scm 2738 */
			     long arg1177_3532;
			     {	/* ./Llib/object.scm 2738 */
				long arg1178_3533;
				arg1178_3533 =
				   OBJECT_TYPE;
				arg1177_3532 =
				   (obj_class_num_177_3527 - arg1178_3533);
			     }
			     arg2366_2889 =
				VECTOR_REF(arg1176_3528, arg1177_3532);
			  }
		       }
		    }
	       }
	    }
	    {	/* Cfa/cfa.scm 76 */
	       object_bglt object_3538;
	       object_3538 =
		  (object_bglt) (value_8);
	       {	/* ./Llib/object.scm 2695 */
		  long arg1179_3539;
		  {	/* ./Llib/object.scm 2695 */
		     long arg1180_3540;
		     long arg1181_3541;
		     arg1180_3540 =
			TYPE(object_3538);
		     arg1181_3541 =
			OBJECT_TYPE;
		     arg1179_3539 =
			(arg1180_3540 - arg1181_3541);
		  }
		  {	/* ./Llib/object.scm 2695 */
		     obj_t vector_3545;
		     vector_3545 = _classes__134___object;
		     arg2367_2890 =
			VECTOR_REF(vector_3545, arg1179_3539);
		  }
	       }
	    }
	    method2358_2891 = arg2366_2889;
	    class2363_2892 = arg2367_2890;
	    {

	       if (
		  INTEGERP(method2358_2891))
		 {	/* Cfa/cfa.scm 76 */
		    switch (
		       (long) CINT(method2358_2891))
		      {
		      case ((long) 0):

			 {	/* Cfa/cfa.scm 82 */
			    svar_cinfo_166_bglt value_2898;
			    value_2898 =
			       (svar_cinfo_166_bglt) (value_8);
			    {	/* ./Cfa/cinfo.scm 1168 */
			       approx_bglt aux_4034;
			       {
				  obj_t aux_4035;
				  {	/* ./Cfa/cinfo.scm 1168 */
				     object_bglt aux_4036;
				     aux_4036 =
					(object_bglt) (value_2898);
				     aux_4035 =
					OBJECT_WIDENING(aux_4036);
				  }
				  aux_4034 =
				     (((svar_cinfo_166_bglt) CREF(aux_4035))->approx);
			       }
			       return
				  (obj_t) (aux_4034);
			    }
			 }
			 break;
		      case ((long) 1):

			 {	/* Cfa/cfa.scm 89 */
			    scnst_cinfo_0_bglt value_2900;
			    value_2900 =
			       (scnst_cinfo_0_bglt) (value_8);
			    {	/* ./Cfa/cinfo.scm 1163 */
			       approx_bglt aux_4042;
			       {
				  obj_t aux_4043;
				  {	/* ./Cfa/cinfo.scm 1163 */
				     object_bglt aux_4044;
				     aux_4044 =
					(object_bglt) (value_2900);
				     aux_4043 =
					OBJECT_WIDENING(aux_4044);
				  }
				  aux_4042 =
				     (((scnst_cinfo_0_bglt) CREF(aux_4043))->approx);
			       }
			       return
				  (obj_t) (aux_4042);
			    }
			 }
			 break;
		      case ((long) 2):

			 {	/* Cfa/cfa.scm 96 */
			    cvar_cinfo_53_bglt value_2902;
			    value_2902 =
			       (cvar_cinfo_53_bglt) (value_8);
			    {	/* ./Cfa/cinfo.scm 1173 */
			       approx_bglt aux_4050;
			       {
				  obj_t aux_4051;
				  {	/* ./Cfa/cinfo.scm 1173 */
				     object_bglt aux_4052;
				     aux_4052 =
					(object_bglt) (value_2902);
				     aux_4051 =
					OBJECT_WIDENING(aux_4052);
				  }
				  aux_4050 =
				     (((cvar_cinfo_53_bglt) CREF(aux_4051))->approx);
			       }
			       return
				  (obj_t) (aux_4050);
			    }
			 }
			 break;
		      case ((long) 3):

			 {	/* Cfa/cfa.scm 103 */
			    sexit_cinfo_49_bglt value_2904;
			    value_2904 =
			       (sexit_cinfo_49_bglt) (value_8);
			    {	/* ./Cfa/cinfo.scm 1176 */
			       approx_bglt aux_4058;
			       {
				  obj_t aux_4059;
				  {	/* ./Cfa/cinfo.scm 1176 */
				     object_bglt aux_4060;
				     aux_4060 =
					(object_bglt) (value_2904);
				     aux_4059 =
					OBJECT_WIDENING(aux_4060);
				  }
				  aux_4058 =
				     (((sexit_cinfo_49_bglt) CREF(aux_4059))->approx);
			       }
			       return
				  (obj_t) (aux_4058);
			    }
			 }
			 break;
		      case ((long) 4):

			 {	/* Cfa/cfa.scm 114 */
			    intern_sfun_cinfo_192_bglt value_2906;
			    value_2906 =
			       (intern_sfun_cinfo_192_bglt) (value_8);
			    {	/* ./Cfa/cinfo.scm 1159 */
			       approx_bglt aux_4066;
			       {
				  obj_t aux_4067;
				  {	/* ./Cfa/cinfo.scm 1159 */
				     object_bglt aux_4068;
				     aux_4068 =
					(object_bglt) (value_2906);
				     aux_4067 =
					OBJECT_WIDENING(aux_4068);
				  }
				  aux_4066 =
				     (((intern_sfun_cinfo_192_bglt) CREF(aux_4067))->approx);
			       }
			       return
				  (obj_t) (aux_4066);
			    }
			 }
			 break;
		      default:
		       case_else2364_2895:
			 if (
			    PROCEDUREP(method2358_2891))
			   {	/* Cfa/cfa.scm 76 */
			      return
				 PROCEDURE_ENTRY(method2358_2891) (method2358_2891,
				 (obj_t) (value_8), BEOA);
			   }
			 else
			   {	/* Cfa/cfa.scm 76 */
			      obj_t fun2357_2887;
			      fun2357_2887 =
				 PROCEDURE_REF(cfa_variable_value_approx_env_230_cfa_cfa, ((long) 0));
			      return
				 PROCEDURE_ENTRY(fun2357_2887) (fun2357_2887,
				 (obj_t) (value_8), BEOA);
			   }
		      }
		 }
	       else
		 {	/* Cfa/cfa.scm 76 */
		    goto case_else2364_2895;
		 }
	    }
	 }
      }
   }
}



/* _cfa-variable-value-approx */
obj_t 
_cfa_variable_value_approx_165_cfa_cfa(obj_t env_3561, obj_t value_3562)
{
   AN_OBJECT;
   {	/* Cfa/cfa.scm 76 */
      return
	 cfa_variable_value_approx_39_cfa_cfa(
	 (value_bglt) (value_3562));
   }
}



/* cfa-variable-value-approx-default2071 */
obj_t 
cfa_variable_value_approx_default2071_70_cfa_cfa(value_bglt value_9)
{
   AN_OBJECT;
   {	/* Cfa/cfa.scm 14 */
      FAILURE(
	 CNST_TABLE_REF(((long) 1)), string2469_cfa_cfa,
	 (obj_t) (value_9));
   }
}



/* _cfa-variable-value-approx-default2071 */
obj_t 
_cfa_variable_value_approx_default2071_57_cfa_cfa(obj_t env_3563, obj_t value_3564)
{
   AN_OBJECT;
   {	/* Cfa/cfa.scm 14 */
      return
	 cfa_variable_value_approx_default2071_70_cfa_cfa(
	 (value_bglt) (value_3564));
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_cfa_cfa()
{
   AN_OBJECT;
   {	/* Cfa/cfa.scm 14 */
      module_initialization_70_tools_trace(((long) 0), "CFA_CFA");
      module_initialization_70_tools_shape(((long) 0), "CFA_CFA");
      module_initialization_70_tools_error(((long) 0), "CFA_CFA");
      module_initialization_70_type_type(((long) 0), "CFA_CFA");
      module_initialization_70_type_cache(((long) 0), "CFA_CFA");
      module_initialization_70_ast_var(((long) 0), "CFA_CFA");
      module_initialization_70_ast_node(((long) 0), "CFA_CFA");
      module_initialization_70_cfa_info(((long) 0), "CFA_CFA");
      module_initialization_70_cfa_info2(((long) 0), "CFA_CFA");
      module_initialization_70_cfa_loose(((long) 0), "CFA_CFA");
      module_initialization_70_cfa_approx(((long) 0), "CFA_CFA");
      module_initialization_70_cfa_app(((long) 0), "CFA_CFA");
      return
	 module_initialization_70_cfa_funcall(((long) 0), "CFA_CFA");
   }
}
