/*===========================================================================*/
/*   (Cfa/closure.scm)                                                       */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;

typedef struct approx
  {
     header_t header;
     obj_t widening;
     struct type *type;
     bool_t type_locked__184;
     obj_t allocs;
     bool_t top__138;
     long lost_stamp_114;
  }
      *approx_bglt;

typedef struct cfun_cinfo_200
  {
     struct approx *approx;
  }
              *cfun_cinfo_200_bglt;

typedef struct extern_sfun_cinfo_6
  {
     struct approx *approx;
  }
                   *extern_sfun_cinfo_6_bglt;

typedef struct intern_sfun_cinfo_192
  {
     struct approx *approx;
     long stamp;
  }
                     *intern_sfun_cinfo_192_bglt;

typedef struct scnst_cinfo_0
  {
     struct approx *approx;
  }
             *scnst_cinfo_0_bglt;

typedef struct pre_clo_env_191
  {
     char dummy;
  }
               *pre_clo_env_191_bglt;

typedef struct svar_cinfo_166
  {
     struct approx *approx;
     bool_t clo_env__87;
  }
              *svar_cinfo_166_bglt;

typedef struct cvar_cinfo_53
  {
     struct approx *approx;
  }
             *cvar_cinfo_53_bglt;

typedef struct sexit_cinfo_49
  {
     struct approx *approx;
  }
              *sexit_cinfo_49_bglt;

typedef struct reshaped_local_224
  {
     obj_t binding_value_3;
  }
                  *reshaped_local_224_bglt;

typedef struct reshaped_global_160
  {
     char dummy;
  }
                   *reshaped_global_160_bglt;

typedef struct atom_cinfo_155
  {
     struct approx *approx;
  }
              *atom_cinfo_155_bglt;

typedef struct kwote_node_102
  {
     struct node *node;
  }
              *kwote_node_102_bglt;

typedef struct kwote_cinfo_48
  {
     struct approx *approx;
  }
              *kwote_cinfo_48_bglt;

typedef struct app_ly_cinfo_234
  {
     struct approx *approx;
  }
                *app_ly_cinfo_234_bglt;

typedef struct funcall_cinfo_75
  {
     struct approx *approx;
     struct approx *va_approx_63;
     bool_t arity_error_noticed__118;
     bool_t type_error_noticed__36;
  }
                *funcall_cinfo_75_bglt;

typedef struct pragma_cinfo_220
  {
     struct approx *approx;
  }
                *pragma_cinfo_220_bglt;

typedef struct setq_cinfo_191
  {
     struct approx *approx;
  }
              *setq_cinfo_191_bglt;

typedef struct conditional_cinfo_212
  {
     struct approx *approx;
  }
                     *conditional_cinfo_212_bglt;

typedef struct fail_cinfo_75
  {
     struct approx *approx;
  }
             *fail_cinfo_75_bglt;

typedef struct select_cinfo_150
  {
     struct approx *approx;
  }
                *select_cinfo_150_bglt;

typedef struct set_ex_it_cinfo_168
  {
     struct approx *approx;
  }
                   *set_ex_it_cinfo_168_bglt;

typedef struct jump_ex_it_cinfo_139
  {
     struct approx *approx;
  }
                    *jump_ex_it_cinfo_139_bglt;

typedef struct pre_make_box_186
  {
     char dummy;
  }
                *pre_make_box_186_bglt;

typedef struct make_box_cinfo_127
  {
     struct approx *approx;
  }
                  *make_box_cinfo_127_bglt;

typedef struct make_box_o_cinfo_96
  {
     struct approx *approx;
     struct approx *value_approx_19;
  }
                   *make_box_o_cinfo_96_bglt;

typedef struct box_set__cinfo_94
  {
     struct approx *approx;
  }
                 *box_set__cinfo_94_bglt;

typedef struct box_ref_cinfo_214
  {
     struct approx *approx;
  }
                 *box_ref_cinfo_214_bglt;

typedef struct box_set__o_cinfo_6
  {
     struct approx *approx;
  }
                  *box_set__o_cinfo_6_bglt;

typedef struct box_ref_o_cinfo_98
  {
     struct approx *approx;
  }
                  *box_ref_o_cinfo_98_bglt;

typedef struct pre_make_procedure_app_60
  {
     struct variable *owner;
  }
                         *pre_make_procedure_app_60_bglt;

typedef struct pre_procedure_ref_app_85
  {
     char dummy;
  }
                        *pre_procedure_ref_app_85_bglt;

typedef struct pre_procedure_set__app_208
  {
     char dummy;
  }
                          *pre_procedure_set__app_208_bglt;

typedef struct make_procedure_app_48
  {
     struct approx *approx;
     long values_approx_len_106;
     struct approx **values_approx_79;
     long lost_stamp_114;
     bool_t x_t__142;
     bool_t x;
     bool_t t;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
  }
                     *make_procedure_app_48_bglt;

typedef struct procedure_ref_app_49
  {
     struct approx *approx;
  }
                    *procedure_ref_app_49_bglt;

typedef struct procedure_set__app_32
  {
     struct approx *approx;
  }
                     *procedure_set__app_32_bglt;

typedef struct pre_make_vector_app_251
  {
     struct variable *owner;
  }
                       *pre_make_vector_app_251_bglt;

typedef struct pre_create_vector_app_162
  {
     struct variable *owner;
  }
                         *pre_create_vector_app_162_bglt;

typedef struct pre_vector_ref_app_208
  {
     char dummy;
  }
                      *pre_vector_ref_app_208_bglt;

typedef struct pre_vector_set__app_211
  {
     char dummy;
  }
                       *pre_vector_set__app_211_bglt;

typedef struct make_vector_app_205
  {
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
     bool_t seen__39;
  }
                   *make_vector_app_205_bglt;

typedef struct create_vector_app_150
  {
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
     bool_t seen__39;
  }
                     *create_vector_app_150_bglt;

typedef struct vector_ref_app_195
  {
     struct approx *approx;
  }
                  *vector_ref_app_195_bglt;

typedef struct vector_set__app_21
  {
     struct approx *approx;
  }
                  *vector_set__app_21_bglt;

typedef struct pre_make_struct_app_218
  {
     struct variable *owner;
  }
                       *pre_make_struct_app_218_bglt;

typedef struct pre_struct_ref_app_207
  {
     char dummy;
  }
                      *pre_struct_ref_app_207_bglt;

typedef struct pre_struct_set__app_116
  {
     char dummy;
  }
                       *pre_struct_set__app_116_bglt;

typedef struct make_struct_app_214
  {
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
  }
                   *make_struct_app_214_bglt;

typedef struct struct_ref_app_73
  {
     struct approx *approx;
  }
                 *struct_ref_app_73_bglt;

typedef struct struct_set__app_162
  {
     struct approx *approx;
  }
                   *struct_set__app_162_bglt;


static obj_t method_init_76_cfa_closure();
extern obj_t find_global_module_25_ast_env(obj_t, obj_t);
extern obj_t closure_optimization__75_cfa_closure();
extern obj_t _optim__89_engine_param;
extern obj_t closure_optimization__48_cfa_closure();
static obj_t _make_procedure_list__56_cfa_closure = BUNSPEC;
static bool_t light_funcall__169_cfa_closure();
extern obj_t var_ast_node;
extern obj_t get_node_atom_value_135_cfa_approx(node_bglt);
static obj_t start_cache_11_cfa_closure();
extern obj_t global_ast_var;
static obj_t _procedure_ref__66_cfa_closure = BUNSPEC;
static obj_t _add_procedure_ref_2466_197_cfa_closure(obj_t, obj_t);
extern bool_t stack_optimization__133_cfa_stack();
extern obj_t verbose_tools_speek(obj_t, obj_t);
extern bool_t is_a__118___object(obj_t, obj_t);
static obj_t _procedure_ref_list__19_cfa_closure = BUNSPEC;
extern obj_t module_initialization_70_cfa_closure(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_speek(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_ast_env(long, char *);
extern obj_t module_initialization_70_cfa_info(long, char *);
extern obj_t module_initialization_70_cfa_info2(long, char *);
extern obj_t module_initialization_70_cfa_cfa(long, char *);
extern obj_t module_initialization_70_cfa_approx(long, char *);
extern obj_t module_initialization_70_cfa_set(long, char *);
extern obj_t module_initialization_70_cfa_stack(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t add_procedure_ref__36_cfa_closure(node_bglt);
extern long class_num_218___object(obj_t);
extern obj_t scnst_ast_var;
extern obj_t add_funcall__195_cfa_closure(node_bglt);
static obj_t imported_modules_init_94_cfa_closure();
static obj_t _anonymous_2088__236_cfa_closure(obj_t, obj_t);
static obj_t _anonymous_2083__147_cfa_closure(obj_t, obj_t);
static obj_t _make_l_procedure__54_cfa_closure = BUNSPEC;
static obj_t library_modules_init_112_cfa_closure();
static bool_t light_make_procedure__143_cfa_closure();
static obj_t _add_make_procedure_2465_29_cfa_closure(obj_t, obj_t);
extern approx_bglt cfa__102_cfa_cfa(node_bglt);
extern obj_t for_each_approx_alloc_83_cfa_approx(obj_t, approx_bglt);
extern obj_t set_length_165_cfa_set(obj_t);
static bool_t light_access__52_cfa_closure();
static obj_t toplevel_init_63_cfa_closure();
extern obj_t _unsafe_type__146_engine_param;
static obj_t show_cfa_closure(obj_t, obj_t);
extern obj_t open_input_string(obj_t);
static obj_t _funcall_list__139_cfa_closure = BUNSPEC;
static obj_t _procedure_1_el_ref__37_cfa_closure = BUNSPEC;
static obj_t show_x_t_233_cfa_closure(obj_t);
static obj_t _closure_optimization__187_cfa_closure(obj_t);
static obj_t _closure_optimization__207_cfa_closure(obj_t);
extern obj_t make_procedure_app_48_cfa_info2;
extern obj_t add_make_procedure__219_cfa_closure(node_bglt);
static obj_t _procedure_l_ref__76_cfa_closure = BUNSPEC;
static obj_t _make_el_procedure__202_cfa_closure = BUNSPEC;
extern obj_t shape_tools_shape(obj_t);
static obj_t _procedure_l_set___202_cfa_closure = BUNSPEC;
static obj_t stop_cache_174_cfa_closure();
static bool_t x__157_cfa_closure(obj_t);
extern obj_t _procedure__226_type_cache;
extern node_bglt stack__132_cfa_stack(node_bglt);
static obj_t _procedure_1_el_set___97_cfa_closure = BUNSPEC;
static obj_t _procedure_el_ref__61_cfa_closure = BUNSPEC;
extern obj_t read___reader(obj_t);
static obj_t _add_funcall_2464_39_cfa_closure(obj_t, obj_t);
static obj_t _procedure_el_set___46_cfa_closure = BUNSPEC;
static obj_t require_initialization_114_cfa_closure = BUNSPEC;
static obj_t _procedure_set___197_cfa_closure = BUNSPEC;
static obj_t _make_el_procedure_1__141_cfa_closure = BUNSPEC;
static obj_t t_fix_point__90_cfa_closure(obj_t);
extern obj_t set__list_248_cfa_set(obj_t);
static obj_t cnst_init_137_cfa_closure();
static obj_t __cnst[21];

DEFINE_EXPORT_PROCEDURE(closure_optimization__env_164_cfa_closure, _closure_optimization__207_cfa_closure2478, _closure_optimization__207_cfa_closure, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc2469_cfa_closure, _anonymous_2088__236_cfa_closure2479, _anonymous_2088__236_cfa_closure, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2468_cfa_closure, _anonymous_2083__147_cfa_closure2480, _anonymous_2083__147_cfa_closure, 0L, 1);
DEFINE_EXPORT_PROCEDURE(add_procedure_ref__env_174_cfa_closure, _add_procedure_ref_2466_197_cfa_closure2481, _add_procedure_ref_2466_197_cfa_closure, 0L, 1);
DEFINE_EXPORT_PROCEDURE(add_make_procedure__env_11_cfa_closure, _add_make_procedure_2465_29_cfa_closure2482, _add_make_procedure_2465_29_cfa_closure, 0L, 1);
DEFINE_EXPORT_PROCEDURE(add_funcall__env_57_cfa_closure, _add_funcall_2464_39_cfa_closure2483, _add_funcall_2464_39_cfa_closure, 0L, 1);
DEFINE_STRING(string2473_cfa_closure, string2473_cfa_closure2484, "MAKE-L-PROCEDURE MAKE-EL-PROCEDURE-1 MAKE-EL-PROCEDURE PROCEDURE-1-EL-SET! PROCEDURE-1-EL-REF PROCEDURE-EL-SET! PROCEDURE-EL-REF PROCEDURE-L-SET! PROCEDURE-L-REF PROCEDURE-SET! FOREIGN PROCEDURE-REF T X LIGHT ELIGHT NOTHING-TO-DO SELFUN SEFUN DONE OK ", 251);
DEFINE_STRING(string2472_cfa_closure, string2472_cfa_closure2485, "        ", 8);
DEFINE_STRING(string2471_cfa_closure, string2471_cfa_closure2486, "     ", 5);
DEFINE_STRING(string2470_cfa_closure, string2470_cfa_closure2487, ": ", 2);
DEFINE_STRING(string2467_cfa_closure, string2467_cfa_closure2488, "   . Light closures", 19);
DEFINE_EXPORT_PROCEDURE(closure_optimization__env_163_cfa_closure, _closure_optimization__187_cfa_closure2489, _closure_optimization__187_cfa_closure, 0L, 0);



/* module-initialization */
obj_t 
module_initialization_70_cfa_closure(long checksum_3752, char *from_3753)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_cfa_closure))
	{
	   require_initialization_114_cfa_closure =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_cfa_closure();
	   cnst_init_137_cfa_closure();
	   imported_modules_init_94_cfa_closure();
	   method_init_76_cfa_closure();
	   toplevel_init_63_cfa_closure();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_cfa_closure()
{
   AN_OBJECT;
   {	/* Cfa/closure.scm 24 */
      module_initialization_70___object(((long) 0), "CFA_CLOSURE");
      module_initialization_70___reader(((long) 0), "CFA_CLOSURE");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_cfa_closure()
{
   AN_OBJECT;
   {	/* Cfa/closure.scm 24 */
      {		/* Cfa/closure.scm 24 */
	 obj_t cnst_port_138_3745;
	 cnst_port_138_3745 =
	    open_input_string(string2473_cfa_closure);
	 {
	    long i_3746;
	    i_3746 = ((long) 20);
	  loop_3747:
	    {	/* Cfa/closure.scm 24 */
	       bool_t test2474_3748;
	       test2474_3748 =
		  (i_3746 == ((long) -1));
	       if (test2474_3748)
		 {	/* Cfa/closure.scm 24 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Cfa/closure.scm 24 */
		    {	/* Cfa/closure.scm 24 */
		       obj_t arg2475_3749;
		       {	/* Cfa/closure.scm 24 */
			  obj_t list2476_3750;
			  list2476_3750 =
			     MAKE_PAIR(cnst_port_138_3745, BNIL);
			  arg2475_3749 =
			     read___reader(list2476_3750);
		       }
		       CNST_TABLE_SET(i_3746, arg2475_3749);
		    }
		    {	/* Cfa/closure.scm 24 */
		       int aux_3751;
		       {	/* Cfa/closure.scm 24 */
			  long aux_3770;
			  aux_3770 =
			     (i_3746 - ((long) 1));
			  aux_3751 =
			     (int) (aux_3770);
		       }
		       {
			  long i_3773;
			  i_3773 =
			     (long) (aux_3751);
			  i_3746 = i_3773;
			  goto loop_3747;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_cfa_closure()
{
   AN_OBJECT;
   {	/* Cfa/closure.scm 24 */
      _funcall_list__139_cfa_closure = BNIL;
      _make_procedure_list__56_cfa_closure = BNIL;
      _procedure_ref_list__19_cfa_closure = BNIL;
      _procedure_ref__66_cfa_closure = BFALSE;
      _procedure_set___197_cfa_closure = BFALSE;
      _procedure_l_ref__76_cfa_closure = BFALSE;
      _procedure_l_set___202_cfa_closure = BFALSE;
      _procedure_el_ref__61_cfa_closure = BFALSE;
      _procedure_el_set___46_cfa_closure = BFALSE;
      _procedure_1_el_ref__37_cfa_closure = BFALSE;
      _procedure_1_el_set___97_cfa_closure = BFALSE;
      _make_el_procedure__202_cfa_closure = BFALSE;
      _make_el_procedure_1__141_cfa_closure = BFALSE;
      return (
	 _make_l_procedure__54_cfa_closure = BFALSE, BUNSPEC);
   }
}



/* closure-optimization? */
obj_t 
closure_optimization__75_cfa_closure()
{
   AN_OBJECT;
   {	/* Cfa/closure.scm 49 */
      {		/* Cfa/closure.scm 50 */
	 long n1_3118;
	 n1_3118 =
	    (long) CINT(_optim__89_engine_param);
	 {	/* ./Ieee/fixnum.scm 7133 */
	    bool_t aux_3776;
	    aux_3776 =
	       (n1_3118 >= ((long) 2));
	    return
	       BBOOL(aux_3776);
	 }
      }
   }
}



/* _closure-optimization? */
obj_t 
_closure_optimization__187_cfa_closure(obj_t env_3731)
{
   AN_OBJECT;
   {	/* Cfa/closure.scm 49 */
      return
	 closure_optimization__75_cfa_closure();
   }
}



/* closure-optimization! */
obj_t 
closure_optimization__48_cfa_closure()
{
   AN_OBJECT;
   {	/* Cfa/closure.scm 55 */
      {		/* Cfa/closure.scm 56 */
	 bool_t test2061_2108;
	 {	/* Cfa/closure.scm 50 */
	    long n1_3120;
	    n1_3120 =
	       (long) CINT(_optim__89_engine_param);
	    test2061_2108 =
	       (n1_3120 >= ((long) 2));
	 }
	 if (test2061_2108)
	   {	/* Cfa/closure.scm 56 */
	      {		/* Cfa/closure.scm 58 */
		 obj_t list2062_2109;
		 {	/* Cfa/closure.scm 58 */
		    obj_t arg2064_2111;
		    {	/* Cfa/closure.scm 58 */
		       obj_t aux_3783;
		       aux_3783 =
			  BCHAR(((unsigned char) '\n'));
		       arg2064_2111 =
			  MAKE_PAIR(aux_3783, BNIL);
		    }
		    list2062_2109 =
		       MAKE_PAIR(string2467_cfa_closure, arg2064_2111);
		 }
		 verbose_tools_speek(
		    BINT(((long) 1)), list2062_2109);
	      }
	      start_cache_11_cfa_closure();
	      {
		 obj_t l2031_2112;
		 l2031_2112 = _make_procedure_list__56_cfa_closure;
	       lname2032_2113:
		 if (
		    PAIRP(l2031_2112))
		   {	/* Cfa/closure.scm 67 */
		      {		/* Cfa/closure.scm 69 */
			 obj_t app_2115;
			 app_2115 =
			    CAR(l2031_2112);
			 {	/* Cfa/closure.scm 70 */
			    variable_bglt fun_2117;
			    bool_t lost__227_2118;
			    obj_t size_2119;
			    {	/* Cfa/closure.scm 70 */
			       var_bglt obj_3126;
			       {	/* Cfa/closure.scm 70 */
				  obj_t aux_3793;
				  {	/* ./Ieee/pair-list.scm 5701 */
				     obj_t aux_3794;
				     {	/* Cfa/closure.scm 70 */
					app_bglt obj_3124;
					obj_3124 =
					   (app_bglt) (app_2115);
					aux_3794 =
					   (((app_bglt) CREF(obj_3124))->args);
				     }
				     aux_3793 =
					CAR(aux_3794);
				  }
				  obj_3126 =
				     (var_bglt) (aux_3793);
			       }
			       fun_2117 =
				  (((var_bglt) CREF(obj_3126))->variable);
			    }
			    {	/* ./Ieee/fixnum.scm 7121 */
			       long aux_3800;
			       {	/* Cfa/closure.scm 71 */
				  make_procedure_app_48_bglt obj_3127;
				  obj_3127 =
				     (make_procedure_app_48_bglt) (app_2115);
				  {
				     obj_t aux_3802;
				     {	/* ./Cfa/cinfo2.scm 1568 */
					object_bglt aux_3803;
					aux_3803 =
					   (object_bglt) (obj_3127);
					aux_3802 =
					   OBJECT_WIDENING(aux_3803);
				     }
				     aux_3800 =
					(((make_procedure_app_48_bglt) CREF(aux_3802))->lost_stamp_114);
				  }
			       }
			       lost__227_2118 =
				  (aux_3800 > ((long) -1));
			    }
			    {	/* Cfa/closure.scm 72 */
			       node_bglt aux_3808;
			       {	/* Cfa/closure.scm 72 */
				  obj_t aux_3809;
				  {	/* ./Ieee/pair-list.scm 5701 */
				     obj_t aux_3810;
				     {	/* ./Ieee/pair-list.scm 5707 */
					obj_t aux_3811;
					{	/* ./Ieee/pair-list.scm 5707 */
					   obj_t aux_3812;
					   {	/* Cfa/closure.scm 72 */
					      app_bglt obj_3130;
					      obj_3130 =
						 (app_bglt) (app_2115);
					      aux_3812 =
						 (((app_bglt) CREF(obj_3130))->args);
					   }
					   aux_3811 =
					      CDR(aux_3812);
					}
					aux_3810 =
					   CDR(aux_3811);
				     }
				     aux_3809 =
					CAR(aux_3810);
				  }
				  aux_3808 =
				     (node_bglt) (aux_3809);
			       }
			       size_2119 =
				  get_node_atom_value_135_cfa_approx(aux_3808);
			    }
			    {	/* Cfa/closure.scm 74 */
			       bool_t test_3820;
			       if (lost__227_2118)
				 {	/* Cfa/closure.scm 74 */
				    test_3820 = ((bool_t) 1)
				       ;
				 }
			       else
				 {	/* Cfa/closure.scm 75 */
				    bool_t test_3822;
				    {	/* Cfa/closure.scm 75 */
				       make_procedure_app_48_bglt obj_3137;
				       obj_3137 =
					  (make_procedure_app_48_bglt) (app_2115);
				       {
					  obj_t aux_3824;
					  {	/* ./Cfa/cinfo2.scm 1570 */
					     object_bglt aux_3825;
					     aux_3825 =
						(object_bglt) (obj_3137);
					     aux_3824 =
						OBJECT_WIDENING(aux_3825);
					  }
					  test_3822 =
					     (((make_procedure_app_48_bglt) CREF(aux_3824))->x_t__142);
				       }
				    }
				    if (test_3822)
				      {		/* Cfa/closure.scm 76 */
					 bool_t test_3829;
					 {	/* ./Ieee/fixnum.scm 7115 */
					    long aux_3830;
					    {	/* Cfa/closure.scm 76 */
					       sfun_bglt obj_3139;
					       {	/* Cfa/closure.scm 76 */
						  value_bglt aux_3831;
						  {	/* Cfa/closure.scm 76 */
						     global_bglt obj_3138;
						     obj_3138 =
							(global_bglt) (fun_2117);
						     aux_3831 =
							(((global_bglt) CREF(obj_3138))->value);
						  }
						  obj_3139 =
						     (sfun_bglt) (aux_3831);
					       }
					       aux_3830 =
						  (((sfun_bglt) CREF(obj_3139))->arity);
					    }
					    test_3829 =
					       (aux_3830 < ((long) 0));
					 }
					 if (test_3829)
					   {	/* Cfa/closure.scm 76 */
					      test_3820 = ((bool_t) 1)
						 ;
					   }
					 else
					   {	/* Cfa/closure.scm 76 */
					      if (
						 INTEGERP(size_2119))
						{	/* ./Ieee/fixnum.scm 7109 */
						   long aux_3839;
						   aux_3839 =
						      (long) CINT(size_2119);
						   test_3820 =
						      (aux_3839 == ((long) 0));
						}
					      else
						{	/* Cfa/closure.scm 77 */
						   test_3820 = ((bool_t) 1)
						      ;
						}
					   }
				      }
				    else
				      {		/* Cfa/closure.scm 75 */
					 test_3820 = ((bool_t) 1)
					    ;
				      }
				 }
			       if (test_3820)
				 {	/* Cfa/closure.scm 74 */
				    BUNSPEC;
				 }
			       else
				 {	/* Cfa/closure.scm 74 */
				    {	/* Cfa/closure.scm 85 */
				       make_procedure_app_48_bglt obj_3145;
				       obj_3145 =
					  (make_procedure_app_48_bglt) (app_2115);
				       {
					  obj_t aux_3843;
					  {	/* ./Cfa/cinfo2.scm 1571 */
					     object_bglt aux_3844;
					     aux_3844 =
						(object_bglt) (obj_3145);
					     aux_3843 =
						OBJECT_WIDENING(aux_3844);
					  }
					  ((((make_procedure_app_48_bglt) CREF(aux_3843))->x) = ((bool_t) ((bool_t) 1)), BUNSPEC);
				       }
				    }
				    {	/* Cfa/closure.scm 86 */
				       make_procedure_app_48_bglt obj_3147;
				       obj_3147 =
					  (make_procedure_app_48_bglt) (app_2115);
				       {
					  obj_t aux_3849;
					  {	/* ./Cfa/cinfo2.scm 1572 */
					     object_bglt aux_3850;
					     aux_3850 =
						(object_bglt) (obj_3147);
					     aux_3849 =
						OBJECT_WIDENING(aux_3850);
					  }
					  ((((make_procedure_app_48_bglt) CREF(aux_3849))->t) = ((bool_t) ((bool_t) 1)), BUNSPEC);
				       }
				    }
				 }
			    }
			 }
		      }
		      {
			 obj_t l2031_3854;
			 l2031_3854 =
			    CDR(l2031_2112);
			 l2031_2112 = l2031_3854;
			 goto lname2032_2113;
		      }
		   }
		 else
		   {	/* Cfa/closure.scm 67 */
		      ((bool_t) 1);
		   }
	      }
	      x__157_cfa_closure(_funcall_list__139_cfa_closure);
	      t_fix_point__90_cfa_closure(_funcall_list__139_cfa_closure);
	      show_x_t_233_cfa_closure(_make_procedure_list__56_cfa_closure);
	      light_funcall__169_cfa_closure();
	      light_access__52_cfa_closure();
	      light_make_procedure__143_cfa_closure();
	      return
		 stop_cache_174_cfa_closure();
	   }
	 else
	   {	/* Cfa/closure.scm 56 */
	      return BUNSPEC;
	   }
      }
   }
}



/* _closure-optimization! */
obj_t 
_closure_optimization__207_cfa_closure(obj_t env_3732)
{
   AN_OBJECT;
   {	/* Cfa/closure.scm 55 */
      return
	 closure_optimization__48_cfa_closure();
   }
}



/* x! */
bool_t 
x__157_cfa_closure(obj_t funcall_list_16_1)
{
   AN_OBJECT;
   {	/* Cfa/closure.scm 117 */
      {
	 obj_t l2034_2134;
	 l2034_2134 = funcall_list_16_1;
       lname2035_2135:
	 if (
	    PAIRP(l2034_2134))
	   {	/* Cfa/closure.scm 119 */
	      {		/* Cfa/closure.scm 119 */
		 funcall_bglt app_2137;
		 {	/* ./Ieee/pair-list.scm 5701 */
		    obj_t aux_3866;
		    aux_3866 =
		       CAR(l2034_2134);
		    app_2137 =
		       (funcall_bglt) (aux_3866);
		 }
		 {	/* Cfa/closure.scm 121 */
		    approx_bglt approx_2139;
		    approx_2139 =
		       cfa__102_cfa_cfa(
		       (((funcall_bglt) CREF(app_2137))->fun));
		    {	/* Cfa/closure.scm 122 */
		       obj_t alloc_2140;
		       alloc_2140 =
			  (((approx_bglt) CREF(approx_2139))->allocs);
		       {	/* Cfa/closure.scm 123 */
			  type_bglt type_2141;
			  type_2141 =
			     (((approx_bglt) CREF(approx_2139))->type);
			  {	/* Cfa/closure.scm 125 */

			     if (
				(((approx_bglt) CREF(approx_2139))->top__138))
			       {	/* Cfa/closure.scm 127 */
				  {	/* Cfa/closure.scm 131 */
				     obj_t _anonymous_2083__147_3733;
				     _anonymous_2083__147_3733 = proc2468_cfa_closure;
				     for_each_approx_alloc_83_cfa_approx(_anonymous_2083__147_3733, approx_2139);
				  }
			       }
			     else
			       {	/* Cfa/closure.scm 138 */
				  bool_t test2085_2148;
				  {	/* Cfa/closure.scm 138 */
				     obj_t arg2093_2159;
				     arg2093_2159 =
					set_length_165_cfa_set(alloc_2140);
				     {	/* ./Ieee/fixnum.scm 7109 */
					long aux_3877;
					aux_3877 =
					   (long) CINT(arg2093_2159);
					test2085_2148 =
					   (aux_3877 == ((long) 0));
				     }
				  }
				  if (test2085_2148)
				    {	/* Cfa/closure.scm 138 */
				       CNST_TABLE_REF(((long) 0));
				    }
				  else
				    {	/* Cfa/closure.scm 141 */
				       bool_t test2086_2149;
				       {	/* Cfa/closure.scm 141 */
					  bool_t test2090_2155;
					  {	/* Cfa/closure.scm 141 */
					     obj_t arg2091_2157;
					     arg2091_2157 =
						set_length_165_cfa_set(alloc_2140);
					     {	/* ./Ieee/fixnum.scm 7109 */
						long aux_3883;
						aux_3883 =
						   (long) CINT(arg2091_2157);
						test2090_2155 =
						   (aux_3883 == ((long) 1));
					     }
					  }
					  if (test2090_2155)
					    {	/* Cfa/closure.scm 142 */
					       obj_t _ortest_2036_2156;
					       _ortest_2036_2156 = _unsafe_type__146_engine_param;
					       if (
						  CBOOL(_ortest_2036_2156))
						 {	/* Cfa/closure.scm 142 */
						    test2086_2149 =
						       CBOOL(_ortest_2036_2156);
						 }
					       else
						 {	/* Cfa/closure.scm 142 */
						    obj_t obj2_3166;
						    obj2_3166 = _procedure__226_type_cache;
						    {	/* ./Ieee/equiv.scm 5508 */
						       obj_t aux_3890;
						       aux_3890 =
							  (obj_t) (type_2141);
						       test2086_2149 =
							  (aux_3890 == obj2_3166);
						    }
						 }
					    }
					  else
					    {	/* Cfa/closure.scm 141 */
					       test2086_2149 = ((bool_t) 0);
					    }
				       }
				       if (test2086_2149)
					 {	/* Cfa/closure.scm 141 */
					    CNST_TABLE_REF(((long) 0));
					 }
				       else
					 {	/* Cfa/closure.scm 141 */
					    {	/* Cfa/closure.scm 150 */
					       obj_t _anonymous_2088__236_3734;
					       _anonymous_2088__236_3734 = proc2469_cfa_closure;
					       for_each_approx_alloc_83_cfa_approx(_anonymous_2088__236_3734, approx_2139);
					    }
					 }
				    }
			       }
			  }
		       }
		    }
		 }
	      }
	      {
		 obj_t l2034_3896;
		 l2034_3896 =
		    CDR(l2034_2134);
		 l2034_2134 = l2034_3896;
		 goto lname2035_2135;
	      }
	   }
	 else
	   {	/* Cfa/closure.scm 119 */
	      return ((bool_t) 1);
	   }
      }
   }
}



/* <anonymous:2083> */
obj_t 
_anonymous_2083__147_cfa_closure(obj_t env_3735, obj_t alloc_3736)
{
   AN_OBJECT;
   {	/* Cfa/closure.scm 130 */
      {
	 obj_t alloc_2144;
	 alloc_2144 = alloc_3736;
	 {	/* Cfa/closure.scm 131 */
	    bool_t test2084_2146;
	    test2084_2146 =
	       is_a__118___object(alloc_2144, make_procedure_app_48_cfa_info2);
	    if (test2084_2146)
	      {		/* Cfa/closure.scm 131 */
		 {	/* Cfa/closure.scm 135 */
		    make_procedure_app_48_bglt obj_3157;
		    obj_3157 =
		       (make_procedure_app_48_bglt) (alloc_2144);
		    {
		       obj_t aux_3901;
		       {	/* ./Cfa/cinfo2.scm 1572 */
			  object_bglt aux_3902;
			  aux_3902 =
			     (object_bglt) (obj_3157);
			  aux_3901 =
			     OBJECT_WIDENING(aux_3902);
		       }
		       ((((make_procedure_app_48_bglt) CREF(aux_3901))->t) = ((bool_t) ((bool_t) 0)), BUNSPEC);
		    }
		 }
		 {	/* Cfa/closure.scm 136 */
		    make_procedure_app_48_bglt obj_3159;
		    obj_3159 =
		       (make_procedure_app_48_bglt) (alloc_2144);
		    {
		       obj_t aux_3907;
		       {	/* ./Cfa/cinfo2.scm 1571 */
			  object_bglt aux_3908;
			  aux_3908 =
			     (object_bglt) (obj_3159);
			  aux_3907 =
			     OBJECT_WIDENING(aux_3908);
		       }
		       return
			  ((((make_procedure_app_48_bglt) CREF(aux_3907))->x) = ((bool_t) ((bool_t) 0)), BUNSPEC);
		    }
		 }
	      }
	    else
	      {		/* Cfa/closure.scm 131 */
		 return BUNSPEC;
	      }
	 }
      }
   }
}



/* <anonymous:2088> */
obj_t 
_anonymous_2088__236_cfa_closure(obj_t env_3737, obj_t alloc_3738)
{
   AN_OBJECT;
   {	/* Cfa/closure.scm 149 */
      {
	 obj_t alloc_2151;
	 alloc_2151 = alloc_3738;
	 {	/* Cfa/closure.scm 150 */
	    bool_t test2089_2153;
	    test2089_2153 =
	       is_a__118___object(alloc_2151, make_procedure_app_48_cfa_info2);
	    if (test2089_2153)
	      {		/* Cfa/closure.scm 150 */
		 {	/* Cfa/closure.scm 154 */
		    make_procedure_app_48_bglt obj_3168;
		    obj_3168 =
		       (make_procedure_app_48_bglt) (alloc_2151);
		    {
		       obj_t aux_3915;
		       {	/* ./Cfa/cinfo2.scm 1571 */
			  object_bglt aux_3916;
			  aux_3916 =
			     (object_bglt) (obj_3168);
			  aux_3915 =
			     OBJECT_WIDENING(aux_3916);
		       }
		       return
			  ((((make_procedure_app_48_bglt) CREF(aux_3915))->x) = ((bool_t) ((bool_t) 0)), BUNSPEC);
		    }
		 }
	      }
	    else
	      {		/* Cfa/closure.scm 150 */
		 return BUNSPEC;
	      }
	 }
      }
   }
}



/* t-fix-point! */
obj_t 
t_fix_point__90_cfa_closure(obj_t funcall_list_16_2)
{
   AN_OBJECT;
   {	/* Cfa/closure.scm 167 */
      {
	 bool_t continue__191_2162;
	 continue__191_2162 = ((bool_t) 1);
       loop_2163:
	 if (continue__191_2162)
	   {	/* Cfa/closure.scm 172 */
	      bool_t continue__191_2164;
	      continue__191_2164 = ((bool_t) 0);
	      {
		 obj_t l2037_2165;
		 l2037_2165 = funcall_list_16_2;
	       lname2038_2166:
		 if (
		    PAIRP(l2037_2165))
		   {	/* Cfa/closure.scm 173 */
		      {		/* Cfa/closure.scm 176 */
			 approx_bglt approx_2170;
			 {	/* Cfa/closure.scm 177 */
			    node_bglt aux_3923;
			    {	/* Cfa/closure.scm 176 */
			       funcall_bglt obj_3173;
			       {	/* Cfa/closure.scm 176 */
				  obj_t aux_3924;
				  aux_3924 =
				     CAR(l2037_2165);
				  obj_3173 =
				     (funcall_bglt) (aux_3924);
			       }
			       aux_3923 =
				  (((funcall_bglt) CREF(obj_3173))->fun);
			    }
			    approx_2170 =
			       cfa__102_cfa_cfa(aux_3923);
			 }
			 {	/* Cfa/closure.scm 177 */
			    obj_t alloc_2171;
			    alloc_2171 =
			       set__list_248_cfa_set(
			       (((approx_bglt) CREF(approx_2170))->allocs));
			    {	/* Cfa/closure.scm 179 */
			       bool_t t_init__227_2173;
			       {	/* Cfa/closure.scm 180 */
				  bool_t _ortest_2039_2192;
				  _ortest_2039_2192 =
				     (((approx_bglt) CREF(approx_2170))->top__138);
				  if (_ortest_2039_2192)
				    {	/* Cfa/closure.scm 180 */
				       t_init__227_2173 = _ortest_2039_2192;
				    }
				  else
				    {	/* Cfa/closure.scm 181 */
				       bool_t test2107_2193;
				       {	/* Cfa/closure.scm 181 */
					  bool_t test2108_2194;
					  {	/* Cfa/closure.scm 181 */
					     obj_t obj2_3178;
					     obj2_3178 = _procedure__226_type_cache;
					     {	/* ./Ieee/equiv.scm 5508 */
						obj_t aux_3933;
						{	/* Cfa/closure.scm 181 */
						   type_bglt aux_3934;
						   aux_3934 =
						      (((approx_bglt) CREF(approx_2170))->type);
						   aux_3933 =
						      (obj_t) (aux_3934);
						}
						test2108_2194 =
						   (aux_3933 == obj2_3178);
					     }
					  }
					  if (test2108_2194)
					    {	/* Cfa/closure.scm 181 */
					       test2107_2193 = ((bool_t) 1);
					    }
					  else
					    {	/* Cfa/closure.scm 181 */
					       test2107_2193 =
						  CBOOL(_unsafe_type__146_engine_param);
					    }
				       }
				       if (test2107_2193)
					 {	/* Cfa/closure.scm 181 */
					    t_init__227_2173 = ((bool_t) 0);
					 }
				       else
					 {	/* Cfa/closure.scm 181 */
					    t_init__227_2173 = ((bool_t) 1);
					 }
				    }
			       }
			       {	/* Cfa/closure.scm 180 */

				  {
				     bool_t one_non_t__209_2174;
				     obj_t allocs_2175;
				     one_non_t__209_2174 = t_init__227_2173;
				     allocs_2175 = alloc_2171;
				   loop_2176:
				     if (
					NULLP(allocs_2175))
				       {	/* Cfa/closure.scm 189 */
					  CNST_TABLE_REF(((long) 1));
				       }
				     else
				       {	/* Cfa/closure.scm 189 */
					  if (one_non_t__209_2174)
					    {	/* Cfa/closure.scm 191 */
					       {
						  obj_t l2040_2178;
						  {	/* Cfa/closure.scm 192 */
						     bool_t aux_3945;
						     l2040_2178 = alloc_2171;
						   lname2041_2179:
						     if (
							PAIRP(l2040_2178))
						       {	/* Cfa/closure.scm 192 */
							  {	/* Cfa/closure.scm 194 */
							     obj_t alloc_2181;
							     alloc_2181 =
								CAR(l2040_2178);
							     {	/* Cfa/closure.scm 194 */
								bool_t test2099_2182;
								test2099_2182 =
								   is_a__118___object(alloc_2181, make_procedure_app_48_cfa_info2);
								if (test2099_2182)
								  {	/* Cfa/closure.scm 196 */
								     bool_t test_3951;
								     {	/* Cfa/closure.scm 196 */
									make_procedure_app_48_bglt obj_3183;
									obj_3183 =
									   (make_procedure_app_48_bglt) (alloc_2181);
									{
									   obj_t aux_3953;
									   {	/* ./Cfa/cinfo2.scm 1572 */
									      object_bglt aux_3954;
									      aux_3954 =
										 (object_bglt) (obj_3183);
									      aux_3953 =
										 OBJECT_WIDENING(aux_3954);
									   }
									   test_3951 =
									      (((make_procedure_app_48_bglt) CREF(aux_3953))->t);
									}
								     }
								     if (test_3951)
								       {	/* Cfa/closure.scm 196 */
									  {	/* Cfa/closure.scm 198 */
									     make_procedure_app_48_bglt obj_3184;
									     obj_3184 =
										(make_procedure_app_48_bglt) (alloc_2181);
									     {
										obj_t aux_3959;
										{	/* ./Cfa/cinfo2.scm 1572 */
										   object_bglt aux_3960;
										   aux_3960 =
										      (object_bglt) (obj_3184);
										   aux_3959 =
										      OBJECT_WIDENING(aux_3960);
										}
										((((make_procedure_app_48_bglt) CREF(aux_3959))->t) = ((bool_t) ((bool_t) 0)), BUNSPEC);
									     }
									  }
									  continue__191_2164 = ((bool_t) 1);
								       }
								     else
								       {	/* Cfa/closure.scm 196 */
									  BUNSPEC;
								       }
								  }
								else
								  {	/* Cfa/closure.scm 194 */
								     BUNSPEC;
								  }
							     }
							  }
							  {
							     obj_t l2040_3964;
							     l2040_3964 =
								CDR(l2040_2178);
							     l2040_2178 = l2040_3964;
							     goto lname2041_2179;
							  }
						       }
						     else
						       {	/* Cfa/closure.scm 192 */
							  aux_3945 = ((bool_t) 1);
						       }
						     BBOOL(aux_3945);
						  }
					       }
					    }
					  else
					    {	/* Cfa/closure.scm 201 */
					       bool_t test2102_2186;
					       test2102_2186 =
						  is_a__118___object(
						  CAR(allocs_2175), make_procedure_app_48_cfa_info2);
					       if (test2102_2186)
						 {	/* Cfa/closure.scm 201 */
						    {	/* Cfa/closure.scm 203 */
						       bool_t test_3970;
						       {	/* Cfa/closure.scm 203 */
							  make_procedure_app_48_bglt obj_3190;
							  {	/* Cfa/closure.scm 203 */
							     obj_t aux_3971;
							     aux_3971 =
								CAR(allocs_2175);
							     obj_3190 =
								(make_procedure_app_48_bglt) (aux_3971);
							  }
							  {
							     obj_t aux_3974;
							     {	/* ./Cfa/cinfo2.scm 1572 */
								object_bglt aux_3975;
								aux_3975 =
								   (object_bglt) (obj_3190);
								aux_3974 =
								   OBJECT_WIDENING(aux_3975);
							     }
							     test_3970 =
								(((make_procedure_app_48_bglt) CREF(aux_3974))->t);
							  }
						       }
						       if (test_3970)
							 {
							    obj_t allocs_3979;
							    allocs_3979 =
							       CDR(allocs_2175);
							    allocs_2175 = allocs_3979;
							    goto loop_2176;
							 }
						       else
							 {
							    bool_t one_non_t__209_3981;
							    one_non_t__209_3981 = ((bool_t) 1);
							    one_non_t__209_2174 = one_non_t__209_3981;
							    goto loop_2176;
							 }
						    }
						 }
					       else
						 {	/* Cfa/closure.scm 201 */
						    if (
						       CBOOL(_unsafe_type__146_engine_param))
						      {
							 obj_t allocs_3984;
							 allocs_3984 =
							    CDR(allocs_2175);
							 allocs_2175 = allocs_3984;
							 goto loop_2176;
						      }
						    else
						      {
							 bool_t one_non_t__209_3986;
							 one_non_t__209_3986 = ((bool_t) 1);
							 one_non_t__209_2174 = one_non_t__209_3986;
							 goto loop_2176;
						      }
						 }
					    }
				       }
				  }
			       }
			    }
			 }
		      }
		      {
			 obj_t l2037_3987;
			 l2037_3987 =
			    CDR(l2037_2165);
			 l2037_2165 = l2037_3987;
			 goto lname2038_2166;
		      }
		   }
		 else
		   {	/* Cfa/closure.scm 173 */
		      ((bool_t) 1);
		   }
	      }
	      {
		 bool_t continue__191_3989;
		 continue__191_3989 = continue__191_2164;
		 continue__191_2162 = continue__191_3989;
		 goto loop_2163;
	      }
	   }
	 else
	   {	/* Cfa/closure.scm 170 */
	      return BUNSPEC;
	   }
      }
   }
}



/* light-make-procedure! */
bool_t 
light_make_procedure__143_cfa_closure()
{
   AN_OBJECT;
   {	/* Cfa/closure.scm 236 */
      {
	 obj_t app_2234;
	 obj_t app_2210;
	 {
	    obj_t l2047_2202;
	    l2047_2202 = _make_procedure_list__56_cfa_closure;
	  lname2048_2203:
	    if (
	       PAIRP(l2047_2202))
	      {		/* Cfa/closure.scm 272 */
		 {	/* Cfa/closure.scm 273 */
		    obj_t app_2205;
		    app_2205 =
		       CAR(l2047_2202);
		    {	/* Cfa/closure.scm 275 */
		       bool_t test_3993;
		       {	/* Cfa/closure.scm 275 */
			  make_procedure_app_48_bglt obj_3196;
			  obj_3196 =
			     (make_procedure_app_48_bglt) (app_2205);
			  {
			     obj_t aux_3995;
			     {	/* ./Cfa/cinfo2.scm 1571 */
				object_bglt aux_3996;
				aux_3996 =
				   (object_bglt) (obj_3196);
				aux_3995 =
				   OBJECT_WIDENING(aux_3996);
			     }
			     test_3993 =
				(((make_procedure_app_48_bglt) CREF(aux_3995))->x);
			  }
		       }
		       if (test_3993)
			 {	/* Cfa/closure.scm 275 */
			    app_2234 = app_2205;
			    {	/* Cfa/closure.scm 239 */
			       obj_t size_2237;
			       {	/* Cfa/closure.scm 239 */
				  node_bglt aux_4000;
				  {	/* Cfa/closure.scm 239 */
				     obj_t aux_4001;
				     {	/* ./Ieee/pair-list.scm 5701 */
					obj_t aux_4002;
					{	/* ./Ieee/pair-list.scm 5707 */
					   obj_t aux_4003;
					   {	/* ./Ieee/pair-list.scm 5707 */
					      obj_t aux_4004;
					      {		/* Cfa/closure.scm 239 */
						 app_bglt obj_3231;
						 obj_3231 =
						    (app_bglt) (app_2234);
						 aux_4004 =
						    (((app_bglt) CREF(obj_3231))->args);
					      }
					      aux_4003 =
						 CDR(aux_4004);
					   }
					   aux_4002 =
					      CDR(aux_4003);
					}
					aux_4001 =
					   CAR(aux_4002);
				     }
				     aux_4000 =
					(node_bglt) (aux_4001);
				  }
				  size_2237 =
				     get_node_atom_value_135_cfa_approx(aux_4000);
			       }
			       {	/* Cfa/closure.scm 239 */
				  variable_bglt ffun_2238;
				  {	/* Cfa/closure.scm 240 */
				     var_bglt obj_3240;
				     {	/* Cfa/closure.scm 240 */
					obj_t aux_4012;
					{	/* ./Ieee/pair-list.scm 5701 */
					   obj_t aux_4013;
					   {	/* Cfa/closure.scm 240 */
					      app_bglt obj_3238;
					      obj_3238 =
						 (app_bglt) (app_2234);
					      aux_4013 =
						 (((app_bglt) CREF(obj_3238))->args);
					   }
					   aux_4012 =
					      CAR(aux_4013);
					}
					obj_3240 =
					   (var_bglt) (aux_4012);
				     }
				     ffun_2238 =
					(((var_bglt) CREF(obj_3240))->variable);
				  }
				  {	/* Cfa/closure.scm 240 */
				     value_bglt sfun_2239;
				     sfun_2239 =
					(((variable_bglt) CREF(ffun_2238))->value);
				     {	/* Cfa/closure.scm 241 */

					{	/* Cfa/closure.scm 243 */
					   bool_t test_4020;
					   {	/* ./Ieee/fixnum.scm 7109 */
					      long aux_4021;
					      aux_4021 =
						 (long) CINT(size_2237);
					      test_4020 =
						 (aux_4021 == ((long) 1));
					   }
					   if (test_4020)
					     {	/* Cfa/closure.scm 243 */
						{	/* Cfa/closure.scm 244 */
						   bool_t test2140_2241;
						   {	/* Cfa/closure.scm 244 */
						      bool_t test2146_2245;
						      test2146_2245 =
							 is_a__118___object(
							 (obj_t) (ffun_2238), global_ast_var);
						      if (test2146_2245)
							{	/* Cfa/closure.scm 245 */
							   bool_t test2147_2246;
							   {	/* ./Ast/var.scm 1132 */
							      obj_t aux_4027;
							      {		/* Cfa/closure.scm 245 */
								 sfun_bglt obj_3245;
								 obj_3245 =
								    (sfun_bglt) (sfun_2239);
								 aux_4027 =
								    (((sfun_bglt) CREF(obj_3245))->the_closure_238);
							      }
							      test2147_2246 =
								 is_a__118___object(aux_4027, global_ast_var);
							   }
							   if (test2147_2246)
							     {	/* ./Ast/var.scm 1205 */
								obj_t aux_4032;
								{	/* Cfa/closure.scm 246 */
								   value_bglt aux_4033;
								   {	/* Cfa/closure.scm 246 */
								      global_bglt obj_3248;
								      {		/* Cfa/closure.scm 246 */
									 obj_t aux_4034;
									 {	/* Cfa/closure.scm 246 */
									    sfun_bglt obj_3247;
									    obj_3247 =
									       (sfun_bglt) (sfun_2239);
									    aux_4034 =
									       (((sfun_bglt) CREF(obj_3247))->the_closure_238);
									 }
									 obj_3248 =
									    (global_bglt) (aux_4034);
								      }
								      aux_4033 =
									 (((global_bglt) CREF(obj_3248))->value);
								   }
								   aux_4032 =
								      (obj_t) (aux_4033);
								}
								test2140_2241 =
								   is_a__118___object(aux_4032, scnst_ast_var);
							     }
							   else
							     {	/* Cfa/closure.scm 245 */
								test2140_2241 = ((bool_t) 0);
							     }
							}
						      else
							{	/* Cfa/closure.scm 244 */
							   test2140_2241 = ((bool_t) 0);
							}
						   }
						   if (test2140_2241)
						     {	/* Cfa/closure.scm 247 */
							obj_t arg2144_2243;
							arg2144_2243 =
							   CNST_TABLE_REF(((long) 3));
							{	/* Cfa/closure.scm 247 */
							   scnst_bglt obj_3252;
							   {	/* Cfa/closure.scm 247 */
							      value_bglt aux_4043;
							      {		/* Cfa/closure.scm 247 */
								 global_bglt obj_3251;
								 {	/* Cfa/closure.scm 247 */
								    obj_t aux_4044;
								    {	/* Cfa/closure.scm 247 */
								       sfun_bglt obj_3250;
								       obj_3250 =
									  (sfun_bglt) (sfun_2239);
								       aux_4044 =
									  (((sfun_bglt) CREF(obj_3250))->the_closure_238);
								    }
								    obj_3251 =
								       (global_bglt) (aux_4044);
								 }
								 aux_4043 =
								    (((global_bglt) CREF(obj_3251))->value);
							      }
							      obj_3252 =
								 (scnst_bglt) (aux_4043);
							   }
							   ((((scnst_bglt) CREF(obj_3252))->class) = ((obj_t) arg2144_2243), BUNSPEC);
							}
						     }
						   else
						     {	/* Cfa/closure.scm 244 */
							BUNSPEC;
						     }
						}
						{	/* Cfa/closure.scm 249 */
						   var_bglt arg2151_2250;
						   {	/* Cfa/closure.scm 249 */
						      app_bglt obj_3254;
						      obj_3254 =
							 (app_bglt) (app_2234);
						      arg2151_2250 =
							 (((app_bglt) CREF(obj_3254))->fun);
						   }
						   {	/* Cfa/closure.scm 249 */
						      variable_bglt val1209_3256;
						      val1209_3256 =
							 (variable_bglt) (_make_el_procedure_1__141_cfa_closure);
						      ((((var_bglt) CREF(arg2151_2250))->variable) = ((variable_bglt) val1209_3256), BUNSPEC);
						   }
						}
					     }
					   else
					     {	/* Cfa/closure.scm 243 */
						{	/* Cfa/closure.scm 251 */
						   var_bglt arg2153_2251;
						   {	/* Cfa/closure.scm 251 */
						      app_bglt obj_3257;
						      obj_3257 =
							 (app_bglt) (app_2234);
						      arg2153_2251 =
							 (((app_bglt) CREF(obj_3257))->fun);
						   }
						   {	/* Cfa/closure.scm 251 */
						      variable_bglt val1209_3259;
						      val1209_3259 =
							 (variable_bglt) (_make_el_procedure__202_cfa_closure);
						      ((((var_bglt) CREF(arg2153_2251))->variable) = ((variable_bglt) val1209_3259), BUNSPEC);
						   }
						}
					     }
					}
				     }
				  }
			       }
			    }
			    {	/* Cfa/closure.scm 252 */
			       obj_t arg2158_2256;
			       {	/* ./Ieee/pair-list.scm 5707 */
				  obj_t aux_4059;
				  {	/* ./Ieee/pair-list.scm 5707 */
				     obj_t aux_4060;
				     {	/* Cfa/closure.scm 252 */
					app_bglt obj_3260;
					obj_3260 =
					   (app_bglt) (app_2234);
					aux_4060 =
					   (((app_bglt) CREF(obj_3260))->args);
				     }
				     aux_4059 =
					CDR(aux_4060);
				  }
				  arg2158_2256 =
				     CDR(aux_4059);
			       }
			       {	/* Cfa/closure.scm 252 */
				  app_bglt obj_3265;
				  obj_3265 =
				     (app_bglt) (app_2234);
				  ((((app_bglt) CREF(obj_3265))->args) = ((obj_t) arg2158_2256), BUNSPEC);
			       }
			    }
			    {	/* Cfa/closure.scm 253 */
			       bool_t test2160_2258;
			       test2160_2258 =
				  stack_optimization__133_cfa_stack();
			       if (test2160_2258)
				 {	/* Cfa/closure.scm 254 */
				    node_bglt aux_4069;
				    aux_4069 =
				       stack__132_cfa_stack(
				       (node_bglt) (app_2234));
				    (obj_t) (aux_4069);
				 }
			       else
				 {	/* Cfa/closure.scm 253 */
				    app_2234;
				 }
			    }
			 }
		       else
			 {	/* Cfa/closure.scm 276 */
			    bool_t test_4073;
			    {	/* Cfa/closure.scm 276 */
			       make_procedure_app_48_bglt obj_3197;
			       obj_3197 =
				  (make_procedure_app_48_bglt) (app_2205);
			       {
				  obj_t aux_4075;
				  {	/* ./Cfa/cinfo2.scm 1572 */
				     object_bglt aux_4076;
				     aux_4076 =
					(object_bglt) (obj_3197);
				     aux_4075 =
					OBJECT_WIDENING(aux_4076);
				  }
				  test_4073 =
				     (((make_procedure_app_48_bglt) CREF(aux_4075))->t);
			       }
			    }
			    if (test_4073)
			      {		/* Cfa/closure.scm 276 */
				 app_2210 = app_2205;
				 {	/* Cfa/closure.scm 258 */
				    obj_t size_2213;
				    {	/* Cfa/closure.scm 258 */
				       node_bglt aux_4080;
				       {	/* Cfa/closure.scm 258 */
					  obj_t aux_4081;
					  {	/* ./Ieee/pair-list.scm 5701 */
					     obj_t aux_4082;
					     {	/* ./Ieee/pair-list.scm 5707 */
						obj_t aux_4083;
						{	/* ./Ieee/pair-list.scm 5707 */
						   obj_t aux_4084;
						   {	/* Cfa/closure.scm 258 */
						      app_bglt obj_3199;
						      obj_3199 =
							 (app_bglt) (app_2210);
						      aux_4084 =
							 (((app_bglt) CREF(obj_3199))->args);
						   }
						   aux_4083 =
						      CDR(aux_4084);
						}
						aux_4082 =
						   CDR(aux_4083);
					     }
					     aux_4081 =
						CAR(aux_4082);
					  }
					  aux_4080 =
					     (node_bglt) (aux_4081);
				       }
				       size_2213 =
					  get_node_atom_value_135_cfa_approx(aux_4080);
				    }
				    {	/* Cfa/closure.scm 258 */
				       variable_bglt ffun_2214;
				       {	/* Cfa/closure.scm 259 */
					  var_bglt obj_3208;
					  {	/* Cfa/closure.scm 259 */
					     obj_t aux_4092;
					     {	/* ./Ieee/pair-list.scm 5701 */
						obj_t aux_4093;
						{	/* Cfa/closure.scm 259 */
						   app_bglt obj_3206;
						   obj_3206 =
						      (app_bglt) (app_2210);
						   aux_4093 =
						      (((app_bglt) CREF(obj_3206))->args);
						}
						aux_4092 =
						   CAR(aux_4093);
					     }
					     obj_3208 =
						(var_bglt) (aux_4092);
					  }
					  ffun_2214 =
					     (((var_bglt) CREF(obj_3208))->variable);
				       }
				       {	/* Cfa/closure.scm 259 */
					  value_bglt sfun_2215;
					  sfun_2215 =
					     (((variable_bglt) CREF(ffun_2214))->value);
					  {	/* Cfa/closure.scm 260 */

					     {	/* Cfa/closure.scm 261 */
						bool_t test2118_2216;
						{	/* Cfa/closure.scm 261 */
						   bool_t test2123_2220;
						   test2123_2220 =
						      is_a__118___object(
						      (obj_t) (ffun_2214), global_ast_var);
						   if (test2123_2220)
						     {	/* Cfa/closure.scm 262 */
							bool_t test2124_2221;
							{	/* ./Ast/var.scm 1132 */
							   obj_t aux_4103;
							   {	/* Cfa/closure.scm 262 */
							      sfun_bglt obj_3211;
							      obj_3211 =
								 (sfun_bglt) (sfun_2215);
							      aux_4103 =
								 (((sfun_bglt) CREF(obj_3211))->the_closure_238);
							   }
							   test2124_2221 =
							      is_a__118___object(aux_4103, global_ast_var);
							}
							if (test2124_2221)
							  {	/* ./Ast/var.scm 1205 */
							     obj_t aux_4108;
							     {	/* Cfa/closure.scm 263 */
								value_bglt aux_4109;
								{	/* Cfa/closure.scm 263 */
								   global_bglt obj_3214;
								   {	/* Cfa/closure.scm 263 */
								      obj_t aux_4110;
								      {		/* Cfa/closure.scm 263 */
									 sfun_bglt obj_3213;
									 obj_3213 =
									    (sfun_bglt) (sfun_2215);
									 aux_4110 =
									    (((sfun_bglt) CREF(obj_3213))->the_closure_238);
								      }
								      obj_3214 =
									 (global_bglt) (aux_4110);
								   }
								   aux_4109 =
								      (((global_bglt) CREF(obj_3214))->value);
								}
								aux_4108 =
								   (obj_t) (aux_4109);
							     }
							     test2118_2216 =
								is_a__118___object(aux_4108, scnst_ast_var);
							  }
							else
							  {	/* Cfa/closure.scm 262 */
							     test2118_2216 = ((bool_t) 0);
							  }
						     }
						   else
						     {	/* Cfa/closure.scm 261 */
							test2118_2216 = ((bool_t) 0);
						     }
						}
						if (test2118_2216)
						  {	/* Cfa/closure.scm 264 */
						     obj_t arg2120_2218;
						     arg2120_2218 =
							CNST_TABLE_REF(((long) 2));
						     {	/* Cfa/closure.scm 264 */
							scnst_bglt obj_3218;
							{	/* Cfa/closure.scm 264 */
							   value_bglt aux_4119;
							   {	/* Cfa/closure.scm 264 */
							      global_bglt obj_3217;
							      {		/* Cfa/closure.scm 264 */
								 obj_t aux_4120;
								 {	/* Cfa/closure.scm 264 */
								    sfun_bglt obj_3216;
								    obj_3216 =
								       (sfun_bglt) (sfun_2215);
								    aux_4120 =
								       (((sfun_bglt) CREF(obj_3216))->the_closure_238);
								 }
								 obj_3217 =
								    (global_bglt) (aux_4120);
							      }
							      aux_4119 =
								 (((global_bglt) CREF(obj_3217))->value);
							   }
							   obj_3218 =
							      (scnst_bglt) (aux_4119);
							}
							((((scnst_bglt) CREF(obj_3218))->class) = ((obj_t) arg2120_2218), BUNSPEC);
						     }
						  }
						else
						  {	/* Cfa/closure.scm 261 */
						     BUNSPEC;
						  }
					     }
					     {	/* Cfa/closure.scm 266 */
						var_bglt arg2128_2225;
						{	/* Cfa/closure.scm 266 */
						   app_bglt obj_3220;
						   obj_3220 =
						      (app_bglt) (app_2210);
						   arg2128_2225 =
						      (((app_bglt) CREF(obj_3220))->fun);
						}
						{	/* Cfa/closure.scm 266 */
						   variable_bglt val1209_3222;
						   val1209_3222 =
						      (variable_bglt) (_make_l_procedure__54_cfa_closure);
						   ((((var_bglt) CREF(arg2128_2225))->variable) = ((variable_bglt) val1209_3222), BUNSPEC);
						}
					     }
					     {	/* ./Ieee/pair-list.scm 5896 */
						obj_t aux_4134;
						obj_t aux_4131;
						{	/* ./Ieee/pair-list.scm 5707 */
						   obj_t aux_4135;
						   {	/* ./Ieee/pair-list.scm 5707 */
						      obj_t aux_4136;
						      {		/* Cfa/closure.scm 267 */
							 app_bglt obj_3224;
							 obj_3224 =
							    (app_bglt) (app_2210);
							 aux_4136 =
							    (((app_bglt) CREF(obj_3224))->args);
						      }
						      aux_4135 =
							 CDR(aux_4136);
						   }
						   aux_4134 =
						      CDR(aux_4135);
						}
						{	/* Cfa/closure.scm 267 */
						   app_bglt obj_3223;
						   obj_3223 =
						      (app_bglt) (app_2210);
						   aux_4131 =
						      (((app_bglt) CREF(obj_3223))->args);
						}
						SET_CDR(aux_4131, aux_4134);
					     }
					     {	/* Cfa/closure.scm 268 */
						bool_t test2133_2229;
						test2133_2229 =
						   stack_optimization__133_cfa_stack();
						if (test2133_2229)
						  {	/* Cfa/closure.scm 269 */
						     node_bglt aux_4144;
						     aux_4144 =
							stack__132_cfa_stack(
							(node_bglt) (app_2210));
						     (obj_t) (aux_4144);
						  }
						else
						  {	/* Cfa/closure.scm 268 */
						     app_2210;
						  }
					     }
					  }
				       }
				    }
				 }
			      }
			    else
			      {		/* Cfa/closure.scm 276 */
				 BFALSE;
			      }
			 }
		    }
		 }
		 {
		    obj_t l2047_4148;
		    l2047_4148 =
		       CDR(l2047_2202);
		    l2047_2202 = l2047_4148;
		    goto lname2048_2203;
		 }
	      }
	    else
	      {		/* Cfa/closure.scm 272 */
		 return ((bool_t) 1);
	      }
	 }
      }
   }
}



/* light-funcall! */
bool_t 
light_funcall__169_cfa_closure()
{
   AN_OBJECT;
   {	/* Cfa/closure.scm 282 */
      {
	 obj_t l2050_2261;
	 l2050_2261 = _funcall_list__139_cfa_closure;
       lname2051_2262:
	 if (
	    PAIRP(l2050_2261))
	   {	/* Cfa/closure.scm 283 */
	      {		/* Cfa/closure.scm 283 */
		 funcall_bglt app_2264;
		 {	/* ./Ieee/pair-list.scm 5701 */
		    obj_t aux_4152;
		    aux_4152 =
		       CAR(l2050_2261);
		    app_2264 =
		       (funcall_bglt) (aux_4152);
		 }
		 {	/* Cfa/closure.scm 285 */
		    approx_bglt approx_2266;
		    approx_2266 =
		       cfa__102_cfa_cfa(
		       (((funcall_bglt) CREF(app_2264))->fun));
		    {	/* Cfa/closure.scm 286 */
		       obj_t alloc_list_184_2267;
		       alloc_list_184_2267 =
			  set__list_248_cfa_set(
			  (((approx_bglt) CREF(approx_2266))->allocs));
		       {	/* Cfa/closure.scm 287 */

			  {	/* Cfa/closure.scm 288 */
			     bool_t test2162_2268;
			     if (
				PAIRP(alloc_list_184_2267))
			       {	/* Cfa/closure.scm 289 */
				  bool_t test2171_2281;
				  test2171_2281 =
				     is_a__118___object(
				     CAR(alloc_list_184_2267), make_procedure_app_48_cfa_info2);
				  if (test2171_2281)
				    {	/* Cfa/closure.scm 289 */
				       test2162_2268 = ((bool_t) 0);
				    }
				  else
				    {	/* Cfa/closure.scm 289 */
				       test2162_2268 = ((bool_t) 1);
				    }
			       }
			     else
			       {	/* Cfa/closure.scm 288 */
				  test2162_2268 = ((bool_t) 1);
			       }
			     if (test2162_2268)
			       {	/* Cfa/closure.scm 288 */
				  CNST_TABLE_REF(((long) 4));
			       }
			     else
			       {	/* Cfa/closure.scm 293 */
				  app_bglt alloc_2269;
				  {	/* ./Ieee/pair-list.scm 5701 */
				     obj_t aux_4166;
				     aux_4166 =
					CAR(alloc_list_184_2267);
				     alloc_2269 =
					(app_bglt) (aux_4166);
				  }
				  {	/* Cfa/closure.scm 296 */
				     bool_t test_4169;
				     {	/* Cfa/closure.scm 296 */
					make_procedure_app_48_bglt obj_3275;
					obj_3275 =
					   (make_procedure_app_48_bglt) (alloc_2269);
					{
					   obj_t aux_4171;
					   {	/* ./Cfa/cinfo2.scm 1571 */
					      object_bglt aux_4172;
					      aux_4172 =
						 (object_bglt) (obj_3275);
					      aux_4171 =
						 OBJECT_WIDENING(aux_4172);
					   }
					   test_4169 =
					      (((make_procedure_app_48_bglt) CREF(aux_4171))->x);
					}
				     }
				     if (test_4169)
				       {	/* Cfa/closure.scm 296 */
					  {	/* Cfa/closure.scm 300 */
					     var_bglt arg2164_2272;
					     {	/* Cfa/closure.scm 300 */
						var_bglt duplicated2053_2273;
						{	/* ./Ieee/pair-list.scm 5701 */
						   obj_t aux_4176;
						   {	/* ./Ieee/pair-list.scm 5701 */
						      obj_t aux_4177;
						      aux_4177 =
							 (((app_bglt) CREF(alloc_2269))->args);
						      aux_4176 =
							 CAR(aux_4177);
						   }
						   duplicated2053_2273 =
						      (var_bglt) (aux_4176);
						}
						{	/* Cfa/closure.scm 300 */
						   var_bglt new2054_2274;
						   {	/* Cfa/closure.scm 300 */
						      obj_t arg2165_2275;
						      type_bglt arg2166_2276;
						      variable_bglt arg2167_2277;
						      arg2165_2275 =
							 (((var_bglt) CREF(duplicated2053_2273))->loc);
						      arg2166_2276 =
							 (((var_bglt) CREF(duplicated2053_2273))->type);
						      arg2167_2277 =
							 (((var_bglt) CREF(duplicated2053_2273))->variable);
						      {		/* Cfa/closure.scm 300 */
							 var_bglt res2463_3291;
							 {	/* ./Ast/node.scm 1266 */
							    var_bglt new1210_3284;
							    new1210_3284 =
							       ((var_bglt) BREF(GC_MALLOC(sizeof(struct var))));
							    {	/* ./Ast/node.scm 1266 */
							       long arg2432_3285;
							       arg2432_3285 =
								  class_num_218___object(var_ast_node);
							       {	/* ./Ast/node.scm 1266 */
								  obj_t obj_3289;
								  obj_3289 =
								     (obj_t) (new1210_3284);
								  (((obj_t) CREF(obj_3289))->header = MAKE_HEADER(arg2432_3285, 0), BUNSPEC);
							       }
							    }
							    {	/* ./Ast/node.scm 1266 */
							       object_bglt aux_4188;
							       aux_4188 =
								  (object_bglt) (new1210_3284);
							       OBJECT_WIDENING_SET(aux_4188, BFALSE);
							    }
							    ((((var_bglt) CREF(new1210_3284))->loc) = ((obj_t) arg2165_2275), BUNSPEC);
							    ((((var_bglt) CREF(new1210_3284))->type) = ((type_bglt) arg2166_2276), BUNSPEC);
							    ((((var_bglt) CREF(new1210_3284))->variable) = ((variable_bglt) arg2167_2277), BUNSPEC);
							    res2463_3291 = new1210_3284;
							 }
							 new2054_2274 = res2463_3291;
						      }
						   }
						   {	/* Cfa/closure.scm 300 */

						      arg2164_2272 = new2054_2274;
						   }
						}
					     }
					     {	/* Cfa/closure.scm 298 */
						node_bglt val1269_3293;
						val1269_3293 =
						   (node_bglt) (arg2164_2272);
						((((funcall_bglt) CREF(app_2264))->fun) = ((node_bglt) val1269_3293), BUNSPEC);
					     }
					  }
					  {	/* Cfa/closure.scm 301 */
					     obj_t val1271_3295;
					     val1271_3295 =
						CNST_TABLE_REF(((long) 5));
					     ((((funcall_bglt) CREF(app_2264))->strength) = ((obj_t) val1271_3295), BUNSPEC);
					  }
				       }
				     else
				       {	/* Cfa/closure.scm 302 */
					  bool_t test_4198;
					  {	/* Cfa/closure.scm 302 */
					     make_procedure_app_48_bglt obj_3296;
					     obj_3296 =
						(make_procedure_app_48_bglt) (alloc_2269);
					     {
						obj_t aux_4200;
						{	/* ./Cfa/cinfo2.scm 1572 */
						   object_bglt aux_4201;
						   aux_4201 =
						      (object_bglt) (obj_3296);
						   aux_4200 =
						      OBJECT_WIDENING(aux_4201);
						}
						test_4198 =
						   (((make_procedure_app_48_bglt) CREF(aux_4200))->t);
					     }
					  }
					  if (test_4198)
					    {	/* Cfa/closure.scm 302 */
					       {	/* Cfa/closure.scm 304 */
						  obj_t val1271_3298;
						  val1271_3298 =
						     CNST_TABLE_REF(((long) 6));
						  ((((funcall_bglt) CREF(app_2264))->strength) = ((obj_t) val1271_3298), BUNSPEC);
					       }
					    }
					  else
					    {	/* Cfa/closure.scm 302 */
					       CNST_TABLE_REF(((long) 4));
					    }
				       }
				  }
			       }
			  }
		       }
		    }
		 }
	      }
	      {
		 obj_t l2050_4208;
		 l2050_4208 =
		    CDR(l2050_2261);
		 l2050_2261 = l2050_4208;
		 goto lname2051_2262;
	      }
	   }
	 else
	   {	/* Cfa/closure.scm 283 */
	      return ((bool_t) 1);
	   }
      }
   }
}



/* light-access! */
bool_t 
light_access__52_cfa_closure()
{
   AN_OBJECT;
   {	/* Cfa/closure.scm 313 */
      {
	 obj_t l2055_2285;
	 l2055_2285 = _procedure_ref_list__19_cfa_closure;
       lname2056_2286:
	 if (
	    PAIRP(l2055_2285))
	   {	/* Cfa/closure.scm 314 */
	      {		/* Cfa/closure.scm 316 */
		 obj_t app_2288;
		 app_2288 =
		    CAR(l2055_2285);
		 {	/* Cfa/closure.scm 316 */
		    approx_bglt approx_2290;
		    {	/* Cfa/closure.scm 317 */
		       node_bglt aux_4213;
		       {	/* Cfa/closure.scm 317 */
			  obj_t aux_4214;
			  {	/* ./Ieee/pair-list.scm 5701 */
			     obj_t aux_4215;
			     {	/* Cfa/closure.scm 317 */
				app_bglt obj_3303;
				obj_3303 =
				   (app_bglt) (app_2288);
				aux_4215 =
				   (((app_bglt) CREF(obj_3303))->args);
			     }
			     aux_4214 =
				CAR(aux_4215);
			  }
			  aux_4213 =
			     (node_bglt) (aux_4214);
		       }
		       approx_2290 =
			  cfa__102_cfa_cfa(aux_4213);
		    }
		    {	/* Cfa/closure.scm 317 */
		       obj_t alloc_list_184_2291;
		       alloc_list_184_2291 =
			  set__list_248_cfa_set(
			  (((approx_bglt) CREF(approx_2290))->allocs));
		       {	/* Cfa/closure.scm 318 */
			  var_bglt fun_2292;
			  {	/* Cfa/closure.scm 319 */
			     app_bglt obj_3306;
			     obj_3306 =
				(app_bglt) (app_2288);
			     fun_2292 =
				(((app_bglt) CREF(obj_3306))->fun);
			  }
			  {	/* Cfa/closure.scm 319 */
			     variable_bglt vfun_2293;
			     vfun_2293 =
				(((var_bglt) CREF(fun_2292))->variable);
			     {	/* Cfa/closure.scm 320 */

				{	/* Cfa/closure.scm 321 */
				   bool_t test2176_2294;
				   if (
				      PAIRP(alloc_list_184_2291))
				     {	/* Cfa/closure.scm 322 */
					bool_t test2189_2308;
					test2189_2308 =
					   is_a__118___object(
					   CAR(alloc_list_184_2291), make_procedure_app_48_cfa_info2);
					if (test2189_2308)
					  {	/* Cfa/closure.scm 322 */
					     test2176_2294 = ((bool_t) 0);
					  }
					else
					  {	/* Cfa/closure.scm 322 */
					     test2176_2294 = ((bool_t) 1);
					  }
				     }
				   else
				     {	/* Cfa/closure.scm 321 */
					test2176_2294 = ((bool_t) 1);
				     }
				   if (test2176_2294)
				     {	/* Cfa/closure.scm 321 */
					CNST_TABLE_REF(((long) 4));
				     }
				   else
				     {	/* Cfa/closure.scm 324 */
					app_bglt alloc_2295;
					{	/* ./Ieee/pair-list.scm 5701 */
					   obj_t aux_4233;
					   aux_4233 =
					      CAR(alloc_list_184_2291);
					   alloc_2295 =
					      (app_bglt) (aux_4233);
					}
					{	/* Cfa/closure.scm 327 */
					   bool_t test_4236;
					   {	/* Cfa/closure.scm 327 */
					      make_procedure_app_48_bglt obj_3312;
					      obj_3312 =
						 (make_procedure_app_48_bglt) (alloc_2295);
					      {
						 obj_t aux_4238;
						 {	/* ./Cfa/cinfo2.scm 1571 */
						    object_bglt aux_4239;
						    aux_4239 =
						       (object_bglt) (obj_3312);
						    aux_4238 =
						       OBJECT_WIDENING(aux_4239);
						 }
						 test_4236 =
						    (((make_procedure_app_48_bglt) CREF(aux_4238))->x);
					      }
					   }
					   if (test_4236)
					     {	/* Cfa/closure.scm 327 */
						{	/* Cfa/closure.scm 328 */
						   bool_t test2178_2298;
						   {	/* Cfa/closure.scm 328 */
						      obj_t arg2181_2301;
						      {		/* Cfa/closure.scm 328 */
							 node_bglt aux_4243;
							 {	/* Cfa/closure.scm 328 */
							    obj_t aux_4244;
							    {	/* ./Ieee/pair-list.scm 5701 */
							       obj_t aux_4245;
							       {	/* ./Ieee/pair-list.scm 5707 */
								  obj_t aux_4246;
								  {	/* ./Ieee/pair-list.scm 5707 */
								     obj_t aux_4247;
								     aux_4247 =
									(((app_bglt) CREF(alloc_2295))->args);
								     aux_4246 =
									CDR(aux_4247);
								  }
								  aux_4245 =
								     CDR(aux_4246);
							       }
							       aux_4244 =
								  CAR(aux_4245);
							    }
							    aux_4243 =
							       (node_bglt) (aux_4244);
							 }
							 arg2181_2301 =
							    get_node_atom_value_135_cfa_approx(aux_4243);
						      }
						      {		/* ./Ieee/fixnum.scm 7109 */
							 long aux_4254;
							 aux_4254 =
							    (long) CINT(arg2181_2301);
							 test2178_2298 =
							    (aux_4254 == ((long) 1));
						      }
						   }
						   if (test2178_2298)
						     {	/* Cfa/closure.scm 329 */
							bool_t test2179_2299;
							{	/* Cfa/closure.scm 329 */
							   obj_t obj2_3323;
							   obj2_3323 = _procedure_ref__66_cfa_closure;
							   {	/* ./Ieee/equiv.scm 5508 */
							      obj_t aux_4258;
							      aux_4258 =
								 (obj_t) (vfun_2293);
							      test2179_2299 =
								 (aux_4258 == obj2_3323);
							   }
							}
							if (test2179_2299)
							  {	/* Cfa/closure.scm 330 */
							     variable_bglt val1209_3325;
							     val1209_3325 =
								(variable_bglt) (_procedure_1_el_ref__37_cfa_closure);
							     ((((var_bglt) CREF(fun_2292))->variable) = ((variable_bglt) val1209_3325), BUNSPEC);
							  }
							else
							  {	/* Cfa/closure.scm 331 */
							     variable_bglt val1209_3327;
							     val1209_3327 =
								(variable_bglt) (_procedure_1_el_set___97_cfa_closure);
							     ((((var_bglt) CREF(fun_2292))->variable) = ((variable_bglt) val1209_3327), BUNSPEC);
							  }
						     }
						   else
						     {	/* Cfa/closure.scm 332 */
							bool_t test2180_2300;
							{	/* Cfa/closure.scm 332 */
							   obj_t obj2_3329;
							   obj2_3329 = _procedure_ref__66_cfa_closure;
							   {	/* ./Ieee/equiv.scm 5508 */
							      obj_t aux_4266;
							      aux_4266 =
								 (obj_t) (vfun_2293);
							      test2180_2300 =
								 (aux_4266 == obj2_3329);
							   }
							}
							if (test2180_2300)
							  {	/* Cfa/closure.scm 333 */
							     variable_bglt val1209_3331;
							     val1209_3331 =
								(variable_bglt) (_procedure_el_ref__61_cfa_closure);
							     ((((var_bglt) CREF(fun_2292))->variable) = ((variable_bglt) val1209_3331), BUNSPEC);
							  }
							else
							  {	/* Cfa/closure.scm 334 */
							     variable_bglt val1209_3333;
							     val1209_3333 =
								(variable_bglt) (_procedure_el_set___46_cfa_closure);
							     ((((var_bglt) CREF(fun_2292))->variable) = ((variable_bglt) val1209_3333), BUNSPEC);
							  }
						     }
						}
					     }
					   else
					     {	/* Cfa/closure.scm 335 */
						bool_t test_4274;
						{	/* Cfa/closure.scm 335 */
						   make_procedure_app_48_bglt obj_3334;
						   obj_3334 =
						      (make_procedure_app_48_bglt) (alloc_2295);
						   {
						      obj_t aux_4276;
						      {		/* ./Cfa/cinfo2.scm 1572 */
							 object_bglt aux_4277;
							 aux_4277 =
							    (object_bglt) (obj_3334);
							 aux_4276 =
							    OBJECT_WIDENING(aux_4277);
						      }
						      test_4274 =
							 (((make_procedure_app_48_bglt) CREF(aux_4276))->t);
						   }
						}
						if (test_4274)
						  {	/* Cfa/closure.scm 335 */
						     {	/* Cfa/closure.scm 336 */
							bool_t test2187_2306;
							{	/* Cfa/closure.scm 336 */
							   obj_t obj2_3336;
							   obj2_3336 = _procedure_ref__66_cfa_closure;
							   {	/* ./Ieee/equiv.scm 5508 */
							      obj_t aux_4281;
							      aux_4281 =
								 (obj_t) (vfun_2293);
							      test2187_2306 =
								 (aux_4281 == obj2_3336);
							   }
							}
							if (test2187_2306)
							  {	/* Cfa/closure.scm 337 */
							     variable_bglt val1209_3338;
							     val1209_3338 =
								(variable_bglt) (_procedure_l_ref__76_cfa_closure);
							     ((((var_bglt) CREF(fun_2292))->variable) = ((variable_bglt) val1209_3338), BUNSPEC);
							  }
							else
							  {	/* Cfa/closure.scm 338 */
							     variable_bglt val1209_3340;
							     val1209_3340 =
								(variable_bglt) (_procedure_l_set___202_cfa_closure);
							     ((((var_bglt) CREF(fun_2292))->variable) = ((variable_bglt) val1209_3340), BUNSPEC);
							  }
						     }
						  }
						else
						  {	/* Cfa/closure.scm 335 */
						     BFALSE;
						  }
					     }
					}
				     }
				}
			     }
			  }
		       }
		    }
		 }
	      }
	      {
		 obj_t l2055_4289;
		 l2055_4289 =
		    CDR(l2055_2285);
		 l2055_2285 = l2055_4289;
		 goto lname2056_2286;
	      }
	   }
	 else
	   {	/* Cfa/closure.scm 314 */
	      return ((bool_t) 1);
	   }
      }
   }
}



/* show-x-t */
obj_t 
show_x_t_233_cfa_closure(obj_t allocs_4)
{
   AN_OBJECT;
   {	/* Cfa/closure.scm 344 */
      {
	 obj_t xp_2315;
	 obj_t tp_2316;
	 obj_t allocs_2317;
	 xp_2315 = BNIL;
	 tp_2316 = BNIL;
	 allocs_2317 = allocs_4;
       loop_2318:
	 if (
	    NULLP(allocs_2317))
	   {	/* Cfa/closure.scm 355 */
	      show_cfa_closure(
		 CNST_TABLE_REF(((long) 7)), xp_2315);
	      show_cfa_closure(
		 CNST_TABLE_REF(((long) 8)), tp_2316);
	      return BUNSPEC;
	   }
	 else
	   {	/* Cfa/closure.scm 360 */
	      obj_t instance2060_2320;
	      instance2060_2320 =
		 CAR(allocs_2317);
	      {		/* Cfa/closure.scm 362 */
		 bool_t test_4298;
		 {	/* Cfa/closure.scm 362 */
		    make_procedure_app_48_bglt obj_3344;
		    obj_3344 =
		       (make_procedure_app_48_bglt) (instance2060_2320);
		    {
		       obj_t aux_4300;
		       {	/* ./Cfa/cinfo2.scm 1571 */
			  object_bglt aux_4301;
			  aux_4301 =
			     (object_bglt) (obj_3344);
			  aux_4300 =
			     OBJECT_WIDENING(aux_4301);
		       }
		       test_4298 =
			  (((make_procedure_app_48_bglt) CREF(aux_4300))->x);
		    }
		 }
		 if (test_4298)
		   {	/* Cfa/closure.scm 362 */
		      {		/* Cfa/closure.scm 363 */
			 obj_t arg2198_2322;
			 obj_t arg2199_2323;
			 {	/* ./Ieee/pair-list.scm 5689 */
			    obj_t aux_4305;
			    {	/* Cfa/closure.scm 363 */
			       variable_bglt aux_4306;
			       {	/* Cfa/closure.scm 363 */
				  var_bglt obj_3347;
				  {	/* Cfa/closure.scm 363 */
				     obj_t aux_4307;
				     {	/* ./Ieee/pair-list.scm 5701 */
					obj_t aux_4308;
					{	/* Cfa/closure.scm 363 */
					   app_bglt obj_3345;
					   obj_3345 =
					      (app_bglt) (instance2060_2320);
					   aux_4308 =
					      (((app_bglt) CREF(obj_3345))->args);
					}
					aux_4307 =
					   CAR(aux_4308);
				     }
				     obj_3347 =
					(var_bglt) (aux_4307);
				  }
				  aux_4306 =
				     (((var_bglt) CREF(obj_3347))->variable);
			       }
			       aux_4305 =
				  (obj_t) (aux_4306);
			    }
			    arg2198_2322 =
			       MAKE_PAIR(aux_4305, xp_2315);
			 }
			 arg2199_2323 =
			    CDR(allocs_2317);
			 {
			    obj_t allocs_4318;
			    obj_t xp_4317;
			    xp_4317 = arg2198_2322;
			    allocs_4318 = arg2199_2323;
			    allocs_2317 = allocs_4318;
			    xp_2315 = xp_4317;
			    goto loop_2318;
			 }
		      }
		   }
		 else
		   {	/* Cfa/closure.scm 364 */
		      bool_t test_4319;
		      {		/* Cfa/closure.scm 364 */
			 make_procedure_app_48_bglt obj_3351;
			 obj_3351 =
			    (make_procedure_app_48_bglt) (instance2060_2320);
			 {
			    obj_t aux_4321;
			    {	/* ./Cfa/cinfo2.scm 1572 */
			       object_bglt aux_4322;
			       aux_4322 =
				  (object_bglt) (obj_3351);
			       aux_4321 =
				  OBJECT_WIDENING(aux_4322);
			    }
			    test_4319 =
			       (((make_procedure_app_48_bglt) CREF(aux_4321))->t);
			 }
		      }
		      if (test_4319)
			{	/* Cfa/closure.scm 364 */
			   {	/* Cfa/closure.scm 365 */
			      obj_t arg2204_2328;
			      obj_t arg2206_2329;
			      {		/* ./Ieee/pair-list.scm 5689 */
				 obj_t aux_4326;
				 {	/* Cfa/closure.scm 365 */
				    variable_bglt aux_4327;
				    {	/* Cfa/closure.scm 365 */
				       var_bglt obj_3354;
				       {	/* Cfa/closure.scm 365 */
					  obj_t aux_4328;
					  {	/* ./Ieee/pair-list.scm 5701 */
					     obj_t aux_4329;
					     {	/* Cfa/closure.scm 365 */
						app_bglt obj_3352;
						obj_3352 =
						   (app_bglt) (instance2060_2320);
						aux_4329 =
						   (((app_bglt) CREF(obj_3352))->args);
					     }
					     aux_4328 =
						CAR(aux_4329);
					  }
					  obj_3354 =
					     (var_bglt) (aux_4328);
				       }
				       aux_4327 =
					  (((var_bglt) CREF(obj_3354))->variable);
				    }
				    aux_4326 =
				       (obj_t) (aux_4327);
				 }
				 arg2204_2328 =
				    MAKE_PAIR(aux_4326, tp_2316);
			      }
			      arg2206_2329 =
				 CDR(allocs_2317);
			      {
				 obj_t allocs_4339;
				 obj_t tp_4338;
				 tp_4338 = arg2204_2328;
				 allocs_4339 = arg2206_2329;
				 allocs_2317 = allocs_4339;
				 tp_2316 = tp_4338;
				 goto loop_2318;
			      }
			   }
			}
		      else
			{	/* Cfa/closure.scm 364 */
			   {
			      obj_t allocs_4340;
			      allocs_4340 =
				 CDR(allocs_2317);
			      allocs_2317 = allocs_4340;
			      goto loop_2318;
			   }
			}
		   }
	      }
	   }
      }
   }
}



/* show */
obj_t 
show_cfa_closure(obj_t prop_2334, obj_t l_2335)
{
   AN_OBJECT;
   {	/* Cfa/closure.scm 345 */
      if (
	 PAIRP(l_2335))
	{	/* Cfa/closure.scm 346 */
	   {	/* Cfa/closure.scm 348 */
	      obj_t arg2216_2341;
	      arg2216_2341 =
		 shape_tools_shape(
		 CAR(l_2335));
	      {		/* Cfa/closure.scm 348 */
		 obj_t list2217_2342;
		 {	/* Cfa/closure.scm 348 */
		    obj_t arg2219_2343;
		    {	/* Cfa/closure.scm 348 */
		       obj_t arg2220_2344;
		       {	/* Cfa/closure.scm 348 */
			  obj_t arg2221_2345;
			  {	/* Cfa/closure.scm 348 */
			     obj_t arg2223_2346;
			     {	/* Cfa/closure.scm 348 */
				obj_t aux_4346;
				aux_4346 =
				   BCHAR(((unsigned char) '\n'));
				arg2223_2346 =
				   MAKE_PAIR(aux_4346, BNIL);
			     }
			     arg2221_2345 =
				MAKE_PAIR(arg2216_2341, arg2223_2346);
			  }
			  arg2220_2344 =
			     MAKE_PAIR(string2470_cfa_closure, arg2221_2345);
		       }
		       arg2219_2343 =
			  MAKE_PAIR(prop_2334, arg2220_2344);
		    }
		    list2217_2342 =
		       MAKE_PAIR(string2471_cfa_closure, arg2219_2343);
		 }
		 verbose_tools_speek(
		    BINT(((long) 2)), list2217_2342);
	      }
	   }
	   {
	      obj_t l2058_2348;
	      {		/* Cfa/closure.scm 349 */
		 bool_t aux_4355;
		 l2058_2348 =
		    CDR(l_2335);
	       lname2059_2349:
		 if (
		    PAIRP(l2058_2348))
		   {	/* Cfa/closure.scm 349 */
		      {		/* Cfa/closure.scm 350 */
			 obj_t arg2229_2355;
			 arg2229_2355 =
			    shape_tools_shape(
			    CAR(l2058_2348));
			 {	/* Cfa/closure.scm 350 */
			    obj_t list2230_2356;
			    {	/* Cfa/closure.scm 350 */
			       obj_t arg2231_2357;
			       {	/* Cfa/closure.scm 350 */
				  obj_t arg2232_2358;
				  {	/* Cfa/closure.scm 350 */
				     obj_t aux_4360;
				     aux_4360 =
					BCHAR(((unsigned char) '\n'));
				     arg2232_2358 =
					MAKE_PAIR(aux_4360, BNIL);
				  }
				  arg2231_2357 =
				     MAKE_PAIR(arg2229_2355, arg2232_2358);
			       }
			       list2230_2356 =
				  MAKE_PAIR(string2472_cfa_closure, arg2231_2357);
			    }
			    verbose_tools_speek(
			       BINT(((long) 2)), list2230_2356);
			 }
		      }
		      {
			 obj_t l2058_4367;
			 l2058_4367 =
			    CDR(l2058_2348);
			 l2058_2348 = l2058_4367;
			 goto lname2059_2349;
		      }
		   }
		 else
		   {	/* Cfa/closure.scm 349 */
		      aux_4355 = ((bool_t) 1);
		   }
		 return
		    BBOOL(aux_4355);
	      }
	   }
	}
      else
	{	/* Cfa/closure.scm 346 */
	   return BUNSPEC;
	}
   }
}



/* add-funcall! */
obj_t 
add_funcall__195_cfa_closure(node_bglt ast_5)
{
   AN_OBJECT;
   {	/* Cfa/closure.scm 379 */
      {		/* Cfa/closure.scm 380 */
	 bool_t test2234_2361;
	 {	/* Cfa/closure.scm 50 */
	    long n1_3365;
	    n1_3365 =
	       (long) CINT(_optim__89_engine_param);
	    test2234_2361 =
	       (n1_3365 >= ((long) 2));
	 }
	 if (test2234_2361)
	   {	/* Cfa/closure.scm 381 */
	      obj_t obj2_3368;
	      obj2_3368 = _funcall_list__139_cfa_closure;
	      {		/* ./Ieee/pair-list.scm 5689 */
		 obj_t aux_4374;
		 aux_4374 =
		    (obj_t) (ast_5);
		 return (
		    _funcall_list__139_cfa_closure =
		    MAKE_PAIR(aux_4374, obj2_3368), BUNSPEC);
	      }
	   }
	 else
	   {	/* Cfa/closure.scm 380 */
	      return BUNSPEC;
	   }
      }
   }
}



/* _add-funcall!2464 */
obj_t 
_add_funcall_2464_39_cfa_closure(obj_t env_3739, obj_t ast_3740)
{
   AN_OBJECT;
   {	/* Cfa/closure.scm 379 */
      return
	 add_funcall__195_cfa_closure(
	 (node_bglt) (ast_3740));
   }
}



/* add-make-procedure! */
obj_t 
add_make_procedure__219_cfa_closure(node_bglt ast_6)
{
   AN_OBJECT;
   {	/* Cfa/closure.scm 386 */
      {		/* Cfa/closure.scm 387 */
	 bool_t test2235_2362;
	 {	/* Cfa/closure.scm 50 */
	    long n1_3369;
	    n1_3369 =
	       (long) CINT(_optim__89_engine_param);
	    test2235_2362 =
	       (n1_3369 >= ((long) 2));
	 }
	 if (test2235_2362)
	   {	/* Cfa/closure.scm 388 */
	      obj_t obj2_3372;
	      obj2_3372 = _make_procedure_list__56_cfa_closure;
	      {		/* ./Ieee/pair-list.scm 5689 */
		 obj_t aux_4382;
		 aux_4382 =
		    (obj_t) (ast_6);
		 return (
		    _make_procedure_list__56_cfa_closure =
		    MAKE_PAIR(aux_4382, obj2_3372), BUNSPEC);
	      }
	   }
	 else
	   {	/* Cfa/closure.scm 387 */
	      return BUNSPEC;
	   }
      }
   }
}



/* _add-make-procedure!2465 */
obj_t 
_add_make_procedure_2465_29_cfa_closure(obj_t env_3741, obj_t ast_3742)
{
   AN_OBJECT;
   {	/* Cfa/closure.scm 386 */
      return
	 add_make_procedure__219_cfa_closure(
	 (node_bglt) (ast_3742));
   }
}



/* add-procedure-ref! */
obj_t 
add_procedure_ref__36_cfa_closure(node_bglt ast_7)
{
   AN_OBJECT;
   {	/* Cfa/closure.scm 393 */
      {		/* Cfa/closure.scm 394 */
	 bool_t test2236_2363;
	 {	/* Cfa/closure.scm 50 */
	    long n1_3373;
	    n1_3373 =
	       (long) CINT(_optim__89_engine_param);
	    test2236_2363 =
	       (n1_3373 >= ((long) 2));
	 }
	 if (test2236_2363)
	   {	/* Cfa/closure.scm 395 */
	      obj_t obj2_3376;
	      obj2_3376 = _procedure_ref_list__19_cfa_closure;
	      {		/* ./Ieee/pair-list.scm 5689 */
		 obj_t aux_4390;
		 aux_4390 =
		    (obj_t) (ast_7);
		 return (
		    _procedure_ref_list__19_cfa_closure =
		    MAKE_PAIR(aux_4390, obj2_3376), BUNSPEC);
	      }
	   }
	 else
	   {	/* Cfa/closure.scm 394 */
	      return BUNSPEC;
	   }
      }
   }
}



/* _add-procedure-ref!2466 */
obj_t 
_add_procedure_ref_2466_197_cfa_closure(obj_t env_3743, obj_t ast_3744)
{
   AN_OBJECT;
   {	/* Cfa/closure.scm 393 */
      return
	 add_procedure_ref__36_cfa_closure(
	 (node_bglt) (ast_3744));
   }
}



/* start-cache */
obj_t 
start_cache_11_cfa_closure()
{
   AN_OBJECT;
   {	/* Cfa/closure.scm 415 */
      _procedure_ref__66_cfa_closure =
	 find_global_module_25_ast_env(
	 CNST_TABLE_REF(((long) 9)),
	 CNST_TABLE_REF(((long) 10)));
      _procedure_set___197_cfa_closure =
	 find_global_module_25_ast_env(
	 CNST_TABLE_REF(((long) 11)),
	 CNST_TABLE_REF(((long) 10)));
      _procedure_l_ref__76_cfa_closure =
	 find_global_module_25_ast_env(
	 CNST_TABLE_REF(((long) 12)),
	 CNST_TABLE_REF(((long) 10)));
      _procedure_l_set___202_cfa_closure =
	 find_global_module_25_ast_env(
	 CNST_TABLE_REF(((long) 13)),
	 CNST_TABLE_REF(((long) 10)));
      _procedure_el_ref__61_cfa_closure =
	 find_global_module_25_ast_env(
	 CNST_TABLE_REF(((long) 14)),
	 CNST_TABLE_REF(((long) 10)));
      _procedure_el_set___46_cfa_closure =
	 find_global_module_25_ast_env(
	 CNST_TABLE_REF(((long) 15)),
	 CNST_TABLE_REF(((long) 10)));
      _procedure_1_el_ref__37_cfa_closure =
	 find_global_module_25_ast_env(
	 CNST_TABLE_REF(((long) 16)),
	 CNST_TABLE_REF(((long) 10)));
      _procedure_1_el_set___97_cfa_closure =
	 find_global_module_25_ast_env(
	 CNST_TABLE_REF(((long) 17)),
	 CNST_TABLE_REF(((long) 10)));
      _make_el_procedure__202_cfa_closure =
	 find_global_module_25_ast_env(
	 CNST_TABLE_REF(((long) 18)),
	 CNST_TABLE_REF(((long) 10)));
      _make_el_procedure_1__141_cfa_closure =
	 find_global_module_25_ast_env(
	 CNST_TABLE_REF(((long) 19)),
	 CNST_TABLE_REF(((long) 10)));
      return (
	 _make_l_procedure__54_cfa_closure =
	 find_global_module_25_ast_env(
	    CNST_TABLE_REF(((long) 20)),
	    CNST_TABLE_REF(((long) 10))), BUNSPEC);
   }
}



/* stop-cache */
obj_t 
stop_cache_174_cfa_closure()
{
   AN_OBJECT;
   {	/* Cfa/closure.scm 431 */
      _procedure_ref__66_cfa_closure = BFALSE;
      _procedure_set___197_cfa_closure = BFALSE;
      _procedure_l_ref__76_cfa_closure = BFALSE;
      _procedure_l_set___202_cfa_closure = BFALSE;
      _procedure_el_ref__61_cfa_closure = BFALSE;
      _procedure_el_set___46_cfa_closure = BFALSE;
      _procedure_1_el_ref__37_cfa_closure = BFALSE;
      _procedure_1_el_set___97_cfa_closure = BFALSE;
      _make_el_procedure__202_cfa_closure = BFALSE;
      _make_el_procedure_1__141_cfa_closure = BFALSE;
      return (
	 _make_l_procedure__54_cfa_closure = BFALSE, BUNSPEC);
   }
}



/* method-init */
obj_t 
method_init_76_cfa_closure()
{
   AN_OBJECT;
   {	/* Cfa/closure.scm 24 */
      return BUNSPEC;
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_cfa_closure()
{
   AN_OBJECT;
   {	/* Cfa/closure.scm 24 */
      module_initialization_70_tools_trace(((long) 0), "CFA_CLOSURE");
      module_initialization_70_engine_param(((long) 0), "CFA_CLOSURE");
      module_initialization_70_type_type(((long) 0), "CFA_CLOSURE");
      module_initialization_70_type_cache(((long) 0), "CFA_CLOSURE");
      module_initialization_70_tools_shape(((long) 0), "CFA_CLOSURE");
      module_initialization_70_tools_speek(((long) 0), "CFA_CLOSURE");
      module_initialization_70_ast_var(((long) 0), "CFA_CLOSURE");
      module_initialization_70_ast_node(((long) 0), "CFA_CLOSURE");
      module_initialization_70_ast_env(((long) 0), "CFA_CLOSURE");
      module_initialization_70_cfa_info(((long) 0), "CFA_CLOSURE");
      module_initialization_70_cfa_info2(((long) 0), "CFA_CLOSURE");
      module_initialization_70_cfa_cfa(((long) 0), "CFA_CLOSURE");
      module_initialization_70_cfa_approx(((long) 0), "CFA_CLOSURE");
      module_initialization_70_cfa_set(((long) 0), "CFA_CLOSURE");
      return
	 module_initialization_70_cfa_stack(((long) 0), "CFA_CLOSURE");
   }
}
