/*===========================================================================*/
/*   (Cfa/collect.scm)                                                       */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct ccomp
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t producer;
     obj_t consumer;
     obj_t finalizer;
     obj_t checksummer;
  }
     *ccomp_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;

typedef struct approx
  {
     header_t header;
     obj_t widening;
     struct type *type;
     bool_t type_locked__184;
     obj_t allocs;
     bool_t top__138;
     long lost_stamp_114;
  }
      *approx_bglt;

typedef struct cfun_cinfo_200
  {
     struct approx *approx;
  }
              *cfun_cinfo_200_bglt;

typedef struct extern_sfun_cinfo_6
  {
     struct approx *approx;
  }
                   *extern_sfun_cinfo_6_bglt;

typedef struct intern_sfun_cinfo_192
  {
     struct approx *approx;
     long stamp;
  }
                     *intern_sfun_cinfo_192_bglt;

typedef struct scnst_cinfo_0
  {
     struct approx *approx;
  }
             *scnst_cinfo_0_bglt;

typedef struct pre_clo_env_191
  {
     char dummy;
  }
               *pre_clo_env_191_bglt;

typedef struct svar_cinfo_166
  {
     struct approx *approx;
     bool_t clo_env__87;
  }
              *svar_cinfo_166_bglt;

typedef struct cvar_cinfo_53
  {
     struct approx *approx;
  }
             *cvar_cinfo_53_bglt;

typedef struct sexit_cinfo_49
  {
     struct approx *approx;
  }
              *sexit_cinfo_49_bglt;

typedef struct reshaped_local_224
  {
     obj_t binding_value_3;
  }
                  *reshaped_local_224_bglt;

typedef struct reshaped_global_160
  {
     char dummy;
  }
                   *reshaped_global_160_bglt;

typedef struct atom_cinfo_155
  {
     struct approx *approx;
  }
              *atom_cinfo_155_bglt;

typedef struct kwote_node_102
  {
     struct node *node;
  }
              *kwote_node_102_bglt;

typedef struct kwote_cinfo_48
  {
     struct approx *approx;
  }
              *kwote_cinfo_48_bglt;

typedef struct app_ly_cinfo_234
  {
     struct approx *approx;
  }
                *app_ly_cinfo_234_bglt;

typedef struct funcall_cinfo_75
  {
     struct approx *approx;
     struct approx *va_approx_63;
     bool_t arity_error_noticed__118;
     bool_t type_error_noticed__36;
  }
                *funcall_cinfo_75_bglt;

typedef struct pragma_cinfo_220
  {
     struct approx *approx;
  }
                *pragma_cinfo_220_bglt;

typedef struct setq_cinfo_191
  {
     struct approx *approx;
  }
              *setq_cinfo_191_bglt;

typedef struct conditional_cinfo_212
  {
     struct approx *approx;
  }
                     *conditional_cinfo_212_bglt;

typedef struct fail_cinfo_75
  {
     struct approx *approx;
  }
             *fail_cinfo_75_bglt;

typedef struct select_cinfo_150
  {
     struct approx *approx;
  }
                *select_cinfo_150_bglt;

typedef struct set_ex_it_cinfo_168
  {
     struct approx *approx;
  }
                   *set_ex_it_cinfo_168_bglt;

typedef struct jump_ex_it_cinfo_139
  {
     struct approx *approx;
  }
                    *jump_ex_it_cinfo_139_bglt;

typedef struct pre_make_box_186
  {
     char dummy;
  }
                *pre_make_box_186_bglt;

typedef struct make_box_cinfo_127
  {
     struct approx *approx;
  }
                  *make_box_cinfo_127_bglt;

typedef struct make_box_o_cinfo_96
  {
     struct approx *approx;
     struct approx *value_approx_19;
  }
                   *make_box_o_cinfo_96_bglt;

typedef struct box_set__cinfo_94
  {
     struct approx *approx;
  }
                 *box_set__cinfo_94_bglt;

typedef struct box_ref_cinfo_214
  {
     struct approx *approx;
  }
                 *box_ref_cinfo_214_bglt;

typedef struct box_set__o_cinfo_6
  {
     struct approx *approx;
  }
                  *box_set__o_cinfo_6_bglt;

typedef struct box_ref_o_cinfo_98
  {
     struct approx *approx;
  }
                  *box_ref_o_cinfo_98_bglt;

typedef struct pre_make_procedure_app_60
  {
     struct variable *owner;
  }
                         *pre_make_procedure_app_60_bglt;

typedef struct pre_procedure_ref_app_85
  {
     char dummy;
  }
                        *pre_procedure_ref_app_85_bglt;

typedef struct pre_procedure_set__app_208
  {
     char dummy;
  }
                          *pre_procedure_set__app_208_bglt;

typedef struct make_procedure_app_48
  {
     struct approx *approx;
     long values_approx_len_106;
     struct approx **values_approx_79;
     long lost_stamp_114;
     bool_t x_t__142;
     bool_t x;
     bool_t t;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
  }
                     *make_procedure_app_48_bglt;

typedef struct procedure_ref_app_49
  {
     struct approx *approx;
  }
                    *procedure_ref_app_49_bglt;

typedef struct procedure_set__app_32
  {
     struct approx *approx;
  }
                     *procedure_set__app_32_bglt;

typedef struct pre_make_vector_app_251
  {
     struct variable *owner;
  }
                       *pre_make_vector_app_251_bglt;

typedef struct pre_create_vector_app_162
  {
     struct variable *owner;
  }
                         *pre_create_vector_app_162_bglt;

typedef struct pre_vector_ref_app_208
  {
     char dummy;
  }
                      *pre_vector_ref_app_208_bglt;

typedef struct pre_vector_set__app_211
  {
     char dummy;
  }
                       *pre_vector_set__app_211_bglt;

typedef struct make_vector_app_205
  {
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
     bool_t seen__39;
  }
                   *make_vector_app_205_bglt;

typedef struct create_vector_app_150
  {
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
     bool_t seen__39;
  }
                     *create_vector_app_150_bglt;

typedef struct vector_ref_app_195
  {
     struct approx *approx;
  }
                  *vector_ref_app_195_bglt;

typedef struct vector_set__app_21
  {
     struct approx *approx;
  }
                  *vector_set__app_21_bglt;

typedef struct pre_make_struct_app_218
  {
     struct variable *owner;
  }
                       *pre_make_struct_app_218_bglt;

typedef struct pre_struct_ref_app_207
  {
     char dummy;
  }
                      *pre_struct_ref_app_207_bglt;

typedef struct pre_struct_set__app_116
  {
     char dummy;
  }
                       *pre_struct_set__app_116_bglt;

typedef struct make_struct_app_214
  {
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
  }
                   *make_struct_app_214_bglt;

typedef struct struct_ref_app_73
  {
     struct approx *approx;
  }
                 *struct_ref_app_73_bglt;

typedef struct struct_set__app_162
  {
     struct approx *approx;
  }
                   *struct_set__app_162_bglt;


static obj_t method_init_76_cfa_collect();
extern obj_t make_box_202_ast_node;
extern obj_t funcall_ast_node;
extern obj_t _optim__89_engine_param;
extern long add_inlined_method__244___object(obj_t, obj_t, long);
extern obj_t fail_ast_node;
extern obj_t pre_struct_set__app_116_cfa_info2;
static bool_t node_collect___108_cfa_collect(obj_t, variable_bglt);
extern obj_t box_ref_242_ast_node;
extern obj_t pre_make_struct_app_218_cfa_info2;
extern obj_t pre_create_vector_app_162_cfa_info2;
extern obj_t sequence_ast_node;
extern obj_t let_var_6_ast_node;
extern obj_t var_ast_node;
extern obj_t get_allocs_52_cfa_collect();
extern obj_t global_ast_var;
extern obj_t pragma_ast_node;
extern obj_t pre_procedure_set__app_208_cfa_info2;
extern obj_t set_ex_it_116_ast_node;
extern bool_t is_a__118___object(obj_t, obj_t);
static obj_t _node_collect__default2077_57_cfa_collect(obj_t, obj_t, obj_t);
extern obj_t module_initialization_70_cfa_collect(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_type_typeof(long, char *);
extern obj_t module_initialization_70_module_module(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_ast_dump(long, char *);
extern obj_t module_initialization_70_ast_env(long, char *);
extern obj_t module_initialization_70_ast_sexp(long, char *);
extern obj_t module_initialization_70_cfa_info(long, char *);
extern obj_t module_initialization_70_cfa_info2(long, char *);
extern obj_t module_initialization_70_cfa_procedure(long, char *);
extern obj_t module_initialization_70_cfa_vector(long, char *);
extern obj_t module_initialization_70_cfa_struct(long, char *);
extern obj_t module_initialization_70_cfa_box(long, char *);
extern obj_t module_initialization_70_cfa_closure(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t pre_struct_ref_app_207_cfa_info2;
extern obj_t pre_make_box_186_cfa_info;
extern long class_num_218___object(obj_t);
extern obj_t scnst_ast_var;
extern obj_t pre_make_vector_app_251_cfa_info2;
extern obj_t let_fun_218_ast_node;
extern obj_t add_funcall__195_cfa_closure(node_bglt);
static obj_t imported_modules_init_94_cfa_collect();
static obj_t node_collect__175_cfa_collect(node_bglt, variable_bglt);
extern obj_t pre_vector_set__app_211_cfa_info2;
static obj_t _get_allocs_32_cfa_collect(obj_t);
extern obj_t app_ly_162_ast_node;
extern obj_t cfun_ast_var;
extern obj_t add_generic__110___object(obj_t, obj_t);
extern obj_t app_ast_node;
extern obj_t pre_make_procedure_app_60_cfa_info2;
static obj_t library_modules_init_112_cfa_collect();
extern obj_t kwote_node_102_cfa_info;
extern obj_t atom_ast_node;
extern obj_t cast_ast_node;
static obj_t toplevel_init_63_cfa_collect();
extern obj_t jump_ex_it_184_ast_node;
extern obj_t open_input_string(obj_t);
extern obj_t kwote_ast_node;
extern node_bglt top_level_sexp__node_204_ast_sexp(obj_t, obj_t);
extern obj_t setq_ast_node;
extern obj_t box_set__221_ast_node;
static obj_t _collect_all_approx__18_cfa_collect(obj_t, obj_t);
static obj_t node_collect__default2077_182_cfa_collect(node_bglt, variable_bglt);
extern obj_t memq___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern obj_t pre_procedure_ref_app_85_cfa_info2;
static bool_t monomorphic_vector__154_cfa_collect(obj_t);
extern obj_t _module__166_module_module;
extern obj_t _classes__134___object;
extern obj_t select_ast_node;
extern obj_t read___reader(obj_t);
extern obj_t pre_vector_ref_app_208_cfa_info2;
static obj_t get_atype_143_cfa_collect(obj_t);
static obj_t require_initialization_114_cfa_collect = BUNSPEC;
extern obj_t conditional_ast_node;
extern obj_t collect_all_approx__236_cfa_collect(obj_t);
static obj_t _used_alloc__125_cfa_collect = BUNSPEC;
static obj_t cnst_init_137_cfa_collect();
static obj_t _node_collect__42_cfa_collect(obj_t, obj_t, obj_t);
static obj_t __cnst[18];

DEFINE_STATIC_PROCEDURE(node_collect__default2077_env_127_cfa_collect, _node_collect__default2077_57_cfa_collect2530, _node_collect__default2077_57_cfa_collect, 0L, 2);
DEFINE_EXPORT_PROCEDURE(collect_all_approx__env_94_cfa_collect, _collect_all_approx__18_cfa_collect2531, _collect_all_approx__18_cfa_collect, 0L, 1);
DEFINE_EXPORT_PROCEDURE(get_allocs_env_59_cfa_collect, _get_allocs_32_cfa_collect2532, _get_allocs_32_cfa_collect, 0L, 0);
DEFINE_STATIC_GENERIC(node_collect__env_176_cfa_collect, _node_collect__42_cfa_collect2533, _node_collect__42_cfa_collect, 0L, 2);
DEFINE_STRING(string2524_cfa_collect, string2524_cfa_collect2534, "NODE-COLLECT!-DEFAULT2077 C-STRUCT-SET! C-STRUCT-REF C-MAKE-STRUCT C-VECTOR-SET! C-VECTOR-REF C-CREATE-VECTOR PROCEDURE-SET! PROCEDURE-REF MAKE-VA-PROCEDURE MAKE-FX-PROCEDURE (PRAGMA::OBJ \"\") C-MAKE-VECTOR REAL STRING BOOLEAN CHAR INTEGER ", 239);
DEFINE_STRING(string2523_cfa_collect, string2523_cfa_collect2535, "No method for this object", 25);



/* module-initialization */
obj_t 
module_initialization_70_cfa_collect(long checksum_3779, char *from_3780)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_cfa_collect))
	{
	   require_initialization_114_cfa_collect =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_cfa_collect();
	   cnst_init_137_cfa_collect();
	   imported_modules_init_94_cfa_collect();
	   method_init_76_cfa_collect();
	   toplevel_init_63_cfa_collect();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_cfa_collect()
{
   AN_OBJECT;
   {	/* Cfa/collect.scm 14 */
      module_initialization_70___object(((long) 0), "CFA_COLLECT");
      module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "CFA_COLLECT");
      module_initialization_70___reader(((long) 0), "CFA_COLLECT");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_cfa_collect()
{
   AN_OBJECT;
   {	/* Cfa/collect.scm 14 */
      {		/* Cfa/collect.scm 14 */
	 obj_t cnst_port_138_3772;
	 cnst_port_138_3772 =
	    open_input_string(string2524_cfa_collect);
	 {
	    long i_3773;
	    i_3773 = ((long) 17);
	  loop_3774:
	    {	/* Cfa/collect.scm 14 */
	       bool_t test2525_3775;
	       test2525_3775 =
		  (i_3773 == ((long) -1));
	       if (test2525_3775)
		 {	/* Cfa/collect.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Cfa/collect.scm 14 */
		    {	/* Cfa/collect.scm 14 */
		       obj_t arg2527_3776;
		       {	/* Cfa/collect.scm 14 */
			  obj_t list2528_3777;
			  list2528_3777 =
			     MAKE_PAIR(cnst_port_138_3772, BNIL);
			  arg2527_3776 =
			     read___reader(list2528_3777);
		       }
		       CNST_TABLE_SET(i_3773, arg2527_3776);
		    }
		    {	/* Cfa/collect.scm 14 */
		       int aux_3778;
		       {	/* Cfa/collect.scm 14 */
			  long aux_3798;
			  aux_3798 =
			     (i_3773 - ((long) 1));
			  aux_3778 =
			     (int) (aux_3798);
		       }
		       {
			  long i_3801;
			  i_3801 =
			     (long) (aux_3778);
			  i_3773 = i_3801;
			  goto loop_3774;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_cfa_collect()
{
   AN_OBJECT;
   {	/* Cfa/collect.scm 14 */
      return (
	 _used_alloc__125_cfa_collect = BNIL, BUNSPEC);
   }
}



/* collect-all-approx! */
obj_t 
collect_all_approx__236_cfa_collect(obj_t globals_1)
{
   AN_OBJECT;
   {	/* Cfa/collect.scm 40 */
      {
	 obj_t l2038_2161;
	 {	/* Cfa/collect.scm 41 */
	    bool_t aux_3803;
	    l2038_2161 = globals_1;
	  lname2039_2162:
	    if (
	       PAIRP(l2038_2161))
	      {		/* Cfa/collect.scm 41 */
		 {	/* Cfa/collect.scm 41 */
		    obj_t global_2164;
		    global_2164 =
		       CAR(l2038_2161);
		    {	/* Cfa/collect.scm 41 */
		       sfun_bglt value_3171;
		       {	/* Cfa/collect.scm 41 */
			  value_bglt aux_3807;
			  {	/* Cfa/collect.scm 41 */
			     global_bglt obj_3170;
			     obj_3170 =
				(global_bglt) (global_2164);
			     aux_3807 =
				(((global_bglt) CREF(obj_3170))->value);
			  }
			  value_3171 =
			     (sfun_bglt) (aux_3807);
		       }
		       {	/* Cfa/collect.scm 48 */
			  variable_bglt aux_3815;
			  node_bglt aux_3811;
			  {	/* Cfa/collect.scm 48 */
			     global_bglt aux_3816;
			     aux_3816 =
				(global_bglt) (global_2164);
			     aux_3815 =
				(variable_bglt) (aux_3816);
			  }
			  {	/* Cfa/collect.scm 48 */
			     obj_t aux_3812;
			     aux_3812 =
				(((sfun_bglt) CREF(value_3171))->body);
			     aux_3811 =
				(node_bglt) (aux_3812);
			  }
			  node_collect__175_cfa_collect(aux_3811, aux_3815);
		       }
		    }
		 }
		 {
		    obj_t l2038_3820;
		    l2038_3820 =
		       CDR(l2038_2161);
		    l2038_2161 = l2038_3820;
		    goto lname2039_2162;
		 }
	      }
	    else
	      {		/* Cfa/collect.scm 41 */
		 aux_3803 = ((bool_t) 1);
	      }
	    return
	       BBOOL(aux_3803);
	 }
      }
   }
}



/* _collect-all-approx! */
obj_t 
_collect_all_approx__18_cfa_collect(obj_t env_3763, obj_t globals_3764)
{
   AN_OBJECT;
   {	/* Cfa/collect.scm 40 */
      return
	 collect_all_approx__236_cfa_collect(globals_3764);
   }
}



/* monomorphic-vector? */
bool_t 
monomorphic_vector__154_cfa_collect(obj_t vector_12)
{
   AN_OBJECT;
   {	/* Cfa/collect.scm 79 */
      {		/* Cfa/collect.scm 94 */
	 long len_2169;
	 len_2169 =
	    VECTOR_LENGTH(vector_12);
	 if (
	    (len_2169 == ((long) 0)))
	   {	/* Cfa/collect.scm 95 */
	      return ((bool_t) 0);
	   }
	 else
	   {	/* Cfa/collect.scm 97 */
	      obj_t atype_2171;
	      atype_2171 =
		 get_atype_143_cfa_collect(
		 VECTOR_REF(vector_12, ((long) 0)));
	      {
		 long i_2172;
		 i_2172 = ((long) 1);
	       loop_2173:
		 if (
		    CBOOL(atype_2171))
		   {	/* Cfa/collect.scm 100 */
		      if (
			 (i_2172 == len_2169))
			{	/* Cfa/collect.scm 102 */
			   return ((bool_t) 1);
			}
		      else
			{	/* Cfa/collect.scm 104 */
			   bool_t test_3833;
			   {	/* ./Ieee/equiv.scm 5508 */
			      obj_t aux_3834;
			      aux_3834 =
				 get_atype_143_cfa_collect(
				 VECTOR_REF(vector_12, i_2172));
			      test_3833 =
				 (aux_3834 == atype_2171);
			   }
			   if (test_3833)
			     {	/* Cfa/collect.scm 104 */
				{
				   long i_3838;
				   i_3838 =
				      (i_2172 + ((long) 1));
				   i_2172 = i_3838;
				   goto loop_2173;
				}
			     }
			   else
			     {	/* Cfa/collect.scm 104 */
				return ((bool_t) 0);
			     }
			}
		   }
		 else
		   {	/* Cfa/collect.scm 100 */
		      return ((bool_t) 0);
		   }
	      }
	   }
      }
   }
}



/* get-atype */
obj_t 
get_atype_143_cfa_collect(obj_t value_2180)
{
   AN_OBJECT;
   {	/* Cfa/collect.scm 80 */
      {		/* Cfa/collect.scm 82 */
	 bool_t test2133_2182;
	 test2133_2182 =
	    INTEGERP(value_2180);
	 if (test2133_2182)
	   {	/* Cfa/collect.scm 82 */
	      return
		 CNST_TABLE_REF(((long) 0));
	   }
	 else
	   {	/* Cfa/collect.scm 82 */
	      if (
		 CHARP(value_2180))
		{	/* Cfa/collect.scm 84 */
		   return
		      CNST_TABLE_REF(((long) 1));
		}
	      else
		{	/* Cfa/collect.scm 84 */
		   if (
		      BOOLEANP(value_2180))
		     {	/* Cfa/collect.scm 86 */
			return
			   CNST_TABLE_REF(((long) 2));
		     }
		   else
		     {	/* Cfa/collect.scm 86 */
			if (
			   STRINGP(value_2180))
			  {	/* Cfa/collect.scm 88 */
			     return
				CNST_TABLE_REF(((long) 3));
			  }
			else
			  {	/* Cfa/collect.scm 90 */
			     bool_t test_3852;
			     if (test2133_2182)
			       {	/* ./Ieee/flonum.scm 7393 */
				  test_3852 = ((bool_t) 1)
				     ;
			       }
			     else
			       {	/* ./Ieee/flonum.scm 7393 */
				  test_3852 =
				     REALP(value_2180)
				     ;
			       }
			     if (test_3852)
			       {	/* Cfa/collect.scm 90 */
				  return
				     CNST_TABLE_REF(((long) 4));
			       }
			     else
			       {	/* Cfa/collect.scm 90 */
				  return BFALSE;
			       }
			  }
		     }
		}
	   }
      }
   }
}



/* node-collect*! */
bool_t 
node_collect___108_cfa_collect(obj_t node__221_49, variable_bglt owner_50)
{
   AN_OBJECT;
   {	/* Cfa/collect.scm 306 */
      {
	 obj_t l2075_2188;
	 l2075_2188 = node__221_49;
       lname2076_2189:
	 if (
	    PAIRP(l2075_2188))
	   {	/* Cfa/collect.scm 307 */
	      {		/* Cfa/collect.scm 307 */
		 node_bglt aux_3858;
		 {	/* Cfa/collect.scm 307 */
		    obj_t aux_3859;
		    aux_3859 =
		       CAR(l2075_2188);
		    aux_3858 =
		       (node_bglt) (aux_3859);
		 }
		 node_collect__175_cfa_collect(aux_3858, owner_50);
	      }
	      {
		 obj_t l2075_3863;
		 l2075_3863 =
		    CDR(l2075_2188);
		 l2075_2188 = l2075_3863;
		 goto lname2076_2189;
	      }
	   }
	 else
	   {	/* Cfa/collect.scm 307 */
	      return ((bool_t) 1);
	   }
      }
   }
}



/* get-allocs */
obj_t 
get_allocs_52_cfa_collect()
{
   AN_OBJECT;
   {	/* Cfa/collect.scm 329 */
      return _used_alloc__125_cfa_collect;
   }
}



/* _get-allocs */
obj_t 
_get_allocs_32_cfa_collect(obj_t env_3765)
{
   AN_OBJECT;
   {	/* Cfa/collect.scm 329 */
      return
	 get_allocs_52_cfa_collect();
   }
}



/* method-init */
obj_t 
method_init_76_cfa_collect()
{
   AN_OBJECT;
   {	/* Cfa/collect.scm 14 */
      add_generic__110___object(node_collect__env_176_cfa_collect, node_collect__default2077_env_127_cfa_collect);
      add_inlined_method__244___object(node_collect__env_176_cfa_collect, atom_ast_node, ((long) 0));
      add_inlined_method__244___object(node_collect__env_176_cfa_collect, kwote_ast_node, ((long) 1));
      add_inlined_method__244___object(node_collect__env_176_cfa_collect, var_ast_node, ((long) 2));
      add_inlined_method__244___object(node_collect__env_176_cfa_collect, sequence_ast_node, ((long) 3));
      add_inlined_method__244___object(node_collect__env_176_cfa_collect, app_ast_node, ((long) 4));
      add_inlined_method__244___object(node_collect__env_176_cfa_collect, app_ly_162_ast_node, ((long) 5));
      add_inlined_method__244___object(node_collect__env_176_cfa_collect, funcall_ast_node, ((long) 6));
      add_inlined_method__244___object(node_collect__env_176_cfa_collect, pragma_ast_node, ((long) 7));
      add_inlined_method__244___object(node_collect__env_176_cfa_collect, cast_ast_node, ((long) 8));
      add_inlined_method__244___object(node_collect__env_176_cfa_collect, setq_ast_node, ((long) 9));
      add_inlined_method__244___object(node_collect__env_176_cfa_collect, conditional_ast_node, ((long) 10));
      add_inlined_method__244___object(node_collect__env_176_cfa_collect, fail_ast_node, ((long) 11));
      add_inlined_method__244___object(node_collect__env_176_cfa_collect, select_ast_node, ((long) 12));
      add_inlined_method__244___object(node_collect__env_176_cfa_collect, let_fun_218_ast_node, ((long) 13));
      add_inlined_method__244___object(node_collect__env_176_cfa_collect, let_var_6_ast_node, ((long) 14));
      add_inlined_method__244___object(node_collect__env_176_cfa_collect, set_ex_it_116_ast_node, ((long) 15));
      add_inlined_method__244___object(node_collect__env_176_cfa_collect, jump_ex_it_184_ast_node, ((long) 16));
      add_inlined_method__244___object(node_collect__env_176_cfa_collect, make_box_202_ast_node, ((long) 17));
      add_inlined_method__244___object(node_collect__env_176_cfa_collect, box_set__221_ast_node, ((long) 18));
      {		/* Cfa/collect.scm 14 */
	 long aux_3886;
	 aux_3886 =
	    add_inlined_method__244___object(node_collect__env_176_cfa_collect, box_ref_242_ast_node, ((long) 19));
	 return
	    BINT(aux_3886);
      }
   }
}



/* node-collect! */
obj_t 
node_collect__175_cfa_collect(node_bglt node_4, variable_bglt owner_5)
{
   AN_OBJECT;
   {	/* Cfa/collect.scm 53 */
    node_collect__175_cfa_collect:
      {
	 obj_t method2383_2960;
	 obj_t class2388_2961;
	 {	/* Cfa/collect.scm 53 */
	    obj_t arg2391_2958;
	    obj_t arg2392_2959;
	    {	/* Cfa/collect.scm 53 */
	       object_bglt obj_3550;
	       obj_3550 =
		  (object_bglt) (node_4);
	       {	/* ./Llib/object.scm 2926 */
		  obj_t pre_method_105_3551;
		  pre_method_105_3551 =
		     PROCEDURE_REF(node_collect__env_176_cfa_collect, ((long) 2));
		  if (
		     INTEGERP(pre_method_105_3551))
		    {	/* ./Llib/object.scm 2927 */
		       PROCEDURE_SET(node_collect__env_176_cfa_collect, ((long) 2), BUNSPEC);
		       arg2391_2958 = pre_method_105_3551;
		    }
		  else
		    {	/* ./Llib/object.scm 2914 */
		       long obj_class_num_177_3556;
		       obj_class_num_177_3556 =
			  TYPE(obj_3550);
		       {	/* ./Llib/object.scm 2915 */
			  obj_t arg1176_3557;
			  arg1176_3557 =
			     PROCEDURE_REF(node_collect__env_176_cfa_collect, ((long) 1));
			  {	/* ./Llib/object.scm 2738 */
			     long arg1177_3561;
			     {	/* ./Llib/object.scm 2738 */
				long arg1178_3562;
				arg1178_3562 =
				   OBJECT_TYPE;
				arg1177_3561 =
				   (obj_class_num_177_3556 - arg1178_3562);
			     }
			     arg2391_2958 =
				VECTOR_REF(arg1176_3557, arg1177_3561);
			  }
		       }
		    }
	       }
	    }
	    {	/* Cfa/collect.scm 53 */
	       object_bglt object_3567;
	       object_3567 =
		  (object_bglt) (node_4);
	       {	/* ./Llib/object.scm 2695 */
		  long arg1179_3568;
		  {	/* ./Llib/object.scm 2695 */
		     long arg1180_3569;
		     long arg1181_3570;
		     arg1180_3569 =
			TYPE(object_3567);
		     arg1181_3570 =
			OBJECT_TYPE;
		     arg1179_3568 =
			(arg1180_3569 - arg1181_3570);
		  }
		  {	/* ./Llib/object.scm 2695 */
		     obj_t vector_3574;
		     vector_3574 = _classes__134___object;
		     arg2392_2959 =
			VECTOR_REF(vector_3574, arg1179_3568);
		  }
	       }
	    }
	    method2383_2960 = arg2391_2958;
	    class2388_2961 = arg2392_2959;
	    {

	       if (
		  INTEGERP(method2383_2960))
		 {	/* Cfa/collect.scm 53 */
		    switch (
		       (long) CINT(method2383_2960))
		      {
		      case ((long) 0):

			 return BUNSPEC;
			 break;
		      case ((long) 1):

			 {	/* Cfa/collect.scm 65 */
			    kwote_bglt node_2969;
			    node_2969 =
			       (kwote_bglt) (node_4);
			    {	/* Cfa/collect.scm 65 */
			       obj_t value_2971;
			       value_2971 =
				  (((kwote_bglt) CREF(node_2969))->value);
			       {	/* Cfa/collect.scm 66 */
				  bool_t test2395_2972;
				  {	/* Cfa/collect.scm 66 */
				     bool_t test2407_2986;
				     {	/* Cfa/collect.scm 66 */
					long n1_3577;
					n1_3577 =
					   (long) CINT(_optim__89_engine_param);
					test2407_2986 =
					   (n1_3577 >= ((long) 2));
				     }
				     if (test2407_2986)
				       {	/* Cfa/collect.scm 66 */
					  test2395_2972 =
					     VECTORP(value_2971);
				       }
				     else
				       {	/* Cfa/collect.scm 66 */
					  test2395_2972 = ((bool_t) 0);
				       }
				  }
				  if (test2395_2972)
				    {	/* Cfa/collect.scm 67 */
				       node_bglt dummy_2973;
				       {	/* Cfa/collect.scm 68 */
					  obj_t arg2399_2978;
					  {	/* Cfa/collect.scm 68 */
					     obj_t arg2400_2979;
					     obj_t arg2401_2980;
					     arg2400_2979 =
						CNST_TABLE_REF(((long) 5));
					     {	/* Cfa/collect.scm 68 */
						long arg2402_2981;
						obj_t arg2403_2982;
						arg2402_2981 =
						   VECTOR_LENGTH(value_2971);
						{	/* ./Ieee/pair-list.scm 5689 */
						   obj_t aux_3915;
						   if (
						      monomorphic_vector__154_cfa_collect(value_2971))
						     {	/* Cfa/collect.scm 69 */
							aux_3915 =
							   VECTOR_REF(value_2971, ((long) 0))
							   ;
						     }
						   else
						     {	/* Cfa/collect.scm 69 */
							aux_3915 =
							   CNST_TABLE_REF(((long) 6))
							   ;
						     }
						   arg2403_2982 =
						      MAKE_PAIR(aux_3915, BNIL);
						}
						{	/* ./Ieee/pair-list.scm 5689 */
						   obj_t aux_3921;
						   aux_3921 =
						      BINT(arg2402_2981);
						   arg2401_2980 =
						      MAKE_PAIR(aux_3921, arg2403_2982);
						}
					     }
					     arg2399_2978 =
						MAKE_PAIR(arg2400_2979, arg2401_2980);
					  }
					  dummy_2973 =
					     top_level_sexp__node_204_ast_sexp(arg2399_2978, BFALSE);
				       }
				       {	/* Cfa/collect.scm 73 */
					  kwote_node_102_bglt obj2040_2974;
					  obj2040_2974 =
					     ((kwote_node_102_bglt) (node_2969));
					  {	/* Cfa/collect.scm 73 */
					     kwote_node_102_bglt arg2396_2975;
					     {	/* Cfa/collect.scm 73 */
						kwote_node_102_bglt res2509_3592;
						{	/* ./Cfa/cinfo.scm 1586 */
						   kwote_node_102_bglt new1581_3590;
						   new1581_3590 =
						      ((kwote_node_102_bglt) BREF(GC_MALLOC(sizeof(struct kwote_node_102))));
						   ((((kwote_node_102_bglt) CREF(new1581_3590))->node) = ((node_bglt) dummy_2973), BUNSPEC);
						   res2509_3592 = new1581_3590;
						}
						arg2396_2975 = res2509_3592;
					     }
					     {	/* Cfa/collect.scm 73 */
						obj_t aux_3931;
						object_bglt aux_3929;
						aux_3931 =
						   (obj_t) (arg2396_2975);
						aux_3929 =
						   (object_bglt) (obj2040_2974);
						OBJECT_WIDENING_SET(aux_3929, aux_3931);
					     }
					  }
					  {	/* Cfa/collect.scm 73 */
					     long arg2398_2977;
					     arg2398_2977 =
						class_num_218___object(kwote_node_102_cfa_info);
					     {	/* Cfa/collect.scm 73 */
						obj_t obj_3593;
						obj_3593 =
						   (obj_t) (obj2040_2974);
						(((obj_t) CREF(obj_3593))->header = MAKE_HEADER(arg2398_2977, 0), BUNSPEC);
					     }
					  }
					  obj2040_2974;
				       }
				       {
					  node_bglt node_3937;
					  node_3937 = dummy_2973;
					  node_4 = node_3937;
					  goto node_collect__175_cfa_collect;
				       }
				    }
				  else
				    {	/* Cfa/collect.scm 66 */
				       return BUNSPEC;
				    }
			       }
			    }
			 }
			 break;
		      case ((long) 2):

			 {	/* Cfa/collect.scm 53 */
			    var_bglt node_2987;
			    node_2987 =
			       (var_bglt) (node_4);
			    {	/* Cfa/collect.scm 113 */
			       variable_bglt v_2989;
			       v_2989 =
				  (((var_bglt) CREF(node_2987))->variable);
			       {	/* Cfa/collect.scm 114 */
				  bool_t test2408_2990;
				  {	/* Cfa/collect.scm 114 */
				     bool_t test2411_2993;
				     test2411_2993 =
					is_a__118___object(
					(obj_t) (v_2989), global_ast_var);
				     if (test2411_2993)
				       {	/* Cfa/collect.scm 115 */
					  bool_t test2412_2994;
					  {	/* Cfa/collect.scm 115 */
					     obj_t obj2_3599;
					     obj2_3599 = _module__166_module_module;
					     {	/* ./Ieee/equiv.scm 5508 */
						obj_t aux_3943;
						{	/* Cfa/collect.scm 115 */
						   global_bglt obj_3597;
						   obj_3597 =
						      (global_bglt) (v_2989);
						   aux_3943 =
						      (((global_bglt) CREF(obj_3597))->module);
						}
						test2412_2994 =
						   (aux_3943 == obj2_3599);
					     }
					  }
					  if (test2412_2994)
					    {	/* Cfa/collect.scm 116 */
					       bool_t test2413_2995;
					       {	/* ./Ast/var.scm 1209 */
						  obj_t aux_3948;
						  {	/* Cfa/collect.scm 116 */
						     value_bglt aux_3949;
						     {	/* Cfa/collect.scm 116 */
							global_bglt obj_3600;
							obj_3600 =
							   (global_bglt) (v_2989);
							aux_3949 =
							   (((global_bglt) CREF(obj_3600))->value);
						     }
						     aux_3948 =
							(obj_t) (aux_3949);
						  }
						  test2413_2995 =
						     is_a__118___object(aux_3948, scnst_ast_var);
					       }
					       if (test2413_2995)
						 {	/* Cfa/collect.scm 117 */
						    bool_t test2414_2996;
						    {	/* Cfa/collect.scm 324 */
						       obj_t aux_3955;
						       {	/* Cfa/collect.scm 324 */
							  obj_t aux_3956;
							  {	/* Cfa/collect.scm 117 */
							     scnst_bglt obj_3603;
							     {	/* Cfa/collect.scm 117 */
								value_bglt aux_3957;
								{	/* Cfa/collect.scm 117 */
								   global_bglt obj_3602;
								   obj_3602 =
								      (global_bglt) (v_2989);
								   aux_3957 =
								      (((global_bglt) CREF(obj_3602))->value);
								}
								obj_3603 =
								   (scnst_bglt) (aux_3957);
							     }
							     aux_3956 =
								(((scnst_bglt) CREF(obj_3603))->node);
							  }
							  aux_3955 =
							     memq___r4_pairs_and_lists_6_3(aux_3956, _used_alloc__125_cfa_collect);
						       }
						       test2414_2996 =
							  CBOOL(aux_3955);
						    }
						    if (test2414_2996)
						      {		/* Cfa/collect.scm 117 */
							 test2408_2990 = ((bool_t) 0);
						      }
						    else
						      {		/* Cfa/collect.scm 117 */
							 test2408_2990 = ((bool_t) 1);
						      }
						 }
					       else
						 {	/* Cfa/collect.scm 116 */
						    test2408_2990 = ((bool_t) 0);
						 }
					    }
					  else
					    {	/* Cfa/collect.scm 115 */
					       test2408_2990 = ((bool_t) 0);
					    }
				       }
				     else
				       {	/* Cfa/collect.scm 114 */
					  test2408_2990 = ((bool_t) 0);
				       }
				  }
				  if (test2408_2990)
				    {	/* Cfa/collect.scm 114 */
				       {	/* Cfa/collect.scm 123 */
					  node_bglt aux_3966;
					  {	/* Cfa/collect.scm 123 */
					     obj_t aux_3967;
					     {	/* Cfa/collect.scm 123 */
						scnst_bglt obj_3606;
						{	/* Cfa/collect.scm 123 */
						   value_bglt aux_3968;
						   {	/* Cfa/collect.scm 123 */
						      global_bglt obj_3605;
						      obj_3605 =
							 (global_bglt) (v_2989);
						      aux_3968 =
							 (((global_bglt) CREF(obj_3605))->value);
						   }
						   obj_3606 =
						      (scnst_bglt) (aux_3968);
						}
						aux_3967 =
						   (((scnst_bglt) CREF(obj_3606))->node);
					     }
					     aux_3966 =
						(node_bglt) (aux_3967);
					  }
					  node_collect__175_cfa_collect(aux_3966, owner_5);
				       }
				    }
				  else
				    {	/* Cfa/collect.scm 114 */
				       BUNSPEC;
				    }
			       }
			    }
			    return BUNSPEC;
			 }
			 break;
		      case ((long) 3):

			 {	/* Cfa/collect.scm 130 */
			    sequence_bglt node_3001;
			    node_3001 =
			       (sequence_bglt) (node_4);
			    {	/* Cfa/collect.scm 130 */
			       bool_t aux_3976;
			       aux_3976 =
				  node_collect___108_cfa_collect(
				  (((sequence_bglt) CREF(node_3001))->nodes), owner_5);
			       return
				  BBOOL(aux_3976);
			    }
			 }
			 break;
		      case ((long) 4):

			 {	/* Cfa/collect.scm 136 */
			    app_bglt node_3004;
			    node_3004 =
			       (app_bglt) (node_4);
			    node_collect___108_cfa_collect(
			       (((app_bglt) CREF(node_3004))->args), owner_5);
			    {	/* Cfa/collect.scm 138 */
			       node_bglt aux_3983;
			       {	/* Cfa/collect.scm 138 */
				  var_bglt aux_3984;
				  aux_3984 =
				     (((app_bglt) CREF(node_3004))->fun);
				  aux_3983 =
				     (node_bglt) (aux_3984);
			       }
			       node_collect__175_cfa_collect(aux_3983, owner_5);
			    }
			    {	/* Cfa/collect.scm 139 */
			       variable_bglt v_3009;
			       {	/* Cfa/collect.scm 139 */
				  var_bglt arg2464_3065;
				  arg2464_3065 =
				     (((app_bglt) CREF(node_3004))->fun);
				  v_3009 =
				     (((var_bglt) CREF(arg2464_3065))->variable);
			       }
			       {	/* Cfa/collect.scm 140 */
				  bool_t test2422_3010;
				  {	/* Cfa/collect.scm 140 */
				     bool_t test2462_3063;
				     test2462_3063 =
					is_a__118___object(
					(obj_t) (v_3009), global_ast_var);
				     if (test2462_3063)
				       {	/* ./Ast/var.scm 1197 */
					  obj_t aux_3993;
					  {	/* Cfa/collect.scm 140 */
					     value_bglt aux_3994;
					     aux_3994 =
						(((variable_bglt) CREF(v_3009))->value);
					     aux_3993 =
						(obj_t) (aux_3994);
					  }
					  test2422_3010 =
					     is_a__118___object(aux_3993, cfun_ast_var);
				       }
				     else
				       {	/* Cfa/collect.scm 140 */
					  test2422_3010 = ((bool_t) 0);
				       }
				  }
				  if (test2422_3010)
				    {	/* Cfa/collect.scm 140 */
				       {	/* Cfa/collect.scm 145 */
					  obj_t case_value_58_3011;
					  {	/* Cfa/collect.scm 145 */
					     global_bglt obj_3615;
					     obj_3615 =
						(global_bglt) (v_3009);
					     case_value_58_3011 =
						(((global_bglt) CREF(obj_3615))->id);
					  }
					  {	/* Cfa/collect.scm 145 */
					     bool_t test_4001;
					     {	/* ./Ieee/equiv.scm 5508 */
						obj_t aux_4002;
						aux_4002 =
						   CNST_TABLE_REF(((long) 7));
						test_4001 =
						   (case_value_58_3011 == aux_4002);
					     }
					     if (test_4001)
					       {	/* Cfa/collect.scm 145 */
						  {	/* Cfa/collect.scm 318 */
						     obj_t obj2_3620;
						     obj2_3620 = _used_alloc__125_cfa_collect;
						     {	/* ./Ieee/pair-list.scm 5689 */
							obj_t aux_4005;
							aux_4005 =
							   (obj_t) (node_3004);
							_used_alloc__125_cfa_collect =
							   MAKE_PAIR(aux_4005, obj2_3620);
						     }
						  }
						  {	/* Cfa/collect.scm 148 */
						     pre_make_procedure_app_60_bglt obj2042_3013;
						     obj2042_3013 =
							((pre_make_procedure_app_60_bglt) (node_3004));
						     {	/* Cfa/collect.scm 148 */
							pre_make_procedure_app_60_bglt arg2424_3014;
							{	/* Cfa/collect.scm 148 */
							   pre_make_procedure_app_60_bglt res2510_3624;
							   {	/* ./Cfa/cinfo2.scm 1636 */
							      pre_make_procedure_app_60_bglt new1762_3622;
							      new1762_3622 =
								 ((pre_make_procedure_app_60_bglt) BREF(GC_MALLOC(sizeof(struct pre_make_procedure_app_60))));
							      ((((pre_make_procedure_app_60_bglt) CREF(new1762_3622))->owner) = ((variable_bglt) owner_5), BUNSPEC);
							      res2510_3624 = new1762_3622;
							   }
							   arg2424_3014 = res2510_3624;
							}
							{	/* Cfa/collect.scm 148 */
							   obj_t aux_4013;
							   object_bglt aux_4011;
							   aux_4013 =
							      (obj_t) (arg2424_3014);
							   aux_4011 =
							      (object_bglt) (obj2042_3013);
							   OBJECT_WIDENING_SET(aux_4011, aux_4013);
							}
						     }
						     {	/* Cfa/collect.scm 148 */
							long arg2426_3016;
							arg2426_3016 =
							   class_num_218___object(pre_make_procedure_app_60_cfa_info2);
							{	/* Cfa/collect.scm 148 */
							   obj_t obj_3625;
							   obj_3625 =
							      (obj_t) (obj2042_3013);
							   (((obj_t) CREF(obj_3625))->header = MAKE_HEADER(arg2426_3016, 0), BUNSPEC);
							}
						     }
						     (obj_t) (obj2042_3013);
						  }
					       }
					     else
					       {	/* Cfa/collect.scm 145 */
						  bool_t test_4020;
						  {	/* ./Ieee/equiv.scm 5508 */
						     obj_t aux_4021;
						     aux_4021 =
							CNST_TABLE_REF(((long) 8));
						     test_4020 =
							(case_value_58_3011 == aux_4021);
						  }
						  if (test_4020)
						    {	/* Cfa/collect.scm 145 */
						       {	/* Cfa/collect.scm 318 */
							  obj_t obj2_3631;
							  obj2_3631 = _used_alloc__125_cfa_collect;
							  {	/* ./Ieee/pair-list.scm 5689 */
							     obj_t aux_4024;
							     aux_4024 =
								(obj_t) (node_3004);
							     _used_alloc__125_cfa_collect =
								MAKE_PAIR(aux_4024, obj2_3631);
							  }
						       }
						       {	/* Cfa/collect.scm 151 */
							  pre_make_procedure_app_60_bglt obj2043_3018;
							  obj2043_3018 =
							     ((pre_make_procedure_app_60_bglt) (node_3004));
							  {	/* Cfa/collect.scm 151 */
							     pre_make_procedure_app_60_bglt arg2428_3019;
							     {	/* Cfa/collect.scm 151 */
								pre_make_procedure_app_60_bglt res2511_3635;
								{	/* ./Cfa/cinfo2.scm 1636 */
								   pre_make_procedure_app_60_bglt new1762_3633;
								   new1762_3633 =
								      ((pre_make_procedure_app_60_bglt) BREF(GC_MALLOC(sizeof(struct pre_make_procedure_app_60))));
								   ((((pre_make_procedure_app_60_bglt) CREF(new1762_3633))->owner) = ((variable_bglt) owner_5), BUNSPEC);
								   res2511_3635 = new1762_3633;
								}
								arg2428_3019 = res2511_3635;
							     }
							     {	/* Cfa/collect.scm 151 */
								obj_t aux_4032;
								object_bglt aux_4030;
								aux_4032 =
								   (obj_t) (arg2428_3019);
								aux_4030 =
								   (object_bglt) (obj2043_3018);
								OBJECT_WIDENING_SET(aux_4030, aux_4032);
							     }
							  }
							  {	/* Cfa/collect.scm 151 */
							     long arg2430_3021;
							     arg2430_3021 =
								class_num_218___object(pre_make_procedure_app_60_cfa_info2);
							     {	/* Cfa/collect.scm 151 */
								obj_t obj_3636;
								obj_3636 =
								   (obj_t) (obj2043_3018);
								(((obj_t) CREF(obj_3636))->header = MAKE_HEADER(arg2430_3021, 0), BUNSPEC);
							     }
							  }
							  (obj_t) (obj2043_3018);
						       }
						    }
						  else
						    {	/* Cfa/collect.scm 145 */
						       bool_t test_4039;
						       {	/* ./Ieee/equiv.scm 5508 */
							  obj_t aux_4040;
							  aux_4040 =
							     CNST_TABLE_REF(((long) 9));
							  test_4039 =
							     (case_value_58_3011 == aux_4040);
						       }
						       if (test_4039)
							 {	/* Cfa/collect.scm 153 */
							    pre_procedure_ref_app_85_bglt obj2044_3023;
							    obj2044_3023 =
							       ((pre_procedure_ref_app_85_bglt) (node_3004));
							    {	/* Cfa/collect.scm 153 */
							       obj_t aux_4046;
							       object_bglt aux_4044;
							       {	/* Cfa/collect.scm 153 */
								  pre_procedure_ref_app_85_bglt aux_4047;
								  {	/* ./Cfa/cinfo2.scm 1639 */

								     aux_4047 =
									((pre_procedure_ref_app_85_bglt) BREF(GC_MALLOC(sizeof(struct pre_procedure_ref_app_85))));
								  }
								  aux_4046 =
								     (obj_t) (aux_4047);
							       }
							       aux_4044 =
								  (object_bglt) (obj2044_3023);
							       OBJECT_WIDENING_SET(aux_4044, aux_4046);
							    }
							    {	/* Cfa/collect.scm 153 */
							       long arg2433_3025;
							       arg2433_3025 =
								  class_num_218___object(pre_procedure_ref_app_85_cfa_info2);
							       {	/* Cfa/collect.scm 153 */
								  obj_t obj_3642;
								  obj_3642 =
								     (obj_t) (obj2044_3023);
								  (((obj_t) CREF(obj_3642))->header = MAKE_HEADER(arg2433_3025, 0), BUNSPEC);
							       }
							    }
							    (obj_t) (obj2044_3023);
							 }
						       else
							 {	/* Cfa/collect.scm 145 */
							    bool_t test_4055;
							    {	/* ./Ieee/equiv.scm 5508 */
							       obj_t aux_4056;
							       aux_4056 =
								  CNST_TABLE_REF(((long) 10));
							       test_4055 =
								  (case_value_58_3011 == aux_4056);
							    }
							    if (test_4055)
							      {		/* Cfa/collect.scm 155 */
								 pre_procedure_set__app_208_bglt obj2045_3027;
								 obj2045_3027 =
								    ((pre_procedure_set__app_208_bglt) (node_3004));
								 {	/* Cfa/collect.scm 155 */
								    obj_t aux_4062;
								    object_bglt aux_4060;
								    {	/* Cfa/collect.scm 155 */
								       pre_procedure_set__app_208_bglt aux_4063;
								       {	/* ./Cfa/cinfo2.scm 1640 */

									  aux_4063 =
									     ((pre_procedure_set__app_208_bglt) BREF(GC_MALLOC(sizeof(struct pre_procedure_set__app_208))));
								       }
								       aux_4062 =
									  (obj_t) (aux_4063);
								    }
								    aux_4060 =
								       (object_bglt) (obj2045_3027);
								    OBJECT_WIDENING_SET(aux_4060, aux_4062);
								 }
								 {	/* Cfa/collect.scm 155 */
								    long arg2436_3029;
								    arg2436_3029 =
								       class_num_218___object(pre_procedure_set__app_208_cfa_info2);
								    {	/* Cfa/collect.scm 155 */
								       obj_t obj_3648;
								       obj_3648 =
									  (obj_t) (obj2045_3027);
								       (((obj_t) CREF(obj_3648))->header = MAKE_HEADER(arg2436_3029, 0), BUNSPEC);
								    }
								 }
								 (obj_t) (obj2045_3027);
							      }
							    else
							      {		/* Cfa/collect.scm 145 */
								 BFALSE;
							      }
							 }
						    }
					       }
					  }
				       }
				       {	/* Cfa/collect.scm 156 */
					  bool_t test2437_3030;
					  {	/* Cfa/collect.scm 156 */
					     long n1_3650;
					     n1_3650 =
						(long) CINT(_optim__89_engine_param);
					     test2437_3030 =
						(n1_3650 >= ((long) 2));
					  }
					  if (test2437_3030)
					    {	/* Cfa/collect.scm 157 */
					       obj_t case_value_58_3031;
					       {	/* Cfa/collect.scm 157 */
						  global_bglt obj_3652;
						  obj_3652 =
						     (global_bglt) (v_3009);
						  case_value_58_3031 =
						     (((global_bglt) CREF(obj_3652))->id);
					       }
					       {	/* Cfa/collect.scm 157 */
						  bool_t test_4076;
						  {	/* ./Ieee/equiv.scm 5508 */
						     obj_t aux_4077;
						     aux_4077 =
							CNST_TABLE_REF(((long) 5));
						     test_4076 =
							(case_value_58_3031 == aux_4077);
						  }
						  if (test_4076)
						    {	/* Cfa/collect.scm 157 */
						       {	/* Cfa/collect.scm 318 */
							  obj_t obj2_3657;
							  obj2_3657 = _used_alloc__125_cfa_collect;
							  {	/* ./Ieee/pair-list.scm 5689 */
							     obj_t aux_4080;
							     aux_4080 =
								(obj_t) (node_3004);
							     _used_alloc__125_cfa_collect =
								MAKE_PAIR(aux_4080, obj2_3657);
							  }
						       }
						       {	/* Cfa/collect.scm 160 */
							  pre_make_vector_app_251_bglt obj2046_3033;
							  obj2046_3033 =
							     ((pre_make_vector_app_251_bglt) (node_3004));
							  {	/* Cfa/collect.scm 160 */
							     pre_make_vector_app_251_bglt arg2439_3034;
							     {	/* Cfa/collect.scm 160 */
								pre_make_vector_app_251_bglt res2514_3661;
								{	/* ./Cfa/cinfo2.scm 1666 */
								   pre_make_vector_app_251_bglt new1849_3659;
								   new1849_3659 =
								      ((pre_make_vector_app_251_bglt) BREF(GC_MALLOC(sizeof(struct pre_make_vector_app_251))));
								   ((((pre_make_vector_app_251_bglt) CREF(new1849_3659))->owner) = ((variable_bglt) owner_5), BUNSPEC);
								   res2514_3661 = new1849_3659;
								}
								arg2439_3034 = res2514_3661;
							     }
							     {	/* Cfa/collect.scm 160 */
								obj_t aux_4088;
								object_bglt aux_4086;
								aux_4088 =
								   (obj_t) (arg2439_3034);
								aux_4086 =
								   (object_bglt) (obj2046_3033);
								OBJECT_WIDENING_SET(aux_4086, aux_4088);
							     }
							  }
							  {	/* Cfa/collect.scm 160 */
							     long arg2441_3036;
							     arg2441_3036 =
								class_num_218___object(pre_make_vector_app_251_cfa_info2);
							     {	/* Cfa/collect.scm 160 */
								obj_t obj_3662;
								obj_3662 =
								   (obj_t) (obj2046_3033);
								(((obj_t) CREF(obj_3662))->header = MAKE_HEADER(arg2441_3036, 0), BUNSPEC);
							     }
							  }
							  return
							     (obj_t) (obj2046_3033);
						       }
						    }
						  else
						    {	/* Cfa/collect.scm 157 */
						       bool_t test_4095;
						       {	/* ./Ieee/equiv.scm 5508 */
							  obj_t aux_4096;
							  aux_4096 =
							     CNST_TABLE_REF(((long) 11));
							  test_4095 =
							     (case_value_58_3031 == aux_4096);
						       }
						       if (test_4095)
							 {	/* Cfa/collect.scm 157 */
							    {	/* Cfa/collect.scm 318 */
							       obj_t obj2_3668;
							       obj2_3668 = _used_alloc__125_cfa_collect;
							       {	/* ./Ieee/pair-list.scm 5689 */
								  obj_t aux_4099;
								  aux_4099 =
								     (obj_t) (node_3004);
								  _used_alloc__125_cfa_collect =
								     MAKE_PAIR(aux_4099, obj2_3668);
							       }
							    }
							    {	/* Cfa/collect.scm 163 */
							       pre_create_vector_app_162_bglt obj2047_3038;
							       obj2047_3038 =
								  ((pre_create_vector_app_162_bglt) (node_3004));
							       {	/* Cfa/collect.scm 163 */
								  pre_create_vector_app_162_bglt arg2443_3039;
								  {	/* Cfa/collect.scm 163 */
								     pre_create_vector_app_162_bglt res2515_3672;
								     {	/* ./Cfa/cinfo2.scm 1669 */
									pre_create_vector_app_162_bglt new1861_3670;
									new1861_3670 =
									   ((pre_create_vector_app_162_bglt) BREF(GC_MALLOC(sizeof(struct pre_create_vector_app_162))));
									((((pre_create_vector_app_162_bglt) CREF(new1861_3670))->owner) = ((variable_bglt) owner_5), BUNSPEC);
									res2515_3672 = new1861_3670;
								     }
								     arg2443_3039 = res2515_3672;
								  }
								  {	/* Cfa/collect.scm 163 */
								     obj_t aux_4107;
								     object_bglt aux_4105;
								     aux_4107 =
									(obj_t) (arg2443_3039);
								     aux_4105 =
									(object_bglt) (obj2047_3038);
								     OBJECT_WIDENING_SET(aux_4105, aux_4107);
								  }
							       }
							       {	/* Cfa/collect.scm 163 */
								  long arg2445_3041;
								  arg2445_3041 =
								     class_num_218___object(pre_create_vector_app_162_cfa_info2);
								  {	/* Cfa/collect.scm 163 */
								     obj_t obj_3673;
								     obj_3673 =
									(obj_t) (obj2047_3038);
								     (((obj_t) CREF(obj_3673))->header = MAKE_HEADER(arg2445_3041, 0), BUNSPEC);
								  }
							       }
							       return
								  (obj_t) (obj2047_3038);
							    }
							 }
						       else
							 {	/* Cfa/collect.scm 157 */
							    bool_t test_4114;
							    {	/* ./Ieee/equiv.scm 5508 */
							       obj_t aux_4115;
							       aux_4115 =
								  CNST_TABLE_REF(((long) 12));
							       test_4114 =
								  (case_value_58_3031 == aux_4115);
							    }
							    if (test_4114)
							      {		/* Cfa/collect.scm 165 */
								 pre_vector_ref_app_208_bglt obj2048_3043;
								 obj2048_3043 =
								    ((pre_vector_ref_app_208_bglt) (node_3004));
								 {	/* Cfa/collect.scm 165 */
								    obj_t aux_4121;
								    object_bglt aux_4119;
								    {	/* Cfa/collect.scm 165 */
								       pre_vector_ref_app_208_bglt aux_4122;
								       {	/* ./Cfa/cinfo2.scm 1672 */

									  aux_4122 =
									     ((pre_vector_ref_app_208_bglt) BREF(GC_MALLOC(sizeof(struct pre_vector_ref_app_208))));
								       }
								       aux_4121 =
									  (obj_t) (aux_4122);
								    }
								    aux_4119 =
								       (object_bglt) (obj2048_3043);
								    OBJECT_WIDENING_SET(aux_4119, aux_4121);
								 }
								 {	/* Cfa/collect.scm 165 */
								    long arg2448_3045;
								    arg2448_3045 =
								       class_num_218___object(pre_vector_ref_app_208_cfa_info2);
								    {	/* Cfa/collect.scm 165 */
								       obj_t obj_3679;
								       obj_3679 =
									  (obj_t) (obj2048_3043);
								       (((obj_t) CREF(obj_3679))->header = MAKE_HEADER(arg2448_3045, 0), BUNSPEC);
								    }
								 }
								 return
								    (obj_t) (obj2048_3043);
							      }
							    else
							      {		/* Cfa/collect.scm 157 */
								 bool_t test_4130;
								 {	/* ./Ieee/equiv.scm 5508 */
								    obj_t aux_4131;
								    aux_4131 =
								       CNST_TABLE_REF(((long) 13));
								    test_4130 =
								       (case_value_58_3031 == aux_4131);
								 }
								 if (test_4130)
								   {	/* Cfa/collect.scm 167 */
								      pre_vector_set__app_211_bglt obj2049_3047;
								      obj2049_3047 =
									 ((pre_vector_set__app_211_bglt) (node_3004));
								      {		/* Cfa/collect.scm 167 */
									 obj_t aux_4137;
									 object_bglt aux_4135;
									 {	/* Cfa/collect.scm 167 */
									    pre_vector_set__app_211_bglt aux_4138;
									    {	/* ./Cfa/cinfo2.scm 1673 */

									       aux_4138 =
										  ((pre_vector_set__app_211_bglt) BREF(GC_MALLOC(sizeof(struct pre_vector_set__app_211))));
									    }
									    aux_4137 =
									       (obj_t) (aux_4138);
									 }
									 aux_4135 =
									    (object_bglt) (obj2049_3047);
									 OBJECT_WIDENING_SET(aux_4135, aux_4137);
								      }
								      {		/* Cfa/collect.scm 167 */
									 long arg2451_3049;
									 arg2451_3049 =
									    class_num_218___object(pre_vector_set__app_211_cfa_info2);
									 {	/* Cfa/collect.scm 167 */
									    obj_t obj_3685;
									    obj_3685 =
									       (obj_t) (obj2049_3047);
									    (((obj_t) CREF(obj_3685))->header = MAKE_HEADER(arg2451_3049, 0), BUNSPEC);
									 }
								      }
								      return
									 (obj_t) (obj2049_3047);
								   }
								 else
								   {	/* Cfa/collect.scm 157 */
								      bool_t test_4146;
								      {		/* ./Ieee/equiv.scm 5508 */
									 obj_t aux_4147;
									 aux_4147 =
									    CNST_TABLE_REF(((long) 14));
									 test_4146 =
									    (case_value_58_3031 == aux_4147);
								      }
								      if (test_4146)
									{	/* Cfa/collect.scm 157 */
									   {	/* Cfa/collect.scm 318 */
									      obj_t obj2_3691;
									      obj2_3691 = _used_alloc__125_cfa_collect;
									      {		/* ./Ieee/pair-list.scm 5689 */
										 obj_t aux_4150;
										 aux_4150 =
										    (obj_t) (node_3004);
										 _used_alloc__125_cfa_collect =
										    MAKE_PAIR(aux_4150, obj2_3691);
									      }
									   }
									   {	/* Cfa/collect.scm 170 */
									      pre_make_struct_app_218_bglt obj2050_3051;
									      obj2050_3051 =
										 ((pre_make_struct_app_218_bglt) (node_3004));
									      {		/* Cfa/collect.scm 170 */
										 pre_make_struct_app_218_bglt arg2453_3052;
										 {	/* Cfa/collect.scm 170 */
										    pre_make_struct_app_218_bglt res2518_3695;
										    {	/* ./Cfa/cinfo2.scm 1720 */
										       pre_make_struct_app_218_bglt new1965_3693;
										       new1965_3693 =
											  ((pre_make_struct_app_218_bglt) BREF(GC_MALLOC(sizeof(struct pre_make_struct_app_218))));
										       ((((pre_make_struct_app_218_bglt) CREF(new1965_3693))->owner) = ((variable_bglt) owner_5), BUNSPEC);
										       res2518_3695 = new1965_3693;
										    }
										    arg2453_3052 = res2518_3695;
										 }
										 {	/* Cfa/collect.scm 170 */
										    obj_t aux_4158;
										    object_bglt aux_4156;
										    aux_4158 =
										       (obj_t) (arg2453_3052);
										    aux_4156 =
										       (object_bglt) (obj2050_3051);
										    OBJECT_WIDENING_SET(aux_4156, aux_4158);
										 }
									      }
									      {		/* Cfa/collect.scm 170 */
										 long arg2455_3054;
										 arg2455_3054 =
										    class_num_218___object(pre_make_struct_app_218_cfa_info2);
										 {	/* Cfa/collect.scm 170 */
										    obj_t obj_3696;
										    obj_3696 =
										       (obj_t) (obj2050_3051);
										    (((obj_t) CREF(obj_3696))->header = MAKE_HEADER(arg2455_3054, 0), BUNSPEC);
										 }
									      }
									      return
										 (obj_t) (obj2050_3051);
									   }
									}
								      else
									{	/* Cfa/collect.scm 157 */
									   bool_t test_4165;
									   {	/* ./Ieee/equiv.scm 5508 */
									      obj_t aux_4166;
									      aux_4166 =
										 CNST_TABLE_REF(((long) 15));
									      test_4165 =
										 (case_value_58_3031 == aux_4166);
									   }
									   if (test_4165)
									     {	/* Cfa/collect.scm 172 */
										pre_struct_ref_app_207_bglt obj2052_3056;
										obj2052_3056 =
										   ((pre_struct_ref_app_207_bglt) (node_3004));
										{	/* Cfa/collect.scm 172 */
										   obj_t aux_4172;
										   object_bglt aux_4170;
										   {	/* Cfa/collect.scm 172 */
										      pre_struct_ref_app_207_bglt aux_4173;
										      {		/* ./Cfa/cinfo2.scm 1723 */

											 aux_4173 =
											    ((pre_struct_ref_app_207_bglt) BREF(GC_MALLOC(sizeof(struct pre_struct_ref_app_207))));
										      }
										      aux_4172 =
											 (obj_t) (aux_4173);
										   }
										   aux_4170 =
										      (object_bglt) (obj2052_3056);
										   OBJECT_WIDENING_SET(aux_4170, aux_4172);
										}
										{	/* Cfa/collect.scm 172 */
										   long arg2458_3058;
										   arg2458_3058 =
										      class_num_218___object(pre_struct_ref_app_207_cfa_info2);
										   {	/* Cfa/collect.scm 172 */
										      obj_t obj_3702;
										      obj_3702 =
											 (obj_t) (obj2052_3056);
										      (((obj_t) CREF(obj_3702))->header = MAKE_HEADER(arg2458_3058, 0), BUNSPEC);
										   }
										}
										return
										   (obj_t) (obj2052_3056);
									     }
									   else
									     {	/* Cfa/collect.scm 157 */
										bool_t test_4181;
										{	/* ./Ieee/equiv.scm 5508 */
										   obj_t aux_4182;
										   aux_4182 =
										      CNST_TABLE_REF(((long) 16));
										   test_4181 =
										      (case_value_58_3031 == aux_4182);
										}
										if (test_4181)
										  {	/* Cfa/collect.scm 174 */
										     pre_struct_set__app_116_bglt obj2053_3060;
										     obj2053_3060 =
											((pre_struct_set__app_116_bglt) (node_3004));
										     {	/* Cfa/collect.scm 174 */
											obj_t aux_4188;
											object_bglt aux_4186;
											{	/* Cfa/collect.scm 174 */
											   pre_struct_set__app_116_bglt aux_4189;
											   {	/* ./Cfa/cinfo2.scm 1724 */

											      aux_4189 =
												 ((pre_struct_set__app_116_bglt) BREF(GC_MALLOC(sizeof(struct pre_struct_set__app_116))));
											   }
											   aux_4188 =
											      (obj_t) (aux_4189);
											}
											aux_4186 =
											   (object_bglt) (obj2053_3060);
											OBJECT_WIDENING_SET(aux_4186, aux_4188);
										     }
										     {	/* Cfa/collect.scm 174 */
											long arg2461_3062;
											arg2461_3062 =
											   class_num_218___object(pre_struct_set__app_116_cfa_info2);
											{	/* Cfa/collect.scm 174 */
											   obj_t obj_3708;
											   obj_3708 =
											      (obj_t) (obj2053_3060);
											   (((obj_t) CREF(obj_3708))->header = MAKE_HEADER(arg2461_3062, 0), BUNSPEC);
											}
										     }
										     return
											(obj_t) (obj2053_3060);
										  }
										else
										  {	/* Cfa/collect.scm 157 */
										     return BFALSE;
										  }
									     }
									}
								   }
							      }
							 }
						    }
					       }
					    }
					  else
					    {	/* Cfa/collect.scm 156 */
					       return BUNSPEC;
					    }
				       }
				    }
				  else
				    {	/* Cfa/collect.scm 140 */
				       return BUNSPEC;
				    }
			       }
			    }
			 }
			 break;
		      case ((long) 5):

			 {	/* Cfa/collect.scm 180 */
			    app_ly_162_bglt node_3066;
			    node_3066 =
			       (app_ly_162_bglt) (node_4);
			    node_collect__175_cfa_collect(
			       (((app_ly_162_bglt) CREF(node_3066))->fun), owner_5);
			    {
			       node_bglt node_4200;
			       node_4200 =
				  (((app_ly_162_bglt) CREF(node_3066))->arg);
			       node_4 = node_4200;
			       goto node_collect__175_cfa_collect;
			    }
			 }
			 break;
		      case ((long) 6):

			 {	/* Cfa/collect.scm 53 */
			    funcall_bglt node_3071;
			    node_3071 =
			       (funcall_bglt) (node_4);
			    add_funcall__195_cfa_closure(
			       (node_bglt) (node_3071));
			    node_collect__175_cfa_collect(
			       (((funcall_bglt) CREF(node_3071))->fun), owner_5);
			    {	/* Cfa/collect.scm 191 */
			       bool_t aux_4207;
			       aux_4207 =
				  node_collect___108_cfa_collect(
				  (((funcall_bglt) CREF(node_3071))->args), owner_5);
			       return
				  BBOOL(aux_4207);
			    }
			 }
			 break;
		      case ((long) 7):

			 {	/* Cfa/collect.scm 197 */
			    pragma_bglt node_3076;
			    node_3076 =
			       (pragma_bglt) (node_4);
			    {	/* Cfa/collect.scm 198 */
			       bool_t aux_4212;
			       aux_4212 =
				  node_collect___108_cfa_collect(
				  (((pragma_bglt) CREF(node_3076))->args), owner_5);
			       return
				  BBOOL(aux_4212);
			    }
			 }
			 break;
		      case ((long) 8):

			 {	/* Cfa/collect.scm 204 */
			    cast_bglt node_3080;
			    node_3080 =
			       (cast_bglt) (node_4);
			    {
			       node_bglt node_4217;
			       node_4217 =
				  (((cast_bglt) CREF(node_3080))->arg);
			       node_4 = node_4217;
			       goto node_collect__175_cfa_collect;
			    }
			 }
			 break;
		      case ((long) 9):

			 {	/* Cfa/collect.scm 211 */
			    setq_bglt node_3084;
			    node_3084 =
			       (setq_bglt) (node_4);
			    {
			       node_bglt node_4220;
			       node_4220 =
				  (((setq_bglt) CREF(node_3084))->value);
			       node_4 = node_4220;
			       goto node_collect__175_cfa_collect;
			    }
			 }
			 break;
		      case ((long) 10):

			 {	/* Cfa/collect.scm 218 */
			    conditional_bglt node_3088;
			    node_3088 =
			       (conditional_bglt) (node_4);
			    node_collect__175_cfa_collect(
			       (((conditional_bglt) CREF(node_3088))->test), owner_5);
			    node_collect__175_cfa_collect(
			       (((conditional_bglt) CREF(node_3088))->true), owner_5);
			    {
			       node_bglt node_4227;
			       node_4227 =
				  (((conditional_bglt) CREF(node_3088))->false);
			       node_4 = node_4227;
			       goto node_collect__175_cfa_collect;
			    }
			 }
			 break;
		      case ((long) 11):

			 {	/* Cfa/collect.scm 227 */
			    fail_bglt node_3094;
			    node_3094 =
			       (fail_bglt) (node_4);
			    node_collect__175_cfa_collect(
			       (((fail_bglt) CREF(node_3094))->proc), owner_5);
			    node_collect__175_cfa_collect(
			       (((fail_bglt) CREF(node_3094))->msg), owner_5);
			    {
			       node_bglt node_4234;
			       node_4234 =
				  (((fail_bglt) CREF(node_3094))->obj);
			       node_4 = node_4234;
			       goto node_collect__175_cfa_collect;
			    }
			 }
			 break;
		      case ((long) 12):

			 {	/* Cfa/collect.scm 236 */
			    select_bglt node_3100;
			    node_3100 =
			       (select_bglt) (node_4);
			    node_collect__175_cfa_collect(
			       (((select_bglt) CREF(node_3100))->test), owner_5);
			    {
			       obj_t l2062_3104;
			       {	/* Cfa/collect.scm 238 */
				  bool_t aux_4239;
				  l2062_3104 =
				     (((select_bglt) CREF(node_3100))->clauses);
				lname2063_3105:
				  if (
				     PAIRP(l2062_3104))
				    {	/* Cfa/collect.scm 238 */
				       {	/* Cfa/collect.scm 239 */
					  node_bglt aux_4242;
					  {	/* Cfa/collect.scm 239 */
					     obj_t aux_4243;
					     {	/* ./Ieee/pair-list.scm 5707 */
						obj_t aux_4244;
						aux_4244 =
						   CAR(l2062_3104);
						aux_4243 =
						   CDR(aux_4244);
					     }
					     aux_4242 =
						(node_bglt) (aux_4243);
					  }
					  node_collect__175_cfa_collect(aux_4242, owner_5);
				       }
				       {
					  obj_t l2062_4249;
					  l2062_4249 =
					     CDR(l2062_3104);
					  l2062_3104 = l2062_4249;
					  goto lname2063_3105;
				       }
				    }
				  else
				    {	/* Cfa/collect.scm 238 */
				       aux_4239 = ((bool_t) 1);
				    }
				  return
				     BBOOL(aux_4239);
			       }
			    }
			 }
			 break;
		      case ((long) 13):

			 {	/* Cfa/collect.scm 246 */
			    let_fun_218_bglt node_3111;
			    node_3111 =
			       (let_fun_218_bglt) (node_4);
			    {
			       obj_t l2065_3114;
			       l2065_3114 =
				  (((let_fun_218_bglt) CREF(node_3111))->locals);
			     lname2066_3115:
			       if (
				  PAIRP(l2065_3114))
				 {	/* Cfa/collect.scm 247 */
				    {	/* Cfa/collect.scm 248 */
				       obj_t l_3118;
				       l_3118 =
					  CAR(l2065_3114);
				       {	/* Cfa/collect.scm 249 */
					  node_bglt aux_4257;
					  {	/* Cfa/collect.scm 249 */
					     obj_t aux_4258;
					     {	/* Cfa/collect.scm 249 */
						sfun_bglt obj_3733;
						{	/* Cfa/collect.scm 249 */
						   value_bglt aux_4259;
						   {	/* Cfa/collect.scm 248 */
						      local_bglt obj_3732;
						      obj_3732 =
							 (local_bglt) (l_3118);
						      aux_4259 =
							 (((local_bglt) CREF(obj_3732))->value);
						   }
						   obj_3733 =
						      (sfun_bglt) (aux_4259);
						}
						aux_4258 =
						   (((sfun_bglt) CREF(obj_3733))->body);
					     }
					     aux_4257 =
						(node_bglt) (aux_4258);
					  }
					  node_collect__175_cfa_collect(aux_4257,
					     (variable_bglt) (l_3118));
				       }
				    }
				    {
				       obj_t l2065_4267;
				       l2065_4267 =
					  CDR(l2065_3114);
				       l2065_3114 = l2065_4267;
				       goto lname2066_3115;
				    }
				 }
			       else
				 {	/* Cfa/collect.scm 247 */
				    ((bool_t) 1);
				 }
			    }
			    {
			       node_bglt node_4270;
			       node_4270 =
				  (((let_fun_218_bglt) CREF(node_3111))->body);
			       node_4 = node_4270;
			       goto node_collect__175_cfa_collect;
			    }
			 }
			 break;
		      case ((long) 14):

			 {	/* Cfa/collect.scm 257 */
			    let_var_6_bglt node_3123;
			    node_3123 =
			       (let_var_6_bglt) (node_4);
			    {
			       obj_t l2068_3126;
			       l2068_3126 =
				  (((let_var_6_bglt) CREF(node_3123))->bindings);
			     lname2069_3127:
			       if (
				  PAIRP(l2068_3126))
				 {	/* Cfa/collect.scm 258 */
				    {	/* Cfa/collect.scm 259 */
				       node_bglt aux_4275;
				       {	/* Cfa/collect.scm 259 */
					  obj_t aux_4276;
					  {	/* ./Ieee/pair-list.scm 5707 */
					     obj_t aux_4277;
					     aux_4277 =
						CAR(l2068_3126);
					     aux_4276 =
						CDR(aux_4277);
					  }
					  aux_4275 =
					     (node_bglt) (aux_4276);
				       }
				       node_collect__175_cfa_collect(aux_4275, owner_5);
				    }
				    {
				       obj_t l2068_4282;
				       l2068_4282 =
					  CDR(l2068_3126);
				       l2068_3126 = l2068_4282;
				       goto lname2069_3127;
				    }
				 }
			       else
				 {	/* Cfa/collect.scm 258 */
				    ((bool_t) 1);
				 }
			    }
			    {
			       node_bglt node_4285;
			       node_4285 =
				  (((let_var_6_bglt) CREF(node_3123))->body);
			       node_4 = node_4285;
			       goto node_collect__175_cfa_collect;
			    }
			 }
			 break;
		      case ((long) 15):

			 {	/* Cfa/collect.scm 267 */
			    set_ex_it_116_bglt node_3134;
			    node_3134 =
			       (set_ex_it_116_bglt) (node_4);
			    {
			       node_bglt node_4288;
			       node_4288 =
				  (((set_ex_it_116_bglt) CREF(node_3134))->body);
			       node_4 = node_4288;
			       goto node_collect__175_cfa_collect;
			    }
			 }
			 break;
		      case ((long) 16):

			 {	/* Cfa/collect.scm 274 */
			    jump_ex_it_184_bglt node_3138;
			    node_3138 =
			       (jump_ex_it_184_bglt) (node_4);
			    node_collect__175_cfa_collect(
			       (((jump_ex_it_184_bglt) CREF(node_3138))->exit), owner_5);
			    {
			       node_bglt node_4293;
			       node_4293 =
				  (((jump_ex_it_184_bglt) CREF(node_3138))->value);
			       node_4 = node_4293;
			       goto node_collect__175_cfa_collect;
			    }
			 }
			 break;
		      case ((long) 17):

			 {	/* Cfa/collect.scm 53 */
			    make_box_202_bglt node_3143;
			    node_3143 =
			       (make_box_202_bglt) (node_4);
			    node_collect__175_cfa_collect(
			       (((make_box_202_bglt) CREF(node_3143))->value), owner_5);
			    {	/* Cfa/collect.scm 283 */
			       bool_t test2497_3146;
			       {	/* Cfa/collect.scm 283 */
				  long n1_3746;
				  n1_3746 =
				     (long) CINT(_optim__89_engine_param);
				  test2497_3146 =
				     (n1_3746 >= ((long) 1));
			       }
			       if (test2497_3146)
				 {	/* Cfa/collect.scm 283 */
				    {	/* Cfa/collect.scm 318 */
				       obj_t obj2_3750;
				       obj2_3750 = _used_alloc__125_cfa_collect;
				       {	/* ./Ieee/pair-list.scm 5689 */
					  obj_t aux_4301;
					  aux_4301 =
					     (obj_t) (node_3143);
					  _used_alloc__125_cfa_collect =
					     MAKE_PAIR(aux_4301, obj2_3750);
				       }
				    }
				    {	/* Cfa/collect.scm 286 */
				       pre_make_box_186_bglt obj2072_3147;
				       obj2072_3147 =
					  ((pre_make_box_186_bglt) (node_3143));
				       {	/* Cfa/collect.scm 286 */
					  obj_t aux_4307;
					  object_bglt aux_4305;
					  {	/* Cfa/collect.scm 286 */
					     pre_make_box_186_bglt aux_4308;
					     {	/* ./Cfa/cinfo.scm 1603 */

						aux_4308 =
						   ((pre_make_box_186_bglt) BREF(GC_MALLOC(sizeof(struct pre_make_box_186))));
					     }
					     aux_4307 =
						(obj_t) (aux_4308);
					  }
					  aux_4305 =
					     (object_bglt) (obj2072_3147);
					  OBJECT_WIDENING_SET(aux_4305, aux_4307);
				       }
				       {	/* Cfa/collect.scm 286 */
					  long arg2499_3149;
					  arg2499_3149 =
					     class_num_218___object(pre_make_box_186_cfa_info);
					  {	/* Cfa/collect.scm 286 */
					     obj_t obj_3753;
					     obj_3753 =
						(obj_t) (obj2072_3147);
					     (((obj_t) CREF(obj_3753))->header = MAKE_HEADER(arg2499_3149, 0), BUNSPEC);
					  }
				       }
				       return
					  (obj_t) (obj2072_3147);
				    }
				 }
			       else
				 {	/* Cfa/collect.scm 283 */
				    return BUNSPEC;
				 }
			    }
			 }
			 break;
		      case ((long) 18):

			 {	/* Cfa/collect.scm 292 */
			    box_set__221_bglt node_3150;
			    node_3150 =
			       (box_set__221_bglt) (node_4);
			    {	/* Cfa/collect.scm 293 */
			       node_bglt aux_4317;
			       {	/* Cfa/collect.scm 293 */
				  var_bglt aux_4318;
				  aux_4318 =
				     (((box_set__221_bglt) CREF(node_3150))->var);
				  aux_4317 =
				     (node_bglt) (aux_4318);
			       }
			       node_collect__175_cfa_collect(aux_4317, owner_5);
			    }
			    {
			       node_bglt node_4322;
			       node_4322 =
				  (((box_set__221_bglt) CREF(node_3150))->value);
			       node_4 = node_4322;
			       goto node_collect__175_cfa_collect;
			    }
			 }
			 break;
		      case ((long) 19):

			 {	/* Cfa/collect.scm 300 */
			    box_ref_242_bglt node_3155;
			    node_3155 =
			       (box_ref_242_bglt) (node_4);
			    {
			       node_bglt node_4325;
			       {	/* Cfa/collect.scm 301 */
				  var_bglt aux_4326;
				  aux_4326 =
				     (((box_ref_242_bglt) CREF(node_3155))->var);
				  node_4325 =
				     (node_bglt) (aux_4326);
			       }
			       node_4 = node_4325;
			       goto node_collect__175_cfa_collect;
			    }
			 }
			 break;
		      default:
		       case_else2389_2964:
			 if (
			    PROCEDUREP(method2383_2960))
			   {	/* Cfa/collect.scm 53 */
			      return
				 PROCEDURE_ENTRY(method2383_2960) (method2383_2960,
				 (obj_t) (node_4),
				 (obj_t) (owner_5), BEOA);
			   }
			 else
			   {	/* Cfa/collect.scm 53 */
			      obj_t fun2381_2956;
			      fun2381_2956 =
				 PROCEDURE_REF(node_collect__env_176_cfa_collect, ((long) 0));
			      return
				 PROCEDURE_ENTRY(fun2381_2956) (fun2381_2956,
				 (obj_t) (node_4),
				 (obj_t) (owner_5), BEOA);
			   }
		      }
		 }
	       else
		 {	/* Cfa/collect.scm 53 */
		    goto case_else2389_2964;
		 }
	    }
	 }
      }
   }
}



/* _node-collect! */
obj_t 
_node_collect__42_cfa_collect(obj_t env_3766, obj_t node_3767, obj_t owner_3768)
{
   AN_OBJECT;
   {	/* Cfa/collect.scm 53 */
      return
	 node_collect__175_cfa_collect(
	 (node_bglt) (node_3767),
	 (variable_bglt) (owner_3768));
   }
}



/* node-collect!-default2077 */
obj_t 
node_collect__default2077_182_cfa_collect(node_bglt node_6, variable_bglt owner_7)
{
   AN_OBJECT;
   {	/* Cfa/collect.scm 14 */
      FAILURE(
	 CNST_TABLE_REF(((long) 17)), string2523_cfa_collect,
	 (obj_t) (node_6));
   }
}



/* _node-collect!-default2077 */
obj_t 
_node_collect__default2077_57_cfa_collect(obj_t env_3769, obj_t node_3770, obj_t owner_3771)
{
   AN_OBJECT;
   {	/* Cfa/collect.scm 14 */
      return
	 node_collect__default2077_182_cfa_collect(
	 (node_bglt) (node_3770),
	 (variable_bglt) (owner_3771));
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_cfa_collect()
{
   AN_OBJECT;
   {	/* Cfa/collect.scm 14 */
      module_initialization_70_tools_trace(((long) 0), "CFA_COLLECT");
      module_initialization_70_tools_shape(((long) 0), "CFA_COLLECT");
      module_initialization_70_type_type(((long) 0), "CFA_COLLECT");
      module_initialization_70_type_cache(((long) 0), "CFA_COLLECT");
      module_initialization_70_type_typeof(((long) 0), "CFA_COLLECT");
      module_initialization_70_module_module(((long) 0), "CFA_COLLECT");
      module_initialization_70_engine_param(((long) 0), "CFA_COLLECT");
      module_initialization_70_ast_var(((long) 0), "CFA_COLLECT");
      module_initialization_70_ast_node(((long) 0), "CFA_COLLECT");
      module_initialization_70_ast_dump(((long) 0), "CFA_COLLECT");
      module_initialization_70_ast_env(((long) 0), "CFA_COLLECT");
      module_initialization_70_ast_sexp(((long) 0), "CFA_COLLECT");
      module_initialization_70_cfa_info(((long) 0), "CFA_COLLECT");
      module_initialization_70_cfa_info2(((long) 0), "CFA_COLLECT");
      module_initialization_70_cfa_procedure(((long) 0), "CFA_COLLECT");
      module_initialization_70_cfa_vector(((long) 0), "CFA_COLLECT");
      module_initialization_70_cfa_struct(((long) 0), "CFA_COLLECT");
      module_initialization_70_cfa_box(((long) 0), "CFA_COLLECT");
      return
	 module_initialization_70_cfa_closure(((long) 0), "CFA_COLLECT");
   }
}
