/*===========================================================================*/
/*   (Cfa/funcall.scm)                                                       */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;

typedef struct approx
  {
     header_t header;
     obj_t widening;
     struct type *type;
     bool_t type_locked__184;
     obj_t allocs;
     bool_t top__138;
     long lost_stamp_114;
  }
      *approx_bglt;

typedef struct cfun_cinfo_200
  {
     struct approx *approx;
  }
              *cfun_cinfo_200_bglt;

typedef struct extern_sfun_cinfo_6
  {
     struct approx *approx;
  }
                   *extern_sfun_cinfo_6_bglt;

typedef struct intern_sfun_cinfo_192
  {
     struct approx *approx;
     long stamp;
  }
                     *intern_sfun_cinfo_192_bglt;

typedef struct scnst_cinfo_0
  {
     struct approx *approx;
  }
             *scnst_cinfo_0_bglt;

typedef struct pre_clo_env_191
  {
     char dummy;
  }
               *pre_clo_env_191_bglt;

typedef struct svar_cinfo_166
  {
     struct approx *approx;
     bool_t clo_env__87;
  }
              *svar_cinfo_166_bglt;

typedef struct cvar_cinfo_53
  {
     struct approx *approx;
  }
             *cvar_cinfo_53_bglt;

typedef struct sexit_cinfo_49
  {
     struct approx *approx;
  }
              *sexit_cinfo_49_bglt;

typedef struct reshaped_local_224
  {
     obj_t binding_value_3;
  }
                  *reshaped_local_224_bglt;

typedef struct reshaped_global_160
  {
     char dummy;
  }
                   *reshaped_global_160_bglt;

typedef struct atom_cinfo_155
  {
     struct approx *approx;
  }
              *atom_cinfo_155_bglt;

typedef struct kwote_node_102
  {
     struct node *node;
  }
              *kwote_node_102_bglt;

typedef struct kwote_cinfo_48
  {
     struct approx *approx;
  }
              *kwote_cinfo_48_bglt;

typedef struct app_ly_cinfo_234
  {
     struct approx *approx;
  }
                *app_ly_cinfo_234_bglt;

typedef struct funcall_cinfo_75
  {
     struct approx *approx;
     struct approx *va_approx_63;
     bool_t arity_error_noticed__118;
     bool_t type_error_noticed__36;
  }
                *funcall_cinfo_75_bglt;

typedef struct pragma_cinfo_220
  {
     struct approx *approx;
  }
                *pragma_cinfo_220_bglt;

typedef struct setq_cinfo_191
  {
     struct approx *approx;
  }
              *setq_cinfo_191_bglt;

typedef struct conditional_cinfo_212
  {
     struct approx *approx;
  }
                     *conditional_cinfo_212_bglt;

typedef struct fail_cinfo_75
  {
     struct approx *approx;
  }
             *fail_cinfo_75_bglt;

typedef struct select_cinfo_150
  {
     struct approx *approx;
  }
                *select_cinfo_150_bglt;

typedef struct set_ex_it_cinfo_168
  {
     struct approx *approx;
  }
                   *set_ex_it_cinfo_168_bglt;

typedef struct jump_ex_it_cinfo_139
  {
     struct approx *approx;
  }
                    *jump_ex_it_cinfo_139_bglt;

typedef struct pre_make_box_186
  {
     char dummy;
  }
                *pre_make_box_186_bglt;

typedef struct make_box_cinfo_127
  {
     struct approx *approx;
  }
                  *make_box_cinfo_127_bglt;

typedef struct make_box_o_cinfo_96
  {
     struct approx *approx;
     struct approx *value_approx_19;
  }
                   *make_box_o_cinfo_96_bglt;

typedef struct box_set__cinfo_94
  {
     struct approx *approx;
  }
                 *box_set__cinfo_94_bglt;

typedef struct box_ref_cinfo_214
  {
     struct approx *approx;
  }
                 *box_ref_cinfo_214_bglt;

typedef struct box_set__o_cinfo_6
  {
     struct approx *approx;
  }
                  *box_set__o_cinfo_6_bglt;

typedef struct box_ref_o_cinfo_98
  {
     struct approx *approx;
  }
                  *box_ref_o_cinfo_98_bglt;

typedef struct pre_make_procedure_app_60
  {
     struct variable *owner;
  }
                         *pre_make_procedure_app_60_bglt;

typedef struct pre_procedure_ref_app_85
  {
     char dummy;
  }
                        *pre_procedure_ref_app_85_bglt;

typedef struct pre_procedure_set__app_208
  {
     char dummy;
  }
                          *pre_procedure_set__app_208_bglt;

typedef struct make_procedure_app_48
  {
     struct approx *approx;
     long values_approx_len_106;
     struct approx **values_approx_79;
     long lost_stamp_114;
     bool_t x_t__142;
     bool_t x;
     bool_t t;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
  }
                     *make_procedure_app_48_bglt;

typedef struct procedure_ref_app_49
  {
     struct approx *approx;
  }
                    *procedure_ref_app_49_bglt;

typedef struct procedure_set__app_32
  {
     struct approx *approx;
  }
                     *procedure_set__app_32_bglt;

typedef struct pre_make_vector_app_251
  {
     struct variable *owner;
  }
                       *pre_make_vector_app_251_bglt;

typedef struct pre_create_vector_app_162
  {
     struct variable *owner;
  }
                         *pre_create_vector_app_162_bglt;

typedef struct pre_vector_ref_app_208
  {
     char dummy;
  }
                      *pre_vector_ref_app_208_bglt;

typedef struct pre_vector_set__app_211
  {
     char dummy;
  }
                       *pre_vector_set__app_211_bglt;

typedef struct make_vector_app_205
  {
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
     bool_t seen__39;
  }
                   *make_vector_app_205_bglt;

typedef struct create_vector_app_150
  {
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
     bool_t seen__39;
  }
                     *create_vector_app_150_bglt;

typedef struct vector_ref_app_195
  {
     struct approx *approx;
  }
                  *vector_ref_app_195_bglt;

typedef struct vector_set__app_21
  {
     struct approx *approx;
  }
                  *vector_set__app_21_bglt;

typedef struct pre_make_struct_app_218
  {
     struct variable *owner;
  }
                       *pre_make_struct_app_218_bglt;

typedef struct pre_struct_ref_app_207
  {
     char dummy;
  }
                      *pre_struct_ref_app_207_bglt;

typedef struct pre_struct_set__app_116
  {
     char dummy;
  }
                       *pre_struct_set__app_116_bglt;

typedef struct make_struct_app_214
  {
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
  }
                   *make_struct_app_214_bglt;

typedef struct struct_ref_app_73
  {
     struct approx *approx;
  }
                 *struct_ref_app_73_bglt;

typedef struct struct_set__app_162
  {
     struct approx *approx;
  }
                   *struct_set__app_162_bglt;


static obj_t method_init_76_cfa_funcall();
extern obj_t user_warning_location_190_tools_error(obj_t, obj_t, obj_t, obj_t);
extern obj_t string_append(obj_t, obj_t);
extern bool_t sound_arity__135_tools_args(obj_t, obj_t);
extern obj_t funcall_cinfo_75_cfa_info;
extern obj_t add_method__1___object(obj_t, obj_t, obj_t);
extern obj_t global_ast_var;
extern obj_t _obj__252_type_cache;
extern approx_bglt make_empty_approx_131_cfa_approx();
static approx_bglt funcall_arity_error_199_cfa_funcall(obj_t, variable_bglt, long, obj_t);
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t module_initialization_70_cfa_funcall(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_args(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_cfa_info(long, char *);
extern obj_t module_initialization_70_cfa_info2(long, char *);
extern obj_t module_initialization_70_cfa_cfa(long, char *);
extern obj_t module_initialization_70_cfa_loose(long, char *);
extern obj_t module_initialization_70_cfa_approx(long, char *);
extern obj_t module_initialization_70_cfa_app(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_numbers_6_5_fixnum(long, char *);
static obj_t funcall_type_error_218_cfa_funcall(funcall_cinfo_75_bglt, type_bglt);
extern approx_bglt union_approx__241_cfa_approx(approx_bglt, approx_bglt);
static approx_bglt funcall__128_cfa_funcall(make_procedure_app_48_bglt, obj_t, obj_t);
static obj_t cfa__funcall_cinfo2048_194_cfa_funcall(obj_t, obj_t);
extern long list_length(obj_t);
extern long class_num_218___object(obj_t);
static obj_t imported_modules_init_94_cfa_funcall();
extern obj_t approx_set_top__187_cfa_approx(approx_bglt);
static obj_t library_modules_init_112_cfa_funcall();
extern approx_bglt cfa__102_cfa_cfa(node_bglt);
extern obj_t for_each_approx_alloc_83_cfa_approx(obj_t, approx_bglt);
static obj_t toplevel_init_63_cfa_funcall();
extern obj_t open_input_string(obj_t);
extern approx_bglt app__231_cfa_app(fun_bglt, var_bglt, obj_t);
extern obj_t approx_set_type__239_cfa_approx(approx_bglt, type_bglt);
extern char *integer__string_135___r4_numbers_6_5_fixnum(long, obj_t);
extern obj_t string_to_bstring(char *);
extern obj_t local_ast_var;
extern obj_t make_procedure_app_48_cfa_info2;
extern obj_t shape_tools_shape(obj_t);
extern obj_t _procedure__226_type_cache;
extern obj_t read___reader(obj_t);
static obj_t _anonymous_2375__104_cfa_funcall(obj_t, obj_t);
static obj_t _anonymous_2368__254_cfa_funcall(obj_t, obj_t);
extern obj_t ____74_type_cache;
static obj_t require_initialization_114_cfa_funcall = BUNSPEC;
extern approx_bglt loose__226_cfa_loose(approx_bglt, obj_t);
static obj_t cnst_init_137_cfa_funcall();
extern obj_t reverse__39___r4_pairs_and_lists_6_3(obj_t);
static obj_t __cnst[1];

DEFINE_STATIC_PROCEDURE(proc2404_cfa_funcall, cfa__funcall_cinfo2048_194_cfa_funcall2410, cfa__funcall_cinfo2048_194_cfa_funcall, 0L, 1);
extern obj_t cfa__env_153_cfa_cfa;
DEFINE_STRING(string2399_cfa_funcall, string2399_cfa_funcall2411, "cfa", 3);
DEFINE_STRING(string2405_cfa_funcall, string2405_cfa_funcall2412, "ALL ", 4);
DEFINE_STRING(string2403_cfa_funcall, string2403_cfa_funcall2413, "Possible funcall arity error", 28);
DEFINE_STRING(string2402_cfa_funcall, string2402_cfa_funcall2414, " arg(s) expected, ", 18);
DEFINE_STRING(string2401_cfa_funcall, string2401_cfa_funcall2415, " provided", 9);
DEFINE_STRING(string2400_cfa_funcall, string2400_cfa_funcall2416, "Possible funcall type error", 27);



/* module-initialization */
obj_t 
module_initialization_70_cfa_funcall(long checksum_3545, char *from_3546)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_cfa_funcall))
	{
	   require_initialization_114_cfa_funcall =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_cfa_funcall();
	   cnst_init_137_cfa_funcall();
	   imported_modules_init_94_cfa_funcall();
	   method_init_76_cfa_funcall();
	   toplevel_init_63_cfa_funcall();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_cfa_funcall()
{
   AN_OBJECT;
   {	/* Cfa/funcall.scm 14 */
      module_initialization_70___object(((long) 0), "CFA_FUNCALL");
      module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "CFA_FUNCALL");
      module_initialization_70___r4_numbers_6_5_fixnum(((long) 0), "CFA_FUNCALL");
      module_initialization_70___reader(((long) 0), "CFA_FUNCALL");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_cfa_funcall()
{
   AN_OBJECT;
   {	/* Cfa/funcall.scm 14 */
      {		/* Cfa/funcall.scm 14 */
	 obj_t cnst_port_138_3538;
	 cnst_port_138_3538 =
	    open_input_string(string2405_cfa_funcall);
	 {
	    long i_3539;
	    i_3539 = ((long) 0);
	  loop_3540:
	    {	/* Cfa/funcall.scm 14 */
	       bool_t test2406_3541;
	       test2406_3541 =
		  (i_3539 == ((long) -1));
	       if (test2406_3541)
		 {	/* Cfa/funcall.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Cfa/funcall.scm 14 */
		    {	/* Cfa/funcall.scm 14 */
		       obj_t arg2407_3542;
		       {	/* Cfa/funcall.scm 14 */
			  obj_t list2408_3543;
			  list2408_3543 =
			     MAKE_PAIR(cnst_port_138_3538, BNIL);
			  arg2407_3542 =
			     read___reader(list2408_3543);
		       }
		       CNST_TABLE_SET(i_3539, arg2407_3542);
		    }
		    {	/* Cfa/funcall.scm 14 */
		       int aux_3544;
		       {	/* Cfa/funcall.scm 14 */
			  long aux_3565;
			  aux_3565 =
			     (i_3539 - ((long) 1));
			  aux_3544 =
			     (int) (aux_3565);
		       }
		       {
			  long i_3568;
			  i_3568 =
			     (long) (aux_3544);
			  i_3539 = i_3568;
			  goto loop_3540;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_cfa_funcall()
{
   AN_OBJECT;
   {	/* Cfa/funcall.scm 14 */
      return BUNSPEC;
   }
}



/* funcall! */
approx_bglt 
funcall__128_cfa_funcall(make_procedure_app_48_bglt alloc_2, obj_t args_approx_137_3, obj_t node_4)
{
   AN_OBJECT;
   {	/* Cfa/funcall.scm 92 */
      {		/* Cfa/funcall.scm 93 */
	 obj_t callee_2111;
	 {	/* ./Ieee/pair-list.scm 5701 */
	    obj_t aux_3570;
	    {	/* Cfa/funcall.scm 93 */
	       app_bglt obj_3008;
	       obj_3008 =
		  (app_bglt) (alloc_2);
	       aux_3570 =
		  (((app_bglt) CREF(obj_3008))->args);
	    }
	    callee_2111 =
	       CAR(aux_3570);
	 }
	 {	/* Cfa/funcall.scm 93 */
	    variable_bglt v_2112;
	    {	/* Cfa/funcall.scm 94 */
	       var_bglt obj_3010;
	       obj_3010 =
		  (var_bglt) (callee_2111);
	       v_2112 =
		  (((var_bglt) CREF(obj_3010))->variable);
	    }
	    {	/* Cfa/funcall.scm 94 */
	       value_bglt fun_2113;
	       fun_2113 =
		  (((variable_bglt) CREF(v_2112))->value);
	       {	/* Cfa/funcall.scm 95 */
		  long arity_2114;
		  {	/* Cfa/funcall.scm 96 */
		     fun_bglt obj_3012;
		     obj_3012 =
			(fun_bglt) (fun_2113);
		     arity_2114 =
			(((fun_bglt) CREF(obj_3012))->arity);
		  }
		  {	/* Cfa/funcall.scm 96 */

		     {	/* Cfa/funcall.scm 100 */
			bool_t test2049_2115;
			test2049_2115 =
			   sound_arity__135_tools_args(
			   BINT(arity_2114), args_approx_137_3);
			if (test2049_2115)
			  {	/* Cfa/funcall.scm 100 */
			     if (
				(arity_2114 >= ((long) 0)))
			       {	/* Cfa/funcall.scm 103 */
				  return
				     app__231_cfa_app(
				     (fun_bglt) (fun_2113),
				     (var_bglt) (callee_2111), args_approx_137_3);
			       }
			     else
			       {	/* Cfa/funcall.scm 103 */
				  {
				     obj_t old_args_approx_165_2117;
				     obj_t new_args_approx_79_2118;
				     long arity_2119;
				     old_args_approx_165_2117 = args_approx_137_3;
				     new_args_approx_79_2118 = BNIL;
				     arity_2119 = arity_2114;
				   loop_2120:
				     if (
					(arity_2119 == ((long) -1)))
				       {	/* Cfa/funcall.scm 112 */
					  {
					     obj_t l2039_2122;
					     l2039_2122 = old_args_approx_165_2117;
					   lname2040_2123:
					     if (
						PAIRP(l2039_2122))
					       {	/* Cfa/funcall.scm 114 */
						  {	/* Cfa/funcall.scm 114 */
						     approx_bglt aux_3591;
						     {	/* Cfa/funcall.scm 114 */
							obj_t aux_3592;
							aux_3592 =
							   CAR(l2039_2122);
							aux_3591 =
							   (approx_bglt) (aux_3592);
						     }
						     loose__226_cfa_loose(aux_3591,
							CNST_TABLE_REF(((long) 0)));
						  }
						  {
						     obj_t l2039_3597;
						     l2039_3597 =
							CDR(l2039_2122);
						     l2039_2122 = l2039_3597;
						     goto lname2040_2123;
						  }
					       }
					     else
					       {	/* Cfa/funcall.scm 114 */
						  ((bool_t) 1);
					       }
					  }
					  {	/* Cfa/funcall.scm 118 */
					     obj_t arg2054_2127;
					     {	/* Cfa/funcall.scm 118 */
						obj_t arg2055_2128;
						{	/* ./Ieee/pair-list.scm 5689 */
						   obj_t aux_3599;
						   {	/* Cfa/funcall.scm 118 */
						      approx_bglt aux_3600;
						      {		/* Cfa/funcall.scm 118 */
							 funcall_cinfo_75_bglt obj_3020;
							 obj_3020 =
							    (funcall_cinfo_75_bglt) (node_4);
							 {
							    obj_t aux_3602;
							    {	/* ./Cfa/cinfo.scm 1120 */
							       object_bglt aux_3603;
							       aux_3603 =
								  (object_bglt) (obj_3020);
							       aux_3602 =
								  OBJECT_WIDENING(aux_3603);
							    }
							    aux_3600 =
							       (((funcall_cinfo_75_bglt) CREF(aux_3602))->va_approx_63);
							 }
						      }
						      aux_3599 =
							 (obj_t) (aux_3600);
						   }
						   arg2055_2128 =
						      MAKE_PAIR(aux_3599, new_args_approx_79_2118);
						}
						arg2054_2127 =
						   reverse__39___r4_pairs_and_lists_6_3(arg2055_2128);
					     }
					     return
						app__231_cfa_app(
						(fun_bglt) (fun_2113),
						(var_bglt) (callee_2111), arg2054_2127);
					  }
				       }
				     else
				       {	/* Cfa/funcall.scm 120 */
					  obj_t arg2057_2130;
					  obj_t arg2058_2131;
					  long arg2059_2132;
					  arg2057_2130 =
					     CDR(old_args_approx_165_2117);
					  {	/* ./Ieee/pair-list.scm 5689 */
					     obj_t aux_3614;
					     aux_3614 =
						CAR(old_args_approx_165_2117);
					     arg2058_2131 =
						MAKE_PAIR(aux_3614, new_args_approx_79_2118);
					  }
					  arg2059_2132 =
					     (arity_2119 + ((long) 1));
					  {
					     long arity_3620;
					     obj_t new_args_approx_79_3619;
					     obj_t old_args_approx_165_3618;
					     old_args_approx_165_3618 = arg2057_2130;
					     new_args_approx_79_3619 = arg2058_2131;
					     arity_3620 = arg2059_2132;
					     arity_2119 = arity_3620;
					     new_args_approx_79_2118 = new_args_approx_79_3619;
					     old_args_approx_165_2117 = old_args_approx_165_3618;
					     goto loop_2120;
					  }
				       }
				  }
			       }
			  }
			else
			  {	/* Cfa/funcall.scm 100 */
			     return
				funcall_arity_error_199_cfa_funcall(node_4, v_2112, arity_2114, args_approx_137_3);
			  }
		     }
		  }
	       }
	    }
	 }
      }
   }
}



/* funcall-type-error */
obj_t 
funcall_type_error_218_cfa_funcall(funcall_cinfo_75_bglt node_5, type_bglt type_6)
{
   AN_OBJECT;
   {	/* Cfa/funcall.scm 127 */
      {		/* Cfa/funcall.scm 130 */
	 bool_t test_3622;
	 {
	    obj_t aux_3623;
	    {	/* ./Cfa/cinfo.scm 1122 */
	       object_bglt aux_3624;
	       aux_3624 =
		  (object_bglt) (node_5);
	       aux_3623 =
		  OBJECT_WIDENING(aux_3624);
	    }
	    test_3622 =
	       (((funcall_cinfo_75_bglt) CREF(aux_3623))->type_error_noticed__36);
	 }
	 if (test_3622)
	   {	/* Cfa/funcall.scm 130 */
	      return BUNSPEC;
	   }
	 else
	   {	/* Cfa/funcall.scm 130 */
	      {
		 obj_t aux_3628;
		 {	/* ./Cfa/cinfo.scm 1122 */
		    object_bglt aux_3629;
		    aux_3629 =
		       (object_bglt) (node_5);
		    aux_3628 =
		       OBJECT_WIDENING(aux_3629);
		 }
		 ((((funcall_cinfo_75_bglt) CREF(aux_3628))->type_error_noticed__36) = ((bool_t) ((bool_t) 1)), BUNSPEC);
	      }
	      {		/* Cfa/funcall.scm 133 */
		 obj_t arg2063_2137;
		 obj_t arg2066_2140;
		 {	/* Cfa/funcall.scm 133 */
		    funcall_bglt obj_3032;
		    obj_3032 =
		       (funcall_bglt) (node_5);
		    arg2063_2137 =
		       (((funcall_bglt) CREF(obj_3032))->loc);
		 }
		 arg2066_2140 =
		    shape_tools_shape(
		    (obj_t) (type_6));
		 return
		    user_warning_location_190_tools_error(arg2063_2137, string2399_cfa_funcall, string2400_cfa_funcall, arg2066_2140);
	      }
	   }
      }
   }
}



/* funcall-arity-error */
approx_bglt 
funcall_arity_error_199_cfa_funcall(obj_t node_7, variable_bglt v_8, long arity_9, obj_t args_approx_137_10)
{
   AN_OBJECT;
   {	/* Cfa/funcall.scm 141 */
      {		/* Cfa/funcall.scm 143 */
	 bool_t test_3638;
	 {	/* Cfa/funcall.scm 143 */
	    funcall_cinfo_75_bglt obj_3033;
	    obj_3033 =
	       (funcall_cinfo_75_bglt) (node_7);
	    {
	       obj_t aux_3640;
	       {	/* ./Cfa/cinfo.scm 1121 */
		  object_bglt aux_3641;
		  aux_3641 =
		     (object_bglt) (obj_3033);
		  aux_3640 =
		     OBJECT_WIDENING(aux_3641);
	       }
	       test_3638 =
		  (((funcall_cinfo_75_bglt) CREF(aux_3640))->arity_error_noticed__118);
	    }
	 }
	 if (test_3638)
	   {	/* Cfa/funcall.scm 143 */
	      BUNSPEC;
	   }
	 else
	   {	/* Cfa/funcall.scm 144 */
	      long len_prov_87_2143;
	      {		/* ./Ieee/fixnum.scm 7199 */
		 long aux_3645;
		 aux_3645 =
		    list_length(args_approx_137_10);
		 len_prov_87_2143 =
		    (aux_3645 - ((long) 1));
	      }
	      {		/* Cfa/funcall.scm 145 */
		 funcall_cinfo_75_bglt obj_3036;
		 obj_3036 =
		    (funcall_cinfo_75_bglt) (node_7);
		 {
		    obj_t aux_3649;
		    {	/* ./Cfa/cinfo.scm 1121 */
		       object_bglt aux_3650;
		       aux_3650 =
			  (object_bglt) (obj_3036);
		       aux_3649 =
			  OBJECT_WIDENING(aux_3650);
		    }
		    ((((funcall_cinfo_75_bglt) CREF(aux_3649))->arity_error_noticed__118) = ((bool_t) ((bool_t) 1)), BUNSPEC);
		 }
	      }
	      {		/* Cfa/funcall.scm 146 */
		 obj_t arg2068_2144;
		 obj_t arg2069_2145;
		 obj_t arg2071_2147;
		 {	/* Cfa/funcall.scm 146 */
		    funcall_bglt obj_3038;
		    obj_3038 =
		       (funcall_bglt) (node_7);
		    arg2068_2144 =
		       (((funcall_bglt) CREF(obj_3038))->loc);
		 }
		 {	/* Cfa/funcall.scm 150 */
		    obj_t arg2072_2148;
		    {	/* Cfa/funcall.scm 150 */
		       bool_t test2073_2149;
		       test2073_2149 =
			  is_a__118___object(
			  (obj_t) (v_8), local_ast_var);
		       if (test2073_2149)
			 {	/* Cfa/funcall.scm 150 */
			    {	/* Cfa/funcall.scm 151 */
			       local_bglt duplicated2043_2150;
			       duplicated2043_2150 =
				  (local_bglt) (v_8);
			       {	/* Cfa/funcall.scm 151 */
				  local_bglt new2044_2151;
				  {	/* Cfa/funcall.scm 151 */
				     obj_t arg2074_2152;
				     obj_t arg2076_2153;
				     type_bglt arg2077_2154;
				     value_bglt arg2078_2155;
				     obj_t arg2079_2156;
				     obj_t arg2080_2157;
				     obj_t arg2081_2158;
				     long arg2082_2159;
				     bool_t arg2083_2160;
				     long arg2084_2161;
				     arg2074_2152 =
					(((local_bglt) CREF(duplicated2043_2150))->id);
				     arg2076_2153 =
					(((local_bglt) CREF(duplicated2043_2150))->name);
				     arg2077_2154 =
					(((local_bglt) CREF(duplicated2043_2150))->type);
				     arg2078_2155 =
					(((local_bglt) CREF(duplicated2043_2150))->value);
				     arg2079_2156 =
					(((local_bglt) CREF(duplicated2043_2150))->access);
				     arg2080_2157 =
					(((local_bglt) CREF(duplicated2043_2150))->fast_alpha_7);
				     arg2081_2158 =
					(((local_bglt) CREF(duplicated2043_2150))->removable);
				     arg2082_2159 =
					(((local_bglt) CREF(duplicated2043_2150))->occurrence);
				     arg2083_2160 =
					(((local_bglt) CREF(duplicated2043_2150))->user__32);
				     arg2084_2161 =
					(((local_bglt) CREF(duplicated2043_2150))->key);
				     {	/* Cfa/funcall.scm 151 */
					local_bglt res2396_3074;
					{	/* ./Ast/var.scm 803 */
					   local_bglt new1089_3060;
					   new1089_3060 =
					      ((local_bglt) BREF(GC_MALLOC(sizeof(struct local))));
					   {	/* ./Ast/var.scm 803 */
					      long arg2347_3061;
					      arg2347_3061 =
						 class_num_218___object(local_ast_var);
					      {		/* ./Ast/var.scm 803 */
						 obj_t obj_3072;
						 obj_3072 =
						    (obj_t) (new1089_3060);
						 (((obj_t) CREF(obj_3072))->header = MAKE_HEADER(arg2347_3061, 0), BUNSPEC);
					      }
					   }
					   {	/* ./Ast/var.scm 803 */
					      object_bglt aux_3674;
					      aux_3674 =
						 (object_bglt) (new1089_3060);
					      OBJECT_WIDENING_SET(aux_3674, BFALSE);
					   }
					   ((((local_bglt) CREF(new1089_3060))->id) = ((obj_t) arg2074_2152), BUNSPEC);
					   ((((local_bglt) CREF(new1089_3060))->name) = ((obj_t) arg2076_2153), BUNSPEC);
					   ((((local_bglt) CREF(new1089_3060))->type) = ((type_bglt) arg2077_2154), BUNSPEC);
					   ((((local_bglt) CREF(new1089_3060))->value) = ((value_bglt) arg2078_2155), BUNSPEC);
					   ((((local_bglt) CREF(new1089_3060))->access) = ((obj_t) arg2079_2156), BUNSPEC);
					   ((((local_bglt) CREF(new1089_3060))->fast_alpha_7) = ((obj_t) arg2080_2157), BUNSPEC);
					   ((((local_bglt) CREF(new1089_3060))->removable) = ((obj_t) arg2081_2158), BUNSPEC);
					   ((((local_bglt) CREF(new1089_3060))->occurrence) = ((long) arg2082_2159), BUNSPEC);
					   ((((local_bglt) CREF(new1089_3060))->user__32) = ((bool_t) arg2083_2160), BUNSPEC);
					   ((((local_bglt) CREF(new1089_3060))->key) = ((long) arg2084_2161), BUNSPEC);
					   res2396_3074 = new1089_3060;
					}
					new2044_2151 = res2396_3074;
				     }
				  }
				  {	/* Cfa/funcall.scm 151 */

				     arg2072_2148 =
					(obj_t) (new2044_2151);
				  }
			       }
			    }
			 }
		       else
			 {	/* Cfa/funcall.scm 152 */
			    bool_t test2085_2162;
			    test2085_2162 =
			       is_a__118___object(
			       (obj_t) (v_8), global_ast_var);
			    if (test2085_2162)
			      {		/* Cfa/funcall.scm 152 */
				 {	/* Cfa/funcall.scm 153 */
				    global_bglt duplicated2045_2163;
				    duplicated2045_2163 =
				       (global_bglt) (v_8);
				    {	/* Cfa/funcall.scm 153 */
				       global_bglt new2046_2164;
				       {	/* Cfa/funcall.scm 153 */
					  obj_t arg2086_2165;
					  obj_t arg2087_2166;
					  type_bglt arg2088_2167;
					  value_bglt arg2090_2168;
					  obj_t arg2091_2169;
					  obj_t arg2092_2170;
					  obj_t arg2093_2171;
					  long arg2094_2172;
					  obj_t arg2095_2173;
					  obj_t arg2096_2174;
					  bool_t arg2098_2175;
					  bool_t arg2099_2176;
					  bool_t arg2100_2177;
					  obj_t arg2101_2178;
					  obj_t arg2103_2179;
					  arg2086_2165 =
					     (((global_bglt) CREF(duplicated2045_2163))->id);
					  arg2087_2166 =
					     (((global_bglt) CREF(duplicated2045_2163))->name);
					  arg2088_2167 =
					     (((global_bglt) CREF(duplicated2045_2163))->type);
					  arg2090_2168 =
					     (((global_bglt) CREF(duplicated2045_2163))->value);
					  arg2091_2169 =
					     (((global_bglt) CREF(duplicated2045_2163))->access);
					  arg2092_2170 =
					     (((global_bglt) CREF(duplicated2045_2163))->fast_alpha_7);
					  arg2093_2171 =
					     (((global_bglt) CREF(duplicated2045_2163))->removable);
					  arg2094_2172 =
					     (((global_bglt) CREF(duplicated2045_2163))->occurrence);
					  arg2095_2173 =
					     (((global_bglt) CREF(duplicated2045_2163))->module);
					  arg2096_2174 =
					     (((global_bglt) CREF(duplicated2045_2163))->import);
					  arg2098_2175 =
					     (((global_bglt) CREF(duplicated2045_2163))->evaluable__248);
					  arg2099_2176 =
					     (((global_bglt) CREF(duplicated2045_2163))->library__255);
					  arg2100_2177 =
					     (((global_bglt) CREF(duplicated2045_2163))->user__32);
					  arg2101_2178 =
					     (((global_bglt) CREF(duplicated2045_2163))->pragma);
					  arg2103_2179 =
					     (((global_bglt) CREF(duplicated2045_2163))->src);
					  {	/* Cfa/funcall.scm 153 */
					     global_bglt res2397_3125;
					     {	/* ./Ast/var.scm 783 */
						global_bglt new1063_3106;
						new1063_3106 =
						   ((global_bglt) BREF(GC_MALLOC(sizeof(struct global))));
						{	/* ./Ast/var.scm 783 */
						   long arg2349_3107;
						   arg2349_3107 =
						      class_num_218___object(global_ast_var);
						   {	/* ./Ast/var.scm 783 */
						      obj_t obj_3123;
						      obj_3123 =
							 (obj_t) (new1063_3106);
						      (((obj_t) CREF(obj_3123))->header = MAKE_HEADER(arg2349_3107, 0), BUNSPEC);
						   }
						}
						{	/* ./Ast/var.scm 783 */
						   object_bglt aux_3711;
						   aux_3711 =
						      (object_bglt) (new1063_3106);
						   OBJECT_WIDENING_SET(aux_3711, BFALSE);
						}
						((((global_bglt) CREF(new1063_3106))->id) = ((obj_t) arg2086_2165), BUNSPEC);
						((((global_bglt) CREF(new1063_3106))->name) = ((obj_t) arg2087_2166), BUNSPEC);
						((((global_bglt) CREF(new1063_3106))->type) = ((type_bglt) arg2088_2167), BUNSPEC);
						((((global_bglt) CREF(new1063_3106))->value) = ((value_bglt) arg2090_2168), BUNSPEC);
						((((global_bglt) CREF(new1063_3106))->access) = ((obj_t) arg2091_2169), BUNSPEC);
						((((global_bglt) CREF(new1063_3106))->fast_alpha_7) = ((obj_t) arg2092_2170), BUNSPEC);
						((((global_bglt) CREF(new1063_3106))->removable) = ((obj_t) arg2093_2171), BUNSPEC);
						((((global_bglt) CREF(new1063_3106))->occurrence) = ((long) arg2094_2172), BUNSPEC);
						((((global_bglt) CREF(new1063_3106))->module) = ((obj_t) arg2095_2173), BUNSPEC);
						((((global_bglt) CREF(new1063_3106))->import) = ((obj_t) arg2096_2174), BUNSPEC);
						((((global_bglt) CREF(new1063_3106))->evaluable__248) = ((bool_t) arg2098_2175), BUNSPEC);
						((((global_bglt) CREF(new1063_3106))->library__255) = ((bool_t) arg2099_2176), BUNSPEC);
						((((global_bglt) CREF(new1063_3106))->user__32) = ((bool_t) arg2100_2177), BUNSPEC);
						((((global_bglt) CREF(new1063_3106))->pragma) = ((obj_t) arg2101_2178), BUNSPEC);
						((((global_bglt) CREF(new1063_3106))->src) = ((obj_t) arg2103_2179), BUNSPEC);
						res2397_3125 = new1063_3106;
					     }
					     new2046_2164 = res2397_3125;
					  }
				       }
				       {	/* Cfa/funcall.scm 153 */

					  arg2072_2148 =
					     (obj_t) (new2046_2164);
				       }
				    }
				 }
			      }
			    else
			      {		/* Cfa/funcall.scm 152 */
				 arg2072_2148 =
				    (obj_t) (v_8);
			      }
			 }
		    }
		    arg2069_2145 =
		       shape_tools_shape(arg2072_2148);
		 }
		 {	/* Cfa/funcall.scm 158 */
		    char *arg2104_2180;
		    obj_t arg2105_2181;
		    arg2104_2180 =
		       integer__string_135___r4_numbers_6_5_fixnum(
		       (arity_9 - ((long) 1)), BNIL);
		    {	/* Cfa/funcall.scm 157 */
		       obj_t arg2109_2185;
		       {	/* Cfa/funcall.scm 157 */
			  obj_t aux_3734;
			  {	/* Cfa/funcall.scm 157 */
			     char *aux_3735;
			     aux_3735 =
				integer__string_135___r4_numbers_6_5_fixnum(len_prov_87_2143, BNIL);
			     aux_3734 =
				string_to_bstring(aux_3735);
			  }
			  arg2109_2185 =
			     string_append(aux_3734, string2401_cfa_funcall);
		       }
		       arg2105_2181 =
			  string_append(string2402_cfa_funcall, arg2109_2185);
		    }
		    {	/* Cfa/funcall.scm 157 */
		       obj_t aux_3740;
		       aux_3740 =
			  string_to_bstring(arg2104_2180);
		       arg2071_2147 =
			  string_append(aux_3740, arg2105_2181);
		    }
		 }
		 user_warning_location_190_tools_error(arg2068_2144, arg2069_2145, string2403_cfa_funcall, arg2071_2147);
	      }
	   }
      }
      return
	 make_empty_approx_131_cfa_approx();
   }
}



/* method-init */
obj_t 
method_init_76_cfa_funcall()
{
   AN_OBJECT;
   {	/* Cfa/funcall.scm 14 */
      {		/* Cfa/funcall.scm 14 */
	 obj_t cfa__funcall_cinfo2048_194_3523;
	 cfa__funcall_cinfo2048_194_3523 = proc2404_cfa_funcall;
	 return
	    add_method__1___object(cfa__env_153_cfa_cfa, funcall_cinfo_75_cfa_info, cfa__funcall_cinfo2048_194_3523);
      }
   }
}



/* cfa!-funcall/cinfo2048 */
obj_t 
cfa__funcall_cinfo2048_194_cfa_funcall(obj_t env_3524, obj_t node_3525)
{
   AN_OBJECT;
   {	/* Cfa/funcall.scm 41 */
      {
	 funcall_cinfo_75_bglt node_2945;
	 {	/* Cfa/funcall.scm 41 */
	    approx_bglt aux_3746;
	    node_2945 =
	       (funcall_cinfo_75_bglt) (node_3525);
	    {	/* Cfa/funcall.scm 44 */
	       approx_bglt fun_approx_73_2949;
	       {	/* Cfa/funcall.scm 44 */
		  node_bglt aux_3747;
		  {	/* Cfa/funcall.scm 44 */
		     funcall_bglt obj_3475;
		     obj_3475 =
			(funcall_bglt) (node_2945);
		     aux_3747 =
			(((funcall_bglt) CREF(obj_3475))->fun);
		  }
		  fun_approx_73_2949 =
		     cfa__102_cfa_cfa(aux_3747);
	       }
	       {	/* Cfa/funcall.scm 44 */
		  obj_t args_approx_137_2950;
		  {	/* Cfa/funcall.scm 45 */
		     obj_t l2032_2988;
		     {	/* ./Ieee/pair-list.scm 5707 */
			obj_t aux_3751;
			{	/* Cfa/funcall.scm 45 */
			   funcall_bglt obj_3476;
			   obj_3476 =
			      (funcall_bglt) (node_2945);
			   aux_3751 =
			      (((funcall_bglt) CREF(obj_3476))->args);
			}
			l2032_2988 =
			   CDR(aux_3751);
		     }
		     if (
			NULLP(l2032_2988))
		       {	/* Cfa/funcall.scm 45 */
			  args_approx_137_2950 = BNIL;
		       }
		     else
		       {	/* Cfa/funcall.scm 45 */
			  obj_t head2034_2990;
			  {	/* Cfa/funcall.scm 45 */
			     approx_bglt arg2390_3001;
			     {	/* Cfa/funcall.scm 45 */
				node_bglt aux_3757;
				{	/* Cfa/funcall.scm 45 */
				   obj_t aux_3758;
				   aux_3758 =
				      CAR(l2032_2988);
				   aux_3757 =
				      (node_bglt) (aux_3758);
				}
				arg2390_3001 =
				   cfa__102_cfa_cfa(aux_3757);
			     }
			     {	/* ./Ieee/pair-list.scm 5689 */
				obj_t aux_3762;
				aux_3762 =
				   (obj_t) (arg2390_3001);
				head2034_2990 =
				   MAKE_PAIR(aux_3762, BNIL);
			     }
			  }
			  {
			     obj_t l2032_2991;
			     obj_t tail2035_2992;
			     l2032_2991 =
				CDR(l2032_2988);
			     tail2035_2992 = head2034_2990;
			   lname2033_2993:
			     if (
				NULLP(l2032_2991))
			       {	/* Cfa/funcall.scm 45 */
				  args_approx_137_2950 = head2034_2990;
			       }
			     else
			       {	/* Cfa/funcall.scm 45 */
				  obj_t newtail2036_2996;
				  {	/* Cfa/funcall.scm 45 */
				     approx_bglt arg2387_2998;
				     {	/* Cfa/funcall.scm 45 */
					node_bglt aux_3767;
					{	/* Cfa/funcall.scm 45 */
					   obj_t aux_3768;
					   aux_3768 =
					      CAR(l2032_2991);
					   aux_3767 =
					      (node_bglt) (aux_3768);
					}
					arg2387_2998 =
					   cfa__102_cfa_cfa(aux_3767);
				     }
				     {	/* ./Ieee/pair-list.scm 5689 */
					obj_t aux_3772;
					aux_3772 =
					   (obj_t) (arg2387_2998);
					newtail2036_2996 =
					   MAKE_PAIR(aux_3772, BNIL);
				     }
				  }
				  SET_CDR(tail2035_2992, newtail2036_2996);
				  {
				     obj_t tail2035_3778;
				     obj_t l2032_3776;
				     l2032_3776 =
					CDR(l2032_2991);
				     tail2035_3778 = newtail2036_2996;
				     tail2035_2992 = tail2035_3778;
				     l2032_2991 = l2032_3776;
				     goto lname2033_2993;
				  }
			       }
			  }
		       }
		  }
		  {	/* Cfa/funcall.scm 45 */

		     {	/* Cfa/funcall.scm 50 */
			type_bglt fun_type_165_2951;
			fun_type_165_2951 =
			   (((approx_bglt) CREF(fun_approx_73_2949))->type);
			{	/* Cfa/funcall.scm 51 */
			   bool_t test2356_2952;
			   {	/* Cfa/funcall.scm 51 */
			      bool_t test2357_2953;
			      {		/* Cfa/funcall.scm 51 */
				 obj_t obj2_3492;
				 obj2_3492 = ____74_type_cache;
				 {	/* ./Ieee/equiv.scm 5508 */
				    obj_t aux_3781;
				    aux_3781 =
				       (obj_t) (fun_type_165_2951);
				    test2357_2953 =
				       (aux_3781 == obj2_3492);
				 }
			      }
			      if (test2357_2953)
				{	/* Cfa/funcall.scm 51 */
				   test2356_2952 = ((bool_t) 0);
				}
			      else
				{	/* Cfa/funcall.scm 52 */
				   bool_t test2358_2954;
				   {	/* Cfa/funcall.scm 52 */
				      obj_t obj2_3494;
				      obj2_3494 = _obj__252_type_cache;
				      {		/* ./Ieee/equiv.scm 5508 */
					 obj_t aux_3785;
					 aux_3785 =
					    (obj_t) (fun_type_165_2951);
					 test2358_2954 =
					    (aux_3785 == obj2_3494);
				      }
				   }
				   if (test2358_2954)
				     {	/* Cfa/funcall.scm 52 */
					test2356_2952 = ((bool_t) 0);
				     }
				   else
				     {	/* Cfa/funcall.scm 53 */
					bool_t test2359_2955;
					{	/* Cfa/funcall.scm 53 */
					   obj_t obj2_3496;
					   obj2_3496 = _procedure__226_type_cache;
					   {	/* ./Ieee/equiv.scm 5508 */
					      obj_t aux_3789;
					      aux_3789 =
						 (obj_t) (fun_type_165_2951);
					      test2359_2955 =
						 (aux_3789 == obj2_3496);
					   }
					}
					if (test2359_2955)
					  {	/* Cfa/funcall.scm 53 */
					     test2356_2952 = ((bool_t) 0);
					  }
					else
					  {	/* Cfa/funcall.scm 53 */
					     test2356_2952 = ((bool_t) 1);
					  }
				     }
				}
			   }
			   if (test2356_2952)
			     {	/* Cfa/funcall.scm 51 */
				funcall_type_error_218_cfa_funcall(node_2945, fun_type_165_2951);
			     }
			   else
			     {	/* Cfa/funcall.scm 51 */
				BUNSPEC;
			     }
			}
		     }
		     {	/* Cfa/funcall.scm 56 */
			bool_t test2360_2956;
			{	/* Cfa/funcall.scm 56 */
			   bool_t test2362_2958;
			   {	/* Cfa/funcall.scm 56 */
			      obj_t obj2_3499;
			      obj2_3499 = _procedure__226_type_cache;
			      {		/* ./Ieee/equiv.scm 5508 */
				 obj_t aux_3795;
				 {	/* Cfa/funcall.scm 56 */
				    type_bglt aux_3796;
				    aux_3796 =
				       (((approx_bglt) CREF(fun_approx_73_2949))->type);
				    aux_3795 =
				       (obj_t) (aux_3796);
				 }
				 test2362_2958 =
				    (aux_3795 == obj2_3499);
			      }
			   }
			   if (test2362_2958)
			     {	/* Cfa/funcall.scm 56 */
				test2360_2956 =
				   (((approx_bglt) CREF(fun_approx_73_2949))->top__138);
			     }
			   else
			     {	/* Cfa/funcall.scm 56 */
				test2360_2956 = ((bool_t) 1);
			     }
			}
			if (test2360_2956)
			  {	/* Cfa/funcall.scm 58 */
			     approx_bglt aux_3803;
			     {
				obj_t aux_3804;
				{	/* ./Cfa/cinfo.scm 1119 */
				   object_bglt aux_3805;
				   aux_3805 =
				      (object_bglt) (node_2945);
				   aux_3804 =
				      OBJECT_WIDENING(aux_3805);
				}
				aux_3803 =
				   (((funcall_cinfo_75_bglt) CREF(aux_3804))->approx);
			     }
			     approx_set_type__239_cfa_approx(aux_3803,
				(type_bglt) (_obj__252_type_cache));
			  }
			else
			  {	/* Cfa/funcall.scm 56 */
			     BUNSPEC;
			  }
		     }
		     {	/* Cfa/funcall.scm 60 */
			bool_t test2364_2960;
			if (
			   (((approx_bglt) CREF(fun_approx_73_2949))->top__138))
			  {	/* Cfa/funcall.scm 60 */
			     test2364_2960 = ((bool_t) 1);
			  }
			else
			  {	/* Cfa/funcall.scm 61 */
			     bool_t test2381_2986;
			     {	/* Cfa/funcall.scm 61 */
				obj_t obj2_3505;
				obj2_3505 = _procedure__226_type_cache;
				{	/* ./Ieee/equiv.scm 5508 */
				   obj_t aux_3813;
				   {	/* Cfa/funcall.scm 61 */
				      type_bglt aux_3814;
				      aux_3814 =
					 (((approx_bglt) CREF(fun_approx_73_2949))->type);
				      aux_3813 =
					 (obj_t) (aux_3814);
				   }
				   test2381_2986 =
				      (aux_3813 == obj2_3505);
				}
			     }
			     if (test2381_2986)
			       {	/* Cfa/funcall.scm 61 */
				  test2364_2960 = ((bool_t) 0);
			       }
			     else
			       {	/* Cfa/funcall.scm 61 */
				  test2364_2960 = ((bool_t) 1);
			       }
			  }
			if (test2364_2960)
			  {	/* Cfa/funcall.scm 60 */
			     {
				obj_t l2037_2961;
				l2037_2961 = args_approx_137_2950;
			      lname2038_2962:
				if (
				   PAIRP(l2037_2961))
				  {	/* Cfa/funcall.scm 63 */
				     {	/* Cfa/funcall.scm 63 */
					approx_bglt aux_3822;
					{	/* Cfa/funcall.scm 63 */
					   obj_t aux_3823;
					   aux_3823 =
					      CAR(l2037_2961);
					   aux_3822 =
					      (approx_bglt) (aux_3823);
					}
					loose__226_cfa_loose(aux_3822,
					   CNST_TABLE_REF(((long) 0)));
				     }
				     {
					obj_t l2037_3828;
					l2037_3828 =
					   CDR(l2037_2961);
					l2037_2961 = l2037_3828;
					goto lname2038_2962;
				     }
				  }
				else
				  {	/* Cfa/funcall.scm 63 */
				     ((bool_t) 1);
				  }
			     }
			     {	/* Cfa/funcall.scm 66 */
				obj_t _anonymous_2368__254_3522;
				_anonymous_2368__254_3522 =
				   make_fx_procedure(_anonymous_2368__254_cfa_funcall, ((long) 1), ((long) 3));
				{	/* Cfa/funcall.scm 66 */
				   obj_t aux_3831;
				   aux_3831 =
				      (obj_t) (node_2945);
				   PROCEDURE_SET(_anonymous_2368__254_3522, ((long) 0), aux_3831);
				}
				PROCEDURE_SET(_anonymous_2368__254_3522, ((long) 1), args_approx_137_2950);
				{	/* Cfa/funcall.scm 66 */
				   obj_t aux_3835;
				   aux_3835 =
				      (obj_t) (node_2945);
				   PROCEDURE_SET(_anonymous_2368__254_3522, ((long) 2), aux_3835);
				}
				for_each_approx_alloc_83_cfa_approx(_anonymous_2368__254_3522, fun_approx_73_2949);
			     }
			     {	/* Cfa/funcall.scm 75 */
				approx_bglt aux_3839;
				{
				   obj_t aux_3840;
				   {	/* ./Cfa/cinfo.scm 1119 */
				      object_bglt aux_3841;
				      aux_3841 =
					 (object_bglt) (node_2945);
				      aux_3840 =
					 OBJECT_WIDENING(aux_3841);
				   }
				   aux_3839 =
				      (((funcall_cinfo_75_bglt) CREF(aux_3840))->approx);
				}
				approx_set_top__187_cfa_approx(aux_3839);
			     }
			  }
			else
			  {	/* Cfa/funcall.scm 78 */
			     obj_t _anonymous_2375__104_3521;
			     _anonymous_2375__104_3521 =
				make_fx_procedure(_anonymous_2375__104_cfa_funcall, ((long) 1), ((long) 3));
			     {	/* Cfa/funcall.scm 78 */
				obj_t aux_3847;
				aux_3847 =
				   (obj_t) (node_2945);
				PROCEDURE_SET(_anonymous_2375__104_3521, ((long) 0), aux_3847);
			     }
			     PROCEDURE_SET(_anonymous_2375__104_3521, ((long) 1), args_approx_137_2950);
			     {	/* Cfa/funcall.scm 78 */
				obj_t aux_3851;
				aux_3851 =
				   (obj_t) (node_2945);
				PROCEDURE_SET(_anonymous_2375__104_3521, ((long) 2), aux_3851);
			     }
			     for_each_approx_alloc_83_cfa_approx(_anonymous_2375__104_3521, fun_approx_73_2949);
			  }
		     }
		     {
			obj_t aux_3855;
			{	/* ./Cfa/cinfo.scm 1119 */
			   object_bglt aux_3856;
			   aux_3856 =
			      (object_bglt) (node_2945);
			   aux_3855 =
			      OBJECT_WIDENING(aux_3856);
			}
			aux_3746 =
			   (((funcall_cinfo_75_bglt) CREF(aux_3855))->approx);
		     }
		  }
	       }
	    }
	    return
	       (obj_t) (aux_3746);
	 }
      }
   }
}



/* <anonymous:2368> */
obj_t 
_anonymous_2368__254_cfa_funcall(obj_t env_3526, obj_t alloc_3530)
{
   AN_OBJECT;
   {	/* Cfa/funcall.scm 65 */
      {		/* Cfa/funcall.scm 66 */
	 obj_t instance2031_3527;
	 obj_t args_approx_137_3528;
	 obj_t node_3529;
	 instance2031_3527 =
	    PROCEDURE_REF(env_3526, ((long) 0));
	 args_approx_137_3528 =
	    PROCEDURE_REF(env_3526, ((long) 1));
	 node_3529 =
	    PROCEDURE_REF(env_3526, ((long) 2));
	 {
	    obj_t alloc_2967;
	    {	/* Cfa/funcall.scm 66 */
	       approx_bglt aux_3865;
	       alloc_2967 = alloc_3530;
	       {	/* Cfa/funcall.scm 66 */
		  bool_t test2369_2969;
		  test2369_2969 =
		     is_a__118___object(alloc_2967, make_procedure_app_48_cfa_info2);
		  if (test2369_2969)
		    {	/* Cfa/funcall.scm 68 */
		       approx_bglt arg2370_2971;
		       approx_bglt arg2371_2972;
		       {	/* Cfa/funcall.scm 68 */
			  funcall_cinfo_75_bglt obj_3511;
			  obj_3511 =
			     (funcall_cinfo_75_bglt) (instance2031_3527);
			  {
			     obj_t aux_3869;
			     {	/* ./Cfa/cinfo.scm 1119 */
				object_bglt aux_3870;
				aux_3870 =
				   (object_bglt) (obj_3511);
				aux_3869 =
				   OBJECT_WIDENING(aux_3870);
			     }
			     arg2370_2971 =
				(((funcall_cinfo_75_bglt) CREF(aux_3869))->approx);
			  }
		       }
		       {	/* Cfa/funcall.scm 70 */
			  obj_t arg2372_2973;
			  {	/* ./Ieee/pair-list.scm 5689 */
			     obj_t aux_3874;
			     {	/* Cfa/funcall.scm 70 */
				approx_bglt aux_3875;
				{	/* Cfa/funcall.scm 67 */
				   make_procedure_app_48_bglt obj_3510;
				   obj_3510 =
				      (make_procedure_app_48_bglt) (alloc_2967);
				   {
				      obj_t aux_3877;
				      {		/* ./Cfa/cinfo2.scm 1171 */
					 object_bglt aux_3878;
					 aux_3878 =
					    (object_bglt) (obj_3510);
					 aux_3877 =
					    OBJECT_WIDENING(aux_3878);
				      }
				      aux_3875 =
					 (((make_procedure_app_48_bglt) CREF(aux_3877))->approx);
				   }
				}
				aux_3874 =
				   (obj_t) (aux_3875);
			     }
			     arg2372_2973 =
				MAKE_PAIR(aux_3874, args_approx_137_3528);
			  }
			  arg2371_2972 =
			     funcall__128_cfa_funcall(
			     (make_procedure_app_48_bglt) (alloc_2967), arg2372_2973, node_3529);
		       }
		       aux_3865 =
			  union_approx__241_cfa_approx(arg2370_2971, arg2371_2972);
		    }
		  else
		    {	/* Cfa/funcall.scm 66 */
		       aux_3865 =
			  make_empty_approx_131_cfa_approx()
			  ;
		    }
	       }
	       return
		  (obj_t) (aux_3865);
	    }
	 }
      }
   }
}



/* <anonymous:2375> */
obj_t 
_anonymous_2375__104_cfa_funcall(obj_t env_3531, obj_t alloc_3535)
{
   AN_OBJECT;
   {	/* Cfa/funcall.scm 77 */
      {		/* Cfa/funcall.scm 78 */
	 obj_t instance2031_3532;
	 obj_t args_approx_137_3533;
	 obj_t node_3534;
	 instance2031_3532 =
	    PROCEDURE_REF(env_3531, ((long) 0));
	 args_approx_137_3533 =
	    PROCEDURE_REF(env_3531, ((long) 1));
	 node_3534 =
	    PROCEDURE_REF(env_3531, ((long) 2));
	 {
	    obj_t alloc_2977;
	    {	/* Cfa/funcall.scm 78 */
	       approx_bglt aux_3892;
	       alloc_2977 = alloc_3535;
	       {	/* Cfa/funcall.scm 78 */
		  bool_t test2376_2979;
		  test2376_2979 =
		     is_a__118___object(alloc_2977, make_procedure_app_48_cfa_info2);
		  if (test2376_2979)
		    {	/* Cfa/funcall.scm 80 */
		       approx_bglt arg2377_2981;
		       approx_bglt arg2378_2982;
		       {	/* Cfa/funcall.scm 80 */
			  funcall_cinfo_75_bglt obj_3517;
			  obj_3517 =
			     (funcall_cinfo_75_bglt) (instance2031_3532);
			  {
			     obj_t aux_3896;
			     {	/* ./Cfa/cinfo.scm 1119 */
				object_bglt aux_3897;
				aux_3897 =
				   (object_bglt) (obj_3517);
				aux_3896 =
				   OBJECT_WIDENING(aux_3897);
			     }
			     arg2377_2981 =
				(((funcall_cinfo_75_bglt) CREF(aux_3896))->approx);
			  }
		       }
		       {	/* Cfa/funcall.scm 82 */
			  obj_t arg2379_2983;
			  {	/* ./Ieee/pair-list.scm 5689 */
			     obj_t aux_3901;
			     {	/* Cfa/funcall.scm 82 */
				approx_bglt aux_3902;
				{	/* Cfa/funcall.scm 79 */
				   make_procedure_app_48_bglt obj_3516;
				   obj_3516 =
				      (make_procedure_app_48_bglt) (alloc_2977);
				   {
				      obj_t aux_3904;
				      {		/* ./Cfa/cinfo2.scm 1171 */
					 object_bglt aux_3905;
					 aux_3905 =
					    (object_bglt) (obj_3516);
					 aux_3904 =
					    OBJECT_WIDENING(aux_3905);
				      }
				      aux_3902 =
					 (((make_procedure_app_48_bglt) CREF(aux_3904))->approx);
				   }
				}
				aux_3901 =
				   (obj_t) (aux_3902);
			     }
			     arg2379_2983 =
				MAKE_PAIR(aux_3901, args_approx_137_3533);
			  }
			  arg2378_2982 =
			     funcall__128_cfa_funcall(
			     (make_procedure_app_48_bglt) (alloc_2977), arg2379_2983, node_3534);
		       }
		       aux_3892 =
			  union_approx__241_cfa_approx(arg2377_2981, arg2378_2982);
		    }
		  else
		    {	/* Cfa/funcall.scm 78 */
		       aux_3892 =
			  make_empty_approx_131_cfa_approx()
			  ;
		    }
	       }
	       return
		  (obj_t) (aux_3892);
	    }
	 }
      }
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_cfa_funcall()
{
   AN_OBJECT;
   {	/* Cfa/funcall.scm 14 */
      module_initialization_70_tools_trace(((long) 0), "CFA_FUNCALL");
      module_initialization_70_tools_shape(((long) 0), "CFA_FUNCALL");
      module_initialization_70_tools_args(((long) 0), "CFA_FUNCALL");
      module_initialization_70_tools_error(((long) 0), "CFA_FUNCALL");
      module_initialization_70_type_type(((long) 0), "CFA_FUNCALL");
      module_initialization_70_type_cache(((long) 0), "CFA_FUNCALL");
      module_initialization_70_ast_var(((long) 0), "CFA_FUNCALL");
      module_initialization_70_ast_node(((long) 0), "CFA_FUNCALL");
      module_initialization_70_cfa_info(((long) 0), "CFA_FUNCALL");
      module_initialization_70_cfa_info2(((long) 0), "CFA_FUNCALL");
      module_initialization_70_cfa_cfa(((long) 0), "CFA_FUNCALL");
      module_initialization_70_cfa_loose(((long) 0), "CFA_FUNCALL");
      module_initialization_70_cfa_approx(((long) 0), "CFA_FUNCALL");
      return
	 module_initialization_70_cfa_app(((long) 0), "CFA_FUNCALL");
   }
}
