/*===========================================================================*/
/*   (Cfa/iterate.scm)                                                       */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;

typedef struct approx
  {
     header_t header;
     obj_t widening;
     struct type *type;
     bool_t type_locked__184;
     obj_t allocs;
     bool_t top__138;
     long lost_stamp_114;
  }
      *approx_bglt;

typedef struct cfun_cinfo_200
  {
     struct approx *approx;
  }
              *cfun_cinfo_200_bglt;

typedef struct extern_sfun_cinfo_6
  {
     struct approx *approx;
  }
                   *extern_sfun_cinfo_6_bglt;

typedef struct intern_sfun_cinfo_192
  {
     struct approx *approx;
     long stamp;
  }
                     *intern_sfun_cinfo_192_bglt;

typedef struct scnst_cinfo_0
  {
     struct approx *approx;
  }
             *scnst_cinfo_0_bglt;

typedef struct pre_clo_env_191
  {
     char dummy;
  }
               *pre_clo_env_191_bglt;

typedef struct svar_cinfo_166
  {
     struct approx *approx;
     bool_t clo_env__87;
  }
              *svar_cinfo_166_bglt;

typedef struct cvar_cinfo_53
  {
     struct approx *approx;
  }
             *cvar_cinfo_53_bglt;

typedef struct sexit_cinfo_49
  {
     struct approx *approx;
  }
              *sexit_cinfo_49_bglt;

typedef struct reshaped_local_224
  {
     obj_t binding_value_3;
  }
                  *reshaped_local_224_bglt;

typedef struct reshaped_global_160
  {
     char dummy;
  }
                   *reshaped_global_160_bglt;

typedef struct atom_cinfo_155
  {
     struct approx *approx;
  }
              *atom_cinfo_155_bglt;

typedef struct kwote_node_102
  {
     struct node *node;
  }
              *kwote_node_102_bglt;

typedef struct kwote_cinfo_48
  {
     struct approx *approx;
  }
              *kwote_cinfo_48_bglt;

typedef struct app_ly_cinfo_234
  {
     struct approx *approx;
  }
                *app_ly_cinfo_234_bglt;

typedef struct funcall_cinfo_75
  {
     struct approx *approx;
     struct approx *va_approx_63;
     bool_t arity_error_noticed__118;
     bool_t type_error_noticed__36;
  }
                *funcall_cinfo_75_bglt;

typedef struct pragma_cinfo_220
  {
     struct approx *approx;
  }
                *pragma_cinfo_220_bglt;

typedef struct setq_cinfo_191
  {
     struct approx *approx;
  }
              *setq_cinfo_191_bglt;

typedef struct conditional_cinfo_212
  {
     struct approx *approx;
  }
                     *conditional_cinfo_212_bglt;

typedef struct fail_cinfo_75
  {
     struct approx *approx;
  }
             *fail_cinfo_75_bglt;

typedef struct select_cinfo_150
  {
     struct approx *approx;
  }
                *select_cinfo_150_bglt;

typedef struct set_ex_it_cinfo_168
  {
     struct approx *approx;
  }
                   *set_ex_it_cinfo_168_bglt;

typedef struct jump_ex_it_cinfo_139
  {
     struct approx *approx;
  }
                    *jump_ex_it_cinfo_139_bglt;

typedef struct pre_make_box_186
  {
     char dummy;
  }
                *pre_make_box_186_bglt;

typedef struct make_box_cinfo_127
  {
     struct approx *approx;
  }
                  *make_box_cinfo_127_bglt;

typedef struct make_box_o_cinfo_96
  {
     struct approx *approx;
     struct approx *value_approx_19;
  }
                   *make_box_o_cinfo_96_bglt;

typedef struct box_set__cinfo_94
  {
     struct approx *approx;
  }
                 *box_set__cinfo_94_bglt;

typedef struct box_ref_cinfo_214
  {
     struct approx *approx;
  }
                 *box_ref_cinfo_214_bglt;

typedef struct box_set__o_cinfo_6
  {
     struct approx *approx;
  }
                  *box_set__o_cinfo_6_bglt;

typedef struct box_ref_o_cinfo_98
  {
     struct approx *approx;
  }
                  *box_ref_o_cinfo_98_bglt;

typedef struct pre_make_procedure_app_60
  {
     struct variable *owner;
  }
                         *pre_make_procedure_app_60_bglt;

typedef struct pre_procedure_ref_app_85
  {
     char dummy;
  }
                        *pre_procedure_ref_app_85_bglt;

typedef struct pre_procedure_set__app_208
  {
     char dummy;
  }
                          *pre_procedure_set__app_208_bglt;

typedef struct make_procedure_app_48
  {
     struct approx *approx;
     long values_approx_len_106;
     struct approx **values_approx_79;
     long lost_stamp_114;
     bool_t x_t__142;
     bool_t x;
     bool_t t;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
  }
                     *make_procedure_app_48_bglt;

typedef struct procedure_ref_app_49
  {
     struct approx *approx;
  }
                    *procedure_ref_app_49_bglt;

typedef struct procedure_set__app_32
  {
     struct approx *approx;
  }
                     *procedure_set__app_32_bglt;

typedef struct pre_make_vector_app_251
  {
     struct variable *owner;
  }
                       *pre_make_vector_app_251_bglt;

typedef struct pre_create_vector_app_162
  {
     struct variable *owner;
  }
                         *pre_create_vector_app_162_bglt;

typedef struct pre_vector_ref_app_208
  {
     char dummy;
  }
                      *pre_vector_ref_app_208_bglt;

typedef struct pre_vector_set__app_211
  {
     char dummy;
  }
                       *pre_vector_set__app_211_bglt;

typedef struct make_vector_app_205
  {
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
     bool_t seen__39;
  }
                   *make_vector_app_205_bglt;

typedef struct create_vector_app_150
  {
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
     bool_t seen__39;
  }
                     *create_vector_app_150_bglt;

typedef struct vector_ref_app_195
  {
     struct approx *approx;
  }
                  *vector_ref_app_195_bglt;

typedef struct vector_set__app_21
  {
     struct approx *approx;
  }
                  *vector_set__app_21_bglt;

typedef struct pre_make_struct_app_218
  {
     struct variable *owner;
  }
                       *pre_make_struct_app_218_bglt;

typedef struct pre_struct_ref_app_207
  {
     char dummy;
  }
                      *pre_struct_ref_app_207_bglt;

typedef struct pre_struct_set__app_116
  {
     char dummy;
  }
                       *pre_struct_set__app_116_bglt;

typedef struct make_struct_app_214
  {
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
  }
                   *make_struct_app_214_bglt;

typedef struct struct_ref_app_73
  {
     struct approx *approx;
  }
                 *struct_ref_app_73_bglt;

typedef struct struct_set__app_162
  {
     struct approx *approx;
  }
                   *struct_set__app_162_bglt;


static obj_t method_init_76_cfa_iterate();
extern approx_bglt cfa_intern_sfun__162_cfa_iterate(intern_sfun_cinfo_192_bglt, obj_t);
extern obj_t cfa_export_var__93_cfa_iterate(value_bglt, obj_t);
extern long add_inlined_method__244___object(obj_t, obj_t, long);
static obj_t cfa_export_var__default2040_112_cfa_iterate(value_bglt, obj_t);
static obj_t _cfa_export_var__160_cfa_iterate(obj_t, obj_t, obj_t);
extern obj_t intern_sfun_cinfo_192_cfa_info;
extern obj_t module_initialization_70_cfa_iterate(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_ast_unit(long, char *);
extern obj_t module_initialization_70_cfa_cfa(long, char *);
extern obj_t module_initialization_70_cfa_info(long, char *);
extern obj_t module_initialization_70_cfa_info2(long, char *);
extern obj_t module_initialization_70_cfa_loose(long, char *);
extern obj_t module_initialization_70_cfa_approx(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern approx_bglt union_approx__241_cfa_approx(approx_bglt, approx_bglt);
extern obj_t stack_intern_sfun_loose__226_cfa_loose(approx_bglt, obj_t);
extern obj_t unit_initializers_25_ast_unit();
extern obj_t cfa_iterate__222_cfa_iterate(obj_t);
static obj_t imported_modules_init_94_cfa_iterate();
static obj_t _cfa_continue___179_cfa_iterate = BUNSPEC;
extern obj_t add_generic__110___object(obj_t, obj_t);
extern obj_t approx_set_top__187_cfa_approx(approx_bglt);
static obj_t _continue_cfa__96_cfa_iterate(obj_t);
extern obj_t append_2_18___r4_pairs_and_lists_6_3(obj_t, obj_t);
static obj_t library_modules_init_112_cfa_iterate();
extern approx_bglt cfa__102_cfa_cfa(node_bglt);
extern obj_t cfa_variable_value_approx_39_cfa_cfa(value_bglt);
static obj_t toplevel_init_63_cfa_iterate();
extern obj_t open_input_string(obj_t);
extern obj_t sfun_ast_var;
static obj_t _cfa_iterate__24_cfa_iterate(obj_t, obj_t);
static obj_t _cfa_iterate_to_fixpoint__26_cfa_iterate(obj_t, obj_t);
static obj_t _cfa_export_var__default2040_81_cfa_iterate(obj_t, obj_t, obj_t);
extern obj_t _classes__134___object;
extern obj_t read___reader(obj_t);
static obj_t _cfa_intern_sfun__144_cfa_iterate(obj_t, obj_t, obj_t);
extern obj_t cfa_iterate_to_fixpoint__166_cfa_iterate(obj_t);
extern obj_t svar_cinfo_166_cfa_info;
obj_t _cfa_stamp__16_cfa_iterate = BUNSPEC;
static obj_t require_initialization_114_cfa_iterate = BUNSPEC;
extern approx_bglt loose__226_cfa_loose(approx_bglt, obj_t);
extern obj_t continue_cfa__104_cfa_iterate();
static obj_t cnst_init_137_cfa_iterate();
static obj_t __cnst[3];

DEFINE_EXPORT_GENERIC(cfa_export_var__env_209_cfa_iterate, _cfa_export_var__160_cfa_iterate2344, _cfa_export_var__160_cfa_iterate, 0L, 2);
DEFINE_EXPORT_PROCEDURE(cfa_iterate_to_fixpoint__env_242_cfa_iterate, _cfa_iterate_to_fixpoint__26_cfa_iterate2345, _cfa_iterate_to_fixpoint__26_cfa_iterate, 0L, 1);
DEFINE_EXPORT_PROCEDURE(continue_cfa__env_5_cfa_iterate, _continue_cfa__96_cfa_iterate2346, _continue_cfa__96_cfa_iterate, 0L, 0);
DEFINE_EXPORT_PROCEDURE(cfa_iterate__env_97_cfa_iterate, _cfa_iterate__24_cfa_iterate2347, _cfa_iterate__24_cfa_iterate, 0L, 1);
DEFINE_STATIC_PROCEDURE(cfa_export_var__default2040_env_202_cfa_iterate, _cfa_export_var__default2040_81_cfa_iterate2348, _cfa_export_var__default2040_81_cfa_iterate, 0L, 2);
DEFINE_STRING(string2339_cfa_iterate, string2339_cfa_iterate2349, "CFA-EXPORT-VAR!-DEFAULT2040 ALL EXPORT ", 39);
DEFINE_STRING(string2338_cfa_iterate, string2338_cfa_iterate2350, "No method for this object", 25);
DEFINE_EXPORT_PROCEDURE(cfa_intern_sfun__env_197_cfa_iterate, _cfa_intern_sfun__144_cfa_iterate2351, _cfa_intern_sfun__144_cfa_iterate, 0L, 2);



/* module-initialization */
obj_t 
module_initialization_70_cfa_iterate(long checksum_3376, char *from_3377)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_cfa_iterate))
	{
	   require_initialization_114_cfa_iterate =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_cfa_iterate();
	   cnst_init_137_cfa_iterate();
	   imported_modules_init_94_cfa_iterate();
	   method_init_76_cfa_iterate();
	   toplevel_init_63_cfa_iterate();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_cfa_iterate()
{
   AN_OBJECT;
   {	/* Cfa/iterate.scm 14 */
      module_initialization_70___object(((long) 0), "CFA_ITERATE");
      module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "CFA_ITERATE");
      module_initialization_70___reader(((long) 0), "CFA_ITERATE");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_cfa_iterate()
{
   AN_OBJECT;
   {	/* Cfa/iterate.scm 14 */
      {		/* Cfa/iterate.scm 14 */
	 obj_t cnst_port_138_3369;
	 cnst_port_138_3369 =
	    open_input_string(string2339_cfa_iterate);
	 {
	    long i_3370;
	    i_3370 = ((long) 2);
	  loop_3371:
	    {	/* Cfa/iterate.scm 14 */
	       bool_t test2340_3372;
	       test2340_3372 =
		  (i_3370 == ((long) -1));
	       if (test2340_3372)
		 {	/* Cfa/iterate.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Cfa/iterate.scm 14 */
		    {	/* Cfa/iterate.scm 14 */
		       obj_t arg2341_3373;
		       {	/* Cfa/iterate.scm 14 */
			  obj_t list2342_3374;
			  list2342_3374 =
			     MAKE_PAIR(cnst_port_138_3369, BNIL);
			  arg2341_3373 =
			     read___reader(list2342_3374);
		       }
		       CNST_TABLE_SET(i_3370, arg2341_3373);
		    }
		    {	/* Cfa/iterate.scm 14 */
		       int aux_3375;
		       {	/* Cfa/iterate.scm 14 */
			  long aux_3395;
			  aux_3395 =
			     (i_3370 - ((long) 1));
			  aux_3375 =
			     (int) (aux_3395);
		       }
		       {
			  long i_3398;
			  i_3398 =
			     (long) (aux_3375);
			  i_3370 = i_3398;
			  goto loop_3371;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_cfa_iterate()
{
   AN_OBJECT;
   {	/* Cfa/iterate.scm 14 */
      _cfa_continue___179_cfa_iterate = BUNSPEC;
      return (
	 _cfa_stamp__16_cfa_iterate =
	 BINT(((long) -1)), BUNSPEC);
   }
}



/* cfa-iterate-to-fixpoint! */
obj_t 
cfa_iterate_to_fixpoint__166_cfa_iterate(obj_t globals_1)
{
   AN_OBJECT;
   {	/* Cfa/iterate.scm 36 */
      _cfa_stamp__16_cfa_iterate =
	 BINT(((long) -1));
      {		/* Cfa/iterate.scm 41 */
	 obj_t glodefs_2113;
	 glodefs_2113 = BNIL;
	 {
	    obj_t l2031_2114;
	    l2031_2114 = globals_1;
	  lname2032_2115:
	    if (
	       PAIRP(l2031_2114))
	      {		/* Cfa/iterate.scm 42 */
		 {	/* Cfa/iterate.scm 43 */
		    obj_t g_2117;
		    g_2117 =
		       CAR(l2031_2114);
		    {	/* Cfa/iterate.scm 43 */
		       bool_t test_3405;
		       {	/* ./Ieee/equiv.scm 5508 */
			  obj_t aux_3409;
			  obj_t aux_3406;
			  aux_3409 =
			     CNST_TABLE_REF(((long) 0));
			  {	/* Cfa/iterate.scm 43 */
			     global_bglt obj_2937;
			     obj_2937 =
				(global_bglt) (g_2117);
			     aux_3406 =
				(((global_bglt) CREF(obj_2937))->import);
			  }
			  test_3405 =
			     (aux_3406 == aux_3409);
		       }
		       if (test_3405)
			 {	/* Cfa/iterate.scm 44 */
			    obj_t obj2_2941;
			    obj2_2941 = glodefs_2113;
			    glodefs_2113 =
			       MAKE_PAIR(g_2117, obj2_2941);
			 }
		       else
			 {	/* Cfa/iterate.scm 43 */
			    BUNSPEC;
			 }
		    }
		 }
		 {
		    obj_t l2031_3413;
		    l2031_3413 =
		       CDR(l2031_2114);
		    l2031_2114 = l2031_3413;
		    goto lname2032_2115;
		 }
	      }
	    else
	      {		/* Cfa/iterate.scm 42 */
		 ((bool_t) 1);
	      }
	 }
	 {	/* Cfa/iterate.scm 47 */
	    obj_t arg2050_2122;
	    arg2050_2122 =
	       unit_initializers_25_ast_unit();
	    glodefs_2113 =
	       append_2_18___r4_pairs_and_lists_6_3(arg2050_2122, glodefs_2113);
	 }
	 continue_cfa__104_cfa_iterate();
	 {

	  loop_2123:
	    {	/* Cfa/iterate.scm 52 */
	       bool_t test2051_2124;
	       test2051_2124 =
		  CBOOL(_cfa_continue___179_cfa_iterate);
	       if (test2051_2124)
		 {	/* Cfa/iterate.scm 52 */
		    cfa_iterate__222_cfa_iterate(glodefs_2113);
		    goto loop_2123;
		 }
	       else
		 {	/* Cfa/iterate.scm 52 */
		    return glodefs_2113;
		 }
	    }
	 }
      }
   }
}



/* _cfa-iterate-to-fixpoint! */
obj_t 
_cfa_iterate_to_fixpoint__26_cfa_iterate(obj_t env_3355, obj_t globals_3356)
{
   AN_OBJECT;
   {	/* Cfa/iterate.scm 36 */
      return
	 cfa_iterate_to_fixpoint__166_cfa_iterate(globals_3356);
   }
}



/* cfa-iterate! */
obj_t 
cfa_iterate__222_cfa_iterate(obj_t globals_2)
{
   AN_OBJECT;
   {	/* Cfa/iterate.scm 62 */
      _cfa_continue___179_cfa_iterate = BFALSE;
      {		/* Cfa/iterate.scm 64 */
	 long z2_2944;
	 z2_2944 =
	    (long) CINT(_cfa_stamp__16_cfa_iterate);
	 {	/* ./Ieee/fixnum.scm 7193 */
	    long aux_3423;
	    aux_3423 =
	       (((long) 1) + z2_2944);
	    _cfa_stamp__16_cfa_iterate =
	       BINT(aux_3423);
	 }
      }
      {
	 obj_t l2033_2125;
	 l2033_2125 = globals_2;
       lname2034_2126:
	 if (
	    PAIRP(l2033_2125))
	   {	/* Cfa/iterate.scm 66 */
	      {		/* Cfa/iterate.scm 66 */
		 obj_t g_2128;
		 g_2128 =
		    CAR(l2033_2125);
		 {	/* Cfa/iterate.scm 68 */
		    value_bglt aux_3429;
		    {	/* Cfa/iterate.scm 68 */
		       global_bglt obj_2947;
		       obj_2947 =
			  (global_bglt) (g_2128);
		       aux_3429 =
			  (((global_bglt) CREF(obj_2947))->value);
		    }
		    cfa_export_var__93_cfa_iterate(aux_3429, g_2128);
		 }
		 BUNSPEC;
	      }
	      {
		 obj_t l2033_3433;
		 l2033_3433 =
		    CDR(l2033_2125);
		 l2033_2125 = l2033_3433;
		 goto lname2034_2126;
	      }
	   }
	 else
	   {	/* Cfa/iterate.scm 66 */
	      ((bool_t) 1);
	   }
      }
      return BUNSPEC;
   }
}



/* _cfa-iterate! */
obj_t 
_cfa_iterate__24_cfa_iterate(obj_t env_3357, obj_t globals_3358)
{
   AN_OBJECT;
   {	/* Cfa/iterate.scm 62 */
      return
	 cfa_iterate__222_cfa_iterate(globals_3358);
   }
}



/* cfa-intern-sfun! */
approx_bglt 
cfa_intern_sfun__162_cfa_iterate(intern_sfun_cinfo_192_bglt sfun_11, obj_t owner_12)
{
   AN_OBJECT;
   {	/* Cfa/iterate.scm 120 */
      {		/* Cfa/iterate.scm 123 */
	 bool_t test2055_2132;
	 {	/* Cfa/iterate.scm 123 */
	    long arg2060_2137;
	    {
	       obj_t aux_3436;
	       {	/* ./Cfa/cinfo.scm 1017 */
		  object_bglt aux_3437;
		  aux_3437 =
		     (object_bglt) (sfun_11);
		  aux_3436 =
		     OBJECT_WIDENING(aux_3437);
	       }
	       arg2060_2137 =
		  (((intern_sfun_cinfo_192_bglt) CREF(aux_3436))->stamp);
	    }
	    {	/* Cfa/iterate.scm 123 */
	       long n2_2951;
	       n2_2951 =
		  (long) CINT(_cfa_stamp__16_cfa_iterate);
	       test2055_2132 =
		  (arg2060_2137 == n2_2951);
	    }
	 }
	 if (test2055_2132)
	   {
	      obj_t aux_3444;
	      {		/* ./Cfa/cinfo.scm 1016 */
		 object_bglt aux_3445;
		 aux_3445 =
		    (object_bglt) (sfun_11);
		 aux_3444 =
		    OBJECT_WIDENING(aux_3445);
	      }
	      return
		 (((intern_sfun_cinfo_192_bglt) CREF(aux_3444))->approx);
	   }
	 else
	   {	/* Cfa/iterate.scm 123 */
	      {		/* Cfa/iterate.scm 126 */
		 long val1488_2954;
		 val1488_2954 =
		    (long) CINT(_cfa_stamp__16_cfa_iterate);
		 {
		    obj_t aux_3450;
		    {	/* ./Cfa/cinfo.scm 1017 */
		       object_bglt aux_3451;
		       aux_3451 =
			  (object_bglt) (sfun_11);
		       aux_3450 =
			  OBJECT_WIDENING(aux_3451);
		    }
		    ((((intern_sfun_cinfo_192_bglt) CREF(aux_3450))->stamp) = ((long) val1488_2954), BUNSPEC);
		 }
	      }
	      {		/* Cfa/iterate.scm 127 */
		 approx_bglt arg2056_2133;
		 approx_bglt arg2057_2134;
		 {
		    obj_t aux_3455;
		    {	/* ./Cfa/cinfo.scm 1016 */
		       object_bglt aux_3456;
		       aux_3456 =
			  (object_bglt) (sfun_11);
		       aux_3455 =
			  OBJECT_WIDENING(aux_3456);
		    }
		    arg2056_2133 =
		       (((intern_sfun_cinfo_192_bglt) CREF(aux_3455))->approx);
		 }
		 {	/* Cfa/iterate.scm 127 */
		    node_bglt aux_3460;
		    {	/* Cfa/iterate.scm 127 */
		       obj_t aux_3461;
		       {	/* Cfa/iterate.scm 127 */
			  sfun_bglt obj_2956;
			  obj_2956 =
			     (sfun_bglt) (sfun_11);
			  aux_3461 =
			     (((sfun_bglt) CREF(obj_2956))->body);
		       }
		       aux_3460 =
			  (node_bglt) (aux_3461);
		    }
		    arg2057_2134 =
		       cfa__102_cfa_cfa(aux_3460);
		 }
		 union_approx__241_cfa_approx(arg2056_2133, arg2057_2134);
	      }
	      {		/* Cfa/iterate.scm 128 */
		 approx_bglt aux_3467;
		 {
		    obj_t aux_3468;
		    {	/* ./Cfa/cinfo.scm 1016 */
		       object_bglt aux_3469;
		       aux_3469 =
			  (object_bglt) (sfun_11);
		       aux_3468 =
			  OBJECT_WIDENING(aux_3469);
		    }
		    aux_3467 =
		       (((intern_sfun_cinfo_192_bglt) CREF(aux_3468))->approx);
		 }
		 stack_intern_sfun_loose__226_cfa_loose(aux_3467, owner_12);
	      }
	      {
		 obj_t aux_3474;
		 {	/* ./Cfa/cinfo.scm 1016 */
		    object_bglt aux_3475;
		    aux_3475 =
		       (object_bglt) (sfun_11);
		    aux_3474 =
		       OBJECT_WIDENING(aux_3475);
		 }
		 return
		    (((intern_sfun_cinfo_192_bglt) CREF(aux_3474))->approx);
	      }
	   }
      }
   }
}



/* _cfa-intern-sfun! */
obj_t 
_cfa_intern_sfun__144_cfa_iterate(obj_t env_3359, obj_t sfun_3360, obj_t owner_3361)
{
   AN_OBJECT;
   {	/* Cfa/iterate.scm 120 */
      {		/* Cfa/iterate.scm 120 */
	 approx_bglt aux_3479;
	 aux_3479 =
	    cfa_intern_sfun__162_cfa_iterate(
	    (intern_sfun_cinfo_192_bglt) (sfun_3360), owner_3361);
	 return
	    (obj_t) (aux_3479);
      }
   }
}



/* continue-cfa! */
obj_t 
continue_cfa__104_cfa_iterate()
{
   AN_OBJECT;
   {	/* Cfa/iterate.scm 140 */
      if (
	 CBOOL(_cfa_continue___179_cfa_iterate))
	{	/* Cfa/iterate.scm 141 */
	   BUNSPEC;
	}
      else
	{	/* Cfa/iterate.scm 141 */
	   BUNSPEC;
	}
      return (
	 _cfa_continue___179_cfa_iterate = BTRUE, BUNSPEC);
   }
}



/* _continue-cfa! */
obj_t 
_continue_cfa__96_cfa_iterate(obj_t env_3362)
{
   AN_OBJECT;
   {	/* Cfa/iterate.scm 140 */
      return
	 continue_cfa__104_cfa_iterate();
   }
}



/* method-init */
obj_t 
method_init_76_cfa_iterate()
{
   AN_OBJECT;
   {	/* Cfa/iterate.scm 14 */
      add_generic__110___object(cfa_export_var__env_209_cfa_iterate, cfa_export_var__default2040_env_202_cfa_iterate);
      add_inlined_method__244___object(cfa_export_var__env_209_cfa_iterate, svar_cinfo_166_cfa_info, ((long) 0));
      {		/* Cfa/iterate.scm 14 */
	 long aux_3488;
	 aux_3488 =
	    add_inlined_method__244___object(cfa_export_var__env_209_cfa_iterate, intern_sfun_cinfo_192_cfa_info, ((long) 1));
	 return
	    BINT(aux_3488);
      }
   }
}



/* cfa-export-var! */
obj_t 
cfa_export_var__93_cfa_iterate(value_bglt value_3, obj_t owner_4)
{
   AN_OBJECT;
   {	/* Cfa/iterate.scm 76 */
      {
	 obj_t method2307_2896;
	 obj_t class2312_2897;
	 {	/* Cfa/iterate.scm 76 */
	    obj_t arg2315_2894;
	    obj_t arg2316_2895;
	    {	/* Cfa/iterate.scm 76 */
	       object_bglt obj_3306;
	       obj_3306 =
		  (object_bglt) (value_3);
	       {	/* ./Llib/object.scm 2926 */
		  obj_t pre_method_105_3307;
		  pre_method_105_3307 =
		     PROCEDURE_REF(cfa_export_var__env_209_cfa_iterate, ((long) 2));
		  if (
		     INTEGERP(pre_method_105_3307))
		    {	/* ./Llib/object.scm 2927 */
		       PROCEDURE_SET(cfa_export_var__env_209_cfa_iterate, ((long) 2), BUNSPEC);
		       arg2315_2894 = pre_method_105_3307;
		    }
		  else
		    {	/* ./Llib/object.scm 2914 */
		       long obj_class_num_177_3312;
		       obj_class_num_177_3312 =
			  TYPE(obj_3306);
		       {	/* ./Llib/object.scm 2915 */
			  obj_t arg1176_3313;
			  arg1176_3313 =
			     PROCEDURE_REF(cfa_export_var__env_209_cfa_iterate, ((long) 1));
			  {	/* ./Llib/object.scm 2738 */
			     long arg1177_3317;
			     {	/* ./Llib/object.scm 2738 */
				long arg1178_3318;
				arg1178_3318 =
				   OBJECT_TYPE;
				arg1177_3317 =
				   (obj_class_num_177_3312 - arg1178_3318);
			     }
			     arg2315_2894 =
				VECTOR_REF(arg1176_3313, arg1177_3317);
			  }
		       }
		    }
	       }
	    }
	    {	/* Cfa/iterate.scm 76 */
	       object_bglt object_3323;
	       object_3323 =
		  (object_bglt) (value_3);
	       {	/* ./Llib/object.scm 2695 */
		  long arg1179_3324;
		  {	/* ./Llib/object.scm 2695 */
		     long arg1180_3325;
		     long arg1181_3326;
		     arg1180_3325 =
			TYPE(object_3323);
		     arg1181_3326 =
			OBJECT_TYPE;
		     arg1179_3324 =
			(arg1180_3325 - arg1181_3326);
		  }
		  {	/* ./Llib/object.scm 2695 */
		     obj_t vector_3330;
		     vector_3330 = _classes__134___object;
		     arg2316_2895 =
			VECTOR_REF(vector_3330, arg1179_3324);
		  }
	       }
	    }
	    method2307_2896 = arg2315_2894;
	    class2312_2897 = arg2316_2895;
	    {

	       if (
		  INTEGERP(method2307_2896))
		 {	/* Cfa/iterate.scm 76 */
		    switch (
		       (long) CINT(method2307_2896))
		      {
		      case ((long) 0):

			 {	/* Cfa/iterate.scm 82 */
			    svar_cinfo_166_bglt value_2903;
			    value_2903 =
			       (svar_cinfo_166_bglt) (value_3);
			    {	/* Cfa/iterate.scm 82 */
			       obj_t instance2035_2905;
			       instance2035_2905 = sfun_ast_var;
			       {	/* Cfa/iterate.scm 86 */
				  bool_t test2319_2906;
				  {	/* Cfa/iterate.scm 86 */
				     long arg2322_2909;
				     {	/* Cfa/iterate.scm 86 */
					intern_sfun_cinfo_192_bglt obj_3332;
					obj_3332 =
					   (intern_sfun_cinfo_192_bglt) (instance2035_2905);
					{
					   obj_t aux_3510;
					   {	/* ./Cfa/cinfo.scm 1017 */
					      object_bglt aux_3511;
					      aux_3511 =
						 (object_bglt) (obj_3332);
					      aux_3510 =
						 OBJECT_WIDENING(aux_3511);
					   }
					   arg2322_2909 =
					      (((intern_sfun_cinfo_192_bglt) CREF(aux_3510))->stamp);
					}
				     }
				     {	/* Cfa/iterate.scm 86 */
					long n2_3334;
					n2_3334 =
					   (long) CINT(_cfa_stamp__16_cfa_iterate);
					test2319_2906 =
					   (arg2322_2909 == n2_3334);
				     }
				  }
				  if (test2319_2906)
				    {	/* Cfa/iterate.scm 86 */
				       return
					  cfa_variable_value_approx_39_cfa_cfa(
					  (value_bglt) (value_2903));
				    }
				  else
				    {	/* Cfa/iterate.scm 86 */
				       {	/* Cfa/iterate.scm 89 */
					  intern_sfun_cinfo_192_bglt obj_3335;
					  long val1488_3336;
					  obj_3335 =
					     (intern_sfun_cinfo_192_bglt) (instance2035_2905);
					  val1488_3336 =
					     (long) CINT(_cfa_stamp__16_cfa_iterate);
					  {
					     obj_t aux_3522;
					     {	/* ./Cfa/cinfo.scm 1017 */
						object_bglt aux_3523;
						aux_3523 =
						   (object_bglt) (obj_3335);
						aux_3522 =
						   OBJECT_WIDENING(aux_3523);
					     }
					     ((((intern_sfun_cinfo_192_bglt) CREF(aux_3522))->stamp) = ((long) val1488_3336), BUNSPEC);
					  }
				       }
				       {	/* Cfa/iterate.scm 90 */
					  obj_t arg2320_2907;
					  obj_t arg2321_2908;
					  arg2320_2907 =
					     cfa_variable_value_approx_39_cfa_cfa(
					     (value_bglt) (value_2903));
					  arg2321_2908 =
					     CNST_TABLE_REF(((long) 1));
					  {	/* Cfa/iterate.scm 90 */
					     approx_bglt aux_3530;
					     aux_3530 =
						loose__226_cfa_loose(
						(approx_bglt) (arg2320_2907), arg2321_2908);
					     return
						(obj_t) (aux_3530);
					  }
				       }
				    }
			       }
			    }
			 }
			 break;
		      case ((long) 1):

			 {	/* Cfa/iterate.scm 96 */
			    intern_sfun_cinfo_192_bglt value_2910;
			    value_2910 =
			       (intern_sfun_cinfo_192_bglt) (value_3);
			    {	/* Cfa/iterate.scm 100 */
			       bool_t test2323_2913;
			       {	/* Cfa/iterate.scm 100 */
				  long arg2331_2925;
				  {
				     obj_t aux_3535;
				     {	/* ./Cfa/cinfo.scm 1017 */
					object_bglt aux_3536;
					aux_3536 =
					   (object_bglt) (value_2910);
					aux_3535 =
					   OBJECT_WIDENING(aux_3536);
				     }
				     arg2331_2925 =
					(((intern_sfun_cinfo_192_bglt) CREF(aux_3535))->stamp);
				  }
				  {	/* Cfa/iterate.scm 100 */
				     long n2_3339;
				     n2_3339 =
					(long) CINT(_cfa_stamp__16_cfa_iterate);
				     test2323_2913 =
					(arg2331_2925 == n2_3339);
				  }
			       }
			       if (test2323_2913)
				 {	/* Cfa/iterate.scm 100 */
				    {	/* Cfa/iterate.scm 102 */
				       long val1488_3341;
				       val1488_3341 =
					  (long) CINT(_cfa_stamp__16_cfa_iterate);
				       {
					  obj_t aux_3544;
					  {	/* ./Cfa/cinfo.scm 1017 */
					     object_bglt aux_3545;
					     aux_3545 =
						(object_bglt) (value_2910);
					     aux_3544 =
						OBJECT_WIDENING(aux_3545);
					  }
					  ((((intern_sfun_cinfo_192_bglt) CREF(aux_3544))->stamp) = ((long) val1488_3341), BUNSPEC);
				       }
				    }
				    {	/* ./Cfa/cinfo.scm 1016 */
				       approx_bglt aux_3549;
				       {
					  obj_t aux_3550;
					  {	/* ./Cfa/cinfo.scm 1016 */
					     object_bglt aux_3551;
					     aux_3551 =
						(object_bglt) (value_2910);
					     aux_3550 =
						OBJECT_WIDENING(aux_3551);
					  }
					  aux_3549 =
					     (((intern_sfun_cinfo_192_bglt) CREF(aux_3550))->approx);
				       }
				       return
					  (obj_t) (aux_3549);
				    }
				 }
			       else
				 {	/* Cfa/iterate.scm 100 */
				    {
				       obj_t l2037_2914;
				       {	/* Cfa/iterate.scm 109 */
					  sfun_bglt obj_3343;
					  obj_3343 =
					     (sfun_bglt) (value_2910);
					  l2037_2914 =
					     (((sfun_bglt) CREF(obj_3343))->args);
				       }
				     lname2038_2915:
				       if (
					  PAIRP(l2037_2914))
					 {	/* Cfa/iterate.scm 109 */
					    {	/* Cfa/iterate.scm 110 */
					       value_bglt val_2919;
					       {	/* Cfa/iterate.scm 110 */
						  local_bglt obj_3346;
						  {	/* Cfa/iterate.scm 110 */
						     obj_t aux_3558;
						     aux_3558 =
							CAR(l2037_2914);
						     obj_3346 =
							(local_bglt) (aux_3558);
						  }
						  val_2919 =
						     (((local_bglt) CREF(obj_3346))->value);
					       }
					       {	/* Cfa/iterate.scm 111 */
						  bool_t test_3562;
						  {	/* Cfa/iterate.scm 111 */
						     svar_cinfo_166_bglt obj_3347;
						     obj_3347 =
							(svar_cinfo_166_bglt) (val_2919);
						     {
							obj_t aux_3564;
							{	/* ./Cfa/cinfo.scm 1029 */
							   object_bglt aux_3565;
							   aux_3565 =
							      (object_bglt) (obj_3347);
							   aux_3564 =
							      OBJECT_WIDENING(aux_3565);
							}
							test_3562 =
							   (((svar_cinfo_166_bglt) CREF(aux_3564))->clo_env__87);
						     }
						  }
						  if (test_3562)
						    {	/* Cfa/iterate.scm 111 */
						       BUNSPEC;
						    }
						  else
						    {	/* Cfa/iterate.scm 112 */
						       approx_bglt aux_3569;
						       {	/* Cfa/iterate.scm 112 */
							  svar_cinfo_166_bglt obj_3348;
							  obj_3348 =
							     (svar_cinfo_166_bglt) (val_2919);
							  {
							     obj_t aux_3571;
							     {	/* ./Cfa/cinfo.scm 1025 */
								object_bglt aux_3572;
								aux_3572 =
								   (object_bglt) (obj_3348);
								aux_3571 =
								   OBJECT_WIDENING(aux_3572);
							     }
							     aux_3569 =
								(((svar_cinfo_166_bglt) CREF(aux_3571))->approx);
							  }
						       }
						       approx_set_top__187_cfa_approx(aux_3569);
						    }
					       }
					    }
					    {
					       obj_t l2037_3577;
					       l2037_3577 =
						  CDR(l2037_2914);
					       l2037_2914 = l2037_3577;
					       goto lname2038_2915;
					    }
					 }
				       else
					 {	/* Cfa/iterate.scm 109 */
					    ((bool_t) 1);
					 }
				    }
				    {	/* Cfa/iterate.scm 115 */
				       approx_bglt arg2329_2923;
				       obj_t arg2330_2924;
				       arg2329_2923 =
					  cfa_intern_sfun__162_cfa_iterate(value_2910, owner_4);
				       arg2330_2924 =
					  CNST_TABLE_REF(((long) 1));
				       {	/* Cfa/iterate.scm 115 */
					  approx_bglt aux_3583;
					  aux_3583 =
					     loose__226_cfa_loose(arg2329_2923, arg2330_2924);
					  return
					     (obj_t) (aux_3583);
				       }
				    }
				 }
			    }
			 }
			 break;
		      default:
		       case_else2313_2900:
			 if (
			    PROCEDUREP(method2307_2896))
			   {	/* Cfa/iterate.scm 76 */
			      return
				 PROCEDURE_ENTRY(method2307_2896) (method2307_2896,
				 (obj_t) (value_3), owner_4, BEOA);
			   }
			 else
			   {	/* Cfa/iterate.scm 76 */
			      obj_t fun2306_2892;
			      fun2306_2892 =
				 PROCEDURE_REF(cfa_export_var__env_209_cfa_iterate, ((long) 0));
			      return
				 PROCEDURE_ENTRY(fun2306_2892) (fun2306_2892,
				 (obj_t) (value_3), owner_4, BEOA);
			   }
		      }
		 }
	       else
		 {	/* Cfa/iterate.scm 76 */
		    goto case_else2313_2900;
		 }
	    }
	 }
      }
   }
}



/* _cfa-export-var! */
obj_t 
_cfa_export_var__160_cfa_iterate(obj_t env_3363, obj_t value_3364, obj_t owner_3365)
{
   AN_OBJECT;
   {	/* Cfa/iterate.scm 76 */
      return
	 cfa_export_var__93_cfa_iterate(
	 (value_bglt) (value_3364), owner_3365);
   }
}



/* cfa-export-var!-default2040 */
obj_t 
cfa_export_var__default2040_112_cfa_iterate(value_bglt value_5, obj_t owner_6)
{
   AN_OBJECT;
   {	/* Cfa/iterate.scm 14 */
      FAILURE(
	 CNST_TABLE_REF(((long) 2)), string2338_cfa_iterate,
	 (obj_t) (value_5));
   }
}



/* _cfa-export-var!-default2040 */
obj_t 
_cfa_export_var__default2040_81_cfa_iterate(obj_t env_3366, obj_t value_3367, obj_t owner_3368)
{
   AN_OBJECT;
   {	/* Cfa/iterate.scm 14 */
      return
	 cfa_export_var__default2040_112_cfa_iterate(
	 (value_bglt) (value_3367), owner_3368);
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_cfa_iterate()
{
   AN_OBJECT;
   {	/* Cfa/iterate.scm 14 */
      module_initialization_70_tools_trace(((long) 0), "CFA_ITERATE");
      module_initialization_70_tools_shape(((long) 0), "CFA_ITERATE");
      module_initialization_70_type_type(((long) 0), "CFA_ITERATE");
      module_initialization_70_ast_var(((long) 0), "CFA_ITERATE");
      module_initialization_70_ast_node(((long) 0), "CFA_ITERATE");
      module_initialization_70_ast_unit(((long) 0), "CFA_ITERATE");
      module_initialization_70_cfa_cfa(((long) 0), "CFA_ITERATE");
      module_initialization_70_cfa_info(((long) 0), "CFA_ITERATE");
      module_initialization_70_cfa_info2(((long) 0), "CFA_ITERATE");
      module_initialization_70_cfa_loose(((long) 0), "CFA_ITERATE");
      return
	 module_initialization_70_cfa_approx(((long) 0), "CFA_ITERATE");
   }
}
