/*===========================================================================*/
/*   (Cfa/loose.scm)                                                         */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;

typedef struct approx
  {
     header_t header;
     obj_t widening;
     struct type *type;
     bool_t type_locked__184;
     obj_t allocs;
     bool_t top__138;
     long lost_stamp_114;
  }
      *approx_bglt;

typedef struct cfun_cinfo_200
  {
     struct approx *approx;
  }
              *cfun_cinfo_200_bglt;

typedef struct extern_sfun_cinfo_6
  {
     struct approx *approx;
  }
                   *extern_sfun_cinfo_6_bglt;

typedef struct intern_sfun_cinfo_192
  {
     struct approx *approx;
     long stamp;
  }
                     *intern_sfun_cinfo_192_bglt;

typedef struct scnst_cinfo_0
  {
     struct approx *approx;
  }
             *scnst_cinfo_0_bglt;

typedef struct pre_clo_env_191
  {
     char dummy;
  }
               *pre_clo_env_191_bglt;

typedef struct svar_cinfo_166
  {
     struct approx *approx;
     bool_t clo_env__87;
  }
              *svar_cinfo_166_bglt;

typedef struct cvar_cinfo_53
  {
     struct approx *approx;
  }
             *cvar_cinfo_53_bglt;

typedef struct sexit_cinfo_49
  {
     struct approx *approx;
  }
              *sexit_cinfo_49_bglt;

typedef struct reshaped_local_224
  {
     obj_t binding_value_3;
  }
                  *reshaped_local_224_bglt;

typedef struct reshaped_global_160
  {
     char dummy;
  }
                   *reshaped_global_160_bglt;

typedef struct atom_cinfo_155
  {
     struct approx *approx;
  }
              *atom_cinfo_155_bglt;

typedef struct kwote_node_102
  {
     struct node *node;
  }
              *kwote_node_102_bglt;

typedef struct kwote_cinfo_48
  {
     struct approx *approx;
  }
              *kwote_cinfo_48_bglt;

typedef struct app_ly_cinfo_234
  {
     struct approx *approx;
  }
                *app_ly_cinfo_234_bglt;

typedef struct funcall_cinfo_75
  {
     struct approx *approx;
     struct approx *va_approx_63;
     bool_t arity_error_noticed__118;
     bool_t type_error_noticed__36;
  }
                *funcall_cinfo_75_bglt;

typedef struct pragma_cinfo_220
  {
     struct approx *approx;
  }
                *pragma_cinfo_220_bglt;

typedef struct setq_cinfo_191
  {
     struct approx *approx;
  }
              *setq_cinfo_191_bglt;

typedef struct conditional_cinfo_212
  {
     struct approx *approx;
  }
                     *conditional_cinfo_212_bglt;

typedef struct fail_cinfo_75
  {
     struct approx *approx;
  }
             *fail_cinfo_75_bglt;

typedef struct select_cinfo_150
  {
     struct approx *approx;
  }
                *select_cinfo_150_bglt;

typedef struct set_ex_it_cinfo_168
  {
     struct approx *approx;
  }
                   *set_ex_it_cinfo_168_bglt;

typedef struct jump_ex_it_cinfo_139
  {
     struct approx *approx;
  }
                    *jump_ex_it_cinfo_139_bglt;

typedef struct pre_make_box_186
  {
     char dummy;
  }
                *pre_make_box_186_bglt;

typedef struct make_box_cinfo_127
  {
     struct approx *approx;
  }
                  *make_box_cinfo_127_bglt;

typedef struct make_box_o_cinfo_96
  {
     struct approx *approx;
     struct approx *value_approx_19;
  }
                   *make_box_o_cinfo_96_bglt;

typedef struct box_set__cinfo_94
  {
     struct approx *approx;
  }
                 *box_set__cinfo_94_bglt;

typedef struct box_ref_cinfo_214
  {
     struct approx *approx;
  }
                 *box_ref_cinfo_214_bglt;

typedef struct box_set__o_cinfo_6
  {
     struct approx *approx;
  }
                  *box_set__o_cinfo_6_bglt;

typedef struct box_ref_o_cinfo_98
  {
     struct approx *approx;
  }
                  *box_ref_o_cinfo_98_bglt;

typedef struct pre_make_procedure_app_60
  {
     struct variable *owner;
  }
                         *pre_make_procedure_app_60_bglt;

typedef struct pre_procedure_ref_app_85
  {
     char dummy;
  }
                        *pre_procedure_ref_app_85_bglt;

typedef struct pre_procedure_set__app_208
  {
     char dummy;
  }
                          *pre_procedure_set__app_208_bglt;

typedef struct make_procedure_app_48
  {
     struct approx *approx;
     long values_approx_len_106;
     struct approx **values_approx_79;
     long lost_stamp_114;
     bool_t x_t__142;
     bool_t x;
     bool_t t;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
  }
                     *make_procedure_app_48_bglt;

typedef struct procedure_ref_app_49
  {
     struct approx *approx;
  }
                    *procedure_ref_app_49_bglt;

typedef struct procedure_set__app_32
  {
     struct approx *approx;
  }
                     *procedure_set__app_32_bglt;

typedef struct pre_make_vector_app_251
  {
     struct variable *owner;
  }
                       *pre_make_vector_app_251_bglt;

typedef struct pre_create_vector_app_162
  {
     struct variable *owner;
  }
                         *pre_create_vector_app_162_bglt;

typedef struct pre_vector_ref_app_208
  {
     char dummy;
  }
                      *pre_vector_ref_app_208_bglt;

typedef struct pre_vector_set__app_211
  {
     char dummy;
  }
                       *pre_vector_set__app_211_bglt;

typedef struct make_vector_app_205
  {
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
     bool_t seen__39;
  }
                   *make_vector_app_205_bglt;

typedef struct create_vector_app_150
  {
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
     bool_t seen__39;
  }
                     *create_vector_app_150_bglt;

typedef struct vector_ref_app_195
  {
     struct approx *approx;
  }
                  *vector_ref_app_195_bglt;

typedef struct vector_set__app_21
  {
     struct approx *approx;
  }
                  *vector_set__app_21_bglt;

typedef struct pre_make_struct_app_218
  {
     struct variable *owner;
  }
                       *pre_make_struct_app_218_bglt;

typedef struct pre_struct_ref_app_207
  {
     char dummy;
  }
                      *pre_struct_ref_app_207_bglt;

typedef struct pre_struct_set__app_116
  {
     char dummy;
  }
                       *pre_struct_set__app_116_bglt;

typedef struct make_struct_app_214
  {
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
  }
                   *make_struct_app_214_bglt;

typedef struct struct_ref_app_73
  {
     struct approx *approx;
  }
                 *struct_ref_app_73_bglt;

typedef struct struct_set__app_162
  {
     struct approx *approx;
  }
                   *struct_set__app_162_bglt;


static obj_t method_init_76_cfa_loose();
static obj_t _loose__76_cfa_loose(obj_t, obj_t, obj_t);
extern obj_t disable_x_t__211_cfa_procedure(approx_bglt);
static obj_t stack_loose_alloc__default2033_250_cfa_loose(node_bglt, obj_t);
extern obj_t global_loose__8_cfa_loose(global_bglt, approx_bglt);
static obj_t _stack_intern_sfun_loose__108_cfa_loose(obj_t, obj_t, obj_t);
extern obj_t notify_assert_fail_37___eval(obj_t, obj_t, obj_t);
static approx_bglt stack_loose__246_cfa_loose(approx_bglt, obj_t);
extern obj_t module_initialization_70_cfa_loose(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_cfa_iterate(long, char *);
extern obj_t module_initialization_70_cfa_set(long, char *);
extern obj_t module_initialization_70_cfa_info(long, char *);
extern obj_t module_initialization_70_cfa_info2(long, char *);
extern obj_t module_initialization_70_cfa_approx(long, char *);
extern obj_t module_initialization_70_cfa_procedure(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___eval(long, char *);
extern obj_t module_initialization_70___evenv(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
static obj_t _stack_loose_alloc__default2033_175_cfa_loose(obj_t, obj_t, obj_t);
static obj_t _loose_alloc__default2032_123_cfa_loose(obj_t, obj_t);
extern obj_t stack_intern_sfun_loose__226_cfa_loose(approx_bglt, obj_t);
extern obj_t loose_alloc__73_cfa_loose(node_bglt);
extern obj_t define_primop_ref__105___evenv(obj_t, obj_t);
static obj_t _looser__194_cfa_loose = BUNSPEC;
static obj_t imported_modules_init_94_cfa_loose();
extern obj_t unbind_primop__163___evenv(obj_t);
extern obj_t stack_loose_alloc__95_cfa_loose(node_bglt, obj_t);
static obj_t loose_alloc__default2032_43_cfa_loose(node_bglt);
extern obj_t add_generic__110___object(obj_t, obj_t);
static obj_t library_modules_init_112_cfa_loose();
static obj_t _anonymous_2041__60_cfa_loose(obj_t, obj_t);
static obj_t _set_looser__78_cfa_loose(obj_t, obj_t);
extern obj_t for_each_approx_alloc_83_cfa_approx(obj_t, approx_bglt);
static obj_t toplevel_init_63_cfa_loose();
extern obj_t open_input_string(obj_t);
extern obj_t set_looser__198_cfa_loose(obj_t);
static obj_t _loose_alloc__239_cfa_loose(obj_t, obj_t);
static approx_bglt cfa_loose__48_cfa_loose(approx_bglt);
static obj_t _global_loose__64_cfa_loose(obj_t, obj_t, obj_t);
extern obj_t memq___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern obj_t _classes__134___object;
extern obj_t read___reader(obj_t);
static obj_t _anonymous_2041__2328_1_cfa_loose(obj_t, obj_t);
extern obj_t _cfa_stamp__16_cfa_iterate;
static obj_t require_initialization_114_cfa_loose = BUNSPEC;
extern approx_bglt loose__226_cfa_loose(approx_bglt, obj_t);
static obj_t _stack_loose_alloc__18_cfa_loose(obj_t, obj_t, obj_t);
static obj_t cnst_init_137_cfa_loose();
static obj_t __cnst[11];

DEFINE_EXPORT_GENERIC(loose_alloc__env_83_cfa_loose, _loose_alloc__239_cfa_loose2335, _loose_alloc__239_cfa_loose, 0L, 1);
DEFINE_STATIC_PROCEDURE(loose_alloc__default2032_env_37_cfa_loose, _loose_alloc__default2032_123_cfa_loose2336, _loose_alloc__default2032_123_cfa_loose, 0L, 1);
DEFINE_STATIC_PROCEDURE(stack_loose_alloc__default2033_env_150_cfa_loose, _stack_loose_alloc__default2033_175_cfa_loose2337, _stack_loose_alloc__default2033_175_cfa_loose, 0L, 2);
DEFINE_EXPORT_PROCEDURE(loose__env_222_cfa_loose, _loose__76_cfa_loose2338, _loose__76_cfa_loose, 0L, 2);
DEFINE_EXPORT_GENERIC(stack_loose_alloc__env_147_cfa_loose, _stack_loose_alloc__18_cfa_loose2339, _stack_loose_alloc__18_cfa_loose, 0L, 2);
DEFINE_EXPORT_PROCEDURE(set_looser__env_207_cfa_loose, _set_looser__78_cfa_loose2340, _set_looser__78_cfa_loose, 0L, 1);
DEFINE_STRING(string2329_cfa_loose, string2329_cfa_loose2341, "No method for this object", 25);
DEFINE_STRING(string2330_cfa_loose, string2330_cfa_loose2342, "STACK-LOOSE-ALLOC!-DEFAULT2033 LOOSE-ALLOC!-DEFAULT2032 STACK ALL (IMPORT EXPORT) (\"/home/tahoe2/serrano/tmp/bigloo/comptime/Cfa/loose.scm\" . 1916) (BEGIN (MEMQ LOOSER (QUOTE (CFA STACK)))) (LOOSER) LOOSER (CFA STACK) CFA ", 222);
DEFINE_EXPORT_PROCEDURE(global_loose__env_130_cfa_loose, _global_loose__64_cfa_loose2343, _global_loose__64_cfa_loose, 0L, 2);
DEFINE_EXPORT_PROCEDURE(stack_intern_sfun_loose__env_222_cfa_loose, _stack_intern_sfun_loose__108_cfa_loose2344, _stack_intern_sfun_loose__108_cfa_loose, 0L, 2);



/* module-initialization */
obj_t 
module_initialization_70_cfa_loose(long checksum_3407, char *from_3408)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_cfa_loose))
	{
	   require_initialization_114_cfa_loose =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_cfa_loose();
	   cnst_init_137_cfa_loose();
	   imported_modules_init_94_cfa_loose();
	   method_init_76_cfa_loose();
	   toplevel_init_63_cfa_loose();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_cfa_loose()
{
   AN_OBJECT;
   {	/* Cfa/loose.scm 15 */
      module_initialization_70___eval(((long) 0), "CFA_LOOSE");
      module_initialization_70___evenv(((long) 0), "CFA_LOOSE");
      module_initialization_70___object(((long) 0), "CFA_LOOSE");
      module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "CFA_LOOSE");
      module_initialization_70___reader(((long) 0), "CFA_LOOSE");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_cfa_loose()
{
   AN_OBJECT;
   {	/* Cfa/loose.scm 15 */
      {		/* Cfa/loose.scm 15 */
	 obj_t cnst_port_138_3400;
	 cnst_port_138_3400 =
	    open_input_string(string2330_cfa_loose);
	 {
	    long i_3401;
	    i_3401 = ((long) 10);
	  loop_3402:
	    {	/* Cfa/loose.scm 15 */
	       bool_t test2331_3403;
	       test2331_3403 =
		  (i_3401 == ((long) -1));
	       if (test2331_3403)
		 {	/* Cfa/loose.scm 15 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Cfa/loose.scm 15 */
		    {	/* Cfa/loose.scm 15 */
		       obj_t arg2332_3404;
		       {	/* Cfa/loose.scm 15 */
			  obj_t list2333_3405;
			  list2333_3405 =
			     MAKE_PAIR(cnst_port_138_3400, BNIL);
			  arg2332_3404 =
			     read___reader(list2333_3405);
		       }
		       CNST_TABLE_SET(i_3401, arg2332_3404);
		    }
		    {	/* Cfa/loose.scm 15 */
		       int aux_3406;
		       {	/* Cfa/loose.scm 15 */
			  long aux_3428;
			  aux_3428 =
			     (i_3401 - ((long) 1));
			  aux_3406 =
			     (int) (aux_3428);
		       }
		       {
			  long i_3431;
			  i_3431 =
			     (long) (aux_3406);
			  i_3401 = i_3431;
			  goto loop_3402;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_cfa_loose()
{
   AN_OBJECT;
   {	/* Cfa/loose.scm 15 */
      _looser__194_cfa_loose =
	 CNST_TABLE_REF(((long) 0));
      return BUNSPEC;
   }
}



/* set-looser! */
obj_t 
set_looser__198_cfa_loose(obj_t looser_1)
{
   AN_OBJECT;
   {	/* Cfa/loose.scm 42 */
      {		/* Cfa/loose.scm 43 */
	 bool_t test_3434;
	 {	/* Cfa/loose.scm 43 */
	    obj_t aux_3435;
	    aux_3435 =
	       memq___r4_pairs_and_lists_6_3(looser_1,
	       CNST_TABLE_REF(((long) 1)));
	    test_3434 =
	       CBOOL(aux_3435);
	 }
	 if (test_3434)
	   {	/* Cfa/loose.scm 43 */
	      BUNSPEC;
	   }
	 else
	   {	/* Cfa/loose.scm 43 */
	      {		/* Cfa/loose.scm 43 */
		 obj_t arg2035_2118;
		 obj_t arg2036_2119;
		 arg2035_2118 =
		    CNST_TABLE_REF(((long) 2));
		 arg2036_2119 =
		    __EVMEANING_ADDRESS(looser_1);
		 define_primop_ref__105___evenv(arg2035_2118, arg2036_2119);
	      }
	      notify_assert_fail_37___eval(
		 CNST_TABLE_REF(((long) 3)),
		 CNST_TABLE_REF(((long) 4)),
		 CNST_TABLE_REF(((long) 5)));
	      unbind_primop__163___evenv(
		 CNST_TABLE_REF(((long) 2)));
	   }
      }
      return (
	 _looser__194_cfa_loose = looser_1, BUNSPEC);
   }
}



/* _set-looser! */
obj_t 
_set_looser__78_cfa_loose(obj_t env_3371, obj_t looser_3372)
{
   AN_OBJECT;
   {	/* Cfa/loose.scm 42 */
      return
	 set_looser__198_cfa_loose(looser_3372);
   }
}



/* loose! */
approx_bglt 
loose__226_cfa_loose(approx_bglt approx_2, obj_t owner_3)
{
   AN_OBJECT;
   {	/* Cfa/loose.scm 49 */
      {		/* Cfa/loose.scm 51 */
	 bool_t test2037_2923;
	 {	/* Cfa/loose.scm 51 */
	    obj_t obj1_2924;
	    obj1_2924 = _looser__194_cfa_loose;
	    {	/* ./Ieee/equiv.scm 5508 */
	       obj_t aux_3449;
	       aux_3449 =
		  CNST_TABLE_REF(((long) 0));
	       test2037_2923 =
		  (obj1_2924 == aux_3449);
	    }
	 }
	 if (test2037_2923)
	   {	/* Cfa/loose.scm 51 */
	      return
		 cfa_loose__48_cfa_loose(approx_2);
	   }
	 else
	   {	/* Cfa/loose.scm 53 */
	      approx_bglt res2322_2930;
	      {		/* Cfa/loose.scm 75 */
		 obj_t _anonymous_2041__60_3373;
		 _anonymous_2041__60_3373 =
		    make_fx_procedure(_anonymous_2041__60_cfa_loose, ((long) 1), ((long) 1));
		 PROCEDURE_SET(_anonymous_2041__60_3373, ((long) 0), owner_3);
		 for_each_approx_alloc_83_cfa_approx(_anonymous_2041__60_3373, approx_2);
	      }
	      res2322_2930 = approx_2;
	      return res2322_2930;
	   }
      }
   }
}



/* _loose! */
obj_t 
_loose__76_cfa_loose(obj_t env_3374, obj_t approx_3375, obj_t owner_3376)
{
   AN_OBJECT;
   {	/* Cfa/loose.scm 49 */
      {		/* Cfa/loose.scm 49 */
	 approx_bglt aux_3457;
	 aux_3457 =
	    loose__226_cfa_loose(
	    (approx_bglt) (approx_3375), owner_3376);
	 return
	    (obj_t) (aux_3457);
      }
   }
}



/* <anonymous:2041> */
obj_t 
_anonymous_2041__60_cfa_loose(obj_t env_3377, obj_t alloc_3379)
{
   AN_OBJECT;
   {	/* Cfa/loose.scm 75 */
      {		/* Cfa/loose.scm 75 */
	 obj_t owner_3378;
	 owner_3378 =
	    PROCEDURE_REF(env_3377, ((long) 0));
	 {
	    obj_t alloc_2929;
	    alloc_2929 = alloc_3379;
	    return
	       stack_loose_alloc__95_cfa_loose(
	       (node_bglt) (alloc_2929), owner_3378);
	 }
      }
   }
}



/* cfa-loose! */
approx_bglt 
cfa_loose__48_cfa_loose(approx_bglt approx_4)
{
   AN_OBJECT;
   {	/* Cfa/loose.scm 58 */
      {		/* Cfa/loose.scm 60 */
	 bool_t test2038_2122;
	 {	/* Cfa/loose.scm 60 */
	    long arg2039_2123;
	    arg2039_2123 =
	       (((approx_bglt) CREF(approx_4))->lost_stamp_114);
	    {	/* Cfa/loose.scm 60 */
	       long n2_2933;
	       n2_2933 =
		  (long) CINT(_cfa_stamp__16_cfa_iterate);
	       test2038_2122 =
		  (arg2039_2123 < n2_2933);
	    }
	 }
	 if (test2038_2122)
	   {	/* Cfa/loose.scm 60 */
	      {		/* Cfa/loose.scm 62 */
		 long val1439_2935;
		 val1439_2935 =
		    (long) CINT(_cfa_stamp__16_cfa_iterate);
		 ((((approx_bglt) CREF(approx_4))->lost_stamp_114) = ((long) val1439_2935), BUNSPEC);
	      }
	      for_each_approx_alloc_83_cfa_approx(loose_alloc__env_83_cfa_loose, approx_4);
	   }
	 else
	   {	/* Cfa/loose.scm 60 */
	      BUNSPEC;
	   }
      }
      return approx_4;
   }
}



/* stack-loose! */
approx_bglt 
stack_loose__246_cfa_loose(approx_bglt approx_7, obj_t owner_8)
{
   AN_OBJECT;
   {	/* Cfa/loose.scm 74 */
      {		/* Cfa/loose.scm 75 */
	 obj_t _anonymous_2041__60_3382;
	 _anonymous_2041__60_3382 =
	    make_fx_procedure(_anonymous_2041__2328_1_cfa_loose, ((long) 1), ((long) 1));
	 PROCEDURE_SET(_anonymous_2041__60_3382, ((long) 0), owner_8);
	 for_each_approx_alloc_83_cfa_approx(_anonymous_2041__60_3382, approx_7);
      }
      return approx_7;
   }
}



/* <anonymous:2041>_2328 */
obj_t 
_anonymous_2041__2328_1_cfa_loose(obj_t env_3383, obj_t alloc_3385)
{
   AN_OBJECT;
   {	/* Cfa/loose.scm 75 */
      {		/* Cfa/loose.scm 75 */
	 obj_t owner_3384;
	 owner_3384 =
	    PROCEDURE_REF(env_3383, ((long) 0));
	 {
	    obj_t alloc_2937;
	    alloc_2937 = alloc_3385;
	    return
	       stack_loose_alloc__95_cfa_loose(
	       (node_bglt) (alloc_2937), owner_3384);
	 }
      }
   }
}



/* global-loose! */
obj_t 
global_loose__8_cfa_loose(global_bglt global_13, approx_bglt approx_14)
{
   AN_OBJECT;
   {	/* Cfa/loose.scm 93 */
      {		/* Cfa/loose.scm 97 */
	 bool_t test_3477;
	 {	/* Cfa/loose.scm 97 */
	    obj_t aux_3478;
	    aux_3478 =
	       memq___r4_pairs_and_lists_6_3(
	       (((global_bglt) CREF(global_13))->import),
	       CNST_TABLE_REF(((long) 6)));
	    test_3477 =
	       CBOOL(aux_3478);
	 }
	 if (test_3477)
	   {	/* Cfa/loose.scm 97 */
	      {		/* Cfa/loose.scm 98 */
		 approx_bglt res2323_2944;
		 {	/* Cfa/loose.scm 51 */
		    bool_t test2037_2941;
		    {	/* Cfa/loose.scm 51 */
		       obj_t obj1_2942;
		       obj1_2942 = _looser__194_cfa_loose;
		       {	/* ./Ieee/equiv.scm 5508 */
			  obj_t aux_3483;
			  aux_3483 =
			     CNST_TABLE_REF(((long) 0));
			  test2037_2941 =
			     (obj1_2942 == aux_3483);
		       }
		    }
		    if (test2037_2941)
		      {		/* Cfa/loose.scm 51 */
			 res2323_2944 =
			    cfa_loose__48_cfa_loose(approx_14);
		      }
		    else
		      {		/* Cfa/loose.scm 51 */
			 res2323_2944 =
			    stack_loose__246_cfa_loose(approx_14,
			    CNST_TABLE_REF(((long) 7)));
		      }
		 }
		 return
		    (obj_t) (res2323_2944);
	      }
	   }
	 else
	   {	/* Cfa/loose.scm 99 */
	      bool_t test2043_2129;
	      {		/* Cfa/loose.scm 99 */
		 obj_t obj1_2945;
		 obj1_2945 = _looser__194_cfa_loose;
		 {	/* ./Ieee/equiv.scm 5508 */
		    obj_t aux_3491;
		    aux_3491 =
		       CNST_TABLE_REF(((long) 8));
		    test2043_2129 =
		       (obj1_2945 == aux_3491);
		 }
	      }
	      if (test2043_2129)
		{	/* Cfa/loose.scm 99 */
		   disable_x_t__211_cfa_procedure(approx_14);
		   {	/* Cfa/loose.scm 101 */
		      approx_bglt res2324_2952;
		      {		/* Cfa/loose.scm 51 */
			 bool_t test2037_2949;
			 {	/* Cfa/loose.scm 51 */
			    obj_t obj1_2950;
			    obj1_2950 = _looser__194_cfa_loose;
			    {	/* ./Ieee/equiv.scm 5508 */
			       obj_t aux_3496;
			       aux_3496 =
				  CNST_TABLE_REF(((long) 0));
			       test2037_2949 =
				  (obj1_2950 == aux_3496);
			    }
			 }
			 if (test2037_2949)
			   {	/* Cfa/loose.scm 51 */
			      res2324_2952 =
				 cfa_loose__48_cfa_loose(approx_14);
			   }
			 else
			   {	/* Cfa/loose.scm 51 */
			      res2324_2952 =
				 stack_loose__246_cfa_loose(approx_14,
				 CNST_TABLE_REF(((long) 7)));
			   }
		      }
		      return
			 (obj_t) (res2324_2952);
		   }
		}
	      else
		{	/* Cfa/loose.scm 99 */
		   return
		      disable_x_t__211_cfa_procedure(approx_14);
		}
	   }
      }
   }
}



/* _global-loose! */
obj_t 
_global_loose__64_cfa_loose(obj_t env_3386, obj_t global_3387, obj_t approx_3388)
{
   AN_OBJECT;
   {	/* Cfa/loose.scm 93 */
      return
	 global_loose__8_cfa_loose(
	 (global_bglt) (global_3387),
	 (approx_bglt) (approx_3388));
   }
}



/* stack-intern-sfun-loose! */
obj_t 
stack_intern_sfun_loose__226_cfa_loose(approx_bglt approx_15, obj_t owner_16)
{
   AN_OBJECT;
   {	/* Cfa/loose.scm 108 */
      {		/* Cfa/loose.scm 112 */
	 bool_t test2046_2953;
	 {	/* Cfa/loose.scm 112 */
	    obj_t obj1_2954;
	    obj1_2954 = _looser__194_cfa_loose;
	    {	/* ./Ieee/equiv.scm 5508 */
	       obj_t aux_3508;
	       aux_3508 =
		  CNST_TABLE_REF(((long) 8));
	       test2046_2953 =
		  (obj1_2954 == aux_3508);
	    }
	 }
	 if (test2046_2953)
	   {	/* Cfa/loose.scm 113 */
	      approx_bglt res2325_2961;
	      {		/* Cfa/loose.scm 51 */
		 bool_t test2037_2958;
		 {	/* Cfa/loose.scm 51 */
		    obj_t obj1_2959;
		    obj1_2959 = _looser__194_cfa_loose;
		    {	/* ./Ieee/equiv.scm 5508 */
		       obj_t aux_3512;
		       aux_3512 =
			  CNST_TABLE_REF(((long) 0));
		       test2037_2958 =
			  (obj1_2959 == aux_3512);
		    }
		 }
		 if (test2037_2958)
		   {	/* Cfa/loose.scm 51 */
		      res2325_2961 =
			 cfa_loose__48_cfa_loose(approx_15);
		   }
		 else
		   {	/* Cfa/loose.scm 51 */
		      res2325_2961 =
			 stack_loose__246_cfa_loose(approx_15, owner_16);
		   }
	      }
	      return
		 (obj_t) (res2325_2961);
	   }
	 else
	   {	/* Cfa/loose.scm 112 */
	      return BUNSPEC;
	   }
      }
   }
}



/* _stack-intern-sfun-loose! */
obj_t 
_stack_intern_sfun_loose__108_cfa_loose(obj_t env_3389, obj_t approx_3390, obj_t owner_3391)
{
   AN_OBJECT;
   {	/* Cfa/loose.scm 108 */
      return
	 stack_intern_sfun_loose__226_cfa_loose(
	 (approx_bglt) (approx_3390), owner_3391);
   }
}



/* method-init */
obj_t 
method_init_76_cfa_loose()
{
   AN_OBJECT;
   {	/* Cfa/loose.scm 15 */
      add_generic__110___object(loose_alloc__env_83_cfa_loose, loose_alloc__default2032_env_37_cfa_loose);
      return
	 add_generic__110___object(stack_loose_alloc__env_147_cfa_loose, stack_loose_alloc__default2033_env_150_cfa_loose);
   }
}



/* loose-alloc! */
obj_t 
loose_alloc__73_cfa_loose(node_bglt node_5)
{
   AN_OBJECT;
   {	/* Cfa/loose.scm 69 */
      {
	 obj_t method2308_2909;
	 obj_t class2313_2910;
	 {	/* Cfa/loose.scm 69 */
	    obj_t arg2314_2907;
	    obj_t arg2315_2908;
	    {	/* Cfa/loose.scm 69 */
	       object_bglt obj_3309;
	       obj_3309 =
		  (object_bglt) (node_5);
	       {	/* ./Llib/object.scm 2926 */
		  obj_t pre_method_105_3310;
		  pre_method_105_3310 =
		     PROCEDURE_REF(loose_alloc__env_83_cfa_loose, ((long) 2));
		  if (
		     INTEGERP(pre_method_105_3310))
		    {	/* ./Llib/object.scm 2927 */
		       PROCEDURE_SET(loose_alloc__env_83_cfa_loose, ((long) 2), BUNSPEC);
		       arg2314_2907 = pre_method_105_3310;
		    }
		  else
		    {	/* ./Llib/object.scm 2914 */
		       long obj_class_num_177_3315;
		       obj_class_num_177_3315 =
			  TYPE(obj_3309);
		       {	/* ./Llib/object.scm 2915 */
			  obj_t arg1176_3316;
			  arg1176_3316 =
			     PROCEDURE_REF(loose_alloc__env_83_cfa_loose, ((long) 1));
			  {	/* ./Llib/object.scm 2738 */
			     long arg1177_3320;
			     {	/* ./Llib/object.scm 2738 */
				long arg1178_3321;
				arg1178_3321 =
				   OBJECT_TYPE;
				arg1177_3320 =
				   (obj_class_num_177_3315 - arg1178_3321);
			     }
			     arg2314_2907 =
				VECTOR_REF(arg1176_3316, arg1177_3320);
			  }
		       }
		    }
	       }
	    }
	    {	/* Cfa/loose.scm 69 */
	       object_bglt object_3326;
	       object_3326 =
		  (object_bglt) (node_5);
	       {	/* ./Llib/object.scm 2695 */
		  long arg1179_3327;
		  {	/* ./Llib/object.scm 2695 */
		     long arg1180_3328;
		     long arg1181_3329;
		     arg1180_3328 =
			TYPE(object_3326);
		     arg1181_3329 =
			OBJECT_TYPE;
		     arg1179_3327 =
			(arg1180_3328 - arg1181_3329);
		  }
		  {	/* ./Llib/object.scm 2695 */
		     obj_t vector_3333;
		     vector_3333 = _classes__134___object;
		     arg2315_2908 =
			VECTOR_REF(vector_3333, arg1179_3327);
		  }
	       }
	    }
	    method2308_2909 = arg2314_2907;
	    class2313_2910 = arg2315_2908;
	    if (
	       PROCEDUREP(method2308_2909))
	      {		/* Cfa/loose.scm 69 */
		 return
		    PROCEDURE_ENTRY(method2308_2909) (method2308_2909,
		    (obj_t) (node_5), BEOA);
	      }
	    else
	      {		/* Cfa/loose.scm 69 */
		 obj_t fun2292_2887;
		 fun2292_2887 =
		    PROCEDURE_REF(loose_alloc__env_83_cfa_loose, ((long) 0));
		 return
		    PROCEDURE_ENTRY(fun2292_2887) (fun2292_2887,
		    (obj_t) (node_5), BEOA);
	      }
	 }
      }
   }
}



/* _loose-alloc! */
obj_t 
_loose_alloc__239_cfa_loose(obj_t env_3380, obj_t node_3381)
{
   AN_OBJECT;
   {	/* Cfa/loose.scm 69 */
      return
	 loose_alloc__73_cfa_loose(
	 (node_bglt) (node_3381));
   }
}



/* loose-alloc!-default2032 */
obj_t 
loose_alloc__default2032_43_cfa_loose(node_bglt node_6)
{
   AN_OBJECT;
   {	/* Cfa/loose.scm 15 */
      FAILURE(
	 CNST_TABLE_REF(((long) 9)), string2329_cfa_loose,
	 (obj_t) (node_6));
   }
}



/* _loose-alloc!-default2032 */
obj_t 
_loose_alloc__default2032_123_cfa_loose(obj_t env_3392, obj_t node_3393)
{
   AN_OBJECT;
   {	/* Cfa/loose.scm 15 */
      return
	 loose_alloc__default2032_43_cfa_loose(
	 (node_bglt) (node_3393));
   }
}



/* stack-loose-alloc! */
obj_t 
stack_loose_alloc__95_cfa_loose(node_bglt node_9, obj_t owner_10)
{
   AN_OBJECT;
   {	/* Cfa/loose.scm 82 */
      {
	 obj_t method2294_2892;
	 obj_t class2299_2893;
	 {	/* Cfa/loose.scm 82 */
	    obj_t arg2300_2890;
	    obj_t arg2301_2891;
	    {	/* Cfa/loose.scm 82 */
	       object_bglt obj_3340;
	       obj_3340 =
		  (object_bglt) (node_9);
	       {	/* ./Llib/object.scm 2926 */
		  obj_t pre_method_105_3341;
		  pre_method_105_3341 =
		     PROCEDURE_REF(stack_loose_alloc__env_147_cfa_loose, ((long) 2));
		  if (
		     INTEGERP(pre_method_105_3341))
		    {	/* ./Llib/object.scm 2927 */
		       PROCEDURE_SET(stack_loose_alloc__env_147_cfa_loose, ((long) 2), BUNSPEC);
		       arg2300_2890 = pre_method_105_3341;
		    }
		  else
		    {	/* ./Llib/object.scm 2914 */
		       long obj_class_num_177_3346;
		       obj_class_num_177_3346 =
			  TYPE(obj_3340);
		       {	/* ./Llib/object.scm 2915 */
			  obj_t arg1176_3347;
			  arg1176_3347 =
			     PROCEDURE_REF(stack_loose_alloc__env_147_cfa_loose, ((long) 1));
			  {	/* ./Llib/object.scm 2738 */
			     long arg1177_3351;
			     {	/* ./Llib/object.scm 2738 */
				long arg1178_3352;
				arg1178_3352 =
				   OBJECT_TYPE;
				arg1177_3351 =
				   (obj_class_num_177_3346 - arg1178_3352);
			     }
			     arg2300_2890 =
				VECTOR_REF(arg1176_3347, arg1177_3351);
			  }
		       }
		    }
	       }
	    }
	    {	/* Cfa/loose.scm 82 */
	       object_bglt object_3357;
	       object_3357 =
		  (object_bglt) (node_9);
	       {	/* ./Llib/object.scm 2695 */
		  long arg1179_3358;
		  {	/* ./Llib/object.scm 2695 */
		     long arg1180_3359;
		     long arg1181_3360;
		     arg1180_3359 =
			TYPE(object_3357);
		     arg1181_3360 =
			OBJECT_TYPE;
		     arg1179_3358 =
			(arg1180_3359 - arg1181_3360);
		  }
		  {	/* ./Llib/object.scm 2695 */
		     obj_t vector_3364;
		     vector_3364 = _classes__134___object;
		     arg2301_2891 =
			VECTOR_REF(vector_3364, arg1179_3358);
		  }
	       }
	    }
	    method2294_2892 = arg2300_2890;
	    class2299_2893 = arg2301_2891;
	    if (
	       PROCEDUREP(method2294_2892))
	      {		/* Cfa/loose.scm 82 */
		 return
		    PROCEDURE_ENTRY(method2294_2892) (method2294_2892,
		    (obj_t) (node_9), owner_10, BEOA);
	      }
	    else
	      {		/* Cfa/loose.scm 82 */
		 obj_t fun2293_2888;
		 fun2293_2888 =
		    PROCEDURE_REF(stack_loose_alloc__env_147_cfa_loose, ((long) 0));
		 return
		    PROCEDURE_ENTRY(fun2293_2888) (fun2293_2888,
		    (obj_t) (node_9), owner_10, BEOA);
	      }
	 }
      }
   }
}



/* _stack-loose-alloc! */
obj_t 
_stack_loose_alloc__18_cfa_loose(obj_t env_3394, obj_t node_3395, obj_t owner_3396)
{
   AN_OBJECT;
   {	/* Cfa/loose.scm 82 */
      return
	 stack_loose_alloc__95_cfa_loose(
	 (node_bglt) (node_3395), owner_3396);
   }
}



/* stack-loose-alloc!-default2033 */
obj_t 
stack_loose_alloc__default2033_250_cfa_loose(node_bglt node_11, obj_t owner_12)
{
   AN_OBJECT;
   {	/* Cfa/loose.scm 15 */
      FAILURE(
	 CNST_TABLE_REF(((long) 10)), string2329_cfa_loose,
	 (obj_t) (node_11));
   }
}



/* _stack-loose-alloc!-default2033 */
obj_t 
_stack_loose_alloc__default2033_175_cfa_loose(obj_t env_3397, obj_t node_3398, obj_t owner_3399)
{
   AN_OBJECT;
   {	/* Cfa/loose.scm 15 */
      return
	 stack_loose_alloc__default2033_250_cfa_loose(
	 (node_bglt) (node_3398), owner_3399);
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_cfa_loose()
{
   AN_OBJECT;
   {	/* Cfa/loose.scm 15 */
      module_initialization_70_tools_trace(((long) 0), "CFA_LOOSE");
      module_initialization_70_type_type(((long) 0), "CFA_LOOSE");
      module_initialization_70_tools_shape(((long) 0), "CFA_LOOSE");
      module_initialization_70_ast_var(((long) 0), "CFA_LOOSE");
      module_initialization_70_ast_node(((long) 0), "CFA_LOOSE");
      module_initialization_70_cfa_iterate(((long) 0), "CFA_LOOSE");
      module_initialization_70_cfa_set(((long) 0), "CFA_LOOSE");
      module_initialization_70_cfa_info(((long) 0), "CFA_LOOSE");
      module_initialization_70_cfa_info2(((long) 0), "CFA_LOOSE");
      module_initialization_70_cfa_approx(((long) 0), "CFA_LOOSE");
      return
	 module_initialization_70_cfa_procedure(((long) 0), "CFA_LOOSE");
   }
}
