/*===========================================================================*/
/*   (Cfa/procedure.scm)                                                     */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;

typedef struct approx
  {
     header_t header;
     obj_t widening;
     struct type *type;
     bool_t type_locked__184;
     obj_t allocs;
     bool_t top__138;
     long lost_stamp_114;
  }
      *approx_bglt;

typedef struct cfun_cinfo_200
  {
     struct approx *approx;
  }
              *cfun_cinfo_200_bglt;

typedef struct extern_sfun_cinfo_6
  {
     struct approx *approx;
  }
                   *extern_sfun_cinfo_6_bglt;

typedef struct intern_sfun_cinfo_192
  {
     struct approx *approx;
     long stamp;
  }
                     *intern_sfun_cinfo_192_bglt;

typedef struct scnst_cinfo_0
  {
     struct approx *approx;
  }
             *scnst_cinfo_0_bglt;

typedef struct pre_clo_env_191
  {
     char dummy;
  }
               *pre_clo_env_191_bglt;

typedef struct svar_cinfo_166
  {
     struct approx *approx;
     bool_t clo_env__87;
  }
              *svar_cinfo_166_bglt;

typedef struct cvar_cinfo_53
  {
     struct approx *approx;
  }
             *cvar_cinfo_53_bglt;

typedef struct sexit_cinfo_49
  {
     struct approx *approx;
  }
              *sexit_cinfo_49_bglt;

typedef struct reshaped_local_224
  {
     obj_t binding_value_3;
  }
                  *reshaped_local_224_bglt;

typedef struct reshaped_global_160
  {
     char dummy;
  }
                   *reshaped_global_160_bglt;

typedef struct atom_cinfo_155
  {
     struct approx *approx;
  }
              *atom_cinfo_155_bglt;

typedef struct kwote_node_102
  {
     struct node *node;
  }
              *kwote_node_102_bglt;

typedef struct kwote_cinfo_48
  {
     struct approx *approx;
  }
              *kwote_cinfo_48_bglt;

typedef struct app_ly_cinfo_234
  {
     struct approx *approx;
  }
                *app_ly_cinfo_234_bglt;

typedef struct funcall_cinfo_75
  {
     struct approx *approx;
     struct approx *va_approx_63;
     bool_t arity_error_noticed__118;
     bool_t type_error_noticed__36;
  }
                *funcall_cinfo_75_bglt;

typedef struct pragma_cinfo_220
  {
     struct approx *approx;
  }
                *pragma_cinfo_220_bglt;

typedef struct setq_cinfo_191
  {
     struct approx *approx;
  }
              *setq_cinfo_191_bglt;

typedef struct conditional_cinfo_212
  {
     struct approx *approx;
  }
                     *conditional_cinfo_212_bglt;

typedef struct fail_cinfo_75
  {
     struct approx *approx;
  }
             *fail_cinfo_75_bglt;

typedef struct select_cinfo_150
  {
     struct approx *approx;
  }
                *select_cinfo_150_bglt;

typedef struct set_ex_it_cinfo_168
  {
     struct approx *approx;
  }
                   *set_ex_it_cinfo_168_bglt;

typedef struct jump_ex_it_cinfo_139
  {
     struct approx *approx;
  }
                    *jump_ex_it_cinfo_139_bglt;

typedef struct pre_make_box_186
  {
     char dummy;
  }
                *pre_make_box_186_bglt;

typedef struct make_box_cinfo_127
  {
     struct approx *approx;
  }
                  *make_box_cinfo_127_bglt;

typedef struct make_box_o_cinfo_96
  {
     struct approx *approx;
     struct approx *value_approx_19;
  }
                   *make_box_o_cinfo_96_bglt;

typedef struct box_set__cinfo_94
  {
     struct approx *approx;
  }
                 *box_set__cinfo_94_bglt;

typedef struct box_ref_cinfo_214
  {
     struct approx *approx;
  }
                 *box_ref_cinfo_214_bglt;

typedef struct box_set__o_cinfo_6
  {
     struct approx *approx;
  }
                  *box_set__o_cinfo_6_bglt;

typedef struct box_ref_o_cinfo_98
  {
     struct approx *approx;
  }
                  *box_ref_o_cinfo_98_bglt;

typedef struct pre_make_procedure_app_60
  {
     struct variable *owner;
  }
                         *pre_make_procedure_app_60_bglt;

typedef struct pre_procedure_ref_app_85
  {
     char dummy;
  }
                        *pre_procedure_ref_app_85_bglt;

typedef struct pre_procedure_set__app_208
  {
     char dummy;
  }
                          *pre_procedure_set__app_208_bglt;

typedef struct make_procedure_app_48
  {
     struct approx *approx;
     long values_approx_len_106;
     struct approx **values_approx_79;
     long lost_stamp_114;
     bool_t x_t__142;
     bool_t x;
     bool_t t;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
  }
                     *make_procedure_app_48_bglt;

typedef struct procedure_ref_app_49
  {
     struct approx *approx;
  }
                    *procedure_ref_app_49_bglt;

typedef struct procedure_set__app_32
  {
     struct approx *approx;
  }
                     *procedure_set__app_32_bglt;

typedef struct pre_make_vector_app_251
  {
     struct variable *owner;
  }
                       *pre_make_vector_app_251_bglt;

typedef struct pre_create_vector_app_162
  {
     struct variable *owner;
  }
                         *pre_create_vector_app_162_bglt;

typedef struct pre_vector_ref_app_208
  {
     char dummy;
  }
                      *pre_vector_ref_app_208_bglt;

typedef struct pre_vector_set__app_211
  {
     char dummy;
  }
                       *pre_vector_set__app_211_bglt;

typedef struct make_vector_app_205
  {
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
     bool_t seen__39;
  }
                   *make_vector_app_205_bglt;

typedef struct create_vector_app_150
  {
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
     bool_t seen__39;
  }
                     *create_vector_app_150_bglt;

typedef struct vector_ref_app_195
  {
     struct approx *approx;
  }
                  *vector_ref_app_195_bglt;

typedef struct vector_set__app_21
  {
     struct approx *approx;
  }
                  *vector_set__app_21_bglt;

typedef struct pre_make_struct_app_218
  {
     struct variable *owner;
  }
                       *pre_make_struct_app_218_bglt;

typedef struct pre_struct_ref_app_207
  {
     char dummy;
  }
                      *pre_struct_ref_app_207_bglt;

typedef struct pre_struct_set__app_116
  {
     char dummy;
  }
                       *pre_struct_set__app_116_bglt;

typedef struct make_struct_app_214
  {
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
  }
                   *make_struct_app_214_bglt;

typedef struct struct_ref_app_73
  {
     struct approx *approx;
  }
                 *struct_ref_app_73_bglt;

typedef struct struct_set__app_162
  {
     struct approx *approx;
  }
                   *struct_set__app_162_bglt;


static obj_t method_init_76_cfa_procedure();
extern obj_t cfa_export_var__93_cfa_iterate(value_bglt, obj_t);
static obj_t node_setup__pre_make_procedure_app2052_122_cfa_procedure(obj_t, obj_t);
extern obj_t disable_x_t__211_cfa_procedure(approx_bglt);
extern obj_t var_ast_node;
extern obj_t get_node_atom_value_135_cfa_approx(node_bglt);
static obj_t cfa__procedure_set__app2062_193_cfa_procedure(obj_t, obj_t);
extern obj_t add_method__1___object(obj_t, obj_t, obj_t);
extern obj_t _obj__252_type_cache;
extern obj_t pre_procedure_set__app_208_cfa_info2;
extern approx_bglt make_type_approx_184_cfa_approx(type_bglt);
extern obj_t find_super_class_method_167___object(object_bglt, obj_t, obj_t);
extern approx_bglt make_empty_approx_131_cfa_approx();
extern bool_t is_a__118___object(obj_t, obj_t);
static obj_t loose_alloc__make_procedure_app2064_94_cfa_procedure(obj_t, obj_t);
extern obj_t _unspec__87_type_cache;
extern obj_t module_initialization_70_cfa_procedure(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_cfa_info(long, char *);
extern obj_t module_initialization_70_cfa_info2(long, char *);
extern obj_t module_initialization_70_cfa_loose(long, char *);
extern obj_t module_initialization_70_cfa_setup(long, char *);
extern obj_t module_initialization_70_cfa_approx(long, char *);
extern obj_t module_initialization_70_cfa_cfa(long, char *);
extern obj_t module_initialization_70_cfa_iterate(long, char *);
extern obj_t module_initialization_70_cfa_closure(long, char *);
extern obj_t module_initialization_70_cfa_stack(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t pre_clo_env_191_cfa_info;
static obj_t node_setup__pre_procedure_set__app2056_189_cfa_procedure(obj_t, obj_t);
extern approx_bglt union_approx__241_cfa_approx(approx_bglt, approx_bglt);
extern obj_t procedure_ref_app_49_cfa_info2;
extern obj_t add_procedure_ref__36_cfa_closure(node_bglt);
extern long class_num_218___object(obj_t);
static obj_t node_setup__pre_procedure_ref_app2054_153_cfa_procedure(obj_t, obj_t);
static obj_t _disable_x_t__100_cfa_procedure(obj_t, obj_t);
extern obj_t node_setup___185_cfa_setup(obj_t);
extern obj_t procedure_set__app_32_cfa_info2;
static obj_t stack__make_procedure_app2068_235_cfa_procedure(obj_t, obj_t);
extern obj_t fun_ast_var;
static obj_t stack_loose_alloc__make_procedure_app2066_57_cfa_procedure(obj_t, obj_t, obj_t);
static obj_t imported_modules_init_94_cfa_procedure();
extern obj_t stack_loose_alloc__95_cfa_loose(node_bglt, obj_t);
extern obj_t stack___129_cfa_stack(obj_t);
static obj_t _anonymous_2075__2_cfa_procedure(obj_t, obj_t);
static obj_t _anonymous_2070__151_cfa_procedure(obj_t, obj_t);
extern obj_t node_setup__189_cfa_setup(node_bglt);
extern obj_t approx_set_top__187_cfa_approx(approx_bglt);
extern obj_t pre_make_procedure_app_60_cfa_info2;
static obj_t library_modules_init_112_cfa_procedure();
extern approx_bglt cfa__102_cfa_cfa(node_bglt);
extern node_bglt node_heap__stack__239_cfa_stack(app_bglt, bool_t);
extern obj_t for_each_approx_alloc_83_cfa_approx(obj_t, approx_bglt);
static obj_t toplevel_init_63_cfa_procedure();
extern obj_t open_input_string(obj_t);
extern obj_t variable_ast_var;
extern obj_t make_procedure_app_48_cfa_info2;
extern obj_t add_make_procedure__219_cfa_closure(node_bglt);
extern obj_t memq___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern obj_t pre_procedure_ref_app_85_cfa_info2;
extern obj_t _procedure__226_type_cache;
extern obj_t _classes__134___object;
static obj_t _anonymous_2414__101_cfa_procedure(obj_t, obj_t);
extern obj_t read___reader(obj_t);
static obj_t _anonymous_2408__207_cfa_procedure(obj_t, obj_t);
static obj_t stack_loose_procedure_env__187_cfa_procedure(make_procedure_app_48_bglt, obj_t);
static obj_t _anonymous_2392__212_cfa_procedure(obj_t, obj_t);
static obj_t cfa__procedure_ref_app2060_105_cfa_procedure(obj_t, obj_t);
static obj_t _anonymous_2384__158_cfa_procedure(obj_t, obj_t);
extern obj_t svar_cinfo_166_cfa_info;
static obj_t cfa__make_procedure_app2058_134_cfa_procedure(obj_t, obj_t);
extern obj_t _cfa_stamp__16_cfa_iterate;
static obj_t require_initialization_114_cfa_procedure = BUNSPEC;
extern approx_bglt make_type_alloc_approx_134_cfa_approx(type_bglt, node_bglt);
extern approx_bglt loose__226_cfa_loose(approx_bglt, obj_t);
extern obj_t class_super_145___object(obj_t);
static obj_t cnst_init_137_cfa_procedure();
static obj_t __cnst[2];

extern obj_t loose_alloc__env_83_cfa_loose;
DEFINE_STATIC_PROCEDURE(proc2464_cfa_procedure, stack__make_procedure_app2068_235_cfa_procedure2470, stack__make_procedure_app2068_235_cfa_procedure, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2463_cfa_procedure, stack_loose_alloc__make_procedure_app2066_57_cfa_procedure2471, stack_loose_alloc__make_procedure_app2066_57_cfa_procedure, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2462_cfa_procedure, loose_alloc__make_procedure_app2064_94_cfa_procedure2472, loose_alloc__make_procedure_app2064_94_cfa_procedure, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2461_cfa_procedure, cfa__procedure_set__app2062_193_cfa_procedure2473, cfa__procedure_set__app2062_193_cfa_procedure, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2459_cfa_procedure, cfa__make_procedure_app2058_134_cfa_procedure2474, cfa__make_procedure_app2058_134_cfa_procedure, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2460_cfa_procedure, cfa__procedure_ref_app2060_105_cfa_procedure2475, cfa__procedure_ref_app2060_105_cfa_procedure, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2458_cfa_procedure, node_setup__pre_procedure_set__app2056_189_cfa_procedure2476, node_setup__pre_procedure_set__app2056_189_cfa_procedure, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2457_cfa_procedure, node_setup__pre_procedure_ref_app2054_153_cfa_procedure2477, node_setup__pre_procedure_ref_app2054_153_cfa_procedure, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2456_cfa_procedure, node_setup__pre_make_procedure_app2052_122_cfa_procedure2478, node_setup__pre_make_procedure_app2052_122_cfa_procedure, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2455_cfa_procedure, _anonymous_2070__151_cfa_procedure2479, _anonymous_2070__151_cfa_procedure, 0L, 1);
extern obj_t cfa__env_153_cfa_cfa;
extern obj_t stack_loose_alloc__env_147_cfa_loose;
DEFINE_EXPORT_PROCEDURE(disable_x_t__env_219_cfa_procedure, _disable_x_t__100_cfa_procedure2480, _disable_x_t__100_cfa_procedure, 0L, 1);
DEFINE_STRING(string2465_cfa_procedure, string2465_cfa_procedure2481, "DONE ALL ", 9);
extern obj_t node_setup__env_214_cfa_setup;
extern obj_t stack__env_104_cfa_stack;



/* module-initialization */
obj_t 
module_initialization_70_cfa_procedure(long checksum_3765, char *from_3766)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_cfa_procedure))
	{
	   require_initialization_114_cfa_procedure =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_cfa_procedure();
	   cnst_init_137_cfa_procedure();
	   imported_modules_init_94_cfa_procedure();
	   method_init_76_cfa_procedure();
	   toplevel_init_63_cfa_procedure();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_cfa_procedure()
{
   AN_OBJECT;
   {	/* Cfa/procedure.scm 14 */
      module_initialization_70___object(((long) 0), "CFA_PROCEDURE");
      module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "CFA_PROCEDURE");
      module_initialization_70___reader(((long) 0), "CFA_PROCEDURE");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_cfa_procedure()
{
   AN_OBJECT;
   {	/* Cfa/procedure.scm 14 */
      {		/* Cfa/procedure.scm 14 */
	 obj_t cnst_port_138_3758;
	 cnst_port_138_3758 =
	    open_input_string(string2465_cfa_procedure);
	 {
	    long i_3759;
	    i_3759 = ((long) 1);
	  loop_3760:
	    {	/* Cfa/procedure.scm 14 */
	       bool_t test2466_3761;
	       test2466_3761 =
		  (i_3759 == ((long) -1));
	       if (test2466_3761)
		 {	/* Cfa/procedure.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Cfa/procedure.scm 14 */
		    {	/* Cfa/procedure.scm 14 */
		       obj_t arg2467_3762;
		       {	/* Cfa/procedure.scm 14 */
			  obj_t list2468_3763;
			  list2468_3763 =
			     MAKE_PAIR(cnst_port_138_3758, BNIL);
			  arg2467_3762 =
			     read___reader(list2468_3763);
		       }
		       CNST_TABLE_SET(i_3759, arg2467_3762);
		    }
		    {	/* Cfa/procedure.scm 14 */
		       int aux_3764;
		       {	/* Cfa/procedure.scm 14 */
			  long aux_3784;
			  aux_3784 =
			     (i_3759 - ((long) 1));
			  aux_3764 =
			     (int) (aux_3784);
		       }
		       {
			  long i_3787;
			  i_3787 =
			     (long) (aux_3764);
			  i_3759 = i_3787;
			  goto loop_3760;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_cfa_procedure()
{
   AN_OBJECT;
   {	/* Cfa/procedure.scm 14 */
      return BUNSPEC;
   }
}



/* disable-x-t! */
obj_t 
disable_x_t__211_cfa_procedure(approx_bglt approx_1)
{
   AN_OBJECT;
   {	/* Cfa/procedure.scm 36 */
      {		/* Cfa/procedure.scm 37 */
	 obj_t _anonymous_2070__151_3692;
	 _anonymous_2070__151_3692 = proc2455_cfa_procedure;
	 return
	    for_each_approx_alloc_83_cfa_approx(_anonymous_2070__151_3692, approx_1);
      }
   }
}



/* _disable-x-t! */
obj_t 
_disable_x_t__100_cfa_procedure(obj_t env_3693, obj_t approx_3694)
{
   AN_OBJECT;
   {	/* Cfa/procedure.scm 36 */
      return
	 disable_x_t__211_cfa_procedure(
	 (approx_bglt) (approx_3694));
   }
}



/* <anonymous:2070> */
obj_t 
_anonymous_2070__151_cfa_procedure(obj_t env_3695, obj_t app_3696)
{
   AN_OBJECT;
   {	/* Cfa/procedure.scm 37 */
      {
	 obj_t app_2115;
	 app_2115 = app_3696;
	 {	/* Cfa/procedure.scm 41 */
	    bool_t test2071_2117;
	    test2071_2117 =
	       is_a__118___object(app_2115, make_procedure_app_48_cfa_info2);
	    if (test2071_2117)
	      {		/* Cfa/procedure.scm 42 */
		 make_procedure_app_48_bglt obj_3104;
		 obj_3104 =
		    (make_procedure_app_48_bglt) (app_2115);
		 {
		    obj_t aux_3795;
		    {	/* ./Cfa/cinfo2.scm 1276 */
		       object_bglt aux_3796;
		       aux_3796 =
			  (object_bglt) (obj_3104);
		       aux_3795 =
			  OBJECT_WIDENING(aux_3796);
		    }
		    return
		       ((((make_procedure_app_48_bglt) CREF(aux_3795))->x_t__142) = ((bool_t) ((bool_t) 0)), BUNSPEC);
		 }
	      }
	    else
	      {		/* Cfa/procedure.scm 41 */
		 return BUNSPEC;
	      }
	 }
      }
   }
}



/* stack-loose-procedure-env! */
obj_t 
stack_loose_procedure_env__187_cfa_procedure(make_procedure_app_48_bglt alloc_11, obj_t cowner_12)
{
   AN_OBJECT;
   {	/* Cfa/procedure.scm 280 */
      {		/* Cfa/procedure.scm 284 */
	 long len_2119;
	 {
	    obj_t aux_3800;
	    {	/* ./Cfa/cinfo2.scm 1270 */
	       object_bglt aux_3801;
	       aux_3801 =
		  (object_bglt) (alloc_11);
	       aux_3800 =
		  OBJECT_WIDENING(aux_3801);
	    }
	    len_2119 =
	       (((make_procedure_app_48_bglt) CREF(aux_3800))->values_approx_len_106);
	 }
	 {
	    long i_2120;
	    i_2120 = ((long) 0);
	  loop_2121:
	    if (
	       (i_2120 < len_2119))
	      {		/* Cfa/procedure.scm 286 */
		 {	/* Cfa/procedure.scm 289 */
		    approx_bglt arg2074_2124;
		    {
		       obj_t aux_3807;
		       {	/* ./Cfa/cinfo2.scm 1270 */
			  object_bglt aux_3808;
			  aux_3808 =
			     (object_bglt) (alloc_11);
			  aux_3807 =
			     OBJECT_WIDENING(aux_3808);
		       }
		       arg2074_2124 =
			  (((make_procedure_app_48_bglt) CREF(aux_3807))->values_approx_79)[i_2120];
		    }
		    {	/* Cfa/procedure.scm 289 */
		       obj_t _anonymous_2075__2_3697;
		       _anonymous_2075__2_3697 =
			  make_fx_procedure(_anonymous_2075__2_cfa_procedure, ((long) 1), ((long) 1));
		       PROCEDURE_SET(_anonymous_2075__2_3697, ((long) 0), cowner_12);
		       for_each_approx_alloc_83_cfa_approx(_anonymous_2075__2_3697, arg2074_2124);
		    }
		 }
		 {
		    long i_3815;
		    i_3815 =
		       (i_2120 + ((long) 1));
		    i_2120 = i_3815;
		    goto loop_2121;
		 }
	      }
	    else
	      {		/* Cfa/procedure.scm 286 */
		 return BUNSPEC;
	      }
	 }
      }
   }
}



/* <anonymous:2075> */
obj_t 
_anonymous_2075__2_cfa_procedure(obj_t env_3698, obj_t alloc_3700)
{
   AN_OBJECT;
   {	/* Cfa/procedure.scm 289 */
      {		/* Cfa/procedure.scm 289 */
	 obj_t cowner_3699;
	 cowner_3699 =
	    PROCEDURE_REF(env_3698, ((long) 0));
	 {
	    obj_t alloc_2125;
	    alloc_2125 = alloc_3700;
	    return
	       stack_loose_alloc__95_cfa_loose(
	       (node_bglt) (alloc_2125), cowner_3699);
	 }
      }
   }
}



/* method-init */
obj_t 
method_init_76_cfa_procedure()
{
   AN_OBJECT;
   {	/* Cfa/procedure.scm 14 */
      {		/* Cfa/procedure.scm 14 */
	 obj_t node_setup__pre_make_procedure_app2052_122_3713;
	 node_setup__pre_make_procedure_app2052_122_3713 = proc2456_cfa_procedure;
	 add_method__1___object(node_setup__env_214_cfa_setup, pre_make_procedure_app_60_cfa_info2, node_setup__pre_make_procedure_app2052_122_3713);
      }
      {		/* Cfa/procedure.scm 14 */
	 obj_t node_setup__pre_procedure_ref_app2054_153_3712;
	 node_setup__pre_procedure_ref_app2054_153_3712 = proc2457_cfa_procedure;
	 add_method__1___object(node_setup__env_214_cfa_setup, pre_procedure_ref_app_85_cfa_info2, node_setup__pre_procedure_ref_app2054_153_3712);
      }
      {		/* Cfa/procedure.scm 14 */
	 obj_t node_setup__pre_procedure_set__app2056_189_3711;
	 node_setup__pre_procedure_set__app2056_189_3711 = proc2458_cfa_procedure;
	 add_method__1___object(node_setup__env_214_cfa_setup, pre_procedure_set__app_208_cfa_info2, node_setup__pre_procedure_set__app2056_189_3711);
      }
      {		/* Cfa/procedure.scm 14 */
	 obj_t cfa__make_procedure_app2058_134_3710;
	 cfa__make_procedure_app2058_134_3710 = proc2459_cfa_procedure;
	 add_method__1___object(cfa__env_153_cfa_cfa, make_procedure_app_48_cfa_info2, cfa__make_procedure_app2058_134_3710);
      }
      {		/* Cfa/procedure.scm 14 */
	 obj_t cfa__procedure_ref_app2060_105_3709;
	 cfa__procedure_ref_app2060_105_3709 = proc2460_cfa_procedure;
	 add_method__1___object(cfa__env_153_cfa_cfa, procedure_ref_app_49_cfa_info2, cfa__procedure_ref_app2060_105_3709);
      }
      {		/* Cfa/procedure.scm 14 */
	 obj_t cfa__procedure_set__app2062_193_3706;
	 cfa__procedure_set__app2062_193_3706 = proc2461_cfa_procedure;
	 add_method__1___object(cfa__env_153_cfa_cfa, procedure_set__app_32_cfa_info2, cfa__procedure_set__app2062_193_3706);
      }
      {		/* Cfa/procedure.scm 14 */
	 obj_t loose_alloc__make_procedure_app2064_94_3703;
	 loose_alloc__make_procedure_app2064_94_3703 = proc2462_cfa_procedure;
	 add_method__1___object(loose_alloc__env_83_cfa_loose, make_procedure_app_48_cfa_info2, loose_alloc__make_procedure_app2064_94_3703);
      }
      {		/* Cfa/procedure.scm 14 */
	 obj_t stack_loose_alloc__make_procedure_app2066_57_3702;
	 stack_loose_alloc__make_procedure_app2066_57_3702 = proc2463_cfa_procedure;
	 add_method__1___object(stack_loose_alloc__env_147_cfa_loose, make_procedure_app_48_cfa_info2, stack_loose_alloc__make_procedure_app2066_57_3702);
      }
      {		/* Cfa/procedure.scm 14 */
	 obj_t stack__make_procedure_app2068_235_3701;
	 stack__make_procedure_app2068_235_3701 = proc2464_cfa_procedure;
	 return
	    add_method__1___object(stack__env_104_cfa_stack, make_procedure_app_48_cfa_info2, stack__make_procedure_app2068_235_3701);
      }
   }
}



/* stack!-make-procedure-app2068 */
obj_t 
stack__make_procedure_app2068_235_cfa_procedure(obj_t env_3716, obj_t node_3717)
{
   AN_OBJECT;
   {	/* Cfa/procedure.scm 296 */
      {
	 make_procedure_app_48_bglt node_3092;
	 {	/* Cfa/procedure.scm 297 */
	    node_bglt aux_3829;
	    node_3092 =
	       (make_procedure_app_48_bglt) (node_3717);
	    {	/* Cfa/procedure.scm 300 */
	       obj_t aux_3830;
	       {	/* Cfa/procedure.scm 300 */
		  app_bglt obj_3687;
		  obj_3687 =
		     (app_bglt) (node_3092);
		  aux_3830 =
		     (((app_bglt) CREF(obj_3687))->args);
	       }
	       stack___129_cfa_stack(aux_3830);
	    }
	    {	/* Cfa/procedure.scm 301 */
	       bool_t aux_3834;
	       {	/* Cfa/procedure.scm 301 */
		  bool_t test_3836;
		  {	/* ./Ieee/fixnum.scm 7109 */
		     long aux_3837;
		     {
			obj_t aux_3838;
			{	/* ./Cfa/cinfo2.scm 1274 */
			   object_bglt aux_3839;
			   aux_3839 =
			      (object_bglt) (node_3092);
			   aux_3838 =
			      OBJECT_WIDENING(aux_3839);
			}
			aux_3837 =
			   (((make_procedure_app_48_bglt) CREF(aux_3838))->lost_stamp_114);
		     }
		     test_3836 =
			(aux_3837 == ((long) -1));
		  }
		  if (test_3836)
		    {
		       obj_t aux_3844;
		       {	/* ./Cfa/cinfo2.scm 1283 */
			  object_bglt aux_3845;
			  aux_3845 =
			     (object_bglt) (node_3092);
			  aux_3844 =
			     OBJECT_WIDENING(aux_3845);
		       }
		       aux_3834 =
			  (((make_procedure_app_48_bglt) CREF(aux_3844))->stackable__42);
		    }
		  else
		    {	/* Cfa/procedure.scm 301 */
		       aux_3834 = ((bool_t) 0)
			  ;
		    }
	       }
	       aux_3829 =
		  node_heap__stack__239_cfa_stack(
		  (app_bglt) (node_3092), aux_3834);
	    }
	    return
	       (obj_t) (aux_3829);
	 }
      }
   }
}



/* stack-loose-alloc!-make-procedure-app2066 */
obj_t 
stack_loose_alloc__make_procedure_app2066_57_cfa_procedure(obj_t env_3718, obj_t alloc_3719, obj_t cowner_3720)
{
   AN_OBJECT;
   {	/* Cfa/procedure.scm 257 */
      {
	 make_procedure_app_48_bglt alloc_3073;
	 obj_t cowner_3074;
	 alloc_3073 =
	    (make_procedure_app_48_bglt) (alloc_3719);
	 cowner_3074 = cowner_3720;
	 {	/* Cfa/procedure.scm 261 */
	    bool_t test_3852;
	    {	/* Cfa/procedure.scm 261 */
	       bool_t test_3853;
	       {
		  obj_t aux_3854;
		  {	/* ./Cfa/cinfo2.scm 1283 */
		     object_bglt aux_3855;
		     aux_3855 =
			(object_bglt) (alloc_3073);
		     aux_3854 =
			OBJECT_WIDENING(aux_3855);
		  }
		  test_3853 =
		     (((make_procedure_app_48_bglt) CREF(aux_3854))->stackable__42);
	       }
	       if (test_3853)
		 {	/* Cfa/procedure.scm 261 */
		    obj_t aux_3859;
		    {	/* Cfa/procedure.scm 261 */
		       obj_t aux_3860;
		       {
			  obj_t aux_3861;
			  {	/* ./Cfa/cinfo2.scm 1285 */
			     object_bglt aux_3862;
			     aux_3862 =
				(object_bglt) (alloc_3073);
			     aux_3861 =
				OBJECT_WIDENING(aux_3862);
			  }
			  aux_3860 =
			     (((make_procedure_app_48_bglt) CREF(aux_3861))->stack_stamp_31);
		       }
		       aux_3859 =
			  memq___r4_pairs_and_lists_6_3(cowner_3074, aux_3860);
		    }
		    test_3852 =
		       CBOOL(aux_3859);
		 }
	       else
		 {	/* Cfa/procedure.scm 261 */
		    test_3852 = ((bool_t) 1)
		       ;
		 }
	    }
	    if (test_3852)
	      {		/* Cfa/procedure.scm 261 */
		 return BUNSPEC;
	      }
	    else
	      {		/* Cfa/procedure.scm 261 */
		 {	/* Cfa/procedure.scm 265 */
		    obj_t arg2431_3079;
		    {	/* ./Ieee/pair-list.scm 5689 */
		       obj_t aux_3868;
		       {
			  obj_t aux_3869;
			  {	/* ./Cfa/cinfo2.scm 1285 */
			     object_bglt aux_3870;
			     aux_3870 =
				(object_bglt) (alloc_3073);
			     aux_3869 =
				OBJECT_WIDENING(aux_3870);
			  }
			  aux_3868 =
			     (((make_procedure_app_48_bglt) CREF(aux_3869))->stack_stamp_31);
		       }
		       arg2431_3079 =
			  MAKE_PAIR(cowner_3074, aux_3868);
		    }
		    {
		       obj_t aux_3875;
		       {	/* ./Cfa/cinfo2.scm 1285 */
			  object_bglt aux_3876;
			  aux_3876 =
			     (object_bglt) (alloc_3073);
			  aux_3875 =
			     OBJECT_WIDENING(aux_3876);
		       }
		       ((((make_procedure_app_48_bglt) CREF(aux_3875))->stack_stamp_31) = ((obj_t) arg2431_3079), BUNSPEC);
		    }
		 }
		 {	/* Cfa/procedure.scm 266 */
		    bool_t test2433_3081;
		    {	/* Cfa/procedure.scm 266 */
		       bool_t test2434_3082;
		       test2434_3082 =
			  is_a__118___object(cowner_3074, variable_ast_var);
		       if (test2434_3082)
			 {	/* ./Ieee/equiv.scm 5508 */
			    obj_t aux_3882;
			    {	/* Cfa/procedure.scm 266 */
			       variable_bglt aux_3883;
			       {
				  obj_t aux_3884;
				  {	/* ./Cfa/cinfo2.scm 1280 */
				     object_bglt aux_3885;
				     aux_3885 =
					(object_bglt) (alloc_3073);
				     aux_3884 =
					OBJECT_WIDENING(aux_3885);
				  }
				  aux_3883 =
				     (((make_procedure_app_48_bglt) CREF(aux_3884))->owner);
			       }
			       aux_3882 =
				  (obj_t) (aux_3883);
			    }
			    test2433_3081 =
			       (aux_3882 == cowner_3074);
			 }
		       else
			 {	/* Cfa/procedure.scm 266 */
			    test2433_3081 = ((bool_t) 1);
			 }
		    }
		    if (test2433_3081)
		      {		/* Cfa/procedure.scm 266 */
			 {
			    obj_t aux_3892;
			    {	/* ./Cfa/cinfo2.scm 1283 */
			       object_bglt aux_3893;
			       aux_3893 =
				  (object_bglt) (alloc_3073);
			       aux_3892 =
				  OBJECT_WIDENING(aux_3893);
			    }
			    ((((make_procedure_app_48_bglt) CREF(aux_3892))->stackable__42) = ((bool_t) ((bool_t) 0)), BUNSPEC);
			 }
			 stack_loose_procedure_env__187_cfa_procedure(alloc_3073,
			    CNST_TABLE_REF(((long) 0)));
		      }
		    else
		      {		/* Cfa/procedure.scm 266 */
			 stack_loose_procedure_env__187_cfa_procedure(alloc_3073, cowner_3074);
		      }
		 }
		 {	/* Cfa/procedure.scm 272 */
		    variable_bglt v_3085;
		    {	/* Cfa/procedure.scm 273 */
		       var_bglt obj_3685;
		       {	/* Cfa/procedure.scm 273 */
			  obj_t aux_3900;
			  {	/* ./Ieee/pair-list.scm 5701 */
			     obj_t aux_3901;
			     {	/* Cfa/procedure.scm 272 */
				app_bglt obj_3683;
				obj_3683 =
				   (app_bglt) (alloc_3073);
				aux_3901 =
				   (((app_bglt) CREF(obj_3683))->args);
			     }
			     aux_3900 =
				CAR(aux_3901);
			  }
			  obj_3685 =
			     (var_bglt) (aux_3900);
		       }
		       v_3085 =
			  (((var_bglt) CREF(obj_3685))->variable);
		    }
		    {	/* Cfa/procedure.scm 274 */

		       return
			  cfa_export_var__93_cfa_iterate(
			  (((variable_bglt) CREF(v_3085))->value), cowner_3074);
		    }
		 }
	      }
	 }
      }
   }
}



/* loose-alloc!-make-procedure-app2064 */
obj_t 
loose_alloc__make_procedure_app2064_94_cfa_procedure(obj_t env_3721, obj_t alloc_3722)
{
   AN_OBJECT;
   {	/* Cfa/procedure.scm 236 */
      {
	 make_procedure_app_48_bglt alloc_3061;
	 alloc_3061 =
	    (make_procedure_app_48_bglt) (alloc_3722);
	 {	/* Cfa/procedure.scm 240 */
	    bool_t test2426_3065;
	    {	/* Cfa/procedure.scm 240 */
	       long arg2428_3070;
	       {
		  obj_t aux_3910;
		  {	/* ./Cfa/cinfo2.scm 1274 */
		     object_bglt aux_3911;
		     aux_3911 =
			(object_bglt) (alloc_3061);
		     aux_3910 =
			OBJECT_WIDENING(aux_3911);
		  }
		  arg2428_3070 =
		     (((make_procedure_app_48_bglt) CREF(aux_3910))->lost_stamp_114);
	       }
	       {	/* Cfa/procedure.scm 240 */
		  long n2_3663;
		  n2_3663 =
		     (long) CINT(_cfa_stamp__16_cfa_iterate);
		  test2426_3065 =
		     (arg2428_3070 == n2_3663);
	       }
	    }
	    if (test2426_3065)
	      {		/* Cfa/procedure.scm 240 */
		 return BUNSPEC;
	      }
	    else
	      {		/* Cfa/procedure.scm 240 */
		 {	/* Cfa/procedure.scm 244 */
		    long val1790_3665;
		    val1790_3665 =
		       (long) CINT(_cfa_stamp__16_cfa_iterate);
		    {
		       obj_t aux_3919;
		       {	/* ./Cfa/cinfo2.scm 1274 */
			  object_bglt aux_3920;
			  aux_3920 =
			     (object_bglt) (alloc_3061);
			  aux_3919 =
			     OBJECT_WIDENING(aux_3920);
		       }
		       ((((make_procedure_app_48_bglt) CREF(aux_3919))->lost_stamp_114) = ((long) val1790_3665), BUNSPEC);
		    }
		 }
		 {	/* Cfa/procedure.scm 245 */
		    variable_bglt v_3067;
		    {	/* Cfa/procedure.scm 246 */
		       var_bglt obj_3668;
		       {	/* Cfa/procedure.scm 246 */
			  obj_t aux_3924;
			  {	/* ./Ieee/pair-list.scm 5701 */
			     obj_t aux_3925;
			     {	/* Cfa/procedure.scm 245 */
				app_bglt obj_3666;
				obj_3666 =
				   (app_bglt) (alloc_3061);
				aux_3925 =
				   (((app_bglt) CREF(obj_3666))->args);
			     }
			     aux_3924 =
				CAR(aux_3925);
			  }
			  obj_3668 =
			     (var_bglt) (aux_3924);
		       }
		       v_3067 =
			  (((var_bglt) CREF(obj_3668))->variable);
		    }
		    {	/* Cfa/procedure.scm 247 */

		       return
			  cfa_export_var__93_cfa_iterate(
			  (((variable_bglt) CREF(v_3067))->value),
			  (obj_t) (v_3067));
		    }
		 }
	      }
	 }
      }
   }
}



/* cfa!-procedure-set!-app2062 */
obj_t 
cfa__procedure_set__app2062_193_cfa_procedure(obj_t env_3723, obj_t node_3724)
{
   AN_OBJECT;
   {	/* Cfa/procedure.scm 186 */
      {
	 procedure_set__app_32_bglt node_3023;
	 {	/* Cfa/procedure.scm 187 */
	    approx_bglt aux_3935;
	    node_3023 =
	       (procedure_set__app_32_bglt) (node_3724);
	    {	/* Cfa/procedure.scm 188 */
	       node_bglt aux_3936;
	       {	/* Cfa/procedure.scm 188 */
		  obj_t aux_3937;
		  {	/* ./Ieee/pair-list.scm 5701 */
		     obj_t aux_3938;
		     {	/* ./Ieee/pair-list.scm 5707 */
			obj_t aux_3939;
			{	/* Cfa/procedure.scm 188 */
			   app_bglt obj_3625;
			   obj_3625 =
			      (app_bglt) (node_3023);
			   aux_3939 =
			      (((app_bglt) CREF(obj_3625))->args);
			}
			aux_3938 =
			   CDR(aux_3939);
		     }
		     aux_3937 =
			CAR(aux_3938);
		  }
		  aux_3936 =
		     (node_bglt) (aux_3937);
	       }
	       cfa__102_cfa_cfa(aux_3936);
	    }
	    {	/* Cfa/procedure.scm 189 */
	       approx_bglt proc_approx_11_3029;
	       obj_t offset_3030;
	       approx_bglt val_approx_22_3031;
	       {	/* Cfa/procedure.scm 189 */
		  node_bglt aux_3946;
		  {	/* Cfa/procedure.scm 189 */
		     obj_t aux_3947;
		     {	/* ./Ieee/pair-list.scm 5701 */
			obj_t aux_3948;
			{	/* Cfa/procedure.scm 189 */
			   app_bglt obj_3630;
			   obj_3630 =
			      (app_bglt) (node_3023);
			   aux_3948 =
			      (((app_bglt) CREF(obj_3630))->args);
			}
			aux_3947 =
			   CAR(aux_3948);
		     }
		     aux_3946 =
			(node_bglt) (aux_3947);
		  }
		  proc_approx_11_3029 =
		     cfa__102_cfa_cfa(aux_3946);
	       }
	       {	/* Cfa/procedure.scm 190 */
		  node_bglt aux_3954;
		  {	/* Cfa/procedure.scm 190 */
		     obj_t aux_3955;
		     {	/* ./Ieee/pair-list.scm 5701 */
			obj_t aux_3956;
			{	/* ./Ieee/pair-list.scm 5707 */
			   obj_t aux_3957;
			   {	/* Cfa/procedure.scm 190 */
			      app_bglt obj_3632;
			      obj_3632 =
				 (app_bglt) (node_3023);
			      aux_3957 =
				 (((app_bglt) CREF(obj_3632))->args);
			   }
			   aux_3956 =
			      CDR(aux_3957);
			}
			aux_3955 =
			   CAR(aux_3956);
		     }
		     aux_3954 =
			(node_bglt) (aux_3955);
		  }
		  offset_3030 =
		     get_node_atom_value_135_cfa_approx(aux_3954);
	       }
	       {	/* Cfa/procedure.scm 191 */
		  node_bglt aux_3964;
		  {	/* Cfa/procedure.scm 191 */
		     obj_t aux_3965;
		     {	/* ./Ieee/pair-list.scm 5701 */
			obj_t aux_3966;
			{	/* ./Ieee/pair-list.scm 5707 */
			   obj_t aux_3967;
			   {	/* ./Ieee/pair-list.scm 5707 */
			      obj_t aux_3968;
			      {		/* Cfa/procedure.scm 191 */
				 app_bglt obj_3637;
				 obj_3637 =
				    (app_bglt) (node_3023);
				 aux_3968 =
				    (((app_bglt) CREF(obj_3637))->args);
			      }
			      aux_3967 =
				 CDR(aux_3968);
			   }
			   aux_3966 =
			      CDR(aux_3967);
			}
			aux_3965 =
			   CAR(aux_3966);
		     }
		     aux_3964 =
			(node_bglt) (aux_3965);
		  }
		  val_approx_22_3031 =
		     cfa__102_cfa_cfa(aux_3964);
	       }
	       if (
		  (((approx_bglt) CREF(proc_approx_11_3029))->top__138))
		 {	/* Cfa/procedure.scm 198 */
		    approx_bglt aux_3978;
		    aux_3978 =
		       loose__226_cfa_loose(val_approx_22_3031,
		       CNST_TABLE_REF(((long) 0)));
		    (obj_t) (aux_3978);
		 }
	       else
		 {	/* Cfa/procedure.scm 196 */
		    if (
		       INTEGERP(offset_3030))
		      {		/* Cfa/procedure.scm 203 */
			 obj_t _anonymous_2408__207_3704;
			 _anonymous_2408__207_3704 =
			    make_fx_procedure(_anonymous_2408__207_cfa_procedure, ((long) 1), ((long) 2));
			 PROCEDURE_SET(_anonymous_2408__207_3704, ((long) 0), offset_3030);
			 {	/* Cfa/procedure.scm 203 */
			    obj_t aux_3986;
			    aux_3986 =
			       (obj_t) (val_approx_22_3031);
			    PROCEDURE_SET(_anonymous_2408__207_3704, ((long) 1), aux_3986);
			 }
			 for_each_approx_alloc_83_cfa_approx(_anonymous_2408__207_3704, proc_approx_11_3029);
		      }
		    else
		      {		/* Cfa/procedure.scm 214 */
			 obj_t _anonymous_2414__101_3705;
			 _anonymous_2414__101_3705 =
			    make_fx_procedure(_anonymous_2414__101_cfa_procedure, ((long) 1), ((long) 1));
			 {	/* Cfa/procedure.scm 214 */
			    obj_t aux_3991;
			    aux_3991 =
			       (obj_t) (val_approx_22_3031);
			    PROCEDURE_SET(_anonymous_2414__101_3705, ((long) 0), aux_3991);
			 }
			 for_each_approx_alloc_83_cfa_approx(_anonymous_2414__101_3705, proc_approx_11_3029);
		      }
		 }
	       {
		  obj_t aux_3995;
		  {	/* ./Cfa/cinfo2.scm 1287 */
		     object_bglt aux_3996;
		     aux_3996 =
			(object_bglt) (node_3023);
		     aux_3995 =
			OBJECT_WIDENING(aux_3996);
		  }
		  aux_3935 =
		     (((procedure_set__app_32_bglt) CREF(aux_3995))->approx);
	       }
	    }
	    return
	       (obj_t) (aux_3935);
	 }
      }
   }
}



/* <anonymous:2408> */
obj_t 
_anonymous_2408__207_cfa_procedure(obj_t env_3725, obj_t app_3728)
{
   AN_OBJECT;
   {	/* Cfa/procedure.scm 202 */
      {		/* Cfa/procedure.scm 203 */
	 obj_t offset_3726;
	 obj_t val_approx_22_3727;
	 offset_3726 =
	    PROCEDURE_REF(env_3725, ((long) 0));
	 val_approx_22_3727 =
	    PROCEDURE_REF(env_3725, ((long) 1));
	 {
	    obj_t app_3035;
	    app_3035 = app_3728;
	    {	/* Cfa/procedure.scm 203 */
	       bool_t test2409_3037;
	       {	/* Cfa/procedure.scm 203 */
		  bool_t test2411_3039;
		  test2411_3039 =
		     is_a__118___object(app_3035, make_procedure_app_48_cfa_info2);
		  if (test2411_3039)
		    {	/* ./Ieee/fixnum.scm 7115 */
		       long aux_4008;
		       long aux_4006;
		       {	/* Cfa/procedure.scm 204 */
			  make_procedure_app_48_bglt obj_3647;
			  obj_3647 =
			     (make_procedure_app_48_bglt) (app_3035);
			  {
			     obj_t aux_4010;
			     {	/* ./Cfa/cinfo2.scm 1270 */
				object_bglt aux_4011;
				aux_4011 =
				   (object_bglt) (obj_3647);
				aux_4010 =
				   OBJECT_WIDENING(aux_4011);
			     }
			     aux_4008 =
				(((make_procedure_app_48_bglt) CREF(aux_4010))->values_approx_len_106);
			  }
		       }
		       aux_4006 =
			  (long) CINT(offset_3726);
		       test2409_3037 =
			  (aux_4006 < aux_4008);
		    }
		  else
		    {	/* Cfa/procedure.scm 203 */
		       test2409_3037 = ((bool_t) 0);
		    }
	       }
	       if (test2409_3037)
		 {	/* Cfa/procedure.scm 206 */
		    approx_bglt aux_4017;
		    {	/* Cfa/procedure.scm 206 */
		       approx_bglt aux_4018;
		       {	/* Cfa/procedure.scm 206 */
			  make_procedure_app_48_bglt obj_3650;
			  long index_3651;
			  obj_3650 =
			     (make_procedure_app_48_bglt) (app_3035);
			  index_3651 =
			     (long) CINT(offset_3726);
			  {
			     obj_t aux_4021;
			     {	/* ./Cfa/cinfo2.scm 1270 */
				object_bglt aux_4022;
				aux_4022 =
				   (object_bglt) (obj_3650);
				aux_4021 =
				   OBJECT_WIDENING(aux_4022);
			     }
			     aux_4018 =
				(((make_procedure_app_48_bglt) CREF(aux_4021))->values_approx_79)[index_3651];
			  }
		       }
		       aux_4017 =
			  union_approx__241_cfa_approx(aux_4018,
			  (approx_bglt) (val_approx_22_3727));
		    }
		    return
		       (obj_t) (aux_4017);
		 }
	       else
		 {	/* Cfa/procedure.scm 203 */
		    return BUNSPEC;
		 }
	    }
	 }
      }
   }
}



/* <anonymous:2414> */
obj_t 
_anonymous_2414__101_cfa_procedure(obj_t env_3729, obj_t app_3731)
{
   AN_OBJECT;
   {	/* Cfa/procedure.scm 213 */
      {		/* Cfa/procedure.scm 214 */
	 obj_t val_approx_22_3730;
	 val_approx_22_3730 =
	    PROCEDURE_REF(env_3729, ((long) 0));
	 {
	    obj_t app_3043;
	    app_3043 = app_3731;
	    {	/* Cfa/procedure.scm 214 */
	       bool_t test2415_3045;
	       test2415_3045 =
		  is_a__118___object(app_3043, make_procedure_app_48_cfa_info2);
	       if (test2415_3045)
		 {	/* Cfa/procedure.scm 215 */
		    long len_3046;
		    {	/* Cfa/procedure.scm 215 */
		       make_procedure_app_48_bglt obj_3653;
		       obj_3653 =
			  (make_procedure_app_48_bglt) (app_3043);
		       {
			  obj_t aux_4033;
			  {	/* ./Cfa/cinfo2.scm 1270 */
			     object_bglt aux_4034;
			     aux_4034 =
				(object_bglt) (obj_3653);
			     aux_4033 =
				OBJECT_WIDENING(aux_4034);
			  }
			  len_3046 =
			     (((make_procedure_app_48_bglt) CREF(aux_4033))->values_approx_len_106);
		       }
		    }
		    {
		       long i_3047;
		       i_3047 = ((long) 0);
		     loop_3048:
		       if (
			  (i_3047 < len_3046))
			 {	/* Cfa/procedure.scm 218 */
			    {	/* Cfa/procedure.scm 220 */
			       approx_bglt aux_4040;
			       {	/* Cfa/procedure.scm 221 */
				  make_procedure_app_48_bglt obj_3656;
				  obj_3656 =
				     (make_procedure_app_48_bglt) (app_3043);
				  {
				     obj_t aux_4042;
				     {	/* ./Cfa/cinfo2.scm 1270 */
					object_bglt aux_4043;
					aux_4043 =
					   (object_bglt) (obj_3656);
					aux_4042 =
					   OBJECT_WIDENING(aux_4043);
				     }
				     aux_4040 =
					(((make_procedure_app_48_bglt) CREF(aux_4042))->values_approx_79)[i_3047];
				  }
			       }
			       union_approx__241_cfa_approx(aux_4040,
				  (approx_bglt) (val_approx_22_3730));
			    }
			    {
			       long i_4049;
			       i_4049 =
				  (i_3047 + ((long) 1));
			       i_3047 = i_4049;
			       goto loop_3048;
			    }
			 }
		       else
			 {	/* Cfa/procedure.scm 218 */
			    return BUNSPEC;
			 }
		    }
		 }
	       else
		 {	/* Cfa/procedure.scm 214 */
		    return BUNSPEC;
		 }
	    }
	 }
      }
   }
}



/* cfa!-procedure-ref-app2060 */
obj_t 
cfa__procedure_ref_app2060_105_cfa_procedure(obj_t env_3732, obj_t node_3733)
{
   AN_OBJECT;
   {	/* Cfa/procedure.scm 142 */
      {
	 procedure_ref_app_49_bglt node_2984;
	 {	/* Cfa/procedure.scm 143 */
	    approx_bglt aux_4051;
	    node_2984 =
	       (procedure_ref_app_49_bglt) (node_3733);
	    {	/* Cfa/procedure.scm 144 */
	       node_bglt aux_4052;
	       {	/* Cfa/procedure.scm 144 */
		  obj_t aux_4053;
		  {	/* ./Ieee/pair-list.scm 5701 */
		     obj_t aux_4054;
		     {	/* ./Ieee/pair-list.scm 5707 */
			obj_t aux_4055;
			{	/* Cfa/procedure.scm 144 */
			   app_bglt obj_3592;
			   obj_3592 =
			      (app_bglt) (node_2984);
			   aux_4055 =
			      (((app_bglt) CREF(obj_3592))->args);
			}
			aux_4054 =
			   CDR(aux_4055);
		     }
		     aux_4053 =
			CAR(aux_4054);
		  }
		  aux_4052 =
		     (node_bglt) (aux_4053);
	       }
	       cfa__102_cfa_cfa(aux_4052);
	    }
	    {	/* Cfa/procedure.scm 145 */
	       approx_bglt proc_approx_11_2990;
	       obj_t offset_2991;
	       {	/* Cfa/procedure.scm 145 */
		  node_bglt aux_4062;
		  {	/* Cfa/procedure.scm 145 */
		     obj_t aux_4063;
		     {	/* ./Ieee/pair-list.scm 5701 */
			obj_t aux_4064;
			{	/* Cfa/procedure.scm 145 */
			   app_bglt obj_3597;
			   obj_3597 =
			      (app_bglt) (node_2984);
			   aux_4064 =
			      (((app_bglt) CREF(obj_3597))->args);
			}
			aux_4063 =
			   CAR(aux_4064);
		     }
		     aux_4062 =
			(node_bglt) (aux_4063);
		  }
		  proc_approx_11_2990 =
		     cfa__102_cfa_cfa(aux_4062);
	       }
	       {	/* Cfa/procedure.scm 146 */
		  node_bglt aux_4070;
		  {	/* Cfa/procedure.scm 146 */
		     obj_t aux_4071;
		     {	/* ./Ieee/pair-list.scm 5701 */
			obj_t aux_4072;
			{	/* ./Ieee/pair-list.scm 5707 */
			   obj_t aux_4073;
			   {	/* Cfa/procedure.scm 146 */
			      app_bglt obj_3599;
			      obj_3599 =
				 (app_bglt) (node_2984);
			      aux_4073 =
				 (((app_bglt) CREF(obj_3599))->args);
			   }
			   aux_4072 =
			      CDR(aux_4073);
			}
			aux_4071 =
			   CAR(aux_4072);
		     }
		     aux_4070 =
			(node_bglt) (aux_4071);
		  }
		  offset_2991 =
		     get_node_atom_value_135_cfa_approx(aux_4070);
	       }
	       if (
		  (((approx_bglt) CREF(proc_approx_11_2990))->top__138))
		 {	/* Cfa/procedure.scm 151 */
		    approx_bglt aux_4082;
		    {
		       obj_t aux_4083;
		       {	/* ./Cfa/cinfo2.scm 1286 */
			  object_bglt aux_4084;
			  aux_4084 =
			     (object_bglt) (node_2984);
			  aux_4083 =
			     OBJECT_WIDENING(aux_4084);
		       }
		       aux_4082 =
			  (((procedure_ref_app_49_bglt) CREF(aux_4083))->approx);
		    }
		    approx_set_top__187_cfa_approx(aux_4082);
		 }
	       else
		 {	/* Cfa/procedure.scm 150 */
		    BUNSPEC;
		 }
	       if (
		  INTEGERP(offset_2991))
		 {	/* Cfa/procedure.scm 156 */
		    obj_t _anonymous_2384__158_3707;
		    _anonymous_2384__158_3707 =
		       make_fx_procedure(_anonymous_2384__158_cfa_procedure, ((long) 1), ((long) 2));
		    PROCEDURE_SET(_anonymous_2384__158_3707, ((long) 0), offset_2991);
		    {	/* Cfa/procedure.scm 156 */
		       obj_t aux_4093;
		       aux_4093 =
			  (obj_t) (node_2984);
		       PROCEDURE_SET(_anonymous_2384__158_3707, ((long) 1), aux_4093);
		    }
		    for_each_approx_alloc_83_cfa_approx(_anonymous_2384__158_3707, proc_approx_11_2990);
		 }
	       else
		 {	/* Cfa/procedure.scm 170 */
		    obj_t _anonymous_2392__212_3708;
		    _anonymous_2392__212_3708 =
		       make_fx_procedure(_anonymous_2392__212_cfa_procedure, ((long) 1), ((long) 1));
		    {	/* Cfa/procedure.scm 170 */
		       obj_t aux_4098;
		       aux_4098 =
			  (obj_t) (node_2984);
		       PROCEDURE_SET(_anonymous_2392__212_3708, ((long) 0), aux_4098);
		    }
		    for_each_approx_alloc_83_cfa_approx(_anonymous_2392__212_3708, proc_approx_11_2990);
		 }
	       {
		  obj_t aux_4102;
		  {	/* ./Cfa/cinfo2.scm 1286 */
		     object_bglt aux_4103;
		     aux_4103 =
			(object_bglt) (node_2984);
		     aux_4102 =
			OBJECT_WIDENING(aux_4103);
		  }
		  aux_4051 =
		     (((procedure_ref_app_49_bglt) CREF(aux_4102))->approx);
	       }
	    }
	    return
	       (obj_t) (aux_4051);
	 }
      }
   }
}



/* <anonymous:2384> */
obj_t 
_anonymous_2384__158_cfa_procedure(obj_t env_3734, obj_t app_3737)
{
   AN_OBJECT;
   {	/* Cfa/procedure.scm 155 */
      {		/* Cfa/procedure.scm 156 */
	 obj_t offset_3735;
	 obj_t instance2045_3736;
	 offset_3735 =
	    PROCEDURE_REF(env_3734, ((long) 0));
	 instance2045_3736 =
	    PROCEDURE_REF(env_3734, ((long) 1));
	 {
	    obj_t app_2996;
	    app_2996 = app_3737;
	    {	/* Cfa/procedure.scm 156 */
	       bool_t test2385_2998;
	       {	/* Cfa/procedure.scm 156 */
		  bool_t test2389_3002;
		  test2389_3002 =
		     is_a__118___object(app_2996, make_procedure_app_48_cfa_info2);
		  if (test2389_3002)
		    {	/* ./Ieee/fixnum.scm 7115 */
		       long aux_4115;
		       long aux_4113;
		       {	/* Cfa/procedure.scm 157 */
			  make_procedure_app_48_bglt obj_3608;
			  obj_3608 =
			     (make_procedure_app_48_bglt) (app_2996);
			  {
			     obj_t aux_4117;
			     {	/* ./Cfa/cinfo2.scm 1270 */
				object_bglt aux_4118;
				aux_4118 =
				   (object_bglt) (obj_3608);
				aux_4117 =
				   OBJECT_WIDENING(aux_4118);
			     }
			     aux_4115 =
				(((make_procedure_app_48_bglt) CREF(aux_4117))->values_approx_len_106);
			  }
		       }
		       aux_4113 =
			  (long) CINT(offset_3735);
		       test2385_2998 =
			  (aux_4113 < aux_4115);
		    }
		  else
		    {	/* Cfa/procedure.scm 156 */
		       test2385_2998 = ((bool_t) 0);
		    }
	       }
	       if (test2385_2998)
		 {	/* Cfa/procedure.scm 159 */
		    approx_bglt aux_4124;
		    {	/* Cfa/procedure.scm 159 */
		       approx_bglt aux_4132;
		       approx_bglt aux_4125;
		       {	/* Cfa/procedure.scm 160 */
			  make_procedure_app_48_bglt obj_3612;
			  long index_3613;
			  obj_3612 =
			     (make_procedure_app_48_bglt) (app_2996);
			  index_3613 =
			     (long) CINT(offset_3735);
			  {
			     obj_t aux_4135;
			     {	/* ./Cfa/cinfo2.scm 1270 */
				object_bglt aux_4136;
				aux_4136 =
				   (object_bglt) (obj_3612);
				aux_4135 =
				   OBJECT_WIDENING(aux_4136);
			     }
			     aux_4132 =
				(((make_procedure_app_48_bglt) CREF(aux_4135))->values_approx_79)[index_3613];
			  }
		       }
		       {	/* Cfa/procedure.scm 159 */
			  procedure_ref_app_49_bglt obj_3611;
			  obj_3611 =
			     (procedure_ref_app_49_bglt) (instance2045_3736);
			  {
			     obj_t aux_4127;
			     {	/* ./Cfa/cinfo2.scm 1286 */
				object_bglt aux_4128;
				aux_4128 =
				   (object_bglt) (obj_3611);
				aux_4127 =
				   OBJECT_WIDENING(aux_4128);
			     }
			     aux_4125 =
				(((procedure_ref_app_49_bglt) CREF(aux_4127))->approx);
			  }
		       }
		       aux_4124 =
			  union_approx__241_cfa_approx(aux_4125, aux_4132);
		    }
		    return
		       (obj_t) (aux_4124);
		 }
	       else
		 {	/* Cfa/procedure.scm 165 */
		    approx_bglt aux_4142;
		    {	/* Cfa/procedure.scm 165 */
		       procedure_ref_app_49_bglt obj_3614;
		       obj_3614 =
			  (procedure_ref_app_49_bglt) (instance2045_3736);
		       {
			  obj_t aux_4144;
			  {	/* ./Cfa/cinfo2.scm 1286 */
			     object_bglt aux_4145;
			     aux_4145 =
				(object_bglt) (obj_3614);
			     aux_4144 =
				OBJECT_WIDENING(aux_4145);
			  }
			  aux_4142 =
			     (((procedure_ref_app_49_bglt) CREF(aux_4144))->approx);
		       }
		    }
		    return
		       approx_set_top__187_cfa_approx(aux_4142);
		 }
	    }
	 }
      }
   }
}



/* <anonymous:2392> */
obj_t 
_anonymous_2392__212_cfa_procedure(obj_t env_3738, obj_t app_3740)
{
   AN_OBJECT;
   {	/* Cfa/procedure.scm 169 */
      {		/* Cfa/procedure.scm 170 */
	 obj_t instance2045_3739;
	 instance2045_3739 =
	    PROCEDURE_REF(env_3738, ((long) 0));
	 {
	    obj_t app_3006;
	    app_3006 = app_3740;
	    {	/* Cfa/procedure.scm 170 */
	       bool_t test2393_3008;
	       test2393_3008 =
		  is_a__118___object(app_3006, make_procedure_app_48_cfa_info2);
	       if (test2393_3008)
		 {	/* Cfa/procedure.scm 171 */
		    long len_3009;
		    {	/* Cfa/procedure.scm 171 */
		       make_procedure_app_48_bglt obj_3616;
		       obj_3616 =
			  (make_procedure_app_48_bglt) (app_3006);
		       {
			  obj_t aux_4154;
			  {	/* ./Cfa/cinfo2.scm 1270 */
			     object_bglt aux_4155;
			     aux_4155 =
				(object_bglt) (obj_3616);
			     aux_4154 =
				OBJECT_WIDENING(aux_4155);
			  }
			  len_3009 =
			     (((make_procedure_app_48_bglt) CREF(aux_4154))->values_approx_len_106);
		       }
		    }
		    {
		       long i_3010;
		       {	/* Cfa/procedure.scm 172 */
			  approx_bglt aux_4159;
			  i_3010 = ((long) 0);
			loop_3011:
			  if (
			     (i_3010 < len_3009))
			    {	/* Cfa/procedure.scm 173 */
			       {	/* Cfa/procedure.scm 175 */
				  approx_bglt aux_4169;
				  approx_bglt aux_4162;
				  {	/* Cfa/procedure.scm 177 */
				     make_procedure_app_48_bglt obj_3620;
				     obj_3620 =
					(make_procedure_app_48_bglt) (app_3006);
				     {
					obj_t aux_4171;
					{	/* ./Cfa/cinfo2.scm 1270 */
					   object_bglt aux_4172;
					   aux_4172 =
					      (object_bglt) (obj_3620);
					   aux_4171 =
					      OBJECT_WIDENING(aux_4172);
					}
					aux_4169 =
					   (((make_procedure_app_48_bglt) CREF(aux_4171))->values_approx_79)[i_3010];
				     }
				  }
				  {	/* Cfa/procedure.scm 175 */
				     procedure_ref_app_49_bglt obj_3619;
				     obj_3619 =
					(procedure_ref_app_49_bglt) (instance2045_3739);
				     {
					obj_t aux_4164;
					{	/* ./Cfa/cinfo2.scm 1286 */
					   object_bglt aux_4165;
					   aux_4165 =
					      (object_bglt) (obj_3619);
					   aux_4164 =
					      OBJECT_WIDENING(aux_4165);
					}
					aux_4162 =
					   (((procedure_ref_app_49_bglt) CREF(aux_4164))->approx);
				     }
				  }
				  aux_4159 =
				     union_approx__241_cfa_approx(aux_4162, aux_4169);
			       }
			    }
			  else
			    {
			       long i_4177;
			       i_4177 =
				  (i_3010 + ((long) 1));
			       i_3010 = i_4177;
			       goto loop_3011;
			    }
			  return
			     (obj_t) (aux_4159);
		       }
		    }
		 }
	       else
		 {	/* Cfa/procedure.scm 170 */
		    return BUNSPEC;
		 }
	    }
	 }
      }
   }
}



/* cfa!-make-procedure-app2058 */
obj_t 
cfa__make_procedure_app2058_134_cfa_procedure(obj_t env_3741, obj_t node_3742)
{
   AN_OBJECT;
   {	/* Cfa/procedure.scm 121 */
      {
	 make_procedure_app_48_bglt node_2963;
	 {	/* Cfa/procedure.scm 122 */
	    approx_bglt aux_4180;
	    node_2963 =
	       (make_procedure_app_48_bglt) (node_3742);
	    {	/* Cfa/procedure.scm 127 */

	       {	/* Cfa/procedure.scm 134 */
		  approx_bglt aux_4205;
		  approx_bglt aux_4181;
		  {
		     obj_t aux_4206;
		     {	/* ./Cfa/cinfo2.scm 1266 */
			object_bglt aux_4207;
			aux_4207 =
			   (object_bglt) (node_2963);
			aux_4206 =
			   OBJECT_WIDENING(aux_4207);
		     }
		     aux_4205 =
			(((make_procedure_app_48_bglt) CREF(aux_4206))->approx);
		  }
		  {	/* Cfa/procedure.scm 134 */
		     svar_cinfo_166_bglt obj_3585;
		     {	/* Cfa/procedure.scm 134 */
			value_bglt aux_4182;
			{	/* Cfa/procedure.scm 134 */
			   local_bglt obj_3584;
			   {	/* Cfa/procedure.scm 134 */
			      obj_t aux_4183;
			      {		/* ./Ieee/pair-list.scm 5701 */
				 obj_t aux_4184;
				 {	/* Cfa/procedure.scm 127 */
				    sfun_bglt obj_3582;
				    {	/* Cfa/procedure.scm 127 */
				       value_bglt aux_4185;
				       {	/* Cfa/procedure.scm 126 */
					  variable_bglt arg2371_2974;
					  {	/* Cfa/procedure.scm 126 */
					     var_bglt obj_3580;
					     {	/* Cfa/procedure.scm 126 */
						obj_t aux_4186;
						{	/* ./Ieee/pair-list.scm 5701 */
						   obj_t aux_4187;
						   {	/* Cfa/procedure.scm 125 */
						      app_bglt obj_3578;
						      obj_3578 =
							 (app_bglt) (node_2963);
						      aux_4187 =
							 (((app_bglt) CREF(obj_3578))->args);
						   }
						   aux_4186 =
						      CAR(aux_4187);
						}
						obj_3580 =
						   (var_bglt) (aux_4186);
					     }
					     arg2371_2974 =
						(((var_bglt) CREF(obj_3580))->variable);
					  }
					  aux_4185 =
					     (((variable_bglt) CREF(arg2371_2974))->value);
				       }
				       obj_3582 =
					  (sfun_bglt) (aux_4185);
				    }
				    aux_4184 =
				       (((sfun_bglt) CREF(obj_3582))->args);
				 }
				 aux_4183 =
				    CAR(aux_4184);
			      }
			      obj_3584 =
				 (local_bglt) (aux_4183);
			   }
			   aux_4182 =
			      (((local_bglt) CREF(obj_3584))->value);
			}
			obj_3585 =
			   (svar_cinfo_166_bglt) (aux_4182);
		     }
		     {
			obj_t aux_4200;
			{	/* ./Cfa/cinfo.scm 1193 */
			   object_bglt aux_4201;
			   aux_4201 =
			      (object_bglt) (obj_3585);
			   aux_4200 =
			      OBJECT_WIDENING(aux_4201);
			}
			aux_4181 =
			   (((svar_cinfo_166_bglt) CREF(aux_4200))->approx);
		     }
		  }
		  union_approx__241_cfa_approx(aux_4181, aux_4205);
	       }
	    }
	    {
	       obj_t l2043_2976;
	       {	/* Cfa/procedure.scm 136 */
		  app_bglt obj_3587;
		  obj_3587 =
		     (app_bglt) (node_2963);
		  l2043_2976 =
		     (((app_bglt) CREF(obj_3587))->args);
	       }
	     lname2044_2977:
	       if (
		  PAIRP(l2043_2976))
		 {	/* Cfa/procedure.scm 136 */
		    {	/* Cfa/procedure.scm 136 */
		       node_bglt aux_4214;
		       {	/* Cfa/procedure.scm 136 */
			  obj_t aux_4215;
			  aux_4215 =
			     CAR(l2043_2976);
			  aux_4214 =
			     (node_bglt) (aux_4215);
		       }
		       cfa__102_cfa_cfa(aux_4214);
		    }
		    {
		       obj_t l2043_4219;
		       l2043_4219 =
			  CDR(l2043_2976);
		       l2043_2976 = l2043_4219;
		       goto lname2044_2977;
		    }
		 }
	       else
		 {	/* Cfa/procedure.scm 136 */
		    ((bool_t) 1);
		 }
	    }
	    {
	       obj_t aux_4223;
	       {	/* ./Cfa/cinfo2.scm 1266 */
		  object_bglt aux_4224;
		  aux_4224 =
		     (object_bglt) (node_2963);
		  aux_4223 =
		     OBJECT_WIDENING(aux_4224);
	       }
	       aux_4180 =
		  (((make_procedure_app_48_bglt) CREF(aux_4223))->approx);
	    }
	    return
	       (obj_t) (aux_4180);
	 }
      }
   }
}



/* node-setup!-pre-procedure-set!-app2056 */
obj_t 
node_setup__pre_procedure_set__app2056_189_cfa_procedure(obj_t env_3743, obj_t node_3744)
{
   AN_OBJECT;
   {	/* Cfa/procedure.scm 110 */
      {
	 pre_procedure_set__app_208_bglt node_2947;
	 {	/* Cfa/procedure.scm 110 */
	    procedure_set__app_32_bglt aux_4230;
	    node_2947 =
	       (pre_procedure_set__app_208_bglt) (node_3744);
	    add_procedure_ref__36_cfa_closure(
	       (node_bglt) (node_2947));
	    {	/* Cfa/procedure.scm 113 */
	       obj_t aux_4233;
	       {	/* Cfa/procedure.scm 113 */
		  app_bglt obj_3560;
		  obj_3560 =
		     (app_bglt) (node_2947);
		  aux_4233 =
		     (((app_bglt) CREF(obj_3560))->args);
	       }
	       node_setup___185_cfa_setup(aux_4233);
	    }
	    {	/* Cfa/procedure.scm 114 */
	       pre_procedure_set__app_208_bglt node_2952;
	       {	/* Cfa/procedure.scm 114 */
		  long arg2363_2958;
		  {	/* Cfa/procedure.scm 114 */
		     obj_t arg2364_2959;
		     {	/* Cfa/procedure.scm 114 */
			obj_t arg2365_2960;
			{	/* Cfa/procedure.scm 114 */
			   object_bglt object_3561;
			   object_3561 =
			      (object_bglt) (node_2947);
			   {	/* ./Llib/object.scm 2695 */
			      long arg1179_3562;
			      {		/* ./Llib/object.scm 2695 */
				 long arg1180_3563;
				 long arg1181_3564;
				 arg1180_3563 =
				    TYPE(object_3561);
				 arg1181_3564 =
				    OBJECT_TYPE;
				 arg1179_3562 =
				    (arg1180_3563 - arg1181_3564);
			      }
			      {		/* ./Llib/object.scm 2695 */
				 obj_t vector_3568;
				 vector_3568 = _classes__134___object;
				 arg2365_2960 =
				    VECTOR_REF(vector_3568, arg1179_3562);
			      }
			   }
			}
			arg2364_2959 =
			   class_super_145___object(arg2365_2960);
		     }
		     arg2363_2958 =
			class_num_218___object(arg2364_2959);
		  }
		  {	/* Cfa/procedure.scm 114 */
		     obj_t obj_3570;
		     obj_3570 =
			(obj_t) (node_2947);
		     (((obj_t) CREF(obj_3570))->header = MAKE_HEADER(arg2363_2958, 0), BUNSPEC);
		  }
	       }
	       {	/* Cfa/procedure.scm 114 */
		  object_bglt aux_4246;
		  aux_4246 =
		     (object_bglt) (node_2947);
		  OBJECT_WIDENING_SET(aux_4246, BFALSE);
	       }
	       node_2952 = node_2947;
	       {	/* Cfa/procedure.scm 115 */
		  procedure_set__app_32_bglt obj2041_2953;
		  obj2041_2953 =
		     ((procedure_set__app_32_bglt) (node_2952));
		  {	/* Cfa/procedure.scm 116 */
		     procedure_set__app_32_bglt arg2360_2954;
		     {	/* Cfa/procedure.scm 116 */
			approx_bglt arg2361_2955;
			arg2361_2955 =
			   make_type_approx_184_cfa_approx(
			   (type_bglt) (_unspec__87_type_cache));
			{	/* Cfa/procedure.scm 115 */
			   procedure_set__app_32_bglt res2448_3575;
			   {	/* ./Cfa/cinfo2.scm 1287 */
			      procedure_set__app_32_bglt new1829_3573;
			      new1829_3573 =
				 ((procedure_set__app_32_bglt) BREF(GC_MALLOC(sizeof(struct procedure_set__app_32))));
			      ((((procedure_set__app_32_bglt) CREF(new1829_3573))->approx) = ((approx_bglt) arg2361_2955), BUNSPEC);
			      res2448_3575 = new1829_3573;
			   }
			   arg2360_2954 = res2448_3575;
			}
		     }
		     {	/* Cfa/procedure.scm 115 */
			obj_t aux_4256;
			object_bglt aux_4254;
			aux_4256 =
			   (obj_t) (arg2360_2954);
			aux_4254 =
			   (object_bglt) (obj2041_2953);
			OBJECT_WIDENING_SET(aux_4254, aux_4256);
		     }
		  }
		  {	/* Cfa/procedure.scm 115 */
		     long arg2362_2956;
		     arg2362_2956 =
			class_num_218___object(procedure_set__app_32_cfa_info2);
		     {	/* Cfa/procedure.scm 115 */
			obj_t obj_3576;
			obj_3576 =
			   (obj_t) (obj2041_2953);
			(((obj_t) CREF(obj_3576))->header = MAKE_HEADER(arg2362_2956, 0), BUNSPEC);
		     }
		  }
		  aux_4230 = obj2041_2953;
	       }
	    }
	    return
	       (obj_t) (aux_4230);
	 }
      }
   }
}



/* node-setup!-pre-procedure-ref-app2054 */
obj_t 
node_setup__pre_procedure_ref_app2054_153_cfa_procedure(obj_t env_3745, obj_t node_3746)
{
   AN_OBJECT;
   {	/* Cfa/procedure.scm 99 */
      {
	 pre_procedure_ref_app_85_bglt node_2931;
	 {	/* Cfa/procedure.scm 99 */
	    procedure_ref_app_49_bglt aux_4264;
	    node_2931 =
	       (pre_procedure_ref_app_85_bglt) (node_3746);
	    add_procedure_ref__36_cfa_closure(
	       (node_bglt) (node_2931));
	    {	/* Cfa/procedure.scm 102 */
	       obj_t aux_4267;
	       {	/* Cfa/procedure.scm 102 */
		  app_bglt obj_3542;
		  obj_3542 =
		     (app_bglt) (node_2931);
		  aux_4267 =
		     (((app_bglt) CREF(obj_3542))->args);
	       }
	       node_setup___185_cfa_setup(aux_4267);
	    }
	    {	/* Cfa/procedure.scm 103 */
	       pre_procedure_ref_app_85_bglt node_2936;
	       {	/* Cfa/procedure.scm 103 */
		  long arg2355_2942;
		  {	/* Cfa/procedure.scm 103 */
		     obj_t arg2356_2943;
		     {	/* Cfa/procedure.scm 103 */
			obj_t arg2357_2944;
			{	/* Cfa/procedure.scm 103 */
			   object_bglt object_3543;
			   object_3543 =
			      (object_bglt) (node_2931);
			   {	/* ./Llib/object.scm 2695 */
			      long arg1179_3544;
			      {		/* ./Llib/object.scm 2695 */
				 long arg1180_3545;
				 long arg1181_3546;
				 arg1180_3545 =
				    TYPE(object_3543);
				 arg1181_3546 =
				    OBJECT_TYPE;
				 arg1179_3544 =
				    (arg1180_3545 - arg1181_3546);
			      }
			      {		/* ./Llib/object.scm 2695 */
				 obj_t vector_3550;
				 vector_3550 = _classes__134___object;
				 arg2357_2944 =
				    VECTOR_REF(vector_3550, arg1179_3544);
			      }
			   }
			}
			arg2356_2943 =
			   class_super_145___object(arg2357_2944);
		     }
		     arg2355_2942 =
			class_num_218___object(arg2356_2943);
		  }
		  {	/* Cfa/procedure.scm 103 */
		     obj_t obj_3552;
		     obj_3552 =
			(obj_t) (node_2931);
		     (((obj_t) CREF(obj_3552))->header = MAKE_HEADER(arg2355_2942, 0), BUNSPEC);
		  }
	       }
	       {	/* Cfa/procedure.scm 103 */
		  object_bglt aux_4280;
		  aux_4280 =
		     (object_bglt) (node_2931);
		  OBJECT_WIDENING_SET(aux_4280, BFALSE);
	       }
	       node_2936 = node_2931;
	       {	/* Cfa/procedure.scm 104 */
		  procedure_ref_app_49_bglt obj2038_2937;
		  obj2038_2937 =
		     ((procedure_ref_app_49_bglt) (node_2936));
		  {	/* Cfa/procedure.scm 105 */
		     procedure_ref_app_49_bglt arg2352_2938;
		     {	/* Cfa/procedure.scm 105 */
			approx_bglt arg2353_2939;
			arg2353_2939 =
			   make_type_approx_184_cfa_approx(
			   (type_bglt) (_obj__252_type_cache));
			{	/* Cfa/procedure.scm 104 */
			   procedure_ref_app_49_bglt res2447_3557;
			   {	/* ./Cfa/cinfo2.scm 1286 */
			      procedure_ref_app_49_bglt new1817_3555;
			      new1817_3555 =
				 ((procedure_ref_app_49_bglt) BREF(GC_MALLOC(sizeof(struct procedure_ref_app_49))));
			      ((((procedure_ref_app_49_bglt) CREF(new1817_3555))->approx) = ((approx_bglt) arg2353_2939), BUNSPEC);
			      res2447_3557 = new1817_3555;
			   }
			   arg2352_2938 = res2447_3557;
			}
		     }
		     {	/* Cfa/procedure.scm 104 */
			obj_t aux_4290;
			object_bglt aux_4288;
			aux_4290 =
			   (obj_t) (arg2352_2938);
			aux_4288 =
			   (object_bglt) (obj2038_2937);
			OBJECT_WIDENING_SET(aux_4288, aux_4290);
		     }
		  }
		  {	/* Cfa/procedure.scm 104 */
		     long arg2354_2940;
		     arg2354_2940 =
			class_num_218___object(procedure_ref_app_49_cfa_info2);
		     {	/* Cfa/procedure.scm 104 */
			obj_t obj_3558;
			obj_3558 =
			   (obj_t) (obj2038_2937);
			(((obj_t) CREF(obj_3558))->header = MAKE_HEADER(arg2354_2940, 0), BUNSPEC);
		     }
		  }
		  aux_4264 = obj2038_2937;
	       }
	    }
	    return
	       (obj_t) (aux_4264);
	 }
      }
   }
}



/* node-setup!-pre-make-procedure-app2052 */
obj_t 
node_setup__pre_make_procedure_app2052_122_cfa_procedure(obj_t env_3747, obj_t node_3748)
{
   AN_OBJECT;
   {	/* Cfa/procedure.scm 48 */
      {
	 pre_make_procedure_app_60_bglt node_2883;
	 node_2883 =
	    (pre_make_procedure_app_60_bglt) (node_3748);
	 {

	    add_make_procedure__219_cfa_closure(
	       (node_bglt) (node_2883));
	    {	/* Cfa/procedure.scm 51 */
	       obj_t aux_4300;
	       {	/* Cfa/procedure.scm 51 */
		  app_bglt obj_3460;
		  obj_3460 =
		     (app_bglt) (node_2883);
		  aux_4300 =
		     (((app_bglt) CREF(obj_3460))->args);
	       }
	       node_setup___185_cfa_setup(aux_4300);
	    }
	    {	/* Cfa/procedure.scm 52 */
	       variable_bglt owner_2888;
	       {
		  obj_t aux_4304;
		  {	/* ./Cfa/cinfo2.scm 1262 */
		     object_bglt aux_4305;
		     aux_4305 =
			(object_bglt) (node_2883);
		     aux_4304 =
			OBJECT_WIDENING(aux_4305);
		  }
		  owner_2888 =
		     (((pre_make_procedure_app_60_bglt) CREF(aux_4304))->owner);
	       }
	       {	/* Cfa/procedure.scm 52 */
		  pre_make_procedure_app_60_bglt node_2889;
		  {	/* Cfa/procedure.scm 53 */
		     long arg2347_2926;
		     {	/* Cfa/procedure.scm 53 */
			obj_t arg2348_2927;
			{	/* Cfa/procedure.scm 53 */
			   obj_t arg2349_2928;
			   {	/* Cfa/procedure.scm 53 */
			      object_bglt object_3462;
			      object_3462 =
				 (object_bglt) (node_2883);
			      {		/* ./Llib/object.scm 2695 */
				 long arg1179_3463;
				 {	/* ./Llib/object.scm 2695 */
				    long arg1180_3464;
				    long arg1181_3465;
				    arg1180_3464 =
				       TYPE(object_3462);
				    arg1181_3465 =
				       OBJECT_TYPE;
				    arg1179_3463 =
				       (arg1180_3464 - arg1181_3465);
				 }
				 {	/* ./Llib/object.scm 2695 */
				    obj_t vector_3469;
				    vector_3469 = _classes__134___object;
				    arg2349_2928 =
				       VECTOR_REF(vector_3469, arg1179_3463);
				 }
			      }
			   }
			   arg2348_2927 =
			      class_super_145___object(arg2349_2928);
			}
			arg2347_2926 =
			   class_num_218___object(arg2348_2927);
		     }
		     {	/* Cfa/procedure.scm 53 */
			obj_t obj_3471;
			obj_3471 =
			   (obj_t) (node_2883);
			(((obj_t) CREF(obj_3471))->header = MAKE_HEADER(arg2347_2926, 0), BUNSPEC);
		     }
		  }
		  {	/* Cfa/procedure.scm 53 */
		     object_bglt aux_4318;
		     aux_4318 =
			(object_bglt) (node_2883);
		     OBJECT_WIDENING_SET(aux_4318, BFALSE);
		  }
		  node_2889 = node_2883;
		  {	/* Cfa/procedure.scm 53 */

		     {	/* Cfa/procedure.scm 54 */
			obj_t proc_size_203_2890;
			obj_t proc_2891;
			{	/* Cfa/procedure.scm 54 */
			   node_bglt aux_4321;
			   {	/* Cfa/procedure.scm 54 */
			      obj_t aux_4322;
			      {		/* ./Ieee/pair-list.scm 5701 */
				 obj_t aux_4323;
				 {	/* ./Ieee/pair-list.scm 5707 */
				    obj_t aux_4324;
				    {	/* ./Ieee/pair-list.scm 5707 */
				       obj_t aux_4325;
				       {	/* Cfa/procedure.scm 54 */
					  app_bglt obj_3473;
					  obj_3473 =
					     (app_bglt) (node_2883);
					  aux_4325 =
					     (((app_bglt) CREF(obj_3473))->args);
				       }
				       aux_4324 =
					  CDR(aux_4325);
				    }
				    aux_4323 =
				       CDR(aux_4324);
				 }
				 aux_4322 =
				    CAR(aux_4323);
			      }
			      aux_4321 =
				 (node_bglt) (aux_4322);
			   }
			   proc_size_203_2890 =
			      get_node_atom_value_135_cfa_approx(aux_4321);
			}
			{	/* ./Ieee/pair-list.scm 5701 */
			   obj_t aux_4333;
			   {	/* Cfa/procedure.scm 55 */
			      app_bglt obj_3480;
			      obj_3480 =
				 (app_bglt) (node_2883);
			      aux_4333 =
				 (((app_bglt) CREF(obj_3480))->args);
			   }
			   proc_2891 =
			      CAR(aux_4333);
			}
			{	/* Cfa/procedure.scm 56 */
			   bool_t test2321_2892;
			   if (
			      INTEGERP(proc_size_203_2890))
			     {	/* Cfa/procedure.scm 57 */
				bool_t test2341_2919;
				test2341_2919 =
				   is_a__118___object(proc_2891, var_ast_node);
				if (test2341_2919)
				  {	/* ./Ast/var.scm 904 */
				     obj_t aux_4341;
				     {	/* Cfa/procedure.scm 58 */
					value_bglt aux_4342;
					{	/* Cfa/procedure.scm 58 */
					   variable_bglt arg2343_2921;
					   {	/* Cfa/procedure.scm 58 */
					      var_bglt obj_3484;
					      obj_3484 =
						 (var_bglt) (proc_2891);
					      arg2343_2921 =
						 (((var_bglt) CREF(obj_3484))->variable);
					   }
					   aux_4342 =
					      (((variable_bglt) CREF(arg2343_2921))->value);
					}
					aux_4341 =
					   (obj_t) (aux_4342);
				     }
				     test2321_2892 =
					is_a__118___object(aux_4341, fun_ast_var);
				  }
				else
				  {	/* Cfa/procedure.scm 57 */
				     test2321_2892 = ((bool_t) 0);
				  }
			     }
			   else
			     {	/* Cfa/procedure.scm 56 */
				test2321_2892 = ((bool_t) 0);
			     }
			   if (test2321_2892)
			     {	/* Cfa/procedure.scm 59 */
				make_procedure_app_48_bglt node_2893;
				{	/* Cfa/procedure.scm 59 */
				   make_procedure_app_48_bglt obj2034_2909;
				   obj2034_2909 =
				      ((make_procedure_app_48_bglt) (node_2889));
				   {	/* Cfa/procedure.scm 61 */
				      make_procedure_app_48_bglt arg2332_2910;
				      {		/* Cfa/procedure.scm 61 */
					 approx_bglt arg2333_2911;
					 approx_bglt arg2335_2913;
					 arg2333_2911 =
					    make_empty_approx_131_cfa_approx();
					 arg2335_2913 =
					    make_empty_approx_131_cfa_approx();
					 {	/* Cfa/procedure.scm 59 */
					    make_procedure_app_48_bglt res2445_3516;
					    {	/* Cfa/procedure.scm 59 */
					       long values_approx_len_106_3488;
					       values_approx_len_106_3488 =
						  (long) CINT(proc_size_203_2890);
					       {	/* ./Cfa/cinfo2.scm 1266 */
						  make_procedure_app_48_bglt new1796_3497;
						  new1796_3497 =
						     ((make_procedure_app_48_bglt) BREF(GC_MALLOC(sizeof(struct make_procedure_app_48))));
						  ((((make_procedure_app_48_bglt) CREF(new1796_3497))->approx) = ((approx_bglt) arg2333_2911), BUNSPEC);
						  ((((make_procedure_app_48_bglt) CREF(new1796_3497))->values_approx_len_106) = ((long) values_approx_len_106_3488), BUNSPEC);
						  ((((make_procedure_app_48_bglt) CREF(new1796_3497))->values_approx_79) = ((approx_bglt *)
							GC_MALLOC(sizeof(struct approx) * values_approx_len_106_3488)), BUNSPEC);
						  {
						     long i1797_3509;
						     i1797_3509 = ((long) 0);
						   loop1800_3508:
						     if (
							(i1797_3509 == values_approx_len_106_3488))
						       {	/* ./Cfa/cinfo2.scm 1266 */
							  CNST_TABLE_REF(((long) 1));
						       }
						     else
						       {	/* ./Cfa/cinfo2.scm 1266 */
							  ((((make_procedure_app_48_bglt) CREF(new1796_3497))->values_approx_79)[i1797_3509] = ((approx_bglt) arg2335_2913), BUNSPEC);
							  {
							     long i1797_4362;
							     i1797_4362 =
								(i1797_3509 + ((long) 1));
							     i1797_3509 = i1797_4362;
							     goto loop1800_3508;
							  }
						       }
						  }
						  ((((make_procedure_app_48_bglt) CREF(new1796_3497))->lost_stamp_114) = ((long) ((long) -1)), BUNSPEC);
						  ((((make_procedure_app_48_bglt) CREF(new1796_3497))->x_t__142) = ((bool_t) ((bool_t) 1)), BUNSPEC);
						  ((((make_procedure_app_48_bglt) CREF(new1796_3497))->x) = ((bool_t) ((bool_t) 0)), BUNSPEC);
						  ((((make_procedure_app_48_bglt) CREF(new1796_3497))->t) = ((bool_t) ((bool_t) 0)), BUNSPEC);
						  ((((make_procedure_app_48_bglt) CREF(new1796_3497))->owner) = ((variable_bglt) owner_2888), BUNSPEC);
						  ((((make_procedure_app_48_bglt) CREF(new1796_3497))->stackable__42) = ((bool_t) ((bool_t) 1)), BUNSPEC);
						  ((((make_procedure_app_48_bglt) CREF(new1796_3497))->stack_stamp_31) = ((obj_t) BNIL), BUNSPEC);
						  res2445_3516 = new1796_3497;
					       }
					    }
					    arg2332_2910 = res2445_3516;
					 }
				      }
				      {		/* Cfa/procedure.scm 59 */
					 obj_t aux_4373;
					 object_bglt aux_4371;
					 aux_4373 =
					    (obj_t) (arg2332_2910);
					 aux_4371 =
					    (object_bglt) (obj2034_2909);
					 OBJECT_WIDENING_SET(aux_4371, aux_4373);
				      }
				   }
				   {	/* Cfa/procedure.scm 59 */
				      long arg2339_2917;
				      arg2339_2917 =
					 class_num_218___object(make_procedure_app_48_cfa_info2);
				      {		/* Cfa/procedure.scm 59 */
					 obj_t obj_3517;
					 obj_3517 =
					    (obj_t) (obj2034_2909);
					 (((obj_t) CREF(obj_3517))->header = MAKE_HEADER(arg2339_2917, 0), BUNSPEC);
				      }
				   }
				   node_2893 = obj2034_2909;
				}
				{	/* Cfa/procedure.scm 68 */
				   approx_bglt arg2322_2894;
				   arg2322_2894 =
				      make_type_alloc_approx_134_cfa_approx(
				      (type_bglt) (_procedure__226_type_cache),
				      (node_bglt) (node_2893));
				   {
				      obj_t aux_4382;
				      {		/* ./Cfa/cinfo2.scm 1266 */
					 object_bglt aux_4383;
					 aux_4383 =
					    (object_bglt) (node_2893);
					 aux_4382 =
					    OBJECT_WIDENING(aux_4383);
				      }
				      ((((make_procedure_app_48_bglt) CREF(aux_4382))->approx) = ((approx_bglt) arg2322_2894), BUNSPEC);
				   }
				}
				{	/* Cfa/procedure.scm 73 */
				   value_bglt vclo_2896;
				   {	/* Cfa/procedure.scm 76 */
				      local_bglt obj_3525;
				      {		/* Cfa/procedure.scm 76 */
					 obj_t aux_4387;
					 {	/* ./Ieee/pair-list.scm 5701 */
					    obj_t aux_4388;
					    {	/* Cfa/procedure.scm 73 */
					       sfun_bglt obj_3523;
					       {	/* Cfa/procedure.scm 73 */
						  value_bglt aux_4389;
						  {	/* Cfa/procedure.scm 75 */
						     variable_bglt arg2328_2903;
						     {	/* Cfa/procedure.scm 75 */
							var_bglt obj_3521;
							obj_3521 =
							   (var_bglt) (proc_2891);
							arg2328_2903 =
							   (((var_bglt) CREF(obj_3521))->variable);
						     }
						     aux_4389 =
							(((variable_bglt) CREF(arg2328_2903))->value);
						  }
						  obj_3523 =
						     (sfun_bglt) (aux_4389);
					       }
					       aux_4388 =
						  (((sfun_bglt) CREF(obj_3523))->args);
					    }
					    aux_4387 =
					       CAR(aux_4388);
					 }
					 obj_3525 =
					    (local_bglt) (aux_4387);
				      }
				      vclo_2896 =
					 (((local_bglt) CREF(obj_3525))->value);
				   }
				   {	/* Cfa/procedure.scm 76 */

				      {		/* Cfa/procedure.scm 77 */
					 bool_t test2323_2897;
					 test2323_2897 =
					    is_a__118___object(
					    (obj_t) (vclo_2896), svar_cinfo_166_cfa_info);
					 if (test2323_2897)
					   {	/* Cfa/procedure.scm 77 */
					      {		/* Cfa/procedure.scm 81 */
						 svar_cinfo_166_bglt obj_3527;
						 obj_3527 =
						    (svar_cinfo_166_bglt) (vclo_2896);
						 {
						    obj_t aux_4402;
						    {	/* ./Cfa/cinfo.scm 1197 */
						       object_bglt aux_4403;
						       aux_4403 =
							  (object_bglt) (obj_3527);
						       aux_4402 =
							  OBJECT_WIDENING(aux_4403);
						    }
						    ((((svar_cinfo_166_bglt) CREF(aux_4402))->clo_env__87) = ((bool_t) ((bool_t) 1)), BUNSPEC);
						 }
					      }
					   }
					 else
					   {	/* Cfa/procedure.scm 82 */
					      pre_clo_env_191_bglt obj2035_2898;
					      obj2035_2898 =
						 ((pre_clo_env_191_bglt) (vclo_2896));
					      {		/* Cfa/procedure.scm 82 */
						 obj_t aux_4410;
						 object_bglt aux_4408;
						 {	/* Cfa/procedure.scm 82 */
						    pre_clo_env_191_bglt aux_4411;
						    {	/* ./Cfa/cinfo.scm 1191 */

						       aux_4411 =
							  ((pre_clo_env_191_bglt) BREF(GC_MALLOC(sizeof(struct pre_clo_env_191))));
						    }
						    aux_4410 =
						       (obj_t) (aux_4411);
						 }
						 aux_4408 =
						    (object_bglt) (obj2035_2898);
						 OBJECT_WIDENING_SET(aux_4408, aux_4410);
					      }
					      {		/* Cfa/procedure.scm 82 */
						 long arg2325_2900;
						 arg2325_2900 =
						    class_num_218___object(pre_clo_env_191_cfa_info);
						 {	/* Cfa/procedure.scm 82 */
						    obj_t obj_3531;
						    obj_3531 =
						       (obj_t) (obj2035_2898);
						    (((obj_t) CREF(obj_3531))->header = MAKE_HEADER(arg2325_2900, 0), BUNSPEC);
						 }
					      }
					      (obj_t) (obj2035_2898);
					   }
				      }
				   }
				}
				{
				   long i_2904;
				   i_2904 = ((long) 0);
				 loop_2905:
				   {	/* Cfa/procedure.scm 85 */
				      bool_t test_4419;
				      {		/* ./Ieee/fixnum.scm 7115 */
					 long aux_4420;
					 aux_4420 =
					    (long) CINT(proc_size_203_2890);
					 test_4419 =
					    (i_2904 < aux_4420);
				      }
				      if (test_4419)
					{	/* Cfa/procedure.scm 85 */
					   {	/* Cfa/procedure.scm 90 */
					      approx_bglt arg2330_2907;
					      arg2330_2907 =
						 make_type_approx_184_cfa_approx(
						 (type_bglt) (_obj__252_type_cache));
					      {
						 obj_t aux_4425;
						 {	/* ./Cfa/cinfo2.scm 1270 */
						    object_bglt aux_4426;
						    aux_4426 =
						       (object_bglt) (node_2893);
						    aux_4425 =
						       OBJECT_WIDENING(aux_4426);
						 }
						 ((((make_procedure_app_48_bglt) CREF(aux_4425))->values_approx_79)[i_2904] = ((approx_bglt) arg2330_2907), BUNSPEC);
					      }
					   }
					   {
					      long i_4430;
					      i_4430 =
						 (i_2904 + ((long) 1));
					      i_2904 = i_4430;
					      goto loop_2905;
					   }
					}
				      else
					{	/* Cfa/procedure.scm 85 */
					   return BUNSPEC;
					}
				   }
				}
			     }
			   else
			     {	/* Cfa/procedure.scm 56 */
				{	/* Cfa/procedure.scm 48 */
				   obj_t next_method2051_180_2929;
				   next_method2051_180_2929 =
				      find_super_class_method_167___object(
				      (object_bglt) (node_2883), node_setup__env_214_cfa_setup, pre_make_procedure_app_60_cfa_info2);
				   if (
				      PROCEDUREP(next_method2051_180_2929))
				     {	/* Cfa/procedure.scm 48 */
					return
					   PROCEDURE_ENTRY(next_method2051_180_2929) (next_method2051_180_2929,
					   (obj_t) (node_2883), BEOA);
				     }
				   else
				     {	/* Cfa/procedure.scm 48 */
					PROCEDURE_SET(node_setup__env_214_cfa_setup, ((long) 2), next_method2051_180_2929);
					return
					   node_setup__189_cfa_setup(
					   (node_bglt) (node_2883));
				     }
				}
			     }
			}
		     }
		  }
	       }
	    }
	 }
      }
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_cfa_procedure()
{
   AN_OBJECT;
   {	/* Cfa/procedure.scm 14 */
      module_initialization_70_tools_trace(((long) 0), "CFA_PROCEDURE");
      module_initialization_70_tools_error(((long) 0), "CFA_PROCEDURE");
      module_initialization_70_tools_shape(((long) 0), "CFA_PROCEDURE");
      module_initialization_70_type_type(((long) 0), "CFA_PROCEDURE");
      module_initialization_70_type_cache(((long) 0), "CFA_PROCEDURE");
      module_initialization_70_ast_var(((long) 0), "CFA_PROCEDURE");
      module_initialization_70_ast_node(((long) 0), "CFA_PROCEDURE");
      module_initialization_70_cfa_info(((long) 0), "CFA_PROCEDURE");
      module_initialization_70_cfa_info2(((long) 0), "CFA_PROCEDURE");
      module_initialization_70_cfa_loose(((long) 0), "CFA_PROCEDURE");
      module_initialization_70_cfa_setup(((long) 0), "CFA_PROCEDURE");
      module_initialization_70_cfa_approx(((long) 0), "CFA_PROCEDURE");
      module_initialization_70_cfa_cfa(((long) 0), "CFA_PROCEDURE");
      module_initialization_70_cfa_iterate(((long) 0), "CFA_PROCEDURE");
      module_initialization_70_cfa_closure(((long) 0), "CFA_PROCEDURE");
      return
	 module_initialization_70_cfa_stack(((long) 0), "CFA_PROCEDURE");
   }
}
