/*===========================================================================*/
/*   (Cfa/set.scm)                                                           */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;

typedef struct approx
  {
     header_t header;
     obj_t widening;
     struct type *type;
     bool_t type_locked__184;
     obj_t allocs;
     bool_t top__138;
     long lost_stamp_114;
  }
      *approx_bglt;

typedef struct cfun_cinfo_200
  {
     struct approx *approx;
  }
              *cfun_cinfo_200_bglt;

typedef struct extern_sfun_cinfo_6
  {
     struct approx *approx;
  }
                   *extern_sfun_cinfo_6_bglt;

typedef struct intern_sfun_cinfo_192
  {
     struct approx *approx;
     long stamp;
  }
                     *intern_sfun_cinfo_192_bglt;

typedef struct scnst_cinfo_0
  {
     struct approx *approx;
  }
             *scnst_cinfo_0_bglt;

typedef struct pre_clo_env_191
  {
     char dummy;
  }
               *pre_clo_env_191_bglt;

typedef struct svar_cinfo_166
  {
     struct approx *approx;
     bool_t clo_env__87;
  }
              *svar_cinfo_166_bglt;

typedef struct cvar_cinfo_53
  {
     struct approx *approx;
  }
             *cvar_cinfo_53_bglt;

typedef struct sexit_cinfo_49
  {
     struct approx *approx;
  }
              *sexit_cinfo_49_bglt;

typedef struct reshaped_local_224
  {
     obj_t binding_value_3;
  }
                  *reshaped_local_224_bglt;

typedef struct reshaped_global_160
  {
     char dummy;
  }
                   *reshaped_global_160_bglt;

typedef struct atom_cinfo_155
  {
     struct approx *approx;
  }
              *atom_cinfo_155_bglt;

typedef struct kwote_node_102
  {
     struct node *node;
  }
              *kwote_node_102_bglt;

typedef struct kwote_cinfo_48
  {
     struct approx *approx;
  }
              *kwote_cinfo_48_bglt;

typedef struct app_ly_cinfo_234
  {
     struct approx *approx;
  }
                *app_ly_cinfo_234_bglt;

typedef struct funcall_cinfo_75
  {
     struct approx *approx;
     struct approx *va_approx_63;
     bool_t arity_error_noticed__118;
     bool_t type_error_noticed__36;
  }
                *funcall_cinfo_75_bglt;

typedef struct pragma_cinfo_220
  {
     struct approx *approx;
  }
                *pragma_cinfo_220_bglt;

typedef struct setq_cinfo_191
  {
     struct approx *approx;
  }
              *setq_cinfo_191_bglt;

typedef struct conditional_cinfo_212
  {
     struct approx *approx;
  }
                     *conditional_cinfo_212_bglt;

typedef struct fail_cinfo_75
  {
     struct approx *approx;
  }
             *fail_cinfo_75_bglt;

typedef struct select_cinfo_150
  {
     struct approx *approx;
  }
                *select_cinfo_150_bglt;

typedef struct set_ex_it_cinfo_168
  {
     struct approx *approx;
  }
                   *set_ex_it_cinfo_168_bglt;

typedef struct jump_ex_it_cinfo_139
  {
     struct approx *approx;
  }
                    *jump_ex_it_cinfo_139_bglt;

typedef struct pre_make_box_186
  {
     char dummy;
  }
                *pre_make_box_186_bglt;

typedef struct make_box_cinfo_127
  {
     struct approx *approx;
  }
                  *make_box_cinfo_127_bglt;

typedef struct make_box_o_cinfo_96
  {
     struct approx *approx;
     struct approx *value_approx_19;
  }
                   *make_box_o_cinfo_96_bglt;

typedef struct box_set__cinfo_94
  {
     struct approx *approx;
  }
                 *box_set__cinfo_94_bglt;

typedef struct box_ref_cinfo_214
  {
     struct approx *approx;
  }
                 *box_ref_cinfo_214_bglt;

typedef struct box_set__o_cinfo_6
  {
     struct approx *approx;
  }
                  *box_set__o_cinfo_6_bglt;

typedef struct box_ref_o_cinfo_98
  {
     struct approx *approx;
  }
                  *box_ref_o_cinfo_98_bglt;

typedef struct pre_make_procedure_app_60
  {
     struct variable *owner;
  }
                         *pre_make_procedure_app_60_bglt;

typedef struct pre_procedure_ref_app_85
  {
     char dummy;
  }
                        *pre_procedure_ref_app_85_bglt;

typedef struct pre_procedure_set__app_208
  {
     char dummy;
  }
                          *pre_procedure_set__app_208_bglt;

typedef struct make_procedure_app_48
  {
     struct approx *approx;
     long values_approx_len_106;
     struct approx **values_approx_79;
     long lost_stamp_114;
     bool_t x_t__142;
     bool_t x;
     bool_t t;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
  }
                     *make_procedure_app_48_bglt;

typedef struct procedure_ref_app_49
  {
     struct approx *approx;
  }
                    *procedure_ref_app_49_bglt;

typedef struct procedure_set__app_32
  {
     struct approx *approx;
  }
                     *procedure_set__app_32_bglt;

typedef struct pre_make_vector_app_251
  {
     struct variable *owner;
  }
                       *pre_make_vector_app_251_bglt;

typedef struct pre_create_vector_app_162
  {
     struct variable *owner;
  }
                         *pre_create_vector_app_162_bglt;

typedef struct pre_vector_ref_app_208
  {
     char dummy;
  }
                      *pre_vector_ref_app_208_bglt;

typedef struct pre_vector_set__app_211
  {
     char dummy;
  }
                       *pre_vector_set__app_211_bglt;

typedef struct make_vector_app_205
  {
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
     bool_t seen__39;
  }
                   *make_vector_app_205_bglt;

typedef struct create_vector_app_150
  {
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
     bool_t seen__39;
  }
                     *create_vector_app_150_bglt;

typedef struct vector_ref_app_195
  {
     struct approx *approx;
  }
                  *vector_ref_app_195_bglt;

typedef struct vector_set__app_21
  {
     struct approx *approx;
  }
                  *vector_set__app_21_bglt;

typedef struct pre_make_struct_app_218
  {
     struct variable *owner;
  }
                       *pre_make_struct_app_218_bglt;

typedef struct pre_struct_ref_app_207
  {
     char dummy;
  }
                      *pre_struct_ref_app_207_bglt;

typedef struct pre_struct_set__app_116
  {
     char dummy;
  }
                       *pre_struct_set__app_116_bglt;

typedef struct make_struct_app_214
  {
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
  }
                   *make_struct_app_214_bglt;

typedef struct struct_ref_app_73
  {
     struct approx *approx;
  }
                 *struct_ref_app_73_bglt;

typedef struct struct_set__app_162
  {
     struct approx *approx;
  }
                   *struct_set__app_162_bglt;


static obj_t method_init_76_cfa_set();
static obj_t _set_for_each_244_cfa_set(obj_t, obj_t, obj_t);
extern obj_t create_struct(obj_t, long);
extern obj_t set_union__206_cfa_set(obj_t, obj_t);
static obj_t _declare_set__206_cfa_set(obj_t, obj_t);
extern obj_t module_initialization_70_cfa_set(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_cfa_info(long, char *);
extern obj_t module_initialization_70_cfa_info2(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_cfa_approx(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_vectors_6_8(long, char *);
static obj_t _set__list_15_cfa_set(obj_t, obj_t);
static obj_t _set_extend__167_cfa_set(obj_t, obj_t, obj_t);
extern obj_t list__vector_101___r4_vectors_6_8(obj_t);
extern obj_t make_set__25_cfa_set(obj_t);
static obj_t imported_modules_init_94_cfa_set();
extern obj_t set_extend__187_cfa_set(obj_t, obj_t);
static obj_t _set__114_cfa_set(obj_t, obj_t);
static obj_t _set_union__126_cfa_set(obj_t, obj_t, obj_t);
static obj_t library_modules_init_112_cfa_set();
extern obj_t set_length_165_cfa_set(obj_t);
static obj_t toplevel_init_63_cfa_set();
extern obj_t open_input_string(obj_t);
static obj_t _set__vector_80_cfa_set(obj_t, obj_t);
extern bool_t set__44_cfa_set(obj_t);
static long max_large_size_22_cfa_set;
extern obj_t set__vector_66_cfa_set(obj_t);
static obj_t _make_set__72_cfa_set(obj_t, obj_t);
extern obj_t shape_tools_shape(obj_t);
extern obj_t make_string(long, unsigned char);
extern obj_t internal_error_43_tools_error(obj_t, obj_t, obj_t);
extern obj_t set_for_each_94_cfa_set(obj_t, obj_t);
extern obj_t read___reader(obj_t);
static obj_t _set_length_66_cfa_set(obj_t, obj_t);
extern obj_t declare_set__41_cfa_set(obj_t);
static obj_t require_initialization_114_cfa_set = BUNSPEC;
static obj_t set_union_2__160_cfa_set(obj_t, obj_t);
extern obj_t set__list_248_cfa_set(obj_t);
static obj_t cnst_init_137_cfa_set();
static obj_t __cnst[2];

DEFINE_EXPORT_PROCEDURE(declare_set__env_66_cfa_set, _declare_set__206_cfa_set2390, _declare_set__206_cfa_set, 0L, 1);
DEFINE_EXPORT_PROCEDURE(set_for_each_env_0_cfa_set, _set_for_each_244_cfa_set2391, _set_for_each_244_cfa_set, 0L, 2);
DEFINE_EXPORT_PROCEDURE(set__env_43_cfa_set, _set__114_cfa_set2392, _set__114_cfa_set, 0L, 1);
DEFINE_EXPORT_PROCEDURE(set__vector_env_86_cfa_set, _set__vector_80_cfa_set2393, _set__vector_80_cfa_set, 0L, 1);
DEFINE_STRING(string2385_cfa_set, string2385_cfa_set2394, "LARGE-SET META-SET ", 19);
DEFINE_STRING(string2384_cfa_set, string2384_cfa_set2395, "Incompatible sets", 17);
DEFINE_STRING(string2383_cfa_set, string2383_cfa_set2396, "set-union!", 10);
DEFINE_STRING(string2382_cfa_set, string2382_cfa_set2397, "Not a meta-set", 14);
DEFINE_STRING(string2381_cfa_set, string2381_cfa_set2398, "make-set", 8);
DEFINE_STRING(string2379_cfa_set, string2379_cfa_set2399, "define-set!", 11);
DEFINE_STRING(string2380_cfa_set, string2380_cfa_set2400, "Too many element in set", 23);
DEFINE_EXPORT_PROCEDURE(set_extend__env_151_cfa_set, _set_extend__167_cfa_set2401, _set_extend__167_cfa_set, 0L, 2);
DEFINE_EXPORT_PROCEDURE(set_union__env_227_cfa_set, _set_union__126_cfa_set2402, va_generic_entry, _set_union__126_cfa_set, -2);
DEFINE_EXPORT_PROCEDURE(make_set__env_47_cfa_set, _make_set__72_cfa_set2403, _make_set__72_cfa_set, 0L, 1);
DEFINE_EXPORT_PROCEDURE(set__list_env_124_cfa_set, _set__list_15_cfa_set2404, _set__list_15_cfa_set, 0L, 1);
DEFINE_EXPORT_PROCEDURE(set_length_env_35_cfa_set, _set_length_66_cfa_set2405, _set_length_66_cfa_set, 0L, 1);



/* module-initialization */
obj_t 
module_initialization_70_cfa_set(long checksum_3769, char *from_3770)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_cfa_set))
	{
	   require_initialization_114_cfa_set =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_cfa_set();
	   cnst_init_137_cfa_set();
	   imported_modules_init_94_cfa_set();
	   method_init_76_cfa_set();
	   toplevel_init_63_cfa_set();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_cfa_set()
{
   AN_OBJECT;
   {	/* Cfa/set.scm 14 */
      module_initialization_70___r4_vectors_6_8(((long) 0), "CFA_SET");
      module_initialization_70___reader(((long) 0), "CFA_SET");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_cfa_set()
{
   AN_OBJECT;
   {	/* Cfa/set.scm 14 */
      {		/* Cfa/set.scm 14 */
	 obj_t cnst_port_138_3762;
	 cnst_port_138_3762 =
	    open_input_string(string2385_cfa_set);
	 {
	    long i_3763;
	    i_3763 = ((long) 1);
	  loop_3764:
	    {	/* Cfa/set.scm 14 */
	       bool_t test2386_3765;
	       test2386_3765 =
		  (i_3763 == ((long) -1));
	       if (test2386_3765)
		 {	/* Cfa/set.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Cfa/set.scm 14 */
		    {	/* Cfa/set.scm 14 */
		       obj_t arg2387_3766;
		       {	/* Cfa/set.scm 14 */
			  obj_t list2388_3767;
			  list2388_3767 =
			     MAKE_PAIR(cnst_port_138_3762, BNIL);
			  arg2387_3766 =
			     read___reader(list2388_3767);
		       }
		       CNST_TABLE_SET(i_3763, arg2387_3766);
		    }
		    {	/* Cfa/set.scm 14 */
		       int aux_3768;
		       {	/* Cfa/set.scm 14 */
			  long aux_3787;
			  aux_3787 =
			     (i_3763 - ((long) 1));
			  aux_3768 =
			     (int) (aux_3787);
		       }
		       {
			  long i_3790;
			  i_3790 =
			     (long) (aux_3768);
			  i_3763 = i_3790;
			  goto loop_3764;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_cfa_set()
{
   AN_OBJECT;
   {	/* Cfa/set.scm 14 */
      return (
	 max_large_size_22_cfa_set = ((long) 10000), BUNSPEC);
   }
}



/* declare-set! */
obj_t 
declare_set__41_cfa_set(obj_t table_21)
{
   AN_OBJECT;
   {	/* Cfa/set.scm 48 */
      {		/* Cfa/set.scm 49 */
	 long cardinal_2157;
	 cardinal_2157 =
	    VECTOR_LENGTH(table_21);
	 {	/* Cfa/set.scm 49 */
	    long quotient_2158;
	    quotient_2158 =
	       (cardinal_2157 / ((long) 8));
	    {	/* Cfa/set.scm 50 */
	       long remainder_2159;
	       remainder_2159 =
		  (cardinal_2157 % ((long) 8));
	       {	/* Cfa/set.scm 51 */
		  long size_2160;
		  if (
		     (remainder_2159 == ((long) 0)))
		    {	/* Cfa/set.scm 53 */
		       size_2160 =
			  (quotient_2158 + ((long) 1));
		    }
		  else
		    {	/* Cfa/set.scm 53 */
		       size_2160 =
			  (quotient_2158 + ((long) 2));
		    }
		  {	/* Cfa/set.scm 52 */

		     if (
			(cardinal_2157 >= ((long) 10000)))
		       {	/* Cfa/set.scm 58 */
			  {	/* Cfa/set.scm 59 */
			     obj_t arg2053_2164;
			     arg2053_2164 =
				shape_tools_shape(table_21);
			     return
				internal_error_43_tools_error(string2379_cfa_set, string2380_cfa_set, arg2053_2164);
			  }
		       }
		     else
		       {	/* Cfa/set.scm 58 */
			  {
			     long i_2165;
			     long quotient_2166;
			     long mask_2167;
			     i_2165 = ((long) 0);
			     quotient_2166 = ((long) 0);
			     mask_2167 = ((long) 1);
			   loop_2168:
			     if (
				(i_2165 == cardinal_2157))
			       {	/* Cfa/set.scm 67 */
				  {	/* Cfa/set.scm 37 */
				     obj_t new_3122;
				     {	/* Cfa/set.scm 37 */
					obj_t aux_3805;
					aux_3805 =
					   CNST_TABLE_REF(((long) 0));
					new_3122 =
					   create_struct(aux_3805, ((long) 2));
				     }
				     {	/* ./Llib/struct.scm 1463 */
					obj_t aux_3808;
					aux_3808 =
					   BINT(size_2160);
					STRUCT_SET(new_3122, ((long) 1), aux_3808);
				     }
				     STRUCT_SET(new_3122, ((long) 0), table_21);
				     return new_3122;
				  }
			       }
			     else
			       {	/* Cfa/set.scm 67 */
				  if (
				     (mask_2167 == ((long) 256)))
				    {	/* Cfa/set.scm 69 */
				       {
					  long mask_3816;
					  long quotient_3814;
					  quotient_3814 =
					     (quotient_2166 + ((long) 1));
					  mask_3816 = ((long) 1);
					  mask_2167 = mask_3816;
					  quotient_2166 = quotient_3814;
					  goto loop_2168;
				       }
				    }
				  else
				    {	/* Cfa/set.scm 69 */
				       {	/* Cfa/set.scm 72 */
					  obj_t arg2058_2173;
					  obj_t arg2059_2174;
					  arg2058_2173 =
					     VECTOR_REF(table_21, i_2165);
					  {	/* ./Ieee/pair-list.scm 5689 */
					     obj_t aux_3820;
					     obj_t aux_3818;
					     aux_3820 =
						BINT(mask_2167);
					     aux_3818 =
						BINT(quotient_2166);
					     arg2059_2174 =
						MAKE_PAIR(aux_3818, aux_3820);
					  }
					  {	/* Cfa/set.scm 72 */
					     node_effect_213_bglt node_3141;
					     node_3141 =
						(node_effect_213_bglt) (arg2058_2173);
					     ((((node_effect_213_bglt) CREF(node_3141))->key) = ((obj_t) arg2059_2174), BUNSPEC);
					  }
				       }
				       {
					  long mask_3827;
					  long i_3825;
					  i_3825 =
					     (i_2165 + ((long) 1));
					  mask_3827 =
					     (mask_2167 * ((long) 2));
					  mask_2167 = mask_3827;
					  i_2165 = i_3825;
					  goto loop_2168;
				       }
				    }
			       }
			  }
		       }
		  }
	       }
	    }
	 }
      }
   }
}



/* _declare-set! */
obj_t 
_declare_set__206_cfa_set(obj_t env_3739, obj_t table_3740)
{
   AN_OBJECT;
   {	/* Cfa/set.scm 48 */
      return
	 declare_set__41_cfa_set(table_3740);
   }
}



/* make-set! */
obj_t 
make_set__25_cfa_set(obj_t meta_set_245_22)
{
   AN_OBJECT;
   {	/* Cfa/set.scm 78 */
      {		/* Cfa/set.scm 80 */
	 bool_t test_3830;
	 if (
	    STRUCTP(meta_set_245_22))
	   {	/* ./Ieee/equiv.scm 5508 */
	      obj_t aux_3835;
	      obj_t aux_3833;
	      aux_3835 =
		 CNST_TABLE_REF(((long) 0));
	      aux_3833 =
		 STRUCT_KEY(meta_set_245_22);
	      test_3830 =
		 (aux_3833 == aux_3835);
	   }
	 else
	   {	/* Cfa/set.scm 37 */
	      test_3830 = ((bool_t) 0)
		 ;
	   }
	 if (test_3830)
	   {	/* Cfa/set.scm 80 */
	      {		/* Cfa/set.scm 83 */
		 obj_t arg2064_2179;
		 {	/* Cfa/set.scm 83 */
		    obj_t arg2065_2180;
		    arg2065_2180 =
		       STRUCT_REF(meta_set_245_22, ((long) 1));
		    {	/* Cfa/set.scm 83 */
		       obj_t list2066_2181;
		       {	/* Cfa/set.scm 83 */
			  obj_t aux_3839;
			  aux_3839 =
			     BCHAR(((unsigned char) '\000'));
			  list2066_2181 =
			     MAKE_PAIR(aux_3839, BNIL);
		       }
		       {	/* Cfa/set.scm 83 */
			  obj_t res2378_3166;
			  {	/* ./Ieee/string.scm 8055 */
			     unsigned char aux_3846;
			     long aux_3842;
			     {	/* ./Ieee/string.scm 8055 */
				obj_t aux_3847;
				aux_3847 =
				   CAR(list2066_2181);
				aux_3846 =
				   (unsigned char) CCHAR(aux_3847);
			     }
			     {	/* ./Ieee/string.scm 8055 */
				int aux_3843;
				aux_3843 =
				   CINT(arg2065_2180);
				aux_3842 =
				   (long) (aux_3843);
			     }
			     res2378_3166 =
				make_string(aux_3842, aux_3846);
			  }
			  arg2064_2179 = res2378_3166;
		       }
		    }
		 }
		 {	/* Cfa/set.scm 38 */
		    obj_t new_3169;
		    {	/* Cfa/set.scm 38 */
		       obj_t aux_3851;
		       aux_3851 =
			  CNST_TABLE_REF(((long) 1));
		       new_3169 =
			  create_struct(aux_3851, ((long) 2));
		    }
		    STRUCT_SET(new_3169, ((long) 1), meta_set_245_22);
		    STRUCT_SET(new_3169, ((long) 0), arg2064_2179);
		    return new_3169;
		 }
	      }
	   }
	 else
	   {	/* Cfa/set.scm 80 */
	      {		/* Cfa/set.scm 81 */
		 obj_t arg2069_2184;
		 arg2069_2184 =
		    shape_tools_shape(meta_set_245_22);
		 return
		    internal_error_43_tools_error(string2381_cfa_set, string2382_cfa_set, arg2069_2184);
	      }
	   }
      }
   }
}



/* _make-set! */
obj_t 
_make_set__72_cfa_set(obj_t env_3741, obj_t meta_set_245_3742)
{
   AN_OBJECT;
   {	/* Cfa/set.scm 78 */
      return
	 make_set__25_cfa_set(meta_set_245_3742);
   }
}



/* set? */
bool_t 
set__44_cfa_set(obj_t obj_23)
{
   AN_OBJECT;
   {	/* Cfa/set.scm 89 */
      if (
	 STRUCTP(obj_23))
	{	/* ./Ieee/equiv.scm 5508 */
	   obj_t aux_3863;
	   obj_t aux_3861;
	   aux_3863 =
	      CNST_TABLE_REF(((long) 1));
	   aux_3861 =
	      STRUCT_KEY(obj_23);
	   return
	      (aux_3861 == aux_3863);
	}
      else
	{	/* Cfa/set.scm 38 */
	   return ((bool_t) 0);
	}
   }
}



/* _set? */
obj_t 
_set__114_cfa_set(obj_t env_3743, obj_t obj_3744)
{
   AN_OBJECT;
   {	/* Cfa/set.scm 89 */
      {		/* Cfa/set.scm 89 */
	 bool_t aux_3866;
	 aux_3866 =
	    set__44_cfa_set(obj_3744);
	 return
	    BBOOL(aux_3866);
      }
   }
}



/* set-extend! */
obj_t 
set_extend__187_cfa_set(obj_t set_24, obj_t obj_25)
{
   AN_OBJECT;
   {	/* Cfa/set.scm 95 */
      {		/* Cfa/set.scm 96 */
	 obj_t key_2185;
	 {	/* Cfa/set.scm 96 */
	    node_effect_213_bglt node_3188;
	    node_3188 =
	       (node_effect_213_bglt) (obj_25);
	    key_2185 =
	       (((node_effect_213_bglt) CREF(node_3188))->key);
	 }
	 {	/* Cfa/set.scm 96 */
	    obj_t the_set_132_2186;
	    the_set_132_2186 =
	       STRUCT_REF(set_24, ((long) 0));
	    {	/* Cfa/set.scm 97 */
	       obj_t quotient_2187;
	       quotient_2187 =
		  CAR(key_2185);
	       {	/* Cfa/set.scm 99 */

		  {	/* ./Ieee/string.scm 8095 */
		     unsigned char aux_3875;
		     long aux_3873;
		     {	/* ./Ieee/char.scm 7909 */
			unsigned char aux_3882;
			unsigned char aux_3876;
			{	/* ./Ieee/string.scm 8089 */
			   long aux_3883;
			   aux_3883 =
			      (long) CINT(quotient_2187);
			   aux_3882 =
			      STRING_REF(the_set_132_2186, aux_3883);
			}
			{	/* ./Ieee/char.scm 7891 */
			   long aux_3877;
			   {	/* Cfa/set.scm 102 */
			      obj_t aux_3878;
			      aux_3878 =
				 CDR(key_2185);
			      aux_3877 =
				 (long) CINT(aux_3878);
			   }
			   aux_3876 =
			      (aux_3877);
			}
			aux_3875 =
			   (aux_3876 | aux_3882);
		     }
		     aux_3873 =
			(long) CINT(quotient_2187);
		     STRING_SET(the_set_132_2186, aux_3873, aux_3875);
		  }
		  return BUNSPEC;
	       }
	    }
	 }
      }
   }
}



/* _set-extend! */
obj_t 
_set_extend__167_cfa_set(obj_t env_3745, obj_t set_3746, obj_t obj_3747)
{
   AN_OBJECT;
   {	/* Cfa/set.scm 95 */
      return
	 set_extend__187_cfa_set(set_3746, obj_3747);
   }
}



/* set-union-2! */
obj_t 
set_union_2__160_cfa_set(obj_t dst_28, obj_t src_29)
{
   AN_OBJECT;
   {	/* Cfa/set.scm 122 */
      {

	 {	/* Cfa/set.scm 139 */
	    bool_t test_3889;
	    if (
	       STRUCTP(src_29))
	      {		/* ./Ieee/equiv.scm 5508 */
		 obj_t aux_3894;
		 obj_t aux_3892;
		 aux_3894 =
		    CNST_TABLE_REF(((long) 1));
		 aux_3892 =
		    STRUCT_KEY(src_29);
		 test_3889 =
		    (aux_3892 == aux_3894);
	      }
	    else
	      {		/* Cfa/set.scm 38 */
		 test_3889 = ((bool_t) 0)
		    ;
	      }
	    if (test_3889)
	      {		/* Cfa/set.scm 141 */
		 bool_t test_3897;
		 {	/* ./Ieee/fixnum.scm 7109 */
		    long aux_3902;
		    long aux_3898;
		    {	/* ./Ieee/string.scm 8067 */
		       obj_t aux_3903;
		       aux_3903 =
			  STRUCT_REF(src_29, ((long) 0));
		       aux_3902 =
			  STRING_LENGTH(aux_3903);
		    }
		    {	/* ./Ieee/string.scm 8067 */
		       obj_t aux_3899;
		       aux_3899 =
			  STRUCT_REF(dst_28, ((long) 0));
		       aux_3898 =
			  STRING_LENGTH(aux_3899);
		    }
		    test_3897 =
		       (aux_3898 == aux_3902);
		 }
		 if (test_3897)
		   {	/* Cfa/set.scm 144 */
		      bool_t aux_3907;
		      {		/* Cfa/set.scm 124 */
			 obj_t the_dst_66_2214;
			 obj_t the_src_137_2215;
			 the_dst_66_2214 =
			    STRUCT_REF(dst_28, ((long) 0));
			 the_src_137_2215 =
			    STRUCT_REF(src_29, ((long) 0));
			 {
			    long i_2216;
			    bool_t res_2217;
			    {	/* ./Ieee/fixnum.scm 7199 */
			       long aux_3927;
			       {	/* Cfa/set.scm 126 */
				  obj_t aux_3928;
				  {	/* ./Llib/struct.scm 1457 */
				     obj_t aux_3929;
				     aux_3929 =
					STRUCT_REF(dst_28, ((long) 1));
				     aux_3928 =
					STRUCT_REF(aux_3929, ((long) 1));
				  }
				  aux_3927 =
				     (long) CINT(aux_3928);
			       }
			       i_2216 =
				  (aux_3927 - ((long) 1));
			    }
			    res_2217 = ((bool_t) 0);
			  loop_2218:
			    if (
			       (i_2216 == ((long) -1)))
			      {		/* Cfa/set.scm 129 */
				 aux_3907 = res_2217
				    ;
			      }
			    else
			      {		/* Cfa/set.scm 131 */
				 unsigned char new_2225;
				 {	/* ./Ieee/char.scm 7909 */
				    unsigned char aux_3914;
				    unsigned char aux_3912;
				    aux_3914 =
				       STRING_REF(the_src_137_2215, i_2216);
				    aux_3912 =
				       STRING_REF(the_dst_66_2214, i_2216);
				    new_2225 =
				       (aux_3912 | aux_3914);
				 }
				 {	/* Cfa/set.scm 134 */
				    bool_t test_3917;
				    {	/* ./Ieee/char.scm 7775 */
				       unsigned char aux_3918;
				       aux_3918 =
					  STRING_REF(the_dst_66_2214, i_2216);
				       test_3917 =
					  (new_2225 == aux_3918);
				    }
				    if (test_3917)
				      {
					 long i_3921;
					 i_3921 =
					    (i_2216 - ((long) 1));
					 i_2216 = i_3921;
					 goto loop_2218;
				      }
				    else
				      {		/* Cfa/set.scm 134 */
					 STRING_SET(the_dst_66_2214, i_2216, new_2225);
					 {
					    bool_t res_3926;
					    long i_3924;
					    i_3924 =
					       (i_2216 - ((long) 1));
					    res_3926 = ((bool_t) 1);
					    res_2217 = res_3926;
					    i_2216 = i_3924;
					    goto loop_2218;
					 }
				      }
				 }
			      }
			 }
		      }
		      return
			 BBOOL(aux_3907);
		   }
		 else
		   {	/* Cfa/set.scm 143 */
		      obj_t arg2082_2205;
		      arg2082_2205 =
			 shape_tools_shape(src_29);
		      return
			 internal_error_43_tools_error(string2383_cfa_set, string2384_cfa_set, arg2082_2205);
		   }
	      }
	    else
	      {		/* Cfa/set.scm 140 */
		 obj_t arg2090_2212;
		 arg2090_2212 =
		    shape_tools_shape(src_29);
		 return
		    internal_error_43_tools_error(string2383_cfa_set, string2384_cfa_set, arg2090_2212);
	      }
	 }
      }
   }
}



/* set-union! */
obj_t 
set_union__206_cfa_set(obj_t dst_30, obj_t src__127_31)
{
   AN_OBJECT;
   {	/* Cfa/set.scm 152 */
      if (
	 NULLP(src__127_31))
	{	/* Cfa/set.scm 154 */
	   return dst_30;
	}
      else
	{	/* Cfa/set.scm 156 */
	   bool_t test_3941;
	   {	/* ./Ieee/pair-list.scm 5912 */
	      obj_t aux_3942;
	      aux_3942 =
		 CDR(src__127_31);
	      test_3941 =
		 NULLP(aux_3942);
	   }
	   if (test_3941)
	     {	/* Cfa/set.scm 156 */
		return
		   set_union_2__160_cfa_set(dst_30,
		   CAR(src__127_31));
	     }
	   else
	     {	/* Cfa/set.scm 156 */
		{
		   obj_t src__127_2235;
		   obj_t res_2236;
		   src__127_2235 = src__127_31;
		   res_2236 = BFALSE;
		 loop_2237:
		   if (
		      NULLP(src__127_2235))
		     {	/* Cfa/set.scm 161 */
			return res_2236;
		     }
		   else
		     {	/* Cfa/set.scm 163 */
			obj_t arg2106_2239;
			obj_t arg2107_2240;
			arg2106_2239 =
			   CDR(src__127_2235);
			{	/* Cfa/set.scm 164 */
			   obj_t _ortest_2031_2241;
			   _ortest_2031_2241 =
			      set_union_2__160_cfa_set(dst_30,
			      CAR(src__127_2235));
			   if (
			      CBOOL(_ortest_2031_2241))
			     {	/* Cfa/set.scm 164 */
				arg2107_2240 = _ortest_2031_2241;
			     }
			   else
			     {	/* Cfa/set.scm 164 */
				arg2107_2240 = res_2236;
			     }
			}
			{
			   obj_t res_3955;
			   obj_t src__127_3954;
			   src__127_3954 = arg2106_2239;
			   res_3955 = arg2107_2240;
			   res_2236 = res_3955;
			   src__127_2235 = src__127_3954;
			   goto loop_2237;
			}
		     }
		}
	     }
	}
   }
}



/* _set-union! */
obj_t 
_set_union__126_cfa_set(obj_t env_3748, obj_t dst_3749, obj_t src__127_3750)
{
   AN_OBJECT;
   {	/* Cfa/set.scm 152 */
      return
	 set_union__206_cfa_set(dst_3749, src__127_3750);
   }
}



/* set-for-each */
obj_t 
set_for_each_94_cfa_set(obj_t proc_32, obj_t set_33)
{
   AN_OBJECT;
   {	/* Cfa/set.scm 169 */
      {

	 {	/* Cfa/set.scm 171 */
	    obj_t table_2247;
	    {	/* ./Llib/struct.scm 1457 */
	       obj_t aux_3957;
	       aux_3957 =
		  STRUCT_REF(set_33, ((long) 1));
	       table_2247 =
		  STRUCT_REF(aux_3957, ((long) 0));
	    }
	    {	/* Cfa/set.scm 172 */

	       {
		  long i_2248;
		  {	/* ./Ieee/fixnum.scm 7199 */
		     long aux_3991;
		     aux_3991 =
			VECTOR_LENGTH(table_2247);
		     i_2248 =
			(aux_3991 - ((long) 1));
		  }
		loop_2249:
		  if (
		     (i_2248 == ((long) -1)))
		    {	/* Cfa/set.scm 175 */
		       return BUNSPEC;
		    }
		  else
		    {	/* Cfa/set.scm 177 */
		       bool_t test_3962;
		       {	/* Cfa/set.scm 110 */
			  obj_t key_3298;
			  {	/* Cfa/set.scm 110 */
			     node_effect_213_bglt node_3306;
			     {	/* Cfa/set.scm 110 */
				obj_t aux_3963;
				aux_3963 =
				   VECTOR_REF(table_2247, i_2248);
				node_3306 =
				   (node_effect_213_bglt) (aux_3963);
			     }
			     key_3298 =
				(((node_effect_213_bglt) CREF(node_3306))->key);
			  }
			  {	/* Cfa/set.scm 113 */

			     {	/* ./Ieee/fixnum.scm 7121 */
				long aux_3967;
				{	/* ./Llib/bit.scm 1967 */
				   long aux_3972;
				   long aux_3968;
				   {	/* ./Ieee/char.scm 7877 */
				      unsigned char aux_3973;
				      {		/* ./Ieee/string.scm 8089 */
					 long aux_3976;
					 obj_t aux_3974;
					 {	/* Cfa/set.scm 114 */
					    obj_t aux_3977;
					    aux_3977 =
					       CAR(key_3298);
					    aux_3976 =
					       (long) CINT(aux_3977);
					 }
					 aux_3974 =
					    STRUCT_REF(set_33, ((long) 0));
					 aux_3973 =
					    STRING_REF(aux_3974, aux_3976);
				      }
				      aux_3972 =
					 (aux_3973);
				   }
				   {	/* Cfa/set.scm 114 */
				      obj_t aux_3969;
				      aux_3969 =
					 CDR(key_3298);
				      aux_3968 =
					 (long) CINT(aux_3969);
				   }
				   aux_3967 =
				      (aux_3968 & aux_3972);
				}
				test_3962 =
				   (aux_3967 > ((long) 0));
			     }
			  }
		       }
		       if (test_3962)
			 {	/* Cfa/set.scm 177 */
			    PROCEDURE_ENTRY(proc_32) (proc_32,
			       VECTOR_REF(table_2247, i_2248), BEOA);
			    {
			       long i_3987;
			       i_3987 =
				  (i_2248 - ((long) 1));
			       i_2248 = i_3987;
			       goto loop_2249;
			    }
			 }
		       else
			 {	/* Cfa/set.scm 177 */
			    {
			       long i_3989;
			       i_3989 =
				  (i_2248 - ((long) 1));
			       i_2248 = i_3989;
			       goto loop_2249;
			    }
			 }
		    }
	       }
	    }
	 }
      }
   }
}



/* _set-for-each */
obj_t 
_set_for_each_244_cfa_set(obj_t env_3751, obj_t proc_3752, obj_t set_3753)
{
   AN_OBJECT;
   {	/* Cfa/set.scm 169 */
      return
	 set_for_each_94_cfa_set(proc_3752, set_3753);
   }
}



/* set-length */
obj_t 
set_length_165_cfa_set(obj_t set_34)
{
   AN_OBJECT;
   {	/* Cfa/set.scm 187 */
      {

	 {	/* Cfa/set.scm 203 */
	    long aux_3995;
	    {	/* Cfa/set.scm 189 */
	       obj_t the_set_132_2262;
	       the_set_132_2262 =
		  STRUCT_REF(set_34, ((long) 0));
	       {	/* Cfa/set.scm 189 */
		  long the_len_105_2263;
		  the_len_105_2263 =
		     STRING_LENGTH(the_set_132_2262);
		  {	/* Cfa/set.scm 190 */

		     {
			long offset_2264;
			long num_2265;
			offset_2264 = ((long) 0);
			num_2265 = ((long) 0);
		      loop_2266:
			if (
			   (offset_2264 == the_len_105_2263))
			  {	/* Cfa/set.scm 193 */
			     aux_3995 = num_2265
				;
			  }
			else
			  {
			     long char_2268;
			     long num_2269;
			     {	/* ./Ieee/char.scm 7877 */
				unsigned char aux_4011;
				aux_4011 =
				   STRING_REF(the_set_132_2262, offset_2264);
				char_2268 =
				   (aux_4011);
			     }
			     num_2269 = num_2265;
			   liip_2270:
			     if (
				(char_2268 == ((long) 0)))
			       {	/* Cfa/set.scm 198 */
				  {
				     long num_4004;
				     long offset_4002;
				     offset_4002 =
					(((long) 1) + offset_2264);
				     num_4004 = num_2269;
				     num_2265 = num_4004;
				     offset_2264 = offset_4002;
				     goto loop_2266;
				  }
			       }
			     else
			       {	/* Cfa/set.scm 198 */
				  {
				     long num_4007;
				     long char_4005;
				     char_4005 =
					(char_2268 >> ((long) 1));
				     {	/* ./Ieee/fixnum.scm 7193 */
					long aux_4008;
					aux_4008 =
					   (char_2268 & ((long) 1));
					num_4007 =
					   (num_2269 + aux_4008);
				     }
				     num_2269 = num_4007;
				     char_2268 = char_4005;
				     goto liip_2270;
				  }
			       }
			  }
		     }
		  }
	       }
	    }
	    return
	       BINT(aux_3995);
	 }
      }
   }
}



/* _set-length */
obj_t 
_set_length_66_cfa_set(obj_t env_3754, obj_t set_3755)
{
   AN_OBJECT;
   {	/* Cfa/set.scm 187 */
      return
	 set_length_165_cfa_set(set_3755);
   }
}



/* set->list */
obj_t 
set__list_248_cfa_set(obj_t set_35)
{
   AN_OBJECT;
   {	/* Cfa/set.scm 208 */
      {		/* Cfa/set.scm 210 */
	 obj_t table_2280;
	 {	/* ./Llib/struct.scm 1457 */
	    obj_t aux_4016;
	    aux_4016 =
	       STRUCT_REF(set_35, ((long) 1));
	    table_2280 =
	       STRUCT_REF(aux_4016, ((long) 0));
	 }
	 {	/* Cfa/set.scm 210 */
	    long size_2281;
	    size_2281 =
	       VECTOR_LENGTH(table_2280);
	    {	/* Cfa/set.scm 211 */

	       {
		  long i_2282;
		  obj_t l_2283;
		  i_2282 = ((long) 0);
		  l_2283 = BNIL;
		loop_2284:
		  if (
		     (i_2282 == size_2281))
		    {	/* Cfa/set.scm 215 */
		       return l_2283;
		    }
		  else
		    {	/* Cfa/set.scm 217 */
		       bool_t test_4022;
		       {	/* Cfa/set.scm 110 */
			  obj_t key_3358;
			  {	/* Cfa/set.scm 110 */
			     node_effect_213_bglt node_3366;
			     {	/* Cfa/set.scm 110 */
				obj_t aux_4023;
				aux_4023 =
				   VECTOR_REF(table_2280, i_2282);
				node_3366 =
				   (node_effect_213_bglt) (aux_4023);
			     }
			     key_3358 =
				(((node_effect_213_bglt) CREF(node_3366))->key);
			  }
			  {	/* Cfa/set.scm 113 */

			     {	/* ./Ieee/fixnum.scm 7121 */
				long aux_4027;
				{	/* ./Llib/bit.scm 1967 */
				   long aux_4032;
				   long aux_4028;
				   {	/* ./Ieee/char.scm 7877 */
				      unsigned char aux_4033;
				      {		/* ./Ieee/string.scm 8089 */
					 long aux_4036;
					 obj_t aux_4034;
					 {	/* Cfa/set.scm 114 */
					    obj_t aux_4037;
					    aux_4037 =
					       CAR(key_3358);
					    aux_4036 =
					       (long) CINT(aux_4037);
					 }
					 aux_4034 =
					    STRUCT_REF(set_35, ((long) 0));
					 aux_4033 =
					    STRING_REF(aux_4034, aux_4036);
				      }
				      aux_4032 =
					 (aux_4033);
				   }
				   {	/* Cfa/set.scm 114 */
				      obj_t aux_4029;
				      aux_4029 =
					 CDR(key_3358);
				      aux_4028 =
					 (long) CINT(aux_4029);
				   }
				   aux_4027 =
				      (aux_4028 & aux_4032);
				}
				test_4022 =
				   (aux_4027 > ((long) 0));
			     }
			  }
		       }
		       if (test_4022)
			 {	/* Cfa/set.scm 217 */
			    {	/* Cfa/set.scm 218 */
			       long arg2131_2287;
			       obj_t arg2132_2288;
			       arg2131_2287 =
				  (i_2282 + ((long) 1));
			       {	/* ./Ieee/pair-list.scm 5689 */
				  obj_t aux_4045;
				  aux_4045 =
				     VECTOR_REF(table_2280, i_2282);
				  arg2132_2288 =
				     MAKE_PAIR(aux_4045, l_2283);
			       }
			       {
				  obj_t l_4049;
				  long i_4048;
				  i_4048 = arg2131_2287;
				  l_4049 = arg2132_2288;
				  l_2283 = l_4049;
				  i_2282 = i_4048;
				  goto loop_2284;
			       }
			    }
			 }
		       else
			 {	/* Cfa/set.scm 217 */
			    {
			       long i_4050;
			       i_4050 =
				  (i_2282 + ((long) 1));
			       i_2282 = i_4050;
			       goto loop_2284;
			    }
			 }
		    }
	       }
	    }
	 }
      }
   }
}



/* _set->list */
obj_t 
_set__list_15_cfa_set(obj_t env_3756, obj_t set_3757)
{
   AN_OBJECT;
   {	/* Cfa/set.scm 208 */
      return
	 set__list_248_cfa_set(set_3757);
   }
}



/* set->vector */
obj_t 
set__vector_66_cfa_set(obj_t set_36)
{
   AN_OBJECT;
   {	/* Cfa/set.scm 225 */
      {		/* Cfa/set.scm 226 */
	 obj_t arg2136_3388;
	 arg2136_3388 =
	    set__list_248_cfa_set(set_36);
	 return
	    list__vector_101___r4_vectors_6_8(arg2136_3388);
      }
   }
}



/* _set->vector */
obj_t 
_set__vector_80_cfa_set(obj_t env_3758, obj_t set_3759)
{
   AN_OBJECT;
   {	/* Cfa/set.scm 225 */
      return
	 set__vector_66_cfa_set(set_3759);
   }
}



/* method-init */
obj_t 
method_init_76_cfa_set()
{
   AN_OBJECT;
   {	/* Cfa/set.scm 14 */
      return BUNSPEC;
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_cfa_set()
{
   AN_OBJECT;
   {	/* Cfa/set.scm 14 */
      module_initialization_70_type_type(((long) 0), "CFA_SET");
      module_initialization_70_ast_var(((long) 0), "CFA_SET");
      module_initialization_70_ast_node(((long) 0), "CFA_SET");
      module_initialization_70_cfa_info(((long) 0), "CFA_SET");
      module_initialization_70_cfa_info2(((long) 0), "CFA_SET");
      module_initialization_70_tools_shape(((long) 0), "CFA_SET");
      module_initialization_70_tools_error(((long) 0), "CFA_SET");
      return
	 module_initialization_70_cfa_approx(((long) 0), "CFA_SET");
   }
}
