/*===========================================================================*/
/*   (Cfa/setup.scm)                                                         */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct ccomp
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t producer;
     obj_t consumer;
     obj_t finalizer;
     obj_t checksummer;
  }
     *ccomp_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;

typedef struct approx
  {
     header_t header;
     obj_t widening;
     struct type *type;
     bool_t type_locked__184;
     obj_t allocs;
     bool_t top__138;
     long lost_stamp_114;
  }
      *approx_bglt;

typedef struct cfun_cinfo_200
  {
     struct approx *approx;
  }
              *cfun_cinfo_200_bglt;

typedef struct extern_sfun_cinfo_6
  {
     struct approx *approx;
  }
                   *extern_sfun_cinfo_6_bglt;

typedef struct intern_sfun_cinfo_192
  {
     struct approx *approx;
     long stamp;
  }
                     *intern_sfun_cinfo_192_bglt;

typedef struct scnst_cinfo_0
  {
     struct approx *approx;
  }
             *scnst_cinfo_0_bglt;

typedef struct pre_clo_env_191
  {
     char dummy;
  }
               *pre_clo_env_191_bglt;

typedef struct svar_cinfo_166
  {
     struct approx *approx;
     bool_t clo_env__87;
  }
              *svar_cinfo_166_bglt;

typedef struct cvar_cinfo_53
  {
     struct approx *approx;
  }
             *cvar_cinfo_53_bglt;

typedef struct sexit_cinfo_49
  {
     struct approx *approx;
  }
              *sexit_cinfo_49_bglt;

typedef struct reshaped_local_224
  {
     obj_t binding_value_3;
  }
                  *reshaped_local_224_bglt;

typedef struct reshaped_global_160
  {
     char dummy;
  }
                   *reshaped_global_160_bglt;

typedef struct atom_cinfo_155
  {
     struct approx *approx;
  }
              *atom_cinfo_155_bglt;

typedef struct kwote_node_102
  {
     struct node *node;
  }
              *kwote_node_102_bglt;

typedef struct kwote_cinfo_48
  {
     struct approx *approx;
  }
              *kwote_cinfo_48_bglt;

typedef struct app_ly_cinfo_234
  {
     struct approx *approx;
  }
                *app_ly_cinfo_234_bglt;

typedef struct funcall_cinfo_75
  {
     struct approx *approx;
     struct approx *va_approx_63;
     bool_t arity_error_noticed__118;
     bool_t type_error_noticed__36;
  }
                *funcall_cinfo_75_bglt;

typedef struct pragma_cinfo_220
  {
     struct approx *approx;
  }
                *pragma_cinfo_220_bglt;

typedef struct setq_cinfo_191
  {
     struct approx *approx;
  }
              *setq_cinfo_191_bglt;

typedef struct conditional_cinfo_212
  {
     struct approx *approx;
  }
                     *conditional_cinfo_212_bglt;

typedef struct fail_cinfo_75
  {
     struct approx *approx;
  }
             *fail_cinfo_75_bglt;

typedef struct select_cinfo_150
  {
     struct approx *approx;
  }
                *select_cinfo_150_bglt;

typedef struct set_ex_it_cinfo_168
  {
     struct approx *approx;
  }
                   *set_ex_it_cinfo_168_bglt;

typedef struct jump_ex_it_cinfo_139
  {
     struct approx *approx;
  }
                    *jump_ex_it_cinfo_139_bglt;

typedef struct pre_make_box_186
  {
     char dummy;
  }
                *pre_make_box_186_bglt;

typedef struct make_box_cinfo_127
  {
     struct approx *approx;
  }
                  *make_box_cinfo_127_bglt;

typedef struct make_box_o_cinfo_96
  {
     struct approx *approx;
     struct approx *value_approx_19;
  }
                   *make_box_o_cinfo_96_bglt;

typedef struct box_set__cinfo_94
  {
     struct approx *approx;
  }
                 *box_set__cinfo_94_bglt;

typedef struct box_ref_cinfo_214
  {
     struct approx *approx;
  }
                 *box_ref_cinfo_214_bglt;

typedef struct box_set__o_cinfo_6
  {
     struct approx *approx;
  }
                  *box_set__o_cinfo_6_bglt;

typedef struct box_ref_o_cinfo_98
  {
     struct approx *approx;
  }
                  *box_ref_o_cinfo_98_bglt;

typedef struct pre_make_procedure_app_60
  {
     struct variable *owner;
  }
                         *pre_make_procedure_app_60_bglt;

typedef struct pre_procedure_ref_app_85
  {
     char dummy;
  }
                        *pre_procedure_ref_app_85_bglt;

typedef struct pre_procedure_set__app_208
  {
     char dummy;
  }
                          *pre_procedure_set__app_208_bglt;

typedef struct make_procedure_app_48
  {
     struct approx *approx;
     long values_approx_len_106;
     struct approx **values_approx_79;
     long lost_stamp_114;
     bool_t x_t__142;
     bool_t x;
     bool_t t;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
  }
                     *make_procedure_app_48_bglt;

typedef struct procedure_ref_app_49
  {
     struct approx *approx;
  }
                    *procedure_ref_app_49_bglt;

typedef struct procedure_set__app_32
  {
     struct approx *approx;
  }
                     *procedure_set__app_32_bglt;

typedef struct pre_make_vector_app_251
  {
     struct variable *owner;
  }
                       *pre_make_vector_app_251_bglt;

typedef struct pre_create_vector_app_162
  {
     struct variable *owner;
  }
                         *pre_create_vector_app_162_bglt;

typedef struct pre_vector_ref_app_208
  {
     char dummy;
  }
                      *pre_vector_ref_app_208_bglt;

typedef struct pre_vector_set__app_211
  {
     char dummy;
  }
                       *pre_vector_set__app_211_bglt;

typedef struct make_vector_app_205
  {
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
     bool_t seen__39;
  }
                   *make_vector_app_205_bglt;

typedef struct create_vector_app_150
  {
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
     bool_t seen__39;
  }
                     *create_vector_app_150_bglt;

typedef struct vector_ref_app_195
  {
     struct approx *approx;
  }
                  *vector_ref_app_195_bglt;

typedef struct vector_set__app_21
  {
     struct approx *approx;
  }
                  *vector_set__app_21_bglt;

typedef struct pre_make_struct_app_218
  {
     struct variable *owner;
  }
                       *pre_make_struct_app_218_bglt;

typedef struct pre_struct_ref_app_207
  {
     char dummy;
  }
                      *pre_struct_ref_app_207_bglt;

typedef struct pre_struct_set__app_116
  {
     char dummy;
  }
                       *pre_struct_set__app_116_bglt;

typedef struct make_struct_app_214
  {
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
  }
                   *make_struct_app_214_bglt;

typedef struct struct_ref_app_73
  {
     struct approx *approx;
  }
                 *struct_ref_app_73_bglt;

typedef struct struct_set__app_162
  {
     struct approx *approx;
  }
                   *struct_set__app_162_bglt;


static obj_t fun_setup__default2133_16_cfa_setup(fun_bglt, obj_t);
static obj_t method_init_76_cfa_setup();
extern obj_t funcall_ast_node;
extern long add_inlined_method__244___object(obj_t, obj_t, long);
extern obj_t fail_ast_node;
extern obj_t funcall_cinfo_75_cfa_info;
extern obj_t conditional_cinfo_212_cfa_info;
static obj_t node_setup__default2103_233_cfa_setup(node_bglt);
extern obj_t set_initial_approx__92_cfa_setup(obj_t);
extern obj_t cfun_cinfo_200_cfa_info;
extern obj_t sequence_ast_node;
extern obj_t let_var_6_ast_node;
extern obj_t var_ast_node;
extern obj_t closure_ast_node;
extern obj_t reshaped_global_160_cfa_info;
extern obj_t global_ast_var;
extern obj_t _obj__252_type_cache;
extern obj_t pragma_ast_node;
extern approx_bglt make_type_approx_184_cfa_approx(type_bglt);
extern obj_t cvar_ast_var;
extern obj_t set_ex_it_116_ast_node;
extern obj_t set_ex_it_cinfo_168_cfa_info;
extern approx_bglt make_empty_approx_131_cfa_approx();
extern obj_t cvar_cinfo_53_cfa_info;
extern obj_t jump_ex_it_cinfo_139_cfa_info;
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t fail_cinfo_75_cfa_info;
extern obj_t intern_sfun_cinfo_192_cfa_info;
extern obj_t _unspec__87_type_cache;
extern obj_t module_initialization_70_cfa_setup(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_type_typeof(long, char *);
extern obj_t module_initialization_70_module_module(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_cfa_info(long, char *);
extern obj_t module_initialization_70_cfa_info2(long, char *);
extern obj_t module_initialization_70_cfa_approx(long, char *);
extern obj_t module_initialization_70___error(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t pre_clo_env_191_cfa_info;
extern obj_t _warning__61___error;
extern long class_num_218___object(obj_t);
extern obj_t svar_ast_var;
extern obj_t node_setup___185_cfa_setup(obj_t);
extern obj_t scnst_ast_var;
extern obj_t reshaped_local_224_cfa_info;
extern obj_t select_cinfo_150_cfa_info;
extern obj_t let_fun_218_ast_node;
static obj_t _node_setup__114_cfa_setup(obj_t, obj_t);
static obj_t imported_modules_init_94_cfa_setup();
extern type_bglt typeof_kwote_49_type_typeof(obj_t);
static obj_t fun_setup__186_cfa_setup(fun_bglt, obj_t);
extern obj_t extern_sfun_cinfo_6_cfa_info;
static obj_t _variable_value_setup__30_cfa_setup(obj_t, obj_t, obj_t);
static obj_t call_next_method_114_cfa_setup(value_bglt, obj_t, variable_bglt);
extern obj_t scnst_cinfo_0_cfa_info;
static obj_t loop2468_cfa_setup(variable_bglt, value_bglt, obj_t, obj_t);
extern obj_t app_ly_162_ast_node;
extern obj_t cfun_ast_var;
extern obj_t node_setup__189_cfa_setup(node_bglt);
extern obj_t add_generic__110___object(obj_t, obj_t);
extern obj_t approx_set_top__187_cfa_approx(approx_bglt);
static obj_t _fun_setup__default2133_69_cfa_setup(obj_t, obj_t, obj_t);
extern obj_t pragma_cinfo_220_cfa_info;
extern obj_t app_ast_node;
extern obj_t pre_make_procedure_app_60_cfa_info2;
static obj_t library_modules_init_112_cfa_setup();
extern obj_t kwote_node_102_cfa_info;
extern obj_t atom_ast_node;
extern obj_t cast_ast_node;
static obj_t toplevel_init_63_cfa_setup();
extern obj_t jump_ex_it_184_ast_node;
extern obj_t open_input_string(obj_t);
extern obj_t kwote_ast_node;
static obj_t _node_setup__default2103_185_cfa_setup(obj_t, obj_t);
extern obj_t sfun_ast_var;
static obj_t _node_setup___39_cfa_setup(obj_t, obj_t);
extern obj_t kwote_cinfo_48_cfa_info;
extern obj_t setq_ast_node;
extern obj_t local_ast_var;
extern obj_t memq___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern obj_t shape_tools_shape(obj_t);
static obj_t _fun_setup__218_cfa_setup(obj_t, obj_t, obj_t);
extern obj_t setq_cinfo_191_cfa_info;
extern type_bglt typeof_atom_134_type_typeof(obj_t);
extern obj_t internal_error_43_tools_error(obj_t, obj_t, obj_t);
extern obj_t _module__166_module_module;
extern obj_t _procedure__226_type_cache;
static obj_t variable_value_setup__80_cfa_setup(value_bglt, variable_bglt);
extern obj_t sexit_ast_var;
static obj_t _set_initial_approx__130_cfa_setup(obj_t, obj_t);
extern obj_t _classes__134___object;
extern obj_t select_ast_node;
extern obj_t read___reader(obj_t);
static obj_t variable_value_setup__default2112_124_cfa_setup(value_bglt, variable_bglt);
static obj_t case_else2473_cfa_setup(variable_bglt, value_bglt, obj_t);
extern obj_t find_method_from_44___object(object_bglt, obj_t, obj_t);
static bool_t alloc_type__187_cfa_setup(type_bglt);
extern obj_t sexit_cinfo_49_cfa_info;
extern obj_t app_ly_cinfo_234_cfa_info;
extern obj_t svar_cinfo_166_cfa_info;
static obj_t require_initialization_114_cfa_setup = BUNSPEC;
extern obj_t _vector__240_type_cache;
extern obj_t conditional_ast_node;
extern bool_t class__60___object(obj_t);
extern obj_t class_super_145___object(obj_t);
extern obj_t _struct__183_type_cache;
static obj_t cnst_init_137_cfa_setup();
extern obj_t atom_cinfo_155_cfa_info;
static obj_t _variable_value_setup__default2112_67_cfa_setup(obj_t, obj_t, obj_t);
static obj_t __cnst[7];

DEFINE_STATIC_GENERIC(variable_value_setup__env_134_cfa_setup, _variable_value_setup__30_cfa_setup2712, _variable_value_setup__30_cfa_setup, 0L, 2);
DEFINE_STATIC_PROCEDURE(variable_value_setup__default2112_env_55_cfa_setup, _variable_value_setup__default2112_67_cfa_setup2713, _variable_value_setup__default2112_67_cfa_setup, 0L, 2);
DEFINE_STATIC_PROCEDURE(fun_setup__default2133_env_165_cfa_setup, _fun_setup__default2133_69_cfa_setup2714, _fun_setup__default2133_69_cfa_setup, 0L, 2);
DEFINE_EXPORT_PROCEDURE(node_setup___env_203_cfa_setup, _node_setup___39_cfa_setup2715, _node_setup___39_cfa_setup, 0L, 1);
DEFINE_STRING(string2707_cfa_setup, string2707_cfa_setup2716, "IMPORT VARIABLE-VALUE-SETUP!-DEFAULT2112 (SFUN SGFUN) ALREADY-DONE STATIC NODE-SETUP!-DEFAULT2103 READ ", 103);
DEFINE_STRING(string2706_cfa_setup, string2706_cfa_setup2717, "No method for this object", 25);
DEFINE_STRING(string2705_cfa_setup, string2705_cfa_setup2718, "Unexpected closure", 18);
DEFINE_STRING(string2704_cfa_setup, string2704_cfa_setup2719, "node-setup!", 11);
DEFINE_EXPORT_PROCEDURE(set_initial_approx__env_29_cfa_setup, _set_initial_approx__130_cfa_setup2720, _set_initial_approx__130_cfa_setup, 0L, 1);
DEFINE_EXPORT_GENERIC(node_setup__env_214_cfa_setup, _node_setup__114_cfa_setup2721, _node_setup__114_cfa_setup, 0L, 1);
DEFINE_STATIC_GENERIC(fun_setup__env_196_cfa_setup, _fun_setup__218_cfa_setup2722, _fun_setup__218_cfa_setup, 0L, 2);
DEFINE_STATIC_PROCEDURE(node_setup__default2103_env_40_cfa_setup, _node_setup__default2103_185_cfa_setup2723, _node_setup__default2103_185_cfa_setup, 0L, 1);



/* module-initialization */
obj_t 
module_initialization_70_cfa_setup(long checksum_4118, char *from_4119)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_cfa_setup))
	{
	   require_initialization_114_cfa_setup =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_cfa_setup();
	   cnst_init_137_cfa_setup();
	   imported_modules_init_94_cfa_setup();
	   method_init_76_cfa_setup();
	   toplevel_init_63_cfa_setup();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_cfa_setup()
{
   AN_OBJECT;
   {	/* Cfa/setup.scm 14 */
      module_initialization_70___object(((long) 0), "CFA_SETUP");
      module_initialization_70___error(((long) 0), "CFA_SETUP");
      module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "CFA_SETUP");
      module_initialization_70___reader(((long) 0), "CFA_SETUP");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_cfa_setup()
{
   AN_OBJECT;
   {	/* Cfa/setup.scm 14 */
      {		/* Cfa/setup.scm 14 */
	 obj_t cnst_port_138_4111;
	 cnst_port_138_4111 =
	    open_input_string(string2707_cfa_setup);
	 {
	    long i_4112;
	    i_4112 = ((long) 6);
	  loop_4113:
	    {	/* Cfa/setup.scm 14 */
	       bool_t test2708_4114;
	       test2708_4114 =
		  (i_4112 == ((long) -1));
	       if (test2708_4114)
		 {	/* Cfa/setup.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Cfa/setup.scm 14 */
		    {	/* Cfa/setup.scm 14 */
		       obj_t arg2709_4115;
		       {	/* Cfa/setup.scm 14 */
			  obj_t list2710_4116;
			  list2710_4116 =
			     MAKE_PAIR(cnst_port_138_4111, BNIL);
			  arg2709_4115 =
			     read___reader(list2710_4116);
		       }
		       CNST_TABLE_SET(i_4112, arg2709_4115);
		    }
		    {	/* Cfa/setup.scm 14 */
		       int aux_4117;
		       {	/* Cfa/setup.scm 14 */
			  long aux_4138;
			  aux_4138 =
			     (i_4112 - ((long) 1));
			  aux_4117 =
			     (int) (aux_4138);
		       }
		       {
			  long i_4141;
			  i_4141 =
			     (long) (aux_4117);
			  i_4112 = i_4141;
			  goto loop_4113;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_cfa_setup()
{
   AN_OBJECT;
   {	/* Cfa/setup.scm 14 */
      return BUNSPEC;
   }
}



/* set-initial-approx! */
obj_t 
set_initial_approx__92_cfa_setup(obj_t globals_1)
{
   AN_OBJECT;
   {	/* Cfa/setup.scm 34 */
      {
	 obj_t l2038_2162;
	 {	/* Cfa/setup.scm 35 */
	    bool_t aux_4143;
	    l2038_2162 = globals_1;
	  lname2039_2163:
	    if (
	       PAIRP(l2038_2162))
	      {		/* Cfa/setup.scm 35 */
		 {	/* Cfa/setup.scm 35 */
		    obj_t global_2165;
		    global_2165 =
		       CAR(l2038_2162);
		    {	/* Cfa/setup.scm 38 */
		       value_bglt fun_2166;
		       {	/* Cfa/setup.scm 38 */
			  global_bglt obj_3319;
			  obj_3319 =
			     (global_bglt) (global_2165);
			  fun_2166 =
			     (((global_bglt) CREF(obj_3319))->value);
		       }
		       fun_setup__186_cfa_setup(
			  (fun_bglt) (fun_2166), global_2165);
		       {
			  obj_t l2040_2167;
			  {	/* Cfa/setup.scm 44 */
			     sfun_bglt obj_3320;
			     obj_3320 =
				(sfun_bglt) (fun_2166);
			     l2040_2167 =
				(((sfun_bglt) CREF(obj_3320))->args);
			  }
			lname2041_2168:
			  if (
			     PAIRP(l2040_2167))
			    {	/* Cfa/setup.scm 40 */
			       {	/* Cfa/setup.scm 40 */
				  obj_t local_2171;
				  local_2171 =
				     CAR(l2040_2167);
				  {	/* Cfa/setup.scm 41 */
				     reshaped_local_224_bglt obj2042_2172;
				     obj2042_2172 =
					((reshaped_local_224_bglt) (local_2171));
				     {	/* Cfa/setup.scm 41 */
					reshaped_local_224_bglt arg2165_2173;
					{	/* Cfa/setup.scm 41 */
					   reshaped_local_224_bglt res2670_3326;
					   {	/* Cfa/setup.scm 41 */
					      obj_t binding_value_3_3323;
					      binding_value_3_3323 = BFALSE;
					      {		/* ./Cfa/cinfo.scm 1434 */
						 reshaped_local_224_bglt new1549_3324;
						 new1549_3324 =
						    ((reshaped_local_224_bglt) BREF(GC_MALLOC(sizeof(struct reshaped_local_224))));
						 ((((reshaped_local_224_bglt) CREF(new1549_3324))->binding_value_3) = ((obj_t) binding_value_3_3323), BUNSPEC);
						 res2670_3326 = new1549_3324;
					      }
					   }
					   arg2165_2173 = res2670_3326;
					}
					{	/* Cfa/setup.scm 41 */
					   obj_t aux_4159;
					   object_bglt aux_4157;
					   aux_4159 =
					      (obj_t) (arg2165_2173);
					   aux_4157 =
					      (object_bglt) (obj2042_2172);
					   OBJECT_WIDENING_SET(aux_4157, aux_4159);
					}
				     }
				     {	/* Cfa/setup.scm 41 */
					long arg2166_2174;
					arg2166_2174 =
					   class_num_218___object(reshaped_local_224_cfa_info);
					{	/* Cfa/setup.scm 41 */
					   obj_t obj_3327;
					   obj_3327 =
					      (obj_t) (obj2042_2172);
					   (((obj_t) CREF(obj_3327))->header = MAKE_HEADER(arg2166_2174, 0), BUNSPEC);
					}
				     }
				     obj2042_2172;
				  }
				  {	/* Cfa/setup.scm 42 */
				     value_bglt aux_4165;
				     {	/* Cfa/setup.scm 42 */
					local_bglt obj_3329;
					obj_3329 =
					   (local_bglt) (local_2171);
					aux_4165 =
					   (((local_bglt) CREF(obj_3329))->value);
				     }
				     variable_value_setup__80_cfa_setup(aux_4165,
					(variable_bglt) (local_2171));
				  }
			       }
			       {
				  obj_t l2040_4170;
				  l2040_4170 =
				     CDR(l2040_2167);
				  l2040_2167 = l2040_4170;
				  goto lname2041_2168;
			       }
			    }
			  else
			    {	/* Cfa/setup.scm 40 */
			       ((bool_t) 1);
			    }
		       }
		    }
		    {	/* Cfa/setup.scm 45 */
		       node_bglt aux_4174;
		       {	/* Cfa/setup.scm 45 */
			  obj_t aux_4175;
			  {	/* Cfa/setup.scm 45 */
			     sfun_bglt obj_3332;
			     {	/* Cfa/setup.scm 45 */
				value_bglt aux_4176;
				{	/* Cfa/setup.scm 45 */
				   global_bglt obj_3331;
				   obj_3331 =
				      (global_bglt) (global_2165);
				   aux_4176 =
				      (((global_bglt) CREF(obj_3331))->value);
				}
				obj_3332 =
				   (sfun_bglt) (aux_4176);
			     }
			     aux_4175 =
				(((sfun_bglt) CREF(obj_3332))->body);
			  }
			  aux_4174 =
			     (node_bglt) (aux_4175);
		       }
		       node_setup__189_cfa_setup(aux_4174);
		    }
		 }
		 {
		    obj_t l2038_4183;
		    l2038_4183 =
		       CDR(l2038_2162);
		    l2038_2162 = l2038_4183;
		    goto lname2039_2163;
		 }
	      }
	    else
	      {		/* Cfa/setup.scm 35 */
		 aux_4143 = ((bool_t) 1);
	      }
	    return
	       BBOOL(aux_4143);
	 }
      }
   }
}



/* _set-initial-approx! */
obj_t 
_set_initial_approx__130_cfa_setup(obj_t env_4083, obj_t globals_4084)
{
   AN_OBJECT;
   {	/* Cfa/setup.scm 34 */
      return
	 set_initial_approx__92_cfa_setup(globals_4084);
   }
}



/* alloc-type? */
bool_t 
alloc_type__187_cfa_setup(type_bglt type_8)
{
   AN_OBJECT;
   {	/* Cfa/setup.scm 95 */
      {		/* Cfa/setup.scm 97 */
	 bool_t test2172_2180;
	 {	/* Cfa/setup.scm 97 */
	    obj_t obj2_3335;
	    obj2_3335 = _vector__240_type_cache;
	    {	/* ./Ieee/equiv.scm 5508 */
	       obj_t aux_4187;
	       aux_4187 =
		  (obj_t) (type_8);
	       test2172_2180 =
		  (aux_4187 == obj2_3335);
	    }
	 }
	 if (test2172_2180)
	   {	/* Cfa/setup.scm 97 */
	      return ((bool_t) 1);
	   }
	 else
	   {	/* Cfa/setup.scm 99 */
	      bool_t test2173_2181;
	      {		/* Cfa/setup.scm 99 */
		 obj_t obj2_3337;
		 obj2_3337 = _procedure__226_type_cache;
		 {	/* ./Ieee/equiv.scm 5508 */
		    obj_t aux_4191;
		    aux_4191 =
		       (obj_t) (type_8);
		    test2173_2181 =
		       (aux_4191 == obj2_3337);
		 }
	      }
	      if (test2173_2181)
		{	/* Cfa/setup.scm 99 */
		   return ((bool_t) 1);
		}
	      else
		{	/* Cfa/setup.scm 101 */
		   bool_t test2174_2182;
		   {	/* Cfa/setup.scm 101 */
		      obj_t obj2_3339;
		      obj2_3339 = _struct__183_type_cache;
		      {		/* ./Ieee/equiv.scm 5508 */
			 obj_t aux_4195;
			 aux_4195 =
			    (obj_t) (type_8);
			 test2174_2182 =
			    (aux_4195 == obj2_3339);
		      }
		   }
		   if (test2174_2182)
		     {	/* Cfa/setup.scm 101 */
			return ((bool_t) 1);
		     }
		   else
		     {	/* Cfa/setup.scm 101 */
			return ((bool_t) 0);
		     }
		}
	   }
      }
   }
}



/* node-setup*! */
obj_t 
node_setup___185_cfa_setup(obj_t node__221_50)
{
   AN_OBJECT;
   {	/* Cfa/setup.scm 393 */
      {
	 obj_t l2101_2183;
	 {	/* Cfa/setup.scm 394 */
	    bool_t aux_4199;
	    l2101_2183 = node__221_50;
	  lname2102_2184:
	    if (
	       PAIRP(l2101_2183))
	      {		/* Cfa/setup.scm 394 */
		 {	/* Cfa/setup.scm 394 */
		    node_bglt aux_4202;
		    {	/* Cfa/setup.scm 394 */
		       obj_t aux_4203;
		       aux_4203 =
			  CAR(l2101_2183);
		       aux_4202 =
			  (node_bglt) (aux_4203);
		    }
		    node_setup__189_cfa_setup(aux_4202);
		 }
		 {
		    obj_t l2101_4207;
		    l2101_4207 =
		       CDR(l2101_2183);
		    l2101_2183 = l2101_4207;
		    goto lname2102_2184;
		 }
	      }
	    else
	      {		/* Cfa/setup.scm 394 */
		 aux_4199 = ((bool_t) 1);
	      }
	    return
	       BBOOL(aux_4199);
	 }
      }
   }
}



/* _node-setup*! */
obj_t 
_node_setup___39_cfa_setup(obj_t env_4085, obj_t node__221_4086)
{
   AN_OBJECT;
   {	/* Cfa/setup.scm 393 */
      return
	 node_setup___185_cfa_setup(node__221_4086);
   }
}



/* method-init */
obj_t 
method_init_76_cfa_setup()
{
   AN_OBJECT;
   {	/* Cfa/setup.scm 14 */
      add_generic__110___object(node_setup__env_214_cfa_setup, node_setup__default2103_env_40_cfa_setup);
      add_inlined_method__244___object(node_setup__env_214_cfa_setup, atom_ast_node, ((long) 0));
      add_inlined_method__244___object(node_setup__env_214_cfa_setup, kwote_ast_node, ((long) 1));
      add_inlined_method__244___object(node_setup__env_214_cfa_setup, kwote_node_102_cfa_info, ((long) 2));
      add_inlined_method__244___object(node_setup__env_214_cfa_setup, var_ast_node, ((long) 3));
      add_generic__110___object(variable_value_setup__env_134_cfa_setup, variable_value_setup__default2112_env_55_cfa_setup);
      add_inlined_method__244___object(variable_value_setup__env_134_cfa_setup, sfun_ast_var, ((long) 0));
      add_inlined_method__244___object(variable_value_setup__env_134_cfa_setup, svar_ast_var, ((long) 1));
      add_inlined_method__244___object(variable_value_setup__env_134_cfa_setup, pre_clo_env_191_cfa_info, ((long) 2));
      add_inlined_method__244___object(variable_value_setup__env_134_cfa_setup, sexit_ast_var, ((long) 3));
      add_inlined_method__244___object(variable_value_setup__env_134_cfa_setup, scnst_cinfo_0_cfa_info, ((long) 4));
      add_inlined_method__244___object(variable_value_setup__env_134_cfa_setup, scnst_ast_var, ((long) 5));
      add_inlined_method__244___object(variable_value_setup__env_134_cfa_setup, cvar_ast_var, ((long) 6));
      add_inlined_method__244___object(node_setup__env_214_cfa_setup, closure_ast_node, ((long) 4));
      add_inlined_method__244___object(node_setup__env_214_cfa_setup, sequence_ast_node, ((long) 5));
      add_inlined_method__244___object(node_setup__env_214_cfa_setup, app_ast_node, ((long) 6));
      add_generic__110___object(fun_setup__env_196_cfa_setup, fun_setup__default2133_env_165_cfa_setup);
      add_inlined_method__244___object(fun_setup__env_196_cfa_setup, sfun_ast_var, ((long) 0));
      add_inlined_method__244___object(fun_setup__env_196_cfa_setup, cfun_ast_var, ((long) 1));
      add_inlined_method__244___object(node_setup__env_214_cfa_setup, app_ly_162_ast_node, ((long) 7));
      add_inlined_method__244___object(node_setup__env_214_cfa_setup, funcall_ast_node, ((long) 8));
      add_inlined_method__244___object(node_setup__env_214_cfa_setup, pragma_ast_node, ((long) 9));
      add_inlined_method__244___object(node_setup__env_214_cfa_setup, cast_ast_node, ((long) 10));
      add_inlined_method__244___object(node_setup__env_214_cfa_setup, setq_ast_node, ((long) 11));
      add_inlined_method__244___object(node_setup__env_214_cfa_setup, conditional_ast_node, ((long) 12));
      add_inlined_method__244___object(node_setup__env_214_cfa_setup, fail_ast_node, ((long) 13));
      add_inlined_method__244___object(node_setup__env_214_cfa_setup, select_ast_node, ((long) 14));
      add_inlined_method__244___object(node_setup__env_214_cfa_setup, let_fun_218_ast_node, ((long) 15));
      add_inlined_method__244___object(node_setup__env_214_cfa_setup, let_var_6_ast_node, ((long) 16));
      add_inlined_method__244___object(node_setup__env_214_cfa_setup, set_ex_it_116_ast_node, ((long) 17));
      {		/* Cfa/setup.scm 14 */
	 long aux_4241;
	 aux_4241 =
	    add_inlined_method__244___object(node_setup__env_214_cfa_setup, jump_ex_it_184_ast_node, ((long) 18));
	 return
	    BINT(aux_4241);
      }
   }
}



/* node-setup! */
obj_t 
node_setup__189_cfa_setup(node_bglt node_2)
{
   AN_OBJECT;
   {	/* Cfa/setup.scm 51 */
    node_setup__189_cfa_setup:
      {
	 obj_t method2531_3110;
	 obj_t class2536_3111;
	 {	/* Cfa/setup.scm 51 */
	    obj_t arg2539_3108;
	    obj_t arg2540_3109;
	    {	/* Cfa/setup.scm 51 */
	       object_bglt obj_3690;
	       obj_3690 =
		  (object_bglt) (node_2);
	       {	/* ./Llib/object.scm 2926 */
		  obj_t pre_method_105_3691;
		  pre_method_105_3691 =
		     PROCEDURE_REF(node_setup__env_214_cfa_setup, ((long) 2));
		  if (
		     INTEGERP(pre_method_105_3691))
		    {	/* ./Llib/object.scm 2927 */
		       PROCEDURE_SET(node_setup__env_214_cfa_setup, ((long) 2), BUNSPEC);
		       arg2539_3108 = pre_method_105_3691;
		    }
		  else
		    {	/* ./Llib/object.scm 2914 */
		       long obj_class_num_177_3696;
		       obj_class_num_177_3696 =
			  TYPE(obj_3690);
		       {	/* ./Llib/object.scm 2915 */
			  obj_t arg1176_3697;
			  arg1176_3697 =
			     PROCEDURE_REF(node_setup__env_214_cfa_setup, ((long) 1));
			  {	/* ./Llib/object.scm 2738 */
			     long arg1177_3701;
			     {	/* ./Llib/object.scm 2738 */
				long arg1178_3702;
				arg1178_3702 =
				   OBJECT_TYPE;
				arg1177_3701 =
				   (obj_class_num_177_3696 - arg1178_3702);
			     }
			     arg2539_3108 =
				VECTOR_REF(arg1176_3697, arg1177_3701);
			  }
		       }
		    }
	       }
	    }
	    {	/* Cfa/setup.scm 51 */
	       object_bglt object_3707;
	       object_3707 =
		  (object_bglt) (node_2);
	       {	/* ./Llib/object.scm 2695 */
		  long arg1179_3708;
		  {	/* ./Llib/object.scm 2695 */
		     long arg1180_3709;
		     long arg1181_3710;
		     arg1180_3709 =
			TYPE(object_3707);
		     arg1181_3710 =
			OBJECT_TYPE;
		     arg1179_3708 =
			(arg1180_3709 - arg1181_3710);
		  }
		  {	/* ./Llib/object.scm 2695 */
		     obj_t vector_3714;
		     vector_3714 = _classes__134___object;
		     arg2540_3109 =
			VECTOR_REF(vector_3714, arg1179_3708);
		  }
	       }
	    }
	    method2531_3110 = arg2539_3108;
	    class2536_3111 = arg2540_3109;
	    {

	       if (
		  INTEGERP(method2531_3110))
		 {	/* Cfa/setup.scm 51 */
		    switch (
		       (long) CINT(method2531_3110))
		      {
		      case ((long) 0):

			 {	/* Cfa/setup.scm 57 */
			    atom_bglt node_3117;
			    node_3117 =
			       (atom_bglt) (node_2);
			    {	/* Cfa/setup.scm 58 */
			       atom_cinfo_155_bglt obj2044_3119;
			       obj2044_3119 =
				  ((atom_cinfo_155_bglt) (node_3117));
			       {	/* Cfa/setup.scm 59 */
				  atom_cinfo_155_bglt arg2543_3120;
				  {	/* Cfa/setup.scm 59 */
				     approx_bglt arg2544_3121;
				     {	/* Cfa/setup.scm 59 */
					type_bglt arg2545_3122;
					arg2545_3122 =
					   typeof_atom_134_type_typeof(
					   (((atom_bglt) CREF(node_3117))->value));
					arg2544_3121 =
					   make_type_approx_184_cfa_approx(arg2545_3122);
				     }
				     {	/* Cfa/setup.scm 58 */
					atom_cinfo_155_bglt res2671_3720;
					{	/* ./Cfa/cinfo.scm 1439 */
					   atom_cinfo_155_bglt new1574_3718;
					   new1574_3718 =
					      ((atom_cinfo_155_bglt) BREF(GC_MALLOC(sizeof(struct atom_cinfo_155))));
					   ((((atom_cinfo_155_bglt) CREF(new1574_3718))->approx) = ((approx_bglt) arg2544_3121), BUNSPEC);
					   res2671_3720 = new1574_3718;
					}
					arg2543_3120 = res2671_3720;
				     }
				  }
				  {	/* Cfa/setup.scm 58 */
				     obj_t aux_4270;
				     object_bglt aux_4268;
				     aux_4270 =
					(obj_t) (arg2543_3120);
				     aux_4268 =
					(object_bglt) (obj2044_3119);
				     OBJECT_WIDENING_SET(aux_4268, aux_4270);
				  }
			       }
			       {	/* Cfa/setup.scm 58 */
				  long arg2547_3124;
				  arg2547_3124 =
				     class_num_218___object(atom_cinfo_155_cfa_info);
				  {	/* Cfa/setup.scm 58 */
				     obj_t obj_3721;
				     obj_3721 =
					(obj_t) (obj2044_3119);
				     (((obj_t) CREF(obj_3721))->header = MAKE_HEADER(arg2547_3124, 0), BUNSPEC);
				  }
			       }
			       return
				  (obj_t) (obj2044_3119);
			    }
			 }
			 break;
		      case ((long) 1):

			 {	/* Cfa/setup.scm 65 */
			    kwote_bglt node_3125;
			    node_3125 =
			       (kwote_bglt) (node_2);
			    {	/* Cfa/setup.scm 66 */
			       kwote_cinfo_48_bglt obj2046_3127;
			       obj2046_3127 =
				  ((kwote_cinfo_48_bglt) (node_3125));
			       {	/* Cfa/setup.scm 67 */
				  kwote_cinfo_48_bglt arg2548_3128;
				  {	/* Cfa/setup.scm 67 */
				     approx_bglt arg2549_3129;
				     {	/* Cfa/setup.scm 67 */
					type_bglt arg2550_3130;
					arg2550_3130 =
					   typeof_kwote_49_type_typeof(
					   (((kwote_bglt) CREF(node_3125))->value));
					arg2549_3129 =
					   make_type_approx_184_cfa_approx(arg2550_3130);
				     }
				     {	/* Cfa/setup.scm 66 */
					kwote_cinfo_48_bglt res2672_3727;
					{	/* ./Cfa/cinfo.scm 1441 */
					   kwote_cinfo_48_bglt new1588_3725;
					   new1588_3725 =
					      ((kwote_cinfo_48_bglt) BREF(GC_MALLOC(sizeof(struct kwote_cinfo_48))));
					   ((((kwote_cinfo_48_bglt) CREF(new1588_3725))->approx) = ((approx_bglt) arg2549_3129), BUNSPEC);
					   res2672_3727 = new1588_3725;
					}
					arg2548_3128 = res2672_3727;
				     }
				  }
				  {	/* Cfa/setup.scm 66 */
				     obj_t aux_4286;
				     object_bglt aux_4284;
				     aux_4286 =
					(obj_t) (arg2548_3128);
				     aux_4284 =
					(object_bglt) (obj2046_3127);
				     OBJECT_WIDENING_SET(aux_4284, aux_4286);
				  }
			       }
			       {	/* Cfa/setup.scm 66 */
				  long arg2552_3132;
				  arg2552_3132 =
				     class_num_218___object(kwote_cinfo_48_cfa_info);
				  {	/* Cfa/setup.scm 66 */
				     obj_t obj_3728;
				     obj_3728 =
					(obj_t) (obj2046_3127);
				     (((obj_t) CREF(obj_3728))->header = MAKE_HEADER(arg2552_3132, 0), BUNSPEC);
				  }
			       }
			       return
				  (obj_t) (obj2046_3127);
			    }
			 }
			 break;
		      case ((long) 2):

			 {	/* Cfa/setup.scm 73 */
			    kwote_node_102_bglt kwote_3133;
			    kwote_3133 =
			       (kwote_node_102_bglt) (node_2);
			    {
			       node_bglt node_4294;
			       {
				  obj_t aux_4295;
				  {	/* ./Cfa/cinfo.scm 1440 */
				     object_bglt aux_4296;
				     aux_4296 =
					(object_bglt) (kwote_3133);
				     aux_4295 =
					OBJECT_WIDENING(aux_4296);
				  }
				  node_4294 =
				     (((kwote_node_102_bglt) CREF(aux_4295))->node);
			       }
			       node_2 = node_4294;
			       goto node_setup__189_cfa_setup;
			    }
			 }
			 break;
		      case ((long) 3):

			 {	/* Cfa/setup.scm 80 */
			    var_bglt node_3136;
			    node_3136 =
			       (var_bglt) (node_2);
			    {	/* Cfa/setup.scm 81 */
			       value_bglt aux_4301;
			       {	/* Cfa/setup.scm 81 */
				  variable_bglt arg2556_3140;
				  arg2556_3140 =
				     (((var_bglt) CREF(node_3136))->variable);
				  aux_4301 =
				     (((variable_bglt) CREF(arg2556_3140))->value);
			       }
			       variable_value_setup__80_cfa_setup(aux_4301,
				  (((var_bglt) CREF(node_3136))->variable));
			    }
			    {	/* Cfa/setup.scm 84 */
			       bool_t test2557_3141;
			       {	/* Cfa/setup.scm 84 */
				  bool_t test2567_3153;
				  {	/* ./Ast/var.scm 1128 */
				     obj_t aux_4306;
				     {	/* Cfa/setup.scm 84 */
					variable_bglt aux_4307;
					aux_4307 =
					   (((var_bglt) CREF(node_3136))->variable);
					aux_4306 =
					   (obj_t) (aux_4307);
				     }
				     test2567_3153 =
					is_a__118___object(aux_4306, local_ast_var);
				  }
				  if (test2567_3153)
				    {	/* Cfa/setup.scm 84 */
				       bool_t test2568_3154;
				       {	/* ./Cfa/cinfo.scm 1434 */
					  obj_t aux_4312;
					  {	/* Cfa/setup.scm 84 */
					     variable_bglt aux_4313;
					     aux_4313 =
						(((var_bglt) CREF(node_3136))->variable);
					     aux_4312 =
						(obj_t) (aux_4313);
					  }
					  test2568_3154 =
					     is_a__118___object(aux_4312, reshaped_local_224_cfa_info);
				       }
				       if (test2568_3154)
					 {	/* Cfa/setup.scm 84 */
					    test2557_3141 = ((bool_t) 0);
					 }
				       else
					 {	/* Cfa/setup.scm 84 */
					    test2557_3141 = ((bool_t) 1);
					 }
				    }
				  else
				    {	/* Cfa/setup.scm 84 */
				       test2557_3141 = ((bool_t) 0);
				    }
			       }
			       if (test2557_3141)
				 {	/* Cfa/setup.scm 84 */
				    {	/* Cfa/setup.scm 85 */
				       reshaped_local_224_bglt obj2049_3142;
				       obj2049_3142 =
					  ((reshaped_local_224_bglt) (
					     (((var_bglt) CREF(node_3136))->variable)));
				       {	/* Cfa/setup.scm 85 */
					  reshaped_local_224_bglt arg2558_3143;
					  {	/* Cfa/setup.scm 85 */
					     reshaped_local_224_bglt res2673_3742;
					     {	/* Cfa/setup.scm 85 */
						obj_t binding_value_3_3739;
						binding_value_3_3739 = BFALSE;
						{	/* ./Cfa/cinfo.scm 1434 */
						   reshaped_local_224_bglt new1549_3740;
						   new1549_3740 =
						      ((reshaped_local_224_bglt) BREF(GC_MALLOC(sizeof(struct reshaped_local_224))));
						   ((((reshaped_local_224_bglt) CREF(new1549_3740))->binding_value_3) = ((obj_t) binding_value_3_3739), BUNSPEC);
						   res2673_3742 = new1549_3740;
						}
					     }
					     arg2558_3143 = res2673_3742;
					  }
					  {	/* Cfa/setup.scm 85 */
					     obj_t aux_4325;
					     object_bglt aux_4323;
					     aux_4325 =
						(obj_t) (arg2558_3143);
					     aux_4323 =
						(object_bglt) (obj2049_3142);
					     OBJECT_WIDENING_SET(aux_4323, aux_4325);
					  }
				       }
				       {	/* Cfa/setup.scm 85 */
					  long arg2559_3144;
					  arg2559_3144 =
					     class_num_218___object(reshaped_local_224_cfa_info);
					  {	/* Cfa/setup.scm 85 */
					     obj_t obj_3743;
					     obj_3743 =
						(obj_t) (obj2049_3142);
					     (((obj_t) CREF(obj_3743))->header = MAKE_HEADER(arg2559_3144, 0), BUNSPEC);
					  }
				       }
				       return
					  (obj_t) (obj2049_3142);
				    }
				 }
			       else
				 {	/* Cfa/setup.scm 86 */
				    bool_t test2560_3145;
				    {	/* Cfa/setup.scm 86 */
				       bool_t test2563_3149;
				       {	/* ./Ast/var.scm 1108 */
					  obj_t aux_4332;
					  {	/* Cfa/setup.scm 86 */
					     variable_bglt aux_4333;
					     aux_4333 =
						(((var_bglt) CREF(node_3136))->variable);
					     aux_4332 =
						(obj_t) (aux_4333);
					  }
					  test2563_3149 =
					     is_a__118___object(aux_4332, global_ast_var);
				       }
				       if (test2563_3149)
					 {	/* Cfa/setup.scm 86 */
					    bool_t test2564_3150;
					    {	/* ./Cfa/cinfo.scm 1436 */
					       obj_t aux_4338;
					       {	/* Cfa/setup.scm 86 */
						  variable_bglt aux_4339;
						  aux_4339 =
						     (((var_bglt) CREF(node_3136))->variable);
						  aux_4338 =
						     (obj_t) (aux_4339);
					       }
					       test2564_3150 =
						  is_a__118___object(aux_4338, reshaped_global_160_cfa_info);
					    }
					    if (test2564_3150)
					      {		/* Cfa/setup.scm 86 */
						 test2560_3145 = ((bool_t) 0);
					      }
					    else
					      {		/* Cfa/setup.scm 86 */
						 test2560_3145 = ((bool_t) 1);
					      }
					 }
				       else
					 {	/* Cfa/setup.scm 86 */
					    test2560_3145 = ((bool_t) 0);
					 }
				    }
				    if (test2560_3145)
				      {		/* Cfa/setup.scm 86 */
					 {	/* Cfa/setup.scm 87 */
					    reshaped_global_160_bglt obj2050_3146;
					    obj2050_3146 =
					       ((reshaped_global_160_bglt) (
						  (((var_bglt) CREF(node_3136))->variable)));
					    {	/* Cfa/setup.scm 87 */
					       obj_t aux_4349;
					       object_bglt aux_4347;
					       {	/* Cfa/setup.scm 87 */
						  reshaped_global_160_bglt aux_4350;
						  {	/* ./Cfa/cinfo.scm 1436 */

						     aux_4350 =
							((reshaped_global_160_bglt) BREF(GC_MALLOC(sizeof(struct reshaped_global_160))));
						  }
						  aux_4349 =
						     (obj_t) (aux_4350);
					       }
					       aux_4347 =
						  (object_bglt) (obj2050_3146);
					       OBJECT_WIDENING_SET(aux_4347, aux_4349);
					    }
					    {	/* Cfa/setup.scm 87 */
					       long arg2562_3148;
					       arg2562_3148 =
						  class_num_218___object(reshaped_global_160_cfa_info);
					       {	/* Cfa/setup.scm 87 */
						  obj_t obj_3752;
						  obj_3752 =
						     (obj_t) (obj2050_3146);
						  (((obj_t) CREF(obj_3752))->header = MAKE_HEADER(arg2562_3148, 0), BUNSPEC);
					       }
					    }
					    return
					       (obj_t) (obj2050_3146);
					 }
				      }
				    else
				      {		/* Cfa/setup.scm 86 */
					 return BFALSE;
				      }
				 }
			    }
			 }
			 break;
		      case ((long) 4):

			 {	/* Cfa/setup.scm 188 */
			    obj_t arg2573_3160;
			    {	/* Cfa/setup.scm 188 */
			       obj_t aux_4358;
			       {	/* Cfa/setup.scm 188 */
				  closure_bglt aux_4359;
				  aux_4359 =
				     (closure_bglt) (node_2);
				  aux_4358 =
				     (obj_t) (aux_4359);
			       }
			       arg2573_3160 =
				  shape_tools_shape(aux_4358);
			    }
			    return
			       internal_error_43_tools_error(string2704_cfa_setup, string2705_cfa_setup, arg2573_3160);
			 }
			 break;
		      case ((long) 5):

			 {	/* Cfa/setup.scm 194 */
			    sequence_bglt node_3161;
			    node_3161 =
			       (sequence_bglt) (node_2);
			    return
			       node_setup___185_cfa_setup(
			       (((sequence_bglt) CREF(node_3161))->nodes));
			 }
			 break;
		      case ((long) 6):

			 {	/* Cfa/setup.scm 51 */
			    app_bglt node_3164;
			    node_3164 =
			       (app_bglt) (node_2);
			    node_setup___185_cfa_setup(
			       (((app_bglt) CREF(node_3164))->args));
			    {	/* Cfa/setup.scm 204 */
			       variable_bglt variable_3167;
			       {	/* Cfa/setup.scm 204 */
				  var_bglt arg2578_3169;
				  arg2578_3169 =
				     (((app_bglt) CREF(node_3164))->fun);
				  variable_3167 =
				     (((var_bglt) CREF(arg2578_3169))->variable);
			       }
			       {	/* Cfa/setup.scm 205 */
				  fun_bglt aux_4372;
				  {	/* Cfa/setup.scm 205 */
				     value_bglt aux_4373;
				     aux_4373 =
					(((variable_bglt) CREF(variable_3167))->value);
				     aux_4372 =
					(fun_bglt) (aux_4373);
				  }
				  return
				     fun_setup__186_cfa_setup(aux_4372,
				     (obj_t) (variable_3167));
			       }
			    }
			 }
			 break;
		      case ((long) 7):

			 {	/* Cfa/setup.scm 244 */
			    app_ly_162_bglt node_3170;
			    node_3170 =
			       (app_ly_162_bglt) (node_2);
			    node_setup__189_cfa_setup(
			       (((app_ly_162_bglt) CREF(node_3170))->fun));
			    node_setup__189_cfa_setup(
			       (((app_ly_162_bglt) CREF(node_3170))->arg));
			    {	/* Cfa/setup.scm 247 */
			       app_ly_cinfo_234_bglt obj2069_3174;
			       obj2069_3174 =
				  ((app_ly_cinfo_234_bglt) (node_3170));
			       {	/* Cfa/setup.scm 248 */
				  app_ly_cinfo_234_bglt arg2581_3175;
				  {	/* Cfa/setup.scm 248 */
				     approx_bglt arg2582_3176;
				     arg2582_3176 =
					make_type_approx_184_cfa_approx(
					(type_bglt) (_obj__252_type_cache));
				     {	/* Cfa/setup.scm 247 */
					app_ly_cinfo_234_bglt res2675_3764;
					{	/* ./Cfa/cinfo.scm 1442 */
					   app_ly_cinfo_234_bglt new1597_3762;
					   new1597_3762 =
					      ((app_ly_cinfo_234_bglt) BREF(GC_MALLOC(sizeof(struct app_ly_cinfo_234))));
					   ((((app_ly_cinfo_234_bglt) CREF(new1597_3762))->approx) = ((approx_bglt) arg2582_3176), BUNSPEC);
					   res2675_3764 = new1597_3762;
					}
					arg2581_3175 = res2675_3764;
				     }
				  }
				  {	/* Cfa/setup.scm 247 */
				     obj_t aux_4390;
				     object_bglt aux_4388;
				     aux_4390 =
					(obj_t) (arg2581_3175);
				     aux_4388 =
					(object_bglt) (obj2069_3174);
				     OBJECT_WIDENING_SET(aux_4388, aux_4390);
				  }
			       }
			       {	/* Cfa/setup.scm 247 */
				  long arg2583_3177;
				  arg2583_3177 =
				     class_num_218___object(app_ly_cinfo_234_cfa_info);
				  {	/* Cfa/setup.scm 247 */
				     obj_t obj_3765;
				     obj_3765 =
					(obj_t) (obj2069_3174);
				     (((obj_t) CREF(obj_3765))->header = MAKE_HEADER(arg2583_3177, 0), BUNSPEC);
				  }
			       }
			       obj2069_3174;
			    }
			    {	/* Cfa/setup.scm 249 */
			       approx_bglt aux_4396;
			       {	/* Cfa/setup.scm 249 */
				  app_ly_cinfo_234_bglt obj_3767;
				  obj_3767 =
				     (app_ly_cinfo_234_bglt) (node_3170);
				  {
				     obj_t aux_4398;
				     {	/* ./Cfa/cinfo.scm 1442 */
					object_bglt aux_4399;
					aux_4399 =
					   (object_bglt) (obj_3767);
					aux_4398 =
					   OBJECT_WIDENING(aux_4399);
				     }
				     aux_4396 =
					(((app_ly_cinfo_234_bglt) CREF(aux_4398))->approx);
				  }
			       }
			       return
				  approx_set_top__187_cfa_approx(aux_4396);
			    }
			 }
			 break;
		      case ((long) 8):

			 {	/* Cfa/setup.scm 255 */
			    funcall_bglt node_3179;
			    node_3179 =
			       (funcall_bglt) (node_2);
			    node_setup__189_cfa_setup(
			       (((funcall_bglt) CREF(node_3179))->fun));
			    node_setup___185_cfa_setup(
			       (((funcall_bglt) CREF(node_3179))->args));
			    {	/* Cfa/setup.scm 258 */
			       funcall_cinfo_75_bglt obj2071_3183;
			       obj2071_3183 =
				  ((funcall_cinfo_75_bglt) (node_3179));
			       {	/* Cfa/setup.scm 259 */
				  funcall_cinfo_75_bglt arg2587_3184;
				  {	/* Cfa/setup.scm 259 */
				     approx_bglt arg2588_3185;
				     approx_bglt arg2589_3186;
				     bool_t arg2590_3187;
				     bool_t arg2591_3188;
				     arg2588_3185 =
					make_type_approx_184_cfa_approx(
					(type_bglt) (_obj__252_type_cache));
				     arg2589_3186 =
					make_type_approx_184_cfa_approx(
					(type_bglt) (_obj__252_type_cache));
				     if (
					CBOOL(_warning__61___error))
				       {	/* ./Cfa/cinfo.scm 1446 */
					  arg2590_3187 = ((bool_t) 0);
				       }
				     else
				       {	/* ./Cfa/cinfo.scm 1446 */
					  arg2590_3187 = ((bool_t) 1);
				       }
				     if (
					CBOOL(_warning__61___error))
				       {	/* ./Cfa/cinfo.scm 1447 */
					  arg2591_3188 = ((bool_t) 0);
				       }
				     else
				       {	/* ./Cfa/cinfo.scm 1447 */
					  arg2591_3188 = ((bool_t) 1);
				       }
				     {	/* Cfa/setup.scm 258 */
					funcall_cinfo_75_bglt res2676_3779;
					{	/* ./Cfa/cinfo.scm 1443 */
					   funcall_cinfo_75_bglt new1609_3774;
					   new1609_3774 =
					      ((funcall_cinfo_75_bglt) BREF(GC_MALLOC(sizeof(struct funcall_cinfo_75))));
					   ((((funcall_cinfo_75_bglt) CREF(new1609_3774))->approx) = ((approx_bglt) arg2588_3185), BUNSPEC);
					   ((((funcall_cinfo_75_bglt) CREF(new1609_3774))->va_approx_63) = ((approx_bglt) arg2589_3186), BUNSPEC);
					   ((((funcall_cinfo_75_bglt) CREF(new1609_3774))->arity_error_noticed__118) = ((bool_t) arg2590_3187), BUNSPEC);
					   ((((funcall_cinfo_75_bglt) CREF(new1609_3774))->type_error_noticed__36) = ((bool_t) arg2591_3188), BUNSPEC);
					   res2676_3779 = new1609_3774;
					}
					arg2587_3184 = res2676_3779;
				     }
				  }
				  {	/* Cfa/setup.scm 258 */
				     obj_t aux_4425;
				     object_bglt aux_4423;
				     aux_4425 =
					(obj_t) (arg2587_3184);
				     aux_4423 =
					(object_bglt) (obj2071_3183);
				     OBJECT_WIDENING_SET(aux_4423, aux_4425);
				  }
			       }
			       {	/* Cfa/setup.scm 258 */
				  long arg2592_3189;
				  arg2592_3189 =
				     class_num_218___object(funcall_cinfo_75_cfa_info);
				  {	/* Cfa/setup.scm 258 */
				     obj_t obj_3780;
				     obj_3780 =
					(obj_t) (obj2071_3183);
				     (((obj_t) CREF(obj_3780))->header = MAKE_HEADER(arg2592_3189, 0), BUNSPEC);
				  }
			       }
			       obj2071_3183;
			    }
			    {	/* Cfa/setup.scm 261 */
			       approx_bglt aux_4431;
			       {	/* Cfa/setup.scm 261 */
				  funcall_cinfo_75_bglt obj_3782;
				  obj_3782 =
				     (funcall_cinfo_75_bglt) (node_3179);
				  {
				     obj_t aux_4433;
				     {	/* ./Cfa/cinfo.scm 1445 */
					object_bglt aux_4434;
					aux_4434 =
					   (object_bglt) (obj_3782);
					aux_4433 =
					   OBJECT_WIDENING(aux_4434);
				     }
				     aux_4431 =
					(((funcall_cinfo_75_bglt) CREF(aux_4433))->va_approx_63);
				  }
			       }
			       return
				  approx_set_top__187_cfa_approx(aux_4431);
			    }
			 }
			 break;
		      case ((long) 9):

			 {	/* Cfa/setup.scm 267 */
			    pragma_bglt node_3191;
			    node_3191 =
			       (pragma_bglt) (node_2);
			    node_setup___185_cfa_setup(
			       (((pragma_bglt) CREF(node_3191))->args));
			    {	/* Cfa/setup.scm 269 */
			       pragma_cinfo_220_bglt obj2073_3194;
			       obj2073_3194 =
				  ((pragma_cinfo_220_bglt) (node_3191));
			       {	/* Cfa/setup.scm 270 */
				  pragma_cinfo_220_bglt arg2595_3195;
				  {	/* Cfa/setup.scm 270 */
				     approx_bglt arg2596_3196;
				     arg2596_3196 =
					make_type_approx_184_cfa_approx(
					(((pragma_bglt) CREF(node_3191))->type));
				     {	/* Cfa/setup.scm 269 */
					pragma_cinfo_220_bglt res2677_3788;
					{	/* ./Cfa/cinfo.scm 1448 */
					   pragma_cinfo_220_bglt new1622_3786;
					   new1622_3786 =
					      ((pragma_cinfo_220_bglt) BREF(GC_MALLOC(sizeof(struct pragma_cinfo_220))));
					   ((((pragma_cinfo_220_bglt) CREF(new1622_3786))->approx) = ((approx_bglt) arg2596_3196), BUNSPEC);
					   res2677_3788 = new1622_3786;
					}
					arg2595_3195 = res2677_3788;
				     }
				  }
				  {	/* Cfa/setup.scm 269 */
				     obj_t aux_4449;
				     object_bglt aux_4447;
				     aux_4449 =
					(obj_t) (arg2595_3195);
				     aux_4447 =
					(object_bglt) (obj2073_3194);
				     OBJECT_WIDENING_SET(aux_4447, aux_4449);
				  }
			       }
			       {	/* Cfa/setup.scm 269 */
				  long arg2598_3198;
				  arg2598_3198 =
				     class_num_218___object(pragma_cinfo_220_cfa_info);
				  {	/* Cfa/setup.scm 269 */
				     obj_t obj_3789;
				     obj_3789 =
					(obj_t) (obj2073_3194);
				     (((obj_t) CREF(obj_3789))->header = MAKE_HEADER(arg2598_3198, 0), BUNSPEC);
				  }
			       }
			       obj2073_3194;
			    }
			    {	/* Cfa/setup.scm 271 */
			       approx_bglt aux_4455;
			       {	/* Cfa/setup.scm 271 */
				  pragma_cinfo_220_bglt obj_3791;
				  obj_3791 =
				     (pragma_cinfo_220_bglt) (node_3191);
				  {
				     obj_t aux_4457;
				     {	/* ./Cfa/cinfo.scm 1448 */
					object_bglt aux_4458;
					aux_4458 =
					   (object_bglt) (obj_3791);
					aux_4457 =
					   OBJECT_WIDENING(aux_4458);
				     }
				     aux_4455 =
					(((pragma_cinfo_220_bglt) CREF(aux_4457))->approx);
				  }
			       }
			       return
				  approx_set_top__187_cfa_approx(aux_4455);
			    }
			 }
			 break;
		      case ((long) 10):

			 {	/* Cfa/setup.scm 277 */
			    cast_bglt node_3200;
			    node_3200 =
			       (cast_bglt) (node_2);
			    {
			       node_bglt node_4464;
			       node_4464 =
				  (((cast_bglt) CREF(node_3200))->arg);
			       node_2 = node_4464;
			       goto node_setup__189_cfa_setup;
			    }
			 }
			 break;
		      case ((long) 11):

			 {	/* Cfa/setup.scm 51 */
			    setq_bglt node_3203;
			    node_3203 =
			       (setq_bglt) (node_2);
			    node_setup__189_cfa_setup(
			       (((setq_bglt) CREF(node_3203))->value));
			    {	/* Cfa/setup.scm 287 */
			       node_bglt aux_4469;
			       {	/* Cfa/setup.scm 287 */
				  var_bglt aux_4470;
				  aux_4470 =
				     (((setq_bglt) CREF(node_3203))->var);
				  aux_4469 =
				     (node_bglt) (aux_4470);
			       }
			       node_setup__189_cfa_setup(aux_4469);
			    }
			    {	/* Cfa/setup.scm 288 */
			       setq_cinfo_191_bglt obj2076_3207;
			       obj2076_3207 =
				  ((setq_cinfo_191_bglt) (node_3203));
			       {	/* Cfa/setup.scm 289 */
				  setq_cinfo_191_bglt arg2603_3208;
				  {	/* Cfa/setup.scm 289 */
				     approx_bglt arg2604_3209;
				     arg2604_3209 =
					make_type_approx_184_cfa_approx(
					(type_bglt) (_unspec__87_type_cache));
				     {	/* Cfa/setup.scm 288 */
					setq_cinfo_191_bglt res2678_3798;
					{	/* ./Cfa/cinfo.scm 1449 */
					   setq_cinfo_191_bglt new1631_3796;
					   new1631_3796 =
					      ((setq_cinfo_191_bglt) BREF(GC_MALLOC(sizeof(struct setq_cinfo_191))));
					   ((((setq_cinfo_191_bglt) CREF(new1631_3796))->approx) = ((approx_bglt) arg2604_3209), BUNSPEC);
					   res2678_3798 = new1631_3796;
					}
					arg2603_3208 = res2678_3798;
				     }
				  }
				  {	/* Cfa/setup.scm 288 */
				     obj_t aux_4481;
				     object_bglt aux_4479;
				     aux_4481 =
					(obj_t) (arg2603_3208);
				     aux_4479 =
					(object_bglt) (obj2076_3207);
				     OBJECT_WIDENING_SET(aux_4479, aux_4481);
				  }
			       }
			       {	/* Cfa/setup.scm 288 */
				  long arg2605_3210;
				  arg2605_3210 =
				     class_num_218___object(setq_cinfo_191_cfa_info);
				  {	/* Cfa/setup.scm 288 */
				     obj_t obj_3799;
				     obj_3799 =
					(obj_t) (obj2076_3207);
				     (((obj_t) CREF(obj_3799))->header = MAKE_HEADER(arg2605_3210, 0), BUNSPEC);
				  }
			       }
			       return
				  (obj_t) (obj2076_3207);
			    }
			 }
			 break;
		      case ((long) 12):

			 {	/* Cfa/setup.scm 295 */
			    conditional_bglt node_3211;
			    node_3211 =
			       (conditional_bglt) (node_2);
			    node_setup__189_cfa_setup(
			       (((conditional_bglt) CREF(node_3211))->test));
			    node_setup__189_cfa_setup(
			       (((conditional_bglt) CREF(node_3211))->true));
			    node_setup__189_cfa_setup(
			       (((conditional_bglt) CREF(node_3211))->false));
			    {	/* Cfa/setup.scm 299 */
			       conditional_cinfo_212_bglt obj2078_3216;
			       obj2078_3216 =
				  ((conditional_cinfo_212_bglt) (node_3211));
			       {	/* Cfa/setup.scm 300 */
				  conditional_cinfo_212_bglt arg2609_3217;
				  {	/* Cfa/setup.scm 300 */
				     approx_bglt arg2610_3218;
				     arg2610_3218 =
					make_empty_approx_131_cfa_approx();
				     {	/* Cfa/setup.scm 299 */
					conditional_cinfo_212_bglt res2679_3807;
					{	/* ./Cfa/cinfo.scm 1450 */
					   conditional_cinfo_212_bglt new1643_3805;
					   new1643_3805 =
					      ((conditional_cinfo_212_bglt) BREF(GC_MALLOC(sizeof(struct conditional_cinfo_212))));
					   ((((conditional_cinfo_212_bglt) CREF(new1643_3805))->approx) = ((approx_bglt) arg2610_3218), BUNSPEC);
					   res2679_3807 = new1643_3805;
					}
					arg2609_3217 = res2679_3807;
				     }
				  }
				  {	/* Cfa/setup.scm 299 */
				     obj_t aux_4501;
				     object_bglt aux_4499;
				     aux_4501 =
					(obj_t) (arg2609_3217);
				     aux_4499 =
					(object_bglt) (obj2078_3216);
				     OBJECT_WIDENING_SET(aux_4499, aux_4501);
				  }
			       }
			       {	/* Cfa/setup.scm 299 */
				  long arg2611_3219;
				  arg2611_3219 =
				     class_num_218___object(conditional_cinfo_212_cfa_info);
				  {	/* Cfa/setup.scm 299 */
				     obj_t obj_3808;
				     obj_3808 =
					(obj_t) (obj2078_3216);
				     (((obj_t) CREF(obj_3808))->header = MAKE_HEADER(arg2611_3219, 0), BUNSPEC);
				  }
			       }
			       return
				  (obj_t) (obj2078_3216);
			    }
			 }
			 break;
		      case ((long) 13):

			 {	/* Cfa/setup.scm 306 */
			    fail_bglt node_3220;
			    node_3220 =
			       (fail_bglt) (node_2);
			    node_setup__189_cfa_setup(
			       (((fail_bglt) CREF(node_3220))->proc));
			    node_setup__189_cfa_setup(
			       (((fail_bglt) CREF(node_3220))->msg));
			    node_setup__189_cfa_setup(
			       (((fail_bglt) CREF(node_3220))->obj));
			    {	/* Cfa/setup.scm 310 */
			       fail_cinfo_75_bglt obj2080_3225;
			       obj2080_3225 =
				  ((fail_cinfo_75_bglt) (node_3220));
			       {	/* Cfa/setup.scm 311 */
				  fail_cinfo_75_bglt arg2615_3226;
				  {	/* Cfa/setup.scm 311 */
				     approx_bglt arg2616_3227;
				     arg2616_3227 =
					make_type_approx_184_cfa_approx(
					(type_bglt) (_obj__252_type_cache));
				     {	/* Cfa/setup.scm 310 */
					fail_cinfo_75_bglt res2680_3816;
					{	/* ./Cfa/cinfo.scm 1451 */
					   fail_cinfo_75_bglt new1653_3814;
					   new1653_3814 =
					      ((fail_cinfo_75_bglt) BREF(GC_MALLOC(sizeof(struct fail_cinfo_75))));
					   ((((fail_cinfo_75_bglt) CREF(new1653_3814))->approx) = ((approx_bglt) arg2616_3227), BUNSPEC);
					   res2680_3816 = new1653_3814;
					}
					arg2615_3226 = res2680_3816;
				     }
				  }
				  {	/* Cfa/setup.scm 310 */
				     obj_t aux_4522;
				     object_bglt aux_4520;
				     aux_4522 =
					(obj_t) (arg2615_3226);
				     aux_4520 =
					(object_bglt) (obj2080_3225);
				     OBJECT_WIDENING_SET(aux_4520, aux_4522);
				  }
			       }
			       {	/* Cfa/setup.scm 310 */
				  long arg2617_3228;
				  arg2617_3228 =
				     class_num_218___object(fail_cinfo_75_cfa_info);
				  {	/* Cfa/setup.scm 310 */
				     obj_t obj_3817;
				     obj_3817 =
					(obj_t) (obj2080_3225);
				     (((obj_t) CREF(obj_3817))->header = MAKE_HEADER(arg2617_3228, 0), BUNSPEC);
				  }
			       }
			       return
				  (obj_t) (obj2080_3225);
			    }
			 }
			 break;
		      case ((long) 14):

			 {	/* Cfa/setup.scm 317 */
			    select_bglt node_3229;
			    node_3229 =
			       (select_bglt) (node_2);
			    node_setup__189_cfa_setup(
			       (((select_bglt) CREF(node_3229))->test));
			    {
			       obj_t l2082_3232;
			       l2082_3232 =
				  (((select_bglt) CREF(node_3229))->clauses);
			     lname2083_3233:
			       if (
				  PAIRP(l2082_3232))
				 {	/* Cfa/setup.scm 319 */
				    {	/* Cfa/setup.scm 320 */
				       node_bglt aux_4534;
				       {	/* Cfa/setup.scm 320 */
					  obj_t aux_4535;
					  {	/* ./Ieee/pair-list.scm 5707 */
					     obj_t aux_4536;
					     aux_4536 =
						CAR(l2082_3232);
					     aux_4535 =
						CDR(aux_4536);
					  }
					  aux_4534 =
					     (node_bglt) (aux_4535);
				       }
				       node_setup__189_cfa_setup(aux_4534);
				    }
				    {
				       obj_t l2082_4541;
				       l2082_4541 =
					  CDR(l2082_3232);
				       l2082_3232 = l2082_4541;
				       goto lname2083_3233;
				    }
				 }
			       else
				 {	/* Cfa/setup.scm 319 */
				    ((bool_t) 1);
				 }
			    }
			    {	/* Cfa/setup.scm 322 */
			       select_cinfo_150_bglt obj2084_3239;
			       obj2084_3239 =
				  ((select_cinfo_150_bglt) (node_3229));
			       {	/* Cfa/setup.scm 323 */
				  select_cinfo_150_bglt arg2623_3240;
				  {	/* Cfa/setup.scm 323 */
				     approx_bglt arg2624_3241;
				     arg2624_3241 =
					make_empty_approx_131_cfa_approx();
				     {	/* Cfa/setup.scm 322 */
					select_cinfo_150_bglt res2681_3828;
					{	/* ./Cfa/cinfo.scm 1452 */
					   select_cinfo_150_bglt new1663_3826;
					   new1663_3826 =
					      ((select_cinfo_150_bglt) BREF(GC_MALLOC(sizeof(struct select_cinfo_150))));
					   ((((select_cinfo_150_bglt) CREF(new1663_3826))->approx) = ((approx_bglt) arg2624_3241), BUNSPEC);
					   res2681_3828 = new1663_3826;
					}
					arg2623_3240 = res2681_3828;
				     }
				  }
				  {	/* Cfa/setup.scm 322 */
				     obj_t aux_4550;
				     object_bglt aux_4548;
				     aux_4550 =
					(obj_t) (arg2623_3240);
				     aux_4548 =
					(object_bglt) (obj2084_3239);
				     OBJECT_WIDENING_SET(aux_4548, aux_4550);
				  }
			       }
			       {	/* Cfa/setup.scm 322 */
				  long arg2625_3242;
				  arg2625_3242 =
				     class_num_218___object(select_cinfo_150_cfa_info);
				  {	/* Cfa/setup.scm 322 */
				     obj_t obj_3829;
				     obj_3829 =
					(obj_t) (obj2084_3239);
				     (((obj_t) CREF(obj_3829))->header = MAKE_HEADER(arg2625_3242, 0), BUNSPEC);
				  }
			       }
			       return
				  (obj_t) (obj2084_3239);
			    }
			 }
			 break;
		      case ((long) 15):

			 {	/* Cfa/setup.scm 329 */
			    let_fun_218_bglt node_3243;
			    node_3243 =
			       (let_fun_218_bglt) (node_2);
			    {
			       obj_t l2086_3245;
			       l2086_3245 =
				  (((let_fun_218_bglt) CREF(node_3243))->locals);
			     lname2087_3246:
			       if (
				  PAIRP(l2086_3245))
				 {	/* Cfa/setup.scm 330 */
				    {	/* Cfa/setup.scm 330 */
				       obj_t l_3249;
				       l_3249 =
					  CAR(l2086_3245);
				       {	/* Cfa/setup.scm 331 */
					  reshaped_local_224_bglt obj2088_3250;
					  obj2088_3250 =
					     ((reshaped_local_224_bglt) (l_3249));
					  {	/* Cfa/setup.scm 331 */
					     reshaped_local_224_bglt arg2628_3251;
					     {	/* Cfa/setup.scm 331 */
						reshaped_local_224_bglt res2682_3837;
						{	/* Cfa/setup.scm 331 */
						   obj_t binding_value_3_3834;
						   binding_value_3_3834 = BFALSE;
						   {	/* ./Cfa/cinfo.scm 1434 */
						      reshaped_local_224_bglt new1549_3835;
						      new1549_3835 =
							 ((reshaped_local_224_bglt) BREF(GC_MALLOC(sizeof(struct reshaped_local_224))));
						      ((((reshaped_local_224_bglt) CREF(new1549_3835))->binding_value_3) = ((obj_t) binding_value_3_3834), BUNSPEC);
						      res2682_3837 = new1549_3835;
						   }
						}
						arg2628_3251 = res2682_3837;
					     }
					     {	/* Cfa/setup.scm 331 */
						obj_t aux_4566;
						object_bglt aux_4564;
						aux_4566 =
						   (obj_t) (arg2628_3251);
						aux_4564 =
						   (object_bglt) (obj2088_3250);
						OBJECT_WIDENING_SET(aux_4564, aux_4566);
					     }
					  }
					  {	/* Cfa/setup.scm 331 */
					     long arg2629_3252;
					     arg2629_3252 =
						class_num_218___object(reshaped_local_224_cfa_info);
					     {	/* Cfa/setup.scm 331 */
						obj_t obj_3838;
						obj_3838 =
						   (obj_t) (obj2088_3250);
						(((obj_t) CREF(obj_3838))->header = MAKE_HEADER(arg2629_3252, 0), BUNSPEC);
					     }
					  }
					  obj2088_3250;
				       }
				       {	/* Cfa/setup.scm 332 */
					  value_bglt fun_3253;
					  {	/* Cfa/setup.scm 332 */
					     local_bglt obj_3840;
					     obj_3840 =
						(local_bglt) (l_3249);
					     fun_3253 =
						(((local_bglt) CREF(obj_3840))->value);
					  }
					  {
					     obj_t l2089_3254;
					     {	/* Cfa/setup.scm 337 */
						sfun_bglt obj_3841;
						obj_3841 =
						   (sfun_bglt) (fun_3253);
						l2089_3254 =
						   (((sfun_bglt) CREF(obj_3841))->args);
					     }
					   lname2090_3255:
					     if (
						PAIRP(l2089_3254))
					       {	/* Cfa/setup.scm 333 */
						  {	/* Cfa/setup.scm 333 */
						     obj_t local_3258;
						     local_3258 =
							CAR(l2089_3254);
						     {	/* Cfa/setup.scm 334 */
							reshaped_local_224_bglt obj2091_3259;
							obj2091_3259 =
							   ((reshaped_local_224_bglt) (local_3258));
							{	/* Cfa/setup.scm 334 */
							   reshaped_local_224_bglt arg2632_3260;
							   {	/* Cfa/setup.scm 334 */
							      reshaped_local_224_bglt res2683_3847;
							      {		/* Cfa/setup.scm 334 */
								 obj_t binding_value_3_3844;
								 binding_value_3_3844 = BFALSE;
								 {	/* ./Cfa/cinfo.scm 1434 */
								    reshaped_local_224_bglt new1549_3845;
								    new1549_3845 =
								       ((reshaped_local_224_bglt) BREF(GC_MALLOC(sizeof(struct reshaped_local_224))));
								    ((((reshaped_local_224_bglt) CREF(new1549_3845))->binding_value_3) = ((obj_t) binding_value_3_3844), BUNSPEC);
								    res2683_3847 = new1549_3845;
								 }
							      }
							      arg2632_3260 = res2683_3847;
							   }
							   {	/* Cfa/setup.scm 334 */
							      obj_t aux_4582;
							      object_bglt aux_4580;
							      aux_4582 =
								 (obj_t) (arg2632_3260);
							      aux_4580 =
								 (object_bglt) (obj2091_3259);
							      OBJECT_WIDENING_SET(aux_4580, aux_4582);
							   }
							}
							{	/* Cfa/setup.scm 334 */
							   long arg2633_3261;
							   arg2633_3261 =
							      class_num_218___object(reshaped_local_224_cfa_info);
							   {	/* Cfa/setup.scm 334 */
							      obj_t obj_3848;
							      obj_3848 =
								 (obj_t) (obj2091_3259);
							      (((obj_t) CREF(obj_3848))->header = MAKE_HEADER(arg2633_3261, 0), BUNSPEC);
							   }
							}
							obj2091_3259;
						     }
						     {	/* Cfa/setup.scm 335 */
							value_bglt aux_4588;
							{	/* Cfa/setup.scm 335 */
							   local_bglt obj_3850;
							   obj_3850 =
							      (local_bglt) (local_3258);
							   aux_4588 =
							      (((local_bglt) CREF(obj_3850))->value);
							}
							variable_value_setup__80_cfa_setup(aux_4588,
							   (variable_bglt) (local_3258));
						     }
						  }
						  {
						     obj_t l2089_4593;
						     l2089_4593 =
							CDR(l2089_3254);
						     l2089_3254 = l2089_4593;
						     goto lname2090_3255;
						  }
					       }
					     else
					       {	/* Cfa/setup.scm 333 */
						  ((bool_t) 1);
					       }
					  }
					  {	/* Cfa/setup.scm 338 */
					     node_bglt aux_4597;
					     {	/* Cfa/setup.scm 338 */
						obj_t aux_4598;
						{	/* Cfa/setup.scm 338 */
						   sfun_bglt obj_3852;
						   obj_3852 =
						      (sfun_bglt) (fun_3253);
						   aux_4598 =
						      (((sfun_bglt) CREF(obj_3852))->body);
						}
						aux_4597 =
						   (node_bglt) (aux_4598);
					     }
					     node_setup__189_cfa_setup(aux_4597);
					  }
				       }
				    }
				    {
				       obj_t l2086_4603;
				       l2086_4603 =
					  CDR(l2086_3245);
				       l2086_3245 = l2086_4603;
				       goto lname2087_3246;
				    }
				 }
			       else
				 {	/* Cfa/setup.scm 330 */
				    ((bool_t) 1);
				 }
			    }
			    {
			       node_bglt node_4606;
			       node_4606 =
				  (((let_fun_218_bglt) CREF(node_3243))->body);
			       node_2 = node_4606;
			       goto node_setup__189_cfa_setup;
			    }
			 }
			 break;
		      case ((long) 16):

			 {	/* Cfa/setup.scm 346 */
			    let_var_6_bglt node_3267;
			    node_3267 =
			       (let_var_6_bglt) (node_2);
			    {
			       obj_t l2093_3269;
			       l2093_3269 =
				  (((let_var_6_bglt) CREF(node_3267))->bindings);
			     lname2094_3270:
			       if (
				  PAIRP(l2093_3269))
				 {	/* Cfa/setup.scm 348 */
				    {	/* Cfa/setup.scm 349 */
				       obj_t binding_3273;
				       binding_3273 =
					  CAR(l2093_3269);
				       {	/* Cfa/setup.scm 349 */
					  obj_t var_3274;
					  obj_t val_3275;
					  var_3274 =
					     CAR(binding_3273);
					  val_3275 =
					     CDR(binding_3273);
					  {	/* Cfa/setup.scm 351 */
					     value_bglt aux_4614;
					     {	/* Cfa/setup.scm 351 */
						local_bglt obj_3860;
						obj_3860 =
						   (local_bglt) (var_3274);
						aux_4614 =
						   (((local_bglt) CREF(obj_3860))->value);
					     }
					     variable_value_setup__80_cfa_setup(aux_4614,
						(variable_bglt) (var_3274));
					  }
					  {	/* Cfa/setup.scm 355 */
					     reshaped_local_224_bglt obj2095_3277;
					     obj2095_3277 =
						((reshaped_local_224_bglt) (var_3274));
					     {	/* Cfa/setup.scm 356 */
						reshaped_local_224_bglt arg2642_3278;
						{	/* Cfa/setup.scm 356 */
						   obj_t arg2643_3279;
						   {	/* Cfa/setup.scm 356 */
						      bool_t test_4620;
						      {		/* ./Ieee/equiv.scm 5508 */
							 obj_t aux_4624;
							 obj_t aux_4621;
							 aux_4624 =
							    CNST_TABLE_REF(((long) 0));
							 {	/* Cfa/setup.scm 356 */
							    local_bglt obj_3861;
							    obj_3861 =
							       (local_bglt) (var_3274);
							    aux_4621 =
							       (((local_bglt) CREF(obj_3861))->access);
							 }
							 test_4620 =
							    (aux_4621 == aux_4624);
						      }
						      if (test_4620)
							{	/* Cfa/setup.scm 356 */
							   arg2643_3279 = val_3275;
							}
						      else
							{	/* Cfa/setup.scm 356 */
							   arg2643_3279 = BFALSE;
							}
						   }
						   {	/* Cfa/setup.scm 355 */
						      reshaped_local_224_bglt res2684_3867;
						      {		/* ./Cfa/cinfo.scm 1434 */
							 reshaped_local_224_bglt new1549_3865;
							 new1549_3865 =
							    ((reshaped_local_224_bglt) BREF(GC_MALLOC(sizeof(struct reshaped_local_224))));
							 ((((reshaped_local_224_bglt) CREF(new1549_3865))->binding_value_3) = ((obj_t) arg2643_3279), BUNSPEC);
							 res2684_3867 = new1549_3865;
						      }
						      arg2642_3278 = res2684_3867;
						   }
						}
						{	/* Cfa/setup.scm 355 */
						   obj_t aux_4631;
						   object_bglt aux_4629;
						   aux_4631 =
						      (obj_t) (arg2642_3278);
						   aux_4629 =
						      (object_bglt) (obj2095_3277);
						   OBJECT_WIDENING_SET(aux_4629, aux_4631);
						}
					     }
					     {	/* Cfa/setup.scm 355 */
						long arg2647_3283;
						arg2647_3283 =
						   class_num_218___object(reshaped_local_224_cfa_info);
						{	/* Cfa/setup.scm 355 */
						   obj_t obj_3868;
						   obj_3868 =
						      (obj_t) (obj2095_3277);
						   (((obj_t) CREF(obj_3868))->header = MAKE_HEADER(arg2647_3283, 0), BUNSPEC);
						}
					     }
					     obj2095_3277;
					  }
					  node_setup__189_cfa_setup(
					     (node_bglt) (val_3275));
					  BUNSPEC;
				       }
				    }
				    {
				       obj_t l2093_4639;
				       l2093_4639 =
					  CDR(l2093_3269);
				       l2093_3269 = l2093_4639;
				       goto lname2094_3270;
				    }
				 }
			       else
				 {	/* Cfa/setup.scm 348 */
				    ((bool_t) 1);
				 }
			    }
			    {
			       node_bglt node_4642;
			       node_4642 =
				  (((let_var_6_bglt) CREF(node_3267))->body);
			       node_2 = node_4642;
			       goto node_setup__189_cfa_setup;
			    }
			 }
			 break;
		      case ((long) 17):

			 {	/* Cfa/setup.scm 371 */
			    set_ex_it_116_bglt node_3286;
			    node_3286 =
			       (set_ex_it_116_bglt) (node_2);
			    node_setup__189_cfa_setup(
			       (((set_ex_it_116_bglt) CREF(node_3286))->body));
			    {	/* Cfa/setup.scm 373 */
			       node_bglt aux_4647;
			       {	/* Cfa/setup.scm 373 */
				  var_bglt aux_4648;
				  aux_4648 =
				     (((set_ex_it_116_bglt) CREF(node_3286))->var);
				  aux_4647 =
				     (node_bglt) (aux_4648);
			       }
			       node_setup__189_cfa_setup(aux_4647);
			    }
			    {	/* Cfa/setup.scm 374 */
			       reshaped_local_224_bglt obj2097_3290;
			       {
				  variable_bglt aux_4652;
				  {	/* Cfa/setup.scm 374 */
				     var_bglt arg2654_3293;
				     arg2654_3293 =
					(((set_ex_it_116_bglt) CREF(node_3286))->var);
				     aux_4652 =
					(((var_bglt) CREF(arg2654_3293))->variable);
				  }
				  obj2097_3290 =
				     ((reshaped_local_224_bglt) (aux_4652));
			       }
			       {	/* Cfa/setup.scm 374 */
				  reshaped_local_224_bglt arg2652_3291;
				  {	/* Cfa/setup.scm 374 */
				     reshaped_local_224_bglt res2685_3879;
				     {	/* Cfa/setup.scm 374 */
					obj_t binding_value_3_3876;
					binding_value_3_3876 = BFALSE;
					{	/* ./Cfa/cinfo.scm 1434 */
					   reshaped_local_224_bglt new1549_3877;
					   new1549_3877 =
					      ((reshaped_local_224_bglt) BREF(GC_MALLOC(sizeof(struct reshaped_local_224))));
					   ((((reshaped_local_224_bglt) CREF(new1549_3877))->binding_value_3) = ((obj_t) binding_value_3_3876), BUNSPEC);
					   res2685_3879 = new1549_3877;
					}
				     }
				     arg2652_3291 = res2685_3879;
				  }
				  {	/* Cfa/setup.scm 374 */
				     obj_t aux_4660;
				     object_bglt aux_4658;
				     aux_4660 =
					(obj_t) (arg2652_3291);
				     aux_4658 =
					(object_bglt) (obj2097_3290);
				     OBJECT_WIDENING_SET(aux_4658, aux_4660);
				  }
			       }
			       {	/* Cfa/setup.scm 374 */
				  long arg2653_3292;
				  arg2653_3292 =
				     class_num_218___object(reshaped_local_224_cfa_info);
				  {	/* Cfa/setup.scm 374 */
				     obj_t obj_3880;
				     obj_3880 =
					(obj_t) (obj2097_3290);
				     (((obj_t) CREF(obj_3880))->header = MAKE_HEADER(arg2653_3292, 0), BUNSPEC);
				  }
			       }
			       obj2097_3290;
			    }
			    {	/* Cfa/setup.scm 375 */
			       set_ex_it_cinfo_168_bglt obj2098_3294;
			       obj2098_3294 =
				  ((set_ex_it_cinfo_168_bglt) (node_3286));
			       {	/* Cfa/setup.scm 376 */
				  set_ex_it_cinfo_168_bglt arg2655_3295;
				  {	/* Cfa/setup.scm 376 */
				     approx_bglt arg2656_3296;
				     arg2656_3296 =
					make_type_approx_184_cfa_approx(
					(type_bglt) (_obj__252_type_cache));
				     {	/* Cfa/setup.scm 375 */
					set_ex_it_cinfo_168_bglt res2686_3885;
					{	/* ./Cfa/cinfo.scm 1453 */
					   set_ex_it_cinfo_168_bglt new1672_3883;
					   new1672_3883 =
					      ((set_ex_it_cinfo_168_bglt) BREF(GC_MALLOC(sizeof(struct set_ex_it_cinfo_168))));
					   ((((set_ex_it_cinfo_168_bglt) CREF(new1672_3883))->approx) = ((approx_bglt) arg2656_3296), BUNSPEC);
					   res2686_3885 = new1672_3883;
					}
					arg2655_3295 = res2686_3885;
				     }
				  }
				  {	/* Cfa/setup.scm 375 */
				     obj_t aux_4673;
				     object_bglt aux_4671;
				     aux_4673 =
					(obj_t) (arg2655_3295);
				     aux_4671 =
					(object_bglt) (obj2098_3294);
				     OBJECT_WIDENING_SET(aux_4671, aux_4673);
				  }
			       }
			       {	/* Cfa/setup.scm 375 */
				  long arg2657_3297;
				  arg2657_3297 =
				     class_num_218___object(set_ex_it_cinfo_168_cfa_info);
				  {	/* Cfa/setup.scm 375 */
				     obj_t obj_3886;
				     obj_3886 =
					(obj_t) (obj2098_3294);
				     (((obj_t) CREF(obj_3886))->header = MAKE_HEADER(arg2657_3297, 0), BUNSPEC);
				  }
			       }
			       obj2098_3294;
			    }
			    {	/* Cfa/setup.scm 377 */
			       approx_bglt aux_4679;
			       {	/* Cfa/setup.scm 377 */
				  set_ex_it_cinfo_168_bglt obj_3888;
				  obj_3888 =
				     (set_ex_it_cinfo_168_bglt) (node_3286);
				  {
				     obj_t aux_4681;
				     {	/* ./Cfa/cinfo.scm 1453 */
					object_bglt aux_4682;
					aux_4682 =
					   (object_bglt) (obj_3888);
					aux_4681 =
					   OBJECT_WIDENING(aux_4682);
				     }
				     aux_4679 =
					(((set_ex_it_cinfo_168_bglt) CREF(aux_4681))->approx);
				  }
			       }
			       return
				  approx_set_top__187_cfa_approx(aux_4679);
			    }
			 }
			 break;
		      case ((long) 18):

			 {	/* Cfa/setup.scm 383 */
			    jump_ex_it_184_bglt node_3299;
			    node_3299 =
			       (jump_ex_it_184_bglt) (node_2);
			    node_setup__189_cfa_setup(
			       (((jump_ex_it_184_bglt) CREF(node_3299))->exit));
			    node_setup__189_cfa_setup(
			       (((jump_ex_it_184_bglt) CREF(node_3299))->value));
			    {	/* Cfa/setup.scm 386 */
			       jump_ex_it_cinfo_139_bglt obj2100_3303;
			       obj2100_3303 =
				  ((jump_ex_it_cinfo_139_bglt) (node_3299));
			       {	/* Cfa/setup.scm 387 */
				  jump_ex_it_cinfo_139_bglt arg2661_3304;
				  {	/* Cfa/setup.scm 387 */
				     approx_bglt arg2662_3305;
				     arg2662_3305 =
					make_type_approx_184_cfa_approx(
					(type_bglt) (_obj__252_type_cache));
				     {	/* Cfa/setup.scm 386 */
					jump_ex_it_cinfo_139_bglt res2687_3894;
					{	/* ./Cfa/cinfo.scm 1454 */
					   jump_ex_it_cinfo_139_bglt new1681_3892;
					   new1681_3892 =
					      ((jump_ex_it_cinfo_139_bglt) BREF(GC_MALLOC(sizeof(struct jump_ex_it_cinfo_139))));
					   ((((jump_ex_it_cinfo_139_bglt) CREF(new1681_3892))->approx) = ((approx_bglt) arg2662_3305), BUNSPEC);
					   res2687_3894 = new1681_3892;
					}
					arg2661_3304 = res2687_3894;
				     }
				  }
				  {	/* Cfa/setup.scm 386 */
				     obj_t aux_4699;
				     object_bglt aux_4697;
				     aux_4699 =
					(obj_t) (arg2661_3304);
				     aux_4697 =
					(object_bglt) (obj2100_3303);
				     OBJECT_WIDENING_SET(aux_4697, aux_4699);
				  }
			       }
			       {	/* Cfa/setup.scm 386 */
				  long arg2663_3306;
				  arg2663_3306 =
				     class_num_218___object(jump_ex_it_cinfo_139_cfa_info);
				  {	/* Cfa/setup.scm 386 */
				     obj_t obj_3895;
				     obj_3895 =
					(obj_t) (obj2100_3303);
				     (((obj_t) CREF(obj_3895))->header = MAKE_HEADER(arg2663_3306, 0), BUNSPEC);
				  }
			       }
			       obj2100_3303;
			    }
			    {	/* Cfa/setup.scm 388 */
			       approx_bglt aux_4705;
			       {	/* Cfa/setup.scm 388 */
				  jump_ex_it_cinfo_139_bglt obj_3897;
				  obj_3897 =
				     (jump_ex_it_cinfo_139_bglt) (node_3299);
				  {
				     obj_t aux_4707;
				     {	/* ./Cfa/cinfo.scm 1454 */
					object_bglt aux_4708;
					aux_4708 =
					   (object_bglt) (obj_3897);
					aux_4707 =
					   OBJECT_WIDENING(aux_4708);
				     }
				     aux_4705 =
					(((jump_ex_it_cinfo_139_bglt) CREF(aux_4707))->approx);
				  }
			       }
			       return
				  approx_set_top__187_cfa_approx(aux_4705);
			    }
			 }
			 break;
		      default:
		       case_else2537_3114:
			 if (
			    PROCEDUREP(method2531_3110))
			   {	/* Cfa/setup.scm 51 */
			      return
				 PROCEDURE_ENTRY(method2531_3110) (method2531_3110,
				 (obj_t) (node_2), BEOA);
			   }
			 else
			   {	/* Cfa/setup.scm 51 */
			      obj_t fun2414_2951;
			      fun2414_2951 =
				 PROCEDURE_REF(node_setup__env_214_cfa_setup, ((long) 0));
			      return
				 PROCEDURE_ENTRY(fun2414_2951) (fun2414_2951,
				 (obj_t) (node_2), BEOA);
			   }
		      }
		 }
	       else
		 {	/* Cfa/setup.scm 51 */
		    goto case_else2537_3114;
		 }
	    }
	 }
      }
   }
}



/* _node-setup! */
obj_t 
_node_setup__114_cfa_setup(obj_t env_4087, obj_t node_4088)
{
   AN_OBJECT;
   {	/* Cfa/setup.scm 51 */
      return
	 node_setup__189_cfa_setup(
	 (node_bglt) (node_4088));
   }
}



/* node-setup!-default2103 */
obj_t 
node_setup__default2103_233_cfa_setup(node_bglt node_3)
{
   AN_OBJECT;
   {	/* Cfa/setup.scm 14 */
      FAILURE(
	 CNST_TABLE_REF(((long) 1)), string2706_cfa_setup,
	 (obj_t) (node_3));
   }
}



/* _node-setup!-default2103 */
obj_t 
_node_setup__default2103_185_cfa_setup(obj_t env_4089, obj_t node_4090)
{
   AN_OBJECT;
   {	/* Cfa/setup.scm 14 */
      return
	 node_setup__default2103_233_cfa_setup(
	 (node_bglt) (node_4090));
   }
}



/* variable-value-setup! */
obj_t 
variable_value_setup__80_cfa_setup(value_bglt value_9, variable_bglt variable_10)
{
   AN_OBJECT;
   {	/* Cfa/setup.scm 109 */
      {		/* Cfa/setup.scm 109 */
	 obj_t arg2475_3018;
	 obj_t arg2476_3019;
	 {	/* Cfa/setup.scm 109 */
	    object_bglt obj_3903;
	    obj_3903 =
	       (object_bglt) (value_9);
	    {	/* ./Llib/object.scm 2926 */
	       obj_t pre_method_105_3904;
	       pre_method_105_3904 =
		  PROCEDURE_REF(variable_value_setup__env_134_cfa_setup, ((long) 2));
	       if (
		  INTEGERP(pre_method_105_3904))
		 {	/* ./Llib/object.scm 2927 */
		    PROCEDURE_SET(variable_value_setup__env_134_cfa_setup, ((long) 2), BUNSPEC);
		    arg2475_3018 = pre_method_105_3904;
		 }
	       else
		 {	/* ./Llib/object.scm 2914 */
		    long obj_class_num_177_3909;
		    obj_class_num_177_3909 =
		       TYPE(obj_3903);
		    {	/* ./Llib/object.scm 2915 */
		       obj_t arg1176_3910;
		       arg1176_3910 =
			  PROCEDURE_REF(variable_value_setup__env_134_cfa_setup, ((long) 1));
		       {	/* ./Llib/object.scm 2738 */
			  long arg1177_3914;
			  {	/* ./Llib/object.scm 2738 */
			     long arg1178_3915;
			     arg1178_3915 =
				OBJECT_TYPE;
			     arg1177_3914 =
				(obj_class_num_177_3909 - arg1178_3915);
			  }
			  arg2475_3018 =
			     VECTOR_REF(arg1176_3910, arg1177_3914);
		       }
		    }
		 }
	    }
	 }
	 {	/* Cfa/setup.scm 109 */
	    object_bglt object_3920;
	    object_3920 =
	       (object_bglt) (value_9);
	    {	/* ./Llib/object.scm 2695 */
	       long arg1179_3921;
	       {	/* ./Llib/object.scm 2695 */
		  long arg1180_3922;
		  long arg1181_3923;
		  arg1180_3922 =
		     TYPE(object_3920);
		  arg1181_3923 =
		     OBJECT_TYPE;
		  arg1179_3921 =
		     (arg1180_3922 - arg1181_3923);
	       }
	       {	/* ./Llib/object.scm 2695 */
		  obj_t vector_3927;
		  vector_3927 = _classes__134___object;
		  arg2476_3019 =
		     VECTOR_REF(vector_3927, arg1179_3921);
	       }
	    }
	 }
	 return
	    loop2468_cfa_setup(variable_10, value_9, arg2475_3018, arg2476_3019);
      }
   }
}



/* case_else2473 */
obj_t 
case_else2473_cfa_setup(variable_bglt variable_4105, value_bglt value_4104, obj_t method2467_4103)
{
   AN_OBJECT;
   {	/* Cfa/setup.scm 109 */
      if (
	 PROCEDUREP(method2467_4103))
	{	/* Cfa/setup.scm 109 */
	   return
	      PROCEDURE_ENTRY(method2467_4103) (method2467_4103,
	      (obj_t) (value_4104),
	      (obj_t) (variable_4105), BEOA);
	}
      else
	{	/* Cfa/setup.scm 109 */
	   obj_t fun2415_2952;
	   fun2415_2952 =
	      PROCEDURE_REF(variable_value_setup__env_134_cfa_setup, ((long) 0));
	   return
	      PROCEDURE_ENTRY(fun2415_2952) (fun2415_2952,
	      (obj_t) (value_4104),
	      (obj_t) (variable_4105), BEOA);
	}
   }
}



/* loop2468 */
obj_t 
loop2468_cfa_setup(variable_bglt variable_4107, value_bglt value_4106, obj_t method2467_3020, obj_t class2472_3021)
{
   AN_OBJECT;
   {	/* Cfa/setup.scm 109 */
      if (
	 INTEGERP(method2467_3020))
	{	/* Cfa/setup.scm 109 */
	   switch (
	      (long) CINT(method2467_3020))
	     {
	     case ((long) 0):

		return BUNSPEC;
		break;
	     case ((long) 1):

		{	/* Cfa/setup.scm 123 */
		   svar_bglt value_3029;
		   value_3029 =
		      (svar_bglt) (value_4106);
		   {	/* Cfa/setup.scm 123 */
		      bool_t test2479_3031;
		      test2479_3031 =
			 is_a__118___object(
			 (obj_t) (variable_4107), global_ast_var);
		      if (test2479_3031)
			{	/* Cfa/setup.scm 124 */
			   svar_cinfo_166_bglt value_3032;
			   {	/* Cfa/setup.scm 124 */
			      svar_cinfo_166_bglt obj2052_3039;
			      obj2052_3039 =
				 ((svar_cinfo_166_bglt) (value_3029));
			      {		/* Cfa/setup.scm 125 */
				 svar_cinfo_166_bglt arg2486_3040;
				 {	/* Cfa/setup.scm 125 */
				    approx_bglt arg2487_3041;
				    arg2487_3041 =
				       make_type_approx_184_cfa_approx(
				       (((variable_bglt) CREF(variable_4107))->type));
				    {	/* Cfa/setup.scm 124 */
				       svar_cinfo_166_bglt res2689_3936;
				       {	/* ./Cfa/cinfo.scm 1422 */
					  svar_cinfo_166_bglt new1520_3933;
					  new1520_3933 =
					     ((svar_cinfo_166_bglt) BREF(GC_MALLOC(sizeof(struct svar_cinfo_166))));
					  ((((svar_cinfo_166_bglt) CREF(new1520_3933))->approx) = ((approx_bglt) arg2487_3041), BUNSPEC);
					  ((((svar_cinfo_166_bglt) CREF(new1520_3933))->clo_env__87) = ((bool_t) ((bool_t) 0)), BUNSPEC);
					  res2689_3936 = new1520_3933;
				       }
				       arg2486_3040 = res2689_3936;
				    }
				 }
				 {	/* Cfa/setup.scm 124 */
				    obj_t aux_4772;
				    object_bglt aux_4770;
				    aux_4772 =
				       (obj_t) (arg2486_3040);
				    aux_4770 =
				       (object_bglt) (obj2052_3039);
				    OBJECT_WIDENING_SET(aux_4770, aux_4772);
				 }
			      }
			      {		/* Cfa/setup.scm 124 */
				 long arg2489_3043;
				 arg2489_3043 =
				    class_num_218___object(svar_cinfo_166_cfa_info);
				 {	/* Cfa/setup.scm 124 */
				    obj_t obj_3937;
				    obj_3937 =
				       (obj_t) (obj2052_3039);
				    (((obj_t) CREF(obj_3937))->header = MAKE_HEADER(arg2489_3043, 0), BUNSPEC);
				 }
			      }
			      value_3032 = obj2052_3039;
			   }
			   {	/* Cfa/setup.scm 126 */
			      bool_t test_4778;
			      {		/* Cfa/setup.scm 126 */
				 bool_t test_4779;
				 {	/* ./Ieee/equiv.scm 5508 */
				    obj_t aux_4783;
				    obj_t aux_4780;
				    aux_4783 =
				       CNST_TABLE_REF(((long) 2));
				    {	/* Cfa/setup.scm 126 */
				       global_bglt obj_3939;
				       obj_3939 =
					  (global_bglt) (variable_4107);
				       aux_4780 =
					  (((global_bglt) CREF(obj_3939))->import);
				    }
				    test_4779 =
				       (aux_4780 == aux_4783);
				 }
				 if (test_4779)
				   {	/* Cfa/setup.scm 126 */
				      test_4778 = ((bool_t) 0)
					 ;
				   }
				 else
				   {	/* Cfa/setup.scm 126 */
				      test_4778 =
					 alloc_type__187_cfa_setup(
					 (((variable_bglt) CREF(variable_4107))->type))
					 ;
				   }
			      }
			      if (test_4778)
				{	/* Cfa/setup.scm 128 */
				   approx_bglt aux_4788;
				   {
				      obj_t aux_4789;
				      {		/* ./Cfa/cinfo.scm 1423 */
					 object_bglt aux_4790;
					 aux_4790 =
					    (object_bglt) (value_3032);
					 aux_4789 =
					    OBJECT_WIDENING(aux_4790);
				      }
				      aux_4788 =
					 (((svar_cinfo_166_bglt) CREF(aux_4789))->approx);
				   }
				   return
				      approx_set_top__187_cfa_approx(aux_4788);
				}
			      else
				{	/* Cfa/setup.scm 126 */
				   return BUNSPEC;
				}
			   }
			}
		      else
			{	/* Cfa/setup.scm 129 */
			   svar_cinfo_166_bglt obj2053_3044;
			   obj2053_3044 =
			      ((svar_cinfo_166_bglt) (value_3029));
			   {	/* Cfa/setup.scm 130 */
			      svar_cinfo_166_bglt arg2490_3045;
			      {		/* Cfa/setup.scm 130 */
				 approx_bglt arg2491_3046;
				 arg2491_3046 =
				    make_type_approx_184_cfa_approx(
				    (((variable_bglt) CREF(variable_4107))->type));
				 {	/* Cfa/setup.scm 129 */
				    svar_cinfo_166_bglt res2690_3950;
				    {	/* ./Cfa/cinfo.scm 1422 */
				       svar_cinfo_166_bglt new1520_3947;
				       new1520_3947 =
					  ((svar_cinfo_166_bglt) BREF(GC_MALLOC(sizeof(struct svar_cinfo_166))));
				       ((((svar_cinfo_166_bglt) CREF(new1520_3947))->approx) = ((approx_bglt) arg2491_3046), BUNSPEC);
				       ((((svar_cinfo_166_bglt) CREF(new1520_3947))->clo_env__87) = ((bool_t) ((bool_t) 0)), BUNSPEC);
				       res2690_3950 = new1520_3947;
				    }
				    arg2490_3045 = res2690_3950;
				 }
			      }
			      {		/* Cfa/setup.scm 129 */
				 obj_t aux_4803;
				 object_bglt aux_4801;
				 aux_4803 =
				    (obj_t) (arg2490_3045);
				 aux_4801 =
				    (object_bglt) (obj2053_3044);
				 OBJECT_WIDENING_SET(aux_4801, aux_4803);
			      }
			   }
			   {	/* Cfa/setup.scm 129 */
			      long arg2493_3048;
			      arg2493_3048 =
				 class_num_218___object(svar_cinfo_166_cfa_info);
			      {		/* Cfa/setup.scm 129 */
				 obj_t obj_3951;
				 obj_3951 =
				    (obj_t) (obj2053_3044);
				 (((obj_t) CREF(obj_3951))->header = MAKE_HEADER(arg2493_3048, 0), BUNSPEC);
			      }
			   }
			   return
			      (obj_t) (obj2053_3044);
			}
		   }
		}
		break;
	     case ((long) 2):

		call_next_method_114_cfa_setup(value_4106, class2472_3021, variable_4107);
		{	/* Cfa/setup.scm 138 */
		   svar_cinfo_166_bglt obj_3954;
		   {	/* Cfa/setup.scm 138 */
		      value_bglt aux_4811;
		      {		/* Cfa/setup.scm 138 */
			 local_bglt obj_3953;
			 obj_3953 =
			    (local_bglt) (variable_4107);
			 aux_4811 =
			    (((local_bglt) CREF(obj_3953))->value);
		      }
		      obj_3954 =
			 (svar_cinfo_166_bglt) (aux_4811);
		   }
		   {
		      obj_t aux_4815;
		      {		/* ./Cfa/cinfo.scm 1427 */
			 object_bglt aux_4816;
			 aux_4816 =
			    (object_bglt) (obj_3954);
			 aux_4815 =
			    OBJECT_WIDENING(aux_4816);
		      }
		      return
			 ((((svar_cinfo_166_bglt) CREF(aux_4815))->clo_env__87) = ((bool_t) ((bool_t) 1)), BUNSPEC);
		   }
		}
		break;
	     case ((long) 3):

		{	/* Cfa/setup.scm 144 */
		   sexit_bglt value_3052;
		   value_3052 =
		      (sexit_bglt) (value_4106);
		   {	/* Cfa/setup.scm 144 */
		      sexit_cinfo_49_bglt obj2054_3054;
		      obj2054_3054 =
			 ((sexit_cinfo_49_bglt) (value_3052));
		      {		/* Cfa/setup.scm 145 */
			 sexit_cinfo_49_bglt arg2495_3055;
			 {	/* Cfa/setup.scm 145 */
			    approx_bglt arg2496_3056;
			    arg2496_3056 =
			       make_type_approx_184_cfa_approx(
			       (((variable_bglt) CREF(variable_4107))->type));
			    {	/* Cfa/setup.scm 144 */
			       sexit_cinfo_49_bglt res2691_3960;
			       {	/* ./Cfa/cinfo.scm 1431 */
				  sexit_cinfo_49_bglt new1535_3958;
				  new1535_3958 =
				     ((sexit_cinfo_49_bglt) BREF(GC_MALLOC(sizeof(struct sexit_cinfo_49))));
				  ((((sexit_cinfo_49_bglt) CREF(new1535_3958))->approx) = ((approx_bglt) arg2496_3056), BUNSPEC);
				  res2691_3960 = new1535_3958;
			       }
			       arg2495_3055 = res2691_3960;
			    }
			 }
			 {	/* Cfa/setup.scm 144 */
			    obj_t aux_4828;
			    object_bglt aux_4826;
			    aux_4828 =
			       (obj_t) (arg2495_3055);
			    aux_4826 =
			       (object_bglt) (obj2054_3054);
			    OBJECT_WIDENING_SET(aux_4826, aux_4828);
			 }
		      }
		      {		/* Cfa/setup.scm 144 */
			 long arg2498_3058;
			 arg2498_3058 =
			    class_num_218___object(sexit_cinfo_49_cfa_info);
			 {	/* Cfa/setup.scm 144 */
			    obj_t obj_3961;
			    obj_3961 =
			       (obj_t) (obj2054_3054);
			    (((obj_t) CREF(obj_3961))->header = MAKE_HEADER(arg2498_3058, 0), BUNSPEC);
			 }
		      }
		      return
			 (obj_t) (obj2054_3054);
		   }
		}
		break;
	     case ((long) 4):

		return
		   CNST_TABLE_REF(((long) 3));
		break;
	     case ((long) 5):

		{	/* Cfa/setup.scm 109 */
		   scnst_bglt value_3061;
		   value_3061 =
		      (scnst_bglt) (value_4106);
		   {	/* Cfa/setup.scm 159 */
		      bool_t test2499_3063;
		      test2499_3063 =
			 is_a__118___object(
			 (obj_t) (variable_4107), global_ast_var);
		      if (test2499_3063)
			{	/* Cfa/setup.scm 160 */
			   bool_t test2500_3064;
			   {	/* Cfa/setup.scm 160 */
			      bool_t test2509_3077;
			      {		/* Cfa/setup.scm 160 */
				 obj_t obj2_3966;
				 obj2_3966 = _module__166_module_module;
				 {	/* ./Ieee/equiv.scm 5508 */
				    obj_t aux_4840;
				    {	/* Cfa/setup.scm 160 */
				       global_bglt obj_3964;
				       obj_3964 =
					  (global_bglt) (variable_4107);
				       aux_4840 =
					  (((global_bglt) CREF(obj_3964))->module);
				    }
				    test2509_3077 =
				       (aux_4840 == obj2_3966);
				 }
			      }
			      if (test2509_3077)
				{	/* Cfa/setup.scm 161 */
				   bool_t test_4845;
				   {	/* Cfa/setup.scm 161 */
				      obj_t aux_4846;
				      aux_4846 =
					 memq___r4_pairs_and_lists_6_3(
					 (((scnst_bglt) CREF(value_3061))->class),
					 CNST_TABLE_REF(((long) 4)));
				      test_4845 =
					 CBOOL(aux_4846);
				   }
				   if (test_4845)
				     {	/* Cfa/setup.scm 161 */
					test2500_3064 =
					   is_a__118___object(
					   (((scnst_bglt) CREF(value_3061))->node), pre_make_procedure_app_60_cfa_info2);
				     }
				   else
				     {	/* Cfa/setup.scm 161 */
					test2500_3064 = ((bool_t) 0);
				     }
				}
			      else
				{	/* Cfa/setup.scm 160 */
				   test2500_3064 = ((bool_t) 0);
				}
			   }
			   if (test2500_3064)
			     {	/* Cfa/setup.scm 164 */
				obj_t node_3065;
				node_3065 =
				   (((scnst_bglt) CREF(value_3061))->node);
				node_setup__189_cfa_setup(
				   (node_bglt) (node_3065));
				{	/* Cfa/setup.scm 167 */
				   scnst_cinfo_0_bglt obj2055_3066;
				   obj2055_3066 =
				      ((scnst_cinfo_0_bglt) (value_3061));
				   {	/* Cfa/setup.scm 168 */
				      scnst_cinfo_0_bglt arg2501_3067;
				      {		/* Cfa/setup.scm 168 */
					 approx_bglt arg2502_3068;
					 {	/* Cfa/setup.scm 168 */
					    make_procedure_app_48_bglt obj_3971;
					    obj_3971 =
					       (make_procedure_app_48_bglt) (node_3065);
					    {
					       obj_t aux_4859;
					       {	/* ./Cfa/cinfo2.scm 1496 */
						  object_bglt aux_4860;
						  aux_4860 =
						     (object_bglt) (obj_3971);
						  aux_4859 =
						     OBJECT_WIDENING(aux_4860);
					       }
					       arg2502_3068 =
						  (((make_procedure_app_48_bglt) CREF(aux_4859))->approx);
					    }
					 }
					 {	/* Cfa/setup.scm 167 */
					    scnst_cinfo_0_bglt res2692_3975;
					    {	/* ./Cfa/cinfo.scm 1418 */
					       scnst_cinfo_0_bglt new1506_3973;
					       new1506_3973 =
						  ((scnst_cinfo_0_bglt) BREF(GC_MALLOC(sizeof(struct scnst_cinfo_0))));
					       ((((scnst_cinfo_0_bglt) CREF(new1506_3973))->approx) = ((approx_bglt) arg2502_3068), BUNSPEC);
					       res2692_3975 = new1506_3973;
					    }
					    arg2501_3067 = res2692_3975;
					 }
				      }
				      {		/* Cfa/setup.scm 167 */
					 obj_t aux_4868;
					 object_bglt aux_4866;
					 aux_4868 =
					    (obj_t) (arg2501_3067);
					 aux_4866 =
					    (object_bglt) (obj2055_3066);
					 OBJECT_WIDENING_SET(aux_4866, aux_4868);
				      }
				   }
				   {	/* Cfa/setup.scm 167 */
				      long arg2503_3069;
				      arg2503_3069 =
					 class_num_218___object(scnst_cinfo_0_cfa_info);
				      {		/* Cfa/setup.scm 167 */
					 obj_t obj_3976;
					 obj_3976 =
					    (obj_t) (obj2055_3066);
					 (((obj_t) CREF(obj_3976))->header = MAKE_HEADER(arg2503_3069, 0), BUNSPEC);
				      }
				   }
				   return
				      (obj_t) (obj2055_3066);
				}
			     }
			   else
			     {	/* Cfa/setup.scm 169 */
				scnst_cinfo_0_bglt value_3070;
				{	/* Cfa/setup.scm 169 */
				   scnst_cinfo_0_bglt obj2056_3072;
				   obj2056_3072 =
				      ((scnst_cinfo_0_bglt) (value_3061));
				   {	/* Cfa/setup.scm 170 */
				      scnst_cinfo_0_bglt arg2505_3073;
				      {		/* Cfa/setup.scm 170 */
					 approx_bglt arg2506_3074;
					 arg2506_3074 =
					    make_type_approx_184_cfa_approx(
					    (((variable_bglt) CREF(variable_4107))->type));
					 {	/* Cfa/setup.scm 169 */
					    scnst_cinfo_0_bglt res2693_3982;
					    {	/* ./Cfa/cinfo.scm 1418 */
					       scnst_cinfo_0_bglt new1506_3980;
					       new1506_3980 =
						  ((scnst_cinfo_0_bglt) BREF(GC_MALLOC(sizeof(struct scnst_cinfo_0))));
					       ((((scnst_cinfo_0_bglt) CREF(new1506_3980))->approx) = ((approx_bglt) arg2506_3074), BUNSPEC);
					       res2693_3982 = new1506_3980;
					    }
					    arg2505_3073 = res2693_3982;
					 }
				      }
				      {		/* Cfa/setup.scm 169 */
					 obj_t aux_4882;
					 object_bglt aux_4880;
					 aux_4882 =
					    (obj_t) (arg2505_3073);
					 aux_4880 =
					    (object_bglt) (obj2056_3072);
					 OBJECT_WIDENING_SET(aux_4880, aux_4882);
				      }
				   }
				   {	/* Cfa/setup.scm 169 */
				      long arg2508_3076;
				      arg2508_3076 =
					 class_num_218___object(scnst_cinfo_0_cfa_info);
				      {		/* Cfa/setup.scm 169 */
					 obj_t obj_3983;
					 obj_3983 =
					    (obj_t) (obj2056_3072);
					 (((obj_t) CREF(obj_3983))->header = MAKE_HEADER(arg2508_3076, 0), BUNSPEC);
				      }
				   }
				   value_3070 = obj2056_3072;
				}
				{	/* Cfa/setup.scm 171 */
				   approx_bglt aux_4888;
				   {
				      obj_t aux_4889;
				      {		/* ./Cfa/cinfo.scm 1418 */
					 object_bglt aux_4890;
					 aux_4890 =
					    (object_bglt) (value_3070);
					 aux_4889 =
					    OBJECT_WIDENING(aux_4890);
				      }
				      aux_4888 =
					 (((scnst_cinfo_0_bglt) CREF(aux_4889))->approx);
				   }
				   return
				      approx_set_top__187_cfa_approx(aux_4888);
				}
			     }
			}
		      else
			{	/* Cfa/setup.scm 172 */
			   scnst_cinfo_0_bglt obj2057_3083;
			   obj2057_3083 =
			      ((scnst_cinfo_0_bglt) (value_3061));
			   {	/* Cfa/setup.scm 173 */
			      scnst_cinfo_0_bglt arg2515_3084;
			      {		/* Cfa/setup.scm 173 */
				 approx_bglt arg2516_3085;
				 arg2516_3085 =
				    make_type_approx_184_cfa_approx(
				    (((variable_bglt) CREF(variable_4107))->type));
				 {	/* Cfa/setup.scm 172 */
				    scnst_cinfo_0_bglt res2694_3990;
				    {	/* ./Cfa/cinfo.scm 1418 */
				       scnst_cinfo_0_bglt new1506_3988;
				       new1506_3988 =
					  ((scnst_cinfo_0_bglt) BREF(GC_MALLOC(sizeof(struct scnst_cinfo_0))));
				       ((((scnst_cinfo_0_bglt) CREF(new1506_3988))->approx) = ((approx_bglt) arg2516_3085), BUNSPEC);
				       res2694_3990 = new1506_3988;
				    }
				    arg2515_3084 = res2694_3990;
				 }
			      }
			      {		/* Cfa/setup.scm 172 */
				 obj_t aux_4902;
				 object_bglt aux_4900;
				 aux_4902 =
				    (obj_t) (arg2515_3084);
				 aux_4900 =
				    (object_bglt) (obj2057_3083);
				 OBJECT_WIDENING_SET(aux_4900, aux_4902);
			      }
			   }
			   {	/* Cfa/setup.scm 172 */
			      long arg2518_3087;
			      arg2518_3087 =
				 class_num_218___object(scnst_cinfo_0_cfa_info);
			      {		/* Cfa/setup.scm 172 */
				 obj_t obj_3991;
				 obj_3991 =
				    (obj_t) (obj2057_3083);
				 (((obj_t) CREF(obj_3991))->header = MAKE_HEADER(arg2518_3087, 0), BUNSPEC);
			      }
			   }
			   return
			      (obj_t) (obj2057_3083);
			}
		   }
		}
		break;
	     case ((long) 6):

		{	/* Cfa/setup.scm 109 */
		   cvar_bglt value_3088;
		   value_3088 =
		      (cvar_bglt) (value_4106);
		   {	/* Cfa/setup.scm 179 */
		      cvar_cinfo_53_bglt obj2058_3090;
		      obj2058_3090 =
			 ((cvar_cinfo_53_bglt) (value_3088));
		      {		/* Cfa/setup.scm 180 */
			 cvar_cinfo_53_bglt arg2519_3091;
			 {	/* Cfa/setup.scm 180 */
			    approx_bglt arg2520_3092;
			    arg2520_3092 =
			       make_type_approx_184_cfa_approx(
			       (((variable_bglt) CREF(variable_4107))->type));
			    {	/* Cfa/setup.scm 179 */
			       cvar_cinfo_53_bglt res2695_3997;
			       {	/* ./Cfa/cinfo.scm 1428 */
				  cvar_cinfo_53_bglt new1527_3995;
				  new1527_3995 =
				     ((cvar_cinfo_53_bglt) BREF(GC_MALLOC(sizeof(struct cvar_cinfo_53))));
				  ((((cvar_cinfo_53_bglt) CREF(new1527_3995))->approx) = ((approx_bglt) arg2520_3092), BUNSPEC);
				  res2695_3997 = new1527_3995;
			       }
			       arg2519_3091 = res2695_3997;
			    }
			 }
			 {	/* Cfa/setup.scm 179 */
			    obj_t aux_4917;
			    object_bglt aux_4915;
			    aux_4917 =
			       (obj_t) (arg2519_3091);
			    aux_4915 =
			       (object_bglt) (obj2058_3090);
			    OBJECT_WIDENING_SET(aux_4915, aux_4917);
			 }
		      }
		      {		/* Cfa/setup.scm 179 */
			 long arg2522_3094;
			 arg2522_3094 =
			    class_num_218___object(cvar_cinfo_53_cfa_info);
			 {	/* Cfa/setup.scm 179 */
			    obj_t obj_3998;
			    obj_3998 =
			       (obj_t) (obj2058_3090);
			    (((obj_t) CREF(obj_3998))->header = MAKE_HEADER(arg2522_3094, 0), BUNSPEC);
			 }
		      }
		      obj2058_3090;
		   }
		   if (
		      alloc_type__187_cfa_setup(
			 (((variable_bglt) CREF(variable_4107))->type)))
		     {	/* Cfa/setup.scm 182 */
			approx_bglt aux_4926;
			{	/* Cfa/setup.scm 182 */
			   cvar_cinfo_53_bglt obj_4001;
			   obj_4001 =
			      (cvar_cinfo_53_bglt) (value_3088);
			   {
			      obj_t aux_4928;
			      {		/* ./Cfa/cinfo.scm 1428 */
				 object_bglt aux_4929;
				 aux_4929 =
				    (object_bglt) (obj_4001);
				 aux_4928 =
				    OBJECT_WIDENING(aux_4929);
			      }
			      aux_4926 =
				 (((cvar_cinfo_53_bglt) CREF(aux_4928))->approx);
			   }
			}
			return
			   approx_set_top__187_cfa_approx(aux_4926);
		     }
		   else
		     {	/* Cfa/setup.scm 181 */
			return BUNSPEC;
		     }
		}
		break;
	     default:
		return
		   case_else2473_cfa_setup(variable_4107, value_4106, method2467_3020);
	     }
	}
      else
	{	/* Cfa/setup.scm 109 */
	   return
	      case_else2473_cfa_setup(variable_4107, value_4106, method2467_3020);
	}
   }
}



/* call-next-method */
obj_t 
call_next_method_114_cfa_setup(value_bglt value_4110, obj_t class2472_4109, variable_bglt variable_4108)
{
   AN_OBJECT;
   {	/* Cfa/setup.scm 109 */
      {		/* Cfa/setup.scm 109 */
	 obj_t aux2470_3101;
	 {	/* Cfa/setup.scm 109 */
	    obj_t aux_4938;
	    if (
	       class__60___object(class2472_4109))
	      {		/* Cfa/setup.scm 109 */
		 aux_4938 =
		    class_super_145___object(class2472_4109)
		    ;
	      }
	    else
	      {		/* Cfa/setup.scm 109 */
		 aux_4938 = BFALSE
		    ;
	      }
	    aux2470_3101 =
	       find_method_from_44___object(
	       (object_bglt) (value_4110), variable_value_setup__env_134_cfa_setup, aux_4938);
	 }
	 {	/* Cfa/setup.scm 109 */

	    return
	       loop2468_cfa_setup(variable_4108, value_4110,
	       CDR(aux2470_3101),
	       CAR(aux2470_3101));
	 }
      }
   }
}



/* _variable-value-setup! */
obj_t 
_variable_value_setup__30_cfa_setup(obj_t env_4091, obj_t value_4092, obj_t variable_4093)
{
   AN_OBJECT;
   {	/* Cfa/setup.scm 109 */
      return
	 variable_value_setup__80_cfa_setup(
	 (value_bglt) (value_4092),
	 (variable_bglt) (variable_4093));
   }
}



/* variable-value-setup!-default2112 */
obj_t 
variable_value_setup__default2112_124_cfa_setup(value_bglt value_11, variable_bglt variable_12)
{
   AN_OBJECT;
   {	/* Cfa/setup.scm 14 */
      FAILURE(
	 CNST_TABLE_REF(((long) 5)), string2706_cfa_setup,
	 (obj_t) (value_11));
   }
}



/* _variable-value-setup!-default2112 */
obj_t 
_variable_value_setup__default2112_67_cfa_setup(obj_t env_4094, obj_t value_4095, obj_t variable_4096)
{
   AN_OBJECT;
   {	/* Cfa/setup.scm 14 */
      return
	 variable_value_setup__default2112_124_cfa_setup(
	 (value_bglt) (value_4095),
	 (variable_bglt) (variable_4096));
   }
}



/* fun-setup! */
obj_t 
fun_setup__186_cfa_setup(fun_bglt fun_30, obj_t var_31)
{
   AN_OBJECT;
   {	/* Cfa/setup.scm 210 */
      {
	 obj_t method2423_2963;
	 obj_t class2428_2964;
	 {	/* Cfa/setup.scm 210 */
	    obj_t arg2431_2961;
	    obj_t arg2432_2962;
	    {	/* Cfa/setup.scm 210 */
	       object_bglt obj_4009;
	       obj_4009 =
		  (object_bglt) (fun_30);
	       {	/* ./Llib/object.scm 2926 */
		  obj_t pre_method_105_4010;
		  pre_method_105_4010 =
		     PROCEDURE_REF(fun_setup__env_196_cfa_setup, ((long) 2));
		  if (
		     INTEGERP(pre_method_105_4010))
		    {	/* ./Llib/object.scm 2927 */
		       PROCEDURE_SET(fun_setup__env_196_cfa_setup, ((long) 2), BUNSPEC);
		       arg2431_2961 = pre_method_105_4010;
		    }
		  else
		    {	/* ./Llib/object.scm 2914 */
		       long obj_class_num_177_4015;
		       obj_class_num_177_4015 =
			  TYPE(obj_4009);
		       {	/* ./Llib/object.scm 2915 */
			  obj_t arg1176_4016;
			  arg1176_4016 =
			     PROCEDURE_REF(fun_setup__env_196_cfa_setup, ((long) 1));
			  {	/* ./Llib/object.scm 2738 */
			     long arg1177_4020;
			     {	/* ./Llib/object.scm 2738 */
				long arg1178_4021;
				arg1178_4021 =
				   OBJECT_TYPE;
				arg1177_4020 =
				   (obj_class_num_177_4015 - arg1178_4021);
			     }
			     arg2431_2961 =
				VECTOR_REF(arg1176_4016, arg1177_4020);
			  }
		       }
		    }
	       }
	    }
	    {	/* Cfa/setup.scm 210 */
	       object_bglt object_4026;
	       object_4026 =
		  (object_bglt) (fun_30);
	       {	/* ./Llib/object.scm 2695 */
		  long arg1179_4027;
		  {	/* ./Llib/object.scm 2695 */
		     long arg1180_4028;
		     long arg1181_4029;
		     arg1180_4028 =
			TYPE(object_4026);
		     arg1181_4029 =
			OBJECT_TYPE;
		     arg1179_4027 =
			(arg1180_4028 - arg1181_4029);
		  }
		  {	/* ./Llib/object.scm 2695 */
		     obj_t vector_4033;
		     vector_4033 = _classes__134___object;
		     arg2432_2962 =
			VECTOR_REF(vector_4033, arg1179_4027);
		  }
	       }
	    }
	    method2423_2963 = arg2431_2961;
	    class2428_2964 = arg2432_2962;
	    {

	       if (
		  INTEGERP(method2423_2963))
		 {	/* Cfa/setup.scm 210 */
		    switch (
		       (long) CINT(method2423_2963))
		      {
		      case ((long) 0):

			 {	/* Cfa/setup.scm 210 */
			    sfun_bglt fun_2970;
			    fun_2970 =
			       (sfun_bglt) (fun_30);
			    {	/* Cfa/setup.scm 219 */
			       bool_t test2435_2972;
			       {	/* Cfa/setup.scm 219 */
				  bool_t test2438_2976;
				  test2438_2976 =
				     is_a__118___object(var_31, global_ast_var);
				  if (test2438_2976)
				    {	/* Cfa/setup.scm 219 */
				       bool_t test2439_2977;
				       test2439_2977 =
					  is_a__118___object(var_31, reshaped_global_160_cfa_info);
				       if (test2439_2977)
					 {	/* Cfa/setup.scm 219 */
					    test2435_2972 = ((bool_t) 0);
					 }
				       else
					 {	/* Cfa/setup.scm 219 */
					    test2435_2972 = ((bool_t) 1);
					 }
				    }
				  else
				    {	/* Cfa/setup.scm 219 */
				       test2435_2972 = ((bool_t) 0);
				    }
			       }
			       if (test2435_2972)
				 {	/* Cfa/setup.scm 220 */
				    reshaped_global_160_bglt obj2062_2973;
				    obj2062_2973 =
				       ((reshaped_global_160_bglt) (var_31));
				    {	/* Cfa/setup.scm 220 */
				       obj_t aux_4982;
				       object_bglt aux_4980;
				       {	/* Cfa/setup.scm 220 */
					  reshaped_global_160_bglt aux_4983;
					  {	/* ./Cfa/cinfo.scm 1436 */

					     aux_4983 =
						((reshaped_global_160_bglt) BREF(GC_MALLOC(sizeof(struct reshaped_global_160))));
					  }
					  aux_4982 =
					     (obj_t) (aux_4983);
				       }
				       aux_4980 =
					  (object_bglt) (obj2062_2973);
				       OBJECT_WIDENING_SET(aux_4980, aux_4982);
				    }
				    {	/* Cfa/setup.scm 220 */
				       long arg2437_2975;
				       arg2437_2975 =
					  class_num_218___object(reshaped_global_160_cfa_info);
				       {	/* Cfa/setup.scm 220 */
					  obj_t obj_4039;
					  obj_4039 =
					     (obj_t) (obj2062_2973);
					  (((obj_t) CREF(obj_4039))->header = MAKE_HEADER(arg2437_2975, 0), BUNSPEC);
				       }
				    }
				    (obj_t) (obj2062_2973);
				 }
			       else
				 {	/* Cfa/setup.scm 219 */
				    BUNSPEC;
				 }
			    }
			    {	/* Cfa/setup.scm 221 */
			       bool_t test2440_2978;
			       {	/* Cfa/setup.scm 221 */
				  bool_t test2451_2992;
				  test2451_2992 =
				     is_a__118___object(var_31, global_ast_var);
				  if (test2451_2992)
				    {	/* ./Ieee/equiv.scm 5508 */
				       obj_t aux_4996;
				       obj_t aux_4993;
				       aux_4996 =
					  CNST_TABLE_REF(((long) 6));
				       {	/* Cfa/setup.scm 221 */
					  global_bglt obj_4042;
					  obj_4042 =
					     (global_bglt) (var_31);
					  aux_4993 =
					     (((global_bglt) CREF(obj_4042))->import);
				       }
				       test2440_2978 =
					  (aux_4993 == aux_4996);
				    }
				  else
				    {	/* Cfa/setup.scm 221 */
				       test2440_2978 = ((bool_t) 0);
				    }
			       }
			       if (test2440_2978)
				 {	/* Cfa/setup.scm 222 */
				    approx_bglt approx_2979;
				    {	/* Cfa/setup.scm 222 */
				       type_bglt aux_5000;
				       {	/* Cfa/setup.scm 222 */
					  global_bglt obj_4045;
					  obj_4045 =
					     (global_bglt) (var_31);
					  aux_5000 =
					     (((global_bglt) CREF(obj_4045))->type);
				       }
				       approx_2979 =
					  make_type_approx_184_cfa_approx(aux_5000);
				    }
				    if (
				       (((sfun_bglt) CREF(fun_2970))->top__138))
				      {		/* Cfa/setup.scm 223 */
					 approx_set_top__187_cfa_approx(approx_2979);
				      }
				    else
				      {		/* Cfa/setup.scm 223 */
					 BUNSPEC;
				      }
				    {	/* Cfa/setup.scm 224 */
				       extern_sfun_cinfo_6_bglt obj2063_2981;
				       obj2063_2981 =
					  ((extern_sfun_cinfo_6_bglt) (fun_2970));
				       {	/* Cfa/setup.scm 224 */
					  extern_sfun_cinfo_6_bglt arg2442_2982;
					  {	/* Cfa/setup.scm 224 */
					     extern_sfun_cinfo_6_bglt res2698_4050;
					     {	/* ./Cfa/cinfo.scm 1412 */
						extern_sfun_cinfo_6_bglt new1479_4048;
						new1479_4048 =
						   ((extern_sfun_cinfo_6_bglt) BREF(GC_MALLOC(sizeof(struct extern_sfun_cinfo_6))));
						((((extern_sfun_cinfo_6_bglt) CREF(new1479_4048))->approx) = ((approx_bglt) approx_2979), BUNSPEC);
						res2698_4050 = new1479_4048;
					     }
					     arg2442_2982 = res2698_4050;
					  }
					  {	/* Cfa/setup.scm 224 */
					     obj_t aux_5012;
					     object_bglt aux_5010;
					     aux_5012 =
						(obj_t) (arg2442_2982);
					     aux_5010 =
						(object_bglt) (obj2063_2981);
					     OBJECT_WIDENING_SET(aux_5010, aux_5012);
					  }
				       }
				       {	/* Cfa/setup.scm 224 */
					  long arg2444_2984;
					  arg2444_2984 =
					     class_num_218___object(extern_sfun_cinfo_6_cfa_info);
					  {	/* Cfa/setup.scm 224 */
					     obj_t obj_4051;
					     obj_4051 =
						(obj_t) (obj2063_2981);
					     (((obj_t) CREF(obj_4051))->header = MAKE_HEADER(arg2444_2984, 0), BUNSPEC);
					  }
				       }
				       return
					  (obj_t) (obj2063_2981);
				    }
				 }
			       else
				 {	/* Cfa/setup.scm 226 */
				    intern_sfun_cinfo_192_bglt obj2064_2986;
				    obj2064_2986 =
				       ((intern_sfun_cinfo_192_bglt) (fun_2970));
				    {	/* Cfa/setup.scm 227 */
				       intern_sfun_cinfo_192_bglt arg2446_2987;
				       {	/* Cfa/setup.scm 227 */
					  approx_bglt arg2447_2988;
					  {	/* Cfa/setup.scm 227 */
					     type_bglt aux_5020;
					     {	/* Cfa/setup.scm 227 */
						variable_bglt obj_4053;
						obj_4053 =
						   (variable_bglt) (var_31);
						aux_5020 =
						   (((variable_bglt) CREF(obj_4053))->type);
					     }
					     arg2447_2988 =
						make_type_approx_184_cfa_approx(aux_5020);
					  }
					  {	/* Cfa/setup.scm 226 */
					     intern_sfun_cinfo_192_bglt res2699_4059;
					     {	/* ./Cfa/cinfo.scm 1413 */
						intern_sfun_cinfo_192_bglt new1497_4056;
						new1497_4056 =
						   ((intern_sfun_cinfo_192_bglt) BREF(GC_MALLOC(sizeof(struct intern_sfun_cinfo_192))));
						((((intern_sfun_cinfo_192_bglt) CREF(new1497_4056))->approx) = ((approx_bglt) arg2447_2988), BUNSPEC);
						((((intern_sfun_cinfo_192_bglt) CREF(new1497_4056))->stamp) = ((long) ((long) -1)), BUNSPEC);
						res2699_4059 = new1497_4056;
					     }
					     arg2446_2987 = res2699_4059;
					  }
				       }
				       {	/* Cfa/setup.scm 226 */
					  obj_t aux_5029;
					  object_bglt aux_5027;
					  aux_5029 =
					     (obj_t) (arg2446_2987);
					  aux_5027 =
					     (object_bglt) (obj2064_2986);
					  OBJECT_WIDENING_SET(aux_5027, aux_5029);
				       }
				    }
				    {	/* Cfa/setup.scm 226 */
				       long arg2450_2991;
				       arg2450_2991 =
					  class_num_218___object(intern_sfun_cinfo_192_cfa_info);
				       {	/* Cfa/setup.scm 226 */
					  obj_t obj_4060;
					  obj_4060 =
					     (obj_t) (obj2064_2986);
					  (((obj_t) CREF(obj_4060))->header = MAKE_HEADER(arg2450_2991, 0), BUNSPEC);
				       }
				    }
				    return
				       (obj_t) (obj2064_2986);
				 }
			    }
			 }
			 break;
		      case ((long) 1):

			 {	/* Cfa/setup.scm 210 */
			    cfun_bglt fun_2995;
			    fun_2995 =
			       (cfun_bglt) (fun_30);
			    {	/* Cfa/setup.scm 233 */
			       bool_t test2454_2997;
			       test2454_2997 =
				  is_a__118___object(var_31, reshaped_global_160_cfa_info);
			       if (test2454_2997)
				 {	/* Cfa/setup.scm 233 */
				    BUNSPEC;
				 }
			       else
				 {	/* Cfa/setup.scm 234 */
				    reshaped_global_160_bglt obj2065_2998;
				    obj2065_2998 =
				       ((reshaped_global_160_bglt) (var_31));
				    {	/* Cfa/setup.scm 234 */
				       obj_t aux_5042;
				       object_bglt aux_5040;
				       {	/* Cfa/setup.scm 234 */
					  reshaped_global_160_bglt aux_5043;
					  {	/* ./Cfa/cinfo.scm 1436 */

					     aux_5043 =
						((reshaped_global_160_bglt) BREF(GC_MALLOC(sizeof(struct reshaped_global_160))));
					  }
					  aux_5042 =
					     (obj_t) (aux_5043);
				       }
				       aux_5040 =
					  (object_bglt) (obj2065_2998);
				       OBJECT_WIDENING_SET(aux_5040, aux_5042);
				    }
				    {	/* Cfa/setup.scm 234 */
				       long arg2456_3000;
				       arg2456_3000 =
					  class_num_218___object(reshaped_global_160_cfa_info);
				       {	/* Cfa/setup.scm 234 */
					  obj_t obj_4065;
					  obj_4065 =
					     (obj_t) (obj2065_2998);
					  (((obj_t) CREF(obj_4065))->header = MAKE_HEADER(arg2456_3000, 0), BUNSPEC);
				       }
				    }
				    (obj_t) (obj2065_2998);
				 }
			    }
			    {	/* Cfa/setup.scm 235 */
			       approx_bglt approx_3001;
			       {	/* Cfa/setup.scm 235 */
				  type_bglt aux_5051;
				  {	/* Cfa/setup.scm 235 */
				     global_bglt obj_4067;
				     obj_4067 =
					(global_bglt) (var_31);
				     aux_5051 =
					(((global_bglt) CREF(obj_4067))->type);
				  }
				  approx_3001 =
				     make_type_approx_184_cfa_approx(aux_5051);
			       }
			       if (
				  (((cfun_bglt) CREF(fun_2995))->top__138))
				 {	/* Cfa/setup.scm 236 */
				    approx_set_top__187_cfa_approx(approx_3001);
				 }
			       else
				 {	/* Cfa/setup.scm 236 */
				    BUNSPEC;
				 }
			       {	/* Cfa/setup.scm 237 */
				  cfun_cinfo_200_bglt obj2066_3003;
				  obj2066_3003 =
				     ((cfun_cinfo_200_bglt) (fun_2995));
				  {	/* Cfa/setup.scm 237 */
				     cfun_cinfo_200_bglt arg2458_3004;
				     {	/* Cfa/setup.scm 237 */
					cfun_cinfo_200_bglt res2701_4072;
					{	/* ./Cfa/cinfo.scm 1411 */
					   cfun_cinfo_200_bglt new1462_4070;
					   new1462_4070 =
					      ((cfun_cinfo_200_bglt) BREF(GC_MALLOC(sizeof(struct cfun_cinfo_200))));
					   ((((cfun_cinfo_200_bglt) CREF(new1462_4070))->approx) = ((approx_bglt) approx_3001), BUNSPEC);
					   res2701_4072 = new1462_4070;
					}
					arg2458_3004 = res2701_4072;
				     }
				     {	/* Cfa/setup.scm 237 */
					obj_t aux_5063;
					object_bglt aux_5061;
					aux_5063 =
					   (obj_t) (arg2458_3004);
					aux_5061 =
					   (object_bglt) (obj2066_3003);
					OBJECT_WIDENING_SET(aux_5061, aux_5063);
				     }
				  }
				  {	/* Cfa/setup.scm 237 */
				     long arg2460_3006;
				     arg2460_3006 =
					class_num_218___object(cfun_cinfo_200_cfa_info);
				     {	/* Cfa/setup.scm 237 */
					obj_t obj_4073;
					obj_4073 =
					   (obj_t) (obj2066_3003);
					(((obj_t) CREF(obj_4073))->header = MAKE_HEADER(arg2460_3006, 0), BUNSPEC);
				     }
				  }
				  return
				     (obj_t) (obj2066_3003);
			       }
			    }
			 }
			 break;
		      default:
		       case_else2429_2967:
			 if (
			    PROCEDUREP(method2423_2963))
			   {	/* Cfa/setup.scm 210 */
			      return
				 PROCEDURE_ENTRY(method2423_2963) (method2423_2963,
				 (obj_t) (fun_30), var_31, BEOA);
			   }
			 else
			   {	/* Cfa/setup.scm 210 */
			      obj_t fun2417_2953;
			      fun2417_2953 =
				 PROCEDURE_REF(fun_setup__env_196_cfa_setup, ((long) 0));
			      return
				 PROCEDURE_ENTRY(fun2417_2953) (fun2417_2953,
				 (obj_t) (fun_30), var_31, BEOA);
			   }
		      }
		 }
	       else
		 {	/* Cfa/setup.scm 210 */
		    goto case_else2429_2967;
		 }
	    }
	 }
      }
   }
}



/* _fun-setup! */
obj_t 
_fun_setup__218_cfa_setup(obj_t env_4097, obj_t fun_4098, obj_t var_4099)
{
   AN_OBJECT;
   {	/* Cfa/setup.scm 210 */
      return
	 fun_setup__186_cfa_setup(
	 (fun_bglt) (fun_4098), var_4099);
   }
}



/* fun-setup!-default2133 */
obj_t 
fun_setup__default2133_16_cfa_setup(fun_bglt fun_32, obj_t var_33)
{
   AN_OBJECT;
   {	/* Cfa/setup.scm 14 */
      {		/* Cfa/setup.scm 211 */
	 bool_t test2418_2954;
	 {	/* Cfa/setup.scm 211 */
	    bool_t test2421_2958;
	    test2421_2958 =
	       is_a__118___object(var_33, global_ast_var);
	    if (test2421_2958)
	      {		/* Cfa/setup.scm 211 */
		 bool_t test2422_2959;
		 test2422_2959 =
		    is_a__118___object(var_33, reshaped_global_160_cfa_info);
		 if (test2422_2959)
		   {	/* Cfa/setup.scm 211 */
		      test2418_2954 = ((bool_t) 0);
		   }
		 else
		   {	/* Cfa/setup.scm 211 */
		      test2418_2954 = ((bool_t) 1);
		   }
	      }
	    else
	      {		/* Cfa/setup.scm 211 */
		 test2418_2954 = ((bool_t) 0);
	      }
	 }
	 if (test2418_2954)
	   {	/* Cfa/setup.scm 212 */
	      reshaped_global_160_bglt obj2061_2955;
	      obj2061_2955 =
		 ((reshaped_global_160_bglt) (var_33));
	      {		/* Cfa/setup.scm 212 */
		 obj_t aux_5091;
		 object_bglt aux_5089;
		 {	/* Cfa/setup.scm 212 */
		    reshaped_global_160_bglt aux_5092;
		    {	/* ./Cfa/cinfo.scm 1436 */

		       aux_5092 =
			  ((reshaped_global_160_bglt) BREF(GC_MALLOC(sizeof(struct reshaped_global_160))));
		    }
		    aux_5091 =
		       (obj_t) (aux_5092);
		 }
		 aux_5089 =
		    (object_bglt) (obj2061_2955);
		 OBJECT_WIDENING_SET(aux_5089, aux_5091);
	      }
	      {		/* Cfa/setup.scm 212 */
		 long arg2420_2957;
		 arg2420_2957 =
		    class_num_218___object(reshaped_global_160_cfa_info);
		 {	/* Cfa/setup.scm 212 */
		    obj_t obj_4081;
		    obj_4081 =
		       (obj_t) (obj2061_2955);
		    (((obj_t) CREF(obj_4081))->header = MAKE_HEADER(arg2420_2957, 0), BUNSPEC);
		 }
	      }
	      (obj_t) (obj2061_2955);
	   }
	 else
	   {	/* Cfa/setup.scm 211 */
	      BUNSPEC;
	   }
      }
      return BUNSPEC;
   }
}



/* _fun-setup!-default2133 */
obj_t 
_fun_setup__default2133_69_cfa_setup(obj_t env_4100, obj_t fun_4101, obj_t var_4102)
{
   AN_OBJECT;
   {	/* Cfa/setup.scm 14 */
      return
	 fun_setup__default2133_16_cfa_setup(
	 (fun_bglt) (fun_4101), var_4102);
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_cfa_setup()
{
   AN_OBJECT;
   {	/* Cfa/setup.scm 14 */
      module_initialization_70_tools_trace(((long) 0), "CFA_SETUP");
      module_initialization_70_type_type(((long) 0), "CFA_SETUP");
      module_initialization_70_type_cache(((long) 0), "CFA_SETUP");
      module_initialization_70_type_typeof(((long) 0), "CFA_SETUP");
      module_initialization_70_module_module(((long) 0), "CFA_SETUP");
      module_initialization_70_tools_shape(((long) 0), "CFA_SETUP");
      module_initialization_70_tools_error(((long) 0), "CFA_SETUP");
      module_initialization_70_ast_var(((long) 0), "CFA_SETUP");
      module_initialization_70_ast_node(((long) 0), "CFA_SETUP");
      module_initialization_70_cfa_info(((long) 0), "CFA_SETUP");
      module_initialization_70_cfa_info2(((long) 0), "CFA_SETUP");
      return
	 module_initialization_70_cfa_approx(((long) 0), "CFA_SETUP");
   }
}
