/*===========================================================================*/
/*   (Cfa/show.scm)                                                          */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;

typedef struct approx
  {
     header_t header;
     obj_t widening;
     struct type *type;
     bool_t type_locked__184;
     obj_t allocs;
     bool_t top__138;
     long lost_stamp_114;
  }
      *approx_bglt;

typedef struct cfun_cinfo_200
  {
     struct approx *approx;
  }
              *cfun_cinfo_200_bglt;

typedef struct extern_sfun_cinfo_6
  {
     struct approx *approx;
  }
                   *extern_sfun_cinfo_6_bglt;

typedef struct intern_sfun_cinfo_192
  {
     struct approx *approx;
     long stamp;
  }
                     *intern_sfun_cinfo_192_bglt;

typedef struct scnst_cinfo_0
  {
     struct approx *approx;
  }
             *scnst_cinfo_0_bglt;

typedef struct pre_clo_env_191
  {
     char dummy;
  }
               *pre_clo_env_191_bglt;

typedef struct svar_cinfo_166
  {
     struct approx *approx;
     bool_t clo_env__87;
  }
              *svar_cinfo_166_bglt;

typedef struct cvar_cinfo_53
  {
     struct approx *approx;
  }
             *cvar_cinfo_53_bglt;

typedef struct sexit_cinfo_49
  {
     struct approx *approx;
  }
              *sexit_cinfo_49_bglt;

typedef struct reshaped_local_224
  {
     obj_t binding_value_3;
  }
                  *reshaped_local_224_bglt;

typedef struct reshaped_global_160
  {
     char dummy;
  }
                   *reshaped_global_160_bglt;

typedef struct atom_cinfo_155
  {
     struct approx *approx;
  }
              *atom_cinfo_155_bglt;

typedef struct kwote_node_102
  {
     struct node *node;
  }
              *kwote_node_102_bglt;

typedef struct kwote_cinfo_48
  {
     struct approx *approx;
  }
              *kwote_cinfo_48_bglt;

typedef struct app_ly_cinfo_234
  {
     struct approx *approx;
  }
                *app_ly_cinfo_234_bglt;

typedef struct funcall_cinfo_75
  {
     struct approx *approx;
     struct approx *va_approx_63;
     bool_t arity_error_noticed__118;
     bool_t type_error_noticed__36;
  }
                *funcall_cinfo_75_bglt;

typedef struct pragma_cinfo_220
  {
     struct approx *approx;
  }
                *pragma_cinfo_220_bglt;

typedef struct setq_cinfo_191
  {
     struct approx *approx;
  }
              *setq_cinfo_191_bglt;

typedef struct conditional_cinfo_212
  {
     struct approx *approx;
  }
                     *conditional_cinfo_212_bglt;

typedef struct fail_cinfo_75
  {
     struct approx *approx;
  }
             *fail_cinfo_75_bglt;

typedef struct select_cinfo_150
  {
     struct approx *approx;
  }
                *select_cinfo_150_bglt;

typedef struct set_ex_it_cinfo_168
  {
     struct approx *approx;
  }
                   *set_ex_it_cinfo_168_bglt;

typedef struct jump_ex_it_cinfo_139
  {
     struct approx *approx;
  }
                    *jump_ex_it_cinfo_139_bglt;

typedef struct pre_make_box_186
  {
     char dummy;
  }
                *pre_make_box_186_bglt;

typedef struct make_box_cinfo_127
  {
     struct approx *approx;
  }
                  *make_box_cinfo_127_bglt;

typedef struct make_box_o_cinfo_96
  {
     struct approx *approx;
     struct approx *value_approx_19;
  }
                   *make_box_o_cinfo_96_bglt;

typedef struct box_set__cinfo_94
  {
     struct approx *approx;
  }
                 *box_set__cinfo_94_bglt;

typedef struct box_ref_cinfo_214
  {
     struct approx *approx;
  }
                 *box_ref_cinfo_214_bglt;

typedef struct box_set__o_cinfo_6
  {
     struct approx *approx;
  }
                  *box_set__o_cinfo_6_bglt;

typedef struct box_ref_o_cinfo_98
  {
     struct approx *approx;
  }
                  *box_ref_o_cinfo_98_bglt;

typedef struct pre_make_procedure_app_60
  {
     struct variable *owner;
  }
                         *pre_make_procedure_app_60_bglt;

typedef struct pre_procedure_ref_app_85
  {
     char dummy;
  }
                        *pre_procedure_ref_app_85_bglt;

typedef struct pre_procedure_set__app_208
  {
     char dummy;
  }
                          *pre_procedure_set__app_208_bglt;

typedef struct make_procedure_app_48
  {
     struct approx *approx;
     long values_approx_len_106;
     struct approx **values_approx_79;
     long lost_stamp_114;
     bool_t x_t__142;
     bool_t x;
     bool_t t;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
  }
                     *make_procedure_app_48_bglt;

typedef struct procedure_ref_app_49
  {
     struct approx *approx;
  }
                    *procedure_ref_app_49_bglt;

typedef struct procedure_set__app_32
  {
     struct approx *approx;
  }
                     *procedure_set__app_32_bglt;

typedef struct pre_make_vector_app_251
  {
     struct variable *owner;
  }
                       *pre_make_vector_app_251_bglt;

typedef struct pre_create_vector_app_162
  {
     struct variable *owner;
  }
                         *pre_create_vector_app_162_bglt;

typedef struct pre_vector_ref_app_208
  {
     char dummy;
  }
                      *pre_vector_ref_app_208_bglt;

typedef struct pre_vector_set__app_211
  {
     char dummy;
  }
                       *pre_vector_set__app_211_bglt;

typedef struct make_vector_app_205
  {
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
     bool_t seen__39;
  }
                   *make_vector_app_205_bglt;

typedef struct create_vector_app_150
  {
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
     bool_t seen__39;
  }
                     *create_vector_app_150_bglt;

typedef struct vector_ref_app_195
  {
     struct approx *approx;
  }
                  *vector_ref_app_195_bglt;

typedef struct vector_set__app_21
  {
     struct approx *approx;
  }
                  *vector_set__app_21_bglt;

typedef struct pre_make_struct_app_218
  {
     struct variable *owner;
  }
                       *pre_make_struct_app_218_bglt;

typedef struct pre_struct_ref_app_207
  {
     char dummy;
  }
                      *pre_struct_ref_app_207_bglt;

typedef struct pre_struct_set__app_116
  {
     char dummy;
  }
                       *pre_struct_set__app_116_bglt;

typedef struct make_struct_app_214
  {
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
  }
                   *make_struct_app_214_bglt;

typedef struct struct_ref_app_73
  {
     struct approx *approx;
  }
                 *struct_ref_app_73_bglt;

typedef struct struct_set__app_162
  {
     struct approx *approx;
  }
                   *struct_set__app_162_bglt;


static obj_t method_init_76_cfa_show();
extern obj_t string_to_symbol(char *);
extern obj_t cfun_cinfo_200_cfa_info;
extern obj_t get_allocs_52_cfa_collect();
static obj_t _show_cfa_results_182_cfa_show(obj_t, obj_t);
extern obj_t reshaped_global_160_cfa_info;
extern obj_t add_method__1___object(obj_t, obj_t, obj_t);
extern obj_t find_super_class_method_167___object(object_bglt, obj_t, obj_t);
extern obj_t cvar_cinfo_53_cfa_info;
extern obj_t verbose_tools_speek(obj_t, obj_t);
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t show_cfa_nb_iterations_231_cfa_show();
extern obj_t intern_sfun_cinfo_192_cfa_info;
static obj_t shape_reshaped_global2036_151_cfa_show(obj_t, obj_t);
extern obj_t show_cfa_results_28_cfa_show(obj_t);
extern obj_t module_initialization_70_cfa_show(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_speek(long, char *);
extern obj_t module_initialization_70_write_scheme(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_cfa_info(long, char *);
extern obj_t module_initialization_70_cfa_info2(long, char *);
extern obj_t module_initialization_70_cfa_approx(long, char *);
extern obj_t module_initialization_70_cfa_collect(long, char *);
extern obj_t module_initialization_70_cfa_iterate(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___r4_output_6_10_3(long, char *);
extern obj_t reshaped_local_224_cfa_info;
extern obj_t display_2_122___r4_output_6_10_3(obj_t, obj_t);
static obj_t imported_modules_init_94_cfa_show();
extern obj_t extern_sfun_cinfo_6_cfa_info;
extern obj_t scnst_cinfo_0_cfa_info;
static obj_t library_modules_init_112_cfa_show();
static obj_t toplevel_init_63_cfa_show();
extern obj_t close_output_port(obj_t);
static obj_t shape_reshaped_local2034_18_cfa_show(obj_t, obj_t);
static obj_t _show_cfa_nb_iterations_163_cfa_show(obj_t);
extern obj_t shape_tools_shape(obj_t);
extern obj_t open_output_string();
static obj_t cfa_variable_shape_84_cfa_show(obj_t, obj_t);
extern obj_t svar_cinfo_166_cfa_info;
extern obj_t _cfa_stamp__16_cfa_iterate;
static obj_t require_initialization_114_cfa_show = BUNSPEC;
static obj_t *__cnst;

DEFINE_STATIC_PROCEDURE(proc2323_cfa_show, shape_reshaped_global2036_151_cfa_show2325, shape_reshaped_global2036_151_cfa_show, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2322_cfa_show, shape_reshaped_local2034_18_cfa_show2326, shape_reshaped_local2034_18_cfa_show, 0L, 1);
DEFINE_EXPORT_PROCEDURE(show_cfa_nb_iterations_env_198_cfa_show, _show_cfa_nb_iterations_163_cfa_show2327, _show_cfa_nb_iterations_163_cfa_show, 0L, 0);
DEFINE_EXPORT_PROCEDURE(show_cfa_results_env_131_cfa_show, _show_cfa_results_182_cfa_show2328, _show_cfa_results_182_cfa_show, 0L, 1);
DEFINE_STRING(string2321_cfa_show, string2321_cfa_show2329, " ", 1);
DEFINE_STRING(string2319_cfa_show, string2319_cfa_show2330, " Iterations)", 12);
DEFINE_STRING(string2320_cfa_show, string2320_cfa_show2331, "      (", 7);
extern obj_t shape_env_98_tools_shape;



/* module-initialization */
obj_t 
module_initialization_70_cfa_show(long checksum_3293, char *from_3294)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_cfa_show))
	{
	   require_initialization_114_cfa_show =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_cfa_show();
	   imported_modules_init_94_cfa_show();
	   method_init_76_cfa_show();
	   toplevel_init_63_cfa_show();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_cfa_show()
{
   AN_OBJECT;
   {	/* Cfa/show.scm 14 */
      module_initialization_70___object(((long) 0), "CFA_SHOW");
      module_initialization_70___r4_output_6_10_3(((long) 0), "CFA_SHOW");
      return BUNSPEC;
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_cfa_show()
{
   AN_OBJECT;
   {	/* Cfa/show.scm 14 */
      return BUNSPEC;
   }
}



/* show-cfa-nb-iterations */
obj_t 
show_cfa_nb_iterations_231_cfa_show()
{
   AN_OBJECT;
   {	/* Cfa/show.scm 34 */
      {		/* Cfa/show.scm 35 */
	 long arg2039_2108;
	 {	/* Cfa/show.scm 35 */
	    long z2_2911;
	    z2_2911 =
	       (long) CINT(_cfa_stamp__16_cfa_iterate);
	    arg2039_2108 =
	       (((long) 1) + z2_2911);
	 }
	 {	/* Cfa/show.scm 35 */
	    obj_t list2041_2110;
	    {	/* Cfa/show.scm 35 */
	       obj_t arg2042_2111;
	       {	/* Cfa/show.scm 35 */
		  obj_t arg2043_2112;
		  {	/* Cfa/show.scm 35 */
		     obj_t arg2044_2113;
		     {	/* Cfa/show.scm 35 */
			obj_t aux_3306;
			aux_3306 =
			   BCHAR(((unsigned char) '\n'));
			arg2044_2113 =
			   MAKE_PAIR(aux_3306, BNIL);
		     }
		     arg2043_2112 =
			MAKE_PAIR(string2319_cfa_show, arg2044_2113);
		  }
		  {	/* Cfa/show.scm 35 */
		     obj_t aux_3310;
		     aux_3310 =
			BINT(arg2039_2108);
		     arg2042_2111 =
			MAKE_PAIR(aux_3310, arg2043_2112);
		  }
	       }
	       list2041_2110 =
		  MAKE_PAIR(string2320_cfa_show, arg2042_2111);
	    }
	    return
	       verbose_tools_speek(
	       BINT(((long) 2)), list2041_2110);
	 }
      }
   }
}



/* _show-cfa-nb-iterations */
obj_t 
_show_cfa_nb_iterations_163_cfa_show(obj_t env_3282)
{
   AN_OBJECT;
   {	/* Cfa/show.scm 34 */
      return
	 show_cfa_nb_iterations_231_cfa_show();
   }
}



/* show-cfa-results */
obj_t 
show_cfa_results_28_cfa_show(obj_t globals_1)
{
   AN_OBJECT;
   {	/* Cfa/show.scm 40 */
      {		/* Cfa/show.scm 45 */
	 bool_t test2045_2114;
	 {	/* Cfa/show.scm 45 */
	    obj_t arg2046_2115;
	    arg2046_2115 =
	       get_allocs_52_cfa_collect();
	    test2045_2114 =
	       PAIRP(arg2046_2115);
	 }
	 if (test2045_2114)
	   {	/* Cfa/show.scm 45 */
	      BUNSPEC;
	   }
	 else
	   {	/* Cfa/show.scm 45 */
	      BUNSPEC;
	   }
      }
      {
	 obj_t l2031_2116;
	 {	/* Cfa/show.scm 48 */
	    obj_t arg2047_2118;
	    arg2047_2118 =
	       get_allocs_52_cfa_collect();
	    l2031_2116 = arg2047_2118;
	  lname2032_2117:
	    if (
	       PAIRP(l2031_2116))
	      {		/* Cfa/show.scm 46 */
		 {
		    obj_t l2031_3323;
		    l2031_3323 =
		       CDR(l2031_2116);
		    l2031_2116 = l2031_3323;
		    goto lname2032_2117;
		 }
	      }
	    else
	      {		/* Cfa/show.scm 46 */
		 ((bool_t) 1);
	      }
	 }
      }
      return BUNSPEC;
   }
}



/* _show-cfa-results */
obj_t 
_show_cfa_results_182_cfa_show(obj_t env_3283, obj_t globals_3284)
{
   AN_OBJECT;
   {	/* Cfa/show.scm 40 */
      return
	 show_cfa_results_28_cfa_show(globals_3284);
   }
}



/* cfa-variable-shape */
obj_t 
cfa_variable_shape_84_cfa_show(obj_t variable_4, obj_t port_5)
{
   AN_OBJECT;
   {	/* Cfa/show.scm 92 */
      {		/* Cfa/show.scm 93 */
	 value_bglt value_2122;
	 {	/* Cfa/show.scm 93 */
	    variable_bglt obj_2916;
	    obj_2916 =
	       (variable_bglt) (variable_4);
	    value_2122 =
	       (((variable_bglt) CREF(obj_2916))->value);
	 }
	 {	/* Cfa/show.scm 95 */
	    bool_t test2050_2123;
	    test2050_2123 =
	       is_a__118___object(
	       (obj_t) (value_2122), svar_cinfo_166_cfa_info);
	    if (test2050_2123)
	      {		/* Cfa/show.scm 95 */
		 display_2_122___r4_output_6_10_3(string2321_cfa_show, port_5);
		 {	/* Cfa/show.scm 97 */
		    obj_t arg2051_2124;
		    {	/* Cfa/show.scm 97 */
		       obj_t aux_3332;
		       {	/* Cfa/show.scm 97 */
			  approx_bglt aux_3333;
			  {	/* Cfa/show.scm 97 */
			     svar_cinfo_166_bglt obj_2918;
			     obj_2918 =
				(svar_cinfo_166_bglt) (value_2122);
			     {
				obj_t aux_3335;
				{	/* ./Cfa/cinfo.scm 924 */
				   object_bglt aux_3336;
				   aux_3336 =
				      (object_bglt) (obj_2918);
				   aux_3335 =
				      OBJECT_WIDENING(aux_3336);
				}
				aux_3333 =
				   (((svar_cinfo_166_bglt) CREF(aux_3335))->approx);
			     }
			  }
			  aux_3332 =
			     (obj_t) (aux_3333);
		       }
		       arg2051_2124 =
			  shape_tools_shape(aux_3332);
		    }
		    display_2_122___r4_output_6_10_3(arg2051_2124, port_5);
		 }
	      }
	    else
	      {		/* Cfa/show.scm 98 */
		 bool_t test2053_2126;
		 test2053_2126 =
		    is_a__118___object(
		    (obj_t) (value_2122), cvar_cinfo_53_cfa_info);
		 if (test2053_2126)
		   {	/* Cfa/show.scm 98 */
		      display_2_122___r4_output_6_10_3(string2321_cfa_show, port_5);
		      {		/* Cfa/show.scm 100 */
			 obj_t arg2054_2127;
			 {	/* Cfa/show.scm 100 */
			    obj_t aux_3347;
			    {	/* Cfa/show.scm 100 */
			       approx_bglt aux_3348;
			       {	/* Cfa/show.scm 100 */
				  cvar_cinfo_53_bglt obj_2920;
				  obj_2920 =
				     (cvar_cinfo_53_bglt) (value_2122);
				  {
				     obj_t aux_3350;
				     {	/* ./Cfa/cinfo.scm 929 */
					object_bglt aux_3351;
					aux_3351 =
					   (object_bglt) (obj_2920);
					aux_3350 =
					   OBJECT_WIDENING(aux_3351);
				     }
				     aux_3348 =
					(((cvar_cinfo_53_bglt) CREF(aux_3350))->approx);
				  }
			       }
			       aux_3347 =
				  (obj_t) (aux_3348);
			    }
			    arg2054_2127 =
			       shape_tools_shape(aux_3347);
			 }
			 display_2_122___r4_output_6_10_3(arg2054_2127, port_5);
		      }
		   }
		 else
		   {	/* Cfa/show.scm 101 */
		      bool_t test2056_2129;
		      test2056_2129 =
			 is_a__118___object(
			 (obj_t) (value_2122), scnst_cinfo_0_cfa_info);
		      if (test2056_2129)
			{	/* Cfa/show.scm 101 */
			   display_2_122___r4_output_6_10_3(string2321_cfa_show, port_5);
			   {	/* Cfa/show.scm 103 */
			      obj_t arg2057_2130;
			      {		/* Cfa/show.scm 103 */
				 obj_t aux_3362;
				 {	/* Cfa/show.scm 103 */
				    approx_bglt aux_3363;
				    {	/* Cfa/show.scm 103 */
				       scnst_cinfo_0_bglt obj_2922;
				       obj_2922 =
					  (scnst_cinfo_0_bglt) (value_2122);
				       {
					  obj_t aux_3365;
					  {	/* ./Cfa/cinfo.scm 919 */
					     object_bglt aux_3366;
					     aux_3366 =
						(object_bglt) (obj_2922);
					     aux_3365 =
						OBJECT_WIDENING(aux_3366);
					  }
					  aux_3363 =
					     (((scnst_cinfo_0_bglt) CREF(aux_3365))->approx);
				       }
				    }
				    aux_3362 =
				       (obj_t) (aux_3363);
				 }
				 arg2057_2130 =
				    shape_tools_shape(aux_3362);
			      }
			      display_2_122___r4_output_6_10_3(arg2057_2130, port_5);
			   }
			}
		      else
			{	/* Cfa/show.scm 104 */
			   bool_t test2059_2132;
			   test2059_2132 =
			      is_a__118___object(
			      (obj_t) (value_2122), intern_sfun_cinfo_192_cfa_info);
			   if (test2059_2132)
			     {	/* Cfa/show.scm 104 */
				display_2_122___r4_output_6_10_3(string2321_cfa_show, port_5);
				{	/* Cfa/show.scm 106 */
				   obj_t arg2060_2133;
				   {	/* Cfa/show.scm 106 */
				      obj_t aux_3377;
				      {		/* Cfa/show.scm 106 */
					 approx_bglt aux_3378;
					 {	/* Cfa/show.scm 106 */
					    intern_sfun_cinfo_192_bglt obj_2924;
					    obj_2924 =
					       (intern_sfun_cinfo_192_bglt) (value_2122);
					    {
					       obj_t aux_3380;
					       {	/* ./Cfa/cinfo.scm 915 */
						  object_bglt aux_3381;
						  aux_3381 =
						     (object_bglt) (obj_2924);
						  aux_3380 =
						     OBJECT_WIDENING(aux_3381);
					       }
					       aux_3378 =
						  (((intern_sfun_cinfo_192_bglt) CREF(aux_3380))->approx);
					    }
					 }
					 aux_3377 =
					    (obj_t) (aux_3378);
				      }
				      arg2060_2133 =
					 shape_tools_shape(aux_3377);
				   }
				   display_2_122___r4_output_6_10_3(arg2060_2133, port_5);
				}
			     }
			   else
			     {	/* Cfa/show.scm 107 */
				bool_t test2062_2135;
				test2062_2135 =
				   is_a__118___object(
				   (obj_t) (value_2122), extern_sfun_cinfo_6_cfa_info);
				if (test2062_2135)
				  {	/* Cfa/show.scm 107 */
				     display_2_122___r4_output_6_10_3(string2321_cfa_show, port_5);
				     {	/* Cfa/show.scm 109 */
					obj_t arg2063_2136;
					{	/* Cfa/show.scm 109 */
					   obj_t aux_3392;
					   {	/* Cfa/show.scm 109 */
					      approx_bglt aux_3393;
					      {		/* Cfa/show.scm 109 */
						 extern_sfun_cinfo_6_bglt obj_2926;
						 obj_2926 =
						    (extern_sfun_cinfo_6_bglt) (value_2122);
						 {
						    obj_t aux_3395;
						    {	/* ./Cfa/cinfo.scm 913 */
						       object_bglt aux_3396;
						       aux_3396 =
							  (object_bglt) (obj_2926);
						       aux_3395 =
							  OBJECT_WIDENING(aux_3396);
						    }
						    aux_3393 =
						       (((extern_sfun_cinfo_6_bglt) CREF(aux_3395))->approx);
						 }
					      }
					      aux_3392 =
						 (obj_t) (aux_3393);
					   }
					   arg2063_2136 =
					      shape_tools_shape(aux_3392);
					}
					display_2_122___r4_output_6_10_3(arg2063_2136, port_5);
				     }
				  }
				else
				  {	/* Cfa/show.scm 110 */
				     bool_t test2065_2138;
				     test2065_2138 =
					is_a__118___object(
					(obj_t) (value_2122), cfun_cinfo_200_cfa_info);
				     if (test2065_2138)
				       {	/* Cfa/show.scm 110 */
					  display_2_122___r4_output_6_10_3(string2321_cfa_show, port_5);
					  {	/* Cfa/show.scm 112 */
					     obj_t arg2066_2139;
					     {	/* Cfa/show.scm 112 */
						obj_t aux_3407;
						{	/* Cfa/show.scm 112 */
						   approx_bglt aux_3408;
						   {	/* Cfa/show.scm 112 */
						      cfun_cinfo_200_bglt obj_2928;
						      obj_2928 =
							 (cfun_cinfo_200_bglt) (value_2122);
						      {
							 obj_t aux_3410;
							 {	/* ./Cfa/cinfo.scm 912 */
							    object_bglt aux_3411;
							    aux_3411 =
							       (object_bglt) (obj_2928);
							    aux_3410 =
							       OBJECT_WIDENING(aux_3411);
							 }
							 aux_3408 =
							    (((cfun_cinfo_200_bglt) CREF(aux_3410))->approx);
						      }
						   }
						   aux_3407 =
						      (obj_t) (aux_3408);
						}
						arg2066_2139 =
						   shape_tools_shape(aux_3407);
					     }
					     display_2_122___r4_output_6_10_3(arg2066_2139, port_5);
					  }
				       }
				     else
				       {	/* Cfa/show.scm 110 */
					  BFALSE;
				       }
				  }
			     }
			}
		   }
	      }
	 }
	 {	/* Cfa/show.scm 113 */
	    obj_t arg2068_2141;
	    arg2068_2141 =
	       close_output_port(port_5);
	    {	/* ./Ieee/symbol.scm 6027 */
	       char *aux_3419;
	       aux_3419 =
		  BSTRING_TO_STRING(arg2068_2141);
	       return
		  string_to_symbol(aux_3419);
	    }
	 }
      }
   }
}



/* method-init */
obj_t 
method_init_76_cfa_show()
{
   AN_OBJECT;
   {	/* Cfa/show.scm 14 */
      {		/* Cfa/show.scm 14 */
	 obj_t shape_reshaped_local2034_18_3288;
	 shape_reshaped_local2034_18_3288 = proc2322_cfa_show;
	 add_method__1___object(shape_env_98_tools_shape, reshaped_local_224_cfa_info, shape_reshaped_local2034_18_3288);
      }
      {		/* Cfa/show.scm 14 */
	 obj_t shape_reshaped_global2036_151_3285;
	 shape_reshaped_global2036_151_3285 = proc2323_cfa_show;
	 return
	    add_method__1___object(shape_env_98_tools_shape, reshaped_global_160_cfa_info, shape_reshaped_global2036_151_3285);
      }
   }
}



/* shape-reshaped-global2036 */
obj_t 
shape_reshaped_global2036_151_cfa_show(obj_t env_3289, obj_t global_3290)
{
   AN_OBJECT;
   {	/* Cfa/show.scm 84 */
      {
	 reshaped_global_160_bglt global_2903;
	 global_2903 =
	    (reshaped_global_160_bglt) (global_3290);
	 {

	    {	/* Cfa/show.scm 85 */
	       obj_t port_2906;
	       port_2906 =
		  open_output_string();
	       {	/* Cfa/show.scm 86 */
		  obj_t arg2316_2907;
		  {	/* Cfa/show.scm 84 */
		     obj_t next_method2035_204_2908;
		     next_method2035_204_2908 =
			find_super_class_method_167___object(
			(object_bglt) (global_2903), shape_env_98_tools_shape, reshaped_global_160_cfa_info);
		     if (
			PROCEDUREP(next_method2035_204_2908))
		       {	/* Cfa/show.scm 84 */
			  arg2316_2907 =
			     PROCEDURE_ENTRY(next_method2035_204_2908) (next_method2035_204_2908,
			     (obj_t) (global_2903), BEOA);
		       }
		     else
		       {	/* Cfa/show.scm 84 */
			  PROCEDURE_SET(shape_env_98_tools_shape, ((long) 2), next_method2035_204_2908);
			  arg2316_2907 =
			     shape_tools_shape(
			     (obj_t) (global_2903));
		       }
		  }
		  display_2_122___r4_output_6_10_3(arg2316_2907, port_2906);
	       }
	       return
		  cfa_variable_shape_84_cfa_show(
		  (obj_t) (global_2903), port_2906);
	    }
	 }
      }
   }
}



/* shape-reshaped-local2034 */
obj_t 
shape_reshaped_local2034_18_cfa_show(obj_t env_3291, obj_t local_3292)
{
   AN_OBJECT;
   {	/* Cfa/show.scm 76 */
      {
	 reshaped_local_224_bglt local_2896;
	 local_2896 =
	    (reshaped_local_224_bglt) (local_3292);
	 {

	    {	/* Cfa/show.scm 77 */
	       obj_t port_2899;
	       port_2899 =
		  open_output_string();
	       {	/* Cfa/show.scm 78 */
		  obj_t arg2314_2900;
		  {	/* Cfa/show.scm 76 */
		     obj_t next_method2033_212_2901;
		     next_method2033_212_2901 =
			find_super_class_method_167___object(
			(object_bglt) (local_2896), shape_env_98_tools_shape, reshaped_local_224_cfa_info);
		     if (
			PROCEDUREP(next_method2033_212_2901))
		       {	/* Cfa/show.scm 76 */
			  arg2314_2900 =
			     PROCEDURE_ENTRY(next_method2033_212_2901) (next_method2033_212_2901,
			     (obj_t) (local_2896), BEOA);
		       }
		     else
		       {	/* Cfa/show.scm 76 */
			  PROCEDURE_SET(shape_env_98_tools_shape, ((long) 2), next_method2033_212_2901);
			  arg2314_2900 =
			     shape_tools_shape(
			     (obj_t) (local_2896));
		       }
		  }
		  display_2_122___r4_output_6_10_3(arg2314_2900, port_2899);
	       }
	       return
		  cfa_variable_shape_84_cfa_show(
		  (obj_t) (local_2896), port_2899);
	    }
	 }
      }
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_cfa_show()
{
   AN_OBJECT;
   {	/* Cfa/show.scm 14 */
      module_initialization_70_tools_trace(((long) 0), "CFA_SHOW");
      module_initialization_70_tools_shape(((long) 0), "CFA_SHOW");
      module_initialization_70_tools_speek(((long) 0), "CFA_SHOW");
      module_initialization_70_write_scheme(((long) 0), "CFA_SHOW");
      module_initialization_70_type_type(((long) 0), "CFA_SHOW");
      module_initialization_70_ast_var(((long) 0), "CFA_SHOW");
      module_initialization_70_ast_node(((long) 0), "CFA_SHOW");
      module_initialization_70_cfa_info(((long) 0), "CFA_SHOW");
      module_initialization_70_cfa_info2(((long) 0), "CFA_SHOW");
      module_initialization_70_cfa_approx(((long) 0), "CFA_SHOW");
      module_initialization_70_cfa_collect(((long) 0), "CFA_SHOW");
      return
	 module_initialization_70_cfa_iterate(((long) 0), "CFA_SHOW");
   }
}
