/*===========================================================================*/
/*   (Cfa/specialize.scm)                                                    */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;

typedef struct isfun
  {
     struct node *original_body_40;
     obj_t recursive_calls_44;
  }
     *isfun_bglt;

typedef struct specialized_global_131
  {
     obj_t fix;
  }
                      *specialized_global_131_bglt;


static obj_t method_init_76_cfa_specialize();
extern obj_t make_box_202_ast_node;
extern obj_t find_global_module_25_ast_env(obj_t, obj_t);
extern obj_t funcall_ast_node;
extern obj_t specialize__184_cfa_specialize(obj_t);
extern obj_t _optim__89_engine_param;
static obj_t add_specialized_type__70_cfa_specialize(type_bglt);
static obj_t _allocate_specialized_global_95_cfa_specialize(obj_t);
extern long add_inlined_method__244___object(obj_t, obj_t, long);
extern obj_t fail_ast_node;
static bool_t show_specialize_223_cfa_specialize();
extern obj_t box_ref_242_ast_node;
extern obj_t sequence_ast_node;
extern obj_t let_var_6_ast_node;
static obj_t _specialized_types__137_cfa_specialize = BUNSPEC;
extern obj_t var_ast_node;
static obj_t patch__227_cfa_specialize(node_bglt);
extern obj_t warning___error(obj_t);
extern obj_t closure_ast_node;
extern object_bglt struct_object__object_93___object(object_bglt, obj_t);
extern obj_t add_method__1___object(obj_t, obj_t, obj_t);
extern obj_t global_ast_var;
extern obj_t pragma_ast_node;
extern obj_t set_ex_it_116_ast_node;
extern obj_t find_super_class_method_167___object(object_bglt, obj_t, obj_t);
static obj_t patch___72_cfa_specialize(obj_t);
extern obj_t verbose_tools_speek(obj_t, obj_t);
static obj_t _patch__77_cfa_specialize(obj_t, obj_t);
extern bool_t is_a__118___object(obj_t, obj_t);
static obj_t _patch__default1514_14_cfa_specialize(obj_t, obj_t);
extern obj_t module_initialization_70_cfa_specialize(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_speek(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_coerce_typeof(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_ast_env(long, char *);
extern obj_t module_initialization_70_inline_inline(long, char *);
extern obj_t module_initialization_70_inline_walk(long, char *);
extern obj_t module_initialization_70___error(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
static obj_t install_specialize__168_cfa_specialize(obj_t, obj_t, obj_t);
static node_bglt specialize_app__163_cfa_specialize(app_bglt);
extern long class_num_218___object(obj_t);
static bool_t uninstall_specializes__251_cfa_specialize();
extern obj_t let_fun_218_ast_node;
static obj_t imported_modules_init_94_cfa_specialize();
static bool_t specialize_optimization__103_cfa_specialize();
extern obj_t app_ly_162_ast_node;
static global_bglt allocate_specialized_global_107_cfa_specialize();
extern obj_t add_generic__110___object(obj_t, obj_t);
static obj_t patch_fun__141_cfa_specialize(obj_t);
extern obj_t app_ast_node;
static obj_t library_modules_init_112_cfa_specialize();
static obj_t specialized_global_131_cfa_specialize = BUNSPEC;
extern obj_t make_struct(obj_t, long, obj_t);
static obj_t struct_object__object_specialized_global1568_34_cfa_specialize(obj_t, obj_t, obj_t);
extern obj_t atom_ast_node;
extern obj_t cast_ast_node;
extern obj_t assq___r4_pairs_and_lists_6_3(obj_t, obj_t);
static obj_t toplevel_init_63_cfa_specialize();
extern obj_t create_vector(long);
extern obj_t jump_ex_it_184_ast_node;
extern obj_t open_input_string(obj_t);
extern obj_t kwote_ast_node;
extern obj_t sfun_ast_var;
extern obj_t setq_ast_node;
extern obj_t box_set__221_ast_node;
extern type_bglt typeof_coerce_typeof(node_bglt);
static bool_t patch_tree__164_cfa_specialize(obj_t);
extern obj_t register_class__225___object(obj_t, obj_t, obj_t, long, obj_t, obj_t, obj_t);
static obj_t patch__default1514_65_cfa_specialize(node_bglt);
extern obj_t shape_tools_shape(obj_t);
static obj_t _specialize__50_cfa_specialize = BUNSPEC;
extern obj_t internal_error_43_tools_error(obj_t, obj_t, obj_t);
static obj_t object_init_111_cfa_specialize();
static obj_t install_specialized_type__228_cfa_specialize(type_bglt);
extern obj_t _classes__134___object;
extern obj_t select_ast_node;
extern obj_t read___reader(obj_t);
extern obj_t _lib_mode__85_engine_param;
extern obj_t object__struct_50___object(object_bglt);
static obj_t require_initialization_114_cfa_specialize = BUNSPEC;
extern obj_t conditional_ast_node;
static obj_t object__struct_specialized_global1566_146_cfa_specialize(obj_t, obj_t);
static obj_t _specialize__238_cfa_specialize(obj_t, obj_t);
extern obj_t class_super_145___object(obj_t);
static obj_t cnst_init_137_cfa_specialize();
static obj_t __cnst[60];

DEFINE_STATIC_PROCEDURE(allocate_specialized_global_env_23_cfa_specialize, _allocate_specialized_global_95_cfa_specialize1992, _allocate_specialized_global_95_cfa_specialize, 0L, 0);
DEFINE_STATIC_PROCEDURE(patch__default1514_env_32_cfa_specialize, _patch__default1514_14_cfa_specialize1993, _patch__default1514_14_cfa_specialize, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc1983_cfa_specialize, struct_object__object_specialized_global1568_34_cfa_specialize1994, struct_object__object_specialized_global1568_34_cfa_specialize, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc1982_cfa_specialize, object__struct_specialized_global1566_146_cfa_specialize1995, object__struct_specialized_global1566_146_cfa_specialize, 0L, 1);
extern obj_t struct_object__object_env_209___object;
DEFINE_EXPORT_PROCEDURE(specialize__env_161_cfa_specialize, _specialize__238_cfa_specialize1996, _specialize__238_cfa_specialize, 0L, 1);
DEFINE_STATIC_GENERIC(patch__env_129_cfa_specialize, _patch__77_cfa_specialize1997, _patch__77_cfa_specialize, 0L, 1);
DEFINE_STRING(string1987_cfa_specialize, string1987_cfa_specialize1998, "PATCH!-DEFAULT1514 SPECIALIZED-GLOBAL DONE SQRT SQRTFL ACOS ACOSFL ASIN ASINFL TAN TANFL COS COSFL SIN SINFL EXP EXPFL LOG LOGFL ABS ABSFL ABSFX 2/ /FL 2* *FL *FX 2- -FL -FX 2+ +FL +FX NEGATIVE? NEGATIVEFL? NEGATIVEFX? POSITIVE? POSITIVEFL? POSITIVEFX? ZERO? ZEROFL? ZEROFX? 2>= >=FL >=FX 2<= <=FL <=FX 2> >FL >FX 2< <FL <FX __R4_NUMBERS_6_5 2= __R4_NUMBERS_6_5_FLONUM =FL __R4_NUMBERS_6_5_FIXNUM =FX ", 401);
DEFINE_STRING(string1986_cfa_specialize, string1986_cfa_specialize1999, "No method for this object", 25);
DEFINE_STRING(string1985_cfa_specialize, string1985_cfa_specialize2000, "Unexpected closure", 18);
DEFINE_STRING(string1984_cfa_specialize, string1984_cfa_specialize2001, "patch!", 6);
DEFINE_STRING(string1981_cfa_specialize, string1981_cfa_specialize2002, "Can't fund global", 17);
DEFINE_STRING(string1979_cfa_specialize, string1979_cfa_specialize2003, "Can't find global", 17);
DEFINE_STRING(string1980_cfa_specialize, string1980_cfa_specialize2004, "install-specialize!", 19);
DEFINE_STRING(string1978_cfa_specialize, string1978_cfa_specialize2005, " -- ", 4);
DEFINE_STRING(string1977_cfa_specialize, string1977_cfa_specialize2006, "Unspecialized type", 18);
DEFINE_STRING(string1976_cfa_specialize, string1976_cfa_specialize2007, "add-specialized-type!", 21);
DEFINE_STRING(string1975_cfa_specialize, string1975_cfa_specialize2008, "        (-> ", 12);
DEFINE_STRING(string1974_cfa_specialize, string1974_cfa_specialize2009, ": ", 2);
DEFINE_STRING(string1973_cfa_specialize, string1973_cfa_specialize2010, ")\n", 2);
DEFINE_STRING(string1972_cfa_specialize, string1972_cfa_specialize2011, "   . specializing", 17);
extern obj_t object__struct_env_210___object;



/* module-initialization */
obj_t 
module_initialization_70_cfa_specialize(long checksum_1916, char *from_1917)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_cfa_specialize))
	{
	   require_initialization_114_cfa_specialize =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_cfa_specialize();
	   cnst_init_137_cfa_specialize();
	   imported_modules_init_94_cfa_specialize();
	   object_init_111_cfa_specialize();
	   method_init_76_cfa_specialize();
	   toplevel_init_63_cfa_specialize();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_cfa_specialize()
{
   AN_OBJECT;
   {	/* Cfa/specialize.scm 18 */
      module_initialization_70___object(((long) 0), "CFA_SPECIALIZE");
      module_initialization_70___error(((long) 0), "CFA_SPECIALIZE");
      module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "CFA_SPECIALIZE");
      module_initialization_70___reader(((long) 0), "CFA_SPECIALIZE");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_cfa_specialize()
{
   AN_OBJECT;
   {	/* Cfa/specialize.scm 18 */
      {		/* Cfa/specialize.scm 18 */
	 obj_t cnst_port_138_1909;
	 cnst_port_138_1909 =
	    open_input_string(string1987_cfa_specialize);
	 {
	    long i_1910;
	    i_1910 = ((long) 59);
	  loop_1911:
	    {	/* Cfa/specialize.scm 18 */
	       bool_t test1988_1912;
	       test1988_1912 =
		  (i_1910 == ((long) -1));
	       if (test1988_1912)
		 {	/* Cfa/specialize.scm 18 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Cfa/specialize.scm 18 */
		    {	/* Cfa/specialize.scm 18 */
		       obj_t arg1989_1913;
		       {	/* Cfa/specialize.scm 18 */
			  obj_t list1990_1914;
			  list1990_1914 =
			     MAKE_PAIR(cnst_port_138_1909, BNIL);
			  arg1989_1913 =
			     read___reader(list1990_1914);
		       }
		       CNST_TABLE_SET(i_1910, arg1989_1913);
		    }
		    {	/* Cfa/specialize.scm 18 */
		       int aux_1915;
		       {	/* Cfa/specialize.scm 18 */
			  long aux_1937;
			  aux_1937 =
			     (i_1910 - ((long) 1));
			  aux_1915 =
			     (int) (aux_1937);
		       }
		       {
			  long i_1940;
			  i_1940 =
			     (long) (aux_1915);
			  i_1910 = i_1940;
			  goto loop_1911;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_cfa_specialize()
{
   AN_OBJECT;
   {	/* Cfa/specialize.scm 18 */
      _specialize__50_cfa_specialize = BNIL;
      _specialized_types__137_cfa_specialize = BNIL;
      return BUNSPEC;
   }
}



/* specialize-optimization? */
bool_t 
specialize_optimization__103_cfa_specialize()
{
   AN_OBJECT;
   {	/* Cfa/specialize.scm 39 */
      {		/* Cfa/specialize.scm 40 */
	 bool_t _andtest_1480_845;
	 {	/* Cfa/specialize.scm 40 */
	    long n1_1586;
	    n1_1586 =
	       (long) CINT(_optim__89_engine_param);
	    _andtest_1480_845 =
	       (n1_1586 >= ((long) 1));
	 }
	 if (_andtest_1480_845)
	   {	/* Cfa/specialize.scm 40 */
	      if (
		 CBOOL(_lib_mode__85_engine_param))
		{	/* Cfa/specialize.scm 40 */
		   return ((bool_t) 0);
		}
	      else
		{	/* Cfa/specialize.scm 40 */
		   return ((bool_t) 1);
		}
	   }
	 else
	   {	/* Cfa/specialize.scm 40 */
	      return ((bool_t) 0);
	   }
      }
   }
}



/* show-specialize */
bool_t 
show_specialize_223_cfa_specialize()
{
   AN_OBJECT;
   {	/* Cfa/specialize.scm 45 */
      {		/* Cfa/specialize.scm 46 */
	 obj_t list1569_846;
	 {	/* Cfa/specialize.scm 46 */
	    obj_t arg1572_848;
	    {	/* Cfa/specialize.scm 46 */
	       obj_t aux_1947;
	       aux_1947 =
		  BCHAR(((unsigned char) '\n'));
	       arg1572_848 =
		  MAKE_PAIR(aux_1947, BNIL);
	    }
	    list1569_846 =
	       MAKE_PAIR(string1972_cfa_specialize, arg1572_848);
	 }
	 verbose_tools_speek(
	    BINT(((long) 1)), list1569_846);
      }
      {
	 obj_t l1481_849;
	 l1481_849 = _specialized_types__137_cfa_specialize;
       lname1482_850:
	 if (
	    PAIRP(l1481_849))
	   {	/* Cfa/specialize.scm 47 */
	      {		/* Cfa/specialize.scm 48 */
		 obj_t type_num_186_852;
		 type_num_186_852 =
		    CAR(l1481_849);
		 {	/* Cfa/specialize.scm 48 */
		    bool_t test_1956;
		    {	/* ./Ieee/fixnum.scm 7121 */
		       long aux_1957;
		       {	/* Cfa/specialize.scm 48 */
			  obj_t aux_1958;
			  aux_1958 =
			     CDR(type_num_186_852);
			  aux_1957 =
			     (long) CINT(aux_1958);
		       }
		       test_1956 =
			  (aux_1957 > ((long) 0));
		    }
		    if (test_1956)
		      {		/* Cfa/specialize.scm 49 */
			 obj_t arg1578_856;
			 obj_t arg1580_858;
			 arg1578_856 =
			    shape_tools_shape(
			    CAR(type_num_186_852));
			 arg1580_858 =
			    CDR(type_num_186_852);
			 {	/* Cfa/specialize.scm 49 */
			    obj_t list1582_860;
			    {	/* Cfa/specialize.scm 49 */
			       obj_t arg1583_861;
			       {	/* Cfa/specialize.scm 49 */
				  obj_t arg1584_862;
				  {	/* Cfa/specialize.scm 49 */
				     obj_t arg1585_863;
				     {	/* Cfa/specialize.scm 49 */
					obj_t arg1586_864;
					arg1586_864 =
					   MAKE_PAIR(string1973_cfa_specialize, BNIL);
					arg1585_863 =
					   MAKE_PAIR(arg1580_858, arg1586_864);
				     }
				     arg1584_862 =
					MAKE_PAIR(string1974_cfa_specialize, arg1585_863);
				  }
				  arg1583_861 =
				     MAKE_PAIR(arg1578_856, arg1584_862);
			       }
			       list1582_860 =
				  MAKE_PAIR(string1975_cfa_specialize, arg1583_861);
			    }
			    verbose_tools_speek(
			       BINT(((long) 2)), list1582_860);
			 }
		      }
		    else
		      {		/* Cfa/specialize.scm 48 */
			 BUNSPEC;
		      }
		 }
	      }
	      {
		 obj_t l1481_1972;
		 l1481_1972 =
		    CDR(l1481_849);
		 l1481_849 = l1481_1972;
		 goto lname1482_850;
	      }
	   }
	 else
	   {	/* Cfa/specialize.scm 47 */
	      return ((bool_t) 1);
	   }
      }
   }
}



/* install-specialized-type! */
obj_t 
install_specialized_type__228_cfa_specialize(type_bglt type_1)
{
   AN_OBJECT;
   {	/* Cfa/specialize.scm 62 */
      {		/* Cfa/specialize.scm 63 */
	 bool_t test1591_869;
	 {	/* Cfa/specialize.scm 63 */
	    obj_t arg1593_871;
	    arg1593_871 =
	       assq___r4_pairs_and_lists_6_3(
	       (obj_t) (type_1), _specialized_types__137_cfa_specialize);
	    test1591_869 =
	       PAIRP(arg1593_871);
	 }
	 if (test1591_869)
	   {	/* Cfa/specialize.scm 63 */
	      return BUNSPEC;
	   }
	 else
	   {	/* Cfa/specialize.scm 64 */
	      obj_t arg1592_870;
	      {		/* ./Ieee/pair-list.scm 5689 */
		 obj_t aux_1980;
		 obj_t aux_1978;
		 aux_1980 =
		    BINT(((long) 0));
		 aux_1978 =
		    (obj_t) (type_1);
		 arg1592_870 =
		    MAKE_PAIR(aux_1978, aux_1980);
	      }
	      {		/* Cfa/specialize.scm 64 */
		 obj_t obj2_1600;
		 obj2_1600 = _specialized_types__137_cfa_specialize;
		 return (
		    _specialized_types__137_cfa_specialize =
		    MAKE_PAIR(arg1592_870, obj2_1600), BUNSPEC);
	      }
	   }
      }
   }
}



/* add-specialized-type! */
obj_t 
add_specialized_type__70_cfa_specialize(type_bglt type_2)
{
   AN_OBJECT;
   {	/* Cfa/specialize.scm 69 */
      {		/* Cfa/specialize.scm 70 */
	 obj_t cell_872;
	 cell_872 =
	    assq___r4_pairs_and_lists_6_3(
	    (obj_t) (type_2), _specialized_types__137_cfa_specialize);
	 if (
	    PAIRP(cell_872))
	   {	/* ./Ieee/pair-list.scm 5896 */
	      obj_t aux_1988;
	      {		/* Cfa/specialize.scm 75 */
		 long aux_1989;
		 {	/* ./Ieee/fixnum.scm 7193 */
		    long aux_1990;
		    {	/* Cfa/specialize.scm 75 */
		       obj_t aux_1991;
		       aux_1991 =
			  CDR(cell_872);
		       aux_1990 =
			  (long) CINT(aux_1991);
		    }
		    aux_1989 =
		       (((long) 1) + aux_1990);
		 }
		 aux_1988 =
		    BINT(aux_1989);
	      }
	      return
		 SET_CDR(cell_872, aux_1988);
	   }
	 else
	   {	/* Cfa/specialize.scm 72 */
	      obj_t arg1600_879;
	      arg1600_879 =
		 shape_tools_shape(
		 (obj_t) (type_2));
	      return
		 internal_error_43_tools_error(string1976_cfa_specialize, string1977_cfa_specialize, arg1600_879);
	   }
      }
   }
}



/* install-specialize! */
obj_t 
install_specialize__168_cfa_specialize(obj_t gen_id_29_3, obj_t gen_mod_247_4, obj_t fixes_5)
{
   AN_OBJECT;
   {	/* Cfa/specialize.scm 80 */
      {		/* Cfa/specialize.scm 81 */
	 obj_t generic_880;
	 generic_880 =
	    find_global_module_25_ast_env(gen_id_29_3, gen_mod_247_4);
	 {	/* Cfa/specialize.scm 82 */
	    bool_t test1601_881;
	    test1601_881 =
	       is_a__118___object(generic_880, global_ast_var);
	    if (test1601_881)
	      {
		 obj_t fixes_882;
		 obj_t res_883;
		 fixes_882 = fixes_5;
		 res_883 = BNIL;
	       loop_884:
		 if (
		    NULLP(fixes_882))
		   {	/* Cfa/specialize.scm 85 */
		      {		/* Cfa/specialize.scm 87 */
			 specialized_global_131_bglt obj1483_886;
			 obj1483_886 =
			    ((specialized_global_131_bglt) (generic_880));
			 {	/* Cfa/specialize.scm 87 */
			    specialized_global_131_bglt arg1603_887;
			    {	/* Cfa/specialize.scm 87 */
			       specialized_global_131_bglt res1966_1612;
			       {	/* Cfa/specialize.scm 32 */
				  specialized_global_131_bglt new1468_1610;
				  new1468_1610 =
				     ((specialized_global_131_bglt) BREF(GC_MALLOC(sizeof(struct specialized_global_131))));
				  ((((specialized_global_131_bglt) CREF(new1468_1610))->fix) = ((obj_t) res_883), BUNSPEC);
				  res1966_1612 = new1468_1610;
			       }
			       arg1603_887 = res1966_1612;
			    }
			    {	/* Cfa/specialize.scm 87 */
			       obj_t aux_2010;
			       object_bglt aux_2008;
			       aux_2010 =
				  (obj_t) (arg1603_887);
			       aux_2008 =
				  (object_bglt) (obj1483_886);
			       OBJECT_WIDENING_SET(aux_2008, aux_2010);
			    }
			 }
			 {	/* Cfa/specialize.scm 87 */
			    long arg1605_889;
			    arg1605_889 =
			       class_num_218___object(specialized_global_131_cfa_specialize);
			    {	/* Cfa/specialize.scm 87 */
			       obj_t obj_1613;
			       obj_1613 =
				  (obj_t) (obj1483_886);
			       (((obj_t) CREF(obj_1613))->header = MAKE_HEADER(arg1605_889, 0), BUNSPEC);
			    }
			 }
			 obj1483_886;
		      }
		      {		/* Cfa/specialize.scm 89 */
			 obj_t obj2_1616;
			 obj2_1616 = _specialize__50_cfa_specialize;
			 return (
			    _specialize__50_cfa_specialize =
			    MAKE_PAIR(generic_880, obj2_1616), BUNSPEC);
		      }
		   }
		 else
		   {	/* Cfa/specialize.scm 90 */
		      obj_t id_890;
		      id_890 =
			 CAR(fixes_882);
		      {		/* Cfa/specialize.scm 90 */
			 obj_t mod_891;
			 {	/* ./Ieee/pair-list.scm 5701 */
			    obj_t aux_2018;
			    aux_2018 =
			       CDR(fixes_882);
			    mod_891 =
			       CAR(aux_2018);
			 }
			 {	/* Cfa/specialize.scm 91 */
			    obj_t global_892;
			    global_892 =
			       find_global_module_25_ast_env(id_890, mod_891);
			    {	/* Cfa/specialize.scm 92 */

			       {	/* Cfa/specialize.scm 93 */
				  bool_t test1606_893;
				  {	/* Cfa/specialize.scm 93 */
				     bool_t test1622_910;
				     test1622_910 =
					is_a__118___object(global_892, global_ast_var);
				     if (test1622_910)
				       {	/* Cfa/specialize.scm 94 */
					  bool_t test1623_911;
					  {	/* ./Ast/var.scm 1225 */
					     obj_t aux_2024;
					     {	/* Cfa/specialize.scm 94 */
						value_bglt aux_2025;
						{	/* Cfa/specialize.scm 94 */
						   global_bglt obj_1623;
						   obj_1623 =
						      (global_bglt) (global_892);
						   aux_2025 =
						      (((global_bglt) CREF(obj_1623))->value);
						}
						aux_2024 =
						   (obj_t) (aux_2025);
					     }
					     test1623_911 =
						is_a__118___object(aux_2024, sfun_ast_var);
					  }
					  if (test1623_911)
					    {	/* ./Ieee/pair-list.scm 5669 */
					       obj_t aux_2031;
					       {	/* Cfa/specialize.scm 95 */
						  sfun_bglt obj_1626;
						  {	/* Cfa/specialize.scm 95 */
						     value_bglt aux_2032;
						     {	/* Cfa/specialize.scm 95 */
							global_bglt obj_1625;
							obj_1625 =
							   (global_bglt) (global_892);
							aux_2032 =
							   (((global_bglt) CREF(obj_1625))->value);
						     }
						     obj_1626 =
							(sfun_bglt) (aux_2032);
						  }
						  aux_2031 =
						     (((sfun_bglt) CREF(obj_1626))->args);
					       }
					       test1606_893 =
						  PAIRP(aux_2031);
					    }
					  else
					    {	/* Cfa/specialize.scm 94 */
					       test1606_893 = ((bool_t) 0);
					    }
				       }
				     else
				       {	/* Cfa/specialize.scm 93 */
					  test1606_893 = ((bool_t) 0);
				       }
				  }
				  if (test1606_893)
				    {	/* Cfa/specialize.scm 96 */
				       type_bglt type_894;
				       {	/* Cfa/specialize.scm 96 */
					  local_bglt obj_1631;
					  {	/* Cfa/specialize.scm 96 */
					     obj_t aux_2039;
					     {	/* ./Ieee/pair-list.scm 5701 */
						obj_t aux_2040;
						{	/* Cfa/specialize.scm 98 */
						   sfun_bglt obj_1629;
						   {	/* Cfa/specialize.scm 98 */
						      value_bglt aux_2041;
						      {		/* Cfa/specialize.scm 99 */
							 global_bglt obj_1628;
							 obj_1628 =
							    (global_bglt) (global_892);
							 aux_2041 =
							    (((global_bglt) CREF(obj_1628))->value);
						      }
						      obj_1629 =
							 (sfun_bglt) (aux_2041);
						   }
						   aux_2040 =
						      (((sfun_bglt) CREF(obj_1629))->args);
						}
						aux_2039 =
						   CAR(aux_2040);
					     }
					     obj_1631 =
						(local_bglt) (aux_2039);
					  }
					  type_894 =
					     (((local_bglt) CREF(obj_1631))->type);
				       }
				       install_specialized_type__228_cfa_specialize(type_894);
				       {	/* Cfa/specialize.scm 102 */
					  obj_t arg1607_895;
					  obj_t arg1608_896;
					  {	/* ./Ieee/pair-list.scm 5707 */
					     obj_t aux_2050;
					     aux_2050 =
						CDR(fixes_882);
					     arg1607_895 =
						CDR(aux_2050);
					  }
					  {	/* Cfa/specialize.scm 103 */
					     obj_t arg1609_897;
					     {	/* ./Ieee/pair-list.scm 5689 */
						obj_t aux_2053;
						aux_2053 =
						   (obj_t) (type_894);
						arg1609_897 =
						   MAKE_PAIR(aux_2053, global_892);
					     }
					     arg1608_896 =
						MAKE_PAIR(arg1609_897, res_883);
					  }
					  {
					     obj_t res_2058;
					     obj_t fixes_2057;
					     fixes_2057 = arg1607_895;
					     res_2058 = arg1608_896;
					     res_883 = res_2058;
					     fixes_882 = fixes_2057;
					     goto loop_884;
					  }
				       }
				    }
				  else
				    {	/* Cfa/specialize.scm 93 */
				       {	/* Cfa/specialize.scm 105 */
					  obj_t arg1616_904;
					  arg1616_904 =
					     MAKE_PAIR(id_890, mod_891);
					  {	/* Cfa/specialize.scm 105 */
					     obj_t list1617_905;
					     {	/* Cfa/specialize.scm 105 */
						obj_t arg1618_906;
						{	/* Cfa/specialize.scm 105 */
						   obj_t arg1619_907;
						   {	/* Cfa/specialize.scm 105 */
						      obj_t arg1620_908;
						      arg1620_908 =
							 MAKE_PAIR(arg1616_904, BNIL);
						      arg1619_907 =
							 MAKE_PAIR(string1978_cfa_specialize, arg1620_908);
						   }
						   arg1618_906 =
						      MAKE_PAIR(string1979_cfa_specialize, arg1619_907);
						}
						list1617_905 =
						   MAKE_PAIR(string1980_cfa_specialize, arg1618_906);
					     }
					     warning___error(list1617_905);
					  }
				       }
				       {
					  obj_t fixes_2065;
					  {	/* ./Ieee/pair-list.scm 5707 */
					     obj_t aux_2066;
					     aux_2066 =
						CDR(fixes_882);
					     fixes_2065 =
						CDR(aux_2066);
					  }
					  fixes_882 = fixes_2065;
					  goto loop_884;
				       }
				    }
			       }
			    }
			 }
		      }
		   }
	      }
	    else
	      {		/* Cfa/specialize.scm 110 */
		 obj_t arg1630_918;
		 arg1630_918 =
		    MAKE_PAIR(gen_id_29_3, gen_mod_247_4);
		 {	/* Cfa/specialize.scm 110 */
		    obj_t list1631_919;
		    {	/* Cfa/specialize.scm 110 */
		       obj_t arg1632_920;
		       {	/* Cfa/specialize.scm 110 */
			  obj_t arg1633_921;
			  {	/* Cfa/specialize.scm 110 */
			     obj_t arg1634_922;
			     arg1634_922 =
				MAKE_PAIR(arg1630_918, BNIL);
			     arg1633_921 =
				MAKE_PAIR(string1978_cfa_specialize, arg1634_922);
			  }
			  arg1632_920 =
			     MAKE_PAIR(string1981_cfa_specialize, arg1633_921);
		       }
		       list1631_919 =
			  MAKE_PAIR(string1980_cfa_specialize, arg1632_920);
		    }
		    return
		       warning___error(list1631_919);
		 }
	      }
	 }
      }
   }
}



/* uninstall-specializes! */
bool_t 
uninstall_specializes__251_cfa_specialize()
{
   AN_OBJECT;
   {	/* Cfa/specialize.scm 118 */
      _specialized_types__137_cfa_specialize = BNIL;
      {
	 obj_t l1484_923;
	 l1484_923 = _specialize__50_cfa_specialize;
       lname1485_924:
	 if (
	    PAIRP(l1484_923))
	   {	/* Cfa/specialize.scm 120 */
	      {		/* Cfa/specialize.scm 120 */
		 obj_t o1486_926;
		 o1486_926 =
		    CAR(l1484_923);
		 {	/* Cfa/specialize.scm 120 */
		    long arg1636_927;
		    {	/* Cfa/specialize.scm 120 */
		       obj_t arg1637_928;
		       {	/* Cfa/specialize.scm 120 */
			  obj_t arg1638_929;
			  {	/* Cfa/specialize.scm 120 */
			     object_bglt object_1650;
			     object_1650 =
				(object_bglt) (o1486_926);
			     {	/* ./Llib/object.scm 2695 */
				long arg1179_1651;
				{	/* ./Llib/object.scm 2695 */
				   long arg1180_1652;
				   long arg1181_1653;
				   arg1180_1652 =
				      TYPE(object_1650);
				   arg1181_1653 =
				      OBJECT_TYPE;
				   arg1179_1651 =
				      (arg1180_1652 - arg1181_1653);
				}
				{	/* ./Llib/object.scm 2695 */
				   obj_t vector_1657;
				   vector_1657 = _classes__134___object;
				   arg1638_929 =
				      VECTOR_REF(vector_1657, arg1179_1651);
				}
			     }
			  }
			  arg1637_928 =
			     class_super_145___object(arg1638_929);
		       }
		       arg1636_927 =
			  class_num_218___object(arg1637_928);
		    }
		    (((obj_t) CREF(o1486_926))->header = MAKE_HEADER(arg1636_927, 0), BUNSPEC);
		 }
		 {	/* Cfa/specialize.scm 120 */
		    object_bglt aux_2086;
		    aux_2086 =
		       (object_bglt) (o1486_926);
		    OBJECT_WIDENING_SET(aux_2086, BFALSE);
		 }
		 o1486_926;
	      }
	      {
		 obj_t l1484_2089;
		 l1484_2089 =
		    CDR(l1484_923);
		 l1484_923 = l1484_2089;
		 goto lname1485_924;
	      }
	   }
	 else
	   {	/* Cfa/specialize.scm 120 */
	      return ((bool_t) 1);
	   }
      }
   }
}



/* specialize! */
obj_t 
specialize__184_cfa_specialize(obj_t globals_6)
{
   AN_OBJECT;
   {	/* Cfa/specialize.scm 125 */
      if (
	 specialize_optimization__103_cfa_specialize())
	{	/* Cfa/specialize.scm 126 */
	   {	/* Cfa/specialize.scm 129 */
	      obj_t list1641_932;
	      {		/* Cfa/specialize.scm 129 */
		 obj_t arg1642_933;
		 obj_t arg1643_934;
		 arg1642_933 =
		    CNST_TABLE_REF(((long) 0));
		 {	/* Cfa/specialize.scm 129 */
		    obj_t arg1644_935;
		    obj_t arg1646_936;
		    arg1644_935 =
		       CNST_TABLE_REF(((long) 1));
		    {	/* Cfa/specialize.scm 130 */
		       obj_t arg1647_937;
		       obj_t arg1648_938;
		       arg1647_937 =
			  CNST_TABLE_REF(((long) 2));
		       {	/* Cfa/specialize.scm 128 */
			  obj_t aux_2096;
			  aux_2096 =
			     CNST_TABLE_REF(((long) 3));
			  arg1648_938 =
			     MAKE_PAIR(aux_2096, BNIL);
		       }
		       arg1646_936 =
			  MAKE_PAIR(arg1647_937, arg1648_938);
		    }
		    arg1643_934 =
		       MAKE_PAIR(arg1644_935, arg1646_936);
		 }
		 list1641_932 =
		    MAKE_PAIR(arg1642_933, arg1643_934);
	      }
	      install_specialize__168_cfa_specialize(
		 CNST_TABLE_REF(((long) 4)),
		 CNST_TABLE_REF(((long) 5)), list1641_932);
	   }
	   {	/* Cfa/specialize.scm 132 */
	      obj_t list1649_939;
	      {		/* Cfa/specialize.scm 132 */
		 obj_t arg1650_940;
		 obj_t arg1651_941;
		 arg1650_940 =
		    CNST_TABLE_REF(((long) 6));
		 {	/* Cfa/specialize.scm 132 */
		    obj_t arg1652_942;
		    obj_t arg1653_943;
		    arg1652_942 =
		       CNST_TABLE_REF(((long) 1));
		    {	/* Cfa/specialize.scm 133 */
		       obj_t arg1654_944;
		       obj_t arg1655_945;
		       arg1654_944 =
			  CNST_TABLE_REF(((long) 7));
		       {	/* Cfa/specialize.scm 131 */
			  obj_t aux_2108;
			  aux_2108 =
			     CNST_TABLE_REF(((long) 3));
			  arg1655_945 =
			     MAKE_PAIR(aux_2108, BNIL);
		       }
		       arg1653_943 =
			  MAKE_PAIR(arg1654_944, arg1655_945);
		    }
		    arg1651_941 =
		       MAKE_PAIR(arg1652_942, arg1653_943);
		 }
		 list1649_939 =
		    MAKE_PAIR(arg1650_940, arg1651_941);
	      }
	      install_specialize__168_cfa_specialize(
		 CNST_TABLE_REF(((long) 8)),
		 CNST_TABLE_REF(((long) 5)), list1649_939);
	   }
	   {	/* Cfa/specialize.scm 135 */
	      obj_t list1656_946;
	      {		/* Cfa/specialize.scm 135 */
		 obj_t arg1657_947;
		 obj_t arg1658_948;
		 arg1657_947 =
		    CNST_TABLE_REF(((long) 9));
		 {	/* Cfa/specialize.scm 135 */
		    obj_t arg1659_949;
		    obj_t arg1660_950;
		    arg1659_949 =
		       CNST_TABLE_REF(((long) 1));
		    {	/* Cfa/specialize.scm 136 */
		       obj_t arg1661_951;
		       obj_t arg1662_952;
		       arg1661_951 =
			  CNST_TABLE_REF(((long) 10));
		       {	/* Cfa/specialize.scm 134 */
			  obj_t aux_2120;
			  aux_2120 =
			     CNST_TABLE_REF(((long) 3));
			  arg1662_952 =
			     MAKE_PAIR(aux_2120, BNIL);
		       }
		       arg1660_950 =
			  MAKE_PAIR(arg1661_951, arg1662_952);
		    }
		    arg1658_948 =
		       MAKE_PAIR(arg1659_949, arg1660_950);
		 }
		 list1656_946 =
		    MAKE_PAIR(arg1657_947, arg1658_948);
	      }
	      install_specialize__168_cfa_specialize(
		 CNST_TABLE_REF(((long) 11)),
		 CNST_TABLE_REF(((long) 5)), list1656_946);
	   }
	   {	/* Cfa/specialize.scm 138 */
	      obj_t list1663_953;
	      {		/* Cfa/specialize.scm 138 */
		 obj_t arg1664_954;
		 obj_t arg1665_955;
		 arg1664_954 =
		    CNST_TABLE_REF(((long) 12));
		 {	/* Cfa/specialize.scm 138 */
		    obj_t arg1666_956;
		    obj_t arg1667_957;
		    arg1666_956 =
		       CNST_TABLE_REF(((long) 1));
		    {	/* Cfa/specialize.scm 139 */
		       obj_t arg1669_958;
		       obj_t arg1670_959;
		       arg1669_958 =
			  CNST_TABLE_REF(((long) 13));
		       {	/* Cfa/specialize.scm 137 */
			  obj_t aux_2132;
			  aux_2132 =
			     CNST_TABLE_REF(((long) 3));
			  arg1670_959 =
			     MAKE_PAIR(aux_2132, BNIL);
		       }
		       arg1667_957 =
			  MAKE_PAIR(arg1669_958, arg1670_959);
		    }
		    arg1665_955 =
		       MAKE_PAIR(arg1666_956, arg1667_957);
		 }
		 list1663_953 =
		    MAKE_PAIR(arg1664_954, arg1665_955);
	      }
	      install_specialize__168_cfa_specialize(
		 CNST_TABLE_REF(((long) 14)),
		 CNST_TABLE_REF(((long) 5)), list1663_953);
	   }
	   {	/* Cfa/specialize.scm 141 */
	      obj_t list1671_960;
	      {		/* Cfa/specialize.scm 141 */
		 obj_t arg1672_961;
		 obj_t arg1673_962;
		 arg1672_961 =
		    CNST_TABLE_REF(((long) 15));
		 {	/* Cfa/specialize.scm 141 */
		    obj_t arg1674_963;
		    obj_t arg1675_964;
		    arg1674_963 =
		       CNST_TABLE_REF(((long) 1));
		    {	/* Cfa/specialize.scm 142 */
		       obj_t arg1676_965;
		       obj_t arg1677_966;
		       arg1676_965 =
			  CNST_TABLE_REF(((long) 16));
		       {	/* Cfa/specialize.scm 140 */
			  obj_t aux_2144;
			  aux_2144 =
			     CNST_TABLE_REF(((long) 3));
			  arg1677_966 =
			     MAKE_PAIR(aux_2144, BNIL);
		       }
		       arg1675_964 =
			  MAKE_PAIR(arg1676_965, arg1677_966);
		    }
		    arg1673_962 =
		       MAKE_PAIR(arg1674_963, arg1675_964);
		 }
		 list1671_960 =
		    MAKE_PAIR(arg1672_961, arg1673_962);
	      }
	      install_specialize__168_cfa_specialize(
		 CNST_TABLE_REF(((long) 17)),
		 CNST_TABLE_REF(((long) 5)), list1671_960);
	   }
	   {	/* Cfa/specialize.scm 144 */
	      obj_t list1678_967;
	      {		/* Cfa/specialize.scm 144 */
		 obj_t arg1679_968;
		 obj_t arg1680_969;
		 arg1679_968 =
		    CNST_TABLE_REF(((long) 18));
		 {	/* Cfa/specialize.scm 144 */
		    obj_t arg1681_970;
		    obj_t arg1682_971;
		    arg1681_970 =
		       CNST_TABLE_REF(((long) 1));
		    {	/* Cfa/specialize.scm 145 */
		       obj_t arg1683_972;
		       obj_t arg1684_973;
		       arg1683_972 =
			  CNST_TABLE_REF(((long) 19));
		       {	/* Cfa/specialize.scm 143 */
			  obj_t aux_2156;
			  aux_2156 =
			     CNST_TABLE_REF(((long) 3));
			  arg1684_973 =
			     MAKE_PAIR(aux_2156, BNIL);
		       }
		       arg1682_971 =
			  MAKE_PAIR(arg1683_972, arg1684_973);
		    }
		    arg1680_969 =
		       MAKE_PAIR(arg1681_970, arg1682_971);
		 }
		 list1678_967 =
		    MAKE_PAIR(arg1679_968, arg1680_969);
	      }
	      install_specialize__168_cfa_specialize(
		 CNST_TABLE_REF(((long) 20)),
		 CNST_TABLE_REF(((long) 5)), list1678_967);
	   }
	   {	/* Cfa/specialize.scm 147 */
	      obj_t list1685_974;
	      {		/* Cfa/specialize.scm 147 */
		 obj_t arg1686_975;
		 obj_t arg1687_976;
		 arg1686_975 =
		    CNST_TABLE_REF(((long) 21));
		 {	/* Cfa/specialize.scm 147 */
		    obj_t arg1688_977;
		    obj_t arg1689_978;
		    arg1688_977 =
		       CNST_TABLE_REF(((long) 1));
		    {	/* Cfa/specialize.scm 148 */
		       obj_t arg1690_979;
		       obj_t arg1691_980;
		       arg1690_979 =
			  CNST_TABLE_REF(((long) 22));
		       {	/* Cfa/specialize.scm 146 */
			  obj_t aux_2168;
			  aux_2168 =
			     CNST_TABLE_REF(((long) 3));
			  arg1691_980 =
			     MAKE_PAIR(aux_2168, BNIL);
		       }
		       arg1689_978 =
			  MAKE_PAIR(arg1690_979, arg1691_980);
		    }
		    arg1687_976 =
		       MAKE_PAIR(arg1688_977, arg1689_978);
		 }
		 list1685_974 =
		    MAKE_PAIR(arg1686_975, arg1687_976);
	      }
	      install_specialize__168_cfa_specialize(
		 CNST_TABLE_REF(((long) 23)),
		 CNST_TABLE_REF(((long) 5)), list1685_974);
	   }
	   {	/* Cfa/specialize.scm 150 */
	      obj_t list1692_981;
	      {		/* Cfa/specialize.scm 150 */
		 obj_t arg1693_982;
		 obj_t arg1694_983;
		 arg1693_982 =
		    CNST_TABLE_REF(((long) 24));
		 {	/* Cfa/specialize.scm 150 */
		    obj_t arg1695_984;
		    obj_t arg1696_985;
		    arg1695_984 =
		       CNST_TABLE_REF(((long) 1));
		    {	/* Cfa/specialize.scm 151 */
		       obj_t arg1697_986;
		       obj_t arg1698_987;
		       arg1697_986 =
			  CNST_TABLE_REF(((long) 25));
		       {	/* Cfa/specialize.scm 149 */
			  obj_t aux_2180;
			  aux_2180 =
			     CNST_TABLE_REF(((long) 3));
			  arg1698_987 =
			     MAKE_PAIR(aux_2180, BNIL);
		       }
		       arg1696_985 =
			  MAKE_PAIR(arg1697_986, arg1698_987);
		    }
		    arg1694_983 =
		       MAKE_PAIR(arg1695_984, arg1696_985);
		 }
		 list1692_981 =
		    MAKE_PAIR(arg1693_982, arg1694_983);
	      }
	      install_specialize__168_cfa_specialize(
		 CNST_TABLE_REF(((long) 26)),
		 CNST_TABLE_REF(((long) 5)), list1692_981);
	   }
	   {	/* Cfa/specialize.scm 153 */
	      obj_t list1699_988;
	      {		/* Cfa/specialize.scm 153 */
		 obj_t arg1700_989;
		 obj_t arg1701_990;
		 arg1700_989 =
		    CNST_TABLE_REF(((long) 27));
		 {	/* Cfa/specialize.scm 153 */
		    obj_t arg1702_991;
		    obj_t arg1703_992;
		    arg1702_991 =
		       CNST_TABLE_REF(((long) 1));
		    {	/* Cfa/specialize.scm 154 */
		       obj_t arg1704_993;
		       obj_t arg1705_994;
		       arg1704_993 =
			  CNST_TABLE_REF(((long) 28));
		       {	/* Cfa/specialize.scm 152 */
			  obj_t aux_2192;
			  aux_2192 =
			     CNST_TABLE_REF(((long) 3));
			  arg1705_994 =
			     MAKE_PAIR(aux_2192, BNIL);
		       }
		       arg1703_992 =
			  MAKE_PAIR(arg1704_993, arg1705_994);
		    }
		    arg1701_990 =
		       MAKE_PAIR(arg1702_991, arg1703_992);
		 }
		 list1699_988 =
		    MAKE_PAIR(arg1700_989, arg1701_990);
	      }
	      install_specialize__168_cfa_specialize(
		 CNST_TABLE_REF(((long) 29)),
		 CNST_TABLE_REF(((long) 5)), list1699_988);
	   }
	   {	/* Cfa/specialize.scm 156 */
	      obj_t list1706_995;
	      {		/* Cfa/specialize.scm 156 */
		 obj_t arg1707_996;
		 obj_t arg1708_997;
		 arg1707_996 =
		    CNST_TABLE_REF(((long) 30));
		 {	/* Cfa/specialize.scm 156 */
		    obj_t arg1709_998;
		    obj_t arg1711_999;
		    arg1709_998 =
		       CNST_TABLE_REF(((long) 1));
		    {	/* Cfa/specialize.scm 157 */
		       obj_t arg1712_1000;
		       obj_t arg1713_1001;
		       arg1712_1000 =
			  CNST_TABLE_REF(((long) 31));
		       {	/* Cfa/specialize.scm 155 */
			  obj_t aux_2204;
			  aux_2204 =
			     CNST_TABLE_REF(((long) 3));
			  arg1713_1001 =
			     MAKE_PAIR(aux_2204, BNIL);
		       }
		       arg1711_999 =
			  MAKE_PAIR(arg1712_1000, arg1713_1001);
		    }
		    arg1708_997 =
		       MAKE_PAIR(arg1709_998, arg1711_999);
		 }
		 list1706_995 =
		    MAKE_PAIR(arg1707_996, arg1708_997);
	      }
	      install_specialize__168_cfa_specialize(
		 CNST_TABLE_REF(((long) 32)),
		 CNST_TABLE_REF(((long) 5)), list1706_995);
	   }
	   {	/* Cfa/specialize.scm 159 */
	      obj_t list1714_1002;
	      {		/* Cfa/specialize.scm 159 */
		 obj_t arg1715_1003;
		 obj_t arg1716_1004;
		 arg1715_1003 =
		    CNST_TABLE_REF(((long) 33));
		 {	/* Cfa/specialize.scm 159 */
		    obj_t arg1717_1005;
		    obj_t arg1718_1006;
		    arg1717_1005 =
		       CNST_TABLE_REF(((long) 1));
		    {	/* Cfa/specialize.scm 160 */
		       obj_t arg1719_1007;
		       obj_t arg1720_1008;
		       arg1719_1007 =
			  CNST_TABLE_REF(((long) 34));
		       {	/* Cfa/specialize.scm 158 */
			  obj_t aux_2216;
			  aux_2216 =
			     CNST_TABLE_REF(((long) 3));
			  arg1720_1008 =
			     MAKE_PAIR(aux_2216, BNIL);
		       }
		       arg1718_1006 =
			  MAKE_PAIR(arg1719_1007, arg1720_1008);
		    }
		    arg1716_1004 =
		       MAKE_PAIR(arg1717_1005, arg1718_1006);
		 }
		 list1714_1002 =
		    MAKE_PAIR(arg1715_1003, arg1716_1004);
	      }
	      install_specialize__168_cfa_specialize(
		 CNST_TABLE_REF(((long) 35)),
		 CNST_TABLE_REF(((long) 5)), list1714_1002);
	   }
	   {	/* Cfa/specialize.scm 162 */
	      obj_t list1721_1009;
	      {		/* Cfa/specialize.scm 162 */
		 obj_t arg1722_1010;
		 obj_t arg1723_1011;
		 arg1722_1010 =
		    CNST_TABLE_REF(((long) 36));
		 {	/* Cfa/specialize.scm 161 */
		    obj_t aux_2226;
		    aux_2226 =
		       CNST_TABLE_REF(((long) 3));
		    arg1723_1011 =
		       MAKE_PAIR(aux_2226, BNIL);
		 }
		 list1721_1009 =
		    MAKE_PAIR(arg1722_1010, arg1723_1011);
	      }
	      install_specialize__168_cfa_specialize(
		 CNST_TABLE_REF(((long) 37)),
		 CNST_TABLE_REF(((long) 5)), list1721_1009);
	   }
	   {	/* Cfa/specialize.scm 164 */
	      obj_t list1724_1012;
	      {		/* Cfa/specialize.scm 164 */
		 obj_t arg1725_1013;
		 obj_t arg1726_1014;
		 arg1725_1013 =
		    CNST_TABLE_REF(((long) 38));
		 {	/* Cfa/specialize.scm 164 */
		    obj_t arg1727_1015;
		    obj_t arg1728_1016;
		    arg1727_1015 =
		       CNST_TABLE_REF(((long) 1));
		    {	/* Cfa/specialize.scm 165 */
		       obj_t arg1729_1017;
		       obj_t arg1730_1018;
		       arg1729_1017 =
			  CNST_TABLE_REF(((long) 39));
		       {	/* Cfa/specialize.scm 163 */
			  obj_t aux_2236;
			  aux_2236 =
			     CNST_TABLE_REF(((long) 3));
			  arg1730_1018 =
			     MAKE_PAIR(aux_2236, BNIL);
		       }
		       arg1728_1016 =
			  MAKE_PAIR(arg1729_1017, arg1730_1018);
		    }
		    arg1726_1014 =
		       MAKE_PAIR(arg1727_1015, arg1728_1016);
		 }
		 list1724_1012 =
		    MAKE_PAIR(arg1725_1013, arg1726_1014);
	      }
	      install_specialize__168_cfa_specialize(
		 CNST_TABLE_REF(((long) 40)),
		 CNST_TABLE_REF(((long) 5)), list1724_1012);
	   }
	   {	/* Cfa/specialize.scm 167 */
	      obj_t list1731_1019;
	      {		/* Cfa/specialize.scm 167 */
		 obj_t arg1732_1020;
		 obj_t arg1733_1021;
		 arg1732_1020 =
		    CNST_TABLE_REF(((long) 41));
		 {	/* Cfa/specialize.scm 166 */
		    obj_t aux_2246;
		    aux_2246 =
		       CNST_TABLE_REF(((long) 3));
		    arg1733_1021 =
		       MAKE_PAIR(aux_2246, BNIL);
		 }
		 list1731_1019 =
		    MAKE_PAIR(arg1732_1020, arg1733_1021);
	      }
	      install_specialize__168_cfa_specialize(
		 CNST_TABLE_REF(((long) 42)),
		 CNST_TABLE_REF(((long) 5)), list1731_1019);
	   }
	   {	/* Cfa/specialize.scm 169 */
	      obj_t list1734_1022;
	      {		/* Cfa/specialize.scm 169 */
		 obj_t arg1735_1023;
		 obj_t arg1736_1024;
		 arg1735_1023 =
		    CNST_TABLE_REF(((long) 43));
		 {	/* Cfa/specialize.scm 168 */
		    obj_t aux_2254;
		    aux_2254 =
		       CNST_TABLE_REF(((long) 3));
		    arg1736_1024 =
		       MAKE_PAIR(aux_2254, BNIL);
		 }
		 list1734_1022 =
		    MAKE_PAIR(arg1735_1023, arg1736_1024);
	      }
	      install_specialize__168_cfa_specialize(
		 CNST_TABLE_REF(((long) 44)),
		 CNST_TABLE_REF(((long) 5)), list1734_1022);
	   }
	   {	/* Cfa/specialize.scm 171 */
	      obj_t list1737_1025;
	      {		/* Cfa/specialize.scm 171 */
		 obj_t arg1738_1026;
		 obj_t arg1739_1027;
		 arg1738_1026 =
		    CNST_TABLE_REF(((long) 45));
		 {	/* Cfa/specialize.scm 170 */
		    obj_t aux_2262;
		    aux_2262 =
		       CNST_TABLE_REF(((long) 3));
		    arg1739_1027 =
		       MAKE_PAIR(aux_2262, BNIL);
		 }
		 list1737_1025 =
		    MAKE_PAIR(arg1738_1026, arg1739_1027);
	      }
	      install_specialize__168_cfa_specialize(
		 CNST_TABLE_REF(((long) 46)),
		 CNST_TABLE_REF(((long) 5)), list1737_1025);
	   }
	   {	/* Cfa/specialize.scm 173 */
	      obj_t list1740_1028;
	      {		/* Cfa/specialize.scm 173 */
		 obj_t arg1741_1029;
		 obj_t arg1742_1030;
		 arg1741_1029 =
		    CNST_TABLE_REF(((long) 47));
		 {	/* Cfa/specialize.scm 172 */
		    obj_t aux_2270;
		    aux_2270 =
		       CNST_TABLE_REF(((long) 3));
		    arg1742_1030 =
		       MAKE_PAIR(aux_2270, BNIL);
		 }
		 list1740_1028 =
		    MAKE_PAIR(arg1741_1029, arg1742_1030);
	      }
	      install_specialize__168_cfa_specialize(
		 CNST_TABLE_REF(((long) 48)),
		 CNST_TABLE_REF(((long) 5)), list1740_1028);
	   }
	   {	/* Cfa/specialize.scm 175 */
	      obj_t list1743_1031;
	      {		/* Cfa/specialize.scm 175 */
		 obj_t arg1744_1032;
		 obj_t arg1745_1033;
		 arg1744_1032 =
		    CNST_TABLE_REF(((long) 49));
		 {	/* Cfa/specialize.scm 174 */
		    obj_t aux_2278;
		    aux_2278 =
		       CNST_TABLE_REF(((long) 3));
		    arg1745_1033 =
		       MAKE_PAIR(aux_2278, BNIL);
		 }
		 list1743_1031 =
		    MAKE_PAIR(arg1744_1032, arg1745_1033);
	      }
	      install_specialize__168_cfa_specialize(
		 CNST_TABLE_REF(((long) 50)),
		 CNST_TABLE_REF(((long) 5)), list1743_1031);
	   }
	   {	/* Cfa/specialize.scm 177 */
	      obj_t list1746_1034;
	      {		/* Cfa/specialize.scm 177 */
		 obj_t arg1747_1035;
		 obj_t arg1748_1036;
		 arg1747_1035 =
		    CNST_TABLE_REF(((long) 51));
		 {	/* Cfa/specialize.scm 176 */
		    obj_t aux_2286;
		    aux_2286 =
		       CNST_TABLE_REF(((long) 3));
		    arg1748_1036 =
		       MAKE_PAIR(aux_2286, BNIL);
		 }
		 list1746_1034 =
		    MAKE_PAIR(arg1747_1035, arg1748_1036);
	      }
	      install_specialize__168_cfa_specialize(
		 CNST_TABLE_REF(((long) 52)),
		 CNST_TABLE_REF(((long) 5)), list1746_1034);
	   }
	   {	/* Cfa/specialize.scm 179 */
	      obj_t list1749_1037;
	      {		/* Cfa/specialize.scm 179 */
		 obj_t arg1750_1038;
		 obj_t arg1751_1039;
		 arg1750_1038 =
		    CNST_TABLE_REF(((long) 53));
		 {	/* Cfa/specialize.scm 178 */
		    obj_t aux_2294;
		    aux_2294 =
		       CNST_TABLE_REF(((long) 3));
		    arg1751_1039 =
		       MAKE_PAIR(aux_2294, BNIL);
		 }
		 list1749_1037 =
		    MAKE_PAIR(arg1750_1038, arg1751_1039);
	      }
	      install_specialize__168_cfa_specialize(
		 CNST_TABLE_REF(((long) 54)),
		 CNST_TABLE_REF(((long) 5)), list1749_1037);
	   }
	   {	/* Cfa/specialize.scm 181 */
	      obj_t list1752_1040;
	      {		/* Cfa/specialize.scm 181 */
		 obj_t arg1753_1041;
		 obj_t arg1754_1042;
		 arg1753_1041 =
		    CNST_TABLE_REF(((long) 55));
		 {	/* Cfa/specialize.scm 180 */
		    obj_t aux_2302;
		    aux_2302 =
		       CNST_TABLE_REF(((long) 3));
		    arg1754_1042 =
		       MAKE_PAIR(aux_2302, BNIL);
		 }
		 list1752_1040 =
		    MAKE_PAIR(arg1753_1041, arg1754_1042);
	      }
	      install_specialize__168_cfa_specialize(
		 CNST_TABLE_REF(((long) 56)),
		 CNST_TABLE_REF(((long) 5)), list1752_1040);
	   }
	   patch_tree__164_cfa_specialize(globals_6);
	   show_specialize_223_cfa_specialize();
	   {	/* Cfa/specialize.scm 184 */
	      bool_t aux_2311;
	      aux_2311 =
		 uninstall_specializes__251_cfa_specialize();
	      BBOOL(aux_2311);
	   }
	}
      else
	{	/* Cfa/specialize.scm 126 */
	   BUNSPEC;
	}
      return globals_6;
   }
}



/* _specialize! */
obj_t 
_specialize__238_cfa_specialize(obj_t env_1890, obj_t globals_1891)
{
   AN_OBJECT;
   {	/* Cfa/specialize.scm 125 */
      return
	 specialize__184_cfa_specialize(globals_1891);
   }
}



/* patch-tree! */
bool_t 
patch_tree__164_cfa_specialize(obj_t globals_7)
{
   AN_OBJECT;
   {	/* Cfa/specialize.scm 190 */
      {
	 obj_t l1487_1043;
	 l1487_1043 = globals_7;
       lname1488_1044:
	 if (
	    PAIRP(l1487_1043))
	   {	/* Cfa/specialize.scm 191 */
	      patch_fun__141_cfa_specialize(
		 CAR(l1487_1043));
	      {
		 obj_t l1487_2319;
		 l1487_2319 =
		    CDR(l1487_1043);
		 l1487_1043 = l1487_2319;
		 goto lname1488_1044;
	      }
	   }
	 else
	   {	/* Cfa/specialize.scm 191 */
	      return ((bool_t) 1);
	   }
      }
   }
}



/* patch-fun! */
obj_t 
patch_fun__141_cfa_specialize(obj_t variable_8)
{
   AN_OBJECT;
   {	/* Cfa/specialize.scm 196 */
      {		/* Cfa/specialize.scm 197 */
	 value_bglt fun_1048;
	 {	/* Cfa/specialize.scm 197 */
	    variable_bglt obj_1665;
	    obj_1665 =
	       (variable_bglt) (variable_8);
	    fun_1048 =
	       (((variable_bglt) CREF(obj_1665))->value);
	 }
	 {	/* Cfa/specialize.scm 198 */
	    obj_t arg1759_1049;
	    {	/* Cfa/specialize.scm 198 */
	       node_bglt aux_2323;
	       {	/* Cfa/specialize.scm 198 */
		  obj_t aux_2324;
		  {	/* Cfa/specialize.scm 198 */
		     sfun_bglt obj_1666;
		     obj_1666 =
			(sfun_bglt) (fun_1048);
		     aux_2324 =
			(((sfun_bglt) CREF(obj_1666))->body);
		  }
		  aux_2323 =
		     (node_bglt) (aux_2324);
	       }
	       arg1759_1049 =
		  patch__227_cfa_specialize(aux_2323);
	    }
	    {	/* Cfa/specialize.scm 198 */
	       sfun_bglt obj_1667;
	       obj_1667 =
		  (sfun_bglt) (fun_1048);
	       return
		  ((((sfun_bglt) CREF(obj_1667))->body) = ((obj_t) arg1759_1049), BUNSPEC);
	    }
	 }
      }
   }
}



/* patch*! */
obj_t 
patch___72_cfa_specialize(obj_t node__221_31)
{
   AN_OBJECT;
   {	/* Cfa/specialize.scm 378 */
      {
	 obj_t node__221_1051;
	 node__221_1051 = node__221_31;
       loop_1052:
	 if (
	    NULLP(node__221_1051))
	   {	/* Cfa/specialize.scm 380 */
	      return
		 CNST_TABLE_REF(((long) 57));
	   }
	 else
	   {	/* Cfa/specialize.scm 380 */
	      {		/* Cfa/specialize.scm 383 */
		 obj_t arg1762_1054;
		 {	/* Cfa/specialize.scm 383 */
		    node_bglt aux_2334;
		    {	/* Cfa/specialize.scm 383 */
		       obj_t aux_2335;
		       aux_2335 =
			  CAR(node__221_1051);
		       aux_2334 =
			  (node_bglt) (aux_2335);
		    }
		    arg1762_1054 =
		       patch__227_cfa_specialize(aux_2334);
		 }
		 SET_CAR(node__221_1051, arg1762_1054);
	      }
	      {
		 obj_t node__221_2340;
		 node__221_2340 =
		    CDR(node__221_1051);
		 node__221_1051 = node__221_2340;
		 goto loop_1052;
	      }
	   }
      }
   }
}



/* specialize-app! */
node_bglt 
specialize_app__163_cfa_specialize(app_bglt node_33)
{
   AN_OBJECT;
   {	/* Cfa/specialize.scm 401 */
      {		/* Cfa/specialize.scm 403 */
	 bool_t test_2342;
	 {	/* ./Ieee/pair-list.scm 5912 */
	    obj_t aux_2343;
	    aux_2343 =
	       (((app_bglt) CREF(node_33))->args);
	    test_2342 =
	       NULLP(aux_2343);
	 }
	 if (test_2342)
	   {	/* Cfa/specialize.scm 403 */
	      return
		 (node_bglt) (node_33);
	   }
	 else
	   {	/* Cfa/specialize.scm 407 */
	      type_bglt type_1059;
	      {		/* Cfa/specialize.scm 407 */
		 node_bglt aux_2347;
		 {	/* Cfa/specialize.scm 407 */
		    obj_t aux_2348;
		    {	/* ./Ieee/pair-list.scm 5701 */
		       obj_t aux_2349;
		       aux_2349 =
			  (((app_bglt) CREF(node_33))->args);
		       aux_2348 =
			  CAR(aux_2349);
		    }
		    aux_2347 =
		       (node_bglt) (aux_2348);
		 }
		 type_1059 =
		    typeof_coerce_typeof(aux_2347);
	      }
	      {		/* Cfa/specialize.scm 408 */
		 obj_t spec_1061;
		 {	/* Cfa/specialize.scm 409 */
		    obj_t aux_2354;
		    {	/* Cfa/specialize.scm 409 */
		       specialized_global_131_bglt obj_1680;
		       {	/* Cfa/specialize.scm 409 */
			  variable_bglt aux_2356;
			  {	/* Cfa/specialize.scm 408 */
			     var_bglt arg1777_1075;
			     arg1777_1075 =
				(((app_bglt) CREF(node_33))->fun);
			     aux_2356 =
				(((var_bglt) CREF(arg1777_1075))->variable);
			  }
			  obj_1680 =
			     (specialized_global_131_bglt) (aux_2356);
		       }
		       {
			  obj_t aux_2360;
			  {	/* Cfa/specialize.scm 33 */
			     object_bglt aux_2361;
			     aux_2361 =
				(object_bglt) (obj_1680);
			     aux_2360 =
				OBJECT_WIDENING(aux_2361);
			  }
			  aux_2354 =
			     (((specialized_global_131_bglt) CREF(aux_2360))->fix);
		       }
		    }
		    spec_1061 =
		       assq___r4_pairs_and_lists_6_3(
		       (obj_t) (type_1059), aux_2354);
		 }
		 {	/* Cfa/specialize.scm 409 */

		    if (
		       PAIRP(spec_1061))
		      {
			 obj_t args_1063;
			 {	/* Cfa/specialize.scm 411 */
			    app_bglt aux_2368;
			    {	/* ./Ieee/pair-list.scm 5707 */
			       obj_t aux_2392;
			       aux_2392 =
				  (((app_bglt) CREF(node_33))->args);
			       args_1063 =
				  CDR(aux_2392);
			    }
			  loop_1064:
			    if (
			       NULLP(args_1063))
			      {		/* Cfa/specialize.scm 413 */
				 add_specialized_type__70_cfa_specialize(type_1059);
				 {	/* Cfa/specialize.scm 415 */
				    var_bglt arg1770_1068;
				    arg1770_1068 =
				       (((app_bglt) CREF(node_33))->fun);
				    {	/* Cfa/specialize.scm 415 */
				       variable_bglt val1209_1688;
				       {	/* Cfa/specialize.scm 415 */
					  obj_t aux_2373;
					  aux_2373 =
					     CDR(spec_1061);
					  val1209_1688 =
					     (variable_bglt) (aux_2373);
				       }
				       ((((var_bglt) CREF(arg1770_1068))->variable) = ((variable_bglt) val1209_1688), BUNSPEC);
				    }
				 }
				 {	/* Cfa/specialize.scm 416 */
				    node_bglt obj_1689;
				    obj_1689 =
				       (node_bglt) (node_33);
				    ((((node_bglt) CREF(obj_1689))->type) = ((type_bglt) type_1059), BUNSPEC);
				 }
				 aux_2368 = node_33;
			      }
			    else
			      {		/* Cfa/specialize.scm 418 */
				 bool_t test1772_1070;
				 {	/* Cfa/specialize.scm 418 */
				    type_bglt arg1774_1072;
				    {	/* Cfa/specialize.scm 418 */
				       node_bglt aux_2379;
				       {	/* Cfa/specialize.scm 418 */
					  obj_t aux_2380;
					  aux_2380 =
					     CAR(args_1063);
					  aux_2379 =
					     (node_bglt) (aux_2380);
				       }
				       arg1774_1072 =
					  typeof_coerce_typeof(aux_2379);
				    }
				    {	/* ./Ieee/equiv.scm 5508 */
				       obj_t aux_2386;
				       obj_t aux_2384;
				       aux_2386 =
					  (obj_t) (type_1059);
				       aux_2384 =
					  (obj_t) (arg1774_1072);
				       test1772_1070 =
					  (aux_2384 == aux_2386);
				    }
				 }
				 if (test1772_1070)
				   {	/* Cfa/specialize.scm 418 */
				      {
					 obj_t args_2390;
					 args_2390 =
					    CDR(args_1063);
					 args_1063 = args_2390;
					 goto loop_1064;
				      }
				   }
				 else
				   {	/* Cfa/specialize.scm 418 */
				      aux_2368 = node_33;
				   }
			      }
			    return
			       (node_bglt) (aux_2368);
			 }
		      }
		    else
		      {		/* Cfa/specialize.scm 410 */
			 return
			    (node_bglt) (node_33);
		      }
		 }
	      }
	   }
      }
   }
}



/* object-init */
obj_t 
object_init_111_cfa_specialize()
{
   AN_OBJECT;
   {	/* Cfa/specialize.scm 18 */
      {		/* Cfa/specialize.scm 18 */
	 obj_t arg1781_1079;
	 obj_t arg1782_1080;
	 obj_t arg1785_1083;
	 arg1781_1079 =
	    CNST_TABLE_REF(((long) 58));
	 arg1782_1080 = global_ast_var;
	 {	/* Cfa/specialize.scm 18 */
	    obj_t v1513_1084;
	    v1513_1084 =
	       create_vector(((long) 0));
	    arg1785_1083 = v1513_1084;
	 }
	 specialized_global_131_cfa_specialize =
	    register_class__225___object(arg1781_1079, arg1782_1080, allocate_specialized_global_env_23_cfa_specialize, ((long) 7812), BUNSPEC, BFALSE, arg1785_1083);
      }
      return BUNSPEC;
   }
}



/* allocate-specialized-global */
global_bglt 
allocate_specialized_global_107_cfa_specialize()
{
   AN_OBJECT;
   {	/* Cfa/specialize.scm 32 */
      {		/* Cfa/specialize.scm 32 */
	 global_bglt new1473_1085;
	 new1473_1085 =
	    ((global_bglt) BREF(GC_MALLOC(sizeof(struct global))));
	 {	/* Cfa/specialize.scm 32 */
	    long arg1786_1086;
	    arg1786_1086 =
	       class_num_218___object(specialized_global_131_cfa_specialize);
	    {	/* Cfa/specialize.scm 32 */
	       obj_t obj_1695;
	       obj_1695 =
		  (obj_t) (new1473_1085);
	       (((obj_t) CREF(obj_1695))->header = MAKE_HEADER(arg1786_1086, 0), BUNSPEC);
	    }
	 }
	 {	/* Cfa/specialize.scm 32 */
	    object_bglt aux_2404;
	    aux_2404 =
	       (object_bglt) (new1473_1085);
	    OBJECT_WIDENING_SET(aux_2404, BFALSE);
	 }
	 return new1473_1085;
      }
   }
}



/* _allocate-specialized-global */
obj_t 
_allocate_specialized_global_95_cfa_specialize(obj_t env_1892)
{
   AN_OBJECT;
   {	/* Cfa/specialize.scm 32 */
      {		/* Cfa/specialize.scm 32 */
	 global_bglt aux_2407;
	 aux_2407 =
	    allocate_specialized_global_107_cfa_specialize();
	 return
	    (obj_t) (aux_2407);
      }
   }
}



/* method-init */
obj_t 
method_init_76_cfa_specialize()
{
   AN_OBJECT;
   {	/* Cfa/specialize.scm 18 */
      add_generic__110___object(patch__env_129_cfa_specialize, patch__default1514_env_32_cfa_specialize);
      add_inlined_method__244___object(patch__env_129_cfa_specialize, atom_ast_node, ((long) 0));
      add_inlined_method__244___object(patch__env_129_cfa_specialize, kwote_ast_node, ((long) 1));
      add_inlined_method__244___object(patch__env_129_cfa_specialize, var_ast_node, ((long) 2));
      add_inlined_method__244___object(patch__env_129_cfa_specialize, closure_ast_node, ((long) 3));
      add_inlined_method__244___object(patch__env_129_cfa_specialize, sequence_ast_node, ((long) 4));
      add_inlined_method__244___object(patch__env_129_cfa_specialize, app_ly_162_ast_node, ((long) 5));
      add_inlined_method__244___object(patch__env_129_cfa_specialize, funcall_ast_node, ((long) 6));
      add_inlined_method__244___object(patch__env_129_cfa_specialize, pragma_ast_node, ((long) 7));
      add_inlined_method__244___object(patch__env_129_cfa_specialize, cast_ast_node, ((long) 8));
      add_inlined_method__244___object(patch__env_129_cfa_specialize, setq_ast_node, ((long) 9));
      add_inlined_method__244___object(patch__env_129_cfa_specialize, conditional_ast_node, ((long) 10));
      add_inlined_method__244___object(patch__env_129_cfa_specialize, fail_ast_node, ((long) 11));
      add_inlined_method__244___object(patch__env_129_cfa_specialize, select_ast_node, ((long) 12));
      add_inlined_method__244___object(patch__env_129_cfa_specialize, let_fun_218_ast_node, ((long) 13));
      add_inlined_method__244___object(patch__env_129_cfa_specialize, let_var_6_ast_node, ((long) 14));
      add_inlined_method__244___object(patch__env_129_cfa_specialize, set_ex_it_116_ast_node, ((long) 15));
      add_inlined_method__244___object(patch__env_129_cfa_specialize, jump_ex_it_184_ast_node, ((long) 16));
      add_inlined_method__244___object(patch__env_129_cfa_specialize, make_box_202_ast_node, ((long) 17));
      add_inlined_method__244___object(patch__env_129_cfa_specialize, box_set__221_ast_node, ((long) 18));
      add_inlined_method__244___object(patch__env_129_cfa_specialize, box_ref_242_ast_node, ((long) 19));
      add_inlined_method__244___object(patch__env_129_cfa_specialize, app_ast_node, ((long) 20));
      {		/* Cfa/specialize.scm 18 */
	 obj_t object__struct_specialized_global1566_146_1897;
	 object__struct_specialized_global1566_146_1897 = proc1982_cfa_specialize;
	 add_method__1___object(object__struct_env_210___object, specialized_global_131_cfa_specialize, object__struct_specialized_global1566_146_1897);
      }
      {		/* Cfa/specialize.scm 18 */
	 obj_t struct_object__object_specialized_global1568_34_1893;
	 struct_object__object_specialized_global1568_34_1893 = proc1983_cfa_specialize;
	 return
	    add_method__1___object(struct_object__object_env_209___object, specialized_global_131_cfa_specialize, struct_object__object_specialized_global1568_34_1893);
      }
   }
}



/* struct+object->object-specialized-global1568 */
obj_t 
struct_object__object_specialized_global1568_34_cfa_specialize(obj_t env_1900, obj_t o_1901, obj_t s_1902)
{
   AN_OBJECT;
   {	/* Cfa/specialize.scm 32 */
      {
	 specialized_global_131_bglt o_1438;
	 obj_t s_1439;
	 {	/* Cfa/specialize.scm 32 */
	    specialized_global_131_bglt aux_2434;
	    o_1438 =
	       (specialized_global_131_bglt) (o_1901);
	    s_1439 = s_1902;
	    {

	       {	/* Cfa/specialize.scm 32 */
		  obj_t old1477_1442;
		  obj_t aux1478_1443;
		  {	/* Cfa/specialize.scm 32 */
		     obj_t next_method1567_156_1448;
		     next_method1567_156_1448 =
			find_super_class_method_167___object(
			(object_bglt) (o_1438), struct_object__object_env_209___object, specialized_global_131_cfa_specialize);
		     if (
			PROCEDUREP(next_method1567_156_1448))
		       {	/* Cfa/specialize.scm 32 */
			  old1477_1442 =
			     PROCEDURE_ENTRY(next_method1567_156_1448) (next_method1567_156_1448,
			     (obj_t) (o_1438), s_1439, BEOA);
		       }
		     else
		       {	/* Cfa/specialize.scm 32 */
			  PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method1567_156_1448);
			  {	/* Cfa/specialize.scm 32 */
			     object_bglt aux_2443;
			     aux_2443 =
				struct_object__object_93___object(
				(object_bglt) (o_1438), s_1439);
			     old1477_1442 =
				(obj_t) (aux_2443);
			  }
		       }
		  }
		  aux1478_1443 =
		     STRUCT_REF(s_1439, ((long) 0));
		  {	/* Cfa/specialize.scm 32 */
		     specialized_global_131_bglt new1479_1444;
		     new1479_1444 =
			((specialized_global_131_bglt) (old1477_1442));
		     {	/* Cfa/specialize.scm 32 */
			long arg1872_1445;
			arg1872_1445 =
			   class_num_218___object(specialized_global_131_cfa_specialize);
			{	/* Cfa/specialize.scm 32 */
			   obj_t obj_1756;
			   obj_1756 =
			      (obj_t) (new1479_1444);
			   (((obj_t) CREF(obj_1756))->header = MAKE_HEADER(arg1872_1445, 0), BUNSPEC);
			}
		     }
		     {	/* Cfa/specialize.scm 32 */
			specialized_global_131_bglt arg1873_1446;
			{	/* Cfa/specialize.scm 32 */
			   obj_t arg1874_1447;
			   arg1874_1447 =
			      STRUCT_REF(aux1478_1443, ((long) 0));
			   {	/* Cfa/specialize.scm 32 */
			      specialized_global_131_bglt res1967_1763;
			      {		/* Cfa/specialize.scm 32 */
				 specialized_global_131_bglt new1468_1761;
				 new1468_1761 =
				    ((specialized_global_131_bglt) BREF(GC_MALLOC(sizeof(struct specialized_global_131))));
				 ((((specialized_global_131_bglt) CREF(new1468_1761))->fix) = ((obj_t) arg1874_1447), BUNSPEC);
				 res1967_1763 = new1468_1761;
			      }
			      arg1873_1446 = res1967_1763;
			   }
			}
			{	/* Cfa/specialize.scm 32 */
			   obj_t aux_2457;
			   object_bglt aux_2455;
			   aux_2457 =
			      (obj_t) (arg1873_1446);
			   aux_2455 =
			      (object_bglt) (new1479_1444);
			   OBJECT_WIDENING_SET(aux_2455, aux_2457);
			}
		     }
		     aux_2434 = new1479_1444;
		  }
	       }
	    }
	    return
	       (obj_t) (aux_2434);
	 }
      }
   }
}



/* object->struct-specialized-global1566 */
obj_t 
object__struct_specialized_global1566_146_cfa_specialize(obj_t env_1903, obj_t obj1474_1904)
{
   AN_OBJECT;
   {	/* Cfa/specialize.scm 32 */
      {
	 specialized_global_131_bglt obj1474_1428;
	 obj1474_1428 =
	    (specialized_global_131_bglt) (obj1474_1904);
	 {

	    {	/* Cfa/specialize.scm 32 */
	       obj_t res1475_1431;
	       {	/* Cfa/specialize.scm 32 */
		  obj_t next_method1565_79_1436;
		  next_method1565_79_1436 =
		     find_super_class_method_167___object(
		     (object_bglt) (obj1474_1428), object__struct_env_210___object, specialized_global_131_cfa_specialize);
		  if (
		     PROCEDUREP(next_method1565_79_1436))
		    {	/* Cfa/specialize.scm 32 */
		       res1475_1431 =
			  PROCEDURE_ENTRY(next_method1565_79_1436) (next_method1565_79_1436,
			  (obj_t) (obj1474_1428), BEOA);
		    }
		  else
		    {	/* Cfa/specialize.scm 32 */
		       PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method1565_79_1436);
		       res1475_1431 =
			  object__struct_50___object(
			  (object_bglt) (obj1474_1428));
		    }
	       }
	       {	/* Cfa/specialize.scm 32 */
		  obj_t aux1476_1432;
		  {	/* ./Llib/struct.scm 1415 */
		     obj_t aux_2472;
		     aux_2472 =
			CNST_TABLE_REF(((long) 58));
		     aux1476_1432 =
			make_struct(aux_2472, ((long) 1), BUNSPEC);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_2475;
		     {
			obj_t aux_2476;
			{	/* Cfa/specialize.scm 33 */
			   object_bglt aux_2477;
			   aux_2477 =
			      (object_bglt) (obj1474_1428);
			   aux_2476 =
			      OBJECT_WIDENING(aux_2477);
			}
			aux_2475 =
			   (((specialized_global_131_bglt) CREF(aux_2476))->fix);
		     }
		     STRUCT_SET(aux1476_1432, ((long) 0), aux_2475);
		  }
		  STRUCT_SET(res1475_1431, ((long) 0), aux1476_1432);
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_2483;
		     aux_2483 =
			STRUCT_KEY(res1475_1431);
		     STRUCT_KEY_SET(aux1476_1432, aux_2483);
		  }
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_2486;
		     aux_2486 =
			CNST_TABLE_REF(((long) 58));
		     STRUCT_KEY_SET(res1475_1431, aux_2486);
		  }
		  return res1475_1431;
	       }
	    }
	 }
      }
   }
}



/* patch! */
obj_t 
patch__227_cfa_specialize(node_bglt node_9)
{
   AN_OBJECT;
   {	/* Cfa/specialize.scm 203 */
      {
	 obj_t method1877_1454;
	 obj_t class1882_1455;
	 {	/* Cfa/specialize.scm 203 */
	    obj_t arg1885_1452;
	    obj_t arg1886_1453;
	    {	/* Cfa/specialize.scm 203 */
	       object_bglt obj_1766;
	       obj_1766 =
		  (object_bglt) (node_9);
	       {	/* ./Llib/object.scm 2926 */
		  obj_t pre_method_105_1767;
		  pre_method_105_1767 =
		     PROCEDURE_REF(patch__env_129_cfa_specialize, ((long) 2));
		  if (
		     INTEGERP(pre_method_105_1767))
		    {	/* ./Llib/object.scm 2927 */
		       PROCEDURE_SET(patch__env_129_cfa_specialize, ((long) 2), BUNSPEC);
		       arg1885_1452 = pre_method_105_1767;
		    }
		  else
		    {	/* ./Llib/object.scm 2914 */
		       long obj_class_num_177_1772;
		       obj_class_num_177_1772 =
			  TYPE(obj_1766);
		       {	/* ./Llib/object.scm 2915 */
			  obj_t arg1176_1773;
			  arg1176_1773 =
			     PROCEDURE_REF(patch__env_129_cfa_specialize, ((long) 1));
			  {	/* ./Llib/object.scm 2738 */
			     long arg1177_1777;
			     {	/* ./Llib/object.scm 2738 */
				long arg1178_1778;
				arg1178_1778 =
				   OBJECT_TYPE;
				arg1177_1777 =
				   (obj_class_num_177_1772 - arg1178_1778);
			     }
			     arg1885_1452 =
				VECTOR_REF(arg1176_1773, arg1177_1777);
			  }
		       }
		    }
	       }
	    }
	    {	/* Cfa/specialize.scm 203 */
	       object_bglt object_1783;
	       object_1783 =
		  (object_bglt) (node_9);
	       {	/* ./Llib/object.scm 2695 */
		  long arg1179_1784;
		  {	/* ./Llib/object.scm 2695 */
		     long arg1180_1785;
		     long arg1181_1786;
		     arg1180_1785 =
			TYPE(object_1783);
		     arg1181_1786 =
			OBJECT_TYPE;
		     arg1179_1784 =
			(arg1180_1785 - arg1181_1786);
		  }
		  {	/* ./Llib/object.scm 2695 */
		     obj_t vector_1790;
		     vector_1790 = _classes__134___object;
		     arg1886_1453 =
			VECTOR_REF(vector_1790, arg1179_1784);
		  }
	       }
	    }
	    method1877_1454 = arg1885_1452;
	    class1882_1455 = arg1886_1453;
	    {

	       if (
		  INTEGERP(method1877_1454))
		 {	/* Cfa/specialize.scm 203 */
		    switch (
		       (long) CINT(method1877_1454))
		      {
		      case ((long) 0):

			 {	/* Cfa/specialize.scm 203 */
			    atom_bglt aux_2507;
			    aux_2507 =
			       (atom_bglt) (node_9);
			    return
			       (obj_t) (aux_2507);
			 }
			 break;
		      case ((long) 1):

			 {	/* Cfa/specialize.scm 203 */
			    kwote_bglt aux_2510;
			    aux_2510 =
			       (kwote_bglt) (node_9);
			    return
			       (obj_t) (aux_2510);
			 }
			 break;
		      case ((long) 2):

			 {	/* Cfa/specialize.scm 203 */
			    var_bglt aux_2513;
			    aux_2513 =
			       (var_bglt) (node_9);
			    return
			       (obj_t) (aux_2513);
			 }
			 break;
		      case ((long) 3):

			 {	/* Cfa/specialize.scm 227 */
			    obj_t arg1891_1467;
			    {	/* Cfa/specialize.scm 227 */
			       obj_t aux_2516;
			       {	/* Cfa/specialize.scm 227 */
				  closure_bglt aux_2517;
				  aux_2517 =
				     (closure_bglt) (node_9);
				  aux_2516 =
				     (obj_t) (aux_2517);
			       }
			       arg1891_1467 =
				  shape_tools_shape(aux_2516);
			    }
			    return
			       internal_error_43_tools_error(string1984_cfa_specialize, string1985_cfa_specialize, arg1891_1467);
			 }
			 break;
		      case ((long) 4):

			 {	/* Cfa/specialize.scm 233 */
			    sequence_bglt node_1468;
			    node_1468 =
			       (sequence_bglt) (node_9);
			    patch___72_cfa_specialize(
			       (((sequence_bglt) CREF(node_1468))->nodes));
			    return
			       (obj_t) (node_1468);
			 }
			 break;
		      case ((long) 5):

			 {	/* Cfa/specialize.scm 241 */
			    app_ly_162_bglt node_1471;
			    node_1471 =
			       (app_ly_162_bglt) (node_9);
			    {	/* Cfa/specialize.scm 242 */
			       obj_t arg1893_1473;
			       arg1893_1473 =
				  patch__227_cfa_specialize(
				  (((app_ly_162_bglt) CREF(node_1471))->fun));
			       {	/* Cfa/specialize.scm 242 */
				  node_bglt val1259_1795;
				  val1259_1795 =
				     (node_bglt) (arg1893_1473);
				  ((((app_ly_162_bglt) CREF(node_1471))->fun) = ((node_bglt) val1259_1795), BUNSPEC);
			       }
			    }
			    {	/* Cfa/specialize.scm 243 */
			       obj_t arg1895_1475;
			       arg1895_1475 =
				  patch__227_cfa_specialize(
				  (((app_ly_162_bglt) CREF(node_1471))->arg));
			       {	/* Cfa/specialize.scm 243 */
				  node_bglt val1260_1798;
				  val1260_1798 =
				     (node_bglt) (arg1895_1475);
				  ((((app_ly_162_bglt) CREF(node_1471))->arg) = ((node_bglt) val1260_1798), BUNSPEC);
			       }
			    }
			    return
			       (obj_t) (node_1471);
			 }
			 break;
		      case ((long) 6):

			 {	/* Cfa/specialize.scm 250 */
			    funcall_bglt node_1477;
			    node_1477 =
			       (funcall_bglt) (node_9);
			    {	/* Cfa/specialize.scm 251 */
			       obj_t arg1897_1479;
			       arg1897_1479 =
				  patch__227_cfa_specialize(
				  (((funcall_bglt) CREF(node_1477))->fun));
			       {	/* Cfa/specialize.scm 251 */
				  node_bglt val1269_1801;
				  val1269_1801 =
				     (node_bglt) (arg1897_1479);
				  ((((funcall_bglt) CREF(node_1477))->fun) = ((node_bglt) val1269_1801), BUNSPEC);
			       }
			    }
			    patch___72_cfa_specialize(
			       (((funcall_bglt) CREF(node_1477))->args));
			    return
			       (obj_t) (node_1477);
			 }
			 break;
		      case ((long) 7):

			 {	/* Cfa/specialize.scm 259 */
			    pragma_bglt node_1482;
			    node_1482 =
			       (pragma_bglt) (node_9);
			    patch___72_cfa_specialize(
			       (((pragma_bglt) CREF(node_1482))->args));
			    return
			       (obj_t) (node_1482);
			 }
			 break;
		      case ((long) 8):

			 {	/* Cfa/specialize.scm 267 */
			    cast_bglt node_1485;
			    node_1485 =
			       (cast_bglt) (node_9);
			    patch__227_cfa_specialize(
			       (((cast_bglt) CREF(node_1485))->arg));
			    return
			       (obj_t) (node_1485);
			 }
			 break;
		      case ((long) 9):

			 {	/* Cfa/specialize.scm 275 */
			    setq_bglt node_1488;
			    node_1488 =
			       (setq_bglt) (node_9);
			    {	/* Cfa/specialize.scm 276 */
			       obj_t arg1902_1490;
			       arg1902_1490 =
				  patch__227_cfa_specialize(
				  (((setq_bglt) CREF(node_1488))->value));
			       {	/* Cfa/specialize.scm 276 */
				  node_bglt val1303_1807;
				  val1303_1807 =
				     (node_bglt) (arg1902_1490);
				  ((((setq_bglt) CREF(node_1488))->value) = ((node_bglt) val1303_1807), BUNSPEC);
			       }
			    }
			    {	/* Cfa/specialize.scm 277 */
			       obj_t arg1904_1492;
			       {	/* Cfa/specialize.scm 277 */
				  node_bglt aux_2557;
				  {	/* Cfa/specialize.scm 277 */
				     var_bglt aux_2558;
				     aux_2558 =
					(((setq_bglt) CREF(node_1488))->var);
				     aux_2557 =
					(node_bglt) (aux_2558);
				  }
				  arg1904_1492 =
				     patch__227_cfa_specialize(aux_2557);
			       }
			       {	/* Cfa/specialize.scm 277 */
				  var_bglt val1302_1810;
				  val1302_1810 =
				     (var_bglt) (arg1904_1492);
				  ((((setq_bglt) CREF(node_1488))->var) = ((var_bglt) val1302_1810), BUNSPEC);
			       }
			    }
			    return
			       (obj_t) (node_1488);
			 }
			 break;
		      case ((long) 10):

			 {	/* Cfa/specialize.scm 284 */
			    conditional_bglt node_1494;
			    node_1494 =
			       (conditional_bglt) (node_9);
			    {	/* Cfa/specialize.scm 285 */
			       obj_t arg1906_1496;
			       arg1906_1496 =
				  patch__227_cfa_specialize(
				  (((conditional_bglt) CREF(node_1494))->test));
			       {	/* Cfa/specialize.scm 285 */
				  node_bglt val1314_1813;
				  val1314_1813 =
				     (node_bglt) (arg1906_1496);
				  ((((conditional_bglt) CREF(node_1494))->test) = ((node_bglt) val1314_1813), BUNSPEC);
			       }
			    }
			    {	/* Cfa/specialize.scm 286 */
			       obj_t arg1909_1498;
			       arg1909_1498 =
				  patch__227_cfa_specialize(
				  (((conditional_bglt) CREF(node_1494))->true));
			       {	/* Cfa/specialize.scm 286 */
				  node_bglt val1315_1816;
				  val1315_1816 =
				     (node_bglt) (arg1909_1498);
				  ((((conditional_bglt) CREF(node_1494))->true) = ((node_bglt) val1315_1816), BUNSPEC);
			       }
			    }
			    {	/* Cfa/specialize.scm 287 */
			       obj_t arg1912_1500;
			       arg1912_1500 =
				  patch__227_cfa_specialize(
				  (((conditional_bglt) CREF(node_1494))->false));
			       {	/* Cfa/specialize.scm 287 */
				  node_bglt val1316_1819;
				  val1316_1819 =
				     (node_bglt) (arg1912_1500);
				  ((((conditional_bglt) CREF(node_1494))->false) = ((node_bglt) val1316_1819), BUNSPEC);
			       }
			    }
			    return
			       (obj_t) (node_1494);
			 }
			 break;
		      case ((long) 11):

			 {	/* Cfa/specialize.scm 294 */
			    fail_bglt node_1502;
			    node_1502 =
			       (fail_bglt) (node_9);
			    {	/* Cfa/specialize.scm 295 */
			       obj_t arg1914_1504;
			       arg1914_1504 =
				  patch__227_cfa_specialize(
				  (((fail_bglt) CREF(node_1502))->proc));
			       {	/* Cfa/specialize.scm 295 */
				  node_bglt val1328_1822;
				  val1328_1822 =
				     (node_bglt) (arg1914_1504);
				  ((((fail_bglt) CREF(node_1502))->proc) = ((node_bglt) val1328_1822), BUNSPEC);
			       }
			    }
			    {	/* Cfa/specialize.scm 296 */
			       obj_t arg1916_1506;
			       arg1916_1506 =
				  patch__227_cfa_specialize(
				  (((fail_bglt) CREF(node_1502))->msg));
			       {	/* Cfa/specialize.scm 296 */
				  node_bglt val1329_1825;
				  val1329_1825 =
				     (node_bglt) (arg1916_1506);
				  ((((fail_bglt) CREF(node_1502))->msg) = ((node_bglt) val1329_1825), BUNSPEC);
			       }
			    }
			    {	/* Cfa/specialize.scm 297 */
			       obj_t arg1919_1508;
			       arg1919_1508 =
				  patch__227_cfa_specialize(
				  (((fail_bglt) CREF(node_1502))->obj));
			       {	/* Cfa/specialize.scm 297 */
				  node_bglt val1330_1828;
				  val1330_1828 =
				     (node_bglt) (arg1919_1508);
				  ((((fail_bglt) CREF(node_1502))->obj) = ((node_bglt) val1330_1828), BUNSPEC);
			       }
			    }
			    return
			       (obj_t) (node_1502);
			 }
			 break;
		      case ((long) 12):

			 {	/* Cfa/specialize.scm 304 */
			    select_bglt node_1510;
			    node_1510 =
			       (select_bglt) (node_9);
			    {	/* Cfa/specialize.scm 305 */
			       obj_t arg1921_1512;
			       arg1921_1512 =
				  patch__227_cfa_specialize(
				  (((select_bglt) CREF(node_1510))->test));
			       {	/* Cfa/specialize.scm 305 */
				  node_bglt val1342_1831;
				  val1342_1831 =
				     (node_bglt) (arg1921_1512);
				  ((((select_bglt) CREF(node_1510))->test) = ((node_bglt) val1342_1831), BUNSPEC);
			       }
			    }
			    {
			       obj_t l1498_1514;
			       l1498_1514 =
				  (((select_bglt) CREF(node_1510))->clauses);
			     lname1499_1515:
			       if (
				  PAIRP(l1498_1514))
				 {	/* Cfa/specialize.scm 306 */
				    {	/* Cfa/specialize.scm 307 */
				       obj_t clause_1518;
				       clause_1518 =
					  CAR(l1498_1514);
				       {	/* Cfa/specialize.scm 307 */
					  obj_t arg1925_1519;
					  {	/* Cfa/specialize.scm 307 */
					     node_bglt aux_2601;
					     {	/* Cfa/specialize.scm 307 */
						obj_t aux_2602;
						aux_2602 =
						   CDR(clause_1518);
						aux_2601 =
						   (node_bglt) (aux_2602);
					     }
					     arg1925_1519 =
						patch__227_cfa_specialize(aux_2601);
					  }
					  SET_CDR(clause_1518, arg1925_1519);
				       }
				    }
				    {
				       obj_t l1498_2607;
				       l1498_2607 =
					  CDR(l1498_1514);
				       l1498_1514 = l1498_2607;
				       goto lname1499_1515;
				    }
				 }
			       else
				 {	/* Cfa/specialize.scm 306 */
				    ((bool_t) 1);
				 }
			    }
			    return
			       (obj_t) (node_1510);
			 }
			 break;
		      case ((long) 13):

			 {	/* Cfa/specialize.scm 315 */
			    let_fun_218_bglt node_1522;
			    node_1522 =
			       (let_fun_218_bglt) (node_9);
			    {
			       obj_t l1501_1524;
			       l1501_1524 =
				  (((let_fun_218_bglt) CREF(node_1522))->locals);
			     lname1502_1525:
			       if (
				  PAIRP(l1501_1524))
				 {	/* Cfa/specialize.scm 316 */
				    patch_fun__141_cfa_specialize(
				       CAR(l1501_1524));
				    {
				       obj_t l1501_2616;
				       l1501_2616 =
					  CDR(l1501_1524);
				       l1501_1524 = l1501_2616;
				       goto lname1502_1525;
				    }
				 }
			       else
				 {	/* Cfa/specialize.scm 316 */
				    ((bool_t) 1);
				 }
			    }
			    {	/* Cfa/specialize.scm 317 */
			       obj_t arg1932_1530;
			       arg1932_1530 =
				  patch__227_cfa_specialize(
				  (((let_fun_218_bglt) CREF(node_1522))->body));
			       {	/* Cfa/specialize.scm 317 */
				  node_bglt val1357_1845;
				  val1357_1845 =
				     (node_bglt) (arg1932_1530);
				  ((((let_fun_218_bglt) CREF(node_1522))->body) = ((node_bglt) val1357_1845), BUNSPEC);
			       }
			    }
			    return
			       (obj_t) (node_1522);
			 }
			 break;
		      case ((long) 14):

			 {	/* Cfa/specialize.scm 324 */
			    let_var_6_bglt node_1532;
			    node_1532 =
			       (let_var_6_bglt) (node_9);
			    {
			       obj_t l1504_1534;
			       l1504_1534 =
				  (((let_var_6_bglt) CREF(node_1532))->bindings);
			     lname1505_1535:
			       if (
				  PAIRP(l1504_1534))
				 {	/* Cfa/specialize.scm 325 */
				    {	/* Cfa/specialize.scm 326 */
				       obj_t binding_1538;
				       binding_1538 =
					  CAR(l1504_1534);
				       {	/* Cfa/specialize.scm 327 */
					  obj_t arg1936_1540;
					  {	/* Cfa/specialize.scm 327 */
					     node_bglt aux_2628;
					     {	/* Cfa/specialize.scm 327 */
						obj_t aux_2629;
						aux_2629 =
						   CDR(binding_1538);
						aux_2628 =
						   (node_bglt) (aux_2629);
					     }
					     arg1936_1540 =
						patch__227_cfa_specialize(aux_2628);
					  }
					  SET_CDR(binding_1538, arg1936_1540);
				       }
				    }
				    {
				       obj_t l1504_2634;
				       l1504_2634 =
					  CDR(l1504_1534);
				       l1504_1534 = l1504_2634;
				       goto lname1505_1535;
				    }
				 }
			       else
				 {	/* Cfa/specialize.scm 325 */
				    ((bool_t) 1);
				 }
			    }
			    {	/* Cfa/specialize.scm 329 */
			       obj_t arg1938_1542;
			       arg1938_1542 =
				  patch__227_cfa_specialize(
				  (((let_var_6_bglt) CREF(node_1532))->body));
			       {	/* Cfa/specialize.scm 329 */
				  node_bglt val1371_1855;
				  val1371_1855 =
				     (node_bglt) (arg1938_1542);
				  ((((let_var_6_bglt) CREF(node_1532))->body) = ((node_bglt) val1371_1855), BUNSPEC);
			       }
			    }
			    return
			       (obj_t) (node_1532);
			 }
			 break;
		      case ((long) 15):

			 {	/* Cfa/specialize.scm 336 */
			    set_ex_it_116_bglt node_1544;
			    node_1544 =
			       (set_ex_it_116_bglt) (node_9);
			    {	/* Cfa/specialize.scm 337 */
			       obj_t arg1940_1546;
			       arg1940_1546 =
				  patch__227_cfa_specialize(
				  (((set_ex_it_116_bglt) CREF(node_1544))->body));
			       {	/* Cfa/specialize.scm 337 */
				  node_bglt val1385_1858;
				  val1385_1858 =
				     (node_bglt) (arg1940_1546);
				  ((((set_ex_it_116_bglt) CREF(node_1544))->body) = ((node_bglt) val1385_1858), BUNSPEC);
			       }
			    }
			    {	/* Cfa/specialize.scm 338 */
			       node_bglt aux_2647;
			       {	/* Cfa/specialize.scm 338 */
				  var_bglt aux_2648;
				  aux_2648 =
				     (((set_ex_it_116_bglt) CREF(node_1544))->var);
				  aux_2647 =
				     (node_bglt) (aux_2648);
			       }
			       patch__227_cfa_specialize(aux_2647);
			    }
			    return
			       (obj_t) (node_1544);
			 }
			 break;
		      case ((long) 16):

			 {	/* Cfa/specialize.scm 345 */
			    jump_ex_it_184_bglt node_1549;
			    node_1549 =
			       (jump_ex_it_184_bglt) (node_9);
			    {	/* Cfa/specialize.scm 346 */
			       obj_t arg1943_1551;
			       arg1943_1551 =
				  patch__227_cfa_specialize(
				  (((jump_ex_it_184_bglt) CREF(node_1549))->exit));
			       {	/* Cfa/specialize.scm 346 */
				  node_bglt val1394_1862;
				  val1394_1862 =
				     (node_bglt) (arg1943_1551);
				  ((((jump_ex_it_184_bglt) CREF(node_1549))->exit) = ((node_bglt) val1394_1862), BUNSPEC);
			       }
			    }
			    {	/* Cfa/specialize.scm 347 */
			       obj_t arg1945_1553;
			       arg1945_1553 =
				  patch__227_cfa_specialize(
				  (((jump_ex_it_184_bglt) CREF(node_1549))->value));
			       {	/* Cfa/specialize.scm 347 */
				  node_bglt val1395_1865;
				  val1395_1865 =
				     (node_bglt) (arg1945_1553);
				  ((((jump_ex_it_184_bglt) CREF(node_1549))->value) = ((node_bglt) val1395_1865), BUNSPEC);
			       }
			    }
			    return
			       (obj_t) (node_1549);
			 }
			 break;
		      case ((long) 17):

			 {	/* Cfa/specialize.scm 354 */
			    make_box_202_bglt node_1555;
			    node_1555 =
			       (make_box_202_bglt) (node_9);
			    {	/* Cfa/specialize.scm 355 */
			       obj_t arg1948_1557;
			       arg1948_1557 =
				  patch__227_cfa_specialize(
				  (((make_box_202_bglt) CREF(node_1555))->value));
			       {	/* Cfa/specialize.scm 355 */
				  node_bglt val1406_1868;
				  val1406_1868 =
				     (node_bglt) (arg1948_1557);
				  ((((make_box_202_bglt) CREF(node_1555))->value) = ((node_bglt) val1406_1868), BUNSPEC);
			       }
			    }
			    return
			       (obj_t) (node_1555);
			 }
			 break;
		      case ((long) 18):

			 {	/* Cfa/specialize.scm 362 */
			    box_set__221_bglt node_1559;
			    node_1559 =
			       (box_set__221_bglt) (node_9);
			    {	/* Cfa/specialize.scm 363 */
			       obj_t arg1950_1561;
			       {	/* Cfa/specialize.scm 363 */
				  node_bglt aux_2670;
				  {	/* Cfa/specialize.scm 363 */
				     var_bglt aux_2671;
				     aux_2671 =
					(((box_set__221_bglt) CREF(node_1559))->var);
				     aux_2670 =
					(node_bglt) (aux_2671);
				  }
				  arg1950_1561 =
				     patch__227_cfa_specialize(aux_2670);
			       }
			       {	/* Cfa/specialize.scm 363 */
				  var_bglt val1428_1871;
				  val1428_1871 =
				     (var_bglt) (arg1950_1561);
				  ((((box_set__221_bglt) CREF(node_1559))->var) = ((var_bglt) val1428_1871), BUNSPEC);
			       }
			    }
			    {	/* Cfa/specialize.scm 364 */
			       obj_t arg1952_1563;
			       arg1952_1563 =
				  patch__227_cfa_specialize(
				  (((box_set__221_bglt) CREF(node_1559))->value));
			       {	/* Cfa/specialize.scm 364 */
				  node_bglt val1429_1874;
				  val1429_1874 =
				     (node_bglt) (arg1952_1563);
				  ((((box_set__221_bglt) CREF(node_1559))->value) = ((node_bglt) val1429_1874), BUNSPEC);
			       }
			    }
			    return
			       (obj_t) (node_1559);
			 }
			 break;
		      case ((long) 19):

			 {	/* Cfa/specialize.scm 371 */
			    box_ref_242_bglt node_1565;
			    node_1565 =
			       (box_ref_242_bglt) (node_9);
			    {	/* Cfa/specialize.scm 372 */
			       obj_t arg1954_1567;
			       {	/* Cfa/specialize.scm 372 */
				  node_bglt aux_2683;
				  {	/* Cfa/specialize.scm 372 */
				     var_bglt aux_2684;
				     aux_2684 =
					(((box_ref_242_bglt) CREF(node_1565))->var);
				     aux_2683 =
					(node_bglt) (aux_2684);
				  }
				  arg1954_1567 =
				     patch__227_cfa_specialize(aux_2683);
			       }
			       {	/* Cfa/specialize.scm 372 */
				  var_bglt val1418_1877;
				  val1418_1877 =
				     (var_bglt) (arg1954_1567);
				  ((((box_ref_242_bglt) CREF(node_1565))->var) = ((var_bglt) val1418_1877), BUNSPEC);
			       }
			    }
			    return
			       (obj_t) (node_1565);
			 }
			 break;
		      case ((long) 20):

			 {	/* Cfa/specialize.scm 390 */
			    app_bglt node_1569;
			    node_1569 =
			       (app_bglt) (node_9);
			    patch___72_cfa_specialize(
			       (((app_bglt) CREF(node_1569))->args));
			    {	/* Cfa/specialize.scm 392 */
			       obj_t arg1957_1572;
			       {	/* Cfa/specialize.scm 392 */
				  node_bglt aux_2694;
				  {	/* Cfa/specialize.scm 392 */
				     var_bglt aux_2695;
				     aux_2695 =
					(((app_bglt) CREF(node_1569))->fun);
				     aux_2694 =
					(node_bglt) (aux_2695);
				  }
				  arg1957_1572 =
				     patch__227_cfa_specialize(aux_2694);
			       }
			       {	/* Cfa/specialize.scm 392 */
				  var_bglt val1245_1881;
				  val1245_1881 =
				     (var_bglt) (arg1957_1572);
				  ((((app_bglt) CREF(node_1569))->fun) = ((var_bglt) val1245_1881), BUNSPEC);
			       }
			    }
			    {	/* Cfa/specialize.scm 394 */
			       bool_t test_2701;
			       {	/* Cfa/specialize.scm 32 */
				  obj_t aux_2702;
				  {	/* Cfa/specialize.scm 394 */
				     variable_bglt aux_2703;
				     {	/* Cfa/specialize.scm 393 */
					var_bglt arg1960_1576;
					arg1960_1576 =
					   (((app_bglt) CREF(node_1569))->fun);
					aux_2703 =
					   (((var_bglt) CREF(arg1960_1576))->variable);
				     }
				     aux_2702 =
					(obj_t) (aux_2703);
				  }
				  test_2701 =
				     is_a__118___object(aux_2702, specialized_global_131_cfa_specialize);
			       }
			       if (test_2701)
				 {	/* Cfa/specialize.scm 395 */
				    node_bglt aux_2708;
				    aux_2708 =
				       specialize_app__163_cfa_specialize(node_1569);
				    return
				       (obj_t) (aux_2708);
				 }
			       else
				 {	/* Cfa/specialize.scm 394 */
				    return
				       (obj_t) (node_1569);
				 }
			    }
			 }
			 break;
		      default:
		       case_else1883_1458:
			 if (
			    PROCEDUREP(method1877_1454))
			   {	/* Cfa/specialize.scm 203 */
			      return
				 PROCEDURE_ENTRY(method1877_1454) (method1877_1454,
				 (obj_t) (node_9), BEOA);
			   }
			 else
			   {	/* Cfa/specialize.scm 203 */
			      obj_t fun1876_1450;
			      fun1876_1450 =
				 PROCEDURE_REF(patch__env_129_cfa_specialize, ((long) 0));
			      return
				 PROCEDURE_ENTRY(fun1876_1450) (fun1876_1450,
				 (obj_t) (node_9), BEOA);
			   }
		      }
		 }
	       else
		 {	/* Cfa/specialize.scm 203 */
		    goto case_else1883_1458;
		 }
	    }
	 }
      }
   }
}



/* _patch! */
obj_t 
_patch__77_cfa_specialize(obj_t env_1905, obj_t node_1906)
{
   AN_OBJECT;
   {	/* Cfa/specialize.scm 203 */
      return
	 patch__227_cfa_specialize(
	 (node_bglt) (node_1906));
   }
}



/* patch!-default1514 */
obj_t 
patch__default1514_65_cfa_specialize(node_bglt node_10)
{
   AN_OBJECT;
   {	/* Cfa/specialize.scm 18 */
      FAILURE(
	 CNST_TABLE_REF(((long) 59)), string1986_cfa_specialize,
	 (obj_t) (node_10));
   }
}



/* _patch!-default1514 */
obj_t 
_patch__default1514_14_cfa_specialize(obj_t env_1907, obj_t node_1908)
{
   AN_OBJECT;
   {	/* Cfa/specialize.scm 18 */
      return
	 patch__default1514_65_cfa_specialize(
	 (node_bglt) (node_1908));
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_cfa_specialize()
{
   AN_OBJECT;
   {	/* Cfa/specialize.scm 18 */
      module_initialization_70_tools_trace(((long) 0), "CFA_SPECIALIZE");
      module_initialization_70_engine_param(((long) 0), "CFA_SPECIALIZE");
      module_initialization_70_type_type(((long) 0), "CFA_SPECIALIZE");
      module_initialization_70_type_cache(((long) 0), "CFA_SPECIALIZE");
      module_initialization_70_tools_shape(((long) 0), "CFA_SPECIALIZE");
      module_initialization_70_tools_speek(((long) 0), "CFA_SPECIALIZE");
      module_initialization_70_tools_error(((long) 0), "CFA_SPECIALIZE");
      module_initialization_70_coerce_typeof(((long) 0), "CFA_SPECIALIZE");
      module_initialization_70_ast_var(((long) 0), "CFA_SPECIALIZE");
      module_initialization_70_ast_node(((long) 0), "CFA_SPECIALIZE");
      module_initialization_70_ast_env(((long) 0), "CFA_SPECIALIZE");
      module_initialization_70_inline_inline(((long) 0), "CFA_SPECIALIZE");
      return
	 module_initialization_70_inline_walk(((long) 0), "CFA_SPECIALIZE");
   }
}
