/*===========================================================================*/
/*   (Cfa/stack.scm)                                                         */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;

typedef struct approx
  {
     header_t header;
     obj_t widening;
     struct type *type;
     bool_t type_locked__184;
     obj_t allocs;
     bool_t top__138;
     long lost_stamp_114;
  }
      *approx_bglt;

typedef struct cfun_cinfo_200
  {
     struct approx *approx;
  }
              *cfun_cinfo_200_bglt;

typedef struct extern_sfun_cinfo_6
  {
     struct approx *approx;
  }
                   *extern_sfun_cinfo_6_bglt;

typedef struct intern_sfun_cinfo_192
  {
     struct approx *approx;
     long stamp;
  }
                     *intern_sfun_cinfo_192_bglt;

typedef struct scnst_cinfo_0
  {
     struct approx *approx;
  }
             *scnst_cinfo_0_bglt;

typedef struct pre_clo_env_191
  {
     char dummy;
  }
               *pre_clo_env_191_bglt;

typedef struct svar_cinfo_166
  {
     struct approx *approx;
     bool_t clo_env__87;
  }
              *svar_cinfo_166_bglt;

typedef struct cvar_cinfo_53
  {
     struct approx *approx;
  }
             *cvar_cinfo_53_bglt;

typedef struct sexit_cinfo_49
  {
     struct approx *approx;
  }
              *sexit_cinfo_49_bglt;

typedef struct reshaped_local_224
  {
     obj_t binding_value_3;
  }
                  *reshaped_local_224_bglt;

typedef struct reshaped_global_160
  {
     char dummy;
  }
                   *reshaped_global_160_bglt;

typedef struct atom_cinfo_155
  {
     struct approx *approx;
  }
              *atom_cinfo_155_bglt;

typedef struct kwote_node_102
  {
     struct node *node;
  }
              *kwote_node_102_bglt;

typedef struct kwote_cinfo_48
  {
     struct approx *approx;
  }
              *kwote_cinfo_48_bglt;

typedef struct app_ly_cinfo_234
  {
     struct approx *approx;
  }
                *app_ly_cinfo_234_bglt;

typedef struct funcall_cinfo_75
  {
     struct approx *approx;
     struct approx *va_approx_63;
     bool_t arity_error_noticed__118;
     bool_t type_error_noticed__36;
  }
                *funcall_cinfo_75_bglt;

typedef struct pragma_cinfo_220
  {
     struct approx *approx;
  }
                *pragma_cinfo_220_bglt;

typedef struct setq_cinfo_191
  {
     struct approx *approx;
  }
              *setq_cinfo_191_bglt;

typedef struct conditional_cinfo_212
  {
     struct approx *approx;
  }
                     *conditional_cinfo_212_bglt;

typedef struct fail_cinfo_75
  {
     struct approx *approx;
  }
             *fail_cinfo_75_bglt;

typedef struct select_cinfo_150
  {
     struct approx *approx;
  }
                *select_cinfo_150_bglt;

typedef struct set_ex_it_cinfo_168
  {
     struct approx *approx;
  }
                   *set_ex_it_cinfo_168_bglt;

typedef struct jump_ex_it_cinfo_139
  {
     struct approx *approx;
  }
                    *jump_ex_it_cinfo_139_bglt;

typedef struct pre_make_box_186
  {
     char dummy;
  }
                *pre_make_box_186_bglt;

typedef struct make_box_cinfo_127
  {
     struct approx *approx;
  }
                  *make_box_cinfo_127_bglt;

typedef struct make_box_o_cinfo_96
  {
     struct approx *approx;
     struct approx *value_approx_19;
  }
                   *make_box_o_cinfo_96_bglt;

typedef struct box_set__cinfo_94
  {
     struct approx *approx;
  }
                 *box_set__cinfo_94_bglt;

typedef struct box_ref_cinfo_214
  {
     struct approx *approx;
  }
                 *box_ref_cinfo_214_bglt;

typedef struct box_set__o_cinfo_6
  {
     struct approx *approx;
  }
                  *box_set__o_cinfo_6_bglt;

typedef struct box_ref_o_cinfo_98
  {
     struct approx *approx;
  }
                  *box_ref_o_cinfo_98_bglt;

typedef struct pre_make_procedure_app_60
  {
     struct variable *owner;
  }
                         *pre_make_procedure_app_60_bglt;

typedef struct pre_procedure_ref_app_85
  {
     char dummy;
  }
                        *pre_procedure_ref_app_85_bglt;

typedef struct pre_procedure_set__app_208
  {
     char dummy;
  }
                          *pre_procedure_set__app_208_bglt;

typedef struct make_procedure_app_48
  {
     struct approx *approx;
     long values_approx_len_106;
     struct approx **values_approx_79;
     long lost_stamp_114;
     bool_t x_t__142;
     bool_t x;
     bool_t t;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
  }
                     *make_procedure_app_48_bglt;

typedef struct procedure_ref_app_49
  {
     struct approx *approx;
  }
                    *procedure_ref_app_49_bglt;

typedef struct procedure_set__app_32
  {
     struct approx *approx;
  }
                     *procedure_set__app_32_bglt;

typedef struct pre_make_vector_app_251
  {
     struct variable *owner;
  }
                       *pre_make_vector_app_251_bglt;

typedef struct pre_create_vector_app_162
  {
     struct variable *owner;
  }
                         *pre_create_vector_app_162_bglt;

typedef struct pre_vector_ref_app_208
  {
     char dummy;
  }
                      *pre_vector_ref_app_208_bglt;

typedef struct pre_vector_set__app_211
  {
     char dummy;
  }
                       *pre_vector_set__app_211_bglt;

typedef struct make_vector_app_205
  {
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
     bool_t seen__39;
  }
                   *make_vector_app_205_bglt;

typedef struct create_vector_app_150
  {
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
     bool_t seen__39;
  }
                     *create_vector_app_150_bglt;

typedef struct vector_ref_app_195
  {
     struct approx *approx;
  }
                  *vector_ref_app_195_bglt;

typedef struct vector_set__app_21
  {
     struct approx *approx;
  }
                  *vector_set__app_21_bglt;

typedef struct pre_make_struct_app_218
  {
     struct variable *owner;
  }
                       *pre_make_struct_app_218_bglt;

typedef struct pre_struct_ref_app_207
  {
     char dummy;
  }
                      *pre_struct_ref_app_207_bglt;

typedef struct pre_struct_set__app_116
  {
     char dummy;
  }
                       *pre_struct_set__app_116_bglt;

typedef struct make_struct_app_214
  {
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
  }
                   *make_struct_app_214_bglt;

typedef struct struct_ref_app_73
  {
     struct approx *approx;
  }
                 *struct_ref_app_73_bglt;

typedef struct struct_set__app_162
  {
     struct approx *approx;
  }
                   *struct_set__app_162_bglt;

typedef struct isfun
  {
     struct node *original_body_40;
     obj_t recursive_calls_44;
  }
     *isfun_bglt;


static obj_t method_init_76_cfa_stack();
extern obj_t make_box_202_ast_node;
extern obj_t funcall_ast_node;
extern long add_inlined_method__244___object(obj_t, obj_t, long);
extern obj_t fail_ast_node;
extern obj_t box_ref_242_ast_node;
extern obj_t sequence_ast_node;
extern obj_t let_var_6_ast_node;
extern obj_t var_ast_node;
extern obj_t closure_ast_node;
extern obj_t global_ast_var;
static bool_t verb_stat_110_cfa_stack();
extern obj_t pragma_ast_node;
static obj_t _statistics__64_cfa_stack = BUNSPEC;
extern obj_t set_ex_it_116_ast_node;
extern bool_t stack_optimization__133_cfa_stack();
extern obj_t verbose_tools_speek(obj_t, obj_t);
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t module_initialization_70_cfa_stack(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_tools_speek(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_cfa_info(long, char *);
extern obj_t module_initialization_70_cfa_info2(long, char *);
extern obj_t module_initialization_70_cfa_iterate(long, char *);
extern obj_t module_initialization_70_cfa_loose(long, char *);
extern obj_t module_initialization_70_inline_inline(long, char *);
extern obj_t module_initialization_70_inline_walk(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_strings_6_7(long, char *);
static node_bglt stack__default2081_166_cfa_stack(node_bglt);
static obj_t _stack___237_cfa_stack(obj_t, obj_t);
extern long class_num_218___object(obj_t);
extern obj_t cfa_iterate__222_cfa_iterate(obj_t);
extern obj_t let_fun_218_ast_node;
static obj_t imported_modules_init_94_cfa_stack();
extern obj_t string_downcase_77___r4_strings_6_7(obj_t);
extern obj_t stack___129_cfa_stack(obj_t);
extern obj_t app_ly_162_ast_node;
extern obj_t heap__stack__166_cfa_stack(obj_t, obj_t);
extern obj_t add_generic__110___object(obj_t, obj_t);
static obj_t _node_heap__stack__85_cfa_stack(obj_t, obj_t, obj_t);
static obj_t stack_stat_fail_33_cfa_stack(obj_t);
extern obj_t app_ast_node;
static obj_t library_modules_init_112_cfa_stack();
extern node_bglt inline_node_218_inline_inline(node_bglt, long, obj_t);
extern obj_t _optim_stack___57_engine_param;
extern node_bglt node_heap__stack__239_cfa_stack(app_bglt, bool_t);
extern obj_t atom_ast_node;
extern obj_t cast_ast_node;
extern obj_t assq___r4_pairs_and_lists_6_3(obj_t, obj_t);
static obj_t toplevel_init_63_cfa_stack();
extern obj_t _inlining___224_engine_param;
extern obj_t jump_ex_it_184_ast_node;
extern obj_t open_input_string(obj_t);
extern obj_t kwote_ast_node;
extern obj_t set_looser__198_cfa_loose(obj_t);
extern obj_t setq_ast_node;
extern obj_t box_set__221_ast_node;
static obj_t stack_stat_succeed_138_cfa_stack(obj_t);
static obj_t _heap__stack__192_cfa_stack(obj_t, obj_t, obj_t);
extern node_bglt stack__132_cfa_stack(node_bglt);
extern obj_t _classes__134___object;
static obj_t _stack__default2081_40_cfa_stack(obj_t, obj_t);
extern obj_t select_ast_node;
extern obj_t read___reader(obj_t);
extern obj_t inline_setup__219_inline_walk(obj_t);
static obj_t _stack__205_cfa_stack(obj_t, obj_t);
static obj_t require_initialization_114_cfa_stack = BUNSPEC;
extern obj_t conditional_ast_node;
static obj_t _stack_optimization__209_cfa_stack(obj_t);
static obj_t cnst_init_137_cfa_stack();
static obj_t __cnst[4];

DEFINE_STATIC_PROCEDURE(stack__default2081_env_242_cfa_stack, _stack__default2081_40_cfa_stack2516, _stack__default2081_40_cfa_stack, 0L, 1);
DEFINE_EXPORT_PROCEDURE(node_heap__stack__env_251_cfa_stack, _node_heap__stack__85_cfa_stack2517, _node_heap__stack__85_cfa_stack, 0L, 2);
DEFINE_EXPORT_PROCEDURE(stack_optimization__env_248_cfa_stack, _stack_optimization__209_cfa_stack2518, _stack_optimization__209_cfa_stack, 0L, 0);
DEFINE_EXPORT_PROCEDURE(heap__stack__env_242_cfa_stack, _heap__stack__192_cfa_stack2519, _heap__stack__192_cfa_stack, 0L, 2);
DEFINE_STRING(string2511_cfa_stack, string2511_cfa_stack2520, "STACK!-DEFAULT2081 DONE ALL STACK ", 34);
DEFINE_STRING(string2509_cfa_stack, string2509_cfa_stack2521, "       ", 7);
DEFINE_STRING(string2510_cfa_stack, string2510_cfa_stack2522, "No method for this object", 25);
DEFINE_STRING(string2508_cfa_stack, string2508_cfa_stack2523, ": ", 2);
DEFINE_STRING(string2507_cfa_stack, string2507_cfa_stack2524, " (of ", 5);
DEFINE_STRING(string2506_cfa_stack, string2506_cfa_stack2525, "   . Heap -> Stack", 18);
DEFINE_EXPORT_PROCEDURE(stack___env_10_cfa_stack, _stack___237_cfa_stack2526, _stack___237_cfa_stack, 0L, 1);
DEFINE_EXPORT_GENERIC(stack__env_104_cfa_stack, _stack__205_cfa_stack2527, _stack__205_cfa_stack, 0L, 1);



/* module-initialization */
obj_t 
module_initialization_70_cfa_stack(long checksum_3739, char *from_3740)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_cfa_stack))
	{
	   require_initialization_114_cfa_stack =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_cfa_stack();
	   cnst_init_137_cfa_stack();
	   imported_modules_init_94_cfa_stack();
	   method_init_76_cfa_stack();
	   toplevel_init_63_cfa_stack();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_cfa_stack()
{
   AN_OBJECT;
   {	/* Cfa/stack.scm 14 */
      module_initialization_70___object(((long) 0), "CFA_STACK");
      module_initialization_70___r4_strings_6_7(((long) 0), "CFA_STACK");
      module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "CFA_STACK");
      module_initialization_70___reader(((long) 0), "CFA_STACK");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_cfa_stack()
{
   AN_OBJECT;
   {	/* Cfa/stack.scm 14 */
      {		/* Cfa/stack.scm 14 */
	 obj_t cnst_port_138_3732;
	 cnst_port_138_3732 =
	    open_input_string(string2511_cfa_stack);
	 {
	    long i_3733;
	    i_3733 = ((long) 3);
	  loop_3734:
	    {	/* Cfa/stack.scm 14 */
	       bool_t test2512_3735;
	       test2512_3735 =
		  (i_3733 == ((long) -1));
	       if (test2512_3735)
		 {	/* Cfa/stack.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Cfa/stack.scm 14 */
		    {	/* Cfa/stack.scm 14 */
		       obj_t arg2513_3736;
		       {	/* Cfa/stack.scm 14 */
			  obj_t list2514_3737;
			  list2514_3737 =
			     MAKE_PAIR(cnst_port_138_3732, BNIL);
			  arg2513_3736 =
			     read___reader(list2514_3737);
		       }
		       CNST_TABLE_SET(i_3733, arg2513_3736);
		    }
		    {	/* Cfa/stack.scm 14 */
		       int aux_3738;
		       {	/* Cfa/stack.scm 14 */
			  long aux_3759;
			  aux_3759 =
			     (i_3733 - ((long) 1));
			  aux_3738 =
			     (int) (aux_3759);
		       }
		       {
			  long i_3762;
			  i_3762 =
			     (long) (aux_3738);
			  i_3733 = i_3762;
			  goto loop_3734;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_cfa_stack()
{
   AN_OBJECT;
   {	/* Cfa/stack.scm 14 */
      _statistics__64_cfa_stack = BNIL;
      return BUNSPEC;
   }
}



/* stack-optimization? */
bool_t 
stack_optimization__133_cfa_stack()
{
   AN_OBJECT;
   {	/* Cfa/stack.scm 37 */
      {		/* Cfa/stack.scm 38 */
	 obj_t _andtest_2050_2183;
	 _andtest_2050_2183 = _optim_stack___57_engine_param;
	 if (
	    CBOOL(_andtest_2050_2183))
	   {	/* Cfa/stack.scm 38 */
	      return
		 CBOOL(_inlining___224_engine_param);
	   }
	 else
	   {	/* Cfa/stack.scm 38 */
	      return ((bool_t) 0);
	   }
      }
   }
}



/* _stack-optimization? */
obj_t 
_stack_optimization__209_cfa_stack(obj_t env_3719)
{
   AN_OBJECT;
   {	/* Cfa/stack.scm 37 */
      {		/* Cfa/stack.scm 37 */
	 bool_t aux_3767;
	 aux_3767 =
	    stack_optimization__133_cfa_stack();
	 return
	    BBOOL(aux_3767);
      }
   }
}



/* heap->stack! */
obj_t 
heap__stack__166_cfa_stack(obj_t roots_1, obj_t globals_2)
{
   AN_OBJECT;
   {	/* Cfa/stack.scm 43 */
      if (
	 stack_optimization__133_cfa_stack())
	{	/* Cfa/stack.scm 44 */
	   {	/* Cfa/stack.scm 46 */
	      obj_t list2126_2185;
	      {		/* Cfa/stack.scm 46 */
		 obj_t arg2128_2187;
		 {	/* Cfa/stack.scm 46 */
		    obj_t aux_3772;
		    aux_3772 =
		       BCHAR(((unsigned char) '\n'));
		    arg2128_2187 =
		       MAKE_PAIR(aux_3772, BNIL);
		 }
		 list2126_2185 =
		    MAKE_PAIR(string2506_cfa_stack, arg2128_2187);
	      }
	      verbose_tools_speek(
		 BINT(((long) 1)), list2126_2185);
	   }
	   set_looser__198_cfa_loose(
	      CNST_TABLE_REF(((long) 0)));
	   cfa_iterate__222_cfa_iterate(roots_1);
	   inline_setup__219_inline_walk(
	      CNST_TABLE_REF(((long) 1)));
	   {
	      obj_t l2051_2188;
	      l2051_2188 = globals_2;
	    lname2052_2189:
	      if (
		 PAIRP(l2051_2188))
		{	/* Cfa/stack.scm 55 */
		   {	/* Cfa/stack.scm 56 */
		      value_bglt fun_2192;
		      {		/* Cfa/stack.scm 56 */
			 global_bglt obj_3153;
			 {	/* Cfa/stack.scm 56 */
			    obj_t aux_3785;
			    aux_3785 =
			       CAR(l2051_2188);
			    obj_3153 =
			       (global_bglt) (aux_3785);
			 }
			 fun_2192 =
			    (((global_bglt) CREF(obj_3153))->value);
		      }
		      {		/* Cfa/stack.scm 57 */
			 node_bglt arg2131_2193;
			 {	/* Cfa/stack.scm 57 */
			    node_bglt aux_3789;
			    {	/* Cfa/stack.scm 57 */
			       obj_t aux_3790;
			       {	/* Cfa/stack.scm 57 */
				  sfun_bglt obj_3154;
				  obj_3154 =
				     (sfun_bglt) (fun_2192);
				  aux_3790 =
				     (((sfun_bglt) CREF(obj_3154))->body);
			       }
			       aux_3789 =
				  (node_bglt) (aux_3790);
			    }
			    arg2131_2193 =
			       stack__132_cfa_stack(aux_3789);
			 }
			 {	/* Cfa/stack.scm 57 */
			    sfun_bglt obj_3155;
			    obj_t val1123_3156;
			    obj_3155 =
			       (sfun_bglt) (fun_2192);
			    val1123_3156 =
			       (obj_t) (arg2131_2193);
			    ((((sfun_bglt) CREF(obj_3155))->body) = ((obj_t) val1123_3156), BUNSPEC);
			 }
		      }
		   }
		   {
		      obj_t l2051_3798;
		      l2051_3798 =
			 CDR(l2051_2188);
		      l2051_2188 = l2051_3798;
		      goto lname2052_2189;
		   }
		}
	      else
		{	/* Cfa/stack.scm 55 */
		   ((bool_t) 1);
		}
	   }
	   verb_stat_110_cfa_stack();
	   return globals_2;
	}
      else
	{	/* Cfa/stack.scm 44 */
	   return BUNSPEC;
	}
   }
}



/* _heap->stack! */
obj_t 
_heap__stack__192_cfa_stack(obj_t env_3720, obj_t roots_3721, obj_t globals_3722)
{
   AN_OBJECT;
   {	/* Cfa/stack.scm 43 */
      return
	 heap__stack__166_cfa_stack(roots_3721, globals_3722);
   }
}



/* node-heap->stack! */
node_bglt 
node_heap__stack__239_cfa_stack(app_bglt node_3, bool_t stackable__42_4)
{
   AN_OBJECT;
   {	/* Cfa/stack.scm 66 */
      {		/* Cfa/stack.scm 68 */
	 variable_bglt v_2197;
	 {	/* Cfa/stack.scm 68 */
	    var_bglt arg2144_2209;
	    arg2144_2209 =
	       (((app_bglt) CREF(node_3))->fun);
	    v_2197 =
	       (((var_bglt) CREF(arg2144_2209))->variable);
	 }
	 {	/* Cfa/stack.scm 68 */
	    value_bglt f_2198;
	    f_2198 =
	       (((variable_bglt) CREF(v_2197))->value);
	    {	/* Cfa/stack.scm 69 */

	       {	/* Cfa/stack.scm 70 */
		  bool_t test2134_2199;
		  {	/* ./Ast/var.scm 927 */
		     obj_t aux_3805;
		     {	/* Cfa/stack.scm 70 */
			fun_bglt obj_3161;
			obj_3161 =
			   (fun_bglt) (f_2198);
			aux_3805 =
			   (((fun_bglt) CREF(obj_3161))->stack_allocator_172);
		     }
		     test2134_2199 =
			is_a__118___object(aux_3805, global_ast_var);
		  }
		  if (test2134_2199)
		    {	/* Cfa/stack.scm 70 */
		       if (stackable__42_4)
			 {	/* Cfa/stack.scm 71 */
			    stack_stat_succeed_138_cfa_stack(
			       (((variable_bglt) CREF(v_2197))->id));
			    {	/* Cfa/stack.scm 74 */
			       var_bglt arg2136_2201;
			       {	/* Cfa/stack.scm 74 */
				  var_bglt duplicated2054_2202;
				  duplicated2054_2202 =
				     (((app_bglt) CREF(node_3))->fun);
				  {	/* Cfa/stack.scm 74 */
				     var_bglt new2055_2203;
				     {	/* Cfa/stack.scm 74 */
					obj_t arg2137_2204;
					type_bglt arg2138_2205;
					arg2137_2204 =
					   (((var_bglt) CREF(duplicated2054_2202))->loc);
					arg2138_2205 =
					   (((var_bglt) CREF(duplicated2054_2202))->type);
					{	/* Cfa/stack.scm 74 */
					   var_bglt res2504_3178;
					   {	/* Cfa/stack.scm 74 */
					      variable_bglt variable_3170;
					      {		/* Cfa/stack.scm 74 */
						 obj_t aux_3816;
						 {	/* Cfa/stack.scm 75 */
						    fun_bglt obj_3167;
						    obj_3167 =
						       (fun_bglt) (f_2198);
						    aux_3816 =
						       (((fun_bglt) CREF(obj_3167))->stack_allocator_172);
						 }
						 variable_3170 =
						    (variable_bglt) (aux_3816);
					      }
					      {		/* ./Ast/node.scm 1061 */
						 var_bglt new1210_3171;
						 new1210_3171 =
						    ((var_bglt) BREF(GC_MALLOC(sizeof(struct var))));
						 {	/* ./Ast/node.scm 1061 */
						    long arg2391_3172;
						    arg2391_3172 =
						       class_num_218___object(var_ast_node);
						    {	/* ./Ast/node.scm 1061 */
						       obj_t obj_3176;
						       obj_3176 =
							  (obj_t) (new1210_3171);
						       (((obj_t) CREF(obj_3176))->header = MAKE_HEADER(arg2391_3172, 0), BUNSPEC);
						    }
						 }
						 {	/* ./Ast/node.scm 1061 */
						    object_bglt aux_3824;
						    aux_3824 =
						       (object_bglt) (new1210_3171);
						    OBJECT_WIDENING_SET(aux_3824, BFALSE);
						 }
						 ((((var_bglt) CREF(new1210_3171))->loc) = ((obj_t) arg2137_2204), BUNSPEC);
						 ((((var_bglt) CREF(new1210_3171))->type) = ((type_bglt) arg2138_2205), BUNSPEC);
						 ((((var_bglt) CREF(new1210_3171))->variable) = ((variable_bglt) variable_3170), BUNSPEC);
						 res2504_3178 = new1210_3171;
					      }
					   }
					   new2055_2203 = res2504_3178;
					}
				     }
				     {	/* Cfa/stack.scm 74 */

					arg2136_2201 = new2055_2203;
				     }
				  }
			       }
			       ((((app_bglt) CREF(node_3))->fun) = ((var_bglt) arg2136_2201), BUNSPEC);
			    }
			    return
			       inline_node_218_inline_inline(
			       (node_bglt) (node_3), ((long) 1), BNIL);
			 }
		       else
			 {	/* Cfa/stack.scm 71 */
			    stack_stat_fail_33_cfa_stack(
			       (((variable_bglt) CREF(v_2197))->id));
			    return
			       (node_bglt) (node_3);
			 }
		    }
		  else
		    {	/* Cfa/stack.scm 70 */
		       return
			  (node_bglt) (node_3);
		    }
	       }
	    }
	 }
      }
   }
}



/* _node-heap->stack! */
obj_t 
_node_heap__stack__85_cfa_stack(obj_t env_3723, obj_t node_3724, obj_t stackable__42_3725)
{
   AN_OBJECT;
   {	/* Cfa/stack.scm 66 */
      {		/* Cfa/stack.scm 66 */
	 node_bglt aux_3837;
	 aux_3837 =
	    node_heap__stack__239_cfa_stack(
	    (app_bglt) (node_3724),
	    CBOOL(stackable__42_3725));
	 return
	    (obj_t) (aux_3837);
      }
   }
}



/* stack-stat-succeed */
obj_t 
stack_stat_succeed_138_cfa_stack(obj_t kind_5)
{
   AN_OBJECT;
   {	/* Cfa/stack.scm 93 */
      {		/* Cfa/stack.scm 94 */
	 obj_t cell_2210;
	 cell_2210 =
	    assq___r4_pairs_and_lists_6_3(kind_5, _statistics__64_cfa_stack);
	 if (
	    PAIRP(cell_2210))
	   {	/* ./Ieee/pair-list.scm 5890 */
	      obj_t aux_3847;
	      obj_t aux_3845;
	      {		/* Cfa/stack.scm 96 */
		 long aux_3848;
		 {	/* ./Ieee/fixnum.scm 7193 */
		    long aux_3849;
		    {	/* Cfa/stack.scm 96 */
		       obj_t aux_3850;
		       {	/* ./Ieee/pair-list.scm 5701 */
			  obj_t aux_3851;
			  aux_3851 =
			     CDR(cell_2210);
			  aux_3850 =
			     CAR(aux_3851);
		       }
		       aux_3849 =
			  (long) CINT(aux_3850);
		    }
		    aux_3848 =
		       (((long) 1) + aux_3849);
		 }
		 aux_3847 =
		    BINT(aux_3848);
	      }
	      aux_3845 =
		 CDR(cell_2210);
	      return
		 SET_CAR(aux_3845, aux_3847);
	   }
	 else
	   {	/* Cfa/stack.scm 97 */
	      obj_t arg2151_2216;
	      {		/* Cfa/stack.scm 97 */
		 obj_t arg2153_2217;
		 {	/* ./Ieee/pair-list.scm 5689 */
		    obj_t aux_3860;
		    obj_t aux_3858;
		    aux_3860 =
		       BINT(((long) 0));
		    aux_3858 =
		       BINT(((long) 1));
		    arg2153_2217 =
		       MAKE_PAIR(aux_3858, aux_3860);
		 }
		 arg2151_2216 =
		    MAKE_PAIR(kind_5, arg2153_2217);
	      }
	      {		/* Cfa/stack.scm 97 */
		 obj_t obj2_3197;
		 obj2_3197 = _statistics__64_cfa_stack;
		 return (
		    _statistics__64_cfa_stack =
		    MAKE_PAIR(arg2151_2216, obj2_3197), BUNSPEC);
	      }
	   }
      }
   }
}



/* stack-stat-fail */
obj_t 
stack_stat_fail_33_cfa_stack(obj_t kind_6)
{
   AN_OBJECT;
   {	/* Cfa/stack.scm 102 */
      {		/* Cfa/stack.scm 103 */
	 obj_t cell_2218;
	 cell_2218 =
	    assq___r4_pairs_and_lists_6_3(kind_6, _statistics__64_cfa_stack);
	 if (
	    PAIRP(cell_2218))
	   {	/* ./Ieee/pair-list.scm 5896 */
	      obj_t aux_3870;
	      obj_t aux_3868;
	      {		/* Cfa/stack.scm 105 */
		 long aux_3871;
		 {	/* ./Ieee/fixnum.scm 7193 */
		    long aux_3872;
		    {	/* Cfa/stack.scm 105 */
		       obj_t aux_3873;
		       {	/* ./Ieee/pair-list.scm 5707 */
			  obj_t aux_3874;
			  aux_3874 =
			     CDR(cell_2218);
			  aux_3873 =
			     CDR(aux_3874);
		       }
		       aux_3872 =
			  (long) CINT(aux_3873);
		    }
		    aux_3871 =
		       (((long) 1) + aux_3872);
		 }
		 aux_3870 =
		    BINT(aux_3871);
	      }
	      aux_3868 =
		 CDR(cell_2218);
	      return
		 SET_CDR(aux_3868, aux_3870);
	   }
	 else
	   {	/* Cfa/stack.scm 106 */
	      obj_t arg2159_2224;
	      {		/* Cfa/stack.scm 106 */
		 obj_t arg2160_2225;
		 {	/* ./Ieee/pair-list.scm 5689 */
		    obj_t aux_3883;
		    obj_t aux_3881;
		    aux_3883 =
		       BINT(((long) 1));
		    aux_3881 =
		       BINT(((long) 0));
		    arg2160_2225 =
		       MAKE_PAIR(aux_3881, aux_3883);
		 }
		 arg2159_2224 =
		    MAKE_PAIR(kind_6, arg2160_2225);
	      }
	      {		/* Cfa/stack.scm 106 */
		 obj_t obj2_3213;
		 obj2_3213 = _statistics__64_cfa_stack;
		 return (
		    _statistics__64_cfa_stack =
		    MAKE_PAIR(arg2159_2224, obj2_3213), BUNSPEC);
	      }
	   }
      }
   }
}



/* verb-stat */
bool_t 
verb_stat_110_cfa_stack()
{
   AN_OBJECT;
   {	/* Cfa/stack.scm 111 */
      {
	 obj_t l2056_2226;
	 l2056_2226 = _statistics__64_cfa_stack;
       lname2057_2227:
	 if (
	    PAIRP(l2056_2226))
	   {	/* Cfa/stack.scm 112 */
	      {		/* Cfa/stack.scm 113 */
		 obj_t stat_2229;
		 stat_2229 =
		    CAR(l2056_2226);
		 {	/* Cfa/stack.scm 113 */
		    obj_t arg2164_2232;
		    obj_t arg2166_2234;
		    long arg2168_2236;
		    {	/* Cfa/stack.scm 114 */
		       obj_t arg2177_2245;
		       {	/* ./Ieee/symbol.scm 6021 */
			  obj_t aux_3891;
			  aux_3891 =
			     CAR(stat_2229);
			  arg2177_2245 =
			     SYMBOL_TO_STRING(aux_3891);
		       }
		       arg2164_2232 =
			  string_downcase_77___r4_strings_6_7(arg2177_2245);
		    }
		    {	/* ./Ieee/pair-list.scm 5701 */
		       obj_t aux_3895;
		       aux_3895 =
			  CDR(stat_2229);
		       arg2166_2234 =
			  CAR(aux_3895);
		    }
		    {	/* ./Ieee/fixnum.scm 7193 */
		       long aux_3904;
		       long aux_3898;
		       {	/* Cfa/stack.scm 115 */
			  obj_t aux_3905;
			  {	/* ./Ieee/pair-list.scm 5707 */
			     obj_t aux_3906;
			     aux_3906 =
				CDR(stat_2229);
			     aux_3905 =
				CDR(aux_3906);
			  }
			  aux_3904 =
			     (long) CINT(aux_3905);
		       }
		       {	/* Cfa/stack.scm 115 */
			  obj_t aux_3899;
			  {	/* ./Ieee/pair-list.scm 5701 */
			     obj_t aux_3900;
			     aux_3900 =
				CDR(stat_2229);
			     aux_3899 =
				CAR(aux_3900);
			  }
			  aux_3898 =
			     (long) CINT(aux_3899);
		       }
		       arg2168_2236 =
			  (aux_3898 + aux_3904);
		    }
		    {	/* Cfa/stack.scm 113 */
		       obj_t list2169_2237;
		       {	/* Cfa/stack.scm 113 */
			  obj_t arg2170_2238;
			  {	/* Cfa/stack.scm 113 */
			     obj_t arg2171_2239;
			     {	/* Cfa/stack.scm 113 */
				obj_t arg2172_2240;
				{	/* Cfa/stack.scm 113 */
				   obj_t arg2173_2241;
				   {	/* Cfa/stack.scm 113 */
				      obj_t arg2174_2242;
				      {		/* Cfa/stack.scm 113 */
					 obj_t arg2175_2243;
					 {	/* Cfa/stack.scm 113 */
					    obj_t arg2176_2244;
					    {	/* Cfa/stack.scm 113 */
					       obj_t aux_3911;
					       aux_3911 =
						  BCHAR(((unsigned char) '\n'));
					       arg2176_2244 =
						  MAKE_PAIR(aux_3911, BNIL);
					    }
					    {	/* Cfa/stack.scm 113 */
					       obj_t aux_3914;
					       aux_3914 =
						  BCHAR(((unsigned char) ')'));
					       arg2175_2243 =
						  MAKE_PAIR(aux_3914, arg2176_2244);
					    }
					 }
					 {	/* Cfa/stack.scm 113 */
					    obj_t aux_3917;
					    aux_3917 =
					       BINT(arg2168_2236);
					    arg2174_2242 =
					       MAKE_PAIR(aux_3917, arg2175_2243);
					 }
				      }
				      arg2173_2241 =
					 MAKE_PAIR(string2507_cfa_stack, arg2174_2242);
				   }
				   arg2172_2240 =
				      MAKE_PAIR(arg2166_2234, arg2173_2241);
				}
				arg2171_2239 =
				   MAKE_PAIR(string2508_cfa_stack, arg2172_2240);
			     }
			     arg2170_2238 =
				MAKE_PAIR(arg2164_2232, arg2171_2239);
			  }
			  list2169_2237 =
			     MAKE_PAIR(string2509_cfa_stack, arg2170_2238);
		       }
		       verbose_tools_speek(
			  BINT(((long) 2)), list2169_2237);
		    }
		 }
	      }
	      {
		 obj_t l2056_3927;
		 l2056_3927 =
		    CDR(l2056_2226);
		 l2056_2226 = l2056_3927;
		 goto lname2057_2227;
	      }
	   }
	 else
	   {	/* Cfa/stack.scm 112 */
	      return ((bool_t) 1);
	   }
      }
   }
}



/* stack*! */
obj_t 
stack___129_cfa_stack(obj_t node__221_30)
{
   AN_OBJECT;
   {	/* Cfa/stack.scm 307 */
      {
	 obj_t node__221_2250;
	 node__221_2250 = node__221_30;
       loop_2251:
	 if (
	    NULLP(node__221_2250))
	   {	/* Cfa/stack.scm 310 */
	      return
		 CNST_TABLE_REF(((long) 2));
	   }
	 else
	   {	/* Cfa/stack.scm 310 */
	      {		/* Cfa/stack.scm 313 */
		 node_bglt arg2183_2253;
		 {	/* Cfa/stack.scm 313 */
		    node_bglt aux_3932;
		    {	/* Cfa/stack.scm 313 */
		       obj_t aux_3933;
		       aux_3933 =
			  CAR(node__221_2250);
		       aux_3932 =
			  (node_bglt) (aux_3933);
		    }
		    arg2183_2253 =
		       stack__132_cfa_stack(aux_3932);
		 }
		 {	/* ./Ieee/pair-list.scm 5890 */
		    obj_t aux_3937;
		    aux_3937 =
		       (obj_t) (arg2183_2253);
		    SET_CAR(node__221_2250, aux_3937);
		 }
	      }
	      {
		 obj_t node__221_3940;
		 node__221_3940 =
		    CDR(node__221_2250);
		 node__221_2250 = node__221_3940;
		 goto loop_2251;
	      }
	   }
      }
   }
}



/* _stack*! */
obj_t 
_stack___237_cfa_stack(obj_t env_3726, obj_t node__221_3727)
{
   AN_OBJECT;
   {	/* Cfa/stack.scm 307 */
      return
	 stack___129_cfa_stack(node__221_3727);
   }
}



/* method-init */
obj_t 
method_init_76_cfa_stack()
{
   AN_OBJECT;
   {	/* Cfa/stack.scm 14 */
      add_generic__110___object(stack__env_104_cfa_stack, stack__default2081_env_242_cfa_stack);
      add_inlined_method__244___object(stack__env_104_cfa_stack, atom_ast_node, ((long) 0));
      add_inlined_method__244___object(stack__env_104_cfa_stack, kwote_ast_node, ((long) 1));
      add_inlined_method__244___object(stack__env_104_cfa_stack, var_ast_node, ((long) 2));
      add_inlined_method__244___object(stack__env_104_cfa_stack, closure_ast_node, ((long) 3));
      add_inlined_method__244___object(stack__env_104_cfa_stack, sequence_ast_node, ((long) 4));
      add_inlined_method__244___object(stack__env_104_cfa_stack, app_ly_162_ast_node, ((long) 5));
      add_inlined_method__244___object(stack__env_104_cfa_stack, funcall_ast_node, ((long) 6));
      add_inlined_method__244___object(stack__env_104_cfa_stack, pragma_ast_node, ((long) 7));
      add_inlined_method__244___object(stack__env_104_cfa_stack, cast_ast_node, ((long) 8));
      add_inlined_method__244___object(stack__env_104_cfa_stack, setq_ast_node, ((long) 9));
      add_inlined_method__244___object(stack__env_104_cfa_stack, conditional_ast_node, ((long) 10));
      add_inlined_method__244___object(stack__env_104_cfa_stack, fail_ast_node, ((long) 11));
      add_inlined_method__244___object(stack__env_104_cfa_stack, select_ast_node, ((long) 12));
      add_inlined_method__244___object(stack__env_104_cfa_stack, let_fun_218_ast_node, ((long) 13));
      add_inlined_method__244___object(stack__env_104_cfa_stack, let_var_6_ast_node, ((long) 14));
      add_inlined_method__244___object(stack__env_104_cfa_stack, set_ex_it_116_ast_node, ((long) 15));
      add_inlined_method__244___object(stack__env_104_cfa_stack, jump_ex_it_184_ast_node, ((long) 16));
      add_inlined_method__244___object(stack__env_104_cfa_stack, make_box_202_ast_node, ((long) 17));
      add_inlined_method__244___object(stack__env_104_cfa_stack, box_set__221_ast_node, ((long) 18));
      add_inlined_method__244___object(stack__env_104_cfa_stack, box_ref_242_ast_node, ((long) 19));
      {		/* Cfa/stack.scm 14 */
	 long aux_3964;
	 aux_3964 =
	    add_inlined_method__244___object(stack__env_104_cfa_stack, app_ast_node, ((long) 20));
	 return
	    BINT(aux_3964);
      }
   }
}



/* stack! */
node_bglt 
stack__132_cfa_stack(node_bglt node_7)
{
   AN_OBJECT;
   {	/* Cfa/stack.scm 122 */
      {
	 obj_t method2423_3023;
	 obj_t class2428_3024;
	 {	/* Cfa/stack.scm 122 */
	    obj_t arg2431_3021;
	    obj_t arg2432_3022;
	    {	/* Cfa/stack.scm 122 */
	       object_bglt obj_3595;
	       obj_3595 =
		  (object_bglt) (node_7);
	       {	/* ./Llib/object.scm 2926 */
		  obj_t pre_method_105_3596;
		  pre_method_105_3596 =
		     PROCEDURE_REF(stack__env_104_cfa_stack, ((long) 2));
		  if (
		     INTEGERP(pre_method_105_3596))
		    {	/* ./Llib/object.scm 2927 */
		       PROCEDURE_SET(stack__env_104_cfa_stack, ((long) 2), BUNSPEC);
		       arg2431_3021 = pre_method_105_3596;
		    }
		  else
		    {	/* ./Llib/object.scm 2914 */
		       long obj_class_num_177_3601;
		       obj_class_num_177_3601 =
			  TYPE(obj_3595);
		       {	/* ./Llib/object.scm 2915 */
			  obj_t arg1176_3602;
			  arg1176_3602 =
			     PROCEDURE_REF(stack__env_104_cfa_stack, ((long) 1));
			  {	/* ./Llib/object.scm 2738 */
			     long arg1177_3606;
			     {	/* ./Llib/object.scm 2738 */
				long arg1178_3607;
				arg1178_3607 =
				   OBJECT_TYPE;
				arg1177_3606 =
				   (obj_class_num_177_3601 - arg1178_3607);
			     }
			     arg2431_3021 =
				VECTOR_REF(arg1176_3602, arg1177_3606);
			  }
		       }
		    }
	       }
	    }
	    {	/* Cfa/stack.scm 122 */
	       object_bglt object_3612;
	       object_3612 =
		  (object_bglt) (node_7);
	       {	/* ./Llib/object.scm 2695 */
		  long arg1179_3613;
		  {	/* ./Llib/object.scm 2695 */
		     long arg1180_3614;
		     long arg1181_3615;
		     arg1180_3614 =
			TYPE(object_3612);
		     arg1181_3615 =
			OBJECT_TYPE;
		     arg1179_3613 =
			(arg1180_3614 - arg1181_3615);
		  }
		  {	/* ./Llib/object.scm 2695 */
		     obj_t vector_3619;
		     vector_3619 = _classes__134___object;
		     arg2432_3022 =
			VECTOR_REF(vector_3619, arg1179_3613);
		  }
	       }
	    }
	    {	/* Cfa/stack.scm 122 */
	       obj_t aux_3982;
	       method2423_3023 = arg2431_3021;
	       class2428_3024 = arg2432_3022;
	       {

		  if (
		     INTEGERP(method2423_3023))
		    {	/* Cfa/stack.scm 122 */
		       switch (
			  (long) CINT(method2423_3023))
			 {
			 case ((long) 0):

			    {	/* Cfa/stack.scm 122 */
			       atom_bglt aux_3985;
			       aux_3985 =
				  (atom_bglt) (node_7);
			       aux_3982 =
				  (obj_t) (aux_3985);
			    }
			    break;
			 case ((long) 1):

			    {	/* Cfa/stack.scm 122 */
			       kwote_bglt aux_3988;
			       aux_3988 =
				  (kwote_bglt) (node_7);
			       aux_3982 =
				  (obj_t) (aux_3988);
			    }
			    break;
			 case ((long) 2):

			    {	/* Cfa/stack.scm 122 */
			       var_bglt aux_3991;
			       aux_3991 =
				  (var_bglt) (node_7);
			       aux_3982 =
				  (obj_t) (aux_3991);
			    }
			    break;
			 case ((long) 3):

			    {	/* Cfa/stack.scm 122 */
			       closure_bglt aux_3994;
			       aux_3994 =
				  (closure_bglt) (node_7);
			       aux_3982 =
				  (obj_t) (aux_3994);
			    }
			    break;
			 case ((long) 4):

			    {	/* Cfa/stack.scm 152 */
			       sequence_bglt node_3034;
			       node_3034 =
				  (sequence_bglt) (node_7);
			       stack___129_cfa_stack(
				  (((sequence_bglt) CREF(node_3034))->nodes));
			       aux_3982 =
				  (obj_t) (node_3034);
			    }
			    break;
			 case ((long) 5):

			    {	/* Cfa/stack.scm 160 */
			       app_ly_162_bglt node_3037;
			       node_3037 =
				  (app_ly_162_bglt) (node_7);
			       {	/* Cfa/stack.scm 161 */
				  node_bglt arg2436_3039;
				  arg2436_3039 =
				     stack__132_cfa_stack(
				     (((app_ly_162_bglt) CREF(node_3037))->fun));
				  ((((app_ly_162_bglt) CREF(node_3037))->fun) = ((node_bglt) arg2436_3039), BUNSPEC);
			       }
			       {	/* Cfa/stack.scm 162 */
				  node_bglt arg2438_3041;
				  arg2438_3041 =
				     stack__132_cfa_stack(
				     (((app_ly_162_bglt) CREF(node_3037))->arg));
				  ((((app_ly_162_bglt) CREF(node_3037))->arg) = ((node_bglt) arg2438_3041), BUNSPEC);
			       }
			       aux_3982 =
				  (obj_t) (node_3037);
			    }
			    break;
			 case ((long) 6):

			    {	/* Cfa/stack.scm 169 */
			       funcall_bglt node_3043;
			       node_3043 =
				  (funcall_bglt) (node_7);
			       {	/* Cfa/stack.scm 170 */
				  node_bglt arg2440_3045;
				  arg2440_3045 =
				     stack__132_cfa_stack(
				     (((funcall_bglt) CREF(node_3043))->fun));
				  ((((funcall_bglt) CREF(node_3043))->fun) = ((node_bglt) arg2440_3045), BUNSPEC);
			       }
			       stack___129_cfa_stack(
				  (((funcall_bglt) CREF(node_3043))->args));
			       aux_3982 =
				  (obj_t) (node_3043);
			    }
			    break;
			 case ((long) 7):

			    {	/* Cfa/stack.scm 178 */
			       pragma_bglt node_3048;
			       node_3048 =
				  (pragma_bglt) (node_7);
			       stack___129_cfa_stack(
				  (((pragma_bglt) CREF(node_3048))->args));
			       aux_3982 =
				  (obj_t) (node_3048);
			    }
			    break;
			 case ((long) 8):

			    {	/* Cfa/stack.scm 186 */
			       cast_bglt node_3051;
			       node_3051 =
				  (cast_bglt) (node_7);
			       stack__132_cfa_stack(
				  (((cast_bglt) CREF(node_3051))->arg));
			       aux_3982 =
				  (obj_t) (node_3051);
			    }
			    break;
			 case ((long) 9):

			    {	/* Cfa/stack.scm 194 */
			       setq_bglt node_3054;
			       node_3054 =
				  (setq_bglt) (node_7);
			       {	/* Cfa/stack.scm 195 */
				  node_bglt arg2445_3056;
				  arg2445_3056 =
				     stack__132_cfa_stack(
				     (((setq_bglt) CREF(node_3054))->value));
				  ((((setq_bglt) CREF(node_3054))->value) = ((node_bglt) arg2445_3056), BUNSPEC);
			       }
			       {	/* Cfa/stack.scm 196 */
				  node_bglt arg2447_3058;
				  {	/* Cfa/stack.scm 196 */
				     node_bglt aux_4028;
				     {	/* Cfa/stack.scm 196 */
					var_bglt aux_4029;
					aux_4029 =
					   (((setq_bglt) CREF(node_3054))->var);
					aux_4028 =
					   (node_bglt) (aux_4029);
				     }
				     arg2447_3058 =
					stack__132_cfa_stack(aux_4028);
				  }
				  {	/* Cfa/stack.scm 196 */
				     var_bglt val1302_3639;
				     val1302_3639 =
					(var_bglt) (arg2447_3058);
				     ((((setq_bglt) CREF(node_3054))->var) = ((var_bglt) val1302_3639), BUNSPEC);
				  }
			       }
			       aux_3982 =
				  (obj_t) (node_3054);
			    }
			    break;
			 case ((long) 10):

			    {	/* Cfa/stack.scm 203 */
			       conditional_bglt node_3060;
			       node_3060 =
				  (conditional_bglt) (node_7);
			       {	/* Cfa/stack.scm 204 */
				  node_bglt arg2449_3062;
				  arg2449_3062 =
				     stack__132_cfa_stack(
				     (((conditional_bglt) CREF(node_3060))->test));
				  ((((conditional_bglt) CREF(node_3060))->test) = ((node_bglt) arg2449_3062), BUNSPEC);
			       }
			       {	/* Cfa/stack.scm 205 */
				  node_bglt arg2451_3064;
				  arg2451_3064 =
				     stack__132_cfa_stack(
				     (((conditional_bglt) CREF(node_3060))->true));
				  ((((conditional_bglt) CREF(node_3060))->true) = ((node_bglt) arg2451_3064), BUNSPEC);
			       }
			       {	/* Cfa/stack.scm 206 */
				  node_bglt arg2453_3066;
				  arg2453_3066 =
				     stack__132_cfa_stack(
				     (((conditional_bglt) CREF(node_3060))->false));
				  ((((conditional_bglt) CREF(node_3060))->false) = ((node_bglt) arg2453_3066), BUNSPEC);
			       }
			       aux_3982 =
				  (obj_t) (node_3060);
			    }
			    break;
			 case ((long) 11):

			    {	/* Cfa/stack.scm 213 */
			       fail_bglt node_3068;
			       node_3068 =
				  (fail_bglt) (node_7);
			       {	/* Cfa/stack.scm 214 */
				  node_bglt arg2455_3070;
				  arg2455_3070 =
				     stack__132_cfa_stack(
				     (((fail_bglt) CREF(node_3068))->proc));
				  ((((fail_bglt) CREF(node_3068))->proc) = ((node_bglt) arg2455_3070), BUNSPEC);
			       }
			       {	/* Cfa/stack.scm 215 */
				  node_bglt arg2457_3072;
				  arg2457_3072 =
				     stack__132_cfa_stack(
				     (((fail_bglt) CREF(node_3068))->msg));
				  ((((fail_bglt) CREF(node_3068))->msg) = ((node_bglt) arg2457_3072), BUNSPEC);
			       }
			       {	/* Cfa/stack.scm 216 */
				  node_bglt arg2459_3074;
				  arg2459_3074 =
				     stack__132_cfa_stack(
				     (((fail_bglt) CREF(node_3068))->obj));
				  ((((fail_bglt) CREF(node_3068))->obj) = ((node_bglt) arg2459_3074), BUNSPEC);
			       }
			       aux_3982 =
				  (obj_t) (node_3068);
			    }
			    break;
			 case ((long) 12):

			    {	/* Cfa/stack.scm 223 */
			       select_bglt node_3076;
			       node_3076 =
				  (select_bglt) (node_7);
			       {	/* Cfa/stack.scm 224 */
				  node_bglt arg2461_3078;
				  arg2461_3078 =
				     stack__132_cfa_stack(
				     (((select_bglt) CREF(node_3076))->test));
				  ((((select_bglt) CREF(node_3076))->test) = ((node_bglt) arg2461_3078), BUNSPEC);
			       }
			       {
				  obj_t l2067_3080;
				  l2067_3080 =
				     (((select_bglt) CREF(node_3076))->clauses);
				lname2068_3081:
				  if (
				     PAIRP(l2067_3080))
				    {	/* Cfa/stack.scm 225 */
				       {	/* Cfa/stack.scm 226 */
					  obj_t clause_3084;
					  clause_3084 =
					     CAR(l2067_3080);
					  {	/* Cfa/stack.scm 226 */
					     node_bglt arg2465_3085;
					     {	/* Cfa/stack.scm 226 */
						node_bglt aux_4065;
						{	/* Cfa/stack.scm 226 */
						   obj_t aux_4066;
						   aux_4066 =
						      CDR(clause_3084);
						   aux_4065 =
						      (node_bglt) (aux_4066);
						}
						arg2465_3085 =
						   stack__132_cfa_stack(aux_4065);
					     }
					     {	/* ./Ieee/pair-list.scm 5896 */
						obj_t aux_4070;
						aux_4070 =
						   (obj_t) (arg2465_3085);
						SET_CDR(clause_3084, aux_4070);
					     }
					  }
				       }
				       {
					  obj_t l2067_4073;
					  l2067_4073 =
					     CDR(l2067_3080);
					  l2067_3080 = l2067_4073;
					  goto lname2068_3081;
				       }
				    }
				  else
				    {	/* Cfa/stack.scm 225 */
				       ((bool_t) 1);
				    }
			       }
			       aux_3982 =
				  (obj_t) (node_3076);
			    }
			    break;
			 case ((long) 13):

			    {	/* Cfa/stack.scm 234 */
			       let_fun_218_bglt node_3088;
			       node_3088 =
				  (let_fun_218_bglt) (node_7);
			       {
				  obj_t l2070_3090;
				  l2070_3090 =
				     (((let_fun_218_bglt) CREF(node_3088))->locals);
				lname2071_3091:
				  if (
				     PAIRP(l2070_3090))
				    {	/* Cfa/stack.scm 235 */
				       {	/* Cfa/stack.scm 236 */
					  value_bglt fun_3095;
					  {	/* Cfa/stack.scm 236 */
					     local_bglt obj_3671;
					     {	/* Cfa/stack.scm 236 */
						obj_t aux_4080;
						aux_4080 =
						   CAR(l2070_3090);
						obj_3671 =
						   (local_bglt) (aux_4080);
					     }
					     fun_3095 =
						(((local_bglt) CREF(obj_3671))->value);
					  }
					  {	/* Cfa/stack.scm 237 */
					     node_bglt arg2470_3096;
					     {	/* Cfa/stack.scm 237 */
						node_bglt aux_4084;
						{	/* Cfa/stack.scm 237 */
						   obj_t aux_4085;
						   {	/* Cfa/stack.scm 237 */
						      sfun_bglt obj_3672;
						      obj_3672 =
							 (sfun_bglt) (fun_3095);
						      aux_4085 =
							 (((sfun_bglt) CREF(obj_3672))->body);
						   }
						   aux_4084 =
						      (node_bglt) (aux_4085);
						}
						arg2470_3096 =
						   stack__132_cfa_stack(aux_4084);
					     }
					     {	/* Cfa/stack.scm 237 */
						sfun_bglt obj_3673;
						obj_t val1123_3674;
						obj_3673 =
						   (sfun_bglt) (fun_3095);
						val1123_3674 =
						   (obj_t) (arg2470_3096);
						((((sfun_bglt) CREF(obj_3673))->body) = ((obj_t) val1123_3674), BUNSPEC);
					     }
					  }
				       }
				       {
					  obj_t l2070_4093;
					  l2070_4093 =
					     CDR(l2070_3090);
					  l2070_3090 = l2070_4093;
					  goto lname2071_3091;
				       }
				    }
				  else
				    {	/* Cfa/stack.scm 235 */
				       ((bool_t) 1);
				    }
			       }
			       {	/* Cfa/stack.scm 239 */
				  node_bglt arg2473_3099;
				  arg2473_3099 =
				     stack__132_cfa_stack(
				     (((let_fun_218_bglt) CREF(node_3088))->body));
				  ((((let_fun_218_bglt) CREF(node_3088))->body) = ((node_bglt) arg2473_3099), BUNSPEC);
			       }
			       aux_3982 =
				  (obj_t) (node_3088);
			    }
			    break;
			 case ((long) 14):

			    {	/* Cfa/stack.scm 246 */
			       let_var_6_bglt node_3101;
			       node_3101 =
				  (let_var_6_bglt) (node_7);
			       {	/* Cfa/stack.scm 247 */
				  node_bglt arg2475_3103;
				  arg2475_3103 =
				     stack__132_cfa_stack(
				     (((let_var_6_bglt) CREF(node_3101))->body));
				  ((((let_var_6_bglt) CREF(node_3101))->body) = ((node_bglt) arg2475_3103), BUNSPEC);
			       }
			       {
				  obj_t l2073_3105;
				  l2073_3105 =
				     (((let_var_6_bglt) CREF(node_3101))->bindings);
				lname2074_3106:
				  if (
				     PAIRP(l2073_3105))
				    {	/* Cfa/stack.scm 248 */
				       {	/* Cfa/stack.scm 249 */
					  obj_t binding_3109;
					  binding_3109 =
					     CAR(l2073_3105);
					  {	/* Cfa/stack.scm 249 */
					     node_bglt arg2479_3110;
					     {	/* Cfa/stack.scm 249 */
						node_bglt aux_4107;
						{	/* Cfa/stack.scm 249 */
						   obj_t aux_4108;
						   aux_4108 =
						      CDR(binding_3109);
						   aux_4107 =
						      (node_bglt) (aux_4108);
						}
						arg2479_3110 =
						   stack__132_cfa_stack(aux_4107);
					     }
					     {	/* ./Ieee/pair-list.scm 5896 */
						obj_t aux_4112;
						aux_4112 =
						   (obj_t) (arg2479_3110);
						SET_CDR(binding_3109, aux_4112);
					     }
					  }
				       }
				       {
					  obj_t l2073_4115;
					  l2073_4115 =
					     CDR(l2073_3105);
					  l2073_3105 = l2073_4115;
					  goto lname2074_3106;
				       }
				    }
				  else
				    {	/* Cfa/stack.scm 248 */
				       ((bool_t) 1);
				    }
			       }
			       aux_3982 =
				  (obj_t) (node_3101);
			    }
			    break;
			 case ((long) 15):

			    {	/* Cfa/stack.scm 257 */
			       set_ex_it_116_bglt node_3113;
			       node_3113 =
				  (set_ex_it_116_bglt) (node_7);
			       {	/* Cfa/stack.scm 258 */
				  node_bglt arg2482_3115;
				  arg2482_3115 =
				     stack__132_cfa_stack(
				     (((set_ex_it_116_bglt) CREF(node_3113))->body));
				  ((((set_ex_it_116_bglt) CREF(node_3113))->body) = ((node_bglt) arg2482_3115), BUNSPEC);
			       }
			       {	/* Cfa/stack.scm 259 */
				  node_bglt arg2484_3117;
				  {	/* Cfa/stack.scm 259 */
				     node_bglt aux_4123;
				     {	/* Cfa/stack.scm 259 */
					var_bglt aux_4124;
					aux_4124 =
					   (((set_ex_it_116_bglt) CREF(node_3113))->var);
					aux_4123 =
					   (node_bglt) (aux_4124);
				     }
				     arg2484_3117 =
					stack__132_cfa_stack(aux_4123);
				  }
				  {	/* Cfa/stack.scm 259 */
				     var_bglt val1384_3694;
				     val1384_3694 =
					(var_bglt) (arg2484_3117);
				     ((((set_ex_it_116_bglt) CREF(node_3113))->var) = ((var_bglt) val1384_3694), BUNSPEC);
				  }
			       }
			       aux_3982 =
				  (obj_t) (node_3113);
			    }
			    break;
			 case ((long) 16):

			    {	/* Cfa/stack.scm 266 */
			       jump_ex_it_184_bglt node_3119;
			       node_3119 =
				  (jump_ex_it_184_bglt) (node_7);
			       {	/* Cfa/stack.scm 267 */
				  node_bglt arg2486_3121;
				  arg2486_3121 =
				     stack__132_cfa_stack(
				     (((jump_ex_it_184_bglt) CREF(node_3119))->exit));
				  ((((jump_ex_it_184_bglt) CREF(node_3119))->exit) = ((node_bglt) arg2486_3121), BUNSPEC);
			       }
			       {	/* Cfa/stack.scm 268 */
				  node_bglt arg2488_3123;
				  arg2488_3123 =
				     stack__132_cfa_stack(
				     (((jump_ex_it_184_bglt) CREF(node_3119))->value));
				  ((((jump_ex_it_184_bglt) CREF(node_3119))->value) = ((node_bglt) arg2488_3123), BUNSPEC);
			       }
			       aux_3982 =
				  (obj_t) (node_3119);
			    }
			    break;
			 case ((long) 17):

			    {	/* Cfa/stack.scm 275 */
			       make_box_202_bglt node_3125;
			       node_3125 =
				  (make_box_202_bglt) (node_7);
			       {	/* Cfa/stack.scm 276 */
				  node_bglt arg2490_3127;
				  arg2490_3127 =
				     stack__132_cfa_stack(
				     (((make_box_202_bglt) CREF(node_3125))->value));
				  ((((make_box_202_bglt) CREF(node_3125))->value) = ((node_bglt) arg2490_3127), BUNSPEC);
			       }
			       aux_3982 =
				  (obj_t) (node_3125);
			    }
			    break;
			 case ((long) 18):

			    {	/* Cfa/stack.scm 283 */
			       box_set__221_bglt node_3129;
			       node_3129 =
				  (box_set__221_bglt) (node_7);
			       {	/* Cfa/stack.scm 284 */
				  node_bglt arg2492_3131;
				  {	/* Cfa/stack.scm 284 */
				     node_bglt aux_4145;
				     {	/* Cfa/stack.scm 284 */
					var_bglt aux_4146;
					aux_4146 =
					   (((box_set__221_bglt) CREF(node_3129))->var);
					aux_4145 =
					   (node_bglt) (aux_4146);
				     }
				     arg2492_3131 =
					stack__132_cfa_stack(aux_4145);
				  }
				  {	/* Cfa/stack.scm 284 */
				     var_bglt val1428_3706;
				     val1428_3706 =
					(var_bglt) (arg2492_3131);
				     ((((box_set__221_bglt) CREF(node_3129))->var) = ((var_bglt) val1428_3706), BUNSPEC);
				  }
			       }
			       {	/* Cfa/stack.scm 285 */
				  node_bglt arg2494_3133;
				  arg2494_3133 =
				     stack__132_cfa_stack(
				     (((box_set__221_bglt) CREF(node_3129))->value));
				  ((((box_set__221_bglt) CREF(node_3129))->value) = ((node_bglt) arg2494_3133), BUNSPEC);
			       }
			       aux_3982 =
				  (obj_t) (node_3129);
			    }
			    break;
			 case ((long) 19):

			    {	/* Cfa/stack.scm 292 */
			       box_ref_242_bglt node_3135;
			       node_3135 =
				  (box_ref_242_bglt) (node_7);
			       {	/* Cfa/stack.scm 293 */
				  node_bglt arg2496_3137;
				  {	/* Cfa/stack.scm 293 */
				     node_bglt aux_4157;
				     {	/* Cfa/stack.scm 293 */
					var_bglt aux_4158;
					aux_4158 =
					   (((box_ref_242_bglt) CREF(node_3135))->var);
					aux_4157 =
					   (node_bglt) (aux_4158);
				     }
				     arg2496_3137 =
					stack__132_cfa_stack(aux_4157);
				  }
				  {	/* Cfa/stack.scm 293 */
				     var_bglt val1418_3712;
				     val1418_3712 =
					(var_bglt) (arg2496_3137);
				     ((((box_ref_242_bglt) CREF(node_3135))->var) = ((var_bglt) val1418_3712), BUNSPEC);
				  }
			       }
			       aux_3982 =
				  (obj_t) (node_3135);
			    }
			    break;
			 case ((long) 20):

			    {	/* Cfa/stack.scm 300 */
			       app_bglt node_3139;
			       node_3139 =
				  (app_bglt) (node_7);
			       stack___129_cfa_stack(
				  (((app_bglt) CREF(node_3139))->args));
			       aux_3982 =
				  (obj_t) (node_3139);
			    }
			    break;
			 default:
			  case_else2429_3027:
			    if (
			       PROCEDUREP(method2423_3023))
			      {		/* Cfa/stack.scm 122 */
				 aux_3982 =
				    PROCEDURE_ENTRY(method2423_3023) (method2423_3023,
				    (obj_t) (node_7), BEOA)
				    ;
			      }
			    else
			      {		/* Cfa/stack.scm 122 */
				 obj_t fun2422_3019;
				 fun2422_3019 =
				    PROCEDURE_REF(stack__env_104_cfa_stack, ((long) 0));
				 aux_3982 =
				    PROCEDURE_ENTRY(fun2422_3019) (fun2422_3019,
				    (obj_t) (node_7), BEOA);
			      }
			 }
		    }
		  else
		    {	/* Cfa/stack.scm 122 */
		       goto case_else2429_3027;
		    }
	       }
	       return
		  (node_bglt) (aux_3982);
	    }
	 }
      }
   }
}



/* _stack! */
obj_t 
_stack__205_cfa_stack(obj_t env_3728, obj_t node_3729)
{
   AN_OBJECT;
   {	/* Cfa/stack.scm 122 */
      {		/* Cfa/stack.scm 122 */
	 node_bglt aux_4181;
	 aux_4181 =
	    stack__132_cfa_stack(
	    (node_bglt) (node_3729));
	 return
	    (obj_t) (aux_4181);
      }
   }
}



/* stack!-default2081 */
node_bglt 
stack__default2081_166_cfa_stack(node_bglt node_8)
{
   AN_OBJECT;
   {	/* Cfa/stack.scm 14 */
      FAILURE(
	 CNST_TABLE_REF(((long) 3)), string2510_cfa_stack,
	 (obj_t) (node_8));
   }
}



/* _stack!-default2081 */
obj_t 
_stack__default2081_40_cfa_stack(obj_t env_3730, obj_t node_3731)
{
   AN_OBJECT;
   {	/* Cfa/stack.scm 14 */
      {		/* Cfa/stack.scm 14 */
	 node_bglt aux_4188;
	 aux_4188 =
	    stack__default2081_166_cfa_stack(
	    (node_bglt) (node_3731));
	 return
	    (obj_t) (aux_4188);
      }
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_cfa_stack()
{
   AN_OBJECT;
   {	/* Cfa/stack.scm 14 */
      module_initialization_70_tools_trace(((long) 0), "CFA_STACK");
      module_initialization_70_engine_param(((long) 0), "CFA_STACK");
      module_initialization_70_tools_speek(((long) 0), "CFA_STACK");
      module_initialization_70_tools_shape(((long) 0), "CFA_STACK");
      module_initialization_70_type_type(((long) 0), "CFA_STACK");
      module_initialization_70_ast_var(((long) 0), "CFA_STACK");
      module_initialization_70_ast_node(((long) 0), "CFA_STACK");
      module_initialization_70_cfa_info(((long) 0), "CFA_STACK");
      module_initialization_70_cfa_info2(((long) 0), "CFA_STACK");
      module_initialization_70_cfa_iterate(((long) 0), "CFA_STACK");
      module_initialization_70_cfa_loose(((long) 0), "CFA_STACK");
      module_initialization_70_inline_inline(((long) 0), "CFA_STACK");
      return
	 module_initialization_70_inline_walk(((long) 0), "CFA_STACK");
   }
}
