/*===========================================================================*/
/*   (Cfa/struct.scm)                                                        */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;

typedef struct approx
  {
     header_t header;
     obj_t widening;
     struct type *type;
     bool_t type_locked__184;
     obj_t allocs;
     bool_t top__138;
     long lost_stamp_114;
  }
      *approx_bglt;

typedef struct cfun_cinfo_200
  {
     struct approx *approx;
  }
              *cfun_cinfo_200_bglt;

typedef struct extern_sfun_cinfo_6
  {
     struct approx *approx;
  }
                   *extern_sfun_cinfo_6_bglt;

typedef struct intern_sfun_cinfo_192
  {
     struct approx *approx;
     long stamp;
  }
                     *intern_sfun_cinfo_192_bglt;

typedef struct scnst_cinfo_0
  {
     struct approx *approx;
  }
             *scnst_cinfo_0_bglt;

typedef struct pre_clo_env_191
  {
     char dummy;
  }
               *pre_clo_env_191_bglt;

typedef struct svar_cinfo_166
  {
     struct approx *approx;
     bool_t clo_env__87;
  }
              *svar_cinfo_166_bglt;

typedef struct cvar_cinfo_53
  {
     struct approx *approx;
  }
             *cvar_cinfo_53_bglt;

typedef struct sexit_cinfo_49
  {
     struct approx *approx;
  }
              *sexit_cinfo_49_bglt;

typedef struct reshaped_local_224
  {
     obj_t binding_value_3;
  }
                  *reshaped_local_224_bglt;

typedef struct reshaped_global_160
  {
     char dummy;
  }
                   *reshaped_global_160_bglt;

typedef struct atom_cinfo_155
  {
     struct approx *approx;
  }
              *atom_cinfo_155_bglt;

typedef struct kwote_node_102
  {
     struct node *node;
  }
              *kwote_node_102_bglt;

typedef struct kwote_cinfo_48
  {
     struct approx *approx;
  }
              *kwote_cinfo_48_bglt;

typedef struct app_ly_cinfo_234
  {
     struct approx *approx;
  }
                *app_ly_cinfo_234_bglt;

typedef struct funcall_cinfo_75
  {
     struct approx *approx;
     struct approx *va_approx_63;
     bool_t arity_error_noticed__118;
     bool_t type_error_noticed__36;
  }
                *funcall_cinfo_75_bglt;

typedef struct pragma_cinfo_220
  {
     struct approx *approx;
  }
                *pragma_cinfo_220_bglt;

typedef struct setq_cinfo_191
  {
     struct approx *approx;
  }
              *setq_cinfo_191_bglt;

typedef struct conditional_cinfo_212
  {
     struct approx *approx;
  }
                     *conditional_cinfo_212_bglt;

typedef struct fail_cinfo_75
  {
     struct approx *approx;
  }
             *fail_cinfo_75_bglt;

typedef struct select_cinfo_150
  {
     struct approx *approx;
  }
                *select_cinfo_150_bglt;

typedef struct set_ex_it_cinfo_168
  {
     struct approx *approx;
  }
                   *set_ex_it_cinfo_168_bglt;

typedef struct jump_ex_it_cinfo_139
  {
     struct approx *approx;
  }
                    *jump_ex_it_cinfo_139_bglt;

typedef struct pre_make_box_186
  {
     char dummy;
  }
                *pre_make_box_186_bglt;

typedef struct make_box_cinfo_127
  {
     struct approx *approx;
  }
                  *make_box_cinfo_127_bglt;

typedef struct make_box_o_cinfo_96
  {
     struct approx *approx;
     struct approx *value_approx_19;
  }
                   *make_box_o_cinfo_96_bglt;

typedef struct box_set__cinfo_94
  {
     struct approx *approx;
  }
                 *box_set__cinfo_94_bglt;

typedef struct box_ref_cinfo_214
  {
     struct approx *approx;
  }
                 *box_ref_cinfo_214_bglt;

typedef struct box_set__o_cinfo_6
  {
     struct approx *approx;
  }
                  *box_set__o_cinfo_6_bglt;

typedef struct box_ref_o_cinfo_98
  {
     struct approx *approx;
  }
                  *box_ref_o_cinfo_98_bglt;

typedef struct pre_make_procedure_app_60
  {
     struct variable *owner;
  }
                         *pre_make_procedure_app_60_bglt;

typedef struct pre_procedure_ref_app_85
  {
     char dummy;
  }
                        *pre_procedure_ref_app_85_bglt;

typedef struct pre_procedure_set__app_208
  {
     char dummy;
  }
                          *pre_procedure_set__app_208_bglt;

typedef struct make_procedure_app_48
  {
     struct approx *approx;
     long values_approx_len_106;
     struct approx **values_approx_79;
     long lost_stamp_114;
     bool_t x_t__142;
     bool_t x;
     bool_t t;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
  }
                     *make_procedure_app_48_bglt;

typedef struct procedure_ref_app_49
  {
     struct approx *approx;
  }
                    *procedure_ref_app_49_bglt;

typedef struct procedure_set__app_32
  {
     struct approx *approx;
  }
                     *procedure_set__app_32_bglt;

typedef struct pre_make_vector_app_251
  {
     struct variable *owner;
  }
                       *pre_make_vector_app_251_bglt;

typedef struct pre_create_vector_app_162
  {
     struct variable *owner;
  }
                         *pre_create_vector_app_162_bglt;

typedef struct pre_vector_ref_app_208
  {
     char dummy;
  }
                      *pre_vector_ref_app_208_bglt;

typedef struct pre_vector_set__app_211
  {
     char dummy;
  }
                       *pre_vector_set__app_211_bglt;

typedef struct make_vector_app_205
  {
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
     bool_t seen__39;
  }
                   *make_vector_app_205_bglt;

typedef struct create_vector_app_150
  {
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
     bool_t seen__39;
  }
                     *create_vector_app_150_bglt;

typedef struct vector_ref_app_195
  {
     struct approx *approx;
  }
                  *vector_ref_app_195_bglt;

typedef struct vector_set__app_21
  {
     struct approx *approx;
  }
                  *vector_set__app_21_bglt;

typedef struct pre_make_struct_app_218
  {
     struct variable *owner;
  }
                       *pre_make_struct_app_218_bglt;

typedef struct pre_struct_ref_app_207
  {
     char dummy;
  }
                      *pre_struct_ref_app_207_bglt;

typedef struct pre_struct_set__app_116
  {
     char dummy;
  }
                       *pre_struct_set__app_116_bglt;

typedef struct make_struct_app_214
  {
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
  }
                   *make_struct_app_214_bglt;

typedef struct struct_ref_app_73
  {
     struct approx *approx;
  }
                 *struct_ref_app_73_bglt;

typedef struct struct_set__app_162
  {
     struct approx *approx;
  }
                   *struct_set__app_162_bglt;


static obj_t method_init_76_cfa_struct();
extern obj_t pre_struct_set__app_116_cfa_info2;
extern obj_t pre_make_struct_app_218_cfa_info2;
static obj_t node_setup__pre_struct_ref_app2054_236_cfa_struct(obj_t, obj_t);
extern obj_t add_method__1___object(obj_t, obj_t, obj_t);
extern obj_t _obj__252_type_cache;
extern approx_bglt make_type_approx_184_cfa_approx(type_bglt);
extern approx_bglt make_empty_approx_131_cfa_approx();
static obj_t stack__make_struct_app2068_184_cfa_struct(obj_t, obj_t);
extern obj_t struct_set__app_162_cfa_info2;
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t _unspec__87_type_cache;
extern obj_t make_struct_app_214_cfa_info2;
extern obj_t module_initialization_70_cfa_struct(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_cfa_info(long, char *);
extern obj_t module_initialization_70_cfa_info2(long, char *);
extern obj_t module_initialization_70_cfa_loose(long, char *);
extern obj_t module_initialization_70_cfa_iterate(long, char *);
extern obj_t module_initialization_70_cfa_cfa(long, char *);
extern obj_t module_initialization_70_cfa_setup(long, char *);
extern obj_t module_initialization_70_cfa_approx(long, char *);
extern obj_t module_initialization_70_cfa_stack(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t pre_struct_ref_app_207_cfa_info2;
extern approx_bglt union_approx__241_cfa_approx(approx_bglt, approx_bglt);
static obj_t stack_loose_alloc__make_struct_app2066_164_cfa_struct(obj_t, obj_t, obj_t);
extern long class_num_218___object(obj_t);
extern obj_t node_setup___185_cfa_setup(obj_t);
static obj_t loose_alloc__make_struct_app2064_34_cfa_struct(obj_t, obj_t);
static obj_t imported_modules_init_94_cfa_struct();
extern obj_t stack_loose_alloc__95_cfa_loose(node_bglt, obj_t);
extern obj_t stack___129_cfa_stack(obj_t);
static obj_t cfa__struct_ref_app2060_84_cfa_struct(obj_t, obj_t);
extern obj_t approx_set_top__187_cfa_approx(approx_bglt);
static obj_t node_setup__pre_struct_set__app2056_37_cfa_struct(obj_t, obj_t);
static obj_t library_modules_init_112_cfa_struct();
static obj_t cfa__struct_set__app2062_212_cfa_struct(obj_t, obj_t);
extern approx_bglt cfa__102_cfa_cfa(node_bglt);
extern node_bglt node_heap__stack__239_cfa_stack(app_bglt, bool_t);
static obj_t node_setup__pre_make_struct_app2052_127_cfa_struct(obj_t, obj_t);
extern obj_t for_each_approx_alloc_83_cfa_approx(obj_t, approx_bglt);
static obj_t toplevel_init_63_cfa_struct();
static obj_t cfa__make_struct_app2058_33_cfa_struct(obj_t, obj_t);
extern obj_t open_input_string(obj_t);
extern obj_t struct_ref_app_73_cfa_info2;
extern obj_t approx_set_type__239_cfa_approx(approx_bglt, type_bglt);
extern obj_t variable_ast_var;
extern obj_t memq___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern obj_t _classes__134___object;
extern obj_t read___reader(obj_t);
static obj_t _anonymous_2391__127_cfa_struct(obj_t, obj_t);
static obj_t _anonymous_2388__79_cfa_struct(obj_t, obj_t);
static obj_t _anonymous_2368__254_cfa_struct(obj_t, obj_t);
extern obj_t _cfa_stamp__16_cfa_iterate;
static obj_t require_initialization_114_cfa_struct = BUNSPEC;
extern approx_bglt make_type_alloc_approx_134_cfa_approx(type_bglt, node_bglt);
extern approx_bglt loose__226_cfa_loose(approx_bglt, obj_t);
extern obj_t class_super_145___object(obj_t);
static obj_t _anonymous_2354__119_cfa_struct(obj_t, obj_t);
extern obj_t _struct__183_type_cache;
static obj_t cnst_init_137_cfa_struct();
static obj_t __cnst[1];

extern obj_t loose_alloc__env_83_cfa_loose;
DEFINE_STATIC_PROCEDURE(proc2419_cfa_struct, stack__make_struct_app2068_184_cfa_struct2426, stack__make_struct_app2068_184_cfa_struct, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2420_cfa_struct, _anonymous_2388__79_cfa_struct2427, _anonymous_2388__79_cfa_struct, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2418_cfa_struct, stack_loose_alloc__make_struct_app2066_164_cfa_struct2428, stack_loose_alloc__make_struct_app2066_164_cfa_struct, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2417_cfa_struct, loose_alloc__make_struct_app2064_34_cfa_struct2429, loose_alloc__make_struct_app2064_34_cfa_struct, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2416_cfa_struct, cfa__struct_set__app2062_212_cfa_struct2430, cfa__struct_set__app2062_212_cfa_struct, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2415_cfa_struct, cfa__struct_ref_app2060_84_cfa_struct2431, cfa__struct_ref_app2060_84_cfa_struct, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2414_cfa_struct, cfa__make_struct_app2058_33_cfa_struct2432, cfa__make_struct_app2058_33_cfa_struct, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2413_cfa_struct, node_setup__pre_struct_set__app2056_37_cfa_struct2433, node_setup__pre_struct_set__app2056_37_cfa_struct, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2412_cfa_struct, node_setup__pre_struct_ref_app2054_236_cfa_struct2434, node_setup__pre_struct_ref_app2054_236_cfa_struct, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2411_cfa_struct, node_setup__pre_make_struct_app2052_127_cfa_struct2435, node_setup__pre_make_struct_app2052_127_cfa_struct, 0L, 1);
extern obj_t cfa__env_153_cfa_cfa;
extern obj_t stack_loose_alloc__env_147_cfa_loose;
DEFINE_STRING(string2421_cfa_struct, string2421_cfa_struct2436, "ALL ", 4);
extern obj_t node_setup__env_214_cfa_setup;
extern obj_t stack__env_104_cfa_stack;



/* module-initialization */
obj_t 
module_initialization_70_cfa_struct(long checksum_3573, char *from_3574)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_cfa_struct))
	{
	   require_initialization_114_cfa_struct =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_cfa_struct();
	   cnst_init_137_cfa_struct();
	   imported_modules_init_94_cfa_struct();
	   method_init_76_cfa_struct();
	   toplevel_init_63_cfa_struct();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_cfa_struct()
{
   AN_OBJECT;
   {	/* Cfa/struct.scm 16 */
      module_initialization_70___object(((long) 0), "CFA_STRUCT");
      module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "CFA_STRUCT");
      module_initialization_70___reader(((long) 0), "CFA_STRUCT");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_cfa_struct()
{
   AN_OBJECT;
   {	/* Cfa/struct.scm 16 */
      {		/* Cfa/struct.scm 16 */
	 obj_t cnst_port_138_3566;
	 cnst_port_138_3566 =
	    open_input_string(string2421_cfa_struct);
	 {
	    long i_3567;
	    i_3567 = ((long) 0);
	  loop_3568:
	    {	/* Cfa/struct.scm 16 */
	       bool_t test2422_3569;
	       test2422_3569 =
		  (i_3567 == ((long) -1));
	       if (test2422_3569)
		 {	/* Cfa/struct.scm 16 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Cfa/struct.scm 16 */
		    {	/* Cfa/struct.scm 16 */
		       obj_t arg2423_3570;
		       {	/* Cfa/struct.scm 16 */
			  obj_t list2424_3571;
			  list2424_3571 =
			     MAKE_PAIR(cnst_port_138_3566, BNIL);
			  arg2423_3570 =
			     read___reader(list2424_3571);
		       }
		       CNST_TABLE_SET(i_3567, arg2423_3570);
		    }
		    {	/* Cfa/struct.scm 16 */
		       int aux_3572;
		       {	/* Cfa/struct.scm 16 */
			  long aux_3592;
			  aux_3592 =
			     (i_3567 - ((long) 1));
			  aux_3572 =
			     (int) (aux_3592);
		       }
		       {
			  long i_3595;
			  i_3595 =
			     (long) (aux_3572);
			  i_3567 = i_3595;
			  goto loop_3568;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_cfa_struct()
{
   AN_OBJECT;
   {	/* Cfa/struct.scm 16 */
      return BUNSPEC;
   }
}



/* method-init */
obj_t 
method_init_76_cfa_struct()
{
   AN_OBJECT;
   {	/* Cfa/struct.scm 16 */
      {		/* Cfa/struct.scm 16 */
	 obj_t node_setup__pre_make_struct_app2052_127_3526;
	 node_setup__pre_make_struct_app2052_127_3526 = proc2411_cfa_struct;
	 add_method__1___object(node_setup__env_214_cfa_setup, pre_make_struct_app_218_cfa_info2, node_setup__pre_make_struct_app2052_127_3526);
      }
      {		/* Cfa/struct.scm 16 */
	 obj_t node_setup__pre_struct_ref_app2054_236_3525;
	 node_setup__pre_struct_ref_app2054_236_3525 = proc2412_cfa_struct;
	 add_method__1___object(node_setup__env_214_cfa_setup, pre_struct_ref_app_207_cfa_info2, node_setup__pre_struct_ref_app2054_236_3525);
      }
      {		/* Cfa/struct.scm 16 */
	 obj_t node_setup__pre_struct_set__app2056_37_3524;
	 node_setup__pre_struct_set__app2056_37_3524 = proc2413_cfa_struct;
	 add_method__1___object(node_setup__env_214_cfa_setup, pre_struct_set__app_116_cfa_info2, node_setup__pre_struct_set__app2056_37_3524);
      }
      {		/* Cfa/struct.scm 16 */
	 obj_t cfa__make_struct_app2058_33_3523;
	 cfa__make_struct_app2058_33_3523 = proc2414_cfa_struct;
	 add_method__1___object(cfa__env_153_cfa_cfa, make_struct_app_214_cfa_info2, cfa__make_struct_app2058_33_3523);
      }
      {		/* Cfa/struct.scm 16 */
	 obj_t cfa__struct_ref_app2060_84_3522;
	 cfa__struct_ref_app2060_84_3522 = proc2415_cfa_struct;
	 add_method__1___object(cfa__env_153_cfa_cfa, struct_ref_app_73_cfa_info2, cfa__struct_ref_app2060_84_3522);
      }
      {		/* Cfa/struct.scm 16 */
	 obj_t cfa__struct_set__app2062_212_3520;
	 cfa__struct_set__app2062_212_3520 = proc2416_cfa_struct;
	 add_method__1___object(cfa__env_153_cfa_cfa, struct_set__app_162_cfa_info2, cfa__struct_set__app2062_212_3520);
      }
      {		/* Cfa/struct.scm 16 */
	 obj_t loose_alloc__make_struct_app2064_34_3516;
	 loose_alloc__make_struct_app2064_34_3516 = proc2417_cfa_struct;
	 add_method__1___object(loose_alloc__env_83_cfa_loose, make_struct_app_214_cfa_info2, loose_alloc__make_struct_app2064_34_3516);
      }
      {		/* Cfa/struct.scm 16 */
	 obj_t stack_loose_alloc__make_struct_app2066_164_3515;
	 stack_loose_alloc__make_struct_app2066_164_3515 = proc2418_cfa_struct;
	 add_method__1___object(stack_loose_alloc__env_147_cfa_loose, make_struct_app_214_cfa_info2, stack_loose_alloc__make_struct_app2066_164_3515);
      }
      {		/* Cfa/struct.scm 16 */
	 obj_t stack__make_struct_app2068_184_3512;
	 stack__make_struct_app2068_184_3512 = proc2419_cfa_struct;
	 return
	    add_method__1___object(stack__env_104_cfa_stack, make_struct_app_214_cfa_info2, stack__make_struct_app2068_184_3512);
      }
   }
}



/* stack!-make-struct-app2068 */
obj_t 
stack__make_struct_app2068_184_cfa_struct(obj_t env_3527, obj_t node_3528)
{
   AN_OBJECT;
   {	/* Cfa/struct.scm 173 */
      {
	 make_struct_app_214_bglt node_3014;
	 {	/* Cfa/struct.scm 174 */
	    node_bglt aux_3606;
	    node_3014 =
	       (make_struct_app_214_bglt) (node_3528);
	    {	/* Cfa/struct.scm 177 */
	       obj_t aux_3607;
	       {	/* Cfa/struct.scm 177 */
		  app_bglt obj_3507;
		  obj_3507 =
		     (app_bglt) (node_3014);
		  aux_3607 =
		     (((app_bglt) CREF(obj_3507))->args);
	       }
	       stack___129_cfa_stack(aux_3607);
	    }
	    {	/* Cfa/struct.scm 178 */
	       bool_t aux_3611;
	       {	/* Cfa/struct.scm 178 */
		  bool_t test_3613;
		  {	/* ./Ieee/fixnum.scm 7109 */
		     long aux_3614;
		     {
			obj_t aux_3615;
			{	/* ./Cfa/cinfo2.scm 1227 */
			   object_bglt aux_3616;
			   aux_3616 =
			      (object_bglt) (node_3014);
			   aux_3615 =
			      OBJECT_WIDENING(aux_3616);
			}
			aux_3614 =
			   (((make_struct_app_214_bglt) CREF(aux_3615))->lost_stamp_114);
		     }
		     test_3613 =
			(aux_3614 == ((long) -1));
		  }
		  if (test_3613)
		    {
		       obj_t aux_3621;
		       {	/* ./Cfa/cinfo2.scm 1232 */
			  object_bglt aux_3622;
			  aux_3622 =
			     (object_bglt) (node_3014);
			  aux_3621 =
			     OBJECT_WIDENING(aux_3622);
		       }
		       aux_3611 =
			  (((make_struct_app_214_bglt) CREF(aux_3621))->stackable__42);
		    }
		  else
		    {	/* Cfa/struct.scm 178 */
		       aux_3611 = ((bool_t) 0)
			  ;
		    }
	       }
	       aux_3606 =
		  node_heap__stack__239_cfa_stack(
		  (app_bglt) (node_3014), aux_3611);
	    }
	    return
	       (obj_t) (aux_3606);
	 }
      }
   }
}



/* stack-loose-alloc!-make-struct-app2066 */
obj_t 
stack_loose_alloc__make_struct_app2066_164_cfa_struct(obj_t env_3529, obj_t alloc_3530, obj_t cowner_3531)
{
   AN_OBJECT;
   {	/* Cfa/struct.scm 151 */
      {
	 make_struct_app_214_bglt alloc_2989;
	 obj_t cowner_2990;
	 alloc_2989 =
	    (make_struct_app_214_bglt) (alloc_3530);
	 cowner_2990 = cowner_3531;
	 {	/* Cfa/struct.scm 154 */
	    bool_t test_3629;
	    {	/* Cfa/struct.scm 154 */
	       bool_t test_3630;
	       {
		  obj_t aux_3631;
		  {	/* ./Cfa/cinfo2.scm 1232 */
		     object_bglt aux_3632;
		     aux_3632 =
			(object_bglt) (alloc_2989);
		     aux_3631 =
			OBJECT_WIDENING(aux_3632);
		  }
		  test_3630 =
		     (((make_struct_app_214_bglt) CREF(aux_3631))->stackable__42);
	       }
	       if (test_3630)
		 {	/* Cfa/struct.scm 154 */
		    obj_t aux_3636;
		    {	/* Cfa/struct.scm 154 */
		       obj_t aux_3637;
		       {
			  obj_t aux_3638;
			  {	/* ./Cfa/cinfo2.scm 1234 */
			     object_bglt aux_3639;
			     aux_3639 =
				(object_bglt) (alloc_2989);
			     aux_3638 =
				OBJECT_WIDENING(aux_3639);
			  }
			  aux_3637 =
			     (((make_struct_app_214_bglt) CREF(aux_3638))->stack_stamp_31);
		       }
		       aux_3636 =
			  memq___r4_pairs_and_lists_6_3(cowner_2990, aux_3637);
		    }
		    test_3629 =
		       CBOOL(aux_3636);
		 }
	       else
		 {	/* Cfa/struct.scm 154 */
		    test_3629 = ((bool_t) 1)
		       ;
		 }
	    }
	    if (test_3629)
	      {		/* Cfa/struct.scm 154 */
		 return BUNSPEC;
	      }
	    else
	      {		/* Cfa/struct.scm 154 */
		 {	/* Cfa/struct.scm 157 */
		    obj_t arg2383_2995;
		    {	/* ./Ieee/pair-list.scm 5689 */
		       obj_t aux_3645;
		       {
			  obj_t aux_3646;
			  {	/* ./Cfa/cinfo2.scm 1234 */
			     object_bglt aux_3647;
			     aux_3647 =
				(object_bglt) (alloc_2989);
			     aux_3646 =
				OBJECT_WIDENING(aux_3647);
			  }
			  aux_3645 =
			     (((make_struct_app_214_bglt) CREF(aux_3646))->stack_stamp_31);
		       }
		       arg2383_2995 =
			  MAKE_PAIR(cowner_2990, aux_3645);
		    }
		    {
		       obj_t aux_3652;
		       {	/* ./Cfa/cinfo2.scm 1234 */
			  object_bglt aux_3653;
			  aux_3653 =
			     (object_bglt) (alloc_2989);
			  aux_3652 =
			     OBJECT_WIDENING(aux_3653);
		       }
		       ((((make_struct_app_214_bglt) CREF(aux_3652))->stack_stamp_31) = ((obj_t) arg2383_2995), BUNSPEC);
		    }
		 }
		 {	/* Cfa/struct.scm 158 */
		    bool_t test2385_2997;
		    {	/* Cfa/struct.scm 158 */
		       bool_t test2392_3008;
		       test2392_3008 =
			  is_a__118___object(cowner_2990, variable_ast_var);
		       if (test2392_3008)
			 {	/* ./Ieee/equiv.scm 5508 */
			    obj_t aux_3659;
			    {	/* Cfa/struct.scm 158 */
			       variable_bglt aux_3660;
			       {
				  obj_t aux_3661;
				  {	/* ./Cfa/cinfo2.scm 1229 */
				     object_bglt aux_3662;
				     aux_3662 =
					(object_bglt) (alloc_2989);
				     aux_3661 =
					OBJECT_WIDENING(aux_3662);
				  }
				  aux_3660 =
				     (((make_struct_app_214_bglt) CREF(aux_3661))->owner);
			       }
			       aux_3659 =
				  (obj_t) (aux_3660);
			    }
			    test2385_2997 =
			       (aux_3659 == cowner_2990);
			 }
		       else
			 {	/* Cfa/struct.scm 158 */
			    test2385_2997 = ((bool_t) 1);
			 }
		    }
		    if (test2385_2997)
		      {		/* Cfa/struct.scm 158 */
			 {
			    obj_t aux_3669;
			    {	/* ./Cfa/cinfo2.scm 1232 */
			       object_bglt aux_3670;
			       aux_3670 =
				  (object_bglt) (alloc_2989);
			       aux_3669 =
				  OBJECT_WIDENING(aux_3670);
			    }
			    ((((make_struct_app_214_bglt) CREF(aux_3669))->stackable__42) = ((bool_t) ((bool_t) 0)), BUNSPEC);
			 }
			 {	/* Cfa/struct.scm 163 */
			    approx_bglt arg2387_2999;
			    {
			       obj_t aux_3674;
			       {	/* ./Cfa/cinfo2.scm 1225 */
				  object_bglt aux_3675;
				  aux_3675 =
				     (object_bglt) (alloc_2989);
				  aux_3674 =
				     OBJECT_WIDENING(aux_3675);
			       }
			       arg2387_2999 =
				  (((make_struct_app_214_bglt) CREF(aux_3674))->value_approx_19);
			    }
			    {	/* Cfa/struct.scm 164 */
			       obj_t _anonymous_2388__79_3513;
			       _anonymous_2388__79_3513 = proc2420_cfa_struct;
			       return
				  for_each_approx_alloc_83_cfa_approx(_anonymous_2388__79_3513, arg2387_2999);
			    }
			 }
		      }
		    else
		      {		/* Cfa/struct.scm 166 */
			 approx_bglt arg2390_3004;
			 {
			    obj_t aux_3680;
			    {	/* ./Cfa/cinfo2.scm 1225 */
			       object_bglt aux_3681;
			       aux_3681 =
				  (object_bglt) (alloc_2989);
			       aux_3680 =
				  OBJECT_WIDENING(aux_3681);
			    }
			    arg2390_3004 =
			       (((make_struct_app_214_bglt) CREF(aux_3680))->value_approx_19);
			 }
			 {	/* Cfa/struct.scm 167 */
			    obj_t _anonymous_2391__127_3514;
			    _anonymous_2391__127_3514 =
			       make_fx_procedure(_anonymous_2391__127_cfa_struct, ((long) 1), ((long) 1));
			    PROCEDURE_SET(_anonymous_2391__127_3514, ((long) 0), cowner_2990);
			    return
			       for_each_approx_alloc_83_cfa_approx(_anonymous_2391__127_3514, arg2390_3004);
			 }
		      }
		 }
	      }
	 }
      }
   }
}



/* <anonymous:2388> */
obj_t 
_anonymous_2388__79_cfa_struct(obj_t env_3532, obj_t alloc_3533)
{
   AN_OBJECT;
   {	/* Cfa/struct.scm 163 */
      {
	 obj_t alloc_3000;
	 alloc_3000 = alloc_3533;
	 return
	    stack_loose_alloc__95_cfa_loose(
	    (node_bglt) (alloc_3000),
	    CNST_TABLE_REF(((long) 0)));
      }
   }
}



/* <anonymous:2391> */
obj_t 
_anonymous_2391__127_cfa_struct(obj_t env_3534, obj_t alloc_3536)
{
   AN_OBJECT;
   {	/* Cfa/struct.scm 166 */
      {		/* Cfa/struct.scm 167 */
	 obj_t cowner_3535;
	 cowner_3535 =
	    PROCEDURE_REF(env_3534, ((long) 0));
	 {
	    obj_t alloc_3005;
	    alloc_3005 = alloc_3536;
	    return
	       stack_loose_alloc__95_cfa_loose(
	       (node_bglt) (alloc_3005), cowner_3535);
	 }
      }
   }
}



/* loose-alloc!-make-struct-app2064 */
obj_t 
loose_alloc__make_struct_app2064_34_cfa_struct(obj_t env_3537, obj_t alloc_3538)
{
   AN_OBJECT;
   {	/* Cfa/struct.scm 136 */
      {
	 make_struct_app_214_bglt alloc_2978;
	 alloc_2978 =
	    (make_struct_app_214_bglt) (alloc_3538);
	 {	/* Cfa/struct.scm 138 */
	    bool_t test2376_2982;
	    {	/* Cfa/struct.scm 138 */
	       long arg2380_2986;
	       {
		  obj_t aux_3695;
		  {	/* ./Cfa/cinfo2.scm 1227 */
		     object_bglt aux_3696;
		     aux_3696 =
			(object_bglt) (alloc_2978);
		     aux_3695 =
			OBJECT_WIDENING(aux_3696);
		  }
		  arg2380_2986 =
		     (((make_struct_app_214_bglt) CREF(aux_3695))->lost_stamp_114);
	       }
	       {	/* Cfa/struct.scm 138 */
		  long n2_3484;
		  n2_3484 =
		     (long) CINT(_cfa_stamp__16_cfa_iterate);
		  test2376_2982 =
		     (arg2380_2986 == n2_3484);
	       }
	    }
	    if (test2376_2982)
	      {		/* Cfa/struct.scm 138 */
		 return BUNSPEC;
	      }
	    else
	      {		/* Cfa/struct.scm 138 */
		 {	/* Cfa/struct.scm 142 */
		    long val1992_3486;
		    val1992_3486 =
		       (long) CINT(_cfa_stamp__16_cfa_iterate);
		    {
		       obj_t aux_3704;
		       {	/* ./Cfa/cinfo2.scm 1227 */
			  object_bglt aux_3705;
			  aux_3705 =
			     (object_bglt) (alloc_2978);
			  aux_3704 =
			     OBJECT_WIDENING(aux_3705);
		       }
		       ((((make_struct_app_214_bglt) CREF(aux_3704))->lost_stamp_114) = ((long) val1992_3486), BUNSPEC);
		    }
		 }
		 {
		    obj_t aux_3709;
		    {	/* ./Cfa/cinfo2.scm 1232 */
		       object_bglt aux_3710;
		       aux_3710 =
			  (object_bglt) (alloc_2978);
		       aux_3709 =
			  OBJECT_WIDENING(aux_3710);
		    }
		    ((((make_struct_app_214_bglt) CREF(aux_3709))->stackable__42) = ((bool_t) ((bool_t) 0)), BUNSPEC);
		 }
		 {	/* Cfa/struct.scm 144 */
		    approx_bglt aux_3714;
		    {
		       obj_t aux_3715;
		       {	/* ./Cfa/cinfo2.scm 1225 */
			  object_bglt aux_3716;
			  aux_3716 =
			     (object_bglt) (alloc_2978);
			  aux_3715 =
			     OBJECT_WIDENING(aux_3716);
		       }
		       aux_3714 =
			  (((make_struct_app_214_bglt) CREF(aux_3715))->value_approx_19);
		    }
		    for_each_approx_alloc_83_cfa_approx(loose_alloc__env_83_cfa_loose, aux_3714);
		 }
		 {	/* Cfa/struct.scm 145 */
		    approx_bglt aux_3721;
		    {
		       obj_t aux_3722;
		       {	/* ./Cfa/cinfo2.scm 1225 */
			  object_bglt aux_3723;
			  aux_3723 =
			     (object_bglt) (alloc_2978);
			  aux_3722 =
			     OBJECT_WIDENING(aux_3723);
		       }
		       aux_3721 =
			  (((make_struct_app_214_bglt) CREF(aux_3722))->value_approx_19);
		    }
		    approx_set_type__239_cfa_approx(aux_3721,
		       (type_bglt) (_obj__252_type_cache));
		 }
		 {	/* Cfa/struct.scm 146 */
		    approx_bglt aux_3729;
		    {
		       obj_t aux_3730;
		       {	/* ./Cfa/cinfo2.scm 1225 */
			  object_bglt aux_3731;
			  aux_3731 =
			     (object_bglt) (alloc_2978);
			  aux_3730 =
			     OBJECT_WIDENING(aux_3731);
		       }
		       aux_3729 =
			  (((make_struct_app_214_bglt) CREF(aux_3730))->value_approx_19);
		    }
		    return
		       approx_set_top__187_cfa_approx(aux_3729);
		 }
	      }
	 }
      }
   }
}



/* cfa!-struct-set!-app2062 */
obj_t 
cfa__struct_set__app2062_212_cfa_struct(obj_t env_3539, obj_t node_3540)
{
   AN_OBJECT;
   {	/* Cfa/struct.scm 109 */
      {
	 struct_set__app_162_bglt node_2956;
	 {	/* Cfa/struct.scm 110 */
	    approx_bglt aux_3737;
	    node_2956 =
	       (struct_set__app_162_bglt) (node_3540);
	    {	/* Cfa/struct.scm 113 */
	       node_bglt aux_3738;
	       {	/* Cfa/struct.scm 113 */
		  obj_t aux_3739;
		  {	/* ./Ieee/pair-list.scm 5701 */
		     obj_t aux_3740;
		     {	/* ./Ieee/pair-list.scm 5707 */
			obj_t aux_3741;
			{	/* Cfa/struct.scm 113 */
			   app_bglt obj_3464;
			   obj_3464 =
			      (app_bglt) (node_2956);
			   aux_3741 =
			      (((app_bglt) CREF(obj_3464))->args);
			}
			aux_3740 =
			   CDR(aux_3741);
		     }
		     aux_3739 =
			CAR(aux_3740);
		  }
		  aux_3738 =
		     (node_bglt) (aux_3739);
	       }
	       cfa__102_cfa_cfa(aux_3738);
	    }
	    {	/* Cfa/struct.scm 114 */
	       approx_bglt struct_approx_51_2962;
	       approx_bglt val_approx_22_2963;
	       {	/* Cfa/struct.scm 114 */
		  node_bglt aux_3748;
		  {	/* Cfa/struct.scm 114 */
		     obj_t aux_3749;
		     {	/* ./Ieee/pair-list.scm 5701 */
			obj_t aux_3750;
			{	/* Cfa/struct.scm 114 */
			   app_bglt obj_3469;
			   obj_3469 =
			      (app_bglt) (node_2956);
			   aux_3750 =
			      (((app_bglt) CREF(obj_3469))->args);
			}
			aux_3749 =
			   CAR(aux_3750);
		     }
		     aux_3748 =
			(node_bglt) (aux_3749);
		  }
		  struct_approx_51_2962 =
		     cfa__102_cfa_cfa(aux_3748);
	       }
	       {	/* Cfa/struct.scm 115 */
		  node_bglt aux_3756;
		  {	/* Cfa/struct.scm 115 */
		     obj_t aux_3757;
		     {	/* ./Ieee/pair-list.scm 5701 */
			obj_t aux_3758;
			{	/* ./Ieee/pair-list.scm 5707 */
			   obj_t aux_3759;
			   {	/* ./Ieee/pair-list.scm 5707 */
			      obj_t aux_3760;
			      {		/* Cfa/struct.scm 115 */
				 app_bglt obj_3471;
				 obj_3471 =
				    (app_bglt) (node_2956);
				 aux_3760 =
				    (((app_bglt) CREF(obj_3471))->args);
			      }
			      aux_3759 =
				 CDR(aux_3760);
			   }
			   aux_3758 =
			      CDR(aux_3759);
			}
			aux_3757 =
			   CAR(aux_3758);
		     }
		     aux_3756 =
			(node_bglt) (aux_3757);
		  }
		  val_approx_22_2963 =
		     cfa__102_cfa_cfa(aux_3756);
	       }
	       if (
		  (((approx_bglt) CREF(struct_approx_51_2962))->top__138))
		 {	/* Cfa/struct.scm 120 */
		    approx_bglt aux_3770;
		    aux_3770 =
		       loose__226_cfa_loose(val_approx_22_2963,
		       CNST_TABLE_REF(((long) 0)));
		    (obj_t) (aux_3770);
		 }
	       else
		 {	/* Cfa/struct.scm 123 */
		    obj_t _anonymous_2368__254_3519;
		    _anonymous_2368__254_3519 =
		       make_fx_procedure(_anonymous_2368__254_cfa_struct, ((long) 1), ((long) 1));
		    {	/* Cfa/struct.scm 123 */
		       obj_t aux_3775;
		       aux_3775 =
			  (obj_t) (val_approx_22_2963);
		       PROCEDURE_SET(_anonymous_2368__254_3519, ((long) 0), aux_3775);
		    }
		    for_each_approx_alloc_83_cfa_approx(_anonymous_2368__254_3519, struct_approx_51_2962);
		 }
	    }
	    {
	       obj_t aux_3779;
	       {	/* ./Cfa/cinfo2.scm 1237 */
		  object_bglt aux_3780;
		  aux_3780 =
		     (object_bglt) (node_2956);
		  aux_3779 =
		     OBJECT_WIDENING(aux_3780);
	       }
	       aux_3737 =
		  (((struct_set__app_162_bglt) CREF(aux_3779))->approx);
	    }
	    return
	       (obj_t) (aux_3737);
	 }
      }
   }
}



/* <anonymous:2368> */
obj_t 
_anonymous_2368__254_cfa_struct(obj_t env_3541, obj_t app_3543)
{
   AN_OBJECT;
   {	/* Cfa/struct.scm 122 */
      {		/* Cfa/struct.scm 123 */
	 obj_t val_approx_22_3542;
	 val_approx_22_3542 =
	    PROCEDURE_REF(env_3541, ((long) 0));
	 {
	    obj_t app_2966;
	    app_2966 = app_3543;
	    {	/* Cfa/struct.scm 123 */
	       bool_t test2369_2968;
	       test2369_2968 =
		  is_a__118___object(app_2966, make_struct_app_214_cfa_info2);
	       if (test2369_2968)
		 {	/* Cfa/struct.scm 125 */
		    approx_bglt aux_3789;
		    {	/* Cfa/struct.scm 125 */
		       approx_bglt aux_3790;
		       {	/* Cfa/struct.scm 125 */
			  make_struct_app_214_bglt obj_3480;
			  obj_3480 =
			     (make_struct_app_214_bglt) (app_2966);
			  {
			     obj_t aux_3792;
			     {	/* ./Cfa/cinfo2.scm 1225 */
				object_bglt aux_3793;
				aux_3793 =
				   (object_bglt) (obj_3480);
				aux_3792 =
				   OBJECT_WIDENING(aux_3793);
			     }
			     aux_3790 =
				(((make_struct_app_214_bglt) CREF(aux_3792))->value_approx_19);
			  }
		       }
		       aux_3789 =
			  union_approx__241_cfa_approx(aux_3790,
			  (approx_bglt) (val_approx_22_3542));
		    }
		    return
		       (obj_t) (aux_3789);
		 }
	       else
		 {	/* Cfa/struct.scm 123 */
		    return BUNSPEC;
		 }
	    }
	 }
      }
   }
}



/* cfa!-struct-ref-app2060 */
obj_t 
cfa__struct_ref_app2060_84_cfa_struct(obj_t env_3544, obj_t node_3545)
{
   AN_OBJECT;
   {	/* Cfa/struct.scm 87 */
      {
	 struct_ref_app_73_bglt node_2932;
	 {	/* Cfa/struct.scm 88 */
	    approx_bglt aux_3800;
	    node_2932 =
	       (struct_ref_app_73_bglt) (node_3545);
	    {	/* Cfa/struct.scm 91 */
	       node_bglt aux_3801;
	       {	/* Cfa/struct.scm 91 */
		  obj_t aux_3802;
		  {	/* ./Ieee/pair-list.scm 5701 */
		     obj_t aux_3803;
		     {	/* ./Ieee/pair-list.scm 5707 */
			obj_t aux_3804;
			{	/* Cfa/struct.scm 91 */
			   app_bglt obj_3448;
			   obj_3448 =
			      (app_bglt) (node_2932);
			   aux_3804 =
			      (((app_bglt) CREF(obj_3448))->args);
			}
			aux_3803 =
			   CDR(aux_3804);
		     }
		     aux_3802 =
			CAR(aux_3803);
		  }
		  aux_3801 =
		     (node_bglt) (aux_3802);
	       }
	       cfa__102_cfa_cfa(aux_3801);
	    }
	    {	/* Cfa/struct.scm 92 */
	       approx_bglt struct_approx_51_2938;
	       {	/* Cfa/struct.scm 92 */
		  node_bglt aux_3811;
		  {	/* Cfa/struct.scm 92 */
		     obj_t aux_3812;
		     {	/* ./Ieee/pair-list.scm 5701 */
			obj_t aux_3813;
			{	/* Cfa/struct.scm 92 */
			   app_bglt obj_3453;
			   obj_3453 =
			      (app_bglt) (node_2932);
			   aux_3813 =
			      (((app_bglt) CREF(obj_3453))->args);
			}
			aux_3812 =
			   CAR(aux_3813);
		     }
		     aux_3811 =
			(node_bglt) (aux_3812);
		  }
		  struct_approx_51_2938 =
		     cfa__102_cfa_cfa(aux_3811);
	       }
	       if (
		  (((approx_bglt) CREF(struct_approx_51_2938))->top__138))
		 {	/* Cfa/struct.scm 96 */
		    approx_bglt aux_3821;
		    {
		       obj_t aux_3822;
		       {	/* ./Cfa/cinfo2.scm 1236 */
			  object_bglt aux_3823;
			  aux_3823 =
			     (object_bglt) (node_2932);
			  aux_3822 =
			     OBJECT_WIDENING(aux_3823);
		       }
		       aux_3821 =
			  (((struct_ref_app_73_bglt) CREF(aux_3822))->approx);
		    }
		    approx_set_top__187_cfa_approx(aux_3821);
		 }
	       else
		 {	/* Cfa/struct.scm 95 */
		    BUNSPEC;
		 }
	       {	/* Cfa/struct.scm 99 */
		  obj_t _anonymous_2354__119_3521;
		  _anonymous_2354__119_3521 =
		     make_fx_procedure(_anonymous_2354__119_cfa_struct, ((long) 1), ((long) 1));
		  {	/* Cfa/struct.scm 99 */
		     obj_t aux_3829;
		     aux_3829 =
			(obj_t) (node_2932);
		     PROCEDURE_SET(_anonymous_2354__119_3521, ((long) 0), aux_3829);
		  }
		  for_each_approx_alloc_83_cfa_approx(_anonymous_2354__119_3521, struct_approx_51_2938);
	       }
	    }
	    {
	       obj_t aux_3833;
	       {	/* ./Cfa/cinfo2.scm 1236 */
		  object_bglt aux_3834;
		  aux_3834 =
		     (object_bglt) (node_2932);
		  aux_3833 =
		     OBJECT_WIDENING(aux_3834);
	       }
	       aux_3800 =
		  (((struct_ref_app_73_bglt) CREF(aux_3833))->approx);
	    }
	    return
	       (obj_t) (aux_3800);
	 }
      }
   }
}



/* <anonymous:2354> */
obj_t 
_anonymous_2354__119_cfa_struct(obj_t env_3546, obj_t app_3548)
{
   AN_OBJECT;
   {	/* Cfa/struct.scm 98 */
      {		/* Cfa/struct.scm 99 */
	 obj_t instance2042_3547;
	 instance2042_3547 =
	    PROCEDURE_REF(env_3546, ((long) 0));
	 {
	    obj_t app_2942;
	    app_2942 = app_3548;
	    {	/* Cfa/struct.scm 99 */
	       bool_t test2355_2944;
	       test2355_2944 =
		  is_a__118___object(app_2942, make_struct_app_214_cfa_info2);
	       if (test2355_2944)
		 {	/* Cfa/struct.scm 99 */
		    {	/* Cfa/struct.scm 101 */
		       approx_bglt aux_3850;
		       approx_bglt aux_3843;
		       {	/* Cfa/struct.scm 101 */
			  make_struct_app_214_bglt obj_3459;
			  obj_3459 =
			     (make_struct_app_214_bglt) (app_2942);
			  {
			     obj_t aux_3852;
			     {	/* ./Cfa/cinfo2.scm 1225 */
				object_bglt aux_3853;
				aux_3853 =
				   (object_bglt) (obj_3459);
				aux_3852 =
				   OBJECT_WIDENING(aux_3853);
			     }
			     aux_3850 =
				(((make_struct_app_214_bglt) CREF(aux_3852))->value_approx_19);
			  }
		       }
		       {	/* Cfa/struct.scm 101 */
			  struct_ref_app_73_bglt obj_3458;
			  obj_3458 =
			     (struct_ref_app_73_bglt) (instance2042_3547);
			  {
			     obj_t aux_3845;
			     {	/* ./Cfa/cinfo2.scm 1236 */
				object_bglt aux_3846;
				aux_3846 =
				   (object_bglt) (obj_3458);
				aux_3845 =
				   OBJECT_WIDENING(aux_3846);
			     }
			     aux_3843 =
				(((struct_ref_app_73_bglt) CREF(aux_3845))->approx);
			  }
		       }
		       union_approx__241_cfa_approx(aux_3843, aux_3850);
		    }
		    {	/* Cfa/struct.scm 102 */
		       type_bglt aux_3865;
		       approx_bglt aux_3858;
		       {	/* Cfa/struct.scm 102 */
			  approx_bglt arg2360_2950;
			  {	/* Cfa/struct.scm 102 */
			     struct_ref_app_73_bglt obj_3461;
			     obj_3461 =
				(struct_ref_app_73_bglt) (instance2042_3547);
			     {
				obj_t aux_3867;
				{	/* ./Cfa/cinfo2.scm 1236 */
				   object_bglt aux_3868;
				   aux_3868 =
				      (object_bglt) (obj_3461);
				   aux_3867 =
				      OBJECT_WIDENING(aux_3868);
				}
				arg2360_2950 =
				   (((struct_ref_app_73_bglt) CREF(aux_3867))->approx);
			     }
			  }
			  aux_3865 =
			     (((approx_bglt) CREF(arg2360_2950))->type);
		       }
		       {	/* Cfa/struct.scm 102 */
			  make_struct_app_214_bglt obj_3460;
			  obj_3460 =
			     (make_struct_app_214_bglt) (app_2942);
			  {
			     obj_t aux_3860;
			     {	/* ./Cfa/cinfo2.scm 1225 */
				object_bglt aux_3861;
				aux_3861 =
				   (object_bglt) (obj_3460);
				aux_3860 =
				   OBJECT_WIDENING(aux_3861);
			     }
			     aux_3858 =
				(((make_struct_app_214_bglt) CREF(aux_3860))->value_approx_19);
			  }
		       }
		       return
			  approx_set_type__239_cfa_approx(aux_3858, aux_3865);
		    }
		 }
	       else
		 {	/* Cfa/struct.scm 99 */
		    return BUNSPEC;
		 }
	    }
	 }
      }
   }
}



/* cfa!-make-struct-app2058 */
obj_t 
cfa__make_struct_app2058_33_cfa_struct(obj_t env_3549, obj_t node_3550)
{
   AN_OBJECT;
   {	/* Cfa/struct.scm 71 */
      {
	 make_struct_app_214_bglt node_2920;
	 {	/* Cfa/struct.scm 72 */
	    approx_bglt aux_3874;
	    node_2920 =
	       (make_struct_app_214_bglt) (node_3550);
	    {	/* Cfa/struct.scm 74 */
	       node_bglt aux_3875;
	       {	/* Cfa/struct.scm 74 */
		  obj_t aux_3876;
		  {	/* ./Ieee/pair-list.scm 5701 */
		     obj_t aux_3877;
		     {	/* Cfa/struct.scm 74 */
			app_bglt obj_3439;
			obj_3439 =
			   (app_bglt) (node_2920);
			aux_3877 =
			   (((app_bglt) CREF(obj_3439))->args);
		     }
		     aux_3876 =
			CAR(aux_3877);
		  }
		  aux_3875 =
		     (node_bglt) (aux_3876);
	       }
	       cfa__102_cfa_cfa(aux_3875);
	    }
	    {	/* Cfa/struct.scm 75 */
	       approx_bglt init_value_approx_9_2926;
	       {	/* Cfa/struct.scm 75 */
		  node_bglt aux_3883;
		  {	/* Cfa/struct.scm 75 */
		     obj_t aux_3884;
		     {	/* ./Ieee/pair-list.scm 5701 */
			obj_t aux_3885;
			{	/* ./Ieee/pair-list.scm 5707 */
			   obj_t aux_3886;
			   {	/* Cfa/struct.scm 75 */
			      app_bglt obj_3441;
			      obj_3441 =
				 (app_bglt) (node_2920);
			      aux_3886 =
				 (((app_bglt) CREF(obj_3441))->args);
			   }
			   aux_3885 =
			      CDR(aux_3886);
			}
			aux_3884 =
			   CAR(aux_3885);
		     }
		     aux_3883 =
			(node_bglt) (aux_3884);
		  }
		  init_value_approx_9_2926 =
		     cfa__102_cfa_cfa(aux_3883);
	       }
	       {	/* Cfa/struct.scm 76 */
		  approx_bglt aux_3893;
		  {
		     obj_t aux_3894;
		     {	/* ./Cfa/cinfo2.scm 1225 */
			object_bglt aux_3895;
			aux_3895 =
			   (object_bglt) (node_2920);
			aux_3894 =
			   OBJECT_WIDENING(aux_3895);
		     }
		     aux_3893 =
			(((make_struct_app_214_bglt) CREF(aux_3894))->value_approx_19);
		  }
		  union_approx__241_cfa_approx(aux_3893, init_value_approx_9_2926);
	       }
	       {
		  obj_t aux_3900;
		  {	/* ./Cfa/cinfo2.scm 1221 */
		     object_bglt aux_3901;
		     aux_3901 =
			(object_bglt) (node_2920);
		     aux_3900 =
			OBJECT_WIDENING(aux_3901);
		  }
		  aux_3874 =
		     (((make_struct_app_214_bglt) CREF(aux_3900))->approx);
	       }
	    }
	    return
	       (obj_t) (aux_3874);
	 }
      }
   }
}



/* node-setup!-pre-struct-set!-app2056 */
obj_t 
node_setup__pre_struct_set__app2056_37_cfa_struct(obj_t env_3551, obj_t node_3552)
{
   AN_OBJECT;
   {	/* Cfa/struct.scm 62 */
      {
	 pre_struct_set__app_116_bglt node_2904;
	 {	/* Cfa/struct.scm 63 */
	    struct_set__app_162_bglt aux_3907;
	    node_2904 =
	       (pre_struct_set__app_116_bglt) (node_3552);
	    {	/* Cfa/struct.scm 64 */
	       obj_t aux_3908;
	       {	/* Cfa/struct.scm 64 */
		  app_bglt obj_3421;
		  obj_3421 =
		     (app_bglt) (node_2904);
		  aux_3908 =
		     (((app_bglt) CREF(obj_3421))->args);
	       }
	       node_setup___185_cfa_setup(aux_3908);
	    }
	    {	/* Cfa/struct.scm 65 */
	       pre_struct_set__app_116_bglt node_2909;
	       {	/* Cfa/struct.scm 65 */
		  long arg2339_2915;
		  {	/* Cfa/struct.scm 65 */
		     obj_t arg2340_2916;
		     {	/* Cfa/struct.scm 65 */
			obj_t arg2341_2917;
			{	/* Cfa/struct.scm 65 */
			   object_bglt object_3422;
			   object_3422 =
			      (object_bglt) (node_2904);
			   {	/* ./Llib/object.scm 2695 */
			      long arg1179_3423;
			      {		/* ./Llib/object.scm 2695 */
				 long arg1180_3424;
				 long arg1181_3425;
				 arg1180_3424 =
				    TYPE(object_3422);
				 arg1181_3425 =
				    OBJECT_TYPE;
				 arg1179_3423 =
				    (arg1180_3424 - arg1181_3425);
			      }
			      {		/* ./Llib/object.scm 2695 */
				 obj_t vector_3429;
				 vector_3429 = _classes__134___object;
				 arg2341_2917 =
				    VECTOR_REF(vector_3429, arg1179_3423);
			      }
			   }
			}
			arg2340_2916 =
			   class_super_145___object(arg2341_2917);
		     }
		     arg2339_2915 =
			class_num_218___object(arg2340_2916);
		  }
		  {	/* Cfa/struct.scm 65 */
		     obj_t obj_3431;
		     obj_3431 =
			(obj_t) (node_2904);
		     (((obj_t) CREF(obj_3431))->header = MAKE_HEADER(arg2339_2915, 0), BUNSPEC);
		  }
	       }
	       {	/* Cfa/struct.scm 65 */
		  object_bglt aux_3921;
		  aux_3921 =
		     (object_bglt) (node_2904);
		  OBJECT_WIDENING_SET(aux_3921, BFALSE);
	       }
	       node_2909 = node_2904;
	       {	/* Cfa/struct.scm 66 */
		  struct_set__app_162_bglt obj2040_2910;
		  obj2040_2910 =
		     ((struct_set__app_162_bglt) (node_2909));
		  {	/* Cfa/struct.scm 66 */
		     struct_set__app_162_bglt arg2336_2911;
		     {	/* Cfa/struct.scm 66 */
			approx_bglt arg2337_2912;
			arg2337_2912 =
			   make_type_approx_184_cfa_approx(
			   (type_bglt) (_unspec__87_type_cache));
			{	/* Cfa/struct.scm 66 */
			   struct_set__app_162_bglt res2404_3436;
			   {	/* ./Cfa/cinfo2.scm 1237 */
			      struct_set__app_162_bglt new2025_3434;
			      new2025_3434 =
				 ((struct_set__app_162_bglt) BREF(GC_MALLOC(sizeof(struct struct_set__app_162))));
			      ((((struct_set__app_162_bglt) CREF(new2025_3434))->approx) = ((approx_bglt) arg2337_2912), BUNSPEC);
			      res2404_3436 = new2025_3434;
			   }
			   arg2336_2911 = res2404_3436;
			}
		     }
		     {	/* Cfa/struct.scm 66 */
			obj_t aux_3931;
			object_bglt aux_3929;
			aux_3931 =
			   (obj_t) (arg2336_2911);
			aux_3929 =
			   (object_bglt) (obj2040_2910);
			OBJECT_WIDENING_SET(aux_3929, aux_3931);
		     }
		  }
		  {	/* Cfa/struct.scm 66 */
		     long arg2338_2913;
		     arg2338_2913 =
			class_num_218___object(struct_set__app_162_cfa_info2);
		     {	/* Cfa/struct.scm 66 */
			obj_t obj_3437;
			obj_3437 =
			   (obj_t) (obj2040_2910);
			(((obj_t) CREF(obj_3437))->header = MAKE_HEADER(arg2338_2913, 0), BUNSPEC);
		     }
		  }
		  aux_3907 = obj2040_2910;
	       }
	    }
	    return
	       (obj_t) (aux_3907);
	 }
      }
   }
}



/* node-setup!-pre-struct-ref-app2054 */
obj_t 
node_setup__pre_struct_ref_app2054_236_cfa_struct(obj_t env_3553, obj_t node_3554)
{
   AN_OBJECT;
   {	/* Cfa/struct.scm 53 */
      {
	 pre_struct_ref_app_207_bglt node_2888;
	 {	/* Cfa/struct.scm 54 */
	    struct_ref_app_73_bglt aux_3939;
	    node_2888 =
	       (pre_struct_ref_app_207_bglt) (node_3554);
	    {	/* Cfa/struct.scm 55 */
	       obj_t aux_3940;
	       {	/* Cfa/struct.scm 55 */
		  app_bglt obj_3403;
		  obj_3403 =
		     (app_bglt) (node_2888);
		  aux_3940 =
		     (((app_bglt) CREF(obj_3403))->args);
	       }
	       node_setup___185_cfa_setup(aux_3940);
	    }
	    {	/* Cfa/struct.scm 56 */
	       pre_struct_ref_app_207_bglt node_2893;
	       {	/* Cfa/struct.scm 56 */
		  long arg2331_2899;
		  {	/* Cfa/struct.scm 56 */
		     obj_t arg2332_2900;
		     {	/* Cfa/struct.scm 56 */
			obj_t arg2333_2901;
			{	/* Cfa/struct.scm 56 */
			   object_bglt object_3404;
			   object_3404 =
			      (object_bglt) (node_2888);
			   {	/* ./Llib/object.scm 2695 */
			      long arg1179_3405;
			      {		/* ./Llib/object.scm 2695 */
				 long arg1180_3406;
				 long arg1181_3407;
				 arg1180_3406 =
				    TYPE(object_3404);
				 arg1181_3407 =
				    OBJECT_TYPE;
				 arg1179_3405 =
				    (arg1180_3406 - arg1181_3407);
			      }
			      {		/* ./Llib/object.scm 2695 */
				 obj_t vector_3411;
				 vector_3411 = _classes__134___object;
				 arg2333_2901 =
				    VECTOR_REF(vector_3411, arg1179_3405);
			      }
			   }
			}
			arg2332_2900 =
			   class_super_145___object(arg2333_2901);
		     }
		     arg2331_2899 =
			class_num_218___object(arg2332_2900);
		  }
		  {	/* Cfa/struct.scm 56 */
		     obj_t obj_3413;
		     obj_3413 =
			(obj_t) (node_2888);
		     (((obj_t) CREF(obj_3413))->header = MAKE_HEADER(arg2331_2899, 0), BUNSPEC);
		  }
	       }
	       {	/* Cfa/struct.scm 56 */
		  object_bglt aux_3953;
		  aux_3953 =
		     (object_bglt) (node_2888);
		  OBJECT_WIDENING_SET(aux_3953, BFALSE);
	       }
	       node_2893 = node_2888;
	       {	/* Cfa/struct.scm 57 */
		  struct_ref_app_73_bglt obj2037_2894;
		  obj2037_2894 =
		     ((struct_ref_app_73_bglt) (node_2893));
		  {	/* Cfa/struct.scm 57 */
		     struct_ref_app_73_bglt arg2328_2895;
		     {	/* Cfa/struct.scm 57 */
			approx_bglt arg2329_2896;
			arg2329_2896 =
			   make_type_approx_184_cfa_approx(
			   (type_bglt) (_obj__252_type_cache));
			{	/* Cfa/struct.scm 57 */
			   struct_ref_app_73_bglt res2403_3418;
			   {	/* ./Cfa/cinfo2.scm 1236 */
			      struct_ref_app_73_bglt new2013_3416;
			      new2013_3416 =
				 ((struct_ref_app_73_bglt) BREF(GC_MALLOC(sizeof(struct struct_ref_app_73))));
			      ((((struct_ref_app_73_bglt) CREF(new2013_3416))->approx) = ((approx_bglt) arg2329_2896), BUNSPEC);
			      res2403_3418 = new2013_3416;
			   }
			   arg2328_2895 = res2403_3418;
			}
		     }
		     {	/* Cfa/struct.scm 57 */
			obj_t aux_3963;
			object_bglt aux_3961;
			aux_3963 =
			   (obj_t) (arg2328_2895);
			aux_3961 =
			   (object_bglt) (obj2037_2894);
			OBJECT_WIDENING_SET(aux_3961, aux_3963);
		     }
		  }
		  {	/* Cfa/struct.scm 57 */
		     long arg2330_2897;
		     arg2330_2897 =
			class_num_218___object(struct_ref_app_73_cfa_info2);
		     {	/* Cfa/struct.scm 57 */
			obj_t obj_3419;
			obj_3419 =
			   (obj_t) (obj2037_2894);
			(((obj_t) CREF(obj_3419))->header = MAKE_HEADER(arg2330_2897, 0), BUNSPEC);
		     }
		  }
		  aux_3939 = obj2037_2894;
	       }
	    }
	    return
	       (obj_t) (aux_3939);
	 }
      }
   }
}



/* node-setup!-pre-make-struct-app2052 */
obj_t 
node_setup__pre_make_struct_app2052_127_cfa_struct(obj_t env_3555, obj_t node_3556)
{
   AN_OBJECT;
   {	/* Cfa/struct.scm 36 */
      {
	 pre_make_struct_app_218_bglt node_2865;
	 node_2865 =
	    (pre_make_struct_app_218_bglt) (node_3556);
	 {	/* Cfa/struct.scm 38 */
	    obj_t aux_3971;
	    {	/* Cfa/struct.scm 38 */
	       app_bglt obj_3372;
	       obj_3372 =
		  (app_bglt) (node_2865);
	       aux_3971 =
		  (((app_bglt) CREF(obj_3372))->args);
	    }
	    node_setup___185_cfa_setup(aux_3971);
	 }
	 {	/* Cfa/struct.scm 39 */
	    variable_bglt owner_2870;
	    {
	       obj_t aux_3975;
	       {	/* ./Cfa/cinfo2.scm 1217 */
		  object_bglt aux_3976;
		  aux_3976 =
		     (object_bglt) (node_2865);
		  aux_3975 =
		     OBJECT_WIDENING(aux_3976);
	       }
	       owner_2870 =
		  (((pre_make_struct_app_218_bglt) CREF(aux_3975))->owner);
	    }
	    {	/* Cfa/struct.scm 39 */
	       pre_make_struct_app_218_bglt node_2871;
	       {	/* Cfa/struct.scm 40 */
		  long arg2323_2883;
		  {	/* Cfa/struct.scm 40 */
		     obj_t arg2324_2884;
		     {	/* Cfa/struct.scm 40 */
			obj_t arg2325_2885;
			{	/* Cfa/struct.scm 40 */
			   object_bglt object_3374;
			   object_3374 =
			      (object_bglt) (node_2865);
			   {	/* ./Llib/object.scm 2695 */
			      long arg1179_3375;
			      {		/* ./Llib/object.scm 2695 */
				 long arg1180_3376;
				 long arg1181_3377;
				 arg1180_3376 =
				    TYPE(object_3374);
				 arg1181_3377 =
				    OBJECT_TYPE;
				 arg1179_3375 =
				    (arg1180_3376 - arg1181_3377);
			      }
			      {		/* ./Llib/object.scm 2695 */
				 obj_t vector_3381;
				 vector_3381 = _classes__134___object;
				 arg2325_2885 =
				    VECTOR_REF(vector_3381, arg1179_3375);
			      }
			   }
			}
			arg2324_2884 =
			   class_super_145___object(arg2325_2885);
		     }
		     arg2323_2883 =
			class_num_218___object(arg2324_2884);
		  }
		  {	/* Cfa/struct.scm 40 */
		     obj_t obj_3383;
		     obj_3383 =
			(obj_t) (node_2865);
		     (((obj_t) CREF(obj_3383))->header = MAKE_HEADER(arg2323_2883, 0), BUNSPEC);
		  }
	       }
	       {	/* Cfa/struct.scm 40 */
		  object_bglt aux_3989;
		  aux_3989 =
		     (object_bglt) (node_2865);
		  OBJECT_WIDENING_SET(aux_3989, BFALSE);
	       }
	       node_2871 = node_2865;
	       {	/* Cfa/struct.scm 40 */

		  {	/* Cfa/struct.scm 41 */
		     make_struct_app_214_bglt wnode_2872;
		     {	/* Cfa/struct.scm 41 */
			make_struct_app_214_bglt obj2034_2874;
			obj2034_2874 =
			   ((make_struct_app_214_bglt) (node_2871));
			{	/* Cfa/struct.scm 43 */
			   make_struct_app_214_bglt arg2316_2875;
			   {	/* Cfa/struct.scm 43 */
			      approx_bglt arg2317_2876;
			      approx_bglt arg2318_2877;
			      arg2317_2876 =
				 make_empty_approx_131_cfa_approx();
			      arg2318_2877 =
				 make_empty_approx_131_cfa_approx();
			      {		/* Cfa/struct.scm 41 */
				 make_struct_app_214_bglt res2402_3398;
				 {	/* ./Cfa/cinfo2.scm 1221 */
				    make_struct_app_214_bglt new1995_3391;
				    new1995_3391 =
				       ((make_struct_app_214_bglt) BREF(GC_MALLOC(sizeof(struct make_struct_app_214))));
				    ((((make_struct_app_214_bglt) CREF(new1995_3391))->approx) = ((approx_bglt) arg2317_2876), BUNSPEC);
				    ((((make_struct_app_214_bglt) CREF(new1995_3391))->value_approx_19) = ((approx_bglt) arg2318_2877), BUNSPEC);
				    ((((make_struct_app_214_bglt) CREF(new1995_3391))->lost_stamp_114) = ((long) ((long) -1)), BUNSPEC);
				    ((((make_struct_app_214_bglt) CREF(new1995_3391))->owner) = ((variable_bglt) owner_2870), BUNSPEC);
				    ((((make_struct_app_214_bglt) CREF(new1995_3391))->stackable__42) = ((bool_t) ((bool_t) 1)), BUNSPEC);
				    ((((make_struct_app_214_bglt) CREF(new1995_3391))->stack_stamp_31) = ((obj_t) BNIL), BUNSPEC);
				    res2402_3398 = new1995_3391;
				 }
				 arg2316_2875 = res2402_3398;
			      }
			   }
			   {	/* Cfa/struct.scm 41 */
			      obj_t aux_4004;
			      object_bglt aux_4002;
			      aux_4004 =
				 (obj_t) (arg2316_2875);
			      aux_4002 =
				 (object_bglt) (obj2034_2874);
			      OBJECT_WIDENING_SET(aux_4002, aux_4004);
			   }
			}
			{	/* Cfa/struct.scm 41 */
			   long arg2322_2881;
			   arg2322_2881 =
			      class_num_218___object(make_struct_app_214_cfa_info2);
			   {	/* Cfa/struct.scm 41 */
			      obj_t obj_3399;
			      obj_3399 =
				 (obj_t) (obj2034_2874);
			      (((obj_t) CREF(obj_3399))->header = MAKE_HEADER(arg2322_2881, 0), BUNSPEC);
			   }
			}
			wnode_2872 = obj2034_2874;
		     }
		     {	/* Cfa/struct.scm 47 */
			approx_bglt arg2315_2873;
			arg2315_2873 =
			   make_type_alloc_approx_134_cfa_approx(
			   (type_bglt) (_struct__183_type_cache),
			   (node_bglt) (node_2871));
			{
			   obj_t aux_4013;
			   {	/* ./Cfa/cinfo2.scm 1221 */
			      object_bglt aux_4014;
			      aux_4014 =
				 (object_bglt) (wnode_2872);
			      aux_4013 =
				 OBJECT_WIDENING(aux_4014);
			   }
			   return
			      ((((make_struct_app_214_bglt) CREF(aux_4013))->approx) = ((approx_bglt) arg2315_2873), BUNSPEC);
			}
		     }
		  }
	       }
	    }
	 }
      }
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_cfa_struct()
{
   AN_OBJECT;
   {	/* Cfa/struct.scm 16 */
      module_initialization_70_tools_trace(((long) 0), "CFA_STRUCT");
      module_initialization_70_tools_error(((long) 0), "CFA_STRUCT");
      module_initialization_70_tools_shape(((long) 0), "CFA_STRUCT");
      module_initialization_70_type_type(((long) 0), "CFA_STRUCT");
      module_initialization_70_type_cache(((long) 0), "CFA_STRUCT");
      module_initialization_70_ast_var(((long) 0), "CFA_STRUCT");
      module_initialization_70_ast_node(((long) 0), "CFA_STRUCT");
      module_initialization_70_cfa_info(((long) 0), "CFA_STRUCT");
      module_initialization_70_cfa_info2(((long) 0), "CFA_STRUCT");
      module_initialization_70_cfa_loose(((long) 0), "CFA_STRUCT");
      module_initialization_70_cfa_iterate(((long) 0), "CFA_STRUCT");
      module_initialization_70_cfa_cfa(((long) 0), "CFA_STRUCT");
      module_initialization_70_cfa_setup(((long) 0), "CFA_STRUCT");
      module_initialization_70_cfa_approx(((long) 0), "CFA_STRUCT");
      return
	 module_initialization_70_cfa_stack(((long) 0), "CFA_STRUCT");
   }
}
