/*===========================================================================*/
/*   (Cfa/tvector.scm)                                                       */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct tvec
  {
     struct type *item_type_130;
  }
    *tvec_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;

typedef struct approx
  {
     header_t header;
     obj_t widening;
     struct type *type;
     bool_t type_locked__184;
     obj_t allocs;
     bool_t top__138;
     long lost_stamp_114;
  }
      *approx_bglt;

typedef struct cfun_cinfo_200
  {
     struct approx *approx;
  }
              *cfun_cinfo_200_bglt;

typedef struct extern_sfun_cinfo_6
  {
     struct approx *approx;
  }
                   *extern_sfun_cinfo_6_bglt;

typedef struct intern_sfun_cinfo_192
  {
     struct approx *approx;
     long stamp;
  }
                     *intern_sfun_cinfo_192_bglt;

typedef struct scnst_cinfo_0
  {
     struct approx *approx;
  }
             *scnst_cinfo_0_bglt;

typedef struct pre_clo_env_191
  {
     char dummy;
  }
               *pre_clo_env_191_bglt;

typedef struct svar_cinfo_166
  {
     struct approx *approx;
     bool_t clo_env__87;
  }
              *svar_cinfo_166_bglt;

typedef struct cvar_cinfo_53
  {
     struct approx *approx;
  }
             *cvar_cinfo_53_bglt;

typedef struct sexit_cinfo_49
  {
     struct approx *approx;
  }
              *sexit_cinfo_49_bglt;

typedef struct reshaped_local_224
  {
     obj_t binding_value_3;
  }
                  *reshaped_local_224_bglt;

typedef struct reshaped_global_160
  {
     char dummy;
  }
                   *reshaped_global_160_bglt;

typedef struct atom_cinfo_155
  {
     struct approx *approx;
  }
              *atom_cinfo_155_bglt;

typedef struct kwote_node_102
  {
     struct node *node;
  }
              *kwote_node_102_bglt;

typedef struct kwote_cinfo_48
  {
     struct approx *approx;
  }
              *kwote_cinfo_48_bglt;

typedef struct app_ly_cinfo_234
  {
     struct approx *approx;
  }
                *app_ly_cinfo_234_bglt;

typedef struct funcall_cinfo_75
  {
     struct approx *approx;
     struct approx *va_approx_63;
     bool_t arity_error_noticed__118;
     bool_t type_error_noticed__36;
  }
                *funcall_cinfo_75_bglt;

typedef struct pragma_cinfo_220
  {
     struct approx *approx;
  }
                *pragma_cinfo_220_bglt;

typedef struct setq_cinfo_191
  {
     struct approx *approx;
  }
              *setq_cinfo_191_bglt;

typedef struct conditional_cinfo_212
  {
     struct approx *approx;
  }
                     *conditional_cinfo_212_bglt;

typedef struct fail_cinfo_75
  {
     struct approx *approx;
  }
             *fail_cinfo_75_bglt;

typedef struct select_cinfo_150
  {
     struct approx *approx;
  }
                *select_cinfo_150_bglt;

typedef struct set_ex_it_cinfo_168
  {
     struct approx *approx;
  }
                   *set_ex_it_cinfo_168_bglt;

typedef struct jump_ex_it_cinfo_139
  {
     struct approx *approx;
  }
                    *jump_ex_it_cinfo_139_bglt;

typedef struct pre_make_box_186
  {
     char dummy;
  }
                *pre_make_box_186_bglt;

typedef struct make_box_cinfo_127
  {
     struct approx *approx;
  }
                  *make_box_cinfo_127_bglt;

typedef struct make_box_o_cinfo_96
  {
     struct approx *approx;
     struct approx *value_approx_19;
  }
                   *make_box_o_cinfo_96_bglt;

typedef struct box_set__cinfo_94
  {
     struct approx *approx;
  }
                 *box_set__cinfo_94_bglt;

typedef struct box_ref_cinfo_214
  {
     struct approx *approx;
  }
                 *box_ref_cinfo_214_bglt;

typedef struct box_set__o_cinfo_6
  {
     struct approx *approx;
  }
                  *box_set__o_cinfo_6_bglt;

typedef struct box_ref_o_cinfo_98
  {
     struct approx *approx;
  }
                  *box_ref_o_cinfo_98_bglt;

typedef struct pre_make_procedure_app_60
  {
     struct variable *owner;
  }
                         *pre_make_procedure_app_60_bglt;

typedef struct pre_procedure_ref_app_85
  {
     char dummy;
  }
                        *pre_procedure_ref_app_85_bglt;

typedef struct pre_procedure_set__app_208
  {
     char dummy;
  }
                          *pre_procedure_set__app_208_bglt;

typedef struct make_procedure_app_48
  {
     struct approx *approx;
     long values_approx_len_106;
     struct approx **values_approx_79;
     long lost_stamp_114;
     bool_t x_t__142;
     bool_t x;
     bool_t t;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
  }
                     *make_procedure_app_48_bglt;

typedef struct procedure_ref_app_49
  {
     struct approx *approx;
  }
                    *procedure_ref_app_49_bglt;

typedef struct procedure_set__app_32
  {
     struct approx *approx;
  }
                     *procedure_set__app_32_bglt;

typedef struct pre_make_vector_app_251
  {
     struct variable *owner;
  }
                       *pre_make_vector_app_251_bglt;

typedef struct pre_create_vector_app_162
  {
     struct variable *owner;
  }
                         *pre_create_vector_app_162_bglt;

typedef struct pre_vector_ref_app_208
  {
     char dummy;
  }
                      *pre_vector_ref_app_208_bglt;

typedef struct pre_vector_set__app_211
  {
     char dummy;
  }
                       *pre_vector_set__app_211_bglt;

typedef struct make_vector_app_205
  {
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
     bool_t seen__39;
  }
                   *make_vector_app_205_bglt;

typedef struct create_vector_app_150
  {
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
     bool_t seen__39;
  }
                     *create_vector_app_150_bglt;

typedef struct vector_ref_app_195
  {
     struct approx *approx;
  }
                  *vector_ref_app_195_bglt;

typedef struct vector_set__app_21
  {
     struct approx *approx;
  }
                  *vector_set__app_21_bglt;

typedef struct pre_make_struct_app_218
  {
     struct variable *owner;
  }
                       *pre_make_struct_app_218_bglt;

typedef struct pre_struct_ref_app_207
  {
     char dummy;
  }
                      *pre_struct_ref_app_207_bglt;

typedef struct pre_struct_set__app_116
  {
     char dummy;
  }
                       *pre_struct_set__app_116_bglt;

typedef struct make_struct_app_214
  {
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
  }
                   *make_struct_app_214_bglt;

typedef struct struct_ref_app_73
  {
     struct approx *approx;
  }
                 *struct_ref_app_73_bglt;

typedef struct struct_set__app_162
  {
     struct approx *approx;
  }
                   *struct_set__app_162_bglt;

typedef struct isfun
  {
     struct node *original_body_40;
     obj_t recursive_calls_44;
  }
     *isfun_bglt;


extern obj_t find_global_223_ast_env(obj_t, obj_t);
extern obj_t _long__149_type_cache;
static obj_t method_init_76_cfa_tvector();
extern obj_t make_box_202_ast_node;
extern obj_t funcall_ast_node;
extern obj_t symbol_append_197___r4_symbols_6_4(obj_t);
extern obj_t _optim__89_engine_param;
static obj_t _patch_vector_set__187_cfa_tvector(obj_t);
extern obj_t tvector_optimization__143_cfa_tvector();
extern long add_inlined_method__244___object(obj_t, obj_t, long);
extern obj_t fail_ast_node;
static bool_t show_tvector_204_cfa_tvector(obj_t);
extern obj_t type_type_type;
extern obj_t box_ref_242_ast_node;
static obj_t _vector__tvector__184_cfa_tvector(obj_t, obj_t);
extern obj_t patch_vector_set__231_cfa_tvector();
extern obj_t sequence_ast_node;
extern obj_t let_var_6_ast_node;
extern obj_t var_ast_node;
static obj_t patch__227_cfa_tvector(node_bglt);
extern obj_t closure_ast_node;
extern obj_t create_struct(obj_t, long);
static obj_t _patch__default2123_49_cfa_tvector(obj_t, obj_t);
extern obj_t tvec_tvector_tvector;
extern obj_t global_ast_var;
extern obj_t _obj__252_type_cache;
extern obj_t pragma_ast_node;
extern obj_t set_ex_it_116_ast_node;
extern obj_t globalize_walk__63_globalize_walk(obj_t, obj_t);
extern obj_t vector__tvector__205_cfa_tvector(obj_t);
extern obj_t vector_ref_app_195_cfa_info2;
static obj_t patch___72_cfa_tvector(obj_t);
extern bool_t stack_optimization__133_cfa_stack();
extern obj_t verbose_tools_speek(obj_t, obj_t);
static obj_t _patch__77_cfa_tvector(obj_t, obj_t);
extern bool_t is_a__118___object(obj_t, obj_t);
extern type_bglt get_default_type_181_type_cache();
extern obj_t module_initialization_70_cfa_tvector(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_module_type(long, char *);
extern obj_t module_initialization_70_module_pragma(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_type_env(long, char *);
extern obj_t module_initialization_70_tvector_tvector(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_speek(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_ast_build(long, char *);
extern obj_t module_initialization_70_ast_sexp(long, char *);
extern obj_t module_initialization_70_ast_env(long, char *);
extern obj_t module_initialization_70_cfa_info(long, char *);
extern obj_t module_initialization_70_cfa_info2(long, char *);
extern obj_t module_initialization_70_cfa_cfa(long, char *);
extern obj_t module_initialization_70_cfa_approx(long, char *);
extern obj_t module_initialization_70_cfa_set(long, char *);
extern obj_t module_initialization_70_cfa_type(long, char *);
extern obj_t module_initialization_70_cfa_stack(long, char *);
extern obj_t module_initialization_70_globalize_walk(long, char *);
extern obj_t module_initialization_70_inline_inline(long, char *);
extern obj_t module_initialization_70_inline_walk(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_symbols_6_4(long, char *);
static obj_t _unpatch_vector_set__250_cfa_tvector(obj_t);
extern bool_t sub_type__174_type_env(type_bglt, type_bglt);
static obj_t _make_vector_list__231_cfa_tvector = BUNSPEC;
extern obj_t tvector_finalizer_246_module_type();
static obj_t declare_tvectors_117_cfa_tvector(obj_t);
extern long class_num_218___object(obj_t);
extern obj_t let_fun_218_ast_node;
static obj_t imported_modules_init_94_cfa_tvector();
static obj_t patch_vector__list__149_cfa_tvector(app_bglt);
static obj_t patch_vector_length__86_cfa_tvector(app_bglt);
extern obj_t app_ly_162_ast_node;
extern obj_t cfun_ast_var;
extern obj_t add_generic__110___object(obj_t, obj_t);
static obj_t patch_fun__141_cfa_tvector(obj_t);
extern obj_t app_ast_node;
extern obj_t append_2_18___r4_pairs_and_lists_6_3(obj_t, obj_t);
static obj_t library_modules_init_112_cfa_tvector();
extern obj_t get_approx_type_210_cfa_type(approx_bglt);
extern node_bglt inline_node_218_inline_inline(node_bglt, long, obj_t);
extern obj_t make_vector_app_205_cfa_info2;
extern approx_bglt cfa__102_cfa_cfa(node_bglt);
extern obj_t unpatch_vector_set__139_cfa_tvector();
extern node_bglt node_heap__stack__239_cfa_stack(app_bglt, bool_t);
extern obj_t set_default_type__106_type_cache(type_bglt);
extern obj_t kwote_node_102_cfa_info;
extern obj_t atom_ast_node;
extern obj_t cast_ast_node;
static obj_t toplevel_init_63_cfa_tvector();
extern node_bglt sexp__node_235_ast_sexp(obj_t, obj_t, obj_t, obj_t);
extern obj_t jump_ex_it_184_ast_node;
extern obj_t open_input_string(obj_t);
extern obj_t vector_set__app_21_cfa_info2;
extern obj_t kwote_ast_node;
static obj_t _get_vector_item_type_42_cfa_tvector(obj_t, obj_t);
extern obj_t sfun_ast_var;
static obj_t patch__default2123_223_cfa_tvector(node_bglt);
extern obj_t setq_ast_node;
extern obj_t box_set__221_ast_node;
static obj_t _tvector_optimization__242_cfa_tvector(obj_t);
static bool_t patch_tree__164_cfa_tvector(obj_t);
extern obj_t create_vector_app_150_cfa_info2;
static obj_t _get_vector_item_type_default2118_240_cfa_tvector(obj_t, obj_t);
extern obj_t shape_tools_shape(obj_t);
extern obj_t internal_error_43_tools_error(obj_t, obj_t, obj_t);
extern obj_t build_ast_sans_remove_93_ast_build(obj_t);
static obj_t patch_vector___0_cfa_tvector(app_bglt);
static obj_t _add_make_vector__56_cfa_tvector(obj_t, obj_t);
extern obj_t _classes__134___object;
static obj_t get_tvectors_38_cfa_tvector();
extern obj_t select_ast_node;
extern obj_t read___reader(obj_t);
extern obj_t pragma_finalizer_170_module_pragma();
extern obj_t inline_setup__219_inline_walk(obj_t);
extern type_bglt get_vector_item_type_88_cfa_tvector(app_bglt);
static obj_t get_vector_item_type_default2118_14_cfa_tvector(app_bglt);
extern obj_t _lib_mode__85_engine_param;
extern obj_t add_make_vector__104_cfa_tvector(node_bglt);
extern obj_t ____74_type_cache;
static obj_t require_initialization_114_cfa_tvector = BUNSPEC;
extern obj_t _vector__240_type_cache;
extern obj_t conditional_ast_node;
extern obj_t class_super_145___object(obj_t);
extern obj_t type_parser_173_module_type(obj_t, obj_t);
static obj_t cnst_init_137_cfa_tvector();
extern obj_t _bool__149_type_cache;
static obj_t __cnst[22];

DEFINE_EXPORT_PROCEDURE(add_make_vector__env_5_cfa_tvector, _add_make_vector__56_cfa_tvector2785, _add_make_vector__56_cfa_tvector, 0L, 1);
DEFINE_EXPORT_PROCEDURE(tvector_optimization__env_42_cfa_tvector, _tvector_optimization__242_cfa_tvector2786, _tvector_optimization__242_cfa_tvector, 0L, 0);
DEFINE_EXPORT_PROCEDURE(patch_vector_set__env_198_cfa_tvector, _patch_vector_set__187_cfa_tvector2787, _patch_vector_set__187_cfa_tvector, 0L, 0);
DEFINE_STATIC_GENERIC(patch__env_129_cfa_tvector, _patch__77_cfa_tvector2788, _patch__77_cfa_tvector, 0L, 1);
DEFINE_STATIC_PROCEDURE(get_vector_item_type_default2118_env_225_cfa_tvector, _get_vector_item_type_default2118_240_cfa_tvector2789, _get_vector_item_type_default2118_240_cfa_tvector, 0L, 1);
DEFINE_STRING(string2779_cfa_tvector, string2779_cfa_tvector2790, "Unexpected closure", 18);
DEFINE_STRING(string2780_cfa_tvector, string2780_cfa_tvector2791, "PATCH!-DEFAULT2123 -SET! -REF ALLOCATE- MAKE- __R4_VECTORS_6_8 VECTOR->LIST C-VECTOR-LENGTH A-TVECTOR GET-VECTOR-ITEM-TYPE-DEFAULT2118 ->LIST VALUE -LENGTH DONE NO-REMOVE UNIT TVECTOR TV-OF- ALL VECTOR? C-VECTOR? (VECTOR-SET! C-VECTOR-SET! VECTOR-SET-UR!) ", 256);
DEFINE_STRING(string2778_cfa_tvector, string2778_cfa_tvector2792, "patch!", 6);
DEFINE_STRING(string2777_cfa_tvector, string2777_cfa_tvector2793, "No method for this object", 25);
DEFINE_STRING(string2776_cfa_tvector, string2776_cfa_tvector2794, "        vector of ", 18);
DEFINE_STRING(string2775_cfa_tvector, string2775_cfa_tvector2795, " -> vector of ", 14);
DEFINE_STRING(string2774_cfa_tvector, string2774_cfa_tvector2796, "   . Vector -> Tvector", 22);
DEFINE_STATIC_PROCEDURE(patch__default2123_env_126_cfa_tvector, _patch__default2123_49_cfa_tvector2797, _patch__default2123_49_cfa_tvector, 0L, 1);
DEFINE_EXPORT_PROCEDURE(vector__tvector__env_76_cfa_tvector, _vector__tvector__184_cfa_tvector2798, _vector__tvector__184_cfa_tvector, 0L, 1);
DEFINE_EXPORT_PROCEDURE(unpatch_vector_set__env_116_cfa_tvector, _unpatch_vector_set__250_cfa_tvector2799, _unpatch_vector_set__250_cfa_tvector, 0L, 0);
DEFINE_EXPORT_GENERIC(get_vector_item_type_env_168_cfa_tvector, _get_vector_item_type_42_cfa_tvector2800, _get_vector_item_type_42_cfa_tvector, 0L, 1);



/* module-initialization */
obj_t 
module_initialization_70_cfa_tvector(long checksum_4414, char *from_4415)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_cfa_tvector))
	{
	   require_initialization_114_cfa_tvector =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_cfa_tvector();
	   cnst_init_137_cfa_tvector();
	   imported_modules_init_94_cfa_tvector();
	   method_init_76_cfa_tvector();
	   toplevel_init_63_cfa_tvector();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_cfa_tvector()
{
   AN_OBJECT;
   {	/* Cfa/tvector.scm 14 */
      module_initialization_70___r4_symbols_6_4(((long) 0), "CFA_TVECTOR");
      module_initialization_70___object(((long) 0), "CFA_TVECTOR");
      module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "CFA_TVECTOR");
      module_initialization_70___reader(((long) 0), "CFA_TVECTOR");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_cfa_tvector()
{
   AN_OBJECT;
   {	/* Cfa/tvector.scm 14 */
      {		/* Cfa/tvector.scm 14 */
	 obj_t cnst_port_138_4407;
	 cnst_port_138_4407 =
	    open_input_string(string2780_cfa_tvector);
	 {
	    long i_4408;
	    i_4408 = ((long) 21);
	  loop_4409:
	    {	/* Cfa/tvector.scm 14 */
	       bool_t test2781_4410;
	       test2781_4410 =
		  (i_4408 == ((long) -1));
	       if (test2781_4410)
		 {	/* Cfa/tvector.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Cfa/tvector.scm 14 */
		    {	/* Cfa/tvector.scm 14 */
		       obj_t arg2782_4411;
		       {	/* Cfa/tvector.scm 14 */
			  obj_t list2783_4412;
			  list2783_4412 =
			     MAKE_PAIR(cnst_port_138_4407, BNIL);
			  arg2782_4411 =
			     read___reader(list2783_4412);
		       }
		       CNST_TABLE_SET(i_4408, arg2782_4411);
		    }
		    {	/* Cfa/tvector.scm 14 */
		       int aux_4413;
		       {	/* Cfa/tvector.scm 14 */
			  long aux_4434;
			  aux_4434 =
			     (i_4408 - ((long) 1));
			  aux_4413 =
			     (int) (aux_4434);
		       }
		       {
			  long i_4437;
			  i_4437 =
			     (long) (aux_4413);
			  i_4408 = i_4437;
			  goto loop_4409;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_cfa_tvector()
{
   AN_OBJECT;
   {	/* Cfa/tvector.scm 14 */
      _make_vector_list__231_cfa_tvector = BNIL;
      return BUNSPEC;
   }
}



/* tvector-optimization? */
obj_t 
tvector_optimization__143_cfa_tvector()
{
   AN_OBJECT;
   {	/* Cfa/tvector.scm 58 */
      {		/* Cfa/tvector.scm 59 */
	 bool_t _andtest_2067_2300;
	 {	/* Cfa/tvector.scm 59 */
	    long n1_3589;
	    n1_3589 =
	       (long) CINT(_optim__89_engine_param);
	    _andtest_2067_2300 =
	       (n1_3589 >= ((long) 3));
	 }
	 if (_andtest_2067_2300)
	   {	/* Cfa/tvector.scm 59 */
	      if (
		 CBOOL(_lib_mode__85_engine_param))
		{	/* Cfa/tvector.scm 59 */
		   return BFALSE;
		}
	      else
		{	/* Cfa/tvector.scm 59 */
		   return BTRUE;
		}
	   }
	 else
	   {	/* Cfa/tvector.scm 59 */
	      return BFALSE;
	   }
      }
   }
}



/* _tvector-optimization? */
obj_t 
_tvector_optimization__242_cfa_tvector(obj_t env_4390)
{
   AN_OBJECT;
   {	/* Cfa/tvector.scm 58 */
      return
	 tvector_optimization__143_cfa_tvector();
   }
}



/* patch-vector-set! */
obj_t 
patch_vector_set__231_cfa_tvector()
{
   AN_OBJECT;
   {	/* Cfa/tvector.scm 67 */
      {		/* Cfa/tvector.scm 68 */
	 bool_t test_4445;
	 {	/* Cfa/tvector.scm 68 */
	    obj_t aux_4446;
	    aux_4446 =
	       tvector_optimization__143_cfa_tvector();
	    test_4445 =
	       CBOOL(aux_4446);
	 }
	 if (test_4445)
	   {	/* Cfa/tvector.scm 68 */
	      {
		 obj_t l2068_2302;
		 l2068_2302 =
		    CNST_TABLE_REF(((long) 0));
	       lname2069_2303:
		 if (
		    PAIRP(l2068_2302))
		   {	/* Cfa/tvector.scm 70 */
		      {		/* Cfa/tvector.scm 71 */
			 obj_t g_2306;
			 g_2306 =
			    find_global_223_ast_env(
			    CAR(l2068_2302), BNIL);
			 {	/* Cfa/tvector.scm 72 */
			    bool_t test2200_2307;
			    test2200_2307 =
			       is_a__118___object(g_2306, global_ast_var);
			    if (test2200_2307)
			      {		/* Cfa/tvector.scm 73 */
				 value_bglt fun_2308;
				 {	/* Cfa/tvector.scm 73 */
				    global_bglt obj_3594;
				    obj_3594 =
				       (global_bglt) (g_2306);
				    fun_2308 =
				       (((global_bglt) CREF(obj_3594))->value);
				 }
				 {	/* Cfa/tvector.scm 75 */
				    bool_t test2201_2309;
				    test2201_2309 =
				       is_a__118___object(
				       (obj_t) (fun_2308), cfun_ast_var);
				    if (test2201_2309)
				      {		/* Cfa/tvector.scm 75 */
					 {	/* Cfa/tvector.scm 76 */
					    obj_t arg2202_2310;
					    type_bglt arg2203_2311;
					    {	/* ./Ieee/pair-list.scm 5707 */
					       obj_t aux_4460;
					       {	/* ./Ieee/pair-list.scm 5707 */
						  obj_t aux_4461;
						  {	/* Cfa/tvector.scm 76 */
						     cfun_bglt obj_3596;
						     obj_3596 =
							(cfun_bglt) (fun_2308);
						     aux_4461 =
							(((cfun_bglt) CREF(obj_3596))->args_type_205);
						  }
						  aux_4460 =
						     CDR(aux_4461);
					       }
					       arg2202_2310 =
						  CDR(aux_4460);
					    }
					    arg2203_2311 =
					       get_default_type_181_type_cache();
					    {	/* ./Ieee/pair-list.scm 5890 */
					       obj_t aux_4467;
					       aux_4467 =
						  (obj_t) (arg2203_2311);
					       SET_CAR(arg2202_2310, aux_4467);
					    }
					 }
				      }
				    else
				      {		/* Cfa/tvector.scm 78 */
					 bool_t test2205_2313;
					 test2205_2313 =
					    is_a__118___object(
					    (obj_t) (fun_2308), sfun_ast_var);
					 if (test2205_2313)
					   {	/* Cfa/tvector.scm 78 */
					      {		/* Cfa/tvector.scm 79 */
						 obj_t arg2206_2314;
						 type_bglt arg2207_2315;
						 {	/* ./Ieee/pair-list.scm 5701 */
						    obj_t aux_4473;
						    {	/* ./Ieee/pair-list.scm 5707 */
						       obj_t aux_4474;
						       {	/* ./Ieee/pair-list.scm 5707 */
							  obj_t aux_4475;
							  {	/* Cfa/tvector.scm 79 */
							     sfun_bglt obj_3604;
							     obj_3604 =
								(sfun_bglt) (fun_2308);
							     aux_4475 =
								(((sfun_bglt) CREF(obj_3604))->args);
							  }
							  aux_4474 =
							     CDR(aux_4475);
						       }
						       aux_4473 =
							  CDR(aux_4474);
						    }
						    arg2206_2314 =
						       CAR(aux_4473);
						 }
						 arg2207_2315 =
						    get_default_type_181_type_cache();
						 {	/* Cfa/tvector.scm 79 */
						    local_bglt obj_3611;
						    obj_3611 =
						       (local_bglt) (arg2206_2314);
						    ((((local_bglt) CREF(obj_3611))->type) = ((type_bglt) arg2207_2315), BUNSPEC);
						 }
					      }
					   }
					 else
					   {	/* Cfa/tvector.scm 78 */
					      BFALSE;
					   }
				      }
				 }
			      }
			    else
			      {		/* Cfa/tvector.scm 72 */
				 BUNSPEC;
			      }
			 }
		      }
		      {
			 obj_t l2068_4484;
			 l2068_4484 =
			    CDR(l2068_2302);
			 l2068_2302 = l2068_4484;
			 goto lname2069_2303;
		      }
		   }
		 else
		   {	/* Cfa/tvector.scm 70 */
		      ((bool_t) 1);
		   }
	      }
	      {		/* Cfa/tvector.scm 82 */
		 obj_t g_2319;
		 g_2319 =
		    find_global_223_ast_env(
		    CNST_TABLE_REF(((long) 1)), BNIL);
		 {	/* Cfa/tvector.scm 83 */
		    bool_t test2211_2320;
		    test2211_2320 =
		       is_a__118___object(g_2319, global_ast_var);
		    if (test2211_2320)
		      {		/* Cfa/tvector.scm 85 */
			 obj_t arg2212_2322;
			 type_bglt arg2213_2323;
			 {	/* Cfa/tvector.scm 85 */
			    cfun_bglt obj_3616;
			    {	/* Cfa/tvector.scm 85 */
			       value_bglt aux_4491;
			       {	/* Cfa/tvector.scm 84 */
				  global_bglt obj_3615;
				  obj_3615 =
				     (global_bglt) (g_2319);
				  aux_4491 =
				     (((global_bglt) CREF(obj_3615))->value);
			       }
			       obj_3616 =
				  (cfun_bglt) (aux_4491);
			    }
			    arg2212_2322 =
			       (((cfun_bglt) CREF(obj_3616))->args_type_205);
			 }
			 arg2213_2323 =
			    get_default_type_181_type_cache();
			 {	/* ./Ieee/pair-list.scm 5890 */
			    obj_t aux_4497;
			    aux_4497 =
			       (obj_t) (arg2213_2323);
			    SET_CAR(arg2212_2322, aux_4497);
			 }
		      }
		    else
		      {		/* Cfa/tvector.scm 83 */
			 BUNSPEC;
		      }
		 }
	      }
	      {		/* Cfa/tvector.scm 86 */
		 obj_t g_2325;
		 g_2325 =
		    find_global_223_ast_env(
		    CNST_TABLE_REF(((long) 2)), BNIL);
		 {	/* Cfa/tvector.scm 87 */
		    bool_t test2215_2326;
		    test2215_2326 =
		       is_a__118___object(g_2325, global_ast_var);
		    if (test2215_2326)
		      {		/* Cfa/tvector.scm 89 */
			 obj_t arg2216_2328;
			 type_bglt arg2217_2329;
			 {	/* ./Ieee/pair-list.scm 5701 */
			    obj_t aux_4504;
			    {	/* Cfa/tvector.scm 89 */
			       sfun_bglt obj_3621;
			       {	/* Cfa/tvector.scm 89 */
				  value_bglt aux_4505;
				  {	/* Cfa/tvector.scm 88 */
				     global_bglt obj_3620;
				     obj_3620 =
					(global_bglt) (g_2325);
				     aux_4505 =
					(((global_bglt) CREF(obj_3620))->value);
				  }
				  obj_3621 =
				     (sfun_bglt) (aux_4505);
			       }
			       aux_4504 =
				  (((sfun_bglt) CREF(obj_3621))->args);
			    }
			    arg2216_2328 =
			       CAR(aux_4504);
			 }
			 arg2217_2329 =
			    get_default_type_181_type_cache();
			 {	/* Cfa/tvector.scm 89 */
			    local_bglt obj_3623;
			    obj_3623 =
			       (local_bglt) (arg2216_2328);
			    return
			       ((((local_bglt) CREF(obj_3623))->type) = ((type_bglt) arg2217_2329), BUNSPEC);
			 }
		      }
		    else
		      {		/* Cfa/tvector.scm 87 */
			 return BUNSPEC;
		      }
		 }
	      }
	   }
	 else
	   {	/* Cfa/tvector.scm 68 */
	      return BUNSPEC;
	   }
      }
   }
}



/* _patch-vector-set! */
obj_t 
_patch_vector_set__187_cfa_tvector(obj_t env_4391)
{
   AN_OBJECT;
   {	/* Cfa/tvector.scm 67 */
      return
	 patch_vector_set__231_cfa_tvector();
   }
}



/* unpatch-vector-set! */
obj_t 
unpatch_vector_set__139_cfa_tvector()
{
   AN_OBJECT;
   {	/* Cfa/tvector.scm 98 */
      {		/* Cfa/tvector.scm 99 */
	 bool_t test_4515;
	 {	/* Cfa/tvector.scm 99 */
	    obj_t aux_4516;
	    aux_4516 =
	       tvector_optimization__143_cfa_tvector();
	    test_4515 =
	       CBOOL(aux_4516);
	 }
	 if (test_4515)
	   {	/* Cfa/tvector.scm 99 */
	      {
		 obj_t l2070_2333;
		 l2070_2333 =
		    CNST_TABLE_REF(((long) 0));
	       lname2071_2334:
		 if (
		    PAIRP(l2070_2333))
		   {	/* Cfa/tvector.scm 101 */
		      {		/* Cfa/tvector.scm 102 */
			 obj_t g_2337;
			 g_2337 =
			    find_global_223_ast_env(
			    CAR(l2070_2333), BNIL);
			 {	/* Cfa/tvector.scm 103 */
			    bool_t test2223_2338;
			    test2223_2338 =
			       is_a__118___object(g_2337, global_ast_var);
			    if (test2223_2338)
			      {		/* Cfa/tvector.scm 104 */
				 value_bglt fun_2339;
				 {	/* Cfa/tvector.scm 104 */
				    global_bglt obj_3628;
				    obj_3628 =
				       (global_bglt) (g_2337);
				    fun_2339 =
				       (((global_bglt) CREF(obj_3628))->value);
				 }
				 {	/* Cfa/tvector.scm 106 */
				    bool_t test2224_2340;
				    test2224_2340 =
				       is_a__118___object(
				       (obj_t) (fun_2339), cfun_ast_var);
				    if (test2224_2340)
				      {		/* Cfa/tvector.scm 106 */
					 {	/* Cfa/tvector.scm 107 */
					    obj_t obj_3636;
					    obj_3636 = _obj__252_type_cache;
					    {	/* ./Ieee/pair-list.scm 5890 */
					       obj_t aux_4530;
					       {	/* ./Ieee/pair-list.scm 5707 */
						  obj_t aux_4531;
						  {	/* ./Ieee/pair-list.scm 5707 */
						     obj_t aux_4532;
						     {	/* Cfa/tvector.scm 107 */
							cfun_bglt obj_3630;
							obj_3630 =
							   (cfun_bglt) (fun_2339);
							aux_4532 =
							   (((cfun_bglt) CREF(obj_3630))->args_type_205);
						     }
						     aux_4531 =
							CDR(aux_4532);
						  }
						  aux_4530 =
						     CDR(aux_4531);
					       }
					       SET_CAR(aux_4530, obj_3636);
					    }
					 }
				      }
				    else
				      {		/* Cfa/tvector.scm 109 */
					 bool_t test2227_2343;
					 test2227_2343 =
					    is_a__118___object(
					    (obj_t) (fun_2339), sfun_ast_var);
					 if (test2227_2343)
					   {	/* Cfa/tvector.scm 109 */
					      {		/* Cfa/tvector.scm 110 */
						 local_bglt obj_3645;
						 type_bglt val1100_3646;
						 {	/* Cfa/tvector.scm 110 */
						    obj_t aux_4541;
						    {	/* ./Ieee/pair-list.scm 5701 */
						       obj_t aux_4542;
						       {	/* ./Ieee/pair-list.scm 5707 */
							  obj_t aux_4543;
							  {	/* ./Ieee/pair-list.scm 5707 */
							     obj_t aux_4544;
							     {	/* Cfa/tvector.scm 110 */
								sfun_bglt obj_3638;
								obj_3638 =
								   (sfun_bglt) (fun_2339);
								aux_4544 =
								   (((sfun_bglt) CREF(obj_3638))->args);
							     }
							     aux_4543 =
								CDR(aux_4544);
							  }
							  aux_4542 =
							     CDR(aux_4543);
						       }
						       aux_4541 =
							  CAR(aux_4542);
						    }
						    obj_3645 =
						       (local_bglt) (aux_4541);
						 }
						 val1100_3646 =
						    (type_bglt) (_obj__252_type_cache);
						 ((((local_bglt) CREF(obj_3645))->type) = ((type_bglt) val1100_3646), BUNSPEC);
					      }
					   }
					 else
					   {	/* Cfa/tvector.scm 109 */
					      BFALSE;
					   }
				      }
				 }
			      }
			    else
			      {		/* Cfa/tvector.scm 103 */
				 BUNSPEC;
			      }
			 }
		      }
		      {
			 obj_t l2070_4553;
			 l2070_4553 =
			    CDR(l2070_2333);
			 l2070_2333 = l2070_4553;
			 goto lname2071_2334;
		      }
		   }
		 else
		   {	/* Cfa/tvector.scm 101 */
		      ((bool_t) 1);
		   }
	      }
	      {		/* Cfa/tvector.scm 113 */
		 obj_t g_2348;
		 g_2348 =
		    find_global_223_ast_env(
		    CNST_TABLE_REF(((long) 1)), BNIL);
		 {	/* Cfa/tvector.scm 114 */
		    bool_t test2232_2349;
		    test2232_2349 =
		       is_a__118___object(g_2348, global_ast_var);
		    if (test2232_2349)
		      {		/* Cfa/tvector.scm 116 */
			 obj_t obj_3652;
			 obj_3652 = _obj__252_type_cache;
			 {	/* ./Ieee/pair-list.scm 5890 */
			    obj_t aux_4560;
			    {	/* Cfa/tvector.scm 116 */
			       cfun_bglt obj_3650;
			       {	/* Cfa/tvector.scm 116 */
				  value_bglt aux_4561;
				  {	/* Cfa/tvector.scm 115 */
				     global_bglt obj_3649;
				     obj_3649 =
					(global_bglt) (g_2348);
				     aux_4561 =
					(((global_bglt) CREF(obj_3649))->value);
				  }
				  obj_3650 =
				     (cfun_bglt) (aux_4561);
			       }
			       aux_4560 =
				  (((cfun_bglt) CREF(obj_3650))->args_type_205);
			    }
			    SET_CAR(aux_4560, obj_3652);
			 }
		      }
		    else
		      {		/* Cfa/tvector.scm 114 */
			 BUNSPEC;
		      }
		 }
	      }
	      {		/* Cfa/tvector.scm 117 */
		 obj_t g_2353;
		 g_2353 =
		    find_global_223_ast_env(
		    CNST_TABLE_REF(((long) 2)), BNIL);
		 {	/* Cfa/tvector.scm 118 */
		    bool_t test2235_2354;
		    test2235_2354 =
		       is_a__118___object(g_2353, global_ast_var);
		    if (test2235_2354)
		      {		/* Cfa/tvector.scm 120 */
			 local_bglt obj_3657;
			 type_bglt val1100_3658;
			 {	/* Cfa/tvector.scm 120 */
			    obj_t aux_4571;
			    {	/* ./Ieee/pair-list.scm 5701 */
			       obj_t aux_4572;
			       {	/* Cfa/tvector.scm 120 */
				  sfun_bglt obj_3655;
				  {	/* Cfa/tvector.scm 120 */
				     value_bglt aux_4573;
				     {	/* Cfa/tvector.scm 119 */
					global_bglt obj_3654;
					obj_3654 =
					   (global_bglt) (g_2353);
					aux_4573 =
					   (((global_bglt) CREF(obj_3654))->value);
				     }
				     obj_3655 =
					(sfun_bglt) (aux_4573);
				  }
				  aux_4572 =
				     (((sfun_bglt) CREF(obj_3655))->args);
			       }
			       aux_4571 =
				  CAR(aux_4572);
			    }
			    obj_3657 =
			       (local_bglt) (aux_4571);
			 }
			 val1100_3658 =
			    (type_bglt) (_obj__252_type_cache);
			 return
			    ((((local_bglt) CREF(obj_3657))->type) = ((type_bglt) val1100_3658), BUNSPEC);
		      }
		    else
		      {		/* Cfa/tvector.scm 118 */
			 return BUNSPEC;
		      }
		 }
	      }
	   }
	 else
	   {	/* Cfa/tvector.scm 99 */
	      return BUNSPEC;
	   }
      }
   }
}



/* _unpatch-vector-set! */
obj_t 
_unpatch_vector_set__250_cfa_tvector(obj_t env_4392)
{
   AN_OBJECT;
   {	/* Cfa/tvector.scm 98 */
      return
	 unpatch_vector_set__139_cfa_tvector();
   }
}



/* vector->tvector! */
obj_t 
vector__tvector__205_cfa_tvector(obj_t globals_29)
{
   AN_OBJECT;
   {	/* Cfa/tvector.scm 125 */
      {		/* Cfa/tvector.scm 126 */
	 bool_t test_4583;
	 {	/* Cfa/tvector.scm 126 */
	    obj_t aux_4584;
	    aux_4584 =
	       tvector_optimization__143_cfa_tvector();
	    test_4583 =
	       CBOOL(aux_4584);
	 }
	 if (test_4583)
	   {	/* Cfa/tvector.scm 126 */
	      inline_setup__219_inline_walk(
		 CNST_TABLE_REF(((long) 3)));
	      {		/* Cfa/tvector.scm 135 */
		 obj_t tvectors_2360;
		 tvectors_2360 =
		    get_tvectors_38_cfa_tvector();
		 show_tvector_204_cfa_tvector(tvectors_2360);
		 if (
		    PAIRP(tvectors_2360))
		   {	/* Cfa/tvector.scm 139 */
		      obj_t add_tree_17_2362;
		      add_tree_17_2362 =
			 declare_tvectors_117_cfa_tvector(tvectors_2360);
		      patch_tree__164_cfa_tvector(globals_29);
		      return add_tree_17_2362;
		   }
		 else
		   {	/* Cfa/tvector.scm 138 */
		      return BNIL;
		   }
	      }
	   }
	 else
	   {	/* Cfa/tvector.scm 126 */
	      return BNIL;
	   }
      }
   }
}



/* _vector->tvector! */
obj_t 
_vector__tvector__184_cfa_tvector(obj_t env_4393, obj_t globals_4394)
{
   AN_OBJECT;
   {	/* Cfa/tvector.scm 125 */
      return
	 vector__tvector__205_cfa_tvector(globals_4394);
   }
}



/* add-make-vector! */
obj_t 
add_make_vector__104_cfa_tvector(node_bglt node_30)
{
   AN_OBJECT;
   {	/* Cfa/tvector.scm 155 */
      {		/* Cfa/tvector.scm 156 */
	 bool_t test_4596;
	 {	/* Cfa/tvector.scm 156 */
	    obj_t aux_4597;
	    aux_4597 =
	       tvector_optimization__143_cfa_tvector();
	    test_4596 =
	       CBOOL(aux_4597);
	 }
	 if (test_4596)
	   {	/* Cfa/tvector.scm 157 */
	      obj_t obj2_3661;
	      obj2_3661 = _make_vector_list__231_cfa_tvector;
	      {		/* ./Ieee/pair-list.scm 5689 */
		 obj_t aux_4600;
		 aux_4600 =
		    (obj_t) (node_30);
		 return (
		    _make_vector_list__231_cfa_tvector =
		    MAKE_PAIR(aux_4600, obj2_3661), BUNSPEC);
	      }
	   }
	 else
	   {	/* Cfa/tvector.scm 156 */
	      return BUNSPEC;
	   }
      }
   }
}



/* _add-make-vector! */
obj_t 
_add_make_vector__56_cfa_tvector(obj_t env_4395, obj_t node_4396)
{
   AN_OBJECT;
   {	/* Cfa/tvector.scm 155 */
      return
	 add_make_vector__104_cfa_tvector(
	 (node_bglt) (node_4396));
   }
}



/* get-tvectors */
obj_t 
get_tvectors_38_cfa_tvector()
{
   AN_OBJECT;
   {	/* Cfa/tvector.scm 165 */
      {
	 obj_t apps_2364;
	 obj_t tvectors_2365;
	 apps_2364 = _make_vector_list__231_cfa_tvector;
	 tvectors_2365 = BNIL;
       loop_2366:
	 if (
	    NULLP(apps_2364))
	   {	/* Cfa/tvector.scm 168 */
	      return tvectors_2365;
	   }
	 else
	   {	/* Cfa/tvector.scm 170 */
	      obj_t app_2368;
	      app_2368 =
		 CAR(apps_2364);
	      {		/* Cfa/tvector.scm 170 */
		 type_bglt type_2369;
		 type_2369 =
		    get_vector_item_type_88_cfa_tvector(
		    (app_bglt) (app_2368));
		 {	/* Cfa/tvector.scm 171 */

		    {	/* Cfa/tvector.scm 175 */
		       bool_t test2243_2370;
		       {	/* Cfa/tvector.scm 175 */
			  bool_t test2247_2374;
			  {	/* Cfa/tvector.scm 175 */
			     obj_t obj2_3665;
			     obj2_3665 = ____74_type_cache;
			     {	/* ./Ieee/equiv.scm 5508 */
				obj_t aux_4610;
				aux_4610 =
				   (obj_t) (type_2369);
				test2247_2374 =
				   (aux_4610 == obj2_3665);
			     }
			  }
			  if (test2247_2374)
			    {	/* Cfa/tvector.scm 175 */
			       test2243_2370 = ((bool_t) 0);
			    }
			  else
			    {	/* Cfa/tvector.scm 176 */
			       bool_t test2248_2375;
			       test2248_2375 =
				  sub_type__174_type_env(type_2369,
				  (type_bglt) (_obj__252_type_cache));
			       if (test2248_2375)
				 {	/* Cfa/tvector.scm 176 */
				    test2243_2370 = ((bool_t) 0);
				 }
			       else
				 {	/* Cfa/tvector.scm 176 */
				    test2243_2370 = ((bool_t) 1);
				 }
			    }
		       }
		       if (test2243_2370)
			 {	/* Cfa/tvector.scm 177 */
			    obj_t arg2244_2371;
			    obj_t arg2245_2372;
			    arg2244_2371 =
			       CDR(apps_2364);
			    arg2245_2372 =
			       MAKE_PAIR(app_2368, tvectors_2365);
			    {
			       obj_t tvectors_4621;
			       obj_t apps_4620;
			       apps_4620 = arg2244_2371;
			       tvectors_4621 = arg2245_2372;
			       tvectors_2365 = tvectors_4621;
			       apps_2364 = apps_4620;
			       goto loop_2366;
			    }
			 }
		       else
			 {
			    obj_t apps_4622;
			    apps_4622 =
			       CDR(apps_2364);
			    apps_2364 = apps_4622;
			    goto loop_2366;
			 }
		    }
		 }
	      }
	   }
      }
   }
}



/* show-tvector */
bool_t 
show_tvector_204_cfa_tvector(obj_t tvector_35)
{
   AN_OBJECT;
   {	/* Cfa/tvector.scm 206 */
      {		/* Cfa/tvector.scm 207 */
	 obj_t list2249_2376;
	 {	/* Cfa/tvector.scm 207 */
	    obj_t arg2251_2378;
	    {	/* Cfa/tvector.scm 207 */
	       obj_t aux_4624;
	       aux_4624 =
		  BCHAR(((unsigned char) '\n'));
	       arg2251_2378 =
		  MAKE_PAIR(aux_4624, BNIL);
	    }
	    list2249_2376 =
	       MAKE_PAIR(string2774_cfa_tvector, arg2251_2378);
	 }
	 verbose_tools_speek(
	    BINT(((long) 1)), list2249_2376);
      }
      {
	 obj_t l2074_2379;
	 l2074_2379 = tvector_35;
       lname2075_2380:
	 if (
	    PAIRP(l2074_2379))
	   {	/* Cfa/tvector.scm 208 */
	      {		/* Cfa/tvector.scm 209 */
		 obj_t arg2255_2385;
		 obj_t arg2257_2387;
		 arg2255_2385 =
		    shape_tools_shape(_obj__252_type_cache);
		 {	/* Cfa/tvector.scm 212 */
		    type_bglt arg2264_2393;
		    {	/* Cfa/tvector.scm 212 */
		       app_bglt aux_4633;
		       {	/* Cfa/tvector.scm 212 */
			  obj_t aux_4634;
			  aux_4634 =
			     CAR(l2074_2379);
			  aux_4633 =
			     (app_bglt) (aux_4634);
		       }
		       arg2264_2393 =
			  get_vector_item_type_88_cfa_tvector(aux_4633);
		    }
		    arg2257_2387 =
		       shape_tools_shape(
		       (obj_t) (arg2264_2393));
		 }
		 {	/* Cfa/tvector.scm 209 */
		    obj_t list2258_2388;
		    {	/* Cfa/tvector.scm 209 */
		       obj_t arg2259_2389;
		       {	/* Cfa/tvector.scm 209 */
			  obj_t arg2260_2390;
			  {	/* Cfa/tvector.scm 209 */
			     obj_t arg2261_2391;
			     {	/* Cfa/tvector.scm 209 */
				obj_t arg2263_2392;
				{	/* Cfa/tvector.scm 209 */
				   obj_t aux_4640;
				   aux_4640 =
				      BCHAR(((unsigned char) '\n'));
				   arg2263_2392 =
				      MAKE_PAIR(aux_4640, BNIL);
				}
				arg2261_2391 =
				   MAKE_PAIR(arg2257_2387, arg2263_2392);
			     }
			     arg2260_2390 =
				MAKE_PAIR(string2775_cfa_tvector, arg2261_2391);
			  }
			  arg2259_2389 =
			     MAKE_PAIR(arg2255_2385, arg2260_2390);
		       }
		       list2258_2388 =
			  MAKE_PAIR(string2776_cfa_tvector, arg2259_2389);
		    }
		    verbose_tools_speek(
		       BINT(((long) 2)), list2258_2388);
		 }
	      }
	      {
		 obj_t l2074_4649;
		 l2074_4649 =
		    CDR(l2074_2379);
		 l2074_2379 = l2074_4649;
		 goto lname2075_2380;
	      }
	   }
	 else
	   {	/* Cfa/tvector.scm 208 */
	      return ((bool_t) 1);
	   }
      }
   }
}



/* declare-tvectors */
obj_t 
declare_tvectors_117_cfa_tvector(obj_t tvector_36)
{
   AN_OBJECT;
   {	/* Cfa/tvector.scm 219 */
      {
	 obj_t l2076_2395;
	 l2076_2395 = tvector_36;
       lname2077_2396:
	 if (
	    PAIRP(l2076_2395))
	   {	/* Cfa/tvector.scm 221 */
	      {		/* Cfa/tvector.scm 222 */
		 type_bglt type_2399;
		 {	/* Cfa/tvector.scm 222 */
		    app_bglt aux_4653;
		    {	/* Cfa/tvector.scm 222 */
		       obj_t aux_4654;
		       aux_4654 =
			  CAR(l2076_2395);
		       aux_4653 =
			  (app_bglt) (aux_4654);
		    }
		    type_2399 =
		       get_vector_item_type_88_cfa_tvector(aux_4653);
		 }
		 {	/* Cfa/tvector.scm 224 */
		    bool_t test2267_2401;
		    test2267_2401 =
		       is_a__118___object(
		       (((type_bglt) CREF(type_2399))->tvector), type_type_type);
		    if (test2267_2401)
		      {		/* Cfa/tvector.scm 224 */
			 BUNSPEC;
		      }
		    else
		      {		/* Cfa/tvector.scm 225 */
			 obj_t tv_id_119_2402;
			 {	/* Cfa/tvector.scm 225 */
			    obj_t arg2280_2413;
			    arg2280_2413 =
			       CNST_TABLE_REF(((long) 4));
			    {	/* Cfa/tvector.scm 225 */
			       obj_t list2282_2415;
			       {	/* Cfa/tvector.scm 225 */
				  obj_t arg2283_2416;
				  {	/* Cfa/tvector.scm 225 */
				     obj_t aux_4662;
				     aux_4662 =
					(((type_bglt) CREF(type_2399))->id);
				     arg2283_2416 =
					MAKE_PAIR(aux_4662, BNIL);
				  }
				  list2282_2415 =
				     MAKE_PAIR(arg2280_2413, arg2283_2416);
			       }
			       tv_id_119_2402 =
				  symbol_append_197___r4_symbols_6_4(list2282_2415);
			    }
			 }
			 {	/* Cfa/tvector.scm 227 */
			    obj_t arg2268_2403;
			    {	/* Cfa/tvector.scm 227 */
			       obj_t arg2269_2404;
			       {	/* Cfa/tvector.scm 227 */
				  obj_t arg2271_2406;
				  obj_t arg2272_2407;
				  arg2271_2406 =
				     CNST_TABLE_REF(((long) 5));
				  {	/* Cfa/tvector.scm 227 */
				     obj_t arg2273_2408;
				     {	/* Cfa/tvector.scm 227 */
					obj_t arg2274_2409;
					{	/* ./Ieee/pair-list.scm 5689 */
					   obj_t aux_4668;
					   aux_4668 =
					      (((type_bglt) CREF(type_2399))->id);
					   arg2274_2409 =
					      MAKE_PAIR(aux_4668, BNIL);
					}
					arg2273_2408 =
					   MAKE_PAIR(arg2274_2409, BNIL);
				     }
				     arg2272_2407 =
					MAKE_PAIR(tv_id_119_2402, arg2273_2408);
				  }
				  arg2269_2404 =
				     MAKE_PAIR(arg2271_2406, arg2272_2407);
			       }
			       arg2268_2403 =
				  type_parser_173_module_type(arg2269_2404, BNIL);
			    }
			    ((((type_bglt) CREF(type_2399))->tvector) = ((obj_t) arg2268_2403), BUNSPEC);
			 }
		      }
		 }
	      }
	      {
		 obj_t l2076_4676;
		 l2076_4676 =
		    CDR(l2076_2395);
		 l2076_2395 = l2076_4676;
		 goto lname2077_2396;
	      }
	   }
	 else
	   {	/* Cfa/tvector.scm 221 */
	      ((bool_t) 1);
	   }
      }
      {		/* Cfa/tvector.scm 231 */
	 type_bglt old_default_type_182_2419;
	 old_default_type_182_2419 =
	    get_default_type_181_type_cache();
	 set_default_type__106_type_cache(
	    (type_bglt) (_obj__252_type_cache));
	 {	/* Cfa/tvector.scm 233 */
	    obj_t tvector_unit_55_2420;
	    tvector_unit_55_2420 =
	       tvector_finalizer_246_module_type();
	    pragma_finalizer_170_module_pragma();
	    {	/* Cfa/tvector.scm 235 */
	       obj_t res_2421;
	       {	/* Cfa/tvector.scm 235 */
		  bool_t test_4683;
		  if (
		     STRUCTP(tvector_unit_55_2420))
		    {	/* ./Ieee/equiv.scm 5508 */
		       obj_t aux_4688;
		       obj_t aux_4686;
		       aux_4688 =
			  CNST_TABLE_REF(((long) 6));
		       aux_4686 =
			  STRUCT_KEY(tvector_unit_55_2420);
		       test_4683 =
			  (aux_4686 == aux_4688);
		    }
		  else
		    {	/* ./Ast/unit.sch 903 */
		       test_4683 = ((bool_t) 0)
			  ;
		    }
		  if (test_4683)
		    {	/* Cfa/tvector.scm 237 */
		       obj_t arg2287_2423;
		       obj_t arg2288_2424;
		       {	/* Cfa/tvector.scm 237 */
			  obj_t arg2289_2425;
			  {	/* Cfa/tvector.scm 237 */
			     obj_t list2290_2426;
			     list2290_2426 =
				MAKE_PAIR(tvector_unit_55_2420, BNIL);
			     arg2289_2425 = list2290_2426;
			  }
			  arg2287_2423 =
			     build_ast_sans_remove_93_ast_build(arg2289_2425);
		       }
		       arg2288_2424 =
			  CNST_TABLE_REF(((long) 7));
		       res_2421 =
			  globalize_walk__63_globalize_walk(arg2287_2423, arg2288_2424);
		    }
		  else
		    {	/* Cfa/tvector.scm 235 */
		       res_2421 = BNIL;
		    }
	       }
	       set_default_type__106_type_cache(old_default_type_182_2419);
	       return res_2421;
	    }
	 }
      }
   }
}



/* patch-tree! */
bool_t 
patch_tree__164_cfa_tvector(obj_t globals_37)
{
   AN_OBJECT;
   {	/* Cfa/tvector.scm 250 */
      {
	 obj_t l2079_2427;
	 l2079_2427 = globals_37;
       lname2080_2428:
	 if (
	    PAIRP(l2079_2427))
	   {	/* Cfa/tvector.scm 251 */
	      patch_fun__141_cfa_tvector(
		 CAR(l2079_2427));
	      {
		 obj_t l2079_4700;
		 l2079_4700 =
		    CDR(l2079_2427);
		 l2079_2427 = l2079_4700;
		 goto lname2080_2428;
	      }
	   }
	 else
	   {	/* Cfa/tvector.scm 251 */
	      return ((bool_t) 1);
	   }
      }
   }
}



/* patch-fun! */
obj_t 
patch_fun__141_cfa_tvector(obj_t variable_38)
{
   AN_OBJECT;
   {	/* Cfa/tvector.scm 256 */
      {		/* Cfa/tvector.scm 257 */
	 value_bglt fun_2432;
	 {	/* Cfa/tvector.scm 257 */
	    variable_bglt obj_3702;
	    obj_3702 =
	       (variable_bglt) (variable_38);
	    fun_2432 =
	       (((variable_bglt) CREF(obj_3702))->value);
	 }
	 {	/* Cfa/tvector.scm 260 */
	    obj_t arg2294_2433;
	    {	/* Cfa/tvector.scm 260 */
	       node_bglt aux_4704;
	       {	/* Cfa/tvector.scm 260 */
		  obj_t aux_4705;
		  {	/* Cfa/tvector.scm 260 */
		     sfun_bglt obj_3703;
		     obj_3703 =
			(sfun_bglt) (fun_2432);
		     aux_4705 =
			(((sfun_bglt) CREF(obj_3703))->body);
		  }
		  aux_4704 =
		     (node_bglt) (aux_4705);
	       }
	       arg2294_2433 =
		  patch__227_cfa_tvector(aux_4704);
	    }
	    {	/* Cfa/tvector.scm 260 */
	       sfun_bglt obj_3704;
	       obj_3704 =
		  (sfun_bglt) (fun_2432);
	       return
		  ((((sfun_bglt) CREF(obj_3704))->body) = ((obj_t) arg2294_2433), BUNSPEC);
	    }
	 }
      }
   }
}



/* patch*! */
obj_t 
patch___72_cfa_tvector(obj_t node__221_62)
{
   AN_OBJECT;
   {	/* Cfa/tvector.scm 452 */
      {
	 obj_t node__221_2435;
	 node__221_2435 = node__221_62;
       loop_2436:
	 if (
	    NULLP(node__221_2435))
	   {	/* Cfa/tvector.scm 454 */
	      return
		 CNST_TABLE_REF(((long) 8));
	   }
	 else
	   {	/* Cfa/tvector.scm 454 */
	      {		/* Cfa/tvector.scm 457 */
		 obj_t arg2297_2438;
		 {	/* Cfa/tvector.scm 457 */
		    node_bglt aux_4715;
		    {	/* Cfa/tvector.scm 457 */
		       obj_t aux_4716;
		       aux_4716 =
			  CAR(node__221_2435);
		       aux_4715 =
			  (node_bglt) (aux_4716);
		    }
		    arg2297_2438 =
		       patch__227_cfa_tvector(aux_4715);
		 }
		 SET_CAR(node__221_2435, arg2297_2438);
	      }
	      {
		 obj_t node__221_4721;
		 node__221_4721 =
		    CDR(node__221_2435);
		 node__221_2435 = node__221_4721;
		 goto loop_2436;
	      }
	   }
      }
   }
}



/* patch-vector-length! */
obj_t 
patch_vector_length__86_cfa_tvector(app_bglt node_64)
{
   AN_OBJECT;
   {	/* Cfa/tvector.scm 486 */
      patch___72_cfa_tvector(
	 (((app_bglt) CREF(node_64))->args));
      {		/* Cfa/tvector.scm 489 */
	 approx_bglt approx_2443;
	 {	/* Cfa/tvector.scm 489 */
	    node_bglt aux_4725;
	    {	/* Cfa/tvector.scm 489 */
	       obj_t aux_4726;
	       {	/* ./Ieee/pair-list.scm 5701 */
		  obj_t aux_4727;
		  aux_4727 =
		     (((app_bglt) CREF(node_64))->args);
		  aux_4726 =
		     CAR(aux_4727);
	       }
	       aux_4725 =
		  (node_bglt) (aux_4726);
	    }
	    approx_2443 =
	       cfa__102_cfa_cfa(aux_4725);
	 }
	 {	/* Cfa/tvector.scm 489 */
	    obj_t tv_2444;
	    tv_2444 =
	       get_approx_type_210_cfa_type(approx_2443);
	    {	/* Cfa/tvector.scm 490 */

	       {	/* Cfa/tvector.scm 491 */
		  bool_t test2301_2445;
		  test2301_2445 =
		     is_a__118___object(tv_2444, tvec_tvector_tvector);
		  if (test2301_2445)
		    {	/* Cfa/tvector.scm 492 */
		       obj_t length_tv_142_2446;
		       {	/* Cfa/tvector.scm 492 */
			  obj_t arg2309_2455;
			  {	/* Cfa/tvector.scm 492 */
			     type_bglt obj_3715;
			     obj_3715 =
				(type_bglt) (tv_2444);
			     arg2309_2455 =
				(((type_bglt) CREF(obj_3715))->id);
			  }
			  {	/* Cfa/tvector.scm 492 */
			     obj_t list2311_2457;
			     {	/* Cfa/tvector.scm 492 */
				obj_t arg2312_2458;
				{	/* Cfa/tvector.scm 492 */
				   obj_t aux_4737;
				   aux_4737 =
				      CNST_TABLE_REF(((long) 9));
				   arg2312_2458 =
				      MAKE_PAIR(aux_4737, BNIL);
				}
				list2311_2457 =
				   MAKE_PAIR(arg2309_2455, arg2312_2458);
			     }
			     length_tv_142_2446 =
				symbol_append_197___r4_symbols_6_4(list2311_2457);
			  }
		       }
		       {	/* Cfa/tvector.scm 492 */
			  node_bglt new_node_11_2447;
			  {	/* Cfa/tvector.scm 493 */
			     obj_t arg2302_2448;
			     obj_t arg2304_2450;
			     obj_t arg2305_2451;
			     {	/* ./Ieee/pair-list.scm 5689 */
				obj_t aux_4742;
				aux_4742 =
				   append_2_18___r4_pairs_and_lists_6_3(
				   (((app_bglt) CREF(node_64))->args), BNIL);
				arg2302_2448 =
				   MAKE_PAIR(length_tv_142_2446, aux_4742);
			     }
			     arg2304_2450 =
				(((app_bglt) CREF(node_64))->loc);
			     arg2305_2451 =
				CNST_TABLE_REF(((long) 10));
			     new_node_11_2447 =
				sexp__node_235_ast_sexp(arg2302_2448, BNIL, arg2304_2450, arg2305_2451);
			  }
			  {	/* Cfa/tvector.scm 493 */

			     {	/* Cfa/tvector.scm 497 */
				type_bglt val1202_3721;
				val1202_3721 =
				   (type_bglt) (_long__149_type_cache);
				((((node_bglt) CREF(new_node_11_2447))->type) = ((type_bglt) val1202_3721), BUNSPEC);
			     }
			     {	/* Cfa/tvector.scm 498 */
				node_bglt aux_4751;
				aux_4751 =
				   inline_node_218_inline_inline(new_node_11_2447, ((long) 1), BNIL);
				return
				   (obj_t) (aux_4751);
			     }
			  }
		       }
		    }
		  else
		    {	/* Cfa/tvector.scm 491 */
		       return
			  (obj_t) (node_64);
		    }
	       }
	    }
	 }
      }
   }
}



/* patch-vector?! */
obj_t 
patch_vector___0_cfa_tvector(app_bglt node_65)
{
   AN_OBJECT;
   {	/* Cfa/tvector.scm 504 */
      patch___72_cfa_tvector(
	 (((app_bglt) CREF(node_65))->args));
      {		/* Cfa/tvector.scm 507 */
	 approx_bglt approx_2463;
	 {	/* Cfa/tvector.scm 507 */
	    node_bglt aux_4757;
	    {	/* Cfa/tvector.scm 507 */
	       obj_t aux_4758;
	       {	/* ./Ieee/pair-list.scm 5701 */
		  obj_t aux_4759;
		  aux_4759 =
		     (((app_bglt) CREF(node_65))->args);
		  aux_4758 =
		     CAR(aux_4759);
	       }
	       aux_4757 =
		  (node_bglt) (aux_4758);
	    }
	    approx_2463 =
	       cfa__102_cfa_cfa(aux_4757);
	 }
	 {	/* Cfa/tvector.scm 508 */

	    {	/* Cfa/tvector.scm 509 */
	       bool_t test2316_2465;
	       {	/* Cfa/tvector.scm 509 */
		  obj_t obj2_3727;
		  obj2_3727 = _vector__240_type_cache;
		  {	/* ./Ieee/equiv.scm 5508 */
		     obj_t aux_4764;
		     {	/* Cfa/tvector.scm 509 */
			type_bglt aux_4765;
			aux_4765 =
			   (((approx_bglt) CREF(approx_2463))->type);
			aux_4764 =
			   (obj_t) (aux_4765);
		     }
		     test2316_2465 =
			(aux_4764 == obj2_3727);
		  }
	       }
	       if (test2316_2465)
		 {	/* Cfa/tvector.scm 510 */
		    obj_t arg2317_2466;
		    obj_t arg2318_2467;
		    arg2317_2466 =
		       (((app_bglt) CREF(node_65))->loc);
		    arg2318_2467 = _bool__149_type_cache;
		    {	/* Cfa/tvector.scm 510 */
		       atom_bglt res2770_3739;
		       {	/* Cfa/tvector.scm 510 */
			  type_bglt type_3730;
			  obj_t value_3731;
			  type_3730 =
			     (type_bglt) (arg2318_2467);
			  value_3731 = BTRUE;
			  {	/* ./Ast/node.scm 1665 */
			     atom_bglt new1220_3732;
			     new1220_3732 =
				((atom_bglt) BREF(GC_MALLOC(sizeof(struct atom))));
			     {	/* ./Ast/node.scm 1665 */
				long arg2534_3733;
				arg2534_3733 =
				   class_num_218___object(atom_ast_node);
				{	/* ./Ast/node.scm 1665 */
				   obj_t obj_3737;
				   obj_3737 =
				      (obj_t) (new1220_3732);
				   (((obj_t) CREF(obj_3737))->header = MAKE_HEADER(arg2534_3733, 0), BUNSPEC);
				}
			     }
			     {	/* ./Ast/node.scm 1665 */
				object_bglt aux_4776;
				aux_4776 =
				   (object_bglt) (new1220_3732);
				OBJECT_WIDENING_SET(aux_4776, BFALSE);
			     }
			     ((((atom_bglt) CREF(new1220_3732))->loc) = ((obj_t) arg2317_2466), BUNSPEC);
			     ((((atom_bglt) CREF(new1220_3732))->type) = ((type_bglt) type_3730), BUNSPEC);
			     ((((atom_bglt) CREF(new1220_3732))->value) = ((obj_t) value_3731), BUNSPEC);
			     res2770_3739 = new1220_3732;
			  }
		       }
		       return
			  (obj_t) (res2770_3739);
		    }
		 }
	       else
		 {	/* Cfa/tvector.scm 509 */
		    return
		       (obj_t) (node_65);
		 }
	    }
	 }
      }
   }
}



/* patch-vector->list! */
obj_t 
patch_vector__list__149_cfa_tvector(app_bglt node_66)
{
   AN_OBJECT;
   {	/* Cfa/tvector.scm 519 */
      patch___72_cfa_tvector(
	 (((app_bglt) CREF(node_66))->args));
      {		/* Cfa/tvector.scm 522 */
	 approx_bglt approx_2473;
	 {	/* Cfa/tvector.scm 522 */
	    node_bglt aux_4786;
	    {	/* Cfa/tvector.scm 522 */
	       obj_t aux_4787;
	       {	/* ./Ieee/pair-list.scm 5701 */
		  obj_t aux_4788;
		  aux_4788 =
		     (((app_bglt) CREF(node_66))->args);
		  aux_4787 =
		     CAR(aux_4788);
	       }
	       aux_4786 =
		  (node_bglt) (aux_4787);
	    }
	    approx_2473 =
	       cfa__102_cfa_cfa(aux_4786);
	 }
	 {	/* Cfa/tvector.scm 522 */
	    obj_t tv_2474;
	    tv_2474 =
	       get_approx_type_210_cfa_type(approx_2473);
	    {	/* Cfa/tvector.scm 523 */

	       {	/* Cfa/tvector.scm 524 */
		  bool_t test2323_2475;
		  test2323_2475 =
		     is_a__118___object(tv_2474, tvec_tvector_tvector);
		  if (test2323_2475)
		    {	/* Cfa/tvector.scm 525 */
		       obj_t tv__list_235_2476;
		       {	/* Cfa/tvector.scm 525 */
			  obj_t arg2332_2486;
			  {	/* Cfa/tvector.scm 525 */
			     type_bglt obj_3744;
			     obj_3744 =
				(type_bglt) (tv_2474);
			     arg2332_2486 =
				(((type_bglt) CREF(obj_3744))->id);
			  }
			  {	/* Cfa/tvector.scm 525 */
			     obj_t list2334_2488;
			     {	/* Cfa/tvector.scm 525 */
				obj_t arg2335_2489;
				{	/* Cfa/tvector.scm 525 */
				   obj_t aux_4798;
				   aux_4798 =
				      CNST_TABLE_REF(((long) 11));
				   arg2335_2489 =
				      MAKE_PAIR(aux_4798, BNIL);
				}
				list2334_2488 =
				   MAKE_PAIR(arg2332_2486, arg2335_2489);
			     }
			     tv__list_235_2476 =
				symbol_append_197___r4_symbols_6_4(list2334_2488);
			  }
		       }
		       {	/* Cfa/tvector.scm 525 */
			  node_bglt new_node_11_2477;
			  {	/* Cfa/tvector.scm 526 */
			     obj_t arg2325_2479;
			     obj_t arg2327_2481;
			     obj_t arg2328_2482;
			     {	/* ./Ieee/pair-list.scm 5689 */
				obj_t aux_4803;
				aux_4803 =
				   append_2_18___r4_pairs_and_lists_6_3(
				   (((app_bglt) CREF(node_66))->args), BNIL);
				arg2325_2479 =
				   MAKE_PAIR(tv__list_235_2476, aux_4803);
			     }
			     arg2327_2481 =
				(((app_bglt) CREF(node_66))->loc);
			     arg2328_2482 =
				CNST_TABLE_REF(((long) 10));
			     new_node_11_2477 =
				sexp__node_235_ast_sexp(arg2325_2479, BNIL, arg2327_2481, arg2328_2482);
			  }
			  {	/* Cfa/tvector.scm 526 */

			     {	/* Cfa/tvector.scm 530 */
				type_bglt arg2324_2478;
				{	/* Cfa/tvector.scm 530 */
				   node_bglt obj_3749;
				   obj_3749 =
				      (node_bglt) (node_66);
				   arg2324_2478 =
				      (((node_bglt) CREF(obj_3749))->type);
				}
				((((node_bglt) CREF(new_node_11_2477))->type) = ((type_bglt) arg2324_2478), BUNSPEC);
			     }
			     return
				(obj_t) (new_node_11_2477);
			  }
		       }
		    }
		  else
		    {	/* Cfa/tvector.scm 524 */
		       return
			  (obj_t) (node_66);
		    }
	       }
	    }
	 }
      }
   }
}



/* method-init */
obj_t 
method_init_76_cfa_tvector()
{
   AN_OBJECT;
   {	/* Cfa/tvector.scm 14 */
      add_generic__110___object(get_vector_item_type_env_168_cfa_tvector, get_vector_item_type_default2118_env_225_cfa_tvector);
      add_inlined_method__244___object(get_vector_item_type_env_168_cfa_tvector, make_vector_app_205_cfa_info2, ((long) 0));
      add_inlined_method__244___object(get_vector_item_type_env_168_cfa_tvector, create_vector_app_150_cfa_info2, ((long) 1));
      add_generic__110___object(patch__env_129_cfa_tvector, patch__default2123_env_126_cfa_tvector);
      add_inlined_method__244___object(patch__env_129_cfa_tvector, atom_ast_node, ((long) 0));
      add_inlined_method__244___object(patch__env_129_cfa_tvector, kwote_ast_node, ((long) 1));
      add_inlined_method__244___object(patch__env_129_cfa_tvector, kwote_node_102_cfa_info, ((long) 2));
      add_inlined_method__244___object(patch__env_129_cfa_tvector, var_ast_node, ((long) 3));
      add_inlined_method__244___object(patch__env_129_cfa_tvector, closure_ast_node, ((long) 4));
      add_inlined_method__244___object(patch__env_129_cfa_tvector, sequence_ast_node, ((long) 5));
      add_inlined_method__244___object(patch__env_129_cfa_tvector, app_ly_162_ast_node, ((long) 6));
      add_inlined_method__244___object(patch__env_129_cfa_tvector, funcall_ast_node, ((long) 7));
      add_inlined_method__244___object(patch__env_129_cfa_tvector, pragma_ast_node, ((long) 8));
      add_inlined_method__244___object(patch__env_129_cfa_tvector, cast_ast_node, ((long) 9));
      add_inlined_method__244___object(patch__env_129_cfa_tvector, setq_ast_node, ((long) 10));
      add_inlined_method__244___object(patch__env_129_cfa_tvector, conditional_ast_node, ((long) 11));
      add_inlined_method__244___object(patch__env_129_cfa_tvector, fail_ast_node, ((long) 12));
      add_inlined_method__244___object(patch__env_129_cfa_tvector, select_ast_node, ((long) 13));
      add_inlined_method__244___object(patch__env_129_cfa_tvector, let_fun_218_ast_node, ((long) 14));
      add_inlined_method__244___object(patch__env_129_cfa_tvector, let_var_6_ast_node, ((long) 15));
      add_inlined_method__244___object(patch__env_129_cfa_tvector, set_ex_it_116_ast_node, ((long) 16));
      add_inlined_method__244___object(patch__env_129_cfa_tvector, jump_ex_it_184_ast_node, ((long) 17));
      add_inlined_method__244___object(patch__env_129_cfa_tvector, make_box_202_ast_node, ((long) 18));
      add_inlined_method__244___object(patch__env_129_cfa_tvector, box_set__221_ast_node, ((long) 19));
      add_inlined_method__244___object(patch__env_129_cfa_tvector, box_ref_242_ast_node, ((long) 20));
      add_inlined_method__244___object(patch__env_129_cfa_tvector, app_ast_node, ((long) 21));
      add_inlined_method__244___object(patch__env_129_cfa_tvector, make_vector_app_205_cfa_info2, ((long) 22));
      add_inlined_method__244___object(patch__env_129_cfa_tvector, create_vector_app_150_cfa_info2, ((long) 23));
      add_inlined_method__244___object(patch__env_129_cfa_tvector, vector_ref_app_195_cfa_info2, ((long) 24));
      {		/* Cfa/tvector.scm 14 */
	 long aux_4844;
	 aux_4844 =
	    add_inlined_method__244___object(patch__env_129_cfa_tvector, vector_set__app_21_cfa_info2, ((long) 25));
	 return
	    BINT(aux_4844);
      }
   }
}



/* get-vector-item-type */
type_bglt 
get_vector_item_type_88_cfa_tvector(app_bglt app_31)
{
   AN_OBJECT;
   {	/* Cfa/tvector.scm 183 */
      {
	 obj_t method2746_3527;
	 obj_t class2751_3528;
	 {	/* Cfa/tvector.scm 183 */
	    obj_t arg2754_3525;
	    obj_t arg2755_3526;
	    {	/* Cfa/tvector.scm 183 */
	       object_bglt obj_4121;
	       obj_4121 =
		  (object_bglt) (app_31);
	       {	/* ./Llib/object.scm 2926 */
		  obj_t pre_method_105_4122;
		  pre_method_105_4122 =
		     PROCEDURE_REF(get_vector_item_type_env_168_cfa_tvector, ((long) 2));
		  if (
		     INTEGERP(pre_method_105_4122))
		    {	/* ./Llib/object.scm 2927 */
		       PROCEDURE_SET(get_vector_item_type_env_168_cfa_tvector, ((long) 2), BUNSPEC);
		       arg2754_3525 = pre_method_105_4122;
		    }
		  else
		    {	/* ./Llib/object.scm 2914 */
		       long obj_class_num_177_4127;
		       obj_class_num_177_4127 =
			  TYPE(obj_4121);
		       {	/* ./Llib/object.scm 2915 */
			  obj_t arg1176_4128;
			  arg1176_4128 =
			     PROCEDURE_REF(get_vector_item_type_env_168_cfa_tvector, ((long) 1));
			  {	/* ./Llib/object.scm 2738 */
			     long arg1177_4132;
			     {	/* ./Llib/object.scm 2738 */
				long arg1178_4133;
				arg1178_4133 =
				   OBJECT_TYPE;
				arg1177_4132 =
				   (obj_class_num_177_4127 - arg1178_4133);
			     }
			     arg2754_3525 =
				VECTOR_REF(arg1176_4128, arg1177_4132);
			  }
		       }
		    }
	       }
	    }
	    {	/* Cfa/tvector.scm 183 */
	       object_bglt object_4138;
	       object_4138 =
		  (object_bglt) (app_31);
	       {	/* ./Llib/object.scm 2695 */
		  long arg1179_4139;
		  {	/* ./Llib/object.scm 2695 */
		     long arg1180_4140;
		     long arg1181_4141;
		     arg1180_4140 =
			TYPE(object_4138);
		     arg1181_4141 =
			OBJECT_TYPE;
		     arg1179_4139 =
			(arg1180_4140 - arg1181_4141);
		  }
		  {	/* ./Llib/object.scm 2695 */
		     obj_t vector_4145;
		     vector_4145 = _classes__134___object;
		     arg2755_3526 =
			VECTOR_REF(vector_4145, arg1179_4139);
		  }
	       }
	    }
	    {	/* Cfa/tvector.scm 183 */
	       obj_t aux_4862;
	       method2746_3527 = arg2754_3525;
	       class2751_3528 = arg2755_3526;
	       {

		  if (
		     INTEGERP(method2746_3527))
		    {	/* Cfa/tvector.scm 183 */
		       switch (
			  (long) CINT(method2746_3527))
			 {
			 case ((long) 0):

			    {	/* Cfa/tvector.scm 189 */
			       make_vector_app_205_bglt app_3534;
			       app_3534 =
				  (make_vector_app_205_bglt) (app_31);
			       {	/* Cfa/tvector.scm 190 */
				  bool_t test_4866;
				  {
				     obj_t aux_4867;
				     {	/* ./Cfa/cinfo2.scm 2180 */
					object_bglt aux_4868;
					aux_4868 =
					   (object_bglt) (app_3534);
					aux_4867 =
					   OBJECT_WIDENING(aux_4868);
				     }
				     test_4866 =
					(((make_vector_app_205_bglt) CREF(aux_4867))->seen__39);
				  }
				  if (test_4866)
				    {	/* Cfa/tvector.scm 192 */
				       approx_bglt arg2759_3537;
				       {
					  obj_t aux_4872;
					  {	/* ./Cfa/cinfo2.scm 2161 */
					     object_bglt aux_4873;
					     aux_4873 =
						(object_bglt) (app_3534);
					     aux_4872 =
						OBJECT_WIDENING(aux_4873);
					  }
					  arg2759_3537 =
					     (((make_vector_app_205_bglt) CREF(aux_4872))->value_approx_19);
				       }
				       {	/* ./Cfa/cinfo.scm 2026 */
					  type_bglt aux_4877;
					  aux_4877 =
					     (((approx_bglt) CREF(arg2759_3537))->type);
					  aux_4862 =
					     (obj_t) (aux_4877);
				       }
				    }
				  else
				    {	/* Cfa/tvector.scm 190 */
				       aux_4862 = _vector__240_type_cache
					  ;
				    }
			       }
			    }
			    break;
			 case ((long) 1):

			    {	/* Cfa/tvector.scm 198 */
			       create_vector_app_150_bglt app_3538;
			       app_3538 =
				  (create_vector_app_150_bglt) (app_31);
			       {	/* Cfa/tvector.scm 199 */
				  bool_t test_4881;
				  {
				     obj_t aux_4882;
				     {	/* ./Cfa/cinfo2.scm 2197 */
					object_bglt aux_4883;
					aux_4883 =
					   (object_bglt) (app_3538);
					aux_4882 =
					   OBJECT_WIDENING(aux_4883);
				     }
				     test_4881 =
					(((create_vector_app_150_bglt) CREF(aux_4882))->seen__39);
				  }
				  if (test_4881)
				    {	/* Cfa/tvector.scm 201 */
				       approx_bglt arg2762_3541;
				       {
					  obj_t aux_4887;
					  {	/* ./Cfa/cinfo2.scm 2185 */
					     object_bglt aux_4888;
					     aux_4888 =
						(object_bglt) (app_3538);
					     aux_4887 =
						OBJECT_WIDENING(aux_4888);
					  }
					  arg2762_3541 =
					     (((create_vector_app_150_bglt) CREF(aux_4887))->value_approx_19);
				       }
				       {	/* ./Cfa/cinfo.scm 2026 */
					  type_bglt aux_4892;
					  aux_4892 =
					     (((approx_bglt) CREF(arg2762_3541))->type);
					  aux_4862 =
					     (obj_t) (aux_4892);
				       }
				    }
				  else
				    {	/* Cfa/tvector.scm 199 */
				       aux_4862 = _vector__240_type_cache
					  ;
				    }
			       }
			    }
			    break;
			 default:
			  case_else2752_3531:
			    if (
			       PROCEDUREP(method2746_3527))
			      {		/* Cfa/tvector.scm 183 */
				 aux_4862 =
				    PROCEDURE_ENTRY(method2746_3527) (method2746_3527,
				    (obj_t) (app_31), BEOA)
				    ;
			      }
			    else
			      {		/* Cfa/tvector.scm 183 */
				 obj_t fun2566_3263;
				 fun2566_3263 =
				    PROCEDURE_REF(get_vector_item_type_env_168_cfa_tvector, ((long) 0));
				 aux_4862 =
				    PROCEDURE_ENTRY(fun2566_3263) (fun2566_3263,
				    (obj_t) (app_31), BEOA);
			      }
			 }
		    }
		  else
		    {	/* Cfa/tvector.scm 183 */
		       goto case_else2752_3531;
		    }
	       }
	       return
		  (type_bglt) (aux_4862);
	    }
	 }
      }
   }
}



/* _get-vector-item-type */
obj_t 
_get_vector_item_type_42_cfa_tvector(obj_t env_4397, obj_t app_4398)
{
   AN_OBJECT;
   {	/* Cfa/tvector.scm 183 */
      {		/* Cfa/tvector.scm 183 */
	 type_bglt aux_4907;
	 aux_4907 =
	    get_vector_item_type_88_cfa_tvector(
	    (app_bglt) (app_4398));
	 return
	    (obj_t) (aux_4907);
      }
   }
}



/* get-vector-item-type-default2118 */
obj_t 
get_vector_item_type_default2118_14_cfa_tvector(app_bglt app_32)
{
   AN_OBJECT;
   {	/* Cfa/tvector.scm 14 */
      FAILURE(
	 CNST_TABLE_REF(((long) 12)), string2777_cfa_tvector,
	 (obj_t) (app_32));
   }
}



/* _get-vector-item-type-default2118 */
obj_t 
_get_vector_item_type_default2118_240_cfa_tvector(obj_t env_4399, obj_t app_4400)
{
   AN_OBJECT;
   {	/* Cfa/tvector.scm 14 */
      return
	 get_vector_item_type_default2118_14_cfa_tvector(
	 (app_bglt) (app_4400));
   }
}



/* patch! */
obj_t 
patch__227_cfa_tvector(node_bglt node_39)
{
   AN_OBJECT;
   {	/* Cfa/tvector.scm 265 */
      {
	 obj_t method2568_3268;
	 obj_t class2573_3269;
	 {	/* Cfa/tvector.scm 265 */
	    obj_t arg2576_3266;
	    obj_t arg2578_3267;
	    {	/* Cfa/tvector.scm 265 */
	       object_bglt obj_4158;
	       obj_4158 =
		  (object_bglt) (node_39);
	       {	/* ./Llib/object.scm 2926 */
		  obj_t pre_method_105_4159;
		  pre_method_105_4159 =
		     PROCEDURE_REF(patch__env_129_cfa_tvector, ((long) 2));
		  if (
		     INTEGERP(pre_method_105_4159))
		    {	/* ./Llib/object.scm 2927 */
		       PROCEDURE_SET(patch__env_129_cfa_tvector, ((long) 2), BUNSPEC);
		       arg2576_3266 = pre_method_105_4159;
		    }
		  else
		    {	/* ./Llib/object.scm 2914 */
		       long obj_class_num_177_4164;
		       obj_class_num_177_4164 =
			  TYPE(obj_4158);
		       {	/* ./Llib/object.scm 2915 */
			  obj_t arg1176_4165;
			  arg1176_4165 =
			     PROCEDURE_REF(patch__env_129_cfa_tvector, ((long) 1));
			  {	/* ./Llib/object.scm 2738 */
			     long arg1177_4169;
			     {	/* ./Llib/object.scm 2738 */
				long arg1178_4170;
				arg1178_4170 =
				   OBJECT_TYPE;
				arg1177_4169 =
				   (obj_class_num_177_4164 - arg1178_4170);
			     }
			     arg2576_3266 =
				VECTOR_REF(arg1176_4165, arg1177_4169);
			  }
		       }
		    }
	       }
	    }
	    {	/* Cfa/tvector.scm 265 */
	       object_bglt object_4175;
	       object_4175 =
		  (object_bglt) (node_39);
	       {	/* ./Llib/object.scm 2695 */
		  long arg1179_4176;
		  {	/* ./Llib/object.scm 2695 */
		     long arg1180_4177;
		     long arg1181_4178;
		     arg1180_4177 =
			TYPE(object_4175);
		     arg1181_4178 =
			OBJECT_TYPE;
		     arg1179_4176 =
			(arg1180_4177 - arg1181_4178);
		  }
		  {	/* ./Llib/object.scm 2695 */
		     obj_t vector_4182;
		     vector_4182 = _classes__134___object;
		     arg2578_3267 =
			VECTOR_REF(vector_4182, arg1179_4176);
		  }
	       }
	    }
	    method2568_3268 = arg2576_3266;
	    class2573_3269 = arg2578_3267;
	    {

	       if (
		  INTEGERP(method2568_3268))
		 {	/* Cfa/tvector.scm 265 */
		    switch (
		       (long) CINT(method2568_3268))
		      {
		      case ((long) 0):

			 {	/* Cfa/tvector.scm 265 */
			    atom_bglt aux_4933;
			    aux_4933 =
			       (atom_bglt) (node_39);
			    return
			       (obj_t) (aux_4933);
			 }
			 break;
		      case ((long) 1):

			 {	/* Cfa/tvector.scm 265 */
			    kwote_bglt aux_4936;
			    aux_4936 =
			       (kwote_bglt) (node_39);
			    return
			       (obj_t) (aux_4936);
			 }
			 break;
		      case ((long) 2):

			 {	/* Cfa/tvector.scm 283 */
			    kwote_node_102_bglt knode_3277;
			    knode_3277 =
			       (kwote_node_102_bglt) (node_39);
			    {	/* Cfa/tvector.scm 284 */
			       approx_bglt approx_3279;
			       {	/* Cfa/tvector.scm 284 */
				  node_bglt aux_4940;
				  {
				     obj_t aux_4941;
				     {	/* ./Cfa/cinfo.scm 2068 */
					object_bglt aux_4942;
					aux_4942 =
					   (object_bglt) (knode_3277);
					aux_4941 =
					   OBJECT_WIDENING(aux_4942);
				     }
				     aux_4940 =
					(((kwote_node_102_bglt) CREF(aux_4941))->node);
				  }
				  approx_3279 =
				     cfa__102_cfa_cfa(aux_4940);
			       }
			       {	/* Cfa/tvector.scm 284 */
				  obj_t tv_3280;
				  tv_3280 =
				     get_approx_type_210_cfa_type(approx_3279);
				  {	/* Cfa/tvector.scm 285 */

				     {	/* Cfa/tvector.scm 286 */
					bool_t test2581_3281;
					test2581_3281 =
					   is_a__118___object(tv_3280, tvec_tvector_tvector);
					if (test2581_3281)
					  {	/* Cfa/tvector.scm 287 */
					     kwote_node_102_bglt knode_3282;
					     {	/* Cfa/tvector.scm 287 */
						long arg2586_3290;
						{	/* Cfa/tvector.scm 287 */
						   obj_t arg2587_3291;
						   {	/* Cfa/tvector.scm 287 */
						      obj_t arg2588_3292;
						      {		/* Cfa/tvector.scm 287 */
							 object_bglt object_4186;
							 object_4186 =
							    (object_bglt) (knode_3277);
							 {	/* ./Llib/object.scm 2695 */
							    long arg1179_4187;
							    {	/* ./Llib/object.scm 2695 */
							       long arg1180_4188;
							       long arg1181_4189;
							       arg1180_4188 =
								  TYPE(object_4186);
							       arg1181_4189 =
								  OBJECT_TYPE;
							       arg1179_4187 =
								  (arg1180_4188 - arg1181_4189);
							    }
							    {	/* ./Llib/object.scm 2695 */
							       obj_t vector_4193;
							       vector_4193 = _classes__134___object;
							       arg2588_3292 =
								  VECTOR_REF(vector_4193, arg1179_4187);
							    }
							 }
						      }
						      arg2587_3291 =
							 class_super_145___object(arg2588_3292);
						   }
						   arg2586_3290 =
						      class_num_218___object(arg2587_3291);
						}
						{	/* Cfa/tvector.scm 287 */
						   obj_t obj_4195;
						   obj_4195 =
						      (obj_t) (knode_3277);
						   (((obj_t) CREF(obj_4195))->header = MAKE_HEADER(arg2586_3290, 0), BUNSPEC);
						}
					     }
					     {	/* Cfa/tvector.scm 287 */
						object_bglt aux_4959;
						aux_4959 =
						   (object_bglt) (knode_3277);
						OBJECT_WIDENING_SET(aux_4959, BFALSE);
					     }
					     knode_3282 = knode_3277;
					     {	/* Cfa/tvector.scm 288 */
						kwote_bglt duplicated2083_3283;
						duplicated2083_3283 =
						   (kwote_bglt) (knode_3282);
						{	/* Cfa/tvector.scm 288 */
						   kwote_bglt new2084_3284;
						   {	/* Cfa/tvector.scm 288 */
						      obj_t arg2582_3285;
						      type_bglt arg2583_3286;
						      obj_t arg2584_3287;
						      arg2582_3285 =
							 (((kwote_bglt) CREF(duplicated2083_3283))->loc);
						      arg2583_3286 =
							 (((kwote_bglt) CREF(duplicated2083_3283))->type);
						      {		/* Cfa/tvector.scm 288 */
							 obj_t arg2585_3288;
							 {	/* Cfa/tvector.scm 288 */
							    kwote_bglt obj_4199;
							    obj_4199 =
							       (kwote_bglt) (knode_3277);
							    arg2585_3288 =
							       (((kwote_bglt) CREF(obj_4199))->value);
							 }
							 {	/* ./Tvector/tvector.sch 921 */
							    obj_t new_4202;
							    {	/* ./Tvector/tvector.sch 921 */
							       obj_t aux_4967;
							       aux_4967 =
								  CNST_TABLE_REF(((long) 13));
							       new_4202 =
								  create_struct(aux_4967, ((long) 2));
							    }
							    STRUCT_SET(new_4202, ((long) 1), arg2585_3288);
							    STRUCT_SET(new_4202, ((long) 0), tv_3280);
							    arg2584_3287 = new_4202;
							 }
						      }
						      {		/* Cfa/tvector.scm 288 */
							 kwote_bglt res2772_4223;
							 {	/* ./Ast/node.scm 1678 */
							    kwote_bglt new1243_4216;
							    new1243_4216 =
							       ((kwote_bglt) BREF(GC_MALLOC(sizeof(struct kwote))));
							    {	/* ./Ast/node.scm 1678 */
							       long arg2528_4217;
							       arg2528_4217 =
								  class_num_218___object(kwote_ast_node);
							       {	/* ./Ast/node.scm 1678 */
								  obj_t obj_4221;
								  obj_4221 =
								     (obj_t) (new1243_4216);
								  (((obj_t) CREF(obj_4221))->header = MAKE_HEADER(arg2528_4217, 0), BUNSPEC);
							       }
							    }
							    {	/* ./Ast/node.scm 1678 */
							       object_bglt aux_4976;
							       aux_4976 =
								  (object_bglt) (new1243_4216);
							       OBJECT_WIDENING_SET(aux_4976, BFALSE);
							    }
							    ((((kwote_bglt) CREF(new1243_4216))->loc) = ((obj_t) arg2582_3285), BUNSPEC);
							    ((((kwote_bglt) CREF(new1243_4216))->type) = ((type_bglt) arg2583_3286), BUNSPEC);
							    ((((kwote_bglt) CREF(new1243_4216))->value) = ((obj_t) arg2584_3287), BUNSPEC);
							    res2772_4223 = new1243_4216;
							 }
							 new2084_3284 = res2772_4223;
						      }
						   }
						   {	/* Cfa/tvector.scm 288 */

						      return
							 (obj_t) (new2084_3284);
						   }
						}
					     }
					  }
					else
					  {	/* Cfa/tvector.scm 286 */
					     {	/* Cfa/tvector.scm 289 */
						long arg2589_3294;
						{	/* Cfa/tvector.scm 289 */
						   obj_t arg2590_3295;
						   {	/* Cfa/tvector.scm 289 */
						      obj_t arg2591_3296;
						      {		/* Cfa/tvector.scm 289 */
							 object_bglt object_4224;
							 object_4224 =
							    (object_bglt) (knode_3277);
							 {	/* ./Llib/object.scm 2695 */
							    long arg1179_4225;
							    {	/* ./Llib/object.scm 2695 */
							       long arg1180_4226;
							       long arg1181_4227;
							       arg1180_4226 =
								  TYPE(object_4224);
							       arg1181_4227 =
								  OBJECT_TYPE;
							       arg1179_4225 =
								  (arg1180_4226 - arg1181_4227);
							    }
							    {	/* ./Llib/object.scm 2695 */
							       obj_t vector_4231;
							       vector_4231 = _classes__134___object;
							       arg2591_3296 =
								  VECTOR_REF(vector_4231, arg1179_4225);
							    }
							 }
						      }
						      arg2590_3295 =
							 class_super_145___object(arg2591_3296);
						   }
						   arg2589_3294 =
						      class_num_218___object(arg2590_3295);
						}
						{	/* Cfa/tvector.scm 289 */
						   obj_t obj_4233;
						   obj_4233 =
						      (obj_t) (knode_3277);
						   (((obj_t) CREF(obj_4233))->header = MAKE_HEADER(arg2589_3294, 0), BUNSPEC);
						}
					     }
					     {	/* Cfa/tvector.scm 289 */
						object_bglt aux_4992;
						aux_4992 =
						   (object_bglt) (knode_3277);
						OBJECT_WIDENING_SET(aux_4992, BFALSE);
					     }
					     return
						(obj_t) (knode_3277);
					  }
				     }
				  }
			       }
			    }
			 }
			 break;
		      case ((long) 3):

			 {	/* Cfa/tvector.scm 265 */
			    var_bglt aux_4996;
			    aux_4996 =
			       (var_bglt) (node_39);
			    return
			       (obj_t) (aux_4996);
			 }
			 break;
		      case ((long) 4):

			 {	/* Cfa/tvector.scm 301 */
			    obj_t arg2595_3302;
			    {	/* Cfa/tvector.scm 301 */
			       obj_t aux_4999;
			       {	/* Cfa/tvector.scm 301 */
				  closure_bglt aux_5000;
				  aux_5000 =
				     (closure_bglt) (node_39);
				  aux_4999 =
				     (obj_t) (aux_5000);
			       }
			       arg2595_3302 =
				  shape_tools_shape(aux_4999);
			    }
			    return
			       internal_error_43_tools_error(string2778_cfa_tvector, string2779_cfa_tvector, arg2595_3302);
			 }
			 break;
		      case ((long) 5):

			 {	/* Cfa/tvector.scm 307 */
			    sequence_bglt node_3303;
			    node_3303 =
			       (sequence_bglt) (node_39);
			    patch___72_cfa_tvector(
			       (((sequence_bglt) CREF(node_3303))->nodes));
			    return
			       (obj_t) (node_3303);
			 }
			 break;
		      case ((long) 6):

			 {	/* Cfa/tvector.scm 315 */
			    app_ly_162_bglt node_3306;
			    node_3306 =
			       (app_ly_162_bglt) (node_39);
			    {	/* Cfa/tvector.scm 316 */
			       obj_t arg2597_3308;
			       arg2597_3308 =
				  patch__227_cfa_tvector(
				  (((app_ly_162_bglt) CREF(node_3306))->fun));
			       {	/* Cfa/tvector.scm 316 */
				  node_bglt val1277_4238;
				  val1277_4238 =
				     (node_bglt) (arg2597_3308);
				  ((((app_ly_162_bglt) CREF(node_3306))->fun) = ((node_bglt) val1277_4238), BUNSPEC);
			       }
			    }
			    {	/* Cfa/tvector.scm 317 */
			       obj_t arg2599_3310;
			       arg2599_3310 =
				  patch__227_cfa_tvector(
				  (((app_ly_162_bglt) CREF(node_3306))->arg));
			       {	/* Cfa/tvector.scm 317 */
				  node_bglt val1278_4241;
				  val1278_4241 =
				     (node_bglt) (arg2599_3310);
				  ((((app_ly_162_bglt) CREF(node_3306))->arg) = ((node_bglt) val1278_4241), BUNSPEC);
			       }
			    }
			    return
			       (obj_t) (node_3306);
			 }
			 break;
		      case ((long) 7):

			 {	/* Cfa/tvector.scm 324 */
			    funcall_bglt node_3312;
			    node_3312 =
			       (funcall_bglt) (node_39);
			    {	/* Cfa/tvector.scm 325 */
			       obj_t arg2601_3314;
			       arg2601_3314 =
				  patch__227_cfa_tvector(
				  (((funcall_bglt) CREF(node_3312))->fun));
			       {	/* Cfa/tvector.scm 325 */
				  node_bglt val1287_4244;
				  val1287_4244 =
				     (node_bglt) (arg2601_3314);
				  ((((funcall_bglt) CREF(node_3312))->fun) = ((node_bglt) val1287_4244), BUNSPEC);
			       }
			    }
			    patch___72_cfa_tvector(
			       (((funcall_bglt) CREF(node_3312))->args));
			    return
			       (obj_t) (node_3312);
			 }
			 break;
		      case ((long) 8):

			 {	/* Cfa/tvector.scm 333 */
			    pragma_bglt node_3317;
			    node_3317 =
			       (pragma_bglt) (node_39);
			    patch___72_cfa_tvector(
			       (((pragma_bglt) CREF(node_3317))->args));
			    return
			       (obj_t) (node_3317);
			 }
			 break;
		      case ((long) 9):

			 {	/* Cfa/tvector.scm 341 */
			    cast_bglt node_3320;
			    node_3320 =
			       (cast_bglt) (node_39);
			    patch__227_cfa_tvector(
			       (((cast_bglt) CREF(node_3320))->arg));
			    return
			       (obj_t) (node_3320);
			 }
			 break;
		      case ((long) 10):

			 {	/* Cfa/tvector.scm 349 */
			    setq_bglt node_3323;
			    node_3323 =
			       (setq_bglt) (node_39);
			    {	/* Cfa/tvector.scm 350 */
			       obj_t arg2606_3325;
			       arg2606_3325 =
				  patch__227_cfa_tvector(
				  (((setq_bglt) CREF(node_3323))->value));
			       {	/* Cfa/tvector.scm 350 */
				  node_bglt val1321_4250;
				  val1321_4250 =
				     (node_bglt) (arg2606_3325);
				  ((((setq_bglt) CREF(node_3323))->value) = ((node_bglt) val1321_4250), BUNSPEC);
			       }
			    }
			    {	/* Cfa/tvector.scm 351 */
			       obj_t arg2608_3327;
			       {	/* Cfa/tvector.scm 351 */
				  node_bglt aux_5040;
				  {	/* Cfa/tvector.scm 351 */
				     var_bglt aux_5041;
				     aux_5041 =
					(((setq_bglt) CREF(node_3323))->var);
				     aux_5040 =
					(node_bglt) (aux_5041);
				  }
				  arg2608_3327 =
				     patch__227_cfa_tvector(aux_5040);
			       }
			       {	/* Cfa/tvector.scm 351 */
				  var_bglt val1320_4253;
				  val1320_4253 =
				     (var_bglt) (arg2608_3327);
				  ((((setq_bglt) CREF(node_3323))->var) = ((var_bglt) val1320_4253), BUNSPEC);
			       }
			    }
			    return
			       (obj_t) (node_3323);
			 }
			 break;
		      case ((long) 11):

			 {	/* Cfa/tvector.scm 358 */
			    conditional_bglt node_3329;
			    node_3329 =
			       (conditional_bglt) (node_39);
			    {	/* Cfa/tvector.scm 359 */
			       obj_t arg2610_3331;
			       arg2610_3331 =
				  patch__227_cfa_tvector(
				  (((conditional_bglt) CREF(node_3329))->test));
			       {	/* Cfa/tvector.scm 359 */
				  node_bglt val1332_4256;
				  val1332_4256 =
				     (node_bglt) (arg2610_3331);
				  ((((conditional_bglt) CREF(node_3329))->test) = ((node_bglt) val1332_4256), BUNSPEC);
			       }
			    }
			    {	/* Cfa/tvector.scm 360 */
			       obj_t arg2612_3333;
			       arg2612_3333 =
				  patch__227_cfa_tvector(
				  (((conditional_bglt) CREF(node_3329))->true));
			       {	/* Cfa/tvector.scm 360 */
				  node_bglt val1333_4259;
				  val1333_4259 =
				     (node_bglt) (arg2612_3333);
				  ((((conditional_bglt) CREF(node_3329))->true) = ((node_bglt) val1333_4259), BUNSPEC);
			       }
			    }
			    {	/* Cfa/tvector.scm 361 */
			       obj_t arg2614_3335;
			       arg2614_3335 =
				  patch__227_cfa_tvector(
				  (((conditional_bglt) CREF(node_3329))->false));
			       {	/* Cfa/tvector.scm 361 */
				  node_bglt val1334_4262;
				  val1334_4262 =
				     (node_bglt) (arg2614_3335);
				  ((((conditional_bglt) CREF(node_3329))->false) = ((node_bglt) val1334_4262), BUNSPEC);
			       }
			    }
			    return
			       (obj_t) (node_3329);
			 }
			 break;
		      case ((long) 12):

			 {	/* Cfa/tvector.scm 368 */
			    fail_bglt node_3337;
			    node_3337 =
			       (fail_bglt) (node_39);
			    {	/* Cfa/tvector.scm 369 */
			       obj_t arg2616_3339;
			       arg2616_3339 =
				  patch__227_cfa_tvector(
				  (((fail_bglt) CREF(node_3337))->proc));
			       {	/* Cfa/tvector.scm 369 */
				  node_bglt val1346_4265;
				  val1346_4265 =
				     (node_bglt) (arg2616_3339);
				  ((((fail_bglt) CREF(node_3337))->proc) = ((node_bglt) val1346_4265), BUNSPEC);
			       }
			    }
			    {	/* Cfa/tvector.scm 370 */
			       obj_t arg2618_3341;
			       arg2618_3341 =
				  patch__227_cfa_tvector(
				  (((fail_bglt) CREF(node_3337))->msg));
			       {	/* Cfa/tvector.scm 370 */
				  node_bglt val1347_4268;
				  val1347_4268 =
				     (node_bglt) (arg2618_3341);
				  ((((fail_bglt) CREF(node_3337))->msg) = ((node_bglt) val1347_4268), BUNSPEC);
			       }
			    }
			    {	/* Cfa/tvector.scm 371 */
			       obj_t arg2620_3343;
			       arg2620_3343 =
				  patch__227_cfa_tvector(
				  (((fail_bglt) CREF(node_3337))->obj));
			       {	/* Cfa/tvector.scm 371 */
				  node_bglt val1348_4271;
				  val1348_4271 =
				     (node_bglt) (arg2620_3343);
				  ((((fail_bglt) CREF(node_3337))->obj) = ((node_bglt) val1348_4271), BUNSPEC);
			       }
			    }
			    return
			       (obj_t) (node_3337);
			 }
			 break;
		      case ((long) 13):

			 {	/* Cfa/tvector.scm 378 */
			    select_bglt node_3345;
			    node_3345 =
			       (select_bglt) (node_39);
			    {	/* Cfa/tvector.scm 379 */
			       obj_t arg2622_3347;
			       arg2622_3347 =
				  patch__227_cfa_tvector(
				  (((select_bglt) CREF(node_3345))->test));
			       {	/* Cfa/tvector.scm 379 */
				  node_bglt val1360_4274;
				  val1360_4274 =
				     (node_bglt) (arg2622_3347);
				  ((((select_bglt) CREF(node_3345))->test) = ((node_bglt) val1360_4274), BUNSPEC);
			       }
			    }
			    {
			       obj_t l2095_3349;
			       l2095_3349 =
				  (((select_bglt) CREF(node_3345))->clauses);
			     lname2096_3350:
			       if (
				  PAIRP(l2095_3349))
				 {	/* Cfa/tvector.scm 380 */
				    {	/* Cfa/tvector.scm 381 */
				       obj_t clause_3353;
				       clause_3353 =
					  CAR(l2095_3349);
				       {	/* Cfa/tvector.scm 381 */
					  obj_t arg2626_3354;
					  {	/* Cfa/tvector.scm 381 */
					     node_bglt aux_5084;
					     {	/* Cfa/tvector.scm 381 */
						obj_t aux_5085;
						aux_5085 =
						   CDR(clause_3353);
						aux_5084 =
						   (node_bglt) (aux_5085);
					     }
					     arg2626_3354 =
						patch__227_cfa_tvector(aux_5084);
					  }
					  SET_CDR(clause_3353, arg2626_3354);
				       }
				    }
				    {
				       obj_t l2095_5090;
				       l2095_5090 =
					  CDR(l2095_3349);
				       l2095_3349 = l2095_5090;
				       goto lname2096_3350;
				    }
				 }
			       else
				 {	/* Cfa/tvector.scm 380 */
				    ((bool_t) 1);
				 }
			    }
			    return
			       (obj_t) (node_3345);
			 }
			 break;
		      case ((long) 14):

			 {	/* Cfa/tvector.scm 389 */
			    let_fun_218_bglt node_3357;
			    node_3357 =
			       (let_fun_218_bglt) (node_39);
			    {
			       obj_t l2098_3359;
			       l2098_3359 =
				  (((let_fun_218_bglt) CREF(node_3357))->locals);
			     lname2099_3360:
			       if (
				  PAIRP(l2098_3359))
				 {	/* Cfa/tvector.scm 390 */
				    patch_fun__141_cfa_tvector(
				       CAR(l2098_3359));
				    {
				       obj_t l2098_5099;
				       l2098_5099 =
					  CDR(l2098_3359);
				       l2098_3359 = l2098_5099;
				       goto lname2099_3360;
				    }
				 }
			       else
				 {	/* Cfa/tvector.scm 390 */
				    ((bool_t) 1);
				 }
			    }
			    {	/* Cfa/tvector.scm 391 */
			       obj_t arg2633_3365;
			       arg2633_3365 =
				  patch__227_cfa_tvector(
				  (((let_fun_218_bglt) CREF(node_3357))->body));
			       {	/* Cfa/tvector.scm 391 */
				  node_bglt val1375_4288;
				  val1375_4288 =
				     (node_bglt) (arg2633_3365);
				  ((((let_fun_218_bglt) CREF(node_3357))->body) = ((node_bglt) val1375_4288), BUNSPEC);
			       }
			    }
			    return
			       (obj_t) (node_3357);
			 }
			 break;
		      case ((long) 15):

			 {	/* Cfa/tvector.scm 398 */
			    let_var_6_bglt node_3367;
			    node_3367 =
			       (let_var_6_bglt) (node_39);
			    {
			       obj_t l2101_3369;
			       l2101_3369 =
				  (((let_var_6_bglt) CREF(node_3367))->bindings);
			     lname2102_3370:
			       if (
				  PAIRP(l2101_3369))
				 {	/* Cfa/tvector.scm 399 */
				    {	/* Cfa/tvector.scm 400 */
				       obj_t binding_3373;
				       binding_3373 =
					  CAR(l2101_3369);
				       {	/* Cfa/tvector.scm 401 */
					  obj_t arg2637_3375;
					  {	/* Cfa/tvector.scm 401 */
					     node_bglt aux_5111;
					     {	/* Cfa/tvector.scm 401 */
						obj_t aux_5112;
						aux_5112 =
						   CDR(binding_3373);
						aux_5111 =
						   (node_bglt) (aux_5112);
					     }
					     arg2637_3375 =
						patch__227_cfa_tvector(aux_5111);
					  }
					  SET_CDR(binding_3373, arg2637_3375);
				       }
				    }
				    {
				       obj_t l2101_5117;
				       l2101_5117 =
					  CDR(l2101_3369);
				       l2101_3369 = l2101_5117;
				       goto lname2102_3370;
				    }
				 }
			       else
				 {	/* Cfa/tvector.scm 399 */
				    ((bool_t) 1);
				 }
			    }
			    {	/* Cfa/tvector.scm 403 */
			       obj_t arg2639_3377;
			       arg2639_3377 =
				  patch__227_cfa_tvector(
				  (((let_var_6_bglt) CREF(node_3367))->body));
			       {	/* Cfa/tvector.scm 403 */
				  node_bglt val1389_4298;
				  val1389_4298 =
				     (node_bglt) (arg2639_3377);
				  ((((let_var_6_bglt) CREF(node_3367))->body) = ((node_bglt) val1389_4298), BUNSPEC);
			       }
			    }
			    return
			       (obj_t) (node_3367);
			 }
			 break;
		      case ((long) 16):

			 {	/* Cfa/tvector.scm 410 */
			    set_ex_it_116_bglt node_3379;
			    node_3379 =
			       (set_ex_it_116_bglt) (node_39);
			    {	/* Cfa/tvector.scm 411 */
			       obj_t arg2641_3381;
			       arg2641_3381 =
				  patch__227_cfa_tvector(
				  (((set_ex_it_116_bglt) CREF(node_3379))->body));
			       {	/* Cfa/tvector.scm 411 */
				  node_bglt val1403_4301;
				  val1403_4301 =
				     (node_bglt) (arg2641_3381);
				  ((((set_ex_it_116_bglt) CREF(node_3379))->body) = ((node_bglt) val1403_4301), BUNSPEC);
			       }
			    }
			    {	/* Cfa/tvector.scm 412 */
			       node_bglt aux_5130;
			       {	/* Cfa/tvector.scm 412 */
				  var_bglt aux_5131;
				  aux_5131 =
				     (((set_ex_it_116_bglt) CREF(node_3379))->var);
				  aux_5130 =
				     (node_bglt) (aux_5131);
			       }
			       patch__227_cfa_tvector(aux_5130);
			    }
			    return
			       (obj_t) (node_3379);
			 }
			 break;
		      case ((long) 17):

			 {	/* Cfa/tvector.scm 419 */
			    jump_ex_it_184_bglt node_3384;
			    node_3384 =
			       (jump_ex_it_184_bglt) (node_39);
			    {	/* Cfa/tvector.scm 420 */
			       obj_t arg2644_3386;
			       arg2644_3386 =
				  patch__227_cfa_tvector(
				  (((jump_ex_it_184_bglt) CREF(node_3384))->exit));
			       {	/* Cfa/tvector.scm 420 */
				  node_bglt val1412_4305;
				  val1412_4305 =
				     (node_bglt) (arg2644_3386);
				  ((((jump_ex_it_184_bglt) CREF(node_3384))->exit) = ((node_bglt) val1412_4305), BUNSPEC);
			       }
			    }
			    {	/* Cfa/tvector.scm 421 */
			       obj_t arg2646_3388;
			       arg2646_3388 =
				  patch__227_cfa_tvector(
				  (((jump_ex_it_184_bglt) CREF(node_3384))->value));
			       {	/* Cfa/tvector.scm 421 */
				  node_bglt val1413_4308;
				  val1413_4308 =
				     (node_bglt) (arg2646_3388);
				  ((((jump_ex_it_184_bglt) CREF(node_3384))->value) = ((node_bglt) val1413_4308), BUNSPEC);
			       }
			    }
			    return
			       (obj_t) (node_3384);
			 }
			 break;
		      case ((long) 18):

			 {	/* Cfa/tvector.scm 428 */
			    make_box_202_bglt node_3390;
			    node_3390 =
			       (make_box_202_bglt) (node_39);
			    {	/* Cfa/tvector.scm 429 */
			       obj_t arg2648_3392;
			       arg2648_3392 =
				  patch__227_cfa_tvector(
				  (((make_box_202_bglt) CREF(node_3390))->value));
			       {	/* Cfa/tvector.scm 429 */
				  node_bglt val1424_4311;
				  val1424_4311 =
				     (node_bglt) (arg2648_3392);
				  ((((make_box_202_bglt) CREF(node_3390))->value) = ((node_bglt) val1424_4311), BUNSPEC);
			       }
			    }
			    return
			       (obj_t) (node_3390);
			 }
			 break;
		      case ((long) 19):

			 {	/* Cfa/tvector.scm 436 */
			    box_set__221_bglt node_3394;
			    node_3394 =
			       (box_set__221_bglt) (node_39);
			    {	/* Cfa/tvector.scm 437 */
			       obj_t arg2650_3396;
			       {	/* Cfa/tvector.scm 437 */
				  node_bglt aux_5153;
				  {	/* Cfa/tvector.scm 437 */
				     var_bglt aux_5154;
				     aux_5154 =
					(((box_set__221_bglt) CREF(node_3394))->var);
				     aux_5153 =
					(node_bglt) (aux_5154);
				  }
				  arg2650_3396 =
				     patch__227_cfa_tvector(aux_5153);
			       }
			       {	/* Cfa/tvector.scm 437 */
				  var_bglt val1446_4314;
				  val1446_4314 =
				     (var_bglt) (arg2650_3396);
				  ((((box_set__221_bglt) CREF(node_3394))->var) = ((var_bglt) val1446_4314), BUNSPEC);
			       }
			    }
			    {	/* Cfa/tvector.scm 438 */
			       obj_t arg2652_3398;
			       arg2652_3398 =
				  patch__227_cfa_tvector(
				  (((box_set__221_bglt) CREF(node_3394))->value));
			       {	/* Cfa/tvector.scm 438 */
				  node_bglt val1447_4317;
				  val1447_4317 =
				     (node_bglt) (arg2652_3398);
				  ((((box_set__221_bglt) CREF(node_3394))->value) = ((node_bglt) val1447_4317), BUNSPEC);
			       }
			    }
			    return
			       (obj_t) (node_3394);
			 }
			 break;
		      case ((long) 20):

			 {	/* Cfa/tvector.scm 445 */
			    box_ref_242_bglt node_3400;
			    node_3400 =
			       (box_ref_242_bglt) (node_39);
			    {	/* Cfa/tvector.scm 446 */
			       obj_t arg2654_3402;
			       {	/* Cfa/tvector.scm 446 */
				  node_bglt aux_5166;
				  {	/* Cfa/tvector.scm 446 */
				     var_bglt aux_5167;
				     aux_5167 =
					(((box_ref_242_bglt) CREF(node_3400))->var);
				     aux_5166 =
					(node_bglt) (aux_5167);
				  }
				  arg2654_3402 =
				     patch__227_cfa_tvector(aux_5166);
			       }
			       {	/* Cfa/tvector.scm 446 */
				  var_bglt val1436_4320;
				  val1436_4320 =
				     (var_bglt) (arg2654_3402);
				  ((((box_ref_242_bglt) CREF(node_3400))->var) = ((var_bglt) val1436_4320), BUNSPEC);
			       }
			    }
			    return
			       (obj_t) (node_3400);
			 }
			 break;
		      case ((long) 21):

			 {	/* Cfa/tvector.scm 464 */
			    app_bglt node_3404;
			    node_3404 =
			       (app_bglt) (node_39);
			    patch___72_cfa_tvector(
			       (((app_bglt) CREF(node_3404))->args));
			    {	/* Cfa/tvector.scm 466 */
			       obj_t arg2657_3407;
			       {	/* Cfa/tvector.scm 466 */
				  node_bglt aux_5177;
				  {	/* Cfa/tvector.scm 466 */
				     var_bglt aux_5178;
				     aux_5178 =
					(((app_bglt) CREF(node_3404))->fun);
				     aux_5177 =
					(node_bglt) (aux_5178);
				  }
				  arg2657_3407 =
				     patch__227_cfa_tvector(aux_5177);
			       }
			       {	/* Cfa/tvector.scm 466 */
				  var_bglt val1263_4324;
				  val1263_4324 =
				     (var_bglt) (arg2657_3407);
				  ((((app_bglt) CREF(node_3404))->fun) = ((var_bglt) val1263_4324), BUNSPEC);
			       }
			    }
			    {	/* Cfa/tvector.scm 467 */
			       variable_bglt v_3409;
			       {	/* Cfa/tvector.scm 467 */
				  var_bglt arg2670_3422;
				  arg2670_3422 =
				     (((app_bglt) CREF(node_3404))->fun);
				  v_3409 =
				     (((var_bglt) CREF(arg2670_3422))->variable);
			       }
			       {	/* Cfa/tvector.scm 468 */
				  bool_t test2659_3410;
				  test2659_3410 =
				     is_a__118___object(
				     (obj_t) (v_3409), global_ast_var);
				  if (test2659_3410)
				    {	/* Cfa/tvector.scm 469 */
				       bool_t test2660_3411;
				       {	/* ./Ast/var.scm 1597 */
					  obj_t aux_5189;
					  {	/* Cfa/tvector.scm 469 */
					     value_bglt aux_5190;
					     aux_5190 =
						(((variable_bglt) CREF(v_3409))->value);
					     aux_5189 =
						(obj_t) (aux_5190);
					  }
					  test2660_3411 =
					     is_a__118___object(aux_5189, cfun_ast_var);
				       }
				       if (test2660_3411)
					 {	/* Cfa/tvector.scm 470 */
					    obj_t case_value_58_3412;
					    {	/* Cfa/tvector.scm 470 */
					       global_bglt obj_4330;
					       obj_4330 =
						  (global_bglt) (v_3409);
					       case_value_58_3412 =
						  (((global_bglt) CREF(obj_4330))->id);
					    }
					    {	/* Cfa/tvector.scm 470 */
					       bool_t test_5197;
					       {	/* ./Ieee/equiv.scm 5508 */
						  obj_t aux_5198;
						  aux_5198 =
						     CNST_TABLE_REF(((long) 14));
						  test_5197 =
						     (case_value_58_3412 == aux_5198);
					       }
					       if (test_5197)
						 {	/* Cfa/tvector.scm 470 */
						    return
						       patch_vector_length__86_cfa_tvector(node_3404);
						 }
					       else
						 {	/* Cfa/tvector.scm 470 */
						    bool_t test_5202;
						    {	/* ./Ieee/equiv.scm 5508 */
						       obj_t aux_5203;
						       aux_5203 =
							  CNST_TABLE_REF(((long) 1));
						       test_5202 =
							  (case_value_58_3412 == aux_5203);
						    }
						    if (test_5202)
						      {		/* Cfa/tvector.scm 470 */
							 return
							    patch_vector___0_cfa_tvector(node_3404);
						      }
						    else
						      {		/* Cfa/tvector.scm 470 */
							 return
							    (obj_t) (node_3404);
						      }
						 }
					    }
					 }
				       else
					 {	/* Cfa/tvector.scm 477 */
					    bool_t test_5208;
					    {	/* Cfa/tvector.scm 477 */
					       bool_t test_5209;
					       {	/* ./Ieee/equiv.scm 5508 */
						  obj_t aux_5213;
						  obj_t aux_5210;
						  aux_5213 =
						     CNST_TABLE_REF(((long) 15));
						  {	/* Cfa/tvector.scm 477 */
						     global_bglt obj_4335;
						     obj_4335 =
							(global_bglt) (v_3409);
						     aux_5210 =
							(((global_bglt) CREF(obj_4335))->id);
						  }
						  test_5209 =
						     (aux_5210 == aux_5213);
					       }
					       if (test_5209)
						 {	/* ./Ieee/equiv.scm 5508 */
						    obj_t aux_5219;
						    obj_t aux_5216;
						    aux_5219 =
						       CNST_TABLE_REF(((long) 16));
						    {	/* Cfa/tvector.scm 478 */
						       global_bglt obj_4338;
						       obj_4338 =
							  (global_bglt) (v_3409);
						       aux_5216 =
							  (((global_bglt) CREF(obj_4338))->module);
						    }
						    test_5208 =
						       (aux_5216 == aux_5219);
						 }
					       else
						 {	/* Cfa/tvector.scm 477 */
						    test_5208 = ((bool_t) 0)
						       ;
						 }
					    }
					    if (test_5208)
					      {		/* Cfa/tvector.scm 477 */
						 return
						    patch_vector__list__149_cfa_tvector(node_3404);
					      }
					    else
					      {		/* Cfa/tvector.scm 477 */
						 return
						    (obj_t) (node_3404);
					      }
					 }
				    }
				  else
				    {	/* Cfa/tvector.scm 468 */
				       return
					  (obj_t) (node_3404);
				    }
			       }
			    }
			 }
			 break;
		      case ((long) 22):

			 {	/* Cfa/tvector.scm 538 */
			    make_vector_app_205_bglt node_3423;
			    node_3423 =
			       (make_vector_app_205_bglt) (node_39);
			    {	/* Cfa/tvector.scm 539 */
			       obj_t aux_5226;
			       {	/* Cfa/tvector.scm 539 */
				  app_bglt obj_4341;
				  obj_4341 =
				     (app_bglt) (node_3423);
				  aux_5226 =
				     (((app_bglt) CREF(obj_4341))->args);
			       }
			       patch___72_cfa_tvector(aux_5226);
			    }
			    {	/* Cfa/tvector.scm 540 */
			       type_bglt type_3426;
			       {	/* Cfa/tvector.scm 540 */
				  approx_bglt arg2689_3447;
				  {
				     obj_t aux_5230;
				     {	/* ./Cfa/cinfo2.scm 2161 */
					object_bglt aux_5231;
					aux_5231 =
					   (object_bglt) (node_3423);
					aux_5230 =
					   OBJECT_WIDENING(aux_5231);
				     }
				     arg2689_3447 =
					(((make_vector_app_205_bglt) CREF(aux_5230))->value_approx_19);
				  }
				  type_3426 =
				     (((approx_bglt) CREF(arg2689_3447))->type);
			       }
			       {	/* Cfa/tvector.scm 540 */
				  obj_t tv_3427;
				  tv_3427 =
				     (((type_bglt) CREF(type_3426))->tvector);
				  {	/* Cfa/tvector.scm 541 */

				     {	/* Cfa/tvector.scm 542 */
					bool_t test2672_3428;
					test2672_3428 =
					   is_a__118___object(tv_3427, type_type_type);
					if (test2672_3428)
					  {	/* Cfa/tvector.scm 543 */
					     obj_t make_tv_69_3429;
					     {	/* Cfa/tvector.scm 543 */
						obj_t arg2685_3443;
						arg2685_3443 =
						   CNST_TABLE_REF(((long) 17));
						{	/* Cfa/tvector.scm 543 */
						   obj_t list2687_3445;
						   {	/* Cfa/tvector.scm 543 */
						      obj_t arg2688_3446;
						      {		/* Cfa/tvector.scm 543 */
							 obj_t aux_5240;
							 {	/* Cfa/tvector.scm 543 */
							    type_bglt obj_4346;
							    obj_4346 =
							       (type_bglt) (tv_3427);
							    aux_5240 =
							       (((type_bglt) CREF(obj_4346))->id);
							 }
							 arg2688_3446 =
							    MAKE_PAIR(aux_5240, BNIL);
						      }
						      list2687_3445 =
							 MAKE_PAIR(arg2685_3443, arg2688_3446);
						   }
						   make_tv_69_3429 =
						      symbol_append_197___r4_symbols_6_4(list2687_3445);
						}
					     }
					     {	/* Cfa/tvector.scm 543 */
						node_bglt new_node_11_3430;
						{	/* Cfa/tvector.scm 544 */
						   obj_t arg2678_3436;
						   obj_t arg2680_3438;
						   obj_t arg2681_3439;
						   {	/* ./Ieee/pair-list.scm 5689 */
						      obj_t aux_5246;
						      {		/* Cfa/tvector.scm 544 */
							 obj_t aux_5247;
							 {	/* Cfa/tvector.scm 544 */
							    app_bglt obj_4347;
							    obj_4347 =
							       (app_bglt) (node_3423);
							    aux_5247 =
							       (((app_bglt) CREF(obj_4347))->args);
							 }
							 aux_5246 =
							    append_2_18___r4_pairs_and_lists_6_3(aux_5247, BNIL);
						      }
						      arg2678_3436 =
							 MAKE_PAIR(make_tv_69_3429, aux_5246);
						   }
						   {	/* Cfa/tvector.scm 544 */
						      app_bglt obj_4350;
						      obj_4350 =
							 (app_bglt) (node_3423);
						      arg2680_3438 =
							 (((app_bglt) CREF(obj_4350))->loc);
						   }
						   arg2681_3439 =
						      CNST_TABLE_REF(((long) 10));
						   new_node_11_3430 =
						      sexp__node_235_ast_sexp(arg2678_3436, BNIL, arg2680_3438, arg2681_3439);
						}
						{	/* Cfa/tvector.scm 544 */

						   {	/* Cfa/tvector.scm 548 */
						      type_bglt val1202_4352;
						      val1202_4352 =
							 (type_bglt) (tv_3427);
						      ((((node_bglt) CREF(new_node_11_3430))->type) = ((type_bglt) val1202_4352), BUNSPEC);
						   }
						   {	/* Cfa/tvector.scm 549 */
						      node_bglt arg2673_3431;
						      {		/* Cfa/tvector.scm 549 */
							 bool_t test2676_3434;
							 test2676_3434 =
							    stack_optimization__133_cfa_stack();
							 if (test2676_3434)
							   {	/* Cfa/tvector.scm 550 */
							      bool_t aux_5260;
							      {
								 obj_t aux_5262;
								 {	/* ./Cfa/cinfo2.scm 2168 */
								    object_bglt aux_5263;
								    aux_5263 =
								       (object_bglt) (node_3423);
								    aux_5262 =
								       OBJECT_WIDENING(aux_5263);
								 }
								 aux_5260 =
								    (((make_vector_app_205_bglt) CREF(aux_5262))->stackable__42);
							      }
							      arg2673_3431 =
								 node_heap__stack__239_cfa_stack(
								 (app_bglt) (new_node_11_3430), aux_5260);
							   }
							 else
							   {	/* Cfa/tvector.scm 549 */
							      arg2673_3431 = new_node_11_3430;
							   }
						      }
						      {		/* Cfa/tvector.scm 549 */
							 node_bglt aux_5268;
							 aux_5268 =
							    inline_node_218_inline_inline(arg2673_3431, ((long) 1), BNIL);
							 return
							    (obj_t) (aux_5268);
						      }
						   }
						}
					     }
					  }
					else
					  {	/* Cfa/tvector.scm 542 */
					     return
						(obj_t) (node_3423);
					  }
				     }
				  }
			       }
			    }
			 }
			 break;
		      case ((long) 23):

			 {	/* Cfa/tvector.scm 560 */
			    create_vector_app_150_bglt node_3448;
			    node_3448 =
			       (create_vector_app_150_bglt) (node_39);
			    {	/* Cfa/tvector.scm 561 */
			       obj_t aux_5273;
			       {	/* Cfa/tvector.scm 561 */
				  app_bglt obj_4354;
				  obj_4354 =
				     (app_bglt) (node_3448);
				  aux_5273 =
				     (((app_bglt) CREF(obj_4354))->args);
			       }
			       patch___72_cfa_tvector(aux_5273);
			    }
			    {	/* Cfa/tvector.scm 562 */
			       type_bglt type_3451;
			       {	/* Cfa/tvector.scm 562 */
				  approx_bglt arg2708_3472;
				  {
				     obj_t aux_5277;
				     {	/* ./Cfa/cinfo2.scm 2185 */
					object_bglt aux_5278;
					aux_5278 =
					   (object_bglt) (node_3448);
					aux_5277 =
					   OBJECT_WIDENING(aux_5278);
				     }
				     arg2708_3472 =
					(((create_vector_app_150_bglt) CREF(aux_5277))->value_approx_19);
				  }
				  type_3451 =
				     (((approx_bglt) CREF(arg2708_3472))->type);
			       }
			       {	/* Cfa/tvector.scm 562 */
				  obj_t tv_3452;
				  tv_3452 =
				     (((type_bglt) CREF(type_3451))->tvector);
				  {	/* Cfa/tvector.scm 563 */

				     {	/* Cfa/tvector.scm 564 */
					bool_t test2691_3453;
					test2691_3453 =
					   is_a__118___object(tv_3452, type_type_type);
					if (test2691_3453)
					  {	/* Cfa/tvector.scm 565 */
					     obj_t create_tv_3_3454;
					     {	/* Cfa/tvector.scm 565 */
						obj_t arg2704_3468;
						arg2704_3468 =
						   CNST_TABLE_REF(((long) 18));
						{	/* Cfa/tvector.scm 565 */
						   obj_t list2706_3470;
						   {	/* Cfa/tvector.scm 565 */
						      obj_t arg2707_3471;
						      {		/* Cfa/tvector.scm 565 */
							 obj_t aux_5287;
							 {	/* Cfa/tvector.scm 565 */
							    type_bglt obj_4359;
							    obj_4359 =
							       (type_bglt) (tv_3452);
							    aux_5287 =
							       (((type_bglt) CREF(obj_4359))->id);
							 }
							 arg2707_3471 =
							    MAKE_PAIR(aux_5287, BNIL);
						      }
						      list2706_3470 =
							 MAKE_PAIR(arg2704_3468, arg2707_3471);
						   }
						   create_tv_3_3454 =
						      symbol_append_197___r4_symbols_6_4(list2706_3470);
						}
					     }
					     {	/* Cfa/tvector.scm 565 */
						node_bglt new_node_11_3455;
						{	/* Cfa/tvector.scm 566 */
						   obj_t arg2697_3461;
						   obj_t arg2699_3463;
						   obj_t arg2700_3464;
						   {	/* ./Ieee/pair-list.scm 5689 */
						      obj_t aux_5293;
						      {		/* Cfa/tvector.scm 566 */
							 obj_t aux_5294;
							 {	/* Cfa/tvector.scm 566 */
							    app_bglt obj_4360;
							    obj_4360 =
							       (app_bglt) (node_3448);
							    aux_5294 =
							       (((app_bglt) CREF(obj_4360))->args);
							 }
							 aux_5293 =
							    append_2_18___r4_pairs_and_lists_6_3(aux_5294, BNIL);
						      }
						      arg2697_3461 =
							 MAKE_PAIR(create_tv_3_3454, aux_5293);
						   }
						   {	/* Cfa/tvector.scm 566 */
						      app_bglt obj_4363;
						      obj_4363 =
							 (app_bglt) (node_3448);
						      arg2699_3463 =
							 (((app_bglt) CREF(obj_4363))->loc);
						   }
						   arg2700_3464 =
						      CNST_TABLE_REF(((long) 10));
						   new_node_11_3455 =
						      sexp__node_235_ast_sexp(arg2697_3461, BNIL, arg2699_3463, arg2700_3464);
						}
						{	/* Cfa/tvector.scm 566 */

						   {	/* Cfa/tvector.scm 570 */
						      type_bglt val1202_4365;
						      val1202_4365 =
							 (type_bglt) (tv_3452);
						      ((((node_bglt) CREF(new_node_11_3455))->type) = ((type_bglt) val1202_4365), BUNSPEC);
						   }
						   {	/* Cfa/tvector.scm 571 */
						      node_bglt arg2692_3456;
						      {		/* Cfa/tvector.scm 571 */
							 bool_t test2695_3459;
							 test2695_3459 =
							    stack_optimization__133_cfa_stack();
							 if (test2695_3459)
							   {	/* Cfa/tvector.scm 572 */
							      bool_t aux_5307;
							      {
								 obj_t aux_5309;
								 {	/* ./Cfa/cinfo2.scm 2192 */
								    object_bglt aux_5310;
								    aux_5310 =
								       (object_bglt) (node_3448);
								    aux_5309 =
								       OBJECT_WIDENING(aux_5310);
								 }
								 aux_5307 =
								    (((create_vector_app_150_bglt) CREF(aux_5309))->stackable__42);
							      }
							      arg2692_3456 =
								 node_heap__stack__239_cfa_stack(
								 (app_bglt) (new_node_11_3455), aux_5307);
							   }
							 else
							   {	/* Cfa/tvector.scm 571 */
							      arg2692_3456 = new_node_11_3455;
							   }
						      }
						      {		/* Cfa/tvector.scm 571 */
							 node_bglt aux_5315;
							 aux_5315 =
							    inline_node_218_inline_inline(arg2692_3456, ((long) 1), BNIL);
							 return
							    (obj_t) (aux_5315);
						      }
						   }
						}
					     }
					  }
					else
					  {	/* Cfa/tvector.scm 564 */
					     return
						(obj_t) (node_3448);
					  }
				     }
				  }
			       }
			    }
			 }
			 break;
		      case ((long) 24):

			 {	/* Cfa/tvector.scm 582 */
			    vector_ref_app_195_bglt node_3473;
			    node_3473 =
			       (vector_ref_app_195_bglt) (node_39);
			    {	/* Cfa/tvector.scm 583 */
			       obj_t aux_5320;
			       {	/* Cfa/tvector.scm 583 */
				  app_bglt obj_4367;
				  obj_4367 =
				     (app_bglt) (node_3473);
				  aux_5320 =
				     (((app_bglt) CREF(obj_4367))->args);
			       }
			       patch___72_cfa_tvector(aux_5320);
			    }
			    {	/* Cfa/tvector.scm 584 */
			       approx_bglt vec_approx_215_3476;
			       {	/* Cfa/tvector.scm 584 */
				  node_bglt aux_5324;
				  {	/* Cfa/tvector.scm 584 */
				     obj_t aux_5325;
				     {	/* ./Ieee/pair-list.scm 5701 */
					obj_t aux_5326;
					{	/* Cfa/tvector.scm 584 */
					   app_bglt obj_4368;
					   obj_4368 =
					      (app_bglt) (node_3473);
					   aux_5326 =
					      (((app_bglt) CREF(obj_4368))->args);
					}
					aux_5325 =
					   CAR(aux_5326);
				     }
				     aux_5324 =
					(node_bglt) (aux_5325);
				  }
				  vec_approx_215_3476 =
				     cfa__102_cfa_cfa(aux_5324);
			       }
			       {	/* Cfa/tvector.scm 584 */
				  obj_t tv_3477;
				  tv_3477 =
				     get_approx_type_210_cfa_type(vec_approx_215_3476);
				  {	/* Cfa/tvector.scm 585 */

				     {	/* Cfa/tvector.scm 586 */
					bool_t test2710_3478;
					test2710_3478 =
					   is_a__118___object(tv_3477, tvec_tvector_tvector);
					if (test2710_3478)
					  {	/* Cfa/tvector.scm 588 */
					     obj_t tv_ref_74_3479;
					     {	/* Cfa/tvector.scm 588 */
						obj_t arg2718_3488;
						{	/* Cfa/tvector.scm 588 */
						   type_bglt obj_4371;
						   obj_4371 =
						      (type_bglt) (tv_3477);
						   arg2718_3488 =
						      (((type_bglt) CREF(obj_4371))->id);
						}
						{	/* Cfa/tvector.scm 588 */
						   obj_t list2720_3490;
						   {	/* Cfa/tvector.scm 588 */
						      obj_t arg2721_3491;
						      {		/* Cfa/tvector.scm 588 */
							 obj_t aux_5337;
							 aux_5337 =
							    CNST_TABLE_REF(((long) 19));
							 arg2721_3491 =
							    MAKE_PAIR(aux_5337, BNIL);
						      }
						      list2720_3490 =
							 MAKE_PAIR(arg2718_3488, arg2721_3491);
						   }
						   tv_ref_74_3479 =
						      symbol_append_197___r4_symbols_6_4(list2720_3490);
						}
					     }
					     {	/* Cfa/tvector.scm 588 */
						node_bglt new_node_11_3480;
						{	/* Cfa/tvector.scm 589 */
						   obj_t arg2711_3481;
						   obj_t arg2713_3483;
						   obj_t arg2714_3484;
						   {	/* ./Ieee/pair-list.scm 5689 */
						      obj_t aux_5342;
						      {		/* Cfa/tvector.scm 589 */
							 obj_t aux_5343;
							 {	/* Cfa/tvector.scm 589 */
							    app_bglt obj_4372;
							    obj_4372 =
							       (app_bglt) (node_3473);
							    aux_5343 =
							       (((app_bglt) CREF(obj_4372))->args);
							 }
							 aux_5342 =
							    append_2_18___r4_pairs_and_lists_6_3(aux_5343, BNIL);
						      }
						      arg2711_3481 =
							 MAKE_PAIR(tv_ref_74_3479, aux_5342);
						   }
						   {	/* Cfa/tvector.scm 589 */
						      app_bglt obj_4375;
						      obj_4375 =
							 (app_bglt) (node_3473);
						      arg2713_3483 =
							 (((app_bglt) CREF(obj_4375))->loc);
						   }
						   arg2714_3484 =
						      CNST_TABLE_REF(((long) 10));
						   new_node_11_3480 =
						      sexp__node_235_ast_sexp(arg2711_3481, BNIL, arg2713_3483, arg2714_3484);
						}
						{	/* Cfa/tvector.scm 589 */

						   {	/* Cfa/tvector.scm 593 */
						      node_bglt aux_5352;
						      aux_5352 =
							 inline_node_218_inline_inline(new_node_11_3480, ((long) 1), BNIL);
						      return
							 (obj_t) (aux_5352);
						   }
						}
					     }
					  }
					else
					  {	/* Cfa/tvector.scm 586 */
					     return
						(obj_t) (node_3473);
					  }
				     }
				  }
			       }
			    }
			 }
			 break;
		      case ((long) 25):

			 {	/* Cfa/tvector.scm 599 */
			    vector_set__app_21_bglt node_3494;
			    node_3494 =
			       (vector_set__app_21_bglt) (node_39);
			    {	/* Cfa/tvector.scm 600 */
			       obj_t aux_5357;
			       {	/* Cfa/tvector.scm 600 */
				  app_bglt obj_4376;
				  obj_4376 =
				     (app_bglt) (node_3494);
				  aux_5357 =
				     (((app_bglt) CREF(obj_4376))->args);
			       }
			       patch___72_cfa_tvector(aux_5357);
			    }
			    {	/* Cfa/tvector.scm 601 */
			       approx_bglt vec_approx_215_3497;
			       {	/* Cfa/tvector.scm 601 */
				  node_bglt aux_5361;
				  {	/* Cfa/tvector.scm 601 */
				     obj_t aux_5362;
				     {	/* ./Ieee/pair-list.scm 5701 */
					obj_t aux_5363;
					{	/* Cfa/tvector.scm 601 */
					   app_bglt obj_4377;
					   obj_4377 =
					      (app_bglt) (node_3494);
					   aux_5363 =
					      (((app_bglt) CREF(obj_4377))->args);
					}
					aux_5362 =
					   CAR(aux_5363);
				     }
				     aux_5361 =
					(node_bglt) (aux_5362);
				  }
				  vec_approx_215_3497 =
				     cfa__102_cfa_cfa(aux_5361);
			       }
			       {	/* Cfa/tvector.scm 601 */
				  obj_t tv_3498;
				  tv_3498 =
				     get_approx_type_210_cfa_type(vec_approx_215_3497);
				  {	/* Cfa/tvector.scm 602 */

				     {	/* Cfa/tvector.scm 603 */
					bool_t test2726_3499;
					test2726_3499 =
					   is_a__118___object(tv_3498, tvec_tvector_tvector);
					if (test2726_3499)
					  {	/* Cfa/tvector.scm 605 */
					     obj_t tv_set__238_3500;
					     {	/* Cfa/tvector.scm 605 */
						obj_t arg2734_3509;
						{	/* Cfa/tvector.scm 605 */
						   type_bglt obj_4380;
						   obj_4380 =
						      (type_bglt) (tv_3498);
						   arg2734_3509 =
						      (((type_bglt) CREF(obj_4380))->id);
						}
						{	/* Cfa/tvector.scm 605 */
						   obj_t list2736_3511;
						   {	/* Cfa/tvector.scm 605 */
						      obj_t arg2737_3512;
						      {		/* Cfa/tvector.scm 605 */
							 obj_t aux_5374;
							 aux_5374 =
							    CNST_TABLE_REF(((long) 20));
							 arg2737_3512 =
							    MAKE_PAIR(aux_5374, BNIL);
						      }
						      list2736_3511 =
							 MAKE_PAIR(arg2734_3509, arg2737_3512);
						   }
						   tv_set__238_3500 =
						      symbol_append_197___r4_symbols_6_4(list2736_3511);
						}
					     }
					     {	/* Cfa/tvector.scm 605 */
						node_bglt new_node_11_3501;
						{	/* Cfa/tvector.scm 606 */
						   obj_t arg2727_3502;
						   obj_t arg2729_3504;
						   obj_t arg2730_3505;
						   {	/* ./Ieee/pair-list.scm 5689 */
						      obj_t aux_5379;
						      {		/* Cfa/tvector.scm 606 */
							 obj_t aux_5380;
							 {	/* Cfa/tvector.scm 606 */
							    app_bglt obj_4381;
							    obj_4381 =
							       (app_bglt) (node_3494);
							    aux_5380 =
							       (((app_bglt) CREF(obj_4381))->args);
							 }
							 aux_5379 =
							    append_2_18___r4_pairs_and_lists_6_3(aux_5380, BNIL);
						      }
						      arg2727_3502 =
							 MAKE_PAIR(tv_set__238_3500, aux_5379);
						   }
						   {	/* Cfa/tvector.scm 606 */
						      app_bglt obj_4384;
						      obj_4384 =
							 (app_bglt) (node_3494);
						      arg2729_3504 =
							 (((app_bglt) CREF(obj_4384))->loc);
						   }
						   arg2730_3505 =
						      CNST_TABLE_REF(((long) 10));
						   new_node_11_3501 =
						      sexp__node_235_ast_sexp(arg2727_3502, BNIL, arg2729_3504, arg2730_3505);
						}
						{	/* Cfa/tvector.scm 606 */

						   {	/* Cfa/tvector.scm 610 */
						      node_bglt aux_5389;
						      aux_5389 =
							 inline_node_218_inline_inline(new_node_11_3501, ((long) 1), BNIL);
						      return
							 (obj_t) (aux_5389);
						   }
						}
					     }
					  }
					else
					  {	/* Cfa/tvector.scm 603 */
					     return
						(obj_t) (node_3494);
					  }
				     }
				  }
			       }
			    }
			 }
			 break;
		      default:
		       case_else2574_3272:
			 if (
			    PROCEDUREP(method2568_3268))
			   {	/* Cfa/tvector.scm 265 */
			      return
				 PROCEDURE_ENTRY(method2568_3268) (method2568_3268,
				 (obj_t) (node_39), BEOA);
			   }
			 else
			   {	/* Cfa/tvector.scm 265 */
			      obj_t fun2567_3264;
			      fun2567_3264 =
				 PROCEDURE_REF(patch__env_129_cfa_tvector, ((long) 0));
			      return
				 PROCEDURE_ENTRY(fun2567_3264) (fun2567_3264,
				 (obj_t) (node_39), BEOA);
			   }
		      }
		 }
	       else
		 {	/* Cfa/tvector.scm 265 */
		    goto case_else2574_3272;
		 }
	    }
	 }
      }
   }
}



/* _patch! */
obj_t 
_patch__77_cfa_tvector(obj_t env_4401, obj_t node_4402)
{
   AN_OBJECT;
   {	/* Cfa/tvector.scm 265 */
      return
	 patch__227_cfa_tvector(
	 (node_bglt) (node_4402));
   }
}



/* patch!-default2123 */
obj_t 
patch__default2123_223_cfa_tvector(node_bglt node_40)
{
   AN_OBJECT;
   {	/* Cfa/tvector.scm 14 */
      FAILURE(
	 CNST_TABLE_REF(((long) 21)), string2777_cfa_tvector,
	 (obj_t) (node_40));
   }
}



/* _patch!-default2123 */
obj_t 
_patch__default2123_49_cfa_tvector(obj_t env_4403, obj_t node_4404)
{
   AN_OBJECT;
   {	/* Cfa/tvector.scm 14 */
      return
	 patch__default2123_223_cfa_tvector(
	 (node_bglt) (node_4404));
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_cfa_tvector()
{
   AN_OBJECT;
   {	/* Cfa/tvector.scm 14 */
      module_initialization_70_tools_trace(((long) 0), "CFA_TVECTOR");
      module_initialization_70_engine_param(((long) 0), "CFA_TVECTOR");
      module_initialization_70_module_type(((long) 0), "CFA_TVECTOR");
      module_initialization_70_module_pragma(((long) 0), "CFA_TVECTOR");
      module_initialization_70_type_type(((long) 0), "CFA_TVECTOR");
      module_initialization_70_type_cache(((long) 0), "CFA_TVECTOR");
      module_initialization_70_type_env(((long) 0), "CFA_TVECTOR");
      module_initialization_70_tvector_tvector(((long) 0), "CFA_TVECTOR");
      module_initialization_70_tools_shape(((long) 0), "CFA_TVECTOR");
      module_initialization_70_tools_speek(((long) 0), "CFA_TVECTOR");
      module_initialization_70_tools_error(((long) 0), "CFA_TVECTOR");
      module_initialization_70_ast_var(((long) 0), "CFA_TVECTOR");
      module_initialization_70_ast_node(((long) 0), "CFA_TVECTOR");
      module_initialization_70_ast_build(((long) 0), "CFA_TVECTOR");
      module_initialization_70_ast_sexp(((long) 0), "CFA_TVECTOR");
      module_initialization_70_ast_env(((long) 0), "CFA_TVECTOR");
      module_initialization_70_cfa_info(((long) 0), "CFA_TVECTOR");
      module_initialization_70_cfa_info2(((long) 0), "CFA_TVECTOR");
      module_initialization_70_cfa_cfa(((long) 0), "CFA_TVECTOR");
      module_initialization_70_cfa_approx(((long) 0), "CFA_TVECTOR");
      module_initialization_70_cfa_set(((long) 0), "CFA_TVECTOR");
      module_initialization_70_cfa_type(((long) 0), "CFA_TVECTOR");
      module_initialization_70_cfa_stack(((long) 0), "CFA_TVECTOR");
      module_initialization_70_globalize_walk(((long) 0), "CFA_TVECTOR");
      module_initialization_70_inline_inline(((long) 0), "CFA_TVECTOR");
      return
	 module_initialization_70_inline_walk(((long) 0), "CFA_TVECTOR");
   }
}
