/*===========================================================================*/
/*   (Cfa/type.scm)                                                          */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;

typedef struct approx
  {
     header_t header;
     obj_t widening;
     struct type *type;
     bool_t type_locked__184;
     obj_t allocs;
     bool_t top__138;
     long lost_stamp_114;
  }
      *approx_bglt;

typedef struct cfun_cinfo_200
  {
     struct approx *approx;
  }
              *cfun_cinfo_200_bglt;

typedef struct extern_sfun_cinfo_6
  {
     struct approx *approx;
  }
                   *extern_sfun_cinfo_6_bglt;

typedef struct intern_sfun_cinfo_192
  {
     struct approx *approx;
     long stamp;
  }
                     *intern_sfun_cinfo_192_bglt;

typedef struct scnst_cinfo_0
  {
     struct approx *approx;
  }
             *scnst_cinfo_0_bglt;

typedef struct pre_clo_env_191
  {
     char dummy;
  }
               *pre_clo_env_191_bglt;

typedef struct svar_cinfo_166
  {
     struct approx *approx;
     bool_t clo_env__87;
  }
              *svar_cinfo_166_bglt;

typedef struct cvar_cinfo_53
  {
     struct approx *approx;
  }
             *cvar_cinfo_53_bglt;

typedef struct sexit_cinfo_49
  {
     struct approx *approx;
  }
              *sexit_cinfo_49_bglt;

typedef struct reshaped_local_224
  {
     obj_t binding_value_3;
  }
                  *reshaped_local_224_bglt;

typedef struct reshaped_global_160
  {
     char dummy;
  }
                   *reshaped_global_160_bglt;

typedef struct atom_cinfo_155
  {
     struct approx *approx;
  }
              *atom_cinfo_155_bglt;

typedef struct kwote_node_102
  {
     struct node *node;
  }
              *kwote_node_102_bglt;

typedef struct kwote_cinfo_48
  {
     struct approx *approx;
  }
              *kwote_cinfo_48_bglt;

typedef struct app_ly_cinfo_234
  {
     struct approx *approx;
  }
                *app_ly_cinfo_234_bglt;

typedef struct funcall_cinfo_75
  {
     struct approx *approx;
     struct approx *va_approx_63;
     bool_t arity_error_noticed__118;
     bool_t type_error_noticed__36;
  }
                *funcall_cinfo_75_bglt;

typedef struct pragma_cinfo_220
  {
     struct approx *approx;
  }
                *pragma_cinfo_220_bglt;

typedef struct setq_cinfo_191
  {
     struct approx *approx;
  }
              *setq_cinfo_191_bglt;

typedef struct conditional_cinfo_212
  {
     struct approx *approx;
  }
                     *conditional_cinfo_212_bglt;

typedef struct fail_cinfo_75
  {
     struct approx *approx;
  }
             *fail_cinfo_75_bglt;

typedef struct select_cinfo_150
  {
     struct approx *approx;
  }
                *select_cinfo_150_bglt;

typedef struct set_ex_it_cinfo_168
  {
     struct approx *approx;
  }
                   *set_ex_it_cinfo_168_bglt;

typedef struct jump_ex_it_cinfo_139
  {
     struct approx *approx;
  }
                    *jump_ex_it_cinfo_139_bglt;

typedef struct pre_make_box_186
  {
     char dummy;
  }
                *pre_make_box_186_bglt;

typedef struct make_box_cinfo_127
  {
     struct approx *approx;
  }
                  *make_box_cinfo_127_bglt;

typedef struct make_box_o_cinfo_96
  {
     struct approx *approx;
     struct approx *value_approx_19;
  }
                   *make_box_o_cinfo_96_bglt;

typedef struct box_set__cinfo_94
  {
     struct approx *approx;
  }
                 *box_set__cinfo_94_bglt;

typedef struct box_ref_cinfo_214
  {
     struct approx *approx;
  }
                 *box_ref_cinfo_214_bglt;

typedef struct box_set__o_cinfo_6
  {
     struct approx *approx;
  }
                  *box_set__o_cinfo_6_bglt;

typedef struct box_ref_o_cinfo_98
  {
     struct approx *approx;
  }
                  *box_ref_o_cinfo_98_bglt;

typedef struct pre_make_procedure_app_60
  {
     struct variable *owner;
  }
                         *pre_make_procedure_app_60_bglt;

typedef struct pre_procedure_ref_app_85
  {
     char dummy;
  }
                        *pre_procedure_ref_app_85_bglt;

typedef struct pre_procedure_set__app_208
  {
     char dummy;
  }
                          *pre_procedure_set__app_208_bglt;

typedef struct make_procedure_app_48
  {
     struct approx *approx;
     long values_approx_len_106;
     struct approx **values_approx_79;
     long lost_stamp_114;
     bool_t x_t__142;
     bool_t x;
     bool_t t;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
  }
                     *make_procedure_app_48_bglt;

typedef struct procedure_ref_app_49
  {
     struct approx *approx;
  }
                    *procedure_ref_app_49_bglt;

typedef struct procedure_set__app_32
  {
     struct approx *approx;
  }
                     *procedure_set__app_32_bglt;

typedef struct pre_make_vector_app_251
  {
     struct variable *owner;
  }
                       *pre_make_vector_app_251_bglt;

typedef struct pre_create_vector_app_162
  {
     struct variable *owner;
  }
                         *pre_create_vector_app_162_bglt;

typedef struct pre_vector_ref_app_208
  {
     char dummy;
  }
                      *pre_vector_ref_app_208_bglt;

typedef struct pre_vector_set__app_211
  {
     char dummy;
  }
                       *pre_vector_set__app_211_bglt;

typedef struct make_vector_app_205
  {
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
     bool_t seen__39;
  }
                   *make_vector_app_205_bglt;

typedef struct create_vector_app_150
  {
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
     bool_t seen__39;
  }
                     *create_vector_app_150_bglt;

typedef struct vector_ref_app_195
  {
     struct approx *approx;
  }
                  *vector_ref_app_195_bglt;

typedef struct vector_set__app_21
  {
     struct approx *approx;
  }
                  *vector_set__app_21_bglt;

typedef struct pre_make_struct_app_218
  {
     struct variable *owner;
  }
                       *pre_make_struct_app_218_bglt;

typedef struct pre_struct_ref_app_207
  {
     char dummy;
  }
                      *pre_struct_ref_app_207_bglt;

typedef struct pre_struct_set__app_116
  {
     char dummy;
  }
                       *pre_struct_set__app_116_bglt;

typedef struct make_struct_app_214
  {
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
  }
                   *make_struct_app_214_bglt;

typedef struct struct_ref_app_73
  {
     struct approx *approx;
  }
                 *struct_ref_app_73_bglt;

typedef struct struct_set__app_162
  {
     struct approx *approx;
  }
                   *struct_set__app_162_bglt;

typedef struct tvec
  {
     struct type *item_type_130;
  }
    *tvec_bglt;


static obj_t method_init_76_cfa_type();
extern obj_t make_box_202_ast_node;
extern obj_t funcall_ast_node;
extern obj_t tvector_optimization__143_cfa_tvector();
extern long add_inlined_method__244___object(obj_t, obj_t, long);
extern obj_t fail_ast_node;
extern obj_t type_type_type;
extern obj_t box_ref_242_ast_node;
static obj_t _type_node__11_cfa_type(obj_t, obj_t);
extern obj_t sequence_ast_node;
extern obj_t let_var_6_ast_node;
static obj_t type_variable__default2082_17_cfa_type(value_bglt, variable_bglt);
extern obj_t var_ast_node;
extern obj_t closure_ast_node;
extern obj_t tvec_tvector_tvector;
extern obj_t global_ast_var;
extern obj_t _obj__252_type_cache;
static obj_t _type_variable__16_cfa_type(obj_t, obj_t, obj_t);
extern obj_t pragma_ast_node;
extern obj_t set_ex_it_116_ast_node;
static bool_t type_node___42_cfa_type(obj_t);
extern obj_t cvar_cinfo_53_cfa_info;
static obj_t _type_node__default2093_154_cfa_type(obj_t, obj_t);
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t intern_sfun_cinfo_192_cfa_info;
static obj_t type_fun__174_cfa_type(variable_bglt);
extern type_bglt get_default_type_181_type_cache();
extern obj_t module_initialization_70_cfa_type(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_cfa_info(long, char *);
extern obj_t module_initialization_70_cfa_info2(long, char *);
extern obj_t module_initialization_70_cfa_set(long, char *);
extern obj_t module_initialization_70_cfa_tvector(long, char *);
extern obj_t module_initialization_70_tvector_tvector(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
static obj_t type_variable__242_cfa_type(value_bglt, variable_bglt);
extern obj_t let_fun_218_ast_node;
extern obj_t fun_ast_var;
static obj_t imported_modules_init_94_cfa_type();
extern obj_t scnst_cinfo_0_cfa_info;
extern obj_t app_ly_162_ast_node;
extern obj_t add_generic__110___object(obj_t, obj_t);
extern obj_t app_ast_node;
static obj_t library_modules_init_112_cfa_type();
extern obj_t get_approx_type_210_cfa_type(approx_bglt);
extern obj_t make_vector_app_205_cfa_info2;
extern obj_t atom_ast_node;
extern obj_t cast_ast_node;
static obj_t toplevel_init_63_cfa_type();
extern obj_t _unsafe_type__146_engine_param;
extern obj_t jump_ex_it_184_ast_node;
extern obj_t open_input_string(obj_t);
extern obj_t kwote_ast_node;
extern obj_t setq_ast_node;
extern obj_t box_set__221_ast_node;
extern obj_t create_vector_app_150_cfa_info2;
static obj_t _type_settings__245_cfa_type(obj_t, obj_t);
static obj_t type_node__default2093_134_cfa_type(node_bglt);
static obj_t _get_approx_type_72_cfa_type(obj_t, obj_t);
extern obj_t shape_tools_shape(obj_t);
extern obj_t internal_error_43_tools_error(obj_t, obj_t, obj_t);
static obj_t type_node__55_cfa_type(node_bglt);
extern obj_t _classes__134___object;
static obj_t _type_variable__default2082_69_cfa_type(obj_t, obj_t, obj_t);
extern obj_t select_ast_node;
extern obj_t read___reader(obj_t);
extern type_bglt get_vector_item_type_88_cfa_tvector(app_bglt);
static obj_t set_variable_type__9_cfa_type(variable_bglt, type_bglt);
extern obj_t type_settings__207_cfa_type(obj_t);
extern obj_t sexit_cinfo_49_cfa_info;
extern obj_t svar_cinfo_166_cfa_info;
extern obj_t ____74_type_cache;
static obj_t require_initialization_114_cfa_type = BUNSPEC;
extern obj_t _vector__240_type_cache;
extern obj_t conditional_ast_node;
extern obj_t set__list_248_cfa_set(obj_t);
static obj_t cnst_init_137_cfa_type();
static obj_t __cnst[4];

DEFINE_STATIC_GENERIC(type_node__env_231_cfa_type, _type_node__11_cfa_type2515, _type_node__11_cfa_type, 0L, 1);
DEFINE_STATIC_PROCEDURE(type_variable__default2082_env_195_cfa_type, _type_variable__default2082_69_cfa_type2516, _type_variable__default2082_69_cfa_type, 0L, 2);
DEFINE_EXPORT_PROCEDURE(get_approx_type_env_38_cfa_type, _get_approx_type_72_cfa_type2517, _get_approx_type_72_cfa_type, 0L, 1);
DEFINE_EXPORT_PROCEDURE(type_settings__env_8_cfa_type, _type_settings__245_cfa_type2518, _type_settings__245_cfa_type, 0L, 1);
DEFINE_STRING(string2509_cfa_type, string2509_cfa_type2519, "No method for this object", 25);
DEFINE_STRING(string2510_cfa_type, string2510_cfa_type2520, "TYPE-NODE!-DEFAULT2093 STATIC NOTHING BIGLOO ", 45);
DEFINE_STRING(string2508_cfa_type, string2508_cfa_type2521, "Unexpected closure", 18);
DEFINE_STRING(string2507_cfa_type, string2507_cfa_type2522, "type-node!", 10);
DEFINE_STATIC_GENERIC(type_variable__env_200_cfa_type, _type_variable__16_cfa_type2523, _type_variable__16_cfa_type, 0L, 2);
DEFINE_STATIC_PROCEDURE(type_node__default2093_env_199_cfa_type, _type_node__default2093_154_cfa_type2524, _type_node__default2093_154_cfa_type, 0L, 1);



/* module-initialization */
obj_t 
module_initialization_70_cfa_type(long checksum_3736, char *from_3737)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_cfa_type))
	{
	   require_initialization_114_cfa_type =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_cfa_type();
	   cnst_init_137_cfa_type();
	   imported_modules_init_94_cfa_type();
	   method_init_76_cfa_type();
	   toplevel_init_63_cfa_type();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_cfa_type()
{
   AN_OBJECT;
   {	/* Cfa/type.scm 14 */
      module_initialization_70___object(((long) 0), "CFA_TYPE");
      module_initialization_70___reader(((long) 0), "CFA_TYPE");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_cfa_type()
{
   AN_OBJECT;
   {	/* Cfa/type.scm 14 */
      {		/* Cfa/type.scm 14 */
	 obj_t cnst_port_138_3729;
	 cnst_port_138_3729 =
	    open_input_string(string2510_cfa_type);
	 {
	    long i_3730;
	    i_3730 = ((long) 3);
	  loop_3731:
	    {	/* Cfa/type.scm 14 */
	       bool_t test2511_3732;
	       test2511_3732 =
		  (i_3730 == ((long) -1));
	       if (test2511_3732)
		 {	/* Cfa/type.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Cfa/type.scm 14 */
		    {	/* Cfa/type.scm 14 */
		       obj_t arg2512_3733;
		       {	/* Cfa/type.scm 14 */
			  obj_t list2513_3734;
			  list2513_3734 =
			     MAKE_PAIR(cnst_port_138_3729, BNIL);
			  arg2512_3733 =
			     read___reader(list2513_3734);
		       }
		       CNST_TABLE_SET(i_3730, arg2512_3733);
		    }
		    {	/* Cfa/type.scm 14 */
		       int aux_3735;
		       {	/* Cfa/type.scm 14 */
			  long aux_3754;
			  aux_3754 =
			     (i_3730 - ((long) 1));
			  aux_3735 =
			     (int) (aux_3754);
		       }
		       {
			  long i_3757;
			  i_3757 =
			     (long) (aux_3735);
			  i_3730 = i_3757;
			  goto loop_3731;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_cfa_type()
{
   AN_OBJECT;
   {	/* Cfa/type.scm 14 */
      return BUNSPEC;
   }
}



/* type-settings! */
obj_t 
type_settings__207_cfa_type(obj_t globals_1)
{
   AN_OBJECT;
   {	/* Cfa/type.scm 36 */
      {
	 obj_t l2049_2195;
	 {	/* Cfa/type.scm 37 */
	    bool_t aux_3759;
	    l2049_2195 = globals_1;
	  lname2050_2196:
	    if (
	       PAIRP(l2049_2195))
	      {		/* Cfa/type.scm 37 */
		 {	/* Cfa/type.scm 37 */
		    variable_bglt aux_3762;
		    {	/* Cfa/type.scm 37 */
		       obj_t aux_3763;
		       aux_3763 =
			  CAR(l2049_2195);
		       aux_3762 =
			  (variable_bglt) (aux_3763);
		    }
		    type_fun__174_cfa_type(aux_3762);
		 }
		 {
		    obj_t l2049_3767;
		    l2049_3767 =
		       CDR(l2049_2195);
		    l2049_2195 = l2049_3767;
		    goto lname2050_2196;
		 }
	      }
	    else
	      {		/* Cfa/type.scm 37 */
		 aux_3759 = ((bool_t) 1);
	      }
	    return
	       BBOOL(aux_3759);
	 }
      }
   }
}



/* _type-settings! */
obj_t 
_type_settings__245_cfa_type(obj_t env_3715, obj_t globals_3716)
{
   AN_OBJECT;
   {	/* Cfa/type.scm 36 */
      return
	 type_settings__207_cfa_type(globals_3716);
   }
}



/* type-fun! */
obj_t 
type_fun__174_cfa_type(variable_bglt var_2)
{
   AN_OBJECT;
   {	/* Cfa/type.scm 42 */
      {		/* Cfa/type.scm 43 */
	 value_bglt fun_2200;
	 fun_2200 =
	    (((variable_bglt) CREF(var_2))->value);
	 {	/* Cfa/type.scm 44 */
	    bool_t test2139_2201;
	    test2139_2201 =
	       is_a__118___object(
	       (obj_t) (fun_2200), intern_sfun_cinfo_192_cfa_info);
	    if (test2139_2201)
	      {		/* Cfa/type.scm 44 */
		 {
		    obj_t l2052_2203;
		    {	/* Cfa/type.scm 49 */
		       sfun_bglt obj_3181;
		       obj_3181 =
			  (sfun_bglt) (fun_2200);
		       l2052_2203 =
			  (((sfun_bglt) CREF(obj_3181))->args);
		    }
		  lname2053_2204:
		    if (
		       PAIRP(l2052_2203))
		      {		/* Cfa/type.scm 49 */
			 {	/* Cfa/type.scm 49 */
			    obj_t var_2207;
			    var_2207 =
			       CAR(l2052_2203);
			    {	/* Cfa/type.scm 49 */
			       value_bglt aux_3778;
			       {	/* Cfa/type.scm 49 */
				  local_bglt obj_3184;
				  obj_3184 =
				     (local_bglt) (var_2207);
				  aux_3778 =
				     (((local_bglt) CREF(obj_3184))->value);
			       }
			       type_variable__242_cfa_type(aux_3778,
				  (variable_bglt) (var_2207));
			    }
			 }
			 {
			    obj_t l2052_3783;
			    l2052_3783 =
			       CDR(l2052_2203);
			    l2052_2203 = l2052_3783;
			    goto lname2053_2204;
			 }
		      }
		    else
		      {		/* Cfa/type.scm 49 */
			 ((bool_t) 1);
		      }
		 }
		 {	/* Cfa/type.scm 52 */
		    node_bglt aux_3787;
		    {	/* Cfa/type.scm 52 */
		       obj_t aux_3788;
		       {	/* Cfa/type.scm 52 */
			  sfun_bglt obj_3186;
			  obj_3186 =
			     (sfun_bglt) (fun_2200);
			  aux_3788 =
			     (((sfun_bglt) CREF(obj_3186))->body);
		       }
		       aux_3787 =
			  (node_bglt) (aux_3788);
		    }
		    type_node__55_cfa_type(aux_3787);
		 }
		 {	/* Cfa/type.scm 54 */
		    obj_t arg2148_2211;
		    {	/* Cfa/type.scm 54 */
		       approx_bglt aux_3793;
		       {	/* Cfa/type.scm 54 */
			  intern_sfun_cinfo_192_bglt obj_3187;
			  obj_3187 =
			     (intern_sfun_cinfo_192_bglt) (fun_2200);
			  {
			     obj_t aux_3795;
			     {	/* ./Cfa/cinfo.scm 1292 */
				object_bglt aux_3796;
				aux_3796 =
				   (object_bglt) (obj_3187);
				aux_3795 =
				   OBJECT_WIDENING(aux_3796);
			     }
			     aux_3793 =
				(((intern_sfun_cinfo_192_bglt) CREF(aux_3795))->approx);
			  }
		       }
		       arg2148_2211 =
			  get_approx_type_210_cfa_type(aux_3793);
		    }
		    return
		       set_variable_type__9_cfa_type(var_2,
		       (type_bglt) (arg2148_2211));
		 }
	      }
	    else
	      {		/* Cfa/type.scm 44 */
		 return BUNSPEC;
	      }
	 }
      }
   }
}



/* get-approx-type */
obj_t 
get_approx_type_210_cfa_type(approx_bglt approx_3)
{
   AN_OBJECT;
   {	/* Cfa/type.scm 59 */
      {		/* Cfa/type.scm 60 */
	 type_bglt type_2213;
	 obj_t alloc_list_184_2214;
	 type_2213 =
	    (((approx_bglt) CREF(approx_3))->type);
	 alloc_list_184_2214 =
	    set__list_248_cfa_set(
	    (((approx_bglt) CREF(approx_3))->allocs));
	 if (
	    PAIRP(alloc_list_184_2214))
	   {	/* Cfa/type.scm 65 */
	      bool_t test2151_2216;
	      {		/* Cfa/type.scm 65 */
		 obj_t aux_3808;
		 aux_3808 =
		    tvector_optimization__143_cfa_tvector();
		 test2151_2216 =
		    CBOOL(aux_3808);
	      }
	      if (test2151_2216)
		{	/* Cfa/type.scm 67 */
		   bool_t test2152_2217;
		   test2152_2217 =
		      is_a__118___object(
		      CAR(alloc_list_184_2214), make_vector_app_205_cfa_info2);
		   if (test2152_2217)
		     {	/* Cfa/type.scm 67 */
			{	/* Cfa/type.scm 68 */
			   obj_t app_2218;
			   app_2218 =
			      CAR(alloc_list_184_2214);
			   {	/* Cfa/type.scm 68 */
			      type_bglt tv_type_111_2219;
			      tv_type_111_2219 =
				 get_vector_item_type_88_cfa_tvector(
				 (app_bglt) (app_2218));
			      {		/* Cfa/type.scm 69 */
				 approx_bglt value_approx_19_2220;
				 {	/* Cfa/type.scm 70 */
				    make_vector_app_205_bglt obj_3194;
				    obj_3194 =
				       (make_vector_app_205_bglt) (app_2218);
				    {
				       obj_t aux_3819;
				       {	/* ./Cfa/cinfo2.scm 1411 */
					  object_bglt aux_3820;
					  aux_3820 =
					     (object_bglt) (obj_3194);
					  aux_3819 =
					     OBJECT_WIDENING(aux_3820);
				       }
				       value_approx_19_2220 =
					  (((make_vector_app_205_bglt) CREF(aux_3819))->value_approx_19);
				    }
				 }
				 {	/* Cfa/type.scm 70 */
				    type_bglt item_type_130_2221;
				    item_type_130_2221 =
				       (((approx_bglt) CREF(value_approx_19_2220))->type);
				    {	/* Cfa/type.scm 71 */
				       obj_t tv_2222;
				       tv_2222 =
					  (((type_bglt) CREF(item_type_130_2221))->tvector);
				       {	/* Cfa/type.scm 72 */

					  {	/* Cfa/type.scm 73 */
					     bool_t test2153_2223;
					     test2153_2223 =
						is_a__118___object(tv_2222, type_type_type);
					     if (test2153_2223)
					       {	/* Cfa/type.scm 73 */
						  return tv_2222;
					       }
					     else
					       {	/* Cfa/type.scm 73 */
						  return
						     (obj_t) (type_2213);
					       }
					  }
				       }
				    }
				 }
			      }
			   }
			}
		     }
		   else
		     {	/* Cfa/type.scm 76 */
			bool_t test2154_2224;
			test2154_2224 =
			   is_a__118___object(
			   CAR(alloc_list_184_2214), create_vector_app_150_cfa_info2);
			if (test2154_2224)
			  {	/* Cfa/type.scm 76 */
			     {	/* Cfa/type.scm 77 */
				obj_t app_2225;
				app_2225 =
				   CAR(alloc_list_184_2214);
				{	/* Cfa/type.scm 77 */
				   type_bglt tv_type_111_2226;
				   tv_type_111_2226 =
				      get_vector_item_type_88_cfa_tvector(
				      (app_bglt) (app_2225));
				   {	/* Cfa/type.scm 78 */
				      approx_bglt value_approx_19_2227;
				      {		/* Cfa/type.scm 79 */
					 create_vector_app_150_bglt obj_3201;
					 obj_3201 =
					    (create_vector_app_150_bglt) (app_2225);
					 {
					    obj_t aux_3836;
					    {	/* ./Cfa/cinfo2.scm 1435 */
					       object_bglt aux_3837;
					       aux_3837 =
						  (object_bglt) (obj_3201);
					       aux_3836 =
						  OBJECT_WIDENING(aux_3837);
					    }
					    value_approx_19_2227 =
					       (((create_vector_app_150_bglt) CREF(aux_3836))->value_approx_19);
					 }
				      }
				      {		/* Cfa/type.scm 79 */
					 type_bglt item_type_130_2228;
					 item_type_130_2228 =
					    (((approx_bglt) CREF(value_approx_19_2227))->type);
					 {	/* Cfa/type.scm 80 */
					    obj_t tv_2229;
					    tv_2229 =
					       (((type_bglt) CREF(item_type_130_2228))->tvector);
					    {	/* Cfa/type.scm 81 */

					       {	/* Cfa/type.scm 82 */
						  bool_t test2155_2230;
						  test2155_2230 =
						     is_a__118___object(tv_2229, type_type_type);
						  if (test2155_2230)
						    {	/* Cfa/type.scm 82 */
						       return tv_2229;
						    }
						  else
						    {	/* Cfa/type.scm 82 */
						       return
							  (obj_t) (type_2213);
						    }
					       }
					    }
					 }
				      }
				   }
				}
			     }
			  }
			else
			  {	/* Cfa/type.scm 76 */
			     return
				(obj_t) (type_2213);
			  }
		     }
		}
	      else
		{	/* Cfa/type.scm 65 */
		   return
		      (obj_t) (type_2213);
		}
	   }
	 else
	   {	/* Cfa/type.scm 63 */
	      return
		 (obj_t) (type_2213);
	   }
      }
   }
}



/* _get-approx-type */
obj_t 
_get_approx_type_72_cfa_type(obj_t env_3717, obj_t approx_3718)
{
   AN_OBJECT;
   {	/* Cfa/type.scm 59 */
      return
	 get_approx_type_210_cfa_type(
	 (approx_bglt) (approx_3718));
   }
}



/* set-variable-type! */
obj_t 
set_variable_type__9_cfa_type(variable_bglt variable_18, type_bglt type_19)
{
   AN_OBJECT;
   {	/* Cfa/type.scm 141 */
      {		/* Cfa/type.scm 142 */
	 obj_t ntype_2234;
	 type_bglt otype_2235;
	 {	/* Cfa/type.scm 142 */
	    bool_t test2169_2246;
	    {	/* Cfa/type.scm 142 */
	       obj_t obj2_3206;
	       obj2_3206 = ____74_type_cache;
	       {	/* ./Ieee/equiv.scm 5508 */
		  obj_t aux_3851;
		  aux_3851 =
		     (obj_t) (type_19);
		  test2169_2246 =
		     (aux_3851 == obj2_3206);
	       }
	    }
	    if (test2169_2246)
	      {		/* Cfa/type.scm 142 */
		 ntype_2234 = _obj__252_type_cache;
	      }
	    else
	      {		/* Cfa/type.scm 142 */
		 ntype_2234 =
		    (obj_t) (type_19);
	      }
	 }
	 otype_2235 =
	    (((variable_bglt) CREF(variable_18))->type);
	 {	/* Cfa/type.scm 145 */
	    bool_t test2159_2236;
	    {	/* Cfa/type.scm 145 */
	       obj_t obj2_3209;
	       obj2_3209 = ____74_type_cache;
	       {	/* ./Ieee/equiv.scm 5508 */
		  obj_t aux_3857;
		  aux_3857 =
		     (obj_t) (otype_2235);
		  test2159_2236 =
		     (aux_3857 == obj2_3209);
	       }
	    }
	    if (test2159_2236)
	      {		/* Cfa/type.scm 145 */
		 {	/* Cfa/type.scm 146 */
		    bool_t test2160_2237;
		    {	/* Cfa/type.scm 146 */
		       bool_t test2161_2238;
		       test2161_2238 =
			  is_a__118___object(
			  (obj_t) (variable_18), global_ast_var);
		       if (test2161_2238)
			 {	/* Cfa/type.scm 147 */
			    bool_t test2162_2239;
			    {	/* ./Ast/var.scm 1012 */
			       obj_t aux_3864;
			       {	/* Cfa/type.scm 147 */
				  value_bglt aux_3865;
				  {	/* Cfa/type.scm 147 */
				     global_bglt obj_3211;
				     obj_3211 =
					(global_bglt) (variable_18);
				     aux_3865 =
					(((global_bglt) CREF(obj_3211))->value);
				  }
				  aux_3864 =
				     (obj_t) (aux_3865);
			       }
			       test2162_2239 =
				  is_a__118___object(aux_3864, fun_ast_var);
			    }
			    if (test2162_2239)
			      {		/* Cfa/type.scm 147 */
				 test2160_2237 = ((bool_t) 0);
			      }
			    else
			      {		/* Cfa/type.scm 147 */
				 if (
				    CBOOL(_unsafe_type__146_engine_param))
				   {	/* Cfa/type.scm 148 */
				      test2160_2237 = ((bool_t) 0);
				   }
				 else
				   {	/* Cfa/type.scm 149 */
				      bool_t test_3873;
				      {		/* ./Ieee/equiv.scm 5508 */
					 obj_t aux_3877;
					 obj_t aux_3874;
					 aux_3877 =
					    CNST_TABLE_REF(((long) 0));
					 {	/* Cfa/type.scm 149 */
					    type_bglt obj_3213;
					    obj_3213 =
					       (type_bglt) (ntype_2234);
					    aux_3874 =
					       (((type_bglt) CREF(obj_3213))->class);
					 }
					 test_3873 =
					    (aux_3874 == aux_3877);
				      }
				      if (test_3873)
					{	/* Cfa/type.scm 149 */
					   test2160_2237 = ((bool_t) 0);
					}
				      else
					{	/* Cfa/type.scm 149 */
					   test2160_2237 = ((bool_t) 1);
					}
				   }
			      }
			 }
		       else
			 {	/* Cfa/type.scm 146 */
			    test2160_2237 = ((bool_t) 0);
			 }
		    }
		    if (test2160_2237)
		      {		/* Cfa/type.scm 154 */
			 type_bglt val1034_3217;
			 val1034_3217 =
			    (type_bglt) (_obj__252_type_cache);
			 return
			    ((((variable_bglt) CREF(variable_18))->type) = ((type_bglt) val1034_3217), BUNSPEC);
		      }
		    else
		      {		/* Cfa/type.scm 155 */
			 type_bglt val1034_3219;
			 val1034_3219 =
			    (type_bglt) (ntype_2234);
			 return
			    ((((variable_bglt) CREF(variable_18))->type) = ((type_bglt) val1034_3219), BUNSPEC);
		      }
		 }
	      }
	    else
	      {		/* Cfa/type.scm 156 */
		 bool_t test2167_2244;
		 {	/* Cfa/type.scm 156 */
		    bool_t test2168_2245;
		    {	/* Cfa/type.scm 156 */
		       obj_t obj2_3221;
		       obj2_3221 = _vector__240_type_cache;
		       {	/* ./Ieee/equiv.scm 5508 */
			  obj_t aux_3885;
			  aux_3885 =
			     (obj_t) (otype_2235);
			  test2168_2245 =
			     (aux_3885 == obj2_3221);
		       }
		    }
		    if (test2168_2245)
		      {		/* Cfa/type.scm 156 */
			 test2167_2244 =
			    is_a__118___object(ntype_2234, tvec_tvector_tvector);
		      }
		    else
		      {		/* Cfa/type.scm 156 */
			 test2167_2244 = ((bool_t) 0);
		      }
		 }
		 if (test2167_2244)
		   {	/* Cfa/type.scm 156 */
		      {		/* Cfa/type.scm 157 */
			 type_bglt val1034_3224;
			 val1034_3224 =
			    (type_bglt) (ntype_2234);
			 return
			    ((((variable_bglt) CREF(variable_18))->type) = ((type_bglt) val1034_3224), BUNSPEC);
		      }
		   }
		 else
		   {	/* Cfa/type.scm 156 */
		      return BFALSE;
		   }
	      }
	 }
      }
   }
}



/* type-node*! */
bool_t 
type_node___42_cfa_type(obj_t node__221_43)
{
   AN_OBJECT;
   {	/* Cfa/type.scm 334 */
      {
	 obj_t l2080_2247;
	 l2080_2247 = node__221_43;
       lname2081_2248:
	 if (
	    PAIRP(l2080_2247))
	   {	/* Cfa/type.scm 335 */
	      {		/* Cfa/type.scm 335 */
		 node_bglt aux_3895;
		 {	/* Cfa/type.scm 335 */
		    obj_t aux_3896;
		    aux_3896 =
		       CAR(l2080_2247);
		    aux_3895 =
		       (node_bglt) (aux_3896);
		 }
		 type_node__55_cfa_type(aux_3895);
	      }
	      {
		 obj_t l2080_3900;
		 l2080_3900 =
		    CDR(l2080_2247);
		 l2080_2247 = l2080_3900;
		 goto lname2081_2248;
	      }
	   }
	 else
	   {	/* Cfa/type.scm 335 */
	      return ((bool_t) 1);
	   }
      }
   }
}



/* method-init */
obj_t 
method_init_76_cfa_type()
{
   AN_OBJECT;
   {	/* Cfa/type.scm 14 */
      add_generic__110___object(type_variable__env_200_cfa_type, type_variable__default2082_env_195_cfa_type);
      add_inlined_method__244___object(type_variable__env_200_cfa_type, svar_cinfo_166_cfa_info, ((long) 0));
      add_inlined_method__244___object(type_variable__env_200_cfa_type, scnst_cinfo_0_cfa_info, ((long) 1));
      add_inlined_method__244___object(type_variable__env_200_cfa_type, cvar_cinfo_53_cfa_info, ((long) 2));
      add_inlined_method__244___object(type_variable__env_200_cfa_type, sexit_cinfo_49_cfa_info, ((long) 3));
      add_inlined_method__244___object(type_variable__env_200_cfa_type, intern_sfun_cinfo_192_cfa_info, ((long) 4));
      add_generic__110___object(type_node__env_231_cfa_type, type_node__default2093_env_199_cfa_type);
      add_inlined_method__244___object(type_node__env_231_cfa_type, atom_ast_node, ((long) 0));
      add_inlined_method__244___object(type_node__env_231_cfa_type, kwote_ast_node, ((long) 1));
      add_inlined_method__244___object(type_node__env_231_cfa_type, var_ast_node, ((long) 2));
      add_inlined_method__244___object(type_node__env_231_cfa_type, closure_ast_node, ((long) 3));
      add_inlined_method__244___object(type_node__env_231_cfa_type, sequence_ast_node, ((long) 4));
      add_inlined_method__244___object(type_node__env_231_cfa_type, app_ast_node, ((long) 5));
      add_inlined_method__244___object(type_node__env_231_cfa_type, app_ly_162_ast_node, ((long) 6));
      add_inlined_method__244___object(type_node__env_231_cfa_type, funcall_ast_node, ((long) 7));
      add_inlined_method__244___object(type_node__env_231_cfa_type, pragma_ast_node, ((long) 8));
      add_inlined_method__244___object(type_node__env_231_cfa_type, cast_ast_node, ((long) 9));
      add_inlined_method__244___object(type_node__env_231_cfa_type, setq_ast_node, ((long) 10));
      add_inlined_method__244___object(type_node__env_231_cfa_type, conditional_ast_node, ((long) 11));
      add_inlined_method__244___object(type_node__env_231_cfa_type, fail_ast_node, ((long) 12));
      add_inlined_method__244___object(type_node__env_231_cfa_type, select_ast_node, ((long) 13));
      add_inlined_method__244___object(type_node__env_231_cfa_type, let_fun_218_ast_node, ((long) 14));
      add_inlined_method__244___object(type_node__env_231_cfa_type, let_var_6_ast_node, ((long) 15));
      add_inlined_method__244___object(type_node__env_231_cfa_type, set_ex_it_116_ast_node, ((long) 16));
      add_inlined_method__244___object(type_node__env_231_cfa_type, jump_ex_it_184_ast_node, ((long) 17));
      add_inlined_method__244___object(type_node__env_231_cfa_type, make_box_202_ast_node, ((long) 18));
      add_inlined_method__244___object(type_node__env_231_cfa_type, box_set__221_ast_node, ((long) 19));
      {		/* Cfa/type.scm 14 */
	 long aux_3929;
	 aux_3929 =
	    add_inlined_method__244___object(type_node__env_231_cfa_type, box_ref_242_ast_node, ((long) 20));
	 return
	    BINT(aux_3929);
      }
   }
}



/* type-variable! */
obj_t 
type_variable__242_cfa_type(value_bglt value_4, variable_bglt variable_5)
{
   AN_OBJECT;
   {	/* Cfa/type.scm 91 */
      {
	 obj_t method2484_3144;
	 obj_t class2489_3145;
	 {	/* Cfa/type.scm 91 */
	    obj_t arg2492_3142;
	    obj_t arg2493_3143;
	    {	/* Cfa/type.scm 91 */
	       object_bglt obj_3594;
	       obj_3594 =
		  (object_bglt) (value_4);
	       {	/* ./Llib/object.scm 2926 */
		  obj_t pre_method_105_3595;
		  pre_method_105_3595 =
		     PROCEDURE_REF(type_variable__env_200_cfa_type, ((long) 2));
		  if (
		     INTEGERP(pre_method_105_3595))
		    {	/* ./Llib/object.scm 2927 */
		       PROCEDURE_SET(type_variable__env_200_cfa_type, ((long) 2), BUNSPEC);
		       arg2492_3142 = pre_method_105_3595;
		    }
		  else
		    {	/* ./Llib/object.scm 2914 */
		       long obj_class_num_177_3600;
		       obj_class_num_177_3600 =
			  TYPE(obj_3594);
		       {	/* ./Llib/object.scm 2915 */
			  obj_t arg1176_3601;
			  arg1176_3601 =
			     PROCEDURE_REF(type_variable__env_200_cfa_type, ((long) 1));
			  {	/* ./Llib/object.scm 2738 */
			     long arg1177_3605;
			     {	/* ./Llib/object.scm 2738 */
				long arg1178_3606;
				arg1178_3606 =
				   OBJECT_TYPE;
				arg1177_3605 =
				   (obj_class_num_177_3600 - arg1178_3606);
			     }
			     arg2492_3142 =
				VECTOR_REF(arg1176_3601, arg1177_3605);
			  }
		       }
		    }
	       }
	    }
	    {	/* Cfa/type.scm 91 */
	       object_bglt object_3611;
	       object_3611 =
		  (object_bglt) (value_4);
	       {	/* ./Llib/object.scm 2695 */
		  long arg1179_3612;
		  {	/* ./Llib/object.scm 2695 */
		     long arg1180_3613;
		     long arg1181_3614;
		     arg1180_3613 =
			TYPE(object_3611);
		     arg1181_3614 =
			OBJECT_TYPE;
		     arg1179_3612 =
			(arg1180_3613 - arg1181_3614);
		  }
		  {	/* ./Llib/object.scm 2695 */
		     obj_t vector_3618;
		     vector_3618 = _classes__134___object;
		     arg2493_3143 =
			VECTOR_REF(vector_3618, arg1179_3612);
		  }
	       }
	    }
	    method2484_3144 = arg2492_3142;
	    class2489_3145 = arg2493_3143;
	    {

	       if (
		  INTEGERP(method2484_3144))
		 {	/* Cfa/type.scm 91 */
		    switch (
		       (long) CINT(method2484_3144))
		      {
		      case ((long) 0):

			 {	/* Cfa/type.scm 101 */
			    svar_cinfo_166_bglt value_3151;
			    value_3151 =
			       (svar_cinfo_166_bglt) (value_4);
			    {	/* Cfa/type.scm 102 */
			       obj_t arg2496_3154;
			       {	/* Cfa/type.scm 102 */
				  approx_bglt aux_3950;
				  {
				     obj_t aux_3951;
				     {	/* ./Cfa/cinfo.scm 1301 */
					object_bglt aux_3952;
					aux_3952 =
					   (object_bglt) (value_3151);
					aux_3951 =
					   OBJECT_WIDENING(aux_3952);
				     }
				     aux_3950 =
					(((svar_cinfo_166_bglt) CREF(aux_3951))->approx);
				  }
				  arg2496_3154 =
				     get_approx_type_210_cfa_type(aux_3950);
			       }
			       return
				  set_variable_type__9_cfa_type(variable_5,
				  (type_bglt) (arg2496_3154));
			    }
			 }
			 break;
		      case ((long) 1):

			 return
			    CNST_TABLE_REF(((long) 1));
			 break;
		      case ((long) 2):

			 {	/* Cfa/type.scm 114 */
			    cvar_cinfo_53_bglt value_3158;
			    value_3158 =
			       (cvar_cinfo_53_bglt) (value_4);
			    {	/* Cfa/type.scm 115 */
			       obj_t arg2498_3161;
			       {	/* Cfa/type.scm 115 */
				  approx_bglt aux_3961;
				  {
				     obj_t aux_3962;
				     {	/* ./Cfa/cinfo.scm 1306 */
					object_bglt aux_3963;
					aux_3963 =
					   (object_bglt) (value_3158);
					aux_3962 =
					   OBJECT_WIDENING(aux_3963);
				     }
				     aux_3961 =
					(((cvar_cinfo_53_bglt) CREF(aux_3962))->approx);
				  }
				  arg2498_3161 =
				     get_approx_type_210_cfa_type(aux_3961);
			       }
			       return
				  set_variable_type__9_cfa_type(variable_5,
				  (type_bglt) (arg2498_3161));
			    }
			 }
			 break;
		      case ((long) 3):

			 return
			    CNST_TABLE_REF(((long) 1));
			 break;
		      case ((long) 4):

			 return
			    CNST_TABLE_REF(((long) 1));
			 break;
		      default:
		       case_else2490_3148:
			 if (
			    PROCEDUREP(method2484_3144))
			   {	/* Cfa/type.scm 91 */
			      return
				 PROCEDURE_ENTRY(method2484_3144) (method2484_3144,
				 (obj_t) (value_4),
				 (obj_t) (variable_5), BEOA);
			   }
			 else
			   {	/* Cfa/type.scm 91 */
			      obj_t fun2410_3014;
			      fun2410_3014 =
				 PROCEDURE_REF(type_variable__env_200_cfa_type, ((long) 0));
			      return
				 PROCEDURE_ENTRY(fun2410_3014) (fun2410_3014,
				 (obj_t) (value_4),
				 (obj_t) (variable_5), BEOA);
			   }
		      }
		 }
	       else
		 {	/* Cfa/type.scm 91 */
		    goto case_else2490_3148;
		 }
	    }
	 }
      }
   }
}



/* _type-variable! */
obj_t 
_type_variable__16_cfa_type(obj_t env_3719, obj_t value_3720, obj_t variable_3721)
{
   AN_OBJECT;
   {	/* Cfa/type.scm 91 */
      return
	 type_variable__242_cfa_type(
	 (value_bglt) (value_3720),
	 (variable_bglt) (variable_3721));
   }
}



/* type-variable!-default2082 */
obj_t 
type_variable__default2082_17_cfa_type(value_bglt value_6, variable_bglt variable_7)
{
   AN_OBJECT;
   {	/* Cfa/type.scm 14 */
      {		/* Cfa/type.scm 93 */
	 bool_t test2411_3625;
	 {	/* ./Type/type.scm 592 */
	    obj_t aux_3988;
	    {	/* Cfa/type.scm 93 */
	       type_bglt aux_3989;
	       aux_3989 =
		  (((variable_bglt) CREF(variable_7))->type);
	       aux_3988 =
		  (obj_t) (aux_3989);
	    }
	    test2411_3625 =
	       is_a__118___object(aux_3988, type_type_type);
	 }
	 if (test2411_3625)
	   {	/* Cfa/type.scm 93 */
	      return
		 CNST_TABLE_REF(((long) 1));
	   }
	 else
	   {	/* Cfa/type.scm 95 */
	      type_bglt arg2412_3626;
	      arg2412_3626 =
		 get_default_type_181_type_cache();
	      return
		 set_variable_type__9_cfa_type(variable_7, arg2412_3626);
	   }
      }
   }
}



/* _type-variable!-default2082 */
obj_t 
_type_variable__default2082_69_cfa_type(obj_t env_3722, obj_t value_3723, obj_t variable_3724)
{
   AN_OBJECT;
   {	/* Cfa/type.scm 14 */
      return
	 type_variable__default2082_17_cfa_type(
	 (value_bglt) (value_3723),
	 (variable_bglt) (variable_3724));
   }
}



/* type-node! */
obj_t 
type_node__55_cfa_type(node_bglt node_20)
{
   AN_OBJECT;
   {	/* Cfa/type.scm 162 */
    type_node__55_cfa_type:
      {
	 obj_t method2414_3022;
	 obj_t class2419_3023;
	 {	/* Cfa/type.scm 162 */
	    obj_t arg2422_3020;
	    obj_t arg2423_3021;
	    {	/* Cfa/type.scm 162 */
	       object_bglt obj_3629;
	       obj_3629 =
		  (object_bglt) (node_20);
	       {	/* ./Llib/object.scm 2926 */
		  obj_t pre_method_105_3630;
		  pre_method_105_3630 =
		     PROCEDURE_REF(type_node__env_231_cfa_type, ((long) 2));
		  if (
		     INTEGERP(pre_method_105_3630))
		    {	/* ./Llib/object.scm 2927 */
		       PROCEDURE_SET(type_node__env_231_cfa_type, ((long) 2), BUNSPEC);
		       arg2422_3020 = pre_method_105_3630;
		    }
		  else
		    {	/* ./Llib/object.scm 2914 */
		       long obj_class_num_177_3635;
		       obj_class_num_177_3635 =
			  TYPE(obj_3629);
		       {	/* ./Llib/object.scm 2915 */
			  obj_t arg1176_3636;
			  arg1176_3636 =
			     PROCEDURE_REF(type_node__env_231_cfa_type, ((long) 1));
			  {	/* ./Llib/object.scm 2738 */
			     long arg1177_3640;
			     {	/* ./Llib/object.scm 2738 */
				long arg1178_3641;
				arg1178_3641 =
				   OBJECT_TYPE;
				arg1177_3640 =
				   (obj_class_num_177_3635 - arg1178_3641);
			     }
			     arg2422_3020 =
				VECTOR_REF(arg1176_3636, arg1177_3640);
			  }
		       }
		    }
	       }
	    }
	    {	/* Cfa/type.scm 162 */
	       object_bglt object_3646;
	       object_3646 =
		  (object_bglt) (node_20);
	       {	/* ./Llib/object.scm 2695 */
		  long arg1179_3647;
		  {	/* ./Llib/object.scm 2695 */
		     long arg1180_3648;
		     long arg1181_3649;
		     arg1180_3648 =
			TYPE(object_3646);
		     arg1181_3649 =
			OBJECT_TYPE;
		     arg1179_3647 =
			(arg1180_3648 - arg1181_3649);
		  }
		  {	/* ./Llib/object.scm 2695 */
		     obj_t vector_3653;
		     vector_3653 = _classes__134___object;
		     arg2423_3021 =
			VECTOR_REF(vector_3653, arg1179_3647);
		  }
	       }
	    }
	    method2414_3022 = arg2422_3020;
	    class2419_3023 = arg2423_3021;
	    {

	       if (
		  INTEGERP(method2414_3022))
		 {	/* Cfa/type.scm 162 */
		    switch (
		       (long) CINT(method2414_3022))
		      {
		      case ((long) 0):

			 return BUNSPEC;
			 break;
		      case ((long) 1):

			 return BUNSPEC;
			 break;
		      case ((long) 2):

			 {	/* Cfa/type.scm 180 */
			    var_bglt node_3031;
			    node_3031 =
			       (var_bglt) (node_20);
			    {	/* Cfa/type.scm 181 */
			       bool_t test2426_3033;
			       {	/* Cfa/type.scm 181 */
				  bool_t test2430_3037;
				  {	/* ./Ast/var.scm 986 */
				     obj_t aux_4018;
				     {	/* Cfa/type.scm 181 */
					variable_bglt aux_4019;
					aux_4019 =
					   (((var_bglt) CREF(node_3031))->variable);
					aux_4018 =
					   (obj_t) (aux_4019);
				     }
				     test2430_3037 =
					is_a__118___object(aux_4018, global_ast_var);
				  }
				  if (test2430_3037)
				    {	/* ./Ieee/equiv.scm 5508 */
				       obj_t aux_4029;
				       obj_t aux_4024;
				       aux_4029 =
					  CNST_TABLE_REF(((long) 2));
				       {	/* Cfa/type.scm 181 */
					  global_bglt obj_3658;
					  {	/* Cfa/type.scm 181 */
					     variable_bglt aux_4025;
					     aux_4025 =
						(((var_bglt) CREF(node_3031))->variable);
					     obj_3658 =
						(global_bglt) (aux_4025);
					  }
					  aux_4024 =
					     (((global_bglt) CREF(obj_3658))->import);
				       }
				       test2426_3033 =
					  (aux_4024 == aux_4029);
				    }
				  else
				    {	/* Cfa/type.scm 181 */
				       test2426_3033 = ((bool_t) 0);
				    }
			       }
			       if (test2426_3033)
				 {	/* Cfa/type.scm 182 */
				    value_bglt aux_4033;
				    {	/* Cfa/type.scm 182 */
				       global_bglt obj_3662;
				       {	/* Cfa/type.scm 182 */
					  variable_bglt aux_4034;
					  aux_4034 =
					     (((var_bglt) CREF(node_3031))->variable);
					  obj_3662 =
					     (global_bglt) (aux_4034);
				       }
				       aux_4033 =
					  (((global_bglt) CREF(obj_3662))->value);
				    }
				    return
				       type_variable__242_cfa_type(aux_4033,
				       (((var_bglt) CREF(node_3031))->variable));
				 }
			       else
				 {	/* Cfa/type.scm 181 */
				    return BUNSPEC;
				 }
			    }
			 }
			 break;
		      case ((long) 3):

			 {	/* Cfa/type.scm 188 */
			    obj_t arg2437_3045;
			    {	/* Cfa/type.scm 188 */
			       obj_t aux_4040;
			       {	/* Cfa/type.scm 188 */
				  closure_bglt aux_4041;
				  aux_4041 =
				     (closure_bglt) (node_20);
				  aux_4040 =
				     (obj_t) (aux_4041);
			       }
			       arg2437_3045 =
				  shape_tools_shape(aux_4040);
			    }
			    return
			       internal_error_43_tools_error(string2507_cfa_type, string2508_cfa_type, arg2437_3045);
			 }
			 break;
		      case ((long) 4):

			 {	/* Cfa/type.scm 194 */
			    sequence_bglt node_3046;
			    node_3046 =
			       (sequence_bglt) (node_20);
			    {	/* Cfa/type.scm 195 */
			       bool_t aux_4047;
			       aux_4047 =
				  type_node___42_cfa_type(
				  (((sequence_bglt) CREF(node_3046))->nodes));
			       return
				  BBOOL(aux_4047);
			    }
			 }
			 break;
		      case ((long) 5):

			 {	/* Cfa/type.scm 201 */
			    app_bglt node_3049;
			    node_3049 =
			       (app_bglt) (node_20);
			    {	/* Cfa/type.scm 202 */
			       bool_t aux_4052;
			       aux_4052 =
				  type_node___42_cfa_type(
				  (((app_bglt) CREF(node_3049))->args));
			       return
				  BBOOL(aux_4052);
			    }
			 }
			 break;
		      case ((long) 6):

			 {	/* Cfa/type.scm 208 */
			    app_ly_162_bglt node_3052;
			    node_3052 =
			       (app_ly_162_bglt) (node_20);
			    type_node__55_cfa_type(
			       (((app_ly_162_bglt) CREF(node_3052))->fun));
			    {
			       node_bglt node_4059;
			       node_4059 =
				  (((app_ly_162_bglt) CREF(node_3052))->arg);
			       node_20 = node_4059;
			       goto type_node__55_cfa_type;
			    }
			 }
			 break;
		      case ((long) 7):

			 {	/* Cfa/type.scm 216 */
			    funcall_bglt node_3056;
			    node_3056 =
			       (funcall_bglt) (node_20);
			    type_node__55_cfa_type(
			       (((funcall_bglt) CREF(node_3056))->fun));
			    {	/* Cfa/type.scm 218 */
			       bool_t aux_4064;
			       aux_4064 =
				  type_node___42_cfa_type(
				  (((funcall_bglt) CREF(node_3056))->args));
			       return
				  BBOOL(aux_4064);
			    }
			 }
			 break;
		      case ((long) 8):

			 {	/* Cfa/type.scm 224 */
			    pragma_bglt node_3060;
			    node_3060 =
			       (pragma_bglt) (node_20);
			    {	/* Cfa/type.scm 225 */
			       bool_t aux_4069;
			       aux_4069 =
				  type_node___42_cfa_type(
				  (((pragma_bglt) CREF(node_3060))->args));
			       return
				  BBOOL(aux_4069);
			    }
			 }
			 break;
		      case ((long) 9):

			 {	/* Cfa/type.scm 231 */
			    cast_bglt node_3063;
			    node_3063 =
			       (cast_bglt) (node_20);
			    {
			       node_bglt node_4074;
			       node_4074 =
				  (((cast_bglt) CREF(node_3063))->arg);
			       node_20 = node_4074;
			       goto type_node__55_cfa_type;
			    }
			 }
			 break;
		      case ((long) 10):

			 {	/* Cfa/type.scm 238 */
			    setq_bglt node_3066;
			    node_3066 =
			       (setq_bglt) (node_20);
			    type_node__55_cfa_type(
			       (((setq_bglt) CREF(node_3066))->value));
			    {
			       node_bglt node_4079;
			       {	/* Cfa/type.scm 240 */
				  var_bglt aux_4080;
				  aux_4080 =
				     (((setq_bglt) CREF(node_3066))->var);
				  node_4079 =
				     (node_bglt) (aux_4080);
			       }
			       node_20 = node_4079;
			       goto type_node__55_cfa_type;
			    }
			 }
			 break;
		      case ((long) 11):

			 {	/* Cfa/type.scm 246 */
			    conditional_bglt node_3070;
			    node_3070 =
			       (conditional_bglt) (node_20);
			    type_node__55_cfa_type(
			       (((conditional_bglt) CREF(node_3070))->test));
			    type_node__55_cfa_type(
			       (((conditional_bglt) CREF(node_3070))->true));
			    {
			       node_bglt node_4088;
			       node_4088 =
				  (((conditional_bglt) CREF(node_3070))->false);
			       node_20 = node_4088;
			       goto type_node__55_cfa_type;
			    }
			 }
			 break;
		      case ((long) 12):

			 {	/* Cfa/type.scm 255 */
			    fail_bglt node_3075;
			    node_3075 =
			       (fail_bglt) (node_20);
			    type_node__55_cfa_type(
			       (((fail_bglt) CREF(node_3075))->proc));
			    type_node__55_cfa_type(
			       (((fail_bglt) CREF(node_3075))->msg));
			    {
			       node_bglt node_4095;
			       node_4095 =
				  (((fail_bglt) CREF(node_3075))->obj);
			       node_20 = node_4095;
			       goto type_node__55_cfa_type;
			    }
			 }
			 break;
		      case ((long) 13):

			 {	/* Cfa/type.scm 264 */
			    select_bglt node_3080;
			    node_3080 =
			       (select_bglt) (node_20);
			    type_node__55_cfa_type(
			       (((select_bglt) CREF(node_3080))->test));
			    {
			       obj_t l2067_3083;
			       {	/* Cfa/type.scm 266 */
				  bool_t aux_4100;
				  l2067_3083 =
				     (((select_bglt) CREF(node_3080))->clauses);
				lname2068_3084:
				  if (
				     PAIRP(l2067_3083))
				    {	/* Cfa/type.scm 266 */
				       {	/* Cfa/type.scm 267 */
					  node_bglt aux_4103;
					  {	/* Cfa/type.scm 267 */
					     obj_t aux_4104;
					     {	/* ./Ieee/pair-list.scm 5707 */
						obj_t aux_4105;
						aux_4105 =
						   CAR(l2067_3083);
						aux_4104 =
						   CDR(aux_4105);
					     }
					     aux_4103 =
						(node_bglt) (aux_4104);
					  }
					  type_node__55_cfa_type(aux_4103);
				       }
				       {
					  obj_t l2067_4110;
					  l2067_4110 =
					     CDR(l2067_3083);
					  l2067_3083 = l2067_4110;
					  goto lname2068_3084;
				       }
				    }
				  else
				    {	/* Cfa/type.scm 266 */
				       aux_4100 = ((bool_t) 1);
				    }
				  return
				     BBOOL(aux_4100);
			       }
			    }
			 }
			 break;
		      case ((long) 14):

			 {	/* Cfa/type.scm 274 */
			    let_fun_218_bglt node_3090;
			    node_3090 =
			       (let_fun_218_bglt) (node_20);
			    {
			       obj_t l2070_3092;
			       l2070_3092 =
				  (((let_fun_218_bglt) CREF(node_3090))->locals);
			     lname2071_3093:
			       if (
				  PAIRP(l2070_3092))
				 {	/* Cfa/type.scm 275 */
				    {	/* Cfa/type.scm 275 */
				       variable_bglt aux_4117;
				       {	/* Cfa/type.scm 275 */
					  obj_t aux_4118;
					  aux_4118 =
					     CAR(l2070_3092);
					  aux_4117 =
					     (variable_bglt) (aux_4118);
				       }
				       type_fun__174_cfa_type(aux_4117);
				    }
				    {
				       obj_t l2070_4122;
				       l2070_4122 =
					  CDR(l2070_3092);
				       l2070_3092 = l2070_4122;
				       goto lname2071_3093;
				    }
				 }
			       else
				 {	/* Cfa/type.scm 275 */
				    ((bool_t) 1);
				 }
			    }
			    {
			       node_bglt node_4125;
			       node_4125 =
				  (((let_fun_218_bglt) CREF(node_3090))->body);
			       node_20 = node_4125;
			       goto type_node__55_cfa_type;
			    }
			 }
			 break;
		      case ((long) 15):

			 {	/* Cfa/type.scm 282 */
			    let_var_6_bglt node_3099;
			    node_3099 =
			       (let_var_6_bglt) (node_20);
			    {
			       obj_t l2073_3101;
			       l2073_3101 =
				  (((let_var_6_bglt) CREF(node_3099))->bindings);
			     lname2074_3102:
			       if (
				  PAIRP(l2073_3101))
				 {	/* Cfa/type.scm 283 */
				    {	/* Cfa/type.scm 284 */
				       obj_t binding_3105;
				       binding_3105 =
					  CAR(l2073_3101);
				       {	/* Cfa/type.scm 284 */
					  obj_t var_3106;
					  var_3106 =
					     CAR(binding_3105);
					  {	/* Cfa/type.scm 286 */
					     node_bglt aux_4132;
					     {	/* Cfa/type.scm 286 */
						obj_t aux_4133;
						aux_4133 =
						   CDR(binding_3105);
						aux_4132 =
						   (node_bglt) (aux_4133);
					     }
					     type_node__55_cfa_type(aux_4132);
					  }
					  {	/* Cfa/type.scm 287 */
					     value_bglt aux_4137;
					     {	/* Cfa/type.scm 287 */
						local_bglt obj_3696;
						obj_3696 =
						   (local_bglt) (var_3106);
						aux_4137 =
						   (((local_bglt) CREF(obj_3696))->value);
					     }
					     type_variable__242_cfa_type(aux_4137,
						(variable_bglt) (var_3106));
					  }
				       }
				    }
				    {
				       obj_t l2073_4142;
				       l2073_4142 =
					  CDR(l2073_3101);
				       l2073_3101 = l2073_4142;
				       goto lname2074_3102;
				    }
				 }
			       else
				 {	/* Cfa/type.scm 283 */
				    ((bool_t) 1);
				 }
			    }
			    {
			       node_bglt node_4145;
			       node_4145 =
				  (((let_var_6_bglt) CREF(node_3099))->body);
			       node_20 = node_4145;
			       goto type_node__55_cfa_type;
			    }
			 }
			 break;
		      case ((long) 16):

			 {	/* Cfa/type.scm 295 */
			    set_ex_it_116_bglt node_3111;
			    node_3111 =
			       (set_ex_it_116_bglt) (node_20);
			    {	/* Cfa/type.scm 296 */
			       variable_bglt v_3113;
			       {	/* Cfa/type.scm 296 */
				  var_bglt arg2470_3115;
				  arg2470_3115 =
				     (((set_ex_it_116_bglt) CREF(node_3111))->var);
				  v_3113 =
				     (((var_bglt) CREF(arg2470_3115))->variable);
			       }
			       {	/* Cfa/type.scm 297 */
				  value_bglt aux_4150;
				  {	/* Cfa/type.scm 297 */
				     local_bglt obj_3701;
				     obj_3701 =
					(local_bglt) (v_3113);
				     aux_4150 =
					(((local_bglt) CREF(obj_3701))->value);
				  }
				  type_variable__242_cfa_type(aux_4150, v_3113);
			       }
			    }
			    type_node__55_cfa_type(
			       (((set_ex_it_116_bglt) CREF(node_3111))->body));
			    {
			       node_bglt node_4156;
			       {	/* Cfa/type.scm 299 */
				  var_bglt aux_4157;
				  aux_4157 =
				     (((set_ex_it_116_bglt) CREF(node_3111))->var);
				  node_4156 =
				     (node_bglt) (aux_4157);
			       }
			       node_20 = node_4156;
			       goto type_node__55_cfa_type;
			    }
			 }
			 break;
		      case ((long) 17):

			 {	/* Cfa/type.scm 305 */
			    jump_ex_it_184_bglt node_3118;
			    node_3118 =
			       (jump_ex_it_184_bglt) (node_20);
			    type_node__55_cfa_type(
			       (((jump_ex_it_184_bglt) CREF(node_3118))->exit));
			    {
			       node_bglt node_4163;
			       node_4163 =
				  (((jump_ex_it_184_bglt) CREF(node_3118))->value);
			       node_20 = node_4163;
			       goto type_node__55_cfa_type;
			    }
			 }
			 break;
		      case ((long) 18):

			 {	/* Cfa/type.scm 313 */
			    make_box_202_bglt node_3122;
			    node_3122 =
			       (make_box_202_bglt) (node_20);
			    {
			       node_bglt node_4166;
			       node_4166 =
				  (((make_box_202_bglt) CREF(node_3122))->value);
			       node_20 = node_4166;
			       goto type_node__55_cfa_type;
			    }
			 }
			 break;
		      case ((long) 19):

			 {	/* Cfa/type.scm 320 */
			    box_set__221_bglt node_3125;
			    node_3125 =
			       (box_set__221_bglt) (node_20);
			    {	/* Cfa/type.scm 321 */
			       node_bglt aux_4169;
			       {	/* Cfa/type.scm 321 */
				  var_bglt aux_4170;
				  aux_4170 =
				     (((box_set__221_bglt) CREF(node_3125))->var);
				  aux_4169 =
				     (node_bglt) (aux_4170);
			       }
			       type_node__55_cfa_type(aux_4169);
			    }
			    {
			       node_bglt node_4174;
			       node_4174 =
				  (((box_set__221_bglt) CREF(node_3125))->value);
			       node_20 = node_4174;
			       goto type_node__55_cfa_type;
			    }
			 }
			 break;
		      case ((long) 20):

			 {	/* Cfa/type.scm 328 */
			    box_ref_242_bglt node_3129;
			    node_3129 =
			       (box_ref_242_bglt) (node_20);
			    {
			       node_bglt node_4177;
			       {	/* Cfa/type.scm 329 */
				  var_bglt aux_4178;
				  aux_4178 =
				     (((box_ref_242_bglt) CREF(node_3129))->var);
				  node_4177 =
				     (node_bglt) (aux_4178);
			       }
			       node_20 = node_4177;
			       goto type_node__55_cfa_type;
			    }
			 }
			 break;
		      default:
		       case_else2420_3026:
			 if (
			    PROCEDUREP(method2414_3022))
			   {	/* Cfa/type.scm 162 */
			      return
				 PROCEDURE_ENTRY(method2414_3022) (method2414_3022,
				 (obj_t) (node_20), BEOA);
			   }
			 else
			   {	/* Cfa/type.scm 162 */
			      obj_t fun2413_3018;
			      fun2413_3018 =
				 PROCEDURE_REF(type_node__env_231_cfa_type, ((long) 0));
			      return
				 PROCEDURE_ENTRY(fun2413_3018) (fun2413_3018,
				 (obj_t) (node_20), BEOA);
			   }
		      }
		 }
	       else
		 {	/* Cfa/type.scm 162 */
		    goto case_else2420_3026;
		 }
	    }
	 }
      }
   }
}



/* _type-node! */
obj_t 
_type_node__11_cfa_type(obj_t env_3725, obj_t node_3726)
{
   AN_OBJECT;
   {	/* Cfa/type.scm 162 */
      return
	 type_node__55_cfa_type(
	 (node_bglt) (node_3726));
   }
}



/* type-node!-default2093 */
obj_t 
type_node__default2093_134_cfa_type(node_bglt node_21)
{
   AN_OBJECT;
   {	/* Cfa/type.scm 14 */
      FAILURE(
	 CNST_TABLE_REF(((long) 3)), string2509_cfa_type,
	 (obj_t) (node_21));
   }
}



/* _type-node!-default2093 */
obj_t 
_type_node__default2093_154_cfa_type(obj_t env_3727, obj_t node_3728)
{
   AN_OBJECT;
   {	/* Cfa/type.scm 14 */
      return
	 type_node__default2093_134_cfa_type(
	 (node_bglt) (node_3728));
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_cfa_type()
{
   AN_OBJECT;
   {	/* Cfa/type.scm 14 */
      module_initialization_70_type_type(((long) 0), "CFA_TYPE");
      module_initialization_70_type_cache(((long) 0), "CFA_TYPE");
      module_initialization_70_tools_shape(((long) 0), "CFA_TYPE");
      module_initialization_70_tools_error(((long) 0), "CFA_TYPE");
      module_initialization_70_engine_param(((long) 0), "CFA_TYPE");
      module_initialization_70_ast_var(((long) 0), "CFA_TYPE");
      module_initialization_70_ast_node(((long) 0), "CFA_TYPE");
      module_initialization_70_cfa_info(((long) 0), "CFA_TYPE");
      module_initialization_70_cfa_info2(((long) 0), "CFA_TYPE");
      module_initialization_70_cfa_set(((long) 0), "CFA_TYPE");
      module_initialization_70_cfa_tvector(((long) 0), "CFA_TYPE");
      return
	 module_initialization_70_tvector_tvector(((long) 0), "CFA_TYPE");
   }
}
