/*===========================================================================*/
/*   (Cfa/vector.scm)                                                        */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;

typedef struct approx
  {
     header_t header;
     obj_t widening;
     struct type *type;
     bool_t type_locked__184;
     obj_t allocs;
     bool_t top__138;
     long lost_stamp_114;
  }
      *approx_bglt;

typedef struct cfun_cinfo_200
  {
     struct approx *approx;
  }
              *cfun_cinfo_200_bglt;

typedef struct extern_sfun_cinfo_6
  {
     struct approx *approx;
  }
                   *extern_sfun_cinfo_6_bglt;

typedef struct intern_sfun_cinfo_192
  {
     struct approx *approx;
     long stamp;
  }
                     *intern_sfun_cinfo_192_bglt;

typedef struct scnst_cinfo_0
  {
     struct approx *approx;
  }
             *scnst_cinfo_0_bglt;

typedef struct pre_clo_env_191
  {
     char dummy;
  }
               *pre_clo_env_191_bglt;

typedef struct svar_cinfo_166
  {
     struct approx *approx;
     bool_t clo_env__87;
  }
              *svar_cinfo_166_bglt;

typedef struct cvar_cinfo_53
  {
     struct approx *approx;
  }
             *cvar_cinfo_53_bglt;

typedef struct sexit_cinfo_49
  {
     struct approx *approx;
  }
              *sexit_cinfo_49_bglt;

typedef struct reshaped_local_224
  {
     obj_t binding_value_3;
  }
                  *reshaped_local_224_bglt;

typedef struct reshaped_global_160
  {
     char dummy;
  }
                   *reshaped_global_160_bglt;

typedef struct atom_cinfo_155
  {
     struct approx *approx;
  }
              *atom_cinfo_155_bglt;

typedef struct kwote_node_102
  {
     struct node *node;
  }
              *kwote_node_102_bglt;

typedef struct kwote_cinfo_48
  {
     struct approx *approx;
  }
              *kwote_cinfo_48_bglt;

typedef struct app_ly_cinfo_234
  {
     struct approx *approx;
  }
                *app_ly_cinfo_234_bglt;

typedef struct funcall_cinfo_75
  {
     struct approx *approx;
     struct approx *va_approx_63;
     bool_t arity_error_noticed__118;
     bool_t type_error_noticed__36;
  }
                *funcall_cinfo_75_bglt;

typedef struct pragma_cinfo_220
  {
     struct approx *approx;
  }
                *pragma_cinfo_220_bglt;

typedef struct setq_cinfo_191
  {
     struct approx *approx;
  }
              *setq_cinfo_191_bglt;

typedef struct conditional_cinfo_212
  {
     struct approx *approx;
  }
                     *conditional_cinfo_212_bglt;

typedef struct fail_cinfo_75
  {
     struct approx *approx;
  }
             *fail_cinfo_75_bglt;

typedef struct select_cinfo_150
  {
     struct approx *approx;
  }
                *select_cinfo_150_bglt;

typedef struct set_ex_it_cinfo_168
  {
     struct approx *approx;
  }
                   *set_ex_it_cinfo_168_bglt;

typedef struct jump_ex_it_cinfo_139
  {
     struct approx *approx;
  }
                    *jump_ex_it_cinfo_139_bglt;

typedef struct pre_make_box_186
  {
     char dummy;
  }
                *pre_make_box_186_bglt;

typedef struct make_box_cinfo_127
  {
     struct approx *approx;
  }
                  *make_box_cinfo_127_bglt;

typedef struct make_box_o_cinfo_96
  {
     struct approx *approx;
     struct approx *value_approx_19;
  }
                   *make_box_o_cinfo_96_bglt;

typedef struct box_set__cinfo_94
  {
     struct approx *approx;
  }
                 *box_set__cinfo_94_bglt;

typedef struct box_ref_cinfo_214
  {
     struct approx *approx;
  }
                 *box_ref_cinfo_214_bglt;

typedef struct box_set__o_cinfo_6
  {
     struct approx *approx;
  }
                  *box_set__o_cinfo_6_bglt;

typedef struct box_ref_o_cinfo_98
  {
     struct approx *approx;
  }
                  *box_ref_o_cinfo_98_bglt;

typedef struct pre_make_procedure_app_60
  {
     struct variable *owner;
  }
                         *pre_make_procedure_app_60_bglt;

typedef struct pre_procedure_ref_app_85
  {
     char dummy;
  }
                        *pre_procedure_ref_app_85_bglt;

typedef struct pre_procedure_set__app_208
  {
     char dummy;
  }
                          *pre_procedure_set__app_208_bglt;

typedef struct make_procedure_app_48
  {
     struct approx *approx;
     long values_approx_len_106;
     struct approx **values_approx_79;
     long lost_stamp_114;
     bool_t x_t__142;
     bool_t x;
     bool_t t;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
  }
                     *make_procedure_app_48_bglt;

typedef struct procedure_ref_app_49
  {
     struct approx *approx;
  }
                    *procedure_ref_app_49_bglt;

typedef struct procedure_set__app_32
  {
     struct approx *approx;
  }
                     *procedure_set__app_32_bglt;

typedef struct pre_make_vector_app_251
  {
     struct variable *owner;
  }
                       *pre_make_vector_app_251_bglt;

typedef struct pre_create_vector_app_162
  {
     struct variable *owner;
  }
                         *pre_create_vector_app_162_bglt;

typedef struct pre_vector_ref_app_208
  {
     char dummy;
  }
                      *pre_vector_ref_app_208_bglt;

typedef struct pre_vector_set__app_211
  {
     char dummy;
  }
                       *pre_vector_set__app_211_bglt;

typedef struct make_vector_app_205
  {
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
     bool_t seen__39;
  }
                   *make_vector_app_205_bglt;

typedef struct create_vector_app_150
  {
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
     bool_t seen__39;
  }
                     *create_vector_app_150_bglt;

typedef struct vector_ref_app_195
  {
     struct approx *approx;
  }
                  *vector_ref_app_195_bglt;

typedef struct vector_set__app_21
  {
     struct approx *approx;
  }
                  *vector_set__app_21_bglt;

typedef struct pre_make_struct_app_218
  {
     struct variable *owner;
  }
                       *pre_make_struct_app_218_bglt;

typedef struct pre_struct_ref_app_207
  {
     char dummy;
  }
                      *pre_struct_ref_app_207_bglt;

typedef struct pre_struct_set__app_116
  {
     char dummy;
  }
                       *pre_struct_set__app_116_bglt;

typedef struct make_struct_app_214
  {
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
  }
                   *make_struct_app_214_bglt;

typedef struct struct_ref_app_73
  {
     struct approx *approx;
  }
                 *struct_ref_app_73_bglt;

typedef struct struct_set__app_162
  {
     struct approx *approx;
  }
                   *struct_set__app_162_bglt;


static obj_t loose_alloc__make_vector_app2080_227_cfa_vector(obj_t, obj_t);
static obj_t method_init_76_cfa_vector();
static obj_t cfa__create_vector_app2074_9_cfa_vector(obj_t, obj_t);
extern obj_t pre_create_vector_app_162_cfa_info2;
static obj_t stack_loose_alloc__create_vector_app2086_65_cfa_vector(obj_t, obj_t, obj_t);
static obj_t node_setup__pre_make_vector_app2064_95_cfa_vector(obj_t, obj_t);
extern obj_t add_method__1___object(obj_t, obj_t, obj_t);
extern obj_t _obj__252_type_cache;
static obj_t cfa__make_vector_app2072_245_cfa_vector(obj_t, obj_t);
extern approx_bglt make_type_approx_184_cfa_approx(type_bglt);
extern approx_bglt make_empty_approx_131_cfa_approx();
extern obj_t vector_ref_app_195_cfa_info2;
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t _unspec__87_type_cache;
extern obj_t module_initialization_70_cfa_vector(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_cfa_info(long, char *);
extern obj_t module_initialization_70_cfa_info2(long, char *);
extern obj_t module_initialization_70_cfa_loose(long, char *);
extern obj_t module_initialization_70_cfa_iterate(long, char *);
extern obj_t module_initialization_70_cfa_cfa(long, char *);
extern obj_t module_initialization_70_cfa_setup(long, char *);
extern obj_t module_initialization_70_cfa_approx(long, char *);
extern obj_t module_initialization_70_cfa_tvector(long, char *);
extern obj_t module_initialization_70_cfa_stack(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern approx_bglt union_approx__241_cfa_approx(approx_bglt, approx_bglt);
static obj_t node_setup__pre_vector_set__app2070_221_cfa_vector(obj_t, obj_t);
extern long class_num_218___object(obj_t);
static obj_t cfa__vector_set__app2078_44_cfa_vector(obj_t, obj_t);
extern obj_t node_setup___185_cfa_setup(obj_t);
extern obj_t pre_make_vector_app_251_cfa_info2;
static obj_t imported_modules_init_94_cfa_vector();
extern obj_t stack_loose_alloc__95_cfa_loose(node_bglt, obj_t);
extern obj_t pre_vector_set__app_211_cfa_info2;
extern obj_t stack___129_cfa_stack(obj_t);
extern obj_t approx_set_top__187_cfa_approx(approx_bglt);
static obj_t library_modules_init_112_cfa_vector();
extern obj_t make_vector_app_205_cfa_info2;
extern approx_bglt cfa__102_cfa_cfa(node_bglt);
extern node_bglt node_heap__stack__239_cfa_stack(app_bglt, bool_t);
static obj_t node_setup__pre_create_vector_app2066_176_cfa_vector(obj_t, obj_t);
extern obj_t for_each_approx_alloc_83_cfa_approx(obj_t, approx_bglt);
static obj_t toplevel_init_63_cfa_vector();
static obj_t node_setup__pre_vector_ref_app2068_71_cfa_vector(obj_t, obj_t);
static obj_t stack__create_vector_app2090_126_cfa_vector(obj_t, obj_t);
extern obj_t open_input_string(obj_t);
extern obj_t vector_set__app_21_cfa_info2;
extern obj_t approx_set_type__239_cfa_approx(approx_bglt, type_bglt);
extern obj_t variable_ast_var;
extern obj_t create_vector_app_150_cfa_info2;
extern obj_t memq___r4_pairs_and_lists_6_3(obj_t, obj_t);
static obj_t _anonymous_2464__58_cfa_vector(obj_t, obj_t);
static obj_t _anonymous_2461__116_cfa_vector(obj_t, obj_t);
static obj_t _anonymous_2449__125_cfa_vector(obj_t, obj_t);
static obj_t _anonymous_2446__14_cfa_vector(obj_t, obj_t);
static obj_t stack__make_vector_app2088_195_cfa_vector(obj_t, obj_t);
extern obj_t _classes__134___object;
static obj_t _anonymous_2418__206_cfa_vector(obj_t, obj_t);
extern obj_t read___reader(obj_t);
extern obj_t pre_vector_ref_app_208_cfa_info2;
static obj_t stack_loose_alloc__make_vector_app2084_55_cfa_vector(obj_t, obj_t, obj_t);
static obj_t _anonymous_2396__244_cfa_vector(obj_t, obj_t);
static obj_t cfa__vector_ref_app2076_154_cfa_vector(obj_t, obj_t);
static obj_t loose_alloc__create_vector_app2082_13_cfa_vector(obj_t, obj_t);
extern obj_t _cfa_stamp__16_cfa_iterate;
extern obj_t add_make_vector__104_cfa_tvector(node_bglt);
static obj_t require_initialization_114_cfa_vector = BUNSPEC;
extern approx_bglt make_type_alloc_approx_134_cfa_approx(type_bglt, node_bglt);
extern obj_t _vector__240_type_cache;
extern approx_bglt loose__226_cfa_loose(approx_bglt, obj_t);
extern obj_t class_super_145___object(obj_t);
static obj_t cnst_init_137_cfa_vector();
static obj_t __cnst[1];

extern obj_t loose_alloc__env_83_cfa_loose;
DEFINE_STATIC_PROCEDURE(proc2499_cfa_vector, loose_alloc__create_vector_app2082_13_cfa_vector2511, loose_alloc__create_vector_app2082_13_cfa_vector, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2498_cfa_vector, loose_alloc__make_vector_app2080_227_cfa_vector2512, loose_alloc__make_vector_app2080_227_cfa_vector, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2497_cfa_vector, cfa__vector_set__app2078_44_cfa_vector2513, cfa__vector_set__app2078_44_cfa_vector, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2496_cfa_vector, cfa__vector_ref_app2076_154_cfa_vector2514, cfa__vector_ref_app2076_154_cfa_vector, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2495_cfa_vector, cfa__create_vector_app2074_9_cfa_vector2515, cfa__create_vector_app2074_9_cfa_vector, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2505_cfa_vector, _anonymous_2446__14_cfa_vector2516, _anonymous_2446__14_cfa_vector, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2494_cfa_vector, cfa__make_vector_app2072_245_cfa_vector2517, cfa__make_vector_app2072_245_cfa_vector, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2504_cfa_vector, _anonymous_2461__116_cfa_vector2518, _anonymous_2461__116_cfa_vector, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2493_cfa_vector, node_setup__pre_vector_set__app2070_221_cfa_vector2519, node_setup__pre_vector_set__app2070_221_cfa_vector, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2503_cfa_vector, stack__create_vector_app2090_126_cfa_vector2520, stack__create_vector_app2090_126_cfa_vector, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2492_cfa_vector, node_setup__pre_vector_ref_app2068_71_cfa_vector2521, node_setup__pre_vector_ref_app2068_71_cfa_vector, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2502_cfa_vector, stack__make_vector_app2088_195_cfa_vector2522, stack__make_vector_app2088_195_cfa_vector, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2491_cfa_vector, node_setup__pre_create_vector_app2066_176_cfa_vector2523, node_setup__pre_create_vector_app2066_176_cfa_vector, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2501_cfa_vector, stack_loose_alloc__create_vector_app2086_65_cfa_vector2524, stack_loose_alloc__create_vector_app2086_65_cfa_vector, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2490_cfa_vector, node_setup__pre_make_vector_app2064_95_cfa_vector2525, node_setup__pre_make_vector_app2064_95_cfa_vector, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2500_cfa_vector, stack_loose_alloc__make_vector_app2084_55_cfa_vector2526, stack_loose_alloc__make_vector_app2084_55_cfa_vector, 0L, 2);
extern obj_t cfa__env_153_cfa_cfa;
extern obj_t stack_loose_alloc__env_147_cfa_loose;
DEFINE_STRING(string2506_cfa_vector, string2506_cfa_vector2527, "ALL ", 4);
extern obj_t node_setup__env_214_cfa_setup;
extern obj_t stack__env_104_cfa_stack;



/* module-initialization */
obj_t 
module_initialization_70_cfa_vector(long checksum_3794, char *from_3795)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_cfa_vector))
	{
	   require_initialization_114_cfa_vector =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_cfa_vector();
	   cnst_init_137_cfa_vector();
	   imported_modules_init_94_cfa_vector();
	   method_init_76_cfa_vector();
	   toplevel_init_63_cfa_vector();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_cfa_vector()
{
   AN_OBJECT;
   {	/* Cfa/vector.scm 16 */
      module_initialization_70___object(((long) 0), "CFA_VECTOR");
      module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "CFA_VECTOR");
      module_initialization_70___reader(((long) 0), "CFA_VECTOR");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_cfa_vector()
{
   AN_OBJECT;
   {	/* Cfa/vector.scm 16 */
      {		/* Cfa/vector.scm 16 */
	 obj_t cnst_port_138_3787;
	 cnst_port_138_3787 =
	    open_input_string(string2506_cfa_vector);
	 {
	    long i_3788;
	    i_3788 = ((long) 0);
	  loop_3789:
	    {	/* Cfa/vector.scm 16 */
	       bool_t test2507_3790;
	       test2507_3790 =
		  (i_3788 == ((long) -1));
	       if (test2507_3790)
		 {	/* Cfa/vector.scm 16 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Cfa/vector.scm 16 */
		    {	/* Cfa/vector.scm 16 */
		       obj_t arg2508_3791;
		       {	/* Cfa/vector.scm 16 */
			  obj_t list2509_3792;
			  list2509_3792 =
			     MAKE_PAIR(cnst_port_138_3787, BNIL);
			  arg2508_3791 =
			     read___reader(list2509_3792);
		       }
		       CNST_TABLE_SET(i_3788, arg2508_3791);
		    }
		    {	/* Cfa/vector.scm 16 */
		       int aux_3793;
		       {	/* Cfa/vector.scm 16 */
			  long aux_3813;
			  aux_3813 =
			     (i_3788 - ((long) 1));
			  aux_3793 =
			     (int) (aux_3813);
		       }
		       {
			  long i_3816;
			  i_3816 =
			     (long) (aux_3793);
			  i_3788 = i_3816;
			  goto loop_3789;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_cfa_vector()
{
   AN_OBJECT;
   {	/* Cfa/vector.scm 16 */
      return BUNSPEC;
   }
}



/* method-init */
obj_t 
method_init_76_cfa_vector()
{
   AN_OBJECT;
   {	/* Cfa/vector.scm 16 */
      {		/* Cfa/vector.scm 16 */
	 obj_t node_setup__pre_make_vector_app2064_95_3731;
	 node_setup__pre_make_vector_app2064_95_3731 = proc2490_cfa_vector;
	 add_method__1___object(node_setup__env_214_cfa_setup, pre_make_vector_app_251_cfa_info2, node_setup__pre_make_vector_app2064_95_3731);
      }
      {		/* Cfa/vector.scm 16 */
	 obj_t node_setup__pre_create_vector_app2066_176_3730;
	 node_setup__pre_create_vector_app2066_176_3730 = proc2491_cfa_vector;
	 add_method__1___object(node_setup__env_214_cfa_setup, pre_create_vector_app_162_cfa_info2, node_setup__pre_create_vector_app2066_176_3730);
      }
      {		/* Cfa/vector.scm 16 */
	 obj_t node_setup__pre_vector_ref_app2068_71_3729;
	 node_setup__pre_vector_ref_app2068_71_3729 = proc2492_cfa_vector;
	 add_method__1___object(node_setup__env_214_cfa_setup, pre_vector_ref_app_208_cfa_info2, node_setup__pre_vector_ref_app2068_71_3729);
      }
      {		/* Cfa/vector.scm 16 */
	 obj_t node_setup__pre_vector_set__app2070_221_3728;
	 node_setup__pre_vector_set__app2070_221_3728 = proc2493_cfa_vector;
	 add_method__1___object(node_setup__env_214_cfa_setup, pre_vector_set__app_211_cfa_info2, node_setup__pre_vector_set__app2070_221_3728);
      }
      {		/* Cfa/vector.scm 16 */
	 obj_t cfa__make_vector_app2072_245_3727;
	 cfa__make_vector_app2072_245_3727 = proc2494_cfa_vector;
	 add_method__1___object(cfa__env_153_cfa_cfa, make_vector_app_205_cfa_info2, cfa__make_vector_app2072_245_3727);
      }
      {		/* Cfa/vector.scm 16 */
	 obj_t cfa__create_vector_app2074_9_3726;
	 cfa__create_vector_app2074_9_3726 = proc2495_cfa_vector;
	 add_method__1___object(cfa__env_153_cfa_cfa, create_vector_app_150_cfa_info2, cfa__create_vector_app2074_9_3726);
      }
      {		/* Cfa/vector.scm 16 */
	 obj_t cfa__vector_ref_app2076_154_3725;
	 cfa__vector_ref_app2076_154_3725 = proc2496_cfa_vector;
	 add_method__1___object(cfa__env_153_cfa_cfa, vector_ref_app_195_cfa_info2, cfa__vector_ref_app2076_154_3725);
      }
      {		/* Cfa/vector.scm 16 */
	 obj_t cfa__vector_set__app2078_44_3723;
	 cfa__vector_set__app2078_44_3723 = proc2497_cfa_vector;
	 add_method__1___object(cfa__env_153_cfa_cfa, vector_set__app_21_cfa_info2, cfa__vector_set__app2078_44_3723);
      }
      {		/* Cfa/vector.scm 16 */
	 obj_t loose_alloc__make_vector_app2080_227_3721;
	 loose_alloc__make_vector_app2080_227_3721 = proc2498_cfa_vector;
	 add_method__1___object(loose_alloc__env_83_cfa_loose, make_vector_app_205_cfa_info2, loose_alloc__make_vector_app2080_227_3721);
      }
      {		/* Cfa/vector.scm 16 */
	 obj_t loose_alloc__create_vector_app2082_13_3718;
	 loose_alloc__create_vector_app2082_13_3718 = proc2499_cfa_vector;
	 add_method__1___object(loose_alloc__env_83_cfa_loose, create_vector_app_150_cfa_info2, loose_alloc__create_vector_app2082_13_3718);
      }
      {		/* Cfa/vector.scm 16 */
	 obj_t stack_loose_alloc__make_vector_app2084_55_3717;
	 stack_loose_alloc__make_vector_app2084_55_3717 = proc2500_cfa_vector;
	 add_method__1___object(stack_loose_alloc__env_147_cfa_loose, make_vector_app_205_cfa_info2, stack_loose_alloc__make_vector_app2084_55_3717);
      }
      {		/* Cfa/vector.scm 16 */
	 obj_t stack_loose_alloc__create_vector_app2086_65_3714;
	 stack_loose_alloc__create_vector_app2086_65_3714 = proc2501_cfa_vector;
	 add_method__1___object(stack_loose_alloc__env_147_cfa_loose, create_vector_app_150_cfa_info2, stack_loose_alloc__create_vector_app2086_65_3714);
      }
      {		/* Cfa/vector.scm 16 */
	 obj_t stack__make_vector_app2088_195_3711;
	 stack__make_vector_app2088_195_3711 = proc2502_cfa_vector;
	 add_method__1___object(stack__env_104_cfa_stack, make_vector_app_205_cfa_info2, stack__make_vector_app2088_195_3711);
      }
      {		/* Cfa/vector.scm 16 */
	 obj_t stack__create_vector_app2090_126_3710;
	 stack__create_vector_app2090_126_3710 = proc2503_cfa_vector;
	 return
	    add_method__1___object(stack__env_104_cfa_stack, create_vector_app_150_cfa_info2, stack__create_vector_app2090_126_3710);
      }
   }
}



/* stack!-create-vector-app2090 */
obj_t 
stack__create_vector_app2090_126_cfa_vector(obj_t env_3732, obj_t node_3733)
{
   AN_OBJECT;
   {	/* Cfa/vector.scm 277 */
      {
	 create_vector_app_150_bglt node_3118;
	 {	/* Cfa/vector.scm 278 */
	    node_bglt aux_3832;
	    node_3118 =
	       (create_vector_app_150_bglt) (node_3733);
	    {	/* Cfa/vector.scm 281 */
	       obj_t aux_3833;
	       {	/* Cfa/vector.scm 281 */
		  app_bglt obj_3705;
		  obj_3705 =
		     (app_bglt) (node_3118);
		  aux_3833 =
		     (((app_bglt) CREF(obj_3705))->args);
	       }
	       stack___129_cfa_stack(aux_3833);
	    }
	    {	/* Cfa/vector.scm 282 */
	       bool_t aux_3837;
	       {	/* Cfa/vector.scm 282 */
		  bool_t test_3839;
		  {	/* ./Ieee/fixnum.scm 7109 */
		     long aux_3840;
		     {
			obj_t aux_3841;
			{	/* ./Cfa/cinfo2.scm 1306 */
			   object_bglt aux_3842;
			   aux_3842 =
			      (object_bglt) (node_3118);
			   aux_3841 =
			      OBJECT_WIDENING(aux_3842);
			}
			aux_3840 =
			   (((create_vector_app_150_bglt) CREF(aux_3841))->lost_stamp_114);
		     }
		     test_3839 =
			(aux_3840 == ((long) -1));
		  }
		  if (test_3839)
		    {
		       obj_t aux_3847;
		       {	/* ./Cfa/cinfo2.scm 1311 */
			  object_bglt aux_3848;
			  aux_3848 =
			     (object_bglt) (node_3118);
			  aux_3847 =
			     OBJECT_WIDENING(aux_3848);
		       }
		       aux_3837 =
			  (((create_vector_app_150_bglt) CREF(aux_3847))->stackable__42);
		    }
		  else
		    {	/* Cfa/vector.scm 282 */
		       aux_3837 = ((bool_t) 0)
			  ;
		    }
	       }
	       aux_3832 =
		  node_heap__stack__239_cfa_stack(
		  (app_bglt) (node_3118), aux_3837);
	    }
	    return
	       (obj_t) (aux_3832);
	 }
      }
   }
}



/* stack!-make-vector-app2088 */
obj_t 
stack__make_vector_app2088_195_cfa_vector(obj_t env_3734, obj_t node_3735)
{
   AN_OBJECT;
   {	/* Cfa/vector.scm 267 */
      {
	 make_vector_app_205_bglt node_3107;
	 {	/* Cfa/vector.scm 268 */
	    node_bglt aux_3855;
	    node_3107 =
	       (make_vector_app_205_bglt) (node_3735);
	    {	/* Cfa/vector.scm 271 */
	       obj_t aux_3856;
	       {	/* Cfa/vector.scm 271 */
		  app_bglt obj_3700;
		  obj_3700 =
		     (app_bglt) (node_3107);
		  aux_3856 =
		     (((app_bglt) CREF(obj_3700))->args);
	       }
	       stack___129_cfa_stack(aux_3856);
	    }
	    {	/* Cfa/vector.scm 272 */
	       bool_t aux_3860;
	       {	/* Cfa/vector.scm 272 */
		  bool_t test_3862;
		  {	/* ./Ieee/fixnum.scm 7109 */
		     long aux_3863;
		     {
			obj_t aux_3864;
			{	/* ./Cfa/cinfo2.scm 1282 */
			   object_bglt aux_3865;
			   aux_3865 =
			      (object_bglt) (node_3107);
			   aux_3864 =
			      OBJECT_WIDENING(aux_3865);
			}
			aux_3863 =
			   (((make_vector_app_205_bglt) CREF(aux_3864))->lost_stamp_114);
		     }
		     test_3862 =
			(aux_3863 == ((long) -1));
		  }
		  if (test_3862)
		    {
		       obj_t aux_3870;
		       {	/* ./Cfa/cinfo2.scm 1287 */
			  object_bglt aux_3871;
			  aux_3871 =
			     (object_bglt) (node_3107);
			  aux_3870 =
			     OBJECT_WIDENING(aux_3871);
		       }
		       aux_3860 =
			  (((make_vector_app_205_bglt) CREF(aux_3870))->stackable__42);
		    }
		  else
		    {	/* Cfa/vector.scm 272 */
		       aux_3860 = ((bool_t) 0)
			  ;
		    }
	       }
	       aux_3855 =
		  node_heap__stack__239_cfa_stack(
		  (app_bglt) (node_3107), aux_3860);
	    }
	    return
	       (obj_t) (aux_3855);
	 }
      }
   }
}



/* stack-loose-alloc!-create-vector-app2086 */
obj_t 
stack_loose_alloc__create_vector_app2086_65_cfa_vector(obj_t env_3736, obj_t alloc_3737, obj_t cowner_3738)
{
   AN_OBJECT;
   {	/* Cfa/vector.scm 243 */
      {
	 create_vector_app_150_bglt alloc_3082;
	 obj_t cowner_3083;
	 alloc_3082 =
	    (create_vector_app_150_bglt) (alloc_3737);
	 cowner_3083 = cowner_3738;
	 {	/* Cfa/vector.scm 246 */
	    bool_t test_3878;
	    {	/* Cfa/vector.scm 246 */
	       bool_t test_3879;
	       {
		  obj_t aux_3880;
		  {	/* ./Cfa/cinfo2.scm 1311 */
		     object_bglt aux_3881;
		     aux_3881 =
			(object_bglt) (alloc_3082);
		     aux_3880 =
			OBJECT_WIDENING(aux_3881);
		  }
		  test_3879 =
		     (((create_vector_app_150_bglt) CREF(aux_3880))->stackable__42);
	       }
	       if (test_3879)
		 {	/* Cfa/vector.scm 246 */
		    obj_t aux_3885;
		    {	/* Cfa/vector.scm 246 */
		       obj_t aux_3886;
		       {
			  obj_t aux_3887;
			  {	/* ./Cfa/cinfo2.scm 1313 */
			     object_bglt aux_3888;
			     aux_3888 =
				(object_bglt) (alloc_3082);
			     aux_3887 =
				OBJECT_WIDENING(aux_3888);
			  }
			  aux_3886 =
			     (((create_vector_app_150_bglt) CREF(aux_3887))->stack_stamp_31);
		       }
		       aux_3885 =
			  memq___r4_pairs_and_lists_6_3(cowner_3083, aux_3886);
		    }
		    test_3878 =
		       CBOOL(aux_3885);
		 }
	       else
		 {	/* Cfa/vector.scm 246 */
		    test_3878 = ((bool_t) 1)
		       ;
		 }
	    }
	    if (test_3878)
	      {		/* Cfa/vector.scm 246 */
		 return BUNSPEC;
	      }
	    else
	      {		/* Cfa/vector.scm 246 */
		 {	/* Cfa/vector.scm 249 */
		    obj_t arg2456_3088;
		    {	/* ./Ieee/pair-list.scm 5689 */
		       obj_t aux_3894;
		       {
			  obj_t aux_3895;
			  {	/* ./Cfa/cinfo2.scm 1313 */
			     object_bglt aux_3896;
			     aux_3896 =
				(object_bglt) (alloc_3082);
			     aux_3895 =
				OBJECT_WIDENING(aux_3896);
			  }
			  aux_3894 =
			     (((create_vector_app_150_bglt) CREF(aux_3895))->stack_stamp_31);
		       }
		       arg2456_3088 =
			  MAKE_PAIR(cowner_3083, aux_3894);
		    }
		    {
		       obj_t aux_3901;
		       {	/* ./Cfa/cinfo2.scm 1313 */
			  object_bglt aux_3902;
			  aux_3902 =
			     (object_bglt) (alloc_3082);
			  aux_3901 =
			     OBJECT_WIDENING(aux_3902);
		       }
		       ((((create_vector_app_150_bglt) CREF(aux_3901))->stack_stamp_31) = ((obj_t) arg2456_3088), BUNSPEC);
		    }
		 }
		 {	/* Cfa/vector.scm 250 */
		    bool_t test2458_3090;
		    {	/* Cfa/vector.scm 250 */
		       bool_t test2465_3101;
		       test2465_3101 =
			  is_a__118___object(cowner_3083, variable_ast_var);
		       if (test2465_3101)
			 {	/* ./Ieee/equiv.scm 5508 */
			    obj_t aux_3908;
			    {	/* Cfa/vector.scm 250 */
			       variable_bglt aux_3909;
			       {
				  obj_t aux_3910;
				  {	/* ./Cfa/cinfo2.scm 1308 */
				     object_bglt aux_3911;
				     aux_3911 =
					(object_bglt) (alloc_3082);
				     aux_3910 =
					OBJECT_WIDENING(aux_3911);
				  }
				  aux_3909 =
				     (((create_vector_app_150_bglt) CREF(aux_3910))->owner);
			       }
			       aux_3908 =
				  (obj_t) (aux_3909);
			    }
			    test2458_3090 =
			       (aux_3908 == cowner_3083);
			 }
		       else
			 {	/* Cfa/vector.scm 250 */
			    test2458_3090 = ((bool_t) 1);
			 }
		    }
		    if (test2458_3090)
		      {		/* Cfa/vector.scm 250 */
			 {
			    obj_t aux_3918;
			    {	/* ./Cfa/cinfo2.scm 1311 */
			       object_bglt aux_3919;
			       aux_3919 =
				  (object_bglt) (alloc_3082);
			       aux_3918 =
				  OBJECT_WIDENING(aux_3919);
			    }
			    ((((create_vector_app_150_bglt) CREF(aux_3918))->stackable__42) = ((bool_t) ((bool_t) 0)), BUNSPEC);
			 }
			 {	/* Cfa/vector.scm 257 */
			    approx_bglt arg2460_3092;
			    {
			       obj_t aux_3923;
			       {	/* ./Cfa/cinfo2.scm 1304 */
				  object_bglt aux_3924;
				  aux_3924 =
				     (object_bglt) (alloc_3082);
				  aux_3923 =
				     OBJECT_WIDENING(aux_3924);
			       }
			       arg2460_3092 =
				  (((create_vector_app_150_bglt) CREF(aux_3923))->value_approx_19);
			    }
			    {	/* Cfa/vector.scm 258 */
			       obj_t _anonymous_2461__116_3712;
			       _anonymous_2461__116_3712 = proc2504_cfa_vector;
			       return
				  for_each_approx_alloc_83_cfa_approx(_anonymous_2461__116_3712, arg2460_3092);
			    }
			 }
		      }
		    else
		      {		/* Cfa/vector.scm 260 */
			 approx_bglt arg2463_3097;
			 {
			    obj_t aux_3929;
			    {	/* ./Cfa/cinfo2.scm 1304 */
			       object_bglt aux_3930;
			       aux_3930 =
				  (object_bglt) (alloc_3082);
			       aux_3929 =
				  OBJECT_WIDENING(aux_3930);
			    }
			    arg2463_3097 =
			       (((create_vector_app_150_bglt) CREF(aux_3929))->value_approx_19);
			 }
			 {	/* Cfa/vector.scm 261 */
			    obj_t _anonymous_2464__58_3713;
			    _anonymous_2464__58_3713 =
			       make_fx_procedure(_anonymous_2464__58_cfa_vector, ((long) 1), ((long) 1));
			    PROCEDURE_SET(_anonymous_2464__58_3713, ((long) 0), cowner_3083);
			    return
			       for_each_approx_alloc_83_cfa_approx(_anonymous_2464__58_3713, arg2463_3097);
			 }
		      }
		 }
	      }
	 }
      }
   }
}



/* <anonymous:2461> */
obj_t 
_anonymous_2461__116_cfa_vector(obj_t env_3739, obj_t alloc_3740)
{
   AN_OBJECT;
   {	/* Cfa/vector.scm 257 */
      {
	 obj_t alloc_3093;
	 alloc_3093 = alloc_3740;
	 return
	    stack_loose_alloc__95_cfa_loose(
	    (node_bglt) (alloc_3093),
	    CNST_TABLE_REF(((long) 0)));
      }
   }
}



/* <anonymous:2464> */
obj_t 
_anonymous_2464__58_cfa_vector(obj_t env_3741, obj_t alloc_3743)
{
   AN_OBJECT;
   {	/* Cfa/vector.scm 260 */
      {		/* Cfa/vector.scm 261 */
	 obj_t cowner_3742;
	 cowner_3742 =
	    PROCEDURE_REF(env_3741, ((long) 0));
	 {
	    obj_t alloc_3098;
	    alloc_3098 = alloc_3743;
	    return
	       stack_loose_alloc__95_cfa_loose(
	       (node_bglt) (alloc_3098), cowner_3742);
	 }
      }
   }
}



/* stack-loose-alloc!-make-vector-app2084 */
obj_t 
stack_loose_alloc__make_vector_app2084_55_cfa_vector(obj_t env_3744, obj_t alloc_3745, obj_t cowner_3746)
{
   AN_OBJECT;
   {	/* Cfa/vector.scm 219 */
      {
	 make_vector_app_205_bglt alloc_3057;
	 obj_t cowner_3058;
	 alloc_3057 =
	    (make_vector_app_205_bglt) (alloc_3745);
	 cowner_3058 = cowner_3746;
	 {	/* Cfa/vector.scm 222 */
	    bool_t test_3944;
	    {	/* Cfa/vector.scm 222 */
	       bool_t test_3945;
	       {
		  obj_t aux_3946;
		  {	/* ./Cfa/cinfo2.scm 1287 */
		     object_bglt aux_3947;
		     aux_3947 =
			(object_bglt) (alloc_3057);
		     aux_3946 =
			OBJECT_WIDENING(aux_3947);
		  }
		  test_3945 =
		     (((make_vector_app_205_bglt) CREF(aux_3946))->stackable__42);
	       }
	       if (test_3945)
		 {	/* Cfa/vector.scm 222 */
		    obj_t aux_3951;
		    {	/* Cfa/vector.scm 222 */
		       obj_t aux_3952;
		       {
			  obj_t aux_3953;
			  {	/* ./Cfa/cinfo2.scm 1289 */
			     object_bglt aux_3954;
			     aux_3954 =
				(object_bglt) (alloc_3057);
			     aux_3953 =
				OBJECT_WIDENING(aux_3954);
			  }
			  aux_3952 =
			     (((make_vector_app_205_bglt) CREF(aux_3953))->stack_stamp_31);
		       }
		       aux_3951 =
			  memq___r4_pairs_and_lists_6_3(cowner_3058, aux_3952);
		    }
		    test_3944 =
		       CBOOL(aux_3951);
		 }
	       else
		 {	/* Cfa/vector.scm 222 */
		    test_3944 = ((bool_t) 1)
		       ;
		 }
	    }
	    if (test_3944)
	      {		/* Cfa/vector.scm 222 */
		 return BUNSPEC;
	      }
	    else
	      {		/* Cfa/vector.scm 222 */
		 {	/* Cfa/vector.scm 225 */
		    obj_t arg2441_3063;
		    {	/* ./Ieee/pair-list.scm 5689 */
		       obj_t aux_3960;
		       {
			  obj_t aux_3961;
			  {	/* ./Cfa/cinfo2.scm 1289 */
			     object_bglt aux_3962;
			     aux_3962 =
				(object_bglt) (alloc_3057);
			     aux_3961 =
				OBJECT_WIDENING(aux_3962);
			  }
			  aux_3960 =
			     (((make_vector_app_205_bglt) CREF(aux_3961))->stack_stamp_31);
		       }
		       arg2441_3063 =
			  MAKE_PAIR(cowner_3058, aux_3960);
		    }
		    {
		       obj_t aux_3967;
		       {	/* ./Cfa/cinfo2.scm 1289 */
			  object_bglt aux_3968;
			  aux_3968 =
			     (object_bglt) (alloc_3057);
			  aux_3967 =
			     OBJECT_WIDENING(aux_3968);
		       }
		       ((((make_vector_app_205_bglt) CREF(aux_3967))->stack_stamp_31) = ((obj_t) arg2441_3063), BUNSPEC);
		    }
		 }
		 {	/* Cfa/vector.scm 226 */
		    bool_t test2443_3065;
		    {	/* Cfa/vector.scm 226 */
		       bool_t test2450_3076;
		       test2450_3076 =
			  is_a__118___object(cowner_3058, variable_ast_var);
		       if (test2450_3076)
			 {	/* ./Ieee/equiv.scm 5508 */
			    obj_t aux_3974;
			    {	/* Cfa/vector.scm 226 */
			       variable_bglt aux_3975;
			       {
				  obj_t aux_3976;
				  {	/* ./Cfa/cinfo2.scm 1284 */
				     object_bglt aux_3977;
				     aux_3977 =
					(object_bglt) (alloc_3057);
				     aux_3976 =
					OBJECT_WIDENING(aux_3977);
				  }
				  aux_3975 =
				     (((make_vector_app_205_bglt) CREF(aux_3976))->owner);
			       }
			       aux_3974 =
				  (obj_t) (aux_3975);
			    }
			    test2443_3065 =
			       (aux_3974 == cowner_3058);
			 }
		       else
			 {	/* Cfa/vector.scm 226 */
			    test2443_3065 = ((bool_t) 1);
			 }
		    }
		    if (test2443_3065)
		      {		/* Cfa/vector.scm 226 */
			 {
			    obj_t aux_3984;
			    {	/* ./Cfa/cinfo2.scm 1287 */
			       object_bglt aux_3985;
			       aux_3985 =
				  (object_bglt) (alloc_3057);
			       aux_3984 =
				  OBJECT_WIDENING(aux_3985);
			    }
			    ((((make_vector_app_205_bglt) CREF(aux_3984))->stackable__42) = ((bool_t) ((bool_t) 0)), BUNSPEC);
			 }
			 {	/* Cfa/vector.scm 233 */
			    approx_bglt arg2445_3067;
			    {
			       obj_t aux_3989;
			       {	/* ./Cfa/cinfo2.scm 1280 */
				  object_bglt aux_3990;
				  aux_3990 =
				     (object_bglt) (alloc_3057);
				  aux_3989 =
				     OBJECT_WIDENING(aux_3990);
			       }
			       arg2445_3067 =
				  (((make_vector_app_205_bglt) CREF(aux_3989))->value_approx_19);
			    }
			    {	/* Cfa/vector.scm 234 */
			       obj_t _anonymous_2446__14_3715;
			       _anonymous_2446__14_3715 = proc2505_cfa_vector;
			       return
				  for_each_approx_alloc_83_cfa_approx(_anonymous_2446__14_3715, arg2445_3067);
			    }
			 }
		      }
		    else
		      {		/* Cfa/vector.scm 236 */
			 approx_bglt arg2448_3072;
			 {
			    obj_t aux_3995;
			    {	/* ./Cfa/cinfo2.scm 1280 */
			       object_bglt aux_3996;
			       aux_3996 =
				  (object_bglt) (alloc_3057);
			       aux_3995 =
				  OBJECT_WIDENING(aux_3996);
			    }
			    arg2448_3072 =
			       (((make_vector_app_205_bglt) CREF(aux_3995))->value_approx_19);
			 }
			 {	/* Cfa/vector.scm 237 */
			    obj_t _anonymous_2449__125_3716;
			    _anonymous_2449__125_3716 =
			       make_fx_procedure(_anonymous_2449__125_cfa_vector, ((long) 1), ((long) 1));
			    PROCEDURE_SET(_anonymous_2449__125_3716, ((long) 0), cowner_3058);
			    return
			       for_each_approx_alloc_83_cfa_approx(_anonymous_2449__125_3716, arg2448_3072);
			 }
		      }
		 }
	      }
	 }
      }
   }
}



/* <anonymous:2446> */
obj_t 
_anonymous_2446__14_cfa_vector(obj_t env_3747, obj_t alloc_3748)
{
   AN_OBJECT;
   {	/* Cfa/vector.scm 233 */
      {
	 obj_t alloc_3068;
	 alloc_3068 = alloc_3748;
	 return
	    stack_loose_alloc__95_cfa_loose(
	    (node_bglt) (alloc_3068),
	    CNST_TABLE_REF(((long) 0)));
      }
   }
}



/* <anonymous:2449> */
obj_t 
_anonymous_2449__125_cfa_vector(obj_t env_3749, obj_t alloc_3751)
{
   AN_OBJECT;
   {	/* Cfa/vector.scm 236 */
      {		/* Cfa/vector.scm 237 */
	 obj_t cowner_3750;
	 cowner_3750 =
	    PROCEDURE_REF(env_3749, ((long) 0));
	 {
	    obj_t alloc_3073;
	    alloc_3073 = alloc_3751;
	    return
	       stack_loose_alloc__95_cfa_loose(
	       (node_bglt) (alloc_3073), cowner_3750);
	 }
      }
   }
}



/* loose-alloc!-create-vector-app2082 */
obj_t 
loose_alloc__create_vector_app2082_13_cfa_vector(obj_t env_3752, obj_t alloc_3753)
{
   AN_OBJECT;
   {	/* Cfa/vector.scm 203 */
      {
	 create_vector_app_150_bglt alloc_3046;
	 alloc_3046 =
	    (create_vector_app_150_bglt) (alloc_3753);
	 {	/* Cfa/vector.scm 205 */
	    bool_t test2434_3050;
	    {	/* Cfa/vector.scm 205 */
	       long arg2438_3054;
	       {
		  obj_t aux_4010;
		  {	/* ./Cfa/cinfo2.scm 1306 */
		     object_bglt aux_4011;
		     aux_4011 =
			(object_bglt) (alloc_3046);
		     aux_4010 =
			OBJECT_WIDENING(aux_4011);
		  }
		  arg2438_3054 =
		     (((create_vector_app_150_bglt) CREF(aux_4010))->lost_stamp_114);
	       }
	       {	/* Cfa/vector.scm 205 */
		  long n2_3662;
		  n2_3662 =
		     (long) CINT(_cfa_stamp__16_cfa_iterate);
		  test2434_3050 =
		     (arg2438_3054 == n2_3662);
	       }
	    }
	    if (test2434_3050)
	      {		/* Cfa/vector.scm 205 */
		 return BUNSPEC;
	      }
	    else
	      {		/* Cfa/vector.scm 205 */
		 {	/* Cfa/vector.scm 210 */
		    long val1911_3664;
		    val1911_3664 =
		       (long) CINT(_cfa_stamp__16_cfa_iterate);
		    {
		       obj_t aux_4019;
		       {	/* ./Cfa/cinfo2.scm 1306 */
			  object_bglt aux_4020;
			  aux_4020 =
			     (object_bglt) (alloc_3046);
			  aux_4019 =
			     OBJECT_WIDENING(aux_4020);
		       }
		       ((((create_vector_app_150_bglt) CREF(aux_4019))->lost_stamp_114) = ((long) val1911_3664), BUNSPEC);
		    }
		 }
		 {
		    obj_t aux_4024;
		    {	/* ./Cfa/cinfo2.scm 1311 */
		       object_bglt aux_4025;
		       aux_4025 =
			  (object_bglt) (alloc_3046);
		       aux_4024 =
			  OBJECT_WIDENING(aux_4025);
		    }
		    ((((create_vector_app_150_bglt) CREF(aux_4024))->stackable__42) = ((bool_t) ((bool_t) 0)), BUNSPEC);
		 }
		 {	/* Cfa/vector.scm 212 */
		    approx_bglt aux_4029;
		    {
		       obj_t aux_4030;
		       {	/* ./Cfa/cinfo2.scm 1304 */
			  object_bglt aux_4031;
			  aux_4031 =
			     (object_bglt) (alloc_3046);
			  aux_4030 =
			     OBJECT_WIDENING(aux_4031);
		       }
		       aux_4029 =
			  (((create_vector_app_150_bglt) CREF(aux_4030))->value_approx_19);
		    }
		    for_each_approx_alloc_83_cfa_approx(loose_alloc__env_83_cfa_loose, aux_4029);
		 }
		 {	/* Cfa/vector.scm 213 */
		    approx_bglt aux_4036;
		    {
		       obj_t aux_4037;
		       {	/* ./Cfa/cinfo2.scm 1304 */
			  object_bglt aux_4038;
			  aux_4038 =
			     (object_bglt) (alloc_3046);
			  aux_4037 =
			     OBJECT_WIDENING(aux_4038);
		       }
		       aux_4036 =
			  (((create_vector_app_150_bglt) CREF(aux_4037))->value_approx_19);
		    }
		    approx_set_type__239_cfa_approx(aux_4036,
		       (type_bglt) (_obj__252_type_cache));
		 }
		 {	/* Cfa/vector.scm 214 */
		    approx_bglt aux_4044;
		    {
		       obj_t aux_4045;
		       {	/* ./Cfa/cinfo2.scm 1304 */
			  object_bglt aux_4046;
			  aux_4046 =
			     (object_bglt) (alloc_3046);
			  aux_4045 =
			     OBJECT_WIDENING(aux_4046);
		       }
		       aux_4044 =
			  (((create_vector_app_150_bglt) CREF(aux_4045))->value_approx_19);
		    }
		    return
		       approx_set_top__187_cfa_approx(aux_4044);
		 }
	      }
	 }
      }
   }
}



/* loose-alloc!-make-vector-app2080 */
obj_t 
loose_alloc__make_vector_app2080_227_cfa_vector(obj_t env_3754, obj_t alloc_3755)
{
   AN_OBJECT;
   {	/* Cfa/vector.scm 184 */
      {
	 make_vector_app_205_bglt alloc_3035;
	 alloc_3035 =
	    (make_vector_app_205_bglt) (alloc_3755);
	 {	/* Cfa/vector.scm 186 */
	    bool_t test2428_3039;
	    {	/* Cfa/vector.scm 186 */
	       long arg2432_3043;
	       {
		  obj_t aux_4052;
		  {	/* ./Cfa/cinfo2.scm 1282 */
		     object_bglt aux_4053;
		     aux_4053 =
			(object_bglt) (alloc_3035);
		     aux_4052 =
			OBJECT_WIDENING(aux_4053);
		  }
		  arg2432_3043 =
		     (((make_vector_app_205_bglt) CREF(aux_4052))->lost_stamp_114);
	       }
	       {	/* Cfa/vector.scm 186 */
		  long n2_3652;
		  n2_3652 =
		     (long) CINT(_cfa_stamp__16_cfa_iterate);
		  test2428_3039 =
		     (arg2432_3043 == n2_3652);
	       }
	    }
	    if (test2428_3039)
	      {		/* Cfa/vector.scm 186 */
		 return BUNSPEC;
	      }
	    else
	      {		/* Cfa/vector.scm 186 */
		 {	/* Cfa/vector.scm 190 */
		    long val1888_3654;
		    val1888_3654 =
		       (long) CINT(_cfa_stamp__16_cfa_iterate);
		    {
		       obj_t aux_4061;
		       {	/* ./Cfa/cinfo2.scm 1282 */
			  object_bglt aux_4062;
			  aux_4062 =
			     (object_bglt) (alloc_3035);
			  aux_4061 =
			     OBJECT_WIDENING(aux_4062);
		       }
		       ((((make_vector_app_205_bglt) CREF(aux_4061))->lost_stamp_114) = ((long) val1888_3654), BUNSPEC);
		    }
		 }
		 {
		    obj_t aux_4066;
		    {	/* ./Cfa/cinfo2.scm 1287 */
		       object_bglt aux_4067;
		       aux_4067 =
			  (object_bglt) (alloc_3035);
		       aux_4066 =
			  OBJECT_WIDENING(aux_4067);
		    }
		    ((((make_vector_app_205_bglt) CREF(aux_4066))->stackable__42) = ((bool_t) ((bool_t) 0)), BUNSPEC);
		 }
		 {	/* Cfa/vector.scm 192 */
		    approx_bglt aux_4071;
		    {
		       obj_t aux_4072;
		       {	/* ./Cfa/cinfo2.scm 1280 */
			  object_bglt aux_4073;
			  aux_4073 =
			     (object_bglt) (alloc_3035);
			  aux_4072 =
			     OBJECT_WIDENING(aux_4073);
		       }
		       aux_4071 =
			  (((make_vector_app_205_bglt) CREF(aux_4072))->value_approx_19);
		    }
		    for_each_approx_alloc_83_cfa_approx(loose_alloc__env_83_cfa_loose, aux_4071);
		 }
		 {	/* Cfa/vector.scm 193 */
		    approx_bglt aux_4078;
		    {
		       obj_t aux_4079;
		       {	/* ./Cfa/cinfo2.scm 1280 */
			  object_bglt aux_4080;
			  aux_4080 =
			     (object_bglt) (alloc_3035);
			  aux_4079 =
			     OBJECT_WIDENING(aux_4080);
		       }
		       aux_4078 =
			  (((make_vector_app_205_bglt) CREF(aux_4079))->value_approx_19);
		    }
		    approx_set_type__239_cfa_approx(aux_4078,
		       (type_bglt) (_obj__252_type_cache));
		 }
		 {	/* Cfa/vector.scm 194 */
		    approx_bglt aux_4086;
		    {
		       obj_t aux_4087;
		       {	/* ./Cfa/cinfo2.scm 1280 */
			  object_bglt aux_4088;
			  aux_4088 =
			     (object_bglt) (alloc_3035);
			  aux_4087 =
			     OBJECT_WIDENING(aux_4088);
		       }
		       aux_4086 =
			  (((make_vector_app_205_bglt) CREF(aux_4087))->value_approx_19);
		    }
		    return
		       approx_set_top__187_cfa_approx(aux_4086);
		 }
	      }
	 }
      }
   }
}



/* cfa!-vector-set!-app2078 */
obj_t 
cfa__vector_set__app2078_44_cfa_vector(obj_t env_3756, obj_t node_3757)
{
   AN_OBJECT;
   {	/* Cfa/vector.scm 146 */
      {
	 vector_set__app_21_bglt node_3008;
	 {	/* Cfa/vector.scm 147 */
	    approx_bglt aux_4094;
	    node_3008 =
	       (vector_set__app_21_bglt) (node_3757);
	    {	/* Cfa/vector.scm 150 */
	       node_bglt aux_4095;
	       {	/* Cfa/vector.scm 150 */
		  obj_t aux_4096;
		  {	/* ./Ieee/pair-list.scm 5701 */
		     obj_t aux_4097;
		     {	/* ./Ieee/pair-list.scm 5707 */
			obj_t aux_4098;
			{	/* Cfa/vector.scm 150 */
			   app_bglt obj_3623;
			   obj_3623 =
			      (app_bglt) (node_3008);
			   aux_4098 =
			      (((app_bglt) CREF(obj_3623))->args);
			}
			aux_4097 =
			   CDR(aux_4098);
		     }
		     aux_4096 =
			CAR(aux_4097);
		  }
		  aux_4095 =
		     (node_bglt) (aux_4096);
	       }
	       cfa__102_cfa_cfa(aux_4095);
	    }
	    {	/* Cfa/vector.scm 151 */
	       approx_bglt vec_approx_215_3014;
	       approx_bglt val_approx_22_3015;
	       {	/* Cfa/vector.scm 151 */
		  node_bglt aux_4105;
		  {	/* Cfa/vector.scm 151 */
		     obj_t aux_4106;
		     {	/* ./Ieee/pair-list.scm 5701 */
			obj_t aux_4107;
			{	/* Cfa/vector.scm 151 */
			   app_bglt obj_3628;
			   obj_3628 =
			      (app_bglt) (node_3008);
			   aux_4107 =
			      (((app_bglt) CREF(obj_3628))->args);
			}
			aux_4106 =
			   CAR(aux_4107);
		     }
		     aux_4105 =
			(node_bglt) (aux_4106);
		  }
		  vec_approx_215_3014 =
		     cfa__102_cfa_cfa(aux_4105);
	       }
	       {	/* Cfa/vector.scm 152 */
		  node_bglt aux_4113;
		  {	/* Cfa/vector.scm 152 */
		     obj_t aux_4114;
		     {	/* ./Ieee/pair-list.scm 5701 */
			obj_t aux_4115;
			{	/* ./Ieee/pair-list.scm 5707 */
			   obj_t aux_4116;
			   {	/* ./Ieee/pair-list.scm 5707 */
			      obj_t aux_4117;
			      {		/* Cfa/vector.scm 152 */
				 app_bglt obj_3630;
				 obj_3630 =
				    (app_bglt) (node_3008);
				 aux_4117 =
				    (((app_bglt) CREF(obj_3630))->args);
			      }
			      aux_4116 =
				 CDR(aux_4117);
			   }
			   aux_4115 =
			      CDR(aux_4116);
			}
			aux_4114 =
			   CAR(aux_4115);
		     }
		     aux_4113 =
			(node_bglt) (aux_4114);
		  }
		  val_approx_22_3015 =
		     cfa__102_cfa_cfa(aux_4113);
	       }
	       {	/* Cfa/vector.scm 156 */
		  bool_t test2414_3016;
		  {	/* Cfa/vector.scm 156 */
		     obj_t obj2_3639;
		     obj2_3639 = _vector__240_type_cache;
		     {	/* ./Ieee/equiv.scm 5508 */
			obj_t aux_4125;
			{	/* Cfa/vector.scm 156 */
			   type_bglt aux_4126;
			   aux_4126 =
			      (((approx_bglt) CREF(vec_approx_215_3014))->type);
			   aux_4125 =
			      (obj_t) (aux_4126);
			}
			test2414_3016 =
			   (aux_4125 == obj2_3639);
		     }
		  }
		  if (test2414_3016)
		    {	/* Cfa/vector.scm 156 */
		       BUNSPEC;
		    }
		  else
		    {	/* Cfa/vector.scm 156 */
		       approx_set_type__239_cfa_approx(val_approx_22_3015,
			  (type_bglt) (_obj__252_type_cache));
		    }
	       }
	       if (
		  (((approx_bglt) CREF(vec_approx_215_3014))->top__138))
		 {	/* Cfa/vector.scm 161 */
		    approx_bglt aux_4135;
		    aux_4135 =
		       loose__226_cfa_loose(val_approx_22_3015,
		       CNST_TABLE_REF(((long) 0)));
		    (obj_t) (aux_4135);
		 }
	       else
		 {	/* Cfa/vector.scm 166 */
		    obj_t _anonymous_2418__206_3722;
		    _anonymous_2418__206_3722 =
		       make_fx_procedure(_anonymous_2418__206_cfa_vector, ((long) 1), ((long) 1));
		    {	/* Cfa/vector.scm 166 */
		       obj_t aux_4140;
		       aux_4140 =
			  (obj_t) (val_approx_22_3015);
		       PROCEDURE_SET(_anonymous_2418__206_3722, ((long) 0), aux_4140);
		    }
		    for_each_approx_alloc_83_cfa_approx(_anonymous_2418__206_3722, vec_approx_215_3014);
		 }
	    }
	    {
	       obj_t aux_4144;
	       {	/* ./Cfa/cinfo2.scm 1318 */
		  object_bglt aux_4145;
		  aux_4145 =
		     (object_bglt) (node_3008);
		  aux_4144 =
		     OBJECT_WIDENING(aux_4145);
	       }
	       aux_4094 =
		  (((vector_set__app_21_bglt) CREF(aux_4144))->approx);
	    }
	    return
	       (obj_t) (aux_4094);
	 }
      }
   }
}



/* <anonymous:2418> */
obj_t 
_anonymous_2418__206_cfa_vector(obj_t env_3758, obj_t app_3760)
{
   AN_OBJECT;
   {	/* Cfa/vector.scm 164 */
      {		/* Cfa/vector.scm 166 */
	 obj_t val_approx_22_3759;
	 val_approx_22_3759 =
	    PROCEDURE_REF(env_3758, ((long) 0));
	 {
	    obj_t app_3020;
	    app_3020 = app_3760;
	    {	/* Cfa/vector.scm 166 */
	       bool_t test2419_3022;
	       test2419_3022 =
		  is_a__118___object(app_3020, make_vector_app_205_cfa_info2);
	       if (test2419_3022)
		 {	/* Cfa/vector.scm 166 */
		    {	/* Cfa/vector.scm 168 */
		       make_vector_app_205_bglt obj_3642;
		       obj_3642 =
			  (make_vector_app_205_bglt) (app_3020);
		       {
			  obj_t aux_4155;
			  {	/* ./Cfa/cinfo2.scm 1299 */
			     object_bglt aux_4156;
			     aux_4156 =
				(object_bglt) (obj_3642);
			     aux_4155 =
				OBJECT_WIDENING(aux_4156);
			  }
			  ((((make_vector_app_205_bglt) CREF(aux_4155))->seen__39) = ((bool_t) ((bool_t) 1)), BUNSPEC);
		       }
		    }
		    {	/* Cfa/vector.scm 169 */
		       approx_bglt aux_4160;
		       {	/* Cfa/vector.scm 169 */
			  approx_bglt aux_4161;
			  {	/* Cfa/vector.scm 169 */
			     make_vector_app_205_bglt obj_3644;
			     obj_3644 =
				(make_vector_app_205_bglt) (app_3020);
			     {
				obj_t aux_4163;
				{	/* ./Cfa/cinfo2.scm 1280 */
				   object_bglt aux_4164;
				   aux_4164 =
				      (object_bglt) (obj_3644);
				   aux_4163 =
				      OBJECT_WIDENING(aux_4164);
				}
				aux_4161 =
				   (((make_vector_app_205_bglt) CREF(aux_4163))->value_approx_19);
			     }
			  }
			  aux_4160 =
			     union_approx__241_cfa_approx(aux_4161,
			     (approx_bglt) (val_approx_22_3759));
		       }
		       return
			  (obj_t) (aux_4160);
		    }
		 }
	       else
		 {	/* Cfa/vector.scm 170 */
		    bool_t test2421_3025;
		    test2421_3025 =
		       is_a__118___object(app_3020, create_vector_app_150_cfa_info2);
		    if (test2421_3025)
		      {		/* Cfa/vector.scm 170 */
			 {	/* Cfa/vector.scm 172 */
			    create_vector_app_150_bglt obj_3646;
			    obj_3646 =
			       (create_vector_app_150_bglt) (app_3020);
			    {
			       obj_t aux_4174;
			       {	/* ./Cfa/cinfo2.scm 1316 */
				  object_bglt aux_4175;
				  aux_4175 =
				     (object_bglt) (obj_3646);
				  aux_4174 =
				     OBJECT_WIDENING(aux_4175);
			       }
			       ((((create_vector_app_150_bglt) CREF(aux_4174))->seen__39) = ((bool_t) ((bool_t) 1)), BUNSPEC);
			    }
			 }
			 {	/* Cfa/vector.scm 173 */
			    approx_bglt aux_4179;
			    {	/* Cfa/vector.scm 173 */
			       approx_bglt aux_4180;
			       {	/* Cfa/vector.scm 173 */
				  create_vector_app_150_bglt obj_3648;
				  obj_3648 =
				     (create_vector_app_150_bglt) (app_3020);
				  {
				     obj_t aux_4182;
				     {	/* ./Cfa/cinfo2.scm 1304 */
					object_bglt aux_4183;
					aux_4183 =
					   (object_bglt) (obj_3648);
					aux_4182 =
					   OBJECT_WIDENING(aux_4183);
				     }
				     aux_4180 =
					(((create_vector_app_150_bglt) CREF(aux_4182))->value_approx_19);
				  }
			       }
			       aux_4179 =
				  union_approx__241_cfa_approx(aux_4180,
				  (approx_bglt) (val_approx_22_3759));
			    }
			    return
			       (obj_t) (aux_4179);
			 }
		      }
		    else
		      {		/* Cfa/vector.scm 170 */
			 return BFALSE;
		      }
		 }
	    }
	 }
      }
   }
}



/* cfa!-vector-ref-app2076 */
obj_t 
cfa__vector_ref_app2076_154_cfa_vector(obj_t env_3761, obj_t node_3762)
{
   AN_OBJECT;
   {	/* Cfa/vector.scm 111 */
      {
	 vector_ref_app_195_bglt node_2973;
	 {	/* Cfa/vector.scm 112 */
	    approx_bglt aux_4190;
	    node_2973 =
	       (vector_ref_app_195_bglt) (node_3762);
	    {	/* Cfa/vector.scm 115 */
	       node_bglt aux_4191;
	       {	/* Cfa/vector.scm 115 */
		  obj_t aux_4192;
		  {	/* ./Ieee/pair-list.scm 5701 */
		     obj_t aux_4193;
		     {	/* ./Ieee/pair-list.scm 5707 */
			obj_t aux_4194;
			{	/* Cfa/vector.scm 115 */
			   app_bglt obj_3592;
			   obj_3592 =
			      (app_bglt) (node_2973);
			   aux_4194 =
			      (((app_bglt) CREF(obj_3592))->args);
			}
			aux_4193 =
			   CDR(aux_4194);
		     }
		     aux_4192 =
			CAR(aux_4193);
		  }
		  aux_4191 =
		     (node_bglt) (aux_4192);
	       }
	       cfa__102_cfa_cfa(aux_4191);
	    }
	    {	/* Cfa/vector.scm 116 */
	       approx_bglt vec_approx_215_2979;
	       {	/* Cfa/vector.scm 116 */
		  node_bglt aux_4201;
		  {	/* Cfa/vector.scm 116 */
		     obj_t aux_4202;
		     {	/* ./Ieee/pair-list.scm 5701 */
			obj_t aux_4203;
			{	/* Cfa/vector.scm 116 */
			   app_bglt obj_3597;
			   obj_3597 =
			      (app_bglt) (node_2973);
			   aux_4203 =
			      (((app_bglt) CREF(obj_3597))->args);
			}
			aux_4202 =
			   CAR(aux_4203);
		     }
		     aux_4201 =
			(node_bglt) (aux_4202);
		  }
		  vec_approx_215_2979 =
		     cfa__102_cfa_cfa(aux_4201);
	       }
	       {	/* Cfa/vector.scm 120 */
		  bool_t test2389_2980;
		  {	/* Cfa/vector.scm 120 */
		     bool_t test2391_2982;
		     {	/* Cfa/vector.scm 120 */
			obj_t obj2_3601;
			obj2_3601 = _vector__240_type_cache;
			{	/* ./Ieee/equiv.scm 5508 */
			   obj_t aux_4209;
			   {	/* Cfa/vector.scm 120 */
			      type_bglt aux_4210;
			      aux_4210 =
				 (((approx_bglt) CREF(vec_approx_215_2979))->type);
			      aux_4209 =
				 (obj_t) (aux_4210);
			   }
			   test2391_2982 =
			      (aux_4209 == obj2_3601);
			}
		     }
		     if (test2391_2982)
		       {	/* Cfa/vector.scm 120 */
			  test2389_2980 =
			     (((approx_bglt) CREF(vec_approx_215_2979))->top__138);
		       }
		     else
		       {	/* Cfa/vector.scm 120 */
			  test2389_2980 = ((bool_t) 1);
		       }
		  }
		  if (test2389_2980)
		    {	/* Cfa/vector.scm 122 */
		       approx_bglt aux_4217;
		       {
			  obj_t aux_4218;
			  {	/* ./Cfa/cinfo2.scm 1317 */
			     object_bglt aux_4219;
			     aux_4219 =
				(object_bglt) (node_2973);
			     aux_4218 =
				OBJECT_WIDENING(aux_4219);
			  }
			  aux_4217 =
			     (((vector_ref_app_195_bglt) CREF(aux_4218))->approx);
		       }
		       approx_set_type__239_cfa_approx(aux_4217,
			  (type_bglt) (_obj__252_type_cache));
		    }
		  else
		    {	/* Cfa/vector.scm 120 */
		       BUNSPEC;
		    }
	       }
	       if (
		  (((approx_bglt) CREF(vec_approx_215_2979))->top__138))
		 {	/* Cfa/vector.scm 125 */
		    approx_bglt aux_4227;
		    {
		       obj_t aux_4228;
		       {	/* ./Cfa/cinfo2.scm 1317 */
			  object_bglt aux_4229;
			  aux_4229 =
			     (object_bglt) (node_2973);
			  aux_4228 =
			     OBJECT_WIDENING(aux_4229);
		       }
		       aux_4227 =
			  (((vector_ref_app_195_bglt) CREF(aux_4228))->approx);
		    }
		    approx_set_top__187_cfa_approx(aux_4227);
		 }
	       else
		 {	/* Cfa/vector.scm 124 */
		    BUNSPEC;
		 }
	       {	/* Cfa/vector.scm 130 */
		  obj_t _anonymous_2396__244_3724;
		  _anonymous_2396__244_3724 =
		     make_fx_procedure(_anonymous_2396__244_cfa_vector, ((long) 1), ((long) 1));
		  {	/* Cfa/vector.scm 130 */
		     obj_t aux_4235;
		     aux_4235 =
			(obj_t) (node_2973);
		     PROCEDURE_SET(_anonymous_2396__244_3724, ((long) 0), aux_4235);
		  }
		  for_each_approx_alloc_83_cfa_approx(_anonymous_2396__244_3724, vec_approx_215_2979);
	       }
	    }
	    {
	       obj_t aux_4239;
	       {	/* ./Cfa/cinfo2.scm 1317 */
		  object_bglt aux_4240;
		  aux_4240 =
		     (object_bglt) (node_2973);
		  aux_4239 =
		     OBJECT_WIDENING(aux_4240);
	       }
	       aux_4190 =
		  (((vector_ref_app_195_bglt) CREF(aux_4239))->approx);
	    }
	    return
	       (obj_t) (aux_4190);
	 }
      }
   }
}



/* <anonymous:2396> */
obj_t 
_anonymous_2396__244_cfa_vector(obj_t env_3763, obj_t app_3765)
{
   AN_OBJECT;
   {	/* Cfa/vector.scm 128 */
      {		/* Cfa/vector.scm 130 */
	 obj_t instance2048_3764;
	 instance2048_3764 =
	    PROCEDURE_REF(env_3763, ((long) 0));
	 {
	    obj_t app_2987;
	    app_2987 = app_3765;
	    {	/* Cfa/vector.scm 130 */
	       bool_t test2397_2989;
	       test2397_2989 =
		  is_a__118___object(app_2987, make_vector_app_205_cfa_info2);
	       if (test2397_2989)
		 {	/* Cfa/vector.scm 130 */
		    {	/* Cfa/vector.scm 132 */
		       make_vector_app_205_bglt obj_3607;
		       obj_3607 =
			  (make_vector_app_205_bglt) (app_2987);
		       {
			  obj_t aux_4250;
			  {	/* ./Cfa/cinfo2.scm 1299 */
			     object_bglt aux_4251;
			     aux_4251 =
				(object_bglt) (obj_3607);
			     aux_4250 =
				OBJECT_WIDENING(aux_4251);
			  }
			  ((((make_vector_app_205_bglt) CREF(aux_4250))->seen__39) = ((bool_t) ((bool_t) 1)), BUNSPEC);
		       }
		    }
		    {	/* Cfa/vector.scm 133 */
		       approx_bglt aux_4262;
		       approx_bglt aux_4255;
		       {	/* Cfa/vector.scm 133 */
			  make_vector_app_205_bglt obj_3610;
			  obj_3610 =
			     (make_vector_app_205_bglt) (app_2987);
			  {
			     obj_t aux_4264;
			     {	/* ./Cfa/cinfo2.scm 1280 */
				object_bglt aux_4265;
				aux_4265 =
				   (object_bglt) (obj_3610);
				aux_4264 =
				   OBJECT_WIDENING(aux_4265);
			     }
			     aux_4262 =
				(((make_vector_app_205_bglt) CREF(aux_4264))->value_approx_19);
			  }
		       }
		       {	/* Cfa/vector.scm 133 */
			  vector_ref_app_195_bglt obj_3609;
			  obj_3609 =
			     (vector_ref_app_195_bglt) (instance2048_3764);
			  {
			     obj_t aux_4257;
			     {	/* ./Cfa/cinfo2.scm 1317 */
				object_bglt aux_4258;
				aux_4258 =
				   (object_bglt) (obj_3609);
				aux_4257 =
				   OBJECT_WIDENING(aux_4258);
			     }
			     aux_4255 =
				(((vector_ref_app_195_bglt) CREF(aux_4257))->approx);
			  }
		       }
		       union_approx__241_cfa_approx(aux_4255, aux_4262);
		    }
		    {	/* Cfa/vector.scm 134 */
		       type_bglt aux_4277;
		       approx_bglt aux_4270;
		       {	/* Cfa/vector.scm 134 */
			  approx_bglt arg2402_2995;
			  {	/* Cfa/vector.scm 134 */
			     vector_ref_app_195_bglt obj_3612;
			     obj_3612 =
				(vector_ref_app_195_bglt) (instance2048_3764);
			     {
				obj_t aux_4279;
				{	/* ./Cfa/cinfo2.scm 1317 */
				   object_bglt aux_4280;
				   aux_4280 =
				      (object_bglt) (obj_3612);
				   aux_4279 =
				      OBJECT_WIDENING(aux_4280);
				}
				arg2402_2995 =
				   (((vector_ref_app_195_bglt) CREF(aux_4279))->approx);
			     }
			  }
			  aux_4277 =
			     (((approx_bglt) CREF(arg2402_2995))->type);
		       }
		       {	/* Cfa/vector.scm 134 */
			  make_vector_app_205_bglt obj_3611;
			  obj_3611 =
			     (make_vector_app_205_bglt) (app_2987);
			  {
			     obj_t aux_4272;
			     {	/* ./Cfa/cinfo2.scm 1280 */
				object_bglt aux_4273;
				aux_4273 =
				   (object_bglt) (obj_3611);
				aux_4272 =
				   OBJECT_WIDENING(aux_4273);
			     }
			     aux_4270 =
				(((make_vector_app_205_bglt) CREF(aux_4272))->value_approx_19);
			  }
		       }
		       return
			  approx_set_type__239_cfa_approx(aux_4270, aux_4277);
		    }
		 }
	       else
		 {	/* Cfa/vector.scm 135 */
		    bool_t test2403_2996;
		    test2403_2996 =
		       is_a__118___object(app_2987, create_vector_app_150_cfa_info2);
		    if (test2403_2996)
		      {		/* Cfa/vector.scm 135 */
			 {	/* Cfa/vector.scm 137 */
			    create_vector_app_150_bglt obj_3615;
			    obj_3615 =
			       (create_vector_app_150_bglt) (app_2987);
			    {
			       obj_t aux_4289;
			       {	/* ./Cfa/cinfo2.scm 1316 */
				  object_bglt aux_4290;
				  aux_4290 =
				     (object_bglt) (obj_3615);
				  aux_4289 =
				     OBJECT_WIDENING(aux_4290);
			       }
			       ((((create_vector_app_150_bglt) CREF(aux_4289))->seen__39) = ((bool_t) ((bool_t) 1)), BUNSPEC);
			    }
			 }
			 {	/* Cfa/vector.scm 138 */
			    approx_bglt aux_4301;
			    approx_bglt aux_4294;
			    {	/* Cfa/vector.scm 138 */
			       create_vector_app_150_bglt obj_3618;
			       obj_3618 =
				  (create_vector_app_150_bglt) (app_2987);
			       {
				  obj_t aux_4303;
				  {	/* ./Cfa/cinfo2.scm 1304 */
				     object_bglt aux_4304;
				     aux_4304 =
					(object_bglt) (obj_3618);
				     aux_4303 =
					OBJECT_WIDENING(aux_4304);
				  }
				  aux_4301 =
				     (((create_vector_app_150_bglt) CREF(aux_4303))->value_approx_19);
			       }
			    }
			    {	/* Cfa/vector.scm 138 */
			       vector_ref_app_195_bglt obj_3617;
			       obj_3617 =
				  (vector_ref_app_195_bglt) (instance2048_3764);
			       {
				  obj_t aux_4296;
				  {	/* ./Cfa/cinfo2.scm 1317 */
				     object_bglt aux_4297;
				     aux_4297 =
					(object_bglt) (obj_3617);
				     aux_4296 =
					OBJECT_WIDENING(aux_4297);
				  }
				  aux_4294 =
				     (((vector_ref_app_195_bglt) CREF(aux_4296))->approx);
			       }
			    }
			    union_approx__241_cfa_approx(aux_4294, aux_4301);
			 }
			 {	/* Cfa/vector.scm 139 */
			    type_bglt aux_4316;
			    approx_bglt aux_4309;
			    {	/* Cfa/vector.scm 139 */
			       approx_bglt arg2408_3002;
			       {	/* Cfa/vector.scm 139 */
				  vector_ref_app_195_bglt obj_3620;
				  obj_3620 =
				     (vector_ref_app_195_bglt) (instance2048_3764);
				  {
				     obj_t aux_4318;
				     {	/* ./Cfa/cinfo2.scm 1317 */
					object_bglt aux_4319;
					aux_4319 =
					   (object_bglt) (obj_3620);
					aux_4318 =
					   OBJECT_WIDENING(aux_4319);
				     }
				     arg2408_3002 =
					(((vector_ref_app_195_bglt) CREF(aux_4318))->approx);
				  }
			       }
			       aux_4316 =
				  (((approx_bglt) CREF(arg2408_3002))->type);
			    }
			    {	/* Cfa/vector.scm 139 */
			       create_vector_app_150_bglt obj_3619;
			       obj_3619 =
				  (create_vector_app_150_bglt) (app_2987);
			       {
				  obj_t aux_4311;
				  {	/* ./Cfa/cinfo2.scm 1304 */
				     object_bglt aux_4312;
				     aux_4312 =
					(object_bglt) (obj_3619);
				     aux_4311 =
					OBJECT_WIDENING(aux_4312);
				  }
				  aux_4309 =
				     (((create_vector_app_150_bglt) CREF(aux_4311))->value_approx_19);
			       }
			    }
			    return
			       approx_set_type__239_cfa_approx(aux_4309, aux_4316);
			 }
		      }
		    else
		      {		/* Cfa/vector.scm 135 */
			 return BFALSE;
		      }
		 }
	    }
	 }
      }
   }
}



/* cfa!-create-vector-app2074 */
obj_t 
cfa__create_vector_app2074_9_cfa_vector(obj_t env_3766, obj_t node_3767)
{
   AN_OBJECT;
   {	/* Cfa/vector.scm 102 */
      {
	 create_vector_app_150_bglt node_2961;
	 {	/* Cfa/vector.scm 103 */
	    approx_bglt aux_4325;
	    node_2961 =
	       (create_vector_app_150_bglt) (node_3767);
	    {
	       obj_t l2046_2965;
	       {	/* Cfa/vector.scm 105 */
		  app_bglt obj_3587;
		  obj_3587 =
		     (app_bglt) (node_2961);
		  l2046_2965 =
		     (((app_bglt) CREF(obj_3587))->args);
	       }
	     lname2047_2966:
	       if (
		  PAIRP(l2046_2965))
		 {	/* Cfa/vector.scm 105 */
		    {	/* Cfa/vector.scm 105 */
		       node_bglt aux_4328;
		       {	/* Cfa/vector.scm 105 */
			  obj_t aux_4329;
			  aux_4329 =
			     CAR(l2046_2965);
			  aux_4328 =
			     (node_bglt) (aux_4329);
		       }
		       cfa__102_cfa_cfa(aux_4328);
		    }
		    {
		       obj_t l2046_4333;
		       l2046_4333 =
			  CDR(l2046_2965);
		       l2046_2965 = l2046_4333;
		       goto lname2047_2966;
		    }
		 }
	       else
		 {	/* Cfa/vector.scm 105 */
		    ((bool_t) 1);
		 }
	    }
	    {
	       obj_t aux_4337;
	       {	/* ./Cfa/cinfo2.scm 1300 */
		  object_bglt aux_4338;
		  aux_4338 =
		     (object_bglt) (node_2961);
		  aux_4337 =
		     OBJECT_WIDENING(aux_4338);
	       }
	       aux_4325 =
		  (((create_vector_app_150_bglt) CREF(aux_4337))->approx);
	    }
	    return
	       (obj_t) (aux_4325);
	 }
      }
   }
}



/* cfa!-make-vector-app2072 */
obj_t 
cfa__make_vector_app2072_245_cfa_vector(obj_t env_3768, obj_t node_3769)
{
   AN_OBJECT;
   {	/* Cfa/vector.scm 91 */
      {
	 make_vector_app_205_bglt node_2949;
	 {	/* Cfa/vector.scm 92 */
	    approx_bglt aux_4344;
	    node_2949 =
	       (make_vector_app_205_bglt) (node_3769);
	    {	/* Cfa/vector.scm 94 */
	       node_bglt aux_4345;
	       {	/* Cfa/vector.scm 94 */
		  obj_t aux_4346;
		  {	/* ./Ieee/pair-list.scm 5701 */
		     obj_t aux_4347;
		     {	/* Cfa/vector.scm 94 */
			app_bglt obj_3578;
			obj_3578 =
			   (app_bglt) (node_2949);
			aux_4347 =
			   (((app_bglt) CREF(obj_3578))->args);
		     }
		     aux_4346 =
			CAR(aux_4347);
		  }
		  aux_4345 =
		     (node_bglt) (aux_4346);
	       }
	       cfa__102_cfa_cfa(aux_4345);
	    }
	    {	/* Cfa/vector.scm 95 */
	       approx_bglt init_value_approx_9_2955;
	       {	/* Cfa/vector.scm 95 */
		  node_bglt aux_4353;
		  {	/* Cfa/vector.scm 95 */
		     obj_t aux_4354;
		     {	/* ./Ieee/pair-list.scm 5701 */
			obj_t aux_4355;
			{	/* ./Ieee/pair-list.scm 5707 */
			   obj_t aux_4356;
			   {	/* Cfa/vector.scm 95 */
			      app_bglt obj_3580;
			      obj_3580 =
				 (app_bglt) (node_2949);
			      aux_4356 =
				 (((app_bglt) CREF(obj_3580))->args);
			   }
			   aux_4355 =
			      CDR(aux_4356);
			}
			aux_4354 =
			   CAR(aux_4355);
		     }
		     aux_4353 =
			(node_bglt) (aux_4354);
		  }
		  init_value_approx_9_2955 =
		     cfa__102_cfa_cfa(aux_4353);
	       }
	       {	/* Cfa/vector.scm 96 */
		  approx_bglt aux_4363;
		  {
		     obj_t aux_4364;
		     {	/* ./Cfa/cinfo2.scm 1280 */
			object_bglt aux_4365;
			aux_4365 =
			   (object_bglt) (node_2949);
			aux_4364 =
			   OBJECT_WIDENING(aux_4365);
		     }
		     aux_4363 =
			(((make_vector_app_205_bglt) CREF(aux_4364))->value_approx_19);
		  }
		  union_approx__241_cfa_approx(aux_4363, init_value_approx_9_2955);
	       }
	       {
		  obj_t aux_4370;
		  {	/* ./Cfa/cinfo2.scm 1276 */
		     object_bglt aux_4371;
		     aux_4371 =
			(object_bglt) (node_2949);
		     aux_4370 =
			OBJECT_WIDENING(aux_4371);
		  }
		  aux_4344 =
		     (((make_vector_app_205_bglt) CREF(aux_4370))->approx);
	       }
	    }
	    return
	       (obj_t) (aux_4344);
	 }
      }
   }
}



/* node-setup!-pre-vector-set!-app2070 */
obj_t 
node_setup__pre_vector_set__app2070_221_cfa_vector(obj_t env_3770, obj_t node_3771)
{
   AN_OBJECT;
   {	/* Cfa/vector.scm 82 */
      {
	 pre_vector_set__app_211_bglt node_2933;
	 {	/* Cfa/vector.scm 83 */
	    vector_set__app_21_bglt aux_4377;
	    node_2933 =
	       (pre_vector_set__app_211_bglt) (node_3771);
	    {	/* Cfa/vector.scm 84 */
	       obj_t aux_4378;
	       {	/* Cfa/vector.scm 84 */
		  app_bglt obj_3560;
		  obj_3560 =
		     (app_bglt) (node_2933);
		  aux_4378 =
		     (((app_bglt) CREF(obj_3560))->args);
	       }
	       node_setup___185_cfa_setup(aux_4378);
	    }
	    {	/* Cfa/vector.scm 85 */
	       pre_vector_set__app_211_bglt node_2938;
	       {	/* Cfa/vector.scm 85 */
		  long arg2372_2944;
		  {	/* Cfa/vector.scm 85 */
		     obj_t arg2373_2945;
		     {	/* Cfa/vector.scm 85 */
			obj_t arg2374_2946;
			{	/* Cfa/vector.scm 85 */
			   object_bglt object_3561;
			   object_3561 =
			      (object_bglt) (node_2933);
			   {	/* ./Llib/object.scm 2695 */
			      long arg1179_3562;
			      {		/* ./Llib/object.scm 2695 */
				 long arg1180_3563;
				 long arg1181_3564;
				 arg1180_3563 =
				    TYPE(object_3561);
				 arg1181_3564 =
				    OBJECT_TYPE;
				 arg1179_3562 =
				    (arg1180_3563 - arg1181_3564);
			      }
			      {		/* ./Llib/object.scm 2695 */
				 obj_t vector_3568;
				 vector_3568 = _classes__134___object;
				 arg2374_2946 =
				    VECTOR_REF(vector_3568, arg1179_3562);
			      }
			   }
			}
			arg2373_2945 =
			   class_super_145___object(arg2374_2946);
		     }
		     arg2372_2944 =
			class_num_218___object(arg2373_2945);
		  }
		  {	/* Cfa/vector.scm 85 */
		     obj_t obj_3570;
		     obj_3570 =
			(obj_t) (node_2933);
		     (((obj_t) CREF(obj_3570))->header = MAKE_HEADER(arg2372_2944, 0), BUNSPEC);
		  }
	       }
	       {	/* Cfa/vector.scm 85 */
		  object_bglt aux_4391;
		  aux_4391 =
		     (object_bglt) (node_2933);
		  OBJECT_WIDENING_SET(aux_4391, BFALSE);
	       }
	       node_2938 = node_2933;
	       {	/* Cfa/vector.scm 86 */
		  vector_set__app_21_bglt obj2043_2939;
		  obj2043_2939 =
		     ((vector_set__app_21_bglt) (node_2938));
		  {	/* Cfa/vector.scm 86 */
		     vector_set__app_21_bglt arg2369_2940;
		     {	/* Cfa/vector.scm 86 */
			approx_bglt arg2370_2941;
			arg2370_2941 =
			   make_type_approx_184_cfa_approx(
			   (type_bglt) (_unspec__87_type_cache));
			{	/* Cfa/vector.scm 86 */
			   vector_set__app_21_bglt res2483_3575;
			   {	/* ./Cfa/cinfo2.scm 1318 */
			      vector_set__app_21_bglt new1945_3573;
			      new1945_3573 =
				 ((vector_set__app_21_bglt) BREF(GC_MALLOC(sizeof(struct vector_set__app_21))));
			      ((((vector_set__app_21_bglt) CREF(new1945_3573))->approx) = ((approx_bglt) arg2370_2941), BUNSPEC);
			      res2483_3575 = new1945_3573;
			   }
			   arg2369_2940 = res2483_3575;
			}
		     }
		     {	/* Cfa/vector.scm 86 */
			obj_t aux_4401;
			object_bglt aux_4399;
			aux_4401 =
			   (obj_t) (arg2369_2940);
			aux_4399 =
			   (object_bglt) (obj2043_2939);
			OBJECT_WIDENING_SET(aux_4399, aux_4401);
		     }
		  }
		  {	/* Cfa/vector.scm 86 */
		     long arg2371_2942;
		     arg2371_2942 =
			class_num_218___object(vector_set__app_21_cfa_info2);
		     {	/* Cfa/vector.scm 86 */
			obj_t obj_3576;
			obj_3576 =
			   (obj_t) (obj2043_2939);
			(((obj_t) CREF(obj_3576))->header = MAKE_HEADER(arg2371_2942, 0), BUNSPEC);
		     }
		  }
		  aux_4377 = obj2043_2939;
	       }
	    }
	    return
	       (obj_t) (aux_4377);
	 }
      }
   }
}



/* node-setup!-pre-vector-ref-app2068 */
obj_t 
node_setup__pre_vector_ref_app2068_71_cfa_vector(obj_t env_3772, obj_t node_3773)
{
   AN_OBJECT;
   {	/* Cfa/vector.scm 73 */
      {
	 pre_vector_ref_app_208_bglt node_2917;
	 {	/* Cfa/vector.scm 74 */
	    vector_ref_app_195_bglt aux_4409;
	    node_2917 =
	       (pre_vector_ref_app_208_bglt) (node_3773);
	    {	/* Cfa/vector.scm 75 */
	       obj_t aux_4410;
	       {	/* Cfa/vector.scm 75 */
		  app_bglt obj_3542;
		  obj_3542 =
		     (app_bglt) (node_2917);
		  aux_4410 =
		     (((app_bglt) CREF(obj_3542))->args);
	       }
	       node_setup___185_cfa_setup(aux_4410);
	    }
	    {	/* Cfa/vector.scm 76 */
	       pre_vector_ref_app_208_bglt node_2922;
	       {	/* Cfa/vector.scm 76 */
		  long arg2364_2928;
		  {	/* Cfa/vector.scm 76 */
		     obj_t arg2365_2929;
		     {	/* Cfa/vector.scm 76 */
			obj_t arg2366_2930;
			{	/* Cfa/vector.scm 76 */
			   object_bglt object_3543;
			   object_3543 =
			      (object_bglt) (node_2917);
			   {	/* ./Llib/object.scm 2695 */
			      long arg1179_3544;
			      {		/* ./Llib/object.scm 2695 */
				 long arg1180_3545;
				 long arg1181_3546;
				 arg1180_3545 =
				    TYPE(object_3543);
				 arg1181_3546 =
				    OBJECT_TYPE;
				 arg1179_3544 =
				    (arg1180_3545 - arg1181_3546);
			      }
			      {		/* ./Llib/object.scm 2695 */
				 obj_t vector_3550;
				 vector_3550 = _classes__134___object;
				 arg2366_2930 =
				    VECTOR_REF(vector_3550, arg1179_3544);
			      }
			   }
			}
			arg2365_2929 =
			   class_super_145___object(arg2366_2930);
		     }
		     arg2364_2928 =
			class_num_218___object(arg2365_2929);
		  }
		  {	/* Cfa/vector.scm 76 */
		     obj_t obj_3552;
		     obj_3552 =
			(obj_t) (node_2917);
		     (((obj_t) CREF(obj_3552))->header = MAKE_HEADER(arg2364_2928, 0), BUNSPEC);
		  }
	       }
	       {	/* Cfa/vector.scm 76 */
		  object_bglt aux_4423;
		  aux_4423 =
		     (object_bglt) (node_2917);
		  OBJECT_WIDENING_SET(aux_4423, BFALSE);
	       }
	       node_2922 = node_2917;
	       {	/* Cfa/vector.scm 77 */
		  vector_ref_app_195_bglt obj2040_2923;
		  obj2040_2923 =
		     ((vector_ref_app_195_bglt) (node_2922));
		  {	/* Cfa/vector.scm 77 */
		     vector_ref_app_195_bglt arg2361_2924;
		     {	/* Cfa/vector.scm 77 */
			approx_bglt arg2362_2925;
			arg2362_2925 =
			   make_empty_approx_131_cfa_approx();
			{	/* Cfa/vector.scm 77 */
			   vector_ref_app_195_bglt res2482_3557;
			   {	/* ./Cfa/cinfo2.scm 1317 */
			      vector_ref_app_195_bglt new1933_3555;
			      new1933_3555 =
				 ((vector_ref_app_195_bglt) BREF(GC_MALLOC(sizeof(struct vector_ref_app_195))));
			      ((((vector_ref_app_195_bglt) CREF(new1933_3555))->approx) = ((approx_bglt) arg2362_2925), BUNSPEC);
			      res2482_3557 = new1933_3555;
			   }
			   arg2361_2924 = res2482_3557;
			}
		     }
		     {	/* Cfa/vector.scm 77 */
			obj_t aux_4432;
			object_bglt aux_4430;
			aux_4432 =
			   (obj_t) (arg2361_2924);
			aux_4430 =
			   (object_bglt) (obj2040_2923);
			OBJECT_WIDENING_SET(aux_4430, aux_4432);
		     }
		  }
		  {	/* Cfa/vector.scm 77 */
		     long arg2363_2926;
		     arg2363_2926 =
			class_num_218___object(vector_ref_app_195_cfa_info2);
		     {	/* Cfa/vector.scm 77 */
			obj_t obj_3558;
			obj_3558 =
			   (obj_t) (obj2040_2923);
			(((obj_t) CREF(obj_3558))->header = MAKE_HEADER(arg2363_2926, 0), BUNSPEC);
		     }
		  }
		  aux_4409 = obj2040_2923;
	       }
	    }
	    return
	       (obj_t) (aux_4409);
	 }
      }
   }
}



/* node-setup!-pre-create-vector-app2066 */
obj_t 
node_setup__pre_create_vector_app2066_176_cfa_vector(obj_t env_3774, obj_t node_3775)
{
   AN_OBJECT;
   {	/* Cfa/vector.scm 55 */
      {
	 pre_create_vector_app_162_bglt node_2894;
	 node_2894 =
	    (pre_create_vector_app_162_bglt) (node_3775);
	 add_make_vector__104_cfa_tvector(
	    (node_bglt) (node_2894));
	 {	/* Cfa/vector.scm 58 */
	    obj_t aux_4442;
	    {	/* Cfa/vector.scm 58 */
	       app_bglt obj_3509;
	       obj_3509 =
		  (app_bglt) (node_2894);
	       aux_4442 =
		  (((app_bglt) CREF(obj_3509))->args);
	    }
	    node_setup___185_cfa_setup(aux_4442);
	 }
	 {	/* Cfa/vector.scm 59 */
	    variable_bglt owner_2899;
	    {
	       obj_t aux_4446;
	       {	/* ./Cfa/cinfo2.scm 1272 */
		  object_bglt aux_4447;
		  aux_4447 =
		     (object_bglt) (node_2894);
		  aux_4446 =
		     OBJECT_WIDENING(aux_4447);
	       }
	       owner_2899 =
		  (((pre_create_vector_app_162_bglt) CREF(aux_4446))->owner);
	    }
	    {	/* Cfa/vector.scm 59 */
	       pre_create_vector_app_162_bglt node_2900;
	       {	/* Cfa/vector.scm 60 */
		  long arg2356_2912;
		  {	/* Cfa/vector.scm 60 */
		     obj_t arg2357_2913;
		     {	/* Cfa/vector.scm 60 */
			obj_t arg2358_2914;
			{	/* Cfa/vector.scm 60 */
			   object_bglt object_3511;
			   object_3511 =
			      (object_bglt) (node_2894);
			   {	/* ./Llib/object.scm 2695 */
			      long arg1179_3512;
			      {		/* ./Llib/object.scm 2695 */
				 long arg1180_3513;
				 long arg1181_3514;
				 arg1180_3513 =
				    TYPE(object_3511);
				 arg1181_3514 =
				    OBJECT_TYPE;
				 arg1179_3512 =
				    (arg1180_3513 - arg1181_3514);
			      }
			      {		/* ./Llib/object.scm 2695 */
				 obj_t vector_3518;
				 vector_3518 = _classes__134___object;
				 arg2358_2914 =
				    VECTOR_REF(vector_3518, arg1179_3512);
			      }
			   }
			}
			arg2357_2913 =
			   class_super_145___object(arg2358_2914);
		     }
		     arg2356_2912 =
			class_num_218___object(arg2357_2913);
		  }
		  {	/* Cfa/vector.scm 60 */
		     obj_t obj_3520;
		     obj_3520 =
			(obj_t) (node_2894);
		     (((obj_t) CREF(obj_3520))->header = MAKE_HEADER(arg2356_2912, 0), BUNSPEC);
		  }
	       }
	       {	/* Cfa/vector.scm 60 */
		  object_bglt aux_4460;
		  aux_4460 =
		     (object_bglt) (node_2894);
		  OBJECT_WIDENING_SET(aux_4460, BFALSE);
	       }
	       node_2900 = node_2894;
	       {	/* Cfa/vector.scm 60 */

		  {	/* Cfa/vector.scm 61 */
		     create_vector_app_150_bglt wnode_2901;
		     {	/* Cfa/vector.scm 61 */
			create_vector_app_150_bglt obj2037_2903;
			obj2037_2903 =
			   ((create_vector_app_150_bglt) (node_2900));
			{	/* Cfa/vector.scm 63 */
			   create_vector_app_150_bglt arg2349_2904;
			   {	/* Cfa/vector.scm 63 */
			      approx_bglt arg2350_2905;
			      approx_bglt arg2351_2906;
			      arg2350_2905 =
				 make_empty_approx_131_cfa_approx();
			      arg2351_2906 =
				 make_empty_approx_131_cfa_approx();
			      {		/* Cfa/vector.scm 61 */
				 create_vector_app_150_bglt res2481_3537;
				 {	/* ./Cfa/cinfo2.scm 1300 */
				    create_vector_app_150_bglt new1915_3529;
				    new1915_3529 =
				       ((create_vector_app_150_bglt) BREF(GC_MALLOC(sizeof(struct create_vector_app_150))));
				    ((((create_vector_app_150_bglt) CREF(new1915_3529))->approx) = ((approx_bglt) arg2350_2905), BUNSPEC);
				    ((((create_vector_app_150_bglt) CREF(new1915_3529))->value_approx_19) = ((approx_bglt) arg2351_2906), BUNSPEC);
				    ((((create_vector_app_150_bglt) CREF(new1915_3529))->lost_stamp_114) = ((long) ((long) -1)), BUNSPEC);
				    ((((create_vector_app_150_bglt) CREF(new1915_3529))->owner) = ((variable_bglt) owner_2899), BUNSPEC);
				    ((((create_vector_app_150_bglt) CREF(new1915_3529))->stackable__42) = ((bool_t) ((bool_t) 1)), BUNSPEC);
				    ((((create_vector_app_150_bglt) CREF(new1915_3529))->stack_stamp_31) = ((obj_t) BNIL), BUNSPEC);
				    ((((create_vector_app_150_bglt) CREF(new1915_3529))->seen__39) = ((bool_t) ((bool_t) 0)), BUNSPEC);
				    res2481_3537 = new1915_3529;
				 }
				 arg2349_2904 = res2481_3537;
			      }
			   }
			   {	/* Cfa/vector.scm 61 */
			      obj_t aux_4476;
			      object_bglt aux_4474;
			      aux_4476 =
				 (obj_t) (arg2349_2904);
			      aux_4474 =
				 (object_bglt) (obj2037_2903);
			      OBJECT_WIDENING_SET(aux_4474, aux_4476);
			   }
			}
			{	/* Cfa/vector.scm 61 */
			   long arg2355_2910;
			   arg2355_2910 =
			      class_num_218___object(create_vector_app_150_cfa_info2);
			   {	/* Cfa/vector.scm 61 */
			      obj_t obj_3538;
			      obj_3538 =
				 (obj_t) (obj2037_2903);
			      (((obj_t) CREF(obj_3538))->header = MAKE_HEADER(arg2355_2910, 0), BUNSPEC);
			   }
			}
			wnode_2901 = obj2037_2903;
		     }
		     {	/* Cfa/vector.scm 67 */
			approx_bglt arg2348_2902;
			arg2348_2902 =
			   make_type_alloc_approx_134_cfa_approx(
			   (type_bglt) (_vector__240_type_cache),
			   (node_bglt) (node_2900));
			{
			   obj_t aux_4485;
			   {	/* ./Cfa/cinfo2.scm 1300 */
			      object_bglt aux_4486;
			      aux_4486 =
				 (object_bglt) (wnode_2901);
			      aux_4485 =
				 OBJECT_WIDENING(aux_4486);
			   }
			   return
			      ((((create_vector_app_150_bglt) CREF(aux_4485))->approx) = ((approx_bglt) arg2348_2902), BUNSPEC);
			}
		     }
		  }
	       }
	    }
	 }
      }
   }
}



/* node-setup!-pre-make-vector-app2064 */
obj_t 
node_setup__pre_make_vector_app2064_95_cfa_vector(obj_t env_3776, obj_t node_3777)
{
   AN_OBJECT;
   {	/* Cfa/vector.scm 37 */
      {
	 pre_make_vector_app_251_bglt node_2871;
	 node_2871 =
	    (pre_make_vector_app_251_bglt) (node_3777);
	 add_make_vector__104_cfa_tvector(
	    (node_bglt) (node_2871));
	 {	/* Cfa/vector.scm 40 */
	    obj_t aux_4493;
	    {	/* Cfa/vector.scm 40 */
	       app_bglt obj_3476;
	       obj_3476 =
		  (app_bglt) (node_2871);
	       aux_4493 =
		  (((app_bglt) CREF(obj_3476))->args);
	    }
	    node_setup___185_cfa_setup(aux_4493);
	 }
	 {	/* Cfa/vector.scm 41 */
	    variable_bglt owner_2876;
	    {
	       obj_t aux_4497;
	       {	/* ./Cfa/cinfo2.scm 1269 */
		  object_bglt aux_4498;
		  aux_4498 =
		     (object_bglt) (node_2871);
		  aux_4497 =
		     OBJECT_WIDENING(aux_4498);
	       }
	       owner_2876 =
		  (((pre_make_vector_app_251_bglt) CREF(aux_4497))->owner);
	    }
	    {	/* Cfa/vector.scm 41 */
	       pre_make_vector_app_251_bglt node_2877;
	       {	/* Cfa/vector.scm 42 */
		  long arg2343_2889;
		  {	/* Cfa/vector.scm 42 */
		     obj_t arg2344_2890;
		     {	/* Cfa/vector.scm 42 */
			obj_t arg2345_2891;
			{	/* Cfa/vector.scm 42 */
			   object_bglt object_3478;
			   object_3478 =
			      (object_bglt) (node_2871);
			   {	/* ./Llib/object.scm 2695 */
			      long arg1179_3479;
			      {		/* ./Llib/object.scm 2695 */
				 long arg1180_3480;
				 long arg1181_3481;
				 arg1180_3480 =
				    TYPE(object_3478);
				 arg1181_3481 =
				    OBJECT_TYPE;
				 arg1179_3479 =
				    (arg1180_3480 - arg1181_3481);
			      }
			      {		/* ./Llib/object.scm 2695 */
				 obj_t vector_3485;
				 vector_3485 = _classes__134___object;
				 arg2345_2891 =
				    VECTOR_REF(vector_3485, arg1179_3479);
			      }
			   }
			}
			arg2344_2890 =
			   class_super_145___object(arg2345_2891);
		     }
		     arg2343_2889 =
			class_num_218___object(arg2344_2890);
		  }
		  {	/* Cfa/vector.scm 42 */
		     obj_t obj_3487;
		     obj_3487 =
			(obj_t) (node_2871);
		     (((obj_t) CREF(obj_3487))->header = MAKE_HEADER(arg2343_2889, 0), BUNSPEC);
		  }
	       }
	       {	/* Cfa/vector.scm 42 */
		  object_bglt aux_4511;
		  aux_4511 =
		     (object_bglt) (node_2871);
		  OBJECT_WIDENING_SET(aux_4511, BFALSE);
	       }
	       node_2877 = node_2871;
	       {	/* Cfa/vector.scm 42 */

		  {	/* Cfa/vector.scm 43 */
		     make_vector_app_205_bglt wnode_2878;
		     {	/* Cfa/vector.scm 43 */
			make_vector_app_205_bglt obj2034_2880;
			obj2034_2880 =
			   ((make_vector_app_205_bglt) (node_2877));
			{	/* Cfa/vector.scm 45 */
			   make_vector_app_205_bglt arg2336_2881;
			   {	/* Cfa/vector.scm 45 */
			      approx_bglt arg2337_2882;
			      approx_bglt arg2338_2883;
			      arg2337_2882 =
				 make_empty_approx_131_cfa_approx();
			      arg2338_2883 =
				 make_empty_approx_131_cfa_approx();
			      {		/* Cfa/vector.scm 43 */
				 make_vector_app_205_bglt res2480_3504;
				 {	/* ./Cfa/cinfo2.scm 1276 */
				    make_vector_app_205_bglt new1892_3496;
				    new1892_3496 =
				       ((make_vector_app_205_bglt) BREF(GC_MALLOC(sizeof(struct make_vector_app_205))));
				    ((((make_vector_app_205_bglt) CREF(new1892_3496))->approx) = ((approx_bglt) arg2337_2882), BUNSPEC);
				    ((((make_vector_app_205_bglt) CREF(new1892_3496))->value_approx_19) = ((approx_bglt) arg2338_2883), BUNSPEC);
				    ((((make_vector_app_205_bglt) CREF(new1892_3496))->lost_stamp_114) = ((long) ((long) -1)), BUNSPEC);
				    ((((make_vector_app_205_bglt) CREF(new1892_3496))->owner) = ((variable_bglt) owner_2876), BUNSPEC);
				    ((((make_vector_app_205_bglt) CREF(new1892_3496))->stackable__42) = ((bool_t) ((bool_t) 1)), BUNSPEC);
				    ((((make_vector_app_205_bglt) CREF(new1892_3496))->stack_stamp_31) = ((obj_t) BNIL), BUNSPEC);
				    ((((make_vector_app_205_bglt) CREF(new1892_3496))->seen__39) = ((bool_t) ((bool_t) 0)), BUNSPEC);
				    res2480_3504 = new1892_3496;
				 }
				 arg2336_2881 = res2480_3504;
			      }
			   }
			   {	/* Cfa/vector.scm 43 */
			      obj_t aux_4527;
			      object_bglt aux_4525;
			      aux_4527 =
				 (obj_t) (arg2336_2881);
			      aux_4525 =
				 (object_bglt) (obj2034_2880);
			      OBJECT_WIDENING_SET(aux_4525, aux_4527);
			   }
			}
			{	/* Cfa/vector.scm 43 */
			   long arg2342_2887;
			   arg2342_2887 =
			      class_num_218___object(make_vector_app_205_cfa_info2);
			   {	/* Cfa/vector.scm 43 */
			      obj_t obj_3505;
			      obj_3505 =
				 (obj_t) (obj2034_2880);
			      (((obj_t) CREF(obj_3505))->header = MAKE_HEADER(arg2342_2887, 0), BUNSPEC);
			   }
			}
			wnode_2878 = obj2034_2880;
		     }
		     {	/* Cfa/vector.scm 49 */
			approx_bglt arg2335_2879;
			arg2335_2879 =
			   make_type_alloc_approx_134_cfa_approx(
			   (type_bglt) (_vector__240_type_cache),
			   (node_bglt) (node_2877));
			{
			   obj_t aux_4536;
			   {	/* ./Cfa/cinfo2.scm 1276 */
			      object_bglt aux_4537;
			      aux_4537 =
				 (object_bglt) (wnode_2878);
			      aux_4536 =
				 OBJECT_WIDENING(aux_4537);
			   }
			   return
			      ((((make_vector_app_205_bglt) CREF(aux_4536))->approx) = ((approx_bglt) arg2335_2879), BUNSPEC);
			}
		     }
		  }
	       }
	    }
	 }
      }
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_cfa_vector()
{
   AN_OBJECT;
   {	/* Cfa/vector.scm 16 */
      module_initialization_70_tools_trace(((long) 0), "CFA_VECTOR");
      module_initialization_70_tools_error(((long) 0), "CFA_VECTOR");
      module_initialization_70_tools_shape(((long) 0), "CFA_VECTOR");
      module_initialization_70_type_type(((long) 0), "CFA_VECTOR");
      module_initialization_70_type_cache(((long) 0), "CFA_VECTOR");
      module_initialization_70_ast_var(((long) 0), "CFA_VECTOR");
      module_initialization_70_ast_node(((long) 0), "CFA_VECTOR");
      module_initialization_70_cfa_info(((long) 0), "CFA_VECTOR");
      module_initialization_70_cfa_info2(((long) 0), "CFA_VECTOR");
      module_initialization_70_cfa_loose(((long) 0), "CFA_VECTOR");
      module_initialization_70_cfa_iterate(((long) 0), "CFA_VECTOR");
      module_initialization_70_cfa_cfa(((long) 0), "CFA_VECTOR");
      module_initialization_70_cfa_setup(((long) 0), "CFA_VECTOR");
      module_initialization_70_cfa_approx(((long) 0), "CFA_VECTOR");
      module_initialization_70_cfa_tvector(((long) 0), "CFA_VECTOR");
      return
	 module_initialization_70_cfa_stack(((long) 0), "CFA_VECTOR");
   }
}
