/*===========================================================================*/
/*   (Cfa/walk.scm)                                                          */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;

typedef struct approx
  {
     header_t header;
     obj_t widening;
     struct type *type;
     bool_t type_locked__184;
     obj_t allocs;
     bool_t top__138;
     long lost_stamp_114;
  }
      *approx_bglt;

typedef struct cfun_cinfo_200
  {
     struct approx *approx;
  }
              *cfun_cinfo_200_bglt;

typedef struct extern_sfun_cinfo_6
  {
     struct approx *approx;
  }
                   *extern_sfun_cinfo_6_bglt;

typedef struct intern_sfun_cinfo_192
  {
     struct approx *approx;
     long stamp;
  }
                     *intern_sfun_cinfo_192_bglt;

typedef struct scnst_cinfo_0
  {
     struct approx *approx;
  }
             *scnst_cinfo_0_bglt;

typedef struct pre_clo_env_191
  {
     char dummy;
  }
               *pre_clo_env_191_bglt;

typedef struct svar_cinfo_166
  {
     struct approx *approx;
     bool_t clo_env__87;
  }
              *svar_cinfo_166_bglt;

typedef struct cvar_cinfo_53
  {
     struct approx *approx;
  }
             *cvar_cinfo_53_bglt;

typedef struct sexit_cinfo_49
  {
     struct approx *approx;
  }
              *sexit_cinfo_49_bglt;

typedef struct reshaped_local_224
  {
     obj_t binding_value_3;
  }
                  *reshaped_local_224_bglt;

typedef struct reshaped_global_160
  {
     char dummy;
  }
                   *reshaped_global_160_bglt;

typedef struct atom_cinfo_155
  {
     struct approx *approx;
  }
              *atom_cinfo_155_bglt;

typedef struct kwote_node_102
  {
     struct node *node;
  }
              *kwote_node_102_bglt;

typedef struct kwote_cinfo_48
  {
     struct approx *approx;
  }
              *kwote_cinfo_48_bglt;

typedef struct app_ly_cinfo_234
  {
     struct approx *approx;
  }
                *app_ly_cinfo_234_bglt;

typedef struct funcall_cinfo_75
  {
     struct approx *approx;
     struct approx *va_approx_63;
     bool_t arity_error_noticed__118;
     bool_t type_error_noticed__36;
  }
                *funcall_cinfo_75_bglt;

typedef struct pragma_cinfo_220
  {
     struct approx *approx;
  }
                *pragma_cinfo_220_bglt;

typedef struct setq_cinfo_191
  {
     struct approx *approx;
  }
              *setq_cinfo_191_bglt;

typedef struct conditional_cinfo_212
  {
     struct approx *approx;
  }
                     *conditional_cinfo_212_bglt;

typedef struct fail_cinfo_75
  {
     struct approx *approx;
  }
             *fail_cinfo_75_bglt;

typedef struct select_cinfo_150
  {
     struct approx *approx;
  }
                *select_cinfo_150_bglt;

typedef struct set_ex_it_cinfo_168
  {
     struct approx *approx;
  }
                   *set_ex_it_cinfo_168_bglt;

typedef struct jump_ex_it_cinfo_139
  {
     struct approx *approx;
  }
                    *jump_ex_it_cinfo_139_bglt;

typedef struct pre_make_box_186
  {
     char dummy;
  }
                *pre_make_box_186_bglt;

typedef struct make_box_cinfo_127
  {
     struct approx *approx;
  }
                  *make_box_cinfo_127_bglt;

typedef struct make_box_o_cinfo_96
  {
     struct approx *approx;
     struct approx *value_approx_19;
  }
                   *make_box_o_cinfo_96_bglt;

typedef struct box_set__cinfo_94
  {
     struct approx *approx;
  }
                 *box_set__cinfo_94_bglt;

typedef struct box_ref_cinfo_214
  {
     struct approx *approx;
  }
                 *box_ref_cinfo_214_bglt;

typedef struct box_set__o_cinfo_6
  {
     struct approx *approx;
  }
                  *box_set__o_cinfo_6_bglt;

typedef struct box_ref_o_cinfo_98
  {
     struct approx *approx;
  }
                  *box_ref_o_cinfo_98_bglt;

typedef struct pre_make_procedure_app_60
  {
     struct variable *owner;
  }
                         *pre_make_procedure_app_60_bglt;

typedef struct pre_procedure_ref_app_85
  {
     char dummy;
  }
                        *pre_procedure_ref_app_85_bglt;

typedef struct pre_procedure_set__app_208
  {
     char dummy;
  }
                          *pre_procedure_set__app_208_bglt;

typedef struct make_procedure_app_48
  {
     struct approx *approx;
     long values_approx_len_106;
     struct approx **values_approx_79;
     long lost_stamp_114;
     bool_t x_t__142;
     bool_t x;
     bool_t t;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
  }
                     *make_procedure_app_48_bglt;

typedef struct procedure_ref_app_49
  {
     struct approx *approx;
  }
                    *procedure_ref_app_49_bglt;

typedef struct procedure_set__app_32
  {
     struct approx *approx;
  }
                     *procedure_set__app_32_bglt;

typedef struct pre_make_vector_app_251
  {
     struct variable *owner;
  }
                       *pre_make_vector_app_251_bglt;

typedef struct pre_create_vector_app_162
  {
     struct variable *owner;
  }
                         *pre_create_vector_app_162_bglt;

typedef struct pre_vector_ref_app_208
  {
     char dummy;
  }
                      *pre_vector_ref_app_208_bglt;

typedef struct pre_vector_set__app_211
  {
     char dummy;
  }
                       *pre_vector_set__app_211_bglt;

typedef struct make_vector_app_205
  {
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
     bool_t seen__39;
  }
                   *make_vector_app_205_bglt;

typedef struct create_vector_app_150
  {
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
     bool_t seen__39;
  }
                     *create_vector_app_150_bglt;

typedef struct vector_ref_app_195
  {
     struct approx *approx;
  }
                  *vector_ref_app_195_bglt;

typedef struct vector_set__app_21
  {
     struct approx *approx;
  }
                  *vector_set__app_21_bglt;

typedef struct pre_make_struct_app_218
  {
     struct variable *owner;
  }
                       *pre_make_struct_app_218_bglt;

typedef struct pre_struct_ref_app_207
  {
     char dummy;
  }
                      *pre_struct_ref_app_207_bglt;

typedef struct pre_struct_set__app_116
  {
     char dummy;
  }
                       *pre_struct_set__app_116_bglt;

typedef struct make_struct_app_214
  {
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
  }
                   *make_struct_app_214_bglt;

typedef struct struct_ref_app_73
  {
     struct approx *approx;
  }
                 *struct_ref_app_73_bglt;

typedef struct struct_set__app_162
  {
     struct approx *approx;
  }
                   *struct_set__app_162_bglt;


static obj_t method_init_76_cfa_walk();
extern obj_t declare_approx_sets__132_cfa_approx();
extern obj_t specialize__184_cfa_specialize(obj_t);
extern obj_t closure_optimization__48_cfa_closure();
extern obj_t current_error_port;
extern obj_t _nb_error_on_pass__70_tools_error;
extern obj_t set_initial_approx__92_cfa_setup(obj_t);
extern obj_t vector__tvector__205_cfa_tvector(obj_t);
extern obj_t shrinkify__187_ast_shrinkify(obj_t);
extern obj_t verbose_tools_speek(obj_t, obj_t);
extern obj_t show_cfa_nb_iterations_231_cfa_show();
extern obj_t show_cfa_results_28_cfa_show(obj_t);
extern obj_t module_initialization_70_cfa_walk(long, char *);
extern obj_t module_initialization_70_tools_speek(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_engine_pass(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_remove(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_ast_shrinkify(long, char *);
extern obj_t module_initialization_70_cfa_collect(long, char *);
extern obj_t module_initialization_70_cfa_setup(long, char *);
extern obj_t module_initialization_70_cfa_iterate(long, char *);
extern obj_t module_initialization_70_cfa_show(long, char *);
extern obj_t module_initialization_70_cfa_info(long, char *);
extern obj_t module_initialization_70_cfa_info2(long, char *);
extern obj_t module_initialization_70_cfa_approx(long, char *);
extern obj_t module_initialization_70_cfa_stack(long, char *);
extern obj_t module_initialization_70_cfa_type(long, char *);
extern obj_t module_initialization_70_cfa_closure(long, char *);
extern obj_t module_initialization_70_cfa_specialize(long, char *);
extern obj_t module_initialization_70_cfa_tvector(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_numbers_6_5(long, char *);
extern obj_t module_initialization_70___r4_output_6_10_3(long, char *);
extern obj_t display_2_122___r4_output_6_10_3(obj_t, obj_t);
static obj_t imported_modules_init_94_cfa_walk();
extern obj_t heap__stack__166_cfa_stack(obj_t, obj_t);
extern obj_t append_2_18___r4_pairs_and_lists_6_3(obj_t, obj_t);
static obj_t library_modules_init_112_cfa_walk();
extern obj_t cfa_walk__41_cfa_walk(obj_t);
extern obj_t open_input_string(obj_t);
extern obj_t string_to_bstring(char *);
extern obj_t remove_var_123_ast_remove(obj_t, obj_t);
extern obj_t internal_error_43_tools_error(obj_t, obj_t, obj_t);
extern bool_t _2__206___r4_numbers_6_5(obj_t, obj_t);
extern obj_t read___reader(obj_t);
extern obj_t _profile_mode__105_engine_param;
extern obj_t type_settings__207_cfa_type(obj_t);
extern obj_t cfa_iterate_to_fixpoint__166_cfa_iterate(obj_t);
static obj_t require_initialization_114_cfa_walk = BUNSPEC;
static obj_t _cfa_walk__129_cfa_walk(obj_t, obj_t);
extern obj_t collect_all_approx__236_cfa_collect(obj_t);
static obj_t cnst_init_137_cfa_walk();
extern obj_t _current_pass__25_engine_pass;
static obj_t __cnst[3];

DEFINE_EXPORT_PROCEDURE(cfa_walk__env_66_cfa_walk, _cfa_walk__129_cfa_walk2324, _cfa_walk__129_cfa_walk, 0L, 1);
DEFINE_STRING(string2319_cfa_walk, string2319_cfa_walk2325, "(UNPATCH-VECTOR-SET!) (CFA INLINE) PASS-STARTED ", 48);
DEFINE_STRING(string2318_cfa_walk, string2318_cfa_walk2326, "failure during postlude hook", 28);
DEFINE_STRING(string2317_cfa_walk, string2317_cfa_walk2327, " occured, ending ...", 20);
DEFINE_STRING(string2316_cfa_walk, string2316_cfa_walk2328, " error", 6);
DEFINE_STRING(string2315_cfa_walk, string2315_cfa_walk2329, "failure during prelude hook", 27);
DEFINE_STRING(string2314_cfa_walk, string2314_cfa_walk2330, "   . ", 5);
DEFINE_STRING(string2313_cfa_walk, string2313_cfa_walk2331, "Cfa", 3);
extern obj_t unpatch_vector_set__env_116_cfa_tvector;



/* module-initialization */
obj_t 
module_initialization_70_cfa_walk(long checksum_3280, char *from_3281)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_cfa_walk))
	{
	   require_initialization_114_cfa_walk =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_cfa_walk();
	   cnst_init_137_cfa_walk();
	   imported_modules_init_94_cfa_walk();
	   method_init_76_cfa_walk();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_cfa_walk()
{
   AN_OBJECT;
   {	/* Cfa/walk.scm 23 */
      module_initialization_70___r4_output_6_10_3(((long) 0), "CFA_WALK");
      module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "CFA_WALK");
      module_initialization_70___r4_numbers_6_5(((long) 0), "CFA_WALK");
      module_initialization_70___reader(((long) 0), "CFA_WALK");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_cfa_walk()
{
   AN_OBJECT;
   {	/* Cfa/walk.scm 23 */
      {		/* Cfa/walk.scm 23 */
	 obj_t cnst_port_138_3273;
	 cnst_port_138_3273 =
	    open_input_string(string2319_cfa_walk);
	 {
	    long i_3274;
	    i_3274 = ((long) 2);
	  loop_3275:
	    {	/* Cfa/walk.scm 23 */
	       bool_t test2320_3276;
	       test2320_3276 =
		  (i_3274 == ((long) -1));
	       if (test2320_3276)
		 {	/* Cfa/walk.scm 23 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Cfa/walk.scm 23 */
		    {	/* Cfa/walk.scm 23 */
		       obj_t arg2321_3277;
		       {	/* Cfa/walk.scm 23 */
			  obj_t list2322_3278;
			  list2322_3278 =
			     MAKE_PAIR(cnst_port_138_3273, BNIL);
			  arg2321_3277 =
			     read___reader(list2322_3278);
		       }
		       CNST_TABLE_SET(i_3274, arg2321_3277);
		    }
		    {	/* Cfa/walk.scm 23 */
		       int aux_3279;
		       {	/* Cfa/walk.scm 23 */
			  long aux_3299;
			  aux_3299 =
			     (i_3274 - ((long) 1));
			  aux_3279 =
			     (int) (aux_3299);
		       }
		       {
			  long i_3302;
			  i_3302 =
			     (long) (aux_3279);
			  i_3274 = i_3302;
			  goto loop_3275;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* cfa-walk! */
obj_t 
cfa_walk__41_cfa_walk(obj_t globals_1)
{
   AN_OBJECT;
   {	/* Cfa/walk.scm 58 */
      {		/* Cfa/walk.scm 58 */
	 obj_t list2032_2102;
	 {	/* Cfa/walk.scm 58 */
	    obj_t arg2034_2104;
	    {	/* Cfa/walk.scm 58 */
	       obj_t arg2036_2106;
	       {	/* Cfa/walk.scm 58 */
		  obj_t aux_3304;
		  aux_3304 =
		     BCHAR(((unsigned char) '\n'));
		  arg2036_2106 =
		     MAKE_PAIR(aux_3304, BNIL);
	       }
	       arg2034_2104 =
		  MAKE_PAIR(string2313_cfa_walk, arg2036_2106);
	    }
	    list2032_2102 =
	       MAKE_PAIR(string2314_cfa_walk, arg2034_2104);
	 }
	 verbose_tools_speek(
	    BINT(((long) 1)), list2032_2102);
      }
      _nb_error_on_pass__70_tools_error =
	 BINT(((long) 0));
      _current_pass__25_engine_pass = string2313_cfa_walk;
      {
	 obj_t hooks_2107;
	 obj_t hnames_2108;
	 hooks_2107 = BNIL;
	 hnames_2108 = BNIL;
       loop_2109:
	 if (
	    NULLP(hooks_2107))
	   {	/* Cfa/walk.scm 58 */
	      CNST_TABLE_REF(((long) 0));
	   }
	 else
	   {	/* Cfa/walk.scm 58 */
	      bool_t test2041_2114;
	      {		/* Cfa/walk.scm 58 */
		 obj_t fun2048_2120;
		 fun2048_2120 =
		    CAR(hooks_2107);
		 {	/* Cfa/walk.scm 58 */
		    obj_t aux_3316;
		    aux_3316 =
		       PROCEDURE_ENTRY(fun2048_2120) (fun2048_2120, BEOA);
		    test2041_2114 =
		       CBOOL(aux_3316);
		 }
	      }
	      if (test2041_2114)
		{	/* Cfa/walk.scm 58 */
		   {
		      obj_t hnames_3323;
		      obj_t hooks_3321;
		      hooks_3321 =
			 CDR(hooks_2107);
		      hnames_3323 =
			 CDR(hnames_2108);
		      hnames_2108 = hnames_3323;
		      hooks_2107 = hooks_3321;
		      goto loop_2109;
		   }
		}
	      else
		{	/* Cfa/walk.scm 58 */
		   internal_error_43_tools_error(string2313_cfa_walk, string2315_cfa_walk,
		      CAR(hnames_2108));
		}
	   }
      }
      collect_all_approx__236_cfa_collect(globals_1);
      declare_approx_sets__132_cfa_approx();
      set_initial_approx__92_cfa_setup(globals_1);
      {		/* Cfa/walk.scm 70 */
	 obj_t iteration_roots_204_2121;
	 iteration_roots_204_2121 =
	    cfa_iterate_to_fixpoint__166_cfa_iterate(globals_1);
	 show_cfa_nb_iterations_231_cfa_show();
	 {	/* Cfa/walk.scm 74 */
	    obj_t globals_2122;
	    globals_2122 =
	       remove_var_123_ast_remove(
	       CNST_TABLE_REF(((long) 1)), globals_1);
	    show_cfa_results_28_cfa_show(globals_2122);
	    heap__stack__166_cfa_stack(iteration_roots_204_2121, globals_2122);
	    {	/* Cfa/walk.scm 80 */
	       obj_t additional_2123;
	       additional_2123 =
		  vector__tvector__205_cfa_tvector(globals_2122);
	       type_settings__207_cfa_type(globals_2122);
	       {	/* Cfa/walk.scm 84 */
		  bool_t test2049_2124;
		  {	/* Cfa/walk.scm 84 */
		     bool_t test2050_2125;
		     {	/* Cfa/walk.scm 84 */
			bool_t res2311_2910;
			{	/* Cfa/walk.scm 84 */
			   obj_t obj_2906;
			   obj_2906 = _profile_mode__105_engine_param;
			   if (
			      INTEGERP(obj_2906))
			     {	/* ./Ieee/number.scm 6283 */
				res2311_2910 = ((bool_t) 1);
			     }
			   else
			     {	/* ./Ieee/number.scm 6283 */
				res2311_2910 =
				   REALP(obj_2906);
			     }
			}
			test2050_2125 = res2311_2910;
		     }
		     if (test2050_2125)
		       {	/* Cfa/walk.scm 84 */
			  test2049_2124 =
			     _2__206___r4_numbers_6_5(_profile_mode__105_engine_param,
			     BINT(((long) 0)));
		       }
		     else
		       {	/* Cfa/walk.scm 84 */
			  test2049_2124 = ((bool_t) 0);
		       }
		  }
		  if (test2049_2124)
		    {	/* Cfa/walk.scm 84 */
		       BUNSPEC;
		    }
		  else
		    {	/* Cfa/walk.scm 84 */
		       closure_optimization__48_cfa_closure();
		    }
	       }
	       specialize__184_cfa_specialize(globals_2122);
	       {	/* Cfa/walk.scm 89 */
		  obj_t value_2126;
		  value_2126 =
		     shrinkify__187_ast_shrinkify(
		     append_2_18___r4_pairs_and_lists_6_3(additional_2123, globals_2122));
		  {	/* Cfa/walk.scm 89 */
		     bool_t test2051_2127;
		     {	/* Cfa/walk.scm 89 */
			long n1_2911;
			n1_2911 =
			   (long) CINT(_nb_error_on_pass__70_tools_error);
			test2051_2127 =
			   (n1_2911 > ((long) 0));
		     }
		     if (test2051_2127)
		       {	/* Cfa/walk.scm 89 */
			  display_2_122___r4_output_6_10_3(_nb_error_on_pass__70_tools_error, current_error_port);
			  display_2_122___r4_output_6_10_3(string2316_cfa_walk, current_error_port);
			  {	/* Cfa/walk.scm 89 */
			     char *arg2052_2129;
			     {	/* Cfa/walk.scm 89 */
				bool_t test2053_2130;
				{	/* Cfa/walk.scm 89 */
				   bool_t test2054_2131;
				   {	/* Cfa/walk.scm 89 */
				      obj_t obj_2913;
				      obj_2913 = _nb_error_on_pass__70_tools_error;
				      test2054_2131 =
					 INTEGERP(obj_2913);
				   }
				   if (test2054_2131)
				     {	/* Cfa/walk.scm 89 */
					test2053_2130 =
					   _2__206___r4_numbers_6_5(_nb_error_on_pass__70_tools_error,
					   BINT(((long) 1)));
				     }
				   else
				     {	/* Cfa/walk.scm 89 */
					test2053_2130 = ((bool_t) 0);
				     }
				}
				if (test2053_2130)
				  {	/* Cfa/walk.scm 89 */
				     arg2052_2129 = "s";
				  }
				else
				  {	/* Cfa/walk.scm 89 */
				     arg2052_2129 = "";
				  }
			     }
			     display_2_122___r4_output_6_10_3(
				string_to_bstring(arg2052_2129), current_error_port);
			  }
			  display_2_122___r4_output_6_10_3(string2317_cfa_walk, current_error_port);
			  WRITE_CHAR(((unsigned char) '\n'), current_error_port);
			  {	/* Cfa/walk.scm 89 */
			     obj_t res2312_2916;
			     exit(((long) -1));
			     res2312_2916 =
				BINT(((long) -1));
			     return res2312_2916;
			  }
		       }
		     else
		       {
			  obj_t hooks_2132;
			  obj_t hnames_2133;
			  {	/* Cfa/walk.scm 89 */
			     obj_t arg2055_2135;
			     obj_t arg2056_2136;
			     {	/* Cfa/walk.scm 89 */
				obj_t list2057_2137;
				list2057_2137 =
				   MAKE_PAIR(unpatch_vector_set__env_116_cfa_tvector, BNIL);
				arg2055_2135 = list2057_2137;
			     }
			     arg2056_2136 =
				CNST_TABLE_REF(((long) 2));
			     hooks_2132 = arg2055_2135;
			     hnames_2133 = arg2056_2136;
			   loop_2134:
			     if (
				NULLP(hooks_2132))
			       {	/* Cfa/walk.scm 89 */
				  return value_2126;
			       }
			     else
			       {	/* Cfa/walk.scm 89 */
				  bool_t test2059_2139;
				  {	/* Cfa/walk.scm 89 */
				     obj_t fun2064_2144;
				     fun2064_2144 =
					CAR(hooks_2132);
				     {	/* Cfa/walk.scm 89 */
					obj_t aux_3370;
					aux_3370 =
					   PROCEDURE_ENTRY(fun2064_2144) (fun2064_2144, BEOA);
					test2059_2139 =
					   CBOOL(aux_3370);
				     }
				  }
				  if (test2059_2139)
				    {	/* Cfa/walk.scm 89 */
				       {
					  obj_t hnames_3377;
					  obj_t hooks_3375;
					  hooks_3375 =
					     CDR(hooks_2132);
					  hnames_3377 =
					     CDR(hnames_2133);
					  hnames_2133 = hnames_3377;
					  hooks_2132 = hooks_3375;
					  goto loop_2134;
				       }
				    }
				  else
				    {	/* Cfa/walk.scm 89 */
				       return
					  internal_error_43_tools_error(_current_pass__25_engine_pass, string2318_cfa_walk,
					  CAR(hnames_2133));
				    }
			       }
			  }
		       }
		  }
	       }
	    }
	 }
      }
   }
}



/* _cfa-walk! */
obj_t 
_cfa_walk__129_cfa_walk(obj_t env_3270, obj_t globals_3271)
{
   AN_OBJECT;
   {	/* Cfa/walk.scm 58 */
      return
	 cfa_walk__41_cfa_walk(globals_3271);
   }
}



/* method-init */
obj_t 
method_init_76_cfa_walk()
{
   AN_OBJECT;
   {	/* Cfa/walk.scm 23 */
      return BUNSPEC;
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_cfa_walk()
{
   AN_OBJECT;
   {	/* Cfa/walk.scm 23 */
      module_initialization_70_tools_speek(((long) 0), "CFA_WALK");
      module_initialization_70_tools_error(((long) 0), "CFA_WALK");
      module_initialization_70_engine_pass(((long) 0), "CFA_WALK");
      module_initialization_70_tools_shape(((long) 0), "CFA_WALK");
      module_initialization_70_engine_param(((long) 0), "CFA_WALK");
      module_initialization_70_type_type(((long) 0), "CFA_WALK");
      module_initialization_70_ast_remove(((long) 0), "CFA_WALK");
      module_initialization_70_ast_var(((long) 0), "CFA_WALK");
      module_initialization_70_ast_node(((long) 0), "CFA_WALK");
      module_initialization_70_ast_shrinkify(((long) 0), "CFA_WALK");
      module_initialization_70_cfa_collect(((long) 0), "CFA_WALK");
      module_initialization_70_cfa_setup(((long) 0), "CFA_WALK");
      module_initialization_70_cfa_iterate(((long) 0), "CFA_WALK");
      module_initialization_70_cfa_show(((long) 0), "CFA_WALK");
      module_initialization_70_cfa_info(((long) 0), "CFA_WALK");
      module_initialization_70_cfa_info2(((long) 0), "CFA_WALK");
      module_initialization_70_cfa_approx(((long) 0), "CFA_WALK");
      module_initialization_70_cfa_stack(((long) 0), "CFA_WALK");
      module_initialization_70_cfa_type(((long) 0), "CFA_WALK");
      module_initialization_70_cfa_closure(((long) 0), "CFA_WALK");
      module_initialization_70_cfa_specialize(((long) 0), "CFA_WALK");
      return
	 module_initialization_70_cfa_tvector(((long) 0), "CFA_WALK");
   }
}
