/*===========================================================================*/
/*   (Cgen/emit-cop.scm)                                                     */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;

typedef struct cop
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
   *cop_bglt;

typedef struct clabel
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     obj_t name;
     bool_t used__226;
     obj_t body;
  }
      *clabel_bglt;

typedef struct cgoto
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct clabel *label;
  }
     *cgoto_bglt;

typedef struct block
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *body;
  }
     *block_bglt;

typedef struct creturn
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *value;
  }
       *creturn_bglt;

typedef struct cvoid
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *value;
  }
     *cvoid_bglt;

typedef struct catom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     obj_t value;
  }
     *catom_bglt;

typedef struct varc
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct variable *variable;
  }
    *varc_bglt;

typedef struct cpragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     obj_t format;
     obj_t args;
  }
       *cpragma_bglt;

typedef struct ccast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct cop *arg;
  }
     *ccast_bglt;

typedef struct csequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     bool_t c_exp__163;
     obj_t cops;
  }
         *csequence_bglt;

typedef struct nop
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
   *nop_bglt;

typedef struct stop
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *value;
  }
    *stop_bglt;

typedef struct csetq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct varc *var;
     struct cop *value;
  }
     *csetq_bglt;

typedef struct cif
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *test;
     struct cop *true;
     struct cop *false;
  }
   *cif_bglt;

typedef struct local_var_164
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     obj_t vars;
  }
             *local_var_164_bglt;

typedef struct cfuncall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *fun;
     obj_t args;
     obj_t strength;
  }
        *cfuncall_bglt;

typedef struct capply
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *fun;
     struct cop *arg;
  }
      *capply_bglt;

typedef struct capp
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *fun;
     obj_t args;
  }
    *capp_bglt;

typedef struct cfail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *proc;
     struct cop *msg;
     struct cop *obj;
  }
     *cfail_bglt;

typedef struct cswitch
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *test;
     obj_t clauses;
  }
       *cswitch_bglt;

typedef struct cmake_box_177
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *value;
  }
             *cmake_box_177_bglt;

typedef struct cbox_ref_44
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *var;
  }
           *cbox_ref_44_bglt;

typedef struct cbox_set__132
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *var;
     struct cop *value;
  }
             *cbox_set__132_bglt;

typedef struct cset_ex_it_123
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *exit;
     struct cop *jump_value_221;
     struct cop *body;
  }
              *cset_ex_it_123_bglt;

typedef struct cjump_ex_it_131
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *exit;
     struct cop *value;
  }
               *cjump_ex_it_131_bglt;

typedef struct sfun_c_188
  {
     struct clabel *label;
     bool_t integrated;
  }
          *sfun_c_188_bglt;

typedef struct bdb_block_21
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *body;
  }
            *bdb_block_21_bglt;


extern obj_t _long__149_type_cache;
extern obj_t _src_files__222_engine_param;
extern obj_t _bdb_debug_no_line_directives___59_engine_param;
static obj_t method_init_76_cgen_emit_cop_239();
extern obj_t find_global_module_25_ast_env(obj_t, obj_t);
extern obj_t block_cgen_cop;
static bool_t emit_regular_cfuncall_eoa_48_cgen_emit_cop_239(cfuncall_bglt);
static obj_t _bfalse__69_cgen_emit_cop_239 = BUNSPEC;
extern obj_t cbox_ref_44_cgen_cop;
static obj_t _reset_bdb_loc__118_cgen_emit_cop_239(obj_t);
extern long add_inlined_method__244___object(obj_t, obj_t, long);
extern obj_t string_append(obj_t, obj_t);
static obj_t _bdb_loc__137_cgen_emit_cop_239 = BUNSPEC;
extern obj_t _stdc__25_engine_param;
extern obj_t _c_port__188_cgen_emit;
extern obj_t string_sans___40_type_tools(obj_t);
extern obj_t make_typed_declaration_180_type_tools(type_bglt, obj_t);
extern bool_t rgc_fill_buffer(obj_t);
extern obj_t _bdb_debug__1_engine_param;
extern obj_t cjump_ex_it_131_cgen_cop;
static obj_t emit_atom_value_68_cgen_emit_cop_239(obj_t);
extern obj_t cpragma_cgen_cop;
extern obj_t untrigraph_cgen_emit_cop_239(obj_t);
static obj_t _untrigraph2264_cgen_emit_cop_239(obj_t, obj_t);
static obj_t _emit_cop_default1681_212_cgen_emit_cop_239(obj_t, obj_t);
extern obj_t varc_cgen_cop;
extern obj_t emit_bdb_loc_8_cgen_emit_cop_239(obj_t);
static obj_t the_string_180_cgen_emit_cop_239(obj_t);
extern obj_t local_var_164_cgen_cop;
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t catom_cgen_cop;
extern obj_t reset_bdb_loc__217_cgen_emit_cop_239();
extern obj_t nop_cgen_cop;
extern obj_t ccast_cgen_cop;
static obj_t _get_current_bdb_loc_57_cgen_emit_cop_239(obj_t);
extern obj_t cswitch_cgen_cop;
extern obj_t cgoto_cgen_cop;
extern obj_t module_initialization_70_cgen_emit_cop_239(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_tools(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_ast_env(long, char *);
extern obj_t module_initialization_70_cgen_emit(long, char *);
extern obj_t module_initialization_70_cgen_cop(long, char *);
extern obj_t module_initialization_70_module_module(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_numbers_6_5(long, char *);
extern obj_t module_initialization_70___r4_numbers_6_5_fixnum(long, char *);
extern obj_t module_initialization_70___r4_vectors_6_8(long, char *);
extern obj_t module_initialization_70___r4_output_6_10_3(long, char *);
static obj_t emit_bdb_loc_comment_217_cgen_emit_cop_239(obj_t);
extern obj_t cbox_set__132_cgen_cop;
extern obj_t clabel_cgen_cop;
extern obj_t csetq_cgen_cop;
extern obj_t bdb_block_21_cgen_cop;
extern obj_t list__vector_101___r4_vectors_6_8(obj_t);
extern obj_t stop_cgen_cop;
extern obj_t display_2_122___r4_output_6_10_3(obj_t, obj_t);
extern obj_t _real__144_type_cache;
static obj_t _emit_cop2265_119_cgen_emit_cop_239(obj_t, obj_t);
static obj_t imported_modules_init_94_cgen_emit_cop_239();
static bool_t emit_cop_default1681_202_cgen_emit_cop_239(cop_bglt);
extern obj_t cfun_ast_var;
extern obj_t add_generic__110___object(obj_t, obj_t);
extern obj_t cif_cgen_cop;
static obj_t _emit_bdb_loc_198_cgen_emit_cop_239(obj_t, obj_t);
extern obj_t creturn_cgen_cop;
extern obj_t get_current_bdb_loc_105_cgen_emit_cop_239();
static obj_t library_modules_init_112_cgen_emit_cop_239();
extern obj_t rgc_buffer_substring(obj_t, int, int);
static obj_t _anonymous_2020__85_cgen_emit_cop_239(obj_t, obj_t);
static obj_t toplevel_init_63_cgen_emit_cop_239();
extern bool_t emit_cop_45_cgen_emit_cop_239(cop_bglt);
extern obj_t capp_cgen_cop;
extern obj_t open_input_string(obj_t);
extern obj_t cvoid_cgen_cop;
extern obj_t cmake_box_177_cgen_cop;
extern char *integer__string_135___r4_numbers_6_5_fixnum(long, obj_t);
extern obj_t string_to_bstring(char *);
extern obj_t _module_location__208_module_module;
extern obj_t csequence_cgen_cop;
extern obj_t cfail_cgen_cop;
extern obj_t make_string(long, unsigned char);
extern obj_t string__number_104___r4_numbers_6_5(obj_t, obj_t);
extern obj_t c_substring(obj_t, long, long);
extern obj_t cset_ex_it_123_cgen_cop;
extern obj_t _classes__134___object;
extern obj_t read___reader(obj_t);
extern obj_t _char__84_type_cache;
static obj_t require_initialization_114_cgen_emit_cop_239 = BUNSPEC;
extern obj_t string_for_read(obj_t);
extern obj_t capply_cgen_cop;
static obj_t cnst_init_137_cgen_emit_cop_239();
extern obj_t cfuncall_cgen_cop;
extern obj_t _bool__149_type_cache;
static obj_t __cnst[8];

DEFINE_STATIC_PROCEDURE(emit_cop_default1681_env_69_cgen_emit_cop_239, _emit_cop_default1681_212_cgen_emit_cop_2392327, _emit_cop_default1681_212_cgen_emit_cop_239, 0L, 1);
DEFINE_EXPORT_PROCEDURE(get_current_bdb_loc_env_166_cgen_emit_cop_239, _get_current_bdb_loc_57_cgen_emit_cop_2392328, _get_current_bdb_loc_57_cgen_emit_cop_239, 0L, 0);
DEFINE_EXPORT_PROCEDURE(reset_bdb_loc__env_152_cgen_emit_cop_239, _reset_bdb_loc__118_cgen_emit_cop_2392329, _reset_bdb_loc__118_cgen_emit_cop_239, 0L, 0);
DEFINE_EXPORT_PROCEDURE(emit_bdb_loc_env_130_cgen_emit_cop_239, _emit_bdb_loc_198_cgen_emit_cop_2392330, _emit_bdb_loc_198_cgen_emit_cop_239, 0L, 1);
DEFINE_EXPORT_GENERIC(emit_cop_env_125_cgen_emit_cop_239, _emit_cop2265_119_cgen_emit_cop_2392331, _emit_cop2265_119_cgen_emit_cop_239, 0L, 1);
DEFINE_STRING(string2322_cgen_emit_cop_239, string2322_cgen_emit_cop_2392332, "EMIT-COP-DEFAULT1681 ELSE FOREIGN BFALSE LIGHT ELIGHT BIGLOO LOCATION ", 70);
DEFINE_STRING(string2321_cgen_emit_cop_239, string2321_cgen_emit_cop_2392333, "No method for this object", 25);
DEFINE_STRING(string2319_cgen_emit_cop_239, string2319_cgen_emit_cop_2392334, "regular-grammar", 15);
DEFINE_STRING(string2320_cgen_emit_cop_239, string2320_cgen_emit_cop_2392335, "Illegal match", 13);
DEFINE_STRING(string2318_cgen_emit_cop_239, string2318_cgen_emit_cop_2392336, "JUMP_EXIT( ", 11);
DEFINE_STRING(string2317_cgen_emit_cop_239, string2317_cgen_emit_cop_2392337, "} else {", 8);
DEFINE_STRING(string2316_cgen_emit_cop_239, string2316_cgen_emit_cop_2392338, "RESTORE_TRACE(); ", 17);
DEFINE_STRING(string2315_cgen_emit_cop_239, string2315_cgen_emit_cop_2392339, ") ) { ", 6);
DEFINE_STRING(string2314_cgen_emit_cop_239, string2314_cgen_emit_cop_2392340, "if( SET_EXIT(", 13);
DEFINE_STRING(string2313_cgen_emit_cop_239, string2313_cgen_emit_cop_2392341, "CELL_SET(", 9);
DEFINE_STRING(string2312_cgen_emit_cop_239, string2312_cgen_emit_cop_2392342, "CELL_REF(", 9);
DEFINE_STRING(string2311_cgen_emit_cop_239, string2311_cgen_emit_cop_2392343, "MAKE_CELL(", 10);
DEFINE_STRING(string2299_cgen_emit_cop_239, string2299_cgen_emit_cop_2392344, "PROCEDURE_L_ENTRY(", 18);
DEFINE_STRING(string2309_cgen_emit_cop_239, string2309_cgen_emit_cop_2392345, "case ", 5);
DEFINE_STRING(string2310_cgen_emit_cop_239, string2310_cgen_emit_cop_2392346, "break;", 6);
DEFINE_STRING(string2298_cgen_emit_cop_239, string2298_cgen_emit_cop_2392347, ")(", 2);
DEFINE_STRING(string2308_cgen_emit_cop_239, string2308_cgen_emit_cop_2392348, "default: ", 9);
DEFINE_STRING(string2297_cgen_emit_cop_239, string2297_cgen_emit_cop_2392349, "PROCEDURE_ENTRY(", 16);
DEFINE_STRING(string2307_cgen_emit_cop_239, string2307_cgen_emit_cop_2392350, ") { ", 4);
DEFINE_STRING(string2296_cgen_emit_cop_239, string2296_cgen_emit_cop_2392351, " )", 2);
DEFINE_STRING(string2306_cgen_emit_cop_239, string2306_cgen_emit_cop_2392352, "switch( ", 8);
DEFINE_STRING(string2295_cgen_emit_cop_239, string2295_cgen_emit_cop_2392353, " : ", 3);
DEFINE_STRING(string2305_cgen_emit_cop_239, string2305_cgen_emit_cop_2392354, "), exit( -1 );", 14);
DEFINE_STRING(string2294_cgen_emit_cop_239, string2294_cgen_emit_cop_2392355, " ) ? ", 5);
DEFINE_STRING(string2304_cgen_emit_cop_239, string2304_cgen_emit_cop_2392356, "the_failure(", 12);
DEFINE_STRING(string2293_cgen_emit_cop_239, string2293_cgen_emit_cop_2392357, "(VA_PROCUDUREP( ", 16);
DEFINE_STRING(string2303_cgen_emit_cop_239, string2303_cgen_emit_cop_2392358, ");", 2);
DEFINE_STRING(string2292_cgen_emit_cop_239, string2292_cgen_emit_cop_2392359, "int bigloo_dummy_bdb; bigloo_dummy_bdb = 0; { ", 46);
DEFINE_STRING(string2302_cgen_emit_cop_239, string2302_cgen_emit_cop_2392360, "FAILURE(", 8);
DEFINE_STRING(string2291_cgen_emit_cop_239, string2291_cgen_emit_cop_2392361, " = ((", 5);
DEFINE_STRING(string2301_cgen_emit_cop_239, string2301_cgen_emit_cop_2392362, "exit( -1 );", 11);
DEFINE_STRING(string2289_cgen_emit_cop_239, string2289_cgen_emit_cop_2392363, "", 0);
DEFINE_STRING(string2290_cgen_emit_cop_239, string2290_cgen_emit_cop_2392364, ")BUNSPEC)", 9);
DEFINE_STRING(string2300_cgen_emit_cop_239, string2300_cgen_emit_cop_2392365, "apply(", 6);
DEFINE_STRING(string2288_cgen_emit_cop_239, string2288_cgen_emit_cop_2392366, " else ", 6);
DEFINE_STRING(string2287_cgen_emit_cop_239, string2287_cgen_emit_cop_2392367, "if(", 3);
DEFINE_STRING(string2286_cgen_emit_cop_239, string2286_cgen_emit_cop_2392368, " = ", 3);
DEFINE_STRING(string2285_cgen_emit_cop_239, string2285_cgen_emit_cop_2392369, ", ", 2);
DEFINE_STRING(string2284_cgen_emit_cop_239, string2284_cgen_emit_cop_2392370, ") ", 2);
DEFINE_STRING(string2283_cgen_emit_cop_239, string2283_cgen_emit_cop_2392371, "( ", 2);
DEFINE_STRING(string2282_cgen_emit_cop_239, string2282_cgen_emit_cop_2392372, "return ", 7);
DEFINE_STRING(string2281_cgen_emit_cop_239, string2281_cgen_emit_cop_2392373, "} ", 2);
DEFINE_STRING(string2279_cgen_emit_cop_239, string2279_cgen_emit_cop_2392374, "{ ", 2);
DEFINE_STRING(string2280_cgen_emit_cop_239, string2280_cgen_emit_cop_2392375, "; ", 2);
DEFINE_STRING(string2278_cgen_emit_cop_239, string2278_cgen_emit_cop_2392376, "goto ", 5);
DEFINE_STRING(string2277_cgen_emit_cop_239, string2277_cgen_emit_cop_2392377, " */", 3);
DEFINE_STRING(string2276_cgen_emit_cop_239, string2276_cgen_emit_cop_2392378, " ", 1);
DEFINE_STRING(string2275_cgen_emit_cop_239, string2275_cgen_emit_cop_2392379, "/* ", 3);
DEFINE_STRING(string2274_cgen_emit_cop_239, string2274_cgen_emit_cop_2392380, " \"", 2);
DEFINE_STRING(string2273_cgen_emit_cop_239, string2273_cgen_emit_cop_2392381, "\n# ", 3);
DEFINE_STRING(string2272_cgen_emit_cop_239, string2272_cgen_emit_cop_2392382, "BCNST(", 6);
DEFINE_STRING(string2271_cgen_emit_cop_239, string2271_cgen_emit_cop_2392383, "BUNSPEC", 7);
DEFINE_STRING(string2269_cgen_emit_cop_239, string2269_cgen_emit_cop_2392384, "'\\000'", 6);
DEFINE_STRING(string2270_cgen_emit_cop_239, string2270_cgen_emit_cop_2392385, "\\''", 3);
DEFINE_STRING(string2268_cgen_emit_cop_239, string2268_cgen_emit_cop_2392386, ")", 1);
DEFINE_STRING(string2267_cgen_emit_cop_239, string2267_cgen_emit_cop_2392387, "BNIL", 4);
DEFINE_STRING(string2266_cgen_emit_cop_239, string2266_cgen_emit_cop_2392388, "((", 2);
DEFINE_EXPORT_PROCEDURE(untrigraph_env_176_cgen_emit_cop_239, _untrigraph2264_cgen_emit_cop_2392389, _untrigraph2264_cgen_emit_cop_239, 0L, 1);



/* module-initialization */
obj_t 
module_initialization_70_cgen_emit_cop_239(long checksum_2786, char *from_2787)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_cgen_emit_cop_239))
	{
	   require_initialization_114_cgen_emit_cop_239 =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_cgen_emit_cop_239();
	   cnst_init_137_cgen_emit_cop_239();
	   imported_modules_init_94_cgen_emit_cop_239();
	   method_init_76_cgen_emit_cop_239();
	   toplevel_init_63_cgen_emit_cop_239();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_cgen_emit_cop_239()
{
   AN_OBJECT;
   {	/* Cgen/emit-cop.scm 14 */
      module_initialization_70___object(((long) 0), "CGEN_EMIT-COP");
      module_initialization_70___r4_vectors_6_8(((long) 0), "CGEN_EMIT-COP");
      module_initialization_70___r4_output_6_10_3(((long) 0), "CGEN_EMIT-COP");
      module_initialization_70___r4_numbers_6_5_fixnum(((long) 0), "CGEN_EMIT-COP");
      module_initialization_70___r4_numbers_6_5(((long) 0), "CGEN_EMIT-COP");
      module_initialization_70___reader(((long) 0), "CGEN_EMIT-COP");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_cgen_emit_cop_239()
{
   AN_OBJECT;
   {	/* Cgen/emit-cop.scm 14 */
      {		/* Cgen/emit-cop.scm 14 */
	 obj_t cnst_port_138_2779;
	 cnst_port_138_2779 =
	    open_input_string(string2322_cgen_emit_cop_239);
	 {
	    long i_2780;
	    i_2780 = ((long) 7);
	  loop_2781:
	    {	/* Cgen/emit-cop.scm 14 */
	       bool_t test2323_2782;
	       test2323_2782 =
		  (i_2780 == ((long) -1));
	       if (test2323_2782)
		 {	/* Cgen/emit-cop.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Cgen/emit-cop.scm 14 */
		    {	/* Cgen/emit-cop.scm 14 */
		       obj_t arg2324_2783;
		       {	/* Cgen/emit-cop.scm 14 */
			  obj_t list2325_2784;
			  list2325_2784 =
			     MAKE_PAIR(cnst_port_138_2779, BNIL);
			  arg2324_2783 =
			     read___reader(list2325_2784);
		       }
		       CNST_TABLE_SET(i_2780, arg2324_2783);
		    }
		    {	/* Cgen/emit-cop.scm 14 */
		       int aux_2785;
		       {	/* Cgen/emit-cop.scm 14 */
			  long aux_2808;
			  aux_2808 =
			     (i_2780 - ((long) 1));
			  aux_2785 =
			     (int) (aux_2808);
		       }
		       {
			  long i_2811;
			  i_2811 =
			     (long) (aux_2785);
			  i_2780 = i_2811;
			  goto loop_2781;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_cgen_emit_cop_239()
{
   AN_OBJECT;
   {	/* Cgen/emit-cop.scm 14 */
      _bfalse__69_cgen_emit_cop_239 = BFALSE;
      return (
	 _bdb_loc__137_cgen_emit_cop_239 = BUNSPEC, BUNSPEC);
   }
}



/* emit-atom-value */
obj_t 
emit_atom_value_68_cgen_emit_cop_239(obj_t value_43)
{
   AN_OBJECT;
   {	/* Cgen/emit-cop.scm 576 */
      if (
	 BOOLEANP(value_43))
	{	/* Cgen/emit-cop.scm 578 */
	   display_2_122___r4_output_6_10_3(string2266_cgen_emit_cop_239, _c_port__188_cgen_emit);
	   {	/* Cgen/emit-cop.scm 580 */
	      obj_t arg1745_1035;
	      {		/* Cgen/emit-cop.scm 580 */
		 obj_t arg1746_1036;
		 {	/* Cgen/emit-cop.scm 580 */
		    type_bglt obj_2122;
		    obj_2122 =
		       (type_bglt) (_bool__149_type_cache);
		    arg1746_1036 =
		       (((type_bglt) CREF(obj_2122))->name);
		 }
		 arg1745_1035 =
		    string_sans___40_type_tools(arg1746_1036);
	      }
	      display_2_122___r4_output_6_10_3(arg1745_1035, _c_port__188_cgen_emit);
	   }
	   display_2_122___r4_output_6_10_3(
	      BCHAR(((unsigned char) ')')), _c_port__188_cgen_emit);
	   {	/* Cgen/emit-cop.scm 582 */
	      obj_t aux_2822;
	      {		/* Cgen/emit-cop.scm 582 */
		 long aux_2823;
		 if (
		    CBOOL(value_43))
		   {	/* Cgen/emit-cop.scm 582 */
		      aux_2823 = ((long) 1)
			 ;
		   }
		 else
		   {	/* Cgen/emit-cop.scm 582 */
		      aux_2823 = ((long) 0)
			 ;
		   }
		 aux_2822 =
		    BINT(aux_2823);
	      }
	      display_2_122___r4_output_6_10_3(aux_2822, _c_port__188_cgen_emit);
	   }
	   return
	      display_2_122___r4_output_6_10_3(
	      BCHAR(((unsigned char) ')')), _c_port__188_cgen_emit);
	}
      else
	{	/* Cgen/emit-cop.scm 578 */
	   if (
	      NULLP(value_43))
	     {	/* Cgen/emit-cop.scm 584 */
		return
		   display_2_122___r4_output_6_10_3(string2267_cgen_emit_cop_239, _c_port__188_cgen_emit);
	     }
	   else
	     {	/* Cgen/emit-cop.scm 584 */
		if (
		   CHARP(value_43))
		  {	/* Cgen/emit-cop.scm 586 */
		     display_2_122___r4_output_6_10_3(string2266_cgen_emit_cop_239, _c_port__188_cgen_emit);
		     {	/* Cgen/emit-cop.scm 588 */
			obj_t arg1750_1040;
			{	/* Cgen/emit-cop.scm 588 */
			   obj_t arg1751_1041;
			   {	/* Cgen/emit-cop.scm 588 */
			      type_bglt obj_2125;
			      obj_2125 =
				 (type_bglt) (_char__84_type_cache);
			      arg1751_1041 =
				 (((type_bglt) CREF(obj_2125))->name);
			   }
			   arg1750_1040 =
			      string_sans___40_type_tools(arg1751_1041);
			}
			display_2_122___r4_output_6_10_3(arg1750_1040, _c_port__188_cgen_emit);
		     }
		     display_2_122___r4_output_6_10_3(string2268_cgen_emit_cop_239, _c_port__188_cgen_emit);
		     {	/* Cgen/emit-cop.scm 590 */
			bool_t test_2841;
			{	/* ./Ieee/fixnum.scm 7109 */
			   long aux_2842;
			   {	/* ./Ieee/char.scm 7877 */
			      unsigned char aux_2843;
			      aux_2843 =
				 (unsigned char) CCHAR(value_43);
			      aux_2842 =
				 (aux_2843);
			   }
			   test_2841 =
			      (aux_2842 == ((long) 0));
			}
			if (test_2841)
			  {	/* Cgen/emit-cop.scm 590 */
			     display_2_122___r4_output_6_10_3(string2269_cgen_emit_cop_239, _c_port__188_cgen_emit);
			  }
			else
			  {	/* Cgen/emit-cop.scm 590 */
			     {	/* Cgen/emit-cop.scm 593 */
				obj_t port_2130;
				port_2130 = _c_port__188_cgen_emit;
				WRITE_CHAR(((unsigned char) '\''), port_2130);
			     }
			     {	/* Cgen/emit-cop.scm 594 */
				bool_t test_2849;
				{	/* ./Ieee/fixnum.scm 7109 */
				   long aux_2850;
				   {	/* ./Ieee/char.scm 7877 */
				      unsigned char aux_2851;
				      aux_2851 =
					 (unsigned char) CCHAR(value_43);
				      aux_2850 =
					 (aux_2851);
				   }
				   test_2849 =
				      (aux_2850 == ((long) 39));
				}
				if (test_2849)
				  {	/* Cgen/emit-cop.scm 594 */
				     display_2_122___r4_output_6_10_3(string2270_cgen_emit_cop_239, _c_port__188_cgen_emit);
				  }
				else
				  {	/* Cgen/emit-cop.scm 594 */
				     if (
					CHARP(value_43))
				       {	/* Cgen/emit-cop.scm 597 */
					  switch (
					     (unsigned char) CCHAR(value_43))
					    {
					    case ((unsigned char) '\r'):

					       {	/* Cgen/emit-cop.scm 599 */
						  obj_t port_2135;
						  port_2135 = _c_port__188_cgen_emit;
						  WRITE_CHAR(((unsigned char) '\\'), port_2135);
					       }
					       {	/* Cgen/emit-cop.scm 600 */
						  obj_t port_2137;
						  port_2137 = _c_port__188_cgen_emit;
						  WRITE_CHAR(((unsigned char) 'r'), port_2137);
					       }
					       break;
					    case ((unsigned char) '\t'):

					       {	/* Cgen/emit-cop.scm 602 */
						  obj_t port_2139;
						  port_2139 = _c_port__188_cgen_emit;
						  WRITE_CHAR(((unsigned char) '\\'), port_2139);
					       }
					       {	/* Cgen/emit-cop.scm 603 */
						  obj_t port_2141;
						  port_2141 = _c_port__188_cgen_emit;
						  WRITE_CHAR(((unsigned char) 't'), port_2141);
					       }
					       break;
					    case ((unsigned char) '\n'):

					       {	/* Cgen/emit-cop.scm 605 */
						  obj_t port_2143;
						  port_2143 = _c_port__188_cgen_emit;
						  WRITE_CHAR(((unsigned char) '\\'), port_2143);
					       }
					       {	/* Cgen/emit-cop.scm 606 */
						  obj_t port_2145;
						  port_2145 = _c_port__188_cgen_emit;
						  WRITE_CHAR(((unsigned char) 'n'), port_2145);
					       }
					       break;
					    case ((unsigned char) '\\'):

					       {	/* Cgen/emit-cop.scm 608 */
						  obj_t port_2147;
						  port_2147 = _c_port__188_cgen_emit;
						  WRITE_CHAR(((unsigned char) '\\'), port_2147);
					       }
					       {	/* Cgen/emit-cop.scm 609 */
						  obj_t port_2149;
						  port_2149 = _c_port__188_cgen_emit;
						  WRITE_CHAR(((unsigned char) '\\'), port_2149);
					       }
					       break;
					    default:
					       {	/* Cgen/emit-cop.scm 611 */
						  obj_t port_2151;
						  port_2151 = _c_port__188_cgen_emit;
						  {	/* ./Ieee/output.scm 9414 */
						     unsigned char aux_2866;
						     aux_2866 =
							(unsigned char) CCHAR(value_43);
						     WRITE_CHAR(aux_2866, port_2151);
						  }
					       }
					    }
				       }
				     else
				       {	/* Cgen/emit-cop.scm 611 */
					  obj_t port_2153;
					  port_2153 = _c_port__188_cgen_emit;
					  {	/* ./Ieee/output.scm 9414 */
					     unsigned char aux_2871;
					     aux_2871 =
						(unsigned char) CCHAR(value_43);
					     WRITE_CHAR(aux_2871, port_2153);
					  }
				       }
				     {	/* Cgen/emit-cop.scm 612 */
					obj_t port_2157;
					port_2157 = _c_port__188_cgen_emit;
					{	/* ./Ieee/output.scm 9414 */
					   unsigned char aux_2874;
					   aux_2874 =
					      WRITE_CHAR(((unsigned char) '\''), port_2157);
					   BCHAR(aux_2874);
					}
				     }
				  }
			     }
			  }
		     }
		     {	/* Cgen/emit-cop.scm 613 */
			obj_t port_2159;
			port_2159 = _c_port__188_cgen_emit;
			{	/* ./Ieee/output.scm 9414 */
			   unsigned char aux_2877;
			   aux_2877 =
			      WRITE_CHAR(((unsigned char) ')'), port_2159);
			   return
			      BCHAR(aux_2877);
			}
		     }
		  }
		else
		  {	/* Cgen/emit-cop.scm 586 */
		     if (
			(value_43 == BUNSPEC))
		       {	/* Cgen/emit-cop.scm 614 */
			  return
			     display_2_122___r4_output_6_10_3(string2271_cgen_emit_cop_239, _c_port__188_cgen_emit);
		       }
		     else
		       {	/* Cgen/emit-cop.scm 614 */
			  if (
			     CNSTP(value_43))
			    {	/* Cgen/emit-cop.scm 616 */
			       display_2_122___r4_output_6_10_3(string2272_cgen_emit_cop_239, _c_port__188_cgen_emit);
			       {	/* Cgen/emit-cop.scm 618 */
				  long arg1762_1053;
				  arg1762_1053 =
				     CCNST(value_43);
				  display_2_122___r4_output_6_10_3(
				     BINT(arg1762_1053), _c_port__188_cgen_emit);
			       }
			       return
				  display_2_122___r4_output_6_10_3(
				  BCHAR(((unsigned char) ')')), _c_port__188_cgen_emit);
			    }
			  else
			    {	/* Cgen/emit-cop.scm 616 */
			       if (
				  STRINGP(value_43))
				 {	/* Cgen/emit-cop.scm 620 */
				    display_2_122___r4_output_6_10_3(
				       BCHAR(((unsigned char) '"')), _c_port__188_cgen_emit);
				    {	/* Cgen/emit-cop.scm 622 */
				       obj_t arg1764_1055;
				       {	/* Cgen/emit-cop.scm 622 */
					  obj_t arg1765_1056;
					  arg1765_1056 =
					     string_for_read(value_43);
					  arg1764_1055 =
					     untrigraph_cgen_emit_cop_239(arg1765_1056);
				       }
				       display_2_122___r4_output_6_10_3(arg1764_1055, _c_port__188_cgen_emit);
				    }
				    return
				       display_2_122___r4_output_6_10_3(
				       BCHAR(((unsigned char) '"')), _c_port__188_cgen_emit);
				 }
			       else
				 {	/* Cgen/emit-cop.scm 620 */
				    if (
				       INTEGERP(value_43))
				      {		/* Cgen/emit-cop.scm 624 */
					 display_2_122___r4_output_6_10_3(string2266_cgen_emit_cop_239, _c_port__188_cgen_emit);
					 {	/* Cgen/emit-cop.scm 626 */
					    obj_t arg1767_1058;
					    {	/* Cgen/emit-cop.scm 626 */
					       obj_t arg1768_1059;
					       {	/* Cgen/emit-cop.scm 626 */
						  type_bglt obj_2166;
						  obj_2166 =
						     (type_bglt) (_long__149_type_cache);
						  arg1768_1059 =
						     (((type_bglt) CREF(obj_2166))->name);
					       }
					       arg1767_1058 =
						  string_sans___40_type_tools(arg1768_1059);
					    }
					    display_2_122___r4_output_6_10_3(arg1767_1058, _c_port__188_cgen_emit);
					 }
					 display_2_122___r4_output_6_10_3(string2268_cgen_emit_cop_239, _c_port__188_cgen_emit);
					 display_2_122___r4_output_6_10_3(value_43, _c_port__188_cgen_emit);
					 return
					    display_2_122___r4_output_6_10_3(string2268_cgen_emit_cop_239, _c_port__188_cgen_emit);
				      }
				    else
				      {		/* Cgen/emit-cop.scm 624 */
					 if (
					    REALP(value_43))
					   {	/* Cgen/emit-cop.scm 630 */
					      display_2_122___r4_output_6_10_3(string2266_cgen_emit_cop_239, _c_port__188_cgen_emit);
					      {		/* Cgen/emit-cop.scm 632 */
						 obj_t arg1770_1061;
						 {	/* Cgen/emit-cop.scm 632 */
						    obj_t arg1771_1062;
						    {	/* Cgen/emit-cop.scm 632 */
						       type_bglt obj_2168;
						       obj_2168 =
							  (type_bglt) (_real__144_type_cache);
						       arg1771_1062 =
							  (((type_bglt) CREF(obj_2168))->name);
						    }
						    arg1770_1061 =
						       string_sans___40_type_tools(arg1771_1062);
						 }
						 display_2_122___r4_output_6_10_3(arg1770_1061, _c_port__188_cgen_emit);
					      }
					      display_2_122___r4_output_6_10_3(string2268_cgen_emit_cop_239, _c_port__188_cgen_emit);
					      display_2_122___r4_output_6_10_3(value_43, _c_port__188_cgen_emit);
					      return
						 display_2_122___r4_output_6_10_3(string2268_cgen_emit_cop_239, _c_port__188_cgen_emit);
					   }
					 else
					   {	/* Cgen/emit-cop.scm 630 */
					      return
						 display_2_122___r4_output_6_10_3(value_43, _c_port__188_cgen_emit);
					   }
				      }
				 }
			    }
		       }
		  }
	     }
	}
   }
}



/* untrigraph */
obj_t 
untrigraph_cgen_emit_cop_239(obj_t from_44)
{
   AN_OBJECT;
   {	/* Cgen/emit-cop.scm 645 */
      {		/* Cgen/emit-cop.scm 646 */
	 long len_1063;
	 len_1063 =
	    STRING_LENGTH(from_44);
	 {	/* Cgen/emit-cop.scm 646 */
	    long len_3_234_1064;
	    len_3_234_1064 =
	       (len_1063 - ((long) 3));
	    {	/* Cgen/emit-cop.scm 647 */

	       {	/* Cgen/emit-cop.scm 649 */
		  long nb_col_224_1065;
		  {
		     long i_1122;
		     long nb_col_224_1123;
		     i_1122 = ((long) 0);
		     nb_col_224_1123 = ((long) 0);
		   loop_1124:
		     if (
			(i_1122 > len_3_234_1064))
		       {	/* Cgen/emit-cop.scm 652 */
			  nb_col_224_1065 = nb_col_224_1123;
		       }
		     else
		       {	/* Cgen/emit-cop.scm 654 */
			  bool_t test_2925;
			  {	/* ./Ieee/char.scm 7775 */
			     unsigned char aux_2926;
			     aux_2926 =
				STRING_REF(from_44, i_1122);
			     test_2925 =
				(aux_2926 == ((unsigned char) '?'));
			  }
			  if (test_2925)
			    {	/* Cgen/emit-cop.scm 656 */
			       bool_t test_2929;
			       {	/* ./Ieee/char.scm 7775 */
				  unsigned char aux_2930;
				  {	/* ./Ieee/string.scm 8089 */
				     long aux_2931;
				     aux_2931 =
					(i_1122 + ((long) 1));
				     aux_2930 =
					STRING_REF(from_44, aux_2931);
				  }
				  test_2929 =
				     (aux_2930 == ((unsigned char) '?'));
			       }
			       if (test_2929)
				 {	/* Cgen/emit-cop.scm 656 */
				    {
				       long nb_col_224_2937;
				       long i_2935;
				       i_2935 =
					  (i_1122 + ((long) 3));
				       nb_col_224_2937 =
					  (nb_col_224_1123 + ((long) 1));
				       nb_col_224_1123 = nb_col_224_2937;
				       i_1122 = i_2935;
				       goto loop_1124;
				    }
				 }
			       else
				 {	/* Cgen/emit-cop.scm 656 */
				    {
				       long i_2939;
				       i_2939 =
					  (i_1122 + ((long) 2));
				       i_1122 = i_2939;
				       goto loop_1124;
				    }
				 }
			    }
			  else
			    {	/* Cgen/emit-cop.scm 654 */
			       {
				  long i_2941;
				  i_2941 =
				     (i_1122 + ((long) 1));
				  i_1122 = i_2941;
				  goto loop_1124;
			       }
			    }
		       }
		  }
		  if (
		     (nb_col_224_1065 == ((long) 0)))
		    {	/* Cgen/emit-cop.scm 661 */
		       return from_44;
		    }
		  else
		    {	/* Cgen/emit-cop.scm 666 */
		       obj_t res_1067;
		       {	/* Cgen/emit-cop.scm 666 */
			  obj_t res2257_2206;
			  {	/* ./Ieee/string.scm 8054 */
			     long aux_2945;
			     {	/* ./Ieee/string.scm 8054 */
				int aux_2946;
				{	/* Cgen/emit-cop.scm 666 */
				   long aux_2947;
				   {	/* ./Ieee/fixnum.scm 7193 */
				      long aux_2948;
				      {		/* ./Ieee/fixnum.scm 7205 */
					 long aux_2949;
					 aux_2949 =
					    (nb_col_224_1065 * ((long) 3));
					 aux_2948 =
					    (((long) 3) * aux_2949);
				      }
				      aux_2947 =
					 (len_1063 + aux_2948);
				   }
				   aux_2946 =
				      (int) (aux_2947);
				}
				aux_2945 =
				   (long) (aux_2946);
			     }
			     res2257_2206 =
				make_string(aux_2945, ((unsigned char) ' '));
			  }
			  res_1067 = res2257_2206;
		       }
		       {
			  long r_1069;
			  long w_1070;
			  r_1069 = ((long) 0);
			  w_1070 = ((long) 0);
			loop_1071:
			  if (
			     (r_1069 == len_1063))
			    {	/* Cgen/emit-cop.scm 671 */
			       return res_1067;
			    }
			  else
			    {	/* Cgen/emit-cop.scm 673 */
			       bool_t test_2958;
			       {	/* Cgen/emit-cop.scm 673 */
				  bool_t test_2959;
				  {	/* ./Ieee/char.scm 7775 */
				     unsigned char aux_2960;
				     aux_2960 =
					STRING_REF(from_44, r_1069);
				     test_2959 =
					(aux_2960 == ((unsigned char) '?'));
				  }
				  if (test_2959)
				    {	/* Cgen/emit-cop.scm 673 */
				       test_2958 =
					  (r_1069 > len_3_234_1064)
					  ;
				    }
				  else
				    {	/* Cgen/emit-cop.scm 673 */
				       test_2958 = ((bool_t) 1)
					  ;
				    }
			       }
			       if (test_2958)
				 {	/* Cgen/emit-cop.scm 673 */
				    {	/* ./Ieee/string.scm 8095 */
				       unsigned char aux_2964;
				       aux_2964 =
					  STRING_REF(from_44, r_1069);
				       STRING_SET(res_1067, w_1070, aux_2964);
				    }
				    {
				       long w_2969;
				       long r_2967;
				       r_2967 =
					  (r_1069 + ((long) 1));
				       w_2969 =
					  (w_1070 + ((long) 1));
				       w_1070 = w_2969;
				       r_1069 = r_2967;
				       goto loop_1071;
				    }
				 }
			       else
				 {	/* Cgen/emit-cop.scm 677 */
				    bool_t test_2971;
				    {	/* ./Ieee/char.scm 7775 */
				       unsigned char aux_2972;
				       {	/* ./Ieee/string.scm 8089 */
					  long aux_2973;
					  aux_2973 =
					     (r_1069 + ((long) 1));
					  aux_2972 =
					     STRING_REF(from_44, aux_2973);
				       }
				       test_2971 =
					  (aux_2972 == ((unsigned char) '?'));
				    }
				    if (test_2971)
				      {		/* Cgen/emit-cop.scm 677 */
					 STRING_SET(res_1067, w_1070, ((unsigned char) '\\'));
					 {	/* ./Ieee/string.scm 8095 */
					    long aux_2978;
					    aux_2978 =
					       (w_1070 + ((long) 1));
					    STRING_SET(res_1067, aux_2978, ((unsigned char) '0'));
					 }
					 {	/* ./Ieee/string.scm 8095 */
					    long aux_2981;
					    aux_2981 =
					       (w_1070 + ((long) 2));
					    STRING_SET(res_1067, aux_2981, ((unsigned char) '7'));
					 }
					 {	/* ./Ieee/string.scm 8095 */
					    long aux_2984;
					    aux_2984 =
					       (w_1070 + ((long) 3));
					    STRING_SET(res_1067, aux_2984, ((unsigned char) '7'));
					 }
					 {	/* ./Ieee/string.scm 8095 */
					    long aux_2987;
					    aux_2987 =
					       (w_1070 + ((long) 4));
					    STRING_SET(res_1067, aux_2987, ((unsigned char) '\\'));
					 }
					 {	/* ./Ieee/string.scm 8095 */
					    long aux_2990;
					    aux_2990 =
					       (w_1070 + ((long) 5));
					    STRING_SET(res_1067, aux_2990, ((unsigned char) '0'));
					 }
					 {	/* ./Ieee/string.scm 8095 */
					    long aux_2993;
					    aux_2993 =
					       (w_1070 + ((long) 6));
					    STRING_SET(res_1067, aux_2993, ((unsigned char) '7'));
					 }
					 {	/* ./Ieee/string.scm 8095 */
					    long aux_2996;
					    aux_2996 =
					       (w_1070 + ((long) 7));
					    STRING_SET(res_1067, aux_2996, ((unsigned char) '7'));
					 }
					 {	/* ./Ieee/string.scm 8095 */
					    long aux_2999;
					    aux_2999 =
					       (w_1070 + ((long) 8));
					    STRING_SET(res_1067, aux_2999, ((unsigned char) '\\'));
					 }
					 {	/* Cgen/emit-cop.scm 692 */
					    char *code_1086;
					    {	/* Cgen/emit-cop.scm 693 */
					       long arg1802_1101;
					       {	/* ./Ieee/char.scm 7877 */
						  unsigned char aux_3002;
						  {	/* ./Ieee/string.scm 8089 */
						     long aux_3003;
						     aux_3003 =
							(r_1069 + ((long) 2));
						     aux_3002 =
							STRING_REF(from_44, aux_3003);
						  }
						  arg1802_1101 =
						     (aux_3002);
					       }
					       {	/* Cgen/emit-cop.scm 692 */
						  obj_t list1804_1103;
						  {	/* Cgen/emit-cop.scm 692 */
						     obj_t aux_3007;
						     aux_3007 =
							BINT(((long) 8));
						     list1804_1103 =
							MAKE_PAIR(aux_3007, BNIL);
						  }
						  code_1086 =
						     integer__string_135___r4_numbers_6_5_fixnum(arg1802_1101, list1804_1103);
					       }
					    }
					    {	/* Cgen/emit-cop.scm 695 */
					       bool_t test_3011;
					       {	/* ./Ieee/fixnum.scm 7109 */
						  long aux_3012;
						  {	/* ./Ieee/string.scm 8067 */
						     obj_t aux_3013;
						     aux_3013 =
							string_to_bstring(code_1086);
						     aux_3012 =
							STRING_LENGTH(aux_3013);
						  }
						  test_3011 =
						     (aux_3012 == ((long) 4));
					       }
					       if (test_3011)
						 {	/* Cgen/emit-cop.scm 695 */
						    {	/* ./Ieee/string.scm 8095 */
						       long aux_3017;
						       aux_3017 =
							  (w_1070 + ((long) 9));
						       STRING_SET(res_1067, aux_3017, ((unsigned char) '0'));
						    }
						    {	/* ./Ieee/string.scm 8095 */
						       unsigned char aux_3022;
						       long aux_3020;
						       {	/* ./Ieee/string.scm 8089 */
							  obj_t aux_3023;
							  aux_3023 =
							     string_to_bstring(code_1086);
							  aux_3022 =
							     STRING_REF(aux_3023, ((long) 2));
						       }
						       aux_3020 =
							  (w_1070 + ((long) 10));
						       STRING_SET(res_1067, aux_3020, aux_3022);
						    }
						    {	/* ./Ieee/string.scm 8095 */
						       unsigned char aux_3029;
						       long aux_3027;
						       {	/* ./Ieee/string.scm 8089 */
							  obj_t aux_3030;
							  aux_3030 =
							     string_to_bstring(code_1086);
							  aux_3029 =
							     STRING_REF(aux_3030, ((long) 3));
						       }
						       aux_3027 =
							  (w_1070 + ((long) 11));
						       STRING_SET(res_1067, aux_3027, aux_3029);
						    }
						 }
					       else
						 {	/* Cgen/emit-cop.scm 695 */
						    {	/* ./Ieee/string.scm 8095 */
						       unsigned char aux_3036;
						       long aux_3034;
						       {	/* ./Ieee/string.scm 8089 */
							  obj_t aux_3037;
							  aux_3037 =
							     string_to_bstring(code_1086);
							  aux_3036 =
							     STRING_REF(aux_3037, ((long) 2));
						       }
						       aux_3034 =
							  (w_1070 + ((long) 9));
						       STRING_SET(res_1067, aux_3034, aux_3036);
						    }
						    {	/* ./Ieee/string.scm 8095 */
						       unsigned char aux_3043;
						       long aux_3041;
						       {	/* ./Ieee/string.scm 8089 */
							  obj_t aux_3044;
							  aux_3044 =
							     string_to_bstring(code_1086);
							  aux_3043 =
							     STRING_REF(aux_3044, ((long) 3));
						       }
						       aux_3041 =
							  (w_1070 + ((long) 10));
						       STRING_SET(res_1067, aux_3041, aux_3043);
						    }
						    {	/* ./Ieee/string.scm 8095 */
						       unsigned char aux_3050;
						       long aux_3048;
						       {	/* ./Ieee/string.scm 8089 */
							  obj_t aux_3051;
							  aux_3051 =
							     string_to_bstring(code_1086);
							  aux_3050 =
							     STRING_REF(aux_3051, ((long) 4));
						       }
						       aux_3048 =
							  (w_1070 + ((long) 11));
						       STRING_SET(res_1067, aux_3048, aux_3050);
						    }
						 }
					    }
					 }
					 {
					    long w_3057;
					    long r_3055;
					    r_3055 =
					       (r_1069 + ((long) 3));
					    w_3057 =
					       (w_1070 + ((long) 12));
					    w_1070 = w_3057;
					    r_1069 = r_3055;
					    goto loop_1071;
					 }
				      }
				    else
				      {		/* Cgen/emit-cop.scm 677 */
					 STRING_SET(res_1067, w_1070, ((unsigned char) '?'));
					 {	/* ./Ieee/string.scm 8095 */
					    unsigned char aux_3062;
					    long aux_3060;
					    {	/* ./Ieee/string.scm 8089 */
					       long aux_3063;
					       aux_3063 =
						  (r_1069 + ((long) 1));
					       aux_3062 =
						  STRING_REF(from_44, aux_3063);
					    }
					    aux_3060 =
					       (w_1070 + ((long) 1));
					    STRING_SET(res_1067, aux_3060, aux_3062);
					 }
					 {
					    long w_3069;
					    long r_3067;
					    r_3067 =
					       (r_1069 + ((long) 2));
					    w_3069 =
					       (w_1070 + ((long) 2));
					    w_1070 = w_3069;
					    r_1069 = r_3067;
					    goto loop_1071;
					 }
				      }
				 }
			    }
		       }
		    }
	       }
	    }
	 }
      }
   }
}



/* _untrigraph2264 */
obj_t 
_untrigraph2264_cgen_emit_cop_239(obj_t env_2763, obj_t from_2764)
{
   AN_OBJECT;
   {	/* Cgen/emit-cop.scm 645 */
      return
	 untrigraph_cgen_emit_cop_239(from_2764);
   }
}



/* reset-bdb-loc! */
obj_t 
reset_bdb_loc__217_cgen_emit_cop_239()
{
   AN_OBJECT;
   {	/* Cgen/emit-cop.scm 721 */
      return (
	 _bdb_loc__137_cgen_emit_cop_239 = BUNSPEC, BUNSPEC);
   }
}



/* _reset-bdb-loc! */
obj_t 
_reset_bdb_loc__118_cgen_emit_cop_239(obj_t env_2765)
{
   AN_OBJECT;
   {	/* Cgen/emit-cop.scm 721 */
      return
	 reset_bdb_loc__217_cgen_emit_cop_239();
   }
}



/* get-current-bdb-loc */
obj_t 
get_current_bdb_loc_105_cgen_emit_cop_239()
{
   AN_OBJECT;
   {	/* Cgen/emit-cop.scm 727 */
      return _bdb_loc__137_cgen_emit_cop_239;
   }
}



/* _get-current-bdb-loc */
obj_t 
_get_current_bdb_loc_57_cgen_emit_cop_239(obj_t env_2766)
{
   AN_OBJECT;
   {	/* Cgen/emit-cop.scm 727 */
      return
	 get_current_bdb_loc_105_cgen_emit_cop_239();
   }
}



/* emit-bdb-loc */
obj_t 
emit_bdb_loc_8_cgen_emit_cop_239(obj_t cur_loc_243_45)
{
   AN_OBJECT;
   {	/* Cgen/emit-cop.scm 738 */
    emit_bdb_loc_8_cgen_emit_cop_239:
      {		/* Cgen/emit-cop.scm 740 */
	 bool_t test1836_1135;
	 {	/* Cgen/emit-cop.scm 740 */
	    bool_t test1842_1145;
	    {	/* Cgen/emit-cop.scm 740 */
	       long n1_2343;
	       n1_2343 =
		  (long) CINT(_bdb_debug__1_engine_param);
	       test1842_1145 =
		  (n1_2343 <= ((long) 0));
	    }
	    if (test1842_1145)
	      {		/* Cgen/emit-cop.scm 740 */
		 test1836_1135 = ((bool_t) 1);
	      }
	    else
	      {		/* Cgen/emit-cop.scm 740 */
		 test1836_1135 =
		    CBOOL(_bdb_debug_no_line_directives___59_engine_param);
	      }
	 }
	 if (test1836_1135)
	   {	/* Cgen/emit-cop.scm 740 */
	      {		/* Cgen/emit-cop.scm 741 */
		 obj_t port_2345;
		 port_2345 = _c_port__188_cgen_emit;
		 {	/* ./Ieee/output.scm 9332 */
		    unsigned char aux_3079;
		    aux_3079 =
		       WRITE_CHAR(((unsigned char) '\n'), port_2345);
		    return
		       BCHAR(aux_3079);
		 }
	      }
	   }
	 else
	   {	/* Cgen/emit-cop.scm 742 */
	      bool_t test_3082;
	      if (
		 STRUCTP(cur_loc_243_45))
		{	/* ./Ieee/equiv.scm 5508 */
		   obj_t aux_3087;
		   obj_t aux_3085;
		   aux_3087 =
		      CNST_TABLE_REF(((long) 0));
		   aux_3085 =
		      STRUCT_KEY(cur_loc_243_45);
		   test_3082 =
		      (aux_3085 == aux_3087);
		}
	      else
		{	/* ./Tools/location.sch 1019 */
		   test_3082 = ((bool_t) 0)
		      ;
		}
	      if (test_3082)
		{	/* Cgen/emit-cop.scm 742 */
		   {	/* Cgen/emit-cop.scm 755 */
		      obj_t cur_fname_227_1137;
		      obj_t cur_line_130_1138;
		      cur_fname_227_1137 =
			 STRUCT_REF(cur_loc_243_45, ((long) 0));
		      cur_line_130_1138 =
			 STRUCT_REF(cur_loc_243_45, ((long) 2));
		      {		/* Cgen/emit-cop.scm 757 */
			 obj_t port1679_1139;
			 port1679_1139 = _c_port__188_cgen_emit;
			 display_2_122___r4_output_6_10_3(string2273_cgen_emit_cop_239, port1679_1139);
			 display_2_122___r4_output_6_10_3(cur_line_130_1138, port1679_1139);
			 display_2_122___r4_output_6_10_3(string2274_cgen_emit_cop_239, port1679_1139);
			 display_2_122___r4_output_6_10_3(cur_fname_227_1137, port1679_1139);
			 display_2_122___r4_output_6_10_3(
			    BCHAR(((unsigned char) '"')), port1679_1139);
			 WRITE_CHAR(((unsigned char) '\n'), port1679_1139);
		      }
		      return (
			 _bdb_loc__137_cgen_emit_cop_239 = cur_loc_243_45, BUNSPEC);
		   }
		}
	      else
		{	/* Cgen/emit-cop.scm 742 */
		   {	/* Cgen/emit-cop.scm 744 */
		      bool_t test1838_1140;
		      {		/* Cgen/emit-cop.scm 744 */
			 obj_t o_2361;
			 o_2361 = _bdb_loc__137_cgen_emit_cop_239;
			 if (
			    STRUCTP(o_2361))
			   {	/* ./Ieee/equiv.scm 5508 */
			      obj_t aux_3103;
			      obj_t aux_3101;
			      aux_3103 =
				 CNST_TABLE_REF(((long) 0));
			      aux_3101 =
				 STRUCT_KEY(o_2361);
			      test1838_1140 =
				 (aux_3101 == aux_3103);
			   }
			 else
			   {	/* ./Tools/location.sch 1019 */
			      test1838_1140 = ((bool_t) 0);
			   }
		      }
		      if (test1838_1140)
			{	/* Cgen/emit-cop.scm 744 */
			   {
			      obj_t cur_loc_243_3107;
			      cur_loc_243_3107 = _bdb_loc__137_cgen_emit_cop_239;
			      cur_loc_243_45 = cur_loc_243_3107;
			      goto emit_bdb_loc_8_cgen_emit_cop_239;
			   }
			}
		      else
			{	/* Cgen/emit-cop.scm 746 */
			   bool_t test1839_1141;
			   {	/* Cgen/emit-cop.scm 746 */
			      obj_t o_2369;
			      o_2369 = _module_location__208_module_module;
			      if (
				 STRUCTP(o_2369))
				{	/* ./Ieee/equiv.scm 5508 */
				   obj_t aux_3112;
				   obj_t aux_3110;
				   aux_3112 =
				      CNST_TABLE_REF(((long) 0));
				   aux_3110 =
				      STRUCT_KEY(o_2369);
				   test1839_1141 =
				      (aux_3110 == aux_3112);
				}
			      else
				{	/* ./Tools/location.sch 1019 */
				   test1839_1141 = ((bool_t) 0);
				}
			   }
			   if (test1839_1141)
			     {	/* Cgen/emit-cop.scm 746 */
				{
				   obj_t cur_loc_243_3116;
				   cur_loc_243_3116 = _module_location__208_module_module;
				   cur_loc_243_45 = cur_loc_243_3116;
				   goto emit_bdb_loc_8_cgen_emit_cop_239;
				}
			     }
			   else
			     {	/* Cgen/emit-cop.scm 750 */
				bool_t test1840_1142;
				{	/* Cgen/emit-cop.scm 750 */
				   obj_t obj_2377;
				   obj_2377 = _src_files__222_engine_param;
				   test1840_1142 =
				      PAIRP(obj_2377);
				}
				if (test1840_1142)
				  {	/* Cgen/emit-cop.scm 750 */
				     {	/* Cgen/emit-cop.scm 753 */
					obj_t port1678_1143;
					port1678_1143 = _c_port__188_cgen_emit;
					display_2_122___r4_output_6_10_3(string2273_cgen_emit_cop_239, port1678_1143);
					display_2_122___r4_output_6_10_3(
					   BINT(((long) 1)), port1678_1143);
					display_2_122___r4_output_6_10_3(string2274_cgen_emit_cop_239, port1678_1143);
					{	/* Cgen/emit-cop.scm 753 */
					   obj_t arg1841_1144;
					   {	/* Cgen/emit-cop.scm 753 */
					      obj_t pair_2378;
					      pair_2378 = _src_files__222_engine_param;
					      arg1841_1144 =
						 CAR(pair_2378);
					   }
					   display_2_122___r4_output_6_10_3(arg1841_1144, port1678_1143);
					}
					display_2_122___r4_output_6_10_3(
					   BCHAR(((unsigned char) '"')), port1678_1143);
					{	/* ./Ieee/output.scm 9332 */
					   unsigned char aux_3127;
					   aux_3127 =
					      WRITE_CHAR(((unsigned char) '\n'), port1678_1143);
					   return
					      BCHAR(aux_3127);
					}
				     }
				  }
				else
				  {	/* Cgen/emit-cop.scm 750 */
				     return BFALSE;
				  }
			     }
			}
		   }
		}
	   }
      }
   }
}



/* _emit-bdb-loc */
obj_t 
_emit_bdb_loc_198_cgen_emit_cop_239(obj_t env_2767, obj_t cur_loc_243_2768)
{
   AN_OBJECT;
   {	/* Cgen/emit-cop.scm 738 */
      return
	 emit_bdb_loc_8_cgen_emit_cop_239(cur_loc_243_2768);
   }
}



/* emit-bdb-loc-comment */
obj_t 
emit_bdb_loc_comment_217_cgen_emit_cop_239(obj_t cur_loc_243_46)
{
   AN_OBJECT;
   {	/* Cgen/emit-cop.scm 766 */
      {		/* Cgen/emit-cop.scm 767 */
	 bool_t test_3131;
	 if (
	    STRUCTP(cur_loc_243_46))
	   {	/* ./Ieee/equiv.scm 5508 */
	      obj_t aux_3136;
	      obj_t aux_3134;
	      aux_3136 =
		 CNST_TABLE_REF(((long) 0));
	      aux_3134 =
		 STRUCT_KEY(cur_loc_243_46);
	      test_3131 =
		 (aux_3134 == aux_3136);
	   }
	 else
	   {	/* ./Tools/location.sch 1019 */
	      test_3131 = ((bool_t) 0)
		 ;
	   }
	 if (test_3131)
	   {	/* Cgen/emit-cop.scm 767 */
	      display_2_122___r4_output_6_10_3(string2275_cgen_emit_cop_239, _c_port__188_cgen_emit);
	      display_2_122___r4_output_6_10_3(
		 STRUCT_REF(cur_loc_243_46, ((long) 0)), _c_port__188_cgen_emit);
	      display_2_122___r4_output_6_10_3(string2276_cgen_emit_cop_239, _c_port__188_cgen_emit);
	      display_2_122___r4_output_6_10_3(
		 STRUCT_REF(cur_loc_243_46, ((long) 2)), _c_port__188_cgen_emit);
	      return
		 display_2_122___r4_output_6_10_3(string2277_cgen_emit_cop_239, _c_port__188_cgen_emit);
	   }
	 else
	   {	/* Cgen/emit-cop.scm 767 */
	      return BUNSPEC;
	   }
      }
   }
}



/* method-init */
obj_t 
method_init_76_cgen_emit_cop_239()
{
   AN_OBJECT;
   {	/* Cgen/emit-cop.scm 14 */
      add_generic__110___object(emit_cop_env_125_cgen_emit_cop_239, emit_cop_default1681_env_69_cgen_emit_cop_239);
      add_inlined_method__244___object(emit_cop_env_125_cgen_emit_cop_239, clabel_cgen_cop, ((long) 0));
      add_inlined_method__244___object(emit_cop_env_125_cgen_emit_cop_239, cgoto_cgen_cop, ((long) 1));
      add_inlined_method__244___object(emit_cop_env_125_cgen_emit_cop_239, block_cgen_cop, ((long) 2));
      add_inlined_method__244___object(emit_cop_env_125_cgen_emit_cop_239, creturn_cgen_cop, ((long) 3));
      add_inlined_method__244___object(emit_cop_env_125_cgen_emit_cop_239, catom_cgen_cop, ((long) 4));
      add_inlined_method__244___object(emit_cop_env_125_cgen_emit_cop_239, cvoid_cgen_cop, ((long) 5));
      add_inlined_method__244___object(emit_cop_env_125_cgen_emit_cop_239, varc_cgen_cop, ((long) 6));
      add_inlined_method__244___object(emit_cop_env_125_cgen_emit_cop_239, cpragma_cgen_cop, ((long) 7));
      add_inlined_method__244___object(emit_cop_env_125_cgen_emit_cop_239, ccast_cgen_cop, ((long) 8));
      add_inlined_method__244___object(emit_cop_env_125_cgen_emit_cop_239, csequence_cgen_cop, ((long) 9));
      add_inlined_method__244___object(emit_cop_env_125_cgen_emit_cop_239, nop_cgen_cop, ((long) 10));
      add_inlined_method__244___object(emit_cop_env_125_cgen_emit_cop_239, stop_cgen_cop, ((long) 11));
      add_inlined_method__244___object(emit_cop_env_125_cgen_emit_cop_239, csetq_cgen_cop, ((long) 12));
      add_inlined_method__244___object(emit_cop_env_125_cgen_emit_cop_239, cif_cgen_cop, ((long) 13));
      add_inlined_method__244___object(emit_cop_env_125_cgen_emit_cop_239, local_var_164_cgen_cop, ((long) 14));
      add_inlined_method__244___object(emit_cop_env_125_cgen_emit_cop_239, bdb_block_21_cgen_cop, ((long) 15));
      add_inlined_method__244___object(emit_cop_env_125_cgen_emit_cop_239, cfuncall_cgen_cop, ((long) 16));
      add_inlined_method__244___object(emit_cop_env_125_cgen_emit_cop_239, capply_cgen_cop, ((long) 17));
      add_inlined_method__244___object(emit_cop_env_125_cgen_emit_cop_239, capp_cgen_cop, ((long) 18));
      add_inlined_method__244___object(emit_cop_env_125_cgen_emit_cop_239, cfail_cgen_cop, ((long) 19));
      add_inlined_method__244___object(emit_cop_env_125_cgen_emit_cop_239, cswitch_cgen_cop, ((long) 20));
      add_inlined_method__244___object(emit_cop_env_125_cgen_emit_cop_239, cmake_box_177_cgen_cop, ((long) 21));
      add_inlined_method__244___object(emit_cop_env_125_cgen_emit_cop_239, cbox_ref_44_cgen_cop, ((long) 22));
      add_inlined_method__244___object(emit_cop_env_125_cgen_emit_cop_239, cbox_set__132_cgen_cop, ((long) 23));
      add_inlined_method__244___object(emit_cop_env_125_cgen_emit_cop_239, cset_ex_it_123_cgen_cop, ((long) 24));
      {		/* Cgen/emit-cop.scm 14 */
	 long aux_3172;
	 aux_3172 =
	    add_inlined_method__244___object(emit_cop_env_125_cgen_emit_cop_239, cjump_ex_it_131_cgen_cop, ((long) 25));
	 return
	    BINT(aux_3172);
      }
   }
}



/* emit-cop */
bool_t 
emit_cop_45_cgen_emit_cop_239(cop_bglt cop_15)
{
   AN_OBJECT;
   {	/* Cgen/emit-cop.scm 43 */
      {
	 obj_t method1981_1667;
	 obj_t class1986_1668;
	 {	/* Cgen/emit-cop.scm 43 */
	    obj_t arg1991_1665;
	    obj_t arg1992_1666;
	    {	/* Cgen/emit-cop.scm 43 */
	       object_bglt obj_2413;
	       obj_2413 =
		  (object_bglt) (cop_15);
	       {	/* ./Llib/object.scm 2926 */
		  obj_t pre_method_105_2414;
		  pre_method_105_2414 =
		     PROCEDURE_REF(emit_cop_env_125_cgen_emit_cop_239, ((long) 2));
		  if (
		     INTEGERP(pre_method_105_2414))
		    {	/* ./Llib/object.scm 2927 */
		       PROCEDURE_SET(emit_cop_env_125_cgen_emit_cop_239, ((long) 2), BUNSPEC);
		       arg1991_1665 = pre_method_105_2414;
		    }
		  else
		    {	/* ./Llib/object.scm 2914 */
		       long obj_class_num_177_2419;
		       obj_class_num_177_2419 =
			  TYPE(obj_2413);
		       {	/* ./Llib/object.scm 2915 */
			  obj_t arg1176_2420;
			  arg1176_2420 =
			     PROCEDURE_REF(emit_cop_env_125_cgen_emit_cop_239, ((long) 1));
			  {	/* ./Llib/object.scm 2738 */
			     long arg1177_2424;
			     {	/* ./Llib/object.scm 2738 */
				long arg1178_2425;
				arg1178_2425 =
				   OBJECT_TYPE;
				arg1177_2424 =
				   (obj_class_num_177_2419 - arg1178_2425);
			     }
			     arg1991_1665 =
				VECTOR_REF(arg1176_2420, arg1177_2424);
			  }
		       }
		    }
	       }
	    }
	    {	/* Cgen/emit-cop.scm 43 */
	       object_bglt object_2430;
	       object_2430 =
		  (object_bglt) (cop_15);
	       {	/* ./Llib/object.scm 2695 */
		  long arg1179_2431;
		  {	/* ./Llib/object.scm 2695 */
		     long arg1180_2432;
		     long arg1181_2433;
		     arg1180_2432 =
			TYPE(object_2430);
		     arg1181_2433 =
			OBJECT_TYPE;
		     arg1179_2431 =
			(arg1180_2432 - arg1181_2433);
		  }
		  {	/* ./Llib/object.scm 2695 */
		     obj_t vector_2437;
		     vector_2437 = _classes__134___object;
		     arg1992_1666 =
			VECTOR_REF(vector_2437, arg1179_2431);
		  }
	       }
	    }
	    {	/* Cgen/emit-cop.scm 43 */
	       obj_t aux_3190;
	       method1981_1667 = arg1991_1665;
	       class1986_1668 = arg1992_1666;
	       {

		  if (
		     INTEGERP(method1981_1667))
		    {	/* Cgen/emit-cop.scm 43 */
		       switch (
			  (long) CINT(method1981_1667))
			 {
			 case ((long) 0):

			    {	/* Cgen/emit-cop.scm 49 */
			       clabel_bglt cop_1674;
			       cop_1674 =
				  (clabel_bglt) (cop_15);
			       if (
				  (((clabel_bglt) CREF(cop_1674))->used__226))
				 {	/* Cgen/emit-cop.scm 50 */
				    emit_bdb_loc_8_cgen_emit_cop_239(
				       (((clabel_bglt) CREF(cop_1674))->loc));
				    display_2_122___r4_output_6_10_3(
				       (((clabel_bglt) CREF(cop_1674))->name), _c_port__188_cgen_emit);
				    {	/* Cgen/emit-cop.scm 54 */
				       obj_t port_2443;
				       port_2443 = _c_port__188_cgen_emit;
				       {	/* ./Ieee/output.scm 9414 */
					  unsigned char aux_3200;
					  aux_3200 =
					     WRITE_CHAR(((unsigned char) ':'), port_2443);
					  BCHAR(aux_3200);
				       }
				    }
				 }
			       else
				 {	/* Cgen/emit-cop.scm 50 */
				    BUNSPEC;
				 }
			       {	/* Cgen/emit-cop.scm 55 */
				  bool_t aux_3203;
				  {	/* Cgen/emit-cop.scm 55 */
				     cop_bglt aux_3204;
				     {	/* Cgen/emit-cop.scm 55 */
					obj_t aux_3205;
					aux_3205 =
					   (((clabel_bglt) CREF(cop_1674))->body);
					aux_3204 =
					   (cop_bglt) (aux_3205);
				     }
				     aux_3203 =
					emit_cop_45_cgen_emit_cop_239(aux_3204);
				  }
				  aux_3190 =
				     BBOOL(aux_3203);
			       }
			    }
			    break;
			 case ((long) 1):

			    {	/* Cgen/emit-cop.scm 61 */
			       cgoto_bglt cop_1680;
			       cop_1680 =
				  (cgoto_bglt) (cop_15);
			       emit_bdb_loc_8_cgen_emit_cop_239(
				  (((cgoto_bglt) CREF(cop_1680))->loc));
			       {	/* Cgen/emit-cop.scm 63 */
				  obj_t port1639_1683;
				  port1639_1683 = _c_port__188_cgen_emit;
				  display_2_122___r4_output_6_10_3(string2278_cgen_emit_cop_239, port1639_1683);
				  {	/* Cgen/emit-cop.scm 63 */
				     obj_t aux_3214;
				     {	/* Cgen/emit-cop.scm 63 */
					clabel_bglt arg2001_1685;
					arg2001_1685 =
					   (((cgoto_bglt) CREF(cop_1680))->label);
					aux_3214 =
					   (((clabel_bglt) CREF(arg2001_1685))->name);
				     }
				     display_2_122___r4_output_6_10_3(aux_3214, port1639_1683);
				  }
				  display_2_122___r4_output_6_10_3(
				     BCHAR(((unsigned char) ';')), port1639_1683);
			       }
			       aux_3190 = BFALSE;
			    }
			    break;
			 case ((long) 2):

			    {	/* Cgen/emit-cop.scm 70 */
			       block_bglt cop_1686;
			       cop_1686 =
				  (block_bglt) (cop_15);
			       emit_bdb_loc_8_cgen_emit_cop_239(
				  (((block_bglt) CREF(cop_1686))->loc));
			       {	/* Cgen/emit-cop.scm 72 */
				  bool_t test2003_1689;
				  {	/* ./Cgen/cop.scm 1837 */
				     obj_t aux_3223;
				     {	/* Cgen/emit-cop.scm 72 */
					cop_bglt aux_3224;
					aux_3224 =
					   (((block_bglt) CREF(cop_1686))->body);
					aux_3223 =
					   (obj_t) (aux_3224);
				     }
				     test2003_1689 =
					is_a__118___object(aux_3223, block_cgen_cop);
				  }
				  if (test2003_1689)
				    {	/* Cgen/emit-cop.scm 73 */
				       bool_t aux_3229;
				       aux_3229 =
					  emit_cop_45_cgen_emit_cop_239(
					  (((block_bglt) CREF(cop_1686))->body));
				       aux_3190 =
					  BBOOL(aux_3229);
				    }
				  else
				    {	/* Cgen/emit-cop.scm 72 */
				       display_2_122___r4_output_6_10_3(string2279_cgen_emit_cop_239, _c_port__188_cgen_emit);
				       emit_bdb_loc_comment_217_cgen_emit_cop_239(
					  (((block_bglt) CREF(cop_1686))->loc));
				       {	/* Cgen/emit-cop.scm 78 */
					  bool_t test2006_1692;
					  test2006_1692 =
					     emit_cop_45_cgen_emit_cop_239(
					     (((block_bglt) CREF(cop_1686))->body));
					  if (test2006_1692)
					    {	/* Cgen/emit-cop.scm 78 */
					       {	/* Cgen/emit-cop.scm 80 */
						  obj_t arg2007_1693;
						  arg2007_1693 = _bdb_loc__137_cgen_emit_cop_239;
						  emit_bdb_loc_8_cgen_emit_cop_239(arg2007_1693);
					       }
					       display_2_122___r4_output_6_10_3(string2280_cgen_emit_cop_239, _c_port__188_cgen_emit);
					       BUNSPEC;
					    }
					  else
					    {	/* Cgen/emit-cop.scm 78 */
					       BUNSPEC;
					    }
				       }
				       display_2_122___r4_output_6_10_3(string2281_cgen_emit_cop_239, _c_port__188_cgen_emit);
				       aux_3190 = BFALSE;
				    }
			       }
			    }
			    break;
			 case ((long) 3):

			    {	/* Cgen/emit-cop.scm 91 */
			       creturn_bglt cop_1696;
			       cop_1696 =
				  (creturn_bglt) (cop_15);
			       emit_bdb_loc_8_cgen_emit_cop_239(
				  (((creturn_bglt) CREF(cop_1696))->loc));
			       display_2_122___r4_output_6_10_3(string2282_cgen_emit_cop_239, _c_port__188_cgen_emit);
			       {	/* Cgen/emit-cop.scm 94 */
				  bool_t test2011_1699;
				  test2011_1699 =
				     emit_cop_45_cgen_emit_cop_239(
				     (((creturn_bglt) CREF(cop_1696))->value));
				  if (test2011_1699)
				    {	/* Cgen/emit-cop.scm 95 */
				       obj_t port_2457;
				       port_2457 = _c_port__188_cgen_emit;
				       {	/* ./Ieee/output.scm 9414 */
					  unsigned char aux_3249;
					  aux_3249 =
					     WRITE_CHAR(((unsigned char) ';'), port_2457);
					  BCHAR(aux_3249);
				       }
				    }
				  else
				    {	/* Cgen/emit-cop.scm 94 */
				       BUNSPEC;
				    }
			       }
			       aux_3190 = BFALSE;
			    }
			    break;
			 case ((long) 4):

			    {	/* Cgen/emit-cop.scm 102 */
			       catom_bglt cop_1701;
			       cop_1701 =
				  (catom_bglt) (cop_15);
			       emit_atom_value_68_cgen_emit_cop_239(
				  (((catom_bglt) CREF(cop_1701))->value));
			       aux_3190 = BTRUE;
			    }
			    break;
			 case ((long) 5):

			    {	/* Cgen/emit-cop.scm 110 */
			       cvoid_bglt cop_1704;
			       cop_1704 =
				  (cvoid_bglt) (cop_15);
			       {	/* Cgen/emit-cop.scm 111 */
				  bool_t aux_3256;
				  aux_3256 =
				     emit_cop_45_cgen_emit_cop_239(
				     (((cvoid_bglt) CREF(cop_1704))->value));
				  aux_3190 =
				     BBOOL(aux_3256);
			       }
			    }
			    break;
			 case ((long) 6):

			    {	/* Cgen/emit-cop.scm 117 */
			       varc_bglt cop_1707;
			       cop_1707 =
				  (varc_bglt) (cop_15);
			       {	/* Cgen/emit-cop.scm 118 */
				  obj_t aux_3261;
				  {	/* Cgen/emit-cop.scm 118 */
				     variable_bglt arg2016_1710;
				     arg2016_1710 =
					(((varc_bglt) CREF(cop_1707))->variable);
				     aux_3261 =
					(((variable_bglt) CREF(arg2016_1710))->name);
				  }
				  display_2_122___r4_output_6_10_3(aux_3261, _c_port__188_cgen_emit);
			       }
			       aux_3190 = BTRUE;
			    }
			    break;
			 case ((long) 7):

			    {	/* Cgen/emit-cop.scm 125 */
			       cpragma_bglt cop_1711;
			       cop_1711 =
				  (cpragma_bglt) (cop_15);
			       emit_bdb_loc_8_cgen_emit_cop_239(
				  (((cpragma_bglt) CREF(cop_1711))->loc));
			       {	/* Cgen/emit-cop.scm 127 */
				  bool_t test_3268;
				  {	/* ./Ieee/pair-list.scm 5912 */
				     obj_t aux_3269;
				     aux_3269 =
					(((cpragma_bglt) CREF(cop_1711))->args);
				     test_3268 =
					NULLP(aux_3269);
				  }
				  if (test_3268)
				    {	/* Cgen/emit-cop.scm 127 */
				       aux_3190 =
					  display_2_122___r4_output_6_10_3(
					  (((cpragma_bglt) CREF(cop_1711))->format), _c_port__188_cgen_emit)
					  ;
				    }
				  else
				    {	/* Cgen/emit-cop.scm 129 */
				       obj_t sport_1716;
				       {	/* ./Ieee/port.scm 8976 */
					  obj_t aux_3274;
					  aux_3274 =
					     (((cpragma_bglt) CREF(cop_1711))->format);
					  sport_1716 =
					     open_input_string(aux_3274);
				       }
				       {	/* Cgen/emit-cop.scm 129 */
					  obj_t args_1717;
					  args_1717 =
					     list__vector_101___r4_vectors_6_8(
					     (((cpragma_bglt) CREF(cop_1711))->args));
					  {	/* Cgen/emit-cop.scm 130 */
					     obj_t parser_1718;
					     {	/* Cgen/emit-cop.scm 131 */
						obj_t _anonymous_2020__85_2773;
						_anonymous_2020__85_2773 =
						   MAKE_EL_PROCEDURE_1(((long) 1));
						PROCEDURE_1_EL_SET(_anonymous_2020__85_2773, ((long) 0), args_1717);
						parser_1718 = _anonymous_2020__85_2773;
					     }
					     {	/* Cgen/emit-cop.scm 131 */

						_anonymous_2020__85_cgen_emit_cop_239(parser_1718, sport_1716);
						aux_3190 = BTRUE;
					     }
					  }
				       }
				    }
			       }
			    }
			    break;
			 case ((long) 8):

			    {	/* Cgen/emit-cop.scm 151 */
			       ccast_bglt cop_1855;
			       cop_1855 =
				  (ccast_bglt) (cop_15);
			       emit_bdb_loc_8_cgen_emit_cop_239(
				  (((ccast_bglt) CREF(cop_1855))->loc));
			       display_2_122___r4_output_6_10_3(string2266_cgen_emit_cop_239, _c_port__188_cgen_emit);
			       {	/* Cgen/emit-cop.scm 154 */
				  obj_t aux_3287;
				  {	/* Cgen/emit-cop.scm 154 */
				     type_bglt arg2088_1859;
				     arg2088_1859 =
					(((ccast_bglt) CREF(cop_1855))->type);
				     aux_3287 =
					(((type_bglt) CREF(arg2088_1859))->name);
				  }
				  display_2_122___r4_output_6_10_3(aux_3287, _c_port__188_cgen_emit);
			       }
			       {	/* Cgen/emit-cop.scm 155 */
				  obj_t port_2549;
				  port_2549 = _c_port__188_cgen_emit;
				  WRITE_CHAR(((unsigned char) ')'), port_2549);
			       }
			       emit_cop_45_cgen_emit_cop_239(
				  (((ccast_bglt) CREF(cop_1855))->arg));
			       {	/* Cgen/emit-cop.scm 157 */
				  obj_t port_2552;
				  port_2552 = _c_port__188_cgen_emit;
				  WRITE_CHAR(((unsigned char) ')'), port_2552);
			       }
			       aux_3190 = BTRUE;
			    }
			    break;
			 case ((long) 9):

			    {	/* Cgen/emit-cop.scm 164 */
			       csequence_bglt cop_1861;
			       cop_1861 =
				  (csequence_bglt) (cop_15);
			       if (
				  (((csequence_bglt) CREF(cop_1861))->c_exp__163))
				 {	/* Cgen/emit-cop.scm 165 */
				    {	/* Cgen/emit-cop.scm 167 */
				       bool_t test_3298;
				       {	/* ./Ieee/pair-list.scm 5912 */
					  obj_t aux_3299;
					  aux_3299 =
					     (((csequence_bglt) CREF(cop_1861))->cops);
					  test_3298 =
					     NULLP(aux_3299);
				       }
				       if (test_3298)
					 {	/* Cgen/emit-cop.scm 167 */
					    aux_3190 =
					       emit_atom_value_68_cgen_emit_cop_239(BUNSPEC)
					       ;
					 }
				       else
					 {	/* Cgen/emit-cop.scm 167 */
					    display_2_122___r4_output_6_10_3(string2283_cgen_emit_cop_239, _c_port__188_cgen_emit);
					    {
					       obj_t exp_1865;
					       {	/* Cgen/emit-cop.scm 172 */
						  bool_t aux_3304;
						  exp_1865 =
						     (((csequence_bglt) CREF(cop_1861))->cops);
						liip_1866:
						  {	/* Cgen/emit-cop.scm 173 */
						     bool_t test_3305;
						     {	/* ./Ieee/pair-list.scm 5912 */
							obj_t aux_3306;
							aux_3306 =
							   CDR(exp_1865);
							test_3305 =
							   NULLP(aux_3306);
						     }
						     if (test_3305)
						       {	/* Cgen/emit-cop.scm 173 */
							  {	/* Cgen/emit-cop.scm 175 */
							     cop_bglt aux_3309;
							     {	/* Cgen/emit-cop.scm 175 */
								obj_t aux_3310;
								aux_3310 =
								   CAR(exp_1865);
								aux_3309 =
								   (cop_bglt) (aux_3310);
							     }
							     emit_cop_45_cgen_emit_cop_239(aux_3309);
							  }
							  display_2_122___r4_output_6_10_3(string2284_cgen_emit_cop_239, _c_port__188_cgen_emit);
							  aux_3304 = ((bool_t) 1);
						       }
						     else
						       {	/* Cgen/emit-cop.scm 173 */
							  {	/* Cgen/emit-cop.scm 180 */
							     cop_bglt aux_3315;
							     {	/* Cgen/emit-cop.scm 180 */
								obj_t aux_3316;
								aux_3316 =
								   CAR(exp_1865);
								aux_3315 =
								   (cop_bglt) (aux_3316);
							     }
							     emit_cop_45_cgen_emit_cop_239(aux_3315);
							  }
							  {	/* Cgen/emit-cop.scm 181 */
							     bool_t test2097_1871;
							     test2097_1871 =
								is_a__118___object(
								CAR(exp_1865), cfail_cgen_cop);
							     if (test2097_1871)
							       {	/* Cgen/emit-cop.scm 181 */
								  display_2_122___r4_output_6_10_3(string2284_cgen_emit_cop_239, _c_port__188_cgen_emit);
								  aux_3304 = ((bool_t) 1);
							       }
							     else
							       {	/* Cgen/emit-cop.scm 181 */
								  display_2_122___r4_output_6_10_3(string2285_cgen_emit_cop_239, _c_port__188_cgen_emit);
								  {
								     obj_t exp_3325;
								     exp_3325 =
									CDR(exp_1865);
								     exp_1865 = exp_3325;
								     goto liip_1866;
								  }
							       }
							  }
						       }
						  }
						  aux_3190 =
						     BBOOL(aux_3304);
					       }
					    }
					 }
				    }
				 }
			       else
				 {
				    obj_t exp_1876;
				    {	/* Cgen/emit-cop.scm 190 */
				       bool_t aux_3329;
				       exp_1876 =
					  (((csequence_bglt) CREF(cop_1861))->cops);
				     liip_1877:
				       if (
					  NULLP(exp_1876))
					 {	/* Cgen/emit-cop.scm 191 */
					    aux_3329 = ((bool_t) 0)
					       ;
					 }
				       else
					 {	/* Cgen/emit-cop.scm 193 */
					    obj_t e_1880;
					    e_1880 =
					       CAR(exp_1876);
					    {	/* Cgen/emit-cop.scm 194 */
					       bool_t test2105_1881;
					       test2105_1881 =
						  emit_cop_45_cgen_emit_cop_239(
						  (cop_bglt) (e_1880));
					       if (test2105_1881)
						 {	/* Cgen/emit-cop.scm 194 */
						    display_2_122___r4_output_6_10_3(string2280_cgen_emit_cop_239, _c_port__188_cgen_emit);
						    BUNSPEC;
						 }
					       else
						 {	/* Cgen/emit-cop.scm 194 */
						    BUNSPEC;
						 }
					    }
					    {	/* Cgen/emit-cop.scm 199 */
					       bool_t test2106_1882;
					       test2106_1882 =
						  is_a__118___object(e_1880, cfail_cgen_cop);
					       if (test2106_1882)
						 {
						    obj_t exp_3339;
						    exp_3339 = BNIL;
						    exp_1876 = exp_3339;
						    goto liip_1877;
						 }
					       else
						 {
						    obj_t exp_3340;
						    exp_3340 =
						       CDR(exp_1876);
						    exp_1876 = exp_3340;
						    goto liip_1877;
						 }
					    }
					 }
				       aux_3190 =
					  BBOOL(aux_3329);
				    }
				 }
			    }
			    break;
			 case ((long) 10):

			    display_2_122___r4_output_6_10_3(string2280_cgen_emit_cop_239, _c_port__188_cgen_emit);
			    aux_3190 = BFALSE;
			    break;
			 case ((long) 11):

			    {	/* Cgen/emit-cop.scm 216 */
			       stop_bglt cop_1886;
			       cop_1886 =
				  (stop_bglt) (cop_15);
			       {	/* Cgen/emit-cop.scm 217 */
				  bool_t test2108_1888;
				  test2108_1888 =
				     emit_cop_45_cgen_emit_cop_239(
				     (((stop_bglt) CREF(cop_1886))->value));
				  if (test2108_1888)
				    {	/* Cgen/emit-cop.scm 217 */
				       display_2_122___r4_output_6_10_3(string2280_cgen_emit_cop_239, _c_port__188_cgen_emit);
				       BUNSPEC;
				    }
				  else
				    {	/* Cgen/emit-cop.scm 217 */
				       BUNSPEC;
				    }
			       }
			       aux_3190 = BFALSE;
			    }
			    break;
			 case ((long) 12):

			    {	/* Cgen/emit-cop.scm 229 */
			       csetq_bglt cop_1890;
			       cop_1890 =
				  (csetq_bglt) (cop_15);
			       emit_bdb_loc_8_cgen_emit_cop_239(
				  (((csetq_bglt) CREF(cop_1890))->loc));
			       {	/* Cgen/emit-cop.scm 232 */
				  cop_bglt aux_3353;
				  {	/* Cgen/emit-cop.scm 232 */
				     varc_bglt aux_3354;
				     aux_3354 =
					(((csetq_bglt) CREF(cop_1890))->var);
				     aux_3353 =
					(cop_bglt) (aux_3354);
				  }
				  emit_cop_45_cgen_emit_cop_239(aux_3353);
			       }
			       display_2_122___r4_output_6_10_3(string2286_cgen_emit_cop_239, _c_port__188_cgen_emit);
			       emit_cop_45_cgen_emit_cop_239(
				  (((csetq_bglt) CREF(cop_1890))->value));
			       aux_3190 = BTRUE;
			    }
			    break;
			 case ((long) 13):

			    {	/* Cgen/emit-cop.scm 243 */
			       cif_bglt cop_1895;
			       cop_1895 =
				  (cif_bglt) (cop_15);
			       emit_bdb_loc_8_cgen_emit_cop_239(
				  (((cif_bglt) CREF(cop_1895))->loc));
			       display_2_122___r4_output_6_10_3(string2287_cgen_emit_cop_239, _c_port__188_cgen_emit);
			       emit_cop_45_cgen_emit_cop_239(
				  (((cif_bglt) CREF(cop_1895))->test));
			       {	/* Cgen/emit-cop.scm 247 */
				  obj_t port_2576;
				  port_2576 = _c_port__188_cgen_emit;
				  WRITE_CHAR(((unsigned char) ')'), port_2576);
			       }
			       emit_cop_45_cgen_emit_cop_239(
				  (((cif_bglt) CREF(cop_1895))->true));
			       display_2_122___r4_output_6_10_3(string2288_cgen_emit_cop_239, _c_port__188_cgen_emit);
			       {	/* Cgen/emit-cop.scm 250 */
				  bool_t aux_3371;
				  aux_3371 =
				     emit_cop_45_cgen_emit_cop_239(
				     (((cif_bglt) CREF(cop_1895))->false));
				  aux_3190 =
				     BBOOL(aux_3371);
			       }
			    }
			    break;
			 case ((long) 14):

			    {	/* Cgen/emit-cop.scm 256 */
			       local_var_164_bglt cop_1901;
			       cop_1901 =
				  (local_var_164_bglt) (cop_15);
			       emit_bdb_loc_8_cgen_emit_cop_239(
				  (((local_var_164_bglt) CREF(cop_1901))->loc));
			       {
				  obj_t l1661_1904;
				  l1661_1904 =
				     (((local_var_164_bglt) CREF(cop_1901))->vars);
				lname1662_1905:
				  if (
				     PAIRP(l1661_1904))
				    {	/* Cgen/emit-cop.scm 258 */
				       {	/* Cgen/emit-cop.scm 259 */
					  obj_t local_1908;
					  local_1908 =
					     CAR(l1661_1904);
					  {	/* Cgen/emit-cop.scm 259 */
					     obj_t port1663_1909;
					     port1663_1909 = _c_port__188_cgen_emit;
					     {	/* Cgen/emit-cop.scm 260 */
						obj_t arg2120_1910;
						{	/* Cgen/emit-cop.scm 260 */
						   obj_t aux_3384;
						   type_bglt aux_3381;
						   {	/* Cgen/emit-cop.scm 261 */
						      local_bglt obj_2584;
						      obj_2584 =
							 (local_bglt) (local_1908);
						      aux_3384 =
							 (((local_bglt) CREF(obj_2584))->name);
						   }
						   {	/* Cgen/emit-cop.scm 260 */
						      local_bglt obj_2583;
						      obj_2583 =
							 (local_bglt) (local_1908);
						      aux_3381 =
							 (((local_bglt) CREF(obj_2583))->type);
						   }
						   arg2120_1910 =
						      make_typed_declaration_180_type_tools(aux_3381, aux_3384);
						}
						display_2_122___r4_output_6_10_3(arg2120_1910, port1663_1909);
					     }
					     {	/* Cgen/emit-cop.scm 262 */
						obj_t arg2124_1913;
						{	/* Cgen/emit-cop.scm 262 */
						   bool_t test2125_1914;
						   {	/* Cgen/emit-cop.scm 262 */
						      bool_t test2133_1921;
						      {		/* Cgen/emit-cop.scm 262 */
							 long n1_2585;
							 n1_2585 =
							    (long) CINT(_bdb_debug__1_engine_param);
							 test2133_1921 =
							    (n1_2585 > ((long) 0));
						      }
						      if (test2133_1921)
							{	/* ./Ieee/equiv.scm 5508 */
							   obj_t aux_3396;
							   obj_t aux_3392;
							   aux_3396 =
							      CNST_TABLE_REF(((long) 1));
							   {	/* Cgen/emit-cop.scm 263 */
							      type_bglt arg2136_1924;
							      {		/* Cgen/emit-cop.scm 263 */
								 local_bglt obj_2587;
								 obj_2587 =
								    (local_bglt) (local_1908);
								 arg2136_1924 =
								    (((local_bglt) CREF(obj_2587))->type);
							      }
							      aux_3392 =
								 (((type_bglt) CREF(arg2136_1924))->class);
							   }
							   test2125_1914 =
							      (aux_3392 == aux_3396);
							}
						      else
							{	/* Cgen/emit-cop.scm 262 */
							   test2125_1914 = ((bool_t) 0);
							}
						   }
						   if (test2125_1914)
						     {	/* Cgen/emit-cop.scm 265 */
							obj_t arg2127_1916;
							{	/* Cgen/emit-cop.scm 267 */
							   obj_t arg2128_1917;
							   {	/* Cgen/emit-cop.scm 266 */
							      type_bglt aux_3400;
							      {		/* Cgen/emit-cop.scm 267 */
								 local_bglt obj_2591;
								 obj_2591 =
								    (local_bglt) (local_1908);
								 aux_3400 =
								    (((local_bglt) CREF(obj_2591))->type);
							      }
							      arg2128_1917 =
								 make_typed_declaration_180_type_tools(aux_3400, string2289_cgen_emit_cop_239);
							   }
							   arg2127_1916 =
							      string_append(arg2128_1917, string2290_cgen_emit_cop_239);
							}
							arg2124_1913 =
							   string_append(string2291_cgen_emit_cop_239, arg2127_1916);
						     }
						   else
						     {	/* Cgen/emit-cop.scm 262 */
							arg2124_1913 = string2289_cgen_emit_cop_239;
						     }
						}
						display_2_122___r4_output_6_10_3(arg2124_1913, port1663_1909);
					     }
					     display_2_122___r4_output_6_10_3(
						BCHAR(((unsigned char) ';')), port1663_1909);
					  }
				       }
				       {
					  obj_t l1661_3409;
					  l1661_3409 =
					     CDR(l1661_1904);
					  l1661_1904 = l1661_3409;
					  goto lname1662_1905;
				       }
				    }
				  else
				    {	/* Cgen/emit-cop.scm 258 */
				       ((bool_t) 1);
				    }
			       }
			       aux_3190 = BFALSE;
			    }
			    break;
			 case ((long) 15):

			    {	/* Cgen/emit-cop.scm 279 */
			       bdb_block_21_bglt cop_1926;
			       cop_1926 =
				  (bdb_block_21_bglt) (cop_15);
			       emit_bdb_loc_8_cgen_emit_cop_239(
				  (((bdb_block_21_bglt) CREF(cop_1926))->loc));
			       {	/* Cgen/emit-cop.scm 281 */
				  obj_t port1665_1929;
				  port1665_1929 = _c_port__188_cgen_emit;
				  display_2_122___r4_output_6_10_3(string2292_cgen_emit_cop_239, port1665_1929);
			       }
			       emit_cop_45_cgen_emit_cop_239(
				  (((bdb_block_21_bglt) CREF(cop_1926))->body));
			       display_2_122___r4_output_6_10_3(string2281_cgen_emit_cop_239, _c_port__188_cgen_emit);
			       aux_3190 = BUNSPEC;
			    }
			    break;
			 case ((long) 16):

			    {	/* Cgen/emit-cop.scm 290 */
			       cfuncall_bglt cop_1931;
			       cop_1931 =
				  (cfuncall_bglt) (cop_15);
			       {
				  cfuncall_bglt cop_1932;
				  cfuncall_bglt cop_1934;
				  cfuncall_bglt cop_1938;
				  cfuncall_bglt cop_1940;
				  {	/* Cgen/emit-cop.scm 367 */
				     obj_t aux_3420;
				     {	/* Cgen/emit-cop.scm 367 */
					cop_bglt obj_2595;
					obj_2595 =
					   (cop_bglt) (cop_1931);
					aux_3420 =
					   (((cop_bglt) CREF(obj_2595))->loc);
				     }
				     emit_bdb_loc_8_cgen_emit_cop_239(aux_3420);
				  }
				  {	/* Cgen/emit-cop.scm 368 */
				     obj_t case_value_58_1943;
				     case_value_58_1943 =
					(((cfuncall_bglt) CREF(cop_1931))->strength);
				     {	/* Cgen/emit-cop.scm 368 */
					bool_t test_3425;
					{	/* ./Ieee/equiv.scm 5508 */
					   obj_t aux_3426;
					   aux_3426 =
					      CNST_TABLE_REF(((long) 2));
					   test_3425 =
					      (case_value_58_1943 == aux_3426);
					}
					if (test_3425)
					  {	/* Cgen/emit-cop.scm 370 */
					     bool_t aux_3429;
					     cop_1932 = cop_1931;
					     {	/* Cgen/emit-cop.scm 291 */
						obj_t actuals_1946;
						actuals_1946 =
						   (((cfuncall_bglt) CREF(cop_1932))->args);
						emit_cop_45_cgen_emit_cop_239(
						   (((cfuncall_bglt) CREF(cop_1932))->fun));
						{	/* Cgen/emit-cop.scm 293 */
						   obj_t port_2604;
						   port_2604 = _c_port__188_cgen_emit;
						   WRITE_CHAR(((unsigned char) '('), port_2604);
						}
						{
						   obj_t actuals_1948;
						   actuals_1948 = actuals_1946;
						 loop_1949:
						   {	/* Cgen/emit-cop.scm 297 */
						      bool_t test_3434;
						      {		/* ./Ieee/pair-list.scm 5912 */
							 obj_t aux_3435;
							 {	/* ./Ieee/pair-list.scm 5707 */
							    obj_t aux_3436;
							    aux_3436 =
							       CDR(actuals_1948);
							    aux_3435 =
							       CDR(aux_3436);
							 }
							 test_3434 =
							    NULLP(aux_3435);
						      }
						      if (test_3434)
							{	/* Cgen/emit-cop.scm 297 */
							   {	/* Cgen/emit-cop.scm 299 */
							      cop_bglt aux_3440;
							      {		/* Cgen/emit-cop.scm 299 */
								 obj_t aux_3441;
								 aux_3441 =
								    CAR(actuals_1948);
								 aux_3440 =
								    (cop_bglt) (aux_3441);
							      }
							      emit_cop_45_cgen_emit_cop_239(aux_3440);
							   }
							   {	/* Cgen/emit-cop.scm 300 */
							      obj_t port_2612;
							      port_2612 = _c_port__188_cgen_emit;
							      WRITE_CHAR(((unsigned char) ')'), port_2612);
							   }
							   aux_3429 = ((bool_t) 1);
							}
						      else
							{	/* Cgen/emit-cop.scm 297 */
							   {	/* Cgen/emit-cop.scm 303 */
							      cop_bglt aux_3446;
							      {		/* Cgen/emit-cop.scm 303 */
								 obj_t aux_3447;
								 aux_3447 =
								    CAR(actuals_1948);
								 aux_3446 =
								    (cop_bglt) (aux_3447);
							      }
							      emit_cop_45_cgen_emit_cop_239(aux_3446);
							   }
							   display_2_122___r4_output_6_10_3(string2285_cgen_emit_cop_239, _c_port__188_cgen_emit);
							   {
							      obj_t actuals_3452;
							      actuals_3452 =
								 CDR(actuals_1948);
							      actuals_1948 = actuals_3452;
							      goto loop_1949;
							   }
							}
						   }
						}
					     }
					     aux_3190 =
						BBOOL(aux_3429);
					  }
					else
					  {	/* Cgen/emit-cop.scm 368 */
					     bool_t test_3455;
					     {	/* ./Ieee/equiv.scm 5508 */
						obj_t aux_3456;
						aux_3456 =
						   CNST_TABLE_REF(((long) 3));
						test_3455 =
						   (case_value_58_1943 == aux_3456);
					     }
					     if (test_3455)
					       {	/* Cgen/emit-cop.scm 372 */
						  bool_t aux_3459;
						  cop_1934 = cop_1931;
						  {	/* Cgen/emit-cop.scm 307 */
						     obj_t actuals_1955;
						     actuals_1955 =
							(((cfuncall_bglt) CREF(cop_1934))->args);
						     display_2_122___r4_output_6_10_3(string2299_cgen_emit_cop_239, _c_port__188_cgen_emit);
						     emit_cop_45_cgen_emit_cop_239(
							(((cfuncall_bglt) CREF(cop_1934))->fun));
						     display_2_122___r4_output_6_10_3(string2298_cgen_emit_cop_239, _c_port__188_cgen_emit);
						     {
							obj_t actuals_1957;
							actuals_1957 = actuals_1955;
						      loop_1958:
							{	/* Cgen/emit-cop.scm 314 */
							   bool_t test_3465;
							   {	/* ./Ieee/pair-list.scm 5912 */
							      obj_t aux_3466;
							      {		/* ./Ieee/pair-list.scm 5707 */
								 obj_t aux_3467;
								 aux_3467 =
								    CDR(actuals_1957);
								 aux_3466 =
								    CDR(aux_3467);
							      }
							      test_3465 =
								 NULLP(aux_3466);
							   }
							   if (test_3465)
							     {	/* Cgen/emit-cop.scm 314 */
								{	/* Cgen/emit-cop.scm 316 */
								   cop_bglt aux_3471;
								   {	/* Cgen/emit-cop.scm 316 */
								      obj_t aux_3472;
								      aux_3472 =
									 CAR(actuals_1957);
								      aux_3471 =
									 (cop_bglt) (aux_3472);
								   }
								   emit_cop_45_cgen_emit_cop_239(aux_3471);
								}
								display_2_122___r4_output_6_10_3(string2268_cgen_emit_cop_239, _c_port__188_cgen_emit);
								aux_3459 = ((bool_t) 1);
							     }
							   else
							     {	/* Cgen/emit-cop.scm 314 */
								{	/* Cgen/emit-cop.scm 320 */
								   cop_bglt aux_3477;
								   {	/* Cgen/emit-cop.scm 320 */
								      obj_t aux_3478;
								      aux_3478 =
									 CAR(actuals_1957);
								      aux_3477 =
									 (cop_bglt) (aux_3478);
								   }
								   emit_cop_45_cgen_emit_cop_239(aux_3477);
								}
								display_2_122___r4_output_6_10_3(string2285_cgen_emit_cop_239, _c_port__188_cgen_emit);
								{
								   obj_t actuals_3483;
								   actuals_3483 =
								      CDR(actuals_1957);
								   actuals_1957 = actuals_3483;
								   goto loop_1958;
								}
							     }
							}
						     }
						  }
						  aux_3190 =
						     BBOOL(aux_3459);
					       }
					     else
					       {	/* Cgen/emit-cop.scm 368 */
						  if (
						     CBOOL(_stdc__25_engine_param))
						    {	/* Cgen/emit-cop.scm 375 */
						       bool_t aux_3488;
						       cop_1940 = cop_1931;
						       display_2_122___r4_output_6_10_3(string2293_cgen_emit_cop_239, _c_port__188_cgen_emit);
						       emit_cop_45_cgen_emit_cop_239(
							  (((cfuncall_bglt) CREF(cop_1940))->fun));
						       display_2_122___r4_output_6_10_3(string2294_cgen_emit_cop_239, _c_port__188_cgen_emit);
						       emit_regular_cfuncall_eoa_48_cgen_emit_cop_239(cop_1940);
						       display_2_122___r4_output_6_10_3(string2295_cgen_emit_cop_239, _c_port__188_cgen_emit);
						       cop_1938 = cop_1940;
						       {	/* Cgen/emit-cop.scm 341 */
							  obj_t actuals_1973;
							  actuals_1973 =
							     (((cfuncall_bglt) CREF(cop_1938))->args);
							  display_2_122___r4_output_6_10_3(string2297_cgen_emit_cop_239, _c_port__188_cgen_emit);
							  emit_cop_45_cgen_emit_cop_239(
							     (((cfuncall_bglt) CREF(cop_1938))->fun));
							  display_2_122___r4_output_6_10_3(string2298_cgen_emit_cop_239, _c_port__188_cgen_emit);
							  {
							     obj_t actuals_1975;
							     actuals_1975 = actuals_1973;
							   loop_1976:
							     {	/* Cgen/emit-cop.scm 348 */
								bool_t test_3500;
								{	/* ./Ieee/pair-list.scm 5912 */
								   obj_t aux_3501;
								   {	/* ./Ieee/pair-list.scm 5707 */
								      obj_t aux_3502;
								      aux_3502 =
									 CDR(actuals_1975);
								      aux_3501 =
									 CDR(aux_3502);
								   }
								   test_3500 =
								      NULLP(aux_3501);
								}
								if (test_3500)
								  {	/* Cgen/emit-cop.scm 348 */
								     {	/* Cgen/emit-cop.scm 350 */
									cop_bglt aux_3506;
									{	/* Cgen/emit-cop.scm 350 */
									   obj_t aux_3507;
									   aux_3507 =
									      CAR(actuals_1975);
									   aux_3506 =
									      (cop_bglt) (aux_3507);
									}
									emit_cop_45_cgen_emit_cop_239(aux_3506);
								     }
								     display_2_122___r4_output_6_10_3(string2268_cgen_emit_cop_239, _c_port__188_cgen_emit);
								     ((bool_t) 1);
								  }
								else
								  {	/* Cgen/emit-cop.scm 348 */
								     {	/* Cgen/emit-cop.scm 354 */
									cop_bglt aux_3512;
									{	/* Cgen/emit-cop.scm 354 */
									   obj_t aux_3513;
									   aux_3513 =
									      CAR(actuals_1975);
									   aux_3512 =
									      (cop_bglt) (aux_3513);
									}
									emit_cop_45_cgen_emit_cop_239(aux_3512);
								     }
								     display_2_122___r4_output_6_10_3(string2285_cgen_emit_cop_239, _c_port__188_cgen_emit);
								     {
									obj_t actuals_3518;
									actuals_3518 =
									   CDR(actuals_1975);
									actuals_1975 = actuals_3518;
									goto loop_1976;
								     }
								  }
							     }
							  }
						       }
						       display_2_122___r4_output_6_10_3(string2296_cgen_emit_cop_239, _c_port__188_cgen_emit);
						       aux_3488 = ((bool_t) 1);
						       aux_3190 =
							  BBOOL(aux_3488);
						    }
						  else
						    {	/* Cgen/emit-cop.scm 376 */
						       bool_t aux_3522;
						       aux_3522 =
							  emit_regular_cfuncall_eoa_48_cgen_emit_cop_239(cop_1931);
						       aux_3190 =
							  BBOOL(aux_3522);
						    }
					       }
					  }
				     }
				  }
			       }
			    }
			    break;
			 case ((long) 17):

			    {	/* Cgen/emit-cop.scm 382 */
			       capply_bglt cop_1983;
			       cop_1983 =
				  (capply_bglt) (cop_15);
			       emit_bdb_loc_8_cgen_emit_cop_239(
				  (((capply_bglt) CREF(cop_1983))->loc));
			       display_2_122___r4_output_6_10_3(string2300_cgen_emit_cop_239, _c_port__188_cgen_emit);
			       emit_cop_45_cgen_emit_cop_239(
				  (((capply_bglt) CREF(cop_1983))->fun));
			       display_2_122___r4_output_6_10_3(string2285_cgen_emit_cop_239, _c_port__188_cgen_emit);
			       emit_cop_45_cgen_emit_cop_239(
				  (((capply_bglt) CREF(cop_1983))->arg));
			       {	/* Cgen/emit-cop.scm 388 */
				  obj_t port_2647;
				  port_2647 = _c_port__188_cgen_emit;
				  WRITE_CHAR(((unsigned char) ')'), port_2647);
			       }
			       aux_3190 = BTRUE;
			    }
			    break;
			 case ((long) 18):

			    {	/* Cgen/emit-cop.scm 43 */
			       capp_bglt cop_1988;
			       cop_1988 =
				  (capp_bglt) (cop_15);
			       {

				  {	/* Cgen/emit-cop.scm 421 */
				     variable_bglt fun_1991;
				     {	/* Cgen/emit-cop.scm 421 */
					varc_bglt obj_2649;
					{	/* Cgen/emit-cop.scm 421 */
					   cop_bglt aux_3536;
					   aux_3536 =
					      (((capp_bglt) CREF(cop_1988))->fun);
					   obj_2649 =
					      (varc_bglt) (aux_3536);
					}
					fun_1991 =
					   (((varc_bglt) CREF(obj_2649))->variable);
				     }
				     emit_bdb_loc_8_cgen_emit_cop_239(
					(((capp_bglt) CREF(cop_1988))->loc));
				     {	/* Cgen/emit-cop.scm 424 */
					bool_t test2174_1993;
					{	/* Cgen/emit-cop.scm 424 */
					   bool_t test2175_1994;
					   {	/* ./Ast/var.scm 1528 */
					      obj_t aux_3542;
					      {		/* Cgen/emit-cop.scm 424 */
						 value_bglt aux_3543;
						 {	/* Cgen/emit-cop.scm 424 */
						    global_bglt obj_2651;
						    obj_2651 =
						       (global_bglt) (fun_1991);
						    aux_3543 =
						       (((global_bglt) CREF(obj_2651))->value);
						 }
						 aux_3542 =
						    (obj_t) (aux_3543);
					      }
					      test2175_1994 =
						 is_a__118___object(aux_3542, cfun_ast_var);
					   }
					   if (test2175_1994)
					     {	/* Cgen/emit-cop.scm 424 */
						cfun_bglt obj_2654;
						{	/* Cgen/emit-cop.scm 424 */
						   value_bglt aux_3549;
						   {	/* Cgen/emit-cop.scm 424 */
						      global_bglt obj_2653;
						      obj_2653 =
							 (global_bglt) (fun_1991);
						      aux_3549 =
							 (((global_bglt) CREF(obj_2653))->value);
						   }
						   obj_2654 =
						      (cfun_bglt) (aux_3549);
						}
						test2174_1993 =
						   (((cfun_bglt) CREF(obj_2654))->infix__163);
					     }
					   else
					     {	/* Cgen/emit-cop.scm 424 */
						test2174_1993 = ((bool_t) 0);
					     }
					}
					if (test2174_1993)
					  {	/* Cgen/emit-cop.scm 425 */
					     bool_t aux_3555;
					     {	/* Cgen/emit-cop.scm 396 */
						obj_t actuals_2010;
						actuals_2010 =
						   (((capp_bglt) CREF(cop_1988))->args);
						{	/* Cgen/emit-cop.scm 397 */
						   obj_t port_2671;
						   port_2671 = _c_port__188_cgen_emit;
						   WRITE_CHAR(((unsigned char) '('), port_2671);
						}
						{	/* Cgen/emit-cop.scm 398 */
						   cop_bglt aux_3558;
						   {	/* Cgen/emit-cop.scm 398 */
						      obj_t aux_3559;
						      aux_3559 =
							 CAR(actuals_2010);
						      aux_3558 =
							 (cop_bglt) (aux_3559);
						   }
						   emit_cop_45_cgen_emit_cop_239(aux_3558);
						}
						emit_cop_45_cgen_emit_cop_239(
						   (((capp_bglt) CREF(cop_1988))->fun));
						{	/* Cgen/emit-cop.scm 400 */
						   cop_bglt aux_3565;
						   {	/* Cgen/emit-cop.scm 400 */
						      obj_t aux_3566;
						      {		/* ./Ieee/pair-list.scm 5701 */
							 obj_t aux_3567;
							 aux_3567 =
							    CDR(actuals_2010);
							 aux_3566 =
							    CAR(aux_3567);
						      }
						      aux_3565 =
							 (cop_bglt) (aux_3566);
						   }
						   emit_cop_45_cgen_emit_cop_239(aux_3565);
						}
						{	/* Cgen/emit-cop.scm 401 */
						   obj_t port_2679;
						   port_2679 = _c_port__188_cgen_emit;
						   WRITE_CHAR(((unsigned char) ')'), port_2679);
						}
						aux_3555 = ((bool_t) 1);
					     }
					     aux_3190 =
						BBOOL(aux_3555);
					  }
					else
					  {	/* Cgen/emit-cop.scm 426 */
					     bool_t aux_3574;
					     {	/* Cgen/emit-cop.scm 404 */
						obj_t actuals_1999;
						actuals_1999 =
						   (((capp_bglt) CREF(cop_1988))->args);
						emit_cop_45_cgen_emit_cop_239(
						   (((capp_bglt) CREF(cop_1988))->fun));
						{	/* Cgen/emit-cop.scm 406 */
						   obj_t port_2658;
						   port_2658 = _c_port__188_cgen_emit;
						   WRITE_CHAR(((unsigned char) '('), port_2658);
						}
						if (
						   NULLP(actuals_1999))
						  {	/* Cgen/emit-cop.scm 407 */
						     {	/* Cgen/emit-cop.scm 409 */
							obj_t port_2661;
							port_2661 = _c_port__188_cgen_emit;
							WRITE_CHAR(((unsigned char) ')'), port_2661);
						     }
						     aux_3574 = ((bool_t) 1);
						  }
						else
						  {
						     obj_t actuals_2002;
						     actuals_2002 = actuals_1999;
						   loop_2003:
						     {	/* Cgen/emit-cop.scm 412 */
							bool_t test_3582;
							{	/* ./Ieee/pair-list.scm 5912 */
							   obj_t aux_3583;
							   aux_3583 =
							      CDR(actuals_2002);
							   test_3582 =
							      NULLP(aux_3583);
							}
							if (test_3582)
							  {	/* Cgen/emit-cop.scm 412 */
							     {	/* Cgen/emit-cop.scm 414 */
								cop_bglt aux_3586;
								{	/* Cgen/emit-cop.scm 414 */
								   obj_t aux_3587;
								   aux_3587 =
								      CAR(actuals_2002);
								   aux_3586 =
								      (cop_bglt) (aux_3587);
								}
								emit_cop_45_cgen_emit_cop_239(aux_3586);
							     }
							     {	/* Cgen/emit-cop.scm 415 */
								obj_t port_2666;
								port_2666 = _c_port__188_cgen_emit;
								WRITE_CHAR(((unsigned char) ')'), port_2666);
							     }
							     aux_3574 = ((bool_t) 1);
							  }
							else
							  {	/* Cgen/emit-cop.scm 412 */
							     {	/* Cgen/emit-cop.scm 418 */
								cop_bglt aux_3592;
								{	/* Cgen/emit-cop.scm 418 */
								   obj_t aux_3593;
								   aux_3593 =
								      CAR(actuals_2002);
								   aux_3592 =
								      (cop_bglt) (aux_3593);
								}
								emit_cop_45_cgen_emit_cop_239(aux_3592);
							     }
							     display_2_122___r4_output_6_10_3(string2285_cgen_emit_cop_239, _c_port__188_cgen_emit);
							     {
								obj_t actuals_3598;
								actuals_3598 =
								   CDR(actuals_2002);
								actuals_2002 = actuals_3598;
								goto loop_2003;
							     }
							  }
						     }
						  }
					     }
					     aux_3190 =
						BBOOL(aux_3574);
					  }
				     }
				  }
			       }
			    }
			    break;
			 case ((long) 19):

			    {	/* Cgen/emit-cop.scm 439 */
			       cfail_bglt cop_2016;
			       cop_2016 =
				  (cfail_bglt) (cop_15);
			       emit_bdb_loc_8_cgen_emit_cop_239(
				  (((cfail_bglt) CREF(cop_2016))->loc));
			       if (
				  CBOOL(_bfalse__69_cgen_emit_cop_239))
				 {	/* Cgen/emit-cop.scm 441 */
				    BUNSPEC;
				 }
			       else
				 {	/* Cgen/emit-cop.scm 441 */
				    _bfalse__69_cgen_emit_cop_239 =
				       find_global_module_25_ast_env(
				       CNST_TABLE_REF(((long) 4)),
				       CNST_TABLE_REF(((long) 5)));
				 }
			       {	/* Cgen/emit-cop.scm 444 */
				  bool_t test2193_2019;
				  {	/* Cgen/emit-cop.scm 444 */
				     bool_t test2202_2027;
				     {	/* ./Cgen/cop.scm 1849 */
					obj_t aux_3609;
					{	/* Cgen/emit-cop.scm 444 */
					   cop_bglt aux_3610;
					   aux_3610 =
					      (((cfail_bglt) CREF(cop_2016))->proc);
					   aux_3609 =
					      (obj_t) (aux_3610);
					}
					test2202_2027 =
					   is_a__118___object(aux_3609, varc_cgen_cop);
				     }
				     if (test2202_2027)
				       {	/* Cgen/emit-cop.scm 444 */
					  bool_t test2203_2028;
					  {	/* Cgen/emit-cop.scm 444 */
					     obj_t obj2_2686;
					     obj2_2686 = _bfalse__69_cgen_emit_cop_239;
					     {	/* ./Ieee/equiv.scm 5508 */
						obj_t aux_3615;
						{	/* Cgen/emit-cop.scm 444 */
						   variable_bglt aux_3616;
						   {	/* Cgen/emit-cop.scm 444 */
						      varc_bglt obj_2684;
						      {		/* Cgen/emit-cop.scm 444 */
							 cop_bglt aux_3617;
							 aux_3617 =
							    (((cfail_bglt) CREF(cop_2016))->proc);
							 obj_2684 =
							    (varc_bglt) (aux_3617);
						      }
						      aux_3616 =
							 (((varc_bglt) CREF(obj_2684))->variable);
						   }
						   aux_3615 =
						      (obj_t) (aux_3616);
						}
						test2203_2028 =
						   (aux_3615 == obj2_2686);
					     }
					  }
					  if (test2203_2028)
					    {	/* Cgen/emit-cop.scm 445 */
					       bool_t test2204_2029;
					       {	/* ./Cgen/cop.scm 1849 */
						  obj_t aux_3624;
						  {	/* Cgen/emit-cop.scm 445 */
						     cop_bglt aux_3625;
						     aux_3625 =
							(((cfail_bglt) CREF(cop_2016))->msg);
						     aux_3624 =
							(obj_t) (aux_3625);
						  }
						  test2204_2029 =
						     is_a__118___object(aux_3624, varc_cgen_cop);
					       }
					       if (test2204_2029)
						 {	/* Cgen/emit-cop.scm 445 */
						    bool_t test2205_2030;
						    {	/* Cgen/emit-cop.scm 445 */
						       obj_t obj2_2692;
						       obj2_2692 = _bfalse__69_cgen_emit_cop_239;
						       {	/* ./Ieee/equiv.scm 5508 */
							  obj_t aux_3630;
							  {	/* Cgen/emit-cop.scm 445 */
							     variable_bglt aux_3631;
							     {	/* Cgen/emit-cop.scm 445 */
								varc_bglt obj_2690;
								{	/* Cgen/emit-cop.scm 445 */
								   cop_bglt aux_3632;
								   aux_3632 =
								      (((cfail_bglt) CREF(cop_2016))->msg);
								   obj_2690 =
								      (varc_bglt) (aux_3632);
								}
								aux_3631 =
								   (((varc_bglt) CREF(obj_2690))->variable);
							     }
							     aux_3630 =
								(obj_t) (aux_3631);
							  }
							  test2205_2030 =
							     (aux_3630 == obj2_2692);
						       }
						    }
						    if (test2205_2030)
						      {		/* Cgen/emit-cop.scm 446 */
							 bool_t test2206_2031;
							 {	/* ./Cgen/cop.scm 1849 */
							    obj_t aux_3639;
							    {	/* Cgen/emit-cop.scm 446 */
							       cop_bglt aux_3640;
							       aux_3640 =
								  (((cfail_bglt) CREF(cop_2016))->obj);
							       aux_3639 =
								  (obj_t) (aux_3640);
							    }
							    test2206_2031 =
							       is_a__118___object(aux_3639, varc_cgen_cop);
							 }
							 if (test2206_2031)
							   {	/* Cgen/emit-cop.scm 446 */
							      obj_t obj2_2698;
							      obj2_2698 = _bfalse__69_cgen_emit_cop_239;
							      {		/* ./Ieee/equiv.scm 5508 */
								 obj_t aux_3645;
								 {	/* Cgen/emit-cop.scm 446 */
								    variable_bglt aux_3646;
								    {	/* Cgen/emit-cop.scm 446 */
								       varc_bglt obj_2696;
								       {	/* Cgen/emit-cop.scm 446 */
									  cop_bglt aux_3647;
									  aux_3647 =
									     (((cfail_bglt) CREF(cop_2016))->obj);
									  obj_2696 =
									     (varc_bglt) (aux_3647);
								       }
								       aux_3646 =
									  (((varc_bglt) CREF(obj_2696))->variable);
								    }
								    aux_3645 =
								       (obj_t) (aux_3646);
								 }
								 test2193_2019 =
								    (aux_3645 == obj2_2698);
							      }
							   }
							 else
							   {	/* Cgen/emit-cop.scm 446 */
							      test2193_2019 = ((bool_t) 0);
							   }
						      }
						    else
						      {		/* Cgen/emit-cop.scm 445 */
							 test2193_2019 = ((bool_t) 0);
						      }
						 }
					       else
						 {	/* Cgen/emit-cop.scm 445 */
						    test2193_2019 = ((bool_t) 0);
						 }
					    }
					  else
					    {	/* Cgen/emit-cop.scm 444 */
					       test2193_2019 = ((bool_t) 0);
					    }
				       }
				     else
				       {	/* Cgen/emit-cop.scm 444 */
					  test2193_2019 = ((bool_t) 0);
				       }
				  }
				  if (test2193_2019)
				    {	/* Cgen/emit-cop.scm 444 */
				       display_2_122___r4_output_6_10_3(string2301_cgen_emit_cop_239, _c_port__188_cgen_emit);
				    }
				  else
				    {	/* Cgen/emit-cop.scm 448 */
				       bool_t test2194_2020;
				       {	/* Cgen/emit-cop.scm 448 */
					  long n1_2699;
					  n1_2699 =
					     (long) CINT(_bdb_debug__1_engine_param);
					  test2194_2020 =
					     (n1_2699 <= ((long) 0));
				       }
				       if (test2194_2020)
					 {	/* Cgen/emit-cop.scm 448 */
					    display_2_122___r4_output_6_10_3(string2302_cgen_emit_cop_239, _c_port__188_cgen_emit);
					    emit_cop_45_cgen_emit_cop_239(
					       (((cfail_bglt) CREF(cop_2016))->proc));
					    {	/* Cgen/emit-cop.scm 451 */
					       obj_t port_2703;
					       port_2703 = _c_port__188_cgen_emit;
					       WRITE_CHAR(((unsigned char) ','), port_2703);
					    }
					    emit_cop_45_cgen_emit_cop_239(
					       (((cfail_bglt) CREF(cop_2016))->msg));
					    {	/* Cgen/emit-cop.scm 453 */
					       obj_t port_2706;
					       port_2706 = _c_port__188_cgen_emit;
					       WRITE_CHAR(((unsigned char) ','), port_2706);
					    }
					    emit_cop_45_cgen_emit_cop_239(
					       (((cfail_bglt) CREF(cop_2016))->obj));
					    display_2_122___r4_output_6_10_3(string2303_cgen_emit_cop_239, _c_port__188_cgen_emit);
					 }
				       else
					 {	/* Cgen/emit-cop.scm 448 */
					    display_2_122___r4_output_6_10_3(string2304_cgen_emit_cop_239, _c_port__188_cgen_emit);
					    emit_cop_45_cgen_emit_cop_239(
					       (((cfail_bglt) CREF(cop_2016))->proc));
					    {	/* Cgen/emit-cop.scm 459 */
					       obj_t port_2710;
					       port_2710 = _c_port__188_cgen_emit;
					       WRITE_CHAR(((unsigned char) ','), port_2710);
					    }
					    emit_cop_45_cgen_emit_cop_239(
					       (((cfail_bglt) CREF(cop_2016))->msg));
					    {	/* Cgen/emit-cop.scm 461 */
					       obj_t port_2713;
					       port_2713 = _c_port__188_cgen_emit;
					       WRITE_CHAR(((unsigned char) ','), port_2713);
					    }
					    emit_cop_45_cgen_emit_cop_239(
					       (((cfail_bglt) CREF(cop_2016))->obj));
					    display_2_122___r4_output_6_10_3(string2305_cgen_emit_cop_239, _c_port__188_cgen_emit);
					 }
				    }
			       }
			       aux_3190 = BFALSE;
			    }
			    break;
			 case ((long) 20):

			    {	/* Cgen/emit-cop.scm 470 */
			       cswitch_bglt cop_2041;
			       cop_2041 =
				  (cswitch_bglt) (cop_15);
			       emit_bdb_loc_8_cgen_emit_cop_239(
				  (((cswitch_bglt) CREF(cop_2041))->loc));
			       display_2_122___r4_output_6_10_3(string2306_cgen_emit_cop_239, _c_port__188_cgen_emit);
			       emit_cop_45_cgen_emit_cop_239(
				  (((cswitch_bglt) CREF(cop_2041))->test));
			       display_2_122___r4_output_6_10_3(string2307_cgen_emit_cop_239, _c_port__188_cgen_emit);
			       {
				  obj_t clauses_2045;
				  {	/* Cgen/emit-cop.scm 476 */
				     bool_t aux_3685;
				     clauses_2045 =
					(((cswitch_bglt) CREF(cop_2041))->clauses);
				   loop_2046:
				     {	/* Cgen/emit-cop.scm 477 */
					obj_t clause_2048;
					clause_2048 =
					   CAR(clauses_2045);
					{	/* Cgen/emit-cop.scm 478 */
					   bool_t test_3687;
					   {	/* ./Ieee/equiv.scm 5508 */
					      obj_t aux_3690;
					      obj_t aux_3688;
					      aux_3690 =
						 CNST_TABLE_REF(((long) 6));
					      aux_3688 =
						 CAR(clause_2048);
					      test_3687 =
						 (aux_3688 == aux_3690);
					   }
					   if (test_3687)
					     {	/* Cgen/emit-cop.scm 478 */
						{	/* Cgen/emit-cop.scm 480 */
						   obj_t aux_3693;
						   {	/* Cgen/emit-cop.scm 479 */
						      cop_bglt obj_2723;
						      {		/* Cgen/emit-cop.scm 479 */
							 obj_t aux_3694;
							 aux_3694 =
							    CDR(clause_2048);
							 obj_2723 =
							    (cop_bglt) (aux_3694);
						      }
						      aux_3693 =
							 (((cop_bglt) CREF(obj_2723))->loc);
						   }
						   emit_bdb_loc_8_cgen_emit_cop_239(aux_3693);
						}
						display_2_122___r4_output_6_10_3(string2308_cgen_emit_cop_239, _c_port__188_cgen_emit);
						{	/* Cgen/emit-cop.scm 482 */
						   bool_t test2221_2051;
						   {	/* Cgen/emit-cop.scm 482 */
						      cop_bglt aux_3700;
						      {		/* Cgen/emit-cop.scm 482 */
							 obj_t aux_3701;
							 aux_3701 =
							    CDR(clause_2048);
							 aux_3700 =
							    (cop_bglt) (aux_3701);
						      }
						      test2221_2051 =
							 emit_cop_45_cgen_emit_cop_239(aux_3700);
						   }
						   if (test2221_2051)
						     {	/* Cgen/emit-cop.scm 482 */
							display_2_122___r4_output_6_10_3(string2280_cgen_emit_cop_239, _c_port__188_cgen_emit);
							BUNSPEC;
						     }
						   else
						     {	/* Cgen/emit-cop.scm 482 */
							BUNSPEC;
						     }
						}
						display_2_122___r4_output_6_10_3(string2281_cgen_emit_cop_239, _c_port__188_cgen_emit);
						aux_3685 = ((bool_t) 0);
					     }
					   else
					     {	/* Cgen/emit-cop.scm 478 */
						{
						   obj_t l1669_2054;
						   l1669_2054 =
						      CAR(clause_2048);
						 lname1670_2055:
						   if (
						      PAIRP(l1669_2054))
						     {	/* Cgen/emit-cop.scm 491 */
							{	/* Cgen/emit-cop.scm 491 */
							   obj_t t_2058;
							   t_2058 =
							      CAR(l1669_2054);
							   display_2_122___r4_output_6_10_3(string2309_cgen_emit_cop_239, _c_port__188_cgen_emit);
							   emit_atom_value_68_cgen_emit_cop_239(t_2058);
							   display_2_122___r4_output_6_10_3(string2295_cgen_emit_cop_239, _c_port__188_cgen_emit);
							   {	/* Cgen/emit-cop.scm 495 */
							      obj_t port_2728;
							      port_2728 = _c_port__188_cgen_emit;
							      WRITE_CHAR(((unsigned char) '\n'), port_2728);
							   }
							}
							{
							   obj_t l1669_3715;
							   l1669_3715 =
							      CDR(l1669_2054);
							   l1669_2054 = l1669_3715;
							   goto lname1670_2055;
							}
						     }
						   else
						     {	/* Cgen/emit-cop.scm 491 */
							((bool_t) 1);
						     }
						}
						{	/* Cgen/emit-cop.scm 497 */
						   bool_t test2228_2060;
						   {	/* Cgen/emit-cop.scm 497 */
						      cop_bglt aux_3718;
						      {		/* Cgen/emit-cop.scm 497 */
							 obj_t aux_3719;
							 aux_3719 =
							    CDR(clause_2048);
							 aux_3718 =
							    (cop_bglt) (aux_3719);
						      }
						      test2228_2060 =
							 emit_cop_45_cgen_emit_cop_239(aux_3718);
						   }
						   if (test2228_2060)
						     {	/* Cgen/emit-cop.scm 497 */
							display_2_122___r4_output_6_10_3(string2280_cgen_emit_cop_239, _c_port__188_cgen_emit);
							BUNSPEC;
						     }
						   else
						     {	/* Cgen/emit-cop.scm 497 */
							BUNSPEC;
						     }
						}
						display_2_122___r4_output_6_10_3(string2310_cgen_emit_cop_239, _c_port__188_cgen_emit);
						{
						   obj_t clauses_3726;
						   clauses_3726 =
						      CDR(clauses_2045);
						   clauses_2045 = clauses_3726;
						   goto loop_2046;
						}
					     }
					}
				     }
				     aux_3190 =
					BBOOL(aux_3685);
				  }
			       }
			    }
			    break;
			 case ((long) 21):

			    {	/* Cgen/emit-cop.scm 509 */
			       cmake_box_177_bglt cop_2065;
			       cop_2065 =
				  (cmake_box_177_bglt) (cop_15);
			       emit_bdb_loc_8_cgen_emit_cop_239(
				  (((cmake_box_177_bglt) CREF(cop_2065))->loc));
			       display_2_122___r4_output_6_10_3(string2311_cgen_emit_cop_239, _c_port__188_cgen_emit);
			       emit_cop_45_cgen_emit_cop_239(
				  (((cmake_box_177_bglt) CREF(cop_2065))->value));
			       {	/* Cgen/emit-cop.scm 513 */
				  obj_t port_2735;
				  port_2735 = _c_port__188_cgen_emit;
				  WRITE_CHAR(((unsigned char) ')'), port_2735);
			       }
			       aux_3190 = BTRUE;
			    }
			    break;
			 case ((long) 22):

			    {	/* Cgen/emit-cop.scm 520 */
			       cbox_ref_44_bglt cop_2069;
			       cop_2069 =
				  (cbox_ref_44_bglt) (cop_15);
			       emit_bdb_loc_8_cgen_emit_cop_239(
				  (((cbox_ref_44_bglt) CREF(cop_2069))->loc));
			       display_2_122___r4_output_6_10_3(string2312_cgen_emit_cop_239, _c_port__188_cgen_emit);
			       emit_cop_45_cgen_emit_cop_239(
				  (((cbox_ref_44_bglt) CREF(cop_2069))->var));
			       {	/* Cgen/emit-cop.scm 524 */
				  obj_t port_2739;
				  port_2739 = _c_port__188_cgen_emit;
				  WRITE_CHAR(((unsigned char) ')'), port_2739);
			       }
			       aux_3190 = BTRUE;
			    }
			    break;
			 case ((long) 23):

			    {	/* Cgen/emit-cop.scm 531 */
			       cbox_set__132_bglt cop_2073;
			       cop_2073 =
				  (cbox_set__132_bglt) (cop_15);
			       emit_bdb_loc_8_cgen_emit_cop_239(
				  (((cbox_set__132_bglt) CREF(cop_2073))->loc));
			       display_2_122___r4_output_6_10_3(string2313_cgen_emit_cop_239, _c_port__188_cgen_emit);
			       emit_cop_45_cgen_emit_cop_239(
				  (((cbox_set__132_bglt) CREF(cop_2073))->var));
			       display_2_122___r4_output_6_10_3(string2285_cgen_emit_cop_239, _c_port__188_cgen_emit);
			       emit_cop_45_cgen_emit_cop_239(
				  (((cbox_set__132_bglt) CREF(cop_2073))->value));
			       {	/* Cgen/emit-cop.scm 537 */
				  obj_t port_2744;
				  port_2744 = _c_port__188_cgen_emit;
				  WRITE_CHAR(((unsigned char) ')'), port_2744);
			       }
			       aux_3190 = BTRUE;
			    }
			    break;
			 case ((long) 24):

			    {	/* Cgen/emit-cop.scm 544 */
			       cset_ex_it_123_bglt cop_2078;
			       cop_2078 =
				  (cset_ex_it_123_bglt) (cop_15);
			       emit_bdb_loc_8_cgen_emit_cop_239(
				  (((cset_ex_it_123_bglt) CREF(cop_2078))->loc));
			       display_2_122___r4_output_6_10_3(string2314_cgen_emit_cop_239, _c_port__188_cgen_emit);
			       emit_cop_45_cgen_emit_cop_239(
				  (((cset_ex_it_123_bglt) CREF(cop_2078))->exit));
			       display_2_122___r4_output_6_10_3(string2315_cgen_emit_cop_239, _c_port__188_cgen_emit);
			       display_2_122___r4_output_6_10_3(string2316_cgen_emit_cop_239, _c_port__188_cgen_emit);
			       emit_cop_45_cgen_emit_cop_239(
				  (((cset_ex_it_123_bglt) CREF(cop_2078))->jump_value_221));
			       emit_bdb_loc_8_cgen_emit_cop_239(
				  (((cset_ex_it_123_bglt) CREF(cop_2078))->loc));
			       display_2_122___r4_output_6_10_3(string2317_cgen_emit_cop_239, _c_port__188_cgen_emit);
			       emit_cop_45_cgen_emit_cop_239(
				  (((cset_ex_it_123_bglt) CREF(cop_2078))->body));
			       emit_bdb_loc_8_cgen_emit_cop_239(
				  (((cset_ex_it_123_bglt) CREF(cop_2078))->loc));
			       display_2_122___r4_output_6_10_3(string2281_cgen_emit_cop_239, _c_port__188_cgen_emit);
			       aux_3190 = BFALSE;
			    }
			    break;
			 case ((long) 25):

			    {	/* Cgen/emit-cop.scm 564 */
			       cjump_ex_it_131_bglt cop_2086;
			       cop_2086 =
				  (cjump_ex_it_131_bglt) (cop_15);
			       emit_bdb_loc_8_cgen_emit_cop_239(
				  (((cjump_ex_it_131_bglt) CREF(cop_2086))->loc));
			       display_2_122___r4_output_6_10_3(string2318_cgen_emit_cop_239, _c_port__188_cgen_emit);
			       emit_cop_45_cgen_emit_cop_239(
				  (((cjump_ex_it_131_bglt) CREF(cop_2086))->exit));
			       {	/* Cgen/emit-cop.scm 568 */
				  obj_t port_2754;
				  port_2754 = _c_port__188_cgen_emit;
				  WRITE_CHAR(((unsigned char) ','), port_2754);
			       }
			       emit_cop_45_cgen_emit_cop_239(
				  (((cjump_ex_it_131_bglt) CREF(cop_2086))->value));
			       {	/* Cgen/emit-cop.scm 570 */
				  obj_t port_2757;
				  port_2757 = _c_port__188_cgen_emit;
				  WRITE_CHAR(((unsigned char) ')'), port_2757);
			       }
			       aux_3190 = BTRUE;
			    }
			    break;
			 default:
			  case_else1987_1671:
			    if (
			       PROCEDUREP(method1981_1667))
			      {		/* Cgen/emit-cop.scm 43 */
				 aux_3190 =
				    PROCEDURE_ENTRY(method1981_1667) (method1981_1667,
				    (obj_t) (cop_15), BEOA)
				    ;
			      }
			    else
			      {		/* Cgen/emit-cop.scm 43 */
				 obj_t fun1980_1663;
				 fun1980_1663 =
				    PROCEDURE_REF(emit_cop_env_125_cgen_emit_cop_239, ((long) 0));
				 aux_3190 =
				    PROCEDURE_ENTRY(fun1980_1663) (fun1980_1663,
				    (obj_t) (cop_15), BEOA);
			      }
			 }
		    }
		  else
		    {	/* Cgen/emit-cop.scm 43 */
		       goto case_else1987_1671;
		    }
	       }
	       return
		  CBOOL(aux_3190);
	    }
	 }
      }
   }
}



/* emit-regular-cfuncall/eoa */
bool_t 
emit_regular_cfuncall_eoa_48_cgen_emit_cop_239(cfuncall_bglt cop_1936)
{
   AN_OBJECT;
   {	/* Cgen/emit-cop.scm 323 */
      {		/* Cgen/emit-cop.scm 324 */
	 obj_t actuals_1964;
	 actuals_1964 =
	    (((cfuncall_bglt) CREF(cop_1936))->args);
	 display_2_122___r4_output_6_10_3(string2297_cgen_emit_cop_239, _c_port__188_cgen_emit);
	 emit_cop_45_cgen_emit_cop_239(
	    (((cfuncall_bglt) CREF(cop_1936))->fun));
	 display_2_122___r4_output_6_10_3(string2298_cgen_emit_cop_239, _c_port__188_cgen_emit);
	 {
	    obj_t actuals_1966;
	    actuals_1966 = actuals_1964;
	  loop_1967:
	    {	/* Cgen/emit-cop.scm 331 */
	       bool_t test_3799;
	       {	/* ./Ieee/pair-list.scm 5912 */
		  obj_t aux_3800;
		  aux_3800 =
		     CDR(actuals_1966);
		  test_3799 =
		     NULLP(aux_3800);
	       }
	       if (test_3799)
		 {	/* Cgen/emit-cop.scm 331 */
		    {	/* Cgen/emit-cop.scm 333 */
		       cop_bglt aux_3803;
		       {	/* Cgen/emit-cop.scm 333 */
			  obj_t aux_3804;
			  aux_3804 =
			     CAR(actuals_1966);
			  aux_3803 =
			     (cop_bglt) (aux_3804);
		       }
		       emit_cop_45_cgen_emit_cop_239(aux_3803);
		    }
		    display_2_122___r4_output_6_10_3(string2268_cgen_emit_cop_239, _c_port__188_cgen_emit);
		    return ((bool_t) 1);
		 }
	       else
		 {	/* Cgen/emit-cop.scm 331 */
		    {	/* Cgen/emit-cop.scm 337 */
		       cop_bglt aux_3809;
		       {	/* Cgen/emit-cop.scm 337 */
			  obj_t aux_3810;
			  aux_3810 =
			     CAR(actuals_1966);
			  aux_3809 =
			     (cop_bglt) (aux_3810);
		       }
		       emit_cop_45_cgen_emit_cop_239(aux_3809);
		    }
		    display_2_122___r4_output_6_10_3(string2285_cgen_emit_cop_239, _c_port__188_cgen_emit);
		    {
		       obj_t actuals_3815;
		       actuals_3815 =
			  CDR(actuals_1966);
		       actuals_1966 = actuals_3815;
		       goto loop_1967;
		    }
		 }
	    }
	 }
      }
   }
}



/* _emit-cop2265 */
obj_t 
_emit_cop2265_119_cgen_emit_cop_239(obj_t env_2769, obj_t cop_2770)
{
   AN_OBJECT;
   {	/* Cgen/emit-cop.scm 43 */
      {		/* Cgen/emit-cop.scm 43 */
	 bool_t aux_3817;
	 aux_3817 =
	    emit_cop_45_cgen_emit_cop_239(
	    (cop_bglt) (cop_2770));
	 return
	    BBOOL(aux_3817);
      }
   }
}



/* <anonymous:2020> */
obj_t 
_anonymous_2020__85_cgen_emit_cop_239(obj_t env_2774, obj_t input_port_219_2776)
{
   AN_OBJECT;
   {	/* Cgen/emit-cop.scm 131 */
      {		/* Cgen/emit-cop.scm 131 */
	 obj_t args_2775;
	 args_2775 =
	    PROCEDURE_1_EL_REF(env_2774, ((long) 0));
	 {
	    obj_t input_port_219_1720;
	    input_port_219_1720 = input_port_219_2776;
	    {
	       long last_match_133_1791;
	       long last_match_133_1799;
	       long last_match_133_1806;
	       long last_match_133_1814;
	       long last_match_133_1822;
	     _anonymous_2021__143_1742:
	       RGC_START_MATCH(input_port_219_1720);
	       {	/* Cgen/emit-cop.scm 131 */
		  int match_1743;
		  {	/* Cgen/emit-cop.scm 131 */
		     long aux_3823;
		     last_match_133_1799 = ((long) 2);
		   _anonymous_2062__47_1800:
		     {	/* Cgen/emit-cop.scm 131 */
			int current_char_37_1801;
			current_char_37_1801 =
			   RGC_BUFFER_GET_CHAR(input_port_219_1720);
			{	/* Cgen/emit-cop.scm 131 */
			   bool_t test_3825;
			   {	/* ./Ieee/fixnum.scm 7109 */
			      long aux_3826;
			      aux_3826 =
				 (long) (current_char_37_1801);
			      test_3825 =
				 (aux_3826 == ((long) 0));
			   }
			   if (test_3825)
			     {	/* Cgen/emit-cop.scm 131 */
				{	/* Cgen/emit-cop.scm 131 */
				   bool_t test2064_1803;
				   test2064_1803 =
				      RGC_BUFFER_EMPTY(input_port_219_1720);
				   if (test2064_1803)
				     {	/* Cgen/emit-cop.scm 131 */
					bool_t test2065_1804;
					test2065_1804 =
					   rgc_fill_buffer(input_port_219_1720);
					if (test2065_1804)
					  {

					     goto _anonymous_2062__47_1800;
					  }
					else
					  {	/* Cgen/emit-cop.scm 131 */
					     aux_3823 = last_match_133_1799
						;
					  }
				     }
				   else
				     {	/* Cgen/emit-cop.scm 131 */
					last_match_133_1806 = last_match_133_1799;
				      _anonymous_2067__169_1807:
					{	/* Cgen/emit-cop.scm 131 */
					   long new_match_93_1808;
					   RGC_STOP_MATCH(input_port_219_1720);
					   new_match_93_1808 = ((long) 1);
					   {	/* Cgen/emit-cop.scm 131 */
					      int current_char_37_1809;
					      current_char_37_1809 =
						 RGC_BUFFER_GET_CHAR(input_port_219_1720);
					      {		/* Cgen/emit-cop.scm 131 */
						 bool_t test_3835;
						 {	/* ./Ieee/fixnum.scm 7109 */
						    long aux_3836;
						    aux_3836 =
						       (long) (current_char_37_1809);
						    test_3835 =
						       (aux_3836 == ((long) 0));
						 }
						 if (test_3835)
						   {	/* Cgen/emit-cop.scm 131 */
						      {		/* Cgen/emit-cop.scm 131 */
							 bool_t test2069_1811;
							 test2069_1811 =
							    RGC_BUFFER_EMPTY(input_port_219_1720);
							 if (test2069_1811)
							   {	/* Cgen/emit-cop.scm 131 */
							      bool_t test2070_1812;
							      test2070_1812 =
								 rgc_fill_buffer(input_port_219_1720);
							      if (test2070_1812)
								{

								   goto _anonymous_2067__169_1807;
								}
							      else
								{	/* Cgen/emit-cop.scm 131 */
								   aux_3823 = new_match_93_1808
								      ;
								}
							   }
							 else
							   {	/* Cgen/emit-cop.scm 131 */
							      last_match_133_1814 = new_match_93_1808;
							    _anonymous_2072__200_1815:
							      {		/* Cgen/emit-cop.scm 131 */
								 long new_match_93_1816;
								 RGC_STOP_MATCH(input_port_219_1720);
								 new_match_93_1816 = ((long) 1);
								 {	/* Cgen/emit-cop.scm 131 */
								    int current_char_37_1817;
								    current_char_37_1817 =
								       RGC_BUFFER_GET_CHAR(input_port_219_1720);
								    {	/* Cgen/emit-cop.scm 131 */
								       bool_t test_3845;
								       {	/* ./Ieee/fixnum.scm 7109 */
									  long aux_3846;
									  aux_3846 =
									     (long) (current_char_37_1817);
									  test_3845 =
									     (aux_3846 == ((long) 0));
								       }
								       if (test_3845)
									 {	/* Cgen/emit-cop.scm 131 */
									    {	/* Cgen/emit-cop.scm 131 */
									       bool_t test2074_1819;
									       test2074_1819 =
										  RGC_BUFFER_EMPTY(input_port_219_1720);
									       if (test2074_1819)
										 {	/* Cgen/emit-cop.scm 131 */
										    bool_t test2075_1820;
										    test2075_1820 =
										       rgc_fill_buffer(input_port_219_1720);
										    if (test2075_1820)
										      {

											 goto _anonymous_2072__200_1815;
										      }
										    else
										      {		/* Cgen/emit-cop.scm 131 */
											 aux_3823 = new_match_93_1816
											    ;
										      }
										 }
									       else
										 {
										    long last_match_133_3853;
										    last_match_133_3853 = new_match_93_1816;
										    last_match_133_1814 = last_match_133_3853;
										    goto _anonymous_2072__200_1815;
										 }
									    }
									 }
								       else
									 {	/* Cgen/emit-cop.scm 131 */
									    bool_t test_3854;
									    {	/* ./Ieee/fixnum.scm 7109 */
									       long aux_3855;
									       aux_3855 =
										  (long) (current_char_37_1817);
									       test_3854 =
										  (aux_3855 == ((long) 36));
									    }
									    if (test_3854)
									      {		/* Cgen/emit-cop.scm 131 */
										 aux_3823 = new_match_93_1816;
									      }
									    else
									      {		/* Cgen/emit-cop.scm 131 */
										 {
										    long last_match_133_3858;
										    last_match_133_3858 = new_match_93_1816;
										    last_match_133_1814 = last_match_133_3858;
										    goto _anonymous_2072__200_1815;
										 }
									      }
									 }
								    }
								 }
							      }
							   }
						      }
						   }
						 else
						   {	/* Cgen/emit-cop.scm 131 */
						      bool_t test_3859;
						      {		/* ./Ieee/fixnum.scm 7109 */
							 long aux_3860;
							 aux_3860 =
							    (long) (current_char_37_1809);
							 test_3859 =
							    (aux_3860 == ((long) 36));
						      }
						      if (test_3859)
							{	/* Cgen/emit-cop.scm 131 */
							   aux_3823 = new_match_93_1808;
							}
						      else
							{	/* Cgen/emit-cop.scm 131 */
							   {
							      long last_match_133_3863;
							      last_match_133_3863 = new_match_93_1808;
							      last_match_133_1814 = last_match_133_3863;
							      goto _anonymous_2072__200_1815;
							   }
							}
						   }
					      }
					   }
					}
				     }
				}
			     }
			   else
			     {	/* Cgen/emit-cop.scm 131 */
				bool_t test_3864;
				{	/* ./Ieee/fixnum.scm 7109 */
				   long aux_3865;
				   aux_3865 =
				      (long) (current_char_37_1801);
				   test_3864 =
				      (aux_3865 == ((long) 36));
				}
				if (test_3864)
				  {	/* Cgen/emit-cop.scm 131 */
				     last_match_133_1822 = last_match_133_1799;
				   _anonymous_2077__254_1823:
				     {	/* Cgen/emit-cop.scm 131 */
					long new_match_93_1824;
					RGC_STOP_MATCH(input_port_219_1720);
					new_match_93_1824 = ((long) 2);
					{	/* Cgen/emit-cop.scm 131 */
					   int current_char_37_1825;
					   current_char_37_1825 =
					      RGC_BUFFER_GET_CHAR(input_port_219_1720);
					   {	/* Cgen/emit-cop.scm 131 */
					      bool_t test_3870;
					      {		/* ./Ieee/fixnum.scm 7109 */
						 long aux_3871;
						 aux_3871 =
						    (long) (current_char_37_1825);
						 test_3870 =
						    (aux_3871 == ((long) 0));
					      }
					      if (test_3870)
						{	/* Cgen/emit-cop.scm 131 */
						   {	/* Cgen/emit-cop.scm 131 */
						      bool_t test2079_1827;
						      {		/* Cgen/emit-cop.scm 131 */
							 bool_t res2262_2538;
							 {	/* ./Rgc/rgc.scm 4690 */
							    bool_t _andtest_1006_2535;
							    _andtest_1006_2535 =
							       RGC_BUFFER_EMPTY(input_port_219_1720);
							    if (_andtest_1006_2535)
							      {		/* ./Rgc/rgc.scm 4690 */
								 res2262_2538 =
								    rgc_fill_buffer(input_port_219_1720);
							      }
							    else
							      {		/* ./Rgc/rgc.scm 4690 */
								 res2262_2538 = ((bool_t) 0);
							      }
							 }
							 test2079_1827 = res2262_2538;
						      }
						      if (test2079_1827)
							{

							   goto _anonymous_2077__254_1823;
							}
						      else
							{	/* Cgen/emit-cop.scm 131 */
							   aux_3823 = new_match_93_1824
							      ;
							}
						   }
						}
					      else
						{	/* Cgen/emit-cop.scm 131 */
						   bool_t test_3878;
						   {	/* Cgen/emit-cop.scm 131 */
						      bool_t test_3879;
						      {		/* ./Ieee/fixnum.scm 7133 */
							 long aux_3880;
							 aux_3880 =
							    (long) (current_char_37_1825);
							 test_3879 =
							    (aux_3880 >= ((long) 48));
						      }
						      if (test_3879)
							{	/* ./Ieee/fixnum.scm 7115 */
							   long aux_3883;
							   aux_3883 =
							      (long) (current_char_37_1825);
							   test_3878 =
							      (aux_3883 < ((long) 58));
							}
						      else
							{	/* Cgen/emit-cop.scm 131 */
							   test_3878 = ((bool_t) 0)
							      ;
							}
						   }
						   if (test_3878)
						     {	/* Cgen/emit-cop.scm 131 */
							last_match_133_1791 = new_match_93_1824;
						      _anonymous_2057__40_1792:
							{	/* Cgen/emit-cop.scm 131 */
							   long new_match_93_1793;
							   RGC_STOP_MATCH(input_port_219_1720);
							   new_match_93_1793 = ((long) 0);
							   {	/* Cgen/emit-cop.scm 131 */
							      int current_char_37_1794;
							      current_char_37_1794 =
								 RGC_BUFFER_GET_CHAR(input_port_219_1720);
							      {		/* Cgen/emit-cop.scm 131 */
								 bool_t test_3888;
								 {	/* ./Ieee/fixnum.scm 7109 */
								    long aux_3889;
								    aux_3889 =
								       (long) (current_char_37_1794);
								    test_3888 =
								       (aux_3889 == ((long) 0));
								 }
								 if (test_3888)
								   {	/* Cgen/emit-cop.scm 131 */
								      {		/* Cgen/emit-cop.scm 131 */
									 bool_t test2059_1796;
									 {	/* Cgen/emit-cop.scm 131 */
									    bool_t res2261_2502;
									    {	/* ./Rgc/rgc.scm 4690 */
									       bool_t _andtest_1006_2499;
									       _andtest_1006_2499 =
										  RGC_BUFFER_EMPTY(input_port_219_1720);
									       if (_andtest_1006_2499)
										 {	/* ./Rgc/rgc.scm 4690 */
										    res2261_2502 =
										       rgc_fill_buffer(input_port_219_1720);
										 }
									       else
										 {	/* ./Rgc/rgc.scm 4690 */
										    res2261_2502 = ((bool_t) 0);
										 }
									    }
									    test2059_1796 = res2261_2502;
									 }
									 if (test2059_1796)
									   {

									      goto _anonymous_2057__40_1792;
									   }
									 else
									   {	/* Cgen/emit-cop.scm 131 */
									      aux_3823 = new_match_93_1793
										 ;
									   }
								      }
								   }
								 else
								   {	/* Cgen/emit-cop.scm 131 */
								      bool_t test_3896;
								      {		/* Cgen/emit-cop.scm 131 */
									 bool_t test_3897;
									 {	/* ./Ieee/fixnum.scm 7133 */
									    long aux_3898;
									    aux_3898 =
									       (long) (current_char_37_1794);
									    test_3897 =
									       (aux_3898 >= ((long) 48));
									 }
									 if (test_3897)
									   {	/* ./Ieee/fixnum.scm 7115 */
									      long aux_3901;
									      aux_3901 =
										 (long) (current_char_37_1794);
									      test_3896 =
										 (aux_3901 < ((long) 58));
									   }
									 else
									   {	/* Cgen/emit-cop.scm 131 */
									      test_3896 = ((bool_t) 0)
										 ;
									   }
								      }
								      if (test_3896)
									{	/* Cgen/emit-cop.scm 131 */
									   {
									      long last_match_133_3904;
									      last_match_133_3904 = new_match_93_1793;
									      last_match_133_1791 = last_match_133_3904;
									      goto _anonymous_2057__40_1792;
									   }
									}
								      else
									{	/* Cgen/emit-cop.scm 131 */
									   aux_3823 = new_match_93_1793;
									}
								   }
							      }
							   }
							}
						     }
						   else
						     {	/* Cgen/emit-cop.scm 131 */
							aux_3823 = new_match_93_1824;
						     }
						}
					   }
					}
				     }
				  }
				else
				  {	/* Cgen/emit-cop.scm 131 */
				     {
					long last_match_133_3905;
					last_match_133_3905 = last_match_133_1799;
					last_match_133_1806 = last_match_133_3905;
					goto _anonymous_2067__169_1807;
				     }
				  }
			     }
			}
		     }
		     match_1743 =
			(int) (aux_3823);
		  }
		  {

		     switch (
			(long) (match_1743))
		       {
		       case ((long) 2):

			  {	/* Cgen/emit-cop.scm 131 */
			     bool_t test2035_1767;
			     {	/* Cgen/emit-cop.scm 131 */
				int arg2038_1770;
				{	/* Cgen/emit-cop.scm 131 */
				   int res2259_2483;
				   {	/* ./Rgc/rgc.scm 4612 */
				      long aux_3907;
				      aux_3907 =
					 RGC_BUFFER_LENGTH(input_port_219_1720);
				      res2259_2483 =
					 (int) (aux_3907);
				   }
				   arg2038_1770 = res2259_2483;
				}
				{	/* ./Ieee/fixnum.scm 7109 */
				   long aux_3910;
				   aux_3910 =
				      (long) (arg2038_1770);
				   test2035_1767 =
				      (aux_3910 == ((long) 0));
				}
			     }
			     if (test2035_1767)
			       {	/* Cgen/emit-cop.scm 131 */
				  return BCNST(256);
			       }
			     else
			       {	/* Cgen/emit-cop.scm 131 */
				  obj_t arg2036_1768;
				  arg2036_1768 =
				     the_string_180_cgen_emit_cop_239(input_port_219_1720);
				  {	/* ./Ieee/string.scm 8089 */
				     unsigned char aux_3915;
				     aux_3915 =
					STRING_REF(arg2036_1768, ((long) 0));
				     return
					BCHAR(aux_3915);
				  }
			       }
			  }
			  break;
		       case ((long) 1):

			  {	/* Cgen/emit-cop.scm 140 */
			     obj_t arg2024_1750;
			     arg2024_1750 =
				the_string_180_cgen_emit_cop_239(input_port_219_1720);
			     display_2_122___r4_output_6_10_3(arg2024_1750, _c_port__188_cgen_emit);
			  }
			  goto _anonymous_2021__143_1742;
			  break;
		       case ((long) 0):

			  {	/* Cgen/emit-cop.scm 133 */
			     obj_t str_1751;
			     str_1751 =
				the_string_180_cgen_emit_cop_239(input_port_219_1720);
			     {	/* Cgen/emit-cop.scm 133 */
				int len_1752;
				{	/* Cgen/emit-cop.scm 134 */
				   int res2258_2471;
				   {	/* ./Rgc/rgc.scm 4612 */
				      long aux_3921;
				      aux_3921 =
					 RGC_BUFFER_LENGTH(input_port_219_1720);
				      res2258_2471 =
					 (int) (aux_3921);
				   }
				   len_1752 = res2258_2471;
				}
				{	/* Cgen/emit-cop.scm 134 */
				   obj_t index_1753;
				   {	/* Cgen/emit-cop.scm 136 */
				      obj_t arg2027_1756;
				      {		/* ./Ieee/string.scm 8192 */
					 long aux_3924;
					 aux_3924 =
					    (long) (len_1752);
					 arg2027_1756 =
					    c_substring(str_1751, ((long) 1), aux_3924);
				      }
				      index_1753 =
					 string__number_104___r4_numbers_6_5(arg2027_1756, BNIL);
				   }
				   {	/* Cgen/emit-cop.scm 135 */

				      {		/* Cgen/emit-cop.scm 137 */
					 cop_bglt aux_3928;
					 {	/* Cgen/emit-cop.scm 137 */
					    obj_t aux_3929;
					    {	/* ./Ieee/vector.scm 8462 */
					       long aux_3930;
					       {	/* ./Ieee/fixnum.scm 7199 */
						  long aux_3931;
						  aux_3931 =
						     (long) CINT(index_1753);
						  aux_3930 =
						     (aux_3931 - ((long) 1));
					       }
					       aux_3929 =
						  VECTOR_REF(args_2775, aux_3930);
					    }
					    aux_3928 =
					       (cop_bglt) (aux_3929);
					 }
					 emit_cop_45_cgen_emit_cop_239(aux_3928);
				      }
				      goto _anonymous_2021__143_1742;
				   }
				}
			     }
			  }
			  break;
		       default:
			  FAILURE(string2319_cgen_emit_cop_239, string2320_cgen_emit_cop_239,
			     BINT(match_1743));
		       }
		  }
	       }
	    }
	 }
      }
   }
}



/* the-string */
obj_t 
the_string_180_cgen_emit_cop_239(obj_t input_port_219_2777)
{
   AN_OBJECT;
   {	/* Cgen/emit-cop.scm 131 */
      {		/* Cgen/emit-cop.scm 131 */
	 int arg2055_1789;
	 {	/* Cgen/emit-cop.scm 131 */
	    int res2260_2490;
	    {	/* ./Rgc/rgc.scm 4612 */
	       long aux_3941;
	       aux_3941 =
		  RGC_BUFFER_LENGTH(input_port_219_2777);
	       res2260_2490 =
		  (int) (aux_3941);
	    }
	    arg2055_1789 = res2260_2490;
	 }
	 {	/* ./Rgc/rgc.scm 4606 */
	    int aux_3944;
	    aux_3944 =
	       (int) (((long) 0));
	    return
	       rgc_buffer_substring(input_port_219_2777, aux_3944, arg2055_1789);
	 }
      }
   }
}



/* emit-cop-default1681 */
bool_t 
emit_cop_default1681_202_cgen_emit_cop_239(cop_bglt cop_16)
{
   AN_OBJECT;
   {	/* Cgen/emit-cop.scm 14 */
      FAILURE(
	 CNST_TABLE_REF(((long) 7)), string2321_cgen_emit_cop_239,
	 (obj_t) (cop_16));
   }
}



/* _emit-cop-default1681 */
obj_t 
_emit_cop_default1681_212_cgen_emit_cop_239(obj_t env_2771, obj_t cop_2772)
{
   AN_OBJECT;
   {	/* Cgen/emit-cop.scm 14 */
      {		/* Cgen/emit-cop.scm 14 */
	 bool_t aux_3950;
	 aux_3950 =
	    emit_cop_default1681_202_cgen_emit_cop_239(
	    (cop_bglt) (cop_2772));
	 return
	    BBOOL(aux_3950);
      }
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_cgen_emit_cop_239()
{
   AN_OBJECT;
   {	/* Cgen/emit-cop.scm 14 */
      module_initialization_70_tools_trace(((long) 0), "CGEN_EMIT-COP");
      module_initialization_70_type_type(((long) 0), "CGEN_EMIT-COP");
      module_initialization_70_type_tools(((long) 0), "CGEN_EMIT-COP");
      module_initialization_70_type_cache(((long) 0), "CGEN_EMIT-COP");
      module_initialization_70_engine_param(((long) 0), "CGEN_EMIT-COP");
      module_initialization_70_ast_var(((long) 0), "CGEN_EMIT-COP");
      module_initialization_70_ast_node(((long) 0), "CGEN_EMIT-COP");
      module_initialization_70_ast_env(((long) 0), "CGEN_EMIT-COP");
      module_initialization_70_cgen_emit(((long) 0), "CGEN_EMIT-COP");
      module_initialization_70_cgen_cop(((long) 0), "CGEN_EMIT-COP");
      return
	 module_initialization_70_module_module(((long) 0), "CGEN_EMIT-COP");
   }
}
