/*===========================================================================*/
/*   (Cgen/emit.scm)                                                         */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;

typedef struct cop
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
   *cop_bglt;

typedef struct clabel
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     obj_t name;
     bool_t used__226;
     obj_t body;
  }
      *clabel_bglt;

typedef struct cgoto
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct clabel *label;
  }
     *cgoto_bglt;

typedef struct block
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *body;
  }
     *block_bglt;

typedef struct creturn
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *value;
  }
       *creturn_bglt;

typedef struct cvoid
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *value;
  }
     *cvoid_bglt;

typedef struct catom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     obj_t value;
  }
     *catom_bglt;

typedef struct varc
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct variable *variable;
  }
    *varc_bglt;

typedef struct cpragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     obj_t format;
     obj_t args;
  }
       *cpragma_bglt;

typedef struct ccast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct cop *arg;
  }
     *ccast_bglt;

typedef struct csequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     bool_t c_exp__163;
     obj_t cops;
  }
         *csequence_bglt;

typedef struct nop
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
   *nop_bglt;

typedef struct stop
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *value;
  }
    *stop_bglt;

typedef struct csetq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct varc *var;
     struct cop *value;
  }
     *csetq_bglt;

typedef struct cif
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *test;
     struct cop *true;
     struct cop *false;
  }
   *cif_bglt;

typedef struct local_var_164
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     obj_t vars;
  }
             *local_var_164_bglt;

typedef struct cfuncall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *fun;
     obj_t args;
     obj_t strength;
  }
        *cfuncall_bglt;

typedef struct capply
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *fun;
     struct cop *arg;
  }
      *capply_bglt;

typedef struct capp
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *fun;
     obj_t args;
  }
    *capp_bglt;

typedef struct cfail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *proc;
     struct cop *msg;
     struct cop *obj;
  }
     *cfail_bglt;

typedef struct cswitch
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *test;
     obj_t clauses;
  }
       *cswitch_bglt;

typedef struct cmake_box_177
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *value;
  }
             *cmake_box_177_bglt;

typedef struct cbox_ref_44
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *var;
  }
           *cbox_ref_44_bglt;

typedef struct cbox_set__132
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *var;
     struct cop *value;
  }
             *cbox_set__132_bglt;

typedef struct cset_ex_it_123
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *exit;
     struct cop *jump_value_221;
     struct cop *body;
  }
              *cset_ex_it_123_bglt;

typedef struct cjump_ex_it_131
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *exit;
     struct cop *value;
  }
               *cjump_ex_it_131_bglt;

typedef struct sfun_c_188
  {
     struct clabel *label;
     bool_t integrated;
  }
          *sfun_c_188_bglt;

typedef struct bdb_block_21
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *body;
  }
            *bdb_block_21_bglt;


static obj_t _stop_emission__69_cgen_emit(obj_t);
extern obj_t _src_files__222_engine_param;
static obj_t method_init_76_cgen_emit();
static obj_t _start_emission_1850_27_cgen_emit(obj_t, obj_t);
extern obj_t current_output_port;
extern obj_t string_append(obj_t, obj_t);
extern obj_t bigloo_license_175_tools_license();
obj_t _c_port__188_cgen_emit = BUNSPEC;
static obj_t _emit_garbage_collector_selection_19_cgen_emit(obj_t);
static obj_t _emit_main_24_cgen_emit(obj_t);
extern obj_t stop_emission__231_cgen_emit();
extern obj_t emit_bdb_loc_8_cgen_emit_cop_239(obj_t);
extern obj_t module_initialization_70_cgen_emit(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_tools_license(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_cgen_cop(long, char *);
extern obj_t module_initialization_70_cgen_emit_cop_239(long, char *);
extern obj_t module_initialization_70___os(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_numbers_6_5(long, char *);
extern obj_t module_initialization_70___r4_numbers_6_5_fixnum(long, char *);
extern obj_t module_initialization_70___r4_input_6_10_2(long, char *);
extern obj_t module_initialization_70___r4_output_6_10_3(long, char *);
extern obj_t read_line_110___r4_input_6_10_2(obj_t);
static obj_t _emit_header_145_cgen_emit(obj_t);
extern obj_t emit_garbage_collector_selection_89_cgen_emit();
extern obj_t display_2_122___r4_output_6_10_3(obj_t, obj_t);
static obj_t imported_modules_init_94_cgen_emit();
extern obj_t emit_header_99_cgen_emit();
static obj_t _emit_debug_activation_100_cgen_emit(obj_t);
extern obj_t _dest__217_engine_param;
extern obj_t _additional_include_foreign__44_engine_param;
extern obj_t prefix___os(obj_t);
static obj_t library_modules_init_112_cgen_emit();
extern obj_t start_emission__101_cgen_emit(obj_t);
extern obj_t _user_heap_size__225_engine_param;
extern obj_t emit_include_217_cgen_emit();
static obj_t toplevel_init_63_cgen_emit();
extern obj_t open_input_string(obj_t);
extern obj_t _bigloo_licensing___64_engine_param;
extern obj_t _bigloo_author__68_engine_param;
extern char *integer__string_135___r4_numbers_6_5_fixnum(long, obj_t);
extern obj_t close_output_port(obj_t);
extern obj_t string_to_bstring(char *);
extern obj_t _bigloo_date__70_engine_param;
extern obj_t emit_comment_138_cgen_emit(obj_t, char);
extern obj_t memq___r4_pairs_and_lists_6_3(obj_t, obj_t);
static obj_t emit_license_138_cgen_emit();
extern obj_t close_input_port(obj_t);
extern obj_t _include_foreign__253_engine_param;
extern obj_t make_string(long, unsigned char);
extern obj_t c_substring(obj_t, long, long);
extern obj_t open_output_string();
static obj_t _emit_comment1851_103_cgen_emit(obj_t, obj_t, obj_t);
extern obj_t emit_main_179_cgen_emit();
extern obj_t _bigloo_name__170_engine_param;
static obj_t _emit_include_89_cgen_emit(obj_t);
extern obj_t emit_debug_activation_148_cgen_emit();
static long _max_col__89_cgen_emit;
extern bool_t _2__206___r4_numbers_6_5(obj_t, obj_t);
extern obj_t read___reader(obj_t);
extern obj_t _profile_mode__105_engine_param;
static obj_t _dest_prefix__46_cgen_emit = BUNSPEC;
extern obj_t _garbage_collector__95_engine_param;
extern obj_t open_output_file(obj_t);
static obj_t require_initialization_114_cgen_emit = BUNSPEC;
extern obj_t _pass__125_engine_param;
extern long _fx_15___r4_numbers_6_5_fixnum(long, long);
static obj_t cnst_init_137_cgen_emit();
extern obj_t reverse__39___r4_pairs_and_lists_6_3(obj_t);
static obj_t __cnst[4];

DEFINE_EXPORT_PROCEDURE(emit_garbage_collector_selection_env_133_cgen_emit, _emit_garbage_collector_selection_19_cgen_emit1879, _emit_garbage_collector_selection_19_cgen_emit, 0L, 0);
DEFINE_EXPORT_PROCEDURE(emit_main_env_112_cgen_emit, _emit_main_24_cgen_emit1880, _emit_main_24_cgen_emit, 0L, 0);
DEFINE_EXPORT_PROCEDURE(emit_header_env_184_cgen_emit, _emit_header_145_cgen_emit1881, _emit_header_145_cgen_emit, 0L, 0);
DEFINE_EXPORT_PROCEDURE(emit_comment_env_67_cgen_emit, _emit_comment1851_103_cgen_emit1882, _emit_comment1851_103_cgen_emit, 0L, 2);
DEFINE_EXPORT_PROCEDURE(stop_emission__env_198_cgen_emit, _stop_emission__69_cgen_emit1883, _stop_emission__69_cgen_emit, 0L, 0);
DEFINE_EXPORT_PROCEDURE(emit_include_env_152_cgen_emit, _emit_include_89_cgen_emit1884, _emit_include_89_cgen_emit, 0L, 0);
DEFINE_EXPORT_PROCEDURE(start_emission__env_25_cgen_emit, _start_emission_1850_27_cgen_emit1885, _start_emission_1850_27_cgen_emit, 0L, 1);
DEFINE_EXPORT_PROCEDURE(emit_debug_activation_env_82_cgen_emit, _emit_debug_activation_100_cgen_emit1886, _emit_debug_activation_100_cgen_emit, 0L, 0);
DEFINE_STRING(string1874_cgen_emit, string1874_cgen_emit1887, "BUMPY BOEHM --TO-STDOUT (CGEN DISTRIB CC CINDENT) ", 50);
DEFINE_STRING(string1873_cgen_emit, string1873_cgen_emit1888, "_bigloo_main(argc, argv);}", 26);
DEFINE_STRING(string1872_cgen_emit, string1872_cgen_emit1889, "extern long heap_size; heap_size = ", 35);
DEFINE_STRING(string1871_cgen_emit, string1871_cgen_emit1890, ";", 1);
DEFINE_STRING(string1869_cgen_emit, string1869_cgen_emit1891, "int BIGLOO_MAIN(int argc, char *argv[])", 39);
DEFINE_STRING(string1870_cgen_emit, string1870_cgen_emit1892, "{", 1);
DEFINE_STRING(string1868_cgen_emit, string1868_cgen_emit1893, "int bigloo_abort(long n) { return n; }", 38);
DEFINE_STRING(string1867_cgen_emit, string1867_cgen_emit1894, "extern int _bigloo_main();\n", 27);
DEFINE_STRING(string1866_cgen_emit, string1866_cgen_emit1895, "#define BIGLOO_DEBUG 1", 22);
DEFINE_STRING(string1865_cgen_emit, string1865_cgen_emit1896, "/* debug mode */", 16);
DEFINE_STRING(string1864_cgen_emit, string1864_cgen_emit1897, ">", 1);
DEFINE_STRING(string1863_cgen_emit, string1863_cgen_emit1898, "#include <", 10);
DEFINE_STRING(string1862_cgen_emit, string1862_cgen_emit1899, "Can't emit code for gc", 22);
DEFINE_STRING(string1861_cgen_emit, string1861_cgen_emit1900, "emit-garbage-collector-selection", 32);
DEFINE_STRING(string1859_cgen_emit, string1859_cgen_emit1901, "#define THE_GC BOEHM_GC", 23);
DEFINE_STRING(string1860_cgen_emit, string1860_cgen_emit1902, "#define BUMPY_GC\n", 17);
DEFINE_STRING(string1858_cgen_emit, string1858_cgen_emit1903, "#define THE_GC BOEHM_GC\n", 24);
DEFINE_STRING(string1857_cgen_emit, string1857_cgen_emit1904, "/* GC selection */", 18);
DEFINE_STRING(string1856_cgen_emit, string1856_cgen_emit1905, " (c)      ", 10);
DEFINE_STRING(string1855_cgen_emit, string1855_cgen_emit1906, "", 0);
DEFINE_STRING(string1854_cgen_emit, string1854_cgen_emit1907, "*/", 2);
DEFINE_STRING(string1853_cgen_emit, string1853_cgen_emit1908, "/*", 2);
DEFINE_STRING(string1852_cgen_emit, string1852_cgen_emit1909, "Can't open file for output", 26);



/* module-initialization */
obj_t 
module_initialization_70_cgen_emit(long checksum_1713, char *from_1714)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_cgen_emit))
	{
	   require_initialization_114_cgen_emit =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_cgen_emit();
	   cnst_init_137_cgen_emit();
	   imported_modules_init_94_cgen_emit();
	   method_init_76_cgen_emit();
	   toplevel_init_63_cgen_emit();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_cgen_emit()
{
   AN_OBJECT;
   {	/* Cgen/emit.scm 14 */
      module_initialization_70___r4_input_6_10_2(((long) 0), "CGEN_EMIT");
      module_initialization_70___r4_output_6_10_3(((long) 0), "CGEN_EMIT");
      module_initialization_70___os(((long) 0), "CGEN_EMIT");
      module_initialization_70___r4_numbers_6_5_fixnum(((long) 0), "CGEN_EMIT");
      module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "CGEN_EMIT");
      module_initialization_70___r4_numbers_6_5(((long) 0), "CGEN_EMIT");
      module_initialization_70___reader(((long) 0), "CGEN_EMIT");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_cgen_emit()
{
   AN_OBJECT;
   {	/* Cgen/emit.scm 14 */
      {		/* Cgen/emit.scm 14 */
	 obj_t cnst_port_138_1706;
	 cnst_port_138_1706 =
	    open_input_string(string1874_cgen_emit);
	 {
	    long i_1707;
	    i_1707 = ((long) 3);
	  loop_1708:
	    {	/* Cgen/emit.scm 14 */
	       bool_t test1875_1709;
	       test1875_1709 =
		  (i_1707 == ((long) -1));
	       if (test1875_1709)
		 {	/* Cgen/emit.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Cgen/emit.scm 14 */
		    {	/* Cgen/emit.scm 14 */
		       obj_t arg1876_1710;
		       {	/* Cgen/emit.scm 14 */
			  obj_t list1877_1711;
			  list1877_1711 =
			     MAKE_PAIR(cnst_port_138_1706, BNIL);
			  arg1876_1710 =
			     read___reader(list1877_1711);
		       }
		       CNST_TABLE_SET(i_1707, arg1876_1710);
		    }
		    {	/* Cgen/emit.scm 14 */
		       int aux_1712;
		       {	/* Cgen/emit.scm 14 */
			  long aux_1736;
			  aux_1736 =
			     (i_1707 - ((long) 1));
			  aux_1712 =
			     (int) (aux_1736);
		       }
		       {
			  long i_1739;
			  i_1739 =
			     (long) (aux_1712);
			  i_1707 = i_1739;
			  goto loop_1708;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_cgen_emit()
{
   AN_OBJECT;
   {	/* Cgen/emit.scm 14 */
      _dest_prefix__46_cgen_emit = BFALSE;
      _c_port__188_cgen_emit = BFALSE;
      return (
	 _max_col__89_cgen_emit = ((long) 79), BUNSPEC);
   }
}



/* start-emission! */
obj_t 
start_emission__101_cgen_emit(obj_t suffix_1)
{
   AN_OBJECT;
   {	/* Cgen/emit.scm 41 */
      {		/* Cgen/emit.scm 42 */
	 obj_t prefix_981;
	 {	/* Cgen/emit.scm 43 */
	    bool_t test1659_987;
	    {	/* Cgen/emit.scm 43 */
	       bool_t test1662_990;
	       {	/* Cgen/emit.scm 43 */
		  obj_t obj_1577;
		  obj_1577 = _dest__217_engine_param;
		  test1662_990 =
		     STRINGP(obj_1577);
	       }
	       if (test1662_990)
		 {	/* Cgen/emit.scm 44 */
		    obj_t aux_1743;
		    aux_1743 =
		       memq___r4_pairs_and_lists_6_3(_pass__125_engine_param,
		       CNST_TABLE_REF(((long) 0)));
		    test1659_987 =
		       CBOOL(aux_1743);
		 }
	       else
		 {	/* Cgen/emit.scm 43 */
		    test1659_987 = ((bool_t) 0);
		 }
	    }
	    if (test1659_987)
	      {		/* Cgen/emit.scm 43 */
		 prefix_981 =
		    prefix___os(_dest__217_engine_param);
	      }
	    else
	      {		/* Cgen/emit.scm 46 */
		 bool_t test1660_988;
		 {	/* Cgen/emit.scm 46 */
		    obj_t obj_1578;
		    obj_1578 = _src_files__222_engine_param;
		    test1660_988 =
		       PAIRP(obj_1578);
		 }
		 if (test1660_988)
		   {	/* Cgen/emit.scm 46 */
		      {		/* Cgen/emit.scm 47 */
			 obj_t arg1661_989;
			 {	/* Cgen/emit.scm 47 */
			    obj_t pair_1579;
			    pair_1579 = _src_files__222_engine_param;
			    arg1661_989 =
			       CAR(pair_1579);
			 }
			 prefix_981 =
			    prefix___os(arg1661_989);
		      }
		   }
		 else
		   {	/* Cgen/emit.scm 46 */
		      prefix_981 = BFALSE;
		   }
	      }
	 }
	 {	/* Cgen/emit.scm 42 */

	    {	/* Cgen/emit.scm 50 */
	       bool_t test1655_982;
	       {	/* Cgen/emit.scm 50 */
		  bool_t test1657_985;
		  {	/* Cgen/emit.scm 50 */
		     obj_t obj1_1580;
		     obj1_1580 = _dest__217_engine_param;
		     {	/* ./Ieee/equiv.scm 5508 */
			obj_t aux_1753;
			aux_1753 =
			   CNST_TABLE_REF(((long) 1));
			test1657_985 =
			   (obj1_1580 == aux_1753);
		     }
		  }
		  if (test1657_985)
		    {	/* Cgen/emit.scm 50 */
		       test1655_982 = ((bool_t) 1);
		    }
		  else
		    {	/* Cgen/emit.scm 50 */
		       if (
			  STRINGP(prefix_981))
			 {	/* Cgen/emit.scm 50 */
			    test1655_982 = ((bool_t) 0);
			 }
		       else
			 {	/* Cgen/emit.scm 50 */
			    test1655_982 = ((bool_t) 1);
			 }
		    }
	       }
	       if (test1655_982)
		 {	/* Cgen/emit.scm 50 */
		    return (
		       _c_port__188_cgen_emit = current_output_port, BUNSPEC);
		 }
	       else
		 {	/* Cgen/emit.scm 52 */
		    obj_t f_name_115_983;
		    f_name_115_983 =
		       string_append(prefix_981, suffix_1);
		    _dest_prefix__46_cgen_emit = prefix_981;
		    _c_port__188_cgen_emit =
		       open_output_file(f_name_115_983);
		    {	/* Cgen/emit.scm 55 */
		       bool_t test1656_984;
		       {	/* Cgen/emit.scm 55 */
			  obj_t obj_1584;
			  obj_1584 = _c_port__188_cgen_emit;
			  test1656_984 =
			     OUTPUT_PORTP(obj_1584);
		       }
		       if (test1656_984)
			 {	/* Cgen/emit.scm 55 */
			    return BUNSPEC;
			 }
		       else
			 {	/* Cgen/emit.scm 56 */
			    obj_t proc_1585;
			    proc_1585 = _bigloo_name__170_engine_param;
			    FAILURE(proc_1585, string1852_cgen_emit, f_name_115_983);
			 }
		    }
		 }
	    }
	 }
      }
   }
}



/* _start-emission!1850 */
obj_t 
_start_emission_1850_27_cgen_emit(obj_t env_1695, obj_t suffix_1696)
{
   AN_OBJECT;
   {	/* Cgen/emit.scm 41 */
      return
	 start_emission__101_cgen_emit(suffix_1696);
   }
}



/* stop-emission! */
obj_t 
stop_emission__231_cgen_emit()
{
   AN_OBJECT;
   {	/* Cgen/emit.scm 61 */
      {		/* Cgen/emit.scm 63 */
	 bool_t test1663_991;
	 {	/* Cgen/emit.scm 63 */
	    obj_t obj_1588;
	    obj_1588 = _c_port__188_cgen_emit;
	    test1663_991 =
	       OUTPUT_PORTP(obj_1588);
	 }
	 if (test1663_991)
	   {	/* Cgen/emit.scm 65 */
	      bool_t test1664_992;
	      {		/* Cgen/emit.scm 65 */
		 obj_t obj1_1589;
		 obj1_1589 = _c_port__188_cgen_emit;
		 test1664_992 =
		    (obj1_1589 == current_output_port);
	      }
	      if (test1664_992)
		{	/* Cgen/emit.scm 65 */
		   return BFALSE;
		}
	      else
		{	/* Cgen/emit.scm 65 */
		   {	/* Cgen/emit.scm 68 */
		      obj_t port_1591;
		      port_1591 = _c_port__188_cgen_emit;
		      FLUSH_OUTPUT_PORT(port_1591);
		   }
		   {	/* Cgen/emit.scm 69 */
		      obj_t port_1592;
		      port_1592 = _c_port__188_cgen_emit;
		      close_output_port(port_1592);
		   }
		   _c_port__188_cgen_emit = BFALSE;
		   return _dest_prefix__46_cgen_emit;
		}
	   }
	 else
	   {	/* Cgen/emit.scm 63 */
	      return BFALSE;
	   }
      }
   }
}



/* _stop-emission! */
obj_t 
_stop_emission__69_cgen_emit(obj_t env_1697)
{
   AN_OBJECT;
   {	/* Cgen/emit.scm 61 */
      return
	 stop_emission__231_cgen_emit();
   }
}



/* emit-comment */
obj_t 
emit_comment_138_cgen_emit(obj_t string_2, char fill_3)
{
   AN_OBJECT;
   {	/* Cgen/emit.scm 81 */
      {		/* Cgen/emit.scm 82 */
	 obj_t string_994;
	 {	/* Cgen/emit.scm 82 */
	    bool_t test_1773;
	    {	/* ./Ieee/fixnum.scm 7121 */
	       long aux_1776;
	       long aux_1774;
	       aux_1776 =
		  (((long) 79) - ((long) 8));
	       aux_1774 =
		  STRING_LENGTH(string_2);
	       test_1773 =
		  (aux_1774 > aux_1776);
	    }
	    if (test_1773)
	      {		/* ./Ieee/string.scm 8192 */
		 long aux_1779;
		 aux_1779 =
		    (((long) 79) - ((long) 9));
		 string_994 =
		    c_substring(string_2, ((long) 0), aux_1779);
	      }
	    else
	      {		/* Cgen/emit.scm 82 */
		 string_994 = string_2;
	      }
	 }
	 display_2_122___r4_output_6_10_3(string1853_cgen_emit, _c_port__188_cgen_emit);
	 {	/* Cgen/emit.scm 86 */
	    long len_995;
	    len_995 =
	       STRING_LENGTH(string_994);
	    if (
	       (len_995 == ((long) 0)))
	      {		/* Cgen/emit.scm 88 */
		 obj_t port1637_997;
		 port1637_997 = _c_port__188_cgen_emit;
		 {	/* Cgen/emit.scm 88 */
		    obj_t arg1667_998;
		    {	/* Cgen/emit.scm 88 */
		       long arg1669_999;
		       arg1669_999 =
			  (((long) 79) - ((long) 4));
		       {	/* Cgen/emit.scm 88 */
			  obj_t list1670_1000;
			  {	/* Cgen/emit.scm 88 */
			     obj_t aux_1787;
			     aux_1787 =
				BCHAR(fill_3);
			     list1670_1000 =
				MAKE_PAIR(aux_1787, BNIL);
			  }
			  {	/* Cgen/emit.scm 88 */
			     obj_t res1845_1614;
			     {	/* ./Ieee/string.scm 8055 */
				unsigned char aux_1794;
				long aux_1790;
				{	/* ./Ieee/string.scm 8055 */
				   obj_t aux_1795;
				   aux_1795 =
				      CAR(list1670_1000);
				   aux_1794 =
				      (unsigned char) CCHAR(aux_1795);
				}
				{	/* ./Ieee/string.scm 8055 */
				   int aux_1791;
				   aux_1791 =
				      (int) (arg1669_999);
				   aux_1790 =
				      (long) (aux_1791);
				}
				res1845_1614 =
				   make_string(aux_1790, aux_1794);
			     }
			     arg1667_998 = res1845_1614;
			  }
		       }
		    }
		    display_2_122___r4_output_6_10_3(arg1667_998, port1637_997);
		 }
		 display_2_122___r4_output_6_10_3(string1854_cgen_emit, port1637_997);
		 {	/* ./Ieee/output.scm 9332 */
		    unsigned char aux_1801;
		    aux_1801 =
		       WRITE_CHAR(((unsigned char) '\n'), port1637_997);
		    return
		       BCHAR(aux_1801);
		 }
	      }
	    else
	      {		/* Cgen/emit.scm 87 */
		 {	/* Cgen/emit.scm 90 */
		    obj_t arg1671_1001;
		    {	/* Cgen/emit.scm 90 */
		       obj_t list1672_1002;
		       {	/* Cgen/emit.scm 90 */
			  obj_t aux_1804;
			  aux_1804 =
			     BCHAR(fill_3);
			  list1672_1002 =
			     MAKE_PAIR(aux_1804, BNIL);
		       }
		       {	/* Cgen/emit.scm 90 */
			  obj_t res1846_1622;
			  {	/* ./Ieee/string.scm 8055 */
			     unsigned char aux_1811;
			     long aux_1807;
			     {	/* ./Ieee/string.scm 8055 */
				obj_t aux_1812;
				aux_1812 =
				   CAR(list1672_1002);
				aux_1811 =
				   (unsigned char) CCHAR(aux_1812);
			     }
			     {	/* ./Ieee/string.scm 8055 */
				int aux_1808;
				aux_1808 =
				   (int) (((long) 2));
				aux_1807 =
				   (long) (aux_1808);
			     }
			     res1846_1622 =
				make_string(aux_1807, aux_1811);
			  }
			  arg1671_1001 = res1846_1622;
		       }
		    }
		    display_2_122___r4_output_6_10_3(arg1671_1001, _c_port__188_cgen_emit);
		 }
		 display_2_122___r4_output_6_10_3(
		    BCHAR(((unsigned char) ' ')), _c_port__188_cgen_emit);
		 display_2_122___r4_output_6_10_3(string_994, _c_port__188_cgen_emit);
		 display_2_122___r4_output_6_10_3(
		    BCHAR(((unsigned char) ' ')), _c_port__188_cgen_emit);
		 {	/* Cgen/emit.scm 94 */
		    obj_t port1638_1003;
		    port1638_1003 = _c_port__188_cgen_emit;
		    {	/* Cgen/emit.scm 95 */
		       obj_t arg1673_1004;
		       {	/* Cgen/emit.scm 95 */
			  long arg1674_1005;
			  {	/* ./Ieee/fixnum.scm 7199 */
			     long aux_1822;
			     {	/* Cgen/emit.scm 95 */
				obj_t aux_1823;
				{	/* Cgen/emit.scm 95 */
				   long aux_1824;
				   aux_1824 =
				      _fx_15___r4_numbers_6_5_fixnum(((long) 8), len_995);
				   aux_1823 =
				      BINT(aux_1824);
				}
				aux_1822 =
				   (long) CINT(aux_1823);
			     }
			     arg1674_1005 =
				(((long) 79) - aux_1822);
			  }
			  {	/* Cgen/emit.scm 95 */
			     obj_t list1675_1006;
			     {	/* Cgen/emit.scm 95 */
				obj_t aux_1829;
				aux_1829 =
				   BCHAR(fill_3);
				list1675_1006 =
				   MAKE_PAIR(aux_1829, BNIL);
			     }
			     {	/* Cgen/emit.scm 95 */
				obj_t res1847_1631;
				{	/* ./Ieee/string.scm 8055 */
				   unsigned char aux_1836;
				   long aux_1832;
				   {	/* ./Ieee/string.scm 8055 */
				      obj_t aux_1837;
				      aux_1837 =
					 CAR(list1675_1006);
				      aux_1836 =
					 (unsigned char) CCHAR(aux_1837);
				   }
				   {	/* ./Ieee/string.scm 8055 */
				      int aux_1833;
				      aux_1833 =
					 (int) (arg1674_1005);
				      aux_1832 =
					 (long) (aux_1833);
				   }
				   res1847_1631 =
				      make_string(aux_1832, aux_1836);
				}
				arg1673_1004 = res1847_1631;
			     }
			  }
		       }
		       display_2_122___r4_output_6_10_3(arg1673_1004, port1638_1003);
		    }
		    display_2_122___r4_output_6_10_3(string1854_cgen_emit, port1638_1003);
		    {	/* ./Ieee/output.scm 9332 */
		       unsigned char aux_1843;
		       aux_1843 =
			  WRITE_CHAR(((unsigned char) '\n'), port1638_1003);
		       return
			  BCHAR(aux_1843);
		    }
		 }
	      }
	 }
      }
   }
}



/* _emit-comment1851 */
obj_t 
_emit_comment1851_103_cgen_emit(obj_t env_1698, obj_t string_1699, obj_t fill_1700)
{
   AN_OBJECT;
   {	/* Cgen/emit.scm 81 */
      return
	 emit_comment_138_cgen_emit(string_1699,
	 CCHAR(fill_1700));
   }
}



/* emit-license */
obj_t 
emit_license_138_cgen_emit()
{
   AN_OBJECT;
   {	/* Cgen/emit.scm 101 */
      {		/* Cgen/emit.scm 102 */
	 obj_t in_1013;
	 {	/* Cgen/emit.scm 102 */
	    obj_t arg1687_1021;
	    arg1687_1021 =
	       bigloo_license_175_tools_license();
	    in_1013 =
	       open_input_string(arg1687_1021);
	 }
	 {
	    obj_t str_1014;
	    {	/* Cgen/emit.scm 103 */
	       obj_t arg1682_1016;
	       {	/* Cgen/emit.scm 103 */
		  obj_t list1683_1017;
		  list1683_1017 =
		     MAKE_PAIR(in_1013, BNIL);
		  arg1682_1016 =
		     read_line_110___r4_input_6_10_2(list1683_1017);
	       }
	       str_1014 = arg1682_1016;
	     loop_1015:
	       {	/* Cgen/emit.scm 104 */
		  bool_t test1684_1018;
		  test1684_1018 =
		     EOF_OBJECTP(str_1014);
		  if (test1684_1018)
		    {	/* Cgen/emit.scm 104 */
		       return
			  close_input_port(in_1013);
		    }
		  else
		    {	/* Cgen/emit.scm 104 */
		       emit_comment_138_cgen_emit(str_1014,
			  (char) (((unsigned char) ' ')));
		       {	/* Cgen/emit.scm 108 */
			  obj_t arg1685_1019;
			  {	/* Cgen/emit.scm 108 */
			     obj_t list1686_1020;
			     list1686_1020 =
				MAKE_PAIR(in_1013, BNIL);
			     arg1685_1019 =
				read_line_110___r4_input_6_10_2(list1686_1020);
			  }
			  {
			     obj_t str_1859;
			     str_1859 = arg1685_1019;
			     str_1014 = str_1859;
			     goto loop_1015;
			  }
		       }
		    }
	       }
	    }
	 }
      }
   }
}



/* emit-header */
obj_t 
emit_header_99_cgen_emit()
{
   AN_OBJECT;
   {	/* Cgen/emit.scm 113 */
      emit_comment_138_cgen_emit(string1855_cgen_emit,
	 (char) (((unsigned char) '=')));
      {		/* Cgen/emit.scm 115 */
	 obj_t arg1688_1022;
	 {	/* Cgen/emit.scm 115 */
	    obj_t p_1023;
	    p_1023 =
	       open_output_string();
	    display_2_122___r4_output_6_10_3(_src_files__222_engine_param, p_1023);
	    arg1688_1022 =
	       close_output_port(p_1023);
	 }
	 emit_comment_138_cgen_emit(arg1688_1022,
	    (char) (((unsigned char) ' ')));
      }
      emit_comment_138_cgen_emit(_bigloo_name__170_engine_param,
	 (char) (((unsigned char) ' ')));
      {		/* Cgen/emit.scm 120 */
	 obj_t arg1689_1024;
	 {	/* Cgen/emit.scm 120 */
	    obj_t arg1690_1025;
	    arg1690_1025 =
	       string_append(string1856_cgen_emit, _bigloo_date__70_engine_param);
	    arg1689_1024 =
	       string_append(_bigloo_author__68_engine_param, arg1690_1025);
	 }
	 emit_comment_138_cgen_emit(arg1689_1024,
	    (char) (((unsigned char) ' ')));
      }
      if (
	 CBOOL(_bigloo_licensing___64_engine_param))
	{	/* Cgen/emit.scm 122 */
	   emit_license_138_cgen_emit();
	}
      else
	{	/* Cgen/emit.scm 122 */
	   BUNSPEC;
	}
      emit_comment_138_cgen_emit(string1855_cgen_emit,
	 (char) (((unsigned char) '=')));
      {		/* Cgen/emit.scm 124 */
	 obj_t port_1637;
	 port_1637 = _c_port__188_cgen_emit;
	 {	/* ./Ieee/output.scm 9332 */
	    unsigned char aux_1878;
	    aux_1878 =
	       WRITE_CHAR(((unsigned char) '\n'), port_1637);
	    return
	       BCHAR(aux_1878);
	 }
      }
   }
}



/* _emit-header */
obj_t 
_emit_header_145_cgen_emit(obj_t env_1701)
{
   AN_OBJECT;
   {	/* Cgen/emit.scm 113 */
      return
	 emit_header_99_cgen_emit();
   }
}



/* emit-garbage-collector-selection */
obj_t 
emit_garbage_collector_selection_89_cgen_emit()
{
   AN_OBJECT;
   {	/* Cgen/emit.scm 129 */
      {		/* Cgen/emit.scm 130 */
	 obj_t port1639_1026;
	 port1639_1026 = _c_port__188_cgen_emit;
	 display_2_122___r4_output_6_10_3(string1857_cgen_emit, port1639_1026);
	 WRITE_CHAR(((unsigned char) '\n'), port1639_1026);
      }
      {		/* Cgen/emit.scm 131 */
	 obj_t case_value_58_1027;
	 case_value_58_1027 = _garbage_collector__95_engine_param;
	 {	/* Cgen/emit.scm 131 */
	    bool_t test_1884;
	    {	/* ./Ieee/equiv.scm 5508 */
	       obj_t aux_1885;
	       aux_1885 =
		  CNST_TABLE_REF(((long) 2));
	       test_1884 =
		  (case_value_58_1027 == aux_1885);
	    }
	    if (test_1884)
	      {		/* Cgen/emit.scm 133 */
		 obj_t port1640_1029;
		 port1640_1029 = _c_port__188_cgen_emit;
		 display_2_122___r4_output_6_10_3(string1858_cgen_emit, port1640_1029);
		 {	/* ./Ieee/output.scm 9332 */
		    unsigned char aux_1889;
		    aux_1889 =
		       WRITE_CHAR(((unsigned char) '\n'), port1640_1029);
		    return
		       BCHAR(aux_1889);
		 }
	      }
	    else
	      {		/* Cgen/emit.scm 131 */
		 bool_t test_1892;
		 {	/* ./Ieee/equiv.scm 5508 */
		    obj_t aux_1893;
		    aux_1893 =
		       CNST_TABLE_REF(((long) 3));
		    test_1892 =
		       (case_value_58_1027 == aux_1893);
		 }
		 if (test_1892)
		   {	/* Cgen/emit.scm 131 */
		      {		/* Cgen/emit.scm 135 */
			 obj_t port1641_1031;
			 port1641_1031 = _c_port__188_cgen_emit;
			 display_2_122___r4_output_6_10_3(string1859_cgen_emit, port1641_1031);
			 WRITE_CHAR(((unsigned char) '\n'), port1641_1031);
		      }
		      {		/* Cgen/emit.scm 136 */
			 obj_t port1642_1032;
			 port1642_1032 = _c_port__188_cgen_emit;
			 display_2_122___r4_output_6_10_3(string1860_cgen_emit, port1642_1032);
			 {	/* ./Ieee/output.scm 9332 */
			    unsigned char aux_1899;
			    aux_1899 =
			       WRITE_CHAR(((unsigned char) '\n'), port1642_1032);
			    return
			       BCHAR(aux_1899);
			 }
		      }
		   }
		 else
		   {	/* Cgen/emit.scm 138 */
		      obj_t object_1648;
		      object_1648 = _garbage_collector__95_engine_param;
		      FAILURE(string1861_cgen_emit, string1862_cgen_emit, object_1648);
		   }
	      }
	 }
      }
   }
}



/* _emit-garbage-collector-selection */
obj_t 
_emit_garbage_collector_selection_19_cgen_emit(obj_t env_1702)
{
   AN_OBJECT;
   {	/* Cgen/emit.scm 129 */
      return
	 emit_garbage_collector_selection_89_cgen_emit();
   }
}



/* emit-include */
obj_t 
emit_include_217_cgen_emit()
{
   AN_OBJECT;
   {	/* Cgen/emit.scm 145 */
      {
	 obj_t l1643_1033;
	 {	/* Cgen/emit.scm 148 */
	    obj_t arg1693_1035;
	    arg1693_1035 =
	       reverse__39___r4_pairs_and_lists_6_3(_include_foreign__253_engine_param);
	    l1643_1033 = arg1693_1035;
	  lname1644_1034:
	    if (
	       PAIRP(l1643_1033))
	      {		/* Cgen/emit.scm 147 */
		 {	/* Cgen/emit.scm 147 */
		    obj_t i_1037;
		    i_1037 =
		       CAR(l1643_1033);
		    {	/* Cgen/emit.scm 147 */
		       obj_t port1645_1038;
		       port1645_1038 = _c_port__188_cgen_emit;
		       display_2_122___r4_output_6_10_3(string1863_cgen_emit, port1645_1038);
		       display_2_122___r4_output_6_10_3(i_1037, port1645_1038);
		       display_2_122___r4_output_6_10_3(string1864_cgen_emit, port1645_1038);
		       WRITE_CHAR(((unsigned char) '\n'), port1645_1038);
		    }
		 }
		 {
		    obj_t l1643_1912;
		    l1643_1912 =
		       CDR(l1643_1033);
		    l1643_1033 = l1643_1912;
		    goto lname1644_1034;
		 }
	      }
	    else
	      {		/* Cgen/emit.scm 147 */
		 ((bool_t) 1);
	      }
	 }
      }
      {
	 obj_t l1646_1040;
	 {	/* Cgen/emit.scm 151 */
	    obj_t arg1696_1042;
	    arg1696_1042 =
	       reverse__39___r4_pairs_and_lists_6_3(_additional_include_foreign__44_engine_param);
	    l1646_1040 = arg1696_1042;
	  lname1647_1041:
	    if (
	       PAIRP(l1646_1040))
	      {		/* Cgen/emit.scm 150 */
		 {	/* Cgen/emit.scm 150 */
		    obj_t i_1044;
		    i_1044 =
		       CAR(l1646_1040);
		    {	/* Cgen/emit.scm 150 */
		       obj_t port1648_1045;
		       port1648_1045 = _c_port__188_cgen_emit;
		       display_2_122___r4_output_6_10_3(string1863_cgen_emit, port1648_1045);
		       display_2_122___r4_output_6_10_3(i_1044, port1648_1045);
		       display_2_122___r4_output_6_10_3(string1864_cgen_emit, port1648_1045);
		       WRITE_CHAR(((unsigned char) '\n'), port1648_1045);
		    }
		 }
		 {
		    obj_t l1646_1922;
		    l1646_1922 =
		       CDR(l1646_1040);
		    l1646_1040 = l1646_1922;
		    goto lname1647_1041;
		 }
	      }
	    else
	      {		/* Cgen/emit.scm 150 */
		 ((bool_t) 1);
	      }
	 }
      }
      {		/* Cgen/emit.scm 152 */
	 obj_t port_1657;
	 port_1657 = _c_port__188_cgen_emit;
	 {	/* ./Ieee/output.scm 9332 */
	    unsigned char aux_1924;
	    aux_1924 =
	       WRITE_CHAR(((unsigned char) '\n'), port_1657);
	    return
	       BCHAR(aux_1924);
	 }
      }
   }
}



/* _emit-include */
obj_t 
_emit_include_89_cgen_emit(obj_t env_1703)
{
   AN_OBJECT;
   {	/* Cgen/emit.scm 145 */
      return
	 emit_include_217_cgen_emit();
   }
}



/* emit-debug-activation */
obj_t 
emit_debug_activation_148_cgen_emit()
{
   AN_OBJECT;
   {	/* Cgen/emit.scm 157 */
      {		/* Cgen/emit.scm 158 */
	 obj_t port1649_1047;
	 port1649_1047 = _c_port__188_cgen_emit;
	 display_2_122___r4_output_6_10_3(string1865_cgen_emit, port1649_1047);
	 WRITE_CHAR(((unsigned char) '\n'), port1649_1047);
      }
      {		/* Cgen/emit.scm 159 */
	 obj_t port1650_1048;
	 port1650_1048 = _c_port__188_cgen_emit;
	 display_2_122___r4_output_6_10_3(string1866_cgen_emit, port1650_1048);
	 WRITE_CHAR(((unsigned char) '\n'), port1650_1048);
      }
      {		/* Cgen/emit.scm 160 */
	 obj_t port_1660;
	 port_1660 = _c_port__188_cgen_emit;
	 {	/* ./Ieee/output.scm 9332 */
	    unsigned char aux_1932;
	    aux_1932 =
	       WRITE_CHAR(((unsigned char) '\n'), port_1660);
	    return
	       BCHAR(aux_1932);
	 }
      }
   }
}



/* _emit-debug-activation */
obj_t 
_emit_debug_activation_100_cgen_emit(obj_t env_1704)
{
   AN_OBJECT;
   {	/* Cgen/emit.scm 157 */
      return
	 emit_debug_activation_148_cgen_emit();
   }
}



/* emit-main */
obj_t 
emit_main_179_cgen_emit()
{
   AN_OBJECT;
   {	/* Cgen/emit.scm 165 */
      {		/* Cgen/emit.scm 166 */
	 obj_t port1651_1049;
	 port1651_1049 = _c_port__188_cgen_emit;
	 display_2_122___r4_output_6_10_3(string1867_cgen_emit, port1651_1049);
	 WRITE_CHAR(((unsigned char) '\n'), port1651_1049);
      }
      emit_bdb_loc_8_cgen_emit_cop_239(BUNSPEC);
      {		/* Cgen/emit.scm 173 */
	 obj_t port1652_1050;
	 port1652_1050 = _c_port__188_cgen_emit;
	 display_2_122___r4_output_6_10_3(string1868_cgen_emit, port1652_1050);
	 WRITE_CHAR(((unsigned char) '\n'), port1652_1050);
      }
      emit_bdb_loc_8_cgen_emit_cop_239(BUNSPEC);
      {		/* Cgen/emit.scm 175 */
	 obj_t port1653_1051;
	 port1653_1051 = _c_port__188_cgen_emit;
	 display_2_122___r4_output_6_10_3(string1869_cgen_emit, port1653_1051);
	 WRITE_CHAR(((unsigned char) '\n'), port1653_1051);
      }
      {		/* Cgen/emit.scm 176 */
	 obj_t port1654_1052;
	 port1654_1052 = _c_port__188_cgen_emit;
	 display_2_122___r4_output_6_10_3(string1870_cgen_emit, port1654_1052);
	 {	/* Cgen/emit.scm 178 */
	    obj_t arg1699_1053;
	    {	/* Cgen/emit.scm 178 */
	       bool_t test1700_1054;
	       {	/* Cgen/emit.scm 178 */
		  bool_t res1848_1668;
		  {	/* Cgen/emit.scm 178 */
		     obj_t obj_1664;
		     obj_1664 = _user_heap_size__225_engine_param;
		     if (
			INTEGERP(obj_1664))
		       {	/* ./Ieee/number.scm 6283 */
			  res1848_1668 = ((bool_t) 1);
		       }
		     else
		       {	/* ./Ieee/number.scm 6283 */
			  res1848_1668 =
			     REALP(obj_1664);
		       }
		  }
		  test1700_1054 = res1848_1668;
	       }
	       if (test1700_1054)
		 {	/* Cgen/emit.scm 179 */
		    obj_t arg1702_1056;
		    {	/* Cgen/emit.scm 180 */
		       char *arg1703_1057;
		       arg1703_1057 =
			  integer__string_135___r4_numbers_6_5_fixnum(
			  (long) CINT(_user_heap_size__225_engine_param), BNIL);
		       {	/* Cgen/emit.scm 179 */
			  obj_t aux_1951;
			  aux_1951 =
			     string_to_bstring(arg1703_1057);
			  arg1702_1056 =
			     string_append(aux_1951, string1871_cgen_emit);
		       }
		    }
		    arg1699_1053 =
		       string_append(string1872_cgen_emit, arg1702_1056);
		 }
	       else
		 {	/* Cgen/emit.scm 178 */
		    arg1699_1053 = string1855_cgen_emit;
		 }
	    }
	    display_2_122___r4_output_6_10_3(arg1699_1053, port1654_1052);
	 }
	 {	/* Cgen/emit.scm 183 */
	    char *arg1706_1060;
	    {	/* Cgen/emit.scm 183 */
	       bool_t test1707_1061;
	       {	/* Cgen/emit.scm 183 */
		  bool_t test1708_1062;
		  {	/* Cgen/emit.scm 183 */
		     bool_t res1849_1673;
		     {	/* Cgen/emit.scm 183 */
			obj_t obj_1669;
			obj_1669 = _profile_mode__105_engine_param;
			if (
			   INTEGERP(obj_1669))
			  {	/* ./Ieee/number.scm 6283 */
			     res1849_1673 = ((bool_t) 1);
			  }
			else
			  {	/* ./Ieee/number.scm 6283 */
			     res1849_1673 =
				REALP(obj_1669);
			  }
		     }
		     test1708_1062 = res1849_1673;
		  }
		  if (test1708_1062)
		    {	/* Cgen/emit.scm 183 */
		       test1707_1061 =
			  _2__206___r4_numbers_6_5(_profile_mode__105_engine_param,
			  BINT(((long) 0)));
		    }
		  else
		    {	/* Cgen/emit.scm 183 */
		       test1707_1061 = ((bool_t) 0);
		    }
	       }
	       if (test1707_1061)
		 {	/* Cgen/emit.scm 183 */
		    arg1706_1060 = "GC_profile_start();";
		 }
	       else
		 {	/* Cgen/emit.scm 183 */
		    arg1706_1060 = "";
		 }
	    }
	    display_2_122___r4_output_6_10_3(
	       string_to_bstring(arg1706_1060), port1654_1052);
	 }
	 display_2_122___r4_output_6_10_3(string1873_cgen_emit, port1654_1052);
	 WRITE_CHAR(((unsigned char) '\n'), port1654_1052);
      }
      {		/* Cgen/emit.scm 187 */
	 obj_t port_1675;
	 port_1675 = _c_port__188_cgen_emit;
	 {	/* ./Ieee/output.scm 9332 */
	    unsigned char aux_1967;
	    aux_1967 =
	       WRITE_CHAR(((unsigned char) '\n'), port_1675);
	    return
	       BCHAR(aux_1967);
	 }
      }
   }
}



/* _emit-main */
obj_t 
_emit_main_24_cgen_emit(obj_t env_1705)
{
   AN_OBJECT;
   {	/* Cgen/emit.scm 165 */
      return
	 emit_main_179_cgen_emit();
   }
}



/* method-init */
obj_t 
method_init_76_cgen_emit()
{
   AN_OBJECT;
   {	/* Cgen/emit.scm 14 */
      return BUNSPEC;
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_cgen_emit()
{
   AN_OBJECT;
   {	/* Cgen/emit.scm 14 */
      module_initialization_70_engine_param(((long) 0), "CGEN_EMIT");
      module_initialization_70_tools_license(((long) 0), "CGEN_EMIT");
      module_initialization_70_type_type(((long) 0), "CGEN_EMIT");
      module_initialization_70_ast_var(((long) 0), "CGEN_EMIT");
      module_initialization_70_ast_node(((long) 0), "CGEN_EMIT");
      module_initialization_70_cgen_cop(((long) 0), "CGEN_EMIT");
      return
	 module_initialization_70_cgen_emit_cop_239(((long) 0), "CGEN_EMIT");
   }
}
