/*===========================================================================*/
/*   (Cgen/init.scm)                                                         */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct ccomp
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t producer;
     obj_t consumer;
     obj_t finalizer;
     obj_t checksummer;
  }
     *ccomp_bglt;

typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;


extern obj_t _long__149_type_cache;
static obj_t method_init_76_cgen_init();
extern obj_t _module_checksum__252_module_module;
extern obj_t _obj__252_type_cache;
extern obj_t module_initialization_70_cgen_init(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_module_module(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_ast_env(long, char *);
extern obj_t module_initialization_70_ast_sexp(long, char *);
extern obj_t module_initialization_70_ast_local(long, char *);
extern obj_t module_initialization_70_ast_glo_def_117(long, char *);
extern obj_t module_initialization_70_ast_unit(long, char *);
extern obj_t module_initialization_70_ast_occur(long, char *);
extern obj_t module_initialization_70_coerce_coerce(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t _unsafe_version__81_engine_param;
extern local_bglt make_local_svar_140_ast_local(obj_t, type_bglt);
extern obj_t module_initialization_id_110_module_module(obj_t);
static obj_t imported_modules_init_94_cgen_init();
extern node_bglt coerce__182_coerce_coerce(node_bglt, type_bglt);
static obj_t _make_module_init_166_cgen_init(obj_t);
extern obj_t append_2_18___r4_pairs_and_lists_6_3(obj_t, obj_t);
static obj_t library_modules_init_112_cgen_init();
extern obj_t occur_node_in__115_ast_occur(node_bglt, global_bglt);
extern node_bglt sexp__node_235_ast_sexp(obj_t, obj_t, obj_t, obj_t);
extern obj_t _unsafe_type__146_engine_param;
extern obj_t unit_init_calls_56_ast_unit();
extern obj_t open_input_string(obj_t);
extern obj_t make_module_init_70_cgen_init();
extern global_bglt def_global_sfun_no_warning__10_ast_glo_def_117(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t _module__166_module_module;
extern obj_t read___reader(obj_t);
extern global_bglt def_global_svar__184_ast_glo_def_117(obj_t, obj_t, obj_t, obj_t);
extern obj_t _string__3_type_cache;
extern obj_t ____74_type_cache;
static obj_t require_initialization_114_cgen_init = BUNSPEC;
static obj_t cnst_init_137_cgen_init();
static obj_t __cnst[16];

DEFINE_EXPORT_PROCEDURE(make_module_init_env_79_cgen_init, _make_module_init_166_cgen_init1588, _make_module_init_166_cgen_init, 0L, 0);
DEFINE_STRING(string1583_cgen_init, string1583_cgen_init1589, "EXPORT MODULE-INITIALIZATION SFUN (CHECKSUM FROM) VALUE FROM MODULE-INIT-ERROR CHECKSUM PRAGMA::BOOL SET! BEGIN REQUIRE-INITIALIZATION IF NOW MODULE-INITALIZATION REQUIRE-INITIALIZATION::OBJ ", 191);
DEFINE_STRING(string1582_cgen_init, string1582_cgen_init1590, "((($1) & ($2)) == ($1))", 23);



/* module-initialization */
obj_t 
module_initialization_70_cgen_init(long checksum_1156, char *from_1157)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_cgen_init))
	{
	   require_initialization_114_cgen_init =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_cgen_init();
	   cnst_init_137_cgen_init();
	   imported_modules_init_94_cgen_init();
	   method_init_76_cgen_init();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_cgen_init()
{
   AN_OBJECT;
   {	/* Cgen/init.scm 14 */
      module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "CGEN_INIT");
      module_initialization_70___reader(((long) 0), "CGEN_INIT");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_cgen_init()
{
   AN_OBJECT;
   {	/* Cgen/init.scm 14 */
      {		/* Cgen/init.scm 14 */
	 obj_t cnst_port_138_1149;
	 cnst_port_138_1149 =
	    open_input_string(string1583_cgen_init);
	 {
	    long i_1150;
	    i_1150 = ((long) 15);
	  loop_1151:
	    {	/* Cgen/init.scm 14 */
	       bool_t test1584_1152;
	       test1584_1152 =
		  (i_1150 == ((long) -1));
	       if (test1584_1152)
		 {	/* Cgen/init.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Cgen/init.scm 14 */
		    {	/* Cgen/init.scm 14 */
		       obj_t arg1585_1153;
		       {	/* Cgen/init.scm 14 */
			  obj_t list1586_1154;
			  list1586_1154 =
			     MAKE_PAIR(cnst_port_138_1149, BNIL);
			  arg1585_1153 =
			     read___reader(list1586_1154);
		       }
		       CNST_TABLE_SET(i_1150, arg1585_1153);
		    }
		    {	/* Cgen/init.scm 14 */
		       int aux_1155;
		       {	/* Cgen/init.scm 14 */
			  long aux_1173;
			  aux_1173 =
			     (i_1150 - ((long) 1));
			  aux_1155 =
			     (int) (aux_1173);
		       }
		       {
			  long i_1176;
			  i_1176 =
			     (long) (aux_1155);
			  i_1150 = i_1176;
			  goto loop_1151;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* make-module-init */
obj_t 
make_module_init_70_cgen_init()
{
   AN_OBJECT;
   {	/* Cgen/init.scm 34 */
      {		/* Cgen/init.scm 35 */
	 global_bglt req_707;
	 req_707 =
	    def_global_svar__184_ast_glo_def_117(
	    CNST_TABLE_REF(((long) 0)), _module__166_module_module,
	    CNST_TABLE_REF(((long) 1)),
	    CNST_TABLE_REF(((long) 2)));
	 {	/* Cgen/init.scm 35 */
	    obj_t ubody_708;
	    {	/* Cgen/init.scm 39 */
	       obj_t arg1481_748;
	       obj_t arg1482_749;
	       arg1481_748 =
		  CNST_TABLE_REF(((long) 3));
	       {	/* Cgen/init.scm 39 */
		  obj_t arg1483_750;
		  obj_t arg1484_751;
		  arg1483_750 =
		     CNST_TABLE_REF(((long) 4));
		  {	/* Cgen/init.scm 40 */
		     obj_t arg1485_752;
		     obj_t arg1486_753;
		     {	/* Cgen/init.scm 40 */
			obj_t arg1488_754;
			obj_t arg1489_755;
			arg1488_754 =
			   CNST_TABLE_REF(((long) 5));
			{	/* Cgen/init.scm 41 */
			   obj_t arg1490_756;
			   obj_t arg1491_757;
			   {	/* Cgen/init.scm 41 */
			      obj_t arg1493_758;
			      obj_t arg1494_759;
			      arg1493_758 =
				 CNST_TABLE_REF(((long) 6));
			      {		/* Cgen/init.scm 41 */
				 obj_t arg1495_760;
				 obj_t arg1496_761;
				 arg1495_760 =
				    CNST_TABLE_REF(((long) 4));
				 arg1496_761 =
				    MAKE_PAIR(BFALSE, BNIL);
				 arg1494_759 =
				    MAKE_PAIR(arg1495_760, arg1496_761);
			      }
			      arg1490_756 =
				 MAKE_PAIR(arg1493_758, arg1494_759);
			   }
			   {	/* Cgen/init.scm 42 */
			      obj_t arg1497_762;
			      obj_t arg1498_763;
			      arg1497_762 =
				 unit_init_calls_56_ast_unit();
			      arg1498_763 =
				 MAKE_PAIR(BUNSPEC, BNIL);
			      arg1491_757 =
				 append_2_18___r4_pairs_and_lists_6_3(arg1497_762, arg1498_763);
			   }
			   arg1489_755 =
			      MAKE_PAIR(arg1490_756, arg1491_757);
			}
			arg1485_752 =
			   MAKE_PAIR(arg1488_754, arg1489_755);
		     }
		     arg1486_753 =
			MAKE_PAIR(BUNSPEC, BNIL);
		     arg1484_751 =
			MAKE_PAIR(arg1485_752, arg1486_753);
		  }
		  arg1482_749 =
		     MAKE_PAIR(arg1483_750, arg1484_751);
	       }
	       ubody_708 =
		  MAKE_PAIR(arg1481_748, arg1482_749);
	    }
	    {	/* Cgen/init.scm 39 */
	       obj_t body_709;
	       if (
		  CBOOL(_unsafe_version__81_engine_param))
		 {	/* Cgen/init.scm 45 */
		    body_709 = ubody_708;
		 }
	       else
		 {	/* Cgen/init.scm 47 */
		    obj_t arg1462_731;
		    obj_t arg1463_732;
		    arg1462_731 =
		       CNST_TABLE_REF(((long) 3));
		    {	/* Cgen/init.scm 47 */
		       obj_t arg1464_733;
		       obj_t arg1466_734;
		       {	/* Cgen/init.scm 47 */
			  obj_t arg1467_735;
			  obj_t arg1469_736;
			  arg1467_735 =
			     CNST_TABLE_REF(((long) 7));
			  {	/* Cgen/init.scm 47 */
			     obj_t arg1471_738;
			     {	/* Cgen/init.scm 47 */
				obj_t arg1472_739;
				obj_t arg1473_740;
				arg1472_739 =
				   CNST_TABLE_REF(((long) 8));
				{	/* Cgen/init.scm 47 */
				   obj_t obj1_1119;
				   obj1_1119 = _module_checksum__252_module_module;
				   arg1473_740 =
				      MAKE_PAIR(obj1_1119, BNIL);
				}
				arg1471_738 =
				   MAKE_PAIR(arg1472_739, arg1473_740);
			     }
			     arg1469_736 =
				MAKE_PAIR(string1582_cgen_init, arg1471_738);
			  }
			  arg1464_733 =
			     MAKE_PAIR(arg1467_735, arg1469_736);
		       }
		       {	/* Cgen/init.scm 51 */
			  obj_t arg1474_741;
			  {	/* Cgen/init.scm 51 */
			     obj_t arg1475_742;
			     {	/* Cgen/init.scm 51 */
				obj_t arg1477_744;
				obj_t arg1478_745;
				arg1477_744 =
				   CNST_TABLE_REF(((long) 9));
				{	/* Cgen/init.scm 51 */
				   obj_t arg1479_746;
				   obj_t arg1480_747;
				   {	/* Cgen/init.scm 51 */
				      obj_t symbol_1127;
				      symbol_1127 = _module__166_module_module;
				      arg1479_746 =
					 SYMBOL_TO_STRING(symbol_1127);
				   }
				   {	/* ./Ieee/pair-list.scm 5689 */
				      obj_t aux_1210;
				      aux_1210 =
					 CNST_TABLE_REF(((long) 10));
				      arg1480_747 =
					 MAKE_PAIR(aux_1210, BNIL);
				   }
				   arg1478_745 =
				      MAKE_PAIR(arg1479_746, arg1480_747);
				}
				arg1475_742 =
				   MAKE_PAIR(arg1477_744, arg1478_745);
			     }
			     arg1474_741 =
				MAKE_PAIR(arg1475_742, BNIL);
			  }
			  arg1466_734 =
			     MAKE_PAIR(ubody_708, arg1474_741);
		       }
		       arg1463_732 =
			  MAKE_PAIR(arg1464_733, arg1466_734);
		    }
		    body_709 =
		       MAKE_PAIR(arg1462_731, arg1463_732);
		 }
	       {	/* Cgen/init.scm 45 */
		  local_bglt cvar_710;
		  cvar_710 =
		     make_local_svar_140_ast_local(
		     CNST_TABLE_REF(((long) 8)),
		     (type_bglt) (_long__149_type_cache));
		  {	/* Cgen/init.scm 52 */
		     local_bglt nvar_711;
		     nvar_711 =
			make_local_svar_140_ast_local(
			CNST_TABLE_REF(((long) 10)),
			(type_bglt) (_string__3_type_cache));
		     {	/* Cgen/init.scm 53 */
			node_bglt node_712;
			{	/* Cgen/init.scm 54 */
			   obj_t __722;
			   obj_t unsafe_type_48_723;
			   __722 = ____74_type_cache;
			   unsafe_type_48_723 = _unsafe_type__146_engine_param;
			   ____74_type_cache = _obj__252_type_cache;
			   _unsafe_type__146_engine_param = BTRUE;
			   {	/* Cgen/init.scm 58 */
			      node_bglt node_724;
			      {		/* Cgen/init.scm 59 */
				 node_bglt arg1455_725;
				 {	/* Cgen/init.scm 59 */
				    obj_t arg1456_726;
				    obj_t arg1458_728;
				    {	/* Cgen/init.scm 59 */
				       obj_t list1459_729;
				       {	/* Cgen/init.scm 59 */
					  obj_t arg1461_730;
					  {	/* Cgen/init.scm 59 */
					     obj_t aux_1225;
					     aux_1225 =
						(obj_t) (nvar_711);
					     arg1461_730 =
						MAKE_PAIR(aux_1225, BNIL);
					  }
					  {	/* Cgen/init.scm 59 */
					     obj_t aux_1228;
					     aux_1228 =
						(obj_t) (cvar_710);
					     list1459_729 =
						MAKE_PAIR(aux_1228, arg1461_730);
					  }
				       }
				       arg1456_726 = list1459_729;
				    }
				    arg1458_728 =
				       CNST_TABLE_REF(((long) 11));
				    arg1455_725 =
				       sexp__node_235_ast_sexp(body_709, arg1456_726, BNIL, arg1458_728);
				 }
				 node_724 =
				    coerce__182_coerce_coerce(arg1455_725,
				    (type_bglt) (_obj__252_type_cache));
			      }
			      ____74_type_cache = __722;
			      _unsafe_type__146_engine_param = unsafe_type_48_723;
			      node_712 = node_724;
			   }
			}
			{	/* Cgen/init.scm 54 */
			   global_bglt init_713;
			   {	/* Cgen/init.scm 67 */
			      obj_t arg1445_714;
			      obj_t arg1446_715;
			      obj_t arg1447_716;
			      obj_t arg1449_717;
			      obj_t arg1450_718;
			      obj_t arg1451_719;
			      arg1445_714 =
				 module_initialization_id_110_module_module(_module__166_module_module);
			      arg1446_715 =
				 CNST_TABLE_REF(((long) 12));
			      {		/* Cgen/init.scm 69 */
				 obj_t list1452_720;
				 {	/* Cgen/init.scm 69 */
				    obj_t arg1454_721;
				    {	/* Cgen/init.scm 69 */
				       obj_t aux_1237;
				       aux_1237 =
					  (obj_t) (nvar_711);
				       arg1454_721 =
					  MAKE_PAIR(aux_1237, BNIL);
				    }
				    {	/* Cgen/init.scm 69 */
				       obj_t aux_1240;
				       aux_1240 =
					  (obj_t) (cvar_710);
				       list1452_720 =
					  MAKE_PAIR(aux_1240, arg1454_721);
				    }
				 }
				 arg1447_716 = list1452_720;
			      }
			      arg1449_717 =
				 CNST_TABLE_REF(((long) 13));
			      arg1450_718 =
				 CNST_TABLE_REF(((long) 14));
			      arg1451_719 =
				 CNST_TABLE_REF(((long) 2));
			      init_713 =
				 def_global_sfun_no_warning__10_ast_glo_def_117(arg1445_714, arg1446_715, arg1447_716, _module__166_module_module, arg1449_717, arg1450_718, arg1451_719,
				 (obj_t) (node_712));
			   }
			   {	/* Cgen/init.scm 66 */

			      {		/* Cgen/init.scm 75 */
				 obj_t val1066_1145;
				 val1066_1145 =
				    CNST_TABLE_REF(((long) 15));
				 ((((global_bglt) CREF(init_713))->import) = ((obj_t) val1066_1145), BUNSPEC);
			      }
			      {		/* Cgen/init.scm 76 */
				 type_bglt val1060_1147;
				 val1060_1147 =
				    (type_bglt) (_obj__252_type_cache);
				 ((((global_bglt) CREF(init_713))->type) = ((type_bglt) val1060_1147), BUNSPEC);
			      }
			      occur_node_in__115_ast_occur(node_712, init_713);
			      return
				 (obj_t) (init_713);
			   }
			}
		     }
		  }
	       }
	    }
	 }
      }
   }
}



/* _make-module-init */
obj_t 
_make_module_init_166_cgen_init(obj_t env_1148)
{
   AN_OBJECT;
   {	/* Cgen/init.scm 34 */
      return
	 make_module_init_70_cgen_init();
   }
}



/* method-init */
obj_t 
method_init_76_cgen_init()
{
   AN_OBJECT;
   {	/* Cgen/init.scm 14 */
      return BUNSPEC;
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_cgen_init()
{
   AN_OBJECT;
   {	/* Cgen/init.scm 14 */
      module_initialization_70_engine_param(((long) 0), "CGEN_INIT");
      module_initialization_70_module_module(((long) 0), "CGEN_INIT");
      module_initialization_70_tools_shape(((long) 0), "CGEN_INIT");
      module_initialization_70_type_type(((long) 0), "CGEN_INIT");
      module_initialization_70_type_cache(((long) 0), "CGEN_INIT");
      module_initialization_70_ast_var(((long) 0), "CGEN_INIT");
      module_initialization_70_ast_node(((long) 0), "CGEN_INIT");
      module_initialization_70_ast_env(((long) 0), "CGEN_INIT");
      module_initialization_70_ast_sexp(((long) 0), "CGEN_INIT");
      module_initialization_70_ast_local(((long) 0), "CGEN_INIT");
      module_initialization_70_ast_glo_def_117(((long) 0), "CGEN_INIT");
      module_initialization_70_ast_unit(((long) 0), "CGEN_INIT");
      module_initialization_70_ast_occur(((long) 0), "CGEN_INIT");
      return
	 module_initialization_70_coerce_coerce(((long) 0), "CGEN_INIT");
   }
}
