/*===========================================================================*/
/*   (Cgen/main.scm)                                                         */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct ccomp
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t producer;
     obj_t consumer;
     obj_t finalizer;
     obj_t checksummer;
  }
     *ccomp_bglt;

typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;


static obj_t method_init_76_cgen_main();
extern obj_t global_ast_var;
extern obj_t _obj__252_type_cache;
static obj_t _make_bigloo_main_92_cgen_main(obj_t);
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t module_initialization_70_cgen_main(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_module_module(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_ast_env(long, char *);
extern obj_t module_initialization_70_ast_sexp(long, char *);
extern obj_t module_initialization_70_ast_local(long, char *);
extern obj_t module_initialization_70_ast_glo_def_117(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t make_bigloo_main_85_cgen_main();
extern local_bglt make_local_svar_140_ast_local(obj_t, type_bglt);
extern global_bglt def_global_sfun__93_ast_glo_def_117(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t module_initialization_id_110_module_module(obj_t);
static obj_t imported_modules_init_94_cgen_main();
static obj_t library_modules_init_112_cgen_main();
extern node_bglt sexp__node_235_ast_sexp(obj_t, obj_t, obj_t, obj_t);
extern obj_t open_input_string(obj_t);
extern obj_t _module__166_module_module;
extern obj_t read___reader(obj_t);
extern obj_t ____74_type_cache;
static obj_t require_initialization_114_cgen_main = BUNSPEC;
extern obj_t _main__152_module_module;
static obj_t cnst_init_137_cgen_main();
static obj_t __cnst[10];

DEFINE_EXPORT_PROCEDURE(make_bigloo_main_env_171_cgen_main, _make_bigloo_main_92_cgen_main1575, _make_bigloo_main_92_cgen_main, 0L, 0);
DEFINE_STRING(string1569_cgen_main, string1569_cgen_main1576, "bigloo_main", 11);
DEFINE_STRING(string1570_cgen_main, string1570_cgen_main1577, "NOW BIGLOO-MAIN-PROCEDURE SFUN (ARGV::OBJ) BIGLOO_MAIN::OBJ VALUE @ BIGLOO-EXIT BEGIN ARGV ", 91);



/* module-initialization */
obj_t 
module_initialization_70_cgen_main(long checksum_1140, char *from_1141)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_cgen_main))
	{
	   require_initialization_114_cgen_main =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_cgen_main();
	   cnst_init_137_cgen_main();
	   imported_modules_init_94_cgen_main();
	   method_init_76_cgen_main();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_cgen_main()
{
   AN_OBJECT;
   {	/* Cgen/main.scm 14 */
      module_initialization_70___object(((long) 0), "CGEN_MAIN");
      module_initialization_70___reader(((long) 0), "CGEN_MAIN");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_cgen_main()
{
   AN_OBJECT;
   {	/* Cgen/main.scm 14 */
      {		/* Cgen/main.scm 14 */
	 obj_t cnst_port_138_1133;
	 cnst_port_138_1133 =
	    open_input_string(string1570_cgen_main);
	 {
	    long i_1134;
	    i_1134 = ((long) 9);
	  loop_1135:
	    {	/* Cgen/main.scm 14 */
	       bool_t test1571_1136;
	       test1571_1136 =
		  (i_1134 == ((long) -1));
	       if (test1571_1136)
		 {	/* Cgen/main.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Cgen/main.scm 14 */
		    {	/* Cgen/main.scm 14 */
		       obj_t arg1572_1137;
		       {	/* Cgen/main.scm 14 */
			  obj_t list1573_1138;
			  list1573_1138 =
			     MAKE_PAIR(cnst_port_138_1133, BNIL);
			  arg1572_1137 =
			     read___reader(list1573_1138);
		       }
		       CNST_TABLE_SET(i_1134, arg1572_1137);
		    }
		    {	/* Cgen/main.scm 14 */
		       int aux_1139;
		       {	/* Cgen/main.scm 14 */
			  long aux_1157;
			  aux_1157 =
			     (i_1134 - ((long) 1));
			  aux_1139 =
			     (int) (aux_1157);
		       }
		       {
			  long i_1160;
			  i_1160 =
			     (long) (aux_1139);
			  i_1134 = i_1160;
			  goto loop_1135;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* make-bigloo-main */
obj_t 
make_bigloo_main_85_cgen_main()
{
   AN_OBJECT;
   {	/* Cgen/main.scm 30 */
      {		/* Cgen/main.scm 31 */
	 obj_t args_707;
	 {	/* Cgen/main.scm 31 */
	    local_bglt arg1486_750;
	    arg1486_750 =
	       make_local_svar_140_ast_local(
	       CNST_TABLE_REF(((long) 0)),
	       (type_bglt) (_obj__252_type_cache));
	    {	/* Cgen/main.scm 31 */
	       obj_t list1487_751;
	       {	/* Cgen/main.scm 31 */
		  obj_t aux_1165;
		  aux_1165 =
		     (obj_t) (arg1486_750);
		  list1487_751 =
		     MAKE_PAIR(aux_1165, BNIL);
	       }
	       args_707 = list1487_751;
	    }
	 }
	 {	/* Cgen/main.scm 31 */
	    obj_t user_main_99_708;
	    {	/* Cgen/main.scm 32 */
	       bool_t test1485_749;
	       {	/* Cgen/main.scm 32 */
		  obj_t obj_1088;
		  obj_1088 = _main__152_module_module;
		  test1485_749 =
		     is_a__118___object(obj_1088, global_ast_var);
	       }
	       if (test1485_749)
		 {	/* Cgen/main.scm 32 */
		    user_main_99_708 = _main__152_module_module;
		 }
	       else
		 {	/* Cgen/main.scm 32 */
		    user_main_99_708 = BFALSE;
		 }
	    }
	    {	/* Cgen/main.scm 32 */
	       obj_t main_body_213_709;
	       {	/* Cgen/main.scm 35 */
		  bool_t test1445_714;
		  test1445_714 =
		     is_a__118___object(user_main_99_708, global_ast_var);
		  if (test1445_714)
		    {	/* Cgen/main.scm 36 */
		       obj_t arg1446_715;
		       obj_t arg1447_716;
		       arg1446_715 =
			  CNST_TABLE_REF(((long) 1));
		       {	/* Cgen/main.scm 37 */
			  obj_t arg1449_717;
			  obj_t arg1450_718;
			  {	/* Cgen/main.scm 37 */
			     obj_t arg1451_719;
			     obj_t arg1452_720;
			     arg1451_719 =
				module_initialization_id_110_module_module(_module__166_module_module);
			     {	/* Cgen/main.scm 37 */
				obj_t arg1455_722;
				{	/* Cgen/main.scm 39 */
				   obj_t arg1456_723;
				   {	/* Cgen/main.scm 39 */
				      obj_t symbol_1090;
				      symbol_1090 = _module__166_module_module;
				      arg1456_723 =
					 SYMBOL_TO_STRING(symbol_1090);
				   }
				   arg1455_722 =
				      MAKE_PAIR(arg1456_723, BNIL);
				}
				{	/* ./Ieee/pair-list.scm 5689 */
				   obj_t aux_1176;
				   aux_1176 =
				      BINT(((long) 0));
				   arg1452_720 =
				      MAKE_PAIR(aux_1176, arg1455_722);
				}
			     }
			     arg1449_717 =
				MAKE_PAIR(arg1451_719, arg1452_720);
			  }
			  {	/* Cgen/main.scm 40 */
			     obj_t arg1458_725;
			     {	/* Cgen/main.scm 40 */
				obj_t arg1461_727;
				obj_t arg1462_728;
				arg1461_727 =
				   CNST_TABLE_REF(((long) 2));
				{	/* Cgen/main.scm 40 */
				   obj_t arg1463_729;
				   {	/* Cgen/main.scm 40 */
				      obj_t arg1466_731;
				      obj_t arg1467_732;
				      {		/* Cgen/main.scm 40 */
					 obj_t arg1469_733;
					 obj_t arg1470_734;
					 arg1469_733 =
					    CNST_TABLE_REF(((long) 3));
					 {	/* Cgen/main.scm 40 */
					    obj_t arg1471_735;
					    obj_t arg1472_736;
					    {	/* Cgen/main.scm 40 */
					       global_bglt obj_1097;
					       obj_1097 =
						  (global_bglt) (user_main_99_708);
					       arg1471_735 =
						  (((global_bglt) CREF(obj_1097))->id);
					    }
					    {	/* ./Ieee/pair-list.scm 5689 */
					       obj_t aux_1184;
					       {	/* Cgen/main.scm 41 */
						  global_bglt obj_1098;
						  obj_1098 =
						     (global_bglt) (user_main_99_708);
						  aux_1184 =
						     (((global_bglt) CREF(obj_1098))->module);
					       }
					       arg1472_736 =
						  MAKE_PAIR(aux_1184, BNIL);
					    }
					    arg1470_734 =
					       MAKE_PAIR(arg1471_735, arg1472_736);
					 }
					 arg1466_731 =
					    MAKE_PAIR(arg1469_733, arg1470_734);
				      }
				      {		/* ./Ieee/pair-list.scm 5689 */
					 obj_t aux_1190;
					 aux_1190 =
					    CNST_TABLE_REF(((long) 0));
					 arg1467_732 =
					    MAKE_PAIR(aux_1190, BNIL);
				      }
				      arg1463_729 =
					 MAKE_PAIR(arg1466_731, arg1467_732);
				   }
				   arg1462_728 =
				      MAKE_PAIR(arg1463_729, BNIL);
				}
				arg1458_725 =
				   MAKE_PAIR(arg1461_727, arg1462_728);
			     }
			     arg1450_718 =
				MAKE_PAIR(arg1458_725, BNIL);
			  }
			  arg1447_716 =
			     MAKE_PAIR(arg1449_717, arg1450_718);
		       }
		       main_body_213_709 =
			  MAKE_PAIR(arg1446_715, arg1447_716);
		    }
		  else
		    {	/* Cgen/main.scm 43 */
		       obj_t arg1475_739;
		       obj_t arg1476_740;
		       arg1475_739 =
			  CNST_TABLE_REF(((long) 2));
		       {	/* Cgen/main.scm 44 */
			  obj_t arg1477_741;
			  {	/* Cgen/main.scm 44 */
			     obj_t arg1479_743;
			     obj_t arg1480_744;
			     arg1479_743 =
				module_initialization_id_110_module_module(_module__166_module_module);
			     {	/* Cgen/main.scm 44 */
				obj_t arg1482_746;
				{	/* Cgen/main.scm 46 */
				   obj_t arg1483_747;
				   {	/* Cgen/main.scm 46 */
				      obj_t symbol_1119;
				      symbol_1119 = _module__166_module_module;
				      arg1483_747 =
					 SYMBOL_TO_STRING(symbol_1119);
				   }
				   arg1482_746 =
				      MAKE_PAIR(arg1483_747, BNIL);
				}
				{	/* ./Ieee/pair-list.scm 5689 */
				   obj_t aux_1203;
				   aux_1203 =
				      BINT(((long) 0));
				   arg1480_744 =
				      MAKE_PAIR(aux_1203, arg1482_746);
				}
			     }
			     arg1477_741 =
				MAKE_PAIR(arg1479_743, arg1480_744);
			  }
			  arg1476_740 =
			     MAKE_PAIR(arg1477_741, BNIL);
		       }
		       main_body_213_709 =
			  MAKE_PAIR(arg1475_739, arg1476_740);
		    }
	       }
	       {	/* Cgen/main.scm 35 */
		  node_bglt node_710;
		  {	/* Cgen/main.scm 47 */
		     obj_t __712;
		     __712 = ____74_type_cache;
		     ____74_type_cache = _obj__252_type_cache;
		     {	/* Cgen/main.scm 49 */
			node_bglt node_713;
			node_713 =
			   sexp__node_235_ast_sexp(main_body_213_709, args_707, BFALSE,
			   CNST_TABLE_REF(((long) 4)));
			____74_type_cache = __712;
			node_710 = node_713;
		     }
		  }
		  {	/* Cgen/main.scm 47 */
		     global_bglt bigloo_main_109_711;
		     bigloo_main_109_711 =
			def_global_sfun__93_ast_glo_def_117(
			CNST_TABLE_REF(((long) 5)),
			CNST_TABLE_REF(((long) 6)), args_707, _module__166_module_module,
			CNST_TABLE_REF(((long) 7)),
			CNST_TABLE_REF(((long) 8)),
			CNST_TABLE_REF(((long) 9)),
			(obj_t) (node_710));
		     {	/* Cgen/main.scm 52 */

			{	/* Cgen/main.scm 60 */
			   obj_t val1059_1131;
			   val1059_1131 = string1569_cgen_main;
			   ((((global_bglt) CREF(bigloo_main_109_711))->name) = ((obj_t) val1059_1131), BUNSPEC);
			}
			return
			   (obj_t) (bigloo_main_109_711);
		     }
		  }
	       }
	    }
	 }
      }
   }
}



/* _make-bigloo-main */
obj_t 
_make_bigloo_main_92_cgen_main(obj_t env_1132)
{
   AN_OBJECT;
   {	/* Cgen/main.scm 30 */
      return
	 make_bigloo_main_85_cgen_main();
   }
}



/* method-init */
obj_t 
method_init_76_cgen_main()
{
   AN_OBJECT;
   {	/* Cgen/main.scm 14 */
      return BUNSPEC;
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_cgen_main()
{
   AN_OBJECT;
   {	/* Cgen/main.scm 14 */
      module_initialization_70_engine_param(((long) 0), "CGEN_MAIN");
      module_initialization_70_module_module(((long) 0), "CGEN_MAIN");
      module_initialization_70_type_type(((long) 0), "CGEN_MAIN");
      module_initialization_70_type_cache(((long) 0), "CGEN_MAIN");
      module_initialization_70_ast_var(((long) 0), "CGEN_MAIN");
      module_initialization_70_ast_node(((long) 0), "CGEN_MAIN");
      module_initialization_70_ast_env(((long) 0), "CGEN_MAIN");
      module_initialization_70_ast_sexp(((long) 0), "CGEN_MAIN");
      module_initialization_70_ast_local(((long) 0), "CGEN_MAIN");
      return
	 module_initialization_70_ast_glo_def_117(((long) 0), "CGEN_MAIN");
   }
}
