/*===========================================================================*/
/*   (Cgen/proto.scm)                                                        */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct ccomp
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t producer;
     obj_t consumer;
     obj_t finalizer;
     obj_t checksummer;
  }
     *ccomp_bglt;

typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;

typedef struct tvec
  {
     struct type *item_type_130;
  }
    *tvec_bglt;

typedef struct cop
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
   *cop_bglt;

typedef struct clabel
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     obj_t name;
     bool_t used__226;
     obj_t body;
  }
      *clabel_bglt;

typedef struct cgoto
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct clabel *label;
  }
     *cgoto_bglt;

typedef struct block
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *body;
  }
     *block_bglt;

typedef struct creturn
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *value;
  }
       *creturn_bglt;

typedef struct cvoid
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *value;
  }
     *cvoid_bglt;

typedef struct catom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     obj_t value;
  }
     *catom_bglt;

typedef struct varc
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct variable *variable;
  }
    *varc_bglt;

typedef struct cpragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     obj_t format;
     obj_t args;
  }
       *cpragma_bglt;

typedef struct ccast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct cop *arg;
  }
     *ccast_bglt;

typedef struct csequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     bool_t c_exp__163;
     obj_t cops;
  }
         *csequence_bglt;

typedef struct nop
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
   *nop_bglt;

typedef struct stop
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *value;
  }
    *stop_bglt;

typedef struct csetq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct varc *var;
     struct cop *value;
  }
     *csetq_bglt;

typedef struct cif
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *test;
     struct cop *true;
     struct cop *false;
  }
   *cif_bglt;

typedef struct local_var_164
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     obj_t vars;
  }
             *local_var_164_bglt;

typedef struct cfuncall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *fun;
     obj_t args;
     obj_t strength;
  }
        *cfuncall_bglt;

typedef struct capply
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *fun;
     struct cop *arg;
  }
      *capply_bglt;

typedef struct capp
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *fun;
     obj_t args;
  }
    *capp_bglt;

typedef struct cfail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *proc;
     struct cop *msg;
     struct cop *obj;
  }
     *cfail_bglt;

typedef struct cswitch
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *test;
     obj_t clauses;
  }
       *cswitch_bglt;

typedef struct cmake_box_177
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *value;
  }
             *cmake_box_177_bglt;

typedef struct cbox_ref_44
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *var;
  }
           *cbox_ref_44_bglt;

typedef struct cbox_set__132
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *var;
     struct cop *value;
  }
             *cbox_set__132_bglt;

typedef struct cset_ex_it_123
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *exit;
     struct cop *jump_value_221;
     struct cop *body;
  }
              *cset_ex_it_123_bglt;

typedef struct cjump_ex_it_131
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *exit;
     struct cop *value;
  }
               *cjump_ex_it_131_bglt;

typedef struct sfun_c_188
  {
     struct clabel *label;
     bool_t integrated;
  }
          *sfun_c_188_bglt;

typedef struct bdb_block_21
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *body;
  }
            *bdb_block_21_bglt;


static obj_t emit_prototype_default1699_103_cgen_prototype(value_bglt, variable_bglt);
static obj_t method_init_76_cgen_prototype();
static obj_t _emit_cnsts_87_cgen_prototype(obj_t);
extern long add_inlined_method__244___object(obj_t, obj_t, long);
extern obj_t string_append(obj_t, obj_t);
extern obj_t type_type_type;
extern obj_t _c_port__188_cgen_emit;
extern obj_t string_sans___40_type_tools(obj_t);
extern obj_t make_typed_declaration_180_type_tools(type_bglt, obj_t);
extern obj_t global_ast_var;
extern obj_t gensym___r4_symbols_6_4;
extern obj_t _obj__252_type_cache;
extern obj_t untrigraph_cgen_emit_cop_239(obj_t);
extern obj_t cvar_ast_var;
extern obj_t type_name_sans___47_type_tools(type_bglt);
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t qualified_name_205_cgen_prototype(obj_t, obj_t);
extern obj_t module_initialization_70_cgen_prototype(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_module_module(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_type_tools(long, char *);
extern obj_t module_initialization_70_type_env(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_ast_env(long, char *);
extern obj_t module_initialization_70_ast_ident(long, char *);
extern obj_t module_initialization_70_tvector_tvector(long, char *);
extern obj_t module_initialization_70_tvector_cnst(long, char *);
extern obj_t module_initialization_70_cnst_alloc(long, char *);
extern obj_t module_initialization_70_cgen_cop(long, char *);
extern obj_t module_initialization_70_cgen_emit(long, char *);
extern obj_t module_initialization_70_cgen_emit_cop_239(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_symbols_6_4(long, char *);
extern obj_t module_initialization_70___r4_numbers_6_5_fixnum(long, char *);
extern obj_t module_initialization_70___r4_output_6_10_3(long, char *);
static obj_t emit_prototype_formal_types_237_cgen_prototype(obj_t);
extern bool_t sub_type__174_type_env(type_bglt, type_bglt);
static obj_t _get_c_scope2136_57_cgen_prototype(obj_t, obj_t);
static obj_t emit_cnst_44_cgen_prototype(scnst_bglt, global_bglt);
static obj_t _get_c_scope_default1710_101_cgen_prototype(obj_t, obj_t);
extern obj_t _max_c_token_length__129_engine_param;
extern obj_t svar_ast_var;
extern obj_t scnst_ast_var;
static obj_t _set_variable_name__28_cgen_prototype(obj_t, obj_t);
extern obj_t emit_prototypes_82_cgen_prototype();
extern obj_t display_2_122___r4_output_6_10_3(obj_t, obj_t);
static obj_t get_c_scope_184_cgen_prototype(variable_bglt);
static obj_t imported_modules_init_94_cgen_prototype();
static obj_t _emit_prototype2135_165_cgen_prototype(obj_t, obj_t, obj_t);
static obj_t emit_prototype_formals_182_cgen_prototype(obj_t);
extern obj_t cfun_ast_var;
extern obj_t add_generic__110___object(obj_t, obj_t);
extern obj_t tvector__c_vector_165_tvector_cnst(obj_t);
extern obj_t id__name_228_ast_ident(obj_t);
static obj_t library_modules_init_112_cgen_prototype();
static obj_t toplevel_init_63_cgen_prototype();
static obj_t _emit_prototypes_68_cgen_prototype(obj_t);
extern obj_t open_input_string(obj_t);
extern obj_t sfun_ast_var;
extern char *integer__string_135___r4_numbers_6_5_fixnum(long, obj_t);
extern obj_t string_to_bstring(char *);
extern obj_t local_ast_var;
extern obj_t emit_cnsts_221_cgen_prototype();
extern obj_t for_each_global__88_ast_env(obj_t);
static obj_t _emit_prototype_default1699_81_cgen_prototype(obj_t, obj_t, obj_t);
static unsigned char emit_prototype_svar_scnst_27_cgen_prototype(obj_t, variable_bglt);
extern obj_t shape_tools_shape(obj_t);
extern obj_t get_cnst_table_42_cnst_alloc();
static obj_t get_c_scope_default1710_124_cgen_prototype(variable_bglt);
extern obj_t c_substring(obj_t, long, long);
extern obj_t internal_error_43_tools_error(obj_t, obj_t, obj_t);
static obj_t emit_cnst_sfun_sgfun_176_cgen_prototype(obj_t, global_bglt, char *);
extern obj_t _module__166_module_module;
static obj_t emit_cnst_string_104_cgen_prototype(obj_t, global_bglt);
static unsigned char emit_cnst_stvector_253_cgen_prototype(obj_t, global_bglt);
extern obj_t _classes__134___object;
extern obj_t set_variable_name__102_cgen_prototype(obj_t);
static obj_t _anonymous_1750__169_cgen_prototype(obj_t, obj_t);
extern obj_t read___reader(obj_t);
static obj_t _qualified_name2134_197_cgen_prototype(obj_t, obj_t, obj_t);
static obj_t _anonymous_1725__22_cgen_prototype(obj_t, obj_t);
static obj_t emit_prototype_23_cgen_prototype(value_bglt, variable_bglt);
static obj_t require_initialization_114_cgen_prototype = BUNSPEC;
static unsigned char emit_cnst_real_94_cgen_prototype(obj_t, global_bglt);
extern obj_t string_for_read(obj_t);
static obj_t cnst_init_137_cgen_prototype();
static obj_t __cnst[11];

DEFINE_STATIC_PROCEDURE(proc2138_cgen_prototype, _anonymous_1750__169_cgen_prototype2176, _anonymous_1750__169_cgen_prototype, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2137_cgen_prototype, _anonymous_1725__22_cgen_prototype2177, _anonymous_1725__22_cgen_prototype, 0L, 1);
DEFINE_STATIC_GENERIC(emit_prototype_env_241_cgen_prototype, _emit_prototype2135_165_cgen_prototype2178, _emit_prototype2135_165_cgen_prototype, 0L, 2);
DEFINE_STATIC_PROCEDURE(get_c_scope_default1710_env_55_cgen_prototype, _get_c_scope_default1710_101_cgen_prototype2179, _get_c_scope_default1710_101_cgen_prototype, 0L, 1);
DEFINE_STATIC_GENERIC(get_c_scope_env_161_cgen_prototype, _get_c_scope2136_57_cgen_prototype2180, _get_c_scope2136_57_cgen_prototype, 0L, 1);
DEFINE_EXPORT_PROCEDURE(emit_cnsts_env_4_cgen_prototype, _emit_cnsts_87_cgen_prototype2181, _emit_cnsts_87_cgen_prototype, 0L, 0);
DEFINE_STATIC_PROCEDURE(emit_prototype_default1699_env_21_cgen_prototype, _emit_prototype_default1699_81_cgen_prototype2182, _emit_prototype_default1699_81_cgen_prototype, 0L, 2);
DEFINE_EXPORT_PROCEDURE(emit_prototypes_env_106_cgen_prototype, _emit_prototypes_68_cgen_prototype2183, _emit_prototypes_68_cgen_prototype, 0L, 0);
DEFINE_STRING(string2171_cgen_prototype, string2171_cgen_prototype2184, "GET-C-SCOPE-DEFAULT1710 EMIT-PROTOTYPE-DEFAULT1699 IMPORT STVECTOR SGFUN SFUN SREAL SSTRING NEVER EXPORT STATIC ", 112);
DEFINE_STRING(string2169_cgen_prototype, string2169_cgen_prototype2185, "get-c-scope", 11);
DEFINE_STRING(string2170_cgen_prototype, string2170_cgen_prototype2186, "Unknown importation", 19);
DEFINE_STRING(string2168_cgen_prototype, string2168_cgen_prototype2187, "extern", 6);
DEFINE_STRING(string2167_cgen_prototype, string2167_cgen_prototype2188, "No method for this object", 25);
DEFINE_STRING(string2166_cgen_prototype, string2166_cgen_prototype2189, "...)", 4);
DEFINE_STRING(string2165_cgen_prototype, string2165_cgen_prototype2190, ", ...)", 6);
DEFINE_STRING(string2164_cgen_prototype, string2164_cgen_prototype2191, "extern ", 7);
DEFINE_STRING(string2163_cgen_prototype, string2163_cgen_prototype2192, "Unknown variable sort", 21);
DEFINE_STRING(string2162_cgen_prototype, string2162_cgen_prototype2193, "set-variable-name!", 18);
DEFINE_STRING(string2161_cgen_prototype, string2161_cgen_prototype2194, "_", 1);
DEFINE_STRING(string2159_cgen_prototype, string2159_cgen_prototype2195, " ) ", 3);
DEFINE_STRING(string2160_cgen_prototype, string2160_cgen_prototype2196, " DEFINE_TVECTOR_STOP( ", 22);
DEFINE_STRING(string2158_cgen_prototype, string2158_cgen_prototype2197, "DEFINE_TVECTOR_START( ", 22);
DEFINE_STRING(string2157_cgen_prototype, string2157_cgen_prototype2198, ", va_generic_entry", 18);
DEFINE_STRING(string2156_cgen_prototype, string2156_cgen_prototype2199, ", 0L, ", 6);
DEFINE_STRING(string2155_cgen_prototype, string2155_cgen_prototype2200, "DEFINE_EXPORT_", 14);
DEFINE_STRING(string2154_cgen_prototype, string2154_cgen_prototype2201, "DEFINE_STATIC_", 14);
DEFINE_STRING(string2153_cgen_prototype, string2153_cgen_prototype2202, "( ", 2);
DEFINE_STRING(string2152_cgen_prototype, string2152_cgen_prototype2203, "DEFINE_REAL( ", 13);
DEFINE_STRING(string2151_cgen_prototype, string2151_cgen_prototype2204, "\"\n\"", 3);
DEFINE_STRING(string2149_cgen_prototype, string2149_cgen_prototype2205, "emit-cnst-string", 16);
DEFINE_STRING(string2150_cgen_prototype, string2150_cgen_prototype2206, "Can't emit string", 17);
DEFINE_STRING(string2148_cgen_prototype, string2148_cgen_prototype2207, " );", 3);
DEFINE_STRING(string2147_cgen_prototype, string2147_cgen_prototype2208, "\", ", 3);
DEFINE_STRING(string2146_cgen_prototype, string2146_cgen_prototype2209, ", \"", 3);
DEFINE_STRING(string2145_cgen_prototype, string2145_cgen_prototype2210, "DEFINE_STRING( ", 15);
DEFINE_STRING(string2144_cgen_prototype, string2144_cgen_prototype2211, "Unknown cnst class", 18);
DEFINE_STRING(string2143_cgen_prototype, string2143_cgen_prototype2212, "emit-cnst", 9);
DEFINE_STRING(string2142_cgen_prototype, string2142_cgen_prototype2213, ", ", 2);
DEFINE_STRING(string2141_cgen_prototype, string2141_cgen_prototype2214, "()", 2);
DEFINE_STRING(string2139_cgen_prototype, string2139_cgen_prototype2215, "static", 6);
DEFINE_STRING(string2140_cgen_prototype, string2140_cgen_prototype2216, " = BUNSPEC;", 11);
DEFINE_EXPORT_PROCEDURE(qualified_name_env_76_cgen_prototype, _qualified_name2134_197_cgen_prototype2217, _qualified_name2134_197_cgen_prototype, 0L, 2);
DEFINE_EXPORT_PROCEDURE(set_variable_name__env_153_cgen_prototype, _set_variable_name__28_cgen_prototype2218, _set_variable_name__28_cgen_prototype, 0L, 1);



/* module-initialization */
obj_t 
module_initialization_70_cgen_prototype(long checksum_2384, char *from_2385)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_cgen_prototype))
	{
	   require_initialization_114_cgen_prototype =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_cgen_prototype();
	   cnst_init_137_cgen_prototype();
	   imported_modules_init_94_cgen_prototype();
	   method_init_76_cgen_prototype();
	   toplevel_init_63_cgen_prototype();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_cgen_prototype()
{
   AN_OBJECT;
   {	/* Cgen/proto.scm 14 */
      module_initialization_70___object(((long) 0), "CGEN_PROTOTYPE");
      module_initialization_70___r4_symbols_6_4(((long) 0), "CGEN_PROTOTYPE");
      module_initialization_70___r4_output_6_10_3(((long) 0), "CGEN_PROTOTYPE");
      module_initialization_70___r4_numbers_6_5_fixnum(((long) 0), "CGEN_PROTOTYPE");
      module_initialization_70___reader(((long) 0), "CGEN_PROTOTYPE");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_cgen_prototype()
{
   AN_OBJECT;
   {	/* Cgen/proto.scm 14 */
      {		/* Cgen/proto.scm 14 */
	 obj_t cnst_port_138_2377;
	 cnst_port_138_2377 =
	    open_input_string(string2171_cgen_prototype);
	 {
	    long i_2378;
	    i_2378 = ((long) 10);
	  loop_2379:
	    {	/* Cgen/proto.scm 14 */
	       bool_t test2172_2380;
	       test2172_2380 =
		  (i_2378 == ((long) -1));
	       if (test2172_2380)
		 {	/* Cgen/proto.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Cgen/proto.scm 14 */
		    {	/* Cgen/proto.scm 14 */
		       obj_t arg2173_2381;
		       {	/* Cgen/proto.scm 14 */
			  obj_t list2174_2382;
			  list2174_2382 =
			     MAKE_PAIR(cnst_port_138_2377, BNIL);
			  arg2173_2381 =
			     read___reader(list2174_2382);
		       }
		       CNST_TABLE_SET(i_2378, arg2173_2381);
		    }
		    {	/* Cgen/proto.scm 14 */
		       int aux_2383;
		       {	/* Cgen/proto.scm 14 */
			  long aux_2405;
			  aux_2405 =
			     (i_2378 - ((long) 1));
			  aux_2383 =
			     (int) (aux_2405);
		       }
		       {
			  long i_2408;
			  i_2408 =
			     (long) (aux_2383);
			  i_2378 = i_2408;
			  goto loop_2379;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_cgen_prototype()
{
   AN_OBJECT;
   {	/* Cgen/proto.scm 14 */
      return BUNSPEC;
   }
}



/* emit-prototypes */
obj_t 
emit_prototypes_82_cgen_prototype()
{
   AN_OBJECT;
   {	/* Cgen/proto.scm 43 */
      {		/* Cgen/proto.scm 47 */
	 obj_t _anonymous_1725__22_2353;
	 _anonymous_1725__22_2353 = proc2137_cgen_prototype;
	 for_each_global__88_ast_env(_anonymous_1725__22_2353);
      }
      {		/* Cgen/proto.scm 58 */
	 obj_t cnst_init_137_1128;
	 cnst_init_137_1128 =
	    get_cnst_table_42_cnst_alloc();
	 {	/* Cgen/proto.scm 59 */
	    value_bglt aux_2412;
	    {	/* Cgen/proto.scm 59 */
	       global_bglt obj_2006;
	       obj_2006 =
		  (global_bglt) (cnst_init_137_1128);
	       aux_2412 =
		  (((global_bglt) CREF(obj_2006))->value);
	    }
	    emit_prototype_23_cgen_prototype(aux_2412,
	       (variable_bglt) (cnst_init_137_1128));
	 }
      }
      {		/* Cgen/proto.scm 61 */
	 obj_t port_2007;
	 port_2007 = _c_port__188_cgen_emit;
	 {	/* ./Ieee/output.scm 9332 */
	    unsigned char aux_2417;
	    aux_2417 =
	       WRITE_CHAR(((unsigned char) '\n'), port_2007);
	    return
	       BCHAR(aux_2417);
	 }
      }
   }
}



/* _emit-prototypes */
obj_t 
_emit_prototypes_68_cgen_prototype(obj_t env_2354)
{
   AN_OBJECT;
   {	/* Cgen/proto.scm 43 */
      return
	 emit_prototypes_82_cgen_prototype();
   }
}



/* <anonymous:1725> */
obj_t 
_anonymous_1725__22_cgen_prototype(obj_t env_2355, obj_t global_2356)
{
   AN_OBJECT;
   {	/* Cgen/proto.scm 46 */
      {
	 obj_t global_1104;
	 global_1104 = global_2356;
	 {	/* Cgen/proto.scm 47 */
	    bool_t test1726_1106;
	    {	/* Cgen/proto.scm 47 */
	       bool_t test1728_1108;
	       {	/* Cgen/proto.scm 47 */
		  bool_t test1743_1122;
		  {	/* Cgen/proto.scm 47 */
		     obj_t obj2_1987;
		     obj2_1987 = _module__166_module_module;
		     {	/* ./Ieee/equiv.scm 5508 */
			obj_t aux_2421;
			{	/* Cgen/proto.scm 47 */
			   global_bglt obj_1985;
			   obj_1985 =
			      (global_bglt) (global_1104);
			   aux_2421 =
			      (((global_bglt) CREF(obj_1985))->module);
			}
			test1743_1122 =
			   (aux_2421 == obj2_1987);
		     }
		  }
		  if (test1743_1122)
		    {	/* Cgen/proto.scm 47 */
		       test1728_1108 = ((bool_t) 1);
		    }
		  else
		    {	/* Cgen/proto.scm 48 */
		       bool_t test_2426;
		       {	/* ./Ieee/equiv.scm 5508 */
			  obj_t aux_2430;
			  obj_t aux_2427;
			  aux_2430 =
			     CNST_TABLE_REF(((long) 0));
			  {	/* Cgen/proto.scm 48 */
			     global_bglt obj_1988;
			     obj_1988 =
				(global_bglt) (global_1104);
			     aux_2427 =
				(((global_bglt) CREF(obj_1988))->import);
			  }
			  test_2426 =
			     (aux_2427 == aux_2430);
		       }
		       if (test_2426)
			 {	/* Cgen/proto.scm 48 */
			    test1728_1108 = ((bool_t) 0);
			 }
		       else
			 {	/* Cgen/proto.scm 48 */
			    test1728_1108 = ((bool_t) 1);
			 }
		    }
	       }
	       if (test1728_1108)
		 {	/* Cgen/proto.scm 49 */
		    bool_t test1729_1109;
		    {	/* Cgen/proto.scm 49 */
		       bool_t test1732_1112;
		       {	/* Cgen/proto.scm 49 */
			  bool_t test1739_1118;
			  {	/* Cgen/proto.scm 49 */
			     obj_t obj2_1993;
			     obj2_1993 = _module__166_module_module;
			     {	/* ./Ieee/equiv.scm 5508 */
				obj_t aux_2434;
				{	/* Cgen/proto.scm 49 */
				   global_bglt obj_1991;
				   obj_1991 =
				      (global_bglt) (global_1104);
				   aux_2434 =
				      (((global_bglt) CREF(obj_1991))->module);
				}
				test1739_1118 =
				   (aux_2434 == obj2_1993);
			     }
			  }
			  if (test1739_1118)
			    {	/* ./Ieee/equiv.scm 5508 */
			       obj_t aux_2442;
			       obj_t aux_2439;
			       aux_2442 =
				  CNST_TABLE_REF(((long) 1));
			       {	/* Cgen/proto.scm 50 */
				  global_bglt obj_1994;
				  obj_1994 =
				     (global_bglt) (global_1104);
				  aux_2439 =
				     (((global_bglt) CREF(obj_1994))->import);
			       }
			       test1732_1112 =
				  (aux_2439 == aux_2442);
			    }
			  else
			    {	/* Cgen/proto.scm 49 */
			       test1732_1112 = ((bool_t) 0);
			    }
		       }
		       if (test1732_1112)
			 {	/* Cgen/proto.scm 49 */
			    test1729_1109 = ((bool_t) 1);
			 }
		       else
			 {	/* Cgen/proto.scm 51 */
			    bool_t test_2446;
			    {	/* ./Ieee/fixnum.scm 7121 */
			       long aux_2447;
			       {	/* Cgen/proto.scm 51 */
				  global_bglt obj_1997;
				  obj_1997 =
				     (global_bglt) (global_1104);
				  aux_2447 =
				     (((global_bglt) CREF(obj_1997))->occurrence);
			       }
			       test_2446 =
				  (aux_2447 > ((long) 0));
			    }
			    if (test_2446)
			      {		/* Cgen/proto.scm 51 */
				 test1729_1109 = ((bool_t) 1);
			      }
			    else
			      {		/* ./Ieee/equiv.scm 5508 */
				 obj_t aux_2454;
				 obj_t aux_2451;
				 aux_2454 =
				    CNST_TABLE_REF(((long) 2));
				 {	/* Cgen/proto.scm 52 */
				    global_bglt obj_2000;
				    obj_2000 =
				       (global_bglt) (global_1104);
				    aux_2451 =
				       (((global_bglt) CREF(obj_2000))->removable);
				 }
				 test1729_1109 =
				    (aux_2451 == aux_2454);
			      }
			 }
		    }
		    if (test1729_1109)
		      {		/* Cgen/proto.scm 53 */
			 bool_t test1730_1110;
			 {	/* ./Ast/var.scm 1376 */
			    obj_t aux_2458;
			    {	/* Cgen/proto.scm 53 */
			       value_bglt aux_2459;
			       {	/* Cgen/proto.scm 53 */
				  global_bglt obj_2003;
				  obj_2003 =
				     (global_bglt) (global_1104);
				  aux_2459 =
				     (((global_bglt) CREF(obj_2003))->value);
			       }
			       aux_2458 =
				  (obj_t) (aux_2459);
			    }
			    test1730_1110 =
			       is_a__118___object(aux_2458, scnst_ast_var);
			 }
			 if (test1730_1110)
			   {	/* Cgen/proto.scm 53 */
			      test1726_1106 = ((bool_t) 0);
			   }
			 else
			   {	/* Cgen/proto.scm 53 */
			      test1726_1106 = ((bool_t) 1);
			   }
		      }
		    else
		      {		/* Cgen/proto.scm 49 */
			 test1726_1106 = ((bool_t) 0);
		      }
		 }
	       else
		 {	/* Cgen/proto.scm 47 */
		    test1726_1106 = ((bool_t) 0);
		 }
	    }
	    if (test1726_1106)
	      {		/* Cgen/proto.scm 54 */
		 value_bglt aux_2466;
		 {	/* Cgen/proto.scm 54 */
		    global_bglt obj_2005;
		    obj_2005 =
		       (global_bglt) (global_1104);
		    aux_2466 =
		       (((global_bglt) CREF(obj_2005))->value);
		 }
		 return
		    emit_prototype_23_cgen_prototype(aux_2466,
		    (variable_bglt) (global_1104));
	      }
	    else
	      {		/* Cgen/proto.scm 47 */
		 return BUNSPEC;
	      }
	 }
      }
   }
}



/* emit-cnsts */
obj_t 
emit_cnsts_221_cgen_prototype()
{
   AN_OBJECT;
   {	/* Cgen/proto.scm 66 */
      {		/* Cgen/proto.scm 69 */
	 obj_t _anonymous_1750__169_2357;
	 _anonymous_1750__169_2357 = proc2138_cgen_prototype;
	 for_each_global__88_ast_env(_anonymous_1750__169_2357);
      }
      {		/* Cgen/proto.scm 76 */
	 obj_t port_2026;
	 port_2026 = _c_port__188_cgen_emit;
	 {	/* ./Ieee/output.scm 9332 */
	    unsigned char aux_2472;
	    aux_2472 =
	       WRITE_CHAR(((unsigned char) '\n'), port_2026);
	    return
	       BCHAR(aux_2472);
	 }
      }
   }
}



/* _emit-cnsts */
obj_t 
_emit_cnsts_87_cgen_prototype(obj_t env_2358)
{
   AN_OBJECT;
   {	/* Cgen/proto.scm 66 */
      return
	 emit_cnsts_221_cgen_prototype();
   }
}



/* <anonymous:1750> */
obj_t 
_anonymous_1750__169_cgen_prototype(obj_t env_2359, obj_t global_2360)
{
   AN_OBJECT;
   {	/* Cgen/proto.scm 68 */
      {
	 obj_t global_1131;
	 global_1131 = global_2360;
	 {	/* Cgen/proto.scm 69 */
	    bool_t test1751_1133;
	    {	/* Cgen/proto.scm 69 */
	       bool_t test1753_1135;
	       {	/* Cgen/proto.scm 69 */
		  bool_t test1764_1145;
		  {	/* Cgen/proto.scm 69 */
		     obj_t obj2_2010;
		     obj2_2010 = _module__166_module_module;
		     {	/* ./Ieee/equiv.scm 5508 */
			obj_t aux_2476;
			{	/* Cgen/proto.scm 69 */
			   global_bglt obj_2008;
			   obj_2008 =
			      (global_bglt) (global_1131);
			   aux_2476 =
			      (((global_bglt) CREF(obj_2008))->module);
			}
			test1764_1145 =
			   (aux_2476 == obj2_2010);
		     }
		  }
		  if (test1764_1145)
		    {	/* Cgen/proto.scm 69 */
		       test1753_1135 = ((bool_t) 1);
		    }
		  else
		    {	/* Cgen/proto.scm 70 */
		       bool_t test_2481;
		       {	/* ./Ieee/equiv.scm 5508 */
			  obj_t aux_2485;
			  obj_t aux_2482;
			  aux_2485 =
			     CNST_TABLE_REF(((long) 0));
			  {	/* Cgen/proto.scm 70 */
			     global_bglt obj_2011;
			     obj_2011 =
				(global_bglt) (global_1131);
			     aux_2482 =
				(((global_bglt) CREF(obj_2011))->import);
			  }
			  test_2481 =
			     (aux_2482 == aux_2485);
		       }
		       if (test_2481)
			 {	/* Cgen/proto.scm 70 */
			    test1753_1135 = ((bool_t) 0);
			 }
		       else
			 {	/* Cgen/proto.scm 70 */
			    test1753_1135 = ((bool_t) 1);
			 }
		    }
	       }
	       if (test1753_1135)
		 {	/* Cgen/proto.scm 71 */
		    bool_t test1754_1136;
		    {	/* Cgen/proto.scm 71 */
		       bool_t test1756_1138;
		       {	/* Cgen/proto.scm 71 */
			  bool_t test1760_1141;
			  {	/* Cgen/proto.scm 71 */
			     obj_t obj2_2016;
			     obj2_2016 = _module__166_module_module;
			     {	/* ./Ieee/equiv.scm 5508 */
				obj_t aux_2489;
				{	/* Cgen/proto.scm 71 */
				   global_bglt obj_2014;
				   obj_2014 =
				      (global_bglt) (global_1131);
				   aux_2489 =
				      (((global_bglt) CREF(obj_2014))->module);
				}
				test1760_1141 =
				   (aux_2489 == obj2_2016);
			     }
			  }
			  if (test1760_1141)
			    {	/* ./Ieee/equiv.scm 5508 */
			       obj_t aux_2497;
			       obj_t aux_2494;
			       aux_2497 =
				  CNST_TABLE_REF(((long) 1));
			       {	/* Cgen/proto.scm 72 */
				  global_bglt obj_2017;
				  obj_2017 =
				     (global_bglt) (global_1131);
				  aux_2494 =
				     (((global_bglt) CREF(obj_2017))->import);
			       }
			       test1756_1138 =
				  (aux_2494 == aux_2497);
			    }
			  else
			    {	/* Cgen/proto.scm 71 */
			       test1756_1138 = ((bool_t) 0);
			    }
		       }
		       if (test1756_1138)
			 {	/* Cgen/proto.scm 71 */
			    test1754_1136 = ((bool_t) 1);
			 }
		       else
			 {	/* ./Ieee/fixnum.scm 7121 */
			    long aux_2501;
			    {	/* Cgen/proto.scm 73 */
			       global_bglt obj_2020;
			       obj_2020 =
				  (global_bglt) (global_1131);
			       aux_2501 =
				  (((global_bglt) CREF(obj_2020))->occurrence);
			    }
			    test1754_1136 =
			       (aux_2501 > ((long) 0));
			 }
		    }
		    if (test1754_1136)
		      {		/* ./Ast/var.scm 1376 */
			 obj_t aux_2506;
			 {	/* Cgen/proto.scm 74 */
			    value_bglt aux_2507;
			    {	/* Cgen/proto.scm 74 */
			       global_bglt obj_2023;
			       obj_2023 =
				  (global_bglt) (global_1131);
			       aux_2507 =
				  (((global_bglt) CREF(obj_2023))->value);
			    }
			    aux_2506 =
			       (obj_t) (aux_2507);
			 }
			 test1751_1133 =
			    is_a__118___object(aux_2506, scnst_ast_var);
		      }
		    else
		      {		/* Cgen/proto.scm 71 */
			 test1751_1133 = ((bool_t) 0);
		      }
		 }
	       else
		 {	/* Cgen/proto.scm 69 */
		    test1751_1133 = ((bool_t) 0);
		 }
	    }
	    if (test1751_1133)
	      {		/* Cgen/proto.scm 75 */
		 scnst_bglt aux_2513;
		 {	/* Cgen/proto.scm 75 */
		    value_bglt aux_2514;
		    {	/* Cgen/proto.scm 75 */
		       global_bglt obj_2025;
		       obj_2025 =
			  (global_bglt) (global_1131);
		       aux_2514 =
			  (((global_bglt) CREF(obj_2025))->value);
		    }
		    aux_2513 =
		       (scnst_bglt) (aux_2514);
		 }
		 return
		    emit_cnst_44_cgen_prototype(aux_2513,
		    (global_bglt) (global_1131));
	      }
	    else
	      {		/* Cgen/proto.scm 69 */
		 return BUNSPEC;
	      }
	 }
      }
   }
}



/* emit-prototype/svar/scnst */
unsigned char 
emit_prototype_svar_scnst_27_cgen_prototype(obj_t value_19, variable_bglt variable_20)
{
   AN_OBJECT;
   {	/* Cgen/proto.scm 98 */
      set_variable_name__102_cgen_prototype(
	 (obj_t) (variable_20));
      {		/* Cgen/proto.scm 102 */
	 bool_t test_2522;
	 {	/* ./Ieee/equiv.scm 5508 */
	    obj_t aux_2526;
	    obj_t aux_2523;
	    aux_2526 =
	       CNST_TABLE_REF(((long) 0));
	    {	/* Cgen/proto.scm 102 */
	       global_bglt obj_2027;
	       obj_2027 =
		  (global_bglt) (variable_20);
	       aux_2523 =
		  (((global_bglt) CREF(obj_2027))->import);
	    }
	    test_2522 =
	       (aux_2523 == aux_2526);
	 }
	 if (test_2522)
	   {	/* Cgen/proto.scm 102 */
	      {		/* Cgen/proto.scm 103 */
		 obj_t port1664_1153;
		 port1664_1153 = _c_port__188_cgen_emit;
		 display_2_122___r4_output_6_10_3(string2139_cgen_prototype, port1664_1153);
		 display_2_122___r4_output_6_10_3(
		    BCHAR(((unsigned char) ' ')), port1664_1153);
		 {	/* Cgen/proto.scm 106 */
		    obj_t arg1770_1154;
		    arg1770_1154 =
		       make_typed_declaration_180_type_tools(
		       (((variable_bglt) CREF(variable_20))->type),
		       (((variable_bglt) CREF(variable_20))->name));
		    display_2_122___r4_output_6_10_3(arg1770_1154, port1664_1153);
		 }
		 {	/* Cgen/proto.scm 107 */
		    obj_t arg1773_1157;
		    {	/* Cgen/proto.scm 107 */
		       bool_t test1774_1158;
		       test1774_1158 =
			  sub_type__174_type_env(
			  (((variable_bglt) CREF(variable_20))->type),
			  (type_bglt) (_obj__252_type_cache));
		       if (test1774_1158)
			 {	/* Cgen/proto.scm 107 */
			    arg1773_1157 = string2140_cgen_prototype;
			 }
		       else
			 {	/* Cgen/proto.scm 107 */
			    arg1773_1157 =
			       BCHAR(((unsigned char) ';'));
			 }
		    }
		    display_2_122___r4_output_6_10_3(arg1773_1157, port1664_1153);
		 }
		 return
		    WRITE_CHAR(((unsigned char) '\n'), port1664_1153);
	      }
	   }
	 else
	   {	/* Cgen/proto.scm 108 */
	      bool_t test_2543;
	      {		/* ./Ieee/equiv.scm 5508 */
		 obj_t aux_2547;
		 obj_t aux_2544;
		 aux_2547 =
		    CNST_TABLE_REF(((long) 1));
		 {	/* Cgen/proto.scm 108 */
		    global_bglt obj_2034;
		    obj_2034 =
		       (global_bglt) (variable_20);
		    aux_2544 =
		       (((global_bglt) CREF(obj_2034))->import);
		 }
		 test_2543 =
		    (aux_2544 == aux_2547);
	      }
	      if (test_2543)
		{	/* Cgen/proto.scm 108 */
		   {	/* Cgen/proto.scm 109 */
		      obj_t port1665_1161;
		      port1665_1161 = _c_port__188_cgen_emit;
		      {		/* Cgen/proto.scm 110 */
			 obj_t arg1777_1162;
			 arg1777_1162 =
			    make_typed_declaration_180_type_tools(
			    (((variable_bglt) CREF(variable_20))->type),
			    (((variable_bglt) CREF(variable_20))->name));
			 display_2_122___r4_output_6_10_3(arg1777_1162, port1665_1161);
		      }
		      {		/* Cgen/proto.scm 111 */
			 obj_t arg1780_1165;
			 {	/* Cgen/proto.scm 111 */
			    bool_t test1781_1166;
			    test1781_1166 =
			       sub_type__174_type_env(
			       (((variable_bglt) CREF(variable_20))->type),
			       (type_bglt) (_obj__252_type_cache));
			    if (test1781_1166)
			      {		/* Cgen/proto.scm 111 */
				 arg1780_1165 = string2140_cgen_prototype;
			      }
			    else
			      {		/* Cgen/proto.scm 111 */
				 arg1780_1165 =
				    BCHAR(((unsigned char) ';'));
			      }
			 }
			 display_2_122___r4_output_6_10_3(arg1780_1165, port1665_1161);
		      }
		      return
			 WRITE_CHAR(((unsigned char) '\n'), port1665_1161);
		   }
		}
	      else
		{	/* Cgen/proto.scm 108 */
		   {	/* Cgen/proto.scm 113 */
		      obj_t port1666_1168;
		      port1666_1168 = _c_port__188_cgen_emit;
		      {		/* Cgen/proto.scm 114 */
			 obj_t arg1783_1169;
			 arg1783_1169 =
			    get_c_scope_184_cgen_prototype(variable_20);
			 display_2_122___r4_output_6_10_3(arg1783_1169, port1666_1168);
		      }
		      display_2_122___r4_output_6_10_3(
			 BCHAR(((unsigned char) ' ')), port1666_1168);
		      {		/* Cgen/proto.scm 116 */
			 obj_t arg1784_1170;
			 arg1784_1170 =
			    make_typed_declaration_180_type_tools(
			    (((variable_bglt) CREF(variable_20))->type),
			    (((variable_bglt) CREF(variable_20))->name));
			 display_2_122___r4_output_6_10_3(arg1784_1170, port1666_1168);
		      }
		      display_2_122___r4_output_6_10_3(
			 BCHAR(((unsigned char) ';')), port1666_1168);
		      return
			 WRITE_CHAR(((unsigned char) '\n'), port1666_1168);
		   }
		}
	   }
      }
   }
}



/* emit-prototype-formal-types */
obj_t 
emit_prototype_formal_types_237_cgen_prototype(obj_t types_23)
{
   AN_OBJECT;
   {	/* Cgen/proto.scm 136 */
      if (
	 NULLP(types_23))
	{	/* Cgen/proto.scm 138 */
	   obj_t port1671_1178;
	   port1671_1178 = _c_port__188_cgen_emit;
	   return
	      display_2_122___r4_output_6_10_3(string2141_cgen_prototype, port1671_1178);
	}
      else
	{	/* Cgen/proto.scm 137 */
	   display_2_122___r4_output_6_10_3(
	      BCHAR(((unsigned char) '(')), _c_port__188_cgen_emit);
	   {
	      obj_t types_1179;
	      types_1179 = types_23;
	    loop_1180:
	      {		/* Cgen/proto.scm 142 */
		 bool_t test_2577;
		 {	/* ./Ieee/pair-list.scm 5912 */
		    obj_t aux_2578;
		    aux_2578 =
		       CDR(types_1179);
		    test_2577 =
		       NULLP(aux_2578);
		 }
		 if (test_2577)
		   {	/* Cgen/proto.scm 143 */
		      obj_t port1672_1182;
		      port1672_1182 = _c_port__188_cgen_emit;
		      {		/* Cgen/proto.scm 143 */
			 obj_t arg1793_1183;
			 {	/* Cgen/proto.scm 143 */
			    type_bglt aux_2581;
			    {	/* Cgen/proto.scm 143 */
			       obj_t aux_2582;
			       aux_2582 =
				  CAR(types_1179);
			       aux_2581 =
				  (type_bglt) (aux_2582);
			    }
			    arg1793_1183 =
			       type_name_sans___47_type_tools(aux_2581);
			 }
			 display_2_122___r4_output_6_10_3(arg1793_1183, port1672_1182);
		      }
		      return
			 display_2_122___r4_output_6_10_3(
			 BCHAR(((unsigned char) ')')), port1672_1182);
		   }
		 else
		   {	/* Cgen/proto.scm 142 */
		      {		/* Cgen/proto.scm 145 */
			 obj_t port1673_1185;
			 port1673_1185 = _c_port__188_cgen_emit;
			 {	/* Cgen/proto.scm 145 */
			    obj_t arg1795_1186;
			    {	/* Cgen/proto.scm 145 */
			       type_bglt aux_2589;
			       {	/* Cgen/proto.scm 145 */
				  obj_t aux_2590;
				  aux_2590 =
				     CAR(types_1179);
				  aux_2589 =
				     (type_bglt) (aux_2590);
			       }
			       arg1795_1186 =
				  type_name_sans___47_type_tools(aux_2589);
			    }
			    display_2_122___r4_output_6_10_3(arg1795_1186, port1673_1185);
			 }
			 display_2_122___r4_output_6_10_3(string2142_cgen_prototype, port1673_1185);
		      }
		      {
			 obj_t types_2596;
			 types_2596 =
			    CDR(types_1179);
			 types_1179 = types_2596;
			 goto loop_1180;
		      }
		   }
	      }
	   }
	}
   }
}



/* emit-prototype-formals */
obj_t 
emit_prototype_formals_182_cgen_prototype(obj_t args_24)
{
   AN_OBJECT;
   {	/* Cgen/proto.scm 151 */
      if (
	 NULLP(args_24))
	{	/* Cgen/proto.scm 153 */
	   obj_t port1674_1191;
	   port1674_1191 = _c_port__188_cgen_emit;
	   return
	      display_2_122___r4_output_6_10_3(string2141_cgen_prototype, port1674_1191);
	}
      else
	{	/* Cgen/proto.scm 152 */
	   display_2_122___r4_output_6_10_3(
	      BCHAR(((unsigned char) '(')), _c_port__188_cgen_emit);
	   {
	      obj_t args_1192;
	      args_1192 = args_24;
	    loop_1193:
	      {		/* Cgen/proto.scm 157 */
		 bool_t test_2603;
		 {	/* ./Ieee/pair-list.scm 5912 */
		    obj_t aux_2604;
		    aux_2604 =
		       CDR(args_1192);
		    test_2603 =
		       NULLP(aux_2604);
		 }
		 if (test_2603)
		   {	/* Cgen/proto.scm 159 */
		      obj_t port1676_1196;
		      port1676_1196 = _c_port__188_cgen_emit;
		      {		/* Cgen/proto.scm 159 */
			 obj_t arg1801_1197;
			 {	/* Cgen/proto.scm 159 */
			    type_bglt aux_2607;
			    {	/* Cgen/proto.scm 159 */
			       local_bglt obj_2054;
			       {	/* Cgen/proto.scm 159 */
				  obj_t aux_2608;
				  aux_2608 =
				     CAR(args_1192);
				  obj_2054 =
				     (local_bglt) (aux_2608);
			       }
			       aux_2607 =
				  (((local_bglt) CREF(obj_2054))->type);
			    }
			    arg1801_1197 =
			       type_name_sans___47_type_tools(aux_2607);
			 }
			 display_2_122___r4_output_6_10_3(arg1801_1197, port1676_1196);
		      }
		      return
			 display_2_122___r4_output_6_10_3(
			 BCHAR(((unsigned char) ')')), port1676_1196);
		   }
		 else
		   {	/* Cgen/proto.scm 157 */
		      {		/* Cgen/proto.scm 161 */
			 obj_t port1678_1200;
			 port1678_1200 = _c_port__188_cgen_emit;
			 {	/* Cgen/proto.scm 161 */
			    obj_t arg1803_1201;
			    {	/* Cgen/proto.scm 161 */
			       type_bglt aux_2616;
			       {	/* Cgen/proto.scm 161 */
				  local_bglt obj_2056;
				  {	/* Cgen/proto.scm 161 */
				     obj_t aux_2617;
				     aux_2617 =
					CAR(args_1192);
				     obj_2056 =
					(local_bglt) (aux_2617);
				  }
				  aux_2616 =
				     (((local_bglt) CREF(obj_2056))->type);
			       }
			       arg1803_1201 =
				  type_name_sans___47_type_tools(aux_2616);
			    }
			    display_2_122___r4_output_6_10_3(arg1803_1201, port1678_1200);
			 }
			 display_2_122___r4_output_6_10_3(string2142_cgen_prototype, port1678_1200);
		      }
		      {
			 obj_t args_2624;
			 args_2624 =
			    CDR(args_1192);
			 args_1192 = args_2624;
			 goto loop_1193;
		      }
		   }
	      }
	   }
	}
   }
}



/* emit-cnst */
obj_t 
emit_cnst_44_cgen_prototype(scnst_bglt value_29, global_bglt variable_30)
{
   AN_OBJECT;
   {	/* Cgen/proto.scm 203 */
      {		/* Cgen/proto.scm 205 */
	 obj_t case_value_58_1206;
	 case_value_58_1206 =
	    (((scnst_bglt) CREF(value_29))->class);
	 {	/* Cgen/proto.scm 205 */
	    bool_t test_2627;
	    {	/* ./Ieee/equiv.scm 5508 */
	       obj_t aux_2628;
	       aux_2628 =
		  CNST_TABLE_REF(((long) 3));
	       test_2627 =
		  (case_value_58_1206 == aux_2628);
	    }
	    if (test_2627)
	      {		/* Cgen/proto.scm 205 */
		 return
		    emit_cnst_string_104_cgen_prototype(
		    (((scnst_bglt) CREF(value_29))->node), variable_30);
	      }
	    else
	      {		/* Cgen/proto.scm 205 */
		 bool_t test_2633;
		 {	/* ./Ieee/equiv.scm 5508 */
		    obj_t aux_2634;
		    aux_2634 =
		       CNST_TABLE_REF(((long) 4));
		    test_2633 =
		       (case_value_58_1206 == aux_2634);
		 }
		 if (test_2633)
		   {	/* Cgen/proto.scm 209 */
		      unsigned char aux_2637;
		      aux_2637 =
			 emit_cnst_real_94_cgen_prototype(
			 (((scnst_bglt) CREF(value_29))->node), variable_30);
		      return
			 BCHAR(aux_2637);
		   }
		 else
		   {	/* Cgen/proto.scm 205 */
		      bool_t test_2641;
		      {		/* ./Ieee/equiv.scm 5508 */
			 obj_t aux_2642;
			 aux_2642 =
			    CNST_TABLE_REF(((long) 5));
			 test_2641 =
			    (case_value_58_1206 == aux_2642);
		      }
		      if (test_2641)
			{	/* Cgen/proto.scm 205 */
			   return
			      emit_cnst_sfun_sgfun_176_cgen_prototype(
			      (((scnst_bglt) CREF(value_29))->node), variable_30, "PROCEDURE");
			}
		      else
			{	/* Cgen/proto.scm 205 */
			   bool_t test_2647;
			   {	/* ./Ieee/equiv.scm 5508 */
			      obj_t aux_2648;
			      aux_2648 =
				 CNST_TABLE_REF(((long) 6));
			      test_2647 =
				 (case_value_58_1206 == aux_2648);
			   }
			   if (test_2647)
			     {	/* Cgen/proto.scm 205 */
				return
				   emit_cnst_sfun_sgfun_176_cgen_prototype(
				   (((scnst_bglt) CREF(value_29))->node), variable_30, "GENERIC");
			     }
			   else
			     {	/* Cgen/proto.scm 205 */
				bool_t test_2653;
				{	/* ./Ieee/equiv.scm 5508 */
				   obj_t aux_2654;
				   aux_2654 =
				      CNST_TABLE_REF(((long) 7));
				   test_2653 =
				      (case_value_58_1206 == aux_2654);
				}
				if (test_2653)
				  {	/* Cgen/proto.scm 215 */
				     unsigned char aux_2657;
				     aux_2657 =
					emit_cnst_stvector_253_cgen_prototype(
					(((scnst_bglt) CREF(value_29))->node), variable_30);
				     return
					BCHAR(aux_2657);
				  }
				else
				  {	/* Cgen/proto.scm 205 */
				     return
					internal_error_43_tools_error(string2143_cgen_prototype, string2144_cgen_prototype,
					(((scnst_bglt) CREF(value_29))->class));
				  }
			     }
			}
		   }
	      }
	 }
      }
   }
}



/* emit-cnst-string */
obj_t 
emit_cnst_string_104_cgen_prototype(obj_t ostr_31, global_bglt global_32)
{
   AN_OBJECT;
   {	/* Cgen/proto.scm 222 */
      set_variable_name__102_cgen_prototype(
	 (obj_t) (global_32));
      {		/* Cgen/proto.scm 224 */
	 obj_t str_1220;
	 str_1220 =
	    string_for_read(ostr_31);
	 {	/* Cgen/proto.scm 225 */
	    obj_t port1689_1221;
	    port1689_1221 = _c_port__188_cgen_emit;
	    display_2_122___r4_output_6_10_3(string2145_cgen_prototype, port1689_1221);
	    display_2_122___r4_output_6_10_3(
	       (((global_bglt) CREF(global_32))->name), port1689_1221);
	    display_2_122___r4_output_6_10_3(string2142_cgen_prototype, port1689_1221);
	    {	/* Cgen/proto.scm 229 */
	       obj_t arg1823_1223;
	       {	/* Cgen/proto.scm 229 */
		  obj_t arg1824_1224;
		  arg1824_1224 =
		     PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4,
		     (((global_bglt) CREF(global_32))->name), BEOA);
		  arg1823_1223 =
		     id__name_228_ast_ident(arg1824_1224);
	       }
	       display_2_122___r4_output_6_10_3(arg1823_1223, port1689_1221);
	    }
	    display_2_122___r4_output_6_10_3(string2146_cgen_prototype, port1689_1221);
	 }
	 {
	    long read_1226;
	    long rlen_1227;
	    read_1226 = ((long) 0);
	    rlen_1227 =
	       STRING_LENGTH(str_1220);
	  loop_1228:
	    {	/* Cgen/proto.scm 234 */
	       bool_t test1828_1231;
	       {	/* Cgen/proto.scm 234 */
		  long n2_2084;
		  n2_2084 =
		     (long) CINT(_max_c_token_length__129_engine_param);
		  test1828_1231 =
		     (rlen_1227 <= n2_2084);
	       }
	       if (test1828_1231)
		 {	/* Cgen/proto.scm 234 */
		    {	/* Cgen/proto.scm 235 */
		       obj_t arg1830_1232;
		       {	/* Cgen/proto.scm 235 */
			  obj_t arg1831_1233;
			  {	/* ./Ieee/string.scm 8192 */
			     long aux_2679;
			     aux_2679 =
				(read_1226 + rlen_1227);
			     arg1831_1233 =
				c_substring(str_1220, read_1226, aux_2679);
			  }
			  arg1830_1232 =
			     untrigraph_cgen_emit_cop_239(arg1831_1233);
		       }
		       display_2_122___r4_output_6_10_3(arg1830_1232, _c_port__188_cgen_emit);
		    }
		    {	/* Cgen/proto.scm 237 */
		       obj_t port1690_1235;
		       port1690_1235 = _c_port__188_cgen_emit;
		       display_2_122___r4_output_6_10_3(string2147_cgen_prototype, port1690_1235);
		       {	/* Cgen/proto.scm 237 */
			  obj_t aux_2685;
			  {	/* Cgen/proto.scm 237 */
			     long aux_2686;
			     aux_2686 =
				STRING_LENGTH(ostr_31);
			     aux_2685 =
				BINT(aux_2686);
			  }
			  display_2_122___r4_output_6_10_3(aux_2685, port1690_1235);
		       }
		       display_2_122___r4_output_6_10_3(string2148_cgen_prototype, port1690_1235);
		       {	/* ./Ieee/output.scm 9332 */
			  unsigned char aux_2691;
			  aux_2691 =
			     WRITE_CHAR(((unsigned char) '\n'), port1690_1235);
			  return
			     BCHAR(aux_2691);
		       }
		    }
		 }
	       else
		 {	/* Cgen/proto.scm 234 */
		    {
		       long offset_1237;
		       {	/* Cgen/proto.scm 239 */
			  long arg1834_1239;
			  {	/* Cgen/proto.scm 239 */
			     long z2_2093;
			     z2_2093 =
				(long) CINT(_max_c_token_length__129_engine_param);
			     arg1834_1239 =
				(read_1226 + z2_2093);
			  }
			  offset_1237 = arg1834_1239;
			laap_1238:
			  {	/* Cgen/proto.scm 241 */
			     bool_t test_2696;
			     {	/* ./Ieee/fixnum.scm 7133 */
				long aux_2697;
				aux_2697 =
				   (read_1226 + ((long) 3));
				test_2696 =
				   (aux_2697 >= offset_1237);
			     }
			     if (test_2696)
			       {	/* Cgen/proto.scm 241 */
				  return
				     internal_error_43_tools_error(string2149_cgen_prototype, string2150_cgen_prototype, ostr_31);
			       }
			     else
			       {	/* Cgen/proto.scm 245 */
				  bool_t test_2701;
				  {	/* ./Ieee/char.scm 7775 */
				     unsigned char aux_2702;
				     {	/* ./Ieee/string.scm 8089 */
					long aux_2703;
					aux_2703 =
					   (offset_1237 - ((long) 1));
					aux_2702 =
					   STRING_REF(str_1220, aux_2703);
				     }
				     test_2701 =
					(aux_2702 == ((unsigned char) '\\'));
				  }
				  if (test_2701)
				    {	/* Cgen/proto.scm 245 */
				       {
					  long offset_2707;
					  offset_2707 =
					     (offset_1237 - ((long) 1));
					  offset_1237 = offset_2707;
					  goto laap_1238;
				       }
				    }
				  else
				    {	/* Cgen/proto.scm 247 */
				       bool_t test_2709;
				       {	/* Cgen/proto.scm 247 */
					  bool_t test_2710;
					  {	/* ./Ieee/char.scm 7775 */
					     unsigned char aux_2711;
					     {	/* ./Ieee/string.scm 8089 */
						long aux_2712;
						aux_2712 =
						   (offset_1237 - ((long) 2));
						aux_2711 =
						   STRING_REF(str_1220, aux_2712);
					     }
					     test_2710 =
						(aux_2711 == ((unsigned char) '\\'));
					  }
					  if (test_2710)
					    {	/* Cgen/proto.scm 248 */
					       unsigned char arg1856_1260;
					       {	/* ./Ieee/string.scm 8089 */
						  long aux_2716;
						  aux_2716 =
						     (offset_1237 - ((long) 1));
						  arg1856_1260 =
						     STRING_REF(str_1220, aux_2716);
					       }
					       if (
						  (arg1856_1260 >= ((unsigned char) '0')))
						 {	/* ./Ieee/char.scm 7844 */
						    test_2709 =
						       (arg1856_1260 <= ((unsigned char) '9'))
						       ;
						 }
					       else
						 {	/* ./Ieee/char.scm 7844 */
						    test_2709 = ((bool_t) 0)
						       ;
						 }
					    }
					  else
					    {	/* Cgen/proto.scm 247 */
					       test_2709 = ((bool_t) 0)
						  ;
					    }
				       }
				       if (test_2709)
					 {	/* Cgen/proto.scm 247 */
					    {
					       long offset_2722;
					       offset_2722 =
						  (offset_1237 - ((long) 2));
					       offset_1237 = offset_2722;
					       goto laap_1238;
					    }
					 }
				       else
					 {	/* Cgen/proto.scm 250 */
					    bool_t test_2724;
					    {	/* Cgen/proto.scm 250 */
					       bool_t test_2725;
					       {	/* ./Ieee/char.scm 7775 */
						  unsigned char aux_2726;
						  {	/* ./Ieee/string.scm 8089 */
						     long aux_2727;
						     aux_2727 =
							(offset_1237 - ((long) 3));
						     aux_2726 =
							STRING_REF(str_1220, aux_2727);
						  }
						  test_2725 =
						     (aux_2726 == ((unsigned char) '\\'));
					       }
					       if (test_2725)
						 {	/* Cgen/proto.scm 251 */
						    bool_t test_2731;
						    {	/* Cgen/proto.scm 251 */
						       unsigned char arg1851_1255;
						       {	/* ./Ieee/string.scm 8089 */
							  long aux_2732;
							  aux_2732 =
							     (offset_1237 - ((long) 2));
							  arg1851_1255 =
							     STRING_REF(str_1220, aux_2732);
						       }
						       if (
							  (arg1851_1255 >= ((unsigned char) '0')))
							 {	/* ./Ieee/char.scm 7844 */
							    test_2731 =
							       (arg1851_1255 <= ((unsigned char) '9'))
							       ;
							 }
						       else
							 {	/* ./Ieee/char.scm 7844 */
							    test_2731 = ((bool_t) 0)
							       ;
							 }
						    }
						    if (test_2731)
						      {		/* Cgen/proto.scm 252 */
							 unsigned char arg1849_1253;
							 {	/* ./Ieee/string.scm 8089 */
							    long aux_2738;
							    aux_2738 =
							       (offset_1237 - ((long) 1));
							    arg1849_1253 =
							       STRING_REF(str_1220, aux_2738);
							 }
							 if (
							    (arg1849_1253 >= ((unsigned char) '0')))
							   {	/* ./Ieee/char.scm 7844 */
							      test_2724 =
								 (arg1849_1253 <= ((unsigned char) '9'))
								 ;
							   }
							 else
							   {	/* ./Ieee/char.scm 7844 */
							      test_2724 = ((bool_t) 0)
								 ;
							   }
						      }
						    else
						      {		/* Cgen/proto.scm 251 */
							 test_2724 = ((bool_t) 0)
							    ;
						      }
						 }
					       else
						 {	/* Cgen/proto.scm 250 */
						    test_2724 = ((bool_t) 0)
						       ;
						 }
					    }
					    if (test_2724)
					      {		/* Cgen/proto.scm 250 */
						 {
						    long offset_2744;
						    offset_2744 =
						       (offset_1237 - ((long) 3));
						    offset_1237 = offset_2744;
						    goto laap_1238;
						 }
					      }
					    else
					      {		/* Cgen/proto.scm 250 */
						 {	/* Cgen/proto.scm 255 */
						    obj_t port1691_1247;
						    port1691_1247 = _c_port__188_cgen_emit;
						    {	/* Cgen/proto.scm 255 */
						       obj_t arg1844_1248;
						       arg1844_1248 =
							  c_substring(str_1220, read_1226, offset_1237);
						       display_2_122___r4_output_6_10_3(arg1844_1248, port1691_1247);
						    }
						    display_2_122___r4_output_6_10_3(string2151_cgen_prototype, port1691_1247);
						 }
						 {
						    long rlen_2750;
						    long read_2749;
						    read_2749 = offset_1237;
						    {	/* ./Ieee/fixnum.scm 7199 */
						       long aux_2751;
						       aux_2751 =
							  (offset_1237 - read_1226);
						       rlen_2750 =
							  (rlen_1227 - aux_2751);
						    }
						    rlen_1227 = rlen_2750;
						    read_1226 = read_2749;
						    goto loop_1228;
						 }
					      }
					 }
				    }
			       }
			  }
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* emit-cnst-real */
unsigned char 
emit_cnst_real_94_cgen_prototype(obj_t real_33, global_bglt global_34)
{
   AN_OBJECT;
   {	/* Cgen/proto.scm 262 */
      set_variable_name__102_cgen_prototype(
	 (obj_t) (global_34));
      {		/* Cgen/proto.scm 264 */
	 obj_t port1692_1267;
	 port1692_1267 = _c_port__188_cgen_emit;
	 display_2_122___r4_output_6_10_3(string2152_cgen_prototype, port1692_1267);
	 display_2_122___r4_output_6_10_3(
	    (((global_bglt) CREF(global_34))->name), port1692_1267);
	 display_2_122___r4_output_6_10_3(string2142_cgen_prototype, port1692_1267);
	 {	/* Cgen/proto.scm 268 */
	    obj_t arg1864_1269;
	    {	/* Cgen/proto.scm 268 */
	       obj_t arg1865_1270;
	       arg1865_1270 =
		  PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4,
		  (((global_bglt) CREF(global_34))->name), BEOA);
	       arg1864_1269 =
		  id__name_228_ast_ident(arg1865_1270);
	    }
	    display_2_122___r4_output_6_10_3(arg1864_1269, port1692_1267);
	 }
	 display_2_122___r4_output_6_10_3(string2142_cgen_prototype, port1692_1267);
	 display_2_122___r4_output_6_10_3(real_33, port1692_1267);
	 display_2_122___r4_output_6_10_3(string2148_cgen_prototype, port1692_1267);
	 return
	    WRITE_CHAR(((unsigned char) '\n'), port1692_1267);
      }
   }
}



/* emit-cnst-sfun/sgfun */
obj_t 
emit_cnst_sfun_sgfun_176_cgen_prototype(obj_t fun_39, global_bglt global_40, char *kind_41)
{
   AN_OBJECT;
   {	/* Cgen/proto.scm 288 */
      {		/* Cgen/proto.scm 289 */
	 bool_t test_2770;
	 {	/* ./Ieee/equiv.scm 5508 */
	    obj_t aux_2773;
	    obj_t aux_2771;
	    aux_2773 =
	       CNST_TABLE_REF(((long) 8));
	    aux_2771 =
	       (((global_bglt) CREF(global_40))->import);
	    test_2770 =
	       (aux_2771 == aux_2773);
	 }
	 if (test_2770)
	   {	/* Cgen/proto.scm 289 */
	      return
		 emit_prototype_23_cgen_prototype(
		 (((global_bglt) CREF(global_40))->value),
		 (variable_bglt) (global_40));
	   }
	 else
	   {	/* Cgen/proto.scm 291 */
	      obj_t actuals_1274;
	      {		/* Cgen/proto.scm 291 */
		 app_bglt obj_2169;
		 obj_2169 =
		    (app_bglt) (fun_39);
		 actuals_1274 =
		    (((app_bglt) CREF(obj_2169))->args);
	      }
	      {		/* Cgen/proto.scm 291 */
		 obj_t entry_1275;
		 entry_1275 =
		    CAR(actuals_1274);
		 {	/* Cgen/proto.scm 292 */
		    obj_t arity_1276;
		    {	/* Cgen/proto.scm 293 */
		       atom_bglt obj_2175;
		       {	/* Cgen/proto.scm 293 */
			  obj_t aux_2782;
			  {	/* ./Ieee/pair-list.scm 5701 */
			     obj_t aux_2783;
			     aux_2783 =
				CDR(actuals_1274);
			     aux_2782 =
				CAR(aux_2783);
			  }
			  obj_2175 =
			     (atom_bglt) (aux_2782);
		       }
		       arity_1276 =
			  (((atom_bglt) CREF(obj_2175))->value);
		    }
		    {	/* Cgen/proto.scm 293 */
		       obj_t vname_1277;
		       vname_1277 =
			  set_variable_name__102_cgen_prototype(
			  (obj_t) (global_40));
		       {	/* Cgen/proto.scm 294 */
			  obj_t name_1278;
			  {	/* Cgen/proto.scm 295 */
			     obj_t aux_2790;
			     {	/* Cgen/proto.scm 295 */
				variable_bglt aux_2791;
				{	/* Cgen/proto.scm 295 */
				   var_bglt obj_2176;
				   obj_2176 =
				      (var_bglt) (entry_1275);
				   aux_2791 =
				      (((var_bglt) CREF(obj_2176))->variable);
				}
				aux_2790 =
				   (obj_t) (aux_2791);
			     }
			     name_1278 =
				set_variable_name__102_cgen_prototype(aux_2790);
			  }
			  {	/* Cgen/proto.scm 295 */

			     {	/* Cgen/proto.scm 296 */
				bool_t test_2796;
				{	/* ./Ieee/fixnum.scm 7133 */
				   long aux_2797;
				   aux_2797 =
				      (long) CINT(arity_1276);
				   test_2796 =
				      (aux_2797 >= ((long) 0));
				}
				if (test_2796)
				  {	/* Cgen/proto.scm 297 */
				     obj_t port1693_1280;
				     port1693_1280 = _c_port__188_cgen_emit;
				     {	/* Cgen/proto.scm 298 */
					obj_t arg1870_1281;
					{	/* Cgen/proto.scm 298 */
					   bool_t test_2800;
					   {	/* ./Ieee/equiv.scm 5508 */
					      obj_t aux_2803;
					      obj_t aux_2801;
					      aux_2803 =
						 CNST_TABLE_REF(((long) 0));
					      aux_2801 =
						 (((global_bglt) CREF(global_40))->import);
					      test_2800 =
						 (aux_2801 == aux_2803);
					   }
					   if (test_2800)
					     {	/* Cgen/proto.scm 299 */
						obj_t arg1873_1284;
						{	/* Cgen/proto.scm 299 */
						   obj_t aux_2806;
						   aux_2806 =
						      string_to_bstring(kind_41);
						   arg1873_1284 =
						      string_append(aux_2806, string2153_cgen_prototype);
						}
						arg1870_1281 =
						   string_append(string2154_cgen_prototype, arg1873_1284);
					     }
					   else
					     {	/* Cgen/proto.scm 300 */
						obj_t arg1875_1286;
						{	/* Cgen/proto.scm 300 */
						   obj_t aux_2810;
						   aux_2810 =
						      string_to_bstring(kind_41);
						   arg1875_1286 =
						      string_append(aux_2810, string2153_cgen_prototype);
						}
						arg1870_1281 =
						   string_append(string2155_cgen_prototype, arg1875_1286);
					     }
					}
					display_2_122___r4_output_6_10_3(arg1870_1281, port1693_1280);
				     }
				     display_2_122___r4_output_6_10_3(vname_1277, port1693_1280);
				     display_2_122___r4_output_6_10_3(string2142_cgen_prototype, port1693_1280);
				     {	/* Cgen/proto.scm 303 */
					obj_t arg1879_1289;
					{	/* Cgen/proto.scm 303 */
					   obj_t arg1880_1290;
					   arg1880_1290 =
					      PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4, name_1278, BEOA);
					   arg1879_1289 =
					      id__name_228_ast_ident(arg1880_1290);
					}
					display_2_122___r4_output_6_10_3(arg1879_1289, port1693_1280);
				     }
				     display_2_122___r4_output_6_10_3(string2142_cgen_prototype, port1693_1280);
				     display_2_122___r4_output_6_10_3(name_1278, port1693_1280);
				     display_2_122___r4_output_6_10_3(string2156_cgen_prototype, port1693_1280);
				     display_2_122___r4_output_6_10_3(arity_1276, port1693_1280);
				     display_2_122___r4_output_6_10_3(string2148_cgen_prototype, port1693_1280);
				     {	/* ./Ieee/output.scm 9332 */
					unsigned char aux_2826;
					aux_2826 =
					   WRITE_CHAR(((unsigned char) '\n'), port1693_1280);
					return
					   BCHAR(aux_2826);
				     }
				  }
				else
				  {	/* Cgen/proto.scm 309 */
				     obj_t port1694_1291;
				     port1694_1291 = _c_port__188_cgen_emit;
				     {	/* Cgen/proto.scm 310 */
					obj_t arg1881_1292;
					{	/* Cgen/proto.scm 310 */
					   bool_t test_2829;
					   {	/* ./Ieee/equiv.scm 5508 */
					      obj_t aux_2832;
					      obj_t aux_2830;
					      aux_2832 =
						 CNST_TABLE_REF(((long) 0));
					      aux_2830 =
						 (((global_bglt) CREF(global_40))->import);
					      test_2829 =
						 (aux_2830 == aux_2832);
					   }
					   if (test_2829)
					     {	/* Cgen/proto.scm 311 */
						obj_t arg1884_1295;
						{	/* Cgen/proto.scm 311 */
						   obj_t aux_2835;
						   aux_2835 =
						      string_to_bstring(kind_41);
						   arg1884_1295 =
						      string_append(aux_2835, string2153_cgen_prototype);
						}
						arg1881_1292 =
						   string_append(string2154_cgen_prototype, arg1884_1295);
					     }
					   else
					     {	/* Cgen/proto.scm 312 */
						obj_t arg1886_1297;
						{	/* Cgen/proto.scm 312 */
						   obj_t aux_2839;
						   aux_2839 =
						      string_to_bstring(kind_41);
						   arg1886_1297 =
						      string_append(aux_2839, string2153_cgen_prototype);
						}
						arg1881_1292 =
						   string_append(string2155_cgen_prototype, arg1886_1297);
					     }
					}
					display_2_122___r4_output_6_10_3(arg1881_1292, port1694_1291);
				     }
				     display_2_122___r4_output_6_10_3(vname_1277, port1694_1291);
				     display_2_122___r4_output_6_10_3(string2142_cgen_prototype, port1694_1291);
				     {	/* Cgen/proto.scm 315 */
					obj_t arg1889_1300;
					{	/* Cgen/proto.scm 315 */
					   obj_t arg1890_1301;
					   arg1890_1301 =
					      PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4, name_1278, BEOA);
					   arg1889_1300 =
					      id__name_228_ast_ident(arg1890_1301);
					}
					display_2_122___r4_output_6_10_3(arg1889_1300, port1694_1291);
				     }
				     display_2_122___r4_output_6_10_3(string2157_cgen_prototype, port1694_1291);
				     display_2_122___r4_output_6_10_3(string2142_cgen_prototype, port1694_1291);
				     display_2_122___r4_output_6_10_3(name_1278, port1694_1291);
				     display_2_122___r4_output_6_10_3(string2142_cgen_prototype, port1694_1291);
				     display_2_122___r4_output_6_10_3(arity_1276, port1694_1291);
				     display_2_122___r4_output_6_10_3(string2148_cgen_prototype, port1694_1291);
				     {	/* ./Ieee/output.scm 9332 */
					unsigned char aux_2856;
					aux_2856 =
					   WRITE_CHAR(((unsigned char) '\n'), port1694_1291);
					return
					   BCHAR(aux_2856);
				     }
				  }
			     }
			  }
		       }
		    }
		 }
	      }
	   }
      }
   }
}



/* emit-cnst-stvector */
unsigned char 
emit_cnst_stvector_253_cgen_prototype(obj_t tvec_42, global_bglt global_43)
{
   AN_OBJECT;
   {	/* Cgen/proto.scm 326 */
      {		/* Cgen/proto.scm 327 */
	 obj_t vec_1306;
	 vec_1306 =
	    STRUCT_REF(tvec_42, ((long) 1));
	 {	/* Cgen/proto.scm 327 */
	    type_bglt itype_1307;
	    {	/* Cgen/proto.scm 328 */
	       tvec_bglt obj_2193;
	       {	/* Cgen/proto.scm 328 */
		  obj_t aux_2860;
		  aux_2860 =
		     STRUCT_REF(tvec_42, ((long) 0));
		  obj_2193 =
		     (tvec_bglt) (aux_2860);
	       }
	       {
		  obj_t aux_2863;
		  {	/* ./Tvector/tvector.scm 1667 */
		     object_bglt aux_2864;
		     aux_2864 =
			(object_bglt) (obj_2193);
		     aux_2863 =
			OBJECT_WIDENING(aux_2864);
		  }
		  itype_1307 =
		     (((tvec_bglt) CREF(aux_2863))->item_type_130);
	       }
	    }
	    {	/* Cgen/proto.scm 328 */
	       obj_t c_vec_209_1308;
	       c_vec_209_1308 =
		  tvector__c_vector_165_tvector_cnst(tvec_42);
	       {	/* Cgen/proto.scm 329 */

		  set_variable_name__102_cgen_prototype(
		     (obj_t) (global_43));
		  {	/* Cgen/proto.scm 331 */
		     obj_t aux_1309;
		     {	/* Cgen/proto.scm 331 */
			obj_t arg1899_1315;
			arg1899_1315 =
			   PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4,
			   (((global_bglt) CREF(global_43))->name), BEOA);
			aux_1309 =
			   id__name_228_ast_ident(arg1899_1315);
		     }
		     {	/* Cgen/proto.scm 332 */
			obj_t port1695_1310;
			port1695_1310 = _c_port__188_cgen_emit;
			display_2_122___r4_output_6_10_3(string2158_cgen_prototype, port1695_1310);
			display_2_122___r4_output_6_10_3(aux_1309, port1695_1310);
			display_2_122___r4_output_6_10_3(string2142_cgen_prototype, port1695_1310);
			{	/* Cgen/proto.scm 332 */
			   obj_t aux_2878;
			   {	/* Cgen/proto.scm 332 */
			      long aux_2879;
			      aux_2879 =
				 VECTOR_LENGTH(vec_1306);
			      aux_2878 =
				 BINT(aux_2879);
			   }
			   display_2_122___r4_output_6_10_3(aux_2878, port1695_1310);
			}
			display_2_122___r4_output_6_10_3(string2142_cgen_prototype, port1695_1310);
			{	/* Cgen/proto.scm 338 */
			   obj_t arg1896_1312;
			   arg1896_1312 =
			      string_sans___40_type_tools(
			      (((type_bglt) CREF(itype_1307))->name));
			   display_2_122___r4_output_6_10_3(arg1896_1312, port1695_1310);
			}
			display_2_122___r4_output_6_10_3(string2159_cgen_prototype, port1695_1310);
			display_2_122___r4_output_6_10_3(c_vec_209_1308, port1695_1310);
			display_2_122___r4_output_6_10_3(string2160_cgen_prototype, port1695_1310);
			display_2_122___r4_output_6_10_3(
			   (((global_bglt) CREF(global_43))->name), port1695_1310);
			display_2_122___r4_output_6_10_3(string2142_cgen_prototype, port1695_1310);
			display_2_122___r4_output_6_10_3(aux_1309, port1695_1310);
			display_2_122___r4_output_6_10_3(string2148_cgen_prototype, port1695_1310);
			return
			   WRITE_CHAR(((unsigned char) '\n'), port1695_1310);
		     }
		  }
	       }
	    }
	 }
      }
   }
}



/* set-variable-name! */
obj_t 
set_variable_name__102_cgen_prototype(obj_t variable_48)
{
   AN_OBJECT;
   {	/* Cgen/proto.scm 376 */
      {		/* Cgen/proto.scm 378 */
	 bool_t test_2896;
	 {	/* ./Ieee/string.scm 8047 */
	    obj_t aux_2897;
	    {	/* Cgen/proto.scm 378 */
	       variable_bglt obj_2199;
	       obj_2199 =
		  (variable_bglt) (variable_48);
	       aux_2897 =
		  (((variable_bglt) CREF(obj_2199))->name);
	    }
	    test_2896 =
	       STRINGP(aux_2897);
	 }
	 if (test_2896)
	   {	/* Cgen/proto.scm 378 */
	      variable_bglt obj_2201;
	      obj_2201 =
		 (variable_bglt) (variable_48);
	      return
		 (((variable_bglt) CREF(obj_2201))->name);
	   }
	 else
	   {	/* Cgen/proto.scm 380 */
	      obj_t n_1320;
	      {		/* Cgen/proto.scm 380 */
		 obj_t name_1321;
		 {	/* Cgen/proto.scm 380 */
		    obj_t aux_2903;
		    {	/* Cgen/proto.scm 380 */
		       variable_bglt obj_2202;
		       obj_2202 =
			  (variable_bglt) (variable_48);
		       aux_2903 =
			  (((variable_bglt) CREF(obj_2202))->id);
		    }
		    name_1321 =
		       id__name_228_ast_ident(aux_2903);
		 }
		 {	/* Cgen/proto.scm 382 */
		    bool_t test1903_1322;
		    test1903_1322 =
		       is_a__118___object(variable_48, global_ast_var);
		    if (test1903_1322)
		      {		/* Cgen/proto.scm 382 */
			 {	/* Cgen/proto.scm 401 */
			    obj_t arg1917_2207;
			    {	/* Cgen/proto.scm 401 */
			       obj_t arg1920_2209;
			       {	/* Cgen/proto.scm 401 */
				  obj_t aux_2909;
				  {	/* Cgen/proto.scm 383 */
				     global_bglt obj_2204;
				     obj_2204 =
					(global_bglt) (variable_48);
				     aux_2909 =
					(((global_bglt) CREF(obj_2204))->module);
				  }
				  arg1920_2209 =
				     id__name_228_ast_ident(aux_2909);
			       }
			       arg1917_2207 =
				  string_append(string2161_cgen_prototype, arg1920_2209);
			    }
			    n_1320 =
			       string_append(name_1321, arg1917_2207);
			 }
		      }
		    else
		      {		/* Cgen/proto.scm 385 */
			 bool_t test1904_1324;
			 test1904_1324 =
			    is_a__118___object(variable_48, local_ast_var);
			 if (test1904_1324)
			   {	/* Cgen/proto.scm 385 */
			      {		/* Cgen/proto.scm 386 */
				 obj_t arg1905_1325;
				 {	/* Cgen/proto.scm 386 */
				    obj_t aux_2917;
				    {	/* Cgen/proto.scm 386 */
				       char *aux_2918;
				       {	/* Cgen/proto.scm 389 */
					  long aux_2919;
					  {	/* Cgen/proto.scm 389 */
					     local_bglt obj_2211;
					     obj_2211 =
						(local_bglt) (variable_48);
					     aux_2919 =
						(((local_bglt) CREF(obj_2211))->key);
					  }
					  aux_2918 =
					     integer__string_135___r4_numbers_6_5_fixnum(aux_2919, BNIL);
				       }
				       aux_2917 =
					  string_to_bstring(aux_2918);
				    }
				    arg1905_1325 =
				       string_append(string2161_cgen_prototype, aux_2917);
				 }
				 n_1320 =
				    string_append(name_1321, arg1905_1325);
			      }
			   }
			 else
			   {	/* Cgen/proto.scm 385 */
			      {		/* Cgen/proto.scm 391 */
				 obj_t arg1914_1332;
				 arg1914_1332 =
				    shape_tools_shape(variable_48);
				 n_1320 =
				    internal_error_43_tools_error(string2162_cgen_prototype, string2163_cgen_prototype, arg1914_1332);
			      }
			   }
		      }
		 }
	      }
	      {		/* Cgen/proto.scm 394 */
		 variable_bglt obj_2212;
		 obj_2212 =
		    (variable_bglt) (variable_48);
		 ((((variable_bglt) CREF(obj_2212))->name) = ((obj_t) n_1320), BUNSPEC);
	      }
	      return n_1320;
	   }
      }
   }
}



/* _set-variable-name! */
obj_t 
_set_variable_name__28_cgen_prototype(obj_t env_2361, obj_t variable_2362)
{
   AN_OBJECT;
   {	/* Cgen/proto.scm 376 */
      return
	 set_variable_name__102_cgen_prototype(variable_2362);
   }
}



/* qualified-name */
obj_t 
qualified_name_205_cgen_prototype(obj_t name_49, obj_t module_id_176_50)
{
   AN_OBJECT;
   {	/* Cgen/proto.scm 400 */
      {		/* Cgen/proto.scm 401 */
	 obj_t arg1917_2214;
	 {	/* Cgen/proto.scm 401 */
	    obj_t arg1920_2216;
	    arg1920_2216 =
	       id__name_228_ast_ident(module_id_176_50);
	    arg1917_2214 =
	       string_append(string2161_cgen_prototype, arg1920_2216);
	 }
	 return
	    string_append(name_49, arg1917_2214);
      }
   }
}



/* _qualified-name2134 */
obj_t 
_qualified_name2134_197_cgen_prototype(obj_t env_2363, obj_t name_2364, obj_t module_id_176_2365)
{
   AN_OBJECT;
   {	/* Cgen/proto.scm 400 */
      return
	 qualified_name_205_cgen_prototype(name_2364, module_id_176_2365);
   }
}



/* method-init */
obj_t 
method_init_76_cgen_prototype()
{
   AN_OBJECT;
   {	/* Cgen/proto.scm 14 */
      add_generic__110___object(emit_prototype_env_241_cgen_prototype, emit_prototype_default1699_env_21_cgen_prototype);
      add_inlined_method__244___object(emit_prototype_env_241_cgen_prototype, svar_ast_var, ((long) 0));
      add_inlined_method__244___object(emit_prototype_env_241_cgen_prototype, scnst_ast_var, ((long) 1));
      add_inlined_method__244___object(emit_prototype_env_241_cgen_prototype, sfun_ast_var, ((long) 2));
      add_inlined_method__244___object(emit_prototype_env_241_cgen_prototype, cfun_ast_var, ((long) 3));
      add_inlined_method__244___object(emit_prototype_env_241_cgen_prototype, cvar_ast_var, ((long) 4));
      add_generic__110___object(get_c_scope_env_161_cgen_prototype, get_c_scope_default1710_env_55_cgen_prototype);
      add_inlined_method__244___object(get_c_scope_env_161_cgen_prototype, global_ast_var, ((long) 0));
      {		/* Cgen/proto.scm 14 */
	 long aux_2943;
	 aux_2943 =
	    add_inlined_method__244___object(get_c_scope_env_161_cgen_prototype, local_ast_var, ((long) 1));
	 return
	    BINT(aux_2943);
      }
   }
}



/* emit-prototype */
obj_t 
emit_prototype_23_cgen_prototype(value_bglt value_11, variable_bglt variable_12)
{
   AN_OBJECT;
   {	/* Cgen/proto.scm 81 */
      {
	 obj_t method2082_1903;
	 obj_t class2087_1904;
	 {	/* Cgen/proto.scm 81 */
	    obj_t arg2090_1901;
	    obj_t arg2091_1902;
	    {	/* Cgen/proto.scm 81 */
	       object_bglt obj_2255;
	       obj_2255 =
		  (object_bglt) (value_11);
	       {	/* ./Llib/object.scm 2926 */
		  obj_t pre_method_105_2256;
		  pre_method_105_2256 =
		     PROCEDURE_REF(emit_prototype_env_241_cgen_prototype, ((long) 2));
		  if (
		     INTEGERP(pre_method_105_2256))
		    {	/* ./Llib/object.scm 2927 */
		       PROCEDURE_SET(emit_prototype_env_241_cgen_prototype, ((long) 2), BUNSPEC);
		       arg2090_1901 = pre_method_105_2256;
		    }
		  else
		    {	/* ./Llib/object.scm 2914 */
		       long obj_class_num_177_2261;
		       obj_class_num_177_2261 =
			  TYPE(obj_2255);
		       {	/* ./Llib/object.scm 2915 */
			  obj_t arg1176_2262;
			  arg1176_2262 =
			     PROCEDURE_REF(emit_prototype_env_241_cgen_prototype, ((long) 1));
			  {	/* ./Llib/object.scm 2738 */
			     long arg1177_2266;
			     {	/* ./Llib/object.scm 2738 */
				long arg1178_2267;
				arg1178_2267 =
				   OBJECT_TYPE;
				arg1177_2266 =
				   (obj_class_num_177_2261 - arg1178_2267);
			     }
			     arg2090_1901 =
				VECTOR_REF(arg1176_2262, arg1177_2266);
			  }
		       }
		    }
	       }
	    }
	    {	/* Cgen/proto.scm 81 */
	       object_bglt object_2272;
	       object_2272 =
		  (object_bglt) (value_11);
	       {	/* ./Llib/object.scm 2695 */
		  long arg1179_2273;
		  {	/* ./Llib/object.scm 2695 */
		     long arg1180_2274;
		     long arg1181_2275;
		     arg1180_2274 =
			TYPE(object_2272);
		     arg1181_2275 =
			OBJECT_TYPE;
		     arg1179_2273 =
			(arg1180_2274 - arg1181_2275);
		  }
		  {	/* ./Llib/object.scm 2695 */
		     obj_t vector_2279;
		     vector_2279 = _classes__134___object;
		     arg2091_1902 =
			VECTOR_REF(vector_2279, arg1179_2273);
		  }
	       }
	    }
	    method2082_1903 = arg2090_1901;
	    class2087_1904 = arg2091_1902;
	    {

	       if (
		  INTEGERP(method2082_1903))
		 {	/* Cgen/proto.scm 81 */
		    switch (
		       (long) CINT(method2082_1903))
		      {
		      case ((long) 0):

			 {	/* Cgen/proto.scm 87 */
			    unsigned char aux_2963;
			    {	/* Cgen/proto.scm 87 */
			       obj_t aux_2964;
			       {	/* Cgen/proto.scm 87 */
				  svar_bglt aux_2965;
				  aux_2965 =
				     (svar_bglt) (value_11);
				  aux_2964 =
				     (obj_t) (aux_2965);
			       }
			       aux_2963 =
				  emit_prototype_svar_scnst_27_cgen_prototype(aux_2964, variable_12);
			    }
			    return
			       BCHAR(aux_2963);
			 }
			 break;
		      case ((long) 1):

			 {	/* Cgen/proto.scm 93 */
			    unsigned char aux_2970;
			    {	/* Cgen/proto.scm 93 */
			       obj_t aux_2971;
			       {	/* Cgen/proto.scm 93 */
				  scnst_bglt aux_2972;
				  aux_2972 =
				     (scnst_bglt) (value_11);
				  aux_2971 =
				     (obj_t) (aux_2972);
			       }
			       aux_2970 =
				  emit_prototype_svar_scnst_27_cgen_prototype(aux_2971, variable_12);
			    }
			    return
			       BCHAR(aux_2970);
			 }
			 break;
		      case ((long) 2):

			 {	/* Cgen/proto.scm 123 */
			    sfun_bglt value_1914;
			    value_1914 =
			       (sfun_bglt) (value_11);
			    set_variable_name__102_cgen_prototype(
			       (obj_t) (variable_12));
			    {	/* Cgen/proto.scm 125 */
			       obj_t port1668_1917;
			       port1668_1917 = _c_port__188_cgen_emit;
			       {	/* Cgen/proto.scm 125 */
				  obj_t arg2094_1918;
				  arg2094_1918 =
				     get_c_scope_184_cgen_prototype(variable_12);
				  display_2_122___r4_output_6_10_3(arg2094_1918, port1668_1917);
			       }
			       display_2_122___r4_output_6_10_3(
				  BCHAR(((unsigned char) ' ')), port1668_1917);
			    }
			    {	/* Cgen/proto.scm 126 */
			       obj_t port1669_1919;
			       port1669_1919 = _c_port__188_cgen_emit;
			       {	/* Cgen/proto.scm 126 */
				  obj_t arg2095_1920;
				  arg2095_1920 =
				     make_typed_declaration_180_type_tools(
				     (((variable_bglt) CREF(variable_12))->type),
				     (((variable_bglt) CREF(variable_12))->name));
				  display_2_122___r4_output_6_10_3(arg2095_1920, port1669_1919);
			       }
			    }
			    {	/* Cgen/proto.scm 127 */
			       obj_t args_1923;
			       args_1923 =
				  (((sfun_bglt) CREF(value_1914))->args);
			       {	/* Cgen/proto.scm 128 */
				  bool_t test2099_1924;
				  if (
				     PAIRP(args_1923))
				    {	/* Cgen/proto.scm 128 */
				       test2099_1924 =
					  is_a__118___object(
					  CAR(args_1923), type_type_type);
				    }
				  else
				    {	/* Cgen/proto.scm 128 */
				       test2099_1924 = ((bool_t) 0);
				    }
				  if (test2099_1924)
				    {	/* Cgen/proto.scm 128 */
				       emit_prototype_formal_types_237_cgen_prototype(args_1923);
				    }
				  else
				    {	/* Cgen/proto.scm 128 */
				       emit_prototype_formals_182_cgen_prototype(args_1923);
				    }
			       }
			    }
			    {	/* Cgen/proto.scm 131 */
			       obj_t port1670_1927;
			       port1670_1927 = _c_port__188_cgen_emit;
			       display_2_122___r4_output_6_10_3(
				  BCHAR(((unsigned char) ';')), port1670_1927);
			       {	/* ./Ieee/output.scm 9332 */
				  unsigned char aux_2998;
				  aux_2998 =
				     WRITE_CHAR(((unsigned char) '\n'), port1670_1927);
				  return
				     BCHAR(aux_2998);
			       }
			    }
			 }
			 break;
		      case ((long) 3):

			 {	/* Cgen/proto.scm 168 */
			    cfun_bglt value_1928;
			    value_1928 =
			       (cfun_bglt) (value_11);
			    if (
			       (((cfun_bglt) CREF(value_1928))->macro__33))
			      {		/* Cgen/proto.scm 168 */
				 return BUNSPEC;
			      }
			    else
			      {		/* Cgen/proto.scm 168 */
				 {	/* Cgen/proto.scm 170 */
				    obj_t port1680_1932;
				    port1680_1932 = _c_port__188_cgen_emit;
				    display_2_122___r4_output_6_10_3(string2164_cgen_prototype, port1680_1932);
				 }
				 {	/* Cgen/proto.scm 171 */
				    long arity_1933;
				    arity_1933 =
				       (((cfun_bglt) CREF(value_1928))->arity);
				    {	/* Cgen/proto.scm 171 */
				       obj_t targs_1934;
				       targs_1934 =
					  (((cfun_bglt) CREF(value_1928))->args_type_205);
				       {	/* Cgen/proto.scm 172 */

					  {	/* Cgen/proto.scm 173 */
					     obj_t port1681_1935;
					     port1681_1935 = _c_port__188_cgen_emit;
					     {	/* Cgen/proto.scm 173 */
						obj_t arg2103_1936;
						{	/* Cgen/proto.scm 173 */
						   obj_t aux_3010;
						   type_bglt aux_3007;
						   {	/* Cgen/proto.scm 173 */
						      global_bglt obj_2292;
						      obj_2292 =
							 (global_bglt) (variable_12);
						      aux_3010 =
							 (((global_bglt) CREF(obj_2292))->name);
						   }
						   {	/* Cgen/proto.scm 173 */
						      global_bglt obj_2291;
						      obj_2291 =
							 (global_bglt) (variable_12);
						      aux_3007 =
							 (((global_bglt) CREF(obj_2291))->type);
						   }
						   arg2103_1936 =
						      make_typed_declaration_180_type_tools(aux_3007, aux_3010);
						}
						display_2_122___r4_output_6_10_3(arg2103_1936, port1681_1935);
					     }
					     display_2_122___r4_output_6_10_3(
						BCHAR(((unsigned char) '(')), port1681_1935);
					  }
					  if (
					     NULLP(targs_1934))
					    {	/* Cgen/proto.scm 175 */
					       display_2_122___r4_output_6_10_3(
						  BCHAR(((unsigned char) ')')), _c_port__188_cgen_emit);
					    }
					  else
					    {	/* Cgen/proto.scm 175 */
					       if (
						  (arity_1933 <= ((long) -1)))
						 {	/* Cgen/proto.scm 177 */
						    {	/* Cgen/proto.scm 178 */
						       obj_t port1682_1941;
						       port1682_1941 = _c_port__188_cgen_emit;
						       {	/* Cgen/proto.scm 178 */
							  obj_t arg2108_1942;
							  {	/* Cgen/proto.scm 178 */
							     type_bglt aux_3023;
							     {	/* Cgen/proto.scm 178 */
								obj_t aux_3024;
								aux_3024 =
								   CAR(targs_1934);
								aux_3023 =
								   (type_bglt) (aux_3024);
							     }
							     arg2108_1942 =
								type_name_sans___47_type_tools(aux_3023);
							  }
							  display_2_122___r4_output_6_10_3(arg2108_1942, port1682_1941);
						       }
						       display_2_122___r4_output_6_10_3(string2165_cgen_prototype, port1682_1941);
						    }
						 }
					       else
						 {	/* Cgen/proto.scm 177 */
						    {
						       obj_t targs_1944;
						       targs_1944 = targs_1934;
						     loop_1945:
						       {	/* Cgen/proto.scm 181 */
							  bool_t test_3030;
							  {	/* ./Ieee/pair-list.scm 5912 */
							     obj_t aux_3031;
							     aux_3031 =
								CDR(targs_1944);
							     test_3030 =
								NULLP(aux_3031);
							  }
							  if (test_3030)
							    {	/* Cgen/proto.scm 181 */
							       if (
								  (arity_1933 < ((long) 0)))
								 {	/* Cgen/proto.scm 183 */
								    obj_t port1683_1948;
								    port1683_1948 = _c_port__188_cgen_emit;
								    display_2_122___r4_output_6_10_3(string2166_cgen_prototype, port1683_1948);
								 }
							       else
								 {	/* Cgen/proto.scm 184 */
								    obj_t port1684_1949;
								    port1684_1949 = _c_port__188_cgen_emit;
								    {	/* Cgen/proto.scm 185 */
								       obj_t arg2112_1950;
								       {	/* Cgen/proto.scm 185 */
									  type_bglt aux_3037;
									  {	/* Cgen/proto.scm 185 */
									     obj_t aux_3038;
									     aux_3038 =
										CAR(targs_1944);
									     aux_3037 =
										(type_bglt) (aux_3038);
									  }
									  arg2112_1950 =
									     type_name_sans___47_type_tools(aux_3037);
								       }
								       display_2_122___r4_output_6_10_3(arg2112_1950, port1684_1949);
								    }
								    display_2_122___r4_output_6_10_3(
								       BCHAR(((unsigned char) ')')), port1684_1949);
								 }
							    }
							  else
							    {	/* Cgen/proto.scm 181 */
							       {	/* Cgen/proto.scm 187 */
								  obj_t port1685_1952;
								  port1685_1952 = _c_port__188_cgen_emit;
								  {	/* Cgen/proto.scm 187 */
								     obj_t arg2114_1953;
								     {	/* Cgen/proto.scm 187 */
									type_bglt aux_3045;
									{	/* Cgen/proto.scm 187 */
									   obj_t aux_3046;
									   aux_3046 =
									      CAR(targs_1944);
									   aux_3045 =
									      (type_bglt) (aux_3046);
									}
									arg2114_1953 =
									   type_name_sans___47_type_tools(aux_3045);
								     }
								     display_2_122___r4_output_6_10_3(arg2114_1953, port1685_1952);
								  }
								  display_2_122___r4_output_6_10_3(string2142_cgen_prototype, port1685_1952);
							       }
							       {
								  obj_t targs_3052;
								  targs_3052 =
								     CDR(targs_1944);
								  targs_1944 = targs_3052;
								  goto loop_1945;
							       }
							    }
						       }
						    }
						 }
					    }
					  display_2_122___r4_output_6_10_3(
					     BCHAR(((unsigned char) ';')), _c_port__188_cgen_emit);
					  {	/* Cgen/proto.scm 190 */
					     obj_t port_2304;
					     port_2304 = _c_port__188_cgen_emit;
					     {	/* ./Ieee/output.scm 9332 */
						unsigned char aux_3056;
						aux_3056 =
						   WRITE_CHAR(((unsigned char) '\n'), port_2304);
						return
						   BCHAR(aux_3056);
					     }
					  }
				       }
				    }
				 }
			      }
			 }
			 break;
		      case ((long) 4):

			 {	/* Cgen/proto.scm 196 */
			    cvar_bglt value_1957;
			    value_1957 =
			       (cvar_bglt) (value_11);
			    if (
			       (((cvar_bglt) CREF(value_1957))->macro__33))
			      {		/* Cgen/proto.scm 196 */
				 return BUNSPEC;
			      }
			    else
			      {		/* Cgen/proto.scm 198 */
				 obj_t port1687_1961;
				 port1687_1961 = _c_port__188_cgen_emit;
				 display_2_122___r4_output_6_10_3(string2164_cgen_prototype, port1687_1961);
				 {	/* Cgen/proto.scm 198 */
				    obj_t arg2119_1962;
				    {	/* Cgen/proto.scm 198 */
				       obj_t aux_3066;
				       type_bglt aux_3063;
				       {	/* Cgen/proto.scm 198 */
					  global_bglt obj_2307;
					  obj_2307 =
					     (global_bglt) (variable_12);
					  aux_3066 =
					     (((global_bglt) CREF(obj_2307))->name);
				       }
				       {	/* Cgen/proto.scm 198 */
					  global_bglt obj_2306;
					  obj_2306 =
					     (global_bglt) (variable_12);
					  aux_3063 =
					     (((global_bglt) CREF(obj_2306))->type);
				       }
				       arg2119_1962 =
					  make_typed_declaration_180_type_tools(aux_3063, aux_3066);
				    }
				    display_2_122___r4_output_6_10_3(arg2119_1962, port1687_1961);
				 }
				 display_2_122___r4_output_6_10_3(
				    BCHAR(((unsigned char) ';')), port1687_1961);
				 {	/* ./Ieee/output.scm 9332 */
				    unsigned char aux_3073;
				    aux_3073 =
				       WRITE_CHAR(((unsigned char) '\n'), port1687_1961);
				    return
				       BCHAR(aux_3073);
				 }
			      }
			 }
			 break;
		      default:
		       case_else2088_1907:
			 if (
			    PROCEDUREP(method2082_1903))
			   {	/* Cgen/proto.scm 81 */
			      return
				 PROCEDURE_ENTRY(method2082_1903) (method2082_1903,
				 (obj_t) (value_11),
				 (obj_t) (variable_12), BEOA);
			   }
			 else
			   {	/* Cgen/proto.scm 81 */
			      obj_t fun2056_1869;
			      fun2056_1869 =
				 PROCEDURE_REF(emit_prototype_env_241_cgen_prototype, ((long) 0));
			      return
				 PROCEDURE_ENTRY(fun2056_1869) (fun2056_1869,
				 (obj_t) (value_11),
				 (obj_t) (variable_12), BEOA);
			   }
		      }
		 }
	       else
		 {	/* Cgen/proto.scm 81 */
		    goto case_else2088_1907;
		 }
	    }
	 }
      }
   }
}



/* _emit-prototype2135 */
obj_t 
_emit_prototype2135_165_cgen_prototype(obj_t env_2366, obj_t value_2367, obj_t variable_2368)
{
   AN_OBJECT;
   {	/* Cgen/proto.scm 81 */
      return
	 emit_prototype_23_cgen_prototype(
	 (value_bglt) (value_2367),
	 (variable_bglt) (variable_2368));
   }
}



/* emit-prototype-default1699 */
obj_t 
emit_prototype_default1699_103_cgen_prototype(value_bglt value_13, variable_bglt variable_14)
{
   AN_OBJECT;
   {	/* Cgen/proto.scm 14 */
      FAILURE(
	 CNST_TABLE_REF(((long) 9)), string2167_cgen_prototype,
	 (obj_t) (value_13));
   }
}



/* _emit-prototype-default1699 */
obj_t 
_emit_prototype_default1699_81_cgen_prototype(obj_t env_2369, obj_t value_2370, obj_t variable_2371)
{
   AN_OBJECT;
   {	/* Cgen/proto.scm 14 */
      return
	 emit_prototype_default1699_103_cgen_prototype(
	 (value_bglt) (value_2370),
	 (variable_bglt) (variable_2371));
   }
}



/* get-c-scope */
obj_t 
get_c_scope_184_cgen_prototype(variable_bglt variable_44)
{
   AN_OBJECT;
   {	/* Cgen/proto.scm 350 */
      {
	 obj_t method2058_1874;
	 obj_t class2063_1875;
	 {	/* Cgen/proto.scm 350 */
	    obj_t arg2066_1872;
	    obj_t arg2067_1873;
	    {	/* Cgen/proto.scm 350 */
	       object_bglt obj_2314;
	       obj_2314 =
		  (object_bglt) (variable_44);
	       {	/* ./Llib/object.scm 2926 */
		  obj_t pre_method_105_2315;
		  pre_method_105_2315 =
		     PROCEDURE_REF(get_c_scope_env_161_cgen_prototype, ((long) 2));
		  if (
		     INTEGERP(pre_method_105_2315))
		    {	/* ./Llib/object.scm 2927 */
		       PROCEDURE_SET(get_c_scope_env_161_cgen_prototype, ((long) 2), BUNSPEC);
		       arg2066_1872 = pre_method_105_2315;
		    }
		  else
		    {	/* ./Llib/object.scm 2914 */
		       long obj_class_num_177_2320;
		       obj_class_num_177_2320 =
			  TYPE(obj_2314);
		       {	/* ./Llib/object.scm 2915 */
			  obj_t arg1176_2321;
			  arg1176_2321 =
			     PROCEDURE_REF(get_c_scope_env_161_cgen_prototype, ((long) 1));
			  {	/* ./Llib/object.scm 2738 */
			     long arg1177_2325;
			     {	/* ./Llib/object.scm 2738 */
				long arg1178_2326;
				arg1178_2326 =
				   OBJECT_TYPE;
				arg1177_2325 =
				   (obj_class_num_177_2320 - arg1178_2326);
			     }
			     arg2066_1872 =
				VECTOR_REF(arg1176_2321, arg1177_2325);
			  }
		       }
		    }
	       }
	    }
	    {	/* Cgen/proto.scm 350 */
	       object_bglt object_2331;
	       object_2331 =
		  (object_bglt) (variable_44);
	       {	/* ./Llib/object.scm 2695 */
		  long arg1179_2332;
		  {	/* ./Llib/object.scm 2695 */
		     long arg1180_2333;
		     long arg1181_2334;
		     arg1180_2333 =
			TYPE(object_2331);
		     arg1181_2334 =
			OBJECT_TYPE;
		     arg1179_2332 =
			(arg1180_2333 - arg1181_2334);
		  }
		  {	/* ./Llib/object.scm 2695 */
		     obj_t vector_2338;
		     vector_2338 = _classes__134___object;
		     arg2067_1873 =
			VECTOR_REF(vector_2338, arg1179_2332);
		  }
	       }
	    }
	    method2058_1874 = arg2066_1872;
	    class2063_1875 = arg2067_1873;
	    {

	       if (
		  INTEGERP(method2058_1874))
		 {	/* Cgen/proto.scm 350 */
		    switch (
		       (long) CINT(method2058_1874))
		      {
		      case ((long) 0):

			 {	/* Cgen/proto.scm 356 */
			    global_bglt variable_1881;
			    variable_1881 =
			       (global_bglt) (variable_44);
			    {	/* Cgen/proto.scm 357 */
			       obj_t case_value_58_1883;
			       case_value_58_1883 =
				  (((global_bglt) CREF(variable_1881))->import);
			       {	/* Cgen/proto.scm 357 */
				  bool_t test_3117;
				  {	/* ./Ieee/equiv.scm 5508 */
				     obj_t aux_3118;
				     aux_3118 =
					CNST_TABLE_REF(((long) 0));
				     test_3117 =
					(case_value_58_1883 == aux_3118);
				  }
				  if (test_3117)
				    {	/* Cgen/proto.scm 357 */
				       return string2139_cgen_prototype;
				    }
				  else
				    {	/* Cgen/proto.scm 357 */
				       bool_t test_3121;
				       {	/* ./Ieee/equiv.scm 5508 */
					  obj_t aux_3122;
					  aux_3122 =
					     CNST_TABLE_REF(((long) 8));
					  test_3121 =
					     (case_value_58_1883 == aux_3122);
				       }
				       if (test_3121)
					 {	/* Cgen/proto.scm 357 */
					    return string2168_cgen_prototype;
					 }
				       else
					 {	/* Cgen/proto.scm 357 */
					    bool_t test_3125;
					    {	/* ./Ieee/equiv.scm 5508 */
					       obj_t aux_3126;
					       aux_3126 =
						  CNST_TABLE_REF(((long) 1));
					       test_3125 =
						  (case_value_58_1883 == aux_3126);
					    }
					    if (test_3125)
					      {		/* Cgen/proto.scm 357 */
						 return string2168_cgen_prototype;
					      }
					    else
					      {		/* Cgen/proto.scm 357 */
						 return
						    internal_error_43_tools_error(string2169_cgen_prototype, string2170_cgen_prototype,
						    (((global_bglt) CREF(variable_1881))->import));
					      }
					 }
				    }
			       }
			    }
			 }
			 break;
		      case ((long) 1):

			 return string2139_cgen_prototype;
			 break;
		      default:
		       case_else2064_1878:
			 if (
			    PROCEDUREP(method2058_1874))
			   {	/* Cgen/proto.scm 350 */
			      return
				 PROCEDURE_ENTRY(method2058_1874) (method2058_1874,
				 (obj_t) (variable_44), BEOA);
			   }
			 else
			   {	/* Cgen/proto.scm 350 */
			      obj_t fun2057_1870;
			      fun2057_1870 =
				 PROCEDURE_REF(get_c_scope_env_161_cgen_prototype, ((long) 0));
			      return
				 PROCEDURE_ENTRY(fun2057_1870) (fun2057_1870,
				 (obj_t) (variable_44), BEOA);
			   }
		      }
		 }
	       else
		 {	/* Cgen/proto.scm 350 */
		    goto case_else2064_1878;
		 }
	    }
	 }
      }
   }
}



/* _get-c-scope2136 */
obj_t 
_get_c_scope2136_57_cgen_prototype(obj_t env_2372, obj_t variable_2373)
{
   AN_OBJECT;
   {	/* Cgen/proto.scm 350 */
      return
	 get_c_scope_184_cgen_prototype(
	 (variable_bglt) (variable_2373));
   }
}



/* get-c-scope-default1710 */
obj_t 
get_c_scope_default1710_124_cgen_prototype(variable_bglt variable_45)
{
   AN_OBJECT;
   {	/* Cgen/proto.scm 14 */
      FAILURE(
	 CNST_TABLE_REF(((long) 10)), string2167_cgen_prototype,
	 (obj_t) (variable_45));
   }
}



/* _get-c-scope-default1710 */
obj_t 
_get_c_scope_default1710_101_cgen_prototype(obj_t env_2374, obj_t variable_2375)
{
   AN_OBJECT;
   {	/* Cgen/proto.scm 14 */
      return
	 get_c_scope_default1710_124_cgen_prototype(
	 (variable_bglt) (variable_2375));
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_cgen_prototype()
{
   AN_OBJECT;
   {	/* Cgen/proto.scm 14 */
      module_initialization_70_tools_error(((long) 0), "CGEN_PROTOTYPE");
      module_initialization_70_tools_shape(((long) 0), "CGEN_PROTOTYPE");
      module_initialization_70_engine_param(((long) 0), "CGEN_PROTOTYPE");
      module_initialization_70_module_module(((long) 0), "CGEN_PROTOTYPE");
      module_initialization_70_type_type(((long) 0), "CGEN_PROTOTYPE");
      module_initialization_70_type_cache(((long) 0), "CGEN_PROTOTYPE");
      module_initialization_70_type_tools(((long) 0), "CGEN_PROTOTYPE");
      module_initialization_70_type_env(((long) 0), "CGEN_PROTOTYPE");
      module_initialization_70_ast_var(((long) 0), "CGEN_PROTOTYPE");
      module_initialization_70_ast_node(((long) 0), "CGEN_PROTOTYPE");
      module_initialization_70_ast_env(((long) 0), "CGEN_PROTOTYPE");
      module_initialization_70_ast_ident(((long) 0), "CGEN_PROTOTYPE");
      module_initialization_70_tvector_tvector(((long) 0), "CGEN_PROTOTYPE");
      module_initialization_70_tvector_cnst(((long) 0), "CGEN_PROTOTYPE");
      module_initialization_70_cnst_alloc(((long) 0), "CGEN_PROTOTYPE");
      module_initialization_70_cgen_cop(((long) 0), "CGEN_PROTOTYPE");
      module_initialization_70_cgen_emit(((long) 0), "CGEN_PROTOTYPE");
      return
	 module_initialization_70_cgen_emit_cop_239(((long) 0), "CGEN_PROTOTYPE");
   }
}
