/*===========================================================================*/
/*   (Cgen/walk.scm)                                                         */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct ccomp
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t producer;
     obj_t consumer;
     obj_t finalizer;
     obj_t checksummer;
  }
     *ccomp_bglt;

typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;

typedef struct tclass
  {
     obj_t its_super_214;
     obj_t slots;
     struct global *holder;
     obj_t widening;
     long depth;
     bool_t final__12;
     obj_t constructor;
     obj_t virtual_slots_number_200;
  }
      *tclass_bglt;

typedef struct cop
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
   *cop_bglt;

typedef struct clabel
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     obj_t name;
     bool_t used__226;
     obj_t body;
  }
      *clabel_bglt;

typedef struct cgoto
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct clabel *label;
  }
     *cgoto_bglt;

typedef struct block
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *body;
  }
     *block_bglt;

typedef struct creturn
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *value;
  }
       *creturn_bglt;

typedef struct cvoid
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *value;
  }
     *cvoid_bglt;

typedef struct catom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     obj_t value;
  }
     *catom_bglt;

typedef struct varc
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct variable *variable;
  }
    *varc_bglt;

typedef struct cpragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     obj_t format;
     obj_t args;
  }
       *cpragma_bglt;

typedef struct ccast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct cop *arg;
  }
     *ccast_bglt;

typedef struct csequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     bool_t c_exp__163;
     obj_t cops;
  }
         *csequence_bglt;

typedef struct nop
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
   *nop_bglt;

typedef struct stop
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *value;
  }
    *stop_bglt;

typedef struct csetq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct varc *var;
     struct cop *value;
  }
     *csetq_bglt;

typedef struct cif
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *test;
     struct cop *true;
     struct cop *false;
  }
   *cif_bglt;

typedef struct local_var_164
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     obj_t vars;
  }
             *local_var_164_bglt;

typedef struct cfuncall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *fun;
     obj_t args;
     obj_t strength;
  }
        *cfuncall_bglt;

typedef struct capply
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *fun;
     struct cop *arg;
  }
      *capply_bglt;

typedef struct capp
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *fun;
     obj_t args;
  }
    *capp_bglt;

typedef struct cfail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *proc;
     struct cop *msg;
     struct cop *obj;
  }
     *cfail_bglt;

typedef struct cswitch
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *test;
     obj_t clauses;
  }
       *cswitch_bglt;

typedef struct cmake_box_177
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *value;
  }
             *cmake_box_177_bglt;

typedef struct cbox_ref_44
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *var;
  }
           *cbox_ref_44_bglt;

typedef struct cbox_set__132
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *var;
     struct cop *value;
  }
             *cbox_set__132_bglt;

typedef struct cset_ex_it_123
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *exit;
     struct cop *jump_value_221;
     struct cop *body;
  }
              *cset_ex_it_123_bglt;

typedef struct cjump_ex_it_131
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *exit;
     struct cop *value;
  }
               *cjump_ex_it_131_bglt;

typedef struct sfun_c_188
  {
     struct clabel *label;
     bool_t integrated;
  }
          *sfun_c_188_bglt;

typedef struct bdb_block_21
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *body;
  }
            *bdb_block_21_bglt;


static obj_t method_init_76_cgen_walk();
extern obj_t _nb_error_on_pass__70_tools_error;
static obj_t _cgen_walk_165_cgen_walk(obj_t, obj_t);
extern obj_t _c_port__188_cgen_emit;
extern obj_t _bdb_debug__1_engine_param;
extern obj_t stop_emission__231_cgen_emit();
extern obj_t verbose_tools_speek(obj_t, obj_t);
extern obj_t module_initialization_70_cgen_walk(long, char *);
extern obj_t module_initialization_70_tools_speek(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_engine_pass(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_module_module(long, char *);
extern obj_t module_initialization_70_module_library(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_ast_occur(long, char *);
extern obj_t module_initialization_70_ast_build(long, char *);
extern obj_t module_initialization_70_object_class(long, char *);
extern obj_t module_initialization_70_bdb_emit(long, char *);
extern obj_t module_initialization_70_prof_emit(long, char *);
extern obj_t module_initialization_70_cgen_cop(long, char *);
extern obj_t module_initialization_70_cgen_emit(long, char *);
extern obj_t module_initialization_70_cgen_prototype(long, char *);
extern obj_t module_initialization_70_cgen_main(long, char *);
extern obj_t module_initialization_70_cgen_init(long, char *);
extern obj_t module_initialization_70_cgen_cgen(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t make_bigloo_main_85_cgen_main();
extern obj_t emit_garbage_collector_selection_89_cgen_emit();
extern obj_t emit_prototypes_82_cgen_prototype();
extern obj_t emit_prof_info_80_prof_emit(obj_t, obj_t);
static obj_t imported_modules_init_94_cgen_walk();
extern obj_t emit_header_99_cgen_emit();
extern obj_t emit_bdb_info_67_bdb_emit(obj_t, obj_t);
extern obj_t cgen_cgen_cgen(global_bglt);
extern obj_t append_2_18___r4_pairs_and_lists_6_3(obj_t, obj_t);
static obj_t library_modules_init_112_cgen_walk();
extern obj_t start_emission__101_cgen_emit(obj_t);
extern obj_t library_finalizer_97_module_library();
extern obj_t emit_include_217_cgen_emit();
extern obj_t occur_node_in__115_ast_occur(node_bglt, global_bglt);
static obj_t toplevel_init_63_cgen_walk();
extern obj_t open_input_string(obj_t);
extern obj_t make_module_init_70_cgen_init();
extern obj_t cgen_walk_174_cgen_walk(obj_t);
extern obj_t emit_cnsts_221_cgen_prototype();
extern obj_t memq___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern obj_t _compiler_debug__134_engine_param;
extern obj_t internal_error_43_tools_error(obj_t, obj_t, obj_t);
extern obj_t build_ast_sans_remove_93_ast_build(obj_t);
extern obj_t emit_main_179_cgen_emit();
extern obj_t emit_debug_activation_148_cgen_emit();
extern obj_t read___reader(obj_t);
extern obj_t _profile_mode__105_engine_param;
extern obj_t _c_debug__136_engine_param;
extern obj_t emit_class_types_26_object_class(obj_t);
static obj_t require_initialization_114_cgen_walk = BUNSPEC;
static obj_t _anonymous_1696__100_cgen_walk(obj_t);
extern obj_t _pass__125_engine_param;
extern obj_t _main__152_module_module;
static obj_t cnst_init_137_cgen_walk();
extern obj_t _current_pass__25_engine_pass;
static obj_t __cnst[5];

DEFINE_EXPORT_PROCEDURE(cgen_walk_env_156_cgen_walk, _cgen_walk_165_cgen_walk1880, _cgen_walk_165_cgen_walk, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc1873_cgen_walk, _anonymous_1696__100_cgen_walk1881, _anonymous_1696__100_cgen_walk, 0L, 0);
DEFINE_STRING(string1875_cgen_walk, string1875_cgen_walk1882, "IMPORTED (LD DISTRIB) UNIT ((LAMBDA () (START-EMISSION! \".c\"))) PASS-STARTED ", 77);
DEFINE_STRING(string1874_cgen_walk, string1874_cgen_walk1883, ".c", 2);
DEFINE_STRING(string1872_cgen_walk, string1872_cgen_walk1884, "failure during prelude hook", 27);
DEFINE_STRING(string1871_cgen_walk, string1871_cgen_walk1885, "   . ", 5);
DEFINE_STRING(string1870_cgen_walk, string1870_cgen_walk1886, "C generation", 12);



/* module-initialization */
obj_t 
module_initialization_70_cgen_walk(long checksum_1808, char *from_1809)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_cgen_walk))
	{
	   require_initialization_114_cgen_walk =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_cgen_walk();
	   cnst_init_137_cgen_walk();
	   imported_modules_init_94_cgen_walk();
	   method_init_76_cgen_walk();
	   toplevel_init_63_cgen_walk();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_cgen_walk()
{
   AN_OBJECT;
   {	/* Cgen/walk.scm 14 */
      module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "CGEN_WALK");
      module_initialization_70___reader(((long) 0), "CGEN_WALK");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_cgen_walk()
{
   AN_OBJECT;
   {	/* Cgen/walk.scm 14 */
      {		/* Cgen/walk.scm 14 */
	 obj_t cnst_port_138_1801;
	 cnst_port_138_1801 =
	    open_input_string(string1875_cgen_walk);
	 {
	    long i_1802;
	    i_1802 = ((long) 4);
	  loop_1803:
	    {	/* Cgen/walk.scm 14 */
	       bool_t test1876_1804;
	       test1876_1804 =
		  (i_1802 == ((long) -1));
	       if (test1876_1804)
		 {	/* Cgen/walk.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Cgen/walk.scm 14 */
		    {	/* Cgen/walk.scm 14 */
		       obj_t arg1877_1805;
		       {	/* Cgen/walk.scm 14 */
			  obj_t list1878_1806;
			  list1878_1806 =
			     MAKE_PAIR(cnst_port_138_1801, BNIL);
			  arg1877_1805 =
			     read___reader(list1878_1806);
		       }
		       CNST_TABLE_SET(i_1802, arg1877_1805);
		    }
		    {	/* Cgen/walk.scm 14 */
		       int aux_1807;
		       {	/* Cgen/walk.scm 14 */
			  long aux_1826;
			  aux_1826 =
			     (i_1802 - ((long) 1));
			  aux_1807 =
			     (int) (aux_1826);
		       }
		       {
			  long i_1829;
			  i_1829 =
			     (long) (aux_1807);
			  i_1802 = i_1829;
			  goto loop_1803;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_cgen_walk()
{
   AN_OBJECT;
   {	/* Cgen/walk.scm 14 */
      return BUNSPEC;
   }
}



/* cgen-walk */
obj_t 
cgen_walk_174_cgen_walk(obj_t globals_19)
{
   AN_OBJECT;
   {	/* Cgen/walk.scm 42 */
      {		/* Cgen/walk.scm 42 */
	 obj_t list1687_1101;
	 {	/* Cgen/walk.scm 42 */
	    obj_t arg1689_1103;
	    {	/* Cgen/walk.scm 42 */
	       obj_t arg1691_1105;
	       {	/* Cgen/walk.scm 42 */
		  obj_t aux_1831;
		  aux_1831 =
		     BCHAR(((unsigned char) '\n'));
		  arg1691_1105 =
		     MAKE_PAIR(aux_1831, BNIL);
	       }
	       arg1689_1103 =
		  MAKE_PAIR(string1870_cgen_walk, arg1691_1105);
	    }
	    list1687_1101 =
	       MAKE_PAIR(string1871_cgen_walk, arg1689_1103);
	 }
	 verbose_tools_speek(
	    BINT(((long) 1)), list1687_1101);
      }
      _nb_error_on_pass__70_tools_error =
	 BINT(((long) 0));
      _current_pass__25_engine_pass = string1870_cgen_walk;
      {
	 obj_t hooks_1106;
	 obj_t hnames_1107;
	 {	/* Cgen/walk.scm 43 */
	    obj_t arg1692_1109;
	    obj_t arg1693_1110;
	    {	/* Cgen/walk.scm 43 */
	       obj_t _anonymous_1696__100_1796;
	       _anonymous_1696__100_1796 = proc1873_cgen_walk;
	       {	/* Cgen/walk.scm 42 */
		  obj_t list1695_1112;
		  list1695_1112 =
		     MAKE_PAIR(_anonymous_1696__100_1796, BNIL);
		  arg1692_1109 = list1695_1112;
	       }
	    }
	    arg1693_1110 =
	       CNST_TABLE_REF(((long) 1));
	    hooks_1106 = arg1692_1109;
	    hnames_1107 = arg1693_1110;
	  loop_1108:
	    if (
	       NULLP(hooks_1106))
	      {		/* Cgen/walk.scm 42 */
		 CNST_TABLE_REF(((long) 0));
	      }
	    else
	      {		/* Cgen/walk.scm 42 */
		 bool_t test1698_1116;
		 {	/* Cgen/walk.scm 42 */
		    obj_t fun1704_1122;
		    fun1704_1122 =
		       CAR(hooks_1106);
		    {	/* Cgen/walk.scm 42 */
		       obj_t aux_1845;
		       aux_1845 =
			  PROCEDURE_ENTRY(fun1704_1122) (fun1704_1122, BEOA);
		       test1698_1116 =
			  CBOOL(aux_1845);
		    }
		 }
		 if (test1698_1116)
		   {	/* Cgen/walk.scm 42 */
		      {
			 obj_t hnames_1852;
			 obj_t hooks_1850;
			 hooks_1850 =
			    CDR(hooks_1106);
			 hnames_1852 =
			    CDR(hnames_1107);
			 hnames_1107 = hnames_1852;
			 hooks_1106 = hooks_1850;
			 goto loop_1108;
		      }
		   }
		 else
		   {	/* Cgen/walk.scm 42 */
		      internal_error_43_tools_error(string1870_cgen_walk, string1872_cgen_walk,
			 CAR(hnames_1107));
		   }
	      }
	 }
      }
      {		/* Cgen/walk.scm 47 */
	 obj_t lib_unit_138_1123;
	 lib_unit_138_1123 =
	    library_finalizer_97_module_library();
	 {	/* Cgen/walk.scm 47 */
	    obj_t lib_init_12_1124;
	    {	/* Cgen/walk.scm 48 */
	       bool_t test_1857;
	       if (
		  STRUCTP(lib_unit_138_1123))
		 {	/* ./Ieee/equiv.scm 5508 */
		    obj_t aux_1862;
		    obj_t aux_1860;
		    aux_1862 =
		       CNST_TABLE_REF(((long) 2));
		    aux_1860 =
		       STRUCT_KEY(lib_unit_138_1123);
		    test_1857 =
		       (aux_1860 == aux_1862);
		 }
	       else
		 {	/* ./Ast/unit.sch 421 */
		    test_1857 = ((bool_t) 0)
		       ;
		 }
	       if (test_1857)
		 {	/* Cgen/walk.scm 49 */
		    obj_t vars_1146;
		    {	/* Cgen/walk.scm 49 */
		       obj_t arg1727_1154;
		       {	/* Cgen/walk.scm 49 */
			  obj_t list1728_1155;
			  list1728_1155 =
			     MAKE_PAIR(lib_unit_138_1123, BNIL);
			  arg1727_1154 = list1728_1155;
		       }
		       vars_1146 =
			  build_ast_sans_remove_93_ast_build(arg1727_1154);
		    }
		    {
		       obj_t l1674_1147;
		       l1674_1147 = vars_1146;
		     lname1675_1148:
		       if (
			  PAIRP(l1674_1147))
			 {	/* Cgen/walk.scm 50 */
			    {	/* Cgen/walk.scm 51 */
			       obj_t g_1150;
			       g_1150 =
				  CAR(l1674_1147);
			       {	/* Cgen/walk.scm 51 */
				  node_bglt aux_1870;
				  {	/* Cgen/walk.scm 51 */
				     obj_t aux_1871;
				     {	/* Cgen/walk.scm 52 */
					sfun_bglt obj_1732;
					{	/* Cgen/walk.scm 52 */
					   value_bglt aux_1872;
					   {	/* Cgen/walk.scm 52 */
					      global_bglt obj_1731;
					      obj_1731 =
						 (global_bglt) (g_1150);
					      aux_1872 =
						 (((global_bglt) CREF(obj_1731))->value);
					   }
					   obj_1732 =
					      (sfun_bglt) (aux_1872);
					}
					aux_1871 =
					   (((sfun_bglt) CREF(obj_1732))->body);
				     }
				     aux_1870 =
					(node_bglt) (aux_1871);
				  }
				  occur_node_in__115_ast_occur(aux_1870,
				     (global_bglt) (g_1150));
			       }
			    }
			    {
			       obj_t l1674_1880;
			       l1674_1880 =
				  CDR(l1674_1147);
			       l1674_1147 = l1674_1880;
			       goto lname1675_1148;
			    }
			 }
		       else
			 {	/* Cgen/walk.scm 50 */
			    ((bool_t) 1);
			 }
		    }
		    lib_init_12_1124 = vars_1146;
		 }
	       else
		 {	/* Cgen/walk.scm 48 */
		    lib_init_12_1124 = BNIL;
		 }
	    }
	    {	/* Cgen/walk.scm 48 */
	       obj_t globals_1125;
	       {	/* Cgen/walk.scm 57 */
		  obj_t arg1715_1138;
		  obj_t arg1716_1139;
		  arg1715_1138 =
		     make_module_init_70_cgen_init();
		  {	/* Cgen/walk.scm 58 */
		     bool_t test1717_1140;
		     {	/* Cgen/walk.scm 58 */
			bool_t test1720_1143;
			if (
			   CBOOL(_main__152_module_module))
			  {	/* Cgen/walk.scm 58 */
			     test1720_1143 = ((bool_t) 1);
			  }
			else
			  {	/* Cgen/walk.scm 58 */
			     obj_t aux_1885;
			     aux_1885 =
				memq___r4_pairs_and_lists_6_3(_pass__125_engine_param,
				CNST_TABLE_REF(((long) 3)));
			     test1720_1143 =
				CBOOL(aux_1885);
			  }
			if (test1720_1143)
			  {	/* Cgen/walk.scm 59 */
			     bool_t test1721_1144;
			     {	/* Cgen/walk.scm 59 */
				obj_t obj1_1734;
				obj1_1734 = _main__152_module_module;
				{	/* ./Ieee/equiv.scm 5508 */
				   obj_t aux_1890;
				   aux_1890 =
				      CNST_TABLE_REF(((long) 4));
				   test1721_1144 =
				      (obj1_1734 == aux_1890);
				}
			     }
			     if (test1721_1144)
			       {	/* Cgen/walk.scm 59 */
				  test1717_1140 = ((bool_t) 0);
			       }
			     else
			       {	/* Cgen/walk.scm 59 */
				  test1717_1140 = ((bool_t) 1);
			       }
			  }
			else
			  {	/* Cgen/walk.scm 58 */
			     test1717_1140 = ((bool_t) 0);
			  }
		     }
		     if (test1717_1140)
		       {	/* Cgen/walk.scm 60 */
			  obj_t arg1718_1141;
			  obj_t arg1719_1142;
			  arg1718_1141 =
			     make_bigloo_main_85_cgen_main();
			  arg1719_1142 =
			     append_2_18___r4_pairs_and_lists_6_3(lib_init_12_1124, globals_19);
			  arg1716_1139 =
			     MAKE_PAIR(arg1718_1141, arg1719_1142);
		       }
		     else
		       {	/* Cgen/walk.scm 58 */
			  arg1716_1139 =
			     append_2_18___r4_pairs_and_lists_6_3(lib_init_12_1124, globals_19);
		       }
		  }
		  globals_1125 =
		     MAKE_PAIR(arg1715_1138, arg1716_1139);
	       }
	       {	/* Cgen/walk.scm 57 */

		  emit_header_99_cgen_emit();
		  emit_garbage_collector_selection_89_cgen_emit();
		  {	/* Cgen/walk.scm 71 */
		     bool_t test1705_1126;
		     {	/* Cgen/walk.scm 71 */
			bool_t test1706_1127;
			{	/* Cgen/walk.scm 71 */
			   long n1_1740;
			   n1_1740 =
			      (long) CINT(_compiler_debug__134_engine_param);
			   test1706_1127 =
			      (n1_1740 > ((long) 0));
			}
			if (test1706_1127)
			  {	/* Cgen/walk.scm 71 */
			     test1705_1126 = ((bool_t) 1);
			  }
			else
			  {	/* Cgen/walk.scm 71 */
			     test1705_1126 =
				CBOOL(_c_debug__136_engine_param);
			  }
		     }
		     if (test1705_1126)
		       {	/* Cgen/walk.scm 71 */
			  emit_debug_activation_148_cgen_emit();
		       }
		     else
		       {	/* Cgen/walk.scm 71 */
			  BUNSPEC;
		       }
		  }
		  emit_include_217_cgen_emit();
		  emit_class_types_26_object_class(_c_port__188_cgen_emit);
		  emit_prototypes_82_cgen_prototype();
		  emit_cnsts_221_cgen_prototype();
		  {	/* Cgen/walk.scm 89 */
		     bool_t test1707_1128;
		     {	/* Cgen/walk.scm 89 */
			long n1_1742;
			n1_1742 =
			   (long) CINT(_bdb_debug__1_engine_param);
			test1707_1128 =
			   (n1_1742 > ((long) 0));
		     }
		     if (test1707_1128)
		       {	/* Cgen/walk.scm 89 */
			  emit_bdb_info_67_bdb_emit(globals_1125, _c_port__188_cgen_emit);
		       }
		     else
		       {	/* Cgen/walk.scm 89 */
			  BUNSPEC;
		       }
		  }
		  {	/* Cgen/walk.scm 93 */
		     bool_t test1708_1129;
		     {	/* Cgen/walk.scm 93 */
			long n1_1744;
			n1_1744 =
			   (long) CINT(_profile_mode__105_engine_param);
			test1708_1129 =
			   (n1_1744 > ((long) 0));
		     }
		     if (test1708_1129)
		       {	/* Cgen/walk.scm 93 */
			  emit_prof_info_80_prof_emit(globals_1125, _c_port__188_cgen_emit);
		       }
		     else
		       {	/* Cgen/walk.scm 93 */
			  BUNSPEC;
		       }
		  }
		  {	/* Cgen/walk.scm 97 */
		     bool_t test1709_1130;
		     {	/* Cgen/walk.scm 97 */
			bool_t test1710_1131;
			if (
			   CBOOL(_main__152_module_module))
			  {	/* Cgen/walk.scm 97 */
			     test1710_1131 = ((bool_t) 1);
			  }
			else
			  {	/* Cgen/walk.scm 97 */
			     obj_t aux_1922;
			     aux_1922 =
				memq___r4_pairs_and_lists_6_3(_pass__125_engine_param,
				CNST_TABLE_REF(((long) 3)));
			     test1710_1131 =
				CBOOL(aux_1922);
			  }
			if (test1710_1131)
			  {	/* Cgen/walk.scm 98 */
			     bool_t test1711_1132;
			     {	/* Cgen/walk.scm 98 */
				obj_t obj1_1746;
				obj1_1746 = _main__152_module_module;
				{	/* ./Ieee/equiv.scm 5508 */
				   obj_t aux_1927;
				   aux_1927 =
				      CNST_TABLE_REF(((long) 4));
				   test1711_1132 =
				      (obj1_1746 == aux_1927);
				}
			     }
			     if (test1711_1132)
			       {	/* Cgen/walk.scm 98 */
				  test1709_1130 = ((bool_t) 0);
			       }
			     else
			       {	/* Cgen/walk.scm 98 */
				  test1709_1130 = ((bool_t) 1);
			       }
			  }
			else
			  {	/* Cgen/walk.scm 97 */
			     test1709_1130 = ((bool_t) 0);
			  }
		     }
		     if (test1709_1130)
		       {	/* Cgen/walk.scm 97 */
			  emit_main_179_cgen_emit();
		       }
		     else
		       {	/* Cgen/walk.scm 97 */
			  BUNSPEC;
		       }
		  }
		  {
		     obj_t l1676_1133;
		     l1676_1133 = globals_1125;
		   lname1677_1134:
		     if (
			PAIRP(l1676_1133))
		       {	/* Cgen/walk.scm 102 */
			  {	/* Cgen/walk.scm 102 */
			     global_bglt aux_1935;
			     {	/* Cgen/walk.scm 102 */
				obj_t aux_1936;
				aux_1936 =
				   CAR(l1676_1133);
				aux_1935 =
				   (global_bglt) (aux_1936);
			     }
			     cgen_cgen_cgen(aux_1935);
			  }
			  {
			     obj_t l1676_1940;
			     l1676_1940 =
				CDR(l1676_1133);
			     l1676_1133 = l1676_1940;
			     goto lname1677_1134;
			  }
		       }
		     else
		       {	/* Cgen/walk.scm 102 */
			  ((bool_t) 1);
		       }
		  }
		  return
		     stop_emission__231_cgen_emit();
	       }
	    }
	 }
      }
   }
}



/* _cgen-walk */
obj_t 
_cgen_walk_165_cgen_walk(obj_t env_1797, obj_t globals_1798)
{
   AN_OBJECT;
   {	/* Cgen/walk.scm 42 */
      return
	 cgen_walk_174_cgen_walk(globals_1798);
   }
}



/* <anonymous:1696> */
obj_t 
_anonymous_1696__100_cgen_walk(obj_t env_1799)
{
   AN_OBJECT;
   {	/* Cgen/walk.scm 43 */
      {

	 return
	    start_emission__101_cgen_emit(string1874_cgen_walk);
      }
   }
}



/* method-init */
obj_t 
method_init_76_cgen_walk()
{
   AN_OBJECT;
   {	/* Cgen/walk.scm 14 */
      return BUNSPEC;
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_cgen_walk()
{
   AN_OBJECT;
   {	/* Cgen/walk.scm 14 */
      module_initialization_70_tools_speek(((long) 0), "CGEN_WALK");
      module_initialization_70_tools_error(((long) 0), "CGEN_WALK");
      module_initialization_70_engine_pass(((long) 0), "CGEN_WALK");
      module_initialization_70_tools_trace(((long) 0), "CGEN_WALK");
      module_initialization_70_tools_shape(((long) 0), "CGEN_WALK");
      module_initialization_70_engine_param(((long) 0), "CGEN_WALK");
      module_initialization_70_module_module(((long) 0), "CGEN_WALK");
      module_initialization_70_module_library(((long) 0), "CGEN_WALK");
      module_initialization_70_type_type(((long) 0), "CGEN_WALK");
      module_initialization_70_ast_var(((long) 0), "CGEN_WALK");
      module_initialization_70_ast_node(((long) 0), "CGEN_WALK");
      module_initialization_70_ast_occur(((long) 0), "CGEN_WALK");
      module_initialization_70_ast_build(((long) 0), "CGEN_WALK");
      module_initialization_70_object_class(((long) 0), "CGEN_WALK");
      module_initialization_70_bdb_emit(((long) 0), "CGEN_WALK");
      module_initialization_70_prof_emit(((long) 0), "CGEN_WALK");
      module_initialization_70_cgen_cop(((long) 0), "CGEN_WALK");
      module_initialization_70_cgen_emit(((long) 0), "CGEN_WALK");
      module_initialization_70_cgen_prototype(((long) 0), "CGEN_WALK");
      module_initialization_70_cgen_main(((long) 0), "CGEN_WALK");
      module_initialization_70_cgen_init(((long) 0), "CGEN_WALK");
      return
	 module_initialization_70_cgen_cgen(((long) 0), "CGEN_WALK");
   }
}
