/*===========================================================================*/
/*   (Cnst/cache.scm)                                                        */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;


extern obj_t find_global_223_ast_env(obj_t, obj_t);
static obj_t method_init_76_cnst_cache();
extern obj_t find_global_module_25_ast_env(obj_t, obj_t);
obj_t _vector_tag_set___225_cnst_cache = BUNSPEC;
obj_t _bfalse__69_cnst_cache = BUNSPEC;
obj_t _string__bstring__114_cnst_cache = BUNSPEC;
obj_t _make_fx_procedure__51_cnst_cache = BUNSPEC;
obj_t _btrue__29_cnst_cache = BUNSPEC;
extern obj_t module_initialization_70_cnst_cache(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_env(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
obj_t _double__real__21_cnst_cache = BUNSPEC;
obj_t _cons__148_cnst_cache = BUNSPEC;
static obj_t imported_modules_init_94_cnst_cache();
static obj_t _stop_cnst_cache__214_cnst_cache(obj_t);
static obj_t library_modules_init_112_cnst_cache();
obj_t _string__symbol__115_cnst_cache = BUNSPEC;
obj_t _list__vector__161_cnst_cache = BUNSPEC;
static obj_t toplevel_init_63_cnst_cache();
extern obj_t stop_cnst_cache__90_cnst_cache();
static obj_t _start_cnst_cache__252_cnst_cache(obj_t);
extern obj_t open_input_string(obj_t);
obj_t _cnst_table_ref__15_cnst_cache = BUNSPEC;
extern obj_t start_cnst_cache__172_cnst_cache();
obj_t _string__keyword__251_cnst_cache = BUNSPEC;
obj_t _bool__bbool__85_cnst_cache = BUNSPEC;
obj_t _cnst_table_set___16_cnst_cache = BUNSPEC;
obj_t _make_va_procedure__53_cnst_cache = BUNSPEC;
extern obj_t read___reader(obj_t);
static bool_t _cache_started___32_cnst_cache;
static obj_t require_initialization_114_cnst_cache = BUNSPEC;
static obj_t cnst_init_137_cnst_cache();
static obj_t __cnst[15];

DEFINE_EXPORT_PROCEDURE(start_cnst_cache__env_224_cnst_cache, _start_cnst_cache__252_cnst_cache1229, _start_cnst_cache__252_cnst_cache, 0L, 0);
DEFINE_EXPORT_PROCEDURE(stop_cnst_cache__env_237_cnst_cache, _stop_cnst_cache__214_cnst_cache1230, _stop_cnst_cache__214_cnst_cache, 0L, 0);
DEFINE_STRING(string1223_cnst_cache, string1223_cnst_cache1231, "VECTOR-TAG-SET! LIST->VECTOR DOUBLE->REAL MAKE-VA-PROCEDURE MAKE-FX-PROCEDURE BOOL->BBOOL C-STRING->KEYWORD C-STRING->SYMBOL STRING->BSTRING BFALSE BTRUE C-CONS CNST-TABLE-SET! FOREIGN CNST-TABLE-REF ", 200);



/* module-initialization */
obj_t 
module_initialization_70_cnst_cache(long checksum_444, char *from_445)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_cnst_cache))
	{
	   require_initialization_114_cnst_cache =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_cnst_cache();
	   cnst_init_137_cnst_cache();
	   imported_modules_init_94_cnst_cache();
	   method_init_76_cnst_cache();
	   toplevel_init_63_cnst_cache();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_cnst_cache()
{
   AN_OBJECT;
   {	/* Cnst/cache.scm 14 */
      module_initialization_70___reader(((long) 0), "CNST_CACHE");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_cnst_cache()
{
   AN_OBJECT;
   {	/* Cnst/cache.scm 14 */
      {		/* Cnst/cache.scm 14 */
	 obj_t cnst_port_138_437;
	 cnst_port_138_437 =
	    open_input_string(string1223_cnst_cache);
	 {
	    long i_438;
	    i_438 = ((long) 14);
	  loop_439:
	    {	/* Cnst/cache.scm 14 */
	       bool_t test1224_440;
	       test1224_440 =
		  (i_438 == ((long) -1));
	       if (test1224_440)
		 {	/* Cnst/cache.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Cnst/cache.scm 14 */
		    {	/* Cnst/cache.scm 14 */
		       obj_t arg1226_441;
		       {	/* Cnst/cache.scm 14 */
			  obj_t list1227_442;
			  list1227_442 =
			     MAKE_PAIR(cnst_port_138_437, BNIL);
			  arg1226_441 =
			     read___reader(list1227_442);
		       }
		       CNST_TABLE_SET(i_438, arg1226_441);
		    }
		    {	/* Cnst/cache.scm 14 */
		       int aux_443;
		       {	/* Cnst/cache.scm 14 */
			  long aux_461;
			  aux_461 =
			     (i_438 - ((long) 1));
			  aux_443 =
			     (int) (aux_461);
		       }
		       {
			  long i_464;
			  i_464 =
			     (long) (aux_443);
			  i_438 = i_464;
			  goto loop_439;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_cnst_cache()
{
   AN_OBJECT;
   {	/* Cnst/cache.scm 14 */
      _cache_started___32_cnst_cache = ((bool_t) 0);
      _cnst_table_ref__15_cnst_cache = BFALSE;
      _cnst_table_set___16_cnst_cache = BFALSE;
      _cons__148_cnst_cache = BFALSE;
      _btrue__29_cnst_cache = BFALSE;
      _bfalse__69_cnst_cache = BFALSE;
      _string__bstring__114_cnst_cache = BFALSE;
      _string__symbol__115_cnst_cache = BFALSE;
      _string__keyword__251_cnst_cache = BFALSE;
      _bool__bbool__85_cnst_cache = BFALSE;
      _make_fx_procedure__51_cnst_cache = BFALSE;
      _make_va_procedure__53_cnst_cache = BFALSE;
      _double__real__21_cnst_cache = BFALSE;
      _list__vector__161_cnst_cache = BFALSE;
      return (
	 _vector_tag_set___225_cnst_cache = BFALSE, BUNSPEC);
   }
}



/* start-cnst-cache! */
obj_t 
start_cnst_cache__172_cnst_cache()
{
   AN_OBJECT;
   {	/* Cnst/cache.scm 59 */
      if (_cache_started___32_cnst_cache)
	{	/* Cnst/cache.scm 60 */
	   return BTRUE;
	}
      else
	{	/* Cnst/cache.scm 60 */
	   _cache_started___32_cnst_cache = ((bool_t) 1);
	   _cnst_table_ref__15_cnst_cache =
	      find_global_module_25_ast_env(
	      CNST_TABLE_REF(((long) 0)),
	      CNST_TABLE_REF(((long) 1)));
	   _cnst_table_set___16_cnst_cache =
	      find_global_module_25_ast_env(
	      CNST_TABLE_REF(((long) 2)),
	      CNST_TABLE_REF(((long) 1)));
	   _cons__148_cnst_cache =
	      find_global_module_25_ast_env(
	      CNST_TABLE_REF(((long) 3)),
	      CNST_TABLE_REF(((long) 1)));
	   _btrue__29_cnst_cache =
	      find_global_module_25_ast_env(
	      CNST_TABLE_REF(((long) 4)),
	      CNST_TABLE_REF(((long) 1)));
	   _bfalse__69_cnst_cache =
	      find_global_module_25_ast_env(
	      CNST_TABLE_REF(((long) 5)),
	      CNST_TABLE_REF(((long) 1)));
	   _string__bstring__114_cnst_cache =
	      find_global_module_25_ast_env(
	      CNST_TABLE_REF(((long) 6)),
	      CNST_TABLE_REF(((long) 1)));
	   _string__symbol__115_cnst_cache =
	      find_global_module_25_ast_env(
	      CNST_TABLE_REF(((long) 7)),
	      CNST_TABLE_REF(((long) 1)));
	   _string__keyword__251_cnst_cache =
	      find_global_module_25_ast_env(
	      CNST_TABLE_REF(((long) 8)),
	      CNST_TABLE_REF(((long) 1)));
	   _bool__bbool__85_cnst_cache =
	      find_global_module_25_ast_env(
	      CNST_TABLE_REF(((long) 9)),
	      CNST_TABLE_REF(((long) 1)));
	   _make_fx_procedure__51_cnst_cache =
	      find_global_module_25_ast_env(
	      CNST_TABLE_REF(((long) 10)),
	      CNST_TABLE_REF(((long) 1)));
	   _make_va_procedure__53_cnst_cache =
	      find_global_module_25_ast_env(
	      CNST_TABLE_REF(((long) 11)),
	      CNST_TABLE_REF(((long) 1)));
	   _double__real__21_cnst_cache =
	      find_global_module_25_ast_env(
	      CNST_TABLE_REF(((long) 12)),
	      CNST_TABLE_REF(((long) 1)));
	   _list__vector__161_cnst_cache =
	      find_global_223_ast_env(
	      CNST_TABLE_REF(((long) 13)), BNIL);
	   _vector_tag_set___225_cnst_cache =
	      find_global_223_ast_env(
	      CNST_TABLE_REF(((long) 14)), BNIL);
	   return BTRUE;
	}
   }
}



/* _start-cnst-cache! */
obj_t 
_start_cnst_cache__252_cnst_cache(obj_t env_435)
{
   AN_OBJECT;
   {	/* Cnst/cache.scm 59 */
      return
	 start_cnst_cache__172_cnst_cache();
   }
}



/* stop-cnst-cache! */
obj_t 
stop_cnst_cache__90_cnst_cache()
{
   AN_OBJECT;
   {	/* Cnst/cache.scm 95 */
      _string__bstring__114_cnst_cache = BFALSE;
      _string__symbol__115_cnst_cache = BFALSE;
      _string__keyword__251_cnst_cache = BFALSE;
      _bool__bbool__85_cnst_cache = BFALSE;
      _make_fx_procedure__51_cnst_cache = BFALSE;
      _make_va_procedure__53_cnst_cache = BFALSE;
      _double__real__21_cnst_cache = BFALSE;
      _cons__148_cnst_cache = BFALSE;
      _btrue__29_cnst_cache = BFALSE;
      _bfalse__69_cnst_cache = BFALSE;
      return BTRUE;
   }
}



/* _stop-cnst-cache! */
obj_t 
_stop_cnst_cache__214_cnst_cache(obj_t env_436)
{
   AN_OBJECT;
   {	/* Cnst/cache.scm 95 */
      return
	 stop_cnst_cache__90_cnst_cache();
   }
}



/* method-init */
obj_t 
method_init_76_cnst_cache()
{
   AN_OBJECT;
   {	/* Cnst/cache.scm 14 */
      return BUNSPEC;
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_cnst_cache()
{
   AN_OBJECT;
   {	/* Cnst/cache.scm 14 */
      module_initialization_70_type_type(((long) 0), "CNST_CACHE");
      module_initialization_70_ast_var(((long) 0), "CNST_CACHE");
      module_initialization_70_ast_env(((long) 0), "CNST_CACHE");
      return
	 module_initialization_70_engine_param(((long) 0), "CNST_CACHE");
   }
}
