/*===========================================================================*/
/*   (Cnst/initialize.scm)                                                   */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;


extern char *number__string_214___r4_numbers_6_5(obj_t, obj_t);
static obj_t method_init_76_cnst_initialize();
static obj_t read_initialize__67_cnst_initialize();
extern obj_t string_append(obj_t, obj_t);
extern obj_t get_cnst_offset_21_cnst_alloc();
extern obj_t create_struct(obj_t, long);
extern obj_t obj_to_string(obj_t);
static obj_t intern_initialize__196_cnst_initialize();
static obj_t lib_initialize__103_cnst_initialize();
extern obj_t module_initialization_70_cnst_initialize(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_speek(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_ast_env(long, char *);
extern obj_t module_initialization_70_ast_build(long, char *);
extern obj_t module_initialization_70_ast_lvtype(long, char *);
extern obj_t module_initialization_70_coerce_coerce(long, char *);
extern obj_t module_initialization_70_cnst_alloc(long, char *);
extern obj_t module_initialization_70_cnst_node(long, char *);
extern obj_t module_initialization_70___intext(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_numbers_6_5(long, char *);
extern obj_t module_initialization_70___r4_vectors_6_8(long, char *);
extern obj_t module_initialization_70___r4_output_6_10_3(long, char *);
static obj_t cnst_set__cnst_string_40_cnst_initialize(obj_t);
static obj_t read_empty_cnst_initialize__140_cnst_initialize();
static obj_t intern_full_cnst_initialize__85_cnst_initialize();
extern obj_t list__vector_101___r4_vectors_6_8(obj_t);
extern obj_t write___r4_output_6_10_3(obj_t, obj_t);
static obj_t imported_modules_init_94_cnst_initialize();
static obj_t _initialize_ast_73_cnst_initialize(obj_t);
extern node_bglt coerce__182_coerce_coerce(node_bglt, type_bglt);
static obj_t library_modules_init_112_cnst_initialize();
static obj_t toplevel_init_63_cnst_initialize();
extern obj_t build_ast_197_ast_build(obj_t);
extern obj_t open_input_string(obj_t);
static obj_t read_full_cnst_initialize__176_cnst_initialize();
extern obj_t initialize_ast_128_cnst_initialize();
extern obj_t close_output_port(obj_t);
extern obj_t string_to_bstring(char *);
extern obj_t get_cnst_sexp_197_cnst_alloc();
extern node_bglt cnst_alloc_string_41_cnst_alloc(obj_t, obj_t);
extern obj_t _init_mode__183_engine_param;
extern obj_t get_cnst_table_42_cnst_alloc();
extern obj_t open_output_string();
extern obj_t internal_error_43_tools_error(obj_t, obj_t, obj_t);
extern obj_t get_cnst_set_138_cnst_alloc();
extern obj_t read___reader(obj_t);
static obj_t intern_empty_cnst_initialize__171_cnst_initialize();
static obj_t require_initialization_114_cnst_initialize = BUNSPEC;
static obj_t cnst_init_137_cnst_initialize();
extern obj_t reverse__39___r4_pairs_and_lists_6_3(obj_t);
static obj_t __cnst[28];

DEFINE_EXPORT_PROCEDURE(initialize_ast_env_80_cnst_initialize, _initialize_ast_73_cnst_initialize1775, _initialize_ast_73_cnst_initialize, 0L, 0);
DEFINE_STRING(string1769_cnst_initialize, string1769_cnst_initialize1776, "Can't open output string port", 29);
DEFINE_STRING(string1770_cnst_initialize, string1770_cnst_initialize1777, "CNST-TMP C-VECTOR-REF I::INT __INTEXT STRING->OBJ CNST-TMP::VECTOR AUX C--FX AUX::INT CNST-PORT __READER @ CNST-TABLE-SET! BEGIN I C-=FX IF I::LONG LOOP LABELS C-OPEN-INPUT-STRING CNST-PORT::INPUT-PORT LET UNIT CNST INTERN READ LIB ", 232);
DEFINE_STRING(string1768_cnst_initialize, string1768_cnst_initialize1778, "cnst-set->cnst-string", 21);
DEFINE_STRING(string1767_cnst_initialize, string1767_cnst_initialize1779, "__cnst[ ", 8);
DEFINE_STRING(string1766_cnst_initialize, string1766_cnst_initialize1780, " ] ", 3);
DEFINE_STRING(string1765_cnst_initialize, string1765_cnst_initialize1781, "*__cnst", 7);
DEFINE_STRING(string1764_cnst_initialize, string1764_cnst_initialize1782, "Illegal init-mode", 17);
DEFINE_STRING(string1763_cnst_initialize, string1763_cnst_initialize1783, "intialize-stop!", 15);



/* module-initialization */
obj_t 
module_initialization_70_cnst_initialize(long checksum_1600, char *from_1601)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_cnst_initialize))
	{
	   require_initialization_114_cnst_initialize =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_cnst_initialize();
	   cnst_init_137_cnst_initialize();
	   imported_modules_init_94_cnst_initialize();
	   method_init_76_cnst_initialize();
	   toplevel_init_63_cnst_initialize();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_cnst_initialize()
{
   AN_OBJECT;
   {	/* Cnst/initialize.scm 14 */
      module_initialization_70___r4_numbers_6_5(((long) 0), "CNST_INITIALIZE");
      module_initialization_70___intext(((long) 0), "CNST_INITIALIZE");
      module_initialization_70___r4_vectors_6_8(((long) 0), "CNST_INITIALIZE");
      module_initialization_70___r4_output_6_10_3(((long) 0), "CNST_INITIALIZE");
      module_initialization_70___reader(((long) 0), "CNST_INITIALIZE");
      module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "CNST_INITIALIZE");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_cnst_initialize()
{
   AN_OBJECT;
   {	/* Cnst/initialize.scm 14 */
      {		/* Cnst/initialize.scm 14 */
	 obj_t cnst_port_138_1593;
	 cnst_port_138_1593 =
	    open_input_string(string1770_cnst_initialize);
	 {
	    long i_1594;
	    i_1594 = ((long) 27);
	  loop_1595:
	    {	/* Cnst/initialize.scm 14 */
	       bool_t test1771_1596;
	       test1771_1596 =
		  (i_1594 == ((long) -1));
	       if (test1771_1596)
		 {	/* Cnst/initialize.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Cnst/initialize.scm 14 */
		    {	/* Cnst/initialize.scm 14 */
		       obj_t arg1772_1597;
		       {	/* Cnst/initialize.scm 14 */
			  obj_t list1773_1598;
			  list1773_1598 =
			     MAKE_PAIR(cnst_port_138_1593, BNIL);
			  arg1772_1597 =
			     read___reader(list1773_1598);
		       }
		       CNST_TABLE_SET(i_1594, arg1772_1597);
		    }
		    {	/* Cnst/initialize.scm 14 */
		       int aux_1599;
		       {	/* Cnst/initialize.scm 14 */
			  long aux_1622;
			  aux_1622 =
			     (i_1594 - ((long) 1));
			  aux_1599 =
			     (int) (aux_1622);
		       }
		       {
			  long i_1625;
			  i_1625 =
			     (long) (aux_1599);
			  i_1594 = i_1625;
			  goto loop_1595;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_cnst_initialize()
{
   AN_OBJECT;
   {	/* Cnst/initialize.scm 14 */
      return BUNSPEC;
   }
}



/* initialize-ast */
obj_t 
initialize_ast_128_cnst_initialize()
{
   AN_OBJECT;
   {	/* Cnst/initialize.scm 39 */
      {		/* Cnst/initialize.scm 40 */
	 obj_t body_725;
	 {	/* Cnst/initialize.scm 40 */
	    obj_t case_value_58_739;
	    case_value_58_739 = _init_mode__183_engine_param;
	    {	/* Cnst/initialize.scm 40 */
	       bool_t test_1627;
	       {	/* ./Ieee/equiv.scm 5508 */
		  obj_t aux_1628;
		  aux_1628 =
		     CNST_TABLE_REF(((long) 0));
		  test_1627 =
		     (case_value_58_739 == aux_1628);
	       }
	       if (test_1627)
		 {	/* Cnst/initialize.scm 40 */
		    body_725 =
		       lib_initialize__103_cnst_initialize();
		 }
	       else
		 {	/* Cnst/initialize.scm 40 */
		    bool_t test_1632;
		    {	/* ./Ieee/equiv.scm 5508 */
		       obj_t aux_1633;
		       aux_1633 =
			  CNST_TABLE_REF(((long) 1));
		       test_1632 =
			  (case_value_58_739 == aux_1633);
		    }
		    if (test_1632)
		      {		/* Cnst/initialize.scm 40 */
			 body_725 =
			    read_initialize__67_cnst_initialize();
		      }
		    else
		      {		/* Cnst/initialize.scm 40 */
			 bool_t test_1637;
			 {	/* ./Ieee/equiv.scm 5508 */
			    obj_t aux_1638;
			    aux_1638 =
			       CNST_TABLE_REF(((long) 2));
			    test_1637 =
			       (case_value_58_739 == aux_1638);
			 }
			 if (test_1637)
			   {	/* Cnst/initialize.scm 40 */
			      body_725 =
				 intern_initialize__196_cnst_initialize();
			   }
			 else
			   {	/* Cnst/initialize.scm 40 */
			      body_725 =
				 internal_error_43_tools_error(string1763_cnst_initialize, string1764_cnst_initialize, _init_mode__183_engine_param);
			   }
		      }
		 }
	    }
	 }
	 if (
	    PAIRP(body_725))
	   {	/* Cnst/initialize.scm 52 */
	      obj_t unit_727;
	      {		/* Cnst/initialize.scm 52 */
		 obj_t id_1336;
		 id_1336 =
		    CNST_TABLE_REF(((long) 3));
		 {	/* ./Ast/unit.sch 460 */
		    obj_t new_1340;
		    {	/* ./Ast/unit.sch 460 */
		       obj_t aux_1646;
		       aux_1646 =
			  CNST_TABLE_REF(((long) 4));
		       new_1340 =
			  create_struct(aux_1646, ((long) 4));
		    }
		    STRUCT_SET(new_1340, ((long) 3), BTRUE);
		    STRUCT_SET(new_1340, ((long) 2), body_725);
		    {	/* ./Llib/struct.scm 1463 */
		       obj_t aux_1651;
		       aux_1651 =
			  BINT(((long) 8));
		       STRUCT_SET(new_1340, ((long) 1), aux_1651);
		    }
		    STRUCT_SET(new_1340, ((long) 0), id_1336);
		    unit_727 = new_1340;
		 }
	      }
	      {		/* Cnst/initialize.scm 53 */
		 obj_t ast_728;
		 {	/* Cnst/initialize.scm 53 */
		    obj_t arg1458_737;
		    {	/* Cnst/initialize.scm 53 */
		       obj_t list1459_738;
		       list1459_738 =
			  MAKE_PAIR(unit_727, BNIL);
		       arg1458_737 = list1459_738;
		    }
		    ast_728 =
		       build_ast_197_ast_build(arg1458_737);
		 }
		 {
		    obj_t l1437_729;
		    l1437_729 = ast_728;
		  lname1438_730:
		    if (
		       PAIRP(l1437_729))
		      {		/* Cnst/initialize.scm 54 */
			 {	/* Cnst/initialize.scm 55 */
			    obj_t global_732;
			    global_732 =
			       CAR(l1437_729);
			    {	/* Cnst/initialize.scm 55 */
			       type_bglt aux_1668;
			       node_bglt aux_1660;
			       {	/* Cnst/initialize.scm 56 */
				  global_bglt obj_1366;
				  obj_1366 =
				     (global_bglt) (global_732);
				  aux_1668 =
				     (((global_bglt) CREF(obj_1366))->type);
			       }
			       {	/* Cnst/initialize.scm 55 */
				  obj_t aux_1661;
				  {	/* Cnst/initialize.scm 55 */
				     sfun_bglt obj_1365;
				     {	/* Cnst/initialize.scm 55 */
					value_bglt aux_1662;
					{	/* Cnst/initialize.scm 55 */
					   global_bglt obj_1364;
					   obj_1364 =
					      (global_bglt) (global_732);
					   aux_1662 =
					      (((global_bglt) CREF(obj_1364))->value);
					}
					obj_1365 =
					   (sfun_bglt) (aux_1662);
				     }
				     aux_1661 =
					(((sfun_bglt) CREF(obj_1365))->body);
				  }
				  aux_1660 =
				     (node_bglt) (aux_1661);
			       }
			       coerce__182_coerce_coerce(aux_1660, aux_1668);
			    }
			 }
			 {
			    obj_t l1437_1672;
			    l1437_1672 =
			       CDR(l1437_729);
			    l1437_729 = l1437_1672;
			    goto lname1438_730;
			 }
		      }
		    else
		      {		/* Cnst/initialize.scm 54 */
			 ((bool_t) 1);
		      }
		 }
		 return ast_728;
	      }
	   }
	 else
	   {	/* Cnst/initialize.scm 51 */
	      return BNIL;
	   }
      }
   }
}



/* _initialize-ast */
obj_t 
_initialize_ast_73_cnst_initialize(obj_t env_1591)
{
   AN_OBJECT;
   {	/* Cnst/initialize.scm 39 */
      return
	 initialize_ast_128_cnst_initialize();
   }
}



/* lib-initialize! */
obj_t 
lib_initialize__103_cnst_initialize()
{
   AN_OBJECT;
   {	/* Cnst/initialize.scm 64 */
      {		/* Cnst/initialize.scm 65 */
	 obj_t arg1463_743;
	 arg1463_743 =
	    get_cnst_table_42_cnst_alloc();
	 {	/* Cnst/initialize.scm 65 */
	    global_bglt obj_1368;
	    obj_t val1051_1369;
	    obj_1368 =
	       (global_bglt) (arg1463_743);
	    val1051_1369 = string1765_cnst_initialize;
	    ((((global_bglt) CREF(obj_1368))->name) = ((obj_t) val1051_1369), BUNSPEC);
	 }
      }
      return
	 get_cnst_sexp_197_cnst_alloc();
   }
}



/* read-initialize! */
obj_t 
read_initialize__67_cnst_initialize()
{
   AN_OBJECT;
   {	/* Cnst/initialize.scm 71 */
      {		/* Cnst/initialize.scm 72 */
	 bool_t test1465_745;
	 {	/* Cnst/initialize.scm 72 */
	    obj_t arg1466_746;
	    arg1466_746 =
	       get_cnst_offset_21_cnst_alloc();
	    {	/* ./Ieee/fixnum.scm 7109 */
	       long aux_1680;
	       aux_1680 =
		  (long) CINT(arg1466_746);
	       test1465_745 =
		  (aux_1680 == ((long) 0));
	    }
	 }
	 if (test1465_745)
	   {	/* Cnst/initialize.scm 72 */
	      return
		 read_empty_cnst_initialize__140_cnst_initialize();
	   }
	 else
	   {	/* Cnst/initialize.scm 72 */
	      return
		 read_full_cnst_initialize__176_cnst_initialize();
	   }
      }
   }
}



/* read-empty-cnst-initialize! */
obj_t 
read_empty_cnst_initialize__140_cnst_initialize()
{
   AN_OBJECT;
   {	/* Cnst/initialize.scm 79 */
      {		/* Cnst/initialize.scm 80 */
	 obj_t arg1469_748;
	 arg1469_748 =
	    get_cnst_table_42_cnst_alloc();
	 {	/* Cnst/initialize.scm 80 */
	    global_bglt obj_1372;
	    obj_t val1051_1373;
	    obj_1372 =
	       (global_bglt) (arg1469_748);
	    val1051_1373 = string1765_cnst_initialize;
	    ((((global_bglt) CREF(obj_1372))->name) = ((obj_t) val1051_1373), BUNSPEC);
	 }
      }
      return
	 get_cnst_sexp_197_cnst_alloc();
   }
}



/* read-full-cnst-initialize! */
obj_t 
read_full_cnst_initialize__176_cnst_initialize()
{
   AN_OBJECT;
   {	/* Cnst/initialize.scm 86 */
      {
	 obj_t cnst_string_99_761;
	 {	/* Cnst/initialize.scm 87 */
	    obj_t arg1471_751;
	    obj_t arg1472_752;
	    arg1471_751 =
	       get_cnst_table_42_cnst_alloc();
	    {	/* Cnst/initialize.scm 88 */
	       obj_t arg1474_754;
	       {	/* Cnst/initialize.scm 89 */
		  char *arg1475_755;
		  {	/* Cnst/initialize.scm 89 */
		     obj_t arg1477_757;
		     arg1477_757 =
			get_cnst_offset_21_cnst_alloc();
		     arg1475_755 =
			number__string_214___r4_numbers_6_5(arg1477_757, BNIL);
		  }
		  {	/* Cnst/initialize.scm 88 */
		     obj_t aux_1693;
		     aux_1693 =
			string_to_bstring(arg1475_755);
		     arg1474_754 =
			string_append(aux_1693, string1766_cnst_initialize);
		  }
	       }
	       arg1472_752 =
		  string_append(string1767_cnst_initialize, arg1474_754);
	    }
	    {	/* Cnst/initialize.scm 87 */
	       global_bglt obj_1374;
	       obj_1374 =
		  (global_bglt) (arg1471_751);
	       ((((global_bglt) CREF(obj_1374))->name) = ((obj_t) arg1472_752), BUNSPEC);
	    }
	 }
	 {	/* Cnst/initialize.scm 108 */
	    obj_t cnst_string_99_759;
	    {	/* Cnst/initialize.scm 108 */
	       obj_t arg1479_760;
	       arg1479_760 =
		  get_cnst_set_138_cnst_alloc();
	       cnst_string_99_759 =
		  cnst_set__cnst_string_40_cnst_initialize(arg1479_760);
	    }
	    cnst_string_99_761 = cnst_string_99_759;
	    {	/* Cnst/initialize.scm 92 */
	       node_bglt var_string_203_763;
	       var_string_203_763 =
		  cnst_alloc_string_41_cnst_alloc(cnst_string_99_761, BFALSE);
	       {	/* Cnst/initialize.scm 92 */
		  obj_t sexp_764;
		  {	/* Cnst/initialize.scm 93 */
		     obj_t arg1482_766;
		     obj_t arg1483_767;
		     arg1482_766 =
			CNST_TABLE_REF(((long) 5));
		     {	/* Cnst/initialize.scm 93 */
			obj_t arg1484_768;
			obj_t arg1485_769;
			{	/* Cnst/initialize.scm 93 */
			   obj_t arg1486_770;
			   {	/* Cnst/initialize.scm 93 */
			      obj_t arg1489_772;
			      obj_t arg1490_773;
			      arg1489_772 =
				 CNST_TABLE_REF(((long) 6));
			      {		/* Cnst/initialize.scm 94 */
				 obj_t arg1491_774;
				 {	/* Cnst/initialize.scm 94 */
				    obj_t arg1494_776;
				    obj_t arg1495_777;
				    arg1494_776 =
				       CNST_TABLE_REF(((long) 7));
				    {	/* ./Ieee/pair-list.scm 5689 */
				       obj_t aux_1705;
				       {	/* Cnst/initialize.scm 94 */
					  global_bglt obj_1377;
					  {	/* Cnst/initialize.scm 94 */
					     variable_bglt aux_1706;
					     {	/* Cnst/initialize.scm 95 */
						var_bglt obj_1376;
						obj_1376 =
						   (var_bglt) (var_string_203_763);
						aux_1706 =
						   (((var_bglt) CREF(obj_1376))->variable);
					     }
					     obj_1377 =
						(global_bglt) (aux_1706);
					  }
					  aux_1705 =
					     (((global_bglt) CREF(obj_1377))->id);
				       }
				       arg1495_777 =
					  MAKE_PAIR(aux_1705, BNIL);
				    }
				    arg1491_774 =
				       MAKE_PAIR(arg1494_776, arg1495_777);
				 }
				 arg1490_773 =
				    MAKE_PAIR(arg1491_774, BNIL);
			      }
			      arg1486_770 =
				 MAKE_PAIR(arg1489_772, arg1490_773);
			   }
			   arg1484_768 =
			      MAKE_PAIR(arg1486_770, BNIL);
			}
			{	/* Cnst/initialize.scm 97 */
			   obj_t arg1499_781;
			   {	/* Cnst/initialize.scm 97 */
			      obj_t arg1501_783;
			      obj_t arg1502_784;
			      arg1501_783 =
				 CNST_TABLE_REF(((long) 8));
			      {		/* Cnst/initialize.scm 97 */
				 obj_t arg1503_785;
				 obj_t arg1504_786;
				 {	/* Cnst/initialize.scm 97 */
				    obj_t arg1505_787;
				    {	/* Cnst/initialize.scm 97 */
				       obj_t arg1508_789;
				       obj_t arg1509_790;
				       arg1508_789 =
					  CNST_TABLE_REF(((long) 9));
				       {	/* Cnst/initialize.scm 97 */
					  obj_t arg1510_791;
					  obj_t arg1511_792;
					  {	/* ./Ieee/pair-list.scm 5689 */
					     obj_t aux_1718;
					     aux_1718 =
						CNST_TABLE_REF(((long) 10));
					     arg1510_791 =
						MAKE_PAIR(aux_1718, BNIL);
					  }
					  {	/* Cnst/initialize.scm 98 */
					     obj_t arg1512_793;
					     {	/* Cnst/initialize.scm 98 */
						obj_t arg1514_795;
						obj_t arg1515_796;
						arg1514_795 =
						   CNST_TABLE_REF(((long) 11));
						{	/* Cnst/initialize.scm 98 */
						   obj_t arg1516_797;
						   obj_t arg1517_798;
						   {	/* Cnst/initialize.scm 98 */
						      obj_t arg1519_799;
						      obj_t arg1520_800;
						      arg1519_799 =
							 CNST_TABLE_REF(((long) 12));
						      {		/* Cnst/initialize.scm 98 */
							 obj_t arg1521_801;
							 obj_t arg1522_802;
							 arg1521_801 =
							    CNST_TABLE_REF(((long) 13));
							 {	/* ./Ieee/pair-list.scm 5689 */
							    obj_t aux_1724;
							    aux_1724 =
							       BINT(((long) -1));
							    arg1522_802 =
							       MAKE_PAIR(aux_1724, BNIL);
							 }
							 arg1520_800 =
							    MAKE_PAIR(arg1521_801, arg1522_802);
						      }
						      arg1516_797 =
							 MAKE_PAIR(arg1519_799, arg1520_800);
						   }
						   {	/* Cnst/initialize.scm 100 */
						      obj_t arg1523_803;
						      {		/* Cnst/initialize.scm 100 */
							 obj_t arg1525_804;
							 {	/* Cnst/initialize.scm 100 */
							    obj_t arg1527_806;
							    obj_t arg1528_807;
							    arg1527_806 =
							       CNST_TABLE_REF(((long) 14));
							    {	/* Cnst/initialize.scm 101 */
							       obj_t arg1529_808;
							       obj_t arg1530_809;
							       {	/* Cnst/initialize.scm 101 */
								  obj_t arg1532_810;
								  obj_t arg1533_811;
								  arg1532_810 =
								     CNST_TABLE_REF(((long) 15));
								  {	/* Cnst/initialize.scm 101 */
								     obj_t arg1534_812;
								     obj_t arg1535_813;
								     arg1534_812 =
									CNST_TABLE_REF(((long) 13));
								     {	/* Cnst/initialize.scm 103 */
									obj_t arg1536_814;
									{	/* Cnst/initialize.scm 103 */
									   obj_t arg1539_816;
									   obj_t arg1540_817;
									   {	/* Cnst/initialize.scm 103 */
									      obj_t arg1541_818;
									      obj_t arg1543_819;
									      arg1541_818 =
										 CNST_TABLE_REF(((long) 16));
									      {		/* Cnst/initialize.scm 103 */
										 obj_t arg1544_820;
										 obj_t arg1545_821;
										 arg1544_820 =
										    CNST_TABLE_REF(((long) 1));
										 {	/* ./Ieee/pair-list.scm 5689 */
										    obj_t aux_1734;
										    aux_1734 =
										       CNST_TABLE_REF(((long) 17));
										    arg1545_821 =
										       MAKE_PAIR(aux_1734, BNIL);
										 }
										 arg1543_819 =
										    MAKE_PAIR(arg1544_820, arg1545_821);
									      }
									      arg1539_816 =
										 MAKE_PAIR(arg1541_818, arg1543_819);
									   }
									   {	/* ./Ieee/pair-list.scm 5689 */
									      obj_t aux_1739;
									      aux_1739 =
										 CNST_TABLE_REF(((long) 18));
									      arg1540_817 =
										 MAKE_PAIR(aux_1739, BNIL);
									   }
									   arg1536_814 =
									      MAKE_PAIR(arg1539_816, arg1540_817);
									}
									arg1535_813 =
									   MAKE_PAIR(arg1536_814, BNIL);
								     }
								     arg1533_811 =
									MAKE_PAIR(arg1534_812, arg1535_813);
								  }
								  arg1529_808 =
								     MAKE_PAIR(arg1532_810, arg1533_811);
							       }
							       {	/* Cnst/initialize.scm 104 */
								  obj_t arg1547_822;
								  {	/* Cnst/initialize.scm 104 */
								     obj_t arg1549_824;
								     obj_t arg1550_825;
								     arg1549_824 =
									CNST_TABLE_REF(((long) 5));
								     {	/* Cnst/initialize.scm 104 */
									obj_t arg1551_826;
									obj_t arg1552_827;
									{	/* Cnst/initialize.scm 104 */
									   obj_t arg1553_828;
									   {	/* Cnst/initialize.scm 104 */
									      obj_t arg1556_830;
									      obj_t arg1557_831;
									      arg1556_830 =
										 CNST_TABLE_REF(((long) 19));
									      {		/* Cnst/initialize.scm 104 */
										 obj_t arg1558_832;
										 {	/* Cnst/initialize.scm 104 */
										    obj_t arg1560_834;
										    obj_t arg1561_835;
										    arg1560_834 =
										       CNST_TABLE_REF(((long) 20));
										    {	/* Cnst/initialize.scm 104 */
										       obj_t arg1562_836;
										       obj_t arg1563_837;
										       arg1562_836 =
											  CNST_TABLE_REF(((long) 13));
										       {	/* ./Ieee/pair-list.scm 5689 */
											  obj_t aux_1750;
											  aux_1750 =
											     BINT(((long) 1));
											  arg1563_837 =
											     MAKE_PAIR(aux_1750, BNIL);
										       }
										       arg1561_835 =
											  MAKE_PAIR(arg1562_836, arg1563_837);
										    }
										    arg1558_832 =
										       MAKE_PAIR(arg1560_834, arg1561_835);
										 }
										 arg1557_831 =
										    MAKE_PAIR(arg1558_832, BNIL);
									      }
									      arg1553_828 =
										 MAKE_PAIR(arg1556_830, arg1557_831);
									   }
									   arg1551_826 =
									      MAKE_PAIR(arg1553_828, BNIL);
									}
									{	/* Cnst/initialize.scm 105 */
									   obj_t arg1564_838;
									   {	/* Cnst/initialize.scm 105 */
									      obj_t arg1566_840;
									      obj_t arg1567_841;
									      arg1566_840 =
										 CNST_TABLE_REF(((long) 9));
									      {		/* ./Ieee/pair-list.scm 5689 */
										 obj_t aux_1759;
										 aux_1759 =
										    CNST_TABLE_REF(((long) 21));
										 arg1567_841 =
										    MAKE_PAIR(aux_1759, BNIL);
									      }
									      arg1564_838 =
										 MAKE_PAIR(arg1566_840, arg1567_841);
									   }
									   arg1552_827 =
									      MAKE_PAIR(arg1564_838, BNIL);
									}
									arg1550_825 =
									   MAKE_PAIR(arg1551_826, arg1552_827);
								     }
								     arg1547_822 =
									MAKE_PAIR(arg1549_824, arg1550_825);
								  }
								  arg1530_809 =
								     MAKE_PAIR(arg1547_822, BNIL);
							       }
							       arg1528_807 =
								  MAKE_PAIR(arg1529_808, arg1530_809);
							    }
							    arg1525_804 =
							       MAKE_PAIR(arg1527_806, arg1528_807);
							 }
							 arg1523_803 =
							    MAKE_PAIR(arg1525_804, BNIL);
						      }
						      arg1517_798 =
							 MAKE_PAIR(BUNSPEC, arg1523_803);
						   }
						   arg1515_796 =
						      MAKE_PAIR(arg1516_797, arg1517_798);
						}
						arg1512_793 =
						   MAKE_PAIR(arg1514_795, arg1515_796);
					     }
					     arg1511_792 =
						MAKE_PAIR(arg1512_793, BNIL);
					  }
					  arg1509_790 =
					     MAKE_PAIR(arg1510_791, arg1511_792);
				       }
				       arg1505_787 =
					  MAKE_PAIR(arg1508_789, arg1509_790);
				    }
				    arg1503_785 =
				       MAKE_PAIR(arg1505_787, BNIL);
				 }
				 {	/* Cnst/initialize.scm 106 */
				    obj_t arg1568_842;
				    {	/* Cnst/initialize.scm 106 */
				       obj_t arg1571_844;
				       obj_t arg1572_845;
				       arg1571_844 =
					  CNST_TABLE_REF(((long) 9));
				       {	/* Cnst/initialize.scm 106 */
					  long arg1573_846;
					  {	/* Cnst/initialize.scm 106 */
					     obj_t arg1577_848;
					     arg1577_848 =
						get_cnst_offset_21_cnst_alloc();
					     {	/* ./Ieee/fixnum.scm 7199 */
						long aux_1779;
						aux_1779 =
						   (long) CINT(arg1577_848);
						arg1573_846 =
						   (aux_1779 - ((long) 1));
					     }
					  }
					  {	/* ./Ieee/pair-list.scm 5689 */
					     obj_t aux_1782;
					     aux_1782 =
						BINT(arg1573_846);
					     arg1572_845 =
						MAKE_PAIR(aux_1782, BNIL);
					  }
				       }
				       arg1568_842 =
					  MAKE_PAIR(arg1571_844, arg1572_845);
				    }
				    arg1504_786 =
				       MAKE_PAIR(arg1568_842, BNIL);
				 }
				 arg1502_784 =
				    MAKE_PAIR(arg1503_785, arg1504_786);
			      }
			      arg1499_781 =
				 MAKE_PAIR(arg1501_783, arg1502_784);
			   }
			   arg1485_769 =
			      MAKE_PAIR(arg1499_781, BNIL);
			}
			arg1483_767 =
			   MAKE_PAIR(arg1484_768, arg1485_769);
		     }
		     sexp_764 =
			MAKE_PAIR(arg1482_766, arg1483_767);
		  }
		  {	/* Cnst/initialize.scm 93 */

		     {	/* Cnst/initialize.scm 107 */
			obj_t arg1481_765;
			arg1481_765 =
			   get_cnst_sexp_197_cnst_alloc();
			return
			   MAKE_PAIR(sexp_764, arg1481_765);
		     }
		  }
	       }
	    }
	 }
      }
   }
}



/* cnst-set->cnst-string */
obj_t 
cnst_set__cnst_string_40_cnst_initialize(obj_t set_19)
{
   AN_OBJECT;
   {	/* Cnst/initialize.scm 117 */
      {		/* Cnst/initialize.scm 118 */
	 obj_t port_851;
	 port_851 =
	    open_output_string();
	 if (
	    OUTPUT_PORTP(port_851))
	   {	/* Cnst/initialize.scm 119 */
	      {
		 obj_t l1439_853;
		 l1439_853 = set_19;
	       lname1440_854:
		 if (
		    PAIRP(l1439_853))
		   {	/* Cnst/initialize.scm 124 */
		      {		/* Cnst/initialize.scm 124 */
			 obj_t cnst_856;
			 cnst_856 =
			    CAR(l1439_853);
			 {	/* Cnst/initialize.scm 125 */
			    obj_t list1581_857;
			    list1581_857 =
			       MAKE_PAIR(port_851, BNIL);
			    write___r4_output_6_10_3(cnst_856, list1581_857);
			 }
			 WRITE_CHAR(((unsigned char) ' '), port_851);
		      }
		      {
			 obj_t l1439_1803;
			 l1439_1803 =
			    CDR(l1439_853);
			 l1439_853 = l1439_1803;
			 goto lname1440_854;
		      }
		   }
		 else
		   {	/* Cnst/initialize.scm 124 */
		      ((bool_t) 1);
		   }
	      }
	      return
		 close_output_port(port_851);
	   }
	 else
	   {	/* Cnst/initialize.scm 119 */
	      return
		 internal_error_43_tools_error(string1768_cnst_initialize, string1769_cnst_initialize, port_851);
	   }
      }
   }
}



/* intern-initialize! */
obj_t 
intern_initialize__196_cnst_initialize()
{
   AN_OBJECT;
   {	/* Cnst/initialize.scm 133 */
      {		/* Cnst/initialize.scm 134 */
	 bool_t test1583_859;
	 {	/* Cnst/initialize.scm 134 */
	    obj_t arg1584_860;
	    arg1584_860 =
	       get_cnst_offset_21_cnst_alloc();
	    {	/* ./Ieee/fixnum.scm 7109 */
	       long aux_1808;
	       aux_1808 =
		  (long) CINT(arg1584_860);
	       test1583_859 =
		  (aux_1808 == ((long) 0));
	    }
	 }
	 if (test1583_859)
	   {	/* Cnst/initialize.scm 134 */
	      return
		 intern_empty_cnst_initialize__171_cnst_initialize();
	   }
	 else
	   {	/* Cnst/initialize.scm 134 */
	      return
		 intern_full_cnst_initialize__85_cnst_initialize();
	   }
      }
   }
}



/* intern-empty-cnst-initialize! */
obj_t 
intern_empty_cnst_initialize__171_cnst_initialize()
{
   AN_OBJECT;
   {	/* Cnst/initialize.scm 141 */
      {		/* Cnst/initialize.scm 142 */
	 obj_t arg1586_862;
	 arg1586_862 =
	    get_cnst_table_42_cnst_alloc();
	 {	/* Cnst/initialize.scm 142 */
	    global_bglt obj_1485;
	    obj_t val1051_1486;
	    obj_1485 =
	       (global_bglt) (arg1586_862);
	    val1051_1486 = string1765_cnst_initialize;
	    ((((global_bglt) CREF(obj_1485))->name) = ((obj_t) val1051_1486), BUNSPEC);
	 }
      }
      return
	 get_cnst_sexp_197_cnst_alloc();
   }
}



/* intern-full-cnst-initialize! */
obj_t 
intern_full_cnst_initialize__85_cnst_initialize()
{
   AN_OBJECT;
   {	/* Cnst/initialize.scm 148 */
      {
	 obj_t cnst_string_99_877;
	 {	/* Cnst/initialize.scm 149 */
	    obj_t arg1588_865;
	    obj_t arg1589_866;
	    arg1588_865 =
	       get_cnst_table_42_cnst_alloc();
	    {	/* Cnst/initialize.scm 150 */
	       obj_t arg1591_868;
	       {	/* Cnst/initialize.scm 151 */
		  char *arg1592_869;
		  {	/* Cnst/initialize.scm 151 */
		     obj_t arg1594_871;
		     arg1594_871 =
			get_cnst_offset_21_cnst_alloc();
		     arg1592_869 =
			number__string_214___r4_numbers_6_5(arg1594_871, BNIL);
		  }
		  {	/* Cnst/initialize.scm 150 */
		     obj_t aux_1821;
		     aux_1821 =
			string_to_bstring(arg1592_869);
		     arg1591_868 =
			string_append(aux_1821, string1766_cnst_initialize);
		  }
	       }
	       arg1589_866 =
		  string_append(string1767_cnst_initialize, arg1591_868);
	    }
	    {	/* Cnst/initialize.scm 149 */
	       global_bglt obj_1487;
	       obj_1487 =
		  (global_bglt) (arg1588_865);
	       ((((global_bglt) CREF(obj_1487))->name) = ((obj_t) arg1589_866), BUNSPEC);
	    }
	 }
	 {	/* Cnst/initialize.scm 171 */
	    obj_t cnst_string_99_873;
	    {	/* Cnst/initialize.scm 171 */
	       obj_t arg1596_874;
	       {	/* Cnst/initialize.scm 171 */
		  obj_t arg1597_875;
		  {	/* Cnst/initialize.scm 171 */
		     obj_t arg1598_876;
		     arg1598_876 =
			get_cnst_set_138_cnst_alloc();
		     arg1597_875 =
			reverse__39___r4_pairs_and_lists_6_3(arg1598_876);
		  }
		  arg1596_874 =
		     list__vector_101___r4_vectors_6_8(arg1597_875);
	       }
	       cnst_string_99_873 =
		  obj_to_string(arg1596_874);
	    }
	    {	/* Cnst/initialize.scm 171 */

	       cnst_string_99_877 = cnst_string_99_873;
	       {	/* Cnst/initialize.scm 154 */
		  node_bglt var_string_203_879;
		  var_string_203_879 =
		     cnst_alloc_string_41_cnst_alloc(cnst_string_99_877, BFALSE);
		  {	/* Cnst/initialize.scm 154 */
		     obj_t sexp_880;
		     {	/* Cnst/initialize.scm 155 */
			obj_t arg1601_882;
			obj_t arg1602_883;
			arg1601_882 =
			   CNST_TABLE_REF(((long) 5));
			{	/* Cnst/initialize.scm 155 */
			   obj_t arg1603_884;
			   obj_t arg1604_885;
			   {	/* Cnst/initialize.scm 155 */
			      obj_t arg1605_886;
			      {		/* Cnst/initialize.scm 155 */
				 obj_t arg1607_888;
				 obj_t arg1608_889;
				 arg1607_888 =
				    CNST_TABLE_REF(((long) 22));
				 {	/* Cnst/initialize.scm 156 */
				    obj_t arg1609_890;
				    {	/* Cnst/initialize.scm 156 */
				       obj_t arg1611_892;
				       obj_t arg1612_893;
				       {	/* Cnst/initialize.scm 156 */
					  obj_t arg1613_894;
					  obj_t arg1614_895;
					  arg1613_894 =
					     CNST_TABLE_REF(((long) 16));
					  {	/* Cnst/initialize.scm 156 */
					     obj_t arg1615_896;
					     obj_t arg1616_897;
					     arg1615_896 =
						CNST_TABLE_REF(((long) 23));
					     {	/* ./Ieee/pair-list.scm 5689 */
						obj_t aux_1836;
						aux_1836 =
						   CNST_TABLE_REF(((long) 24));
						arg1616_897 =
						   MAKE_PAIR(aux_1836, BNIL);
					     }
					     arg1614_895 =
						MAKE_PAIR(arg1615_896, arg1616_897);
					  }
					  arg1611_892 =
					     MAKE_PAIR(arg1613_894, arg1614_895);
				       }
				       {	/* ./Ieee/pair-list.scm 5689 */
					  obj_t aux_1841;
					  {	/* Cnst/initialize.scm 157 */
					     global_bglt obj_1496;
					     {	/* Cnst/initialize.scm 157 */
						variable_bglt aux_1842;
						{	/* Cnst/initialize.scm 158 */
						   var_bglt obj_1495;
						   obj_1495 =
						      (var_bglt) (var_string_203_879);
						   aux_1842 =
						      (((var_bglt) CREF(obj_1495))->variable);
						}
						obj_1496 =
						   (global_bglt) (aux_1842);
					     }
					     aux_1841 =
						(((global_bglt) CREF(obj_1496))->id);
					  }
					  arg1612_893 =
					     MAKE_PAIR(aux_1841, BNIL);
				       }
				       arg1609_890 =
					  MAKE_PAIR(arg1611_892, arg1612_893);
				    }
				    arg1608_889 =
				       MAKE_PAIR(arg1609_890, BNIL);
				 }
				 arg1605_886 =
				    MAKE_PAIR(arg1607_888, arg1608_889);
			      }
			      arg1603_884 =
				 MAKE_PAIR(arg1605_886, BNIL);
			   }
			   {	/* Cnst/initialize.scm 159 */
			      obj_t arg1620_901;
			      {		/* Cnst/initialize.scm 159 */
				 obj_t arg1622_903;
				 obj_t arg1623_904;
				 arg1622_903 =
				    CNST_TABLE_REF(((long) 8));
				 {	/* Cnst/initialize.scm 159 */
				    obj_t arg1624_905;
				    obj_t arg1625_906;
				    {	/* Cnst/initialize.scm 159 */
				       obj_t arg1626_907;
				       {	/* Cnst/initialize.scm 159 */
					  obj_t arg1628_909;
					  obj_t arg1629_910;
					  arg1628_909 =
					     CNST_TABLE_REF(((long) 9));
					  {	/* Cnst/initialize.scm 159 */
					     obj_t arg1630_911;
					     obj_t arg1631_912;
					     {	/* ./Ieee/pair-list.scm 5689 */
						obj_t aux_1854;
						aux_1854 =
						   CNST_TABLE_REF(((long) 25));
						arg1630_911 =
						   MAKE_PAIR(aux_1854, BNIL);
					     }
					     {	/* Cnst/initialize.scm 160 */
						obj_t arg1632_913;
						{	/* Cnst/initialize.scm 160 */
						   obj_t arg1634_915;
						   obj_t arg1635_916;
						   arg1634_915 =
						      CNST_TABLE_REF(((long) 11));
						   {	/* Cnst/initialize.scm 160 */
						      obj_t arg1636_917;
						      obj_t arg1637_918;
						      {		/* Cnst/initialize.scm 160 */
							 obj_t arg1638_919;
							 obj_t arg1639_920;
							 arg1638_919 =
							    CNST_TABLE_REF(((long) 12));
							 {	/* Cnst/initialize.scm 160 */
							    obj_t arg1640_921;
							    obj_t arg1641_922;
							    arg1640_921 =
							       CNST_TABLE_REF(((long) 13));
							    {	/* ./Ieee/pair-list.scm 5689 */
							       obj_t aux_1860;
							       aux_1860 =
								  BINT(((long) -1));
							       arg1641_922 =
								  MAKE_PAIR(aux_1860, BNIL);
							    }
							    arg1639_920 =
							       MAKE_PAIR(arg1640_921, arg1641_922);
							 }
							 arg1636_917 =
							    MAKE_PAIR(arg1638_919, arg1639_920);
						      }
						      {		/* Cnst/initialize.scm 162 */
							 obj_t arg1642_923;
							 {	/* Cnst/initialize.scm 162 */
							    obj_t arg1643_924;
							    {	/* Cnst/initialize.scm 162 */
							       obj_t arg1646_926;
							       obj_t arg1647_927;
							       arg1646_926 =
								  CNST_TABLE_REF(((long) 14));
							       {	/* Cnst/initialize.scm 163 */
								  obj_t arg1648_928;
								  obj_t arg1649_929;
								  {	/* Cnst/initialize.scm 163 */
								     obj_t arg1650_930;
								     obj_t arg1651_931;
								     arg1650_930 =
									CNST_TABLE_REF(((long) 15));
								     {	/* Cnst/initialize.scm 163 */
									obj_t arg1652_932;
									obj_t arg1653_933;
									arg1652_932 =
									   CNST_TABLE_REF(((long) 13));
									{	/* Cnst/initialize.scm 164 */
									   obj_t arg1654_934;
									   {	/* Cnst/initialize.scm 164 */
									      obj_t arg1656_936;
									      obj_t arg1657_937;
									      arg1656_936 =
										 CNST_TABLE_REF(((long) 26));
									      {		/* Cnst/initialize.scm 164 */
										 obj_t arg1658_938;
										 obj_t arg1659_939;
										 arg1658_938 =
										    CNST_TABLE_REF(((long) 27));
										 {	/* ./Ieee/pair-list.scm 5689 */
										    obj_t aux_1870;
										    aux_1870 =
										       CNST_TABLE_REF(((long) 13));
										    arg1659_939 =
										       MAKE_PAIR(aux_1870, BNIL);
										 }
										 arg1657_937 =
										    MAKE_PAIR(arg1658_938, arg1659_939);
									      }
									      arg1654_934 =
										 MAKE_PAIR(arg1656_936, arg1657_937);
									   }
									   arg1653_933 =
									      MAKE_PAIR(arg1654_934, BNIL);
									}
									arg1651_931 =
									   MAKE_PAIR(arg1652_932, arg1653_933);
								     }
								     arg1648_928 =
									MAKE_PAIR(arg1650_930, arg1651_931);
								  }
								  {	/* Cnst/initialize.scm 167 */
								     obj_t arg1660_940;
								     {	/* Cnst/initialize.scm 167 */
									obj_t arg1662_942;
									obj_t arg1663_943;
									arg1662_942 =
									   CNST_TABLE_REF(((long) 5));
									{	/* Cnst/initialize.scm 167 */
									   obj_t arg1664_944;
									   obj_t arg1665_945;
									   {	/* Cnst/initialize.scm 167 */
									      obj_t arg1666_946;
									      {		/* Cnst/initialize.scm 167 */
										 obj_t arg1669_948;
										 obj_t arg1670_949;
										 arg1669_948 =
										    CNST_TABLE_REF(((long) 19));
										 {	/* Cnst/initialize.scm 167 */
										    obj_t arg1671_950;
										    {	/* Cnst/initialize.scm 167 */
										       obj_t arg1673_952;
										       obj_t arg1674_953;
										       arg1673_952 =
											  CNST_TABLE_REF(((long) 20));
										       {	/* Cnst/initialize.scm 167 */
											  obj_t arg1675_954;
											  obj_t arg1676_955;
											  arg1675_954 =
											     CNST_TABLE_REF(((long) 13));
											  {	/* ./Ieee/pair-list.scm 5689 */
											     obj_t aux_1882;
											     aux_1882 =
												BINT(((long) 1));
											     arg1676_955 =
												MAKE_PAIR(aux_1882, BNIL);
											  }
											  arg1674_953 =
											     MAKE_PAIR(arg1675_954, arg1676_955);
										       }
										       arg1671_950 =
											  MAKE_PAIR(arg1673_952, arg1674_953);
										    }
										    arg1670_949 =
										       MAKE_PAIR(arg1671_950, BNIL);
										 }
										 arg1666_946 =
										    MAKE_PAIR(arg1669_948, arg1670_949);
									      }
									      arg1664_944 =
										 MAKE_PAIR(arg1666_946, BNIL);
									   }
									   {	/* Cnst/initialize.scm 168 */
									      obj_t arg1677_956;
									      {		/* Cnst/initialize.scm 168 */
										 obj_t arg1679_958;
										 obj_t arg1680_959;
										 arg1679_958 =
										    CNST_TABLE_REF(((long) 9));
										 {	/* ./Ieee/pair-list.scm 5689 */
										    obj_t aux_1891;
										    aux_1891 =
										       CNST_TABLE_REF(((long) 21));
										    arg1680_959 =
										       MAKE_PAIR(aux_1891, BNIL);
										 }
										 arg1677_956 =
										    MAKE_PAIR(arg1679_958, arg1680_959);
									      }
									      arg1665_945 =
										 MAKE_PAIR(arg1677_956, BNIL);
									   }
									   arg1663_943 =
									      MAKE_PAIR(arg1664_944, arg1665_945);
									}
									arg1660_940 =
									   MAKE_PAIR(arg1662_942, arg1663_943);
								     }
								     arg1649_929 =
									MAKE_PAIR(arg1660_940, BNIL);
								  }
								  arg1647_927 =
								     MAKE_PAIR(arg1648_928, arg1649_929);
							       }
							       arg1643_924 =
								  MAKE_PAIR(arg1646_926, arg1647_927);
							    }
							    arg1642_923 =
							       MAKE_PAIR(arg1643_924, BNIL);
							 }
							 arg1637_918 =
							    MAKE_PAIR(BUNSPEC, arg1642_923);
						      }
						      arg1635_916 =
							 MAKE_PAIR(arg1636_917, arg1637_918);
						   }
						   arg1632_913 =
						      MAKE_PAIR(arg1634_915, arg1635_916);
						}
						arg1631_912 =
						   MAKE_PAIR(arg1632_913, BNIL);
					     }
					     arg1629_910 =
						MAKE_PAIR(arg1630_911, arg1631_912);
					  }
					  arg1626_907 =
					     MAKE_PAIR(arg1628_909, arg1629_910);
				       }
				       arg1624_905 =
					  MAKE_PAIR(arg1626_907, BNIL);
				    }
				    {	/* Cnst/initialize.scm 169 */
				       obj_t arg1681_960;
				       {	/* Cnst/initialize.scm 169 */
					  obj_t arg1683_962;
					  obj_t arg1684_963;
					  arg1683_962 =
					     CNST_TABLE_REF(((long) 9));
					  {	/* Cnst/initialize.scm 169 */
					     long arg1685_964;
					     {	/* Cnst/initialize.scm 169 */
						obj_t arg1687_966;
						arg1687_966 =
						   get_cnst_offset_21_cnst_alloc();
						{	/* ./Ieee/fixnum.scm 7199 */
						   long aux_1911;
						   aux_1911 =
						      (long) CINT(arg1687_966);
						   arg1685_964 =
						      (aux_1911 - ((long) 1));
						}
					     }
					     {	/* ./Ieee/pair-list.scm 5689 */
						obj_t aux_1914;
						aux_1914 =
						   BINT(arg1685_964);
						arg1684_963 =
						   MAKE_PAIR(aux_1914, BNIL);
					     }
					  }
					  arg1681_960 =
					     MAKE_PAIR(arg1683_962, arg1684_963);
				       }
				       arg1625_906 =
					  MAKE_PAIR(arg1681_960, BNIL);
				    }
				    arg1623_904 =
				       MAKE_PAIR(arg1624_905, arg1625_906);
				 }
				 arg1620_901 =
				    MAKE_PAIR(arg1622_903, arg1623_904);
			      }
			      arg1604_885 =
				 MAKE_PAIR(arg1620_901, BNIL);
			   }
			   arg1602_883 =
			      MAKE_PAIR(arg1603_884, arg1604_885);
			}
			sexp_880 =
			   MAKE_PAIR(arg1601_882, arg1602_883);
		     }
		     {	/* Cnst/initialize.scm 155 */

			{	/* Cnst/initialize.scm 170 */
			   obj_t arg1600_881;
			   arg1600_881 =
			      get_cnst_sexp_197_cnst_alloc();
			   return
			      MAKE_PAIR(sexp_880, arg1600_881);
			}
		     }
		  }
	       }
	    }
	 }
      }
   }
}



/* method-init */
obj_t 
method_init_76_cnst_initialize()
{
   AN_OBJECT;
   {	/* Cnst/initialize.scm 14 */
      return BUNSPEC;
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_cnst_initialize()
{
   AN_OBJECT;
   {	/* Cnst/initialize.scm 14 */
      module_initialization_70_tools_trace(((long) 0), "CNST_INITIALIZE");
      module_initialization_70_tools_shape(((long) 0), "CNST_INITIALIZE");
      module_initialization_70_tools_speek(((long) 0), "CNST_INITIALIZE");
      module_initialization_70_tools_error(((long) 0), "CNST_INITIALIZE");
      module_initialization_70_engine_param(((long) 0), "CNST_INITIALIZE");
      module_initialization_70_type_type(((long) 0), "CNST_INITIALIZE");
      module_initialization_70_type_cache(((long) 0), "CNST_INITIALIZE");
      module_initialization_70_ast_var(((long) 0), "CNST_INITIALIZE");
      module_initialization_70_ast_node(((long) 0), "CNST_INITIALIZE");
      module_initialization_70_ast_env(((long) 0), "CNST_INITIALIZE");
      module_initialization_70_ast_build(((long) 0), "CNST_INITIALIZE");
      module_initialization_70_ast_lvtype(((long) 0), "CNST_INITIALIZE");
      module_initialization_70_coerce_coerce(((long) 0), "CNST_INITIALIZE");
      module_initialization_70_cnst_alloc(((long) 0), "CNST_INITIALIZE");
      return
	 module_initialization_70_cnst_node(((long) 0), "CNST_INITIALIZE");
   }
}
