/*===========================================================================*/
/*   (Cnst/node.scm)                                                         */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;

typedef struct local_bvalue_105
  {
     struct node *binding_value_3;
  }
                *local_bvalue_105_bglt;


static obj_t method_init_76_cnst_node();
extern obj_t make_box_202_ast_node;
static obj_t get_node_atom_value_default1534_92_cnst_node(node_bglt);
extern obj_t funcall_ast_node;
extern obj_t _bfalse__69_cnst_cache;
extern obj_t _string__bstring__114_cnst_cache;
extern long add_inlined_method__244___object(obj_t, obj_t, long);
extern obj_t fail_ast_node;
extern obj_t box_ref_242_ast_node;
extern obj_t _make_fx_procedure__51_cnst_cache;
extern obj_t sequence_ast_node;
extern node_bglt cnst_alloc_procedure_240_cnst_alloc(node_bglt, obj_t);
extern obj_t let_var_6_ast_node;
extern obj_t var_ast_node;
static obj_t get_node_atom_value_135_cnst_node(node_bglt);
extern obj_t closure_ast_node;
extern object_bglt struct_object__object_93___object(object_bglt, obj_t);
extern obj_t add_method__1___object(obj_t, obj_t, obj_t);
extern obj_t _btrue__29_cnst_cache;
extern obj_t pragma_ast_node;
extern obj_t set_ex_it_116_ast_node;
extern obj_t find_super_class_method_167___object(object_bglt, obj_t, obj_t);
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t module_initialization_70_cnst_node(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_speek(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_ast_env(long, char *);
extern obj_t module_initialization_70_cnst_cache(long, char *);
extern obj_t module_initialization_70_cnst_alloc(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
static obj_t _allocate_local_bvalue_102_cnst_node(obj_t);
static obj_t _cnst_1846_224_cnst_node(obj_t, obj_t);
extern obj_t _double__real__21_cnst_cache;
extern long class_num_218___object(obj_t);
extern obj_t let_fun_218_ast_node;
static obj_t imported_modules_init_94_cnst_node();
extern node_bglt cnst_alloc_list_56_cnst_alloc(obj_t, obj_t);
extern obj_t app_ly_162_ast_node;
extern obj_t add_generic__110___object(obj_t, obj_t);
extern node_bglt cnst_alloc_real_118_cnst_alloc(obj_t, obj_t);
static obj_t local_bvalue_105_cnst_node = BUNSPEC;
extern obj_t app_ast_node;
static obj_t library_modules_init_112_cnst_node();
extern obj_t make_struct(obj_t, long, obj_t);
static obj_t _get_node_atom_value1847_10_cnst_node(obj_t, obj_t);
extern obj_t atom_ast_node;
extern obj_t cast_ast_node;
static obj_t toplevel_init_63_cnst_node();
extern obj_t create_vector(long);
extern obj_t jump_ex_it_184_ast_node;
extern obj_t open_input_string(obj_t);
extern obj_t kwote_ast_node;
static obj_t cnst___82_cnst_node(obj_t);
extern obj_t setq_ast_node;
extern obj_t _bbool__55_type_cache;
extern node_bglt cnst_alloc_tvector_190_cnst_alloc(obj_t, obj_t);
static local_bglt allocate_local_bvalue_47_cnst_node();
extern obj_t box_set__221_ast_node;
static obj_t _cnst__default1490_122_cnst_node(obj_t, obj_t);
extern obj_t local_ast_var;
extern node_bglt cnst_alloc_string_41_cnst_alloc(obj_t, obj_t);
extern node_bglt cnst_alloc_symbol_123_cnst_alloc(obj_t, obj_t);
extern obj_t register_class__225___object(obj_t, obj_t, obj_t, long, obj_t, obj_t, obj_t);
extern obj_t shape_tools_shape(obj_t);
static node_bglt cnst__default1490_120_cnst_node(node_bglt);
extern obj_t internal_error_43_tools_error(obj_t, obj_t, obj_t);
static obj_t object_init_111_cnst_node();
static obj_t object__struct_local_bvalue1543_65_cnst_node(obj_t, obj_t);
extern obj_t _bool__bbool__85_cnst_cache;
extern obj_t _classes__134___object;
static obj_t struct_object__object_local_bvalue1545_149_cnst_node(obj_t, obj_t, obj_t);
extern obj_t select_ast_node;
extern obj_t _make_va_procedure__53_cnst_cache;
extern obj_t read___reader(obj_t);
static obj_t _get_node_atom_value_default1534_229_cnst_node(obj_t, obj_t);
extern obj_t object__struct_50___object(object_bglt);
extern node_bglt cnst_alloc_vector_65_cnst_alloc(obj_t, obj_t);
static obj_t require_initialization_114_cnst_node = BUNSPEC;
extern obj_t conditional_ast_node;
extern node_bglt cnst_alloc_keyword_47_cnst_alloc(obj_t, obj_t);
extern node_bglt cnst__44_cnst_node(node_bglt);
static obj_t cnst_init_137_cnst_node();
static obj_t __cnst[6];

DEFINE_STATIC_PROCEDURE(get_node_atom_value_default1534_env_29_cnst_node, _get_node_atom_value_default1534_229_cnst_node1860, _get_node_atom_value_default1534_229_cnst_node, 0L, 1);
DEFINE_STATIC_PROCEDURE(cnst__default1490_env_192_cnst_node, _cnst__default1490_122_cnst_node1861, _cnst__default1490_122_cnst_node, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc1849_cnst_node, struct_object__object_local_bvalue1545_149_cnst_node1862, struct_object__object_local_bvalue1545_149_cnst_node, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc1848_cnst_node, object__struct_local_bvalue1543_65_cnst_node1863, object__struct_local_bvalue1543_65_cnst_node, 0L, 1);
extern obj_t struct_object__object_env_209___object;
DEFINE_EXPORT_GENERIC(cnst__env_43_cnst_node, _cnst_1846_224_cnst_node1864, _cnst_1846_224_cnst_node, 0L, 1);
DEFINE_STATIC_GENERIC(get_node_atom_value_env_18_cnst_node, _get_node_atom_value1847_10_cnst_node1865, _get_node_atom_value1847_10_cnst_node, 0L, 1);
DEFINE_STRING(string1855_cnst_node, string1855_cnst_node1866, "(NO-ATOM-VALUE) CNST!-DEFAULT1490 READ A-TVECTOR LOCAL/BVALUE DONE ", 67);
DEFINE_STRING(string1854_cnst_node, string1854_cnst_node1867, "No method for this object", 25);
DEFINE_STRING(string1853_cnst_node, string1853_cnst_node1868, "Unexepected `closure' node", 26);
DEFINE_STRING(string1852_cnst_node, string1852_cnst_node1869, "cnst!", 5);
DEFINE_STRING(string1851_cnst_node, string1851_cnst_node1870, "Illegal expression", 18);
DEFINE_STRING(string1850_cnst_node, string1850_cnst_node1871, "cnst-quote", 10);
extern obj_t object__struct_env_210___object;
DEFINE_STATIC_PROCEDURE(allocate_local_bvalue_env_61_cnst_node, _allocate_local_bvalue_102_cnst_node1872, _allocate_local_bvalue_102_cnst_node, 0L, 0);



/* module-initialization */
obj_t 
module_initialization_70_cnst_node(long checksum_1784, char *from_1785)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_cnst_node))
	{
	   require_initialization_114_cnst_node =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_cnst_node();
	   cnst_init_137_cnst_node();
	   imported_modules_init_94_cnst_node();
	   object_init_111_cnst_node();
	   method_init_76_cnst_node();
	   toplevel_init_63_cnst_node();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_cnst_node()
{
   AN_OBJECT;
   {	/* Cnst/node.scm 15 */
      module_initialization_70___object(((long) 0), "CNST_NODE");
      module_initialization_70___reader(((long) 0), "CNST_NODE");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_cnst_node()
{
   AN_OBJECT;
   {	/* Cnst/node.scm 15 */
      {		/* Cnst/node.scm 15 */
	 obj_t cnst_port_138_1777;
	 cnst_port_138_1777 =
	    open_input_string(string1855_cnst_node);
	 {
	    long i_1778;
	    i_1778 = ((long) 5);
	  loop_1779:
	    {	/* Cnst/node.scm 15 */
	       bool_t test1856_1780;
	       test1856_1780 =
		  (i_1778 == ((long) -1));
	       if (test1856_1780)
		 {	/* Cnst/node.scm 15 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Cnst/node.scm 15 */
		    {	/* Cnst/node.scm 15 */
		       obj_t arg1857_1781;
		       {	/* Cnst/node.scm 15 */
			  obj_t list1858_1782;
			  list1858_1782 =
			     MAKE_PAIR(cnst_port_138_1777, BNIL);
			  arg1857_1781 =
			     read___reader(list1858_1782);
		       }
		       CNST_TABLE_SET(i_1778, arg1857_1781);
		    }
		    {	/* Cnst/node.scm 15 */
		       int aux_1783;
		       {	/* Cnst/node.scm 15 */
			  long aux_1803;
			  aux_1803 =
			     (i_1778 - ((long) 1));
			  aux_1783 =
			     (int) (aux_1803);
		       }
		       {
			  long i_1806;
			  i_1806 =
			     (long) (aux_1783);
			  i_1778 = i_1806;
			  goto loop_1779;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_cnst_node()
{
   AN_OBJECT;
   {	/* Cnst/node.scm 15 */
      return BUNSPEC;
   }
}



/* cnst*! */
obj_t 
cnst___82_cnst_node(obj_t nodes_33)
{
   AN_OBJECT;
   {	/* Cnst/node.scm 240 */
      {
	 obj_t hook_787;
	 hook_787 = nodes_33;
       loop_788:
	 if (
	    NULLP(hook_787))
	   {	/* Cnst/node.scm 242 */
	      return
		 CNST_TABLE_REF(((long) 0));
	   }
	 else
	   {	/* Cnst/node.scm 242 */
	      {		/* Cnst/node.scm 245 */
		 node_bglt arg1557_790;
		 {	/* Cnst/node.scm 245 */
		    node_bglt aux_1811;
		    {	/* Cnst/node.scm 245 */
		       obj_t aux_1812;
		       aux_1812 =
			  CAR(hook_787);
		       aux_1811 =
			  (node_bglt) (aux_1812);
		    }
		    arg1557_790 =
		       cnst__44_cnst_node(aux_1811);
		 }
		 {	/* ./Ieee/pair-list.scm 5890 */
		    obj_t aux_1816;
		    aux_1816 =
		       (obj_t) (arg1557_790);
		    SET_CAR(hook_787, aux_1816);
		 }
	      }
	      {
		 obj_t hook_1819;
		 hook_1819 =
		    CDR(hook_787);
		 hook_787 = hook_1819;
		 goto loop_788;
	      }
	   }
      }
   }
}



/* object-init */
obj_t 
object_init_111_cnst_node()
{
   AN_OBJECT;
   {	/* Cnst/node.scm 15 */
      {		/* Cnst/node.scm 15 */
	 obj_t arg1560_793;
	 obj_t arg1561_794;
	 obj_t arg1564_797;
	 arg1560_793 =
	    CNST_TABLE_REF(((long) 1));
	 arg1561_794 = local_ast_var;
	 {	/* Cnst/node.scm 15 */
	    obj_t v1489_798;
	    v1489_798 =
	       create_vector(((long) 0));
	    arg1564_797 = v1489_798;
	 }
	 local_bvalue_105_cnst_node =
	    register_class__225___object(arg1560_793, arg1561_794, allocate_local_bvalue_env_61_cnst_node, ((long) 36702), BUNSPEC, BFALSE, arg1564_797);
      }
      return BUNSPEC;
   }
}



/* allocate-local/bvalue */
local_bglt 
allocate_local_bvalue_47_cnst_node()
{
   AN_OBJECT;
   {	/* Cnst/node.scm 29 */
      {		/* Cnst/node.scm 29 */
	 local_bglt new1450_799;
	 new1450_799 =
	    ((local_bglt) BREF(GC_MALLOC(sizeof(struct local))));
	 {	/* Cnst/node.scm 29 */
	    long arg1565_800;
	    arg1565_800 =
	       class_num_218___object(local_bvalue_105_cnst_node);
	    {	/* Cnst/node.scm 29 */
	       obj_t obj_1414;
	       obj_1414 =
		  (obj_t) (new1450_799);
	       (((obj_t) CREF(obj_1414))->header = MAKE_HEADER(arg1565_800, 0), BUNSPEC);
	    }
	 }
	 {	/* Cnst/node.scm 29 */
	    object_bglt aux_1828;
	    aux_1828 =
	       (object_bglt) (new1450_799);
	    OBJECT_WIDENING_SET(aux_1828, BFALSE);
	 }
	 return new1450_799;
      }
   }
}



/* _allocate-local/bvalue */
obj_t 
_allocate_local_bvalue_102_cnst_node(obj_t env_1755)
{
   AN_OBJECT;
   {	/* Cnst/node.scm 29 */
      {		/* Cnst/node.scm 29 */
	 local_bglt aux_1831;
	 aux_1831 =
	    allocate_local_bvalue_47_cnst_node();
	 return
	    (obj_t) (aux_1831);
      }
   }
}



/* method-init */
obj_t 
method_init_76_cnst_node()
{
   AN_OBJECT;
   {	/* Cnst/node.scm 15 */
      add_generic__110___object(cnst__env_43_cnst_node, cnst__default1490_env_192_cnst_node);
      add_inlined_method__244___object(cnst__env_43_cnst_node, atom_ast_node, ((long) 0));
      add_inlined_method__244___object(cnst__env_43_cnst_node, kwote_ast_node, ((long) 1));
      add_inlined_method__244___object(cnst__env_43_cnst_node, var_ast_node, ((long) 2));
      add_inlined_method__244___object(cnst__env_43_cnst_node, closure_ast_node, ((long) 3));
      add_inlined_method__244___object(cnst__env_43_cnst_node, sequence_ast_node, ((long) 4));
      add_inlined_method__244___object(cnst__env_43_cnst_node, pragma_ast_node, ((long) 5));
      add_inlined_method__244___object(cnst__env_43_cnst_node, cast_ast_node, ((long) 6));
      add_inlined_method__244___object(cnst__env_43_cnst_node, setq_ast_node, ((long) 7));
      add_inlined_method__244___object(cnst__env_43_cnst_node, conditional_ast_node, ((long) 8));
      add_inlined_method__244___object(cnst__env_43_cnst_node, fail_ast_node, ((long) 9));
      add_inlined_method__244___object(cnst__env_43_cnst_node, select_ast_node, ((long) 10));
      add_inlined_method__244___object(cnst__env_43_cnst_node, let_fun_218_ast_node, ((long) 11));
      add_inlined_method__244___object(cnst__env_43_cnst_node, let_var_6_ast_node, ((long) 12));
      add_inlined_method__244___object(cnst__env_43_cnst_node, set_ex_it_116_ast_node, ((long) 13));
      add_inlined_method__244___object(cnst__env_43_cnst_node, jump_ex_it_184_ast_node, ((long) 14));
      add_inlined_method__244___object(cnst__env_43_cnst_node, make_box_202_ast_node, ((long) 15));
      add_inlined_method__244___object(cnst__env_43_cnst_node, box_ref_242_ast_node, ((long) 16));
      add_inlined_method__244___object(cnst__env_43_cnst_node, box_set__221_ast_node, ((long) 17));
      add_inlined_method__244___object(cnst__env_43_cnst_node, app_ly_162_ast_node, ((long) 18));
      add_inlined_method__244___object(cnst__env_43_cnst_node, funcall_ast_node, ((long) 19));
      add_inlined_method__244___object(cnst__env_43_cnst_node, app_ast_node, ((long) 20));
      add_generic__110___object(get_node_atom_value_env_18_cnst_node, get_node_atom_value_default1534_env_29_cnst_node);
      add_inlined_method__244___object(get_node_atom_value_env_18_cnst_node, atom_ast_node, ((long) 0));
      add_inlined_method__244___object(get_node_atom_value_env_18_cnst_node, var_ast_node, ((long) 1));
      {		/* Cnst/node.scm 15 */
	 obj_t object__struct_local_bvalue1543_65_1760;
	 object__struct_local_bvalue1543_65_1760 = proc1848_cnst_node;
	 add_method__1___object(object__struct_env_210___object, local_bvalue_105_cnst_node, object__struct_local_bvalue1543_65_1760);
      }
      {		/* Cnst/node.scm 15 */
	 obj_t struct_object__object_local_bvalue1545_149_1756;
	 struct_object__object_local_bvalue1545_149_1756 = proc1849_cnst_node;
	 return
	    add_method__1___object(struct_object__object_env_209___object, local_bvalue_105_cnst_node, struct_object__object_local_bvalue1545_149_1756);
      }
   }
}



/* struct+object->object-local/bvalue1545 */
obj_t 
struct_object__object_local_bvalue1545_149_cnst_node(obj_t env_1763, obj_t o_1764, obj_t s_1765)
{
   AN_OBJECT;
   {	/* Cnst/node.scm 29 */
      {
	 local_bvalue_105_bglt o_1143;
	 obj_t s_1144;
	 {	/* Cnst/node.scm 29 */
	    local_bvalue_105_bglt aux_1861;
	    o_1143 =
	       (local_bvalue_105_bglt) (o_1764);
	    s_1144 = s_1765;
	    {

	       {	/* Cnst/node.scm 29 */
		  obj_t old1456_1147;
		  obj_t aux1457_1148;
		  {	/* Cnst/node.scm 29 */
		     obj_t next_method1544_93_1153;
		     next_method1544_93_1153 =
			find_super_class_method_167___object(
			(object_bglt) (o_1143), struct_object__object_env_209___object, local_bvalue_105_cnst_node);
		     if (
			PROCEDUREP(next_method1544_93_1153))
		       {	/* Cnst/node.scm 29 */
			  old1456_1147 =
			     PROCEDURE_ENTRY(next_method1544_93_1153) (next_method1544_93_1153,
			     (obj_t) (o_1143), s_1144, BEOA);
		       }
		     else
		       {	/* Cnst/node.scm 29 */
			  PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method1544_93_1153);
			  {	/* Cnst/node.scm 29 */
			     object_bglt aux_1870;
			     aux_1870 =
				struct_object__object_93___object(
				(object_bglt) (o_1143), s_1144);
			     old1456_1147 =
				(obj_t) (aux_1870);
			  }
		       }
		  }
		  aux1457_1148 =
		     STRUCT_REF(s_1144, ((long) 0));
		  {	/* Cnst/node.scm 29 */
		     local_bvalue_105_bglt new1458_1149;
		     new1458_1149 =
			((local_bvalue_105_bglt) (old1456_1147));
		     {	/* Cnst/node.scm 29 */
			long arg1646_1150;
			arg1646_1150 =
			   class_num_218___object(local_bvalue_105_cnst_node);
			{	/* Cnst/node.scm 29 */
			   obj_t obj_1465;
			   obj_1465 =
			      (obj_t) (new1458_1149);
			   (((obj_t) CREF(obj_1465))->header = MAKE_HEADER(arg1646_1150, 0), BUNSPEC);
			}
		     }
		     {	/* Cnst/node.scm 29 */
			local_bvalue_105_bglt arg1647_1151;
			{	/* Cnst/node.scm 29 */
			   local_bvalue_105_bglt res1834_1472;
			   {	/* Cnst/node.scm 29 */
			      node_bglt binding_value_3_1469;
			      {		/* Cnst/node.scm 29 */
				 obj_t aux_1879;
				 aux_1879 =
				    STRUCT_REF(aux1457_1148, ((long) 0));
				 binding_value_3_1469 =
				    (node_bglt) (aux_1879);
			      }
			      {		/* Cnst/node.scm 29 */
				 local_bvalue_105_bglt new1445_1470;
				 new1445_1470 =
				    ((local_bvalue_105_bglt) BREF(GC_MALLOC(sizeof(struct local_bvalue_105))));
				 ((((local_bvalue_105_bglt) CREF(new1445_1470))->binding_value_3) = ((node_bglt) binding_value_3_1469), BUNSPEC);
				 res1834_1472 = new1445_1470;
			      }
			   }
			   arg1647_1151 = res1834_1472;
			}
			{	/* Cnst/node.scm 29 */
			   obj_t aux_1886;
			   object_bglt aux_1884;
			   aux_1886 =
			      (obj_t) (arg1647_1151);
			   aux_1884 =
			      (object_bglt) (new1458_1149);
			   OBJECT_WIDENING_SET(aux_1884, aux_1886);
			}
		     }
		     aux_1861 = new1458_1149;
		  }
	       }
	    }
	    return
	       (obj_t) (aux_1861);
	 }
      }
   }
}



/* object->struct-local/bvalue1543 */
obj_t 
object__struct_local_bvalue1543_65_cnst_node(obj_t env_1766, obj_t obj1453_1767)
{
   AN_OBJECT;
   {	/* Cnst/node.scm 29 */
      {
	 local_bvalue_105_bglt obj1453_1133;
	 obj1453_1133 =
	    (local_bvalue_105_bglt) (obj1453_1767);
	 {

	    {	/* Cnst/node.scm 29 */
	       obj_t res1454_1136;
	       {	/* Cnst/node.scm 29 */
		  obj_t next_method1542_3_1141;
		  next_method1542_3_1141 =
		     find_super_class_method_167___object(
		     (object_bglt) (obj1453_1133), object__struct_env_210___object, local_bvalue_105_cnst_node);
		  if (
		     PROCEDUREP(next_method1542_3_1141))
		    {	/* Cnst/node.scm 29 */
		       res1454_1136 =
			  PROCEDURE_ENTRY(next_method1542_3_1141) (next_method1542_3_1141,
			  (obj_t) (obj1453_1133), BEOA);
		    }
		  else
		    {	/* Cnst/node.scm 29 */
		       PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method1542_3_1141);
		       res1454_1136 =
			  object__struct_50___object(
			  (object_bglt) (obj1453_1133));
		    }
	       }
	       {	/* Cnst/node.scm 29 */
		  obj_t aux1455_1137;
		  {	/* ./Llib/struct.scm 1415 */
		     obj_t aux_1901;
		     aux_1901 =
			CNST_TABLE_REF(((long) 1));
		     aux1455_1137 =
			make_struct(aux_1901, ((long) 1), BUNSPEC);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_1904;
		     {	/* Cnst/node.scm 29 */
			node_bglt aux_1905;
			{
			   obj_t aux_1906;
			   {	/* Cnst/node.scm 30 */
			      object_bglt aux_1907;
			      aux_1907 =
				 (object_bglt) (obj1453_1133);
			      aux_1906 =
				 OBJECT_WIDENING(aux_1907);
			   }
			   aux_1905 =
			      (((local_bvalue_105_bglt) CREF(aux_1906))->binding_value_3);
			}
			aux_1904 =
			   (obj_t) (aux_1905);
		     }
		     STRUCT_SET(aux1455_1137, ((long) 0), aux_1904);
		  }
		  STRUCT_SET(res1454_1136, ((long) 0), aux1455_1137);
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_1914;
		     aux_1914 =
			STRUCT_KEY(res1454_1136);
		     STRUCT_KEY_SET(aux1455_1137, aux_1914);
		  }
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_1917;
		     aux_1917 =
			CNST_TABLE_REF(((long) 1));
		     STRUCT_KEY_SET(res1454_1136, aux_1917);
		  }
		  return res1454_1136;
	       }
	    }
	 }
      }
   }
}



/* cnst! */
node_bglt 
cnst__44_cnst_node(node_bglt node_11)
{
   AN_OBJECT;
   {	/* Cnst/node.scm 35 */
      {
	 obj_t method1672_1184;
	 obj_t class1677_1185;
	 {	/* Cnst/node.scm 35 */
	    obj_t arg1680_1182;
	    obj_t arg1681_1183;
	    {	/* Cnst/node.scm 35 */
	       object_bglt obj_1475;
	       obj_1475 =
		  (object_bglt) (node_11);
	       {	/* ./Llib/object.scm 2926 */
		  obj_t pre_method_105_1476;
		  pre_method_105_1476 =
		     PROCEDURE_REF(cnst__env_43_cnst_node, ((long) 2));
		  if (
		     INTEGERP(pre_method_105_1476))
		    {	/* ./Llib/object.scm 2927 */
		       PROCEDURE_SET(cnst__env_43_cnst_node, ((long) 2), BUNSPEC);
		       arg1680_1182 = pre_method_105_1476;
		    }
		  else
		    {	/* ./Llib/object.scm 2914 */
		       long obj_class_num_177_1481;
		       obj_class_num_177_1481 =
			  TYPE(obj_1475);
		       {	/* ./Llib/object.scm 2915 */
			  obj_t arg1176_1482;
			  arg1176_1482 =
			     PROCEDURE_REF(cnst__env_43_cnst_node, ((long) 1));
			  {	/* ./Llib/object.scm 2738 */
			     long arg1177_1486;
			     {	/* ./Llib/object.scm 2738 */
				long arg1178_1487;
				arg1178_1487 =
				   OBJECT_TYPE;
				arg1177_1486 =
				   (obj_class_num_177_1481 - arg1178_1487);
			     }
			     arg1680_1182 =
				VECTOR_REF(arg1176_1482, arg1177_1486);
			  }
		       }
		    }
	       }
	    }
	    {	/* Cnst/node.scm 35 */
	       object_bglt object_1492;
	       object_1492 =
		  (object_bglt) (node_11);
	       {	/* ./Llib/object.scm 2695 */
		  long arg1179_1493;
		  {	/* ./Llib/object.scm 2695 */
		     long arg1180_1494;
		     long arg1181_1495;
		     arg1180_1494 =
			TYPE(object_1492);
		     arg1181_1495 =
			OBJECT_TYPE;
		     arg1179_1493 =
			(arg1180_1494 - arg1181_1495);
		  }
		  {	/* ./Llib/object.scm 2695 */
		     obj_t vector_1499;
		     vector_1499 = _classes__134___object;
		     arg1681_1183 =
			VECTOR_REF(vector_1499, arg1179_1493);
		  }
	       }
	    }
	    {	/* Cnst/node.scm 35 */
	       obj_t aux_1936;
	       method1672_1184 = arg1680_1182;
	       class1677_1185 = arg1681_1183;
	       {

		  if (
		     INTEGERP(method1672_1184))
		    {	/* Cnst/node.scm 35 */
		       switch (
			  (long) CINT(method1672_1184))
			 {
			 case ((long) 0):

			    {	/* Cnst/node.scm 41 */
			       atom_bglt node_1191;
			       node_1191 =
				  (atom_bglt) (node_11);
			       {	/* Cnst/node.scm 43 */
				  bool_t test_1940;
				  {	/* ./Ieee/symbol.scm 6131 */
				     obj_t aux_1941;
				     aux_1941 =
					(((atom_bglt) CREF(node_1191))->value);
				     test_1940 =
					KEYWORDP(aux_1941);
				  }
				  if (test_1940)
				    {	/* Cnst/node.scm 43 */
				       {	/* Cnst/node.scm 44 */
					  node_bglt aux_1944;
					  aux_1944 =
					     cnst_alloc_keyword_47_cnst_alloc(
					     (((atom_bglt) CREF(node_1191))->value),
					     (((atom_bglt) CREF(node_1191))->loc));
					  aux_1936 =
					     (obj_t) (aux_1944);
				       }
				    }
				  else
				    {	/* Cnst/node.scm 43 */
				       aux_1936 =
					  (obj_t) (node_1191);
				    }
			       }
			    }
			    break;
			 case ((long) 1):

			    {	/* Cnst/node.scm 52 */
			       kwote_bglt node_1197;
			       node_1197 =
				  (kwote_bglt) (node_11);
			       {	/* Cnst/node.scm 54 */
				  bool_t test_1951;
				  {	/* ./Ieee/symbol.scm 6015 */
				     obj_t aux_1952;
				     aux_1952 =
					(((kwote_bglt) CREF(node_1197))->value);
				     test_1951 =
					SYMBOLP(aux_1952);
				  }
				  if (test_1951)
				    {	/* Cnst/node.scm 54 */
				       {	/* Cnst/node.scm 55 */
					  node_bglt aux_1955;
					  aux_1955 =
					     cnst_alloc_symbol_123_cnst_alloc(
					     (((kwote_bglt) CREF(node_1197))->value),
					     (((kwote_bglt) CREF(node_1197))->loc));
					  aux_1936 =
					     (obj_t) (aux_1955);
				       }
				    }
				  else
				    {	/* Cnst/node.scm 56 */
				       bool_t test_1960;
				       {	/* ./Ieee/symbol.scm 6131 */
					  obj_t aux_1961;
					  aux_1961 =
					     (((kwote_bglt) CREF(node_1197))->value);
					  test_1960 =
					     KEYWORDP(aux_1961);
				       }
				       if (test_1960)
					 {	/* Cnst/node.scm 56 */
					    {	/* Cnst/node.scm 57 */
					       node_bglt aux_1964;
					       aux_1964 =
						  cnst_alloc_keyword_47_cnst_alloc(
						  (((kwote_bglt) CREF(node_1197))->value),
						  (((kwote_bglt) CREF(node_1197))->loc));
					       aux_1936 =
						  (obj_t) (aux_1964);
					    }
					 }
				       else
					 {	/* Cnst/node.scm 58 */
					    bool_t test_1969;
					    {	/* ./Ieee/pair-list.scm 5669 */
					       obj_t aux_1970;
					       aux_1970 =
						  (((kwote_bglt) CREF(node_1197))->value);
					       test_1969 =
						  PAIRP(aux_1970);
					    }
					    if (test_1969)
					      {		/* Cnst/node.scm 58 */
						 {	/* Cnst/node.scm 59 */
						    node_bglt aux_1973;
						    aux_1973 =
						       cnst_alloc_list_56_cnst_alloc(
						       (((kwote_bglt) CREF(node_1197))->value),
						       (((kwote_bglt) CREF(node_1197))->loc));
						    aux_1936 =
						       (obj_t) (aux_1973);
						 }
					      }
					    else
					      {		/* Cnst/node.scm 60 */
						 bool_t test_1978;
						 {	/* ./Ieee/vector.scm 8420 */
						    obj_t aux_1979;
						    aux_1979 =
						       (((kwote_bglt) CREF(node_1197))->value);
						    test_1978 =
						       VECTORP(aux_1979);
						 }
						 if (test_1978)
						   {	/* Cnst/node.scm 60 */
						      {		/* Cnst/node.scm 61 */
							 node_bglt aux_1982;
							 aux_1982 =
							    cnst_alloc_vector_65_cnst_alloc(
							    (((kwote_bglt) CREF(node_1197))->value),
							    (((kwote_bglt) CREF(node_1197))->loc));
							 aux_1936 =
							    (obj_t) (aux_1982);
						      }
						   }
						 else
						   {	/* Cnst/node.scm 62 */
						      bool_t test_1987;
						      {		/* ./Ieee/string.scm 8047 */
							 obj_t aux_1988;
							 aux_1988 =
							    (((kwote_bglt) CREF(node_1197))->value);
							 test_1987 =
							    STRINGP(aux_1988);
						      }
						      if (test_1987)
							{	/* Cnst/node.scm 62 */
							   {	/* Cnst/node.scm 63 */
							      node_bglt aux_1991;
							      aux_1991 =
								 cnst_alloc_string_41_cnst_alloc(
								 (((kwote_bglt) CREF(node_1197))->value),
								 (((kwote_bglt) CREF(node_1197))->loc));
							      aux_1936 =
								 (obj_t) (aux_1991);
							   }
							}
						      else
							{	/* Cnst/node.scm 64 */
							   bool_t test_1996;
							   {	/* Cnst/node.scm 64 */
							      obj_t arg1723_1233;
							      arg1723_1233 =
								 (((kwote_bglt) CREF(node_1197))->value);
							      if (
								 STRUCTP(arg1723_1233))
								{	/* ./Ieee/equiv.scm 5508 */
								   obj_t aux_2002;
								   obj_t aux_2000;
								   aux_2002 =
								      CNST_TABLE_REF(((long) 2));
								   aux_2000 =
								      STRUCT_KEY(arg1723_1233);
								   test_1996 =
								      (aux_2000 == aux_2002);
								}
							      else
								{	/* ./Tvector/tvector.sch 606 */
								   test_1996 = ((bool_t) 0)
								      ;
								}
							   }
							   if (test_1996)
							     {	/* Cnst/node.scm 64 */
								{	/* Cnst/node.scm 65 */
								   node_bglt aux_2005;
								   aux_2005 =
								      cnst_alloc_tvector_190_cnst_alloc(
								      (((kwote_bglt) CREF(node_1197))->value),
								      (((kwote_bglt) CREF(node_1197))->loc));
								   aux_1936 =
								      (obj_t) (aux_2005);
								}
							     }
							   else
							     {	/* Cnst/node.scm 66 */
								bool_t test_2010;
								{	/* Cnst/node.scm 66 */
								   bool_t test_2011;
								   {	/* ./Ieee/char.scm 7769 */
								      obj_t aux_2012;
								      aux_2012 =
									 (((kwote_bglt) CREF(node_1197))->value);
								      test_2011 =
									 CHARP(aux_2012);
								   }
								   if (test_2011)
								     {	/* Cnst/node.scm 66 */
									test_2010 = ((bool_t) 1)
									   ;
								     }
								   else
								     {	/* Cnst/node.scm 67 */
									bool_t test_2015;
									{	/* ./Ieee/fixnum.scm 7079 */
									   obj_t aux_2016;
									   aux_2016 =
									      (((kwote_bglt) CREF(node_1197))->value);
									   test_2015 =
									      INTEGERP(aux_2016);
									}
									if (test_2015)
									  {	/* Cnst/node.scm 67 */
									     test_2010 = ((bool_t) 1)
										;
									  }
									else
									  {	/* Cnst/node.scm 68 */
									     bool_t test_2019;
									     {	/* ./Ieee/boolean.scm 5452 */
										obj_t aux_2020;
										aux_2020 =
										   (((kwote_bglt) CREF(node_1197))->value);
										test_2019 =
										   BOOLEANP(aux_2020);
									     }
									     if (test_2019)
									       {	/* Cnst/node.scm 68 */
										  test_2010 = ((bool_t) 1)
										     ;
									       }
									     else
									       {	/* Cnst/node.scm 69 */
										  bool_t test_2023;
										  {	/* Cnst/node.scm 69 */
										     obj_t arg1719_1229;
										     arg1719_1229 =
											(((kwote_bglt) CREF(node_1197))->value);
										     if (
											INTEGERP(arg1719_1229))
										       {	/* ./Ieee/flonum.scm 7393 */
											  test_2023 = ((bool_t) 1)
											     ;
										       }
										     else
										       {	/* ./Ieee/flonum.scm 7393 */
											  test_2023 =
											     REALP(arg1719_1229)
											     ;
										       }
										  }
										  if (test_2023)
										    {	/* Cnst/node.scm 69 */
										       test_2010 = ((bool_t) 1)
											  ;
										    }
										  else
										    {	/* ./Llib/bigloo.scm 945 */
										       obj_t aux_2028;
										       aux_2028 =
											  (((kwote_bglt) CREF(node_1197))->value);
										       test_2010 =
											  CNSTP(aux_2028);
										    }
									       }
									  }
								     }
								}
								if (test_2010)
								  {	/* Cnst/node.scm 66 */
								     {	/* Cnst/node.scm 71 */
									obj_t arg1707_1218;
									type_bglt arg1708_1219;
									obj_t arg1709_1220;
									arg1707_1218 =
									   (((kwote_bglt) CREF(node_1197))->loc);
									arg1708_1219 =
									   (((kwote_bglt) CREF(node_1197))->type);
									arg1709_1220 =
									   (((kwote_bglt) CREF(node_1197))->value);
									{	/* Cnst/node.scm 71 */
									   atom_bglt res1836_1561;
									   {	/* ./Ast/node.scm 1057 */
									      atom_bglt new1202_1554;
									      new1202_1554 =
										 ((atom_bglt) BREF(GC_MALLOC(sizeof(struct atom))));
									      {		/* ./Ast/node.scm 1057 */
										 long arg1612_1555;
										 arg1612_1555 =
										    class_num_218___object(atom_ast_node);
										 {	/* ./Ast/node.scm 1057 */
										    obj_t obj_1559;
										    obj_1559 =
										       (obj_t) (new1202_1554);
										    (((obj_t) CREF(obj_1559))->header = MAKE_HEADER(arg1612_1555, 0), BUNSPEC);
										 }
									      }
									      {		/* ./Ast/node.scm 1057 */
										 object_bglt aux_2038;
										 aux_2038 =
										    (object_bglt) (new1202_1554);
										 OBJECT_WIDENING_SET(aux_2038, BFALSE);
									      }
									      ((((atom_bglt) CREF(new1202_1554))->loc) = ((obj_t) arg1707_1218), BUNSPEC);
									      ((((atom_bglt) CREF(new1202_1554))->type) = ((type_bglt) arg1708_1219), BUNSPEC);
									      ((((atom_bglt) CREF(new1202_1554))->value) = ((obj_t) arg1709_1220), BUNSPEC);
									      res1836_1561 = new1202_1554;
									   }
									   aux_1936 =
									      (obj_t) (res1836_1561);
									}
								     }
								  }
								else
								  {	/* Cnst/node.scm 66 */
								     {	/* Cnst/node.scm 73 */
									obj_t arg1713_1223;
									arg1713_1223 =
									   shape_tools_shape(
									   (obj_t) (node_1197));
									aux_1936 =
									   internal_error_43_tools_error(string1850_cnst_node, string1851_cnst_node, arg1713_1223);
								     }
								  }
							     }
							}
						   }
					      }
					 }
				    }
			       }
			    }
			    break;
			 case ((long) 2):

			    {	/* Cnst/node.scm 35 */
			       var_bglt aux_2048;
			       aux_2048 =
				  (var_bglt) (node_11);
			       aux_1936 =
				  (obj_t) (aux_2048);
			    }
			    break;
			 case ((long) 3):

			    {	/* Cnst/node.scm 85 */
			       obj_t arg1731_1243;
			       {	/* Cnst/node.scm 85 */
				  obj_t aux_2051;
				  {	/* Cnst/node.scm 85 */
				     closure_bglt aux_2052;
				     aux_2052 =
					(closure_bglt) (node_11);
				     aux_2051 =
					(obj_t) (aux_2052);
				  }
				  arg1731_1243 =
				     shape_tools_shape(aux_2051);
			       }
			       aux_1936 =
				  internal_error_43_tools_error(string1852_cnst_node, string1853_cnst_node, arg1731_1243);
			    }
			    break;
			 case ((long) 4):

			    {	/* Cnst/node.scm 91 */
			       sequence_bglt node_1244;
			       node_1244 =
				  (sequence_bglt) (node_11);
			       cnst___82_cnst_node(
				  (((sequence_bglt) CREF(node_1244))->nodes));
			       aux_1936 =
				  (obj_t) (node_1244);
			    }
			    break;
			 case ((long) 5):

			    {	/* Cnst/node.scm 99 */
			       pragma_bglt node_1247;
			       node_1247 =
				  (pragma_bglt) (node_11);
			       cnst___82_cnst_node(
				  (((pragma_bglt) CREF(node_1247))->args));
			       aux_1936 =
				  (obj_t) (node_1247);
			    }
			    break;
			 case ((long) 6):

			    {	/* Cnst/node.scm 107 */
			       cast_bglt node_1250;
			       node_1250 =
				  (cast_bglt) (node_11);
			       cnst__44_cnst_node(
				  (((cast_bglt) CREF(node_1250))->arg));
			       aux_1936 =
				  (obj_t) (node_1250);
			    }
			    break;
			 case ((long) 7):

			    {	/* Cnst/node.scm 115 */
			       setq_bglt node_1253;
			       node_1253 =
				  (setq_bglt) (node_11);
			       {	/* Cnst/node.scm 116 */
				  node_bglt arg1735_1255;
				  arg1735_1255 =
				     cnst__44_cnst_node(
				     (((setq_bglt) CREF(node_1253))->value));
				  ((((setq_bglt) CREF(node_1253))->value) = ((node_bglt) arg1735_1255), BUNSPEC);
			       }
			       aux_1936 =
				  (obj_t) (node_1253);
			    }
			    break;
			 case ((long) 8):

			    {	/* Cnst/node.scm 123 */
			       conditional_bglt node_1257;
			       node_1257 =
				  (conditional_bglt) (node_11);
			       {	/* Cnst/node.scm 124 */
				  node_bglt arg1738_1259;
				  arg1738_1259 =
				     cnst__44_cnst_node(
				     (((conditional_bglt) CREF(node_1257))->test));
				  ((((conditional_bglt) CREF(node_1257))->test) = ((node_bglt) arg1738_1259), BUNSPEC);
			       }
			       {	/* Cnst/node.scm 125 */
				  node_bglt arg1740_1261;
				  arg1740_1261 =
				     cnst__44_cnst_node(
				     (((conditional_bglt) CREF(node_1257))->true));
				  ((((conditional_bglt) CREF(node_1257))->true) = ((node_bglt) arg1740_1261), BUNSPEC);
			       }
			       {	/* Cnst/node.scm 126 */
				  node_bglt arg1742_1263;
				  arg1742_1263 =
				     cnst__44_cnst_node(
				     (((conditional_bglt) CREF(node_1257))->false));
				  ((((conditional_bglt) CREF(node_1257))->false) = ((node_bglt) arg1742_1263), BUNSPEC);
			       }
			       aux_1936 =
				  (obj_t) (node_1257);
			    }
			    break;
			 case ((long) 9):

			    {	/* Cnst/node.scm 133 */
			       fail_bglt node_1265;
			       node_1265 =
				  (fail_bglt) (node_11);
			       {	/* Cnst/node.scm 134 */
				  node_bglt arg1744_1267;
				  arg1744_1267 =
				     cnst__44_cnst_node(
				     (((fail_bglt) CREF(node_1265))->proc));
				  ((((fail_bglt) CREF(node_1265))->proc) = ((node_bglt) arg1744_1267), BUNSPEC);
			       }
			       {	/* Cnst/node.scm 135 */
				  node_bglt arg1746_1269;
				  arg1746_1269 =
				     cnst__44_cnst_node(
				     (((fail_bglt) CREF(node_1265))->msg));
				  ((((fail_bglt) CREF(node_1265))->msg) = ((node_bglt) arg1746_1269), BUNSPEC);
			       }
			       {	/* Cnst/node.scm 136 */
				  node_bglt arg1748_1271;
				  arg1748_1271 =
				     cnst__44_cnst_node(
				     (((fail_bglt) CREF(node_1265))->obj));
				  ((((fail_bglt) CREF(node_1265))->obj) = ((node_bglt) arg1748_1271), BUNSPEC);
			       }
			       aux_1936 =
				  (obj_t) (node_1265);
			    }
			    break;
			 case ((long) 10):

			    {	/* Cnst/node.scm 143 */
			       select_bglt node_1273;
			       node_1273 =
				  (select_bglt) (node_11);
			       {	/* Cnst/node.scm 144 */
				  node_bglt arg1750_1275;
				  arg1750_1275 =
				     cnst__44_cnst_node(
				     (((select_bglt) CREF(node_1273))->test));
				  ((((select_bglt) CREF(node_1273))->test) = ((node_bglt) arg1750_1275), BUNSPEC);
			       }
			       {
				  obj_t l1469_1277;
				  l1469_1277 =
				     (((select_bglt) CREF(node_1273))->clauses);
				lname1470_1278:
				  if (
				     PAIRP(l1469_1277))
				    {	/* Cnst/node.scm 145 */
				       {	/* Cnst/node.scm 146 */
					  obj_t clause_1281;
					  clause_1281 =
					     CAR(l1469_1277);
					  {	/* Cnst/node.scm 146 */
					     node_bglt arg1754_1282;
					     {	/* Cnst/node.scm 146 */
						node_bglt aux_2103;
						{	/* Cnst/node.scm 146 */
						   obj_t aux_2104;
						   aux_2104 =
						      CDR(clause_1281);
						   aux_2103 =
						      (node_bglt) (aux_2104);
						}
						arg1754_1282 =
						   cnst__44_cnst_node(aux_2103);
					     }
					     {	/* ./Ieee/pair-list.scm 5896 */
						obj_t aux_2108;
						aux_2108 =
						   (obj_t) (arg1754_1282);
						SET_CDR(clause_1281, aux_2108);
					     }
					  }
				       }
				       {
					  obj_t l1469_2111;
					  l1469_2111 =
					     CDR(l1469_1277);
					  l1469_1277 = l1469_2111;
					  goto lname1470_1278;
				       }
				    }
				  else
				    {	/* Cnst/node.scm 145 */
				       ((bool_t) 1);
				    }
			       }
			       aux_1936 =
				  (obj_t) (node_1273);
			    }
			    break;
			 case ((long) 11):

			    {	/* Cnst/node.scm 154 */
			       let_fun_218_bglt node_1285;
			       node_1285 =
				  (let_fun_218_bglt) (node_11);
			       {
				  obj_t l1472_1287;
				  l1472_1287 =
				     (((let_fun_218_bglt) CREF(node_1285))->locals);
				lname1473_1288:
				  if (
				     PAIRP(l1472_1287))
				    {	/* Cnst/node.scm 155 */
				       {	/* Cnst/node.scm 156 */
					  value_bglt fun_1292;
					  {	/* Cnst/node.scm 156 */
					     local_bglt obj_1599;
					     {	/* Cnst/node.scm 156 */
						obj_t aux_2118;
						aux_2118 =
						   CAR(l1472_1287);
						obj_1599 =
						   (local_bglt) (aux_2118);
					     }
					     fun_1292 =
						(((local_bglt) CREF(obj_1599))->value);
					  }
					  {	/* Cnst/node.scm 157 */
					     node_bglt arg1760_1293;
					     {	/* Cnst/node.scm 157 */
						node_bglt aux_2122;
						{	/* Cnst/node.scm 157 */
						   obj_t aux_2123;
						   {	/* Cnst/node.scm 157 */
						      sfun_bglt obj_1600;
						      obj_1600 =
							 (sfun_bglt) (fun_1292);
						      aux_2123 =
							 (((sfun_bglt) CREF(obj_1600))->body);
						   }
						   aux_2122 =
						      (node_bglt) (aux_2123);
						}
						arg1760_1293 =
						   cnst__44_cnst_node(aux_2122);
					     }
					     {	/* Cnst/node.scm 157 */
						sfun_bglt obj_1601;
						obj_t val1123_1602;
						obj_1601 =
						   (sfun_bglt) (fun_1292);
						val1123_1602 =
						   (obj_t) (arg1760_1293);
						((((sfun_bglt) CREF(obj_1601))->body) = ((obj_t) val1123_1602), BUNSPEC);
					     }
					  }
				       }
				       {
					  obj_t l1472_2131;
					  l1472_2131 =
					     CDR(l1472_1287);
					  l1472_1287 = l1472_2131;
					  goto lname1473_1288;
				       }
				    }
				  else
				    {	/* Cnst/node.scm 155 */
				       ((bool_t) 1);
				    }
			       }
			       {	/* Cnst/node.scm 159 */
				  node_bglt arg1763_1296;
				  arg1763_1296 =
				     cnst__44_cnst_node(
				     (((let_fun_218_bglt) CREF(node_1285))->body));
				  ((((let_fun_218_bglt) CREF(node_1285))->body) = ((node_bglt) arg1763_1296), BUNSPEC);
			       }
			       aux_1936 =
				  (obj_t) (node_1285);
			    }
			    break;
			 case ((long) 12):

			    {	/* Cnst/node.scm 166 */
			       let_var_6_bglt node_1298;
			       node_1298 =
				  (let_var_6_bglt) (node_11);
			       {
				  obj_t l1475_1300;
				  l1475_1300 =
				     (((let_var_6_bglt) CREF(node_1298))->bindings);
				lname1476_1301:
				  if (
				     PAIRP(l1475_1300))
				    {	/* Cnst/node.scm 167 */
				       {	/* Cnst/node.scm 168 */
					  obj_t binding_1304;
					  binding_1304 =
					     CAR(l1475_1300);
					  {	/* Cnst/node.scm 168 */
					     obj_t var_1305;
					     var_1305 =
						CAR(binding_1304);
					     {	/* Cnst/node.scm 169 */
						node_bglt arg1767_1306;
						{	/* Cnst/node.scm 169 */
						   node_bglt aux_2143;
						   {	/* Cnst/node.scm 169 */
						      obj_t aux_2144;
						      aux_2144 =
							 CDR(binding_1304);
						      aux_2143 =
							 (node_bglt) (aux_2144);
						   }
						   arg1767_1306 =
						      cnst__44_cnst_node(aux_2143);
						}
						{	/* ./Ieee/pair-list.scm 5896 */
						   obj_t aux_2148;
						   aux_2148 =
						      (obj_t) (arg1767_1306);
						   SET_CDR(binding_1304, aux_2148);
						}
					     }
					     {	/* Cnst/node.scm 170 */
						bool_t test_2151;
						{	/* ./Ieee/equiv.scm 5508 */
						   obj_t aux_2155;
						   obj_t aux_2152;
						   aux_2155 =
						      CNST_TABLE_REF(((long) 3));
						   {	/* Cnst/node.scm 170 */
						      local_bglt obj_1614;
						      obj_1614 =
							 (local_bglt) (var_1305);
						      aux_2152 =
							 (((local_bglt) CREF(obj_1614))->access);
						   }
						   test_2151 =
						      (aux_2152 == aux_2155);
						}
						if (test_2151)
						  {	/* Cnst/node.scm 171 */
						     local_bvalue_105_bglt obj1478_1309;
						     obj1478_1309 =
							((local_bvalue_105_bglt) (var_1305));
						     {	/* Cnst/node.scm 172 */
							local_bvalue_105_bglt arg1770_1310;
							{	/* Cnst/node.scm 171 */
							   local_bvalue_105_bglt res1837_1621;
							   {	/* Cnst/node.scm 171 */
							      node_bglt binding_value_3_1618;
							      {		/* Cnst/node.scm 171 */
								 obj_t aux_2159;
								 aux_2159 =
								    CDR(binding_1304);
								 binding_value_3_1618 =
								    (node_bglt) (aux_2159);
							      }
							      {		/* Cnst/node.scm 29 */
								 local_bvalue_105_bglt new1445_1619;
								 new1445_1619 =
								    ((local_bvalue_105_bglt) BREF(GC_MALLOC(sizeof(struct local_bvalue_105))));
								 ((((local_bvalue_105_bglt) CREF(new1445_1619))->binding_value_3) = ((node_bglt) binding_value_3_1618), BUNSPEC);
								 res1837_1621 = new1445_1619;
							      }
							   }
							   arg1770_1310 = res1837_1621;
							}
							{	/* Cnst/node.scm 171 */
							   obj_t aux_2166;
							   object_bglt aux_2164;
							   aux_2166 =
							      (obj_t) (arg1770_1310);
							   aux_2164 =
							      (object_bglt) (obj1478_1309);
							   OBJECT_WIDENING_SET(aux_2164, aux_2166);
							}
						     }
						     {	/* Cnst/node.scm 171 */
							long arg1772_1312;
							arg1772_1312 =
							   class_num_218___object(local_bvalue_105_cnst_node);
							{	/* Cnst/node.scm 171 */
							   obj_t obj_1622;
							   obj_1622 =
							      (obj_t) (obj1478_1309);
							   (((obj_t) CREF(obj_1622))->header = MAKE_HEADER(arg1772_1312, 0), BUNSPEC);
							}
						     }
						     (obj_t) (obj1478_1309);
						  }
						else
						  {	/* Cnst/node.scm 170 */
						     BUNSPEC;
						  }
					     }
					  }
				       }
				       {
					  obj_t l1475_2173;
					  l1475_2173 =
					     CDR(l1475_1300);
					  l1475_1300 = l1475_2173;
					  goto lname1476_1301;
				       }
				    }
				  else
				    {	/* Cnst/node.scm 167 */
				       ((bool_t) 1);
				    }
			       }
			       {	/* Cnst/node.scm 174 */
				  node_bglt arg1776_1316;
				  arg1776_1316 =
				     cnst__44_cnst_node(
				     (((let_var_6_bglt) CREF(node_1298))->body));
				  ((((let_var_6_bglt) CREF(node_1298))->body) = ((node_bglt) arg1776_1316), BUNSPEC);
			       }
			       aux_1936 =
				  (obj_t) (node_1298);
			    }
			    break;
			 case ((long) 13):

			    {	/* Cnst/node.scm 181 */
			       set_ex_it_116_bglt node_1318;
			       node_1318 =
				  (set_ex_it_116_bglt) (node_11);
			       {	/* Cnst/node.scm 182 */
				  node_bglt arg1778_1320;
				  arg1778_1320 =
				     cnst__44_cnst_node(
				     (((set_ex_it_116_bglt) CREF(node_1318))->body));
				  ((((set_ex_it_116_bglt) CREF(node_1318))->body) = ((node_bglt) arg1778_1320), BUNSPEC);
			       }
			       aux_1936 =
				  (obj_t) (node_1318);
			    }
			    break;
			 case ((long) 14):

			    {	/* Cnst/node.scm 189 */
			       jump_ex_it_184_bglt node_1322;
			       node_1322 =
				  (jump_ex_it_184_bglt) (node_11);
			       {	/* Cnst/node.scm 190 */
				  node_bglt arg1780_1324;
				  arg1780_1324 =
				     cnst__44_cnst_node(
				     (((jump_ex_it_184_bglt) CREF(node_1322))->exit));
				  ((((jump_ex_it_184_bglt) CREF(node_1322))->exit) = ((node_bglt) arg1780_1324), BUNSPEC);
			       }
			       {	/* Cnst/node.scm 191 */
				  node_bglt arg1782_1326;
				  arg1782_1326 =
				     cnst__44_cnst_node(
				     (((jump_ex_it_184_bglt) CREF(node_1322))->value));
				  ((((jump_ex_it_184_bglt) CREF(node_1322))->value) = ((node_bglt) arg1782_1326), BUNSPEC);
			       }
			       aux_1936 =
				  (obj_t) (node_1322);
			    }
			    break;
			 case ((long) 15):

			    {	/* Cnst/node.scm 198 */
			       make_box_202_bglt node_1328;
			       node_1328 =
				  (make_box_202_bglt) (node_11);
			       {	/* Cnst/node.scm 199 */
				  node_bglt arg1784_1330;
				  arg1784_1330 =
				     cnst__44_cnst_node(
				     (((make_box_202_bglt) CREF(node_1328))->value));
				  ((((make_box_202_bglt) CREF(node_1328))->value) = ((node_bglt) arg1784_1330), BUNSPEC);
			       }
			       aux_1936 =
				  (obj_t) (node_1328);
			    }
			    break;
			 case ((long) 16):

			    {	/* Cnst/node.scm 206 */
			       box_ref_242_bglt node_1332;
			       node_1332 =
				  (box_ref_242_bglt) (node_11);
			       {	/* Cnst/node.scm 207 */
				  node_bglt arg1786_1334;
				  {	/* Cnst/node.scm 207 */
				     node_bglt aux_2199;
				     {	/* Cnst/node.scm 207 */
					var_bglt aux_2200;
					aux_2200 =
					   (((box_ref_242_bglt) CREF(node_1332))->var);
					aux_2199 =
					   (node_bglt) (aux_2200);
				     }
				     arg1786_1334 =
					cnst__44_cnst_node(aux_2199);
				  }
				  {	/* Cnst/node.scm 207 */
				     var_bglt val1418_1642;
				     val1418_1642 =
					(var_bglt) (arg1786_1334);
				     ((((box_ref_242_bglt) CREF(node_1332))->var) = ((var_bglt) val1418_1642), BUNSPEC);
				  }
			       }
			       aux_1936 =
				  (obj_t) (node_1332);
			    }
			    break;
			 case ((long) 17):

			    {	/* Cnst/node.scm 214 */
			       box_set__221_bglt node_1336;
			       node_1336 =
				  (box_set__221_bglt) (node_11);
			       {	/* Cnst/node.scm 215 */
				  node_bglt arg1788_1338;
				  {	/* Cnst/node.scm 215 */
				     node_bglt aux_2208;
				     {	/* Cnst/node.scm 215 */
					var_bglt aux_2209;
					aux_2209 =
					   (((box_set__221_bglt) CREF(node_1336))->var);
					aux_2208 =
					   (node_bglt) (aux_2209);
				     }
				     arg1788_1338 =
					cnst__44_cnst_node(aux_2208);
				  }
				  {	/* Cnst/node.scm 215 */
				     var_bglt val1428_1645;
				     val1428_1645 =
					(var_bglt) (arg1788_1338);
				     ((((box_set__221_bglt) CREF(node_1336))->var) = ((var_bglt) val1428_1645), BUNSPEC);
				  }
			       }
			       {	/* Cnst/node.scm 216 */
				  node_bglt arg1790_1340;
				  arg1790_1340 =
				     cnst__44_cnst_node(
				     (((box_set__221_bglt) CREF(node_1336))->value));
				  ((((box_set__221_bglt) CREF(node_1336))->value) = ((node_bglt) arg1790_1340), BUNSPEC);
			       }
			       aux_1936 =
				  (obj_t) (node_1336);
			    }
			    break;
			 case ((long) 18):

			    {	/* Cnst/node.scm 223 */
			       app_ly_162_bglt node_1342;
			       node_1342 =
				  (app_ly_162_bglt) (node_11);
			       {	/* Cnst/node.scm 224 */
				  node_bglt arg1792_1344;
				  arg1792_1344 =
				     cnst__44_cnst_node(
				     (((app_ly_162_bglt) CREF(node_1342))->fun));
				  ((((app_ly_162_bglt) CREF(node_1342))->fun) = ((node_bglt) arg1792_1344), BUNSPEC);
			       }
			       {	/* Cnst/node.scm 225 */
				  node_bglt arg1794_1346;
				  arg1794_1346 =
				     cnst__44_cnst_node(
				     (((app_ly_162_bglt) CREF(node_1342))->arg));
				  ((((app_ly_162_bglt) CREF(node_1342))->arg) = ((node_bglt) arg1794_1346), BUNSPEC);
			       }
			       aux_1936 =
				  (obj_t) (node_1342);
			    }
			    break;
			 case ((long) 19):

			    {	/* Cnst/node.scm 232 */
			       funcall_bglt node_1348;
			       node_1348 =
				  (funcall_bglt) (node_11);
			       {	/* Cnst/node.scm 233 */
				  node_bglt arg1796_1350;
				  arg1796_1350 =
				     cnst__44_cnst_node(
				     (((funcall_bglt) CREF(node_1348))->fun));
				  ((((funcall_bglt) CREF(node_1348))->fun) = ((node_bglt) arg1796_1350), BUNSPEC);
			       }
			       cnst___82_cnst_node(
				  (((funcall_bglt) CREF(node_1348))->args));
			       aux_1936 =
				  (obj_t) (node_1348);
			    }
			    break;
			 case ((long) 20):

			    {	/* Cnst/node.scm 252 */
			       app_bglt node_1353;
			       node_1353 =
				  (app_bglt) (node_11);
			       cnst___82_cnst_node(
				  (((app_bglt) CREF(node_1353))->args));
			       {	/* Cnst/node.scm 255 */
				  bool_t test_2237;
				  {	/* ./Ieee/pair-list.scm 5912 */
				     obj_t aux_2238;
				     aux_2238 =
					(((app_bglt) CREF(node_1353))->args);
				     test_2237 =
					NULLP(aux_2238);
				  }
				  if (test_2237)
				    {	/* Cnst/node.scm 255 */
				       aux_1936 =
					  (obj_t) (node_1353)
					  ;
				    }
				  else
				    {	/* Cnst/node.scm 257 */
				       variable_bglt fun_1357;
				       {	/* Cnst/node.scm 257 */
					  var_bglt arg1826_1384;
					  arg1826_1384 =
					     (((app_bglt) CREF(node_1353))->fun);
					  fun_1357 =
					     (((var_bglt) CREF(arg1826_1384))->variable);
				       }
				       {	/* Cnst/node.scm 258 */
					  obj_t actual_value_16_1359;
					  {	/* Cnst/node.scm 259 */
					     node_bglt aux_2244;
					     {	/* Cnst/node.scm 259 */
						obj_t aux_2245;
						{	/* ./Ieee/pair-list.scm 5701 */
						   obj_t aux_2246;
						   aux_2246 =
						      (((app_bglt) CREF(node_1353))->args);
						   aux_2245 =
						      CAR(aux_2246);
						}
						aux_2244 =
						   (node_bglt) (aux_2245);
					     }
					     actual_value_16_1359 =
						get_node_atom_value_135_cnst_node(aux_2244);
					  }
					  {	/* Cnst/node.scm 259 */

					     {	/* Cnst/node.scm 261 */
						bool_t test1802_1360;
						{	/* Cnst/node.scm 261 */
						   obj_t obj2_1667;
						   obj2_1667 = _string__bstring__114_cnst_cache;
						   {	/* ./Ieee/equiv.scm 5508 */
						      obj_t aux_2251;
						      aux_2251 =
							 (obj_t) (fun_1357);
						      test1802_1360 =
							 (aux_2251 == obj2_1667);
						   }
						}
						if (test1802_1360)
						  {	/* Cnst/node.scm 261 */
						     if (
							STRINGP(actual_value_16_1359))
						       {	/* Cnst/node.scm 263 */
							  node_bglt r_1362;
							  r_1362 =
							     cnst_alloc_string_41_cnst_alloc(actual_value_16_1359,
							     (((app_bglt) CREF(node_1353))->loc));
							  aux_1936 =
							     (obj_t) (r_1362);
						       }
						     else
						       {	/* Cnst/node.scm 262 */
							  aux_1936 =
							     (obj_t) (node_1353)
							     ;
						       }
						  }
						else
						  {	/* Cnst/node.scm 267 */
						     bool_t test1805_1364;
						     {	/* Cnst/node.scm 267 */
							obj_t obj2_1671;
							obj2_1671 = _bool__bbool__85_cnst_cache;
							{	/* ./Ieee/equiv.scm 5508 */
							   obj_t aux_2261;
							   aux_2261 =
							      (obj_t) (fun_1357);
							   test1805_1364 =
							      (aux_2261 == obj2_1671);
							}
						     }
						     if (test1805_1364)
						       {	/* Cnst/node.scm 267 */
							  if (
							     BOOLEANP(actual_value_16_1359))
							    {	/* Cnst/node.scm 268 */
							       if (
								  CBOOL(actual_value_16_1359))
								 {	/* Cnst/node.scm 270 */
								    obj_t arg1807_1366;
								    obj_t arg1809_1367;
								    obj_t arg1810_1368;
								    arg1807_1366 =
								       (((app_bglt) CREF(node_1353))->loc);
								    arg1809_1367 = _bbool__55_type_cache;
								    arg1810_1368 = _btrue__29_cnst_cache;
								    {	/* Cnst/node.scm 270 */
								       var_bglt res1838_1684;
								       {	/* Cnst/node.scm 270 */
									  type_bglt type_1675;
									  variable_bglt variable_1676;
									  type_1675 =
									     (type_bglt) (arg1809_1367);
									  variable_1676 =
									     (variable_bglt) (arg1810_1368);
									  {	/* ./Ast/node.scm 1062 */
									     var_bglt new1210_1677;
									     new1210_1677 =
										((var_bglt) BREF(GC_MALLOC(sizeof(struct var))));
									     {	/* ./Ast/node.scm 1062 */
										long arg1610_1678;
										arg1610_1678 =
										   class_num_218___object(var_ast_node);
										{	/* ./Ast/node.scm 1062 */
										   obj_t obj_1682;
										   obj_1682 =
										      (obj_t) (new1210_1677);
										   (((obj_t) CREF(obj_1682))->header = MAKE_HEADER(arg1610_1678, 0), BUNSPEC);
										}
									     }
									     {	/* ./Ast/node.scm 1062 */
										object_bglt aux_2276;
										aux_2276 =
										   (object_bglt) (new1210_1677);
										OBJECT_WIDENING_SET(aux_2276, BFALSE);
									     }
									     ((((var_bglt) CREF(new1210_1677))->loc) = ((obj_t) arg1807_1366), BUNSPEC);
									     ((((var_bglt) CREF(new1210_1677))->type) = ((type_bglt) type_1675), BUNSPEC);
									     ((((var_bglt) CREF(new1210_1677))->variable) = ((variable_bglt) variable_1676), BUNSPEC);
									     res1838_1684 = new1210_1677;
									  }
								       }
								       aux_1936 =
									  (obj_t) (res1838_1684);
								    }
								 }
							       else
								 {	/* Cnst/node.scm 274 */
								    obj_t arg1811_1369;
								    obj_t arg1812_1370;
								    obj_t arg1813_1371;
								    arg1811_1369 =
								       (((app_bglt) CREF(node_1353))->loc);
								    arg1812_1370 = _bbool__55_type_cache;
								    arg1813_1371 = _bfalse__69_cnst_cache;
								    {	/* Cnst/node.scm 274 */
								       var_bglt res1839_1696;
								       {	/* Cnst/node.scm 274 */
									  type_bglt type_1687;
									  variable_bglt variable_1688;
									  type_1687 =
									     (type_bglt) (arg1812_1370);
									  variable_1688 =
									     (variable_bglt) (arg1813_1371);
									  {	/* ./Ast/node.scm 1062 */
									     var_bglt new1210_1689;
									     new1210_1689 =
										((var_bglt) BREF(GC_MALLOC(sizeof(struct var))));
									     {	/* ./Ast/node.scm 1062 */
										long arg1610_1690;
										arg1610_1690 =
										   class_num_218___object(var_ast_node);
										{	/* ./Ast/node.scm 1062 */
										   obj_t obj_1694;
										   obj_1694 =
										      (obj_t) (new1210_1689);
										   (((obj_t) CREF(obj_1694))->header = MAKE_HEADER(arg1610_1690, 0), BUNSPEC);
										}
									     }
									     {	/* ./Ast/node.scm 1062 */
										object_bglt aux_2290;
										aux_2290 =
										   (object_bglt) (new1210_1689);
										OBJECT_WIDENING_SET(aux_2290, BFALSE);
									     }
									     ((((var_bglt) CREF(new1210_1689))->loc) = ((obj_t) arg1811_1369), BUNSPEC);
									     ((((var_bglt) CREF(new1210_1689))->type) = ((type_bglt) type_1687), BUNSPEC);
									     ((((var_bglt) CREF(new1210_1689))->variable) = ((variable_bglt) variable_1688), BUNSPEC);
									     res1839_1696 = new1210_1689;
									  }
								       }
								       aux_1936 =
									  (obj_t) (res1839_1696);
								    }
								 }
							    }
							  else
							    {	/* Cnst/node.scm 268 */
							       aux_1936 =
								  (obj_t) (node_1353)
								  ;
							    }
						       }
						     else
						       {	/* Cnst/node.scm 279 */
							  bool_t test1814_1372;
							  {	/* Cnst/node.scm 279 */
							     bool_t test1824_1382;
							     {	/* Cnst/node.scm 279 */
								obj_t obj2_1698;
								obj2_1698 = _make_fx_procedure__51_cnst_cache;
								{	/* ./Ieee/equiv.scm 5508 */
								   obj_t aux_2298;
								   aux_2298 =
								      (obj_t) (fun_1357);
								   test1824_1382 =
								      (aux_2298 == obj2_1698);
								}
							     }
							     if (test1824_1382)
							       {	/* Cnst/node.scm 279 */
								  test1814_1372 = ((bool_t) 1);
							       }
							     else
							       {	/* Cnst/node.scm 280 */
								  obj_t obj2_1700;
								  obj2_1700 = _make_va_procedure__53_cnst_cache;
								  {	/* ./Ieee/equiv.scm 5508 */
								     obj_t aux_2302;
								     aux_2302 =
									(obj_t) (fun_1357);
								     test1814_1372 =
									(aux_2302 == obj2_1700);
								  }
							       }
							  }
							  if (test1814_1372)
							    {	/* Cnst/node.scm 279 */
							       {	/* Cnst/node.scm 281 */
								  obj_t size_value_33_1373;
								  {	/* Cnst/node.scm 281 */
								     node_bglt aux_2306;
								     {	/* Cnst/node.scm 281 */
									obj_t aux_2307;
									{	/* ./Ieee/pair-list.scm 5701 */
									   obj_t aux_2308;
									   {	/* ./Ieee/pair-list.scm 5707 */
									      obj_t aux_2309;
									      {		/* ./Ieee/pair-list.scm 5707 */
										 obj_t aux_2310;
										 aux_2310 =
										    (((app_bglt) CREF(node_1353))->args);
										 aux_2309 =
										    CDR(aux_2310);
									      }
									      aux_2308 =
										 CDR(aux_2309);
									   }
									   aux_2307 =
									      CAR(aux_2308);
									}
									aux_2306 =
									   (node_bglt) (aux_2307);
								     }
								     size_value_33_1373 =
									get_node_atom_value_135_cnst_node(aux_2306);
								  }
								  {	/* Cnst/node.scm 282 */
								     bool_t test_2317;
								     if (
									INTEGERP(size_value_33_1373))
								       {	/* ./Ieee/fixnum.scm 7109 */
									  long aux_2320;
									  aux_2320 =
									     (long) CINT(size_value_33_1373);
									  test_2317 =
									     (aux_2320 == ((long) 0));
								       }
								     else
								       {	/* Cnst/node.scm 282 */
									  test_2317 = ((bool_t) 0)
									     ;
								       }
								     if (test_2317)
								       {	/* Cnst/node.scm 283 */
									  node_bglt aux_2323;
									  aux_2323 =
									     cnst_alloc_procedure_240_cnst_alloc(
									     (node_bglt) (node_1353),
									     (((app_bglt) CREF(node_1353))->loc));
									  aux_1936 =
									     (obj_t) (aux_2323);
								       }
								     else
								       {	/* Cnst/node.scm 282 */
									  aux_1936 =
									     (obj_t) (node_1353)
									     ;
								       }
								  }
							       }
							    }
							  else
							    {	/* Cnst/node.scm 285 */
							       bool_t test1821_1379;
							       {	/* Cnst/node.scm 285 */
								  obj_t obj2_1713;
								  obj2_1713 = _double__real__21_cnst_cache;
								  {	/* ./Ieee/equiv.scm 5508 */
								     obj_t aux_2329;
								     aux_2329 =
									(obj_t) (fun_1357);
								     test1821_1379 =
									(aux_2329 == obj2_1713);
								  }
							       }
							       if (test1821_1379)
								 {	/* Cnst/node.scm 285 */
								    {	/* Cnst/node.scm 286 */
								       bool_t test_2333;
								       if (
									  INTEGERP(actual_value_16_1359))
									 {	/* ./Ieee/flonum.scm 7393 */
									    test_2333 = ((bool_t) 1)
									       ;
									 }
								       else
									 {	/* ./Ieee/flonum.scm 7393 */
									    test_2333 =
									       REALP(actual_value_16_1359)
									       ;
									 }
								       if (test_2333)
									 {	/* Cnst/node.scm 287 */
									    node_bglt aux_2337;
									    aux_2337 =
									       cnst_alloc_real_118_cnst_alloc(actual_value_16_1359,
									       (((app_bglt) CREF(node_1353))->loc));
									    aux_1936 =
									       (obj_t) (aux_2337);
									 }
								       else
									 {	/* Cnst/node.scm 286 */
									    aux_1936 =
									       (obj_t) (node_1353)
									       ;
									 }
								    }
								 }
							       else
								 {	/* Cnst/node.scm 285 */
								    aux_1936 =
								       (obj_t) (node_1353);
								 }
							    }
						       }
						  }
					     }
					  }
				       }
				    }
			       }
			    }
			    break;
			 default:
			  case_else1678_1188:
			    if (
			       PROCEDUREP(method1672_1184))
			      {		/* Cnst/node.scm 35 */
				 aux_1936 =
				    PROCEDURE_ENTRY(method1672_1184) (method1672_1184,
				    (obj_t) (node_11), BEOA)
				    ;
			      }
			    else
			      {		/* Cnst/node.scm 35 */
				 obj_t fun1650_1155;
				 fun1650_1155 =
				    PROCEDURE_REF(cnst__env_43_cnst_node, ((long) 0));
				 aux_1936 =
				    PROCEDURE_ENTRY(fun1650_1155) (fun1650_1155,
				    (obj_t) (node_11), BEOA);
			      }
			 }
		    }
		  else
		    {	/* Cnst/node.scm 35 */
		       goto case_else1678_1188;
		    }
	       }
	       return
		  (node_bglt) (aux_1936);
	    }
	 }
      }
   }
}



/* _cnst!1846 */
obj_t 
_cnst_1846_224_cnst_node(obj_t env_1768, obj_t node_1769)
{
   AN_OBJECT;
   {	/* Cnst/node.scm 35 */
      {		/* Cnst/node.scm 35 */
	 node_bglt aux_2355;
	 aux_2355 =
	    cnst__44_cnst_node(
	    (node_bglt) (node_1769));
	 return
	    (obj_t) (aux_2355);
      }
   }
}



/* cnst!-default1490 */
node_bglt 
cnst__default1490_120_cnst_node(node_bglt node_12)
{
   AN_OBJECT;
   {	/* Cnst/node.scm 15 */
      FAILURE(
	 CNST_TABLE_REF(((long) 4)), string1854_cnst_node,
	 (obj_t) (node_12));
   }
}



/* _cnst!-default1490 */
obj_t 
_cnst__default1490_122_cnst_node(obj_t env_1770, obj_t node_1771)
{
   AN_OBJECT;
   {	/* Cnst/node.scm 15 */
      {		/* Cnst/node.scm 15 */
	 node_bglt aux_2362;
	 aux_2362 =
	    cnst__default1490_120_cnst_node(
	    (node_bglt) (node_1771));
	 return
	    (obj_t) (aux_2362);
      }
   }
}



/* get-node-atom-value */
obj_t 
get_node_atom_value_135_cnst_node(node_bglt node_35)
{
   AN_OBJECT;
   {	/* Cnst/node.scm 297 */
    get_node_atom_value_135_cnst_node:
      {
	 obj_t method1652_1160;
	 obj_t class1657_1161;
	 {	/* Cnst/node.scm 297 */
	    obj_t arg1660_1158;
	    obj_t arg1661_1159;
	    {	/* Cnst/node.scm 297 */
	       object_bglt obj_1723;
	       obj_1723 =
		  (object_bglt) (node_35);
	       {	/* ./Llib/object.scm 2926 */
		  obj_t pre_method_105_1724;
		  pre_method_105_1724 =
		     PROCEDURE_REF(get_node_atom_value_env_18_cnst_node, ((long) 2));
		  if (
		     INTEGERP(pre_method_105_1724))
		    {	/* ./Llib/object.scm 2927 */
		       PROCEDURE_SET(get_node_atom_value_env_18_cnst_node, ((long) 2), BUNSPEC);
		       arg1660_1158 = pre_method_105_1724;
		    }
		  else
		    {	/* ./Llib/object.scm 2914 */
		       long obj_class_num_177_1729;
		       obj_class_num_177_1729 =
			  TYPE(obj_1723);
		       {	/* ./Llib/object.scm 2915 */
			  obj_t arg1176_1730;
			  arg1176_1730 =
			     PROCEDURE_REF(get_node_atom_value_env_18_cnst_node, ((long) 1));
			  {	/* ./Llib/object.scm 2738 */
			     long arg1177_1734;
			     {	/* ./Llib/object.scm 2738 */
				long arg1178_1735;
				arg1178_1735 =
				   OBJECT_TYPE;
				arg1177_1734 =
				   (obj_class_num_177_1729 - arg1178_1735);
			     }
			     arg1660_1158 =
				VECTOR_REF(arg1176_1730, arg1177_1734);
			  }
		       }
		    }
	       }
	    }
	    {	/* Cnst/node.scm 297 */
	       object_bglt object_1740;
	       object_1740 =
		  (object_bglt) (node_35);
	       {	/* ./Llib/object.scm 2695 */
		  long arg1179_1741;
		  {	/* ./Llib/object.scm 2695 */
		     long arg1180_1742;
		     long arg1181_1743;
		     arg1180_1742 =
			TYPE(object_1740);
		     arg1181_1743 =
			OBJECT_TYPE;
		     arg1179_1741 =
			(arg1180_1742 - arg1181_1743);
		  }
		  {	/* ./Llib/object.scm 2695 */
		     obj_t vector_1747;
		     vector_1747 = _classes__134___object;
		     arg1661_1159 =
			VECTOR_REF(vector_1747, arg1179_1741);
		  }
	       }
	    }
	    method1652_1160 = arg1660_1158;
	    class1657_1161 = arg1661_1159;
	    {

	       if (
		  INTEGERP(method1652_1160))
		 {	/* Cnst/node.scm 297 */
		    switch (
		       (long) CINT(method1652_1160))
		      {
		      case ((long) 0):

			 {	/* Cnst/node.scm 304 */
			    atom_bglt node_1167;
			    node_1167 =
			       (atom_bglt) (node_35);
			    return
			       (((atom_bglt) CREF(node_1167))->value);
			 }
			 break;
		      case ((long) 1):

			 {	/* Cnst/node.scm 310 */
			    var_bglt node_1168;
			    node_1168 =
			       (var_bglt) (node_35);
			    {	/* Cnst/node.scm 310 */
			       variable_bglt v_1169;
			       v_1169 =
				  (((var_bglt) CREF(node_1168))->variable);
			       if (
				  is_a__118___object(
				     (obj_t) (v_1169), local_bvalue_105_cnst_node))
				 {
				    node_bglt node_2390;
				    {	/* Cnst/node.scm 312 */
				       local_bvalue_105_bglt obj_1752;
				       obj_1752 =
					  (local_bvalue_105_bglt) (v_1169);
				       {
					  obj_t aux_2392;
					  {	/* Cnst/node.scm 30 */
					     object_bglt aux_2393;
					     aux_2393 =
						(object_bglt) (obj_1752);
					     aux_2392 =
						OBJECT_WIDENING(aux_2393);
					  }
					  node_2390 =
					     (((local_bvalue_105_bglt) CREF(aux_2392))->binding_value_3);
				       }
				    }
				    node_35 = node_2390;
				    goto get_node_atom_value_135_cnst_node;
				 }
			       else
				 {	/* Cnst/node.scm 311 */
				    return
				       CNST_TABLE_REF(((long) 5));
				 }
			    }
			 }
			 break;
		      default:
		       case_else1658_1164:
			 if (
			    PROCEDUREP(method1652_1160))
			   {	/* Cnst/node.scm 297 */
			      return
				 PROCEDURE_ENTRY(method1652_1160) (method1652_1160,
				 (obj_t) (node_35), BEOA);
			   }
			 else
			   {	/* Cnst/node.scm 297 */
			      obj_t fun1651_1156;
			      fun1651_1156 =
				 PROCEDURE_REF(get_node_atom_value_env_18_cnst_node, ((long) 0));
			      return
				 PROCEDURE_ENTRY(fun1651_1156) (fun1651_1156,
				 (obj_t) (node_35), BEOA);
			   }
		      }
		 }
	       else
		 {	/* Cnst/node.scm 297 */
		    goto case_else1658_1164;
		 }
	    }
	 }
      }
   }
}



/* _get-node-atom-value1847 */
obj_t 
_get_node_atom_value1847_10_cnst_node(obj_t env_1772, obj_t node_1773)
{
   AN_OBJECT;
   {	/* Cnst/node.scm 297 */
      return
	 get_node_atom_value_135_cnst_node(
	 (node_bglt) (node_1773));
   }
}



/* get-node-atom-value-default1534 */
obj_t 
get_node_atom_value_default1534_92_cnst_node(node_bglt node_36)
{
   AN_OBJECT;
   {	/* Cnst/node.scm 15 */
      return
	 CNST_TABLE_REF(((long) 5));
   }
}



/* _get-node-atom-value-default1534 */
obj_t 
_get_node_atom_value_default1534_229_cnst_node(obj_t env_1774, obj_t node_1775)
{
   AN_OBJECT;
   {	/* Cnst/node.scm 15 */
      return
	 get_node_atom_value_default1534_92_cnst_node(
	 (node_bglt) (node_1775));
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_cnst_node()
{
   AN_OBJECT;
   {	/* Cnst/node.scm 15 */
      module_initialization_70_tools_trace(((long) 0), "CNST_NODE");
      module_initialization_70_tools_shape(((long) 0), "CNST_NODE");
      module_initialization_70_tools_speek(((long) 0), "CNST_NODE");
      module_initialization_70_tools_error(((long) 0), "CNST_NODE");
      module_initialization_70_type_type(((long) 0), "CNST_NODE");
      module_initialization_70_type_cache(((long) 0), "CNST_NODE");
      module_initialization_70_ast_var(((long) 0), "CNST_NODE");
      module_initialization_70_ast_node(((long) 0), "CNST_NODE");
      module_initialization_70_ast_env(((long) 0), "CNST_NODE");
      module_initialization_70_cnst_cache(((long) 0), "CNST_NODE");
      return
	 module_initialization_70_cnst_alloc(((long) 0), "CNST_NODE");
   }
}
