/*===========================================================================*/
/*   (Cnst/walk.scm)                                                         */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;


static obj_t _old_unsafe_type__146_cnst_walk = BUNSPEC;
static obj_t _old_unsafe_struct__195_cnst_walk = BUNSPEC;
static obj_t method_init_76_cnst_walk();
static obj_t unsafe__47_cnst_walk();
static obj_t _cnst_walk__8_cnst_walk(obj_t, obj_t);
static obj_t _old_unsafe_arity__240_cnst_walk = BUNSPEC;
extern obj_t current_error_port;
extern obj_t _nb_error_on_pass__70_tools_error;
extern obj_t leave_function_170_tools_error();
extern obj_t verbose_tools_speek(obj_t, obj_t);
extern obj_t _unsafe_struct__195_engine_param;
extern obj_t module_initialization_70_cnst_walk(long, char *);
extern obj_t module_initialization_70_tools_speek(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_engine_pass(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_ast_remove(long, char *);
extern obj_t module_initialization_70_cnst_alloc(long, char *);
extern obj_t module_initialization_70_cnst_cache(long, char *);
extern obj_t module_initialization_70_cnst_node(long, char *);
extern obj_t module_initialization_70_cnst_initialize(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_numbers_6_5(long, char *);
extern obj_t module_initialization_70___r4_output_6_10_3(long, char *);
extern obj_t _unsafe_arity__240_engine_param;
static obj_t _old_unsafe_version__81_cnst_walk = BUNSPEC;
extern obj_t _unsafe_version__81_engine_param;
static obj_t _safe__136_cnst_walk(obj_t);
extern obj_t display_2_122___r4_output_6_10_3(obj_t, obj_t);
static obj_t imported_modules_init_94_cnst_walk();
extern obj_t append_2_18___r4_pairs_and_lists_6_3(obj_t, obj_t);
static obj_t library_modules_init_112_cnst_walk();
static obj_t toplevel_init_63_cnst_walk();
extern obj_t _unsafe_type__146_engine_param;
extern obj_t open_input_string(obj_t);
static obj_t _old_unsafe_range__218_cnst_walk = BUNSPEC;
extern obj_t initialize_ast_128_cnst_initialize();
extern obj_t string_to_bstring(char *);
extern obj_t enter_function_81_tools_error(obj_t);
extern obj_t cnst_walk__13_cnst_walk(obj_t);
extern obj_t _init_mode__183_engine_param;
extern obj_t remove_var_123_ast_remove(obj_t, obj_t);
extern obj_t internal_error_43_tools_error(obj_t, obj_t, obj_t);
extern obj_t _unsafe_range__218_engine_param;
extern bool_t _2__206___r4_numbers_6_5(obj_t, obj_t);
extern obj_t read___reader(obj_t);
static obj_t _unsafe__49_cnst_walk(obj_t);
static obj_t safe__104_cnst_walk();
static obj_t require_initialization_114_cnst_walk = BUNSPEC;
extern node_bglt cnst__44_cnst_node(node_bglt);
static obj_t cnst_init_137_cnst_walk();
extern obj_t _current_pass__25_engine_pass;
static obj_t __cnst[4];

DEFINE_EXPORT_PROCEDURE(cnst_walk__env_34_cnst_walk, _cnst_walk__8_cnst_walk1583, _cnst_walk__8_cnst_walk, 0L, 1);
extern obj_t start_cnst_cache__env_224_cnst_cache;
DEFINE_STATIC_PROCEDURE(safe__env_5_cnst_walk, _safe__136_cnst_walk1584, _safe__136_cnst_walk, 0L, 0);
DEFINE_STATIC_PROCEDURE(unsafe__env_61_cnst_walk, _unsafe__49_cnst_walk1585, _unsafe__49_cnst_walk, 0L, 0);
extern obj_t start_cnst_alloc__env_227_cnst_alloc;
extern obj_t stop_cnst_alloc__env_174_cnst_alloc;
DEFINE_STRING(string1578_cnst_walk, string1578_cnst_walk1586, "(STOP-CNST-ALLOC! SAFE!) CNST (START-CNST-CACHE! START-CNST-ALLOC! UNSAFE!) PASS-STARTED ", 89);
DEFINE_STRING(string1577_cnst_walk, string1577_cnst_walk1587, "failure during postlude hook", 28);
DEFINE_STRING(string1576_cnst_walk, string1576_cnst_walk1588, " occured, ending ...", 20);
DEFINE_STRING(string1575_cnst_walk, string1575_cnst_walk1589, " error", 6);
DEFINE_STRING(string1574_cnst_walk, string1574_cnst_walk1590, "      [", 7);
DEFINE_STRING(string1573_cnst_walk, string1573_cnst_walk1591, "failure during prelude hook", 27);
DEFINE_STRING(string1572_cnst_walk, string1572_cnst_walk1592, "   . ", 5);
DEFINE_STRING(string1571_cnst_walk, string1571_cnst_walk1593, "Cnst", 4);



/* module-initialization */
obj_t 
module_initialization_70_cnst_walk(long checksum_1121, char *from_1122)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_cnst_walk))
	{
	   require_initialization_114_cnst_walk =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_cnst_walk();
	   cnst_init_137_cnst_walk();
	   imported_modules_init_94_cnst_walk();
	   method_init_76_cnst_walk();
	   toplevel_init_63_cnst_walk();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_cnst_walk()
{
   AN_OBJECT;
   {	/* Cnst/walk.scm 14 */
      module_initialization_70___r4_output_6_10_3(((long) 0), "CNST_WALK");
      module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "CNST_WALK");
      module_initialization_70___r4_numbers_6_5(((long) 0), "CNST_WALK");
      module_initialization_70___reader(((long) 0), "CNST_WALK");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_cnst_walk()
{
   AN_OBJECT;
   {	/* Cnst/walk.scm 14 */
      {		/* Cnst/walk.scm 14 */
	 obj_t cnst_port_138_1114;
	 cnst_port_138_1114 =
	    open_input_string(string1578_cnst_walk);
	 {
	    long i_1115;
	    i_1115 = ((long) 3);
	  loop_1116:
	    {	/* Cnst/walk.scm 14 */
	       bool_t test1579_1117;
	       test1579_1117 =
		  (i_1115 == ((long) -1));
	       if (test1579_1117)
		 {	/* Cnst/walk.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Cnst/walk.scm 14 */
		    {	/* Cnst/walk.scm 14 */
		       obj_t arg1580_1118;
		       {	/* Cnst/walk.scm 14 */
			  obj_t list1581_1119;
			  list1581_1119 =
			     MAKE_PAIR(cnst_port_138_1114, BNIL);
			  arg1580_1118 =
			     read___reader(list1581_1119);
		       }
		       CNST_TABLE_SET(i_1115, arg1580_1118);
		    }
		    {	/* Cnst/walk.scm 14 */
		       int aux_1120;
		       {	/* Cnst/walk.scm 14 */
			  long aux_1141;
			  aux_1141 =
			     (i_1115 - ((long) 1));
			  aux_1120 =
			     (int) (aux_1141);
		       }
		       {
			  long i_1144;
			  i_1144 =
			     (long) (aux_1120);
			  i_1115 = i_1144;
			  goto loop_1116;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_cnst_walk()
{
   AN_OBJECT;
   {	/* Cnst/walk.scm 14 */
      _old_unsafe_type__146_cnst_walk = BFALSE;
      _old_unsafe_arity__240_cnst_walk = BFALSE;
      _old_unsafe_range__218_cnst_walk = BFALSE;
      _old_unsafe_struct__195_cnst_walk = BFALSE;
      return (
	 _old_unsafe_version__81_cnst_walk = BFALSE, BUNSPEC);
   }
}



/* cnst-walk! */
obj_t 
cnst_walk__13_cnst_walk(obj_t globals_1)
{
   AN_OBJECT;
   {	/* Cnst/walk.scm 32 */
      {		/* Cnst/walk.scm 32 */
	 obj_t list1440_697;
	 {	/* Cnst/walk.scm 32 */
	    obj_t arg1442_699;
	    {	/* Cnst/walk.scm 32 */
	       obj_t arg1444_701;
	       {	/* Cnst/walk.scm 32 */
		  obj_t aux_1146;
		  aux_1146 =
		     BCHAR(((unsigned char) '\n'));
		  arg1444_701 =
		     MAKE_PAIR(aux_1146, BNIL);
	       }
	       arg1442_699 =
		  MAKE_PAIR(string1571_cnst_walk, arg1444_701);
	    }
	    list1440_697 =
	       MAKE_PAIR(string1572_cnst_walk, arg1442_699);
	 }
	 verbose_tools_speek(
	    BINT(((long) 1)), list1440_697);
      }
      _nb_error_on_pass__70_tools_error =
	 BINT(((long) 0));
      _current_pass__25_engine_pass = string1571_cnst_walk;
      {
	 obj_t hooks_702;
	 obj_t hnames_703;
	 {	/* Cnst/walk.scm 32 */
	    obj_t arg1445_705;
	    obj_t arg1446_706;
	    {	/* Cnst/walk.scm 32 */
	       obj_t list1447_707;
	       {	/* Cnst/walk.scm 32 */
		  obj_t arg1449_708;
		  {	/* Cnst/walk.scm 32 */
		     obj_t arg1450_709;
		     arg1450_709 =
			MAKE_PAIR(unsafe__env_61_cnst_walk, BNIL);
		     arg1449_708 =
			MAKE_PAIR(start_cnst_alloc__env_227_cnst_alloc, arg1450_709);
		  }
		  list1447_707 =
		     MAKE_PAIR(start_cnst_cache__env_224_cnst_cache, arg1449_708);
	       }
	       arg1445_705 = list1447_707;
	    }
	    arg1446_706 =
	       CNST_TABLE_REF(((long) 1));
	    hooks_702 = arg1445_705;
	    hnames_703 = arg1446_706;
	  loop_704:
	    if (
	       NULLP(hooks_702))
	      {		/* Cnst/walk.scm 32 */
		 CNST_TABLE_REF(((long) 0));
	      }
	    else
	      {		/* Cnst/walk.scm 32 */
		 bool_t test1452_711;
		 {	/* Cnst/walk.scm 32 */
		    obj_t fun1459_717;
		    fun1459_717 =
		       CAR(hooks_702);
		    {	/* Cnst/walk.scm 32 */
		       obj_t aux_1162;
		       aux_1162 =
			  PROCEDURE_ENTRY(fun1459_717) (fun1459_717, BEOA);
		       test1452_711 =
			  CBOOL(aux_1162);
		    }
		 }
		 if (test1452_711)
		   {	/* Cnst/walk.scm 32 */
		      {
			 obj_t hnames_1169;
			 obj_t hooks_1167;
			 hooks_1167 =
			    CDR(hooks_702);
			 hnames_1169 =
			    CDR(hnames_703);
			 hnames_703 = hnames_1169;
			 hooks_702 = hooks_1167;
			 goto loop_704;
		      }
		   }
		 else
		   {	/* Cnst/walk.scm 32 */
		      internal_error_43_tools_error(string1571_cnst_walk, string1573_cnst_walk,
			 CAR(hnames_703));
		   }
	      }
	 }
      }
      {		/* Cnst/walk.scm 34 */
	 obj_t list1460_718;
	 {	/* Cnst/walk.scm 34 */
	    obj_t arg1462_720;
	    {	/* Cnst/walk.scm 34 */
	       obj_t arg1463_721;
	       {	/* Cnst/walk.scm 34 */
		  obj_t arg1464_722;
		  {	/* Cnst/walk.scm 34 */
		     obj_t aux_1173;
		     aux_1173 =
			BCHAR(((unsigned char) '\n'));
		     arg1464_722 =
			MAKE_PAIR(aux_1173, BNIL);
		  }
		  {	/* Cnst/walk.scm 34 */
		     obj_t aux_1176;
		     aux_1176 =
			BCHAR(((unsigned char) ']'));
		     arg1463_721 =
			MAKE_PAIR(aux_1176, arg1464_722);
		  }
	       }
	       arg1462_720 =
		  MAKE_PAIR(_init_mode__183_engine_param, arg1463_721);
	    }
	    list1460_718 =
	       MAKE_PAIR(string1574_cnst_walk, arg1462_720);
	 }
	 verbose_tools_speek(
	    BINT(((long) 2)), list1460_718);
      }
      {
	 obj_t l1437_723;
	 l1437_723 = globals_1;
       lname1438_724:
	 if (
	    PAIRP(l1437_723))
	   {	/* Cnst/walk.scm 35 */
	      {		/* Cnst/walk.scm 35 */
		 obj_t global_726;
		 global_726 =
		    CAR(l1437_723);
		 {	/* Cnst/walk.scm 36 */
		    obj_t aux_1186;
		    {	/* Cnst/walk.scm 36 */
		       global_bglt obj_1089;
		       obj_1089 =
			  (global_bglt) (global_726);
		       aux_1186 =
			  (((global_bglt) CREF(obj_1089))->id);
		    }
		    enter_function_81_tools_error(aux_1186);
		 }
		 {	/* Cnst/walk.scm 37 */
		    value_bglt fun_728;
		    {	/* Cnst/walk.scm 37 */
		       global_bglt obj_1090;
		       obj_1090 =
			  (global_bglt) (global_726);
		       fun_728 =
			  (((global_bglt) CREF(obj_1090))->value);
		    }
		    {	/* Cnst/walk.scm 37 */
		       node_bglt new_body_215_729;
		       {	/* Cnst/walk.scm 38 */
			  node_bglt aux_1192;
			  {	/* Cnst/walk.scm 38 */
			     obj_t aux_1193;
			     {	/* Cnst/walk.scm 38 */
				sfun_bglt obj_1091;
				obj_1091 =
				   (sfun_bglt) (fun_728);
				aux_1193 =
				   (((sfun_bglt) CREF(obj_1091))->body);
			     }
			     aux_1192 =
				(node_bglt) (aux_1193);
			  }
			  new_body_215_729 =
			     cnst__44_cnst_node(aux_1192);
		       }
		       {	/* Cnst/walk.scm 38 */

			  {	/* Cnst/walk.scm 39 */
			     sfun_bglt obj_1092;
			     obj_t val1123_1093;
			     obj_1092 =
				(sfun_bglt) (fun_728);
			     val1123_1093 =
				(obj_t) (new_body_215_729);
			     ((((sfun_bglt) CREF(obj_1092))->body) = ((obj_t) val1123_1093), BUNSPEC);
			  }
		       }
		    }
		 }
		 leave_function_170_tools_error();
	      }
	      {
		 obj_t l1437_1202;
		 l1437_1202 =
		    CDR(l1437_723);
		 l1437_723 = l1437_1202;
		 goto lname1438_724;
	      }
	   }
	 else
	   {	/* Cnst/walk.scm 35 */
	      ((bool_t) 1);
	   }
      }
      {		/* Cnst/walk.scm 42 */
	 obj_t value_732;
	 {	/* Cnst/walk.scm 42 */
	    obj_t arg1488_752;
	    obj_t arg1489_753;
	    arg1488_752 =
	       CNST_TABLE_REF(((long) 2));
	    {	/* Cnst/walk.scm 42 */
	       obj_t arg1490_754;
	       arg1490_754 =
		  initialize_ast_128_cnst_initialize();
	       arg1489_753 =
		  append_2_18___r4_pairs_and_lists_6_3(arg1490_754, globals_1);
	    }
	    value_732 =
	       remove_var_123_ast_remove(arg1488_752, arg1489_753);
	 }
	 {	/* Cnst/walk.scm 42 */
	    bool_t test1470_733;
	    {	/* Cnst/walk.scm 42 */
	       long n1_1095;
	       n1_1095 =
		  (long) CINT(_nb_error_on_pass__70_tools_error);
	       test1470_733 =
		  (n1_1095 > ((long) 0));
	    }
	    if (test1470_733)
	      {		/* Cnst/walk.scm 42 */
		 display_2_122___r4_output_6_10_3(_nb_error_on_pass__70_tools_error, current_error_port);
		 display_2_122___r4_output_6_10_3(string1575_cnst_walk, current_error_port);
		 {	/* Cnst/walk.scm 42 */
		    char *arg1471_735;
		    {	/* Cnst/walk.scm 42 */
		       bool_t test1472_736;
		       {	/* Cnst/walk.scm 42 */
			  bool_t test1473_737;
			  {	/* Cnst/walk.scm 42 */
			     obj_t obj_1097;
			     obj_1097 = _nb_error_on_pass__70_tools_error;
			     test1473_737 =
				INTEGERP(obj_1097);
			  }
			  if (test1473_737)
			    {	/* Cnst/walk.scm 42 */
			       test1472_736 =
				  _2__206___r4_numbers_6_5(_nb_error_on_pass__70_tools_error,
				  BINT(((long) 1)));
			    }
			  else
			    {	/* Cnst/walk.scm 42 */
			       test1472_736 = ((bool_t) 0);
			    }
		       }
		       if (test1472_736)
			 {	/* Cnst/walk.scm 42 */
			    arg1471_735 = "s";
			 }
		       else
			 {	/* Cnst/walk.scm 42 */
			    arg1471_735 = "";
			 }
		    }
		    display_2_122___r4_output_6_10_3(
		       string_to_bstring(arg1471_735), current_error_port);
		 }
		 display_2_122___r4_output_6_10_3(string1576_cnst_walk, current_error_port);
		 WRITE_CHAR(((unsigned char) '\n'), current_error_port);
		 {	/* Cnst/walk.scm 42 */
		    obj_t res1570_1100;
		    exit(((long) -1));
		    res1570_1100 =
		       BINT(((long) -1));
		    return res1570_1100;
		 }
	      }
	    else
	      {
		 obj_t hooks_738;
		 obj_t hnames_739;
		 {	/* Cnst/walk.scm 42 */
		    obj_t arg1474_741;
		    obj_t arg1475_742;
		    {	/* Cnst/walk.scm 42 */
		       obj_t list1476_743;
		       {	/* Cnst/walk.scm 42 */
			  obj_t arg1477_744;
			  arg1477_744 =
			     MAKE_PAIR(safe__env_5_cnst_walk, BNIL);
			  list1476_743 =
			     MAKE_PAIR(stop_cnst_alloc__env_174_cnst_alloc, arg1477_744);
		       }
		       arg1474_741 = list1476_743;
		    }
		    arg1475_742 =
		       CNST_TABLE_REF(((long) 3));
		    hooks_738 = arg1474_741;
		    hnames_739 = arg1475_742;
		  loop_740:
		    if (
		       NULLP(hooks_738))
		      {		/* Cnst/walk.scm 42 */
			 return value_732;
		      }
		    else
		      {		/* Cnst/walk.scm 42 */
			 bool_t test1479_746;
			 {	/* Cnst/walk.scm 42 */
			    obj_t fun1487_751;
			    fun1487_751 =
			       CAR(hooks_738);
			    {	/* Cnst/walk.scm 42 */
			       obj_t aux_1230;
			       aux_1230 =
				  PROCEDURE_ENTRY(fun1487_751) (fun1487_751, BEOA);
			       test1479_746 =
				  CBOOL(aux_1230);
			    }
			 }
			 if (test1479_746)
			   {	/* Cnst/walk.scm 42 */
			      {
				 obj_t hnames_1237;
				 obj_t hooks_1235;
				 hooks_1235 =
				    CDR(hooks_738);
				 hnames_1237 =
				    CDR(hnames_739);
				 hnames_739 = hnames_1237;
				 hooks_738 = hooks_1235;
				 goto loop_740;
			      }
			   }
			 else
			   {	/* Cnst/walk.scm 42 */
			      return
				 internal_error_43_tools_error(_current_pass__25_engine_pass, string1577_cnst_walk,
				 CAR(hnames_739));
			   }
		      }
		 }
	      }
	 }
      }
   }
}



/* _cnst-walk! */
obj_t 
_cnst_walk__8_cnst_walk(obj_t env_1107, obj_t globals_1108)
{
   AN_OBJECT;
   {	/* Cnst/walk.scm 32 */
      return
	 cnst_walk__13_cnst_walk(globals_1108);
   }
}



/* unsafe! */
obj_t 
unsafe__47_cnst_walk()
{
   AN_OBJECT;
   {	/* Cnst/walk.scm 49 */
      _old_unsafe_type__146_cnst_walk = _unsafe_type__146_engine_param;
      _unsafe_type__146_engine_param = BTRUE;
      _old_unsafe_arity__240_cnst_walk = _unsafe_arity__240_engine_param;
      _unsafe_arity__240_engine_param = BTRUE;
      _old_unsafe_range__218_cnst_walk = _unsafe_range__218_engine_param;
      _unsafe_range__218_engine_param = BTRUE;
      _old_unsafe_struct__195_cnst_walk = _unsafe_struct__195_engine_param;
      _unsafe_struct__195_engine_param = BTRUE;
      _old_unsafe_version__81_cnst_walk = _unsafe_version__81_engine_param;
      return (
	 _unsafe_version__81_engine_param = BTRUE, BUNSPEC);
   }
}



/* _unsafe! */
obj_t 
_unsafe__49_cnst_walk(obj_t env_1109)
{
   AN_OBJECT;
   {	/* Cnst/walk.scm 49 */
      return
	 unsafe__47_cnst_walk();
   }
}



/* safe! */
obj_t 
safe__104_cnst_walk()
{
   AN_OBJECT;
   {	/* Cnst/walk.scm 64 */
      _unsafe_type__146_engine_param = _old_unsafe_type__146_cnst_walk;
      _unsafe_arity__240_engine_param = _old_unsafe_arity__240_cnst_walk;
      _unsafe_range__218_engine_param = _old_unsafe_range__218_cnst_walk;
      _unsafe_struct__195_engine_param = _old_unsafe_struct__195_cnst_walk;
      return (
	 _unsafe_version__81_engine_param = _old_unsafe_version__81_cnst_walk, BUNSPEC);
   }
}



/* _safe! */
obj_t 
_safe__136_cnst_walk(obj_t env_1112)
{
   AN_OBJECT;
   {	/* Cnst/walk.scm 64 */
      return
	 safe__104_cnst_walk();
   }
}



/* method-init */
obj_t 
method_init_76_cnst_walk()
{
   AN_OBJECT;
   {	/* Cnst/walk.scm 14 */
      return BUNSPEC;
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_cnst_walk()
{
   AN_OBJECT;
   {	/* Cnst/walk.scm 14 */
      module_initialization_70_tools_speek(((long) 0), "CNST_WALK");
      module_initialization_70_tools_error(((long) 0), "CNST_WALK");
      module_initialization_70_engine_pass(((long) 0), "CNST_WALK");
      module_initialization_70_tools_shape(((long) 0), "CNST_WALK");
      module_initialization_70_engine_param(((long) 0), "CNST_WALK");
      module_initialization_70_type_type(((long) 0), "CNST_WALK");
      module_initialization_70_ast_var(((long) 0), "CNST_WALK");
      module_initialization_70_ast_node(((long) 0), "CNST_WALK");
      module_initialization_70_ast_remove(((long) 0), "CNST_WALK");
      module_initialization_70_cnst_alloc(((long) 0), "CNST_WALK");
      module_initialization_70_cnst_cache(((long) 0), "CNST_WALK");
      module_initialization_70_cnst_node(((long) 0), "CNST_WALK");
      return
	 module_initialization_70_cnst_initialize(((long) 0), "CNST_WALK");
   }
}
