/*===========================================================================*/
/*   (Coerce/app.scm)                                                        */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;


static obj_t coerce__app1439_89_coerce_app(obj_t, obj_t, obj_t);
static obj_t method_init_76_coerce_app();
static node_bglt coerce_bigloo_app__198_coerce_app(variable_bglt, app_bglt, obj_t);
extern obj_t type_type_type;
static node_bglt coerce_foreign_va_app__44_coerce_app(value_bglt, variable_bglt, app_bglt, obj_t);
extern obj_t add_method__1___object(obj_t, obj_t, obj_t);
extern obj_t global_ast_var;
extern obj_t notify_assert_fail_37___eval(obj_t, obj_t, obj_t);
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t module_initialization_70_coerce_app(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_coerce_coerce(long, char *);
extern obj_t module_initialization_70_coerce_convert(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___eval(long, char *);
extern obj_t module_initialization_70___evenv(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern long list_length(obj_t);
extern obj_t define_primop_ref__105___evenv(obj_t, obj_t);
static obj_t imported_modules_init_94_coerce_app();
extern obj_t unbind_primop__163___evenv(obj_t);
static node_bglt coerce_foreign_fx_app__114_coerce_app(value_bglt, variable_bglt, app_bglt, obj_t);
extern obj_t cfun_ast_var;
extern node_bglt coerce__182_coerce_coerce(node_bglt, type_bglt);
extern obj_t app_ast_node;
static obj_t library_modules_init_112_coerce_app();
static obj_t toplevel_init_63_coerce_app();
extern obj_t open_input_string(obj_t);
extern node_bglt convert__122_coerce_convert(node_bglt, type_bglt, type_bglt);
extern obj_t shape_tools_shape(obj_t);
static node_bglt coerce_bigloo_intern_app__35_coerce_app(variable_bglt, app_bglt, obj_t);
static node_bglt coerce_foreign_app__190_coerce_app(variable_bglt, app_bglt, obj_t);
extern obj_t read___reader(obj_t);
static node_bglt coerce_bigloo_extern_app__81_coerce_app(variable_bglt, app_bglt, obj_t);
static obj_t require_initialization_114_coerce_app = BUNSPEC;
static obj_t cnst_init_137_coerce_app();
static obj_t __cnst[7];

DEFINE_STATIC_PROCEDURE(proc1598_coerce_app, coerce__app1439_89_coerce_app1604, coerce__app1439_89_coerce_app, 0L, 2);
DEFINE_STRING(string1599_coerce_app, string1599_coerce_app1605, "(\"/home/tahoe2/serrano/tmp/bigloo/comptime/Coerce/app.scm\" . 4552) (BEGIN (=FX (LENGTH ACTUALS) (LENGTH FORMALS))) (ACTUALS FORMALS SH) ACTUALS FORMALS SH IMPORT ", 162);
extern obj_t coerce__env_127_coerce_coerce;



/* module-initialization */
obj_t 
module_initialization_70_coerce_app(long checksum_1233, char *from_1234)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_coerce_app))
	{
	   require_initialization_114_coerce_app =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_coerce_app();
	   cnst_init_137_coerce_app();
	   imported_modules_init_94_coerce_app();
	   method_init_76_coerce_app();
	   toplevel_init_63_coerce_app();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_coerce_app()
{
   AN_OBJECT;
   {	/* Coerce/app.scm 14 */
      module_initialization_70___object(((long) 0), "COERCE_APP");
      module_initialization_70___eval(((long) 0), "COERCE_APP");
      module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "COERCE_APP");
      module_initialization_70___evenv(((long) 0), "COERCE_APP");
      module_initialization_70___reader(((long) 0), "COERCE_APP");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_coerce_app()
{
   AN_OBJECT;
   {	/* Coerce/app.scm 14 */
      {		/* Coerce/app.scm 14 */
	 obj_t cnst_port_138_1226;
	 cnst_port_138_1226 =
	    open_input_string(string1599_coerce_app);
	 {
	    long i_1227;
	    i_1227 = ((long) 6);
	  loop_1228:
	    {	/* Coerce/app.scm 14 */
	       bool_t test1600_1229;
	       test1600_1229 =
		  (i_1227 == ((long) -1));
	       if (test1600_1229)
		 {	/* Coerce/app.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Coerce/app.scm 14 */
		    {	/* Coerce/app.scm 14 */
		       obj_t arg1601_1230;
		       {	/* Coerce/app.scm 14 */
			  obj_t list1602_1231;
			  list1602_1231 =
			     MAKE_PAIR(cnst_port_138_1226, BNIL);
			  arg1601_1230 =
			     read___reader(list1602_1231);
		       }
		       CNST_TABLE_SET(i_1227, arg1601_1230);
		    }
		    {	/* Coerce/app.scm 14 */
		       int aux_1232;
		       {	/* Coerce/app.scm 14 */
			  long aux_1254;
			  aux_1254 =
			     (i_1227 - ((long) 1));
			  aux_1232 =
			     (int) (aux_1254);
		       }
		       {
			  long i_1257;
			  i_1257 =
			     (long) (aux_1232);
			  i_1227 = i_1257;
			  goto loop_1228;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_coerce_app()
{
   AN_OBJECT;
   {	/* Coerce/app.scm 14 */
      return BUNSPEC;
   }
}



/* coerce-foreign-app! */
node_bglt 
coerce_foreign_app__190_coerce_app(variable_bglt callee_3, app_bglt node_4, obj_t to_5)
{
   AN_OBJECT;
   {	/* Coerce/app.scm 37 */
      {		/* Coerce/app.scm 40 */
	 value_bglt ffun_718;
	 ffun_718 =
	    (((variable_bglt) CREF(callee_3))->value);
	 {	/* Coerce/app.scm 41 */

	    {	/* Coerce/app.scm 42 */
	       bool_t test_1260;
	       {	/* ./Ieee/fixnum.scm 7133 */
		  long aux_1261;
		  {	/* Coerce/app.scm 41 */
		     fun_bglt obj_1143;
		     obj_1143 =
			(fun_bglt) (ffun_718);
		     aux_1261 =
			(((fun_bglt) CREF(obj_1143))->arity);
		  }
		  test_1260 =
		     (aux_1261 >= ((long) 0));
	       }
	       if (test_1260)
		 {	/* Coerce/app.scm 42 */
		    return
		       coerce_foreign_fx_app__114_coerce_app(ffun_718, callee_3, node_4, to_5);
		 }
	       else
		 {	/* Coerce/app.scm 42 */
		    return
		       coerce_foreign_va_app__44_coerce_app(ffun_718, callee_3, node_4, to_5);
		 }
	    }
	 }
      }
   }
}



/* coerce-foreign-fx-app! */
node_bglt 
coerce_foreign_fx_app__114_coerce_app(value_bglt fun_6, variable_bglt callee_7, app_bglt node_8, obj_t to_9)
{
   AN_OBJECT;
   {	/* Coerce/app.scm 49 */
      {
	 obj_t actuals_721;
	 obj_t types_722;
	 actuals_721 =
	    (((app_bglt) CREF(node_8))->args);
	 {	/* Coerce/app.scm 51 */
	    cfun_bglt obj_1147;
	    obj_1147 =
	       (cfun_bglt) (fun_6);
	    types_722 =
	       (((cfun_bglt) CREF(obj_1147))->args_type_205);
	 }
       loop_723:
	 if (
	    NULLP(actuals_721))
	   {	/* Coerce/app.scm 52 */
	      return
		 convert__122_coerce_convert(
		 (node_bglt) (node_8),
		 (((variable_bglt) CREF(callee_7))->type),
		 (type_bglt) (to_9));
	   }
	 else
	   {	/* Coerce/app.scm 52 */
	      {		/* Coerce/app.scm 55 */
		 node_bglt arg1445_728;
		 {	/* Coerce/app.scm 55 */
		    type_bglt aux_1277;
		    node_bglt aux_1273;
		    {	/* Coerce/app.scm 55 */
		       obj_t aux_1278;
		       aux_1278 =
			  CAR(types_722);
		       aux_1277 =
			  (type_bglt) (aux_1278);
		    }
		    {	/* Coerce/app.scm 55 */
		       obj_t aux_1274;
		       aux_1274 =
			  CAR(actuals_721);
		       aux_1273 =
			  (node_bglt) (aux_1274);
		    }
		    arg1445_728 =
		       coerce__182_coerce_coerce(aux_1273, aux_1277);
		 }
		 {	/* ./Ieee/pair-list.scm 5890 */
		    obj_t aux_1282;
		    aux_1282 =
		       (obj_t) (arg1445_728);
		    SET_CAR(actuals_721, aux_1282);
		 }
	      }
	      {
		 obj_t types_1287;
		 obj_t actuals_1285;
		 actuals_1285 =
		    CDR(actuals_721);
		 types_1287 =
		    CDR(types_722);
		 types_722 = types_1287;
		 actuals_721 = actuals_1285;
		 goto loop_723;
	      }
	   }
      }
   }
}



/* coerce-foreign-va-app! */
node_bglt 
coerce_foreign_va_app__44_coerce_app(value_bglt fun_10, variable_bglt callee_11, app_bglt node_12, obj_t to_13)
{
   AN_OBJECT;
   {	/* Coerce/app.scm 61 */
      {
	 obj_t actuals_733;
	 obj_t types_734;
	 long counter_735;
	 actuals_733 =
	    (((app_bglt) CREF(node_12))->args);
	 {	/* Coerce/app.scm 63 */
	    cfun_bglt obj_1157;
	    obj_1157 =
	       (cfun_bglt) (fun_10);
	    types_734 =
	       (((cfun_bglt) CREF(obj_1157))->args_type_205);
	 }
	 {	/* Coerce/app.scm 64 */
	    fun_bglt obj_1158;
	    obj_1158 =
	       (fun_bglt) (fun_10);
	    counter_735 =
	       (((fun_bglt) CREF(obj_1158))->arity);
	 }
       loop_736:
	 if (
	    (counter_735 == ((long) -1)))
	   {
	      obj_t actuals_741;
	      actuals_741 = actuals_733;
	    loop_742:
	      if (
		 NULLP(actuals_741))
		{	/* Coerce/app.scm 68 */
		   return
		      convert__122_coerce_convert(
		      (node_bglt) (node_12),
		      (((variable_bglt) CREF(callee_11))->type),
		      (type_bglt) (to_13));
		}
	      else
		{	/* Coerce/app.scm 68 */
		   {	/* Coerce/app.scm 71 */
		      node_bglt arg1458_745;
		      {		/* Coerce/app.scm 71 */
			 type_bglt aux_1304;
			 node_bglt aux_1300;
			 {	/* Coerce/app.scm 71 */
			    obj_t aux_1305;
			    aux_1305 =
			       CAR(types_734);
			    aux_1304 =
			       (type_bglt) (aux_1305);
			 }
			 {	/* Coerce/app.scm 71 */
			    obj_t aux_1301;
			    aux_1301 =
			       CAR(actuals_741);
			    aux_1300 =
			       (node_bglt) (aux_1301);
			 }
			 arg1458_745 =
			    coerce__182_coerce_coerce(aux_1300, aux_1304);
		      }
		      {		/* ./Ieee/pair-list.scm 5890 */
			 obj_t aux_1309;
			 aux_1309 =
			    (obj_t) (arg1458_745);
			 SET_CAR(actuals_741, aux_1309);
		      }
		   }
		   {
		      obj_t actuals_1312;
		      actuals_1312 =
			 CDR(actuals_741);
		      actuals_741 = actuals_1312;
		      goto loop_742;
		   }
		}
	   }
	 else
	   {	/* Coerce/app.scm 65 */
	      {		/* Coerce/app.scm 74 */
		 node_bglt arg1463_749;
		 {	/* Coerce/app.scm 74 */
		    type_bglt aux_1318;
		    node_bglt aux_1314;
		    {	/* Coerce/app.scm 74 */
		       obj_t aux_1319;
		       aux_1319 =
			  CAR(types_734);
		       aux_1318 =
			  (type_bglt) (aux_1319);
		    }
		    {	/* Coerce/app.scm 74 */
		       obj_t aux_1315;
		       aux_1315 =
			  CAR(actuals_733);
		       aux_1314 =
			  (node_bglt) (aux_1315);
		    }
		    arg1463_749 =
		       coerce__182_coerce_coerce(aux_1314, aux_1318);
		 }
		 {	/* ./Ieee/pair-list.scm 5890 */
		    obj_t aux_1323;
		    aux_1323 =
		       (obj_t) (arg1463_749);
		    SET_CAR(actuals_733, aux_1323);
		 }
	      }
	      {
		 long counter_1330;
		 obj_t types_1328;
		 obj_t actuals_1326;
		 actuals_1326 =
		    CDR(actuals_733);
		 types_1328 =
		    CDR(types_734);
		 counter_1330 =
		    (counter_735 + ((long) 1));
		 counter_735 = counter_1330;
		 types_734 = types_1328;
		 actuals_733 = actuals_1326;
		 goto loop_736;
	      }
	   }
      }
   }
}



/* coerce-bigloo-app! */
node_bglt 
coerce_bigloo_app__198_coerce_app(variable_bglt callee_14, app_bglt node_15, obj_t to_16)
{
   AN_OBJECT;
   {	/* Coerce/app.scm 80 */
      {		/* Coerce/app.scm 84 */
	 bool_t test1471_755;
	 {	/* Coerce/app.scm 84 */
	    bool_t test1472_756;
	    test1472_756 =
	       is_a__118___object(
	       (obj_t) (callee_14), global_ast_var);
	    if (test1472_756)
	      {		/* Coerce/app.scm 85 */
		 bool_t test_1340;
		 {	/* ./Ieee/equiv.scm 5508 */
		    obj_t aux_1344;
		    obj_t aux_1341;
		    aux_1344 =
		       CNST_TABLE_REF(((long) 0));
		    {	/* Coerce/app.scm 85 */
		       global_bglt obj_1177;
		       obj_1177 =
			  (global_bglt) (callee_14);
		       aux_1341 =
			  (((global_bglt) CREF(obj_1177))->import);
		    }
		    test_1340 =
		       (aux_1341 == aux_1344);
		 }
		 if (test_1340)
		   {	/* Coerce/app.scm 86 */
		      bool_t test_1347;
		      {		/* ./Ieee/pair-list.scm 5669 */
			 obj_t aux_1348;
			 {	/* Coerce/app.scm 86 */
			    sfun_bglt obj_1181;
			    {	/* Coerce/app.scm 86 */
			       value_bglt aux_1349;
			       aux_1349 =
				  (((variable_bglt) CREF(callee_14))->value);
			       obj_1181 =
				  (sfun_bglt) (aux_1349);
			    }
			    aux_1348 =
			       (((sfun_bglt) CREF(obj_1181))->args);
			 }
			 test_1347 =
			    PAIRP(aux_1348);
		      }
		      if (test_1347)
			{	/* ./Type/type.scm 621 */
			   obj_t aux_1354;
			   {	/* ./Ieee/pair-list.scm 5701 */
			      obj_t aux_1355;
			      {		/* Coerce/app.scm 87 */
				 sfun_bglt obj_1184;
				 {	/* Coerce/app.scm 87 */
				    value_bglt aux_1356;
				    aux_1356 =
				       (((variable_bglt) CREF(callee_14))->value);
				    obj_1184 =
				       (sfun_bglt) (aux_1356);
				 }
				 aux_1355 =
				    (((sfun_bglt) CREF(obj_1184))->args);
			      }
			      aux_1354 =
				 CAR(aux_1355);
			   }
			   test1471_755 =
			      is_a__118___object(aux_1354, type_type_type);
			}
		      else
			{	/* Coerce/app.scm 86 */
			   test1471_755 = ((bool_t) 0);
			}
		   }
		 else
		   {	/* Coerce/app.scm 85 */
		      test1471_755 = ((bool_t) 0);
		   }
	      }
	    else
	      {		/* Coerce/app.scm 84 */
		 test1471_755 = ((bool_t) 0);
	      }
	 }
	 if (test1471_755)
	   {	/* Coerce/app.scm 84 */
	      return
		 coerce_bigloo_extern_app__81_coerce_app(callee_14, node_15, to_16);
	   }
	 else
	   {	/* Coerce/app.scm 84 */
	      return
		 coerce_bigloo_intern_app__35_coerce_app(callee_14, node_15, to_16);
	   }
      }
   }
}



/* coerce-bigloo-intern-app! */
node_bglt 
coerce_bigloo_intern_app__35_coerce_app(variable_bglt callee_17, app_bglt node_18, obj_t to_19)
{
   AN_OBJECT;
   {	/* Coerce/app.scm 94 */
      {		/* Coerce/app.scm 95 */
	 value_bglt fun_766;
	 fun_766 =
	    (((variable_bglt) CREF(callee_17))->value);
	 {	/* Coerce/app.scm 96 */
	    obj_t sh_768;
	    sh_768 =
	       shape_tools_shape(
	       (obj_t) (callee_17));
	    {	/* Coerce/app.scm 97 */

	       {
		  obj_t actuals_769;
		  obj_t formals_770;
		  actuals_769 =
		     (((app_bglt) CREF(node_18))->args);
		  {	/* Coerce/app.scm 99 */
		     sfun_bglt obj_1190;
		     obj_1190 =
			(sfun_bglt) (fun_766);
		     formals_770 =
			(((sfun_bglt) CREF(obj_1190))->args);
		  }
		loop_771:
		  {	/* Coerce/app.scm 100 */
		     bool_t test_1368;
		     {	/* ./Ieee/fixnum.scm 7109 */
			long aux_1371;
			long aux_1369;
			aux_1371 =
			   list_length(formals_770);
			aux_1369 =
			   list_length(actuals_769);
			test_1368 =
			   (aux_1369 == aux_1371);
		     }
		     if (test_1368)
		       {	/* Coerce/app.scm 100 */
			  BUNSPEC;
		       }
		     else
		       {	/* Coerce/app.scm 100 */
			  {	/* Coerce/app.scm 100 */
			     obj_t arg1485_775;
			     obj_t arg1486_776;
			     arg1485_775 =
				CNST_TABLE_REF(((long) 1));
			     arg1486_776 =
				__EVMEANING_ADDRESS(sh_768);
			     define_primop_ref__105___evenv(arg1485_775, arg1486_776);
			  }
			  {	/* Coerce/app.scm 100 */
			     obj_t arg1488_777;
			     obj_t arg1489_778;
			     arg1488_777 =
				CNST_TABLE_REF(((long) 2));
			     arg1489_778 =
				__EVMEANING_ADDRESS(formals_770);
			     define_primop_ref__105___evenv(arg1488_777, arg1489_778);
			  }
			  {	/* Coerce/app.scm 100 */
			     obj_t arg1490_779;
			     obj_t arg1491_780;
			     arg1490_779 =
				CNST_TABLE_REF(((long) 3));
			     arg1491_780 =
				__EVMEANING_ADDRESS(actuals_769);
			     define_primop_ref__105___evenv(arg1490_779, arg1491_780);
			  }
			  notify_assert_fail_37___eval(
			     CNST_TABLE_REF(((long) 4)),
			     CNST_TABLE_REF(((long) 5)),
			     CNST_TABLE_REF(((long) 6)));
			  unbind_primop__163___evenv(
			     CNST_TABLE_REF(((long) 1)));
			  unbind_primop__163___evenv(
			     CNST_TABLE_REF(((long) 2)));
			  unbind_primop__163___evenv(
			     CNST_TABLE_REF(((long) 3)));
		       }
		  }
		  if (
		     NULLP(actuals_769))
		    {	/* Coerce/app.scm 101 */
		       return
			  convert__122_coerce_convert(
			  (node_bglt) (node_18),
			  (((variable_bglt) CREF(callee_17))->type),
			  (type_bglt) (to_19));
		    }
		  else
		    {	/* Coerce/app.scm 101 */
		       {	/* Coerce/app.scm 104 */
			  node_bglt arg1497_786;
			  {	/* Coerce/app.scm 104 */
			     type_bglt aux_1403;
			     node_bglt aux_1399;
			     {	/* Coerce/app.scm 103 */
				local_bglt obj_1196;
				{	/* Coerce/app.scm 103 */
				   obj_t aux_1404;
				   aux_1404 =
				      CAR(formals_770);
				   obj_1196 =
				      (local_bglt) (aux_1404);
				}
				aux_1403 =
				   (((local_bglt) CREF(obj_1196))->type);
			     }
			     {	/* Coerce/app.scm 104 */
				obj_t aux_1400;
				aux_1400 =
				   CAR(actuals_769);
				aux_1399 =
				   (node_bglt) (aux_1400);
			     }
			     arg1497_786 =
				coerce__182_coerce_coerce(aux_1399, aux_1403);
			  }
			  {	/* ./Ieee/pair-list.scm 5890 */
			     obj_t aux_1409;
			     aux_1409 =
				(obj_t) (arg1497_786);
			     SET_CAR(actuals_769, aux_1409);
			  }
		       }
		       {
			  obj_t formals_1414;
			  obj_t actuals_1412;
			  actuals_1412 =
			     CDR(actuals_769);
			  formals_1414 =
			     CDR(formals_770);
			  formals_770 = formals_1414;
			  actuals_769 = actuals_1412;
			  goto loop_771;
		       }
		    }
	       }
	    }
	 }
      }
   }
}



/* coerce-bigloo-extern-app! */
node_bglt 
coerce_bigloo_extern_app__81_coerce_app(variable_bglt callee_20, app_bglt node_21, obj_t to_22)
{
   AN_OBJECT;
   {	/* Coerce/app.scm 110 */
      {		/* Coerce/app.scm 112 */

	 {
	    obj_t actuals_793;
	    obj_t formals_794;
	    actuals_793 =
	       (((app_bglt) CREF(node_21))->args);
	    {	/* Coerce/app.scm 114 */
	       sfun_bglt obj_1205;
	       {	/* Coerce/app.scm 114 */
		  value_bglt aux_1442;
		  aux_1442 =
		     (((variable_bglt) CREF(callee_20))->value);
		  obj_1205 =
		     (sfun_bglt) (aux_1442);
	       }
	       formals_794 =
		  (((sfun_bglt) CREF(obj_1205))->args);
	    }
	  loop_795:
	    if (
	       NULLP(actuals_793))
	      {		/* Coerce/app.scm 115 */
		 return
		    convert__122_coerce_convert(
		    (node_bglt) (node_21),
		    (((variable_bglt) CREF(callee_20))->type),
		    (type_bglt) (to_22));
	      }
	    else
	      {		/* Coerce/app.scm 115 */
		 {	/* Coerce/app.scm 118 */
		    node_bglt arg1506_801;
		    {	/* Coerce/app.scm 118 */
		       type_bglt aux_1429;
		       node_bglt aux_1425;
		       {	/* Coerce/app.scm 118 */
			  obj_t aux_1430;
			  aux_1430 =
			     CAR(formals_794);
			  aux_1429 =
			     (type_bglt) (aux_1430);
		       }
		       {	/* Coerce/app.scm 118 */
			  obj_t aux_1426;
			  aux_1426 =
			     CAR(actuals_793);
			  aux_1425 =
			     (node_bglt) (aux_1426);
		       }
		       arg1506_801 =
			  coerce__182_coerce_coerce(aux_1425, aux_1429);
		    }
		    {	/* ./Ieee/pair-list.scm 5890 */
		       obj_t aux_1434;
		       aux_1434 =
			  (obj_t) (arg1506_801);
		       SET_CAR(actuals_793, aux_1434);
		    }
		 }
		 {
		    obj_t formals_1439;
		    obj_t actuals_1437;
		    actuals_1437 =
		       CDR(actuals_793);
		    formals_1439 =
		       CDR(formals_794);
		    formals_794 = formals_1439;
		    actuals_793 = actuals_1437;
		    goto loop_795;
		 }
	      }
	 }
      }
   }
}



/* method-init */
obj_t 
method_init_76_coerce_app()
{
   AN_OBJECT;
   {	/* Coerce/app.scm 14 */
      {		/* Coerce/app.scm 14 */
	 obj_t coerce__app1439_89_1219;
	 coerce__app1439_89_1219 = proc1598_coerce_app;
	 return
	    add_method__1___object(coerce__env_127_coerce_coerce, app_ast_node, coerce__app1439_89_1219);
      }
   }
}



/* coerce!-app1439 */
obj_t 
coerce__app1439_89_coerce_app(obj_t env_1220, obj_t node_1221, obj_t to_1222)
{
   AN_OBJECT;
   {	/* Coerce/app.scm 28 */
      {
	 app_bglt node_1131;
	 obj_t to_1132;
	 {	/* Coerce/app.scm 29 */
	    node_bglt aux_1447;
	    node_1131 =
	       (app_bglt) (node_1221);
	    to_1132 = to_1222;
	    {	/* Coerce/app.scm 29 */
	       variable_bglt fun_1135;
	       {	/* Coerce/app.scm 29 */
		  var_bglt arg1594_1139;
		  arg1594_1139 =
		     (((app_bglt) CREF(node_1131))->fun);
		  fun_1135 =
		     (((var_bglt) CREF(arg1594_1139))->variable);
	       }
	       {	/* Coerce/app.scm 30 */
		  bool_t test1591_1136;
		  {	/* Coerce/app.scm 30 */
		     bool_t test1592_1137;
		     test1592_1137 =
			is_a__118___object(
			(obj_t) (fun_1135), global_ast_var);
		     if (test1592_1137)
		       {	/* ./Ast/var.scm 845 */
			  obj_t aux_1453;
			  {	/* Coerce/app.scm 30 */
			     value_bglt aux_1454;
			     aux_1454 =
				(((variable_bglt) CREF(fun_1135))->value);
			     aux_1453 =
				(obj_t) (aux_1454);
			  }
			  test1591_1136 =
			     is_a__118___object(aux_1453, cfun_ast_var);
		       }
		     else
		       {	/* Coerce/app.scm 30 */
			  test1591_1136 = ((bool_t) 0);
		       }
		  }
		  if (test1591_1136)
		    {	/* Coerce/app.scm 30 */
		       aux_1447 =
			  coerce_foreign_app__190_coerce_app(fun_1135, node_1131, to_1132)
			  ;
		    }
		  else
		    {	/* Coerce/app.scm 30 */
		       aux_1447 =
			  coerce_bigloo_app__198_coerce_app(fun_1135, node_1131, to_1132)
			  ;
		    }
	       }
	    }
	    return
	       (obj_t) (aux_1447);
	 }
      }
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_coerce_app()
{
   AN_OBJECT;
   {	/* Coerce/app.scm 14 */
      module_initialization_70_tools_trace(((long) 0), "COERCE_APP");
      module_initialization_70_engine_param(((long) 0), "COERCE_APP");
      module_initialization_70_tools_shape(((long) 0), "COERCE_APP");
      module_initialization_70_type_type(((long) 0), "COERCE_APP");
      module_initialization_70_type_cache(((long) 0), "COERCE_APP");
      module_initialization_70_ast_var(((long) 0), "COERCE_APP");
      module_initialization_70_ast_node(((long) 0), "COERCE_APP");
      module_initialization_70_coerce_coerce(((long) 0), "COERCE_APP");
      return
	 module_initialization_70_coerce_convert(((long) 0), "COERCE_APP");
   }
}
