/*===========================================================================*/
/*   (Coerce/apply.scm)                                                      */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;


static obj_t method_init_76_coerce_apply();
extern obj_t symbol_append_197___r4_symbols_6_4(obj_t);
extern obj_t let_var_6_ast_node;
extern obj_t var_ast_node;
extern obj_t location_full_fname_231_tools_location(obj_t);
extern obj_t _bdb_debug__1_engine_param;
extern obj_t add_method__1___object(obj_t, obj_t, obj_t);
extern obj_t gensym___r4_symbols_6_4;
extern obj_t _obj__252_type_cache;
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t current_function_76_tools_error();
extern obj_t module_initialization_70_coerce_apply(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_location(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_ast_sexp(long, char *);
extern obj_t module_initialization_70_ast_local(long, char *);
extern obj_t module_initialization_70_coerce_coerce(long, char *);
extern obj_t module_initialization_70_coerce_convert(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_symbols_6_4(long, char *);
extern obj_t _unsafe_arity__240_engine_param;
extern local_bglt make_local_svar_140_ast_local(obj_t, type_bglt);
extern long class_num_218___object(obj_t);
static obj_t imported_modules_init_94_coerce_apply();
extern obj_t app_ly_162_ast_node;
extern node_bglt coerce__182_coerce_coerce(node_bglt, type_bglt);
static obj_t library_modules_init_112_coerce_apply();
static obj_t toplevel_init_63_coerce_apply();
extern obj_t _unsafe_type__146_engine_param;
extern obj_t open_input_string(obj_t);
static obj_t coerce__app_ly1443_180_coerce_apply(obj_t, obj_t, obj_t);
extern node_bglt top_level_sexp__node_204_ast_sexp(obj_t, obj_t);
extern node_bglt convert__122_coerce_convert(node_bglt, type_bglt, type_bglt);
extern obj_t _compiler_debug__134_engine_param;
extern obj_t shape_tools_shape(obj_t);
extern obj_t _procedure__226_type_cache;
extern obj_t read___reader(obj_t);
static node_bglt make_error_node_135_coerce_apply(obj_t, obj_t, obj_t);
static obj_t require_initialization_114_coerce_apply = BUNSPEC;
static obj_t cnst_init_137_coerce_apply();
static obj_t __cnst[16];

DEFINE_STATIC_PROCEDURE(proc1666_coerce_apply, coerce__app_ly1443_180_coerce_apply1672, coerce__app_ly1443_180_coerce_apply, 0L, 2);
DEFINE_STRING(string1667_coerce_apply, string1667_coerce_apply1673, "CORRECT-ARITY? IF LENGTH ::LONG LET LEN VAL FUN _ FAILURE QUOTE __ERROR ERROR/LOCATION @ BEGIN LOCATION ", 104);
DEFINE_STRING(string1665_coerce_apply, string1665_coerce_apply1674, "Wrong number of arguments", 25);
extern obj_t coerce__env_127_coerce_coerce;



/* module-initialization */
obj_t 
module_initialization_70_coerce_apply(long checksum_1419, char *from_1420)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_coerce_apply))
	{
	   require_initialization_114_coerce_apply =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_coerce_apply();
	   cnst_init_137_coerce_apply();
	   imported_modules_init_94_coerce_apply();
	   method_init_76_coerce_apply();
	   toplevel_init_63_coerce_apply();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_coerce_apply()
{
   AN_OBJECT;
   {	/* Coerce/apply.scm 14 */
      module_initialization_70___r4_symbols_6_4(((long) 0), "COERCE_APPLY");
      module_initialization_70___object(((long) 0), "COERCE_APPLY");
      module_initialization_70___reader(((long) 0), "COERCE_APPLY");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_coerce_apply()
{
   AN_OBJECT;
   {	/* Coerce/apply.scm 14 */
      {		/* Coerce/apply.scm 14 */
	 obj_t cnst_port_138_1412;
	 cnst_port_138_1412 =
	    open_input_string(string1667_coerce_apply);
	 {
	    long i_1413;
	    i_1413 = ((long) 15);
	  loop_1414:
	    {	/* Coerce/apply.scm 14 */
	       bool_t test1668_1415;
	       test1668_1415 =
		  (i_1413 == ((long) -1));
	       if (test1668_1415)
		 {	/* Coerce/apply.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Coerce/apply.scm 14 */
		    {	/* Coerce/apply.scm 14 */
		       obj_t arg1669_1416;
		       {	/* Coerce/apply.scm 14 */
			  obj_t list1670_1417;
			  list1670_1417 =
			     MAKE_PAIR(cnst_port_138_1412, BNIL);
			  arg1669_1416 =
			     read___reader(list1670_1417);
		       }
		       CNST_TABLE_SET(i_1413, arg1669_1416);
		    }
		    {	/* Coerce/apply.scm 14 */
		       int aux_1418;
		       {	/* Coerce/apply.scm 14 */
			  long aux_1438;
			  aux_1438 =
			     (i_1413 - ((long) 1));
			  aux_1418 =
			     (int) (aux_1438);
		       }
		       {
			  long i_1441;
			  i_1441 =
			     (long) (aux_1418);
			  i_1413 = i_1441;
			  goto loop_1414;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_coerce_apply()
{
   AN_OBJECT;
   {	/* Coerce/apply.scm 14 */
      return BUNSPEC;
   }
}



/* make-error-node */
node_bglt 
make_error_node_135_coerce_apply(obj_t error_msg_180_17, obj_t loc_18, obj_t to_19)
{
   AN_OBJECT;
   {	/* Coerce/apply.scm 86 */
      {		/* Coerce/apply.scm 87 */
	 obj_t ut_725;
	 ut_725 = _unsafe_type__146_engine_param;
	 _unsafe_type__146_engine_param = BTRUE;
	 {	/* Coerce/apply.scm 89 */
	    node_bglt node_726;
	    {	/* Coerce/apply.scm 91 */
	       node_bglt arg1455_727;
	       {	/* Coerce/apply.scm 91 */
		  obj_t arg1456_728;
		  {	/* Coerce/apply.scm 91 */
		     bool_t test1457_729;
		     {	/* Coerce/apply.scm 91 */
			bool_t test1513_779;
			{	/* Coerce/apply.scm 91 */
			   bool_t test1514_780;
			   {	/* Coerce/apply.scm 91 */
			      long n1_1201;
			      n1_1201 =
				 (long) CINT(_bdb_debug__1_engine_param);
			      test1514_780 =
				 (n1_1201 > ((long) 0));
			   }
			   if (test1514_780)
			     {	/* Coerce/apply.scm 91 */
				test1513_779 = ((bool_t) 1);
			     }
			   else
			     {	/* Coerce/apply.scm 92 */
				long n1_1203;
				n1_1203 =
				   (long) CINT(_compiler_debug__134_engine_param);
				test1513_779 =
				   (n1_1203 > ((long) 0));
			     }
			}
			if (test1513_779)
			  {	/* Coerce/apply.scm 91 */
			     if (
				STRUCTP(loc_18))
			       {	/* ./Ieee/equiv.scm 5508 */
				  obj_t aux_1453;
				  obj_t aux_1451;
				  aux_1453 =
				     CNST_TABLE_REF(((long) 0));
				  aux_1451 =
				     STRUCT_KEY(loc_18);
				  test1457_729 =
				     (aux_1451 == aux_1453);
			       }
			     else
			       {	/* ./Tools/location.sch 395 */
				  test1457_729 = ((bool_t) 0);
			       }
			  }
			else
			  {	/* Coerce/apply.scm 91 */
			     test1457_729 = ((bool_t) 0);
			  }
		     }
		     if (test1457_729)
		       {	/* Coerce/apply.scm 94 */
			  obj_t arg1458_730;
			  obj_t arg1459_731;
			  arg1458_730 =
			     CNST_TABLE_REF(((long) 1));
			  {	/* Coerce/apply.scm 95 */
			     obj_t arg1461_732;
			     obj_t arg1462_733;
			     {	/* Coerce/apply.scm 95 */
				obj_t arg1463_734;
				obj_t arg1464_735;
				{	/* Coerce/apply.scm 95 */
				   obj_t arg1466_736;
				   obj_t arg1467_737;
				   arg1466_736 =
				      CNST_TABLE_REF(((long) 2));
				   {	/* Coerce/apply.scm 95 */
				      obj_t arg1469_738;
				      obj_t arg1470_739;
				      arg1469_738 =
					 CNST_TABLE_REF(((long) 3));
				      {		/* ./Ieee/pair-list.scm 5689 */
					 obj_t aux_1460;
					 aux_1460 =
					    CNST_TABLE_REF(((long) 4));
					 arg1470_739 =
					    MAKE_PAIR(aux_1460, BNIL);
				      }
				      arg1467_737 =
					 MAKE_PAIR(arg1469_738, arg1470_739);
				   }
				   arg1463_734 =
				      MAKE_PAIR(arg1466_736, arg1467_737);
				}
				{	/* Coerce/apply.scm 96 */
				   obj_t arg1471_740;
				   obj_t arg1472_741;
				   {	/* Coerce/apply.scm 96 */
				      obj_t arg1473_742;
				      obj_t arg1474_743;
				      arg1473_742 =
					 CNST_TABLE_REF(((long) 5));
				      arg1474_743 =
					 current_function_76_tools_error();
				      {		/* Coerce/apply.scm 96 */
					 obj_t list1475_744;
					 {	/* Coerce/apply.scm 96 */
					    obj_t arg1476_745;
					    arg1476_745 =
					       MAKE_PAIR(arg1474_743, BNIL);
					    list1475_744 =
					       MAKE_PAIR(arg1473_742, arg1476_745);
					 }
					 arg1471_740 = list1475_744;
				      }
				   }
				   {	/* Coerce/apply.scm 95 */
				      obj_t arg1478_747;
				      {		/* Coerce/apply.scm 99 */
					 obj_t arg1479_748;
					 {	/* Coerce/apply.scm 99 */
					    obj_t arg1480_749;
					    obj_t arg1481_750;
					    arg1480_749 =
					       location_full_fname_231_tools_location(loc_18);
					    {	/* ./Ieee/pair-list.scm 5689 */
					       obj_t aux_1470;
					       aux_1470 =
						  STRUCT_REF(loc_18, ((long) 1));
					       arg1481_750 =
						  MAKE_PAIR(aux_1470, BNIL);
					    }
					    arg1479_748 =
					       MAKE_PAIR(arg1480_749, arg1481_750);
					 }
					 arg1478_747 =
					    MAKE_PAIR(error_msg_180_17, arg1479_748);
				      }
				      arg1472_741 =
					 MAKE_PAIR(string1665_coerce_apply, arg1478_747);
				   }
				   arg1464_735 =
				      MAKE_PAIR(arg1471_740, arg1472_741);
				}
				arg1461_732 =
				   MAKE_PAIR(arg1463_734, arg1464_735);
			     }
			     {	/* Coerce/apply.scm 101 */
				obj_t arg1484_753;
				{	/* Coerce/apply.scm 101 */
				   obj_t arg1486_755;
				   obj_t arg1488_756;
				   arg1486_755 =
				      CNST_TABLE_REF(((long) 6));
				   {	/* Coerce/apply.scm 101 */
				      obj_t arg1489_757;
				      obj_t arg1490_758;
				      {		/* Coerce/apply.scm 101 */
					 obj_t arg1491_759;
					 obj_t arg1493_760;
					 arg1491_759 =
					    CNST_TABLE_REF(((long) 5));
					 {	/* ./Ieee/pair-list.scm 5689 */
					    obj_t aux_1480;
					    aux_1480 =
					       CNST_TABLE_REF(((long) 7));
					    arg1493_760 =
					       MAKE_PAIR(aux_1480, BNIL);
					 }
					 arg1489_757 =
					    MAKE_PAIR(arg1491_759, arg1493_760);
				      }
				      {		/* Coerce/apply.scm 101 */
					 obj_t arg1494_761;
					 obj_t arg1495_762;
					 {	/* Coerce/apply.scm 101 */
					    obj_t arg1496_763;
					    obj_t arg1497_764;
					    arg1496_763 =
					       CNST_TABLE_REF(((long) 5));
					    {	/* ./Ieee/pair-list.scm 5689 */
					       obj_t aux_1485;
					       aux_1485 =
						  CNST_TABLE_REF(((long) 7));
					       arg1497_764 =
						  MAKE_PAIR(aux_1485, BNIL);
					    }
					    arg1494_761 =
					       MAKE_PAIR(arg1496_763, arg1497_764);
					 }
					 {	/* Coerce/apply.scm 101 */
					    obj_t arg1498_765;
					    {	/* Coerce/apply.scm 101 */
					       obj_t arg1500_767;
					       obj_t arg1501_768;
					       arg1500_767 =
						  CNST_TABLE_REF(((long) 5));
					       {	/* ./Ieee/pair-list.scm 5689 */
						  obj_t aux_1490;
						  aux_1490 =
						     CNST_TABLE_REF(((long) 7));
						  arg1501_768 =
						     MAKE_PAIR(aux_1490, BNIL);
					       }
					       arg1498_765 =
						  MAKE_PAIR(arg1500_767, arg1501_768);
					    }
					    arg1495_762 =
					       MAKE_PAIR(arg1498_765, BNIL);
					 }
					 arg1490_758 =
					    MAKE_PAIR(arg1494_761, arg1495_762);
				      }
				      arg1488_756 =
					 MAKE_PAIR(arg1489_757, arg1490_758);
				   }
				   arg1484_753 =
				      MAKE_PAIR(arg1486_755, arg1488_756);
				}
				arg1462_733 =
				   MAKE_PAIR(arg1484_753, BNIL);
			     }
			     arg1459_731 =
				MAKE_PAIR(arg1461_732, arg1462_733);
			  }
			  arg1456_728 =
			     MAKE_PAIR(arg1458_730, arg1459_731);
		       }
		     else
		       {	/* Coerce/apply.scm 102 */
			  obj_t arg1502_769;
			  obj_t arg1503_770;
			  arg1502_769 =
			     CNST_TABLE_REF(((long) 6));
			  {	/* Coerce/apply.scm 102 */
			     obj_t arg1504_771;
			     obj_t arg1505_772;
			     {	/* Coerce/apply.scm 102 */
				obj_t arg1506_773;
				obj_t arg1508_774;
				arg1506_773 =
				   CNST_TABLE_REF(((long) 5));
				arg1508_774 =
				   current_function_76_tools_error();
				{	/* Coerce/apply.scm 102 */
				   obj_t list1509_775;
				   {	/* Coerce/apply.scm 102 */
				      obj_t arg1510_776;
				      arg1510_776 =
					 MAKE_PAIR(arg1508_774, BNIL);
				      list1509_775 =
					 MAKE_PAIR(arg1506_773, arg1510_776);
				   }
				   arg1504_771 = list1509_775;
				}
			     }
			     {	/* Coerce/apply.scm 102 */
				obj_t arg1512_778;
				arg1512_778 =
				   MAKE_PAIR(error_msg_180_17, BNIL);
				arg1505_772 =
				   MAKE_PAIR(string1665_coerce_apply, arg1512_778);
			     }
			     arg1503_770 =
				MAKE_PAIR(arg1504_771, arg1505_772);
			  }
			  arg1456_728 =
			     MAKE_PAIR(arg1502_769, arg1503_770);
		       }
		  }
		  arg1455_727 =
		     top_level_sexp__node_204_ast_sexp(arg1456_728, loc_18);
	       }
	       node_726 =
		  coerce__182_coerce_coerce(arg1455_727,
		  (type_bglt) (to_19));
	    }
	    _unsafe_type__146_engine_param = ut_725;
	    return node_726;
	 }
      }
   }
}



/* method-init */
obj_t 
method_init_76_coerce_apply()
{
   AN_OBJECT;
   {	/* Coerce/apply.scm 14 */
      {		/* Coerce/apply.scm 14 */
	 obj_t coerce__app_ly1443_180_1404;
	 coerce__app_ly1443_180_1404 = proc1666_coerce_apply;
	 return
	    add_method__1___object(coerce__env_127_coerce_coerce, app_ly_162_ast_node, coerce__app_ly1443_180_1404);
      }
   }
}



/* coerce!-app-ly1443 */
obj_t 
coerce__app_ly1443_180_coerce_apply(obj_t env_1405, obj_t node_1406, obj_t to_1407)
{
   AN_OBJECT;
   {	/* Coerce/apply.scm 33 */
      {
	 app_ly_162_bglt node_1107;
	 obj_t to_1108;
	 node_1107 =
	    (app_ly_162_bglt) (node_1406);
	 to_1108 = to_1407;
	 {	/* Coerce/apply.scm 35 */
	    obj_t error_msg_180_1111;
	    {	/* Coerce/apply.scm 35 */
	       obj_t arg1653_1176;
	       obj_t arg1654_1177;
	       arg1653_1176 =
		  CNST_TABLE_REF(((long) 5));
	       arg1654_1177 =
		  shape_tools_shape(
		  (obj_t) (node_1107));
	       {	/* Coerce/apply.scm 35 */
		  obj_t list1655_1178;
		  {	/* Coerce/apply.scm 35 */
		     obj_t arg1656_1179;
		     arg1656_1179 =
			MAKE_PAIR(arg1654_1177, BNIL);
		     list1655_1178 =
			MAKE_PAIR(arg1653_1176, arg1656_1179);
		  }
		  error_msg_180_1111 = list1655_1178;
	       }
	    }
	    {	/* Coerce/apply.scm 37 */
	       node_bglt arg1595_1112;
	       arg1595_1112 =
		  coerce__182_coerce_coerce(
		  (((app_ly_162_bglt) CREF(node_1107))->arg),
		  (type_bglt) (_obj__252_type_cache));
	       ((((app_ly_162_bglt) CREF(node_1107))->arg) = ((node_bglt) arg1595_1112), BUNSPEC);
	    }
	    {	/* Coerce/apply.scm 39 */
	       node_bglt c_fun_136_1114;
	       c_fun_136_1114 =
		  coerce__182_coerce_coerce(
		  (((app_ly_162_bglt) CREF(node_1107))->fun),
		  (type_bglt) (_procedure__226_type_cache));
	       if (
		  CBOOL(_unsafe_arity__240_engine_param))
		 {	/* Coerce/apply.scm 41 */
		    {	/* Coerce/apply.scm 43 */
		       bool_t test1597_1115;
		       test1597_1115 =
			  is_a__118___object(
			  (obj_t) (c_fun_136_1114), var_ast_node);
		       if (test1597_1115)
			 {	/* Coerce/apply.scm 43 */
			    ((((app_ly_162_bglt) CREF(node_1107))->fun) = ((node_bglt) c_fun_136_1114), BUNSPEC);
			    {	/* Coerce/apply.scm 46 */
			       node_bglt aux_1532;
			       aux_1532 =
				  convert__122_coerce_convert(
				  (node_bglt) (node_1107),
				  (type_bglt) (_obj__252_type_cache),
				  (type_bglt) (to_1108));
			       return
				  (obj_t) (aux_1532);
			    }
			 }
		       else
			 {	/* Coerce/apply.scm 47 */
			    local_bglt fun_1116;
			    fun_1116 =
			       make_local_svar_140_ast_local(
			       CNST_TABLE_REF(((long) 8)),
			       (type_bglt) (_procedure__226_type_cache));
			    ((((app_ly_162_bglt) CREF(node_1107))->fun) = ((node_bglt) c_fun_136_1114), BUNSPEC);
			    {	/* Coerce/apply.scm 50 */
			       obj_t arg1598_1117;
			       type_bglt arg1599_1118;
			       obj_t arg1601_1120;
			       node_bglt arg1602_1121;
			       {	/* Coerce/apply.scm 50 */
				  node_bglt obj_1298;
				  obj_1298 =
				     (node_bglt) (node_1107);
				  arg1598_1117 =
				     (((node_bglt) CREF(obj_1298))->loc);
			       }
			       {	/* Coerce/apply.scm 51 */
				  node_bglt obj_1299;
				  obj_1299 =
				     (node_bglt) (node_1107);
				  arg1599_1118 =
				     (((node_bglt) CREF(obj_1299))->type);
			       }
			       {	/* Coerce/apply.scm 52 */
				  obj_t arg1603_1122;
				  {	/* ./Ieee/pair-list.scm 5689 */
				     obj_t aux_1548;
				     obj_t aux_1546;
				     aux_1548 =
					(obj_t) (c_fun_136_1114);
				     aux_1546 =
					(obj_t) (fun_1116);
				     arg1603_1122 =
					MAKE_PAIR(aux_1546, aux_1548);
				  }
				  {	/* Coerce/apply.scm 52 */
				     obj_t list1604_1123;
				     list1604_1123 =
					MAKE_PAIR(arg1603_1122, BNIL);
				     arg1601_1120 = list1604_1123;
				  }
			       }
			       arg1602_1121 =
				  convert__122_coerce_convert(
				  (node_bglt) (node_1107),
				  (type_bglt) (_obj__252_type_cache),
				  (type_bglt) (to_1108));
			       {	/* Coerce/apply.scm 49 */
				  let_var_6_bglt res1659_1321;
				  {	/* Coerce/apply.scm 49 */
				     obj_t key_1306;
				     key_1306 =
					BINT(((long) -1));
				     {	/* ./Ast/node.scm 1088 */
					let_var_6_bglt new1373_1310;
					new1373_1310 =
					   ((let_var_6_bglt) BREF(GC_MALLOC(sizeof(struct let_var_6))));
					{	/* ./Ast/node.scm 1088 */
					   long arg1528_1311;
					   arg1528_1311 =
					      class_num_218___object(let_var_6_ast_node);
					   {	/* ./Ast/node.scm 1088 */
					      obj_t obj_1319;
					      obj_1319 =
						 (obj_t) (new1373_1310);
					      (((obj_t) CREF(obj_1319))->header = MAKE_HEADER(arg1528_1311, 0), BUNSPEC);
					   }
					}
					{	/* ./Ast/node.scm 1088 */
					   object_bglt aux_1561;
					   aux_1561 =
					      (object_bglt) (new1373_1310);
					   OBJECT_WIDENING_SET(aux_1561, BFALSE);
					}
					((((let_var_6_bglt) CREF(new1373_1310))->loc) = ((obj_t) arg1598_1117), BUNSPEC);
					((((let_var_6_bglt) CREF(new1373_1310))->type) = ((type_bglt) arg1599_1118), BUNSPEC);
					((((let_var_6_bglt) CREF(new1373_1310))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
					((((let_var_6_bglt) CREF(new1373_1310))->key) = ((obj_t) key_1306), BUNSPEC);
					((((let_var_6_bglt) CREF(new1373_1310))->bindings) = ((obj_t) arg1601_1120), BUNSPEC);
					((((let_var_6_bglt) CREF(new1373_1310))->body) = ((node_bglt) arg1602_1121), BUNSPEC);
					((((let_var_6_bglt) CREF(new1373_1310))->removable__42) = ((bool_t) ((bool_t) 1)), BUNSPEC);
					res1659_1321 = new1373_1310;
				     }
				  }
				  return
				     (obj_t) (res1659_1321);
			       }
			    }
			 }
		    }
		 }
	       else
		 {	/* Coerce/apply.scm 54 */
		    local_bglt fun_1124;
		    fun_1124 =
		       make_local_svar_140_ast_local(
		       CNST_TABLE_REF(((long) 8)),
		       (type_bglt) (_procedure__226_type_cache));
		    {	/* Coerce/apply.scm 54 */
		       local_bglt val_1125;
		       val_1125 =
			  make_local_svar_140_ast_local(
			  CNST_TABLE_REF(((long) 9)),
			  (type_bglt) (_procedure__226_type_cache));
		       {	/* Coerce/apply.scm 55 */
			  obj_t len_1126;
			  len_1126 =
			     PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4,
			     CNST_TABLE_REF(((long) 10)), BEOA);
			  {	/* Coerce/apply.scm 56 */
			     obj_t loc_1127;
			     {	/* Coerce/apply.scm 57 */
				node_bglt obj_1322;
				obj_1322 =
				   (node_bglt) (node_1107);
				loc_1127 =
				   (((node_bglt) CREF(obj_1322))->loc);
			     }
			     {	/* Coerce/apply.scm 57 */
				let_var_6_bglt lnode_1128;
				{	/* Coerce/apply.scm 58 */
				   obj_t arg1614_1138;
				   obj_t arg1616_1140;
				   node_bglt arg1617_1141;
				   arg1614_1138 = _obj__252_type_cache;
				   {	/* Coerce/apply.scm 61 */
				      obj_t arg1618_1142;
				      obj_t arg1619_1143;
				      {		/* ./Ieee/pair-list.scm 5689 */
					 obj_t aux_1585;
					 obj_t aux_1583;
					 aux_1585 =
					    (obj_t) (c_fun_136_1114);
					 aux_1583 =
					    (obj_t) (fun_1124);
					 arg1618_1142 =
					    MAKE_PAIR(aux_1583, aux_1585);
				      }
				      {		/* ./Ieee/pair-list.scm 5689 */
					 obj_t aux_1590;
					 obj_t aux_1588;
					 {	/* Coerce/apply.scm 62 */
					    node_bglt aux_1591;
					    aux_1591 =
					       (((app_ly_162_bglt) CREF(node_1107))->arg);
					    aux_1590 =
					       (obj_t) (aux_1591);
					 }
					 aux_1588 =
					    (obj_t) (val_1125);
					 arg1619_1143 =
					    MAKE_PAIR(aux_1588, aux_1590);
				      }
				      {		/* Coerce/apply.scm 61 */
					 obj_t list1620_1144;
					 {	/* Coerce/apply.scm 61 */
					    obj_t arg1621_1145;
					    arg1621_1145 =
					       MAKE_PAIR(arg1619_1143, BNIL);
					    list1620_1144 =
					       MAKE_PAIR(arg1618_1142, arg1621_1145);
					 }
					 arg1616_1140 = list1620_1144;
				      }
				   }
				   {	/* Coerce/apply.scm 64 */
				      obj_t arg1623_1147;
				      {		/* Coerce/apply.scm 64 */
					 obj_t arg1624_1148;
					 obj_t arg1625_1149;
					 arg1624_1148 =
					    CNST_TABLE_REF(((long) 11));
					 {	/* Coerce/apply.scm 64 */
					    obj_t arg1626_1150;
					    obj_t arg1627_1151;
					    {	/* Coerce/apply.scm 64 */
					       obj_t arg1628_1152;
					       {	/* Coerce/apply.scm 64 */
						  obj_t arg1630_1154;
						  obj_t arg1631_1155;
						  {	/* Coerce/apply.scm 64 */
						     obj_t list1632_1156;
						     {	/* Coerce/apply.scm 64 */
							obj_t arg1633_1157;
							{	/* Coerce/apply.scm 64 */
							   obj_t aux_1598;
							   aux_1598 =
							      CNST_TABLE_REF(((long) 12));
							   arg1633_1157 =
							      MAKE_PAIR(aux_1598, BNIL);
							}
							list1632_1156 =
							   MAKE_PAIR(len_1126, arg1633_1157);
						     }
						     arg1630_1154 =
							symbol_append_197___r4_symbols_6_4(list1632_1156);
						  }
						  {	/* Coerce/apply.scm 65 */
						     obj_t arg1634_1158;
						     {	/* Coerce/apply.scm 65 */
							obj_t arg1636_1160;
							obj_t arg1637_1161;
							arg1636_1160 =
							   CNST_TABLE_REF(((long) 13));
							{	/* ./Ieee/pair-list.scm 5689 */
							   obj_t aux_1604;
							   aux_1604 =
							      (obj_t) (val_1125);
							   arg1637_1161 =
							      MAKE_PAIR(aux_1604, BNIL);
							}
							arg1634_1158 =
							   MAKE_PAIR(arg1636_1160, arg1637_1161);
						     }
						     arg1631_1155 =
							MAKE_PAIR(arg1634_1158, BNIL);
						  }
						  arg1628_1152 =
						     MAKE_PAIR(arg1630_1154, arg1631_1155);
					       }
					       arg1626_1150 =
						  MAKE_PAIR(arg1628_1152, BNIL);
					    }
					    {	/* Coerce/apply.scm 66 */
					       obj_t arg1638_1162;
					       {	/* Coerce/apply.scm 66 */
						  obj_t arg1640_1164;
						  obj_t arg1641_1165;
						  arg1640_1164 =
						     CNST_TABLE_REF(((long) 14));
						  {	/* Coerce/apply.scm 66 */
						     obj_t arg1642_1166;
						     obj_t arg1643_1167;
						     {	/* Coerce/apply.scm 66 */
							obj_t arg1644_1168;
							obj_t arg1646_1169;
							arg1644_1168 =
							   CNST_TABLE_REF(((long) 15));
							{	/* Coerce/apply.scm 66 */
							   obj_t arg1647_1170;
							   arg1647_1170 =
							      MAKE_PAIR(len_1126, BNIL);
							   {	/* ./Ieee/pair-list.scm 5689 */
							      obj_t aux_1614;
							      aux_1614 =
								 (obj_t) (fun_1124);
							      arg1646_1169 =
								 MAKE_PAIR(aux_1614, arg1647_1170);
							   }
							}
							arg1642_1166 =
							   MAKE_PAIR(arg1644_1168, arg1646_1169);
						     }
						     {	/* Coerce/apply.scm 67 */
							node_bglt arg1648_1171;
							obj_t arg1649_1172;
							arg1648_1171 =
							   convert__122_coerce_convert(
							   (node_bglt) (node_1107),
							   (type_bglt) (_obj__252_type_cache),
							   (type_bglt) (to_1108));
							{	/* Coerce/apply.scm 68 */
							   node_bglt arg1650_1173;
							   arg1650_1173 =
							      make_error_node_135_coerce_apply(error_msg_180_1111, loc_1127, to_1108);
							   {	/* ./Ieee/pair-list.scm 5689 */
							      obj_t aux_1623;
							      aux_1623 =
								 (obj_t) (arg1650_1173);
							      arg1649_1172 =
								 MAKE_PAIR(aux_1623, BNIL);
							   }
							}
							{	/* ./Ieee/pair-list.scm 5689 */
							   obj_t aux_1626;
							   aux_1626 =
							      (obj_t) (arg1648_1171);
							   arg1643_1167 =
							      MAKE_PAIR(aux_1626, arg1649_1172);
							}
						     }
						     arg1641_1165 =
							MAKE_PAIR(arg1642_1166, arg1643_1167);
						  }
						  arg1638_1162 =
						     MAKE_PAIR(arg1640_1164, arg1641_1165);
					       }
					       arg1627_1151 =
						  MAKE_PAIR(arg1638_1162, BNIL);
					    }
					    arg1625_1149 =
					       MAKE_PAIR(arg1626_1150, arg1627_1151);
					 }
					 arg1623_1147 =
					    MAKE_PAIR(arg1624_1148, arg1625_1149);
				      }
				      arg1617_1141 =
					 top_level_sexp__node_204_ast_sexp(arg1623_1147, loc_1127);
				   }
				   {	/* Coerce/apply.scm 58 */
				      let_var_6_bglt res1660_1377;
				      {		/* Coerce/apply.scm 58 */
					 type_bglt type_1360;
					 obj_t key_1362;
					 type_1360 =
					    (type_bglt) (arg1614_1138);
					 key_1362 =
					    BINT(((long) -1));
					 {	/* ./Ast/node.scm 1088 */
					    let_var_6_bglt new1373_1366;
					    new1373_1366 =
					       ((let_var_6_bglt) BREF(GC_MALLOC(sizeof(struct let_var_6))));
					    {	/* ./Ast/node.scm 1088 */
					       long arg1528_1367;
					       arg1528_1367 =
						  class_num_218___object(let_var_6_ast_node);
					       {	/* ./Ast/node.scm 1088 */
						  obj_t obj_1375;
						  obj_1375 =
						     (obj_t) (new1373_1366);
						  (((obj_t) CREF(obj_1375))->header = MAKE_HEADER(arg1528_1367, 0), BUNSPEC);
					       }
					    }
					    {	/* ./Ast/node.scm 1088 */
					       object_bglt aux_1641;
					       aux_1641 =
						  (object_bglt) (new1373_1366);
					       OBJECT_WIDENING_SET(aux_1641, BFALSE);
					    }
					    ((((let_var_6_bglt) CREF(new1373_1366))->loc) = ((obj_t) loc_1127), BUNSPEC);
					    ((((let_var_6_bglt) CREF(new1373_1366))->type) = ((type_bglt) type_1360), BUNSPEC);
					    ((((let_var_6_bglt) CREF(new1373_1366))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
					    ((((let_var_6_bglt) CREF(new1373_1366))->key) = ((obj_t) key_1362), BUNSPEC);
					    ((((let_var_6_bglt) CREF(new1373_1366))->bindings) = ((obj_t) arg1616_1140), BUNSPEC);
					    ((((let_var_6_bglt) CREF(new1373_1366))->body) = ((node_bglt) arg1617_1141), BUNSPEC);
					    ((((let_var_6_bglt) CREF(new1373_1366))->removable__42) = ((bool_t) ((bool_t) 1)), BUNSPEC);
					    res1660_1377 = new1373_1366;
					 }
				      }
				      lnode_1128 = res1660_1377;
				   }
				}
				{	/* Coerce/apply.scm 58 */

				   {	/* Coerce/apply.scm 73 */
				      var_bglt arg1605_1129;
				      {		/* Coerce/apply.scm 73 */
					 obj_t arg1607_1131;
					 arg1607_1131 = _procedure__226_type_cache;
					 {	/* Coerce/apply.scm 73 */
					    var_bglt res1661_1388;
					    {	/* Coerce/apply.scm 73 */
					       type_bglt type_1379;
					       variable_bglt variable_1380;
					       type_1379 =
						  (type_bglt) (arg1607_1131);
					       variable_1380 =
						  (variable_bglt) (fun_1124);
					       {	/* ./Ast/node.scm 995 */
						  var_bglt new1210_1381;
						  new1210_1381 =
						     ((var_bglt) BREF(GC_MALLOC(sizeof(struct var))));
						  {	/* ./Ast/node.scm 995 */
						     long arg1561_1382;
						     arg1561_1382 =
							class_num_218___object(var_ast_node);
						     {	/* ./Ast/node.scm 995 */
							obj_t obj_1386;
							obj_1386 =
							   (obj_t) (new1210_1381);
							(((obj_t) CREF(obj_1386))->header = MAKE_HEADER(arg1561_1382, 0), BUNSPEC);
						     }
						  }
						  {	/* ./Ast/node.scm 995 */
						     object_bglt aux_1657;
						     aux_1657 =
							(object_bglt) (new1210_1381);
						     OBJECT_WIDENING_SET(aux_1657, BFALSE);
						  }
						  ((((var_bglt) CREF(new1210_1381))->loc) = ((obj_t) loc_1127), BUNSPEC);
						  ((((var_bglt) CREF(new1210_1381))->type) = ((type_bglt) type_1379), BUNSPEC);
						  ((((var_bglt) CREF(new1210_1381))->variable) = ((variable_bglt) variable_1380), BUNSPEC);
						  res1661_1388 = new1210_1381;
					       }
					    }
					    arg1605_1129 = res1661_1388;
					 }
				      }
				      {		/* Coerce/apply.scm 73 */
					 node_bglt val1259_1390;
					 val1259_1390 =
					    (node_bglt) (arg1605_1129);
					 ((((app_ly_162_bglt) CREF(node_1107))->fun) = ((node_bglt) val1259_1390), BUNSPEC);
				      }
				   }
				   {	/* Coerce/apply.scm 77 */
				      var_bglt arg1609_1133;
				      {		/* Coerce/apply.scm 77 */
					 obj_t arg1611_1135;
					 arg1611_1135 = _obj__252_type_cache;
					 {	/* Coerce/apply.scm 77 */
					    var_bglt res1662_1401;
					    {	/* Coerce/apply.scm 77 */
					       type_bglt type_1392;
					       variable_bglt variable_1393;
					       type_1392 =
						  (type_bglt) (arg1611_1135);
					       variable_1393 =
						  (variable_bglt) (val_1125);
					       {	/* ./Ast/node.scm 995 */
						  var_bglt new1210_1394;
						  new1210_1394 =
						     ((var_bglt) BREF(GC_MALLOC(sizeof(struct var))));
						  {	/* ./Ast/node.scm 995 */
						     long arg1561_1395;
						     arg1561_1395 =
							class_num_218___object(var_ast_node);
						     {	/* ./Ast/node.scm 995 */
							obj_t obj_1399;
							obj_1399 =
							   (obj_t) (new1210_1394);
							(((obj_t) CREF(obj_1399))->header = MAKE_HEADER(arg1561_1395, 0), BUNSPEC);
						     }
						  }
						  {	/* ./Ast/node.scm 995 */
						     object_bglt aux_1671;
						     aux_1671 =
							(object_bglt) (new1210_1394);
						     OBJECT_WIDENING_SET(aux_1671, BFALSE);
						  }
						  ((((var_bglt) CREF(new1210_1394))->loc) = ((obj_t) loc_1127), BUNSPEC);
						  ((((var_bglt) CREF(new1210_1394))->type) = ((type_bglt) type_1392), BUNSPEC);
						  ((((var_bglt) CREF(new1210_1394))->variable) = ((variable_bglt) variable_1393), BUNSPEC);
						  res1662_1401 = new1210_1394;
					       }
					    }
					    arg1609_1133 = res1662_1401;
					 }
				      }
				      {		/* Coerce/apply.scm 77 */
					 node_bglt val1260_1403;
					 val1260_1403 =
					    (node_bglt) (arg1609_1133);
					 ((((app_ly_162_bglt) CREF(node_1107))->arg) = ((node_bglt) val1260_1403), BUNSPEC);
				      }
				   }
				   return
				      (obj_t) (lnode_1128);
				}
			     }
			  }
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_coerce_apply()
{
   AN_OBJECT;
   {	/* Coerce/apply.scm 14 */
      module_initialization_70_tools_trace(((long) 0), "COERCE_APPLY");
      module_initialization_70_engine_param(((long) 0), "COERCE_APPLY");
      module_initialization_70_tools_shape(((long) 0), "COERCE_APPLY");
      module_initialization_70_tools_location(((long) 0), "COERCE_APPLY");
      module_initialization_70_tools_error(((long) 0), "COERCE_APPLY");
      module_initialization_70_type_type(((long) 0), "COERCE_APPLY");
      module_initialization_70_type_cache(((long) 0), "COERCE_APPLY");
      module_initialization_70_ast_var(((long) 0), "COERCE_APPLY");
      module_initialization_70_ast_node(((long) 0), "COERCE_APPLY");
      module_initialization_70_ast_sexp(((long) 0), "COERCE_APPLY");
      module_initialization_70_ast_local(((long) 0), "COERCE_APPLY");
      module_initialization_70_coerce_coerce(((long) 0), "COERCE_APPLY");
      return
	 module_initialization_70_coerce_convert(((long) 0), "COERCE_APPLY");
   }
}
