/*===========================================================================*/
/*   (Coerce/coerce.scm)                                                     */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;


static obj_t method_init_76_coerce_coerce();
extern obj_t make_box_202_ast_node;
extern long add_inlined_method__244___object(obj_t, obj_t, long);
extern obj_t fail_ast_node;
extern obj_t box_ref_242_ast_node;
extern obj_t sequence_ast_node;
extern obj_t let_var_6_ast_node;
extern obj_t var_ast_node;
extern obj_t closure_ast_node;
extern obj_t _obj__252_type_cache;
extern obj_t pragma_ast_node;
extern obj_t set_ex_it_116_ast_node;
extern obj_t _magic__144_type_cache;
extern obj_t _unspec__87_type_cache;
extern obj_t module_initialization_70_coerce_coerce(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_type_coercion(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_coerce_pproto(long, char *);
extern obj_t module_initialization_70_coerce_convert(long, char *);
extern obj_t module_initialization_70_coerce_app(long, char *);
extern obj_t module_initialization_70_coerce_apply(long, char *);
extern obj_t module_initialization_70_coerce_funcall(long, char *);
extern obj_t module_initialization_70_coerce_typeof(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t runtime_type_error_216_coerce_convert(obj_t, obj_t, obj_t);
static obj_t _coerce__156_coerce_coerce(obj_t, obj_t, obj_t);
extern obj_t let_fun_218_ast_node;
extern obj_t pfunction_proto_197_coerce_pproto(long, variable_bglt);
static obj_t imported_modules_init_94_coerce_coerce();
extern obj_t inc_ppmarge__59_coerce_pproto();
extern obj_t add_generic__110___object(obj_t, obj_t);
extern node_bglt coerce__182_coerce_coerce(node_bglt, type_bglt);
extern obj_t dec_ppmarge__31_coerce_pproto();
static obj_t library_modules_init_112_coerce_coerce();
static obj_t _coerce__default1459_194_coerce_coerce(obj_t, obj_t, obj_t);
extern obj_t atom_ast_node;
extern obj_t cast_ast_node;
static obj_t toplevel_init_63_coerce_coerce();
extern obj_t jump_ex_it_184_ast_node;
extern obj_t open_input_string(obj_t);
extern obj_t kwote_ast_node;
extern obj_t setq_ast_node;
extern obj_t box_set__221_ast_node;
extern node_bglt convert__122_coerce_convert(node_bglt, type_bglt, type_bglt);
extern type_bglt typeof_coerce_typeof(node_bglt);
extern obj_t _exit__255_type_cache;
static obj_t _coerce_function__79_coerce_coerce(obj_t, obj_t);
extern obj_t shape_tools_shape(obj_t);
extern obj_t internal_error_43_tools_error(obj_t, obj_t, obj_t);
extern obj_t pvariable_proto_90_coerce_pproto(long, variable_bglt);
static node_bglt coerce__default1459_215_coerce_coerce(node_bglt, type_bglt);
extern obj_t _classes__134___object;
extern obj_t select_ast_node;
extern obj_t coerce_function__220_coerce_coerce(variable_bglt);
extern obj_t read___reader(obj_t);
extern bool_t coercer_exists__27_type_coercion(type_bglt, type_bglt);
static obj_t require_initialization_114_coerce_coerce = BUNSPEC;
extern obj_t conditional_ast_node;
static obj_t cnst_init_137_coerce_coerce();
extern obj_t _bool__149_type_cache;
static obj_t __cnst[1];

DEFINE_EXPORT_PROCEDURE(coerce_function__env_155_coerce_coerce, _coerce_function__79_coerce_coerce1698, _coerce_function__79_coerce_coerce, 0L, 1);
DEFINE_STATIC_PROCEDURE(coerce__default1459_env_167_coerce_coerce, _coerce__default1459_194_coerce_coerce1699, _coerce__default1459_194_coerce_coerce, 0L, 2);
DEFINE_STRING(string1693_coerce_coerce, string1693_coerce_coerce1700, "COERCE!-DEFAULT1459 ", 20);
DEFINE_STRING(string1692_coerce_coerce, string1692_coerce_coerce1701, "No method for this object", 25);
DEFINE_STRING(string1691_coerce_coerce, string1691_coerce_coerce1702, "Unexepected `closure' node", 26);
DEFINE_STRING(string1690_coerce_coerce, string1690_coerce_coerce1703, "coerce!", 7);
DEFINE_EXPORT_GENERIC(coerce__env_127_coerce_coerce, _coerce__156_coerce_coerce1704, _coerce__156_coerce_coerce, 0L, 2);



/* module-initialization */
obj_t 
module_initialization_70_coerce_coerce(long checksum_1402, char *from_1403)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_coerce_coerce))
	{
	   require_initialization_114_coerce_coerce =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_coerce_coerce();
	   cnst_init_137_coerce_coerce();
	   imported_modules_init_94_coerce_coerce();
	   method_init_76_coerce_coerce();
	   toplevel_init_63_coerce_coerce();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_coerce_coerce()
{
   AN_OBJECT;
   {	/* Coerce/coerce.scm 14 */
      module_initialization_70___object(((long) 0), "COERCE_COERCE");
      module_initialization_70___reader(((long) 0), "COERCE_COERCE");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_coerce_coerce()
{
   AN_OBJECT;
   {	/* Coerce/coerce.scm 14 */
      {		/* Coerce/coerce.scm 14 */
	 obj_t cnst_port_138_1395;
	 cnst_port_138_1395 =
	    open_input_string(string1693_coerce_coerce);
	 {
	    long i_1396;
	    i_1396 = ((long) 0);
	  loop_1397:
	    {	/* Coerce/coerce.scm 14 */
	       bool_t test1694_1398;
	       test1694_1398 =
		  (i_1396 == ((long) -1));
	       if (test1694_1398)
		 {	/* Coerce/coerce.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Coerce/coerce.scm 14 */
		    {	/* Coerce/coerce.scm 14 */
		       obj_t arg1695_1399;
		       {	/* Coerce/coerce.scm 14 */
			  obj_t list1696_1400;
			  list1696_1400 =
			     MAKE_PAIR(cnst_port_138_1395, BNIL);
			  arg1695_1399 =
			     read___reader(list1696_1400);
		       }
		       CNST_TABLE_SET(i_1396, arg1695_1399);
		    }
		    {	/* Coerce/coerce.scm 14 */
		       int aux_1401;
		       {	/* Coerce/coerce.scm 14 */
			  long aux_1420;
			  aux_1420 =
			     (i_1396 - ((long) 1));
			  aux_1401 =
			     (int) (aux_1420);
		       }
		       {
			  long i_1423;
			  i_1423 =
			     (long) (aux_1401);
			  i_1396 = i_1423;
			  goto loop_1397;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_coerce_coerce()
{
   AN_OBJECT;
   {	/* Coerce/coerce.scm 14 */
      return BUNSPEC;
   }
}



/* coerce-function! */
obj_t 
coerce_function__220_coerce_coerce(variable_bglt variable_1)
{
   AN_OBJECT;
   {	/* Coerce/coerce.scm 36 */
      {		/* Coerce/coerce.scm 37 */
	 value_bglt fun_737;
	 fun_737 =
	    (((variable_bglt) CREF(variable_1))->value);
	 {	/* Coerce/coerce.scm 37 */
	    obj_t body_738;
	    {	/* Coerce/coerce.scm 38 */
	       sfun_bglt obj_1246;
	       obj_1246 =
		  (sfun_bglt) (fun_737);
	       body_738 =
		  (((sfun_bglt) CREF(obj_1246))->body);
	    }
	    {	/* Coerce/coerce.scm 38 */
	       type_bglt tres_739;
	       tres_739 =
		  (((variable_bglt) CREF(variable_1))->type);
	       {	/* Coerce/coerce.scm 39 */

		  pfunction_proto_197_coerce_pproto(((long) 3), variable_1);
		  {	/* Coerce/coerce.scm 41 */
		     node_bglt arg1496_740;
		     arg1496_740 =
			coerce__182_coerce_coerce(
			(node_bglt) (body_738), tres_739);
		     {	/* Coerce/coerce.scm 41 */
			sfun_bglt obj_1248;
			obj_t val1123_1249;
			obj_1248 =
			   (sfun_bglt) (fun_737);
			val1123_1249 =
			   (obj_t) (arg1496_740);
			return
			   ((((sfun_bglt) CREF(obj_1248))->body) = ((obj_t) val1123_1249), BUNSPEC);
		     }
		  }
	       }
	    }
	 }
      }
   }
}



/* _coerce-function! */
obj_t 
_coerce_function__79_coerce_coerce(obj_t env_1387, obj_t variable_1388)
{
   AN_OBJECT;
   {	/* Coerce/coerce.scm 36 */
      return
	 coerce_function__220_coerce_coerce(
	 (variable_bglt) (variable_1388));
   }
}



/* method-init */
obj_t 
method_init_76_coerce_coerce()
{
   AN_OBJECT;
   {	/* Coerce/coerce.scm 14 */
      add_generic__110___object(coerce__env_127_coerce_coerce, coerce__default1459_env_167_coerce_coerce);
      add_inlined_method__244___object(coerce__env_127_coerce_coerce, atom_ast_node, ((long) 0));
      add_inlined_method__244___object(coerce__env_127_coerce_coerce, kwote_ast_node, ((long) 1));
      add_inlined_method__244___object(coerce__env_127_coerce_coerce, var_ast_node, ((long) 2));
      add_inlined_method__244___object(coerce__env_127_coerce_coerce, closure_ast_node, ((long) 3));
      add_inlined_method__244___object(coerce__env_127_coerce_coerce, sequence_ast_node, ((long) 4));
      add_inlined_method__244___object(coerce__env_127_coerce_coerce, pragma_ast_node, ((long) 5));
      add_inlined_method__244___object(coerce__env_127_coerce_coerce, cast_ast_node, ((long) 6));
      add_inlined_method__244___object(coerce__env_127_coerce_coerce, setq_ast_node, ((long) 7));
      add_inlined_method__244___object(coerce__env_127_coerce_coerce, conditional_ast_node, ((long) 8));
      add_inlined_method__244___object(coerce__env_127_coerce_coerce, fail_ast_node, ((long) 9));
      add_inlined_method__244___object(coerce__env_127_coerce_coerce, select_ast_node, ((long) 10));
      add_inlined_method__244___object(coerce__env_127_coerce_coerce, let_fun_218_ast_node, ((long) 11));
      add_inlined_method__244___object(coerce__env_127_coerce_coerce, let_var_6_ast_node, ((long) 12));
      add_inlined_method__244___object(coerce__env_127_coerce_coerce, set_ex_it_116_ast_node, ((long) 13));
      add_inlined_method__244___object(coerce__env_127_coerce_coerce, jump_ex_it_184_ast_node, ((long) 14));
      add_inlined_method__244___object(coerce__env_127_coerce_coerce, make_box_202_ast_node, ((long) 15));
      add_inlined_method__244___object(coerce__env_127_coerce_coerce, box_ref_242_ast_node, ((long) 16));
      {		/* Coerce/coerce.scm 14 */
	 long aux_1455;
	 aux_1455 =
	    add_inlined_method__244___object(coerce__env_127_coerce_coerce, box_set__221_ast_node, ((long) 17));
	 return
	    BINT(aux_1455);
      }
   }
}



/* coerce! */
node_bglt 
coerce__182_coerce_coerce(node_bglt node_2, type_bglt to_3)
{
   AN_OBJECT;
   {	/* Coerce/coerce.scm 46 */
      {
	 obj_t method1579_1071;
	 obj_t class1584_1072;
	 {	/* Coerce/coerce.scm 46 */
	    obj_t arg1587_1069;
	    obj_t arg1588_1070;
	    {	/* Coerce/coerce.scm 46 */
	       object_bglt obj_1250;
	       obj_1250 =
		  (object_bglt) (node_2);
	       {	/* ./Llib/object.scm 2926 */
		  obj_t pre_method_105_1251;
		  pre_method_105_1251 =
		     PROCEDURE_REF(coerce__env_127_coerce_coerce, ((long) 2));
		  if (
		     INTEGERP(pre_method_105_1251))
		    {	/* ./Llib/object.scm 2927 */
		       PROCEDURE_SET(coerce__env_127_coerce_coerce, ((long) 2), BUNSPEC);
		       arg1587_1069 = pre_method_105_1251;
		    }
		  else
		    {	/* ./Llib/object.scm 2914 */
		       long obj_class_num_177_1256;
		       obj_class_num_177_1256 =
			  TYPE(obj_1250);
		       {	/* ./Llib/object.scm 2915 */
			  obj_t arg1176_1257;
			  arg1176_1257 =
			     PROCEDURE_REF(coerce__env_127_coerce_coerce, ((long) 1));
			  {	/* ./Llib/object.scm 2738 */
			     long arg1177_1261;
			     {	/* ./Llib/object.scm 2738 */
				long arg1178_1262;
				arg1178_1262 =
				   OBJECT_TYPE;
				arg1177_1261 =
				   (obj_class_num_177_1256 - arg1178_1262);
			     }
			     arg1587_1069 =
				VECTOR_REF(arg1176_1257, arg1177_1261);
			  }
		       }
		    }
	       }
	    }
	    {	/* Coerce/coerce.scm 46 */
	       object_bglt object_1267;
	       object_1267 =
		  (object_bglt) (node_2);
	       {	/* ./Llib/object.scm 2695 */
		  long arg1179_1268;
		  {	/* ./Llib/object.scm 2695 */
		     long arg1180_1269;
		     long arg1181_1270;
		     arg1180_1269 =
			TYPE(object_1267);
		     arg1181_1270 =
			OBJECT_TYPE;
		     arg1179_1268 =
			(arg1180_1269 - arg1181_1270);
		  }
		  {	/* ./Llib/object.scm 2695 */
		     obj_t vector_1274;
		     vector_1274 = _classes__134___object;
		     arg1588_1070 =
			VECTOR_REF(vector_1274, arg1179_1268);
		  }
	       }
	    }
	    {	/* Coerce/coerce.scm 46 */
	       obj_t aux_1473;
	       method1579_1071 = arg1587_1069;
	       class1584_1072 = arg1588_1070;
	       {

		  if (
		     INTEGERP(method1579_1071))
		    {	/* Coerce/coerce.scm 46 */
		       switch (
			  (long) CINT(method1579_1071))
			 {
			 case ((long) 0):

			    {	/* Coerce/coerce.scm 52 */
			       atom_bglt node_1078;
			       node_1078 =
				  (atom_bglt) (node_2);
			       {	/* Coerce/coerce.scm 52 */
				  type_bglt arg1591_1080;
				  arg1591_1080 =
				     typeof_coerce_typeof(
				     (node_bglt) (node_1078));
				  {	/* Coerce/coerce.scm 52 */
				     node_bglt aux_1479;
				     aux_1479 =
					convert__122_coerce_convert(
					(node_bglt) (node_1078), arg1591_1080, to_3);
				     aux_1473 =
					(obj_t) (aux_1479);
				  }
			       }
			    }
			    break;
			 case ((long) 1):

			    {	/* Coerce/coerce.scm 58 */
			       kwote_bglt node_1081;
			       node_1081 =
				  (kwote_bglt) (node_2);
			       {	/* Coerce/coerce.scm 58 */
				  type_bglt arg1592_1083;
				  arg1592_1083 =
				     typeof_coerce_typeof(
				     (node_bglt) (node_1081));
				  {	/* Coerce/coerce.scm 58 */
				     node_bglt aux_1486;
				     aux_1486 =
					convert__122_coerce_convert(
					(node_bglt) (node_1081), arg1592_1083, to_3);
				     aux_1473 =
					(obj_t) (aux_1486);
				  }
			       }
			    }
			    break;
			 case ((long) 2):

			    {	/* Coerce/coerce.scm 64 */
			       var_bglt node_1084;
			       node_1084 =
				  (var_bglt) (node_2);
			       {	/* Coerce/coerce.scm 65 */
				  type_bglt type_1087;
				  type_1087 =
				     typeof_coerce_typeof(
				     (node_bglt) (node_1084));
				  {	/* Coerce/coerce.scm 66 */
				     node_bglt aux_1493;
				     aux_1493 =
					convert__122_coerce_convert(
					(node_bglt) (node_1084), type_1087, to_3);
				     aux_1473 =
					(obj_t) (aux_1493);
				  }
			       }
			    }
			    break;
			 case ((long) 3):

			    {	/* Coerce/coerce.scm 72 */
			       obj_t arg1595_1092;
			       {	/* Coerce/coerce.scm 72 */
				  obj_t aux_1497;
				  {	/* Coerce/coerce.scm 72 */
				     closure_bglt aux_1498;
				     aux_1498 =
					(closure_bglt) (node_2);
				     aux_1497 =
					(obj_t) (aux_1498);
				  }
				  arg1595_1092 =
				     shape_tools_shape(aux_1497);
			       }
			       aux_1473 =
				  internal_error_43_tools_error(string1690_coerce_coerce, string1691_coerce_coerce, arg1595_1092);
			    }
			    break;
			 case ((long) 4):

			    {	/* Coerce/coerce.scm 78 */
			       sequence_bglt node_1093;
			       node_1093 =
				  (sequence_bglt) (node_2);
			       {
				  obj_t hook_1096;
				  {	/* Coerce/coerce.scm 79 */
				     sequence_bglt aux_1504;
				     hook_1096 =
					(((sequence_bglt) CREF(node_1093))->nodes);
				   loop_1097:
				     {	/* Coerce/coerce.scm 80 */
					bool_t test_1505;
					{	/* ./Ieee/pair-list.scm 5912 */
					   obj_t aux_1506;
					   aux_1506 =
					      CDR(hook_1096);
					   test_1505 =
					      NULLP(aux_1506);
					}
					if (test_1505)
					  {	/* Coerce/coerce.scm 80 */
					     {	/* Coerce/coerce.scm 82 */
						node_bglt arg1598_1100;
						{	/* Coerce/coerce.scm 82 */
						   node_bglt aux_1509;
						   {	/* Coerce/coerce.scm 82 */
						      obj_t aux_1510;
						      aux_1510 =
							 CAR(hook_1096);
						      aux_1509 =
							 (node_bglt) (aux_1510);
						   }
						   arg1598_1100 =
						      coerce__182_coerce_coerce(aux_1509, to_3);
						}
						{	/* ./Ieee/pair-list.scm 5890 */
						   obj_t aux_1514;
						   aux_1514 =
						      (obj_t) (arg1598_1100);
						   SET_CAR(hook_1096, aux_1514);
						}
					     }
					     aux_1504 = node_1093;
					  }
					else
					  {	/* Coerce/coerce.scm 80 */
					     {	/* Coerce/coerce.scm 87 */
						node_bglt arg1600_1102;
						{	/* Coerce/coerce.scm 87 */
						   obj_t arg1601_1103;
						   type_bglt arg1602_1104;
						   arg1601_1103 =
						      CAR(hook_1096);
						   {	/* Coerce/coerce.scm 87 */
						      node_bglt aux_1518;
						      {		/* Coerce/coerce.scm 87 */
							 obj_t aux_1519;
							 aux_1519 =
							    CAR(hook_1096);
							 aux_1518 =
							    (node_bglt) (aux_1519);
						      }
						      arg1602_1104 =
							 typeof_coerce_typeof(aux_1518);
						   }
						   arg1600_1102 =
						      coerce__182_coerce_coerce(
						      (node_bglt) (arg1601_1103), arg1602_1104);
						}
						{	/* ./Ieee/pair-list.scm 5890 */
						   obj_t aux_1525;
						   aux_1525 =
						      (obj_t) (arg1600_1102);
						   SET_CAR(hook_1096, aux_1525);
						}
					     }
					     {
						obj_t hook_1528;
						hook_1528 =
						   CDR(hook_1096);
						hook_1096 = hook_1528;
						goto loop_1097;
					     }
					  }
				     }
				     aux_1473 =
					(obj_t) (aux_1504);
				  }
			       }
			    }
			    break;
			 case ((long) 5):

			    {	/* Coerce/coerce.scm 94 */
			       pragma_bglt node_1108;
			       node_1108 =
				  (pragma_bglt) (node_2);
			       {
				  obj_t values_1111;
				  {	/* Coerce/coerce.scm 95 */
				     node_bglt aux_1533;
				     values_1111 =
					(((pragma_bglt) CREF(node_1108))->args);
				   loop_1112:
				     if (
					NULLP(values_1111))
				       {	/* Coerce/coerce.scm 97 */
					  type_bglt arg1608_1115;
					  arg1608_1115 =
					     typeof_coerce_typeof(
					     (node_bglt) (node_1108));
					  aux_1533 =
					     convert__122_coerce_convert(
					     (node_bglt) (node_1108), arg1608_1115, to_3);
				       }
				     else
				       {	/* Coerce/coerce.scm 96 */
					  {	/* Coerce/coerce.scm 99 */
					     node_bglt arg1609_1116;
					     {	/* Coerce/coerce.scm 99 */
						obj_t arg1610_1117;
						type_bglt arg1611_1118;
						arg1610_1117 =
						   CAR(values_1111);
						{	/* Coerce/coerce.scm 100 */
						   node_bglt aux_1541;
						   {	/* Coerce/coerce.scm 100 */
						      obj_t aux_1542;
						      aux_1542 =
							 CAR(values_1111);
						      aux_1541 =
							 (node_bglt) (aux_1542);
						   }
						   arg1611_1118 =
						      typeof_coerce_typeof(aux_1541);
						}
						arg1609_1116 =
						   coerce__182_coerce_coerce(
						   (node_bglt) (arg1610_1117), arg1611_1118);
					     }
					     {	/* ./Ieee/pair-list.scm 5890 */
						obj_t aux_1548;
						aux_1548 =
						   (obj_t) (arg1609_1116);
						SET_CAR(values_1111, aux_1548);
					     }
					  }
					  {
					     obj_t values_1551;
					     values_1551 =
						CDR(values_1111);
					     values_1111 = values_1551;
					     goto loop_1112;
					  }
				       }
				     aux_1473 =
					(obj_t) (aux_1533);
				  }
			       }
			    }
			    break;
			 case ((long) 6):

			    {	/* Coerce/coerce.scm 108 */
			       cast_bglt node_1121;
			       node_1121 =
				  (cast_bglt) (node_2);
			       {	/* Coerce/coerce.scm 109 */
				  node_bglt arg1614_1124;
				  {	/* Coerce/coerce.scm 109 */
				     node_bglt arg1615_1125;
				     type_bglt arg1616_1126;
				     arg1615_1125 =
					(((cast_bglt) CREF(node_1121))->arg);
				     arg1616_1126 =
					typeof_coerce_typeof(
					(((cast_bglt) CREF(node_1121))->arg));
				     arg1614_1124 =
					coerce__182_coerce_coerce(arg1615_1125, arg1616_1126);
				  }
				  ((((cast_bglt) CREF(node_1121))->arg) = ((node_bglt) arg1614_1124), BUNSPEC);
			       }
			       {	/* Coerce/coerce.scm 110 */
				  node_bglt aux_1561;
				  aux_1561 =
				     convert__122_coerce_convert(
				     (node_bglt) (node_1121),
				     (((cast_bglt) CREF(node_1121))->type), to_3);
				  aux_1473 =
				     (obj_t) (aux_1561);
			       }
			    }
			    break;
			 case ((long) 7):

			    {	/* Coerce/coerce.scm 116 */
			       setq_bglt node_1129;
			       node_1129 =
				  (setq_bglt) (node_2);
			       {	/* Coerce/coerce.scm 117 */
				  node_bglt arg1619_1132;
				  {	/* Coerce/coerce.scm 117 */
				     type_bglt aux_1567;
				     {	/* Coerce/coerce.scm 117 */
					variable_bglt arg1622_1135;
					{	/* Coerce/coerce.scm 117 */
					   var_bglt arg1623_1136;
					   arg1623_1136 =
					      (((setq_bglt) CREF(node_1129))->var);
					   arg1622_1135 =
					      (((var_bglt) CREF(arg1623_1136))->variable);
					}
					aux_1567 =
					   (((variable_bglt) CREF(arg1622_1135))->type);
				     }
				     arg1619_1132 =
					coerce__182_coerce_coerce(
					(((setq_bglt) CREF(node_1129))->value), aux_1567);
				  }
				  ((((setq_bglt) CREF(node_1129))->value) = ((node_bglt) arg1619_1132), BUNSPEC);
			       }
			       {	/* Coerce/coerce.scm 118 */
				  node_bglt aux_1574;
				  aux_1574 =
				     convert__122_coerce_convert(
				     (node_bglt) (node_1129),
				     (type_bglt) (_unspec__87_type_cache), to_3);
				  aux_1473 =
				     (obj_t) (aux_1574);
			       }
			    }
			    break;
			 case ((long) 8):

			    {	/* Coerce/coerce.scm 124 */
			       conditional_bglt node_1137;
			       node_1137 =
				  (conditional_bglt) (node_2);
			       {	/* Coerce/coerce.scm 125 */
				  node_bglt arg1624_1140;
				  arg1624_1140 =
				     coerce__182_coerce_coerce(
				     (((conditional_bglt) CREF(node_1137))->test),
				     (type_bglt) (_bool__149_type_cache));
				  ((((conditional_bglt) CREF(node_1137))->test) = ((node_bglt) arg1624_1140), BUNSPEC);
			       }
			       {	/* Coerce/coerce.scm 126 */
				  node_bglt arg1626_1142;
				  arg1626_1142 =
				     coerce__182_coerce_coerce(
				     (((conditional_bglt) CREF(node_1137))->true), to_3);
				  ((((conditional_bglt) CREF(node_1137))->true) = ((node_bglt) arg1626_1142), BUNSPEC);
			       }
			       {	/* Coerce/coerce.scm 127 */
				  node_bglt arg1628_1144;
				  arg1628_1144 =
				     coerce__182_coerce_coerce(
				     (((conditional_bglt) CREF(node_1137))->false), to_3);
				  ((((conditional_bglt) CREF(node_1137))->false) = ((node_bglt) arg1628_1144), BUNSPEC);
			       }
			       aux_1473 =
				  (obj_t) (node_1137);
			    }
			    break;
			 case ((long) 9):

			    {	/* Coerce/coerce.scm 134 */
			       fail_bglt node_1146;
			       node_1146 =
				  (fail_bglt) (node_2);
			       {	/* Coerce/coerce.scm 135 */
				  node_bglt arg1630_1149;
				  arg1630_1149 =
				     coerce__182_coerce_coerce(
				     (((fail_bglt) CREF(node_1146))->proc),
				     (type_bglt) (_obj__252_type_cache));
				  ((((fail_bglt) CREF(node_1146))->proc) = ((node_bglt) arg1630_1149), BUNSPEC);
			       }
			       {	/* Coerce/coerce.scm 136 */
				  node_bglt arg1632_1151;
				  arg1632_1151 =
				     coerce__182_coerce_coerce(
				     (((fail_bglt) CREF(node_1146))->msg),
				     (type_bglt) (_obj__252_type_cache));
				  ((((fail_bglt) CREF(node_1146))->msg) = ((node_bglt) arg1632_1151), BUNSPEC);
			       }
			       {	/* Coerce/coerce.scm 137 */
				  node_bglt arg1634_1153;
				  arg1634_1153 =
				     coerce__182_coerce_coerce(
				     (((fail_bglt) CREF(node_1146))->obj),
				     (type_bglt) (_obj__252_type_cache));
				  ((((fail_bglt) CREF(node_1146))->obj) = ((node_bglt) arg1634_1153), BUNSPEC);
			       }
			       {	/* Coerce/coerce.scm 138 */
				  node_bglt aux_1604;
				  aux_1604 =
				     convert__122_coerce_convert(
				     (node_bglt) (node_1146),
				     (type_bglt) (_magic__144_type_cache), to_3);
				  aux_1473 =
				     (obj_t) (aux_1604);
			       }
			    }
			    break;
			 case ((long) 10):

			    {	/* Coerce/coerce.scm 144 */
			       select_bglt node_1155;
			       node_1155 =
				  (select_bglt) (node_2);
			       {	/* Coerce/coerce.scm 145 */
				  obj_t clauses_1158;
				  type_bglt test_type_84_1159;
				  type_bglt test_node_type_36_1160;
				  clauses_1158 =
				     (((select_bglt) CREF(node_1155))->clauses);
				  test_type_84_1159 =
				     (((select_bglt) CREF(node_1155))->item_type_130);
				  test_node_type_36_1160 =
				     typeof_coerce_typeof(
				     (((select_bglt) CREF(node_1155))->test));
				  {	/* Coerce/coerce.scm 155 */
				     bool_t test1636_1161;
				     test1636_1161 =
					coercer_exists__27_type_coercion(test_node_type_36_1160, test_type_84_1159);
				     if (test1636_1161)
				       {	/* Coerce/coerce.scm 155 */
					  {	/* Coerce/coerce.scm 161 */
					     node_bglt arg1637_1162;
					     arg1637_1162 =
						coerce__182_coerce_coerce(
						(((select_bglt) CREF(node_1155))->test), test_type_84_1159);
					     ((((select_bglt) CREF(node_1155))->test) = ((node_bglt) arg1637_1162), BUNSPEC);
					  }
					  {
					     obj_t l1445_1164;
					     l1445_1164 = clauses_1158;
					   lname1446_1165:
					     if (
						PAIRP(l1445_1164))
					       {	/* Coerce/coerce.scm 162 */
						  {	/* Coerce/coerce.scm 163 */
						     obj_t clause_1167;
						     clause_1167 =
							CAR(l1445_1164);
						     {	/* Coerce/coerce.scm 163 */
							node_bglt arg1640_1168;
							{	/* Coerce/coerce.scm 163 */
							   node_bglt aux_1622;
							   {	/* Coerce/coerce.scm 163 */
							      obj_t aux_1623;
							      aux_1623 =
								 CDR(clause_1167);
							      aux_1622 =
								 (node_bglt) (aux_1623);
							   }
							   arg1640_1168 =
							      coerce__182_coerce_coerce(aux_1622, to_3);
							}
							{	/* ./Ieee/pair-list.scm 5896 */
							   obj_t aux_1627;
							   aux_1627 =
							      (obj_t) (arg1640_1168);
							   SET_CDR(clause_1167, aux_1627);
							}
						     }
						  }
						  {
						     obj_t l1445_1630;
						     l1445_1630 =
							CDR(l1445_1164);
						     l1445_1164 = l1445_1630;
						     goto lname1446_1165;
						  }
					       }
					     else
					       {	/* Coerce/coerce.scm 162 */
						  ((bool_t) 1);
					       }
					  }
					  aux_1473 =
					     (obj_t) (node_1155);
				       }
				     else
				       {	/* Coerce/coerce.scm 156 */
					  obj_t arg1643_1171;
					  {	/* Coerce/coerce.scm 156 */
					     obj_t aux_1633;
					     {	/* Coerce/coerce.scm 156 */
						node_bglt aux_1636;
						aux_1636 =
						   (((select_bglt) CREF(node_1155))->test);
						aux_1633 =
						   (obj_t) (aux_1636);
					     }
					     arg1643_1171 =
						runtime_type_error_216_coerce_convert(
						(((select_bglt) CREF(node_1155))->loc),
						(((type_bglt) CREF(test_type_84_1159))->id), aux_1633);
					  }
					  {	/* Coerce/coerce.scm 156 */
					     node_bglt aux_1640;
					     aux_1640 =
						coerce__182_coerce_coerce(
						(node_bglt) (arg1643_1171), to_3);
					     aux_1473 =
						(obj_t) (aux_1640);
					  }
				       }
				  }
			       }
			    }
			    break;
			 case ((long) 11):

			    {	/* Coerce/coerce.scm 171 */
			       let_fun_218_bglt node_1176;
			       node_1176 =
				  (let_fun_218_bglt) (node_2);
			       inc_ppmarge__59_coerce_pproto();
			       {
				  obj_t l1448_1179;
				  l1448_1179 =
				     (((let_fun_218_bglt) CREF(node_1176))->locals);
				lname1449_1180:
				  if (
				     PAIRP(l1448_1179))
				    {	/* Coerce/coerce.scm 173 */
				       {	/* Coerce/coerce.scm 173 */
					  variable_bglt aux_1648;
					  {	/* Coerce/coerce.scm 173 */
					     obj_t aux_1649;
					     aux_1649 =
						CAR(l1448_1179);
					     aux_1648 =
						(variable_bglt) (aux_1649);
					  }
					  coerce_function__220_coerce_coerce(aux_1648);
				       }
				       {
					  obj_t l1448_1653;
					  l1448_1653 =
					     CDR(l1448_1179);
					  l1448_1179 = l1448_1653;
					  goto lname1449_1180;
				       }
				    }
				  else
				    {	/* Coerce/coerce.scm 173 */
				       ((bool_t) 1);
				    }
			       }
			       {	/* Coerce/coerce.scm 174 */
				  node_bglt arg1653_1185;
				  arg1653_1185 =
				     coerce__182_coerce_coerce(
				     (((let_fun_218_bglt) CREF(node_1176))->body), to_3);
				  ((((let_fun_218_bglt) CREF(node_1176))->body) = ((node_bglt) arg1653_1185), BUNSPEC);
			       }
			       dec_ppmarge__31_coerce_pproto();
			       aux_1473 =
				  (obj_t) (node_1176);
			    }
			    break;
			 case ((long) 12):

			    {	/* Coerce/coerce.scm 182 */
			       let_var_6_bglt node_1187;
			       node_1187 =
				  (let_var_6_bglt) (node_2);
			       inc_ppmarge__59_coerce_pproto();
			       {
				  obj_t l1451_1190;
				  l1451_1190 =
				     (((let_var_6_bglt) CREF(node_1187))->bindings);
				lname1452_1191:
				  if (
				     PAIRP(l1451_1190))
				    {	/* Coerce/coerce.scm 184 */
				       {	/* Coerce/coerce.scm 184 */
					  obj_t binding_1194;
					  binding_1194 =
					     CAR(l1451_1190);
					  {	/* Coerce/coerce.scm 185 */
					     variable_bglt aux_1666;
					     {	/* Coerce/coerce.scm 185 */
						obj_t aux_1667;
						aux_1667 =
						   CAR(binding_1194);
						aux_1666 =
						   (variable_bglt) (aux_1667);
					     }
					     pvariable_proto_90_coerce_pproto(((long) 3), aux_1666);
					  }
					  {	/* Coerce/coerce.scm 186 */
					     node_bglt arg1659_1197;
					     {	/* Coerce/coerce.scm 186 */
						type_bglt aux_1675;
						node_bglt aux_1671;
						{	/* Coerce/coerce.scm 187 */
						   local_bglt obj_1351;
						   {	/* Coerce/coerce.scm 187 */
						      obj_t aux_1676;
						      aux_1676 =
							 CAR(binding_1194);
						      obj_1351 =
							 (local_bglt) (aux_1676);
						   }
						   aux_1675 =
						      (((local_bglt) CREF(obj_1351))->type);
						}
						{	/* Coerce/coerce.scm 186 */
						   obj_t aux_1672;
						   aux_1672 =
						      CDR(binding_1194);
						   aux_1671 =
						      (node_bglt) (aux_1672);
						}
						arg1659_1197 =
						   coerce__182_coerce_coerce(aux_1671, aux_1675);
					     }
					     {	/* ./Ieee/pair-list.scm 5896 */
						obj_t aux_1681;
						aux_1681 =
						   (obj_t) (arg1659_1197);
						SET_CDR(binding_1194, aux_1681);
					     }
					  }
				       }
				       {
					  obj_t l1451_1684;
					  l1451_1684 =
					     CDR(l1451_1190);
					  l1451_1190 = l1451_1684;
					  goto lname1452_1191;
				       }
				    }
				  else
				    {	/* Coerce/coerce.scm 184 */
				       ((bool_t) 1);
				    }
			       }
			       {	/* Coerce/coerce.scm 189 */
				  node_bglt arg1664_1202;
				  arg1664_1202 =
				     coerce__182_coerce_coerce(
				     (((let_var_6_bglt) CREF(node_1187))->body), to_3);
				  ((((let_var_6_bglt) CREF(node_1187))->body) = ((node_bglt) arg1664_1202), BUNSPEC);
			       }
			       dec_ppmarge__31_coerce_pproto();
			       aux_1473 =
				  (obj_t) (node_1187);
			    }
			    break;
			 case ((long) 13):

			    {	/* Coerce/coerce.scm 197 */
			       set_ex_it_116_bglt node_1204;
			       node_1204 =
				  (set_ex_it_116_bglt) (node_2);
			       {	/* Coerce/coerce.scm 198 */
				  node_bglt arg1666_1207;
				  {	/* Coerce/coerce.scm 198 */
				     node_bglt aux_1693;
				     {	/* Coerce/coerce.scm 198 */
					var_bglt aux_1694;
					aux_1694 =
					   (((set_ex_it_116_bglt) CREF(node_1204))->var);
					aux_1693 =
					   (node_bglt) (aux_1694);
				     }
				     arg1666_1207 =
					coerce__182_coerce_coerce(aux_1693,
					(type_bglt) (_exit__255_type_cache));
				  }
				  {	/* Coerce/coerce.scm 198 */
				     var_bglt val1384_1360;
				     val1384_1360 =
					(var_bglt) (arg1666_1207);
				     ((((set_ex_it_116_bglt) CREF(node_1204))->var) = ((var_bglt) val1384_1360), BUNSPEC);
				  }
			       }
			       {	/* Coerce/coerce.scm 199 */
				  variable_bglt aux_1701;
				  {	/* Coerce/coerce.scm 199 */
				     var_bglt arg1671_1211;
				     arg1671_1211 =
					(((set_ex_it_116_bglt) CREF(node_1204))->var);
				     aux_1701 =
					(((var_bglt) CREF(arg1671_1211))->variable);
				  }
				  pvariable_proto_90_coerce_pproto(((long) 3), aux_1701);
			       }
			       {	/* Coerce/coerce.scm 200 */
				  node_bglt arg1672_1212;
				  arg1672_1212 =
				     coerce__182_coerce_coerce(
				     (((set_ex_it_116_bglt) CREF(node_1204))->body), to_3);
				  ((((set_ex_it_116_bglt) CREF(node_1204))->body) = ((node_bglt) arg1672_1212), BUNSPEC);
			       }
			       aux_1473 =
				  (obj_t) (node_1204);
			    }
			    break;
			 case ((long) 14):

			    {	/* Coerce/coerce.scm 207 */
			       jump_ex_it_184_bglt node_1214;
			       node_1214 =
				  (jump_ex_it_184_bglt) (node_2);
			       {	/* Coerce/coerce.scm 208 */
				  node_bglt arg1674_1217;
				  arg1674_1217 =
				     coerce__182_coerce_coerce(
				     (((jump_ex_it_184_bglt) CREF(node_1214))->exit),
				     (type_bglt) (_exit__255_type_cache));
				  ((((jump_ex_it_184_bglt) CREF(node_1214))->exit) = ((node_bglt) arg1674_1217), BUNSPEC);
			       }
			       {	/* Coerce/coerce.scm 209 */
				  node_bglt arg1676_1219;
				  arg1676_1219 =
				     coerce__182_coerce_coerce(
				     (((jump_ex_it_184_bglt) CREF(node_1214))->value), to_3);
				  ((((jump_ex_it_184_bglt) CREF(node_1214))->value) = ((node_bglt) arg1676_1219), BUNSPEC);
			       }
			       aux_1473 =
				  (obj_t) (node_1214);
			    }
			    break;
			 case ((long) 15):

			    {	/* Coerce/coerce.scm 216 */
			       make_box_202_bglt node_1221;
			       node_1221 =
				  (make_box_202_bglt) (node_2);
			       {	/* Coerce/coerce.scm 217 */
				  node_bglt arg1678_1224;
				  arg1678_1224 =
				     coerce__182_coerce_coerce(
				     (((make_box_202_bglt) CREF(node_1221))->value),
				     (type_bglt) (_obj__252_type_cache));
				  ((((make_box_202_bglt) CREF(node_1221))->value) = ((node_bglt) arg1678_1224), BUNSPEC);
			       }
			       aux_1473 =
				  (obj_t) (node_1221);
			    }
			    break;
			 case ((long) 16):

			    {	/* Coerce/coerce.scm 225 */
			       node_bglt aux_1724;
			       {	/* Coerce/coerce.scm 225 */
				  node_bglt aux_1725;
				  {	/* Coerce/coerce.scm 225 */
				     box_ref_242_bglt aux_1726;
				     aux_1726 =
					(box_ref_242_bglt) (node_2);
				     aux_1725 =
					(node_bglt) (aux_1726);
				  }
				  aux_1724 =
				     convert__122_coerce_convert(aux_1725,
				     (type_bglt) (_obj__252_type_cache), to_3);
			       }
			       aux_1473 =
				  (obj_t) (aux_1724);
			    }
			    break;
			 case ((long) 17):

			    {	/* Coerce/coerce.scm 231 */
			       box_set__221_bglt node_1229;
			       node_1229 =
				  (box_set__221_bglt) (node_2);
			       {	/* Coerce/coerce.scm 232 */
				  local_bglt obj_1377;
				  type_bglt val1082_1378;
				  {	/* Coerce/coerce.scm 232 */
				     variable_bglt aux_1733;
				     {	/* Coerce/coerce.scm 232 */
					var_bglt arg1681_1233;
					arg1681_1233 =
					   (((box_set__221_bglt) CREF(node_1229))->var);
					aux_1733 =
					   (((var_bglt) CREF(arg1681_1233))->variable);
				     }
				     obj_1377 =
					(local_bglt) (aux_1733);
				  }
				  val1082_1378 =
				     (type_bglt) (_obj__252_type_cache);
				  ((((local_bglt) CREF(obj_1377))->type) = ((type_bglt) val1082_1378), BUNSPEC);
			       }
			       {	/* Coerce/coerce.scm 233 */
				  node_bglt arg1682_1234;
				  arg1682_1234 =
				     coerce__182_coerce_coerce(
				     (((box_set__221_bglt) CREF(node_1229))->value),
				     (type_bglt) (_obj__252_type_cache));
				  ((((box_set__221_bglt) CREF(node_1229))->value) = ((node_bglt) arg1682_1234), BUNSPEC);
			       }
			       {	/* Coerce/coerce.scm 234 */
				  node_bglt aux_1743;
				  aux_1743 =
				     convert__122_coerce_convert(
				     (node_bglt) (node_1229),
				     (type_bglt) (_unspec__87_type_cache), to_3);
				  aux_1473 =
				     (obj_t) (aux_1743);
			       }
			    }
			    break;
			 default:
			  case_else1585_1075:
			    if (
			       PROCEDUREP(method1579_1071))
			      {		/* Coerce/coerce.scm 46 */
				 aux_1473 =
				    PROCEDURE_ENTRY(method1579_1071) (method1579_1071,
				    (obj_t) (node_2),
				    (obj_t) (to_3), BEOA)
				    ;
			      }
			    else
			      {		/* Coerce/coerce.scm 46 */
				 obj_t fun1578_1067;
				 fun1578_1067 =
				    PROCEDURE_REF(coerce__env_127_coerce_coerce, ((long) 0));
				 aux_1473 =
				    PROCEDURE_ENTRY(fun1578_1067) (fun1578_1067,
				    (obj_t) (node_2),
				    (obj_t) (to_3), BEOA);
			      }
			 }
		    }
		  else
		    {	/* Coerce/coerce.scm 46 */
		       goto case_else1585_1075;
		    }
	       }
	       return
		  (node_bglt) (aux_1473);
	    }
	 }
      }
   }
}



/* _coerce! */
obj_t 
_coerce__156_coerce_coerce(obj_t env_1389, obj_t node_1390, obj_t to_1391)
{
   AN_OBJECT;
   {	/* Coerce/coerce.scm 46 */
      {		/* Coerce/coerce.scm 46 */
	 node_bglt aux_1762;
	 aux_1762 =
	    coerce__182_coerce_coerce(
	    (node_bglt) (node_1390),
	    (type_bglt) (to_1391));
	 return
	    (obj_t) (aux_1762);
      }
   }
}



/* coerce!-default1459 */
node_bglt 
coerce__default1459_215_coerce_coerce(node_bglt node_4, type_bglt to_5)
{
   AN_OBJECT;
   {	/* Coerce/coerce.scm 14 */
      FAILURE(
	 CNST_TABLE_REF(((long) 0)), string1692_coerce_coerce,
	 (obj_t) (node_4));
   }
}



/* _coerce!-default1459 */
obj_t 
_coerce__default1459_194_coerce_coerce(obj_t env_1392, obj_t node_1393, obj_t to_1394)
{
   AN_OBJECT;
   {	/* Coerce/coerce.scm 14 */
      {		/* Coerce/coerce.scm 14 */
	 node_bglt aux_1770;
	 aux_1770 =
	    coerce__default1459_215_coerce_coerce(
	    (node_bglt) (node_1393),
	    (type_bglt) (to_1394));
	 return
	    (obj_t) (aux_1770);
      }
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_coerce_coerce()
{
   AN_OBJECT;
   {	/* Coerce/coerce.scm 14 */
      module_initialization_70_tools_trace(((long) 0), "COERCE_COERCE");
      module_initialization_70_engine_param(((long) 0), "COERCE_COERCE");
      module_initialization_70_tools_shape(((long) 0), "COERCE_COERCE");
      module_initialization_70_tools_error(((long) 0), "COERCE_COERCE");
      module_initialization_70_type_type(((long) 0), "COERCE_COERCE");
      module_initialization_70_type_cache(((long) 0), "COERCE_COERCE");
      module_initialization_70_type_coercion(((long) 0), "COERCE_COERCE");
      module_initialization_70_ast_var(((long) 0), "COERCE_COERCE");
      module_initialization_70_ast_node(((long) 0), "COERCE_COERCE");
      module_initialization_70_coerce_pproto(((long) 0), "COERCE_COERCE");
      module_initialization_70_coerce_convert(((long) 0), "COERCE_COERCE");
      module_initialization_70_coerce_app(((long) 0), "COERCE_COERCE");
      module_initialization_70_coerce_apply(((long) 0), "COERCE_COERCE");
      module_initialization_70_coerce_funcall(((long) 0), "COERCE_COERCE");
      return
	 module_initialization_70_coerce_typeof(((long) 0), "COERCE_COERCE");
   }
}
