/*===========================================================================*/
/*   (Coerce/convert.scm)                                                    */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;

typedef struct tclass
  {
     obj_t its_super_214;
     obj_t slots;
     struct global *holder;
     obj_t widening;
     long depth;
     bool_t final__12;
     obj_t constructor;
     obj_t virtual_slots_number_200;
  }
      *tclass_bglt;


static obj_t method_init_76_coerce_convert();
extern obj_t user_warning_location_190_tools_error(obj_t, obj_t, obj_t, obj_t);
extern obj_t symbol_append_197___r4_symbols_6_4(obj_t);
static obj_t convert_error_217_coerce_convert(type_bglt, type_bglt, obj_t, node_bglt);
extern obj_t mark_symbol_non_user__17_ast_ident(obj_t);
extern obj_t let_var_6_ast_node;
extern obj_t var_ast_node;
extern obj_t location_full_fname_231_tools_location(obj_t);
extern obj_t lvtype_node__58_ast_lvtype(node_bglt);
extern obj_t _bdb_debug__1_engine_param;
extern obj_t gensym___r4_symbols_6_4;
extern obj_t _obj__252_type_cache;
extern bool_t type_subclass__90_object_class(type_bglt, type_bglt);
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t current_function_76_tools_error();
extern obj_t module_initialization_70_coerce_convert(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_location(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_tools_misc(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_type_coercion(long, char *);
extern obj_t module_initialization_70_type_env(long, char *);
extern obj_t module_initialization_70_ast_sexp(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_ast_ident(long, char *);
extern obj_t module_initialization_70_ast_lvtype(long, char *);
extern obj_t module_initialization_70_object_class(long, char *);
extern obj_t module_initialization_70_coerce_typeof(long, char *);
extern obj_t module_initialization_70_coerce_coerce(long, char *);
extern obj_t module_initialization_70___error(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_symbols_6_4(long, char *);
extern obj_t runtime_type_error_216_coerce_convert(obj_t, obj_t, obj_t);
extern bool_t sub_type__174_type_env(type_bglt, type_bglt);
extern long class_num_218___object(obj_t);
extern obj_t node_ast_node;
static obj_t imported_modules_init_94_coerce_convert();
static obj_t make_one_conversion_147_coerce_convert(obj_t, type_bglt, type_bglt, obj_t, obj_t, obj_t);
extern node_bglt coerce__182_coerce_coerce(node_bglt, type_bglt);
static node_bglt skip_let_var_187_coerce_convert(node_bglt);
extern obj_t app_ast_node;
static obj_t library_modules_init_112_coerce_convert();
static obj_t type_error_location_103_coerce_convert(obj_t, obj_t, type_bglt, type_bglt);
extern obj_t cast_ast_node;
static obj_t toplevel_init_63_coerce_convert();
extern obj_t _unsafe_type__146_engine_param;
static obj_t _convert__140_coerce_convert(obj_t, obj_t, obj_t, obj_t);
extern obj_t open_input_string(obj_t);
extern node_bglt top_level_sexp__node_204_ast_sexp(obj_t, obj_t);
static obj_t make_one_class_conversion_131_coerce_convert(obj_t, type_bglt, type_bglt, obj_t, obj_t, obj_t);
extern node_bglt convert__122_coerce_convert(node_bglt, type_bglt, type_bglt);
extern obj_t tclass_object_class;
extern obj_t bigloo_type_error_msg_127___error(obj_t, obj_t, obj_t);
extern obj_t _compiler_debug__134_engine_param;
static obj_t do_convert_128_coerce_convert(obj_t, obj_t, type_bglt);
extern obj_t shape_tools_shape(obj_t);
extern obj_t internal_error_43_tools_error(obj_t, obj_t, obj_t);
extern type_bglt get_aliased_type_1_type_type(type_bglt);
static obj_t _runtime_type_error_144_coerce_convert(obj_t, obj_t, obj_t, obj_t);
static node_bglt make_one_type_conversion_101_coerce_convert(obj_t, type_bglt, type_bglt, obj_t, obj_t, obj_t);
extern obj_t _4dots_199_tools_misc;
extern obj_t read___reader(obj_t);
extern obj_t find_coercer_15_type_coercion(type_bglt, type_bglt);
static obj_t require_initialization_114_coerce_convert = BUNSPEC;
static obj_t cnst_init_137_coerce_convert();
extern obj_t user_error_location_137_tools_error(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t runtime_type_error_id_5_coerce_convert(obj_t, obj_t, obj_t);
static obj_t __cnst[14];

DEFINE_EXPORT_PROCEDURE(runtime_type_error_env_213_coerce_convert, _runtime_type_error_144_coerce_convert1830, _runtime_type_error_144_coerce_convert, 0L, 3);
DEFINE_EXPORT_PROCEDURE(convert__env_238_coerce_convert, _convert__140_coerce_convert1831, _convert__140_coerce_convert, 0L, 3);
DEFINE_STRING(string1825_coerce_convert, string1825_coerce_convert1832, "AUX2 IF COERCER BIGLOO-TYPE-ERROR FAILURE QUOTE __ERROR BIGLOO-TYPE-ERROR/LOCATION @ BEGIN LOCATION ::OBJ LET AUX ", 114);
DEFINE_STRING(string1824_coerce_convert, string1824_coerce_convert1833, "Illegal converter", 17);
DEFINE_STRING(string1823_coerce_convert, string1823_coerce_convert1834, "do-convert", 10);
DEFINE_STRING(string1822_coerce_convert, string1822_coerce_convert1835, "Illegal conversion", 18);
DEFINE_STRING(string1821_coerce_convert, string1821_coerce_convert1836, "Type error", 10);
DEFINE_STRING(string1820_coerce_convert, string1820_coerce_convert1837, "", 0);



/* module-initialization */
obj_t 
module_initialization_70_coerce_convert(long checksum_1914, char *from_1915)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_coerce_convert))
	{
	   require_initialization_114_coerce_convert =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_coerce_convert();
	   cnst_init_137_coerce_convert();
	   imported_modules_init_94_coerce_convert();
	   method_init_76_coerce_convert();
	   toplevel_init_63_coerce_convert();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_coerce_convert()
{
   AN_OBJECT;
   {	/* Coerce/convert.scm 15 */
      module_initialization_70___r4_symbols_6_4(((long) 0), "COERCE_CONVERT");
      module_initialization_70___object(((long) 0), "COERCE_CONVERT");
      module_initialization_70___error(((long) 0), "COERCE_CONVERT");
      module_initialization_70___reader(((long) 0), "COERCE_CONVERT");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_coerce_convert()
{
   AN_OBJECT;
   {	/* Coerce/convert.scm 15 */
      {		/* Coerce/convert.scm 15 */
	 obj_t cnst_port_138_1907;
	 cnst_port_138_1907 =
	    open_input_string(string1825_coerce_convert);
	 {
	    long i_1908;
	    i_1908 = ((long) 13);
	  loop_1909:
	    {	/* Coerce/convert.scm 15 */
	       bool_t test1826_1910;
	       test1826_1910 =
		  (i_1908 == ((long) -1));
	       if (test1826_1910)
		 {	/* Coerce/convert.scm 15 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Coerce/convert.scm 15 */
		    {	/* Coerce/convert.scm 15 */
		       obj_t arg1827_1911;
		       {	/* Coerce/convert.scm 15 */
			  obj_t list1828_1912;
			  list1828_1912 =
			     MAKE_PAIR(cnst_port_138_1907, BNIL);
			  arg1827_1911 =
			     read___reader(list1828_1912);
		       }
		       CNST_TABLE_SET(i_1908, arg1827_1911);
		    }
		    {	/* Coerce/convert.scm 15 */
		       int aux_1913;
		       {	/* Coerce/convert.scm 15 */
			  long aux_1934;
			  aux_1934 =
			     (i_1908 - ((long) 1));
			  aux_1913 =
			     (int) (aux_1934);
		       }
		       {
			  long i_1937;
			  i_1937 =
			     (long) (aux_1913);
			  i_1908 = i_1937;
			  goto loop_1909;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_coerce_convert()
{
   AN_OBJECT;
   {	/* Coerce/convert.scm 15 */
      return BUNSPEC;
   }
}



/* type-error/location */
obj_t 
type_error_location_103_coerce_convert(obj_t loc_33, obj_t function_34, type_bglt from_35, type_bglt to_36)
{
   AN_OBJECT;
   {	/* Coerce/convert.scm 42 */
      {		/* Coerce/convert.scm 43 */
	 obj_t arg1490_872;
	 {	/* Coerce/convert.scm 46 */
	    obj_t arg1494_875;
	    obj_t arg1495_876;
	    {	/* ./Ieee/symbol.scm 6021 */
	       obj_t aux_1939;
	       aux_1939 =
		  (((type_bglt) CREF(to_36))->id);
	       arg1494_875 =
		  SYMBOL_TO_STRING(aux_1939);
	    }
	    {	/* ./Ieee/symbol.scm 6021 */
	       obj_t aux_1942;
	       aux_1942 =
		  (((type_bglt) CREF(from_35))->id);
	       arg1495_876 =
		  SYMBOL_TO_STRING(aux_1942);
	    }
	    arg1490_872 =
	       bigloo_type_error_msg_127___error(string1820_coerce_convert, arg1494_875, arg1495_876);
	 }
	 return
	    user_error_location_137_tools_error(loc_33, function_34, string1821_coerce_convert, arg1490_872, BNIL);
      }
   }
}



/* runtime-type-error */
obj_t 
runtime_type_error_216_coerce_convert(obj_t loc_41, obj_t ti_42, obj_t value_43)
{
   AN_OBJECT;
   {	/* Coerce/convert.scm 66 */
      {

	 {	/* Coerce/convert.scm 99 */
	    bool_t test1505_888;
	    test1505_888 =
	       is_a__118___object(value_43, node_ast_node);
	    if (test1505_888)
	      {		/* Coerce/convert.scm 100 */
		 node_bglt aux_1949;
		 {	/* Coerce/convert.scm 91 */
		    obj_t aux_890;
		    aux_890 =
		       PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4,
		       CNST_TABLE_REF(((long) 0)), BEOA);
		    {	/* Coerce/convert.scm 91 */
		       node_bglt res_891;
		       {	/* Coerce/convert.scm 93 */
			  obj_t arg1510_894;
			  {	/* Coerce/convert.scm 93 */
			     obj_t arg1511_895;
			     obj_t arg1512_896;
			     arg1511_895 =
				CNST_TABLE_REF(((long) 1));
			     {	/* Coerce/convert.scm 93 */
				obj_t arg1513_897;
				obj_t arg1514_898;
				{	/* Coerce/convert.scm 93 */
				   obj_t arg1515_899;
				   {	/* Coerce/convert.scm 93 */
				      obj_t arg1517_901;
				      obj_t arg1519_902;
				      {		/* Coerce/convert.scm 93 */
					 obj_t arg1520_903;
					 {	/* Coerce/convert.scm 93 */
					    obj_t list1521_904;
					    {	/* Coerce/convert.scm 93 */
					       obj_t arg1522_905;
					       {	/* Coerce/convert.scm 93 */
						  obj_t aux_1954;
						  aux_1954 =
						     CNST_TABLE_REF(((long) 2));
						  arg1522_905 =
						     MAKE_PAIR(aux_1954, BNIL);
					       }
					       list1521_904 =
						  MAKE_PAIR(aux_890, arg1522_905);
					    }
					    arg1520_903 =
					       symbol_append_197___r4_symbols_6_4(list1521_904);
					 }
					 arg1517_901 =
					    mark_symbol_non_user__17_ast_ident(arg1520_903);
				      }
				      arg1519_902 =
					 MAKE_PAIR(BUNSPEC, BNIL);
				      arg1515_899 =
					 MAKE_PAIR(arg1517_901, arg1519_902);
				   }
				   arg1513_897 =
				      MAKE_PAIR(arg1515_899, BNIL);
				}
				{	/* Coerce/convert.scm 95 */
				   obj_t arg1523_906;
				   arg1523_906 =
				      runtime_type_error_id_5_coerce_convert(ti_42, loc_41, aux_890);
				   arg1514_898 =
				      MAKE_PAIR(arg1523_906, BNIL);
				}
				arg1512_896 =
				   MAKE_PAIR(arg1513_897, arg1514_898);
			     }
			     arg1510_894 =
				MAKE_PAIR(arg1511_895, arg1512_896);
			  }
			  res_891 =
			     top_level_sexp__node_204_ast_sexp(arg1510_894, loc_41);
		       }
		       {	/* Coerce/convert.scm 92 */

			  {	/* ./Ieee/pair-list.scm 5896 */
			     obj_t aux_1968;
			     {	/* ./Ieee/pair-list.scm 5701 */
				obj_t aux_1969;
				{	/* Coerce/convert.scm 97 */
				   let_var_6_bglt obj_1551;
				   obj_1551 =
				      (let_var_6_bglt) (res_891);
				   aux_1969 =
				      (((let_var_6_bglt) CREF(obj_1551))->bindings);
				}
				aux_1968 =
				   CAR(aux_1969);
			     }
			     SET_CDR(aux_1968, value_43);
			  }
			  aux_1949 = res_891;
		       }
		    }
		 }
		 return
		    (obj_t) (aux_1949);
	      }
	    else
	      {		/* Coerce/convert.scm 99 */
		 return
		    runtime_type_error_id_5_coerce_convert(ti_42, loc_41, value_43);
	      }
	 }
      }
   }
}



/* runtime-type-error/id */
obj_t 
runtime_type_error_id_5_coerce_convert(obj_t ti_1904, obj_t loc_1903, obj_t id_908)
{
   AN_OBJECT;
   {	/* Coerce/convert.scm 69 */
      {		/* Coerce/convert.scm 71 */
	 bool_t test1527_910;
	 {	/* Coerce/convert.scm 71 */
	    bool_t test1589_964;
	    {	/* Coerce/convert.scm 71 */
	       bool_t test1590_965;
	       {	/* Coerce/convert.scm 71 */
		  long n1_1555;
		  n1_1555 =
		     (long) CINT(_bdb_debug__1_engine_param);
		  test1590_965 =
		     (n1_1555 > ((long) 0));
	       }
	       if (test1590_965)
		 {	/* Coerce/convert.scm 71 */
		    test1589_964 = ((bool_t) 1);
		 }
	       else
		 {	/* Coerce/convert.scm 72 */
		    long n1_1557;
		    n1_1557 =
		       (long) CINT(_compiler_debug__134_engine_param);
		    test1589_964 =
		       (n1_1557 > ((long) 0));
		 }
	    }
	    if (test1589_964)
	      {		/* Coerce/convert.scm 71 */
		 if (
		    STRUCTP(loc_1903))
		   {	/* ./Ieee/equiv.scm 5508 */
		      obj_t aux_1986;
		      obj_t aux_1984;
		      aux_1986 =
			 CNST_TABLE_REF(((long) 3));
		      aux_1984 =
			 STRUCT_KEY(loc_1903);
		      test1527_910 =
			 (aux_1984 == aux_1986);
		   }
		 else
		   {	/* ./Tools/location.sch 613 */
		      test1527_910 = ((bool_t) 0);
		   }
	      }
	    else
	      {		/* Coerce/convert.scm 71 */
		 test1527_910 = ((bool_t) 0);
	      }
	 }
	 if (test1527_910)
	   {	/* Coerce/convert.scm 74 */
	      obj_t arg1528_911;
	      obj_t arg1529_912;
	      arg1528_911 =
		 CNST_TABLE_REF(((long) 4));
	      {		/* Coerce/convert.scm 75 */
		 obj_t arg1530_913;
		 obj_t arg1532_914;
		 {	/* Coerce/convert.scm 75 */
		    obj_t arg1533_915;
		    obj_t arg1534_916;
		    {	/* Coerce/convert.scm 75 */
		       obj_t arg1535_917;
		       obj_t arg1536_918;
		       arg1535_917 =
			  CNST_TABLE_REF(((long) 5));
		       {	/* Coerce/convert.scm 75 */
			  obj_t arg1537_919;
			  obj_t arg1539_920;
			  arg1537_919 =
			     CNST_TABLE_REF(((long) 6));
			  {	/* ./Ieee/pair-list.scm 5689 */
			     obj_t aux_1993;
			     aux_1993 =
				CNST_TABLE_REF(((long) 7));
			     arg1539_920 =
				MAKE_PAIR(aux_1993, BNIL);
			  }
			  arg1536_918 =
			     MAKE_PAIR(arg1537_919, arg1539_920);
		       }
		       arg1533_915 =
			  MAKE_PAIR(arg1535_917, arg1536_918);
		    }
		    {	/* Coerce/convert.scm 75 */
		       obj_t arg1540_921;
		       obj_t arg1541_922;
		       {	/* Coerce/convert.scm 75 */
			  obj_t arg1543_923;
			  obj_t arg1544_924;
			  arg1543_923 =
			     CNST_TABLE_REF(((long) 8));
			  {	/* Coerce/convert.scm 75 */
			     obj_t arg1545_925;
			     arg1545_925 =
				current_function_76_tools_error();
			     arg1544_924 =
				MAKE_PAIR(arg1545_925, BNIL);
			  }
			  arg1540_921 =
			     MAKE_PAIR(arg1543_923, arg1544_924);
		       }
		       {	/* Coerce/convert.scm 76 */
			  obj_t arg1548_927;
			  obj_t arg1549_928;
			  arg1548_927 =
			     SYMBOL_TO_STRING(ti_1904);
			  {	/* Coerce/convert.scm 78 */
			     obj_t arg1550_929;
			     {	/* Coerce/convert.scm 78 */
				obj_t arg1551_930;
				obj_t arg1552_931;
				arg1551_930 =
				   location_full_fname_231_tools_location(loc_1903);
				{	/* ./Ieee/pair-list.scm 5689 */
				   obj_t aux_2004;
				   aux_2004 =
				      STRUCT_REF(loc_1903, ((long) 1));
				   arg1552_931 =
				      MAKE_PAIR(aux_2004, BNIL);
				}
				arg1550_929 =
				   MAKE_PAIR(arg1551_930, arg1552_931);
			     }
			     arg1549_928 =
				MAKE_PAIR(id_908, arg1550_929);
			  }
			  arg1541_922 =
			     MAKE_PAIR(arg1548_927, arg1549_928);
		       }
		       arg1534_916 =
			  MAKE_PAIR(arg1540_921, arg1541_922);
		    }
		    arg1530_913 =
		       MAKE_PAIR(arg1533_915, arg1534_916);
		 }
		 {	/* Coerce/convert.scm 83 */
		    obj_t arg1556_934;
		    {	/* Coerce/convert.scm 83 */
		       obj_t arg1558_936;
		       obj_t arg1559_937;
		       arg1558_936 =
			  CNST_TABLE_REF(((long) 9));
		       {	/* Coerce/convert.scm 83 */
			  obj_t arg1560_938;
			  {	/* Coerce/convert.scm 83 */
			     obj_t arg1561_939;
			     arg1561_939 =
				MAKE_PAIR(BFALSE, BNIL);
			     arg1560_938 =
				MAKE_PAIR(BFALSE, arg1561_939);
			  }
			  arg1559_937 =
			     MAKE_PAIR(BFALSE, arg1560_938);
		       }
		       arg1556_934 =
			  MAKE_PAIR(arg1558_936, arg1559_937);
		    }
		    arg1532_914 =
		       MAKE_PAIR(arg1556_934, BNIL);
		 }
		 arg1529_912 =
		    MAKE_PAIR(arg1530_913, arg1532_914);
	      }
	      return
		 MAKE_PAIR(arg1528_911, arg1529_912);
	   }
	 else
	   {	/* Coerce/convert.scm 84 */
	      obj_t arg1562_940;
	      obj_t arg1563_941;
	      arg1562_940 =
		 CNST_TABLE_REF(((long) 4));
	      {		/* Coerce/convert.scm 85 */
		 obj_t arg1564_942;
		 obj_t arg1565_943;
		 {	/* Coerce/convert.scm 85 */
		    obj_t arg1566_944;
		    obj_t arg1567_945;
		    {	/* Coerce/convert.scm 85 */
		       obj_t arg1568_946;
		       obj_t arg1569_947;
		       arg1568_946 =
			  CNST_TABLE_REF(((long) 5));
		       {	/* Coerce/convert.scm 85 */
			  obj_t arg1571_948;
			  obj_t arg1572_949;
			  arg1571_948 =
			     CNST_TABLE_REF(((long) 10));
			  {	/* ./Ieee/pair-list.scm 5689 */
			     obj_t aux_2023;
			     aux_2023 =
				CNST_TABLE_REF(((long) 7));
			     arg1572_949 =
				MAKE_PAIR(aux_2023, BNIL);
			  }
			  arg1569_947 =
			     MAKE_PAIR(arg1571_948, arg1572_949);
		       }
		       arg1566_944 =
			  MAKE_PAIR(arg1568_946, arg1569_947);
		    }
		    {	/* Coerce/convert.scm 85 */
		       obj_t arg1573_950;
		       obj_t arg1576_951;
		       {	/* Coerce/convert.scm 85 */
			  obj_t arg1577_952;
			  obj_t arg1578_953;
			  arg1577_952 =
			     CNST_TABLE_REF(((long) 8));
			  {	/* Coerce/convert.scm 85 */
			     obj_t arg1579_954;
			     arg1579_954 =
				current_function_76_tools_error();
			     arg1578_953 =
				MAKE_PAIR(arg1579_954, BNIL);
			  }
			  arg1573_950 =
			     MAKE_PAIR(arg1577_952, arg1578_953);
		       }
		       {	/* Coerce/convert.scm 86 */
			  obj_t arg1581_956;
			  obj_t arg1582_957;
			  arg1581_956 =
			     SYMBOL_TO_STRING(ti_1904);
			  arg1582_957 =
			     MAKE_PAIR(id_908, BNIL);
			  arg1576_951 =
			     MAKE_PAIR(arg1581_956, arg1582_957);
		       }
		       arg1567_945 =
			  MAKE_PAIR(arg1573_950, arg1576_951);
		    }
		    arg1564_942 =
		       MAKE_PAIR(arg1566_944, arg1567_945);
		 }
		 {	/* Coerce/convert.scm 88 */
		    obj_t arg1583_958;
		    {	/* Coerce/convert.scm 88 */
		       obj_t arg1585_960;
		       obj_t arg1586_961;
		       arg1585_960 =
			  CNST_TABLE_REF(((long) 9));
		       {	/* Coerce/convert.scm 88 */
			  obj_t arg1587_962;
			  {	/* Coerce/convert.scm 88 */
			     obj_t arg1588_963;
			     arg1588_963 =
				MAKE_PAIR(BFALSE, BNIL);
			     arg1587_962 =
				MAKE_PAIR(BFALSE, arg1588_963);
			  }
			  arg1586_961 =
			     MAKE_PAIR(BFALSE, arg1587_962);
		       }
		       arg1583_958 =
			  MAKE_PAIR(arg1585_960, arg1586_961);
		    }
		    arg1565_943 =
		       MAKE_PAIR(arg1583_958, BNIL);
		 }
		 arg1563_941 =
		    MAKE_PAIR(arg1564_942, arg1565_943);
	      }
	      return
		 MAKE_PAIR(arg1562_940, arg1563_941);
	   }
      }
   }
}



/* _runtime-type-error */
obj_t 
_runtime_type_error_144_coerce_convert(obj_t env_1895, obj_t loc_1896, obj_t ti_1897, obj_t value_1898)
{
   AN_OBJECT;
   {	/* Coerce/convert.scm 66 */
      return
	 runtime_type_error_216_coerce_convert(loc_1896, ti_1897, value_1898);
   }
}



/* convert-error */
obj_t 
convert_error_217_coerce_convert(type_bglt from_44, type_bglt to_45, obj_t loc_46, node_bglt node_47)
{
   AN_OBJECT;
   {	/* Coerce/convert.scm 110 */
      {		/* Coerce/convert.scm 113 */
	 bool_t test1591_968;
	 {	/* Coerce/convert.scm 113 */
	    bool_t test1596_975;
	    {	/* Coerce/convert.scm 113 */
	       obj_t obj2_1641;
	       obj2_1641 = _obj__252_type_cache;
	       {	/* ./Ieee/equiv.scm 5508 */
		  obj_t aux_2046;
		  aux_2046 =
		     (obj_t) (to_45);
		  test1596_975 =
		     (aux_2046 == obj2_1641);
	       }
	    }
	    if (test1596_975)
	      {		/* Coerce/convert.scm 113 */
		 test1591_968 = ((bool_t) 0);
	      }
	    else
	      {		/* Coerce/convert.scm 113 */
		 test1591_968 =
		    sub_type__174_type_env(to_45,
		    (type_bglt) (_obj__252_type_cache));
	      }
	 }
	 if (test1591_968)
	   {	/* Coerce/convert.scm 114 */
	      obj_t unsafe_type_48_969;
	      unsafe_type_48_969 = _unsafe_type__146_engine_param;
	      _unsafe_type__146_engine_param = BTRUE;
	      {		/* Coerce/convert.scm 116 */
		 obj_t arg1592_970;
		 arg1592_970 =
		    current_function_76_tools_error();
		 {	/* Coerce/convert.scm 55 */
		    obj_t arg1499_1647;
		    {	/* Coerce/convert.scm 58 */
		       obj_t arg1501_1649;
		       obj_t arg1502_1650;
		       {	/* ./Ieee/symbol.scm 6021 */
			  obj_t aux_2054;
			  aux_2054 =
			     (((type_bglt) CREF(to_45))->id);
			  arg1501_1649 =
			     SYMBOL_TO_STRING(aux_2054);
		       }
		       {	/* ./Ieee/symbol.scm 6021 */
			  obj_t aux_2057;
			  aux_2057 =
			     (((type_bglt) CREF(from_44))->id);
			  arg1502_1650 =
			     SYMBOL_TO_STRING(aux_2057);
		       }
		       arg1499_1647 =
			  bigloo_type_error_msg_127___error(string1820_coerce_convert, arg1501_1649, arg1502_1650);
		    }
		    user_warning_location_190_tools_error(loc_46, arg1592_970, string1821_coerce_convert, arg1499_1647);
		 }
	      }
	      {		/* Coerce/convert.scm 117 */
		 node_bglt res_971;
		 {	/* Coerce/convert.scm 117 */
		    obj_t arg1593_972;
		    arg1593_972 =
		       runtime_type_error_216_coerce_convert(loc_46,
		       (((type_bglt) CREF(to_45))->id),
		       (obj_t) (node_47));
		    res_971 =
		       coerce__182_coerce_coerce(
		       (node_bglt) (arg1593_972), from_44);
		 }
		 _unsafe_type__146_engine_param = unsafe_type_48_969;
		 return
		    (obj_t) (res_971);
	      }
	   }
	 else
	   {	/* Coerce/convert.scm 121 */
	      obj_t arg1595_974;
	      arg1595_974 =
		 current_function_76_tools_error();
	      return
		 type_error_location_103_coerce_convert(loc_46, arg1595_974, from_44, to_45);
	   }
      }
   }
}



/* convert! */
node_bglt 
convert__122_coerce_convert(node_bglt node_48, type_bglt from_49, type_bglt to_50)
{
   AN_OBJECT;
   {	/* Coerce/convert.scm 129 */
      {		/* Coerce/convert.scm 133 */
	 type_bglt to_976;
	 type_bglt from_977;
	 to_976 =
	    get_aliased_type_1_type_type(to_50);
	 from_977 =
	    get_aliased_type_1_type_type(from_49);
	 {	/* Coerce/convert.scm 135 */
	    bool_t test_2072;
	    {	/* Coerce/convert.scm 135 */
	       bool_t test_2073;
	       {	/* ./Ieee/equiv.scm 5508 */
		  obj_t aux_2076;
		  obj_t aux_2074;
		  aux_2076 =
		     (obj_t) (to_976);
		  aux_2074 =
		     (obj_t) (from_977);
		  test_2073 =
		     (aux_2074 == aux_2076);
	       }
	       if (test_2073)
		 {	/* Coerce/convert.scm 135 */
		    test_2072 = ((bool_t) 1)
		       ;
		 }
	       else
		 {	/* Coerce/convert.scm 135 */
		    test_2072 =
		       (((type_bglt) CREF(from_977))->magic__53)
		       ;
		 }
	    }
	    if (test_2072)
	      {		/* Coerce/convert.scm 135 */
		 return node_48;
	      }
	    else
	      {		/* Coerce/convert.scm 137 */
		 obj_t coercer_979;
		 obj_t loc_980;
		 coercer_979 =
		    find_coercer_15_type_coercion(from_977, to_976);
		 loc_980 =
		    (((node_bglt) CREF(node_48))->loc);
		 {	/* Coerce/convert.scm 139 */
		    bool_t test_2082;
		    if (
		       STRUCTP(coercer_979))
		      {		/* ./Ieee/equiv.scm 5508 */
			 obj_t aux_2087;
			 obj_t aux_2085;
			 aux_2087 =
			    CNST_TABLE_REF(((long) 11));
			 aux_2085 =
			    STRUCT_KEY(coercer_979);
			 test_2082 =
			    (aux_2085 == aux_2087);
		      }
		    else
		      {		/* ./Type/coercer.sch 624 */
			 test_2082 = ((bool_t) 0)
			    ;
		      }
		    if (test_2082)
		      {		/* Coerce/convert.scm 139 */
			 {
			    obj_t checks_984;
			    obj_t coerces_985;
			    obj_t node_986;
			    {	/* Coerce/convert.scm 148 */
			       obj_t aux_2090;
			       checks_984 =
				  STRUCT_REF(coercer_979, ((long) 2));
			       coerces_985 =
				  STRUCT_REF(coercer_979, ((long) 3));
			       node_986 =
				  (obj_t) (node_48);
			     loop_987:
			       if (
				  NULLP(checks_984))
				 {	/* Coerce/convert.scm 152 */
				    if (
				       NULLP(coerces_985))
				      {		/* Coerce/convert.scm 153 */
					 aux_2090 = node_986
					    ;
				      }
				    else
				      {		/* Coerce/convert.scm 155 */
					 obj_t arg1602_991;
					 obj_t arg1603_992;
					 arg1602_991 =
					    shape_tools_shape(
					    (obj_t) (from_977));
					 arg1603_992 =
					    shape_tools_shape(
					    (obj_t) (to_976));
					 aux_2090 =
					    internal_error_43_tools_error(string1822_coerce_convert, arg1602_991, arg1603_992);
				      }
				 }
			       else
				 {	/* Coerce/convert.scm 152 */
				    if (
				       NULLP(coerces_985))
				      {		/* Coerce/convert.scm 158 */
					 {	/* Coerce/convert.scm 159 */
					    obj_t arg1606_995;
					    obj_t arg1607_996;
					    arg1606_995 =
					       shape_tools_shape(
					       (obj_t) (from_977));
					    arg1607_996 =
					       shape_tools_shape(
					       (obj_t) (to_976));
					    aux_2090 =
					       internal_error_43_tools_error(string1822_coerce_convert, arg1606_995, arg1607_996);
					 }
				      }
				    else
				      {		/* Coerce/convert.scm 158 */
					 {	/* Coerce/convert.scm 163 */
					    obj_t arg1608_997;
					    obj_t arg1609_998;
					    obj_t arg1610_999;
					    arg1608_997 =
					       CDR(checks_984);
					    arg1609_998 =
					       CDR(coerces_985);
					    arg1610_999 =
					       make_one_conversion_147_coerce_convert(
					       CAR(checks_984), from_977, to_976,
					       CAR(checks_984),
					       CAR(coerces_985), node_986);
					    {
					       obj_t node_2115;
					       obj_t coerces_2114;
					       obj_t checks_2113;
					       checks_2113 = arg1608_997;
					       coerces_2114 = arg1609_998;
					       node_2115 = arg1610_999;
					       node_986 = node_2115;
					       coerces_985 = coerces_2114;
					       checks_984 = checks_2113;
					       goto loop_987;
					    }
					 }
				      }
				 }
			       return
				  (node_bglt) (aux_2090);
			    }
			 }
		      }
		    else
		      {		/* Coerce/convert.scm 142 */
			 obj_t aux_2120;
			 aux_2120 =
			    convert_error_217_coerce_convert(from_977, to_976, loc_980, node_48);
			 return
			    (node_bglt) (aux_2120);
		      }
		 }
	      }
	 }
      }
   }
}



/* _convert! */
obj_t 
_convert__140_coerce_convert(obj_t env_1899, obj_t node_1900, obj_t from_1901, obj_t to_1902)
{
   AN_OBJECT;
   {	/* Coerce/convert.scm 129 */
      {		/* Coerce/convert.scm 129 */
	 node_bglt aux_2123;
	 aux_2123 =
	    convert__122_coerce_convert(
	    (node_bglt) (node_1900),
	    (type_bglt) (from_1901),
	    (type_bglt) (to_1902));
	 return
	    (obj_t) (aux_2123);
      }
   }
}



/* make-one-conversion */
obj_t 
make_one_conversion_147_coerce_convert(obj_t id_from_153_51, type_bglt from_52, type_bglt to_53, obj_t checkop_54, obj_t coerceop_55, obj_t node_56)
{
   AN_OBJECT;
   {	/* Coerce/convert.scm 181 */
      {		/* Coerce/convert.scm 182 */
	 bool_t test1615_1004;
	 if (
	    NULLP(checkop_54))
	   {	/* Coerce/convert.scm 182 */
	      test1615_1004 = ((bool_t) 1);
	   }
	 else
	   {	/* Coerce/convert.scm 182 */
	      test1615_1004 =
		 CBOOL(_unsafe_type__146_engine_param);
	   }
	 if (test1615_1004)
	   {	/* Coerce/convert.scm 182 */
	      return
		 do_convert_128_coerce_convert(coerceop_55, node_56, from_52);
	   }
	 else
	   {	/* Coerce/convert.scm 184 */
	      bool_t test1616_1005;
	      test1616_1005 =
		 is_a__118___object(
		 (obj_t) (from_52), tclass_object_class);
	      if (test1616_1005)
		{	/* Coerce/convert.scm 184 */
		   return
		      make_one_class_conversion_131_coerce_convert(id_from_153_51, from_52, to_53, checkop_54, coerceop_55, node_56);
		}
	      else
		{	/* Coerce/convert.scm 186 */
		   node_bglt aux_2138;
		   aux_2138 =
		      make_one_type_conversion_101_coerce_convert(id_from_153_51, from_52, to_53, checkop_54, coerceop_55, node_56);
		   return
		      (obj_t) (aux_2138);
		}
	   }
      }
   }
}



/* skip-let-var */
node_bglt 
skip_let_var_187_coerce_convert(node_bglt node_57)
{
   AN_OBJECT;
   {	/* Coerce/convert.scm 191 */
    skip_let_var_187_coerce_convert:
      {		/* Coerce/convert.scm 192 */
	 bool_t test1618_1007;
	 test1618_1007 =
	    is_a__118___object(
	    (obj_t) (node_57), let_var_6_ast_node);
	 if (test1618_1007)
	   {
	      node_bglt node_2144;
	      {		/* Coerce/convert.scm 193 */
		 let_var_6_bglt obj_1687;
		 obj_1687 =
		    (let_var_6_bglt) (node_57);
		 node_2144 =
		    (((let_var_6_bglt) CREF(obj_1687))->body);
	      }
	      node_57 = node_2144;
	      goto skip_let_var_187_coerce_convert;
	   }
	 else
	   {	/* Coerce/convert.scm 192 */
	      return node_57;
	   }
      }
   }
}



/* make-one-type-conversion */
node_bglt 
make_one_type_conversion_101_coerce_convert(obj_t id_from_153_58, type_bglt from_59, type_bglt to_60, obj_t check_op_210_61, obj_t coerce_op_79_62, obj_t node_63)
{
   AN_OBJECT;
   {	/* Coerce/convert.scm 199 */
      {		/* Coerce/convert.scm 200 */
	 obj_t aux_1009;
	 {	/* Coerce/convert.scm 200 */
	    obj_t arg1656_1050;
	    arg1656_1050 =
	       PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4,
	       CNST_TABLE_REF(((long) 0)), BEOA);
	    aux_1009 =
	       mark_symbol_non_user__17_ast_ident(arg1656_1050);
	 }
	 {	/* Coerce/convert.scm 200 */
	    obj_t loc_1010;
	    {	/* Coerce/convert.scm 201 */
	       node_bglt obj_1688;
	       obj_1688 =
		  (node_bglt) (node_63);
	       loc_1010 =
		  (((node_bglt) CREF(obj_1688))->loc);
	    }
	    {	/* Coerce/convert.scm 201 */
	       node_bglt lnode_1011;
	       {	/* Coerce/convert.scm 208 */
		  obj_t arg1630_1025;
		  {	/* Coerce/convert.scm 208 */
		     obj_t arg1631_1026;
		     obj_t arg1632_1027;
		     arg1631_1026 =
			CNST_TABLE_REF(((long) 1));
		     {	/* Coerce/convert.scm 209 */
			obj_t arg1633_1028;
			obj_t arg1634_1029;
			{	/* Coerce/convert.scm 209 */
			   obj_t arg1635_1030;
			   {	/* Coerce/convert.scm 209 */
			      obj_t arg1637_1032;
			      obj_t arg1638_1033;
			      {		/* Coerce/convert.scm 209 */
				 obj_t arg1639_1034;
				 {	/* Coerce/convert.scm 209 */
				    obj_t list1641_1036;
				    {	/* Coerce/convert.scm 209 */
				       obj_t arg1642_1037;
				       {	/* Coerce/convert.scm 209 */
					  obj_t arg1643_1038;
					  {	/* Coerce/convert.scm 209 */
					     obj_t aux_2154;
					     aux_2154 =
						(((type_bglt) CREF(from_59))->id);
					     arg1643_1038 =
						MAKE_PAIR(aux_2154, BNIL);
					  }
					  arg1642_1037 =
					     MAKE_PAIR(_4dots_199_tools_misc, arg1643_1038);
				       }
				       list1641_1036 =
					  MAKE_PAIR(aux_1009, arg1642_1037);
				    }
				    arg1639_1034 =
				       symbol_append_197___r4_symbols_6_4(list1641_1036);
				 }
				 arg1637_1032 =
				    mark_symbol_non_user__17_ast_ident(arg1639_1034);
			      }
			      arg1638_1033 =
				 MAKE_PAIR(BUNSPEC, BNIL);
			      arg1635_1030 =
				 MAKE_PAIR(arg1637_1032, arg1638_1033);
			   }
			   arg1633_1028 =
			      MAKE_PAIR(arg1635_1030, BNIL);
			}
			{	/* Coerce/convert.scm 211 */
			   obj_t arg1644_1039;
			   {	/* Coerce/convert.scm 211 */
			      obj_t arg1647_1041;
			      obj_t arg1648_1042;
			      arg1647_1041 =
				 CNST_TABLE_REF(((long) 12));
			      {		/* Coerce/convert.scm 211 */
				 obj_t arg1649_1043;
				 obj_t arg1650_1044;
				 {	/* Coerce/convert.scm 211 */
				    obj_t arg1651_1045;
				    arg1651_1045 =
				       MAKE_PAIR(aux_1009, BNIL);
				    arg1649_1043 =
				       MAKE_PAIR(check_op_210_61, arg1651_1045);
				 }
				 {	/* Coerce/convert.scm 213 */
				    obj_t arg1652_1046;
				    {	/* Coerce/convert.scm 213 */
				       obj_t arg1653_1047;
				       arg1653_1047 =
					  runtime_type_error_216_coerce_convert(loc_1010,
					  (((type_bglt) CREF(to_60))->id), aux_1009);
				       arg1652_1046 =
					  MAKE_PAIR(arg1653_1047, BNIL);
				    }
				    arg1650_1044 =
				       MAKE_PAIR(aux_1009, arg1652_1046);
				 }
				 arg1648_1042 =
				    MAKE_PAIR(arg1649_1043, arg1650_1044);
			      }
			      arg1644_1039 =
				 MAKE_PAIR(arg1647_1041, arg1648_1042);
			   }
			   arg1634_1029 =
			      MAKE_PAIR(arg1644_1039, BNIL);
			}
			arg1632_1027 =
			   MAKE_PAIR(arg1633_1028, arg1634_1029);
		     }
		     arg1630_1025 =
			MAKE_PAIR(arg1631_1026, arg1632_1027);
		  }
		  lnode_1011 =
		     top_level_sexp__node_204_ast_sexp(arg1630_1025, loc_1010);
	       }
	       {	/* Coerce/convert.scm 202 */

		  lvtype_node__58_ast_lvtype(lnode_1011);
		  {	/* Coerce/convert.scm 216 */
		     obj_t var_1012;
		     {	/* ./Ieee/pair-list.scm 5701 */
			obj_t aux_2178;
			{	/* ./Ieee/pair-list.scm 5701 */
			   obj_t aux_2179;
			   {	/* Coerce/convert.scm 216 */
			      let_var_6_bglt obj_1715;
			      obj_1715 =
				 (let_var_6_bglt) (lnode_1011);
			      aux_2179 =
				 (((let_var_6_bglt) CREF(obj_1715))->bindings);
			   }
			   aux_2178 =
			      CAR(aux_2179);
			}
			var_1012 =
			   CAR(aux_2178);
		     }
		     {	/* Coerce/convert.scm 216 */
			obj_t coerce_app_174_1013;
			{	/* Coerce/convert.scm 218 */
			   var_bglt arg1624_1019;
			   {	/* Coerce/convert.scm 218 */
			      var_bglt res1816_1728;
			      {		/* Coerce/convert.scm 218 */
				 variable_bglt variable_1720;
				 variable_1720 =
				    (variable_bglt) (var_1012);
				 {	/* ./Ast/node.scm 1395 */
				    var_bglt new1210_1721;
				    new1210_1721 =
				       ((var_bglt) BREF(GC_MALLOC(sizeof(struct var))));
				    {	/* ./Ast/node.scm 1395 */
				       long arg1781_1722;
				       arg1781_1722 =
					  class_num_218___object(var_ast_node);
				       {	/* ./Ast/node.scm 1395 */
					  obj_t obj_1726;
					  obj_1726 =
					     (obj_t) (new1210_1721);
					  (((obj_t) CREF(obj_1726))->header = MAKE_HEADER(arg1781_1722, 0), BUNSPEC);
				       }
				    }
				    {	/* ./Ast/node.scm 1395 */
				       object_bglt aux_2189;
				       aux_2189 =
					  (object_bglt) (new1210_1721);
				       OBJECT_WIDENING_SET(aux_2189, BFALSE);
				    }
				    ((((var_bglt) CREF(new1210_1721))->loc) = ((obj_t) loc_1010), BUNSPEC);
				    ((((var_bglt) CREF(new1210_1721))->type) = ((type_bglt) from_59), BUNSPEC);
				    ((((var_bglt) CREF(new1210_1721))->variable) = ((variable_bglt) variable_1720), BUNSPEC);
				    res1816_1728 = new1210_1721;
				 }
			      }
			      arg1624_1019 = res1816_1728;
			   }
			   coerce_app_174_1013 =
			      do_convert_128_coerce_convert(coerce_op_79_62,
			      (obj_t) (arg1624_1019), from_59);
			}
			{	/* Coerce/convert.scm 217 */
			   node_bglt condn_1014;
			   condn_1014 =
			      skip_let_var_187_coerce_convert(lnode_1011);
			   {	/* Coerce/convert.scm 223 */

			      {		/* Coerce/convert.scm 225 */
				 local_bglt obj_1729;
				 obj_1729 =
				    (local_bglt) (var_1012);
				 ((((local_bglt) CREF(obj_1729))->type) = ((type_bglt) from_59), BUNSPEC);
			      }
			      {		/* ./Ieee/pair-list.scm 5896 */
				 obj_t aux_2200;
				 {	/* ./Ieee/pair-list.scm 5701 */
				    obj_t aux_2201;
				    {	/* Coerce/convert.scm 227 */
				       let_var_6_bglt obj_1731;
				       obj_1731 =
					  (let_var_6_bglt) (lnode_1011);
				       aux_2201 =
					  (((let_var_6_bglt) CREF(obj_1731))->bindings);
				    }
				    aux_2200 =
				       CAR(aux_2201);
				 }
				 SET_CDR(aux_2200, node_63);
			      }
			      {		/* Coerce/convert.scm 228 */
				 conditional_bglt obj_1735;
				 node_bglt val1315_1736;
				 obj_1735 =
				    (conditional_bglt) (condn_1014);
				 val1315_1736 =
				    (node_bglt) (coerce_app_174_1013);
				 ((((conditional_bglt) CREF(obj_1735))->true) = ((node_bglt) val1315_1736), BUNSPEC);
			      }
			      _unsafe_type__146_engine_param = BTRUE;
			      {		/* Coerce/convert.scm 231 */
				 node_bglt arg1622_1017;
				 {	/* Coerce/convert.scm 231 */
				    node_bglt aux_2209;
				    {	/* Coerce/convert.scm 231 */
				       conditional_bglt obj_1737;
				       obj_1737 =
					  (conditional_bglt) (condn_1014);
				       aux_2209 =
					  (((conditional_bglt) CREF(obj_1737))->false);
				    }
				    arg1622_1017 =
				       coerce__182_coerce_coerce(aux_2209, from_59);
				 }
				 {	/* Coerce/convert.scm 230 */
				    conditional_bglt obj_1738;
				    obj_1738 =
				       (conditional_bglt) (condn_1014);
				    ((((conditional_bglt) CREF(obj_1738))->false) = ((node_bglt) arg1622_1017), BUNSPEC);
				 }
			      }
			      _unsafe_type__146_engine_param = BFALSE;
			      return lnode_1011;
			   }
			}
		     }
		  }
	       }
	    }
	 }
      }
   }
}



/* make-one-class-conversion */
obj_t 
make_one_class_conversion_131_coerce_convert(obj_t id_from_153_64, type_bglt from_65, type_bglt to_66, obj_t check_op_210_67, obj_t coerce_op_79_68, obj_t node_69)
{
   AN_OBJECT;
   {	/* Coerce/convert.scm 238 */
      {		/* Coerce/convert.scm 239 */
	 bool_t test1657_1051;
	 {	/* Coerce/convert.scm 239 */
	    bool_t test1715_1115;
	    test1715_1115 =
	       is_a__118___object(
	       (obj_t) (to_66), tclass_object_class);
	    if (test1715_1115)
	      {		/* Coerce/convert.scm 239 */
		 test1657_1051 =
		    type_subclass__90_object_class(from_65, to_66);
	      }
	    else
	      {		/* Coerce/convert.scm 239 */
		 test1657_1051 = ((bool_t) 0);
	      }
	 }
	 if (test1657_1051)
	   {	/* Coerce/convert.scm 239 */
	      return
		 do_convert_128_coerce_convert(coerce_op_79_68, node_69, from_65);
	   }
	 else
	   {	/* Coerce/convert.scm 241 */
	      obj_t aux_1052;
	      aux_1052 =
		 PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4,
		 CNST_TABLE_REF(((long) 0)), BEOA);
	      {		/* Coerce/convert.scm 241 */
		 obj_t aux2_1053;
		 aux2_1053 =
		    PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4,
		    CNST_TABLE_REF(((long) 13)), BEOA);
		 {	/* Coerce/convert.scm 242 */
		    obj_t loc_1054;
		    {	/* Coerce/convert.scm 243 */
		       node_bglt obj_1741;
		       obj_1741 =
			  (node_bglt) (node_69);
		       loc_1054 =
			  (((node_bglt) CREF(obj_1741))->loc);
		    }
		    {	/* Coerce/convert.scm 243 */
		       node_bglt lnode_1055;
		       {	/* Coerce/convert.scm 245 */
			  obj_t arg1678_1079;
			  {	/* Coerce/convert.scm 245 */
			     obj_t arg1679_1080;
			     obj_t arg1680_1081;
			     arg1679_1080 =
				CNST_TABLE_REF(((long) 1));
			     {	/* Coerce/convert.scm 246 */
				obj_t arg1681_1082;
				obj_t arg1682_1083;
				{	/* Coerce/convert.scm 246 */
				   obj_t arg1683_1084;
				   {	/* Coerce/convert.scm 246 */
				      obj_t arg1685_1086;
				      obj_t arg1686_1087;
				      {		/* Coerce/convert.scm 246 */
					 obj_t arg1687_1088;
					 {	/* Coerce/convert.scm 246 */
					    obj_t list1688_1089;
					    {	/* Coerce/convert.scm 246 */
					       obj_t arg1689_1090;
					       {	/* Coerce/convert.scm 246 */
						  obj_t aux_2230;
						  aux_2230 =
						     CNST_TABLE_REF(((long) 2));
						  arg1689_1090 =
						     MAKE_PAIR(aux_2230, BNIL);
					       }
					       list1688_1089 =
						  MAKE_PAIR(aux_1052, arg1689_1090);
					    }
					    arg1687_1088 =
					       symbol_append_197___r4_symbols_6_4(list1688_1089);
					 }
					 arg1685_1086 =
					    mark_symbol_non_user__17_ast_ident(arg1687_1088);
				      }
				      arg1686_1087 =
					 MAKE_PAIR(BUNSPEC, BNIL);
				      arg1683_1084 =
					 MAKE_PAIR(arg1685_1086, arg1686_1087);
				   }
				   arg1681_1082 =
				      MAKE_PAIR(arg1683_1084, BNIL);
				}
				{	/* Coerce/convert.scm 247 */
				   obj_t arg1690_1091;
				   {	/* Coerce/convert.scm 247 */
				      obj_t arg1692_1093;
				      obj_t arg1693_1094;
				      arg1692_1093 =
					 CNST_TABLE_REF(((long) 1));
				      {		/* Coerce/convert.scm 248 */
					 obj_t arg1694_1095;
					 obj_t arg1695_1096;
					 {	/* Coerce/convert.scm 248 */
					    obj_t arg1696_1097;
					    {	/* Coerce/convert.scm 248 */
					       obj_t arg1698_1099;
					       obj_t arg1699_1100;
					       {	/* Coerce/convert.scm 248 */
						  obj_t arg1700_1101;
						  {	/* Coerce/convert.scm 248 */
						     obj_t list1701_1102;
						     {	/* Coerce/convert.scm 248 */
							obj_t arg1702_1103;
							{	/* Coerce/convert.scm 248 */
							   obj_t aux_2240;
							   aux_2240 =
							      CNST_TABLE_REF(((long) 2));
							   arg1702_1103 =
							      MAKE_PAIR(aux_2240, BNIL);
							}
							list1701_1102 =
							   MAKE_PAIR(aux2_1053, arg1702_1103);
						     }
						     arg1700_1101 =
							symbol_append_197___r4_symbols_6_4(list1701_1102);
						  }
						  arg1698_1099 =
						     mark_symbol_non_user__17_ast_ident(arg1700_1101);
					       }
					       arg1699_1100 =
						  MAKE_PAIR(BUNSPEC, BNIL);
					       arg1696_1097 =
						  MAKE_PAIR(arg1698_1099, arg1699_1100);
					    }
					    arg1694_1095 =
					       MAKE_PAIR(arg1696_1097, BNIL);
					 }
					 {	/* Coerce/convert.scm 249 */
					    obj_t arg1703_1104;
					    {	/* Coerce/convert.scm 249 */
					       obj_t arg1705_1106;
					       obj_t arg1706_1107;
					       arg1705_1106 =
						  CNST_TABLE_REF(((long) 12));
					       {	/* Coerce/convert.scm 249 */
						  obj_t arg1707_1108;
						  obj_t arg1708_1109;
						  {	/* Coerce/convert.scm 249 */
						     obj_t arg1709_1110;
						     arg1709_1110 =
							MAKE_PAIR(aux2_1053, BNIL);
						     arg1707_1108 =
							MAKE_PAIR(check_op_210_67, arg1709_1110);
						  }
						  {	/* Coerce/convert.scm 251 */
						     obj_t arg1711_1111;
						     {	/* Coerce/convert.scm 251 */
							obj_t arg1712_1112;
							arg1712_1112 =
							   runtime_type_error_216_coerce_convert(loc_1054,
							   (((type_bglt) CREF(to_66))->id), aux_1052);
							arg1711_1111 =
							   MAKE_PAIR(arg1712_1112, BNIL);
						     }
						     arg1708_1109 =
							MAKE_PAIR(aux_1052, arg1711_1111);
						  }
						  arg1706_1107 =
						     MAKE_PAIR(arg1707_1108, arg1708_1109);
					       }
					       arg1703_1104 =
						  MAKE_PAIR(arg1705_1106, arg1706_1107);
					    }
					    arg1695_1096 =
					       MAKE_PAIR(arg1703_1104, BNIL);
					 }
					 arg1693_1094 =
					    MAKE_PAIR(arg1694_1095, arg1695_1096);
				      }
				      arg1690_1091 =
					 MAKE_PAIR(arg1692_1093, arg1693_1094);
				   }
				   arg1682_1083 =
				      MAKE_PAIR(arg1690_1091, BNIL);
				}
				arg1680_1081 =
				   MAKE_PAIR(arg1681_1082, arg1682_1083);
			     }
			     arg1678_1079 =
				MAKE_PAIR(arg1679_1080, arg1680_1081);
			  }
			  lnode_1055 =
			     top_level_sexp__node_204_ast_sexp(arg1678_1079, loc_1054);
		       }
		       {	/* Coerce/convert.scm 244 */

			  lvtype_node__58_ast_lvtype(lnode_1055);
			  {	/* Coerce/convert.scm 254 */
			     obj_t var_1056;
			     {	/* ./Ieee/pair-list.scm 5701 */
				obj_t aux_2266;
				{	/* ./Ieee/pair-list.scm 5701 */
				   obj_t aux_2267;
				   {	/* Coerce/convert.scm 254 */
				      let_var_6_bglt obj_1779;
				      obj_1779 =
					 (let_var_6_bglt) (lnode_1055);
				      aux_2267 =
					 (((let_var_6_bglt) CREF(obj_1779))->bindings);
				   }
				   aux_2266 =
				      CAR(aux_2267);
				}
				var_1056 =
				   CAR(aux_2266);
			     }
			     {	/* Coerce/convert.scm 254 */
				obj_t coerce_app_174_1057;
				{	/* Coerce/convert.scm 256 */
				   var_bglt arg1672_1073;
				   {	/* Coerce/convert.scm 256 */
				      var_bglt res1817_1792;
				      {		/* Coerce/convert.scm 256 */
					 variable_bglt variable_1784;
					 variable_1784 =
					    (variable_bglt) (var_1056);
					 {	/* ./Ast/node.scm 1395 */
					    var_bglt new1210_1785;
					    new1210_1785 =
					       ((var_bglt) BREF(GC_MALLOC(sizeof(struct var))));
					    {	/* ./Ast/node.scm 1395 */
					       long arg1781_1786;
					       arg1781_1786 =
						  class_num_218___object(var_ast_node);
					       {	/* ./Ast/node.scm 1395 */
						  obj_t obj_1790;
						  obj_1790 =
						     (obj_t) (new1210_1785);
						  (((obj_t) CREF(obj_1790))->header = MAKE_HEADER(arg1781_1786, 0), BUNSPEC);
					       }
					    }
					    {	/* ./Ast/node.scm 1395 */
					       object_bglt aux_2277;
					       aux_2277 =
						  (object_bglt) (new1210_1785);
					       OBJECT_WIDENING_SET(aux_2277, BFALSE);
					    }
					    ((((var_bglt) CREF(new1210_1785))->loc) = ((obj_t) loc_1054), BUNSPEC);
					    ((((var_bglt) CREF(new1210_1785))->type) = ((type_bglt) from_65), BUNSPEC);
					    ((((var_bglt) CREF(new1210_1785))->variable) = ((variable_bglt) variable_1784), BUNSPEC);
					    res1817_1792 = new1210_1785;
					 }
				      }
				      arg1672_1073 = res1817_1792;
				   }
				   coerce_app_174_1057 =
				      do_convert_128_coerce_convert(coerce_op_79_68,
				      (obj_t) (arg1672_1073), from_65);
				}
				{	/* Coerce/convert.scm 255 */
				   node_bglt condn_1058;
				   condn_1058 =
				      skip_let_var_187_coerce_convert(lnode_1055);
				   {	/* Coerce/convert.scm 261 */

				      {		/* Coerce/convert.scm 263 */
					 local_bglt obj_1793;
					 obj_1793 =
					    (local_bglt) (var_1056);
					 ((((local_bglt) CREF(obj_1793))->type) = ((type_bglt) from_65), BUNSPEC);
				      }
				      {		/* ./Ieee/pair-list.scm 5896 */
					 obj_t aux_2288;
					 {	/* ./Ieee/pair-list.scm 5701 */
					    obj_t aux_2289;
					    {	/* Coerce/convert.scm 265 */
					       let_var_6_bglt obj_1795;
					       obj_1795 =
						  (let_var_6_bglt) (lnode_1055);
					       aux_2289 =
						  (((let_var_6_bglt) CREF(obj_1795))->bindings);
					    }
					    aux_2288 =
					       CAR(aux_2289);
					 }
					 SET_CDR(aux_2288, node_69);
				      }
				      {		/* Coerce/convert.scm 266 */
					 obj_t binding2_1061;
					 {	/* ./Ieee/pair-list.scm 5701 */
					    obj_t aux_2294;
					    {	/* Coerce/convert.scm 266 */
					       let_var_6_bglt obj_1800;
					       {	/* Coerce/convert.scm 266 */
						  node_bglt aux_2295;
						  {	/* Coerce/convert.scm 266 */
						     let_var_6_bglt obj_1799;
						     obj_1799 =
							(let_var_6_bglt) (lnode_1055);
						     aux_2295 =
							(((let_var_6_bglt) CREF(obj_1799))->body);
						  }
						  obj_1800 =
						     (let_var_6_bglt) (aux_2295);
					       }
					       aux_2294 =
						  (((let_var_6_bglt) CREF(obj_1800))->bindings);
					    }
					    binding2_1061 =
					       CAR(aux_2294);
					 }
					 {	/* Coerce/convert.scm 267 */
					    cast_bglt arg1660_1062;
					    {	/* Coerce/convert.scm 267 */
					       obj_t arg1662_1064;
					       var_bglt arg1663_1065;
					       arg1662_1064 = _obj__252_type_cache;
					       {	/* Coerce/convert.scm 270 */
						  var_bglt res1818_1812;
						  {	/* Coerce/convert.scm 270 */
						     variable_bglt variable_1804;
						     variable_1804 =
							(variable_bglt) (var_1056);
						     {	/* ./Ast/node.scm 1395 */
							var_bglt new1210_1805;
							new1210_1805 =
							   ((var_bglt) BREF(GC_MALLOC(sizeof(struct var))));
							{	/* ./Ast/node.scm 1395 */
							   long arg1781_1806;
							   arg1781_1806 =
							      class_num_218___object(var_ast_node);
							   {	/* ./Ast/node.scm 1395 */
							      obj_t obj_1810;
							      obj_1810 =
								 (obj_t) (new1210_1805);
							      (((obj_t) CREF(obj_1810))->header = MAKE_HEADER(arg1781_1806, 0), BUNSPEC);
							   }
							}
							{	/* ./Ast/node.scm 1395 */
							   object_bglt aux_2306;
							   aux_2306 =
							      (object_bglt) (new1210_1805);
							   OBJECT_WIDENING_SET(aux_2306, BFALSE);
							}
							((((var_bglt) CREF(new1210_1805))->loc) = ((obj_t) loc_1054), BUNSPEC);
							((((var_bglt) CREF(new1210_1805))->type) = ((type_bglt) from_65), BUNSPEC);
							((((var_bglt) CREF(new1210_1805))->variable) = ((variable_bglt) variable_1804), BUNSPEC);
							res1818_1812 = new1210_1805;
						     }
						  }
						  arg1663_1065 = res1818_1812;
					       }
					       {	/* Coerce/convert.scm 267 */
						  cast_bglt res1819_1823;
						  {	/* Coerce/convert.scm 267 */
						     type_bglt type_1814;
						     node_bglt arg_1815;
						     type_1814 =
							(type_bglt) (arg1662_1064);
						     arg_1815 =
							(node_bglt) (arg1663_1065);
						     {	/* ./Ast/node.scm 1444 */
							cast_bglt new1295_1816;
							new1295_1816 =
							   ((cast_bglt) BREF(GC_MALLOC(sizeof(struct cast))));
							{	/* ./Ast/node.scm 1444 */
							   long arg1765_1817;
							   arg1765_1817 =
							      class_num_218___object(cast_ast_node);
							   {	/* ./Ast/node.scm 1444 */
							      obj_t obj_1821;
							      obj_1821 =
								 (obj_t) (new1295_1816);
							      (((obj_t) CREF(obj_1821))->header = MAKE_HEADER(arg1765_1817, 0), BUNSPEC);
							   }
							}
							{	/* ./Ast/node.scm 1444 */
							   object_bglt aux_2318;
							   aux_2318 =
							      (object_bglt) (new1295_1816);
							   OBJECT_WIDENING_SET(aux_2318, BFALSE);
							}
							((((cast_bglt) CREF(new1295_1816))->loc) = ((obj_t) loc_1054), BUNSPEC);
							((((cast_bglt) CREF(new1295_1816))->type) = ((type_bglt) type_1814), BUNSPEC);
							((((cast_bglt) CREF(new1295_1816))->arg) = ((node_bglt) arg_1815), BUNSPEC);
							res1819_1823 = new1295_1816;
						     }
						  }
						  arg1660_1062 = res1819_1823;
					       }
					    }
					    {	/* ./Ieee/pair-list.scm 5896 */
					       obj_t aux_2324;
					       aux_2324 =
						  (obj_t) (arg1660_1062);
					       SET_CDR(binding2_1061, aux_2324);
					    }
					 }
				      }
				      {		/* Coerce/convert.scm 274 */
					 conditional_bglt obj_1826;
					 node_bglt val1315_1827;
					 obj_1826 =
					    (conditional_bglt) (condn_1058);
					 val1315_1827 =
					    (node_bglt) (coerce_app_174_1057);
					 ((((conditional_bglt) CREF(obj_1826))->true) = ((node_bglt) val1315_1827), BUNSPEC);
				      }
				      _unsafe_type__146_engine_param = BTRUE;
				      {		/* Coerce/convert.scm 277 */
					 node_bglt arg1670_1071;
					 {	/* Coerce/convert.scm 277 */
					    node_bglt aux_2330;
					    {	/* Coerce/convert.scm 277 */
					       conditional_bglt obj_1828;
					       obj_1828 =
						  (conditional_bglt) (condn_1058);
					       aux_2330 =
						  (((conditional_bglt) CREF(obj_1828))->false);
					    }
					    arg1670_1071 =
					       coerce__182_coerce_coerce(aux_2330, from_65);
					 }
					 {	/* Coerce/convert.scm 276 */
					    conditional_bglt obj_1829;
					    obj_1829 =
					       (conditional_bglt) (condn_1058);
					    ((((conditional_bglt) CREF(obj_1829))->false) = ((node_bglt) arg1670_1071), BUNSPEC);
					 }
				      }
				      _unsafe_type__146_engine_param = BFALSE;
				      return
					 (obj_t) (lnode_1055);
				   }
				}
			     }
			  }
		       }
		    }
		 }
	      }
	   }
      }
   }
}



/* do-convert */
obj_t 
do_convert_128_coerce_convert(obj_t coerce_op_79_70, obj_t node_71, type_bglt from_72)
{
   AN_OBJECT;
   {	/* Coerce/convert.scm 284 */
      if (
	 NULLP(coerce_op_79_70))
	{	/* Coerce/convert.scm 287 */
	   return node_71;
	}
      else
	{	/* Coerce/convert.scm 289 */
	   node_bglt nnode_1117;
	   {	/* Coerce/convert.scm 289 */
	      obj_t arg1734_1136;
	      obj_t arg1735_1137;
	      {		/* Coerce/convert.scm 289 */
		 obj_t arg1736_1138;
		 arg1736_1138 =
		    MAKE_PAIR(BUNSPEC, BNIL);
		 arg1734_1136 =
		    MAKE_PAIR(coerce_op_79_70, arg1736_1138);
	      }
	      {		/* Coerce/convert.scm 290 */
		 node_bglt obj_1836;
		 obj_1836 =
		    (node_bglt) (node_71);
		 arg1735_1137 =
		    (((node_bglt) CREF(obj_1836))->loc);
	      }
	      nnode_1117 =
		 top_level_sexp__node_204_ast_sexp(arg1734_1136, arg1735_1137);
	   }
	   {	/* Coerce/convert.scm 289 */

	      {		/* Coerce/convert.scm 299 */
		 node_bglt obj_1837;
		 obj_1837 =
		    (node_bglt) (node_71);
		 ((((node_bglt) CREF(obj_1837))->type) = ((type_bglt) from_72), BUNSPEC);
	      }
	      {		/* Coerce/convert.scm 302 */
		 bool_t test1717_1118;
		 test1717_1118 =
		    is_a__118___object(
		    (obj_t) (nnode_1117), app_ast_node);
		 if (test1717_1118)
		   {	/* Coerce/convert.scm 302 */
		      {		/* Coerce/convert.scm 303 */
			 obj_t arg1718_1119;
			 {	/* Coerce/convert.scm 303 */
			    obj_t list1719_1120;
			    list1719_1120 =
			       MAKE_PAIR(node_71, BNIL);
			    arg1718_1119 = list1719_1120;
			 }
			 {	/* Coerce/convert.scm 303 */
			    app_bglt obj_1841;
			    obj_1841 =
			       (app_bglt) (nnode_1117);
			    ((((app_bglt) CREF(obj_1841))->args) = ((obj_t) arg1718_1119), BUNSPEC);
			 }
		      }
		      return
			 (obj_t) (nnode_1117);
		   }
		 else
		   {	/* Coerce/convert.scm 305 */
		      bool_t test1720_1121;
		      test1720_1121 =
			 is_a__118___object(
			 (obj_t) (nnode_1117), let_var_6_ast_node);
		      if (test1720_1121)
			{	/* Coerce/convert.scm 305 */
			   {	/* Coerce/convert.scm 306 */
			      obj_t bdgs_1122;
			      {		/* Coerce/convert.scm 306 */
				 let_var_6_bglt obj_1844;
				 obj_1844 =
				    (let_var_6_bglt) (nnode_1117);
				 bdgs_1122 =
				    (((let_var_6_bglt) CREF(obj_1844))->bindings);
			      }
			      {		/* Coerce/convert.scm 307 */
				 bool_t test_2358;
				 if (
				    NULLP(bdgs_1122))
				   {	/* Coerce/convert.scm 307 */
				      test_2358 = ((bool_t) 1)
					 ;
				   }
				 else
				   {	/* Coerce/convert.scm 307 */
				      bool_t test_2361;
				      {		/* ./Ieee/pair-list.scm 5912 */
					 obj_t aux_2362;
					 aux_2362 =
					    CDR(bdgs_1122);
					 test_2361 =
					    NULLP(aux_2362);
				      }
				      if (test_2361)
					{	/* Coerce/convert.scm 307 */
					   test_2358 = ((bool_t) 0)
					      ;
					}
				      else
					{	/* Coerce/convert.scm 307 */
					   test_2358 = ((bool_t) 1)
					      ;
					}
				   }
				 if (test_2358)
				   {	/* Coerce/convert.scm 308 */
				      obj_t arg1724_1126;
				      arg1724_1126 =
					 shape_tools_shape(coerce_op_79_70);
				      return
					 internal_error_43_tools_error(string1823_coerce_convert, string1824_coerce_convert, arg1724_1126);
				   }
				 else
				   {	/* Coerce/convert.scm 307 */
				      {		/* Coerce/convert.scm 312 */
					 local_bglt obj_1850;
					 {	/* Coerce/convert.scm 312 */
					    obj_t aux_2367;
					    {	/* ./Ieee/pair-list.scm 5701 */
					       obj_t aux_2368;
					       aux_2368 =
						  CAR(bdgs_1122);
					       aux_2367 =
						  CAR(aux_2368);
					    }
					    obj_1850 =
					       (local_bglt) (aux_2367);
					 }
					 ((((local_bglt) CREF(obj_1850))->type) = ((type_bglt) from_72), BUNSPEC);
				      }
				      {		/* ./Ieee/pair-list.scm 5896 */
					 obj_t aux_2373;
					 aux_2373 =
					    CAR(bdgs_1122);
					 SET_CDR(aux_2373, node_71);
				      }
				      return
					 (obj_t) (nnode_1117);
				   }
			      }
			   }
			}
		      else
			{	/* Coerce/convert.scm 305 */
			   {	/* Coerce/convert.scm 316 */
			      obj_t arg1733_1135;
			      arg1733_1135 =
				 shape_tools_shape(coerce_op_79_70);
			      return
				 internal_error_43_tools_error(string1823_coerce_convert, string1824_coerce_convert, arg1733_1135);
			   }
			}
		   }
	      }
	   }
	}
   }
}



/* method-init */
obj_t 
method_init_76_coerce_convert()
{
   AN_OBJECT;
   {	/* Coerce/convert.scm 15 */
      return BUNSPEC;
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_coerce_convert()
{
   AN_OBJECT;
   {	/* Coerce/convert.scm 15 */
      module_initialization_70_tools_trace(((long) 0), "COERCE_CONVERT");
      module_initialization_70_engine_param(((long) 0), "COERCE_CONVERT");
      module_initialization_70_tools_shape(((long) 0), "COERCE_CONVERT");
      module_initialization_70_tools_location(((long) 0), "COERCE_CONVERT");
      module_initialization_70_tools_error(((long) 0), "COERCE_CONVERT");
      module_initialization_70_tools_misc(((long) 0), "COERCE_CONVERT");
      module_initialization_70_type_type(((long) 0), "COERCE_CONVERT");
      module_initialization_70_type_cache(((long) 0), "COERCE_CONVERT");
      module_initialization_70_type_coercion(((long) 0), "COERCE_CONVERT");
      module_initialization_70_type_env(((long) 0), "COERCE_CONVERT");
      module_initialization_70_ast_sexp(((long) 0), "COERCE_CONVERT");
      module_initialization_70_ast_var(((long) 0), "COERCE_CONVERT");
      module_initialization_70_ast_node(((long) 0), "COERCE_CONVERT");
      module_initialization_70_ast_ident(((long) 0), "COERCE_CONVERT");
      module_initialization_70_ast_lvtype(((long) 0), "COERCE_CONVERT");
      module_initialization_70_object_class(((long) 0), "COERCE_CONVERT");
      module_initialization_70_coerce_typeof(((long) 0), "COERCE_CONVERT");
      return
	 module_initialization_70_coerce_coerce(((long) 0), "COERCE_CONVERT");
   }
}
