/*===========================================================================*/
/*   (Coerce/funcall.scm)                                                    */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;


static obj_t method_init_76_coerce_funcall();
extern obj_t funcall_ast_node;
static obj_t coerce_funcall_args__156_coerce_funcall(funcall_bglt, obj_t);
extern obj_t symbol_append_197___r4_symbols_6_4(obj_t);
extern obj_t string_append(obj_t, obj_t);
extern obj_t mark_symbol_non_user__17_ast_ident(obj_t);
extern obj_t let_var_6_ast_node;
extern obj_t var_ast_node;
extern obj_t location_full_fname_231_tools_location(obj_t);
extern obj_t _bdb_debug__1_engine_param;
extern obj_t add_method__1___object(obj_t, obj_t, obj_t);
extern obj_t gensym___r4_symbols_6_4;
extern obj_t _obj__252_type_cache;
extern obj_t current_function_76_tools_error();
extern obj_t module_initialization_70_coerce_funcall(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_tools_location(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_ast_sexp(long, char *);
extern obj_t module_initialization_70_ast_local(long, char *);
extern obj_t module_initialization_70_ast_ident(long, char *);
extern obj_t module_initialization_70_coerce_coerce(long, char *);
extern obj_t module_initialization_70_coerce_convert(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_symbols_6_4(long, char *);
extern obj_t _unsafe_arity__240_engine_param;
extern long list_length(obj_t);
extern local_bglt make_local_svar_140_ast_local(obj_t, type_bglt);
extern long class_num_218___object(obj_t);
static obj_t imported_modules_init_94_coerce_funcall();
extern node_bglt coerce__182_coerce_coerce(node_bglt, type_bglt);
static obj_t library_modules_init_112_coerce_funcall();
static obj_t toplevel_init_63_coerce_funcall();
extern obj_t _unsafe_type__146_engine_param;
extern obj_t open_input_string(obj_t);
extern node_bglt top_level_sexp__node_204_ast_sexp(obj_t, obj_t);
extern node_bglt convert__122_coerce_convert(node_bglt, type_bglt, type_bglt);
extern obj_t memq___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern obj_t _compiler_debug__134_engine_param;
extern obj_t shape_tools_shape(obj_t);
static obj_t coerce__funcall1441_140_coerce_funcall(obj_t, obj_t, obj_t);
extern obj_t _procedure__226_type_cache;
extern obj_t read___reader(obj_t);
static node_bglt make_error_node_135_coerce_funcall(local_bglt, obj_t, obj_t, obj_t);
static obj_t require_initialization_114_coerce_funcall = BUNSPEC;
static obj_t cnst_init_137_coerce_funcall();
static obj_t __cnst[17];

DEFINE_STATIC_PROCEDURE(proc1657_coerce_funcall, coerce__funcall1441_140_coerce_funcall1663, coerce__funcall1441_140_coerce_funcall, 0L, 2);
DEFINE_STRING(string1658_coerce_funcall, string1658_coerce_funcall1664, "CORRECT-ARITY? IF LET ::LONG LEN FUN (LIGHT ELIGHT) DUMMY __EOA__ _ QUOTE FAILURE __ERROR ERROR/LOCATION @ BEGIN LOCATION ", 122);
DEFINE_STRING(string1656_coerce_funcall, string1656_coerce_funcall1665, ":Wrong number of arguments", 26);
extern obj_t coerce__env_127_coerce_coerce;



/* module-initialization */
obj_t 
module_initialization_70_coerce_funcall(long checksum_1394, char *from_1395)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_coerce_funcall))
	{
	   require_initialization_114_coerce_funcall =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_coerce_funcall();
	   cnst_init_137_coerce_funcall();
	   imported_modules_init_94_coerce_funcall();
	   method_init_76_coerce_funcall();
	   toplevel_init_63_coerce_funcall();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_coerce_funcall()
{
   AN_OBJECT;
   {	/* Coerce/funcall.scm 14 */
      module_initialization_70___r4_symbols_6_4(((long) 0), "COERCE_FUNCALL");
      module_initialization_70___object(((long) 0), "COERCE_FUNCALL");
      module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "COERCE_FUNCALL");
      module_initialization_70___reader(((long) 0), "COERCE_FUNCALL");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_coerce_funcall()
{
   AN_OBJECT;
   {	/* Coerce/funcall.scm 14 */
      {		/* Coerce/funcall.scm 14 */
	 obj_t cnst_port_138_1387;
	 cnst_port_138_1387 =
	    open_input_string(string1658_coerce_funcall);
	 {
	    long i_1388;
	    i_1388 = ((long) 16);
	  loop_1389:
	    {	/* Coerce/funcall.scm 14 */
	       bool_t test1659_1390;
	       test1659_1390 =
		  (i_1388 == ((long) -1));
	       if (test1659_1390)
		 {	/* Coerce/funcall.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Coerce/funcall.scm 14 */
		    {	/* Coerce/funcall.scm 14 */
		       obj_t arg1660_1391;
		       {	/* Coerce/funcall.scm 14 */
			  obj_t list1661_1392;
			  list1661_1392 =
			     MAKE_PAIR(cnst_port_138_1387, BNIL);
			  arg1660_1391 =
			     read___reader(list1661_1392);
		       }
		       CNST_TABLE_SET(i_1388, arg1660_1391);
		    }
		    {	/* Coerce/funcall.scm 14 */
		       int aux_1393;
		       {	/* Coerce/funcall.scm 14 */
			  long aux_1414;
			  aux_1414 =
			     (i_1388 - ((long) 1));
			  aux_1393 =
			     (int) (aux_1414);
		       }
		       {
			  long i_1417;
			  i_1417 =
			     (long) (aux_1393);
			  i_1388 = i_1417;
			  goto loop_1389;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_coerce_funcall()
{
   AN_OBJECT;
   {	/* Coerce/funcall.scm 14 */
      return BUNSPEC;
   }
}



/* make-error-node */
node_bglt 
make_error_node_135_coerce_funcall(local_bglt fun_17, obj_t error_msg_180_18, obj_t loc_19, obj_t to_20)
{
   AN_OBJECT;
   {	/* Coerce/funcall.scm 77 */
      {		/* Coerce/funcall.scm 78 */
	 obj_t ut_728;
	 ut_728 = _unsafe_type__146_engine_param;
	 _unsafe_type__146_engine_param = BTRUE;
	 {	/* Coerce/funcall.scm 80 */
	    node_bglt node_729;
	    {	/* Coerce/funcall.scm 82 */
	       node_bglt arg1451_730;
	       {	/* Coerce/funcall.scm 82 */
		  obj_t arg1452_731;
		  {	/* Coerce/funcall.scm 82 */
		     bool_t test1453_732;
		     {	/* Coerce/funcall.scm 82 */
			bool_t test1504_778;
			{	/* Coerce/funcall.scm 82 */
			   bool_t test1505_779;
			   {	/* Coerce/funcall.scm 82 */
			      long n1_1206;
			      n1_1206 =
				 (long) CINT(_compiler_debug__134_engine_param);
			      test1505_779 =
				 (n1_1206 > ((long) 0));
			   }
			   if (test1505_779)
			     {	/* Coerce/funcall.scm 82 */
				test1504_778 = ((bool_t) 1);
			     }
			   else
			     {	/* Coerce/funcall.scm 83 */
				long n1_1208;
				n1_1208 =
				   (long) CINT(_bdb_debug__1_engine_param);
				test1504_778 =
				   (n1_1208 > ((long) 0));
			     }
			}
			if (test1504_778)
			  {	/* Coerce/funcall.scm 82 */
			     if (
				STRUCTP(loc_19))
			       {	/* ./Ieee/equiv.scm 5508 */
				  obj_t aux_1429;
				  obj_t aux_1427;
				  aux_1429 =
				     CNST_TABLE_REF(((long) 0));
				  aux_1427 =
				     STRUCT_KEY(loc_19);
				  test1453_732 =
				     (aux_1427 == aux_1429);
			       }
			     else
			       {	/* ./Tools/location.sch 407 */
				  test1453_732 = ((bool_t) 0);
			       }
			  }
			else
			  {	/* Coerce/funcall.scm 82 */
			     test1453_732 = ((bool_t) 0);
			  }
		     }
		     if (test1453_732)
		       {	/* Coerce/funcall.scm 85 */
			  obj_t arg1454_733;
			  obj_t arg1455_734;
			  arg1454_733 =
			     CNST_TABLE_REF(((long) 1));
			  {	/* Coerce/funcall.scm 86 */
			     obj_t arg1456_735;
			     obj_t arg1457_736;
			     {	/* Coerce/funcall.scm 86 */
				obj_t arg1458_737;
				obj_t arg1459_738;
				{	/* Coerce/funcall.scm 86 */
				   obj_t arg1461_739;
				   obj_t arg1462_740;
				   arg1461_739 =
				      CNST_TABLE_REF(((long) 2));
				   {	/* Coerce/funcall.scm 86 */
				      obj_t arg1463_741;
				      obj_t arg1464_742;
				      arg1463_741 =
					 CNST_TABLE_REF(((long) 3));
				      {		/* ./Ieee/pair-list.scm 5689 */
					 obj_t aux_1436;
					 aux_1436 =
					    CNST_TABLE_REF(((long) 4));
					 arg1464_742 =
					    MAKE_PAIR(aux_1436, BNIL);
				      }
				      arg1462_740 =
					 MAKE_PAIR(arg1463_741, arg1464_742);
				   }
				   arg1458_737 =
				      MAKE_PAIR(arg1461_739, arg1462_740);
				}
				{	/* Coerce/funcall.scm 88 */
				   obj_t arg1466_743;
				   obj_t arg1467_744;
				   {	/* Coerce/funcall.scm 88 */
				      obj_t arg1469_745;
				      {		/* Coerce/funcall.scm 88 */
					 obj_t arg1471_747;
					 arg1471_747 =
					    current_function_76_tools_error();
					 arg1469_745 =
					    SYMBOL_TO_STRING(arg1471_747);
				      }
				      arg1466_743 =
					 string_append(arg1469_745, string1656_coerce_funcall);
				   }
				   {	/* Coerce/funcall.scm 92 */
				      obj_t arg1472_748;
				      {		/* Coerce/funcall.scm 92 */
					 obj_t arg1473_749;
					 {	/* Coerce/funcall.scm 92 */
					    obj_t arg1474_750;
					    obj_t arg1475_751;
					    arg1474_750 =
					       location_full_fname_231_tools_location(loc_19);
					    {	/* ./Ieee/pair-list.scm 5689 */
					       obj_t aux_1445;
					       aux_1445 =
						  STRUCT_REF(loc_19, ((long) 1));
					       arg1475_751 =
						  MAKE_PAIR(aux_1445, BNIL);
					    }
					    arg1473_749 =
					       MAKE_PAIR(arg1474_750, arg1475_751);
					 }
					 {	/* ./Ieee/pair-list.scm 5689 */
					    obj_t aux_1449;
					    aux_1449 =
					       (obj_t) (fun_17);
					    arg1472_748 =
					       MAKE_PAIR(aux_1449, arg1473_749);
					 }
				      }
				      arg1467_744 =
					 MAKE_PAIR(error_msg_180_18, arg1472_748);
				   }
				   arg1459_738 =
				      MAKE_PAIR(arg1466_743, arg1467_744);
				}
				arg1456_735 =
				   MAKE_PAIR(arg1458_737, arg1459_738);
			     }
			     {	/* Coerce/funcall.scm 94 */
				obj_t arg1478_754;
				{	/* Coerce/funcall.scm 94 */
				   obj_t arg1480_756;
				   obj_t arg1481_757;
				   arg1480_756 =
				      CNST_TABLE_REF(((long) 5));
				   {	/* Coerce/funcall.scm 94 */
				      obj_t arg1482_758;
				      obj_t arg1483_759;
				      {		/* Coerce/funcall.scm 94 */
					 obj_t arg1484_760;
					 obj_t arg1485_761;
					 arg1484_760 =
					    CNST_TABLE_REF(((long) 6));
					 {	/* ./Ieee/pair-list.scm 5689 */
					    obj_t aux_1457;
					    aux_1457 =
					       CNST_TABLE_REF(((long) 7));
					    arg1485_761 =
					       MAKE_PAIR(aux_1457, BNIL);
					 }
					 arg1482_758 =
					    MAKE_PAIR(arg1484_760, arg1485_761);
				      }
				      {		/* Coerce/funcall.scm 94 */
					 obj_t arg1486_762;
					 obj_t arg1488_763;
					 {	/* Coerce/funcall.scm 94 */
					    obj_t arg1489_764;
					    obj_t arg1490_765;
					    arg1489_764 =
					       CNST_TABLE_REF(((long) 6));
					    {	/* ./Ieee/pair-list.scm 5689 */
					       obj_t aux_1462;
					       aux_1462 =
						  CNST_TABLE_REF(((long) 7));
					       arg1490_765 =
						  MAKE_PAIR(aux_1462, BNIL);
					    }
					    arg1486_762 =
					       MAKE_PAIR(arg1489_764, arg1490_765);
					 }
					 {	/* Coerce/funcall.scm 94 */
					    obj_t arg1491_766;
					    {	/* Coerce/funcall.scm 94 */
					       obj_t arg1494_768;
					       obj_t arg1495_769;
					       arg1494_768 =
						  CNST_TABLE_REF(((long) 6));
					       {	/* ./Ieee/pair-list.scm 5689 */
						  obj_t aux_1467;
						  aux_1467 =
						     CNST_TABLE_REF(((long) 7));
						  arg1495_769 =
						     MAKE_PAIR(aux_1467, BNIL);
					       }
					       arg1491_766 =
						  MAKE_PAIR(arg1494_768, arg1495_769);
					    }
					    arg1488_763 =
					       MAKE_PAIR(arg1491_766, BNIL);
					 }
					 arg1483_759 =
					    MAKE_PAIR(arg1486_762, arg1488_763);
				      }
				      arg1481_757 =
					 MAKE_PAIR(arg1482_758, arg1483_759);
				   }
				   arg1478_754 =
				      MAKE_PAIR(arg1480_756, arg1481_757);
				}
				arg1457_736 =
				   MAKE_PAIR(arg1478_754, BNIL);
			     }
			     arg1455_734 =
				MAKE_PAIR(arg1456_735, arg1457_736);
			  }
			  arg1452_731 =
			     MAKE_PAIR(arg1454_733, arg1455_734);
		       }
		     else
		       {	/* Coerce/funcall.scm 95 */
			  obj_t arg1496_770;
			  obj_t arg1497_771;
			  arg1496_770 =
			     CNST_TABLE_REF(((long) 5));
			  {	/* Coerce/funcall.scm 96 */
			     obj_t arg1498_772;
			     obj_t arg1499_773;
			     {	/* Coerce/funcall.scm 96 */
				obj_t arg1500_774;
				{	/* Coerce/funcall.scm 96 */
				   obj_t arg1502_776;
				   arg1502_776 =
				      current_function_76_tools_error();
				   arg1500_774 =
				      SYMBOL_TO_STRING(arg1502_776);
				}
				arg1498_772 =
				   string_append(arg1500_774, string1656_coerce_funcall);
			     }
			     {	/* Coerce/funcall.scm 95 */
				obj_t arg1503_777;
				{	/* ./Ieee/pair-list.scm 5689 */
				   obj_t aux_1482;
				   aux_1482 =
				      (obj_t) (fun_17);
				   arg1503_777 =
				      MAKE_PAIR(aux_1482, BNIL);
				}
				arg1499_773 =
				   MAKE_PAIR(error_msg_180_18, arg1503_777);
			     }
			     arg1497_771 =
				MAKE_PAIR(arg1498_772, arg1499_773);
			  }
			  arg1452_731 =
			     MAKE_PAIR(arg1496_770, arg1497_771);
		       }
		  }
		  arg1451_730 =
		     top_level_sexp__node_204_ast_sexp(arg1452_731, loc_19);
	       }
	       node_729 =
		  coerce__182_coerce_coerce(arg1451_730,
		  (type_bglt) (to_20));
	    }
	    _unsafe_type__146_engine_param = ut_728;
	    return node_729;
	 }
      }
   }
}



/* coerce-funcall-args! */
obj_t 
coerce_funcall_args__156_coerce_funcall(funcall_bglt node_21, obj_t to_22)
{
   AN_OBJECT;
   {	/* Coerce/funcall.scm 108 */
      {		/* Coerce/funcall.scm 109 */
	 bool_t test_1491;
	 {	/* ./Ieee/pair-list.scm 5912 */
	    obj_t aux_1492;
	    aux_1492 =
	       (((funcall_bglt) CREF(node_21))->args);
	    test_1491 =
	       NULLP(aux_1492);
	 }
	 if (test_1491)
	   {	/* Coerce/funcall.scm 111 */
	      obj_t arg1508_781;
	      {		/* Coerce/funcall.scm 111 */
		 node_bglt arg1509_782;
		 {	/* Coerce/funcall.scm 110 */
		    obj_t aux_1495;
		    {	/* Coerce/funcall.scm 112 */
		       node_bglt obj_1277;
		       obj_1277 =
			  (node_bglt) (node_21);
		       aux_1495 =
			  (((node_bglt) CREF(obj_1277))->loc);
		    }
		    arg1509_782 =
		       top_level_sexp__node_204_ast_sexp(
		       CNST_TABLE_REF(((long) 8)), aux_1495);
		 }
		 {	/* Coerce/funcall.scm 110 */
		    obj_t list1510_783;
		    {	/* Coerce/funcall.scm 110 */
		       obj_t aux_1500;
		       aux_1500 =
			  (obj_t) (arg1509_782);
		       list1510_783 =
			  MAKE_PAIR(aux_1500, BNIL);
		    }
		    arg1508_781 = list1510_783;
		 }
	      }
	      return
		 ((((funcall_bglt) CREF(node_21))->args) = ((obj_t) arg1508_781), BUNSPEC);
	   }
	 else
	   {
	      obj_t actuals_786;
	      obj_t prev_787;
	      actuals_786 =
		 (((funcall_bglt) CREF(node_21))->args);
	      prev_787 =
		 CNST_TABLE_REF(((long) 9));
	    loop_788:
	      if (
		 NULLP(actuals_786))
		{	/* Coerce/funcall.scm 117 */
		   obj_t arg1516_792;
		   {	/* Coerce/funcall.scm 117 */
		      node_bglt arg1517_793;
		      {		/* Coerce/funcall.scm 116 */
			 obj_t aux_1506;
			 {	/* Coerce/funcall.scm 118 */
			    node_bglt obj_1283;
			    obj_1283 =
			       (node_bglt) (node_21);
			    aux_1506 =
			       (((node_bglt) CREF(obj_1283))->loc);
			 }
			 arg1517_793 =
			    top_level_sexp__node_204_ast_sexp(
			    CNST_TABLE_REF(((long) 8)), aux_1506);
		      }
		      {		/* Coerce/funcall.scm 116 */
			 obj_t list1518_794;
			 {	/* Coerce/funcall.scm 116 */
			    obj_t aux_1511;
			    aux_1511 =
			       (obj_t) (arg1517_793);
			    list1518_794 =
			       MAKE_PAIR(aux_1511, BNIL);
			 }
			 arg1516_792 = list1518_794;
		      }
		   }
		   return
		      SET_CDR(prev_787, arg1516_792);
		}
	      else
		{	/* Coerce/funcall.scm 115 */
		   {	/* Coerce/funcall.scm 120 */
		      node_bglt arg1521_797;
		      {		/* Coerce/funcall.scm 120 */
			 node_bglt aux_1515;
			 {	/* Coerce/funcall.scm 120 */
			    obj_t aux_1516;
			    aux_1516 =
			       CAR(actuals_786);
			    aux_1515 =
			       (node_bglt) (aux_1516);
			 }
			 arg1521_797 =
			    coerce__182_coerce_coerce(aux_1515,
			    (type_bglt) (_obj__252_type_cache));
		      }
		      {		/* ./Ieee/pair-list.scm 5890 */
			 obj_t aux_1521;
			 aux_1521 =
			    (obj_t) (arg1521_797);
			 SET_CAR(actuals_786, aux_1521);
		      }
		   }
		   {
		      obj_t prev_1526;
		      obj_t actuals_1524;
		      actuals_1524 =
			 CDR(actuals_786);
		      prev_1526 = actuals_786;
		      prev_787 = prev_1526;
		      actuals_786 = actuals_1524;
		      goto loop_788;
		   }
		}
	   }
      }
   }
}



/* method-init */
obj_t 
method_init_76_coerce_funcall()
{
   AN_OBJECT;
   {	/* Coerce/funcall.scm 14 */
      {		/* Coerce/funcall.scm 14 */
	 obj_t coerce__funcall1441_140_1379;
	 coerce__funcall1441_140_1379 = proc1657_coerce_funcall;
	 return
	    add_method__1___object(coerce__env_127_coerce_coerce, funcall_ast_node, coerce__funcall1441_140_1379);
      }
   }
}



/* coerce!-funcall1441 */
obj_t 
coerce__funcall1441_140_coerce_funcall(obj_t env_1380, obj_t node_1381, obj_t to_1382)
{
   AN_OBJECT;
   {	/* Coerce/funcall.scm 34 */
      {
	 funcall_bglt node_1127;
	 obj_t to_1128;
	 node_1127 =
	    (funcall_bglt) (node_1381);
	 to_1128 = to_1382;
	 {	/* Coerce/funcall.scm 36 */
	    obj_t error_msg_180_1131;
	    obj_t strength_1132;
	    {	/* Coerce/funcall.scm 36 */
	       obj_t arg1646_1181;
	       obj_t arg1647_1182;
	       arg1646_1181 =
		  CNST_TABLE_REF(((long) 6));
	       arg1647_1182 =
		  shape_tools_shape(
		  (obj_t) (node_1127));
	       {	/* Coerce/funcall.scm 36 */
		  obj_t list1648_1183;
		  {	/* Coerce/funcall.scm 36 */
		     obj_t arg1649_1184;
		     arg1649_1184 =
			MAKE_PAIR(arg1647_1182, BNIL);
		     list1648_1183 =
			MAKE_PAIR(arg1646_1181, arg1649_1184);
		  }
		  error_msg_180_1131 = list1648_1183;
	       }
	    }
	    strength_1132 =
	       (((funcall_bglt) CREF(node_1127))->strength);
	    coerce_funcall_args__156_coerce_funcall(node_1127, to_1128);
	    {	/* Coerce/funcall.scm 40 */
	       bool_t test_1537;
	       {	/* Coerce/funcall.scm 40 */
		  obj_t aux_1538;
		  aux_1538 =
		     memq___r4_pairs_and_lists_6_3(strength_1132,
		     CNST_TABLE_REF(((long) 10)));
		  test_1537 =
		     CBOOL(aux_1538);
	       }
	       if (test_1537)
		 {	/* Coerce/funcall.scm 41 */
		    node_bglt aux_1542;
		    aux_1542 =
		       convert__122_coerce_convert(
		       (node_bglt) (node_1127),
		       (type_bglt) (_obj__252_type_cache),
		       (type_bglt) (to_1128));
		    return
		       (obj_t) (aux_1542);
		 }
	       else
		 {	/* Coerce/funcall.scm 43 */
		    node_bglt c_fun_136_1134;
		    c_fun_136_1134 =
		       coerce__182_coerce_coerce(
		       (((funcall_bglt) CREF(node_1127))->fun),
		       (type_bglt) (_procedure__226_type_cache));
		    if (
		       CBOOL(_unsafe_arity__240_engine_param))
		      {		/* Coerce/funcall.scm 45 */
			 ((((funcall_bglt) CREF(node_1127))->fun) = ((node_bglt) c_fun_136_1134), BUNSPEC);
			 {	/* Coerce/funcall.scm 48 */
			    node_bglt aux_1554;
			    aux_1554 =
			       convert__122_coerce_convert(
			       (node_bglt) (node_1127),
			       (type_bglt) (_obj__252_type_cache),
			       (type_bglt) (to_1128));
			    return
			       (obj_t) (aux_1554);
			 }
		      }
		    else
		      {		/* Coerce/funcall.scm 49 */
			 local_bglt fun_1135;
			 fun_1135 =
			    make_local_svar_140_ast_local(
			    CNST_TABLE_REF(((long) 11)),
			    (type_bglt) (_procedure__226_type_cache));
			 {	/* Coerce/funcall.scm 49 */
			    obj_t loc_1136;
			    {	/* Coerce/funcall.scm 50 */
			       node_bglt obj_1314;
			       obj_1314 =
				  (node_bglt) (node_1127);
			       loc_1136 =
				  (((node_bglt) CREF(obj_1314))->loc);
			    }
			    {	/* Coerce/funcall.scm 50 */
			       long len_1137;
			       {	/* ./Ieee/fixnum.scm 7199 */
				  long aux_1565;
				  aux_1565 =
				     list_length(
				     (((funcall_bglt) CREF(node_1127))->args));
				  len_1137 =
				     (aux_1565 - ((long) 2));
			       }
			       {	/* Coerce/funcall.scm 51 */
				  obj_t a_len_134_1138;
				  {	/* Coerce/funcall.scm 52 */
				     obj_t arg1640_1176;
				     arg1640_1176 =
					PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4,
					CNST_TABLE_REF(((long) 12)), BEOA);
				     a_len_134_1138 =
					mark_symbol_non_user__17_ast_ident(arg1640_1176);
				  }
				  {	/* Coerce/funcall.scm 52 */
				     obj_t a_tlen_49_1139;
				     {	/* Coerce/funcall.scm 54 */
					obj_t arg1637_1173;
					{	/* Coerce/funcall.scm 54 */
					   obj_t list1638_1174;
					   {	/* Coerce/funcall.scm 54 */
					      obj_t arg1639_1175;
					      {		/* Coerce/funcall.scm 54 */
						 obj_t aux_1573;
						 aux_1573 =
						    CNST_TABLE_REF(((long) 13));
						 arg1639_1175 =
						    MAKE_PAIR(aux_1573, BNIL);
					      }
					      list1638_1174 =
						 MAKE_PAIR(a_len_134_1138, arg1639_1175);
					   }
					   arg1637_1173 =
					      symbol_append_197___r4_symbols_6_4(list1638_1174);
					}
					a_tlen_49_1139 =
					   mark_symbol_non_user__17_ast_ident(arg1637_1173);
				     }
				     {	/* Coerce/funcall.scm 53 */
					let_var_6_bglt lnode_1140;
					{	/* Coerce/funcall.scm 55 */
					   obj_t arg1610_1146;
					   obj_t arg1612_1148;
					   node_bglt arg1613_1149;
					   arg1610_1146 = _obj__252_type_cache;
					   {	/* Coerce/funcall.scm 58 */
					      obj_t arg1614_1150;
					      {		/* ./Ieee/pair-list.scm 5689 */
						 obj_t aux_1581;
						 obj_t aux_1579;
						 aux_1581 =
						    (obj_t) (c_fun_136_1134);
						 aux_1579 =
						    (obj_t) (fun_1135);
						 arg1614_1150 =
						    MAKE_PAIR(aux_1579, aux_1581);
					      }
					      {		/* Coerce/funcall.scm 58 */
						 obj_t list1615_1151;
						 list1615_1151 =
						    MAKE_PAIR(arg1614_1150, BNIL);
						 arg1612_1148 = list1615_1151;
					      }
					   }
					   {	/* Coerce/funcall.scm 60 */
					      obj_t arg1616_1152;
					      {		/* Coerce/funcall.scm 60 */
						 obj_t arg1617_1153;
						 obj_t arg1618_1154;
						 arg1617_1153 =
						    CNST_TABLE_REF(((long) 14));
						 {	/* Coerce/funcall.scm 60 */
						    obj_t arg1619_1155;
						    obj_t arg1620_1156;
						    {	/* Coerce/funcall.scm 60 */
						       obj_t arg1621_1157;
						       {	/* Coerce/funcall.scm 60 */
							  obj_t arg1623_1159;
							  {	/* ./Ieee/pair-list.scm 5689 */
							     obj_t aux_1586;
							     aux_1586 =
								BINT(len_1137);
							     arg1623_1159 =
								MAKE_PAIR(aux_1586, BNIL);
							  }
							  arg1621_1157 =
							     MAKE_PAIR(a_tlen_49_1139, arg1623_1159);
						       }
						       arg1619_1155 =
							  MAKE_PAIR(arg1621_1157, BNIL);
						    }
						    {	/* Coerce/funcall.scm 61 */
						       obj_t arg1624_1160;
						       {	/* Coerce/funcall.scm 61 */
							  obj_t arg1626_1162;
							  obj_t arg1627_1163;
							  arg1626_1162 =
							     CNST_TABLE_REF(((long) 15));
							  {	/* Coerce/funcall.scm 61 */
							     obj_t arg1628_1164;
							     obj_t arg1629_1165;
							     {	/* Coerce/funcall.scm 61 */
								obj_t arg1630_1166;
								obj_t arg1631_1167;
								arg1630_1166 =
								   CNST_TABLE_REF(((long) 16));
								{	/* Coerce/funcall.scm 61 */
								   obj_t arg1632_1168;
								   arg1632_1168 =
								      MAKE_PAIR(a_len_134_1138, BNIL);
								   {	/* ./Ieee/pair-list.scm 5689 */
								      obj_t aux_1594;
								      aux_1594 =
									 (obj_t) (fun_1135);
								      arg1631_1167 =
									 MAKE_PAIR(aux_1594, arg1632_1168);
								   }
								}
								arg1628_1164 =
								   MAKE_PAIR(arg1630_1166, arg1631_1167);
							     }
							     {	/* Coerce/funcall.scm 62 */
								node_bglt arg1633_1169;
								obj_t arg1634_1170;
								arg1633_1169 =
								   convert__122_coerce_convert(
								   (node_bglt) (node_1127),
								   (type_bglt) (_obj__252_type_cache),
								   (type_bglt) (to_1128));
								{	/* Coerce/funcall.scm 63 */
								   node_bglt arg1635_1171;
								   arg1635_1171 =
								      make_error_node_135_coerce_funcall(fun_1135, error_msg_180_1131, loc_1136, to_1128);
								   {	/* ./Ieee/pair-list.scm 5689 */
								      obj_t aux_1603;
								      aux_1603 =
									 (obj_t) (arg1635_1171);
								      arg1634_1170 =
									 MAKE_PAIR(aux_1603, BNIL);
								   }
								}
								{	/* ./Ieee/pair-list.scm 5689 */
								   obj_t aux_1606;
								   aux_1606 =
								      (obj_t) (arg1633_1169);
								   arg1629_1165 =
								      MAKE_PAIR(aux_1606, arg1634_1170);
								}
							     }
							     arg1627_1163 =
								MAKE_PAIR(arg1628_1164, arg1629_1165);
							  }
							  arg1624_1160 =
							     MAKE_PAIR(arg1626_1162, arg1627_1163);
						       }
						       arg1620_1156 =
							  MAKE_PAIR(arg1624_1160, BNIL);
						    }
						    arg1618_1154 =
						       MAKE_PAIR(arg1619_1155, arg1620_1156);
						 }
						 arg1616_1152 =
						    MAKE_PAIR(arg1617_1153, arg1618_1154);
					      }
					      arg1613_1149 =
						 top_level_sexp__node_204_ast_sexp(arg1616_1152, loc_1136);
					   }
					   {	/* Coerce/funcall.scm 55 */
					      let_var_6_bglt res1652_1365;
					      {		/* Coerce/funcall.scm 55 */
						 type_bglt type_1348;
						 obj_t key_1350;
						 type_1348 =
						    (type_bglt) (arg1610_1146);
						 key_1350 =
						    BINT(((long) -1));
						 {	/* ./Ast/node.scm 1100 */
						    let_var_6_bglt new1373_1354;
						    new1373_1354 =
						       ((let_var_6_bglt) BREF(GC_MALLOC(sizeof(struct let_var_6))));
						    {	/* ./Ast/node.scm 1100 */
						       long arg1539_1355;
						       arg1539_1355 =
							  class_num_218___object(let_var_6_ast_node);
						       {	/* ./Ast/node.scm 1100 */
							  obj_t obj_1363;
							  obj_1363 =
							     (obj_t) (new1373_1354);
							  (((obj_t) CREF(obj_1363))->header = MAKE_HEADER(arg1539_1355, 0), BUNSPEC);
						       }
						    }
						    {	/* ./Ast/node.scm 1100 */
						       object_bglt aux_1621;
						       aux_1621 =
							  (object_bglt) (new1373_1354);
						       OBJECT_WIDENING_SET(aux_1621, BFALSE);
						    }
						    ((((let_var_6_bglt) CREF(new1373_1354))->loc) = ((obj_t) loc_1136), BUNSPEC);
						    ((((let_var_6_bglt) CREF(new1373_1354))->type) = ((type_bglt) type_1348), BUNSPEC);
						    ((((let_var_6_bglt) CREF(new1373_1354))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
						    ((((let_var_6_bglt) CREF(new1373_1354))->key) = ((obj_t) key_1350), BUNSPEC);
						    ((((let_var_6_bglt) CREF(new1373_1354))->bindings) = ((obj_t) arg1612_1148), BUNSPEC);
						    ((((let_var_6_bglt) CREF(new1373_1354))->body) = ((node_bglt) arg1613_1149), BUNSPEC);
						    ((((let_var_6_bglt) CREF(new1373_1354))->removable__42) = ((bool_t) ((bool_t) 1)), BUNSPEC);
						    res1652_1365 = new1373_1354;
						 }
					      }
					      lnode_1140 = res1652_1365;
					   }
					}
					{	/* Coerce/funcall.scm 55 */

					   {	/* Coerce/funcall.scm 68 */
					      var_bglt arg1605_1141;
					      {		/* Coerce/funcall.scm 68 */
						 obj_t arg1607_1143;
						 arg1607_1143 = _obj__252_type_cache;
						 {	/* Coerce/funcall.scm 68 */
						    var_bglt res1653_1376;
						    {	/* Coerce/funcall.scm 68 */
						       type_bglt type_1367;
						       variable_bglt variable_1368;
						       type_1367 =
							  (type_bglt) (arg1607_1143);
						       variable_1368 =
							  (variable_bglt) (fun_1135);
						       {	/* ./Ast/node.scm 1007 */
							  var_bglt new1210_1369;
							  new1210_1369 =
							     ((var_bglt) BREF(GC_MALLOC(sizeof(struct var))));
							  {	/* ./Ast/node.scm 1007 */
							     long arg1571_1370;
							     arg1571_1370 =
								class_num_218___object(var_ast_node);
							     {	/* ./Ast/node.scm 1007 */
								obj_t obj_1374;
								obj_1374 =
								   (obj_t) (new1210_1369);
								(((obj_t) CREF(obj_1374))->header = MAKE_HEADER(arg1571_1370, 0), BUNSPEC);
							     }
							  }
							  {	/* ./Ast/node.scm 1007 */
							     object_bglt aux_1637;
							     aux_1637 =
								(object_bglt) (new1210_1369);
							     OBJECT_WIDENING_SET(aux_1637, BFALSE);
							  }
							  ((((var_bglt) CREF(new1210_1369))->loc) = ((obj_t) loc_1136), BUNSPEC);
							  ((((var_bglt) CREF(new1210_1369))->type) = ((type_bglt) type_1367), BUNSPEC);
							  ((((var_bglt) CREF(new1210_1369))->variable) = ((variable_bglt) variable_1368), BUNSPEC);
							  res1653_1376 = new1210_1369;
						       }
						    }
						    arg1605_1141 = res1653_1376;
						 }
					      }
					      {		/* Coerce/funcall.scm 68 */
						 node_bglt val1269_1378;
						 val1269_1378 =
						    (node_bglt) (arg1605_1141);
						 ((((funcall_bglt) CREF(node_1127))->fun) = ((node_bglt) val1269_1378), BUNSPEC);
					      }
					   }
					   return
					      (obj_t) (lnode_1140);
					}
				     }
				  }
			       }
			    }
			 }
		      }
		 }
	    }
	 }
      }
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_coerce_funcall()
{
   AN_OBJECT;
   {	/* Coerce/funcall.scm 14 */
      module_initialization_70_tools_trace(((long) 0), "COERCE_FUNCALL");
      module_initialization_70_engine_param(((long) 0), "COERCE_FUNCALL");
      module_initialization_70_tools_shape(((long) 0), "COERCE_FUNCALL");
      module_initialization_70_tools_error(((long) 0), "COERCE_FUNCALL");
      module_initialization_70_tools_location(((long) 0), "COERCE_FUNCALL");
      module_initialization_70_type_type(((long) 0), "COERCE_FUNCALL");
      module_initialization_70_type_cache(((long) 0), "COERCE_FUNCALL");
      module_initialization_70_ast_var(((long) 0), "COERCE_FUNCALL");
      module_initialization_70_ast_node(((long) 0), "COERCE_FUNCALL");
      module_initialization_70_ast_sexp(((long) 0), "COERCE_FUNCALL");
      module_initialization_70_ast_local(((long) 0), "COERCE_FUNCALL");
      module_initialization_70_ast_ident(((long) 0), "COERCE_FUNCALL");
      module_initialization_70_coerce_coerce(((long) 0), "COERCE_FUNCALL");
      return
	 module_initialization_70_coerce_convert(((long) 0), "COERCE_FUNCALL");
   }
}
