/*===========================================================================*/
/*   (Coerce/typeof.scm)                                                     */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;


static obj_t method_init_76_coerce_typeof();
extern obj_t make_box_202_ast_node;
extern obj_t funcall_ast_node;
extern long add_inlined_method__244___object(obj_t, obj_t, long);
extern obj_t fail_ast_node;
extern obj_t box_ref_242_ast_node;
extern obj_t sequence_ast_node;
extern obj_t let_var_6_ast_node;
extern obj_t var_ast_node;
static type_bglt typeof_default1450_244_coerce_typeof(node_bglt);
extern obj_t closure_ast_node;
extern obj_t _obj__252_type_cache;
extern obj_t pragma_ast_node;
extern obj_t set_ex_it_116_ast_node;
extern obj_t last_pair_93___r4_pairs_and_lists_6_3(obj_t);
extern obj_t _magic__144_type_cache;
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t _unspec__87_type_cache;
extern obj_t module_initialization_70_coerce_typeof(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_type_typeof(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t let_fun_218_ast_node;
static obj_t imported_modules_init_94_coerce_typeof();
extern type_bglt typeof_kwote_49_type_typeof(obj_t);
extern obj_t app_ly_162_ast_node;
extern obj_t cfun_ast_var;
extern obj_t add_generic__110___object(obj_t, obj_t);
extern obj_t app_ast_node;
static obj_t library_modules_init_112_coerce_typeof();
extern obj_t atom_ast_node;
extern obj_t cast_ast_node;
static obj_t toplevel_init_63_coerce_typeof();
extern obj_t jump_ex_it_184_ast_node;
extern obj_t open_input_string(obj_t);
extern obj_t kwote_ast_node;
extern obj_t sfun_ast_var;
extern obj_t setq_ast_node;
extern obj_t box_set__221_ast_node;
extern type_bglt typeof_coerce_typeof(node_bglt);
static obj_t _typeof_default1450_113_coerce_typeof(obj_t, obj_t);
extern obj_t shape_tools_shape(obj_t);
static obj_t _typeof_coerce_typeof(obj_t, obj_t);
extern type_bglt typeof_atom_134_type_typeof(obj_t);
extern obj_t _procedure__226_type_cache;
extern obj_t _classes__134___object;
extern obj_t select_ast_node;
extern obj_t read___reader(obj_t);
static obj_t require_initialization_114_coerce_typeof = BUNSPEC;
extern obj_t conditional_ast_node;
static obj_t cnst_init_137_coerce_typeof();
static obj_t __cnst[1];

DEFINE_STATIC_PROCEDURE(typeof_default1450_env_212_coerce_typeof, _typeof_default1450_113_coerce_typeof1631, _typeof_default1450_113_coerce_typeof, 0L, 1);
DEFINE_EXPORT_GENERIC(typeof_env_7_coerce_typeof, _typeof_coerce_typeof1632, _typeof_coerce_typeof, 0L, 1);
DEFINE_STRING(string1626_coerce_typeof, string1626_coerce_typeof1633, "TYPEOF-DEFAULT1450 ", 19);
DEFINE_STRING(string1625_coerce_typeof, string1625_coerce_typeof1634, "No method for this object", 25);
DEFINE_STRING(string1624_coerce_typeof, string1624_coerce_typeof1635, "Je n'ai pas encore fait ce truc", 31);
DEFINE_STRING(string1623_coerce_typeof, string1623_coerce_typeof1636, "typeof", 6);



/* module-initialization */
obj_t 
module_initialization_70_coerce_typeof(long checksum_1212, char *from_1213)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_coerce_typeof))
	{
	   require_initialization_114_coerce_typeof =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_coerce_typeof();
	   cnst_init_137_coerce_typeof();
	   imported_modules_init_94_coerce_typeof();
	   method_init_76_coerce_typeof();
	   toplevel_init_63_coerce_typeof();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_coerce_typeof()
{
   AN_OBJECT;
   {	/* Coerce/typeof.scm 14 */
      module_initialization_70___object(((long) 0), "COERCE_TYPEOF");
      module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "COERCE_TYPEOF");
      module_initialization_70___reader(((long) 0), "COERCE_TYPEOF");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_coerce_typeof()
{
   AN_OBJECT;
   {	/* Coerce/typeof.scm 14 */
      {		/* Coerce/typeof.scm 14 */
	 obj_t cnst_port_138_1205;
	 cnst_port_138_1205 =
	    open_input_string(string1626_coerce_typeof);
	 {
	    long i_1206;
	    i_1206 = ((long) 0);
	  loop_1207:
	    {	/* Coerce/typeof.scm 14 */
	       bool_t test1627_1208;
	       test1627_1208 =
		  (i_1206 == ((long) -1));
	       if (test1627_1208)
		 {	/* Coerce/typeof.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Coerce/typeof.scm 14 */
		    {	/* Coerce/typeof.scm 14 */
		       obj_t arg1628_1209;
		       {	/* Coerce/typeof.scm 14 */
			  obj_t list1629_1210;
			  list1629_1210 =
			     MAKE_PAIR(cnst_port_138_1205, BNIL);
			  arg1628_1209 =
			     read___reader(list1629_1210);
		       }
		       CNST_TABLE_SET(i_1206, arg1628_1209);
		    }
		    {	/* Coerce/typeof.scm 14 */
		       int aux_1211;
		       {	/* Coerce/typeof.scm 14 */
			  long aux_1231;
			  aux_1231 =
			     (i_1206 - ((long) 1));
			  aux_1211 =
			     (int) (aux_1231);
		       }
		       {
			  long i_1234;
			  i_1234 =
			     (long) (aux_1211);
			  i_1206 = i_1234;
			  goto loop_1207;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_coerce_typeof()
{
   AN_OBJECT;
   {	/* Coerce/typeof.scm 14 */
      return BUNSPEC;
   }
}



/* method-init */
obj_t 
method_init_76_coerce_typeof()
{
   AN_OBJECT;
   {	/* Coerce/typeof.scm 14 */
      add_generic__110___object(typeof_env_7_coerce_typeof, typeof_default1450_env_212_coerce_typeof);
      add_inlined_method__244___object(typeof_env_7_coerce_typeof, atom_ast_node, ((long) 0));
      add_inlined_method__244___object(typeof_env_7_coerce_typeof, kwote_ast_node, ((long) 1));
      add_inlined_method__244___object(typeof_env_7_coerce_typeof, var_ast_node, ((long) 2));
      add_inlined_method__244___object(typeof_env_7_coerce_typeof, closure_ast_node, ((long) 3));
      add_inlined_method__244___object(typeof_env_7_coerce_typeof, sequence_ast_node, ((long) 4));
      add_inlined_method__244___object(typeof_env_7_coerce_typeof, pragma_ast_node, ((long) 5));
      add_inlined_method__244___object(typeof_env_7_coerce_typeof, cast_ast_node, ((long) 6));
      add_inlined_method__244___object(typeof_env_7_coerce_typeof, setq_ast_node, ((long) 7));
      add_inlined_method__244___object(typeof_env_7_coerce_typeof, conditional_ast_node, ((long) 8));
      add_inlined_method__244___object(typeof_env_7_coerce_typeof, fail_ast_node, ((long) 9));
      add_inlined_method__244___object(typeof_env_7_coerce_typeof, select_ast_node, ((long) 10));
      add_inlined_method__244___object(typeof_env_7_coerce_typeof, let_fun_218_ast_node, ((long) 11));
      add_inlined_method__244___object(typeof_env_7_coerce_typeof, let_var_6_ast_node, ((long) 12));
      add_inlined_method__244___object(typeof_env_7_coerce_typeof, set_ex_it_116_ast_node, ((long) 13));
      add_inlined_method__244___object(typeof_env_7_coerce_typeof, jump_ex_it_184_ast_node, ((long) 14));
      add_inlined_method__244___object(typeof_env_7_coerce_typeof, make_box_202_ast_node, ((long) 15));
      add_inlined_method__244___object(typeof_env_7_coerce_typeof, box_ref_242_ast_node, ((long) 16));
      add_inlined_method__244___object(typeof_env_7_coerce_typeof, box_set__221_ast_node, ((long) 17));
      add_inlined_method__244___object(typeof_env_7_coerce_typeof, app_ly_162_ast_node, ((long) 18));
      add_inlined_method__244___object(typeof_env_7_coerce_typeof, funcall_ast_node, ((long) 19));
      {		/* Coerce/typeof.scm 14 */
	 long aux_1257;
	 aux_1257 =
	    add_inlined_method__244___object(typeof_env_7_coerce_typeof, app_ast_node, ((long) 20));
	 return
	    BINT(aux_1257);
      }
   }
}



/* typeof */
type_bglt 
typeof_coerce_typeof(node_bglt node_1)
{
   AN_OBJECT;
   {	/* Coerce/typeof.scm 26 */
      {
	 obj_t method1574_1049;
	 obj_t class1579_1050;
	 {	/* Coerce/typeof.scm 26 */
	    obj_t arg1582_1047;
	    obj_t arg1583_1048;
	    {	/* Coerce/typeof.scm 26 */
	       object_bglt obj_1135;
	       obj_1135 =
		  (object_bglt) (node_1);
	       {	/* ./Llib/object.scm 2926 */
		  obj_t pre_method_105_1136;
		  pre_method_105_1136 =
		     PROCEDURE_REF(typeof_env_7_coerce_typeof, ((long) 2));
		  if (
		     INTEGERP(pre_method_105_1136))
		    {	/* ./Llib/object.scm 2927 */
		       PROCEDURE_SET(typeof_env_7_coerce_typeof, ((long) 2), BUNSPEC);
		       arg1582_1047 = pre_method_105_1136;
		    }
		  else
		    {	/* ./Llib/object.scm 2914 */
		       long obj_class_num_177_1141;
		       obj_class_num_177_1141 =
			  TYPE(obj_1135);
		       {	/* ./Llib/object.scm 2915 */
			  obj_t arg1176_1142;
			  arg1176_1142 =
			     PROCEDURE_REF(typeof_env_7_coerce_typeof, ((long) 1));
			  {	/* ./Llib/object.scm 2738 */
			     long arg1177_1146;
			     {	/* ./Llib/object.scm 2738 */
				long arg1178_1147;
				arg1178_1147 =
				   OBJECT_TYPE;
				arg1177_1146 =
				   (obj_class_num_177_1141 - arg1178_1147);
			     }
			     arg1582_1047 =
				VECTOR_REF(arg1176_1142, arg1177_1146);
			  }
		       }
		    }
	       }
	    }
	    {	/* Coerce/typeof.scm 26 */
	       object_bglt object_1152;
	       object_1152 =
		  (object_bglt) (node_1);
	       {	/* ./Llib/object.scm 2695 */
		  long arg1179_1153;
		  {	/* ./Llib/object.scm 2695 */
		     long arg1180_1154;
		     long arg1181_1155;
		     arg1180_1154 =
			TYPE(object_1152);
		     arg1181_1155 =
			OBJECT_TYPE;
		     arg1179_1153 =
			(arg1180_1154 - arg1181_1155);
		  }
		  {	/* ./Llib/object.scm 2695 */
		     obj_t vector_1159;
		     vector_1159 = _classes__134___object;
		     arg1583_1048 =
			VECTOR_REF(vector_1159, arg1179_1153);
		  }
	       }
	    }
	    {	/* Coerce/typeof.scm 26 */
	       obj_t aux_1275;
	       method1574_1049 = arg1582_1047;
	       class1579_1050 = arg1583_1048;
	       {

		  if (
		     INTEGERP(method1574_1049))
		    {	/* Coerce/typeof.scm 26 */
		       switch (
			  (long) CINT(method1574_1049))
			 {
			 case ((long) 0):

			    {	/* Coerce/typeof.scm 32 */
			       atom_bglt node_1056;
			       node_1056 =
				  (atom_bglt) (node_1);
			       {	/* Coerce/typeof.scm 33 */
				  type_bglt aux_1279;
				  aux_1279 =
				     typeof_atom_134_type_typeof(
				     (((atom_bglt) CREF(node_1056))->value));
				  aux_1275 =
				     (obj_t) (aux_1279);
			       }
			    }
			    break;
			 case ((long) 1):

			    {	/* Coerce/typeof.scm 39 */
			       kwote_bglt node_1059;
			       node_1059 =
				  (kwote_bglt) (node_1);
			       {	/* Coerce/typeof.scm 40 */
				  type_bglt aux_1284;
				  aux_1284 =
				     typeof_kwote_49_type_typeof(
				     (((kwote_bglt) CREF(node_1059))->value));
				  aux_1275 =
				     (obj_t) (aux_1284);
			       }
			    }
			    break;
			 case ((long) 2):

			    {	/* Coerce/typeof.scm 46 */
			       var_bglt node_1062;
			       node_1062 =
				  (var_bglt) (node_1);
			       {	/* Coerce/typeof.scm 47 */
				  value_bglt value_1064;
				  {	/* Coerce/typeof.scm 47 */
				     variable_bglt arg1594_1071;
				     arg1594_1071 =
					(((var_bglt) CREF(node_1062))->variable);
				     value_1064 =
					(((variable_bglt) CREF(arg1594_1071))->value);
				  }
				  {	/* Coerce/typeof.scm 49 */
				     bool_t test1588_1065;
				     test1588_1065 =
					is_a__118___object(
					(obj_t) (value_1064), sfun_ast_var);
				     if (test1588_1065)
				       {	/* Coerce/typeof.scm 49 */
					  aux_1275 = _procedure__226_type_cache;
				       }
				     else
				       {	/* Coerce/typeof.scm 51 */
					  bool_t test1589_1066;
					  test1589_1066 =
					     is_a__118___object(
					     (obj_t) (value_1064), cfun_ast_var);
					  if (test1589_1066)
					    {	/* Coerce/typeof.scm 51 */
					       {	/* Coerce/typeof.scm 52 */
						  obj_t arg1592_1069;
						  arg1592_1069 =
						     shape_tools_shape(
						     (obj_t) (node_1062));
						  FAILURE(string1623_coerce_typeof, string1624_coerce_typeof, arg1592_1069);
					       }
					    }
					  else
					    {	/* Coerce/typeof.scm 51 */
					       {	/* Coerce/typeof.scm 54 */
						  variable_bglt arg1593_1070;
						  arg1593_1070 =
						     (((var_bglt) CREF(node_1062))->variable);
						  {	/* ./Ast/var.scm 685 */
						     type_bglt aux_1301;
						     aux_1301 =
							(((variable_bglt) CREF(arg1593_1070))->type);
						     aux_1275 =
							(obj_t) (aux_1301);
						  }
					       }
					    }
				       }
				  }
			       }
			    }
			    break;
			 case ((long) 3):

			    aux_1275 = _procedure__226_type_cache;
			    break;
			 case ((long) 4):

			    {	/* Coerce/typeof.scm 66 */
			       sequence_bglt node_1073;
			       node_1073 =
				  (sequence_bglt) (node_1);
			       {	/* Coerce/typeof.scm 67 */
				  type_bglt aux_1305;
				  {	/* Coerce/typeof.scm 67 */
				     node_bglt aux_1306;
				     {	/* Coerce/typeof.scm 67 */
					obj_t aux_1307;
					{	/* ./Ieee/pair-list.scm 5701 */
					   obj_t aux_1308;
					   aux_1308 =
					      last_pair_93___r4_pairs_and_lists_6_3(
					      (((sequence_bglt) CREF(node_1073))->nodes));
					   aux_1307 =
					      CAR(aux_1308);
					}
					aux_1306 =
					   (node_bglt) (aux_1307);
				     }
				     aux_1305 =
					typeof_coerce_typeof(aux_1306);
				  }
				  aux_1275 =
				     (obj_t) (aux_1305);
			       }
			    }
			    break;
			 case ((long) 5):

			    {	/* Coerce/typeof.scm 73 */
			       pragma_bglt node_1078;
			       node_1078 =
				  (pragma_bglt) (node_1);
			       {	/* ./Ast/node.scm 880 */
				  type_bglt aux_1316;
				  aux_1316 =
				     (((pragma_bglt) CREF(node_1078))->type);
				  aux_1275 =
				     (obj_t) (aux_1316);
			       }
			    }
			    break;
			 case ((long) 6):

			    {	/* Coerce/typeof.scm 80 */
			       cast_bglt node_1080;
			       node_1080 =
				  (cast_bglt) (node_1);
			       {	/* ./Ast/node.scm 885 */
				  type_bglt aux_1320;
				  aux_1320 =
				     (((cast_bglt) CREF(node_1080))->type);
				  aux_1275 =
				     (obj_t) (aux_1320);
			       }
			    }
			    break;
			 case ((long) 7):

			    aux_1275 = _unspec__87_type_cache;
			    break;
			 case ((long) 8):

			    {	/* Coerce/typeof.scm 93 */
			       conditional_bglt node_1083;
			       node_1083 =
				  (conditional_bglt) (node_1);
			       {	/* Coerce/typeof.scm 94 */
				  type_bglt ttrue_1085;
				  type_bglt tfalse_1086;
				  ttrue_1085 =
				     typeof_coerce_typeof(
				     (((conditional_bglt) CREF(node_1083))->true));
				  tfalse_1086 =
				     typeof_coerce_typeof(
				     (((conditional_bglt) CREF(node_1083))->false));
				  {	/* Coerce/typeof.scm 96 */
				     bool_t test_1328;
				     {	/* ./Ieee/equiv.scm 5508 */
					obj_t aux_1331;
					obj_t aux_1329;
					aux_1331 =
					   (obj_t) (tfalse_1086);
					aux_1329 =
					   (obj_t) (ttrue_1085);
					test_1328 =
					   (aux_1329 == aux_1331);
				     }
				     if (test_1328)
				       {	/* Coerce/typeof.scm 96 */
					  aux_1275 =
					     (obj_t) (ttrue_1085)
					     ;
				       }
				     else
				       {	/* Coerce/typeof.scm 96 */
					  aux_1275 = _obj__252_type_cache
					     ;
				       }
				  }
			       }
			    }
			    break;
			 case ((long) 9):

			    aux_1275 = _magic__144_type_cache;
			    break;
			 case ((long) 10):

			    {	/* Coerce/typeof.scm 111 */
			       select_bglt node_1092;
			       node_1092 =
				  (select_bglt) (node_1);
			       {
				  obj_t clauses_1094;
				  type_bglt type_1095;
				  {	/* Coerce/typeof.scm 112 */
				     obj_t arg1601_1097;
				     type_bglt arg1602_1098;
				     {	/* ./Ieee/pair-list.scm 5707 */
					obj_t aux_1336;
					aux_1336 =
					   (((select_bglt) CREF(node_1092))->clauses);
					arg1601_1097 =
					   CDR(aux_1336);
				     }
				     {	/* Coerce/typeof.scm 113 */
					node_bglt aux_1339;
					{	/* Coerce/typeof.scm 113 */
					   obj_t aux_1340;
					   {	/* ./Ieee/pair-list.scm 5707 */
					      obj_t aux_1341;
					      {		/* ./Ieee/pair-list.scm 5701 */
						 obj_t aux_1342;
						 aux_1342 =
						    (((select_bglt) CREF(node_1092))->clauses);
						 aux_1341 =
						    CAR(aux_1342);
					      }
					      aux_1340 =
						 CDR(aux_1341);
					   }
					   aux_1339 =
					      (node_bglt) (aux_1340);
					}
					arg1602_1098 =
					   typeof_coerce_typeof(aux_1339);
				     }
				     clauses_1094 = arg1601_1097;
				     type_1095 = arg1602_1098;
				   loop_1096:
				     if (
					NULLP(clauses_1094))
				       {	/* Coerce/typeof.scm 114 */
					  aux_1275 =
					     (obj_t) (type_1095)
					     ;
				       }
				     else
				       {	/* Coerce/typeof.scm 116 */
					  bool_t test1608_1104;
					  {	/* Coerce/typeof.scm 116 */
					     type_bglt arg1610_1106;
					     {	/* Coerce/typeof.scm 116 */
						node_bglt aux_1351;
						{	/* Coerce/typeof.scm 116 */
						   obj_t aux_1352;
						   {	/* ./Ieee/pair-list.scm 5707 */
						      obj_t aux_1353;
						      aux_1353 =
							 CAR(clauses_1094);
						      aux_1352 =
							 CDR(aux_1353);
						   }
						   aux_1351 =
						      (node_bglt) (aux_1352);
						}
						arg1610_1106 =
						   typeof_coerce_typeof(aux_1351);
					     }
					     {	/* ./Ieee/equiv.scm 5508 */
						obj_t aux_1360;
						obj_t aux_1358;
						aux_1360 =
						   (obj_t) (type_1095);
						aux_1358 =
						   (obj_t) (arg1610_1106);
						test1608_1104 =
						   (aux_1358 == aux_1360);
					     }
					  }
					  if (test1608_1104)
					    {
					       obj_t clauses_1364;
					       clauses_1364 =
						  CDR(clauses_1094);
					       clauses_1094 = clauses_1364;
					       goto loop_1096;
					    }
					  else
					    {	/* Coerce/typeof.scm 116 */
					       aux_1275 = _obj__252_type_cache
						  ;
					    }
				       }
				  }
			       }
			    }
			    break;
			 case ((long) 11):

			    {	/* Coerce/typeof.scm 124 */
			       let_fun_218_bglt node_1109;
			       node_1109 =
				  (let_fun_218_bglt) (node_1);
			       {	/* Coerce/typeof.scm 125 */
				  type_bglt aux_1367;
				  aux_1367 =
				     typeof_coerce_typeof(
				     (((let_fun_218_bglt) CREF(node_1109))->body));
				  aux_1275 =
				     (obj_t) (aux_1367);
			       }
			    }
			    break;
			 case ((long) 12):

			    {	/* Coerce/typeof.scm 131 */
			       let_var_6_bglt node_1112;
			       node_1112 =
				  (let_var_6_bglt) (node_1);
			       {	/* Coerce/typeof.scm 132 */
				  type_bglt aux_1372;
				  aux_1372 =
				     typeof_coerce_typeof(
				     (((let_var_6_bglt) CREF(node_1112))->body));
				  aux_1275 =
				     (obj_t) (aux_1372);
			       }
			    }
			    break;
			 case ((long) 13):

			    aux_1275 = _obj__252_type_cache;
			    break;
			 case ((long) 14):

			    aux_1275 = _obj__252_type_cache;
			    break;
			 case ((long) 15):

			    aux_1275 = _obj__252_type_cache;
			    break;
			 case ((long) 16):

			    aux_1275 = _obj__252_type_cache;
			    break;
			 case ((long) 17):

			    aux_1275 = _unspec__87_type_cache;
			    break;
			 case ((long) 18):

			    aux_1275 = _obj__252_type_cache;
			    break;
			 case ((long) 19):

			    aux_1275 = _obj__252_type_cache;
			    break;
			 case ((long) 20):

			    {	/* Coerce/typeof.scm 180 */
			       app_bglt node_1122;
			       node_1122 =
				  (app_bglt) (node_1);
			       {	/* Coerce/typeof.scm 181 */
				  variable_bglt arg1615_1124;
				  {	/* Coerce/typeof.scm 181 */
				     var_bglt arg1616_1125;
				     arg1616_1125 =
					(((app_bglt) CREF(node_1122))->fun);
				     arg1615_1124 =
					(((var_bglt) CREF(arg1616_1125))->variable);
				  }
				  {	/* ./Ast/var.scm 685 */
				     type_bglt aux_1379;
				     aux_1379 =
					(((variable_bglt) CREF(arg1615_1124))->type);
				     aux_1275 =
					(obj_t) (aux_1379);
				  }
			       }
			    }
			    break;
			 default:
			  case_else1580_1053:
			    if (
			       PROCEDUREP(method1574_1049))
			      {		/* Coerce/typeof.scm 26 */
				 aux_1275 =
				    PROCEDURE_ENTRY(method1574_1049) (method1574_1049,
				    (obj_t) (node_1), BEOA)
				    ;
			      }
			    else
			      {		/* Coerce/typeof.scm 26 */
				 obj_t fun1573_1045;
				 fun1573_1045 =
				    PROCEDURE_REF(typeof_env_7_coerce_typeof, ((long) 0));
				 aux_1275 =
				    PROCEDURE_ENTRY(fun1573_1045) (fun1573_1045,
				    (obj_t) (node_1), BEOA);
			      }
			 }
		    }
		  else
		    {	/* Coerce/typeof.scm 26 */
		       goto case_else1580_1053;
		    }
	       }
	       return
		  (type_bglt) (aux_1275);
	    }
	 }
      }
   }
}



/* _typeof */
obj_t 
_typeof_coerce_typeof(obj_t env_1201, obj_t node_1202)
{
   AN_OBJECT;
   {	/* Coerce/typeof.scm 26 */
      {		/* Coerce/typeof.scm 26 */
	 type_bglt aux_1394;
	 aux_1394 =
	    typeof_coerce_typeof(
	    (node_bglt) (node_1202));
	 return
	    (obj_t) (aux_1394);
      }
   }
}



/* typeof-default1450 */
type_bglt 
typeof_default1450_244_coerce_typeof(node_bglt node_2)
{
   AN_OBJECT;
   {	/* Coerce/typeof.scm 14 */
      FAILURE(
	 CNST_TABLE_REF(((long) 0)), string1625_coerce_typeof,
	 (obj_t) (node_2));
   }
}



/* _typeof-default1450 */
obj_t 
_typeof_default1450_113_coerce_typeof(obj_t env_1203, obj_t node_1204)
{
   AN_OBJECT;
   {	/* Coerce/typeof.scm 14 */
      {		/* Coerce/typeof.scm 14 */
	 type_bglt aux_1401;
	 aux_1401 =
	    typeof_default1450_244_coerce_typeof(
	    (node_bglt) (node_1204));
	 return
	    (obj_t) (aux_1401);
      }
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_coerce_typeof()
{
   AN_OBJECT;
   {	/* Coerce/typeof.scm 14 */
      module_initialization_70_type_type(((long) 0), "COERCE_TYPEOF");
      module_initialization_70_type_cache(((long) 0), "COERCE_TYPEOF");
      module_initialization_70_type_typeof(((long) 0), "COERCE_TYPEOF");
      module_initialization_70_tools_shape(((long) 0), "COERCE_TYPEOF");
      module_initialization_70_ast_var(((long) 0), "COERCE_TYPEOF");
      return
	 module_initialization_70_ast_node(((long) 0), "COERCE_TYPEOF");
   }
}
