/*===========================================================================*/
/*   (Coerce/walk.scm)                                                       */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;


static obj_t method_init_76_coerce_walk();
extern obj_t current_error_port;
extern obj_t _nb_error_on_pass__70_tools_error;
extern obj_t leave_function_170_tools_error();
extern obj_t verbose_tools_speek(obj_t, obj_t);
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t module_initialization_70_coerce_walk(long, char *);
extern obj_t module_initialization_70_tools_speek(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_engine_pass(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_env(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_ast_remove(long, char *);
extern obj_t module_initialization_70_coerce_pproto(long, char *);
extern obj_t module_initialization_70_coerce_coerce(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_numbers_6_5(long, char *);
extern obj_t module_initialization_70___r4_output_6_10_3(long, char *);
static obj_t _anonymous_1464__227_coerce_walk(obj_t, obj_t);
extern obj_t coerce_walk__125_coerce_walk(obj_t);
extern obj_t display_2_122___r4_output_6_10_3(obj_t, obj_t);
extern obj_t fun_ast_var;
static obj_t imported_modules_init_94_coerce_walk();
static obj_t library_modules_init_112_coerce_walk();
extern obj_t open_input_string(obj_t);
static obj_t _coerce_walk__98_coerce_walk(obj_t, obj_t);
extern obj_t string_to_bstring(char *);
extern obj_t enter_function_81_tools_error(obj_t);
extern obj_t reset_ppmarge__67_coerce_pproto();
extern obj_t for_each_global__88_ast_env(obj_t);
extern obj_t remove_var_123_ast_remove(obj_t, obj_t);
extern obj_t internal_error_43_tools_error(obj_t, obj_t, obj_t);
extern obj_t pvariable_proto_90_coerce_pproto(long, variable_bglt);
extern obj_t coerce_function__220_coerce_coerce(variable_bglt);
extern bool_t _2__206___r4_numbers_6_5(obj_t, obj_t);
extern obj_t read___reader(obj_t);
static obj_t require_initialization_114_coerce_walk = BUNSPEC;
static obj_t cnst_init_137_coerce_walk();
extern obj_t _current_pass__25_engine_pass;
static obj_t __cnst[4];

DEFINE_STATIC_PROCEDURE(proc1571_coerce_walk, _anonymous_1464__227_coerce_walk1580, _anonymous_1464__227_coerce_walk, 0L, 1);
DEFINE_EXPORT_PROCEDURE(coerce_walk__env_217_coerce_walk, _coerce_walk__98_coerce_walk1581, _coerce_walk__98_coerce_walk, 0L, 1);
DEFINE_STRING(string1575_coerce_walk, string1575_coerce_walk1582, "EXPORT STATIC COERCE PASS-STARTED ", 34);
DEFINE_STRING(string1574_coerce_walk, string1574_coerce_walk1583, "failure during postlude hook", 28);
DEFINE_STRING(string1573_coerce_walk, string1573_coerce_walk1584, " occured, ending ...", 20);
DEFINE_STRING(string1572_coerce_walk, string1572_coerce_walk1585, " error", 6);
DEFINE_STRING(string1569_coerce_walk, string1569_coerce_walk1586, "   . ", 5);
DEFINE_STRING(string1570_coerce_walk, string1570_coerce_walk1587, "failure during prelude hook", 27);
DEFINE_STRING(string1568_coerce_walk, string1568_coerce_walk1588, "Coercions & Checks", 18);



/* module-initialization */
obj_t 
module_initialization_70_coerce_walk(long checksum_1121, char *from_1122)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_coerce_walk))
	{
	   require_initialization_114_coerce_walk =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_coerce_walk();
	   cnst_init_137_coerce_walk();
	   imported_modules_init_94_coerce_walk();
	   method_init_76_coerce_walk();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_coerce_walk()
{
   AN_OBJECT;
   {	/* Coerce/walk.scm 14 */
      module_initialization_70___object(((long) 0), "COERCE_WALK");
      module_initialization_70___r4_output_6_10_3(((long) 0), "COERCE_WALK");
      module_initialization_70___r4_numbers_6_5(((long) 0), "COERCE_WALK");
      module_initialization_70___reader(((long) 0), "COERCE_WALK");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_coerce_walk()
{
   AN_OBJECT;
   {	/* Coerce/walk.scm 14 */
      {		/* Coerce/walk.scm 14 */
	 obj_t cnst_port_138_1114;
	 cnst_port_138_1114 =
	    open_input_string(string1575_coerce_walk);
	 {
	    long i_1115;
	    i_1115 = ((long) 3);
	  loop_1116:
	    {	/* Coerce/walk.scm 14 */
	       bool_t test1576_1117;
	       test1576_1117 =
		  (i_1115 == ((long) -1));
	       if (test1576_1117)
		 {	/* Coerce/walk.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Coerce/walk.scm 14 */
		    {	/* Coerce/walk.scm 14 */
		       obj_t arg1577_1118;
		       {	/* Coerce/walk.scm 14 */
			  obj_t list1578_1119;
			  list1578_1119 =
			     MAKE_PAIR(cnst_port_138_1114, BNIL);
			  arg1577_1118 =
			     read___reader(list1578_1119);
		       }
		       CNST_TABLE_SET(i_1115, arg1577_1118);
		    }
		    {	/* Coerce/walk.scm 14 */
		       int aux_1120;
		       {	/* Coerce/walk.scm 14 */
			  long aux_1140;
			  aux_1140 =
			     (i_1115 - ((long) 1));
			  aux_1120 =
			     (int) (aux_1140);
		       }
		       {
			  long i_1143;
			  i_1143 =
			     (long) (aux_1120);
			  i_1115 = i_1143;
			  goto loop_1116;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* coerce-walk! */
obj_t 
coerce_walk__125_coerce_walk(obj_t ast_1)
{
   AN_OBJECT;
   {	/* Coerce/walk.scm 33 */
      {		/* Coerce/walk.scm 33 */
	 obj_t list1441_697;
	 {	/* Coerce/walk.scm 33 */
	    obj_t arg1443_699;
	    {	/* Coerce/walk.scm 33 */
	       obj_t arg1445_701;
	       {	/* Coerce/walk.scm 33 */
		  obj_t aux_1145;
		  aux_1145 =
		     BCHAR(((unsigned char) '\n'));
		  arg1445_701 =
		     MAKE_PAIR(aux_1145, BNIL);
	       }
	       arg1443_699 =
		  MAKE_PAIR(string1568_coerce_walk, arg1445_701);
	    }
	    list1441_697 =
	       MAKE_PAIR(string1569_coerce_walk, arg1443_699);
	 }
	 verbose_tools_speek(
	    BINT(((long) 1)), list1441_697);
      }
      _nb_error_on_pass__70_tools_error =
	 BINT(((long) 0));
      _current_pass__25_engine_pass = string1568_coerce_walk;
      {
	 obj_t hooks_702;
	 obj_t hnames_703;
	 hooks_702 = BNIL;
	 hnames_703 = BNIL;
       loop_704:
	 if (
	    NULLP(hooks_702))
	   {	/* Coerce/walk.scm 33 */
	      CNST_TABLE_REF(((long) 0));
	   }
	 else
	   {	/* Coerce/walk.scm 33 */
	      bool_t test1450_709;
	      {		/* Coerce/walk.scm 33 */
		 obj_t fun1458_715;
		 fun1458_715 =
		    CAR(hooks_702);
		 {	/* Coerce/walk.scm 33 */
		    obj_t aux_1157;
		    aux_1157 =
		       PROCEDURE_ENTRY(fun1458_715) (fun1458_715, BEOA);
		    test1450_709 =
		       CBOOL(aux_1157);
		 }
	      }
	      if (test1450_709)
		{	/* Coerce/walk.scm 33 */
		   {
		      obj_t hnames_1164;
		      obj_t hooks_1162;
		      hooks_1162 =
			 CDR(hooks_702);
		      hnames_1164 =
			 CDR(hnames_703);
		      hnames_703 = hnames_1164;
		      hooks_702 = hooks_1162;
		      goto loop_704;
		   }
		}
	      else
		{	/* Coerce/walk.scm 33 */
		   internal_error_43_tools_error(string1568_coerce_walk, string1570_coerce_walk,
		      CAR(hnames_703));
		}
	   }
      }
      {
	 obj_t l1437_716;
	 l1437_716 = ast_1;
       lname1438_717:
	 if (
	    PAIRP(l1437_716))
	   {	/* Coerce/walk.scm 35 */
	      {		/* Coerce/walk.scm 35 */
		 obj_t global_719;
		 global_719 =
		    CAR(l1437_716);
		 reset_ppmarge__67_coerce_pproto();
		 {	/* Coerce/walk.scm 37 */
		    obj_t aux_1172;
		    {	/* Coerce/walk.scm 37 */
		       global_bglt obj_1087;
		       obj_1087 =
			  (global_bglt) (global_719);
		       aux_1172 =
			  (((global_bglt) CREF(obj_1087))->id);
		    }
		    enter_function_81_tools_error(aux_1172);
		 }
		 coerce_function__220_coerce_coerce(
		    (variable_bglt) (global_719));
		 leave_function_170_tools_error();
	      }
	      {
		 obj_t l1437_1179;
		 l1437_1179 =
		    CDR(l1437_716);
		 l1437_716 = l1437_1179;
		 goto lname1438_717;
	      }
	   }
	 else
	   {	/* Coerce/walk.scm 35 */
	      ((bool_t) 1);
	   }
      }
      reset_ppmarge__67_coerce_pproto();
      {		/* Coerce/walk.scm 43 */
	 obj_t _anonymous_1464__227_1109;
	 _anonymous_1464__227_1109 = proc1571_coerce_walk;
	 for_each_global__88_ast_env(_anonymous_1464__227_1109);
      }
      {		/* Coerce/walk.scm 47 */
	 obj_t value_734;
	 value_734 =
	    remove_var_123_ast_remove(
	    CNST_TABLE_REF(((long) 1)), ast_1);
	 {	/* Coerce/walk.scm 47 */
	    bool_t test1473_735;
	    {	/* Coerce/walk.scm 47 */
	       long n1_1097;
	       n1_1097 =
		  (long) CINT(_nb_error_on_pass__70_tools_error);
	       test1473_735 =
		  (n1_1097 > ((long) 0));
	    }
	    if (test1473_735)
	      {		/* Coerce/walk.scm 47 */
		 display_2_122___r4_output_6_10_3(_nb_error_on_pass__70_tools_error, current_error_port);
		 display_2_122___r4_output_6_10_3(string1572_coerce_walk, current_error_port);
		 {	/* Coerce/walk.scm 47 */
		    char *arg1474_737;
		    {	/* Coerce/walk.scm 47 */
		       bool_t test1475_738;
		       {	/* Coerce/walk.scm 47 */
			  bool_t test1476_739;
			  {	/* Coerce/walk.scm 47 */
			     obj_t obj_1099;
			     obj_1099 = _nb_error_on_pass__70_tools_error;
			     test1476_739 =
				INTEGERP(obj_1099);
			  }
			  if (test1476_739)
			    {	/* Coerce/walk.scm 47 */
			       test1475_738 =
				  _2__206___r4_numbers_6_5(_nb_error_on_pass__70_tools_error,
				  BINT(((long) 1)));
			    }
			  else
			    {	/* Coerce/walk.scm 47 */
			       test1475_738 = ((bool_t) 0);
			    }
		       }
		       if (test1475_738)
			 {	/* Coerce/walk.scm 47 */
			    arg1474_737 = "s";
			 }
		       else
			 {	/* Coerce/walk.scm 47 */
			    arg1474_737 = "";
			 }
		    }
		    display_2_122___r4_output_6_10_3(
		       string_to_bstring(arg1474_737), current_error_port);
		 }
		 display_2_122___r4_output_6_10_3(string1573_coerce_walk, current_error_port);
		 WRITE_CHAR(((unsigned char) '\n'), current_error_port);
		 {	/* Coerce/walk.scm 47 */
		    obj_t res1567_1102;
		    exit(((long) -1));
		    res1567_1102 =
		       BINT(((long) -1));
		    return res1567_1102;
		 }
	      }
	    else
	      {
		 obj_t hooks_740;
		 obj_t hnames_741;
		 hooks_740 = BNIL;
		 hnames_741 = BNIL;
	       loop_742:
		 if (
		    NULLP(hooks_740))
		   {	/* Coerce/walk.scm 47 */
		      return value_734;
		   }
		 else
		   {	/* Coerce/walk.scm 47 */
		      bool_t test1481_747;
		      {		/* Coerce/walk.scm 47 */
			 obj_t fun1487_752;
			 fun1487_752 =
			    CAR(hooks_740);
			 {	/* Coerce/walk.scm 47 */
			    obj_t aux_1204;
			    aux_1204 =
			       PROCEDURE_ENTRY(fun1487_752) (fun1487_752, BEOA);
			    test1481_747 =
			       CBOOL(aux_1204);
			 }
		      }
		      if (test1481_747)
			{	/* Coerce/walk.scm 47 */
			   {
			      obj_t hnames_1211;
			      obj_t hooks_1209;
			      hooks_1209 =
				 CDR(hooks_740);
			      hnames_1211 =
				 CDR(hnames_741);
			      hnames_741 = hnames_1211;
			      hooks_740 = hooks_1209;
			      goto loop_742;
			   }
			}
		      else
			{	/* Coerce/walk.scm 47 */
			   return
			      internal_error_43_tools_error(_current_pass__25_engine_pass, string1574_coerce_walk,
			      CAR(hnames_741));
			}
		   }
	      }
	 }
      }
   }
}



/* _coerce-walk! */
obj_t 
_coerce_walk__98_coerce_walk(obj_t env_1110, obj_t ast_1111)
{
   AN_OBJECT;
   {	/* Coerce/walk.scm 33 */
      return
	 coerce_walk__125_coerce_walk(ast_1111);
   }
}



/* <anonymous:1464> */
obj_t 
_anonymous_1464__227_coerce_walk(obj_t env_1112, obj_t global_1113)
{
   AN_OBJECT;
   {	/* Coerce/walk.scm 42 */
      {
	 obj_t global_723;
	 global_723 = global_1113;
	 {	/* Coerce/walk.scm 43 */
	    bool_t test1465_725;
	    {	/* Coerce/walk.scm 43 */
	       bool_t test1466_726;
	       {	/* ./Ast/var.scm 838 */
		  obj_t aux_1216;
		  {	/* Coerce/walk.scm 43 */
		     value_bglt aux_1217;
		     {	/* Coerce/walk.scm 43 */
			global_bglt obj_1089;
			obj_1089 =
			   (global_bglt) (global_723);
			aux_1217 =
			   (((global_bglt) CREF(obj_1089))->value);
		     }
		     aux_1216 =
			(obj_t) (aux_1217);
		  }
		  test1466_726 =
		     is_a__118___object(aux_1216, fun_ast_var);
	       }
	       if (test1466_726)
		 {	/* Coerce/walk.scm 43 */
		    test1465_725 = ((bool_t) 0);
		 }
	       else
		 {	/* Coerce/walk.scm 44 */
		    bool_t _ortest_1439_727;
		    {	/* ./Ieee/equiv.scm 5508 */
		       obj_t aux_1226;
		       obj_t aux_1223;
		       aux_1226 =
			  CNST_TABLE_REF(((long) 2));
		       {	/* Coerce/walk.scm 44 */
			  global_bglt obj_1091;
			  obj_1091 =
			     (global_bglt) (global_723);
			  aux_1223 =
			     (((global_bglt) CREF(obj_1091))->import);
		       }
		       _ortest_1439_727 =
			  (aux_1223 == aux_1226);
		    }
		    if (_ortest_1439_727)
		      {		/* Coerce/walk.scm 44 */
			 test1465_725 = _ortest_1439_727;
		      }
		    else
		      {		/* ./Ieee/equiv.scm 5508 */
			 obj_t aux_1233;
			 obj_t aux_1230;
			 aux_1233 =
			    CNST_TABLE_REF(((long) 3));
			 {	/* Coerce/walk.scm 45 */
			    global_bglt obj_1094;
			    obj_1094 =
			       (global_bglt) (global_723);
			    aux_1230 =
			       (((global_bglt) CREF(obj_1094))->import);
			 }
			 test1465_725 =
			    (aux_1230 == aux_1233);
		      }
		 }
	    }
	    if (test1465_725)
	      {		/* Coerce/walk.scm 43 */
		 return
		    pvariable_proto_90_coerce_pproto(((long) 3),
		    (variable_bglt) (global_723));
	      }
	    else
	      {		/* Coerce/walk.scm 43 */
		 return BUNSPEC;
	      }
	 }
      }
   }
}



/* method-init */
obj_t 
method_init_76_coerce_walk()
{
   AN_OBJECT;
   {	/* Coerce/walk.scm 14 */
      return BUNSPEC;
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_coerce_walk()
{
   AN_OBJECT;
   {	/* Coerce/walk.scm 14 */
      module_initialization_70_tools_speek(((long) 0), "COERCE_WALK");
      module_initialization_70_tools_error(((long) 0), "COERCE_WALK");
      module_initialization_70_engine_pass(((long) 0), "COERCE_WALK");
      module_initialization_70_tools_shape(((long) 0), "COERCE_WALK");
      module_initialization_70_type_type(((long) 0), "COERCE_WALK");
      module_initialization_70_type_cache(((long) 0), "COERCE_WALK");
      module_initialization_70_engine_param(((long) 0), "COERCE_WALK");
      module_initialization_70_ast_var(((long) 0), "COERCE_WALK");
      module_initialization_70_ast_env(((long) 0), "COERCE_WALK");
      module_initialization_70_ast_node(((long) 0), "COERCE_WALK");
      module_initialization_70_ast_remove(((long) 0), "COERCE_WALK");
      module_initialization_70_coerce_pproto(((long) 0), "COERCE_WALK");
      return
	 module_initialization_70_coerce_coerce(((long) 0), "COERCE_WALK");
   }
}
