/*===========================================================================*/
/*   (Effect/cgraph.scm)                                                     */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;

typedef struct local_from_91
  {
     obj_t from;
  }
             *local_from_91_bglt;

typedef struct global_from_205
  {
     obj_t from;
  }
               *global_from_205_bglt;


static obj_t mark_side_effect__61_effect_cgraph(variable_bglt);
extern obj_t local_from_user__set__131_effect_cgraph(local_bglt, bool_t);
static obj_t object__struct_local_from1572_217_effect_cgraph(obj_t, obj_t);
extern obj_t local_from_from_set__181_effect_cgraph(local_from_91_bglt, obj_t);
static obj_t method_init_76_effect_cgraph();
extern obj_t make_box_202_ast_node;
extern obj_t funcall_ast_node;
extern local_from_91_bglt widening_local_from_161_effect_cgraph(obj_t);
extern long add_inlined_method__244___object(obj_t, obj_t, long);
extern obj_t local_from_occurrence_set__59_effect_cgraph(local_bglt, long);
static obj_t _allocate_local_from_49_effect_cgraph(obj_t);
extern obj_t fail_ast_node;
extern obj_t box_ref_242_ast_node;
static obj_t _local_from_access_219_effect_cgraph(obj_t, obj_t);
static obj_t _global_from_name_set__215_effect_cgraph(obj_t, obj_t, obj_t);
extern obj_t global_from_from_set__167_effect_cgraph(global_from_205_bglt, obj_t);
static obj_t _global_from_evaluable__set__180_effect_cgraph(obj_t, obj_t, obj_t);
extern long local_from_occurrence_155_effect_cgraph(local_bglt);
static obj_t _var_all__30_effect_cgraph = BUNSPEC;
extern obj_t global_from_value_set__85_effect_cgraph(global_bglt, value_bglt);
static obj_t _global_from_src_128_effect_cgraph(obj_t, obj_t);
extern obj_t global_from_fast_alpha_93_effect_cgraph(global_bglt);
extern obj_t sequence_ast_node;
static obj_t _global_from_import_set__37_effect_cgraph(obj_t, obj_t, obj_t);
extern obj_t let_var_6_ast_node;
static obj_t _save_call__default1554_247_effect_cgraph(obj_t, obj_t, obj_t);
static obj_t _local_from_name_set__71_effect_cgraph(obj_t, obj_t, obj_t);
extern global_from_205_bglt widening_global_from_27_effect_cgraph(obj_t);
extern obj_t local_from_access_186_effect_cgraph(local_bglt);
extern obj_t local_from_removable_243_effect_cgraph(local_bglt);
static obj_t call_graph__default1514_170_effect_cgraph(node_bglt, variable_bglt);
extern obj_t global_from_module_199_effect_cgraph(global_bglt);
static obj_t object__struct_global_from1568_37_effect_cgraph(obj_t, obj_t);
static obj_t _local_from_type_194_effect_cgraph(obj_t, obj_t);
extern object_bglt struct_object__object_93___object(object_bglt, obj_t);
extern obj_t add_method__1___object(obj_t, obj_t, obj_t);
static obj_t _local_from_user__20_effect_cgraph(obj_t, obj_t);
extern obj_t global_ast_var;
extern obj_t pragma_ast_node;
static obj_t _global_from_library__143_effect_cgraph(obj_t, obj_t);
extern obj_t set_ex_it_116_ast_node;
extern obj_t find_super_class_method_167___object(object_bglt, obj_t, obj_t);
extern obj_t local_from_type_set__115_effect_cgraph(local_bglt, type_bglt);
static obj_t _global_from_name_66_effect_cgraph(obj_t, obj_t);
static obj_t _global_from_library__set__232_effect_cgraph(obj_t, obj_t, obj_t);
extern obj_t global_from_removable_194_effect_cgraph(global_bglt);
extern bool_t is_a__118___object(obj_t, obj_t);
static obj_t _global_from_id_145_effect_cgraph(obj_t, obj_t);
static obj_t _make_global_from_242_effect_cgraph(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static bool_t call_graph___13_effect_cgraph(obj_t, variable_bglt);
extern obj_t global_from_occurrence_set__12_effect_cgraph(global_bglt, long);
static obj_t _get_var_all_236_effect_cgraph(obj_t);
extern obj_t module_initialization_70_effect_cgraph(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
static obj_t _global_from_evaluable__111_effect_cgraph(obj_t, obj_t);
extern bool_t local_from_user__236_effect_cgraph(local_bglt);
static obj_t _global_from_user__set__242_effect_cgraph(obj_t, obj_t, obj_t);
extern local_bglt allocate_local_from_4_effect_cgraph();
extern obj_t global_from_type_set__45_effect_cgraph(global_bglt, type_bglt);
static obj_t _global_from_from_34_effect_cgraph(obj_t, obj_t);
extern obj_t local_from_removable_set__109_effect_cgraph(local_bglt, obj_t);
static obj_t _global_from_value_186_effect_cgraph(obj_t, obj_t);
obj_t local_from_91_effect_cgraph = BUNSPEC;
extern obj_t local_from_value_set__238_effect_cgraph(local_bglt, value_bglt);
extern obj_t local_from_id_164_effect_cgraph(local_bglt);
extern obj_t local_from_fast_alpha_88_effect_cgraph(local_bglt);
static obj_t _var_side_effect__143_effect_cgraph = BUNSPEC;
extern obj_t get_var_all_239_effect_cgraph();
extern obj_t global_from_name_15_effect_cgraph(global_bglt);
extern long class_num_218___object(obj_t);
static obj_t _allocate_global_from_157_effect_cgraph(obj_t);
static obj_t _global_from_access_171_effect_cgraph(obj_t, obj_t);
extern value_bglt global_from_value_26_effect_cgraph(global_bglt);
extern global_from_205_bglt make_global_from_185_effect_cgraph(obj_t, obj_t, type_bglt, value_bglt, obj_t, obj_t, obj_t, long, obj_t, obj_t, bool_t, bool_t, bool_t, obj_t, obj_t, obj_t);
static obj_t _global_from_src_set__107_effect_cgraph(obj_t, obj_t, obj_t);
static obj_t _global_from_occurrence_212_effect_cgraph(obj_t, obj_t);
static obj_t _local_from_fast_alpha_set__212_effect_cgraph(obj_t, obj_t, obj_t);
static obj_t save_call__133_effect_cgraph(variable_bglt, variable_bglt);
extern obj_t local_from_name_set__39_effect_cgraph(local_bglt, obj_t);
extern obj_t let_fun_218_ast_node;
static obj_t _global_from_removable_set__80_effect_cgraph(obj_t, obj_t, obj_t);
static obj_t _local_from_access_set__198_effect_cgraph(obj_t, obj_t, obj_t);
static obj_t imported_modules_init_94_effect_cgraph();
extern obj_t global_from_from_91_effect_cgraph(global_from_205_bglt);
static obj_t _global_from_pragma_164_effect_cgraph(obj_t, obj_t);
static obj_t _global_from_fast_alpha_set__161_effect_cgraph(obj_t, obj_t, obj_t);
static obj_t _global_from_access_set__7_effect_cgraph(obj_t, obj_t, obj_t);
extern obj_t global_from_id_148_effect_cgraph(global_bglt);
extern bool_t global_from_library__57_effect_cgraph(global_bglt);
extern obj_t app_ly_162_ast_node;
extern obj_t cfun_ast_var;
extern obj_t add_generic__110___object(obj_t, obj_t);
extern obj_t global_from_name_set__93_effect_cgraph(global_bglt, obj_t);
extern bool_t global_from__222_effect_cgraph(obj_t);
static obj_t _call_graph__9_effect_cgraph(obj_t, obj_t, obj_t);
extern obj_t local_from_name_69_effect_cgraph(local_bglt);
extern local_from_91_bglt make_local_from_27_effect_cgraph(obj_t, obj_t, type_bglt, value_bglt, obj_t, obj_t, obj_t, long, bool_t, long, obj_t);
extern obj_t app_ast_node;
static obj_t _global_from_import_184_effect_cgraph(obj_t, obj_t);
static obj_t library_modules_init_112_effect_cgraph();
extern obj_t global_from_evaluable__set__132_effect_cgraph(global_bglt, bool_t);
extern obj_t fun_call_graph__231_effect_cgraph(variable_bglt);
extern obj_t make_struct(obj_t, long, obj_t);
extern obj_t cast_ast_node;
static obj_t toplevel_init_63_effect_cgraph();
static obj_t call_graph__81_effect_cgraph(node_bglt, variable_bglt);
extern obj_t local_from_from_185_effect_cgraph(local_from_91_bglt);
extern obj_t global_from_import_set__85_effect_cgraph(global_bglt, obj_t);
extern obj_t create_vector(long);
extern obj_t jump_ex_it_184_ast_node;
extern obj_t open_input_string(obj_t);
static obj_t _global_from_value_set__145_effect_cgraph(obj_t, obj_t, obj_t);
static obj_t _local_from_user__set__49_effect_cgraph(obj_t, obj_t, obj_t);
static obj_t save_call__default1554_39_effect_cgraph(variable_bglt, variable_bglt);
extern global_bglt allocate_global_from_170_effect_cgraph();
static obj_t _local_from_value_174_effect_cgraph(obj_t, obj_t);
static obj_t _global_from_fast_alpha_10_effect_cgraph(obj_t, obj_t);
extern obj_t sfun_ast_var;
static obj_t struct_object__object_local_from1574_245_effect_cgraph(obj_t, obj_t, obj_t);
extern obj_t setq_ast_node;
extern obj_t global_from_src_set__208_effect_cgraph(global_bglt, obj_t);
static obj_t _reset_effect_tables__191_effect_cgraph(obj_t);
extern obj_t local_from_fast_alpha_set__165_effect_cgraph(local_bglt, obj_t);
extern obj_t box_set__221_ast_node;
extern obj_t global_from_removable_set__176_effect_cgraph(global_bglt, obj_t);
static obj_t _global_from_module_160_effect_cgraph(obj_t, obj_t);
static obj_t _global_from_type_149_effect_cgraph(obj_t, obj_t);
static obj_t _call_graph__default1514_208_effect_cgraph(obj_t, obj_t, obj_t);
extern obj_t local_ast_var;
static obj_t _get_var_side_effect_19_effect_cgraph(obj_t);
extern obj_t global_from_library__set__21_effect_cgraph(global_bglt, bool_t);
static obj_t _global_from_from_set__151_effect_cgraph(obj_t, obj_t, obj_t);
static obj_t _local_from_name_196_effect_cgraph(obj_t, obj_t);
obj_t global_from_205_effect_cgraph = BUNSPEC;
static obj_t _local_from_occurrence_27_effect_cgraph(obj_t, obj_t);
static obj_t _make_local_from_25_effect_cgraph(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t _save_call__94_effect_cgraph(obj_t, obj_t, obj_t);
extern obj_t memq___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern obj_t register_class__225___object(obj_t, obj_t, obj_t, long, obj_t, obj_t, obj_t);
extern value_bglt local_from_value_53_effect_cgraph(local_bglt);
static obj_t _fun_call_graph__58_effect_cgraph(obj_t, obj_t);
static obj_t _local_from_from_set__10_effect_cgraph(obj_t, obj_t, obj_t);
static obj_t _global_from__164_effect_cgraph(obj_t, obj_t);
extern bool_t global_from_evaluable__174_effect_cgraph(global_bglt);
extern obj_t global_from_user__set__38_effect_cgraph(global_bglt, bool_t);
static obj_t _widening_local_from_224_effect_cgraph(obj_t, obj_t);
static obj_t _local_from_key_127_effect_cgraph(obj_t, obj_t);
static obj_t object_init_111_effect_cgraph();
static obj_t _local_from_occurrence_set__202_effect_cgraph(obj_t, obj_t, obj_t);
static obj_t _local_from_from_35_effect_cgraph(obj_t, obj_t);
extern type_bglt global_from_type_150_effect_cgraph(global_bglt);
static obj_t struct_object__object_global_from1570_205_effect_cgraph(obj_t, obj_t, obj_t);
static obj_t _global_from_occurrence_set__250_effect_cgraph(obj_t, obj_t, obj_t);
static obj_t _local_from_removable_set__173_effect_cgraph(obj_t, obj_t, obj_t);
extern obj_t global_from_access_80_effect_cgraph(global_bglt);
static obj_t _global_from_removable_24_effect_cgraph(obj_t, obj_t);
extern obj_t _classes__134___object;
extern obj_t select_ast_node;
extern obj_t global_from_fast_alpha_set__42_effect_cgraph(global_bglt, obj_t);
static obj_t _local_from_id_15_effect_cgraph(obj_t, obj_t);
static obj_t _global_from_user__183_effect_cgraph(obj_t, obj_t);
extern obj_t read___reader(obj_t);
static obj_t _widening_global_from_137_effect_cgraph(obj_t, obj_t);
extern long global_from_occurrence_204_effect_cgraph(global_bglt);
static obj_t _local_from_removable_239_effect_cgraph(obj_t, obj_t);
static obj_t _local_from__225_effect_cgraph(obj_t, obj_t);
extern obj_t global_from_src_107_effect_cgraph(global_bglt);
extern obj_t local_from_access_set__145_effect_cgraph(local_bglt, obj_t);
extern obj_t global_from_access_set__164_effect_cgraph(global_bglt, obj_t);
extern obj_t global_from_pragma_13_effect_cgraph(global_bglt);
extern bool_t global_from_user__144_effect_cgraph(global_bglt);
extern obj_t reset_effect_tables__151_effect_cgraph();
static obj_t _global_from_type_set__148_effect_cgraph(obj_t, obj_t, obj_t);
extern obj_t object__struct_50___object(object_bglt);
static obj_t require_initialization_114_effect_cgraph = BUNSPEC;
static obj_t _local_from_value_set__132_effect_cgraph(obj_t, obj_t, obj_t);
extern obj_t conditional_ast_node;
extern type_bglt local_from_type_22_effect_cgraph(local_bglt);
static obj_t _local_from_fast_alpha_3_effect_cgraph(obj_t, obj_t);
extern obj_t get_var_side_effect_0_effect_cgraph();
static obj_t _local_from_type_set__176_effect_cgraph(obj_t, obj_t, obj_t);
extern bool_t local_from__82_effect_cgraph(obj_t);
static obj_t cnst_init_137_effect_cgraph();
extern long local_from_key_203_effect_cgraph(local_bglt);
extern obj_t global_from_import_26_effect_cgraph(global_bglt);
static obj_t __cnst[6];

DEFINE_EXPORT_PROCEDURE(global_from_from_set__env_187_effect_cgraph, _global_from_from_set__151_effect_cgraph1815, _global_from_from_set__151_effect_cgraph, 0L, 2);
DEFINE_EXPORT_PROCEDURE(global_from_occurrence_set__env_74_effect_cgraph, _global_from_occurrence_set__250_effect_cgraph1816, _global_from_occurrence_set__250_effect_cgraph, 0L, 2);
DEFINE_EXPORT_PROCEDURE(global_from_fast_alpha_set__env_73_effect_cgraph, _global_from_fast_alpha_set__161_effect_cgraph1817, _global_from_fast_alpha_set__161_effect_cgraph, 0L, 2);
DEFINE_EXPORT_PROCEDURE(global_from_name_env_27_effect_cgraph, _global_from_name_66_effect_cgraph1818, _global_from_name_66_effect_cgraph, 0L, 1);
DEFINE_EXPORT_PROCEDURE(reset_effect_tables__env_101_effect_cgraph, _reset_effect_tables__191_effect_cgraph1819, _reset_effect_tables__191_effect_cgraph, 0L, 0);
DEFINE_EXPORT_PROCEDURE(local_from_occurrence_set__env_119_effect_cgraph, _local_from_occurrence_set__202_effect_cgraph1820, _local_from_occurrence_set__202_effect_cgraph, 0L, 2);
DEFINE_EXPORT_PROCEDURE(local_from_user__set__env_91_effect_cgraph, _local_from_user__set__49_effect_cgraph1821, _local_from_user__set__49_effect_cgraph, 0L, 2);
DEFINE_EXPORT_PROCEDURE(local_from_id_env_208_effect_cgraph, _local_from_id_15_effect_cgraph1822, _local_from_id_15_effect_cgraph, 0L, 1);
DEFINE_EXPORT_PROCEDURE(widening_global_from_env_64_effect_cgraph, _widening_global_from_137_effect_cgraph1823, _widening_global_from_137_effect_cgraph, 0L, 1);
DEFINE_EXPORT_PROCEDURE(local_from_fast_alpha_set__env_35_effect_cgraph, _local_from_fast_alpha_set__212_effect_cgraph1824, _local_from_fast_alpha_set__212_effect_cgraph, 0L, 2);
DEFINE_EXPORT_PROCEDURE(local_from_value_env_92_effect_cgraph, _local_from_value_174_effect_cgraph1825, _local_from_value_174_effect_cgraph, 0L, 1);
DEFINE_EXPORT_PROCEDURE(local_from_access_set__env_1_effect_cgraph, _local_from_access_set__198_effect_cgraph1826, _local_from_access_set__198_effect_cgraph, 0L, 2);
DEFINE_EXPORT_PROCEDURE(global_from_import_env_252_effect_cgraph, _global_from_import_184_effect_cgraph1827, _global_from_import_184_effect_cgraph, 0L, 1);
DEFINE_EXPORT_PROCEDURE(local_from_name_set__env_230_effect_cgraph, _local_from_name_set__71_effect_cgraph1828, _local_from_name_set__71_effect_cgraph, 0L, 2);
DEFINE_EXPORT_PROCEDURE(global_from_import_set__env_171_effect_cgraph, _global_from_import_set__37_effect_cgraph1829, _global_from_import_set__37_effect_cgraph, 0L, 2);
DEFINE_EXPORT_PROCEDURE(local_from_removable_set__env_45_effect_cgraph, _local_from_removable_set__173_effect_cgraph1830, _local_from_removable_set__173_effect_cgraph, 0L, 2);
DEFINE_EXPORT_PROCEDURE(local_from_occurrence_env_228_effect_cgraph, _local_from_occurrence_27_effect_cgraph1831, _local_from_occurrence_27_effect_cgraph, 0L, 1);
DEFINE_EXPORT_PROCEDURE(global_from_name_set__env_209_effect_cgraph, _global_from_name_set__215_effect_cgraph1832, _global_from_name_set__215_effect_cgraph, 0L, 2);
DEFINE_EXPORT_PROCEDURE(global_from_value_env_252_effect_cgraph, _global_from_value_186_effect_cgraph1833, _global_from_value_186_effect_cgraph, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc1808_effect_cgraph, struct_object__object_local_from1574_245_effect_cgraph1834, struct_object__object_local_from1574_245_effect_cgraph, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc1807_effect_cgraph, object__struct_local_from1572_217_effect_cgraph1835, object__struct_local_from1572_217_effect_cgraph, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc1806_effect_cgraph, struct_object__object_global_from1570_205_effect_cgraph1836, struct_object__object_global_from1570_205_effect_cgraph, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc1805_effect_cgraph, object__struct_global_from1568_37_effect_cgraph1837, object__struct_global_from1568_37_effect_cgraph, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_global_from_env_203_effect_cgraph, _make_global_from_242_effect_cgraph1838, _make_global_from_242_effect_cgraph, 0L, 16);
DEFINE_STATIC_PROCEDURE(save_call__default1554_env_230_effect_cgraph, _save_call__default1554_247_effect_cgraph1839, _save_call__default1554_247_effect_cgraph, 0L, 2);
DEFINE_EXPORT_PROCEDURE(global_from_value_set__env_171_effect_cgraph, _global_from_value_set__145_effect_cgraph1840, _global_from_value_set__145_effect_cgraph, 0L, 2);
DEFINE_EXPORT_PROCEDURE(global_from__env_97_effect_cgraph, _global_from__164_effect_cgraph1841, _global_from__164_effect_cgraph, 0L, 1);
extern obj_t struct_object__object_env_209___object;
DEFINE_EXPORT_PROCEDURE(global_from_library__env_240_effect_cgraph, _global_from_library__143_effect_cgraph1842, _global_from_library__143_effect_cgraph, 0L, 1);
DEFINE_EXPORT_PROCEDURE(global_from_access_env_134_effect_cgraph, _global_from_access_171_effect_cgraph1843, _global_from_access_171_effect_cgraph, 0L, 1);
DEFINE_EXPORT_PROCEDURE(local_from_key_env_223_effect_cgraph, _local_from_key_127_effect_cgraph1844, _local_from_key_127_effect_cgraph, 0L, 1);
DEFINE_EXPORT_PROCEDURE(global_from_access_set__env_208_effect_cgraph, _global_from_access_set__7_effect_cgraph1845, _global_from_access_set__7_effect_cgraph, 0L, 2);
DEFINE_EXPORT_PROCEDURE(local_from_removable_env_20_effect_cgraph, _local_from_removable_239_effect_cgraph1846, _local_from_removable_239_effect_cgraph, 0L, 1);
DEFINE_EXPORT_PROCEDURE(local_from_name_env_84_effect_cgraph, _local_from_name_196_effect_cgraph1847, _local_from_name_196_effect_cgraph, 0L, 1);
DEFINE_EXPORT_PROCEDURE(global_from_evaluable__env_156_effect_cgraph, _global_from_evaluable__111_effect_cgraph1848, _global_from_evaluable__111_effect_cgraph, 0L, 1);
DEFINE_STATIC_PROCEDURE(call_graph__default1514_env_89_effect_cgraph, _call_graph__default1514_208_effect_cgraph1849, _call_graph__default1514_208_effect_cgraph, 0L, 2);
DEFINE_EXPORT_PROCEDURE(local_from_fast_alpha_env_168_effect_cgraph, _local_from_fast_alpha_3_effect_cgraph1850, _local_from_fast_alpha_3_effect_cgraph, 0L, 1);
DEFINE_EXPORT_PROCEDURE(global_from_removable_env_246_effect_cgraph, _global_from_removable_24_effect_cgraph1851, _global_from_removable_24_effect_cgraph, 0L, 1);
DEFINE_EXPORT_PROCEDURE(fun_call_graph__env_198_effect_cgraph, _fun_call_graph__58_effect_cgraph1852, _fun_call_graph__58_effect_cgraph, 0L, 1);
DEFINE_EXPORT_PROCEDURE(local_from__env_106_effect_cgraph, _local_from__225_effect_cgraph1853, _local_from__225_effect_cgraph, 0L, 1);
DEFINE_EXPORT_PROCEDURE(global_from_from_env_87_effect_cgraph, _global_from_from_34_effect_cgraph1854, _global_from_from_34_effect_cgraph, 0L, 1);
DEFINE_EXPORT_PROCEDURE(global_from_user__set__env_162_effect_cgraph, _global_from_user__set__242_effect_cgraph1855, _global_from_user__set__242_effect_cgraph, 0L, 2);
DEFINE_EXPORT_PROCEDURE(global_from_src_env_23_effect_cgraph, _global_from_src_128_effect_cgraph1856, _global_from_src_128_effect_cgraph, 0L, 1);
DEFINE_EXPORT_PROCEDURE(local_from_access_env_196_effect_cgraph, _local_from_access_219_effect_cgraph1857, _local_from_access_219_effect_cgraph, 0L, 1);
DEFINE_EXPORT_PROCEDURE(local_from_type_set__env_172_effect_cgraph, _local_from_type_set__176_effect_cgraph1858, _local_from_type_set__176_effect_cgraph, 0L, 2);
DEFINE_STATIC_GENERIC(save_call__env_248_effect_cgraph, _save_call__94_effect_cgraph1859, _save_call__94_effect_cgraph, 0L, 2);
DEFINE_EXPORT_PROCEDURE(global_from_occurrence_env_236_effect_cgraph, _global_from_occurrence_212_effect_cgraph1860, _global_from_occurrence_212_effect_cgraph, 0L, 1);
DEFINE_EXPORT_PROCEDURE(global_from_type_set__env_125_effect_cgraph, _global_from_type_set__148_effect_cgraph1861, _global_from_type_set__148_effect_cgraph, 0L, 2);
DEFINE_EXPORT_PROCEDURE(global_from_pragma_env_34_effect_cgraph, _global_from_pragma_164_effect_cgraph1862, _global_from_pragma_164_effect_cgraph, 0L, 1);
DEFINE_EXPORT_PROCEDURE(global_from_type_env_9_effect_cgraph, _global_from_type_149_effect_cgraph1863, _global_from_type_149_effect_cgraph, 0L, 1);
DEFINE_EXPORT_PROCEDURE(global_from_module_env_206_effect_cgraph, _global_from_module_160_effect_cgraph1864, _global_from_module_160_effect_cgraph, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_local_from_env_64_effect_cgraph, _make_local_from_25_effect_cgraph1865, _make_local_from_25_effect_cgraph, 0L, 11);
DEFINE_EXPORT_PROCEDURE(global_from_removable_set__env_239_effect_cgraph, _global_from_removable_set__80_effect_cgraph1866, _global_from_removable_set__80_effect_cgraph, 0L, 2);
DEFINE_EXPORT_PROCEDURE(allocate_global_from_env_89_effect_cgraph, _allocate_global_from_157_effect_cgraph1867, _allocate_global_from_157_effect_cgraph, 0L, 0);
DEFINE_EXPORT_PROCEDURE(global_from_evaluable__set__env_104_effect_cgraph, _global_from_evaluable__set__180_effect_cgraph1868, _global_from_evaluable__set__180_effect_cgraph, 0L, 2);
DEFINE_EXPORT_PROCEDURE(global_from_fast_alpha_env_209_effect_cgraph, _global_from_fast_alpha_10_effect_cgraph1869, _global_from_fast_alpha_10_effect_cgraph, 0L, 1);
DEFINE_EXPORT_PROCEDURE(local_from_user__env_94_effect_cgraph, _local_from_user__20_effect_cgraph1870, _local_from_user__20_effect_cgraph, 0L, 1);
DEFINE_EXPORT_PROCEDURE(local_from_from_env_203_effect_cgraph, _local_from_from_35_effect_cgraph1871, _local_from_from_35_effect_cgraph, 0L, 1);
DEFINE_EXPORT_PROCEDURE(allocate_local_from_env_235_effect_cgraph, _allocate_local_from_49_effect_cgraph1872, _allocate_local_from_49_effect_cgraph, 0L, 0);
DEFINE_STRING(string1809_effect_cgraph, string1809_effect_cgraph1873, "No method for this object", 25);
DEFINE_STRING(string1810_effect_cgraph, string1810_effect_cgraph1874, "SAVE-CALL!-DEFAULT1554 IMPORT DONE GLOBAL/FROM LOCAL/FROM NOTHING ", 66);
DEFINE_EXPORT_PROCEDURE(global_from_id_env_82_effect_cgraph, _global_from_id_145_effect_cgraph1875, _global_from_id_145_effect_cgraph, 0L, 1);
DEFINE_EXPORT_PROCEDURE(get_var_all_env_251_effect_cgraph, _get_var_all_236_effect_cgraph1876, _get_var_all_236_effect_cgraph, 0L, 0);
DEFINE_EXPORT_PROCEDURE(global_from_user__env_243_effect_cgraph, _global_from_user__183_effect_cgraph1877, _global_from_user__183_effect_cgraph, 0L, 1);
DEFINE_EXPORT_PROCEDURE(global_from_src_set__env_54_effect_cgraph, _global_from_src_set__107_effect_cgraph1878, _global_from_src_set__107_effect_cgraph, 0L, 2);
DEFINE_EXPORT_PROCEDURE(global_from_library__set__env_123_effect_cgraph, _global_from_library__set__232_effect_cgraph1879, _global_from_library__set__232_effect_cgraph, 0L, 2);
DEFINE_EXPORT_PROCEDURE(local_from_value_set__env_75_effect_cgraph, _local_from_value_set__132_effect_cgraph1880, _local_from_value_set__132_effect_cgraph, 0L, 2);
DEFINE_EXPORT_PROCEDURE(local_from_type_env_98_effect_cgraph, _local_from_type_194_effect_cgraph1881, _local_from_type_194_effect_cgraph, 0L, 1);
extern obj_t object__struct_env_210___object;
DEFINE_EXPORT_PROCEDURE(local_from_from_set__env_60_effect_cgraph, _local_from_from_set__10_effect_cgraph1882, _local_from_from_set__10_effect_cgraph, 0L, 2);
DEFINE_EXPORT_PROCEDURE(widening_local_from_env_53_effect_cgraph, _widening_local_from_224_effect_cgraph1883, _widening_local_from_224_effect_cgraph, 0L, 1);
DEFINE_STATIC_GENERIC(call_graph__env_226_effect_cgraph, _call_graph__9_effect_cgraph1884, _call_graph__9_effect_cgraph, 0L, 2);
DEFINE_EXPORT_PROCEDURE(get_var_side_effect_env_93_effect_cgraph, _get_var_side_effect_19_effect_cgraph1885, _get_var_side_effect_19_effect_cgraph, 0L, 0);



/* module-initialization */
obj_t 
module_initialization_70_effect_cgraph(long checksum_1981, char *from_1982)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_effect_cgraph))
	{
	   require_initialization_114_effect_cgraph =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_effect_cgraph();
	   cnst_init_137_effect_cgraph();
	   imported_modules_init_94_effect_cgraph();
	   object_init_111_effect_cgraph();
	   method_init_76_effect_cgraph();
	   toplevel_init_63_effect_cgraph();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_effect_cgraph()
{
   AN_OBJECT;
   {	/* Effect/cgraph.scm 14 */
      module_initialization_70___object(((long) 0), "EFFECT_CGRAPH");
      module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "EFFECT_CGRAPH");
      module_initialization_70___reader(((long) 0), "EFFECT_CGRAPH");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_effect_cgraph()
{
   AN_OBJECT;
   {	/* Effect/cgraph.scm 14 */
      {		/* Effect/cgraph.scm 14 */
	 obj_t cnst_port_138_1974;
	 cnst_port_138_1974 =
	    open_input_string(string1810_effect_cgraph);
	 {
	    long i_1975;
	    i_1975 = ((long) 5);
	  loop_1976:
	    {	/* Effect/cgraph.scm 14 */
	       bool_t test1811_1977;
	       test1811_1977 =
		  (i_1975 == ((long) -1));
	       if (test1811_1977)
		 {	/* Effect/cgraph.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Effect/cgraph.scm 14 */
		    {	/* Effect/cgraph.scm 14 */
		       obj_t arg1812_1978;
		       {	/* Effect/cgraph.scm 14 */
			  obj_t list1813_1979;
			  list1813_1979 =
			     MAKE_PAIR(cnst_port_138_1974, BNIL);
			  arg1812_1978 =
			     read___reader(list1813_1979);
		       }
		       CNST_TABLE_SET(i_1975, arg1812_1978);
		    }
		    {	/* Effect/cgraph.scm 14 */
		       int aux_1980;
		       {	/* Effect/cgraph.scm 14 */
			  long aux_2001;
			  aux_2001 =
			     (i_1975 - ((long) 1));
			  aux_1980 =
			     (int) (aux_2001);
		       }
		       {
			  long i_2004;
			  i_2004 =
			     (long) (aux_1980);
			  i_1975 = i_2004;
			  goto loop_1976;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_effect_cgraph()
{
   AN_OBJECT;
   {	/* Effect/cgraph.scm 14 */
      _var_side_effect__143_effect_cgraph = BNIL;
      return (
	 _var_all__30_effect_cgraph = BNIL, BUNSPEC);
   }
}



/* fun-call-graph! */
obj_t 
fun_call_graph__231_effect_cgraph(variable_bglt variable_1)
{
   AN_OBJECT;
   {	/* Effect/cgraph.scm 29 */
      {		/* Effect/cgraph.scm 30 */
	 obj_t obj2_1445;
	 obj2_1445 = _var_all__30_effect_cgraph;
	 {	/* ./Ieee/pair-list.scm 5689 */
	    obj_t aux_2006;
	    aux_2006 =
	       (obj_t) (variable_1);
	    _var_all__30_effect_cgraph =
	       MAKE_PAIR(aux_2006, obj2_1445);
	 }
      }
      {		/* Effect/cgraph.scm 31 */
	 node_bglt aux_2009;
	 {	/* Effect/cgraph.scm 31 */
	    obj_t aux_2010;
	    {	/* Effect/cgraph.scm 31 */
	       sfun_bglt obj_1447;
	       {	/* Effect/cgraph.scm 31 */
		  value_bglt aux_2011;
		  aux_2011 =
		     (((variable_bglt) CREF(variable_1))->value);
		  obj_1447 =
		     (sfun_bglt) (aux_2011);
	       }
	       aux_2010 =
		  (((sfun_bglt) CREF(obj_1447))->body);
	    }
	    aux_2009 =
	       (node_bglt) (aux_2010);
	 }
	 return
	    call_graph__81_effect_cgraph(aux_2009, variable_1);
      }
   }
}



/* _fun-call-graph! */
obj_t 
_fun_call_graph__58_effect_cgraph(obj_t env_1779, obj_t variable_1780)
{
   AN_OBJECT;
   {	/* Effect/cgraph.scm 29 */
      return
	 fun_call_graph__231_effect_cgraph(
	 (variable_bglt) (variable_1780));
   }
}



/* call-graph*! */
bool_t 
call_graph___13_effect_cgraph(obj_t node__221_40, variable_bglt owner_41)
{
   AN_OBJECT;
   {	/* Effect/cgraph.scm 196 */
      {
	 obj_t l1504_860;
	 l1504_860 = node__221_40;
       lname1505_861:
	 if (
	    PAIRP(l1504_860))
	   {	/* Effect/cgraph.scm 197 */
	      {		/* Effect/cgraph.scm 197 */
		 node_bglt aux_2021;
		 {	/* Effect/cgraph.scm 197 */
		    obj_t aux_2022;
		    aux_2022 =
		       CAR(l1504_860);
		    aux_2021 =
		       (node_bglt) (aux_2022);
		 }
		 call_graph__81_effect_cgraph(aux_2021, owner_41);
	      }
	      {
		 obj_t l1504_2026;
		 l1504_2026 =
		    CDR(l1504_860);
		 l1504_860 = l1504_2026;
		 goto lname1505_861;
	      }
	   }
	 else
	   {	/* Effect/cgraph.scm 197 */
	      return ((bool_t) 1);
	   }
      }
   }
}



/* get-var/side-effect */
obj_t 
get_var_side_effect_0_effect_cgraph()
{
   AN_OBJECT;
   {	/* Effect/cgraph.scm 241 */
      return _var_side_effect__143_effect_cgraph;
   }
}



/* _get-var/side-effect */
obj_t 
_get_var_side_effect_19_effect_cgraph(obj_t env_1781)
{
   AN_OBJECT;
   {	/* Effect/cgraph.scm 241 */
      return
	 get_var_side_effect_0_effect_cgraph();
   }
}



/* get-var/all */
obj_t 
get_var_all_239_effect_cgraph()
{
   AN_OBJECT;
   {	/* Effect/cgraph.scm 252 */
      return _var_all__30_effect_cgraph;
   }
}



/* _get-var/all */
obj_t 
_get_var_all_236_effect_cgraph(obj_t env_1782)
{
   AN_OBJECT;
   {	/* Effect/cgraph.scm 252 */
      return
	 get_var_all_239_effect_cgraph();
   }
}



/* reset-effect-tables! */
obj_t 
reset_effect_tables__151_effect_cgraph()
{
   AN_OBJECT;
   {	/* Effect/cgraph.scm 263 */
      _var_side_effect__143_effect_cgraph = BNIL;
      return (
	 _var_all__30_effect_cgraph = BNIL, BUNSPEC);
   }
}



/* _reset-effect-tables! */
obj_t 
_reset_effect_tables__191_effect_cgraph(obj_t env_1783)
{
   AN_OBJECT;
   {	/* Effect/cgraph.scm 263 */
      return
	 reset_effect_tables__151_effect_cgraph();
   }
}



/* mark-side-effect! */
obj_t 
mark_side_effect__61_effect_cgraph(variable_bglt v_54)
{
   AN_OBJECT;
   {	/* Effect/cgraph.scm 270 */
      {		/* Effect/cgraph.scm 272 */
	 value_bglt fun_865;
	 fun_865 =
	    (((variable_bglt) CREF(v_54))->value);
	 {	/* Effect/cgraph.scm 274 */
	    bool_t test_2032;
	    {	/* Effect/cgraph.scm 274 */
	       fun_bglt obj_1452;
	       obj_1452 =
		  (fun_bglt) (fun_865);
	       {	/* ./Ast/var.scm 702 */
		  obj_t aux_2034;
		  aux_2034 =
		     (((fun_bglt) CREF(obj_1452))->side_effect__165);
		  test_2032 =
		     CBOOL(aux_2034);
	       }
	    }
	    if (test_2032)
	      {		/* Effect/cgraph.scm 277 */
		 bool_t test1581_867;
		 {	/* Effect/cgraph.scm 277 */
		    obj_t aux_2037;
		    aux_2037 =
		       memq___r4_pairs_and_lists_6_3(
		       (obj_t) (v_54), _var_side_effect__143_effect_cgraph);
		    test1581_867 =
		       CBOOL(aux_2037);
		 }
		 if (test1581_867)
		   {	/* Effect/cgraph.scm 277 */
		      return
			 CNST_TABLE_REF(((long) 0));
		   }
		 else
		   {	/* Effect/cgraph.scm 277 */
		      {		/* Effect/cgraph.scm 278 */
			 obj_t obj2_1454;
			 obj2_1454 = _var_side_effect__143_effect_cgraph;
			 {	/* ./Ieee/pair-list.scm 5689 */
			    obj_t aux_2043;
			    aux_2043 =
			       (obj_t) (v_54);
			    return (
			       _var_side_effect__143_effect_cgraph =
			       MAKE_PAIR(aux_2043, obj2_1454), BUNSPEC);
			 }
		      }
		   }
	      }
	    else
	      {		/* Effect/cgraph.scm 274 */
		 {	/* Effect/cgraph.scm 275 */
		    obj_t obj2_1456;
		    obj2_1456 = _var_side_effect__143_effect_cgraph;
		    {	/* ./Ieee/pair-list.scm 5689 */
		       obj_t aux_2046;
		       aux_2046 =
			  (obj_t) (v_54);
		       _var_side_effect__143_effect_cgraph =
			  MAKE_PAIR(aux_2046, obj2_1456);
		    }
		 }
		 {	/* Effect/cgraph.scm 276 */
		    fun_bglt obj_1457;
		    obj_t val1102_1458;
		    obj_1457 =
		       (fun_bglt) (fun_865);
		    val1102_1458 = BTRUE;
		    return
		       ((((fun_bglt) CREF(obj_1457))->side_effect__165) = ((obj_t) val1102_1458), BUNSPEC);
		 }
	      }
	 }
      }
   }
}



/* object-init */
obj_t 
object_init_111_effect_cgraph()
{
   AN_OBJECT;
   {	/* Effect/cgraph.scm 14 */
      {		/* Effect/cgraph.scm 14 */
	 obj_t arg1582_868;
	 obj_t arg1583_869;
	 obj_t arg1586_872;
	 arg1582_868 =
	    CNST_TABLE_REF(((long) 1));
	 arg1583_869 = local_ast_var;
	 {	/* Effect/cgraph.scm 14 */
	    obj_t v1512_873;
	    v1512_873 =
	       create_vector(((long) 0));
	    arg1586_872 = v1512_873;
	 }
	 local_from_91_effect_cgraph =
	    register_class__225___object(arg1582_868, arg1583_869, allocate_local_from_env_235_effect_cgraph, ((long) 28402), BUNSPEC, BFALSE, arg1586_872);
      }
      {		/* Effect/cgraph.scm 14 */
	 obj_t arg1587_874;
	 obj_t arg1588_875;
	 obj_t arg1591_878;
	 arg1587_874 =
	    CNST_TABLE_REF(((long) 2));
	 arg1588_875 = global_ast_var;
	 {	/* Effect/cgraph.scm 14 */
	    obj_t v1513_879;
	    v1513_879 =
	       create_vector(((long) 0));
	    arg1591_878 = v1513_879;
	 }
	 global_from_205_effect_cgraph =
	    register_class__225___object(arg1587_874, arg1588_875, allocate_global_from_env_89_effect_cgraph, ((long) 53296), BUNSPEC, BFALSE, arg1591_878);
      }
      return BUNSPEC;
   }
}



/* allocate-global/from */
global_bglt 
allocate_global_from_170_effect_cgraph()
{
   AN_OBJECT;
   {	/* Effect/cgraph.scm 20 */
      {		/* Effect/cgraph.scm 20 */
	 global_bglt new1477_880;
	 new1477_880 =
	    ((global_bglt) BREF(GC_MALLOC(sizeof(struct global))));
	 {	/* Effect/cgraph.scm 20 */
	    long arg1592_881;
	    arg1592_881 =
	       class_num_218___object(global_from_205_effect_cgraph);
	    {	/* Effect/cgraph.scm 20 */
	       obj_t obj_1459;
	       obj_1459 =
		  (obj_t) (new1477_880);
	       (((obj_t) CREF(obj_1459))->header = MAKE_HEADER(arg1592_881, 0), BUNSPEC);
	    }
	 }
	 {	/* Effect/cgraph.scm 20 */
	    object_bglt aux_2061;
	    aux_2061 =
	       (object_bglt) (new1477_880);
	    OBJECT_WIDENING_SET(aux_2061, BFALSE);
	 }
	 return new1477_880;
      }
   }
}



/* _allocate-global/from */
obj_t 
_allocate_global_from_157_effect_cgraph(obj_t env_1785)
{
   AN_OBJECT;
   {	/* Effect/cgraph.scm 20 */
      {		/* Effect/cgraph.scm 20 */
	 global_bglt aux_2064;
	 aux_2064 =
	    allocate_global_from_170_effect_cgraph();
	 return
	    (obj_t) (aux_2064);
      }
   }
}



/* global/from? */
bool_t 
global_from__222_effect_cgraph(obj_t obj_58)
{
   AN_OBJECT;
   {	/* Effect/cgraph.scm 20 */
      return
	 is_a__118___object(obj_58, global_from_205_effect_cgraph);
   }
}



/* _global/from? */
obj_t 
_global_from__164_effect_cgraph(obj_t env_1786, obj_t obj_1787)
{
   AN_OBJECT;
   {	/* Effect/cgraph.scm 20 */
      {		/* Effect/cgraph.scm 20 */
	 bool_t aux_2068;
	 aux_2068 =
	    global_from__222_effect_cgraph(obj_1787);
	 return
	    BBOOL(aux_2068);
      }
   }
}



/* widening-global/from */
global_from_205_bglt 
widening_global_from_27_effect_cgraph(obj_t from_59)
{
   AN_OBJECT;
   {	/* Effect/cgraph.scm 20 */
      {		/* Effect/cgraph.scm 20 */
	 global_from_205_bglt new1472_1461;
	 new1472_1461 =
	    ((global_from_205_bglt) BREF(GC_MALLOC(sizeof(struct global_from_205))));
	 ((((global_from_205_bglt) CREF(new1472_1461))->from) = ((obj_t) from_59), BUNSPEC);
	 return new1472_1461;
      }
   }
}



/* _widening-global/from */
obj_t 
_widening_global_from_137_effect_cgraph(obj_t env_1788, obj_t from_1789)
{
   AN_OBJECT;
   {	/* Effect/cgraph.scm 20 */
      {		/* Effect/cgraph.scm 20 */
	 global_from_205_bglt aux_2073;
	 aux_2073 =
	    widening_global_from_27_effect_cgraph(from_1789);
	 return
	    (obj_t) (aux_2073);
      }
   }
}



/* make-global/from */
global_from_205_bglt 
make_global_from_185_effect_cgraph(obj_t id_60, obj_t name_61, type_bglt type_62, value_bglt value_63, obj_t access_64, obj_t fast_alpha_7_65, obj_t removable_66, long occurrence_67, obj_t module_68, obj_t import_69, bool_t evaluable__248_70, bool_t library__255_71, bool_t user__32_72, obj_t pragma_73, obj_t src_74, obj_t from_75)
{
   AN_OBJECT;
   {	/* Effect/cgraph.scm 20 */
      {		/* Effect/cgraph.scm 20 */
	 global_bglt aux1475_1463;
	 {	/* Effect/cgraph.scm 20 */
	    global_bglt res1792_1501;
	    {	/* ./Ast/var.scm 672 */
	       global_bglt new1063_1482;
	       new1063_1482 =
		  ((global_bglt) BREF(GC_MALLOC(sizeof(struct global))));
	       {	/* ./Ast/var.scm 672 */
		  long arg1662_1483;
		  arg1662_1483 =
		     class_num_218___object(global_ast_var);
		  {	/* ./Ast/var.scm 672 */
		     obj_t obj_1499;
		     obj_1499 =
			(obj_t) (new1063_1482);
		     (((obj_t) CREF(obj_1499))->header = MAKE_HEADER(arg1662_1483, 0), BUNSPEC);
		  }
	       }
	       {	/* ./Ast/var.scm 672 */
		  object_bglt aux_2080;
		  aux_2080 =
		     (object_bglt) (new1063_1482);
		  OBJECT_WIDENING_SET(aux_2080, BFALSE);
	       }
	       ((((global_bglt) CREF(new1063_1482))->id) = ((obj_t) id_60), BUNSPEC);
	       ((((global_bglt) CREF(new1063_1482))->name) = ((obj_t) name_61), BUNSPEC);
	       ((((global_bglt) CREF(new1063_1482))->type) = ((type_bglt) type_62), BUNSPEC);
	       ((((global_bglt) CREF(new1063_1482))->value) = ((value_bglt) value_63), BUNSPEC);
	       ((((global_bglt) CREF(new1063_1482))->access) = ((obj_t) access_64), BUNSPEC);
	       ((((global_bglt) CREF(new1063_1482))->fast_alpha_7) = ((obj_t) fast_alpha_7_65), BUNSPEC);
	       ((((global_bglt) CREF(new1063_1482))->removable) = ((obj_t) removable_66), BUNSPEC);
	       ((((global_bglt) CREF(new1063_1482))->occurrence) = ((long) occurrence_67), BUNSPEC);
	       ((((global_bglt) CREF(new1063_1482))->module) = ((obj_t) module_68), BUNSPEC);
	       ((((global_bglt) CREF(new1063_1482))->import) = ((obj_t) import_69), BUNSPEC);
	       ((((global_bglt) CREF(new1063_1482))->evaluable__248) = ((bool_t) evaluable__248_70), BUNSPEC);
	       ((((global_bglt) CREF(new1063_1482))->library__255) = ((bool_t) library__255_71), BUNSPEC);
	       ((((global_bglt) CREF(new1063_1482))->user__32) = ((bool_t) user__32_72), BUNSPEC);
	       ((((global_bglt) CREF(new1063_1482))->pragma) = ((obj_t) pragma_73), BUNSPEC);
	       ((((global_bglt) CREF(new1063_1482))->src) = ((obj_t) src_74), BUNSPEC);
	       res1792_1501 = new1063_1482;
	    }
	    aux1475_1463 = res1792_1501;
	 }
	 {	/* Effect/cgraph.scm 20 */
	    global_from_205_bglt new1476_1464;
	    new1476_1464 =
	       ((global_from_205_bglt) (aux1475_1463));
	    {	/* Effect/cgraph.scm 20 */
	       long arg1593_1465;
	       arg1593_1465 =
		  class_num_218___object(global_from_205_effect_cgraph);
	       {	/* Effect/cgraph.scm 20 */
		  obj_t obj_1502;
		  obj_1502 =
		     (obj_t) (new1476_1464);
		  (((obj_t) CREF(obj_1502))->header = MAKE_HEADER(arg1593_1465, 0), BUNSPEC);
	       }
	    }
	    {	/* Effect/cgraph.scm 20 */
	       global_from_205_bglt arg1594_1466;
	       {	/* Effect/cgraph.scm 20 */
		  global_from_205_bglt res1793_1507;
		  {	/* Effect/cgraph.scm 20 */
		     global_from_205_bglt new1472_1505;
		     new1472_1505 =
			((global_from_205_bglt) BREF(GC_MALLOC(sizeof(struct global_from_205))));
		     ((((global_from_205_bglt) CREF(new1472_1505))->from) = ((obj_t) from_75), BUNSPEC);
		     res1793_1507 = new1472_1505;
		  }
		  arg1594_1466 = res1793_1507;
	       }
	       {	/* Effect/cgraph.scm 20 */
		  obj_t aux_2106;
		  object_bglt aux_2104;
		  aux_2106 =
		     (obj_t) (arg1594_1466);
		  aux_2104 =
		     (object_bglt) (new1476_1464);
		  OBJECT_WIDENING_SET(aux_2104, aux_2106);
	       }
	    }
	    return new1476_1464;
	 }
      }
   }
}



/* _make-global/from */
obj_t 
_make_global_from_242_effect_cgraph(obj_t env_1790, obj_t id_1791, obj_t name_1792, obj_t type_1793, obj_t value_1794, obj_t access_1795, obj_t fast_alpha_7_1796, obj_t removable_1797, obj_t occurrence_1798, obj_t module_1799, obj_t import_1800, obj_t evaluable__248_1801, obj_t library__255_1802, obj_t user__32_1803, obj_t pragma_1804, obj_t src_1805, obj_t from_1806)
{
   AN_OBJECT;
   {	/* Effect/cgraph.scm 20 */
      {		/* Effect/cgraph.scm 20 */
	 global_from_205_bglt aux_2109;
	 aux_2109 =
	    make_global_from_185_effect_cgraph(id_1791, name_1792,
	    (type_bglt) (type_1793),
	    (value_bglt) (value_1794), access_1795, fast_alpha_7_1796, removable_1797,
	    (long) CINT(occurrence_1798), module_1799, import_1800,
	    CBOOL(evaluable__248_1801),
	    CBOOL(library__255_1802),
	    CBOOL(user__32_1803), pragma_1804, src_1805, from_1806);
	 return
	    (obj_t) (aux_2109);
      }
   }
}



/* global/from-id */
obj_t 
global_from_id_148_effect_cgraph(global_bglt obj_76)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 651 */
      return
	 (((global_bglt) CREF(obj_76))->id);
   }
}



/* _global/from-id */
obj_t 
_global_from_id_145_effect_cgraph(obj_t env_1807, obj_t obj_1808)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 651 */
      return
	 global_from_id_148_effect_cgraph(
	 (global_bglt) (obj_1808));
   }
}



/* global/from-name-set! */
obj_t 
global_from_name_set__93_effect_cgraph(global_bglt obj_77, obj_t val1459_78)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 653 */
      return
	 ((((global_bglt) CREF(obj_77))->name) = ((obj_t) val1459_78), BUNSPEC);
   }
}



/* _global/from-name-set! */
obj_t 
_global_from_name_set__215_effect_cgraph(obj_t env_1809, obj_t obj_1810, obj_t val1459_1811)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 653 */
      return
	 global_from_name_set__93_effect_cgraph(
	 (global_bglt) (obj_1810), val1459_1811);
   }
}



/* global/from-name */
obj_t 
global_from_name_15_effect_cgraph(global_bglt obj_79)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 653 */
      return
	 (((global_bglt) CREF(obj_79))->name);
   }
}



/* _global/from-name */
obj_t 
_global_from_name_66_effect_cgraph(obj_t env_1812, obj_t obj_1813)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 653 */
      return
	 global_from_name_15_effect_cgraph(
	 (global_bglt) (obj_1813));
   }
}



/* global/from-type-set! */
obj_t 
global_from_type_set__45_effect_cgraph(global_bglt obj_80, type_bglt val1460_81)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 655 */
      return
	 ((((global_bglt) CREF(obj_80))->type) = ((type_bglt) val1460_81), BUNSPEC);
   }
}



/* _global/from-type-set! */
obj_t 
_global_from_type_set__148_effect_cgraph(obj_t env_1814, obj_t obj_1815, obj_t val1460_1816)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 655 */
      return
	 global_from_type_set__45_effect_cgraph(
	 (global_bglt) (obj_1815),
	 (type_bglt) (val1460_1816));
   }
}



/* global/from-type */
type_bglt 
global_from_type_150_effect_cgraph(global_bglt obj_82)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 655 */
      return
	 (((global_bglt) CREF(obj_82))->type);
   }
}



/* _global/from-type */
obj_t 
_global_from_type_149_effect_cgraph(obj_t env_1817, obj_t obj_1818)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 655 */
      {		/* ./Ast/var.scm 655 */
	 type_bglt aux_2132;
	 aux_2132 =
	    global_from_type_150_effect_cgraph(
	    (global_bglt) (obj_1818));
	 return
	    (obj_t) (aux_2132);
      }
   }
}



/* global/from-value-set! */
obj_t 
global_from_value_set__85_effect_cgraph(global_bglt obj_83, value_bglt val1461_84)
{
   AN_OBJECT;
   {	/* Effect/cgraph.scm 20 */
      return
	 ((((global_bglt) CREF(obj_83))->value) = ((value_bglt) val1461_84), BUNSPEC);
   }
}



/* _global/from-value-set! */
obj_t 
_global_from_value_set__145_effect_cgraph(obj_t env_1819, obj_t obj_1820, obj_t val1461_1821)
{
   AN_OBJECT;
   {	/* Effect/cgraph.scm 20 */
      return
	 global_from_value_set__85_effect_cgraph(
	 (global_bglt) (obj_1820),
	 (value_bglt) (val1461_1821));
   }
}



/* global/from-value */
value_bglt 
global_from_value_26_effect_cgraph(global_bglt obj_85)
{
   AN_OBJECT;
   {	/* Effect/cgraph.scm 20 */
      return
	 (((global_bglt) CREF(obj_85))->value);
   }
}



/* _global/from-value */
obj_t 
_global_from_value_186_effect_cgraph(obj_t env_1822, obj_t obj_1823)
{
   AN_OBJECT;
   {	/* Effect/cgraph.scm 20 */
      {		/* Effect/cgraph.scm 20 */
	 value_bglt aux_2141;
	 aux_2141 =
	    global_from_value_26_effect_cgraph(
	    (global_bglt) (obj_1823));
	 return
	    (obj_t) (aux_2141);
      }
   }
}



/* global/from-access-set! */
obj_t 
global_from_access_set__164_effect_cgraph(global_bglt obj_86, obj_t val1462_87)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 659 */
      return
	 ((((global_bglt) CREF(obj_86))->access) = ((obj_t) val1462_87), BUNSPEC);
   }
}



/* _global/from-access-set! */
obj_t 
_global_from_access_set__7_effect_cgraph(obj_t env_1824, obj_t obj_1825, obj_t val1462_1826)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 659 */
      return
	 global_from_access_set__164_effect_cgraph(
	 (global_bglt) (obj_1825), val1462_1826);
   }
}



/* global/from-access */
obj_t 
global_from_access_80_effect_cgraph(global_bglt obj_88)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 659 */
      return
	 (((global_bglt) CREF(obj_88))->access);
   }
}



/* _global/from-access */
obj_t 
_global_from_access_171_effect_cgraph(obj_t env_1827, obj_t obj_1828)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 659 */
      return
	 global_from_access_80_effect_cgraph(
	 (global_bglt) (obj_1828));
   }
}



/* global/from-fast-alpha-set! */
obj_t 
global_from_fast_alpha_set__42_effect_cgraph(global_bglt obj_89, obj_t val1463_90)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 666 */
      return
	 ((((global_bglt) CREF(obj_89))->fast_alpha_7) = ((obj_t) val1463_90), BUNSPEC);
   }
}



/* _global/from-fast-alpha-set! */
obj_t 
_global_from_fast_alpha_set__161_effect_cgraph(obj_t env_1829, obj_t obj_1830, obj_t val1463_1831)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 666 */
      return
	 global_from_fast_alpha_set__42_effect_cgraph(
	 (global_bglt) (obj_1830), val1463_1831);
   }
}



/* global/from-fast-alpha */
obj_t 
global_from_fast_alpha_93_effect_cgraph(global_bglt obj_91)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 666 */
      return
	 (((global_bglt) CREF(obj_91))->fast_alpha_7);
   }
}



/* _global/from-fast-alpha */
obj_t 
_global_from_fast_alpha_10_effect_cgraph(obj_t env_1832, obj_t obj_1833)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 666 */
      return
	 global_from_fast_alpha_93_effect_cgraph(
	 (global_bglt) (obj_1833));
   }
}



/* global/from-removable-set! */
obj_t 
global_from_removable_set__176_effect_cgraph(global_bglt obj_92, obj_t val1464_93)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 668 */
      return
	 ((((global_bglt) CREF(obj_92))->removable) = ((obj_t) val1464_93), BUNSPEC);
   }
}



/* _global/from-removable-set! */
obj_t 
_global_from_removable_set__80_effect_cgraph(obj_t env_1834, obj_t obj_1835, obj_t val1464_1836)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 668 */
      return
	 global_from_removable_set__176_effect_cgraph(
	 (global_bglt) (obj_1835), val1464_1836);
   }
}



/* global/from-removable */
obj_t 
global_from_removable_194_effect_cgraph(global_bglt obj_94)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 668 */
      return
	 (((global_bglt) CREF(obj_94))->removable);
   }
}



/* _global/from-removable */
obj_t 
_global_from_removable_24_effect_cgraph(obj_t env_1837, obj_t obj_1838)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 668 */
      return
	 global_from_removable_194_effect_cgraph(
	 (global_bglt) (obj_1838));
   }
}



/* global/from-occurrence-set! */
obj_t 
global_from_occurrence_set__12_effect_cgraph(global_bglt obj_95, long val1465_96)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 670 */
      return
	 ((((global_bglt) CREF(obj_95))->occurrence) = ((long) val1465_96), BUNSPEC);
   }
}



/* _global/from-occurrence-set! */
obj_t 
_global_from_occurrence_set__250_effect_cgraph(obj_t env_1839, obj_t obj_1840, obj_t val1465_1841)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 670 */
      return
	 global_from_occurrence_set__12_effect_cgraph(
	 (global_bglt) (obj_1840),
	 (long) CINT(val1465_1841));
   }
}



/* global/from-occurrence */
long 
global_from_occurrence_204_effect_cgraph(global_bglt obj_97)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 670 */
      return
	 (((global_bglt) CREF(obj_97))->occurrence);
   }
}



/* _global/from-occurrence */
obj_t 
_global_from_occurrence_212_effect_cgraph(obj_t env_1842, obj_t obj_1843)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 670 */
      {		/* ./Ast/var.scm 670 */
	 long aux_2168;
	 aux_2168 =
	    global_from_occurrence_204_effect_cgraph(
	    (global_bglt) (obj_1843));
	 return
	    BINT(aux_2168);
      }
   }
}



/* global/from-module */
obj_t 
global_from_module_199_effect_cgraph(global_bglt obj_98)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 674 */
      return
	 (((global_bglt) CREF(obj_98))->module);
   }
}



/* _global/from-module */
obj_t 
_global_from_module_160_effect_cgraph(obj_t env_1844, obj_t obj_1845)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 674 */
      return
	 global_from_module_199_effect_cgraph(
	 (global_bglt) (obj_1845));
   }
}



/* global/from-import-set! */
obj_t 
global_from_import_set__85_effect_cgraph(global_bglt obj_99, obj_t val1466_100)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 676 */
      return
	 ((((global_bglt) CREF(obj_99))->import) = ((obj_t) val1466_100), BUNSPEC);
   }
}



/* _global/from-import-set! */
obj_t 
_global_from_import_set__37_effect_cgraph(obj_t env_1846, obj_t obj_1847, obj_t val1466_1848)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 676 */
      return
	 global_from_import_set__85_effect_cgraph(
	 (global_bglt) (obj_1847), val1466_1848);
   }
}



/* global/from-import */
obj_t 
global_from_import_26_effect_cgraph(global_bglt obj_101)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 676 */
      return
	 (((global_bglt) CREF(obj_101))->import);
   }
}



/* _global/from-import */
obj_t 
_global_from_import_184_effect_cgraph(obj_t env_1849, obj_t obj_1850)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 676 */
      return
	 global_from_import_26_effect_cgraph(
	 (global_bglt) (obj_1850));
   }
}



/* global/from-evaluable?-set! */
obj_t 
global_from_evaluable__set__132_effect_cgraph(global_bglt obj_102, bool_t val1467_103)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 679 */
      return
	 ((((global_bglt) CREF(obj_102))->evaluable__248) = ((bool_t) val1467_103), BUNSPEC);
   }
}



/* _global/from-evaluable?-set! */
obj_t 
_global_from_evaluable__set__180_effect_cgraph(obj_t env_1851, obj_t obj_1852, obj_t val1467_1853)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 679 */
      return
	 global_from_evaluable__set__132_effect_cgraph(
	 (global_bglt) (obj_1852),
	 CBOOL(val1467_1853));
   }
}



/* global/from-evaluable? */
bool_t 
global_from_evaluable__174_effect_cgraph(global_bglt obj_104)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 679 */
      return
	 (((global_bglt) CREF(obj_104))->evaluable__248);
   }
}



/* _global/from-evaluable? */
obj_t 
_global_from_evaluable__111_effect_cgraph(obj_t env_1854, obj_t obj_1855)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 679 */
      {		/* ./Ast/var.scm 679 */
	 bool_t aux_2186;
	 aux_2186 =
	    global_from_evaluable__174_effect_cgraph(
	    (global_bglt) (obj_1855));
	 return
	    BBOOL(aux_2186);
      }
   }
}



/* global/from-library?-set! */
obj_t 
global_from_library__set__21_effect_cgraph(global_bglt obj_105, bool_t val1468_106)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 681 */
      return
	 ((((global_bglt) CREF(obj_105))->library__255) = ((bool_t) val1468_106), BUNSPEC);
   }
}



/* _global/from-library?-set! */
obj_t 
_global_from_library__set__232_effect_cgraph(obj_t env_1856, obj_t obj_1857, obj_t val1468_1858)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 681 */
      return
	 global_from_library__set__21_effect_cgraph(
	 (global_bglt) (obj_1857),
	 CBOOL(val1468_1858));
   }
}



/* global/from-library? */
bool_t 
global_from_library__57_effect_cgraph(global_bglt obj_107)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 681 */
      return
	 (((global_bglt) CREF(obj_107))->library__255);
   }
}



/* _global/from-library? */
obj_t 
_global_from_library__143_effect_cgraph(obj_t env_1859, obj_t obj_1860)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 681 */
      {		/* ./Ast/var.scm 681 */
	 bool_t aux_2195;
	 aux_2195 =
	    global_from_library__57_effect_cgraph(
	    (global_bglt) (obj_1860));
	 return
	    BBOOL(aux_2195);
      }
   }
}



/* global/from-user?-set! */
obj_t 
global_from_user__set__38_effect_cgraph(global_bglt obj_108, bool_t val1469_109)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 686 */
      return
	 ((((global_bglt) CREF(obj_108))->user__32) = ((bool_t) val1469_109), BUNSPEC);
   }
}



/* _global/from-user?-set! */
obj_t 
_global_from_user__set__242_effect_cgraph(obj_t env_1861, obj_t obj_1862, obj_t val1469_1863)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 686 */
      return
	 global_from_user__set__38_effect_cgraph(
	 (global_bglt) (obj_1862),
	 CBOOL(val1469_1863));
   }
}



/* global/from-user? */
bool_t 
global_from_user__144_effect_cgraph(global_bglt obj_110)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 686 */
      return
	 (((global_bglt) CREF(obj_110))->user__32);
   }
}



/* _global/from-user? */
obj_t 
_global_from_user__183_effect_cgraph(obj_t env_1864, obj_t obj_1865)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 686 */
      {		/* ./Ast/var.scm 686 */
	 bool_t aux_2204;
	 aux_2204 =
	    global_from_user__144_effect_cgraph(
	    (global_bglt) (obj_1865));
	 return
	    BBOOL(aux_2204);
      }
   }
}



/* global/from-pragma */
obj_t 
global_from_pragma_13_effect_cgraph(global_bglt obj_111)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 688 */
      return
	 (((global_bglt) CREF(obj_111))->pragma);
   }
}



/* _global/from-pragma */
obj_t 
_global_from_pragma_164_effect_cgraph(obj_t env_1866, obj_t obj_1867)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 688 */
      return
	 global_from_pragma_13_effect_cgraph(
	 (global_bglt) (obj_1867));
   }
}



/* global/from-src-set! */
obj_t 
global_from_src_set__208_effect_cgraph(global_bglt obj_112, obj_t val1470_113)
{
   AN_OBJECT;
   {	/* Effect/cgraph.scm 20 */
      return
	 ((((global_bglt) CREF(obj_112))->src) = ((obj_t) val1470_113), BUNSPEC);
   }
}



/* _global/from-src-set! */
obj_t 
_global_from_src_set__107_effect_cgraph(obj_t env_1868, obj_t obj_1869, obj_t val1470_1870)
{
   AN_OBJECT;
   {	/* Effect/cgraph.scm 20 */
      return
	 global_from_src_set__208_effect_cgraph(
	 (global_bglt) (obj_1869), val1470_1870);
   }
}



/* global/from-src */
obj_t 
global_from_src_107_effect_cgraph(global_bglt obj_114)
{
   AN_OBJECT;
   {	/* Effect/cgraph.scm 20 */
      return
	 (((global_bglt) CREF(obj_114))->src);
   }
}



/* _global/from-src */
obj_t 
_global_from_src_128_effect_cgraph(obj_t env_1871, obj_t obj_1872)
{
   AN_OBJECT;
   {	/* Effect/cgraph.scm 20 */
      return
	 global_from_src_107_effect_cgraph(
	 (global_bglt) (obj_1872));
   }
}



/* global/from-from-set! */
obj_t 
global_from_from_set__167_effect_cgraph(global_from_205_bglt obj_115, obj_t val1471_116)
{
   AN_OBJECT;
   {	/* Effect/cgraph.scm 20 */
      {
	 obj_t aux_2217;
	 {	/* Effect/cgraph.scm 20 */
	    object_bglt aux_2218;
	    aux_2218 =
	       (object_bglt) (obj_115);
	    aux_2217 =
	       OBJECT_WIDENING(aux_2218);
	 }
	 return
	    ((((global_from_205_bglt) CREF(aux_2217))->from) = ((obj_t) val1471_116), BUNSPEC);
      }
   }
}



/* _global/from-from-set! */
obj_t 
_global_from_from_set__151_effect_cgraph(obj_t env_1873, obj_t obj_1874, obj_t val1471_1875)
{
   AN_OBJECT;
   {	/* Effect/cgraph.scm 20 */
      return
	 global_from_from_set__167_effect_cgraph(
	 (global_from_205_bglt) (obj_1874), val1471_1875);
   }
}



/* global/from-from */
obj_t 
global_from_from_91_effect_cgraph(global_from_205_bglt obj_117)
{
   AN_OBJECT;
   {	/* Effect/cgraph.scm 20 */
      {
	 obj_t aux_2224;
	 {	/* Effect/cgraph.scm 20 */
	    object_bglt aux_2225;
	    aux_2225 =
	       (object_bglt) (obj_117);
	    aux_2224 =
	       OBJECT_WIDENING(aux_2225);
	 }
	 return
	    (((global_from_205_bglt) CREF(aux_2224))->from);
      }
   }
}



/* _global/from-from */
obj_t 
_global_from_from_34_effect_cgraph(obj_t env_1876, obj_t obj_1877)
{
   AN_OBJECT;
   {	/* Effect/cgraph.scm 20 */
      return
	 global_from_from_91_effect_cgraph(
	 (global_from_205_bglt) (obj_1877));
   }
}



/* allocate-local/from */
local_bglt 
allocate_local_from_4_effect_cgraph()
{
   AN_OBJECT;
   {	/* Effect/cgraph.scm 19 */
      {		/* Effect/cgraph.scm 19 */
	 local_bglt new1451_888;
	 new1451_888 =
	    ((local_bglt) BREF(GC_MALLOC(sizeof(struct local))));
	 {	/* Effect/cgraph.scm 19 */
	    long arg1595_889;
	    arg1595_889 =
	       class_num_218___object(local_from_91_effect_cgraph);
	    {	/* Effect/cgraph.scm 19 */
	       obj_t obj_1508;
	       obj_1508 =
		  (obj_t) (new1451_888);
	       (((obj_t) CREF(obj_1508))->header = MAKE_HEADER(arg1595_889, 0), BUNSPEC);
	    }
	 }
	 {	/* Effect/cgraph.scm 19 */
	    object_bglt aux_2235;
	    aux_2235 =
	       (object_bglt) (new1451_888);
	    OBJECT_WIDENING_SET(aux_2235, BFALSE);
	 }
	 return new1451_888;
      }
   }
}



/* _allocate-local/from */
obj_t 
_allocate_local_from_49_effect_cgraph(obj_t env_1784)
{
   AN_OBJECT;
   {	/* Effect/cgraph.scm 19 */
      {		/* Effect/cgraph.scm 19 */
	 local_bglt aux_2238;
	 aux_2238 =
	    allocate_local_from_4_effect_cgraph();
	 return
	    (obj_t) (aux_2238);
      }
   }
}



/* local/from? */
bool_t 
local_from__82_effect_cgraph(obj_t obj_121)
{
   AN_OBJECT;
   {	/* Effect/cgraph.scm 19 */
      return
	 is_a__118___object(obj_121, local_from_91_effect_cgraph);
   }
}



/* _local/from? */
obj_t 
_local_from__225_effect_cgraph(obj_t env_1878, obj_t obj_1879)
{
   AN_OBJECT;
   {	/* Effect/cgraph.scm 19 */
      {		/* Effect/cgraph.scm 19 */
	 bool_t aux_2242;
	 aux_2242 =
	    local_from__82_effect_cgraph(obj_1879);
	 return
	    BBOOL(aux_2242);
      }
   }
}



/* widening-local/from */
local_from_91_bglt 
widening_local_from_161_effect_cgraph(obj_t from_122)
{
   AN_OBJECT;
   {	/* Effect/cgraph.scm 19 */
      {		/* Effect/cgraph.scm 19 */
	 local_from_91_bglt new1446_1510;
	 new1446_1510 =
	    ((local_from_91_bglt) BREF(GC_MALLOC(sizeof(struct local_from_91))));
	 ((((local_from_91_bglt) CREF(new1446_1510))->from) = ((obj_t) from_122), BUNSPEC);
	 return new1446_1510;
      }
   }
}



/* _widening-local/from */
obj_t 
_widening_local_from_224_effect_cgraph(obj_t env_1880, obj_t from_1881)
{
   AN_OBJECT;
   {	/* Effect/cgraph.scm 19 */
      {		/* Effect/cgraph.scm 19 */
	 local_from_91_bglt aux_2247;
	 aux_2247 =
	    widening_local_from_161_effect_cgraph(from_1881);
	 return
	    (obj_t) (aux_2247);
      }
   }
}



/* make-local/from */
local_from_91_bglt 
make_local_from_27_effect_cgraph(obj_t id_123, obj_t name_124, type_bglt type_125, value_bglt value_126, obj_t access_127, obj_t fast_alpha_7_128, obj_t removable_129, long occurrence_130, bool_t user__32_131, long key_132, obj_t from_133)
{
   AN_OBJECT;
   {	/* Effect/cgraph.scm 19 */
      {		/* Effect/cgraph.scm 19 */
	 local_bglt aux1449_1512;
	 {	/* Effect/cgraph.scm 19 */
	    local_bglt res1794_1540;
	    {	/* ./Ast/var.scm 692 */
	       local_bglt new1089_1526;
	       new1089_1526 =
		  ((local_bglt) BREF(GC_MALLOC(sizeof(struct local))));
	       {	/* ./Ast/var.scm 692 */
		  long arg1660_1527;
		  arg1660_1527 =
		     class_num_218___object(local_ast_var);
		  {	/* ./Ast/var.scm 692 */
		     obj_t obj_1538;
		     obj_1538 =
			(obj_t) (new1089_1526);
		     (((obj_t) CREF(obj_1538))->header = MAKE_HEADER(arg1660_1527, 0), BUNSPEC);
		  }
	       }
	       {	/* ./Ast/var.scm 692 */
		  object_bglt aux_2254;
		  aux_2254 =
		     (object_bglt) (new1089_1526);
		  OBJECT_WIDENING_SET(aux_2254, BFALSE);
	       }
	       ((((local_bglt) CREF(new1089_1526))->id) = ((obj_t) id_123), BUNSPEC);
	       ((((local_bglt) CREF(new1089_1526))->name) = ((obj_t) name_124), BUNSPEC);
	       ((((local_bglt) CREF(new1089_1526))->type) = ((type_bglt) type_125), BUNSPEC);
	       ((((local_bglt) CREF(new1089_1526))->value) = ((value_bglt) value_126), BUNSPEC);
	       ((((local_bglt) CREF(new1089_1526))->access) = ((obj_t) access_127), BUNSPEC);
	       ((((local_bglt) CREF(new1089_1526))->fast_alpha_7) = ((obj_t) fast_alpha_7_128), BUNSPEC);
	       ((((local_bglt) CREF(new1089_1526))->removable) = ((obj_t) removable_129), BUNSPEC);
	       ((((local_bglt) CREF(new1089_1526))->occurrence) = ((long) occurrence_130), BUNSPEC);
	       ((((local_bglt) CREF(new1089_1526))->user__32) = ((bool_t) user__32_131), BUNSPEC);
	       ((((local_bglt) CREF(new1089_1526))->key) = ((long) key_132), BUNSPEC);
	       res1794_1540 = new1089_1526;
	    }
	    aux1449_1512 = res1794_1540;
	 }
	 {	/* Effect/cgraph.scm 19 */
	    local_from_91_bglt new1450_1513;
	    new1450_1513 =
	       ((local_from_91_bglt) (aux1449_1512));
	    {	/* Effect/cgraph.scm 19 */
	       long arg1596_1514;
	       arg1596_1514 =
		  class_num_218___object(local_from_91_effect_cgraph);
	       {	/* Effect/cgraph.scm 19 */
		  obj_t obj_1541;
		  obj_1541 =
		     (obj_t) (new1450_1513);
		  (((obj_t) CREF(obj_1541))->header = MAKE_HEADER(arg1596_1514, 0), BUNSPEC);
	       }
	    }
	    {	/* Effect/cgraph.scm 19 */
	       local_from_91_bglt arg1597_1515;
	       {	/* Effect/cgraph.scm 19 */
		  local_from_91_bglt res1795_1546;
		  {	/* Effect/cgraph.scm 19 */
		     local_from_91_bglt new1446_1544;
		     new1446_1544 =
			((local_from_91_bglt) BREF(GC_MALLOC(sizeof(struct local_from_91))));
		     ((((local_from_91_bglt) CREF(new1446_1544))->from) = ((obj_t) from_133), BUNSPEC);
		     res1795_1546 = new1446_1544;
		  }
		  arg1597_1515 = res1795_1546;
	       }
	       {	/* Effect/cgraph.scm 19 */
		  obj_t aux_2275;
		  object_bglt aux_2273;
		  aux_2275 =
		     (obj_t) (arg1597_1515);
		  aux_2273 =
		     (object_bglt) (new1450_1513);
		  OBJECT_WIDENING_SET(aux_2273, aux_2275);
	       }
	    }
	    return new1450_1513;
	 }
      }
   }
}



/* _make-local/from */
obj_t 
_make_local_from_25_effect_cgraph(obj_t env_1882, obj_t id_1883, obj_t name_1884, obj_t type_1885, obj_t value_1886, obj_t access_1887, obj_t fast_alpha_7_1888, obj_t removable_1889, obj_t occurrence_1890, obj_t user__32_1891, obj_t key_1892, obj_t from_1893)
{
   AN_OBJECT;
   {	/* Effect/cgraph.scm 19 */
      {		/* Effect/cgraph.scm 19 */
	 local_from_91_bglt aux_2278;
	 aux_2278 =
	    make_local_from_27_effect_cgraph(id_1883, name_1884,
	    (type_bglt) (type_1885),
	    (value_bglt) (value_1886), access_1887, fast_alpha_7_1888, removable_1889,
	    (long) CINT(occurrence_1890),
	    CBOOL(user__32_1891),
	    (long) CINT(key_1892), from_1893);
	 return
	    (obj_t) (aux_2278);
      }
   }
}



/* local/from-id */
obj_t 
local_from_id_164_effect_cgraph(local_bglt obj_134)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 651 */
      return
	 (((local_bglt) CREF(obj_134))->id);
   }
}



/* _local/from-id */
obj_t 
_local_from_id_15_effect_cgraph(obj_t env_1894, obj_t obj_1895)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 651 */
      return
	 local_from_id_164_effect_cgraph(
	 (local_bglt) (obj_1895));
   }
}



/* local/from-name-set! */
obj_t 
local_from_name_set__39_effect_cgraph(local_bglt obj_135, obj_t val1437_136)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 653 */
      return
	 ((((local_bglt) CREF(obj_135))->name) = ((obj_t) val1437_136), BUNSPEC);
   }
}



/* _local/from-name-set! */
obj_t 
_local_from_name_set__71_effect_cgraph(obj_t env_1896, obj_t obj_1897, obj_t val1437_1898)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 653 */
      return
	 local_from_name_set__39_effect_cgraph(
	 (local_bglt) (obj_1897), val1437_1898);
   }
}



/* local/from-name */
obj_t 
local_from_name_69_effect_cgraph(local_bglt obj_137)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 653 */
      return
	 (((local_bglt) CREF(obj_137))->name);
   }
}



/* _local/from-name */
obj_t 
_local_from_name_196_effect_cgraph(obj_t env_1899, obj_t obj_1900)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 653 */
      return
	 local_from_name_69_effect_cgraph(
	 (local_bglt) (obj_1900));
   }
}



/* local/from-type-set! */
obj_t 
local_from_type_set__115_effect_cgraph(local_bglt obj_138, type_bglt val1438_139)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 655 */
      return
	 ((((local_bglt) CREF(obj_138))->type) = ((type_bglt) val1438_139), BUNSPEC);
   }
}



/* _local/from-type-set! */
obj_t 
_local_from_type_set__176_effect_cgraph(obj_t env_1901, obj_t obj_1902, obj_t val1438_1903)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 655 */
      return
	 local_from_type_set__115_effect_cgraph(
	 (local_bglt) (obj_1902),
	 (type_bglt) (val1438_1903));
   }
}



/* local/from-type */
type_bglt 
local_from_type_22_effect_cgraph(local_bglt obj_140)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 655 */
      return
	 (((local_bglt) CREF(obj_140))->type);
   }
}



/* _local/from-type */
obj_t 
_local_from_type_194_effect_cgraph(obj_t env_1904, obj_t obj_1905)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 655 */
      {		/* ./Ast/var.scm 655 */
	 type_bglt aux_2300;
	 aux_2300 =
	    local_from_type_22_effect_cgraph(
	    (local_bglt) (obj_1905));
	 return
	    (obj_t) (aux_2300);
      }
   }
}



/* local/from-value-set! */
obj_t 
local_from_value_set__238_effect_cgraph(local_bglt obj_141, value_bglt val1439_142)
{
   AN_OBJECT;
   {	/* Effect/cgraph.scm 19 */
      return
	 ((((local_bglt) CREF(obj_141))->value) = ((value_bglt) val1439_142), BUNSPEC);
   }
}



/* _local/from-value-set! */
obj_t 
_local_from_value_set__132_effect_cgraph(obj_t env_1906, obj_t obj_1907, obj_t val1439_1908)
{
   AN_OBJECT;
   {	/* Effect/cgraph.scm 19 */
      return
	 local_from_value_set__238_effect_cgraph(
	 (local_bglt) (obj_1907),
	 (value_bglt) (val1439_1908));
   }
}



/* local/from-value */
value_bglt 
local_from_value_53_effect_cgraph(local_bglt obj_143)
{
   AN_OBJECT;
   {	/* Effect/cgraph.scm 19 */
      return
	 (((local_bglt) CREF(obj_143))->value);
   }
}



/* _local/from-value */
obj_t 
_local_from_value_174_effect_cgraph(obj_t env_1909, obj_t obj_1910)
{
   AN_OBJECT;
   {	/* Effect/cgraph.scm 19 */
      {		/* Effect/cgraph.scm 19 */
	 value_bglt aux_2309;
	 aux_2309 =
	    local_from_value_53_effect_cgraph(
	    (local_bglt) (obj_1910));
	 return
	    (obj_t) (aux_2309);
      }
   }
}



/* local/from-access-set! */
obj_t 
local_from_access_set__145_effect_cgraph(local_bglt obj_144, obj_t val1440_145)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 659 */
      return
	 ((((local_bglt) CREF(obj_144))->access) = ((obj_t) val1440_145), BUNSPEC);
   }
}



/* _local/from-access-set! */
obj_t 
_local_from_access_set__198_effect_cgraph(obj_t env_1911, obj_t obj_1912, obj_t val1440_1913)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 659 */
      return
	 local_from_access_set__145_effect_cgraph(
	 (local_bglt) (obj_1912), val1440_1913);
   }
}



/* local/from-access */
obj_t 
local_from_access_186_effect_cgraph(local_bglt obj_146)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 659 */
      return
	 (((local_bglt) CREF(obj_146))->access);
   }
}



/* _local/from-access */
obj_t 
_local_from_access_219_effect_cgraph(obj_t env_1914, obj_t obj_1915)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 659 */
      return
	 local_from_access_186_effect_cgraph(
	 (local_bglt) (obj_1915));
   }
}



/* local/from-fast-alpha-set! */
obj_t 
local_from_fast_alpha_set__165_effect_cgraph(local_bglt obj_147, obj_t val1441_148)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 666 */
      return
	 ((((local_bglt) CREF(obj_147))->fast_alpha_7) = ((obj_t) val1441_148), BUNSPEC);
   }
}



/* _local/from-fast-alpha-set! */
obj_t 
_local_from_fast_alpha_set__212_effect_cgraph(obj_t env_1916, obj_t obj_1917, obj_t val1441_1918)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 666 */
      return
	 local_from_fast_alpha_set__165_effect_cgraph(
	 (local_bglt) (obj_1917), val1441_1918);
   }
}



/* local/from-fast-alpha */
obj_t 
local_from_fast_alpha_88_effect_cgraph(local_bglt obj_149)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 666 */
      return
	 (((local_bglt) CREF(obj_149))->fast_alpha_7);
   }
}



/* _local/from-fast-alpha */
obj_t 
_local_from_fast_alpha_3_effect_cgraph(obj_t env_1919, obj_t obj_1920)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 666 */
      return
	 local_from_fast_alpha_88_effect_cgraph(
	 (local_bglt) (obj_1920));
   }
}



/* local/from-removable-set! */
obj_t 
local_from_removable_set__109_effect_cgraph(local_bglt obj_150, obj_t val1442_151)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 668 */
      return
	 ((((local_bglt) CREF(obj_150))->removable) = ((obj_t) val1442_151), BUNSPEC);
   }
}



/* _local/from-removable-set! */
obj_t 
_local_from_removable_set__173_effect_cgraph(obj_t env_1921, obj_t obj_1922, obj_t val1442_1923)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 668 */
      return
	 local_from_removable_set__109_effect_cgraph(
	 (local_bglt) (obj_1922), val1442_1923);
   }
}



/* local/from-removable */
obj_t 
local_from_removable_243_effect_cgraph(local_bglt obj_152)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 668 */
      return
	 (((local_bglt) CREF(obj_152))->removable);
   }
}



/* _local/from-removable */
obj_t 
_local_from_removable_239_effect_cgraph(obj_t env_1924, obj_t obj_1925)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 668 */
      return
	 local_from_removable_243_effect_cgraph(
	 (local_bglt) (obj_1925));
   }
}



/* local/from-occurrence-set! */
obj_t 
local_from_occurrence_set__59_effect_cgraph(local_bglt obj_153, long val1443_154)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 670 */
      return
	 ((((local_bglt) CREF(obj_153))->occurrence) = ((long) val1443_154), BUNSPEC);
   }
}



/* _local/from-occurrence-set! */
obj_t 
_local_from_occurrence_set__202_effect_cgraph(obj_t env_1926, obj_t obj_1927, obj_t val1443_1928)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 670 */
      return
	 local_from_occurrence_set__59_effect_cgraph(
	 (local_bglt) (obj_1927),
	 (long) CINT(val1443_1928));
   }
}



/* local/from-occurrence */
long 
local_from_occurrence_155_effect_cgraph(local_bglt obj_155)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 670 */
      return
	 (((local_bglt) CREF(obj_155))->occurrence);
   }
}



/* _local/from-occurrence */
obj_t 
_local_from_occurrence_27_effect_cgraph(obj_t env_1929, obj_t obj_1930)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 670 */
      {		/* ./Ast/var.scm 670 */
	 long aux_2336;
	 aux_2336 =
	    local_from_occurrence_155_effect_cgraph(
	    (local_bglt) (obj_1930));
	 return
	    BINT(aux_2336);
      }
   }
}



/* local/from-user?-set! */
obj_t 
local_from_user__set__131_effect_cgraph(local_bglt obj_156, bool_t val1444_157)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 694 */
      return
	 ((((local_bglt) CREF(obj_156))->user__32) = ((bool_t) val1444_157), BUNSPEC);
   }
}



/* _local/from-user?-set! */
obj_t 
_local_from_user__set__49_effect_cgraph(obj_t env_1931, obj_t obj_1932, obj_t val1444_1933)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 694 */
      return
	 local_from_user__set__131_effect_cgraph(
	 (local_bglt) (obj_1932),
	 CBOOL(val1444_1933));
   }
}



/* local/from-user? */
bool_t 
local_from_user__236_effect_cgraph(local_bglt obj_158)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 694 */
      return
	 (((local_bglt) CREF(obj_158))->user__32);
   }
}



/* _local/from-user? */
obj_t 
_local_from_user__20_effect_cgraph(obj_t env_1934, obj_t obj_1935)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 694 */
      {		/* ./Ast/var.scm 694 */
	 bool_t aux_2345;
	 aux_2345 =
	    local_from_user__236_effect_cgraph(
	    (local_bglt) (obj_1935));
	 return
	    BBOOL(aux_2345);
      }
   }
}



/* local/from-key */
long 
local_from_key_203_effect_cgraph(local_bglt obj_159)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 696 */
      return
	 (((local_bglt) CREF(obj_159))->key);
   }
}



/* _local/from-key */
obj_t 
_local_from_key_127_effect_cgraph(obj_t env_1936, obj_t obj_1937)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 696 */
      {		/* ./Ast/var.scm 696 */
	 long aux_2350;
	 aux_2350 =
	    local_from_key_203_effect_cgraph(
	    (local_bglt) (obj_1937));
	 return
	    BINT(aux_2350);
      }
   }
}



/* local/from-from-set! */
obj_t 
local_from_from_set__181_effect_cgraph(local_from_91_bglt obj_160, obj_t val1445_161)
{
   AN_OBJECT;
   {	/* Effect/cgraph.scm 19 */
      {
	 obj_t aux_2354;
	 {	/* Effect/cgraph.scm 19 */
	    object_bglt aux_2355;
	    aux_2355 =
	       (object_bglt) (obj_160);
	    aux_2354 =
	       OBJECT_WIDENING(aux_2355);
	 }
	 return
	    ((((local_from_91_bglt) CREF(aux_2354))->from) = ((obj_t) val1445_161), BUNSPEC);
      }
   }
}



/* _local/from-from-set! */
obj_t 
_local_from_from_set__10_effect_cgraph(obj_t env_1938, obj_t obj_1939, obj_t val1445_1940)
{
   AN_OBJECT;
   {	/* Effect/cgraph.scm 19 */
      return
	 local_from_from_set__181_effect_cgraph(
	 (local_from_91_bglt) (obj_1939), val1445_1940);
   }
}



/* local/from-from */
obj_t 
local_from_from_185_effect_cgraph(local_from_91_bglt obj_162)
{
   AN_OBJECT;
   {	/* Effect/cgraph.scm 19 */
      {
	 obj_t aux_2361;
	 {	/* Effect/cgraph.scm 19 */
	    object_bglt aux_2362;
	    aux_2362 =
	       (object_bglt) (obj_162);
	    aux_2361 =
	       OBJECT_WIDENING(aux_2362);
	 }
	 return
	    (((local_from_91_bglt) CREF(aux_2361))->from);
      }
   }
}



/* _local/from-from */
obj_t 
_local_from_from_35_effect_cgraph(obj_t env_1941, obj_t obj_1942)
{
   AN_OBJECT;
   {	/* Effect/cgraph.scm 19 */
      return
	 local_from_from_185_effect_cgraph(
	 (local_from_91_bglt) (obj_1942));
   }
}



/* method-init */
obj_t 
method_init_76_effect_cgraph()
{
   AN_OBJECT;
   {	/* Effect/cgraph.scm 14 */
      add_generic__110___object(call_graph__env_226_effect_cgraph, call_graph__default1514_env_89_effect_cgraph);
      add_inlined_method__244___object(call_graph__env_226_effect_cgraph, sequence_ast_node, ((long) 0));
      add_inlined_method__244___object(call_graph__env_226_effect_cgraph, app_ast_node, ((long) 1));
      add_inlined_method__244___object(call_graph__env_226_effect_cgraph, app_ly_162_ast_node, ((long) 2));
      add_inlined_method__244___object(call_graph__env_226_effect_cgraph, funcall_ast_node, ((long) 3));
      add_inlined_method__244___object(call_graph__env_226_effect_cgraph, pragma_ast_node, ((long) 4));
      add_inlined_method__244___object(call_graph__env_226_effect_cgraph, cast_ast_node, ((long) 5));
      add_inlined_method__244___object(call_graph__env_226_effect_cgraph, setq_ast_node, ((long) 6));
      add_inlined_method__244___object(call_graph__env_226_effect_cgraph, conditional_ast_node, ((long) 7));
      add_inlined_method__244___object(call_graph__env_226_effect_cgraph, fail_ast_node, ((long) 8));
      add_inlined_method__244___object(call_graph__env_226_effect_cgraph, select_ast_node, ((long) 9));
      add_inlined_method__244___object(call_graph__env_226_effect_cgraph, let_fun_218_ast_node, ((long) 10));
      add_inlined_method__244___object(call_graph__env_226_effect_cgraph, let_var_6_ast_node, ((long) 11));
      add_inlined_method__244___object(call_graph__env_226_effect_cgraph, set_ex_it_116_ast_node, ((long) 12));
      add_inlined_method__244___object(call_graph__env_226_effect_cgraph, jump_ex_it_184_ast_node, ((long) 13));
      add_inlined_method__244___object(call_graph__env_226_effect_cgraph, make_box_202_ast_node, ((long) 14));
      add_inlined_method__244___object(call_graph__env_226_effect_cgraph, box_ref_242_ast_node, ((long) 15));
      add_inlined_method__244___object(call_graph__env_226_effect_cgraph, box_set__221_ast_node, ((long) 16));
      add_generic__110___object(save_call__env_248_effect_cgraph, save_call__default1554_env_230_effect_cgraph);
      add_inlined_method__244___object(save_call__env_248_effect_cgraph, global_ast_var, ((long) 0));
      add_inlined_method__244___object(save_call__env_248_effect_cgraph, global_from_205_effect_cgraph, ((long) 1));
      add_inlined_method__244___object(save_call__env_248_effect_cgraph, local_ast_var, ((long) 2));
      add_inlined_method__244___object(save_call__env_248_effect_cgraph, local_from_91_effect_cgraph, ((long) 3));
      {		/* Effect/cgraph.scm 14 */
	 obj_t object__struct_global_from1568_37_1951;
	 object__struct_global_from1568_37_1951 = proc1805_effect_cgraph;
	 add_method__1___object(object__struct_env_210___object, global_from_205_effect_cgraph, object__struct_global_from1568_37_1951);
      }
      {		/* Effect/cgraph.scm 14 */
	 obj_t struct_object__object_global_from1570_205_1950;
	 struct_object__object_global_from1570_205_1950 = proc1806_effect_cgraph;
	 add_method__1___object(struct_object__object_env_209___object, global_from_205_effect_cgraph, struct_object__object_global_from1570_205_1950);
      }
      {		/* Effect/cgraph.scm 14 */
	 obj_t object__struct_local_from1572_217_1947;
	 object__struct_local_from1572_217_1947 = proc1807_effect_cgraph;
	 add_method__1___object(object__struct_env_210___object, local_from_91_effect_cgraph, object__struct_local_from1572_217_1947);
      }
      {		/* Effect/cgraph.scm 14 */
	 obj_t struct_object__object_local_from1574_245_1943;
	 struct_object__object_local_from1574_245_1943 = proc1808_effect_cgraph;
	 return
	    add_method__1___object(struct_object__object_env_209___object, local_from_91_effect_cgraph, struct_object__object_local_from1574_245_1943);
      }
   }
}



/* struct+object->object-local/from1574 */
obj_t 
struct_object__object_local_from1574_245_effect_cgraph(obj_t env_1952, obj_t o_1953, obj_t s_1954)
{
   AN_OBJECT;
   {	/* Effect/cgraph.scm 19 */
      {
	 local_from_91_bglt o_1254;
	 obj_t s_1255;
	 {	/* Effect/cgraph.scm 19 */
	    local_from_91_bglt aux_2395;
	    o_1254 =
	       (local_from_91_bglt) (o_1953);
	    s_1255 = s_1954;
	    {

	       {	/* Effect/cgraph.scm 19 */
		  obj_t old1456_1258;
		  obj_t aux1457_1259;
		  {	/* Effect/cgraph.scm 19 */
		     obj_t next_method1573_104_1264;
		     next_method1573_104_1264 =
			find_super_class_method_167___object(
			(object_bglt) (o_1254), struct_object__object_env_209___object, local_from_91_effect_cgraph);
		     if (
			PROCEDUREP(next_method1573_104_1264))
		       {	/* Effect/cgraph.scm 19 */
			  old1456_1258 =
			     PROCEDURE_ENTRY(next_method1573_104_1264) (next_method1573_104_1264,
			     (obj_t) (o_1254), s_1255, BEOA);
		       }
		     else
		       {	/* Effect/cgraph.scm 19 */
			  PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method1573_104_1264);
			  {	/* Effect/cgraph.scm 19 */
			     object_bglt aux_2404;
			     aux_2404 =
				struct_object__object_93___object(
				(object_bglt) (o_1254), s_1255);
			     old1456_1258 =
				(obj_t) (aux_2404);
			  }
		       }
		  }
		  aux1457_1259 =
		     STRUCT_REF(s_1255, ((long) 0));
		  {	/* Effect/cgraph.scm 19 */
		     local_from_91_bglt new1458_1260;
		     new1458_1260 =
			((local_from_91_bglt) (old1456_1258));
		     {	/* Effect/cgraph.scm 19 */
			long arg1682_1261;
			arg1682_1261 =
			   class_num_218___object(local_from_91_effect_cgraph);
			{	/* Effect/cgraph.scm 19 */
			   obj_t obj_1628;
			   obj_1628 =
			      (obj_t) (new1458_1260);
			   (((obj_t) CREF(obj_1628))->header = MAKE_HEADER(arg1682_1261, 0), BUNSPEC);
			}
		     }
		     {	/* Effect/cgraph.scm 19 */
			local_from_91_bglt arg1683_1262;
			{	/* Effect/cgraph.scm 19 */
			   obj_t arg1684_1263;
			   arg1684_1263 =
			      STRUCT_REF(aux1457_1259, ((long) 0));
			   {	/* Effect/cgraph.scm 19 */
			      local_from_91_bglt res1797_1635;
			      {		/* Effect/cgraph.scm 19 */
				 local_from_91_bglt new1446_1633;
				 new1446_1633 =
				    ((local_from_91_bglt) BREF(GC_MALLOC(sizeof(struct local_from_91))));
				 ((((local_from_91_bglt) CREF(new1446_1633))->from) = ((obj_t) arg1684_1263), BUNSPEC);
				 res1797_1635 = new1446_1633;
			      }
			      arg1683_1262 = res1797_1635;
			   }
			}
			{	/* Effect/cgraph.scm 19 */
			   obj_t aux_2418;
			   object_bglt aux_2416;
			   aux_2418 =
			      (obj_t) (arg1683_1262);
			   aux_2416 =
			      (object_bglt) (new1458_1260);
			   OBJECT_WIDENING_SET(aux_2416, aux_2418);
			}
		     }
		     aux_2395 = new1458_1260;
		  }
	       }
	    }
	    return
	       (obj_t) (aux_2395);
	 }
      }
   }
}



/* object->struct-local/from1572 */
obj_t 
object__struct_local_from1572_217_effect_cgraph(obj_t env_1955, obj_t obj1453_1956)
{
   AN_OBJECT;
   {	/* Effect/cgraph.scm 19 */
      {
	 local_from_91_bglt obj1453_1244;
	 obj1453_1244 =
	    (local_from_91_bglt) (obj1453_1956);
	 {

	    {	/* Effect/cgraph.scm 19 */
	       obj_t res1454_1247;
	       {	/* Effect/cgraph.scm 19 */
		  obj_t next_method1571_49_1252;
		  next_method1571_49_1252 =
		     find_super_class_method_167___object(
		     (object_bglt) (obj1453_1244), object__struct_env_210___object, local_from_91_effect_cgraph);
		  if (
		     PROCEDUREP(next_method1571_49_1252))
		    {	/* Effect/cgraph.scm 19 */
		       res1454_1247 =
			  PROCEDURE_ENTRY(next_method1571_49_1252) (next_method1571_49_1252,
			  (obj_t) (obj1453_1244), BEOA);
		    }
		  else
		    {	/* Effect/cgraph.scm 19 */
		       PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method1571_49_1252);
		       res1454_1247 =
			  object__struct_50___object(
			  (object_bglt) (obj1453_1244));
		    }
	       }
	       {	/* Effect/cgraph.scm 19 */
		  obj_t aux1455_1248;
		  {	/* ./Llib/struct.scm 1415 */
		     obj_t aux_2433;
		     aux_2433 =
			CNST_TABLE_REF(((long) 1));
		     aux1455_1248 =
			make_struct(aux_2433, ((long) 1), BUNSPEC);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_2436;
		     {
			obj_t aux_2437;
			{	/* Effect/cgraph.scm 19 */
			   object_bglt aux_2438;
			   aux_2438 =
			      (object_bglt) (obj1453_1244);
			   aux_2437 =
			      OBJECT_WIDENING(aux_2438);
			}
			aux_2436 =
			   (((local_from_91_bglt) CREF(aux_2437))->from);
		     }
		     STRUCT_SET(aux1455_1248, ((long) 0), aux_2436);
		  }
		  STRUCT_SET(res1454_1247, ((long) 0), aux1455_1248);
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_2444;
		     aux_2444 =
			STRUCT_KEY(res1454_1247);
		     STRUCT_KEY_SET(aux1455_1248, aux_2444);
		  }
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_2447;
		     aux_2447 =
			CNST_TABLE_REF(((long) 1));
		     STRUCT_KEY_SET(res1454_1247, aux_2447);
		  }
		  return res1454_1247;
	       }
	    }
	 }
      }
   }
}



/* struct+object->object-global/from1570 */
obj_t 
struct_object__object_global_from1570_205_effect_cgraph(obj_t env_1957, obj_t o_1958, obj_t s_1959)
{
   AN_OBJECT;
   {	/* Effect/cgraph.scm 20 */
      {
	 global_from_205_bglt o_1232;
	 obj_t s_1233;
	 {	/* Effect/cgraph.scm 20 */
	    global_from_205_bglt aux_2451;
	    o_1232 =
	       (global_from_205_bglt) (o_1958);
	    s_1233 = s_1959;
	    {

	       {	/* Effect/cgraph.scm 20 */
		  obj_t old1481_1236;
		  obj_t aux1482_1237;
		  {	/* Effect/cgraph.scm 20 */
		     obj_t next_method1569_128_1242;
		     next_method1569_128_1242 =
			find_super_class_method_167___object(
			(object_bglt) (o_1232), struct_object__object_env_209___object, global_from_205_effect_cgraph);
		     if (
			PROCEDUREP(next_method1569_128_1242))
		       {	/* Effect/cgraph.scm 20 */
			  old1481_1236 =
			     PROCEDURE_ENTRY(next_method1569_128_1242) (next_method1569_128_1242,
			     (obj_t) (o_1232), s_1233, BEOA);
		       }
		     else
		       {	/* Effect/cgraph.scm 20 */
			  PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method1569_128_1242);
			  {	/* Effect/cgraph.scm 20 */
			     object_bglt aux_2460;
			     aux_2460 =
				struct_object__object_93___object(
				(object_bglt) (o_1232), s_1233);
			     old1481_1236 =
				(obj_t) (aux_2460);
			  }
		       }
		  }
		  aux1482_1237 =
		     STRUCT_REF(s_1233, ((long) 0));
		  {	/* Effect/cgraph.scm 20 */
		     global_from_205_bglt new1483_1238;
		     new1483_1238 =
			((global_from_205_bglt) (old1481_1236));
		     {	/* Effect/cgraph.scm 20 */
			long arg1674_1239;
			arg1674_1239 =
			   class_num_218___object(global_from_205_effect_cgraph);
			{	/* Effect/cgraph.scm 20 */
			   obj_t obj_1599;
			   obj_1599 =
			      (obj_t) (new1483_1238);
			   (((obj_t) CREF(obj_1599))->header = MAKE_HEADER(arg1674_1239, 0), BUNSPEC);
			}
		     }
		     {	/* Effect/cgraph.scm 20 */
			global_from_205_bglt arg1675_1240;
			{	/* Effect/cgraph.scm 20 */
			   obj_t arg1676_1241;
			   arg1676_1241 =
			      STRUCT_REF(aux1482_1237, ((long) 0));
			   {	/* Effect/cgraph.scm 20 */
			      global_from_205_bglt res1796_1606;
			      {		/* Effect/cgraph.scm 20 */
				 global_from_205_bglt new1472_1604;
				 new1472_1604 =
				    ((global_from_205_bglt) BREF(GC_MALLOC(sizeof(struct global_from_205))));
				 ((((global_from_205_bglt) CREF(new1472_1604))->from) = ((obj_t) arg1676_1241), BUNSPEC);
				 res1796_1606 = new1472_1604;
			      }
			      arg1675_1240 = res1796_1606;
			   }
			}
			{	/* Effect/cgraph.scm 20 */
			   obj_t aux_2474;
			   object_bglt aux_2472;
			   aux_2474 =
			      (obj_t) (arg1675_1240);
			   aux_2472 =
			      (object_bglt) (new1483_1238);
			   OBJECT_WIDENING_SET(aux_2472, aux_2474);
			}
		     }
		     aux_2451 = new1483_1238;
		  }
	       }
	    }
	    return
	       (obj_t) (aux_2451);
	 }
      }
   }
}



/* object->struct-global/from1568 */
obj_t 
object__struct_global_from1568_37_effect_cgraph(obj_t env_1960, obj_t obj1478_1961)
{
   AN_OBJECT;
   {	/* Effect/cgraph.scm 20 */
      {
	 global_from_205_bglt obj1478_1222;
	 obj1478_1222 =
	    (global_from_205_bglt) (obj1478_1961);
	 {

	    {	/* Effect/cgraph.scm 20 */
	       obj_t res1479_1225;
	       {	/* Effect/cgraph.scm 20 */
		  obj_t next_method1567_156_1230;
		  next_method1567_156_1230 =
		     find_super_class_method_167___object(
		     (object_bglt) (obj1478_1222), object__struct_env_210___object, global_from_205_effect_cgraph);
		  if (
		     PROCEDUREP(next_method1567_156_1230))
		    {	/* Effect/cgraph.scm 20 */
		       res1479_1225 =
			  PROCEDURE_ENTRY(next_method1567_156_1230) (next_method1567_156_1230,
			  (obj_t) (obj1478_1222), BEOA);
		    }
		  else
		    {	/* Effect/cgraph.scm 20 */
		       PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method1567_156_1230);
		       res1479_1225 =
			  object__struct_50___object(
			  (object_bglt) (obj1478_1222));
		    }
	       }
	       {	/* Effect/cgraph.scm 20 */
		  obj_t aux1480_1226;
		  {	/* ./Llib/struct.scm 1415 */
		     obj_t aux_2489;
		     aux_2489 =
			CNST_TABLE_REF(((long) 2));
		     aux1480_1226 =
			make_struct(aux_2489, ((long) 1), BUNSPEC);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_2492;
		     {
			obj_t aux_2493;
			{	/* Effect/cgraph.scm 20 */
			   object_bglt aux_2494;
			   aux_2494 =
			      (object_bglt) (obj1478_1222);
			   aux_2493 =
			      OBJECT_WIDENING(aux_2494);
			}
			aux_2492 =
			   (((global_from_205_bglt) CREF(aux_2493))->from);
		     }
		     STRUCT_SET(aux1480_1226, ((long) 0), aux_2492);
		  }
		  STRUCT_SET(res1479_1225, ((long) 0), aux1480_1226);
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_2500;
		     aux_2500 =
			STRUCT_KEY(res1479_1225);
		     STRUCT_KEY_SET(aux1480_1226, aux_2500);
		  }
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_2503;
		     aux_2503 =
			CNST_TABLE_REF(((long) 2));
		     STRUCT_KEY_SET(res1479_1225, aux_2503);
		  }
		  return res1479_1225;
	       }
	    }
	 }
      }
   }
}



/* call-graph! */
obj_t 
call_graph__81_effect_cgraph(node_bglt node_2, variable_bglt owner_3)
{
   AN_OBJECT;
   {	/* Effect/cgraph.scm 36 */
    call_graph__81_effect_cgraph:
      {
	 obj_t method1725_1323;
	 obj_t class1730_1324;
	 {	/* Effect/cgraph.scm 36 */
	    obj_t arg1733_1321;
	    obj_t arg1734_1322;
	    {	/* Effect/cgraph.scm 36 */
	       object_bglt obj_1638;
	       obj_1638 =
		  (object_bglt) (node_2);
	       {	/* ./Llib/object.scm 2926 */
		  obj_t pre_method_105_1639;
		  pre_method_105_1639 =
		     PROCEDURE_REF(call_graph__env_226_effect_cgraph, ((long) 2));
		  if (
		     INTEGERP(pre_method_105_1639))
		    {	/* ./Llib/object.scm 2927 */
		       PROCEDURE_SET(call_graph__env_226_effect_cgraph, ((long) 2), BUNSPEC);
		       arg1733_1321 = pre_method_105_1639;
		    }
		  else
		    {	/* ./Llib/object.scm 2914 */
		       long obj_class_num_177_1644;
		       obj_class_num_177_1644 =
			  TYPE(obj_1638);
		       {	/* ./Llib/object.scm 2915 */
			  obj_t arg1176_1645;
			  arg1176_1645 =
			     PROCEDURE_REF(call_graph__env_226_effect_cgraph, ((long) 1));
			  {	/* ./Llib/object.scm 2738 */
			     long arg1177_1649;
			     {	/* ./Llib/object.scm 2738 */
				long arg1178_1650;
				arg1178_1650 =
				   OBJECT_TYPE;
				arg1177_1649 =
				   (obj_class_num_177_1644 - arg1178_1650);
			     }
			     arg1733_1321 =
				VECTOR_REF(arg1176_1645, arg1177_1649);
			  }
		       }
		    }
	       }
	    }
	    {	/* Effect/cgraph.scm 36 */
	       object_bglt object_1655;
	       object_1655 =
		  (object_bglt) (node_2);
	       {	/* ./Llib/object.scm 2695 */
		  long arg1179_1656;
		  {	/* ./Llib/object.scm 2695 */
		     long arg1180_1657;
		     long arg1181_1658;
		     arg1180_1657 =
			TYPE(object_1655);
		     arg1181_1658 =
			OBJECT_TYPE;
		     arg1179_1656 =
			(arg1180_1657 - arg1181_1658);
		  }
		  {	/* ./Llib/object.scm 2695 */
		     obj_t vector_1662;
		     vector_1662 = _classes__134___object;
		     arg1734_1322 =
			VECTOR_REF(vector_1662, arg1179_1656);
		  }
	       }
	    }
	    method1725_1323 = arg1733_1321;
	    class1730_1324 = arg1734_1322;
	    {

	       if (
		  INTEGERP(method1725_1323))
		 {	/* Effect/cgraph.scm 36 */
		    switch (
		       (long) CINT(method1725_1323))
		      {
		      case ((long) 0):

			 {	/* Effect/cgraph.scm 43 */
			    sequence_bglt node_1330;
			    node_1330 =
			       (sequence_bglt) (node_2);
			    {	/* Effect/cgraph.scm 43 */
			       bool_t aux_2525;
			       aux_2525 =
				  call_graph___13_effect_cgraph(
				  (((sequence_bglt) CREF(node_1330))->nodes), owner_3);
			       return
				  BBOOL(aux_2525);
			    }
			 }
			 break;
		      case ((long) 1):

			 {	/* Effect/cgraph.scm 49 */
			    app_bglt node_1333;
			    node_1333 =
			       (app_bglt) (node_2);
			    {	/* Effect/cgraph.scm 52 */
			       variable_bglt aux_2530;
			       {	/* Effect/cgraph.scm 52 */
				  var_bglt arg1740_1337;
				  arg1740_1337 =
				     (((app_bglt) CREF(node_1333))->fun);
				  aux_2530 =
				     (((var_bglt) CREF(arg1740_1337))->variable);
			       }
			       save_call__133_effect_cgraph(aux_2530, owner_3);
			    }
			    {	/* Effect/cgraph.scm 53 */
			       bool_t aux_2534;
			       aux_2534 =
				  call_graph___13_effect_cgraph(
				  (((app_bglt) CREF(node_1333))->args), owner_3);
			       return
				  BBOOL(aux_2534);
			    }
			 }
			 break;
		      case ((long) 2):

			 {	/* Effect/cgraph.scm 59 */
			    app_ly_162_bglt node_1339;
			    node_1339 =
			       (app_ly_162_bglt) (node_2);
			    mark_side_effect__61_effect_cgraph(owner_3);
			    call_graph__81_effect_cgraph(
			       (((app_ly_162_bglt) CREF(node_1339))->fun), owner_3);
			    {
			       node_bglt node_2542;
			       node_2542 =
				  (((app_ly_162_bglt) CREF(node_1339))->arg);
			       node_2 = node_2542;
			       goto call_graph__81_effect_cgraph;
			    }
			 }
			 break;
		      case ((long) 3):

			 {	/* Effect/cgraph.scm 68 */
			    funcall_bglt node_1344;
			    node_1344 =
			       (funcall_bglt) (node_2);
			    mark_side_effect__61_effect_cgraph(owner_3);
			    call_graph__81_effect_cgraph(
			       (((funcall_bglt) CREF(node_1344))->fun), owner_3);
			    {	/* Effect/cgraph.scm 71 */
			       bool_t aux_2548;
			       aux_2548 =
				  call_graph___13_effect_cgraph(
				  (((funcall_bglt) CREF(node_1344))->args), owner_3);
			       return
				  BBOOL(aux_2548);
			    }
			 }
			 break;
		      case ((long) 4):

			 {	/* Effect/cgraph.scm 77 */
			    pragma_bglt node_1349;
			    node_1349 =
			       (pragma_bglt) (node_2);
			    {	/* Effect/cgraph.scm 78 */
			       bool_t test_2553;
			       {	/* ./Ast/node.scm 794 */
				  obj_t aux_2554;
				  aux_2554 =
				     (((pragma_bglt) CREF(node_1349))->side_effect__165);
				  test_2553 =
				     CBOOL(aux_2554);
			       }
			       if (test_2553)
				 {	/* Effect/cgraph.scm 78 */
				    mark_side_effect__61_effect_cgraph(owner_3);
				 }
			       else
				 {	/* Effect/cgraph.scm 78 */
				    BUNSPEC;
				 }
			    }
			    {	/* Effect/cgraph.scm 80 */
			       bool_t aux_2558;
			       aux_2558 =
				  call_graph___13_effect_cgraph(
				  (((pragma_bglt) CREF(node_1349))->args), owner_3);
			       return
				  BBOOL(aux_2558);
			    }
			 }
			 break;
		      case ((long) 5):

			 {	/* Effect/cgraph.scm 86 */
			    cast_bglt node_1354;
			    node_1354 =
			       (cast_bglt) (node_2);
			    {
			       node_bglt node_2563;
			       node_2563 =
				  (((cast_bglt) CREF(node_1354))->arg);
			       node_2 = node_2563;
			       goto call_graph__81_effect_cgraph;
			    }
			 }
			 break;
		      case ((long) 6):

			 {	/* Effect/cgraph.scm 97 */
			    setq_bglt node_1358;
			    node_1358 =
			       (setq_bglt) (node_2);
			    {	/* Effect/cgraph.scm 98 */
			       bool_t test1749_1361;
			       {	/* Effect/cgraph.scm 98 */
				  bool_t test1750_1362;
				  test1750_1362 =
				     is_a__118___object(
				     (obj_t) (owner_3), local_ast_var);
				  if (test1750_1362)
				    {	/* Effect/cgraph.scm 98 */
				       test1749_1361 = ((bool_t) 1);
				    }
				  else
				    {	/* ./Ast/var.scm 672 */
				       obj_t aux_2569;
				       {	/* Effect/cgraph.scm 98 */
					  variable_bglt aux_2570;
					  {	/* Effect/cgraph.scm 98 */
					     var_bglt arg1752_1364;
					     arg1752_1364 =
						(((setq_bglt) CREF(node_1358))->var);
					     aux_2570 =
						(((var_bglt) CREF(arg1752_1364))->variable);
					  }
					  aux_2569 =
					     (obj_t) (aux_2570);
				       }
				       test1749_1361 =
					  is_a__118___object(aux_2569, global_ast_var);
				    }
			       }
			       if (test1749_1361)
				 {	/* Effect/cgraph.scm 98 */
				    mark_side_effect__61_effect_cgraph(owner_3);
				 }
			       else
				 {	/* Effect/cgraph.scm 98 */
				    BUNSPEC;
				 }
			    }
			    {	/* Effect/cgraph.scm 100 */
			       node_bglt aux_2577;
			       {	/* Effect/cgraph.scm 100 */
				  var_bglt aux_2578;
				  aux_2578 =
				     (((setq_bglt) CREF(node_1358))->var);
				  aux_2577 =
				     (node_bglt) (aux_2578);
			       }
			       call_graph__81_effect_cgraph(aux_2577, owner_3);
			    }
			    {
			       node_bglt node_2582;
			       node_2582 =
				  (((setq_bglt) CREF(node_1358))->value);
			       node_2 = node_2582;
			       goto call_graph__81_effect_cgraph;
			    }
			 }
			 break;
		      case ((long) 7):

			 {	/* Effect/cgraph.scm 107 */
			    conditional_bglt node_1367;
			    node_1367 =
			       (conditional_bglt) (node_2);
			    call_graph__81_effect_cgraph(
			       (((conditional_bglt) CREF(node_1367))->test), owner_3);
			    call_graph__81_effect_cgraph(
			       (((conditional_bglt) CREF(node_1367))->true), owner_3);
			    {
			       node_bglt node_2589;
			       node_2589 =
				  (((conditional_bglt) CREF(node_1367))->false);
			       node_2 = node_2589;
			       goto call_graph__81_effect_cgraph;
			    }
			 }
			 break;
		      case ((long) 8):

			 {	/* Effect/cgraph.scm 116 */
			    fail_bglt node_1373;
			    node_1373 =
			       (fail_bglt) (node_2);
			    mark_side_effect__61_effect_cgraph(owner_3);
			    call_graph__81_effect_cgraph(
			       (((fail_bglt) CREF(node_1373))->proc), owner_3);
			    call_graph__81_effect_cgraph(
			       (((fail_bglt) CREF(node_1373))->msg), owner_3);
			    {
			       node_bglt node_2597;
			       node_2597 =
				  (((fail_bglt) CREF(node_1373))->obj);
			       node_2 = node_2597;
			       goto call_graph__81_effect_cgraph;
			    }
			 }
			 break;
		      case ((long) 9):

			 {	/* Effect/cgraph.scm 126 */
			    select_bglt node_1379;
			    node_1379 =
			       (select_bglt) (node_2);
			    call_graph__81_effect_cgraph(
			       (((select_bglt) CREF(node_1379))->test), owner_3);
			    {
			       obj_t l1493_1383;
			       {	/* Effect/cgraph.scm 128 */
				  bool_t aux_2602;
				  l1493_1383 =
				     (((select_bglt) CREF(node_1379))->clauses);
				lname1494_1384:
				  if (
				     PAIRP(l1493_1383))
				    {	/* Effect/cgraph.scm 128 */
				       {	/* Effect/cgraph.scm 129 */
					  node_bglt aux_2605;
					  {	/* Effect/cgraph.scm 129 */
					     obj_t aux_2606;
					     {	/* ./Ieee/pair-list.scm 5707 */
						obj_t aux_2607;
						aux_2607 =
						   CAR(l1493_1383);
						aux_2606 =
						   CDR(aux_2607);
					     }
					     aux_2605 =
						(node_bglt) (aux_2606);
					  }
					  call_graph__81_effect_cgraph(aux_2605, owner_3);
				       }
				       {
					  obj_t l1493_2612;
					  l1493_2612 =
					     CDR(l1493_1383);
					  l1493_1383 = l1493_2612;
					  goto lname1494_1384;
				       }
				    }
				  else
				    {	/* Effect/cgraph.scm 128 */
				       aux_2602 = ((bool_t) 1);
				    }
				  return
				     BBOOL(aux_2602);
			       }
			    }
			 }
			 break;
		      case ((long) 10):

			 {	/* Effect/cgraph.scm 136 */
			    let_fun_218_bglt node_1390;
			    node_1390 =
			       (let_fun_218_bglt) (node_2);
			    {
			       obj_t l1496_1393;
			       l1496_1393 =
				  (((let_fun_218_bglt) CREF(node_1390))->locals);
			     lname1497_1394:
			       if (
				  PAIRP(l1496_1393))
				 {	/* Effect/cgraph.scm 137 */
				    {	/* Effect/cgraph.scm 138 */
				       variable_bglt aux_2619;
				       {	/* Effect/cgraph.scm 138 */
					  obj_t aux_2620;
					  aux_2620 =
					     CAR(l1496_1393);
					  aux_2619 =
					     (variable_bglt) (aux_2620);
				       }
				       fun_call_graph__231_effect_cgraph(aux_2619);
				    }
				    {
				       obj_t l1496_2624;
				       l1496_2624 =
					  CDR(l1496_1393);
				       l1496_1393 = l1496_2624;
				       goto lname1497_1394;
				    }
				 }
			       else
				 {	/* Effect/cgraph.scm 137 */
				    ((bool_t) 1);
				 }
			    }
			    {
			       node_bglt node_2627;
			       node_2627 =
				  (((let_fun_218_bglt) CREF(node_1390))->body);
			       node_2 = node_2627;
			       goto call_graph__81_effect_cgraph;
			    }
			 }
			 break;
		      case ((long) 11):

			 {	/* Effect/cgraph.scm 146 */
			    let_var_6_bglt node_1400;
			    node_1400 =
			       (let_var_6_bglt) (node_2);
			    call_graph__81_effect_cgraph(
			       (((let_var_6_bglt) CREF(node_1400))->body), owner_3);
			    {
			       obj_t l1499_1404;
			       {	/* Effect/cgraph.scm 148 */
				  bool_t aux_2632;
				  l1499_1404 =
				     (((let_var_6_bglt) CREF(node_1400))->bindings);
				lname1500_1405:
				  if (
				     PAIRP(l1499_1404))
				    {	/* Effect/cgraph.scm 148 */
				       {	/* Effect/cgraph.scm 149 */
					  node_bglt aux_2635;
					  {	/* Effect/cgraph.scm 149 */
					     obj_t aux_2636;
					     {	/* ./Ieee/pair-list.scm 5707 */
						obj_t aux_2637;
						aux_2637 =
						   CAR(l1499_1404);
						aux_2636 =
						   CDR(aux_2637);
					     }
					     aux_2635 =
						(node_bglt) (aux_2636);
					  }
					  call_graph__81_effect_cgraph(aux_2635, owner_3);
				       }
				       {
					  obj_t l1499_2642;
					  l1499_2642 =
					     CDR(l1499_1404);
					  l1499_1404 = l1499_2642;
					  goto lname1500_1405;
				       }
				    }
				  else
				    {	/* Effect/cgraph.scm 148 */
				       aux_2632 = ((bool_t) 1);
				    }
				  return
				     BBOOL(aux_2632);
			       }
			    }
			 }
			 break;
		      case ((long) 12):

			 {	/* Effect/cgraph.scm 156 */
			    set_ex_it_116_bglt node_1411;
			    node_1411 =
			       (set_ex_it_116_bglt) (node_2);
			    mark_side_effect__61_effect_cgraph(owner_3);
			    {
			       node_bglt node_2648;
			       node_2648 =
				  (((set_ex_it_116_bglt) CREF(node_1411))->body);
			       node_2 = node_2648;
			       goto call_graph__81_effect_cgraph;
			    }
			 }
			 break;
		      case ((long) 13):

			 {	/* Effect/cgraph.scm 164 */
			    jump_ex_it_184_bglt node_1415;
			    node_1415 =
			       (jump_ex_it_184_bglt) (node_2);
			    mark_side_effect__61_effect_cgraph(owner_3);
			    call_graph__81_effect_cgraph(
			       (((jump_ex_it_184_bglt) CREF(node_1415))->exit), owner_3);
			    {
			       node_bglt node_2654;
			       node_2654 =
				  (((jump_ex_it_184_bglt) CREF(node_1415))->value);
			       node_2 = node_2654;
			       goto call_graph__81_effect_cgraph;
			    }
			 }
			 break;
		      case ((long) 14):

			 {	/* Effect/cgraph.scm 173 */
			    make_box_202_bglt node_1420;
			    node_1420 =
			       (make_box_202_bglt) (node_2);
			    {
			       node_bglt node_2657;
			       node_2657 =
				  (((make_box_202_bglt) CREF(node_1420))->value);
			       node_2 = node_2657;
			       goto call_graph__81_effect_cgraph;
			    }
			 }
			 break;
		      case ((long) 15):

			 {	/* Effect/cgraph.scm 179 */
			    box_ref_242_bglt node_1423;
			    node_1423 =
			       (box_ref_242_bglt) (node_2);
			    {
			       node_bglt node_2660;
			       {	/* Effect/cgraph.scm 179 */
				  var_bglt aux_2661;
				  aux_2661 =
				     (((box_ref_242_bglt) CREF(node_1423))->var);
				  node_2660 =
				     (node_bglt) (aux_2661);
			       }
			       node_2 = node_2660;
			       goto call_graph__81_effect_cgraph;
			    }
			 }
			 break;
		      case ((long) 16):

			 {	/* Effect/cgraph.scm 187 */
			    box_set__221_bglt node_1426;
			    node_1426 =
			       (box_set__221_bglt) (node_2);
			    {	/* Effect/cgraph.scm 188 */
			       bool_t test1781_1429;
			       {	/* Effect/cgraph.scm 188 */
				  bool_t test1782_1430;
				  test1782_1430 =
				     is_a__118___object(
				     (obj_t) (owner_3), local_ast_var);
				  if (test1782_1430)
				    {	/* Effect/cgraph.scm 188 */
				       test1781_1429 = ((bool_t) 1);
				    }
				  else
				    {	/* ./Ast/var.scm 672 */
				       obj_t aux_2668;
				       {	/* Effect/cgraph.scm 188 */
					  variable_bglt aux_2669;
					  {	/* Effect/cgraph.scm 188 */
					     var_bglt arg1784_1432;
					     arg1784_1432 =
						(((box_set__221_bglt) CREF(node_1426))->var);
					     aux_2669 =
						(((var_bglt) CREF(arg1784_1432))->variable);
					  }
					  aux_2668 =
					     (obj_t) (aux_2669);
				       }
				       test1781_1429 =
					  is_a__118___object(aux_2668, global_ast_var);
				    }
			       }
			       if (test1781_1429)
				 {	/* Effect/cgraph.scm 188 */
				    mark_side_effect__61_effect_cgraph(owner_3);
				 }
			       else
				 {	/* Effect/cgraph.scm 188 */
				    BUNSPEC;
				 }
			    }
			    {	/* Effect/cgraph.scm 190 */
			       node_bglt aux_2676;
			       {	/* Effect/cgraph.scm 190 */
				  var_bglt aux_2677;
				  aux_2677 =
				     (((box_set__221_bglt) CREF(node_1426))->var);
				  aux_2676 =
				     (node_bglt) (aux_2677);
			       }
			       call_graph__81_effect_cgraph(aux_2676, owner_3);
			    }
			    {
			       node_bglt node_2681;
			       node_2681 =
				  (((box_set__221_bglt) CREF(node_1426))->value);
			       node_2 = node_2681;
			       goto call_graph__81_effect_cgraph;
			    }
			 }
			 break;
		      default:
		       case_else1731_1327:
			 if (
			    PROCEDUREP(method1725_1323))
			   {	/* Effect/cgraph.scm 36 */
			      return
				 PROCEDURE_ENTRY(method1725_1323) (method1725_1323,
				 (obj_t) (node_2),
				 (obj_t) (owner_3), BEOA);
			   }
			 else
			   {	/* Effect/cgraph.scm 36 */
			      obj_t fun1686_1266;
			      fun1686_1266 =
				 PROCEDURE_REF(call_graph__env_226_effect_cgraph, ((long) 0));
			      return
				 PROCEDURE_ENTRY(fun1686_1266) (fun1686_1266,
				 (obj_t) (node_2),
				 (obj_t) (owner_3), BEOA);
			   }
		      }
		 }
	       else
		 {	/* Effect/cgraph.scm 36 */
		    goto case_else1731_1327;
		 }
	    }
	 }
      }
   }
}



/* _call-graph! */
obj_t 
_call_graph__9_effect_cgraph(obj_t env_1962, obj_t node_1963, obj_t owner_1964)
{
   AN_OBJECT;
   {	/* Effect/cgraph.scm 36 */
      return
	 call_graph__81_effect_cgraph(
	 (node_bglt) (node_1963),
	 (variable_bglt) (owner_1964));
   }
}



/* call-graph!-default1514 */
obj_t 
call_graph__default1514_170_effect_cgraph(node_bglt node_4, variable_bglt owner_5)
{
   AN_OBJECT;
   {	/* Effect/cgraph.scm 14 */
      return
	 CNST_TABLE_REF(((long) 3));
   }
}



/* _call-graph!-default1514 */
obj_t 
_call_graph__default1514_208_effect_cgraph(obj_t env_1965, obj_t node_1966, obj_t owner_1967)
{
   AN_OBJECT;
   {	/* Effect/cgraph.scm 14 */
      return
	 call_graph__default1514_170_effect_cgraph(
	 (node_bglt) (node_1966),
	 (variable_bglt) (owner_1967));
   }
}



/* save-call! */
obj_t 
save_call__133_effect_cgraph(variable_bglt callee_42, variable_bglt owner_43)
{
   AN_OBJECT;
   {	/* Effect/cgraph.scm 202 */
    save_call__133_effect_cgraph:
      {
	 obj_t method1688_1271;
	 obj_t class1693_1272;
	 {	/* Effect/cgraph.scm 202 */
	    obj_t arg1696_1269;
	    obj_t arg1697_1270;
	    {	/* Effect/cgraph.scm 202 */
	       object_bglt obj_1717;
	       obj_1717 =
		  (object_bglt) (callee_42);
	       {	/* ./Llib/object.scm 2926 */
		  obj_t pre_method_105_1718;
		  pre_method_105_1718 =
		     PROCEDURE_REF(save_call__env_248_effect_cgraph, ((long) 2));
		  if (
		     INTEGERP(pre_method_105_1718))
		    {	/* ./Llib/object.scm 2927 */
		       PROCEDURE_SET(save_call__env_248_effect_cgraph, ((long) 2), BUNSPEC);
		       arg1696_1269 = pre_method_105_1718;
		    }
		  else
		    {	/* ./Llib/object.scm 2914 */
		       long obj_class_num_177_1723;
		       obj_class_num_177_1723 =
			  TYPE(obj_1717);
		       {	/* ./Llib/object.scm 2915 */
			  obj_t arg1176_1724;
			  arg1176_1724 =
			     PROCEDURE_REF(save_call__env_248_effect_cgraph, ((long) 1));
			  {	/* ./Llib/object.scm 2738 */
			     long arg1177_1728;
			     {	/* ./Llib/object.scm 2738 */
				long arg1178_1729;
				arg1178_1729 =
				   OBJECT_TYPE;
				arg1177_1728 =
				   (obj_class_num_177_1723 - arg1178_1729);
			     }
			     arg1696_1269 =
				VECTOR_REF(arg1176_1724, arg1177_1728);
			  }
		       }
		    }
	       }
	    }
	    {	/* Effect/cgraph.scm 202 */
	       object_bglt object_1734;
	       object_1734 =
		  (object_bglt) (callee_42);
	       {	/* ./Llib/object.scm 2695 */
		  long arg1179_1735;
		  {	/* ./Llib/object.scm 2695 */
		     long arg1180_1736;
		     long arg1181_1737;
		     arg1180_1736 =
			TYPE(object_1734);
		     arg1181_1737 =
			OBJECT_TYPE;
		     arg1179_1735 =
			(arg1180_1736 - arg1181_1737);
		  }
		  {	/* ./Llib/object.scm 2695 */
		     obj_t vector_1741;
		     vector_1741 = _classes__134___object;
		     arg1697_1270 =
			VECTOR_REF(vector_1741, arg1179_1735);
		  }
	       }
	    }
	    method1688_1271 = arg1696_1269;
	    class1693_1272 = arg1697_1270;
	    {

	       if (
		  INTEGERP(method1688_1271))
		 {	/* Effect/cgraph.scm 202 */
		    switch (
		       (long) CINT(method1688_1271))
		      {
		      case ((long) 0):

			 {	/* Effect/cgraph.scm 208 */
			    global_bglt callee_1278;
			    callee_1278 =
			       (global_bglt) (callee_42);
			    {	/* Effect/cgraph.scm 208 */
			       value_bglt fun_1280;
			       fun_1280 =
				  (((global_bglt) CREF(callee_1278))->value);
			       {	/* Effect/cgraph.scm 209 */
				  bool_t test1700_1281;
				  {	/* Effect/cgraph.scm 209 */
				     bool_t test1705_1287;
				     test1705_1287 =
					is_a__118___object(
					(obj_t) (fun_1280), cfun_ast_var);
				     if (test1705_1287)
				       {	/* Effect/cgraph.scm 209 */
					  test1700_1281 = ((bool_t) 1);
				       }
				     else
				       {	/* Effect/cgraph.scm 210 */
					  bool_t _andtest_1506_1288;
					  _andtest_1506_1288 =
					     is_a__118___object(
					     (obj_t) (fun_1280), sfun_ast_var);
					  if (_andtest_1506_1288)
					    {	/* ./Ieee/equiv.scm 5508 */
					       obj_t aux_2730;
					       obj_t aux_2728;
					       aux_2730 =
						  CNST_TABLE_REF(((long) 4));
					       aux_2728 =
						  (((global_bglt) CREF(callee_1278))->import);
					       test1700_1281 =
						  (aux_2728 == aux_2730);
					    }
					  else
					    {	/* Effect/cgraph.scm 210 */
					       test1700_1281 = ((bool_t) 0);
					    }
				       }
				  }
				  if (test1700_1281)
				    {	/* Effect/cgraph.scm 212 */
				       bool_t test_2734;
				       {	/* Effect/cgraph.scm 212 */
					  fun_bglt obj_1749;
					  obj_1749 =
					     (fun_bglt) (fun_1280);
					  {	/* ./Ast/var.scm 702 */
					     obj_t aux_2736;
					     aux_2736 =
						(((fun_bglt) CREF(obj_1749))->side_effect__165);
					     test_2734 =
						CBOOL(aux_2736);
					  }
				       }
				       if (test_2734)
					 {	/* Effect/cgraph.scm 212 */
					    return
					       mark_side_effect__61_effect_cgraph(owner_43);
					 }
				       else
					 {	/* Effect/cgraph.scm 212 */
					    return BUNSPEC;
					 }
				    }
				  else
				    {	/* Effect/cgraph.scm 214 */
				       global_from_205_bglt arg1702_1283;
				       {	/* Effect/cgraph.scm 214 */
					  global_from_205_bglt obj1507_1284;
					  obj1507_1284 =
					     ((global_from_205_bglt) (callee_1278));
					  {	/* Effect/cgraph.scm 214 */
					     global_from_205_bglt arg1703_1285;
					     {	/* Effect/cgraph.scm 214 */
						global_from_205_bglt res1799_1753;
						{	/* Effect/cgraph.scm 20 */
						   global_from_205_bglt new1472_1751;
						   new1472_1751 =
						      ((global_from_205_bglt) BREF(GC_MALLOC(sizeof(struct global_from_205))));
						   ((((global_from_205_bglt) CREF(new1472_1751))->from) = ((obj_t) BNIL), BUNSPEC);
						   res1799_1753 = new1472_1751;
						}
						arg1703_1285 = res1799_1753;
					     }
					     {	/* Effect/cgraph.scm 214 */
						obj_t aux_2745;
						object_bglt aux_2743;
						aux_2745 =
						   (obj_t) (arg1703_1285);
						aux_2743 =
						   (object_bglt) (obj1507_1284);
						OBJECT_WIDENING_SET(aux_2743, aux_2745);
					     }
					  }
					  {	/* Effect/cgraph.scm 214 */
					     long arg1704_1286;
					     arg1704_1286 =
						class_num_218___object(global_from_205_effect_cgraph);
					     {	/* Effect/cgraph.scm 214 */
						obj_t obj_1754;
						obj_1754 =
						   (obj_t) (obj1507_1284);
						(((obj_t) CREF(obj_1754))->header = MAKE_HEADER(arg1704_1286, 0), BUNSPEC);
					     }
					  }
					  arg1702_1283 = obj1507_1284;
				       }
				       {
					  variable_bglt callee_2751;
					  callee_2751 =
					     (variable_bglt) (arg1702_1283);
					  callee_42 = callee_2751;
					  goto save_call__133_effect_cgraph;
				       }
				    }
			       }
			    }
			 }
			 break;
		      case ((long) 1):

			 {	/* Effect/cgraph.scm 220 */
			    global_from_205_bglt callee_1291;
			    callee_1291 =
			       (global_from_205_bglt) (callee_42);
			    {	/* Effect/cgraph.scm 221 */
			       bool_t test_2754;
			       {	/* Effect/cgraph.scm 221 */
				  obj_t aux_2755;
				  {	/* Effect/cgraph.scm 221 */
				     obj_t aux_2756;
				     {
					obj_t aux_2758;
					{	/* Effect/cgraph.scm 20 */
					   object_bglt aux_2759;
					   aux_2759 =
					      (object_bglt) (callee_1291);
					   aux_2758 =
					      OBJECT_WIDENING(aux_2759);
					}
					aux_2756 =
					   (((global_from_205_bglt) CREF(aux_2758))->from);
				     }
				     aux_2755 =
					memq___r4_pairs_and_lists_6_3(
					(obj_t) (owner_43), aux_2756);
				  }
				  test_2754 =
				     CBOOL(aux_2755);
			       }
			       if (test_2754)
				 {	/* Effect/cgraph.scm 221 */
				    return BUNSPEC;
				 }
			       else
				 {	/* Effect/cgraph.scm 222 */
				    obj_t arg1709_1295;
				    {	/* ./Ieee/pair-list.scm 5689 */
				       obj_t aux_2767;
				       obj_t aux_2765;
				       {
					  obj_t aux_2768;
					  {	/* Effect/cgraph.scm 20 */
					     object_bglt aux_2769;
					     aux_2769 =
						(object_bglt) (callee_1291);
					     aux_2768 =
						OBJECT_WIDENING(aux_2769);
					  }
					  aux_2767 =
					     (((global_from_205_bglt) CREF(aux_2768))->from);
				       }
				       aux_2765 =
					  (obj_t) (owner_43);
				       arg1709_1295 =
					  MAKE_PAIR(aux_2765, aux_2767);
				    }
				    {
				       obj_t aux_2774;
				       {	/* Effect/cgraph.scm 20 */
					  object_bglt aux_2775;
					  aux_2775 =
					     (object_bglt) (callee_1291);
					  aux_2774 =
					     OBJECT_WIDENING(aux_2775);
				       }
				       return
					  ((((global_from_205_bglt) CREF(aux_2774))->from) = ((obj_t) arg1709_1295), BUNSPEC);
				    }
				 }
			    }
			 }
			 break;
		      case ((long) 2):

			 {	/* Effect/cgraph.scm 228 */
			    local_bglt callee_1298;
			    callee_1298 =
			       (local_bglt) (callee_42);
			    {	/* Effect/cgraph.scm 228 */
			       local_from_91_bglt arg1713_1300;
			       {	/* Effect/cgraph.scm 228 */
				  local_from_91_bglt obj1510_1301;
				  obj1510_1301 =
				     ((local_from_91_bglt) (callee_1298));
				  {	/* Effect/cgraph.scm 228 */
				     local_from_91_bglt arg1714_1302;
				     {	/* Effect/cgraph.scm 228 */
					local_from_91_bglt res1800_1765;
					{	/* Effect/cgraph.scm 19 */
					   local_from_91_bglt new1446_1763;
					   new1446_1763 =
					      ((local_from_91_bglt) BREF(GC_MALLOC(sizeof(struct local_from_91))));
					   ((((local_from_91_bglt) CREF(new1446_1763))->from) = ((obj_t) BNIL), BUNSPEC);
					   res1800_1765 = new1446_1763;
					}
					arg1714_1302 = res1800_1765;
				     }
				     {	/* Effect/cgraph.scm 228 */
					obj_t aux_2785;
					object_bglt aux_2783;
					aux_2785 =
					   (obj_t) (arg1714_1302);
					aux_2783 =
					   (object_bglt) (obj1510_1301);
					OBJECT_WIDENING_SET(aux_2783, aux_2785);
				     }
				  }
				  {	/* Effect/cgraph.scm 228 */
				     long arg1715_1303;
				     arg1715_1303 =
					class_num_218___object(local_from_91_effect_cgraph);
				     {	/* Effect/cgraph.scm 228 */
					obj_t obj_1766;
					obj_1766 =
					   (obj_t) (obj1510_1301);
					(((obj_t) CREF(obj_1766))->header = MAKE_HEADER(arg1715_1303, 0), BUNSPEC);
				     }
				  }
				  arg1713_1300 = obj1510_1301;
			       }
			       {
				  variable_bglt callee_2791;
				  callee_2791 =
				     (variable_bglt) (arg1713_1300);
				  callee_42 = callee_2791;
				  goto save_call__133_effect_cgraph;
			       }
			    }
			 }
			 break;
		      case ((long) 3):

			 {	/* Effect/cgraph.scm 234 */
			    local_from_91_bglt callee_1304;
			    callee_1304 =
			       (local_from_91_bglt) (callee_42);
			    {	/* Effect/cgraph.scm 235 */
			       bool_t test_2794;
			       {	/* Effect/cgraph.scm 235 */
				  obj_t aux_2795;
				  {	/* Effect/cgraph.scm 235 */
				     obj_t aux_2796;
				     {
					obj_t aux_2798;
					{	/* Effect/cgraph.scm 19 */
					   object_bglt aux_2799;
					   aux_2799 =
					      (object_bglt) (callee_1304);
					   aux_2798 =
					      OBJECT_WIDENING(aux_2799);
					}
					aux_2796 =
					   (((local_from_91_bglt) CREF(aux_2798))->from);
				     }
				     aux_2795 =
					memq___r4_pairs_and_lists_6_3(
					(obj_t) (owner_43), aux_2796);
				  }
				  test_2794 =
				     CBOOL(aux_2795);
			       }
			       if (test_2794)
				 {	/* Effect/cgraph.scm 235 */
				    return BUNSPEC;
				 }
			       else
				 {	/* Effect/cgraph.scm 236 */
				    obj_t arg1717_1308;
				    {	/* ./Ieee/pair-list.scm 5689 */
				       obj_t aux_2807;
				       obj_t aux_2805;
				       {
					  obj_t aux_2808;
					  {	/* Effect/cgraph.scm 19 */
					     object_bglt aux_2809;
					     aux_2809 =
						(object_bglt) (callee_1304);
					     aux_2808 =
						OBJECT_WIDENING(aux_2809);
					  }
					  aux_2807 =
					     (((local_from_91_bglt) CREF(aux_2808))->from);
				       }
				       aux_2805 =
					  (obj_t) (owner_43);
				       arg1717_1308 =
					  MAKE_PAIR(aux_2805, aux_2807);
				    }
				    {
				       obj_t aux_2814;
				       {	/* Effect/cgraph.scm 19 */
					  object_bglt aux_2815;
					  aux_2815 =
					     (object_bglt) (callee_1304);
					  aux_2814 =
					     OBJECT_WIDENING(aux_2815);
				       }
				       return
					  ((((local_from_91_bglt) CREF(aux_2814))->from) = ((obj_t) arg1717_1308), BUNSPEC);
				    }
				 }
			    }
			 }
			 break;
		      default:
		       case_else1694_1275:
			 if (
			    PROCEDUREP(method1688_1271))
			   {	/* Effect/cgraph.scm 202 */
			      return
				 PROCEDURE_ENTRY(method1688_1271) (method1688_1271,
				 (obj_t) (callee_42),
				 (obj_t) (owner_43), BEOA);
			   }
			 else
			   {	/* Effect/cgraph.scm 202 */
			      obj_t fun1687_1267;
			      fun1687_1267 =
				 PROCEDURE_REF(save_call__env_248_effect_cgraph, ((long) 0));
			      return
				 PROCEDURE_ENTRY(fun1687_1267) (fun1687_1267,
				 (obj_t) (callee_42),
				 (obj_t) (owner_43), BEOA);
			   }
		      }
		 }
	       else
		 {	/* Effect/cgraph.scm 202 */
		    goto case_else1694_1275;
		 }
	    }
	 }
      }
   }
}



/* _save-call! */
obj_t 
_save_call__94_effect_cgraph(obj_t env_1968, obj_t callee_1969, obj_t owner_1970)
{
   AN_OBJECT;
   {	/* Effect/cgraph.scm 202 */
      return
	 save_call__133_effect_cgraph(
	 (variable_bglt) (callee_1969),
	 (variable_bglt) (owner_1970));
   }
}



/* save-call!-default1554 */
obj_t 
save_call__default1554_39_effect_cgraph(variable_bglt callee_44, variable_bglt owner_45)
{
   AN_OBJECT;
   {	/* Effect/cgraph.scm 14 */
      FAILURE(
	 CNST_TABLE_REF(((long) 5)), string1809_effect_cgraph,
	 (obj_t) (callee_44));
   }
}



/* _save-call!-default1554 */
obj_t 
_save_call__default1554_247_effect_cgraph(obj_t env_1971, obj_t callee_1972, obj_t owner_1973)
{
   AN_OBJECT;
   {	/* Effect/cgraph.scm 14 */
      return
	 save_call__default1554_39_effect_cgraph(
	 (variable_bglt) (callee_1972),
	 (variable_bglt) (owner_1973));
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_effect_cgraph()
{
   AN_OBJECT;
   {	/* Effect/cgraph.scm 14 */
      module_initialization_70_type_type(((long) 0), "EFFECT_CGRAPH");
      module_initialization_70_ast_var(((long) 0), "EFFECT_CGRAPH");
      module_initialization_70_ast_node(((long) 0), "EFFECT_CGRAPH");
      module_initialization_70_tools_trace(((long) 0), "EFFECT_CGRAPH");
      module_initialization_70_tools_shape(((long) 0), "EFFECT_CGRAPH");
      return
	 module_initialization_70_tools_error(((long) 0), "EFFECT_CGRAPH");
   }
}
