/*===========================================================================*/
/*   (Effect/effect.scm)                                                     */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;


static obj_t method_init_76_effect_effect();
extern obj_t funcall_ast_node;
extern obj_t node_effect_213_ast_node;
extern long add_inlined_method__244___object(obj_t, obj_t, long);
extern obj_t fail_ast_node;
extern obj_t var_ast_node;
static obj_t _side_effect_1566_223_effect_effect(obj_t, obj_t);
static obj_t _side_effect__default1438_108_effect_effect(obj_t, obj_t);
extern obj_t set_ex_it_116_ast_node;
extern obj_t module_initialization_70_effect_effect(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
static obj_t side_effect__default1438_4_effect_effect(node_bglt);
extern obj_t node_ast_node;
static obj_t imported_modules_init_94_effect_effect();
extern obj_t app_ly_162_ast_node;
extern obj_t add_generic__110___object(obj_t, obj_t);
static obj_t library_modules_init_112_effect_effect();
extern obj_t cast_ast_node;
static obj_t toplevel_init_63_effect_effect();
extern obj_t jump_ex_it_184_ast_node;
extern obj_t open_input_string(obj_t);
extern bool_t side_effect__165_effect_effect(node_bglt);
extern obj_t setq_ast_node;
extern obj_t box_set__221_ast_node;
extern obj_t _classes__134___object;
extern obj_t read___reader(obj_t);
static obj_t require_initialization_114_effect_effect = BUNSPEC;
static obj_t cnst_init_137_effect_effect();
static obj_t __cnst[2];

DEFINE_STATIC_PROCEDURE(side_effect__default1438_env_235_effect_effect, _side_effect__default1438_108_effect_effect1574, _side_effect__default1438_108_effect_effect, 0L, 1);
DEFINE_EXPORT_GENERIC(side_effect__env_35_effect_effect, _side_effect_1566_223_effect_effect1575, _side_effect_1566_223_effect_effect, 0L, 1);
DEFINE_STRING(string1568_effect_effect, string1568_effect_effect1576, "SIDE-EFFECT?-DEFAULT1438 READ ", 30);
DEFINE_STRING(string1567_effect_effect, string1567_effect_effect1577, "No method for this object", 25);



/* module-initialization */
obj_t 
module_initialization_70_effect_effect(long checksum_1123, char *from_1124)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_effect_effect))
	{
	   require_initialization_114_effect_effect =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_effect_effect();
	   cnst_init_137_effect_effect();
	   imported_modules_init_94_effect_effect();
	   method_init_76_effect_effect();
	   toplevel_init_63_effect_effect();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_effect_effect()
{
   AN_OBJECT;
   {	/* Effect/effect.scm 18 */
      module_initialization_70___object(((long) 0), "EFFECT_EFFECT");
      module_initialization_70___reader(((long) 0), "EFFECT_EFFECT");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_effect_effect()
{
   AN_OBJECT;
   {	/* Effect/effect.scm 18 */
      {		/* Effect/effect.scm 18 */
	 obj_t cnst_port_138_1116;
	 cnst_port_138_1116 =
	    open_input_string(string1568_effect_effect);
	 {
	    long i_1117;
	    i_1117 = ((long) 1);
	  loop_1118:
	    {	/* Effect/effect.scm 18 */
	       bool_t test1569_1119;
	       test1569_1119 =
		  (i_1117 == ((long) -1));
	       if (test1569_1119)
		 {	/* Effect/effect.scm 18 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Effect/effect.scm 18 */
		    {	/* Effect/effect.scm 18 */
		       obj_t arg1571_1120;
		       {	/* Effect/effect.scm 18 */
			  obj_t list1572_1121;
			  list1572_1121 =
			     MAKE_PAIR(cnst_port_138_1116, BNIL);
			  arg1571_1120 =
			     read___reader(list1572_1121);
		       }
		       CNST_TABLE_SET(i_1117, arg1571_1120);
		    }
		    {	/* Effect/effect.scm 18 */
		       int aux_1122;
		       {	/* Effect/effect.scm 18 */
			  long aux_1141;
			  aux_1141 =
			     (i_1117 - ((long) 1));
			  aux_1122 =
			     (int) (aux_1141);
		       }
		       {
			  long i_1144;
			  i_1144 =
			     (long) (aux_1122);
			  i_1117 = i_1144;
			  goto loop_1118;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_effect_effect()
{
   AN_OBJECT;
   {	/* Effect/effect.scm 18 */
      return BUNSPEC;
   }
}



/* method-init */
obj_t 
method_init_76_effect_effect()
{
   AN_OBJECT;
   {	/* Effect/effect.scm 18 */
      add_generic__110___object(side_effect__env_35_effect_effect, side_effect__default1438_env_235_effect_effect);
      add_inlined_method__244___object(side_effect__env_35_effect_effect, node_ast_node, ((long) 0));
      add_inlined_method__244___object(side_effect__env_35_effect_effect, var_ast_node, ((long) 1));
      add_inlined_method__244___object(side_effect__env_35_effect_effect, node_effect_213_ast_node, ((long) 2));
      add_inlined_method__244___object(side_effect__env_35_effect_effect, setq_ast_node, ((long) 3));
      add_inlined_method__244___object(side_effect__env_35_effect_effect, fail_ast_node, ((long) 4));
      add_inlined_method__244___object(side_effect__env_35_effect_effect, set_ex_it_116_ast_node, ((long) 5));
      add_inlined_method__244___object(side_effect__env_35_effect_effect, jump_ex_it_184_ast_node, ((long) 6));
      add_inlined_method__244___object(side_effect__env_35_effect_effect, box_set__221_ast_node, ((long) 7));
      add_inlined_method__244___object(side_effect__env_35_effect_effect, app_ly_162_ast_node, ((long) 8));
      add_inlined_method__244___object(side_effect__env_35_effect_effect, funcall_ast_node, ((long) 9));
      {		/* Effect/effect.scm 18 */
	 long aux_1157;
	 aux_1157 =
	    add_inlined_method__244___object(side_effect__env_35_effect_effect, cast_ast_node, ((long) 10));
	 return
	    BINT(aux_1157);
      }
   }
}



/* side-effect? */
bool_t 
side_effect__165_effect_effect(node_bglt node_1)
{
   AN_OBJECT;
   {	/* Effect/effect.scm 25 */
      {
	 obj_t method1541_1039;
	 obj_t class1546_1040;
	 {	/* Effect/effect.scm 25 */
	    obj_t arg1549_1037;
	    obj_t arg1550_1038;
	    {	/* Effect/effect.scm 25 */
	       object_bglt obj_1074;
	       obj_1074 =
		  (object_bglt) (node_1);
	       {	/* ./Llib/object.scm 2926 */
		  obj_t pre_method_105_1075;
		  pre_method_105_1075 =
		     PROCEDURE_REF(side_effect__env_35_effect_effect, ((long) 2));
		  if (
		     INTEGERP(pre_method_105_1075))
		    {	/* ./Llib/object.scm 2927 */
		       PROCEDURE_SET(side_effect__env_35_effect_effect, ((long) 2), BUNSPEC);
		       arg1549_1037 = pre_method_105_1075;
		    }
		  else
		    {	/* ./Llib/object.scm 2914 */
		       long obj_class_num_177_1080;
		       obj_class_num_177_1080 =
			  TYPE(obj_1074);
		       {	/* ./Llib/object.scm 2915 */
			  obj_t arg1176_1081;
			  arg1176_1081 =
			     PROCEDURE_REF(side_effect__env_35_effect_effect, ((long) 1));
			  {	/* ./Llib/object.scm 2738 */
			     long arg1177_1085;
			     {	/* ./Llib/object.scm 2738 */
				long arg1178_1086;
				arg1178_1086 =
				   OBJECT_TYPE;
				arg1177_1085 =
				   (obj_class_num_177_1080 - arg1178_1086);
			     }
			     arg1549_1037 =
				VECTOR_REF(arg1176_1081, arg1177_1085);
			  }
		       }
		    }
	       }
	    }
	    {	/* Effect/effect.scm 25 */
	       object_bglt object_1091;
	       object_1091 =
		  (object_bglt) (node_1);
	       {	/* ./Llib/object.scm 2695 */
		  long arg1179_1092;
		  {	/* ./Llib/object.scm 2695 */
		     long arg1180_1093;
		     long arg1181_1094;
		     arg1180_1093 =
			TYPE(object_1091);
		     arg1181_1094 =
			OBJECT_TYPE;
		     arg1179_1092 =
			(arg1180_1093 - arg1181_1094);
		  }
		  {	/* ./Llib/object.scm 2695 */
		     obj_t vector_1098;
		     vector_1098 = _classes__134___object;
		     arg1550_1038 =
			VECTOR_REF(vector_1098, arg1179_1092);
		  }
	       }
	    }
	    {	/* Effect/effect.scm 25 */
	       obj_t aux_1175;
	       method1541_1039 = arg1549_1037;
	       class1546_1040 = arg1550_1038;
	       {

		  if (
		     INTEGERP(method1541_1039))
		    {	/* Effect/effect.scm 25 */
		       switch (
			  (long) CINT(method1541_1039))
			 {
			 case ((long) 0):

			    aux_1175 = BFALSE;
			    break;
			 case ((long) 1):

			    {	/* Effect/effect.scm 37 */
			       var_bglt node_1047;
			       node_1047 =
				  (var_bglt) (node_1);
			       {	/* Effect/effect.scm 37 */
				  bool_t test_1179;
				  {	/* ./Ieee/equiv.scm 5508 */
				     obj_t aux_1183;
				     obj_t aux_1180;
				     aux_1183 =
					CNST_TABLE_REF(((long) 0));
				     {	/* Effect/effect.scm 37 */
					variable_bglt arg1557_1051;
					arg1557_1051 =
					   (((var_bglt) CREF(node_1047))->variable);
					aux_1180 =
					   (((variable_bglt) CREF(arg1557_1051))->access);
				     }
				     test_1179 =
					(aux_1180 == aux_1183);
				  }
				  if (test_1179)
				    {	/* Effect/effect.scm 37 */
				       aux_1175 = BFALSE
					  ;
				    }
				  else
				    {	/* Effect/effect.scm 37 */
				       aux_1175 = BTRUE
					  ;
				    }
			       }
			    }
			    break;
			 case ((long) 2):

			    {	/* Effect/effect.scm 43 */
			       node_effect_213_bglt node_1052;
			       node_1052 =
				  (node_effect_213_bglt) (node_1);
			       {	/* Effect/effect.scm 43 */
				  obj_t effect_1053;
				  effect_1053 =
				     (((node_effect_213_bglt) CREF(node_1052))->side_effect__165);
				  if (
				     BOOLEANP(effect_1053))
				    {	/* Effect/effect.scm 44 */
				       aux_1175 = effect_1053
					  ;
				    }
				  else
				    {	/* Effect/effect.scm 44 */
				       aux_1175 = BTRUE
					  ;
				    }
			       }
			    }
			    break;
			 case ((long) 3):

			    aux_1175 = BTRUE;
			    break;
			 case ((long) 4):

			    aux_1175 = BTRUE;
			    break;
			 case ((long) 5):

			    aux_1175 = BTRUE;
			    break;
			 case ((long) 6):

			    aux_1175 = BTRUE;
			    break;
			 case ((long) 7):

			    aux_1175 = BTRUE;
			    break;
			 case ((long) 8):

			    aux_1175 = BTRUE;
			    break;
			 case ((long) 9):

			    aux_1175 = BTRUE;
			    break;
			 case ((long) 10):

			    {	/* Effect/effect.scm 94 */
			       cast_bglt node_1062;
			       node_1062 =
				  (cast_bglt) (node_1);
			       {	/* Effect/effect.scm 95 */
				  bool_t aux_1191;
				  aux_1191 =
				     side_effect__165_effect_effect(
				     (((cast_bglt) CREF(node_1062))->arg));
				  aux_1175 =
				     BBOOL(aux_1191);
			       }
			    }
			    break;
			 default:
			  case_else1547_1043:
			    if (
			       PROCEDUREP(method1541_1039))
			      {		/* Effect/effect.scm 25 */
				 aux_1175 =
				    PROCEDURE_ENTRY(method1541_1039) (method1541_1039,
				    (obj_t) (node_1), BEOA)
				    ;
			      }
			    else
			      {		/* Effect/effect.scm 25 */
				 obj_t fun1540_1035;
				 fun1540_1035 =
				    PROCEDURE_REF(side_effect__env_35_effect_effect, ((long) 0));
				 aux_1175 =
				    PROCEDURE_ENTRY(fun1540_1035) (fun1540_1035,
				    (obj_t) (node_1), BEOA);
			      }
			 }
		    }
		  else
		    {	/* Effect/effect.scm 25 */
		       goto case_else1547_1043;
		    }
	       }
	       return
		  CBOOL(aux_1175);
	    }
	 }
      }
   }
}



/* _side-effect?1566 */
obj_t 
_side_effect_1566_223_effect_effect(obj_t env_1112, obj_t node_1113)
{
   AN_OBJECT;
   {	/* Effect/effect.scm 25 */
      {		/* Effect/effect.scm 25 */
	 bool_t aux_1207;
	 aux_1207 =
	    side_effect__165_effect_effect(
	    (node_bglt) (node_1113));
	 return
	    BBOOL(aux_1207);
      }
   }
}



/* side-effect?-default1438 */
obj_t 
side_effect__default1438_4_effect_effect(node_bglt node_2)
{
   AN_OBJECT;
   {	/* Effect/effect.scm 18 */
      FAILURE(
	 CNST_TABLE_REF(((long) 1)), string1567_effect_effect,
	 (obj_t) (node_2));
   }
}



/* _side-effect?-default1438 */
obj_t 
_side_effect__default1438_108_effect_effect(obj_t env_1114, obj_t node_1115)
{
   AN_OBJECT;
   {	/* Effect/effect.scm 18 */
      return
	 side_effect__default1438_4_effect_effect(
	 (node_bglt) (node_1115));
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_effect_effect()
{
   AN_OBJECT;
   {	/* Effect/effect.scm 18 */
      module_initialization_70_type_type(((long) 0), "EFFECT_EFFECT");
      module_initialization_70_ast_var(((long) 0), "EFFECT_EFFECT");
      return
	 module_initialization_70_ast_node(((long) 0), "EFFECT_EFFECT");
   }
}
