/*===========================================================================*/
/*   (Effect/spread.scm)                                                     */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;


static obj_t method_init_76_effect_spread();
extern obj_t make_box_202_ast_node;
extern obj_t funcall_ast_node;
extern long add_inlined_method__244___object(obj_t, obj_t, long);
extern obj_t fail_ast_node;
extern obj_t box_ref_242_ast_node;
extern obj_t sequence_ast_node;
extern obj_t let_var_6_ast_node;
extern obj_t var_ast_node;
extern obj_t pragma_ast_node;
extern obj_t set_ex_it_116_ast_node;
static bool_t spread_side_effect___103_effect_spread(obj_t);
extern obj_t module_initialization_70_effect_spread(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern bool_t spread_side_effect__136_effect_spread(node_bglt);
extern obj_t let_fun_218_ast_node;
static obj_t imported_modules_init_94_effect_spread();
extern obj_t app_ly_162_ast_node;
extern obj_t add_generic__110___object(obj_t, obj_t);
extern obj_t app_ast_node;
static obj_t library_modules_init_112_effect_spread();
extern obj_t cast_ast_node;
static obj_t toplevel_init_63_effect_spread();
extern obj_t jump_ex_it_184_ast_node;
extern obj_t open_input_string(obj_t);
static obj_t _spread_side_effect__default1462_34_effect_spread(obj_t, obj_t);
extern obj_t setq_ast_node;
extern obj_t box_set__221_ast_node;
static bool_t spread_side_effect__default1462_185_effect_spread(node_bglt);
extern obj_t _classes__134___object;
extern obj_t select_ast_node;
extern obj_t read___reader(obj_t);
static obj_t _spread_side_effect_1655_137_effect_spread(obj_t, obj_t);
static obj_t require_initialization_114_effect_spread = BUNSPEC;
extern obj_t conditional_ast_node;
static obj_t cnst_init_137_effect_spread();
static obj_t __cnst[1];

DEFINE_EXPORT_GENERIC(spread_side_effect__env_137_effect_spread, _spread_side_effect_1655_137_effect_spread1661, _spread_side_effect_1655_137_effect_spread, 0L, 1);
DEFINE_STATIC_PROCEDURE(spread_side_effect__default1462_env_203_effect_spread, _spread_side_effect__default1462_34_effect_spread1662, _spread_side_effect__default1462_34_effect_spread, 0L, 1);
DEFINE_STRING(string1656_effect_spread, string1656_effect_spread1663, "READ ", 5);



/* module-initialization */
obj_t 
module_initialization_70_effect_spread(long checksum_1289, char *from_1290)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_effect_spread))
	{
	   require_initialization_114_effect_spread =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_effect_spread();
	   cnst_init_137_effect_spread();
	   imported_modules_init_94_effect_spread();
	   method_init_76_effect_spread();
	   toplevel_init_63_effect_spread();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_effect_spread()
{
   AN_OBJECT;
   {	/* Effect/spread.scm 14 */
      module_initialization_70___object(((long) 0), "EFFECT_SPREAD");
      module_initialization_70___reader(((long) 0), "EFFECT_SPREAD");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_effect_spread()
{
   AN_OBJECT;
   {	/* Effect/spread.scm 14 */
      {		/* Effect/spread.scm 14 */
	 obj_t cnst_port_138_1282;
	 cnst_port_138_1282 =
	    open_input_string(string1656_effect_spread);
	 {
	    long i_1283;
	    i_1283 = ((long) 0);
	  loop_1284:
	    {	/* Effect/spread.scm 14 */
	       bool_t test1657_1285;
	       test1657_1285 =
		  (i_1283 == ((long) -1));
	       if (test1657_1285)
		 {	/* Effect/spread.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Effect/spread.scm 14 */
		    {	/* Effect/spread.scm 14 */
		       obj_t arg1658_1286;
		       {	/* Effect/spread.scm 14 */
			  obj_t list1659_1287;
			  list1659_1287 =
			     MAKE_PAIR(cnst_port_138_1282, BNIL);
			  arg1658_1286 =
			     read___reader(list1659_1287);
		       }
		       CNST_TABLE_SET(i_1283, arg1658_1286);
		    }
		    {	/* Effect/spread.scm 14 */
		       int aux_1288;
		       {	/* Effect/spread.scm 14 */
			  long aux_1307;
			  aux_1307 =
			     (i_1283 - ((long) 1));
			  aux_1288 =
			     (int) (aux_1307);
		       }
		       {
			  long i_1310;
			  i_1310 =
			     (long) (aux_1288);
			  i_1283 = i_1310;
			  goto loop_1284;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_effect_spread()
{
   AN_OBJECT;
   {	/* Effect/spread.scm 14 */
      return BUNSPEC;
   }
}



/* spread-side-effect*! */
bool_t 
spread_side_effect___103_effect_spread(obj_t node__221_21)
{
   AN_OBJECT;
   {	/* Effect/spread.scm 200 */
      {
	 obj_t node__221_717;
	 bool_t res_718;
	 node__221_717 = node__221_21;
	 res_718 = ((bool_t) 0);
       loop_719:
	 if (
	    NULLP(node__221_717))
	   {	/* Effect/spread.scm 203 */
	      return res_718;
	   }
	 else
	   {	/* Effect/spread.scm 205 */
	      obj_t arg1501_721;
	      bool_t arg1502_722;
	      arg1501_721 =
		 CDR(node__221_717);
	      {		/* Effect/spread.scm 205 */
		 bool_t _ortest_1461_723;
		 {	/* Effect/spread.scm 205 */
		    node_bglt aux_1315;
		    {	/* Effect/spread.scm 205 */
		       obj_t aux_1316;
		       aux_1316 =
			  CAR(node__221_717);
		       aux_1315 =
			  (node_bglt) (aux_1316);
		    }
		    _ortest_1461_723 =
		       spread_side_effect__136_effect_spread(aux_1315);
		 }
		 if (_ortest_1461_723)
		   {	/* Effect/spread.scm 205 */
		      arg1502_722 = _ortest_1461_723;
		   }
		 else
		   {	/* Effect/spread.scm 205 */
		      arg1502_722 = res_718;
		   }
	      }
	      {
		 bool_t res_1322;
		 obj_t node__221_1321;
		 node__221_1321 = arg1501_721;
		 res_1322 = arg1502_722;
		 res_718 = res_1322;
		 node__221_717 = node__221_1321;
		 goto loop_719;
	      }
	   }
      }
   }
}



/* method-init */
obj_t 
method_init_76_effect_spread()
{
   AN_OBJECT;
   {	/* Effect/spread.scm 14 */
      add_generic__110___object(spread_side_effect__env_137_effect_spread, spread_side_effect__default1462_env_203_effect_spread);
      add_inlined_method__244___object(spread_side_effect__env_137_effect_spread, var_ast_node, ((long) 0));
      add_inlined_method__244___object(spread_side_effect__env_137_effect_spread, sequence_ast_node, ((long) 1));
      add_inlined_method__244___object(spread_side_effect__env_137_effect_spread, app_ast_node, ((long) 2));
      add_inlined_method__244___object(spread_side_effect__env_137_effect_spread, app_ly_162_ast_node, ((long) 3));
      add_inlined_method__244___object(spread_side_effect__env_137_effect_spread, funcall_ast_node, ((long) 4));
      add_inlined_method__244___object(spread_side_effect__env_137_effect_spread, pragma_ast_node, ((long) 5));
      add_inlined_method__244___object(spread_side_effect__env_137_effect_spread, cast_ast_node, ((long) 6));
      add_inlined_method__244___object(spread_side_effect__env_137_effect_spread, setq_ast_node, ((long) 7));
      add_inlined_method__244___object(spread_side_effect__env_137_effect_spread, conditional_ast_node, ((long) 8));
      add_inlined_method__244___object(spread_side_effect__env_137_effect_spread, fail_ast_node, ((long) 9));
      add_inlined_method__244___object(spread_side_effect__env_137_effect_spread, select_ast_node, ((long) 10));
      add_inlined_method__244___object(spread_side_effect__env_137_effect_spread, let_fun_218_ast_node, ((long) 11));
      add_inlined_method__244___object(spread_side_effect__env_137_effect_spread, let_var_6_ast_node, ((long) 12));
      add_inlined_method__244___object(spread_side_effect__env_137_effect_spread, set_ex_it_116_ast_node, ((long) 13));
      add_inlined_method__244___object(spread_side_effect__env_137_effect_spread, jump_ex_it_184_ast_node, ((long) 14));
      add_inlined_method__244___object(spread_side_effect__env_137_effect_spread, make_box_202_ast_node, ((long) 15));
      add_inlined_method__244___object(spread_side_effect__env_137_effect_spread, box_set__221_ast_node, ((long) 16));
      {		/* Effect/spread.scm 14 */
	 long aux_1341;
	 aux_1341 =
	    add_inlined_method__244___object(spread_side_effect__env_137_effect_spread, box_ref_242_ast_node, ((long) 17));
	 return
	    BINT(aux_1341);
      }
   }
}



/* spread-side-effect! */
bool_t 
spread_side_effect__136_effect_spread(node_bglt node_1)
{
   AN_OBJECT;
   {	/* Effect/spread.scm 22 */
      {
	 obj_t method1586_1055;
	 obj_t class1591_1056;
	 {	/* Effect/spread.scm 22 */
	    obj_t arg1594_1053;
	    obj_t arg1595_1054;
	    {	/* Effect/spread.scm 22 */
	       object_bglt obj_1185;
	       obj_1185 =
		  (object_bglt) (node_1);
	       {	/* ./Llib/object.scm 2926 */
		  obj_t pre_method_105_1186;
		  pre_method_105_1186 =
		     PROCEDURE_REF(spread_side_effect__env_137_effect_spread, ((long) 2));
		  if (
		     INTEGERP(pre_method_105_1186))
		    {	/* ./Llib/object.scm 2927 */
		       PROCEDURE_SET(spread_side_effect__env_137_effect_spread, ((long) 2), BUNSPEC);
		       arg1594_1053 = pre_method_105_1186;
		    }
		  else
		    {	/* ./Llib/object.scm 2914 */
		       long obj_class_num_177_1191;
		       obj_class_num_177_1191 =
			  TYPE(obj_1185);
		       {	/* ./Llib/object.scm 2915 */
			  obj_t arg1176_1192;
			  arg1176_1192 =
			     PROCEDURE_REF(spread_side_effect__env_137_effect_spread, ((long) 1));
			  {	/* ./Llib/object.scm 2738 */
			     long arg1177_1196;
			     {	/* ./Llib/object.scm 2738 */
				long arg1178_1197;
				arg1178_1197 =
				   OBJECT_TYPE;
				arg1177_1196 =
				   (obj_class_num_177_1191 - arg1178_1197);
			     }
			     arg1594_1053 =
				VECTOR_REF(arg1176_1192, arg1177_1196);
			  }
		       }
		    }
	       }
	    }
	    {	/* Effect/spread.scm 22 */
	       object_bglt object_1202;
	       object_1202 =
		  (object_bglt) (node_1);
	       {	/* ./Llib/object.scm 2695 */
		  long arg1179_1203;
		  {	/* ./Llib/object.scm 2695 */
		     long arg1180_1204;
		     long arg1181_1205;
		     arg1180_1204 =
			TYPE(object_1202);
		     arg1181_1205 =
			OBJECT_TYPE;
		     arg1179_1203 =
			(arg1180_1204 - arg1181_1205);
		  }
		  {	/* ./Llib/object.scm 2695 */
		     obj_t vector_1209;
		     vector_1209 = _classes__134___object;
		     arg1595_1054 =
			VECTOR_REF(vector_1209, arg1179_1203);
		  }
	       }
	    }
	    {	/* Effect/spread.scm 22 */
	       obj_t aux_1359;
	       method1586_1055 = arg1594_1053;
	       class1591_1056 = arg1595_1054;
	       {

		  if (
		     INTEGERP(method1586_1055))
		    {	/* Effect/spread.scm 22 */
		       switch (
			  (long) CINT(method1586_1055))
			 {
			 case ((long) 0):

			    {	/* Effect/spread.scm 29 */
			       var_bglt node_1062;
			       node_1062 =
				  (var_bglt) (node_1);
			       {	/* Effect/spread.scm 29 */
				  bool_t test_1363;
				  {	/* ./Ieee/equiv.scm 5508 */
				     obj_t aux_1367;
				     obj_t aux_1364;
				     aux_1367 =
					CNST_TABLE_REF(((long) 0));
				     {	/* Effect/spread.scm 29 */
					variable_bglt arg1601_1066;
					arg1601_1066 =
					   (((var_bglt) CREF(node_1062))->variable);
					aux_1364 =
					   (((variable_bglt) CREF(arg1601_1066))->access);
				     }
				     test_1363 =
					(aux_1364 == aux_1367);
				  }
				  if (test_1363)
				    {	/* Effect/spread.scm 29 */
				       aux_1359 = BFALSE
					  ;
				    }
				  else
				    {	/* Effect/spread.scm 29 */
				       aux_1359 = BTRUE
					  ;
				    }
			       }
			    }
			    break;
			 case ((long) 1):

			    {	/* Effect/spread.scm 35 */
			       sequence_bglt node_1067;
			       node_1067 =
				  (sequence_bglt) (node_1);
			       {	/* Effect/spread.scm 35 */
				  bool_t res_1068;
				  res_1068 =
				     spread_side_effect___103_effect_spread(
				     (((sequence_bglt) CREF(node_1067))->nodes));
				  {	/* Effect/spread.scm 36 */
				     obj_t val1232_1217;
				     val1232_1217 =
					BBOOL(res_1068);
				     ((((sequence_bglt) CREF(node_1067))->side_effect__165) = ((obj_t) val1232_1217), BUNSPEC);
				  }
				  aux_1359 =
				     BBOOL(res_1068);
			       }
			    }
			    break;
			 case ((long) 2):

			    {	/* Effect/spread.scm 43 */
			       app_bglt node_1070;
			       node_1070 =
				  (app_bglt) (node_1);
			       {	/* Effect/spread.scm 44 */
				  obj_t res_1072;
				  {	/* Effect/spread.scm 44 */
				     bool_t _ortest_1438_1073;
				     _ortest_1438_1073 =
					spread_side_effect___103_effect_spread(
					(((app_bglt) CREF(node_1070))->args));
				     if (_ortest_1438_1073)
				       {	/* Effect/spread.scm 44 */
					  res_1072 =
					     BBOOL(_ortest_1438_1073);
				       }
				     else
				       {	/* Effect/spread.scm 45 */
					  fun_bglt obj_1222;
					  {	/* Effect/spread.scm 45 */
					     value_bglt aux_1381;
					     {	/* Effect/spread.scm 45 */
						variable_bglt arg1604_1075;
						{	/* Effect/spread.scm 45 */
						   var_bglt arg1605_1076;
						   arg1605_1076 =
						      (((app_bglt) CREF(node_1070))->fun);
						   arg1604_1075 =
						      (((var_bglt) CREF(arg1605_1076))->variable);
						}
						aux_1381 =
						   (((variable_bglt) CREF(arg1604_1075))->value);
					     }
					     obj_1222 =
						(fun_bglt) (aux_1381);
					  }
					  res_1072 =
					     (((fun_bglt) CREF(obj_1222))->side_effect__165);
				       }
				  }
				  ((((app_bglt) CREF(node_1070))->side_effect__165) = ((obj_t) res_1072), BUNSPEC);
				  aux_1359 = res_1072;
			       }
			    }
			    break;
			 case ((long) 3):

			    {	/* Effect/spread.scm 53 */
			       app_ly_162_bglt node_1078;
			       node_1078 =
				  (app_ly_162_bglt) (node_1);
			       spread_side_effect__136_effect_spread(
				  (((app_ly_162_bglt) CREF(node_1078))->fun));
			       spread_side_effect__136_effect_spread(
				  (((app_ly_162_bglt) CREF(node_1078))->arg));
			       aux_1359 = BTRUE;
			    }
			    break;
			 case ((long) 4):

			    {	/* Effect/spread.scm 62 */
			       funcall_bglt node_1082;
			       node_1082 =
				  (funcall_bglt) (node_1);
			       spread_side_effect__136_effect_spread(
				  (((funcall_bglt) CREF(node_1082))->fun));
			       spread_side_effect___103_effect_spread(
				  (((funcall_bglt) CREF(node_1082))->args));
			       aux_1359 = BTRUE;
			    }
			    break;
			 case ((long) 5):

			    {	/* Effect/spread.scm 71 */
			       pragma_bglt node_1086;
			       node_1086 =
				  (pragma_bglt) (node_1);
			       {	/* Effect/spread.scm 72 */
				  obj_t res_1088;
				  {	/* Effect/spread.scm 72 */
				     bool_t _ortest_1442_1089;
				     _ortest_1442_1089 =
					spread_side_effect___103_effect_spread(
					(((pragma_bglt) CREF(node_1086))->args));
				     if (_ortest_1442_1089)
				       {	/* Effect/spread.scm 72 */
					  res_1088 =
					     BBOOL(_ortest_1442_1089);
				       }
				     else
				       {	/* Effect/spread.scm 72 */
					  res_1088 =
					     (((pragma_bglt) CREF(node_1086))->side_effect__165);
				       }
				  }
				  ((((pragma_bglt) CREF(node_1086))->side_effect__165) = ((obj_t) res_1088), BUNSPEC);
				  aux_1359 = res_1088;
			       }
			    }
			    break;
			 case ((long) 6):

			    {	/* Effect/spread.scm 80 */
			       cast_bglt node_1091;
			       node_1091 =
				  (cast_bglt) (node_1);
			       {	/* Effect/spread.scm 81 */
				  bool_t aux_1406;
				  aux_1406 =
				     spread_side_effect__136_effect_spread(
				     (((cast_bglt) CREF(node_1091))->arg));
				  aux_1359 =
				     BBOOL(aux_1406);
			       }
			    }
			    break;
			 case ((long) 7):

			    {	/* Effect/spread.scm 87 */
			       setq_bglt node_1094;
			       node_1094 =
				  (setq_bglt) (node_1);
			       spread_side_effect__136_effect_spread(
				  (((setq_bglt) CREF(node_1094))->value));
			       aux_1359 = BTRUE;
			    }
			    break;
			 case ((long) 8):

			    {	/* Effect/spread.scm 95 */
			       conditional_bglt node_1097;
			       node_1097 =
				  (conditional_bglt) (node_1);
			       {	/* Effect/spread.scm 96 */
				  bool_t res_test_153_1099;
				  res_test_153_1099 =
				     spread_side_effect__136_effect_spread(
				     (((conditional_bglt) CREF(node_1097))->test));
				  {	/* Effect/spread.scm 96 */
				     bool_t res_true_149_1100;
				     res_true_149_1100 =
					spread_side_effect__136_effect_spread(
					(((conditional_bglt) CREF(node_1097))->true));
				     {	/* Effect/spread.scm 97 */
					bool_t res_false_133_1101;
					res_false_133_1101 =
					   spread_side_effect__136_effect_spread(
					   (((conditional_bglt) CREF(node_1097))->false));
					{	/* Effect/spread.scm 98 */
					   bool_t res_1102;
					   if (res_test_153_1099)
					     {	/* Effect/spread.scm 99 */
						res_1102 = res_test_153_1099;
					     }
					   else
					     {	/* Effect/spread.scm 99 */
						if (res_true_149_1100)
						  {	/* Effect/spread.scm 99 */
						     res_1102 = res_true_149_1100;
						  }
						else
						  {	/* Effect/spread.scm 99 */
						     res_1102 = res_false_133_1101;
						  }
					     }
					   {	/* Effect/spread.scm 99 */

					      {		/* Effect/spread.scm 100 */
						 obj_t val1312_1239;
						 val1312_1239 =
						    BBOOL(res_1102);
						 ((((conditional_bglt) CREF(node_1097))->side_effect__165) = ((obj_t) val1312_1239), BUNSPEC);
					      }
					      aux_1359 =
						 BBOOL(res_1102);
					   }
					}
				     }
				  }
			       }
			    }
			    break;
			 case ((long) 9):

			    {	/* Effect/spread.scm 107 */
			       fail_bglt node_1108;
			       node_1108 =
				  (fail_bglt) (node_1);
			       {	/* Effect/spread.scm 108 */
				  bool_t res_proc_202_1110;
				  res_proc_202_1110 =
				     spread_side_effect__136_effect_spread(
				     (((fail_bglt) CREF(node_1108))->proc));
				  {	/* Effect/spread.scm 108 */
				     bool_t res_msg_53_1111;
				     res_msg_53_1111 =
					spread_side_effect__136_effect_spread(
					(((fail_bglt) CREF(node_1108))->msg));
				     {	/* Effect/spread.scm 109 */
					bool_t res_obj_160_1112;
					res_obj_160_1112 =
					   spread_side_effect__136_effect_spread(
					   (((fail_bglt) CREF(node_1108))->obj));
					{	/* Effect/spread.scm 110 */

					   aux_1359 = BTRUE;
					}
				     }
				  }
			       }
			    }
			    break;
			 case ((long) 10):

			    {	/* Effect/spread.scm 117 */
			       select_bglt node_1116;
			       node_1116 =
				  (select_bglt) (node_1);
			       {
				  obj_t clauses_1118;
				  bool_t res_1119;
				  {	/* Effect/spread.scm 118 */
				     obj_t arg1620_1121;
				     bool_t arg1621_1122;
				     arg1620_1121 =
					(((select_bglt) CREF(node_1116))->clauses);
				     arg1621_1122 =
					spread_side_effect__136_effect_spread(
					(((select_bglt) CREF(node_1116))->test));
				     {	/* Effect/spread.scm 118 */
					bool_t aux_1436;
					clauses_1118 = arg1620_1121;
					res_1119 = arg1621_1122;
				      loop_1120:
					if (
					   NULLP(clauses_1118))
					  {	/* Effect/spread.scm 120 */
					     {	/* Effect/spread.scm 122 */
						obj_t val1340_1247;
						val1340_1247 =
						   BBOOL(res_1119);
						((((select_bglt) CREF(node_1116))->side_effect__165) = ((obj_t) val1340_1247), BUNSPEC);
					     }
					     aux_1436 = res_1119;
					  }
					else
					  {	/* Effect/spread.scm 124 */
					     obj_t arg1624_1125;
					     bool_t arg1625_1126;
					     arg1624_1125 =
						CDR(clauses_1118);
					     {	/* Effect/spread.scm 125 */
						bool_t _ortest_1450_1127;
						{	/* Effect/spread.scm 125 */
						   node_bglt aux_1442;
						   {	/* Effect/spread.scm 125 */
						      obj_t aux_1443;
						      {		/* ./Ieee/pair-list.scm 5707 */
							 obj_t aux_1444;
							 aux_1444 =
							    CAR(clauses_1118);
							 aux_1443 =
							    CDR(aux_1444);
						      }
						      aux_1442 =
							 (node_bglt) (aux_1443);
						   }
						   _ortest_1450_1127 =
						      spread_side_effect__136_effect_spread(aux_1442);
						}
						if (_ortest_1450_1127)
						  {	/* Effect/spread.scm 125 */
						     arg1625_1126 = _ortest_1450_1127;
						  }
						else
						  {	/* Effect/spread.scm 125 */
						     arg1625_1126 = res_1119;
						  }
					     }
					     {
						bool_t res_1451;
						obj_t clauses_1450;
						clauses_1450 = arg1624_1125;
						res_1451 = arg1625_1126;
						res_1119 = res_1451;
						clauses_1118 = clauses_1450;
						goto loop_1120;
					     }
					  }
					aux_1359 =
					   BBOOL(aux_1436);
				     }
				  }
			       }
			    }
			    break;
			 case ((long) 11):

			    {	/* Effect/spread.scm 131 */
			       let_fun_218_bglt node_1130;
			       node_1130 =
				  (let_fun_218_bglt) (node_1);
			       {
				  obj_t l1452_1132;
				  l1452_1132 =
				     (((let_fun_218_bglt) CREF(node_1130))->locals);
				lname1453_1133:
				  if (
				     PAIRP(l1452_1132))
				    {	/* Effect/spread.scm 132 */
				       {	/* Effect/spread.scm 133 */
					  node_bglt aux_1456;
					  {	/* Effect/spread.scm 133 */
					     obj_t aux_1457;
					     {	/* Effect/spread.scm 133 */
						sfun_bglt obj_1255;
						{	/* Effect/spread.scm 133 */
						   value_bglt aux_1458;
						   {	/* Effect/spread.scm 133 */
						      local_bglt obj_1254;
						      {		/* Effect/spread.scm 133 */
							 obj_t aux_1459;
							 aux_1459 =
							    CAR(l1452_1132);
							 obj_1254 =
							    (local_bglt) (aux_1459);
						      }
						      aux_1458 =
							 (((local_bglt) CREF(obj_1254))->value);
						   }
						   obj_1255 =
						      (sfun_bglt) (aux_1458);
						}
						aux_1457 =
						   (((sfun_bglt) CREF(obj_1255))->body);
					     }
					     aux_1456 =
						(node_bglt) (aux_1457);
					  }
					  spread_side_effect__136_effect_spread(aux_1456);
				       }
				       {
					  obj_t l1452_1467;
					  l1452_1467 =
					     CDR(l1452_1132);
					  l1452_1132 = l1452_1467;
					  goto lname1453_1133;
				       }
				    }
				  else
				    {	/* Effect/spread.scm 132 */
				       ((bool_t) 1);
				    }
			       }
			       {	/* Effect/spread.scm 135 */
				  bool_t res_1140;
				  res_1140 =
				     spread_side_effect__136_effect_spread(
				     (((let_fun_218_bglt) CREF(node_1130))->body));
				  {	/* Effect/spread.scm 136 */
				     obj_t val1354_1259;
				     val1354_1259 =
					BBOOL(res_1140);
				     ((((let_fun_218_bglt) CREF(node_1130))->side_effect__165) = ((obj_t) val1354_1259), BUNSPEC);
				  }
				  aux_1359 =
				     BBOOL(res_1140);
			       }
			    }
			    break;
			 case ((long) 12):

			    {	/* Effect/spread.scm 143 */
			       let_var_6_bglt node_1142;
			       node_1142 =
				  (let_var_6_bglt) (node_1);
			       {
				  obj_t bdgs_1144;
				  bool_t res_1145;
				  {	/* Effect/spread.scm 144 */
				     obj_t arg1634_1147;
				     bool_t arg1635_1148;
				     arg1634_1147 =
					(((let_var_6_bglt) CREF(node_1142))->bindings);
				     arg1635_1148 =
					spread_side_effect__136_effect_spread(
					(((let_var_6_bglt) CREF(node_1142))->body));
				     {	/* Effect/spread.scm 144 */
					bool_t aux_1479;
					bdgs_1144 = arg1634_1147;
					res_1145 = arg1635_1148;
				      loop_1146:
					if (
					   NULLP(bdgs_1144))
					  {	/* Effect/spread.scm 146 */
					     {	/* Effect/spread.scm 148 */
						obj_t val1368_1264;
						val1368_1264 =
						   BBOOL(res_1145);
						((((let_var_6_bglt) CREF(node_1142))->side_effect__165) = ((obj_t) val1368_1264), BUNSPEC);
					     }
					     aux_1479 = res_1145;
					  }
					else
					  {	/* Effect/spread.scm 150 */
					     obj_t arg1638_1151;
					     bool_t arg1639_1152;
					     arg1638_1151 =
						CDR(bdgs_1144);
					     {	/* Effect/spread.scm 151 */
						bool_t _ortest_1455_1153;
						{	/* Effect/spread.scm 151 */
						   node_bglt aux_1485;
						   {	/* Effect/spread.scm 151 */
						      obj_t aux_1486;
						      {		/* ./Ieee/pair-list.scm 5707 */
							 obj_t aux_1487;
							 aux_1487 =
							    CAR(bdgs_1144);
							 aux_1486 =
							    CDR(aux_1487);
						      }
						      aux_1485 =
							 (node_bglt) (aux_1486);
						   }
						   _ortest_1455_1153 =
						      spread_side_effect__136_effect_spread(aux_1485);
						}
						if (_ortest_1455_1153)
						  {	/* Effect/spread.scm 151 */
						     arg1639_1152 = _ortest_1455_1153;
						  }
						else
						  {	/* Effect/spread.scm 151 */
						     arg1639_1152 = res_1145;
						  }
					     }
					     {
						bool_t res_1494;
						obj_t bdgs_1493;
						bdgs_1493 = arg1638_1151;
						res_1494 = arg1639_1152;
						res_1145 = res_1494;
						bdgs_1144 = bdgs_1493;
						goto loop_1146;
					     }
					  }
					aux_1359 =
					   BBOOL(aux_1479);
				     }
				  }
			       }
			    }
			    break;
			 case ((long) 13):

			    {	/* Effect/spread.scm 157 */
			       set_ex_it_116_bglt node_1156;
			       node_1156 =
				  (set_ex_it_116_bglt) (node_1);
			       {	/* Effect/spread.scm 158 */
				  bool_t aux_1497;
				  aux_1497 =
				     spread_side_effect__136_effect_spread(
				     (((set_ex_it_116_bglt) CREF(node_1156))->body));
				  aux_1359 =
				     BBOOL(aux_1497);
			       }
			    }
			    break;
			 case ((long) 14):

			    {	/* Effect/spread.scm 164 */
			       jump_ex_it_184_bglt node_1159;
			       node_1159 =
				  (jump_ex_it_184_bglt) (node_1);
			       spread_side_effect__136_effect_spread(
				  (((jump_ex_it_184_bglt) CREF(node_1159))->exit));
			       spread_side_effect__136_effect_spread(
				  (((jump_ex_it_184_bglt) CREF(node_1159))->value));
			       aux_1359 = BTRUE;
			    }
			    break;
			 case ((long) 15):

			    {	/* Effect/spread.scm 173 */
			       make_box_202_bglt node_1163;
			       node_1163 =
				  (make_box_202_bglt) (node_1);
			       {	/* Effect/spread.scm 174 */
				  bool_t res_1165;
				  res_1165 =
				     spread_side_effect__136_effect_spread(
				     (((make_box_202_bglt) CREF(node_1163))->value));
				  {	/* Effect/spread.scm 175 */
				     obj_t val1404_1273;
				     val1404_1273 =
					BBOOL(res_1165);
				     ((((make_box_202_bglt) CREF(node_1163))->side_effect__165) = ((obj_t) val1404_1273), BUNSPEC);
				  }
				  aux_1359 =
				     BBOOL(res_1165);
			       }
			    }
			    break;
			 case ((long) 16):

			    {	/* Effect/spread.scm 182 */
			       box_set__221_bglt node_1167;
			       node_1167 =
				  (box_set__221_bglt) (node_1);
			       spread_side_effect__136_effect_spread(
				  (((box_set__221_bglt) CREF(node_1167))->value));
			       aux_1359 = BTRUE;
			    }
			    break;
			 case ((long) 17):

			    {	/* Effect/spread.scm 194 */
			       box_ref_242_bglt node_1170;
			       node_1170 =
				  (box_ref_242_bglt) (node_1);
			       {	/* Effect/spread.scm 195 */
				  bool_t aux_1516;
				  {	/* Effect/spread.scm 195 */
				     node_bglt aux_1517;
				     {	/* Effect/spread.scm 195 */
					var_bglt aux_1518;
					aux_1518 =
					   (((box_ref_242_bglt) CREF(node_1170))->var);
					aux_1517 =
					   (node_bglt) (aux_1518);
				     }
				     aux_1516 =
					spread_side_effect__136_effect_spread(aux_1517);
				  }
				  aux_1359 =
				     BBOOL(aux_1516);
			       }
			    }
			    break;
			 default:
			  case_else1592_1059:
			    if (
			       PROCEDUREP(method1586_1055))
			      {		/* Effect/spread.scm 22 */
				 aux_1359 =
				    PROCEDURE_ENTRY(method1586_1055) (method1586_1055,
				    (obj_t) (node_1), BEOA)
				    ;
			      }
			    else
			      {		/* Effect/spread.scm 22 */
				 obj_t fun1585_1051;
				 fun1585_1051 =
				    PROCEDURE_REF(spread_side_effect__env_137_effect_spread, ((long) 0));
				 aux_1359 =
				    PROCEDURE_ENTRY(fun1585_1051) (fun1585_1051,
				    (obj_t) (node_1), BEOA);
			      }
			 }
		    }
		  else
		    {	/* Effect/spread.scm 22 */
		       goto case_else1592_1059;
		    }
	       }
	       return
		  CBOOL(aux_1359);
	    }
	 }
      }
   }
}



/* _spread-side-effect!1655 */
obj_t 
_spread_side_effect_1655_137_effect_spread(obj_t env_1278, obj_t node_1279)
{
   AN_OBJECT;
   {	/* Effect/spread.scm 22 */
      {		/* Effect/spread.scm 22 */
	 bool_t aux_1535;
	 aux_1535 =
	    spread_side_effect__136_effect_spread(
	    (node_bglt) (node_1279));
	 return
	    BBOOL(aux_1535);
      }
   }
}



/* spread-side-effect!-default1462 */
bool_t 
spread_side_effect__default1462_185_effect_spread(node_bglt node_2)
{
   AN_OBJECT;
   {	/* Effect/spread.scm 14 */
      return ((bool_t) 0);
   }
}



/* _spread-side-effect!-default1462 */
obj_t 
_spread_side_effect__default1462_34_effect_spread(obj_t env_1280, obj_t node_1281)
{
   AN_OBJECT;
   {	/* Effect/spread.scm 14 */
      {		/* Effect/spread.scm 14 */
	 bool_t aux_1539;
	 aux_1539 =
	    spread_side_effect__default1462_185_effect_spread(
	    (node_bglt) (node_1281));
	 return
	    BBOOL(aux_1539);
      }
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_effect_spread()
{
   AN_OBJECT;
   {	/* Effect/spread.scm 14 */
      module_initialization_70_type_type(((long) 0), "EFFECT_SPREAD");
      module_initialization_70_ast_var(((long) 0), "EFFECT_SPREAD");
      return
	 module_initialization_70_ast_node(((long) 0), "EFFECT_SPREAD");
   }
}
