/*===========================================================================*/
/*   (Effect/walk.scm)                                                       */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;

typedef struct local_from_91
  {
     obj_t from;
  }
             *local_from_91_bglt;

typedef struct global_from_205
  {
     obj_t from;
  }
               *global_from_205_bglt;


static obj_t method_init_76_effect_walk();
extern obj_t current_error_port;
extern obj_t _nb_error_on_pass__70_tools_error;
extern obj_t verbose_tools_speek(obj_t, obj_t);
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t module_initialization_70_effect_walk(long, char *);
extern obj_t module_initialization_70_tools_speek(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_engine_pass(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_effect_cgraph(long, char *);
extern obj_t module_initialization_70_effect_spread(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_numbers_6_5(long, char *);
extern obj_t module_initialization_70___r4_output_6_10_3(long, char *);
extern obj_t local_from_91_effect_cgraph;
extern obj_t get_var_all_239_effect_cgraph();
extern bool_t spread_side_effect__136_effect_spread(node_bglt);
static obj_t iterate_to_fix_point__167_effect_walk(obj_t);
extern obj_t display_2_122___r4_output_6_10_3(obj_t, obj_t);
static obj_t imported_modules_init_94_effect_walk();
extern obj_t effect_walk__175_effect_walk(obj_t);
static obj_t library_modules_init_112_effect_walk();
extern obj_t fun_call_graph__231_effect_cgraph(variable_bglt);
extern obj_t open_input_string(obj_t);
extern obj_t string_to_bstring(char *);
extern obj_t global_from_205_effect_cgraph;
static obj_t _effect_walk__96_effect_walk(obj_t, obj_t);
extern obj_t internal_error_43_tools_error(obj_t, obj_t, obj_t);
extern bool_t _2__206___r4_numbers_6_5(obj_t, obj_t);
extern obj_t read___reader(obj_t);
static obj_t require_initialization_114_effect_walk = BUNSPEC;
extern obj_t get_var_side_effect_0_effect_cgraph();
static obj_t cnst_init_137_effect_walk();
extern obj_t _current_pass__25_engine_pass;
static obj_t __cnst[3];

extern obj_t reset_effect_tables__env_101_effect_cgraph;
DEFINE_EXPORT_PROCEDURE(effect_walk__env_176_effect_walk, _effect_walk__96_effect_walk1629, _effect_walk__96_effect_walk, 0L, 1);
DEFINE_STRING(string1624_effect_walk, string1624_effect_walk1630, "DONE (RESET-EFFECT-TABLES!) PASS-STARTED ", 41);
DEFINE_STRING(string1623_effect_walk, string1623_effect_walk1631, "failure during postlude hook", 28);
DEFINE_STRING(string1622_effect_walk, string1622_effect_walk1632, " occured, ending ...", 20);
DEFINE_STRING(string1621_effect_walk, string1621_effect_walk1633, " error", 6);
DEFINE_STRING(string1619_effect_walk, string1619_effect_walk1634, "   . ", 5);
DEFINE_STRING(string1620_effect_walk, string1620_effect_walk1635, "failure during prelude hook", 27);
DEFINE_STRING(string1618_effect_walk, string1618_effect_walk1636, "Effect", 6);



/* module-initialization */
obj_t 
module_initialization_70_effect_walk(long checksum_1311, char *from_1312)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_effect_walk))
	{
	   require_initialization_114_effect_walk =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_effect_walk();
	   cnst_init_137_effect_walk();
	   imported_modules_init_94_effect_walk();
	   method_init_76_effect_walk();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_effect_walk()
{
   AN_OBJECT;
   {	/* Effect/walk.scm 14 */
      module_initialization_70___object(((long) 0), "EFFECT_WALK");
      module_initialization_70___r4_output_6_10_3(((long) 0), "EFFECT_WALK");
      module_initialization_70___r4_numbers_6_5(((long) 0), "EFFECT_WALK");
      module_initialization_70___reader(((long) 0), "EFFECT_WALK");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_effect_walk()
{
   AN_OBJECT;
   {	/* Effect/walk.scm 14 */
      {		/* Effect/walk.scm 14 */
	 obj_t cnst_port_138_1304;
	 cnst_port_138_1304 =
	    open_input_string(string1624_effect_walk);
	 {
	    long i_1305;
	    i_1305 = ((long) 2);
	  loop_1306:
	    {	/* Effect/walk.scm 14 */
	       bool_t test1625_1307;
	       test1625_1307 =
		  (i_1305 == ((long) -1));
	       if (test1625_1307)
		 {	/* Effect/walk.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Effect/walk.scm 14 */
		    {	/* Effect/walk.scm 14 */
		       obj_t arg1626_1308;
		       {	/* Effect/walk.scm 14 */
			  obj_t list1627_1309;
			  list1627_1309 =
			     MAKE_PAIR(cnst_port_138_1304, BNIL);
			  arg1626_1308 =
			     read___reader(list1627_1309);
		       }
		       CNST_TABLE_SET(i_1305, arg1626_1308);
		    }
		    {	/* Effect/walk.scm 14 */
		       int aux_1310;
		       {	/* Effect/walk.scm 14 */
			  long aux_1330;
			  aux_1330 =
			     (i_1305 - ((long) 1));
			  aux_1310 =
			     (int) (aux_1330);
		       }
		       {
			  long i_1333;
			  i_1333 =
			     (long) (aux_1310);
			  i_1305 = i_1333;
			  goto loop_1306;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* effect-walk! */
obj_t 
effect_walk__175_effect_walk(obj_t globals_1)
{
   AN_OBJECT;
   {	/* Effect/walk.scm 28 */
      {		/* Effect/walk.scm 28 */
	 obj_t list1480_800;
	 {	/* Effect/walk.scm 28 */
	    obj_t arg1482_802;
	    {	/* Effect/walk.scm 28 */
	       obj_t arg1484_804;
	       {	/* Effect/walk.scm 28 */
		  obj_t aux_1335;
		  aux_1335 =
		     BCHAR(((unsigned char) '\n'));
		  arg1484_804 =
		     MAKE_PAIR(aux_1335, BNIL);
	       }
	       arg1482_802 =
		  MAKE_PAIR(string1618_effect_walk, arg1484_804);
	    }
	    list1480_800 =
	       MAKE_PAIR(string1619_effect_walk, arg1482_802);
	 }
	 verbose_tools_speek(
	    BINT(((long) 1)), list1480_800);
      }
      _nb_error_on_pass__70_tools_error =
	 BINT(((long) 0));
      _current_pass__25_engine_pass = string1618_effect_walk;
      {
	 obj_t hooks_805;
	 obj_t hnames_806;
	 hooks_805 = BNIL;
	 hnames_806 = BNIL;
       loop_807:
	 if (
	    NULLP(hooks_805))
	   {	/* Effect/walk.scm 28 */
	      CNST_TABLE_REF(((long) 0));
	   }
	 else
	   {	/* Effect/walk.scm 28 */
	      bool_t test1489_812;
	      {		/* Effect/walk.scm 28 */
		 obj_t fun1496_818;
		 fun1496_818 =
		    CAR(hooks_805);
		 {	/* Effect/walk.scm 28 */
		    obj_t aux_1347;
		    aux_1347 =
		       PROCEDURE_ENTRY(fun1496_818) (fun1496_818, BEOA);
		    test1489_812 =
		       CBOOL(aux_1347);
		 }
	      }
	      if (test1489_812)
		{	/* Effect/walk.scm 28 */
		   {
		      obj_t hnames_1354;
		      obj_t hooks_1352;
		      hooks_1352 =
			 CDR(hooks_805);
		      hnames_1354 =
			 CDR(hnames_806);
		      hnames_806 = hnames_1354;
		      hooks_805 = hooks_1352;
		      goto loop_807;
		   }
		}
	      else
		{	/* Effect/walk.scm 28 */
		   internal_error_43_tools_error(string1618_effect_walk, string1620_effect_walk,
		      CAR(hnames_806));
		}
	   }
      }
      {
	 obj_t l1471_819;
	 l1471_819 = globals_1;
       lname1472_820:
	 if (
	    PAIRP(l1471_819))
	   {	/* Effect/walk.scm 32 */
	      {		/* Effect/walk.scm 33 */
		 variable_bglt aux_1360;
		 {	/* Effect/walk.scm 33 */
		    obj_t aux_1361;
		    aux_1361 =
		       CAR(l1471_819);
		    aux_1360 =
		       (variable_bglt) (aux_1361);
		 }
		 fun_call_graph__231_effect_cgraph(aux_1360);
	      }
	      {
		 obj_t l1471_1365;
		 l1471_1365 =
		    CDR(l1471_819);
		 l1471_819 = l1471_1365;
		 goto lname1472_820;
	      }
	   }
	 else
	   {	/* Effect/walk.scm 32 */
	      ((bool_t) 1);
	   }
      }
      {		/* Effect/walk.scm 37 */
	 obj_t arg1499_824;
	 arg1499_824 =
	    get_var_side_effect_0_effect_cgraph();
	 iterate_to_fix_point__167_effect_walk(arg1499_824);
      }
      {
	 obj_t l1473_825;
	 {	/* Effect/walk.scm 43 */
	    obj_t arg1500_827;
	    arg1500_827 =
	       get_var_all_239_effect_cgraph();
	    l1473_825 = arg1500_827;
	  lname1474_826:
	    if (
	       PAIRP(l1473_825))
	      {		/* Effect/walk.scm 39 */
		 {	/* Effect/walk.scm 40 */
		    value_bglt fun_830;
		    {	/* Effect/walk.scm 40 */
		       variable_bglt obj_1226;
		       {	/* Effect/walk.scm 40 */
			  obj_t aux_1372;
			  aux_1372 =
			     CAR(l1473_825);
			  obj_1226 =
			     (variable_bglt) (aux_1372);
		       }
		       fun_830 =
			  (((variable_bglt) CREF(obj_1226))->value);
		    }
		    {	/* Effect/walk.scm 41 */
		       bool_t test_1376;
		       {	/* ./Ieee/equiv.scm 5508 */
			  obj_t aux_1377;
			  {	/* Effect/walk.scm 41 */
			     fun_bglt obj_1227;
			     obj_1227 =
				(fun_bglt) (fun_830);
			     aux_1377 =
				(((fun_bglt) CREF(obj_1227))->side_effect__165);
			  }
			  test_1376 =
			     (aux_1377 == BUNSPEC);
		       }
		       if (test_1376)
			 {	/* Effect/walk.scm 42 */
			    fun_bglt obj_1230;
			    obj_t val1102_1231;
			    obj_1230 =
			       (fun_bglt) (fun_830);
			    val1102_1231 = BFALSE;
			    ((((fun_bglt) CREF(obj_1230))->side_effect__165) = ((obj_t) val1102_1231), BUNSPEC);
			 }
		       else
			 {	/* Effect/walk.scm 41 */
			    BUNSPEC;
			 }
		    }
		 }
		 {
		    obj_t l1473_1383;
		    l1473_1383 =
		       CDR(l1473_825);
		    l1473_825 = l1473_1383;
		    goto lname1474_826;
		 }
	      }
	    else
	      {		/* Effect/walk.scm 39 */
		 ((bool_t) 1);
	      }
	 }
      }
      {
	 obj_t l1475_834;
	 l1475_834 = globals_1;
       lname1476_835:
	 if (
	    PAIRP(l1475_834))
	   {	/* Effect/walk.scm 46 */
	      {		/* Effect/walk.scm 47 */
		 node_bglt aux_1387;
		 {	/* Effect/walk.scm 47 */
		    obj_t aux_1388;
		    {	/* Effect/walk.scm 47 */
		       sfun_bglt obj_1236;
		       {	/* Effect/walk.scm 47 */
			  value_bglt aux_1389;
			  {	/* Effect/walk.scm 47 */
			     global_bglt obj_1235;
			     {	/* Effect/walk.scm 47 */
				obj_t aux_1390;
				aux_1390 =
				   CAR(l1475_834);
				obj_1235 =
				   (global_bglt) (aux_1390);
			     }
			     aux_1389 =
				(((global_bglt) CREF(obj_1235))->value);
			  }
			  obj_1236 =
			     (sfun_bglt) (aux_1389);
		       }
		       aux_1388 =
			  (((sfun_bglt) CREF(obj_1236))->body);
		    }
		    aux_1387 =
		       (node_bglt) (aux_1388);
		 }
		 spread_side_effect__136_effect_spread(aux_1387);
	      }
	      {
		 obj_t l1475_1398;
		 l1475_1398 =
		    CDR(l1475_834);
		 l1475_834 = l1475_1398;
		 goto lname1476_835;
	      }
	   }
	 else
	   {	/* Effect/walk.scm 46 */
	      ((bool_t) 1);
	   }
      }
      {		/* Effect/walk.scm 51 */
	 bool_t test1510_842;
	 {	/* Effect/walk.scm 51 */
	    long n1_1238;
	    n1_1238 =
	       (long) CINT(_nb_error_on_pass__70_tools_error);
	    test1510_842 =
	       (n1_1238 > ((long) 0));
	 }
	 if (test1510_842)
	   {	/* Effect/walk.scm 51 */
	      display_2_122___r4_output_6_10_3(_nb_error_on_pass__70_tools_error, current_error_port);
	      display_2_122___r4_output_6_10_3(string1621_effect_walk, current_error_port);
	      {		/* Effect/walk.scm 51 */
		 char *arg1511_844;
		 {	/* Effect/walk.scm 51 */
		    bool_t test1512_845;
		    {	/* Effect/walk.scm 51 */
		       bool_t test1513_846;
		       {	/* Effect/walk.scm 51 */
			  obj_t obj_1240;
			  obj_1240 = _nb_error_on_pass__70_tools_error;
			  test1513_846 =
			     INTEGERP(obj_1240);
		       }
		       if (test1513_846)
			 {	/* Effect/walk.scm 51 */
			    test1512_845 =
			       _2__206___r4_numbers_6_5(_nb_error_on_pass__70_tools_error,
			       BINT(((long) 1)));
			 }
		       else
			 {	/* Effect/walk.scm 51 */
			    test1512_845 = ((bool_t) 0);
			 }
		    }
		    if (test1512_845)
		      {		/* Effect/walk.scm 51 */
			 arg1511_844 = "s";
		      }
		    else
		      {		/* Effect/walk.scm 51 */
			 arg1511_844 = "";
		      }
		 }
		 display_2_122___r4_output_6_10_3(
		    string_to_bstring(arg1511_844), current_error_port);
	      }
	      display_2_122___r4_output_6_10_3(string1622_effect_walk, current_error_port);
	      WRITE_CHAR(((unsigned char) '\n'), current_error_port);
	      {		/* Effect/walk.scm 51 */
		 obj_t res1617_1243;
		 exit(((long) -1));
		 res1617_1243 =
		    BINT(((long) -1));
		 return res1617_1243;
	      }
	   }
	 else
	   {
	      obj_t hooks_847;
	      obj_t hnames_848;
	      {		/* Effect/walk.scm 51 */
		 obj_t arg1514_850;
		 obj_t arg1515_851;
		 {	/* Effect/walk.scm 51 */
		    obj_t list1516_852;
		    list1516_852 =
		       MAKE_PAIR(reset_effect_tables__env_101_effect_cgraph, BNIL);
		    arg1514_850 = list1516_852;
		 }
		 arg1515_851 =
		    CNST_TABLE_REF(((long) 1));
		 hooks_847 = arg1514_850;
		 hnames_848 = arg1515_851;
	       loop_849:
		 if (
		    NULLP(hooks_847))
		   {	/* Effect/walk.scm 51 */
		      return globals_1;
		   }
		 else
		   {	/* Effect/walk.scm 51 */
		      bool_t test1518_854;
		      {		/* Effect/walk.scm 51 */
			 obj_t fun1523_859;
			 fun1523_859 =
			    CAR(hooks_847);
			 {	/* Effect/walk.scm 51 */
			    obj_t aux_1421;
			    aux_1421 =
			       PROCEDURE_ENTRY(fun1523_859) (fun1523_859, BEOA);
			    test1518_854 =
			       CBOOL(aux_1421);
			 }
		      }
		      if (test1518_854)
			{	/* Effect/walk.scm 51 */
			   {
			      obj_t hnames_1428;
			      obj_t hooks_1426;
			      hooks_1426 =
				 CDR(hooks_847);
			      hnames_1428 =
				 CDR(hnames_848);
			      hnames_848 = hnames_1428;
			      hooks_847 = hooks_1426;
			      goto loop_849;
			   }
			}
		      else
			{	/* Effect/walk.scm 51 */
			   return
			      internal_error_43_tools_error(_current_pass__25_engine_pass, string1623_effect_walk,
			      CAR(hnames_848));
			}
		   }
	      }
	   }
      }
   }
}



/* _effect-walk! */
obj_t 
_effect_walk__96_effect_walk(obj_t env_1301, obj_t globals_1302)
{
   AN_OBJECT;
   {	/* Effect/walk.scm 28 */
      return
	 effect_walk__175_effect_walk(globals_1302);
   }
}



/* iterate-to-fix-point! */
obj_t 
iterate_to_fix_point__167_effect_walk(obj_t w_2)
{
   AN_OBJECT;
   {	/* Effect/walk.scm 56 */
      if (
	 NULLP(w_2))
	{	/* Effect/walk.scm 57 */
	   return
	      CNST_TABLE_REF(((long) 2));
	}
      else
	{
	   obj_t l1478_861;
	   {	/* Effect/walk.scm 59 */
	      bool_t aux_1436;
	      l1478_861 = w_2;
	    lname1479_862:
	      if (
		 PAIRP(l1478_861))
		{	/* Effect/walk.scm 59 */
		   {	/* Effect/walk.scm 61 */
		      obj_t var_864;
		      var_864 =
			 CAR(l1478_861);
		      {		/* Effect/walk.scm 61 */
			 value_bglt fun_865;
			 {	/* Effect/walk.scm 61 */
			    variable_bglt obj_1253;
			    obj_1253 =
			       (variable_bglt) (var_864);
			    fun_865 =
			       (((variable_bglt) CREF(obj_1253))->value);
			 }
			 {	/* Effect/walk.scm 62 */
			    bool_t test_1442;
			    {	/* ./Ieee/equiv.scm 5508 */
			       obj_t aux_1443;
			       {	/* Effect/walk.scm 62 */
				  fun_bglt obj_1254;
				  obj_1254 =
				     (fun_bglt) (fun_865);
				  aux_1443 =
				     (((fun_bglt) CREF(obj_1254))->side_effect__165);
			       }
			       test_1442 =
				  (aux_1443 == BTRUE);
			    }
			    if (test_1442)
			      {		/* Effect/walk.scm 62 */
				 BUNSPEC;
			      }
			    else
			      {		/* Effect/walk.scm 62 */
				 {	/* Effect/walk.scm 64 */
				    fun_bglt obj_1257;
				    obj_t val1102_1258;
				    obj_1257 =
				       (fun_bglt) (fun_865);
				    val1102_1258 = BTRUE;
				    ((((fun_bglt) CREF(obj_1257))->side_effect__165) = ((obj_t) val1102_1258), BUNSPEC);
				 }
				 {	/* Effect/walk.scm 66 */
				    bool_t test1527_867;
				    test1527_867 =
				       is_a__118___object(var_864, local_from_91_effect_cgraph);
				    if (test1527_867)
				      {		/* Effect/walk.scm 66 */
					 {	/* Effect/walk.scm 67 */
					    obj_t aux_1451;
					    {	/* Effect/walk.scm 67 */
					       local_from_91_bglt obj_1260;
					       obj_1260 =
						  (local_from_91_bglt) (var_864);
					       {
						  obj_t aux_1453;
						  {	/* ./Effect/cgraph.scm 921 */
						     object_bglt aux_1454;
						     aux_1454 =
							(object_bglt) (obj_1260);
						     aux_1453 =
							OBJECT_WIDENING(aux_1454);
						  }
						  aux_1451 =
						     (((local_from_91_bglt) CREF(aux_1453))->from);
					       }
					    }
					    iterate_to_fix_point__167_effect_walk(aux_1451);
					 }
				      }
				    else
				      {		/* Effect/walk.scm 68 */
					 bool_t test1529_869;
					 test1529_869 =
					    is_a__118___object(var_864, global_from_205_effect_cgraph);
					 if (test1529_869)
					   {	/* Effect/walk.scm 68 */
					      {		/* Effect/walk.scm 69 */
						 obj_t aux_1461;
						 {	/* Effect/walk.scm 69 */
						    global_from_205_bglt obj_1262;
						    obj_1262 =
						       (global_from_205_bglt) (var_864);
						    {
						       obj_t aux_1463;
						       {	/* ./Effect/cgraph.scm 922 */
							  object_bglt aux_1464;
							  aux_1464 =
							     (object_bglt) (obj_1262);
							  aux_1463 =
							     OBJECT_WIDENING(aux_1464);
						       }
						       aux_1461 =
							  (((global_from_205_bglt) CREF(aux_1463))->from);
						    }
						 }
						 iterate_to_fix_point__167_effect_walk(aux_1461);
					      }
					   }
					 else
					   {	/* Effect/walk.scm 68 */
					      BFALSE;
					   }
				      }
				 }
			      }
			 }
		      }
		   }
		   {
		      obj_t l1478_1469;
		      l1478_1469 =
			 CDR(l1478_861);
		      l1478_861 = l1478_1469;
		      goto lname1479_862;
		   }
		}
	      else
		{	/* Effect/walk.scm 59 */
		   aux_1436 = ((bool_t) 1);
		}
	      return
		 BBOOL(aux_1436);
	   }
	}
   }
}



/* method-init */
obj_t 
method_init_76_effect_walk()
{
   AN_OBJECT;
   {	/* Effect/walk.scm 14 */
      return BUNSPEC;
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_effect_walk()
{
   AN_OBJECT;
   {	/* Effect/walk.scm 14 */
      module_initialization_70_tools_speek(((long) 0), "EFFECT_WALK");
      module_initialization_70_tools_error(((long) 0), "EFFECT_WALK");
      module_initialization_70_engine_pass(((long) 0), "EFFECT_WALK");
      module_initialization_70_tools_trace(((long) 0), "EFFECT_WALK");
      module_initialization_70_type_type(((long) 0), "EFFECT_WALK");
      module_initialization_70_ast_var(((long) 0), "EFFECT_WALK");
      module_initialization_70_ast_node(((long) 0), "EFFECT_WALK");
      module_initialization_70_effect_cgraph(((long) 0), "EFFECT_WALK");
      return
	 module_initialization_70_effect_spread(((long) 0), "EFFECT_WALK");
   }
}
