/*===========================================================================*/
/*   (Engine/compiler.scm)                                                   */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>
#include <signal.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;

typedef struct ccomp
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t producer;
     obj_t consumer;
     obj_t finalizer;
     obj_t checksummer;
  }
     *ccomp_bglt;


extern obj_t indent_cc_indent(obj_t);
static obj_t method_init_76_engine_compiler();
extern obj_t _optim__89_engine_param;
extern obj_t _optim_unroll_loop___80_engine_param;
static obj_t _compiler_engine_compiler(obj_t);
extern obj_t engine_engine_engine();
extern obj_t current_error_port;
extern obj_t _nb_error_on_pass__70_tools_error;
extern obj_t patch_vector_set__231_cfa_tvector();
extern obj_t make_add_heap_195_heap_make();
extern obj_t compiler_engine_compiler();
extern obj_t integrate_walk__134_integrate_walk(obj_t);
extern obj_t warning___error(obj_t);
extern obj_t stop_on_pass_198_engine_pass(obj_t, obj_t);
static obj_t _anonymous_1588__113_engine_compiler(obj_t);
extern obj_t callcc_walk__209_callcc_walk(obj_t);
static obj_t _anonymous_1583__48_engine_compiler(obj_t);
extern obj_t _bdb_debug__1_engine_param;
static obj_t _anonymous_1577__233_engine_compiler(obj_t);
extern obj_t _obj__252_type_cache;
static obj_t _anonymous_1572__86_engine_compiler(obj_t);
static obj_t _anonymous_1568__238_engine_compiler(obj_t);
extern obj_t user_error_151_tools_error(obj_t, obj_t, obj_t, obj_t);
static obj_t _anonymous_1564__74_engine_compiler(obj_t);
static obj_t _anonymous_1561__76_engine_compiler(obj_t);
static obj_t _anonymous_1557__105_engine_compiler(obj_t);
extern obj_t globalize_walk__63_globalize_walk(obj_t, obj_t);
static obj_t _anonymous_1552__108_engine_compiler(obj_t);
static obj_t _anonymous_1548__142_engine_compiler(obj_t);
static obj_t _anonymous_1544__64_engine_compiler(obj_t);
static obj_t _anonymous_1540__174_engine_compiler(obj_t);
static obj_t _anonymous_1536__60_engine_compiler(obj_t);
static obj_t _anonymous_1533__34_engine_compiler(obj_t);
static obj_t _anonymous_1527__45_engine_compiler(obj_t);
extern obj_t module_initialization_70_engine_compiler(long, char *);
extern obj_t module_initialization_70_tools_speek(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_engine_pass(long, char *);
extern obj_t module_initialization_70_engine_signals(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_engine_engine(long, char *);
extern obj_t module_initialization_70_read_src(long, char *);
extern obj_t module_initialization_70_write_expanded(long, char *);
extern obj_t module_initialization_70_write_ast(long, char *);
extern obj_t module_initialization_70_read_access(long, char *);
extern obj_t module_initialization_70_heap_restore(long, char *);
extern obj_t module_initialization_70_heap_make(long, char *);
extern obj_t module_initialization_70_ast_env(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_ast_build(long, char *);
extern obj_t module_initialization_70_ast_unit(long, char *);
extern obj_t module_initialization_70_ast_check_global_init_17(long, char *);
extern obj_t module_initialization_70_user_user(long, char *);
extern obj_t module_initialization_70_type_env(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_module_module(long, char *);
extern obj_t module_initialization_70_module_include(long, char *);
extern obj_t module_initialization_70_expand_syntax_case_44(long, char *);
extern obj_t module_initialization_70_expand_eps(long, char *);
extern obj_t module_initialization_70_expand_install(long, char *);
extern obj_t module_initialization_70_init_main(long, char *);
extern obj_t module_initialization_70_init_setrc(long, char *);
extern obj_t module_initialization_70_trace_walk(long, char *);
extern obj_t module_initialization_70_inline_walk(long, char *);
extern obj_t module_initialization_70_effect_walk(long, char *);
extern obj_t module_initialization_70_callcc_walk(long, char *);
extern obj_t module_initialization_70_fail_walk(long, char *);
extern obj_t module_initialization_70_globalize_walk(long, char *);
extern obj_t module_initialization_70_cfa_walk(long, char *);
extern obj_t module_initialization_70_cfa_tvector(long, char *);
extern obj_t module_initialization_70_integrate_walk(long, char *);
extern obj_t module_initialization_70_coerce_walk(long, char *);
extern obj_t module_initialization_70_reduce_walk(long, char *);
extern obj_t module_initialization_70_cnst_walk(long, char *);
extern obj_t module_initialization_70_cgen_walk(long, char *);
extern obj_t module_initialization_70_hgen_walk(long, char *);
extern obj_t module_initialization_70_bdb_setting(long, char *);
extern obj_t module_initialization_70_bdb_spread_obj_171(long, char *);
extern obj_t module_initialization_70_bdb_walk(long, char *);
extern obj_t module_initialization_70_prof_walk(long, char *);
extern obj_t module_initialization_70_cc_indent(long, char *);
extern obj_t module_initialization_70_cc_cc(long, char *);
extern obj_t module_initialization_70_cc_ld(long, char *);
extern obj_t module_initialization_70___error(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_numbers_6_5(long, char *);
extern obj_t module_initialization_70___r4_output_6_10_3(long, char *);
extern obj_t module_initialization_70___r5_macro_4_3_init(long, char *);
extern obj_t user_walk_92_user_user(obj_t);
static obj_t _anonymous_1521__218_engine_compiler(obj_t);
extern obj_t _warning__61___error;
extern obj_t write_ast_133_write_ast(obj_t);
static obj_t _anonymous_1518__240_engine_compiler(obj_t);
extern obj_t initialize_genv__97_ast_env();
static obj_t _anonymous_1515__236_engine_compiler(obj_t);
extern obj_t _module_checksum_object___74_engine_param;
static obj_t _anonymous_1510__10_engine_compiler(obj_t);
static obj_t _anonymous_1497__161_engine_compiler(obj_t);
static obj_t _anonymous_1506__179_engine_compiler(obj_t);
extern obj_t syntax_expand_units_115_expand_syntax_case_44(obj_t);
static obj_t _anonymous_1494__255_engine_compiler(obj_t);
static obj_t _anonymous_1503__0_engine_compiler(obj_t);
static obj_t _anonymous_1500__165_engine_compiler(obj_t);
static obj_t _anonymous_1490__15_engine_compiler(obj_t);
extern obj_t trace_walk__65_trace_walk(obj_t);
extern obj_t make_heap_12_heap_make();
extern obj_t load_library_init_89_init_setrc();
static obj_t _anonymous_1470__95_engine_compiler(obj_t);
extern obj_t coerce_walk__125_coerce_walk(obj_t);
extern obj_t exit_bigloo_229_init_main(obj_t);
extern obj_t display_2_122___r4_output_6_10_3(obj_t, obj_t);
extern obj_t write_expanded_48_write_expanded(obj_t);
static obj_t imported_modules_init_94_engine_compiler();
extern obj_t _hygien___100___r5_macro_4_3_init;
extern obj_t initialize_tenv__150_type_env();
extern obj_t expand_units_9_expand_eps(obj_t);
extern obj_t effect_walk__175_effect_walk(obj_t);
extern obj_t bdb_setting__207_bdb_setting();
extern obj_t fail_walk__172_fail_walk(obj_t);
extern obj_t _rest_args__8_engine_param;
static obj_t library_modules_init_112_engine_compiler();
extern obj_t hello_world_248_engine_engine();
extern obj_t install_type_cache__77_type_cache();
extern obj_t set_default_type__106_type_cache(type_bglt);
extern obj_t cfa_walk__41_cfa_walk(obj_t);
static obj_t toplevel_init_63_engine_compiler();
extern obj_t build_ast_197_ast_build(obj_t);
extern obj_t check_global_initialization_113_ast_check_global_init_17();
extern obj_t _call_cc___102_engine_param;
extern obj_t check_types_141_type_env();
extern obj_t open_input_string(obj_t);
extern obj_t _interpreter__140_engine_param;
extern obj_t string_to_bstring(char *);
extern obj_t inline_walk__185_inline_walk(obj_t, obj_t);
extern obj_t cgen_walk_174_cgen_walk(obj_t);
extern obj_t cnst_walk__13_cnst_walk(obj_t);
extern obj_t bdb_walk__231_bdb_walk(obj_t);
extern obj_t install_initial_expander_168_expand_install();
extern obj_t reduce_walk__148_reduce_walk(obj_t);
extern obj_t _compiler_debug__134_engine_param;
extern obj_t read_access_file_42_read_access();
extern obj_t module_checksum_object_250_module_module();
extern obj_t internal_error_43_tools_error(obj_t, obj_t, obj_t);
extern obj_t unit_sexp__add__71_ast_unit(obj_t, obj_t);
extern obj_t bdb_spread_obj__133_bdb_spread_obj_171(obj_t);
extern obj_t produce_module__65_module_module(obj_t);
extern obj_t make_prof_unit_161_prof_walk();
extern obj_t ld_cc_ld(obj_t, bool_t);
extern obj_t cc_cc_cc(obj_t, bool_t);
extern bool_t _2__206___r4_numbers_6_5(obj_t, obj_t);
extern obj_t read_src_204_read_src();
extern obj_t restore_heap_59_heap_restore();
extern obj_t read___reader(obj_t);
extern obj_t _profile_mode__105_engine_param;
extern obj_t install_compiler_signals__223_engine_signals();
extern obj_t _c_debug__136_engine_param;
extern obj_t _lib_mode__85_engine_param;
static obj_t require_initialization_114_engine_compiler = BUNSPEC;
extern obj_t _pass__125_engine_param;
extern obj_t get_toplevel_unit_32_module_include();
static obj_t cnst_init_137_engine_compiler();
extern obj_t _current_pass__25_engine_pass;
static obj_t __cnst[31];

DEFINE_STATIC_PROCEDURE(proc1676_engine_compiler, _anonymous_1588__113_engine_compiler1682, _anonymous_1588__113_engine_compiler, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc1675_engine_compiler, _anonymous_1583__48_engine_compiler1683, _anonymous_1583__48_engine_compiler, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc1674_engine_compiler, _anonymous_1577__233_engine_compiler1684, _anonymous_1577__233_engine_compiler, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc1673_engine_compiler, _anonymous_1572__86_engine_compiler1685, _anonymous_1572__86_engine_compiler, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc1672_engine_compiler, _anonymous_1506__179_engine_compiler1686, _anonymous_1506__179_engine_compiler, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc1671_engine_compiler, _anonymous_1503__0_engine_compiler1687, _anonymous_1503__0_engine_compiler, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc1667_engine_compiler, _anonymous_1470__95_engine_compiler1688, _anonymous_1470__95_engine_compiler, 0L, 0);
extern obj_t hgen_walk_env_69_hgen_walk;
DEFINE_EXPORT_PROCEDURE(compiler_env_81_engine_compiler, _compiler_engine_compiler1689, _compiler_engine_compiler, 0L, 0);
DEFINE_STRING(string1677_engine_compiler, string1677_engine_compiler1690, "DONE CC CINDENT DISTRIB CGEN INLINE+ REDUCER CNST BDB REDUCE COERCE INTEGRATE CFA GLOBALIZE GLOBALIZATION FAIL TRACE INLINE ALL EFFECT CALLCC BDB-SPREAD-OBJ MAKE-ADD-HEAP MAKE-HEAP AST EXPAND SYNTAX USER HGEN (#unspecified) MCO ", 228);
DEFINE_STRING(string1669_engine_compiler, string1669_engine_compiler1691, " occured, ending ...", 20);
DEFINE_STRING(string1670_engine_compiler, string1670_engine_compiler1692, "failure during postlude hook", 28);
DEFINE_STRING(string1668_engine_compiler, string1668_engine_compiler1693, " error", 6);
DEFINE_STRING(string1666_engine_compiler, string1666_engine_compiler1694, "Don't know what to do with arguments: ", 38);
DEFINE_STRING(string1665_engine_compiler, string1665_engine_compiler1695, "Illegal source file", 19);
DEFINE_STRING(string1664_engine_compiler, string1664_engine_compiler1696, "Parse error", 11);



/* module-initialization */
obj_t 
module_initialization_70_engine_compiler(long checksum_1388, char *from_1389)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_engine_compiler))
	{
	   require_initialization_114_engine_compiler =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_engine_compiler();
	   cnst_init_137_engine_compiler();
	   imported_modules_init_94_engine_compiler();
	   method_init_76_engine_compiler();
	   toplevel_init_63_engine_compiler();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_engine_compiler()
{
   AN_OBJECT;
   {	/* Engine/compiler.scm 14 */
      module_initialization_70___error(((long) 0), "ENGINE_COMPILER");
      module_initialization_70___r4_output_6_10_3(((long) 0), "ENGINE_COMPILER");
      module_initialization_70___r5_macro_4_3_init(((long) 0), "ENGINE_COMPILER");
      module_initialization_70___r4_numbers_6_5(((long) 0), "ENGINE_COMPILER");
      module_initialization_70___reader(((long) 0), "ENGINE_COMPILER");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_engine_compiler()
{
   AN_OBJECT;
   {	/* Engine/compiler.scm 14 */
      {		/* Engine/compiler.scm 14 */
	 obj_t cnst_port_138_1381;
	 cnst_port_138_1381 =
	    open_input_string(string1677_engine_compiler);
	 {
	    long i_1382;
	    i_1382 = ((long) 30);
	  loop_1383:
	    {	/* Engine/compiler.scm 14 */
	       bool_t test1678_1384;
	       test1678_1384 =
		  (i_1382 == ((long) -1));
	       if (test1678_1384)
		 {	/* Engine/compiler.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Engine/compiler.scm 14 */
		    {	/* Engine/compiler.scm 14 */
		       obj_t arg1679_1385;
		       {	/* Engine/compiler.scm 14 */
			  obj_t list1680_1386;
			  list1680_1386 =
			     MAKE_PAIR(cnst_port_138_1381, BNIL);
			  arg1679_1385 =
			     read___reader(list1680_1386);
		       }
		       CNST_TABLE_SET(i_1382, arg1679_1385);
		    }
		    {	/* Engine/compiler.scm 14 */
		       int aux_1387;
		       {	/* Engine/compiler.scm 14 */
			  long aux_1409;
			  aux_1409 =
			     (i_1382 - ((long) 1));
			  aux_1387 =
			     (int) (aux_1409);
		       }
		       {
			  long i_1412;
			  i_1412 =
			     (long) (aux_1387);
			  i_1382 = i_1412;
			  goto loop_1383;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_engine_compiler()
{
   AN_OBJECT;
   {	/* Engine/compiler.scm 14 */
      return BUNSPEC;
   }
}



/* compiler */
obj_t 
compiler_engine_compiler()
{
   AN_OBJECT;
   {	/* Engine/compiler.scm 71 */
      install_compiler_signals__223_engine_signals();
      {		/* Engine/compiler.scm 77 */
	 obj_t src_735;
	 src_735 =
	    read_src_204_read_src();
	 if (
	    CBOOL(src_735))
	   {	/* Engine/compiler.scm 82 */
	      if (
		 PAIRP(src_735))
		{	/* Engine/compiler.scm 85 */
		   BFALSE;
		}
	      else
		{	/* Engine/compiler.scm 85 */
		   user_error_151_tools_error(string1664_engine_compiler, string1665_engine_compiler, src_735, BNIL);
		}
	   }
	 else
	   {	/* Engine/compiler.scm 82 */
	      _interpreter__140_engine_param = BTRUE;
	      {		/* Engine/compiler.scm 84 */
		 obj_t arg1458_738;
		 arg1458_738 =
		    engine_engine_engine();
		 exit_bigloo_229_init_main(arg1458_738);
	      }
	   }
	 hello_world_248_engine_engine();
	 {	/* Engine/compiler.scm 92 */
	    bool_t test1459_739;
	    {	/* Engine/compiler.scm 92 */
	       long n1_1243;
	       n1_1243 =
		  (long) CINT(_bdb_debug__1_engine_param);
	       test1459_739 =
		  (n1_1243 > ((long) 0));
	    }
	    if (test1459_739)
	      {		/* Engine/compiler.scm 92 */
		 bdb_setting__207_bdb_setting();
	      }
	    else
	      {		/* Engine/compiler.scm 92 */
		 BUNSPEC;
	      }
	 }
	 {	/* Engine/compiler.scm 96 */
	    bool_t test1460_740;
	    {	/* Engine/compiler.scm 96 */
	       obj_t obj_1245;
	       obj_1245 = _rest_args__8_engine_param;
	       test1460_740 =
		  NULLP(obj_1245);
	    }
	    if (test1460_740)
	      {		/* Engine/compiler.scm 96 */
		 BUNSPEC;
	      }
	    else
	      {		/* Engine/compiler.scm 97 */
		 obj_t list1461_741;
		 {	/* Engine/compiler.scm 97 */
		    obj_t arg1463_743;
		    arg1463_743 =
		       MAKE_PAIR(_rest_args__8_engine_param, BNIL);
		    list1461_741 =
		       MAKE_PAIR(string1666_engine_compiler, arg1463_743);
		 }
		 warning___error(list1461_741);
	      }
	 }
	 read_access_file_42_read_access();
	 if (
	    CBOOL(_lib_mode__85_engine_param))
	   {	/* Engine/compiler.scm 103 */
	      initialize_genv__97_ast_env();
	      initialize_tenv__150_type_env();
	   }
	 else
	   {	/* Engine/compiler.scm 103 */
	      restore_heap_59_heap_restore();
	   }
	 install_type_cache__77_type_cache();
	 patch_vector_set__231_cfa_tvector();
	 {	/* Engine/compiler.scm 119 */
	    obj_t src_code_162_745;
	    src_code_162_745 =
	       CDR(src_735);
	    {	/* Engine/compiler.scm 120 */
	       obj_t units_746;
	       {	/* Engine/compiler.scm 121 */
		  obj_t cellval_1442;
		  cellval_1442 =
		     produce_module__65_module_module(
		     CAR(src_735));
		  units_746 =
		     MAKE_CELL(cellval_1442);
	       }
	       {	/* Engine/compiler.scm 121 */

		  {	/* Engine/compiler.scm 124 */
		     bool_t test1464_747;
		     {	/* Engine/compiler.scm 124 */
			long n1_1248;
			n1_1248 =
			   (long) CINT(_profile_mode__105_engine_param);
			test1464_747 =
			   (n1_1248 >= ((long) 1));
		     }
		     if (test1464_747)
		       {	/* Engine/compiler.scm 125 */
			  obj_t aux_1363;
			  {	/* Engine/compiler.scm 125 */
			     obj_t arg1466_748;
			     arg1466_748 =
				make_prof_unit_161_prof_walk();
			     {	/* Engine/compiler.scm 125 */
				obj_t obj2_1251;
				obj2_1251 =
				   CELL_REF(units_746);
				aux_1363 =
				   MAKE_PAIR(arg1466_748, obj2_1251);
			     }
			  }
			  CELL_SET(units_746, aux_1363);
		       }
		     else
		       {	/* Engine/compiler.scm 124 */
			  BUNSPEC;
		       }
		  }
		  if (
		     CBOOL(_module_checksum_object___74_engine_param))
		    {	/* Engine/compiler.scm 128 */
		       module_checksum_object_250_module_module();
		    }
		  else
		    {	/* Engine/compiler.scm 128 */
		       BUNSPEC;
		    }
		  {	/* Engine/compiler.scm 130 */
		     obj_t arg1467_749;
		     arg1467_749 =
			CNST_TABLE_REF(((long) 0));
		     {	/* Engine/compiler.scm 130 */
			obj_t _anonymous_1470__95_1316;
			_anonymous_1470__95_1316 = proc1667_engine_compiler;
			stop_on_pass_198_engine_pass(arg1467_749, _anonymous_1470__95_1316);
		     }
		  }
		  {	/* Engine/compiler.scm 133 */
		     obj_t code_753;
		     if (
			NULLP(src_code_162_745))
		       {	/* Engine/compiler.scm 133 */
			  code_753 =
			     CNST_TABLE_REF(((long) 1));
		       }
		     else
		       {	/* Engine/compiler.scm 133 */
			  code_753 = src_code_162_745;
		       }
		     {	/* Engine/compiler.scm 134 */
			obj_t arg1471_754;
			arg1471_754 =
			   get_toplevel_unit_32_module_include();
			unit_sexp__add__71_ast_unit(arg1471_754, code_753);
		     }
		  }
		  {	/* Engine/compiler.scm 137 */
		     bool_t test1473_757;
		     {	/* Engine/compiler.scm 137 */
			long n1_1253;
			n1_1253 =
			   (long) CINT(_nb_error_on_pass__70_tools_error);
			test1473_757 =
			   (n1_1253 > ((long) 0));
		     }
		     if (test1473_757)
		       {	/* Engine/compiler.scm 137 */
			  display_2_122___r4_output_6_10_3(_nb_error_on_pass__70_tools_error, current_error_port);
			  display_2_122___r4_output_6_10_3(string1668_engine_compiler, current_error_port);
			  {	/* Engine/compiler.scm 137 */
			     char *arg1474_759;
			     {	/* Engine/compiler.scm 137 */
				bool_t test1475_760;
				{	/* Engine/compiler.scm 137 */
				   bool_t test1476_761;
				   {	/* Engine/compiler.scm 137 */
				      obj_t obj_1255;
				      obj_1255 = _nb_error_on_pass__70_tools_error;
				      test1476_761 =
					 INTEGERP(obj_1255);
				   }
				   if (test1476_761)
				     {	/* Engine/compiler.scm 137 */
					test1475_760 =
					   _2__206___r4_numbers_6_5(_nb_error_on_pass__70_tools_error,
					   BINT(((long) 1)));
				     }
				   else
				     {	/* Engine/compiler.scm 137 */
					test1475_760 = ((bool_t) 0);
				     }
				}
				if (test1475_760)
				  {	/* Engine/compiler.scm 137 */
				     arg1474_759 = "s";
				  }
				else
				  {	/* Engine/compiler.scm 137 */
				     arg1474_759 = "";
				  }
			     }
			     display_2_122___r4_output_6_10_3(
				string_to_bstring(arg1474_759), current_error_port);
			  }
			  display_2_122___r4_output_6_10_3(string1669_engine_compiler, current_error_port);
			  WRITE_CHAR(((unsigned char) '\n'), current_error_port);
			  {	/* Engine/compiler.scm 137 */
			     obj_t res1663_1258;
			     exit(((long) -1));
			     res1663_1258 =
				BINT(((long) -1));
			     res1663_1258;
			  }
		       }
		     else
		       {
			  obj_t hooks_762;
			  obj_t hnames_763;
			  hooks_762 = BNIL;
			  hnames_763 = BNIL;
			loop_764:
			  if (
			     NULLP(hooks_762))
			    {	/* Engine/compiler.scm 137 */
			       BUNSPEC;
			    }
			  else
			    {	/* Engine/compiler.scm 137 */
			       bool_t test1481_769;
			       {	/* Engine/compiler.scm 137 */
				  obj_t fun1487_774;
				  fun1487_774 =
				     CAR(hooks_762);
				  {	/* Engine/compiler.scm 137 */
				     obj_t aux_1479;
				     aux_1479 =
					PROCEDURE_ENTRY(fun1487_774) (fun1487_774, BEOA);
				     test1481_769 =
					CBOOL(aux_1479);
				  }
			       }
			       if (test1481_769)
				 {	/* Engine/compiler.scm 137 */
				    {
				       obj_t hnames_1486;
				       obj_t hooks_1484;
				       hooks_1484 =
					  CDR(hooks_762);
				       hnames_1486 =
					  CDR(hnames_763);
				       hnames_763 = hnames_1486;
				       hooks_762 = hooks_1484;
				       goto loop_764;
				    }
				 }
			       else
				 {	/* Engine/compiler.scm 137 */
				    internal_error_43_tools_error(_current_pass__25_engine_pass, string1670_engine_compiler,
				       CAR(hnames_763));
				 }
			    }
		       }
		  }
		  check_types_141_type_env();
		  stop_on_pass_198_engine_pass(
		     CNST_TABLE_REF(((long) 2)), hgen_walk_env_69_hgen_walk);
		  user_walk_92_user_user(
		     CELL_REF(units_746));
		  {	/* Engine/compiler.scm 147 */
		     obj_t arg1488_775;
		     arg1488_775 =
			CNST_TABLE_REF(((long) 3));
		     {	/* Engine/compiler.scm 147 */
			obj_t _anonymous_1490__15_1315;
			_anonymous_1490__15_1315 =
			   make_fx_procedure(_anonymous_1490__15_engine_compiler, ((long) 0), ((long) 1));
			PROCEDURE_SET(_anonymous_1490__15_1315, ((long) 0), units_746);
			stop_on_pass_198_engine_pass(arg1488_775, _anonymous_1490__15_1315);
		     }
		  }
		  install_initial_expander_168_expand_install();
		  load_library_init_89_init_setrc();
		  if (
		     CBOOL(_hygien___100___r5_macro_4_3_init))
		    {	/* Engine/compiler.scm 158 */
		       syntax_expand_units_115_expand_syntax_case_44(
			  CELL_REF(units_746));
		    }
		  else
		    {	/* Engine/compiler.scm 158 */
		       BUNSPEC;
		    }
		  {	/* Engine/compiler.scm 160 */
		     obj_t arg1491_779;
		     arg1491_779 =
			CNST_TABLE_REF(((long) 4));
		     {	/* Engine/compiler.scm 160 */
			obj_t _anonymous_1494__255_1314;
			_anonymous_1494__255_1314 =
			   make_fx_procedure(_anonymous_1494__255_engine_compiler, ((long) 0), ((long) 1));
			PROCEDURE_SET(_anonymous_1494__255_1314, ((long) 0), units_746);
			stop_on_pass_198_engine_pass(arg1491_779, _anonymous_1494__255_1314);
		     }
		  }
		  expand_units_9_expand_eps(
		     CELL_REF(units_746));
		  {	/* Engine/compiler.scm 164 */
		     obj_t arg1495_783;
		     arg1495_783 =
			CNST_TABLE_REF(((long) 5));
		     {	/* Engine/compiler.scm 164 */
			obj_t _anonymous_1497__161_1313;
			_anonymous_1497__161_1313 =
			   make_fx_procedure(_anonymous_1497__161_engine_compiler, ((long) 0), ((long) 1));
			PROCEDURE_SET(_anonymous_1497__161_1313, ((long) 0), units_746);
			stop_on_pass_198_engine_pass(arg1495_783, _anonymous_1497__161_1313);
		     }
		  }
		  {	/* Engine/compiler.scm 167 */
		     obj_t ast_787;
		     {	/* Engine/compiler.scm 167 */
			obj_t cellval_1512;
			cellval_1512 =
			   build_ast_197_ast_build(
			   CELL_REF(units_746));
			ast_787 =
			   MAKE_CELL(cellval_1512);
		     }
		     {	/* Engine/compiler.scm 168 */
			obj_t arg1498_788;
			arg1498_788 =
			   CNST_TABLE_REF(((long) 6));
			{	/* Engine/compiler.scm 168 */
			   obj_t _anonymous_1500__165_1312;
			   _anonymous_1500__165_1312 =
			      make_fx_procedure(_anonymous_1500__165_engine_compiler, ((long) 0), ((long) 1));
			   PROCEDURE_SET(_anonymous_1500__165_1312, ((long) 0), ast_787);
			   stop_on_pass_198_engine_pass(arg1498_788, _anonymous_1500__165_1312);
			}
		     }
		     if (
			CBOOL(_warning__61___error))
		       {	/* Engine/compiler.scm 172 */
			  check_global_initialization_113_ast_check_global_init_17();
		       }
		     else
		       {	/* Engine/compiler.scm 172 */
			  BUNSPEC;
		       }
		     {	/* Engine/compiler.scm 176 */
			obj_t arg1501_792;
			arg1501_792 =
			   CNST_TABLE_REF(((long) 7));
			{	/* Engine/compiler.scm 176 */
			   obj_t _anonymous_1503__0_1311;
			   _anonymous_1503__0_1311 = proc1671_engine_compiler;
			   stop_on_pass_198_engine_pass(arg1501_792, _anonymous_1503__0_1311);
			}
		     }
		     {	/* Engine/compiler.scm 179 */
			obj_t arg1504_796;
			arg1504_796 =
			   CNST_TABLE_REF(((long) 8));
			{	/* Engine/compiler.scm 179 */
			   obj_t _anonymous_1506__179_1310;
			   _anonymous_1506__179_1310 = proc1672_engine_compiler;
			   stop_on_pass_198_engine_pass(arg1504_796, _anonymous_1506__179_1310);
			}
		     }
		     {	/* Engine/compiler.scm 182 */
			bool_t test1507_800;
			{	/* Engine/compiler.scm 182 */
			   long n1_1265;
			   n1_1265 =
			      (long) CINT(_bdb_debug__1_engine_param);
			   test1507_800 =
			      (n1_1265 > ((long) 0));
			}
			if (test1507_800)
			  {	/* Engine/compiler.scm 182 */
			     bdb_spread_obj__133_bdb_spread_obj_171(
				CELL_REF(ast_787));
			  }
			else
			  {	/* Engine/compiler.scm 182 */
			     BUNSPEC;
			  }
		     }
		     {	/* Engine/compiler.scm 184 */
			obj_t arg1508_801;
			arg1508_801 =
			   CNST_TABLE_REF(((long) 9));
			{	/* Engine/compiler.scm 184 */
			   obj_t _anonymous_1510__10_1309;
			   _anonymous_1510__10_1309 =
			      make_fx_procedure(_anonymous_1510__10_engine_compiler, ((long) 0), ((long) 1));
			   PROCEDURE_SET(_anonymous_1510__10_1309, ((long) 0), ast_787);
			   stop_on_pass_198_engine_pass(arg1508_801, _anonymous_1510__10_1309);
			}
		     }
		     {	/* Engine/compiler.scm 188 */
			bool_t test1511_805;
			{	/* Engine/compiler.scm 188 */
			   bool_t test1512_806;
			   {	/* Engine/compiler.scm 188 */
			      obj_t obj_1267;
			      obj_1267 = _compiler_debug__134_engine_param;
			      test1512_806 =
				 INTEGERP(obj_1267);
			   }
			   if (test1512_806)
			     {	/* Engine/compiler.scm 188 */
				long n1_1268;
				n1_1268 =
				   (long) CINT(_compiler_debug__134_engine_param);
				test1511_805 =
				   (n1_1268 > ((long) 2));
			     }
			   else
			     {	/* Engine/compiler.scm 188 */
				test1511_805 = ((bool_t) 0);
			     }
			}
			if (test1511_805)
			  {	/* Engine/compiler.scm 189 */
			     obj_t aux_1365;
			     aux_1365 =
				trace_walk__65_trace_walk(
				CELL_REF(ast_787));
			     CELL_SET(ast_787, aux_1365);
			  }
			else
			  {	/* Engine/compiler.scm 188 */
			     BUNSPEC;
			  }
		     }
		     if (
			CBOOL(_call_cc___102_engine_param))
		       {	/* Engine/compiler.scm 194 */
			  obj_t aux_1366;
			  aux_1366 =
			     callcc_walk__209_callcc_walk(
			     CELL_REF(ast_787));
			  CELL_SET(ast_787, aux_1366);
		       }
		     else
		       {	/* Engine/compiler.scm 193 */
			  BUNSPEC;
		       }
		     {	/* Engine/compiler.scm 195 */
			obj_t arg1513_807;
			arg1513_807 =
			   CNST_TABLE_REF(((long) 10));
			{	/* Engine/compiler.scm 195 */
			   obj_t _anonymous_1515__236_1308;
			   _anonymous_1515__236_1308 =
			      make_fx_procedure(_anonymous_1515__236_engine_compiler, ((long) 0), ((long) 1));
			   PROCEDURE_SET(_anonymous_1515__236_1308, ((long) 0), ast_787);
			   stop_on_pass_198_engine_pass(arg1513_807, _anonymous_1515__236_1308);
			}
		     }
		     if (
			CBOOL(_optim_unroll_loop___80_engine_param))
		       {	/* Engine/compiler.scm 198 */
			  {	/* Engine/compiler.scm 200 */
			     obj_t aux_1367;
			     aux_1367 =
				effect_walk__175_effect_walk(
				CELL_REF(ast_787));
			     CELL_SET(ast_787, aux_1367);
			  }
			  {	/* Engine/compiler.scm 201 */
			     obj_t arg1516_811;
			     arg1516_811 =
				CNST_TABLE_REF(((long) 11));
			     {	/* Engine/compiler.scm 201 */
				obj_t _anonymous_1518__240_1307;
				_anonymous_1518__240_1307 =
				   make_fx_procedure(_anonymous_1518__240_engine_compiler, ((long) 0), ((long) 1));
				PROCEDURE_SET(_anonymous_1518__240_1307, ((long) 0), ast_787);
				stop_on_pass_198_engine_pass(arg1516_811, _anonymous_1518__240_1307);
			     }
			  }
		       }
		     else
		       {	/* Engine/compiler.scm 198 */
			  BUNSPEC;
		       }
		     {	/* Engine/compiler.scm 204 */
			obj_t aux_1368;
			aux_1368 =
			   inline_walk__185_inline_walk(
			   CELL_REF(ast_787),
			   CNST_TABLE_REF(((long) 12)));
			CELL_SET(ast_787, aux_1368);
		     }
		     {	/* Engine/compiler.scm 205 */
			obj_t arg1519_815;
			arg1519_815 =
			   CNST_TABLE_REF(((long) 13));
			{	/* Engine/compiler.scm 205 */
			   obj_t _anonymous_1521__218_1306;
			   _anonymous_1521__218_1306 =
			      make_fx_procedure(_anonymous_1521__218_engine_compiler, ((long) 0), ((long) 1));
			   PROCEDURE_SET(_anonymous_1521__218_1306, ((long) 0), ast_787);
			   stop_on_pass_198_engine_pass(arg1519_815, _anonymous_1521__218_1306);
			}
		     }
		     {	/* Engine/compiler.scm 208 */
			bool_t test1522_819;
			{	/* Engine/compiler.scm 208 */
			   bool_t test1523_820;
			   {	/* Engine/compiler.scm 208 */
			      obj_t obj_1270;
			      obj_1270 = _compiler_debug__134_engine_param;
			      test1523_820 =
				 INTEGERP(obj_1270);
			   }
			   if (test1523_820)
			     {	/* Engine/compiler.scm 209 */
				bool_t test1524_821;
				{	/* Engine/compiler.scm 209 */
				   long n1_1271;
				   n1_1271 =
				      (long) CINT(_compiler_debug__134_engine_param);
				   test1524_821 =
				      (n1_1271 > ((long) 0));
				}
				if (test1524_821)
				  {	/* Engine/compiler.scm 209 */
				     long n1_1273;
				     n1_1273 =
					(long) CINT(_compiler_debug__134_engine_param);
				     test1522_819 =
					(n1_1273 <= ((long) 2));
				  }
				else
				  {	/* Engine/compiler.scm 209 */
				     test1522_819 = ((bool_t) 0);
				  }
			     }
			   else
			     {	/* Engine/compiler.scm 208 */
				test1522_819 = ((bool_t) 0);
			     }
			}
			if (test1522_819)
			  {	/* Engine/compiler.scm 210 */
			     obj_t aux_1369;
			     aux_1369 =
				trace_walk__65_trace_walk(
				CELL_REF(ast_787));
			     CELL_SET(ast_787, aux_1369);
			  }
			else
			  {	/* Engine/compiler.scm 208 */
			     BUNSPEC;
			  }
		     }
		     {	/* Engine/compiler.scm 211 */
			obj_t arg1525_822;
			arg1525_822 =
			   CNST_TABLE_REF(((long) 14));
			{	/* Engine/compiler.scm 211 */
			   obj_t _anonymous_1527__45_1305;
			   _anonymous_1527__45_1305 =
			      make_fx_procedure(_anonymous_1527__45_engine_compiler, ((long) 0), ((long) 1));
			   PROCEDURE_SET(_anonymous_1527__45_1305, ((long) 0), ast_787);
			   stop_on_pass_198_engine_pass(arg1525_822, _anonymous_1527__45_1305);
			}
		     }
		     {	/* Engine/compiler.scm 215 */
			bool_t test1528_826;
			{	/* Engine/compiler.scm 215 */
			   bool_t test1529_827;
			   {	/* Engine/compiler.scm 215 */
			      obj_t obj_1275;
			      obj_1275 = _compiler_debug__134_engine_param;
			      test1529_827 =
				 INTEGERP(obj_1275);
			   }
			   if (test1529_827)
			     {	/* Engine/compiler.scm 215 */
				long n1_1276;
				n1_1276 =
				   (long) CINT(_compiler_debug__134_engine_param);
				test1528_826 =
				   (n1_1276 > ((long) 0));
			     }
			   else
			     {	/* Engine/compiler.scm 215 */
				test1528_826 = ((bool_t) 0);
			     }
			}
			if (test1528_826)
			  {	/* Engine/compiler.scm 216 */
			     obj_t aux_1370;
			     aux_1370 =
				fail_walk__172_fail_walk(
				CELL_REF(ast_787));
			     CELL_SET(ast_787, aux_1370);
			  }
			else
			  {	/* Engine/compiler.scm 215 */
			     BUNSPEC;
			  }
		     }
		     {	/* Engine/compiler.scm 217 */
			obj_t arg1530_828;
			arg1530_828 =
			   CNST_TABLE_REF(((long) 15));
			{	/* Engine/compiler.scm 217 */
			   obj_t _anonymous_1533__34_1304;
			   _anonymous_1533__34_1304 =
			      make_fx_procedure(_anonymous_1533__34_engine_compiler, ((long) 0), ((long) 1));
			   PROCEDURE_SET(_anonymous_1533__34_1304, ((long) 0), ast_787);
			   stop_on_pass_198_engine_pass(arg1530_828, _anonymous_1533__34_1304);
			}
		     }
		     {	/* Engine/compiler.scm 220 */
			obj_t aux_1371;
			aux_1371 =
			   globalize_walk__63_globalize_walk(
			   CELL_REF(ast_787),
			   CNST_TABLE_REF(((long) 16)));
			CELL_SET(ast_787, aux_1371);
		     }
		     {	/* Engine/compiler.scm 221 */
			obj_t arg1534_832;
			arg1534_832 =
			   CNST_TABLE_REF(((long) 17));
			{	/* Engine/compiler.scm 221 */
			   obj_t _anonymous_1536__60_1303;
			   _anonymous_1536__60_1303 =
			      make_fx_procedure(_anonymous_1536__60_engine_compiler, ((long) 0), ((long) 1));
			   PROCEDURE_SET(_anonymous_1536__60_1303, ((long) 0), ast_787);
			   stop_on_pass_198_engine_pass(arg1534_832, _anonymous_1536__60_1303);
			}
		     }
		     {	/* Engine/compiler.scm 224 */
			obj_t aux_1372;
			aux_1372 =
			   cfa_walk__41_cfa_walk(
			   CELL_REF(ast_787));
			CELL_SET(ast_787, aux_1372);
		     }
		     {	/* Engine/compiler.scm 225 */
			obj_t arg1537_836;
			arg1537_836 =
			   CNST_TABLE_REF(((long) 18));
			{	/* Engine/compiler.scm 225 */
			   obj_t _anonymous_1540__174_1302;
			   _anonymous_1540__174_1302 =
			      make_fx_procedure(_anonymous_1540__174_engine_compiler, ((long) 0), ((long) 1));
			   PROCEDURE_SET(_anonymous_1540__174_1302, ((long) 0), ast_787);
			   stop_on_pass_198_engine_pass(arg1537_836, _anonymous_1540__174_1302);
			}
		     }
		     set_default_type__106_type_cache(
			(type_bglt) (_obj__252_type_cache));
		     {	/* Engine/compiler.scm 232 */
			obj_t aux_1373;
			aux_1373 =
			   integrate_walk__134_integrate_walk(
			   CELL_REF(ast_787));
			CELL_SET(ast_787, aux_1373);
		     }
		     {	/* Engine/compiler.scm 233 */
			obj_t arg1541_840;
			arg1541_840 =
			   CNST_TABLE_REF(((long) 19));
			{	/* Engine/compiler.scm 233 */
			   obj_t _anonymous_1544__64_1301;
			   _anonymous_1544__64_1301 =
			      make_fx_procedure(_anonymous_1544__64_engine_compiler, ((long) 0), ((long) 1));
			   PROCEDURE_SET(_anonymous_1544__64_1301, ((long) 0), ast_787);
			   stop_on_pass_198_engine_pass(arg1541_840, _anonymous_1544__64_1301);
			}
		     }
		     {	/* Engine/compiler.scm 236 */
			obj_t aux_1374;
			aux_1374 =
			   coerce_walk__125_coerce_walk(
			   CELL_REF(ast_787));
			CELL_SET(ast_787, aux_1374);
		     }
		     {	/* Engine/compiler.scm 237 */
			obj_t arg1545_844;
			arg1545_844 =
			   CNST_TABLE_REF(((long) 20));
			{	/* Engine/compiler.scm 237 */
			   obj_t _anonymous_1548__142_1300;
			   _anonymous_1548__142_1300 =
			      make_fx_procedure(_anonymous_1548__142_engine_compiler, ((long) 0), ((long) 1));
			   PROCEDURE_SET(_anonymous_1548__142_1300, ((long) 0), ast_787);
			   stop_on_pass_198_engine_pass(arg1545_844, _anonymous_1548__142_1300);
			}
		     }
		     {	/* Engine/compiler.scm 241 */
			bool_t test1549_848;
			{	/* Engine/compiler.scm 241 */
			   long n1_1278;
			   n1_1278 =
			      (long) CINT(_optim__89_engine_param);
			   test1549_848 =
			      (n1_1278 >= ((long) 2));
			}
			if (test1549_848)
			  {	/* Engine/compiler.scm 241 */
			     {	/* Engine/compiler.scm 243 */
				obj_t aux_1375;
				aux_1375 =
				   effect_walk__175_effect_walk(
				   CELL_REF(ast_787));
				CELL_SET(ast_787, aux_1375);
			     }
			     {	/* Engine/compiler.scm 244 */
				obj_t arg1550_849;
				arg1550_849 =
				   CNST_TABLE_REF(((long) 11));
				{	/* Engine/compiler.scm 244 */
				   obj_t _anonymous_1552__108_1299;
				   _anonymous_1552__108_1299 =
				      make_fx_procedure(_anonymous_1552__108_engine_compiler, ((long) 0), ((long) 1));
				   PROCEDURE_SET(_anonymous_1552__108_1299, ((long) 0), ast_787);
				   stop_on_pass_198_engine_pass(arg1550_849, _anonymous_1552__108_1299);
				}
			     }
			  }
			else
			  {	/* Engine/compiler.scm 241 */
			     BUNSPEC;
			  }
		     }
		     {	/* Engine/compiler.scm 247 */
			bool_t test1553_853;
			{	/* Engine/compiler.scm 247 */
			   long n1_1280;
			   n1_1280 =
			      (long) CINT(_optim__89_engine_param);
			   test1553_853 =
			      (n1_1280 >= ((long) 1));
			}
			if (test1553_853)
			  {	/* Engine/compiler.scm 248 */
			     obj_t aux_1376;
			     aux_1376 =
				reduce_walk__148_reduce_walk(
				CELL_REF(ast_787));
			     CELL_SET(ast_787, aux_1376);
			  }
			else
			  {	/* Engine/compiler.scm 247 */
			     BUNSPEC;
			  }
		     }
		     {	/* Engine/compiler.scm 249 */
			obj_t arg1555_854;
			arg1555_854 =
			   CNST_TABLE_REF(((long) 21));
			{	/* Engine/compiler.scm 249 */
			   obj_t _anonymous_1557__105_1298;
			   _anonymous_1557__105_1298 =
			      make_fx_procedure(_anonymous_1557__105_engine_compiler, ((long) 0), ((long) 1));
			   PROCEDURE_SET(_anonymous_1557__105_1298, ((long) 0), ast_787);
			   stop_on_pass_198_engine_pass(arg1555_854, _anonymous_1557__105_1298);
			}
		     }
		     {	/* Engine/compiler.scm 252 */
			bool_t test1558_858;
			{	/* Engine/compiler.scm 252 */
			   long n1_1282;
			   n1_1282 =
			      (long) CINT(_bdb_debug__1_engine_param);
			   test1558_858 =
			      (n1_1282 > ((long) 0));
			}
			if (test1558_858)
			  {	/* Engine/compiler.scm 253 */
			     obj_t aux_1377;
			     aux_1377 =
				bdb_walk__231_bdb_walk(
				CELL_REF(ast_787));
			     CELL_SET(ast_787, aux_1377);
			  }
			else
			  {	/* Engine/compiler.scm 252 */
			     BUNSPEC;
			  }
		     }
		     {	/* Engine/compiler.scm 254 */
			obj_t arg1559_859;
			arg1559_859 =
			   CNST_TABLE_REF(((long) 22));
			{	/* Engine/compiler.scm 254 */
			   obj_t _anonymous_1561__76_1297;
			   _anonymous_1561__76_1297 =
			      make_fx_procedure(_anonymous_1561__76_engine_compiler, ((long) 0), ((long) 1));
			   PROCEDURE_SET(_anonymous_1561__76_1297, ((long) 0), ast_787);
			   stop_on_pass_198_engine_pass(arg1559_859, _anonymous_1561__76_1297);
			}
		     }
		     {	/* Engine/compiler.scm 257 */
			obj_t aux_1378;
			aux_1378 =
			   cnst_walk__13_cnst_walk(
			   CELL_REF(ast_787));
			CELL_SET(ast_787, aux_1378);
		     }
		     {	/* Engine/compiler.scm 258 */
			obj_t arg1562_863;
			arg1562_863 =
			   CNST_TABLE_REF(((long) 23));
			{	/* Engine/compiler.scm 258 */
			   obj_t _anonymous_1564__74_1296;
			   _anonymous_1564__74_1296 =
			      make_fx_procedure(_anonymous_1564__74_engine_compiler, ((long) 0), ((long) 1));
			   PROCEDURE_SET(_anonymous_1564__74_1296, ((long) 0), ast_787);
			   stop_on_pass_198_engine_pass(arg1562_863, _anonymous_1564__74_1296);
			}
		     }
		     {	/* Engine/compiler.scm 262 */
			bool_t test1565_867;
			{	/* Engine/compiler.scm 262 */
			   long n1_1284;
			   n1_1284 =
			      (long) CINT(_optim__89_engine_param);
			   test1565_867 =
			      (n1_1284 >= ((long) 3));
			}
			if (test1565_867)
			  {	/* Engine/compiler.scm 263 */
			     obj_t aux_1379;
			     aux_1379 =
				inline_walk__185_inline_walk(
				CELL_REF(ast_787),
				CNST_TABLE_REF(((long) 24)));
			     CELL_SET(ast_787, aux_1379);
			  }
			else
			  {	/* Engine/compiler.scm 262 */
			     BUNSPEC;
			  }
		     }
		     {	/* Engine/compiler.scm 264 */
			obj_t arg1566_868;
			arg1566_868 =
			   CNST_TABLE_REF(((long) 25));
			{	/* Engine/compiler.scm 264 */
			   obj_t _anonymous_1568__238_1295;
			   _anonymous_1568__238_1295 =
			      make_fx_procedure(_anonymous_1568__238_engine_compiler, ((long) 0), ((long) 1));
			   PROCEDURE_SET(_anonymous_1568__238_1295, ((long) 0), ast_787);
			   stop_on_pass_198_engine_pass(arg1566_868, _anonymous_1568__238_1295);
			}
		     }
		     {	/* Engine/compiler.scm 267 */
			obj_t c_prefix_211_872;
			c_prefix_211_872 =
			   cgen_walk_174_cgen_walk(
			   CELL_REF(ast_787));
			{	/* Engine/compiler.scm 268 */
			   obj_t arg1569_873;
			   arg1569_873 =
			      CNST_TABLE_REF(((long) 26));
			   {	/* Engine/compiler.scm 268 */
			      obj_t _anonymous_1572__86_1294;
			      _anonymous_1572__86_1294 = proc1673_engine_compiler;
			      stop_on_pass_198_engine_pass(arg1569_873, _anonymous_1572__86_1294);
			   }
			}
			{	/* Engine/compiler.scm 269 */
			   obj_t arg1573_877;
			   arg1573_877 =
			      CNST_TABLE_REF(((long) 27));
			   {	/* Engine/compiler.scm 269 */
			      obj_t _anonymous_1577__233_1293;
			      _anonymous_1577__233_1293 = proc1674_engine_compiler;
			      stop_on_pass_198_engine_pass(arg1573_877, _anonymous_1577__233_1293);
			   }
			}
			if (
			   STRINGP(c_prefix_211_872))
			  {	/* Engine/compiler.scm 271 */
			     {	/* Engine/compiler.scm 274 */
				bool_t test1579_882;
				{	/* Engine/compiler.scm 274 */
				   bool_t test1580_883;
				   {	/* Engine/compiler.scm 274 */
				      obj_t obj1_1287;
				      obj1_1287 = _pass__125_engine_param;
				      {		/* ./Ieee/equiv.scm 5508 */
					 obj_t aux_1650;
					 aux_1650 =
					    CNST_TABLE_REF(((long) 28));
					 test1580_883 =
					    (obj1_1287 == aux_1650);
				      }
				   }
				   if (test1580_883)
				     {	/* Engine/compiler.scm 274 */
					test1579_882 = ((bool_t) 1);
				     }
				   else
				     {	/* Engine/compiler.scm 274 */
					test1579_882 =
					   CBOOL(_c_debug__136_engine_param);
				     }
				}
				if (test1579_882)
				  {	/* Engine/compiler.scm 274 */
				     indent_cc_indent(c_prefix_211_872);
				  }
				else
				  {	/* Engine/compiler.scm 274 */
				     BUNSPEC;
				  }
			     }
			     {	/* Engine/compiler.scm 278 */
				obj_t arg1581_884;
				arg1581_884 =
				   CNST_TABLE_REF(((long) 28));
				{	/* Engine/compiler.scm 278 */
				   obj_t _anonymous_1583__48_1292;
				   _anonymous_1583__48_1292 = proc1675_engine_compiler;
				   stop_on_pass_198_engine_pass(arg1581_884, _anonymous_1583__48_1292);
				}
			     }
			     {	/* Engine/compiler.scm 281 */
				bool_t arg1584_888;
				{	/* Engine/compiler.scm 281 */
				   bool_t test1585_889;
				   {	/* Engine/compiler.scm 281 */
				      obj_t obj1_1289;
				      obj1_1289 = _pass__125_engine_param;
				      {		/* ./Ieee/equiv.scm 5508 */
					 obj_t aux_1659;
					 aux_1659 =
					    CNST_TABLE_REF(((long) 29));
					 test1585_889 =
					    (obj1_1289 == aux_1659);
				      }
				   }
				   if (test1585_889)
				     {	/* Engine/compiler.scm 281 */
					arg1584_888 = ((bool_t) 0);
				     }
				   else
				     {	/* Engine/compiler.scm 281 */
					arg1584_888 = ((bool_t) 1);
				     }
				}
				cc_cc_cc(c_prefix_211_872, arg1584_888);
			     }
			     {	/* Engine/compiler.scm 282 */
				obj_t arg1586_890;
				arg1586_890 =
				   CNST_TABLE_REF(((long) 29));
				{	/* Engine/compiler.scm 282 */
				   obj_t _anonymous_1588__113_1291;
				   _anonymous_1588__113_1291 = proc1676_engine_compiler;
				   stop_on_pass_198_engine_pass(arg1586_890, _anonymous_1588__113_1291);
				}
			     }
			     ld_cc_ld(c_prefix_211_872, ((bool_t) 1));
			  }
			else
			  {	/* Engine/compiler.scm 271 */
			     BUNSPEC;
			  }
			return
			   BINT(((long) 0));
		     }
		  }
	       }
	    }
	 }
      }
   }
}



/* _compiler */
obj_t 
_compiler_engine_compiler(obj_t env_1317)
{
   AN_OBJECT;
   {	/* Engine/compiler.scm 71 */
      return
	 compiler_engine_compiler();
   }
}



/* <anonymous:1588> */
obj_t 
_anonymous_1588__113_engine_compiler(obj_t env_1318)
{
   AN_OBJECT;
   {	/* Engine/compiler.scm 282 */
      {

	 return
	    CNST_TABLE_REF(((long) 30));
      }
   }
}



/* <anonymous:1583> */
obj_t 
_anonymous_1583__48_engine_compiler(obj_t env_1319)
{
   AN_OBJECT;
   {	/* Engine/compiler.scm 278 */
      {

	 return
	    CNST_TABLE_REF(((long) 30));
      }
   }
}



/* <anonymous:1577> */
obj_t 
_anonymous_1577__233_engine_compiler(obj_t env_1320)
{
   AN_OBJECT;
   {	/* Engine/compiler.scm 269 */
      {

	 return
	    CNST_TABLE_REF(((long) 30));
      }
   }
}



/* <anonymous:1572> */
obj_t 
_anonymous_1572__86_engine_compiler(obj_t env_1321)
{
   AN_OBJECT;
   {	/* Engine/compiler.scm 268 */
      {

	 return
	    CNST_TABLE_REF(((long) 30));
      }
   }
}



/* <anonymous:1568> */
obj_t 
_anonymous_1568__238_engine_compiler(obj_t env_1322)
{
   AN_OBJECT;
   {	/* Engine/compiler.scm 264 */
      {		/* Engine/compiler.scm 264 */
	 obj_t ast_1323;
	 ast_1323 =
	    PROCEDURE_REF(env_1322, ((long) 0));
	 {

	    return
	       write_ast_133_write_ast(
	       CELL_REF(ast_1323));
	 }
      }
   }
}



/* <anonymous:1564> */
obj_t 
_anonymous_1564__74_engine_compiler(obj_t env_1324)
{
   AN_OBJECT;
   {	/* Engine/compiler.scm 258 */
      {		/* Engine/compiler.scm 258 */
	 obj_t ast_1325;
	 ast_1325 =
	    PROCEDURE_REF(env_1324, ((long) 0));
	 {

	    return
	       write_ast_133_write_ast(
	       CELL_REF(ast_1325));
	 }
      }
   }
}



/* <anonymous:1561> */
obj_t 
_anonymous_1561__76_engine_compiler(obj_t env_1326)
{
   AN_OBJECT;
   {	/* Engine/compiler.scm 254 */
      {		/* Engine/compiler.scm 254 */
	 obj_t ast_1327;
	 ast_1327 =
	    PROCEDURE_REF(env_1326, ((long) 0));
	 {

	    return
	       write_ast_133_write_ast(
	       CELL_REF(ast_1327));
	 }
      }
   }
}



/* <anonymous:1557> */
obj_t 
_anonymous_1557__105_engine_compiler(obj_t env_1328)
{
   AN_OBJECT;
   {	/* Engine/compiler.scm 249 */
      {		/* Engine/compiler.scm 249 */
	 obj_t ast_1329;
	 ast_1329 =
	    PROCEDURE_REF(env_1328, ((long) 0));
	 {

	    return
	       write_ast_133_write_ast(
	       CELL_REF(ast_1329));
	 }
      }
   }
}



/* <anonymous:1552> */
obj_t 
_anonymous_1552__108_engine_compiler(obj_t env_1330)
{
   AN_OBJECT;
   {	/* Engine/compiler.scm 244 */
      {		/* Engine/compiler.scm 244 */
	 obj_t ast_1331;
	 ast_1331 =
	    PROCEDURE_REF(env_1330, ((long) 0));
	 {

	    return
	       write_ast_133_write_ast(
	       CELL_REF(ast_1331));
	 }
      }
   }
}



/* <anonymous:1548> */
obj_t 
_anonymous_1548__142_engine_compiler(obj_t env_1332)
{
   AN_OBJECT;
   {	/* Engine/compiler.scm 237 */
      {		/* Engine/compiler.scm 237 */
	 obj_t ast_1333;
	 ast_1333 =
	    PROCEDURE_REF(env_1332, ((long) 0));
	 {

	    return
	       write_ast_133_write_ast(
	       CELL_REF(ast_1333));
	 }
      }
   }
}



/* <anonymous:1544> */
obj_t 
_anonymous_1544__64_engine_compiler(obj_t env_1334)
{
   AN_OBJECT;
   {	/* Engine/compiler.scm 233 */
      {		/* Engine/compiler.scm 233 */
	 obj_t ast_1335;
	 ast_1335 =
	    PROCEDURE_REF(env_1334, ((long) 0));
	 {

	    return
	       write_ast_133_write_ast(
	       CELL_REF(ast_1335));
	 }
      }
   }
}



/* <anonymous:1540> */
obj_t 
_anonymous_1540__174_engine_compiler(obj_t env_1336)
{
   AN_OBJECT;
   {	/* Engine/compiler.scm 225 */
      {		/* Engine/compiler.scm 225 */
	 obj_t ast_1337;
	 ast_1337 =
	    PROCEDURE_REF(env_1336, ((long) 0));
	 {

	    return
	       write_ast_133_write_ast(
	       CELL_REF(ast_1337));
	 }
      }
   }
}



/* <anonymous:1536> */
obj_t 
_anonymous_1536__60_engine_compiler(obj_t env_1338)
{
   AN_OBJECT;
   {	/* Engine/compiler.scm 221 */
      {		/* Engine/compiler.scm 221 */
	 obj_t ast_1339;
	 ast_1339 =
	    PROCEDURE_REF(env_1338, ((long) 0));
	 {

	    return
	       write_ast_133_write_ast(
	       CELL_REF(ast_1339));
	 }
      }
   }
}



/* <anonymous:1533> */
obj_t 
_anonymous_1533__34_engine_compiler(obj_t env_1340)
{
   AN_OBJECT;
   {	/* Engine/compiler.scm 217 */
      {		/* Engine/compiler.scm 217 */
	 obj_t ast_1341;
	 ast_1341 =
	    PROCEDURE_REF(env_1340, ((long) 0));
	 {

	    return
	       write_ast_133_write_ast(
	       CELL_REF(ast_1341));
	 }
      }
   }
}



/* <anonymous:1527> */
obj_t 
_anonymous_1527__45_engine_compiler(obj_t env_1342)
{
   AN_OBJECT;
   {	/* Engine/compiler.scm 211 */
      {		/* Engine/compiler.scm 211 */
	 obj_t ast_1343;
	 ast_1343 =
	    PROCEDURE_REF(env_1342, ((long) 0));
	 {

	    return
	       write_ast_133_write_ast(
	       CELL_REF(ast_1343));
	 }
      }
   }
}



/* <anonymous:1521> */
obj_t 
_anonymous_1521__218_engine_compiler(obj_t env_1344)
{
   AN_OBJECT;
   {	/* Engine/compiler.scm 205 */
      {		/* Engine/compiler.scm 205 */
	 obj_t ast_1345;
	 ast_1345 =
	    PROCEDURE_REF(env_1344, ((long) 0));
	 {

	    return
	       write_ast_133_write_ast(
	       CELL_REF(ast_1345));
	 }
      }
   }
}



/* <anonymous:1518> */
obj_t 
_anonymous_1518__240_engine_compiler(obj_t env_1346)
{
   AN_OBJECT;
   {	/* Engine/compiler.scm 201 */
      {		/* Engine/compiler.scm 201 */
	 obj_t ast_1347;
	 ast_1347 =
	    PROCEDURE_REF(env_1346, ((long) 0));
	 {

	    return
	       write_ast_133_write_ast(
	       CELL_REF(ast_1347));
	 }
      }
   }
}



/* <anonymous:1515> */
obj_t 
_anonymous_1515__236_engine_compiler(obj_t env_1348)
{
   AN_OBJECT;
   {	/* Engine/compiler.scm 195 */
      {		/* Engine/compiler.scm 195 */
	 obj_t ast_1349;
	 ast_1349 =
	    PROCEDURE_REF(env_1348, ((long) 0));
	 {

	    return
	       write_ast_133_write_ast(
	       CELL_REF(ast_1349));
	 }
      }
   }
}



/* <anonymous:1510> */
obj_t 
_anonymous_1510__10_engine_compiler(obj_t env_1350)
{
   AN_OBJECT;
   {	/* Engine/compiler.scm 184 */
      {		/* Engine/compiler.scm 184 */
	 obj_t ast_1351;
	 ast_1351 =
	    PROCEDURE_REF(env_1350, ((long) 0));
	 {

	    return
	       write_ast_133_write_ast(
	       CELL_REF(ast_1351));
	 }
      }
   }
}



/* <anonymous:1506> */
obj_t 
_anonymous_1506__179_engine_compiler(obj_t env_1352)
{
   AN_OBJECT;
   {	/* Engine/compiler.scm 179 */
      {

	 return
	    make_add_heap_195_heap_make();
      }
   }
}



/* <anonymous:1503> */
obj_t 
_anonymous_1503__0_engine_compiler(obj_t env_1353)
{
   AN_OBJECT;
   {	/* Engine/compiler.scm 176 */
      {

	 return
	    make_heap_12_heap_make();
      }
   }
}



/* <anonymous:1500> */
obj_t 
_anonymous_1500__165_engine_compiler(obj_t env_1354)
{
   AN_OBJECT;
   {	/* Engine/compiler.scm 168 */
      {		/* Engine/compiler.scm 168 */
	 obj_t ast_1355;
	 ast_1355 =
	    PROCEDURE_REF(env_1354, ((long) 0));
	 {

	    return
	       write_ast_133_write_ast(
	       CELL_REF(ast_1355));
	 }
      }
   }
}



/* <anonymous:1497> */
obj_t 
_anonymous_1497__161_engine_compiler(obj_t env_1356)
{
   AN_OBJECT;
   {	/* Engine/compiler.scm 164 */
      {		/* Engine/compiler.scm 164 */
	 obj_t units_1357;
	 units_1357 =
	    PROCEDURE_REF(env_1356, ((long) 0));
	 {

	    return
	       write_expanded_48_write_expanded(
	       CELL_REF(units_1357));
	 }
      }
   }
}



/* <anonymous:1494> */
obj_t 
_anonymous_1494__255_engine_compiler(obj_t env_1358)
{
   AN_OBJECT;
   {	/* Engine/compiler.scm 160 */
      {		/* Engine/compiler.scm 160 */
	 obj_t units_1359;
	 units_1359 =
	    PROCEDURE_REF(env_1358, ((long) 0));
	 {

	    return
	       write_expanded_48_write_expanded(
	       CELL_REF(units_1359));
	 }
      }
   }
}



/* <anonymous:1490> */
obj_t 
_anonymous_1490__15_engine_compiler(obj_t env_1360)
{
   AN_OBJECT;
   {	/* Engine/compiler.scm 147 */
      {		/* Engine/compiler.scm 147 */
	 obj_t units_1361;
	 units_1361 =
	    PROCEDURE_REF(env_1360, ((long) 0));
	 {

	    return
	       write_expanded_48_write_expanded(
	       CELL_REF(units_1361));
	 }
      }
   }
}



/* <anonymous:1470> */
obj_t 
_anonymous_1470__95_engine_compiler(obj_t env_1362)
{
   AN_OBJECT;
   {	/* Engine/compiler.scm 130 */
      {

	 {	/* Engine/compiler.scm 130 */
	    long aux_1713;
	    aux_1713 = ((long) 0);
	    return
	       BINT(aux_1713);
	 }
      }
   }
}



/* method-init */
obj_t 
method_init_76_engine_compiler()
{
   AN_OBJECT;
   {	/* Engine/compiler.scm 14 */
      return BUNSPEC;
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_engine_compiler()
{
   AN_OBJECT;
   {	/* Engine/compiler.scm 14 */
      module_initialization_70_tools_speek(((long) 0), "ENGINE_COMPILER");
      module_initialization_70_tools_error(((long) 0), "ENGINE_COMPILER");
      module_initialization_70_engine_pass(((long) 0), "ENGINE_COMPILER");
      module_initialization_70_engine_signals(((long) 0), "ENGINE_COMPILER");
      module_initialization_70_engine_param(((long) 0), "ENGINE_COMPILER");
      module_initialization_70_engine_engine(((long) 0), "ENGINE_COMPILER");
      module_initialization_70_read_src(((long) 0), "ENGINE_COMPILER");
      module_initialization_70_write_expanded(((long) 0), "ENGINE_COMPILER");
      module_initialization_70_write_ast(((long) 0), "ENGINE_COMPILER");
      module_initialization_70_read_access(((long) 0), "ENGINE_COMPILER");
      module_initialization_70_heap_restore(((long) 0), "ENGINE_COMPILER");
      module_initialization_70_heap_make(((long) 0), "ENGINE_COMPILER");
      module_initialization_70_ast_env(((long) 0), "ENGINE_COMPILER");
      module_initialization_70_type_type(((long) 0), "ENGINE_COMPILER");
      module_initialization_70_ast_var(((long) 0), "ENGINE_COMPILER");
      module_initialization_70_ast_node(((long) 0), "ENGINE_COMPILER");
      module_initialization_70_ast_build(((long) 0), "ENGINE_COMPILER");
      module_initialization_70_ast_unit(((long) 0), "ENGINE_COMPILER");
      module_initialization_70_ast_check_global_init_17(((long) 0), "ENGINE_COMPILER");
      module_initialization_70_user_user(((long) 0), "ENGINE_COMPILER");
      module_initialization_70_type_env(((long) 0), "ENGINE_COMPILER");
      module_initialization_70_type_cache(((long) 0), "ENGINE_COMPILER");
      module_initialization_70_module_module(((long) 0), "ENGINE_COMPILER");
      module_initialization_70_module_include(((long) 0), "ENGINE_COMPILER");
      module_initialization_70_expand_syntax_case_44(((long) 0), "ENGINE_COMPILER");
      module_initialization_70_expand_eps(((long) 0), "ENGINE_COMPILER");
      module_initialization_70_expand_install(((long) 0), "ENGINE_COMPILER");
      module_initialization_70_init_main(((long) 0), "ENGINE_COMPILER");
      module_initialization_70_init_setrc(((long) 0), "ENGINE_COMPILER");
      module_initialization_70_trace_walk(((long) 0), "ENGINE_COMPILER");
      module_initialization_70_inline_walk(((long) 0), "ENGINE_COMPILER");
      module_initialization_70_effect_walk(((long) 0), "ENGINE_COMPILER");
      module_initialization_70_callcc_walk(((long) 0), "ENGINE_COMPILER");
      module_initialization_70_fail_walk(((long) 0), "ENGINE_COMPILER");
      module_initialization_70_globalize_walk(((long) 0), "ENGINE_COMPILER");
      module_initialization_70_cfa_walk(((long) 0), "ENGINE_COMPILER");
      module_initialization_70_cfa_tvector(((long) 0), "ENGINE_COMPILER");
      module_initialization_70_integrate_walk(((long) 0), "ENGINE_COMPILER");
      module_initialization_70_coerce_walk(((long) 0), "ENGINE_COMPILER");
      module_initialization_70_reduce_walk(((long) 0), "ENGINE_COMPILER");
      module_initialization_70_cnst_walk(((long) 0), "ENGINE_COMPILER");
      module_initialization_70_cgen_walk(((long) 0), "ENGINE_COMPILER");
      module_initialization_70_hgen_walk(((long) 0), "ENGINE_COMPILER");
      module_initialization_70_bdb_setting(((long) 0), "ENGINE_COMPILER");
      module_initialization_70_bdb_spread_obj_171(((long) 0), "ENGINE_COMPILER");
      module_initialization_70_bdb_walk(((long) 0), "ENGINE_COMPILER");
      module_initialization_70_prof_walk(((long) 0), "ENGINE_COMPILER");
      module_initialization_70_cc_indent(((long) 0), "ENGINE_COMPILER");
      module_initialization_70_cc_cc(((long) 0), "ENGINE_COMPILER");
      return
	 module_initialization_70_cc_ld(((long) 0), "ENGINE_COMPILER");
   }
}
