/*===========================================================================*/
/*   (Expand/object.scm)                                                     */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct tclass
  {
     obj_t its_super_214;
     obj_t slots;
     struct global *holder;
     obj_t widening;
     long depth;
     bool_t final__12;
     obj_t constructor;
     obj_t virtual_slots_number_200;
  }
      *tclass_bglt;


static obj_t make_widening_107_expand_object(obj_t, type_bglt, obj_t, obj_t);
static obj_t method_init_76_expand_object();
extern obj_t symbol_append_197___r4_symbols_6_4(obj_t);
extern obj_t string_append(obj_t, obj_t);
static obj_t find_slot_offset___11_expand_object(obj_t, obj_t, obj_t);
extern obj_t list_ref_194___r4_pairs_and_lists_6_3(obj_t, long);
extern obj_t mark_symbol_non_user__17_ast_ident(obj_t);
static obj_t _expand_widen__96_expand_object(obj_t, obj_t, obj_t);
static obj_t make_virtual_set_218_expand_object(obj_t, obj_t, obj_t, obj_t, obj_t, char *);
extern obj_t gensym___r4_symbols_6_4;
static obj_t make_a_shrink__124_expand_object(obj_t, obj_t);
extern type_bglt type_of_id_183_ast_ident(obj_t, obj_t);
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t module_initialization_70_expand_object(long, char *);
extern obj_t module_initialization_70_tools_args(long, char *);
extern obj_t module_initialization_70_tools_progn(long, char *);
extern obj_t module_initialization_70_tools_misc(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_env(long, char *);
extern obj_t module_initialization_70_expand_eps(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_ident(long, char *);
extern obj_t module_initialization_70_object_class(long, char *);
extern obj_t module_initialization_70_tools_location(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_symbols_6_4(long, char *);
extern long list_length(obj_t);
static obj_t _expand_duplicate_242_expand_object(obj_t, obj_t, obj_t);
static obj_t object_epairify_147_expand_object(obj_t, obj_t);
static obj_t instantiate__make_36_expand_object(obj_t, type_bglt, obj_t);
static obj_t imported_modules_init_94_expand_object();
static obj_t find_slot_offset_103_expand_object(obj_t, obj_t, obj_t);
extern obj_t normalize_progn_143_tools_progn(obj_t);
static obj_t duplicate__make_94_expand_object(obj_t, obj_t, obj_t, obj_t);
extern obj_t expand_duplicate_139_expand_object(obj_t, obj_t);
static obj_t _expand_with_access_125_expand_object(obj_t, obj_t, obj_t);
static obj_t _expand_instantiate_86_expand_object(obj_t, obj_t, obj_t);
extern obj_t append_2_18___r4_pairs_and_lists_6_3(obj_t, obj_t);
static obj_t library_modules_init_112_expand_object();
static obj_t _expand_shrink__87_expand_object(obj_t, obj_t, obj_t);
extern obj_t assq___r4_pairs_and_lists_6_3(obj_t, obj_t);
static obj_t toplevel_init_63_expand_object();
extern obj_t _unsafe_type__146_engine_param;
extern obj_t replace__160_tools_misc(obj_t, obj_t);
extern obj_t open_input_string(obj_t);
extern obj_t expand_widen__163_expand_object(obj_t, obj_t);
extern obj_t lexical_stack_189_expand_eps();
extern obj_t with_lexical_22_expand_eps(obj_t, obj_t, obj_t, obj_t);
extern obj_t string_to_bstring(char *);
extern obj_t parse_id_241_ast_ident(obj_t, obj_t);
extern obj_t tclass_object_class;
static obj_t with_access_expander_113_expand_object(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t memq___r4_pairs_and_lists_6_3(obj_t, obj_t);
static obj_t _anonymous_1261__28_expand_object(obj_t, obj_t, obj_t);
extern obj_t expand_shrink__128_expand_object(obj_t, obj_t);
static obj_t _anonymous_1241__199_expand_object(obj_t);
extern obj_t _4dots_199_tools_misc;
extern obj_t read___reader(obj_t);
static obj_t find_slot_offset__176_expand_object(obj_t, obj_t, obj_t);
extern obj_t find_location_120_tools_location(obj_t);
static obj_t require_initialization_114_expand_object = BUNSPEC;
extern obj_t expand_with_access_221_expand_object(obj_t, obj_t);
extern obj_t expand_instantiate_150_expand_object(obj_t, obj_t);
static obj_t cnst_init_137_expand_object();
extern obj_t reverse__39___r4_pairs_and_lists_6_3(obj_t);
extern obj_t make_vector(long, obj_t);
static obj_t __cnst[30];

DEFINE_EXPORT_PROCEDURE(expand_duplicate_env_116_expand_object, _expand_duplicate_242_expand_object2067, _expand_duplicate_242_expand_object, 0L, 2);
DEFINE_EXPORT_PROCEDURE(expand_instantiate_env_9_expand_object, _expand_instantiate_86_expand_object2068, _expand_instantiate_86_expand_object, 0L, 2);
DEFINE_EXPORT_PROCEDURE(expand_widen__env_255_expand_object, _expand_widen__96_expand_object2069, _expand_widen__96_expand_object, 0L, 2);
DEFINE_EXPORT_PROCEDURE(expand_shrink__env_80_expand_object, _expand_shrink__87_expand_object2070, _expand_shrink__87_expand_object, 0L, 2);
DEFINE_STRING(string2062_expand_object, string2062_expand_object2071, "OBJECT? O ERROR BEGIN OBJECT-CLASS CLASS-SUPER EQ? SHRINK! OBJECT-WIDENING IF CLASS-NUM __OBJECT OBJECT-CLASS-NUM-SET! @ OBJECT-WIDENING-SET! PRAGMA OBJ LET* -REF NOTHING DUPLICATED MAKE- OK DONE NEW SET! -SET! - LET INSTANCE ", 226);
DEFINE_STRING(string2061_expand_object, string2061_expand_object2072, "Type `extended pair' expected for expression", 44);
DEFINE_STRING(string2059_expand_object, string2059_expand_object2073, "Illegal `", 9);
DEFINE_STRING(string2060_expand_object, string2060_expand_object2074, "cer", 3);
DEFINE_STRING(string2058_expand_object, string2058_expand_object2075, "' form (read-only slot ", 23);
DEFINE_STRING(string2057_expand_object, string2057_expand_object2076, "shrink!", 7);
DEFINE_STRING(string2056_expand_object, string2056_expand_object2077, "Not a wide object", 17);
DEFINE_STRING(string2055_expand_object, string2055_expand_object2078, "Illegal `shrink!' form", 22);
DEFINE_STRING(string2054_expand_object, string2054_expand_object2079, "Illegal `widen!' form (unknown slot ", 36);
DEFINE_STRING(string2053_expand_object, string2053_expand_object2080, "widen!", 6);
DEFINE_STRING(string2052_expand_object, string2052_expand_object2081, "This object can't be widened to the wanted class", 48);
DEFINE_STRING(string2051_expand_object, string2051_expand_object2082, "Illegal `widening!' form (missing arguments for slot ", 53);
DEFINE_STRING(string2049_expand_object, string2049_expand_object2083, ")($1))", 6);
DEFINE_STRING(string2050_expand_object, string2050_expand_object2084, "((", 2);
DEFINE_STRING(string2048_expand_object, string2048_expand_object2085, "Illegal `widen!' form", 21);
DEFINE_STRING(string2047_expand_object, string2047_expand_object2086, "widen!:Illegal class type:", 26);
DEFINE_STRING(string2046_expand_object, string2046_expand_object2087, "Illegal `duplicate' form (unknown slot ", 39);
DEFINE_STRING(string2045_expand_object, string2045_expand_object2088, "Illegal `duplicate' form", 24);
DEFINE_STRING(string2044_expand_object, string2044_expand_object2089, "duplicate:Illegal class type:", 29);
DEFINE_STRING(string2043_expand_object, string2043_expand_object2090, "Illegal `instantiate' form (unknown slot ", 41);
DEFINE_STRING(string2042_expand_object, string2042_expand_object2091, "Illegal `instantiate' form (missing arguments for slot ", 55);
DEFINE_STRING(string2041_expand_object, string2041_expand_object2092, ")", 1);
DEFINE_STRING(string2039_expand_object, string2039_expand_object2093, "Illegal `with-access' form", 26);
DEFINE_STRING(string2040_expand_object, string2040_expand_object2094, "Illegal `instantiate' form", 26);
DEFINE_EXPORT_PROCEDURE(expand_with_access_env_4_expand_object, _expand_with_access_125_expand_object2095, _expand_with_access_125_expand_object, 0L, 2);



/* module-initialization */
obj_t 
module_initialization_70_expand_object(long checksum_2681, char *from_2682)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_expand_object))
	{
	   require_initialization_114_expand_object =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_expand_object();
	   cnst_init_137_expand_object();
	   imported_modules_init_94_expand_object();
	   method_init_76_expand_object();
	   toplevel_init_63_expand_object();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_expand_object()
{
   AN_OBJECT;
   {	/* Expand/object.scm 14 */
      module_initialization_70___r4_symbols_6_4(((long) 0), "EXPAND_OBJECT");
      module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "EXPAND_OBJECT");
      module_initialization_70___object(((long) 0), "EXPAND_OBJECT");
      module_initialization_70___reader(((long) 0), "EXPAND_OBJECT");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_expand_object()
{
   AN_OBJECT;
   {	/* Expand/object.scm 14 */
      {		/* Expand/object.scm 14 */
	 obj_t cnst_port_138_2674;
	 cnst_port_138_2674 =
	    open_input_string(string2062_expand_object);
	 {
	    long i_2675;
	    i_2675 = ((long) 29);
	  loop_2676:
	    {	/* Expand/object.scm 14 */
	       bool_t test2063_2677;
	       test2063_2677 =
		  (i_2675 == ((long) -1));
	       if (test2063_2677)
		 {	/* Expand/object.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Expand/object.scm 14 */
		    {	/* Expand/object.scm 14 */
		       obj_t arg2064_2678;
		       {	/* Expand/object.scm 14 */
			  obj_t list2065_2679;
			  list2065_2679 =
			     MAKE_PAIR(cnst_port_138_2674, BNIL);
			  arg2064_2678 =
			     read___reader(list2065_2679);
		       }
		       CNST_TABLE_SET(i_2675, arg2064_2678);
		    }
		    {	/* Expand/object.scm 14 */
		       int aux_2680;
		       {	/* Expand/object.scm 14 */
			  long aux_2701;
			  aux_2701 =
			     (i_2675 - ((long) 1));
			  aux_2680 =
			     (int) (aux_2701);
		       }
		       {
			  long i_2704;
			  i_2704 =
			     (long) (aux_2680);
			  i_2675 = i_2704;
			  goto loop_2676;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_expand_object()
{
   AN_OBJECT;
   {	/* Expand/object.scm 14 */
      return BUNSPEC;
   }
}



/* expand-with-access */
obj_t 
expand_with_access_221_expand_object(obj_t x_71, obj_t e_72)
{
   AN_OBJECT;
   {	/* Expand/object.scm 36 */
      {
	 obj_t with_access_173_504;
	 obj_t instance_505;
	 obj_t slots_506;
	 obj_t body_507;
	 if (
	    PAIRP(x_71))
	   {	/* Expand/object.scm 37 */
	      obj_t cdr_113_28_512;
	      cdr_113_28_512 =
		 CDR(x_71);
	      if (
		 PAIRP(cdr_113_28_512))
		{	/* Expand/object.scm 37 */
		   obj_t cdr_119_211_514;
		   cdr_119_211_514 =
		      CDR(cdr_113_28_512);
		   if (
		      PAIRP(cdr_119_211_514))
		     {	/* Expand/object.scm 37 */
			obj_t car_123_18_516;
			obj_t cdr_124_99_517;
			car_123_18_516 =
			   CAR(cdr_119_211_514);
			cdr_124_99_517 =
			   CDR(cdr_119_211_514);
			if (
			   PAIRP(car_123_18_516))
			  {	/* Expand/object.scm 37 */
			     if (
				PAIRP(cdr_124_99_517))
			       {	/* Expand/object.scm 37 */
				  with_access_173_504 =
				     CAR(x_71);
				  instance_505 =
				     CAR(cdr_113_28_512);
				  slots_506 = car_123_18_516;
				  body_507 = cdr_124_99_517;
				  {	/* Expand/object.scm 39 */
				     obj_t loc_522;
				     loc_522 =
					find_location_120_tools_location(x_71);
				     {	/* Expand/object.scm 39 */
					type_bglt class_523;
					class_523 =
					   type_of_id_183_ast_ident(with_access_173_504, loc_522);
					{	/* Expand/object.scm 40 */

					   {	/* Expand/object.scm 41 */
					      bool_t test1235_524;
					      test1235_524 =
						 is_a__118___object(
						 (obj_t) (class_523), tclass_object_class);
					      if (test1235_524)
						{
						   obj_t s_525;
						   s_525 = slots_506;
						 loop_526:
						   if (
						      NULLP(s_525))
						     {	/* Expand/object.scm 45 */
							{	/* Expand/object.scm 46 */
							   obj_t aux_528;
							   {	/* Expand/object.scm 46 */
							      obj_t arg1256_548;
							      arg1256_548 =
								 PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4,
								 CNST_TABLE_REF(((long) 0)), BEOA);
							      aux_528 =
								 mark_symbol_non_user__17_ast_ident(arg1256_548);
							   }
							   {	/* Expand/object.scm 47 */
							      obj_t instance_530;
							      instance_530 =
								 PROCEDURE_ENTRY(e_72) (e_72, instance_505, e_72, BEOA);
							      {		/* Expand/object.scm 48 */

								 {	/* Expand/object.scm 53 */
								    obj_t arg1237_531;
								    {	/* Expand/object.scm 53 */
								       obj_t arg1238_532;
								       arg1238_532 =
									  find_location_120_tools_location(x_71);
								       {	/* Expand/object.scm 55 */
									  obj_t _anonymous_1241__199_2629;
									  _anonymous_1241__199_2629 =
									     make_fx_procedure(_anonymous_1241__199_expand_object, ((long) 0), ((long) 7));
									  {	/* Expand/object.scm 55 */
									     obj_t aux_2735;
									     aux_2735 =
										(obj_t) (class_523);
									     PROCEDURE_SET(_anonymous_1241__199_2629, ((long) 0), aux_2735);
									  }
									  PROCEDURE_SET(_anonymous_1241__199_2629, ((long) 1), e_72);
									  PROCEDURE_SET(_anonymous_1241__199_2629, ((long) 2), aux_528);
									  PROCEDURE_SET(_anonymous_1241__199_2629, ((long) 3), aux_528);
									  PROCEDURE_SET(_anonymous_1241__199_2629, ((long) 4), slots_506);
									  PROCEDURE_SET(_anonymous_1241__199_2629, ((long) 5), instance_530);
									  PROCEDURE_SET(_anonymous_1241__199_2629, ((long) 6), body_507);
									  arg1237_531 =
									     with_lexical_22_expand_eps(slots_506, aux_528, arg1238_532, _anonymous_1241__199_2629);
								       }
								    }
								    return
								       replace__160_tools_misc(x_71, arg1237_531);
								 }
							      }
							   }
							}
						     }
						   else
						     {	/* Expand/object.scm 45 */
							if (
							   PAIRP(s_525))
							  {	/* Expand/object.scm 66 */
							     bool_t test_2748;
							     {	/* ./Ieee/symbol.scm 6015 */
								obj_t aux_2749;
								aux_2749 =
								   CAR(s_525);
								test_2748 =
								   SYMBOLP(aux_2749);
							     }
							     if (test_2748)
							       {	/* Expand/object.scm 66 */
								  {
								     obj_t s_2752;
								     s_2752 =
									CDR(s_525);
								     s_525 = s_2752;
								     goto loop_526;
								  }
							       }
							     else
							       {	/* Expand/object.scm 66 */
								  FAILURE(BFALSE, string2039_expand_object, x_71);
							       }
							  }
							else
							  {	/* Expand/object.scm 64 */
							     FAILURE(BFALSE, string2039_expand_object, x_71);
							  }
						     }
						}
					      else
						{	/* Expand/object.scm 41 */
						   FAILURE(BFALSE, string2039_expand_object, x_71);
						}
					   }
					}
				     }
				  }
			       }
			     else
			       {	/* Expand/object.scm 37 */
				tag_102_241_509:
				  FAILURE(BFALSE, string2039_expand_object, x_71);
			       }
			  }
			else
			  {	/* Expand/object.scm 37 */
			     goto tag_102_241_509;
			  }
		     }
		   else
		     {	/* Expand/object.scm 37 */
			goto tag_102_241_509;
		     }
		}
	      else
		{	/* Expand/object.scm 37 */
		   goto tag_102_241_509;
		}
	   }
	 else
	   {	/* Expand/object.scm 37 */
	      goto tag_102_241_509;
	   }
      }
   }
}



/* _expand-with-access */
obj_t 
_expand_with_access_125_expand_object(obj_t env_2630, obj_t x_2631, obj_t e_2632)
{
   AN_OBJECT;
   {	/* Expand/object.scm 36 */
      return
	 expand_with_access_221_expand_object(x_2631, e_2632);
   }
}



/* <anonymous:1241> */
obj_t 
_anonymous_1241__199_expand_object(obj_t env_2633)
{
   AN_OBJECT;
   {	/* Expand/object.scm 54 */
      {		/* Expand/object.scm 55 */
	 obj_t class_2634;
	 obj_t e_2635;
	 obj_t mark_2636;
	 obj_t aux_2637;
	 obj_t slots_2638;
	 obj_t instance_2639;
	 obj_t body_2640;
	 class_2634 =
	    PROCEDURE_REF(env_2633, ((long) 0));
	 e_2635 =
	    PROCEDURE_REF(env_2633, ((long) 1));
	 mark_2636 =
	    PROCEDURE_REF(env_2633, ((long) 2));
	 aux_2637 =
	    PROCEDURE_REF(env_2633, ((long) 3));
	 slots_2638 =
	    PROCEDURE_REF(env_2633, ((long) 4));
	 instance_2639 =
	    PROCEDURE_REF(env_2633, ((long) 5));
	 body_2640 =
	    PROCEDURE_REF(env_2633, ((long) 6));
	 {

	    {	/* Expand/object.scm 55 */
	       obj_t e_535;
	       {	/* Expand/object.scm 55 */
		  obj_t aux_2768;
		  {	/* Expand/object.scm 59 */
		     type_bglt obj_1643;
		     obj_1643 =
			(type_bglt) (class_2634);
		     aux_2768 =
			(((type_bglt) CREF(obj_1643))->id);
		  }
		  e_535 =
		     with_access_expander_113_expand_object(e_2635, mark_2636, aux_2637, aux_2768, slots_2638);
	       }
	       {	/* Expand/object.scm 61 */
		  obj_t arg1243_536;
		  obj_t arg1245_537;
		  arg1243_536 =
		     CNST_TABLE_REF(((long) 1));
		  {	/* Expand/object.scm 61 */
		     obj_t arg1246_538;
		     obj_t arg1248_539;
		     {	/* Expand/object.scm 61 */
			obj_t arg1249_540;
			{	/* Expand/object.scm 61 */
			   obj_t arg1251_542;
			   arg1251_542 =
			      MAKE_PAIR(instance_2639, BNIL);
			   arg1249_540 =
			      MAKE_PAIR(aux_2637, arg1251_542);
			}
			arg1246_538 =
			   MAKE_PAIR(arg1249_540, BNIL);
		     }
		     {	/* Expand/object.scm 62 */
			obj_t arg1252_543;
			{	/* Expand/object.scm 62 */
			   obj_t arg1254_545;
			   arg1254_545 =
			      normalize_progn_143_tools_progn(body_2640);
			   arg1252_543 =
			      PROCEDURE_ENTRY(e_535) (e_535, arg1254_545, e_535, BEOA);
			}
			arg1248_539 =
			   MAKE_PAIR(arg1252_543, BNIL);
		     }
		     arg1245_537 =
			MAKE_PAIR(arg1246_538, arg1248_539);
		  }
		  return
		     MAKE_PAIR(arg1243_536, arg1245_537);
	       }
	    }
	 }
      }
   }
}



/* with-access-expander */
obj_t 
with_access_expander_113_expand_object(obj_t old_expander_200_73, obj_t mark_74, obj_t instance_75, obj_t class_76, obj_t slots_77)
{
   AN_OBJECT;
   {	/* Expand/object.scm 76 */
      {		/* Expand/object.scm 77 */
	 obj_t _anonymous_1261__28_2641;
	 _anonymous_1261__28_2641 =
	    make_fx_procedure(_anonymous_1261__28_expand_object, ((long) 2), ((long) 5));
	 PROCEDURE_SET(_anonymous_1261__28_2641, ((long) 0), old_expander_200_73);
	 PROCEDURE_SET(_anonymous_1261__28_2641, ((long) 1), slots_77);
	 PROCEDURE_SET(_anonymous_1261__28_2641, ((long) 2), mark_74);
	 PROCEDURE_SET(_anonymous_1261__28_2641, ((long) 3), class_76);
	 PROCEDURE_SET(_anonymous_1261__28_2641, ((long) 4), instance_75);
	 return _anonymous_1261__28_2641;
      }
   }
}



/* <anonymous:1261> */
obj_t 
_anonymous_1261__28_expand_object(obj_t env_2642, obj_t x_2648, obj_t e_2649)
{
   AN_OBJECT;
   {	/* Expand/object.scm 77 */
      {		/* Expand/object.scm 77 */
	 obj_t old_expander_200_2643;
	 obj_t slots_2644;
	 obj_t mark_2645;
	 obj_t class_2646;
	 obj_t instance_2647;
	 old_expander_200_2643 =
	    PROCEDURE_REF(env_2642, ((long) 0));
	 slots_2644 =
	    PROCEDURE_REF(env_2642, ((long) 1));
	 mark_2645 =
	    PROCEDURE_REF(env_2642, ((long) 2));
	 class_2646 =
	    PROCEDURE_REF(env_2642, ((long) 3));
	 instance_2647 =
	    PROCEDURE_REF(env_2642, ((long) 4));
	 {
	    obj_t x_553;
	    obj_t e_554;
	    x_553 = x_2648;
	    e_554 = e_2649;
	    {
	       obj_t var_558;
	       obj_t val_559;
	       obj_t var_556;
	       if (
		  SYMBOLP(x_553))
		 {	/* Expand/object.scm 77 */
		    var_556 = x_553;
		    {	/* Expand/object.scm 80 */
		       bool_t test1274_578;
		       {	/* Expand/object.scm 80 */
			  bool_t test_2795;
			  {	/* Expand/object.scm 80 */
			     obj_t aux_2796;
			     aux_2796 =
				memq___r4_pairs_and_lists_6_3(var_556, slots_2644);
			     test_2795 =
				CBOOL(aux_2796);
			  }
			  if (test_2795)
			    {	/* Expand/object.scm 81 */
			       obj_t cell_586;
			       {	/* Expand/object.scm 81 */
				  obj_t arg1287_589;
				  arg1287_589 =
				     lexical_stack_189_expand_eps();
				  cell_586 =
				     assq___r4_pairs_and_lists_6_3(var_556, arg1287_589);
			       }
			       if (
				  PAIRP(cell_586))
				 {	/* ./Ieee/equiv.scm 5508 */
				    obj_t aux_2803;
				    aux_2803 =
				       CDR(cell_586);
				    test1274_578 =
				       (aux_2803 == mark_2645);
				 }
			       else
				 {	/* Expand/object.scm 82 */
				    test1274_578 = ((bool_t) 0);
				 }
			    }
			  else
			    {	/* Expand/object.scm 80 */
			       test1274_578 = ((bool_t) 0);
			    }
		       }
		       if (test1274_578)
			 {	/* Expand/object.scm 83 */
			    obj_t arg1276_579;
			    obj_t arg1277_580;
			    {	/* Expand/object.scm 83 */
			       obj_t list1278_581;
			       {	/* Expand/object.scm 83 */
				  obj_t arg1280_582;
				  {	/* Expand/object.scm 83 */
				     obj_t arg1281_583;
				     obj_t arg1282_584;
				     arg1281_583 =
					CNST_TABLE_REF(((long) 2));
				     arg1282_584 =
					MAKE_PAIR(var_556, BNIL);
				     arg1280_582 =
					MAKE_PAIR(arg1281_583, arg1282_584);
				  }
				  list1278_581 =
				     MAKE_PAIR(class_2646, arg1280_582);
			       }
			       arg1276_579 =
				  symbol_append_197___r4_symbols_6_4(list1278_581);
			    }
			    arg1277_580 =
			       MAKE_PAIR(instance_2647, BNIL);
			    return
			       MAKE_PAIR(arg1276_579, arg1277_580);
			 }
		       else
			 {	/* Expand/object.scm 80 */
			    return
			       PROCEDURE_ENTRY(old_expander_200_2643) (old_expander_200_2643, var_556, old_expander_200_2643, BEOA);
			 }
		    }
		 }
	       else
		 {	/* Expand/object.scm 77 */
		    if (
		       PAIRP(x_553))
		      {		/* Expand/object.scm 77 */
			 obj_t cdr_144_157_565;
			 cdr_144_157_565 =
			    CDR(x_553);
			 {	/* Expand/object.scm 77 */
			    bool_t test_2819;
			    {	/* ./Ieee/equiv.scm 5508 */
			       obj_t aux_2822;
			       obj_t aux_2820;
			       aux_2822 =
				  CNST_TABLE_REF(((long) 4));
			       aux_2820 =
				  CAR(x_553);
			       test_2819 =
				  (aux_2820 == aux_2822);
			    }
			    if (test_2819)
			      {		/* Expand/object.scm 77 */
				 if (
				    PAIRP(cdr_144_157_565))
				   {	/* Expand/object.scm 77 */
				      obj_t car_147_230_568;
				      obj_t cdr_148_78_569;
				      car_147_230_568 =
					 CAR(cdr_144_157_565);
				      cdr_148_78_569 =
					 CDR(cdr_144_157_565);
				      if (
					 SYMBOLP(car_147_230_568))
					{	/* Expand/object.scm 77 */
					   if (
					      PAIRP(cdr_148_78_569))
					     {	/* Expand/object.scm 77 */
						bool_t test_2833;
						{	/* ./Ieee/equiv.scm 5508 */
						   obj_t aux_2834;
						   aux_2834 =
						      CDR(cdr_148_78_569);
						   test_2833 =
						      (aux_2834 == BNIL);
						}
						if (test_2833)
						  {	/* Expand/object.scm 77 */
						     var_558 = car_147_230_568;
						     val_559 =
							CAR(cdr_148_78_569);
						     {	/* Expand/object.scm 86 */
							obj_t val_590;
							val_590 =
							   PROCEDURE_ENTRY(e_554) (e_554, val_559, e_554, BEOA);
							{	/* Expand/object.scm 87 */
							   bool_t test1288_591;
							   {	/* Expand/object.scm 87 */
							      bool_t test_2839;
							      {		/* Expand/object.scm 87 */
								 obj_t aux_2840;
								 aux_2840 =
								    memq___r4_pairs_and_lists_6_3(var_558, slots_2644);
								 test_2839 =
								    CBOOL(aux_2840);
							      }
							      if (test_2839)
								{	/* Expand/object.scm 88 */
								   obj_t cell_603;
								   {	/* Expand/object.scm 88 */
								      obj_t arg1301_606;
								      arg1301_606 =
									 lexical_stack_189_expand_eps();
								      cell_603 =
									 assq___r4_pairs_and_lists_6_3(var_558, arg1301_606);
								   }
								   if (
								      PAIRP(cell_603))
								     {	/* ./Ieee/equiv.scm 5508 */
									obj_t aux_2847;
									aux_2847 =
									   CDR(cell_603);
									test1288_591 =
									   (aux_2847 == mark_2645);
								     }
								   else
								     {	/* Expand/object.scm 89 */
									test1288_591 = ((bool_t) 0);
								     }
								}
							      else
								{	/* Expand/object.scm 87 */
								   test1288_591 = ((bool_t) 0);
								}
							   }
							   if (test1288_591)
							     {	/* Expand/object.scm 91 */
								obj_t arg1289_592;
								{	/* Expand/object.scm 91 */
								   obj_t arg1290_593;
								   obj_t arg1291_594;
								   {	/* Expand/object.scm 91 */
								      obj_t list1292_595;
								      {		/* Expand/object.scm 91 */
									 obj_t arg1293_596;
									 {	/* Expand/object.scm 91 */
									    obj_t arg1294_597;
									    obj_t arg1295_598;
									    arg1294_597 =
									       CNST_TABLE_REF(((long) 2));
									    {	/* Expand/object.scm 91 */
									       obj_t arg1296_599;
									       {	/* Expand/object.scm 91 */
										  obj_t aux_2852;
										  aux_2852 =
										     CNST_TABLE_REF(((long) 3));
										  arg1296_599 =
										     MAKE_PAIR(aux_2852, BNIL);
									       }
									       arg1295_598 =
										  MAKE_PAIR(var_558, arg1296_599);
									    }
									    arg1293_596 =
									       MAKE_PAIR(arg1294_597, arg1295_598);
									 }
									 list1292_595 =
									    MAKE_PAIR(class_2646, arg1293_596);
								      }
								      arg1290_593 =
									 symbol_append_197___r4_symbols_6_4(list1292_595);
								   }
								   {	/* Expand/object.scm 91 */
								      obj_t arg1297_600;
								      arg1297_600 =
									 MAKE_PAIR(val_590, BNIL);
								      arg1291_594 =
									 MAKE_PAIR(instance_2647, arg1297_600);
								   }
								   arg1289_592 =
								      MAKE_PAIR(arg1290_593, arg1291_594);
								}
								return
								   object_epairify_147_expand_object(arg1289_592, x_553);
							     }
							   else
							     {	/* Expand/object.scm 87 */
								{	/* ./Ieee/pair-list.scm 5890 */
								   obj_t aux_2863;
								   {	/* ./Ieee/pair-list.scm 5707 */
								      obj_t aux_2864;
								      aux_2864 =
									 CDR(x_553);
								      aux_2863 =
									 CDR(aux_2864);
								   }
								   SET_CAR(aux_2863, val_590);
								}
								return
								   PROCEDURE_ENTRY(old_expander_200_2643) (old_expander_200_2643, x_553, old_expander_200_2643, BEOA);
							     }
							}
						     }
						  }
						else
						  {	/* Expand/object.scm 77 */
						   tag_133_84_561:
						     return
							PROCEDURE_ENTRY(old_expander_200_2643) (old_expander_200_2643, x_553, e_554, BEOA);
						  }
					     }
					   else
					     {	/* Expand/object.scm 77 */
						goto tag_133_84_561;
					     }
					}
				      else
					{	/* Expand/object.scm 77 */
					   goto tag_133_84_561;
					}
				   }
				 else
				   {	/* Expand/object.scm 77 */
				      goto tag_133_84_561;
				   }
			      }
			    else
			      {		/* Expand/object.scm 77 */
				 goto tag_133_84_561;
			      }
			 }
		      }
		    else
		      {		/* Expand/object.scm 77 */
			 goto tag_133_84_561;
		      }
		 }
	    }
	 }
      }
   }
}



/* expand-instantiate */
obj_t 
expand_instantiate_150_expand_object(obj_t x_78, obj_t e_79)
{
   AN_OBJECT;
   {	/* Expand/object.scm 102 */
      {
	 obj_t instantiate_607;
	 obj_t provided_608;
	 if (
	    PAIRP(x_78))
	   {	/* Expand/object.scm 103 */
	      instantiate_607 =
		 CAR(x_78);
	      provided_608 =
		 CDR(x_78);
	      {		/* Expand/object.scm 105 */
		 type_bglt class_615;
		 {	/* Expand/object.scm 105 */
		    obj_t arg1309_619;
		    arg1309_619 =
		       find_location_120_tools_location(x_78);
		    class_615 =
		       type_of_id_183_ast_ident(instantiate_607, arg1309_619);
		 }
		 {	/* Expand/object.scm 106 */
		    bool_t test1305_616;
		    test1305_616 =
		       is_a__118___object(
		       (obj_t) (class_615), tclass_object_class);
		    if (test1305_616)
		      {		/* Expand/object.scm 108 */
			 obj_t arg1307_617;
			 {	/* Expand/object.scm 108 */
			    obj_t arg1308_618;
			    arg1308_618 =
			       instantiate__make_36_expand_object(x_78, class_615, provided_608);
			    arg1307_617 =
			       PROCEDURE_ENTRY(e_79) (e_79, arg1308_618, e_79, BEOA);
			 }
			 return
			    replace__160_tools_misc(x_78, arg1307_617);
		      }
		    else
		      {		/* Expand/object.scm 106 */
			 FAILURE(BFALSE, string2040_expand_object, x_78);
		      }
		 }
	      }
	   }
	 else
	   {	/* Expand/object.scm 103 */
	      FAILURE(BFALSE, string2040_expand_object, x_78);
	   }
      }
   }
}



/* _expand-instantiate */
obj_t 
_expand_instantiate_86_expand_object(obj_t env_2650, obj_t x_2651, obj_t e_2652)
{
   AN_OBJECT;
   {	/* Expand/object.scm 102 */
      return
	 expand_instantiate_150_expand_object(x_2651, e_2652);
   }
}



/* instantiate->make */
obj_t 
instantiate__make_36_expand_object(obj_t form_80, type_bglt class_81, obj_t provided_82)
{
   AN_OBJECT;
   {	/* Expand/object.scm 115 */
      {		/* Expand/object.scm 116 */
	 obj_t slots_620;
	 {	/* Expand/object.scm 116 */
	    bool_t test_2889;
	    {	/* Expand/object.scm 116 */
	       tclass_bglt obj_1721;
	       obj_1721 =
		  (tclass_bglt) (class_81);
	       {	/* ./Object/class.scm 1548 */
		  obj_t aux_2891;
		  {
		     obj_t aux_2892;
		     {	/* ./Object/class.scm 1548 */
			object_bglt aux_2893;
			aux_2893 =
			   (object_bglt) (obj_1721);
			aux_2892 =
			   OBJECT_WIDENING(aux_2893);
		     }
		     aux_2891 =
			(((tclass_bglt) CREF(aux_2892))->widening);
		  }
		  test_2889 =
		     CBOOL(aux_2891);
	       }
	    }
	    if (test_2889)
	      {		/* Expand/object.scm 118 */
		 obj_t aux_2912;
		 obj_t aux_2898;
		 {	/* Expand/object.scm 119 */
		    tclass_bglt obj_1724;
		    obj_1724 =
		       (tclass_bglt) (class_81);
		    {
		       obj_t aux_2914;
		       {	/* ./Object/class.scm 1544 */
			  object_bglt aux_2915;
			  aux_2915 =
			     (object_bglt) (obj_1724);
			  aux_2914 =
			     OBJECT_WIDENING(aux_2915);
		       }
		       aux_2912 =
			  (((tclass_bglt) CREF(aux_2914))->slots);
		    }
		 }
		 {	/* Expand/object.scm 118 */
		    tclass_bglt obj_1723;
		    {	/* Expand/object.scm 118 */
		       obj_t aux_2899;
		       {	/* Expand/object.scm 118 */
			  tclass_bglt obj_1722;
			  obj_1722 =
			     (tclass_bglt) (class_81);
			  {
			     obj_t aux_2901;
			     {	/* ./Object/class.scm 1540 */
				object_bglt aux_2902;
				aux_2902 =
				   (object_bglt) (obj_1722);
				aux_2901 =
				   OBJECT_WIDENING(aux_2902);
			     }
			     aux_2899 =
				(((tclass_bglt) CREF(aux_2901))->its_super_214);
			  }
		       }
		       obj_1723 =
			  (tclass_bglt) (aux_2899);
		    }
		    {
		       obj_t aux_2907;
		       {	/* ./Object/class.scm 1544 */
			  object_bglt aux_2908;
			  aux_2908 =
			     (object_bglt) (obj_1723);
			  aux_2907 =
			     OBJECT_WIDENING(aux_2908);
		       }
		       aux_2898 =
			  (((tclass_bglt) CREF(aux_2907))->slots);
		    }
		 }
		 slots_620 =
		    append_2_18___r4_pairs_and_lists_6_3(aux_2898, aux_2912);
	      }
	    else
	      {		/* Expand/object.scm 117 */
		 tclass_bglt obj_1725;
		 obj_1725 =
		    (tclass_bglt) (class_81);
		 {
		    obj_t aux_2921;
		    {	/* ./Object/class.scm 1544 */
		       object_bglt aux_2922;
		       aux_2922 =
			  (object_bglt) (obj_1725);
		       aux_2921 =
			  OBJECT_WIDENING(aux_2922);
		    }
		    slots_620 =
		       (((tclass_bglt) CREF(aux_2921))->slots);
		 }
	      }
	 }
	 {	/* Expand/object.scm 116 */
	    long len_621;
	    len_621 =
	       list_length(slots_620);
	    {	/* Expand/object.scm 120 */
	       obj_t vargs_622;
	       vargs_622 =
		  make_vector(len_621, BUNSPEC);
	       {	/* Expand/object.scm 121 */
		  obj_t new_623;
		  new_623 =
		     PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4,
		     CNST_TABLE_REF(((long) 5)), BEOA);
		  {	/* Expand/object.scm 123 */

		     {
			long i_625;
			obj_t slots_626;
			i_625 = ((long) 0);
			slots_626 = slots_620;
		      loop_627:
			if (
			   NULLP(slots_626))
			  {	/* Expand/object.scm 142 */
			     CNST_TABLE_REF(((long) 6));
			  }
			else
			  {	/* Expand/object.scm 144 */
			     obj_t s_629;
			     s_629 =
				CAR(slots_626);
			     {	/* Expand/object.scm 146 */
				bool_t test_2935;
				{	/* ./Llib/struct.scm 1457 */
				   obj_t aux_2936;
				   aux_2936 =
				      STRUCT_REF(s_629, ((long) 8));
				   test_2935 =
				      CBOOL(aux_2936);
				}
				if (test_2935)
				  {	/* Expand/object.scm 146 */
				     {	/* Expand/object.scm 147 */
					obj_t arg1313_631;
					{	/* ./Ieee/pair-list.scm 5689 */
					   obj_t aux_2939;
					   aux_2939 =
					      STRUCT_REF(s_629, ((long) 9));
					   arg1313_631 =
					      MAKE_PAIR(BTRUE, aux_2939);
					}
					VECTOR_SET(vargs_622, i_625, arg1313_631);
				     }
				  }
				else
				  {	/* Expand/object.scm 146 */
				     {	/* Expand/object.scm 149 */
					obj_t arg1315_633;
					arg1315_633 =
					   MAKE_PAIR(BFALSE, BUNSPEC);
					VECTOR_SET(vargs_622, i_625, arg1315_633);
				     }
				  }
			     }
			     {
				obj_t slots_2947;
				long i_2945;
				i_2945 =
				   (i_625 + ((long) 1));
				slots_2947 =
				   CDR(slots_626);
				slots_626 = slots_2947;
				i_625 = i_2945;
				goto loop_627;
			     }
			  }
		     }
		     {
			obj_t provided_636;
			provided_636 = provided_82;
		      loop_637:
			if (
			   NULLP(provided_636))
			  {	/* Expand/object.scm 154 */
			     CNST_TABLE_REF(((long) 6));
			  }
			else
			  {	/* Expand/object.scm 156 */
			     obj_t p_639;
			     p_639 =
				CAR(provided_636);
			     {
				obj_t s_name_91_640;
				obj_t value_641;
				obj_t s_name_91_643;
				obj_t len_644;
				obj_t value_645;
				if (
				   PAIRP(p_639))
				  {	/* Expand/object.scm 157 */
				     obj_t cdr_177_60_650;
				     cdr_177_60_650 =
					CDR(p_639);
				     if (
					PAIRP(cdr_177_60_650))
				       {	/* Expand/object.scm 157 */
					  bool_t test_2958;
					  {	/* ./Ieee/equiv.scm 5508 */
					     obj_t aux_2959;
					     aux_2959 =
						CDR(cdr_177_60_650);
					     test_2958 =
						(aux_2959 == BNIL);
					  }
					  if (test_2958)
					    {	/* Expand/object.scm 157 */
					       s_name_91_640 =
						  CAR(p_639);
					       value_641 =
						  CAR(cdr_177_60_650);
					       {	/* Expand/object.scm 159 */
						  obj_t pval_666;
						  {	/* Expand/object.scm 159 */
						     obj_t arg1337_668;
						     arg1337_668 =
							find_slot_offset___11_expand_object(slots_620, form_80, s_name_91_640);
						     {	/* ./Ieee/vector.scm 8462 */
							long aux_2963;
							aux_2963 =
							   (long) CINT(arg1337_668);
							pval_666 =
							   VECTOR_REF(vargs_622, aux_2963);
						     }
						  }
						  SET_CAR(pval_666, BTRUE);
						  {	/* Expand/object.scm 161 */
						     obj_t arg1336_667;
						     arg1336_667 =
							object_epairify_147_expand_object(value_641, p_639);
						     SET_CDR(pval_666, arg1336_667);
						  }
					       }
					    }
					  else
					    {	/* Expand/object.scm 157 */
					       obj_t cdr_199_216_656;
					       cdr_199_216_656 =
						  CDR(cdr_177_60_650);
					       if (
						  PAIRP(cdr_199_216_656))
						 {	/* Expand/object.scm 157 */
						    bool_t test_2974;
						    {	/* ./Ieee/equiv.scm 5508 */
						       obj_t aux_2975;
						       aux_2975 =
							  CDR(cdr_199_216_656);
						       test_2974 =
							  (aux_2975 == BNIL);
						    }
						    if (test_2974)
						      {		/* Expand/object.scm 157 */
							 s_name_91_643 =
							    CAR(p_639);
							 len_644 =
							    CAR(cdr_177_60_650);
							 value_645 =
							    CAR(cdr_199_216_656);
							 {	/* Expand/object.scm 163 */
							    obj_t snum_669;
							    snum_669 =
							       find_slot_offset___11_expand_object(slots_620, form_80, s_name_91_643);
							    {	/* Expand/object.scm 164 */

							       {	/* Expand/object.scm 165 */
								  bool_t test_2979;
								  {	/* ./Llib/struct.scm 1457 */
								     obj_t aux_2980;
								     {	/* ./Llib/struct.scm 1457 */
									obj_t aux_2981;
									aux_2981 =
									   list_ref_194___r4_pairs_and_lists_6_3(slots_620,
									   (long) CINT(snum_669));
									aux_2980 =
									   STRUCT_REF(aux_2981, ((long) 5));
								     }
								     test_2979 =
									CBOOL(aux_2980);
								  }
								  if (test_2979)
								    {	/* Expand/object.scm 167 */
								       obj_t pval_672;
								       {	/* ./Ieee/vector.scm 8462 */
									  long aux_2986;
									  aux_2986 =
									     (long) CINT(snum_669);
									  pval_672 =
									     VECTOR_REF(vargs_622, aux_2986);
								       }
								       {	/* Expand/object.scm 167 */
									  obj_t plen_673;
									  {	/* ./Ieee/vector.scm 8462 */
									     long aux_2989;
									     {	/* ./Ieee/fixnum.scm 7199 */
										long aux_2990;
										aux_2990 =
										   (long) CINT(snum_669);
										aux_2989 =
										   (aux_2990 - ((long) 1));
									     }
									     plen_673 =
										VECTOR_REF(vargs_622, aux_2989);
									  }
									  {	/* Expand/object.scm 168 */

									     SET_CAR(pval_672, BTRUE);
									     {	/* Expand/object.scm 170 */
										obj_t arg1339_674;
										arg1339_674 =
										   object_epairify_147_expand_object(value_645, p_639);
										SET_CDR(pval_672, arg1339_674);
									     }
									     SET_CAR(plen_673, BTRUE);
									     SET_CDR(plen_673, len_644);
									  }
								       }
								    }
								  else
								    {	/* Expand/object.scm 165 */
								       FAILURE(BFALSE, string2040_expand_object, form_80);
								    }
							       }
							    }
							 }
						      }
						    else
						      {		/* Expand/object.scm 157 */
						       tag_169_222_647:
							 FAILURE(BFALSE, string2040_expand_object, form_80);
						      }
						 }
					       else
						 {	/* Expand/object.scm 157 */
						    goto tag_169_222_647;
						 }
					    }
				       }
				     else
				       {	/* Expand/object.scm 157 */
					  goto tag_169_222_647;
				       }
				  }
				else
				  {	/* Expand/object.scm 157 */
				     goto tag_169_222_647;
				  }
			     }
			     {
				obj_t provided_3004;
				provided_3004 =
				   CDR(provided_636);
				provided_636 = provided_3004;
				goto loop_637;
			     }
			  }
		     }
		     {
			long i_677;
			obj_t s_678;
			i_677 = ((long) 0);
			s_678 = slots_620;
		      loop_679:
			if (
			   (i_677 == len_621))
			  {	/* Expand/object.scm 180 */
			     CNST_TABLE_REF(((long) 7));
			  }
			else
			  {	/* Expand/object.scm 182 */
			     bool_t test_3009;
			     {	/* Expand/object.scm 182 */
				bool_t test_3010;
				{	/* ./Ieee/pair-list.scm 5701 */
				   obj_t aux_3011;
				   {	/* ./Ieee/pair-list.scm 5701 */
				      obj_t aux_3012;
				      aux_3012 =
					 VECTOR_REF(vargs_622, i_677);
				      aux_3011 =
					 CAR(aux_3012);
				   }
				   test_3010 =
				      CBOOL(aux_3011);
				}
				if (test_3010)
				  {	/* Expand/object.scm 182 */
				     test_3009 = ((bool_t) 0)
					;
				  }
				else
				  {	/* Expand/object.scm 183 */
				     bool_t test_3016;
				     {	/* ./Llib/struct.scm 1457 */
					obj_t aux_3017;
					{	/* ./Llib/struct.scm 1457 */
					   obj_t aux_3018;
					   aux_3018 =
					      CAR(s_678);
					   aux_3017 =
					      STRUCT_REF(aux_3018, ((long) 11));
					}
					test_3016 =
					   CBOOL(aux_3017);
				     }
				     if (test_3016)
				       {	/* Expand/object.scm 183 */
					  test_3009 = ((bool_t) 0)
					     ;
				       }
				     else
				       {	/* Expand/object.scm 183 */
					  test_3009 = ((bool_t) 1)
					     ;
				       }
				  }
			     }
			     if (test_3009)
			       {	/* Expand/object.scm 182 */
				  {	/* Expand/object.scm 186 */
				     obj_t arg1346_682;
				     {	/* Expand/object.scm 186 */
					obj_t arg1348_684;
					{	/* Expand/object.scm 188 */
					   obj_t arg1350_685;
					   {	/* ./Ieee/symbol.scm 6021 */
					      obj_t aux_3022;
					      {		/* ./Llib/struct.scm 1457 */
						 obj_t aux_3023;
						 aux_3023 =
						    CAR(s_678);
						 aux_3022 =
						    STRUCT_REF(aux_3023, ((long) 0));
					      }
					      arg1350_685 =
						 SYMBOL_TO_STRING(aux_3022);
					   }
					   arg1348_684 =
					      string_append(arg1350_685, string2041_expand_object);
					}
					arg1346_682 =
					   string_append(string2042_expand_object, arg1348_684);
				     }
				     FAILURE(BFALSE, arg1346_682, form_80);
				  }
			       }
			     else
			       {	/* Expand/object.scm 182 */
				  {
				     obj_t s_3032;
				     long i_3030;
				     i_3030 =
					(i_677 + ((long) 1));
				     s_3032 =
					CDR(s_678);
				     s_678 = s_3032;
				     i_677 = i_3030;
				     goto loop_679;
				  }
			       }
			  }
		     }
		     {
			long i_695;
			obj_t slots_696;
			obj_t largs_697;
			obj_t virtuals_698;
			i_695 = ((long) 0);
			slots_696 = slots_620;
			largs_697 = BNIL;
			virtuals_698 = BNIL;
		      loop_699:
			if (
			   (i_695 == len_621))
			  {	/* Expand/object.scm 199 */
			     obj_t make_name_208_701;
			     {	/* Expand/object.scm 199 */
				obj_t arg1380_716;
				arg1380_716 =
				   CNST_TABLE_REF(((long) 8));
				{	/* Expand/object.scm 199 */
				   obj_t list1382_718;
				   {	/* Expand/object.scm 199 */
				      obj_t arg1383_719;
				      {		/* Expand/object.scm 199 */
					 obj_t aux_3037;
					 aux_3037 =
					    (((type_bglt) CREF(class_81))->id);
					 arg1383_719 =
					    MAKE_PAIR(aux_3037, BNIL);
				      }
				      list1382_718 =
					 MAKE_PAIR(arg1380_716, arg1383_719);
				   }
				   make_name_208_701 =
				      symbol_append_197___r4_symbols_6_4(list1382_718);
				}
			     }
			     {	/* Expand/object.scm 199 */
				obj_t alloc_702;
				{	/* Expand/object.scm 200 */
				   obj_t arg1377_713;
				   {	/* Expand/object.scm 200 */
				      obj_t arg1378_714;
				      arg1378_714 =
					 reverse__39___r4_pairs_and_lists_6_3(largs_697);
				      arg1377_713 =
					 append_2_18___r4_pairs_and_lists_6_3(arg1378_714, BNIL);
				   }
				   alloc_702 =
				      MAKE_PAIR(make_name_208_701, arg1377_713);
				}
				{	/* Expand/object.scm 200 */

				   if (
				      NULLP(virtuals_698))
				     {	/* Expand/object.scm 201 */
					return alloc_702;
				     }
				   else
				     {	/* Expand/object.scm 203 */
					obj_t arg1366_704;
					obj_t arg1367_705;
					arg1366_704 =
					   CNST_TABLE_REF(((long) 1));
					{	/* Expand/object.scm 203 */
					   obj_t arg1369_706;
					   obj_t arg1371_707;
					   {	/* Expand/object.scm 203 */
					      obj_t arg1372_708;
					      {		/* Expand/object.scm 203 */
						 obj_t arg1374_710;
						 arg1374_710 =
						    MAKE_PAIR(alloc_702, BNIL);
						 arg1372_708 =
						    MAKE_PAIR(new_623, arg1374_710);
					      }
					      arg1369_706 =
						 MAKE_PAIR(arg1372_708, BNIL);
					   }
					   {	/* Expand/object.scm 204 */
					      obj_t arg1375_711;
					      obj_t arg1376_712;
					      arg1375_711 =
						 reverse__39___r4_pairs_and_lists_6_3(virtuals_698);
					      arg1376_712 =
						 MAKE_PAIR(new_623, BNIL);
					      arg1371_707 =
						 append_2_18___r4_pairs_and_lists_6_3(arg1375_711, arg1376_712);
					   }
					   arg1367_705 =
					      MAKE_PAIR(arg1369_706, arg1371_707);
					}
					return
					   MAKE_PAIR(arg1366_704, arg1367_705);
				     }
				}
			     }
			  }
			else
			  {	/* Expand/object.scm 206 */
			     obj_t value_720;
			     {	/* ./Ieee/pair-list.scm 5707 */
				obj_t aux_3056;
				aux_3056 =
				   VECTOR_REF(vargs_622, i_695);
				value_720 =
				   CDR(aux_3056);
			     }
			     {	/* Expand/object.scm 208 */
				bool_t test_3059;
				{	/* ./Llib/struct.scm 1457 */
				   obj_t aux_3060;
				   {	/* ./Llib/struct.scm 1457 */
				      obj_t aux_3061;
				      aux_3061 =
					 CAR(slots_696);
				      aux_3060 =
					 STRUCT_REF(aux_3061, ((long) 11));
				   }
				   test_3059 =
				      CBOOL(aux_3060);
				}
				if (test_3059)
				  {	/* Expand/object.scm 208 */
				     {	/* Expand/object.scm 209 */
					long arg1385_722;
					obj_t arg1387_723;
					obj_t arg1389_724;
					arg1385_722 =
					   (i_695 + ((long) 1));
					arg1387_723 =
					   CDR(slots_696);
					if (
					   (value_720 == BUNSPEC))
					  {	/* Expand/object.scm 212 */
					     arg1389_724 = virtuals_698;
					  }
					else
					  {	/* Expand/object.scm 214 */
					     obj_t arg1391_726;
					     arg1391_726 =
						make_virtual_set_218_expand_object(
						CAR(slots_696), value_720, new_623,
						(obj_t) (class_81), form_80, "instantiate");
					     arg1389_724 =
						MAKE_PAIR(arg1391_726, virtuals_698);
					  }
					{
					   obj_t virtuals_3075;
					   obj_t slots_3074;
					   long i_3073;
					   i_3073 = arg1385_722;
					   slots_3074 = arg1387_723;
					   virtuals_3075 = arg1389_724;
					   virtuals_698 = virtuals_3075;
					   slots_696 = slots_3074;
					   i_695 = i_3073;
					   goto loop_699;
					}
				     }
				  }
				else
				  {	/* Expand/object.scm 208 */
				     {	/* Expand/object.scm 222 */
					long arg1395_729;
					obj_t arg1397_730;
					obj_t arg1398_731;
					arg1395_729 =
					   (i_695 + ((long) 1));
					arg1397_730 =
					   CDR(slots_696);
					arg1398_731 =
					   MAKE_PAIR(value_720, largs_697);
					{
					   obj_t largs_3081;
					   obj_t slots_3080;
					   long i_3079;
					   i_3079 = arg1395_729;
					   slots_3080 = arg1397_730;
					   largs_3081 = arg1398_731;
					   largs_697 = largs_3081;
					   slots_696 = slots_3080;
					   i_695 = i_3079;
					   goto loop_699;
					}
				     }
				  }
			     }
			  }
		     }
		  }
	       }
	    }
	 }
      }
   }
}



/* find-slot-offset'' */
obj_t 
find_slot_offset___11_expand_object(obj_t slots_2667, obj_t form_2666, obj_t s_name_91_734)
{
   AN_OBJECT;
   {	/* Expand/object.scm 123 */
      {
	 obj_t slots_736;
	 long i_737;
	 slots_736 = slots_2667;
	 i_737 = ((long) 0);
       loop_738:
	 if (
	    NULLP(slots_736))
	   {	/* Expand/object.scm 127 */
	      {		/* Expand/object.scm 130 */
		 obj_t arg1403_740;
		 {	/* Expand/object.scm 130 */
		    obj_t arg1405_742;
		    {	/* Expand/object.scm 132 */
		       obj_t arg1406_743;
		       arg1406_743 =
			  SYMBOL_TO_STRING(s_name_91_734);
		       arg1405_742 =
			  string_append(arg1406_743, string2041_expand_object);
		    }
		    arg1403_740 =
		       string_append(string2043_expand_object, arg1405_742);
		 }
		 FAILURE(BFALSE, arg1403_740, form_2666);
	      }
	   }
	 else
	   {	/* Expand/object.scm 135 */
	      bool_t test_3088;
	      {		/* ./Ieee/equiv.scm 5508 */
		 obj_t aux_3089;
		 {	/* ./Llib/struct.scm 1457 */
		    obj_t aux_3090;
		    aux_3090 =
		       CAR(slots_736);
		    aux_3089 =
		       STRUCT_REF(aux_3090, ((long) 0));
		 }
		 test_3088 =
		    (aux_3089 == s_name_91_734);
	      }
	      if (test_3088)
		{	/* Expand/object.scm 135 */
		   return
		      BINT(i_737);
		}
	      else
		{	/* Expand/object.scm 135 */
		   {
		      long i_3097;
		      obj_t slots_3095;
		      slots_3095 =
			 CDR(slots_736);
		      i_3097 =
			 (i_737 + ((long) 1));
		      i_737 = i_3097;
		      slots_736 = slots_3095;
		      goto loop_738;
		   }
		}
	   }
      }
   }
}



/* expand-duplicate */
obj_t 
expand_duplicate_139_expand_object(obj_t x_83, obj_t e_84)
{
   AN_OBJECT;
   {	/* Expand/object.scm 230 */
      {
	 obj_t duplicate_757;
	 obj_t dup_758;
	 obj_t prov_759;
	 if (
	    PAIRP(x_83))
	   {	/* Expand/object.scm 231 */
	      obj_t cdr_229_251_764;
	      cdr_229_251_764 =
		 CDR(x_83);
	      if (
		 PAIRP(cdr_229_251_764))
		{	/* Expand/object.scm 231 */
		   duplicate_757 =
		      CAR(x_83);
		   dup_758 =
		      CAR(cdr_229_251_764);
		   prov_759 =
		      CDR(cdr_229_251_764);
		   {	/* Expand/object.scm 233 */
		      obj_t id_type_89_769;
		      {		/* Expand/object.scm 233 */
			 obj_t arg1438_778;
			 arg1438_778 =
			    find_location_120_tools_location(x_83);
			 id_type_89_769 =
			    parse_id_241_ast_ident(duplicate_757, arg1438_778);
		      }
		      {		/* Expand/object.scm 233 */
			 obj_t id_770;
			 id_770 =
			    CAR(id_type_89_769);
			 {	/* Expand/object.scm 234 */
			    obj_t class_771;
			    class_771 =
			       CDR(id_type_89_769);
			    {	/* Expand/object.scm 235 */

			       {	/* Expand/object.scm 236 */
				  bool_t test1432_772;
				  test1432_772 =
				     is_a__118___object(class_771, tclass_object_class);
				  if (test1432_772)
				    {	/* Expand/object.scm 241 */
				       obj_t arg1433_773;
				       {	/* Expand/object.scm 241 */
					  obj_t arg1434_774;
					  arg1434_774 =
					     duplicate__make_94_expand_object(x_83, class_771, dup_758, prov_759);
					  arg1433_773 =
					     PROCEDURE_ENTRY(e_84) (e_84, arg1434_774, e_84, BEOA);
				       }
				       return
					  replace__160_tools_misc(x_83, arg1433_773);
				    }
				  else
				    {	/* Expand/object.scm 238 */
				       obj_t arg1435_775;
				       {	/* Expand/object.scm 238 */
					  obj_t arg1437_777;
					  arg1437_777 =
					     SYMBOL_TO_STRING(id_770);
					  arg1435_775 =
					     string_append(string2044_expand_object, arg1437_777);
				       }
				       FAILURE(BFALSE, arg1435_775, x_83);
				    }
			       }
			    }
			 }
		      }
		   }
		}
	      else
		{	/* Expand/object.scm 231 */
		 tag_220_216_761:
		   FAILURE(BFALSE, string2045_expand_object, x_83);
		}
	   }
	 else
	   {	/* Expand/object.scm 231 */
	      goto tag_220_216_761;
	   }
      }
   }
}



/* _expand-duplicate */
obj_t 
_expand_duplicate_242_expand_object(obj_t env_2653, obj_t x_2654, obj_t e_2655)
{
   AN_OBJECT;
   {	/* Expand/object.scm 230 */
      return
	 expand_duplicate_139_expand_object(x_2654, e_2655);
   }
}



/* duplicate->make */
obj_t 
duplicate__make_94_expand_object(obj_t form_85, obj_t class_86, obj_t duplicated_87, obj_t provided_88)
{
   AN_OBJECT;
   {	/* Expand/object.scm 254 */
      {		/* Expand/object.scm 255 */
	 obj_t slots_779;
	 {	/* Expand/object.scm 255 */
	    bool_t test_3122;
	    {	/* Expand/object.scm 255 */
	       tclass_bglt obj_1885;
	       obj_1885 =
		  (tclass_bglt) (class_86);
	       {	/* ./Object/class.scm 1548 */
		  obj_t aux_3124;
		  {
		     obj_t aux_3125;
		     {	/* ./Object/class.scm 1548 */
			object_bglt aux_3126;
			aux_3126 =
			   (object_bglt) (obj_1885);
			aux_3125 =
			   OBJECT_WIDENING(aux_3126);
		     }
		     aux_3124 =
			(((tclass_bglt) CREF(aux_3125))->widening);
		  }
		  test_3122 =
		     CBOOL(aux_3124);
	       }
	    }
	    if (test_3122)
	      {		/* Expand/object.scm 257 */
		 obj_t aux_3145;
		 obj_t aux_3131;
		 {	/* Expand/object.scm 258 */
		    tclass_bglt obj_1888;
		    obj_1888 =
		       (tclass_bglt) (class_86);
		    {
		       obj_t aux_3147;
		       {	/* ./Object/class.scm 1544 */
			  object_bglt aux_3148;
			  aux_3148 =
			     (object_bglt) (obj_1888);
			  aux_3147 =
			     OBJECT_WIDENING(aux_3148);
		       }
		       aux_3145 =
			  (((tclass_bglt) CREF(aux_3147))->slots);
		    }
		 }
		 {	/* Expand/object.scm 257 */
		    tclass_bglt obj_1887;
		    {	/* Expand/object.scm 257 */
		       obj_t aux_3132;
		       {	/* Expand/object.scm 257 */
			  tclass_bglt obj_1886;
			  obj_1886 =
			     (tclass_bglt) (class_86);
			  {
			     obj_t aux_3134;
			     {	/* ./Object/class.scm 1540 */
				object_bglt aux_3135;
				aux_3135 =
				   (object_bglt) (obj_1886);
				aux_3134 =
				   OBJECT_WIDENING(aux_3135);
			     }
			     aux_3132 =
				(((tclass_bglt) CREF(aux_3134))->its_super_214);
			  }
		       }
		       obj_1887 =
			  (tclass_bglt) (aux_3132);
		    }
		    {
		       obj_t aux_3140;
		       {	/* ./Object/class.scm 1544 */
			  object_bglt aux_3141;
			  aux_3141 =
			     (object_bglt) (obj_1887);
			  aux_3140 =
			     OBJECT_WIDENING(aux_3141);
		       }
		       aux_3131 =
			  (((tclass_bglt) CREF(aux_3140))->slots);
		    }
		 }
		 slots_779 =
		    append_2_18___r4_pairs_and_lists_6_3(aux_3131, aux_3145);
	      }
	    else
	      {		/* Expand/object.scm 256 */
		 tclass_bglt obj_1889;
		 obj_1889 =
		    (tclass_bglt) (class_86);
		 {
		    obj_t aux_3154;
		    {	/* ./Object/class.scm 1544 */
		       object_bglt aux_3155;
		       aux_3155 =
			  (object_bglt) (obj_1889);
		       aux_3154 =
			  OBJECT_WIDENING(aux_3155);
		    }
		    slots_779 =
		       (((tclass_bglt) CREF(aux_3154))->slots);
		 }
	      }
	 }
	 {	/* Expand/object.scm 255 */
	    long len_780;
	    len_780 =
	       list_length(slots_779);
	    {	/* Expand/object.scm 259 */
	       obj_t dup_var_35_781;
	       {	/* Expand/object.scm 260 */
		  obj_t arg1551_925;
		  arg1551_925 =
		     PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4,
		     CNST_TABLE_REF(((long) 9)), BEOA);
		  dup_var_35_781 =
		     mark_symbol_non_user__17_ast_ident(arg1551_925);
	       }
	       {	/* Expand/object.scm 260 */
		  obj_t dup_var_typed_156_782;
		  {	/* Expand/object.scm 261 */
		     obj_t list1548_922;
		     {	/* Expand/object.scm 261 */
			obj_t arg1549_923;
			{	/* Expand/object.scm 261 */
			   obj_t arg1550_924;
			   {	/* Expand/object.scm 261 */
			      obj_t aux_3164;
			      {		/* Expand/object.scm 261 */
				 type_bglt obj_1890;
				 obj_1890 =
				    (type_bglt) (class_86);
				 aux_3164 =
				    (((type_bglt) CREF(obj_1890))->id);
			      }
			      arg1550_924 =
				 MAKE_PAIR(aux_3164, BNIL);
			   }
			   arg1549_923 =
			      MAKE_PAIR(_4dots_199_tools_misc, arg1550_924);
			}
			list1548_922 =
			   MAKE_PAIR(dup_var_35_781, arg1549_923);
		     }
		     dup_var_typed_156_782 =
			symbol_append_197___r4_symbols_6_4(list1548_922);
		  }
		  {	/* Expand/object.scm 261 */
		     obj_t new_783;
		     new_783 =
			PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4,
			CNST_TABLE_REF(((long) 5)), BEOA);
		     {	/* Expand/object.scm 262 */
			obj_t vargs_784;
			vargs_784 =
			   make_vector(len_780, BUNSPEC);
			{	/* Expand/object.scm 264 */

			   {
			      obj_t provided_786;
			      provided_786 = provided_88;
			    loop_787:
			      if (
				 NULLP(provided_786))
				{	/* Expand/object.scm 282 */
				   CNST_TABLE_REF(((long) 6));
				}
			      else
				{	/* Expand/object.scm 284 */
				   obj_t p_789;
				   p_789 =
				      CAR(provided_786);
				   {
				      obj_t s_name_91_790;
				      obj_t value_791;
				      obj_t s_name_91_793;
				      obj_t len_794;
				      obj_t value_795;
				      if (
					 PAIRP(p_789))
					{	/* Expand/object.scm 285 */
					   obj_t cdr_247_56_800;
					   cdr_247_56_800 =
					      CDR(p_789);
					   if (
					      PAIRP(cdr_247_56_800))
					     {	/* Expand/object.scm 285 */
						bool_t test_3184;
						{	/* ./Ieee/equiv.scm 5508 */
						   obj_t aux_3185;
						   aux_3185 =
						      CDR(cdr_247_56_800);
						   test_3184 =
						      (aux_3185 == BNIL);
						}
						if (test_3184)
						  {	/* Expand/object.scm 285 */
						     s_name_91_790 =
							CAR(p_789);
						     value_791 =
							CAR(cdr_247_56_800);
						     {	/* Expand/object.scm 288 */
							obj_t arg1456_816;
							obj_t arg1457_817;
							arg1456_816 =
							   find_slot_offset__176_expand_object(slots_779, form_85, s_name_91_790);
							{	/* Expand/object.scm 289 */
							   obj_t arg1458_818;
							   arg1458_818 =
							      object_epairify_147_expand_object(value_791, p_789);
							   arg1457_817 =
							      MAKE_PAIR(BTRUE, arg1458_818);
							}
							{	/* ./Ieee/vector.scm 8468 */
							   obj_t x_2671;
							   {	/* ./Ieee/vector.scm 8468 */
							      long aux_3191;
							      aux_3191 =
								 (long) CINT(arg1456_816);
							      x_2671 =
								 VECTOR_SET(vargs_784, aux_3191, arg1457_817);
							   }
							   BUNSPEC;
							}
						     }
						  }
						else
						  {	/* Expand/object.scm 285 */
						     obj_t cdr_269_208_806;
						     cdr_269_208_806 =
							CDR(cdr_247_56_800);
						     if (
							PAIRP(cdr_269_208_806))
						       {	/* Expand/object.scm 285 */
							  bool_t test_3199;
							  {	/* ./Ieee/equiv.scm 5508 */
							     obj_t aux_3200;
							     aux_3200 =
								CDR(cdr_269_208_806);
							     test_3199 =
								(aux_3200 == BNIL);
							  }
							  if (test_3199)
							    {	/* Expand/object.scm 285 */
							       s_name_91_793 =
								  CAR(p_789);
							       len_794 =
								  CAR(cdr_247_56_800);
							       value_795 =
								  CAR(cdr_269_208_806);
							       {	/* Expand/object.scm 291 */
								  obj_t snum_819;
								  snum_819 =
								     find_slot_offset__176_expand_object(slots_779, form_85, s_name_91_793);
								  {	/* Expand/object.scm 291 */
								     obj_t slot_820;
								     slot_820 =
									list_ref_194___r4_pairs_and_lists_6_3(slots_779,
									(long) CINT(snum_819));
								     {	/* Expand/object.scm 292 */

									{	/* Expand/object.scm 293 */
									   bool_t test_3206;
									   {	/* Expand/object.scm 293 */
									      bool_t test_3207;
									      {		/* ./Llib/struct.scm 1457 */
										 obj_t aux_3208;
										 aux_3208 =
										    STRUCT_REF(slot_820, ((long) 3));
										 test_3207 =
										    CBOOL(aux_3208);
									      }
									      if (test_3207)
										{	/* Expand/object.scm 293 */
										   test_3206 = ((bool_t) 1)
										      ;
										}
									      else
										{	/* ./Llib/struct.scm 1457 */
										   obj_t aux_3211;
										   aux_3211 =
										      STRUCT_REF(slot_820, ((long) 5));
										   test_3206 =
										      CBOOL(aux_3211);
										}
									   }
									   if (test_3206)
									     {	/* Expand/object.scm 293 */
										{	/* Expand/object.scm 299 */
										   obj_t arg1461_822;
										   {	/* Expand/object.scm 299 */
										      obj_t arg1462_823;
										      arg1462_823 =
											 object_epairify_147_expand_object(value_795, p_789);
										      arg1461_822 =
											 MAKE_PAIR(BTRUE, arg1462_823);
										   }
										   {	/* ./Ieee/vector.scm 8468 */
										      long aux_3216;
										      aux_3216 =
											 (long) CINT(snum_819);
										      VECTOR_SET(vargs_784, aux_3216, arg1461_822);
										   }
										}
										{	/* Expand/object.scm 300 */
										   long arg1463_824;
										   obj_t arg1464_825;
										   {	/* ./Ieee/fixnum.scm 7199 */
										      long aux_3219;
										      aux_3219 =
											 (long) CINT(snum_819);
										      arg1463_824 =
											 (aux_3219 - ((long) 1));
										   }
										   arg1464_825 =
										      MAKE_PAIR(BFALSE, len_794);
										   VECTOR_SET(vargs_784, arg1463_824, arg1464_825);
										}
									     }
									   else
									     {	/* Expand/object.scm 293 */
										FAILURE(BFALSE, string2045_expand_object, form_85);
									     }
									}
								     }
								  }
							       }
							    }
							  else
							    {	/* Expand/object.scm 285 */
							     tag_239_2_797:
							       FAILURE(BFALSE, string2045_expand_object, form_85);
							    }
						       }
						     else
						       {	/* Expand/object.scm 285 */
							  goto tag_239_2_797;
						       }
						  }
					     }
					   else
					     {	/* Expand/object.scm 285 */
						goto tag_239_2_797;
					     }
					}
				      else
					{	/* Expand/object.scm 285 */
					   goto tag_239_2_797;
					}
				   }
				   {
				      obj_t provided_3229;
				      provided_3229 =
					 CDR(provided_786);
				      provided_786 = provided_3229;
				      goto loop_787;
				   }
				}
			   }
			   {
			      long i_828;
			      obj_t slots_829;
			      i_828 = ((long) 0);
			      slots_829 = slots_779;
			    loop_830:
			      if (
				 NULLP(slots_829))
				{	/* Expand/object.scm 308 */
				   CNST_TABLE_REF(((long) 6));
				}
			      else
				{	/* Expand/object.scm 308 */
				   {	/* Expand/object.scm 311 */
				      bool_t test_3234;
				      {		/* ./Ieee/pair-list.scm 5669 */
					 obj_t aux_3235;
					 aux_3235 =
					    VECTOR_REF(vargs_784, i_828);
					 test_3234 =
					    PAIRP(aux_3235);
				      }
				      if (test_3234)
					{	/* Expand/object.scm 311 */
					   CNST_TABLE_REF(((long) 10));
					}
				      else
					{	/* Expand/object.scm 314 */
					   obj_t slot_834;
					   slot_834 =
					      CAR(slots_829);
					   {	/* Expand/object.scm 317 */
					      bool_t test_3240;
					      {		/* Expand/object.scm 317 */
						 bool_t test_3241;
						 {	/* ./Llib/struct.scm 1457 */
						    obj_t aux_3242;
						    aux_3242 =
						       STRUCT_REF(slot_834, ((long) 5));
						    test_3241 =
						       CBOOL(aux_3242);
						 }
						 if (test_3241)
						   {	/* Expand/object.scm 317 */
						      test_3240 = ((bool_t) 1)
							 ;
						   }
						 else
						   {	/* ./Llib/struct.scm 1457 */
						      obj_t aux_3245;
						      aux_3245 =
							 STRUCT_REF(slot_834, ((long) 3));
						      test_3240 =
							 CBOOL(aux_3245);
						   }
					      }
					      if (test_3240)
						{	/* Expand/object.scm 321 */
						   obj_t a_name_201_836;
						   {	/* Expand/object.scm 321 */
						      obj_t arg1474_841;
						      obj_t arg1475_842;
						      obj_t arg1476_843;
						      {		/* Expand/object.scm 321 */
							 type_bglt obj_1952;
							 obj_1952 =
							    (type_bglt) (class_86);
							 arg1474_841 =
							    (((type_bglt) CREF(obj_1952))->id);
						      }
						      arg1475_842 =
							 CNST_TABLE_REF(((long) 2));
						      arg1476_843 =
							 STRUCT_REF(slot_834, ((long) 0));
						      {		/* Expand/object.scm 321 */
							 obj_t list1478_845;
							 {	/* Expand/object.scm 321 */
							    obj_t arg1479_846;
							    {	/* Expand/object.scm 321 */
							       obj_t arg1480_847;
							       {	/* Expand/object.scm 321 */
								  obj_t arg1481_848;
								  {	/* Expand/object.scm 321 */
								     obj_t aux_3252;
								     aux_3252 =
									CNST_TABLE_REF(((long) 11));
								     arg1481_848 =
									MAKE_PAIR(aux_3252, BNIL);
								  }
								  arg1480_847 =
								     MAKE_PAIR(arg1476_843, arg1481_848);
							       }
							       arg1479_846 =
								  MAKE_PAIR(arg1475_842, arg1480_847);
							    }
							    list1478_845 =
							       MAKE_PAIR(arg1474_841, arg1479_846);
							 }
							 a_name_201_836 =
							    symbol_append_197___r4_symbols_6_4(list1478_845);
						      }
						   }
						   {	/* Expand/object.scm 327 */
						      obj_t arg1470_837;
						      {		/* Expand/object.scm 327 */
							 obj_t arg1471_838;
							 {	/* Expand/object.scm 327 */
							    obj_t arg1472_839;
							    {	/* Expand/object.scm 327 */
							       obj_t arg1473_840;
							       {	/* ./Ieee/pair-list.scm 5689 */
								  obj_t aux_3259;
								  aux_3259 =
								     BINT(((long) 0));
								  arg1473_840 =
								     MAKE_PAIR(aux_3259, BNIL);
							       }
							       arg1472_839 =
								  MAKE_PAIR(dup_var_35_781, arg1473_840);
							    }
							    arg1471_838 =
							       MAKE_PAIR(a_name_201_836, arg1472_839);
							 }
							 arg1470_837 =
							    MAKE_PAIR(BTRUE, arg1471_838);
						      }
						      VECTOR_SET(vargs_784, i_828, arg1470_837);
						   }
						}
					      else
						{	/* Expand/object.scm 328 */
						   obj_t a_name_201_849;
						   {	/* Expand/object.scm 328 */
						      obj_t arg1485_853;
						      obj_t arg1486_854;
						      {		/* Expand/object.scm 328 */
							 type_bglt obj_1967;
							 obj_1967 =
							    (type_bglt) (class_86);
							 arg1485_853 =
							    (((type_bglt) CREF(obj_1967))->id);
						      }
						      arg1486_854 =
							 CNST_TABLE_REF(((long) 2));
						      {		/* Expand/object.scm 328 */
							 obj_t list1489_856;
							 {	/* Expand/object.scm 328 */
							    obj_t arg1490_857;
							    {	/* Expand/object.scm 328 */
							       obj_t arg1491_858;
							       {	/* Expand/object.scm 328 */
								  obj_t aux_3269;
								  aux_3269 =
								     STRUCT_REF(slot_834, ((long) 0));
								  arg1491_858 =
								     MAKE_PAIR(aux_3269, BNIL);
							       }
							       arg1490_857 =
								  MAKE_PAIR(arg1486_854, arg1491_858);
							    }
							    list1489_856 =
							       MAKE_PAIR(arg1485_853, arg1490_857);
							 }
							 a_name_201_849 =
							    symbol_append_197___r4_symbols_6_4(list1489_856);
						      }
						   }
						   {	/* Expand/object.scm 333 */
						      obj_t arg1482_850;
						      {		/* Expand/object.scm 333 */
							 obj_t arg1483_851;
							 {	/* Expand/object.scm 333 */
							    obj_t arg1484_852;
							    arg1484_852 =
							       MAKE_PAIR(dup_var_35_781, BNIL);
							    arg1483_851 =
							       MAKE_PAIR(a_name_201_849, arg1484_852);
							 }
							 arg1482_850 =
							    MAKE_PAIR(BTRUE, arg1483_851);
						      }
						      VECTOR_SET(vargs_784, i_828, arg1482_850);
						   }
						}
					   }
					}
				   }
				   {
				      obj_t slots_3281;
				      long i_3279;
				      i_3279 =
					 (i_828 + ((long) 1));
				      slots_3281 =
					 CDR(slots_829);
				      slots_829 = slots_3281;
				      i_828 = i_3279;
				      goto loop_830;
				   }
				}
			   }
			   {
			      long i_862;
			      obj_t slots_863;
			      obj_t largs_864;
			      obj_t virtuals_865;
			      i_862 = ((long) 0);
			      slots_863 = slots_779;
			      largs_864 = BNIL;
			      virtuals_865 = BNIL;
			    loop_866:
			      if (
				 (i_862 == len_780))
				{	/* Expand/object.scm 342 */
				   obj_t make_name_208_868;
				   {	/* Expand/object.scm 342 */
				      obj_t arg1512_885;
				      arg1512_885 =
					 CNST_TABLE_REF(((long) 8));
				      {		/* Expand/object.scm 342 */
					 obj_t list1514_887;
					 {	/* Expand/object.scm 342 */
					    obj_t arg1515_888;
					    {	/* Expand/object.scm 342 */
					       obj_t aux_3286;
					       {	/* Expand/object.scm 342 */
						  type_bglt obj_1985;
						  obj_1985 =
						     (type_bglt) (class_86);
						  aux_3286 =
						     (((type_bglt) CREF(obj_1985))->id);
					       }
					       arg1515_888 =
						  MAKE_PAIR(aux_3286, BNIL);
					    }
					    list1514_887 =
					       MAKE_PAIR(arg1512_885, arg1515_888);
					 }
					 make_name_208_868 =
					    symbol_append_197___r4_symbols_6_4(list1514_887);
				      }
				   }
				   {	/* Expand/object.scm 342 */
				      obj_t alloc_869;
				      {		/* Expand/object.scm 343 */
					 obj_t arg1509_882;
					 {	/* Expand/object.scm 343 */
					    obj_t arg1510_883;
					    arg1510_883 =
					       reverse__39___r4_pairs_and_lists_6_3(largs_864);
					    arg1509_882 =
					       append_2_18___r4_pairs_and_lists_6_3(arg1510_883, BNIL);
					 }
					 alloc_869 =
					    MAKE_PAIR(make_name_208_868, arg1509_882);
				      }
				      {		/* Expand/object.scm 343 */

					 {	/* Expand/object.scm 344 */
					    obj_t arg1496_870;
					    obj_t arg1497_871;
					    arg1496_870 =
					       CNST_TABLE_REF(((long) 12));
					    {	/* Expand/object.scm 344 */
					       obj_t arg1498_872;
					       obj_t arg1499_873;
					       {	/* Expand/object.scm 344 */
						  obj_t arg1500_874;
						  obj_t arg1501_875;
						  {	/* Expand/object.scm 344 */
						     obj_t arg1502_876;
						     arg1502_876 =
							MAKE_PAIR(duplicated_87, BNIL);
						     arg1500_874 =
							MAKE_PAIR(dup_var_typed_156_782, arg1502_876);
						  }
						  {	/* Expand/object.scm 345 */
						     obj_t arg1503_877;
						     {	/* Expand/object.scm 345 */
							obj_t arg1505_879;
							arg1505_879 =
							   MAKE_PAIR(alloc_869, BNIL);
							arg1503_877 =
							   MAKE_PAIR(new_783, arg1505_879);
						     }
						     arg1501_875 =
							MAKE_PAIR(arg1503_877, BNIL);
						  }
						  arg1498_872 =
						     MAKE_PAIR(arg1500_874, arg1501_875);
					       }
					       {	/* Expand/object.scm 346 */
						  obj_t arg1506_880;
						  obj_t arg1508_881;
						  arg1506_880 =
						     reverse__39___r4_pairs_and_lists_6_3(virtuals_865);
						  arg1508_881 =
						     MAKE_PAIR(new_783, BNIL);
						  arg1499_873 =
						     append_2_18___r4_pairs_and_lists_6_3(arg1506_880, arg1508_881);
					       }
					       arg1497_871 =
						  MAKE_PAIR(arg1498_872, arg1499_873);
					    }
					    return
					       MAKE_PAIR(arg1496_870, arg1497_871);
					 }
				      }
				   }
				}
			      else
				{	/* Expand/object.scm 348 */
				   obj_t value_889;
				   {	/* ./Ieee/pair-list.scm 5707 */
				      obj_t aux_3307;
				      aux_3307 =
					 VECTOR_REF(vargs_784, i_862);
				      value_889 =
					 CDR(aux_3307);
				   }
				   {	/* Expand/object.scm 350 */
				      bool_t test_3310;
				      {		/* ./Llib/struct.scm 1457 */
					 obj_t aux_3311;
					 {	/* ./Llib/struct.scm 1457 */
					    obj_t aux_3312;
					    aux_3312 =
					       CAR(slots_863);
					    aux_3311 =
					       STRUCT_REF(aux_3312, ((long) 11));
					 }
					 test_3310 =
					    CBOOL(aux_3311);
				      }
				      if (test_3310)
					{	/* Expand/object.scm 350 */
					   {	/* Expand/object.scm 351 */
					      long arg1517_891;
					      obj_t arg1519_892;
					      obj_t arg1520_893;
					      arg1517_891 =
						 (i_862 + ((long) 1));
					      arg1519_892 =
						 CDR(slots_863);
					      {		/* Expand/object.scm 354 */
						 obj_t arg1521_894;
						 arg1521_894 =
						    make_virtual_set_218_expand_object(
						    CAR(slots_863), value_889, new_783, class_86, form_85, "duplicate");
						 arg1520_893 =
						    MAKE_PAIR(arg1521_894, virtuals_865);
					      }
					      {
						 obj_t virtuals_3323;
						 obj_t slots_3322;
						 long i_3321;
						 i_3321 = arg1517_891;
						 slots_3322 = arg1519_892;
						 virtuals_3323 = arg1520_893;
						 virtuals_865 = virtuals_3323;
						 slots_863 = slots_3322;
						 i_862 = i_3321;
						 goto loop_866;
					      }
					   }
					}
				      else
					{	/* Expand/object.scm 350 */
					   {	/* Expand/object.scm 362 */
					      long arg1525_897;
					      obj_t arg1526_898;
					      obj_t arg1527_899;
					      arg1525_897 =
						 (i_862 + ((long) 1));
					      arg1526_898 =
						 CDR(slots_863);
					      arg1527_899 =
						 MAKE_PAIR(value_889, largs_864);
					      {
						 obj_t largs_3329;
						 obj_t slots_3328;
						 long i_3327;
						 i_3327 = arg1525_897;
						 slots_3328 = arg1526_898;
						 largs_3329 = arg1527_899;
						 largs_864 = largs_3329;
						 slots_863 = slots_3328;
						 i_862 = i_3327;
						 goto loop_866;
					      }
					   }
					}
				   }
				}
			   }
			}
		     }
		  }
	       }
	    }
	 }
      }
   }
}



/* find-slot-offset' */
obj_t 
find_slot_offset__176_expand_object(obj_t slots_2665, obj_t form_2664, obj_t s_name_91_902)
{
   AN_OBJECT;
   {	/* Expand/object.scm 264 */
      {
	 obj_t slots_904;
	 long i_905;
	 slots_904 = slots_2665;
	 i_905 = ((long) 0);
       loop_906:
	 if (
	    NULLP(slots_904))
	   {	/* Expand/object.scm 268 */
	      {		/* Expand/object.scm 271 */
		 obj_t arg1532_908;
		 {	/* Expand/object.scm 271 */
		    obj_t arg1534_910;
		    {	/* Expand/object.scm 273 */
		       obj_t arg1535_911;
		       arg1535_911 =
			  SYMBOL_TO_STRING(s_name_91_902);
		       arg1534_910 =
			  string_append(arg1535_911, string2041_expand_object);
		    }
		    arg1532_908 =
		       string_append(string2046_expand_object, arg1534_910);
		 }
		 FAILURE(BFALSE, arg1532_908, form_2664);
	      }
	   }
	 else
	   {	/* Expand/object.scm 276 */
	      bool_t test_3336;
	      {		/* ./Ieee/equiv.scm 5508 */
		 obj_t aux_3337;
		 {	/* ./Llib/struct.scm 1457 */
		    obj_t aux_3338;
		    aux_3338 =
		       CAR(slots_904);
		    aux_3337 =
		       STRUCT_REF(aux_3338, ((long) 0));
		 }
		 test_3336 =
		    (aux_3337 == s_name_91_902);
	      }
	      if (test_3336)
		{	/* Expand/object.scm 276 */
		   return
		      BINT(i_905);
		}
	      else
		{	/* Expand/object.scm 276 */
		   {
		      long i_3345;
		      obj_t slots_3343;
		      slots_3343 =
			 CDR(slots_904);
		      i_3345 =
			 (i_905 + ((long) 1));
		      i_905 = i_3345;
		      slots_904 = slots_3343;
		      goto loop_906;
		   }
		}
	   }
      }
   }
}



/* expand-widen! */
obj_t 
expand_widen__163_expand_object(obj_t x_89, obj_t e_90)
{
   AN_OBJECT;
   {	/* Expand/object.scm 370 */
      {
	 obj_t widen__231_930;
	 obj_t obj_931;
	 obj_t provided_932;
	 if (
	    PAIRP(x_89))
	   {	/* Expand/object.scm 371 */
	      obj_t cdr_299_139_937;
	      cdr_299_139_937 =
		 CDR(x_89);
	      if (
		 PAIRP(cdr_299_139_937))
		{	/* Expand/object.scm 371 */
		   widen__231_930 =
		      CAR(x_89);
		   obj_931 =
		      CAR(cdr_299_139_937);
		   provided_932 =
		      CDR(cdr_299_139_937);
		   {	/* Expand/object.scm 373 */
		      type_bglt class_942;
		      {		/* Expand/object.scm 373 */
			 obj_t arg1571_951;
			 arg1571_951 =
			    find_location_120_tools_location(x_89);
			 class_942 =
			    type_of_id_183_ast_ident(widen__231_930, arg1571_951);
		      }
		      {		/* Expand/object.scm 374 */
			 bool_t test1562_943;
			 {	/* Expand/object.scm 374 */
			    bool_t test1569_950;
			    test1569_950 =
			       is_a__118___object(
			       (obj_t) (class_942), tclass_object_class);
			    if (test1569_950)
			      {		/* Expand/object.scm 374 */
				 tclass_bglt obj_2045;
				 obj_2045 =
				    (tclass_bglt) (class_942);
				 {	/* ./Object/class.scm 1548 */
				    obj_t aux_3358;
				    {
				       obj_t aux_3359;
				       {	/* ./Object/class.scm 1548 */
					  object_bglt aux_3360;
					  aux_3360 =
					     (object_bglt) (obj_2045);
					  aux_3359 =
					     OBJECT_WIDENING(aux_3360);
				       }
				       aux_3358 =
					  (((tclass_bglt) CREF(aux_3359))->widening);
				    }
				    test1562_943 =
				       CBOOL(aux_3358);
				 }
			      }
			    else
			      {		/* Expand/object.scm 374 */
				 test1562_943 = ((bool_t) 0);
			      }
			 }
			 if (test1562_943)
			   {	/* Expand/object.scm 375 */
			      obj_t arg1563_944;
			      {		/* Expand/object.scm 375 */
				 obj_t arg1564_945;
				 arg1564_945 =
				    make_widening_107_expand_object(x_89, class_942, obj_931, provided_932);
				 arg1563_944 =
				    PROCEDURE_ENTRY(e_90) (e_90, arg1564_945, e_90, BEOA);
			      }
			      return
				 replace__160_tools_misc(x_89, arg1563_944);
			   }
			 else
			   {	/* Expand/object.scm 377 */
			      obj_t arg1565_946;
			      {		/* Expand/object.scm 377 */
				 obj_t arg1567_948;
				 {	/* ./Ieee/symbol.scm 6021 */
				    obj_t aux_3370;
				    aux_3370 =
				       (((type_bglt) CREF(class_942))->id);
				    arg1567_948 =
				       SYMBOL_TO_STRING(aux_3370);
				 }
				 arg1565_946 =
				    string_append(string2047_expand_object, arg1567_948);
			      }
			      FAILURE(BFALSE, arg1565_946, x_89);
			   }
		      }
		   }
		}
	      else
		{	/* Expand/object.scm 371 */
		 tag_290_159_934:
		   FAILURE(BFALSE, string2048_expand_object, x_89);
		}
	   }
	 else
	   {	/* Expand/object.scm 371 */
	      goto tag_290_159_934;
	   }
      }
   }
}



/* _expand-widen! */
obj_t 
_expand_widen__96_expand_object(obj_t env_2656, obj_t x_2657, obj_t e_2658)
{
   AN_OBJECT;
   {	/* Expand/object.scm 370 */
      return
	 expand_widen__163_expand_object(x_2657, e_2658);
   }
}



/* make-widening */
obj_t 
make_widening_107_expand_object(obj_t form_91, type_bglt class_92, obj_t obj_93, obj_t provided_94)
{
   AN_OBJECT;
   {	/* Expand/object.scm 386 */
      {		/* Expand/object.scm 387 */
	 obj_t slots_952;
	 {	/* Expand/object.scm 387 */
	    tclass_bglt obj_2054;
	    obj_2054 =
	       (tclass_bglt) (class_92);
	    {
	       obj_t aux_3381;
	       {	/* ./Object/class.scm 1544 */
		  object_bglt aux_3382;
		  aux_3382 =
		     (object_bglt) (obj_2054);
		  aux_3381 =
		     OBJECT_WIDENING(aux_3382);
	       }
	       slots_952 =
		  (((tclass_bglt) CREF(aux_3381))->slots);
	    }
	 }
	 {	/* Expand/object.scm 387 */
	    global_bglt holder_953;
	    {	/* Expand/object.scm 388 */
	       tclass_bglt obj_2055;
	       obj_2055 =
		  (tclass_bglt) (class_92);
	       {
		  obj_t aux_3387;
		  {	/* ./Object/class.scm 1546 */
		     object_bglt aux_3388;
		     aux_3388 =
			(object_bglt) (obj_2055);
		     aux_3387 =
			OBJECT_WIDENING(aux_3388);
		  }
		  holder_953 =
		     (((tclass_bglt) CREF(aux_3387))->holder);
	       }
	    }
	    {	/* Expand/object.scm 388 */
	       long len_954;
	       len_954 =
		  list_length(slots_952);
	       {	/* Expand/object.scm 389 */
		  obj_t vargs_955;
		  vargs_955 =
		     make_vector(len_954, BUNSPEC);
		  {	/* Expand/object.scm 390 */
		     obj_t dup_var_35_956;
		     {	/* Expand/object.scm 391 */
			obj_t arg1825_1241;
			arg1825_1241 =
			   PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4,
			   CNST_TABLE_REF(((long) 13)), BEOA);
			dup_var_35_956 =
			   mark_symbol_non_user__17_ast_ident(arg1825_1241);
		     }
		     {	/* Expand/object.scm 391 */
			obj_t dup_var_typed_156_957;
			{	/* Expand/object.scm 392 */
			   obj_t list1822_1238;
			   {	/* Expand/object.scm 392 */
			      obj_t arg1823_1239;
			      {		/* Expand/object.scm 392 */
				 obj_t arg1824_1240;
				 {	/* Expand/object.scm 392 */
				    obj_t aux_3398;
				    aux_3398 =
				       (((type_bglt) CREF(class_92))->id);
				    arg1824_1240 =
				       MAKE_PAIR(aux_3398, BNIL);
				 }
				 arg1823_1239 =
				    MAKE_PAIR(_4dots_199_tools_misc, arg1824_1240);
			      }
			      list1822_1238 =
				 MAKE_PAIR(dup_var_35_956, arg1823_1239);
			   }
			   dup_var_typed_156_957 =
			      symbol_append_197___r4_symbols_6_4(list1822_1238);
			}
			{	/* Expand/object.scm 392 */
			   obj_t pragma_typed_60_958;
			   {	/* Expand/object.scm 393 */
			      obj_t arg1815_1232;
			      arg1815_1232 =
				 CNST_TABLE_REF(((long) 14));
			      {		/* Expand/object.scm 393 */
				 obj_t list1817_1234;
				 {	/* Expand/object.scm 393 */
				    obj_t arg1818_1235;
				    {	/* Expand/object.scm 393 */
				       obj_t arg1820_1236;
				       {	/* Expand/object.scm 393 */
					  obj_t aux_3405;
					  aux_3405 =
					     (((type_bglt) CREF(class_92))->id);
					  arg1820_1236 =
					     MAKE_PAIR(aux_3405, BNIL);
				       }
				       arg1818_1235 =
					  MAKE_PAIR(_4dots_199_tools_misc, arg1820_1236);
				    }
				    list1817_1234 =
				       MAKE_PAIR(arg1815_1232, arg1818_1235);
				 }
				 pragma_typed_60_958 =
				    symbol_append_197___r4_symbols_6_4(list1817_1234);
			      }
			   }
			   {	/* Expand/object.scm 393 */
			      obj_t pragma_format_172_959;
			      {		/* Expand/object.scm 394 */
				 obj_t arg1812_1229;
				 {	/* Expand/object.scm 394 */
				    obj_t aux_3411;
				    aux_3411 =
				       (((type_bglt) CREF(class_92))->name);
				    arg1812_1229 =
				       string_append(aux_3411, string2049_expand_object);
				 }
				 pragma_format_172_959 =
				    string_append(string2050_expand_object, arg1812_1229);
			      }
			      {		/* Expand/object.scm 395 */

				 {
				    long i_961;
				    obj_t slots_962;
				    i_961 = ((long) 0);
				    slots_962 = slots_952;
				  loop_963:
				    if (
				       NULLP(slots_962))
				      {		/* Expand/object.scm 414 */
					 CNST_TABLE_REF(((long) 6));
				      }
				    else
				      {		/* Expand/object.scm 416 */
					 obj_t s_965;
					 s_965 =
					    CAR(slots_962);
					 {	/* Expand/object.scm 417 */
					    bool_t test_3419;
					    {	/* ./Llib/struct.scm 1457 */
					       obj_t aux_3420;
					       aux_3420 =
						  STRUCT_REF(s_965, ((long) 8));
					       test_3419 =
						  CBOOL(aux_3420);
					    }
					    if (test_3419)
					      {		/* Expand/object.scm 418 */
						 obj_t arg1576_967;
						 {	/* ./Ieee/pair-list.scm 5689 */
						    obj_t aux_3423;
						    aux_3423 =
						       STRUCT_REF(s_965, ((long) 9));
						    arg1576_967 =
						       MAKE_PAIR(BTRUE, aux_3423);
						 }
						 VECTOR_SET(vargs_955, i_961, arg1576_967);
					      }
					    else
					      {		/* Expand/object.scm 419 */
						 obj_t arg1578_969;
						 arg1578_969 =
						    MAKE_PAIR(BFALSE, BUNSPEC);
						 VECTOR_SET(vargs_955, i_961, arg1578_969);
					      }
					 }
					 {
					    obj_t slots_3431;
					    long i_3429;
					    i_3429 =
					       (i_961 + ((long) 1));
					    slots_3431 =
					       CDR(slots_962);
					    slots_962 = slots_3431;
					    i_961 = i_3429;
					    goto loop_963;
					 }
				      }
				 }
				 {
				    obj_t provided_972;
				    provided_972 = provided_94;
				  loop_973:
				    if (
				       NULLP(provided_972))
				      {		/* Expand/object.scm 424 */
					 CNST_TABLE_REF(((long) 6));
				      }
				    else
				      {		/* Expand/object.scm 426 */
					 obj_t p_975;
					 p_975 =
					    CAR(provided_972);
					 {
					    obj_t s_name_91_976;
					    obj_t value_977;
					    obj_t s_name_91_979;
					    obj_t len_980;
					    obj_t value_981;
					    if (
					       PAIRP(p_975))
					      {		/* Expand/object.scm 427 */
						 obj_t cdr_317_116_986;
						 cdr_317_116_986 =
						    CDR(p_975);
						 if (
						    PAIRP(cdr_317_116_986))
						   {	/* Expand/object.scm 427 */
						      bool_t test_3442;
						      {		/* ./Ieee/equiv.scm 5508 */
							 obj_t aux_3443;
							 aux_3443 =
							    CDR(cdr_317_116_986);
							 test_3442 =
							    (aux_3443 == BNIL);
						      }
						      if (test_3442)
							{	/* Expand/object.scm 427 */
							   s_name_91_976 =
							      CAR(p_975);
							   value_977 =
							      CAR(cdr_317_116_986);
							   {	/* Expand/object.scm 430 */
							      obj_t arg1596_1002;
							      obj_t arg1597_1003;
							      arg1596_1002 =
								 find_slot_offset_103_expand_object(slots_952, form_91, s_name_91_976);
							      {		/* Expand/object.scm 431 */
								 obj_t arg1598_1004;
								 arg1598_1004 =
								    object_epairify_147_expand_object(value_977, p_975);
								 arg1597_1003 =
								    MAKE_PAIR(BTRUE, arg1598_1004);
							      }
							      {		/* ./Ieee/vector.scm 8468 */
								 obj_t x_2673;
								 {	/* ./Ieee/vector.scm 8468 */
								    long aux_3449;
								    aux_3449 =
								       (long) CINT(arg1596_1002);
								    x_2673 =
								       VECTOR_SET(vargs_955, aux_3449, arg1597_1003);
								 }
								 BUNSPEC;
							      }
							   }
							}
						      else
							{	/* Expand/object.scm 427 */
							   obj_t cdr_339_142_992;
							   cdr_339_142_992 =
							      CDR(cdr_317_116_986);
							   if (
							      PAIRP(cdr_339_142_992))
							     {	/* Expand/object.scm 427 */
								bool_t test_3457;
								{	/* ./Ieee/equiv.scm 5508 */
								   obj_t aux_3458;
								   aux_3458 =
								      CDR(cdr_339_142_992);
								   test_3457 =
								      (aux_3458 == BNIL);
								}
								if (test_3457)
								  {	/* Expand/object.scm 427 */
								     s_name_91_979 =
									CAR(p_975);
								     len_980 =
									CAR(cdr_317_116_986);
								     value_981 =
									CAR(cdr_339_142_992);
								     {	/* Expand/object.scm 433 */
									obj_t snum_1005;
									snum_1005 =
									   find_slot_offset_103_expand_object(slots_952, form_91, s_name_91_979);
									{	/* Expand/object.scm 433 */
									   obj_t slot_1006;
									   slot_1006 =
									      list_ref_194___r4_pairs_and_lists_6_3(slots_952,
									      (long) CINT(snum_1005));
									   {	/* Expand/object.scm 434 */

									      {		/* Expand/object.scm 435 */
										 bool_t test_3464;
										 {	/* Expand/object.scm 435 */
										    bool_t test_3465;
										    {	/* ./Llib/struct.scm 1457 */
										       obj_t aux_3466;
										       aux_3466 =
											  STRUCT_REF(slot_1006, ((long) 3));
										       test_3465 =
											  CBOOL(aux_3466);
										    }
										    if (test_3465)
										      {		/* Expand/object.scm 435 */
											 test_3464 = ((bool_t) 1)
											    ;
										      }
										    else
										      {		/* ./Llib/struct.scm 1457 */
											 obj_t aux_3469;
											 aux_3469 =
											    STRUCT_REF(slot_1006, ((long) 5));
											 test_3464 =
											    CBOOL(aux_3469);
										      }
										 }
										 if (test_3464)
										   {	/* Expand/object.scm 435 */
										      {		/* Expand/object.scm 441 */
											 obj_t arg1600_1008;
											 {	/* Expand/object.scm 441 */
											    obj_t arg1601_1009;
											    arg1601_1009 =
											       object_epairify_147_expand_object(value_981, p_975);
											    arg1600_1008 =
											       MAKE_PAIR(BTRUE, arg1601_1009);
											 }
											 {	/* ./Ieee/vector.scm 8468 */
											    long aux_3474;
											    aux_3474 =
											       (long) CINT(snum_1005);
											    VECTOR_SET(vargs_955, aux_3474, arg1600_1008);
											 }
										      }
										      {		/* Expand/object.scm 442 */
											 long arg1602_1010;
											 obj_t arg1603_1011;
											 {	/* ./Ieee/fixnum.scm 7199 */
											    long aux_3477;
											    aux_3477 =
											       (long) CINT(snum_1005);
											    arg1602_1010 =
											       (aux_3477 - ((long) 1));
											 }
											 arg1603_1011 =
											    MAKE_PAIR(BFALSE, len_980);
											 VECTOR_SET(vargs_955, arg1602_1010, arg1603_1011);
										      }
										   }
										 else
										   {	/* Expand/object.scm 435 */
										      FAILURE(BFALSE, string2048_expand_object, form_91);
										   }
									      }
									   }
									}
								     }
								  }
								else
								  {	/* Expand/object.scm 427 */
								   tag_309_102_983:
								     FAILURE(BFALSE, string2048_expand_object, form_91);
								  }
							     }
							   else
							     {	/* Expand/object.scm 427 */
								goto tag_309_102_983;
							     }
							}
						   }
						 else
						   {	/* Expand/object.scm 427 */
						      goto tag_309_102_983;
						   }
					      }
					    else
					      {		/* Expand/object.scm 427 */
						 goto tag_309_102_983;
					      }
					 }
					 {
					    obj_t provided_3487;
					    provided_3487 =
					       CDR(provided_972);
					    provided_972 = provided_3487;
					    goto loop_973;
					 }
				      }
				 }
				 {
				    long i_1014;
				    obj_t s_1015;
				    i_1014 = ((long) 0);
				    s_1015 = slots_952;
				  loop_1016:
				    if (
				       (i_1014 == len_954))
				      {		/* Expand/object.scm 451 */
					 CNST_TABLE_REF(((long) 7));
				      }
				    else
				      {		/* Expand/object.scm 453 */
					 bool_t test_3492;
					 {	/* Expand/object.scm 453 */
					    bool_t test_3493;
					    {	/* ./Ieee/pair-list.scm 5701 */
					       obj_t aux_3494;
					       {	/* ./Ieee/pair-list.scm 5701 */
						  obj_t aux_3495;
						  aux_3495 =
						     VECTOR_REF(vargs_955, i_1014);
						  aux_3494 =
						     CAR(aux_3495);
					       }
					       test_3493 =
						  CBOOL(aux_3494);
					    }
					    if (test_3493)
					      {		/* Expand/object.scm 453 */
						 test_3492 = ((bool_t) 0)
						    ;
					      }
					    else
					      {		/* Expand/object.scm 454 */
						 bool_t test_3499;
						 {	/* ./Llib/struct.scm 1457 */
						    obj_t aux_3500;
						    {	/* ./Llib/struct.scm 1457 */
						       obj_t aux_3501;
						       aux_3501 =
							  CAR(s_1015);
						       aux_3500 =
							  STRUCT_REF(aux_3501, ((long) 11));
						    }
						    test_3499 =
						       CBOOL(aux_3500);
						 }
						 if (test_3499)
						   {	/* Expand/object.scm 454 */
						      test_3492 = ((bool_t) 0)
							 ;
						   }
						 else
						   {	/* Expand/object.scm 454 */
						      test_3492 = ((bool_t) 1)
							 ;
						   }
					      }
					 }
					 if (test_3492)
					   {	/* Expand/object.scm 453 */
					      {		/* Expand/object.scm 457 */
						 obj_t arg1608_1019;
						 {	/* Expand/object.scm 457 */
						    obj_t arg1610_1021;
						    {	/* Expand/object.scm 459 */
						       obj_t arg1611_1022;
						       {	/* ./Ieee/symbol.scm 6021 */
							  obj_t aux_3505;
							  {	/* ./Llib/struct.scm 1457 */
							     obj_t aux_3506;
							     aux_3506 =
								CAR(s_1015);
							     aux_3505 =
								STRUCT_REF(aux_3506, ((long) 0));
							  }
							  arg1611_1022 =
							     SYMBOL_TO_STRING(aux_3505);
						       }
						       arg1610_1021 =
							  string_append(arg1611_1022, string2041_expand_object);
						    }
						    arg1608_1019 =
						       string_append(string2051_expand_object, arg1610_1021);
						 }
						 FAILURE(BFALSE, arg1608_1019, form_91);
					      }
					   }
					 else
					   {	/* Expand/object.scm 453 */
					      {
						 obj_t s_3515;
						 long i_3513;
						 i_3513 =
						    (i_1014 + ((long) 1));
						 s_3515 =
						    CDR(s_1015);
						 s_1015 = s_3515;
						 i_1014 = i_3513;
						 goto loop_1016;
					      }
					   }
				      }
				 }
				 {
				    long i_1032;
				    obj_t slots_1033;
				    obj_t largs_1034;
				    obj_t virtuals_1035;
				    i_1032 = ((long) 0);
				    slots_1033 = slots_952;
				    largs_1034 = BNIL;
				    virtuals_1035 = BNIL;
				  loop_1036:
				    if (
				       (i_1032 == len_954))
				      {		/* Expand/object.scm 470 */
					 obj_t widening_1038;
					 {	/* Expand/object.scm 470 */
					    obj_t arg1779_1191;
					    obj_t arg1780_1192;
					    {	/* Expand/object.scm 470 */
					       tclass_bglt obj_2152;
					       obj_2152 =
						  (tclass_bglt) (class_92);
					       {
						  obj_t aux_3520;
						  {	/* ./Object/class.scm 1548 */
						     object_bglt aux_3521;
						     aux_3521 =
							(object_bglt) (obj_2152);
						     aux_3520 =
							OBJECT_WIDENING(aux_3521);
						  }
						  arg1779_1191 =
						     (((tclass_bglt) CREF(aux_3520))->widening);
					       }
					    }
					    arg1780_1192 =
					       CNST_TABLE_REF(((long) 2));
					    {	/* Expand/object.scm 470 */
					       obj_t list1782_1194;
					       {	/* Expand/object.scm 470 */
						  obj_t arg1783_1195;
						  {	/* Expand/object.scm 470 */
						     obj_t arg1784_1196;
						     {	/* Expand/object.scm 470 */
							obj_t aux_3526;
							aux_3526 =
							   (((type_bglt) CREF(class_92))->id);
							arg1784_1196 =
							   MAKE_PAIR(aux_3526, BNIL);
						     }
						     arg1783_1195 =
							MAKE_PAIR(arg1780_1192, arg1784_1196);
						  }
						  list1782_1194 =
						     MAKE_PAIR(arg1779_1191, arg1783_1195);
					       }
					       widening_1038 =
						  symbol_append_197___r4_symbols_6_4(list1782_1194);
					    }
					 }
					 if (
					    CBOOL(_unsafe_type__146_engine_param))
					   {	/* Expand/object.scm 474 */
					      obj_t arg1622_1039;
					      obj_t arg1623_1040;
					      arg1622_1039 =
						 CNST_TABLE_REF(((long) 1));
					      {		/* Expand/object.scm 474 */
						 obj_t arg1624_1041;
						 obj_t arg1625_1042;
						 {	/* Expand/object.scm 474 */
						    obj_t arg1626_1043;
						    {	/* Expand/object.scm 474 */
						       obj_t arg1628_1045;
						       {	/* Expand/object.scm 474 */
							  obj_t arg1629_1046;
							  {	/* Expand/object.scm 474 */
							     obj_t arg1631_1048;
							     {	/* Expand/object.scm 474 */
								obj_t arg1632_1049;
								arg1632_1049 =
								   MAKE_PAIR(obj_93, BNIL);
								arg1631_1048 =
								   MAKE_PAIR(pragma_format_172_959, arg1632_1049);
							     }
							     arg1629_1046 =
								MAKE_PAIR(pragma_typed_60_958, arg1631_1048);
							  }
							  arg1628_1045 =
							     MAKE_PAIR(arg1629_1046, BNIL);
						       }
						       arg1626_1043 =
							  MAKE_PAIR(dup_var_typed_156_957, arg1628_1045);
						    }
						    arg1624_1041 =
						       MAKE_PAIR(arg1626_1043, BNIL);
						 }
						 {	/* Expand/object.scm 476 */
						    obj_t arg1633_1050;
						    obj_t arg1634_1051;
						    {	/* Expand/object.scm 476 */
						       obj_t arg1635_1052;
						       obj_t arg1636_1053;
						       arg1635_1052 =
							  CNST_TABLE_REF(((long) 15));
						       {	/* Expand/object.scm 478 */
							  obj_t arg1637_1054;
							  {	/* Expand/object.scm 478 */
							     obj_t arg1638_1055;
							     {	/* Expand/object.scm 478 */
								obj_t arg1640_1057;
								{	/* Expand/object.scm 478 */
								   obj_t arg1641_1058;
								   arg1641_1058 =
								      reverse__39___r4_pairs_and_lists_6_3(largs_1034);
								   arg1640_1057 =
								      append_2_18___r4_pairs_and_lists_6_3(arg1641_1058, BNIL);
								}
								arg1638_1055 =
								   MAKE_PAIR(widening_1038, arg1640_1057);
							     }
							     arg1637_1054 =
								MAKE_PAIR(arg1638_1055, BNIL);
							  }
							  arg1636_1053 =
							     MAKE_PAIR(dup_var_35_956, arg1637_1054);
						       }
						       arg1633_1050 =
							  MAKE_PAIR(arg1635_1052, arg1636_1053);
						    }
						    {	/* Expand/object.scm 481 */
						       obj_t arg1643_1060;
						       obj_t arg1644_1061;
						       {	/* Expand/object.scm 481 */
							  obj_t arg1646_1062;
							  obj_t arg1647_1063;
							  {	/* Expand/object.scm 481 */
							     obj_t arg1648_1064;
							     obj_t arg1649_1065;
							     arg1648_1064 =
								CNST_TABLE_REF(((long) 16));
							     {	/* Expand/object.scm 481 */
								obj_t arg1650_1066;
								obj_t arg1651_1067;
								arg1650_1066 =
								   CNST_TABLE_REF(((long) 17));
								{	/* ./Ieee/pair-list.scm 5689 */
								   obj_t aux_3550;
								   aux_3550 =
								      CNST_TABLE_REF(((long) 18));
								   arg1651_1067 =
								      MAKE_PAIR(aux_3550, BNIL);
								}
								arg1649_1065 =
								   MAKE_PAIR(arg1650_1066, arg1651_1067);
							     }
							     arg1646_1062 =
								MAKE_PAIR(arg1648_1064, arg1649_1065);
							  }
							  {	/* Expand/object.scm 483 */
							     obj_t arg1652_1068;
							     {	/* Expand/object.scm 483 */
								obj_t arg1653_1069;
								{	/* Expand/object.scm 483 */
								   obj_t arg1655_1071;
								   obj_t arg1656_1072;
								   {	/* Expand/object.scm 483 */
								      obj_t arg1657_1073;
								      obj_t arg1658_1074;
								      arg1657_1073 =
									 CNST_TABLE_REF(((long) 16));
								      {		/* Expand/object.scm 483 */
									 obj_t arg1659_1075;
									 obj_t arg1660_1076;
									 arg1659_1075 =
									    CNST_TABLE_REF(((long) 19));
									 {	/* ./Ieee/pair-list.scm 5689 */
									    obj_t aux_3557;
									    aux_3557 =
									       CNST_TABLE_REF(((long) 18));
									    arg1660_1076 =
									       MAKE_PAIR(aux_3557, BNIL);
									 }
									 arg1658_1074 =
									    MAKE_PAIR(arg1659_1075, arg1660_1076);
								      }
								      arg1655_1071 =
									 MAKE_PAIR(arg1657_1073, arg1658_1074);
								   }
								   {	/* Expand/object.scm 484 */
								      obj_t arg1661_1077;
								      {		/* Expand/object.scm 484 */
									 obj_t arg1663_1079;
									 obj_t arg1664_1080;
									 arg1663_1079 =
									    CNST_TABLE_REF(((long) 16));
									 {	/* Expand/object.scm 484 */
									    obj_t arg1665_1081;
									    obj_t arg1666_1082;
									    arg1665_1081 =
									       (((global_bglt) CREF(holder_953))->id);
									    {	/* ./Ieee/pair-list.scm 5689 */
									       obj_t aux_3564;
									       aux_3564 =
										  (((global_bglt) CREF(holder_953))->module);
									       arg1666_1082 =
										  MAKE_PAIR(aux_3564, BNIL);
									    }
									    arg1664_1080 =
									       MAKE_PAIR(arg1665_1081, arg1666_1082);
									 }
									 arg1661_1077 =
									    MAKE_PAIR(arg1663_1079, arg1664_1080);
								      }
								      arg1656_1072 =
									 MAKE_PAIR(arg1661_1077, BNIL);
								   }
								   arg1653_1069 =
								      MAKE_PAIR(arg1655_1071, arg1656_1072);
								}
								arg1652_1068 =
								   MAKE_PAIR(arg1653_1069, BNIL);
							     }
							     arg1647_1063 =
								MAKE_PAIR(dup_var_35_956, arg1652_1068);
							  }
							  arg1643_1060 =
							     MAKE_PAIR(arg1646_1062, arg1647_1063);
						       }
						       {	/* Expand/object.scm 485 */
							  obj_t arg1670_1085;
							  obj_t arg1671_1086;
							  arg1670_1085 =
							     reverse__39___r4_pairs_and_lists_6_3(virtuals_1035);
							  arg1671_1086 =
							     MAKE_PAIR(dup_var_35_956, BNIL);
							  arg1644_1061 =
							     append_2_18___r4_pairs_and_lists_6_3(arg1670_1085, arg1671_1086);
						       }
						       arg1634_1051 =
							  MAKE_PAIR(arg1643_1060, arg1644_1061);
						    }
						    arg1625_1042 =
						       MAKE_PAIR(arg1633_1050, arg1634_1051);
						 }
						 arg1623_1040 =
						    MAKE_PAIR(arg1624_1041, arg1625_1042);
					      }
					      return
						 MAKE_PAIR(arg1622_1039, arg1623_1040);
					   }
					 else
					   {	/* Expand/object.scm 487 */
					      obj_t arg1672_1087;
					      obj_t arg1673_1088;
					      arg1672_1087 =
						 CNST_TABLE_REF(((long) 1));
					      {		/* Expand/object.scm 487 */
						 obj_t arg1674_1089;
						 obj_t arg1675_1090;
						 {	/* Expand/object.scm 487 */
						    obj_t arg1676_1091;
						    {	/* Expand/object.scm 487 */
						       obj_t arg1678_1093;
						       {	/* Expand/object.scm 487 */
							  obj_t arg1679_1094;
							  {	/* Expand/object.scm 487 */
							     obj_t arg1681_1096;
							     {	/* Expand/object.scm 487 */
								obj_t arg1682_1097;
								arg1682_1097 =
								   MAKE_PAIR(obj_93, BNIL);
								arg1681_1096 =
								   MAKE_PAIR(pragma_format_172_959, arg1682_1097);
							     }
							     arg1679_1094 =
								MAKE_PAIR(pragma_typed_60_958, arg1681_1096);
							  }
							  arg1678_1093 =
							     MAKE_PAIR(arg1679_1094, BNIL);
						       }
						       arg1676_1091 =
							  MAKE_PAIR(dup_var_typed_156_957, arg1678_1093);
						    }
						    arg1674_1089 =
						       MAKE_PAIR(arg1676_1091, BNIL);
						 }
						 {	/* Expand/object.scm 489 */
						    obj_t arg1683_1098;
						    obj_t arg1684_1099;
						    {	/* Expand/object.scm 489 */
						       obj_t arg1685_1100;
						       obj_t arg1686_1101;
						       arg1685_1100 =
							  CNST_TABLE_REF(((long) 20));
						       {	/* Expand/object.scm 489 */
							  obj_t arg1687_1102;
							  obj_t arg1688_1103;
							  {	/* Expand/object.scm 489 */
							     obj_t arg1689_1104;
							     obj_t arg1690_1105;
							     arg1689_1104 =
								CNST_TABLE_REF(((long) 21));
							     arg1690_1105 =
								MAKE_PAIR(dup_var_35_956, BNIL);
							     arg1687_1102 =
								MAKE_PAIR(arg1689_1104, arg1690_1105);
							  }
							  {	/* Expand/object.scm 490 */
							     obj_t arg1691_1106;
							     {	/* Expand/object.scm 490 */
								obj_t arg1693_1108;
								obj_t arg1694_1109;
								arg1693_1108 =
								   CNST_TABLE_REF(((long) 22));
								arg1694_1109 =
								   MAKE_PAIR(dup_var_35_956, BNIL);
								arg1691_1106 =
								   MAKE_PAIR(arg1693_1108, arg1694_1109);
							     }
							     arg1688_1103 =
								MAKE_PAIR(arg1691_1106, BNIL);
							  }
							  arg1686_1101 =
							     MAKE_PAIR(arg1687_1102, arg1688_1103);
						       }
						       arg1683_1098 =
							  MAKE_PAIR(arg1685_1100, arg1686_1101);
						    }
						    {	/* Expand/object.scm 491 */
						       obj_t arg1695_1110;
						       {	/* Expand/object.scm 491 */
							  obj_t arg1697_1112;
							  obj_t arg1698_1113;
							  arg1697_1112 =
							     CNST_TABLE_REF(((long) 20));
							  {	/* Expand/object.scm 491 */
							     obj_t arg1699_1114;
							     obj_t arg1700_1115;
							     {	/* Expand/object.scm 491 */
								obj_t arg1701_1116;
								obj_t arg1702_1117;
								arg1701_1116 =
								   CNST_TABLE_REF(((long) 23));
								{	/* Expand/object.scm 491 */
								   obj_t arg1703_1118;
								   obj_t arg1704_1119;
								   {	/* Expand/object.scm 491 */
								      obj_t arg1705_1120;
								      obj_t arg1706_1121;
								      {		/* Expand/object.scm 491 */
									 obj_t arg1707_1122;
									 obj_t arg1708_1123;
									 arg1707_1122 =
									    CNST_TABLE_REF(((long) 16));
									 {	/* Expand/object.scm 491 */
									    obj_t arg1709_1124;
									    obj_t arg1711_1125;
									    arg1709_1124 =
									       CNST_TABLE_REF(((long) 24));
									    {	/* ./Ieee/pair-list.scm 5689 */
									       obj_t aux_3602;
									       aux_3602 =
										  CNST_TABLE_REF(((long) 18));
									       arg1711_1125 =
										  MAKE_PAIR(aux_3602, BNIL);
									    }
									    arg1708_1123 =
									       MAKE_PAIR(arg1709_1124, arg1711_1125);
									 }
									 arg1705_1120 =
									    MAKE_PAIR(arg1707_1122, arg1708_1123);
								      }
								      {		/* Expand/object.scm 492 */
									 obj_t arg1712_1126;
									 {	/* Expand/object.scm 492 */
									    obj_t arg1714_1128;
									    obj_t arg1715_1129;
									    arg1714_1128 =
									       CNST_TABLE_REF(((long) 16));
									    {	/* Expand/object.scm 492 */
									       obj_t arg1716_1130;
									       obj_t arg1717_1131;
									       arg1716_1130 =
										  (((global_bglt) CREF(holder_953))->id);
									       {	/* ./Ieee/pair-list.scm 5689 */
										  obj_t aux_3609;
										  aux_3609 =
										     (((global_bglt) CREF(holder_953))->module);
										  arg1717_1131 =
										     MAKE_PAIR(aux_3609, BNIL);
									       }
									       arg1715_1129 =
										  MAKE_PAIR(arg1716_1130, arg1717_1131);
									    }
									    arg1712_1126 =
									       MAKE_PAIR(arg1714_1128, arg1715_1129);
									 }
									 arg1706_1121 =
									    MAKE_PAIR(arg1712_1126, BNIL);
								      }
								      arg1703_1118 =
									 MAKE_PAIR(arg1705_1120, arg1706_1121);
								   }
								   {	/* Expand/object.scm 494 */
								      obj_t arg1720_1134;
								      {		/* Expand/object.scm 494 */
									 obj_t arg1722_1136;
									 obj_t arg1723_1137;
									 {	/* Expand/object.scm 494 */
									    obj_t arg1724_1138;
									    obj_t arg1725_1139;
									    arg1724_1138 =
									       CNST_TABLE_REF(((long) 16));
									    {	/* Expand/object.scm 494 */
									       obj_t arg1726_1140;
									       obj_t arg1727_1141;
									       arg1726_1140 =
										  CNST_TABLE_REF(((long) 25));
									       {	/* ./Ieee/pair-list.scm 5689 */
										  obj_t aux_3618;
										  aux_3618 =
										     CNST_TABLE_REF(((long) 18));
										  arg1727_1141 =
										     MAKE_PAIR(aux_3618, BNIL);
									       }
									       arg1725_1139 =
										  MAKE_PAIR(arg1726_1140, arg1727_1141);
									    }
									    arg1722_1136 =
									       MAKE_PAIR(arg1724_1138, arg1725_1139);
									 }
									 arg1723_1137 =
									    MAKE_PAIR(dup_var_35_956, BNIL);
									 arg1720_1134 =
									    MAKE_PAIR(arg1722_1136, arg1723_1137);
								      }
								      arg1704_1119 =
									 MAKE_PAIR(arg1720_1134, BNIL);
								   }
								   arg1702_1117 =
								      MAKE_PAIR(arg1703_1118, arg1704_1119);
								}
								arg1699_1114 =
								   MAKE_PAIR(arg1701_1116, arg1702_1117);
							     }
							     {	/* Expand/object.scm 495 */
								obj_t arg1728_1142;
								obj_t arg1729_1143;
								{	/* Expand/object.scm 495 */
								   obj_t arg1730_1144;
								   obj_t arg1731_1145;
								   arg1730_1144 =
								      CNST_TABLE_REF(((long) 26));
								   {	/* Expand/object.scm 496 */
								      obj_t arg1732_1146;
								      obj_t arg1733_1147;
								      {		/* Expand/object.scm 496 */
									 obj_t arg1734_1148;
									 obj_t arg1735_1149;
									 arg1734_1148 =
									    CNST_TABLE_REF(((long) 15));
									 {	/* Expand/object.scm 498 */
									    obj_t arg1736_1150;
									    {	/* Expand/object.scm 498 */
									       obj_t arg1738_1151;
									       {	/* Expand/object.scm 498 */
										  obj_t arg1740_1153;
										  {	/* Expand/object.scm 498 */
										     obj_t arg1741_1154;
										     arg1741_1154 =
											reverse__39___r4_pairs_and_lists_6_3(largs_1034);
										     arg1740_1153 =
											append_2_18___r4_pairs_and_lists_6_3(arg1741_1154, BNIL);
										  }
										  arg1738_1151 =
										     MAKE_PAIR(widening_1038, arg1740_1153);
									       }
									       arg1736_1150 =
										  MAKE_PAIR(arg1738_1151, BNIL);
									    }
									    arg1735_1149 =
									       MAKE_PAIR(dup_var_35_956, arg1736_1150);
									 }
									 arg1732_1146 =
									    MAKE_PAIR(arg1734_1148, arg1735_1149);
								      }
								      {		/* Expand/object.scm 500 */
									 obj_t arg1743_1156;
									 obj_t arg1744_1157;
									 {	/* Expand/object.scm 500 */
									    obj_t arg1745_1158;
									    obj_t arg1746_1159;
									    {	/* Expand/object.scm 500 */
									       obj_t arg1747_1160;
									       obj_t arg1748_1161;
									       arg1747_1160 =
										  CNST_TABLE_REF(((long) 16));
									       {	/* Expand/object.scm 500 */
										  obj_t arg1749_1162;
										  obj_t arg1750_1163;
										  arg1749_1162 =
										     CNST_TABLE_REF(((long) 17));
										  {	/* ./Ieee/pair-list.scm 5689 */
										     obj_t aux_3638;
										     aux_3638 =
											CNST_TABLE_REF(((long) 18));
										     arg1750_1163 =
											MAKE_PAIR(aux_3638, BNIL);
										  }
										  arg1748_1161 =
										     MAKE_PAIR(arg1749_1162, arg1750_1163);
									       }
									       arg1745_1158 =
										  MAKE_PAIR(arg1747_1160, arg1748_1161);
									    }
									    {	/* Expand/object.scm 502 */
									       obj_t arg1751_1164;
									       {	/* Expand/object.scm 502 */
										  obj_t arg1752_1165;
										  {	/* Expand/object.scm 502 */
										     obj_t arg1754_1167;
										     obj_t arg1755_1168;
										     {	/* Expand/object.scm 502 */
											obj_t arg1756_1169;
											obj_t arg1758_1170;
											arg1756_1169 =
											   CNST_TABLE_REF(((long) 16));
											{	/* Expand/object.scm 502 */
											   obj_t arg1759_1171;
											   obj_t arg1760_1172;
											   arg1759_1171 =
											      CNST_TABLE_REF(((long) 19));
											   {	/* ./Ieee/pair-list.scm 5689 */
											      obj_t aux_3645;
											      aux_3645 =
												 CNST_TABLE_REF(((long) 18));
											      arg1760_1172 =
												 MAKE_PAIR(aux_3645, BNIL);
											   }
											   arg1758_1170 =
											      MAKE_PAIR(arg1759_1171, arg1760_1172);
											}
											arg1754_1167 =
											   MAKE_PAIR(arg1756_1169, arg1758_1170);
										     }
										     {	/* Expand/object.scm 503 */
											obj_t arg1761_1173;
											{	/* Expand/object.scm 503 */
											   obj_t arg1763_1175;
											   obj_t arg1764_1176;
											   arg1763_1175 =
											      CNST_TABLE_REF(((long) 16));
											   {	/* Expand/object.scm 503 */
											      obj_t arg1765_1177;
											      obj_t arg1766_1178;
											      arg1765_1177 =
												 (((global_bglt) CREF(holder_953))->id);
											      {		/* ./Ieee/pair-list.scm 5689 */
												 obj_t aux_3652;
												 aux_3652 =
												    (((global_bglt) CREF(holder_953))->module);
												 arg1766_1178 =
												    MAKE_PAIR(aux_3652, BNIL);
											      }
											      arg1764_1176 =
												 MAKE_PAIR(arg1765_1177, arg1766_1178);
											   }
											   arg1761_1173 =
											      MAKE_PAIR(arg1763_1175, arg1764_1176);
											}
											arg1755_1168 =
											   MAKE_PAIR(arg1761_1173, BNIL);
										     }
										     arg1752_1165 =
											MAKE_PAIR(arg1754_1167, arg1755_1168);
										  }
										  arg1751_1164 =
										     MAKE_PAIR(arg1752_1165, BNIL);
									       }
									       arg1746_1159 =
										  MAKE_PAIR(dup_var_35_956, arg1751_1164);
									    }
									    arg1743_1156 =
									       MAKE_PAIR(arg1745_1158, arg1746_1159);
									 }
									 {	/* Expand/object.scm 505 */
									    obj_t arg1769_1181;
									    obj_t arg1770_1182;
									    arg1769_1181 =
									       reverse__39___r4_pairs_and_lists_6_3(virtuals_1035);
									    arg1770_1182 =
									       MAKE_PAIR(dup_var_35_956, BNIL);
									    arg1744_1157 =
									       append_2_18___r4_pairs_and_lists_6_3(arg1769_1181, arg1770_1182);
									 }
									 arg1733_1147 =
									    MAKE_PAIR(arg1743_1156, arg1744_1157);
								      }
								      arg1731_1145 =
									 MAKE_PAIR(arg1732_1146, arg1733_1147);
								   }
								   arg1728_1142 =
								      MAKE_PAIR(arg1730_1144, arg1731_1145);
								}
								{	/* Expand/object.scm 507 */
								   obj_t arg1771_1183;
								   {	/* Expand/object.scm 507 */
								      obj_t arg1773_1185;
								      obj_t arg1774_1186;
								      arg1773_1185 =
									 CNST_TABLE_REF(((long) 27));
								      {		/* Expand/object.scm 507 */
									 obj_t arg1776_1188;
									 {	/* Expand/object.scm 507 */
									    obj_t arg1778_1190;
									    arg1778_1190 =
									       MAKE_PAIR(dup_var_35_956, BNIL);
									    arg1776_1188 =
									       MAKE_PAIR(string2052_expand_object, arg1778_1190);
									 }
									 arg1774_1186 =
									    MAKE_PAIR(string2053_expand_object, arg1776_1188);
								      }
								      arg1771_1183 =
									 MAKE_PAIR(arg1773_1185, arg1774_1186);
								   }
								   arg1729_1143 =
								      MAKE_PAIR(arg1771_1183, BNIL);
								}
								arg1700_1115 =
								   MAKE_PAIR(arg1728_1142, arg1729_1143);
							     }
							     arg1698_1113 =
								MAKE_PAIR(arg1699_1114, arg1700_1115);
							  }
							  arg1695_1110 =
							     MAKE_PAIR(arg1697_1112, arg1698_1113);
						       }
						       arg1684_1099 =
							  MAKE_PAIR(arg1695_1110, BNIL);
						    }
						    arg1675_1090 =
						       MAKE_PAIR(arg1683_1098, arg1684_1099);
						 }
						 arg1673_1088 =
						    MAKE_PAIR(arg1674_1089, arg1675_1090);
					      }
					      return
						 MAKE_PAIR(arg1672_1087, arg1673_1088);
					   }
				      }
				    else
				      {		/* Expand/object.scm 511 */
					 obj_t value_1197;
					 {	/* ./Ieee/pair-list.scm 5707 */
					    obj_t aux_3681;
					    aux_3681 =
					       VECTOR_REF(vargs_955, i_1032);
					    value_1197 =
					       CDR(aux_3681);
					 }
					 {	/* Expand/object.scm 513 */
					    bool_t test_3684;
					    {	/* ./Llib/struct.scm 1457 */
					       obj_t aux_3685;
					       {	/* ./Llib/struct.scm 1457 */
						  obj_t aux_3686;
						  aux_3686 =
						     CAR(slots_1033);
						  aux_3685 =
						     STRUCT_REF(aux_3686, ((long) 11));
					       }
					       test_3684 =
						  CBOOL(aux_3685);
					    }
					    if (test_3684)
					      {		/* Expand/object.scm 513 */
						 {	/* Expand/object.scm 514 */
						    long arg1786_1199;
						    obj_t arg1787_1200;
						    obj_t arg1788_1201;
						    arg1786_1199 =
						       (i_1032 + ((long) 1));
						    arg1787_1200 =
						       CDR(slots_1033);
						    if (
						       (value_1197 == BUNSPEC))
						      {		/* Expand/object.scm 517 */
							 arg1788_1201 = virtuals_1035;
						      }
						    else
						      {		/* Expand/object.scm 519 */
							 obj_t arg1790_1203;
							 arg1790_1203 =
							    make_virtual_set_218_expand_object(
							    CAR(slots_1033), value_1197, dup_var_35_956,
							    (obj_t) (class_92), form_91, "widen!");
							 arg1788_1201 =
							    MAKE_PAIR(arg1790_1203, virtuals_1035);
						      }
						    {
						       obj_t virtuals_3700;
						       obj_t slots_3699;
						       long i_3698;
						       i_3698 = arg1786_1199;
						       slots_3699 = arg1787_1200;
						       virtuals_3700 = arg1788_1201;
						       virtuals_1035 = virtuals_3700;
						       slots_1033 = slots_3699;
						       i_1032 = i_3698;
						       goto loop_1036;
						    }
						 }
					      }
					    else
					      {		/* Expand/object.scm 513 */
						 {	/* Expand/object.scm 527 */
						    long arg1793_1206;
						    obj_t arg1794_1207;
						    obj_t arg1795_1208;
						    arg1793_1206 =
						       (i_1032 + ((long) 1));
						    arg1794_1207 =
						       CDR(slots_1033);
						    arg1795_1208 =
						       MAKE_PAIR(value_1197, largs_1034);
						    {
						       obj_t largs_3706;
						       obj_t slots_3705;
						       long i_3704;
						       i_3704 = arg1793_1206;
						       slots_3705 = arg1794_1207;
						       largs_3706 = arg1795_1208;
						       largs_1034 = largs_3706;
						       slots_1033 = slots_3705;
						       i_1032 = i_3704;
						       goto loop_1036;
						    }
						 }
					      }
					 }
				      }
				 }
			      }
			   }
			}
		     }
		  }
	       }
	    }
	 }
      }
   }
}



/* find-slot-offset */
obj_t 
find_slot_offset_103_expand_object(obj_t slots_2663, obj_t form_2662, obj_t s_name_91_1211)
{
   AN_OBJECT;
   {	/* Expand/object.scm 395 */
      {
	 obj_t slots_1213;
	 long i_1214;
	 slots_1213 = slots_2663;
	 i_1214 = ((long) 0);
       loop_1215:
	 if (
	    NULLP(slots_1213))
	   {	/* Expand/object.scm 399 */
	      {		/* Expand/object.scm 402 */
		 obj_t arg1800_1217;
		 {	/* Expand/object.scm 402 */
		    obj_t arg1802_1219;
		    {	/* Expand/object.scm 404 */
		       obj_t arg1803_1220;
		       arg1803_1220 =
			  SYMBOL_TO_STRING(s_name_91_1211);
		       arg1802_1219 =
			  string_append(arg1803_1220, string2041_expand_object);
		    }
		    arg1800_1217 =
		       string_append(string2054_expand_object, arg1802_1219);
		 }
		 FAILURE(BFALSE, arg1800_1217, form_2662);
	      }
	   }
	 else
	   {	/* Expand/object.scm 407 */
	      bool_t test_3713;
	      {		/* ./Ieee/equiv.scm 5508 */
		 obj_t aux_3714;
		 {	/* ./Llib/struct.scm 1457 */
		    obj_t aux_3715;
		    aux_3715 =
		       CAR(slots_1213);
		    aux_3714 =
		       STRUCT_REF(aux_3715, ((long) 0));
		 }
		 test_3713 =
		    (aux_3714 == s_name_91_1211);
	      }
	      if (test_3713)
		{	/* Expand/object.scm 407 */
		   return
		      BINT(i_1214);
		}
	      else
		{	/* Expand/object.scm 407 */
		   {
		      long i_3722;
		      obj_t slots_3720;
		      slots_3720 =
			 CDR(slots_1213);
		      i_3722 =
			 (i_1214 + ((long) 1));
		      i_1214 = i_3722;
		      slots_1213 = slots_3720;
		      goto loop_1215;
		   }
		}
	   }
      }
   }
}



/* expand-shrink! */
obj_t 
expand_shrink__128_expand_object(obj_t x_95, obj_t e_96)
{
   AN_OBJECT;
   {	/* Expand/object.scm 535 */
      {

	 if (
	    PAIRP(x_95))
	   {	/* Expand/object.scm 536 */
	      obj_t cdr_365_142_1249;
	      cdr_365_142_1249 =
		 CDR(x_95);
	      {		/* Expand/object.scm 536 */
		 bool_t test_3727;
		 {	/* ./Ieee/equiv.scm 5508 */
		    obj_t aux_3730;
		    obj_t aux_3728;
		    aux_3730 =
		       CNST_TABLE_REF(((long) 22));
		    aux_3728 =
		       CAR(x_95);
		    test_3727 =
		       (aux_3728 == aux_3730);
		 }
		 if (test_3727)
		   {	/* Expand/object.scm 536 */
		      if (
			 PAIRP(cdr_365_142_1249))
			{	/* Expand/object.scm 536 */
			   bool_t test_3735;
			   {	/* ./Ieee/equiv.scm 5508 */
			      obj_t aux_3736;
			      aux_3736 =
				 CDR(cdr_365_142_1249);
			      test_3735 =
				 (aux_3736 == BNIL);
			   }
			   if (test_3735)
			     {	/* Expand/object.scm 538 */
				obj_t arg1838_2389;
				arg1838_2389 =
				   make_a_shrink__124_expand_object(e_96,
				   CAR(cdr_365_142_1249));
				return
				   replace__160_tools_misc(x_95, arg1838_2389);
			     }
			   else
			     {	/* Expand/object.scm 536 */
			      tag_360_173_1246:
				FAILURE(BFALSE, string2055_expand_object, x_95);
			     }
			}
		      else
			{	/* Expand/object.scm 536 */
			   goto tag_360_173_1246;
			}
		   }
		 else
		   {	/* Expand/object.scm 536 */
		      goto tag_360_173_1246;
		   }
	      }
	   }
	 else
	   {	/* Expand/object.scm 536 */
	      goto tag_360_173_1246;
	   }
      }
   }
}



/* _expand-shrink! */
obj_t 
_expand_shrink__87_expand_object(obj_t env_2659, obj_t x_2660, obj_t e_2661)
{
   AN_OBJECT;
   {	/* Expand/object.scm 535 */
      return
	 expand_shrink__128_expand_object(x_2660, e_2661);
   }
}



/* make-a-shrink! */
obj_t 
make_a_shrink__124_expand_object(obj_t e_97, obj_t o_98)
{
   AN_OBJECT;
   {	/* Expand/object.scm 545 */
      {		/* Expand/object.scm 546 */
	 obj_t newo_1259;
	 {	/* Expand/object.scm 546 */
	    obj_t arg1976_1390;
	    arg1976_1390 =
	       PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4,
	       CNST_TABLE_REF(((long) 28)), BEOA);
	    newo_1259 =
	       mark_symbol_non_user__17_ast_ident(arg1976_1390);
	 }
	 if (
	    CBOOL(_unsafe_type__146_engine_param))
	   {	/* Expand/object.scm 548 */
	      obj_t arg1839_1260;
	      obj_t arg1841_1261;
	      arg1839_1260 =
		 CNST_TABLE_REF(((long) 1));
	      {		/* Expand/object.scm 548 */
		 obj_t arg1842_1262;
		 obj_t arg1843_1263;
		 {	/* Expand/object.scm 548 */
		    obj_t arg1844_1264;
		    {	/* Expand/object.scm 548 */
		       obj_t arg1846_1266;
		       {	/* Expand/object.scm 548 */
			  obj_t arg1847_1267;
			  arg1847_1267 =
			     PROCEDURE_ENTRY(e_97) (e_97, o_98, e_97, BEOA);
			  arg1846_1266 =
			     MAKE_PAIR(arg1847_1267, BNIL);
		       }
		       arg1844_1264 =
			  MAKE_PAIR(newo_1259, arg1846_1266);
		    }
		    arg1842_1262 =
		       MAKE_PAIR(arg1844_1264, BNIL);
		 }
		 {	/* Expand/object.scm 549 */
		    obj_t arg1849_1269;
		    obj_t arg1850_1270;
		    {	/* Expand/object.scm 549 */
		       obj_t arg1851_1271;
		       obj_t arg1852_1272;
		       {	/* Expand/object.scm 549 */
			  obj_t arg1853_1273;
			  obj_t arg1854_1274;
			  arg1853_1273 =
			     CNST_TABLE_REF(((long) 16));
			  {	/* Expand/object.scm 549 */
			     obj_t arg1855_1275;
			     obj_t arg1856_1276;
			     arg1855_1275 =
				CNST_TABLE_REF(((long) 17));
			     {	/* ./Ieee/pair-list.scm 5689 */
				obj_t aux_3758;
				aux_3758 =
				   CNST_TABLE_REF(((long) 18));
				arg1856_1276 =
				   MAKE_PAIR(aux_3758, BNIL);
			     }
			     arg1854_1274 =
				MAKE_PAIR(arg1855_1275, arg1856_1276);
			  }
			  arg1851_1271 =
			     MAKE_PAIR(arg1853_1273, arg1854_1274);
		       }
		       {	/* Expand/object.scm 551 */
			  obj_t arg1857_1277;
			  {	/* Expand/object.scm 551 */
			     obj_t arg1858_1278;
			     {	/* Expand/object.scm 551 */
				obj_t arg1860_1280;
				obj_t arg1861_1281;
				{	/* Expand/object.scm 551 */
				   obj_t arg1862_1282;
				   obj_t arg1863_1283;
				   arg1862_1282 =
				      CNST_TABLE_REF(((long) 16));
				   {	/* Expand/object.scm 551 */
				      obj_t arg1864_1284;
				      obj_t arg1865_1285;
				      arg1864_1284 =
					 CNST_TABLE_REF(((long) 19));
				      {		/* ./Ieee/pair-list.scm 5689 */
					 obj_t aux_3765;
					 aux_3765 =
					    CNST_TABLE_REF(((long) 18));
					 arg1865_1285 =
					    MAKE_PAIR(aux_3765, BNIL);
				      }
				      arg1863_1283 =
					 MAKE_PAIR(arg1864_1284, arg1865_1285);
				   }
				   arg1860_1280 =
				      MAKE_PAIR(arg1862_1282, arg1863_1283);
				}
				{	/* Expand/object.scm 552 */
				   obj_t arg1866_1286;
				   {	/* Expand/object.scm 552 */
				      obj_t arg1868_1288;
				      obj_t arg1869_1289;
				      {		/* Expand/object.scm 552 */
					 obj_t arg1870_1290;
					 obj_t arg1871_1291;
					 arg1870_1290 =
					    CNST_TABLE_REF(((long) 16));
					 {	/* Expand/object.scm 552 */
					    obj_t arg1872_1292;
					    obj_t arg1873_1293;
					    arg1872_1292 =
					       CNST_TABLE_REF(((long) 24));
					    {	/* ./Ieee/pair-list.scm 5689 */
					       obj_t aux_3772;
					       aux_3772 =
						  CNST_TABLE_REF(((long) 18));
					       arg1873_1293 =
						  MAKE_PAIR(aux_3772, BNIL);
					    }
					    arg1871_1291 =
					       MAKE_PAIR(arg1872_1292, arg1873_1293);
					 }
					 arg1868_1288 =
					    MAKE_PAIR(arg1870_1290, arg1871_1291);
				      }
				      {		/* Expand/object.scm 553 */
					 obj_t arg1874_1294;
					 {	/* Expand/object.scm 553 */
					    obj_t arg1876_1296;
					    obj_t arg1877_1297;
					    {	/* Expand/object.scm 553 */
					       obj_t arg1879_1298;
					       obj_t arg1880_1299;
					       arg1879_1298 =
						  CNST_TABLE_REF(((long) 16));
					       {	/* Expand/object.scm 553 */
						  obj_t arg1881_1300;
						  obj_t arg1882_1301;
						  arg1881_1300 =
						     CNST_TABLE_REF(((long) 25));
						  {	/* ./Ieee/pair-list.scm 5689 */
						     obj_t aux_3779;
						     aux_3779 =
							CNST_TABLE_REF(((long) 18));
						     arg1882_1301 =
							MAKE_PAIR(aux_3779, BNIL);
						  }
						  arg1880_1299 =
						     MAKE_PAIR(arg1881_1300, arg1882_1301);
					       }
					       arg1876_1296 =
						  MAKE_PAIR(arg1879_1298, arg1880_1299);
					    }
					    arg1877_1297 =
					       MAKE_PAIR(newo_1259, BNIL);
					    arg1874_1294 =
					       MAKE_PAIR(arg1876_1296, arg1877_1297);
					 }
					 arg1869_1289 =
					    MAKE_PAIR(arg1874_1294, BNIL);
				      }
				      arg1866_1286 =
					 MAKE_PAIR(arg1868_1288, arg1869_1289);
				   }
				   arg1861_1281 =
				      MAKE_PAIR(arg1866_1286, BNIL);
				}
				arg1858_1278 =
				   MAKE_PAIR(arg1860_1280, arg1861_1281);
			     }
			     arg1857_1277 =
				MAKE_PAIR(arg1858_1278, BNIL);
			  }
			  arg1852_1272 =
			     MAKE_PAIR(newo_1259, arg1857_1277);
		       }
		       arg1849_1269 =
			  MAKE_PAIR(arg1851_1271, arg1852_1272);
		    }
		    {	/* Expand/object.scm 554 */
		       obj_t arg1883_1302;
		       obj_t arg1884_1303;
		       {	/* Expand/object.scm 554 */
			  obj_t arg1885_1304;
			  obj_t arg1886_1305;
			  arg1885_1304 =
			     CNST_TABLE_REF(((long) 15));
			  {	/* Expand/object.scm 554 */
			     obj_t arg1887_1306;
			     arg1887_1306 =
				MAKE_PAIR(BFALSE, BNIL);
			     arg1886_1305 =
				MAKE_PAIR(newo_1259, arg1887_1306);
			  }
			  arg1883_1302 =
			     MAKE_PAIR(arg1885_1304, arg1886_1305);
		       }
		       arg1884_1303 =
			  MAKE_PAIR(newo_1259, BNIL);
		       arg1850_1270 =
			  MAKE_PAIR(arg1883_1302, arg1884_1303);
		    }
		    arg1843_1263 =
		       MAKE_PAIR(arg1849_1269, arg1850_1270);
		 }
		 arg1841_1261 =
		    MAKE_PAIR(arg1842_1262, arg1843_1263);
	      }
	      return
		 MAKE_PAIR(arg1839_1260, arg1841_1261);
	   }
	 else
	   {	/* Expand/object.scm 556 */
	      obj_t arg1888_1307;
	      obj_t arg1889_1308;
	      arg1888_1307 =
		 CNST_TABLE_REF(((long) 1));
	      {		/* Expand/object.scm 556 */
		 obj_t arg1890_1309;
		 obj_t arg1891_1310;
		 {	/* Expand/object.scm 556 */
		    obj_t arg1892_1311;
		    {	/* Expand/object.scm 556 */
		       obj_t arg1894_1313;
		       {	/* Expand/object.scm 556 */
			  obj_t arg1895_1314;
			  arg1895_1314 =
			     PROCEDURE_ENTRY(e_97) (e_97, o_98, e_97, BEOA);
			  arg1894_1313 =
			     MAKE_PAIR(arg1895_1314, BNIL);
		       }
		       arg1892_1311 =
			  MAKE_PAIR(newo_1259, arg1894_1313);
		    }
		    arg1890_1309 =
		       MAKE_PAIR(arg1892_1311, BNIL);
		 }
		 {	/* Expand/object.scm 557 */
		    obj_t arg1897_1316;
		    {	/* Expand/object.scm 557 */
		       obj_t arg1899_1318;
		       obj_t arg1900_1319;
		       arg1899_1318 =
			  CNST_TABLE_REF(((long) 20));
		       {	/* Expand/object.scm 557 */
			  obj_t arg1901_1320;
			  obj_t arg1902_1321;
			  {	/* Expand/object.scm 557 */
			     obj_t arg1903_1322;
			     obj_t arg1904_1323;
			     arg1903_1322 =
				CNST_TABLE_REF(((long) 29));
			     arg1904_1323 =
				MAKE_PAIR(newo_1259, BNIL);
			     arg1901_1320 =
				MAKE_PAIR(arg1903_1322, arg1904_1323);
			  }
			  {	/* Expand/object.scm 558 */
			     obj_t arg1905_1324;
			     obj_t arg1906_1325;
			     {	/* Expand/object.scm 558 */
				obj_t arg1907_1326;
				obj_t arg1909_1327;
				arg1907_1326 =
				   CNST_TABLE_REF(((long) 20));
				{	/* Expand/object.scm 558 */
				   obj_t arg1910_1328;
				   obj_t arg1912_1329;
				   {	/* Expand/object.scm 558 */
				      obj_t arg1913_1330;
				      obj_t arg1914_1331;
				      arg1913_1330 =
					 CNST_TABLE_REF(((long) 21));
				      arg1914_1331 =
					 MAKE_PAIR(newo_1259, BNIL);
				      arg1910_1328 =
					 MAKE_PAIR(arg1913_1330, arg1914_1331);
				   }
				   {	/* Expand/object.scm 559 */
				      obj_t arg1915_1332;
				      obj_t arg1916_1333;
				      {		/* Expand/object.scm 559 */
					 obj_t arg1917_1334;
					 obj_t arg1919_1335;
					 arg1917_1334 =
					    CNST_TABLE_REF(((long) 26));
					 {	/* Expand/object.scm 560 */
					    obj_t arg1920_1336;
					    obj_t arg1921_1337;
					    {	/* Expand/object.scm 560 */
					       obj_t arg1922_1338;
					       obj_t arg1923_1339;
					       {	/* Expand/object.scm 560 */
						  obj_t arg1924_1340;
						  obj_t arg1925_1341;
						  arg1924_1340 =
						     CNST_TABLE_REF(((long) 16));
						  {	/* Expand/object.scm 560 */
						     obj_t arg1926_1342;
						     obj_t arg1927_1343;
						     arg1926_1342 =
							CNST_TABLE_REF(((long) 17));
						     {	/* ./Ieee/pair-list.scm 5689 */
							obj_t aux_3819;
							aux_3819 =
							   CNST_TABLE_REF(((long) 18));
							arg1927_1343 =
							   MAKE_PAIR(aux_3819, BNIL);
						     }
						     arg1925_1341 =
							MAKE_PAIR(arg1926_1342, arg1927_1343);
						  }
						  arg1922_1338 =
						     MAKE_PAIR(arg1924_1340, arg1925_1341);
					       }
					       {	/* Expand/object.scm 562 */
						  obj_t arg1928_1344;
						  {	/* Expand/object.scm 562 */
						     obj_t arg1929_1345;
						     {	/* Expand/object.scm 562 */
							obj_t arg1931_1347;
							obj_t arg1932_1348;
							{	/* Expand/object.scm 562 */
							   obj_t arg1933_1349;
							   obj_t arg1934_1350;
							   arg1933_1349 =
							      CNST_TABLE_REF(((long) 16));
							   {	/* Expand/object.scm 562 */
							      obj_t arg1935_1351;
							      obj_t arg1936_1352;
							      arg1935_1351 =
								 CNST_TABLE_REF(((long) 19));
							      {		/* ./Ieee/pair-list.scm 5689 */
								 obj_t aux_3826;
								 aux_3826 =
								    CNST_TABLE_REF(((long) 18));
								 arg1936_1352 =
								    MAKE_PAIR(aux_3826, BNIL);
							      }
							      arg1934_1350 =
								 MAKE_PAIR(arg1935_1351, arg1936_1352);
							   }
							   arg1931_1347 =
							      MAKE_PAIR(arg1933_1349, arg1934_1350);
							}
							{	/* Expand/object.scm 563 */
							   obj_t arg1937_1353;
							   {	/* Expand/object.scm 563 */
							      obj_t arg1939_1355;
							      obj_t arg1940_1356;
							      {		/* Expand/object.scm 563 */
								 obj_t arg1941_1357;
								 obj_t arg1942_1358;
								 arg1941_1357 =
								    CNST_TABLE_REF(((long) 16));
								 {	/* Expand/object.scm 563 */
								    obj_t arg1943_1359;
								    obj_t arg1944_1360;
								    arg1943_1359 =
								       CNST_TABLE_REF(((long) 24));
								    {	/* ./Ieee/pair-list.scm 5689 */
								       obj_t aux_3833;
								       aux_3833 =
									  CNST_TABLE_REF(((long) 18));
								       arg1944_1360 =
									  MAKE_PAIR(aux_3833, BNIL);
								    }
								    arg1942_1358 =
								       MAKE_PAIR(arg1943_1359, arg1944_1360);
								 }
								 arg1939_1355 =
								    MAKE_PAIR(arg1941_1357, arg1942_1358);
							      }
							      {		/* Expand/object.scm 564 */
								 obj_t arg1945_1361;
								 {	/* Expand/object.scm 564 */
								    obj_t arg1948_1363;
								    obj_t arg1949_1364;
								    {	/* Expand/object.scm 564 */
								       obj_t arg1950_1365;
								       obj_t arg1951_1366;
								       arg1950_1365 =
									  CNST_TABLE_REF(((long) 16));
								       {	/* Expand/object.scm 564 */
									  obj_t arg1952_1367;
									  obj_t arg1953_1368;
									  arg1952_1367 =
									     CNST_TABLE_REF(((long) 25));
									  {	/* ./Ieee/pair-list.scm 5689 */
									     obj_t aux_3840;
									     aux_3840 =
										CNST_TABLE_REF(((long) 18));
									     arg1953_1368 =
										MAKE_PAIR(aux_3840, BNIL);
									  }
									  arg1951_1366 =
									     MAKE_PAIR(arg1952_1367, arg1953_1368);
								       }
								       arg1948_1363 =
									  MAKE_PAIR(arg1950_1365, arg1951_1366);
								    }
								    arg1949_1364 =
								       MAKE_PAIR(newo_1259, BNIL);
								    arg1945_1361 =
								       MAKE_PAIR(arg1948_1363, arg1949_1364);
								 }
								 arg1940_1356 =
								    MAKE_PAIR(arg1945_1361, BNIL);
							      }
							      arg1937_1353 =
								 MAKE_PAIR(arg1939_1355, arg1940_1356);
							   }
							   arg1932_1348 =
							      MAKE_PAIR(arg1937_1353, BNIL);
							}
							arg1929_1345 =
							   MAKE_PAIR(arg1931_1347, arg1932_1348);
						     }
						     arg1928_1344 =
							MAKE_PAIR(arg1929_1345, BNIL);
						  }
						  arg1923_1339 =
						     MAKE_PAIR(newo_1259, arg1928_1344);
					       }
					       arg1920_1336 =
						  MAKE_PAIR(arg1922_1338, arg1923_1339);
					    }
					    {	/* Expand/object.scm 565 */
					       obj_t arg1954_1369;
					       obj_t arg1955_1370;
					       {	/* Expand/object.scm 565 */
						  obj_t arg1956_1371;
						  obj_t arg1957_1372;
						  arg1956_1371 =
						     CNST_TABLE_REF(((long) 15));
						  {	/* Expand/object.scm 565 */
						     obj_t arg1958_1373;
						     arg1958_1373 =
							MAKE_PAIR(BFALSE, BNIL);
						     arg1957_1372 =
							MAKE_PAIR(newo_1259, arg1958_1373);
						  }
						  arg1954_1369 =
						     MAKE_PAIR(arg1956_1371, arg1957_1372);
					       }
					       arg1955_1370 =
						  MAKE_PAIR(newo_1259, BNIL);
					       arg1921_1337 =
						  MAKE_PAIR(arg1954_1369, arg1955_1370);
					    }
					    arg1919_1335 =
					       MAKE_PAIR(arg1920_1336, arg1921_1337);
					 }
					 arg1915_1332 =
					    MAKE_PAIR(arg1917_1334, arg1919_1335);
				      }
				      {		/* Expand/object.scm 567 */
					 obj_t arg1959_1374;
					 {	/* Expand/object.scm 567 */
					    obj_t arg1961_1376;
					    obj_t arg1962_1377;
					    arg1961_1376 =
					       CNST_TABLE_REF(((long) 27));
					    {	/* Expand/object.scm 567 */
					       obj_t arg1964_1379;
					       {	/* Expand/object.scm 567 */
						  obj_t arg1966_1381;
						  arg1966_1381 =
						     MAKE_PAIR(newo_1259, BNIL);
						  arg1964_1379 =
						     MAKE_PAIR(string2056_expand_object, arg1966_1381);
					       }
					       arg1962_1377 =
						  MAKE_PAIR(string2057_expand_object, arg1964_1379);
					    }
					    arg1959_1374 =
					       MAKE_PAIR(arg1961_1376, arg1962_1377);
					 }
					 arg1916_1333 =
					    MAKE_PAIR(arg1959_1374, BNIL);
				      }
				      arg1912_1329 =
					 MAKE_PAIR(arg1915_1332, arg1916_1333);
				   }
				   arg1909_1327 =
				      MAKE_PAIR(arg1910_1328, arg1912_1329);
				}
				arg1905_1324 =
				   MAKE_PAIR(arg1907_1326, arg1909_1327);
			     }
			     {	/* Expand/object.scm 568 */
				obj_t arg1967_1382;
				{	/* Expand/object.scm 568 */
				   obj_t arg1969_1384;
				   obj_t arg1970_1385;
				   arg1969_1384 =
				      CNST_TABLE_REF(((long) 27));
				   {	/* Expand/object.scm 568 */
				      obj_t arg1972_1387;
				      {		/* Expand/object.scm 568 */
					 obj_t arg1974_1389;
					 arg1974_1389 =
					    MAKE_PAIR(newo_1259, BNIL);
					 arg1972_1387 =
					    MAKE_PAIR(string2056_expand_object, arg1974_1389);
				      }
				      arg1970_1385 =
					 MAKE_PAIR(string2057_expand_object, arg1972_1387);
				   }
				   arg1967_1382 =
				      MAKE_PAIR(arg1969_1384, arg1970_1385);
				}
				arg1906_1325 =
				   MAKE_PAIR(arg1967_1382, BNIL);
			     }
			     arg1902_1321 =
				MAKE_PAIR(arg1905_1324, arg1906_1325);
			  }
			  arg1900_1319 =
			     MAKE_PAIR(arg1901_1320, arg1902_1321);
		       }
		       arg1897_1316 =
			  MAKE_PAIR(arg1899_1318, arg1900_1319);
		    }
		    arg1891_1310 =
		       MAKE_PAIR(arg1897_1316, BNIL);
		 }
		 arg1889_1308 =
		    MAKE_PAIR(arg1890_1309, arg1891_1310);
	      }
	      return
		 MAKE_PAIR(arg1888_1307, arg1889_1308);
	   }
      }
   }
}



/* make-virtual-set */
obj_t 
make_virtual_set_218_expand_object(obj_t slot_99, obj_t value_100, obj_t var_101, obj_t class_102, obj_t form_103, char *alloc_kind_252_104)
{
   AN_OBJECT;
   {	/* Expand/object.scm 573 */
      {		/* Expand/object.scm 574 */
	 bool_t test_3883;
	 {	/* ./Llib/struct.scm 1457 */
	    obj_t aux_3884;
	    aux_3884 =
	       STRUCT_REF(slot_99, ((long) 7));
	    test_3883 =
	       CBOOL(aux_3884);
	 }
	 if (test_3883)
	   {	/* Expand/object.scm 576 */
	      obj_t arg1979_1392;
	      {		/* Expand/object.scm 576 */
		 obj_t arg1981_1394;
		 {	/* Expand/object.scm 576 */
		    obj_t arg1982_1395;
		    {	/* Expand/object.scm 576 */
		       obj_t arg1984_1397;
		       {	/* Expand/object.scm 577 */
			  obj_t arg1985_1398;
			  {	/* ./Ieee/symbol.scm 6021 */
			     obj_t aux_3887;
			     aux_3887 =
				STRUCT_REF(slot_99, ((long) 0));
			     arg1985_1398 =
				SYMBOL_TO_STRING(aux_3887);
			  }
			  arg1984_1397 =
			     string_append(arg1985_1398, string2041_expand_object);
		       }
		       arg1982_1395 =
			  string_append(string2058_expand_object, arg1984_1397);
		    }
		    {	/* Expand/object.scm 576 */
		       obj_t aux_3892;
		       aux_3892 =
			  string_to_bstring(alloc_kind_252_104);
		       arg1981_1394 =
			  string_append(aux_3892, arg1982_1395);
		    }
		 }
		 arg1979_1392 =
		    string_append(string2059_expand_object, arg1981_1394);
	      }
	      FAILURE(BFALSE, arg1979_1392, form_103);
	   }
	 else
	   {	/* Expand/object.scm 581 */
	      obj_t arg1988_1401;
	      {		/* Expand/object.scm 581 */
		 obj_t arg1989_1402;
		 obj_t arg1990_1403;
		 {	/* Expand/object.scm 581 */
		    obj_t arg1991_1404;
		    obj_t arg1992_1405;
		    obj_t arg1993_1406;
		    {	/* Expand/object.scm 581 */
		       type_bglt obj_2576;
		       obj_2576 =
			  (type_bglt) (class_102);
		       arg1991_1404 =
			  (((type_bglt) CREF(obj_2576))->id);
		    }
		    arg1992_1405 =
		       CNST_TABLE_REF(((long) 2));
		    arg1993_1406 =
		       STRUCT_REF(slot_99, ((long) 0));
		    {	/* Expand/object.scm 581 */
		       obj_t list1995_1408;
		       {	/* Expand/object.scm 581 */
			  obj_t arg1996_1409;
			  {	/* Expand/object.scm 581 */
			     obj_t arg1997_1410;
			     {	/* Expand/object.scm 581 */
				obj_t arg1998_1411;
				{	/* Expand/object.scm 581 */
				   obj_t aux_3901;
				   aux_3901 =
				      CNST_TABLE_REF(((long) 3));
				   arg1998_1411 =
				      MAKE_PAIR(aux_3901, BNIL);
				}
				arg1997_1410 =
				   MAKE_PAIR(arg1993_1406, arg1998_1411);
			     }
			     arg1996_1409 =
				MAKE_PAIR(arg1992_1405, arg1997_1410);
			  }
			  list1995_1408 =
			     MAKE_PAIR(arg1991_1404, arg1996_1409);
		       }
		       arg1989_1402 =
			  symbol_append_197___r4_symbols_6_4(list1995_1408);
		    }
		 }
		 {	/* Expand/object.scm 581 */
		    obj_t arg1999_1412;
		    arg1999_1412 =
		       MAKE_PAIR(value_100, BNIL);
		    arg1990_1403 =
		       MAKE_PAIR(var_101, arg1999_1412);
		 }
		 arg1988_1401 =
		    MAKE_PAIR(arg1989_1402, arg1990_1403);
	      }
	      return
		 object_epairify_147_expand_object(arg1988_1401, value_100);
	   }
      }
   }
}



/* object-epairify */
obj_t 
object_epairify_147_expand_object(obj_t obj_105, obj_t epair_106)
{
   AN_OBJECT;
   {	/* Expand/object.scm 589 */
    object_epairify_147_expand_object:
      {		/* Expand/object.scm 590 */
	 bool_t test2000_1413;
	 test2000_1413 =
	    EXTENDED_PAIRP(epair_106);
	 if (test2000_1413)
	   {	/* Expand/object.scm 590 */
	      if (
		 PAIRP(obj_105))
		{	/* Expand/object.scm 592 */
		   obj_t arg2002_1415;
		   obj_t arg2003_1416;
		   obj_t arg2004_1417;
		   arg2002_1415 =
		      CAR(obj_105);
		   arg2003_1416 =
		      CDR(obj_105);
		   {	/* ./Ieee/pair-list.scm 5713 */
		      bool_t test1136_2591;
		      test1136_2591 =
			 EXTENDED_PAIRP(epair_106);
		      if (test1136_2591)
			{	/* ./Ieee/pair-list.scm 5713 */
			   arg2004_1417 =
			      CER(epair_106);
			}
		      else
			{	/* ./Ieee/pair-list.scm 5713 */
			   FAILURE(string2060_expand_object, string2061_expand_object, epair_106);
			}
		   }
		   return
		      MAKE_EXTENDED_PAIR(arg2002_1415, arg2003_1416, arg2004_1417);
		}
	      else
		{	/* Expand/object.scm 593 */
		   obj_t arg2005_1418;
		   {	/* Expand/object.scm 593 */
		      obj_t arg2006_1419;
		      obj_t arg2007_1420;
		      arg2006_1419 =
			 CNST_TABLE_REF(((long) 26));
		      arg2007_1420 =
			 MAKE_PAIR(obj_105, BNIL);
		      arg2005_1418 =
			 MAKE_PAIR(arg2006_1419, arg2007_1420);
		   }
		   {
		      obj_t obj_3926;
		      obj_3926 = arg2005_1418;
		      obj_105 = obj_3926;
		      goto object_epairify_147_expand_object;
		   }
		}
	   }
	 else
	   {	/* Expand/object.scm 590 */
	      return obj_105;
	   }
      }
   }
}



/* method-init */
obj_t 
method_init_76_expand_object()
{
   AN_OBJECT;
   {	/* Expand/object.scm 14 */
      return BUNSPEC;
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_expand_object()
{
   AN_OBJECT;
   {	/* Expand/object.scm 14 */
      module_initialization_70_tools_args(((long) 0), "EXPAND_OBJECT");
      module_initialization_70_tools_progn(((long) 0), "EXPAND_OBJECT");
      module_initialization_70_tools_misc(((long) 0), "EXPAND_OBJECT");
      module_initialization_70_type_type(((long) 0), "EXPAND_OBJECT");
      module_initialization_70_type_env(((long) 0), "EXPAND_OBJECT");
      module_initialization_70_expand_eps(((long) 0), "EXPAND_OBJECT");
      module_initialization_70_engine_param(((long) 0), "EXPAND_OBJECT");
      module_initialization_70_ast_var(((long) 0), "EXPAND_OBJECT");
      module_initialization_70_ast_ident(((long) 0), "EXPAND_OBJECT");
      module_initialization_70_object_class(((long) 0), "EXPAND_OBJECT");
      return
	 module_initialization_70_tools_location(((long) 0), "EXPAND_OBJECT");
   }
}
