/*===========================================================================*/
/*   (Fail/walk.scm)                                                         */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;


static obj_t method_init_76_fail_walk();
extern obj_t make_box_202_ast_node;
extern obj_t funcall_ast_node;
extern long add_inlined_method__244___object(obj_t, obj_t, long);
extern obj_t current_error_port;
extern obj_t fail_ast_node;
extern obj_t _nb_error_on_pass__70_tools_error;
extern obj_t box_ref_242_ast_node;
extern obj_t leave_function_170_tools_error();
extern obj_t sequence_ast_node;
extern obj_t let_var_6_ast_node;
extern obj_t var_ast_node;
static obj_t fail_fun__97_fail_walk(obj_t);
extern obj_t location_full_fname_231_tools_location(obj_t);
extern obj_t pragma_ast_node;
extern obj_t set_ex_it_116_ast_node;
extern obj_t verbose_tools_speek(obj_t, obj_t);
static obj_t _error__173_fail_walk = BUNSPEC;
extern obj_t module_initialization_70_fail_walk(long, char *);
extern obj_t module_initialization_70_tools_speek(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_engine_pass(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_location(long, char *);
extern obj_t module_initialization_70_ast_sexp(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_numbers_6_5(long, char *);
extern obj_t module_initialization_70___r4_output_6_10_3(long, char *);
static obj_t _fail_node_1723_182_fail_walk(obj_t, obj_t);
extern obj_t display_2_122___r4_output_6_10_3(obj_t, obj_t);
extern obj_t let_fun_218_ast_node;
static obj_t _fail_node__default1457_120_fail_walk(obj_t, obj_t);
static obj_t fail_node___231_fail_walk(obj_t);
static obj_t imported_modules_init_94_fail_walk();
extern obj_t app_ly_162_ast_node;
extern obj_t add_generic__110___object(obj_t, obj_t);
extern obj_t fail_walk__172_fail_walk(obj_t);
extern obj_t app_ast_node;
static obj_t library_modules_init_112_fail_walk();
extern obj_t atom_ast_node;
static obj_t toplevel_init_63_fail_walk();
extern node_bglt sexp__node_235_ast_sexp(obj_t, obj_t, obj_t, obj_t);
static node_bglt fail_node__137_fail_walk(node_bglt);
extern obj_t jump_ex_it_184_ast_node;
extern obj_t open_input_string(obj_t);
extern obj_t kwote_ast_node;
extern obj_t setq_ast_node;
extern obj_t box_set__221_ast_node;
extern obj_t string_to_bstring(char *);
extern obj_t enter_function_81_tools_error(obj_t);
extern obj_t internal_error_43_tools_error(obj_t, obj_t, obj_t);
static obj_t _fail_walk__150_fail_walk(obj_t, obj_t);
extern obj_t _classes__134___object;
extern obj_t select_ast_node;
extern bool_t _2__206___r4_numbers_6_5(obj_t, obj_t);
extern obj_t read___reader(obj_t);
static node_bglt fail_node__default1457_45_fail_walk(node_bglt);
static obj_t require_initialization_114_fail_walk = BUNSPEC;
extern obj_t conditional_ast_node;
static obj_t cnst_init_137_fail_walk();
extern obj_t _current_pass__25_engine_pass;
static obj_t __cnst[6];

DEFINE_STATIC_PROCEDURE(fail_node__default1457_env_125_fail_walk, _fail_node__default1457_120_fail_walk1736, _fail_node__default1457_120_fail_walk, 0L, 1);
DEFINE_EXPORT_PROCEDURE(fail_walk__env_224_fail_walk, _fail_walk__150_fail_walk1737, _fail_walk__150_fail_walk, 0L, 1);
DEFINE_STRING(string1731_fail_walk, string1731_fail_walk1738, "FAIL-NODE!-DEFAULT1457 VALUE DEBUG-ERROR/LOCATION LOCATION DONE PASS-STARTED ", 77);
DEFINE_STRING(string1729_fail_walk, string1729_fail_walk1739, "failure during postlude hook", 28);
DEFINE_STRING(string1730_fail_walk, string1730_fail_walk1740, "No method for this object", 25);
DEFINE_STRING(string1728_fail_walk, string1728_fail_walk1741, " occured, ending ...", 20);
DEFINE_STRING(string1727_fail_walk, string1727_fail_walk1742, " error", 6);
DEFINE_STRING(string1726_fail_walk, string1726_fail_walk1743, "failure during prelude hook", 27);
DEFINE_STRING(string1725_fail_walk, string1725_fail_walk1744, "   . ", 5);
DEFINE_STRING(string1724_fail_walk, string1724_fail_walk1745, "Fail", 4);
DEFINE_STATIC_GENERIC(fail_node__env_77_fail_walk, _fail_node_1723_182_fail_walk1746, _fail_node_1723_182_fail_walk, 0L, 1);



/* module-initialization */
obj_t 
module_initialization_70_fail_walk(long checksum_1455, char *from_1456)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_fail_walk))
	{
	   require_initialization_114_fail_walk =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_fail_walk();
	   cnst_init_137_fail_walk();
	   imported_modules_init_94_fail_walk();
	   method_init_76_fail_walk();
	   toplevel_init_63_fail_walk();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_fail_walk()
{
   AN_OBJECT;
   {	/* Fail/walk.scm 14 */
      module_initialization_70___object(((long) 0), "FAIL_WALK");
      module_initialization_70___r4_output_6_10_3(((long) 0), "FAIL_WALK");
      module_initialization_70___r4_numbers_6_5(((long) 0), "FAIL_WALK");
      module_initialization_70___reader(((long) 0), "FAIL_WALK");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_fail_walk()
{
   AN_OBJECT;
   {	/* Fail/walk.scm 14 */
      {		/* Fail/walk.scm 14 */
	 obj_t cnst_port_138_1448;
	 cnst_port_138_1448 =
	    open_input_string(string1731_fail_walk);
	 {
	    long i_1449;
	    i_1449 = ((long) 5);
	  loop_1450:
	    {	/* Fail/walk.scm 14 */
	       bool_t test1732_1451;
	       test1732_1451 =
		  (i_1449 == ((long) -1));
	       if (test1732_1451)
		 {	/* Fail/walk.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Fail/walk.scm 14 */
		    {	/* Fail/walk.scm 14 */
		       obj_t arg1733_1452;
		       {	/* Fail/walk.scm 14 */
			  obj_t list1734_1453;
			  list1734_1453 =
			     MAKE_PAIR(cnst_port_138_1448, BNIL);
			  arg1733_1452 =
			     read___reader(list1734_1453);
		       }
		       CNST_TABLE_SET(i_1449, arg1733_1452);
		    }
		    {	/* Fail/walk.scm 14 */
		       int aux_1454;
		       {	/* Fail/walk.scm 14 */
			  long aux_1475;
			  aux_1475 =
			     (i_1449 - ((long) 1));
			  aux_1454 =
			     (int) (aux_1475);
		       }
		       {
			  long i_1478;
			  i_1478 =
			     (long) (aux_1454);
			  i_1449 = i_1478;
			  goto loop_1450;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_fail_walk()
{
   AN_OBJECT;
   {	/* Fail/walk.scm 14 */
      _error__173_fail_walk = BUNSPEC;
      return BUNSPEC;
   }
}



/* fail-walk! */
obj_t 
fail_walk__172_fail_walk(obj_t globals_15)
{
   AN_OBJECT;
   {	/* Fail/walk.scm 32 */
      {		/* Fail/walk.scm 32 */
	 obj_t list1505_744;
	 {	/* Fail/walk.scm 32 */
	    obj_t arg1508_746;
	    {	/* Fail/walk.scm 32 */
	       obj_t arg1510_748;
	       {	/* Fail/walk.scm 32 */
		  obj_t aux_1480;
		  aux_1480 =
		     BCHAR(((unsigned char) '\n'));
		  arg1510_748 =
		     MAKE_PAIR(aux_1480, BNIL);
	       }
	       arg1508_746 =
		  MAKE_PAIR(string1724_fail_walk, arg1510_748);
	    }
	    list1505_744 =
	       MAKE_PAIR(string1725_fail_walk, arg1508_746);
	 }
	 verbose_tools_speek(
	    BINT(((long) 1)), list1505_744);
      }
      _nb_error_on_pass__70_tools_error =
	 BINT(((long) 0));
      _current_pass__25_engine_pass = string1724_fail_walk;
      {
	 obj_t hooks_749;
	 obj_t hnames_750;
	 hooks_749 = BNIL;
	 hnames_750 = BNIL;
       loop_751:
	 if (
	    NULLP(hooks_749))
	   {	/* Fail/walk.scm 32 */
	      CNST_TABLE_REF(((long) 0));
	   }
	 else
	   {	/* Fail/walk.scm 32 */
	      bool_t test1515_756;
	      {		/* Fail/walk.scm 32 */
		 obj_t fun1522_762;
		 fun1522_762 =
		    CAR(hooks_749);
		 {	/* Fail/walk.scm 32 */
		    obj_t aux_1492;
		    aux_1492 =
		       PROCEDURE_ENTRY(fun1522_762) (fun1522_762, BEOA);
		    test1515_756 =
		       CBOOL(aux_1492);
		 }
	      }
	      if (test1515_756)
		{	/* Fail/walk.scm 32 */
		   {
		      obj_t hnames_1499;
		      obj_t hooks_1497;
		      hooks_1497 =
			 CDR(hooks_749);
		      hnames_1499 =
			 CDR(hnames_750);
		      hnames_750 = hnames_1499;
		      hooks_749 = hooks_1497;
		      goto loop_751;
		   }
		}
	      else
		{	/* Fail/walk.scm 32 */
		   internal_error_43_tools_error(string1724_fail_walk, string1726_fail_walk,
		      CAR(hnames_750));
		}
	   }
      }
      {
	 obj_t l1437_763;
	 l1437_763 = globals_15;
       lname1438_764:
	 if (
	    PAIRP(l1437_763))
	   {	/* Fail/walk.scm 34 */
	      fail_fun__97_fail_walk(
		 CAR(l1437_763));
	      {
		 obj_t l1437_1507;
		 l1437_1507 =
		    CDR(l1437_763);
		 l1437_763 = l1437_1507;
		 goto lname1438_764;
	      }
	   }
	 else
	   {	/* Fail/walk.scm 34 */
	      ((bool_t) 1);
	   }
      }
      {		/* Fail/walk.scm 35 */
	 bool_t test1527_769;
	 {	/* Fail/walk.scm 35 */
	    long n1_1281;
	    n1_1281 =
	       (long) CINT(_nb_error_on_pass__70_tools_error);
	    test1527_769 =
	       (n1_1281 > ((long) 0));
	 }
	 if (test1527_769)
	   {	/* Fail/walk.scm 35 */
	      display_2_122___r4_output_6_10_3(_nb_error_on_pass__70_tools_error, current_error_port);
	      display_2_122___r4_output_6_10_3(string1727_fail_walk, current_error_port);
	      {		/* Fail/walk.scm 35 */
		 char *arg1528_771;
		 {	/* Fail/walk.scm 35 */
		    bool_t test1529_772;
		    {	/* Fail/walk.scm 35 */
		       bool_t test1530_773;
		       {	/* Fail/walk.scm 35 */
			  obj_t obj_1283;
			  obj_1283 = _nb_error_on_pass__70_tools_error;
			  test1530_773 =
			     INTEGERP(obj_1283);
		       }
		       if (test1530_773)
			 {	/* Fail/walk.scm 35 */
			    test1529_772 =
			       _2__206___r4_numbers_6_5(_nb_error_on_pass__70_tools_error,
			       BINT(((long) 1)));
			 }
		       else
			 {	/* Fail/walk.scm 35 */
			    test1529_772 = ((bool_t) 0);
			 }
		    }
		    if (test1529_772)
		      {		/* Fail/walk.scm 35 */
			 arg1528_771 = "s";
		      }
		    else
		      {		/* Fail/walk.scm 35 */
			 arg1528_771 = "";
		      }
		 }
		 display_2_122___r4_output_6_10_3(
		    string_to_bstring(arg1528_771), current_error_port);
	      }
	      display_2_122___r4_output_6_10_3(string1728_fail_walk, current_error_port);
	      WRITE_CHAR(((unsigned char) '\n'), current_error_port);
	      {		/* Fail/walk.scm 35 */
		 obj_t res1721_1286;
		 exit(((long) -1));
		 res1721_1286 =
		    BINT(((long) -1));
		 return res1721_1286;
	      }
	   }
	 else
	   {
	      obj_t hooks_774;
	      obj_t hnames_775;
	      hooks_774 = BNIL;
	      hnames_775 = BNIL;
	    loop_776:
	      if (
		 NULLP(hooks_774))
		{	/* Fail/walk.scm 35 */
		   return globals_15;
		}
	      else
		{	/* Fail/walk.scm 35 */
		   bool_t test1536_781;
		   {	/* Fail/walk.scm 35 */
		      obj_t fun1543_786;
		      fun1543_786 =
			 CAR(hooks_774);
		      {		/* Fail/walk.scm 35 */
			 obj_t aux_1528;
			 aux_1528 =
			    PROCEDURE_ENTRY(fun1543_786) (fun1543_786, BEOA);
			 test1536_781 =
			    CBOOL(aux_1528);
		      }
		   }
		   if (test1536_781)
		     {	/* Fail/walk.scm 35 */
			{
			   obj_t hnames_1535;
			   obj_t hooks_1533;
			   hooks_1533 =
			      CDR(hooks_774);
			   hnames_1535 =
			      CDR(hnames_775);
			   hnames_775 = hnames_1535;
			   hooks_774 = hooks_1533;
			   goto loop_776;
			}
		     }
		   else
		     {	/* Fail/walk.scm 35 */
			return
			   internal_error_43_tools_error(_current_pass__25_engine_pass, string1729_fail_walk,
			   CAR(hnames_775));
		     }
		}
	   }
      }
   }
}



/* _fail-walk! */
obj_t 
_fail_walk__150_fail_walk(obj_t env_1441, obj_t globals_1442)
{
   AN_OBJECT;
   {	/* Fail/walk.scm 32 */
      return
	 fail_walk__172_fail_walk(globals_1442);
   }
}



/* fail-fun! */
obj_t 
fail_fun__97_fail_walk(obj_t var_16)
{
   AN_OBJECT;
   {	/* Fail/walk.scm 40 */
      {		/* Fail/walk.scm 41 */
	 value_bglt fun_787;
	 {	/* Fail/walk.scm 41 */
	    variable_bglt obj_1293;
	    obj_1293 =
	       (variable_bglt) (var_16);
	    fun_787 =
	       (((variable_bglt) CREF(obj_1293))->value);
	 }
	 {	/* Fail/walk.scm 41 */
	    obj_t body_788;
	    {	/* Fail/walk.scm 42 */
	       sfun_bglt obj_1294;
	       obj_1294 =
		  (sfun_bglt) (fun_787);
	       body_788 =
		  (((sfun_bglt) CREF(obj_1294))->body);
	    }
	    {	/* Fail/walk.scm 43 */

	       {	/* Fail/walk.scm 44 */
		  obj_t aux_1544;
		  {	/* Fail/walk.scm 44 */
		     variable_bglt obj_1296;
		     obj_1296 =
			(variable_bglt) (var_16);
		     aux_1544 =
			(((variable_bglt) CREF(obj_1296))->id);
		  }
		  enter_function_81_tools_error(aux_1544);
	       }
	       {	/* Fail/walk.scm 45 */
		  node_bglt arg1545_791;
		  arg1545_791 =
		     fail_node__137_fail_walk(
		     (node_bglt) (body_788));
		  {	/* Fail/walk.scm 45 */
		     sfun_bglt obj_1297;
		     obj_t val1123_1298;
		     obj_1297 =
			(sfun_bglt) (fun_787);
		     val1123_1298 =
			(obj_t) (arg1545_791);
		     ((((sfun_bglt) CREF(obj_1297))->body) = ((obj_t) val1123_1298), BUNSPEC);
		  }
	       }
	       return
		  leave_function_170_tools_error();
	    }
	 }
      }
   }
}



/* fail-node*! */
obj_t 
fail_node___231_fail_walk(obj_t node__221_38)
{
   AN_OBJECT;
   {	/* Fail/walk.scm 218 */
    fail_node___231_fail_walk:
      if (
	 NULLP(node__221_38))
	{	/* Fail/walk.scm 219 */
	   return
	      CNST_TABLE_REF(((long) 1));
	}
      else
	{	/* Fail/walk.scm 219 */
	   {	/* Fail/walk.scm 222 */
	      node_bglt arg1547_793;
	      {		/* Fail/walk.scm 222 */
		 node_bglt aux_1557;
		 {	/* Fail/walk.scm 222 */
		    obj_t aux_1558;
		    aux_1558 =
		       CAR(node__221_38);
		    aux_1557 =
		       (node_bglt) (aux_1558);
		 }
		 arg1547_793 =
		    fail_node__137_fail_walk(aux_1557);
	      }
	      {		/* ./Ieee/pair-list.scm 5890 */
		 obj_t aux_1562;
		 aux_1562 =
		    (obj_t) (arg1547_793);
		 SET_CAR(node__221_38, aux_1562);
	      }
	   }
	   {
	      obj_t node__221_1565;
	      node__221_1565 =
		 CDR(node__221_38);
	      node__221_38 = node__221_1565;
	      goto fail_node___231_fail_walk;
	   }
	}
   }
}



/* method-init */
obj_t 
method_init_76_fail_walk()
{
   AN_OBJECT;
   {	/* Fail/walk.scm 14 */
      add_generic__110___object(fail_node__env_77_fail_walk, fail_node__default1457_env_125_fail_walk);
      add_inlined_method__244___object(fail_node__env_77_fail_walk, atom_ast_node, ((long) 0));
      add_inlined_method__244___object(fail_node__env_77_fail_walk, kwote_ast_node, ((long) 1));
      add_inlined_method__244___object(fail_node__env_77_fail_walk, var_ast_node, ((long) 2));
      add_inlined_method__244___object(fail_node__env_77_fail_walk, sequence_ast_node, ((long) 3));
      add_inlined_method__244___object(fail_node__env_77_fail_walk, app_ast_node, ((long) 4));
      add_inlined_method__244___object(fail_node__env_77_fail_walk, app_ly_162_ast_node, ((long) 5));
      add_inlined_method__244___object(fail_node__env_77_fail_walk, funcall_ast_node, ((long) 6));
      add_inlined_method__244___object(fail_node__env_77_fail_walk, pragma_ast_node, ((long) 7));
      add_inlined_method__244___object(fail_node__env_77_fail_walk, setq_ast_node, ((long) 8));
      add_inlined_method__244___object(fail_node__env_77_fail_walk, conditional_ast_node, ((long) 9));
      add_inlined_method__244___object(fail_node__env_77_fail_walk, fail_ast_node, ((long) 10));
      add_inlined_method__244___object(fail_node__env_77_fail_walk, select_ast_node, ((long) 11));
      add_inlined_method__244___object(fail_node__env_77_fail_walk, let_fun_218_ast_node, ((long) 12));
      add_inlined_method__244___object(fail_node__env_77_fail_walk, let_var_6_ast_node, ((long) 13));
      add_inlined_method__244___object(fail_node__env_77_fail_walk, set_ex_it_116_ast_node, ((long) 14));
      add_inlined_method__244___object(fail_node__env_77_fail_walk, jump_ex_it_184_ast_node, ((long) 15));
      add_inlined_method__244___object(fail_node__env_77_fail_walk, make_box_202_ast_node, ((long) 16));
      add_inlined_method__244___object(fail_node__env_77_fail_walk, box_ref_242_ast_node, ((long) 17));
      {		/* Fail/walk.scm 14 */
	 long aux_1586;
	 aux_1586 =
	    add_inlined_method__244___object(fail_node__env_77_fail_walk, box_set__221_ast_node, ((long) 18));
	 return
	    BINT(aux_1586);
      }
   }
}



/* fail-node! */
node_bglt 
fail_node__137_fail_walk(node_bglt node_17)
{
   AN_OBJECT;
   {	/* Fail/walk.scm 51 */
      {
	 obj_t method1626_1126;
	 obj_t class1631_1127;
	 {	/* Fail/walk.scm 51 */
	    obj_t arg1634_1124;
	    obj_t arg1635_1125;
	    {	/* Fail/walk.scm 51 */
	       object_bglt obj_1304;
	       obj_1304 =
		  (object_bglt) (node_17);
	       {	/* ./Llib/object.scm 2926 */
		  obj_t pre_method_105_1305;
		  pre_method_105_1305 =
		     PROCEDURE_REF(fail_node__env_77_fail_walk, ((long) 2));
		  if (
		     INTEGERP(pre_method_105_1305))
		    {	/* ./Llib/object.scm 2927 */
		       PROCEDURE_SET(fail_node__env_77_fail_walk, ((long) 2), BUNSPEC);
		       arg1634_1124 = pre_method_105_1305;
		    }
		  else
		    {	/* ./Llib/object.scm 2914 */
		       long obj_class_num_177_1310;
		       obj_class_num_177_1310 =
			  TYPE(obj_1304);
		       {	/* ./Llib/object.scm 2915 */
			  obj_t arg1176_1311;
			  arg1176_1311 =
			     PROCEDURE_REF(fail_node__env_77_fail_walk, ((long) 1));
			  {	/* ./Llib/object.scm 2738 */
			     long arg1177_1315;
			     {	/* ./Llib/object.scm 2738 */
				long arg1178_1316;
				arg1178_1316 =
				   OBJECT_TYPE;
				arg1177_1315 =
				   (obj_class_num_177_1310 - arg1178_1316);
			     }
			     arg1634_1124 =
				VECTOR_REF(arg1176_1311, arg1177_1315);
			  }
		       }
		    }
	       }
	    }
	    {	/* Fail/walk.scm 51 */
	       object_bglt object_1321;
	       object_1321 =
		  (object_bglt) (node_17);
	       {	/* ./Llib/object.scm 2695 */
		  long arg1179_1322;
		  {	/* ./Llib/object.scm 2695 */
		     long arg1180_1323;
		     long arg1181_1324;
		     arg1180_1323 =
			TYPE(object_1321);
		     arg1181_1324 =
			OBJECT_TYPE;
		     arg1179_1322 =
			(arg1180_1323 - arg1181_1324);
		  }
		  {	/* ./Llib/object.scm 2695 */
		     obj_t vector_1328;
		     vector_1328 = _classes__134___object;
		     arg1635_1125 =
			VECTOR_REF(vector_1328, arg1179_1322);
		  }
	       }
	    }
	    {	/* Fail/walk.scm 51 */
	       obj_t aux_1604;
	       method1626_1126 = arg1634_1124;
	       class1631_1127 = arg1635_1125;
	       {

		  if (
		     INTEGERP(method1626_1126))
		    {	/* Fail/walk.scm 51 */
		       switch (
			  (long) CINT(method1626_1126))
			 {
			 case ((long) 0):

			    {	/* Fail/walk.scm 51 */
			       atom_bglt aux_1607;
			       aux_1607 =
				  (atom_bglt) (node_17);
			       aux_1604 =
				  (obj_t) (aux_1607);
			    }
			    break;
			 case ((long) 1):

			    {	/* Fail/walk.scm 51 */
			       kwote_bglt aux_1610;
			       aux_1610 =
				  (kwote_bglt) (node_17);
			       aux_1604 =
				  (obj_t) (aux_1610);
			    }
			    break;
			 case ((long) 2):

			    {	/* Fail/walk.scm 51 */
			       var_bglt aux_1613;
			       aux_1613 =
				  (var_bglt) (node_17);
			       aux_1604 =
				  (obj_t) (aux_1613);
			    }
			    break;
			 case ((long) 3):

			    {	/* Fail/walk.scm 51 */
			       sequence_bglt node_1136;
			       node_1136 =
				  (sequence_bglt) (node_17);
			       fail_node___231_fail_walk(
				  (((sequence_bglt) CREF(node_1136))->nodes));
			       aux_1604 =
				  (obj_t) (node_1136);
			    }
			    break;
			 case ((long) 4):

			    {	/* Fail/walk.scm 82 */
			       app_bglt node_1138;
			       node_1138 =
				  (app_bglt) (node_17);
			       fail_node___231_fail_walk(
				  (((app_bglt) CREF(node_1138))->args));
			       aux_1604 =
				  (obj_t) (node_1138);
			    }
			    break;
			 case ((long) 5):

			    {	/* Fail/walk.scm 90 */
			       app_ly_162_bglt node_1141;
			       node_1141 =
				  (app_ly_162_bglt) (node_17);
			       {	/* Fail/walk.scm 91 */
				  node_bglt arg1640_1143;
				  arg1640_1143 =
				     fail_node__137_fail_walk(
				     (((app_ly_162_bglt) CREF(node_1141))->fun));
				  ((((app_ly_162_bglt) CREF(node_1141))->fun) = ((node_bglt) arg1640_1143), BUNSPEC);
			       }
			       {	/* Fail/walk.scm 92 */
				  node_bglt arg1642_1145;
				  arg1642_1145 =
				     fail_node__137_fail_walk(
				     (((app_ly_162_bglt) CREF(node_1141))->arg));
				  ((((app_ly_162_bglt) CREF(node_1141))->arg) = ((node_bglt) arg1642_1145), BUNSPEC);
			       }
			       aux_1604 =
				  (obj_t) (node_1141);
			    }
			    break;
			 case ((long) 6):

			    {	/* Fail/walk.scm 99 */
			       funcall_bglt node_1147;
			       node_1147 =
				  (funcall_bglt) (node_17);
			       {	/* Fail/walk.scm 100 */
				  node_bglt arg1644_1149;
				  arg1644_1149 =
				     fail_node__137_fail_walk(
				     (((funcall_bglt) CREF(node_1147))->fun));
				  ((((funcall_bglt) CREF(node_1147))->fun) = ((node_bglt) arg1644_1149), BUNSPEC);
			       }
			       fail_node___231_fail_walk(
				  (((funcall_bglt) CREF(node_1147))->args));
			       aux_1604 =
				  (obj_t) (node_1147);
			    }
			    break;
			 case ((long) 7):

			    {	/* Fail/walk.scm 51 */
			       pragma_bglt node_1152;
			       node_1152 =
				  (pragma_bglt) (node_17);
			       fail_node___231_fail_walk(
				  (((pragma_bglt) CREF(node_1152))->args));
			       aux_1604 =
				  (obj_t) (node_1152);
			    }
			    break;
			 case ((long) 8):

			    {	/* Fail/walk.scm 51 */
			       setq_bglt node_1154;
			       node_1154 =
				  (setq_bglt) (node_17);
			       {	/* Fail/walk.scm 115 */
				  node_bglt arg1649_1155;
				  arg1649_1155 =
				     fail_node__137_fail_walk(
				     (((setq_bglt) CREF(node_1154))->value));
				  ((((setq_bglt) CREF(node_1154))->value) = ((node_bglt) arg1649_1155), BUNSPEC);
			       }
			       aux_1604 =
				  (obj_t) (node_1154);
			    }
			    break;
			 case ((long) 9):

			    {	/* Fail/walk.scm 122 */
			       conditional_bglt node_1157;
			       node_1157 =
				  (conditional_bglt) (node_17);
			       {	/* Fail/walk.scm 123 */
				  node_bglt arg1651_1159;
				  arg1651_1159 =
				     fail_node__137_fail_walk(
				     (((conditional_bglt) CREF(node_1157))->test));
				  ((((conditional_bglt) CREF(node_1157))->test) = ((node_bglt) arg1651_1159), BUNSPEC);
			       }
			       {	/* Fail/walk.scm 124 */
				  node_bglt arg1653_1161;
				  arg1653_1161 =
				     fail_node__137_fail_walk(
				     (((conditional_bglt) CREF(node_1157))->true));
				  ((((conditional_bglt) CREF(node_1157))->true) = ((node_bglt) arg1653_1161), BUNSPEC);
			       }
			       {	/* Fail/walk.scm 125 */
				  node_bglt arg1655_1163;
				  arg1655_1163 =
				     fail_node__137_fail_walk(
				     (((conditional_bglt) CREF(node_1157))->false));
				  ((((conditional_bglt) CREF(node_1157))->false) = ((node_bglt) arg1655_1163), BUNSPEC);
			       }
			       aux_1604 =
				  (obj_t) (node_1157);
			    }
			    break;
			 case ((long) 10):

			    {	/* Fail/walk.scm 132 */
			       fail_bglt node_1165;
			       node_1165 =
				  (fail_bglt) (node_17);
			       {	/* Fail/walk.scm 133 */
				  node_bglt arg1657_1167;
				  arg1657_1167 =
				     fail_node__137_fail_walk(
				     (((fail_bglt) CREF(node_1165))->proc));
				  ((((fail_bglt) CREF(node_1165))->proc) = ((node_bglt) arg1657_1167), BUNSPEC);
			       }
			       {	/* Fail/walk.scm 134 */
				  node_bglt arg1659_1169;
				  arg1659_1169 =
				     fail_node__137_fail_walk(
				     (((fail_bglt) CREF(node_1165))->msg));
				  ((((fail_bglt) CREF(node_1165))->msg) = ((node_bglt) arg1659_1169), BUNSPEC);
			       }
			       {	/* Fail/walk.scm 135 */
				  node_bglt arg1661_1171;
				  arg1661_1171 =
				     fail_node__137_fail_walk(
				     (((fail_bglt) CREF(node_1165))->obj));
				  ((((fail_bglt) CREF(node_1165))->obj) = ((node_bglt) arg1661_1171), BUNSPEC);
			       }
			       {	/* Fail/walk.scm 136 */
				  bool_t test_1669;
				  {	/* Fail/walk.scm 136 */
				     obj_t arg1683_1192;
				     arg1683_1192 =
					(((fail_bglt) CREF(node_1165))->loc);
				     if (
					STRUCTP(arg1683_1192))
				       {	/* ./Ieee/equiv.scm 5508 */
					  obj_t aux_1675;
					  obj_t aux_1673;
					  aux_1675 =
					     CNST_TABLE_REF(((long) 2));
					  aux_1673 =
					     STRUCT_KEY(arg1683_1192);
					  test_1669 =
					     (aux_1673 == aux_1675);
				       }
				     else
				       {	/* ./Tools/location.sch 546 */
					  test_1669 = ((bool_t) 0)
					     ;
				       }
				  }
				  if (test_1669)
				    {	/* Fail/walk.scm 137 */
				       obj_t arg1664_1174;
				       obj_t arg1666_1176;
				       obj_t arg1667_1177;
				       {	/* Fail/walk.scm 137 */
					  obj_t arg1669_1178;
					  obj_t arg1670_1179;
					  arg1669_1178 =
					     CNST_TABLE_REF(((long) 3));
					  {	/* Fail/walk.scm 137 */
					     node_bglt arg1671_1180;
					     obj_t arg1672_1181;
					     arg1671_1180 =
						(((fail_bglt) CREF(node_1165))->proc);
					     {	/* Fail/walk.scm 137 */
						node_bglt arg1673_1182;
						obj_t arg1674_1183;
						arg1673_1182 =
						   (((fail_bglt) CREF(node_1165))->msg);
						{	/* Fail/walk.scm 137 */
						   node_bglt arg1675_1184;
						   obj_t arg1676_1185;
						   arg1675_1184 =
						      (((fail_bglt) CREF(node_1165))->obj);
						   {	/* Fail/walk.scm 140 */
						      obj_t arg1677_1186;
						      obj_t arg1678_1187;
						      arg1677_1186 =
							 location_full_fname_231_tools_location(
							 (((fail_bglt) CREF(node_1165))->loc));
						      {		/* ./Ieee/pair-list.scm 5689 */
							 obj_t aux_1684;
							 {	/* ./Llib/struct.scm 1457 */
							    obj_t aux_1685;
							    aux_1685 =
							       (((fail_bglt) CREF(node_1165))->loc);
							    aux_1684 =
							       STRUCT_REF(aux_1685, ((long) 1));
							 }
							 arg1678_1187 =
							    MAKE_PAIR(aux_1684, BNIL);
						      }
						      arg1676_1185 =
							 MAKE_PAIR(arg1677_1186, arg1678_1187);
						   }
						   {	/* ./Ieee/pair-list.scm 5689 */
						      obj_t aux_1690;
						      aux_1690 =
							 (obj_t) (arg1675_1184);
						      arg1674_1183 =
							 MAKE_PAIR(aux_1690, arg1676_1185);
						   }
						}
						{	/* ./Ieee/pair-list.scm 5689 */
						   obj_t aux_1693;
						   aux_1693 =
						      (obj_t) (arg1673_1182);
						   arg1672_1181 =
						      MAKE_PAIR(aux_1693, arg1674_1183);
						}
					     }
					     {	/* ./Ieee/pair-list.scm 5689 */
						obj_t aux_1696;
						aux_1696 =
						   (obj_t) (arg1671_1180);
						arg1670_1179 =
						   MAKE_PAIR(aux_1696, arg1672_1181);
					     }
					  }
					  arg1664_1174 =
					     MAKE_PAIR(arg1669_1178, arg1670_1179);
				       }
				       arg1666_1176 =
					  (((fail_bglt) CREF(node_1165))->loc);
				       arg1667_1177 =
					  CNST_TABLE_REF(((long) 4));
				       {	/* Fail/walk.scm 137 */
					  node_bglt aux_1702;
					  aux_1702 =
					     sexp__node_235_ast_sexp(arg1664_1174, BNIL, arg1666_1176, arg1667_1177);
					  aux_1604 =
					     (obj_t) (aux_1702);
				       }
				    }
				  else
				    {	/* Fail/walk.scm 136 */
				       aux_1604 =
					  (obj_t) (node_1165)
					  ;
				    }
			       }
			    }
			    break;
			 case ((long) 11):

			    {	/* Fail/walk.scm 151 */
			       select_bglt node_1193;
			       node_1193 =
				  (select_bglt) (node_17);
			       {	/* Fail/walk.scm 152 */
				  node_bglt arg1684_1195;
				  arg1684_1195 =
				     fail_node__137_fail_walk(
				     (((select_bglt) CREF(node_1193))->test));
				  ((((select_bglt) CREF(node_1193))->test) = ((node_bglt) arg1684_1195), BUNSPEC);
			       }
			       {
				  obj_t l1446_1197;
				  l1446_1197 =
				     (((select_bglt) CREF(node_1193))->clauses);
				lname1447_1198:
				  if (
				     PAIRP(l1446_1197))
				    {	/* Fail/walk.scm 153 */
				       {	/* Fail/walk.scm 154 */
					  obj_t clause_1201;
					  clause_1201 =
					     CAR(l1446_1197);
					  {	/* Fail/walk.scm 154 */
					     node_bglt arg1688_1202;
					     {	/* Fail/walk.scm 154 */
						node_bglt aux_1713;
						{	/* Fail/walk.scm 154 */
						   obj_t aux_1714;
						   aux_1714 =
						      CDR(clause_1201);
						   aux_1713 =
						      (node_bglt) (aux_1714);
						}
						arg1688_1202 =
						   fail_node__137_fail_walk(aux_1713);
					     }
					     {	/* ./Ieee/pair-list.scm 5896 */
						obj_t aux_1718;
						aux_1718 =
						   (obj_t) (arg1688_1202);
						SET_CDR(clause_1201, aux_1718);
					     }
					  }
				       }
				       {
					  obj_t l1446_1721;
					  l1446_1721 =
					     CDR(l1446_1197);
					  l1446_1197 = l1446_1721;
					  goto lname1447_1198;
				       }
				    }
				  else
				    {	/* Fail/walk.scm 153 */
				       ((bool_t) 1);
				    }
			       }
			       aux_1604 =
				  (obj_t) (node_1193);
			    }
			    break;
			 case ((long) 12):

			    {	/* Fail/walk.scm 162 */
			       let_fun_218_bglt node_1205;
			       node_1205 =
				  (let_fun_218_bglt) (node_17);
			       {
				  obj_t l1449_1207;
				  l1449_1207 =
				     (((let_fun_218_bglt) CREF(node_1205))->locals);
				lname1450_1208:
				  if (
				     PAIRP(l1449_1207))
				    {	/* Fail/walk.scm 163 */
				       fail_fun__97_fail_walk(
					  CAR(l1449_1207));
				       {
					  obj_t l1449_1730;
					  l1449_1730 =
					     CDR(l1449_1207);
					  l1449_1207 = l1449_1730;
					  goto lname1450_1208;
				       }
				    }
				  else
				    {	/* Fail/walk.scm 163 */
				       ((bool_t) 1);
				    }
			       }
			       {	/* Fail/walk.scm 164 */
				  node_bglt arg1695_1213;
				  arg1695_1213 =
				     fail_node__137_fail_walk(
				     (((let_fun_218_bglt) CREF(node_1205))->body));
				  ((((let_fun_218_bglt) CREF(node_1205))->body) = ((node_bglt) arg1695_1213), BUNSPEC);
			       }
			       aux_1604 =
				  (obj_t) (node_1205);
			    }
			    break;
			 case ((long) 13):

			    {	/* Fail/walk.scm 171 */
			       let_var_6_bglt node_1215;
			       node_1215 =
				  (let_var_6_bglt) (node_17);
			       {
				  obj_t l1452_1217;
				  l1452_1217 =
				     (((let_var_6_bglt) CREF(node_1215))->bindings);
				lname1453_1218:
				  if (
				     PAIRP(l1452_1217))
				    {	/* Fail/walk.scm 172 */
				       {	/* Fail/walk.scm 173 */
					  obj_t binding_1221;
					  binding_1221 =
					     CAR(l1452_1217);
					  {	/* Fail/walk.scm 173 */
					     node_bglt arg1699_1222;
					     {	/* Fail/walk.scm 173 */
						node_bglt aux_1741;
						{	/* Fail/walk.scm 173 */
						   obj_t aux_1742;
						   aux_1742 =
						      CDR(binding_1221);
						   aux_1741 =
						      (node_bglt) (aux_1742);
						}
						arg1699_1222 =
						   fail_node__137_fail_walk(aux_1741);
					     }
					     {	/* ./Ieee/pair-list.scm 5896 */
						obj_t aux_1746;
						aux_1746 =
						   (obj_t) (arg1699_1222);
						SET_CDR(binding_1221, aux_1746);
					     }
					  }
				       }
				       {
					  obj_t l1452_1749;
					  l1452_1749 =
					     CDR(l1452_1217);
					  l1452_1217 = l1452_1749;
					  goto lname1453_1218;
				       }
				    }
				  else
				    {	/* Fail/walk.scm 172 */
				       ((bool_t) 1);
				    }
			       }
			       {	/* Fail/walk.scm 175 */
				  node_bglt arg1702_1225;
				  arg1702_1225 =
				     fail_node__137_fail_walk(
				     (((let_var_6_bglt) CREF(node_1215))->body));
				  ((((let_var_6_bglt) CREF(node_1215))->body) = ((node_bglt) arg1702_1225), BUNSPEC);
			       }
			       aux_1604 =
				  (obj_t) (node_1215);
			    }
			    break;
			 case ((long) 14):

			    {	/* Fail/walk.scm 51 */
			       set_ex_it_116_bglt node_1227;
			       node_1227 =
				  (set_ex_it_116_bglt) (node_17);
			       {	/* Fail/walk.scm 182 */
				  node_bglt arg1704_1228;
				  arg1704_1228 =
				     fail_node__137_fail_walk(
				     (((set_ex_it_116_bglt) CREF(node_1227))->body));
				  ((((set_ex_it_116_bglt) CREF(node_1227))->body) = ((node_bglt) arg1704_1228), BUNSPEC);
			       }
			       aux_1604 =
				  (obj_t) (node_1227);
			    }
			    break;
			 case ((long) 15):

			    {	/* Fail/walk.scm 189 */
			       jump_ex_it_184_bglt node_1230;
			       node_1230 =
				  (jump_ex_it_184_bglt) (node_17);
			       {	/* Fail/walk.scm 190 */
				  node_bglt arg1706_1232;
				  arg1706_1232 =
				     fail_node__137_fail_walk(
				     (((jump_ex_it_184_bglt) CREF(node_1230))->exit));
				  ((((jump_ex_it_184_bglt) CREF(node_1230))->exit) = ((node_bglt) arg1706_1232), BUNSPEC);
			       }
			       {	/* Fail/walk.scm 191 */
				  node_bglt arg1708_1234;
				  arg1708_1234 =
				     fail_node__137_fail_walk(
				     (((jump_ex_it_184_bglt) CREF(node_1230))->value));
				  ((((jump_ex_it_184_bglt) CREF(node_1230))->value) = ((node_bglt) arg1708_1234), BUNSPEC);
			       }
			       aux_1604 =
				  (obj_t) (node_1230);
			    }
			    break;
			 case ((long) 16):

			    {	/* Fail/walk.scm 51 */
			       make_box_202_bglt node_1236;
			       node_1236 =
				  (make_box_202_bglt) (node_17);
			       {	/* Fail/walk.scm 198 */
				  node_bglt arg1711_1237;
				  arg1711_1237 =
				     fail_node__137_fail_walk(
				     (((make_box_202_bglt) CREF(node_1236))->value));
				  ((((make_box_202_bglt) CREF(node_1236))->value) = ((node_bglt) arg1711_1237), BUNSPEC);
			       }
			       aux_1604 =
				  (obj_t) (node_1236);
			    }
			    break;
			 case ((long) 17):

			    {	/* Fail/walk.scm 51 */
			       box_ref_242_bglt aux_1774;
			       aux_1774 =
				  (box_ref_242_bglt) (node_17);
			       aux_1604 =
				  (obj_t) (aux_1774);
			    }
			    break;
			 case ((long) 18):

			    {	/* Fail/walk.scm 211 */
			       box_set__221_bglt node_1240;
			       node_1240 =
				  (box_set__221_bglt) (node_17);
			       {	/* Fail/walk.scm 212 */
				  node_bglt arg1713_1242;
				  arg1713_1242 =
				     fail_node__137_fail_walk(
				     (((box_set__221_bglt) CREF(node_1240))->value));
				  ((((box_set__221_bglt) CREF(node_1240))->value) = ((node_bglt) arg1713_1242), BUNSPEC);
			       }
			       aux_1604 =
				  (obj_t) (node_1240);
			    }
			    break;
			 default:
			  case_else1632_1130:
			    if (
			       PROCEDUREP(method1626_1126))
			      {		/* Fail/walk.scm 51 */
				 aux_1604 =
				    PROCEDURE_ENTRY(method1626_1126) (method1626_1126,
				    (obj_t) (node_17), BEOA)
				    ;
			      }
			    else
			      {		/* Fail/walk.scm 51 */
				 obj_t fun1625_1122;
				 fun1625_1122 =
				    PROCEDURE_REF(fail_node__env_77_fail_walk, ((long) 0));
				 aux_1604 =
				    PROCEDURE_ENTRY(fun1625_1122) (fun1625_1122,
				    (obj_t) (node_17), BEOA);
			      }
			 }
		    }
		  else
		    {	/* Fail/walk.scm 51 */
		       goto case_else1632_1130;
		    }
	       }
	       return
		  (node_bglt) (aux_1604);
	    }
	 }
      }
   }
}



/* _fail-node!1723 */
obj_t 
_fail_node_1723_182_fail_walk(obj_t env_1443, obj_t node_1444)
{
   AN_OBJECT;
   {	/* Fail/walk.scm 51 */
      {		/* Fail/walk.scm 51 */
	 node_bglt aux_1794;
	 aux_1794 =
	    fail_node__137_fail_walk(
	    (node_bglt) (node_1444));
	 return
	    (obj_t) (aux_1794);
      }
   }
}



/* fail-node!-default1457 */
node_bglt 
fail_node__default1457_45_fail_walk(node_bglt node_18)
{
   AN_OBJECT;
   {	/* Fail/walk.scm 14 */
      FAILURE(
	 CNST_TABLE_REF(((long) 5)), string1730_fail_walk,
	 (obj_t) (node_18));
   }
}



/* _fail-node!-default1457 */
obj_t 
_fail_node__default1457_120_fail_walk(obj_t env_1445, obj_t node_1446)
{
   AN_OBJECT;
   {	/* Fail/walk.scm 14 */
      {		/* Fail/walk.scm 14 */
	 node_bglt aux_1801;
	 aux_1801 =
	    fail_node__default1457_45_fail_walk(
	    (node_bglt) (node_1446));
	 return
	    (obj_t) (aux_1801);
      }
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_fail_walk()
{
   AN_OBJECT;
   {	/* Fail/walk.scm 14 */
      module_initialization_70_tools_speek(((long) 0), "FAIL_WALK");
      module_initialization_70_tools_error(((long) 0), "FAIL_WALK");
      module_initialization_70_engine_pass(((long) 0), "FAIL_WALK");
      module_initialization_70_type_type(((long) 0), "FAIL_WALK");
      module_initialization_70_ast_var(((long) 0), "FAIL_WALK");
      module_initialization_70_ast_node(((long) 0), "FAIL_WALK");
      module_initialization_70_tools_shape(((long) 0), "FAIL_WALK");
      module_initialization_70_tools_location(((long) 0), "FAIL_WALK");
      return
	 module_initialization_70_ast_sexp(((long) 0), "FAIL_WALK");
   }
}
