/*===========================================================================*/
/*   (Globalize/clocto.scm)                                                  */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;

typedef struct sfun_ginfo_98
  {
     bool_t g__219;
     obj_t cfrom;
     obj_t cfrom__119;
     obj_t cto;
     obj_t cto__14;
     obj_t cfunction;
     obj_t integrator;
     obj_t integrated;
     obj_t plugged_in_15;
     long mark;
     obj_t free_mark_81;
     obj_t the_global_201;
     obj_t kaptured;
     obj_t new_body_215;
     long bmark;
     long umark;
     obj_t free;
     obj_t bound;
  }
             *sfun_ginfo_98_bglt;

typedef struct svar_ginfo_131
  {
     bool_t kaptured__204;
     long free_mark_81;
     long mark;
     bool_t celled__113;
  }
              *svar_ginfo_131_bglt;

typedef struct sexit_ginfo_81
  {
     bool_t g__219;
     bool_t kaptured__204;
     long free_mark_81;
     long mark;
  }
              *sexit_ginfo_81_bglt;

typedef struct local_ginfo_108
  {
     bool_t escape__117;
  }
               *local_ginfo_108_bglt;

typedef struct global_ginfo_75
  {
     bool_t escape__117;
     obj_t global_closure_229;
  }
               *global_ginfo_75_bglt;


static obj_t method_init_76_globalize_clocto();
extern obj_t cto_transitive_closure__123_globalize_clocto(local_bglt);
extern obj_t module_initialization_70_globalize_clocto(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_globalize_ginfo(long, char *);
extern obj_t module_initialization_70_globalize_kapture(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t union_3_globalize_kapture(obj_t);
static obj_t _cto_transitive_closure_1672_71_globalize_clocto(obj_t, obj_t);
static obj_t imported_modules_init_94_globalize_clocto();
extern obj_t append_2_18___r4_pairs_and_lists_6_3(obj_t, obj_t);
static obj_t library_modules_init_112_globalize_clocto();
extern obj_t local_ast_var;
static obj_t require_initialization_114_globalize_clocto = BUNSPEC;
static obj_t *__cnst;

DEFINE_EXPORT_PROCEDURE(cto_transitive_closure__env_229_globalize_clocto, _cto_transitive_closure_1672_71_globalize_clocto1674, _cto_transitive_closure_1672_71_globalize_clocto, 0L, 1);



/* module-initialization */
obj_t 
module_initialization_70_globalize_clocto(long checksum_1551, char *from_1552)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_globalize_clocto))
	{
	   require_initialization_114_globalize_clocto =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_globalize_clocto();
	   imported_modules_init_94_globalize_clocto();
	   method_init_76_globalize_clocto();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_globalize_clocto()
{
   AN_OBJECT;
   {	/* Globalize/clocto.scm 14 */
      module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "GLOBALIZE_CLOCTO");
      return BUNSPEC;
   }
}



/* cto-transitive-closure! */
obj_t 
cto_transitive_closure__123_globalize_clocto(local_bglt host_1)
{
   AN_OBJECT;
   {	/* Globalize/clocto.scm 35 */
      {		/* Globalize/clocto.scm 36 */
	 value_bglt info_995;
	 info_995 =
	    (((local_bglt) CREF(host_1))->value);
	 {	/* Globalize/clocto.scm 36 */
	    obj_t cto_996;
	    {	/* Globalize/clocto.scm 37 */
	       obj_t aux_1568;
	       obj_t aux_1561;
	       {	/* Globalize/clocto.scm 38 */
		  sfun_ginfo_98_bglt obj_1422;
		  obj_1422 =
		     (sfun_ginfo_98_bglt) (info_995);
		  {
		     obj_t aux_1570;
		     {	/* ./Globalize/ginfo.scm 802 */
			object_bglt aux_1571;
			aux_1571 =
			   (object_bglt) (obj_1422);
			aux_1570 =
			   OBJECT_WIDENING(aux_1571);
		     }
		     aux_1568 =
			(((sfun_ginfo_98_bglt) CREF(aux_1570))->cfunction);
		  }
	       }
	       {	/* Globalize/clocto.scm 37 */
		  sfun_ginfo_98_bglt obj_1421;
		  obj_1421 =
		     (sfun_ginfo_98_bglt) (info_995);
		  {
		     obj_t aux_1563;
		     {	/* ./Globalize/ginfo.scm 798 */
			object_bglt aux_1564;
			aux_1564 =
			   (object_bglt) (obj_1421);
			aux_1563 =
			   OBJECT_WIDENING(aux_1564);
		     }
		     aux_1561 =
			(((sfun_ginfo_98_bglt) CREF(aux_1563))->cto);
		  }
	       }
	       cto_996 =
		  append_2_18___r4_pairs_and_lists_6_3(aux_1561, aux_1568);
	    }
	    {	/* Globalize/clocto.scm 37 */
	       obj_t cto__orig_75_997;
	       {	/* Globalize/clocto.scm 39 */
		  obj_t list1582_1027;
		  list1582_1027 =
		     MAKE_PAIR(cto_996, BNIL);
		  cto__orig_75_997 = list1582_1027;
	       }
	       {	/* Globalize/clocto.scm 39 */

		  {
		     obj_t cto_998;
		     obj_t cto__14_999;
		     cto_998 = cto_996;
		     cto__14_999 = cto__orig_75_997;
		   loop_1000:
		     if (
			NULLP(cto_998))
		       {	/* Globalize/clocto.scm 43 */
			  {	/* Globalize/clocto.scm 45 */
			     obj_t arg1555_1002;
			     if (
				(cto__14_999 == cto__orig_75_997))
			       {	/* Globalize/clocto.scm 45 */
				  arg1555_1002 =
				     CAR(cto__orig_75_997);
			       }
			     else
			       {	/* Globalize/clocto.scm 45 */
				  arg1555_1002 =
				     union_3_globalize_kapture(cto__14_999);
			       }
			     {	/* Globalize/clocto.scm 44 */
				sfun_ginfo_98_bglt obj_1428;
				obj_1428 =
				   (sfun_ginfo_98_bglt) (info_995);
				{
				   obj_t aux_1584;
				   {	/* ./Globalize/ginfo.scm 800 */
				      object_bglt aux_1585;
				      aux_1585 =
					 (object_bglt) (obj_1428);
				      aux_1584 =
					 OBJECT_WIDENING(aux_1585);
				   }
				   return
				      ((((sfun_ginfo_98_bglt) CREF(aux_1584))->cto__14) = ((obj_t) arg1555_1002), BUNSPEC);
				}
			     }
			  }
		       }
		     else
		       {	/* Globalize/clocto.scm 48 */
			  bool_t test1557_1004;
			  {	/* Globalize/clocto.scm 48 */
			     obj_t obj2_1432;
			     obj2_1432 = local_ast_var;
			     {	/* ./Ieee/equiv.scm 5508 */
				obj_t aux_1589;
				aux_1589 =
				   CAR(cto_998);
				test1557_1004 =
				   (aux_1589 == obj2_1432);
			     }
			  }
			  if (test1557_1004)
			    {	/* Globalize/clocto.scm 48 */
			       {
				  obj_t cto_1593;
				  cto_1593 =
				     CDR(cto_998);
				  cto_998 = cto_1593;
				  goto loop_1000;
			       }
			    }
			  else
			    {	/* Globalize/clocto.scm 50 */
			       bool_t test_1595;
			       {	/* Globalize/clocto.scm 50 */
				  sfun_ginfo_98_bglt obj_1436;
				  {	/* Globalize/clocto.scm 50 */
				     value_bglt aux_1596;
				     {	/* Globalize/clocto.scm 50 */
					local_bglt obj_1435;
					{	/* Globalize/clocto.scm 50 */
					   obj_t aux_1597;
					   aux_1597 =
					      CAR(cto_998);
					   obj_1435 =
					      (local_bglt) (aux_1597);
					}
					aux_1596 =
					   (((local_bglt) CREF(obj_1435))->value);
				     }
				     obj_1436 =
					(sfun_ginfo_98_bglt) (aux_1596);
				  }
				  {
				     obj_t aux_1602;
				     {	/* ./Globalize/ginfo.scm 792 */
					object_bglt aux_1603;
					aux_1603 =
					   (object_bglt) (obj_1436);
					aux_1602 =
					   OBJECT_WIDENING(aux_1603);
				     }
				     test_1595 =
					(((sfun_ginfo_98_bglt) CREF(aux_1602))->g__219);
				  }
			       }
			       if (test_1595)
				 {	/* Globalize/clocto.scm 50 */
				    {
				       obj_t cto_1607;
				       cto_1607 =
					  CDR(cto_998);
				       cto_998 = cto_1607;
				       goto loop_1000;
				    }
				 }
			       else
				 {	/* Globalize/clocto.scm 52 */
				    bool_t test_1609;
				    {	/* Globalize/clocto.scm 52 */
				       sfun_ginfo_98_bglt obj_1440;
				       {	/* Globalize/clocto.scm 52 */
					  value_bglt aux_1610;
					  {	/* Globalize/clocto.scm 52 */
					     local_bglt obj_1439;
					     {	/* Globalize/clocto.scm 52 */
						obj_t aux_1611;
						aux_1611 =
						   CAR(cto_998);
						obj_1439 =
						   (local_bglt) (aux_1611);
					     }
					     aux_1610 =
						(((local_bglt) CREF(obj_1439))->value);
					  }
					  obj_1440 =
					     (sfun_ginfo_98_bglt) (aux_1610);
				       }
				       {	/* ./Globalize/ginfo.scm 800 */
					  obj_t aux_1616;
					  {
					     obj_t aux_1617;
					     {	/* ./Globalize/ginfo.scm 800 */
						object_bglt aux_1618;
						aux_1618 =
						   (object_bglt) (obj_1440);
						aux_1617 =
						   OBJECT_WIDENING(aux_1618);
					     }
					     aux_1616 =
						(((sfun_ginfo_98_bglt) CREF(aux_1617))->cto__14);
					  }
					  test_1609 =
					     CBOOL(aux_1616);
				       }
				    }
				    if (test_1609)
				      {		/* Globalize/clocto.scm 52 */
					 {
					    obj_t cto_1623;
					    cto_1623 =
					       CDR(cto_998);
					    cto_998 = cto_1623;
					    goto loop_1000;
					 }
				      }
				    else
				      {		/* Globalize/clocto.scm 52 */
					 {	/* Globalize/clocto.scm 56 */
					    obj_t callee_1010;
					    {	/* Globalize/clocto.scm 56 */
					       obj_t aux_1637;
					       obj_t aux_1625;
					       {	/* Globalize/clocto.scm 58 */
						  sfun_ginfo_98_bglt obj_1447;
						  {	/* Globalize/clocto.scm 58 */
						     value_bglt aux_1638;
						     {	/* Globalize/clocto.scm 58 */
							local_bglt obj_1446;
							{	/* Globalize/clocto.scm 58 */
							   obj_t aux_1639;
							   aux_1639 =
							      CAR(cto_998);
							   obj_1446 =
							      (local_bglt) (aux_1639);
							}
							aux_1638 =
							   (((local_bglt) CREF(obj_1446))->value);
						     }
						     obj_1447 =
							(sfun_ginfo_98_bglt) (aux_1638);
						  }
						  {
						     obj_t aux_1644;
						     {	/* ./Globalize/ginfo.scm 802 */
							object_bglt aux_1645;
							aux_1645 =
							   (object_bglt) (obj_1447);
							aux_1644 =
							   OBJECT_WIDENING(aux_1645);
						     }
						     aux_1637 =
							(((sfun_ginfo_98_bglt) CREF(aux_1644))->cfunction);
						  }
					       }
					       {	/* Globalize/clocto.scm 57 */
						  sfun_ginfo_98_bglt obj_1444;
						  {	/* Globalize/clocto.scm 57 */
						     value_bglt aux_1626;
						     {	/* Globalize/clocto.scm 57 */
							local_bglt obj_1443;
							{	/* Globalize/clocto.scm 57 */
							   obj_t aux_1627;
							   aux_1627 =
							      CAR(cto_998);
							   obj_1443 =
							      (local_bglt) (aux_1627);
							}
							aux_1626 =
							   (((local_bglt) CREF(obj_1443))->value);
						     }
						     obj_1444 =
							(sfun_ginfo_98_bglt) (aux_1626);
						  }
						  {
						     obj_t aux_1632;
						     {	/* ./Globalize/ginfo.scm 798 */
							object_bglt aux_1633;
							aux_1633 =
							   (object_bglt) (obj_1444);
							aux_1632 =
							   OBJECT_WIDENING(aux_1633);
						     }
						     aux_1625 =
							(((sfun_ginfo_98_bglt) CREF(aux_1632))->cto);
						  }
					       }
					       callee_1010 =
						  append_2_18___r4_pairs_and_lists_6_3(aux_1625, aux_1637);
					    }
					    {	/* Globalize/clocto.scm 60 */
					       sfun_ginfo_98_bglt obj_1450;
					       obj_t val1452_1451;
					       {	/* Globalize/clocto.scm 60 */
						  value_bglt aux_1650;
						  {	/* Globalize/clocto.scm 60 */
						     local_bglt obj_1449;
						     {	/* Globalize/clocto.scm 60 */
							obj_t aux_1651;
							aux_1651 =
							   CAR(cto_998);
							obj_1449 =
							   (local_bglt) (aux_1651);
						     }
						     aux_1650 =
							(((local_bglt) CREF(obj_1449))->value);
						  }
						  obj_1450 =
						     (sfun_ginfo_98_bglt) (aux_1650);
					       }
					       val1452_1451 = BTRUE;
					       {
						  obj_t aux_1656;
						  {	/* ./Globalize/ginfo.scm 800 */
						     object_bglt aux_1657;
						     aux_1657 =
							(object_bglt) (obj_1450);
						     aux_1656 =
							OBJECT_WIDENING(aux_1657);
						  }
						  ((((sfun_ginfo_98_bglt) CREF(aux_1656))->cto__14) = ((obj_t) val1452_1451), BUNSPEC);
					       }
					    }
					    {	/* Globalize/clocto.scm 62 */
					       obj_t arg1565_1013;
					       obj_t arg1566_1014;
					       arg1565_1013 =
						  append_2_18___r4_pairs_and_lists_6_3(
						  CDR(cto_998), callee_1010);
					       arg1566_1014 =
						  MAKE_PAIR(callee_1010, cto__14_999);
					       {
						  obj_t cto__14_1665;
						  obj_t cto_1664;
						  cto_1664 = arg1565_1013;
						  cto__14_1665 = arg1566_1014;
						  cto__14_999 = cto__14_1665;
						  cto_998 = cto_1664;
						  goto loop_1000;
					       }
					    }
					 }
				      }
				 }
			    }
		       }
		  }
	       }
	    }
	 }
      }
   }
}



/* _cto-transitive-closure!1672 */
obj_t 
_cto_transitive_closure_1672_71_globalize_clocto(obj_t env_1549, obj_t host_1550)
{
   AN_OBJECT;
   {	/* Globalize/clocto.scm 35 */
      return
	 cto_transitive_closure__123_globalize_clocto(
	 (local_bglt) (host_1550));
   }
}



/* method-init */
obj_t 
method_init_76_globalize_clocto()
{
   AN_OBJECT;
   {	/* Globalize/clocto.scm 14 */
      return BUNSPEC;
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_globalize_clocto()
{
   AN_OBJECT;
   {	/* Globalize/clocto.scm 14 */
      module_initialization_70_tools_trace(((long) 0), "GLOBALIZE_CLOCTO");
      module_initialization_70_tools_shape(((long) 0), "GLOBALIZE_CLOCTO");
      module_initialization_70_type_type(((long) 0), "GLOBALIZE_CLOCTO");
      module_initialization_70_ast_var(((long) 0), "GLOBALIZE_CLOCTO");
      module_initialization_70_ast_node(((long) 0), "GLOBALIZE_CLOCTO");
      module_initialization_70_globalize_ginfo(((long) 0), "GLOBALIZE_CLOCTO");
      return
	 module_initialization_70_globalize_kapture(((long) 0), "GLOBALIZE_CLOCTO");
   }
}
