/*===========================================================================*/
/*   (Globalize/escape.scm)                                                  */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;

typedef struct sfun_ginfo_98
  {
     bool_t g__219;
     obj_t cfrom;
     obj_t cfrom__119;
     obj_t cto;
     obj_t cto__14;
     obj_t cfunction;
     obj_t integrator;
     obj_t integrated;
     obj_t plugged_in_15;
     long mark;
     obj_t free_mark_81;
     obj_t the_global_201;
     obj_t kaptured;
     obj_t new_body_215;
     long bmark;
     long umark;
     obj_t free;
     obj_t bound;
  }
             *sfun_ginfo_98_bglt;

typedef struct svar_ginfo_131
  {
     bool_t kaptured__204;
     long free_mark_81;
     long mark;
     bool_t celled__113;
  }
              *svar_ginfo_131_bglt;

typedef struct sexit_ginfo_81
  {
     bool_t g__219;
     bool_t kaptured__204;
     long free_mark_81;
     long mark;
  }
              *sexit_ginfo_81_bglt;

typedef struct local_ginfo_108
  {
     bool_t escape__117;
  }
               *local_ginfo_108_bglt;

typedef struct global_ginfo_75
  {
     bool_t escape__117;
     obj_t global_closure_229;
  }
               *global_ginfo_75_bglt;


extern obj_t local_ginfo_108_globalize_ginfo;
static obj_t method_init_76_globalize_escape();
extern obj_t make_box_202_ast_node;
extern obj_t funcall_ast_node;
static obj_t escape__default1606_50_globalize_escape(node_bglt);
extern long add_inlined_method__244___object(obj_t, obj_t, long);
extern obj_t fail_ast_node;
extern obj_t box_ref_242_ast_node;
extern obj_t sequence_ast_node;
extern obj_t let_var_6_ast_node;
extern obj_t var_ast_node;
extern obj_t closure_ast_node;
extern obj_t global_ast_var;
extern obj_t pragma_ast_node;
static obj_t _escape__238_globalize_escape(obj_t, obj_t);
extern obj_t set_ex_it_116_ast_node;
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t module_initialization_70_globalize_escape(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_globalize_ginfo(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
static obj_t escape__235_globalize_escape(node_bglt);
static obj_t _escape_fun__default1593_81_globalize_escape(obj_t, obj_t);
extern long class_num_218___object(obj_t);
extern obj_t let_fun_218_ast_node;
static obj_t imported_modules_init_94_globalize_escape();
extern obj_t sfun_ginfo_98_globalize_ginfo;
extern obj_t app_ly_162_ast_node;
extern obj_t add_generic__110___object(obj_t, obj_t);
extern obj_t app_ast_node;
extern obj_t sexit_ginfo_81_globalize_ginfo;
static obj_t library_modules_init_112_globalize_escape();
extern obj_t global_ginfo_75_globalize_ginfo;
extern obj_t svar_ginfo_131_globalize_ginfo;
static obj_t _escape_fun__253_globalize_escape(obj_t, obj_t);
static obj_t _set_escaping_fun__default1598_158_globalize_escape(obj_t, obj_t);
extern obj_t atom_ast_node;
extern obj_t cast_ast_node;
static obj_t toplevel_init_63_globalize_escape();
extern obj_t jump_ex_it_184_ast_node;
extern obj_t open_input_string(obj_t);
extern obj_t kwote_ast_node;
extern obj_t escape_fun__53_globalize_escape(variable_bglt);
extern obj_t setq_ast_node;
extern obj_t box_set__221_ast_node;
extern obj_t local_ast_var;
extern obj_t shape_tools_shape(obj_t);
static obj_t escape_fun__default1593_18_globalize_escape(variable_bglt);
static obj_t _escape__default1606_17_globalize_escape(obj_t, obj_t);
static obj_t _set_escaping_fun__208_globalize_escape(obj_t, obj_t);
extern obj_t _classes__134___object;
extern obj_t select_ast_node;
static bool_t escape___220_globalize_escape(obj_t);
extern obj_t read___reader(obj_t);
static obj_t set_escaping_fun__default1598_240_globalize_escape(variable_bglt);
static obj_t set_escaping_fun__14_globalize_escape(variable_bglt);
extern obj_t find_method_from_44___object(object_bglt, obj_t, obj_t);
static obj_t require_initialization_114_globalize_escape = BUNSPEC;
extern obj_t conditional_ast_node;
extern bool_t class__60___object(obj_t);
extern obj_t class_super_145___object(obj_t);
static obj_t cnst_init_137_globalize_escape();
static obj_t __cnst[3];

DEFINE_STATIC_PROCEDURE(escape__default1606_env_210_globalize_escape, _escape__default1606_17_globalize_escape1900, _escape__default1606_17_globalize_escape, 0L, 1);
DEFINE_EXPORT_GENERIC(escape_fun__env_92_globalize_escape, _escape_fun__253_globalize_escape1901, _escape_fun__253_globalize_escape, 0L, 1);
DEFINE_STATIC_PROCEDURE(set_escaping_fun__default1598_env_95_globalize_escape, _set_escaping_fun__default1598_158_globalize_escape1902, _set_escaping_fun__default1598_158_globalize_escape, 0L, 1);
DEFINE_STATIC_GENERIC(escape__env_201_globalize_escape, _escape__238_globalize_escape1903, _escape__238_globalize_escape, 0L, 1);
DEFINE_STRING(string1895_globalize_escape, string1895_globalize_escape1904, "ESCAPE!-DEFAULT1606 DONE EXPORT ", 32);
DEFINE_STRING(string1894_globalize_escape, string1894_globalize_escape1905, "No method for this object", 25);
DEFINE_STRING(string1893_globalize_escape, string1893_globalize_escape1906, "Illegal variable", 16);
DEFINE_STRING(string1892_globalize_escape, string1892_globalize_escape1907, "set-escaping-fun!", 17);
DEFINE_STATIC_PROCEDURE(escape_fun__default1593_env_90_globalize_escape, _escape_fun__default1593_81_globalize_escape1908, _escape_fun__default1593_81_globalize_escape, 0L, 1);
DEFINE_STATIC_GENERIC(set_escaping_fun__env_225_globalize_escape, _set_escaping_fun__208_globalize_escape1909, _set_escaping_fun__208_globalize_escape, 0L, 1);



/* module-initialization */
obj_t 
module_initialization_70_globalize_escape(long checksum_2070, char *from_2071)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_globalize_escape))
	{
	   require_initialization_114_globalize_escape =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_globalize_escape();
	   cnst_init_137_globalize_escape();
	   imported_modules_init_94_globalize_escape();
	   method_init_76_globalize_escape();
	   toplevel_init_63_globalize_escape();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_globalize_escape()
{
   AN_OBJECT;
   {	/* Globalize/escape.scm 14 */
      module_initialization_70___object(((long) 0), "GLOBALIZE_ESCAPE");
      module_initialization_70___reader(((long) 0), "GLOBALIZE_ESCAPE");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_globalize_escape()
{
   AN_OBJECT;
   {	/* Globalize/escape.scm 14 */
      {		/* Globalize/escape.scm 14 */
	 obj_t cnst_port_138_2063;
	 cnst_port_138_2063 =
	    open_input_string(string1895_globalize_escape);
	 {
	    long i_2064;
	    i_2064 = ((long) 2);
	  loop_2065:
	    {	/* Globalize/escape.scm 14 */
	       bool_t test1896_2066;
	       test1896_2066 =
		  (i_2064 == ((long) -1));
	       if (test1896_2066)
		 {	/* Globalize/escape.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Globalize/escape.scm 14 */
		    {	/* Globalize/escape.scm 14 */
		       obj_t arg1897_2067;
		       {	/* Globalize/escape.scm 14 */
			  obj_t list1898_2068;
			  list1898_2068 =
			     MAKE_PAIR(cnst_port_138_2063, BNIL);
			  arg1897_2067 =
			     read___reader(list1898_2068);
		       }
		       CNST_TABLE_SET(i_2064, arg1897_2067);
		    }
		    {	/* Globalize/escape.scm 14 */
		       int aux_2069;
		       {	/* Globalize/escape.scm 14 */
			  long aux_2088;
			  aux_2088 =
			     (i_2064 - ((long) 1));
			  aux_2069 =
			     (int) (aux_2088);
		       }
		       {
			  long i_2091;
			  i_2091 =
			     (long) (aux_2069);
			  i_2064 = i_2091;
			  goto loop_2065;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_globalize_escape()
{
   AN_OBJECT;
   {	/* Globalize/escape.scm 14 */
      return BUNSPEC;
   }
}



/* escape*! */
bool_t 
escape___220_globalize_escape(obj_t node__221_33)
{
   AN_OBJECT;
   {	/* Globalize/escape.scm 258 */
      {
	 obj_t l1591_1027;
	 l1591_1027 = node__221_33;
       lname1592_1028:
	 if (
	    PAIRP(l1591_1027))
	   {	/* Globalize/escape.scm 259 */
	      {		/* Globalize/escape.scm 259 */
		 node_bglt aux_2095;
		 {	/* Globalize/escape.scm 259 */
		    obj_t aux_2096;
		    aux_2096 =
		       CAR(l1591_1027);
		    aux_2095 =
		       (node_bglt) (aux_2096);
		 }
		 escape__235_globalize_escape(aux_2095);
	      }
	      {
		 obj_t l1591_2100;
		 l1591_2100 =
		    CDR(l1591_1027);
		 l1591_1027 = l1591_2100;
		 goto lname1592_1028;
	      }
	   }
	 else
	   {	/* Globalize/escape.scm 259 */
	      return ((bool_t) 1);
	   }
      }
   }
}



/* method-init */
obj_t 
method_init_76_globalize_escape()
{
   AN_OBJECT;
   {	/* Globalize/escape.scm 14 */
      add_generic__110___object(escape_fun__env_92_globalize_escape, escape_fun__default1593_env_90_globalize_escape);
      add_inlined_method__244___object(escape_fun__env_92_globalize_escape, global_ast_var, ((long) 0));
      add_inlined_method__244___object(escape_fun__env_92_globalize_escape, local_ast_var, ((long) 1));
      add_generic__110___object(set_escaping_fun__env_225_globalize_escape, set_escaping_fun__default1598_env_95_globalize_escape);
      add_inlined_method__244___object(set_escaping_fun__env_225_globalize_escape, global_ast_var, ((long) 0));
      add_inlined_method__244___object(set_escaping_fun__env_225_globalize_escape, global_ginfo_75_globalize_ginfo, ((long) 1));
      add_inlined_method__244___object(set_escaping_fun__env_225_globalize_escape, local_ginfo_108_globalize_ginfo, ((long) 2));
      add_generic__110___object(escape__env_201_globalize_escape, escape__default1606_env_210_globalize_escape);
      add_inlined_method__244___object(escape__env_201_globalize_escape, atom_ast_node, ((long) 0));
      add_inlined_method__244___object(escape__env_201_globalize_escape, kwote_ast_node, ((long) 1));
      add_inlined_method__244___object(escape__env_201_globalize_escape, var_ast_node, ((long) 2));
      add_inlined_method__244___object(escape__env_201_globalize_escape, closure_ast_node, ((long) 3));
      add_inlined_method__244___object(escape__env_201_globalize_escape, sequence_ast_node, ((long) 4));
      add_inlined_method__244___object(escape__env_201_globalize_escape, app_ast_node, ((long) 5));
      add_inlined_method__244___object(escape__env_201_globalize_escape, app_ly_162_ast_node, ((long) 6));
      add_inlined_method__244___object(escape__env_201_globalize_escape, funcall_ast_node, ((long) 7));
      add_inlined_method__244___object(escape__env_201_globalize_escape, pragma_ast_node, ((long) 8));
      add_inlined_method__244___object(escape__env_201_globalize_escape, cast_ast_node, ((long) 9));
      add_inlined_method__244___object(escape__env_201_globalize_escape, setq_ast_node, ((long) 10));
      add_inlined_method__244___object(escape__env_201_globalize_escape, conditional_ast_node, ((long) 11));
      add_inlined_method__244___object(escape__env_201_globalize_escape, fail_ast_node, ((long) 12));
      add_inlined_method__244___object(escape__env_201_globalize_escape, select_ast_node, ((long) 13));
      add_inlined_method__244___object(escape__env_201_globalize_escape, let_fun_218_ast_node, ((long) 14));
      add_inlined_method__244___object(escape__env_201_globalize_escape, let_var_6_ast_node, ((long) 15));
      add_inlined_method__244___object(escape__env_201_globalize_escape, set_ex_it_116_ast_node, ((long) 16));
      add_inlined_method__244___object(escape__env_201_globalize_escape, jump_ex_it_184_ast_node, ((long) 17));
      add_inlined_method__244___object(escape__env_201_globalize_escape, make_box_202_ast_node, ((long) 18));
      add_inlined_method__244___object(escape__env_201_globalize_escape, box_set__221_ast_node, ((long) 19));
      {		/* Globalize/escape.scm 14 */
	 long aux_2130;
	 aux_2130 =
	    add_inlined_method__244___object(escape__env_201_globalize_escape, box_ref_242_ast_node, ((long) 20));
	 return
	    BINT(aux_2130);
      }
   }
}



/* escape-fun! */
obj_t 
escape_fun__53_globalize_escape(variable_bglt variable_1)
{
   AN_OBJECT;
   {	/* Globalize/escape.scm 26 */
      {
	 obj_t method1853_1603;
	 obj_t class1858_1604;
	 {	/* Globalize/escape.scm 26 */
	    obj_t arg1861_1601;
	    obj_t arg1862_1602;
	    {	/* Globalize/escape.scm 26 */
	       object_bglt obj_1729;
	       obj_1729 =
		  (object_bglt) (variable_1);
	       {	/* ./Llib/object.scm 2926 */
		  obj_t pre_method_105_1730;
		  pre_method_105_1730 =
		     PROCEDURE_REF(escape_fun__env_92_globalize_escape, ((long) 2));
		  if (
		     INTEGERP(pre_method_105_1730))
		    {	/* ./Llib/object.scm 2927 */
		       PROCEDURE_SET(escape_fun__env_92_globalize_escape, ((long) 2), BUNSPEC);
		       arg1861_1601 = pre_method_105_1730;
		    }
		  else
		    {	/* ./Llib/object.scm 2914 */
		       long obj_class_num_177_1735;
		       obj_class_num_177_1735 =
			  TYPE(obj_1729);
		       {	/* ./Llib/object.scm 2915 */
			  obj_t arg1176_1736;
			  arg1176_1736 =
			     PROCEDURE_REF(escape_fun__env_92_globalize_escape, ((long) 1));
			  {	/* ./Llib/object.scm 2738 */
			     long arg1177_1740;
			     {	/* ./Llib/object.scm 2738 */
				long arg1178_1741;
				arg1178_1741 =
				   OBJECT_TYPE;
				arg1177_1740 =
				   (obj_class_num_177_1735 - arg1178_1741);
			     }
			     arg1861_1601 =
				VECTOR_REF(arg1176_1736, arg1177_1740);
			  }
		       }
		    }
	       }
	    }
	    {	/* Globalize/escape.scm 26 */
	       object_bglt object_1746;
	       object_1746 =
		  (object_bglt) (variable_1);
	       {	/* ./Llib/object.scm 2695 */
		  long arg1179_1747;
		  {	/* ./Llib/object.scm 2695 */
		     long arg1180_1748;
		     long arg1181_1749;
		     arg1180_1748 =
			TYPE(object_1746);
		     arg1181_1749 =
			OBJECT_TYPE;
		     arg1179_1747 =
			(arg1180_1748 - arg1181_1749);
		  }
		  {	/* ./Llib/object.scm 2695 */
		     obj_t vector_1753;
		     vector_1753 = _classes__134___object;
		     arg1862_1602 =
			VECTOR_REF(vector_1753, arg1179_1747);
		  }
	       }
	    }
	    method1853_1603 = arg1861_1601;
	    class1858_1604 = arg1862_1602;
	  _anonymous_1863__44_1605:
	    {

	       {

		  if (
		     INTEGERP(method1853_1603))
		    {	/* Globalize/escape.scm 26 */
		       switch (
			  (long) CINT(method1853_1603))
			 {
			 case ((long) 0):

			    {	/* Globalize/escape.scm 26 */
			       global_bglt variable_1610;
			       variable_1610 =
				  (global_bglt) (variable_1);
			       {	/* Globalize/escape.scm 38 */
				  bool_t test1865_1611;
				  test1865_1611 =
				     is_a__118___object(
				     (obj_t) (variable_1610), global_ginfo_75_globalize_ginfo);
				  if (test1865_1611)
				    {	/* Globalize/escape.scm 38 */
				       BUNSPEC;
				    }
				  else
				    {	/* Globalize/escape.scm 39 */
				       global_ginfo_75_bglt obj1559_1612;
				       obj1559_1612 =
					  ((global_ginfo_75_bglt) (variable_1610));
				       {	/* Globalize/escape.scm 40 */
					  global_ginfo_75_bglt arg1866_1613;
					  {	/* Globalize/escape.scm 40 */
					     bool_t arg1867_1614;
					     {	/* ./Ieee/equiv.scm 5508 */
						obj_t aux_2157;
						obj_t aux_2155;
						aux_2157 =
						   CNST_TABLE_REF(((long) 0));
						aux_2155 =
						   (((global_bglt) CREF(variable_1610))->import);
						arg1867_1614 =
						   (aux_2155 == aux_2157);
					     }
					     {	/* Globalize/escape.scm 39 */
						global_ginfo_75_bglt res1879_1764;
						{	/* Globalize/escape.scm 39 */
						   obj_t global_closure_229_1760;
						   global_closure_229_1760 = BFALSE;
						   {	/* ./Globalize/ginfo.scm 1126 */
						      global_ginfo_75_bglt new1547_1761;
						      new1547_1761 =
							 ((global_ginfo_75_bglt) BREF(GC_MALLOC(sizeof(struct global_ginfo_75))));
						      ((((global_ginfo_75_bglt) CREF(new1547_1761))->escape__117) = ((bool_t) arg1867_1614), BUNSPEC);
						      ((((global_ginfo_75_bglt) CREF(new1547_1761))->global_closure_229) = ((obj_t) global_closure_229_1760), BUNSPEC);
						      res1879_1764 = new1547_1761;
						   }
						}
						arg1866_1613 = res1879_1764;
					     }
					  }
					  {	/* Globalize/escape.scm 39 */
					     obj_t aux_2165;
					     object_bglt aux_2163;
					     aux_2165 =
						(obj_t) (arg1866_1613);
					     aux_2163 =
						(object_bglt) (obj1559_1612);
					     OBJECT_WIDENING_SET(aux_2163, aux_2165);
					  }
				       }
				       {	/* Globalize/escape.scm 39 */
					  long arg1870_1617;
					  arg1870_1617 =
					     class_num_218___object(global_ginfo_75_globalize_ginfo);
					  {	/* Globalize/escape.scm 39 */
					     obj_t obj_1765;
					     obj_1765 =
						(obj_t) (obj1559_1612);
					     (((obj_t) CREF(obj_1765))->header = MAKE_HEADER(arg1870_1617, 0), BUNSPEC);
					  }
				       }
				       (obj_t) (obj1559_1612);
				    }
			       }
			     _anonymous_1875__232_1624:
			       {	/* Globalize/escape.scm 26 */
				  obj_t aux1856_1626;
				  {	/* Globalize/escape.scm 26 */
				     obj_t aux_2172;
				     if (
					class__60___object(class1858_1604))
				       {	/* Globalize/escape.scm 26 */
					  aux_2172 =
					     class_super_145___object(class1858_1604)
					     ;
				       }
				     else
				       {	/* Globalize/escape.scm 26 */
					  aux_2172 = BFALSE
					     ;
				       }
				     aux1856_1626 =
					find_method_from_44___object(
					(object_bglt) (variable_1), escape_fun__env_92_globalize_escape, aux_2172);
				  }
				  {	/* Globalize/escape.scm 26 */

				     {
					obj_t class1858_2180;
					obj_t method1853_2178;
					method1853_2178 =
					   CDR(aux1856_1626);
					class1858_2180 =
					   CAR(aux1856_1626);
					class1858_1604 = class1858_2180;
					method1853_1603 = method1853_2178;
					goto _anonymous_1863__44_1605;
				     }
				  }
			       }
			    }
			    break;
			 case ((long) 1):

			    {	/* Globalize/escape.scm 26 */
			       local_bglt variable_1618;
			       variable_1618 =
				  (local_bglt) (variable_1);
			       {	/* Globalize/escape.scm 47 */
				  bool_t test1871_1619;
				  test1871_1619 =
				     is_a__118___object(
				     (obj_t) (variable_1618), local_ginfo_108_globalize_ginfo);
				  if (test1871_1619)
				    {	/* Globalize/escape.scm 47 */
				       BUNSPEC;
				    }
				  else
				    {	/* Globalize/escape.scm 48 */
				       local_ginfo_108_bglt obj1560_1620;
				       obj1560_1620 =
					  ((local_ginfo_108_bglt) (variable_1618));
				       {	/* Globalize/escape.scm 48 */
					  local_ginfo_108_bglt arg1872_1621;
					  {	/* Globalize/escape.scm 48 */
					     local_ginfo_108_bglt res1880_1771;
					     {	/* ./Globalize/ginfo.scm 1122 */
						local_ginfo_108_bglt new1527_1769;
						new1527_1769 =
						   ((local_ginfo_108_bglt) BREF(GC_MALLOC(sizeof(struct local_ginfo_108))));
						((((local_ginfo_108_bglt) CREF(new1527_1769))->escape__117) = ((bool_t) ((bool_t) 0)), BUNSPEC);
						res1880_1771 = new1527_1769;
					     }
					     arg1872_1621 = res1880_1771;
					  }
					  {	/* Globalize/escape.scm 48 */
					     obj_t aux_2191;
					     object_bglt aux_2189;
					     aux_2191 =
						(obj_t) (arg1872_1621);
					     aux_2189 =
						(object_bglt) (obj1560_1620);
					     OBJECT_WIDENING_SET(aux_2189, aux_2191);
					  }
				       }
				       {	/* Globalize/escape.scm 48 */
					  long arg1873_1622;
					  arg1873_1622 =
					     class_num_218___object(local_ginfo_108_globalize_ginfo);
					  {	/* Globalize/escape.scm 48 */
					     obj_t obj_1772;
					     obj_1772 =
						(obj_t) (obj1560_1620);
					     (((obj_t) CREF(obj_1772))->header = MAKE_HEADER(arg1873_1622, 0), BUNSPEC);
					  }
				       }
				       (obj_t) (obj1560_1620);
				    }
			       }
			       goto _anonymous_1875__232_1624;
			    }
			    break;
			 default:
			  case_else1859_1607:
			    if (
			       PROCEDUREP(method1853_1603))
			      {		/* Globalize/escape.scm 26 */
				 return
				    PROCEDURE_ENTRY(method1853_1603) (method1853_1603,
				    (obj_t) (variable_1), BEOA);
			      }
			    else
			      {		/* Globalize/escape.scm 26 */
				 obj_t fun1741_1422;
				 fun1741_1422 =
				    PROCEDURE_REF(escape_fun__env_92_globalize_escape, ((long) 0));
				 return
				    PROCEDURE_ENTRY(fun1741_1422) (fun1741_1422,
				    (obj_t) (variable_1), BEOA);
			      }
			 }
		    }
		  else
		    {	/* Globalize/escape.scm 26 */
		       goto case_else1859_1607;
		    }
	       }
	    }
	 }
      }
   }
}



/* _escape-fun! */
obj_t 
_escape_fun__253_globalize_escape(obj_t env_2051, obj_t variable_2052)
{
   AN_OBJECT;
   {	/* Globalize/escape.scm 26 */
      return
	 escape_fun__53_globalize_escape(
	 (variable_bglt) (variable_2052));
   }
}



/* escape-fun!-default1593 */
obj_t 
escape_fun__default1593_18_globalize_escape(variable_bglt variable_2)
{
   AN_OBJECT;
   {	/* Globalize/escape.scm 14 */
      {		/* Globalize/escape.scm 27 */
	 value_bglt fun_1423;
	 fun_1423 =
	    (((variable_bglt) CREF(variable_2))->value);
	 {
	    obj_t l1554_1424;
	    {	/* Globalize/escape.scm 30 */
	       sfun_bglt obj_1779;
	       obj_1779 =
		  (sfun_bglt) (fun_1423);
	       l1554_1424 =
		  (((sfun_bglt) CREF(obj_1779))->args);
	    }
	  lname1555_1425:
	    if (
	       PAIRP(l1554_1424))
	      {		/* Globalize/escape.scm 28 */
		 {	/* Globalize/escape.scm 29 */
		    obj_t local_1428;
		    local_1428 =
		       CAR(l1554_1424);
		    {	/* Globalize/escape.scm 29 */
		       svar_ginfo_131_bglt obj1557_1429;
		       {
			  value_bglt aux_2215;
			  {	/* Globalize/escape.scm 29 */
			     local_bglt obj_1782;
			     obj_1782 =
				(local_bglt) (local_1428);
			     aux_2215 =
				(((local_bglt) CREF(obj_1782))->value);
			  }
			  obj1557_1429 =
			     ((svar_ginfo_131_bglt) (aux_2215));
		       }
		       {	/* Globalize/escape.scm 29 */
			  svar_ginfo_131_bglt arg1744_1430;
			  {	/* Globalize/escape.scm 29 */
			     svar_ginfo_131_bglt res1882_1792;
			     {	/* ./Globalize/ginfo.scm 1102 */
				svar_ginfo_131_bglt new1494_1787;
				new1494_1787 =
				   ((svar_ginfo_131_bglt) BREF(GC_MALLOC(sizeof(struct svar_ginfo_131))));
				((((svar_ginfo_131_bglt) CREF(new1494_1787))->kaptured__204) = ((bool_t) ((bool_t) 0)), BUNSPEC);
				((((svar_ginfo_131_bglt) CREF(new1494_1787))->free_mark_81) = ((long) ((long) -10)), BUNSPEC);
				((((svar_ginfo_131_bglt) CREF(new1494_1787))->mark) = ((long) ((long) -10)), BUNSPEC);
				((((svar_ginfo_131_bglt) CREF(new1494_1787))->celled__113) = ((bool_t) ((bool_t) 0)), BUNSPEC);
				res1882_1792 = new1494_1787;
			     }
			     arg1744_1430 = res1882_1792;
			  }
			  {	/* Globalize/escape.scm 29 */
			     obj_t aux_2226;
			     object_bglt aux_2224;
			     aux_2226 =
				(obj_t) (arg1744_1430);
			     aux_2224 =
				(object_bglt) (obj1557_1429);
			     OBJECT_WIDENING_SET(aux_2224, aux_2226);
			  }
		       }
		       {	/* Globalize/escape.scm 29 */
			  long arg1745_1431;
			  arg1745_1431 =
			     class_num_218___object(svar_ginfo_131_globalize_ginfo);
			  {	/* Globalize/escape.scm 29 */
			     obj_t obj_1793;
			     obj_1793 =
				(obj_t) (obj1557_1429);
			     (((obj_t) CREF(obj_1793))->header = MAKE_HEADER(arg1745_1431, 0), BUNSPEC);
			  }
		       }
		       obj1557_1429;
		    }
		 }
		 {
		    obj_t l1554_2232;
		    l1554_2232 =
		       CDR(l1554_1424);
		    l1554_1424 = l1554_2232;
		    goto lname1555_1425;
		 }
	      }
	    else
	      {		/* Globalize/escape.scm 28 */
		 ((bool_t) 1);
	      }
	 }
	 {	/* Globalize/escape.scm 31 */
	    sfun_ginfo_98_bglt obj1558_1433;
	    obj1558_1433 =
	       ((sfun_ginfo_98_bglt) (fun_1423));
	    {	/* Globalize/escape.scm 31 */
	       sfun_ginfo_98_bglt arg1747_1434;
	       {	/* Globalize/escape.scm 31 */
		  sfun_ginfo_98_bglt res1883_1833;
		  {	/* Globalize/escape.scm 31 */
		     obj_t cfrom__119_1798;
		     obj_t cto__14_1800;
		     obj_t the_global_201_1807;
		     obj_t kaptured_1808;
		     obj_t new_body_215_1809;
		     cfrom__119_1798 = BFALSE;
		     cto__14_1800 = BFALSE;
		     the_global_201_1807 = BFALSE;
		     kaptured_1808 = BFALSE;
		     new_body_215_1809 = BFALSE;
		     {	/* ./Globalize/ginfo.scm 1064 */
			sfun_ginfo_98_bglt new1466_1814;
			new1466_1814 =
			   ((sfun_ginfo_98_bglt) BREF(GC_MALLOC(sizeof(struct sfun_ginfo_98))));
			((((sfun_ginfo_98_bglt) CREF(new1466_1814))->g__219) = ((bool_t) ((bool_t) 0)), BUNSPEC);
			((((sfun_ginfo_98_bglt) CREF(new1466_1814))->cfrom) = ((obj_t) BNIL), BUNSPEC);
			((((sfun_ginfo_98_bglt) CREF(new1466_1814))->cfrom__119) = ((obj_t) cfrom__119_1798), BUNSPEC);
			((((sfun_ginfo_98_bglt) CREF(new1466_1814))->cto) = ((obj_t) BNIL), BUNSPEC);
			((((sfun_ginfo_98_bglt) CREF(new1466_1814))->cto__14) = ((obj_t) cto__14_1800), BUNSPEC);
			((((sfun_ginfo_98_bglt) CREF(new1466_1814))->cfunction) = ((obj_t) BNIL), BUNSPEC);
			((((sfun_ginfo_98_bglt) CREF(new1466_1814))->integrator) = ((obj_t) BNIL), BUNSPEC);
			((((sfun_ginfo_98_bglt) CREF(new1466_1814))->integrated) = ((obj_t) BNIL), BUNSPEC);
			((((sfun_ginfo_98_bglt) CREF(new1466_1814))->plugged_in_15) = ((obj_t) BNIL), BUNSPEC);
			((((sfun_ginfo_98_bglt) CREF(new1466_1814))->mark) = ((long) ((long) -10)), BUNSPEC);
			((((sfun_ginfo_98_bglt) CREF(new1466_1814))->free_mark_81) = ((obj_t) BNIL), BUNSPEC);
			((((sfun_ginfo_98_bglt) CREF(new1466_1814))->the_global_201) = ((obj_t) the_global_201_1807), BUNSPEC);
			((((sfun_ginfo_98_bglt) CREF(new1466_1814))->kaptured) = ((obj_t) kaptured_1808), BUNSPEC);
			((((sfun_ginfo_98_bglt) CREF(new1466_1814))->new_body_215) = ((obj_t) new_body_215_1809), BUNSPEC);
			((((sfun_ginfo_98_bglt) CREF(new1466_1814))->bmark) = ((long) ((long) -10)), BUNSPEC);
			((((sfun_ginfo_98_bglt) CREF(new1466_1814))->umark) = ((long) ((long) -10)), BUNSPEC);
			((((sfun_ginfo_98_bglt) CREF(new1466_1814))->free) = ((obj_t) BUNSPEC), BUNSPEC);
			((((sfun_ginfo_98_bglt) CREF(new1466_1814))->bound) = ((obj_t) BNIL), BUNSPEC);
			res1883_1833 = new1466_1814;
		     }
		  }
		  arg1747_1434 = res1883_1833;
	       }
	       {	/* Globalize/escape.scm 31 */
		  obj_t aux_2258;
		  object_bglt aux_2256;
		  aux_2258 =
		     (obj_t) (arg1747_1434);
		  aux_2256 =
		     (object_bglt) (obj1558_1433);
		  OBJECT_WIDENING_SET(aux_2256, aux_2258);
	       }
	    }
	    {	/* Globalize/escape.scm 31 */
	       long arg1748_1435;
	       arg1748_1435 =
		  class_num_218___object(sfun_ginfo_98_globalize_ginfo);
	       {	/* Globalize/escape.scm 31 */
		  obj_t obj_1834;
		  obj_1834 =
		     (obj_t) (obj1558_1433);
		  (((obj_t) CREF(obj_1834))->header = MAKE_HEADER(arg1748_1435, 0), BUNSPEC);
	       }
	    }
	    obj1558_1433;
	 }
	 {	/* Globalize/escape.scm 32 */
	    node_bglt aux_2264;
	    {	/* Globalize/escape.scm 32 */
	       obj_t aux_2265;
	       {	/* Globalize/escape.scm 32 */
		  sfun_bglt obj_1836;
		  obj_1836 =
		     (sfun_bglt) (fun_1423);
		  aux_2265 =
		     (((sfun_bglt) CREF(obj_1836))->body);
	       }
	       aux_2264 =
		  (node_bglt) (aux_2265);
	    }
	    return
	       escape__235_globalize_escape(aux_2264);
	 }
      }
   }
}



/* _escape-fun!-default1593 */
obj_t 
_escape_fun__default1593_81_globalize_escape(obj_t env_2053, obj_t variable_2054)
{
   AN_OBJECT;
   {	/* Globalize/escape.scm 14 */
      return
	 escape_fun__default1593_18_globalize_escape(
	 (variable_bglt) (variable_2054));
   }
}



/* set-escaping-fun! */
obj_t 
set_escaping_fun__14_globalize_escape(variable_bglt variable_5)
{
   AN_OBJECT;
   {	/* Globalize/escape.scm 54 */
      {
	 obj_t method1833_1577;
	 obj_t class1838_1578;
	 {	/* Globalize/escape.scm 54 */
	    obj_t arg1841_1575;
	    obj_t arg1842_1576;
	    {	/* Globalize/escape.scm 54 */
	       object_bglt obj_1837;
	       obj_1837 =
		  (object_bglt) (variable_5);
	       {	/* ./Llib/object.scm 2926 */
		  obj_t pre_method_105_1838;
		  pre_method_105_1838 =
		     PROCEDURE_REF(set_escaping_fun__env_225_globalize_escape, ((long) 2));
		  if (
		     INTEGERP(pre_method_105_1838))
		    {	/* ./Llib/object.scm 2927 */
		       PROCEDURE_SET(set_escaping_fun__env_225_globalize_escape, ((long) 2), BUNSPEC);
		       arg1841_1575 = pre_method_105_1838;
		    }
		  else
		    {	/* ./Llib/object.scm 2914 */
		       long obj_class_num_177_1843;
		       obj_class_num_177_1843 =
			  TYPE(obj_1837);
		       {	/* ./Llib/object.scm 2915 */
			  obj_t arg1176_1844;
			  arg1176_1844 =
			     PROCEDURE_REF(set_escaping_fun__env_225_globalize_escape, ((long) 1));
			  {	/* ./Llib/object.scm 2738 */
			     long arg1177_1848;
			     {	/* ./Llib/object.scm 2738 */
				long arg1178_1849;
				arg1178_1849 =
				   OBJECT_TYPE;
				arg1177_1848 =
				   (obj_class_num_177_1843 - arg1178_1849);
			     }
			     arg1841_1575 =
				VECTOR_REF(arg1176_1844, arg1177_1848);
			  }
		       }
		    }
	       }
	    }
	    {	/* Globalize/escape.scm 54 */
	       object_bglt object_1854;
	       object_1854 =
		  (object_bglt) (variable_5);
	       {	/* ./Llib/object.scm 2695 */
		  long arg1179_1855;
		  {	/* ./Llib/object.scm 2695 */
		     long arg1180_1856;
		     long arg1181_1857;
		     arg1180_1856 =
			TYPE(object_1854);
		     arg1181_1857 =
			OBJECT_TYPE;
		     arg1179_1855 =
			(arg1180_1856 - arg1181_1857);
		  }
		  {	/* ./Llib/object.scm 2695 */
		     obj_t vector_1861;
		     vector_1861 = _classes__134___object;
		     arg1842_1576 =
			VECTOR_REF(vector_1861, arg1179_1855);
		  }
	       }
	    }
	    method1833_1577 = arg1841_1575;
	    class1838_1578 = arg1842_1576;
	    {

	       if (
		  INTEGERP(method1833_1577))
		 {	/* Globalize/escape.scm 54 */
		    switch (
		       (long) CINT(method1833_1577))
		      {
		      case ((long) 0):

			 {	/* Globalize/escape.scm 63 */
			    global_bglt variable_1584;
			    variable_1584 =
			       (global_bglt) (variable_5);
			    {	/* Globalize/escape.scm 63 */
			       global_ginfo_75_bglt obj1561_1585;
			       obj1561_1585 =
				  ((global_ginfo_75_bglt) (variable_1584));
			       {	/* Globalize/escape.scm 63 */
				  global_ginfo_75_bglt arg1845_1586;
				  {	/* Globalize/escape.scm 63 */
				     global_ginfo_75_bglt res1884_1868;
				     {	/* Globalize/escape.scm 63 */
					obj_t global_closure_229_1864;
					global_closure_229_1864 = BFALSE;
					{	/* ./Globalize/ginfo.scm 1126 */
					   global_ginfo_75_bglt new1547_1865;
					   new1547_1865 =
					      ((global_ginfo_75_bglt) BREF(GC_MALLOC(sizeof(struct global_ginfo_75))));
					   ((((global_ginfo_75_bglt) CREF(new1547_1865))->escape__117) = ((bool_t) ((bool_t) 1)), BUNSPEC);
					   ((((global_ginfo_75_bglt) CREF(new1547_1865))->global_closure_229) = ((obj_t) global_closure_229_1864), BUNSPEC);
					   res1884_1868 = new1547_1865;
					}
				     }
				     arg1845_1586 = res1884_1868;
				  }
				  {	/* Globalize/escape.scm 63 */
				     obj_t aux_2296;
				     object_bglt aux_2294;
				     aux_2296 =
					(obj_t) (arg1845_1586);
				     aux_2294 =
					(object_bglt) (obj1561_1585);
				     OBJECT_WIDENING_SET(aux_2294, aux_2296);
				  }
			       }
			       {	/* Globalize/escape.scm 63 */
				  long arg1847_1588;
				  arg1847_1588 =
				     class_num_218___object(global_ginfo_75_globalize_ginfo);
				  {	/* Globalize/escape.scm 63 */
				     obj_t obj_1869;
				     obj_1869 =
					(obj_t) (obj1561_1585);
				     (((obj_t) CREF(obj_1869))->header = MAKE_HEADER(arg1847_1588, 0), BUNSPEC);
				  }
			       }
			       return
				  (obj_t) (obj1561_1585);
			    }
			 }
			 break;
		      case ((long) 1):

			 {	/* Globalize/escape.scm 69 */
			    global_ginfo_75_bglt variable_1589;
			    variable_1589 =
			       (global_ginfo_75_bglt) (variable_5);
			    {
			       obj_t aux_2304;
			       {	/* ./Globalize/ginfo.scm 1128 */
				  object_bglt aux_2305;
				  aux_2305 =
				     (object_bglt) (variable_1589);
				  aux_2304 =
				     OBJECT_WIDENING(aux_2305);
			       }
			       return
				  ((((global_ginfo_75_bglt) CREF(aux_2304))->escape__117) = ((bool_t) ((bool_t) 1)), BUNSPEC);
			    }
			 }
			 break;
		      case ((long) 2):

			 {	/* Globalize/escape.scm 75 */
			    local_ginfo_108_bglt variable_1590;
			    variable_1590 =
			       (local_ginfo_108_bglt) (variable_5);
			    {
			       obj_t aux_2310;
			       {	/* ./Globalize/ginfo.scm 1124 */
				  object_bglt aux_2311;
				  aux_2311 =
				     (object_bglt) (variable_1590);
				  aux_2310 =
				     OBJECT_WIDENING(aux_2311);
			       }
			       return
				  ((((local_ginfo_108_bglt) CREF(aux_2310))->escape__117) = ((bool_t) ((bool_t) 1)), BUNSPEC);
			    }
			 }
			 break;
		      default:
		       case_else1839_1581:
			 if (
			    PROCEDUREP(method1833_1577))
			   {	/* Globalize/escape.scm 54 */
			      return
				 PROCEDURE_ENTRY(method1833_1577) (method1833_1577,
				 (obj_t) (variable_5), BEOA);
			   }
			 else
			   {	/* Globalize/escape.scm 54 */
			      obj_t fun1750_1437;
			      fun1750_1437 =
				 PROCEDURE_REF(set_escaping_fun__env_225_globalize_escape, ((long) 0));
			      return
				 PROCEDURE_ENTRY(fun1750_1437) (fun1750_1437,
				 (obj_t) (variable_5), BEOA);
			   }
		      }
		 }
	       else
		 {	/* Globalize/escape.scm 54 */
		    goto case_else1839_1581;
		 }
	    }
	 }
      }
   }
}



/* _set-escaping-fun! */
obj_t 
_set_escaping_fun__208_globalize_escape(obj_t env_2055, obj_t variable_2056)
{
   AN_OBJECT;
   {	/* Globalize/escape.scm 54 */
      return
	 set_escaping_fun__14_globalize_escape(
	 (variable_bglt) (variable_2056));
   }
}



/* set-escaping-fun!-default1598 */
obj_t 
set_escaping_fun__default1598_240_globalize_escape(variable_bglt variable_6)
{
   AN_OBJECT;
   {	/* Globalize/escape.scm 14 */
      {		/* Globalize/escape.scm 55 */
	 obj_t arg1753_1440;
	 {	/* Globalize/escape.scm 57 */
	    obj_t arg1754_1441;
	    arg1754_1441 =
	       shape_tools_shape(
	       (obj_t) (variable_6));
	    {	/* ./Ieee/pair-list.scm 5689 */
	       obj_t aux_2330;
	       aux_2330 =
		  (obj_t) (variable_6);
	       arg1753_1440 =
		  MAKE_PAIR(aux_2330, arg1754_1441);
	    }
	 }
	 FAILURE(string1892_globalize_escape, string1893_globalize_escape, arg1753_1440);
      }
   }
}



/* _set-escaping-fun!-default1598 */
obj_t 
_set_escaping_fun__default1598_158_globalize_escape(obj_t env_2057, obj_t variable_2058)
{
   AN_OBJECT;
   {	/* Globalize/escape.scm 14 */
      return
	 set_escaping_fun__default1598_240_globalize_escape(
	 (variable_bglt) (variable_2058));
   }
}



/* escape! */
obj_t 
escape__235_globalize_escape(node_bglt node_10)
{
   AN_OBJECT;
   {	/* Globalize/escape.scm 80 */
    escape__235_globalize_escape:
      {
	 obj_t method1756_1446;
	 obj_t class1761_1447;
	 {	/* Globalize/escape.scm 80 */
	    obj_t arg1764_1444;
	    obj_t arg1765_1445;
	    {	/* Globalize/escape.scm 80 */
	       object_bglt obj_1882;
	       obj_1882 =
		  (object_bglt) (node_10);
	       {	/* ./Llib/object.scm 2926 */
		  obj_t pre_method_105_1883;
		  pre_method_105_1883 =
		     PROCEDURE_REF(escape__env_201_globalize_escape, ((long) 2));
		  if (
		     INTEGERP(pre_method_105_1883))
		    {	/* ./Llib/object.scm 2927 */
		       PROCEDURE_SET(escape__env_201_globalize_escape, ((long) 2), BUNSPEC);
		       arg1764_1444 = pre_method_105_1883;
		    }
		  else
		    {	/* ./Llib/object.scm 2914 */
		       long obj_class_num_177_1888;
		       obj_class_num_177_1888 =
			  TYPE(obj_1882);
		       {	/* ./Llib/object.scm 2915 */
			  obj_t arg1176_1889;
			  arg1176_1889 =
			     PROCEDURE_REF(escape__env_201_globalize_escape, ((long) 1));
			  {	/* ./Llib/object.scm 2738 */
			     long arg1177_1893;
			     {	/* ./Llib/object.scm 2738 */
				long arg1178_1894;
				arg1178_1894 =
				   OBJECT_TYPE;
				arg1177_1893 =
				   (obj_class_num_177_1888 - arg1178_1894);
			     }
			     arg1764_1444 =
				VECTOR_REF(arg1176_1889, arg1177_1893);
			  }
		       }
		    }
	       }
	    }
	    {	/* Globalize/escape.scm 80 */
	       object_bglt object_1899;
	       object_1899 =
		  (object_bglt) (node_10);
	       {	/* ./Llib/object.scm 2695 */
		  long arg1179_1900;
		  {	/* ./Llib/object.scm 2695 */
		     long arg1180_1901;
		     long arg1181_1902;
		     arg1180_1901 =
			TYPE(object_1899);
		     arg1181_1902 =
			OBJECT_TYPE;
		     arg1179_1900 =
			(arg1180_1901 - arg1181_1902);
		  }
		  {	/* ./Llib/object.scm 2695 */
		     obj_t vector_1906;
		     vector_1906 = _classes__134___object;
		     arg1765_1445 =
			VECTOR_REF(vector_1906, arg1179_1900);
		  }
	       }
	    }
	    method1756_1446 = arg1764_1444;
	    class1761_1447 = arg1765_1445;
	    {

	       if (
		  INTEGERP(method1756_1446))
		 {	/* Globalize/escape.scm 80 */
		    switch (
		       (long) CINT(method1756_1446))
		      {
		      case ((long) 0):

			 return
			    CNST_TABLE_REF(((long) 1));
			 break;
		      case ((long) 1):

			 return
			    CNST_TABLE_REF(((long) 1));
			 break;
		      case ((long) 2):

			 return
			    CNST_TABLE_REF(((long) 1));
			 break;
		      case ((long) 3):

			 {	/* Globalize/escape.scm 104 */
			    closure_bglt node_1456;
			    node_1456 =
			       (closure_bglt) (node_10);
			    return
			       set_escaping_fun__14_globalize_escape(
			       (((closure_bglt) CREF(node_1456))->variable));
			 }
			 break;
		      case ((long) 4):

			 {	/* Globalize/escape.scm 110 */
			    sequence_bglt node_1458;
			    node_1458 =
			       (sequence_bglt) (node_10);
			    {	/* Globalize/escape.scm 110 */
			       bool_t aux_2360;
			       aux_2360 =
				  escape___220_globalize_escape(
				  (((sequence_bglt) CREF(node_1458))->nodes));
			       return
				  BBOOL(aux_2360);
			    }
			 }
			 break;
		      case ((long) 5):

			 {	/* Globalize/escape.scm 116 */
			    app_bglt node_1460;
			    node_1460 =
			       (app_bglt) (node_10);
			    {	/* Globalize/escape.scm 117 */
			       bool_t aux_2365;
			       aux_2365 =
				  escape___220_globalize_escape(
				  (((app_bglt) CREF(node_1460))->args));
			       return
				  BBOOL(aux_2365);
			    }
			 }
			 break;
		      case ((long) 6):

			 {	/* Globalize/escape.scm 123 */
			    app_ly_162_bglt node_1463;
			    node_1463 =
			       (app_ly_162_bglt) (node_10);
			    escape__235_globalize_escape(
			       (((app_ly_162_bglt) CREF(node_1463))->fun));
			    {
			       node_bglt node_2372;
			       node_2372 =
				  (((app_ly_162_bglt) CREF(node_1463))->arg);
			       node_10 = node_2372;
			       goto escape__235_globalize_escape;
			    }
			 }
			 break;
		      case ((long) 7):

			 {	/* Globalize/escape.scm 131 */
			    funcall_bglt node_1467;
			    node_1467 =
			       (funcall_bglt) (node_10);
			    escape__235_globalize_escape(
			       (((funcall_bglt) CREF(node_1467))->fun));
			    {	/* Globalize/escape.scm 133 */
			       bool_t aux_2377;
			       aux_2377 =
				  escape___220_globalize_escape(
				  (((funcall_bglt) CREF(node_1467))->args));
			       return
				  BBOOL(aux_2377);
			    }
			 }
			 break;
		      case ((long) 8):

			 {	/* Globalize/escape.scm 139 */
			    pragma_bglt node_1471;
			    node_1471 =
			       (pragma_bglt) (node_10);
			    {	/* Globalize/escape.scm 139 */
			       bool_t aux_2382;
			       aux_2382 =
				  escape___220_globalize_escape(
				  (((pragma_bglt) CREF(node_1471))->args));
			       return
				  BBOOL(aux_2382);
			    }
			 }
			 break;
		      case ((long) 9):

			 {	/* Globalize/escape.scm 145 */
			    cast_bglt node_1473;
			    node_1473 =
			       (cast_bglt) (node_10);
			    {
			       node_bglt node_2387;
			       node_2387 =
				  (((cast_bglt) CREF(node_1473))->arg);
			       node_10 = node_2387;
			       goto escape__235_globalize_escape;
			    }
			 }
			 break;
		      case ((long) 10):

			 {	/* Globalize/escape.scm 151 */
			    setq_bglt node_1475;
			    node_1475 =
			       (setq_bglt) (node_10);
			    {
			       node_bglt node_2390;
			       node_2390 =
				  (((setq_bglt) CREF(node_1475))->value);
			       node_10 = node_2390;
			       goto escape__235_globalize_escape;
			    }
			 }
			 break;
		      case ((long) 11):

			 {	/* Globalize/escape.scm 158 */
			    conditional_bglt node_1478;
			    node_1478 =
			       (conditional_bglt) (node_10);
			    escape__235_globalize_escape(
			       (((conditional_bglt) CREF(node_1478))->test));
			    escape__235_globalize_escape(
			       (((conditional_bglt) CREF(node_1478))->true));
			    {
			       node_bglt node_2397;
			       node_2397 =
				  (((conditional_bglt) CREF(node_1478))->false);
			       node_10 = node_2397;
			       goto escape__235_globalize_escape;
			    }
			 }
			 break;
		      case ((long) 12):

			 {	/* Globalize/escape.scm 167 */
			    fail_bglt node_1483;
			    node_1483 =
			       (fail_bglt) (node_10);
			    escape__235_globalize_escape(
			       (((fail_bglt) CREF(node_1483))->proc));
			    escape__235_globalize_escape(
			       (((fail_bglt) CREF(node_1483))->msg));
			    {
			       node_bglt node_2404;
			       node_2404 =
				  (((fail_bglt) CREF(node_1483))->obj);
			       node_10 = node_2404;
			       goto escape__235_globalize_escape;
			    }
			 }
			 break;
		      case ((long) 13):

			 {	/* Globalize/escape.scm 176 */
			    select_bglt node_1488;
			    node_1488 =
			       (select_bglt) (node_10);
			    escape__235_globalize_escape(
			       (((select_bglt) CREF(node_1488))->test));
			    {
			       obj_t l1569_1491;
			       {	/* Globalize/escape.scm 178 */
				  bool_t aux_2409;
				  l1569_1491 =
				     (((select_bglt) CREF(node_1488))->clauses);
				lname1570_1492:
				  if (
				     PAIRP(l1569_1491))
				    {	/* Globalize/escape.scm 178 */
				       {	/* Globalize/escape.scm 179 */
					  node_bglt aux_2412;
					  {	/* Globalize/escape.scm 179 */
					     obj_t aux_2413;
					     {	/* ./Ieee/pair-list.scm 5707 */
						obj_t aux_2414;
						aux_2414 =
						   CAR(l1569_1491);
						aux_2413 =
						   CDR(aux_2414);
					     }
					     aux_2412 =
						(node_bglt) (aux_2413);
					  }
					  escape__235_globalize_escape(aux_2412);
				       }
				       {
					  obj_t l1569_2419;
					  l1569_2419 =
					     CDR(l1569_1491);
					  l1569_1491 = l1569_2419;
					  goto lname1570_1492;
				       }
				    }
				  else
				    {	/* Globalize/escape.scm 178 */
				       aux_2409 = ((bool_t) 1);
				    }
				  return
				     BBOOL(aux_2409);
			       }
			    }
			 }
			 break;
		      case ((long) 14):

			 {	/* Globalize/escape.scm 190 */
			    let_fun_218_bglt node_1498;
			    node_1498 =
			       (let_fun_218_bglt) (node_10);
			    {
			       obj_t l1572_1500;
			       l1572_1500 =
				  (((let_fun_218_bglt) CREF(node_1498))->locals);
			     lname1573_1501:
			       if (
				  PAIRP(l1572_1500))
				 {	/* Globalize/escape.scm 192 */
				    {	/* Globalize/escape.scm 192 */
				       obj_t local_1504;
				       local_1504 =
					  CAR(l1572_1500);
				       {	/* Globalize/escape.scm 193 */
					  local_ginfo_108_bglt obj1574_1505;
					  obj1574_1505 =
					     ((local_ginfo_108_bglt) (local_1504));
					  {	/* Globalize/escape.scm 193 */
					     local_ginfo_108_bglt arg1791_1506;
					     {	/* Globalize/escape.scm 193 */
						local_ginfo_108_bglt res1886_1936;
						{	/* ./Globalize/ginfo.scm 1122 */
						   local_ginfo_108_bglt new1527_1934;
						   new1527_1934 =
						      ((local_ginfo_108_bglt) BREF(GC_MALLOC(sizeof(struct local_ginfo_108))));
						   ((((local_ginfo_108_bglt) CREF(new1527_1934))->escape__117) = ((bool_t) ((bool_t) 0)), BUNSPEC);
						   res1886_1936 = new1527_1934;
						}
						arg1791_1506 = res1886_1936;
					     }
					     {	/* Globalize/escape.scm 193 */
						obj_t aux_2432;
						object_bglt aux_2430;
						aux_2432 =
						   (obj_t) (arg1791_1506);
						aux_2430 =
						   (object_bglt) (obj1574_1505);
						OBJECT_WIDENING_SET(aux_2430, aux_2432);
					     }
					  }
					  {	/* Globalize/escape.scm 193 */
					     long arg1792_1507;
					     arg1792_1507 =
						class_num_218___object(local_ginfo_108_globalize_ginfo);
					     {	/* Globalize/escape.scm 193 */
						obj_t obj_1937;
						obj_1937 =
						   (obj_t) (obj1574_1505);
						(((obj_t) CREF(obj_1937))->header = MAKE_HEADER(arg1792_1507, 0), BUNSPEC);
					     }
					  }
					  obj1574_1505;
				       }
				       {	/* Globalize/escape.scm 194 */
					  value_bglt fun_1508;
					  {	/* Globalize/escape.scm 194 */
					     local_bglt obj_1939;
					     obj_1939 =
						(local_bglt) (local_1504);
					     fun_1508 =
						(((local_bglt) CREF(obj_1939))->value);
					  }
					  {	/* Globalize/escape.scm 195 */
					     sfun_ginfo_98_bglt obj1575_1509;
					     obj1575_1509 =
						((sfun_ginfo_98_bglt) (fun_1508));
					     {	/* Globalize/escape.scm 195 */
						sfun_ginfo_98_bglt arg1793_1510;
						{	/* Globalize/escape.scm 195 */
						   sfun_ginfo_98_bglt res1887_1977;
						   {	/* Globalize/escape.scm 195 */
						      obj_t cfrom__119_1942;
						      obj_t cto__14_1944;
						      obj_t the_global_201_1951;
						      obj_t kaptured_1952;
						      obj_t new_body_215_1953;
						      cfrom__119_1942 = BFALSE;
						      cto__14_1944 = BFALSE;
						      the_global_201_1951 = BFALSE;
						      kaptured_1952 = BFALSE;
						      new_body_215_1953 = BFALSE;
						      {		/* ./Globalize/ginfo.scm 1064 */
							 sfun_ginfo_98_bglt new1466_1958;
							 new1466_1958 =
							    ((sfun_ginfo_98_bglt) BREF(GC_MALLOC(sizeof(struct sfun_ginfo_98))));
							 ((((sfun_ginfo_98_bglt) CREF(new1466_1958))->g__219) = ((bool_t) ((bool_t) 0)), BUNSPEC);
							 ((((sfun_ginfo_98_bglt) CREF(new1466_1958))->cfrom) = ((obj_t) BNIL), BUNSPEC);
							 ((((sfun_ginfo_98_bglt) CREF(new1466_1958))->cfrom__119) = ((obj_t) cfrom__119_1942), BUNSPEC);
							 ((((sfun_ginfo_98_bglt) CREF(new1466_1958))->cto) = ((obj_t) BNIL), BUNSPEC);
							 ((((sfun_ginfo_98_bglt) CREF(new1466_1958))->cto__14) = ((obj_t) cto__14_1944), BUNSPEC);
							 ((((sfun_ginfo_98_bglt) CREF(new1466_1958))->cfunction) = ((obj_t) BNIL), BUNSPEC);
							 ((((sfun_ginfo_98_bglt) CREF(new1466_1958))->integrator) = ((obj_t) BNIL), BUNSPEC);
							 ((((sfun_ginfo_98_bglt) CREF(new1466_1958))->integrated) = ((obj_t) BNIL), BUNSPEC);
							 ((((sfun_ginfo_98_bglt) CREF(new1466_1958))->plugged_in_15) = ((obj_t) BNIL), BUNSPEC);
							 ((((sfun_ginfo_98_bglt) CREF(new1466_1958))->mark) = ((long) ((long) -10)), BUNSPEC);
							 ((((sfun_ginfo_98_bglt) CREF(new1466_1958))->free_mark_81) = ((obj_t) BNIL), BUNSPEC);
							 ((((sfun_ginfo_98_bglt) CREF(new1466_1958))->the_global_201) = ((obj_t) the_global_201_1951), BUNSPEC);
							 ((((sfun_ginfo_98_bglt) CREF(new1466_1958))->kaptured) = ((obj_t) kaptured_1952), BUNSPEC);
							 ((((sfun_ginfo_98_bglt) CREF(new1466_1958))->new_body_215) = ((obj_t) new_body_215_1953), BUNSPEC);
							 ((((sfun_ginfo_98_bglt) CREF(new1466_1958))->bmark) = ((long) ((long) -10)), BUNSPEC);
							 ((((sfun_ginfo_98_bglt) CREF(new1466_1958))->umark) = ((long) ((long) -10)), BUNSPEC);
							 ((((sfun_ginfo_98_bglt) CREF(new1466_1958))->free) = ((obj_t) BUNSPEC), BUNSPEC);
							 ((((sfun_ginfo_98_bglt) CREF(new1466_1958))->bound) = ((obj_t) BNIL), BUNSPEC);
							 res1887_1977 = new1466_1958;
						      }
						   }
						   arg1793_1510 = res1887_1977;
						}
						{	/* Globalize/escape.scm 195 */
						   obj_t aux_2462;
						   object_bglt aux_2460;
						   aux_2462 =
						      (obj_t) (arg1793_1510);
						   aux_2460 =
						      (object_bglt) (obj1575_1509);
						   OBJECT_WIDENING_SET(aux_2460, aux_2462);
						}
					     }
					     {	/* Globalize/escape.scm 195 */
						long arg1794_1511;
						arg1794_1511 =
						   class_num_218___object(sfun_ginfo_98_globalize_ginfo);
						{	/* Globalize/escape.scm 195 */
						   obj_t obj_1978;
						   obj_1978 =
						      (obj_t) (obj1575_1509);
						   (((obj_t) CREF(obj_1978))->header = MAKE_HEADER(arg1794_1511, 0), BUNSPEC);
						}
					     }
					     obj1575_1509;
					  }
					  {
					     obj_t l1576_1512;
					     {	/* Globalize/escape.scm 198 */
						sfun_bglt obj_1980;
						obj_1980 =
						   (sfun_bglt) (fun_1508);
						l1576_1512 =
						   (((sfun_bglt) CREF(obj_1980))->args);
					     }
					   lname1577_1513:
					     if (
						PAIRP(l1576_1512))
					       {	/* Globalize/escape.scm 196 */
						  {	/* Globalize/escape.scm 197 */
						     obj_t local_1516;
						     local_1516 =
							CAR(l1576_1512);
						     {	/* Globalize/escape.scm 197 */
							svar_ginfo_131_bglt obj1579_1517;
							{
							   value_bglt aux_2471;
							   {	/* Globalize/escape.scm 197 */
							      local_bglt obj_1983;
							      obj_1983 =
								 (local_bglt) (local_1516);
							      aux_2471 =
								 (((local_bglt) CREF(obj_1983))->value);
							   }
							   obj1579_1517 =
							      ((svar_ginfo_131_bglt) (aux_2471));
							}
							{	/* Globalize/escape.scm 197 */
							   svar_ginfo_131_bglt arg1797_1518;
							   {	/* Globalize/escape.scm 197 */
							      svar_ginfo_131_bglt res1888_1993;
							      {		/* ./Globalize/ginfo.scm 1102 */
								 svar_ginfo_131_bglt new1494_1988;
								 new1494_1988 =
								    ((svar_ginfo_131_bglt) BREF(GC_MALLOC(sizeof(struct svar_ginfo_131))));
								 ((((svar_ginfo_131_bglt) CREF(new1494_1988))->kaptured__204) = ((bool_t) ((bool_t) 0)), BUNSPEC);
								 ((((svar_ginfo_131_bglt) CREF(new1494_1988))->free_mark_81) = ((long) ((long) -10)), BUNSPEC);
								 ((((svar_ginfo_131_bglt) CREF(new1494_1988))->mark) = ((long) ((long) -10)), BUNSPEC);
								 ((((svar_ginfo_131_bglt) CREF(new1494_1988))->celled__113) = ((bool_t) ((bool_t) 0)), BUNSPEC);
								 res1888_1993 = new1494_1988;
							      }
							      arg1797_1518 = res1888_1993;
							   }
							   {	/* Globalize/escape.scm 197 */
							      obj_t aux_2482;
							      object_bglt aux_2480;
							      aux_2482 =
								 (obj_t) (arg1797_1518);
							      aux_2480 =
								 (object_bglt) (obj1579_1517);
							      OBJECT_WIDENING_SET(aux_2480, aux_2482);
							   }
							}
							{	/* Globalize/escape.scm 197 */
							   long arg1798_1519;
							   arg1798_1519 =
							      class_num_218___object(svar_ginfo_131_globalize_ginfo);
							   {	/* Globalize/escape.scm 197 */
							      obj_t obj_1994;
							      obj_1994 =
								 (obj_t) (obj1579_1517);
							      (((obj_t) CREF(obj_1994))->header = MAKE_HEADER(arg1798_1519, 0), BUNSPEC);
							   }
							}
							obj1579_1517;
						     }
						  }
						  {
						     obj_t l1576_2488;
						     l1576_2488 =
							CDR(l1576_1512);
						     l1576_1512 = l1576_2488;
						     goto lname1577_1513;
						  }
					       }
					     else
					       {	/* Globalize/escape.scm 196 */
						  ((bool_t) 1);
					       }
					  }
				       }
				    }
				    {
				       obj_t l1572_2492;
				       l1572_2492 =
					  CDR(l1572_1500);
				       l1572_1500 = l1572_2492;
				       goto lname1573_1501;
				    }
				 }
			       else
				 {	/* Globalize/escape.scm 192 */
				    ((bool_t) 1);
				 }
			    }
			    {
			       obj_t l1580_1522;
			       l1580_1522 =
				  (((let_fun_218_bglt) CREF(node_1498))->locals);
			     lname1581_1523:
			       if (
				  PAIRP(l1580_1522))
				 {	/* Globalize/escape.scm 201 */
				    {	/* Globalize/escape.scm 203 */
				       node_bglt aux_2497;
				       {	/* Globalize/escape.scm 203 */
					  obj_t aux_2498;
					  {	/* Globalize/escape.scm 203 */
					     sfun_bglt obj_2002;
					     {	/* Globalize/escape.scm 203 */
						value_bglt aux_2499;
						{	/* Globalize/escape.scm 202 */
						   local_bglt obj_2001;
						   {	/* Globalize/escape.scm 202 */
						      obj_t aux_2500;
						      aux_2500 =
							 CAR(l1580_1522);
						      obj_2001 =
							 (local_bglt) (aux_2500);
						   }
						   aux_2499 =
						      (((local_bglt) CREF(obj_2001))->value);
						}
						obj_2002 =
						   (sfun_bglt) (aux_2499);
					     }
					     aux_2498 =
						(((sfun_bglt) CREF(obj_2002))->body);
					  }
					  aux_2497 =
					     (node_bglt) (aux_2498);
				       }
				       escape__235_globalize_escape(aux_2497);
				    }
				    {
				       obj_t l1580_2508;
				       l1580_2508 =
					  CDR(l1580_1522);
				       l1580_1522 = l1580_2508;
				       goto lname1581_1523;
				    }
				 }
			       else
				 {	/* Globalize/escape.scm 201 */
				    ((bool_t) 1);
				 }
			    }
			    {
			       node_bglt node_2511;
			       node_2511 =
				  (((let_fun_218_bglt) CREF(node_1498))->body);
			       node_10 = node_2511;
			       goto escape__235_globalize_escape;
			    }
			 }
			 break;
		      case ((long) 15):

			 {	/* Globalize/escape.scm 212 */
			    let_var_6_bglt node_1531;
			    node_1531 =
			       (let_var_6_bglt) (node_10);
			    escape__235_globalize_escape(
			       (((let_var_6_bglt) CREF(node_1531))->body));
			    {
			       obj_t l1583_1534;
			       {	/* Globalize/escape.scm 214 */
				  bool_t aux_2516;
				  l1583_1534 =
				     (((let_var_6_bglt) CREF(node_1531))->bindings);
				lname1584_1535:
				  if (
				     PAIRP(l1583_1534))
				    {	/* Globalize/escape.scm 214 */
				       {	/* Globalize/escape.scm 214 */
					  obj_t binding_1538;
					  binding_1538 =
					     CAR(l1583_1534);
					  {	/* Globalize/escape.scm 215 */
					     svar_ginfo_131_bglt obj1585_1539;
					     {
						value_bglt aux_2520;
						{	/* Globalize/escape.scm 215 */
						   obj_t arg1813_1542;
						   arg1813_1542 =
						      CAR(binding_1538);
						   {	/* Globalize/escape.scm 215 */
						      local_bglt obj_2010;
						      obj_2010 =
							 (local_bglt) (arg1813_1542);
						      aux_2520 =
							 (((local_bglt) CREF(obj_2010))->value);
						   }
						}
						obj1585_1539 =
						   ((svar_ginfo_131_bglt) (aux_2520));
					     }
					     {	/* Globalize/escape.scm 215 */
						svar_ginfo_131_bglt arg1811_1540;
						{	/* Globalize/escape.scm 215 */
						   svar_ginfo_131_bglt res1889_2020;
						   {	/* ./Globalize/ginfo.scm 1102 */
						      svar_ginfo_131_bglt new1494_2015;
						      new1494_2015 =
							 ((svar_ginfo_131_bglt) BREF(GC_MALLOC(sizeof(struct svar_ginfo_131))));
						      ((((svar_ginfo_131_bglt) CREF(new1494_2015))->kaptured__204) = ((bool_t) ((bool_t) 0)), BUNSPEC);
						      ((((svar_ginfo_131_bglt) CREF(new1494_2015))->free_mark_81) = ((long) ((long) -10)), BUNSPEC);
						      ((((svar_ginfo_131_bglt) CREF(new1494_2015))->mark) = ((long) ((long) -10)), BUNSPEC);
						      ((((svar_ginfo_131_bglt) CREF(new1494_2015))->celled__113) = ((bool_t) ((bool_t) 0)), BUNSPEC);
						      res1889_2020 = new1494_2015;
						   }
						   arg1811_1540 = res1889_2020;
						}
						{	/* Globalize/escape.scm 215 */
						   obj_t aux_2532;
						   object_bglt aux_2530;
						   aux_2532 =
						      (obj_t) (arg1811_1540);
						   aux_2530 =
						      (object_bglt) (obj1585_1539);
						   OBJECT_WIDENING_SET(aux_2530, aux_2532);
						}
					     }
					     {	/* Globalize/escape.scm 215 */
						long arg1812_1541;
						arg1812_1541 =
						   class_num_218___object(svar_ginfo_131_globalize_ginfo);
						{	/* Globalize/escape.scm 215 */
						   obj_t obj_2021;
						   obj_2021 =
						      (obj_t) (obj1585_1539);
						   (((obj_t) CREF(obj_2021))->header = MAKE_HEADER(arg1812_1541, 0), BUNSPEC);
						}
					     }
					     obj1585_1539;
					  }
					  {	/* Globalize/escape.scm 216 */
					     node_bglt aux_2538;
					     {	/* Globalize/escape.scm 216 */
						obj_t aux_2539;
						aux_2539 =
						   CDR(binding_1538);
						aux_2538 =
						   (node_bglt) (aux_2539);
					     }
					     escape__235_globalize_escape(aux_2538);
					  }
				       }
				       {
					  obj_t l1583_2543;
					  l1583_2543 =
					     CDR(l1583_1534);
					  l1583_1534 = l1583_2543;
					  goto lname1584_1535;
				       }
				    }
				  else
				    {	/* Globalize/escape.scm 214 */
				       aux_2516 = ((bool_t) 1);
				    }
				  return
				     BBOOL(aux_2516);
			       }
			    }
			 }
			 break;
		      case ((long) 16):

			 {	/* Globalize/escape.scm 223 */
			    set_ex_it_116_bglt node_1545;
			    node_1545 =
			       (set_ex_it_116_bglt) (node_10);
			    {	/* Globalize/escape.scm 224 */
			       sexit_ginfo_81_bglt obj1587_1547;
			       {
				  value_bglt aux_2548;
				  {	/* Globalize/escape.scm 224 */
				     variable_bglt arg1818_1550;
				     {	/* Globalize/escape.scm 224 */
					var_bglt arg1820_1551;
					arg1820_1551 =
					   (((set_ex_it_116_bglt) CREF(node_1545))->var);
					arg1818_1550 =
					   (((var_bglt) CREF(arg1820_1551))->variable);
				     }
				     {	/* Globalize/escape.scm 224 */
					local_bglt obj_2027;
					obj_2027 =
					   (local_bglt) (arg1818_1550);
					aux_2548 =
					   (((local_bglt) CREF(obj_2027))->value);
				     }
				  }
				  obj1587_1547 =
				     ((sexit_ginfo_81_bglt) (aux_2548));
			       }
			       {	/* Globalize/escape.scm 224 */
				  sexit_ginfo_81_bglt arg1816_1548;
				  {	/* Globalize/escape.scm 224 */
				     sexit_ginfo_81_bglt res1890_2037;
				     {	/* ./Globalize/ginfo.scm 1112 */
					sexit_ginfo_81_bglt new1509_2032;
					new1509_2032 =
					   ((sexit_ginfo_81_bglt) BREF(GC_MALLOC(sizeof(struct sexit_ginfo_81))));
					((((sexit_ginfo_81_bglt) CREF(new1509_2032))->g__219) = ((bool_t) ((bool_t) 0)), BUNSPEC);
					((((sexit_ginfo_81_bglt) CREF(new1509_2032))->kaptured__204) = ((bool_t) ((bool_t) 0)), BUNSPEC);
					((((sexit_ginfo_81_bglt) CREF(new1509_2032))->free_mark_81) = ((long) ((long) -10)), BUNSPEC);
					((((sexit_ginfo_81_bglt) CREF(new1509_2032))->mark) = ((long) ((long) -10)), BUNSPEC);
					res1890_2037 = new1509_2032;
				     }
				     arg1816_1548 = res1890_2037;
				  }
				  {	/* Globalize/escape.scm 224 */
				     obj_t aux_2561;
				     object_bglt aux_2559;
				     aux_2561 =
					(obj_t) (arg1816_1548);
				     aux_2559 =
					(object_bglt) (obj1587_1547);
				     OBJECT_WIDENING_SET(aux_2559, aux_2561);
				  }
			       }
			       {	/* Globalize/escape.scm 224 */
				  long arg1817_1549;
				  arg1817_1549 =
				     class_num_218___object(sexit_ginfo_81_globalize_ginfo);
				  {	/* Globalize/escape.scm 224 */
				     obj_t obj_2038;
				     obj_2038 =
					(obj_t) (obj1587_1547);
				     (((obj_t) CREF(obj_2038))->header = MAKE_HEADER(arg1817_1549, 0), BUNSPEC);
				  }
			       }
			       obj1587_1547;
			    }
			    {
			       node_bglt node_2567;
			       node_2567 =
				  (((set_ex_it_116_bglt) CREF(node_1545))->body);
			       node_10 = node_2567;
			       goto escape__235_globalize_escape;
			    }
			 }
			 break;
		      case ((long) 17):

			 {	/* Globalize/escape.scm 231 */
			    jump_ex_it_184_bglt node_1553;
			    node_1553 =
			       (jump_ex_it_184_bglt) (node_10);
			    escape__235_globalize_escape(
			       (((jump_ex_it_184_bglt) CREF(node_1553))->exit));
			    {
			       node_bglt node_2572;
			       node_2572 =
				  (((jump_ex_it_184_bglt) CREF(node_1553))->value);
			       node_10 = node_2572;
			       goto escape__235_globalize_escape;
			    }
			 }
			 break;
		      case ((long) 18):

			 {	/* Globalize/escape.scm 239 */
			    make_box_202_bglt node_1557;
			    node_1557 =
			       (make_box_202_bglt) (node_10);
			    {
			       node_bglt node_2575;
			       node_2575 =
				  (((make_box_202_bglt) CREF(node_1557))->value);
			       node_10 = node_2575;
			       goto escape__235_globalize_escape;
			    }
			 }
			 break;
		      case ((long) 19):

			 {	/* Globalize/escape.scm 245 */
			    box_set__221_bglt node_1559;
			    node_1559 =
			       (box_set__221_bglt) (node_10);
			    {
			       node_bglt node_2578;
			       node_2578 =
				  (((box_set__221_bglt) CREF(node_1559))->value);
			       node_10 = node_2578;
			       goto escape__235_globalize_escape;
			    }
			 }
			 break;
		      case ((long) 20):

			 {	/* Globalize/escape.scm 252 */
			    box_ref_242_bglt node_1562;
			    node_1562 =
			       (box_ref_242_bglt) (node_10);
			    {
			       node_bglt node_2581;
			       {	/* Globalize/escape.scm 253 */
				  var_bglt aux_2582;
				  aux_2582 =
				     (((box_ref_242_bglt) CREF(node_1562))->var);
				  node_2581 =
				     (node_bglt) (aux_2582);
			       }
			       node_10 = node_2581;
			       goto escape__235_globalize_escape;
			    }
			 }
			 break;
		      default:
		       case_else1762_1450:
			 if (
			    PROCEDUREP(method1756_1446))
			   {	/* Globalize/escape.scm 80 */
			      return
				 PROCEDURE_ENTRY(method1756_1446) (method1756_1446,
				 (obj_t) (node_10), BEOA);
			   }
			 else
			   {	/* Globalize/escape.scm 80 */
			      obj_t fun1755_1442;
			      fun1755_1442 =
				 PROCEDURE_REF(escape__env_201_globalize_escape, ((long) 0));
			      return
				 PROCEDURE_ENTRY(fun1755_1442) (fun1755_1442,
				 (obj_t) (node_10), BEOA);
			   }
		      }
		 }
	       else
		 {	/* Globalize/escape.scm 80 */
		    goto case_else1762_1450;
		 }
	    }
	 }
      }
   }
}



/* _escape! */
obj_t 
_escape__238_globalize_escape(obj_t env_2059, obj_t node_2060)
{
   AN_OBJECT;
   {	/* Globalize/escape.scm 80 */
      return
	 escape__235_globalize_escape(
	 (node_bglt) (node_2060));
   }
}



/* escape!-default1606 */
obj_t 
escape__default1606_50_globalize_escape(node_bglt node_11)
{
   AN_OBJECT;
   {	/* Globalize/escape.scm 14 */
      FAILURE(
	 CNST_TABLE_REF(((long) 2)), string1894_globalize_escape,
	 (obj_t) (node_11));
   }
}



/* _escape!-default1606 */
obj_t 
_escape__default1606_17_globalize_escape(obj_t env_2061, obj_t node_2062)
{
   AN_OBJECT;
   {	/* Globalize/escape.scm 14 */
      return
	 escape__default1606_50_globalize_escape(
	 (node_bglt) (node_2062));
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_globalize_escape()
{
   AN_OBJECT;
   {	/* Globalize/escape.scm 14 */
      module_initialization_70_tools_shape(((long) 0), "GLOBALIZE_ESCAPE");
      module_initialization_70_type_type(((long) 0), "GLOBALIZE_ESCAPE");
      module_initialization_70_engine_param(((long) 0), "GLOBALIZE_ESCAPE");
      module_initialization_70_ast_var(((long) 0), "GLOBALIZE_ESCAPE");
      module_initialization_70_ast_node(((long) 0), "GLOBALIZE_ESCAPE");
      return
	 module_initialization_70_globalize_ginfo(((long) 0), "GLOBALIZE_ESCAPE");
   }
}
