/*===========================================================================*/
/*   (Globalize/free.scm)                                                    */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;

typedef struct sfun_ginfo_98
  {
     bool_t g__219;
     obj_t cfrom;
     obj_t cfrom__119;
     obj_t cto;
     obj_t cto__14;
     obj_t cfunction;
     obj_t integrator;
     obj_t integrated;
     obj_t plugged_in_15;
     long mark;
     obj_t free_mark_81;
     obj_t the_global_201;
     obj_t kaptured;
     obj_t new_body_215;
     long bmark;
     long umark;
     obj_t free;
     obj_t bound;
  }
             *sfun_ginfo_98_bglt;

typedef struct svar_ginfo_131
  {
     bool_t kaptured__204;
     long free_mark_81;
     long mark;
     bool_t celled__113;
  }
              *svar_ginfo_131_bglt;

typedef struct sexit_ginfo_81
  {
     bool_t g__219;
     bool_t kaptured__204;
     long free_mark_81;
     long mark;
  }
              *sexit_ginfo_81_bglt;

typedef struct local_ginfo_108
  {
     bool_t escape__117;
  }
               *local_ginfo_108_bglt;

typedef struct global_ginfo_75
  {
     bool_t escape__117;
     obj_t global_closure_229;
  }
               *global_ginfo_75_bglt;


extern obj_t local_ginfo_108_globalize_ginfo;
static obj_t internal_get_free_vars__185_globalize_free(node_bglt, local_bglt);
static obj_t method_init_76_globalize_free();
extern obj_t make_box_202_ast_node;
extern obj_t funcall_ast_node;
extern obj_t symbol_append_197___r4_symbols_6_4(obj_t);
extern long add_inlined_method__244___object(obj_t, obj_t, long);
static obj_t _get_free_vars1925_70_globalize_free(obj_t, obj_t, obj_t);
extern obj_t fail_ast_node;
extern obj_t box_ref_242_ast_node;
extern obj_t the_closure_238_globalize_free(variable_bglt, obj_t);
static obj_t _node_free_default1592_105_globalize_free(obj_t, obj_t, obj_t);
extern global_bglt def_global_scnst__93_ast_glo_def_117(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t sequence_ast_node;
extern obj_t let_var_6_ast_node;
extern obj_t var_ast_node;
static long _round__57_globalize_free;
extern obj_t closure_ast_node;
extern obj_t global_ast_var;
static obj_t node_free_158_globalize_free(node_bglt, obj_t);
extern obj_t pragma_ast_node;
static obj_t _integrator__235_globalize_free = BUNSPEC;
extern obj_t set_ex_it_116_ast_node;
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t module_initialization_70_globalize_free(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_speek(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_local(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_ast_sexp(long, char *);
extern obj_t module_initialization_70_ast_glo_def_117(long, char *);
extern obj_t module_initialization_70_globalize_ginfo(long, char *);
extern obj_t module_initialization_70_globalize_node(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_globalize_global_closure_246(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_symbols_6_4(long, char *);
static obj_t mark_variable__104_globalize_free(local_bglt);
extern global_bglt make_global_closure_44_globalize_global_closure_246(global_bglt);
extern local_bglt make_local_svar_140_ast_local(obj_t, type_bglt);
extern long class_num_218___object(obj_t);
extern obj_t let_fun_218_ast_node;
static obj_t imported_modules_init_94_globalize_free();
extern obj_t sfun_ginfo_98_globalize_ginfo;
extern obj_t app_ly_162_ast_node;
extern obj_t add_generic__110___object(obj_t, obj_t);
static obj_t node_free_default1592_13_globalize_free(node_bglt, obj_t);
extern obj_t app_ast_node;
extern obj_t sexit_ginfo_81_globalize_ginfo;
static obj_t library_modules_init_112_globalize_free();
extern obj_t svar_ginfo_131_globalize_ginfo;
static obj_t _node_free1929_98_globalize_free(obj_t, obj_t, obj_t);
extern obj_t atom_ast_node;
extern obj_t cast_ast_node;
static obj_t toplevel_init_63_globalize_free();
extern node_bglt sexp__node_235_ast_sexp(obj_t, obj_t, obj_t, obj_t);
extern obj_t jump_ex_it_184_ast_node;
extern obj_t open_input_string(obj_t);
extern obj_t sfun_ast_var;
extern obj_t setq_ast_node;
extern obj_t box_set__221_ast_node;
static obj_t node_free__199_globalize_free(obj_t, obj_t);
static obj_t _the_global_closure1927_10_globalize_free(obj_t, obj_t, obj_t);
extern obj_t get_free_vars_244_globalize_free(node_bglt, local_bglt);
extern obj_t local_ast_var;
static obj_t free_variable__181_globalize_free(obj_t);
extern obj_t shape_tools_shape(obj_t);
static obj_t _free_from1928_98_globalize_free(obj_t, obj_t, obj_t);
extern obj_t _procedure__226_type_cache;
extern obj_t the_global_closure_233_globalize_free(global_bglt, obj_t);
static obj_t _the_closure1926_136_globalize_free(obj_t, obj_t, obj_t);
extern obj_t _classes__134___object;
extern obj_t select_ast_node;
extern obj_t read___reader(obj_t);
extern obj_t free_from_222_globalize_free(obj_t, local_bglt);
static obj_t bind_variable__14_globalize_free(local_bglt, local_bglt);
extern obj_t ____74_type_cache;
static obj_t require_initialization_114_globalize_free = BUNSPEC;
extern obj_t conditional_ast_node;
static obj_t the_local_closure_213_globalize_free(obj_t, obj_t);
static obj_t cnst_init_137_globalize_free();
static obj_t __cnst[6];

DEFINE_EXPORT_PROCEDURE(the_closure_env_75_globalize_free, _the_closure1926_136_globalize_free1937, _the_closure1926_136_globalize_free, 0L, 2);
DEFINE_STATIC_GENERIC(node_free_env_48_globalize_free, _node_free1929_98_globalize_free1938, _node_free1929_98_globalize_free, 0L, 2);
DEFINE_EXPORT_PROCEDURE(get_free_vars_env_212_globalize_free, _get_free_vars1925_70_globalize_free1939, _get_free_vars1925_70_globalize_free, 0L, 2);
DEFINE_EXPORT_PROCEDURE(the_global_closure_env_40_globalize_free, _the_global_closure1927_10_globalize_free1940, _the_global_closure1927_10_globalize_free, 0L, 2);
DEFINE_EXPORT_PROCEDURE(free_from_env_97_globalize_free, _free_from1928_98_globalize_free1941, _free_from1928_98_globalize_free, 0L, 2);
DEFINE_STATIC_PROCEDURE(node_free_default1592_env_34_globalize_free, _node_free_default1592_105_globalize_free1942, _node_free_default1592_105_globalize_free, 0L, 2);
DEFINE_STRING(string1932_globalize_free, string1932_globalize_free1943, "SFUN SGFUN -ENV::PROCEDURE VALUE MAKE-FX-PROCEDURE MAKE-VA-PROCEDURE ", 69);
DEFINE_STRING(string1931_globalize_free, string1931_globalize_free1944, "Unknown variable type", 21);
DEFINE_STRING(string1930_globalize_free, string1930_globalize_free1945, "free-variable?", 14);



/* module-initialization */
obj_t 
module_initialization_70_globalize_free(long checksum_2172, char *from_2173)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_globalize_free))
	{
	   require_initialization_114_globalize_free =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_globalize_free();
	   cnst_init_137_globalize_free();
	   imported_modules_init_94_globalize_free();
	   method_init_76_globalize_free();
	   toplevel_init_63_globalize_free();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_globalize_free()
{
   AN_OBJECT;
   {	/* Globalize/free.scm 14 */
      module_initialization_70___r4_symbols_6_4(((long) 0), "GLOBALIZE_FREE");
      module_initialization_70___object(((long) 0), "GLOBALIZE_FREE");
      module_initialization_70___reader(((long) 0), "GLOBALIZE_FREE");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_globalize_free()
{
   AN_OBJECT;
   {	/* Globalize/free.scm 14 */
      {		/* Globalize/free.scm 14 */
	 obj_t cnst_port_138_2165;
	 cnst_port_138_2165 =
	    open_input_string(string1932_globalize_free);
	 {
	    long i_2166;
	    i_2166 = ((long) 5);
	  loop_2167:
	    {	/* Globalize/free.scm 14 */
	       bool_t test1933_2168;
	       test1933_2168 =
		  (i_2166 == ((long) -1));
	       if (test1933_2168)
		 {	/* Globalize/free.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Globalize/free.scm 14 */
		    {	/* Globalize/free.scm 14 */
		       obj_t arg1934_2169;
		       {	/* Globalize/free.scm 14 */
			  obj_t list1935_2170;
			  list1935_2170 =
			     MAKE_PAIR(cnst_port_138_2165, BNIL);
			  arg1934_2169 =
			     read___reader(list1935_2170);
		       }
		       CNST_TABLE_SET(i_2166, arg1934_2169);
		    }
		    {	/* Globalize/free.scm 14 */
		       int aux_2171;
		       {	/* Globalize/free.scm 14 */
			  long aux_2191;
			  aux_2191 =
			     (i_2166 - ((long) 1));
			  aux_2171 =
			     (int) (aux_2191);
		       }
		       {
			  long i_2194;
			  i_2194 =
			     (long) (aux_2171);
			  i_2166 = i_2194;
			  goto loop_2167;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_globalize_free()
{
   AN_OBJECT;
   {	/* Globalize/free.scm 14 */
      _round__57_globalize_free = ((long) 0);
      _integrator__235_globalize_free = BUNSPEC;
      return BUNSPEC;
   }
}



/* mark-variable! */
obj_t 
mark_variable__104_globalize_free(local_bglt local_1)
{
   AN_OBJECT;
   {	/* Globalize/free.scm 42 */
      {		/* Globalize/free.scm 43 */
	 value_bglt info_1054;
	 info_1054 =
	    (((local_bglt) CREF(local_1))->value);
	 {	/* Globalize/free.scm 45 */
	    bool_t test1632_1055;
	    test1632_1055 =
	       is_a__118___object(
	       (obj_t) (info_1054), svar_ginfo_131_globalize_ginfo);
	    if (test1632_1055)
	      {		/* Globalize/free.scm 45 */
		 {	/* Globalize/free.scm 46 */
		    svar_ginfo_131_bglt obj_1752;
		    long val1491_1753;
		    obj_1752 =
		       (svar_ginfo_131_bglt) (info_1054);
		    val1491_1753 = _round__57_globalize_free;
		    {
		       obj_t aux_2201;
		       {	/* ./Globalize/ginfo.scm 1444 */
			  object_bglt aux_2202;
			  aux_2202 =
			     (object_bglt) (obj_1752);
			  aux_2201 =
			     OBJECT_WIDENING(aux_2202);
		       }
		       return
			  ((((svar_ginfo_131_bglt) CREF(aux_2201))->free_mark_81) = ((long) val1491_1753), BUNSPEC);
		    }
		 }
	      }
	    else
	      {		/* Globalize/free.scm 47 */
		 bool_t test1633_1056;
		 test1633_1056 =
		    is_a__118___object(
		    (obj_t) (info_1054), sfun_ginfo_98_globalize_ginfo);
		 if (test1633_1056)
		   {	/* Globalize/free.scm 47 */
		      {		/* Globalize/free.scm 48 */
			 sfun_ginfo_98_bglt obj_1755;
			 obj_t val1458_1756;
			 obj_1755 =
			    (sfun_ginfo_98_bglt) (info_1054);
			 val1458_1756 =
			    BINT(_round__57_globalize_free);
			 {
			    obj_t aux_2211;
			    {	/* ./Globalize/ginfo.scm 1424 */
			       object_bglt aux_2212;
			       aux_2212 =
				  (object_bglt) (obj_1755);
			       aux_2211 =
				  OBJECT_WIDENING(aux_2212);
			    }
			    return
			       ((((sfun_ginfo_98_bglt) CREF(aux_2211))->free_mark_81) = ((obj_t) val1458_1756), BUNSPEC);
			 }
		      }
		   }
		 else
		   {	/* Globalize/free.scm 49 */
		      bool_t test1634_1057;
		      test1634_1057 =
			 is_a__118___object(
			 (obj_t) (info_1054), sexit_ginfo_81_globalize_ginfo);
		      if (test1634_1057)
			{	/* Globalize/free.scm 49 */
			   {	/* Globalize/free.scm 50 */
			      sexit_ginfo_81_bglt obj_1758;
			      long val1507_1759;
			      obj_1758 =
				 (sexit_ginfo_81_bglt) (info_1054);
			      val1507_1759 = _round__57_globalize_free;
			      {
				 obj_t aux_2220;
				 {	/* ./Globalize/ginfo.scm 1456 */
				    object_bglt aux_2221;
				    aux_2221 =
				       (object_bglt) (obj_1758);
				    aux_2220 =
				       OBJECT_WIDENING(aux_2221);
				 }
				 return
				    ((((sexit_ginfo_81_bglt) CREF(aux_2220))->free_mark_81) = ((long) val1507_1759), BUNSPEC);
			      }
			   }
			}
		      else
			{	/* Globalize/free.scm 49 */
			   return BFALSE;
			}
		   }
	      }
	 }
      }
   }
}



/* bind-variable! */
obj_t 
bind_variable__14_globalize_free(local_bglt local_2, local_bglt integrator_3)
{
   AN_OBJECT;
   {	/* Globalize/free.scm 55 */
      {		/* Globalize/free.scm 56 */
	 value_bglt finfo_1058;
	 finfo_1058 =
	    (((local_bglt) CREF(integrator_3))->value);
	 {	/* Globalize/free.scm 57 */
	    obj_t arg1635_1059;
	    {	/* ./Ieee/pair-list.scm 5689 */
	       obj_t aux_2228;
	       obj_t aux_2226;
	       {	/* Globalize/free.scm 57 */
		  sfun_ginfo_98_bglt obj_1761;
		  obj_1761 =
		     (sfun_ginfo_98_bglt) (finfo_1058);
		  {
		     obj_t aux_2230;
		     {	/* ./Globalize/ginfo.scm 1438 */
			object_bglt aux_2231;
			aux_2231 =
			   (object_bglt) (obj_1761);
			aux_2230 =
			   OBJECT_WIDENING(aux_2231);
		     }
		     aux_2228 =
			(((sfun_ginfo_98_bglt) CREF(aux_2230))->bound);
		  }
	       }
	       aux_2226 =
		  (obj_t) (local_2);
	       arg1635_1059 =
		  MAKE_PAIR(aux_2226, aux_2228);
	    }
	    {	/* Globalize/free.scm 57 */
	       sfun_ginfo_98_bglt obj_1764;
	       obj_1764 =
		  (sfun_ginfo_98_bglt) (finfo_1058);
	       {
		  obj_t aux_2237;
		  {	/* ./Globalize/ginfo.scm 1438 */
		     object_bglt aux_2238;
		     aux_2238 =
			(object_bglt) (obj_1764);
		     aux_2237 =
			OBJECT_WIDENING(aux_2238);
		  }
		  ((((sfun_ginfo_98_bglt) CREF(aux_2237))->bound) = ((obj_t) arg1635_1059), BUNSPEC);
	       }
	    }
	 }
	 return
	    mark_variable__104_globalize_free(local_2);
      }
   }
}



/* free-variable? */
obj_t 
free_variable__181_globalize_free(obj_t local_4)
{
   AN_OBJECT;
   {	/* Globalize/free.scm 63 */
      {		/* Globalize/free.scm 64 */
	 value_bglt info_1061;
	 {	/* Globalize/free.scm 64 */
	    local_bglt obj_1766;
	    obj_1766 =
	       (local_bglt) (local_4);
	    info_1061 =
	       (((local_bglt) CREF(obj_1766))->value);
	 }
	 {	/* Globalize/free.scm 66 */
	    bool_t test1637_1062;
	    test1637_1062 =
	       is_a__118___object(
	       (obj_t) (info_1061), svar_ginfo_131_globalize_ginfo);
	    if (test1637_1062)
	      {		/* Globalize/free.scm 66 */
		 {	/* Globalize/free.scm 67 */
		    bool_t test1638_1063;
		    {	/* Globalize/free.scm 67 */
		       obj_t obj1_1769;
		       obj_t obj2_1770;
		       {	/* Globalize/free.scm 67 */
			  long aux_2248;
			  {	/* Globalize/free.scm 67 */
			     svar_ginfo_131_bglt obj_1768;
			     obj_1768 =
				(svar_ginfo_131_bglt) (info_1061);
			     {
				obj_t aux_2250;
				{	/* ./Globalize/ginfo.scm 1444 */
				   object_bglt aux_2251;
				   aux_2251 =
				      (object_bglt) (obj_1768);
				   aux_2250 =
				      OBJECT_WIDENING(aux_2251);
				}
				aux_2248 =
				   (((svar_ginfo_131_bglt) CREF(aux_2250))->free_mark_81);
			     }
			  }
			  obj1_1769 =
			     BINT(aux_2248);
		       }
		       obj2_1770 =
			  BINT(_round__57_globalize_free);
		       test1638_1063 =
			  (obj1_1769 == obj2_1770);
		    }
		    if (test1638_1063)
		      {		/* Globalize/free.scm 67 */
			 return BFALSE;
		      }
		    else
		      {		/* Globalize/free.scm 67 */
			 return BTRUE;
		      }
		 }
	      }
	    else
	      {		/* Globalize/free.scm 68 */
		 bool_t test1640_1065;
		 test1640_1065 =
		    is_a__118___object(
		    (obj_t) (info_1061), sfun_ginfo_98_globalize_ginfo);
		 if (test1640_1065)
		   {	/* Globalize/free.scm 68 */
		      {		/* Globalize/free.scm 69 */
			 bool_t test1641_1066;
			 {	/* Globalize/free.scm 69 */
			    obj_t arg1642_1067;
			    {	/* Globalize/free.scm 69 */
			       sfun_ginfo_98_bglt obj_1772;
			       obj_1772 =
				  (sfun_ginfo_98_bglt) (info_1061);
			       {
				  obj_t aux_2263;
				  {	/* ./Globalize/ginfo.scm 1424 */
				     object_bglt aux_2264;
				     aux_2264 =
					(object_bglt) (obj_1772);
				     aux_2263 =
					OBJECT_WIDENING(aux_2264);
				  }
				  arg1642_1067 =
				     (((sfun_ginfo_98_bglt) CREF(aux_2263))->free_mark_81);
			       }
			    }
			    {	/* Globalize/free.scm 69 */
			       obj_t obj2_1774;
			       obj2_1774 =
				  BINT(_round__57_globalize_free);
			       test1641_1066 =
				  (arg1642_1067 == obj2_1774);
			    }
			 }
			 if (test1641_1066)
			   {	/* Globalize/free.scm 69 */
			      return BFALSE;
			   }
			 else
			   {	/* Globalize/free.scm 69 */
			      return BTRUE;
			   }
		      }
		   }
		 else
		   {	/* Globalize/free.scm 70 */
		      bool_t test1643_1068;
		      test1643_1068 =
			 is_a__118___object(
			 (obj_t) (info_1061), sexit_ginfo_81_globalize_ginfo);
		      if (test1643_1068)
			{	/* Globalize/free.scm 70 */
			   {	/* Globalize/free.scm 71 */
			      bool_t test1644_1069;
			      {		/* Globalize/free.scm 71 */
				 obj_t obj1_1777;
				 obj_t obj2_1778;
				 {	/* Globalize/free.scm 71 */
				    long aux_2274;
				    {	/* Globalize/free.scm 71 */
				       sexit_ginfo_81_bglt obj_1776;
				       obj_1776 =
					  (sexit_ginfo_81_bglt) (info_1061);
				       {
					  obj_t aux_2276;
					  {	/* ./Globalize/ginfo.scm 1456 */
					     object_bglt aux_2277;
					     aux_2277 =
						(object_bglt) (obj_1776);
					     aux_2276 =
						OBJECT_WIDENING(aux_2277);
					  }
					  aux_2274 =
					     (((sexit_ginfo_81_bglt) CREF(aux_2276))->free_mark_81);
				       }
				    }
				    obj1_1777 =
				       BINT(aux_2274);
				 }
				 obj2_1778 =
				    BINT(_round__57_globalize_free);
				 test1644_1069 =
				    (obj1_1777 == obj2_1778);
			      }
			      if (test1644_1069)
				{	/* Globalize/free.scm 71 */
				   return BFALSE;
				}
			      else
				{	/* Globalize/free.scm 71 */
				   return BTRUE;
				}
			   }
			}
		      else
			{	/* Globalize/free.scm 70 */
			   {	/* Globalize/free.scm 73 */
			      obj_t arg1649_1073;
			      {		/* Globalize/free.scm 75 */
				 obj_t arg1650_1074;
				 arg1650_1074 =
				    shape_tools_shape(local_4);
				 arg1649_1073 =
				    MAKE_PAIR(local_4, arg1650_1074);
			      }
			      FAILURE(string1930_globalize_free, string1931_globalize_free, arg1649_1073);
			   }
			}
		   }
	      }
	 }
      }
   }
}



/* get-free-vars */
obj_t 
get_free_vars_244_globalize_free(node_bglt node_5, local_bglt integrator_6)
{
   AN_OBJECT;
   {	/* Globalize/free.scm 83 */
      {		/* Globalize/free.scm 86 */
	 obj_t free_1075;
	 {	/* Globalize/free.scm 86 */
	    sfun_ginfo_98_bglt obj_1785;
	    {	/* Globalize/free.scm 86 */
	       value_bglt aux_2288;
	       aux_2288 =
		  (((local_bglt) CREF(integrator_6))->value);
	       obj_1785 =
		  (sfun_ginfo_98_bglt) (aux_2288);
	    }
	    {
	       obj_t aux_2291;
	       {	/* ./Globalize/ginfo.scm 1436 */
		  object_bglt aux_2292;
		  aux_2292 =
		     (object_bglt) (obj_1785);
		  aux_2291 =
		     OBJECT_WIDENING(aux_2292);
	       }
	       free_1075 =
		  (((sfun_ginfo_98_bglt) CREF(aux_2291))->free);
	    }
	 }
	 {	/* Globalize/free.scm 87 */
	    bool_t test_2296;
	    if (
	       NULLP(free_1075))
	      {		/* Globalize/free.scm 87 */
		 test_2296 = ((bool_t) 1)
		    ;
	      }
	    else
	      {		/* Globalize/free.scm 87 */
		 test_2296 =
		    PAIRP(free_1075)
		    ;
	      }
	    if (test_2296)
	      {		/* Globalize/free.scm 87 */
		 return free_1075;
	      }
	    else
	      {		/* Globalize/free.scm 89 */
		 obj_t free_1077;
		 free_1077 =
		    internal_get_free_vars__185_globalize_free(node_5, integrator_6);
		 {	/* Globalize/free.scm 90 */
		    sfun_ginfo_98_bglt obj_1789;
		    {	/* Globalize/free.scm 90 */
		       value_bglt aux_2301;
		       aux_2301 =
			  (((local_bglt) CREF(integrator_6))->value);
		       obj_1789 =
			  (sfun_ginfo_98_bglt) (aux_2301);
		    }
		    {
		       obj_t aux_2304;
		       {	/* ./Globalize/ginfo.scm 1436 */
			  object_bglt aux_2305;
			  aux_2305 =
			     (object_bglt) (obj_1789);
			  aux_2304 =
			     OBJECT_WIDENING(aux_2305);
		       }
		       ((((sfun_ginfo_98_bglt) CREF(aux_2304))->free) = ((obj_t) free_1077), BUNSPEC);
		    }
		 }
		 return free_1077;
	      }
	 }
      }
   }
}



/* _get-free-vars1925 */
obj_t 
_get_free_vars1925_70_globalize_free(obj_t env_2147, obj_t node_2148, obj_t integrator_2149)
{
   AN_OBJECT;
   {	/* Globalize/free.scm 83 */
      return
	 get_free_vars_244_globalize_free(
	 (node_bglt) (node_2148),
	 (local_bglt) (integrator_2149));
   }
}



/* internal-get-free-vars! */
obj_t 
internal_get_free_vars__185_globalize_free(node_bglt node_7, local_bglt integrator_8)
{
   AN_OBJECT;
   {	/* Globalize/free.scm 104 */
      {		/* Globalize/free.scm 105 */
	 long z1_1791;
	 z1_1791 = _round__57_globalize_free;
	 _round__57_globalize_free =
	    (z1_1791 + ((long) 1));
      }
      _integrator__235_globalize_free =
	 (obj_t) (integrator_8);
      bind_variable__14_globalize_free(integrator_8, integrator_8);
      {		/* Globalize/free.scm 109 */
	 obj_t arg1655_1081;
	 {	/* Globalize/free.scm 109 */
	    variable_bglt variable_1793;
	    obj_t loc_1794;
	    variable_1793 =
	       (variable_bglt) (integrator_8);
	    loc_1794 = BFALSE;
	    {	/* Globalize/free.scm 323 */
	       bool_t test1664_1795;
	       test1664_1795 =
		  is_a__118___object(
		  (obj_t) (variable_1793), global_ast_var);
	       if (test1664_1795)
		 {	/* Globalize/free.scm 323 */
		    arg1655_1081 =
		       the_global_closure_233_globalize_free(
		       (global_bglt) (variable_1793), loc_1794);
		 }
	       else
		 {	/* Globalize/free.scm 323 */
		    arg1655_1081 =
		       the_local_closure_213_globalize_free(
		       (obj_t) (variable_1793), loc_1794);
		 }
	    }
	 }
	 bind_variable__14_globalize_free(
	    (local_bglt) (arg1655_1081), integrator_8);
      }
      {
	 obj_t l1554_1082;
	 {	/* Globalize/free.scm 111 */
	    sfun_bglt obj_1798;
	    {	/* Globalize/free.scm 111 */
	       value_bglt aux_2334;
	       aux_2334 =
		  (((local_bglt) CREF(integrator_8))->value);
	       obj_1798 =
		  (sfun_bglt) (aux_2334);
	    }
	    l1554_1082 =
	       (((sfun_bglt) CREF(obj_1798))->args);
	 }
       lname1555_1083:
	 if (
	    PAIRP(l1554_1082))
	   {	/* Globalize/free.scm 110 */
	      {		/* Globalize/free.scm 110 */
		 local_bglt aux_2327;
		 {	/* Globalize/free.scm 110 */
		    obj_t aux_2328;
		    aux_2328 =
		       CAR(l1554_1082);
		    aux_2327 =
		       (local_bglt) (aux_2328);
		 }
		 bind_variable__14_globalize_free(aux_2327, integrator_8);
	      }
	      {
		 obj_t l1554_2332;
		 l1554_2332 =
		    CDR(l1554_1082);
		 l1554_1082 = l1554_2332;
		 goto lname1555_1083;
	      }
	   }
	 else
	   {	/* Globalize/free.scm 110 */
	      ((bool_t) 1);
	   }
      }
      return
	 node_free_158_globalize_free(node_7, BNIL);
   }
}



/* node-free* */
obj_t 
node_free__199_globalize_free(obj_t node__221_51, obj_t free_52)
{
   AN_OBJECT;
   {	/* Globalize/free.scm 311 */
      {
	 obj_t node__221_1089;
	 obj_t free_1090;
	 node__221_1089 = node__221_51;
	 free_1090 = free_52;
       loop_1091:
	 if (
	    NULLP(node__221_1089))
	   {	/* Globalize/free.scm 314 */
	      return free_1090;
	   }
	 else
	   {	/* Globalize/free.scm 316 */
	      obj_t arg1661_1093;
	      obj_t arg1662_1094;
	      arg1661_1093 =
		 CDR(node__221_1089);
	      {		/* Globalize/free.scm 317 */
		 node_bglt aux_2342;
		 {	/* Globalize/free.scm 317 */
		    obj_t aux_2343;
		    aux_2343 =
		       CAR(node__221_1089);
		    aux_2342 =
		       (node_bglt) (aux_2343);
		 }
		 arg1662_1094 =
		    node_free_158_globalize_free(aux_2342, free_1090);
	      }
	      {
		 obj_t free_2348;
		 obj_t node__221_2347;
		 node__221_2347 = arg1661_1093;
		 free_2348 = arg1662_1094;
		 free_1090 = free_2348;
		 node__221_1089 = node__221_2347;
		 goto loop_1091;
	      }
	   }
      }
   }
}



/* the-closure */
obj_t 
the_closure_238_globalize_free(variable_bglt variable_53, obj_t loc_54)
{
   AN_OBJECT;
   {	/* Globalize/free.scm 322 */
      {		/* Globalize/free.scm 323 */
	 bool_t test1664_1805;
	 test1664_1805 =
	    is_a__118___object(
	    (obj_t) (variable_53), global_ast_var);
	 if (test1664_1805)
	   {	/* Globalize/free.scm 323 */
	      return
		 the_global_closure_233_globalize_free(
		 (global_bglt) (variable_53), loc_54);
	   }
	 else
	   {	/* Globalize/free.scm 323 */
	      return
		 the_local_closure_213_globalize_free(
		 (obj_t) (variable_53), loc_54);
	   }
      }
   }
}



/* _the-closure1926 */
obj_t 
_the_closure1926_136_globalize_free(obj_t env_2150, obj_t variable_2151, obj_t loc_2152)
{
   AN_OBJECT;
   {	/* Globalize/free.scm 322 */
      return
	 the_closure_238_globalize_free(
	 (variable_bglt) (variable_2151), loc_2152);
   }
}



/* the-global-closure */
obj_t 
the_global_closure_233_globalize_free(global_bglt global_55, obj_t loc_56)
{
   AN_OBJECT;
   {	/* Globalize/free.scm 330 */
      {		/* Globalize/free.scm 331 */
	 obj_t closure_1097;
	 {	/* Globalize/free.scm 331 */
	    fun_bglt obj_1808;
	    {	/* Globalize/free.scm 331 */
	       value_bglt aux_2358;
	       aux_2358 =
		  (((global_bglt) CREF(global_55))->value);
	       obj_1808 =
		  (fun_bglt) (aux_2358);
	    }
	    closure_1097 =
	       (((fun_bglt) CREF(obj_1808))->the_closure_238);
	 }
	 {	/* Globalize/free.scm 332 */
	    bool_t test1665_1098;
	    test1665_1098 =
	       is_a__118___object(closure_1097, global_ast_var);
	    if (test1665_1098)
	      {		/* Globalize/free.scm 332 */
		 return closure_1097;
	      }
	    else
	      {		/* Globalize/free.scm 334 */
		 global_bglt gloclo_1099;
		 gloclo_1099 =
		    make_global_closure_44_globalize_global_closure_246(global_55);
		 {	/* Globalize/free.scm 334 */
		    long arity_1100;
		    {	/* Globalize/free.scm 335 */
		       fun_bglt obj_1811;
		       {	/* Globalize/free.scm 335 */
			  value_bglt aux_2365;
			  aux_2365 =
			     (((global_bglt) CREF(global_55))->value);
			  obj_1811 =
			     (fun_bglt) (aux_2365);
		       }
		       arity_1100 =
			  (((fun_bglt) CREF(obj_1811))->arity);
		    }
		    {	/* Globalize/free.scm 335 */
		       obj_t make_clo_34_1101;
		       if (
			  (arity_1100 < ((long) 0)))
			 {	/* Globalize/free.scm 336 */
			    make_clo_34_1101 =
			       CNST_TABLE_REF(((long) 0));
			 }
		       else
			 {	/* Globalize/free.scm 336 */
			    make_clo_34_1101 =
			       CNST_TABLE_REF(((long) 1));
			 }
		       {	/* Globalize/free.scm 336 */
			  node_bglt node_1102;
			  {	/* Globalize/free.scm 340 */
			     obj_t arg1682_1120;
			     obj_t arg1684_1122;
			     {	/* Globalize/free.scm 340 */
				obj_t arg1685_1123;
				{	/* Globalize/free.scm 340 */
				   var_bglt arg1686_1124;
				   obj_t arg1687_1125;
				   {	/* Globalize/free.scm 340 */
				      obj_t arg1689_1127;
				      arg1689_1127 = ____74_type_cache;
				      {		/* Globalize/free.scm 340 */
					 var_bglt res1919_1824;
					 {	/* Globalize/free.scm 340 */
					    type_bglt type_1815;
					    variable_bglt variable_1816;
					    type_1815 =
					       (type_bglt) (arg1689_1127);
					    variable_1816 =
					       (variable_bglt) (gloclo_1099);
					    {	/* ./Ast/node.scm 1132 */
					       var_bglt new1210_1817;
					       new1210_1817 =
						  ((var_bglt) BREF(GC_MALLOC(sizeof(struct var))));
					       {	/* ./Ast/node.scm 1132 */
						  long arg1785_1818;
						  arg1785_1818 =
						     class_num_218___object(var_ast_node);
						  {	/* ./Ast/node.scm 1132 */
						     obj_t obj_1822;
						     obj_1822 =
							(obj_t) (new1210_1817);
						     (((obj_t) CREF(obj_1822))->header = MAKE_HEADER(arg1785_1818, 0), BUNSPEC);
						  }
					       }
					       {	/* ./Ast/node.scm 1132 */
						  object_bglt aux_2379;
						  aux_2379 =
						     (object_bglt) (new1210_1817);
						  OBJECT_WIDENING_SET(aux_2379, BFALSE);
					       }
					       ((((var_bglt) CREF(new1210_1817))->loc) = ((obj_t) loc_56), BUNSPEC);
					       ((((var_bglt) CREF(new1210_1817))->type) = ((type_bglt) type_1815), BUNSPEC);
					       ((((var_bglt) CREF(new1210_1817))->variable) = ((variable_bglt) variable_1816), BUNSPEC);
					       res1919_1824 = new1210_1817;
					    }
					 }
					 arg1686_1124 = res1919_1824;
				      }
				   }
				   {	/* Globalize/free.scm 344 */
				      atom_bglt arg1691_1129;
				      obj_t arg1692_1130;
				      {		/* Globalize/free.scm 344 */
					 obj_t arg1694_1132;
					 arg1694_1132 = ____74_type_cache;
					 {	/* Globalize/free.scm 344 */
					    atom_bglt res1920_1835;
					    {	/* Globalize/free.scm 344 */
					       type_bglt type_1826;
					       obj_t value_1827;
					       type_1826 =
						  (type_bglt) (arg1694_1132);
					       value_1827 =
						  BINT(arity_1100);
					       {	/* ./Ast/node.scm 1127 */
						  atom_bglt new1202_1828;
						  new1202_1828 =
						     ((atom_bglt) BREF(GC_MALLOC(sizeof(struct atom))));
						  {	/* ./Ast/node.scm 1127 */
						     long arg1787_1829;
						     arg1787_1829 =
							class_num_218___object(atom_ast_node);
						     {	/* ./Ast/node.scm 1127 */
							obj_t obj_1833;
							obj_1833 =
							   (obj_t) (new1202_1828);
							(((obj_t) CREF(obj_1833))->header = MAKE_HEADER(arg1787_1829, 0), BUNSPEC);
						     }
						  }
						  {	/* ./Ast/node.scm 1127 */
						     object_bglt aux_2391;
						     aux_2391 =
							(object_bglt) (new1202_1828);
						     OBJECT_WIDENING_SET(aux_2391, BFALSE);
						  }
						  ((((atom_bglt) CREF(new1202_1828))->loc) = ((obj_t) loc_56), BUNSPEC);
						  ((((atom_bglt) CREF(new1202_1828))->type) = ((type_bglt) type_1826), BUNSPEC);
						  ((((atom_bglt) CREF(new1202_1828))->value) = ((obj_t) value_1827), BUNSPEC);
						  res1920_1835 = new1202_1828;
					       }
					    }
					    arg1691_1129 = res1920_1835;
					 }
				      }
				      {		/* Globalize/free.scm 348 */
					 atom_bglt arg1696_1134;
					 {	/* Globalize/free.scm 348 */
					    obj_t arg1699_1137;
					    arg1699_1137 = ____74_type_cache;
					    {	/* Globalize/free.scm 348 */
					       atom_bglt res1921_1846;
					       {	/* Globalize/free.scm 348 */
						  type_bglt type_1837;
						  obj_t value_1838;
						  type_1837 =
						     (type_bglt) (arg1699_1137);
						  value_1838 =
						     BINT(((long) 0));
						  {	/* ./Ast/node.scm 1127 */
						     atom_bglt new1202_1839;
						     new1202_1839 =
							((atom_bglt) BREF(GC_MALLOC(sizeof(struct atom))));
						     {	/* ./Ast/node.scm 1127 */
							long arg1787_1840;
							arg1787_1840 =
							   class_num_218___object(atom_ast_node);
							{	/* ./Ast/node.scm 1127 */
							   obj_t obj_1844;
							   obj_1844 =
							      (obj_t) (new1202_1839);
							   (((obj_t) CREF(obj_1844))->header = MAKE_HEADER(arg1787_1840, 0), BUNSPEC);
							}
						     }
						     {	/* ./Ast/node.scm 1127 */
							object_bglt aux_2403;
							aux_2403 =
							   (object_bglt) (new1202_1839);
							OBJECT_WIDENING_SET(aux_2403, BFALSE);
						     }
						     ((((atom_bglt) CREF(new1202_1839))->loc) = ((obj_t) loc_56), BUNSPEC);
						     ((((atom_bglt) CREF(new1202_1839))->type) = ((type_bglt) type_1837), BUNSPEC);
						     ((((atom_bglt) CREF(new1202_1839))->value) = ((obj_t) value_1838), BUNSPEC);
						     res1921_1846 = new1202_1839;
						  }
					       }
					       arg1696_1134 = res1921_1846;
					    }
					 }
					 {	/* ./Ieee/pair-list.scm 5689 */
					    obj_t aux_2409;
					    aux_2409 =
					       (obj_t) (arg1696_1134);
					    arg1692_1130 =
					       MAKE_PAIR(aux_2409, BNIL);
					 }
				      }
				      {		/* ./Ieee/pair-list.scm 5689 */
					 obj_t aux_2412;
					 aux_2412 =
					    (obj_t) (arg1691_1129);
					 arg1687_1125 =
					    MAKE_PAIR(aux_2412, arg1692_1130);
				      }
				   }
				   {	/* ./Ieee/pair-list.scm 5689 */
				      obj_t aux_2415;
				      aux_2415 =
					 (obj_t) (arg1686_1124);
				      arg1685_1123 =
					 MAKE_PAIR(aux_2415, arg1687_1125);
				   }
				}
				arg1682_1120 =
				   MAKE_PAIR(make_clo_34_1101, arg1685_1123);
			     }
			     arg1684_1122 =
				CNST_TABLE_REF(((long) 2));
			     node_1102 =
				sexp__node_235_ast_sexp(arg1682_1120, BNIL, loc_56, arg1684_1122);
			  }
			  {	/* Globalize/free.scm 339 */
			     global_bglt closure_1103;
			     {	/* Globalize/free.scm 356 */
				obj_t arg1671_1108;
				obj_t arg1672_1109;
				obj_t arg1673_1110;
				{	/* Globalize/free.scm 356 */
				   obj_t arg1674_1111;
				   arg1674_1111 =
				      (((global_bglt) CREF(global_55))->id);
				   {	/* Globalize/free.scm 355 */
				      obj_t list1676_1113;
				      {		/* Globalize/free.scm 355 */
					 obj_t arg1677_1114;
					 {	/* Globalize/free.scm 355 */
					    obj_t aux_2422;
					    aux_2422 =
					       CNST_TABLE_REF(((long) 3));
					    arg1677_1114 =
					       MAKE_PAIR(aux_2422, BNIL);
					 }
					 list1676_1113 =
					    MAKE_PAIR(arg1674_1111, arg1677_1114);
				      }
				      arg1671_1108 =
					 symbol_append_197___r4_symbols_6_4(list1676_1113);
				   }
				}
				arg1672_1109 =
				   (((global_bglt) CREF(global_55))->module);
				{	/* Globalize/free.scm 360 */
				   bool_t test1678_1115;
				   {	/* ./Ast/var.scm 1009 */
				      obj_t aux_2428;
				      {		/* Globalize/free.scm 360 */
					 value_bglt aux_2429;
					 aux_2429 =
					    (((global_bglt) CREF(global_55))->value);
					 aux_2428 =
					    (obj_t) (aux_2429);
				      }
				      test1678_1115 =
					 is_a__118___object(aux_2428, sfun_ast_var);
				   }
				   if (test1678_1115)
				     {	/* Globalize/free.scm 361 */
					bool_t test_2434;
					{	/* ./Ieee/equiv.scm 5508 */
					   obj_t aux_2440;
					   obj_t aux_2435;
					   aux_2440 =
					      CNST_TABLE_REF(((long) 4));
					   {	/* Globalize/free.scm 361 */
					      sfun_bglt obj_1860;
					      {		/* Globalize/free.scm 361 */
						 value_bglt aux_2436;
						 aux_2436 =
						    (((global_bglt) CREF(global_55))->value);
						 obj_1860 =
						    (sfun_bglt) (aux_2436);
					      }
					      aux_2435 =
						 (((sfun_bglt) CREF(obj_1860))->class);
					   }
					   test_2434 =
					      (aux_2435 == aux_2440);
					}
					if (test_2434)
					  {	/* Globalize/free.scm 361 */
					     arg1673_1110 =
						CNST_TABLE_REF(((long) 4));
					  }
					else
					  {	/* Globalize/free.scm 361 */
					     arg1673_1110 =
						CNST_TABLE_REF(((long) 5));
					  }
				     }
				   else
				     {	/* Globalize/free.scm 360 */
					arg1673_1110 =
					   CNST_TABLE_REF(((long) 5));
				     }
				}
				closure_1103 =
				   def_global_scnst__93_ast_glo_def_117(arg1671_1108, arg1672_1109,
				   (obj_t) (node_1102), arg1673_1110, loc_56);
			     }
			     {	/* Globalize/free.scm 355 */

				{	/* Globalize/free.scm 368 */
				   bool_t arg1666_1104;
				   arg1666_1104 =
				      (((global_bglt) CREF(global_55))->library__255);
				   ((((global_bglt) CREF(closure_1103))->library__255) = ((bool_t) arg1666_1104), BUNSPEC);
				}
				{	/* Globalize/free.scm 369 */
				   obj_t arg1667_1105;
				   arg1667_1105 =
				      (((global_bglt) CREF(global_55))->import);
				   ((((global_bglt) CREF(closure_1103))->import) = ((obj_t) arg1667_1105), BUNSPEC);
				}
				{	/* Globalize/free.scm 370 */
				   fun_bglt obj_1870;
				   obj_t val1106_1871;
				   {	/* Globalize/free.scm 370 */
				      value_bglt aux_2452;
				      aux_2452 =
					 (((global_bglt) CREF(global_55))->value);
				      obj_1870 =
					 (fun_bglt) (aux_2452);
				   }
				   val1106_1871 =
				      (obj_t) (closure_1103);
				   ((((fun_bglt) CREF(obj_1870))->the_closure_238) = ((obj_t) val1106_1871), BUNSPEC);
				}
				{	/* Globalize/free.scm 374 */
				   fun_bglt obj_1873;
				   obj_t val1106_1874;
				   {	/* Globalize/free.scm 374 */
				      value_bglt aux_2457;
				      aux_2457 =
					 (((global_bglt) CREF(gloclo_1099))->value);
				      obj_1873 =
					 (fun_bglt) (aux_2457);
				   }
				   val1106_1874 =
				      (obj_t) (closure_1103);
				   ((((fun_bglt) CREF(obj_1873))->the_closure_238) = ((obj_t) val1106_1874), BUNSPEC);
				}
				return
				   (obj_t) (closure_1103);
			     }
			  }
		       }
		    }
		 }
	      }
	 }
      }
   }
}



/* _the-global-closure1927 */
obj_t 
_the_global_closure1927_10_globalize_free(obj_t env_2153, obj_t global_2154, obj_t loc_2155)
{
   AN_OBJECT;
   {	/* Globalize/free.scm 330 */
      return
	 the_global_closure_233_globalize_free(
	 (global_bglt) (global_2154), loc_2155);
   }
}



/* the-local-closure */
obj_t 
the_local_closure_213_globalize_free(obj_t local_57, obj_t loc_58)
{
   AN_OBJECT;
   {	/* Globalize/free.scm 384 */
      {		/* Globalize/free.scm 385 */
	 value_bglt info_1142;
	 {	/* Globalize/free.scm 385 */
	    local_bglt obj_1875;
	    obj_1875 =
	       (local_bglt) (local_57);
	    info_1142 =
	       (((local_bglt) CREF(obj_1875))->value);
	 }
	 {	/* Globalize/free.scm 386 */
	    bool_t test1704_1143;
	    {	/* ./Ast/var.scm 989 */
	       obj_t aux_2467;
	       {	/* Globalize/free.scm 386 */
		  sfun_bglt obj_1876;
		  obj_1876 =
		     (sfun_bglt) (info_1142);
		  aux_2467 =
		     (((sfun_bglt) CREF(obj_1876))->the_closure_238);
	       }
	       test1704_1143 =
		  is_a__118___object(aux_2467, local_ast_var);
	    }
	    if (test1704_1143)
	      {		/* Globalize/free.scm 387 */
		 sfun_bglt obj_1878;
		 obj_1878 =
		    (sfun_bglt) (info_1142);
		 return
		    (((sfun_bglt) CREF(obj_1878))->the_closure_238);
	      }
	    else
	      {		/* Globalize/free.scm 388 */
		 local_bglt closure_1144;
		 {	/* Globalize/free.scm 388 */
		    obj_t aux_2474;
		    {	/* Globalize/free.scm 388 */
		       local_bglt obj_1879;
		       obj_1879 =
			  (local_bglt) (local_57);
		       aux_2474 =
			  (((local_bglt) CREF(obj_1879))->id);
		    }
		    closure_1144 =
		       make_local_svar_140_ast_local(aux_2474,
		       (type_bglt) (_procedure__226_type_cache));
		 }
		 {	/* Globalize/free.scm 389 */
		    bool_t arg1705_1145;
		    {	/* Globalize/free.scm 389 */
		       local_bglt obj_1880;
		       obj_1880 =
			  (local_bglt) (local_57);
		       arg1705_1145 =
			  (((local_bglt) CREF(obj_1880))->user__32);
		    }
		    ((((local_bglt) CREF(closure_1144))->user__32) = ((bool_t) arg1705_1145), BUNSPEC);
		 }
		 {	/* Globalize/free.scm 390 */
		    svar_ginfo_131_bglt obj1582_1146;
		    obj1582_1146 =
		       ((svar_ginfo_131_bglt) (
			  (((local_bglt) CREF(closure_1144))->value)));
		    {	/* Globalize/free.scm 390 */
		       svar_ginfo_131_bglt arg1706_1147;
		       {	/* Globalize/free.scm 390 */
			  svar_ginfo_131_bglt res1922_1893;
			  {	/* ./Globalize/ginfo.scm 1440 */
			     svar_ginfo_131_bglt new1494_1888;
			     new1494_1888 =
				((svar_ginfo_131_bglt) BREF(GC_MALLOC(sizeof(struct svar_ginfo_131))));
			     ((((svar_ginfo_131_bglt) CREF(new1494_1888))->kaptured__204) = ((bool_t) ((bool_t) 0)), BUNSPEC);
			     ((((svar_ginfo_131_bglt) CREF(new1494_1888))->free_mark_81) = ((long) ((long) -10)), BUNSPEC);
			     ((((svar_ginfo_131_bglt) CREF(new1494_1888))->mark) = ((long) ((long) -10)), BUNSPEC);
			     ((((svar_ginfo_131_bglt) CREF(new1494_1888))->celled__113) = ((bool_t) ((bool_t) 0)), BUNSPEC);
			     res1922_1893 = new1494_1888;
			  }
			  arg1706_1147 = res1922_1893;
		       }
		       {	/* Globalize/free.scm 390 */
			  obj_t aux_2491;
			  object_bglt aux_2489;
			  aux_2491 =
			     (obj_t) (arg1706_1147);
			  aux_2489 =
			     (object_bglt) (obj1582_1146);
			  OBJECT_WIDENING_SET(aux_2489, aux_2491);
		       }
		    }
		    {	/* Globalize/free.scm 390 */
		       long arg1707_1148;
		       arg1707_1148 =
			  class_num_218___object(svar_ginfo_131_globalize_ginfo);
		       {	/* Globalize/free.scm 390 */
			  obj_t obj_1894;
			  obj_1894 =
			     (obj_t) (obj1582_1146);
			  (((obj_t) CREF(obj_1894))->header = MAKE_HEADER(arg1707_1148, 0), BUNSPEC);
		       }
		    }
		    obj1582_1146;
		 }
		 {	/* Globalize/free.scm 391 */
		    local_ginfo_108_bglt obj1584_1149;
		    obj1584_1149 =
		       ((local_ginfo_108_bglt) (closure_1144));
		    {	/* Globalize/free.scm 391 */
		       local_ginfo_108_bglt arg1708_1150;
		       {	/* Globalize/free.scm 391 */
			  local_ginfo_108_bglt res1923_1899;
			  {	/* ./Globalize/ginfo.scm 1460 */
			     local_ginfo_108_bglt new1527_1897;
			     new1527_1897 =
				((local_ginfo_108_bglt) BREF(GC_MALLOC(sizeof(struct local_ginfo_108))));
			     ((((local_ginfo_108_bglt) CREF(new1527_1897))->escape__117) = ((bool_t) ((bool_t) 0)), BUNSPEC);
			     res1923_1899 = new1527_1897;
			  }
			  arg1708_1150 = res1923_1899;
		       }
		       {	/* Globalize/free.scm 391 */
			  obj_t aux_2502;
			  object_bglt aux_2500;
			  aux_2502 =
			     (obj_t) (arg1708_1150);
			  aux_2500 =
			     (object_bglt) (obj1584_1149);
			  OBJECT_WIDENING_SET(aux_2500, aux_2502);
		       }
		    }
		    {	/* Globalize/free.scm 391 */
		       long arg1709_1151;
		       arg1709_1151 =
			  class_num_218___object(local_ginfo_108_globalize_ginfo);
		       {	/* Globalize/free.scm 391 */
			  obj_t obj_1900;
			  obj_1900 =
			     (obj_t) (obj1584_1149);
			  (((obj_t) CREF(obj_1900))->header = MAKE_HEADER(arg1709_1151, 0), BUNSPEC);
		       }
		    }
		    obj1584_1149;
		 }
		 {	/* Globalize/free.scm 392 */
		    sfun_bglt obj_1902;
		    obj_t val1441_1903;
		    obj_1902 =
		       (sfun_bglt) (info_1142);
		    val1441_1903 =
		       (obj_t) (closure_1144);
		    ((((sfun_bglt) CREF(obj_1902))->the_closure_238) = ((obj_t) val1441_1903), BUNSPEC);
		 }
		 return
		    (obj_t) (closure_1144);
	      }
	 }
      }
   }
}



/* free-from */
obj_t 
free_from_222_globalize_free(obj_t sets_59, local_bglt integrator_60)
{
   AN_OBJECT;
   {	/* Globalize/free.scm 398 */
      {		/* Globalize/free.scm 399 */
	 long z1_1904;
	 z1_1904 = _round__57_globalize_free;
	 _round__57_globalize_free =
	    (z1_1904 + ((long) 1));
      }
      {
	 obj_t l1585_1155;
	 {	/* Globalize/free.scm 408 */
	    sfun_ginfo_98_bglt obj_1907;
	    {	/* Globalize/free.scm 408 */
	       value_bglt aux_2522;
	       aux_2522 =
		  (((local_bglt) CREF(integrator_60))->value);
	       obj_1907 =
		  (sfun_ginfo_98_bglt) (aux_2522);
	    }
	    {
	       obj_t aux_2525;
	       {	/* ./Globalize/ginfo.scm 1438 */
		  object_bglt aux_2526;
		  aux_2526 =
		     (object_bglt) (obj_1907);
		  aux_2525 =
		     OBJECT_WIDENING(aux_2526);
	       }
	       l1585_1155 =
		  (((sfun_ginfo_98_bglt) CREF(aux_2525))->bound);
	    }
	 }
       lname1586_1156:
	 if (
	    PAIRP(l1585_1155))
	   {	/* Globalize/free.scm 408 */
	      {		/* Globalize/free.scm 408 */
		 local_bglt aux_2515;
		 {	/* Globalize/free.scm 408 */
		    obj_t aux_2516;
		    aux_2516 =
		       CAR(l1585_1155);
		    aux_2515 =
		       (local_bglt) (aux_2516);
		 }
		 mark_variable__104_globalize_free(aux_2515);
	      }
	      {
		 obj_t l1585_2520;
		 l1585_2520 =
		    CDR(l1585_1155);
		 l1585_1155 = l1585_2520;
		 goto lname1586_1156;
	      }
	   }
	 else
	   {	/* Globalize/free.scm 408 */
	      ((bool_t) 1);
	   }
      }
      if (
	 NULLP(sets_59))
	{	/* Globalize/free.scm 410 */
	   return BNIL;
	}
      else
	{	/* Globalize/free.scm 410 */
	   obj_t head1589_1163;
	   head1589_1163 =
	      MAKE_PAIR(BNIL, BNIL);
	   {
	      obj_t l1587_1164;
	      obj_t tail1590_1165;
	      l1587_1164 = sets_59;
	      tail1590_1165 = head1589_1163;
	    lname1588_1166:
	      if (
		 NULLP(l1587_1164))
		{	/* Globalize/free.scm 410 */
		   return
		      CDR(head1589_1163);
		}
	      else
		{	/* Globalize/free.scm 411 */
		   obj_t newtail1591_1168;
		   {	/* Globalize/free.scm 411 */
		      obj_t arg1720_1170;
		      {
			 obj_t set_1173;
			 obj_t res_1174;
			 set_1173 =
			    CAR(l1587_1164);
			 res_1174 = BNIL;
		       loop_1175:
			 if (
			    NULLP(set_1173))
			   {	/* Globalize/free.scm 414 */
			      arg1720_1170 = res_1174;
			   }
			 else
			   {	/* Globalize/free.scm 416 */
			      bool_t test1723_1177;
			      {		/* Globalize/free.scm 416 */
				 obj_t aux_2538;
				 aux_2538 =
				    free_variable__181_globalize_free(
				    CAR(set_1173));
				 test1723_1177 =
				    CBOOL(aux_2538);
			      }
			      if (test1723_1177)
				{	/* Globalize/free.scm 416 */
				   {	/* Globalize/free.scm 417 */
				      obj_t arg1724_1178;
				      obj_t arg1725_1179;
				      arg1724_1178 =
					 CDR(set_1173);
				      {		/* ./Ieee/pair-list.scm 5689 */
					 obj_t aux_2544;
					 aux_2544 =
					    CAR(set_1173);
					 arg1725_1179 =
					    MAKE_PAIR(aux_2544, res_1174);
				      }
				      {
					 obj_t res_2548;
					 obj_t set_2547;
					 set_2547 = arg1724_1178;
					 res_2548 = arg1725_1179;
					 res_1174 = res_2548;
					 set_1173 = set_2547;
					 goto loop_1175;
				      }
				   }
				}
			      else
				{	/* Globalize/free.scm 416 */
				   {
				      obj_t set_2549;
				      set_2549 =
					 CDR(set_1173);
				      set_1173 = set_2549;
				      goto loop_1175;
				   }
				}
			   }
		      }
		      newtail1591_1168 =
			 MAKE_PAIR(arg1720_1170, BNIL);
		   }
		   SET_CDR(tail1590_1165, newtail1591_1168);
		   {
		      obj_t tail1590_2556;
		      obj_t l1587_2554;
		      l1587_2554 =
			 CDR(l1587_1164);
		      tail1590_2556 = newtail1591_1168;
		      tail1590_1165 = tail1590_2556;
		      l1587_1164 = l1587_2554;
		      goto lname1588_1166;
		   }
		}
	   }
	}
   }
}



/* _free-from1928 */
obj_t 
_free_from1928_98_globalize_free(obj_t env_2156, obj_t sets_2157, obj_t integrator_2158)
{
   AN_OBJECT;
   {	/* Globalize/free.scm 398 */
      return
	 free_from_222_globalize_free(sets_2157,
	 (local_bglt) (integrator_2158));
   }
}



/* method-init */
obj_t 
method_init_76_globalize_free()
{
   AN_OBJECT;
   {	/* Globalize/free.scm 14 */
      add_generic__110___object(node_free_env_48_globalize_free, node_free_default1592_env_34_globalize_free);
      add_inlined_method__244___object(node_free_env_48_globalize_free, var_ast_node, ((long) 0));
      add_inlined_method__244___object(node_free_env_48_globalize_free, closure_ast_node, ((long) 1));
      add_inlined_method__244___object(node_free_env_48_globalize_free, sequence_ast_node, ((long) 2));
      add_inlined_method__244___object(node_free_env_48_globalize_free, app_ast_node, ((long) 3));
      add_inlined_method__244___object(node_free_env_48_globalize_free, app_ly_162_ast_node, ((long) 4));
      add_inlined_method__244___object(node_free_env_48_globalize_free, funcall_ast_node, ((long) 5));
      add_inlined_method__244___object(node_free_env_48_globalize_free, pragma_ast_node, ((long) 6));
      add_inlined_method__244___object(node_free_env_48_globalize_free, cast_ast_node, ((long) 7));
      add_inlined_method__244___object(node_free_env_48_globalize_free, setq_ast_node, ((long) 8));
      add_inlined_method__244___object(node_free_env_48_globalize_free, conditional_ast_node, ((long) 9));
      add_inlined_method__244___object(node_free_env_48_globalize_free, fail_ast_node, ((long) 10));
      add_inlined_method__244___object(node_free_env_48_globalize_free, select_ast_node, ((long) 11));
      add_inlined_method__244___object(node_free_env_48_globalize_free, let_fun_218_ast_node, ((long) 12));
      add_inlined_method__244___object(node_free_env_48_globalize_free, let_var_6_ast_node, ((long) 13));
      add_inlined_method__244___object(node_free_env_48_globalize_free, set_ex_it_116_ast_node, ((long) 14));
      add_inlined_method__244___object(node_free_env_48_globalize_free, jump_ex_it_184_ast_node, ((long) 15));
      add_inlined_method__244___object(node_free_env_48_globalize_free, make_box_202_ast_node, ((long) 16));
      add_inlined_method__244___object(node_free_env_48_globalize_free, box_ref_242_ast_node, ((long) 17));
      {		/* Globalize/free.scm 14 */
	 long aux_2578;
	 aux_2578 =
	    add_inlined_method__244___object(node_free_env_48_globalize_free, box_set__221_ast_node, ((long) 18));
	 return
	    BINT(aux_2578);
      }
   }
}



/* node-free */
obj_t 
node_free_158_globalize_free(node_bglt node_9, obj_t free_10)
{
   AN_OBJECT;
   {	/* Globalize/free.scm 118 */
    node_free_158_globalize_free:
      {
	 obj_t method1819_1577;
	 obj_t class1824_1578;
	 {	/* Globalize/free.scm 118 */
	    obj_t arg1827_1575;
	    obj_t arg1828_1576;
	    {	/* Globalize/free.scm 118 */
	       object_bglt obj_2037;
	       obj_2037 =
		  (object_bglt) (node_9);
	       {	/* ./Llib/object.scm 2926 */
		  obj_t pre_method_105_2038;
		  pre_method_105_2038 =
		     PROCEDURE_REF(node_free_env_48_globalize_free, ((long) 2));
		  if (
		     INTEGERP(pre_method_105_2038))
		    {	/* ./Llib/object.scm 2927 */
		       PROCEDURE_SET(node_free_env_48_globalize_free, ((long) 2), BUNSPEC);
		       arg1827_1575 = pre_method_105_2038;
		    }
		  else
		    {	/* ./Llib/object.scm 2914 */
		       long obj_class_num_177_2043;
		       obj_class_num_177_2043 =
			  TYPE(obj_2037);
		       {	/* ./Llib/object.scm 2915 */
			  obj_t arg1176_2044;
			  arg1176_2044 =
			     PROCEDURE_REF(node_free_env_48_globalize_free, ((long) 1));
			  {	/* ./Llib/object.scm 2738 */
			     long arg1177_2048;
			     {	/* ./Llib/object.scm 2738 */
				long arg1178_2049;
				arg1178_2049 =
				   OBJECT_TYPE;
				arg1177_2048 =
				   (obj_class_num_177_2043 - arg1178_2049);
			     }
			     arg1827_1575 =
				VECTOR_REF(arg1176_2044, arg1177_2048);
			  }
		       }
		    }
	       }
	    }
	    {	/* Globalize/free.scm 118 */
	       object_bglt object_2054;
	       object_2054 =
		  (object_bglt) (node_9);
	       {	/* ./Llib/object.scm 2695 */
		  long arg1179_2055;
		  {	/* ./Llib/object.scm 2695 */
		     long arg1180_2056;
		     long arg1181_2057;
		     arg1180_2056 =
			TYPE(object_2054);
		     arg1181_2057 =
			OBJECT_TYPE;
		     arg1179_2055 =
			(arg1180_2056 - arg1181_2057);
		  }
		  {	/* ./Llib/object.scm 2695 */
		     obj_t vector_2061;
		     vector_2061 = _classes__134___object;
		     arg1828_1576 =
			VECTOR_REF(vector_2061, arg1179_2055);
		  }
	       }
	    }
	    method1819_1577 = arg1827_1575;
	    class1824_1578 = arg1828_1576;
	    {

	       if (
		  INTEGERP(method1819_1577))
		 {	/* Globalize/free.scm 118 */
		    switch (
		       (long) CINT(method1819_1577))
		      {
		      case ((long) 0):

			 {	/* Globalize/free.scm 125 */
			    var_bglt node_1584;
			    node_1584 =
			       (var_bglt) (node_9);
			    {	/* Globalize/free.scm 127 */
			       bool_t test1831_1587;
			       {	/* ./Ast/var.scm 969 */
				  obj_t aux_2599;
				  {	/* Globalize/free.scm 127 */
				     variable_bglt aux_2600;
				     aux_2600 =
					(((var_bglt) CREF(node_1584))->variable);
				     aux_2599 =
					(obj_t) (aux_2600);
				  }
				  test1831_1587 =
				     is_a__118___object(aux_2599, global_ast_var);
			       }
			       if (test1831_1587)
				 {	/* Globalize/free.scm 127 */
				    return free_10;
				 }
			       else
				 {	/* Globalize/free.scm 129 */
				    bool_t test1832_1588;
				    {	/* Globalize/free.scm 129 */
				       obj_t aux_2605;
				       {	/* Globalize/free.scm 129 */
					  obj_t aux_2606;
					  {	/* Globalize/free.scm 129 */
					     variable_bglt aux_2607;
					     aux_2607 =
						(((var_bglt) CREF(node_1584))->variable);
					     aux_2606 =
						(obj_t) (aux_2607);
					  }
					  aux_2605 =
					     free_variable__181_globalize_free(aux_2606);
				       }
				       test1832_1588 =
					  CBOOL(aux_2605);
				    }
				    if (test1832_1588)
				      {		/* Globalize/free.scm 129 */
					 {	/* Globalize/free.scm 130 */
					    local_bglt aux_2613;
					    {	/* Globalize/free.scm 130 */
					       variable_bglt aux_2614;
					       aux_2614 =
						  (((var_bglt) CREF(node_1584))->variable);
					       aux_2613 =
						  (local_bglt) (aux_2614);
					    }
					    mark_variable__104_globalize_free(aux_2613);
					 }
					 {	/* ./Ieee/pair-list.scm 5689 */
					    obj_t aux_2618;
					    {	/* Globalize/free.scm 131 */
					       variable_bglt aux_2619;
					       aux_2619 =
						  (((var_bglt) CREF(node_1584))->variable);
					       aux_2618 =
						  (obj_t) (aux_2619);
					    }
					    return
					       MAKE_PAIR(aux_2618, free_10);
					 }
				      }
				    else
				      {		/* Globalize/free.scm 129 */
					 return free_10;
				      }
				 }
			    }
			 }
			 break;
		      case ((long) 1):

			 {	/* Globalize/free.scm 139 */
			    closure_bglt node_1593;
			    node_1593 =
			       (closure_bglt) (node_9);
			    {	/* Globalize/free.scm 140 */
			       obj_t var_1596;
			       {	/* Globalize/free.scm 140 */
				  variable_bglt arg1839_1599;
				  arg1839_1599 =
				     (((closure_bglt) CREF(node_1593))->variable);
				  {	/* Globalize/free.scm 140 */
				     obj_t loc_2072;
				     loc_2072 = BFALSE;
				     {	/* Globalize/free.scm 323 */
					bool_t test1664_2073;
					test1664_2073 =
					   is_a__118___object(
					   (obj_t) (arg1839_1599), global_ast_var);
					if (test1664_2073)
					  {	/* Globalize/free.scm 323 */
					     var_1596 =
						the_global_closure_233_globalize_free(
						(global_bglt) (arg1839_1599), loc_2072);
					  }
					else
					  {	/* Globalize/free.scm 323 */
					     var_1596 =
						the_local_closure_213_globalize_free(
						(obj_t) (arg1839_1599), loc_2072);
					  }
				     }
				  }
			       }
			       {	/* Globalize/free.scm 142 */
				  bool_t test1837_1597;
				  test1837_1597 =
				     is_a__118___object(var_1596, global_ast_var);
				  if (test1837_1597)
				    {	/* Globalize/free.scm 142 */
				       return free_10;
				    }
				  else
				    {	/* Globalize/free.scm 144 */
				       bool_t test1838_1598;
				       {	/* Globalize/free.scm 144 */
					  obj_t aux_2634;
					  aux_2634 =
					     free_variable__181_globalize_free(var_1596);
					  test1838_1598 =
					     CBOOL(aux_2634);
				       }
				       if (test1838_1598)
					 {	/* Globalize/free.scm 144 */
					    mark_variable__104_globalize_free(
					       (local_bglt) (var_1596));
					    return
					       MAKE_PAIR(var_1596, free_10);
					 }
				       else
					 {	/* Globalize/free.scm 144 */
					    return free_10;
					 }
				    }
			       }
			    }
			 }
			 break;
		      case ((long) 2):

			 {	/* Globalize/free.scm 154 */
			    sequence_bglt node_1600;
			    node_1600 =
			       (sequence_bglt) (node_9);
			    return
			       node_free__199_globalize_free(
			       (((sequence_bglt) CREF(node_1600))->nodes), free_10);
			 }
			 break;
		      case ((long) 3):

			 {	/* Globalize/free.scm 161 */
			    app_bglt node_1604;
			    node_1604 =
			       (app_bglt) (node_9);
			    {	/* Globalize/free.scm 162 */
			       obj_t free_1607;
			       {	/* Globalize/free.scm 162 */
				  variable_bglt var_1609;
				  {	/* Globalize/free.scm 162 */
				     var_bglt arg1848_1615;
				     arg1848_1615 =
					(((app_bglt) CREF(node_1604))->fun);
				     var_1609 =
					(((var_bglt) CREF(arg1848_1615))->variable);
				  }
				  {	/* Globalize/free.scm 164 */
				     bool_t test1843_1610;
				     test1843_1610 =
					is_a__118___object(
					(obj_t) (var_1609), global_ast_var);
				     if (test1843_1610)
				       {	/* Globalize/free.scm 164 */
					  free_1607 = free_10;
				       }
				     else
				       {	/* Globalize/free.scm 166 */
					  bool_t test1844_1611;
					  {	/* Globalize/free.scm 166 */
					     bool_t test_2650;
					     {	/* Globalize/free.scm 166 */
						local_ginfo_108_bglt obj_2082;
						obj_2082 =
						   (local_ginfo_108_bglt) (var_1609);
						{
						   obj_t aux_2652;
						   {	/* ./Globalize/ginfo.scm 1462 */
						      object_bglt aux_2653;
						      aux_2653 =
							 (object_bglt) (obj_2082);
						      aux_2652 =
							 OBJECT_WIDENING(aux_2653);
						   }
						   test_2650 =
						      (((local_ginfo_108_bglt) CREF(aux_2652))->escape__117);
						}
					     }
					     if (test_2650)
					       {	/* Globalize/free.scm 166 */
						  obj_t aux_2657;
						  aux_2657 =
						     free_variable__181_globalize_free(
						     (obj_t) (var_1609));
						  test1844_1611 =
						     CBOOL(aux_2657);
					       }
					     else
					       {	/* Globalize/free.scm 166 */
						  test1844_1611 = ((bool_t) 0);
					       }
					  }
					  if (test1844_1611)
					    {	/* Globalize/free.scm 166 */
					       mark_variable__104_globalize_free(
						  (local_bglt) (var_1609));
					       {	/* Globalize/free.scm 168 */
						  obj_t arg1845_1612;
						  {	/* Globalize/free.scm 168 */
						     obj_t arg1846_1613;
						     {	/* Globalize/free.scm 168 */
							node_bglt obj_2083;
							obj_2083 =
							   (node_bglt) (node_1604);
							arg1846_1613 =
							   (((node_bglt) CREF(obj_2083))->loc);
						     }
						     {	/* Globalize/free.scm 323 */
							bool_t test1664_2086;
							test1664_2086 =
							   is_a__118___object(
							   (obj_t) (var_1609), global_ast_var);
							if (test1664_2086)
							  {	/* Globalize/free.scm 323 */
							     arg1845_1612 =
								the_global_closure_233_globalize_free(
								(global_bglt) (var_1609), arg1846_1613);
							  }
							else
							  {	/* Globalize/free.scm 323 */
							     arg1845_1612 =
								the_local_closure_213_globalize_free(
								(obj_t) (var_1609), arg1846_1613);
							  }
						     }
						  }
						  free_1607 =
						     MAKE_PAIR(arg1845_1612, free_10);
					       }
					    }
					  else
					    {	/* Globalize/free.scm 166 */
					       free_1607 = free_10;
					    }
				       }
				  }
			       }
			       return
				  node_free__199_globalize_free(
				  (((app_bglt) CREF(node_1604))->args), free_1607);
			    }
			 }
			 break;
		      case ((long) 4):

			 {	/* Globalize/free.scm 177 */
			    app_ly_162_bglt node_1616;
			    node_1616 =
			       (app_ly_162_bglt) (node_9);
			    {	/* Globalize/free.scm 178 */
			       node_bglt arg1849_1619;
			       obj_t arg1850_1620;
			       arg1849_1619 =
				  (((app_ly_162_bglt) CREF(node_1616))->fun);
			       arg1850_1620 =
				  node_free_158_globalize_free(
				  (((app_ly_162_bglt) CREF(node_1616))->arg), free_10);
			       {
				  obj_t free_2681;
				  node_bglt node_2680;
				  node_2680 = arg1849_1619;
				  free_2681 = arg1850_1620;
				  free_10 = free_2681;
				  node_9 = node_2680;
				  goto node_free_158_globalize_free;
			       }
			    }
			 }
			 break;
		      case ((long) 5):

			 {	/* Globalize/free.scm 184 */
			    funcall_bglt node_1622;
			    node_1622 =
			       (funcall_bglt) (node_9);
			    {	/* Globalize/free.scm 185 */
			       node_bglt arg1852_1625;
			       obj_t arg1853_1626;
			       arg1852_1625 =
				  (((funcall_bglt) CREF(node_1622))->fun);
			       arg1853_1626 =
				  node_free__199_globalize_free(
				  (((funcall_bglt) CREF(node_1622))->args), free_10);
			       {
				  obj_t free_2687;
				  node_bglt node_2686;
				  node_2686 = arg1852_1625;
				  free_2687 = arg1853_1626;
				  free_10 = free_2687;
				  node_9 = node_2686;
				  goto node_free_158_globalize_free;
			       }
			    }
			 }
			 break;
		      case ((long) 6):

			 {	/* Globalize/free.scm 191 */
			    pragma_bglt node_1628;
			    node_1628 =
			       (pragma_bglt) (node_9);
			    return
			       node_free__199_globalize_free(
			       (((pragma_bglt) CREF(node_1628))->args), free_10);
			 }
			 break;
		      case ((long) 7):

			 {	/* Globalize/free.scm 198 */
			    cast_bglt node_1632;
			    node_1632 =
			       (cast_bglt) (node_9);
			    {
			       node_bglt node_2692;
			       node_2692 =
				  (((cast_bglt) CREF(node_1632))->arg);
			       node_9 = node_2692;
			       goto node_free_158_globalize_free;
			    }
			 }
			 break;
		      case ((long) 8):

			 {	/* Globalize/free.scm 205 */
			    setq_bglt node_1636;
			    node_1636 =
			       (setq_bglt) (node_9);
			    {	/* Globalize/free.scm 206 */
			       var_bglt arg1857_1639;
			       obj_t arg1858_1640;
			       arg1857_1639 =
				  (((setq_bglt) CREF(node_1636))->var);
			       arg1858_1640 =
				  node_free_158_globalize_free(
				  (((setq_bglt) CREF(node_1636))->value), free_10);
			       {
				  obj_t free_2700;
				  node_bglt node_2698;
				  node_2698 =
				     (node_bglt) (arg1857_1639);
				  free_2700 = arg1858_1640;
				  free_10 = free_2700;
				  node_9 = node_2698;
				  goto node_free_158_globalize_free;
			       }
			    }
			 }
			 break;
		      case ((long) 9):

			 {	/* Globalize/free.scm 212 */
			    conditional_bglt node_1642;
			    node_1642 =
			       (conditional_bglt) (node_9);
			    {	/* Globalize/free.scm 213 */
			       node_bglt arg1860_1645;
			       obj_t arg1861_1646;
			       arg1860_1645 =
				  (((conditional_bglt) CREF(node_1642))->test);
			       {	/* Globalize/free.scm 213 */
				  node_bglt arg1862_1647;
				  obj_t arg1863_1648;
				  arg1862_1647 =
				     (((conditional_bglt) CREF(node_1642))->true);
				  arg1863_1648 =
				     node_free_158_globalize_free(
				     (((conditional_bglt) CREF(node_1642))->false), free_10);
				  arg1861_1646 =
				     node_free_158_globalize_free(arg1862_1647, arg1863_1648);
			       }
			       {
				  obj_t free_2708;
				  node_bglt node_2707;
				  node_2707 = arg1860_1645;
				  free_2708 = arg1861_1646;
				  free_10 = free_2708;
				  node_9 = node_2707;
				  goto node_free_158_globalize_free;
			       }
			    }
			 }
			 break;
		      case ((long) 10):

			 {	/* Globalize/free.scm 219 */
			    fail_bglt node_1650;
			    node_1650 =
			       (fail_bglt) (node_9);
			    {	/* Globalize/free.scm 220 */
			       node_bglt arg1865_1653;
			       obj_t arg1866_1654;
			       arg1865_1653 =
				  (((fail_bglt) CREF(node_1650))->proc);
			       {	/* Globalize/free.scm 220 */
				  node_bglt arg1867_1655;
				  obj_t arg1868_1656;
				  arg1867_1655 =
				     (((fail_bglt) CREF(node_1650))->msg);
				  arg1868_1656 =
				     node_free_158_globalize_free(
				     (((fail_bglt) CREF(node_1650))->obj), free_10);
				  arg1866_1654 =
				     node_free_158_globalize_free(arg1867_1655, arg1868_1656);
			       }
			       {
				  obj_t free_2716;
				  node_bglt node_2715;
				  node_2715 = arg1865_1653;
				  free_2716 = arg1866_1654;
				  free_10 = free_2716;
				  node_9 = node_2715;
				  goto node_free_158_globalize_free;
			       }
			    }
			 }
			 break;
		      case ((long) 11):

			 {	/* Globalize/free.scm 226 */
			    select_bglt node_1658;
			    node_1658 =
			       (select_bglt) (node_9);
			    {
			       obj_t clauses_1661;
			       obj_t free_1662;
			       clauses_1661 =
				  (((select_bglt) CREF(node_1658))->clauses);
			       free_1662 = free_10;
			     loop_1663:
			       if (
				  NULLP(clauses_1661))
				 {
				    obj_t free_2722;
				    node_bglt node_2720;
				    node_2720 =
				       (((select_bglt) CREF(node_1658))->test);
				    free_2722 = free_1662;
				    free_10 = free_2722;
				    node_9 = node_2720;
				    goto node_free_158_globalize_free;
				 }
			       else
				 {	/* Globalize/free.scm 231 */
				    obj_t arg1873_1667;
				    obj_t arg1874_1668;
				    arg1873_1667 =
				       CDR(clauses_1661);
				    {	/* Globalize/free.scm 231 */
				       node_bglt aux_2724;
				       {	/* Globalize/free.scm 231 */
					  obj_t aux_2725;
					  {	/* ./Ieee/pair-list.scm 5707 */
					     obj_t aux_2726;
					     aux_2726 =
						CAR(clauses_1661);
					     aux_2725 =
						CDR(aux_2726);
					  }
					  aux_2724 =
					     (node_bglt) (aux_2725);
				       }
				       arg1874_1668 =
					  node_free_158_globalize_free(aux_2724, free_1662);
				    }
				    {
				       obj_t free_2732;
				       obj_t clauses_2731;
				       clauses_2731 = arg1873_1667;
				       free_2732 = arg1874_1668;
				       free_1662 = free_2732;
				       clauses_1661 = clauses_2731;
				       goto loop_1663;
				    }
				 }
			    }
			 }
			 break;
		      case ((long) 12):

			 {	/* Globalize/free.scm 237 */
			    let_fun_218_bglt node_1671;
			    node_1671 =
			       (let_fun_218_bglt) (node_9);
			    {
			       obj_t l1569_1674;
			       l1569_1674 =
				  (((let_fun_218_bglt) CREF(node_1671))->locals);
			     lname1570_1675:
			       if (
				  PAIRP(l1569_1674))
				 {	/* Globalize/free.scm 238 */
				    {	/* Globalize/free.scm 238 */
				       obj_t f_1678;
				       f_1678 =
					  CAR(l1569_1674);
				       bind_variable__14_globalize_free(
					  (local_bglt) (f_1678),
					  (local_bglt) (_integrator__235_globalize_free));
				       {	/* Globalize/free.scm 242 */
					  bool_t test_2741;
					  {	/* Globalize/free.scm 242 */
					     local_ginfo_108_bglt obj_2114;
					     obj_2114 =
						(local_ginfo_108_bglt) (f_1678);
					     {
						obj_t aux_2743;
						{	/* ./Globalize/ginfo.scm 1462 */
						   object_bglt aux_2744;
						   aux_2744 =
						      (object_bglt) (obj_2114);
						   aux_2743 =
						      OBJECT_WIDENING(aux_2744);
						}
						test_2741 =
						   (((local_ginfo_108_bglt) CREF(aux_2743))->escape__117);
					     }
					  }
					  if (test_2741)
					    {	/* Globalize/free.scm 243 */
					       obj_t arg1880_1680;
					       {	/* Globalize/free.scm 243 */
						  obj_t aux_2748;
						  {	/* Globalize/free.scm 243 */
						     node_bglt obj_2115;
						     obj_2115 =
							(node_bglt) (node_1671);
						     aux_2748 =
							(((node_bglt) CREF(obj_2115))->loc);
						  }
						  arg1880_1680 =
						     the_local_closure_213_globalize_free(f_1678, aux_2748);
					       }
					       bind_variable__14_globalize_free(
						  (local_bglt) (arg1880_1680),
						  (local_bglt) (_integrator__235_globalize_free));
					    }
					  else
					    {	/* Globalize/free.scm 242 */
					       BUNSPEC;
					    }
				       }
				    }
				    {
				       obj_t l1569_2755;
				       l1569_2755 =
					  CDR(l1569_1674);
				       l1569_1674 = l1569_2755;
				       goto lname1570_1675;
				    }
				 }
			       else
				 {	/* Globalize/free.scm 238 */
				    ((bool_t) 1);
				 }
			    }
			    {
			       obj_t lcls_1683;
			       obj_t free_1684;
			       lcls_1683 =
				  (((let_fun_218_bglt) CREF(node_1671))->locals);
			       free_1684 = free_10;
			     liip_1685:
			       if (
				  NULLP(lcls_1683))
				 {
				    obj_t free_2762;
				    node_bglt node_2760;
				    node_2760 =
				       (((let_fun_218_bglt) CREF(node_1671))->body);
				    free_2762 = free_1684;
				    free_10 = free_2762;
				    node_9 = node_2760;
				    goto node_free_158_globalize_free;
				 }
			       else
				 {	/* Globalize/free.scm 250 */
				    value_bglt fun_1690;
				    {	/* Globalize/free.scm 251 */
				       local_bglt obj_2121;
				       {	/* Globalize/free.scm 251 */
					  obj_t aux_2763;
					  aux_2763 =
					     CAR(lcls_1683);
					  obj_2121 =
					     (local_bglt) (aux_2763);
				       }
				       fun_1690 =
					  (((local_bglt) CREF(obj_2121))->value);
				    }
				    {	/* Globalize/free.scm 251 */

				       {
					  obj_t l1571_1691;
					  {	/* Globalize/free.scm 254 */
					     sfun_bglt obj_2122;
					     obj_2122 =
						(sfun_bglt) (fun_1690);
					     l1571_1691 =
						(((sfun_bglt) CREF(obj_2122))->args);
					  }
					lname1572_1692:
					  if (
					     PAIRP(l1571_1691))
					    {	/* Globalize/free.scm 252 */
					       {	/* Globalize/free.scm 253 */
						  local_bglt aux_2769;
						  {	/* Globalize/free.scm 253 */
						     obj_t aux_2770;
						     aux_2770 =
							CAR(l1571_1691);
						     aux_2769 =
							(local_bglt) (aux_2770);
						  }
						  bind_variable__14_globalize_free(aux_2769,
						     (local_bglt) (_integrator__235_globalize_free));
					       }
					       {
						  obj_t l1571_2775;
						  l1571_2775 =
						     CDR(l1571_1691);
						  l1571_1691 = l1571_2775;
						  goto lname1572_1692;
					       }
					    }
					  else
					    {	/* Globalize/free.scm 252 */
					       ((bool_t) 1);
					    }
				       }
				       {	/* Globalize/free.scm 255 */
					  obj_t arg1889_1697;
					  obj_t arg1890_1698;
					  arg1889_1697 =
					     CDR(lcls_1683);
					  {	/* Globalize/free.scm 256 */
					     node_bglt aux_2780;
					     {	/* Globalize/free.scm 256 */
						obj_t aux_2781;
						{	/* Globalize/free.scm 256 */
						   sfun_bglt obj_2127;
						   obj_2127 =
						      (sfun_bglt) (fun_1690);
						   aux_2781 =
						      (((sfun_bglt) CREF(obj_2127))->body);
						}
						aux_2780 =
						   (node_bglt) (aux_2781);
					     }
					     arg1890_1698 =
						node_free_158_globalize_free(aux_2780, free_1684);
					  }
					  {
					     obj_t free_2787;
					     obj_t lcls_2786;
					     lcls_2786 = arg1889_1697;
					     free_2787 = arg1890_1698;
					     free_1684 = free_2787;
					     lcls_1683 = lcls_2786;
					     goto liip_1685;
					  }
				       }
				    }
				 }
			    }
			 }
			 break;
		      case ((long) 13):

			 {	/* Globalize/free.scm 262 */
			    let_var_6_bglt node_1700;
			    node_1700 =
			       (let_var_6_bglt) (node_9);
			    {
			       obj_t bindings_1703;
			       obj_t free_1704;
			       bindings_1703 =
				  (((let_var_6_bglt) CREF(node_1700))->bindings);
			       free_1704 = free_10;
			     loop_1705:
			       if (
				  NULLP(bindings_1703))
				 {
				    obj_t free_2794;
				    node_bglt node_2792;
				    node_2792 =
				       (((let_var_6_bglt) CREF(node_1700))->body);
				    free_2794 = free_1704;
				    free_10 = free_2794;
				    node_9 = node_2792;
				    goto node_free_158_globalize_free;
				 }
			       else
				 {	/* Globalize/free.scm 265 */
				    {	/* Globalize/free.scm 268 */
				       local_bglt aux_2795;
				       {	/* Globalize/free.scm 268 */
					  obj_t aux_2796;
					  {	/* ./Ieee/pair-list.scm 5701 */
					     obj_t aux_2797;
					     aux_2797 =
						CAR(bindings_1703);
					     aux_2796 =
						CAR(aux_2797);
					  }
					  aux_2795 =
					     (local_bglt) (aux_2796);
				       }
				       bind_variable__14_globalize_free(aux_2795,
					  (local_bglt) (_integrator__235_globalize_free));
				    }
				    {	/* Globalize/free.scm 269 */
				       obj_t arg1897_1711;
				       obj_t arg1898_1712;
				       arg1897_1711 =
					  CDR(bindings_1703);
				       {	/* Globalize/free.scm 270 */
					  node_bglt aux_2804;
					  {	/* Globalize/free.scm 270 */
					     obj_t aux_2805;
					     {	/* ./Ieee/pair-list.scm 5707 */
						obj_t aux_2806;
						aux_2806 =
						   CAR(bindings_1703);
						aux_2805 =
						   CDR(aux_2806);
					     }
					     aux_2804 =
						(node_bglt) (aux_2805);
					  }
					  arg1898_1712 =
					     node_free_158_globalize_free(aux_2804, free_1704);
				       }
				       {
					  obj_t free_2812;
					  obj_t bindings_2811;
					  bindings_2811 = arg1897_1711;
					  free_2812 = arg1898_1712;
					  free_1704 = free_2812;
					  bindings_1703 = bindings_2811;
					  goto loop_1705;
				       }
				    }
				 }
			    }
			 }
			 break;
		      case ((long) 14):

			 {	/* Globalize/free.scm 276 */
			    set_ex_it_116_bglt node_1715;
			    node_1715 =
			       (set_ex_it_116_bglt) (node_9);
			    {	/* Globalize/free.scm 277 */
			       local_bglt aux_2815;
			       {	/* Globalize/free.scm 277 */
				  variable_bglt aux_2816;
				  {	/* Globalize/free.scm 277 */
				     var_bglt arg1902_1719;
				     arg1902_1719 =
					(((set_ex_it_116_bglt) CREF(node_1715))->var);
				     aux_2816 =
					(((var_bglt) CREF(arg1902_1719))->variable);
				  }
				  aux_2815 =
				     (local_bglt) (aux_2816);
			       }
			       bind_variable__14_globalize_free(aux_2815,
				  (local_bglt) (_integrator__235_globalize_free));
			    }
			    {
			       node_bglt node_2822;
			       node_2822 =
				  (((set_ex_it_116_bglt) CREF(node_1715))->body);
			       node_9 = node_2822;
			       goto node_free_158_globalize_free;
			    }
			 }
			 break;
		      case ((long) 15):

			 {	/* Globalize/free.scm 284 */
			    jump_ex_it_184_bglt node_1721;
			    node_1721 =
			       (jump_ex_it_184_bglt) (node_9);
			    {	/* Globalize/free.scm 285 */
			       node_bglt arg1904_1724;
			       obj_t arg1905_1725;
			       arg1904_1724 =
				  (((jump_ex_it_184_bglt) CREF(node_1721))->exit);
			       arg1905_1725 =
				  node_free_158_globalize_free(
				  (((jump_ex_it_184_bglt) CREF(node_1721))->value), free_10);
			       {
				  obj_t free_2829;
				  node_bglt node_2828;
				  node_2828 = arg1904_1724;
				  free_2829 = arg1905_1725;
				  free_10 = free_2829;
				  node_9 = node_2828;
				  goto node_free_158_globalize_free;
			       }
			    }
			 }
			 break;
		      case ((long) 16):

			 {	/* Globalize/free.scm 291 */
			    make_box_202_bglt node_1727;
			    node_1727 =
			       (make_box_202_bglt) (node_9);
			    {
			       node_bglt node_2831;
			       node_2831 =
				  (((make_box_202_bglt) CREF(node_1727))->value);
			       node_9 = node_2831;
			       goto node_free_158_globalize_free;
			    }
			 }
			 break;
		      case ((long) 17):

			 {	/* Globalize/free.scm 298 */
			    box_ref_242_bglt node_1731;
			    node_1731 =
			       (box_ref_242_bglt) (node_9);
			    {
			       node_bglt node_2834;
			       {	/* Globalize/free.scm 299 */
				  var_bglt aux_2835;
				  aux_2835 =
				     (((box_ref_242_bglt) CREF(node_1731))->var);
				  node_2834 =
				     (node_bglt) (aux_2835);
			       }
			       node_9 = node_2834;
			       goto node_free_158_globalize_free;
			    }
			 }
			 break;
		      case ((long) 18):

			 {	/* Globalize/free.scm 305 */
			    box_set__221_bglt node_1735;
			    node_1735 =
			       (box_set__221_bglt) (node_9);
			    {	/* Globalize/free.scm 306 */
			       var_bglt arg1910_1738;
			       obj_t arg1912_1739;
			       arg1910_1738 =
				  (((box_set__221_bglt) CREF(node_1735))->var);
			       arg1912_1739 =
				  node_free_158_globalize_free(
				  (((box_set__221_bglt) CREF(node_1735))->value), free_10);
			       {
				  obj_t free_2844;
				  node_bglt node_2842;
				  node_2842 =
				     (node_bglt) (arg1910_1738);
				  free_2844 = arg1912_1739;
				  free_10 = free_2844;
				  node_9 = node_2842;
				  goto node_free_158_globalize_free;
			       }
			    }
			 }
			 break;
		      default:
		       case_else1825_1581:
			 if (
			    PROCEDUREP(method1819_1577))
			   {	/* Globalize/free.scm 118 */
			      return
				 PROCEDURE_ENTRY(method1819_1577) (method1819_1577,
				 (obj_t) (node_9), free_10, BEOA);
			   }
			 else
			   {	/* Globalize/free.scm 118 */
			      obj_t fun1818_1573;
			      fun1818_1573 =
				 PROCEDURE_REF(node_free_env_48_globalize_free, ((long) 0));
			      return
				 PROCEDURE_ENTRY(fun1818_1573) (fun1818_1573,
				 (obj_t) (node_9), free_10, BEOA);
			   }
		      }
		 }
	       else
		 {	/* Globalize/free.scm 118 */
		    goto case_else1825_1581;
		 }
	    }
	 }
      }
   }
}



/* _node-free1929 */
obj_t 
_node_free1929_98_globalize_free(obj_t env_2159, obj_t node_2160, obj_t free_2161)
{
   AN_OBJECT;
   {	/* Globalize/free.scm 118 */
      return
	 node_free_158_globalize_free(
	 (node_bglt) (node_2160), free_2161);
   }
}



/* node-free-default1592 */
obj_t 
node_free_default1592_13_globalize_free(node_bglt node_11, obj_t free_12)
{
   AN_OBJECT;
   {	/* Globalize/free.scm 14 */
      return free_12;
   }
}



/* _node-free-default1592 */
obj_t 
_node_free_default1592_105_globalize_free(obj_t env_2162, obj_t node_2163, obj_t free_2164)
{
   AN_OBJECT;
   {	/* Globalize/free.scm 14 */
      return
	 node_free_default1592_13_globalize_free(
	 (node_bglt) (node_2163), free_2164);
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_globalize_free()
{
   AN_OBJECT;
   {	/* Globalize/free.scm 14 */
      module_initialization_70_tools_trace(((long) 0), "GLOBALIZE_FREE");
      module_initialization_70_tools_shape(((long) 0), "GLOBALIZE_FREE");
      module_initialization_70_tools_speek(((long) 0), "GLOBALIZE_FREE");
      module_initialization_70_type_type(((long) 0), "GLOBALIZE_FREE");
      module_initialization_70_type_cache(((long) 0), "GLOBALIZE_FREE");
      module_initialization_70_ast_var(((long) 0), "GLOBALIZE_FREE");
      module_initialization_70_ast_local(((long) 0), "GLOBALIZE_FREE");
      module_initialization_70_ast_node(((long) 0), "GLOBALIZE_FREE");
      module_initialization_70_ast_sexp(((long) 0), "GLOBALIZE_FREE");
      module_initialization_70_ast_glo_def_117(((long) 0), "GLOBALIZE_FREE");
      module_initialization_70_globalize_ginfo(((long) 0), "GLOBALIZE_FREE");
      module_initialization_70_globalize_node(((long) 0), "GLOBALIZE_FREE");
      module_initialization_70_engine_param(((long) 0), "GLOBALIZE_FREE");
      return
	 module_initialization_70_globalize_global_closure_246(((long) 0), "GLOBALIZE_FREE");
   }
}
