/*===========================================================================*/
/*   (Globalize/globalize.scm)                                               */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;

typedef struct sfun_ginfo_98
  {
     bool_t g__219;
     obj_t cfrom;
     obj_t cfrom__119;
     obj_t cto;
     obj_t cto__14;
     obj_t cfunction;
     obj_t integrator;
     obj_t integrated;
     obj_t plugged_in_15;
     long mark;
     obj_t free_mark_81;
     obj_t the_global_201;
     obj_t kaptured;
     obj_t new_body_215;
     long bmark;
     long umark;
     obj_t free;
     obj_t bound;
  }
             *sfun_ginfo_98_bglt;

typedef struct svar_ginfo_131
  {
     bool_t kaptured__204;
     long free_mark_81;
     long mark;
     bool_t celled__113;
  }
              *svar_ginfo_131_bglt;

typedef struct sexit_ginfo_81
  {
     bool_t g__219;
     bool_t kaptured__204;
     long free_mark_81;
     long mark;
  }
              *sexit_ginfo_81_bglt;

typedef struct local_ginfo_108
  {
     bool_t escape__117;
  }
               *local_ginfo_108_bglt;

typedef struct global_ginfo_75
  {
     bool_t escape__117;
     obj_t global_closure_229;
  }
               *global_ginfo_75_bglt;


obj_t _g1__181_globalize_globalize = BUNSPEC;
obj_t _g0__244_globalize_globalize = BUNSPEC;
obj_t _e__34_globalize_globalize = BUNSPEC;
static obj_t method_init_76_globalize_globalize();
extern obj_t _verbose__1_engine_param;
extern obj_t set_kaptured__104_globalize_kapture(obj_t);
extern obj_t globalize__167_globalize_globalize(global_bglt);
extern obj_t set_globalized_new_bodies__10_globalize_new_body_146(global_bglt, obj_t);
extern obj_t verbose_tools_speek(obj_t, obj_t);
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t module_initialization_70_globalize_globalize(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_speek(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_globalize_ginfo(long, char *);
extern obj_t module_initialization_70_globalize_node(long, char *);
extern obj_t module_initialization_70_globalize_free(long, char *);
extern obj_t module_initialization_70_globalize_kapture(long, char *);
extern obj_t module_initialization_70_globalize_gn(long, char *);
extern obj_t module_initialization_70_globalize_integration(long, char *);
extern obj_t module_initialization_70_globalize_new_body_146(long, char *);
extern obj_t module_initialization_70_globalize_local__global_194(long, char *);
extern obj_t module_initialization_70_globalize_global_closure_246(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___r4_numbers_6_5(long, char *);
extern global_bglt local__global_40_globalize_local__global_194(local_bglt);
extern node_bglt node_globalize__229_globalize_node(node_bglt, variable_bglt, obj_t);
extern obj_t gn__33_globalize_gn(obj_t, node_bglt, variable_bglt, obj_t);
static obj_t imported_modules_init_94_globalize_globalize();
static obj_t library_modules_init_112_globalize_globalize();
static obj_t _globalize__140_globalize_globalize(obj_t, obj_t);
static obj_t toplevel_init_63_globalize_globalize();
extern obj_t local_ast_var;
extern global_bglt global_closure_229_globalize_global_closure_246(global_bglt, obj_t);
extern obj_t shape_tools_shape(obj_t);
static bool_t verb_globalization_175_globalize_globalize();
extern bool_t ___161___r4_numbers_6_5(obj_t, obj_t, obj_t);
extern obj_t set_integration__52_globalize_integration();
static obj_t require_initialization_114_globalize_globalize = BUNSPEC;
static obj_t *__cnst;

DEFINE_EXPORT_PROCEDURE(globalize__env_187_globalize_globalize, _globalize__140_globalize_globalize1731, _globalize__140_globalize_globalize, 0L, 1);
DEFINE_STRING(string1729_globalize_globalize, string1729_globalize_globalize1732, " -->", 4);
DEFINE_STRING(string1728_globalize_globalize, string1728_globalize_globalize1733, " --> ", 5);
DEFINE_STRING(string1727_globalize_globalize, string1727_globalize_globalize1734, "           ", 11);
DEFINE_STRING(string1726_globalize_globalize, string1726_globalize_globalize1735, " ==>", 4);
DEFINE_STRING(string1725_globalize_globalize, string1725_globalize_globalize1736, "        ", 8);
DEFINE_STRING(string1724_globalize_globalize, string1724_globalize_globalize1737, " : ", 3);



/* module-initialization */
obj_t 
module_initialization_70_globalize_globalize(long checksum_1609, char *from_1610)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_globalize_globalize))
	{
	   require_initialization_114_globalize_globalize =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_globalize_globalize();
	   imported_modules_init_94_globalize_globalize();
	   method_init_76_globalize_globalize();
	   toplevel_init_63_globalize_globalize();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_globalize_globalize()
{
   AN_OBJECT;
   {	/* Globalize/globalize.scm 14 */
      module_initialization_70___object(((long) 0), "GLOBALIZE_GLOBALIZE");
      module_initialization_70___r4_numbers_6_5(((long) 0), "GLOBALIZE_GLOBALIZE");
      return BUNSPEC;
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_globalize_globalize()
{
   AN_OBJECT;
   {	/* Globalize/globalize.scm 14 */
      _e__34_globalize_globalize = BNIL;
      _g0__244_globalize_globalize = BNIL;
      return (
	 _g1__181_globalize_globalize = BNIL, BUNSPEC);
   }
}



/* globalize! */
obj_t 
globalize__167_globalize_globalize(global_bglt global_1)
{
   AN_OBJECT;
   {	/* Globalize/globalize.scm 46 */
      {		/* Globalize/globalize.scm 53 */
	 bool_t test1562_996;
	 test1562_996 =
	    ___161___r4_numbers_6_5(
	    BINT(((long) 3)), _verbose__1_engine_param, BNIL);
	 if (test1562_996)
	   {	/* Globalize/globalize.scm 53 */
	      obj_t arg1564_998;
	      arg1564_998 =
		 shape_tools_shape(
		 (obj_t) (global_1));
	      {		/* Globalize/globalize.scm 53 */
		 obj_t list1566_1000;
		 {	/* Globalize/globalize.scm 53 */
		    obj_t arg1567_1001;
		    {	/* Globalize/globalize.scm 53 */
		       obj_t arg1568_1002;
		       {	/* Globalize/globalize.scm 53 */
			  obj_t arg1569_1003;
			  {	/* Globalize/globalize.scm 53 */
			     obj_t aux_1625;
			     aux_1625 =
				BCHAR(((unsigned char) '\n'));
			     arg1569_1003 =
				MAKE_PAIR(aux_1625, BNIL);
			  }
			  arg1568_1002 =
			     MAKE_PAIR(string1724_globalize_globalize, arg1569_1003);
		       }
		       arg1567_1001 =
			  MAKE_PAIR(arg1564_998, arg1568_1002);
		    }
		    list1566_1000 =
		       MAKE_PAIR(string1725_globalize_globalize, arg1567_1001);
		 }
		 verbose_tools_speek(
		    BINT(((long) 3)), list1566_1000);
	      }
	   }
	 else
	   {	/* Globalize/globalize.scm 53 */
	      BUNSPEC;
	   }
      }
      {		/* Globalize/globalize.scm 54 */
	 value_bglt fun_1005;
	 fun_1005 =
	    (((global_bglt) CREF(global_1))->value);
	 _e__34_globalize_globalize = BNIL;
	 _g0__244_globalize_globalize = BNIL;
	 _g1__181_globalize_globalize = BNIL;
	 {	/* Globalize/globalize.scm 58 */
	    node_bglt aux_1637;
	    obj_t aux_1634;
	    {	/* Globalize/globalize.scm 58 */
	       obj_t aux_1638;
	       {	/* Globalize/globalize.scm 58 */
		  sfun_bglt obj_1479;
		  obj_1479 =
		     (sfun_bglt) (fun_1005);
		  aux_1638 =
		     (((sfun_bglt) CREF(obj_1479))->body);
	       }
	       aux_1637 =
		  (node_bglt) (aux_1638);
	    }
	    {	/* Globalize/globalize.scm 58 */
	       sfun_bglt obj_1478;
	       obj_1478 =
		  (sfun_bglt) (fun_1005);
	       aux_1634 =
		  (((sfun_bglt) CREF(obj_1478))->args);
	    }
	    gn__33_globalize_gn(aux_1634, aux_1637,
	       (variable_bglt) (global_1), BNIL);
	 }
	 set_integration__52_globalize_integration();
	 {	/* Globalize/globalize.scm 69 */
	    obj_t g_1009;
	    {
	       obj_t g1_1029;
	       obj_t g_1030;
	       g1_1029 = _g1__181_globalize_globalize;
	       g_1030 = _e__34_globalize_globalize;
	     loop_1031:
	       if (
		  NULLP(g1_1029))
		 {	/* Globalize/globalize.scm 72 */
		    g_1009 = g_1030;
		 }
	       else
		 {	/* Globalize/globalize.scm 75 */
		    bool_t test1592_1033;
		    {	/* ./Ast/var.scm 782 */
		       obj_t aux_1647;
		       {	/* Globalize/globalize.scm 75 */
			  sfun_ginfo_98_bglt obj_1483;
			  {	/* Globalize/globalize.scm 75 */
			     value_bglt aux_1648;
			     {	/* Globalize/globalize.scm 75 */
				local_bglt obj_1482;
				{	/* Globalize/globalize.scm 75 */
				   obj_t aux_1649;
				   aux_1649 =
				      CAR(g1_1029);
				   obj_1482 =
				      (local_bglt) (aux_1649);
				}
				aux_1648 =
				   (((local_bglt) CREF(obj_1482))->value);
			     }
			     obj_1483 =
				(sfun_ginfo_98_bglt) (aux_1648);
			  }
			  {
			     obj_t aux_1654;
			     {	/* ./Globalize/ginfo.scm 1058 */
				object_bglt aux_1655;
				aux_1655 =
				   (object_bglt) (obj_1483);
				aux_1654 =
				   OBJECT_WIDENING(aux_1655);
			     }
			     aux_1647 =
				(((sfun_ginfo_98_bglt) CREF(aux_1654))->integrator);
			  }
		       }
		       test1592_1033 =
			  is_a__118___object(aux_1647, local_ast_var);
		    }
		    if (test1592_1033)
		      {		/* Globalize/globalize.scm 75 */
			 {
			    obj_t g1_1661;
			    g1_1661 =
			       CDR(g1_1029);
			    g1_1029 = g1_1661;
			    goto loop_1031;
			 }
		      }
		    else
		      {		/* Globalize/globalize.scm 75 */
			 {	/* Globalize/globalize.scm 78 */
			    obj_t arg1594_1035;
			    obj_t arg1595_1036;
			    arg1594_1035 =
			       CDR(g1_1029);
			    {	/* ./Ieee/pair-list.scm 5689 */
			       obj_t aux_1664;
			       aux_1664 =
				  CAR(g1_1029);
			       arg1595_1036 =
				  MAKE_PAIR(aux_1664, g_1030);
			    }
			    {
			       obj_t g_1668;
			       obj_t g1_1667;
			       g1_1667 = arg1594_1035;
			       g_1668 = arg1595_1036;
			       g_1030 = g_1668;
			       g1_1029 = g1_1667;
			       goto loop_1031;
			    }
			 }
		      }
		 }
	    }
	    verb_globalization_175_globalize_globalize();
	    set_globalized_new_bodies__10_globalize_new_body_146(global_1, g_1009);
	    set_kaptured__104_globalize_kapture(g_1009);
	    {
	       obj_t g_1010;
	       obj_t new_g_67_1011;
	       {	/* Globalize/globalize.scm 88 */
		  obj_t arg1576_1013;
		  {	/* Globalize/globalize.scm 88 */
		     bool_t test_1672;
		     {	/* Globalize/globalize.scm 88 */
			global_ginfo_75_bglt obj_1490;
			obj_1490 =
			   (global_ginfo_75_bglt) (global_1);
			{
			   obj_t aux_1674;
			   {	/* ./Globalize/ginfo.scm 1108 */
			      object_bglt aux_1675;
			      aux_1675 =
				 (object_bglt) (obj_1490);
			      aux_1674 =
				 OBJECT_WIDENING(aux_1675);
			   }
			   test_1672 =
			      (((global_ginfo_75_bglt) CREF(aux_1674))->escape__117);
			}
		     }
		     if (test_1672)
		       {	/* Globalize/globalize.scm 91 */
			  global_bglt arg1578_1015;
			  {	/* Globalize/globalize.scm 89 */
			     obj_t aux_1679;
			     {	/* Globalize/globalize.scm 90 */
				node_bglt obj_1492;
				{	/* Globalize/globalize.scm 90 */
				   obj_t aux_1680;
				   {	/* Globalize/globalize.scm 91 */
				      sfun_bglt obj_1491;
				      obj_1491 =
					 (sfun_bglt) (fun_1005);
				      aux_1680 =
					 (((sfun_bglt) CREF(obj_1491))->body);
				   }
				   obj_1492 =
				      (node_bglt) (aux_1680);
				}
				aux_1679 =
				   (((node_bglt) CREF(obj_1492))->loc);
			     }
			     arg1578_1015 =
				global_closure_229_globalize_global_closure_246(global_1, aux_1679);
			  }
			  {	/* Globalize/globalize.scm 89 */
			     obj_t list1579_1016;
			     {	/* Globalize/globalize.scm 89 */
				obj_t arg1580_1017;
				{	/* Globalize/globalize.scm 89 */
				   obj_t aux_1686;
				   aux_1686 =
				      (obj_t) (global_1);
				   arg1580_1017 =
				      MAKE_PAIR(aux_1686, BNIL);
				}
				{	/* Globalize/globalize.scm 89 */
				   obj_t aux_1689;
				   aux_1689 =
				      (obj_t) (arg1578_1015);
				   list1579_1016 =
				      MAKE_PAIR(aux_1689, arg1580_1017);
				}
			     }
			     arg1576_1013 = list1579_1016;
			  }
		       }
		     else
		       {	/* Globalize/globalize.scm 93 */
			  obj_t list1583_1020;
			  {	/* Globalize/globalize.scm 93 */
			     obj_t aux_1692;
			     aux_1692 =
				(obj_t) (global_1);
			     list1583_1020 =
				MAKE_PAIR(aux_1692, BNIL);
			  }
			  arg1576_1013 = list1583_1020;
		       }
		  }
		  g_1010 = g_1009;
		  new_g_67_1011 = arg1576_1013;
		loop_1012:
		  if (
		     NULLP(g_1010))
		    {	/* Globalize/globalize.scm 96 */
		       node_bglt body_1022;
		       {	/* Globalize/globalize.scm 96 */
			  node_bglt aux_1697;
			  {	/* Globalize/globalize.scm 96 */
			     obj_t aux_1698;
			     {	/* Globalize/globalize.scm 96 */
				sfun_bglt obj_1496;
				obj_1496 =
				   (sfun_bglt) (fun_1005);
				aux_1698 =
				   (((sfun_bglt) CREF(obj_1496))->body);
			     }
			     aux_1697 =
				(node_bglt) (aux_1698);
			  }
			  body_1022 =
			     node_globalize__229_globalize_node(aux_1697,
			     (variable_bglt) (global_1), BNIL);
		       }
		       {	/* Globalize/globalize.scm 97 */
			  sfun_bglt obj_1497;
			  obj_t val1123_1498;
			  obj_1497 =
			     (sfun_bglt) (fun_1005);
			  val1123_1498 =
			     (obj_t) (body_1022);
			  ((((sfun_bglt) CREF(obj_1497))->body) = ((obj_t) val1123_1498), BUNSPEC);
		       }
		       return new_g_67_1011;
		    }
		  else
		    {	/* Globalize/globalize.scm 100 */
		       obj_t arg1587_1025;
		       obj_t arg1588_1026;
		       arg1587_1025 =
			  CDR(g_1010);
		       {	/* Globalize/globalize.scm 101 */
			  global_bglt arg1589_1027;
			  {	/* Globalize/globalize.scm 101 */
			     local_bglt aux_1708;
			     {	/* Globalize/globalize.scm 101 */
				obj_t aux_1709;
				aux_1709 =
				   CAR(g_1010);
				aux_1708 =
				   (local_bglt) (aux_1709);
			     }
			     arg1589_1027 =
				local__global_40_globalize_local__global_194(aux_1708);
			  }
			  {	/* ./Ieee/pair-list.scm 5689 */
			     obj_t aux_1713;
			     aux_1713 =
				(obj_t) (arg1589_1027);
			     arg1588_1026 =
				MAKE_PAIR(aux_1713, new_g_67_1011);
			  }
		       }
		       {
			  obj_t new_g_67_1717;
			  obj_t g_1716;
			  g_1716 = arg1587_1025;
			  new_g_67_1717 = arg1588_1026;
			  new_g_67_1011 = new_g_67_1717;
			  g_1010 = g_1716;
			  goto loop_1012;
		       }
		    }
	       }
	    }
	 }
      }
   }
}



/* _globalize! */
obj_t 
_globalize__140_globalize_globalize(obj_t env_1607, obj_t global_1608)
{
   AN_OBJECT;
   {	/* Globalize/globalize.scm 46 */
      return
	 globalize__167_globalize_globalize(
	 (global_bglt) (global_1608));
   }
}



/* verb-globalization */
bool_t 
verb_globalization_175_globalize_globalize()
{
   AN_OBJECT;
   {	/* Globalize/globalize.scm 106 */
      {
	 obj_t l1555_1041;
	 l1555_1041 = _e__34_globalize_globalize;
       lname1556_1042:
	 if (
	    PAIRP(l1555_1041))
	   {	/* Globalize/globalize.scm 107 */
	      {		/* Globalize/globalize.scm 108 */
		 obj_t local_1044;
		 local_1044 =
		    CAR(l1555_1041);
		 {	/* Globalize/globalize.scm 108 */
		    bool_t test1601_1046;
		    test1601_1046 =
		       ___161___r4_numbers_6_5(
		       BINT(((long) 3)), _verbose__1_engine_param, BNIL);
		    if (test1601_1046)
		      {		/* Globalize/globalize.scm 108 */
			 obj_t arg1603_1048;
			 arg1603_1048 =
			    shape_tools_shape(local_1044);
			 {	/* Globalize/globalize.scm 108 */
			    obj_t list1605_1050;
			    {	/* Globalize/globalize.scm 108 */
			       obj_t arg1606_1051;
			       {	/* Globalize/globalize.scm 108 */
				  obj_t arg1607_1052;
				  {	/* Globalize/globalize.scm 108 */
				     obj_t arg1608_1053;
				     {	/* Globalize/globalize.scm 108 */
					obj_t aux_1727;
					aux_1727 =
					   BCHAR(((unsigned char) '\n'));
					arg1608_1053 =
					   MAKE_PAIR(aux_1727, BNIL);
				     }
				     arg1607_1052 =
					MAKE_PAIR(string1726_globalize_globalize, arg1608_1053);
				  }
				  arg1606_1051 =
				     MAKE_PAIR(arg1603_1048, arg1607_1052);
			       }
			       list1605_1050 =
				  MAKE_PAIR(string1727_globalize_globalize, arg1606_1051);
			    }
			    verbose_tools_speek(
			       BINT(((long) 3)), list1605_1050);
			 }
		      }
		    else
		      {		/* Globalize/globalize.scm 108 */
			 BUNSPEC;
		      }
		 }
	      }
	      {
		 obj_t l1555_1735;
		 l1555_1735 =
		    CDR(l1555_1041);
		 l1555_1041 = l1555_1735;
		 goto lname1556_1042;
	      }
	   }
	 else
	   {	/* Globalize/globalize.scm 107 */
	      ((bool_t) 1);
	   }
      }
      {
	 obj_t l1558_1056;
	 l1558_1056 = _g1__181_globalize_globalize;
       lname1559_1057:
	 if (
	    PAIRP(l1558_1056))
	   {	/* Globalize/globalize.scm 110 */
	      {		/* Globalize/globalize.scm 111 */
		 obj_t local_1059;
		 local_1059 =
		    CAR(l1558_1056);
		 {	/* Globalize/globalize.scm 111 */
		    value_bglt sfun_ginfo_98_1060;
		    {	/* Globalize/globalize.scm 111 */
		       local_bglt obj_1508;
		       obj_1508 =
			  (local_bglt) (local_1059);
		       sfun_ginfo_98_1060 =
			  (((local_bglt) CREF(obj_1508))->value);
		    }
		    {	/* Globalize/globalize.scm 112 */
		       bool_t test1612_1061;
		       {	/* ./Ast/var.scm 782 */
			  obj_t aux_1742;
			  {	/* Globalize/globalize.scm 112 */
			     sfun_ginfo_98_bglt obj_1509;
			     obj_1509 =
				(sfun_ginfo_98_bglt) (sfun_ginfo_98_1060);
			     {
				obj_t aux_1744;
				{	/* ./Globalize/ginfo.scm 1058 */
				   object_bglt aux_1745;
				   aux_1745 =
				      (object_bglt) (obj_1509);
				   aux_1744 =
				      OBJECT_WIDENING(aux_1745);
				}
				aux_1742 =
				   (((sfun_ginfo_98_bglt) CREF(aux_1744))->integrator);
			     }
			  }
			  test1612_1061 =
			     is_a__118___object(aux_1742, local_ast_var);
		       }
		       if (test1612_1061)
			 {	/* Globalize/globalize.scm 113 */
			    bool_t test1613_1063;
			    test1613_1063 =
			       ___161___r4_numbers_6_5(
			       BINT(((long) 3)), _verbose__1_engine_param, BNIL);
			    if (test1613_1063)
			      {		/* Globalize/globalize.scm 113 */
				 obj_t arg1615_1065;
				 obj_t arg1617_1067;
				 arg1615_1065 =
				    shape_tools_shape(local_1059);
				 {	/* Globalize/globalize.scm 116 */
				    obj_t aux_1755;
				    {	/* Globalize/globalize.scm 116 */
				       sfun_ginfo_98_bglt obj_1511;
				       obj_1511 =
					  (sfun_ginfo_98_bglt) (sfun_ginfo_98_1060);
				       {
					  obj_t aux_1757;
					  {	/* ./Globalize/ginfo.scm 1058 */
					     object_bglt aux_1758;
					     aux_1758 =
						(object_bglt) (obj_1511);
					     aux_1757 =
						OBJECT_WIDENING(aux_1758);
					  }
					  aux_1755 =
					     (((sfun_ginfo_98_bglt) CREF(aux_1757))->integrator);
				       }
				    }
				    arg1617_1067 =
				       shape_tools_shape(aux_1755);
				 }
				 {	/* Globalize/globalize.scm 113 */
				    obj_t list1618_1068;
				    {	/* Globalize/globalize.scm 113 */
				       obj_t arg1619_1069;
				       {	/* Globalize/globalize.scm 113 */
					  obj_t arg1620_1070;
					  {	/* Globalize/globalize.scm 113 */
					     obj_t arg1621_1071;
					     {	/* Globalize/globalize.scm 113 */
						obj_t arg1622_1072;
						{	/* Globalize/globalize.scm 113 */
						   obj_t aux_1763;
						   aux_1763 =
						      BCHAR(((unsigned char) '\n'));
						   arg1622_1072 =
						      MAKE_PAIR(aux_1763, BNIL);
						}
						arg1621_1071 =
						   MAKE_PAIR(arg1617_1067, arg1622_1072);
					     }
					     arg1620_1070 =
						MAKE_PAIR(string1728_globalize_globalize, arg1621_1071);
					  }
					  arg1619_1069 =
					     MAKE_PAIR(arg1615_1065, arg1620_1070);
				       }
				       list1618_1068 =
					  MAKE_PAIR(string1727_globalize_globalize, arg1619_1069);
				    }
				    verbose_tools_speek(
				       BINT(((long) 3)), list1618_1068);
				 }
			      }
			    else
			      {		/* Globalize/globalize.scm 113 */
				 BUNSPEC;
			      }
			 }
		       else
			 {	/* Globalize/globalize.scm 118 */
			    bool_t test1625_1076;
			    test1625_1076 =
			       ___161___r4_numbers_6_5(
			       BINT(((long) 3)), _verbose__1_engine_param, BNIL);
			    if (test1625_1076)
			      {		/* Globalize/globalize.scm 118 */
				 obj_t arg1627_1078;
				 arg1627_1078 =
				    shape_tools_shape(local_1059);
				 {	/* Globalize/globalize.scm 118 */
				    obj_t list1629_1080;
				    {	/* Globalize/globalize.scm 118 */
				       obj_t arg1630_1081;
				       {	/* Globalize/globalize.scm 118 */
					  obj_t arg1631_1082;
					  {	/* Globalize/globalize.scm 118 */
					     obj_t arg1632_1083;
					     {	/* Globalize/globalize.scm 118 */
						obj_t aux_1776;
						aux_1776 =
						   BCHAR(((unsigned char) '\n'));
						arg1632_1083 =
						   MAKE_PAIR(aux_1776, BNIL);
					     }
					     arg1631_1082 =
						MAKE_PAIR(string1729_globalize_globalize, arg1632_1083);
					  }
					  arg1630_1081 =
					     MAKE_PAIR(arg1627_1078, arg1631_1082);
				       }
				       list1629_1080 =
					  MAKE_PAIR(string1727_globalize_globalize, arg1630_1081);
				    }
				    verbose_tools_speek(
				       BINT(((long) 3)), list1629_1080);
				 }
			      }
			    else
			      {		/* Globalize/globalize.scm 118 */
				 BUNSPEC;
			      }
			 }
		    }
		 }
	      }
	      {
		 obj_t l1558_1784;
		 l1558_1784 =
		    CDR(l1558_1056);
		 l1558_1056 = l1558_1784;
		 goto lname1559_1057;
	      }
	   }
	 else
	   {	/* Globalize/globalize.scm 110 */
	      return ((bool_t) 1);
	   }
      }
   }
}



/* method-init */
obj_t 
method_init_76_globalize_globalize()
{
   AN_OBJECT;
   {	/* Globalize/globalize.scm 14 */
      return BUNSPEC;
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_globalize_globalize()
{
   AN_OBJECT;
   {	/* Globalize/globalize.scm 14 */
      module_initialization_70_tools_trace(((long) 0), "GLOBALIZE_GLOBALIZE");
      module_initialization_70_engine_param(((long) 0), "GLOBALIZE_GLOBALIZE");
      module_initialization_70_tools_shape(((long) 0), "GLOBALIZE_GLOBALIZE");
      module_initialization_70_tools_speek(((long) 0), "GLOBALIZE_GLOBALIZE");
      module_initialization_70_type_type(((long) 0), "GLOBALIZE_GLOBALIZE");
      module_initialization_70_ast_var(((long) 0), "GLOBALIZE_GLOBALIZE");
      module_initialization_70_ast_node(((long) 0), "GLOBALIZE_GLOBALIZE");
      module_initialization_70_globalize_ginfo(((long) 0), "GLOBALIZE_GLOBALIZE");
      module_initialization_70_globalize_node(((long) 0), "GLOBALIZE_GLOBALIZE");
      module_initialization_70_globalize_free(((long) 0), "GLOBALIZE_GLOBALIZE");
      module_initialization_70_globalize_kapture(((long) 0), "GLOBALIZE_GLOBALIZE");
      module_initialization_70_globalize_gn(((long) 0), "GLOBALIZE_GLOBALIZE");
      module_initialization_70_globalize_integration(((long) 0), "GLOBALIZE_GLOBALIZE");
      module_initialization_70_globalize_new_body_146(((long) 0), "GLOBALIZE_GLOBALIZE");
      module_initialization_70_globalize_local__global_194(((long) 0), "GLOBALIZE_GLOBALIZE");
      return
	 module_initialization_70_globalize_global_closure_246(((long) 0), "GLOBALIZE_GLOBALIZE");
   }
}
