/*===========================================================================*/
/*   (Globalize/gloclo.scm)                                                  */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;

typedef struct ccomp
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t producer;
     obj_t consumer;
     obj_t finalizer;
     obj_t checksummer;
  }
     *ccomp_bglt;

typedef struct sfun_ginfo_98
  {
     bool_t g__219;
     obj_t cfrom;
     obj_t cfrom__119;
     obj_t cto;
     obj_t cto__14;
     obj_t cfunction;
     obj_t integrator;
     obj_t integrated;
     obj_t plugged_in_15;
     long mark;
     obj_t free_mark_81;
     obj_t the_global_201;
     obj_t kaptured;
     obj_t new_body_215;
     long bmark;
     long umark;
     obj_t free;
     obj_t bound;
  }
             *sfun_ginfo_98_bglt;

typedef struct svar_ginfo_131
  {
     bool_t kaptured__204;
     long free_mark_81;
     long mark;
     bool_t celled__113;
  }
              *svar_ginfo_131_bglt;

typedef struct sexit_ginfo_81
  {
     bool_t g__219;
     bool_t kaptured__204;
     long free_mark_81;
     long mark;
  }
              *sexit_ginfo_81_bglt;

typedef struct local_ginfo_108
  {
     bool_t escape__117;
  }
               *local_ginfo_108_bglt;

typedef struct global_ginfo_75
  {
     bool_t escape__117;
     obj_t global_closure_229;
  }
               *global_ginfo_75_bglt;


extern obj_t local_ginfo_108_globalize_ginfo;
extern obj_t make_n_proto_123_tools_args(obj_t);
static obj_t method_init_76_globalize_global_closure_246();
extern obj_t symbol_append_197___r4_symbols_6_4(obj_t);
static obj_t _make_global_closure_22_globalize_global_closure_246(obj_t, obj_t);
extern obj_t string_append(obj_t, obj_t);
extern obj_t var_ast_node;
static obj_t gloclo_globalize_global_closure_246(global_bglt, local_bglt, obj_t);
extern obj_t global_ast_var;
extern obj_t gensym___r4_symbols_6_4;
extern obj_t _obj__252_type_cache;
static obj_t _foreign_closures__211_globalize_global_closure_246 = BUNSPEC;
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t module_initialization_70_globalize_global_closure_246(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_args(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_ast_sexp(long, char *);
extern obj_t module_initialization_70_ast_local(long, char *);
extern obj_t module_initialization_70_ast_glo_def_117(long, char *);
extern obj_t module_initialization_70_module_module(long, char *);
extern obj_t module_initialization_70_globalize_ginfo(long, char *);
extern obj_t module_initialization_70_globalize_node(long, char *);
extern obj_t module_initialization_70_globalize_free(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_symbols_6_4(long, char *);
extern global_bglt make_global_closure_44_globalize_global_closure_246(global_bglt);
extern local_bglt make_local_svar_140_ast_local(obj_t, type_bglt);
extern long class_num_218___object(obj_t);
static obj_t _foreign_closures_249_globalize_global_closure_246(obj_t);
static obj_t imported_modules_init_94_globalize_global_closure_246();
extern obj_t cfun_ast_var;
extern obj_t app_ast_node;
static obj_t library_modules_init_112_globalize_global_closure_246();
extern obj_t global_ginfo_75_globalize_ginfo;
extern obj_t svar_ginfo_131_globalize_ginfo;
extern obj_t foreign_closures_19_globalize_global_closure_246();
static obj_t _global_closure_9_globalize_global_closure_246(obj_t, obj_t, obj_t);
static obj_t toplevel_init_63_globalize_global_closure_246();
extern obj_t open_input_string(obj_t);
extern bool_t symbol_exists_p(char *);
extern obj_t sfun_ast_var;
extern obj_t local_ast_var;
extern global_bglt global_closure_229_globalize_global_closure_246(global_bglt, obj_t);
extern global_bglt def_global_sfun_no_warning__10_ast_glo_def_117(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t internal_error_43_tools_error(obj_t, obj_t, obj_t);
extern obj_t __arity_132_tools_args(obj_t, obj_t);
extern obj_t _module__166_module_module;
extern obj_t _procedure__226_type_cache;
extern obj_t the_global_closure_233_globalize_free(global_bglt, obj_t);
extern obj_t read___reader(obj_t);
extern obj_t ____74_type_cache;
static obj_t require_initialization_114_globalize_global_closure_246 = BUNSPEC;
static obj_t cnst_init_137_globalize_global_closure_246();
static obj_t __cnst[8];

DEFINE_EXPORT_PROCEDURE(global_closure_env_218_globalize_global_closure_246, _global_closure_9_globalize_global_closure_2461773, _global_closure_9_globalize_global_closure_246, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_global_closure_env_43_globalize_global_closure_246, _make_global_closure_22_globalize_global_closure_2461774, _make_global_closure_22_globalize_global_closure_246, 0L, 1);
DEFINE_EXPORT_PROCEDURE(foreign_closures_env_102_globalize_global_closure_246, _foreign_closures_249_globalize_global_closure_2461775, _foreign_closures_249_globalize_global_closure_246, 0L, 0);
DEFINE_STRING(string1768_globalize_global_closure_246, string1768_globalize_global_closure_2461776, "STATIC NEVER NOW SFUN FOREIGN ::OBJ _ ENV ", 42);
DEFINE_STRING(string1767_globalize_global_closure_246, string1767_globalize_global_closure_2461777, "Can't allocate global closure", 29);
DEFINE_STRING(string1766_globalize_global_closure_246, string1766_globalize_global_closure_2461778, "global-closure", 14);
DEFINE_STRING(string1765_globalize_global_closure_246, string1765_globalize_global_closure_2461779, "_", 1);
DEFINE_STRING(string1764_globalize_global_closure_246, string1764_globalize_global_closure_2461780, "Unexpected value", 16);
DEFINE_STRING(string1763_globalize_global_closure_246, string1763_globalize_global_closure_2461781, "make-global-closure", 19);



/* module-initialization */
obj_t 
module_initialization_70_globalize_global_closure_246(long checksum_1822, char *from_1823)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_globalize_global_closure_246))
	{
	   require_initialization_114_globalize_global_closure_246 =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_globalize_global_closure_246();
	   cnst_init_137_globalize_global_closure_246();
	   imported_modules_init_94_globalize_global_closure_246();
	   method_init_76_globalize_global_closure_246();
	   toplevel_init_63_globalize_global_closure_246();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_globalize_global_closure_246()
{
   AN_OBJECT;
   {	/* Globalize/gloclo.scm 14 */
      module_initialization_70___r4_symbols_6_4(((long) 0), "GLOBALIZE_GLOBAL-CLOSURE");
      module_initialization_70___object(((long) 0), "GLOBALIZE_GLOBAL-CLOSURE");
      module_initialization_70___reader(((long) 0), "GLOBALIZE_GLOBAL-CLOSURE");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_globalize_global_closure_246()
{
   AN_OBJECT;
   {	/* Globalize/gloclo.scm 14 */
      {		/* Globalize/gloclo.scm 14 */
	 obj_t cnst_port_138_1815;
	 cnst_port_138_1815 =
	    open_input_string(string1768_globalize_global_closure_246);
	 {
	    long i_1816;
	    i_1816 = ((long) 7);
	  loop_1817:
	    {	/* Globalize/gloclo.scm 14 */
	       bool_t test1769_1818;
	       test1769_1818 =
		  (i_1816 == ((long) -1));
	       if (test1769_1818)
		 {	/* Globalize/gloclo.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Globalize/gloclo.scm 14 */
		    {	/* Globalize/gloclo.scm 14 */
		       obj_t arg1770_1819;
		       {	/* Globalize/gloclo.scm 14 */
			  obj_t list1771_1820;
			  list1771_1820 =
			     MAKE_PAIR(cnst_port_138_1815, BNIL);
			  arg1770_1819 =
			     read___reader(list1771_1820);
		       }
		       CNST_TABLE_SET(i_1816, arg1770_1819);
		    }
		    {	/* Globalize/gloclo.scm 14 */
		       int aux_1821;
		       {	/* Globalize/gloclo.scm 14 */
			  long aux_1841;
			  aux_1841 =
			     (i_1816 - ((long) 1));
			  aux_1821 =
			     (int) (aux_1841);
		       }
		       {
			  long i_1844;
			  i_1844 =
			     (long) (aux_1821);
			  i_1816 = i_1844;
			  goto loop_1817;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_globalize_global_closure_246()
{
   AN_OBJECT;
   {	/* Globalize/gloclo.scm 14 */
      return (
	 _foreign_closures__211_globalize_global_closure_246 = BNIL, BUNSPEC);
   }
}



/* global-closure */
global_bglt 
global_closure_229_globalize_global_closure_246(global_bglt global_1, obj_t loc_2)
{
   AN_OBJECT;
   {	/* Globalize/gloclo.scm 38 */
      the_global_closure_233_globalize_free(global_1, loc_2);
      return
	 make_global_closure_44_globalize_global_closure_246(global_1);
   }
}



/* _global-closure */
obj_t 
_global_closure_9_globalize_global_closure_246(obj_t env_1809, obj_t global_1810, obj_t loc_1811)
{
   AN_OBJECT;
   {	/* Globalize/gloclo.scm 38 */
      {		/* Globalize/gloclo.scm 38 */
	 global_bglt aux_1848;
	 aux_1848 =
	    global_closure_229_globalize_global_closure_246(
	    (global_bglt) (global_1810), loc_1811);
	 return
	    (obj_t) (aux_1848);
      }
   }
}



/* make-global-closure */
global_bglt 
make_global_closure_44_globalize_global_closure_246(global_bglt global_3)
{
   AN_OBJECT;
   {	/* Globalize/gloclo.scm 45 */
      {		/* Globalize/gloclo.scm 46 */
	 obj_t glo_1011;
	 {	/* Globalize/gloclo.scm 46 */
	    global_ginfo_75_bglt obj_1526;
	    obj_1526 =
	       (global_ginfo_75_bglt) (global_3);
	    {
	       obj_t aux_1853;
	       {	/* ./Globalize/ginfo.scm 1509 */
		  object_bglt aux_1854;
		  aux_1854 =
		     (object_bglt) (obj_1526);
		  aux_1853 =
		     OBJECT_WIDENING(aux_1854);
	       }
	       glo_1011 =
		  (((global_ginfo_75_bglt) CREF(aux_1853))->global_closure_229);
	    }
	 }
	 {	/* Globalize/gloclo.scm 47 */
	    bool_t test1581_1012;
	    test1581_1012 =
	       is_a__118___object(glo_1011, global_ast_var);
	    if (test1581_1012)
	      {		/* Globalize/gloclo.scm 47 */
		 return
		    (global_bglt) (glo_1011);
	      }
	    else
	      {		/* Globalize/gloclo.scm 49 */
		 value_bglt old_fun_147_1013;
		 old_fun_147_1013 =
		    (((global_bglt) CREF(global_3))->value);
		 {	/* Globalize/gloclo.scm 49 */
		    local_bglt env_1014;
		    {	/* Globalize/gloclo.scm 50 */
		       local_bglt var_1076;
		       var_1076 =
			  make_local_svar_140_ast_local(
			  CNST_TABLE_REF(((long) 0)),
			  (type_bglt) (_procedure__226_type_cache));
		       {	/* Globalize/gloclo.scm 51 */
			  local_ginfo_108_bglt obj1562_1077;
			  obj1562_1077 =
			     ((local_ginfo_108_bglt) (var_1076));
			  {	/* Globalize/gloclo.scm 51 */
			     local_ginfo_108_bglt arg1620_1078;
			     {	/* Globalize/gloclo.scm 51 */
				local_ginfo_108_bglt res1755_1532;
				{	/* ./Globalize/ginfo.scm 1501 */
				   local_ginfo_108_bglt new1535_1530;
				   new1535_1530 =
				      ((local_ginfo_108_bglt) BREF(GC_MALLOC(sizeof(struct local_ginfo_108))));
				   ((((local_ginfo_108_bglt) CREF(new1535_1530))->escape__117) = ((bool_t) ((bool_t) 0)), BUNSPEC);
				   res1755_1532 = new1535_1530;
				}
				arg1620_1078 = res1755_1532;
			     }
			     {	/* Globalize/gloclo.scm 51 */
				obj_t aux_1870;
				object_bglt aux_1868;
				aux_1870 =
				   (obj_t) (arg1620_1078);
				aux_1868 =
				   (object_bglt) (obj1562_1077);
				OBJECT_WIDENING_SET(aux_1868, aux_1870);
			     }
			  }
			  {	/* Globalize/gloclo.scm 51 */
			     long arg1621_1079;
			     arg1621_1079 =
				class_num_218___object(local_ginfo_108_globalize_ginfo);
			     {	/* Globalize/gloclo.scm 51 */
				obj_t obj_1533;
				obj_1533 =
				   (obj_t) (obj1562_1077);
				(((obj_t) CREF(obj_1533))->header = MAKE_HEADER(arg1621_1079, 0), BUNSPEC);
			     }
			  }
			  obj1562_1077;
		       }
		       env_1014 = var_1076;
		    }
		    {	/* Globalize/gloclo.scm 50 */
		       obj_t new_args_235_1015;
		       {	/* Globalize/gloclo.scm 53 */
			  obj_t l1563_1051;
			  {	/* Globalize/gloclo.scm 65 */
			     bool_t test1618_1074;
			     test1618_1074 =
				is_a__118___object(
				(obj_t) (old_fun_147_1013), sfun_ast_var);
			     if (test1618_1074)
			       {	/* Globalize/gloclo.scm 66 */
				  sfun_bglt obj_1536;
				  obj_1536 =
				     (sfun_bglt) (old_fun_147_1013);
				  l1563_1051 =
				     (((sfun_bglt) CREF(obj_1536))->args);
			       }
			     else
			       {	/* Globalize/gloclo.scm 67 */
				  bool_t test1619_1075;
				  test1619_1075 =
				     is_a__118___object(
				     (obj_t) (old_fun_147_1013), cfun_ast_var);
				  if (test1619_1075)
				    {	/* Globalize/gloclo.scm 72 */
				       cfun_bglt obj_1538;
				       obj_1538 =
					  (cfun_bglt) (old_fun_147_1013);
				       l1563_1051 =
					  (((cfun_bglt) CREF(obj_1538))->args_type_205);
				    }
				  else
				    {	/* Globalize/gloclo.scm 67 */
				       l1563_1051 =
					  internal_error_43_tools_error(string1763_globalize_global_closure_246, string1764_globalize_global_closure_246,
					  (obj_t) (old_fun_147_1013));
				    }
			       }
			  }
			  if (
			     NULLP(l1563_1051))
			    {	/* Globalize/gloclo.scm 53 */
			       new_args_235_1015 = BNIL;
			    }
			  else
			    {	/* Globalize/gloclo.scm 53 */
			       obj_t head1565_1053;
			       head1565_1053 =
				  MAKE_PAIR(BNIL, BNIL);
			       {
				  obj_t l1563_1054;
				  obj_t tail1566_1055;
				  l1563_1054 = l1563_1051;
				  tail1566_1055 = head1565_1053;
				lname1564_1056:
				  if (
				     NULLP(l1563_1054))
				    {	/* Globalize/gloclo.scm 53 */
				       new_args_235_1015 =
					  CDR(head1565_1053);
				    }
				  else
				    {	/* Globalize/gloclo.scm 54 */
				       obj_t newtail1567_1058;
				       {	/* Globalize/gloclo.scm 54 */
					  local_bglt arg1608_1060;
					  {	/* Globalize/gloclo.scm 54 */
					     obj_t old_1062;
					     old_1062 =
						CAR(l1563_1054);
					     {	/* Globalize/gloclo.scm 54 */
						local_bglt new_1063;
						{	/* Globalize/gloclo.scm 55 */
						   obj_t arg1616_1072;
						   {	/* Globalize/gloclo.scm 55 */
						      bool_t test1617_1073;
						      test1617_1073 =
							 is_a__118___object(old_1062, local_ast_var);
						      if (test1617_1073)
							{	/* Globalize/gloclo.scm 56 */
							   local_bglt obj_1546;
							   obj_1546 =
							      (local_bglt) (old_1062);
							   arg1616_1072 =
							      (((local_bglt) CREF(obj_1546))->id);
							}
						      else
							{	/* Globalize/gloclo.scm 55 */
							   arg1616_1072 =
							      PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4, BEOA);
							}
						   }
						   new_1063 =
						      make_local_svar_140_ast_local(arg1616_1072,
						      (type_bglt) (_obj__252_type_cache));
						}
						{	/* Globalize/gloclo.scm 59 */
						   bool_t test1610_1064;
						   test1610_1064 =
						      is_a__118___object(old_1062, local_ast_var);
						   if (test1610_1064)
						     {	/* Globalize/gloclo.scm 61 */
							bool_t arg1611_1065;
							{	/* Globalize/gloclo.scm 61 */
							   local_bglt obj_1548;
							   obj_1548 =
							      (local_bglt) (old_1062);
							   arg1611_1065 =
							      (((local_bglt) CREF(obj_1548))->user__32);
							}
							((((local_bglt) CREF(new_1063))->user__32) = ((bool_t) arg1611_1065), BUNSPEC);
						     }
						   else
						     {	/* Globalize/gloclo.scm 59 */
							BUNSPEC;
						     }
						}
						{	/* Globalize/gloclo.scm 62 */
						   svar_ginfo_131_bglt obj1568_1066;
						   obj1568_1066 =
						      ((svar_ginfo_131_bglt) (
							 (((local_bglt) CREF(new_1063))->value)));
						   {	/* Globalize/gloclo.scm 62 */
						      svar_ginfo_131_bglt arg1612_1067;
						      {		/* Globalize/gloclo.scm 62 */
							 svar_ginfo_131_bglt res1756_1561;
							 {	/* ./Globalize/ginfo.scm 1481 */
							    svar_ginfo_131_bglt new1502_1556;
							    new1502_1556 =
							       ((svar_ginfo_131_bglt) BREF(GC_MALLOC(sizeof(struct svar_ginfo_131))));
							    ((((svar_ginfo_131_bglt) CREF(new1502_1556))->kaptured__204) = ((bool_t) ((bool_t) 0)), BUNSPEC);
							    ((((svar_ginfo_131_bglt) CREF(new1502_1556))->free_mark_81) = ((long) ((long) -10)), BUNSPEC);
							    ((((svar_ginfo_131_bglt) CREF(new1502_1556))->mark) = ((long) ((long) -10)), BUNSPEC);
							    ((((svar_ginfo_131_bglt) CREF(new1502_1556))->celled__113) = ((bool_t) ((bool_t) 0)), BUNSPEC);
							    res1756_1561 = new1502_1556;
							 }
							 arg1612_1067 = res1756_1561;
						      }
						      {		/* Globalize/gloclo.scm 62 */
							 obj_t aux_1917;
							 object_bglt aux_1915;
							 aux_1917 =
							    (obj_t) (arg1612_1067);
							 aux_1915 =
							    (object_bglt) (obj1568_1066);
							 OBJECT_WIDENING_SET(aux_1915, aux_1917);
						      }
						   }
						   {	/* Globalize/gloclo.scm 62 */
						      long arg1613_1068;
						      arg1613_1068 =
							 class_num_218___object(svar_ginfo_131_globalize_ginfo);
						      {		/* Globalize/gloclo.scm 62 */
							 obj_t obj_1562;
							 obj_1562 =
							    (obj_t) (obj1568_1066);
							 (((obj_t) CREF(obj_1562))->header = MAKE_HEADER(arg1613_1068, 0), BUNSPEC);
						      }
						   }
						   obj1568_1066;
						}
						{	/* Globalize/gloclo.scm 63 */
						   local_ginfo_108_bglt obj1569_1069;
						   obj1569_1069 =
						      ((local_ginfo_108_bglt) (new_1063));
						   {	/* Globalize/gloclo.scm 63 */
						      local_ginfo_108_bglt arg1614_1070;
						      {		/* Globalize/gloclo.scm 63 */
							 local_ginfo_108_bglt res1757_1567;
							 {	/* ./Globalize/ginfo.scm 1501 */
							    local_ginfo_108_bglt new1535_1565;
							    new1535_1565 =
							       ((local_ginfo_108_bglt) BREF(GC_MALLOC(sizeof(struct local_ginfo_108))));
							    ((((local_ginfo_108_bglt) CREF(new1535_1565))->escape__117) = ((bool_t) ((bool_t) 0)), BUNSPEC);
							    res1757_1567 = new1535_1565;
							 }
							 arg1614_1070 = res1757_1567;
						      }
						      {		/* Globalize/gloclo.scm 63 */
							 obj_t aux_1928;
							 object_bglt aux_1926;
							 aux_1928 =
							    (obj_t) (arg1614_1070);
							 aux_1926 =
							    (object_bglt) (obj1569_1069);
							 OBJECT_WIDENING_SET(aux_1926, aux_1928);
						      }
						   }
						   {	/* Globalize/gloclo.scm 63 */
						      long arg1615_1071;
						      arg1615_1071 =
							 class_num_218___object(local_ginfo_108_globalize_ginfo);
						      {		/* Globalize/gloclo.scm 63 */
							 obj_t obj_1568;
							 obj_1568 =
							    (obj_t) (obj1569_1069);
							 (((obj_t) CREF(obj_1568))->header = MAKE_HEADER(arg1615_1071, 0), BUNSPEC);
						      }
						   }
						   obj1569_1069;
						}
						arg1608_1060 = new_1063;
					     }
					  }
					  {	/* ./Ieee/pair-list.scm 5689 */
					     obj_t aux_1934;
					     aux_1934 =
						(obj_t) (arg1608_1060);
					     newtail1567_1058 =
						MAKE_PAIR(aux_1934, BNIL);
					  }
				       }
				       SET_CDR(tail1566_1055, newtail1567_1058);
				       {
					  obj_t tail1566_1940;
					  obj_t l1563_1938;
					  l1563_1938 =
					     CDR(l1563_1054);
					  tail1566_1940 = newtail1567_1058;
					  tail1566_1055 = tail1566_1940;
					  l1563_1054 = l1563_1938;
					  goto lname1564_1056;
				       }
				    }
			       }
			    }
		       }
		       {	/* Globalize/gloclo.scm 53 */
			  obj_t loc_1016;
			  {	/* Globalize/gloclo.scm 76 */
			     bool_t test1604_1050;
			     test1604_1050 =
				is_a__118___object(
				(obj_t) (old_fun_147_1013), sfun_ast_var);
			     if (test1604_1050)
			       {	/* Globalize/gloclo.scm 77 */
				  sfun_bglt obj_1576;
				  obj_1576 =
				     (sfun_bglt) (old_fun_147_1013);
				  loc_1016 =
				     (((sfun_bglt) CREF(obj_1576))->loc);
			       }
			     else
			       {	/* Globalize/gloclo.scm 76 */
				  loc_1016 = BUNSPEC;
			       }
			  }
			  {	/* Globalize/gloclo.scm 76 */
			     obj_t gloclo_1017;
			     gloclo_1017 =
				gloclo_globalize_global_closure_246(global_3, env_1014, new_args_235_1015);
			     {	/* Globalize/gloclo.scm 78 */
				value_bglt new_fun_115_1018;
				{	/* Globalize/gloclo.scm 79 */
				   global_bglt obj_1577;
				   obj_1577 =
				      (global_bglt) (gloclo_1017);
				   new_fun_115_1018 =
				      (((global_bglt) CREF(obj_1577))->value);
				}
				{	/* Globalize/gloclo.scm 79 */

				   {	/* Globalize/gloclo.scm 81 */
				      svar_ginfo_131_bglt obj1570_1019;
				      obj1570_1019 =
					 ((svar_ginfo_131_bglt) (
					    (((local_bglt) CREF(env_1014))->value)));
				      {		/* Globalize/gloclo.scm 81 */
					 svar_ginfo_131_bglt arg1582_1020;
					 {	/* Globalize/gloclo.scm 81 */
					    svar_ginfo_131_bglt res1758_1588;
					    {	/* ./Globalize/ginfo.scm 1481 */
					       svar_ginfo_131_bglt new1502_1583;
					       new1502_1583 =
						  ((svar_ginfo_131_bglt) BREF(GC_MALLOC(sizeof(struct svar_ginfo_131))));
					       ((((svar_ginfo_131_bglt) CREF(new1502_1583))->kaptured__204) = ((bool_t) ((bool_t) 0)), BUNSPEC);
					       ((((svar_ginfo_131_bglt) CREF(new1502_1583))->free_mark_81) = ((long) ((long) -10)), BUNSPEC);
					       ((((svar_ginfo_131_bglt) CREF(new1502_1583))->mark) = ((long) ((long) -10)), BUNSPEC);
					       ((((svar_ginfo_131_bglt) CREF(new1502_1583))->celled__113) = ((bool_t) ((bool_t) 0)), BUNSPEC);
					       res1758_1588 = new1502_1583;
					    }
					    arg1582_1020 = res1758_1588;
					 }
					 {	/* Globalize/gloclo.scm 81 */
					    obj_t aux_1958;
					    object_bglt aux_1956;
					    aux_1958 =
					       (obj_t) (arg1582_1020);
					    aux_1956 =
					       (object_bglt) (obj1570_1019);
					    OBJECT_WIDENING_SET(aux_1956, aux_1958);
					 }
				      }
				      {		/* Globalize/gloclo.scm 81 */
					 long arg1583_1021;
					 arg1583_1021 =
					    class_num_218___object(svar_ginfo_131_globalize_ginfo);
					 {	/* Globalize/gloclo.scm 81 */
					    obj_t obj_1589;
					    obj_1589 =
					       (obj_t) (obj1570_1019);
					    (((obj_t) CREF(obj_1589))->header = MAKE_HEADER(arg1583_1021, 0), BUNSPEC);
					 }
				      }
				      obj1570_1019;
				   }
				   {	/* Globalize/gloclo.scm 83 */
				      global_ginfo_75_bglt obj1572_1022;
				      obj1572_1022 =
					 ((global_ginfo_75_bglt) (gloclo_1017));
				      {		/* Globalize/gloclo.scm 83 */
					 global_ginfo_75_bglt arg1584_1023;
					 {	/* Globalize/gloclo.scm 83 */
					    global_ginfo_75_bglt res1759_1596;
					    {	/* Globalize/gloclo.scm 83 */
					       obj_t global_closure_229_1592;
					       global_closure_229_1592 = BFALSE;
					       {	/* ./Globalize/ginfo.scm 1505 */
						  global_ginfo_75_bglt new1555_1593;
						  new1555_1593 =
						     ((global_ginfo_75_bglt) BREF(GC_MALLOC(sizeof(struct global_ginfo_75))));
						  ((((global_ginfo_75_bglt) CREF(new1555_1593))->escape__117) = ((bool_t) ((bool_t) 1)), BUNSPEC);
						  ((((global_ginfo_75_bglt) CREF(new1555_1593))->global_closure_229) = ((obj_t) global_closure_229_1592), BUNSPEC);
						  res1759_1596 = new1555_1593;
					       }
					    }
					    arg1584_1023 = res1759_1596;
					 }
					 {	/* Globalize/gloclo.scm 83 */
					    obj_t aux_1970;
					    object_bglt aux_1968;
					    aux_1970 =
					       (obj_t) (arg1584_1023);
					    aux_1968 =
					       (object_bglt) (obj1572_1022);
					    OBJECT_WIDENING_SET(aux_1968, aux_1970);
					 }
				      }
				      {		/* Globalize/gloclo.scm 83 */
					 long arg1586_1025;
					 arg1586_1025 =
					    class_num_218___object(global_ginfo_75_globalize_ginfo);
					 {	/* Globalize/gloclo.scm 83 */
					    obj_t obj_1597;
					    obj_1597 =
					       (obj_t) (obj1572_1022);
					    (((obj_t) CREF(obj_1597))->header = MAKE_HEADER(arg1586_1025, 0), BUNSPEC);
					 }
				      }
				      obj1572_1022;
				   }
				   {	/* Globalize/gloclo.scm 85 */
				      app_bglt arg1587_1026;
				      {		/* Globalize/gloclo.scm 85 */
					 obj_t arg1589_1028;
					 var_bglt arg1591_1030;
					 obj_t arg1592_1031;
					 arg1589_1028 = _obj__252_type_cache;
					 {	/* Globalize/gloclo.scm 88 */
					    obj_t arg1594_1033;
					    arg1594_1033 = ____74_type_cache;
					    {	/* Globalize/gloclo.scm 88 */
					       var_bglt res1760_1609;
					       {	/* Globalize/gloclo.scm 88 */
						  type_bglt type_1600;
						  variable_bglt variable_1601;
						  type_1600 =
						     (type_bglt) (arg1594_1033);
						  variable_1601 =
						     (variable_bglt) (global_3);
						  {	/* ./Ast/node.scm 1063 */
						     var_bglt new1210_1602;
						     new1210_1602 =
							((var_bglt) BREF(GC_MALLOC(sizeof(struct var))));
						     {	/* ./Ast/node.scm 1063 */
							long arg1723_1603;
							arg1723_1603 =
							   class_num_218___object(var_ast_node);
							{	/* ./Ast/node.scm 1063 */
							   obj_t obj_1607;
							   obj_1607 =
							      (obj_t) (new1210_1602);
							   (((obj_t) CREF(obj_1607))->header = MAKE_HEADER(arg1723_1603, 0), BUNSPEC);
							}
						     }
						     {	/* ./Ast/node.scm 1063 */
							object_bglt aux_1982;
							aux_1982 =
							   (object_bglt) (new1210_1602);
							OBJECT_WIDENING_SET(aux_1982, BFALSE);
						     }
						     ((((var_bglt) CREF(new1210_1602))->loc) = ((obj_t) loc_1016), BUNSPEC);
						     ((((var_bglt) CREF(new1210_1602))->type) = ((type_bglt) type_1600), BUNSPEC);
						     ((((var_bglt) CREF(new1210_1602))->variable) = ((variable_bglt) variable_1601), BUNSPEC);
						     res1760_1609 = new1210_1602;
						  }
					       }
					       arg1591_1030 = res1760_1609;
					    }
					 }
					 if (
					    NULLP(new_args_235_1015))
					   {	/* Globalize/gloclo.scm 95 */
					      arg1592_1031 = BNIL;
					   }
					 else
					   {	/* Globalize/gloclo.scm 95 */
					      obj_t head1577_1037;
					      head1577_1037 =
						 MAKE_PAIR(BNIL, BNIL);
					      {
						 obj_t l1575_1038;
						 obj_t tail1578_1039;
						 l1575_1038 = new_args_235_1015;
						 tail1578_1039 = head1577_1037;
					       lname1576_1040:
						 if (
						    NULLP(l1575_1038))
						   {	/* Globalize/gloclo.scm 95 */
						      arg1592_1031 =
							 CDR(head1577_1037);
						   }
						 else
						   {	/* Globalize/gloclo.scm 96 */
						      obj_t newtail1579_1042;
						      {		/* Globalize/gloclo.scm 96 */
							 var_bglt arg1599_1044;
							 {	/* Globalize/gloclo.scm 96 */
							    obj_t arg1602_1048;
							    arg1602_1048 = _obj__252_type_cache;
							    {	/* Globalize/gloclo.scm 96 */
							       var_bglt res1761_1626;
							       {	/* Globalize/gloclo.scm 96 */
								  type_bglt type_1617;
								  variable_bglt variable_1618;
								  type_1617 =
								     (type_bglt) (arg1602_1048);
								  {	/* Globalize/gloclo.scm 96 */
								     obj_t aux_1995;
								     aux_1995 =
									CAR(l1575_1038);
								     variable_1618 =
									(variable_bglt) (aux_1995);
								  }
								  {	/* ./Ast/node.scm 1063 */
								     var_bglt new1210_1619;
								     new1210_1619 =
									((var_bglt) BREF(GC_MALLOC(sizeof(struct var))));
								     {	/* ./Ast/node.scm 1063 */
									long arg1723_1620;
									arg1723_1620 =
									   class_num_218___object(var_ast_node);
									{	/* ./Ast/node.scm 1063 */
									   obj_t obj_1624;
									   obj_1624 =
									      (obj_t) (new1210_1619);
									   (((obj_t) CREF(obj_1624))->header = MAKE_HEADER(arg1723_1620, 0), BUNSPEC);
									}
								     }
								     {	/* ./Ast/node.scm 1063 */
									object_bglt aux_2002;
									aux_2002 =
									   (object_bglt) (new1210_1619);
									OBJECT_WIDENING_SET(aux_2002, BFALSE);
								     }
								     ((((var_bglt) CREF(new1210_1619))->loc) = ((obj_t) loc_1016), BUNSPEC);
								     ((((var_bglt) CREF(new1210_1619))->type) = ((type_bglt) type_1617), BUNSPEC);
								     ((((var_bglt) CREF(new1210_1619))->variable) = ((variable_bglt) variable_1618), BUNSPEC);
								     res1761_1626 = new1210_1619;
								  }
							       }
							       arg1599_1044 = res1761_1626;
							    }
							 }
							 {	/* ./Ieee/pair-list.scm 5689 */
							    obj_t aux_2008;
							    aux_2008 =
							       (obj_t) (arg1599_1044);
							    newtail1579_1042 =
							       MAKE_PAIR(aux_2008, BNIL);
							 }
						      }
						      SET_CDR(tail1578_1039, newtail1579_1042);
						      {
							 obj_t tail1578_2014;
							 obj_t l1575_2012;
							 l1575_2012 =
							    CDR(l1575_1038);
							 tail1578_2014 = newtail1579_1042;
							 tail1578_1039 = tail1578_2014;
							 l1575_1038 = l1575_2012;
							 goto lname1576_1040;
						      }
						   }
					      }
					   }
					 {	/* Globalize/gloclo.scm 85 */
					    app_bglt res1762_1650;
					    {	/* Globalize/gloclo.scm 85 */
					       type_bglt type_1633;
					       obj_t key_1635;
					       type_1633 =
						  (type_bglt) (arg1589_1028);
					       key_1635 =
						  BINT(((long) -1));
					       {	/* ./Ast/node.scm 1080 */
						  app_bglt new1248_1639;
						  new1248_1639 =
						     ((app_bglt) BREF(GC_MALLOC(sizeof(struct app))));
						  {	/* ./Ast/node.scm 1080 */
						     long arg1715_1640;
						     arg1715_1640 =
							class_num_218___object(app_ast_node);
						     {	/* ./Ast/node.scm 1080 */
							obj_t obj_1648;
							obj_1648 =
							   (obj_t) (new1248_1639);
							(((obj_t) CREF(obj_1648))->header = MAKE_HEADER(arg1715_1640, 0), BUNSPEC);
						     }
						  }
						  {	/* ./Ast/node.scm 1080 */
						     object_bglt aux_2021;
						     aux_2021 =
							(object_bglt) (new1248_1639);
						     OBJECT_WIDENING_SET(aux_2021, BFALSE);
						  }
						  ((((app_bglt) CREF(new1248_1639))->loc) = ((obj_t) loc_1016), BUNSPEC);
						  ((((app_bglt) CREF(new1248_1639))->type) = ((type_bglt) type_1633), BUNSPEC);
						  ((((app_bglt) CREF(new1248_1639))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
						  ((((app_bglt) CREF(new1248_1639))->key) = ((obj_t) key_1635), BUNSPEC);
						  ((((app_bglt) CREF(new1248_1639))->fun) = ((var_bglt) arg1591_1030), BUNSPEC);
						  ((((app_bglt) CREF(new1248_1639))->args) = ((obj_t) arg1592_1031), BUNSPEC);
						  ((((app_bglt) CREF(new1248_1639))->stack_info_255) = ((obj_t) BUNSPEC), BUNSPEC);
						  res1762_1650 = new1248_1639;
					       }
					    }
					    arg1587_1026 = res1762_1650;
					 }
				      }
				      {		/* Globalize/gloclo.scm 84 */
					 sfun_bglt obj_1651;
					 obj_t val1123_1652;
					 obj_1651 =
					    (sfun_bglt) (new_fun_115_1018);
					 val1123_1652 =
					    (obj_t) (arg1587_1026);
					 ((((sfun_bglt) CREF(obj_1651))->body) = ((obj_t) val1123_1652), BUNSPEC);
				      }
				   }
				   return
				      (global_bglt) (gloclo_1017);
				}
			     }
			  }
		       }
		    }
		 }
	      }
	 }
      }
   }
}



/* _make-global-closure */
obj_t 
_make_global_closure_22_globalize_global_closure_246(obj_t env_1812, obj_t global_1813)
{
   AN_OBJECT;
   {	/* Globalize/gloclo.scm 45 */
      {		/* Globalize/gloclo.scm 45 */
	 global_bglt aux_2035;
	 aux_2035 =
	    make_global_closure_44_globalize_global_closure_246(
	    (global_bglt) (global_1813));
	 return
	    (obj_t) (aux_2035);
      }
   }
}



/* foreign-closures */
obj_t 
foreign_closures_19_globalize_global_closure_246()
{
   AN_OBJECT;
   {	/* Globalize/gloclo.scm 114 */
      {		/* Globalize/gloclo.scm 115 */
	 obj_t res_1080;
	 res_1080 = _foreign_closures__211_globalize_global_closure_246;
	 _foreign_closures__211_globalize_global_closure_246 = BNIL;
	 return res_1080;
      }
   }
}



/* _foreign-closures */
obj_t 
_foreign_closures_249_globalize_global_closure_246(obj_t env_1814)
{
   AN_OBJECT;
   {	/* Globalize/gloclo.scm 114 */
      return
	 foreign_closures_19_globalize_global_closure_246();
   }
}



/* gloclo */
obj_t 
gloclo_globalize_global_closure_246(global_bglt global_4, local_bglt env_5, obj_t args_6)
{
   AN_OBJECT;
   {	/* Globalize/gloclo.scm 122 */
      {		/* Globalize/gloclo.scm 123 */
	 long arity_1081;
	 {	/* Globalize/gloclo.scm 123 */
	    fun_bglt obj_1654;
	    {	/* Globalize/gloclo.scm 123 */
	       value_bglt aux_2040;
	       aux_2040 =
		  (((global_bglt) CREF(global_4))->value);
	       obj_1654 =
		  (fun_bglt) (aux_2040);
	    }
	    arity_1081 =
	       (((fun_bglt) CREF(obj_1654))->arity);
	 }
	 {	/* Globalize/gloclo.scm 123 */
	    obj_t id_1082;
	    {	/* Globalize/gloclo.scm 124 */
	       obj_t str_1112;
	       {	/* Globalize/gloclo.scm 124 */
		  obj_t arg1662_1124;
		  {	/* ./Ieee/symbol.scm 6021 */
		     obj_t aux_2044;
		     aux_2044 =
			(((global_bglt) CREF(global_4))->id);
		     arg1662_1124 =
			SYMBOL_TO_STRING(aux_2044);
		  }
		  str_1112 =
		     string_append(string1765_globalize_global_closure_246, arg1662_1124);
	       }
	       {	/* Globalize/gloclo.scm 127 */
		  bool_t test1651_1113;
		  {	/* Globalize/gloclo.scm 127 */
		     char *aux_2048;
		     aux_2048 =
			BSTRING_TO_STRING(str_1112);
		     test1651_1113 =
			symbol_exists_p(aux_2048);
		  }
		  if (test1651_1113)
		    {	/* Globalize/gloclo.scm 128 */
		       obj_t arg1652_1114;
		       {	/* Globalize/gloclo.scm 128 */
			  obj_t arg1653_1115;
			  arg1653_1115 =
			     CNST_TABLE_REF(((long) 1));
			  {	/* Globalize/gloclo.scm 128 */
			     obj_t list1655_1117;
			     {	/* Globalize/gloclo.scm 128 */
				obj_t arg1656_1118;
				{	/* Globalize/gloclo.scm 128 */
				   obj_t aux_2053;
				   aux_2053 =
				      (((global_bglt) CREF(global_4))->id);
				   arg1656_1118 =
				      MAKE_PAIR(aux_2053, BNIL);
				}
				list1655_1117 =
				   MAKE_PAIR(arg1653_1115, arg1656_1118);
			     }
			     arg1652_1114 =
				symbol_append_197___r4_symbols_6_4(list1655_1117);
			  }
		       }
		       id_1082 =
			  PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4, arg1652_1114, BEOA);
		    }
		  else
		    {	/* Globalize/gloclo.scm 129 */
		       obj_t arg1657_1119;
		       arg1657_1119 =
			  CNST_TABLE_REF(((long) 1));
		       {	/* Globalize/gloclo.scm 129 */
			  obj_t list1659_1121;
			  {	/* Globalize/gloclo.scm 129 */
			     obj_t arg1660_1122;
			     {	/* Globalize/gloclo.scm 129 */
				obj_t aux_2061;
				aux_2061 =
				   (((global_bglt) CREF(global_4))->id);
				arg1660_1122 =
				   MAKE_PAIR(aux_2061, BNIL);
			     }
			     list1659_1121 =
				MAKE_PAIR(arg1657_1119, arg1660_1122);
			  }
			  id_1082 =
			     symbol_append_197___r4_symbols_6_4(list1659_1121);
		       }
		    }
	       }
	    }
	    {	/* Globalize/gloclo.scm 124 */
	       global_bglt gloclo_1083;
	       {	/* Globalize/gloclo.scm 130 */
		  obj_t arg1637_1099;
		  obj_t arg1638_1100;
		  obj_t arg1639_1101;
		  obj_t arg1640_1102;
		  obj_t arg1641_1103;
		  obj_t arg1642_1104;
		  obj_t arg1643_1105;
		  {	/* Globalize/gloclo.scm 130 */
		     obj_t list1644_1106;
		     {	/* Globalize/gloclo.scm 130 */
			obj_t arg1646_1107;
			{	/* Globalize/gloclo.scm 130 */
			   obj_t aux_2066;
			   aux_2066 =
			      CNST_TABLE_REF(((long) 2));
			   arg1646_1107 =
			      MAKE_PAIR(aux_2066, BNIL);
			}
			list1644_1106 =
			   MAKE_PAIR(id_1082, arg1646_1107);
		     }
		     arg1637_1099 =
			symbol_append_197___r4_symbols_6_4(list1644_1106);
		  }
		  {	/* Globalize/gloclo.scm 131 */
		     obj_t arg1647_1108;
		     arg1647_1108 =
			__arity_132_tools_args(
			BINT(arity_1081),
			BINT(((long) 1)));
		     arg1638_1100 =
			make_n_proto_123_tools_args(arg1647_1108);
		  }
		  {	/* ./Ieee/pair-list.scm 5689 */
		     obj_t aux_2075;
		     aux_2075 =
			(obj_t) (env_5);
		     arg1639_1101 =
			MAKE_PAIR(aux_2075, args_6);
		  }
		  {	/* Globalize/gloclo.scm 133 */
		     bool_t test_2078;
		     {	/* ./Ieee/equiv.scm 5508 */
			obj_t aux_2081;
			obj_t aux_2079;
			aux_2081 =
			   CNST_TABLE_REF(((long) 3));
			aux_2079 =
			   (((global_bglt) CREF(global_4))->import);
			test_2078 =
			   (aux_2079 == aux_2081);
		     }
		     if (test_2078)
		       {	/* Globalize/gloclo.scm 133 */
			  arg1640_1102 = _module__166_module_module;
		       }
		     else
		       {	/* Globalize/gloclo.scm 133 */
			  arg1640_1102 =
			     (((global_bglt) CREF(global_4))->module);
		       }
		  }
		  arg1641_1103 =
		     (((global_bglt) CREF(global_4))->import);
		  arg1642_1104 =
		     CNST_TABLE_REF(((long) 4));
		  arg1643_1105 =
		     CNST_TABLE_REF(((long) 5));
		  gloclo_1083 =
		     def_global_sfun_no_warning__10_ast_glo_def_117(arg1637_1099, arg1638_1100, arg1639_1101, arg1640_1102, arg1641_1103, arg1642_1104, arg1643_1105, BUNSPEC);
	       }
	       {	/* Globalize/gloclo.scm 130 */

		  {	/* Globalize/gloclo.scm 140 */
		     global_ginfo_75_bglt obj_1666;
		     obj_t val1554_1667;
		     obj_1666 =
			(global_ginfo_75_bglt) (global_4);
		     val1554_1667 =
			(obj_t) (gloclo_1083);
		     {
			obj_t aux_2091;
			{	/* ./Globalize/ginfo.scm 1509 */
			   object_bglt aux_2092;
			   aux_2092 =
			      (object_bglt) (obj_1666);
			   aux_2091 =
			      OBJECT_WIDENING(aux_2092);
			}
			((((global_ginfo_75_bglt) CREF(aux_2091))->global_closure_229) = ((obj_t) val1554_1667), BUNSPEC);
		     }
		  }
		  {	/* Globalize/gloclo.scm 143 */
		     bool_t test1622_1084;
		     {	/* ./Ast/var.scm 969 */
			obj_t aux_2096;
			{	/* Globalize/gloclo.scm 143 */
			   value_bglt aux_2097;
			   aux_2097 =
			      (((global_bglt) CREF(global_4))->value);
			   aux_2096 =
			      (obj_t) (aux_2097);
			}
			test1622_1084 =
			   is_a__118___object(aux_2096, sfun_ast_var);
		     }
		     if (test1622_1084)
		       {	/* Globalize/gloclo.scm 144 */
			  obj_t arg1624_1086;
			  {	/* Globalize/gloclo.scm 145 */
			     sfun_bglt obj_1672;
			     {	/* Globalize/gloclo.scm 145 */
				value_bglt aux_2102;
				aux_2102 =
				   (((global_bglt) CREF(global_4))->value);
				obj_1672 =
				   (sfun_bglt) (aux_2102);
			     }
			     arg1624_1086 =
				(((sfun_bglt) CREF(obj_1672))->loc);
			  }
			  {	/* Globalize/gloclo.scm 144 */
			     sfun_bglt obj_1673;
			     {	/* Globalize/gloclo.scm 144 */
				value_bglt aux_2106;
				aux_2106 =
				   (((global_bglt) CREF(gloclo_1083))->value);
				obj_1673 =
				   (sfun_bglt) (aux_2106);
			     }
			     ((((sfun_bglt) CREF(obj_1673))->loc) = ((obj_t) arg1624_1086), BUNSPEC);
			  }
		       }
		     else
		       {	/* Globalize/gloclo.scm 143 */
			  BUNSPEC;
		       }
		  }
		  {	/* Globalize/gloclo.scm 155 */
		     bool_t test_2110;
		     {	/* ./Ieee/equiv.scm 5508 */
			obj_t aux_2113;
			obj_t aux_2111;
			aux_2113 =
			   CNST_TABLE_REF(((long) 3));
			aux_2111 =
			   (((global_bglt) CREF(global_4))->import);
			test_2110 =
			   (aux_2111 == aux_2113);
		     }
		     if (test_2110)
		       {	/* Globalize/gloclo.scm 155 */
			  {	/* Globalize/gloclo.scm 157 */
			     obj_t obj2_1679;
			     obj2_1679 = _foreign_closures__211_globalize_global_closure_246;
			     {	/* ./Ieee/pair-list.scm 5689 */
				obj_t aux_2116;
				aux_2116 =
				   (obj_t) (gloclo_1083);
				_foreign_closures__211_globalize_global_closure_246 =
				   MAKE_PAIR(aux_2116, obj2_1679);
			     }
			  }
			  {	/* Globalize/gloclo.scm 158 */
			     obj_t val1056_1681;
			     val1056_1681 =
				CNST_TABLE_REF(((long) 6));
			     ((((global_bglt) CREF(gloclo_1083))->removable) = ((obj_t) val1056_1681), BUNSPEC);
			  }
			  {	/* Globalize/gloclo.scm 159 */
			     obj_t val1058_1683;
			     val1058_1683 =
				CNST_TABLE_REF(((long) 7));
			     ((((global_bglt) CREF(gloclo_1083))->import) = ((obj_t) val1058_1683), BUNSPEC);
			  }
		       }
		     else
		       {	/* Globalize/gloclo.scm 155 */
			  {	/* Globalize/gloclo.scm 161 */
			     bool_t test_2123;
			     {	/* ./Ieee/equiv.scm 5508 */
				obj_t aux_2126;
				obj_t aux_2124;
				aux_2126 =
				   CNST_TABLE_REF(((long) 7));
				aux_2124 =
				   (((global_bglt) CREF(global_4))->import);
				test_2123 =
				   (aux_2124 == aux_2126);
			     }
			     if (test_2123)
			       {	/* Globalize/gloclo.scm 161 */
				  BUNSPEC;
			       }
			     else
			       {	/* Globalize/gloclo.scm 162 */
				  obj_t val1056_1688;
				  val1056_1688 =
				     CNST_TABLE_REF(((long) 6));
				  ((((global_bglt) CREF(gloclo_1083))->removable) = ((obj_t) val1056_1688), BUNSPEC);
			       }
			  }
			  {	/* Globalize/gloclo.scm 163 */
			     obj_t val1058_1690;
			     val1058_1690 =
				CNST_TABLE_REF(((long) 7));
			     ((((global_bglt) CREF(gloclo_1083))->import) = ((obj_t) val1058_1690), BUNSPEC);
			  }
		       }
		  }
		  {	/* Globalize/gloclo.scm 164 */
		     obj_t arg1634_1096;
		     {	/* Globalize/gloclo.scm 165 */
			fun_bglt obj_1693;
			{	/* Globalize/gloclo.scm 165 */
			   value_bglt aux_2133;
			   aux_2133 =
			      (((global_bglt) CREF(global_4))->value);
			   obj_1693 =
			      (fun_bglt) (aux_2133);
			}
			arg1634_1096 =
			   (((fun_bglt) CREF(obj_1693))->side_effect__165);
		     }
		     {	/* Globalize/gloclo.scm 164 */
			fun_bglt obj_1694;
			{	/* Globalize/gloclo.scm 164 */
			   value_bglt aux_2137;
			   aux_2137 =
			      (((global_bglt) CREF(gloclo_1083))->value);
			   obj_1694 =
			      (fun_bglt) (aux_2137);
			}
			((((fun_bglt) CREF(obj_1694))->side_effect__165) = ((obj_t) arg1634_1096), BUNSPEC);
		     }
		  }
		  {	/* Globalize/gloclo.scm 166 */
		     bool_t test1636_1098;
		     test1636_1098 =
			is_a__118___object(
			(obj_t) (gloclo_1083), global_ast_var);
		     if (test1636_1098)
		       {	/* Globalize/gloclo.scm 166 */
			  return
			     (obj_t) (gloclo_1083);
		       }
		     else
		       {	/* Globalize/gloclo.scm 166 */
			  return
			     internal_error_43_tools_error(string1766_globalize_global_closure_246, string1767_globalize_global_closure_246,
			     (obj_t) (gloclo_1083));
		       }
		  }
	       }
	    }
	 }
      }
   }
}



/* method-init */
obj_t 
method_init_76_globalize_global_closure_246()
{
   AN_OBJECT;
   {	/* Globalize/gloclo.scm 14 */
      return BUNSPEC;
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_globalize_global_closure_246()
{
   AN_OBJECT;
   {	/* Globalize/gloclo.scm 14 */
      module_initialization_70_tools_trace(((long) 0), "GLOBALIZE_GLOBAL-CLOSURE");
      module_initialization_70_tools_shape(((long) 0), "GLOBALIZE_GLOBAL-CLOSURE");
      module_initialization_70_tools_args(((long) 0), "GLOBALIZE_GLOBAL-CLOSURE");
      module_initialization_70_tools_error(((long) 0), "GLOBALIZE_GLOBAL-CLOSURE");
      module_initialization_70_engine_param(((long) 0), "GLOBALIZE_GLOBAL-CLOSURE");
      module_initialization_70_type_type(((long) 0), "GLOBALIZE_GLOBAL-CLOSURE");
      module_initialization_70_type_cache(((long) 0), "GLOBALIZE_GLOBAL-CLOSURE");
      module_initialization_70_ast_var(((long) 0), "GLOBALIZE_GLOBAL-CLOSURE");
      module_initialization_70_ast_node(((long) 0), "GLOBALIZE_GLOBAL-CLOSURE");
      module_initialization_70_ast_sexp(((long) 0), "GLOBALIZE_GLOBAL-CLOSURE");
      module_initialization_70_ast_local(((long) 0), "GLOBALIZE_GLOBAL-CLOSURE");
      module_initialization_70_ast_glo_def_117(((long) 0), "GLOBALIZE_GLOBAL-CLOSURE");
      module_initialization_70_module_module(((long) 0), "GLOBALIZE_GLOBAL-CLOSURE");
      module_initialization_70_globalize_ginfo(((long) 0), "GLOBALIZE_GLOBAL-CLOSURE");
      module_initialization_70_globalize_node(((long) 0), "GLOBALIZE_GLOBAL-CLOSURE");
      return
	 module_initialization_70_globalize_free(((long) 0), "GLOBALIZE_GLOBAL-CLOSURE");
   }
}
