/*===========================================================================*/
/*   (Globalize/gn.scm)                                                      */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;

typedef struct sfun_ginfo_98
  {
     bool_t g__219;
     obj_t cfrom;
     obj_t cfrom__119;
     obj_t cto;
     obj_t cto__14;
     obj_t cfunction;
     obj_t integrator;
     obj_t integrated;
     obj_t plugged_in_15;
     long mark;
     obj_t free_mark_81;
     obj_t the_global_201;
     obj_t kaptured;
     obj_t new_body_215;
     long bmark;
     long umark;
     obj_t free;
     obj_t bound;
  }
             *sfun_ginfo_98_bglt;

typedef struct svar_ginfo_131
  {
     bool_t kaptured__204;
     long free_mark_81;
     long mark;
     bool_t celled__113;
  }
              *svar_ginfo_131_bglt;

typedef struct sexit_ginfo_81
  {
     bool_t g__219;
     bool_t kaptured__204;
     long free_mark_81;
     long mark;
  }
              *sexit_ginfo_81_bglt;

typedef struct local_ginfo_108
  {
     bool_t escape__117;
  }
               *local_ginfo_108_bglt;

typedef struct global_ginfo_75
  {
     bool_t escape__117;
     obj_t global_closure_229;
  }
               *global_ginfo_75_bglt;


extern obj_t _g1__181_globalize_globalize;
extern obj_t _g0__244_globalize_globalize;
extern obj_t _e__34_globalize_globalize;
static obj_t method_init_76_globalize_gn();
extern obj_t make_box_202_ast_node;
extern obj_t funcall_ast_node;
extern long add_inlined_method__244___object(obj_t, obj_t, long);
extern obj_t fail_ast_node;
extern obj_t box_ref_242_ast_node;
extern obj_t sequence_ast_node;
extern obj_t let_var_6_ast_node;
extern obj_t var_ast_node;
extern obj_t closure_ast_node;
extern obj_t global_ast_var;
extern obj_t pragma_ast_node;
extern obj_t set_ex_it_116_ast_node;
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t module_initialization_70_globalize_gn(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_globalize_ginfo(long, char *);
extern obj_t module_initialization_70_globalize_globalize(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
static obj_t e_default1571_218_globalize_gn(node_bglt, variable_bglt, obj_t);
extern obj_t let_fun_218_ast_node;
extern obj_t gn__33_globalize_gn(obj_t, node_bglt, variable_bglt, obj_t);
static obj_t imported_modules_init_94_globalize_gn();
static obj_t save_app__130_globalize_gn(variable_bglt, variable_bglt);
static obj_t save_fun__213_globalize_gn(variable_bglt, variable_bglt);
extern obj_t app_ly_162_ast_node;
extern obj_t add_generic__110___object(obj_t, obj_t);
static obj_t _gn__74_globalize_gn(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t app_ast_node;
extern obj_t append_2_18___r4_pairs_and_lists_6_3(obj_t, obj_t);
static obj_t library_modules_init_112_globalize_gn();
extern obj_t atom_ast_node;
extern obj_t cast_ast_node;
static obj_t toplevel_init_63_globalize_gn();
extern obj_t jump_ex_it_184_ast_node;
extern obj_t open_input_string(obj_t);
extern obj_t kwote_ast_node;
extern obj_t setq_ast_node;
extern obj_t box_set__221_ast_node;
extern obj_t local_ast_var;
static obj_t g_from_cto_7_globalize_gn(obj_t);
extern obj_t memq___r4_pairs_and_lists_6_3(obj_t, obj_t);
static obj_t _e_globalize_gn(obj_t, obj_t, obj_t, obj_t);
static obj_t e__176_globalize_gn(obj_t, variable_bglt, obj_t);
extern obj_t _classes__134___object;
extern obj_t select_ast_node;
extern obj_t read___reader(obj_t);
static obj_t _e_default1571_122_globalize_gn(obj_t, obj_t, obj_t, obj_t);
static obj_t require_initialization_114_globalize_gn = BUNSPEC;
extern obj_t conditional_ast_node;
static obj_t e_globalize_gn(node_bglt, variable_bglt, obj_t);
static obj_t cnst_init_137_globalize_gn();
static obj_t __cnst[2];

DEFINE_EXPORT_PROCEDURE(gn__env_63_globalize_gn, _gn__74_globalize_gn1827, _gn__74_globalize_gn, 0L, 4);
DEFINE_STATIC_PROCEDURE(e_default1571_env_12_globalize_gn, _e_default1571_122_globalize_gn1828, _e_default1571_122_globalize_gn, 0L, 3);
DEFINE_STRING(string1822_globalize_gn, string1822_globalize_gn1829, "E-DEFAULT1571 DONE ", 19);
DEFINE_STRING(string1821_globalize_gn, string1821_globalize_gn1830, "No method for this object", 25);
DEFINE_STATIC_GENERIC(e_env_17_globalize_gn, _e_globalize_gn1831, _e_globalize_gn, 0L, 3);



/* module-initialization */
obj_t 
module_initialization_70_globalize_gn(long checksum_1928, char *from_1929)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_globalize_gn))
	{
	   require_initialization_114_globalize_gn =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_globalize_gn();
	   cnst_init_137_globalize_gn();
	   imported_modules_init_94_globalize_gn();
	   method_init_76_globalize_gn();
	   toplevel_init_63_globalize_gn();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_globalize_gn()
{
   AN_OBJECT;
   {	/* Globalize/gn.scm 22 */
      module_initialization_70___object(((long) 0), "GLOBALIZE_GN");
      module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "GLOBALIZE_GN");
      module_initialization_70___reader(((long) 0), "GLOBALIZE_GN");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_globalize_gn()
{
   AN_OBJECT;
   {	/* Globalize/gn.scm 22 */
      {		/* Globalize/gn.scm 22 */
	 obj_t cnst_port_138_1921;
	 cnst_port_138_1921 =
	    open_input_string(string1822_globalize_gn);
	 {
	    long i_1922;
	    i_1922 = ((long) 1);
	  loop_1923:
	    {	/* Globalize/gn.scm 22 */
	       bool_t test1823_1924;
	       test1823_1924 =
		  (i_1922 == ((long) -1));
	       if (test1823_1924)
		 {	/* Globalize/gn.scm 22 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Globalize/gn.scm 22 */
		    {	/* Globalize/gn.scm 22 */
		       obj_t arg1824_1925;
		       {	/* Globalize/gn.scm 22 */
			  obj_t list1825_1926;
			  list1825_1926 =
			     MAKE_PAIR(cnst_port_138_1921, BNIL);
			  arg1824_1925 =
			     read___reader(list1825_1926);
		       }
		       CNST_TABLE_SET(i_1922, arg1824_1925);
		    }
		    {	/* Globalize/gn.scm 22 */
		       int aux_1927;
		       {	/* Globalize/gn.scm 22 */
			  long aux_1947;
			  aux_1947 =
			     (i_1922 - ((long) 1));
			  aux_1927 =
			     (int) (aux_1947);
		       }
		       {
			  long i_1950;
			  i_1950 =
			     (long) (aux_1927);
			  i_1922 = i_1950;
			  goto loop_1923;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_globalize_gn()
{
   AN_OBJECT;
   {	/* Globalize/gn.scm 22 */
      return BUNSPEC;
   }
}



/* gn! */
obj_t 
gn__33_globalize_gn(obj_t args_1, node_bglt node_2, variable_bglt caller_3, obj_t g_4)
{
   AN_OBJECT;
   {	/* Globalize/gn.scm 40 */
      _e__34_globalize_globalize =
	 e_globalize_gn(node_2, caller_3, g_4);
      {
	 obj_t g_1075;
	 obj_t g1_1076;
	 g_1075 = _e__34_globalize_globalize;
	 g1_1076 = BNIL;
       loop_1077:
	 if (
	    NULLP(g_1075))
	   {	/* Globalize/gn.scm 44 */
	      _g0__244_globalize_globalize =
		 append_2_18___r4_pairs_and_lists_6_3(_e__34_globalize_globalize, g1_1076);
	      return (
		 _g1__181_globalize_globalize = g1_1076, BUNSPEC);
	   }
	 else
	   {	/* Globalize/gn.scm 48 */
	      obj_t new_g_67_1079;
	      new_g_67_1079 =
		 g_from_cto_7_globalize_gn(
		 CAR(g_1075));
	      {
		 obj_t g1_1961;
		 obj_t g_1958;
		 g_1958 =
		    append_2_18___r4_pairs_and_lists_6_3(new_g_67_1079,
		    CDR(g_1075));
		 g1_1961 =
		    append_2_18___r4_pairs_and_lists_6_3(new_g_67_1079, g1_1076);
		 g1_1076 = g1_1961;
		 g_1075 = g_1958;
		 goto loop_1077;
	      }
	   }
      }
   }
}



/* _gn! */
obj_t 
_gn__74_globalize_gn(obj_t env_1908, obj_t args_1909, obj_t node_1910, obj_t caller_1911, obj_t g_1912)
{
   AN_OBJECT;
   {	/* Globalize/gn.scm 40 */
      return
	 gn__33_globalize_gn(args_1909,
	 (node_bglt) (node_1910),
	 (variable_bglt) (caller_1911), g_1912);
   }
}



/* e* */
obj_t 
e__176_globalize_gn(obj_t node__221_74, variable_bglt caller_75, obj_t g_76)
{
   AN_OBJECT;
   {	/* Globalize/gn.scm 228 */
      {
	 obj_t node__221_1084;
	 obj_t g_1085;
	 node__221_1084 = node__221_74;
	 g_1085 = g_76;
       loop_1086:
	 if (
	    NULLP(node__221_1084))
	   {	/* Globalize/gn.scm 231 */
	      return g_1085;
	   }
	 else
	   {	/* Globalize/gn.scm 233 */
	      obj_t arg1620_1088;
	      obj_t arg1621_1089;
	      arg1620_1088 =
		 CDR(node__221_1084);
	      {		/* Globalize/gn.scm 234 */
		 node_bglt aux_1969;
		 {	/* Globalize/gn.scm 234 */
		    obj_t aux_1970;
		    aux_1970 =
		       CAR(node__221_1084);
		    aux_1969 =
		       (node_bglt) (aux_1970);
		 }
		 arg1621_1089 =
		    e_globalize_gn(aux_1969, caller_75, g_1085);
	      }
	      {
		 obj_t g_1975;
		 obj_t node__221_1974;
		 node__221_1974 = arg1620_1088;
		 g_1975 = arg1621_1089;
		 g_1085 = g_1975;
		 node__221_1084 = node__221_1974;
		 goto loop_1086;
	      }
	   }
      }
   }
}



/* save-app! */
obj_t 
save_app__130_globalize_gn(variable_bglt caller_77, variable_bglt callee_78)
{
   AN_OBJECT;
   {	/* Globalize/gn.scm 239 */
      {		/* Globalize/gn.scm 240 */
	 bool_t test1623_1091;
	 test1623_1091 =
	    is_a__118___object(
	    (obj_t) (callee_78), global_ast_var);
	 if (test1623_1091)
	   {	/* Globalize/gn.scm 240 */
	      return
		 CNST_TABLE_REF(((long) 0));
	   }
	 else
	   {	/* Globalize/gn.scm 242 */
	      value_bglt callee_info_105_1092;
	      {		/* Globalize/gn.scm 242 */
		 local_bglt obj_1691;
		 obj_1691 =
		    (local_bglt) (callee_78);
		 callee_info_105_1092 =
		    (((local_bglt) CREF(obj_1691))->value);
	      }
	      {		/* Globalize/gn.scm 243 */
		 bool_t test_1982;
		 {	/* Globalize/gn.scm 243 */
		    obj_t aux_1983;
		    {	/* Globalize/gn.scm 243 */
		       obj_t aux_1984;
		       {	/* Globalize/gn.scm 243 */
			  sfun_ginfo_98_bglt obj_1692;
			  obj_1692 =
			     (sfun_ginfo_98_bglt) (callee_info_105_1092);
			  {
			     obj_t aux_1987;
			     {	/* ./Globalize/ginfo.scm 1018 */
				object_bglt aux_1988;
				aux_1988 =
				   (object_bglt) (obj_1692);
				aux_1987 =
				   OBJECT_WIDENING(aux_1988);
			     }
			     aux_1984 =
				(((sfun_ginfo_98_bglt) CREF(aux_1987))->cfrom);
			  }
		       }
		       aux_1983 =
			  memq___r4_pairs_and_lists_6_3(
			  (obj_t) (caller_77), aux_1984);
		    }
		    test_1982 =
		       CBOOL(aux_1983);
		 }
		 if (test_1982)
		   {	/* Globalize/gn.scm 243 */
		      BUNSPEC;
		   }
		 else
		   {	/* Globalize/gn.scm 243 */
		      {		/* Globalize/gn.scm 247 */
			 obj_t arg1625_1094;
			 {	/* ./Ieee/pair-list.scm 5689 */
			    obj_t aux_1996;
			    obj_t aux_1994;
			    {	/* Globalize/gn.scm 247 */
			       sfun_ginfo_98_bglt obj_1693;
			       obj_1693 =
				  (sfun_ginfo_98_bglt) (callee_info_105_1092);
			       {
				  obj_t aux_1998;
				  {	/* ./Globalize/ginfo.scm 1018 */
				     object_bglt aux_1999;
				     aux_1999 =
					(object_bglt) (obj_1693);
				     aux_1998 =
					OBJECT_WIDENING(aux_1999);
				  }
				  aux_1996 =
				     (((sfun_ginfo_98_bglt) CREF(aux_1998))->cfrom);
			       }
			    }
			    aux_1994 =
			       (obj_t) (caller_77);
			    arg1625_1094 =
			       MAKE_PAIR(aux_1994, aux_1996);
			 }
			 {	/* Globalize/gn.scm 245 */
			    sfun_ginfo_98_bglt obj_1696;
			    obj_1696 =
			       (sfun_ginfo_98_bglt) (callee_info_105_1092);
			    {
			       obj_t aux_2005;
			       {	/* ./Globalize/ginfo.scm 1018 */
				  object_bglt aux_2006;
				  aux_2006 =
				     (object_bglt) (obj_1696);
				  aux_2005 =
				     OBJECT_WIDENING(aux_2006);
			       }
			       ((((sfun_ginfo_98_bglt) CREF(aux_2005))->cfrom) = ((obj_t) arg1625_1094), BUNSPEC);
			    }
			 }
		      }
		      {		/* Globalize/gn.scm 248 */
			 bool_t test1627_1096;
			 test1627_1096 =
			    is_a__118___object(
			    (obj_t) (caller_77), local_ast_var);
			 if (test1627_1096)
			   {	/* Globalize/gn.scm 249 */
			      value_bglt caller_info_12_1097;
			      {		/* Globalize/gn.scm 249 */
				 local_bglt obj_1699;
				 obj_1699 =
				    (local_bglt) (caller_77);
				 caller_info_12_1097 =
				    (((local_bglt) CREF(obj_1699))->value);
			      }
			      {		/* Globalize/gn.scm 252 */
				 obj_t arg1628_1098;
				 {	/* ./Ieee/pair-list.scm 5689 */
				    obj_t aux_2017;
				    obj_t aux_2015;
				    {	/* Globalize/gn.scm 252 */
				       sfun_ginfo_98_bglt obj_1700;
				       obj_1700 =
					  (sfun_ginfo_98_bglt) (caller_info_12_1097);
				       {
					  obj_t aux_2019;
					  {	/* ./Globalize/ginfo.scm 1022 */
					     object_bglt aux_2020;
					     aux_2020 =
						(object_bglt) (obj_1700);
					     aux_2019 =
						OBJECT_WIDENING(aux_2020);
					  }
					  aux_2017 =
					     (((sfun_ginfo_98_bglt) CREF(aux_2019))->cto);
				       }
				    }
				    aux_2015 =
				       (obj_t) (callee_78);
				    arg1628_1098 =
				       MAKE_PAIR(aux_2015, aux_2017);
				 }
				 {	/* Globalize/gn.scm 250 */
				    sfun_ginfo_98_bglt obj_1703;
				    obj_1703 =
				       (sfun_ginfo_98_bglt) (caller_info_12_1097);
				    {
				       obj_t aux_2026;
				       {	/* ./Globalize/ginfo.scm 1022 */
					  object_bglt aux_2027;
					  aux_2027 =
					     (object_bglt) (obj_1703);
					  aux_2026 =
					     OBJECT_WIDENING(aux_2027);
				       }
				       ((((sfun_ginfo_98_bglt) CREF(aux_2026))->cto) = ((obj_t) arg1628_1098), BUNSPEC);
				    }
				 }
			      }
			   }
			 else
			   {	/* Globalize/gn.scm 248 */
			      BUNSPEC;
			   }
		      }
		   }
	      }
	      return
		 CNST_TABLE_REF(((long) 0));
	   }
      }
   }
}



/* save-fun! */
obj_t 
save_fun__213_globalize_gn(variable_bglt caller_79, variable_bglt callee_80)
{
   AN_OBJECT;
   {	/* Globalize/gn.scm 259 */
      {		/* Globalize/gn.scm 260 */
	 bool_t test1631_1101;
	 {	/* Globalize/gn.scm 260 */
	    bool_t test1636_1107;
	    test1636_1107 =
	       is_a__118___object(
	       (obj_t) (caller_79), global_ast_var);
	    if (test1636_1107)
	      {		/* Globalize/gn.scm 260 */
		 test1631_1101 = ((bool_t) 1);
	      }
	    else
	      {		/* Globalize/gn.scm 260 */
		 test1631_1101 =
		    is_a__118___object(
		    (obj_t) (callee_80), global_ast_var);
	      }
	 }
	 if (test1631_1101)
	   {	/* Globalize/gn.scm 260 */
	      return
		 CNST_TABLE_REF(((long) 0));
	   }
	 else
	   {	/* Globalize/gn.scm 262 */
	      value_bglt caller_info_12_1102;
	      {		/* Globalize/gn.scm 262 */
		 local_bglt obj_1707;
		 obj_1707 =
		    (local_bglt) (caller_79);
		 caller_info_12_1102 =
		    (((local_bglt) CREF(obj_1707))->value);
	      }
	      {		/* Globalize/gn.scm 266 */
		 bool_t test_2041;
		 {	/* Globalize/gn.scm 266 */
		    obj_t aux_2042;
		    {	/* Globalize/gn.scm 266 */
		       obj_t aux_2043;
		       {	/* Globalize/gn.scm 266 */
			  sfun_ginfo_98_bglt obj_1708;
			  obj_1708 =
			     (sfun_ginfo_98_bglt) (caller_info_12_1102);
			  {
			     obj_t aux_2046;
			     {	/* ./Globalize/ginfo.scm 1026 */
				object_bglt aux_2047;
				aux_2047 =
				   (object_bglt) (obj_1708);
				aux_2046 =
				   OBJECT_WIDENING(aux_2047);
			     }
			     aux_2043 =
				(((sfun_ginfo_98_bglt) CREF(aux_2046))->cfunction);
			  }
		       }
		       aux_2042 =
			  memq___r4_pairs_and_lists_6_3(
			  (obj_t) (callee_80), aux_2043);
		    }
		    test_2041 =
		       CBOOL(aux_2042);
		 }
		 if (test_2041)
		   {	/* Globalize/gn.scm 266 */
		      BUNSPEC;
		   }
		 else
		   {	/* Globalize/gn.scm 269 */
		      obj_t arg1633_1104;
		      {		/* ./Ieee/pair-list.scm 5689 */
			 obj_t aux_2055;
			 obj_t aux_2053;
			 {	/* Globalize/gn.scm 269 */
			    sfun_ginfo_98_bglt obj_1709;
			    obj_1709 =
			       (sfun_ginfo_98_bglt) (caller_info_12_1102);
			    {
			       obj_t aux_2057;
			       {	/* ./Globalize/ginfo.scm 1026 */
				  object_bglt aux_2058;
				  aux_2058 =
				     (object_bglt) (obj_1709);
				  aux_2057 =
				     OBJECT_WIDENING(aux_2058);
			       }
			       aux_2055 =
				  (((sfun_ginfo_98_bglt) CREF(aux_2057))->cfunction);
			    }
			 }
			 aux_2053 =
			    (obj_t) (callee_80);
			 arg1633_1104 =
			    MAKE_PAIR(aux_2053, aux_2055);
		      }
		      {		/* Globalize/gn.scm 267 */
			 sfun_ginfo_98_bglt obj_1712;
			 obj_1712 =
			    (sfun_ginfo_98_bglt) (caller_info_12_1102);
			 {
			    obj_t aux_2064;
			    {	/* ./Globalize/ginfo.scm 1026 */
			       object_bglt aux_2065;
			       aux_2065 =
				  (object_bglt) (obj_1712);
			       aux_2064 =
				  OBJECT_WIDENING(aux_2065);
			    }
			    ((((sfun_ginfo_98_bglt) CREF(aux_2064))->cfunction) = ((obj_t) arg1633_1104), BUNSPEC);
			 }
		      }
		   }
	      }
	      return
		 CNST_TABLE_REF(((long) 0));
	   }
      }
   }
}



/* g-from-cto */
obj_t 
g_from_cto_7_globalize_gn(obj_t local_81)
{
   AN_OBJECT;
   {	/* Globalize/gn.scm 276 */
      {
	 obj_t cto_1108;
	 obj_t g_1109;
	 {	/* Globalize/gn.scm 277 */
	    sfun_ginfo_98_bglt obj_1715;
	    {	/* Globalize/gn.scm 277 */
	       value_bglt aux_2103;
	       {	/* Globalize/gn.scm 277 */
		  local_bglt obj_1714;
		  obj_1714 =
		     (local_bglt) (local_81);
		  aux_2103 =
		     (((local_bglt) CREF(obj_1714))->value);
	       }
	       obj_1715 =
		  (sfun_ginfo_98_bglt) (aux_2103);
	    }
	    {
	       obj_t aux_2107;
	       {	/* ./Globalize/ginfo.scm 1022 */
		  object_bglt aux_2108;
		  aux_2108 =
		     (object_bglt) (obj_1715);
		  aux_2107 =
		     OBJECT_WIDENING(aux_2108);
	       }
	       cto_1108 =
		  (((sfun_ginfo_98_bglt) CREF(aux_2107))->cto);
	    }
	 }
	 g_1109 = BNIL;
       loop_1110:
	 if (
	    NULLP(cto_1108))
	   {	/* Globalize/gn.scm 280 */
	      return g_1109;
	   }
	 else
	   {	/* Globalize/gn.scm 282 */
	      bool_t test_2072;
	      {		/* Globalize/gn.scm 282 */
		 sfun_ginfo_98_bglt obj_1719;
		 {	/* Globalize/gn.scm 282 */
		    value_bglt aux_2073;
		    {	/* Globalize/gn.scm 282 */
		       local_bglt obj_1718;
		       {	/* Globalize/gn.scm 282 */
			  obj_t aux_2074;
			  aux_2074 =
			     CAR(cto_1108);
			  obj_1718 =
			     (local_bglt) (aux_2074);
		       }
		       aux_2073 =
			  (((local_bglt) CREF(obj_1718))->value);
		    }
		    obj_1719 =
		       (sfun_ginfo_98_bglt) (aux_2073);
		 }
		 {
		    obj_t aux_2079;
		    {	/* ./Globalize/ginfo.scm 1016 */
		       object_bglt aux_2080;
		       aux_2080 =
			  (object_bglt) (obj_1719);
		       aux_2079 =
			  OBJECT_WIDENING(aux_2080);
		    }
		    test_2072 =
		       (((sfun_ginfo_98_bglt) CREF(aux_2079))->g__219);
		 }
	      }
	      if (test_2072)
		{	/* Globalize/gn.scm 282 */
		   {
		      obj_t cto_2084;
		      cto_2084 =
			 CDR(cto_1108);
		      cto_1108 = cto_2084;
		      goto loop_1110;
		   }
		}
	      else
		{	/* Globalize/gn.scm 282 */
		   {	/* Globalize/gn.scm 285 */
		      sfun_ginfo_98_bglt obj_1723;
		      {		/* Globalize/gn.scm 285 */
			 value_bglt aux_2086;
			 {	/* Globalize/gn.scm 285 */
			    local_bglt obj_1722;
			    {	/* Globalize/gn.scm 285 */
			       obj_t aux_2087;
			       aux_2087 =
				  CAR(cto_1108);
			       obj_1722 =
				  (local_bglt) (aux_2087);
			    }
			    aux_2086 =
			       (((local_bglt) CREF(obj_1722))->value);
			 }
			 obj_1723 =
			    (sfun_ginfo_98_bglt) (aux_2086);
		      }
		      {
			 obj_t aux_2092;
			 {	/* ./Globalize/ginfo.scm 1016 */
			    object_bglt aux_2093;
			    aux_2093 =
			       (object_bglt) (obj_1723);
			    aux_2092 =
			       OBJECT_WIDENING(aux_2093);
			 }
			 ((((sfun_ginfo_98_bglt) CREF(aux_2092))->g__219) = ((bool_t) ((bool_t) 1)), BUNSPEC);
		      }
		   }
		   {	/* Globalize/gn.scm 286 */
		      obj_t arg1646_1119;
		      obj_t arg1647_1120;
		      arg1646_1119 =
			 CDR(cto_1108);
		      {		/* ./Ieee/pair-list.scm 5689 */
			 obj_t aux_2098;
			 aux_2098 =
			    CAR(cto_1108);
			 arg1647_1120 =
			    MAKE_PAIR(aux_2098, g_1109);
		      }
		      {
			 obj_t g_2102;
			 obj_t cto_2101;
			 cto_2101 = arg1646_1119;
			 g_2102 = arg1647_1120;
			 g_1109 = g_2102;
			 cto_1108 = cto_2101;
			 goto loop_1110;
		      }
		   }
		}
	   }
      }
   }
}



/* method-init */
obj_t 
method_init_76_globalize_gn()
{
   AN_OBJECT;
   {	/* Globalize/gn.scm 22 */
      add_generic__110___object(e_env_17_globalize_gn, e_default1571_env_12_globalize_gn);
      add_inlined_method__244___object(e_env_17_globalize_gn, atom_ast_node, ((long) 0));
      add_inlined_method__244___object(e_env_17_globalize_gn, kwote_ast_node, ((long) 1));
      add_inlined_method__244___object(e_env_17_globalize_gn, var_ast_node, ((long) 2));
      add_inlined_method__244___object(e_env_17_globalize_gn, closure_ast_node, ((long) 3));
      add_inlined_method__244___object(e_env_17_globalize_gn, sequence_ast_node, ((long) 4));
      add_inlined_method__244___object(e_env_17_globalize_gn, app_ast_node, ((long) 5));
      add_inlined_method__244___object(e_env_17_globalize_gn, app_ly_162_ast_node, ((long) 6));
      add_inlined_method__244___object(e_env_17_globalize_gn, funcall_ast_node, ((long) 7));
      add_inlined_method__244___object(e_env_17_globalize_gn, pragma_ast_node, ((long) 8));
      add_inlined_method__244___object(e_env_17_globalize_gn, cast_ast_node, ((long) 9));
      add_inlined_method__244___object(e_env_17_globalize_gn, setq_ast_node, ((long) 10));
      add_inlined_method__244___object(e_env_17_globalize_gn, conditional_ast_node, ((long) 11));
      add_inlined_method__244___object(e_env_17_globalize_gn, fail_ast_node, ((long) 12));
      add_inlined_method__244___object(e_env_17_globalize_gn, select_ast_node, ((long) 13));
      add_inlined_method__244___object(e_env_17_globalize_gn, let_fun_218_ast_node, ((long) 14));
      add_inlined_method__244___object(e_env_17_globalize_gn, let_var_6_ast_node, ((long) 15));
      add_inlined_method__244___object(e_env_17_globalize_gn, set_ex_it_116_ast_node, ((long) 16));
      add_inlined_method__244___object(e_env_17_globalize_gn, jump_ex_it_184_ast_node, ((long) 17));
      add_inlined_method__244___object(e_env_17_globalize_gn, make_box_202_ast_node, ((long) 18));
      add_inlined_method__244___object(e_env_17_globalize_gn, box_ref_242_ast_node, ((long) 19));
      {		/* Globalize/gn.scm 22 */
	 long aux_2133;
	 aux_2133 =
	    add_inlined_method__244___object(e_env_17_globalize_gn, box_set__221_ast_node, ((long) 20));
	 return
	    BINT(aux_2133);
      }
   }
}



/* e */
obj_t 
e_globalize_gn(node_bglt node_5, variable_bglt caller_6, obj_t g_7)
{
   AN_OBJECT;
   {	/* Globalize/gn.scm 55 */
    e_globalize_gn:
      {
	 obj_t method1740_1518;
	 obj_t class1745_1519;
	 {	/* Globalize/gn.scm 55 */
	    obj_t arg1748_1516;
	    obj_t arg1749_1517;
	    {	/* Globalize/gn.scm 55 */
	       object_bglt obj_1823;
	       obj_1823 =
		  (object_bglt) (node_5);
	       {	/* ./Llib/object.scm 2926 */
		  obj_t pre_method_105_1824;
		  pre_method_105_1824 =
		     PROCEDURE_REF(e_env_17_globalize_gn, ((long) 2));
		  if (
		     INTEGERP(pre_method_105_1824))
		    {	/* ./Llib/object.scm 2927 */
		       PROCEDURE_SET(e_env_17_globalize_gn, ((long) 2), BUNSPEC);
		       arg1748_1516 = pre_method_105_1824;
		    }
		  else
		    {	/* ./Llib/object.scm 2914 */
		       long obj_class_num_177_1829;
		       obj_class_num_177_1829 =
			  TYPE(obj_1823);
		       {	/* ./Llib/object.scm 2915 */
			  obj_t arg1176_1830;
			  arg1176_1830 =
			     PROCEDURE_REF(e_env_17_globalize_gn, ((long) 1));
			  {	/* ./Llib/object.scm 2738 */
			     long arg1177_1834;
			     {	/* ./Llib/object.scm 2738 */
				long arg1178_1835;
				arg1178_1835 =
				   OBJECT_TYPE;
				arg1177_1834 =
				   (obj_class_num_177_1829 - arg1178_1835);
			     }
			     arg1748_1516 =
				VECTOR_REF(arg1176_1830, arg1177_1834);
			  }
		       }
		    }
	       }
	    }
	    {	/* Globalize/gn.scm 55 */
	       object_bglt object_1840;
	       object_1840 =
		  (object_bglt) (node_5);
	       {	/* ./Llib/object.scm 2695 */
		  long arg1179_1841;
		  {	/* ./Llib/object.scm 2695 */
		     long arg1180_1842;
		     long arg1181_1843;
		     arg1180_1842 =
			TYPE(object_1840);
		     arg1181_1843 =
			OBJECT_TYPE;
		     arg1179_1841 =
			(arg1180_1842 - arg1181_1843);
		  }
		  {	/* ./Llib/object.scm 2695 */
		     obj_t vector_1847;
		     vector_1847 = _classes__134___object;
		     arg1749_1517 =
			VECTOR_REF(vector_1847, arg1179_1841);
		  }
	       }
	    }
	    method1740_1518 = arg1748_1516;
	    class1745_1519 = arg1749_1517;
	    {

	       if (
		  INTEGERP(method1740_1518))
		 {	/* Globalize/gn.scm 55 */
		    switch (
		       (long) CINT(method1740_1518))
		      {
		      case ((long) 0):

			 return g_7;
			 break;
		      case ((long) 1):

			 return g_7;
			 break;
		      case ((long) 2):

			 return g_7;
			 break;
		      case ((long) 3):

			 {	/* Globalize/gn.scm 79 */
			    variable_bglt var_1537;
			    {	/* Globalize/gn.scm 79 */
			       var_bglt obj_1849;
			       {	/* Globalize/gn.scm 79 */
				  closure_bglt aux_2153;
				  aux_2153 =
				     (closure_bglt) (node_5);
				  obj_1849 =
				     (var_bglt) (aux_2153);
			       }
			       var_1537 =
				  (((var_bglt) CREF(obj_1849))->variable);
			    }
			    save_fun__213_globalize_gn(caller_6, var_1537);
			    {	/* Globalize/gn.scm 81 */
			       bool_t test1752_1538;
			       {	/* Globalize/gn.scm 81 */
				  bool_t test1754_1540;
				  test1754_1540 =
				     is_a__118___object(
				     (obj_t) (var_1537), local_ast_var);
				  if (test1754_1540)
				    {	/* Globalize/gn.scm 83 */
				       bool_t test_2161;
				       {	/* Globalize/gn.scm 83 */
					  local_ginfo_108_bglt obj_1851;
					  obj_1851 =
					     (local_ginfo_108_bglt) (var_1537);
					  {
					     obj_t aux_2163;
					     {	/* ./Globalize/ginfo.scm 1074 */
						object_bglt aux_2164;
						aux_2164 =
						   (object_bglt) (obj_1851);
						aux_2163 =
						   OBJECT_WIDENING(aux_2164);
					     }
					     test_2161 =
						(((local_ginfo_108_bglt) CREF(aux_2163))->escape__117);
					  }
				       }
				       if (test_2161)
					 {	/* Globalize/gn.scm 84 */
					    bool_t test_2168;
					    {	/* Globalize/gn.scm 84 */
					       sfun_ginfo_98_bglt obj_1853;
					       {	/* Globalize/gn.scm 84 */
						  value_bglt aux_2169;
						  {	/* Globalize/gn.scm 84 */
						     local_bglt obj_1852;
						     obj_1852 =
							(local_bglt) (var_1537);
						     aux_2169 =
							(((local_bglt) CREF(obj_1852))->value);
						  }
						  obj_1853 =
						     (sfun_ginfo_98_bglt) (aux_2169);
					       }
					       {
						  obj_t aux_2173;
						  {	/* ./Globalize/ginfo.scm 1016 */
						     object_bglt aux_2174;
						     aux_2174 =
							(object_bglt) (obj_1853);
						     aux_2173 =
							OBJECT_WIDENING(aux_2174);
						  }
						  test_2168 =
						     (((sfun_ginfo_98_bglt) CREF(aux_2173))->g__219);
					       }
					    }
					    if (test_2168)
					      {		/* Globalize/gn.scm 84 */
						 test1752_1538 = ((bool_t) 0);
					      }
					    else
					      {		/* Globalize/gn.scm 84 */
						 test1752_1538 = ((bool_t) 1);
					      }
					 }
				       else
					 {	/* Globalize/gn.scm 83 */
					    test1752_1538 = ((bool_t) 0);
					 }
				    }
				  else
				    {	/* Globalize/gn.scm 81 */
				       test1752_1538 = ((bool_t) 0);
				    }
			       }
			       if (test1752_1538)
				 {	/* Globalize/gn.scm 81 */
				    {	/* Globalize/gn.scm 86 */
				       sfun_ginfo_98_bglt obj_1855;
				       {	/* Globalize/gn.scm 86 */
					  value_bglt aux_2179;
					  {	/* Globalize/gn.scm 86 */
					     local_bglt obj_1854;
					     obj_1854 =
						(local_bglt) (var_1537);
					     aux_2179 =
						(((local_bglt) CREF(obj_1854))->value);
					  }
					  obj_1855 =
					     (sfun_ginfo_98_bglt) (aux_2179);
				       }
				       {
					  obj_t aux_2183;
					  {	/* ./Globalize/ginfo.scm 1016 */
					     object_bglt aux_2184;
					     aux_2184 =
						(object_bglt) (obj_1855);
					     aux_2183 =
						OBJECT_WIDENING(aux_2184);
					  }
					  ((((sfun_ginfo_98_bglt) CREF(aux_2183))->g__219) = ((bool_t) ((bool_t) 1)), BUNSPEC);
				       }
				    }
				    {	/* ./Ieee/pair-list.scm 5689 */
				       obj_t aux_2188;
				       aux_2188 =
					  (obj_t) (var_1537);
				       return
					  MAKE_PAIR(aux_2188, g_7);
				    }
				 }
			       else
				 {	/* Globalize/gn.scm 81 */
				    return g_7;
				 }
			    }
			 }
			 break;
		      case ((long) 4):

			 {	/* Globalize/gn.scm 94 */
			    sequence_bglt node_1544;
			    node_1544 =
			       (sequence_bglt) (node_5);
			    return
			       e__176_globalize_gn(
			       (((sequence_bglt) CREF(node_1544))->nodes), caller_6, g_7);
			 }
			 break;
		      case ((long) 5):

			 {	/* Globalize/gn.scm 100 */
			    app_bglt node_1548;
			    node_1548 =
			       (app_bglt) (node_5);
			    {	/* Globalize/gn.scm 101 */
			       variable_bglt aux_2195;
			       {	/* Globalize/gn.scm 101 */
				  var_bglt arg1761_1553;
				  arg1761_1553 =
				     (((app_bglt) CREF(node_1548))->fun);
				  aux_2195 =
				     (((var_bglt) CREF(arg1761_1553))->variable);
			       }
			       save_app__130_globalize_gn(caller_6, aux_2195);
			    }
			    return
			       e__176_globalize_gn(
			       (((app_bglt) CREF(node_1548))->args), caller_6, g_7);
			 }
			 break;
		      case ((long) 6):

			 {	/* Globalize/gn.scm 108 */
			    app_ly_162_bglt node_1555;
			    node_1555 =
			       (app_ly_162_bglt) (node_5);
			    {	/* Globalize/gn.scm 109 */
			       node_bglt arg1763_1559;
			       obj_t arg1764_1560;
			       arg1763_1559 =
				  (((app_ly_162_bglt) CREF(node_1555))->fun);
			       arg1764_1560 =
				  e_globalize_gn(
				  (((app_ly_162_bglt) CREF(node_1555))->arg), caller_6, g_7);
			       {
				  obj_t g_2206;
				  node_bglt node_2205;
				  node_2205 = arg1763_1559;
				  g_2206 = arg1764_1560;
				  g_7 = g_2206;
				  node_5 = node_2205;
				  goto e_globalize_gn;
			       }
			    }
			 }
			 break;
		      case ((long) 7):

			 {	/* Globalize/gn.scm 115 */
			    funcall_bglt node_1562;
			    node_1562 =
			       (funcall_bglt) (node_5);
			    {	/* Globalize/gn.scm 116 */
			       node_bglt arg1766_1566;
			       obj_t arg1767_1567;
			       arg1766_1566 =
				  (((funcall_bglt) CREF(node_1562))->fun);
			       arg1767_1567 =
				  e__176_globalize_gn(
				  (((funcall_bglt) CREF(node_1562))->args), caller_6, g_7);
			       {
				  obj_t g_2212;
				  node_bglt node_2211;
				  node_2211 = arg1766_1566;
				  g_2212 = arg1767_1567;
				  g_7 = g_2212;
				  node_5 = node_2211;
				  goto e_globalize_gn;
			       }
			    }
			 }
			 break;
		      case ((long) 8):

			 {	/* Globalize/gn.scm 122 */
			    pragma_bglt node_1569;
			    node_1569 =
			       (pragma_bglt) (node_5);
			    return
			       e__176_globalize_gn(
			       (((pragma_bglt) CREF(node_1569))->args), caller_6, g_7);
			 }
			 break;
		      case ((long) 9):

			 {	/* Globalize/gn.scm 129 */
			    cast_bglt node_1574;
			    node_1574 =
			       (cast_bglt) (node_5);
			    {
			       node_bglt node_2217;
			       node_2217 =
				  (((cast_bglt) CREF(node_1574))->arg);
			       node_5 = node_2217;
			       goto e_globalize_gn;
			    }
			 }
			 break;
		      case ((long) 10):

			 {	/* Globalize/gn.scm 136 */
			    setq_bglt node_1579;
			    node_1579 =
			       (setq_bglt) (node_5);
			    {
			       node_bglt node_2220;
			       node_2220 =
				  (((setq_bglt) CREF(node_1579))->value);
			       node_5 = node_2220;
			       goto e_globalize_gn;
			    }
			 }
			 break;
		      case ((long) 11):

			 {	/* Globalize/gn.scm 143 */
			    conditional_bglt node_1584;
			    node_1584 =
			       (conditional_bglt) (node_5);
			    {	/* Globalize/gn.scm 144 */
			       node_bglt arg1772_1588;
			       obj_t arg1773_1589;
			       arg1772_1588 =
				  (((conditional_bglt) CREF(node_1584))->test);
			       {	/* Globalize/gn.scm 144 */
				  node_bglt arg1774_1590;
				  obj_t arg1775_1591;
				  arg1774_1590 =
				     (((conditional_bglt) CREF(node_1584))->true);
				  arg1775_1591 =
				     e_globalize_gn(
				     (((conditional_bglt) CREF(node_1584))->false), caller_6, g_7);
				  arg1773_1589 =
				     e_globalize_gn(arg1774_1590, caller_6, arg1775_1591);
			       }
			       {
				  obj_t g_2229;
				  node_bglt node_2228;
				  node_2228 = arg1772_1588;
				  g_2229 = arg1773_1589;
				  g_7 = g_2229;
				  node_5 = node_2228;
				  goto e_globalize_gn;
			       }
			    }
			 }
			 break;
		      case ((long) 12):

			 {	/* Globalize/gn.scm 150 */
			    fail_bglt node_1593;
			    node_1593 =
			       (fail_bglt) (node_5);
			    {	/* Globalize/gn.scm 151 */
			       node_bglt arg1777_1597;
			       obj_t arg1778_1598;
			       arg1777_1597 =
				  (((fail_bglt) CREF(node_1593))->proc);
			       {	/* Globalize/gn.scm 151 */
				  node_bglt arg1779_1599;
				  obj_t arg1780_1600;
				  arg1779_1599 =
				     (((fail_bglt) CREF(node_1593))->msg);
				  arg1780_1600 =
				     e_globalize_gn(
				     (((fail_bglt) CREF(node_1593))->obj), caller_6, g_7);
				  arg1778_1598 =
				     e_globalize_gn(arg1779_1599, caller_6, arg1780_1600);
			       }
			       {
				  obj_t g_2237;
				  node_bglt node_2236;
				  node_2236 = arg1777_1597;
				  g_2237 = arg1778_1598;
				  g_7 = g_2237;
				  node_5 = node_2236;
				  goto e_globalize_gn;
			       }
			    }
			 }
			 break;
		      case ((long) 13):

			 {	/* Globalize/gn.scm 157 */
			    select_bglt node_1602;
			    node_1602 =
			       (select_bglt) (node_5);
			    {
			       obj_t clauses_1606;
			       obj_t g_1607;
			       clauses_1606 =
				  (((select_bglt) CREF(node_1602))->clauses);
			       g_1607 = g_7;
			     loop_1608:
			       if (
				  NULLP(clauses_1606))
				 {
				    obj_t g_2243;
				    node_bglt node_2241;
				    node_2241 =
				       (((select_bglt) CREF(node_1602))->test);
				    g_2243 = g_1607;
				    g_7 = g_2243;
				    node_5 = node_2241;
				    goto e_globalize_gn;
				 }
			       else
				 {	/* Globalize/gn.scm 162 */
				    obj_t arg1785_1612;
				    obj_t arg1786_1613;
				    arg1785_1612 =
				       CDR(clauses_1606);
				    {	/* Globalize/gn.scm 162 */
				       node_bglt aux_2245;
				       {	/* Globalize/gn.scm 162 */
					  obj_t aux_2246;
					  {	/* ./Ieee/pair-list.scm 5707 */
					     obj_t aux_2247;
					     aux_2247 =
						CAR(clauses_1606);
					     aux_2246 =
						CDR(aux_2247);
					  }
					  aux_2245 =
					     (node_bglt) (aux_2246);
				       }
				       arg1786_1613 =
					  e_globalize_gn(aux_2245, caller_6, g_1607);
				    }
				    {
				       obj_t g_2253;
				       obj_t clauses_2252;
				       clauses_2252 = arg1785_1612;
				       g_2253 = arg1786_1613;
				       g_1607 = g_2253;
				       clauses_1606 = clauses_2252;
				       goto loop_1608;
				    }
				 }
			    }
			 }
			 break;
		      case ((long) 14):

			 {	/* Globalize/gn.scm 168 */
			    let_fun_218_bglt node_1616;
			    node_1616 =
			       (let_fun_218_bglt) (node_5);
			    {
			       obj_t locals_1620;
			       obj_t g_1621;
			       locals_1620 =
				  (((let_fun_218_bglt) CREF(node_1616))->locals);
			       g_1621 = g_7;
			     loop_1622:
			       if (
				  NULLP(locals_1620))
				 {
				    obj_t g_2260;
				    node_bglt node_2258;
				    node_2258 =
				       (((let_fun_218_bglt) CREF(node_1616))->body);
				    g_2260 = g_1621;
				    g_7 = g_2260;
				    node_5 = node_2258;
				    goto e_globalize_gn;
				 }
			       else
				 {	/* Globalize/gn.scm 173 */
				    obj_t arg1792_1626;
				    obj_t arg1793_1627;
				    arg1792_1626 =
				       CDR(locals_1620);
				    {	/* Globalize/gn.scm 174 */
				       variable_bglt aux_2272;
				       node_bglt aux_2262;
				       {	/* Globalize/gn.scm 174 */
					  obj_t aux_2273;
					  aux_2273 =
					     CAR(locals_1620);
					  aux_2272 =
					     (variable_bglt) (aux_2273);
				       }
				       {	/* Globalize/gn.scm 174 */
					  obj_t aux_2263;
					  {	/* Globalize/gn.scm 174 */
					     sfun_bglt obj_1888;
					     {	/* Globalize/gn.scm 174 */
						value_bglt aux_2264;
						{	/* Globalize/gn.scm 174 */
						   local_bglt obj_1887;
						   {	/* Globalize/gn.scm 174 */
						      obj_t aux_2265;
						      aux_2265 =
							 CAR(locals_1620);
						      obj_1887 =
							 (local_bglt) (aux_2265);
						   }
						   aux_2264 =
						      (((local_bglt) CREF(obj_1887))->value);
						}
						obj_1888 =
						   (sfun_bglt) (aux_2264);
					     }
					     aux_2263 =
						(((sfun_bglt) CREF(obj_1888))->body);
					  }
					  aux_2262 =
					     (node_bglt) (aux_2263);
				       }
				       arg1793_1627 =
					  e_globalize_gn(aux_2262, aux_2272, g_1621);
				    }
				    {
				       obj_t g_2278;
				       obj_t locals_2277;
				       locals_2277 = arg1792_1626;
				       g_2278 = arg1793_1627;
				       g_1621 = g_2278;
				       locals_1620 = locals_2277;
				       goto loop_1622;
				    }
				 }
			    }
			 }
			 break;
		      case ((long) 15):

			 {	/* Globalize/gn.scm 182 */
			    let_var_6_bglt node_1632;
			    node_1632 =
			       (let_var_6_bglt) (node_5);
			    {
			       obj_t bindings_1636;
			       obj_t g_1637;
			       bindings_1636 =
				  (((let_var_6_bglt) CREF(node_1632))->bindings);
			       g_1637 = g_7;
			     loop_1638:
			       if (
				  NULLP(bindings_1636))
				 {
				    obj_t g_2285;
				    node_bglt node_2283;
				    node_2283 =
				       (((let_var_6_bglt) CREF(node_1632))->body);
				    g_2285 = g_1637;
				    g_7 = g_2285;
				    node_5 = node_2283;
				    goto e_globalize_gn;
				 }
			       else
				 {	/* Globalize/gn.scm 187 */
				    obj_t arg1801_1642;
				    obj_t arg1802_1643;
				    arg1801_1642 =
				       CDR(bindings_1636);
				    {	/* Globalize/gn.scm 188 */
				       node_bglt aux_2287;
				       {	/* Globalize/gn.scm 188 */
					  obj_t aux_2288;
					  {	/* ./Ieee/pair-list.scm 5707 */
					     obj_t aux_2289;
					     aux_2289 =
						CAR(bindings_1636);
					     aux_2288 =
						CDR(aux_2289);
					  }
					  aux_2287 =
					     (node_bglt) (aux_2288);
				       }
				       arg1802_1643 =
					  e_globalize_gn(aux_2287, caller_6, g_1637);
				    }
				    {
				       obj_t g_2295;
				       obj_t bindings_2294;
				       bindings_2294 = arg1801_1642;
				       g_2295 = arg1802_1643;
				       g_1637 = g_2295;
				       bindings_1636 = bindings_2294;
				       goto loop_1638;
				    }
				 }
			    }
			 }
			 break;
		      case ((long) 16):

			 {	/* Globalize/gn.scm 194 */
			    set_ex_it_116_bglt node_1646;
			    node_1646 =
			       (set_ex_it_116_bglt) (node_5);
			    {
			       node_bglt node_2298;
			       node_2298 =
				  (((set_ex_it_116_bglt) CREF(node_1646))->body);
			       node_5 = node_2298;
			       goto e_globalize_gn;
			    }
			 }
			 break;
		      case ((long) 17):

			 {	/* Globalize/gn.scm 201 */
			    jump_ex_it_184_bglt node_1651;
			    node_1651 =
			       (jump_ex_it_184_bglt) (node_5);
			    {	/* Globalize/gn.scm 202 */
			       node_bglt arg1806_1655;
			       obj_t arg1807_1656;
			       arg1806_1655 =
				  (((jump_ex_it_184_bglt) CREF(node_1651))->exit);
			       arg1807_1656 =
				  e_globalize_gn(
				  (((jump_ex_it_184_bglt) CREF(node_1651))->value), caller_6, g_7);
			       {
				  obj_t g_2305;
				  node_bglt node_2304;
				  node_2304 = arg1806_1655;
				  g_2305 = arg1807_1656;
				  g_7 = g_2305;
				  node_5 = node_2304;
				  goto e_globalize_gn;
			       }
			    }
			 }
			 break;
		      case ((long) 18):

			 {	/* Globalize/gn.scm 208 */
			    make_box_202_bglt node_1658;
			    node_1658 =
			       (make_box_202_bglt) (node_5);
			    {
			       node_bglt node_2307;
			       node_2307 =
				  (((make_box_202_bglt) CREF(node_1658))->value);
			       node_5 = node_2307;
			       goto e_globalize_gn;
			    }
			 }
			 break;
		      case ((long) 19):

			 {	/* Globalize/gn.scm 215 */
			    box_ref_242_bglt node_1663;
			    node_1663 =
			       (box_ref_242_bglt) (node_5);
			    {
			       node_bglt node_2310;
			       {	/* Globalize/gn.scm 216 */
				  var_bglt aux_2311;
				  aux_2311 =
				     (((box_ref_242_bglt) CREF(node_1663))->var);
				  node_2310 =
				     (node_bglt) (aux_2311);
			       }
			       node_5 = node_2310;
			       goto e_globalize_gn;
			    }
			 }
			 break;
		      case ((long) 20):

			 {	/* Globalize/gn.scm 222 */
			    box_set__221_bglt node_1668;
			    node_1668 =
			       (box_set__221_bglt) (node_5);
			    {	/* Globalize/gn.scm 223 */
			       var_bglt arg1812_1672;
			       obj_t arg1813_1673;
			       arg1812_1672 =
				  (((box_set__221_bglt) CREF(node_1668))->var);
			       arg1813_1673 =
				  e_globalize_gn(
				  (((box_set__221_bglt) CREF(node_1668))->value), caller_6, g_7);
			       {
				  obj_t g_2320;
				  node_bglt node_2318;
				  node_2318 =
				     (node_bglt) (arg1812_1672);
				  g_2320 = arg1813_1673;
				  g_7 = g_2320;
				  node_5 = node_2318;
				  goto e_globalize_gn;
			       }
			    }
			 }
			 break;
		      default:
		       case_else1746_1522:
			 if (
			    PROCEDUREP(method1740_1518))
			   {	/* Globalize/gn.scm 55 */
			      return
				 PROCEDURE_ENTRY(method1740_1518) (method1740_1518,
				 (obj_t) (node_5),
				 (obj_t) (caller_6), g_7, BEOA);
			   }
			 else
			   {	/* Globalize/gn.scm 55 */
			      obj_t fun1739_1514;
			      fun1739_1514 =
				 PROCEDURE_REF(e_env_17_globalize_gn, ((long) 0));
			      return
				 PROCEDURE_ENTRY(fun1739_1514) (fun1739_1514,
				 (obj_t) (node_5),
				 (obj_t) (caller_6), g_7, BEOA);
			   }
		      }
		 }
	       else
		 {	/* Globalize/gn.scm 55 */
		    goto case_else1746_1522;
		 }
	    }
	 }
      }
   }
}



/* _e */
obj_t 
_e_globalize_gn(obj_t env_1913, obj_t node_1914, obj_t caller_1915, obj_t g_1916)
{
   AN_OBJECT;
   {	/* Globalize/gn.scm 55 */
      return
	 e_globalize_gn(
	 (node_bglt) (node_1914),
	 (variable_bglt) (caller_1915), g_1916);
   }
}



/* e-default1571 */
obj_t 
e_default1571_218_globalize_gn(node_bglt node_8, variable_bglt caller_9, obj_t g_10)
{
   AN_OBJECT;
   {	/* Globalize/gn.scm 22 */
      FAILURE(
	 CNST_TABLE_REF(((long) 1)), string1821_globalize_gn,
	 (obj_t) (node_8));
   }
}



/* _e-default1571 */
obj_t 
_e_default1571_122_globalize_gn(obj_t env_1917, obj_t node_1918, obj_t caller_1919, obj_t g_1920)
{
   AN_OBJECT;
   {	/* Globalize/gn.scm 22 */
      return
	 e_default1571_218_globalize_gn(
	 (node_bglt) (node_1918),
	 (variable_bglt) (caller_1919), g_1920);
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_globalize_gn()
{
   AN_OBJECT;
   {	/* Globalize/gn.scm 22 */
      module_initialization_70_tools_trace(((long) 0), "GLOBALIZE_GN");
      module_initialization_70_tools_shape(((long) 0), "GLOBALIZE_GN");
      module_initialization_70_type_type(((long) 0), "GLOBALIZE_GN");
      module_initialization_70_ast_var(((long) 0), "GLOBALIZE_GN");
      module_initialization_70_ast_node(((long) 0), "GLOBALIZE_GN");
      module_initialization_70_globalize_ginfo(((long) 0), "GLOBALIZE_GN");
      return
	 module_initialization_70_globalize_globalize(((long) 0), "GLOBALIZE_GN");
   }
}
