/*===========================================================================*/
/*   (Globalize/integration.scm)                                             */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;

typedef struct sfun_ginfo_98
  {
     bool_t g__219;
     obj_t cfrom;
     obj_t cfrom__119;
     obj_t cto;
     obj_t cto__14;
     obj_t cfunction;
     obj_t integrator;
     obj_t integrated;
     obj_t plugged_in_15;
     long mark;
     obj_t free_mark_81;
     obj_t the_global_201;
     obj_t kaptured;
     obj_t new_body_215;
     long bmark;
     long umark;
     obj_t free;
     obj_t bound;
  }
             *sfun_ginfo_98_bglt;

typedef struct svar_ginfo_131
  {
     bool_t kaptured__204;
     long free_mark_81;
     long mark;
     bool_t celled__113;
  }
              *svar_ginfo_131_bglt;

typedef struct sexit_ginfo_81
  {
     bool_t g__219;
     bool_t kaptured__204;
     long free_mark_81;
     long mark;
  }
              *sexit_ginfo_81_bglt;

typedef struct local_ginfo_108
  {
     bool_t escape__117;
  }
               *local_ginfo_108_bglt;

typedef struct global_ginfo_75
  {
     bool_t escape__117;
     obj_t global_closure_229;
  }
               *global_ginfo_75_bglt;


extern obj_t _g1__181_globalize_globalize;
extern obj_t _e__34_globalize_globalize;
static obj_t method_init_76_globalize_integration();
extern obj_t global_ast_var;
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t module_initialization_70_globalize_integration(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_globalize_ginfo(long, char *);
extern obj_t module_initialization_70_globalize_globalize(long, char *);
extern obj_t module_initialization_70_globalize_kapture(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t union_3_globalize_kapture(obj_t);
static obj_t imported_modules_init_94_globalize_integration();
extern obj_t append_2_18___r4_pairs_and_lists_6_3(obj_t, obj_t);
static obj_t library_modules_init_112_globalize_integration();
extern obj_t open_input_string(obj_t);
static obj_t get_new_tg_254_globalize_integration(obj_t, obj_t, long);
static obj_t get_new_fg_250_globalize_integration(obj_t, long);
extern obj_t local_ast_var;
static obj_t get_integrator_6_globalize_integration(obj_t);
static obj_t set_integrators__120_globalize_integration(obj_t, obj_t, long);
static obj_t _set_integration__157_globalize_integration(obj_t);
extern obj_t read___reader(obj_t);
extern obj_t set_integration__52_globalize_integration();
static obj_t set_cfrom___159_globalize_integration(local_bglt);
static obj_t require_initialization_114_globalize_integration = BUNSPEC;
static obj_t cnst_init_137_globalize_integration();
static obj_t __cnst[1];

DEFINE_STRING(string1747_globalize_integration, string1747_globalize_integration1752, "DONE ", 5);
DEFINE_EXPORT_PROCEDURE(set_integration__env_59_globalize_integration, _set_integration__157_globalize_integration1753, _set_integration__157_globalize_integration, 0L, 0);



/* module-initialization */
obj_t 
module_initialization_70_globalize_integration(long checksum_1769, char *from_1770)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_globalize_integration))
	{
	   require_initialization_114_globalize_integration =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_globalize_integration();
	   cnst_init_137_globalize_integration();
	   imported_modules_init_94_globalize_integration();
	   method_init_76_globalize_integration();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_globalize_integration()
{
   AN_OBJECT;
   {	/* Globalize/integration.scm 15 */
      module_initialization_70___object(((long) 0), "GLOBALIZE_INTEGRATION");
      module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "GLOBALIZE_INTEGRATION");
      module_initialization_70___reader(((long) 0), "GLOBALIZE_INTEGRATION");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_globalize_integration()
{
   AN_OBJECT;
   {	/* Globalize/integration.scm 15 */
      {		/* Globalize/integration.scm 15 */
	 obj_t cnst_port_138_1762;
	 cnst_port_138_1762 =
	    open_input_string(string1747_globalize_integration);
	 {
	    long i_1763;
	    i_1763 = ((long) 0);
	  loop_1764:
	    {	/* Globalize/integration.scm 15 */
	       bool_t test1748_1765;
	       test1748_1765 =
		  (i_1763 == ((long) -1));
	       if (test1748_1765)
		 {	/* Globalize/integration.scm 15 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Globalize/integration.scm 15 */
		    {	/* Globalize/integration.scm 15 */
		       obj_t arg1749_1766;
		       {	/* Globalize/integration.scm 15 */
			  obj_t list1750_1767;
			  list1750_1767 =
			     MAKE_PAIR(cnst_port_138_1762, BNIL);
			  arg1749_1766 =
			     read___reader(list1750_1767);
		       }
		       CNST_TABLE_SET(i_1763, arg1749_1766);
		    }
		    {	/* Globalize/integration.scm 15 */
		       int aux_1768;
		       {	/* Globalize/integration.scm 15 */
			  long aux_1787;
			  aux_1787 =
			     (i_1763 - ((long) 1));
			  aux_1768 =
			     (int) (aux_1787);
		       }
		       {
			  long i_1790;
			  i_1790 =
			     (long) (aux_1768);
			  i_1763 = i_1790;
			  goto loop_1764;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* set-integration! */
obj_t 
set_integration__52_globalize_integration()
{
   AN_OBJECT;
   {	/* Globalize/integration.scm 29 */
      {
	 obj_t l1554_1004;
	 l1554_1004 = _e__34_globalize_globalize;
       lname1555_1005:
	 if (
	    PAIRP(l1554_1004))
	   {	/* Globalize/integration.scm 33 */
	      {		/* Globalize/integration.scm 33 */
		 local_bglt aux_1794;
		 {	/* Globalize/integration.scm 33 */
		    obj_t aux_1795;
		    aux_1795 =
		       CAR(l1554_1004);
		    aux_1794 =
		       (local_bglt) (aux_1795);
		 }
		 set_cfrom___159_globalize_integration(aux_1794);
	      }
	      {
		 obj_t l1554_1799;
		 l1554_1799 =
		    CDR(l1554_1004);
		 l1554_1004 = l1554_1799;
		 goto lname1555_1005;
	      }
	   }
	 else
	   {	/* Globalize/integration.scm 33 */
	      ((bool_t) 1);
	   }
      }
      {
	 obj_t l1556_1009;
	 l1556_1009 = _g1__181_globalize_globalize;
       lname1557_1010:
	 if (
	    PAIRP(l1556_1009))
	   {	/* Globalize/integration.scm 34 */
	      {		/* Globalize/integration.scm 34 */
		 local_bglt aux_1803;
		 {	/* Globalize/integration.scm 34 */
		    obj_t aux_1804;
		    aux_1804 =
		       CAR(l1556_1009);
		    aux_1803 =
		       (local_bglt) (aux_1804);
		 }
		 set_cfrom___159_globalize_integration(aux_1803);
	      }
	      {
		 obj_t l1556_1808;
		 l1556_1808 =
		    CDR(l1556_1009);
		 l1556_1009 = l1556_1808;
		 goto lname1557_1010;
	      }
	   }
	 else
	   {	/* Globalize/integration.scm 34 */
	      ((bool_t) 1);
	   }
      }
      {
	 obj_t tg_1014;
	 obj_t fg_1015;
	 long round_1016;
	 tg_1014 = _e__34_globalize_globalize;
	 fg_1015 = _g1__181_globalize_globalize;
	 round_1016 = ((long) 0);
       loop_1017:
	 {
	    obj_t l1558_1018;
	    l1558_1018 = tg_1014;
	  lname1559_1019:
	    if (
	       PAIRP(l1558_1018))
	      {		/* Globalize/integration.scm 46 */
		 {	/* Globalize/integration.scm 47 */
		    sfun_ginfo_98_bglt obj_1542;
		    {	/* Globalize/integration.scm 47 */
		       value_bglt aux_1812;
		       {	/* Globalize/integration.scm 47 */
			  local_bglt obj_1541;
			  {	/* Globalize/integration.scm 47 */
			     obj_t aux_1813;
			     aux_1813 =
				CAR(l1558_1018);
			     obj_1541 =
				(local_bglt) (aux_1813);
			  }
			  aux_1812 =
			     (((local_bglt) CREF(obj_1541))->value);
		       }
		       obj_1542 =
			  (sfun_ginfo_98_bglt) (aux_1812);
		    }
		    {
		       obj_t aux_1818;
		       {	/* ./Globalize/ginfo.scm 961 */
			  object_bglt aux_1819;
			  aux_1819 =
			     (object_bglt) (obj_1542);
			  aux_1818 =
			     OBJECT_WIDENING(aux_1819);
		       }
		       ((((sfun_ginfo_98_bglt) CREF(aux_1818))->mark) = ((long) round_1016), BUNSPEC);
		    }
		 }
		 {
		    obj_t l1558_1823;
		    l1558_1823 =
		       CDR(l1558_1018);
		    l1558_1018 = l1558_1823;
		    goto lname1559_1019;
		 }
	      }
	    else
	      {		/* Globalize/integration.scm 46 */
		 ((bool_t) 1);
	      }
	 }
	 {	/* Globalize/integration.scm 49 */
	    obj_t new_tg_10_1024;
	    new_tg_10_1024 =
	       get_new_tg_254_globalize_integration(tg_1014, fg_1015, round_1016);
	    if (
	       NULLP(new_tg_10_1024))
	      {		/* Globalize/integration.scm 51 */
		 return
		    set_integrators__120_globalize_integration(tg_1014, fg_1015, round_1016);
	      }
	    else
	      {		/* Globalize/integration.scm 55 */
		 obj_t new_fg_180_1026;
		 new_fg_180_1026 =
		    get_new_fg_250_globalize_integration(fg_1015, round_1016);
		 {
		    long round_1833;
		    obj_t fg_1832;
		    obj_t tg_1830;
		    tg_1830 =
		       append_2_18___r4_pairs_and_lists_6_3(new_tg_10_1024, tg_1014);
		    fg_1832 = new_fg_180_1026;
		    round_1833 =
		       (round_1016 + ((long) 1));
		    round_1016 = round_1833;
		    fg_1015 = fg_1832;
		    tg_1014 = tg_1830;
		    goto loop_1017;
		 }
	      }
	 }
      }
   }
}



/* _set-integration! */
obj_t 
_set_integration__157_globalize_integration(obj_t env_1761)
{
   AN_OBJECT;
   {	/* Globalize/integration.scm 29 */
      return
	 set_integration__52_globalize_integration();
   }
}



/* set-cfrom*! */
obj_t 
set_cfrom___159_globalize_integration(local_bglt local_1)
{
   AN_OBJECT;
   {	/* Globalize/integration.scm 65 */
      {		/* Globalize/integration.scm 66 */
	 value_bglt info_1029;
	 info_1029 =
	    (((local_bglt) CREF(local_1))->value);
	 {	/* Globalize/integration.scm 67 */
	    bool_t test_1837;
	    {	/* Globalize/integration.scm 67 */
	       bool_t test_1838;
	       {	/* ./Ieee/pair-list.scm 5669 */
		  obj_t aux_1839;
		  {	/* Globalize/integration.scm 67 */
		     sfun_ginfo_98_bglt obj_1549;
		     obj_1549 =
			(sfun_ginfo_98_bglt) (info_1029);
		     {
			obj_t aux_1841;
			{	/* ./Globalize/ginfo.scm 947 */
			   object_bglt aux_1842;
			   aux_1842 =
			      (object_bglt) (obj_1549);
			   aux_1841 =
			      OBJECT_WIDENING(aux_1842);
			}
			aux_1839 =
			   (((sfun_ginfo_98_bglt) CREF(aux_1841))->cfrom__119);
		     }
		  }
		  test_1838 =
		     PAIRP(aux_1839);
	       }
	       if (test_1838)
		 {	/* Globalize/integration.scm 67 */
		    test_1837 = ((bool_t) 1)
		       ;
		 }
	       else
		 {	/* ./Ieee/pair-list.scm 5912 */
		    obj_t aux_1847;
		    {	/* Globalize/integration.scm 68 */
		       sfun_ginfo_98_bglt obj_1551;
		       obj_1551 =
			  (sfun_ginfo_98_bglt) (info_1029);
		       {
			  obj_t aux_1849;
			  {	/* ./Globalize/ginfo.scm 947 */
			     object_bglt aux_1850;
			     aux_1850 =
				(object_bglt) (obj_1551);
			     aux_1849 =
				OBJECT_WIDENING(aux_1850);
			  }
			  aux_1847 =
			     (((sfun_ginfo_98_bglt) CREF(aux_1849))->cfrom__119);
		       }
		    }
		    test_1837 =
		       NULLP(aux_1847);
		 }
	    }
	    if (test_1837)
	      {		/* Globalize/integration.scm 69 */
		 sfun_ginfo_98_bglt obj_1553;
		 obj_1553 =
		    (sfun_ginfo_98_bglt) (info_1029);
		 {
		    obj_t aux_1856;
		    {	/* ./Globalize/ginfo.scm 947 */
		       object_bglt aux_1857;
		       aux_1857 =
			  (object_bglt) (obj_1553);
		       aux_1856 =
			  OBJECT_WIDENING(aux_1857);
		    }
		    return
		       (((sfun_ginfo_98_bglt) CREF(aux_1856))->cfrom__119);
		 }
	      }
	    else
	      {		/* Globalize/integration.scm 67 */
		 {	/* Globalize/integration.scm 72 */
		    sfun_ginfo_98_bglt obj_1554;
		    obj_1554 =
		       (sfun_ginfo_98_bglt) (info_1029);
		    {
		       obj_t aux_1862;
		       {	/* ./Globalize/ginfo.scm 947 */
			  object_bglt aux_1863;
			  aux_1863 =
			     (object_bglt) (obj_1554);
			  aux_1862 =
			     OBJECT_WIDENING(aux_1863);
		       }
		       ((((sfun_ginfo_98_bglt) CREF(aux_1862))->cfrom__119) = ((obj_t) BNIL), BUNSPEC);
		    }
		 }
		 {
		    obj_t cfrom_1031;
		    obj_t cfrom__set_44_1032;
		    obj_t global_1033;
		    {	/* Globalize/integration.scm 73 */
		       sfun_ginfo_98_bglt obj_1556;
		       obj_1556 =
			  (sfun_ginfo_98_bglt) (info_1029);
		       {
			  obj_t aux_1915;
			  {	/* ./Globalize/ginfo.scm 945 */
			     object_bglt aux_1916;
			     aux_1916 =
				(object_bglt) (obj_1556);
			     aux_1915 =
				OBJECT_WIDENING(aux_1916);
			  }
			  cfrom_1031 =
			     (((sfun_ginfo_98_bglt) CREF(aux_1915))->cfrom);
		       }
		    }
		    cfrom__set_44_1032 = BNIL;
		    global_1033 = BFALSE;
		  loop_1034:
		    if (
		       NULLP(cfrom_1031))
		      {		/* Globalize/integration.scm 77 */
			 {	/* Globalize/integration.scm 78 */
			    obj_t res_1038;
			    {	/* Globalize/integration.scm 78 */
			       obj_t u_1039;
			       u_1039 =
				  union_3_globalize_kapture(cfrom__set_44_1032);
			       {	/* Globalize/integration.scm 79 */
				  bool_t test1579_1040;
				  test1579_1040 =
				     is_a__118___object(global_1033, global_ast_var);
				  if (test1579_1040)
				    {	/* Globalize/integration.scm 79 */
				       res_1038 =
					  MAKE_PAIR(global_1033, u_1039);
				    }
				  else
				    {	/* Globalize/integration.scm 79 */
				       res_1038 = u_1039;
				    }
			       }
			    }
			    {	/* Globalize/integration.scm 85 */
			       sfun_ginfo_98_bglt obj_1561;
			       obj_1561 =
				  (sfun_ginfo_98_bglt) (info_1029);
			       {
				  obj_t aux_1874;
				  {	/* ./Globalize/ginfo.scm 947 */
				     object_bglt aux_1875;
				     aux_1875 =
					(object_bglt) (obj_1561);
				     aux_1874 =
					OBJECT_WIDENING(aux_1875);
				  }
				  ((((sfun_ginfo_98_bglt) CREF(aux_1874))->cfrom__119) = ((obj_t) res_1038), BUNSPEC);
			       }
			    }
			    return res_1038;
			 }
		      }
		    else
		      {		/* Globalize/integration.scm 87 */
			 bool_t test1580_1041;
			 test1580_1041 =
			    is_a__118___object(
			    CAR(cfrom_1031), global_ast_var);
			 if (test1580_1041)
			   {	/* Globalize/integration.scm 87 */
			      {
				 obj_t global_1884;
				 obj_t cfrom_1882;
				 cfrom_1882 =
				    CDR(cfrom_1031);
				 global_1884 =
				    CAR(cfrom_1031);
				 global_1033 = global_1884;
				 cfrom_1031 = cfrom_1882;
				 goto loop_1034;
			      }
			   }
			 else
			   {	/* Globalize/integration.scm 87 */
			      {		/* Globalize/integration.scm 92 */
				 obj_t cfrom__119_1044;
				 {	/* Globalize/integration.scm 92 */
				    local_bglt aux_1886;
				    {	/* Globalize/integration.scm 92 */
				       obj_t aux_1887;
				       aux_1887 =
					  CAR(cfrom_1031);
				       aux_1886 =
					  (local_bglt) (aux_1887);
				    }
				    cfrom__119_1044 =
				       set_cfrom___159_globalize_integration(aux_1886);
				 }
				 {	/* Globalize/integration.scm 93 */
				    bool_t test1583_1045;
				    if (
				       PAIRP(cfrom__119_1044))
				      {		/* Globalize/integration.scm 93 */
					 test1583_1045 =
					    is_a__118___object(
					    CAR(cfrom__119_1044), global_ast_var);
				      }
				    else
				      {		/* Globalize/integration.scm 93 */
					 test1583_1045 = ((bool_t) 0);
				      }
				    if (test1583_1045)
				      {		/* Globalize/integration.scm 94 */
					 obj_t arg1584_1046;
					 obj_t arg1585_1047;
					 obj_t arg1586_1048;
					 arg1584_1046 =
					    CDR(cfrom_1031);
					 {	/* Globalize/integration.scm 95 */
					    obj_t arg1587_1049;
					    {	/* ./Ieee/pair-list.scm 5689 */
					       obj_t aux_1899;
					       obj_t aux_1897;
					       aux_1899 =
						  CDR(cfrom__119_1044);
					       aux_1897 =
						  CAR(cfrom_1031);
					       arg1587_1049 =
						  MAKE_PAIR(aux_1897, aux_1899);
					    }
					    arg1585_1047 =
					       MAKE_PAIR(arg1587_1049, cfrom__set_44_1032);
					 }
					 arg1586_1048 =
					    CAR(cfrom__119_1044);
					 {
					    obj_t global_1906;
					    obj_t cfrom__set_44_1905;
					    obj_t cfrom_1904;
					    cfrom_1904 = arg1584_1046;
					    cfrom__set_44_1905 = arg1585_1047;
					    global_1906 = arg1586_1048;
					    global_1033 = global_1906;
					    cfrom__set_44_1032 = cfrom__set_44_1905;
					    cfrom_1031 = cfrom_1904;
					    goto loop_1034;
					 }
				      }
				    else
				      {		/* Globalize/integration.scm 98 */
					 obj_t arg1590_1052;
					 obj_t arg1591_1053;
					 arg1590_1052 =
					    CDR(cfrom_1031);
					 {	/* Globalize/integration.scm 99 */
					    obj_t arg1592_1054;
					    {	/* ./Ieee/pair-list.scm 5689 */
					       obj_t aux_1908;
					       aux_1908 =
						  CAR(cfrom_1031);
					       arg1592_1054 =
						  MAKE_PAIR(aux_1908, cfrom__119_1044);
					    }
					    arg1591_1053 =
					       MAKE_PAIR(arg1592_1054, cfrom__set_44_1032);
					 }
					 {
					    obj_t cfrom__set_44_1913;
					    obj_t cfrom_1912;
					    cfrom_1912 = arg1590_1052;
					    cfrom__set_44_1913 = arg1591_1053;
					    cfrom__set_44_1032 = cfrom__set_44_1913;
					    cfrom_1031 = cfrom_1912;
					    goto loop_1034;
					 }
				      }
				 }
			      }
			   }
		      }
		 }
	      }
	 }
      }
   }
}



/* get-new-tg */
obj_t 
get_new_tg_254_globalize_integration(obj_t tg_2, obj_t fg_3, long round_4)
{
   AN_OBJECT;
   {	/* Globalize/integration.scm 109 */
      {
	 obj_t new_tg_10_1063;
	 obj_t fg_1064;
	 new_tg_10_1063 = BNIL;
	 fg_1064 = fg_3;
       loop_1065:
	 if (
	    NULLP(fg_1064))
	   {	/* Globalize/integration.scm 112 */
	      return new_tg_10_1063;
	   }
	 else
	   {	/* Globalize/integration.scm 114 */
	      obj_t local_1067;
	      local_1067 =
		 CAR(fg_1064);
	      {
		 obj_t cfrom_1068;
		 long new_1069;
		 {	/* Globalize/integration.scm 119 */
		    sfun_ginfo_98_bglt obj_1588;
		    {	/* Globalize/integration.scm 119 */
		       value_bglt aux_1982;
		       {	/* Globalize/integration.scm 119 */
			  local_bglt obj_1587;
			  obj_1587 =
			     (local_bglt) (local_1067);
			  aux_1982 =
			     (((local_bglt) CREF(obj_1587))->value);
		       }
		       obj_1588 =
			  (sfun_ginfo_98_bglt) (aux_1982);
		    }
		    {
		       obj_t aux_1986;
		       {	/* ./Globalize/ginfo.scm 947 */
			  object_bglt aux_1987;
			  aux_1987 =
			     (object_bglt) (obj_1588);
			  aux_1986 =
			     OBJECT_WIDENING(aux_1987);
		       }
		       cfrom_1068 =
			  (((sfun_ginfo_98_bglt) CREF(aux_1986))->cfrom__119);
		    }
		 }
		 new_1069 = ((long) 0);
	       liip_1070:
		 if (
		    NULLP(cfrom_1068))
		   {	/* Globalize/integration.scm 122 */
		      if (
			 (new_1069 < ((long) 2)))
			{
			   obj_t fg_1927;
			   fg_1927 =
			      CDR(fg_1064);
			   fg_1064 = fg_1927;
			   goto loop_1065;
			}
		      else
			{	/* Globalize/integration.scm 123 */
			   {	/* Globalize/integration.scm 128 */
			      long arg1609_1078;
			      arg1609_1078 =
				 (round_4 - ((long) 1));
			      {		/* Globalize/integration.scm 128 */
				 sfun_ginfo_98_bglt obj_1596;
				 {	/* Globalize/integration.scm 128 */
				    value_bglt aux_1930;
				    {	/* Globalize/integration.scm 128 */
				       local_bglt obj_1593;
				       obj_1593 =
					  (local_bglt) (local_1067);
				       aux_1930 =
					  (((local_bglt) CREF(obj_1593))->value);
				    }
				    obj_1596 =
				       (sfun_ginfo_98_bglt) (aux_1930);
				 }
				 {
				    obj_t aux_1934;
				    {	/* ./Globalize/ginfo.scm 961 */
				       object_bglt aux_1935;
				       aux_1935 =
					  (object_bglt) (obj_1596);
				       aux_1934 =
					  OBJECT_WIDENING(aux_1935);
				    }
				    ((((sfun_ginfo_98_bglt) CREF(aux_1934))->mark) = ((long) arg1609_1078), BUNSPEC);
				 }
			      }
			   }
			   {	/* Globalize/integration.scm 130 */
			      obj_t arg1610_1079;
			      obj_t arg1611_1080;
			      arg1610_1079 =
				 MAKE_PAIR(local_1067, new_tg_10_1063);
			      arg1611_1080 =
				 CDR(fg_1064);
			      {
				 obj_t fg_1942;
				 obj_t new_tg_10_1941;
				 new_tg_10_1941 = arg1610_1079;
				 fg_1942 = arg1611_1080;
				 fg_1064 = fg_1942;
				 new_tg_10_1063 = new_tg_10_1941;
				 goto loop_1065;
			      }
			   }
			}
		   }
		 else
		   {	/* Globalize/integration.scm 131 */
		      bool_t test1612_1081;
		      test1612_1081 =
			 is_a__118___object(
			 CAR(cfrom_1068), global_ast_var);
		      if (test1612_1081)
			{	/* Globalize/integration.scm 131 */
			   {
			      long new_1948;
			      obj_t cfrom_1946;
			      cfrom_1946 =
				 CDR(cfrom_1068);
			      new_1948 =
				 (new_1069 + ((long) 1));
			      new_1069 = new_1948;
			      cfrom_1068 = cfrom_1946;
			      goto liip_1070;
			   }
			}
		      else
			{	/* Globalize/integration.scm 133 */
			   bool_t test_1950;
			   {	/* Globalize/integration.scm 133 */
			      bool_t test_1951;
			      {		/* Globalize/integration.scm 133 */
				 sfun_ginfo_98_bglt obj_1608;
				 {	/* Globalize/integration.scm 133 */
				    value_bglt aux_1952;
				    {	/* Globalize/integration.scm 133 */
				       local_bglt obj_1607;
				       {	/* Globalize/integration.scm 133 */
					  obj_t aux_1953;
					  aux_1953 =
					     CAR(cfrom_1068);
					  obj_1607 =
					     (local_bglt) (aux_1953);
				       }
				       aux_1952 =
					  (((local_bglt) CREF(obj_1607))->value);
				    }
				    obj_1608 =
				       (sfun_ginfo_98_bglt) (aux_1952);
				 }
				 {
				    obj_t aux_1958;
				    {	/* ./Globalize/ginfo.scm 943 */
				       object_bglt aux_1959;
				       aux_1959 =
					  (object_bglt) (obj_1608);
				       aux_1958 =
					  OBJECT_WIDENING(aux_1959);
				    }
				    test_1951 =
				       (((sfun_ginfo_98_bglt) CREF(aux_1958))->g__219);
				 }
			      }
			      if (test_1951)
				{	/* ./Ieee/fixnum.scm 7115 */
				   long aux_1963;
				   {	/* Globalize/integration.scm 134 */
				      sfun_ginfo_98_bglt obj_1611;
				      {		/* Globalize/integration.scm 134 */
					 value_bglt aux_1964;
					 {	/* Globalize/integration.scm 134 */
					    local_bglt obj_1610;
					    {	/* Globalize/integration.scm 134 */
					       obj_t aux_1965;
					       aux_1965 =
						  CAR(cfrom_1068);
					       obj_1610 =
						  (local_bglt) (aux_1965);
					    }
					    aux_1964 =
					       (((local_bglt) CREF(obj_1610))->value);
					 }
					 obj_1611 =
					    (sfun_ginfo_98_bglt) (aux_1964);
				      }
				      {
					 obj_t aux_1970;
					 {	/* ./Globalize/ginfo.scm 961 */
					    object_bglt aux_1971;
					    aux_1971 =
					       (object_bglt) (obj_1611);
					    aux_1970 =
					       OBJECT_WIDENING(aux_1971);
					 }
					 aux_1963 =
					    (((sfun_ginfo_98_bglt) CREF(aux_1970))->mark);
				      }
				   }
				   test_1950 =
				      (aux_1963 < round_4);
				}
			      else
				{	/* Globalize/integration.scm 133 */
				   test_1950 = ((bool_t) 1)
				      ;
				}
			   }
			   if (test_1950)
			     {	/* Globalize/integration.scm 133 */
				{
				   obj_t cfrom_1976;
				   cfrom_1976 =
				      CDR(cfrom_1068);
				   cfrom_1068 = cfrom_1976;
				   goto liip_1070;
				}
			     }
			   else
			     {	/* Globalize/integration.scm 133 */
				{
				   long new_1980;
				   obj_t cfrom_1978;
				   cfrom_1978 =
				      CDR(cfrom_1068);
				   new_1980 =
				      (new_1069 + ((long) 1));
				   new_1069 = new_1980;
				   cfrom_1068 = cfrom_1978;
				   goto liip_1070;
				}
			     }
			}
		   }
	      }
	   }
      }
   }
}



/* get-new-fg */
obj_t 
get_new_fg_250_globalize_integration(obj_t fg_5, long round_6)
{
   AN_OBJECT;
   {	/* Globalize/integration.scm 144 */
      {
	 obj_t old_fg_154_1095;
	 obj_t new_fg_180_1096;
	 old_fg_154_1095 = fg_5;
	 new_fg_180_1096 = BNIL;
       loop_1097:
	 if (
	    NULLP(old_fg_154_1095))
	   {	/* Globalize/integration.scm 148 */
	      return new_fg_180_1096;
	   }
	 else
	   {	/* Globalize/integration.scm 150 */
	      bool_t test_1993;
	      {		/* ./Ieee/fixnum.scm 7109 */
		 long aux_2006;
		 long aux_1994;
		 aux_2006 =
		    (round_6 - ((long) 1));
		 {	/* Globalize/integration.scm 150 */
		    sfun_ginfo_98_bglt obj_1621;
		    {	/* Globalize/integration.scm 150 */
		       value_bglt aux_1995;
		       {	/* Globalize/integration.scm 150 */
			  local_bglt obj_1620;
			  {	/* Globalize/integration.scm 150 */
			     obj_t aux_1996;
			     aux_1996 =
				CAR(old_fg_154_1095);
			     obj_1620 =
				(local_bglt) (aux_1996);
			  }
			  aux_1995 =
			     (((local_bglt) CREF(obj_1620))->value);
		       }
		       obj_1621 =
			  (sfun_ginfo_98_bglt) (aux_1995);
		    }
		    {
		       obj_t aux_2001;
		       {	/* ./Globalize/ginfo.scm 961 */
			  object_bglt aux_2002;
			  aux_2002 =
			     (object_bglt) (obj_1621);
			  aux_2001 =
			     OBJECT_WIDENING(aux_2002);
		       }
		       aux_1994 =
			  (((sfun_ginfo_98_bglt) CREF(aux_2001))->mark);
		    }
		 }
		 test_1993 =
		    (aux_1994 == aux_2006);
	      }
	      if (test_1993)
		{	/* Globalize/integration.scm 150 */
		   {
		      obj_t old_fg_154_2009;
		      old_fg_154_2009 =
			 CDR(old_fg_154_1095);
		      old_fg_154_1095 = old_fg_154_2009;
		      goto loop_1097;
		   }
		}
	      else
		{	/* Globalize/integration.scm 150 */
		   {	/* Globalize/integration.scm 153 */
		      obj_t arg1629_1101;
		      obj_t arg1630_1102;
		      arg1629_1101 =
			 CDR(old_fg_154_1095);
		      {		/* ./Ieee/pair-list.scm 5689 */
			 obj_t aux_2012;
			 aux_2012 =
			    CAR(old_fg_154_1095);
			 arg1630_1102 =
			    MAKE_PAIR(aux_2012, new_fg_180_1096);
		      }
		      {
			 obj_t new_fg_180_2016;
			 obj_t old_fg_154_2015;
			 old_fg_154_2015 = arg1629_1101;
			 new_fg_180_2016 = arg1630_1102;
			 new_fg_180_1096 = new_fg_180_2016;
			 old_fg_154_1095 = old_fg_154_2015;
			 goto loop_1097;
		      }
		   }
		}
	   }
      }
   }
}



/* set-integrators! */
obj_t 
set_integrators__120_globalize_integration(obj_t tg_7, obj_t fg_8, long round_9)
{
   AN_OBJECT;
   {	/* Globalize/integration.scm 161 */
      {
	 obj_t roots_1108;
	 roots_1108 = tg_7;
       loop_1109:
	 if (
	    NULLP(roots_1108))
	   {	/* Globalize/integration.scm 165 */
	      return
		 CNST_TABLE_REF(((long) 0));
	   }
	 else
	   {
	      obj_t roots_1111;
	      obj_t new_roots_207_1112;
	      roots_1111 = roots_1108;
	      new_roots_207_1112 = BNIL;
	    liip_1113:
	      if (
		 NULLP(roots_1111))
		{
		   obj_t roots_2022;
		   roots_2022 = new_roots_207_1112;
		   roots_1108 = roots_2022;
		   goto loop_1109;
		}
	      else
		{	/* Globalize/integration.scm 171 */
		   obj_t root_1115;
		   root_1115 =
		      CAR(roots_1111);
		   {
		      obj_t cto_1116;
		      obj_t new_1117;
		      {		/* Globalize/integration.scm 172 */
			 sfun_ginfo_98_bglt obj_1635;
			 {	/* Globalize/integration.scm 172 */
			    value_bglt aux_2099;
			    {	/* Globalize/integration.scm 172 */
			       local_bglt obj_1634;
			       obj_1634 =
				  (local_bglt) (root_1115);
			       aux_2099 =
				  (((local_bglt) CREF(obj_1634))->value);
			    }
			    obj_1635 =
			       (sfun_ginfo_98_bglt) (aux_2099);
			 }
			 {
			    obj_t aux_2103;
			    {	/* ./Globalize/ginfo.scm 949 */
			       object_bglt aux_2104;
			       aux_2104 =
				  (object_bglt) (obj_1635);
			       aux_2103 =
				  OBJECT_WIDENING(aux_2104);
			    }
			    cto_1116 =
			       (((sfun_ginfo_98_bglt) CREF(aux_2103))->cto);
			 }
		      }
		      new_1117 = new_roots_207_1112;
		    laap_1118:
		      if (
			 NULLP(cto_1116))
			{
			   obj_t new_roots_207_2028;
			   obj_t roots_2026;
			   roots_2026 =
			      CDR(roots_1111);
			   new_roots_207_2028 = new_1117;
			   new_roots_207_1112 = new_roots_207_2028;
			   roots_1111 = roots_2026;
			   goto liip_1113;
			}
		      else
			{	/* Globalize/integration.scm 176 */
			   obj_t to_1123;
			   to_1123 =
			      CAR(cto_1116);
			   {	/* Globalize/integration.scm 176 */
			      value_bglt info_1124;
			      {		/* Globalize/integration.scm 177 */
				 local_bglt obj_1639;
				 obj_1639 =
				    (local_bglt) (to_1123);
				 info_1124 =
				    (((local_bglt) CREF(obj_1639))->value);
			      }
			      {		/* Globalize/integration.scm 177 */

				 {	/* Globalize/integration.scm 179 */
				    bool_t test_2032;
				    {	/* Globalize/integration.scm 179 */
				       sfun_ginfo_98_bglt obj_1640;
				       obj_1640 =
					  (sfun_ginfo_98_bglt) (info_1124);
				       {
					  obj_t aux_2034;
					  {	/* ./Globalize/ginfo.scm 943 */
					     object_bglt aux_2035;
					     aux_2035 =
						(object_bglt) (obj_1640);
					     aux_2034 =
						OBJECT_WIDENING(aux_2035);
					  }
					  test_2032 =
					     (((sfun_ginfo_98_bglt) CREF(aux_2034))->g__219);
				       }
				    }
				    if (test_2032)
				      {		/* Globalize/integration.scm 182 */
					 bool_t test_2039;
					 {	/* ./Ieee/fixnum.scm 7109 */
					    long aux_2040;
					    {	/* Globalize/integration.scm 182 */
					       sfun_ginfo_98_bglt obj_1641;
					       obj_1641 =
						  (sfun_ginfo_98_bglt) (info_1124);
					       {
						  obj_t aux_2042;
						  {	/* ./Globalize/ginfo.scm 961 */
						     object_bglt aux_2043;
						     aux_2043 =
							(object_bglt) (obj_1641);
						     aux_2042 =
							OBJECT_WIDENING(aux_2043);
						  }
						  aux_2040 =
						     (((sfun_ginfo_98_bglt) CREF(aux_2042))->mark);
					       }
					    }
					    test_2039 =
					       (aux_2040 == round_9);
					 }
					 if (test_2039)
					   {	/* Globalize/integration.scm 182 */
					      {
						 obj_t cto_2048;
						 cto_2048 =
						    CDR(cto_1116);
						 cto_1116 = cto_2048;
						 goto laap_1118;
					      }
					   }
					 else
					   {	/* Globalize/integration.scm 186 */
					      bool_t test1645_1128;
					      {		/* ./Ast/var.scm 679 */
						 obj_t aux_2050;
						 {	/* Globalize/integration.scm 186 */
						    sfun_ginfo_98_bglt obj_1645;
						    obj_1645 =
						       (sfun_ginfo_98_bglt) (info_1124);
						    {
						       obj_t aux_2052;
						       {	/* ./Globalize/ginfo.scm 955 */
							  object_bglt aux_2053;
							  aux_2053 =
							     (object_bglt) (obj_1645);
							  aux_2052 =
							     OBJECT_WIDENING(aux_2053);
						       }
						       aux_2050 =
							  (((sfun_ginfo_98_bglt) CREF(aux_2052))->integrator);
						    }
						 }
						 test1645_1128 =
						    is_a__118___object(aux_2050, local_ast_var);
					      }
					      if (test1645_1128)
						{	/* Globalize/integration.scm 186 */
						   {
						      obj_t cto_2059;
						      cto_2059 =
							 CDR(cto_1116);
						      cto_1116 = cto_2059;
						      goto laap_1118;
						   }
						}
					      else
						{	/* Globalize/integration.scm 186 */
						   {	/* Globalize/integration.scm 193 */
						      sfun_ginfo_98_bglt obj_1648;
						      obj_1648 =
							 (sfun_ginfo_98_bglt) (info_1124);
						      {
							 obj_t aux_2062;
							 {	/* ./Globalize/ginfo.scm 943 */
							    object_bglt aux_2063;
							    aux_2063 =
							       (object_bglt) (obj_1648);
							    aux_2062 =
							       OBJECT_WIDENING(aux_2063);
							 }
							 ((((sfun_ginfo_98_bglt) CREF(aux_2062))->g__219) = ((bool_t) ((bool_t) 0)), BUNSPEC);
						      }
						   }
						   {	/* Globalize/integration.scm 194 */
						      obj_t integrator_1130;
						      integrator_1130 =
							 get_integrator_6_globalize_integration(root_1115);
						      {		/* Globalize/integration.scm 196 */
							 sfun_ginfo_98_bglt obj_1650;
							 obj_1650 =
							    (sfun_ginfo_98_bglt) (info_1124);
							 {
							    obj_t aux_2069;
							    {	/* ./Globalize/ginfo.scm 955 */
							       object_bglt aux_2070;
							       aux_2070 =
								  (object_bglt) (obj_1650);
							       aux_2069 =
								  OBJECT_WIDENING(aux_2070);
							    }
							    ((((sfun_ginfo_98_bglt) CREF(aux_2069))->integrator) = ((obj_t) integrator_1130), BUNSPEC);
							 }
						      }
						      {		/* Globalize/integration.scm 200 */
							 value_bglt arg1647_1131;
							 obj_t arg1648_1132;
							 {	/* Globalize/integration.scm 200 */
							    local_bglt obj_1652;
							    obj_1652 =
							       (local_bglt) (integrator_1130);
							    arg1647_1131 =
							       (((local_bglt) CREF(obj_1652))->value);
							 }
							 {	/* ./Ieee/pair-list.scm 5689 */
							    obj_t aux_2076;
							    {	/* Globalize/integration.scm 201 */
							       sfun_ginfo_98_bglt obj_1654;
							       {	/* Globalize/integration.scm 201 */
								  value_bglt aux_2077;
								  {	/* Globalize/integration.scm 202 */
								     local_bglt obj_1653;
								     obj_1653 =
									(local_bglt) (integrator_1130);
								     aux_2077 =
									(((local_bglt) CREF(obj_1653))->value);
								  }
								  obj_1654 =
								     (sfun_ginfo_98_bglt) (aux_2077);
							       }
							       {
								  obj_t aux_2081;
								  {	/* ./Globalize/ginfo.scm 957 */
								     object_bglt aux_2082;
								     aux_2082 =
									(object_bglt) (obj_1654);
								     aux_2081 =
									OBJECT_WIDENING(aux_2082);
								  }
								  aux_2076 =
								     (((sfun_ginfo_98_bglt) CREF(aux_2081))->integrated);
							       }
							    }
							    arg1648_1132 =
							       MAKE_PAIR(to_1123, aux_2076);
							 }
							 {	/* Globalize/integration.scm 199 */
							    sfun_ginfo_98_bglt obj_1657;
							    obj_1657 =
							       (sfun_ginfo_98_bglt) (arg1647_1131);
							    {
							       obj_t aux_2088;
							       {	/* ./Globalize/ginfo.scm 957 */
								  object_bglt aux_2089;
								  aux_2089 =
								     (object_bglt) (obj_1657);
								  aux_2088 =
								     OBJECT_WIDENING(aux_2089);
							       }
							       ((((sfun_ginfo_98_bglt) CREF(aux_2088))->integrated) = ((obj_t) arg1648_1132), BUNSPEC);
							    }
							 }
						      }
						   }
						   {	/* Globalize/integration.scm 203 */
						      obj_t arg1651_1135;
						      obj_t arg1652_1136;
						      arg1651_1135 =
							 CDR(cto_1116);
						      arg1652_1136 =
							 MAKE_PAIR(to_1123, new_1117);
						      {
							 obj_t new_2096;
							 obj_t cto_2095;
							 cto_2095 = arg1651_1135;
							 new_2096 = arg1652_1136;
							 new_1117 = new_2096;
							 cto_1116 = cto_2095;
							 goto laap_1118;
						      }
						   }
						}
					   }
				      }
				    else
				      {		/* Globalize/integration.scm 179 */
					 {
					    obj_t cto_2097;
					    cto_2097 =
					       CDR(cto_1116);
					    cto_1116 = cto_2097;
					    goto laap_1118;
					 }
				      }
				 }
			      }
			   }
			}
		   }
		}
	   }
      }
   }
}



/* get-integrator */
obj_t 
get_integrator_6_globalize_integration(obj_t local_10)
{
   AN_OBJECT;
   {	/* Globalize/integration.scm 209 */
      {		/* Globalize/integration.scm 210 */
	 bool_t test_2108;
	 {	/* Globalize/integration.scm 210 */
	    sfun_ginfo_98_bglt obj_1664;
	    {	/* Globalize/integration.scm 210 */
	       value_bglt aux_2109;
	       {	/* Globalize/integration.scm 210 */
		  local_bglt obj_1663;
		  obj_1663 =
		     (local_bglt) (local_10);
		  aux_2109 =
		     (((local_bglt) CREF(obj_1663))->value);
	       }
	       obj_1664 =
		  (sfun_ginfo_98_bglt) (aux_2109);
	    }
	    {
	       obj_t aux_2113;
	       {	/* ./Globalize/ginfo.scm 943 */
		  object_bglt aux_2114;
		  aux_2114 =
		     (object_bglt) (obj_1664);
		  aux_2113 =
		     OBJECT_WIDENING(aux_2114);
	       }
	       test_2108 =
		  (((sfun_ginfo_98_bglt) CREF(aux_2113))->g__219);
	    }
	 }
	 if (test_2108)
	   {	/* Globalize/integration.scm 210 */
	      return local_10;
	   }
	 else
	   {	/* Globalize/integration.scm 212 */
	      sfun_ginfo_98_bglt obj_1666;
	      {		/* Globalize/integration.scm 212 */
		 value_bglt aux_2118;
		 {	/* Globalize/integration.scm 212 */
		    local_bglt obj_1665;
		    obj_1665 =
		       (local_bglt) (local_10);
		    aux_2118 =
		       (((local_bglt) CREF(obj_1665))->value);
		 }
		 obj_1666 =
		    (sfun_ginfo_98_bglt) (aux_2118);
	      }
	      {
		 obj_t aux_2122;
		 {	/* ./Globalize/ginfo.scm 955 */
		    object_bglt aux_2123;
		    aux_2123 =
		       (object_bglt) (obj_1666);
		    aux_2122 =
		       OBJECT_WIDENING(aux_2123);
		 }
		 return
		    (((sfun_ginfo_98_bglt) CREF(aux_2122))->integrator);
	      }
	   }
      }
   }
}



/* method-init */
obj_t 
method_init_76_globalize_integration()
{
   AN_OBJECT;
   {	/* Globalize/integration.scm 15 */
      return BUNSPEC;
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_globalize_integration()
{
   AN_OBJECT;
   {	/* Globalize/integration.scm 15 */
      module_initialization_70_tools_trace(((long) 0), "GLOBALIZE_INTEGRATION");
      module_initialization_70_tools_shape(((long) 0), "GLOBALIZE_INTEGRATION");
      module_initialization_70_type_type(((long) 0), "GLOBALIZE_INTEGRATION");
      module_initialization_70_ast_var(((long) 0), "GLOBALIZE_INTEGRATION");
      module_initialization_70_ast_node(((long) 0), "GLOBALIZE_INTEGRATION");
      module_initialization_70_globalize_ginfo(((long) 0), "GLOBALIZE_INTEGRATION");
      module_initialization_70_globalize_globalize(((long) 0), "GLOBALIZE_INTEGRATION");
      return
	 module_initialization_70_globalize_kapture(((long) 0), "GLOBALIZE_INTEGRATION");
   }
}
