/*===========================================================================*/
/*   (Globalize/kapture.scm)                                                 */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;

typedef struct sfun_ginfo_98
  {
     bool_t g__219;
     obj_t cfrom;
     obj_t cfrom__119;
     obj_t cto;
     obj_t cto__14;
     obj_t cfunction;
     obj_t integrator;
     obj_t integrated;
     obj_t plugged_in_15;
     long mark;
     obj_t free_mark_81;
     obj_t the_global_201;
     obj_t kaptured;
     obj_t new_body_215;
     long bmark;
     long umark;
     obj_t free;
     obj_t bound;
  }
             *sfun_ginfo_98_bglt;

typedef struct svar_ginfo_131
  {
     bool_t kaptured__204;
     long free_mark_81;
     long mark;
     bool_t celled__113;
  }
              *svar_ginfo_131_bglt;

typedef struct sexit_ginfo_81
  {
     bool_t g__219;
     bool_t kaptured__204;
     long free_mark_81;
     long mark;
  }
              *sexit_ginfo_81_bglt;

typedef struct local_ginfo_108
  {
     bool_t escape__117;
  }
               *local_ginfo_108_bglt;

typedef struct global_ginfo_75
  {
     bool_t escape__117;
     obj_t global_closure_229;
  }
               *global_ginfo_75_bglt;


static obj_t method_init_76_globalize_kapture();
extern obj_t set_kaptured__104_globalize_kapture(obj_t);
extern obj_t cto_transitive_closure__123_globalize_clocto(local_bglt);
extern bool_t is_a__118___object(obj_t, obj_t);
static obj_t set_one_kaptured__205_globalize_kapture(local_bglt, obj_t);
extern obj_t module_initialization_70_globalize_kapture(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_speek(long, char *);
extern obj_t module_initialization_70_tools_args(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_ast_sexp(long, char *);
extern obj_t module_initialization_70_ast_local(long, char *);
extern obj_t module_initialization_70_globalize_ginfo(long, char *);
extern obj_t module_initialization_70_globalize_node(long, char *);
extern obj_t module_initialization_70_globalize_free(long, char *);
extern obj_t module_initialization_70_globalize_clocto(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t union_3_globalize_kapture(obj_t);
extern obj_t fun_ast_var;
static obj_t imported_modules_init_94_globalize_kapture();
extern obj_t append_2_18___r4_pairs_and_lists_6_3(obj_t, obj_t);
static obj_t library_modules_init_112_globalize_kapture();
static long _union_round__11_globalize_kapture;
static obj_t toplevel_init_63_globalize_kapture();
extern obj_t create_vector(long);
static obj_t _set_kaptured__95_globalize_kapture(obj_t, obj_t);
extern obj_t get_free_vars_244_globalize_free(node_bglt, local_bglt);
extern obj_t local_ast_var;
static obj_t _union_globalize_kapture(obj_t, obj_t);
extern obj_t free_from_222_globalize_free(obj_t, local_bglt);
static obj_t require_initialization_114_globalize_kapture = BUNSPEC;
static obj_t *__cnst;

DEFINE_EXPORT_PROCEDURE(union_env_221_globalize_kapture, _union_globalize_kapture1716, _union_globalize_kapture, 0L, 1);
DEFINE_EXPORT_PROCEDURE(set_kaptured__env_5_globalize_kapture, _set_kaptured__95_globalize_kapture1717, _set_kaptured__95_globalize_kapture, 0L, 1);



/* module-initialization */
obj_t 
module_initialization_70_globalize_kapture(long checksum_1694, char *from_1695)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_globalize_kapture))
	{
	   require_initialization_114_globalize_kapture =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_globalize_kapture();
	   imported_modules_init_94_globalize_kapture();
	   method_init_76_globalize_kapture();
	   toplevel_init_63_globalize_kapture();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_globalize_kapture()
{
   AN_OBJECT;
   {	/* Globalize/kapture.scm 14 */
      module_initialization_70___object(((long) 0), "GLOBALIZE_KAPTURE");
      module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "GLOBALIZE_KAPTURE");
      return BUNSPEC;
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_globalize_kapture()
{
   AN_OBJECT;
   {	/* Globalize/kapture.scm 14 */
      return (
	 _union_round__11_globalize_kapture = ((long) 0), BUNSPEC);
   }
}



/* set-kaptured! */
obj_t 
set_kaptured__104_globalize_kapture(obj_t local__0_1)
{
   AN_OBJECT;
   {	/* Globalize/kapture.scm 35 */
      {
	 obj_t l1554_998;
	 l1554_998 = local__0_1;
       lname1555_999:
	 if (
	    PAIRP(l1554_998))
	   {	/* Globalize/kapture.scm 38 */
	      {		/* Globalize/kapture.scm 39 */
		 local_bglt aux_1707;
		 {	/* Globalize/kapture.scm 39 */
		    obj_t aux_1708;
		    aux_1708 =
		       CAR(l1554_998);
		    aux_1707 =
		       (local_bglt) (aux_1708);
		 }
		 cto_transitive_closure__123_globalize_clocto(aux_1707);
	      }
	      {
		 obj_t l1554_1712;
		 l1554_1712 =
		    CDR(l1554_998);
		 l1554_998 = l1554_1712;
		 goto lname1555_999;
	      }
	   }
	 else
	   {	/* Globalize/kapture.scm 38 */
	      ((bool_t) 1);
	   }
      }
      {
	 obj_t l1556_1003;
	 {	/* Globalize/kapture.scm 42 */
	    bool_t aux_1714;
	    l1556_1003 = local__0_1;
	  lname1557_1004:
	    if (
	       PAIRP(l1556_1003))
	      {		/* Globalize/kapture.scm 42 */
		 {	/* Globalize/kapture.scm 43 */
		    obj_t local_1006;
		    local_1006 =
		       CAR(l1556_1003);
		    set_one_kaptured__205_globalize_kapture(
		       (local_bglt) (local_1006), local_1006);
		 }
		 {
		    obj_t l1556_1720;
		    l1556_1720 =
		       CDR(l1556_1003);
		    l1556_1003 = l1556_1720;
		    goto lname1557_1004;
		 }
	      }
	    else
	      {		/* Globalize/kapture.scm 42 */
		 aux_1714 = ((bool_t) 1);
	      }
	    return
	       BBOOL(aux_1714);
	 }
      }
   }
}



/* _set-kaptured! */
obj_t 
_set_kaptured__95_globalize_kapture(obj_t env_1690, obj_t local__0_1691)
{
   AN_OBJECT;
   {	/* Globalize/kapture.scm 35 */
      return
	 set_kaptured__104_globalize_kapture(local__0_1691);
   }
}



/* set-one-kaptured! */
obj_t 
set_one_kaptured__205_globalize_kapture(local_bglt local_2, obj_t locking_3)
{
   AN_OBJECT;
   {	/* Globalize/kapture.scm 52 */
      {		/* Globalize/kapture.scm 56 */
	 value_bglt info_1008;
	 info_1008 =
	    (((local_bglt) CREF(local_2))->value);
	 {	/* Globalize/kapture.scm 56 */
	    obj_t kaptured_1009;
	    {	/* Globalize/kapture.scm 57 */
	       sfun_ginfo_98_bglt obj_1485;
	       obj_1485 =
		  (sfun_ginfo_98_bglt) (info_1008);
	       {
		  obj_t aux_1726;
		  {	/* ./Globalize/ginfo.scm 1153 */
		     object_bglt aux_1727;
		     aux_1727 =
			(object_bglt) (obj_1485);
		     aux_1726 =
			OBJECT_WIDENING(aux_1727);
		  }
		  kaptured_1009 =
		     (((sfun_ginfo_98_bglt) CREF(aux_1726))->kaptured);
	       }
	    }
	    {	/* Globalize/kapture.scm 57 */

	       {	/* Globalize/kapture.scm 59 */
		  bool_t test_1731;
		  if (
		     PAIRP(kaptured_1009))
		    {	/* Globalize/kapture.scm 59 */
		       test_1731 = ((bool_t) 1)
			  ;
		    }
		  else
		    {	/* Globalize/kapture.scm 59 */
		       test_1731 =
			  NULLP(kaptured_1009)
			  ;
		    }
		  if (test_1731)
		    {	/* Globalize/kapture.scm 59 */
		       {	/* Globalize/kapture.scm 62 */
			  obj_t v1558_1011;
			  v1558_1011 =
			     create_vector(((long) 3));
			  VECTOR_SET(v1558_1011, ((long) 2), kaptured_1009);
			  VECTOR_SET(v1558_1011, ((long) 1), locking_3);
			  VECTOR_SET(v1558_1011, ((long) 0), BTRUE);
			  return v1558_1011;
		       }
		    }
		  else
		    {	/* Globalize/kapture.scm 63 */
		       bool_t test1569_1012;
		       test1569_1012 =
			  is_a__118___object(kaptured_1009, local_ast_var);
		       if (test1569_1012)
			 {	/* Globalize/kapture.scm 63 */
			    {	/* Globalize/kapture.scm 66 */
			       obj_t v1559_1013;
			       v1559_1013 =
				  create_vector(((long) 3));
			       VECTOR_SET(v1559_1013, ((long) 2), BNIL);
			       VECTOR_SET(v1559_1013, ((long) 1), locking_3);
			       VECTOR_SET(v1559_1013, ((long) 0), BFALSE);
			       return v1559_1013;
			    }
			 }
		       else
			 {	/* Globalize/kapture.scm 63 */
			    {	/* Globalize/kapture.scm 70 */
			       obj_t new_body_215_1014;
			       {	/* Globalize/kapture.scm 70 */
				  sfun_ginfo_98_bglt obj_1507;
				  obj_1507 =
				     (sfun_ginfo_98_bglt) (info_1008);
				  {
				     obj_t aux_1746;
				     {	/* ./Globalize/ginfo.scm 1155 */
					object_bglt aux_1747;
					aux_1747 =
					   (object_bglt) (obj_1507);
					aux_1746 =
					   OBJECT_WIDENING(aux_1747);
				     }
				     new_body_215_1014 =
					(((sfun_ginfo_98_bglt) CREF(aux_1746))->new_body_215);
				  }
			       }
			       {	/* Globalize/kapture.scm 72 */
				  sfun_ginfo_98_bglt obj_1508;
				  obj_t val1460_1509;
				  obj_1508 =
				     (sfun_ginfo_98_bglt) (info_1008);
				  val1460_1509 =
				     (obj_t) (local_2);
				  {
				     obj_t aux_1753;
				     {	/* ./Globalize/ginfo.scm 1153 */
					object_bglt aux_1754;
					aux_1754 =
					   (object_bglt) (obj_1508);
					aux_1753 =
					   OBJECT_WIDENING(aux_1754);
				     }
				     ((((sfun_ginfo_98_bglt) CREF(aux_1753))->kaptured) = ((obj_t) val1460_1509), BUNSPEC);
				  }
			       }
			       {
				  obj_t kaptured_1015;
				  obj_t cto_1016;
				  bool_t setter__165_1017;
				  kaptured_1015 = BNIL;
				  {	/* Globalize/kapture.scm 75 */
				     obj_t aux_1858;
				     obj_t aux_1851;
				     {	/* Globalize/kapture.scm 76 */
					sfun_ginfo_98_bglt obj_1511;
					obj_1511 =
					   (sfun_ginfo_98_bglt) (info_1008);
					{
					   obj_t aux_1860;
					   {	/* ./Globalize/ginfo.scm 1139 */
					      object_bglt aux_1861;
					      aux_1861 =
						 (object_bglt) (obj_1511);
					      aux_1860 =
						 OBJECT_WIDENING(aux_1861);
					   }
					   aux_1858 =
					      (((sfun_ginfo_98_bglt) CREF(aux_1860))->cfunction);
					}
				     }
				     {	/* Globalize/kapture.scm 75 */
					sfun_ginfo_98_bglt obj_1510;
					obj_1510 =
					   (sfun_ginfo_98_bglt) (info_1008);
					{
					   obj_t aux_1853;
					   {	/* ./Globalize/ginfo.scm 1137 */
					      object_bglt aux_1854;
					      aux_1854 =
						 (object_bglt) (obj_1510);
					      aux_1853 =
						 OBJECT_WIDENING(aux_1854);
					   }
					   aux_1851 =
					      (((sfun_ginfo_98_bglt) CREF(aux_1853))->cto__14);
					}
				     }
				     cto_1016 =
					append_2_18___r4_pairs_and_lists_6_3(aux_1851, aux_1858);
				  }
				  setter__165_1017 = ((bool_t) 1);
				loop_1018:
				  if (
				     NULLP(cto_1016))
				    {	/* Globalize/kapture.scm 84 */
				       {	/* Globalize/kapture.scm 85 */
					  obj_t free_1024;
					  free_1024 =
					     get_free_vars_244_globalize_free(
					     (node_bglt) (new_body_215_1014), local_2);
					  {	/* Globalize/kapture.scm 85 */
					     obj_t fkaptured_1025;
					     fkaptured_1025 =
						free_from_222_globalize_free(kaptured_1015, local_2);
					     {	/* Globalize/kapture.scm 86 */
						obj_t kaptured_1026;
						{	/* Globalize/kapture.scm 87 */
						   obj_t arg1581_1034;
						   arg1581_1034 =
						      MAKE_PAIR(free_1024, fkaptured_1025);
						   kaptured_1026 =
						      union_3_globalize_kapture(arg1581_1034);
						}
						{	/* Globalize/kapture.scm 87 */

						   if (setter__165_1017)
						     {	/* Globalize/kapture.scm 94 */
							{	/* Globalize/kapture.scm 97 */
							   sfun_ginfo_98_bglt obj_1515;
							   obj_1515 =
							      (sfun_ginfo_98_bglt) (info_1008);
							   {
							      obj_t aux_1767;
							      {		/* ./Globalize/ginfo.scm 1153 */
								 object_bglt aux_1768;
								 aux_1768 =
								    (object_bglt) (obj_1515);
								 aux_1767 =
								    OBJECT_WIDENING(aux_1768);
							      }
							      ((((sfun_ginfo_98_bglt) CREF(aux_1767))->kaptured) = ((obj_t) kaptured_1026), BUNSPEC);
							   }
							}
							{
							   obj_t l1560_1027;
							   {	/* Globalize/kapture.scm 99 */
							      bool_t aux_1772;
							      l1560_1027 = kaptured_1026;
							    lname1561_1028:
							      if (
								 PAIRP(l1560_1027))
								{	/* Globalize/kapture.scm 99 */
								   {	/* Globalize/kapture.scm 100 */
								      svar_ginfo_131_bglt obj_1520;
								      {		/* Globalize/kapture.scm 100 */
									 value_bglt aux_1775;
									 {	/* Globalize/kapture.scm 101 */
									    local_bglt obj_1519;
									    {	/* Globalize/kapture.scm 101 */
									       obj_t aux_1776;
									       aux_1776 =
										  CAR(l1560_1027);
									       obj_1519 =
										  (local_bglt) (aux_1776);
									    }
									    aux_1775 =
									       (((local_bglt) CREF(obj_1519))->value);
									 }
									 obj_1520 =
									    (svar_ginfo_131_bglt) (aux_1775);
								      }
								      {
									 obj_t aux_1781;
									 {	/* ./Globalize/ginfo.scm 1167 */
									    object_bglt aux_1782;
									    aux_1782 =
									       (object_bglt) (obj_1520);
									    aux_1781 =
									       OBJECT_WIDENING(aux_1782);
									 }
									 ((((svar_ginfo_131_bglt) CREF(aux_1781))->kaptured__204) = ((bool_t) ((bool_t) 1)), BUNSPEC);
								      }
								   }
								   {
								      obj_t l1560_1786;
								      l1560_1786 =
									 CDR(l1560_1027);
								      l1560_1027 = l1560_1786;
								      goto lname1561_1028;
								   }
								}
							      else
								{	/* Globalize/kapture.scm 99 */
								   aux_1772 = ((bool_t) 1);
								}
							      BBOOL(aux_1772);
							   }
							}
						     }
						   else
						     {	/* Globalize/kapture.scm 103 */
							sfun_ginfo_98_bglt obj_1523;
							obj_t val1460_1524;
							obj_1523 =
							   (sfun_ginfo_98_bglt) (info_1008);
							val1460_1524 = BFALSE;
							{
							   obj_t aux_1790;
							   {	/* ./Globalize/ginfo.scm 1153 */
							      object_bglt aux_1791;
							      aux_1791 =
								 (object_bglt) (obj_1523);
							      aux_1790 =
								 OBJECT_WIDENING(aux_1791);
							   }
							   ((((sfun_ginfo_98_bglt) CREF(aux_1790))->kaptured) = ((obj_t) val1460_1524), BUNSPEC);
							}
						     }
						   {	/* Globalize/kapture.scm 104 */
						      obj_t v1562_1033;
						      v1562_1033 =
							 create_vector(((long) 3));
						      VECTOR_SET(v1562_1033, ((long) 2), kaptured_1026);
						      VECTOR_SET(v1562_1033, ((long) 1), locking_3);
						      {		/* ./Ieee/vector.scm 8468 */
							 obj_t aux_1798;
							 aux_1798 =
							    BBOOL(setter__165_1017);
							 VECTOR_SET(v1562_1033, ((long) 0), aux_1798);
						      }
						      return v1562_1033;
						   }
						}
					     }
					  }
				       }
				    }
				  else
				    {	/* Globalize/kapture.scm 105 */
				       bool_t test_1801;
				       {	/* ./Ieee/equiv.scm 5508 */
					  obj_t aux_1804;
					  obj_t aux_1802;
					  aux_1804 =
					     (obj_t) (local_2);
					  aux_1802 =
					     CAR(cto_1016);
					  test_1801 =
					     (aux_1802 == aux_1804);
				       }
				       if (test_1801)
					 {	/* Globalize/kapture.scm 105 */
					    {
					       obj_t cto_1807;
					       cto_1807 =
						  CDR(cto_1016);
					       cto_1016 = cto_1807;
					       goto loop_1018;
					    }
					 }
				       else
					 {	/* Globalize/kapture.scm 111 */
					    bool_t test_1809;
					    {	/* Globalize/kapture.scm 111 */
					       sfun_ginfo_98_bglt obj_1540;
					       {	/* Globalize/kapture.scm 111 */
						  value_bglt aux_1810;
						  {	/* Globalize/kapture.scm 111 */
						     local_bglt obj_1539;
						     {	/* Globalize/kapture.scm 111 */
							obj_t aux_1811;
							aux_1811 =
							   CAR(cto_1016);
							obj_1539 =
							   (local_bglt) (aux_1811);
						     }
						     aux_1810 =
							(((local_bglt) CREF(obj_1539))->value);
						  }
						  obj_1540 =
						     (sfun_ginfo_98_bglt) (aux_1810);
					       }
					       {
						  obj_t aux_1816;
						  {	/* ./Globalize/ginfo.scm 1129 */
						     object_bglt aux_1817;
						     aux_1817 =
							(object_bglt) (obj_1540);
						     aux_1816 =
							OBJECT_WIDENING(aux_1817);
						  }
						  test_1809 =
						     (((sfun_ginfo_98_bglt) CREF(aux_1816))->g__219);
					       }
					    }
					    if (test_1809)
					      {		/* Globalize/kapture.scm 111 */
						 {	/* Globalize/kapture.scm 114 */
						    obj_t other_kaptured_142_1038;
						    {	/* Globalize/kapture.scm 114 */
						       local_bglt aux_1821;
						       {	/* Globalize/kapture.scm 114 */
							  obj_t aux_1822;
							  aux_1822 =
							     CAR(cto_1016);
							  aux_1821 =
							     (local_bglt) (aux_1822);
						       }
						       other_kaptured_142_1038 =
							  set_one_kaptured__205_globalize_kapture(aux_1821, locking_3);
						    }
						    {	/* Globalize/kapture.scm 116 */
						       bool_t test_1826;
						       {	/* ./Ieee/vector.scm 8462 */
							  obj_t aux_1827;
							  aux_1827 =
							     VECTOR_REF(other_kaptured_142_1038, ((long) 0));
							  test_1826 =
							     CBOOL(aux_1827);
						       }
						       if (test_1826)
							 {	/* Globalize/kapture.scm 122 */
							    obj_t arg1586_1040;
							    obj_t arg1587_1041;
							    {	/* ./Ieee/pair-list.scm 5689 */
							       obj_t aux_1830;
							       aux_1830 =
								  VECTOR_REF(other_kaptured_142_1038, ((long) 2));
							       arg1586_1040 =
								  MAKE_PAIR(aux_1830, kaptured_1015);
							    }
							    arg1587_1041 =
							       CDR(cto_1016);
							    {
							       obj_t cto_1835;
							       obj_t kaptured_1834;
							       kaptured_1834 = arg1586_1040;
							       cto_1835 = arg1587_1041;
							       cto_1016 = cto_1835;
							       kaptured_1015 = kaptured_1834;
							       goto loop_1018;
							    }
							 }
						       else
							 {	/* Globalize/kapture.scm 117 */
							    obj_t arg1589_1043;
							    obj_t arg1590_1044;
							    bool_t arg1591_1045;
							    {	/* ./Ieee/pair-list.scm 5689 */
							       obj_t aux_1836;
							       aux_1836 =
								  VECTOR_REF(other_kaptured_142_1038, ((long) 2));
							       arg1589_1043 =
								  MAKE_PAIR(aux_1836, kaptured_1015);
							    }
							    arg1590_1044 =
							       CDR(cto_1016);
							    if (setter__165_1017)
							      {		/* ./Ieee/equiv.scm 5508 */
								 obj_t aux_1843;
								 obj_t aux_1841;
								 aux_1843 =
								    (obj_t) (local_2);
								 aux_1841 =
								    VECTOR_REF(other_kaptured_142_1038, ((long) 1));
								 arg1591_1045 =
								    (aux_1841 == aux_1843);
							      }
							    else
							      {		/* Globalize/kapture.scm 119 */
								 arg1591_1045 = ((bool_t) 0);
							      }
							    {
							       bool_t setter__165_1848;
							       obj_t cto_1847;
							       obj_t kaptured_1846;
							       kaptured_1846 = arg1589_1043;
							       cto_1847 = arg1590_1044;
							       setter__165_1848 = arg1591_1045;
							       setter__165_1017 = setter__165_1848;
							       cto_1016 = cto_1847;
							       kaptured_1015 = kaptured_1846;
							       goto loop_1018;
							    }
							 }
						    }
						 }
					      }
					    else
					      {		/* Globalize/kapture.scm 111 */
						 {
						    obj_t cto_1849;
						    cto_1849 =
						       CDR(cto_1016);
						    cto_1016 = cto_1849;
						    goto loop_1018;
						 }
					      }
					 }
				    }
			       }
			    }
			 }
		    }
	       }
	    }
	 }
      }
   }
}



/* union */
obj_t 
union_3_globalize_kapture(obj_t sets_4)
{
   AN_OBJECT;
   {	/* Globalize/kapture.scm 140 */
      {		/* Globalize/kapture.scm 141 */
	 long z2_1560;
	 z2_1560 = _union_round__11_globalize_kapture;
	 _union_round__11_globalize_kapture =
	    (((long) 1) + z2_1560);
      }
      {
	 obj_t sets_1055;
	 obj_t union_1056;
	 sets_1055 = sets_4;
	 union_1056 = BNIL;
       loop_1057:
	 if (
	    NULLP(sets_1055))
	   {	/* Globalize/kapture.scm 144 */
	      return union_1056;
	   }
	 else
	   {
	      obj_t set_1059;
	      obj_t union_1060;
	      set_1059 =
		 CAR(sets_1055);
	      union_1060 = union_1056;
	    liip_1061:
	      if (
		 NULLP(set_1059))
		{	/* Globalize/kapture.scm 149 */
		   {
		      obj_t union_1873;
		      obj_t sets_1871;
		      sets_1871 =
			 CDR(sets_1055);
		      union_1873 = union_1060;
		      union_1056 = union_1873;
		      sets_1055 = sets_1871;
		      goto loop_1057;
		   }
		}
	      else
		{	/* Globalize/kapture.scm 152 */
		   bool_t test1604_1065;
		   {	/* ./Ast/var.scm 790 */
		      obj_t aux_1874;
		      {		/* Globalize/kapture.scm 152 */
			 value_bglt aux_1875;
			 {	/* Globalize/kapture.scm 152 */
			    local_bglt obj_1566;
			    {	/* Globalize/kapture.scm 152 */
			       obj_t aux_1876;
			       aux_1876 =
				  CAR(set_1059);
			       obj_1566 =
				  (local_bglt) (aux_1876);
			    }
			    aux_1875 =
			       (((local_bglt) CREF(obj_1566))->value);
			 }
			 aux_1874 =
			    (obj_t) (aux_1875);
		      }
		      test1604_1065 =
			 is_a__118___object(aux_1874, fun_ast_var);
		   }
		   if (test1604_1065)
		     {	/* Globalize/kapture.scm 152 */
			{	/* Globalize/kapture.scm 153 */
			   bool_t test1605_1066;
			   {	/* Globalize/kapture.scm 153 */
			      obj_t obj1_1571;
			      obj_t obj2_1572;
			      {		/* Globalize/kapture.scm 153 */
				 long aux_1883;
				 {	/* Globalize/kapture.scm 153 */
				    sfun_ginfo_98_bglt obj_1570;
				    {	/* Globalize/kapture.scm 153 */
				       value_bglt aux_1884;
				       {	/* Globalize/kapture.scm 153 */
					  local_bglt obj_1569;
					  {	/* Globalize/kapture.scm 153 */
					     obj_t aux_1885;
					     aux_1885 =
						CAR(set_1059);
					     obj_1569 =
						(local_bglt) (aux_1885);
					  }
					  aux_1884 =
					     (((local_bglt) CREF(obj_1569))->value);
				       }
				       obj_1570 =
					  (sfun_ginfo_98_bglt) (aux_1884);
				    }
				    {
				       obj_t aux_1890;
				       {	/* ./Globalize/ginfo.scm 1159 */
					  object_bglt aux_1891;
					  aux_1891 =
					     (object_bglt) (obj_1570);
					  aux_1890 =
					     OBJECT_WIDENING(aux_1891);
				       }
				       aux_1883 =
					  (((sfun_ginfo_98_bglt) CREF(aux_1890))->umark);
				    }
				 }
				 obj1_1571 =
				    BINT(aux_1883);
			      }
			      obj2_1572 =
				 BINT(_union_round__11_globalize_kapture);
			      test1605_1066 =
				 (obj1_1571 == obj2_1572);
			   }
			   if (test1605_1066)
			     {
				obj_t set_1899;
				set_1899 =
				   CDR(set_1059);
				set_1059 = set_1899;
				goto liip_1061;
			     }
			   else
			     {	/* Globalize/kapture.scm 153 */
				{	/* Globalize/kapture.scm 157 */
				   sfun_ginfo_98_bglt obj_1576;
				   long val1463_1577;
				   {	/* Globalize/kapture.scm 157 */
				      value_bglt aux_1901;
				      {		/* Globalize/kapture.scm 157 */
					 local_bglt obj_1575;
					 {	/* Globalize/kapture.scm 157 */
					    obj_t aux_1902;
					    aux_1902 =
					       CAR(set_1059);
					    obj_1575 =
					       (local_bglt) (aux_1902);
					 }
					 aux_1901 =
					    (((local_bglt) CREF(obj_1575))->value);
				      }
				      obj_1576 =
					 (sfun_ginfo_98_bglt) (aux_1901);
				   }
				   val1463_1577 = _union_round__11_globalize_kapture;
				   {
				      obj_t aux_1907;
				      {		/* ./Globalize/ginfo.scm 1159 */
					 object_bglt aux_1908;
					 aux_1908 =
					    (object_bglt) (obj_1576);
					 aux_1907 =
					    OBJECT_WIDENING(aux_1908);
				      }
				      ((((sfun_ginfo_98_bglt) CREF(aux_1907))->umark) = ((long) val1463_1577), BUNSPEC);
				   }
				}
				{	/* Globalize/kapture.scm 159 */
				   obj_t arg1609_1070;
				   obj_t arg1610_1071;
				   arg1609_1070 =
				      CDR(set_1059);
				   {	/* ./Ieee/pair-list.scm 5689 */
				      obj_t aux_1913;
				      aux_1913 =
					 CAR(set_1059);
				      arg1610_1071 =
					 MAKE_PAIR(aux_1913, union_1060);
				   }
				   {
				      obj_t union_1917;
				      obj_t set_1916;
				      set_1916 = arg1609_1070;
				      union_1917 = arg1610_1071;
				      union_1060 = union_1917;
				      set_1059 = set_1916;
				      goto liip_1061;
				   }
				}
			     }
			}
		     }
		   else
		     {	/* Globalize/kapture.scm 161 */
			bool_t test1615_1076;
			{	/* Globalize/kapture.scm 161 */
			   obj_t obj1_1585;
			   obj_t obj2_1586;
			   {	/* Globalize/kapture.scm 161 */
			      long aux_1918;
			      {		/* Globalize/kapture.scm 161 */
				 svar_ginfo_131_bglt obj_1584;
				 {	/* Globalize/kapture.scm 161 */
				    value_bglt aux_1919;
				    {	/* Globalize/kapture.scm 161 */
				       local_bglt obj_1583;
				       {	/* Globalize/kapture.scm 161 */
					  obj_t aux_1920;
					  aux_1920 =
					     CAR(set_1059);
					  obj_1583 =
					     (local_bglt) (aux_1920);
				       }
				       aux_1919 =
					  (((local_bglt) CREF(obj_1583))->value);
				    }
				    obj_1584 =
				       (svar_ginfo_131_bglt) (aux_1919);
				 }
				 {
				    obj_t aux_1925;
				    {	/* ./Globalize/ginfo.scm 1171 */
				       object_bglt aux_1926;
				       aux_1926 =
					  (object_bglt) (obj_1584);
				       aux_1925 =
					  OBJECT_WIDENING(aux_1926);
				    }
				    aux_1918 =
				       (((svar_ginfo_131_bglt) CREF(aux_1925))->mark);
				 }
			      }
			      obj1_1585 =
				 BINT(aux_1918);
			   }
			   obj2_1586 =
			      BINT(_union_round__11_globalize_kapture);
			   test1615_1076 =
			      (obj1_1585 == obj2_1586);
			}
			if (test1615_1076)
			  {	/* Globalize/kapture.scm 161 */
			     {
				obj_t set_1934;
				set_1934 =
				   CDR(set_1059);
				set_1059 = set_1934;
				goto liip_1061;
			     }
			  }
			else
			  {	/* Globalize/kapture.scm 161 */
			     {	/* Globalize/kapture.scm 164 */
				svar_ginfo_131_bglt obj_1590;
				long val1492_1591;
				{	/* Globalize/kapture.scm 164 */
				   value_bglt aux_1936;
				   {	/* Globalize/kapture.scm 164 */
				      local_bglt obj_1589;
				      {		/* Globalize/kapture.scm 164 */
					 obj_t aux_1937;
					 aux_1937 =
					    CAR(set_1059);
					 obj_1589 =
					    (local_bglt) (aux_1937);
				      }
				      aux_1936 =
					 (((local_bglt) CREF(obj_1589))->value);
				   }
				   obj_1590 =
				      (svar_ginfo_131_bglt) (aux_1936);
				}
				val1492_1591 = _union_round__11_globalize_kapture;
				{
				   obj_t aux_1942;
				   {	/* ./Globalize/ginfo.scm 1171 */
				      object_bglt aux_1943;
				      aux_1943 =
					 (object_bglt) (obj_1590);
				      aux_1942 =
					 OBJECT_WIDENING(aux_1943);
				   }
				   ((((svar_ginfo_131_bglt) CREF(aux_1942))->mark) = ((long) val1492_1591), BUNSPEC);
				}
			     }
			     {	/* Globalize/kapture.scm 165 */
				obj_t arg1619_1080;
				obj_t arg1620_1081;
				arg1619_1080 =
				   CDR(set_1059);
				{	/* ./Ieee/pair-list.scm 5689 */
				   obj_t aux_1948;
				   aux_1948 =
				      CAR(set_1059);
				   arg1620_1081 =
				      MAKE_PAIR(aux_1948, union_1060);
				}
				{
				   obj_t union_1952;
				   obj_t set_1951;
				   set_1951 = arg1619_1080;
				   union_1952 = arg1620_1081;
				   union_1060 = union_1952;
				   set_1059 = set_1951;
				   goto liip_1061;
				}
			     }
			  }
		     }
		}
	   }
      }
   }
}



/* _union */
obj_t 
_union_globalize_kapture(obj_t env_1692, obj_t sets_1693)
{
   AN_OBJECT;
   {	/* Globalize/kapture.scm 140 */
      return
	 union_3_globalize_kapture(sets_1693);
   }
}



/* method-init */
obj_t 
method_init_76_globalize_kapture()
{
   AN_OBJECT;
   {	/* Globalize/kapture.scm 14 */
      return BUNSPEC;
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_globalize_kapture()
{
   AN_OBJECT;
   {	/* Globalize/kapture.scm 14 */
      module_initialization_70_tools_trace(((long) 0), "GLOBALIZE_KAPTURE");
      module_initialization_70_tools_shape(((long) 0), "GLOBALIZE_KAPTURE");
      module_initialization_70_tools_speek(((long) 0), "GLOBALIZE_KAPTURE");
      module_initialization_70_tools_args(((long) 0), "GLOBALIZE_KAPTURE");
      module_initialization_70_type_type(((long) 0), "GLOBALIZE_KAPTURE");
      module_initialization_70_type_cache(((long) 0), "GLOBALIZE_KAPTURE");
      module_initialization_70_ast_var(((long) 0), "GLOBALIZE_KAPTURE");
      module_initialization_70_ast_node(((long) 0), "GLOBALIZE_KAPTURE");
      module_initialization_70_ast_sexp(((long) 0), "GLOBALIZE_KAPTURE");
      module_initialization_70_ast_local(((long) 0), "GLOBALIZE_KAPTURE");
      module_initialization_70_globalize_ginfo(((long) 0), "GLOBALIZE_KAPTURE");
      module_initialization_70_globalize_node(((long) 0), "GLOBALIZE_KAPTURE");
      module_initialization_70_globalize_free(((long) 0), "GLOBALIZE_KAPTURE");
      return
	 module_initialization_70_globalize_clocto(((long) 0), "GLOBALIZE_KAPTURE");
   }
}
