/*===========================================================================*/
/*   (Globalize/loc2glo.scm)                                                 */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct ccomp
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t producer;
     obj_t consumer;
     obj_t finalizer;
     obj_t checksummer;
  }
     *ccomp_bglt;

typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;

typedef struct sfun_ginfo_98
  {
     bool_t g__219;
     obj_t cfrom;
     obj_t cfrom__119;
     obj_t cto;
     obj_t cto__14;
     obj_t cfunction;
     obj_t integrator;
     obj_t integrated;
     obj_t plugged_in_15;
     long mark;
     obj_t free_mark_81;
     obj_t the_global_201;
     obj_t kaptured;
     obj_t new_body_215;
     long bmark;
     long umark;
     obj_t free;
     obj_t bound;
  }
             *sfun_ginfo_98_bglt;

typedef struct svar_ginfo_131
  {
     bool_t kaptured__204;
     long free_mark_81;
     long mark;
     bool_t celled__113;
  }
              *svar_ginfo_131_bglt;

typedef struct sexit_ginfo_81
  {
     bool_t g__219;
     bool_t kaptured__204;
     long free_mark_81;
     long mark;
  }
              *sexit_ginfo_81_bglt;

typedef struct local_ginfo_108
  {
     bool_t escape__117;
  }
               *local_ginfo_108_bglt;

typedef struct global_ginfo_75
  {
     bool_t escape__117;
     obj_t global_closure_229;
  }
               *global_ginfo_75_bglt;


extern obj_t local_ginfo_108_globalize_ginfo;
static obj_t method_init_76_globalize_local__global_194();
extern obj_t find_global_module_25_ast_env(obj_t, obj_t);
static obj_t _the_global1922_161_globalize_local__global_194(obj_t, obj_t);
extern obj_t symbol_append_197___r4_symbols_6_4(obj_t);
extern obj_t _optim__89_engine_param;
extern obj_t the_closure_238_globalize_free(variable_bglt, obj_t);
extern obj_t let_var_6_ast_node;
extern obj_t var_ast_node;
static obj_t _local__global1921_115_globalize_local__global_194(obj_t, obj_t);
extern obj_t global_ast_var;
extern obj_t gensym___r4_symbols_6_4;
extern obj_t _obj__252_type_cache;
extern obj_t reverse___r4_pairs_and_lists_6_3(obj_t);
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t module_initialization_70_globalize_local__global_194(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_args(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_module_module(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_ast_local(long, char *);
extern obj_t module_initialization_70_ast_glo_def_117(long, char *);
extern obj_t module_initialization_70_ast_sexp(long, char *);
extern obj_t module_initialization_70_ast_env(long, char *);
extern obj_t module_initialization_70_globalize_ginfo(long, char *);
extern obj_t module_initialization_70_globalize_node(long, char *);
extern obj_t module_initialization_70_globalize_free(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_symbols_6_4(long, char *);
extern long list_length(obj_t);
extern local_bglt make_local_svar_140_ast_local(obj_t, type_bglt);
extern long class_num_218___object(obj_t);
extern global_bglt local__global_40_globalize_local__global_194(local_bglt);
extern obj_t let_fun_218_ast_node;
extern node_bglt node_globalize__229_globalize_node(node_bglt, variable_bglt, obj_t);
static obj_t imported_modules_init_94_globalize_local__global_194();
extern obj_t sfun_ginfo_98_globalize_ginfo;
extern obj_t app_ast_node;
extern obj_t append_2_18___r4_pairs_and_lists_6_3(obj_t, obj_t);
static global_bglt fix_non_escaping_definition_247_globalize_local__global_194(global_bglt, local_bglt, obj_t, obj_t, obj_t);
static obj_t library_modules_init_112_globalize_local__global_194();
extern obj_t global_ginfo_75_globalize_ginfo;
extern obj_t svar_ginfo_131_globalize_ginfo;
extern node_bglt sexp__node_235_ast_sexp(obj_t, obj_t, obj_t, obj_t);
extern obj_t open_input_string(obj_t);
extern obj_t sfun_ast_var;
extern global_bglt the_global_201_globalize_local__global_194(local_bglt);
extern global_bglt def_global_sfun_no_warning__10_ast_glo_def_117(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t __arity_132_tools_args(obj_t, obj_t);
extern obj_t _module__166_module_module;
extern obj_t _procedure__226_type_cache;
static node_bglt make_escaping_body_209_globalize_local__global_194(local_bglt, global_bglt, obj_t, obj_t, local_bglt, node_bglt);
static global_bglt fix_escaping_definition_56_globalize_local__global_194(global_bglt, local_bglt, obj_t, obj_t, obj_t);
extern obj_t read___reader(obj_t);
extern obj_t ____74_type_cache;
static obj_t require_initialization_114_globalize_local__global_194 = BUNSPEC;
static obj_t cnst_init_137_globalize_local__global_194();
extern obj_t reverse__39___r4_pairs_and_lists_6_3(obj_t);
static obj_t default_type_190_globalize_local__global_194();
static obj_t __cnst[7];

DEFINE_EXPORT_PROCEDURE(local__global_env_170_globalize_local__global_194, _local__global1921_115_globalize_local__global_1941928, _local__global1921_115_globalize_local__global_194, 0L, 1);
DEFINE_EXPORT_PROCEDURE(the_global_env_148_globalize_local__global_194, _the_global1922_161_globalize_local__global_1941929, _the_global1922_161_globalize_local__global_194, 0L, 1);
DEFINE_STRING(string1923_globalize_local__global_194, string1923_globalize_local__global_1941930, "NOW SFUN STATIC _ VALUE PROCEDURE-REF ENV ", 42);



/* module-initialization */
obj_t 
module_initialization_70_globalize_local__global_194(long checksum_2313, char *from_2314)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_globalize_local__global_194))
	{
	   require_initialization_114_globalize_local__global_194 =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_globalize_local__global_194();
	   cnst_init_137_globalize_local__global_194();
	   imported_modules_init_94_globalize_local__global_194();
	   method_init_76_globalize_local__global_194();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_globalize_local__global_194()
{
   AN_OBJECT;
   {	/* Globalize/loc2glo.scm 14 */
      module_initialization_70___r4_symbols_6_4(((long) 0), "GLOBALIZE_LOCAL->GLOBAL");
      module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "GLOBALIZE_LOCAL->GLOBAL");
      module_initialization_70___object(((long) 0), "GLOBALIZE_LOCAL->GLOBAL");
      module_initialization_70___reader(((long) 0), "GLOBALIZE_LOCAL->GLOBAL");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_globalize_local__global_194()
{
   AN_OBJECT;
   {	/* Globalize/loc2glo.scm 14 */
      {		/* Globalize/loc2glo.scm 14 */
	 obj_t cnst_port_138_2306;
	 cnst_port_138_2306 =
	    open_input_string(string1923_globalize_local__global_194);
	 {
	    long i_2307;
	    i_2307 = ((long) 6);
	  loop_2308:
	    {	/* Globalize/loc2glo.scm 14 */
	       bool_t test1924_2309;
	       test1924_2309 =
		  (i_2307 == ((long) -1));
	       if (test1924_2309)
		 {	/* Globalize/loc2glo.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Globalize/loc2glo.scm 14 */
		    {	/* Globalize/loc2glo.scm 14 */
		       obj_t arg1925_2310;
		       {	/* Globalize/loc2glo.scm 14 */
			  obj_t list1926_2311;
			  list1926_2311 =
			     MAKE_PAIR(cnst_port_138_2306, BNIL);
			  arg1925_2310 =
			     read___reader(list1926_2311);
		       }
		       CNST_TABLE_SET(i_2307, arg1925_2310);
		    }
		    {	/* Globalize/loc2glo.scm 14 */
		       int aux_2312;
		       {	/* Globalize/loc2glo.scm 14 */
			  long aux_2332;
			  aux_2332 =
			     (i_2307 - ((long) 1));
			  aux_2312 =
			     (int) (aux_2332);
		       }
		       {
			  long i_2335;
			  i_2335 =
			     (long) (aux_2312);
			  i_2307 = i_2335;
			  goto loop_2308;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* default-type */
obj_t 
default_type_190_globalize_local__global_194()
{
   AN_OBJECT;
   {	/* Globalize/loc2glo.scm 37 */
      {		/* Globalize/loc2glo.scm 38 */
	 bool_t test1615_1023;
	 {	/* Globalize/loc2glo.scm 38 */
	    long n1_1698;
	    n1_1698 =
	       (long) CINT(_optim__89_engine_param);
	    test1615_1023 =
	       (n1_1698 < ((long) 2));
	 }
	 if (test1615_1023)
	   {	/* Globalize/loc2glo.scm 38 */
	      return _obj__252_type_cache;
	   }
	 else
	   {	/* Globalize/loc2glo.scm 38 */
	      return ____74_type_cache;
	   }
      }
   }
}



/* local->global */
global_bglt 
local__global_40_globalize_local__global_194(local_bglt local_1)
{
   AN_OBJECT;
   {	/* Globalize/loc2glo.scm 43 */
      {		/* Globalize/loc2glo.scm 45 */
	 global_bglt global_1024;
	 global_1024 =
	    the_global_201_globalize_local__global_194(local_1);
	 {	/* Globalize/loc2glo.scm 45 */
	    obj_t args_1025;
	    {	/* Globalize/loc2glo.scm 46 */
	       sfun_bglt obj_1701;
	       {	/* Globalize/loc2glo.scm 46 */
		  value_bglt aux_2341;
		  aux_2341 =
		     (((local_bglt) CREF(local_1))->value);
		  obj_1701 =
		     (sfun_bglt) (aux_2341);
	       }
	       args_1025 =
		  (((sfun_bglt) CREF(obj_1701))->args);
	    }
	    {	/* Globalize/loc2glo.scm 46 */
	       value_bglt info_1026;
	       info_1026 =
		  (((local_bglt) CREF(local_1))->value);
	       {	/* Globalize/loc2glo.scm 47 */
		  obj_t new_body_215_1027;
		  {	/* Globalize/loc2glo.scm 48 */
		     sfun_ginfo_98_bglt obj_1703;
		     obj_1703 =
			(sfun_ginfo_98_bglt) (info_1026);
		     {
			obj_t aux_2347;
			{	/* ./Globalize/ginfo.scm 1522 */
			   object_bglt aux_2348;
			   aux_2348 =
			      (object_bglt) (obj_1703);
			   aux_2347 =
			      OBJECT_WIDENING(aux_2348);
			}
			new_body_215_1027 =
			   (((sfun_ginfo_98_bglt) CREF(aux_2347))->new_body_215);
		     }
		  }
		  {	/* Globalize/loc2glo.scm 48 */
		     obj_t kaptured_1028;
		     {	/* Globalize/loc2glo.scm 49 */
			sfun_ginfo_98_bglt obj_1704;
			obj_1704 =
			   (sfun_ginfo_98_bglt) (info_1026);
			{
			   obj_t aux_2353;
			   {	/* ./Globalize/ginfo.scm 1520 */
			      object_bglt aux_2354;
			      aux_2354 =
				 (object_bglt) (obj_1704);
			      aux_2353 =
				 OBJECT_WIDENING(aux_2354);
			   }
			   kaptured_1028 =
			      (((sfun_ginfo_98_bglt) CREF(aux_2353))->kaptured);
			}
		     }
		     {	/* Globalize/loc2glo.scm 49 */

			{	/* Globalize/loc2glo.scm 50 */
			   bool_t test_2358;
			   {	/* Globalize/loc2glo.scm 50 */
			      local_ginfo_108_bglt obj_1705;
			      obj_1705 =
				 (local_ginfo_108_bglt) (local_1);
			      {
				 obj_t aux_2360;
				 {	/* ./Globalize/ginfo.scm 1554 */
				    object_bglt aux_2361;
				    aux_2361 =
				       (object_bglt) (obj_1705);
				    aux_2360 =
				       OBJECT_WIDENING(aux_2361);
				 }
				 test_2358 =
				    (((local_ginfo_108_bglt) CREF(aux_2360))->escape__117);
			      }
			   }
			   if (test_2358)
			     {	/* Globalize/loc2glo.scm 50 */
				fix_escaping_definition_56_globalize_local__global_194(global_1024, local_1, args_1025, kaptured_1028, new_body_215_1027);
			     }
			   else
			     {	/* Globalize/loc2glo.scm 50 */
				fix_non_escaping_definition_247_globalize_local__global_194(global_1024, local_1, args_1025, kaptured_1028, new_body_215_1027);
			     }
			}
			return global_1024;
		     }
		  }
	       }
	    }
	 }
      }
   }
}



/* _local->global1921 */
obj_t 
_local__global1921_115_globalize_local__global_194(obj_t env_2302, obj_t local_2303)
{
   AN_OBJECT;
   {	/* Globalize/loc2glo.scm 43 */
      {		/* Globalize/loc2glo.scm 43 */
	 global_bglt aux_2367;
	 aux_2367 =
	    local__global_40_globalize_local__global_194(
	    (local_bglt) (local_2303));
	 return
	    (obj_t) (aux_2367);
      }
   }
}



/* fix-escaping-definition */
global_bglt 
fix_escaping_definition_56_globalize_local__global_194(global_bglt global_2, local_bglt local_3, obj_t args_4, obj_t kaptured_5, obj_t body_6)
{
   AN_OBJECT;
   {	/* Globalize/loc2glo.scm 59 */
      {		/* Globalize/loc2glo.scm 60 */
	 local_bglt env_1031;
	 env_1031 =
	    make_local_svar_140_ast_local(
	    CNST_TABLE_REF(((long) 0)),
	    (type_bglt) (_procedure__226_type_cache));
	 {	/* Globalize/loc2glo.scm 60 */
	    obj_t new_free_31_1032;
	    if (
	       NULLP(kaptured_5))
	      {		/* Globalize/loc2glo.scm 61 */
		 new_free_31_1032 = BNIL;
	      }
	    else
	      {		/* Globalize/loc2glo.scm 61 */
		 obj_t head1564_1125;
		 head1564_1125 =
		    MAKE_PAIR(BNIL, BNIL);
		 {
		    obj_t l1562_1126;
		    obj_t tail1565_1127;
		    l1562_1126 = kaptured_5;
		    tail1565_1127 = head1564_1125;
		  lname1563_1128:
		    if (
		       NULLP(l1562_1126))
		      {		/* Globalize/loc2glo.scm 61 */
			 new_free_31_1032 =
			    CDR(head1564_1125);
		      }
		    else
		      {		/* Globalize/loc2glo.scm 62 */
			 obj_t newtail1566_1130;
			 {	/* Globalize/loc2glo.scm 62 */
			    local_bglt arg1685_1132;
			    {	/* Globalize/loc2glo.scm 62 */
			       obj_t old_1134;
			       old_1134 =
				  CAR(l1562_1126);
			       {	/* Globalize/loc2glo.scm 62 */
				  local_bglt new_1135;
				  {	/* Globalize/loc2glo.scm 62 */
				     type_bglt aux_2384;
				     obj_t aux_2381;
				     {	/* Globalize/loc2glo.scm 62 */
					obj_t aux_2385;
					aux_2385 =
					   default_type_190_globalize_local__global_194();
					aux_2384 =
					   (type_bglt) (aux_2385);
				     }
				     {	/* Globalize/loc2glo.scm 62 */
					local_bglt obj_1712;
					obj_1712 =
					   (local_bglt) (old_1134);
					aux_2381 =
					   (((local_bglt) CREF(obj_1712))->id);
				     }
				     new_1135 =
					make_local_svar_140_ast_local(aux_2381, aux_2384);
				  }
				  {	/* Globalize/loc2glo.scm 64 */
				     bool_t arg1687_1136;
				     {	/* Globalize/loc2glo.scm 64 */
					local_bglt obj_1713;
					obj_1713 =
					   (local_bglt) (old_1134);
					arg1687_1136 =
					   (((local_bglt) CREF(obj_1713))->user__32);
				     }
				     ((((local_bglt) CREF(new_1135))->user__32) = ((bool_t) arg1687_1136), BUNSPEC);
				  }
				  {	/* Globalize/loc2glo.scm 65 */
				     local_ginfo_108_bglt obj1567_1137;
				     obj1567_1137 =
					((local_ginfo_108_bglt) (new_1135));
				     {	/* Globalize/loc2glo.scm 65 */
					local_ginfo_108_bglt arg1688_1138;
					{	/* Globalize/loc2glo.scm 65 */
					   local_ginfo_108_bglt res1905_1719;
					   {	/* ./Globalize/ginfo.scm 1552 */
					      local_ginfo_108_bglt new1535_1717;
					      new1535_1717 =
						 ((local_ginfo_108_bglt) BREF(GC_MALLOC(sizeof(struct local_ginfo_108))));
					      ((((local_ginfo_108_bglt) CREF(new1535_1717))->escape__117) = ((bool_t) ((bool_t) 0)), BUNSPEC);
					      res1905_1719 = new1535_1717;
					   }
					   arg1688_1138 = res1905_1719;
					}
					{	/* Globalize/loc2glo.scm 65 */
					   obj_t aux_2397;
					   object_bglt aux_2395;
					   aux_2397 =
					      (obj_t) (arg1688_1138);
					   aux_2395 =
					      (object_bglt) (obj1567_1137);
					   OBJECT_WIDENING_SET(aux_2395, aux_2397);
					}
				     }
				     {	/* Globalize/loc2glo.scm 65 */
					long arg1689_1139;
					arg1689_1139 =
					   class_num_218___object(local_ginfo_108_globalize_ginfo);
					{	/* Globalize/loc2glo.scm 65 */
					   obj_t obj_1720;
					   obj_1720 =
					      (obj_t) (obj1567_1137);
					   (((obj_t) CREF(obj_1720))->header = MAKE_HEADER(arg1689_1139, 0), BUNSPEC);
					}
				     }
				     obj1567_1137;
				  }
				  {	/* Globalize/loc2glo.scm 66 */
				     svar_ginfo_131_bglt obj1568_1140;
				     obj1568_1140 =
					((svar_ginfo_131_bglt) (
					   (((local_bglt) CREF(new_1135))->value)));
				     {	/* Globalize/loc2glo.scm 66 */
					svar_ginfo_131_bglt arg1690_1141;
					{	/* Globalize/loc2glo.scm 66 */
					   svar_ginfo_131_bglt res1906_1732;
					   {	/* ./Globalize/ginfo.scm 1532 */
					      svar_ginfo_131_bglt new1502_1727;
					      new1502_1727 =
						 ((svar_ginfo_131_bglt) BREF(GC_MALLOC(sizeof(struct svar_ginfo_131))));
					      ((((svar_ginfo_131_bglt) CREF(new1502_1727))->kaptured__204) = ((bool_t) ((bool_t) 1)), BUNSPEC);
					      ((((svar_ginfo_131_bglt) CREF(new1502_1727))->free_mark_81) = ((long) ((long) -10)), BUNSPEC);
					      ((((svar_ginfo_131_bglt) CREF(new1502_1727))->mark) = ((long) ((long) -10)), BUNSPEC);
					      ((((svar_ginfo_131_bglt) CREF(new1502_1727))->celled__113) = ((bool_t) ((bool_t) 0)), BUNSPEC);
					      res1906_1732 = new1502_1727;
					   }
					   arg1690_1141 = res1906_1732;
					}
					{	/* Globalize/loc2glo.scm 66 */
					   obj_t aux_2412;
					   object_bglt aux_2410;
					   aux_2412 =
					      (obj_t) (arg1690_1141);
					   aux_2410 =
					      (object_bglt) (obj1568_1140);
					   OBJECT_WIDENING_SET(aux_2410, aux_2412);
					}
				     }
				     {	/* Globalize/loc2glo.scm 66 */
					long arg1694_1145;
					arg1694_1145 =
					   class_num_218___object(svar_ginfo_131_globalize_ginfo);
					{	/* Globalize/loc2glo.scm 66 */
					   obj_t obj_1733;
					   obj_1733 =
					      (obj_t) (obj1568_1140);
					   (((obj_t) CREF(obj_1733))->header = MAKE_HEADER(arg1694_1145, 0), BUNSPEC);
					}
				     }
				     obj1568_1140;
				  }
				  {	/* Globalize/loc2glo.scm 68 */
				     obj_t arg1695_1146;
				     {	/* Globalize/loc2glo.scm 68 */
					local_bglt obj_1735;
					obj_1735 =
					   (local_bglt) (old_1134);
					arg1695_1146 =
					   (((local_bglt) CREF(obj_1735))->access);
				     }
				     ((((local_bglt) CREF(new_1135))->access) = ((obj_t) arg1695_1146), BUNSPEC);
				  }
				  arg1685_1132 = new_1135;
			       }
			    }
			    {	/* ./Ieee/pair-list.scm 5689 */
			       obj_t aux_2421;
			       aux_2421 =
				  (obj_t) (arg1685_1132);
			       newtail1566_1130 =
				  MAKE_PAIR(aux_2421, BNIL);
			    }
			 }
			 SET_CDR(tail1565_1127, newtail1566_1130);
			 {
			    obj_t tail1565_2427;
			    obj_t l1562_2425;
			    l1562_2425 =
			       CDR(l1562_1126);
			    tail1565_2427 = newtail1566_1130;
			    tail1565_1127 = tail1565_2427;
			    l1562_1126 = l1562_2425;
			    goto lname1563_1128;
			 }
		      }
		 }
	      }
	    {	/* Globalize/loc2glo.scm 61 */
	       obj_t new_args_235_1033;
	       if (
		  NULLP(args_4))
		 {	/* Globalize/loc2glo.scm 71 */
		    new_args_235_1033 = BNIL;
		 }
	       else
		 {	/* Globalize/loc2glo.scm 71 */
		    obj_t head1571_1098;
		    head1571_1098 =
		       MAKE_PAIR(BNIL, BNIL);
		    {
		       obj_t l1569_1099;
		       obj_t tail1572_1100;
		       l1569_1099 = args_4;
		       tail1572_1100 = head1571_1098;
		     lname1570_1101:
		       if (
			  NULLP(l1569_1099))
			 {	/* Globalize/loc2glo.scm 71 */
			    new_args_235_1033 =
			       CDR(head1571_1098);
			 }
		       else
			 {	/* Globalize/loc2glo.scm 72 */
			    obj_t newtail1573_1103;
			    {	/* Globalize/loc2glo.scm 72 */
			       local_bglt arg1667_1105;
			       {	/* Globalize/loc2glo.scm 72 */
				  obj_t old_1107;
				  old_1107 =
				     CAR(l1569_1099);
				  {	/* Globalize/loc2glo.scm 72 */
				     local_bglt new_1108;
				     {	/* Globalize/loc2glo.scm 72 */
					type_bglt aux_2438;
					obj_t aux_2435;
					{	/* Globalize/loc2glo.scm 72 */
					   obj_t aux_2439;
					   aux_2439 =
					      default_type_190_globalize_local__global_194();
					   aux_2438 =
					      (type_bglt) (aux_2439);
					}
					{	/* Globalize/loc2glo.scm 72 */
					   local_bglt obj_1749;
					   obj_1749 =
					      (local_bglt) (old_1107);
					   aux_2435 =
					      (((local_bglt) CREF(obj_1749))->id);
					}
					new_1108 =
					   make_local_svar_140_ast_local(aux_2435, aux_2438);
				     }
				     {	/* Globalize/loc2glo.scm 74 */
					bool_t arg1670_1109;
					{	/* Globalize/loc2glo.scm 74 */
					   local_bglt obj_1750;
					   obj_1750 =
					      (local_bglt) (old_1107);
					   arg1670_1109 =
					      (((local_bglt) CREF(obj_1750))->user__32);
					}
					((((local_bglt) CREF(new_1108))->user__32) = ((bool_t) arg1670_1109), BUNSPEC);
				     }
				     {	/* Globalize/loc2glo.scm 75 */
					local_ginfo_108_bglt obj1574_1110;
					obj1574_1110 =
					   ((local_ginfo_108_bglt) (new_1108));
					{	/* Globalize/loc2glo.scm 75 */
					   local_ginfo_108_bglt arg1671_1111;
					   {	/* Globalize/loc2glo.scm 75 */
					      local_ginfo_108_bglt res1907_1756;
					      {		/* ./Globalize/ginfo.scm 1552 */
						 local_ginfo_108_bglt new1535_1754;
						 new1535_1754 =
						    ((local_ginfo_108_bglt) BREF(GC_MALLOC(sizeof(struct local_ginfo_108))));
						 ((((local_ginfo_108_bglt) CREF(new1535_1754))->escape__117) = ((bool_t) ((bool_t) 0)), BUNSPEC);
						 res1907_1756 = new1535_1754;
					      }
					      arg1671_1111 = res1907_1756;
					   }
					   {	/* Globalize/loc2glo.scm 75 */
					      obj_t aux_2451;
					      object_bglt aux_2449;
					      aux_2451 =
						 (obj_t) (arg1671_1111);
					      aux_2449 =
						 (object_bglt) (obj1574_1110);
					      OBJECT_WIDENING_SET(aux_2449, aux_2451);
					   }
					}
					{	/* Globalize/loc2glo.scm 75 */
					   long arg1672_1112;
					   arg1672_1112 =
					      class_num_218___object(local_ginfo_108_globalize_ginfo);
					   {	/* Globalize/loc2glo.scm 75 */
					      obj_t obj_1757;
					      obj_1757 =
						 (obj_t) (obj1574_1110);
					      (((obj_t) CREF(obj_1757))->header = MAKE_HEADER(arg1672_1112, 0), BUNSPEC);
					   }
					}
					obj1574_1110;
				     }
				     {	/* Globalize/loc2glo.scm 76 */
					svar_ginfo_131_bglt obj1575_1113;
					obj1575_1113 =
					   ((svar_ginfo_131_bglt) (
					      (((local_bglt) CREF(new_1108))->value)));
					{	/* Globalize/loc2glo.scm 78 */
					   svar_ginfo_131_bglt arg1673_1114;
					   {	/* Globalize/loc2glo.scm 78 */
					      bool_t arg1674_1115;
					      {		/* Globalize/loc2glo.scm 77 */
						 svar_ginfo_131_bglt obj_1761;
						 {	/* Globalize/loc2glo.scm 77 */
						    value_bglt aux_2459;
						    {	/* Globalize/loc2glo.scm 78 */
						       local_bglt obj_1760;
						       obj_1760 =
							  (local_bglt) (old_1107);
						       aux_2459 =
							  (((local_bglt) CREF(obj_1760))->value);
						    }
						    obj_1761 =
						       (svar_ginfo_131_bglt) (aux_2459);
						 }
						 {
						    obj_t aux_2463;
						    {	/* ./Globalize/ginfo.scm 1534 */
						       object_bglt aux_2464;
						       aux_2464 =
							  (object_bglt) (obj_1761);
						       aux_2463 =
							  OBJECT_WIDENING(aux_2464);
						    }
						    arg1674_1115 =
						       (((svar_ginfo_131_bglt) CREF(aux_2463))->kaptured__204);
						 }
					      }
					      {		/* Globalize/loc2glo.scm 76 */
						 svar_ginfo_131_bglt res1908_1771;
						 {	/* ./Globalize/ginfo.scm 1532 */
						    svar_ginfo_131_bglt new1502_1766;
						    new1502_1766 =
						       ((svar_ginfo_131_bglt) BREF(GC_MALLOC(sizeof(struct svar_ginfo_131))));
						    ((((svar_ginfo_131_bglt) CREF(new1502_1766))->kaptured__204) = ((bool_t) arg1674_1115), BUNSPEC);
						    ((((svar_ginfo_131_bglt) CREF(new1502_1766))->free_mark_81) = ((long) ((long) -10)), BUNSPEC);
						    ((((svar_ginfo_131_bglt) CREF(new1502_1766))->mark) = ((long) ((long) -10)), BUNSPEC);
						    ((((svar_ginfo_131_bglt) CREF(new1502_1766))->celled__113) = ((bool_t) ((bool_t) 0)), BUNSPEC);
						    res1908_1771 = new1502_1766;
						 }
						 arg1673_1114 = res1908_1771;
					      }
					   }
					   {	/* Globalize/loc2glo.scm 76 */
					      obj_t aux_2475;
					      object_bglt aux_2473;
					      aux_2475 =
						 (obj_t) (arg1673_1114);
					      aux_2473 =
						 (object_bglt) (obj1575_1113);
					      OBJECT_WIDENING_SET(aux_2473, aux_2475);
					   }
					}
					{	/* Globalize/loc2glo.scm 76 */
					   long arg1678_1119;
					   arg1678_1119 =
					      class_num_218___object(svar_ginfo_131_globalize_ginfo);
					   {	/* Globalize/loc2glo.scm 76 */
					      obj_t obj_1772;
					      obj_1772 =
						 (obj_t) (obj1575_1113);
					      (((obj_t) CREF(obj_1772))->header = MAKE_HEADER(arg1678_1119, 0), BUNSPEC);
					   }
					}
					obj1575_1113;
				     }
				     {	/* Globalize/loc2glo.scm 79 */
					obj_t arg1679_1120;
					{	/* Globalize/loc2glo.scm 79 */
					   local_bglt obj_1774;
					   obj_1774 =
					      (local_bglt) (old_1107);
					   arg1679_1120 =
					      (((local_bglt) CREF(obj_1774))->access);
					}
					((((local_bglt) CREF(new_1108))->access) = ((obj_t) arg1679_1120), BUNSPEC);
				     }
				     arg1667_1105 = new_1108;
				  }
			       }
			       {	/* ./Ieee/pair-list.scm 5689 */
				  obj_t aux_2484;
				  aux_2484 =
				     (obj_t) (arg1667_1105);
				  newtail1573_1103 =
				     MAKE_PAIR(aux_2484, BNIL);
			       }
			    }
			    SET_CDR(tail1572_1100, newtail1573_1103);
			    {
			       obj_t tail1572_2490;
			       obj_t l1569_2488;
			       l1569_2488 =
				  CDR(l1569_1099);
			       tail1572_2490 = newtail1573_1103;
			       tail1572_1100 = tail1572_2490;
			       l1569_1099 = l1569_2488;
			       goto lname1570_1101;
			    }
			 }
		    }
		 }
	       {	/* Globalize/loc2glo.scm 82 */
		  sfun_bglt new_fun_115_1035;
		  {	/* Globalize/loc2glo.scm 83 */
		     sfun_bglt duplicated1576_1080;
		     {	/* Globalize/loc2glo.scm 83 */
			value_bglt aux_2491;
			aux_2491 =
			   (((local_bglt) CREF(local_3))->value);
			duplicated1576_1080 =
			   (sfun_bglt) (aux_2491);
		     }
		     {	/* Globalize/loc2glo.scm 84 */
			sfun_bglt new1577_1081;
			{	/* Globalize/loc2glo.scm 84 */
			   obj_t arg1650_1082;
			   obj_t arg1651_1083;
			   obj_t arg1652_1084;
			   obj_t arg1653_1085;
			   bool_t arg1654_1086;
			   obj_t arg1655_1087;
			   obj_t arg1656_1088;
			   obj_t arg1657_1089;
			   obj_t arg1658_1090;
			   obj_t arg1659_1091;
			   obj_t arg1660_1092;
			   obj_t arg1661_1093;
			   {	/* Globalize/loc2glo.scm 84 */
			      obj_t aux_2494;
			      {		/* Globalize/loc2glo.scm 84 */
				 long aux_2495;
				 aux_2495 =
				    (((sfun_bglt) CREF(duplicated1576_1080))->arity);
				 aux_2494 =
				    BINT(aux_2495);
			      }
			      arg1650_1082 =
				 __arity_132_tools_args(aux_2494,
				 BINT(((long) 1)));
			   }
			   arg1651_1083 =
			      (((sfun_bglt) CREF(duplicated1576_1080))->side_effect__165);
			   arg1652_1084 =
			      (((sfun_bglt) CREF(duplicated1576_1080))->predicate_of_78);
			   arg1653_1085 =
			      (((sfun_bglt) CREF(duplicated1576_1080))->stack_allocator_172);
			   arg1654_1086 =
			      (((sfun_bglt) CREF(duplicated1576_1080))->top__138);
			   arg1655_1087 =
			      (((sfun_bglt) CREF(duplicated1576_1080))->the_closure_238);
			   arg1656_1088 =
			      (((sfun_bglt) CREF(duplicated1576_1080))->property);
			   {	/* ./Ieee/pair-list.scm 5689 */
			      obj_t aux_2506;
			      aux_2506 =
				 (obj_t) (env_1031);
			      arg1657_1089 =
				 MAKE_PAIR(aux_2506, new_args_235_1033);
			   }
			   arg1658_1090 =
			      (((sfun_bglt) CREF(duplicated1576_1080))->body);
			   arg1659_1091 =
			      (((sfun_bglt) CREF(duplicated1576_1080))->class);
			   arg1660_1092 =
			      (((sfun_bglt) CREF(duplicated1576_1080))->dsssl_keywords_243);
			   arg1661_1093 =
			      (((sfun_bglt) CREF(duplicated1576_1080))->loc);
			   {	/* Globalize/loc2glo.scm 83 */
			      sfun_bglt res1909_1824;
			      {		/* Globalize/loc2glo.scm 83 */
				 long arity_1796;
				 arity_1796 =
				    (long) CINT(arg1650_1082);
				 {	/* ./Ast/var.scm 1061 */
				    sfun_bglt new1135_1808;
				    new1135_1808 =
				       ((sfun_bglt) BREF(GC_MALLOC(sizeof(struct sfun))));
				    {	/* ./Ast/var.scm 1061 */
				       long arg1890_1809;
				       arg1890_1809 =
					  class_num_218___object(sfun_ast_var);
				       {	/* ./Ast/var.scm 1061 */
					  obj_t obj_1822;
					  obj_1822 =
					     (obj_t) (new1135_1808);
					  (((obj_t) CREF(obj_1822))->header = MAKE_HEADER(arg1890_1809, 0), BUNSPEC);
				       }
				    }
				    {	/* ./Ast/var.scm 1061 */
				       object_bglt aux_2518;
				       aux_2518 =
					  (object_bglt) (new1135_1808);
				       OBJECT_WIDENING_SET(aux_2518, BFALSE);
				    }
				    ((((sfun_bglt) CREF(new1135_1808))->arity) = ((long) arity_1796), BUNSPEC);
				    ((((sfun_bglt) CREF(new1135_1808))->side_effect__165) = ((obj_t) arg1651_1083), BUNSPEC);
				    ((((sfun_bglt) CREF(new1135_1808))->predicate_of_78) = ((obj_t) arg1652_1084), BUNSPEC);
				    ((((sfun_bglt) CREF(new1135_1808))->stack_allocator_172) = ((obj_t) arg1653_1085), BUNSPEC);
				    ((((sfun_bglt) CREF(new1135_1808))->top__138) = ((bool_t) arg1654_1086), BUNSPEC);
				    ((((sfun_bglt) CREF(new1135_1808))->the_closure_238) = ((obj_t) arg1655_1087), BUNSPEC);
				    ((((sfun_bglt) CREF(new1135_1808))->property) = ((obj_t) arg1656_1088), BUNSPEC);
				    ((((sfun_bglt) CREF(new1135_1808))->args) = ((obj_t) arg1657_1089), BUNSPEC);
				    ((((sfun_bglt) CREF(new1135_1808))->body) = ((obj_t) arg1658_1090), BUNSPEC);
				    ((((sfun_bglt) CREF(new1135_1808))->class) = ((obj_t) arg1659_1091), BUNSPEC);
				    ((((sfun_bglt) CREF(new1135_1808))->dsssl_keywords_243) = ((obj_t) arg1660_1092), BUNSPEC);
				    ((((sfun_bglt) CREF(new1135_1808))->loc) = ((obj_t) arg1661_1093), BUNSPEC);
				    res1909_1824 = new1135_1808;
				 }
			      }
			      new1577_1081 = res1909_1824;
			   }
			}
			{	/* Globalize/loc2glo.scm 83 */

			   new_fun_115_1035 = new1577_1081;
			}
		     }
		  }
		  {	/* Globalize/loc2glo.scm 83 */

		     {	/* Globalize/loc2glo.scm 87 */
			global_ginfo_75_bglt obj_1825;
			obj_1825 =
			   (global_ginfo_75_bglt) (global_2);
			{
			   obj_t aux_2534;
			   {	/* ./Globalize/ginfo.scm 1558 */
			      object_bglt aux_2535;
			      aux_2535 =
				 (object_bglt) (obj_1825);
			      aux_2534 =
				 OBJECT_WIDENING(aux_2535);
			   }
			   ((((global_ginfo_75_bglt) CREF(aux_2534))->escape__117) = ((bool_t) ((bool_t) 1)), BUNSPEC);
			}
		     }
		     {	/* Globalize/loc2glo.scm 88 */
			sfun_ginfo_98_bglt obj1579_1036;
			obj1579_1036 =
			   ((sfun_ginfo_98_bglt) (new_fun_115_1035));
			{	/* Globalize/loc2glo.scm 88 */
			   sfun_ginfo_98_bglt arg1618_1037;
			   {	/* Globalize/loc2glo.scm 88 */
			      sfun_ginfo_98_bglt res1910_1864;
			      {		/* Globalize/loc2glo.scm 88 */
				 obj_t cfrom__119_1829;
				 obj_t cto__14_1831;
				 obj_t the_global_201_1838;
				 obj_t kaptured_1839;
				 obj_t new_body_215_1840;
				 cfrom__119_1829 = BFALSE;
				 cto__14_1831 = BFALSE;
				 the_global_201_1838 = BFALSE;
				 kaptured_1839 = BFALSE;
				 new_body_215_1840 = BFALSE;
				 {	/* ./Globalize/ginfo.scm 1494 */
				    sfun_ginfo_98_bglt new1474_1845;
				    new1474_1845 =
				       ((sfun_ginfo_98_bglt) BREF(GC_MALLOC(sizeof(struct sfun_ginfo_98))));
				    ((((sfun_ginfo_98_bglt) CREF(new1474_1845))->g__219) = ((bool_t) ((bool_t) 0)), BUNSPEC);
				    ((((sfun_ginfo_98_bglt) CREF(new1474_1845))->cfrom) = ((obj_t) BNIL), BUNSPEC);
				    ((((sfun_ginfo_98_bglt) CREF(new1474_1845))->cfrom__119) = ((obj_t) cfrom__119_1829), BUNSPEC);
				    ((((sfun_ginfo_98_bglt) CREF(new1474_1845))->cto) = ((obj_t) BNIL), BUNSPEC);
				    ((((sfun_ginfo_98_bglt) CREF(new1474_1845))->cto__14) = ((obj_t) cto__14_1831), BUNSPEC);
				    ((((sfun_ginfo_98_bglt) CREF(new1474_1845))->cfunction) = ((obj_t) BNIL), BUNSPEC);
				    ((((sfun_ginfo_98_bglt) CREF(new1474_1845))->integrator) = ((obj_t) BNIL), BUNSPEC);
				    ((((sfun_ginfo_98_bglt) CREF(new1474_1845))->integrated) = ((obj_t) BNIL), BUNSPEC);
				    ((((sfun_ginfo_98_bglt) CREF(new1474_1845))->plugged_in_15) = ((obj_t) BNIL), BUNSPEC);
				    ((((sfun_ginfo_98_bglt) CREF(new1474_1845))->mark) = ((long) ((long) -10)), BUNSPEC);
				    ((((sfun_ginfo_98_bglt) CREF(new1474_1845))->free_mark_81) = ((obj_t) BNIL), BUNSPEC);
				    ((((sfun_ginfo_98_bglt) CREF(new1474_1845))->the_global_201) = ((obj_t) the_global_201_1838), BUNSPEC);
				    ((((sfun_ginfo_98_bglt) CREF(new1474_1845))->kaptured) = ((obj_t) kaptured_1839), BUNSPEC);
				    ((((sfun_ginfo_98_bglt) CREF(new1474_1845))->new_body_215) = ((obj_t) new_body_215_1840), BUNSPEC);
				    ((((sfun_ginfo_98_bglt) CREF(new1474_1845))->bmark) = ((long) ((long) -10)), BUNSPEC);
				    ((((sfun_ginfo_98_bglt) CREF(new1474_1845))->umark) = ((long) ((long) -10)), BUNSPEC);
				    ((((sfun_ginfo_98_bglt) CREF(new1474_1845))->free) = ((obj_t) BUNSPEC), BUNSPEC);
				    ((((sfun_ginfo_98_bglt) CREF(new1474_1845))->bound) = ((obj_t) BNIL), BUNSPEC);
				    res1910_1864 = new1474_1845;
				 }
			      }
			      arg1618_1037 = res1910_1864;
			   }
			   {	/* Globalize/loc2glo.scm 88 */
			      obj_t aux_2561;
			      object_bglt aux_2559;
			      aux_2561 =
				 (obj_t) (arg1618_1037);
			      aux_2559 =
				 (object_bglt) (obj1579_1036);
			      OBJECT_WIDENING_SET(aux_2559, aux_2561);
			   }
			}
			{	/* Globalize/loc2glo.scm 88 */
			   long arg1619_1038;
			   arg1619_1038 =
			      class_num_218___object(sfun_ginfo_98_globalize_ginfo);
			   {	/* Globalize/loc2glo.scm 88 */
			      obj_t obj_1865;
			      obj_1865 =
				 (obj_t) (obj1579_1036);
			      (((obj_t) CREF(obj_1865))->header = MAKE_HEADER(arg1619_1038, 0), BUNSPEC);
			   }
			}
			obj1579_1036;
		     }
		     {	/* Globalize/loc2glo.scm 90 */
			svar_ginfo_131_bglt obj1580_1039;
			obj1580_1039 =
			   ((svar_ginfo_131_bglt) (
			      (((local_bglt) CREF(env_1031))->value)));
			{	/* Globalize/loc2glo.scm 90 */
			   svar_ginfo_131_bglt arg1620_1040;
			   {	/* Globalize/loc2glo.scm 90 */
			      svar_ginfo_131_bglt res1911_1877;
			      {		/* ./Globalize/ginfo.scm 1532 */
				 svar_ginfo_131_bglt new1502_1872;
				 new1502_1872 =
				    ((svar_ginfo_131_bglt) BREF(GC_MALLOC(sizeof(struct svar_ginfo_131))));
				 ((((svar_ginfo_131_bglt) CREF(new1502_1872))->kaptured__204) = ((bool_t) ((bool_t) 0)), BUNSPEC);
				 ((((svar_ginfo_131_bglt) CREF(new1502_1872))->free_mark_81) = ((long) ((long) -10)), BUNSPEC);
				 ((((svar_ginfo_131_bglt) CREF(new1502_1872))->mark) = ((long) ((long) -10)), BUNSPEC);
				 ((((svar_ginfo_131_bglt) CREF(new1502_1872))->celled__113) = ((bool_t) ((bool_t) 0)), BUNSPEC);
				 res1911_1877 = new1502_1872;
			      }
			      arg1620_1040 = res1911_1877;
			   }
			   {	/* Globalize/loc2glo.scm 90 */
			      obj_t aux_2576;
			      object_bglt aux_2574;
			      aux_2576 =
				 (obj_t) (arg1620_1040);
			      aux_2574 =
				 (object_bglt) (obj1580_1039);
			      OBJECT_WIDENING_SET(aux_2574, aux_2576);
			   }
			}
			{	/* Globalize/loc2glo.scm 90 */
			   long arg1624_1044;
			   arg1624_1044 =
			      class_num_218___object(svar_ginfo_131_globalize_ginfo);
			   {	/* Globalize/loc2glo.scm 90 */
			      obj_t obj_1878;
			      obj_1878 =
				 (obj_t) (obj1580_1039);
			      (((obj_t) CREF(obj_1878))->header = MAKE_HEADER(arg1624_1044, 0), BUNSPEC);
			   }
			}
			obj1580_1039;
		     }
		     {	/* Globalize/loc2glo.scm 94 */
			type_bglt val1060_1881;
			val1060_1881 =
			   (type_bglt) (_obj__252_type_cache);
			((((global_bglt) CREF(global_2))->type) = ((type_bglt) val1060_1881), BUNSPEC);
		     }
		     {
			obj_t l1581_1045;
			{	/* ./Ieee/pair-list.scm 5707 */
			   obj_t aux_2593;
			   aux_2593 =
			      (((sfun_bglt) CREF(new_fun_115_1035))->args);
			   l1581_1045 =
			      CDR(aux_2593);
			}
		      lname1582_1046:
			if (
			   PAIRP(l1581_1045))
			  {	/* Globalize/loc2glo.scm 97 */
			     {	/* Globalize/loc2glo.scm 97 */
				local_bglt obj_1886;
				type_bglt val1090_1887;
				{	/* Globalize/loc2glo.scm 97 */
				   obj_t aux_2586;
				   aux_2586 =
				      CAR(l1581_1045);
				   obj_1886 =
				      (local_bglt) (aux_2586);
				}
				val1090_1887 =
				   (type_bglt) (_obj__252_type_cache);
				((((local_bglt) CREF(obj_1886))->type) = ((type_bglt) val1090_1887), BUNSPEC);
			     }
			     {
				obj_t l1581_2591;
				l1581_2591 =
				   CDR(l1581_1045);
				l1581_1045 = l1581_2591;
				goto lname1582_1046;
			     }
			  }
			else
			  {	/* Globalize/loc2glo.scm 97 */
			     ((bool_t) 1);
			  }
		     }
		     {	/* Globalize/loc2glo.scm 99 */
			value_bglt val1061_1890;
			val1061_1890 =
			   (value_bglt) (new_fun_115_1035);
			((((global_bglt) CREF(global_2))->value) = ((value_bglt) val1061_1890), BUNSPEC);
		     }
		     {	/* Globalize/loc2glo.scm 109 */
			node_bglt arg1629_1052;
			{	/* Globalize/loc2glo.scm 109 */
			   node_bglt arg1630_1053;
			   {	/* Globalize/loc2glo.scm 109 */
			      obj_t arg1631_1054;
			      {		/* Globalize/loc2glo.scm 109 */
				 obj_t arg1632_1055;
				 obj_t arg1633_1056;
				 {	/* Globalize/loc2glo.scm 109 */
				    obj_t arg1634_1057;
				    arg1634_1057 =
				       the_closure_238_globalize_free(
				       (variable_bglt) (local_3), BFALSE);
				    {	/* ./Ieee/pair-list.scm 5689 */
				       obj_t aux_2600;
				       aux_2600 =
					  (obj_t) (env_1031);
				       arg1632_1055 =
					  MAKE_PAIR(arg1634_1057, aux_2600);
				    }
				 }
				 if (
				    NULLP(kaptured_5))
				   {	/* Globalize/loc2glo.scm 111 */
				      arg1633_1056 = BNIL;
				   }
				 else
				   {	/* Globalize/loc2glo.scm 111 */
				      obj_t head1585_1061;
				      {		/* Globalize/loc2glo.scm 111 */
					 obj_t arg1646_1076;
					 {	/* ./Ieee/pair-list.scm 5689 */
					    obj_t aux_2607;
					    obj_t aux_2605;
					    aux_2607 =
					       CAR(new_free_31_1032);
					    aux_2605 =
					       CAR(kaptured_5);
					    arg1646_1076 =
					       MAKE_PAIR(aux_2605, aux_2607);
					 }
					 head1585_1061 =
					    MAKE_PAIR(arg1646_1076, BNIL);
				      }
				      {
					 obj_t ll1583_1062;
					 obj_t ll1584_1063;
					 obj_t tail1586_1064;
					 ll1583_1062 =
					    CDR(kaptured_5);
					 ll1584_1063 =
					    CDR(new_free_31_1032);
					 tail1586_1064 = head1585_1061;
				       lname1588_1065:
					 if (
					    NULLP(ll1583_1062))
					   {	/* Globalize/loc2glo.scm 111 */
					      arg1633_1056 = head1585_1061;
					   }
					 else
					   {	/* Globalize/loc2glo.scm 111 */
					      obj_t newtail1587_1069;
					      {		/* Globalize/loc2glo.scm 111 */
						 obj_t arg1641_1072;
						 {	/* ./Ieee/pair-list.scm 5689 */
						    obj_t aux_2615;
						    obj_t aux_2613;
						    aux_2615 =
						       CAR(ll1584_1063);
						    aux_2613 =
						       CAR(ll1583_1062);
						    arg1641_1072 =
						       MAKE_PAIR(aux_2613, aux_2615);
						 }
						 newtail1587_1069 =
						    MAKE_PAIR(arg1641_1072, BNIL);
					      }
					      SET_CDR(tail1586_1064, newtail1587_1069);
					      {
						 obj_t tail1586_2624;
						 obj_t ll1584_2622;
						 obj_t ll1583_2620;
						 ll1583_2620 =
						    CDR(ll1583_1062);
						 ll1584_2622 =
						    CDR(ll1584_1063);
						 tail1586_2624 = newtail1587_1069;
						 tail1586_1064 = tail1586_2624;
						 ll1584_1063 = ll1584_2622;
						 ll1583_1062 = ll1583_2620;
						 goto lname1588_1065;
					      }
					   }
				      }
				   }
				 arg1631_1054 =
				    MAKE_PAIR(arg1632_1055, arg1633_1056);
			      }
			      arg1630_1053 =
				 node_globalize__229_globalize_node(
				 (node_bglt) (body_6),
				 (variable_bglt) (local_3), arg1631_1054);
			   }
			   arg1629_1052 =
			      make_escaping_body_209_globalize_local__global_194(local_3, global_2, new_args_235_1033, new_free_31_1032, env_1031, arg1630_1053);
			}
			{	/* Globalize/loc2glo.scm 100 */
			   obj_t val1131_1916;
			   val1131_1916 =
			      (obj_t) (arg1629_1052);
			   ((((sfun_bglt) CREF(new_fun_115_1035))->body) = ((obj_t) val1131_1916), BUNSPEC);
			}
		     }
		     return global_2;
		  }
	       }
	    }
	 }
      }
   }
}



/* make-escaping-body */
node_bglt 
make_escaping_body_209_globalize_local__global_194(local_bglt local_7, global_bglt global_8, obj_t args_9, obj_t kaptured_10, local_bglt env_11, node_bglt body_12)
{
   AN_OBJECT;
   {	/* Globalize/loc2glo.scm 119 */
      {		/* Globalize/loc2glo.scm 120 */
	 obj_t stack_1149;
	 obj_t loc_1150;
	 {	/* Globalize/loc2glo.scm 120 */
	    obj_t list1741_1203;
	    {	/* Globalize/loc2glo.scm 120 */
	       obj_t aux_2634;
	       aux_2634 =
		  (obj_t) (env_11);
	       list1741_1203 =
		  MAKE_PAIR(aux_2634, BNIL);
	    }
	    stack_1149 = list1741_1203;
	 }
	 loc_1150 =
	    (((node_bglt) CREF(body_12))->loc);
	 {	/* Globalize/loc2glo.scm 122 */
	    sfun_bglt obj_1920;
	    obj_t val1131_1921;
	    {	/* Globalize/loc2glo.scm 122 */
	       value_bglt aux_2638;
	       aux_2638 =
		  (((local_bglt) CREF(local_7))->value);
	       obj_1920 =
		  (sfun_bglt) (aux_2638);
	    }
	    val1131_1921 =
	       (obj_t) (body_12);
	    ((((sfun_bglt) CREF(obj_1920))->body) = ((obj_t) val1131_1921), BUNSPEC);
	 }
	 {	/* Globalize/loc2glo.scm 123 */
	    obj_t arg1700_1153;
	    obj_t arg1702_1155;
	    let_fun_218_bglt arg1703_1156;
	    arg1700_1153 = ____74_type_cache;
	    {
	       obj_t kaptured_1157;
	       long num_1158;
	       obj_t res_1159;
	       kaptured_1157 = kaptured_10;
	       num_1158 = ((long) 0);
	       res_1159 = BNIL;
	     loop_1160:
	       if (
		  NULLP(kaptured_1157))
		 {	/* Globalize/loc2glo.scm 129 */
		    arg1702_1155 =
		       reverse__39___r4_pairs_and_lists_6_3(res_1159);
		 }
	       else
		 {	/* Globalize/loc2glo.scm 131 */
		    obj_t arg1705_1162;
		    long arg1706_1163;
		    obj_t arg1707_1164;
		    arg1705_1162 =
		       CDR(kaptured_1157);
		    arg1706_1163 =
		       (num_1158 + ((long) 1));
		    {	/* Globalize/loc2glo.scm 133 */
		       obj_t arg1708_1165;
		       {	/* Globalize/loc2glo.scm 133 */
			  obj_t arg1709_1166;
			  node_bglt arg1711_1167;
			  arg1709_1166 =
			     CAR(kaptured_1157);
			  {	/* Globalize/loc2glo.scm 135 */
			     obj_t arg1712_1168;
			     obj_t arg1713_1169;
			     {	/* Globalize/loc2glo.scm 135 */
				obj_t arg1714_1170;
				obj_t arg1715_1171;
				arg1714_1170 =
				   CNST_TABLE_REF(((long) 1));
				{	/* Globalize/loc2glo.scm 135 */
				   obj_t arg1716_1172;
				   obj_t arg1717_1173;
				   arg1716_1172 =
				      CNST_TABLE_REF(((long) 0));
				   {	/* ./Ieee/pair-list.scm 5689 */
				      obj_t aux_2651;
				      aux_2651 =
					 BINT(num_1158);
				      arg1717_1173 =
					 MAKE_PAIR(aux_2651, BNIL);
				   }
				   arg1715_1171 =
				      MAKE_PAIR(arg1716_1172, arg1717_1173);
				}
				arg1712_1168 =
				   MAKE_PAIR(arg1714_1170, arg1715_1171);
			     }
			     arg1713_1169 =
				CNST_TABLE_REF(((long) 2));
			     arg1711_1167 =
				sexp__node_235_ast_sexp(arg1712_1168, stack_1149, loc_1150, arg1713_1169);
			  }
			  {	/* ./Ieee/pair-list.scm 5689 */
			     obj_t aux_2658;
			     aux_2658 =
				(obj_t) (arg1711_1167);
			     arg1708_1165 =
				MAKE_PAIR(arg1709_1166, aux_2658);
			  }
		       }
		       arg1707_1164 =
			  MAKE_PAIR(arg1708_1165, res_1159);
		    }
		    {
		       obj_t res_2664;
		       long num_2663;
		       obj_t kaptured_2662;
		       kaptured_2662 = arg1705_1162;
		       num_2663 = arg1706_1163;
		       res_2664 = arg1707_1164;
		       res_1159 = res_2664;
		       num_1158 = num_2663;
		       kaptured_1157 = kaptured_2662;
		       goto loop_1160;
		    }
		 }
	    }
	    {	/* Globalize/loc2glo.scm 140 */
	       obj_t arg1719_1175;
	       obj_t arg1721_1177;
	       app_bglt arg1722_1178;
	       arg1719_1175 = ____74_type_cache;
	       {	/* Globalize/loc2glo.scm 143 */
		  obj_t list1723_1179;
		  {	/* Globalize/loc2glo.scm 143 */
		     obj_t aux_2665;
		     aux_2665 =
			(obj_t) (local_7);
		     list1723_1179 =
			MAKE_PAIR(aux_2665, BNIL);
		  }
		  arg1721_1177 = list1723_1179;
	       }
	       {	/* Globalize/loc2glo.scm 144 */
		  obj_t arg1725_1181;
		  var_bglt arg1727_1183;
		  obj_t arg1728_1184;
		  arg1725_1181 = ____74_type_cache;
		  {	/* Globalize/loc2glo.scm 147 */
		     obj_t arg1730_1186;
		     arg1730_1186 = ____74_type_cache;
		     {	/* Globalize/loc2glo.scm 147 */
			var_bglt res1912_1948;
			{	/* Globalize/loc2glo.scm 147 */
			   type_bglt type_1939;
			   variable_bglt variable_1940;
			   type_1939 =
			      (type_bglt) (arg1730_1186);
			   variable_1940 =
			      (variable_bglt) (local_7);
			   {	/* ./Ast/node.scm 1155 */
			      var_bglt new1218_1941;
			      new1218_1941 =
				 ((var_bglt) BREF(GC_MALLOC(sizeof(struct var))));
			      {		/* ./Ast/node.scm 1155 */
				 long arg1871_1942;
				 arg1871_1942 =
				    class_num_218___object(var_ast_node);
				 {	/* ./Ast/node.scm 1155 */
				    obj_t obj_1946;
				    obj_1946 =
				       (obj_t) (new1218_1941);
				    (((obj_t) CREF(obj_1946))->header = MAKE_HEADER(arg1871_1942, 0), BUNSPEC);
				 }
			      }
			      {		/* ./Ast/node.scm 1155 */
				 object_bglt aux_2674;
				 aux_2674 =
				    (object_bglt) (new1218_1941);
				 OBJECT_WIDENING_SET(aux_2674, BFALSE);
			      }
			      ((((var_bglt) CREF(new1218_1941))->loc) = ((obj_t) loc_1150), BUNSPEC);
			      ((((var_bglt) CREF(new1218_1941))->type) = ((type_bglt) type_1939), BUNSPEC);
			      ((((var_bglt) CREF(new1218_1941))->variable) = ((variable_bglt) variable_1940), BUNSPEC);
			      res1912_1948 = new1218_1941;
			   }
			}
			arg1727_1183 = res1912_1948;
		     }
		  }
		  if (
		     NULLP(args_9))
		    {	/* Globalize/loc2glo.scm 151 */
		       arg1728_1184 = BNIL;
		    }
		  else
		    {	/* Globalize/loc2glo.scm 151 */
		       obj_t head1595_1190;
		       head1595_1190 =
			  MAKE_PAIR(BNIL, BNIL);
		       {
			  obj_t l1593_1191;
			  obj_t tail1596_1192;
			  l1593_1191 = args_9;
			  tail1596_1192 = head1595_1190;
			lname1594_1193:
			  if (
			     NULLP(l1593_1191))
			    {	/* Globalize/loc2glo.scm 151 */
			       arg1728_1184 =
				  CDR(head1595_1190);
			    }
			  else
			    {	/* Globalize/loc2glo.scm 152 */
			       obj_t newtail1597_1195;
			       {	/* Globalize/loc2glo.scm 152 */
				  var_bglt arg1735_1197;
				  {	/* Globalize/loc2glo.scm 152 */
				     obj_t arg1739_1201;
				     arg1739_1201 = ____74_type_cache;
				     {	/* Globalize/loc2glo.scm 152 */
					var_bglt res1913_1965;
					{	/* Globalize/loc2glo.scm 152 */
					   type_bglt type_1956;
					   variable_bglt variable_1957;
					   type_1956 =
					      (type_bglt) (arg1739_1201);
					   {	/* Globalize/loc2glo.scm 152 */
					      obj_t aux_2687;
					      aux_2687 =
						 CAR(l1593_1191);
					      variable_1957 =
						 (variable_bglt) (aux_2687);
					   }
					   {	/* ./Ast/node.scm 1155 */
					      var_bglt new1218_1958;
					      new1218_1958 =
						 ((var_bglt) BREF(GC_MALLOC(sizeof(struct var))));
					      {		/* ./Ast/node.scm 1155 */
						 long arg1871_1959;
						 arg1871_1959 =
						    class_num_218___object(var_ast_node);
						 {	/* ./Ast/node.scm 1155 */
						    obj_t obj_1963;
						    obj_1963 =
						       (obj_t) (new1218_1958);
						    (((obj_t) CREF(obj_1963))->header = MAKE_HEADER(arg1871_1959, 0), BUNSPEC);
						 }
					      }
					      {		/* ./Ast/node.scm 1155 */
						 object_bglt aux_2694;
						 aux_2694 =
						    (object_bglt) (new1218_1958);
						 OBJECT_WIDENING_SET(aux_2694, BFALSE);
					      }
					      ((((var_bglt) CREF(new1218_1958))->loc) = ((obj_t) loc_1150), BUNSPEC);
					      ((((var_bglt) CREF(new1218_1958))->type) = ((type_bglt) type_1956), BUNSPEC);
					      ((((var_bglt) CREF(new1218_1958))->variable) = ((variable_bglt) variable_1957), BUNSPEC);
					      res1913_1965 = new1218_1958;
					   }
					}
					arg1735_1197 = res1913_1965;
				     }
				  }
				  {	/* ./Ieee/pair-list.scm 5689 */
				     obj_t aux_2700;
				     aux_2700 =
					(obj_t) (arg1735_1197);
				     newtail1597_1195 =
					MAKE_PAIR(aux_2700, BNIL);
				  }
			       }
			       SET_CDR(tail1596_1192, newtail1597_1195);
			       {
				  obj_t tail1596_2706;
				  obj_t l1593_2704;
				  l1593_2704 =
				     CDR(l1593_1191);
				  tail1596_2706 = newtail1597_1195;
				  tail1596_1192 = tail1596_2706;
				  l1593_1191 = l1593_2704;
				  goto lname1594_1193;
			       }
			    }
		       }
		    }
		  {	/* Globalize/loc2glo.scm 144 */
		     app_bglt res1914_1989;
		     {	/* Globalize/loc2glo.scm 144 */
			type_bglt type_1972;
			obj_t key_1974;
			type_1972 =
			   (type_bglt) (arg1725_1181);
			key_1974 =
			   BINT(((long) -1));
			{	/* ./Ast/node.scm 1172 */
			   app_bglt new1256_1978;
			   new1256_1978 =
			      ((app_bglt) BREF(GC_MALLOC(sizeof(struct app))));
			   {	/* ./Ast/node.scm 1172 */
			      long arg1863_1979;
			      arg1863_1979 =
				 class_num_218___object(app_ast_node);
			      {		/* ./Ast/node.scm 1172 */
				 obj_t obj_1987;
				 obj_1987 =
				    (obj_t) (new1256_1978);
				 (((obj_t) CREF(obj_1987))->header = MAKE_HEADER(arg1863_1979, 0), BUNSPEC);
			      }
			   }
			   {	/* ./Ast/node.scm 1172 */
			      object_bglt aux_2713;
			      aux_2713 =
				 (object_bglt) (new1256_1978);
			      OBJECT_WIDENING_SET(aux_2713, BFALSE);
			   }
			   ((((app_bglt) CREF(new1256_1978))->loc) = ((obj_t) loc_1150), BUNSPEC);
			   ((((app_bglt) CREF(new1256_1978))->type) = ((type_bglt) type_1972), BUNSPEC);
			   ((((app_bglt) CREF(new1256_1978))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
			   ((((app_bglt) CREF(new1256_1978))->key) = ((obj_t) key_1974), BUNSPEC);
			   ((((app_bglt) CREF(new1256_1978))->fun) = ((var_bglt) arg1727_1183), BUNSPEC);
			   ((((app_bglt) CREF(new1256_1978))->args) = ((obj_t) arg1728_1184), BUNSPEC);
			   ((((app_bglt) CREF(new1256_1978))->stack_info_255) = ((obj_t) BUNSPEC), BUNSPEC);
			   res1914_1989 = new1256_1978;
			}
		     }
		     arg1722_1178 = res1914_1989;
		  }
	       }
	       {	/* Globalize/loc2glo.scm 140 */
		  let_fun_218_bglt res1915_2006;
		  {	/* Globalize/loc2glo.scm 140 */
		     type_bglt type_1991;
		     obj_t key_1993;
		     node_bglt body_1995;
		     type_1991 =
			(type_bglt) (arg1719_1175);
		     key_1993 =
			BINT(((long) -1));
		     body_1995 =
			(node_bglt) (arg1722_1178);
		     {	/* ./Ast/node.scm 1241 */
			let_fun_218_bglt new1366_1996;
			new1366_1996 =
			   ((let_fun_218_bglt) BREF(GC_MALLOC(sizeof(struct let_fun_218))));
			{	/* ./Ast/node.scm 1241 */
			   long arg1845_1997;
			   arg1845_1997 =
			      class_num_218___object(let_fun_218_ast_node);
			   {	/* ./Ast/node.scm 1241 */
			      obj_t obj_2004;
			      obj_2004 =
				 (obj_t) (new1366_1996);
			      (((obj_t) CREF(obj_2004))->header = MAKE_HEADER(arg1845_1997, 0), BUNSPEC);
			   }
			}
			{	/* ./Ast/node.scm 1241 */
			   object_bglt aux_2730;
			   aux_2730 =
			      (object_bglt) (new1366_1996);
			   OBJECT_WIDENING_SET(aux_2730, BFALSE);
			}
			((((let_fun_218_bglt) CREF(new1366_1996))->loc) = ((obj_t) loc_1150), BUNSPEC);
			((((let_fun_218_bglt) CREF(new1366_1996))->type) = ((type_bglt) type_1991), BUNSPEC);
			((((let_fun_218_bglt) CREF(new1366_1996))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
			((((let_fun_218_bglt) CREF(new1366_1996))->key) = ((obj_t) key_1993), BUNSPEC);
			((((let_fun_218_bglt) CREF(new1366_1996))->locals) = ((obj_t) arg1721_1177), BUNSPEC);
			((((let_fun_218_bglt) CREF(new1366_1996))->body) = ((node_bglt) body_1995), BUNSPEC);
			res1915_2006 = new1366_1996;
		     }
		  }
		  arg1703_1156 = res1915_2006;
	       }
	    }
	    {	/* Globalize/loc2glo.scm 123 */
	       let_var_6_bglt res1916_2025;
	       {	/* Globalize/loc2glo.scm 123 */
		  type_bglt type_2008;
		  obj_t key_2010;
		  node_bglt body_2012;
		  type_2008 =
		     (type_bglt) (arg1700_1153);
		  key_2010 =
		     BINT(((long) -1));
		  body_2012 =
		     (node_bglt) (arg1703_1156);
		  {	/* ./Ast/node.scm 1248 */
		     let_var_6_bglt new1381_2014;
		     new1381_2014 =
			((let_var_6_bglt) BREF(GC_MALLOC(sizeof(struct let_var_6))));
		     {	/* ./Ast/node.scm 1248 */
			long arg1843_2015;
			arg1843_2015 =
			   class_num_218___object(let_var_6_ast_node);
			{	/* ./Ast/node.scm 1248 */
			   obj_t obj_2023;
			   obj_2023 =
			      (obj_t) (new1381_2014);
			   (((obj_t) CREF(obj_2023))->header = MAKE_HEADER(arg1843_2015, 0), BUNSPEC);
			}
		     }
		     {	/* ./Ast/node.scm 1248 */
			object_bglt aux_2746;
			aux_2746 =
			   (object_bglt) (new1381_2014);
			OBJECT_WIDENING_SET(aux_2746, BFALSE);
		     }
		     ((((let_var_6_bglt) CREF(new1381_2014))->loc) = ((obj_t) loc_1150), BUNSPEC);
		     ((((let_var_6_bglt) CREF(new1381_2014))->type) = ((type_bglt) type_2008), BUNSPEC);
		     ((((let_var_6_bglt) CREF(new1381_2014))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
		     ((((let_var_6_bglt) CREF(new1381_2014))->key) = ((obj_t) key_2010), BUNSPEC);
		     ((((let_var_6_bglt) CREF(new1381_2014))->bindings) = ((obj_t) arg1702_1155), BUNSPEC);
		     ((((let_var_6_bglt) CREF(new1381_2014))->body) = ((node_bglt) body_2012), BUNSPEC);
		     ((((let_var_6_bglt) CREF(new1381_2014))->removable__42) = ((bool_t) ((bool_t) 1)), BUNSPEC);
		     res1916_2025 = new1381_2014;
		  }
	       }
	       return
		  (node_bglt) (res1916_2025);
	    }
	 }
      }
   }
}



/* fix-non-escaping-definition */
global_bglt 
fix_non_escaping_definition_247_globalize_local__global_194(global_bglt global_13, local_bglt local_14, obj_t args_15, obj_t kaptured_16, obj_t body_17)
{
   AN_OBJECT;
   {	/* Globalize/loc2glo.scm 161 */
      {		/* Globalize/loc2glo.scm 162 */
	 obj_t add_args_4_1204;
	 if (
	    NULLP(kaptured_16))
	   {	/* Globalize/loc2glo.scm 162 */
	      add_args_4_1204 = BNIL;
	   }
	 else
	   {	/* Globalize/loc2glo.scm 162 */
	      obj_t head1601_1253;
	      head1601_1253 =
		 MAKE_PAIR(BNIL, BNIL);
	      {
		 obj_t l1599_1254;
		 obj_t tail1602_1255;
		 l1599_1254 = kaptured_16;
		 tail1602_1255 = head1601_1253;
	       lname1600_1256:
		 if (
		    NULLP(l1599_1254))
		   {	/* Globalize/loc2glo.scm 162 */
		      add_args_4_1204 =
			 CDR(head1601_1253);
		   }
		 else
		   {	/* Globalize/loc2glo.scm 163 */
		      obj_t newtail1603_1258;
		      {		/* Globalize/loc2glo.scm 163 */
			 local_bglt arg1780_1260;
			 {	/* Globalize/loc2glo.scm 163 */
			    obj_t old_1262;
			    old_1262 =
			       CAR(l1599_1254);
			    {	/* Globalize/loc2glo.scm 163 */
			       local_bglt new_1263;
			       {	/* Globalize/loc2glo.scm 163 */
				  type_bglt aux_2767;
				  obj_t aux_2764;
				  {	/* Globalize/loc2glo.scm 163 */
				     obj_t aux_2768;
				     aux_2768 =
					default_type_190_globalize_local__global_194();
				     aux_2767 =
					(type_bglt) (aux_2768);
				  }
				  {	/* Globalize/loc2glo.scm 163 */
				     local_bglt obj_2032;
				     obj_2032 =
					(local_bglt) (old_1262);
				     aux_2764 =
					(((local_bglt) CREF(obj_2032))->id);
				  }
				  new_1263 =
				     make_local_svar_140_ast_local(aux_2764, aux_2767);
			       }
			       {	/* Globalize/loc2glo.scm 165 */
				  bool_t arg1782_1264;
				  {	/* Globalize/loc2glo.scm 165 */
				     local_bglt obj_2033;
				     obj_2033 =
					(local_bglt) (old_1262);
				     arg1782_1264 =
					(((local_bglt) CREF(obj_2033))->user__32);
				  }
				  ((((local_bglt) CREF(new_1263))->user__32) = ((bool_t) arg1782_1264), BUNSPEC);
			       }
			       {	/* Globalize/loc2glo.scm 166 */
				  local_ginfo_108_bglt obj1604_1265;
				  obj1604_1265 =
				     ((local_ginfo_108_bglt) (new_1263));
				  {	/* Globalize/loc2glo.scm 166 */
				     local_ginfo_108_bglt arg1783_1266;
				     {	/* Globalize/loc2glo.scm 166 */
					local_ginfo_108_bglt res1917_2039;
					{	/* ./Globalize/ginfo.scm 1552 */
					   local_ginfo_108_bglt new1535_2037;
					   new1535_2037 =
					      ((local_ginfo_108_bglt) BREF(GC_MALLOC(sizeof(struct local_ginfo_108))));
					   ((((local_ginfo_108_bglt) CREF(new1535_2037))->escape__117) = ((bool_t) ((bool_t) 0)), BUNSPEC);
					   res1917_2039 = new1535_2037;
					}
					arg1783_1266 = res1917_2039;
				     }
				     {	/* Globalize/loc2glo.scm 166 */
					obj_t aux_2780;
					object_bglt aux_2778;
					aux_2780 =
					   (obj_t) (arg1783_1266);
					aux_2778 =
					   (object_bglt) (obj1604_1265);
					OBJECT_WIDENING_SET(aux_2778, aux_2780);
				     }
				  }
				  {	/* Globalize/loc2glo.scm 166 */
				     long arg1784_1267;
				     arg1784_1267 =
					class_num_218___object(local_ginfo_108_globalize_ginfo);
				     {	/* Globalize/loc2glo.scm 166 */
					obj_t obj_2040;
					obj_2040 =
					   (obj_t) (obj1604_1265);
					(((obj_t) CREF(obj_2040))->header = MAKE_HEADER(arg1784_1267, 0), BUNSPEC);
				     }
				  }
				  obj1604_1265;
			       }
			       {	/* Globalize/loc2glo.scm 167 */
				  svar_ginfo_131_bglt obj1605_1268;
				  obj1605_1268 =
				     ((svar_ginfo_131_bglt) (
					(((local_bglt) CREF(new_1263))->value)));
				  {	/* Globalize/loc2glo.scm 167 */
				     svar_ginfo_131_bglt arg1785_1269;
				     {	/* Globalize/loc2glo.scm 167 */
					svar_ginfo_131_bglt res1918_2052;
					{	/* ./Globalize/ginfo.scm 1532 */
					   svar_ginfo_131_bglt new1502_2047;
					   new1502_2047 =
					      ((svar_ginfo_131_bglt) BREF(GC_MALLOC(sizeof(struct svar_ginfo_131))));
					   ((((svar_ginfo_131_bglt) CREF(new1502_2047))->kaptured__204) = ((bool_t) ((bool_t) 1)), BUNSPEC);
					   ((((svar_ginfo_131_bglt) CREF(new1502_2047))->free_mark_81) = ((long) ((long) -10)), BUNSPEC);
					   ((((svar_ginfo_131_bglt) CREF(new1502_2047))->mark) = ((long) ((long) -10)), BUNSPEC);
					   ((((svar_ginfo_131_bglt) CREF(new1502_2047))->celled__113) = ((bool_t) ((bool_t) 0)), BUNSPEC);
					   res1918_2052 = new1502_2047;
					}
					arg1785_1269 = res1918_2052;
				     }
				     {	/* Globalize/loc2glo.scm 167 */
					obj_t aux_2795;
					object_bglt aux_2793;
					aux_2795 =
					   (obj_t) (arg1785_1269);
					aux_2793 =
					   (object_bglt) (obj1605_1268);
					OBJECT_WIDENING_SET(aux_2793, aux_2795);
				     }
				  }
				  {	/* Globalize/loc2glo.scm 167 */
				     long arg1789_1273;
				     arg1789_1273 =
					class_num_218___object(svar_ginfo_131_globalize_ginfo);
				     {	/* Globalize/loc2glo.scm 167 */
					obj_t obj_2053;
					obj_2053 =
					   (obj_t) (obj1605_1268);
					(((obj_t) CREF(obj_2053))->header = MAKE_HEADER(arg1789_1273, 0), BUNSPEC);
				     }
				  }
				  obj1605_1268;
			       }
			       {	/* Globalize/loc2glo.scm 169 */
				  obj_t arg1790_1274;
				  {	/* Globalize/loc2glo.scm 169 */
				     local_bglt obj_2055;
				     obj_2055 =
					(local_bglt) (old_1262);
				     arg1790_1274 =
					(((local_bglt) CREF(obj_2055))->access);
				  }
				  ((((local_bglt) CREF(new_1263))->access) = ((obj_t) arg1790_1274), BUNSPEC);
			       }
			       arg1780_1260 = new_1263;
			    }
			 }
			 {	/* ./Ieee/pair-list.scm 5689 */
			    obj_t aux_2804;
			    aux_2804 =
			       (obj_t) (arg1780_1260);
			    newtail1603_1258 =
			       MAKE_PAIR(aux_2804, BNIL);
			 }
		      }
		      SET_CDR(tail1602_1255, newtail1603_1258);
		      {
			 obj_t tail1602_2810;
			 obj_t l1599_2808;
			 l1599_2808 =
			    CDR(l1599_1254);
			 tail1602_2810 = newtail1603_1258;
			 tail1602_1255 = tail1602_2810;
			 l1599_1254 = l1599_2808;
			 goto lname1600_1256;
		      }
		   }
	      }
	   }
	 {	/* Globalize/loc2glo.scm 172 */
	    sfun_bglt new_fun_115_1206;
	    {	/* Globalize/loc2glo.scm 173 */
	       sfun_bglt duplicated1606_1234;
	       {	/* Globalize/loc2glo.scm 173 */
		  value_bglt aux_2811;
		  aux_2811 =
		     (((local_bglt) CREF(local_14))->value);
		  duplicated1606_1234 =
		     (sfun_bglt) (aux_2811);
	       }
	       {	/* Globalize/loc2glo.scm 174 */
		  sfun_bglt new1607_1235;
		  {	/* Globalize/loc2glo.scm 174 */
		     obj_t arg1762_1236;
		     obj_t arg1763_1237;
		     obj_t arg1764_1238;
		     obj_t arg1765_1239;
		     bool_t arg1766_1240;
		     obj_t arg1767_1241;
		     obj_t arg1768_1242;
		     obj_t arg1769_1243;
		     obj_t arg1770_1244;
		     obj_t arg1771_1245;
		     obj_t arg1772_1246;
		     obj_t arg1773_1247;
		     {	/* Globalize/loc2glo.scm 174 */
			obj_t aux_2818;
			obj_t aux_2814;
			{	/* Globalize/loc2glo.scm 174 */
			   long aux_2819;
			   aux_2819 =
			      list_length(kaptured_16);
			   aux_2818 =
			      BINT(aux_2819);
			}
			{	/* Globalize/loc2glo.scm 174 */
			   long aux_2815;
			   aux_2815 =
			      (((sfun_bglt) CREF(duplicated1606_1234))->arity);
			   aux_2814 =
			      BINT(aux_2815);
			}
			arg1762_1236 =
			   __arity_132_tools_args(aux_2814, aux_2818);
		     }
		     arg1763_1237 =
			(((sfun_bglt) CREF(duplicated1606_1234))->side_effect__165);
		     arg1764_1238 =
			(((sfun_bglt) CREF(duplicated1606_1234))->predicate_of_78);
		     arg1765_1239 =
			(((sfun_bglt) CREF(duplicated1606_1234))->stack_allocator_172);
		     arg1766_1240 =
			(((sfun_bglt) CREF(duplicated1606_1234))->top__138);
		     arg1767_1241 =
			(((sfun_bglt) CREF(duplicated1606_1234))->the_closure_238);
		     arg1768_1242 =
			(((sfun_bglt) CREF(duplicated1606_1234))->property);
		     arg1769_1243 =
			append_2_18___r4_pairs_and_lists_6_3(
			reverse___r4_pairs_and_lists_6_3(add_args_4_1204), args_15);
		     arg1770_1244 =
			(((sfun_bglt) CREF(duplicated1606_1234))->body);
		     arg1771_1245 =
			(((sfun_bglt) CREF(duplicated1606_1234))->class);
		     arg1772_1246 =
			(((sfun_bglt) CREF(duplicated1606_1234))->dsssl_keywords_243);
		     arg1773_1247 =
			(((sfun_bglt) CREF(duplicated1606_1234))->loc);
		     {	/* Globalize/loc2glo.scm 173 */
			sfun_bglt res1919_2103;
			{	/* Globalize/loc2glo.scm 173 */
			   long arity_2075;
			   arity_2075 =
			      (long) CINT(arg1762_1236);
			   {	/* ./Ast/var.scm 1061 */
			      sfun_bglt new1135_2087;
			      new1135_2087 =
				 ((sfun_bglt) BREF(GC_MALLOC(sizeof(struct sfun))));
			      {		/* ./Ast/var.scm 1061 */
				 long arg1890_2088;
				 arg1890_2088 =
				    class_num_218___object(sfun_ast_var);
				 {	/* ./Ast/var.scm 1061 */
				    obj_t obj_2101;
				    obj_2101 =
				       (obj_t) (new1135_2087);
				    (((obj_t) CREF(obj_2101))->header = MAKE_HEADER(arg1890_2088, 0), BUNSPEC);
				 }
			      }
			      {		/* ./Ast/var.scm 1061 */
				 object_bglt aux_2840;
				 aux_2840 =
				    (object_bglt) (new1135_2087);
				 OBJECT_WIDENING_SET(aux_2840, BFALSE);
			      }
			      ((((sfun_bglt) CREF(new1135_2087))->arity) = ((long) arity_2075), BUNSPEC);
			      ((((sfun_bglt) CREF(new1135_2087))->side_effect__165) = ((obj_t) arg1763_1237), BUNSPEC);
			      ((((sfun_bglt) CREF(new1135_2087))->predicate_of_78) = ((obj_t) arg1764_1238), BUNSPEC);
			      ((((sfun_bglt) CREF(new1135_2087))->stack_allocator_172) = ((obj_t) arg1765_1239), BUNSPEC);
			      ((((sfun_bglt) CREF(new1135_2087))->top__138) = ((bool_t) arg1766_1240), BUNSPEC);
			      ((((sfun_bglt) CREF(new1135_2087))->the_closure_238) = ((obj_t) arg1767_1241), BUNSPEC);
			      ((((sfun_bglt) CREF(new1135_2087))->property) = ((obj_t) arg1768_1242), BUNSPEC);
			      ((((sfun_bglt) CREF(new1135_2087))->args) = ((obj_t) arg1769_1243), BUNSPEC);
			      ((((sfun_bglt) CREF(new1135_2087))->body) = ((obj_t) arg1770_1244), BUNSPEC);
			      ((((sfun_bglt) CREF(new1135_2087))->class) = ((obj_t) arg1771_1245), BUNSPEC);
			      ((((sfun_bglt) CREF(new1135_2087))->dsssl_keywords_243) = ((obj_t) arg1772_1246), BUNSPEC);
			      ((((sfun_bglt) CREF(new1135_2087))->loc) = ((obj_t) arg1773_1247), BUNSPEC);
			      res1919_2103 = new1135_2087;
			   }
			}
			new1607_1235 = res1919_2103;
		     }
		  }
		  {	/* Globalize/loc2glo.scm 173 */

		     new_fun_115_1206 = new1607_1235;
		  }
	       }
	    }
	    {	/* Globalize/loc2glo.scm 173 */

	       {	/* Globalize/loc2glo.scm 176 */
		  local_ginfo_108_bglt obj_2104;
		  obj_2104 =
		     (local_ginfo_108_bglt) (local_14);
		  {
		     obj_t aux_2856;
		     {	/* ./Globalize/ginfo.scm 1554 */
			object_bglt aux_2857;
			aux_2857 =
			   (object_bglt) (obj_2104);
			aux_2856 =
			   OBJECT_WIDENING(aux_2857);
		     }
		     ((((local_ginfo_108_bglt) CREF(aux_2856))->escape__117) = ((bool_t) ((bool_t) 0)), BUNSPEC);
		  }
	       }
	       {	/* Globalize/loc2glo.scm 177 */
		  global_ginfo_75_bglt obj_2106;
		  obj_2106 =
		     (global_ginfo_75_bglt) (global_13);
		  {
		     obj_t aux_2862;
		     {	/* ./Globalize/ginfo.scm 1558 */
			object_bglt aux_2863;
			aux_2863 =
			   (object_bglt) (obj_2106);
			aux_2862 =
			   OBJECT_WIDENING(aux_2863);
		     }
		     ((((global_ginfo_75_bglt) CREF(aux_2862))->escape__117) = ((bool_t) ((bool_t) 1)), BUNSPEC);
		  }
	       }
	       {	/* Globalize/loc2glo.scm 178 */
		  type_bglt arg1742_1207;
		  arg1742_1207 =
		     (((local_bglt) CREF(local_14))->type);
		  ((((global_bglt) CREF(global_13))->type) = ((type_bglt) arg1742_1207), BUNSPEC);
	       }
	       {	/* Globalize/loc2glo.scm 181 */
		  node_bglt arg1743_1208;
		  {	/* Globalize/loc2glo.scm 181 */
		     obj_t arg1744_1209;
		     obj_t arg1745_1210;
		     {	/* Globalize/loc2glo.scm 180 */
			sfun_ginfo_98_bglt obj_2112;
			{	/* Globalize/loc2glo.scm 180 */
			   value_bglt aux_2869;
			   aux_2869 =
			      (((local_bglt) CREF(local_14))->value);
			   obj_2112 =
			      (sfun_ginfo_98_bglt) (aux_2869);
			}
			{
			   obj_t aux_2872;
			   {	/* ./Globalize/ginfo.scm 1522 */
			      object_bglt aux_2873;
			      aux_2873 =
				 (object_bglt) (obj_2112);
			      aux_2872 =
				 OBJECT_WIDENING(aux_2873);
			   }
			   arg1744_1209 =
			      (((sfun_ginfo_98_bglt) CREF(aux_2872))->new_body_215);
			}
		     }
		     if (
			NULLP(kaptured_16))
		       {	/* Globalize/loc2glo.scm 183 */
			  arg1745_1210 = BNIL;
		       }
		     else
		       {	/* Globalize/loc2glo.scm 183 */
			  obj_t head1610_1215;
			  {	/* Globalize/loc2glo.scm 183 */
			     obj_t arg1758_1230;
			     {	/* ./Ieee/pair-list.scm 5689 */
				obj_t aux_2881;
				obj_t aux_2879;
				aux_2881 =
				   CAR(add_args_4_1204);
				aux_2879 =
				   CAR(kaptured_16);
				arg1758_1230 =
				   MAKE_PAIR(aux_2879, aux_2881);
			     }
			     head1610_1215 =
				MAKE_PAIR(arg1758_1230, BNIL);
			  }
			  {
			     obj_t ll1608_1216;
			     obj_t ll1609_1217;
			     obj_t tail1611_1218;
			     ll1608_1216 =
				CDR(kaptured_16);
			     ll1609_1217 =
				CDR(add_args_4_1204);
			     tail1611_1218 = head1610_1215;
			   lname1613_1219:
			     if (
				NULLP(ll1608_1216))
			       {	/* Globalize/loc2glo.scm 183 */
				  arg1745_1210 = head1610_1215;
			       }
			     else
			       {	/* Globalize/loc2glo.scm 183 */
				  obj_t newtail1612_1223;
				  {	/* Globalize/loc2glo.scm 183 */
				     obj_t arg1753_1226;
				     {	/* ./Ieee/pair-list.scm 5689 */
					obj_t aux_2889;
					obj_t aux_2887;
					aux_2889 =
					   CAR(ll1609_1217);
					aux_2887 =
					   CAR(ll1608_1216);
					arg1753_1226 =
					   MAKE_PAIR(aux_2887, aux_2889);
				     }
				     newtail1612_1223 =
					MAKE_PAIR(arg1753_1226, BNIL);
				  }
				  SET_CDR(tail1611_1218, newtail1612_1223);
				  {
				     obj_t tail1611_2898;
				     obj_t ll1609_2896;
				     obj_t ll1608_2894;
				     ll1608_2894 =
					CDR(ll1608_1216);
				     ll1609_2896 =
					CDR(ll1609_1217);
				     tail1611_2898 = newtail1612_1223;
				     tail1611_1218 = tail1611_2898;
				     ll1609_1217 = ll1609_2896;
				     ll1608_1216 = ll1608_2894;
				     goto lname1613_1219;
				  }
			       }
			  }
		       }
		     arg1743_1208 =
			node_globalize__229_globalize_node(
			(node_bglt) (arg1744_1209),
			(variable_bglt) (local_14), arg1745_1210);
		  }
		  {	/* Globalize/loc2glo.scm 179 */
		     obj_t val1131_2134;
		     val1131_2134 =
			(obj_t) (arg1743_1208);
		     ((((sfun_bglt) CREF(new_fun_115_1206))->body) = ((obj_t) val1131_2134), BUNSPEC);
		  }
	       }
	       {	/* Globalize/loc2glo.scm 184 */
		  value_bglt val1061_2136;
		  val1061_2136 =
		     (value_bglt) (new_fun_115_1206);
		  ((((global_bglt) CREF(global_13))->value) = ((value_bglt) val1061_2136), BUNSPEC);
	       }
	       return global_13;
	    }
	 }
      }
   }
}



/* the-global */
global_bglt 
the_global_201_globalize_local__global_194(local_bglt local_18)
{
   AN_OBJECT;
   {	/* Globalize/loc2glo.scm 193 */
      {		/* Globalize/loc2glo.scm 194 */
	 value_bglt value_1277;
	 value_1277 =
	    (((local_bglt) CREF(local_18))->value);
	 {	/* Globalize/loc2glo.scm 195 */
	    bool_t test1793_1278;
	    {	/* ./Ast/var.scm 1021 */
	       obj_t aux_2909;
	       {	/* Globalize/loc2glo.scm 195 */
		  sfun_ginfo_98_bglt obj_2138;
		  obj_2138 =
		     (sfun_ginfo_98_bglt) (value_1277);
		  {
		     obj_t aux_2911;
		     {	/* ./Globalize/ginfo.scm 1518 */
			object_bglt aux_2912;
			aux_2912 =
			   (object_bglt) (obj_2138);
			aux_2911 =
			   OBJECT_WIDENING(aux_2912);
		     }
		     aux_2909 =
			(((sfun_ginfo_98_bglt) CREF(aux_2911))->the_global_201);
		  }
	       }
	       test1793_1278 =
		  is_a__118___object(aux_2909, global_ast_var);
	    }
	    if (test1793_1278)
	      {		/* Globalize/loc2glo.scm 196 */
		 sfun_ginfo_98_bglt obj_2140;
		 obj_2140 =
		    (sfun_ginfo_98_bglt) (value_1277);
		 {	/* ./Globalize/ginfo.scm 1518 */
		    obj_t aux_2919;
		    {
		       obj_t aux_2920;
		       {	/* ./Globalize/ginfo.scm 1518 */
			  object_bglt aux_2921;
			  aux_2921 =
			     (object_bglt) (obj_2140);
			  aux_2920 =
			     OBJECT_WIDENING(aux_2921);
		       }
		       aux_2919 =
			  (((sfun_ginfo_98_bglt) CREF(aux_2920))->the_global_201);
		    }
		    return
		       (global_bglt) (aux_2919);
		 }
	      }
	    else
	      {		/* Globalize/loc2glo.scm 197 */
		 obj_t id_1279;
		 {	/* Globalize/loc2glo.scm 197 */
		    bool_t test1803_1290;
		    {	/* Globalize/loc2glo.scm 197 */
		       obj_t arg1810_1296;
		       arg1810_1296 =
			  find_global_module_25_ast_env(
			  (((local_bglt) CREF(local_18))->id), _module__166_module_module);
		       test1803_1290 =
			  is_a__118___object(arg1810_1296, global_ast_var);
		    }
		    if (test1803_1290)
		      {		/* Globalize/loc2glo.scm 199 */
			 obj_t arg1804_1291;
			 {	/* Globalize/loc2glo.scm 199 */
			    obj_t arg1805_1292;
			    arg1805_1292 =
			       (((local_bglt) CREF(local_18))->id);
			    {	/* Globalize/loc2glo.scm 199 */
			       obj_t list1807_1294;
			       {	/* Globalize/loc2glo.scm 199 */
				  obj_t arg1809_1295;
				  {	/* Globalize/loc2glo.scm 199 */
				     obj_t aux_2931;
				     aux_2931 =
					CNST_TABLE_REF(((long) 3));
				     arg1809_1295 =
					MAKE_PAIR(aux_2931, BNIL);
				  }
				  list1807_1294 =
				     MAKE_PAIR(arg1805_1292, arg1809_1295);
			       }
			       arg1804_1291 =
				  symbol_append_197___r4_symbols_6_4(list1807_1294);
			    }
			 }
			 id_1279 =
			    PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4, arg1804_1291, BEOA);
		      }
		    else
		      {		/* Globalize/loc2glo.scm 197 */
			 id_1279 =
			    (((local_bglt) CREF(local_18))->id);
		      }
		 }
		 {	/* Globalize/loc2glo.scm 197 */
		    global_bglt global_1280;
		    global_1280 =
		       def_global_sfun_no_warning__10_ast_glo_def_117(id_1279, BNIL, BNIL, _module__166_module_module,
		       CNST_TABLE_REF(((long) 4)),
		       CNST_TABLE_REF(((long) 5)),
		       CNST_TABLE_REF(((long) 6)), BUNSPEC);
		    {	/* Globalize/loc2glo.scm 201 */

		       {	/* Globalize/loc2glo.scm 214 */
			  obj_t arg1795_1282;
			  {	/* Globalize/loc2glo.scm 214 */
			     sfun_bglt obj_2146;
			     obj_2146 =
				(sfun_bglt) (value_1277);
			     arg1795_1282 =
				(((sfun_bglt) CREF(obj_2146))->loc);
			  }
			  {	/* Globalize/loc2glo.scm 214 */
			     sfun_bglt obj_2147;
			     {	/* Globalize/loc2glo.scm 214 */
				value_bglt aux_2945;
				aux_2945 =
				   (((global_bglt) CREF(global_1280))->value);
				obj_2147 =
				   (sfun_bglt) (aux_2945);
			     }
			     ((((sfun_bglt) CREF(obj_2147))->loc) = ((obj_t) arg1795_1282), BUNSPEC);
			  }
		       }
		       {	/* Globalize/loc2glo.scm 216 */
			  type_bglt arg1796_1283;
			  arg1796_1283 =
			     (((local_bglt) CREF(local_18))->type);
			  ((((global_bglt) CREF(global_1280))->type) = ((type_bglt) arg1796_1283), BUNSPEC);
		       }
		       if (
			  (((local_bglt) CREF(local_18))->user__32))
			 {	/* Globalize/loc2glo.scm 218 */
			    BUNSPEC;
			 }
		       else
			 {	/* Globalize/loc2glo.scm 218 */
			    ((((global_bglt) CREF(global_1280))->user__32) = ((bool_t) ((bool_t) 0)), BUNSPEC);
			 }
		       {	/* Globalize/loc2glo.scm 220 */
			  global_ginfo_75_bglt obj1614_1285;
			  obj1614_1285 =
			     ((global_ginfo_75_bglt) (global_1280));
			  {	/* Globalize/loc2glo.scm 220 */
			     global_ginfo_75_bglt arg1798_1286;
			     {	/* Globalize/loc2glo.scm 220 */
				global_ginfo_75_bglt res1920_2160;
				{	/* Globalize/loc2glo.scm 220 */
				   obj_t global_closure_229_2156;
				   global_closure_229_2156 = BFALSE;
				   {	/* ./Globalize/ginfo.scm 1556 */
				      global_ginfo_75_bglt new1555_2157;
				      new1555_2157 =
					 ((global_ginfo_75_bglt) BREF(GC_MALLOC(sizeof(struct global_ginfo_75))));
				      ((((global_ginfo_75_bglt) CREF(new1555_2157))->escape__117) = ((bool_t) ((bool_t) 0)), BUNSPEC);
				      ((((global_ginfo_75_bglt) CREF(new1555_2157))->global_closure_229) = ((obj_t) global_closure_229_2156), BUNSPEC);
				      res1920_2160 = new1555_2157;
				   }
				}
				arg1798_1286 = res1920_2160;
			     }
			     {	/* Globalize/loc2glo.scm 220 */
				obj_t aux_2960;
				object_bglt aux_2958;
				aux_2960 =
				   (obj_t) (arg1798_1286);
				aux_2958 =
				   (object_bglt) (obj1614_1285);
				OBJECT_WIDENING_SET(aux_2958, aux_2960);
			     }
			  }
			  {	/* Globalize/loc2glo.scm 220 */
			     long arg1800_1287;
			     arg1800_1287 =
				class_num_218___object(global_ginfo_75_globalize_ginfo);
			     {	/* Globalize/loc2glo.scm 220 */
				obj_t obj_2161;
				obj_2161 =
				   (obj_t) (obj1614_1285);
				(((obj_t) CREF(obj_2161))->header = MAKE_HEADER(arg1800_1287, 0), BUNSPEC);
			     }
			  }
			  obj1614_1285;
		       }
		       {	/* Globalize/loc2glo.scm 221 */
			  obj_t arg1802_1289;
			  {	/* Globalize/loc2glo.scm 222 */
			     sfun_bglt obj_2164;
			     obj_2164 =
				(sfun_bglt) (value_1277);
			     arg1802_1289 =
				(((sfun_bglt) CREF(obj_2164))->side_effect__165);
			  }
			  {	/* Globalize/loc2glo.scm 221 */
			     sfun_bglt obj_2165;
			     {	/* Globalize/loc2glo.scm 221 */
				value_bglt aux_2968;
				aux_2968 =
				   (((global_bglt) CREF(global_1280))->value);
				obj_2165 =
				   (sfun_bglt) (aux_2968);
			     }
			     ((((sfun_bglt) CREF(obj_2165))->side_effect__165) = ((obj_t) arg1802_1289), BUNSPEC);
			  }
		       }
		       {	/* Globalize/loc2glo.scm 223 */
			  sfun_ginfo_98_bglt obj_2167;
			  obj_t val1467_2168;
			  obj_2167 =
			     (sfun_ginfo_98_bglt) (value_1277);
			  val1467_2168 =
			     (obj_t) (global_1280);
			  {
			     obj_t aux_2974;
			     {	/* ./Globalize/ginfo.scm 1518 */
				object_bglt aux_2975;
				aux_2975 =
				   (object_bglt) (obj_2167);
				aux_2974 =
				   OBJECT_WIDENING(aux_2975);
			     }
			     ((((sfun_ginfo_98_bglt) CREF(aux_2974))->the_global_201) = ((obj_t) val1467_2168), BUNSPEC);
			  }
		       }
		       return global_1280;
		    }
		 }
	      }
	 }
      }
   }
}



/* _the-global1922 */
obj_t 
_the_global1922_161_globalize_local__global_194(obj_t env_2304, obj_t local_2305)
{
   AN_OBJECT;
   {	/* Globalize/loc2glo.scm 193 */
      {		/* Globalize/loc2glo.scm 193 */
	 global_bglt aux_2979;
	 aux_2979 =
	    the_global_201_globalize_local__global_194(
	    (local_bglt) (local_2305));
	 return
	    (obj_t) (aux_2979);
      }
   }
}



/* method-init */
obj_t 
method_init_76_globalize_local__global_194()
{
   AN_OBJECT;
   {	/* Globalize/loc2glo.scm 14 */
      return BUNSPEC;
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_globalize_local__global_194()
{
   AN_OBJECT;
   {	/* Globalize/loc2glo.scm 14 */
      module_initialization_70_tools_trace(((long) 0), "GLOBALIZE_LOCAL->GLOBAL");
      module_initialization_70_tools_shape(((long) 0), "GLOBALIZE_LOCAL->GLOBAL");
      module_initialization_70_tools_args(((long) 0), "GLOBALIZE_LOCAL->GLOBAL");
      module_initialization_70_engine_param(((long) 0), "GLOBALIZE_LOCAL->GLOBAL");
      module_initialization_70_module_module(((long) 0), "GLOBALIZE_LOCAL->GLOBAL");
      module_initialization_70_type_type(((long) 0), "GLOBALIZE_LOCAL->GLOBAL");
      module_initialization_70_type_cache(((long) 0), "GLOBALIZE_LOCAL->GLOBAL");
      module_initialization_70_ast_var(((long) 0), "GLOBALIZE_LOCAL->GLOBAL");
      module_initialization_70_ast_node(((long) 0), "GLOBALIZE_LOCAL->GLOBAL");
      module_initialization_70_ast_local(((long) 0), "GLOBALIZE_LOCAL->GLOBAL");
      module_initialization_70_ast_glo_def_117(((long) 0), "GLOBALIZE_LOCAL->GLOBAL");
      module_initialization_70_ast_sexp(((long) 0), "GLOBALIZE_LOCAL->GLOBAL");
      module_initialization_70_ast_env(((long) 0), "GLOBALIZE_LOCAL->GLOBAL");
      module_initialization_70_globalize_ginfo(((long) 0), "GLOBALIZE_LOCAL->GLOBAL");
      module_initialization_70_globalize_node(((long) 0), "GLOBALIZE_LOCAL->GLOBAL");
      return
	 module_initialization_70_globalize_free(((long) 0), "GLOBALIZE_LOCAL->GLOBAL");
   }
}
