/*===========================================================================*/
/*   (Globalize/new-body.scm)                                                */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;

typedef struct sfun_ginfo_98
  {
     bool_t g__219;
     obj_t cfrom;
     obj_t cfrom__119;
     obj_t cto;
     obj_t cto__14;
     obj_t cfunction;
     obj_t integrator;
     obj_t integrated;
     obj_t plugged_in_15;
     long mark;
     obj_t free_mark_81;
     obj_t the_global_201;
     obj_t kaptured;
     obj_t new_body_215;
     long bmark;
     long umark;
     obj_t free;
     obj_t bound;
  }
             *sfun_ginfo_98_bglt;

typedef struct svar_ginfo_131
  {
     bool_t kaptured__204;
     long free_mark_81;
     long mark;
     bool_t celled__113;
  }
              *svar_ginfo_131_bglt;

typedef struct sexit_ginfo_81
  {
     bool_t g__219;
     bool_t kaptured__204;
     long free_mark_81;
     long mark;
  }
              *sexit_ginfo_81_bglt;

typedef struct local_ginfo_108
  {
     bool_t escape__117;
  }
               *local_ginfo_108_bglt;

typedef struct global_ginfo_75
  {
     bool_t escape__117;
     obj_t global_closure_229;
  }
               *global_ginfo_75_bglt;


static obj_t method_init_76_globalize_new_body_146();
extern obj_t make_box_202_ast_node;
static bool_t is_in__90_globalize_new_body_146(obj_t, obj_t);
extern obj_t funcall_ast_node;
extern long add_inlined_method__244___object(obj_t, obj_t, long);
extern obj_t fail_ast_node;
extern obj_t box_ref_242_ast_node;
extern obj_t sequence_ast_node;
extern obj_t let_var_6_ast_node;
extern obj_t var_ast_node;
static long _round__57_globalize_new_body_146;
extern obj_t pragma_ast_node;
extern obj_t set_ex_it_116_ast_node;
extern obj_t set_globalized_new_bodies__10_globalize_new_body_146(global_bglt, obj_t);
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t module_initialization_70_globalize_new_body_146(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_speek(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_ast_sexp(long, char *);
extern obj_t module_initialization_70_globalize_ginfo(long, char *);
extern obj_t module_initialization_70_globalize_node(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern long class_num_218___object(obj_t);
extern obj_t let_fun_218_ast_node;
static obj_t imported_modules_init_94_globalize_new_body_146();
static obj_t _rem__default1581_159_globalize_new_body_146(obj_t, obj_t, obj_t, obj_t);
extern obj_t app_ly_162_ast_node;
extern obj_t add_generic__110___object(obj_t, obj_t);
extern obj_t app_ast_node;
static obj_t library_modules_init_112_globalize_new_body_146();
static node_bglt rem__default1581_181_globalize_new_body_146(node_bglt, obj_t, obj_t);
extern obj_t atom_ast_node;
extern obj_t cast_ast_node;
static obj_t toplevel_init_63_globalize_new_body_146();
extern obj_t jump_ex_it_184_ast_node;
extern obj_t open_input_string(obj_t);
extern obj_t kwote_ast_node;
extern obj_t setq_ast_node;
extern obj_t box_set__221_ast_node;
static obj_t _rem__41_globalize_new_body_146(obj_t, obj_t, obj_t, obj_t);
extern obj_t local_ast_var;
extern obj_t memq___r4_pairs_and_lists_6_3(obj_t, obj_t);
static obj_t rem___100_globalize_new_body_146(obj_t, obj_t, obj_t);
extern obj_t _classes__134___object;
static node_bglt rem__73_globalize_new_body_146(node_bglt, obj_t, obj_t);
extern obj_t select_ast_node;
extern obj_t read___reader(obj_t);
static obj_t set_globalized_new_body__17_globalize_new_body_146(obj_t);
static obj_t require_initialization_114_globalize_new_body_146 = BUNSPEC;
extern obj_t conditional_ast_node;
static obj_t _set_globalized_new_bodies__36_globalize_new_body_146(obj_t, obj_t, obj_t);
static obj_t cnst_init_137_globalize_new_body_146();
static obj_t __cnst[2];

DEFINE_STATIC_GENERIC(rem__env_83_globalize_new_body_146, _rem__41_globalize_new_body_1461880, _rem__41_globalize_new_body_146, 0L, 3);
DEFINE_STRING(string1875_globalize_new_body_146, string1875_globalize_new_body_1461881, "REM!-DEFAULT1581 DONE ", 22);
DEFINE_STRING(string1874_globalize_new_body_146, string1874_globalize_new_body_1461882, "No method for this object", 25);
DEFINE_EXPORT_PROCEDURE(set_globalized_new_bodies__env_71_globalize_new_body_146, _set_globalized_new_bodies__36_globalize_new_body_1461883, _set_globalized_new_bodies__36_globalize_new_body_146, 0L, 2);
DEFINE_STATIC_PROCEDURE(rem__default1581_env_60_globalize_new_body_146, _rem__default1581_159_globalize_new_body_1461884, _rem__default1581_159_globalize_new_body_146, 0L, 3);



/* module-initialization */
obj_t 
module_initialization_70_globalize_new_body_146(long checksum_2092, char *from_2093)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_globalize_new_body_146))
	{
	   require_initialization_114_globalize_new_body_146 =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_globalize_new_body_146();
	   cnst_init_137_globalize_new_body_146();
	   imported_modules_init_94_globalize_new_body_146();
	   method_init_76_globalize_new_body_146();
	   toplevel_init_63_globalize_new_body_146();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_globalize_new_body_146()
{
   AN_OBJECT;
   {	/* Globalize/new-body.scm 14 */
      module_initialization_70___object(((long) 0), "GLOBALIZE_NEW-BODY");
      module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "GLOBALIZE_NEW-BODY");
      module_initialization_70___reader(((long) 0), "GLOBALIZE_NEW-BODY");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_globalize_new_body_146()
{
   AN_OBJECT;
   {	/* Globalize/new-body.scm 14 */
      {		/* Globalize/new-body.scm 14 */
	 obj_t cnst_port_138_2085;
	 cnst_port_138_2085 =
	    open_input_string(string1875_globalize_new_body_146);
	 {
	    long i_2086;
	    i_2086 = ((long) 1);
	  loop_2087:
	    {	/* Globalize/new-body.scm 14 */
	       bool_t test1876_2088;
	       test1876_2088 =
		  (i_2086 == ((long) -1));
	       if (test1876_2088)
		 {	/* Globalize/new-body.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Globalize/new-body.scm 14 */
		    {	/* Globalize/new-body.scm 14 */
		       obj_t arg1877_2089;
		       {	/* Globalize/new-body.scm 14 */
			  obj_t list1878_2090;
			  list1878_2090 =
			     MAKE_PAIR(cnst_port_138_2085, BNIL);
			  arg1877_2089 =
			     read___reader(list1878_2090);
		       }
		       CNST_TABLE_SET(i_2086, arg1877_2089);
		    }
		    {	/* Globalize/new-body.scm 14 */
		       int aux_2091;
		       {	/* Globalize/new-body.scm 14 */
			  long aux_2111;
			  aux_2111 =
			     (i_2086 - ((long) 1));
			  aux_2091 =
			     (int) (aux_2111);
		       }
		       {
			  long i_2114;
			  i_2114 =
			     (long) (aux_2091);
			  i_2086 = i_2114;
			  goto loop_2087;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_globalize_new_body_146()
{
   AN_OBJECT;
   {	/* Globalize/new-body.scm 14 */
      _round__57_globalize_new_body_146 = ((long) 0);
      return BUNSPEC;
   }
}



/* set-globalized-new-bodies! */
obj_t 
set_globalized_new_bodies__10_globalize_new_body_146(global_bglt global_1, obj_t locals_2)
{
   AN_OBJECT;
   {	/* Globalize/new-body.scm 30 */
      {		/* Globalize/new-body.scm 31 */
	 long z1_1729;
	 z1_1729 = _round__57_globalize_new_body_146;
	 _round__57_globalize_new_body_146 =
	    (z1_1729 + ((long) 1));
      }
      {		/* Globalize/new-body.scm 33 */
	 value_bglt fun_1068;
	 fun_1068 =
	    (((global_bglt) CREF(global_1))->value);
	 {	/* Globalize/new-body.scm 34 */
	    node_bglt arg1622_1069;
	    {	/* Globalize/new-body.scm 34 */
	       node_bglt aux_2118;
	       {	/* Globalize/new-body.scm 34 */
		  obj_t aux_2119;
		  {	/* Globalize/new-body.scm 34 */
		     sfun_bglt obj_1732;
		     obj_1732 =
			(sfun_bglt) (fun_1068);
		     aux_2119 =
			(((sfun_bglt) CREF(obj_1732))->body);
		  }
		  aux_2118 =
		     (node_bglt) (aux_2119);
	       }
	       arg1622_1069 =
		  rem__73_globalize_new_body_146(aux_2118,
		  (obj_t) (global_1),
		  (obj_t) (global_1));
	    }
	    {	/* Globalize/new-body.scm 34 */
	       sfun_bglt obj_1733;
	       obj_t val1123_1734;
	       obj_1733 =
		  (sfun_bglt) (fun_1068);
	       val1123_1734 =
		  (obj_t) (arg1622_1069);
	       ((((sfun_bglt) CREF(obj_1733))->body) = ((obj_t) val1123_1734), BUNSPEC);
	    }
	 }
      }
      {
	 obj_t l1554_1071;
	 {	/* Globalize/new-body.scm 36 */
	    bool_t aux_2129;
	    l1554_1071 = locals_2;
	  lname1555_1072:
	    if (
	       PAIRP(l1554_1071))
	      {		/* Globalize/new-body.scm 36 */
		 set_globalized_new_body__17_globalize_new_body_146(
		    CAR(l1554_1071));
		 {
		    obj_t l1554_2134;
		    l1554_2134 =
		       CDR(l1554_1071);
		    l1554_1071 = l1554_2134;
		    goto lname1555_1072;
		 }
	      }
	    else
	      {		/* Globalize/new-body.scm 36 */
		 aux_2129 = ((bool_t) 1);
	      }
	    return
	       BBOOL(aux_2129);
	 }
      }
   }
}



/* _set-globalized-new-bodies! */
obj_t 
_set_globalized_new_bodies__36_globalize_new_body_146(obj_t env_2074, obj_t global_2075, obj_t locals_2076)
{
   AN_OBJECT;
   {	/* Globalize/new-body.scm 30 */
      return
	 set_globalized_new_bodies__10_globalize_new_body_146(
	 (global_bglt) (global_2075), locals_2076);
   }
}



/* set-globalized-new-body! */
obj_t 
set_globalized_new_body__17_globalize_new_body_146(obj_t local_3)
{
   AN_OBJECT;
   {	/* Globalize/new-body.scm 41 */
      {		/* Globalize/new-body.scm 46 */
	 long z1_1738;
	 z1_1738 = _round__57_globalize_new_body_146;
	 _round__57_globalize_new_body_146 =
	    (z1_1738 + ((long) 1));
      }
      {		/* Globalize/new-body.scm 48 */
	 value_bglt fun_1076;
	 {	/* Globalize/new-body.scm 48 */
	    local_bglt obj_1740;
	    obj_1740 =
	       (local_bglt) (local_3);
	    fun_1076 =
	       (((local_bglt) CREF(obj_1740))->value);
	 }
	 {	/* Globalize/new-body.scm 49 */
	    obj_t old_body_129_1078;
	    {	/* Globalize/new-body.scm 50 */
	       sfun_bglt obj_1742;
	       obj_1742 =
		  (sfun_bglt) (fun_1076);
	       old_body_129_1078 =
		  (((sfun_bglt) CREF(obj_1742))->body);
	    }
	    {	/* Globalize/new-body.scm 50 */
	       obj_t obindings_1079;
	       {	/* Globalize/new-body.scm 51 */
		  sfun_ginfo_98_bglt obj_1743;
		  obj_1743 =
		     (sfun_ginfo_98_bglt) (fun_1076);
		  {
		     obj_t aux_2145;
		     {	/* ./Globalize/ginfo.scm 1262 */
			object_bglt aux_2146;
			aux_2146 =
			   (object_bglt) (obj_1743);
			aux_2145 =
			   OBJECT_WIDENING(aux_2146);
		     }
		     obindings_1079 =
			(((sfun_ginfo_98_bglt) CREF(aux_2145))->integrated);
		  }
	       }
	       {	/* Globalize/new-body.scm 51 */
		  node_bglt new_body_215_1080;
		  new_body_215_1080 =
		     rem__73_globalize_new_body_146(
		     (node_bglt) (old_body_129_1078), local_3, local_3);
		  {	/* Globalize/new-body.scm 52 */

		     {
			obj_t l1556_1081;
			l1556_1081 = obindings_1079;
		      lname1557_1082:
			if (
			   PAIRP(l1556_1081))
			  {	/* Globalize/new-body.scm 56 */
			     {	/* Globalize/new-body.scm 56 */
				obj_t f_1084;
				f_1084 =
				   CAR(l1556_1081);
				{	/* Globalize/new-body.scm 58 */
				   bool_t test1628_1085;
				   {	/* Globalize/new-body.scm 58 */
				      long n2_1749;
				      n2_1749 = _round__57_globalize_new_body_146;
				      {		/* ./Ieee/fixnum.scm 7109 */
					 long aux_2155;
					 {	/* Globalize/new-body.scm 58 */
					    sfun_ginfo_98_bglt obj_1747;
					    {	/* Globalize/new-body.scm 58 */
					       value_bglt aux_2156;
					       {	/* Globalize/new-body.scm 58 */
						  local_bglt obj_1746;
						  obj_1746 =
						     (local_bglt) (f_1084);
						  aux_2156 =
						     (((local_bglt) CREF(obj_1746))->value);
					       }
					       obj_1747 =
						  (sfun_ginfo_98_bglt) (aux_2156);
					    }
					    {
					       obj_t aux_2160;
					       {	/* ./Globalize/ginfo.scm 1276 */
						  object_bglt aux_2161;
						  aux_2161 =
						     (object_bglt) (obj_1747);
						  aux_2160 =
						     OBJECT_WIDENING(aux_2161);
					       }
					       aux_2155 =
						  (((sfun_ginfo_98_bglt) CREF(aux_2160))->bmark);
					    }
					 }
					 test1628_1085 =
					    (aux_2155 == n2_1749);
				      }
				   }
				   if (test1628_1085)
				     {	/* Globalize/new-body.scm 58 */
					BUNSPEC;
				     }
				   else
				     {	/* Globalize/new-body.scm 59 */
					value_bglt fun_1086;
					{	/* Globalize/new-body.scm 59 */
					   local_bglt obj_1750;
					   obj_1750 =
					      (local_bglt) (f_1084);
					   fun_1086 =
					      (((local_bglt) CREF(obj_1750))->value);
					}
					{	/* Globalize/new-body.scm 60 */

					   {	/* Globalize/new-body.scm 61 */
					      node_bglt arg1629_1088;
					      {		/* Globalize/new-body.scm 61 */
						 node_bglt aux_2169;
						 {	/* Globalize/new-body.scm 61 */
						    obj_t aux_2170;
						    {	/* Globalize/new-body.scm 60 */
						       sfun_bglt obj_1751;
						       obj_1751 =
							  (sfun_bglt) (fun_1086);
						       aux_2170 =
							  (((sfun_bglt) CREF(obj_1751))->body);
						    }
						    aux_2169 =
						       (node_bglt) (aux_2170);
						 }
						 arg1629_1088 =
						    rem__73_globalize_new_body_146(aux_2169, local_3, f_1084);
					      }
					      {		/* Globalize/new-body.scm 61 */
						 sfun_bglt obj_1752;
						 obj_t val1123_1753;
						 obj_1752 =
						    (sfun_bglt) (fun_1086);
						 val1123_1753 =
						    (obj_t) (arg1629_1088);
						 ((((sfun_bglt) CREF(obj_1752))->body) = ((obj_t) val1123_1753), BUNSPEC);
					      }
					   }
					}
				     }
				}
			     }
			     {
				obj_t l1556_2178;
				l1556_2178 =
				   CDR(l1556_1081);
				l1556_1081 = l1556_2178;
				goto lname1557_1082;
			     }
			  }
			else
			  {	/* Globalize/new-body.scm 56 */
			     ((bool_t) 1);
			  }
		     }
		     {	/* Globalize/new-body.scm 64 */
			obj_t nbindings_1092;
			{
			   obj_t nbdings_1119;
			   obj_t obdings_1120;
			   nbdings_1119 = BNIL;
			   obdings_1120 = obindings_1079;
			 loop_1121:
			   if (
			      NULLP(obdings_1120))
			     {	/* Globalize/new-body.scm 67 */
				nbindings_1092 = nbdings_1119;
			     }
			   else
			     {	/* Globalize/new-body.scm 69 */
				bool_t test1654_1123;
				{	/* Globalize/new-body.scm 69 */
				   long n2_1760;
				   n2_1760 = _round__57_globalize_new_body_146;
				   {	/* ./Ieee/fixnum.scm 7109 */
				      long aux_2182;
				      {		/* Globalize/new-body.scm 69 */
					 sfun_ginfo_98_bglt obj_1758;
					 {	/* Globalize/new-body.scm 69 */
					    value_bglt aux_2183;
					    {	/* Globalize/new-body.scm 69 */
					       local_bglt obj_1757;
					       {	/* Globalize/new-body.scm 69 */
						  obj_t aux_2184;
						  aux_2184 =
						     CAR(obdings_1120);
						  obj_1757 =
						     (local_bglt) (aux_2184);
					       }
					       aux_2183 =
						  (((local_bglt) CREF(obj_1757))->value);
					    }
					    obj_1758 =
					       (sfun_ginfo_98_bglt) (aux_2183);
					 }
					 {
					    obj_t aux_2189;
					    {	/* ./Globalize/ginfo.scm 1276 */
					       object_bglt aux_2190;
					       aux_2190 =
						  (object_bglt) (obj_1758);
					       aux_2189 =
						  OBJECT_WIDENING(aux_2190);
					    }
					    aux_2182 =
					       (((sfun_ginfo_98_bglt) CREF(aux_2189))->bmark);
					 }
				      }
				      test1654_1123 =
					 (aux_2182 == n2_1760);
				   }
				}
				if (test1654_1123)
				  {	/* Globalize/new-body.scm 69 */
				     {
					obj_t obdings_2196;
					obdings_2196 =
					   CDR(obdings_1120);
					obdings_1120 = obdings_2196;
					goto loop_1121;
				     }
				  }
				else
				  {	/* Globalize/new-body.scm 69 */
				     {	/* Globalize/new-body.scm 75 */
					obj_t arg1656_1125;
					obj_t arg1657_1126;
					{	/* ./Ieee/pair-list.scm 5689 */
					   obj_t aux_2198;
					   aux_2198 =
					      CAR(obdings_1120);
					   arg1656_1125 =
					      MAKE_PAIR(aux_2198, nbdings_1119);
					}
					arg1657_1126 =
					   CDR(obdings_1120);
					{
					   obj_t obdings_2203;
					   obj_t nbdings_2202;
					   nbdings_2202 = arg1656_1125;
					   obdings_2203 = arg1657_1126;
					   obdings_1120 = obdings_2203;
					   nbdings_1119 = nbdings_2202;
					   goto loop_1121;
					}
				     }
				  }
			     }
			}
			{	/* Globalize/new-body.scm 77 */
			   obj_t new2_body_172_1093;
			   if (
			      NULLP(nbindings_1092))
			     {	/* Globalize/new-body.scm 77 */
				new2_body_172_1093 =
				   (obj_t) (new_body_215_1080);
			     }
			   else
			     {	/* Globalize/new-body.scm 80 */
				obj_t arg1648_1114;
				type_bglt arg1649_1115;
				{	/* Globalize/new-body.scm 80 */
				   node_bglt obj_1767;
				   obj_1767 =
				      (node_bglt) (old_body_129_1078);
				   arg1648_1114 =
				      (((node_bglt) CREF(obj_1767))->loc);
				}
				{	/* Globalize/new-body.scm 81 */
				   node_bglt obj_1768;
				   obj_1768 =
				      (node_bglt) (old_body_129_1078);
				   arg1649_1115 =
				      (((node_bglt) CREF(obj_1768))->type);
				}
				{	/* Globalize/new-body.scm 79 */
				   let_fun_218_bglt res1872_1785;
				   {	/* Globalize/new-body.scm 79 */
				      obj_t key_1772;
				      key_1772 =
					 BINT(((long) -1));
				      {		/* ./Ast/node.scm 1132 */
					 let_fun_218_bglt new1358_1775;
					 new1358_1775 =
					    ((let_fun_218_bglt) BREF(GC_MALLOC(sizeof(struct let_fun_218))));
					 {	/* ./Ast/node.scm 1132 */
					    long arg1700_1776;
					    arg1700_1776 =
					       class_num_218___object(let_fun_218_ast_node);
					    {	/* ./Ast/node.scm 1132 */
					       obj_t obj_1783;
					       obj_1783 =
						  (obj_t) (new1358_1775);
					       (((obj_t) CREF(obj_1783))->header = MAKE_HEADER(arg1700_1776, 0), BUNSPEC);
					    }
					 }
					 {	/* ./Ast/node.scm 1132 */
					    object_bglt aux_2216;
					    aux_2216 =
					       (object_bglt) (new1358_1775);
					    OBJECT_WIDENING_SET(aux_2216, BFALSE);
					 }
					 ((((let_fun_218_bglt) CREF(new1358_1775))->loc) = ((obj_t) arg1648_1114), BUNSPEC);
					 ((((let_fun_218_bglt) CREF(new1358_1775))->type) = ((type_bglt) arg1649_1115), BUNSPEC);
					 ((((let_fun_218_bglt) CREF(new1358_1775))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
					 ((((let_fun_218_bglt) CREF(new1358_1775))->key) = ((obj_t) key_1772), BUNSPEC);
					 ((((let_fun_218_bglt) CREF(new1358_1775))->locals) = ((obj_t) nbindings_1092), BUNSPEC);
					 ((((let_fun_218_bglt) CREF(new1358_1775))->body) = ((node_bglt) new_body_215_1080), BUNSPEC);
					 res1872_1785 = new1358_1775;
				      }
				   }
				   new2_body_172_1093 =
				      (obj_t) (res1872_1785);
				}
			     }
			   {
			      obj_t ncto_1094;
			      obj_t nbindings_1095;
			      {		/* Globalize/new-body.scm 87 */
				 sfun_ginfo_98_bglt obj_1786;
				 obj_1786 =
				    (sfun_ginfo_98_bglt) (fun_1076);
				 {
				    obj_t aux_2264;
				    {	/* ./Globalize/ginfo.scm 1254 */
				       object_bglt aux_2265;
				       aux_2265 =
					  (object_bglt) (obj_1786);
				       aux_2264 =
					  OBJECT_WIDENING(aux_2265);
				    }
				    ncto_1094 =
				       (((sfun_ginfo_98_bglt) CREF(aux_2264))->cto);
				 }
			      }
			      nbindings_1095 = nbindings_1092;
			    loop_1096:
			      if (
				 NULLP(nbindings_1095))
				{	/* Globalize/new-body.scm 90 */
				   sfun_ginfo_98_bglt obj_1788;
				   obj_1788 =
				      (sfun_ginfo_98_bglt) (fun_1076);
				   {
				      obj_t aux_2229;
				      {		/* ./Globalize/ginfo.scm 1254 */
					 object_bglt aux_2230;
					 aux_2230 =
					    (object_bglt) (obj_1788);
					 aux_2229 =
					    OBJECT_WIDENING(aux_2230);
				      }
				      ((((sfun_ginfo_98_bglt) CREF(aux_2229))->cto) = ((obj_t) ncto_1094), BUNSPEC);
				   }
				}
			      else
				{
				   obj_t ncto_1099;
				   obj_t lcto_1100;
				   ncto_1099 = ncto_1094;
				   {	/* Globalize/new-body.scm 92 */
				      sfun_ginfo_98_bglt obj_1792;
				      {		/* Globalize/new-body.scm 92 */
					 value_bglt aux_2252;
					 {	/* Globalize/new-body.scm 92 */
					    local_bglt obj_1791;
					    {	/* Globalize/new-body.scm 92 */
					       obj_t aux_2253;
					       aux_2253 =
						  CAR(nbindings_1095);
					       obj_1791 =
						  (local_bglt) (aux_2253);
					    }
					    aux_2252 =
					       (((local_bglt) CREF(obj_1791))->value);
					 }
					 obj_1792 =
					    (sfun_ginfo_98_bglt) (aux_2252);
				      }
				      {
					 obj_t aux_2258;
					 {	/* ./Globalize/ginfo.scm 1254 */
					    object_bglt aux_2259;
					    aux_2259 =
					       (object_bglt) (obj_1792);
					    aux_2258 =
					       OBJECT_WIDENING(aux_2259);
					 }
					 lcto_1100 =
					    (((sfun_ginfo_98_bglt) CREF(aux_2258))->cto);
				      }
				   }
				 liip_1101:
				   if (
				      NULLP(lcto_1100))
				     {	/* Globalize/new-body.scm 95 */
					{
					   obj_t nbindings_2237;
					   obj_t ncto_2236;
					   ncto_2236 = ncto_1099;
					   nbindings_2237 =
					      CDR(nbindings_1095);
					   nbindings_1095 = nbindings_2237;
					   ncto_1094 = ncto_2236;
					   goto loop_1096;
					}
				     }
				   else
				     {	/* Globalize/new-body.scm 97 */
					bool_t test_2239;
					{	/* Globalize/new-body.scm 97 */
					   obj_t aux_2240;
					   aux_2240 =
					      memq___r4_pairs_and_lists_6_3(
					      CAR(lcto_1100), ncto_1099);
					   test_2239 =
					      CBOOL(aux_2240);
					}
					if (test_2239)
					  {	/* Globalize/new-body.scm 97 */
					     {
						obj_t lcto_2244;
						lcto_2244 =
						   CDR(lcto_1100);
						lcto_1100 = lcto_2244;
						goto liip_1101;
					     }
					  }
					else
					  {	/* Globalize/new-body.scm 97 */
					     {	/* Globalize/new-body.scm 100 */
						obj_t arg1642_1109;
						obj_t arg1643_1110;
						{	/* ./Ieee/pair-list.scm 5689 */
						   obj_t aux_2246;
						   aux_2246 =
						      CAR(lcto_1100);
						   arg1642_1109 =
						      MAKE_PAIR(aux_2246, ncto_1099);
						}
						arg1643_1110 =
						   CDR(lcto_1100);
						{
						   obj_t lcto_2251;
						   obj_t ncto_2250;
						   ncto_2250 = arg1642_1109;
						   lcto_2251 = arg1643_1110;
						   lcto_1100 = lcto_2251;
						   ncto_1099 = ncto_2250;
						   goto liip_1101;
						}
					     }
					  }
				     }
				}
			   }
			   {	/* Globalize/new-body.scm 111 */
			      sfun_ginfo_98_bglt obj_1801;
			      obj_1801 =
				 (sfun_ginfo_98_bglt) (fun_1076);
			      {
				 obj_t aux_2270;
				 {	/* ./Globalize/ginfo.scm 1274 */
				    object_bglt aux_2271;
				    aux_2271 =
				       (object_bglt) (obj_1801);
				    aux_2270 =
				       OBJECT_WIDENING(aux_2271);
				 }
				 return
				    ((((sfun_ginfo_98_bglt) CREF(aux_2270))->new_body_215) = ((obj_t) new2_body_172_1093), BUNSPEC);
			      }
			   }
			}
		     }
		  }
	       }
	    }
	 }
      }
   }
}



/* is-in? */
bool_t 
is_in__90_globalize_new_body_146(obj_t f1_4, obj_t f2_5)
{
   AN_OBJECT;
   {	/* Globalize/new-body.scm 118 */
      {		/* Globalize/new-body.scm 119 */
	 value_bglt info_1131;
	 {	/* Globalize/new-body.scm 119 */
	    local_bglt obj_1803;
	    obj_1803 =
	       (local_bglt) (f1_4);
	    info_1131 =
	       (((local_bglt) CREF(obj_1803))->value);
	 }
	 {	/* Globalize/new-body.scm 121 */
	    bool_t test_2277;
	    {	/* Globalize/new-body.scm 121 */
	       sfun_ginfo_98_bglt obj_1804;
	       obj_1804 =
		  (sfun_ginfo_98_bglt) (info_1131);
	       {
		  obj_t aux_2279;
		  {	/* ./Globalize/ginfo.scm 1248 */
		     object_bglt aux_2280;
		     aux_2280 =
			(object_bglt) (obj_1804);
		     aux_2279 =
			OBJECT_WIDENING(aux_2280);
		  }
		  test_2277 =
		     (((sfun_ginfo_98_bglt) CREF(aux_2279))->g__219);
	       }
	    }
	    if (test_2277)
	      {		/* Globalize/new-body.scm 121 */
		 return ((bool_t) 0);
	      }
	    else
	      {		/* Globalize/new-body.scm 123 */
		 bool_t test1663_1133;
		 {	/* ./Ast/var.scm 932 */
		    obj_t aux_2284;
		    {	/* Globalize/new-body.scm 123 */
		       sfun_ginfo_98_bglt obj_1805;
		       obj_1805 =
			  (sfun_ginfo_98_bglt) (info_1131);
		       {
			  obj_t aux_2286;
			  {	/* ./Globalize/ginfo.scm 1260 */
			     object_bglt aux_2287;
			     aux_2287 =
				(object_bglt) (obj_1805);
			     aux_2286 =
				OBJECT_WIDENING(aux_2287);
			  }
			  aux_2284 =
			     (((sfun_ginfo_98_bglt) CREF(aux_2286))->integrator);
		       }
		    }
		    test1663_1133 =
		       is_a__118___object(aux_2284, local_ast_var);
		 }
		 if (test1663_1133)
		   {	/* Globalize/new-body.scm 125 */
		      bool_t test_2293;
		      {		/* ./Ieee/equiv.scm 5508 */
			 obj_t aux_2294;
			 {	/* Globalize/new-body.scm 125 */
			    sfun_ginfo_98_bglt obj_1807;
			    obj_1807 =
			       (sfun_ginfo_98_bglt) (info_1131);
			    {
			       obj_t aux_2296;
			       {	/* ./Globalize/ginfo.scm 1260 */
				  object_bglt aux_2297;
				  aux_2297 =
				     (object_bglt) (obj_1807);
				  aux_2296 =
				     OBJECT_WIDENING(aux_2297);
			       }
			       aux_2294 =
				  (((sfun_ginfo_98_bglt) CREF(aux_2296))->integrator);
			    }
			 }
			 test_2293 =
			    (aux_2294 == f2_5);
		      }
		      if (test_2293)
			{	/* Globalize/new-body.scm 125 */
			   return ((bool_t) 1);
			}
		      else
			{	/* Globalize/new-body.scm 125 */
			   return ((bool_t) 0);
			}
		   }
		 else
		   {	/* Globalize/new-body.scm 123 */
		      return ((bool_t) 1);
		   }
	      }
	 }
      }
   }
}



/* rem*! */
obj_t 
rem___100_globalize_new_body_146(obj_t node__221_72, obj_t owner_73, obj_t current_74)
{
   AN_OBJECT;
   {	/* Globalize/new-body.scm 356 */
      {
	 obj_t node__221_1137;
	 node__221_1137 = node__221_72;
       loop_1138:
	 if (
	    NULLP(node__221_1137))
	   {	/* Globalize/new-body.scm 358 */
	      return
		 CNST_TABLE_REF(((long) 0));
	   }
	 else
	   {	/* Globalize/new-body.scm 358 */
	      {		/* Globalize/new-body.scm 361 */
		 node_bglt arg1669_1140;
		 {	/* Globalize/new-body.scm 361 */
		    node_bglt aux_2305;
		    {	/* Globalize/new-body.scm 361 */
		       obj_t aux_2306;
		       aux_2306 =
			  CAR(node__221_1137);
		       aux_2305 =
			  (node_bglt) (aux_2306);
		    }
		    arg1669_1140 =
		       rem__73_globalize_new_body_146(aux_2305, owner_73, current_74);
		 }
		 {	/* ./Ieee/pair-list.scm 5890 */
		    obj_t aux_2310;
		    aux_2310 =
		       (obj_t) (arg1669_1140);
		    SET_CAR(node__221_1137, aux_2310);
		 }
	      }
	      {
		 obj_t node__221_2313;
		 node__221_2313 =
		    CDR(node__221_1137);
		 node__221_1137 = node__221_2313;
		 goto loop_1138;
	      }
	   }
      }
   }
}



/* method-init */
obj_t 
method_init_76_globalize_new_body_146()
{
   AN_OBJECT;
   {	/* Globalize/new-body.scm 14 */
      add_generic__110___object(rem__env_83_globalize_new_body_146, rem__default1581_env_60_globalize_new_body_146);
      add_inlined_method__244___object(rem__env_83_globalize_new_body_146, atom_ast_node, ((long) 0));
      add_inlined_method__244___object(rem__env_83_globalize_new_body_146, kwote_ast_node, ((long) 1));
      add_inlined_method__244___object(rem__env_83_globalize_new_body_146, var_ast_node, ((long) 2));
      add_inlined_method__244___object(rem__env_83_globalize_new_body_146, sequence_ast_node, ((long) 3));
      add_inlined_method__244___object(rem__env_83_globalize_new_body_146, app_ast_node, ((long) 4));
      add_inlined_method__244___object(rem__env_83_globalize_new_body_146, app_ly_162_ast_node, ((long) 5));
      add_inlined_method__244___object(rem__env_83_globalize_new_body_146, funcall_ast_node, ((long) 6));
      add_inlined_method__244___object(rem__env_83_globalize_new_body_146, pragma_ast_node, ((long) 7));
      add_inlined_method__244___object(rem__env_83_globalize_new_body_146, cast_ast_node, ((long) 8));
      add_inlined_method__244___object(rem__env_83_globalize_new_body_146, setq_ast_node, ((long) 9));
      add_inlined_method__244___object(rem__env_83_globalize_new_body_146, conditional_ast_node, ((long) 10));
      add_inlined_method__244___object(rem__env_83_globalize_new_body_146, fail_ast_node, ((long) 11));
      add_inlined_method__244___object(rem__env_83_globalize_new_body_146, select_ast_node, ((long) 12));
      add_inlined_method__244___object(rem__env_83_globalize_new_body_146, let_fun_218_ast_node, ((long) 13));
      add_inlined_method__244___object(rem__env_83_globalize_new_body_146, let_var_6_ast_node, ((long) 14));
      add_inlined_method__244___object(rem__env_83_globalize_new_body_146, set_ex_it_116_ast_node, ((long) 15));
      add_inlined_method__244___object(rem__env_83_globalize_new_body_146, jump_ex_it_184_ast_node, ((long) 16));
      add_inlined_method__244___object(rem__env_83_globalize_new_body_146, make_box_202_ast_node, ((long) 17));
      add_inlined_method__244___object(rem__env_83_globalize_new_body_146, box_ref_242_ast_node, ((long) 18));
      {		/* Globalize/new-body.scm 14 */
	 long aux_2335;
	 aux_2335 =
	    add_inlined_method__244___object(rem__env_83_globalize_new_body_146, box_set__221_ast_node, ((long) 19));
	 return
	    BINT(aux_2335);
      }
   }
}



/* rem! */
node_bglt 
rem__73_globalize_new_body_146(node_bglt node_6, obj_t owner_7, obj_t current_8)
{
   AN_OBJECT;
   {	/* Globalize/new-body.scm 138 */
      {
	 obj_t method1761_1537;
	 obj_t class1766_1538;
	 {	/* Globalize/new-body.scm 138 */
	    obj_t arg1769_1535;
	    obj_t arg1770_1536;
	    {	/* Globalize/new-body.scm 138 */
	       object_bglt obj_1919;
	       obj_1919 =
		  (object_bglt) (node_6);
	       {	/* ./Llib/object.scm 2926 */
		  obj_t pre_method_105_1920;
		  pre_method_105_1920 =
		     PROCEDURE_REF(rem__env_83_globalize_new_body_146, ((long) 2));
		  if (
		     INTEGERP(pre_method_105_1920))
		    {	/* ./Llib/object.scm 2927 */
		       PROCEDURE_SET(rem__env_83_globalize_new_body_146, ((long) 2), BUNSPEC);
		       arg1769_1535 = pre_method_105_1920;
		    }
		  else
		    {	/* ./Llib/object.scm 2914 */
		       long obj_class_num_177_1925;
		       obj_class_num_177_1925 =
			  TYPE(obj_1919);
		       {	/* ./Llib/object.scm 2915 */
			  obj_t arg1176_1926;
			  arg1176_1926 =
			     PROCEDURE_REF(rem__env_83_globalize_new_body_146, ((long) 1));
			  {	/* ./Llib/object.scm 2738 */
			     long arg1177_1930;
			     {	/* ./Llib/object.scm 2738 */
				long arg1178_1931;
				arg1178_1931 =
				   OBJECT_TYPE;
				arg1177_1930 =
				   (obj_class_num_177_1925 - arg1178_1931);
			     }
			     arg1769_1535 =
				VECTOR_REF(arg1176_1926, arg1177_1930);
			  }
		       }
		    }
	       }
	    }
	    {	/* Globalize/new-body.scm 138 */
	       object_bglt object_1936;
	       object_1936 =
		  (object_bglt) (node_6);
	       {	/* ./Llib/object.scm 2695 */
		  long arg1179_1937;
		  {	/* ./Llib/object.scm 2695 */
		     long arg1180_1938;
		     long arg1181_1939;
		     arg1180_1938 =
			TYPE(object_1936);
		     arg1181_1939 =
			OBJECT_TYPE;
		     arg1179_1937 =
			(arg1180_1938 - arg1181_1939);
		  }
		  {	/* ./Llib/object.scm 2695 */
		     obj_t vector_1943;
		     vector_1943 = _classes__134___object;
		     arg1770_1536 =
			VECTOR_REF(vector_1943, arg1179_1937);
		  }
	       }
	    }
	    {	/* Globalize/new-body.scm 138 */
	       obj_t aux_2353;
	       method1761_1537 = arg1769_1535;
	       class1766_1538 = arg1770_1536;
	       {

		  if (
		     INTEGERP(method1761_1537))
		    {	/* Globalize/new-body.scm 138 */
		       switch (
			  (long) CINT(method1761_1537))
			 {
			 case ((long) 0):

			    {	/* Globalize/new-body.scm 138 */
			       atom_bglt aux_2356;
			       aux_2356 =
				  (atom_bglt) (node_6);
			       aux_2353 =
				  (obj_t) (aux_2356);
			    }
			    break;
			 case ((long) 1):

			    {	/* Globalize/new-body.scm 138 */
			       kwote_bglt aux_2359;
			       aux_2359 =
				  (kwote_bglt) (node_6);
			       aux_2353 =
				  (obj_t) (aux_2359);
			    }
			    break;
			 case ((long) 2):

			    {	/* Globalize/new-body.scm 138 */
			       var_bglt aux_2362;
			       aux_2362 =
				  (var_bglt) (node_6);
			       aux_2353 =
				  (obj_t) (aux_2362);
			    }
			    break;
			 case ((long) 3):

			    {	/* Globalize/new-body.scm 162 */
			       sequence_bglt node_1553;
			       node_1553 =
				  (sequence_bglt) (node_6);
			       rem___100_globalize_new_body_146(
				  (((sequence_bglt) CREF(node_1553))->nodes), owner_7, current_8);
			       aux_2353 =
				  (obj_t) (node_1553);
			    }
			    break;
			 case ((long) 4):

			    {	/* Globalize/new-body.scm 170 */
			       app_bglt node_1558;
			       node_1558 =
				  (app_bglt) (node_6);
			       rem___100_globalize_new_body_146(
				  (((app_bglt) CREF(node_1558))->args), owner_7, current_8);
			       aux_2353 =
				  (obj_t) (node_1558);
			    }
			    break;
			 case ((long) 5):

			    {	/* Globalize/new-body.scm 178 */
			       app_ly_162_bglt node_1563;
			       node_1563 =
				  (app_ly_162_bglt) (node_6);
			       {	/* Globalize/new-body.scm 179 */
				  node_bglt arg1775_1567;
				  arg1775_1567 =
				     rem__73_globalize_new_body_146(
				     (((app_ly_162_bglt) CREF(node_1563))->fun), owner_7, current_8);
				  ((((app_ly_162_bglt) CREF(node_1563))->fun) = ((node_bglt) arg1775_1567), BUNSPEC);
			       }
			       {	/* Globalize/new-body.scm 180 */
				  node_bglt arg1777_1569;
				  arg1777_1569 =
				     rem__73_globalize_new_body_146(
				     (((app_ly_162_bglt) CREF(node_1563))->arg), owner_7, current_8);
				  ((((app_ly_162_bglt) CREF(node_1563))->arg) = ((node_bglt) arg1777_1569), BUNSPEC);
			       }
			       aux_2353 =
				  (obj_t) (node_1563);
			    }
			    break;
			 case ((long) 6):

			    {	/* Globalize/new-body.scm 187 */
			       funcall_bglt node_1571;
			       node_1571 =
				  (funcall_bglt) (node_6);
			       {	/* Globalize/new-body.scm 188 */
				  node_bglt arg1779_1575;
				  arg1779_1575 =
				     rem__73_globalize_new_body_146(
				     (((funcall_bglt) CREF(node_1571))->fun), owner_7, current_8);
				  ((((funcall_bglt) CREF(node_1571))->fun) = ((node_bglt) arg1779_1575), BUNSPEC);
			       }
			       rem___100_globalize_new_body_146(
				  (((funcall_bglt) CREF(node_1571))->args), owner_7, current_8);
			       aux_2353 =
				  (obj_t) (node_1571);
			    }
			    break;
			 case ((long) 7):

			    {	/* Globalize/new-body.scm 196 */
			       pragma_bglt node_1578;
			       node_1578 =
				  (pragma_bglt) (node_6);
			       rem___100_globalize_new_body_146(
				  (((pragma_bglt) CREF(node_1578))->args), owner_7, current_8);
			       aux_2353 =
				  (obj_t) (node_1578);
			    }
			    break;
			 case ((long) 8):

			    {	/* Globalize/new-body.scm 204 */
			       cast_bglt node_1583;
			       node_1583 =
				  (cast_bglt) (node_6);
			       rem__73_globalize_new_body_146(
				  (((cast_bglt) CREF(node_1583))->arg), owner_7, current_8);
			       aux_2353 =
				  (obj_t) (node_1583);
			    }
			    break;
			 case ((long) 9):

			    {	/* Globalize/new-body.scm 212 */
			       setq_bglt node_1588;
			       node_1588 =
				  (setq_bglt) (node_6);
			       {	/* Globalize/new-body.scm 213 */
				  node_bglt arg1784_1592;
				  arg1784_1592 =
				     rem__73_globalize_new_body_146(
				     (((setq_bglt) CREF(node_1588))->value), owner_7, current_8);
				  ((((setq_bglt) CREF(node_1588))->value) = ((node_bglt) arg1784_1592), BUNSPEC);
			       }
			       aux_2353 =
				  (obj_t) (node_1588);
			    }
			    break;
			 case ((long) 10):

			    {	/* Globalize/new-body.scm 220 */
			       conditional_bglt node_1594;
			       node_1594 =
				  (conditional_bglt) (node_6);
			       {	/* Globalize/new-body.scm 221 */
				  node_bglt arg1786_1598;
				  arg1786_1598 =
				     rem__73_globalize_new_body_146(
				     (((conditional_bglt) CREF(node_1594))->test), owner_7, current_8);
				  ((((conditional_bglt) CREF(node_1594))->test) = ((node_bglt) arg1786_1598), BUNSPEC);
			       }
			       {	/* Globalize/new-body.scm 222 */
				  node_bglt arg1788_1600;
				  arg1788_1600 =
				     rem__73_globalize_new_body_146(
				     (((conditional_bglt) CREF(node_1594))->true), owner_7, current_8);
				  ((((conditional_bglt) CREF(node_1594))->true) = ((node_bglt) arg1788_1600), BUNSPEC);
			       }
			       {	/* Globalize/new-body.scm 223 */
				  node_bglt arg1790_1602;
				  arg1790_1602 =
				     rem__73_globalize_new_body_146(
				     (((conditional_bglt) CREF(node_1594))->false), owner_7, current_8);
				  ((((conditional_bglt) CREF(node_1594))->false) = ((node_bglt) arg1790_1602), BUNSPEC);
			       }
			       aux_2353 =
				  (obj_t) (node_1594);
			    }
			    break;
			 case ((long) 11):

			    {	/* Globalize/new-body.scm 230 */
			       fail_bglt node_1604;
			       node_1604 =
				  (fail_bglt) (node_6);
			       {	/* Globalize/new-body.scm 231 */
				  node_bglt arg1792_1608;
				  arg1792_1608 =
				     rem__73_globalize_new_body_146(
				     (((fail_bglt) CREF(node_1604))->proc), owner_7, current_8);
				  ((((fail_bglt) CREF(node_1604))->proc) = ((node_bglt) arg1792_1608), BUNSPEC);
			       }
			       {	/* Globalize/new-body.scm 232 */
				  node_bglt arg1794_1610;
				  arg1794_1610 =
				     rem__73_globalize_new_body_146(
				     (((fail_bglt) CREF(node_1604))->msg), owner_7, current_8);
				  ((((fail_bglt) CREF(node_1604))->msg) = ((node_bglt) arg1794_1610), BUNSPEC);
			       }
			       {	/* Globalize/new-body.scm 233 */
				  node_bglt arg1796_1612;
				  arg1796_1612 =
				     rem__73_globalize_new_body_146(
				     (((fail_bglt) CREF(node_1604))->obj), owner_7, current_8);
				  ((((fail_bglt) CREF(node_1604))->obj) = ((node_bglt) arg1796_1612), BUNSPEC);
			       }
			       aux_2353 =
				  (obj_t) (node_1604);
			    }
			    break;
			 case ((long) 12):

			    {	/* Globalize/new-body.scm 240 */
			       select_bglt node_1614;
			       node_1614 =
				  (select_bglt) (node_6);
			       {	/* Globalize/new-body.scm 241 */
				  node_bglt arg1798_1618;
				  arg1798_1618 =
				     rem__73_globalize_new_body_146(
				     (((select_bglt) CREF(node_1614))->test), owner_7, current_8);
				  ((((select_bglt) CREF(node_1614))->test) = ((node_bglt) arg1798_1618), BUNSPEC);
			       }
			       {
				  obj_t l1569_1620;
				  l1569_1620 =
				     (((select_bglt) CREF(node_1614))->clauses);
				lname1570_1621:
				  if (
				     PAIRP(l1569_1620))
				    {	/* Globalize/new-body.scm 242 */
				       {	/* Globalize/new-body.scm 243 */
					  obj_t clause_1624;
					  clause_1624 =
					     CAR(l1569_1620);
					  {	/* Globalize/new-body.scm 243 */
					     node_bglt arg1803_1625;
					     {	/* Globalize/new-body.scm 243 */
						node_bglt aux_2430;
						{	/* Globalize/new-body.scm 243 */
						   obj_t aux_2431;
						   aux_2431 =
						      CDR(clause_1624);
						   aux_2430 =
						      (node_bglt) (aux_2431);
						}
						arg1803_1625 =
						   rem__73_globalize_new_body_146(aux_2430, owner_7, current_8);
					     }
					     {	/* ./Ieee/pair-list.scm 5896 */
						obj_t aux_2435;
						aux_2435 =
						   (obj_t) (arg1803_1625);
						SET_CDR(clause_1624, aux_2435);
					     }
					  }
				       }
				       {
					  obj_t l1569_2438;
					  l1569_2438 =
					     CDR(l1569_1620);
					  l1569_1620 = l1569_2438;
					  goto lname1570_1621;
				       }
				    }
				  else
				    {	/* Globalize/new-body.scm 242 */
				       ((bool_t) 1);
				    }
			       }
			       aux_2353 =
				  (obj_t) (node_1614);
			    }
			    break;
			 case ((long) 13):

			    {	/* Globalize/new-body.scm 251 */
			       let_fun_218_bglt node_1628;
			       node_1628 =
				  (let_fun_218_bglt) (node_6);
			       {	/* Globalize/new-body.scm 252 */
				  node_bglt arg1806_1632;
				  arg1806_1632 =
				     rem__73_globalize_new_body_146(
				     (((let_fun_218_bglt) CREF(node_1628))->body), owner_7, current_8);
				  ((((let_fun_218_bglt) CREF(node_1628))->body) = ((node_bglt) arg1806_1632), BUNSPEC);
			       }
			       {
				  obj_t obindings_1634;
				  obj_t nbindings_1635;
				  {	/* Globalize/new-body.scm 253 */
				     let_fun_218_bglt aux_2446;
				     obindings_1634 =
					(((let_fun_218_bglt) CREF(node_1628))->locals);
				     nbindings_1635 = BNIL;
				   liip_1636:
				     if (
					NULLP(obindings_1634))
				       {	/* Globalize/new-body.scm 256 */
					  ((((let_fun_218_bglt) CREF(node_1628))->locals) = ((obj_t) nbindings_1635), BUNSPEC);
					  aux_2446 = node_1628;
				       }
				     else
				       {	/* Globalize/new-body.scm 259 */
					  bool_t test1812_1640;
					  {	/* Globalize/new-body.scm 259 */
					     long n2_2001;
					     n2_2001 = _round__57_globalize_new_body_146;
					     {	/* ./Ieee/fixnum.scm 7109 */
						long aux_2450;
						{	/* Globalize/new-body.scm 259 */
						   sfun_ginfo_98_bglt obj_1999;
						   {	/* Globalize/new-body.scm 259 */
						      value_bglt aux_2451;
						      {		/* Globalize/new-body.scm 259 */
							 local_bglt obj_1998;
							 {	/* Globalize/new-body.scm 259 */
							    obj_t aux_2452;
							    aux_2452 =
							       CAR(obindings_1634);
							    obj_1998 =
							       (local_bglt) (aux_2452);
							 }
							 aux_2451 =
							    (((local_bglt) CREF(obj_1998))->value);
						      }
						      obj_1999 =
							 (sfun_ginfo_98_bglt) (aux_2451);
						   }
						   {
						      obj_t aux_2457;
						      {		/* ./Globalize/ginfo.scm 1276 */
							 object_bglt aux_2458;
							 aux_2458 =
							    (object_bglt) (obj_1999);
							 aux_2457 =
							    OBJECT_WIDENING(aux_2458);
						      }
						      aux_2450 =
							 (((sfun_ginfo_98_bglt) CREF(aux_2457))->bmark);
						   }
						}
						test1812_1640 =
						   (aux_2450 == n2_2001);
					     }
					  }
					  if (test1812_1640)
					    {	/* Globalize/new-body.scm 259 */
					       {	/* Globalize/new-body.scm 266 */
						  bool_t test_2464;
						  {	/* ./Ieee/equiv.scm 5508 */
						     obj_t aux_2465;
						     {	/* Globalize/new-body.scm 267 */
							sfun_ginfo_98_bglt obj_2004;
							{	/* Globalize/new-body.scm 267 */
							   value_bglt aux_2466;
							   {	/* Globalize/new-body.scm 267 */
							      local_bglt obj_2003;
							      {		/* Globalize/new-body.scm 267 */
								 obj_t aux_2467;
								 aux_2467 =
								    CAR(obindings_1634);
								 obj_2003 =
								    (local_bglt) (aux_2467);
							      }
							      aux_2466 =
								 (((local_bglt) CREF(obj_2003))->value);
							   }
							   obj_2004 =
							      (sfun_ginfo_98_bglt) (aux_2466);
							}
							{
							   obj_t aux_2472;
							   {	/* ./Globalize/ginfo.scm 1264 */
							      object_bglt aux_2473;
							      aux_2473 =
								 (object_bglt) (obj_2004);
							      aux_2472 =
								 OBJECT_WIDENING(aux_2473);
							   }
							   aux_2465 =
							      (((sfun_ginfo_98_bglt) CREF(aux_2472))->plugged_in_15);
							}
						     }
						     test_2464 =
							(current_8 == aux_2465);
						  }
						  if (test_2464)
						    {	/* Globalize/new-body.scm 269 */
						       obj_t arg1814_1642;
						       obj_t arg1815_1643;
						       arg1814_1642 =
							  CDR(obindings_1634);
						       {	/* ./Ieee/pair-list.scm 5689 */
							  obj_t aux_2479;
							  aux_2479 =
							     CAR(obindings_1634);
							  arg1815_1643 =
							     MAKE_PAIR(aux_2479, nbindings_1635);
						       }
						       {
							  obj_t nbindings_2483;
							  obj_t obindings_2482;
							  obindings_2482 = arg1814_1642;
							  nbindings_2483 = arg1815_1643;
							  nbindings_1635 = nbindings_2483;
							  obindings_1634 = obindings_2482;
							  goto liip_1636;
						       }
						    }
						  else
						    {
						       obj_t obindings_2484;
						       obindings_2484 =
							  CDR(obindings_1634);
						       obindings_1634 = obindings_2484;
						       goto liip_1636;
						    }
					       }
					    }
					  else
					    {	/* Globalize/new-body.scm 259 */
					       if (
						  is_in__90_globalize_new_body_146(
						     CAR(obindings_1634), owner_7))
						 {	/* Globalize/new-body.scm 273 */
						    {	/* Globalize/new-body.scm 279 */
						       sfun_ginfo_98_bglt obj_2015;
						       long val1462_2016;
						       {	/* Globalize/new-body.scm 279 */
							  value_bglt aux_2489;
							  {	/* Globalize/new-body.scm 279 */
							     local_bglt obj_2014;
							     {	/* Globalize/new-body.scm 279 */
								obj_t aux_2490;
								aux_2490 =
								   CAR(obindings_1634);
								obj_2014 =
								   (local_bglt) (aux_2490);
							     }
							     aux_2489 =
								(((local_bglt) CREF(obj_2014))->value);
							  }
							  obj_2015 =
							     (sfun_ginfo_98_bglt) (aux_2489);
						       }
						       val1462_2016 = _round__57_globalize_new_body_146;
						       {
							  obj_t aux_2495;
							  {	/* ./Globalize/ginfo.scm 1276 */
							     object_bglt aux_2496;
							     aux_2496 =
								(object_bglt) (obj_2015);
							     aux_2495 =
								OBJECT_WIDENING(aux_2496);
							  }
							  ((((sfun_ginfo_98_bglt) CREF(aux_2495))->bmark) = ((long) val1462_2016), BUNSPEC);
						       }
						    }
						    {	/* Globalize/new-body.scm 281 */
						       sfun_ginfo_98_bglt obj_2019;
						       {	/* Globalize/new-body.scm 281 */
							  value_bglt aux_2500;
							  {	/* Globalize/new-body.scm 281 */
							     local_bglt obj_2018;
							     {	/* Globalize/new-body.scm 281 */
								obj_t aux_2501;
								aux_2501 =
								   CAR(obindings_1634);
								obj_2018 =
								   (local_bglt) (aux_2501);
							     }
							     aux_2500 =
								(((local_bglt) CREF(obj_2018))->value);
							  }
							  obj_2019 =
							     (sfun_ginfo_98_bglt) (aux_2500);
						       }
						       {
							  obj_t aux_2506;
							  {	/* ./Globalize/ginfo.scm 1264 */
							     object_bglt aux_2507;
							     aux_2507 =
								(object_bglt) (obj_2019);
							     aux_2506 =
								OBJECT_WIDENING(aux_2507);
							  }
							  ((((sfun_ginfo_98_bglt) CREF(aux_2506))->plugged_in_15) = ((obj_t) current_8), BUNSPEC);
						       }
						    }
						    {	/* Globalize/new-body.scm 283 */
						       value_bglt fun_1654;
						       {	/* Globalize/new-body.scm 283 */
							  local_bglt obj_2022;
							  {	/* Globalize/new-body.scm 283 */
							     obj_t aux_2511;
							     aux_2511 =
								CAR(obindings_1634);
							     obj_2022 =
								(local_bglt) (aux_2511);
							  }
							  fun_1654 =
							     (((local_bglt) CREF(obj_2022))->value);
						       }
						       {	/* Globalize/new-body.scm 284 */

							  {	/* Globalize/new-body.scm 285 */
							     node_bglt arg1827_1656;
							     {	/* Globalize/new-body.scm 285 */
								node_bglt aux_2515;
								{	/* Globalize/new-body.scm 285 */
								   obj_t aux_2516;
								   {	/* Globalize/new-body.scm 284 */
								      sfun_bglt obj_2023;
								      obj_2023 =
									 (sfun_bglt) (fun_1654);
								      aux_2516 =
									 (((sfun_bglt) CREF(obj_2023))->body);
								   }
								   aux_2515 =
								      (node_bglt) (aux_2516);
								}
								arg1827_1656 =
								   rem__73_globalize_new_body_146(aux_2515, owner_7,
								   CAR(obindings_1634));
							     }
							     {	/* Globalize/new-body.scm 285 */
								sfun_bglt obj_2025;
								obj_t val1123_2026;
								obj_2025 =
								   (sfun_bglt) (fun_1654);
								val1123_2026 =
								   (obj_t) (arg1827_1656);
								((((sfun_bglt) CREF(obj_2025))->body) = ((obj_t) val1123_2026), BUNSPEC);
							     }
							  }
							  {	/* Globalize/new-body.scm 286 */
							     obj_t arg1830_1658;
							     obj_t arg1831_1659;
							     arg1830_1658 =
								CDR(obindings_1634);
							     {	/* ./Ieee/pair-list.scm 5689 */
								obj_t aux_2526;
								aux_2526 =
								   CAR(obindings_1634);
								arg1831_1659 =
								   MAKE_PAIR(aux_2526, nbindings_1635);
							     }
							     {
								obj_t nbindings_2530;
								obj_t obindings_2529;
								obindings_2529 = arg1830_1658;
								nbindings_2530 = arg1831_1659;
								nbindings_1635 = nbindings_2530;
								obindings_1634 = obindings_2529;
								goto liip_1636;
							     }
							  }
						       }
						    }
						 }
					       else
						 {	/* Globalize/new-body.scm 288 */
						    bool_t test_2531;
						    {	/* Globalize/new-body.scm 288 */
						       local_ginfo_108_bglt obj_2032;
						       {	/* Globalize/new-body.scm 288 */
							  obj_t aux_2532;
							  aux_2532 =
							     CAR(obindings_1634);
							  obj_2032 =
							     (local_ginfo_108_bglt) (aux_2532);
						       }
						       {
							  obj_t aux_2535;
							  {	/* ./Globalize/ginfo.scm 1306 */
							     object_bglt aux_2536;
							     aux_2536 =
								(object_bglt) (obj_2032);
							     aux_2535 =
								OBJECT_WIDENING(aux_2536);
							  }
							  test_2531 =
							     (((local_ginfo_108_bglt) CREF(aux_2535))->escape__117);
						       }
						    }
						    if (test_2531)
						      {		/* Globalize/new-body.scm 288 */
							 {	/* Globalize/new-body.scm 292 */
							    obj_t arg1835_1663;
							    obj_t arg1836_1664;
							    arg1835_1663 =
							       CDR(obindings_1634);
							    {	/* ./Ieee/pair-list.scm 5689 */
							       obj_t aux_2541;
							       aux_2541 =
								  CAR(obindings_1634);
							       arg1836_1664 =
								  MAKE_PAIR(aux_2541, nbindings_1635);
							    }
							    {
							       obj_t nbindings_2545;
							       obj_t obindings_2544;
							       obindings_2544 = arg1835_1663;
							       nbindings_2545 = arg1836_1664;
							       nbindings_1635 = nbindings_2545;
							       obindings_1634 = obindings_2544;
							       goto liip_1636;
							    }
							 }
						      }
						    else
						      {		/* Globalize/new-body.scm 288 */
							 {
							    obj_t obindings_2546;
							    obindings_2546 =
							       CDR(obindings_1634);
							    obindings_1634 = obindings_2546;
							    goto liip_1636;
							 }
						      }
						 }
					    }
				       }
				     aux_2353 =
					(obj_t) (aux_2446);
				  }
			       }
			    }
			    break;
			 case ((long) 14):

			    {	/* Globalize/new-body.scm 304 */
			       let_var_6_bglt node_1672;
			       node_1672 =
				  (let_var_6_bglt) (node_6);
			       {	/* Globalize/new-body.scm 305 */
				  node_bglt arg1846_1676;
				  arg1846_1676 =
				     rem__73_globalize_new_body_146(
				     (((let_var_6_bglt) CREF(node_1672))->body), owner_7, current_8);
				  ((((let_var_6_bglt) CREF(node_1672))->body) = ((node_bglt) arg1846_1676), BUNSPEC);
			       }
			       {
				  obj_t l1573_1678;
				  l1573_1678 =
				     (((let_var_6_bglt) CREF(node_1672))->bindings);
				lname1574_1679:
				  if (
				     PAIRP(l1573_1678))
				    {	/* Globalize/new-body.scm 306 */
				       {	/* Globalize/new-body.scm 307 */
					  obj_t binding_1682;
					  binding_1682 =
					     CAR(l1573_1678);
					  {	/* Globalize/new-body.scm 307 */
					     node_bglt arg1850_1683;
					     {	/* Globalize/new-body.scm 307 */
						node_bglt aux_2557;
						{	/* Globalize/new-body.scm 307 */
						   obj_t aux_2558;
						   aux_2558 =
						      CDR(binding_1682);
						   aux_2557 =
						      (node_bglt) (aux_2558);
						}
						arg1850_1683 =
						   rem__73_globalize_new_body_146(aux_2557, owner_7, current_8);
					     }
					     {	/* ./Ieee/pair-list.scm 5896 */
						obj_t aux_2562;
						aux_2562 =
						   (obj_t) (arg1850_1683);
						SET_CDR(binding_1682, aux_2562);
					     }
					  }
				       }
				       {
					  obj_t l1573_2565;
					  l1573_2565 =
					     CDR(l1573_1678);
					  l1573_1678 = l1573_2565;
					  goto lname1574_1679;
				       }
				    }
				  else
				    {	/* Globalize/new-body.scm 306 */
				       ((bool_t) 1);
				    }
			       }
			       aux_2353 =
				  (obj_t) (node_1672);
			    }
			    break;
			 case ((long) 15):

			    {	/* Globalize/new-body.scm 315 */
			       set_ex_it_116_bglt node_1686;
			       node_1686 =
				  (set_ex_it_116_bglt) (node_6);
			       {	/* Globalize/new-body.scm 316 */
				  node_bglt arg1853_1690;
				  arg1853_1690 =
				     rem__73_globalize_new_body_146(
				     (((set_ex_it_116_bglt) CREF(node_1686))->body), owner_7, current_8);
				  ((((set_ex_it_116_bglt) CREF(node_1686))->body) = ((node_bglt) arg1853_1690), BUNSPEC);
			       }
			       aux_2353 =
				  (obj_t) (node_1686);
			    }
			    break;
			 case ((long) 16):

			    {	/* Globalize/new-body.scm 323 */
			       jump_ex_it_184_bglt node_1692;
			       node_1692 =
				  (jump_ex_it_184_bglt) (node_6);
			       {	/* Globalize/new-body.scm 324 */
				  node_bglt arg1855_1696;
				  arg1855_1696 =
				     rem__73_globalize_new_body_146(
				     (((jump_ex_it_184_bglt) CREF(node_1692))->exit), owner_7, current_8);
				  ((((jump_ex_it_184_bglt) CREF(node_1692))->exit) = ((node_bglt) arg1855_1696), BUNSPEC);
			       }
			       {	/* Globalize/new-body.scm 325 */
				  node_bglt arg1857_1698;
				  arg1857_1698 =
				     rem__73_globalize_new_body_146(
				     (((jump_ex_it_184_bglt) CREF(node_1692))->value), owner_7, current_8);
				  ((((jump_ex_it_184_bglt) CREF(node_1692))->value) = ((node_bglt) arg1857_1698), BUNSPEC);
			       }
			       aux_2353 =
				  (obj_t) (node_1692);
			    }
			    break;
			 case ((long) 17):

			    {	/* Globalize/new-body.scm 332 */
			       make_box_202_bglt node_1700;
			       node_1700 =
				  (make_box_202_bglt) (node_6);
			       {	/* Globalize/new-body.scm 333 */
				  node_bglt arg1859_1704;
				  arg1859_1704 =
				     rem__73_globalize_new_body_146(
				     (((make_box_202_bglt) CREF(node_1700))->value), owner_7, current_8);
				  ((((make_box_202_bglt) CREF(node_1700))->value) = ((node_bglt) arg1859_1704), BUNSPEC);
			       }
			       aux_2353 =
				  (obj_t) (node_1700);
			    }
			    break;
			 case ((long) 18):

			    {	/* Globalize/new-body.scm 340 */
			       box_ref_242_bglt node_1706;
			       node_1706 =
				  (box_ref_242_bglt) (node_6);
			       {	/* Globalize/new-body.scm 341 */
				  node_bglt arg1861_1710;
				  {	/* Globalize/new-body.scm 341 */
				     node_bglt aux_2588;
				     {	/* Globalize/new-body.scm 341 */
					var_bglt aux_2589;
					aux_2589 =
					   (((box_ref_242_bglt) CREF(node_1706))->var);
					aux_2588 =
					   (node_bglt) (aux_2589);
				     }
				     arg1861_1710 =
					rem__73_globalize_new_body_146(aux_2588, owner_7, current_8);
				  }
				  {	/* Globalize/new-body.scm 341 */
				     var_bglt val1418_2062;
				     val1418_2062 =
					(var_bglt) (arg1861_1710);
				     ((((box_ref_242_bglt) CREF(node_1706))->var) = ((var_bglt) val1418_2062), BUNSPEC);
				  }
			       }
			       aux_2353 =
				  (obj_t) (node_1706);
			    }
			    break;
			 case ((long) 19):

			    {	/* Globalize/new-body.scm 348 */
			       box_set__221_bglt node_1712;
			       node_1712 =
				  (box_set__221_bglt) (node_6);
			       {	/* Globalize/new-body.scm 349 */
				  node_bglt arg1863_1716;
				  {	/* Globalize/new-body.scm 349 */
				     node_bglt aux_2597;
				     {	/* Globalize/new-body.scm 349 */
					var_bglt aux_2598;
					aux_2598 =
					   (((box_set__221_bglt) CREF(node_1712))->var);
					aux_2597 =
					   (node_bglt) (aux_2598);
				     }
				     arg1863_1716 =
					rem__73_globalize_new_body_146(aux_2597, owner_7, current_8);
				  }
				  {	/* Globalize/new-body.scm 349 */
				     var_bglt val1428_2065;
				     val1428_2065 =
					(var_bglt) (arg1863_1716);
				     ((((box_set__221_bglt) CREF(node_1712))->var) = ((var_bglt) val1428_2065), BUNSPEC);
				  }
			       }
			       {	/* Globalize/new-body.scm 350 */
				  node_bglt arg1865_1718;
				  arg1865_1718 =
				     rem__73_globalize_new_body_146(
				     (((box_set__221_bglt) CREF(node_1712))->value), owner_7, current_8);
				  ((((box_set__221_bglt) CREF(node_1712))->value) = ((node_bglt) arg1865_1718), BUNSPEC);
			       }
			       aux_2353 =
				  (obj_t) (node_1712);
			    }
			    break;
			 default:
			  case_else1767_1541:
			    if (
			       PROCEDUREP(method1761_1537))
			      {		/* Globalize/new-body.scm 138 */
				 aux_2353 =
				    PROCEDURE_ENTRY(method1761_1537) (method1761_1537,
				    (obj_t) (node_6), owner_7, current_8, BEOA)
				    ;
			      }
			    else
			      {		/* Globalize/new-body.scm 138 */
				 obj_t fun1760_1533;
				 fun1760_1533 =
				    PROCEDURE_REF(rem__env_83_globalize_new_body_146, ((long) 0));
				 aux_2353 =
				    PROCEDURE_ENTRY(fun1760_1533) (fun1760_1533,
				    (obj_t) (node_6), owner_7, current_8, BEOA);
			      }
			 }
		    }
		  else
		    {	/* Globalize/new-body.scm 138 */
		       goto case_else1767_1541;
		    }
	       }
	       return
		  (node_bglt) (aux_2353);
	    }
	 }
      }
   }
}



/* _rem! */
obj_t 
_rem__41_globalize_new_body_146(obj_t env_2077, obj_t node_2078, obj_t owner_2079, obj_t current_2080)
{
   AN_OBJECT;
   {	/* Globalize/new-body.scm 138 */
      {		/* Globalize/new-body.scm 138 */
	 node_bglt aux_2620;
	 aux_2620 =
	    rem__73_globalize_new_body_146(
	    (node_bglt) (node_2078), owner_2079, current_2080);
	 return
	    (obj_t) (aux_2620);
      }
   }
}



/* rem!-default1581 */
node_bglt 
rem__default1581_181_globalize_new_body_146(node_bglt node_9, obj_t owner_10, obj_t current_11)
{
   AN_OBJECT;
   {	/* Globalize/new-body.scm 14 */
      FAILURE(
	 CNST_TABLE_REF(((long) 1)), string1874_globalize_new_body_146,
	 (obj_t) (node_9));
   }
}



/* _rem!-default1581 */
obj_t 
_rem__default1581_159_globalize_new_body_146(obj_t env_2081, obj_t node_2082, obj_t owner_2083, obj_t current_2084)
{
   AN_OBJECT;
   {	/* Globalize/new-body.scm 14 */
      {		/* Globalize/new-body.scm 14 */
	 node_bglt aux_2627;
	 aux_2627 =
	    rem__default1581_181_globalize_new_body_146(
	    (node_bglt) (node_2082), owner_2083, current_2084);
	 return
	    (obj_t) (aux_2627);
      }
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_globalize_new_body_146()
{
   AN_OBJECT;
   {	/* Globalize/new-body.scm 14 */
      module_initialization_70_tools_trace(((long) 0), "GLOBALIZE_NEW-BODY");
      module_initialization_70_tools_shape(((long) 0), "GLOBALIZE_NEW-BODY");
      module_initialization_70_tools_speek(((long) 0), "GLOBALIZE_NEW-BODY");
      module_initialization_70_type_type(((long) 0), "GLOBALIZE_NEW-BODY");
      module_initialization_70_type_cache(((long) 0), "GLOBALIZE_NEW-BODY");
      module_initialization_70_ast_var(((long) 0), "GLOBALIZE_NEW-BODY");
      module_initialization_70_ast_node(((long) 0), "GLOBALIZE_NEW-BODY");
      module_initialization_70_ast_sexp(((long) 0), "GLOBALIZE_NEW-BODY");
      module_initialization_70_globalize_ginfo(((long) 0), "GLOBALIZE_NEW-BODY");
      return
	 module_initialization_70_globalize_node(((long) 0), "GLOBALIZE_NEW-BODY");
   }
}
