/*===========================================================================*/
/*   (Globalize/node.scm)                                                    */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;

typedef struct sfun_ginfo_98
  {
     bool_t g__219;
     obj_t cfrom;
     obj_t cfrom__119;
     obj_t cto;
     obj_t cto__14;
     obj_t cfunction;
     obj_t integrator;
     obj_t integrated;
     obj_t plugged_in_15;
     long mark;
     obj_t free_mark_81;
     obj_t the_global_201;
     obj_t kaptured;
     obj_t new_body_215;
     long bmark;
     long umark;
     obj_t free;
     obj_t bound;
  }
             *sfun_ginfo_98_bglt;

typedef struct svar_ginfo_131
  {
     bool_t kaptured__204;
     long free_mark_81;
     long mark;
     bool_t celled__113;
  }
              *svar_ginfo_131_bglt;

typedef struct sexit_ginfo_81
  {
     bool_t g__219;
     bool_t kaptured__204;
     long free_mark_81;
     long mark;
  }
              *sexit_ginfo_81_bglt;

typedef struct local_ginfo_108
  {
     bool_t escape__117;
  }
               *local_ginfo_108_bglt;

typedef struct global_ginfo_75
  {
     bool_t escape__117;
     obj_t global_closure_229;
  }
               *global_ginfo_75_bglt;


static let_var_6_bglt make_escaping_bindings_69_globalize_node(obj_t, node_bglt, variable_bglt);
static obj_t method_init_76_globalize_node();
extern obj_t make_box_202_ast_node;
extern obj_t find_global_module_25_ast_env(obj_t, obj_t);
extern obj_t funcall_ast_node;
extern long add_inlined_method__244___object(obj_t, obj_t, long);
extern obj_t fail_ast_node;
static obj_t glo___241_globalize_node(obj_t, variable_bglt);
extern obj_t box_ref_242_ast_node;
extern obj_t the_closure_238_globalize_free(variable_bglt, obj_t);
extern obj_t sequence_ast_node;
extern obj_t let_var_6_ast_node;
extern obj_t var_ast_node;
extern obj_t closure_ast_node;
extern obj_t global_ast_var;
extern obj_t _obj__252_type_cache;
extern obj_t pragma_ast_node;
extern obj_t set_ex_it_116_ast_node;
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t module_initialization_70_globalize_node(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_globalize_ginfo(long, char *);
extern obj_t module_initialization_70_ast_sexp(long, char *);
extern obj_t module_initialization_70_ast_env(long, char *);
extern obj_t module_initialization_70_ast_local(long, char *);
extern obj_t module_initialization_70_globalize_free(long, char *);
extern obj_t module_initialization_70_globalize_local__global_194(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
static app_bglt a_make_procedure_166_globalize_node(local_bglt);
extern long list_length(obj_t);
extern local_bglt make_local_svar_140_ast_local(obj_t, type_bglt);
extern long class_num_218___object(obj_t);
static obj_t make_sets_85_globalize_node(obj_t, obj_t, obj_t, variable_bglt);
extern obj_t let_fun_218_ast_node;
extern node_bglt node_globalize__229_globalize_node(node_bglt, variable_bglt, obj_t);
static obj_t imported_modules_init_94_globalize_node();
static bool_t celled__113_globalize_node(variable_bglt);
static obj_t celled_bindings_3_globalize_node(obj_t);
extern obj_t app_ly_162_ast_node;
extern obj_t add_generic__110___object(obj_t, obj_t);
static obj_t _glo__107_globalize_node(obj_t, obj_t, obj_t);
extern obj_t app_ast_node;
extern obj_t append_2_18___r4_pairs_and_lists_6_3(obj_t, obj_t);
static obj_t library_modules_init_112_globalize_node();
extern obj_t svar_ginfo_131_globalize_ginfo;
extern obj_t atom_ast_node;
extern obj_t cast_ast_node;
static obj_t toplevel_init_63_globalize_node();
extern obj_t jump_ex_it_184_ast_node;
extern obj_t open_input_string(obj_t);
extern obj_t kwote_ast_node;
static make_box_202_bglt a_make_cell_117_globalize_node(node_bglt, variable_bglt);
extern obj_t setq_ast_node;
extern obj_t box_set__221_ast_node;
static node_bglt glo__115_globalize_node(node_bglt, variable_bglt);
static app_bglt a_procedure_set__174_globalize_node(obj_t, obj_t, long, obj_t, variable_bglt);
extern obj_t local_ast_var;
static obj_t cell_formals_12_globalize_node(obj_t, node_bglt);
extern global_bglt the_global_201_globalize_local__global_194(local_bglt);
extern obj_t memq___r4_pairs_and_lists_6_3(obj_t, obj_t);
static obj_t _node_globalize_2119_43_globalize_node(obj_t, obj_t, obj_t, obj_t);
static obj_t _glo__default1621_41_globalize_node(obj_t, obj_t, obj_t);
extern obj_t _procedure__226_type_cache;
extern obj_t _classes__134___object;
extern obj_t select_ast_node;
extern obj_t read___reader(obj_t);
static node_bglt glo__default1621_84_globalize_node(node_bglt, variable_bglt);
extern obj_t ____74_type_cache;
static obj_t require_initialization_114_globalize_node = BUNSPEC;
extern obj_t conditional_ast_node;
static obj_t globalize_local_fun__50_globalize_node(local_bglt, variable_bglt);
static obj_t cnst_init_137_globalize_node();
extern obj_t reverse__39___r4_pairs_and_lists_6_3(obj_t);
static obj_t __cnst[9];

DEFINE_STATIC_GENERIC(glo__env_172_globalize_node, _glo__107_globalize_node2126, _glo__107_globalize_node, 0L, 2);
DEFINE_EXPORT_PROCEDURE(node_globalize__env_218_globalize_node, _node_globalize_2119_43_globalize_node2127, _node_globalize_2119_43_globalize_node, 0L, 3);
DEFINE_STATIC_PROCEDURE(glo__default1621_env_72_globalize_node, _glo__default1621_41_globalize_node2128, _glo__default1621_41_globalize_node, 0L, 2);
DEFINE_STRING(string2121_globalize_node, string2121_globalize_node2129, "GLO!-DEFAULT1621 AUX PROCEDURE-SET! FOREIGN MAKE-VA-PROCEDURE MAKE-FX-PROCEDURE DONE (WRITE CELL-GLOBALIZE) CELL-GLOBALIZE ", 123);
DEFINE_STRING(string2120_globalize_node, string2120_globalize_node2130, "No method for this object", 25);



/* module-initialization */
obj_t 
module_initialization_70_globalize_node(long checksum_2823, char *from_2824)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_globalize_node))
	{
	   require_initialization_114_globalize_node =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_globalize_node();
	   cnst_init_137_globalize_node();
	   imported_modules_init_94_globalize_node();
	   method_init_76_globalize_node();
	   toplevel_init_63_globalize_node();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_globalize_node()
{
   AN_OBJECT;
   {	/* Globalize/node.scm 16 */
      module_initialization_70___object(((long) 0), "GLOBALIZE_NODE");
      module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "GLOBALIZE_NODE");
      module_initialization_70___reader(((long) 0), "GLOBALIZE_NODE");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_globalize_node()
{
   AN_OBJECT;
   {	/* Globalize/node.scm 16 */
      {		/* Globalize/node.scm 16 */
	 obj_t cnst_port_138_2816;
	 cnst_port_138_2816 =
	    open_input_string(string2121_globalize_node);
	 {
	    long i_2817;
	    i_2817 = ((long) 8);
	  loop_2818:
	    {	/* Globalize/node.scm 16 */
	       bool_t test2122_2819;
	       test2122_2819 =
		  (i_2817 == ((long) -1));
	       if (test2122_2819)
		 {	/* Globalize/node.scm 16 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Globalize/node.scm 16 */
		    {	/* Globalize/node.scm 16 */
		       obj_t arg2123_2820;
		       {	/* Globalize/node.scm 16 */
			  obj_t list2124_2821;
			  list2124_2821 =
			     MAKE_PAIR(cnst_port_138_2816, BNIL);
			  arg2123_2820 =
			     read___reader(list2124_2821);
		       }
		       CNST_TABLE_SET(i_2817, arg2123_2820);
		    }
		    {	/* Globalize/node.scm 16 */
		       int aux_2822;
		       {	/* Globalize/node.scm 16 */
			  long aux_2842;
			  aux_2842 =
			     (i_2817 - ((long) 1));
			  aux_2822 =
			     (int) (aux_2842);
		       }
		       {
			  long i_2845;
			  i_2845 =
			     (long) (aux_2822);
			  i_2817 = i_2845;
			  goto loop_2818;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_globalize_node()
{
   AN_OBJECT;
   {	/* Globalize/node.scm 16 */
      return BUNSPEC;
   }
}



/* node-globalize! */
node_bglt 
node_globalize__229_globalize_node(node_bglt node_1, variable_bglt integrator_2, obj_t what_by__117_3)
{
   AN_OBJECT;
   {	/* Globalize/node.scm 37 */
      {		/* Globalize/node.scm 40 */
	 obj_t celled_1067;
	 {	/* Globalize/node.scm 41 */
	    obj_t aux_2847;
	    {	/* Globalize/node.scm 41 */
	       sfun_bglt obj_1944;
	       {	/* Globalize/node.scm 41 */
		  value_bglt aux_2848;
		  aux_2848 =
		     (((variable_bglt) CREF(integrator_2))->value);
		  obj_1944 =
		     (sfun_bglt) (aux_2848);
	       }
	       aux_2847 =
		  (((sfun_bglt) CREF(obj_1944))->args);
	    }
	    celled_1067 =
	       celled_bindings_3_globalize_node(aux_2847);
	 }
	 {	/* Globalize/node.scm 41 */
	    obj_t what_by__117_1068;
	    what_by__117_1068 =
	       append_2_18___r4_pairs_and_lists_6_3(celled_1067, what_by__117_3);
	    {	/* Globalize/node.scm 42 */

	       {
		  obj_t l1554_1069;
		  l1554_1069 = what_by__117_1068;
		lname1555_1070:
		  if (
		     PAIRP(l1554_1069))
		    {	/* Globalize/node.scm 44 */
		       {	/* Globalize/node.scm 45 */
			  obj_t w_b_127_1072;
			  w_b_127_1072 =
			     CAR(l1554_1069);
			  {	/* Globalize/node.scm 45 */
			     obj_t arg1666_1074;
			     arg1666_1074 =
				CDR(w_b_127_1072);
			     {	/* Globalize/node.scm 45 */
				local_bglt obj_1949;
				{	/* Globalize/node.scm 45 */
				   obj_t aux_2858;
				   aux_2858 =
				      CAR(w_b_127_1072);
				   obj_1949 =
				      (local_bglt) (aux_2858);
				}
				((((local_bglt) CREF(obj_1949))->fast_alpha_7) = ((obj_t) arg1666_1074), BUNSPEC);
			     }
			  }
		       }
		       {
			  obj_t l1554_2862;
			  l1554_2862 =
			     CDR(l1554_1069);
			  l1554_1069 = l1554_2862;
			  goto lname1555_1070;
		       }
		    }
		  else
		    {	/* Globalize/node.scm 44 */
		       ((bool_t) 1);
		    }
	       }
	       {	/* Globalize/node.scm 47 */
		  obj_t res_1076;
		  {	/* Globalize/node.scm 47 */
		     node_bglt arg1671_1083;
		     arg1671_1083 =
			glo__115_globalize_node(node_1, integrator_2);
		     res_1076 =
			cell_formals_12_globalize_node(celled_1067, arg1671_1083);
		  }
		  {
		     obj_t l1556_1077;
		     l1556_1077 = what_by__117_1068;
		   lname1557_1078:
		     if (
			PAIRP(l1556_1077))
		       {	/* Globalize/node.scm 49 */
			  {	/* Globalize/node.scm 50 */
			     local_bglt obj_1955;
			     {	/* Globalize/node.scm 50 */
				obj_t aux_2868;
				{	/* ./Ieee/pair-list.scm 5701 */
				   obj_t aux_2869;
				   aux_2869 =
				      CAR(l1556_1077);
				   aux_2868 =
				      CAR(aux_2869);
				}
				obj_1955 =
				   (local_bglt) (aux_2868);
			     }
			     ((((local_bglt) CREF(obj_1955))->fast_alpha_7) = ((obj_t) BUNSPEC), BUNSPEC);
			  }
			  {
			     obj_t l1556_2874;
			     l1556_2874 =
				CDR(l1556_1077);
			     l1556_1077 = l1556_2874;
			     goto lname1557_1078;
			  }
		       }
		     else
		       {	/* Globalize/node.scm 49 */
			  ((bool_t) 1);
		       }
		  }
		  return
		     (node_bglt) (res_1076);
	       }
	    }
	 }
      }
   }
}



/* _node-globalize!2119 */
obj_t 
_node_globalize_2119_43_globalize_node(obj_t env_2806, obj_t node_2807, obj_t integrator_2808, obj_t what_by__117_2809)
{
   AN_OBJECT;
   {	/* Globalize/node.scm 37 */
      {		/* Globalize/node.scm 37 */
	 node_bglt aux_2877;
	 aux_2877 =
	    node_globalize__229_globalize_node(
	    (node_bglt) (node_2807),
	    (variable_bglt) (integrator_2808), what_by__117_2809);
	 return
	    (obj_t) (aux_2877);
      }
   }
}



/* celled-bindings */
obj_t 
celled_bindings_3_globalize_node(obj_t formals_4)
{
   AN_OBJECT;
   {	/* Globalize/node.scm 57 */
      {
	 obj_t celled_1085;
	 obj_t formals_1086;
	 celled_1085 = BNIL;
	 formals_1086 = formals_4;
       loop_1087:
	 if (
	    NULLP(formals_1086))
	   {	/* Globalize/node.scm 61 */
	      return celled_1085;
	   }
	 else
	   {	/* Globalize/node.scm 63 */
	      bool_t test_2884;
	      {		/* Globalize/node.scm 63 */
		 variable_bglt aux_2885;
		 {	/* Globalize/node.scm 63 */
		    obj_t aux_2886;
		    aux_2886 =
		       CAR(formals_1086);
		    aux_2885 =
		       (variable_bglt) (aux_2886);
		 }
		 test_2884 =
		    celled__113_globalize_node(aux_2885);
	      }
	      if (test_2884)
		{	/* Globalize/node.scm 63 */
		   {	/* Globalize/node.scm 66 */
		      local_bglt var_1090;
		      {		/* Globalize/node.scm 66 */
			 obj_t aux_2890;
			 {	/* Globalize/node.scm 66 */
			    local_bglt obj_1961;
			    {	/* Globalize/node.scm 66 */
			       obj_t aux_2891;
			       aux_2891 =
				  CAR(formals_1086);
			       obj_1961 =
				  (local_bglt) (aux_2891);
			    }
			    aux_2890 =
			       (((local_bglt) CREF(obj_1961))->id);
			 }
			 var_1090 =
			    make_local_svar_140_ast_local(aux_2890,
			    (type_bglt) (_obj__252_type_cache));
		      }
		      {		/* Globalize/node.scm 66 */
			 obj_t o_n_168_1091;
			 {	/* ./Ieee/pair-list.scm 5689 */
			    obj_t aux_2899;
			    obj_t aux_2897;
			    aux_2899 =
			       (obj_t) (var_1090);
			    aux_2897 =
			       CAR(formals_1086);
			    o_n_168_1091 =
			       MAKE_PAIR(aux_2897, aux_2899);
			 }
			 {	/* Globalize/node.scm 67 */

			    {	/* Globalize/node.scm 68 */
			       obj_t val1084_1966;
			       val1084_1966 =
				  CNST_TABLE_REF(((long) 0));
			       ((((local_bglt) CREF(var_1090))->access) = ((obj_t) val1084_1966), BUNSPEC);
			    }
			    {	/* Globalize/node.scm 69 */
			       bool_t arg1675_1092;
			       {	/* Globalize/node.scm 69 */
				  local_bglt obj_1968;
				  {	/* Globalize/node.scm 69 */
				     obj_t aux_2904;
				     aux_2904 =
					CAR(formals_1086);
				     obj_1968 =
					(local_bglt) (aux_2904);
				  }
				  arg1675_1092 =
				     (((local_bglt) CREF(obj_1968))->user__32);
			       }
			       ((((local_bglt) CREF(var_1090))->user__32) = ((bool_t) arg1675_1092), BUNSPEC);
			    }
			    {	/* Globalize/node.scm 70 */
			       svar_ginfo_131_bglt obj1558_1094;
			       obj1558_1094 =
				  ((svar_ginfo_131_bglt) (
				     (((local_bglt) CREF(var_1090))->value)));
			       {	/* Globalize/node.scm 70 */
				  svar_ginfo_131_bglt arg1677_1095;
				  {	/* Globalize/node.scm 70 */
				     svar_ginfo_131_bglt res2092_1981;
				     {	/* ./Globalize/ginfo.scm 1430 */
					svar_ginfo_131_bglt new1494_1976;
					new1494_1976 =
					   ((svar_ginfo_131_bglt) BREF(GC_MALLOC(sizeof(struct svar_ginfo_131))));
					((((svar_ginfo_131_bglt) CREF(new1494_1976))->kaptured__204) = ((bool_t) ((bool_t) 1)), BUNSPEC);
					((((svar_ginfo_131_bglt) CREF(new1494_1976))->free_mark_81) = ((long) ((long) -10)), BUNSPEC);
					((((svar_ginfo_131_bglt) CREF(new1494_1976))->mark) = ((long) ((long) -10)), BUNSPEC);
					((((svar_ginfo_131_bglt) CREF(new1494_1976))->celled__113) = ((bool_t) ((bool_t) 1)), BUNSPEC);
					res2092_1981 = new1494_1976;
				     }
				     arg1677_1095 = res2092_1981;
				  }
				  {	/* Globalize/node.scm 70 */
				     obj_t aux_2918;
				     object_bglt aux_2916;
				     aux_2918 =
					(obj_t) (arg1677_1095);
				     aux_2916 =
					(object_bglt) (obj1558_1094);
				     OBJECT_WIDENING_SET(aux_2916, aux_2918);
				  }
			       }
			       {	/* Globalize/node.scm 70 */
				  long arg1682_1100;
				  arg1682_1100 =
				     class_num_218___object(svar_ginfo_131_globalize_ginfo);
				  {	/* Globalize/node.scm 70 */
				     obj_t obj_1982;
				     obj_1982 =
					(obj_t) (obj1558_1094);
				     (((obj_t) CREF(obj_1982))->header = MAKE_HEADER(arg1682_1100, 0), BUNSPEC);
				  }
			       }
			       obj1558_1094;
			    }
			    {	/* Globalize/node.scm 73 */
			       obj_t arg1683_1101;
			       obj_t arg1684_1102;
			       arg1683_1101 =
				  MAKE_PAIR(o_n_168_1091, celled_1085);
			       arg1684_1102 =
				  CDR(formals_1086);
			       {
				  obj_t formals_2927;
				  obj_t celled_2926;
				  celled_2926 = arg1683_1101;
				  formals_2927 = arg1684_1102;
				  formals_1086 = formals_2927;
				  celled_1085 = celled_2926;
				  goto loop_1087;
			       }
			    }
			 }
		      }
		   }
		}
	      else
		{	/* Globalize/node.scm 63 */
		   {
		      obj_t formals_2928;
		      formals_2928 =
			 CDR(formals_1086);
		      formals_1086 = formals_2928;
		      goto loop_1087;
		   }
		}
	   }
      }
   }
}



/* cell-formals */
obj_t 
cell_formals_12_globalize_node(obj_t celled_5, node_bglt body_6)
{
   AN_OBJECT;
   {	/* Globalize/node.scm 78 */
      {		/* Globalize/node.scm 79 */
	 bool_t test1690_1108;
	 test1690_1108 =
	    NULLP(celled_5);
	 if (test1690_1108)
	   {	/* Globalize/node.scm 79 */
	      return
		 (obj_t) (body_6);
	   }
	 else
	   {	/* Globalize/node.scm 81 */
	      obj_t loc_1109;
	      loc_1109 =
		 (((node_bglt) CREF(body_6))->loc);
	      {		/* Globalize/node.scm 82 */
		 obj_t arg1692_1111;
		 obj_t arg1694_1113;
		 arg1692_1111 = ____74_type_cache;
		 if (test1690_1108)
		   {	/* Globalize/node.scm 86 */
		      arg1694_1113 = BNIL;
		   }
		 else
		   {	/* Globalize/node.scm 86 */
		      obj_t head1562_1117;
		      head1562_1117 =
			 MAKE_PAIR(BNIL, BNIL);
		      {
			 obj_t l1560_1118;
			 obj_t tail1563_1119;
			 l1560_1118 = celled_5;
			 tail1563_1119 = head1562_1117;
		       lname1561_1120:
			 if (
			    NULLP(l1560_1118))
			   {	/* Globalize/node.scm 86 */
			      arg1694_1113 =
				 CDR(head1562_1117);
			   }
			 else
			   {	/* Globalize/node.scm 87 */
			      obj_t newtail1564_1122;
			      {		/* Globalize/node.scm 87 */
				 obj_t arg1699_1124;
				 {	/* Globalize/node.scm 87 */
				    obj_t o_n_168_1126;
				    o_n_168_1126 =
				       CAR(l1560_1118);
				    {	/* Globalize/node.scm 87 */
				       obj_t arg1701_1127;
				       make_box_202_bglt arg1702_1128;
				       arg1701_1127 =
					  CDR(o_n_168_1126);
				       {	/* Globalize/node.scm 88 */
					  var_bglt arg1703_1129;
					  obj_t arg1704_1130;
					  {	/* Globalize/node.scm 88 */
					     obj_t arg1706_1132;
					     arg1706_1132 = ____74_type_cache;
					     {	/* Globalize/node.scm 88 */
						var_bglt res2093_2008;
						{	/* Globalize/node.scm 88 */
						   type_bglt type_1999;
						   variable_bglt variable_2000;
						   type_1999 =
						      (type_bglt) (arg1706_1132);
						   {	/* Globalize/node.scm 88 */
						      obj_t aux_2942;
						      aux_2942 =
							 CAR(o_n_168_1126);
						      variable_2000 =
							 (variable_bglt) (aux_2942);
						   }
						   {	/* ./Ast/node.scm 1244 */
						      var_bglt new1210_2001;
						      new1210_2001 =
							 ((var_bglt) BREF(GC_MALLOC(sizeof(struct var))));
						      {		/* ./Ast/node.scm 1244 */
							 long arg1879_2002;
							 arg1879_2002 =
							    class_num_218___object(var_ast_node);
							 {	/* ./Ast/node.scm 1244 */
							    obj_t obj_2006;
							    obj_2006 =
							       (obj_t) (new1210_2001);
							    (((obj_t) CREF(obj_2006))->header = MAKE_HEADER(arg1879_2002, 0), BUNSPEC);
							 }
						      }
						      {		/* ./Ast/node.scm 1244 */
							 object_bglt aux_2949;
							 aux_2949 =
							    (object_bglt) (new1210_2001);
							 OBJECT_WIDENING_SET(aux_2949, BFALSE);
						      }
						      ((((var_bglt) CREF(new1210_2001))->loc) = ((obj_t) loc_1109), BUNSPEC);
						      ((((var_bglt) CREF(new1210_2001))->type) = ((type_bglt) type_1999), BUNSPEC);
						      ((((var_bglt) CREF(new1210_2001))->variable) = ((variable_bglt) variable_2000), BUNSPEC);
						      res2093_2008 = new1210_2001;
						   }
						}
						arg1703_1129 = res2093_2008;
					     }
					  }
					  arg1704_1130 =
					     CAR(o_n_168_1126);
					  arg1702_1128 =
					     a_make_cell_117_globalize_node(
					     (node_bglt) (arg1703_1129),
					     (variable_bglt) (arg1704_1130));
				       }
				       {	/* ./Ieee/pair-list.scm 5689 */
					  obj_t aux_2959;
					  aux_2959 =
					     (obj_t) (arg1702_1128);
					  arg1699_1124 =
					     MAKE_PAIR(arg1701_1127, aux_2959);
				       }
				    }
				 }
				 newtail1564_1122 =
				    MAKE_PAIR(arg1699_1124, BNIL);
			      }
			      SET_CDR(tail1563_1119, newtail1564_1122);
			      {
				 obj_t tail1563_2966;
				 obj_t l1560_2964;
				 l1560_2964 =
				    CDR(l1560_1118);
				 tail1563_2966 = newtail1564_1122;
				 tail1563_1119 = tail1563_2966;
				 l1560_1118 = l1560_2964;
				 goto lname1561_1120;
			      }
			   }
		      }
		   }
		 {	/* Globalize/node.scm 82 */
		    let_var_6_bglt res2094_2035;
		    {	/* Globalize/node.scm 82 */
		       type_bglt type_2018;
		       obj_t key_2020;
		       type_2018 =
			  (type_bglt) (arg1692_1111);
		       key_2020 =
			  BINT(((long) -1));
		       {	/* ./Ast/node.scm 1337 */
			  let_var_6_bglt new1373_2024;
			  new1373_2024 =
			     ((let_var_6_bglt) BREF(GC_MALLOC(sizeof(struct let_var_6))));
			  {	/* ./Ast/node.scm 1337 */
			     long arg1850_2025;
			     arg1850_2025 =
				class_num_218___object(let_var_6_ast_node);
			     {	/* ./Ast/node.scm 1337 */
				obj_t obj_2033;
				obj_2033 =
				   (obj_t) (new1373_2024);
				(((obj_t) CREF(obj_2033))->header = MAKE_HEADER(arg1850_2025, 0), BUNSPEC);
			     }
			  }
			  {	/* ./Ast/node.scm 1337 */
			     object_bglt aux_2973;
			     aux_2973 =
				(object_bglt) (new1373_2024);
			     OBJECT_WIDENING_SET(aux_2973, BFALSE);
			  }
			  ((((let_var_6_bglt) CREF(new1373_2024))->loc) = ((obj_t) loc_1109), BUNSPEC);
			  ((((let_var_6_bglt) CREF(new1373_2024))->type) = ((type_bglt) type_2018), BUNSPEC);
			  ((((let_var_6_bglt) CREF(new1373_2024))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
			  ((((let_var_6_bglt) CREF(new1373_2024))->key) = ((obj_t) key_2020), BUNSPEC);
			  ((((let_var_6_bglt) CREF(new1373_2024))->bindings) = ((obj_t) arg1694_1113), BUNSPEC);
			  ((((let_var_6_bglt) CREF(new1373_2024))->body) = ((node_bglt) body_6), BUNSPEC);
			  ((((let_var_6_bglt) CREF(new1373_2024))->removable__42) = ((bool_t) ((bool_t) 1)), BUNSPEC);
			  res2094_2035 = new1373_2024;
		       }
		    }
		    return
		       (obj_t) (res2094_2035);
		 }
	      }
	   }
      }
   }
}



/* a-make-cell */
make_box_202_bglt 
a_make_cell_117_globalize_node(node_bglt node_7, variable_bglt variable_8)
{
   AN_OBJECT;
   {	/* Globalize/node.scm 98 */
      {		/* Globalize/node.scm 100 */
	 local_bglt obj_2036;
	 obj_t val1084_2037;
	 obj_2036 =
	    (local_bglt) (variable_8);
	 val1084_2037 =
	    CNST_TABLE_REF(((long) 0));
	 ((((local_bglt) CREF(obj_2036))->access) = ((obj_t) val1084_2037), BUNSPEC);
      }
      {		/* Globalize/node.scm 101 */
	 svar_ginfo_131_bglt obj_2039;
	 {	/* Globalize/node.scm 101 */
	    value_bglt aux_2987;
	    aux_2987 =
	       (((variable_bglt) CREF(variable_8))->value);
	    obj_2039 =
	       (svar_ginfo_131_bglt) (aux_2987);
	 }
	 {
	    obj_t aux_2990;
	    {	/* ./Globalize/ginfo.scm 1438 */
	       object_bglt aux_2991;
	       aux_2991 =
		  (object_bglt) (obj_2039);
	       aux_2990 =
		  OBJECT_WIDENING(aux_2991);
	    }
	    ((((svar_ginfo_131_bglt) CREF(aux_2990))->celled__113) = ((bool_t) ((bool_t) 1)), BUNSPEC);
	 }
      }
      {		/* Globalize/node.scm 102 */
	 obj_t arg1709_1136;
	 obj_t arg1711_1137;
	 arg1709_1136 =
	    (((node_bglt) CREF(node_7))->loc);
	 arg1711_1137 = ____74_type_cache;
	 {	/* Globalize/node.scm 102 */
	    make_box_202_bglt res2095_2056;
	    {	/* Globalize/node.scm 102 */
	       type_bglt type_2043;
	       obj_t key_2045;
	       type_2043 =
		  (type_bglt) (arg1711_1137);
	       key_2045 =
		  BINT(((long) -1));
	       {	/* ./Ast/node.scm 1360 */
		  make_box_202_bglt new1407_2047;
		  new1407_2047 =
		     ((make_box_202_bglt) BREF(GC_MALLOC(sizeof(struct make_box_202))));
		  {	/* ./Ast/node.scm 1360 */
		     long arg1844_2048;
		     arg1844_2048 =
			class_num_218___object(make_box_202_ast_node);
		     {	/* ./Ast/node.scm 1360 */
			obj_t obj_2054;
			obj_2054 =
			   (obj_t) (new1407_2047);
			(((obj_t) CREF(obj_2054))->header = MAKE_HEADER(arg1844_2048, 0), BUNSPEC);
		     }
		  }
		  {	/* ./Ast/node.scm 1360 */
		     object_bglt aux_3002;
		     aux_3002 =
			(object_bglt) (new1407_2047);
		     OBJECT_WIDENING_SET(aux_3002, BFALSE);
		  }
		  ((((make_box_202_bglt) CREF(new1407_2047))->loc) = ((obj_t) arg1709_1136), BUNSPEC);
		  ((((make_box_202_bglt) CREF(new1407_2047))->type) = ((type_bglt) type_2043), BUNSPEC);
		  ((((make_box_202_bglt) CREF(new1407_2047))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
		  ((((make_box_202_bglt) CREF(new1407_2047))->key) = ((obj_t) key_2045), BUNSPEC);
		  ((((make_box_202_bglt) CREF(new1407_2047))->value) = ((node_bglt) node_7), BUNSPEC);
		  res2095_2056 = new1407_2047;
	       }
	    }
	    return res2095_2056;
	 }
      }
   }
}



/* celled? */
bool_t 
celled__113_globalize_node(variable_bglt variable_9)
{
   AN_OBJECT;
   {	/* Globalize/node.scm 107 */
      {		/* Globalize/node.scm 108 */
	 bool_t _andtest_1568_1140;
	 _andtest_1568_1140 =
	    is_a__118___object(
	    (obj_t) (variable_9), local_ast_var);
	 if (_andtest_1568_1140)
	   {	/* Globalize/node.scm 109 */
	      bool_t _andtest_1569_1141;
	      {		/* ./Globalize/ginfo.scm 1430 */
		 obj_t aux_3013;
		 {	/* Globalize/node.scm 109 */
		    value_bglt aux_3014;
		    aux_3014 =
		       (((variable_bglt) CREF(variable_9))->value);
		    aux_3013 =
		       (obj_t) (aux_3014);
		 }
		 _andtest_1569_1141 =
		    is_a__118___object(aux_3013, svar_ginfo_131_globalize_ginfo);
	      }
	      if (_andtest_1569_1141)
		{	/* Globalize/node.scm 110 */
		   bool_t _ortest_1570_1142;
		   {	/* Globalize/node.scm 110 */
		      svar_ginfo_131_bglt obj_2061;
		      {		/* Globalize/node.scm 110 */
			 value_bglt aux_3019;
			 aux_3019 =
			    (((variable_bglt) CREF(variable_9))->value);
			 obj_2061 =
			    (svar_ginfo_131_bglt) (aux_3019);
		      }
		      {
			 obj_t aux_3022;
			 {	/* ./Globalize/ginfo.scm 1438 */
			    object_bglt aux_3023;
			    aux_3023 =
			       (object_bglt) (obj_2061);
			    aux_3022 =
			       OBJECT_WIDENING(aux_3023);
			 }
			 _ortest_1570_1142 =
			    (((svar_ginfo_131_bglt) CREF(aux_3022))->celled__113);
		      }
		   }
		   if (_ortest_1570_1142)
		     {	/* Globalize/node.scm 110 */
			return _ortest_1570_1142;
		     }
		   else
		     {	/* Globalize/node.scm 111 */
			bool_t test_3028;
			{	/* Globalize/node.scm 111 */
			   obj_t aux_3029;
			   aux_3029 =
			      memq___r4_pairs_and_lists_6_3(
			      (((variable_bglt) CREF(variable_9))->access),
			      CNST_TABLE_REF(((long) 1)));
			   test_3028 =
			      CBOOL(aux_3029);
			}
			if (test_3028)
			  {	/* Globalize/node.scm 112 */
			     svar_ginfo_131_bglt obj_2064;
			     {	/* Globalize/node.scm 112 */
				value_bglt aux_3034;
				aux_3034 =
				   (((variable_bglt) CREF(variable_9))->value);
				obj_2064 =
				   (svar_ginfo_131_bglt) (aux_3034);
			     }
			     {
				obj_t aux_3037;
				{	/* ./Globalize/ginfo.scm 1432 */
				   object_bglt aux_3038;
				   aux_3038 =
				      (object_bglt) (obj_2064);
				   aux_3037 =
				      OBJECT_WIDENING(aux_3038);
				}
				return
				   (((svar_ginfo_131_bglt) CREF(aux_3037))->kaptured__204);
			     }
			  }
			else
			  {	/* Globalize/node.scm 111 */
			     return ((bool_t) 0);
			  }
		     }
		}
	      else
		{	/* Globalize/node.scm 109 */
		   return ((bool_t) 0);
		}
	   }
	 else
	   {	/* Globalize/node.scm 108 */
	      return ((bool_t) 0);
	   }
      }
   }
}



/* glo*! */
obj_t 
glo___241_globalize_node(obj_t node__221_56, variable_bglt integrator_57)
{
   AN_OBJECT;
   {	/* Globalize/node.scm 439 */
      {
	 obj_t node__221_1149;
	 node__221_1149 = node__221_56;
       loop_1150:
	 if (
	    NULLP(node__221_1149))
	   {	/* Globalize/node.scm 441 */
	      return
		 CNST_TABLE_REF(((long) 2));
	   }
	 else
	   {	/* Globalize/node.scm 441 */
	      {		/* Globalize/node.scm 444 */
		 node_bglt arg1720_1152;
		 {	/* Globalize/node.scm 444 */
		    node_bglt aux_3045;
		    {	/* Globalize/node.scm 444 */
		       obj_t aux_3046;
		       aux_3046 =
			  CAR(node__221_1149);
		       aux_3045 =
			  (node_bglt) (aux_3046);
		    }
		    arg1720_1152 =
		       glo__115_globalize_node(aux_3045, integrator_57);
		 }
		 {	/* ./Ieee/pair-list.scm 5890 */
		    obj_t aux_3050;
		    aux_3050 =
		       (obj_t) (arg1720_1152);
		    SET_CAR(node__221_1149, aux_3050);
		 }
	      }
	      {
		 obj_t node__221_3053;
		 node__221_3053 =
		    CDR(node__221_1149);
		 node__221_1149 = node__221_3053;
		 goto loop_1150;
	      }
	   }
      }
   }
}



/* make-escaping-bindings */
let_var_6_bglt 
make_escaping_bindings_69_globalize_node(obj_t ebindings_58, node_bglt node_59, variable_bglt integrator_60)
{
   AN_OBJECT;
   {	/* Globalize/node.scm 450 */
      {
	 obj_t ebindings_1155;
	 obj_t bindings_1156;
	 obj_t sets_1157;
	 ebindings_1155 = ebindings_58;
	 bindings_1156 = BNIL;
	 sets_1157 = BNIL;
       loop_1158:
	 if (
	    NULLP(ebindings_1155))
	   {	/* Globalize/node.scm 461 */
	      obj_t arg1724_1160;
	      obj_t arg1725_1161;
	      obj_t arg1728_1164;
	      arg1724_1160 =
		 (((node_bglt) CREF(node_59))->loc);
	      arg1725_1161 = ____74_type_cache;
	      if (
		 NULLP(sets_1157))
		{	/* Globalize/node.scm 464 */
		   arg1728_1164 =
		      (obj_t) (node_59);
		}
	      else
		{	/* Globalize/node.scm 467 */
		   obj_t arg1730_1166;
		   obj_t arg1731_1167;
		   obj_t arg1733_1169;
		   arg1730_1166 =
		      (((node_bglt) CREF(node_59))->loc);
		   arg1731_1167 = ____74_type_cache;
		   {	/* Globalize/node.scm 469 */
		      obj_t arg1734_1170;
		      {		/* Globalize/node.scm 469 */
			 obj_t list1735_1171;
			 {	/* Globalize/node.scm 469 */
			    obj_t aux_3062;
			    aux_3062 =
			       (obj_t) (node_59);
			    list1735_1171 =
			       MAKE_PAIR(aux_3062, BNIL);
			 }
			 arg1734_1170 = list1735_1171;
		      }
		      arg1733_1169 =
			 append_2_18___r4_pairs_and_lists_6_3(sets_1157, arg1734_1170);
		   }
		   {	/* Globalize/node.scm 466 */
		      sequence_bglt res2096_2089;
		      {		/* Globalize/node.scm 466 */
			 type_bglt type_2076;
			 obj_t key_2078;
			 type_2076 =
			    (type_bglt) (arg1731_1167);
			 key_2078 =
			    BINT(((long) -1));
			 {	/* ./Ast/node.scm 1257 */
			    sequence_bglt new1234_2080;
			    new1234_2080 =
			       ((sequence_bglt) BREF(GC_MALLOC(sizeof(struct sequence))));
			    {	/* ./Ast/node.scm 1257 */
			       long arg1872_2081;
			       arg1872_2081 =
				  class_num_218___object(sequence_ast_node);
			       {	/* ./Ast/node.scm 1257 */
				  obj_t obj_2087;
				  obj_2087 =
				     (obj_t) (new1234_2080);
				  (((obj_t) CREF(obj_2087))->header = MAKE_HEADER(arg1872_2081, 0), BUNSPEC);
			       }
			    }
			    {	/* ./Ast/node.scm 1257 */
			       object_bglt aux_3072;
			       aux_3072 =
				  (object_bglt) (new1234_2080);
			       OBJECT_WIDENING_SET(aux_3072, BFALSE);
			    }
			    ((((sequence_bglt) CREF(new1234_2080))->loc) = ((obj_t) arg1730_1166), BUNSPEC);
			    ((((sequence_bglt) CREF(new1234_2080))->type) = ((type_bglt) type_2076), BUNSPEC);
			    ((((sequence_bglt) CREF(new1234_2080))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
			    ((((sequence_bglt) CREF(new1234_2080))->key) = ((obj_t) key_2078), BUNSPEC);
			    ((((sequence_bglt) CREF(new1234_2080))->nodes) = ((obj_t) arg1733_1169), BUNSPEC);
			    res2096_2089 = new1234_2080;
			 }
		      }
		      arg1728_1164 =
			 (obj_t) (res2096_2089);
		   }
		}
	      {		/* Globalize/node.scm 460 */
		 let_var_6_bglt res2097_2108;
		 {	/* Globalize/node.scm 460 */
		    type_bglt type_2091;
		    obj_t key_2093;
		    node_bglt body_2095;
		    type_2091 =
		       (type_bglt) (arg1725_1161);
		    key_2093 =
		       BINT(((long) -1));
		    body_2095 =
		       (node_bglt) (arg1728_1164);
		    {	/* ./Ast/node.scm 1337 */
		       let_var_6_bglt new1373_2097;
		       new1373_2097 =
			  ((let_var_6_bglt) BREF(GC_MALLOC(sizeof(struct let_var_6))));
		       {	/* ./Ast/node.scm 1337 */
			  long arg1850_2098;
			  arg1850_2098 =
			     class_num_218___object(let_var_6_ast_node);
			  {	/* ./Ast/node.scm 1337 */
			     obj_t obj_2106;
			     obj_2106 =
				(obj_t) (new1373_2097);
			     (((obj_t) CREF(obj_2106))->header = MAKE_HEADER(arg1850_2098, 0), BUNSPEC);
			  }
		       }
		       {	/* ./Ast/node.scm 1337 */
			  object_bglt aux_3088;
			  aux_3088 =
			     (object_bglt) (new1373_2097);
			  OBJECT_WIDENING_SET(aux_3088, BFALSE);
		       }
		       ((((let_var_6_bglt) CREF(new1373_2097))->loc) = ((obj_t) arg1724_1160), BUNSPEC);
		       ((((let_var_6_bglt) CREF(new1373_2097))->type) = ((type_bglt) type_2091), BUNSPEC);
		       ((((let_var_6_bglt) CREF(new1373_2097))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
		       ((((let_var_6_bglt) CREF(new1373_2097))->key) = ((obj_t) key_2093), BUNSPEC);
		       ((((let_var_6_bglt) CREF(new1373_2097))->bindings) = ((obj_t) bindings_1156), BUNSPEC);
		       ((((let_var_6_bglt) CREF(new1373_2097))->body) = ((node_bglt) body_2095), BUNSPEC);
		       ((((let_var_6_bglt) CREF(new1373_2097))->removable__42) = ((bool_t) ((bool_t) 1)), BUNSPEC);
		       res2097_2108 = new1373_2097;
		    }
		 }
		 return res2097_2108;
	      }
	   }
	 else
	   {	/* Globalize/node.scm 470 */
	      obj_t local_1172;
	      local_1172 =
		 CAR(ebindings_1155);
	      {		/* Globalize/node.scm 470 */
		 obj_t new_1173;
		 new_1173 =
		    the_closure_238_globalize_free(
		    (variable_bglt) (local_1172),
		    (((node_bglt) CREF(node_59))->loc));
		 {	/* Globalize/node.scm 471 */
		    obj_t nsets_1174;
		    {	/* Globalize/node.scm 472 */
		       obj_t aux_3102;
		       {	/* Globalize/node.scm 474 */
			  sfun_ginfo_98_bglt obj_2113;
			  {	/* Globalize/node.scm 474 */
			     value_bglt aux_3104;
			     {	/* Globalize/node.scm 474 */
				local_bglt obj_2112;
				obj_2112 =
				   (local_bglt) (local_1172);
				aux_3104 =
				   (((local_bglt) CREF(obj_2112))->value);
			     }
			     obj_2113 =
				(sfun_ginfo_98_bglt) (aux_3104);
			  }
			  {
			     obj_t aux_3108;
			     {	/* ./Globalize/ginfo.scm 1418 */
				object_bglt aux_3109;
				aux_3109 =
				   (object_bglt) (obj_2113);
				aux_3108 =
				   OBJECT_WIDENING(aux_3109);
			     }
			     aux_3102 =
				(((sfun_ginfo_98_bglt) CREF(aux_3108))->kaptured);
			  }
		       }
		       nsets_1174 =
			  make_sets_85_globalize_node(new_1173,
			  (((node_bglt) CREF(node_59))->loc), aux_3102, integrator_60);
		    }
		    {	/* Globalize/node.scm 472 */

		       {	/* Globalize/node.scm 476 */
			  obj_t arg1736_1175;
			  obj_t arg1738_1176;
			  obj_t arg1739_1177;
			  arg1736_1175 =
			     CDR(ebindings_1155);
			  {	/* Globalize/node.scm 477 */
			     obj_t arg1740_1178;
			     {	/* Globalize/node.scm 477 */
				app_bglt arg1741_1179;
				arg1741_1179 =
				   a_make_procedure_166_globalize_node(
				   (local_bglt) (local_1172));
				{	/* ./Ieee/pair-list.scm 5689 */
				   obj_t aux_3117;
				   aux_3117 =
				      (obj_t) (arg1741_1179);
				   arg1740_1178 =
				      MAKE_PAIR(new_1173, aux_3117);
				}
			     }
			     arg1738_1176 =
				MAKE_PAIR(arg1740_1178, bindings_1156);
			  }
			  if (
			     NULLP(nsets_1174))
			    {	/* Globalize/node.scm 479 */
			       arg1739_1177 = sets_1157;
			    }
			  else
			    {	/* Globalize/node.scm 479 */
			       arg1739_1177 =
				  MAKE_PAIR(nsets_1174, sets_1157);
			    }
			  {
			     obj_t sets_3126;
			     obj_t bindings_3125;
			     obj_t ebindings_3124;
			     ebindings_3124 = arg1736_1175;
			     bindings_3125 = arg1738_1176;
			     sets_3126 = arg1739_1177;
			     sets_1157 = sets_3126;
			     bindings_1156 = bindings_3125;
			     ebindings_1155 = ebindings_3124;
			     goto loop_1158;
			  }
		       }
		    }
		 }
	      }
	   }
      }
   }
}



/* globalize-local-fun! */
obj_t 
globalize_local_fun__50_globalize_node(local_bglt local_61, variable_bglt integrator_62)
{
   AN_OBJECT;
   {	/* Globalize/node.scm 486 */
      {		/* Globalize/node.scm 487 */
	 value_bglt fun_1185;
	 fun_1185 =
	    (((local_bglt) CREF(local_61))->value);
	 {	/* Globalize/node.scm 487 */
	    obj_t obody_1186;
	    {	/* Globalize/node.scm 488 */
	       sfun_bglt obj_2123;
	       obj_2123 =
		  (sfun_bglt) (fun_1185);
	       obody_1186 =
		  (((sfun_bglt) CREF(obj_2123))->body);
	    }
	    {	/* Globalize/node.scm 488 */

	       {	/* Globalize/node.scm 489 */
		  bool_t test_3130;
		  {	/* ./Ieee/equiv.scm 5508 */
		     obj_t aux_3133;
		     obj_t aux_3131;
		     aux_3133 =
			(obj_t) (integrator_62);
		     aux_3131 =
			(obj_t) (local_61);
		     test_3130 =
			(aux_3131 == aux_3133);
		  }
		  if (test_3130)
		    {	/* Globalize/node.scm 490 */
		       node_bglt arg1748_1188;
		       arg1748_1188 =
			  glo__115_globalize_node(
			  (node_bglt) (obody_1186), integrator_62);
		       {	/* Globalize/node.scm 490 */
			  sfun_bglt obj_2126;
			  obj_t val1123_2127;
			  obj_2126 =
			     (sfun_bglt) (fun_1185);
			  val1123_2127 =
			     (obj_t) (arg1748_1188);
			  return
			     ((((sfun_bglt) CREF(obj_2126))->body) = ((obj_t) val1123_2127), BUNSPEC);
		       }
		    }
		  else
		    {	/* Globalize/node.scm 491 */
		       obj_t celled_1189;
		       {	/* Globalize/node.scm 491 */
			  obj_t aux_3141;
			  {	/* Globalize/node.scm 491 */
			     sfun_bglt obj_2128;
			     obj_2128 =
				(sfun_bglt) (fun_1185);
			     aux_3141 =
				(((sfun_bglt) CREF(obj_2128))->args);
			  }
			  celled_1189 =
			     celled_bindings_3_globalize_node(aux_3141);
		       }
		       {
			  obj_t l1606_1190;
			  l1606_1190 = celled_1189;
			lname1607_1191:
			  if (
			     PAIRP(l1606_1190))
			    {	/* Globalize/node.scm 492 */
			       {	/* Globalize/node.scm 493 */
				  obj_t w_b_127_1193;
				  w_b_127_1193 =
				     CAR(l1606_1190);
				  {	/* Globalize/node.scm 493 */
				     obj_t arg1751_1195;
				     arg1751_1195 =
					CDR(w_b_127_1193);
				     {	/* Globalize/node.scm 493 */
					local_bglt obj_2133;
					{	/* Globalize/node.scm 493 */
					   obj_t aux_3149;
					   aux_3149 =
					      CAR(w_b_127_1193);
					   obj_2133 =
					      (local_bglt) (aux_3149);
					}
					((((local_bglt) CREF(obj_2133))->fast_alpha_7) = ((obj_t) arg1751_1195), BUNSPEC);
				     }
				  }
			       }
			       {
				  obj_t l1606_3153;
				  l1606_3153 =
				     CDR(l1606_1190);
				  l1606_1190 = l1606_3153;
				  goto lname1607_1191;
			       }
			    }
			  else
			    {	/* Globalize/node.scm 492 */
			       ((bool_t) 1);
			    }
		       }
		       {	/* Globalize/node.scm 495 */
			  node_bglt nbody1_1197;
			  nbody1_1197 =
			     glo__115_globalize_node(
			     (node_bglt) (obody_1186), integrator_62);
			  {	/* Globalize/node.scm 495 */
			     obj_t nbody2_1198;
			     nbody2_1198 =
				cell_formals_12_globalize_node(celled_1189, nbody1_1197);
			     {	/* Globalize/node.scm 496 */

				{
				   obj_t l1608_1199;
				   l1608_1199 = celled_1189;
				 lname1609_1200:
				   if (
				      PAIRP(l1608_1199))
				     {	/* Globalize/node.scm 497 */
					{	/* Globalize/node.scm 498 */
					   local_bglt obj_2139;
					   {	/* Globalize/node.scm 498 */
					      obj_t aux_3160;
					      {		/* ./Ieee/pair-list.scm 5701 */
						 obj_t aux_3161;
						 aux_3161 =
						    CAR(l1608_1199);
						 aux_3160 =
						    CAR(aux_3161);
					      }
					      obj_2139 =
						 (local_bglt) (aux_3160);
					   }
					   ((((local_bglt) CREF(obj_2139))->fast_alpha_7) = ((obj_t) BUNSPEC), BUNSPEC);
					}
					{
					   obj_t l1608_3166;
					   l1608_3166 =
					      CDR(l1608_1199);
					   l1608_1199 = l1608_3166;
					   goto lname1609_1200;
					}
				     }
				   else
				     {	/* Globalize/node.scm 497 */
					((bool_t) 1);
				     }
				}
				{	/* Globalize/node.scm 500 */
				   sfun_bglt obj_2142;
				   obj_2142 =
				      (sfun_bglt) (fun_1185);
				   return
				      ((((sfun_bglt) CREF(obj_2142))->body) = ((obj_t) nbody2_1198), BUNSPEC);
				}
			     }
			  }
		       }
		    }
	       }
	    }
	 }
      }
   }
}



/* a-make-procedure */
app_bglt 
a_make_procedure_166_globalize_node(local_bglt local_63)
{
   AN_OBJECT;
   {	/* Globalize/node.scm 505 */
      {		/* Globalize/node.scm 506 */
	 long arity_1207;
	 {	/* Globalize/node.scm 507 */
	    sfun_bglt obj_2145;
	    {	/* Globalize/node.scm 507 */
	       value_bglt aux_3170;
	       aux_3170 =
		  (((local_bglt) CREF(local_63))->value);
	       obj_2145 =
		  (sfun_bglt) (aux_3170);
	    }
	    arity_1207 =
	       (((sfun_bglt) CREF(obj_2145))->arity);
	 }
	 {	/* Globalize/node.scm 512 */

	    {	/* Globalize/node.scm 513 */
	       obj_t arg1759_1212;
	       var_bglt arg1761_1214;
	       obj_t arg1762_1215;
	       arg1759_1212 = ____74_type_cache;
	       {	/* Globalize/node.scm 516 */
		  obj_t arg1764_1217;
		  obj_t arg1765_1218;
		  arg1764_1217 = ____74_type_cache;
		  {	/* Globalize/node.scm 519 */
		     obj_t aux_3174;
		     if (
			(arity_1207 >= ((long) 0)))
		       {	/* Globalize/node.scm 512 */
			  aux_3174 =
			     CNST_TABLE_REF(((long) 3))
			     ;
		       }
		     else
		       {	/* Globalize/node.scm 512 */
			  aux_3174 =
			     CNST_TABLE_REF(((long) 4))
			     ;
		       }
		     arg1765_1218 =
			find_global_module_25_ast_env(aux_3174,
			CNST_TABLE_REF(((long) 5)));
		  }
		  {	/* Globalize/node.scm 516 */
		     var_bglt res2098_2160;
		     {	/* Globalize/node.scm 516 */
			type_bglt type_2151;
			variable_bglt variable_2152;
			type_2151 =
			   (type_bglt) (arg1764_1217);
			variable_2152 =
			   (variable_bglt) (arg1765_1218);
			{	/* ./Ast/node.scm 1244 */
			   var_bglt new1210_2153;
			   new1210_2153 =
			      ((var_bglt) BREF(GC_MALLOC(sizeof(struct var))));
			   {	/* ./Ast/node.scm 1244 */
			      long arg1879_2154;
			      arg1879_2154 =
				 class_num_218___object(var_ast_node);
			      {		/* ./Ast/node.scm 1244 */
				 obj_t obj_2158;
				 obj_2158 =
				    (obj_t) (new1210_2153);
				 (((obj_t) CREF(obj_2158))->header = MAKE_HEADER(arg1879_2154, 0), BUNSPEC);
			      }
			   }
			   {	/* ./Ast/node.scm 1244 */
			      object_bglt aux_3187;
			      aux_3187 =
				 (object_bglt) (new1210_2153);
			      OBJECT_WIDENING_SET(aux_3187, BFALSE);
			   }
			   ((((var_bglt) CREF(new1210_2153))->loc) = ((obj_t) BUNSPEC), BUNSPEC);
			   ((((var_bglt) CREF(new1210_2153))->type) = ((type_bglt) type_2151), BUNSPEC);
			   ((((var_bglt) CREF(new1210_2153))->variable) = ((variable_bglt) variable_2152), BUNSPEC);
			   res2098_2160 = new1210_2153;
			}
		     }
		     arg1761_1214 = res2098_2160;
		  }
	       }
	       {	/* Globalize/node.scm 520 */
		  var_bglt arg1766_1219;
		  atom_bglt arg1767_1220;
		  atom_bglt arg1768_1221;
		  {	/* Globalize/node.scm 520 */
		     obj_t arg1773_1226;
		     global_bglt arg1774_1227;
		     arg1773_1226 = ____74_type_cache;
		     arg1774_1227 =
			the_global_201_globalize_local__global_194(local_63);
		     {	/* Globalize/node.scm 520 */
			var_bglt res2099_2171;
			{	/* Globalize/node.scm 520 */
			   type_bglt type_2162;
			   variable_bglt variable_2163;
			   type_2162 =
			      (type_bglt) (arg1773_1226);
			   variable_2163 =
			      (variable_bglt) (arg1774_1227);
			   {	/* ./Ast/node.scm 1244 */
			      var_bglt new1210_2164;
			      new1210_2164 =
				 ((var_bglt) BREF(GC_MALLOC(sizeof(struct var))));
			      {		/* ./Ast/node.scm 1244 */
				 long arg1879_2165;
				 arg1879_2165 =
				    class_num_218___object(var_ast_node);
				 {	/* ./Ast/node.scm 1244 */
				    obj_t obj_2169;
				    obj_2169 =
				       (obj_t) (new1210_2164);
				    (((obj_t) CREF(obj_2169))->header = MAKE_HEADER(arg1879_2165, 0), BUNSPEC);
				 }
			      }
			      {		/* ./Ast/node.scm 1244 */
				 object_bglt aux_3200;
				 aux_3200 =
				    (object_bglt) (new1210_2164);
				 OBJECT_WIDENING_SET(aux_3200, BFALSE);
			      }
			      ((((var_bglt) CREF(new1210_2164))->loc) = ((obj_t) BUNSPEC), BUNSPEC);
			      ((((var_bglt) CREF(new1210_2164))->type) = ((type_bglt) type_2162), BUNSPEC);
			      ((((var_bglt) CREF(new1210_2164))->variable) = ((variable_bglt) variable_2163), BUNSPEC);
			      res2099_2171 = new1210_2164;
			   }
			}
			arg1766_1219 = res2099_2171;
		     }
		  }
		  {	/* Globalize/node.scm 524 */
		     obj_t arg1776_1229;
		     arg1776_1229 = ____74_type_cache;
		     {	/* Globalize/node.scm 524 */
			atom_bglt res2100_2182;
			{	/* Globalize/node.scm 524 */
			   type_bglt type_2173;
			   obj_t value_2174;
			   type_2173 =
			      (type_bglt) (arg1776_1229);
			   value_2174 =
			      BINT(arity_1207);
			   {	/* ./Ast/node.scm 1239 */
			      atom_bglt new1202_2175;
			      new1202_2175 =
				 ((atom_bglt) BREF(GC_MALLOC(sizeof(struct atom))));
			      {		/* ./Ast/node.scm 1239 */
				 long arg1881_2176;
				 arg1881_2176 =
				    class_num_218___object(atom_ast_node);
				 {	/* ./Ast/node.scm 1239 */
				    obj_t obj_2180;
				    obj_2180 =
				       (obj_t) (new1202_2175);
				    (((obj_t) CREF(obj_2180))->header = MAKE_HEADER(arg1881_2176, 0), BUNSPEC);
				 }
			      }
			      {		/* ./Ast/node.scm 1239 */
				 object_bglt aux_3212;
				 aux_3212 =
				    (object_bglt) (new1202_2175);
				 OBJECT_WIDENING_SET(aux_3212, BFALSE);
			      }
			      ((((atom_bglt) CREF(new1202_2175))->loc) = ((obj_t) BUNSPEC), BUNSPEC);
			      ((((atom_bglt) CREF(new1202_2175))->type) = ((type_bglt) type_2173), BUNSPEC);
			      ((((atom_bglt) CREF(new1202_2175))->value) = ((obj_t) value_2174), BUNSPEC);
			      res2100_2182 = new1202_2175;
			   }
			}
			arg1767_1220 = res2100_2182;
		     }
		  }
		  {	/* Globalize/node.scm 528 */
		     obj_t arg1779_1232;
		     arg1779_1232 = ____74_type_cache;
		     {	/* Globalize/node.scm 528 */
			atom_bglt res2101_2193;
			{	/* Globalize/node.scm 528 */
			   type_bglt type_2184;
			   obj_t value_2185;
			   type_2184 =
			      (type_bglt) (arg1779_1232);
			   {	/* Globalize/node.scm 528 */
			      long aux_3219;
			      {		/* Globalize/node.scm 531 */
				 obj_t aux_3220;
				 {	/* Globalize/node.scm 508 */
				    sfun_ginfo_98_bglt obj_2147;
				    {	/* Globalize/node.scm 508 */
				       value_bglt aux_3221;
				       aux_3221 =
					  (((local_bglt) CREF(local_63))->value);
				       obj_2147 =
					  (sfun_ginfo_98_bglt) (aux_3221);
				    }
				    {
				       obj_t aux_3224;
				       {	/* ./Globalize/ginfo.scm 1418 */
					  object_bglt aux_3225;
					  aux_3225 =
					     (object_bglt) (obj_2147);
					  aux_3224 =
					     OBJECT_WIDENING(aux_3225);
				       }
				       aux_3220 =
					  (((sfun_ginfo_98_bglt) CREF(aux_3224))->kaptured);
				    }
				 }
				 aux_3219 =
				    list_length(aux_3220);
			      }
			      value_2185 =
				 BINT(aux_3219);
			   }
			   {	/* ./Ast/node.scm 1239 */
			      atom_bglt new1202_2186;
			      new1202_2186 =
				 ((atom_bglt) BREF(GC_MALLOC(sizeof(struct atom))));
			      {		/* ./Ast/node.scm 1239 */
				 long arg1881_2187;
				 arg1881_2187 =
				    class_num_218___object(atom_ast_node);
				 {	/* ./Ast/node.scm 1239 */
				    obj_t obj_2191;
				    obj_2191 =
				       (obj_t) (new1202_2186);
				    (((obj_t) CREF(obj_2191))->header = MAKE_HEADER(arg1881_2187, 0), BUNSPEC);
				 }
			      }
			      {		/* ./Ast/node.scm 1239 */
				 object_bglt aux_3235;
				 aux_3235 =
				    (object_bglt) (new1202_2186);
				 OBJECT_WIDENING_SET(aux_3235, BFALSE);
			      }
			      ((((atom_bglt) CREF(new1202_2186))->loc) = ((obj_t) BUNSPEC), BUNSPEC);
			      ((((atom_bglt) CREF(new1202_2186))->type) = ((type_bglt) type_2184), BUNSPEC);
			      ((((atom_bglt) CREF(new1202_2186))->value) = ((obj_t) value_2185), BUNSPEC);
			      res2101_2193 = new1202_2186;
			   }
			}
			arg1768_1221 = res2101_2193;
		     }
		  }
		  {	/* Globalize/node.scm 520 */
		     obj_t list1769_1222;
		     {	/* Globalize/node.scm 520 */
			obj_t arg1770_1223;
			{	/* Globalize/node.scm 520 */
			   obj_t arg1771_1224;
			   {	/* Globalize/node.scm 520 */
			      obj_t aux_3241;
			      aux_3241 =
				 (obj_t) (arg1768_1221);
			      arg1771_1224 =
				 MAKE_PAIR(aux_3241, BNIL);
			   }
			   {	/* Globalize/node.scm 520 */
			      obj_t aux_3244;
			      aux_3244 =
				 (obj_t) (arg1767_1220);
			      arg1770_1223 =
				 MAKE_PAIR(aux_3244, arg1771_1224);
			   }
			}
			{	/* Globalize/node.scm 520 */
			   obj_t aux_3247;
			   aux_3247 =
			      (obj_t) (arg1766_1219);
			   list1769_1222 =
			      MAKE_PAIR(aux_3247, arg1770_1223);
			}
		     }
		     arg1762_1215 = list1769_1222;
		  }
	       }
	       {	/* Globalize/node.scm 513 */
		  app_bglt res2102_2213;
		  {	/* Globalize/node.scm 513 */
		     type_bglt type_2196;
		     obj_t key_2198;
		     type_2196 =
			(type_bglt) (arg1759_1212);
		     key_2198 =
			BINT(((long) -1));
		     {	/* ./Ast/node.scm 1261 */
			app_bglt new1248_2202;
			new1248_2202 =
			   ((app_bglt) BREF(GC_MALLOC(sizeof(struct app))));
			{	/* ./Ast/node.scm 1261 */
			   long arg1870_2203;
			   arg1870_2203 =
			      class_num_218___object(app_ast_node);
			   {	/* ./Ast/node.scm 1261 */
			      obj_t obj_2211;
			      obj_2211 =
				 (obj_t) (new1248_2202);
			      (((obj_t) CREF(obj_2211))->header = MAKE_HEADER(arg1870_2203, 0), BUNSPEC);
			   }
			}
			{	/* ./Ast/node.scm 1261 */
			   object_bglt aux_3256;
			   aux_3256 =
			      (object_bglt) (new1248_2202);
			   OBJECT_WIDENING_SET(aux_3256, BFALSE);
			}
			((((app_bglt) CREF(new1248_2202))->loc) = ((obj_t) BUNSPEC), BUNSPEC);
			((((app_bglt) CREF(new1248_2202))->type) = ((type_bglt) type_2196), BUNSPEC);
			((((app_bglt) CREF(new1248_2202))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
			((((app_bglt) CREF(new1248_2202))->key) = ((obj_t) key_2198), BUNSPEC);
			((((app_bglt) CREF(new1248_2202))->fun) = ((var_bglt) arg1761_1214), BUNSPEC);
			((((app_bglt) CREF(new1248_2202))->args) = ((obj_t) arg1762_1215), BUNSPEC);
			((((app_bglt) CREF(new1248_2202))->stack_info_255) = ((obj_t) BUNSPEC), BUNSPEC);
			res2102_2213 = new1248_2202;
		     }
		  }
		  return res2102_2213;
	       }
	    }
	 }
      }
   }
}



/* make-sets */
obj_t 
make_sets_85_globalize_node(obj_t new_64, obj_t loc_65, obj_t kaptured_66, variable_bglt integrator_67)
{
   AN_OBJECT;
   {	/* Globalize/node.scm 536 */
      if (
	 NULLP(kaptured_66))
	{	/* Globalize/node.scm 537 */
	   return BNIL;
	}
      else
	{	/* Globalize/node.scm 539 */
	   obj_t arg1785_1238;
	   obj_t arg1787_1240;
	   arg1785_1238 = ____74_type_cache;
	   {
	      obj_t kaptured_1241;
	      long indice_1242;
	      obj_t sets_1243;
	      kaptured_1241 = kaptured_66;
	      indice_1242 = ((long) 0);
	      sets_1243 = BNIL;
	    loop_1244:
	      if (
		 NULLP(kaptured_1241))
		{	/* Globalize/node.scm 545 */
		   arg1787_1240 =
		      reverse__39___r4_pairs_and_lists_6_3(sets_1243);
		}
	      else
		{	/* Globalize/node.scm 547 */
		   obj_t arg1789_1246;
		   long arg1790_1247;
		   obj_t arg1791_1248;
		   arg1789_1246 =
		      CDR(kaptured_1241);
		   arg1790_1247 =
		      (indice_1242 + ((long) 1));
		   {	/* Globalize/node.scm 552 */
		      app_bglt arg1792_1249;
		      arg1792_1249 =
			 a_procedure_set__174_globalize_node(loc_65, new_64, indice_1242,
			 CAR(kaptured_1241), integrator_67);
		      {		/* ./Ieee/pair-list.scm 5689 */
			 obj_t aux_3275;
			 aux_3275 =
			    (obj_t) (arg1792_1249);
			 arg1791_1248 =
			    MAKE_PAIR(aux_3275, sets_1243);
		      }
		   }
		   {
		      obj_t sets_3280;
		      long indice_3279;
		      obj_t kaptured_3278;
		      kaptured_3278 = arg1789_1246;
		      indice_3279 = arg1790_1247;
		      sets_3280 = arg1791_1248;
		      sets_1243 = sets_3280;
		      indice_1242 = indice_3279;
		      kaptured_1241 = kaptured_3278;
		      goto loop_1244;
		   }
		}
	   }
	   {	/* Globalize/node.scm 539 */
	      sequence_bglt res2103_2236;
	      {		/* Globalize/node.scm 539 */
		 type_bglt type_2223;
		 obj_t key_2225;
		 type_2223 =
		    (type_bglt) (arg1785_1238);
		 key_2225 =
		    BINT(((long) -1));
		 {	/* ./Ast/node.scm 1257 */
		    sequence_bglt new1234_2227;
		    new1234_2227 =
		       ((sequence_bglt) BREF(GC_MALLOC(sizeof(struct sequence))));
		    {	/* ./Ast/node.scm 1257 */
		       long arg1872_2228;
		       arg1872_2228 =
			  class_num_218___object(sequence_ast_node);
		       {	/* ./Ast/node.scm 1257 */
			  obj_t obj_2234;
			  obj_2234 =
			     (obj_t) (new1234_2227);
			  (((obj_t) CREF(obj_2234))->header = MAKE_HEADER(arg1872_2228, 0), BUNSPEC);
		       }
		    }
		    {	/* ./Ast/node.scm 1257 */
		       object_bglt aux_3287;
		       aux_3287 =
			  (object_bglt) (new1234_2227);
		       OBJECT_WIDENING_SET(aux_3287, BFALSE);
		    }
		    ((((sequence_bglt) CREF(new1234_2227))->loc) = ((obj_t) loc_65), BUNSPEC);
		    ((((sequence_bglt) CREF(new1234_2227))->type) = ((type_bglt) type_2223), BUNSPEC);
		    ((((sequence_bglt) CREF(new1234_2227))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
		    ((((sequence_bglt) CREF(new1234_2227))->key) = ((obj_t) key_2225), BUNSPEC);
		    ((((sequence_bglt) CREF(new1234_2227))->nodes) = ((obj_t) arg1787_1240), BUNSPEC);
		    res2103_2236 = new1234_2227;
		 }
	      }
	      return
		 (obj_t) (res2103_2236);
	   }
	}
   }
}



/* a-procedure-set! */
app_bglt 
a_procedure_set__174_globalize_node(obj_t loc_68, obj_t new_69, long indice_70, obj_t kaptured_71, variable_bglt integrator_72)
{
   AN_OBJECT;
   {	/* Globalize/node.scm 559 */
      {
	 obj_t var_1275;
	 {	/* Globalize/node.scm 565 */
	    obj_t arg1795_1253;
	    var_bglt arg1797_1255;
	    obj_t arg1798_1256;
	    arg1795_1253 = ____74_type_cache;
	    {	/* Globalize/node.scm 568 */
	       obj_t arg1801_1258;
	       obj_t arg1802_1259;
	       arg1801_1258 = ____74_type_cache;
	       arg1802_1259 =
		  find_global_module_25_ast_env(
		  CNST_TABLE_REF(((long) 6)),
		  CNST_TABLE_REF(((long) 5)));
	       {	/* Globalize/node.scm 568 */
		  var_bglt res2104_2247;
		  {	/* Globalize/node.scm 568 */
		     type_bglt type_2238;
		     variable_bglt variable_2239;
		     type_2238 =
			(type_bglt) (arg1801_1258);
		     variable_2239 =
			(variable_bglt) (arg1802_1259);
		     {	/* ./Ast/node.scm 1244 */
			var_bglt new1210_2240;
			new1210_2240 =
			   ((var_bglt) BREF(GC_MALLOC(sizeof(struct var))));
			{	/* ./Ast/node.scm 1244 */
			   long arg1879_2241;
			   arg1879_2241 =
			      class_num_218___object(var_ast_node);
			   {	/* ./Ast/node.scm 1244 */
			      obj_t obj_2245;
			      obj_2245 =
				 (obj_t) (new1210_2240);
			      (((obj_t) CREF(obj_2245))->header = MAKE_HEADER(arg1879_2241, 0), BUNSPEC);
			   }
			}
			{	/* ./Ast/node.scm 1244 */
			   object_bglt aux_3305;
			   aux_3305 =
			      (object_bglt) (new1210_2240);
			   OBJECT_WIDENING_SET(aux_3305, BFALSE);
			}
			((((var_bglt) CREF(new1210_2240))->loc) = ((obj_t) loc_68), BUNSPEC);
			((((var_bglt) CREF(new1210_2240))->type) = ((type_bglt) type_2238), BUNSPEC);
			((((var_bglt) CREF(new1210_2240))->variable) = ((variable_bglt) variable_2239), BUNSPEC);
			res2104_2247 = new1210_2240;
		     }
		  }
		  arg1797_1255 = res2104_2247;
	       }
	    }
	    {	/* Globalize/node.scm 572 */
	       var_bglt arg1803_1260;
	       atom_bglt arg1804_1261;
	       var_bglt arg1805_1262;
	       {	/* Globalize/node.scm 572 */
		  obj_t arg1811_1267;
		  arg1811_1267 = ____74_type_cache;
		  {	/* Globalize/node.scm 572 */
		     var_bglt res2105_2258;
		     {	/* Globalize/node.scm 572 */
			type_bglt type_2249;
			variable_bglt variable_2250;
			type_2249 =
			   (type_bglt) (arg1811_1267);
			variable_2250 =
			   (variable_bglt) (new_69);
			{	/* ./Ast/node.scm 1244 */
			   var_bglt new1210_2251;
			   new1210_2251 =
			      ((var_bglt) BREF(GC_MALLOC(sizeof(struct var))));
			   {	/* ./Ast/node.scm 1244 */
			      long arg1879_2252;
			      arg1879_2252 =
				 class_num_218___object(var_ast_node);
			      {		/* ./Ast/node.scm 1244 */
				 obj_t obj_2256;
				 obj_2256 =
				    (obj_t) (new1210_2251);
				 (((obj_t) CREF(obj_2256))->header = MAKE_HEADER(arg1879_2252, 0), BUNSPEC);
			      }
			   }
			   {	/* ./Ast/node.scm 1244 */
			      object_bglt aux_3317;
			      aux_3317 =
				 (object_bglt) (new1210_2251);
			      OBJECT_WIDENING_SET(aux_3317, BFALSE);
			   }
			   ((((var_bglt) CREF(new1210_2251))->loc) = ((obj_t) loc_68), BUNSPEC);
			   ((((var_bglt) CREF(new1210_2251))->type) = ((type_bglt) type_2249), BUNSPEC);
			   ((((var_bglt) CREF(new1210_2251))->variable) = ((variable_bglt) variable_2250), BUNSPEC);
			   res2105_2258 = new1210_2251;
			}
		     }
		     arg1803_1260 = res2105_2258;
		  }
	       }
	       {	/* Globalize/node.scm 576 */
		  obj_t arg1814_1270;
		  arg1814_1270 = ____74_type_cache;
		  {	/* Globalize/node.scm 576 */
		     atom_bglt res2106_2269;
		     {	/* Globalize/node.scm 576 */
			type_bglt type_2260;
			obj_t value_2261;
			type_2260 =
			   (type_bglt) (arg1814_1270);
			value_2261 =
			   BINT(indice_70);
			{	/* ./Ast/node.scm 1239 */
			   atom_bglt new1202_2262;
			   new1202_2262 =
			      ((atom_bglt) BREF(GC_MALLOC(sizeof(struct atom))));
			   {	/* ./Ast/node.scm 1239 */
			      long arg1881_2263;
			      arg1881_2263 =
				 class_num_218___object(atom_ast_node);
			      {		/* ./Ast/node.scm 1239 */
				 obj_t obj_2267;
				 obj_2267 =
				    (obj_t) (new1202_2262);
				 (((obj_t) CREF(obj_2267))->header = MAKE_HEADER(arg1881_2263, 0), BUNSPEC);
			      }
			   }
			   {	/* ./Ast/node.scm 1239 */
			      object_bglt aux_3329;
			      aux_3329 =
				 (object_bglt) (new1202_2262);
			      OBJECT_WIDENING_SET(aux_3329, BFALSE);
			   }
			   ((((atom_bglt) CREF(new1202_2262))->loc) = ((obj_t) loc_68), BUNSPEC);
			   ((((atom_bglt) CREF(new1202_2262))->type) = ((type_bglt) type_2260), BUNSPEC);
			   ((((atom_bglt) CREF(new1202_2262))->value) = ((obj_t) value_2261), BUNSPEC);
			   res2106_2269 = new1202_2262;
			}
		     }
		     arg1804_1261 = res2106_2269;
		  }
	       }
	       {	/* Globalize/node.scm 580 */
		  obj_t arg1817_1273;
		  arg1817_1273 = ____74_type_cache;
		  {	/* Globalize/node.scm 580 */
		     var_bglt res2107_2280;
		     {	/* Globalize/node.scm 580 */
			type_bglt type_2271;
			variable_bglt variable_2272;
			type_2271 =
			   (type_bglt) (arg1817_1273);
			{	/* Globalize/node.scm 580 */
			   obj_t aux_3336;
			   var_1275 = kaptured_71;
			 _anonymous_1819__206_1276:
			   {	/* Globalize/node.scm 561 */
			      obj_t alpha_1277;
			      {		/* Globalize/node.scm 561 */
				 variable_bglt obj_2301;
				 obj_2301 =
				    (variable_bglt) (var_1275);
				 alpha_1277 =
				    (((variable_bglt) CREF(obj_2301))->fast_alpha_7);
			      }
			      {		/* Globalize/node.scm 562 */
				 bool_t test1820_1278;
				 test1820_1278 =
				    is_a__118___object(alpha_1277, local_ast_var);
				 if (test1820_1278)
				   {
				      obj_t var_3341;
				      var_3341 = alpha_1277;
				      var_1275 = var_3341;
				      goto _anonymous_1819__206_1276;
				   }
				 else
				   {	/* Globalize/node.scm 562 */
				      aux_3336 = var_1275
					 ;
				   }
			      }
			   }
			   variable_2272 =
			      (variable_bglt) (aux_3336);
			}
			{	/* ./Ast/node.scm 1244 */
			   var_bglt new1210_2273;
			   new1210_2273 =
			      ((var_bglt) BREF(GC_MALLOC(sizeof(struct var))));
			   {	/* ./Ast/node.scm 1244 */
			      long arg1879_2274;
			      arg1879_2274 =
				 class_num_218___object(var_ast_node);
			      {		/* ./Ast/node.scm 1244 */
				 obj_t obj_2278;
				 obj_2278 =
				    (obj_t) (new1210_2273);
				 (((obj_t) CREF(obj_2278))->header = MAKE_HEADER(arg1879_2274, 0), BUNSPEC);
			      }
			   }
			   {	/* ./Ast/node.scm 1244 */
			      object_bglt aux_3347;
			      aux_3347 =
				 (object_bglt) (new1210_2273);
			      OBJECT_WIDENING_SET(aux_3347, BFALSE);
			   }
			   ((((var_bglt) CREF(new1210_2273))->loc) = ((obj_t) loc_68), BUNSPEC);
			   ((((var_bglt) CREF(new1210_2273))->type) = ((type_bglt) type_2271), BUNSPEC);
			   ((((var_bglt) CREF(new1210_2273))->variable) = ((variable_bglt) variable_2272), BUNSPEC);
			   res2107_2280 = new1210_2273;
			}
		     }
		     arg1805_1262 = res2107_2280;
		  }
	       }
	       {	/* Globalize/node.scm 572 */
		  obj_t list1806_1263;
		  {	/* Globalize/node.scm 572 */
		     obj_t arg1807_1264;
		     {	/* Globalize/node.scm 572 */
			obj_t arg1809_1265;
			{	/* Globalize/node.scm 572 */
			   obj_t aux_3353;
			   aux_3353 =
			      (obj_t) (arg1805_1262);
			   arg1809_1265 =
			      MAKE_PAIR(aux_3353, BNIL);
			}
			{	/* Globalize/node.scm 572 */
			   obj_t aux_3356;
			   aux_3356 =
			      (obj_t) (arg1804_1261);
			   arg1807_1264 =
			      MAKE_PAIR(aux_3356, arg1809_1265);
			}
		     }
		     {	/* Globalize/node.scm 572 */
			obj_t aux_3359;
			aux_3359 =
			   (obj_t) (arg1803_1260);
			list1806_1263 =
			   MAKE_PAIR(aux_3359, arg1807_1264);
		     }
		  }
		  arg1798_1256 = list1806_1263;
	       }
	    }
	    {	/* Globalize/node.scm 565 */
	       app_bglt res2108_2300;
	       {	/* Globalize/node.scm 565 */
		  type_bglt type_2283;
		  obj_t key_2285;
		  type_2283 =
		     (type_bglt) (arg1795_1253);
		  key_2285 =
		     BINT(((long) -1));
		  {	/* ./Ast/node.scm 1261 */
		     app_bglt new1248_2289;
		     new1248_2289 =
			((app_bglt) BREF(GC_MALLOC(sizeof(struct app))));
		     {	/* ./Ast/node.scm 1261 */
			long arg1870_2290;
			arg1870_2290 =
			   class_num_218___object(app_ast_node);
			{	/* ./Ast/node.scm 1261 */
			   obj_t obj_2298;
			   obj_2298 =
			      (obj_t) (new1248_2289);
			   (((obj_t) CREF(obj_2298))->header = MAKE_HEADER(arg1870_2290, 0), BUNSPEC);
			}
		     }
		     {	/* ./Ast/node.scm 1261 */
			object_bglt aux_3368;
			aux_3368 =
			   (object_bglt) (new1248_2289);
			OBJECT_WIDENING_SET(aux_3368, BFALSE);
		     }
		     ((((app_bglt) CREF(new1248_2289))->loc) = ((obj_t) loc_68), BUNSPEC);
		     ((((app_bglt) CREF(new1248_2289))->type) = ((type_bglt) type_2283), BUNSPEC);
		     ((((app_bglt) CREF(new1248_2289))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
		     ((((app_bglt) CREF(new1248_2289))->key) = ((obj_t) key_2285), BUNSPEC);
		     ((((app_bglt) CREF(new1248_2289))->fun) = ((var_bglt) arg1797_1255), BUNSPEC);
		     ((((app_bglt) CREF(new1248_2289))->args) = ((obj_t) arg1798_1256), BUNSPEC);
		     ((((app_bglt) CREF(new1248_2289))->stack_info_255) = ((obj_t) BUNSPEC), BUNSPEC);
		     res2108_2300 = new1248_2289;
		  }
	       }
	       return res2108_2300;
	    }
	 }
      }
   }
}



/* method-init */
obj_t 
method_init_76_globalize_node()
{
   AN_OBJECT;
   {	/* Globalize/node.scm 16 */
      add_generic__110___object(glo__env_172_globalize_node, glo__default1621_env_72_globalize_node);
      add_inlined_method__244___object(glo__env_172_globalize_node, atom_ast_node, ((long) 0));
      add_inlined_method__244___object(glo__env_172_globalize_node, kwote_ast_node, ((long) 1));
      add_inlined_method__244___object(glo__env_172_globalize_node, var_ast_node, ((long) 2));
      add_inlined_method__244___object(glo__env_172_globalize_node, closure_ast_node, ((long) 3));
      add_inlined_method__244___object(glo__env_172_globalize_node, sequence_ast_node, ((long) 4));
      add_inlined_method__244___object(glo__env_172_globalize_node, app_ast_node, ((long) 5));
      add_inlined_method__244___object(glo__env_172_globalize_node, app_ly_162_ast_node, ((long) 6));
      add_inlined_method__244___object(glo__env_172_globalize_node, funcall_ast_node, ((long) 7));
      add_inlined_method__244___object(glo__env_172_globalize_node, pragma_ast_node, ((long) 8));
      add_inlined_method__244___object(glo__env_172_globalize_node, cast_ast_node, ((long) 9));
      add_inlined_method__244___object(glo__env_172_globalize_node, setq_ast_node, ((long) 10));
      add_inlined_method__244___object(glo__env_172_globalize_node, conditional_ast_node, ((long) 11));
      add_inlined_method__244___object(glo__env_172_globalize_node, fail_ast_node, ((long) 12));
      add_inlined_method__244___object(glo__env_172_globalize_node, select_ast_node, ((long) 13));
      add_inlined_method__244___object(glo__env_172_globalize_node, let_fun_218_ast_node, ((long) 14));
      add_inlined_method__244___object(glo__env_172_globalize_node, let_var_6_ast_node, ((long) 15));
      add_inlined_method__244___object(glo__env_172_globalize_node, set_ex_it_116_ast_node, ((long) 16));
      add_inlined_method__244___object(glo__env_172_globalize_node, jump_ex_it_184_ast_node, ((long) 17));
      add_inlined_method__244___object(glo__env_172_globalize_node, make_box_202_ast_node, ((long) 18));
      add_inlined_method__244___object(glo__env_172_globalize_node, box_ref_242_ast_node, ((long) 19));
      {		/* Globalize/node.scm 16 */
	 long aux_3399;
	 aux_3399 =
	    add_inlined_method__244___object(glo__env_172_globalize_node, box_set__221_ast_node, ((long) 20));
	 return
	    BINT(aux_3399);
      }
   }
}



/* glo! */
node_bglt 
glo__115_globalize_node(node_bglt node_10, variable_bglt integrator_11)
{
   AN_OBJECT;
   {	/* Globalize/node.scm 117 */
      {
	 obj_t method1912_1674;
	 obj_t class1917_1675;
	 {	/* Globalize/node.scm 117 */
	    obj_t arg1920_1672;
	    obj_t arg1921_1673;
	    {	/* Globalize/node.scm 117 */
	       object_bglt obj_2468;
	       obj_2468 =
		  (object_bglt) (node_10);
	       {	/* ./Llib/object.scm 2926 */
		  obj_t pre_method_105_2469;
		  pre_method_105_2469 =
		     PROCEDURE_REF(glo__env_172_globalize_node, ((long) 2));
		  if (
		     INTEGERP(pre_method_105_2469))
		    {	/* ./Llib/object.scm 2927 */
		       PROCEDURE_SET(glo__env_172_globalize_node, ((long) 2), BUNSPEC);
		       arg1920_1672 = pre_method_105_2469;
		    }
		  else
		    {	/* ./Llib/object.scm 2914 */
		       long obj_class_num_177_2474;
		       obj_class_num_177_2474 =
			  TYPE(obj_2468);
		       {	/* ./Llib/object.scm 2915 */
			  obj_t arg1176_2475;
			  arg1176_2475 =
			     PROCEDURE_REF(glo__env_172_globalize_node, ((long) 1));
			  {	/* ./Llib/object.scm 2738 */
			     long arg1177_2479;
			     {	/* ./Llib/object.scm 2738 */
				long arg1178_2480;
				arg1178_2480 =
				   OBJECT_TYPE;
				arg1177_2479 =
				   (obj_class_num_177_2474 - arg1178_2480);
			     }
			     arg1920_1672 =
				VECTOR_REF(arg1176_2475, arg1177_2479);
			  }
		       }
		    }
	       }
	    }
	    {	/* Globalize/node.scm 117 */
	       object_bglt object_2485;
	       object_2485 =
		  (object_bglt) (node_10);
	       {	/* ./Llib/object.scm 2695 */
		  long arg1179_2486;
		  {	/* ./Llib/object.scm 2695 */
		     long arg1180_2487;
		     long arg1181_2488;
		     arg1180_2487 =
			TYPE(object_2485);
		     arg1181_2488 =
			OBJECT_TYPE;
		     arg1179_2486 =
			(arg1180_2487 - arg1181_2488);
		  }
		  {	/* ./Llib/object.scm 2695 */
		     obj_t vector_2492;
		     vector_2492 = _classes__134___object;
		     arg1921_1673 =
			VECTOR_REF(vector_2492, arg1179_2486);
		  }
	       }
	    }
	    {	/* Globalize/node.scm 117 */
	       obj_t aux_3417;
	       method1912_1674 = arg1920_1672;
	       class1917_1675 = arg1921_1673;
	       {

		  if (
		     INTEGERP(method1912_1674))
		    {	/* Globalize/node.scm 117 */
		       switch (
			  (long) CINT(method1912_1674))
			 {
			 case ((long) 0):

			    {	/* Globalize/node.scm 117 */
			       atom_bglt aux_3420;
			       aux_3420 =
				  (atom_bglt) (node_10);
			       aux_3417 =
				  (obj_t) (aux_3420);
			    }
			    break;
			 case ((long) 1):

			    {	/* Globalize/node.scm 117 */
			       kwote_bglt aux_3423;
			       aux_3423 =
				  (kwote_bglt) (node_10);
			       aux_3417 =
				  (obj_t) (aux_3423);
			    }
			    break;
			 case ((long) 2):

			    {	/* Globalize/node.scm 135 */
			       var_bglt node_1685;
			       node_1685 =
				  (var_bglt) (node_10);
			       {	/* Globalize/node.scm 135 */
				  variable_bglt var_1687;
				  var_1687 =
				     (((var_bglt) CREF(node_1685))->variable);
				  {	/* Globalize/node.scm 135 */
				     obj_t alpha_1688;
				     alpha_1688 =
					(((variable_bglt) CREF(var_1687))->fast_alpha_7);
				     {	/* Globalize/node.scm 136 */

					{	/* Globalize/node.scm 138 */
					   bool_t test1924_1689;
					   test1924_1689 =
					      is_a__118___object(alpha_1688, local_ast_var);
					   if (test1924_1689)
					     {	/* Globalize/node.scm 138 */
						{	/* Globalize/node.scm 139 */
						   variable_bglt val1209_2498;
						   val1209_2498 =
						      (variable_bglt) (alpha_1688);
						   ((((var_bglt) CREF(node_1685))->variable) = ((variable_bglt) val1209_2498), BUNSPEC);
						}
						{	/* Globalize/node.scm 140 */
						   node_bglt aux_3433;
						   aux_3433 =
						      glo__115_globalize_node(
						      (node_bglt) (node_1685), integrator_11);
						   aux_3417 =
						      (obj_t) (aux_3433);
						}
					     }
					   else
					     {	/* Globalize/node.scm 141 */
						bool_t test1925_1690;
						test1925_1690 =
						   is_a__118___object(
						   (obj_t) (var_1687), global_ast_var);
						if (test1925_1690)
						  {	/* Globalize/node.scm 141 */
						     aux_3417 =
							(obj_t) (node_1685);
						  }
						else
						  {	/* Globalize/node.scm 141 */
						     if (
							celled__113_globalize_node(var_1687))
						       {	/* Globalize/node.scm 143 */
							  {	/* Globalize/node.scm 144 */
							     local_bglt obj_2500;
							     obj_t val1084_2501;
							     obj_2500 =
								(local_bglt) (var_1687);
							     val1084_2501 =
								CNST_TABLE_REF(((long) 0));
							     ((((local_bglt) CREF(obj_2500))->access) = ((obj_t) val1084_2501), BUNSPEC);
							  }
							  {	/* Globalize/node.scm 146 */
							     obj_t arg1927_1692;
							     type_bglt arg1928_1693;
							     {	/* Globalize/node.scm 146 */
								node_bglt obj_2502;
								obj_2502 =
								   (node_bglt) (node_1685);
								arg1927_1692 =
								   (((node_bglt) CREF(obj_2502))->loc);
							     }
							     {	/* Globalize/node.scm 147 */
								node_bglt obj_2503;
								obj_2503 =
								   (node_bglt) (node_1685);
								arg1928_1693 =
								   (((node_bglt) CREF(obj_2503))->type);
							     }
							     {	/* Globalize/node.scm 145 */
								box_ref_242_bglt res2109_2518;
								{	/* Globalize/node.scm 145 */
								   obj_t key_2507;
								   key_2507 =
								      BINT(((long) -1));
								   {	/* ./Ast/node.scm 1364 */
								      box_ref_242_bglt new1419_2509;
								      new1419_2509 =
									 ((box_ref_242_bglt) BREF(GC_MALLOC(sizeof(struct box_ref_242))));
								      {		/* ./Ast/node.scm 1364 */
									 long arg1842_2510;
									 arg1842_2510 =
									    class_num_218___object(box_ref_242_ast_node);
									 {	/* ./Ast/node.scm 1364 */
									    obj_t obj_2516;
									    obj_2516 =
									       (obj_t) (new1419_2509);
									    (((obj_t) CREF(obj_2516))->header = MAKE_HEADER(arg1842_2510, 0), BUNSPEC);
									 }
								      }
								      {		/* ./Ast/node.scm 1364 */
									 object_bglt aux_3455;
									 aux_3455 =
									    (object_bglt) (new1419_2509);
									 OBJECT_WIDENING_SET(aux_3455, BFALSE);
								      }
								      ((((box_ref_242_bglt) CREF(new1419_2509))->loc) = ((obj_t) arg1927_1692), BUNSPEC);
								      ((((box_ref_242_bglt) CREF(new1419_2509))->type) = ((type_bglt) arg1928_1693), BUNSPEC);
								      ((((box_ref_242_bglt) CREF(new1419_2509))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
								      ((((box_ref_242_bglt) CREF(new1419_2509))->key) = ((obj_t) key_2507), BUNSPEC);
								      ((((box_ref_242_bglt) CREF(new1419_2509))->var) = ((var_bglt) node_1685), BUNSPEC);
								      res2109_2518 = new1419_2509;
								   }
								}
								aux_3417 =
								   (obj_t) (res2109_2518);
							     }
							  }
						       }
						     else
						       {	/* Globalize/node.scm 143 */
							  aux_3417 =
							     (obj_t) (node_1685);
						       }
						  }
					     }
					}
				     }
				  }
			       }
			    }
			    break;
			 case ((long) 3):

			    {	/* Globalize/node.scm 156 */
			       closure_bglt node_1696;
			       node_1696 =
				  (closure_bglt) (node_10);
			       {	/* Globalize/node.scm 157 */
				  var_bglt arg1931_1699;
				  {	/* Globalize/node.scm 157 */
				     obj_t arg1932_1700;
				     obj_t arg1933_1701;
				     obj_t arg1934_1702;
				     arg1932_1700 =
					(((closure_bglt) CREF(node_1696))->loc);
				     arg1933_1701 = _procedure__226_type_cache;
				     arg1934_1702 =
					the_closure_238_globalize_free(
					(((closure_bglt) CREF(node_1696))->variable),
					(((closure_bglt) CREF(node_1696))->loc));
				     {	/* Globalize/node.scm 157 */
					var_bglt res2110_2532;
					{	/* Globalize/node.scm 157 */
					   type_bglt type_2523;
					   variable_bglt variable_2524;
					   type_2523 =
					      (type_bglt) (arg1933_1701);
					   variable_2524 =
					      (variable_bglt) (arg1934_1702);
					   {	/* ./Ast/node.scm 1244 */
					      var_bglt new1210_2525;
					      new1210_2525 =
						 ((var_bglt) BREF(GC_MALLOC(sizeof(struct var))));
					      {		/* ./Ast/node.scm 1244 */
						 long arg1879_2526;
						 arg1879_2526 =
						    class_num_218___object(var_ast_node);
						 {	/* ./Ast/node.scm 1244 */
						    obj_t obj_2530;
						    obj_2530 =
						       (obj_t) (new1210_2525);
						    (((obj_t) CREF(obj_2530))->header = MAKE_HEADER(arg1879_2526, 0), BUNSPEC);
						 }
					      }
					      {		/* ./Ast/node.scm 1244 */
						 object_bglt aux_3476;
						 aux_3476 =
						    (object_bglt) (new1210_2525);
						 OBJECT_WIDENING_SET(aux_3476, BFALSE);
					      }
					      ((((var_bglt) CREF(new1210_2525))->loc) = ((obj_t) arg1932_1700), BUNSPEC);
					      ((((var_bglt) CREF(new1210_2525))->type) = ((type_bglt) type_2523), BUNSPEC);
					      ((((var_bglt) CREF(new1210_2525))->variable) = ((variable_bglt) variable_2524), BUNSPEC);
					      res2110_2532 = new1210_2525;
					   }
					}
					arg1931_1699 = res2110_2532;
				     }
				  }
				  {	/* Globalize/node.scm 157 */
				     node_bglt aux_3482;
				     aux_3482 =
					glo__115_globalize_node(
					(node_bglt) (arg1931_1699), integrator_11);
				     aux_3417 =
					(obj_t) (aux_3482);
				  }
			       }
			    }
			    break;
			 case ((long) 4):

			    {	/* Globalize/node.scm 167 */
			       sequence_bglt node_1705;
			       node_1705 =
				  (sequence_bglt) (node_10);
			       glo___241_globalize_node(
				  (((sequence_bglt) CREF(node_1705))->nodes), integrator_11);
			       aux_3417 =
				  (obj_t) (node_1705);
			    }
			    break;
			 case ((long) 5):

			    {	/* Globalize/node.scm 175 */
			       app_bglt node_1709;
			       node_1709 =
				  (app_bglt) (node_10);
			       {	/* Globalize/node.scm 176 */
				  variable_bglt fun_1712;
				  {	/* Globalize/node.scm 176 */
				     var_bglt arg1976_1759;
				     arg1976_1759 =
					(((app_bglt) CREF(node_1709))->fun);
				     fun_1712 =
					(((var_bglt) CREF(arg1976_1759))->variable);
				  }
				  {	/* Globalize/node.scm 176 */
				     value_bglt info_1713;
				     info_1713 =
					(((variable_bglt) CREF(fun_1712))->value);
				     {	/* Globalize/node.scm 177 */

					{	/* Globalize/node.scm 186 */
					   bool_t test1938_1714;
					   {	/* Globalize/node.scm 186 */
					      bool_t test1943_1719;
					      test1943_1719 =
						 is_a__118___object(
						 (obj_t) (fun_1712), local_ast_var);
					      if (test1943_1719)
						{	/* Globalize/node.scm 187 */
						   bool_t test_3497;
						   {	/* Globalize/node.scm 187 */
						      bool_t test_3498;
						      {		/* ./Ieee/equiv.scm 5508 */
							 obj_t aux_3501;
							 obj_t aux_3499;
							 aux_3501 =
							    (obj_t) (integrator_11);
							 aux_3499 =
							    (obj_t) (fun_1712);
							 test_3498 =
							    (aux_3499 == aux_3501);
						      }
						      if (test_3498)
							{	/* Globalize/node.scm 188 */
							   bool_t test_3504;
							   {	/* Globalize/node.scm 188 */
							      local_ginfo_108_bglt obj_2540;
							      obj_2540 =
								 (local_ginfo_108_bglt) (fun_1712);
							      {
								 obj_t aux_3506;
								 {	/* ./Globalize/ginfo.scm 1452 */
								    object_bglt aux_3507;
								    aux_3507 =
								       (object_bglt) (obj_2540);
								    aux_3506 =
								       OBJECT_WIDENING(aux_3507);
								 }
								 test_3504 =
								    (((local_ginfo_108_bglt) CREF(aux_3506))->escape__117);
							      }
							   }
							   if (test_3504)
							     {	/* Globalize/node.scm 188 */
								test_3497 = ((bool_t) 0)
								   ;
							     }
							   else
							     {	/* Globalize/node.scm 188 */
								test_3497 = ((bool_t) 1)
								   ;
							     }
							}
						      else
							{	/* Globalize/node.scm 187 */
							   test_3497 = ((bool_t) 1)
							      ;
							}
						   }
						   if (test_3497)
						     {	/* Globalize/node.scm 189 */
							sfun_ginfo_98_bglt obj_2541;
							obj_2541 =
							   (sfun_ginfo_98_bglt) (info_1713);
							{
							   obj_t aux_3512;
							   {	/* ./Globalize/ginfo.scm 1394 */
							      object_bglt aux_3513;
							      aux_3513 =
								 (object_bglt) (obj_2541);
							      aux_3512 =
								 OBJECT_WIDENING(aux_3513);
							   }
							   test1938_1714 =
							      (((sfun_ginfo_98_bglt) CREF(aux_3512))->g__219);
							}
						     }
						   else
						     {	/* Globalize/node.scm 187 */
							test1938_1714 = ((bool_t) 0);
						     }
						}
					      else
						{	/* Globalize/node.scm 186 */
						   test1938_1714 = ((bool_t) 0);
						}
					   }
					   if (test1938_1714)
					     {	/* Globalize/node.scm 191 */
						var_bglt arg1939_1715;
						{	/* Globalize/node.scm 191 */
						   obj_t arg1940_1716;
						   type_bglt arg1941_1717;
						   global_bglt arg1942_1718;
						   arg1940_1716 =
						      (((app_bglt) CREF(node_1709))->loc);
						   arg1941_1717 =
						      (((app_bglt) CREF(node_1709))->type);
						   arg1942_1718 =
						      the_global_201_globalize_local__global_194(
						      (local_bglt) (fun_1712));
						   {	/* Globalize/node.scm 191 */
						      var_bglt res2111_2554;
						      {		/* Globalize/node.scm 191 */
							 variable_bglt variable_2546;
							 variable_2546 =
							    (variable_bglt) (arg1942_1718);
							 {	/* ./Ast/node.scm 1244 */
							    var_bglt new1210_2547;
							    new1210_2547 =
							       ((var_bglt) BREF(GC_MALLOC(sizeof(struct var))));
							    {	/* ./Ast/node.scm 1244 */
							       long arg1879_2548;
							       arg1879_2548 =
								  class_num_218___object(var_ast_node);
							       {	/* ./Ast/node.scm 1244 */
								  obj_t obj_2552;
								  obj_2552 =
								     (obj_t) (new1210_2547);
								  (((obj_t) CREF(obj_2552))->header = MAKE_HEADER(arg1879_2548, 0), BUNSPEC);
							       }
							    }
							    {	/* ./Ast/node.scm 1244 */
							       object_bglt aux_3527;
							       aux_3527 =
								  (object_bglt) (new1210_2547);
							       OBJECT_WIDENING_SET(aux_3527, BFALSE);
							    }
							    ((((var_bglt) CREF(new1210_2547))->loc) = ((obj_t) arg1940_1716), BUNSPEC);
							    ((((var_bglt) CREF(new1210_2547))->type) = ((type_bglt) arg1941_1717), BUNSPEC);
							    ((((var_bglt) CREF(new1210_2547))->variable) = ((variable_bglt) variable_2546), BUNSPEC);
							    res2111_2554 = new1210_2547;
							 }
						      }
						      arg1939_1715 = res2111_2554;
						   }
						}
						((((app_bglt) CREF(node_1709))->fun) = ((var_bglt) arg1939_1715), BUNSPEC);
					     }
					   else
					     {	/* Globalize/node.scm 186 */
						BUNSPEC;
					     }
					}
					{
					   obj_t nodes_1723;
					   nodes_1723 =
					      (((app_bglt) CREF(node_1709))->args);
					 liip_1724:
					   if (
					      NULLP(nodes_1723))
					     {	/* Globalize/node.scm 198 */
						CNST_TABLE_REF(((long) 2));
					     }
					   else
					     {	/* Globalize/node.scm 198 */
						{	/* Globalize/node.scm 201 */
						   node_bglt arg1950_1727;
						   {	/* Globalize/node.scm 201 */
						      node_bglt aux_3537;
						      {		/* Globalize/node.scm 201 */
							 obj_t aux_3538;
							 aux_3538 =
							    CAR(nodes_1723);
							 aux_3537 =
							    (node_bglt) (aux_3538);
						      }
						      arg1950_1727 =
							 glo__115_globalize_node(aux_3537, integrator_11);
						   }
						   {	/* ./Ieee/pair-list.scm 5890 */
						      obj_t aux_3542;
						      aux_3542 =
							 (obj_t) (arg1950_1727);
						      SET_CAR(nodes_1723, aux_3542);
						   }
						}
						{
						   obj_t nodes_3545;
						   nodes_3545 =
						      CDR(nodes_1723);
						   nodes_1723 = nodes_3545;
						   goto liip_1724;
						}
					     }
					}
					{	/* Globalize/node.scm 204 */
					   bool_t test1953_1730;
					   {	/* Globalize/node.scm 204 */
					      bool_t test1973_1756;
					      test1973_1756 =
						 is_a__118___object(
						 (obj_t) (fun_1712), global_ast_var);
					      if (test1973_1756)
						{	/* Globalize/node.scm 204 */
						   test1953_1730 = ((bool_t) 1);
						}
					      else
						{	/* Globalize/node.scm 205 */
						   bool_t test_3551;
						   {	/* Globalize/node.scm 205 */
						      sfun_ginfo_98_bglt obj_2564;
						      obj_2564 =
							 (sfun_ginfo_98_bglt) (info_1713);
						      {
							 obj_t aux_3553;
							 {	/* ./Globalize/ginfo.scm 1394 */
							    object_bglt aux_3554;
							    aux_3554 =
							       (object_bglt) (obj_2564);
							    aux_3553 =
							       OBJECT_WIDENING(aux_3554);
							 }
							 test_3551 =
							    (((sfun_ginfo_98_bglt) CREF(aux_3553))->g__219);
						      }
						   }
						   if (test_3551)
						     {	/* Globalize/node.scm 206 */
							bool_t test_3558;
							{	/* ./Ieee/equiv.scm 5508 */
							   obj_t aux_3561;
							   obj_t aux_3559;
							   aux_3561 =
							      (obj_t) (integrator_11);
							   aux_3559 =
							      (obj_t) (fun_1712);
							   test_3558 =
							      (aux_3559 == aux_3561);
							}
							if (test_3558)
							  {	/* Globalize/node.scm 207 */
							     local_ginfo_108_bglt obj_2567;
							     obj_2567 =
								(local_ginfo_108_bglt) (fun_1712);
							     {
								obj_t aux_3565;
								{	/* ./Globalize/ginfo.scm 1452 */
								   object_bglt aux_3566;
								   aux_3566 =
								      (object_bglt) (obj_2567);
								   aux_3565 =
								      OBJECT_WIDENING(aux_3566);
								}
								test1953_1730 =
								   (((local_ginfo_108_bglt) CREF(aux_3565))->escape__117);
							     }
							  }
							else
							  {	/* Globalize/node.scm 206 */
							     test1953_1730 = ((bool_t) 0);
							  }
						     }
						   else
						     {	/* Globalize/node.scm 205 */
							test1953_1730 = ((bool_t) 1);
						     }
						}
					   }
					   if (test1953_1730)
					     {	/* Globalize/node.scm 204 */
						CNST_TABLE_REF(((long) 2));
					     }
					   else
					     {	/* Globalize/node.scm 209 */
						bool_t test_3572;
						{	/* Globalize/node.scm 209 */
						   local_ginfo_108_bglt obj_2568;
						   obj_2568 =
						      (local_ginfo_108_bglt) (fun_1712);
						   {
						      obj_t aux_3574;
						      {		/* ./Globalize/ginfo.scm 1452 */
							 object_bglt aux_3575;
							 aux_3575 =
							    (object_bglt) (obj_2568);
							 aux_3574 =
							    OBJECT_WIDENING(aux_3575);
						      }
						      test_3572 =
							 (((local_ginfo_108_bglt) CREF(aux_3574))->escape__117);
						   }
						}
						if (test_3572)
						  {	/* Globalize/node.scm 209 */
						     {	/* Globalize/node.scm 212 */
							obj_t arg1955_1732;
							{	/* Globalize/node.scm 212 */
							   node_bglt arg1956_1733;
							   obj_t arg1957_1734;
							   {	/* Globalize/node.scm 212 */
							      var_bglt arg1958_1735;
							      {		/* Globalize/node.scm 212 */
								 obj_t arg1959_1736;
								 obj_t arg1960_1737;
								 obj_t arg1961_1738;
								 arg1959_1736 =
								    (((app_bglt) CREF(node_1709))->loc);
								 arg1960_1737 = ____74_type_cache;
								 arg1961_1738 =
								    the_closure_238_globalize_free(fun_1712,
								    (((app_bglt) CREF(node_1709))->loc));
								 {	/* Globalize/node.scm 212 */
								    var_bglt res2112_2581;
								    {	/* Globalize/node.scm 212 */
								       type_bglt type_2572;
								       variable_bglt variable_2573;
								       type_2572 =
									  (type_bglt) (arg1960_1737);
								       variable_2573 =
									  (variable_bglt) (arg1961_1738);
								       {	/* ./Ast/node.scm 1244 */
									  var_bglt new1210_2574;
									  new1210_2574 =
									     ((var_bglt) BREF(GC_MALLOC(sizeof(struct var))));
									  {	/* ./Ast/node.scm 1244 */
									     long arg1879_2575;
									     arg1879_2575 =
										class_num_218___object(var_ast_node);
									     {	/* ./Ast/node.scm 1244 */
										obj_t obj_2579;
										obj_2579 =
										   (obj_t) (new1210_2574);
										(((obj_t) CREF(obj_2579))->header = MAKE_HEADER(arg1879_2575, 0), BUNSPEC);
									     }
									  }
									  {	/* ./Ast/node.scm 1244 */
									     object_bglt aux_3588;
									     aux_3588 =
										(object_bglt) (new1210_2574);
									     OBJECT_WIDENING_SET(aux_3588, BFALSE);
									  }
									  ((((var_bglt) CREF(new1210_2574))->loc) = ((obj_t) arg1959_1736), BUNSPEC);
									  ((((var_bglt) CREF(new1210_2574))->type) = ((type_bglt) type_2572), BUNSPEC);
									  ((((var_bglt) CREF(new1210_2574))->variable) = ((variable_bglt) variable_2573), BUNSPEC);
									  res2112_2581 = new1210_2574;
								       }
								    }
								    arg1958_1735 = res2112_2581;
								 }
							      }
							      arg1956_1733 =
								 glo__115_globalize_node(
								 (node_bglt) (arg1958_1735), integrator_11);
							   }
							   arg1957_1734 =
							      (((app_bglt) CREF(node_1709))->args);
							   {	/* ./Ieee/pair-list.scm 5689 */
							      obj_t aux_3597;
							      aux_3597 =
								 (obj_t) (arg1956_1733);
							      arg1955_1732 =
								 MAKE_PAIR(aux_3597, arg1957_1734);
							   }
							}
							((((app_bglt) CREF(node_1709))->args) = ((obj_t) arg1955_1732), BUNSPEC);
						     }
						  }
						else
						  {	/* Globalize/node.scm 209 */
						     {
							obj_t new_actuals_73_1740;
							obj_t kaptured_1741;
							new_actuals_73_1740 =
							   (((app_bglt) CREF(node_1709))->args);
							{	/* Globalize/node.scm 222 */
							   sfun_ginfo_98_bglt obj_2588;
							   obj_2588 =
							      (sfun_ginfo_98_bglt) (info_1713);
							   {
							      obj_t aux_3630;
							      {		/* ./Globalize/ginfo.scm 1418 */
								 object_bglt aux_3631;
								 aux_3631 =
								    (object_bglt) (obj_2588);
								 aux_3630 =
								    OBJECT_WIDENING(aux_3631);
							      }
							      kaptured_1741 =
								 (((sfun_ginfo_98_bglt) CREF(aux_3630))->kaptured);
							   }
							}
						      loop_1742:
							if (
							   NULLP(kaptured_1741))
							  {	/* Globalize/node.scm 223 */
							     ((((app_bglt) CREF(node_1709))->args) = ((obj_t) new_actuals_73_1740), BUNSPEC);
							  }
							else
							  {	/* Globalize/node.scm 225 */
							     obj_t kap_1746;
							     kap_1746 =
								CAR(kaptured_1741);
							     {	/* Globalize/node.scm 225 */
								obj_t alpha_1747;
								{	/* Globalize/node.scm 226 */
								   local_bglt obj_2593;
								   obj_2593 =
								      (local_bglt) (kap_1746);
								   alpha_1747 =
								      (((local_bglt) CREF(obj_2593))->fast_alpha_7);
								}
								{	/* Globalize/node.scm 226 */
								   obj_t var_1748;
								   {	/* Globalize/node.scm 227 */
								      bool_t test1972_1755;
								      test1972_1755 =
									 is_a__118___object(alpha_1747, local_ast_var);
								      if (test1972_1755)
									{	/* Globalize/node.scm 227 */
									   var_1748 = alpha_1747;
									}
								      else
									{	/* Globalize/node.scm 227 */
									   var_1748 = kap_1746;
									}
								   }
								   {	/* Globalize/node.scm 227 */

								      {		/* Globalize/node.scm 228 */
									 obj_t arg1966_1749;
									 obj_t arg1967_1750;
									 {	/* Globalize/node.scm 228 */
									    var_bglt arg1968_1751;
									    {	/* Globalize/node.scm 228 */
									       obj_t arg1969_1752;
									       obj_t arg1970_1753;
									       arg1969_1752 =
										  (((app_bglt) CREF(node_1709))->loc);
									       arg1970_1753 = ____74_type_cache;
									       {	/* Globalize/node.scm 228 */
										  var_bglt res2113_2606;
										  {	/* Globalize/node.scm 228 */
										     type_bglt type_2597;
										     variable_bglt variable_2598;
										     type_2597 =
											(type_bglt) (arg1970_1753);
										     variable_2598 =
											(variable_bglt) (var_1748);
										     {	/* ./Ast/node.scm 1244 */
											var_bglt new1210_2599;
											new1210_2599 =
											   ((var_bglt) BREF(GC_MALLOC(sizeof(struct var))));
											{	/* ./Ast/node.scm 1244 */
											   long arg1879_2600;
											   arg1879_2600 =
											      class_num_218___object(var_ast_node);
											   {	/* ./Ast/node.scm 1244 */
											      obj_t obj_2604;
											      obj_2604 =
												 (obj_t) (new1210_2599);
											      (((obj_t) CREF(obj_2604))->header = MAKE_HEADER(arg1879_2600, 0), BUNSPEC);
											   }
											}
											{	/* ./Ast/node.scm 1244 */
											   object_bglt aux_3616;
											   aux_3616 =
											      (object_bglt) (new1210_2599);
											   OBJECT_WIDENING_SET(aux_3616, BFALSE);
											}
											((((var_bglt) CREF(new1210_2599))->loc) = ((obj_t) arg1969_1752), BUNSPEC);
											((((var_bglt) CREF(new1210_2599))->type) = ((type_bglt) type_2597), BUNSPEC);
											((((var_bglt) CREF(new1210_2599))->variable) = ((variable_bglt) variable_2598), BUNSPEC);
											res2113_2606 = new1210_2599;
										     }
										  }
										  arg1968_1751 = res2113_2606;
									       }
									    }
									    {	/* ./Ieee/pair-list.scm 5689 */
									       obj_t aux_3622;
									       aux_3622 =
										  (obj_t) (arg1968_1751);
									       arg1966_1749 =
										  MAKE_PAIR(aux_3622, new_actuals_73_1740);
									    }
									 }
									 arg1967_1750 =
									    CDR(kaptured_1741);
									 {
									    obj_t kaptured_3627;
									    obj_t new_actuals_73_3626;
									    new_actuals_73_3626 = arg1966_1749;
									    kaptured_3627 = arg1967_1750;
									    kaptured_1741 = kaptured_3627;
									    new_actuals_73_1740 = new_actuals_73_3626;
									    goto loop_1742;
									 }
								      }
								   }
								}
							     }
							  }
						     }
						  }
					     }
					}
					aux_3417 =
					   (obj_t) (node_1709);
				     }
				  }
			       }
			    }
			    break;
			 case ((long) 6):

			    {	/* Globalize/node.scm 240 */
			       app_ly_162_bglt node_1760;
			       node_1760 =
				  (app_ly_162_bglt) (node_10);
			       {	/* Globalize/node.scm 241 */
				  node_bglt arg1977_1763;
				  arg1977_1763 =
				     glo__115_globalize_node(
				     (((app_ly_162_bglt) CREF(node_1760))->fun), integrator_11);
				  ((((app_ly_162_bglt) CREF(node_1760))->fun) = ((node_bglt) arg1977_1763), BUNSPEC);
			       }
			       {	/* Globalize/node.scm 242 */
				  node_bglt arg1980_1765;
				  arg1980_1765 =
				     glo__115_globalize_node(
				     (((app_ly_162_bglt) CREF(node_1760))->arg), integrator_11);
				  ((((app_ly_162_bglt) CREF(node_1760))->arg) = ((node_bglt) arg1980_1765), BUNSPEC);
			       }
			       aux_3417 =
				  (obj_t) (node_1760);
			    }
			    break;
			 case ((long) 7):

			    {	/* Globalize/node.scm 249 */
			       funcall_bglt node_1767;
			       node_1767 =
				  (funcall_bglt) (node_10);
			       {	/* Globalize/node.scm 250 */
				  node_bglt arg1982_1770;
				  arg1982_1770 =
				     glo__115_globalize_node(
				     (((funcall_bglt) CREF(node_1767))->fun), integrator_11);
				  ((((funcall_bglt) CREF(node_1767))->fun) = ((node_bglt) arg1982_1770), BUNSPEC);
			       }
			       glo___241_globalize_node(
				  (((funcall_bglt) CREF(node_1767))->args), integrator_11);
			       aux_3417 =
				  (obj_t) (node_1767);
			    }
			    break;
			 case ((long) 8):

			    {	/* Globalize/node.scm 258 */
			       pragma_bglt node_1773;
			       node_1773 =
				  (pragma_bglt) (node_10);
			       glo___241_globalize_node(
				  (((pragma_bglt) CREF(node_1773))->args), integrator_11);
			       aux_3417 =
				  (obj_t) (node_1773);
			    }
			    break;
			 case ((long) 9):

			    {	/* Globalize/node.scm 266 */
			       cast_bglt node_1777;
			       node_1777 =
				  (cast_bglt) (node_10);
			       glo__115_globalize_node(
				  (((cast_bglt) CREF(node_1777))->arg), integrator_11);
			       aux_3417 =
				  (obj_t) (node_1777);
			    }
			    break;
			 case ((long) 10):

			    {	/* Globalize/node.scm 274 */
			       setq_bglt node_1781;
			       node_1781 =
				  (setq_bglt) (node_10);
			       {	/* Globalize/node.scm 275 */
				  node_bglt arg1987_1784;
				  arg1987_1784 =
				     glo__115_globalize_node(
				     (((setq_bglt) CREF(node_1781))->value), integrator_11);
				  ((((setq_bglt) CREF(node_1781))->value) = ((node_bglt) arg1987_1784), BUNSPEC);
			       }
			       {	/* Globalize/node.scm 276 */
				  variable_bglt var_1786;
				  {	/* Globalize/node.scm 276 */
				     var_bglt arg2017_1822;
				     arg2017_1822 =
					(((setq_bglt) CREF(node_1781))->var);
				     var_1786 =
					(((var_bglt) CREF(arg2017_1822))->variable);
				  }
				  {
				     obj_t var_1787;
				     obj_t alpha_1788;
				     var_1787 =
					(obj_t) (var_1786);
				     alpha_1788 =
					(((variable_bglt) CREF(var_1786))->fast_alpha_7);
				   loop_1789:
				     {	/* Globalize/node.scm 279 */
					bool_t test1990_1791;
					test1990_1791 =
					   is_a__118___object(alpha_1788, local_ast_var);
					if (test1990_1791)
					  {	/* Globalize/node.scm 279 */
					     {	/* Globalize/node.scm 281 */
						var_bglt arg1991_1792;
						arg1991_1792 =
						   (((setq_bglt) CREF(node_1781))->var);
						{	/* Globalize/node.scm 281 */
						   variable_bglt val1209_2631;
						   val1209_2631 =
						      (variable_bglt) (alpha_1788);
						   ((((var_bglt) CREF(arg1991_1792))->variable) = ((variable_bglt) val1209_2631), BUNSPEC);
						}
					     }
					     {
						obj_t alpha_3671;
						obj_t var_3670;
						var_3670 = alpha_1788;
						{	/* Globalize/node.scm 282 */
						   variable_bglt obj_2632;
						   obj_2632 =
						      (variable_bglt) (alpha_1788);
						   alpha_3671 =
						      (((variable_bglt) CREF(obj_2632))->fast_alpha_7);
						}
						alpha_1788 = alpha_3671;
						var_1787 = var_3670;
						goto loop_1789;
					     }
					  }
					else
					  {	/* Globalize/node.scm 283 */
					     variable_bglt var_1794;
					     {	/* Globalize/node.scm 283 */
						var_bglt arg2016_1821;
						arg2016_1821 =
						   (((setq_bglt) CREF(node_1781))->var);
						var_1794 =
						   (((var_bglt) CREF(arg2016_1821))->variable);
					     }
					     {	/* Globalize/node.scm 284 */
						bool_t test1993_1795;
						{	/* Globalize/node.scm 284 */
						   bool_t test2015_1820;
						   test2015_1820 =
						      is_a__118___object(
						      (obj_t) (var_1794), local_ast_var);
						   if (test2015_1820)
						     {	/* Globalize/node.scm 284 */
							test1993_1795 =
							   celled__113_globalize_node(var_1794);
						     }
						   else
						     {	/* Globalize/node.scm 284 */
							test1993_1795 = ((bool_t) 0);
						     }
						}
						if (test1993_1795)
						  {	/* Globalize/node.scm 285 */
						     local_bglt a_var_30_1796;
						     obj_t loc_1797;
						     a_var_30_1796 =
							make_local_svar_140_ast_local(
							CNST_TABLE_REF(((long) 7)),
							(type_bglt) (_obj__252_type_cache));
						     {	/* Globalize/node.scm 286 */
							node_bglt obj_2636;
							obj_2636 =
							   (node_bglt) (node_1781);
							loc_1797 =
							   (((node_bglt) CREF(obj_2636))->loc);
						     }
						     {	/* Globalize/node.scm 287 */
							local_bglt obj_2637;
							obj_t val1084_2638;
							obj_2637 =
							   (local_bglt) (var_1794);
							val1084_2638 =
							   CNST_TABLE_REF(((long) 0));
							((((local_bglt) CREF(obj_2637))->access) = ((obj_t) val1084_2638), BUNSPEC);
						     }
						     {	/* Globalize/node.scm 288 */
							bool_t arg1994_1798;
							{	/* Globalize/node.scm 288 */
							   local_bglt obj_2639;
							   obj_2639 =
							      (local_bglt) (var_1794);
							   arg1994_1798 =
							      (((local_bglt) CREF(obj_2639))->user__32);
							}
							((((local_bglt) CREF(a_var_30_1796))->user__32) = ((bool_t) arg1994_1798), BUNSPEC);
						     }
						     {	/* Globalize/node.scm 289 */
							svar_ginfo_131_bglt obj1586_1799;
							obj1586_1799 =
							   ((svar_ginfo_131_bglt) (
							      (((local_bglt) CREF(a_var_30_1796))->value)));
							{	/* Globalize/node.scm 289 */
							   svar_ginfo_131_bglt arg1995_1800;
							   {	/* Globalize/node.scm 289 */
							      svar_ginfo_131_bglt res2114_2652;
							      {		/* ./Globalize/ginfo.scm 1430 */
								 svar_ginfo_131_bglt new1494_2647;
								 new1494_2647 =
								    ((svar_ginfo_131_bglt) BREF(GC_MALLOC(sizeof(struct svar_ginfo_131))));
								 ((((svar_ginfo_131_bglt) CREF(new1494_2647))->kaptured__204) = ((bool_t) ((bool_t) 0)), BUNSPEC);
								 ((((svar_ginfo_131_bglt) CREF(new1494_2647))->free_mark_81) = ((long) ((long) -10)), BUNSPEC);
								 ((((svar_ginfo_131_bglt) CREF(new1494_2647))->mark) = ((long) ((long) -10)), BUNSPEC);
								 ((((svar_ginfo_131_bglt) CREF(new1494_2647))->celled__113) = ((bool_t) ((bool_t) 0)), BUNSPEC);
								 res2114_2652 = new1494_2647;
							      }
							      arg1995_1800 = res2114_2652;
							   }
							   {	/* Globalize/node.scm 289 */
							      obj_t aux_3701;
							      object_bglt aux_3699;
							      aux_3701 =
								 (obj_t) (arg1995_1800);
							      aux_3699 =
								 (object_bglt) (obj1586_1799);
							      OBJECT_WIDENING_SET(aux_3699, aux_3701);
							   }
							}
							{	/* Globalize/node.scm 289 */
							   long arg1999_1804;
							   arg1999_1804 =
							      class_num_218___object(svar_ginfo_131_globalize_ginfo);
							   {	/* Globalize/node.scm 289 */
							      obj_t obj_2653;
							      obj_2653 =
								 (obj_t) (obj1586_1799);
							      (((obj_t) CREF(obj_2653))->header = MAKE_HEADER(arg1999_1804, 0), BUNSPEC);
							   }
							}
							obj1586_1799;
						     }
						     {	/* Globalize/node.scm 291 */
							obj_t arg2001_1806;
							obj_t arg2003_1808;
							box_set__221_bglt arg2004_1809;
							arg2001_1806 = ____74_type_cache;
							{	/* Globalize/node.scm 294 */
							   obj_t arg2005_1810;
							   {	/* ./Ieee/pair-list.scm 5689 */
							      obj_t aux_3709;
							      obj_t aux_3707;
							      {		/* Globalize/node.scm 294 */
								 node_bglt aux_3710;
								 aux_3710 =
								    (((setq_bglt) CREF(node_1781))->value);
								 aux_3709 =
								    (obj_t) (aux_3710);
							      }
							      aux_3707 =
								 (obj_t) (a_var_30_1796);
							      arg2005_1810 =
								 MAKE_PAIR(aux_3707, aux_3709);
							   }
							   {	/* Globalize/node.scm 294 */
							      obj_t list2006_1811;
							      list2006_1811 =
								 MAKE_PAIR(arg2005_1810, BNIL);
							      arg2003_1808 = list2006_1811;
							   }
							}
							{	/* Globalize/node.scm 295 */
							   obj_t arg2009_1814;
							   var_bglt arg2010_1815;
							   var_bglt arg2011_1816;
							   arg2009_1814 = ____74_type_cache;
							   arg2010_1815 =
							      (((setq_bglt) CREF(node_1781))->var);
							   {	/* Globalize/node.scm 299 */
							      obj_t arg2013_1818;
							      arg2013_1818 = ____74_type_cache;
							      {		/* Globalize/node.scm 299 */
								 var_bglt res2115_2670;
								 {	/* Globalize/node.scm 299 */
								    type_bglt type_2661;
								    variable_bglt variable_2662;
								    type_2661 =
								       (type_bglt) (arg2013_1818);
								    variable_2662 =
								       (variable_bglt) (a_var_30_1796);
								    {	/* ./Ast/node.scm 1244 */
								       var_bglt new1210_2663;
								       new1210_2663 =
									  ((var_bglt) BREF(GC_MALLOC(sizeof(struct var))));
								       {	/* ./Ast/node.scm 1244 */
									  long arg1879_2664;
									  arg1879_2664 =
									     class_num_218___object(var_ast_node);
									  {	/* ./Ast/node.scm 1244 */
									     obj_t obj_2668;
									     obj_2668 =
										(obj_t) (new1210_2663);
									     (((obj_t) CREF(obj_2668))->header = MAKE_HEADER(arg1879_2664, 0), BUNSPEC);
									  }
								       }
								       {	/* ./Ast/node.scm 1244 */
									  object_bglt aux_3722;
									  aux_3722 =
									     (object_bglt) (new1210_2663);
									  OBJECT_WIDENING_SET(aux_3722, BFALSE);
								       }
								       ((((var_bglt) CREF(new1210_2663))->loc) = ((obj_t) loc_1797), BUNSPEC);
								       ((((var_bglt) CREF(new1210_2663))->type) = ((type_bglt) type_2661), BUNSPEC);
								       ((((var_bglt) CREF(new1210_2663))->variable) = ((variable_bglt) variable_2662), BUNSPEC);
								       res2115_2670 = new1210_2663;
								    }
								 }
								 arg2011_1816 = res2115_2670;
							      }
							   }
							   {	/* Globalize/node.scm 295 */
							      box_set__221_bglt res2116_2683;
							      {		/* Globalize/node.scm 295 */
								 type_bglt type_2672;
								 node_bglt value_2674;
								 type_2672 =
								    (type_bglt) (arg2009_1814);
								 value_2674 =
								    (node_bglt) (arg2011_1816);
								 {	/* ./Ast/node.scm 1368 */
								    box_set__221_bglt new1430_2675;
								    new1430_2675 =
								       ((box_set__221_bglt) BREF(GC_MALLOC(sizeof(struct box_set__221))));
								    {	/* ./Ast/node.scm 1368 */
								       long arg1839_2676;
								       arg1839_2676 =
									  class_num_218___object(box_set__221_ast_node);
								       {	/* ./Ast/node.scm 1368 */
									  obj_t obj_2681;
									  obj_2681 =
									     (obj_t) (new1430_2675);
									  (((obj_t) CREF(obj_2681))->header = MAKE_HEADER(arg1839_2676, 0), BUNSPEC);
								       }
								    }
								    {	/* ./Ast/node.scm 1368 */
								       object_bglt aux_3734;
								       aux_3734 =
									  (object_bglt) (new1430_2675);
								       OBJECT_WIDENING_SET(aux_3734, BFALSE);
								    }
								    ((((box_set__221_bglt) CREF(new1430_2675))->loc) = ((obj_t) loc_1797), BUNSPEC);
								    ((((box_set__221_bglt) CREF(new1430_2675))->type) = ((type_bglt) type_2672), BUNSPEC);
								    ((((box_set__221_bglt) CREF(new1430_2675))->var) = ((var_bglt) arg2010_1815), BUNSPEC);
								    ((((box_set__221_bglt) CREF(new1430_2675))->value) = ((node_bglt) value_2674), BUNSPEC);
								    res2116_2683 = new1430_2675;
								 }
							      }
							      arg2004_1809 = res2116_2683;
							   }
							}
							{	/* Globalize/node.scm 291 */
							   let_var_6_bglt res2117_2702;
							   {	/* Globalize/node.scm 291 */
							      type_bglt type_2685;
							      obj_t key_2687;
							      node_bglt body_2689;
							      type_2685 =
								 (type_bglt) (arg2001_1806);
							      key_2687 =
								 BINT(((long) -1));
							      body_2689 =
								 (node_bglt) (arg2004_1809);
							      {		/* ./Ast/node.scm 1337 */
								 let_var_6_bglt new1373_2691;
								 new1373_2691 =
								    ((let_var_6_bglt) BREF(GC_MALLOC(sizeof(struct let_var_6))));
								 {	/* ./Ast/node.scm 1337 */
								    long arg1850_2692;
								    arg1850_2692 =
								       class_num_218___object(let_var_6_ast_node);
								    {	/* ./Ast/node.scm 1337 */
								       obj_t obj_2700;
								       obj_2700 =
									  (obj_t) (new1373_2691);
								       (((obj_t) CREF(obj_2700))->header = MAKE_HEADER(arg1850_2692, 0), BUNSPEC);
								    }
								 }
								 {	/* ./Ast/node.scm 1337 */
								    object_bglt aux_3748;
								    aux_3748 =
								       (object_bglt) (new1373_2691);
								    OBJECT_WIDENING_SET(aux_3748, BFALSE);
								 }
								 ((((let_var_6_bglt) CREF(new1373_2691))->loc) = ((obj_t) loc_1797), BUNSPEC);
								 ((((let_var_6_bglt) CREF(new1373_2691))->type) = ((type_bglt) type_2685), BUNSPEC);
								 ((((let_var_6_bglt) CREF(new1373_2691))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
								 ((((let_var_6_bglt) CREF(new1373_2691))->key) = ((obj_t) key_2687), BUNSPEC);
								 ((((let_var_6_bglt) CREF(new1373_2691))->bindings) = ((obj_t) arg2003_1808), BUNSPEC);
								 ((((let_var_6_bglt) CREF(new1373_2691))->body) = ((node_bglt) body_2689), BUNSPEC);
								 ((((let_var_6_bglt) CREF(new1373_2691))->removable__42) = ((bool_t) ((bool_t) 1)), BUNSPEC);
								 res2117_2702 = new1373_2691;
							      }
							   }
							   aux_3417 =
							      (obj_t) (res2117_2702);
							}
						     }
						  }
						else
						  {	/* Globalize/node.scm 284 */
						     aux_3417 =
							(obj_t) (node_1781)
							;
						  }
					     }
					  }
				     }
				  }
			       }
			    }
			    break;
			 case ((long) 11):

			    {	/* Globalize/node.scm 309 */
			       conditional_bglt node_1823;
			       node_1823 =
				  (conditional_bglt) (node_10);
			       {	/* Globalize/node.scm 310 */
				  node_bglt arg2018_1826;
				  arg2018_1826 =
				     glo__115_globalize_node(
				     (((conditional_bglt) CREF(node_1823))->test), integrator_11);
				  ((((conditional_bglt) CREF(node_1823))->test) = ((node_bglt) arg2018_1826), BUNSPEC);
			       }
			       {	/* Globalize/node.scm 311 */
				  node_bglt arg2020_1828;
				  arg2020_1828 =
				     glo__115_globalize_node(
				     (((conditional_bglt) CREF(node_1823))->true), integrator_11);
				  ((((conditional_bglt) CREF(node_1823))->true) = ((node_bglt) arg2020_1828), BUNSPEC);
			       }
			       {	/* Globalize/node.scm 312 */
				  node_bglt arg2022_1830;
				  arg2022_1830 =
				     glo__115_globalize_node(
				     (((conditional_bglt) CREF(node_1823))->false), integrator_11);
				  ((((conditional_bglt) CREF(node_1823))->false) = ((node_bglt) arg2022_1830), BUNSPEC);
			       }
			       aux_3417 =
				  (obj_t) (node_1823);
			    }
			    break;
			 case ((long) 12):

			    {	/* Globalize/node.scm 319 */
			       fail_bglt node_1832;
			       node_1832 =
				  (fail_bglt) (node_10);
			       {	/* Globalize/node.scm 320 */
				  node_bglt arg2024_1835;
				  arg2024_1835 =
				     glo__115_globalize_node(
				     (((fail_bglt) CREF(node_1832))->proc), integrator_11);
				  ((((fail_bglt) CREF(node_1832))->proc) = ((node_bglt) arg2024_1835), BUNSPEC);
			       }
			       {	/* Globalize/node.scm 321 */
				  node_bglt arg2026_1837;
				  arg2026_1837 =
				     glo__115_globalize_node(
				     (((fail_bglt) CREF(node_1832))->msg), integrator_11);
				  ((((fail_bglt) CREF(node_1832))->msg) = ((node_bglt) arg2026_1837), BUNSPEC);
			       }
			       {	/* Globalize/node.scm 322 */
				  node_bglt arg2028_1839;
				  arg2028_1839 =
				     glo__115_globalize_node(
				     (((fail_bglt) CREF(node_1832))->obj), integrator_11);
				  ((((fail_bglt) CREF(node_1832))->obj) = ((node_bglt) arg2028_1839), BUNSPEC);
			       }
			       aux_3417 =
				  (obj_t) (node_1832);
			    }
			    break;
			 case ((long) 13):

			    {	/* Globalize/node.scm 329 */
			       select_bglt node_1841;
			       node_1841 =
				  (select_bglt) (node_10);
			       {	/* Globalize/node.scm 330 */
				  node_bglt arg2030_1844;
				  arg2030_1844 =
				     glo__115_globalize_node(
				     (((select_bglt) CREF(node_1841))->test), integrator_11);
				  ((((select_bglt) CREF(node_1841))->test) = ((node_bglt) arg2030_1844), BUNSPEC);
			       }
			       {
				  obj_t l1593_1846;
				  l1593_1846 =
				     (((select_bglt) CREF(node_1841))->clauses);
				lname1594_1847:
				  if (
				     PAIRP(l1593_1846))
				    {	/* Globalize/node.scm 331 */
				       {	/* Globalize/node.scm 332 */
					  obj_t clause_1850;
					  clause_1850 =
					     CAR(l1593_1846);
					  {	/* Globalize/node.scm 332 */
					     node_bglt arg2034_1851;
					     {	/* Globalize/node.scm 332 */
						node_bglt aux_3791;
						{	/* Globalize/node.scm 332 */
						   obj_t aux_3792;
						   aux_3792 =
						      CDR(clause_1850);
						   aux_3791 =
						      (node_bglt) (aux_3792);
						}
						arg2034_1851 =
						   glo__115_globalize_node(aux_3791, integrator_11);
					     }
					     {	/* ./Ieee/pair-list.scm 5896 */
						obj_t aux_3796;
						aux_3796 =
						   (obj_t) (arg2034_1851);
						SET_CDR(clause_1850, aux_3796);
					     }
					  }
				       }
				       {
					  obj_t l1593_3799;
					  l1593_3799 =
					     CDR(l1593_1846);
					  l1593_1846 = l1593_3799;
					  goto lname1594_1847;
				       }
				    }
				  else
				    {	/* Globalize/node.scm 331 */
				       ((bool_t) 1);
				    }
			       }
			       aux_3417 =
				  (obj_t) (node_1841);
			    }
			    break;
			 case ((long) 14):

			    {	/* Globalize/node.scm 340 */
			       let_fun_218_bglt node_1854;
			       node_1854 =
				  (let_fun_218_bglt) (node_10);
			       {	/* Globalize/node.scm 341 */
				  node_bglt arg2037_1857;
				  arg2037_1857 =
				     glo__115_globalize_node(
				     (((let_fun_218_bglt) CREF(node_1854))->body), integrator_11);
				  ((((let_fun_218_bglt) CREF(node_1854))->body) = ((node_bglt) arg2037_1857), BUNSPEC);
			       }
			       {
				  obj_t obindings_1859;
				  obj_t nbindings_1860;
				  obj_t ebindings_1861;
				  obindings_1859 =
				     (((let_fun_218_bglt) CREF(node_1854))->locals);
				  nbindings_1860 = BNIL;
				  ebindings_1861 = BNIL;
				liip_1862:
				  if (
				     NULLP(obindings_1859))
				    {	/* Globalize/node.scm 352 */
				       ((((let_fun_218_bglt) CREF(node_1854))->locals) = ((obj_t) nbindings_1860), BUNSPEC);
				       if (
					  NULLP(ebindings_1861))
					 {	/* Globalize/node.scm 354 */
					    aux_3417 =
					       (obj_t) (node_1854)
					       ;
					 }
				       else
					 {	/* Globalize/node.scm 356 */
					    let_var_6_bglt aux_3813;
					    aux_3813 =
					       make_escaping_bindings_69_globalize_node(ebindings_1861,
					       (node_bglt) (node_1854), integrator_11);
					    aux_3417 =
					       (obj_t) (aux_3813);
					 }
				    }
				  else
				    {	/* Globalize/node.scm 357 */
				       bool_t test_3817;
				       {	/* Globalize/node.scm 357 */
					  bool_t test_3818;
					  {	/* ./Ieee/equiv.scm 5508 */
					     obj_t aux_3821;
					     obj_t aux_3819;
					     aux_3821 =
						(obj_t) (integrator_11);
					     aux_3819 =
						CAR(obindings_1859);
					     test_3818 =
						(aux_3819 == aux_3821);
					  }
					  if (test_3818)
					    {	/* Globalize/node.scm 357 */
					       test_3817 = ((bool_t) 0)
						  ;
					    }
					  else
					    {	/* Globalize/node.scm 358 */
					       local_ginfo_108_bglt obj_2744;
					       {	/* Globalize/node.scm 358 */
						  obj_t aux_3824;
						  aux_3824 =
						     CAR(obindings_1859);
						  obj_2744 =
						     (local_ginfo_108_bglt) (aux_3824);
					       }
					       {
						  obj_t aux_3827;
						  {	/* ./Globalize/ginfo.scm 1452 */
						     object_bglt aux_3828;
						     aux_3828 =
							(object_bglt) (obj_2744);
						     aux_3827 =
							OBJECT_WIDENING(aux_3828);
						  }
						  test_3817 =
						     (((local_ginfo_108_bglt) CREF(aux_3827))->escape__117);
					       }
					    }
				       }
				       if (test_3817)
					 {	/* Globalize/node.scm 357 */
					    {	/* Globalize/node.scm 359 */
					       obj_t arg2046_1870;
					       obj_t arg2047_1871;
					       arg2046_1870 =
						  CDR(obindings_1859);
					       {	/* ./Ieee/pair-list.scm 5689 */
						  obj_t aux_3833;
						  aux_3833 =
						     CAR(obindings_1859);
						  arg2047_1871 =
						     MAKE_PAIR(aux_3833, ebindings_1861);
					       }
					       {
						  obj_t ebindings_3837;
						  obj_t obindings_3836;
						  obindings_3836 = arg2046_1870;
						  ebindings_3837 = arg2047_1871;
						  ebindings_1861 = ebindings_3837;
						  obindings_1859 = obindings_3836;
						  goto liip_1862;
					       }
					    }
					 }
				       else
					 {	/* Globalize/node.scm 357 */
					    {	/* Globalize/node.scm 363 */
					       obj_t local_1873;
					       local_1873 =
						  CAR(obindings_1859);
					       globalize_local_fun__50_globalize_node(
						  (local_bglt) (local_1873), integrator_11);
					       {	/* Globalize/node.scm 365 */
						  obj_t arg2049_1874;
						  obj_t arg2050_1875;
						  arg2049_1874 =
						     CDR(obindings_1859);
						  arg2050_1875 =
						     MAKE_PAIR(local_1873, nbindings_1860);
						  {
						     obj_t nbindings_3844;
						     obj_t obindings_3843;
						     obindings_3843 = arg2049_1874;
						     nbindings_3844 = arg2050_1875;
						     nbindings_1860 = nbindings_3844;
						     obindings_1859 = obindings_3843;
						     goto liip_1862;
						  }
					       }
					    }
					 }
				    }
			       }
			    }
			    break;
			 case ((long) 15):

			    {	/* Globalize/node.scm 373 */
			       let_var_6_bglt node_1879;
			       node_1879 =
				  (let_var_6_bglt) (node_10);
			       {
				  obj_t l1597_1882;
				  l1597_1882 =
				     (((let_var_6_bglt) CREF(node_1879))->bindings);
				lname1598_1883:
				  if (
				     PAIRP(l1597_1882))
				    {	/* Globalize/node.scm 374 */
				       {	/* Globalize/node.scm 375 */
					  obj_t binding_1886;
					  binding_1886 =
					     CAR(l1597_1882);
					  {	/* Globalize/node.scm 375 */
					     obj_t var_1887;
					     var_1887 =
						CAR(binding_1886);
					     {	/* Globalize/node.scm 377 */
						node_bglt arg2056_1889;
						{	/* Globalize/node.scm 377 */
						   node_bglt aux_3851;
						   {	/* Globalize/node.scm 377 */
						      obj_t aux_3852;
						      aux_3852 =
							 CDR(binding_1886);
						      aux_3851 =
							 (node_bglt) (aux_3852);
						   }
						   arg2056_1889 =
						      glo__115_globalize_node(aux_3851, integrator_11);
						}
						{	/* ./Ieee/pair-list.scm 5896 */
						   obj_t aux_3856;
						   aux_3856 =
						      (obj_t) (arg2056_1889);
						   SET_CDR(binding_1886, aux_3856);
						}
					     }
					     if (
						celled__113_globalize_node(
						   (variable_bglt) (var_1887)))
					       {	/* Globalize/node.scm 378 */
						  {	/* Globalize/node.scm 380 */
						     local_bglt obj_2760;
						     type_bglt val1082_2761;
						     obj_2760 =
							(local_bglt) (var_1887);
						     val1082_2761 =
							(type_bglt) (_obj__252_type_cache);
						     ((((local_bglt) CREF(obj_2760))->type) = ((type_bglt) val1082_2761), BUNSPEC);
						  }
						  {	/* Globalize/node.scm 381 */
						     make_box_202_bglt arg2058_1891;
						     {	/* Globalize/node.scm 381 */
							node_bglt aux_3865;
							{	/* Globalize/node.scm 381 */
							   obj_t aux_3866;
							   aux_3866 =
							      CDR(binding_1886);
							   aux_3865 =
							      (node_bglt) (aux_3866);
							}
							arg2058_1891 =
							   a_make_cell_117_globalize_node(aux_3865,
							   (variable_bglt) (var_1887));
						     }
						     {	/* ./Ieee/pair-list.scm 5896 */
							obj_t aux_3871;
							aux_3871 =
							   (obj_t) (arg2058_1891);
							SET_CDR(binding_1886, aux_3871);
						     }
						  }
					       }
					     else
					       {	/* Globalize/node.scm 378 */
						  BUNSPEC;
					       }
					  }
				       }
				       {
					  obj_t l1597_3874;
					  l1597_3874 =
					     CDR(l1597_1882);
					  l1597_1882 = l1597_3874;
					  goto lname1598_1883;
				       }
				    }
				  else
				    {	/* Globalize/node.scm 374 */
				       ((bool_t) 1);
				    }
			       }
			       {	/* Globalize/node.scm 384 */
				  node_bglt arg2061_1894;
				  arg2061_1894 =
				     glo__115_globalize_node(
				     (((let_var_6_bglt) CREF(node_1879))->body), integrator_11);
				  ((((let_var_6_bglt) CREF(node_1879))->body) = ((node_bglt) arg2061_1894), BUNSPEC);
			       }
			       aux_3417 =
				  (obj_t) (node_1879);
			    }
			    break;
			 case ((long) 16):

			    {	/* Globalize/node.scm 391 */
			       set_ex_it_116_bglt node_1896;
			       node_1896 =
				  (set_ex_it_116_bglt) (node_10);
			       {	/* Globalize/node.scm 397 */
				  bool_t test_3882;
				  {	/* Globalize/node.scm 397 */
				     sfun_ginfo_98_bglt obj_2774;
				     {	/* Globalize/node.scm 397 */
					value_bglt aux_3883;
					{	/* Globalize/node.scm 397 */
					   local_bglt obj_2773;
					   {	/* Globalize/node.scm 397 */
					      obj_t aux_3884;
					      {		/* Globalize/node.scm 392 */
						 sexit_bglt obj_2772;
						 {	/* Globalize/node.scm 392 */
						    value_bglt aux_3885;
						    {	/* Globalize/node.scm 392 */
						       local_bglt obj_2771;
						       {	/* Globalize/node.scm 392 */
							  variable_bglt aux_3886;
							  {	/* Globalize/node.scm 392 */
							     var_bglt arg2072_1909;
							     arg2072_1909 =
								(((set_ex_it_116_bglt) CREF(node_1896))->var);
							     aux_3886 =
								(((var_bglt) CREF(arg2072_1909))->variable);
							  }
							  obj_2771 =
							     (local_bglt) (aux_3886);
						       }
						       aux_3885 =
							  (((local_bglt) CREF(obj_2771))->value);
						    }
						    obj_2772 =
						       (sexit_bglt) (aux_3885);
						 }
						 aux_3884 =
						    (((sexit_bglt) CREF(obj_2772))->handler);
					      }
					      obj_2773 =
						 (local_bglt) (aux_3884);
					   }
					   aux_3883 =
					      (((local_bglt) CREF(obj_2773))->value);
					}
					obj_2774 =
					   (sfun_ginfo_98_bglt) (aux_3883);
				     }
				     {
					obj_t aux_3896;
					{	/* ./Globalize/ginfo.scm 1394 */
					   object_bglt aux_3897;
					   aux_3897 =
					      (object_bglt) (obj_2774);
					   aux_3896 =
					      OBJECT_WIDENING(aux_3897);
					}
					test_3882 =
					   (((sfun_ginfo_98_bglt) CREF(aux_3896))->g__219);
				     }
				  }
				  if (test_3882)
				    {	/* Globalize/node.scm 398 */
				       sexit_bglt obj_2778;
				       {	/* Globalize/node.scm 398 */
					  value_bglt aux_3901;
					  {	/* Globalize/node.scm 398 */
					     local_bglt obj_2777;
					     {	/* Globalize/node.scm 398 */
						variable_bglt aux_3902;
						{	/* Globalize/node.scm 398 */
						   var_bglt arg2066_1903;
						   arg2066_1903 =
						      (((set_ex_it_116_bglt) CREF(node_1896))->var);
						   aux_3902 =
						      (((var_bglt) CREF(arg2066_1903))->variable);
						}
						obj_2777 =
						   (local_bglt) (aux_3902);
					     }
					     aux_3901 =
						(((local_bglt) CREF(obj_2777))->value);
					  }
					  obj_2778 =
					     (sexit_bglt) (aux_3901);
				       }
				       ((((sexit_bglt) CREF(obj_2778))->detached__120) = ((bool_t) ((bool_t) 1)), BUNSPEC);
				    }
				  else
				    {	/* Globalize/node.scm 397 */
				       BUNSPEC;
				    }
			       }
			       {	/* Globalize/node.scm 399 */
				  node_bglt arg2068_1905;
				  arg2068_1905 =
				     glo__115_globalize_node(
				     (((set_ex_it_116_bglt) CREF(node_1896))->body), integrator_11);
				  ((((set_ex_it_116_bglt) CREF(node_1896))->body) = ((node_bglt) arg2068_1905), BUNSPEC);
			       }
			       aux_3417 =
				  (obj_t) (node_1896);
			    }
			    break;
			 case ((long) 17):

			    {	/* Globalize/node.scm 406 */
			       jump_ex_it_184_bglt node_1910;
			       node_1910 =
				  (jump_ex_it_184_bglt) (node_10);
			       {	/* Globalize/node.scm 407 */
				  node_bglt arg2073_1913;
				  arg2073_1913 =
				     glo__115_globalize_node(
				     (((jump_ex_it_184_bglt) CREF(node_1910))->exit), integrator_11);
				  ((((jump_ex_it_184_bglt) CREF(node_1910))->exit) = ((node_bglt) arg2073_1913), BUNSPEC);
			       }
			       {	/* Globalize/node.scm 408 */
				  node_bglt arg2076_1915;
				  arg2076_1915 =
				     glo__115_globalize_node(
				     (((jump_ex_it_184_bglt) CREF(node_1910))->value), integrator_11);
				  ((((jump_ex_it_184_bglt) CREF(node_1910))->value) = ((node_bglt) arg2076_1915), BUNSPEC);
			       }
			       aux_3417 =
				  (obj_t) (node_1910);
			    }
			    break;
			 case ((long) 18):

			    {	/* Globalize/node.scm 415 */
			       make_box_202_bglt node_1917;
			       node_1917 =
				  (make_box_202_bglt) (node_10);
			       {	/* Globalize/node.scm 416 */
				  node_bglt arg2078_1920;
				  arg2078_1920 =
				     glo__115_globalize_node(
				     (((make_box_202_bglt) CREF(node_1917))->value), integrator_11);
				  ((((make_box_202_bglt) CREF(node_1917))->value) = ((node_bglt) arg2078_1920), BUNSPEC);
			       }
			       aux_3417 =
				  (obj_t) (node_1917);
			    }
			    break;
			 case ((long) 19):

			    {	/* Globalize/node.scm 423 */
			       box_ref_242_bglt node_1922;
			       node_1922 =
				  (box_ref_242_bglt) (node_10);
			       {	/* Globalize/node.scm 424 */
				  node_bglt arg2080_1925;
				  {	/* Globalize/node.scm 424 */
				     node_bglt aux_3927;
				     {	/* Globalize/node.scm 424 */
					var_bglt aux_3928;
					aux_3928 =
					   (((box_ref_242_bglt) CREF(node_1922))->var);
					aux_3927 =
					   (node_bglt) (aux_3928);
				     }
				     arg2080_1925 =
					glo__115_globalize_node(aux_3927, integrator_11);
				  }
				  {	/* Globalize/node.scm 424 */
				     var_bglt val1418_2794;
				     val1418_2794 =
					(var_bglt) (arg2080_1925);
				     ((((box_ref_242_bglt) CREF(node_1922))->var) = ((var_bglt) val1418_2794), BUNSPEC);
				  }
			       }
			       aux_3417 =
				  (obj_t) (node_1922);
			    }
			    break;
			 case ((long) 20):

			    {	/* Globalize/node.scm 431 */
			       box_set__221_bglt node_1927;
			       node_1927 =
				  (box_set__221_bglt) (node_10);
			       {	/* Globalize/node.scm 432 */
				  node_bglt arg2082_1930;
				  {	/* Globalize/node.scm 432 */
				     node_bglt aux_3936;
				     {	/* Globalize/node.scm 432 */
					var_bglt aux_3937;
					aux_3937 =
					   (((box_set__221_bglt) CREF(node_1927))->var);
					aux_3936 =
					   (node_bglt) (aux_3937);
				     }
				     arg2082_1930 =
					glo__115_globalize_node(aux_3936, integrator_11);
				  }
				  {	/* Globalize/node.scm 432 */
				     var_bglt val1428_2797;
				     val1428_2797 =
					(var_bglt) (arg2082_1930);
				     ((((box_set__221_bglt) CREF(node_1927))->var) = ((var_bglt) val1428_2797), BUNSPEC);
				  }
			       }
			       {	/* Globalize/node.scm 433 */
				  node_bglt arg2084_1932;
				  arg2084_1932 =
				     glo__115_globalize_node(
				     (((box_set__221_bglt) CREF(node_1927))->value), integrator_11);
				  ((((box_set__221_bglt) CREF(node_1927))->value) = ((node_bglt) arg2084_1932), BUNSPEC);
			       }
			       aux_3417 =
				  (obj_t) (node_1927);
			    }
			    break;
			 default:
			  case_else1918_1678:
			    if (
			       PROCEDUREP(method1912_1674))
			      {		/* Globalize/node.scm 117 */
				 aux_3417 =
				    PROCEDURE_ENTRY(method1912_1674) (method1912_1674,
				    (obj_t) (node_10),
				    (obj_t) (integrator_11), BEOA)
				    ;
			      }
			    else
			      {		/* Globalize/node.scm 117 */
				 obj_t fun1911_1670;
				 fun1911_1670 =
				    PROCEDURE_REF(glo__env_172_globalize_node, ((long) 0));
				 aux_3417 =
				    PROCEDURE_ENTRY(fun1911_1670) (fun1911_1670,
				    (obj_t) (node_10),
				    (obj_t) (integrator_11), BEOA);
			      }
			 }
		    }
		  else
		    {	/* Globalize/node.scm 117 */
		       goto case_else1918_1678;
		    }
	       }
	       return
		  (node_bglt) (aux_3417);
	    }
	 }
      }
   }
}



/* _glo! */
obj_t 
_glo__107_globalize_node(obj_t env_2810, obj_t node_2811, obj_t integrator_2812)
{
   AN_OBJECT;
   {	/* Globalize/node.scm 117 */
      {		/* Globalize/node.scm 117 */
	 node_bglt aux_3961;
	 aux_3961 =
	    glo__115_globalize_node(
	    (node_bglt) (node_2811),
	    (variable_bglt) (integrator_2812));
	 return
	    (obj_t) (aux_3961);
      }
   }
}



/* glo!-default1621 */
node_bglt 
glo__default1621_84_globalize_node(node_bglt node_12, variable_bglt integrator_13)
{
   AN_OBJECT;
   {	/* Globalize/node.scm 16 */
      FAILURE(
	 CNST_TABLE_REF(((long) 8)), string2120_globalize_node,
	 (obj_t) (node_12));
   }
}



/* _glo!-default1621 */
obj_t 
_glo__default1621_41_globalize_node(obj_t env_2813, obj_t node_2814, obj_t integrator_2815)
{
   AN_OBJECT;
   {	/* Globalize/node.scm 16 */
      {		/* Globalize/node.scm 16 */
	 node_bglt aux_3969;
	 aux_3969 =
	    glo__default1621_84_globalize_node(
	    (node_bglt) (node_2814),
	    (variable_bglt) (integrator_2815));
	 return
	    (obj_t) (aux_3969);
      }
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_globalize_node()
{
   AN_OBJECT;
   {	/* Globalize/node.scm 16 */
      module_initialization_70_tools_trace(((long) 0), "GLOBALIZE_NODE");
      module_initialization_70_tools_shape(((long) 0), "GLOBALIZE_NODE");
      module_initialization_70_type_type(((long) 0), "GLOBALIZE_NODE");
      module_initialization_70_type_cache(((long) 0), "GLOBALIZE_NODE");
      module_initialization_70_ast_var(((long) 0), "GLOBALIZE_NODE");
      module_initialization_70_ast_node(((long) 0), "GLOBALIZE_NODE");
      module_initialization_70_globalize_ginfo(((long) 0), "GLOBALIZE_NODE");
      module_initialization_70_ast_sexp(((long) 0), "GLOBALIZE_NODE");
      module_initialization_70_ast_env(((long) 0), "GLOBALIZE_NODE");
      module_initialization_70_ast_local(((long) 0), "GLOBALIZE_NODE");
      module_initialization_70_globalize_free(((long) 0), "GLOBALIZE_NODE");
      return
	 module_initialization_70_globalize_local__global_194(((long) 0), "GLOBALIZE_NODE");
   }
}
