/*===========================================================================*/
/*   (Globalize/walk.scm)                                                    */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;


static obj_t method_init_76_globalize_walk();
extern obj_t current_error_port;
extern obj_t _nb_error_on_pass__70_tools_error;
extern obj_t globalize__167_globalize_globalize(global_bglt);
extern obj_t globalize_walk__63_globalize_walk(obj_t, obj_t);
extern obj_t verbose_tools_speek(obj_t, obj_t);
extern obj_t module_initialization_70_globalize_walk(long, char *);
extern obj_t module_initialization_70_tools_speek(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_engine_pass(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_globalize_escape(long, char *);
extern obj_t module_initialization_70_globalize_globalize(long, char *);
extern obj_t module_initialization_70_globalize_global_closure_246(long, char *);
extern obj_t module_initialization_70_ast_remove(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_numbers_6_5(long, char *);
extern obj_t module_initialization_70___r4_output_6_10_3(long, char *);
extern obj_t display_2_122___r4_output_6_10_3(obj_t, obj_t);
static obj_t _globalize_walk__137_globalize_walk(obj_t, obj_t, obj_t);
static obj_t imported_modules_init_94_globalize_walk();
extern obj_t append_2_18___r4_pairs_and_lists_6_3(obj_t, obj_t);
static obj_t library_modules_init_112_globalize_walk();
extern obj_t foreign_closures_19_globalize_global_closure_246();
extern obj_t open_input_string(obj_t);
extern obj_t escape_fun__53_globalize_escape(variable_bglt);
extern obj_t string_to_bstring(char *);
extern obj_t remove_var_123_ast_remove(obj_t, obj_t);
extern obj_t internal_error_43_tools_error(obj_t, obj_t, obj_t);
extern bool_t _2__206___r4_numbers_6_5(obj_t, obj_t);
extern obj_t read___reader(obj_t);
static obj_t require_initialization_114_globalize_walk = BUNSPEC;
static obj_t cnst_init_137_globalize_walk();
extern obj_t _current_pass__25_engine_pass;
static obj_t __cnst[1];

DEFINE_EXPORT_PROCEDURE(globalize_walk__env_111_globalize_walk, _globalize_walk__137_globalize_walk1574, _globalize_walk__137_globalize_walk, 0L, 2);
DEFINE_STRING(string1569_globalize_walk, string1569_globalize_walk1575, "PASS-STARTED ", 13);
DEFINE_STRING(string1568_globalize_walk, string1568_globalize_walk1576, "failure during postlude hook", 28);
DEFINE_STRING(string1567_globalize_walk, string1567_globalize_walk1577, " occured, ending ...", 20);
DEFINE_STRING(string1566_globalize_walk, string1566_globalize_walk1578, " error", 6);
DEFINE_STRING(string1565_globalize_walk, string1565_globalize_walk1579, "failure during prelude hook", 27);
DEFINE_STRING(string1564_globalize_walk, string1564_globalize_walk1580, "   . ", 5);
DEFINE_STRING(string1563_globalize_walk, string1563_globalize_walk1581, "Globalization", 13);



/* module-initialization */
obj_t 
module_initialization_70_globalize_walk(long checksum_1111, char *from_1112)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_globalize_walk))
	{
	   require_initialization_114_globalize_walk =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_globalize_walk();
	   cnst_init_137_globalize_walk();
	   imported_modules_init_94_globalize_walk();
	   method_init_76_globalize_walk();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_globalize_walk()
{
   AN_OBJECT;
   {	/* Globalize/walk.scm 14 */
      module_initialization_70___r4_output_6_10_3(((long) 0), "GLOBALIZE_WALK");
      module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "GLOBALIZE_WALK");
      module_initialization_70___r4_numbers_6_5(((long) 0), "GLOBALIZE_WALK");
      module_initialization_70___reader(((long) 0), "GLOBALIZE_WALK");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_globalize_walk()
{
   AN_OBJECT;
   {	/* Globalize/walk.scm 14 */
      {		/* Globalize/walk.scm 14 */
	 obj_t cnst_port_138_1104;
	 cnst_port_138_1104 =
	    open_input_string(string1569_globalize_walk);
	 {
	    long i_1105;
	    i_1105 = ((long) 0);
	  loop_1106:
	    {	/* Globalize/walk.scm 14 */
	       bool_t test1570_1107;
	       test1570_1107 =
		  (i_1105 == ((long) -1));
	       if (test1570_1107)
		 {	/* Globalize/walk.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Globalize/walk.scm 14 */
		    {	/* Globalize/walk.scm 14 */
		       obj_t arg1571_1108;
		       {	/* Globalize/walk.scm 14 */
			  obj_t list1572_1109;
			  list1572_1109 =
			     MAKE_PAIR(cnst_port_138_1104, BNIL);
			  arg1571_1108 =
			     read___reader(list1572_1109);
		       }
		       CNST_TABLE_SET(i_1105, arg1571_1108);
		    }
		    {	/* Globalize/walk.scm 14 */
		       int aux_1110;
		       {	/* Globalize/walk.scm 14 */
			  long aux_1130;
			  aux_1130 =
			     (i_1105 - ((long) 1));
			  aux_1110 =
			     (int) (aux_1130);
		       }
		       {
			  long i_1133;
			  i_1133 =
			     (long) (aux_1110);
			  i_1105 = i_1133;
			  goto loop_1106;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* globalize-walk! */
obj_t 
globalize_walk__63_globalize_walk(obj_t globals_1, obj_t remove_2)
{
   AN_OBJECT;
   {	/* Globalize/walk.scm 27 */
      {		/* Globalize/walk.scm 27 */
	 obj_t list1440_698;
	 {	/* Globalize/walk.scm 27 */
	    obj_t arg1442_700;
	    {	/* Globalize/walk.scm 27 */
	       obj_t arg1444_702;
	       {	/* Globalize/walk.scm 27 */
		  obj_t aux_1135;
		  aux_1135 =
		     BCHAR(((unsigned char) '\n'));
		  arg1444_702 =
		     MAKE_PAIR(aux_1135, BNIL);
	       }
	       arg1442_700 =
		  MAKE_PAIR(string1563_globalize_walk, arg1444_702);
	    }
	    list1440_698 =
	       MAKE_PAIR(string1564_globalize_walk, arg1442_700);
	 }
	 verbose_tools_speek(
	    BINT(((long) 1)), list1440_698);
      }
      _nb_error_on_pass__70_tools_error =
	 BINT(((long) 0));
      _current_pass__25_engine_pass = string1563_globalize_walk;
      {
	 obj_t hooks_703;
	 obj_t hnames_704;
	 hooks_703 = BNIL;
	 hnames_704 = BNIL;
       loop_705:
	 if (
	    NULLP(hooks_703))
	   {	/* Globalize/walk.scm 27 */
	      CNST_TABLE_REF(((long) 0));
	   }
	 else
	   {	/* Globalize/walk.scm 27 */
	      bool_t test1449_710;
	      {		/* Globalize/walk.scm 27 */
		 obj_t fun1456_716;
		 fun1456_716 =
		    CAR(hooks_703);
		 {	/* Globalize/walk.scm 27 */
		    obj_t aux_1147;
		    aux_1147 =
		       PROCEDURE_ENTRY(fun1456_716) (fun1456_716, BEOA);
		    test1449_710 =
		       CBOOL(aux_1147);
		 }
	      }
	      if (test1449_710)
		{	/* Globalize/walk.scm 27 */
		   {
		      obj_t hnames_1154;
		      obj_t hooks_1152;
		      hooks_1152 =
			 CDR(hooks_703);
		      hnames_1154 =
			 CDR(hnames_704);
		      hnames_704 = hnames_1154;
		      hooks_703 = hooks_1152;
		      goto loop_705;
		   }
		}
	      else
		{	/* Globalize/walk.scm 27 */
		   internal_error_43_tools_error(string1563_globalize_walk, string1565_globalize_walk,
		      CAR(hnames_704));
		}
	   }
      }
      {
	 obj_t l1437_717;
	 l1437_717 = globals_1;
       lname1438_718:
	 if (
	    PAIRP(l1437_717))
	   {	/* Globalize/walk.scm 30 */
	      {		/* Globalize/walk.scm 30 */
		 variable_bglt aux_1160;
		 {	/* Globalize/walk.scm 30 */
		    obj_t aux_1161;
		    aux_1161 =
		       CAR(l1437_717);
		    aux_1160 =
		       (variable_bglt) (aux_1161);
		 }
		 escape_fun__53_globalize_escape(aux_1160);
	      }
	      {
		 obj_t l1437_1165;
		 l1437_1165 =
		    CDR(l1437_717);
		 l1437_717 = l1437_1165;
		 goto lname1438_718;
	      }
	   }
	 else
	   {	/* Globalize/walk.scm 30 */
	      ((bool_t) 1);
	   }
      }
      {
	 obj_t globals_722;
	 obj_t new_globals_42_723;
	 globals_722 = globals_1;
	 new_globals_42_723 = BNIL;
       loop_724:
	 if (
	    NULLP(globals_722))
	   {	/* Globalize/walk.scm 35 */
	      obj_t value_726;
	      {		/* Globalize/walk.scm 36 */
		 obj_t arg1476_745;
		 {	/* Globalize/walk.scm 36 */
		    obj_t arg1477_746;
		    arg1477_746 =
		       foreign_closures_19_globalize_global_closure_246();
		    arg1476_745 =
		       append_2_18___r4_pairs_and_lists_6_3(new_globals_42_723, arg1477_746);
		 }
		 value_726 =
		    remove_var_123_ast_remove(remove_2, arg1476_745);
	      }
	      {		/* Globalize/walk.scm 35 */
		 bool_t test1461_727;
		 {	/* Globalize/walk.scm 35 */
		    long n1_1087;
		    n1_1087 =
		       (long) CINT(_nb_error_on_pass__70_tools_error);
		    test1461_727 =
		       (n1_1087 > ((long) 0));
		 }
		 if (test1461_727)
		   {	/* Globalize/walk.scm 35 */
		      display_2_122___r4_output_6_10_3(_nb_error_on_pass__70_tools_error, current_error_port);
		      display_2_122___r4_output_6_10_3(string1566_globalize_walk, current_error_port);
		      {		/* Globalize/walk.scm 35 */
			 char *arg1462_729;
			 {	/* Globalize/walk.scm 35 */
			    bool_t test1463_730;
			    {	/* Globalize/walk.scm 35 */
			       bool_t test1464_731;
			       {	/* Globalize/walk.scm 35 */
				  obj_t obj_1089;
				  obj_1089 = _nb_error_on_pass__70_tools_error;
				  test1464_731 =
				     INTEGERP(obj_1089);
			       }
			       if (test1464_731)
				 {	/* Globalize/walk.scm 35 */
				    test1463_730 =
				       _2__206___r4_numbers_6_5(_nb_error_on_pass__70_tools_error,
				       BINT(((long) 1)));
				 }
			       else
				 {	/* Globalize/walk.scm 35 */
				    test1463_730 = ((bool_t) 0);
				 }
			    }
			    if (test1463_730)
			      {		/* Globalize/walk.scm 35 */
				 arg1462_729 = "s";
			      }
			    else
			      {		/* Globalize/walk.scm 35 */
				 arg1462_729 = "";
			      }
			 }
			 display_2_122___r4_output_6_10_3(
			    string_to_bstring(arg1462_729), current_error_port);
		      }
		      display_2_122___r4_output_6_10_3(string1567_globalize_walk, current_error_port);
		      WRITE_CHAR(((unsigned char) '\n'), current_error_port);
		      {		/* Globalize/walk.scm 35 */
			 obj_t res1562_1092;
			 exit(((long) -1));
			 res1562_1092 =
			    BINT(((long) -1));
			 return res1562_1092;
		      }
		   }
		 else
		   {
		      obj_t hooks_732;
		      obj_t hnames_733;
		      hooks_732 = BNIL;
		      hnames_733 = BNIL;
		    loop_734:
		      if (
			 NULLP(hooks_732))
			{	/* Globalize/walk.scm 35 */
			   return value_726;
			}
		      else
			{	/* Globalize/walk.scm 35 */
			   bool_t test1470_739;
			   {	/* Globalize/walk.scm 35 */
			      obj_t fun1475_744;
			      fun1475_744 =
				 CAR(hooks_732);
			      {		/* Globalize/walk.scm 35 */
				 obj_t aux_1191;
				 aux_1191 =
				    PROCEDURE_ENTRY(fun1475_744) (fun1475_744, BEOA);
				 test1470_739 =
				    CBOOL(aux_1191);
			      }
			   }
			   if (test1470_739)
			     {	/* Globalize/walk.scm 35 */
				{
				   obj_t hnames_1198;
				   obj_t hooks_1196;
				   hooks_1196 =
				      CDR(hooks_732);
				   hnames_1198 =
				      CDR(hnames_733);
				   hnames_733 = hnames_1198;
				   hooks_732 = hooks_1196;
				   goto loop_734;
				}
			     }
			   else
			     {	/* Globalize/walk.scm 35 */
				return
				   internal_error_43_tools_error(_current_pass__25_engine_pass, string1568_globalize_walk,
				   CAR(hnames_733));
			     }
			}
		   }
	      }
	   }
	 else
	   {	/* Globalize/walk.scm 37 */
	      obj_t arg1478_747;
	      obj_t arg1479_748;
	      arg1478_747 =
		 CDR(globals_722);
	      {		/* Globalize/walk.scm 38 */
		 obj_t arg1480_749;
		 {	/* Globalize/walk.scm 38 */
		    global_bglt aux_1203;
		    {	/* Globalize/walk.scm 38 */
		       obj_t aux_1204;
		       aux_1204 =
			  CAR(globals_722);
		       aux_1203 =
			  (global_bglt) (aux_1204);
		    }
		    arg1480_749 =
		       globalize__167_globalize_globalize(aux_1203);
		 }
		 arg1479_748 =
		    append_2_18___r4_pairs_and_lists_6_3(arg1480_749, new_globals_42_723);
	      }
	      {
		 obj_t new_globals_42_1210;
		 obj_t globals_1209;
		 globals_1209 = arg1478_747;
		 new_globals_42_1210 = arg1479_748;
		 new_globals_42_723 = new_globals_42_1210;
		 globals_722 = globals_1209;
		 goto loop_724;
	      }
	   }
      }
   }
}



/* _globalize-walk! */
obj_t 
_globalize_walk__137_globalize_walk(obj_t env_1101, obj_t globals_1102, obj_t remove_1103)
{
   AN_OBJECT;
   {	/* Globalize/walk.scm 27 */
      return
	 globalize_walk__63_globalize_walk(globals_1102, remove_1103);
   }
}



/* method-init */
obj_t 
method_init_76_globalize_walk()
{
   AN_OBJECT;
   {	/* Globalize/walk.scm 14 */
      return BUNSPEC;
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_globalize_walk()
{
   AN_OBJECT;
   {	/* Globalize/walk.scm 14 */
      module_initialization_70_tools_speek(((long) 0), "GLOBALIZE_WALK");
      module_initialization_70_tools_error(((long) 0), "GLOBALIZE_WALK");
      module_initialization_70_engine_pass(((long) 0), "GLOBALIZE_WALK");
      module_initialization_70_type_type(((long) 0), "GLOBALIZE_WALK");
      module_initialization_70_ast_var(((long) 0), "GLOBALIZE_WALK");
      module_initialization_70_ast_node(((long) 0), "GLOBALIZE_WALK");
      module_initialization_70_globalize_escape(((long) 0), "GLOBALIZE_WALK");
      module_initialization_70_globalize_globalize(((long) 0), "GLOBALIZE_WALK");
      module_initialization_70_globalize_global_closure_246(((long) 0), "GLOBALIZE_WALK");
      return
	 module_initialization_70_ast_remove(((long) 0), "GLOBALIZE_WALK");
   }
}
