/*===========================================================================*/
/*   (Heap/make.scm)                                                         */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;


extern obj_t set_obj_string_mode__22___intext(obj_t);
static obj_t method_init_76_heap_make();
extern obj_t get_tenv_245_type_env();
extern obj_t output_obj(obj_t, obj_t);
extern obj_t _nb_error_on_pass__70_tools_error;
extern obj_t make_add_heap_195_heap_make();
static obj_t _prepare_additional_globals__38_heap_make(obj_t);
extern obj_t user_error_151_tools_error(obj_t, obj_t, obj_t, obj_t);
extern obj_t verbose_tools_speek(obj_t, obj_t);
extern obj_t module_initialization_70_heap_make(long, char *);
extern obj_t module_initialization_70_tools_speek(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_engine_pass(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_env(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_env(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70___os(long, char *);
extern obj_t module_initialization_70___intext(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t unbind_global__45_ast_env(obj_t, obj_t);
extern obj_t _heap_name__135_engine_param;
extern obj_t get_genv_41_ast_env();
extern obj_t make_heap_12_heap_make();
static obj_t imported_modules_init_94_heap_make();
extern obj_t _additional_include_foreign__44_engine_param;
static obj_t library_modules_init_112_heap_make();
static bool_t prepare_additional_globals__227_heap_make();
extern obj_t create_vector(long);
extern obj_t open_input_string(obj_t);
static obj_t _make_add_heap_150_heap_make(obj_t);
extern obj_t close_binary_port(obj_t);
extern obj_t _lib_dir__34_engine_param;
static obj_t _make_heap_207_heap_make(obj_t);
extern obj_t for_each_global__88_ast_env(obj_t);
static obj_t _anonymous_1257__220_heap_make(obj_t, obj_t);
extern obj_t open_output_binary_file(obj_t);
extern obj_t _additional_heap_name__223_engine_param;
extern obj_t internal_error_43_tools_error(obj_t, obj_t, obj_t);
static obj_t _prepare_globals__42_heap_make(obj_t);
static obj_t _anonymous_1218__46_heap_make(obj_t, obj_t);
extern obj_t read___reader(obj_t);
static bool_t prepare_globals__191_heap_make();
static obj_t require_initialization_114_heap_make = BUNSPEC;
extern obj_t make_file_name_203___os(obj_t, obj_t);
static obj_t cnst_init_137_heap_make();
extern obj_t _current_pass__25_engine_pass;
static obj_t __cnst[7];

DEFINE_EXPORT_PROCEDURE(make_add_heap_env_57_heap_make, _make_add_heap_150_heap_make1316, _make_add_heap_150_heap_make, 0L, 0);
DEFINE_EXPORT_PROCEDURE(make_heap_env_74_heap_make, _make_heap_207_heap_make1317, _make_heap_207_heap_make, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc1309_heap_make, _anonymous_1257__220_heap_make1318, _anonymous_1257__220_heap_make, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc1305_heap_make, _anonymous_1218__46_heap_make1319, _anonymous_1218__46_heap_make, 0L, 1);
DEFINE_STATIC_PROCEDURE(prepare_additional_globals__env_129_heap_make, _prepare_additional_globals__38_heap_make1320, _prepare_additional_globals__38_heap_make, 0L, 0);
DEFINE_STATIC_PROCEDURE(prepare_globals__env_2_heap_make, _prepare_globals__42_heap_make1321, _prepare_globals__42_heap_make, 0L, 0);
DEFINE_STRING(string1299_heap_make, string1299_heap_make1322, "Heap", 4);
DEFINE_STRING(string1310_heap_make, string1310_heap_make1323, "(PREPARE-ADDITIONAL-GLOBALS!) IMPORT EXPORT STATIC PAIR (PREPARE-GLOBALS!) PASS-STARTED ", 88);
DEFINE_STRING(string1308_heap_make, string1308_heap_make1324, "make-add-heap", 13);
DEFINE_STRING(string1307_heap_make, string1307_heap_make1325, "make-addd-heap", 14);
DEFINE_STRING(string1306_heap_make, string1306_heap_make1326, "Library heap", 12);
DEFINE_STRING(string1304_heap_make, string1304_heap_make1327, "Illegal heap's name", 19);
DEFINE_STRING(string1303_heap_make, string1303_heap_make1328, "Can't open output port", 22);
DEFINE_STRING(string1302_heap_make, string1302_heap_make1329, "make-heap", 9);
DEFINE_STRING(string1301_heap_make, string1301_heap_make1330, "failure during prelude hook", 27);
DEFINE_STRING(string1300_heap_make, string1300_heap_make1331, "   . ", 5);



/* module-initialization */
obj_t 
module_initialization_70_heap_make(long checksum_600, char *from_601)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_heap_make))
	{
	   require_initialization_114_heap_make =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_heap_make();
	   cnst_init_137_heap_make();
	   imported_modules_init_94_heap_make();
	   method_init_76_heap_make();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_heap_make()
{
   AN_OBJECT;
   {	/* Heap/make.scm 14 */
      module_initialization_70___intext(((long) 0), "HEAP_MAKE");
      module_initialization_70___reader(((long) 0), "HEAP_MAKE");
      module_initialization_70___os(((long) 0), "HEAP_MAKE");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_heap_make()
{
   AN_OBJECT;
   {	/* Heap/make.scm 14 */
      {		/* Heap/make.scm 14 */
	 obj_t cnst_port_138_593;
	 cnst_port_138_593 =
	    open_input_string(string1310_heap_make);
	 {
	    long i_594;
	    i_594 = ((long) 6);
	  loop_595:
	    {	/* Heap/make.scm 14 */
	       bool_t test1311_596;
	       test1311_596 =
		  (i_594 == ((long) -1));
	       if (test1311_596)
		 {	/* Heap/make.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Heap/make.scm 14 */
		    {	/* Heap/make.scm 14 */
		       obj_t arg1313_597;
		       {	/* Heap/make.scm 14 */
			  obj_t list1314_598;
			  list1314_598 =
			     MAKE_PAIR(cnst_port_138_593, BNIL);
			  arg1313_597 =
			     read___reader(list1314_598);
		       }
		       CNST_TABLE_SET(i_594, arg1313_597);
		    }
		    {	/* Heap/make.scm 14 */
		       int aux_599;
		       {	/* Heap/make.scm 14 */
			  long aux_618;
			  aux_618 =
			     (i_594 - ((long) 1));
			  aux_599 =
			     (int) (aux_618);
		       }
		       {
			  long i_621;
			  i_621 =
			     (long) (aux_599);
			  i_594 = i_621;
			  goto loop_595;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* make-heap */
obj_t 
make_heap_12_heap_make()
{
   AN_OBJECT;
   {	/* Heap/make.scm 29 */
      {		/* Heap/make.scm 29 */
	 obj_t list1185_305;
	 {	/* Heap/make.scm 29 */
	    obj_t arg1188_307;
	    {	/* Heap/make.scm 29 */
	       obj_t arg1190_309;
	       {	/* Heap/make.scm 29 */
		  obj_t aux_623;
		  aux_623 =
		     BCHAR(((unsigned char) '\n'));
		  arg1190_309 =
		     MAKE_PAIR(aux_623, BNIL);
	       }
	       arg1188_307 =
		  MAKE_PAIR(string1299_heap_make, arg1190_309);
	    }
	    list1185_305 =
	       MAKE_PAIR(string1300_heap_make, arg1188_307);
	 }
	 verbose_tools_speek(
	    BINT(((long) 1)), list1185_305);
      }
      _nb_error_on_pass__70_tools_error =
	 BINT(((long) 0));
      _current_pass__25_engine_pass = string1299_heap_make;
      {
	 obj_t hooks_310;
	 obj_t hnames_311;
	 {	/* Heap/make.scm 29 */
	    obj_t arg1192_313;
	    obj_t arg1193_314;
	    {	/* Heap/make.scm 29 */
	       obj_t list1194_315;
	       list1194_315 =
		  MAKE_PAIR(prepare_globals__env_2_heap_make, BNIL);
	       arg1192_313 = list1194_315;
	    }
	    arg1193_314 =
	       CNST_TABLE_REF(((long) 1));
	    hooks_310 = arg1192_313;
	    hnames_311 = arg1193_314;
	  loop_312:
	    if (
	       NULLP(hooks_310))
	      {		/* Heap/make.scm 29 */
		 CNST_TABLE_REF(((long) 0));
	      }
	    else
	      {		/* Heap/make.scm 29 */
		 bool_t test1196_317;
		 {	/* Heap/make.scm 29 */
		    obj_t fun1208_323;
		    fun1208_323 =
		       CAR(hooks_310);
		    {	/* Heap/make.scm 29 */
		       obj_t aux_637;
		       aux_637 =
			  PROCEDURE_ENTRY(fun1208_323) (fun1208_323, BEOA);
		       test1196_317 =
			  CBOOL(aux_637);
		    }
		 }
		 if (test1196_317)
		   {	/* Heap/make.scm 29 */
		      {
			 obj_t hnames_644;
			 obj_t hooks_642;
			 hooks_642 =
			    CDR(hooks_310);
			 hnames_644 =
			    CDR(hnames_311);
			 hnames_311 = hnames_644;
			 hooks_310 = hooks_642;
			 goto loop_312;
		      }
		   }
		 else
		   {	/* Heap/make.scm 29 */
		      internal_error_43_tools_error(string1299_heap_make, string1301_heap_make,
			 CAR(hnames_311));
		   }
	      }
	 }
      }
      set_obj_string_mode__22___intext(
	 CNST_TABLE_REF(((long) 2)));
      {		/* Heap/make.scm 32 */
	 bool_t test1209_324;
	 {	/* Heap/make.scm 32 */
	    obj_t obj_522;
	    obj_522 = _heap_name__135_engine_param;
	    test1209_324 =
	       STRINGP(obj_522);
	 }
	 if (test1209_324)
	   {	/* Heap/make.scm 34 */
	      obj_t hname_325;
	      {		/* Heap/make.scm 34 */
		 obj_t arg1215_331;
		 {	/* Heap/make.scm 34 */
		    obj_t pair_523;
		    pair_523 = _lib_dir__34_engine_param;
		    arg1215_331 =
		       CAR(pair_523);
		 }
		 hname_325 =
		    make_file_name_203___os(arg1215_331, _heap_name__135_engine_param);
	      }
	      {		/* Heap/make.scm 35 */
		 obj_t port_326;
		 port_326 =
		    open_output_binary_file(hname_325);
		 if (
		    BINARY_PORTP(port_326))
		   {	/* Heap/make.scm 36 */
		      {		/* Heap/make.scm 39 */
			 obj_t arg1212_328;
			 {	/* Heap/make.scm 39 */
			    obj_t arg1213_329;
			    obj_t arg1214_330;
			    arg1213_329 =
			       get_genv_41_ast_env();
			    arg1214_330 =
			       get_tenv_245_type_env();
			    arg1212_328 =
			       MAKE_PAIR(arg1213_329, arg1214_330);
			 }
			 output_obj(port_326, arg1212_328);
		      }
		      return
			 close_binary_port(port_326);
		   }
		 else
		   {	/* Heap/make.scm 36 */
		      FAILURE(string1302_heap_make, string1303_heap_make, hname_325);
		   }
	      }
	   }
	 else
	   {	/* Heap/make.scm 32 */
	      return
		 user_error_151_tools_error(string1302_heap_make, string1304_heap_make, _heap_name__135_engine_param, BNIL);
	   }
      }
   }
}



/* _make-heap */
obj_t 
_make_heap_207_heap_make(obj_t env_583)
{
   AN_OBJECT;
   {	/* Heap/make.scm 29 */
      return
	 make_heap_12_heap_make();
   }
}



/* prepare-globals! */
bool_t 
prepare_globals__191_heap_make()
{
   AN_OBJECT;
   {	/* Heap/make.scm 49 */
      {		/* Heap/make.scm 50 */
	 obj_t _anonymous_1218__46_585;
	 _anonymous_1218__46_585 = proc1305_heap_make;
	 for_each_global__88_ast_env(_anonymous_1218__46_585);
      }
      return ((bool_t) 1);
   }
}



/* _prepare-globals! */
obj_t 
_prepare_globals__42_heap_make(obj_t env_584)
{
   AN_OBJECT;
   {	/* Heap/make.scm 49 */
      {		/* Heap/make.scm 49 */
	 bool_t aux_666;
	 aux_666 =
	    prepare_globals__191_heap_make();
	 return
	    BBOOL(aux_666);
      }
   }
}



/* <anonymous:1218> */
obj_t 
_anonymous_1218__46_heap_make(obj_t env_586, obj_t g_587)
{
   AN_OBJECT;
   {	/* Heap/make.scm 50 */
      {
	 obj_t g_334;
	 g_334 = g_587;
	 {	/* Heap/make.scm 53 */
	    bool_t test_669;
	    {	/* ./Ieee/equiv.scm 5508 */
	       obj_t aux_673;
	       obj_t aux_670;
	       aux_673 =
		  CNST_TABLE_REF(((long) 3));
	       {	/* Heap/make.scm 53 */
		  global_bglt obj_534;
		  obj_534 =
		     (global_bglt) (g_334);
		  aux_670 =
		     (((global_bglt) CREF(obj_534))->import);
	       }
	       test_669 =
		  (aux_670 == aux_673);
	    }
	    if (test_669)
	      {		/* Heap/make.scm 53 */
		 {	/* Heap/make.scm 54 */
		    obj_t aux_679;
		    obj_t aux_676;
		    {	/* Heap/make.scm 54 */
		       global_bglt obj_538;
		       obj_538 =
			  (global_bglt) (g_334);
		       aux_679 =
			  (((global_bglt) CREF(obj_538))->module);
		    }
		    {	/* Heap/make.scm 54 */
		       global_bglt obj_537;
		       obj_537 =
			  (global_bglt) (g_334);
		       aux_676 =
			  (((global_bglt) CREF(obj_537))->id);
		    }
		    unbind_global__45_ast_env(aux_676, aux_679);
		 }
	      }
	    else
	      {		/* Heap/make.scm 55 */
		 bool_t test_683;
		 {	/* ./Ieee/equiv.scm 5508 */
		    obj_t aux_687;
		    obj_t aux_684;
		    aux_687 =
		       CNST_TABLE_REF(((long) 4));
		    {	/* Heap/make.scm 55 */
		       global_bglt obj_539;
		       obj_539 =
			  (global_bglt) (g_334);
		       aux_684 =
			  (((global_bglt) CREF(obj_539))->import);
		    }
		    test_683 =
		       (aux_684 == aux_687);
		 }
		 if (test_683)
		   {	/* Heap/make.scm 55 */
		      {		/* Heap/make.scm 56 */
			 global_bglt obj_542;
			 obj_t val1058_543;
			 obj_542 =
			    (global_bglt) (g_334);
			 val1058_543 =
			    CNST_TABLE_REF(((long) 5));
			 ((((global_bglt) CREF(obj_542))->import) = ((obj_t) val1058_543), BUNSPEC);
		      }
		   }
		 else
		   {	/* Heap/make.scm 55 */
		      BUNSPEC;
		   }
	      }
	 }
	 {	/* Heap/make.scm 60 */
	    global_bglt obj_544;
	    obj_544 =
	       (global_bglt) (g_334);
	    return
	       ((((global_bglt) CREF(obj_544))->occurrence) = ((long) ((long) 0)), BUNSPEC);
	 }
      }
   }
}



/* make-add-heap */
obj_t 
make_add_heap_195_heap_make()
{
   AN_OBJECT;
   {	/* Heap/make.scm 66 */
      {		/* Heap/make.scm 66 */
	 obj_t list1229_345;
	 {	/* Heap/make.scm 66 */
	    obj_t arg1231_347;
	    {	/* Heap/make.scm 66 */
	       obj_t arg1233_349;
	       {	/* Heap/make.scm 66 */
		  obj_t aux_695;
		  aux_695 =
		     BCHAR(((unsigned char) '\n'));
		  arg1233_349 =
		     MAKE_PAIR(aux_695, BNIL);
	       }
	       arg1231_347 =
		  MAKE_PAIR(string1306_heap_make, arg1233_349);
	    }
	    list1229_345 =
	       MAKE_PAIR(string1300_heap_make, arg1231_347);
	 }
	 verbose_tools_speek(
	    BINT(((long) 1)), list1229_345);
      }
      _nb_error_on_pass__70_tools_error =
	 BINT(((long) 0));
      _current_pass__25_engine_pass = string1306_heap_make;
      {
	 obj_t hooks_350;
	 obj_t hnames_351;
	 {	/* Heap/make.scm 66 */
	    obj_t arg1234_353;
	    obj_t arg1235_354;
	    {	/* Heap/make.scm 66 */
	       obj_t list1236_355;
	       list1236_355 =
		  MAKE_PAIR(prepare_additional_globals__env_129_heap_make, BNIL);
	       arg1234_353 = list1236_355;
	    }
	    arg1235_354 =
	       CNST_TABLE_REF(((long) 6));
	    hooks_350 = arg1234_353;
	    hnames_351 = arg1235_354;
	  loop_352:
	    if (
	       NULLP(hooks_350))
	      {		/* Heap/make.scm 66 */
		 CNST_TABLE_REF(((long) 0));
	      }
	    else
	      {		/* Heap/make.scm 66 */
		 bool_t test1238_357;
		 {	/* Heap/make.scm 66 */
		    obj_t fun1247_363;
		    fun1247_363 =
		       CAR(hooks_350);
		    {	/* Heap/make.scm 66 */
		       obj_t aux_709;
		       aux_709 =
			  PROCEDURE_ENTRY(fun1247_363) (fun1247_363, BEOA);
		       test1238_357 =
			  CBOOL(aux_709);
		    }
		 }
		 if (test1238_357)
		   {	/* Heap/make.scm 66 */
		      {
			 obj_t hnames_716;
			 obj_t hooks_714;
			 hooks_714 =
			    CDR(hooks_350);
			 hnames_716 =
			    CDR(hnames_351);
			 hnames_351 = hnames_716;
			 hooks_350 = hooks_714;
			 goto loop_352;
		      }
		   }
		 else
		   {	/* Heap/make.scm 66 */
		      internal_error_43_tools_error(string1306_heap_make, string1301_heap_make,
			 CAR(hnames_351));
		   }
	      }
	 }
      }
      set_obj_string_mode__22___intext(
	 CNST_TABLE_REF(((long) 2)));
      {		/* Heap/make.scm 69 */
	 bool_t test1248_364;
	 {	/* Heap/make.scm 69 */
	    obj_t obj_552;
	    obj_552 = _additional_heap_name__223_engine_param;
	    test1248_364 =
	       STRINGP(obj_552);
	 }
	 if (test1248_364)
	   {	/* Heap/make.scm 73 */
	      obj_t hname_365;
	      hname_365 = _additional_heap_name__223_engine_param;
	      {		/* Heap/make.scm 74 */
		 obj_t port_366;
		 port_366 =
		    open_output_binary_file(hname_365);
		 if (
		    BINARY_PORTP(port_366))
		   {	/* Heap/make.scm 75 */
		      {		/* Heap/make.scm 78 */
			 obj_t arg1250_368;
			 {	/* Heap/make.scm 78 */
			    obj_t v1184_369;
			    v1184_369 =
			       create_vector(((long) 3));
			    {	/* Heap/make.scm 78 */
			       obj_t obj_557;
			       obj_557 = _additional_include_foreign__44_engine_param;
			       VECTOR_SET(v1184_369, ((long) 2), obj_557);
			    }
			    {	/* Heap/make.scm 78 */
			       obj_t arg1252_371;
			       arg1252_371 =
				  get_tenv_245_type_env();
			       VECTOR_SET(v1184_369, ((long) 1), arg1252_371);
			    }
			    {	/* Heap/make.scm 78 */
			       obj_t arg1254_373;
			       arg1254_373 =
				  get_genv_41_ast_env();
			       VECTOR_SET(v1184_369, ((long) 0), arg1254_373);
			    }
			    arg1250_368 = v1184_369;
			 }
			 output_obj(port_366, arg1250_368);
		      }
		      return
			 close_binary_port(port_366);
		   }
		 else
		   {	/* Heap/make.scm 75 */
		      FAILURE(string1307_heap_make, string1303_heap_make, hname_365);
		   }
	      }
	   }
	 else
	   {	/* Heap/make.scm 69 */
	      return
		 user_error_151_tools_error(string1308_heap_make, string1304_heap_make, _additional_heap_name__223_engine_param, BNIL);
	   }
      }
   }
}



/* _make-add-heap */
obj_t 
_make_add_heap_150_heap_make(obj_t env_588)
{
   AN_OBJECT;
   {	/* Heap/make.scm 66 */
      return
	 make_add_heap_195_heap_make();
   }
}



/* prepare-additional-globals! */
bool_t 
prepare_additional_globals__227_heap_make()
{
   AN_OBJECT;
   {	/* Heap/make.scm 90 */
      {		/* Heap/make.scm 91 */
	 obj_t _anonymous_1257__220_590;
	 _anonymous_1257__220_590 = proc1309_heap_make;
	 for_each_global__88_ast_env(_anonymous_1257__220_590);
      }
      return ((bool_t) 1);
   }
}



/* _prepare-additional-globals! */
obj_t 
_prepare_additional_globals__38_heap_make(obj_t env_589)
{
   AN_OBJECT;
   {	/* Heap/make.scm 90 */
      {		/* Heap/make.scm 90 */
	 bool_t aux_739;
	 aux_739 =
	    prepare_additional_globals__227_heap_make();
	 return
	    BBOOL(aux_739);
      }
   }
}



/* <anonymous:1257> */
obj_t 
_anonymous_1257__220_heap_make(obj_t env_591, obj_t g_592)
{
   AN_OBJECT;
   {	/* Heap/make.scm 91 */
      {
	 obj_t g_376;
	 g_376 = g_592;
	 {	/* Heap/make.scm 94 */
	    bool_t test_742;
	    {	/* Heap/make.scm 94 */
	       bool_t test_743;
	       {	/* ./Ieee/equiv.scm 5508 */
		  obj_t aux_747;
		  obj_t aux_744;
		  aux_747 =
		     CNST_TABLE_REF(((long) 3));
		  {	/* Heap/make.scm 94 */
		     global_bglt obj_570;
		     obj_570 =
			(global_bglt) (g_376);
		     aux_744 =
			(((global_bglt) CREF(obj_570))->import);
		  }
		  test_743 =
		     (aux_744 == aux_747);
	       }
	       if (test_743)
		 {	/* Heap/make.scm 94 */
		    test_742 = ((bool_t) 1)
		       ;
		 }
	       else
		 {	/* Heap/make.scm 95 */
		    global_bglt obj_573;
		    obj_573 =
		       (global_bglt) (g_376);
		    test_742 =
		       (((global_bglt) CREF(obj_573))->library__255);
		 }
	    }
	    if (test_742)
	      {		/* Heap/make.scm 94 */
		 {	/* Heap/make.scm 96 */
		    obj_t aux_755;
		    obj_t aux_752;
		    {	/* Heap/make.scm 96 */
		       global_bglt obj_575;
		       obj_575 =
			  (global_bglt) (g_376);
		       aux_755 =
			  (((global_bglt) CREF(obj_575))->module);
		    }
		    {	/* Heap/make.scm 96 */
		       global_bglt obj_574;
		       obj_574 =
			  (global_bglt) (g_376);
		       aux_752 =
			  (((global_bglt) CREF(obj_574))->id);
		    }
		    unbind_global__45_ast_env(aux_752, aux_755);
		 }
	      }
	    else
	      {		/* Heap/make.scm 97 */
		 bool_t test_759;
		 {	/* ./Ieee/equiv.scm 5508 */
		    obj_t aux_763;
		    obj_t aux_760;
		    aux_763 =
		       CNST_TABLE_REF(((long) 4));
		    {	/* Heap/make.scm 97 */
		       global_bglt obj_576;
		       obj_576 =
			  (global_bglt) (g_376);
		       aux_760 =
			  (((global_bglt) CREF(obj_576))->import);
		    }
		    test_759 =
		       (aux_760 == aux_763);
		 }
		 if (test_759)
		   {	/* Heap/make.scm 97 */
		      {		/* Heap/make.scm 98 */
			 global_bglt obj_579;
			 obj_t val1058_580;
			 obj_579 =
			    (global_bglt) (g_376);
			 val1058_580 =
			    CNST_TABLE_REF(((long) 5));
			 ((((global_bglt) CREF(obj_579))->import) = ((obj_t) val1058_580), BUNSPEC);
		      }
		   }
		 else
		   {	/* Heap/make.scm 97 */
		      BUNSPEC;
		   }
	      }
	 }
	 {	/* Heap/make.scm 102 */
	    global_bglt obj_581;
	    obj_581 =
	       (global_bglt) (g_376);
	    return
	       ((((global_bglt) CREF(obj_581))->occurrence) = ((long) ((long) 0)), BUNSPEC);
	 }
      }
   }
}



/* method-init */
obj_t 
method_init_76_heap_make()
{
   AN_OBJECT;
   {	/* Heap/make.scm 14 */
      return BUNSPEC;
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_heap_make()
{
   AN_OBJECT;
   {	/* Heap/make.scm 14 */
      module_initialization_70_tools_speek(((long) 0), "HEAP_MAKE");
      module_initialization_70_tools_error(((long) 0), "HEAP_MAKE");
      module_initialization_70_engine_pass(((long) 0), "HEAP_MAKE");
      module_initialization_70_engine_param(((long) 0), "HEAP_MAKE");
      module_initialization_70_type_type(((long) 0), "HEAP_MAKE");
      module_initialization_70_type_env(((long) 0), "HEAP_MAKE");
      module_initialization_70_ast_var(((long) 0), "HEAP_MAKE");
      module_initialization_70_ast_env(((long) 0), "HEAP_MAKE");
      return
	 module_initialization_70_tools_shape(((long) 0), "HEAP_MAKE");
   }
}
