/*===========================================================================*/
/*   (Heap/restore.scm)                                                      */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;


extern obj_t unwind_until__178___bexit(obj_t, obj_t);
static obj_t escape_1338_heap_restore(obj_t, obj_t);
static obj_t body1197_heap_restore(obj_t);
static obj_t method_init_76_heap_restore();
static obj_t body1187_heap_restore(obj_t);
extern obj_t find_global_module_25_ast_env(obj_t, obj_t);
extern obj_t string_append(obj_t, obj_t);
extern obj_t exitd_top;
extern obj_t _nb_error_on_pass__70_tools_error;
static obj_t restore_additional_heap_154_heap_restore(obj_t);
extern obj_t find_file_path_55___os(obj_t, obj_t);
static obj_t unbind_call_cc__206_heap_restore();
static obj_t _restore_heap_238_heap_restore(obj_t);
static obj_t handling_function1290_heap_restore(obj_t, obj_t, obj_t, obj_t);
static obj_t handling_function1236_heap_restore(obj_t, obj_t, obj_t, obj_t);
extern obj_t verbose_tools_speek(obj_t, obj_t);
extern obj_t module_initialization_70_heap_restore(long, char *);
extern obj_t module_initialization_70_tools_speek(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_engine_pass(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_engine_engine(long, char *);
extern obj_t module_initialization_70_init_main(long, char *);
extern obj_t module_initialization_70_ast_env(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_env(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70___error(long, char *);
extern obj_t module_initialization_70___os(long, char *);
extern obj_t module_initialization_70___bexit(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_control_features_6_9(long, char *);
extern obj_t unbind_global__45_ast_env(obj_t, obj_t);
extern obj_t notify_error_43___error(obj_t, obj_t, obj_t);
static obj_t handler_1339_heap_restore(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t _heap_name__135_engine_param;
extern obj_t exit_bigloo_229_init_main(obj_t);
static obj_t imported_modules_init_94_heap_restore();
static obj_t rhandler1196_heap_restore(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t handler_heap_restore(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t _additional_include_foreign__44_engine_param;
static obj_t rhandler1186_heap_restore(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t append_2_18___r4_pairs_and_lists_6_3(obj_t, obj_t);
static obj_t library_modules_init_112_heap_restore();
extern obj_t add_genv__67_ast_env(obj_t);
extern obj_t input_obj(obj_t);
extern obj_t _call_cc___102_engine_param;
extern obj_t open_input_string(obj_t);
static obj_t _restore_additional_heaps_52_heap_restore(obj_t);
static obj_t _anonymous_1294__155_heap_restore(obj_t);
extern obj_t close_binary_port(obj_t);
static obj_t _anonymous_1293__185_heap_restore(obj_t);
extern obj_t _lib_dir__34_engine_param;
extern obj_t add_tenv__100_type_env(obj_t);
extern obj_t set_genv__34_ast_env(obj_t);
extern obj_t dynamic_wind_31___r4_control_features_6_9(obj_t, obj_t, obj_t);
static obj_t _anonymous_1240__5_heap_restore(obj_t);
static obj_t _anonymous_1239__60_heap_restore(obj_t);
extern obj_t internal_error_43_tools_error(obj_t, obj_t, obj_t);
extern obj_t open_input_binary_file(obj_t);
extern obj_t restore_additional_heaps_23_heap_restore();
extern obj_t remove_error_handler__102___error();
extern obj_t restore_heap_59_heap_restore();
extern obj_t read___reader(obj_t);
extern obj_t set_tenv__70_type_env(obj_t);
static obj_t escape_heap_restore(obj_t, obj_t);
extern obj_t add_error_handler__155___error(obj_t, obj_t);
static obj_t require_initialization_114_heap_restore = BUNSPEC;
extern obj_t _additional_heap_names__104_engine_param;
static obj_t cnst_init_137_heap_restore();
extern obj_t _current_pass__25_engine_pass;
static obj_t __cnst[4];

DEFINE_EXPORT_PROCEDURE(restore_heap_env_119_heap_restore, _restore_heap_238_heap_restore1357, _restore_heap_238_heap_restore, 0L, 0);
DEFINE_EXPORT_PROCEDURE(restore_additional_heaps_env_241_heap_restore, _restore_additional_heaps_52_heap_restore1358, _restore_additional_heaps_52_heap_restore, 0L, 0);
DEFINE_STRING(string1349_heap_restore, string1349_heap_restore1359, "restore-additional-heap", 23);
DEFINE_STRING(string1350_heap_restore, string1350_heap_restore1360, "CALL-WITH-CURRENT-CONTINUATION __R4_CONTROL_FEATURES_6_9 CALL/CC PASS-STARTED ", 78);
DEFINE_STRING(string1348_heap_restore, string1348_heap_restore1361, "Library", 7);
DEFINE_STRING(string1347_heap_restore, string1347_heap_restore1362, "restore-heap", 12);
DEFINE_STRING(string1346_heap_restore, string1346_heap_restore1363, "Cannot open heap file \"", 23);
DEFINE_STRING(string1345_heap_restore, string1345_heap_restore1364, "\"", 1);
DEFINE_STRING(string1344_heap_restore, string1344_heap_restore1365, "      [reading ", 15);
DEFINE_STRING(string1343_heap_restore, string1343_heap_restore1366, "]", 1);
DEFINE_STRING(string1342_heap_restore, string1342_heap_restore1367, "failure during prelude hook", 27);
DEFINE_STRING(string1341_heap_restore, string1341_heap_restore1368, "   . ", 5);
DEFINE_STRING(string1340_heap_restore, string1340_heap_restore1369, "Heap", 4);



/* module-initialization */
obj_t 
module_initialization_70_heap_restore(long checksum_724, char *from_725)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_heap_restore))
	{
	   require_initialization_114_heap_restore =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_heap_restore();
	   cnst_init_137_heap_restore();
	   imported_modules_init_94_heap_restore();
	   method_init_76_heap_restore();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_heap_restore()
{
   AN_OBJECT;
   {	/* Heap/restore.scm 14 */
      module_initialization_70___bexit(((long) 0), "HEAP_RESTORE");
      module_initialization_70___os(((long) 0), "HEAP_RESTORE");
      module_initialization_70___error(((long) 0), "HEAP_RESTORE");
      module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "HEAP_RESTORE");
      module_initialization_70___r4_control_features_6_9(((long) 0), "HEAP_RESTORE");
      module_initialization_70___reader(((long) 0), "HEAP_RESTORE");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_heap_restore()
{
   AN_OBJECT;
   {	/* Heap/restore.scm 14 */
      {		/* Heap/restore.scm 14 */
	 obj_t cnst_port_138_717;
	 cnst_port_138_717 =
	    open_input_string(string1350_heap_restore);
	 {
	    long i_718;
	    i_718 = ((long) 3);
	  loop_719:
	    {	/* Heap/restore.scm 14 */
	       bool_t test1351_720;
	       test1351_720 =
		  (i_718 == ((long) -1));
	       if (test1351_720)
		 {	/* Heap/restore.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Heap/restore.scm 14 */
		    {	/* Heap/restore.scm 14 */
		       obj_t arg1354_721;
		       {	/* Heap/restore.scm 14 */
			  obj_t list1355_722;
			  list1355_722 =
			     MAKE_PAIR(cnst_port_138_717, BNIL);
			  arg1354_721 =
			     read___reader(list1355_722);
		       }
		       CNST_TABLE_SET(i_718, arg1354_721);
		    }
		    {	/* Heap/restore.scm 14 */
		       int aux_723;
		       {	/* Heap/restore.scm 14 */
			  long aux_745;
			  aux_745 =
			     (i_718 - ((long) 1));
			  aux_723 =
			     (int) (aux_745);
		       }
		       {
			  long i_748;
			  i_748 =
			     (long) (aux_723);
			  i_718 = i_748;
			  goto loop_719;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* restore-heap */
obj_t 
restore_heap_59_heap_restore()
{
   AN_OBJECT;
   {	/* Heap/restore.scm 30 */
      {		/* Heap/restore.scm 31 */
	 bool_t test1203_306;
	 {	/* Heap/restore.scm 31 */
	    obj_t obj_586;
	    obj_586 = _heap_name__135_engine_param;
	    test1203_306 =
	       STRINGP(obj_586);
	 }
	 if (test1203_306)
	   {	/* Heap/restore.scm 31 */
	      {		/* Heap/restore.scm 33 */
		 obj_t list1204_307;
		 {	/* Heap/restore.scm 33 */
		    obj_t arg1207_309;
		    {	/* Heap/restore.scm 33 */
		       obj_t arg1212_311;
		       {	/* Heap/restore.scm 33 */
			  obj_t aux_752;
			  aux_752 =
			     BCHAR(((unsigned char) '\n'));
			  arg1212_311 =
			     MAKE_PAIR(aux_752, BNIL);
		       }
		       arg1207_309 =
			  MAKE_PAIR(string1340_heap_restore, arg1212_311);
		    }
		    list1204_307 =
		       MAKE_PAIR(string1341_heap_restore, arg1207_309);
		 }
		 verbose_tools_speek(
		    BINT(((long) 1)), list1204_307);
	      }
	      _nb_error_on_pass__70_tools_error =
		 BINT(((long) 0));
	      _current_pass__25_engine_pass = string1340_heap_restore;
	      {
		 obj_t hooks_312;
		 obj_t hnames_313;
		 hooks_312 = BNIL;
		 hnames_313 = BNIL;
	       loop_314:
		 if (
		    NULLP(hooks_312))
		   {	/* Heap/restore.scm 33 */
		      CNST_TABLE_REF(((long) 0));
		   }
		 else
		   {	/* Heap/restore.scm 33 */
		      bool_t test1217_319;
		      {		/* Heap/restore.scm 33 */
			 obj_t fun1227_325;
			 fun1227_325 =
			    CAR(hooks_312);
			 {	/* Heap/restore.scm 33 */
			    obj_t aux_764;
			    aux_764 =
			       PROCEDURE_ENTRY(fun1227_325) (fun1227_325, BEOA);
			    test1217_319 =
			       CBOOL(aux_764);
			 }
		      }
		      if (test1217_319)
			{	/* Heap/restore.scm 33 */
			   {
			      obj_t hnames_771;
			      obj_t hooks_769;
			      hooks_769 =
				 CDR(hooks_312);
			      hnames_771 =
				 CDR(hnames_313);
			      hnames_313 = hnames_771;
			      hooks_312 = hooks_769;
			      goto loop_314;
			   }
			}
		      else
			{	/* Heap/restore.scm 33 */
			   internal_error_43_tools_error(string1340_heap_restore, string1342_heap_restore,
			      CAR(hnames_313));
			}
		   }
	      }
	      {		/* Heap/restore.scm 34 */
		 obj_t fname_326;
		 fname_326 =
		    find_file_path_55___os(_heap_name__135_engine_param, _lib_dir__34_engine_param);
		 if (
		    STRINGP(fname_326))
		   {	/* Heap/restore.scm 36 */
		      obj_t port_328;
		      port_328 =
			 open_input_binary_file(fname_326);
		      {		/* Heap/restore.scm 37 */
			 obj_t handler_640;
			 handler_640 =
			    make_fx_procedure(handler_heap_restore, ((long) 4), ((long) 1));
			 PROCEDURE_SET(handler_640, ((long) 0), port_328);
			 {	/* Heap/restore.scm 37 */

			    if (
			       BINARY_PORTP(port_328))
			      {		/* Heap/restore.scm 41 */
				 {	/* Heap/restore.scm 49 */
				    obj_t list1230_331;
				    {	/* Heap/restore.scm 49 */
				       obj_t arg1232_333;
				       {	/* Heap/restore.scm 49 */
					  obj_t arg1233_334;
					  {	/* Heap/restore.scm 49 */
					     obj_t arg1235_336;
					     {	/* Heap/restore.scm 49 */
						obj_t aux_783;
						aux_783 =
						   BCHAR(((unsigned char) '\n'));
						arg1235_336 =
						   MAKE_PAIR(aux_783, BNIL);
					     }
					     arg1233_334 =
						MAKE_PAIR(string1343_heap_restore, arg1235_336);
					  }
					  arg1232_333 =
					     MAKE_PAIR(fname_326, arg1233_334);
				       }
				       list1230_331 =
					  MAKE_PAIR(string1344_heap_restore, arg1232_333);
				    }
				    verbose_tools_speek(
				       BINT(((long) 2)), list1230_331);
				 }
				 {	/* Heap/restore.scm 52 */
				    obj_t armed1188_337;
				    obj_t handler1185_338;
				    armed1188_337 =
				       MAKE_CELL(BUNSPEC);
				    handler1185_338 =
				       MAKE_CELL(BUNSPEC);
				    {	/* Heap/restore.scm 52 */
				       obj_t body1187_636;
				       obj_t rhandler1186_638;
				       body1187_636 =
					  make_fx_procedure(body1187_heap_restore, ((long) 0), ((long) 1));
				       rhandler1186_638 =
					  make_fx_procedure(rhandler1186_heap_restore, ((long) 4), ((long) 2));
				       PROCEDURE_SET(body1187_636, ((long) 0), port_328);
				       PROCEDURE_SET(rhandler1186_638, ((long) 0), armed1188_337);
				       PROCEDURE_SET(rhandler1186_638, ((long) 1), handler1185_338);
				       CELL_SET(handler1185_338, handler_640);
				       CELL_SET(armed1188_337, BTRUE);
				       return
					  handling_function1236_heap_restore(body1187_636, rhandler1186_638, handler1185_338, armed1188_337);
				    }
				 }
			      }
			    else
			      {		/* Heap/restore.scm 41 */
				 {	/* Heap/restore.scm 43 */
				    obj_t arg1245_365;
				    {	/* Heap/restore.scm 44 */
				       obj_t arg1248_367;
				       arg1248_367 =
					  string_append(fname_326, string1345_heap_restore);
				       arg1245_365 =
					  string_append(string1346_heap_restore, arg1248_367);
				    }
				    {	/* Heap/restore.scm 43 */
				       obj_t object_602;
				       object_602 = _lib_dir__34_engine_param;
				       FAILURE(string1347_heap_restore, arg1245_365, object_602);
				    }
				 }
				 return
				    exit_bigloo_229_init_main(
				    BINT(((long) -5)));
			      }
			 }
		      }
		   }
		 else
		   {	/* Heap/restore.scm 35 */
		      {		/* Heap/restore.scm 63 */
			 obj_t arg1251_375;
			 {	/* Heap/restore.scm 64 */
			    obj_t arg1253_377;
			    arg1253_377 =
			       string_append(_heap_name__135_engine_param, string1345_heap_restore);
			    arg1251_375 =
			       string_append(string1346_heap_restore, arg1253_377);
			 }
			 {	/* Heap/restore.scm 63 */
			    obj_t object_606;
			    object_606 = _lib_dir__34_engine_param;
			    FAILURE(string1347_heap_restore, arg1251_375, object_606);
			 }
		      }
		      return
			 exit_bigloo_229_init_main(
			 BINT(((long) -5)));
		   }
	      }
	   }
	 else
	   {	/* Heap/restore.scm 31 */
	      return BFALSE;
	   }
      }
   }
}



/* handling_function1236 */
obj_t 
handling_function1236_heap_restore(obj_t body1187_716, obj_t rhandler1186_715, obj_t handler1185_714, obj_t armed1188_713)
{
   AN_OBJECT;
   {	/* Heap/restore.scm 52 */
      jmp_buf jmpbuf;
      obj_t an_exit1189_342;
      if (SET_EXIT(an_exit1189_342))
	{
	   RESTORE_TRACE();
	   return
	      _exit_value_;
	}
      else
	{
	   an_exit1189_342 =
	      (obj_t) jmpbuf;
	   {	/* Heap/restore.scm 52 */

	      PUSH_EXIT(an_exit1189_342, ((bool_t) 1));
	      {		/* Heap/restore.scm 52 */
		 obj_t an_exitd1190_343;
		 an_exitd1190_343 = exitd_top;
		 {	/* Heap/restore.scm 52 */
		    obj_t escape_637;
		    escape_637 =
		       make_fx_procedure(escape_heap_restore, ((long) 1), ((long) 1));
		    PROCEDURE_SET(escape_637, ((long) 0), an_exitd1190_343);
		    {	/* Heap/restore.scm 52 */
		       obj_t res1192_346;
		       {	/* Heap/restore.scm 52 */
			  obj_t _anonymous_1240__5_635;
			  obj_t _anonymous_1239__60_639;
			  _anonymous_1240__5_635 =
			     make_fx_procedure(_anonymous_1240__5_heap_restore, ((long) 0), ((long) 1));
			  _anonymous_1239__60_639 =
			     make_fx_procedure(_anonymous_1239__60_heap_restore, ((long) 0), ((long) 5));
			  PROCEDURE_SET(_anonymous_1240__5_635, ((long) 0), armed1188_713);
			  PROCEDURE_SET(_anonymous_1239__60_639, ((long) 0), an_exitd1190_343);
			  PROCEDURE_SET(_anonymous_1239__60_639, ((long) 1), armed1188_713);
			  PROCEDURE_SET(_anonymous_1239__60_639, ((long) 2), handler1185_714);
			  PROCEDURE_SET(_anonymous_1239__60_639, ((long) 3), rhandler1186_715);
			  PROCEDURE_SET(_anonymous_1239__60_639, ((long) 4), escape_637);
			  res1192_346 =
			     dynamic_wind_31___r4_control_features_6_9(_anonymous_1239__60_639, body1187_716, _anonymous_1240__5_635);
		       }
		       POP_EXIT();
		       return res1192_346;
		    }
		 }
	      }
	   }
	}
   }
}



/* _restore-heap */
obj_t 
_restore_heap_238_heap_restore(obj_t env_641)
{
   AN_OBJECT;
   {	/* Heap/restore.scm 30 */
      return
	 restore_heap_59_heap_restore();
   }
}



/* <anonymous:1240> */
obj_t 
_anonymous_1240__5_heap_restore(obj_t env_642)
{
   AN_OBJECT;
   {	/* Heap/restore.scm 52 */
      {		/* Heap/restore.scm 52 */
	 obj_t armed1188_643;
	 armed1188_643 =
	    PROCEDURE_REF(env_642, ((long) 0));
	 {

	    {	/* Heap/restore.scm 52 */
	       bool_t test_824;
	       {	/* Heap/restore.scm 52 */
		  obj_t aux_825;
		  aux_825 =
		     CELL_REF(armed1188_643);
		  test_824 =
		     CBOOL(aux_825);
	       }
	       if (test_824)
		 {	/* Heap/restore.scm 52 */
		    CELL_SET(armed1188_643, BFALSE);
		    return
		       remove_error_handler__102___error();
		 }
	       else
		 {	/* Heap/restore.scm 52 */
		    return BUNSPEC;
		 }
	    }
	 }
      }
   }
}



/* body1187 */
obj_t 
body1187_heap_restore(obj_t env_645)
{
   AN_OBJECT;
   {	/* Heap/restore.scm 52 */
      {		/* Heap/restore.scm 52 */
	 obj_t port_646;
	 port_646 =
	    PROCEDURE_REF(env_645, ((long) 0));
	 {

	    {	/* Heap/restore.scm 52 */
	       bool_t aux_829;
	       {	/* Heap/restore.scm 52 */
		  obj_t envs_359;
		  envs_359 =
		     input_obj(port_646);
		  {	/* Heap/restore.scm 52 */
		     obj_t genv_360;
		     genv_360 =
			CAR(envs_359);
		     {	/* Heap/restore.scm 53 */
			obj_t tenv_361;
			tenv_361 =
			   CDR(envs_359);
			{	/* Heap/restore.scm 54 */

			   close_binary_port(port_646);
			   set_genv__34_ast_env(genv_360);
			   set_tenv__70_type_env(tenv_361);
			   if (
			      CBOOL(_call_cc___102_engine_param))
			     {	/* Heap/restore.scm 58 */
				BUNSPEC;
			     }
			   else
			     {	/* Heap/restore.scm 58 */
				unbind_call_cc__206_heap_restore();
			     }
			   aux_829 = ((bool_t) 1);
			}
		     }
		  }
	       }
	       return
		  BBOOL(aux_829);
	    }
	 }
      }
   }
}



/* <anonymous:1239> */
obj_t 
_anonymous_1239__60_heap_restore(obj_t env_647)
{
   AN_OBJECT;
   {	/* Heap/restore.scm 52 */
      {		/* Heap/restore.scm 52 */
	 obj_t rhandler1186_651;
	 obj_t escape_652;
	 rhandler1186_651 =
	    PROCEDURE_REF(env_647, ((long) 3));
	 escape_652 =
	    PROCEDURE_REF(env_647, ((long) 4));
	 {

	    return
	       add_error_handler__155___error(rhandler1186_651, escape_652);
	 }
      }
   }
}



/* escape */
obj_t 
escape_heap_restore(obj_t env_653, obj_t val1191_655)
{
   AN_OBJECT;
   {	/* Heap/restore.scm 52 */
      {		/* Heap/restore.scm 52 */
	 obj_t an_exitd1190_654;
	 an_exitd1190_654 =
	    PROCEDURE_REF(env_653, ((long) 0));
	 {
	    obj_t val1191_344;
	    val1191_344 = val1191_655;
	    return
	       unwind_until__178___bexit(an_exitd1190_654, val1191_344);
	 }
      }
   }
}



/* rhandler1186 */
obj_t 
rhandler1186_heap_restore(obj_t env_656, obj_t esc_659, obj_t obj_660, obj_t proc_661, obj_t msg_662)
{
   AN_OBJECT;
   {	/* Heap/restore.scm 52 */
      {		/* Heap/restore.scm 52 */
	 obj_t armed1188_657;
	 obj_t handler1185_658;
	 armed1188_657 =
	    PROCEDURE_REF(env_656, ((long) 0));
	 handler1185_658 =
	    PROCEDURE_REF(env_656, ((long) 1));
	 {
	    obj_t esc_353;
	    obj_t obj_354;
	    obj_t proc_355;
	    obj_t msg_356;
	    esc_353 = esc_659;
	    obj_354 = obj_660;
	    proc_355 = proc_661;
	    msg_356 = msg_662;
	    CELL_SET(armed1188_657, BFALSE);
	    remove_error_handler__102___error();
	    {	/* Heap/restore.scm 52 */
	       obj_t aux_849;
	       aux_849 =
		  CELL_REF(handler1185_658);
	       return
		  PROCEDURE_ENTRY(aux_849) (
		  CELL_REF(handler1185_658), esc_353, obj_354, proc_355, msg_356, BEOA);
	    }
	 }
      }
   }
}



/* handler */
obj_t 
handler_heap_restore(obj_t env_664, obj_t escape_666, obj_t proc_667, obj_t mes_668, obj_t obj_669)
{
   AN_OBJECT;
   {	/* Heap/restore.scm 37 */
      {		/* Heap/restore.scm 37 */
	 obj_t port_665;
	 port_665 =
	    PROCEDURE_REF(env_664, ((long) 0));
	 {
	    obj_t escape_368;
	    obj_t proc_369;
	    obj_t mes_370;
	    obj_t obj_371;
	    escape_368 = escape_666;
	    proc_369 = proc_667;
	    mes_370 = mes_668;
	    obj_371 = obj_669;
	    notify_error_43___error(proc_369, mes_370, obj_371);
	    close_binary_port(port_665);
	    return
	       exit_bigloo_229_init_main(
	       BINT(((long) -5)));
	 }
      }
   }
}



/* unbind-call/cc! */
obj_t 
unbind_call_cc__206_heap_restore()
{
   AN_OBJECT;
   {	/* Heap/restore.scm 73 */
      {		/* Heap/restore.scm 74 */
	 bool_t test1254_378;
	 {	/* Heap/restore.scm 74 */
	    obj_t aux_855;
	    aux_855 =
	       find_global_module_25_ast_env(
	       CNST_TABLE_REF(((long) 1)),
	       CNST_TABLE_REF(((long) 2)));
	    test1254_378 =
	       CBOOL(aux_855);
	 }
	 if (test1254_378)
	   {	/* Heap/restore.scm 74 */
	      unbind_global__45_ast_env(
		 CNST_TABLE_REF(((long) 1)),
		 CNST_TABLE_REF(((long) 2)));
	   }
	 else
	   {	/* Heap/restore.scm 74 */
	      BUNSPEC;
	   }
      }
      {		/* Heap/restore.scm 76 */
	 bool_t test1255_379;
	 {	/* Heap/restore.scm 76 */
	    obj_t aux_864;
	    aux_864 =
	       find_global_module_25_ast_env(
	       CNST_TABLE_REF(((long) 3)),
	       CNST_TABLE_REF(((long) 2)));
	    test1255_379 =
	       CBOOL(aux_864);
	 }
	 if (test1255_379)
	   {	/* Heap/restore.scm 76 */
	      return
		 unbind_global__45_ast_env(
		 CNST_TABLE_REF(((long) 3)),
		 CNST_TABLE_REF(((long) 2)));
	   }
	 else
	   {	/* Heap/restore.scm 76 */
	      return BUNSPEC;
	   }
      }
   }
}



/* restore-additional-heaps */
obj_t 
restore_additional_heaps_23_heap_restore()
{
   AN_OBJECT;
   {	/* Heap/restore.scm 84 */
      {		/* Heap/restore.scm 85 */
	 bool_t test1256_380;
	 {	/* Heap/restore.scm 85 */
	    obj_t obj_607;
	    obj_607 = _additional_heap_names__104_engine_param;
	    test1256_380 =
	       PAIRP(obj_607);
	 }
	 if (test1256_380)
	   {	/* Heap/restore.scm 85 */
	      {		/* Heap/restore.scm 87 */
		 obj_t list1257_381;
		 {	/* Heap/restore.scm 87 */
		    obj_t arg1259_383;
		    {	/* Heap/restore.scm 87 */
		       obj_t arg1261_385;
		       {	/* Heap/restore.scm 87 */
			  obj_t aux_875;
			  aux_875 =
			     BCHAR(((unsigned char) '\n'));
			  arg1261_385 =
			     MAKE_PAIR(aux_875, BNIL);
		       }
		       arg1259_383 =
			  MAKE_PAIR(string1348_heap_restore, arg1261_385);
		    }
		    list1257_381 =
		       MAKE_PAIR(string1341_heap_restore, arg1259_383);
		 }
		 verbose_tools_speek(
		    BINT(((long) 1)), list1257_381);
	      }
	      _nb_error_on_pass__70_tools_error =
		 BINT(((long) 0));
	      _current_pass__25_engine_pass = string1348_heap_restore;
	      {
		 obj_t hooks_386;
		 obj_t hnames_387;
		 hooks_386 = BNIL;
		 hnames_387 = BNIL;
	       loop_388:
		 if (
		    NULLP(hooks_386))
		   {	/* Heap/restore.scm 87 */
		      CNST_TABLE_REF(((long) 0));
		   }
		 else
		   {	/* Heap/restore.scm 87 */
		      bool_t test1267_393;
		      {		/* Heap/restore.scm 87 */
			 obj_t fun1273_399;
			 fun1273_399 =
			    CAR(hooks_386);
			 {	/* Heap/restore.scm 87 */
			    obj_t aux_887;
			    aux_887 =
			       PROCEDURE_ENTRY(fun1273_399) (fun1273_399, BEOA);
			    test1267_393 =
			       CBOOL(aux_887);
			 }
		      }
		      if (test1267_393)
			{	/* Heap/restore.scm 87 */
			   {
			      obj_t hnames_894;
			      obj_t hooks_892;
			      hooks_892 =
				 CDR(hooks_386);
			      hnames_894 =
				 CDR(hnames_387);
			      hnames_387 = hnames_894;
			      hooks_386 = hooks_892;
			      goto loop_388;
			   }
			}
		      else
			{	/* Heap/restore.scm 87 */
			   internal_error_43_tools_error(string1348_heap_restore, string1342_heap_restore,
			      CAR(hnames_387));
			}
		   }
	      }
	      {
		 obj_t l1193_400;
		 {	/* Heap/restore.scm 88 */
		    bool_t aux_898;
		    l1193_400 = _additional_heap_names__104_engine_param;
		  lname1194_401:
		    if (
		       PAIRP(l1193_400))
		      {		/* Heap/restore.scm 88 */
			 restore_additional_heap_154_heap_restore(
			    CAR(l1193_400));
			 {
			    obj_t l1193_903;
			    l1193_903 =
			       CDR(l1193_400);
			    l1193_400 = l1193_903;
			    goto lname1194_401;
			 }
		      }
		    else
		      {		/* Heap/restore.scm 88 */
			 aux_898 = ((bool_t) 1);
		      }
		    return
		       BBOOL(aux_898);
		 }
	      }
	   }
	 else
	   {	/* Heap/restore.scm 85 */
	      return BUNSPEC;
	   }
      }
   }
}



/* _restore-additional-heaps */
obj_t 
_restore_additional_heaps_52_heap_restore(obj_t env_672)
{
   AN_OBJECT;
   {	/* Heap/restore.scm 84 */
      return
	 restore_additional_heaps_23_heap_restore();
   }
}



/* restore-additional-heap */
obj_t 
restore_additional_heap_154_heap_restore(obj_t heap_1)
{
   AN_OBJECT;
   {	/* Heap/restore.scm 93 */
      {		/* Heap/restore.scm 94 */
	 obj_t fname_405;
	 fname_405 =
	    find_file_path_55___os(heap_1, _lib_dir__34_engine_param);
	 if (
	    STRINGP(fname_405))
	   {	/* Heap/restore.scm 96 */
	      obj_t port_407;
	      port_407 =
		 open_input_binary_file(fname_405);
	      {		/* Heap/restore.scm 97 */
		 obj_t handler_678;
		 handler_678 =
		    make_fx_procedure(handler_1339_heap_restore, ((long) 4), ((long) 1));
		 PROCEDURE_SET(handler_678, ((long) 0), port_407);
		 {	/* Heap/restore.scm 97 */

		    if (
		       BINARY_PORTP(port_407))
		      {		/* Heap/restore.scm 101 */
			 {	/* Heap/restore.scm 109 */
			    obj_t list1280_410;
			    {	/* Heap/restore.scm 109 */
			       obj_t arg1282_412;
			       {	/* Heap/restore.scm 109 */
				  obj_t arg1286_413;
				  {	/* Heap/restore.scm 109 */
				     obj_t arg1289_415;
				     {	/* Heap/restore.scm 109 */
					obj_t aux_915;
					aux_915 =
					   BCHAR(((unsigned char) '\n'));
					arg1289_415 =
					   MAKE_PAIR(aux_915, BNIL);
				     }
				     arg1286_413 =
					MAKE_PAIR(string1343_heap_restore, arg1289_415);
				  }
				  arg1282_412 =
				     MAKE_PAIR(fname_405, arg1286_413);
			       }
			       list1280_410 =
				  MAKE_PAIR(string1344_heap_restore, arg1282_412);
			    }
			    verbose_tools_speek(
			       BINT(((long) 2)), list1280_410);
			 }
			 {	/* Heap/restore.scm 112 */
			    obj_t armed1198_416;
			    obj_t handler1195_417;
			    armed1198_416 =
			       MAKE_CELL(BUNSPEC);
			    handler1195_417 =
			       MAKE_CELL(BUNSPEC);
			    {	/* Heap/restore.scm 112 */
			       obj_t body1197_674;
			       obj_t rhandler1196_676;
			       body1197_674 =
				  make_fx_procedure(body1197_heap_restore, ((long) 0), ((long) 1));
			       rhandler1196_676 =
				  make_fx_procedure(rhandler1196_heap_restore, ((long) 4), ((long) 2));
			       PROCEDURE_SET(body1197_674, ((long) 0), port_407);
			       PROCEDURE_SET(rhandler1196_676, ((long) 0), armed1198_416);
			       PROCEDURE_SET(rhandler1196_676, ((long) 1), handler1195_417);
			       CELL_SET(handler1195_417, handler_678);
			       CELL_SET(armed1198_416, BTRUE);
			       return
				  handling_function1290_heap_restore(body1197_674, rhandler1196_676, handler1195_417, armed1198_416);
			    }
			 }
		      }
		    else
		      {		/* Heap/restore.scm 101 */
			 {	/* Heap/restore.scm 103 */
			    obj_t arg1298_445;
			    {	/* Heap/restore.scm 104 */
			       obj_t arg1300_447;
			       arg1300_447 =
				  string_append(fname_405, string1345_heap_restore);
			       arg1298_445 =
				  string_append(string1346_heap_restore, arg1300_447);
			    }
			    {	/* Heap/restore.scm 103 */
			       obj_t object_630;
			       object_630 = _lib_dir__34_engine_param;
			       FAILURE(string1349_heap_restore, arg1298_445, object_630);
			    }
			 }
			 return
			    exit_bigloo_229_init_main(
			    BINT(((long) -6)));
		      }
		 }
	      }
	   }
	 else
	   {	/* Heap/restore.scm 95 */
	      {		/* Heap/restore.scm 125 */
		 obj_t arg1303_455;
		 {	/* Heap/restore.scm 126 */
		    obj_t arg1305_457;
		    arg1305_457 =
		       string_append(heap_1, string1345_heap_restore);
		    arg1303_455 =
		       string_append(string1346_heap_restore, arg1305_457);
		 }
		 {	/* Heap/restore.scm 125 */
		    obj_t object_634;
		    object_634 = _lib_dir__34_engine_param;
		    FAILURE(string1349_heap_restore, arg1303_455, object_634);
		 }
	      }
	      return
		 exit_bigloo_229_init_main(
		 BINT(((long) -6)));
	   }
      }
   }
}



/* handling_function1290 */
obj_t 
handling_function1290_heap_restore(obj_t body1197_712, obj_t rhandler1196_711, obj_t handler1195_710, obj_t armed1198_709)
{
   AN_OBJECT;
   {	/* Heap/restore.scm 112 */
      jmp_buf jmpbuf;
      obj_t an_exit1199_421;
      if (SET_EXIT(an_exit1199_421))
	{
	   RESTORE_TRACE();
	   return
	      _exit_value_;
	}
      else
	{
	   an_exit1199_421 =
	      (obj_t) jmpbuf;
	   {	/* Heap/restore.scm 112 */

	      PUSH_EXIT(an_exit1199_421, ((bool_t) 1));
	      {		/* Heap/restore.scm 112 */
		 obj_t an_exitd1200_422;
		 an_exitd1200_422 = exitd_top;
		 {	/* Heap/restore.scm 112 */
		    obj_t escape_675;
		    escape_675 =
		       make_fx_procedure(escape_1338_heap_restore, ((long) 1), ((long) 1));
		    PROCEDURE_SET(escape_675, ((long) 0), an_exitd1200_422);
		    {	/* Heap/restore.scm 112 */
		       obj_t res1202_425;
		       {	/* Heap/restore.scm 112 */
			  obj_t _anonymous_1294__155_673;
			  obj_t _anonymous_1293__185_677;
			  _anonymous_1294__155_673 =
			     make_fx_procedure(_anonymous_1294__155_heap_restore, ((long) 0), ((long) 1));
			  _anonymous_1293__185_677 =
			     make_fx_procedure(_anonymous_1293__185_heap_restore, ((long) 0), ((long) 5));
			  PROCEDURE_SET(_anonymous_1294__155_673, ((long) 0), armed1198_709);
			  PROCEDURE_SET(_anonymous_1293__185_677, ((long) 0), an_exitd1200_422);
			  PROCEDURE_SET(_anonymous_1293__185_677, ((long) 1), armed1198_709);
			  PROCEDURE_SET(_anonymous_1293__185_677, ((long) 2), handler1195_710);
			  PROCEDURE_SET(_anonymous_1293__185_677, ((long) 3), rhandler1196_711);
			  PROCEDURE_SET(_anonymous_1293__185_677, ((long) 4), escape_675);
			  res1202_425 =
			     dynamic_wind_31___r4_control_features_6_9(_anonymous_1293__185_677, body1197_712, _anonymous_1294__155_673);
		       }
		       POP_EXIT();
		       return res1202_425;
		    }
		 }
	      }
	   }
	}
   }
}



/* <anonymous:1294> */
obj_t 
_anonymous_1294__155_heap_restore(obj_t env_679)
{
   AN_OBJECT;
   {	/* Heap/restore.scm 112 */
      {		/* Heap/restore.scm 112 */
	 obj_t armed1198_680;
	 armed1198_680 =
	    PROCEDURE_REF(env_679, ((long) 0));
	 {

	    {	/* Heap/restore.scm 112 */
	       bool_t test_955;
	       {	/* Heap/restore.scm 112 */
		  obj_t aux_956;
		  aux_956 =
		     CELL_REF(armed1198_680);
		  test_955 =
		     CBOOL(aux_956);
	       }
	       if (test_955)
		 {	/* Heap/restore.scm 112 */
		    CELL_SET(armed1198_680, BFALSE);
		    return
		       remove_error_handler__102___error();
		 }
	       else
		 {	/* Heap/restore.scm 112 */
		    return BUNSPEC;
		 }
	    }
	 }
      }
   }
}



/* body1197 */
obj_t 
body1197_heap_restore(obj_t env_682)
{
   AN_OBJECT;
   {	/* Heap/restore.scm 112 */
      {		/* Heap/restore.scm 112 */
	 obj_t port_683;
	 port_683 =
	    PROCEDURE_REF(env_682, ((long) 0));
	 {

	    {	/* Heap/restore.scm 112 */
	       bool_t aux_960;
	       {	/* Heap/restore.scm 112 */
		  obj_t envs_438;
		  envs_438 =
		     input_obj(port_683);
		  {	/* Heap/restore.scm 112 */
		     obj_t genv_439;
		     genv_439 =
			VECTOR_REF(envs_438, ((long) 0));
		     {	/* Heap/restore.scm 113 */
			obj_t tenv_440;
			tenv_440 =
			   VECTOR_REF(envs_438, ((long) 1));
			{	/* Heap/restore.scm 114 */
			   obj_t includes_441;
			   includes_441 =
			      VECTOR_REF(envs_438, ((long) 2));
			   {	/* Heap/restore.scm 115 */

			      close_binary_port(port_683);
			      add_tenv__100_type_env(tenv_440);
			      add_genv__67_ast_env(genv_439);
			      _additional_include_foreign__44_engine_param =
				 append_2_18___r4_pairs_and_lists_6_3(_additional_include_foreign__44_engine_param, includes_441);
			      aux_960 = ((bool_t) 1);
			   }
			}
		     }
		  }
	       }
	       return
		  BBOOL(aux_960);
	    }
	 }
      }
   }
}



/* <anonymous:1293> */
obj_t 
_anonymous_1293__185_heap_restore(obj_t env_684)
{
   AN_OBJECT;
   {	/* Heap/restore.scm 112 */
      {		/* Heap/restore.scm 112 */
	 obj_t rhandler1196_688;
	 obj_t escape_689;
	 rhandler1196_688 =
	    PROCEDURE_REF(env_684, ((long) 3));
	 escape_689 =
	    PROCEDURE_REF(env_684, ((long) 4));
	 {

	    return
	       add_error_handler__155___error(rhandler1196_688, escape_689);
	 }
      }
   }
}



/* escape_1338 */
obj_t 
escape_1338_heap_restore(obj_t env_690, obj_t val1201_692)
{
   AN_OBJECT;
   {	/* Heap/restore.scm 112 */
      {		/* Heap/restore.scm 112 */
	 obj_t an_exitd1200_691;
	 an_exitd1200_691 =
	    PROCEDURE_REF(env_690, ((long) 0));
	 {
	    obj_t val1201_423;
	    val1201_423 = val1201_692;
	    return
	       unwind_until__178___bexit(an_exitd1200_691, val1201_423);
	 }
      }
   }
}



/* rhandler1196 */
obj_t 
rhandler1196_heap_restore(obj_t env_693, obj_t esc_696, obj_t obj_697, obj_t proc_698, obj_t msg_699)
{
   AN_OBJECT;
   {	/* Heap/restore.scm 112 */
      {		/* Heap/restore.scm 112 */
	 obj_t armed1198_694;
	 obj_t handler1195_695;
	 armed1198_694 =
	    PROCEDURE_REF(env_693, ((long) 0));
	 handler1195_695 =
	    PROCEDURE_REF(env_693, ((long) 1));
	 {
	    obj_t esc_432;
	    obj_t obj_433;
	    obj_t proc_434;
	    obj_t msg_435;
	    esc_432 = esc_696;
	    obj_433 = obj_697;
	    proc_434 = proc_698;
	    msg_435 = msg_699;
	    CELL_SET(armed1198_694, BFALSE);
	    remove_error_handler__102___error();
	    {	/* Heap/restore.scm 112 */
	       obj_t aux_979;
	       aux_979 =
		  CELL_REF(handler1195_695);
	       return
		  PROCEDURE_ENTRY(aux_979) (
		  CELL_REF(handler1195_695), esc_432, obj_433, proc_434, msg_435, BEOA);
	    }
	 }
      }
   }
}



/* handler_1339 */
obj_t 
handler_1339_heap_restore(obj_t env_701, obj_t escape_703, obj_t proc_704, obj_t mes_705, obj_t obj_706)
{
   AN_OBJECT;
   {	/* Heap/restore.scm 97 */
      {		/* Heap/restore.scm 97 */
	 obj_t port_702;
	 port_702 =
	    PROCEDURE_REF(env_701, ((long) 0));
	 {
	    obj_t escape_448;
	    obj_t proc_449;
	    obj_t mes_450;
	    obj_t obj_451;
	    escape_448 = escape_703;
	    proc_449 = proc_704;
	    mes_450 = mes_705;
	    obj_451 = obj_706;
	    notify_error_43___error(proc_449, mes_450, obj_451);
	    close_binary_port(port_702);
	    return
	       exit_bigloo_229_init_main(
	       BINT(((long) -6)));
	 }
      }
   }
}



/* method-init */
obj_t 
method_init_76_heap_restore()
{
   AN_OBJECT;
   {	/* Heap/restore.scm 14 */
      return BUNSPEC;
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_heap_restore()
{
   AN_OBJECT;
   {	/* Heap/restore.scm 14 */
      module_initialization_70_tools_speek(((long) 0), "HEAP_RESTORE");
      module_initialization_70_tools_error(((long) 0), "HEAP_RESTORE");
      module_initialization_70_engine_pass(((long) 0), "HEAP_RESTORE");
      module_initialization_70_engine_param(((long) 0), "HEAP_RESTORE");
      module_initialization_70_engine_engine(((long) 0), "HEAP_RESTORE");
      module_initialization_70_init_main(((long) 0), "HEAP_RESTORE");
      module_initialization_70_ast_env(((long) 0), "HEAP_RESTORE");
      module_initialization_70_type_type(((long) 0), "HEAP_RESTORE");
      module_initialization_70_type_env(((long) 0), "HEAP_RESTORE");
      return
	 module_initialization_70_ast_var(((long) 0), "HEAP_RESTORE");
   }
}
