/*===========================================================================*/
/*   (Hgen/walk.scm)                                                         */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct tclass
  {
     obj_t its_super_214;
     obj_t slots;
     struct global *holder;
     obj_t widening;
     long depth;
     bool_t final__12;
     obj_t constructor;
     obj_t virtual_slots_number_200;
  }
      *tclass_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;


static obj_t method_init_76_hgen_walk();
extern obj_t _nb_error_on_pass__70_tools_error;
extern obj_t _c_port__188_cgen_emit;
extern obj_t stop_emission__231_cgen_emit();
extern obj_t verbose_tools_speek(obj_t, obj_t);
extern obj_t module_initialization_70_hgen_walk(long, char *);
extern obj_t module_initialization_70_tools_speek(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_engine_pass(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_object_class(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_cgen_emit(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
static obj_t _anonymous_1476__74_hgen_walk(obj_t);
static obj_t imported_modules_init_94_hgen_walk();
extern obj_t emit_header_99_cgen_emit();
extern obj_t hgen_walk_202_hgen_walk();
static obj_t library_modules_init_112_hgen_walk();
extern obj_t start_emission__101_cgen_emit(obj_t);
extern obj_t open_input_string(obj_t);
extern obj_t internal_error_43_tools_error(obj_t, obj_t, obj_t);
static obj_t _hgen_walk_236_hgen_walk(obj_t);
extern obj_t read___reader(obj_t);
extern obj_t emit_class_types_26_object_class(obj_t);
static obj_t require_initialization_114_hgen_walk = BUNSPEC;
static obj_t cnst_init_137_hgen_walk();
extern obj_t _current_pass__25_engine_pass;
static obj_t __cnst[2];

DEFINE_STATIC_PROCEDURE(proc1573_hgen_walk, _anonymous_1476__74_hgen_walk1580, _anonymous_1476__74_hgen_walk, 0L, 0);
DEFINE_EXPORT_PROCEDURE(hgen_walk_env_69_hgen_walk, _hgen_walk_236_hgen_walk1581, _hgen_walk_236_hgen_walk, 0L, 0);
DEFINE_STRING(string1575_hgen_walk, string1575_hgen_walk1582, "((LAMBDA () (START-EMISSION! \".h\"))) PASS-STARTED ", 50);
DEFINE_STRING(string1574_hgen_walk, string1574_hgen_walk1583, ".h", 2);
DEFINE_STRING(string1572_hgen_walk, string1572_hgen_walk1584, "failure during prelude hook", 27);
DEFINE_STRING(string1571_hgen_walk, string1571_hgen_walk1585, "   . ", 5);
DEFINE_STRING(string1570_hgen_walk, string1570_hgen_walk1586, "C headers generation", 20);



/* module-initialization */
obj_t 
module_initialization_70_hgen_walk(long checksum_1184, char *from_1185)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_hgen_walk))
	{
	   require_initialization_114_hgen_walk =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_hgen_walk();
	   cnst_init_137_hgen_walk();
	   imported_modules_init_94_hgen_walk();
	   method_init_76_hgen_walk();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_hgen_walk()
{
   AN_OBJECT;
   {	/* Hgen/walk.scm 14 */
      module_initialization_70___reader(((long) 0), "HGEN_WALK");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_hgen_walk()
{
   AN_OBJECT;
   {	/* Hgen/walk.scm 14 */
      {		/* Hgen/walk.scm 14 */
	 obj_t cnst_port_138_1177;
	 cnst_port_138_1177 =
	    open_input_string(string1575_hgen_walk);
	 {
	    long i_1178;
	    i_1178 = ((long) 1);
	  loop_1179:
	    {	/* Hgen/walk.scm 14 */
	       bool_t test1576_1180;
	       test1576_1180 =
		  (i_1178 == ((long) -1));
	       if (test1576_1180)
		 {	/* Hgen/walk.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Hgen/walk.scm 14 */
		    {	/* Hgen/walk.scm 14 */
		       obj_t arg1577_1181;
		       {	/* Hgen/walk.scm 14 */
			  obj_t list1578_1182;
			  list1578_1182 =
			     MAKE_PAIR(cnst_port_138_1177, BNIL);
			  arg1577_1181 =
			     read___reader(list1578_1182);
		       }
		       CNST_TABLE_SET(i_1178, arg1577_1181);
		    }
		    {	/* Hgen/walk.scm 14 */
		       int aux_1183;
		       {	/* Hgen/walk.scm 14 */
			  long aux_1200;
			  aux_1200 =
			     (i_1178 - ((long) 1));
			  aux_1183 =
			     (int) (aux_1200);
		       }
		       {
			  long i_1203;
			  i_1203 =
			     (long) (aux_1183);
			  i_1178 = i_1203;
			  goto loop_1179;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* hgen-walk */
obj_t 
hgen_walk_202_hgen_walk()
{
   AN_OBJECT;
   {	/* Hgen/walk.scm 27 */
      {		/* Hgen/walk.scm 27 */
	 obj_t list1466_779;
	 {	/* Hgen/walk.scm 27 */
	    obj_t arg1469_781;
	    {	/* Hgen/walk.scm 27 */
	       obj_t arg1471_783;
	       {	/* Hgen/walk.scm 27 */
		  obj_t aux_1205;
		  aux_1205 =
		     BCHAR(((unsigned char) '\n'));
		  arg1471_783 =
		     MAKE_PAIR(aux_1205, BNIL);
	       }
	       arg1469_781 =
		  MAKE_PAIR(string1570_hgen_walk, arg1471_783);
	    }
	    list1466_779 =
	       MAKE_PAIR(string1571_hgen_walk, arg1469_781);
	 }
	 verbose_tools_speek(
	    BINT(((long) 1)), list1466_779);
      }
      _nb_error_on_pass__70_tools_error =
	 BINT(((long) 0));
      _current_pass__25_engine_pass = string1570_hgen_walk;
      {
	 obj_t hooks_784;
	 obj_t hnames_785;
	 {	/* Hgen/walk.scm 28 */
	    obj_t arg1472_787;
	    obj_t arg1473_788;
	    {	/* Hgen/walk.scm 28 */
	       obj_t _anonymous_1476__74_1174;
	       _anonymous_1476__74_1174 = proc1573_hgen_walk;
	       {	/* Hgen/walk.scm 27 */
		  obj_t list1475_790;
		  list1475_790 =
		     MAKE_PAIR(_anonymous_1476__74_1174, BNIL);
		  arg1472_787 = list1475_790;
	       }
	    }
	    arg1473_788 =
	       CNST_TABLE_REF(((long) 1));
	    hooks_784 = arg1472_787;
	    hnames_785 = arg1473_788;
	  loop_786:
	    if (
	       NULLP(hooks_784))
	      {		/* Hgen/walk.scm 27 */
		 CNST_TABLE_REF(((long) 0));
	      }
	    else
	      {		/* Hgen/walk.scm 27 */
		 bool_t test1478_794;
		 {	/* Hgen/walk.scm 27 */
		    obj_t fun1487_800;
		    fun1487_800 =
		       CAR(hooks_784);
		    {	/* Hgen/walk.scm 27 */
		       obj_t aux_1219;
		       aux_1219 =
			  PROCEDURE_ENTRY(fun1487_800) (fun1487_800, BEOA);
		       test1478_794 =
			  CBOOL(aux_1219);
		    }
		 }
		 if (test1478_794)
		   {	/* Hgen/walk.scm 27 */
		      {
			 obj_t hnames_1226;
			 obj_t hooks_1224;
			 hooks_1224 =
			    CDR(hooks_784);
			 hnames_1226 =
			    CDR(hnames_785);
			 hnames_785 = hnames_1226;
			 hooks_784 = hooks_1224;
			 goto loop_786;
		      }
		   }
		 else
		   {	/* Hgen/walk.scm 27 */
		      internal_error_43_tools_error(string1570_hgen_walk, string1572_hgen_walk,
			 CAR(hnames_785));
		   }
	      }
	 }
      }
      emit_header_99_cgen_emit();
      emit_class_types_26_object_class(_c_port__188_cgen_emit);
      return
	 stop_emission__231_cgen_emit();
   }
}



/* _hgen-walk */
obj_t 
_hgen_walk_236_hgen_walk(obj_t env_1175)
{
   AN_OBJECT;
   {	/* Hgen/walk.scm 27 */
      return
	 hgen_walk_202_hgen_walk();
   }
}



/* <anonymous:1476> */
obj_t 
_anonymous_1476__74_hgen_walk(obj_t env_1176)
{
   AN_OBJECT;
   {	/* Hgen/walk.scm 28 */
      {

	 return
	    start_emission__101_cgen_emit(string1574_hgen_walk);
      }
   }
}



/* method-init */
obj_t 
method_init_76_hgen_walk()
{
   AN_OBJECT;
   {	/* Hgen/walk.scm 14 */
      return BUNSPEC;
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_hgen_walk()
{
   AN_OBJECT;
   {	/* Hgen/walk.scm 14 */
      module_initialization_70_tools_speek(((long) 0), "HGEN_WALK");
      module_initialization_70_tools_error(((long) 0), "HGEN_WALK");
      module_initialization_70_engine_pass(((long) 0), "HGEN_WALK");
      module_initialization_70_type_type(((long) 0), "HGEN_WALK");
      module_initialization_70_object_class(((long) 0), "HGEN_WALK");
      module_initialization_70_ast_var(((long) 0), "HGEN_WALK");
      module_initialization_70_ast_node(((long) 0), "HGEN_WALK");
      return
	 module_initialization_70_cgen_emit(((long) 0), "HGEN_WALK");
   }
}
