/*===========================================================================*/
/*   (Inline/app.scm)                                                        */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;

typedef struct isfun
  {
     struct node *original_body_40;
     obj_t recursive_calls_44;
  }
     *isfun_bglt;


extern long node_size_119_inline_size(node_bglt);
static obj_t method_init_76_inline_app();
extern obj_t _optim_unroll_loop___80_engine_param;
extern node_bglt inline_app_recursive_121_inline_recursion(node_bglt, long, obj_t);
extern obj_t global_ast_var;
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t module_initialization_70_inline_app(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_inline_walk(long, char *);
extern obj_t module_initialization_70_inline_inline(long, char *);
extern obj_t module_initialization_70_inline_size(long, char *);
extern obj_t module_initialization_70_inline_simple(long, char *);
extern obj_t module_initialization_70_inline_recursion(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern node_bglt inline_app_72_inline_app(app_bglt, long, obj_t);
extern long list_length(obj_t);
extern node_bglt inline_app_simple_198_inline_simple(node_bglt, long, obj_t, obj_t);
static obj_t imported_modules_init_94_inline_app();
static obj_t library_modules_init_112_inline_app();
extern obj_t _inlining___224_engine_param;
extern obj_t open_input_string(obj_t);
extern obj_t sfun_ast_var;
static obj_t _inline_app_253_inline_app(obj_t, obj_t, obj_t, obj_t);
extern obj_t _non_inlined_calls__201_inline_walk;
extern bool_t is_recursive__125_inline_recursion(variable_bglt);
extern obj_t isfun_inline_inline;
static obj_t _inline_app__45_inline_app(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t memq___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern obj_t _optim_loop_inlining___30_engine_param;
extern bool_t inline_app__99_inline_app(variable_bglt, long, long, obj_t);
extern obj_t read___reader(obj_t);
extern obj_t _inlined_calls__118_inline_walk;
static obj_t require_initialization_114_inline_app = BUNSPEC;
static obj_t cnst_init_137_inline_app();
static obj_t __cnst[3];

DEFINE_EXPORT_PROCEDURE(inline_app_env_13_inline_app, _inline_app_253_inline_app1579, _inline_app_253_inline_app, 0L, 3);
DEFINE_EXPORT_PROCEDURE(inline_app__env_184_inline_app, _inline_app__45_inline_app1580, _inline_app__45_inline_app, 0L, 4);
DEFINE_STRING(string1574_inline_app, string1574_inline_app1581, "IMPORT SNIFUN SIFUN ", 20);
DEFINE_STRING(string1573_inline_app, string1573_inline_app1582, "simple", 6);



/* module-initialization */
obj_t 
module_initialization_70_inline_app(long checksum_1202, char *from_1203)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_inline_app))
	{
	   require_initialization_114_inline_app =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_inline_app();
	   cnst_init_137_inline_app();
	   imported_modules_init_94_inline_app();
	   method_init_76_inline_app();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_inline_app()
{
   AN_OBJECT;
   {	/* Inline/app.scm 14 */
      module_initialization_70___object(((long) 0), "INLINE_APP");
      module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "INLINE_APP");
      module_initialization_70___reader(((long) 0), "INLINE_APP");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_inline_app()
{
   AN_OBJECT;
   {	/* Inline/app.scm 14 */
      {		/* Inline/app.scm 14 */
	 obj_t cnst_port_138_1195;
	 cnst_port_138_1195 =
	    open_input_string(string1574_inline_app);
	 {
	    long i_1196;
	    i_1196 = ((long) 2);
	  loop_1197:
	    {	/* Inline/app.scm 14 */
	       bool_t test1575_1198;
	       test1575_1198 =
		  (i_1196 == ((long) -1));
	       if (test1575_1198)
		 {	/* Inline/app.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Inline/app.scm 14 */
		    {	/* Inline/app.scm 14 */
		       obj_t arg1576_1199;
		       {	/* Inline/app.scm 14 */
			  obj_t list1577_1200;
			  list1577_1200 =
			     MAKE_PAIR(cnst_port_138_1195, BNIL);
			  arg1576_1199 =
			     read___reader(list1577_1200);
		       }
		       CNST_TABLE_SET(i_1196, arg1576_1199);
		    }
		    {	/* Inline/app.scm 14 */
		       int aux_1201;
		       {	/* Inline/app.scm 14 */
			  long aux_1220;
			  aux_1220 =
			     (i_1196 - ((long) 1));
			  aux_1201 =
			     (int) (aux_1220);
		       }
		       {
			  long i_1223;
			  i_1223 =
			     (long) (aux_1201);
			  i_1196 = i_1223;
			  goto loop_1197;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* inline-app */
node_bglt 
inline_app_72_inline_app(app_bglt node_1, long kfactor_2, obj_t stack_3)
{
   AN_OBJECT;
   {	/* Inline/app.scm 33 */
      {		/* Inline/app.scm 34 */
	 var_bglt callee_758;
	 callee_758 =
	    (((app_bglt) CREF(node_1))->fun);
	 {	/* Inline/app.scm 34 */
	    variable_bglt var_759;
	    var_759 =
	       (((var_bglt) CREF(callee_758))->variable);
	    {	/* Inline/app.scm 35 */
	       value_bglt sfun_760;
	       sfun_760 =
		  (((variable_bglt) CREF(var_759))->value);
	       {	/* Inline/app.scm 38 */

		  {	/* Inline/app.scm 39 */
		     bool_t test1456_763;
		     test1456_763 =
			is_a__118___object(
			(obj_t) (sfun_760), sfun_ast_var);
		     if (test1456_763)
		       {	/* Inline/app.scm 41 */
			  bool_t test1457_764;
			  {	/* Inline/app.scm 41 */
			     long aux_1231;
			     {	/* ./Ieee/fixnum.scm 7193 */
				long aux_1232;
				aux_1232 =
				   list_length(
				   (((app_bglt) CREF(node_1))->args));
				aux_1231 =
				   (((long) 1) + aux_1232);
			     }
			     test1457_764 =
				inline_app__99_inline_app(var_759, kfactor_2, aux_1231, stack_3);
			  }
			  if (test1457_764)
			    {	/* Inline/app.scm 41 */
			       {	/* Inline/app.scm 46 */
				  bool_t test_1238;
				  {	/* ./Ieee/equiv.scm 5508 */
				     obj_t aux_1242;
				     obj_t aux_1239;
				     aux_1242 =
					CNST_TABLE_REF(((long) 0));
				     {	/* Inline/app.scm 46 */
					sfun_bglt obj_1140;
					obj_1140 =
					   (sfun_bglt) (sfun_760);
					aux_1239 =
					   (((sfun_bglt) CREF(obj_1140))->class);
				     }
				     test_1238 =
					(aux_1239 == aux_1242);
				  }
				  if (test_1238)
				    {	/* Inline/app.scm 46 */
				       BUNSPEC;
				    }
				  else
				    {	/* Inline/app.scm 47 */
				       long z1_1143;
				       z1_1143 =
					  (long) CINT(_inlined_calls__118_inline_walk);
				       {	/* ./Ieee/fixnum.scm 7193 */
					  long aux_1246;
					  aux_1246 =
					     (z1_1143 + ((long) 1));
					  _inlined_calls__118_inline_walk =
					     BINT(aux_1246);
				       }
				    }
			       }
			       {	/* Inline/app.scm 48 */
				  bool_t test1462_768;
				  if (
				     CBOOL(_optim_loop_inlining___30_engine_param))
				    {	/* Inline/app.scm 48 */
				       test1462_768 =
					  is_recursive__125_inline_recursion(var_759);
				    }
				  else
				    {	/* Inline/app.scm 48 */
				       test1462_768 = ((bool_t) 0);
				    }
				  if (test1462_768)
				    {	/* Inline/app.scm 48 */
				       return
					  inline_app_recursive_121_inline_recursion(
					  (node_bglt) (node_1), kfactor_2, stack_3);
				    }
				  else
				    {	/* Inline/app.scm 48 */
				       return
					  inline_app_simple_198_inline_simple(
					  (node_bglt) (node_1), kfactor_2, stack_3, string1573_inline_app);
				    }
			       }
			    }
			  else
			    {	/* Inline/app.scm 41 */
			       {	/* Inline/app.scm 52 */
				  long z1_1145;
				  z1_1145 =
				     (long) CINT(_non_inlined_calls__201_inline_walk);
				  {	/* ./Ieee/fixnum.scm 7193 */
				     long aux_1258;
				     aux_1258 =
					(z1_1145 + ((long) 1));
				     _non_inlined_calls__201_inline_walk =
					BINT(aux_1258);
				  }
			       }
			       return
				  (node_bglt) (node_1);
			    }
		       }
		     else
		       {	/* Inline/app.scm 39 */
			  return
			     (node_bglt) (node_1);
		       }
		  }
	       }
	    }
	 }
      }
   }
}



/* _inline-app */
obj_t 
_inline_app_253_inline_app(obj_t env_1186, obj_t node_1187, obj_t kfactor_1188, obj_t stack_1189)
{
   AN_OBJECT;
   {	/* Inline/app.scm 33 */
      {		/* Inline/app.scm 33 */
	 node_bglt aux_1263;
	 aux_1263 =
	    inline_app_72_inline_app(
	    (app_bglt) (node_1187),
	    (long) CINT(kfactor_1188), stack_1189);
	 return
	    (obj_t) (aux_1263);
      }
   }
}



/* inline-app? */
bool_t 
inline_app__99_inline_app(variable_bglt var_4, long kfactor_5, long call_size_65_6, obj_t stack_7)
{
   AN_OBJECT;
   {	/* Inline/app.scm 58 */
      {		/* Inline/app.scm 63 */
	 value_bglt sfun_773;
	 sfun_773 =
	    (((variable_bglt) CREF(var_4))->value);
	 {	/* Inline/app.scm 63 */
	    obj_t body_774;
	    {	/* Inline/app.scm 64 */
	       bool_t test1489_795;
	       test1489_795 =
		  is_a__118___object(
		  (obj_t) (sfun_773), isfun_inline_inline);
	       if (test1489_795)
		 {	/* Inline/app.scm 65 */
		    isfun_bglt obj_1149;
		    obj_1149 =
		       (isfun_bglt) (sfun_773);
		    {	/* ./Inline/inline.scm 1168 */
		       node_bglt aux_1273;
		       {
			  obj_t aux_1274;
			  {	/* ./Inline/inline.scm 1168 */
			     object_bglt aux_1275;
			     aux_1275 =
				(object_bglt) (obj_1149);
			     aux_1274 =
				OBJECT_WIDENING(aux_1275);
			  }
			  aux_1273 =
			     (((isfun_bglt) CREF(aux_1274))->original_body_40);
		       }
		       body_774 =
			  (obj_t) (aux_1273);
		    }
		 }
	       else
		 {	/* Inline/app.scm 66 */
		    sfun_bglt obj_1150;
		    obj_1150 =
		       (sfun_bglt) (sfun_773);
		    body_774 =
		       (((sfun_bglt) CREF(obj_1150))->body);
		 }
	    }
	    {	/* Inline/app.scm 64 */

	       if (
		  CBOOL(_inlining___224_engine_param))
		 {	/* Inline/app.scm 72 */
		    bool_t test1468_775;
		    if (
		       CBOOL(_optim_loop_inlining___30_engine_param))
		      {		/* Inline/app.scm 72 */
			 if (
			    CBOOL(_optim_unroll_loop___80_engine_param))
			   {	/* Inline/app.scm 73 */
			      test1468_775 = ((bool_t) 0);
			   }
			 else
			   {	/* Inline/app.scm 74 */
			      obj_t aux_1288;
			      aux_1288 =
				 memq___r4_pairs_and_lists_6_3(
				 (obj_t) (var_4), stack_7);
			      test1468_775 =
				 CBOOL(aux_1288);
			   }
		      }
		    else
		      {		/* Inline/app.scm 72 */
			 test1468_775 = ((bool_t) 0);
		      }
		    if (test1468_775)
		      {		/* Inline/app.scm 72 */
			 return ((bool_t) 0);
		      }
		    else
		      {		/* Inline/app.scm 78 */
			 bool_t test_1293;
			 {	/* ./Ieee/equiv.scm 5508 */
			    obj_t aux_1297;
			    obj_t aux_1294;
			    aux_1297 =
			       CNST_TABLE_REF(((long) 1));
			    {	/* Inline/app.scm 78 */
			       sfun_bglt obj_1151;
			       obj_1151 =
				  (sfun_bglt) (sfun_773);
			       aux_1294 =
				  (((sfun_bglt) CREF(obj_1151))->class);
			    }
			    test_1293 =
			       (aux_1294 == aux_1297);
			 }
			 if (test_1293)
			   {	/* Inline/app.scm 78 */
			      return ((bool_t) 0);
			   }
			 else
			   {	/* Inline/app.scm 82 */
			      bool_t test_1300;
			      {		/* Inline/app.scm 82 */
				 bool_t test_1301;
				 {	/* ./Ieee/equiv.scm 5508 */
				    obj_t aux_1305;
				    obj_t aux_1302;
				    aux_1305 =
				       CNST_TABLE_REF(((long) 0));
				    {	/* Inline/app.scm 82 */
				       sfun_bglt obj_1154;
				       obj_1154 =
					  (sfun_bglt) (sfun_773);
				       aux_1302 =
					  (((sfun_bglt) CREF(obj_1154))->class);
				    }
				    test_1301 =
				       (aux_1302 == aux_1305);
				 }
				 if (test_1301)
				   {	/* Inline/app.scm 82 */
				      bool_t test_1308;
				      {		/* Inline/app.scm 82 */
					 obj_t aux_1309;
					 aux_1309 =
					    memq___r4_pairs_and_lists_6_3(
					    (obj_t) (var_4), stack_7);
					 test_1308 =
					    CBOOL(aux_1309);
				      }
				      if (test_1308)
					{	/* Inline/app.scm 82 */
					   test_1300 = ((bool_t) 0)
					      ;
					}
				      else
					{	/* Inline/app.scm 82 */
					   test_1300 = ((bool_t) 1)
					      ;
					}
				   }
				 else
				   {	/* Inline/app.scm 82 */
				      test_1300 = ((bool_t) 0)
					 ;
				   }
			      }
			      if (test_1300)
				{	/* Inline/app.scm 82 */
				   return ((bool_t) 1);
				}
			      else
				{	/* Inline/app.scm 86 */
				   bool_t test1471_778;
				   {	/* Inline/app.scm 86 */
				      bool_t test1479_786;
				      test1479_786 =
					 is_a__118___object(
					 (obj_t) (var_4), global_ast_var);
				      if (test1479_786)
					{	/* ./Ieee/equiv.scm 5508 */
					   obj_t aux_1319;
					   obj_t aux_1316;
					   aux_1319 =
					      CNST_TABLE_REF(((long) 2));
					   {	/* Inline/app.scm 86 */
					      global_bglt obj_1158;
					      obj_1158 =
						 (global_bglt) (var_4);
					      aux_1316 =
						 (((global_bglt) CREF(obj_1158))->import);
					   }
					   test1471_778 =
					      (aux_1316 == aux_1319);
					}
				      else
					{	/* Inline/app.scm 86 */
					   test1471_778 = ((bool_t) 0);
					}
				   }
				   if (test1471_778)
				     {	/* Inline/app.scm 86 */
					return ((bool_t) 0);
				     }
				   else
				     {	/* Inline/app.scm 90 */
					bool_t test1472_779;
					{	/* Inline/app.scm 90 */
					   long arg1477_784;
					   long arg1478_785;
					   arg1477_784 =
					      node_size_119_inline_size(
					      (node_bglt) (body_774));
					   arg1478_785 =
					      (kfactor_5 * call_size_65_6);
					   test1472_779 =
					      (arg1477_784 < arg1478_785);
					}
					if (test1472_779)
					  {	/* Inline/app.scm 90 */
					     return ((bool_t) 1);
					  }
					else
					  {	/* Inline/app.scm 98 */
					     bool_t test1473_780;
					     {	/* Inline/app.scm 98 */
						bool_t test1474_781;
						{	/* Inline/app.scm 98 */
						   long arg1476_783;
						   arg1476_783 =
						      node_size_119_inline_size(
						      (node_bglt) (body_774));
						   test1474_781 =
						      (arg1476_783 == call_size_65_6);
						}
						if (test1474_781)
						  {	/* Inline/app.scm 99 */
						     bool_t test_1332;
						     {	/* Inline/app.scm 99 */
							obj_t aux_1333;
							aux_1333 =
							   memq___r4_pairs_and_lists_6_3(
							   (obj_t) (var_4), stack_7);
							test_1332 =
							   CBOOL(aux_1333);
						     }
						     if (test_1332)
						       {	/* Inline/app.scm 99 */
							  test1473_780 = ((bool_t) 0);
						       }
						     else
						       {	/* Inline/app.scm 99 */
							  test1473_780 = ((bool_t) 1);
						       }
						  }
						else
						  {	/* Inline/app.scm 98 */
						     test1473_780 = ((bool_t) 0);
						  }
					     }
					     if (test1473_780)
					       {	/* Inline/app.scm 98 */
						  return ((bool_t) 1);
					       }
					     else
					       {	/* Inline/app.scm 98 */
						  return ((bool_t) 0);
					       }
					  }
				     }
				}
			   }
		      }
		 }
	       else
		 {	/* Inline/app.scm 68 */
		    return ((bool_t) 0);
		 }
	    }
	 }
      }
   }
}



/* _inline-app? */
obj_t 
_inline_app__45_inline_app(obj_t env_1190, obj_t var_1191, obj_t kfactor_1192, obj_t call_size_65_1193, obj_t stack_1194)
{
   AN_OBJECT;
   {	/* Inline/app.scm 58 */
      {		/* Inline/app.scm 58 */
	 bool_t aux_1338;
	 aux_1338 =
	    inline_app__99_inline_app(
	    (variable_bglt) (var_1191),
	    (long) CINT(kfactor_1192),
	    (long) CINT(call_size_65_1193), stack_1194);
	 return
	    BBOOL(aux_1338);
      }
   }
}



/* method-init */
obj_t 
method_init_76_inline_app()
{
   AN_OBJECT;
   {	/* Inline/app.scm 14 */
      return BUNSPEC;
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_inline_app()
{
   AN_OBJECT;
   {	/* Inline/app.scm 14 */
      module_initialization_70_tools_trace(((long) 0), "INLINE_APP");
      module_initialization_70_engine_param(((long) 0), "INLINE_APP");
      module_initialization_70_tools_shape(((long) 0), "INLINE_APP");
      module_initialization_70_tools_error(((long) 0), "INLINE_APP");
      module_initialization_70_type_type(((long) 0), "INLINE_APP");
      module_initialization_70_ast_var(((long) 0), "INLINE_APP");
      module_initialization_70_ast_node(((long) 0), "INLINE_APP");
      module_initialization_70_inline_walk(((long) 0), "INLINE_APP");
      module_initialization_70_inline_inline(((long) 0), "INLINE_APP");
      module_initialization_70_inline_size(((long) 0), "INLINE_APP");
      module_initialization_70_inline_simple(((long) 0), "INLINE_APP");
      return
	 module_initialization_70_inline_recursion(((long) 0), "INLINE_APP");
   }
}
