/*===========================================================================*/
/*   (Inline/inline.scm)                                                     */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;

typedef struct isfun
  {
     struct node *original_body_40;
     obj_t recursive_calls_44;
  }
     *isfun_bglt;


extern sfun_bglt allocate_isfun_51_inline_inline();
static obj_t method_init_76_inline_inline();
extern obj_t make_box_202_ast_node;
extern obj_t funcall_ast_node;
extern obj_t inline_sfun__229_inline_inline(variable_bglt, long, obj_t);
extern isfun_bglt make_isfun_38_inline_inline(long, obj_t, obj_t, obj_t, bool_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, node_bglt, obj_t);
extern obj_t _optim__89_engine_param;
extern obj_t isfun_loc_set__164_inline_inline(sfun_bglt, obj_t);
static obj_t _isfun_side_effect__set__147_inline_inline(obj_t, obj_t, obj_t);
extern long add_inlined_method__244___object(obj_t, obj_t, long);
static obj_t _isfun_dsssl_keywords_set__213_inline_inline(obj_t, obj_t, obj_t);
extern obj_t isfun_args_set__220_inline_inline(sfun_bglt, obj_t);
extern obj_t fail_ast_node;
extern obj_t box_ref_242_ast_node;
extern obj_t isfun_property_57_inline_inline(sfun_bglt);
extern obj_t isfun_loc_80_inline_inline(sfun_bglt);
extern obj_t sequence_ast_node;
extern obj_t let_var_6_ast_node;
extern obj_t var_ast_node;
static obj_t _isfun_class_set__77_inline_inline(obj_t, obj_t, obj_t);
static obj_t _isfun_body_101_inline_inline(obj_t, obj_t);
extern object_bglt struct_object__object_93___object(object_bglt, obj_t);
extern obj_t add_method__1___object(obj_t, obj_t, obj_t);
static obj_t _sfun__63_inline_inline(obj_t, obj_t);
extern obj_t global_ast_var;
extern obj_t pragma_ast_node;
static obj_t inline_node___77_inline_inline(obj_t, long, obj_t);
extern obj_t set_ex_it_116_ast_node;
extern obj_t find_super_class_method_167___object(object_bglt, obj_t, obj_t);
extern obj_t isfun_top__set__21_inline_inline(sfun_bglt, bool_t);
static obj_t _isfun_recursive_calls_set__129_inline_inline(obj_t, obj_t, obj_t);
static obj_t _isfun_property_set__146_inline_inline(obj_t, obj_t, obj_t);
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t isfun_class_set__81_inline_inline(sfun_bglt, obj_t);
extern obj_t module_initialization_70_inline_inline(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_inline_walk(long, char *);
extern obj_t module_initialization_70_inline_app(long, char *);
extern obj_t module_initialization_70_ast_alphatize(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
static obj_t _isfun_args_set__13_inline_inline(obj_t, obj_t, obj_t);
static obj_t _isfun_args_30_inline_inline(obj_t, obj_t);
static obj_t _isfun_stack_allocator_255_inline_inline(obj_t, obj_t);
static obj_t struct_object__object_isfun1521_239_inline_inline(obj_t, obj_t, obj_t);
extern node_bglt inline_app_72_inline_app(app_bglt, long, obj_t);
static obj_t _inline_sfun__45_inline_inline(obj_t, obj_t, obj_t, obj_t);
extern bool_t isfun__40_inline_inline(obj_t);
extern obj_t isfun_predicate_of_231_inline_inline(sfun_bglt);
static obj_t _isfun_original_body_22_inline_inline(obj_t, obj_t);
static obj_t _isfun_stack_allocator_set__220_inline_inline(obj_t, obj_t, obj_t);
extern long list_length(obj_t);
extern long class_num_218___object(obj_t);
static obj_t _isfun_dsssl_keywords_62_inline_inline(obj_t, obj_t);
static obj_t _make_isfun_175_inline_inline(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern isfun_bglt widening_isfun_234_inline_inline(node_bglt, obj_t);
static obj_t _widening_isfun1734_126_inline_inline(obj_t, obj_t, obj_t);
extern obj_t let_fun_218_ast_node;
static obj_t _isfun_top__set__218_inline_inline(obj_t, obj_t, obj_t);
static obj_t imported_modules_init_94_inline_inline();
extern obj_t isfun_the_closure_set__113_inline_inline(sfun_bglt, obj_t);
static obj_t _isfun__19_inline_inline(obj_t, obj_t);
extern obj_t isfun_side_effect__245_inline_inline(sfun_bglt);
static obj_t _inline_node_166_inline_inline(obj_t, obj_t, obj_t, obj_t);
static obj_t _isfun_predicate_of_set__128_inline_inline(obj_t, obj_t, obj_t);
extern obj_t app_ly_162_ast_node;
extern obj_t add_generic__110___object(obj_t, obj_t);
static obj_t _isfun_arity_245_inline_inline(obj_t, obj_t);
extern obj_t isfun_property_set__21_inline_inline(sfun_bglt, obj_t);
extern obj_t isfun_recursive_calls_set__23_inline_inline(isfun_bglt, obj_t);
static obj_t _isfun_loc_111_inline_inline(obj_t, obj_t);
static obj_t _inline_node_default1476_23_inline_inline(obj_t, obj_t, obj_t, obj_t);
extern obj_t isfun_body_set__168_inline_inline(sfun_bglt, obj_t);
static obj_t _isfun_class_81_inline_inline(obj_t, obj_t);
extern obj_t app_ast_node;
extern obj_t isfun_side_effect__set__5_inline_inline(sfun_bglt, obj_t);
static obj_t library_modules_init_112_inline_inline();
extern node_bglt inline_node_218_inline_inline(node_bglt, long, obj_t);
extern obj_t isfun_dsssl_keywords_set__79_inline_inline(sfun_bglt, obj_t);
extern obj_t make_struct(obj_t, long, obj_t);
extern long isfun_arity_98_inline_inline(sfun_bglt);
static obj_t _isfun_recursive_calls_234_inline_inline(obj_t, obj_t);
extern obj_t atom_ast_node;
extern obj_t cast_ast_node;
static obj_t toplevel_init_63_inline_inline();
static obj_t _isfun_the_closure_166_inline_inline(obj_t, obj_t);
extern obj_t isfun_class_67_inline_inline(sfun_bglt);
extern node_bglt isfun_original_body_3_inline_inline(isfun_bglt);
extern obj_t create_vector(long);
extern obj_t jump_ex_it_184_ast_node;
extern obj_t open_input_string(obj_t);
extern obj_t kwote_ast_node;
extern obj_t isfun_stack_allocator_set__37_inline_inline(sfun_bglt, obj_t);
extern bool_t isfun_top__57_inline_inline(sfun_bglt);
extern obj_t isfun_dsssl_keywords_90_inline_inline(sfun_bglt);
extern node_bglt alphatize_ast_alphatize(obj_t, obj_t, obj_t, node_bglt);
extern obj_t sfun_ast_var;
extern obj_t isfun_the_closure_61_inline_inline(sfun_bglt);
extern obj_t _non_inlined_calls__201_inline_walk;
extern obj_t setq_ast_node;
extern obj_t box_set__221_ast_node;
extern obj_t isfun_stack_allocator_184_inline_inline(sfun_bglt);
obj_t isfun_inline_inline = BUNSPEC;
static obj_t _isfun_body_set__162_inline_inline(obj_t, obj_t, obj_t);
static bool_t sfun__199_inline_inline(obj_t);
extern obj_t register_class__225___object(obj_t, obj_t, obj_t, long, obj_t, obj_t, obj_t);
static obj_t object_init_111_inline_inline();
extern bool_t inline_app__99_inline_app(variable_bglt, long, long, obj_t);
static obj_t _allocate_isfun_106_inline_inline(obj_t);
extern obj_t isfun_body_87_inline_inline(sfun_bglt);
static obj_t _isfun_loc_set__180_inline_inline(obj_t, obj_t, obj_t);
extern obj_t _kfactor__149_inline_walk;
extern obj_t _classes__134___object;
static obj_t _isfun_predicate_of_5_inline_inline(obj_t, obj_t);
extern obj_t select_ast_node;
extern obj_t read___reader(obj_t);
static obj_t _isfun_property_115_inline_inline(obj_t, obj_t);
extern obj_t object__struct_50___object(object_bglt);
static obj_t _isfun_the_closure_set__252_inline_inline(obj_t, obj_t, obj_t);
extern obj_t isfun_predicate_of_set__54_inline_inline(sfun_bglt, obj_t);
static obj_t _isfun_top__74_inline_inline(obj_t, obj_t);
static obj_t require_initialization_114_inline_inline = BUNSPEC;
extern obj_t conditional_ast_node;
extern obj_t isfun_args_255_inline_inline(sfun_bglt);
extern obj_t isfun_recursive_calls_17_inline_inline(isfun_bglt);
static obj_t _isfun_side_effect__141_inline_inline(obj_t, obj_t);
static node_bglt inline_node_default1476_251_inline_inline(node_bglt, long, obj_t);
static obj_t object__struct_isfun1518_54_inline_inline(obj_t, obj_t);
static obj_t cnst_init_137_inline_inline();
static obj_t __cnst[5];

DEFINE_EXPORT_PROCEDURE(isfun_loc_set__env_208_inline_inline, _isfun_loc_set__180_inline_inline1746, _isfun_loc_set__180_inline_inline, 0L, 2);
DEFINE_EXPORT_PROCEDURE(isfun_original_body_env_221_inline_inline, _isfun_original_body_22_inline_inline1747, _isfun_original_body_22_inline_inline, 0L, 1);
DEFINE_EXPORT_PROCEDURE(isfun_body_env_234_inline_inline, _isfun_body_101_inline_inline1748, _isfun_body_101_inline_inline, 0L, 1);
DEFINE_EXPORT_PROCEDURE(isfun_side_effect__set__env_185_inline_inline, _isfun_side_effect__set__147_inline_inline1749, _isfun_side_effect__set__147_inline_inline, 0L, 2);
DEFINE_EXPORT_PROCEDURE(isfun_predicate_of_env_198_inline_inline, _isfun_predicate_of_5_inline_inline1750, _isfun_predicate_of_5_inline_inline, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_isfun_env_162_inline_inline, _make_isfun_175_inline_inline1751, _make_isfun_175_inline_inline, 0L, 14);
DEFINE_EXPORT_PROCEDURE(isfun_class_set__env_226_inline_inline, _isfun_class_set__77_inline_inline1752, _isfun_class_set__77_inline_inline, 0L, 2);
DEFINE_EXPORT_PROCEDURE(isfun_the_closure_env_205_inline_inline, _isfun_the_closure_166_inline_inline1753, _isfun_the_closure_166_inline_inline, 0L, 1);
DEFINE_EXPORT_PROCEDURE(widening_isfun_env_144_inline_inline, _widening_isfun1734_126_inline_inline1754, _widening_isfun1734_126_inline_inline, 0L, 2);
DEFINE_STATIC_PROCEDURE(inline_node_default1476_env_173_inline_inline, _inline_node_default1476_23_inline_inline1755, _inline_node_default1476_23_inline_inline, 0L, 3);
DEFINE_EXPORT_PROCEDURE(isfun_property_set__env_123_inline_inline, _isfun_property_set__146_inline_inline1756, _isfun_property_set__146_inline_inline, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc1739_inline_inline, struct_object__object_isfun1521_239_inline_inline1757, struct_object__object_isfun1521_239_inline_inline, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc1738_inline_inline, object__struct_isfun1518_54_inline_inline1758, object__struct_isfun1518_54_inline_inline, 0L, 1);
extern obj_t struct_object__object_env_209___object;
DEFINE_EXPORT_GENERIC(inline_node_env_12_inline_inline, _inline_node_166_inline_inline1759, _inline_node_166_inline_inline, 0L, 3);
DEFINE_EXPORT_PROCEDURE(isfun_body_set__env_132_inline_inline, _isfun_body_set__162_inline_inline1760, _isfun_body_set__162_inline_inline, 0L, 2);
DEFINE_EXPORT_PROCEDURE(isfun_arity_env_65_inline_inline, _isfun_arity_245_inline_inline1761, _isfun_arity_245_inline_inline, 0L, 1);
DEFINE_EXPORT_PROCEDURE(isfun_dsssl_keywords_set__env_141_inline_inline, _isfun_dsssl_keywords_set__213_inline_inline1762, _isfun_dsssl_keywords_set__213_inline_inline, 0L, 2);
DEFINE_EXPORT_PROCEDURE(isfun_recursive_calls_env_195_inline_inline, _isfun_recursive_calls_234_inline_inline1763, _isfun_recursive_calls_234_inline_inline, 0L, 1);
DEFINE_EXPORT_PROCEDURE(isfun_predicate_of_set__env_19_inline_inline, _isfun_predicate_of_set__128_inline_inline1764, _isfun_predicate_of_set__128_inline_inline, 0L, 2);
DEFINE_EXPORT_PROCEDURE(isfun_stack_allocator_set__env_121_inline_inline, _isfun_stack_allocator_set__220_inline_inline1765, _isfun_stack_allocator_set__220_inline_inline, 0L, 2);
DEFINE_EXPORT_PROCEDURE(isfun_property_env_240_inline_inline, _isfun_property_115_inline_inline1766, _isfun_property_115_inline_inline, 0L, 1);
DEFINE_EXPORT_PROCEDURE(isfun_args_set__env_155_inline_inline, _isfun_args_set__13_inline_inline1767, _isfun_args_set__13_inline_inline, 0L, 2);
DEFINE_STATIC_PROCEDURE(sfun__env_206_inline_inline, _sfun__63_inline_inline1768, _sfun__63_inline_inline, 0L, 1);
DEFINE_EXPORT_PROCEDURE(isfun_top__env_240_inline_inline, _isfun_top__74_inline_inline1769, _isfun_top__74_inline_inline, 0L, 1);
DEFINE_STRING(string1741_inline_inline, string1741_inline_inline1770, "INLINE-NODE-DEFAULT1476 READ STATIC ISFUN DONE ", 47);
DEFINE_STRING(string1740_inline_inline, string1740_inline_inline1771, "No method for this object", 25);
DEFINE_EXPORT_PROCEDURE(isfun_class_env_109_inline_inline, _isfun_class_81_inline_inline1772, _isfun_class_81_inline_inline, 0L, 1);
DEFINE_EXPORT_PROCEDURE(isfun_the_closure_set__env_39_inline_inline, _isfun_the_closure_set__252_inline_inline1773, _isfun_the_closure_set__252_inline_inline, 0L, 2);
DEFINE_EXPORT_PROCEDURE(isfun_top__set__env_123_inline_inline, _isfun_top__set__218_inline_inline1774, _isfun_top__set__218_inline_inline, 0L, 2);
DEFINE_EXPORT_PROCEDURE(isfun_recursive_calls_set__env_241_inline_inline, _isfun_recursive_calls_set__129_inline_inline1775, _isfun_recursive_calls_set__129_inline_inline, 0L, 2);
DEFINE_EXPORT_PROCEDURE(isfun_side_effect__env_113_inline_inline, _isfun_side_effect__141_inline_inline1776, _isfun_side_effect__141_inline_inline, 0L, 1);
DEFINE_EXPORT_PROCEDURE(isfun_dsssl_keywords_env_237_inline_inline, _isfun_dsssl_keywords_62_inline_inline1777, _isfun_dsssl_keywords_62_inline_inline, 0L, 1);
DEFINE_EXPORT_PROCEDURE(isfun_stack_allocator_env_161_inline_inline, _isfun_stack_allocator_255_inline_inline1778, _isfun_stack_allocator_255_inline_inline, 0L, 1);
DEFINE_EXPORT_PROCEDURE(allocate_isfun_env_181_inline_inline, _allocate_isfun_106_inline_inline1779, _allocate_isfun_106_inline_inline, 0L, 0);
DEFINE_EXPORT_PROCEDURE(isfun__env_170_inline_inline, _isfun__19_inline_inline1780, _isfun__19_inline_inline, 0L, 1);
DEFINE_EXPORT_PROCEDURE(isfun_loc_env_134_inline_inline, _isfun_loc_111_inline_inline1781, _isfun_loc_111_inline_inline, 0L, 1);
DEFINE_EXPORT_PROCEDURE(isfun_args_env_194_inline_inline, _isfun_args_30_inline_inline1782, _isfun_args_30_inline_inline, 0L, 1);
DEFINE_EXPORT_PROCEDURE(inline_sfun__env_218_inline_inline, _inline_sfun__45_inline_inline1783, _inline_sfun__45_inline_inline, 0L, 3);
extern obj_t object__struct_env_210___object;



/* module-initialization */
obj_t 
module_initialization_70_inline_inline(long checksum_1754, char *from_1755)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_inline_inline))
	{
	   require_initialization_114_inline_inline =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_inline_inline();
	   cnst_init_137_inline_inline();
	   imported_modules_init_94_inline_inline();
	   object_init_111_inline_inline();
	   method_init_76_inline_inline();
	   toplevel_init_63_inline_inline();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_inline_inline()
{
   AN_OBJECT;
   {	/* Inline/inline.scm 14 */
      module_initialization_70___object(((long) 0), "INLINE_INLINE");
      module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "INLINE_INLINE");
      module_initialization_70___reader(((long) 0), "INLINE_INLINE");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_inline_inline()
{
   AN_OBJECT;
   {	/* Inline/inline.scm 14 */
      {		/* Inline/inline.scm 14 */
	 obj_t cnst_port_138_1747;
	 cnst_port_138_1747 =
	    open_input_string(string1741_inline_inline);
	 {
	    long i_1748;
	    i_1748 = ((long) 4);
	  loop_1749:
	    {	/* Inline/inline.scm 14 */
	       bool_t test1742_1750;
	       test1742_1750 =
		  (i_1748 == ((long) -1));
	       if (test1742_1750)
		 {	/* Inline/inline.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Inline/inline.scm 14 */
		    {	/* Inline/inline.scm 14 */
		       obj_t arg1743_1751;
		       {	/* Inline/inline.scm 14 */
			  obj_t list1744_1752;
			  list1744_1752 =
			     MAKE_PAIR(cnst_port_138_1747, BNIL);
			  arg1743_1751 =
			     read___reader(list1744_1752);
		       }
		       CNST_TABLE_SET(i_1748, arg1743_1751);
		    }
		    {	/* Inline/inline.scm 14 */
		       int aux_1753;
		       {	/* Inline/inline.scm 14 */
			  long aux_1774;
			  aux_1774 =
			     (i_1748 - ((long) 1));
			  aux_1753 =
			     (int) (aux_1774);
		       }
		       {
			  long i_1777;
			  i_1777 =
			     (long) (aux_1753);
			  i_1748 = i_1777;
			  goto loop_1749;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_inline_inline()
{
   AN_OBJECT;
   {	/* Inline/inline.scm 14 */
      return BUNSPEC;
   }
}



/* inline-sfun! */
obj_t 
inline_sfun__229_inline_inline(variable_bglt variable_1, long kfactor_2, obj_t stack_3)
{
   AN_OBJECT;
   {	/* Inline/inline.scm 32 */
      {		/* Inline/inline.scm 35 */
	 value_bglt sfun_826;
	 sfun_826 =
	    (((variable_bglt) CREF(variable_1))->value);
	 {	/* Inline/inline.scm 35 */
	    obj_t isfun_827;
	    {	/* Inline/inline.scm 36 */
	       bool_t test1530_838;
	       test1530_838 =
		  is_a__118___object(sfun__env_206_inline_inline, isfun_inline_inline);
	       if (test1530_838)
		 {	/* Inline/inline.scm 36 */
		    isfun_827 =
		       (obj_t) (sfun_826);
		 }
	       else
		 {	/* Inline/inline.scm 38 */
		    isfun_bglt obj1462_839;
		    obj1462_839 =
		       ((isfun_bglt) (sfun_826));
		    {	/* Inline/inline.scm 38 */
		       isfun_bglt arg1532_840;
		       {	/* Inline/inline.scm 38 */
			  isfun_bglt res1729_1388;
			  {	/* Inline/inline.scm 38 */
			     node_bglt original_body_40_1383;
			     {	/* Inline/inline.scm 38 */
				obj_t aux_1784;
				{	/* Inline/inline.scm 38 */
				   sfun_bglt obj_1382;
				   obj_1382 =
				      (sfun_bglt) (sfun_826);
				   aux_1784 =
				      (((sfun_bglt) CREF(obj_1382))->body);
				}
				original_body_40_1383 =
				   (node_bglt) (aux_1784);
			     }
			     {	/* Inline/inline.scm 24 */
				isfun_bglt new1449_1385;
				new1449_1385 =
				   ((isfun_bglt) BREF(GC_MALLOC(sizeof(struct isfun))));
				((((isfun_bglt) CREF(new1449_1385))->original_body_40) = ((node_bglt) original_body_40_1383), BUNSPEC);
				((((isfun_bglt) CREF(new1449_1385))->recursive_calls_44) = ((obj_t) BUNSPEC), BUNSPEC);
				res1729_1388 = new1449_1385;
			     }
			  }
			  arg1532_840 = res1729_1388;
		       }
		       {	/* Inline/inline.scm 38 */
			  obj_t aux_1793;
			  object_bglt aux_1791;
			  aux_1793 =
			     (obj_t) (arg1532_840);
			  aux_1791 =
			     (object_bglt) (obj1462_839);
			  OBJECT_WIDENING_SET(aux_1791, aux_1793);
		       }
		    }
		    {	/* Inline/inline.scm 38 */
		       long arg1534_842;
		       arg1534_842 =
			  class_num_218___object(isfun_inline_inline);
		       {	/* Inline/inline.scm 38 */
			  obj_t obj_1389;
			  obj_1389 =
			     (obj_t) (obj1462_839);
			  (((obj_t) CREF(obj_1389))->header = MAKE_HEADER(arg1534_842, 0), BUNSPEC);
		       }
		    }
		    isfun_827 =
		       (obj_t) (obj1462_839);
		 }
	    }
	    {	/* Inline/inline.scm 36 */
	       node_bglt o_body_107_828;
	       {	/* Inline/inline.scm 39 */
		  isfun_bglt obj_1391;
		  obj_1391 =
		     (isfun_bglt) (isfun_827);
		  {
		     obj_t aux_1801;
		     {	/* Inline/inline.scm 25 */
			object_bglt aux_1802;
			aux_1802 =
			   (object_bglt) (obj_1391);
			aux_1801 =
			   OBJECT_WIDENING(aux_1802);
		     }
		     o_body_107_828 =
			(((isfun_bglt) CREF(aux_1801))->original_body_40);
		  }
	       }
	       {	/* Inline/inline.scm 39 */
		  node_bglt inl_body_109_829;
		  {	/* Inline/inline.scm 40 */
		     bool_t test1524_832;
		     {	/* Inline/inline.scm 42 */
			long arg1525_833;
			{	/* ./Ieee/fixnum.scm 7193 */
			   long aux_1806;
			   {	/* Inline/inline.scm 42 */
			      obj_t aux_1807;
			      {		/* Inline/inline.scm 42 */
				 sfun_bglt obj_1392;
				 obj_1392 =
				    (sfun_bglt) (sfun_826);
				 aux_1807 =
				    (((sfun_bglt) CREF(obj_1392))->args);
			      }
			      aux_1806 =
				 list_length(aux_1807);
			   }
			   arg1525_833 =
			      (((long) 1) + aux_1806);
			}
			test1524_832 =
			   inline_app__99_inline_app(variable_1,
			   (long) CINT(_kfactor__149_inline_walk), arg1525_833, BNIL);
		     }
		     if (test1524_832)
		       {	/* Inline/inline.scm 40 */
			  inl_body_109_829 =
			     alphatize_ast_alphatize(BNIL, BNIL, BFALSE, o_body_107_828);
		       }
		     else
		       {	/* Inline/inline.scm 40 */
			  inl_body_109_829 = o_body_107_828;
		       }
		  }
		  {	/* Inline/inline.scm 40 */

		     {	/* Inline/inline.scm 53 */
			node_bglt arg1522_830;
			{	/* Inline/inline.scm 53 */
			   obj_t arg1523_831;
			   {	/* ./Ieee/pair-list.scm 5689 */
			      obj_t aux_1816;
			      aux_1816 =
				 (obj_t) (variable_1);
			      arg1523_831 =
				 MAKE_PAIR(aux_1816, stack_3);
			   }
			   arg1522_830 =
			      inline_node_218_inline_inline(inl_body_109_829, kfactor_2, arg1523_831);
			}
			{	/* Inline/inline.scm 51 */
			   sfun_bglt obj_1397;
			   obj_t val1123_1398;
			   obj_1397 =
			      (sfun_bglt) (sfun_826);
			   val1123_1398 =
			      (obj_t) (arg1522_830);
			   ((((sfun_bglt) CREF(obj_1397))->body) = ((obj_t) val1123_1398), BUNSPEC);
			}
		     }
		     return BUNSPEC;
		  }
	       }
	    }
	 }
      }
   }
}



/* _inline-sfun! */
obj_t 
_inline_sfun__45_inline_inline(obj_t env_1636, obj_t variable_1637, obj_t kfactor_1638, obj_t stack_1639)
{
   AN_OBJECT;
   {	/* Inline/inline.scm 32 */
      return
	 inline_sfun__229_inline_inline(
	 (variable_bglt) (variable_1637),
	 (long) CINT(kfactor_1638), stack_1639);
   }
}



/* inline-node*! */
obj_t 
inline_node___77_inline_inline(obj_t node__221_70, long kfactor_71, obj_t stack_72)
{
   AN_OBJECT;
   {	/* Inline/inline.scm 236 */
    inline_node___77_inline_inline:
      if (
	 NULLP(node__221_70))
	{	/* Inline/inline.scm 237 */
	   return
	      CNST_TABLE_REF(((long) 0));
	}
      else
	{	/* Inline/inline.scm 237 */
	   {	/* Inline/inline.scm 240 */
	      node_bglt arg1536_844;
	      {		/* Inline/inline.scm 240 */
		 node_bglt aux_1829;
		 {	/* Inline/inline.scm 240 */
		    obj_t aux_1830;
		    aux_1830 =
		       CAR(node__221_70);
		    aux_1829 =
		       (node_bglt) (aux_1830);
		 }
		 arg1536_844 =
		    inline_node_218_inline_inline(aux_1829, kfactor_71, stack_72);
	      }
	      {		/* ./Ieee/pair-list.scm 5890 */
		 obj_t aux_1834;
		 aux_1834 =
		    (obj_t) (arg1536_844);
		 SET_CAR(node__221_70, aux_1834);
	      }
	   }
	   {
	      obj_t node__221_1837;
	      node__221_1837 =
		 CDR(node__221_70);
	      node__221_70 = node__221_1837;
	      goto inline_node___77_inline_inline;
	   }
	}
   }
}



/* object-init */
obj_t 
object_init_111_inline_inline()
{
   AN_OBJECT;
   {	/* Inline/inline.scm 14 */
      {		/* Inline/inline.scm 14 */
	 obj_t arg1540_847;
	 obj_t arg1541_848;
	 obj_t arg1545_851;
	 arg1540_847 =
	    CNST_TABLE_REF(((long) 1));
	 arg1541_848 = sfun_ast_var;
	 {	/* Inline/inline.scm 14 */
	    obj_t v1475_852;
	    v1475_852 =
	       create_vector(((long) 0));
	    arg1545_851 = v1475_852;
	 }
	 isfun_inline_inline =
	    register_class__225___object(arg1540_847, arg1541_848, allocate_isfun_env_181_inline_inline, ((long) 49291), BUNSPEC, BFALSE, arg1545_851);
      }
      return BUNSPEC;
   }
}



/* allocate-isfun */
sfun_bglt 
allocate_isfun_51_inline_inline()
{
   AN_OBJECT;
   {	/* Inline/inline.scm 24 */
      {		/* Inline/inline.scm 24 */
	 sfun_bglt new1455_853;
	 new1455_853 =
	    ((sfun_bglt) BREF(GC_MALLOC(sizeof(struct sfun))));
	 {	/* Inline/inline.scm 24 */
	    long arg1547_854;
	    arg1547_854 =
	       class_num_218___object(isfun_inline_inline);
	    {	/* Inline/inline.scm 24 */
	       obj_t obj_1404;
	       obj_1404 =
		  (obj_t) (new1455_853);
	       (((obj_t) CREF(obj_1404))->header = MAKE_HEADER(arg1547_854, 0), BUNSPEC);
	    }
	 }
	 {	/* Inline/inline.scm 24 */
	    object_bglt aux_1846;
	    aux_1846 =
	       (object_bglt) (new1455_853);
	    OBJECT_WIDENING_SET(aux_1846, BFALSE);
	 }
	 return new1455_853;
      }
   }
}



/* _allocate-isfun */
obj_t 
_allocate_isfun_106_inline_inline(obj_t env_1642)
{
   AN_OBJECT;
   {	/* Inline/inline.scm 24 */
      {		/* Inline/inline.scm 24 */
	 sfun_bglt aux_1849;
	 aux_1849 =
	    allocate_isfun_51_inline_inline();
	 return
	    (obj_t) (aux_1849);
      }
   }
}



/* isfun? */
bool_t 
isfun__40_inline_inline(obj_t obj_76)
{
   AN_OBJECT;
   {	/* Inline/inline.scm 24 */
      return
	 is_a__118___object(obj_76, isfun_inline_inline);
   }
}



/* _isfun? */
obj_t 
_isfun__19_inline_inline(obj_t env_1643, obj_t obj_1644)
{
   AN_OBJECT;
   {	/* Inline/inline.scm 24 */
      {		/* Inline/inline.scm 24 */
	 bool_t aux_1853;
	 aux_1853 =
	    isfun__40_inline_inline(obj_1644);
	 return
	    BBOOL(aux_1853);
      }
   }
}



/* widening-isfun */
isfun_bglt 
widening_isfun_234_inline_inline(node_bglt original_body_40_77, obj_t recursive_calls_44_78)
{
   AN_OBJECT;
   {	/* Inline/inline.scm 24 */
      {		/* Inline/inline.scm 24 */
	 isfun_bglt new1449_1406;
	 new1449_1406 =
	    ((isfun_bglt) BREF(GC_MALLOC(sizeof(struct isfun))));
	 ((((isfun_bglt) CREF(new1449_1406))->original_body_40) = ((node_bglt) original_body_40_77), BUNSPEC);
	 ((((isfun_bglt) CREF(new1449_1406))->recursive_calls_44) = ((obj_t) recursive_calls_44_78), BUNSPEC);
	 return new1449_1406;
      }
   }
}



/* _widening-isfun1734 */
obj_t 
_widening_isfun1734_126_inline_inline(obj_t env_1645, obj_t original_body_40_1646, obj_t recursive_calls_44_1647)
{
   AN_OBJECT;
   {	/* Inline/inline.scm 24 */
      {		/* Inline/inline.scm 24 */
	 isfun_bglt aux_1859;
	 aux_1859 =
	    widening_isfun_234_inline_inline(
	    (node_bglt) (original_body_40_1646), recursive_calls_44_1647);
	 return
	    (obj_t) (aux_1859);
      }
   }
}



/* make-isfun */
isfun_bglt 
make_isfun_38_inline_inline(long arity_79, obj_t side_effect__165_80, obj_t predicate_of_78_81, obj_t stack_allocator_172_82, bool_t top__138_83, obj_t the_closure_238_84, obj_t property_85, obj_t args_86, obj_t body_87, obj_t class_88, obj_t dsssl_keywords_243_89, obj_t loc_90, node_bglt original_body_40_91, obj_t recursive_calls_44_92)
{
   AN_OBJECT;
   {	/* Inline/inline.scm 24 */
      {		/* Inline/inline.scm 24 */
	 sfun_bglt aux1453_1409;
	 {	/* Inline/inline.scm 24 */
	    sfun_bglt res1730_1441;
	    {	/* ./Ast/var.scm 675 */
	       sfun_bglt new1127_1425;
	       new1127_1425 =
		  ((sfun_bglt) BREF(GC_MALLOC(sizeof(struct sfun))));
	       {	/* ./Ast/var.scm 675 */
		  long arg1611_1426;
		  arg1611_1426 =
		     class_num_218___object(sfun_ast_var);
		  {	/* ./Ast/var.scm 675 */
		     obj_t obj_1439;
		     obj_1439 =
			(obj_t) (new1127_1425);
		     (((obj_t) CREF(obj_1439))->header = MAKE_HEADER(arg1611_1426, 0), BUNSPEC);
		  }
	       }
	       {	/* ./Ast/var.scm 675 */
		  object_bglt aux_1867;
		  aux_1867 =
		     (object_bglt) (new1127_1425);
		  OBJECT_WIDENING_SET(aux_1867, BFALSE);
	       }
	       ((((sfun_bglt) CREF(new1127_1425))->arity) = ((long) arity_79), BUNSPEC);
	       ((((sfun_bglt) CREF(new1127_1425))->side_effect__165) = ((obj_t) side_effect__165_80), BUNSPEC);
	       ((((sfun_bglt) CREF(new1127_1425))->predicate_of_78) = ((obj_t) predicate_of_78_81), BUNSPEC);
	       ((((sfun_bglt) CREF(new1127_1425))->stack_allocator_172) = ((obj_t) stack_allocator_172_82), BUNSPEC);
	       ((((sfun_bglt) CREF(new1127_1425))->top__138) = ((bool_t) top__138_83), BUNSPEC);
	       ((((sfun_bglt) CREF(new1127_1425))->the_closure_238) = ((obj_t) the_closure_238_84), BUNSPEC);
	       ((((sfun_bglt) CREF(new1127_1425))->property) = ((obj_t) property_85), BUNSPEC);
	       ((((sfun_bglt) CREF(new1127_1425))->args) = ((obj_t) args_86), BUNSPEC);
	       ((((sfun_bglt) CREF(new1127_1425))->body) = ((obj_t) body_87), BUNSPEC);
	       ((((sfun_bglt) CREF(new1127_1425))->class) = ((obj_t) class_88), BUNSPEC);
	       ((((sfun_bglt) CREF(new1127_1425))->dsssl_keywords_243) = ((obj_t) dsssl_keywords_243_89), BUNSPEC);
	       ((((sfun_bglt) CREF(new1127_1425))->loc) = ((obj_t) loc_90), BUNSPEC);
	       res1730_1441 = new1127_1425;
	    }
	    aux1453_1409 = res1730_1441;
	 }
	 {	/* Inline/inline.scm 24 */
	    isfun_bglt new1454_1410;
	    new1454_1410 =
	       ((isfun_bglt) (aux1453_1409));
	    {	/* Inline/inline.scm 24 */
	       long arg1548_1411;
	       arg1548_1411 =
		  class_num_218___object(isfun_inline_inline);
	       {	/* Inline/inline.scm 24 */
		  obj_t obj_1442;
		  obj_1442 =
		     (obj_t) (new1454_1410);
		  (((obj_t) CREF(obj_1442))->header = MAKE_HEADER(arg1548_1411, 0), BUNSPEC);
	       }
	    }
	    {	/* Inline/inline.scm 24 */
	       isfun_bglt arg1549_1412;
	       {	/* Inline/inline.scm 24 */
		  isfun_bglt res1731_1449;
		  {	/* Inline/inline.scm 24 */
		     isfun_bglt new1449_1446;
		     new1449_1446 =
			((isfun_bglt) BREF(GC_MALLOC(sizeof(struct isfun))));
		     ((((isfun_bglt) CREF(new1449_1446))->original_body_40) = ((node_bglt) original_body_40_91), BUNSPEC);
		     ((((isfun_bglt) CREF(new1449_1446))->recursive_calls_44) = ((obj_t) recursive_calls_44_92), BUNSPEC);
		     res1731_1449 = new1449_1446;
		  }
		  arg1549_1412 = res1731_1449;
	       }
	       {	/* Inline/inline.scm 24 */
		  obj_t aux_1891;
		  object_bglt aux_1889;
		  aux_1891 =
		     (obj_t) (arg1549_1412);
		  aux_1889 =
		     (object_bglt) (new1454_1410);
		  OBJECT_WIDENING_SET(aux_1889, aux_1891);
	       }
	    }
	    return new1454_1410;
	 }
      }
   }
}



/* _make-isfun */
obj_t 
_make_isfun_175_inline_inline(obj_t env_1648, obj_t arity_1649, obj_t side_effect__165_1650, obj_t predicate_of_78_1651, obj_t stack_allocator_172_1652, obj_t top__138_1653, obj_t the_closure_238_1654, obj_t property_1655, obj_t args_1656, obj_t body_1657, obj_t class_1658, obj_t dsssl_keywords_243_1659, obj_t loc_1660, obj_t original_body_40_1661, obj_t recursive_calls_44_1662)
{
   AN_OBJECT;
   {	/* Inline/inline.scm 24 */
      {		/* Inline/inline.scm 24 */
	 isfun_bglt aux_1894;
	 aux_1894 =
	    make_isfun_38_inline_inline(
	    (long) CINT(arity_1649), side_effect__165_1650, predicate_of_78_1651, stack_allocator_172_1652,
	    CBOOL(top__138_1653), the_closure_238_1654, property_1655, args_1656, body_1657, class_1658, dsssl_keywords_243_1659, loc_1660,
	    (node_bglt) (original_body_40_1661), recursive_calls_44_1662);
	 return
	    (obj_t) (aux_1894);
      }
   }
}



/* isfun-arity */
long 
isfun_arity_98_inline_inline(sfun_bglt obj_93)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 663 */
      return
	 (((sfun_bglt) CREF(obj_93))->arity);
   }
}



/* _isfun-arity */
obj_t 
_isfun_arity_245_inline_inline(obj_t env_1663, obj_t obj_1664)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 663 */
      {		/* ./Ast/var.scm 663 */
	 long aux_1901;
	 aux_1901 =
	    isfun_arity_98_inline_inline(
	    (sfun_bglt) (obj_1664));
	 return
	    BINT(aux_1901);
      }
   }
}



/* isfun-side-effect?-set! */
obj_t 
isfun_side_effect__set__5_inline_inline(sfun_bglt obj_94, obj_t val1437_95)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 665 */
      return
	 ((((sfun_bglt) CREF(obj_94))->side_effect__165) = ((obj_t) val1437_95), BUNSPEC);
   }
}



/* _isfun-side-effect?-set! */
obj_t 
_isfun_side_effect__set__147_inline_inline(obj_t env_1665, obj_t obj_1666, obj_t val1437_1667)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 665 */
      return
	 isfun_side_effect__set__5_inline_inline(
	 (sfun_bglt) (obj_1666), val1437_1667);
   }
}



/* isfun-side-effect? */
obj_t 
isfun_side_effect__245_inline_inline(sfun_bglt obj_96)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 665 */
      return
	 (((sfun_bglt) CREF(obj_96))->side_effect__165);
   }
}



/* _isfun-side-effect? */
obj_t 
_isfun_side_effect__141_inline_inline(obj_t env_1668, obj_t obj_1669)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 665 */
      return
	 isfun_side_effect__245_inline_inline(
	 (sfun_bglt) (obj_1669));
   }
}



/* isfun-predicate-of-set! */
obj_t 
isfun_predicate_of_set__54_inline_inline(sfun_bglt obj_97, obj_t val1438_98)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 667 */
      return
	 ((((sfun_bglt) CREF(obj_97))->predicate_of_78) = ((obj_t) val1438_98), BUNSPEC);
   }
}



/* _isfun-predicate-of-set! */
obj_t 
_isfun_predicate_of_set__128_inline_inline(obj_t env_1670, obj_t obj_1671, obj_t val1438_1672)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 667 */
      return
	 isfun_predicate_of_set__54_inline_inline(
	 (sfun_bglt) (obj_1671), val1438_1672);
   }
}



/* isfun-predicate-of */
obj_t 
isfun_predicate_of_231_inline_inline(sfun_bglt obj_99)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 667 */
      return
	 (((sfun_bglt) CREF(obj_99))->predicate_of_78);
   }
}



/* _isfun-predicate-of */
obj_t 
_isfun_predicate_of_5_inline_inline(obj_t env_1673, obj_t obj_1674)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 667 */
      return
	 isfun_predicate_of_231_inline_inline(
	 (sfun_bglt) (obj_1674));
   }
}



/* isfun-stack-allocator-set! */
obj_t 
isfun_stack_allocator_set__37_inline_inline(sfun_bglt obj_100, obj_t val1439_101)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 669 */
      return
	 ((((sfun_bglt) CREF(obj_100))->stack_allocator_172) = ((obj_t) val1439_101), BUNSPEC);
   }
}



/* _isfun-stack-allocator-set! */
obj_t 
_isfun_stack_allocator_set__220_inline_inline(obj_t env_1675, obj_t obj_1676, obj_t val1439_1677)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 669 */
      return
	 isfun_stack_allocator_set__37_inline_inline(
	 (sfun_bglt) (obj_1676), val1439_1677);
   }
}



/* isfun-stack-allocator */
obj_t 
isfun_stack_allocator_184_inline_inline(sfun_bglt obj_102)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 669 */
      return
	 (((sfun_bglt) CREF(obj_102))->stack_allocator_172);
   }
}



/* _isfun-stack-allocator */
obj_t 
_isfun_stack_allocator_255_inline_inline(obj_t env_1678, obj_t obj_1679)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 669 */
      return
	 isfun_stack_allocator_184_inline_inline(
	 (sfun_bglt) (obj_1679));
   }
}



/* isfun-top?-set! */
obj_t 
isfun_top__set__21_inline_inline(sfun_bglt obj_103, bool_t val1440_104)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 671 */
      return
	 ((((sfun_bglt) CREF(obj_103))->top__138) = ((bool_t) val1440_104), BUNSPEC);
   }
}



/* _isfun-top?-set! */
obj_t 
_isfun_top__set__218_inline_inline(obj_t env_1680, obj_t obj_1681, obj_t val1440_1682)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 671 */
      return
	 isfun_top__set__21_inline_inline(
	 (sfun_bglt) (obj_1681),
	 CBOOL(val1440_1682));
   }
}



/* isfun-top? */
bool_t 
isfun_top__57_inline_inline(sfun_bglt obj_105)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 671 */
      return
	 (((sfun_bglt) CREF(obj_105))->top__138);
   }
}



/* _isfun-top? */
obj_t 
_isfun_top__74_inline_inline(obj_t env_1683, obj_t obj_1684)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 671 */
      {		/* ./Ast/var.scm 671 */
	 bool_t aux_1928;
	 aux_1928 =
	    isfun_top__57_inline_inline(
	    (sfun_bglt) (obj_1684));
	 return
	    BBOOL(aux_1928);
      }
   }
}



/* isfun-the-closure-set! */
obj_t 
isfun_the_closure_set__113_inline_inline(sfun_bglt obj_106, obj_t val1441_107)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 673 */
      return
	 ((((sfun_bglt) CREF(obj_106))->the_closure_238) = ((obj_t) val1441_107), BUNSPEC);
   }
}



/* _isfun-the-closure-set! */
obj_t 
_isfun_the_closure_set__252_inline_inline(obj_t env_1685, obj_t obj_1686, obj_t val1441_1687)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 673 */
      return
	 isfun_the_closure_set__113_inline_inline(
	 (sfun_bglt) (obj_1686), val1441_1687);
   }
}



/* isfun-the-closure */
obj_t 
isfun_the_closure_61_inline_inline(sfun_bglt obj_108)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 673 */
      return
	 (((sfun_bglt) CREF(obj_108))->the_closure_238);
   }
}



/* _isfun-the-closure */
obj_t 
_isfun_the_closure_166_inline_inline(obj_t env_1688, obj_t obj_1689)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 673 */
      return
	 isfun_the_closure_61_inline_inline(
	 (sfun_bglt) (obj_1689));
   }
}



/* isfun-property-set! */
obj_t 
isfun_property_set__21_inline_inline(sfun_bglt obj_109, obj_t val1442_110)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 677 */
      return
	 ((((sfun_bglt) CREF(obj_109))->property) = ((obj_t) val1442_110), BUNSPEC);
   }
}



/* _isfun-property-set! */
obj_t 
_isfun_property_set__146_inline_inline(obj_t env_1690, obj_t obj_1691, obj_t val1442_1692)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 677 */
      return
	 isfun_property_set__21_inline_inline(
	 (sfun_bglt) (obj_1691), val1442_1692);
   }
}



/* isfun-property */
obj_t 
isfun_property_57_inline_inline(sfun_bglt obj_111)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 677 */
      return
	 (((sfun_bglt) CREF(obj_111))->property);
   }
}



/* _isfun-property */
obj_t 
_isfun_property_115_inline_inline(obj_t env_1693, obj_t obj_1694)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 677 */
      return
	 isfun_property_57_inline_inline(
	 (sfun_bglt) (obj_1694));
   }
}



/* isfun-args-set! */
obj_t 
isfun_args_set__220_inline_inline(sfun_bglt obj_112, obj_t val1443_113)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 679 */
      return
	 ((((sfun_bglt) CREF(obj_112))->args) = ((obj_t) val1443_113), BUNSPEC);
   }
}



/* _isfun-args-set! */
obj_t 
_isfun_args_set__13_inline_inline(obj_t env_1695, obj_t obj_1696, obj_t val1443_1697)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 679 */
      return
	 isfun_args_set__220_inline_inline(
	 (sfun_bglt) (obj_1696), val1443_1697);
   }
}



/* isfun-args */
obj_t 
isfun_args_255_inline_inline(sfun_bglt obj_114)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 679 */
      return
	 (((sfun_bglt) CREF(obj_114))->args);
   }
}



/* _isfun-args */
obj_t 
_isfun_args_30_inline_inline(obj_t env_1698, obj_t obj_1699)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 679 */
      return
	 isfun_args_255_inline_inline(
	 (sfun_bglt) (obj_1699));
   }
}



/* isfun-body-set! */
obj_t 
isfun_body_set__168_inline_inline(sfun_bglt obj_115, obj_t val1444_116)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 681 */
      return
	 ((((sfun_bglt) CREF(obj_115))->body) = ((obj_t) val1444_116), BUNSPEC);
   }
}



/* _isfun-body-set! */
obj_t 
_isfun_body_set__162_inline_inline(obj_t env_1700, obj_t obj_1701, obj_t val1444_1702)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 681 */
      return
	 isfun_body_set__168_inline_inline(
	 (sfun_bglt) (obj_1701), val1444_1702);
   }
}



/* isfun-body */
obj_t 
isfun_body_87_inline_inline(sfun_bglt obj_117)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 681 */
      return
	 (((sfun_bglt) CREF(obj_117))->body);
   }
}



/* _isfun-body */
obj_t 
_isfun_body_101_inline_inline(obj_t env_1703, obj_t obj_1704)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 681 */
      return
	 isfun_body_87_inline_inline(
	 (sfun_bglt) (obj_1704));
   }
}



/* isfun-class-set! */
obj_t 
isfun_class_set__81_inline_inline(sfun_bglt obj_118, obj_t val1445_119)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 683 */
      return
	 ((((sfun_bglt) CREF(obj_118))->class) = ((obj_t) val1445_119), BUNSPEC);
   }
}



/* _isfun-class-set! */
obj_t 
_isfun_class_set__77_inline_inline(obj_t env_1705, obj_t obj_1706, obj_t val1445_1707)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 683 */
      return
	 isfun_class_set__81_inline_inline(
	 (sfun_bglt) (obj_1706), val1445_1707);
   }
}



/* isfun-class */
obj_t 
isfun_class_67_inline_inline(sfun_bglt obj_120)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 683 */
      return
	 (((sfun_bglt) CREF(obj_120))->class);
   }
}



/* _isfun-class */
obj_t 
_isfun_class_81_inline_inline(obj_t env_1708, obj_t obj_1709)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 683 */
      return
	 isfun_class_67_inline_inline(
	 (sfun_bglt) (obj_1709));
   }
}



/* isfun-dsssl-keywords-set! */
obj_t 
isfun_dsssl_keywords_set__79_inline_inline(sfun_bglt obj_121, obj_t val1446_122)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 689 */
      return
	 ((((sfun_bglt) CREF(obj_121))->dsssl_keywords_243) = ((obj_t) val1446_122), BUNSPEC);
   }
}



/* _isfun-dsssl-keywords-set! */
obj_t 
_isfun_dsssl_keywords_set__213_inline_inline(obj_t env_1710, obj_t obj_1711, obj_t val1446_1712)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 689 */
      return
	 isfun_dsssl_keywords_set__79_inline_inline(
	 (sfun_bglt) (obj_1711), val1446_1712);
   }
}



/* isfun-dsssl-keywords */
obj_t 
isfun_dsssl_keywords_90_inline_inline(sfun_bglt obj_123)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 689 */
      return
	 (((sfun_bglt) CREF(obj_123))->dsssl_keywords_243);
   }
}



/* _isfun-dsssl-keywords */
obj_t 
_isfun_dsssl_keywords_62_inline_inline(obj_t env_1713, obj_t obj_1714)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 689 */
      return
	 isfun_dsssl_keywords_90_inline_inline(
	 (sfun_bglt) (obj_1714));
   }
}



/* isfun-loc-set! */
obj_t 
isfun_loc_set__164_inline_inline(sfun_bglt obj_124, obj_t val1447_125)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 694 */
      return
	 ((((sfun_bglt) CREF(obj_124))->loc) = ((obj_t) val1447_125), BUNSPEC);
   }
}



/* _isfun-loc-set! */
obj_t 
_isfun_loc_set__180_inline_inline(obj_t env_1715, obj_t obj_1716, obj_t val1447_1717)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 694 */
      return
	 isfun_loc_set__164_inline_inline(
	 (sfun_bglt) (obj_1716), val1447_1717);
   }
}



/* isfun-loc */
obj_t 
isfun_loc_80_inline_inline(sfun_bglt obj_126)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 694 */
      return
	 (((sfun_bglt) CREF(obj_126))->loc);
   }
}



/* _isfun-loc */
obj_t 
_isfun_loc_111_inline_inline(obj_t env_1718, obj_t obj_1719)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 694 */
      return
	 isfun_loc_80_inline_inline(
	 (sfun_bglt) (obj_1719));
   }
}



/* isfun-original-body */
node_bglt 
isfun_original_body_3_inline_inline(isfun_bglt obj_127)
{
   AN_OBJECT;
   {	/* Inline/inline.scm 25 */
      {
	 obj_t aux_1974;
	 {	/* Inline/inline.scm 25 */
	    object_bglt aux_1975;
	    aux_1975 =
	       (object_bglt) (obj_127);
	    aux_1974 =
	       OBJECT_WIDENING(aux_1975);
	 }
	 return
	    (((isfun_bglt) CREF(aux_1974))->original_body_40);
      }
   }
}



/* _isfun-original-body */
obj_t 
_isfun_original_body_22_inline_inline(obj_t env_1720, obj_t obj_1721)
{
   AN_OBJECT;
   {	/* Inline/inline.scm 25 */
      {		/* Inline/inline.scm 25 */
	 node_bglt aux_1979;
	 aux_1979 =
	    isfun_original_body_3_inline_inline(
	    (isfun_bglt) (obj_1721));
	 return
	    (obj_t) (aux_1979);
      }
   }
}



/* isfun-recursive-calls-set! */
obj_t 
isfun_recursive_calls_set__23_inline_inline(isfun_bglt obj_128, obj_t val1448_129)
{
   AN_OBJECT;
   {	/* Inline/inline.scm 26 */
      {
	 obj_t aux_1983;
	 {	/* Inline/inline.scm 26 */
	    object_bglt aux_1984;
	    aux_1984 =
	       (object_bglt) (obj_128);
	    aux_1983 =
	       OBJECT_WIDENING(aux_1984);
	 }
	 return
	    ((((isfun_bglt) CREF(aux_1983))->recursive_calls_44) = ((obj_t) val1448_129), BUNSPEC);
      }
   }
}



/* _isfun-recursive-calls-set! */
obj_t 
_isfun_recursive_calls_set__129_inline_inline(obj_t env_1722, obj_t obj_1723, obj_t val1448_1724)
{
   AN_OBJECT;
   {	/* Inline/inline.scm 26 */
      return
	 isfun_recursive_calls_set__23_inline_inline(
	 (isfun_bglt) (obj_1723), val1448_1724);
   }
}



/* isfun-recursive-calls */
obj_t 
isfun_recursive_calls_17_inline_inline(isfun_bglt obj_130)
{
   AN_OBJECT;
   {	/* Inline/inline.scm 26 */
      {
	 obj_t aux_1990;
	 {	/* Inline/inline.scm 26 */
	    object_bglt aux_1991;
	    aux_1991 =
	       (object_bglt) (obj_130);
	    aux_1990 =
	       OBJECT_WIDENING(aux_1991);
	 }
	 return
	    (((isfun_bglt) CREF(aux_1990))->recursive_calls_44);
      }
   }
}



/* _isfun-recursive-calls */
obj_t 
_isfun_recursive_calls_234_inline_inline(obj_t env_1725, obj_t obj_1726)
{
   AN_OBJECT;
   {	/* Inline/inline.scm 26 */
      return
	 isfun_recursive_calls_17_inline_inline(
	 (isfun_bglt) (obj_1726));
   }
}



/* sfun? */
bool_t 
sfun__199_inline_inline(obj_t obj_581)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 675 */
      return
	 is_a__118___object(obj_581, sfun_ast_var);
   }
}



/* _sfun? */
obj_t 
_sfun__63_inline_inline(obj_t env_1640, obj_t obj_1641)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 675 */
      {		/* ./Ast/var.scm 675 */
	 bool_t aux_1998;
	 aux_1998 =
	    sfun__199_inline_inline(obj_1641);
	 return
	    BBOOL(aux_1998);
      }
   }
}



/* method-init */
obj_t 
method_init_76_inline_inline()
{
   AN_OBJECT;
   {	/* Inline/inline.scm 14 */
      add_generic__110___object(inline_node_env_12_inline_inline, inline_node_default1476_env_173_inline_inline);
      add_inlined_method__244___object(inline_node_env_12_inline_inline, atom_ast_node, ((long) 0));
      add_inlined_method__244___object(inline_node_env_12_inline_inline, var_ast_node, ((long) 1));
      add_inlined_method__244___object(inline_node_env_12_inline_inline, kwote_ast_node, ((long) 2));
      add_inlined_method__244___object(inline_node_env_12_inline_inline, sequence_ast_node, ((long) 3));
      add_inlined_method__244___object(inline_node_env_12_inline_inline, app_ast_node, ((long) 4));
      add_inlined_method__244___object(inline_node_env_12_inline_inline, app_ly_162_ast_node, ((long) 5));
      add_inlined_method__244___object(inline_node_env_12_inline_inline, funcall_ast_node, ((long) 6));
      add_inlined_method__244___object(inline_node_env_12_inline_inline, pragma_ast_node, ((long) 7));
      add_inlined_method__244___object(inline_node_env_12_inline_inline, cast_ast_node, ((long) 8));
      add_inlined_method__244___object(inline_node_env_12_inline_inline, setq_ast_node, ((long) 9));
      add_inlined_method__244___object(inline_node_env_12_inline_inline, conditional_ast_node, ((long) 10));
      add_inlined_method__244___object(inline_node_env_12_inline_inline, fail_ast_node, ((long) 11));
      add_inlined_method__244___object(inline_node_env_12_inline_inline, select_ast_node, ((long) 12));
      add_inlined_method__244___object(inline_node_env_12_inline_inline, let_fun_218_ast_node, ((long) 13));
      add_inlined_method__244___object(inline_node_env_12_inline_inline, let_var_6_ast_node, ((long) 14));
      add_inlined_method__244___object(inline_node_env_12_inline_inline, set_ex_it_116_ast_node, ((long) 15));
      add_inlined_method__244___object(inline_node_env_12_inline_inline, jump_ex_it_184_ast_node, ((long) 16));
      add_inlined_method__244___object(inline_node_env_12_inline_inline, make_box_202_ast_node, ((long) 17));
      add_inlined_method__244___object(inline_node_env_12_inline_inline, box_ref_242_ast_node, ((long) 18));
      add_inlined_method__244___object(inline_node_env_12_inline_inline, box_set__221_ast_node, ((long) 19));
      {		/* Inline/inline.scm 14 */
	 obj_t object__struct_isfun1518_54_1731;
	 object__struct_isfun1518_54_1731 = proc1738_inline_inline;
	 add_method__1___object(object__struct_env_210___object, isfun_inline_inline, object__struct_isfun1518_54_1731);
      }
      {		/* Inline/inline.scm 14 */
	 obj_t struct_object__object_isfun1521_239_1727;
	 struct_object__object_isfun1521_239_1727 = proc1739_inline_inline;
	 return
	    add_method__1___object(struct_object__object_env_209___object, isfun_inline_inline, struct_object__object_isfun1521_239_1727);
      }
   }
}



/* struct+object->object-isfun1521 */
obj_t 
struct_object__object_isfun1521_239_inline_inline(obj_t env_1734, obj_t o_1735, obj_t s_1736)
{
   AN_OBJECT;
   {	/* Inline/inline.scm 24 */
      {
	 isfun_bglt o_1200;
	 obj_t s_1201;
	 {	/* Inline/inline.scm 24 */
	    isfun_bglt aux_2024;
	    o_1200 =
	       (isfun_bglt) (o_1735);
	    s_1201 = s_1736;
	    {

	       {	/* Inline/inline.scm 24 */
		  obj_t old1459_1204;
		  obj_t aux1460_1205;
		  {	/* Inline/inline.scm 24 */
		     obj_t next_method1520_75_1211;
		     next_method1520_75_1211 =
			find_super_class_method_167___object(
			(object_bglt) (o_1200), struct_object__object_env_209___object, isfun_inline_inline);
		     if (
			PROCEDUREP(next_method1520_75_1211))
		       {	/* Inline/inline.scm 24 */
			  old1459_1204 =
			     PROCEDURE_ENTRY(next_method1520_75_1211) (next_method1520_75_1211,
			     (obj_t) (o_1200), s_1201, BEOA);
		       }
		     else
		       {	/* Inline/inline.scm 24 */
			  PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method1520_75_1211);
			  {	/* Inline/inline.scm 24 */
			     object_bglt aux_2033;
			     aux_2033 =
				struct_object__object_93___object(
				(object_bglt) (o_1200), s_1201);
			     old1459_1204 =
				(obj_t) (aux_2033);
			  }
		       }
		  }
		  aux1460_1205 =
		     STRUCT_REF(s_1201, ((long) 0));
		  {	/* Inline/inline.scm 24 */
		     isfun_bglt new1461_1206;
		     new1461_1206 =
			((isfun_bglt) (old1459_1204));
		     {	/* Inline/inline.scm 24 */
			long arg1630_1207;
			arg1630_1207 =
			   class_num_218___object(isfun_inline_inline);
			{	/* Inline/inline.scm 24 */
			   obj_t obj_1489;
			   obj_1489 =
			      (obj_t) (new1461_1206);
			   (((obj_t) CREF(obj_1489))->header = MAKE_HEADER(arg1630_1207, 0), BUNSPEC);
			}
		     }
		     {	/* Inline/inline.scm 24 */
			isfun_bglt arg1631_1208;
			{	/* Inline/inline.scm 24 */
			   obj_t arg1633_1210;
			   arg1633_1210 =
			      STRUCT_REF(aux1460_1205, ((long) 1));
			   {	/* Inline/inline.scm 24 */
			      isfun_bglt res1732_1500;
			      {		/* Inline/inline.scm 24 */
				 node_bglt original_body_40_1495;
				 {	/* Inline/inline.scm 24 */
				    obj_t aux_2043;
				    aux_2043 =
				       STRUCT_REF(aux1460_1205, ((long) 0));
				    original_body_40_1495 =
				       (node_bglt) (aux_2043);
				 }
				 {	/* Inline/inline.scm 24 */
				    isfun_bglt new1449_1497;
				    new1449_1497 =
				       ((isfun_bglt) BREF(GC_MALLOC(sizeof(struct isfun))));
				    ((((isfun_bglt) CREF(new1449_1497))->original_body_40) = ((node_bglt) original_body_40_1495), BUNSPEC);
				    ((((isfun_bglt) CREF(new1449_1497))->recursive_calls_44) = ((obj_t) arg1633_1210), BUNSPEC);
				    res1732_1500 = new1449_1497;
				 }
			      }
			      arg1631_1208 = res1732_1500;
			   }
			}
			{	/* Inline/inline.scm 24 */
			   obj_t aux_2051;
			   object_bglt aux_2049;
			   aux_2051 =
			      (obj_t) (arg1631_1208);
			   aux_2049 =
			      (object_bglt) (new1461_1206);
			   OBJECT_WIDENING_SET(aux_2049, aux_2051);
			}
		     }
		     aux_2024 = new1461_1206;
		  }
	       }
	    }
	    return
	       (obj_t) (aux_2024);
	 }
      }
   }
}



/* object->struct-isfun1518 */
obj_t 
object__struct_isfun1518_54_inline_inline(obj_t env_1737, obj_t obj1456_1738)
{
   AN_OBJECT;
   {	/* Inline/inline.scm 24 */
      {
	 isfun_bglt obj1456_1188;
	 obj1456_1188 =
	    (isfun_bglt) (obj1456_1738);
	 {

	    {	/* Inline/inline.scm 24 */
	       obj_t res1457_1191;
	       {	/* Inline/inline.scm 24 */
		  obj_t next_method1517_190_1198;
		  next_method1517_190_1198 =
		     find_super_class_method_167___object(
		     (object_bglt) (obj1456_1188), object__struct_env_210___object, isfun_inline_inline);
		  if (
		     PROCEDUREP(next_method1517_190_1198))
		    {	/* Inline/inline.scm 24 */
		       res1457_1191 =
			  PROCEDURE_ENTRY(next_method1517_190_1198) (next_method1517_190_1198,
			  (obj_t) (obj1456_1188), BEOA);
		    }
		  else
		    {	/* Inline/inline.scm 24 */
		       PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method1517_190_1198);
		       res1457_1191 =
			  object__struct_50___object(
			  (object_bglt) (obj1456_1188));
		    }
	       }
	       {	/* Inline/inline.scm 24 */
		  obj_t aux1458_1192;
		  {	/* ./Llib/struct.scm 1415 */
		     obj_t aux_2066;
		     aux_2066 =
			CNST_TABLE_REF(((long) 1));
		     aux1458_1192 =
			make_struct(aux_2066, ((long) 2), BUNSPEC);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_2069;
		     {	/* Inline/inline.scm 24 */
			node_bglt aux_2070;
			{
			   obj_t aux_2071;
			   {	/* Inline/inline.scm 25 */
			      object_bglt aux_2072;
			      aux_2072 =
				 (object_bglt) (obj1456_1188);
			      aux_2071 =
				 OBJECT_WIDENING(aux_2072);
			   }
			   aux_2070 =
			      (((isfun_bglt) CREF(aux_2071))->original_body_40);
			}
			aux_2069 =
			   (obj_t) (aux_2070);
		     }
		     STRUCT_SET(aux1458_1192, ((long) 0), aux_2069);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_2078;
		     {
			obj_t aux_2079;
			{	/* Inline/inline.scm 26 */
			   object_bglt aux_2080;
			   aux_2080 =
			      (object_bglt) (obj1456_1188);
			   aux_2079 =
			      OBJECT_WIDENING(aux_2080);
			}
			aux_2078 =
			   (((isfun_bglt) CREF(aux_2079))->recursive_calls_44);
		     }
		     STRUCT_SET(aux1458_1192, ((long) 1), aux_2078);
		  }
		  STRUCT_SET(res1457_1191, ((long) 0), aux1458_1192);
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_2086;
		     aux_2086 =
			STRUCT_KEY(res1457_1191);
		     STRUCT_KEY_SET(aux1458_1192, aux_2086);
		  }
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_2089;
		     aux_2089 =
			CNST_TABLE_REF(((long) 1));
		     STRUCT_KEY_SET(res1457_1191, aux_2089);
		  }
		  return res1457_1191;
	       }
	    }
	 }
      }
   }
}



/* inline-node */
node_bglt 
inline_node_218_inline_inline(node_bglt node_4, long kfactor_5, obj_t stack_6)
{
   AN_OBJECT;
   {	/* Inline/inline.scm 60 */
      {
	 obj_t method1636_1217;
	 obj_t class1641_1218;
	 {	/* Inline/inline.scm 60 */
	    obj_t arg1644_1215;
	    obj_t arg1646_1216;
	    {	/* Inline/inline.scm 60 */
	       object_bglt obj_1503;
	       obj_1503 =
		  (object_bglt) (node_4);
	       {	/* ./Llib/object.scm 2926 */
		  obj_t pre_method_105_1504;
		  pre_method_105_1504 =
		     PROCEDURE_REF(inline_node_env_12_inline_inline, ((long) 2));
		  if (
		     INTEGERP(pre_method_105_1504))
		    {	/* ./Llib/object.scm 2927 */
		       PROCEDURE_SET(inline_node_env_12_inline_inline, ((long) 2), BUNSPEC);
		       arg1644_1215 = pre_method_105_1504;
		    }
		  else
		    {	/* ./Llib/object.scm 2914 */
		       long obj_class_num_177_1509;
		       obj_class_num_177_1509 =
			  TYPE(obj_1503);
		       {	/* ./Llib/object.scm 2915 */
			  obj_t arg1176_1510;
			  arg1176_1510 =
			     PROCEDURE_REF(inline_node_env_12_inline_inline, ((long) 1));
			  {	/* ./Llib/object.scm 2738 */
			     long arg1177_1514;
			     {	/* ./Llib/object.scm 2738 */
				long arg1178_1515;
				arg1178_1515 =
				   OBJECT_TYPE;
				arg1177_1514 =
				   (obj_class_num_177_1509 - arg1178_1515);
			     }
			     arg1644_1215 =
				VECTOR_REF(arg1176_1510, arg1177_1514);
			  }
		       }
		    }
	       }
	    }
	    {	/* Inline/inline.scm 60 */
	       object_bglt object_1520;
	       object_1520 =
		  (object_bglt) (node_4);
	       {	/* ./Llib/object.scm 2695 */
		  long arg1179_1521;
		  {	/* ./Llib/object.scm 2695 */
		     long arg1180_1522;
		     long arg1181_1523;
		     arg1180_1522 =
			TYPE(object_1520);
		     arg1181_1523 =
			OBJECT_TYPE;
		     arg1179_1521 =
			(arg1180_1522 - arg1181_1523);
		  }
		  {	/* ./Llib/object.scm 2695 */
		     obj_t vector_1527;
		     vector_1527 = _classes__134___object;
		     arg1646_1216 =
			VECTOR_REF(vector_1527, arg1179_1521);
		  }
	       }
	    }
	    {	/* Inline/inline.scm 60 */
	       obj_t aux_2108;
	       method1636_1217 = arg1644_1215;
	       class1641_1218 = arg1646_1216;
	       {

		  if (
		     INTEGERP(method1636_1217))
		    {	/* Inline/inline.scm 60 */
		       switch (
			  (long) CINT(method1636_1217))
			 {
			 case ((long) 0):

			    {	/* Inline/inline.scm 60 */
			       atom_bglt aux_2111;
			       aux_2111 =
				  (atom_bglt) (node_4);
			       aux_2108 =
				  (obj_t) (aux_2111);
			    }
			    break;
			 case ((long) 1):

			    {	/* Inline/inline.scm 72 */
			       var_bglt node_1227;
			       node_1227 =
				  (var_bglt) (node_4);
			       {	/* Inline/inline.scm 73 */
				  bool_t test1649_1231;
				  {	/* Inline/inline.scm 73 */
				     bool_t test1651_1233;
				     {	/* Inline/inline.scm 73 */
					long n1_1529;
					n1_1529 =
					   (long) CINT(_optim__89_engine_param);
					test1651_1233 =
					   (n1_1529 > ((long) 0));
				     }
				     if (test1651_1233)
				       {	/* Inline/inline.scm 74 */
					  bool_t test1652_1234;
					  {	/* ./Ast/var.scm 635 */
					     obj_t aux_2118;
					     {	/* Inline/inline.scm 74 */
						variable_bglt aux_2119;
						aux_2119 =
						   (((var_bglt) CREF(node_1227))->variable);
						aux_2118 =
						   (obj_t) (aux_2119);
					     }
					     test1652_1234 =
						is_a__118___object(aux_2118, global_ast_var);
					  }
					  if (test1652_1234)
					    {	/* Inline/inline.scm 75 */
					       bool_t test_2124;
					       {	/* ./Ieee/equiv.scm 5508 */
						  obj_t aux_2130;
						  obj_t aux_2125;
						  aux_2130 =
						     CNST_TABLE_REF(((long) 2));
						  {	/* Inline/inline.scm 75 */
						     global_bglt obj_1534;
						     {	/* Inline/inline.scm 75 */
							variable_bglt aux_2126;
							aux_2126 =
							   (((var_bglt) CREF(node_1227))->variable);
							obj_1534 =
							   (global_bglt) (aux_2126);
						     }
						     aux_2125 =
							(((global_bglt) CREF(obj_1534))->import);
						  }
						  test_2124 =
						     (aux_2125 == aux_2130);
					       }
					       if (test_2124)
						 {	/* Inline/inline.scm 76 */
						    bool_t test_2133;
						    {	/* ./Ieee/equiv.scm 5508 */
						       obj_t aux_2139;
						       obj_t aux_2134;
						       aux_2139 =
							  CNST_TABLE_REF(((long) 3));
						       {	/* Inline/inline.scm 76 */
							  global_bglt obj_1538;
							  {	/* Inline/inline.scm 76 */
							     variable_bglt aux_2135;
							     aux_2135 =
								(((var_bglt) CREF(node_1227))->variable);
							     obj_1538 =
								(global_bglt) (aux_2135);
							  }
							  aux_2134 =
							     (((global_bglt) CREF(obj_1538))->access);
						       }
						       test_2133 =
							  (aux_2134 == aux_2139);
						    }
						    if (test_2133)
						      {		/* ./Ast/node.scm 764 */
							 obj_t aux_2142;
							 {	/* Inline/inline.scm 77 */
							    global_bglt obj_1542;
							    {	/* Inline/inline.scm 77 */
							       variable_bglt aux_2143;
							       aux_2143 =
								  (((var_bglt) CREF(node_1227))->variable);
							       obj_1542 =
								  (global_bglt) (aux_2143);
							    }
							    aux_2142 =
							       (((global_bglt) CREF(obj_1542))->src);
							 }
							 test1649_1231 =
							    is_a__118___object(aux_2142, atom_ast_node);
						      }
						    else
						      {		/* Inline/inline.scm 76 */
							 test1649_1231 = ((bool_t) 0);
						      }
						 }
					       else
						 {	/* Inline/inline.scm 75 */
						    test1649_1231 = ((bool_t) 0);
						 }
					    }
					  else
					    {	/* Inline/inline.scm 74 */
					       test1649_1231 = ((bool_t) 0);
					    }
				       }
				     else
				       {	/* Inline/inline.scm 73 */
					  test1649_1231 = ((bool_t) 0);
				       }
				  }
				  if (test1649_1231)
				    {	/* Inline/inline.scm 73 */
				       {	/* Inline/inline.scm 81 */
					  global_bglt obj_1545;
					  {	/* Inline/inline.scm 81 */
					     variable_bglt aux_2149;
					     aux_2149 =
						(((var_bglt) CREF(node_1227))->variable);
					     obj_1545 =
						(global_bglt) (aux_2149);
					  }
					  aux_2108 =
					     (((global_bglt) CREF(obj_1545))->src);
				       }
				    }
				  else
				    {	/* Inline/inline.scm 73 */
				       aux_2108 =
					  (obj_t) (node_1227)
					  ;
				    }
			       }
			    }
			    break;
			 case ((long) 2):

			    {	/* Inline/inline.scm 60 */
			       kwote_bglt aux_2154;
			       aux_2154 =
				  (kwote_bglt) (node_4);
			       aux_2108 =
				  (obj_t) (aux_2154);
			    }
			    break;
			 case ((long) 3):

			    {	/* Inline/inline.scm 60 */
			       sequence_bglt node_1249;
			       node_1249 =
				  (sequence_bglt) (node_4);
			       inline_node___77_inline_inline(
				  (((sequence_bglt) CREF(node_1249))->nodes), kfactor_5, stack_6);
			       aux_2108 =
				  (obj_t) (node_1249);
			    }
			    break;
			 case ((long) 4):

			    {	/* Inline/inline.scm 60 */
			       app_bglt node_1253;
			       node_1253 =
				  (app_bglt) (node_4);
			       inline_node___77_inline_inline(
				  (((app_bglt) CREF(node_1253))->args), kfactor_5, stack_6);
			       {	/* Inline/inline.scm 102 */
				  node_bglt aux_2164;
				  aux_2164 =
				     inline_app_72_inline_app(node_1253, kfactor_5, stack_6);
				  aux_2108 =
				     (obj_t) (aux_2164);
			       }
			    }
			    break;
			 case ((long) 5):

			    {	/* Inline/inline.scm 108 */
			       app_ly_162_bglt node_1257;
			       node_1257 =
				  (app_ly_162_bglt) (node_4);
			       {	/* Inline/inline.scm 109 */
				  node_bglt arg1666_1261;
				  arg1666_1261 =
				     inline_node_218_inline_inline(
				     (((app_ly_162_bglt) CREF(node_1257))->fun), kfactor_5, stack_6);
				  ((((app_ly_162_bglt) CREF(node_1257))->fun) = ((node_bglt) arg1666_1261), BUNSPEC);
			       }
			       {	/* Inline/inline.scm 110 */
				  node_bglt arg1669_1263;
				  arg1669_1263 =
				     inline_node_218_inline_inline(
				     (((app_ly_162_bglt) CREF(node_1257))->arg), kfactor_5, stack_6);
				  ((((app_ly_162_bglt) CREF(node_1257))->arg) = ((node_bglt) arg1669_1263), BUNSPEC);
			       }
			       aux_2108 =
				  (obj_t) (node_1257);
			    }
			    break;
			 case ((long) 6):

			    {	/* Inline/inline.scm 60 */
			       funcall_bglt node_1265;
			       node_1265 =
				  (funcall_bglt) (node_4);
			       {	/* Inline/inline.scm 118 */
				  long z1_1554;
				  z1_1554 =
				     (long) CINT(_non_inlined_calls__201_inline_walk);
				  {	/* ./Ieee/fixnum.scm 7193 */
				     long aux_2177;
				     aux_2177 =
					(z1_1554 + ((long) 1));
				     _non_inlined_calls__201_inline_walk =
					BINT(aux_2177);
				  }
			       }
			       {	/* Inline/inline.scm 119 */
				  node_bglt arg1671_1268;
				  arg1671_1268 =
				     inline_node_218_inline_inline(
				     (((funcall_bglt) CREF(node_1265))->fun), kfactor_5, stack_6);
				  ((((funcall_bglt) CREF(node_1265))->fun) = ((node_bglt) arg1671_1268), BUNSPEC);
			       }
			       inline_node___77_inline_inline(
				  (((funcall_bglt) CREF(node_1265))->args), kfactor_5, stack_6);
			       aux_2108 =
				  (obj_t) (node_1265);
			    }
			    break;
			 case ((long) 7):

			    {	/* Inline/inline.scm 60 */
			       pragma_bglt node_1271;
			       node_1271 =
				  (pragma_bglt) (node_4);
			       inline_node___77_inline_inline(
				  (((pragma_bglt) CREF(node_1271))->args), kfactor_5, stack_6);
			       aux_2108 =
				  (obj_t) (node_1271);
			    }
			    break;
			 case ((long) 8):

			    {	/* Inline/inline.scm 60 */
			       cast_bglt node_1275;
			       node_1275 =
				  (cast_bglt) (node_4);
			       inline_node_218_inline_inline(
				  (((cast_bglt) CREF(node_1275))->arg), kfactor_5, stack_6);
			       aux_2108 =
				  (obj_t) (node_1275);
			    }
			    break;
			 case ((long) 9):

			    {	/* Inline/inline.scm 60 */
			       setq_bglt node_1279;
			       node_1279 =
				  (setq_bglt) (node_4);
			       {	/* Inline/inline.scm 141 */
				  node_bglt arg1676_1282;
				  arg1676_1282 =
				     inline_node_218_inline_inline(
				     (((setq_bglt) CREF(node_1279))->value), kfactor_5, stack_6);
				  ((((setq_bglt) CREF(node_1279))->value) = ((node_bglt) arg1676_1282), BUNSPEC);
			       }
			       aux_2108 =
				  (obj_t) (node_1279);
			    }
			    break;
			 case ((long) 10):

			    {	/* Inline/inline.scm 148 */
			       conditional_bglt node_1284;
			       node_1284 =
				  (conditional_bglt) (node_4);
			       {	/* Inline/inline.scm 149 */
				  node_bglt arg1678_1288;
				  arg1678_1288 =
				     inline_node_218_inline_inline(
				     (((conditional_bglt) CREF(node_1284))->test), kfactor_5, stack_6);
				  ((((conditional_bglt) CREF(node_1284))->test) = ((node_bglt) arg1678_1288), BUNSPEC);
			       }
			       {	/* Inline/inline.scm 150 */
				  node_bglt arg1680_1290;
				  arg1680_1290 =
				     inline_node_218_inline_inline(
				     (((conditional_bglt) CREF(node_1284))->true), kfactor_5, stack_6);
				  ((((conditional_bglt) CREF(node_1284))->true) = ((node_bglt) arg1680_1290), BUNSPEC);
			       }
			       {	/* Inline/inline.scm 151 */
				  node_bglt arg1682_1292;
				  arg1682_1292 =
				     inline_node_218_inline_inline(
				     (((conditional_bglt) CREF(node_1284))->false), kfactor_5, stack_6);
				  ((((conditional_bglt) CREF(node_1284))->false) = ((node_bglt) arg1682_1292), BUNSPEC);
			       }
			       aux_2108 =
				  (obj_t) (node_1284);
			    }
			    break;
			 case ((long) 11):

			    {	/* Inline/inline.scm 158 */
			       fail_bglt node_1294;
			       node_1294 =
				  (fail_bglt) (node_4);
			       {	/* Inline/inline.scm 159 */
				  node_bglt arg1684_1298;
				  arg1684_1298 =
				     inline_node_218_inline_inline(
				     (((fail_bglt) CREF(node_1294))->proc), kfactor_5, stack_6);
				  ((((fail_bglt) CREF(node_1294))->proc) = ((node_bglt) arg1684_1298), BUNSPEC);
			       }
			       {	/* Inline/inline.scm 160 */
				  node_bglt arg1686_1300;
				  arg1686_1300 =
				     inline_node_218_inline_inline(
				     (((fail_bglt) CREF(node_1294))->msg), kfactor_5, stack_6);
				  ((((fail_bglt) CREF(node_1294))->msg) = ((node_bglt) arg1686_1300), BUNSPEC);
			       }
			       {	/* Inline/inline.scm 161 */
				  node_bglt arg1688_1302;
				  arg1688_1302 =
				     inline_node_218_inline_inline(
				     (((fail_bglt) CREF(node_1294))->obj), kfactor_5, stack_6);
				  ((((fail_bglt) CREF(node_1294))->obj) = ((node_bglt) arg1688_1302), BUNSPEC);
			       }
			       aux_2108 =
				  (obj_t) (node_1294);
			    }
			    break;
			 case ((long) 12):

			    {	/* Inline/inline.scm 60 */
			       select_bglt node_1304;
			       node_1304 =
				  (select_bglt) (node_4);
			       {	/* Inline/inline.scm 168 */
				  node_bglt arg1690_1307;
				  arg1690_1307 =
				     inline_node_218_inline_inline(
				     (((select_bglt) CREF(node_1304))->test), kfactor_5, stack_6);
				  ((((select_bglt) CREF(node_1304))->test) = ((node_bglt) arg1690_1307), BUNSPEC);
			       }
			       {
				  obj_t l1467_1309;
				  l1467_1309 =
				     (((select_bglt) CREF(node_1304))->clauses);
				lname1468_1310:
				  if (
				     PAIRP(l1467_1309))
				    {	/* Inline/inline.scm 169 */
				       {	/* Inline/inline.scm 170 */
					  obj_t clause_1313;
					  clause_1313 =
					     CAR(l1467_1309);
					  {	/* Inline/inline.scm 170 */
					     node_bglt arg1694_1314;
					     {	/* Inline/inline.scm 170 */
						node_bglt aux_2228;
						{	/* Inline/inline.scm 170 */
						   obj_t aux_2229;
						   aux_2229 =
						      CDR(clause_1313);
						   aux_2228 =
						      (node_bglt) (aux_2229);
						}
						arg1694_1314 =
						   inline_node_218_inline_inline(aux_2228, kfactor_5, stack_6);
					     }
					     {	/* ./Ieee/pair-list.scm 5896 */
						obj_t aux_2233;
						aux_2233 =
						   (obj_t) (arg1694_1314);
						SET_CDR(clause_1313, aux_2233);
					     }
					  }
				       }
				       {
					  obj_t l1467_2236;
					  l1467_2236 =
					     CDR(l1467_1309);
					  l1467_1309 = l1467_2236;
					  goto lname1468_1310;
				       }
				    }
				  else
				    {	/* Inline/inline.scm 169 */
				       ((bool_t) 1);
				    }
			       }
			       aux_2108 =
				  (obj_t) (node_1304);
			    }
			    break;
			 case ((long) 13):

			    {	/* Inline/inline.scm 60 */
			       let_fun_218_bglt node_1317;
			       node_1317 =
				  (let_fun_218_bglt) (node_4);
			       {	/* Inline/inline.scm 178 */
				  node_bglt arg1697_1320;
				  arg1697_1320 =
				     inline_node_218_inline_inline(
				     (((let_fun_218_bglt) CREF(node_1317))->body), kfactor_5, stack_6);
				  ((((let_fun_218_bglt) CREF(node_1317))->body) = ((node_bglt) arg1697_1320), BUNSPEC);
			       }
			       {
				  obj_t l1469_1322;
				  l1469_1322 =
				     (((let_fun_218_bglt) CREF(node_1317))->locals);
				lname1470_1323:
				  if (
				     PAIRP(l1469_1322))
				    {	/* Inline/inline.scm 179 */
				       {	/* Inline/inline.scm 180 */
					  variable_bglt aux_2246;
					  {	/* Inline/inline.scm 180 */
					     obj_t aux_2247;
					     aux_2247 =
						CAR(l1469_1322);
					     aux_2246 =
						(variable_bglt) (aux_2247);
					  }
					  inline_sfun__229_inline_inline(aux_2246, kfactor_5, stack_6);
				       }
				       {
					  obj_t l1469_2251;
					  l1469_2251 =
					     CDR(l1469_1322);
					  l1469_1322 = l1469_2251;
					  goto lname1470_1323;
				       }
				    }
				  else
				    {	/* Inline/inline.scm 179 */
				       ((bool_t) 1);
				    }
			       }
			       aux_2108 =
				  (obj_t) (node_1317);
			    }
			    break;
			 case ((long) 14):

			    {	/* Inline/inline.scm 60 */
			       let_var_6_bglt node_1328;
			       node_1328 =
				  (let_var_6_bglt) (node_4);
			       {
				  obj_t l1471_1331;
				  l1471_1331 =
				     (((let_var_6_bglt) CREF(node_1328))->bindings);
				lname1472_1332:
				  if (
				     PAIRP(l1471_1331))
				    {	/* Inline/inline.scm 188 */
				       {	/* Inline/inline.scm 189 */
					  obj_t binding_1335;
					  binding_1335 =
					     CAR(l1471_1331);
					  {	/* Inline/inline.scm 189 */
					     node_bglt arg1704_1336;
					     {	/* Inline/inline.scm 189 */
						node_bglt aux_2259;
						{	/* Inline/inline.scm 189 */
						   obj_t aux_2260;
						   aux_2260 =
						      CDR(binding_1335);
						   aux_2259 =
						      (node_bglt) (aux_2260);
						}
						arg1704_1336 =
						   inline_node_218_inline_inline(aux_2259, kfactor_5, stack_6);
					     }
					     {	/* ./Ieee/pair-list.scm 5896 */
						obj_t aux_2264;
						aux_2264 =
						   (obj_t) (arg1704_1336);
						SET_CDR(binding_1335, aux_2264);
					     }
					  }
				       }
				       {
					  obj_t l1471_2267;
					  l1471_2267 =
					     CDR(l1471_1331);
					  l1471_1331 = l1471_2267;
					  goto lname1472_1332;
				       }
				    }
				  else
				    {	/* Inline/inline.scm 188 */
				       ((bool_t) 1);
				    }
			       }
			       {	/* Inline/inline.scm 191 */
				  node_bglt arg1707_1339;
				  arg1707_1339 =
				     inline_node_218_inline_inline(
				     (((let_var_6_bglt) CREF(node_1328))->body), kfactor_5, stack_6);
				  ((((let_var_6_bglt) CREF(node_1328))->body) = ((node_bglt) arg1707_1339), BUNSPEC);
			       }
			       aux_2108 =
				  (obj_t) (node_1328);
			    }
			    break;
			 case ((long) 15):

			    {	/* Inline/inline.scm 60 */
			       set_ex_it_116_bglt node_1341;
			       node_1341 =
				  (set_ex_it_116_bglt) (node_4);
			       {	/* Inline/inline.scm 198 */
				  node_bglt arg1709_1344;
				  arg1709_1344 =
				     inline_node_218_inline_inline(
				     (((set_ex_it_116_bglt) CREF(node_1341))->body), kfactor_5, stack_6);
				  ((((set_ex_it_116_bglt) CREF(node_1341))->body) = ((node_bglt) arg1709_1344), BUNSPEC);
			       }
			       aux_2108 =
				  (obj_t) (node_1341);
			    }
			    break;
			 case ((long) 16):

			    {	/* Inline/inline.scm 205 */
			       jump_ex_it_184_bglt node_1346;
			       node_1346 =
				  (jump_ex_it_184_bglt) (node_4);
			       {	/* Inline/inline.scm 206 */
				  node_bglt arg1712_1350;
				  arg1712_1350 =
				     inline_node_218_inline_inline(
				     (((jump_ex_it_184_bglt) CREF(node_1346))->exit), kfactor_5, stack_6);
				  ((((jump_ex_it_184_bglt) CREF(node_1346))->exit) = ((node_bglt) arg1712_1350), BUNSPEC);
			       }
			       {	/* Inline/inline.scm 207 */
				  node_bglt arg1714_1352;
				  arg1714_1352 =
				     inline_node_218_inline_inline(
				     (((jump_ex_it_184_bglt) CREF(node_1346))->value), kfactor_5, stack_6);
				  ((((jump_ex_it_184_bglt) CREF(node_1346))->value) = ((node_bglt) arg1714_1352), BUNSPEC);
			       }
			       aux_2108 =
				  (obj_t) (node_1346);
			    }
			    break;
			 case ((long) 17):

			    {	/* Inline/inline.scm 60 */
			       make_box_202_bglt node_1354;
			       node_1354 =
				  (make_box_202_bglt) (node_4);
			       {	/* Inline/inline.scm 214 */
				  node_bglt arg1716_1357;
				  arg1716_1357 =
				     inline_node_218_inline_inline(
				     (((make_box_202_bglt) CREF(node_1354))->value), kfactor_5, stack_6);
				  ((((make_box_202_bglt) CREF(node_1354))->value) = ((node_bglt) arg1716_1357), BUNSPEC);
			       }
			       aux_2108 =
				  (obj_t) (node_1354);
			    }
			    break;
			 case ((long) 18):

			    {	/* Inline/inline.scm 60 */
			       box_ref_242_bglt node_1359;
			       node_1359 =
				  (box_ref_242_bglt) (node_4);
			       {	/* Inline/inline.scm 221 */
				  node_bglt arg1718_1362;
				  {	/* Inline/inline.scm 221 */
				     node_bglt aux_2293;
				     {	/* Inline/inline.scm 221 */
					var_bglt aux_2294;
					aux_2294 =
					   (((box_ref_242_bglt) CREF(node_1359))->var);
					aux_2293 =
					   (node_bglt) (aux_2294);
				     }
				     arg1718_1362 =
					inline_node_218_inline_inline(aux_2293, kfactor_5, stack_6);
				  }
				  {	/* Inline/inline.scm 221 */
				     var_bglt val1418_1624;
				     val1418_1624 =
					(var_bglt) (arg1718_1362);
				     ((((box_ref_242_bglt) CREF(node_1359))->var) = ((var_bglt) val1418_1624), BUNSPEC);
				  }
			       }
			       aux_2108 =
				  (obj_t) (node_1359);
			    }
			    break;
			 case ((long) 19):

			    {	/* Inline/inline.scm 228 */
			       box_set__221_bglt node_1364;
			       node_1364 =
				  (box_set__221_bglt) (node_4);
			       {	/* Inline/inline.scm 229 */
				  node_bglt arg1720_1368;
				  {	/* Inline/inline.scm 229 */
				     node_bglt aux_2302;
				     {	/* Inline/inline.scm 229 */
					var_bglt aux_2303;
					aux_2303 =
					   (((box_set__221_bglt) CREF(node_1364))->var);
					aux_2302 =
					   (node_bglt) (aux_2303);
				     }
				     arg1720_1368 =
					inline_node_218_inline_inline(aux_2302, kfactor_5, stack_6);
				  }
				  {	/* Inline/inline.scm 229 */
				     var_bglt val1428_1627;
				     val1428_1627 =
					(var_bglt) (arg1720_1368);
				     ((((box_set__221_bglt) CREF(node_1364))->var) = ((var_bglt) val1428_1627), BUNSPEC);
				  }
			       }
			       {	/* Inline/inline.scm 230 */
				  node_bglt arg1722_1370;
				  arg1722_1370 =
				     inline_node_218_inline_inline(
				     (((box_set__221_bglt) CREF(node_1364))->value), kfactor_5, stack_6);
				  ((((box_set__221_bglt) CREF(node_1364))->value) = ((node_bglt) arg1722_1370), BUNSPEC);
			       }
			       aux_2108 =
				  (obj_t) (node_1364);
			    }
			    break;
			 default:
			  case_else1642_1221:
			    if (
			       PROCEDUREP(method1636_1217))
			      {		/* Inline/inline.scm 60 */
				 aux_2108 =
				    PROCEDURE_ENTRY(method1636_1217) (method1636_1217,
				    (obj_t) (node_4),
				    BINT(kfactor_5), stack_6, BEOA)
				    ;
			      }
			    else
			      {		/* Inline/inline.scm 60 */
				 obj_t fun1635_1213;
				 fun1635_1213 =
				    PROCEDURE_REF(inline_node_env_12_inline_inline, ((long) 0));
				 aux_2108 =
				    PROCEDURE_ENTRY(fun1635_1213) (fun1635_1213,
				    (obj_t) (node_4),
				    BINT(kfactor_5), stack_6, BEOA);
			      }
			 }
		    }
		  else
		    {	/* Inline/inline.scm 60 */
		       goto case_else1642_1221;
		    }
	       }
	       return
		  (node_bglt) (aux_2108);
	    }
	 }
      }
   }
}



/* _inline-node */
obj_t 
_inline_node_166_inline_inline(obj_t env_1739, obj_t node_1740, obj_t kfactor_1741, obj_t stack_1742)
{
   AN_OBJECT;
   {	/* Inline/inline.scm 60 */
      {		/* Inline/inline.scm 60 */
	 node_bglt aux_2327;
	 aux_2327 =
	    inline_node_218_inline_inline(
	    (node_bglt) (node_1740),
	    (long) CINT(kfactor_1741), stack_1742);
	 return
	    (obj_t) (aux_2327);
      }
   }
}



/* inline-node-default1476 */
node_bglt 
inline_node_default1476_251_inline_inline(node_bglt node_7, long kfactor_8, obj_t stack_9)
{
   AN_OBJECT;
   {	/* Inline/inline.scm 14 */
      FAILURE(
	 CNST_TABLE_REF(((long) 4)), string1740_inline_inline,
	 (obj_t) (node_7));
   }
}



/* _inline-node-default1476 */
obj_t 
_inline_node_default1476_23_inline_inline(obj_t env_1743, obj_t node_1744, obj_t kfactor_1745, obj_t stack_1746)
{
   AN_OBJECT;
   {	/* Inline/inline.scm 14 */
      {		/* Inline/inline.scm 14 */
	 node_bglt aux_2335;
	 aux_2335 =
	    inline_node_default1476_251_inline_inline(
	    (node_bglt) (node_1744),
	    (long) CINT(kfactor_1745), stack_1746);
	 return
	    (obj_t) (aux_2335);
      }
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_inline_inline()
{
   AN_OBJECT;
   {	/* Inline/inline.scm 14 */
      module_initialization_70_type_type(((long) 0), "INLINE_INLINE");
      module_initialization_70_ast_var(((long) 0), "INLINE_INLINE");
      module_initialization_70_ast_node(((long) 0), "INLINE_INLINE");
      module_initialization_70_tools_trace(((long) 0), "INLINE_INLINE");
      module_initialization_70_inline_walk(((long) 0), "INLINE_INLINE");
      module_initialization_70_inline_app(((long) 0), "INLINE_INLINE");
      module_initialization_70_ast_alphatize(((long) 0), "INLINE_INLINE");
      module_initialization_70_engine_param(((long) 0), "INLINE_INLINE");
      module_initialization_70_tools_shape(((long) 0), "INLINE_INLINE");
      return
	 module_initialization_70_tools_error(((long) 0), "INLINE_INLINE");
   }
}
