/*===========================================================================*/
/*   (Inline/loop.scm)                                                       */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;

typedef struct isfun
  {
     struct node *original_body_40;
     obj_t recursive_calls_44;
  }
     *isfun_bglt;

typedef struct local_variant_63
  {
     bool_t variant;
  }
                *local_variant_63_bglt;


static obj_t method_init_76_inline_loop();
extern obj_t make_box_202_ast_node;
extern obj_t funcall_ast_node;
extern long add_inlined_method__244___object(obj_t, obj_t, long);
extern obj_t fail_ast_node;
extern obj_t box_ref_242_ast_node;
static obj_t _find_let_fun__218_inline_loop(obj_t, obj_t);
extern obj_t sequence_ast_node;
extern obj_t let_var_6_ast_node;
extern obj_t var_ast_node;
extern obj_t pragma_ast_node;
extern obj_t set_ex_it_116_ast_node;
extern bool_t is_a__118___object(obj_t, obj_t);
static bool_t find_let_fun__default1508_172_inline_loop(node_bglt);
extern obj_t module_initialization_70_inline_loop(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_ast_local(long, char *);
extern obj_t module_initialization_70_ast_sexp(long, char *);
extern obj_t module_initialization_70_tools_speek(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_inline_inline(long, char *);
extern obj_t module_initialization_70_inline_variant(long, char *);
extern obj_t module_initialization_70_inline_recursion(long, char *);
extern obj_t module_initialization_70_effect_effect(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
static obj_t _nest_loop__216_inline_loop(obj_t, obj_t, obj_t, obj_t);
static bool_t find_let_fun___232_inline_loop(obj_t);
extern long list_length(obj_t);
static obj_t _is_loop__141_inline_loop(obj_t, obj_t);
extern obj_t let_fun_218_ast_node;
extern bool_t is_loop__232_inline_loop(variable_bglt);
static obj_t imported_modules_init_94_inline_loop();
static obj_t _nest_loop__default1548_34_inline_loop(obj_t, obj_t, obj_t, obj_t);
extern obj_t app_ly_162_ast_node;
extern obj_t add_generic__110___object(obj_t, obj_t);
extern obj_t app_ast_node;
static obj_t library_modules_init_112_inline_loop();
static obj_t _inner_loop__3_inline_loop(obj_t, obj_t);
extern obj_t atom_ast_node;
extern obj_t cast_ast_node;
static obj_t toplevel_init_63_inline_loop();
static obj_t find_let_fun__180_inline_loop(node_bglt);
extern obj_t jump_ex_it_184_ast_node;
extern obj_t open_input_string(obj_t);
extern obj_t kwote_ast_node;
extern bool_t inner_loop__79_inline_loop(variable_bglt);
extern obj_t setq_ast_node;
extern bool_t is_recursive__125_inline_recursion(variable_bglt);
extern obj_t box_set__221_ast_node;
static obj_t nest_loop___100_inline_loop(obj_t, local_bglt, obj_t);
static obj_t _find_let_fun__default1508_14_inline_loop(obj_t, obj_t);
extern obj_t _classes__134___object;
extern obj_t select_ast_node;
extern obj_t read___reader(obj_t);
static obj_t require_initialization_114_inline_loop = BUNSPEC;
extern obj_t conditional_ast_node;
static node_bglt nest_loop__default1548_108_inline_loop(node_bglt, local_bglt, obj_t);
extern node_bglt nest_loop__92_inline_loop(node_bglt, local_bglt, obj_t);
static obj_t cnst_init_137_inline_loop();
static obj_t __cnst[2];

DEFINE_EXPORT_GENERIC(nest_loop__env_29_inline_loop, _nest_loop__216_inline_loop1835, _nest_loop__216_inline_loop, 0L, 3);
DEFINE_STATIC_GENERIC(find_let_fun__env_154_inline_loop, _find_let_fun__218_inline_loop1836, _find_let_fun__218_inline_loop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(inner_loop__env_141_inline_loop, _inner_loop__3_inline_loop1837, _inner_loop__3_inline_loop, 0L, 1);
DEFINE_STATIC_PROCEDURE(find_let_fun__default1508_env_224_inline_loop, _find_let_fun__default1508_14_inline_loop1838, _find_let_fun__default1508_14_inline_loop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(is_loop__env_96_inline_loop, _is_loop__141_inline_loop1839, _is_loop__141_inline_loop, 0L, 1);
DEFINE_STATIC_PROCEDURE(nest_loop__default1548_env_26_inline_loop, _nest_loop__default1548_34_inline_loop1840, _nest_loop__default1548_34_inline_loop, 0L, 3);
DEFINE_STRING(string1829_inline_loop, string1829_inline_loop1841, "No method for this object", 25);
DEFINE_STRING(string1830_inline_loop, string1830_inline_loop1842, "NEST-LOOP!-DEFAULT1548 DONE ", 28);



/* module-initialization */
obj_t 
module_initialization_70_inline_loop(long checksum_1764, char *from_1765)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_inline_loop))
	{
	   require_initialization_114_inline_loop =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_inline_loop();
	   cnst_init_137_inline_loop();
	   imported_modules_init_94_inline_loop();
	   method_init_76_inline_loop();
	   toplevel_init_63_inline_loop();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_inline_loop()
{
   AN_OBJECT;
   {	/* Inline/loop.scm 14 */
      module_initialization_70___object(((long) 0), "INLINE_LOOP");
      module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "INLINE_LOOP");
      module_initialization_70___reader(((long) 0), "INLINE_LOOP");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_inline_loop()
{
   AN_OBJECT;
   {	/* Inline/loop.scm 14 */
      {		/* Inline/loop.scm 14 */
	 obj_t cnst_port_138_1757;
	 cnst_port_138_1757 =
	    open_input_string(string1830_inline_loop);
	 {
	    long i_1758;
	    i_1758 = ((long) 1);
	  loop_1759:
	    {	/* Inline/loop.scm 14 */
	       bool_t test1831_1760;
	       test1831_1760 =
		  (i_1758 == ((long) -1));
	       if (test1831_1760)
		 {	/* Inline/loop.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Inline/loop.scm 14 */
		    {	/* Inline/loop.scm 14 */
		       obj_t arg1832_1761;
		       {	/* Inline/loop.scm 14 */
			  obj_t list1833_1762;
			  list1833_1762 =
			     MAKE_PAIR(cnst_port_138_1757, BNIL);
			  arg1832_1761 =
			     read___reader(list1833_1762);
		       }
		       CNST_TABLE_SET(i_1758, arg1832_1761);
		    }
		    {	/* Inline/loop.scm 14 */
		       int aux_1763;
		       {	/* Inline/loop.scm 14 */
			  long aux_1783;
			  aux_1783 =
			     (i_1758 - ((long) 1));
			  aux_1763 =
			     (int) (aux_1783);
		       }
		       {
			  long i_1786;
			  i_1786 =
			     (long) (aux_1763);
			  i_1758 = i_1786;
			  goto loop_1759;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_inline_loop()
{
   AN_OBJECT;
   {	/* Inline/loop.scm 14 */
      return BUNSPEC;
   }
}



/* is-loop? */
bool_t 
is_loop__232_inline_loop(variable_bglt variable_1)
{
   AN_OBJECT;
   {	/* Inline/loop.scm 38 */
      {		/* Inline/loop.scm 40 */
	 bool_t _andtest_1471_884;
	 _andtest_1471_884 =
	    is_recursive__125_inline_recursion(variable_1);
	 if (_andtest_1471_884)
	   {	/* ./Ieee/fixnum.scm 7109 */
	      long aux_1790;
	      {		/* Inline/loop.scm 41 */
		 obj_t aux_1791;
		 {	/* Inline/loop.scm 41 */
		    isfun_bglt obj_1507;
		    {	/* Inline/loop.scm 41 */
		       value_bglt aux_1792;
		       aux_1792 =
			  (((variable_bglt) CREF(variable_1))->value);
		       obj_1507 =
			  (isfun_bglt) (aux_1792);
		    }
		    {
		       obj_t aux_1795;
		       {	/* ./Inline/inline.scm 1421 */
			  object_bglt aux_1796;
			  aux_1796 =
			     (object_bglt) (obj_1507);
			  aux_1795 =
			     OBJECT_WIDENING(aux_1796);
		       }
		       aux_1791 =
			  (((isfun_bglt) CREF(aux_1795))->recursive_calls_44);
		    }
		 }
		 aux_1790 =
		    list_length(aux_1791);
	      }
	      return
		 (aux_1790 == ((long) 1));
	   }
	 else
	   {	/* Inline/loop.scm 40 */
	      return ((bool_t) 0);
	   }
      }
   }
}



/* _is-loop? */
obj_t 
_is_loop__141_inline_loop(obj_t env_1741, obj_t variable_1742)
{
   AN_OBJECT;
   {	/* Inline/loop.scm 38 */
      {		/* Inline/loop.scm 38 */
	 bool_t aux_1802;
	 aux_1802 =
	    is_loop__232_inline_loop(
	    (variable_bglt) (variable_1742));
	 return
	    BBOOL(aux_1802);
      }
   }
}



/* inner-loop? */
bool_t 
inner_loop__79_inline_loop(variable_bglt variable_2)
{
   AN_OBJECT;
   {	/* Inline/loop.scm 48 */
      {		/* Inline/loop.scm 49 */
	 obj_t aux_1806;
	 {	/* Inline/loop.scm 49 */
	    node_bglt aux_1807;
	    {	/* Inline/loop.scm 49 */
	       obj_t aux_1808;
	       {	/* Inline/loop.scm 49 */
		  sfun_bglt obj_1513;
		  {	/* Inline/loop.scm 49 */
		     value_bglt aux_1809;
		     aux_1809 =
			(((variable_bglt) CREF(variable_2))->value);
		     obj_1513 =
			(sfun_bglt) (aux_1809);
		  }
		  aux_1808 =
		     (((sfun_bglt) CREF(obj_1513))->body);
	       }
	       aux_1807 =
		  (node_bglt) (aux_1808);
	    }
	    aux_1806 =
	       find_let_fun__180_inline_loop(aux_1807);
	 }
	 return
	    CBOOL(aux_1806);
      }
   }
}



/* _inner-loop? */
obj_t 
_inner_loop__3_inline_loop(obj_t env_1743, obj_t variable_1744)
{
   AN_OBJECT;
   {	/* Inline/loop.scm 48 */
      {		/* Inline/loop.scm 48 */
	 bool_t aux_1816;
	 aux_1816 =
	    inner_loop__79_inline_loop(
	    (variable_bglt) (variable_1744));
	 return
	    BBOOL(aux_1816);
      }
   }
}



/* find-let-fun?* */
bool_t 
find_let_fun___232_inline_loop(obj_t node__221_22)
{
   AN_OBJECT;
   {	/* Inline/loop.scm 188 */
      {
	 obj_t node__221_891;
	 node__221_891 = node__221_22;
       loop_892:
	 if (
	    NULLP(node__221_891))
	   {	/* Inline/loop.scm 191 */
	      return ((bool_t) 0);
	   }
	 else
	   {	/* Inline/loop.scm 193 */
	      bool_t test1601_894;
	      {		/* Inline/loop.scm 193 */
		 obj_t aux_1822;
		 {	/* Inline/loop.scm 193 */
		    node_bglt aux_1823;
		    {	/* Inline/loop.scm 193 */
		       obj_t aux_1824;
		       aux_1824 =
			  CAR(node__221_891);
		       aux_1823 =
			  (node_bglt) (aux_1824);
		    }
		    aux_1822 =
		       find_let_fun__180_inline_loop(aux_1823);
		 }
		 test1601_894 =
		    CBOOL(aux_1822);
	      }
	      if (test1601_894)
		{	/* Inline/loop.scm 193 */
		   return ((bool_t) 1);
		}
	      else
		{	/* Inline/loop.scm 193 */
		   {
		      obj_t node__221_1830;
		      node__221_1830 =
			 CDR(node__221_891);
		      node__221_891 = node__221_1830;
		      goto loop_892;
		   }
		}
	   }
      }
   }
}



/* nest-loop!* */
obj_t 
nest_loop___100_inline_loop(obj_t node__221_89, local_bglt var_90, obj_t nester_91)
{
   AN_OBJECT;
   {	/* Inline/loop.scm 380 */
      {
	 obj_t node__221_897;
	 node__221_897 = node__221_89;
       loop_898:
	 if (
	    NULLP(node__221_897))
	   {	/* Inline/loop.scm 382 */
	      return
		 CNST_TABLE_REF(((long) 0));
	   }
	 else
	   {	/* Inline/loop.scm 382 */
	      {		/* Inline/loop.scm 385 */
		 node_bglt arg1605_900;
		 {	/* Inline/loop.scm 385 */
		    node_bglt aux_1835;
		    {	/* Inline/loop.scm 385 */
		       obj_t aux_1836;
		       aux_1836 =
			  CAR(node__221_897);
		       aux_1835 =
			  (node_bglt) (aux_1836);
		    }
		    arg1605_900 =
		       nest_loop__92_inline_loop(aux_1835, var_90, nester_91);
		 }
		 {	/* ./Ieee/pair-list.scm 5890 */
		    obj_t aux_1840;
		    aux_1840 =
		       (obj_t) (arg1605_900);
		    SET_CAR(node__221_897, aux_1840);
		 }
	      }
	      {
		 obj_t node__221_1843;
		 node__221_1843 =
		    CDR(node__221_897);
		 node__221_897 = node__221_1843;
		 goto loop_898;
	      }
	   }
      }
   }
}



/* method-init */
obj_t 
method_init_76_inline_loop()
{
   AN_OBJECT;
   {	/* Inline/loop.scm 14 */
      add_generic__110___object(find_let_fun__env_154_inline_loop, find_let_fun__default1508_env_224_inline_loop);
      add_inlined_method__244___object(find_let_fun__env_154_inline_loop, sequence_ast_node, ((long) 0));
      add_inlined_method__244___object(find_let_fun__env_154_inline_loop, app_ast_node, ((long) 1));
      add_inlined_method__244___object(find_let_fun__env_154_inline_loop, app_ly_162_ast_node, ((long) 2));
      add_inlined_method__244___object(find_let_fun__env_154_inline_loop, funcall_ast_node, ((long) 3));
      add_inlined_method__244___object(find_let_fun__env_154_inline_loop, pragma_ast_node, ((long) 4));
      add_inlined_method__244___object(find_let_fun__env_154_inline_loop, cast_ast_node, ((long) 5));
      add_inlined_method__244___object(find_let_fun__env_154_inline_loop, setq_ast_node, ((long) 6));
      add_inlined_method__244___object(find_let_fun__env_154_inline_loop, conditional_ast_node, ((long) 7));
      add_inlined_method__244___object(find_let_fun__env_154_inline_loop, fail_ast_node, ((long) 8));
      add_inlined_method__244___object(find_let_fun__env_154_inline_loop, select_ast_node, ((long) 9));
      add_inlined_method__244___object(find_let_fun__env_154_inline_loop, let_fun_218_ast_node, ((long) 10));
      add_inlined_method__244___object(find_let_fun__env_154_inline_loop, let_var_6_ast_node, ((long) 11));
      add_inlined_method__244___object(find_let_fun__env_154_inline_loop, set_ex_it_116_ast_node, ((long) 12));
      add_inlined_method__244___object(find_let_fun__env_154_inline_loop, jump_ex_it_184_ast_node, ((long) 13));
      add_inlined_method__244___object(find_let_fun__env_154_inline_loop, make_box_202_ast_node, ((long) 14));
      add_inlined_method__244___object(find_let_fun__env_154_inline_loop, box_ref_242_ast_node, ((long) 15));
      add_inlined_method__244___object(find_let_fun__env_154_inline_loop, box_set__221_ast_node, ((long) 16));
      add_generic__110___object(nest_loop__env_29_inline_loop, nest_loop__default1548_env_26_inline_loop);
      add_inlined_method__244___object(nest_loop__env_29_inline_loop, atom_ast_node, ((long) 0));
      add_inlined_method__244___object(nest_loop__env_29_inline_loop, kwote_ast_node, ((long) 1));
      add_inlined_method__244___object(nest_loop__env_29_inline_loop, var_ast_node, ((long) 2));
      add_inlined_method__244___object(nest_loop__env_29_inline_loop, sequence_ast_node, ((long) 3));
      add_inlined_method__244___object(nest_loop__env_29_inline_loop, app_ast_node, ((long) 4));
      add_inlined_method__244___object(nest_loop__env_29_inline_loop, app_ly_162_ast_node, ((long) 5));
      add_inlined_method__244___object(nest_loop__env_29_inline_loop, funcall_ast_node, ((long) 6));
      add_inlined_method__244___object(nest_loop__env_29_inline_loop, pragma_ast_node, ((long) 7));
      add_inlined_method__244___object(nest_loop__env_29_inline_loop, cast_ast_node, ((long) 8));
      add_inlined_method__244___object(nest_loop__env_29_inline_loop, setq_ast_node, ((long) 9));
      add_inlined_method__244___object(nest_loop__env_29_inline_loop, conditional_ast_node, ((long) 10));
      add_inlined_method__244___object(nest_loop__env_29_inline_loop, fail_ast_node, ((long) 11));
      add_inlined_method__244___object(nest_loop__env_29_inline_loop, select_ast_node, ((long) 12));
      add_inlined_method__244___object(nest_loop__env_29_inline_loop, let_fun_218_ast_node, ((long) 13));
      add_inlined_method__244___object(nest_loop__env_29_inline_loop, let_var_6_ast_node, ((long) 14));
      add_inlined_method__244___object(nest_loop__env_29_inline_loop, set_ex_it_116_ast_node, ((long) 15));
      add_inlined_method__244___object(nest_loop__env_29_inline_loop, jump_ex_it_184_ast_node, ((long) 16));
      add_inlined_method__244___object(nest_loop__env_29_inline_loop, make_box_202_ast_node, ((long) 17));
      add_inlined_method__244___object(nest_loop__env_29_inline_loop, box_ref_242_ast_node, ((long) 18));
      {		/* Inline/loop.scm 14 */
	 long aux_1883;
	 aux_1883 =
	    add_inlined_method__244___object(nest_loop__env_29_inline_loop, box_set__221_ast_node, ((long) 19));
	 return
	    BINT(aux_1883);
      }
   }
}



/* find-let-fun? */
obj_t 
find_let_fun__180_inline_loop(node_bglt node_3)
{
   AN_OBJECT;
   {	/* Inline/loop.scm 54 */
    find_let_fun__180_inline_loop:
      {
	 obj_t method1772_1418;
	 obj_t class1777_1419;
	 {	/* Inline/loop.scm 54 */
	    obj_t arg1780_1416;
	    obj_t arg1781_1417;
	    {	/* Inline/loop.scm 54 */
	       object_bglt obj_1557;
	       obj_1557 =
		  (object_bglt) (node_3);
	       {	/* ./Llib/object.scm 2926 */
		  obj_t pre_method_105_1558;
		  pre_method_105_1558 =
		     PROCEDURE_REF(find_let_fun__env_154_inline_loop, ((long) 2));
		  if (
		     INTEGERP(pre_method_105_1558))
		    {	/* ./Llib/object.scm 2927 */
		       PROCEDURE_SET(find_let_fun__env_154_inline_loop, ((long) 2), BUNSPEC);
		       arg1780_1416 = pre_method_105_1558;
		    }
		  else
		    {	/* ./Llib/object.scm 2914 */
		       long obj_class_num_177_1563;
		       obj_class_num_177_1563 =
			  TYPE(obj_1557);
		       {	/* ./Llib/object.scm 2915 */
			  obj_t arg1176_1564;
			  arg1176_1564 =
			     PROCEDURE_REF(find_let_fun__env_154_inline_loop, ((long) 1));
			  {	/* ./Llib/object.scm 2738 */
			     long arg1177_1568;
			     {	/* ./Llib/object.scm 2738 */
				long arg1178_1569;
				arg1178_1569 =
				   OBJECT_TYPE;
				arg1177_1568 =
				   (obj_class_num_177_1563 - arg1178_1569);
			     }
			     arg1780_1416 =
				VECTOR_REF(arg1176_1564, arg1177_1568);
			  }
		       }
		    }
	       }
	    }
	    {	/* Inline/loop.scm 54 */
	       object_bglt object_1574;
	       object_1574 =
		  (object_bglt) (node_3);
	       {	/* ./Llib/object.scm 2695 */
		  long arg1179_1575;
		  {	/* ./Llib/object.scm 2695 */
		     long arg1180_1576;
		     long arg1181_1577;
		     arg1180_1576 =
			TYPE(object_1574);
		     arg1181_1577 =
			OBJECT_TYPE;
		     arg1179_1575 =
			(arg1180_1576 - arg1181_1577);
		  }
		  {	/* ./Llib/object.scm 2695 */
		     obj_t vector_1581;
		     vector_1581 = _classes__134___object;
		     arg1781_1417 =
			VECTOR_REF(vector_1581, arg1179_1575);
		  }
	       }
	    }
	    method1772_1418 = arg1780_1416;
	    class1777_1419 = arg1781_1417;
	    {

	       if (
		  INTEGERP(method1772_1418))
		 {	/* Inline/loop.scm 54 */
		    switch (
		       (long) CINT(method1772_1418))
		      {
		      case ((long) 0):

			 {	/* Inline/loop.scm 61 */
			    sequence_bglt node_1425;
			    node_1425 =
			       (sequence_bglt) (node_3);
			    {	/* Inline/loop.scm 61 */
			       bool_t aux_1904;
			       aux_1904 =
				  find_let_fun___232_inline_loop(
				  (((sequence_bglt) CREF(node_1425))->nodes));
			       return
				  BBOOL(aux_1904);
			    }
			 }
			 break;
		      case ((long) 1):

			 {	/* Inline/loop.scm 67 */
			    app_bglt node_1427;
			    node_1427 =
			       (app_bglt) (node_3);
			    {	/* Inline/loop.scm 68 */
			       bool_t aux_1909;
			       aux_1909 =
				  find_let_fun___232_inline_loop(
				  (((app_bglt) CREF(node_1427))->args));
			       return
				  BBOOL(aux_1909);
			    }
			 }
			 break;
		      case ((long) 2):

			 {	/* Inline/loop.scm 74 */
			    app_ly_162_bglt node_1430;
			    node_1430 =
			       (app_ly_162_bglt) (node_3);
			    {	/* Inline/loop.scm 75 */
			       obj_t _ortest_1474_1432;
			       _ortest_1474_1432 =
				  find_let_fun__180_inline_loop(
				  (((app_ly_162_bglt) CREF(node_1430))->fun));
			       if (
				  CBOOL(_ortest_1474_1432))
				 {	/* Inline/loop.scm 75 */
				    return _ortest_1474_1432;
				 }
			       else
				 {
				    node_bglt node_1918;
				    node_1918 =
				       (((app_ly_162_bglt) CREF(node_1430))->arg);
				    node_3 = node_1918;
				    goto find_let_fun__180_inline_loop;
				 }
			    }
			 }
			 break;
		      case ((long) 3):

			 {	/* Inline/loop.scm 81 */
			    funcall_bglt node_1435;
			    node_1435 =
			       (funcall_bglt) (node_3);
			    {	/* Inline/loop.scm 82 */
			       obj_t _ortest_1476_1437;
			       _ortest_1476_1437 =
				  find_let_fun__180_inline_loop(
				  (((funcall_bglt) CREF(node_1435))->fun));
			       if (
				  CBOOL(_ortest_1476_1437))
				 {	/* Inline/loop.scm 82 */
				    return _ortest_1476_1437;
				 }
			       else
				 {	/* Inline/loop.scm 83 */
				    bool_t aux_1925;
				    aux_1925 =
				       find_let_fun___232_inline_loop(
				       (((funcall_bglt) CREF(node_1435))->args));
				    return
				       BBOOL(aux_1925);
				 }
			    }
			 }
			 break;
		      case ((long) 4):

			 {	/* Inline/loop.scm 89 */
			    pragma_bglt node_1440;
			    node_1440 =
			       (pragma_bglt) (node_3);
			    {	/* Inline/loop.scm 89 */
			       bool_t aux_1930;
			       aux_1930 =
				  find_let_fun___232_inline_loop(
				  (((pragma_bglt) CREF(node_1440))->args));
			       return
				  BBOOL(aux_1930);
			    }
			 }
			 break;
		      case ((long) 5):

			 {	/* Inline/loop.scm 95 */
			    cast_bglt node_1442;
			    node_1442 =
			       (cast_bglt) (node_3);
			    {
			       node_bglt node_1935;
			       node_1935 =
				  (((cast_bglt) CREF(node_1442))->arg);
			       node_3 = node_1935;
			       goto find_let_fun__180_inline_loop;
			    }
			 }
			 break;
		      case ((long) 6):

			 {	/* Inline/loop.scm 101 */
			    setq_bglt node_1444;
			    node_1444 =
			       (setq_bglt) (node_3);
			    {
			       node_bglt node_1938;
			       node_1938 =
				  (((setq_bglt) CREF(node_1444))->value);
			       node_3 = node_1938;
			       goto find_let_fun__180_inline_loop;
			    }
			 }
			 break;
		      case ((long) 7):

			 {	/* Inline/loop.scm 107 */
			    conditional_bglt node_1446;
			    node_1446 =
			       (conditional_bglt) (node_3);
			    {	/* Inline/loop.scm 108 */
			       obj_t _ortest_1478_1448;
			       _ortest_1478_1448 =
				  find_let_fun__180_inline_loop(
				  (((conditional_bglt) CREF(node_1446))->test));
			       if (
				  CBOOL(_ortest_1478_1448))
				 {	/* Inline/loop.scm 108 */
				    return _ortest_1478_1448;
				 }
			       else
				 {	/* Inline/loop.scm 109 */
				    obj_t _ortest_1479_1449;
				    _ortest_1479_1449 =
				       find_let_fun__180_inline_loop(
				       (((conditional_bglt) CREF(node_1446))->true));
				    if (
				       CBOOL(_ortest_1479_1449))
				      {		/* Inline/loop.scm 109 */
					 return _ortest_1479_1449;
				      }
				    else
				      {
					 node_bglt node_1949;
					 node_1949 =
					    (((conditional_bglt) CREF(node_1446))->false);
					 node_3 = node_1949;
					 goto find_let_fun__180_inline_loop;
				      }
				 }
			    }
			 }
			 break;
		      case ((long) 8):

			 {	/* Inline/loop.scm 116 */
			    fail_bglt node_1453;
			    node_1453 =
			       (fail_bglt) (node_3);
			    {	/* Inline/loop.scm 117 */
			       obj_t _ortest_1481_1455;
			       _ortest_1481_1455 =
				  find_let_fun__180_inline_loop(
				  (((fail_bglt) CREF(node_1453))->proc));
			       if (
				  CBOOL(_ortest_1481_1455))
				 {	/* Inline/loop.scm 117 */
				    return _ortest_1481_1455;
				 }
			       else
				 {	/* Inline/loop.scm 118 */
				    obj_t _ortest_1482_1456;
				    _ortest_1482_1456 =
				       find_let_fun__180_inline_loop(
				       (((fail_bglt) CREF(node_1453))->msg));
				    if (
				       CBOOL(_ortest_1482_1456))
				      {		/* Inline/loop.scm 118 */
					 return _ortest_1482_1456;
				      }
				    else
				      {
					 node_bglt node_1960;
					 node_1960 =
					    (((fail_bglt) CREF(node_1453))->obj);
					 node_3 = node_1960;
					 goto find_let_fun__180_inline_loop;
				      }
				 }
			    }
			 }
			 break;
		      case ((long) 9):

			 {	/* Inline/loop.scm 125 */
			    select_bglt node_1460;
			    node_1460 =
			       (select_bglt) (node_3);
			    {
			       obj_t clauses_1461;
			       clauses_1461 =
				  (((select_bglt) CREF(node_1460))->clauses);
			     loop_1462:
			       if (
				  NULLP(clauses_1461))
				 {	/* Inline/loop.scm 127 */
				    {
				       node_bglt node_1965;
				       node_1965 =
					  (((select_bglt) CREF(node_1460))->test);
				       node_3 = node_1965;
				       goto find_let_fun__180_inline_loop;
				    }
				 }
			       else
				 {	/* Inline/loop.scm 129 */
				    bool_t test1803_1466;
				    {	/* Inline/loop.scm 129 */
				       obj_t aux_1967;
				       {	/* Inline/loop.scm 129 */
					  node_bglt aux_1968;
					  {	/* Inline/loop.scm 129 */
					     obj_t aux_1969;
					     {	/* ./Ieee/pair-list.scm 5707 */
						obj_t aux_1970;
						aux_1970 =
						   CAR(clauses_1461);
						aux_1969 =
						   CDR(aux_1970);
					     }
					     aux_1968 =
						(node_bglt) (aux_1969);
					  }
					  aux_1967 =
					     find_let_fun__180_inline_loop(aux_1968);
				       }
				       test1803_1466 =
					  CBOOL(aux_1967);
				    }
				    if (test1803_1466)
				      {		/* Inline/loop.scm 129 */
					 return BTRUE;
				      }
				    else
				      {		/* Inline/loop.scm 129 */
					 {
					    obj_t clauses_1977;
					    clauses_1977 =
					       CDR(clauses_1461);
					    clauses_1461 = clauses_1977;
					    goto loop_1462;
					 }
				      }
				 }
			    }
			 }
			 break;
		      case ((long) 10):

			 return BTRUE;
			 break;
		      case ((long) 11):

			 {	/* Inline/loop.scm 144 */
			    let_var_6_bglt node_1471;
			    node_1471 =
			       (let_var_6_bglt) (node_3);
			    {
			       obj_t bindings_1472;
			       bindings_1472 =
				  (((let_var_6_bglt) CREF(node_1471))->bindings);
			     loop_1473:
			       if (
				  NULLP(bindings_1472))
				 {	/* Inline/loop.scm 146 */
				    {
				       node_bglt node_1983;
				       node_1983 =
					  (((let_var_6_bglt) CREF(node_1471))->body);
				       node_3 = node_1983;
				       goto find_let_fun__180_inline_loop;
				    }
				 }
			       else
				 {	/* Inline/loop.scm 148 */
				    bool_t test1810_1477;
				    {	/* Inline/loop.scm 148 */
				       obj_t aux_1985;
				       {	/* Inline/loop.scm 148 */
					  node_bglt aux_1986;
					  {	/* Inline/loop.scm 148 */
					     obj_t aux_1987;
					     {	/* ./Ieee/pair-list.scm 5707 */
						obj_t aux_1988;
						aux_1988 =
						   CAR(bindings_1472);
						aux_1987 =
						   CDR(aux_1988);
					     }
					     aux_1986 =
						(node_bglt) (aux_1987);
					  }
					  aux_1985 =
					     find_let_fun__180_inline_loop(aux_1986);
				       }
				       test1810_1477 =
					  CBOOL(aux_1985);
				    }
				    if (test1810_1477)
				      {		/* Inline/loop.scm 148 */
					 return BTRUE;
				      }
				    else
				      {		/* Inline/loop.scm 148 */
					 {
					    obj_t bindings_1995;
					    bindings_1995 =
					       CDR(bindings_1472);
					    bindings_1472 = bindings_1995;
					    goto loop_1473;
					 }
				      }
				 }
			    }
			 }
			 break;
		      case ((long) 12):

			 {	/* Inline/loop.scm 157 */
			    set_ex_it_116_bglt node_1481;
			    node_1481 =
			       (set_ex_it_116_bglt) (node_3);
			    {
			       node_bglt node_1999;
			       node_1999 =
				  (((set_ex_it_116_bglt) CREF(node_1481))->body);
			       node_3 = node_1999;
			       goto find_let_fun__180_inline_loop;
			    }
			 }
			 break;
		      case ((long) 13):

			 {	/* Inline/loop.scm 163 */
			    jump_ex_it_184_bglt node_1483;
			    node_1483 =
			       (jump_ex_it_184_bglt) (node_3);
			    {	/* Inline/loop.scm 164 */
			       obj_t _ortest_1484_1485;
			       _ortest_1484_1485 =
				  find_let_fun__180_inline_loop(
				  (((jump_ex_it_184_bglt) CREF(node_1483))->exit));
			       if (
				  CBOOL(_ortest_1484_1485))
				 {	/* Inline/loop.scm 164 */
				    return _ortest_1484_1485;
				 }
			       else
				 {
				    node_bglt node_2006;
				    node_2006 =
				       (((jump_ex_it_184_bglt) CREF(node_1483))->value);
				    node_3 = node_2006;
				    goto find_let_fun__180_inline_loop;
				 }
			    }
			 }
			 break;
		      case ((long) 14):

			 {	/* Inline/loop.scm 170 */
			    make_box_202_bglt node_1488;
			    node_1488 =
			       (make_box_202_bglt) (node_3);
			    {
			       node_bglt node_2009;
			       node_2009 =
				  (((make_box_202_bglt) CREF(node_1488))->value);
			       node_3 = node_2009;
			       goto find_let_fun__180_inline_loop;
			    }
			 }
			 break;
		      case ((long) 15):

			 {	/* Inline/loop.scm 176 */
			    box_ref_242_bglt node_1490;
			    node_1490 =
			       (box_ref_242_bglt) (node_3);
			    {
			       node_bglt node_2012;
			       {	/* Inline/loop.scm 176 */
				  var_bglt aux_2013;
				  aux_2013 =
				     (((box_ref_242_bglt) CREF(node_1490))->var);
				  node_2012 =
				     (node_bglt) (aux_2013);
			       }
			       node_3 = node_2012;
			       goto find_let_fun__180_inline_loop;
			    }
			 }
			 break;
		      case ((long) 16):

			 {	/* Inline/loop.scm 182 */
			    box_set__221_bglt node_1492;
			    node_1492 =
			       (box_set__221_bglt) (node_3);
			    {	/* Inline/loop.scm 183 */
			       obj_t _ortest_1486_1494;
			       {	/* Inline/loop.scm 183 */
				  node_bglt aux_2017;
				  {	/* Inline/loop.scm 183 */
				     var_bglt aux_2018;
				     aux_2018 =
					(((box_set__221_bglt) CREF(node_1492))->var);
				     aux_2017 =
					(node_bglt) (aux_2018);
				  }
				  _ortest_1486_1494 =
				     find_let_fun__180_inline_loop(aux_2017);
			       }
			       if (
				  CBOOL(_ortest_1486_1494))
				 {	/* Inline/loop.scm 183 */
				    return _ortest_1486_1494;
				 }
			       else
				 {
				    node_bglt node_2024;
				    node_2024 =
				       (((box_set__221_bglt) CREF(node_1492))->value);
				    node_3 = node_2024;
				    goto find_let_fun__180_inline_loop;
				 }
			    }
			 }
			 break;
		      default:
		       case_else1778_1422:
			 if (
			    PROCEDUREP(method1772_1418))
			   {	/* Inline/loop.scm 54 */
			      return
				 PROCEDURE_ENTRY(method1772_1418) (method1772_1418,
				 (obj_t) (node_3), BEOA);
			   }
			 else
			   {	/* Inline/loop.scm 54 */
			      obj_t fun1686_1246;
			      fun1686_1246 =
				 PROCEDURE_REF(find_let_fun__env_154_inline_loop, ((long) 0));
			      return
				 PROCEDURE_ENTRY(fun1686_1246) (fun1686_1246,
				 (obj_t) (node_3), BEOA);
			   }
		      }
		 }
	       else
		 {	/* Inline/loop.scm 54 */
		    goto case_else1778_1422;
		 }
	    }
	 }
      }
   }
}



/* _find-let-fun? */
obj_t 
_find_let_fun__218_inline_loop(obj_t env_1745, obj_t node_1746)
{
   AN_OBJECT;
   {	/* Inline/loop.scm 54 */
      return
	 find_let_fun__180_inline_loop(
	 (node_bglt) (node_1746));
   }
}



/* find-let-fun?-default1508 */
bool_t 
find_let_fun__default1508_172_inline_loop(node_bglt node_4)
{
   AN_OBJECT;
   {	/* Inline/loop.scm 14 */
      return ((bool_t) 0);
   }
}



/* _find-let-fun?-default1508 */
obj_t 
_find_let_fun__default1508_14_inline_loop(obj_t env_1747, obj_t node_1748)
{
   AN_OBJECT;
   {	/* Inline/loop.scm 14 */
      {		/* Inline/loop.scm 14 */
	 bool_t aux_2039;
	 aux_2039 =
	    find_let_fun__default1508_172_inline_loop(
	    (node_bglt) (node_1748));
	 return
	    BBOOL(aux_2039);
      }
   }
}



/* nest-loop! */
node_bglt 
nest_loop__92_inline_loop(node_bglt node_23, local_bglt local_24, obj_t nester_25)
{
   AN_OBJECT;
   {	/* Inline/loop.scm 201 */
      {
	 obj_t method1688_1251;
	 obj_t class1693_1252;
	 {	/* Inline/loop.scm 201 */
	    obj_t arg1696_1249;
	    obj_t arg1697_1250;
	    {	/* Inline/loop.scm 201 */
	       object_bglt obj_1619;
	       obj_1619 =
		  (object_bglt) (node_23);
	       {	/* ./Llib/object.scm 2926 */
		  obj_t pre_method_105_1620;
		  pre_method_105_1620 =
		     PROCEDURE_REF(nest_loop__env_29_inline_loop, ((long) 2));
		  if (
		     INTEGERP(pre_method_105_1620))
		    {	/* ./Llib/object.scm 2927 */
		       PROCEDURE_SET(nest_loop__env_29_inline_loop, ((long) 2), BUNSPEC);
		       arg1696_1249 = pre_method_105_1620;
		    }
		  else
		    {	/* ./Llib/object.scm 2914 */
		       long obj_class_num_177_1625;
		       obj_class_num_177_1625 =
			  TYPE(obj_1619);
		       {	/* ./Llib/object.scm 2915 */
			  obj_t arg1176_1626;
			  arg1176_1626 =
			     PROCEDURE_REF(nest_loop__env_29_inline_loop, ((long) 1));
			  {	/* ./Llib/object.scm 2738 */
			     long arg1177_1630;
			     {	/* ./Llib/object.scm 2738 */
				long arg1178_1631;
				arg1178_1631 =
				   OBJECT_TYPE;
				arg1177_1630 =
				   (obj_class_num_177_1625 - arg1178_1631);
			     }
			     arg1696_1249 =
				VECTOR_REF(arg1176_1626, arg1177_1630);
			  }
		       }
		    }
	       }
	    }
	    {	/* Inline/loop.scm 201 */
	       object_bglt object_1636;
	       object_1636 =
		  (object_bglt) (node_23);
	       {	/* ./Llib/object.scm 2695 */
		  long arg1179_1637;
		  {	/* ./Llib/object.scm 2695 */
		     long arg1180_1638;
		     long arg1181_1639;
		     arg1180_1638 =
			TYPE(object_1636);
		     arg1181_1639 =
			OBJECT_TYPE;
		     arg1179_1637 =
			(arg1180_1638 - arg1181_1639);
		  }
		  {	/* ./Llib/object.scm 2695 */
		     obj_t vector_1643;
		     vector_1643 = _classes__134___object;
		     arg1697_1250 =
			VECTOR_REF(vector_1643, arg1179_1637);
		  }
	       }
	    }
	    {	/* Inline/loop.scm 201 */
	       obj_t aux_2058;
	       method1688_1251 = arg1696_1249;
	       class1693_1252 = arg1697_1250;
	       {

		  if (
		     INTEGERP(method1688_1251))
		    {	/* Inline/loop.scm 201 */
		       switch (
			  (long) CINT(method1688_1251))
			 {
			 case ((long) 0):

			    {	/* Inline/loop.scm 201 */
			       atom_bglt aux_2061;
			       aux_2061 =
				  (atom_bglt) (node_23);
			       aux_2058 =
				  (obj_t) (aux_2061);
			    }
			    break;
			 case ((long) 1):

			    {	/* Inline/loop.scm 201 */
			       kwote_bglt aux_2064;
			       aux_2064 =
				  (kwote_bglt) (node_23);
			       aux_2058 =
				  (obj_t) (aux_2064);
			    }
			    break;
			 case ((long) 2):

			    {	/* Inline/loop.scm 201 */
			       var_bglt aux_2067;
			       aux_2067 =
				  (var_bglt) (node_23);
			       aux_2058 =
				  (obj_t) (aux_2067);
			    }
			    break;
			 case ((long) 3):

			    {	/* Inline/loop.scm 225 */
			       sequence_bglt node_1267;
			       node_1267 =
				  (sequence_bglt) (node_23);
			       nest_loop___100_inline_loop(
				  (((sequence_bglt) CREF(node_1267))->nodes), local_24, nester_25);
			       aux_2058 =
				  (obj_t) (node_1267);
			    }
			    break;
			 case ((long) 4):

			    {	/* Inline/loop.scm 233 */
			       app_bglt node_1272;
			       node_1272 =
				  (app_bglt) (node_23);
			       nest_loop___100_inline_loop(
				  (((app_bglt) CREF(node_1272))->args), local_24, nester_25);
			       {	/* Inline/loop.scm 235 */
				  bool_t test1702_1277;
				  {	/* Inline/loop.scm 235 */
				     bool_t test1703_1278;
				     {	/* ./Ast/node.scm 1070 */
					obj_t aux_2077;
					{	/* Inline/loop.scm 235 */
					   var_bglt aux_2078;
					   aux_2078 =
					      (((app_bglt) CREF(node_1272))->fun);
					   aux_2077 =
					      (obj_t) (aux_2078);
					}
					test1703_1278 =
					   is_a__118___object(aux_2077, var_ast_node);
				     }
				     if (test1703_1278)
				       {	/* ./Ieee/equiv.scm 5508 */
					  obj_t aux_2088;
					  obj_t aux_2083;
					  aux_2088 =
					     (obj_t) (local_24);
					  {	/* Inline/loop.scm 235 */
					     variable_bglt aux_2084;
					     {	/* Inline/loop.scm 235 */
						var_bglt arg1705_1280;
						arg1705_1280 =
						   (((app_bglt) CREF(node_1272))->fun);
						aux_2084 =
						   (((var_bglt) CREF(arg1705_1280))->variable);
					     }
					     aux_2083 =
						(obj_t) (aux_2084);
					  }
					  test1702_1277 =
					     (aux_2083 == aux_2088);
				       }
				     else
				       {	/* Inline/loop.scm 235 */
					  test1702_1277 = ((bool_t) 0);
				       }
				  }
				  if (test1702_1277)
				    {	/* Inline/loop.scm 235 */
				       aux_2058 =
					  PROCEDURE_ENTRY(nester_25) (nester_25,
					  (obj_t) (node_1272), BEOA)
					  ;
				    }
				  else
				    {	/* Inline/loop.scm 235 */
				       aux_2058 =
					  (obj_t) (node_1272)
					  ;
				    }
			       }
			    }
			    break;
			 case ((long) 5):

			    {	/* Inline/loop.scm 243 */
			       app_ly_162_bglt node_1282;
			       node_1282 =
				  (app_ly_162_bglt) (node_23);
			       {	/* Inline/loop.scm 244 */
				  node_bglt arg1707_1286;
				  arg1707_1286 =
				     nest_loop__92_inline_loop(
				     (((app_ly_162_bglt) CREF(node_1282))->fun), local_24, nester_25);
				  ((((app_ly_162_bglt) CREF(node_1282))->fun) = ((node_bglt) arg1707_1286), BUNSPEC);
			       }
			       {	/* Inline/loop.scm 245 */
				  node_bglt arg1709_1288;
				  arg1709_1288 =
				     nest_loop__92_inline_loop(
				     (((app_ly_162_bglt) CREF(node_1282))->arg), local_24, nester_25);
				  ((((app_ly_162_bglt) CREF(node_1282))->arg) = ((node_bglt) arg1709_1288), BUNSPEC);
			       }
			       aux_2058 =
				  (obj_t) (node_1282);
			    }
			    break;
			 case ((long) 6):

			    {	/* Inline/loop.scm 252 */
			       funcall_bglt node_1290;
			       node_1290 =
				  (funcall_bglt) (node_23);
			       {	/* Inline/loop.scm 253 */
				  node_bglt arg1712_1294;
				  arg1712_1294 =
				     nest_loop__92_inline_loop(
				     (((funcall_bglt) CREF(node_1290))->fun), local_24, nester_25);
				  ((((funcall_bglt) CREF(node_1290))->fun) = ((node_bglt) arg1712_1294), BUNSPEC);
			       }
			       nest_loop___100_inline_loop(
				  (((funcall_bglt) CREF(node_1290))->args), local_24, nester_25);
			       aux_2058 =
				  (obj_t) (node_1290);
			    }
			    break;
			 case ((long) 7):

			    {	/* Inline/loop.scm 201 */
			       pragma_bglt node_1297;
			       node_1297 =
				  (pragma_bglt) (node_23);
			       nest_loop___100_inline_loop(
				  (((pragma_bglt) CREF(node_1297))->args), local_24, nester_25);
			       aux_2058 =
				  (obj_t) (node_1297);
			    }
			    break;
			 case ((long) 8):

			    {	/* Inline/loop.scm 201 */
			       cast_bglt node_1301;
			       node_1301 =
				  (cast_bglt) (node_23);
			       nest_loop__92_inline_loop(
				  (((cast_bglt) CREF(node_1301))->arg), local_24, nester_25);
			       aux_2058 =
				  (obj_t) (node_1301);
			    }
			    break;
			 case ((long) 9):

			    {	/* Inline/loop.scm 201 */
			       setq_bglt node_1305;
			       node_1305 =
				  (setq_bglt) (node_23);
			       nest_loop__92_inline_loop(
				  (((setq_bglt) CREF(node_1305))->value), local_24, nester_25);
			       aux_2058 =
				  (obj_t) (node_1305);
			    }
			    break;
			 case ((long) 10):

			    {	/* Inline/loop.scm 282 */
			       conditional_bglt node_1309;
			       node_1309 =
				  (conditional_bglt) (node_23);
			       {	/* Inline/loop.scm 283 */
				  node_bglt arg1718_1313;
				  arg1718_1313 =
				     nest_loop__92_inline_loop(
				     (((conditional_bglt) CREF(node_1309))->test), local_24, nester_25);
				  ((((conditional_bglt) CREF(node_1309))->test) = ((node_bglt) arg1718_1313), BUNSPEC);
			       }
			       {	/* Inline/loop.scm 284 */
				  node_bglt arg1720_1315;
				  arg1720_1315 =
				     nest_loop__92_inline_loop(
				     (((conditional_bglt) CREF(node_1309))->true), local_24, nester_25);
				  ((((conditional_bglt) CREF(node_1309))->true) = ((node_bglt) arg1720_1315), BUNSPEC);
			       }
			       {	/* Inline/loop.scm 285 */
				  node_bglt arg1722_1317;
				  arg1722_1317 =
				     nest_loop__92_inline_loop(
				     (((conditional_bglt) CREF(node_1309))->false), local_24, nester_25);
				  ((((conditional_bglt) CREF(node_1309))->false) = ((node_bglt) arg1722_1317), BUNSPEC);
			       }
			       aux_2058 =
				  (obj_t) (node_1309);
			    }
			    break;
			 case ((long) 11):

			    {	/* Inline/loop.scm 292 */
			       fail_bglt node_1319;
			       node_1319 =
				  (fail_bglt) (node_23);
			       {	/* Inline/loop.scm 293 */
				  node_bglt arg1724_1323;
				  arg1724_1323 =
				     nest_loop__92_inline_loop(
				     (((fail_bglt) CREF(node_1319))->proc), local_24, nester_25);
				  ((((fail_bglt) CREF(node_1319))->proc) = ((node_bglt) arg1724_1323), BUNSPEC);
			       }
			       {	/* Inline/loop.scm 294 */
				  node_bglt arg1726_1325;
				  arg1726_1325 =
				     nest_loop__92_inline_loop(
				     (((fail_bglt) CREF(node_1319))->msg), local_24, nester_25);
				  ((((fail_bglt) CREF(node_1319))->msg) = ((node_bglt) arg1726_1325), BUNSPEC);
			       }
			       {	/* Inline/loop.scm 295 */
				  node_bglt arg1728_1327;
				  arg1728_1327 =
				     nest_loop__92_inline_loop(
				     (((fail_bglt) CREF(node_1319))->obj), local_24, nester_25);
				  ((((fail_bglt) CREF(node_1319))->obj) = ((node_bglt) arg1728_1327), BUNSPEC);
			       }
			       aux_2058 =
				  (obj_t) (node_1319);
			    }
			    break;
			 case ((long) 12):

			    {	/* Inline/loop.scm 302 */
			       select_bglt node_1329;
			       node_1329 =
				  (select_bglt) (node_23);
			       {	/* Inline/loop.scm 303 */
				  node_bglt arg1730_1333;
				  arg1730_1333 =
				     nest_loop__92_inline_loop(
				     (((select_bglt) CREF(node_1329))->test), local_24, nester_25);
				  ((((select_bglt) CREF(node_1329))->test) = ((node_bglt) arg1730_1333), BUNSPEC);
			       }
			       {
				  obj_t l1494_1335;
				  l1494_1335 =
				     (((select_bglt) CREF(node_1329))->clauses);
				lname1495_1336:
				  if (
				     PAIRP(l1494_1335))
				    {	/* Inline/loop.scm 304 */
				       {	/* Inline/loop.scm 305 */
					  obj_t clause_1339;
					  clause_1339 =
					     CAR(l1494_1335);
					  {	/* Inline/loop.scm 305 */
					     node_bglt arg1734_1340;
					     {	/* Inline/loop.scm 305 */
						node_bglt aux_2152;
						{	/* Inline/loop.scm 305 */
						   obj_t aux_2153;
						   aux_2153 =
						      CDR(clause_1339);
						   aux_2152 =
						      (node_bglt) (aux_2153);
						}
						arg1734_1340 =
						   nest_loop__92_inline_loop(aux_2152, local_24, nester_25);
					     }
					     {	/* ./Ieee/pair-list.scm 5896 */
						obj_t aux_2157;
						aux_2157 =
						   (obj_t) (arg1734_1340);
						SET_CDR(clause_1339, aux_2157);
					     }
					  }
				       }
				       {
					  obj_t l1494_2160;
					  l1494_2160 =
					     CDR(l1494_1335);
					  l1494_1335 = l1494_2160;
					  goto lname1495_1336;
				       }
				    }
				  else
				    {	/* Inline/loop.scm 304 */
				       ((bool_t) 1);
				    }
			       }
			       aux_2058 =
				  (obj_t) (node_1329);
			    }
			    break;
			 case ((long) 13):

			    {	/* Inline/loop.scm 313 */
			       let_fun_218_bglt node_1343;
			       node_1343 =
				  (let_fun_218_bglt) (node_23);
			       {	/* Inline/loop.scm 314 */
				  node_bglt arg1738_1347;
				  arg1738_1347 =
				     nest_loop__92_inline_loop(
				     (((let_fun_218_bglt) CREF(node_1343))->body), local_24, nester_25);
				  ((((let_fun_218_bglt) CREF(node_1343))->body) = ((node_bglt) arg1738_1347), BUNSPEC);
			       }
			       {
				  obj_t l1497_1349;
				  l1497_1349 =
				     (((let_fun_218_bglt) CREF(node_1343))->locals);
				lname1498_1350:
				  if (
				     PAIRP(l1497_1349))
				    {	/* Inline/loop.scm 315 */
				       {	/* Inline/loop.scm 316 */
					  value_bglt sfun_1354;
					  {	/* Inline/loop.scm 316 */
					     local_bglt obj_1700;
					     {	/* Inline/loop.scm 316 */
						obj_t aux_2170;
						aux_2170 =
						   CAR(l1497_1349);
						obj_1700 =
						   (local_bglt) (aux_2170);
					     }
					     sfun_1354 =
						(((local_bglt) CREF(obj_1700))->value);
					  }
					  {	/* Inline/loop.scm 318 */
					     node_bglt arg1742_1355;
					     {	/* Inline/loop.scm 318 */
						node_bglt aux_2174;
						{	/* Inline/loop.scm 318 */
						   obj_t aux_2175;
						   {	/* Inline/loop.scm 318 */
						      sfun_bglt obj_1701;
						      obj_1701 =
							 (sfun_bglt) (sfun_1354);
						      aux_2175 =
							 (((sfun_bglt) CREF(obj_1701))->body);
						   }
						   aux_2174 =
						      (node_bglt) (aux_2175);
						}
						arg1742_1355 =
						   nest_loop__92_inline_loop(aux_2174, local_24, nester_25);
					     }
					     {	/* Inline/loop.scm 317 */
						sfun_bglt obj_1702;
						obj_t val1123_1703;
						obj_1702 =
						   (sfun_bglt) (sfun_1354);
						val1123_1703 =
						   (obj_t) (arg1742_1355);
						((((sfun_bglt) CREF(obj_1702))->body) = ((obj_t) val1123_1703), BUNSPEC);
					     }
					  }
				       }
				       {
					  obj_t l1497_2183;
					  l1497_2183 =
					     CDR(l1497_1349);
					  l1497_1349 = l1497_2183;
					  goto lname1498_1350;
				       }
				    }
				  else
				    {	/* Inline/loop.scm 315 */
				       ((bool_t) 1);
				    }
			       }
			       aux_2058 =
				  (obj_t) (node_1343);
			    }
			    break;
			 case ((long) 14):

			    {	/* Inline/loop.scm 328 */
			       let_var_6_bglt node_1358;
			       node_1358 =
				  (let_var_6_bglt) (node_23);
			       {	/* Inline/loop.scm 329 */
				  node_bglt arg1745_1362;
				  arg1745_1362 =
				     nest_loop__92_inline_loop(
				     (((let_var_6_bglt) CREF(node_1358))->body), local_24, nester_25);
				  ((((let_var_6_bglt) CREF(node_1358))->body) = ((node_bglt) arg1745_1362), BUNSPEC);
			       }
			       {
				  obj_t l1500_1364;
				  l1500_1364 =
				     (((let_var_6_bglt) CREF(node_1358))->bindings);
				lname1501_1365:
				  if (
				     PAIRP(l1500_1364))
				    {	/* Inline/loop.scm 330 */
				       {	/* Inline/loop.scm 331 */
					  obj_t binding_1368;
					  binding_1368 =
					     CAR(l1500_1364);
					  {	/* Inline/loop.scm 331 */
					     node_bglt arg1749_1369;
					     {	/* Inline/loop.scm 331 */
						node_bglt aux_2194;
						{	/* Inline/loop.scm 331 */
						   obj_t aux_2195;
						   aux_2195 =
						      CDR(binding_1368);
						   aux_2194 =
						      (node_bglt) (aux_2195);
						}
						arg1749_1369 =
						   nest_loop__92_inline_loop(aux_2194, local_24, nester_25);
					     }
					     {	/* ./Ieee/pair-list.scm 5896 */
						obj_t aux_2199;
						aux_2199 =
						   (obj_t) (arg1749_1369);
						SET_CDR(binding_1368, aux_2199);
					     }
					  }
				       }
				       {
					  obj_t l1500_2202;
					  l1500_2202 =
					     CDR(l1500_1364);
					  l1500_1364 = l1500_2202;
					  goto lname1501_1365;
				       }
				    }
				  else
				    {	/* Inline/loop.scm 330 */
				       ((bool_t) 1);
				    }
			       }
			       aux_2058 =
				  (obj_t) (node_1358);
			    }
			    break;
			 case ((long) 15):

			    {	/* Inline/loop.scm 339 */
			       set_ex_it_116_bglt node_1372;
			       node_1372 =
				  (set_ex_it_116_bglt) (node_23);
			       {	/* Inline/loop.scm 340 */
				  node_bglt arg1752_1376;
				  arg1752_1376 =
				     nest_loop__92_inline_loop(
				     (((set_ex_it_116_bglt) CREF(node_1372))->body), local_24, nester_25);
				  ((((set_ex_it_116_bglt) CREF(node_1372))->body) = ((node_bglt) arg1752_1376), BUNSPEC);
			       }
			       aux_2058 =
				  (obj_t) (node_1372);
			    }
			    break;
			 case ((long) 16):

			    {	/* Inline/loop.scm 347 */
			       jump_ex_it_184_bglt node_1378;
			       node_1378 =
				  (jump_ex_it_184_bglt) (node_23);
			       {	/* Inline/loop.scm 348 */
				  node_bglt arg1754_1382;
				  arg1754_1382 =
				     nest_loop__92_inline_loop(
				     (((jump_ex_it_184_bglt) CREF(node_1378))->exit), local_24, nester_25);
				  ((((jump_ex_it_184_bglt) CREF(node_1378))->exit) = ((node_bglt) arg1754_1382), BUNSPEC);
			       }
			       {	/* Inline/loop.scm 349 */
				  node_bglt arg1756_1384;
				  arg1756_1384 =
				     nest_loop__92_inline_loop(
				     (((jump_ex_it_184_bglt) CREF(node_1378))->value), local_24, nester_25);
				  ((((jump_ex_it_184_bglt) CREF(node_1378))->value) = ((node_bglt) arg1756_1384), BUNSPEC);
			       }
			       aux_2058 =
				  (obj_t) (node_1378);
			    }
			    break;
			 case ((long) 17):

			    {	/* Inline/loop.scm 356 */
			       make_box_202_bglt node_1386;
			       node_1386 =
				  (make_box_202_bglt) (node_23);
			       {	/* Inline/loop.scm 357 */
				  node_bglt arg1759_1390;
				  arg1759_1390 =
				     nest_loop__92_inline_loop(
				     (((make_box_202_bglt) CREF(node_1386))->value), local_24, nester_25);
				  ((((make_box_202_bglt) CREF(node_1386))->value) = ((node_bglt) arg1759_1390), BUNSPEC);
			       }
			       aux_2058 =
				  (obj_t) (node_1386);
			    }
			    break;
			 case ((long) 18):

			    {	/* Inline/loop.scm 364 */
			       box_ref_242_bglt node_1392;
			       node_1392 =
				  (box_ref_242_bglt) (node_23);
			       {	/* Inline/loop.scm 365 */
				  node_bglt arg1761_1396;
				  {	/* Inline/loop.scm 365 */
				     node_bglt aux_2225;
				     {	/* Inline/loop.scm 365 */
					var_bglt aux_2226;
					aux_2226 =
					   (((box_ref_242_bglt) CREF(node_1392))->var);
					aux_2225 =
					   (node_bglt) (aux_2226);
				     }
				     arg1761_1396 =
					nest_loop__92_inline_loop(aux_2225, local_24, nester_25);
				  }
				  {	/* Inline/loop.scm 365 */
				     var_bglt val1418_1729;
				     val1418_1729 =
					(var_bglt) (arg1761_1396);
				     ((((box_ref_242_bglt) CREF(node_1392))->var) = ((var_bglt) val1418_1729), BUNSPEC);
				  }
			       }
			       aux_2058 =
				  (obj_t) (node_1392);
			    }
			    break;
			 case ((long) 19):

			    {	/* Inline/loop.scm 372 */
			       box_set__221_bglt node_1398;
			       node_1398 =
				  (box_set__221_bglt) (node_23);
			       {	/* Inline/loop.scm 373 */
				  node_bglt arg1763_1402;
				  {	/* Inline/loop.scm 373 */
				     node_bglt aux_2234;
				     {	/* Inline/loop.scm 373 */
					var_bglt aux_2235;
					aux_2235 =
					   (((box_set__221_bglt) CREF(node_1398))->var);
					aux_2234 =
					   (node_bglt) (aux_2235);
				     }
				     arg1763_1402 =
					nest_loop__92_inline_loop(aux_2234, local_24, nester_25);
				  }
				  {	/* Inline/loop.scm 373 */
				     var_bglt val1428_1732;
				     val1428_1732 =
					(var_bglt) (arg1763_1402);
				     ((((box_set__221_bglt) CREF(node_1398))->var) = ((var_bglt) val1428_1732), BUNSPEC);
				  }
			       }
			       {	/* Inline/loop.scm 374 */
				  node_bglt arg1765_1404;
				  arg1765_1404 =
				     nest_loop__92_inline_loop(
				     (((box_set__221_bglt) CREF(node_1398))->value), local_24, nester_25);
				  ((((box_set__221_bglt) CREF(node_1398))->value) = ((node_bglt) arg1765_1404), BUNSPEC);
			       }
			       aux_2058 =
				  (obj_t) (node_1398);
			    }
			    break;
			 default:
			  case_else1694_1255:
			    if (
			       PROCEDUREP(method1688_1251))
			      {		/* Inline/loop.scm 201 */
				 aux_2058 =
				    PROCEDURE_ENTRY(method1688_1251) (method1688_1251,
				    (obj_t) (node_23),
				    (obj_t) (local_24), nester_25, BEOA)
				    ;
			      }
			    else
			      {		/* Inline/loop.scm 201 */
				 obj_t fun1687_1247;
				 fun1687_1247 =
				    PROCEDURE_REF(nest_loop__env_29_inline_loop, ((long) 0));
				 aux_2058 =
				    PROCEDURE_ENTRY(fun1687_1247) (fun1687_1247,
				    (obj_t) (node_23),
				    (obj_t) (local_24), nester_25, BEOA);
			      }
			 }
		    }
		  else
		    {	/* Inline/loop.scm 201 */
		       goto case_else1694_1255;
		    }
	       }
	       return
		  (node_bglt) (aux_2058);
	    }
	 }
      }
   }
}



/* _nest-loop! */
obj_t 
_nest_loop__216_inline_loop(obj_t env_1749, obj_t node_1750, obj_t local_1751, obj_t nester_1752)
{
   AN_OBJECT;
   {	/* Inline/loop.scm 201 */
      {		/* Inline/loop.scm 201 */
	 node_bglt aux_2259;
	 aux_2259 =
	    nest_loop__92_inline_loop(
	    (node_bglt) (node_1750),
	    (local_bglt) (local_1751), nester_1752);
	 return
	    (obj_t) (aux_2259);
      }
   }
}



/* nest-loop!-default1548 */
node_bglt 
nest_loop__default1548_108_inline_loop(node_bglt node_26, local_bglt local_27, obj_t nester_28)
{
   AN_OBJECT;
   {	/* Inline/loop.scm 14 */
      FAILURE(
	 CNST_TABLE_REF(((long) 1)), string1829_inline_loop,
	 (obj_t) (node_26));
   }
}



/* _nest-loop!-default1548 */
obj_t 
_nest_loop__default1548_34_inline_loop(obj_t env_1753, obj_t node_1754, obj_t local_1755, obj_t nester_1756)
{
   AN_OBJECT;
   {	/* Inline/loop.scm 14 */
      {		/* Inline/loop.scm 14 */
	 node_bglt aux_2267;
	 aux_2267 =
	    nest_loop__default1548_108_inline_loop(
	    (node_bglt) (node_1754),
	    (local_bglt) (local_1755), nester_1756);
	 return
	    (obj_t) (aux_2267);
      }
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_inline_loop()
{
   AN_OBJECT;
   {	/* Inline/loop.scm 14 */
      module_initialization_70_tools_trace(((long) 0), "INLINE_LOOP");
      module_initialization_70_engine_param(((long) 0), "INLINE_LOOP");
      module_initialization_70_type_type(((long) 0), "INLINE_LOOP");
      module_initialization_70_ast_var(((long) 0), "INLINE_LOOP");
      module_initialization_70_ast_node(((long) 0), "INLINE_LOOP");
      module_initialization_70_ast_local(((long) 0), "INLINE_LOOP");
      module_initialization_70_ast_sexp(((long) 0), "INLINE_LOOP");
      module_initialization_70_tools_speek(((long) 0), "INLINE_LOOP");
      module_initialization_70_tools_shape(((long) 0), "INLINE_LOOP");
      module_initialization_70_tools_error(((long) 0), "INLINE_LOOP");
      module_initialization_70_inline_inline(((long) 0), "INLINE_LOOP");
      module_initialization_70_inline_variant(((long) 0), "INLINE_LOOP");
      module_initialization_70_inline_recursion(((long) 0), "INLINE_LOOP");
      return
	 module_initialization_70_effect_effect(((long) 0), "INLINE_LOOP");
   }
}
