/*===========================================================================*/
/*   (Inline/recursion.scm)                                                  */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;

typedef struct isfun
  {
     struct node *original_body_40;
     obj_t recursive_calls_44;
  }
     *isfun_bglt;

typedef struct local_variant_63
  {
     bool_t variant;
  }
                *local_variant_63_bglt;


extern obj_t append___r4_pairs_and_lists_6_3(obj_t);
extern obj_t _inlining_reduce_kfactor__26_engine_param;
static obj_t method_init_76_inline_recursion();
extern obj_t make_box_202_ast_node;
extern obj_t funcall_ast_node;
extern obj_t inline_sfun__229_inline_inline(variable_bglt, long, obj_t);
extern obj_t _optim_unroll_loop___80_engine_param;
extern node_bglt inline_app_recursive_121_inline_recursion(node_bglt, long, obj_t);
extern long add_inlined_method__244___object(obj_t, obj_t, long);
extern obj_t fail_ast_node;
extern obj_t _verbose__1_engine_param;
static let_fun_218_bglt plain_call_51_inline_recursion(variable_bglt, node_bglt, local_bglt, app_bglt, obj_t);
static obj_t find_recursive_calls__36_inline_recursion(obj_t, variable_bglt);
static obj_t _anonymous_1631__2_inline_recursion(obj_t, obj_t);
static obj_t find_recursive_calls_default1506_129_inline_recursion(node_bglt, variable_bglt);
extern obj_t box_ref_242_ast_node;
static obj_t _inline_app_recursive1846_161_inline_recursion(obj_t, obj_t, obj_t, obj_t);
extern obj_t _res1__155___r5_control_features_6_4;
extern obj_t sequence_ast_node;
extern obj_t let_var_6_ast_node;
extern obj_t var_ast_node;
extern obj_t global_ast_var;
extern obj_t pragma_ast_node;
extern local_bglt clone_local_230_ast_local(local_bglt, value_bglt);
extern obj_t set_ex_it_116_ast_node;
extern obj_t verbose_tools_speek(obj_t, obj_t);
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t current_function_76_tools_error();
static obj_t _is_recursive_1847_53_inline_recursion(obj_t, obj_t);
extern obj_t module_initialization_70_inline_recursion(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_ast_local(long, char *);
extern obj_t module_initialization_70_ast_alphatize(long, char *);
extern obj_t module_initialization_70_ast_sexp(long, char *);
extern obj_t module_initialization_70_tools_speek(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_inline_inline(long, char *);
extern obj_t module_initialization_70_inline_simple(long, char *);
extern obj_t module_initialization_70_inline_variant(long, char *);
extern obj_t module_initialization_70_inline_loop(long, char *);
extern obj_t module_initialization_70_inline_app(long, char *);
extern obj_t module_initialization_70_reduce_cse(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_numbers_6_5(long, char *);
extern obj_t module_initialization_70___r5_control_features_6_4(long, char *);
extern obj_t shrink_args__237_inline_variant(variable_bglt);
static obj_t inline_app_labels_34_inline_recursion(node_bglt, long, obj_t);
extern long list_length(obj_t);
extern long class_num_218___object(obj_t);
extern obj_t svar_ast_var;
extern obj_t let_fun_218_ast_node;
extern node_bglt inline_app_simple_198_inline_simple(node_bglt, long, obj_t, obj_t);
extern bool_t is_loop__232_inline_loop(variable_bglt);
static obj_t imported_modules_init_94_inline_recursion();
extern obj_t app_ly_162_ast_node;
extern obj_t add_generic__110___object(obj_t, obj_t);
extern obj_t app_ast_node;
extern obj_t append_2_18___r4_pairs_and_lists_6_3(obj_t, obj_t);
static obj_t library_modules_init_112_inline_recursion();
extern obj_t variant_args_126_inline_variant(variable_bglt);
extern obj_t cast_ast_node;
static obj_t toplevel_init_63_inline_recursion();
extern obj_t jump_ex_it_184_ast_node;
extern obj_t open_input_string(obj_t);
extern local_bglt make_local_sfun_184_ast_local(obj_t, type_bglt, sfun_bglt);
static obj_t unroll_call_164_inline_recursion(variable_bglt, node_bglt, local_bglt, obj_t, app_bglt, obj_t);
extern node_bglt alphatize_ast_alphatize(obj_t, obj_t, obj_t, node_bglt);
extern app_bglt remove_invariant_args__113_inline_variant(app_bglt);
extern obj_t sfun_ast_var;
extern bool_t inner_loop__79_inline_loop(variable_bglt);
extern obj_t setq_ast_node;
extern bool_t is_recursive__125_inline_recursion(variable_bglt);
extern obj_t box_set__221_ast_node;
extern obj_t invariant_args_254_inline_variant(variable_bglt, obj_t);
extern obj_t isfun_inline_inline;
extern obj_t node_cse__231_reduce_cse(node_bglt, obj_t);
static obj_t _find_recursive_calls1848_248_inline_recursion(obj_t, obj_t, obj_t);
extern obj_t local_ast_var;
extern obj_t memq___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern obj_t substitutions_inline_variant(variable_bglt, obj_t, obj_t);
extern obj_t shape_tools_shape(obj_t);
static obj_t find_recursive_calls_52_inline_recursion(node_bglt, variable_bglt);
extern bool_t inline_app__99_inline_app(variable_bglt, long, long, obj_t);
extern bool_t ___161___r4_numbers_6_5(obj_t, obj_t, obj_t);
extern obj_t _classes__134___object;
extern obj_t select_ast_node;
extern obj_t read___reader(obj_t);
static obj_t _find_recursive_calls_default1506_144_inline_recursion(obj_t, obj_t, obj_t);
static obj_t require_initialization_114_inline_recursion = BUNSPEC;
extern obj_t conditional_ast_node;
extern node_bglt nest_loop__92_inline_loop(node_bglt, local_bglt, obj_t);
static obj_t cnst_init_137_inline_recursion();
static obj_t __cnst[2];

DEFINE_STATIC_PROCEDURE(find_recursive_calls_default1506_env_10_inline_recursion, _find_recursive_calls_default1506_144_inline_recursion1859, _find_recursive_calls_default1506_144_inline_recursion, 0L, 2);
DEFINE_STATIC_GENERIC(find_recursive_calls_env_59_inline_recursion, _find_recursive_calls1848_248_inline_recursion1860, _find_recursive_calls1848_248_inline_recursion, 0L, 2);
DEFINE_EXPORT_PROCEDURE(inline_app_recursive_env_100_inline_recursion, _inline_app_recursive1846_161_inline_recursion1861, _inline_app_recursive1846_161_inline_recursion, 0L, 3);
DEFINE_EXPORT_PROCEDURE(is_recursive__env_217_inline_recursion, _is_recursive_1847_53_inline_recursion1862, _is_recursive_1847_53_inline_recursion, 0L, 1);
DEFINE_STRING(string1854_inline_recursion, string1854_inline_recursion1863, "(SIFUN SGFUN) SFUN ", 19);
DEFINE_STRING(string1853_inline_recursion, string1853_inline_recursion1864, "unrolling", 9);
DEFINE_STRING(string1852_inline_recursion, string1852_inline_recursion1865, "         ", 9);
DEFINE_STRING(string1851_inline_recursion, string1851_inline_recursion1866, " --> ", 5);
DEFINE_STRING(string1849_inline_recursion, string1849_inline_recursion1867, "simple", 6);
DEFINE_STRING(string1850_inline_recursion, string1850_inline_recursion1868, " (recursive)", 12);



/* module-initialization */
obj_t 
module_initialization_70_inline_recursion(long checksum_1864, char *from_1865)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_inline_recursion))
	{
	   require_initialization_114_inline_recursion =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_inline_recursion();
	   cnst_init_137_inline_recursion();
	   imported_modules_init_94_inline_recursion();
	   method_init_76_inline_recursion();
	   toplevel_init_63_inline_recursion();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_inline_recursion()
{
   AN_OBJECT;
   {	/* Inline/recursion.scm 14 */
      module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "INLINE_RECURSION");
      module_initialization_70___object(((long) 0), "INLINE_RECURSION");
      module_initialization_70___r5_control_features_6_4(((long) 0), "INLINE_RECURSION");
      module_initialization_70___r4_numbers_6_5(((long) 0), "INLINE_RECURSION");
      module_initialization_70___reader(((long) 0), "INLINE_RECURSION");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_inline_recursion()
{
   AN_OBJECT;
   {	/* Inline/recursion.scm 14 */
      {		/* Inline/recursion.scm 14 */
	 obj_t cnst_port_138_1857;
	 cnst_port_138_1857 =
	    open_input_string(string1854_inline_recursion);
	 {
	    long i_1858;
	    i_1858 = ((long) 1);
	  loop_1859:
	    {	/* Inline/recursion.scm 14 */
	       bool_t test1855_1860;
	       test1855_1860 =
		  (i_1858 == ((long) -1));
	       if (test1855_1860)
		 {	/* Inline/recursion.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Inline/recursion.scm 14 */
		    {	/* Inline/recursion.scm 14 */
		       obj_t arg1856_1861;
		       {	/* Inline/recursion.scm 14 */
			  obj_t list1857_1862;
			  list1857_1862 =
			     MAKE_PAIR(cnst_port_138_1857, BNIL);
			  arg1856_1861 =
			     read___reader(list1857_1862);
		       }
		       CNST_TABLE_SET(i_1858, arg1856_1861);
		    }
		    {	/* Inline/recursion.scm 14 */
		       int aux_1863;
		       {	/* Inline/recursion.scm 14 */
			  long aux_1885;
			  aux_1885 =
			     (i_1858 - ((long) 1));
			  aux_1863 =
			     (int) (aux_1885);
		       }
		       {
			  long i_1888;
			  i_1888 =
			     (long) (aux_1863);
			  i_1858 = i_1888;
			  goto loop_1859;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_inline_recursion()
{
   AN_OBJECT;
   {	/* Inline/recursion.scm 14 */
      return BUNSPEC;
   }
}



/* inline-app-recursive */
node_bglt 
inline_app_recursive_121_inline_recursion(node_bglt node_1, long kfactor_2, obj_t stack_3)
{
   AN_OBJECT;
   {	/* Inline/recursion.scm 39 */
      {		/* Inline/recursion.scm 42 */
	 bool_t test_1890;
	 {	/* Inline/recursion.scm 42 */
	    obj_t aux_1891;
	    {	/* Inline/recursion.scm 42 */
	       obj_t aux_1892;
	       {	/* Inline/recursion.scm 42 */
		  variable_bglt aux_1893;
		  {	/* Inline/recursion.scm 41 */
		     var_bglt arg1547_855;
		     {	/* Inline/recursion.scm 41 */
			app_bglt obj_1522;
			obj_1522 =
			   (app_bglt) (node_1);
			arg1547_855 =
			   (((app_bglt) CREF(obj_1522))->fun);
		     }
		     aux_1893 =
			(((var_bglt) CREF(arg1547_855))->variable);
		  }
		  aux_1892 =
		     (obj_t) (aux_1893);
	       }
	       aux_1891 =
		  memq___r4_pairs_and_lists_6_3(aux_1892, stack_3);
	    }
	    test_1890 =
	       CBOOL(aux_1891);
	 }
	 if (test_1890)
	   {	/* Inline/recursion.scm 42 */
	      return
		 inline_app_simple_198_inline_simple(node_1, kfactor_2, stack_3, string1849_inline_recursion);
	   }
	 else
	   {	/* Inline/recursion.scm 42 */
	      {		/* Inline/recursion.scm 51 */
		 obj_t labels_node_100_854;
		 labels_node_100_854 =
		    inline_app_labels_34_inline_recursion(node_1, kfactor_2, stack_3);
		 return
		    (node_bglt) (labels_node_100_854);
	      }
	   }
      }
   }
}



/* _inline-app-recursive1846 */
obj_t 
_inline_app_recursive1846_161_inline_recursion(obj_t env_1840, obj_t node_1841, obj_t kfactor_1842, obj_t stack_1843)
{
   AN_OBJECT;
   {	/* Inline/recursion.scm 39 */
      {		/* Inline/recursion.scm 39 */
	 node_bglt aux_1903;
	 aux_1903 =
	    inline_app_recursive_121_inline_recursion(
	    (node_bglt) (node_1841),
	    (long) CINT(kfactor_1842), stack_1843);
	 return
	    (obj_t) (aux_1903);
      }
   }
}



/* inline-app-labels */
obj_t 
inline_app_labels_34_inline_recursion(node_bglt node_4, long kfactor_5, obj_t stack_6)
{
   AN_OBJECT;
   {	/* Inline/recursion.scm 59 */
      {		/* Inline/recursion.scm 60 */
	 variable_bglt variable_856;
	 {	/* Inline/recursion.scm 60 */
	    var_bglt arg1617_972;
	    {	/* Inline/recursion.scm 60 */
	       app_bglt obj_1524;
	       obj_1524 =
		  (app_bglt) (node_4);
	       arg1617_972 =
		  (((app_bglt) CREF(obj_1524))->fun);
	    }
	    variable_856 =
	       (((var_bglt) CREF(arg1617_972))->variable);
	 }
	 {	/* Inline/recursion.scm 60 */
	    long call_size_65_857;
	    {	/* ./Ieee/fixnum.scm 7193 */
	       long aux_1911;
	       {	/* Inline/recursion.scm 61 */
		  obj_t aux_1912;
		  {	/* Inline/recursion.scm 61 */
		     app_bglt obj_1526;
		     obj_1526 =
			(app_bglt) (node_4);
		     aux_1912 =
			(((app_bglt) CREF(obj_1526))->args);
		  }
		  aux_1911 =
		     list_length(aux_1912);
	       }
	       call_size_65_857 =
		  (((long) 1) + aux_1911);
	    }
	    {	/* Inline/recursion.scm 61 */
	       local_bglt local_858;
	       {	/* Inline/recursion.scm 62 */
		  sfun_bglt aux_1917;
		  {	/* Inline/recursion.scm 62 */
		     value_bglt aux_1920;
		     aux_1920 =
			(((variable_bglt) CREF(variable_856))->value);
		     aux_1917 =
			(sfun_bglt) (aux_1920);
		  }
		  local_858 =
		     make_local_sfun_184_ast_local(
		     (((variable_bglt) CREF(variable_856))->id),
		     (((variable_bglt) CREF(variable_856))->type), aux_1917);
	       }
	       {	/* Inline/recursion.scm 62 */
		  value_bglt old_sfun_249_859;
		  old_sfun_249_859 =
		     (((variable_bglt) CREF(variable_856))->value);
		  {	/* Inline/recursion.scm 65 */
		     obj_t rec_calls_225_860;
		     {	/* Inline/recursion.scm 66 */
			isfun_bglt obj_1533;
			obj_1533 =
			   (isfun_bglt) (old_sfun_249_859);
			{
			   obj_t aux_1926;
			   {	/* ./Inline/inline.scm 1479 */
			      object_bglt aux_1927;
			      aux_1927 =
				 (object_bglt) (obj_1533);
			      aux_1926 =
				 OBJECT_WIDENING(aux_1927);
			   }
			   rec_calls_225_860 =
			      (((isfun_bglt) CREF(aux_1926))->recursive_calls_44);
			}
		     }
		     {	/* Inline/recursion.scm 66 */
			obj_t old_args_130_861;
			{	/* Inline/recursion.scm 67 */
			   sfun_bglt obj_1534;
			   obj_1534 =
			      (sfun_bglt) (old_sfun_249_859);
			   old_args_130_861 =
			      (((sfun_bglt) CREF(obj_1534))->args);
			}
			{	/* Inline/recursion.scm 67 */
			   obj_t inv_args_8_862;
			   inv_args_8_862 =
			      invariant_args_254_inline_variant(variable_856, rec_calls_225_860);
			   {	/* Inline/recursion.scm 68 */
			      obj_t var_args_195_863;
			      var_args_195_863 =
				 variant_args_126_inline_variant(variable_856);
			      {		/* Inline/recursion.scm 69 */
				 obj_t new_args_235_864;
				 if (
				    NULLP(var_args_195_863))
				   {	/* Inline/recursion.scm 70 */
				      new_args_235_864 = BNIL;
				   }
				 else
				   {	/* Inline/recursion.scm 70 */
				      obj_t head1473_952;
				      head1473_952 =
					 MAKE_PAIR(BNIL, BNIL);
				      {
					 obj_t l1471_953;
					 obj_t tail1474_954;
					 l1471_953 = var_args_195_863;
					 tail1474_954 = head1473_952;
				       lname1472_955:
					 if (
					    NULLP(l1471_953))
					   {	/* Inline/recursion.scm 70 */
					      new_args_235_864 =
						 CDR(head1473_952);
					   }
					 else
					   {	/* Inline/recursion.scm 71 */
					      obj_t newtail1475_957;
					      {		/* Inline/recursion.scm 71 */
						 local_bglt arg1607_959;
						 {	/* Inline/recursion.scm 71 */
						    obj_t l_961;
						    l_961 =
						       CAR(l1471_953);
						    {	/* Inline/recursion.scm 73 */
						       svar_bglt arg1609_962;
						       {	/* Inline/recursion.scm 73 */
							  svar_bglt duplicated1476_963;
							  {	/* Inline/recursion.scm 73 */
							     local_bglt obj_1541;
							     obj_1541 =
								(local_bglt) (l_961);
							     {	/* ./Ast/var.scm 966 */
								value_bglt aux_1943;
								aux_1943 =
								   (((local_bglt) CREF(obj_1541))->value);
								duplicated1476_963 =
								   (svar_bglt) (aux_1943);
							     }
							  }
							  {	/* Inline/recursion.scm 73 */
							     svar_bglt new1477_964;
							     {	/* Inline/recursion.scm 73 */
								obj_t arg1610_965;
								arg1610_965 =
								   (((svar_bglt) CREF(duplicated1476_963))->loc);
								{	/* Inline/recursion.scm 73 */
								   svar_bglt res1840_1549;
								   {	/* ./Ast/var.scm 1015 */
								      svar_bglt new1161_1544;
								      new1161_1544 =
									 ((svar_bglt) BREF(GC_MALLOC(sizeof(struct svar))));
								      {		/* ./Ast/var.scm 1015 */
									 long arg1722_1545;
									 arg1722_1545 =
									    class_num_218___object(svar_ast_var);
									 {	/* ./Ast/var.scm 1015 */
									    obj_t obj_1547;
									    obj_1547 =
									       (obj_t) (new1161_1544);
									    (((obj_t) CREF(obj_1547))->header = MAKE_HEADER(arg1722_1545, 0), BUNSPEC);
									 }
								      }
								      {		/* ./Ast/var.scm 1015 */
									 object_bglt aux_1951;
									 aux_1951 =
									    (object_bglt) (new1161_1544);
									 OBJECT_WIDENING_SET(aux_1951, BFALSE);
								      }
								      ((((svar_bglt) CREF(new1161_1544))->loc) = ((obj_t) arg1610_965), BUNSPEC);
								      res1840_1549 = new1161_1544;
								   }
								   new1477_964 = res1840_1549;
								}
							     }
							     {	/* Inline/recursion.scm 73 */

								arg1609_962 = new1477_964;
							     }
							  }
						       }
						       arg1607_959 =
							  clone_local_230_ast_local(
							  (local_bglt) (l_961),
							  (value_bglt) (arg1609_962));
						    }
						 }
						 {	/* ./Ieee/pair-list.scm 5689 */
						    obj_t aux_1958;
						    aux_1958 =
						       (obj_t) (arg1607_959);
						    newtail1475_957 =
						       MAKE_PAIR(aux_1958, BNIL);
						 }
					      }
					      SET_CDR(tail1474_954, newtail1475_957);
					      {
						 obj_t tail1474_1964;
						 obj_t l1471_1962;
						 l1471_1962 =
						    CDR(l1471_953);
						 tail1474_1964 = newtail1475_957;
						 tail1474_954 = tail1474_1964;
						 l1471_953 = l1471_1962;
						 goto lname1472_955;
					      }
					   }
				      }
				   }
				 {	/* Inline/recursion.scm 70 */
				    obj_t substitute_865;
				    {	/* Inline/recursion.scm 75 */
				       obj_t aux_1965;
				       {	/* Inline/recursion.scm 75 */
					  app_bglt obj_1555;
					  obj_1555 =
					     (app_bglt) (node_4);
					  aux_1965 =
					     (((app_bglt) CREF(obj_1555))->args);
				       }
				       substitute_865 =
					  substitutions_inline_variant(variable_856, aux_1965, new_args_235_864);
				    }
				    {	/* Inline/recursion.scm 75 */
				       obj_t old_body_129_866;
				       {	/* Inline/recursion.scm 76 */
					  bool_t test1602_948;
					  test1602_948 =
					     is_a__118___object(
					     (obj_t) (old_sfun_249_859), isfun_inline_inline);
					  if (test1602_948)
					    {	/* Inline/recursion.scm 77 */
					       isfun_bglt obj_1557;
					       obj_1557 =
						  (isfun_bglt) (old_sfun_249_859);
					       {	/* ./Inline/inline.scm 1478 */
						  node_bglt aux_1973;
						  {
						     obj_t aux_1974;
						     {	/* ./Inline/inline.scm 1478 */
							object_bglt aux_1975;
							aux_1975 =
							   (object_bglt) (obj_1557);
							aux_1974 =
							   OBJECT_WIDENING(aux_1975);
						     }
						     aux_1973 =
							(((isfun_bglt) CREF(aux_1974))->original_body_40);
						  }
						  old_body_129_866 =
						     (obj_t) (aux_1973);
					       }
					    }
					  else
					    {	/* Inline/recursion.scm 78 */
					       sfun_bglt obj_1558;
					       obj_1558 =
						  (sfun_bglt) (old_sfun_249_859);
					       old_body_129_866 =
						  (((sfun_bglt) CREF(obj_1558))->body);
					    }
				       }
				       {	/* Inline/recursion.scm 76 */
					  obj_t svg_calls_args_120_867;
					  if (
					     NULLP(rec_calls_225_860))
					    {	/* Inline/recursion.scm 79 */
					       svg_calls_args_120_867 = BNIL;
					    }
					  else
					    {	/* Inline/recursion.scm 79 */
					       obj_t head1480_938;
					       head1480_938 =
						  MAKE_PAIR(BNIL, BNIL);
					       {
						  obj_t l1478_939;
						  obj_t tail1481_940;
						  l1478_939 = rec_calls_225_860;
						  tail1481_940 = head1480_938;
						lname1479_941:
						  if (
						     NULLP(l1478_939))
						    {	/* Inline/recursion.scm 79 */
						       svg_calls_args_120_867 =
							  CDR(head1480_938);
						    }
						  else
						    {	/* Inline/recursion.scm 79 */
						       obj_t newtail1482_943;
						       {	/* ./Ieee/pair-list.scm 5689 */
							  obj_t aux_1988;
							  {	/* Inline/recursion.scm 79 */
							     app_bglt obj_1565;
							     {	/* Inline/recursion.scm 79 */
								obj_t aux_1989;
								aux_1989 =
								   CAR(l1478_939);
								obj_1565 =
								   (app_bglt) (aux_1989);
							     }
							     aux_1988 =
								(((app_bglt) CREF(obj_1565))->args);
							  }
							  newtail1482_943 =
							     MAKE_PAIR(aux_1988, BNIL);
						       }
						       SET_CDR(tail1481_940, newtail1482_943);
						       {
							  obj_t tail1481_1997;
							  obj_t l1478_1995;
							  l1478_1995 =
							     CDR(l1478_939);
							  tail1481_1997 = newtail1482_943;
							  tail1481_940 = tail1481_1997;
							  l1478_939 = l1478_1995;
							  goto lname1479_941;
						       }
						    }
					       }
					    }
					  {	/* Inline/recursion.scm 79 */
					     bool_t remove__21_868;
					     {
						obj_t l1483_931;
						l1483_931 = rec_calls_225_860;
					      lname1484_932:
						if (
						   PAIRP(l1483_931))
						  {	/* Inline/recursion.scm 80 */
						     {	/* Inline/recursion.scm 80 */
							app_bglt aux_2000;
							{	/* Inline/recursion.scm 80 */
							   obj_t aux_2001;
							   aux_2001 =
							      CAR(l1483_931);
							   aux_2000 =
							      (app_bglt) (aux_2001);
							}
							remove_invariant_args__113_inline_variant(aux_2000);
						     }
						     {
							obj_t l1483_2005;
							l1483_2005 =
							   CDR(l1483_931);
							l1483_931 = l1483_2005;
							goto lname1484_932;
						     }
						  }
						else
						  {	/* Inline/recursion.scm 80 */
						     remove__21_868 = ((bool_t) 1);
						  }
					     }
					     {	/* Inline/recursion.scm 80 */
						node_bglt new_body_215_869;
						{	/* Inline/recursion.scm 81 */
						   obj_t arg1591_928;
						   obj_t arg1592_929;
						   obj_t arg1593_930;
						   {	/* ./Ieee/pair-list.scm 5689 */
						      obj_t aux_2007;
						      aux_2007 =
							 (obj_t) (variable_856);
						      arg1591_928 =
							 MAKE_PAIR(aux_2007, old_args_130_861);
						   }
						   {	/* ./Ieee/pair-list.scm 5689 */
						      obj_t aux_2010;
						      aux_2010 =
							 (obj_t) (local_858);
						      arg1592_929 =
							 MAKE_PAIR(aux_2010, substitute_865);
						   }
						   arg1593_930 =
						      (((node_bglt) CREF(node_4))->loc);
						   new_body_215_869 =
						      alphatize_ast_alphatize(arg1591_928, arg1592_929, arg1593_930,
						      (node_bglt) (old_body_129_866));
						}
						{	/* Inline/recursion.scm 81 */
						   bool_t restore__176_870;
						   {
						      obj_t ll1485_920;
						      obj_t ll1486_921;
						      ll1485_920 = rec_calls_225_860;
						      ll1486_921 = svg_calls_args_120_867;
						    lname1487_922:
						      if (
							 NULLP(ll1485_920))
							{	/* Inline/recursion.scm 85 */
							   restore__176_870 = ((bool_t) 1);
							}
						      else
							{	/* Inline/recursion.scm 85 */
							   {	/* Inline/recursion.scm 86 */
							      obj_t args_925;
							      args_925 =
								 CAR(ll1486_921);
							      {		/* Inline/recursion.scm 86 */
								 app_bglt obj_1582;
								 {	/* Inline/recursion.scm 86 */
								    obj_t aux_2019;
								    aux_2019 =
								       CAR(ll1485_920);
								    obj_1582 =
								       (app_bglt) (aux_2019);
								 }
								 ((((app_bglt) CREF(obj_1582))->args) = ((obj_t) args_925), BUNSPEC);
							      }
							   }
							   {
							      obj_t ll1486_2025;
							      obj_t ll1485_2023;
							      ll1485_2023 =
								 CDR(ll1485_920);
							      ll1486_2025 =
								 CDR(ll1486_921);
							      ll1486_921 = ll1486_2025;
							      ll1485_920 = ll1485_2023;
							      goto lname1487_922;
							   }
							}
						   }
						   {	/* Inline/recursion.scm 85 */
						      sfun_bglt new_sfun_134_871;
						      {		/* Inline/recursion.scm 89 */
							 sfun_bglt duplicated1488_906;
							 duplicated1488_906 =
							    (sfun_bglt) (old_sfun_249_859);
							 {	/* Inline/recursion.scm 89 */
							    sfun_bglt new1489_907;
							    {	/* Inline/recursion.scm 89 */
							       long arg1576_908;
							       obj_t arg1577_909;
							       obj_t arg1578_910;
							       obj_t arg1579_911;
							       bool_t arg1580_912;
							       obj_t arg1581_913;
							       obj_t arg1582_914;
							       obj_t arg1585_917;
							       obj_t arg1586_918;
							       obj_t arg1587_919;
							       arg1576_908 =
								  (((sfun_bglt) CREF(duplicated1488_906))->arity);
							       arg1577_909 =
								  (((sfun_bglt) CREF(duplicated1488_906))->side_effect__165);
							       arg1578_910 =
								  (((sfun_bglt) CREF(duplicated1488_906))->predicate_of_78);
							       arg1579_911 =
								  (((sfun_bglt) CREF(duplicated1488_906))->stack_allocator_172);
							       arg1580_912 =
								  (((sfun_bglt) CREF(duplicated1488_906))->top__138);
							       arg1581_913 =
								  (((sfun_bglt) CREF(duplicated1488_906))->the_closure_238);
							       arg1582_914 =
								  (((sfun_bglt) CREF(duplicated1488_906))->property);
							       arg1585_917 =
								  CNST_TABLE_REF(((long) 0));
							       arg1586_918 =
								  (((sfun_bglt) CREF(duplicated1488_906))->dsssl_keywords_243);
							       arg1587_919 =
								  (((sfun_bglt) CREF(duplicated1488_906))->loc);
							       {	/* Inline/recursion.scm 89 */
								  sfun_bglt res1841_1623;
								  {	/* Inline/recursion.scm 89 */
								     obj_t body_1603;
								     body_1603 =
									(obj_t) (new_body_215_869);
								     {	/* ./Ast/var.scm 986 */
									sfun_bglt new1127_1607;
									new1127_1607 =
									   ((sfun_bglt) BREF(GC_MALLOC(sizeof(struct sfun))));
									{	/* ./Ast/var.scm 986 */
									   long arg1726_1608;
									   arg1726_1608 =
									      class_num_218___object(sfun_ast_var);
									   {	/* ./Ast/var.scm 986 */
									      obj_t obj_1621;
									      obj_1621 =
										 (obj_t) (new1127_1607);
									      (((obj_t) CREF(obj_1621))->header = MAKE_HEADER(arg1726_1608, 0), BUNSPEC);
									   }
									}
									{	/* ./Ast/var.scm 986 */
									   object_bglt aux_2043;
									   aux_2043 =
									      (object_bglt) (new1127_1607);
									   OBJECT_WIDENING_SET(aux_2043, BFALSE);
									}
									((((sfun_bglt) CREF(new1127_1607))->arity) = ((long) arg1576_908), BUNSPEC);
									((((sfun_bglt) CREF(new1127_1607))->side_effect__165) = ((obj_t) arg1577_909), BUNSPEC);
									((((sfun_bglt) CREF(new1127_1607))->predicate_of_78) = ((obj_t) arg1578_910), BUNSPEC);
									((((sfun_bglt) CREF(new1127_1607))->stack_allocator_172) = ((obj_t) arg1579_911), BUNSPEC);
									((((sfun_bglt) CREF(new1127_1607))->top__138) = ((bool_t) arg1580_912), BUNSPEC);
									((((sfun_bglt) CREF(new1127_1607))->the_closure_238) = ((obj_t) arg1581_913), BUNSPEC);
									((((sfun_bglt) CREF(new1127_1607))->property) = ((obj_t) arg1582_914), BUNSPEC);
									((((sfun_bglt) CREF(new1127_1607))->args) = ((obj_t) new_args_235_864), BUNSPEC);
									((((sfun_bglt) CREF(new1127_1607))->body) = ((obj_t) body_1603), BUNSPEC);
									((((sfun_bglt) CREF(new1127_1607))->class) = ((obj_t) arg1585_917), BUNSPEC);
									((((sfun_bglt) CREF(new1127_1607))->dsssl_keywords_243) = ((obj_t) arg1586_918), BUNSPEC);
									((((sfun_bglt) CREF(new1127_1607))->loc) = ((obj_t) arg1587_919), BUNSPEC);
									res1841_1623 = new1127_1607;
								     }
								  }
								  new1489_907 = res1841_1623;
							       }
							    }
							    {	/* Inline/recursion.scm 89 */

							       new_sfun_134_871 = new1489_907;
							    }
							 }
						      }
						      {		/* Inline/recursion.scm 89 */
							 obj_t new_kfactor_216_872;
							 new_kfactor_216_872 =
							    PROCEDURE_ENTRY(_inlining_reduce_kfactor__26_engine_param) (_inlining_reduce_kfactor__26_engine_param,
							    BINT(kfactor_5), BEOA);
							 {	/* Inline/recursion.scm 93 */

							    {
							       obj_t ll1490_873;
							       obj_t ll1491_874;
							       ll1490_873 = new_args_235_864;
							       ll1491_874 = old_args_130_861;
							     lname1492_875:
							       if (
								  NULLP(ll1490_873))
								 {	/* Inline/recursion.scm 95 */
								    ((bool_t) 1);
								 }
							       else
								 {	/* Inline/recursion.scm 95 */
								    {	/* Inline/recursion.scm 96 */
								       bool_t arg1549_879;
								       {	/* Inline/recursion.scm 96 */
									  local_bglt obj_1627;
									  {	/* Inline/recursion.scm 96 */
									     obj_t aux_2063;
									     aux_2063 =
										CAR(ll1491_874);
									     obj_1627 =
										(local_bglt) (aux_2063);
									  }
									  arg1549_879 =
									     (((local_bglt) CREF(obj_1627))->user__32);
								       }
								       {	/* Inline/recursion.scm 96 */
									  local_bglt obj_1628;
									  {	/* Inline/recursion.scm 96 */
									     obj_t aux_2067;
									     aux_2067 =
										CAR(ll1490_873);
									     obj_1628 =
										(local_bglt) (aux_2067);
									  }
									  ((((local_bglt) CREF(obj_1628))->user__32) = ((bool_t) arg1549_879), BUNSPEC);
								       }
								    }
								    {
								       obj_t ll1491_2073;
								       obj_t ll1490_2071;
								       ll1490_2071 =
									  CDR(ll1490_873);
								       ll1491_2073 =
									  CDR(ll1491_874);
								       ll1491_874 = ll1491_2073;
								       ll1490_873 = ll1490_2071;
								       goto lname1492_875;
								    }
								 }
							    }
							    {	/* Inline/recursion.scm 101 */
							       bool_t arg1552_882;
							       {	/* Inline/recursion.scm 101 */
								  bool_t test1553_883;
								  test1553_883 =
								     is_a__118___object(
								     (obj_t) (variable_856), global_ast_var);
								  if (test1553_883)
								    {	/* Inline/recursion.scm 101 */
								       {	/* Inline/recursion.scm 102 */
									  global_bglt obj_1633;
									  obj_1633 =
									     (global_bglt) (variable_856);
									  arg1552_882 =
									     (((global_bglt) CREF(obj_1633))->user__32);
								       }
								    }
								  else
								    {	/* Inline/recursion.scm 103 */
								       bool_t test1554_884;
								       test1554_884 =
									  is_a__118___object(
									  (obj_t) (variable_856), local_ast_var);
								       if (test1554_884)
									 {	/* Inline/recursion.scm 103 */
									    {	/* Inline/recursion.scm 104 */
									       local_bglt obj_1635;
									       obj_1635 =
										  (local_bglt) (variable_856);
									       arg1552_882 =
										  (((local_bglt) CREF(obj_1635))->user__32);
									    }
									 }
								       else
									 {	/* Inline/recursion.scm 103 */
									    arg1552_882 = ((bool_t) 0);
									 }
								    }
							       }
							       ((((local_bglt) CREF(local_858))->user__32) = ((bool_t) arg1552_882), BUNSPEC);
							    }
							    {	/* Inline/recursion.scm 107 */
							       value_bglt val1083_1639;
							       val1083_1639 =
								  (value_bglt) (new_sfun_134_871);
							       ((((local_bglt) CREF(local_858))->value) = ((value_bglt) val1083_1639), BUNSPEC);
							    }
							    {	/* Inline/recursion.scm 116 */
							       bool_t test_2088;
							       {	/* Inline/recursion.scm 116 */
								  obj_t aux_2089;
								  {	/* Inline/recursion.scm 116 */
								     obj_t aux_2090;
								     {	/* Inline/recursion.scm 116 */
									sfun_bglt obj_1640;
									obj_1640 =
									   (sfun_bglt) (old_sfun_249_859);
									aux_2090 =
									   (((sfun_bglt) CREF(obj_1640))->class);
								     }
								     aux_2089 =
									memq___r4_pairs_and_lists_6_3(aux_2090,
									CNST_TABLE_REF(((long) 1)));
								  }
								  test_2088 =
								     CBOOL(aux_2089);
							       }
							       if (test_2088)
								 {	/* Inline/recursion.scm 116 */
								    BUNSPEC;
								 }
							       else
								 {	/* Inline/recursion.scm 117 */
								    bool_t test1556_887;
								    test1556_887 =
								       ___161___r4_numbers_6_5(
								       BINT(((long) 3)), _verbose__1_engine_param, BNIL);
								    if (test1556_887)
								      {		/* Inline/recursion.scm 117 */
									 obj_t arg1558_889;
									 obj_t arg1560_891;
									 arg1558_889 =
									    shape_tools_shape(
									    (obj_t) (variable_856));
									 arg1560_891 =
									    current_function_76_tools_error();
									 {	/* Inline/recursion.scm 117 */
									    obj_t list1562_893;
									    {	/* Inline/recursion.scm 117 */
									       obj_t arg1563_894;
									       {	/* Inline/recursion.scm 117 */
										  obj_t arg1564_895;
										  {	/* Inline/recursion.scm 117 */
										     obj_t arg1565_896;
										     {	/* Inline/recursion.scm 117 */
											obj_t arg1566_897;
											{	/* Inline/recursion.scm 117 */
											   obj_t arg1567_898;
											   {	/* Inline/recursion.scm 117 */
											      obj_t aux_2102;
											      aux_2102 =
												 BCHAR(((unsigned char) '\n'));
											      arg1567_898 =
												 MAKE_PAIR(aux_2102, BNIL);
											   }
											   arg1566_897 =
											      MAKE_PAIR(string1850_inline_recursion, arg1567_898);
											}
											arg1565_896 =
											   MAKE_PAIR(arg1560_891, arg1566_897);
										     }
										     arg1564_895 =
											MAKE_PAIR(string1851_inline_recursion, arg1565_896);
										  }
										  arg1563_894 =
										     MAKE_PAIR(arg1558_889, arg1564_895);
									       }
									       list1562_893 =
										  MAKE_PAIR(string1852_inline_recursion, arg1563_894);
									    }
									    verbose_tools_speek(
									       BINT(((long) 3)), list1562_893);
									 }
								      }
								    else
								      {		/* Inline/recursion.scm 117 */
									 BUNSPEC;
								      }
								 }
							    }
							    inline_sfun__229_inline_inline(
							       (variable_bglt) (local_858),
							       (long) CINT(new_kfactor_216_872), stack_6);
							    {	/* Inline/recursion.scm 127 */
							       app_bglt new_call_202_902;
							       new_call_202_902 =
								  remove_invariant_args__113_inline_variant(
								  (app_bglt) (node_4));
							       {	/* Inline/recursion.scm 128 */
								  bool_t test1572_903;
								  if (
								     CBOOL(_optim_unroll_loop___80_engine_param))
								    {	/* Inline/recursion.scm 129 */
								       bool_t test1573_904;
								       test1573_904 =
									  is_loop__232_inline_loop(variable_856);
								       if (test1573_904)
									 {	/* Inline/recursion.scm 132 */
									    bool_t test1574_905;
									    test1574_905 =
									       inner_loop__79_inline_loop(variable_856);
									    if (test1574_905)
									      {		/* Inline/recursion.scm 132 */
										 test1572_903 = ((bool_t) 0);
									      }
									    else
									      {		/* Inline/recursion.scm 132 */
										 test1572_903 =
										    inline_app__99_inline_app(
										    (variable_bglt) (local_858),
										    (long) CINT(new_kfactor_216_872), call_size_65_857, stack_6);
									      }
									 }
								       else
									 {	/* Inline/recursion.scm 129 */
									    test1572_903 = ((bool_t) 0);
									 }
								    }
								  else
								    {	/* Inline/recursion.scm 128 */
								       test1572_903 = ((bool_t) 0);
								    }
								  if (test1572_903)
								    {	/* Inline/recursion.scm 128 */
								       return
									  unroll_call_164_inline_recursion(variable_856, node_4, local_858, new_kfactor_216_872, new_call_202_902, stack_6);
								    }
								  else
								    {	/* Inline/recursion.scm 135 */
								       let_fun_218_bglt aux_2128;
								       aux_2128 =
									  plain_call_51_inline_recursion(variable_856, node_4, local_858, new_call_202_902, stack_6);
								       return
									  (obj_t) (aux_2128);
								    }
							       }
							    }
							 }
						      }
						   }
						}
					     }
					  }
				       }
				    }
				 }
			      }
			   }
			}
		     }
		  }
	       }
	    }
	 }
      }
   }
}



/* plain-call */
let_fun_218_bglt 
plain_call_51_inline_recursion(variable_bglt variable_7, node_bglt node_8, local_bglt local_9, app_bglt new_call_202_10, obj_t stack_11)
{
   AN_OBJECT;
   {	/* Inline/recursion.scm 140 */
      shrink_args__237_inline_variant(variable_7);
      {		/* Inline/recursion.scm 150 */
	 obj_t loc_973;
	 loc_973 =
	    (((node_bglt) CREF(node_8))->loc);
	 {	/* Inline/recursion.scm 151 */
	    type_bglt arg1619_975;
	    obj_t arg1621_977;
	    node_bglt arg1622_978;
	    arg1619_975 =
	       (((node_bglt) CREF(node_8))->type);
	    {	/* Inline/recursion.scm 154 */
	       obj_t list1623_979;
	       {	/* Inline/recursion.scm 154 */
		  obj_t aux_2134;
		  aux_2134 =
		     (obj_t) (local_9);
		  list1623_979 =
		     MAKE_PAIR(aux_2134, BNIL);
	       }
	       arg1621_977 = list1623_979;
	    }
	    {	/* Inline/recursion.scm 155 */
	       obj_t arg1624_980;
	       obj_t arg1625_981;
	       {	/* Inline/recursion.scm 155 */
		  obj_t list1626_982;
		  {	/* Inline/recursion.scm 155 */
		     obj_t aux_2137;
		     aux_2137 =
			(obj_t) (variable_7);
		     list1626_982 =
			MAKE_PAIR(aux_2137, BNIL);
		  }
		  arg1624_980 = list1626_982;
	       }
	       {	/* Inline/recursion.scm 155 */
		  obj_t list1627_983;
		  {	/* Inline/recursion.scm 155 */
		     obj_t aux_2140;
		     aux_2140 =
			(obj_t) (local_9);
		     list1627_983 =
			MAKE_PAIR(aux_2140, BNIL);
		  }
		  arg1625_981 = list1627_983;
	       }
	       arg1622_978 =
		  alphatize_ast_alphatize(arg1624_980, arg1625_981, loc_973,
		  (node_bglt) (new_call_202_10));
	    }
	    {	/* Inline/recursion.scm 151 */
	       let_fun_218_bglt res1842_1662;
	       {	/* Inline/recursion.scm 151 */
		  obj_t key_1649;
		  key_1649 =
		     BINT(((long) -1));
		  {	/* ./Ast/node.scm 1166 */
		     let_fun_218_bglt new1358_1652;
		     new1358_1652 =
			((let_fun_218_bglt) BREF(GC_MALLOC(sizeof(struct let_fun_218))));
		     {	/* ./Ast/node.scm 1166 */
			long arg1681_1653;
			arg1681_1653 =
			   class_num_218___object(let_fun_218_ast_node);
			{	/* ./Ast/node.scm 1166 */
			   obj_t obj_1660;
			   obj_1660 =
			      (obj_t) (new1358_1652);
			   (((obj_t) CREF(obj_1660))->header = MAKE_HEADER(arg1681_1653, 0), BUNSPEC);
			}
		     }
		     {	/* ./Ast/node.scm 1166 */
			object_bglt aux_2150;
			aux_2150 =
			   (object_bglt) (new1358_1652);
			OBJECT_WIDENING_SET(aux_2150, BFALSE);
		     }
		     ((((let_fun_218_bglt) CREF(new1358_1652))->loc) = ((obj_t) loc_973), BUNSPEC);
		     ((((let_fun_218_bglt) CREF(new1358_1652))->type) = ((type_bglt) arg1619_975), BUNSPEC);
		     ((((let_fun_218_bglt) CREF(new1358_1652))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
		     ((((let_fun_218_bglt) CREF(new1358_1652))->key) = ((obj_t) key_1649), BUNSPEC);
		     ((((let_fun_218_bglt) CREF(new1358_1652))->locals) = ((obj_t) arg1621_977), BUNSPEC);
		     ((((let_fun_218_bglt) CREF(new1358_1652))->body) = ((node_bglt) arg1622_978), BUNSPEC);
		     res1842_1662 = new1358_1652;
		  }
	       }
	       return res1842_1662;
	    }
	 }
      }
   }
}



/* unroll-call */
obj_t 
unroll_call_164_inline_recursion(variable_bglt variable_12, node_bglt node_13, local_bglt local_14, obj_t kfactor_15, app_bglt call_16, obj_t stack_17)
{
   AN_OBJECT;
   {	/* Inline/recursion.scm 160 */
      {		/* Inline/recursion.scm 166 */
	 obj_t loc_984;
	 {	/* Inline/recursion.scm 166 */
	    node_bglt obj_1663;
	    obj_1663 =
	       (node_bglt) (call_16);
	    loc_984 =
	       (((node_bglt) CREF(obj_1663))->loc);
	 }
	 {	/* Inline/recursion.scm 166 */
	    node_bglt new_call_202_985;
	    {	/* Inline/recursion.scm 167 */
	       obj_t arg1641_1005;
	       obj_t arg1642_1006;
	       {	/* Inline/recursion.scm 167 */
		  obj_t list1643_1007;
		  {	/* Inline/recursion.scm 167 */
		     obj_t aux_2161;
		     aux_2161 =
			(obj_t) (variable_12);
		     list1643_1007 =
			MAKE_PAIR(aux_2161, BNIL);
		  }
		  arg1641_1005 = list1643_1007;
	       }
	       {	/* Inline/recursion.scm 167 */
		  obj_t list1644_1008;
		  {	/* Inline/recursion.scm 167 */
		     obj_t aux_2164;
		     aux_2164 =
			(obj_t) (local_14);
		     list1644_1008 =
			MAKE_PAIR(aux_2164, BNIL);
		  }
		  arg1642_1006 = list1644_1008;
	       }
	       new_call_202_985 =
		  alphatize_ast_alphatize(arg1641_1005, arg1642_1006, loc_984,
		  (node_bglt) (call_16));
	    }
	    {	/* Inline/recursion.scm 168 */
	       node_bglt new_body_215_987;
	       {	/* Inline/recursion.scm 171 */
		  obj_t arg1638_1002;
		  {	/* ./Ieee/pair-list.scm 5689 */
		     obj_t aux_2169;
		     aux_2169 =
			(obj_t) (local_14);
		     arg1638_1002 =
			MAKE_PAIR(aux_2169, stack_17);
		  }
		  new_body_215_987 =
		     inline_app_simple_198_inline_simple(new_call_202_985,
		     (long) CINT(kfactor_15), arg1638_1002, string1853_inline_recursion);
	       }
	       {	/* Inline/recursion.scm 169 */

		  shrink_args__237_inline_variant(variable_12);
		  {	/* Inline/recursion.scm 180 */
		     obj_t __988;
		     {	/* Inline/recursion.scm 184 */
			node_bglt arg1628_990;
			{	/* Inline/recursion.scm 184 */
			   obj_t _anonymous_1631__2_1844;
			   _anonymous_1631__2_1844 =
			      make_fx_procedure(_anonymous_1631__2_inline_recursion, ((long) 1), ((long) 2));
			   PROCEDURE_SET(_anonymous_1631__2_1844, ((long) 0), loc_984);
			   {	/* Inline/recursion.scm 184 */
			      obj_t aux_2177;
			      aux_2177 =
				 (obj_t) (local_14);
			      PROCEDURE_SET(_anonymous_1631__2_1844, ((long) 1), aux_2177);
			   }
			   arg1628_990 =
			      nest_loop__92_inline_loop(new_body_215_987, local_14, _anonymous_1631__2_1844);
			}
			__988 =
			   node_cse__231_reduce_cse(arg1628_990, BNIL);
		     }
		     {	/* Inline/recursion.scm 180 */
			obj_t node_989;
			node_989 = _res1__155___r5_control_features_6_4;
			return node_989;
		     }
		  }
	       }
	    }
	 }
      }
   }
}



/* <anonymous:1631> */
obj_t 
_anonymous_1631__2_inline_recursion(obj_t env_1845, obj_t node_1848)
{
   AN_OBJECT;
   {	/* Inline/recursion.scm 183 */
      {		/* Inline/recursion.scm 184 */
	 obj_t loc_1846;
	 obj_t local_1847;
	 loc_1846 =
	    PROCEDURE_REF(env_1845, ((long) 0));
	 local_1847 =
	    PROCEDURE_REF(env_1845, ((long) 1));
	 {
	    obj_t node_993;
	    {	/* Inline/recursion.scm 184 */
	       let_fun_218_bglt aux_2184;
	       node_993 = node_1848;
	       {	/* Inline/recursion.scm 184 */
		  type_bglt arg1633_996;
		  obj_t arg1635_998;
		  {	/* Inline/recursion.scm 186 */
		     node_bglt obj_1670;
		     obj_1670 =
			(node_bglt) (node_993);
		     arg1633_996 =
			(((node_bglt) CREF(obj_1670))->type);
		  }
		  {	/* Inline/recursion.scm 188 */
		     obj_t list1637_1000;
		     list1637_1000 =
			MAKE_PAIR(local_1847, BNIL);
		     arg1635_998 = list1637_1000;
		  }
		  {	/* Inline/recursion.scm 184 */
		     let_fun_218_bglt res1843_1688;
		     {	/* Inline/recursion.scm 184 */
			obj_t key_1675;
			node_bglt body_1677;
			key_1675 =
			   BINT(((long) -1));
			body_1677 =
			   (node_bglt) (node_993);
			{	/* ./Ast/node.scm 1166 */
			   let_fun_218_bglt new1358_1678;
			   new1358_1678 =
			      ((let_fun_218_bglt) BREF(GC_MALLOC(sizeof(struct let_fun_218))));
			   {	/* ./Ast/node.scm 1166 */
			      long arg1681_1679;
			      arg1681_1679 =
				 class_num_218___object(let_fun_218_ast_node);
			      {		/* ./Ast/node.scm 1166 */
				 obj_t obj_1686;
				 obj_1686 =
				    (obj_t) (new1358_1678);
				 (((obj_t) CREF(obj_1686))->header = MAKE_HEADER(arg1681_1679, 0), BUNSPEC);
			      }
			   }
			   {	/* ./Ast/node.scm 1166 */
			      object_bglt aux_2194;
			      aux_2194 =
				 (object_bglt) (new1358_1678);
			      OBJECT_WIDENING_SET(aux_2194, BFALSE);
			   }
			   ((((let_fun_218_bglt) CREF(new1358_1678))->loc) = ((obj_t) loc_1846), BUNSPEC);
			   ((((let_fun_218_bglt) CREF(new1358_1678))->type) = ((type_bglt) arg1633_996), BUNSPEC);
			   ((((let_fun_218_bglt) CREF(new1358_1678))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
			   ((((let_fun_218_bglt) CREF(new1358_1678))->key) = ((obj_t) key_1675), BUNSPEC);
			   ((((let_fun_218_bglt) CREF(new1358_1678))->locals) = ((obj_t) arg1635_998), BUNSPEC);
			   ((((let_fun_218_bglt) CREF(new1358_1678))->body) = ((node_bglt) body_1677), BUNSPEC);
			   res1843_1688 = new1358_1678;
			}
		     }
		     aux_2184 = res1843_1688;
		  }
	       }
	       return
		  (obj_t) (aux_2184);
	    }
	 }
      }
   }
}



/* is-recursive? */
bool_t 
is_recursive__125_inline_recursion(variable_bglt var_18)
{
   AN_OBJECT;
   {	/* Inline/recursion.scm 195 */
      {		/* Inline/recursion.scm 197 */
	 value_bglt sfun_1009;
	 sfun_1009 =
	    (((variable_bglt) CREF(var_18))->value);
	 {	/* Inline/recursion.scm 198 */
	    bool_t test1645_1010;
	    test1645_1010 =
	       is_a__118___object(
	       (obj_t) (sfun_1009), isfun_inline_inline);
	    if (test1645_1010)
	      {		/* Inline/recursion.scm 205 */
		 bool_t test_2208;
		 {	/* ./Ieee/pair-list.scm 5669 */
		    obj_t aux_2209;
		    {	/* Inline/recursion.scm 205 */
		       isfun_bglt obj_1691;
		       obj_1691 =
			  (isfun_bglt) (sfun_1009);
		       {
			  obj_t aux_2211;
			  {	/* ./Inline/inline.scm 1479 */
			     object_bglt aux_2212;
			     aux_2212 =
				(object_bglt) (obj_1691);
			     aux_2211 =
				OBJECT_WIDENING(aux_2212);
			  }
			  aux_2209 =
			     (((isfun_bglt) CREF(aux_2211))->recursive_calls_44);
		       }
		    }
		    test_2208 =
		       PAIRP(aux_2209);
		 }
		 if (test_2208)
		   {	/* Inline/recursion.scm 205 */
		      return ((bool_t) 1);
		   }
		 else
		   {	/* Inline/recursion.scm 207 */
		      bool_t test_2217;
		      {		/* ./Ieee/pair-list.scm 5912 */
			 obj_t aux_2218;
			 {	/* Inline/recursion.scm 207 */
			    isfun_bglt obj_1693;
			    obj_1693 =
			       (isfun_bglt) (sfun_1009);
			    {
			       obj_t aux_2220;
			       {	/* ./Inline/inline.scm 1479 */
				  object_bglt aux_2221;
				  aux_2221 =
				     (object_bglt) (obj_1693);
				  aux_2220 =
				     OBJECT_WIDENING(aux_2221);
			       }
			       aux_2218 =
				  (((isfun_bglt) CREF(aux_2220))->recursive_calls_44);
			    }
			 }
			 test_2217 =
			    NULLP(aux_2218);
		      }
		      if (test_2217)
			{	/* Inline/recursion.scm 207 */
			   return ((bool_t) 0);
			}
		      else
			{	/* Inline/recursion.scm 207 */
			   {	/* Inline/recursion.scm 210 */
			      obj_t calls_1013;
			      {		/* Inline/recursion.scm 210 */
				 node_bglt aux_2226;
				 {	/* Inline/recursion.scm 210 */
				    isfun_bglt obj_1695;
				    obj_1695 =
				       (isfun_bglt) (sfun_1009);
				    {
				       obj_t aux_2228;
				       {	/* ./Inline/inline.scm 1478 */
					  object_bglt aux_2229;
					  aux_2229 =
					     (object_bglt) (obj_1695);
					  aux_2228 =
					     OBJECT_WIDENING(aux_2229);
				       }
				       aux_2226 =
					  (((isfun_bglt) CREF(aux_2228))->original_body_40);
				    }
				 }
				 calls_1013 =
				    find_recursive_calls_52_inline_recursion(aux_2226, var_18);
			      }
			      {		/* Inline/recursion.scm 212 */
				 isfun_bglt obj_1696;
				 obj_1696 =
				    (isfun_bglt) (sfun_1009);
				 {
				    obj_t aux_2235;
				    {	/* ./Inline/inline.scm 1479 */
				       object_bglt aux_2236;
				       aux_2236 =
					  (object_bglt) (obj_1696);
				       aux_2235 =
					  OBJECT_WIDENING(aux_2236);
				    }
				    ((((isfun_bglt) CREF(aux_2235))->recursive_calls_44) = ((obj_t) calls_1013), BUNSPEC);
				 }
			      }
			      return
				 PAIRP(calls_1013);
			   }
			}
		   }
	      }
	    else
	      {		/* Inline/recursion.scm 199 */
		 obj_t calls_1017;
		 {	/* Inline/recursion.scm 199 */
		    node_bglt aux_2241;
		    {	/* Inline/recursion.scm 199 */
		       obj_t aux_2242;
		       {	/* Inline/recursion.scm 199 */
			  sfun_bglt obj_1699;
			  obj_1699 =
			     (sfun_bglt) (sfun_1009);
			  aux_2242 =
			     (((sfun_bglt) CREF(obj_1699))->body);
		       }
		       aux_2241 =
			  (node_bglt) (aux_2242);
		    }
		    calls_1017 =
		       find_recursive_calls_52_inline_recursion(aux_2241, var_18);
		 }
		 {	/* Inline/recursion.scm 200 */
		    isfun_bglt obj1497_1018;
		    obj1497_1018 =
		       ((isfun_bglt) (sfun_1009));
		    {	/* Inline/recursion.scm 201 */
		       isfun_bglt arg1651_1019;
		       {	/* Inline/recursion.scm 200 */
			  isfun_bglt res1844_1706;
			  {	/* Inline/recursion.scm 200 */
			     node_bglt original_body_40_1701;
			     {	/* Inline/recursion.scm 200 */
				obj_t aux_2248;
				{	/* Inline/recursion.scm 201 */
				   sfun_bglt obj_1700;
				   obj_1700 =
				      (sfun_bglt) (sfun_1009);
				   aux_2248 =
				      (((sfun_bglt) CREF(obj_1700))->body);
				}
				original_body_40_1701 =
				   (node_bglt) (aux_2248);
			     }
			     {	/* ./Inline/inline.scm 1477 */
				isfun_bglt new1449_1703;
				new1449_1703 =
				   ((isfun_bglt) BREF(GC_MALLOC(sizeof(struct isfun))));
				((((isfun_bglt) CREF(new1449_1703))->original_body_40) = ((node_bglt) original_body_40_1701), BUNSPEC);
				((((isfun_bglt) CREF(new1449_1703))->recursive_calls_44) = ((obj_t) calls_1017), BUNSPEC);
				res1844_1706 = new1449_1703;
			     }
			  }
			  arg1651_1019 = res1844_1706;
		       }
		       {	/* Inline/recursion.scm 200 */
			  obj_t aux_2257;
			  object_bglt aux_2255;
			  aux_2257 =
			     (obj_t) (arg1651_1019);
			  aux_2255 =
			     (object_bglt) (obj1497_1018);
			  OBJECT_WIDENING_SET(aux_2255, aux_2257);
		       }
		    }
		    {	/* Inline/recursion.scm 200 */
		       long arg1654_1022;
		       arg1654_1022 =
			  class_num_218___object(isfun_inline_inline);
		       {	/* Inline/recursion.scm 200 */
			  obj_t obj_1707;
			  obj_1707 =
			     (obj_t) (obj1497_1018);
			  (((obj_t) CREF(obj_1707))->header = MAKE_HEADER(arg1654_1022, 0), BUNSPEC);
		       }
		    }
		    obj1497_1018;
		 }
		 return
		    PAIRP(calls_1017);
	      }
	 }
      }
   }
}



/* _is-recursive?1847 */
obj_t 
_is_recursive_1847_53_inline_recursion(obj_t env_1849, obj_t var_1850)
{
   AN_OBJECT;
   {	/* Inline/recursion.scm 195 */
      {		/* Inline/recursion.scm 195 */
	 bool_t aux_2264;
	 aux_2264 =
	    is_recursive__125_inline_recursion(
	    (variable_bglt) (var_1850));
	 return
	    BBOOL(aux_2264);
      }
   }
}



/* find-recursive-calls* */
obj_t 
find_recursive_calls__36_inline_recursion(obj_t node__221_57, variable_bglt var_58)
{
   AN_OBJECT;
   {	/* Inline/recursion.scm 364 */
      {
	 obj_t node__221_1024;
	 obj_t calls_1025;
	 node__221_1024 = node__221_57;
	 calls_1025 = BNIL;
       loop_1026:
	 if (
	    NULLP(node__221_1024))
	   {	/* Inline/recursion.scm 367 */
	      return calls_1025;
	   }
	 else
	   {	/* Inline/recursion.scm 369 */
	      obj_t arg1657_1028;
	      obj_t arg1658_1029;
	      arg1657_1028 =
		 CDR(node__221_1024);
	      {		/* Inline/recursion.scm 370 */
		 obj_t arg1659_1030;
		 {	/* Inline/recursion.scm 370 */
		    node_bglt aux_2271;
		    {	/* Inline/recursion.scm 370 */
		       obj_t aux_2272;
		       aux_2272 =
			  CAR(node__221_1024);
		       aux_2271 =
			  (node_bglt) (aux_2272);
		    }
		    arg1659_1030 =
		       find_recursive_calls_52_inline_recursion(aux_2271, var_58);
		 }
		 arg1658_1029 =
		    append_2_18___r4_pairs_and_lists_6_3(arg1659_1030, calls_1025);
	      }
	      {
		 obj_t calls_2278;
		 obj_t node__221_2277;
		 node__221_2277 = arg1657_1028;
		 calls_2278 = arg1658_1029;
		 calls_1025 = calls_2278;
		 node__221_1024 = node__221_2277;
		 goto loop_1026;
	      }
	   }
      }
   }
}



/* method-init */
obj_t 
method_init_76_inline_recursion()
{
   AN_OBJECT;
   {	/* Inline/recursion.scm 14 */
      add_generic__110___object(find_recursive_calls_env_59_inline_recursion, find_recursive_calls_default1506_env_10_inline_recursion);
      add_inlined_method__244___object(find_recursive_calls_env_59_inline_recursion, sequence_ast_node, ((long) 0));
      add_inlined_method__244___object(find_recursive_calls_env_59_inline_recursion, app_ast_node, ((long) 1));
      add_inlined_method__244___object(find_recursive_calls_env_59_inline_recursion, app_ly_162_ast_node, ((long) 2));
      add_inlined_method__244___object(find_recursive_calls_env_59_inline_recursion, funcall_ast_node, ((long) 3));
      add_inlined_method__244___object(find_recursive_calls_env_59_inline_recursion, pragma_ast_node, ((long) 4));
      add_inlined_method__244___object(find_recursive_calls_env_59_inline_recursion, cast_ast_node, ((long) 5));
      add_inlined_method__244___object(find_recursive_calls_env_59_inline_recursion, setq_ast_node, ((long) 6));
      add_inlined_method__244___object(find_recursive_calls_env_59_inline_recursion, conditional_ast_node, ((long) 7));
      add_inlined_method__244___object(find_recursive_calls_env_59_inline_recursion, fail_ast_node, ((long) 8));
      add_inlined_method__244___object(find_recursive_calls_env_59_inline_recursion, select_ast_node, ((long) 9));
      add_inlined_method__244___object(find_recursive_calls_env_59_inline_recursion, let_fun_218_ast_node, ((long) 10));
      add_inlined_method__244___object(find_recursive_calls_env_59_inline_recursion, let_var_6_ast_node, ((long) 11));
      add_inlined_method__244___object(find_recursive_calls_env_59_inline_recursion, set_ex_it_116_ast_node, ((long) 12));
      add_inlined_method__244___object(find_recursive_calls_env_59_inline_recursion, jump_ex_it_184_ast_node, ((long) 13));
      add_inlined_method__244___object(find_recursive_calls_env_59_inline_recursion, make_box_202_ast_node, ((long) 14));
      add_inlined_method__244___object(find_recursive_calls_env_59_inline_recursion, box_ref_242_ast_node, ((long) 15));
      {		/* Inline/recursion.scm 14 */
	 long aux_2296;
	 aux_2296 =
	    add_inlined_method__244___object(find_recursive_calls_env_59_inline_recursion, box_set__221_ast_node, ((long) 16));
	 return
	    BINT(aux_2296);
      }
   }
}



/* find-recursive-calls */
obj_t 
find_recursive_calls_52_inline_recursion(node_bglt node_19, variable_bglt var_20)
{
   AN_OBJECT;
   {	/* Inline/recursion.scm 218 */
    find_recursive_calls_52_inline_recursion:
      {
	 obj_t method1742_1379;
	 obj_t class1747_1380;
	 {	/* Inline/recursion.scm 218 */
	    obj_t arg1750_1377;
	    obj_t arg1751_1378;
	    {	/* Inline/recursion.scm 218 */
	       object_bglt obj_1763;
	       obj_1763 =
		  (object_bglt) (node_19);
	       {	/* ./Llib/object.scm 2926 */
		  obj_t pre_method_105_1764;
		  pre_method_105_1764 =
		     PROCEDURE_REF(find_recursive_calls_env_59_inline_recursion, ((long) 2));
		  if (
		     INTEGERP(pre_method_105_1764))
		    {	/* ./Llib/object.scm 2927 */
		       PROCEDURE_SET(find_recursive_calls_env_59_inline_recursion, ((long) 2), BUNSPEC);
		       arg1750_1377 = pre_method_105_1764;
		    }
		  else
		    {	/* ./Llib/object.scm 2914 */
		       long obj_class_num_177_1769;
		       obj_class_num_177_1769 =
			  TYPE(obj_1763);
		       {	/* ./Llib/object.scm 2915 */
			  obj_t arg1176_1770;
			  arg1176_1770 =
			     PROCEDURE_REF(find_recursive_calls_env_59_inline_recursion, ((long) 1));
			  {	/* ./Llib/object.scm 2738 */
			     long arg1177_1774;
			     {	/* ./Llib/object.scm 2738 */
				long arg1178_1775;
				arg1178_1775 =
				   OBJECT_TYPE;
				arg1177_1774 =
				   (obj_class_num_177_1769 - arg1178_1775);
			     }
			     arg1750_1377 =
				VECTOR_REF(arg1176_1770, arg1177_1774);
			  }
		       }
		    }
	       }
	    }
	    {	/* Inline/recursion.scm 218 */
	       object_bglt object_1780;
	       object_1780 =
		  (object_bglt) (node_19);
	       {	/* ./Llib/object.scm 2695 */
		  long arg1179_1781;
		  {	/* ./Llib/object.scm 2695 */
		     long arg1180_1782;
		     long arg1181_1783;
		     arg1180_1782 =
			TYPE(object_1780);
		     arg1181_1783 =
			OBJECT_TYPE;
		     arg1179_1781 =
			(arg1180_1782 - arg1181_1783);
		  }
		  {	/* ./Llib/object.scm 2695 */
		     obj_t vector_1787;
		     vector_1787 = _classes__134___object;
		     arg1751_1378 =
			VECTOR_REF(vector_1787, arg1179_1781);
		  }
	       }
	    }
	    method1742_1379 = arg1750_1377;
	    class1747_1380 = arg1751_1378;
	    {

	       if (
		  INTEGERP(method1742_1379))
		 {	/* Inline/recursion.scm 218 */
		    switch (
		       (long) CINT(method1742_1379))
		      {
		      case ((long) 0):

			 {	/* Inline/recursion.scm 225 */
			    sequence_bglt node_1386;
			    node_1386 =
			       (sequence_bglt) (node_19);
			    return
			       find_recursive_calls__36_inline_recursion(
			       (((sequence_bglt) CREF(node_1386))->nodes), var_20);
			 }
			 break;
		      case ((long) 1):

			 {	/* Inline/recursion.scm 234 */
			    app_bglt node_1389;
			    node_1389 =
			       (app_bglt) (node_19);
			    {	/* Inline/recursion.scm 235 */
			       obj_t args_calls_209_1392;
			       args_calls_209_1392 =
				  find_recursive_calls__36_inline_recursion(
				  (((app_bglt) CREF(node_1389))->args), var_20);
			       {	/* Inline/recursion.scm 236 */
				  bool_t test1755_1393;
				  {	/* Inline/recursion.scm 236 */
				     bool_t test1756_1394;
				     {	/* ./Ast/node.scm 1080 */
					obj_t aux_2322;
					{	/* Inline/recursion.scm 236 */
					   var_bglt aux_2323;
					   aux_2323 =
					      (((app_bglt) CREF(node_1389))->fun);
					   aux_2322 =
					      (obj_t) (aux_2323);
					}
					test1756_1394 =
					   is_a__118___object(aux_2322, var_ast_node);
				     }
				     if (test1756_1394)
				       {	/* ./Ieee/equiv.scm 5508 */
					  obj_t aux_2333;
					  obj_t aux_2328;
					  aux_2333 =
					     (obj_t) (var_20);
					  {	/* Inline/recursion.scm 236 */
					     variable_bglt aux_2329;
					     {	/* Inline/recursion.scm 236 */
						var_bglt arg1759_1396;
						arg1759_1396 =
						   (((app_bglt) CREF(node_1389))->fun);
						aux_2329 =
						   (((var_bglt) CREF(arg1759_1396))->variable);
					     }
					     aux_2328 =
						(obj_t) (aux_2329);
					  }
					  test1755_1393 =
					     (aux_2328 == aux_2333);
				       }
				     else
				       {	/* Inline/recursion.scm 236 */
					  test1755_1393 = ((bool_t) 0);
				       }
				  }
				  if (test1755_1393)
				    {	/* ./Ieee/pair-list.scm 5689 */
				       obj_t aux_2337;
				       aux_2337 =
					  (obj_t) (node_1389);
				       return
					  MAKE_PAIR(aux_2337, args_calls_209_1392);
				    }
				  else
				    {	/* Inline/recursion.scm 236 */
				       return args_calls_209_1392;
				    }
			       }
			    }
			 }
			 break;
		      case ((long) 2):

			 {	/* Inline/recursion.scm 244 */
			    app_ly_162_bglt node_1399;
			    node_1399 =
			       (app_ly_162_bglt) (node_19);
			    {	/* Inline/recursion.scm 245 */
			       obj_t arg1762_1402;
			       obj_t arg1763_1403;
			       arg1762_1402 =
				  find_recursive_calls_52_inline_recursion(
				  (((app_ly_162_bglt) CREF(node_1399))->fun), var_20);
			       arg1763_1403 =
				  find_recursive_calls_52_inline_recursion(
				  (((app_ly_162_bglt) CREF(node_1399))->arg), var_20);
			       return
				  append_2_18___r4_pairs_and_lists_6_3(arg1762_1402, arg1763_1403);
			    }
			 }
			 break;
		      case ((long) 3):

			 {	/* Inline/recursion.scm 251 */
			    funcall_bglt node_1406;
			    node_1406 =
			       (funcall_bglt) (node_19);
			    {	/* Inline/recursion.scm 252 */
			       obj_t arg1766_1409;
			       obj_t arg1767_1410;
			       arg1766_1409 =
				  find_recursive_calls_52_inline_recursion(
				  (((funcall_bglt) CREF(node_1406))->fun), var_20);
			       arg1767_1410 =
				  find_recursive_calls__36_inline_recursion(
				  (((funcall_bglt) CREF(node_1406))->args), var_20);
			       return
				  append_2_18___r4_pairs_and_lists_6_3(arg1766_1409, arg1767_1410);
			    }
			 }
			 break;
		      case ((long) 4):

			 {	/* Inline/recursion.scm 259 */
			    pragma_bglt node_1413;
			    node_1413 =
			       (pragma_bglt) (node_19);
			    return
			       find_recursive_calls__36_inline_recursion(
			       (((pragma_bglt) CREF(node_1413))->args), var_20);
			 }
			 break;
		      case ((long) 5):

			 {	/* Inline/recursion.scm 265 */
			    cast_bglt node_1416;
			    node_1416 =
			       (cast_bglt) (node_19);
			    {
			       node_bglt node_2356;
			       node_2356 =
				  (((cast_bglt) CREF(node_1416))->arg);
			       node_19 = node_2356;
			       goto find_recursive_calls_52_inline_recursion;
			    }
			 }
			 break;
		      case ((long) 6):

			 {	/* Inline/recursion.scm 271 */
			    setq_bglt node_1419;
			    node_1419 =
			       (setq_bglt) (node_19);
			    {
			       node_bglt node_2359;
			       node_2359 =
				  (((setq_bglt) CREF(node_1419))->value);
			       node_19 = node_2359;
			       goto find_recursive_calls_52_inline_recursion;
			    }
			 }
			 break;
		      case ((long) 7):

			 {	/* Inline/recursion.scm 277 */
			    conditional_bglt node_1422;
			    node_1422 =
			       (conditional_bglt) (node_19);
			    {	/* Inline/recursion.scm 278 */
			       obj_t arg1773_1425;
			       obj_t arg1774_1426;
			       obj_t arg1775_1427;
			       arg1773_1425 =
				  find_recursive_calls_52_inline_recursion(
				  (((conditional_bglt) CREF(node_1422))->test), var_20);
			       arg1774_1426 =
				  find_recursive_calls_52_inline_recursion(
				  (((conditional_bglt) CREF(node_1422))->true), var_20);
			       arg1775_1427 =
				  find_recursive_calls_52_inline_recursion(
				  (((conditional_bglt) CREF(node_1422))->false), var_20);
			       {	/* Inline/recursion.scm 278 */
				  obj_t list1776_1428;
				  {	/* Inline/recursion.scm 278 */
				     obj_t arg1777_1429;
				     {	/* Inline/recursion.scm 278 */
					obj_t arg1778_1430;
					arg1778_1430 =
					   MAKE_PAIR(arg1775_1427, BNIL);
					arg1777_1429 =
					   MAKE_PAIR(arg1774_1426, arg1778_1430);
				     }
				     list1776_1428 =
					MAKE_PAIR(arg1773_1425, arg1777_1429);
				  }
				  return
				     append___r4_pairs_and_lists_6_3(list1776_1428);
			       }
			    }
			 }
			 break;
		      case ((long) 8):

			 {	/* Inline/recursion.scm 286 */
			    fail_bglt node_1434;
			    node_1434 =
			       (fail_bglt) (node_19);
			    {	/* Inline/recursion.scm 287 */
			       obj_t arg1782_1437;
			       obj_t arg1783_1438;
			       obj_t arg1784_1439;
			       arg1782_1437 =
				  find_recursive_calls_52_inline_recursion(
				  (((fail_bglt) CREF(node_1434))->proc), var_20);
			       arg1783_1438 =
				  find_recursive_calls_52_inline_recursion(
				  (((fail_bglt) CREF(node_1434))->msg), var_20);
			       arg1784_1439 =
				  find_recursive_calls_52_inline_recursion(
				  (((fail_bglt) CREF(node_1434))->obj), var_20);
			       {	/* Inline/recursion.scm 287 */
				  obj_t list1785_1440;
				  {	/* Inline/recursion.scm 287 */
				     obj_t arg1786_1441;
				     {	/* Inline/recursion.scm 287 */
					obj_t arg1787_1442;
					arg1787_1442 =
					   MAKE_PAIR(arg1784_1439, BNIL);
					arg1786_1441 =
					   MAKE_PAIR(arg1783_1438, arg1787_1442);
				     }
				     list1785_1440 =
					MAKE_PAIR(arg1782_1437, arg1786_1441);
				  }
				  return
				     append___r4_pairs_and_lists_6_3(list1785_1440);
			       }
			    }
			 }
			 break;
		      case ((long) 9):

			 {	/* Inline/recursion.scm 295 */
			    select_bglt node_1446;
			    node_1446 =
			       (select_bglt) (node_19);
			    {
			       obj_t clauses_1448;
			       obj_t calls_1449;
			       {	/* Inline/recursion.scm 295 */
				  obj_t arg1791_1451;
				  obj_t arg1792_1452;
				  arg1791_1451 =
				     (((select_bglt) CREF(node_1446))->clauses);
				  arg1792_1452 =
				     find_recursive_calls_52_inline_recursion(
				     (((select_bglt) CREF(node_1446))->test), var_20);
				  clauses_1448 = arg1791_1451;
				  calls_1449 = arg1792_1452;
				loop_1450:
				  if (
				     NULLP(clauses_1448))
				    {	/* Inline/recursion.scm 297 */
				       return calls_1449;
				    }
				  else
				    {	/* Inline/recursion.scm 299 */
				       obj_t arg1795_1455;
				       obj_t arg1796_1456;
				       arg1795_1455 =
					  CDR(clauses_1448);
				       {	/* Inline/recursion.scm 300 */
					  obj_t arg1797_1457;
					  {	/* Inline/recursion.scm 300 */
					     node_bglt aux_2390;
					     {	/* Inline/recursion.scm 300 */
						obj_t aux_2391;
						{	/* ./Ieee/pair-list.scm 5707 */
						   obj_t aux_2392;
						   aux_2392 =
						      CAR(clauses_1448);
						   aux_2391 =
						      CDR(aux_2392);
						}
						aux_2390 =
						   (node_bglt) (aux_2391);
					     }
					     arg1797_1457 =
						find_recursive_calls_52_inline_recursion(aux_2390, var_20);
					  }
					  arg1796_1456 =
					     append_2_18___r4_pairs_and_lists_6_3(arg1797_1457, calls_1449);
				       }
				       {
					  obj_t calls_2399;
					  obj_t clauses_2398;
					  clauses_2398 = arg1795_1455;
					  calls_2399 = arg1796_1456;
					  calls_1449 = calls_2399;
					  clauses_1448 = clauses_2398;
					  goto loop_1450;
				       }
				    }
			       }
			    }
			 }
			 break;
		      case ((long) 10):

			 {	/* Inline/recursion.scm 307 */
			    let_fun_218_bglt node_1460;
			    node_1460 =
			       (let_fun_218_bglt) (node_19);
			    {
			       obj_t locals_1462;
			       obj_t calls_1463;
			       {	/* Inline/recursion.scm 307 */
				  obj_t arg1801_1465;
				  obj_t arg1802_1466;
				  arg1801_1465 =
				     (((let_fun_218_bglt) CREF(node_1460))->locals);
				  arg1802_1466 =
				     find_recursive_calls_52_inline_recursion(
				     (((let_fun_218_bglt) CREF(node_1460))->body), var_20);
				  locals_1462 = arg1801_1465;
				  calls_1463 = arg1802_1466;
				loop_1464:
				  if (
				     NULLP(locals_1462))
				    {	/* Inline/recursion.scm 309 */
				       return calls_1463;
				    }
				  else
				    {	/* Inline/recursion.scm 311 */
				       obj_t arg1805_1469;
				       obj_t arg1806_1470;
				       arg1805_1469 =
					  CDR(locals_1462);
				       {	/* Inline/recursion.scm 314 */
					  obj_t arg1807_1471;
					  {	/* Inline/recursion.scm 313 */
					     node_bglt aux_2407;
					     {	/* Inline/recursion.scm 313 */
						obj_t aux_2408;
						{	/* Inline/recursion.scm 314 */
						   sfun_bglt obj_1824;
						   {	/* Inline/recursion.scm 314 */
						      value_bglt aux_2409;
						      {		/* Inline/recursion.scm 314 */
							 local_bglt obj_1823;
							 {	/* Inline/recursion.scm 314 */
							    obj_t aux_2410;
							    aux_2410 =
							       CAR(locals_1462);
							    obj_1823 =
							       (local_bglt) (aux_2410);
							 }
							 aux_2409 =
							    (((local_bglt) CREF(obj_1823))->value);
						      }
						      obj_1824 =
							 (sfun_bglt) (aux_2409);
						   }
						   aux_2408 =
						      (((sfun_bglt) CREF(obj_1824))->body);
						}
						aux_2407 =
						   (node_bglt) (aux_2408);
					     }
					     arg1807_1471 =
						find_recursive_calls_52_inline_recursion(aux_2407, var_20);
					  }
					  arg1806_1470 =
					     append_2_18___r4_pairs_and_lists_6_3(calls_1463, arg1807_1471);
				       }
				       {
					  obj_t calls_2420;
					  obj_t locals_2419;
					  locals_2419 = arg1805_1469;
					  calls_2420 = arg1806_1470;
					  calls_1463 = calls_2420;
					  locals_1462 = locals_2419;
					  goto loop_1464;
				       }
				    }
			       }
			    }
			 }
			 break;
		      case ((long) 11):

			 {	/* Inline/recursion.scm 321 */
			    let_var_6_bglt node_1475;
			    node_1475 =
			       (let_var_6_bglt) (node_19);
			    {
			       obj_t bindings_1477;
			       obj_t calls_1478;
			       {	/* Inline/recursion.scm 321 */
				  obj_t arg1812_1480;
				  obj_t arg1813_1481;
				  arg1812_1480 =
				     (((let_var_6_bglt) CREF(node_1475))->bindings);
				  arg1813_1481 =
				     find_recursive_calls_52_inline_recursion(
				     (((let_var_6_bglt) CREF(node_1475))->body), var_20);
				  bindings_1477 = arg1812_1480;
				  calls_1478 = arg1813_1481;
				loop_1479:
				  if (
				     NULLP(bindings_1477))
				    {	/* Inline/recursion.scm 323 */
				       return calls_1478;
				    }
				  else
				    {	/* Inline/recursion.scm 325 */
				       obj_t arg1816_1484;
				       obj_t arg1817_1485;
				       arg1816_1484 =
					  CDR(bindings_1477);
				       {	/* Inline/recursion.scm 327 */
					  obj_t arg1818_1486;
					  {	/* Inline/recursion.scm 327 */
					     node_bglt aux_2428;
					     {	/* Inline/recursion.scm 327 */
						obj_t aux_2429;
						{	/* ./Ieee/pair-list.scm 5707 */
						   obj_t aux_2430;
						   aux_2430 =
						      CAR(bindings_1477);
						   aux_2429 =
						      CDR(aux_2430);
						}
						aux_2428 =
						   (node_bglt) (aux_2429);
					     }
					     arg1818_1486 =
						find_recursive_calls_52_inline_recursion(aux_2428, var_20);
					  }
					  arg1817_1485 =
					     append_2_18___r4_pairs_and_lists_6_3(calls_1478, arg1818_1486);
				       }
				       {
					  obj_t calls_2437;
					  obj_t bindings_2436;
					  bindings_2436 = arg1816_1484;
					  calls_2437 = arg1817_1485;
					  calls_1478 = calls_2437;
					  bindings_1477 = bindings_2436;
					  goto loop_1479;
				       }
				    }
			       }
			    }
			 }
			 break;
		      case ((long) 12):

			 {	/* Inline/recursion.scm 333 */
			    set_ex_it_116_bglt node_1489;
			    node_1489 =
			       (set_ex_it_116_bglt) (node_19);
			    {
			       node_bglt node_2439;
			       node_2439 =
				  (((set_ex_it_116_bglt) CREF(node_1489))->body);
			       node_19 = node_2439;
			       goto find_recursive_calls_52_inline_recursion;
			    }
			 }
			 break;
		      case ((long) 13):

			 {	/* Inline/recursion.scm 339 */
			    jump_ex_it_184_bglt node_1492;
			    node_1492 =
			       (jump_ex_it_184_bglt) (node_19);
			    {	/* Inline/recursion.scm 340 */
			       obj_t arg1823_1495;
			       obj_t arg1824_1496;
			       arg1823_1495 =
				  find_recursive_calls_52_inline_recursion(
				  (((jump_ex_it_184_bglt) CREF(node_1492))->exit), var_20);
			       arg1824_1496 =
				  find_recursive_calls_52_inline_recursion(
				  (((jump_ex_it_184_bglt) CREF(node_1492))->value), var_20);
			       return
				  append_2_18___r4_pairs_and_lists_6_3(arg1823_1495, arg1824_1496);
			    }
			 }
			 break;
		      case ((long) 14):

			 {	/* Inline/recursion.scm 346 */
			    make_box_202_bglt node_1499;
			    node_1499 =
			       (make_box_202_bglt) (node_19);
			    {
			       node_bglt node_2448;
			       node_2448 =
				  (((make_box_202_bglt) CREF(node_1499))->value);
			       node_19 = node_2448;
			       goto find_recursive_calls_52_inline_recursion;
			    }
			 }
			 break;
		      case ((long) 15):

			 {	/* Inline/recursion.scm 352 */
			    box_ref_242_bglt node_1502;
			    node_1502 =
			       (box_ref_242_bglt) (node_19);
			    {
			       node_bglt node_2451;
			       {	/* Inline/recursion.scm 352 */
				  var_bglt aux_2452;
				  aux_2452 =
				     (((box_ref_242_bglt) CREF(node_1502))->var);
				  node_2451 =
				     (node_bglt) (aux_2452);
			       }
			       node_19 = node_2451;
			       goto find_recursive_calls_52_inline_recursion;
			    }
			 }
			 break;
		      case ((long) 16):

			 {	/* Inline/recursion.scm 358 */
			    box_set__221_bglt node_1505;
			    node_1505 =
			       (box_set__221_bglt) (node_19);
			    {	/* Inline/recursion.scm 359 */
			       obj_t arg1830_1508;
			       obj_t arg1831_1509;
			       {	/* Inline/recursion.scm 359 */
				  node_bglt aux_2456;
				  {	/* Inline/recursion.scm 359 */
				     var_bglt aux_2457;
				     aux_2457 =
					(((box_set__221_bglt) CREF(node_1505))->var);
				     aux_2456 =
					(node_bglt) (aux_2457);
				  }
				  arg1830_1508 =
				     find_recursive_calls_52_inline_recursion(aux_2456, var_20);
			       }
			       arg1831_1509 =
				  find_recursive_calls_52_inline_recursion(
				  (((box_set__221_bglt) CREF(node_1505))->value), var_20);
			       return
				  append_2_18___r4_pairs_and_lists_6_3(arg1830_1508, arg1831_1509);
			    }
			 }
			 break;
		      default:
		       case_else1748_1383:
			 if (
			    PROCEDUREP(method1742_1379))
			   {	/* Inline/recursion.scm 218 */
			      return
				 PROCEDURE_ENTRY(method1742_1379) (method1742_1379,
				 (obj_t) (node_19),
				 (obj_t) (var_20), BEOA);
			   }
			 else
			   {	/* Inline/recursion.scm 218 */
			      obj_t fun1741_1375;
			      fun1741_1375 =
				 PROCEDURE_REF(find_recursive_calls_env_59_inline_recursion, ((long) 0));
			      return
				 PROCEDURE_ENTRY(fun1741_1375) (fun1741_1375,
				 (obj_t) (node_19),
				 (obj_t) (var_20), BEOA);
			   }
		      }
		 }
	       else
		 {	/* Inline/recursion.scm 218 */
		    goto case_else1748_1383;
		 }
	    }
	 }
      }
   }
}



/* _find-recursive-calls1848 */
obj_t 
_find_recursive_calls1848_248_inline_recursion(obj_t env_1851, obj_t node_1852, obj_t var_1853)
{
   AN_OBJECT;
   {	/* Inline/recursion.scm 218 */
      return
	 find_recursive_calls_52_inline_recursion(
	 (node_bglt) (node_1852),
	 (variable_bglt) (var_1853));
   }
}



/* find-recursive-calls-default1506 */
obj_t 
find_recursive_calls_default1506_129_inline_recursion(node_bglt node_21, variable_bglt var_22)
{
   AN_OBJECT;
   {	/* Inline/recursion.scm 14 */
      return BNIL;
   }
}



/* _find-recursive-calls-default1506 */
obj_t 
_find_recursive_calls_default1506_144_inline_recursion(obj_t env_1854, obj_t node_1855, obj_t var_1856)
{
   AN_OBJECT;
   {	/* Inline/recursion.scm 14 */
      return
	 find_recursive_calls_default1506_129_inline_recursion(
	 (node_bglt) (node_1855),
	 (variable_bglt) (var_1856));
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_inline_recursion()
{
   AN_OBJECT;
   {	/* Inline/recursion.scm 14 */
      module_initialization_70_tools_trace(((long) 0), "INLINE_RECURSION");
      module_initialization_70_engine_param(((long) 0), "INLINE_RECURSION");
      module_initialization_70_type_type(((long) 0), "INLINE_RECURSION");
      module_initialization_70_ast_var(((long) 0), "INLINE_RECURSION");
      module_initialization_70_ast_node(((long) 0), "INLINE_RECURSION");
      module_initialization_70_ast_local(((long) 0), "INLINE_RECURSION");
      module_initialization_70_ast_alphatize(((long) 0), "INLINE_RECURSION");
      module_initialization_70_ast_sexp(((long) 0), "INLINE_RECURSION");
      module_initialization_70_tools_speek(((long) 0), "INLINE_RECURSION");
      module_initialization_70_tools_shape(((long) 0), "INLINE_RECURSION");
      module_initialization_70_tools_error(((long) 0), "INLINE_RECURSION");
      module_initialization_70_inline_inline(((long) 0), "INLINE_RECURSION");
      module_initialization_70_inline_simple(((long) 0), "INLINE_RECURSION");
      module_initialization_70_inline_variant(((long) 0), "INLINE_RECURSION");
      module_initialization_70_inline_loop(((long) 0), "INLINE_RECURSION");
      module_initialization_70_inline_app(((long) 0), "INLINE_RECURSION");
      return
	 module_initialization_70_reduce_cse(((long) 0), "INLINE_RECURSION");
   }
}
