/*===========================================================================*/
/*   (Inline/simple.scm)                                                     */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;

typedef struct isfun
  {
     struct node *original_body_40;
     obj_t recursive_calls_44;
  }
     *isfun_bglt;


extern obj_t _inlining_reduce_kfactor__26_engine_param;
static obj_t method_init_76_inline_simple();
extern obj_t _verbose__1_engine_param;
extern obj_t let_var_6_ast_node;
extern obj_t var_ast_node;
extern obj_t closure_ast_node;
extern obj_t gensym___r4_symbols_6_4;
extern obj_t _obj__252_type_cache;
extern local_bglt clone_local_230_ast_local(local_bglt, value_bglt);
extern obj_t verbose_tools_speek(obj_t, obj_t);
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t current_function_76_tools_error();
extern obj_t module_initialization_70_inline_simple(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_ast_local(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_speek(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_inline_inline(long, char *);
extern obj_t module_initialization_70_inline_size(long, char *);
extern obj_t module_initialization_70_ast_alphatize(long, char *);
extern obj_t module_initialization_70_ast_sexp(long, char *);
extern obj_t module_initialization_70_effect_effect(long, char *);
extern obj_t module_initialization_70_effect_spread(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_symbols_6_4(long, char *);
extern obj_t module_initialization_70___r4_numbers_6_5(long, char *);
extern local_bglt make_local_svar_140_ast_local(obj_t, type_bglt);
extern bool_t spread_side_effect__136_effect_spread(node_bglt);
extern long class_num_218___object(obj_t);
extern obj_t svar_ast_var;
static obj_t _inline_app_simple_231_inline_simple(obj_t, obj_t, obj_t, obj_t, obj_t);
extern node_bglt inline_app_simple_198_inline_simple(node_bglt, long, obj_t, obj_t);
static obj_t imported_modules_init_94_inline_simple();
static obj_t library_modules_init_112_inline_simple();
extern node_bglt inline_node_218_inline_inline(node_bglt, long, obj_t);
extern obj_t open_input_string(obj_t);
extern node_bglt alphatize_ast_alphatize(obj_t, obj_t, obj_t, node_bglt);
extern bool_t side_effect__165_effect_effect(node_bglt);
extern obj_t isfun_inline_inline;
extern obj_t memq___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern obj_t shape_tools_shape(obj_t);
extern bool_t ___161___r4_numbers_6_5(obj_t, obj_t, obj_t);
extern obj_t read___reader(obj_t);
extern obj_t ____74_type_cache;
static obj_t require_initialization_114_inline_simple = BUNSPEC;
static obj_t cnst_init_137_inline_simple();
extern obj_t reverse__39___r4_pairs_and_lists_6_3(obj_t);
static obj_t __cnst[3];

DEFINE_EXPORT_PROCEDURE(inline_app_simple_env_207_inline_simple, _inline_app_simple_231_inline_simple1644, _inline_app_simple_231_inline_simple, 0L, 4);
DEFINE_STRING(string1639_inline_simple, string1639_inline_simple1645, "RES (SIFUN SGFUN) READ ", 23);
DEFINE_STRING(string1638_inline_simple, string1638_inline_simple1646, "         ", 9);
DEFINE_STRING(string1637_inline_simple, string1637_inline_simple1647, " --> ", 5);
DEFINE_STRING(string1636_inline_simple, string1636_inline_simple1648, " (", 2);



/* module-initialization */
obj_t 
module_initialization_70_inline_simple(long checksum_1382, char *from_1383)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_inline_simple))
	{
	   require_initialization_114_inline_simple =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_inline_simple();
	   cnst_init_137_inline_simple();
	   imported_modules_init_94_inline_simple();
	   method_init_76_inline_simple();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_inline_simple()
{
   AN_OBJECT;
   {	/* Inline/simple.scm 14 */
      module_initialization_70___r4_symbols_6_4(((long) 0), "INLINE_SIMPLE");
      module_initialization_70___object(((long) 0), "INLINE_SIMPLE");
      module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "INLINE_SIMPLE");
      module_initialization_70___r4_numbers_6_5(((long) 0), "INLINE_SIMPLE");
      module_initialization_70___reader(((long) 0), "INLINE_SIMPLE");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_inline_simple()
{
   AN_OBJECT;
   {	/* Inline/simple.scm 14 */
      {		/* Inline/simple.scm 14 */
	 obj_t cnst_port_138_1375;
	 cnst_port_138_1375 =
	    open_input_string(string1639_inline_simple);
	 {
	    long i_1376;
	    i_1376 = ((long) 2);
	  loop_1377:
	    {	/* Inline/simple.scm 14 */
	       bool_t test1640_1378;
	       test1640_1378 =
		  (i_1376 == ((long) -1));
	       if (test1640_1378)
		 {	/* Inline/simple.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Inline/simple.scm 14 */
		    {	/* Inline/simple.scm 14 */
		       obj_t arg1641_1379;
		       {	/* Inline/simple.scm 14 */
			  obj_t list1642_1380;
			  list1642_1380 =
			     MAKE_PAIR(cnst_port_138_1375, BNIL);
			  arg1641_1379 =
			     read___reader(list1642_1380);
		       }
		       CNST_TABLE_SET(i_1376, arg1641_1379);
		    }
		    {	/* Inline/simple.scm 14 */
		       int aux_1381;
		       {	/* Inline/simple.scm 14 */
			  long aux_1402;
			  aux_1402 =
			     (i_1376 - ((long) 1));
			  aux_1381 =
			     (int) (aux_1402);
		       }
		       {
			  long i_1405;
			  i_1405 =
			     (long) (aux_1381);
			  i_1376 = i_1405;
			  goto loop_1377;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* inline-app-simple */
node_bglt 
inline_app_simple_198_inline_simple(node_bglt node_1, long kfactor_2, obj_t stack_3, obj_t msg_4)
{
   AN_OBJECT;
   {	/* Inline/simple.scm 41 */
      {		/* Inline/simple.scm 43 */
	 variable_bglt callee_755;
	 {	/* Inline/simple.scm 43 */
	    var_bglt arg1555_865;
	    {	/* Inline/simple.scm 43 */
	       app_bglt obj_1201;
	       obj_1201 =
		  (app_bglt) (node_1);
	       arg1555_865 =
		  (((app_bglt) CREF(obj_1201))->fun);
	    }
	    callee_755 =
	       (((var_bglt) CREF(arg1555_865))->variable);
	 }
	 {	/* Inline/simple.scm 43 */
	    value_bglt sfun_756;
	    sfun_756 =
	       (((variable_bglt) CREF(callee_755))->value);
	    {	/* Inline/simple.scm 44 */
	       obj_t formals_757;
	       {	/* Inline/simple.scm 45 */
		  sfun_bglt obj_1204;
		  obj_1204 =
		     (sfun_bglt) (sfun_756);
		  formals_757 =
		     (((sfun_bglt) CREF(obj_1204))->args);
	       }
	       {	/* Inline/simple.scm 45 */
		  obj_t actuals_758;
		  {	/* Inline/simple.scm 46 */
		     app_bglt obj_1205;
		     obj_1205 =
			(app_bglt) (node_1);
		     actuals_758 =
			(((app_bglt) CREF(obj_1205))->args);
		  }
		  {	/* Inline/simple.scm 46 */
		     obj_t reductors_759;
		     if (
			NULLP(formals_757))
		       {	/* Inline/simple.scm 47 */
			  reductors_759 = BNIL;
		       }
		     else
		       {	/* Inline/simple.scm 47 */
			  obj_t head1458_844;
			  head1458_844 =
			     MAKE_PAIR(BNIL, BNIL);
			  {
			     obj_t ll1456_845;
			     obj_t ll1457_846;
			     obj_t tail1459_847;
			     ll1456_845 = formals_757;
			     ll1457_846 = actuals_758;
			     tail1459_847 = head1458_844;
			   lname1461_848:
			     if (
				NULLP(ll1456_845))
			       {	/* Inline/simple.scm 47 */
				  reductors_759 =
				     CDR(head1458_844);
			       }
			     else
			       {	/* Inline/simple.scm 48 */
				  obj_t newtail1460_850;
				  {	/* Inline/simple.scm 48 */
				     obj_t arg1545_853;
				     {	/* Inline/simple.scm 48 */
					obj_t f_855;
					obj_t a_856;
					f_855 =
					   CAR(ll1456_845);
					a_856 =
					   CAR(ll1457_846);
					{	/* Inline/simple.scm 48 */
					   bool_t test1548_857;
					   {	/* Inline/simple.scm 48 */
					      bool_t test1551_862;
					      test1551_862 =
						 is_a__118___object(a_856, closure_ast_node);
					      if (test1551_862)
						{	/* ./Ieee/equiv.scm 5508 */
						   obj_t aux_1428;
						   obj_t aux_1425;
						   aux_1428 =
						      CNST_TABLE_REF(((long) 0));
						   {	/* Inline/simple.scm 49 */
						      local_bglt obj_1214;
						      obj_1214 =
							 (local_bglt) (f_855);
						      aux_1425 =
							 (((local_bglt) CREF(obj_1214))->access);
						   }
						   test1548_857 =
						      (aux_1425 == aux_1428);
						}
					      else
						{	/* Inline/simple.scm 48 */
						   test1548_857 = ((bool_t) 0);
						}
					   }
					   if (test1548_857)
					     {	/* Inline/simple.scm 54 */
						closure_bglt obj_1217;
						obj_1217 =
						   (closure_bglt) (a_856);
						{	/* ./Ast/node.scm 923 */
						   variable_bglt aux_1433;
						   aux_1433 =
						      (((closure_bglt) CREF(obj_1217))->variable);
						   arg1545_853 =
						      (obj_t) (aux_1433);
						}
					     }
					   else
					     {	/* Inline/simple.scm 57 */
						svar_bglt arg1549_858;
						{	/* Inline/simple.scm 57 */
						   svar_bglt duplicated1462_859;
						   {	/* Inline/simple.scm 57 */
						      local_bglt obj_1218;
						      obj_1218 =
							 (local_bglt) (f_855);
						      {		/* ./Ast/var.scm 804 */
							 value_bglt aux_1437;
							 aux_1437 =
							    (((local_bglt) CREF(obj_1218))->value);
							 duplicated1462_859 =
							    (svar_bglt) (aux_1437);
						      }
						   }
						   {	/* Inline/simple.scm 57 */
						      svar_bglt new1463_860;
						      {		/* Inline/simple.scm 57 */
							 obj_t arg1550_861;
							 arg1550_861 =
							    (((svar_bglt) CREF(duplicated1462_859))->loc);
							 {	/* Inline/simple.scm 57 */
							    svar_bglt res1632_1226;
							    {	/* ./Ast/var.scm 853 */
							       svar_bglt new1161_1221;
							       new1161_1221 =
								  ((svar_bglt) BREF(GC_MALLOC(sizeof(struct svar))));
							       {	/* ./Ast/var.scm 853 */
								  long arg1615_1222;
								  arg1615_1222 =
								     class_num_218___object(svar_ast_var);
								  {	/* ./Ast/var.scm 853 */
								     obj_t obj_1224;
								     obj_1224 =
									(obj_t) (new1161_1221);
								     (((obj_t) CREF(obj_1224))->header = MAKE_HEADER(arg1615_1222, 0), BUNSPEC);
								  }
							       }
							       {	/* ./Ast/var.scm 853 */
								  object_bglt aux_1445;
								  aux_1445 =
								     (object_bglt) (new1161_1221);
								  OBJECT_WIDENING_SET(aux_1445, BFALSE);
							       }
							       ((((svar_bglt) CREF(new1161_1221))->loc) = ((obj_t) arg1550_861), BUNSPEC);
							       res1632_1226 = new1161_1221;
							    }
							    new1463_860 = res1632_1226;
							 }
						      }
						      {		/* Inline/simple.scm 57 */

							 arg1549_858 = new1463_860;
						      }
						   }
						}
						{	/* Inline/simple.scm 55 */
						   local_bglt aux_1449;
						   aux_1449 =
						      clone_local_230_ast_local(
						      (local_bglt) (f_855),
						      (value_bglt) (arg1549_858));
						   arg1545_853 =
						      (obj_t) (aux_1449);
						}
					     }
					}
				     }
				     newtail1460_850 =
					MAKE_PAIR(arg1545_853, BNIL);
				  }
				  SET_CDR(tail1459_847, newtail1460_850);
				  {
				     obj_t tail1459_1460;
				     obj_t ll1457_1458;
				     obj_t ll1456_1456;
				     ll1456_1456 =
					CDR(ll1456_845);
				     ll1457_1458 =
					CDR(ll1457_846);
				     tail1459_1460 = newtail1460_850;
				     tail1459_847 = tail1459_1460;
				     ll1457_846 = ll1457_1458;
				     ll1456_845 = ll1456_1456;
				     goto lname1461_848;
				  }
			       }
			  }
		       }
		     {	/* Inline/simple.scm 47 */
			obj_t bindings_760;
			{
			   obj_t reductors_822;
			   obj_t actuals_823;
			   obj_t res_824;
			   reductors_822 = reductors_759;
			   actuals_823 = actuals_758;
			   res_824 = BNIL;
			 loop_825:
			   if (
			      NULLP(actuals_823))
			     {	/* Inline/simple.scm 64 */
				bindings_760 =
				   reverse__39___r4_pairs_and_lists_6_3(res_824);
			     }
			   else
			     {	/* Inline/simple.scm 66 */
				bool_t test1523_827;
				{	/* Inline/simple.scm 66 */
				   bool_t test1534_836;
				   test1534_836 =
				      is_a__118___object(
				      CAR(actuals_823), closure_ast_node);
				   if (test1534_836)
				     {	/* ./Ieee/equiv.scm 5508 */
					obj_t aux_1469;
					obj_t aux_1467;
					{	/* Inline/simple.scm 67 */
					   variable_bglt aux_1470;
					   {	/* Inline/simple.scm 68 */
					      closure_bglt obj_1238;
					      {		/* Inline/simple.scm 68 */
						 obj_t aux_1471;
						 aux_1471 =
						    CAR(actuals_823);
						 obj_1238 =
						    (closure_bglt) (aux_1471);
					      }
					      aux_1470 =
						 (((closure_bglt) CREF(obj_1238))->variable);
					   }
					   aux_1469 =
					      (obj_t) (aux_1470);
					}
					aux_1467 =
					   CAR(reductors_822);
					test1523_827 =
					   (aux_1467 == aux_1469);
				     }
				   else
				     {	/* Inline/simple.scm 66 */
					test1523_827 = ((bool_t) 0);
				     }
				}
				if (test1523_827)
				  {	/* Inline/simple.scm 66 */
				     {
					obj_t actuals_1480;
					obj_t reductors_1478;
					reductors_1478 =
					   CDR(reductors_822);
					actuals_1480 =
					   CDR(actuals_823);
					actuals_823 = actuals_1480;
					reductors_822 = reductors_1478;
					goto loop_825;
				     }
				  }
				else
				  {	/* Inline/simple.scm 66 */
				     {	/* Inline/simple.scm 73 */
					obj_t arg1527_830;
					obj_t arg1528_831;
					obj_t arg1529_832;
					arg1527_830 =
					   CDR(reductors_822);
					arg1528_831 =
					   CDR(actuals_823);
					{	/* Inline/simple.scm 75 */
					   obj_t arg1530_833;
					   {	/* ./Ieee/pair-list.scm 5689 */
					      obj_t aux_1486;
					      obj_t aux_1484;
					      aux_1486 =
						 CAR(actuals_823);
					      aux_1484 =
						 CAR(reductors_822);
					      arg1530_833 =
						 MAKE_PAIR(aux_1484, aux_1486);
					   }
					   arg1529_832 =
					      MAKE_PAIR(arg1530_833, res_824);
					}
					{
					   obj_t res_1492;
					   obj_t actuals_1491;
					   obj_t reductors_1490;
					   reductors_1490 = arg1527_830;
					   actuals_1491 = arg1528_831;
					   res_1492 = arg1529_832;
					   res_824 = res_1492;
					   actuals_823 = actuals_1491;
					   reductors_822 = reductors_1490;
					   goto loop_825;
					}
				     }
				  }
			     }
			}
			{	/* Inline/simple.scm 60 */
			   obj_t body_761;
			   {	/* Inline/simple.scm 78 */
			      bool_t test1521_821;
			      test1521_821 =
				 is_a__118___object(
				 (obj_t) (sfun_756), isfun_inline_inline);
			      if (test1521_821)
				{	/* Inline/simple.scm 79 */
				   isfun_bglt obj_1252;
				   obj_1252 =
				      (isfun_bglt) (sfun_756);
				   {	/* ./Inline/inline.scm 1216 */
				      node_bglt aux_1497;
				      {
					 obj_t aux_1498;
					 {	/* ./Inline/inline.scm 1216 */
					    object_bglt aux_1499;
					    aux_1499 =
					       (object_bglt) (obj_1252);
					    aux_1498 =
					       OBJECT_WIDENING(aux_1499);
					 }
					 aux_1497 =
					    (((isfun_bglt) CREF(aux_1498))->original_body_40);
				      }
				      body_761 =
					 (obj_t) (aux_1497);
				   }
				}
			      else
				{	/* Inline/simple.scm 80 */
				   sfun_bglt obj_1253;
				   obj_1253 =
				      (sfun_bglt) (sfun_756);
				   body_761 =
				      (((sfun_bglt) CREF(obj_1253))->body);
				}
			   }
			   {	/* Inline/simple.scm 81 */
			      obj_t new_kfactor_216_763;
			      new_kfactor_216_763 =
				 PROCEDURE_ENTRY(_inlining_reduce_kfactor__26_engine_param) (_inlining_reduce_kfactor__26_engine_param,
				 BINT(kfactor_2), BEOA);
			      {		/* Inline/simple.scm 82 */
				 obj_t loc_764;
				 loc_764 =
				    (((node_bglt) CREF(node_1))->loc);
				 {	/* Inline/simple.scm 83 */
				    type_bglt type_765;
				    type_765 =
				       (((node_bglt) CREF(node_1))->type);
				    {	/* Inline/simple.scm 84 */

				       {	/* Inline/simple.scm 86 */
					  bool_t test_1511;
					  {	/* Inline/simple.scm 86 */
					     obj_t aux_1512;
					     {	/* Inline/simple.scm 86 */
						obj_t aux_1513;
						{	/* Inline/simple.scm 86 */
						   sfun_bglt obj_1257;
						   obj_1257 =
						      (sfun_bglt) (sfun_756);
						   aux_1513 =
						      (((sfun_bglt) CREF(obj_1257))->class);
						}
						aux_1512 =
						   memq___r4_pairs_and_lists_6_3(aux_1513,
						   CNST_TABLE_REF(((long) 1)));
					     }
					     test_1511 =
						CBOOL(aux_1512);
					  }
					  if (test_1511)
					    {	/* Inline/simple.scm 86 */
					       BUNSPEC;
					    }
					  else
					    {	/* Inline/simple.scm 87 */
					       bool_t test1472_768;
					       test1472_768 =
						  ___161___r4_numbers_6_5(
						  BINT(((long) 3)), _verbose__1_engine_param, BNIL);
					       if (test1472_768)
						 {	/* Inline/simple.scm 87 */
						    obj_t arg1474_770;
						    obj_t arg1476_772;
						    arg1474_770 =
						       shape_tools_shape(
						       (obj_t) (callee_755));
						    arg1476_772 =
						       current_function_76_tools_error();
						    {	/* Inline/simple.scm 87 */
						       obj_t list1478_774;
						       {	/* Inline/simple.scm 87 */
							  obj_t arg1479_775;
							  {	/* Inline/simple.scm 87 */
							     obj_t arg1480_776;
							     {	/* Inline/simple.scm 87 */
								obj_t arg1481_777;
								{	/* Inline/simple.scm 87 */
								   obj_t arg1482_778;
								   {	/* Inline/simple.scm 87 */
								      obj_t arg1483_779;
								      {		/* Inline/simple.scm 87 */
									 obj_t arg1484_780;
									 {	/* Inline/simple.scm 87 */
									    obj_t arg1485_781;
									    {	/* Inline/simple.scm 87 */
									       obj_t aux_1525;
									       aux_1525 =
										  BCHAR(((unsigned char) '\n'));
									       arg1485_781 =
										  MAKE_PAIR(aux_1525, BNIL);
									    }
									    {	/* Inline/simple.scm 87 */
									       obj_t aux_1528;
									       aux_1528 =
										  BCHAR(((unsigned char) ')'));
									       arg1484_780 =
										  MAKE_PAIR(aux_1528, arg1485_781);
									    }
									 }
									 arg1483_779 =
									    MAKE_PAIR(msg_4, arg1484_780);
								      }
								      arg1482_778 =
									 MAKE_PAIR(string1636_inline_simple, arg1483_779);
								   }
								   arg1481_777 =
								      MAKE_PAIR(arg1476_772, arg1482_778);
								}
								arg1480_776 =
								   MAKE_PAIR(string1637_inline_simple, arg1481_777);
							     }
							     arg1479_775 =
								MAKE_PAIR(arg1474_770, arg1480_776);
							  }
							  list1478_774 =
							     MAKE_PAIR(string1638_inline_simple, arg1479_775);
						       }
						       verbose_tools_speek(
							  BINT(((long) 3)), list1478_774);
						    }
						 }
					       else
						 {	/* Inline/simple.scm 87 */
						    BUNSPEC;
						 }
					    }
				       }
				       {	/* Inline/simple.scm 95 */
					  node_bglt alpha_body_133_785;
					  alpha_body_133_785 =
					     alphatize_ast_alphatize(formals_757, reductors_759, loc_764,
					     (node_bglt) (body_761));
					  spread_side_effect__136_effect_spread(alpha_body_133_785);
					  {	/* Inline/simple.scm 99 */
					     let_var_6_bglt inline_body_50_786;
					     {	/* Inline/simple.scm 99 */
						bool_t arg1515_816;
						node_bglt arg1519_819;
						arg1515_816 =
						   side_effect__165_effect_effect(alpha_body_133_785);
						{	/* Inline/simple.scm 106 */
						   obj_t arg1520_820;
						   {	/* ./Ieee/pair-list.scm 5689 */
						      obj_t aux_1543;
						      aux_1543 =
							 (obj_t) (callee_755);
						      arg1520_820 =
							 MAKE_PAIR(aux_1543, stack_3);
						   }
						   arg1519_819 =
						      inline_node_218_inline_inline(alpha_body_133_785,
						      (long) CINT(new_kfactor_216_763), arg1520_820);
						}
						{	/* Inline/simple.scm 99 */
						   let_var_6_bglt res1633_1278;
						   {	/* Inline/simple.scm 99 */
						      obj_t side_effect__165_1262;
						      obj_t key_1263;
						      side_effect__165_1262 =
							 BBOOL(arg1515_816);
						      key_1263 =
							 BINT(((long) -1));
						      {		/* ./Ast/node.scm 1011 */
							 let_var_6_bglt new1373_1267;
							 new1373_1267 =
							    ((let_var_6_bglt) BREF(GC_MALLOC(sizeof(struct let_var_6))));
							 {	/* ./Ast/node.scm 1011 */
							    long arg1571_1268;
							    arg1571_1268 =
							       class_num_218___object(let_var_6_ast_node);
							    {	/* ./Ast/node.scm 1011 */
							       obj_t obj_1276;
							       obj_1276 =
								  (obj_t) (new1373_1267);
							       (((obj_t) CREF(obj_1276))->header = MAKE_HEADER(arg1571_1268, 0), BUNSPEC);
							    }
							 }
							 {	/* ./Ast/node.scm 1011 */
							    object_bglt aux_1554;
							    aux_1554 =
							       (object_bglt) (new1373_1267);
							    OBJECT_WIDENING_SET(aux_1554, BFALSE);
							 }
							 ((((let_var_6_bglt) CREF(new1373_1267))->loc) = ((obj_t) loc_764), BUNSPEC);
							 ((((let_var_6_bglt) CREF(new1373_1267))->type) = ((type_bglt) type_765), BUNSPEC);
							 ((((let_var_6_bglt) CREF(new1373_1267))->side_effect__165) = ((obj_t) side_effect__165_1262), BUNSPEC);
							 ((((let_var_6_bglt) CREF(new1373_1267))->key) = ((obj_t) key_1263), BUNSPEC);
							 ((((let_var_6_bglt) CREF(new1373_1267))->bindings) = ((obj_t) bindings_760), BUNSPEC);
							 ((((let_var_6_bglt) CREF(new1373_1267))->body) = ((node_bglt) arg1519_819), BUNSPEC);
							 ((((let_var_6_bglt) CREF(new1373_1267))->removable__42) = ((bool_t) ((bool_t) 1)), BUNSPEC);
							 res1633_1278 = new1373_1267;
						      }
						   }
						   inline_body_50_786 = res1633_1278;
						}
					     }
					     {
						obj_t ll1466_787;
						obj_t ll1467_788;
						ll1466_787 = bindings_760;
						ll1467_788 = formals_757;
					      lname1468_789:
						if (
						   NULLP(ll1466_787))
						  {	/* Inline/simple.scm 108 */
						     ((bool_t) 1);
						  }
						else
						  {	/* Inline/simple.scm 108 */
						     {	/* Inline/simple.scm 109 */
							bool_t arg1493_794;
							{	/* Inline/simple.scm 109 */
							   local_bglt obj_1283;
							   {	/* Inline/simple.scm 109 */
							      obj_t aux_1566;
							      aux_1566 =
								 CAR(ll1467_788);
							      obj_1283 =
								 (local_bglt) (aux_1566);
							   }
							   arg1493_794 =
							      (((local_bglt) CREF(obj_1283))->user__32);
							}
							{	/* Inline/simple.scm 109 */
							   local_bglt obj_1284;
							   {	/* Inline/simple.scm 109 */
							      obj_t aux_1570;
							      {		/* ./Ieee/pair-list.scm 5701 */
								 obj_t aux_1571;
								 aux_1571 =
								    CAR(ll1466_787);
								 aux_1570 =
								    CAR(aux_1571);
							      }
							      obj_1284 =
								 (local_bglt) (aux_1570);
							   }
							   ((((local_bglt) CREF(obj_1284))->user__32) = ((bool_t) arg1493_794), BUNSPEC);
							}
						     }
						     {
							obj_t ll1467_1578;
							obj_t ll1466_1576;
							ll1466_1576 =
							   CDR(ll1466_787);
							ll1467_1578 =
							   CDR(ll1467_788);
							ll1467_788 = ll1467_1578;
							ll1466_787 = ll1466_1576;
							goto lname1468_789;
						     }
						  }
					     }
					     {	/* Inline/simple.scm 116 */
						bool_t test1496_797;
						{	/* Inline/simple.scm 116 */
						   bool_t test1510_811;
						   {	/* Inline/simple.scm 116 */
						      obj_t obj2_1289;
						      obj2_1289 = ____74_type_cache;
						      {		/* ./Ieee/equiv.scm 5508 */
							 obj_t aux_1580;
							 aux_1580 =
							    (obj_t) (type_765);
							 test1510_811 =
							    (aux_1580 == obj2_1289);
						      }
						   }
						   if (test1510_811)
						     {	/* Inline/simple.scm 116 */
							test1496_797 = ((bool_t) 1);
						     }
						   else
						     {	/* Inline/simple.scm 117 */
							bool_t test1511_812;
							{	/* Inline/simple.scm 117 */
							   obj_t obj2_1291;
							   obj2_1291 = _obj__252_type_cache;
							   {	/* ./Ieee/equiv.scm 5508 */
							      obj_t aux_1584;
							      aux_1584 =
								 (obj_t) (type_765);
							      test1511_812 =
								 (aux_1584 == obj2_1291);
							   }
							}
							if (test1511_812)
							  {	/* Inline/simple.scm 117 */
							     test1496_797 = ((bool_t) 1);
							  }
							else
							  {	/* ./Ieee/equiv.scm 5508 */
							     obj_t aux_1590;
							     obj_t aux_1588;
							     {	/* Inline/simple.scm 118 */
								type_bglt aux_1591;
								aux_1591 =
								   (((node_bglt) CREF(alpha_body_133_785))->type);
								aux_1590 =
								   (obj_t) (aux_1591);
							     }
							     aux_1588 =
								(obj_t) (type_765);
							     test1496_797 =
								(aux_1588 == aux_1590);
							  }
						     }
						}
						if (test1496_797)
						  {	/* Inline/simple.scm 116 */
						     return
							(node_bglt) (inline_body_50_786);
						  }
						else
						  {	/* Inline/simple.scm 120 */
						     local_bglt var_798;
						     {	/* Inline/simple.scm 120 */
							obj_t arg1509_810;
							arg1509_810 =
							   PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4,
							   CNST_TABLE_REF(((long) 2)), BEOA);
							var_798 =
							   make_local_svar_140_ast_local(arg1509_810, type_765);
						     }
						     {	/* Inline/simple.scm 121 */
							bool_t arg1499_801;
							obj_t arg1501_803;
							var_bglt arg1502_804;
							arg1499_801 =
							   side_effect__165_effect_effect(
							   (node_bglt) (inline_body_50_786));
							{	/* Inline/simple.scm 125 */
							   obj_t arg1503_805;
							   {	/* ./Ieee/pair-list.scm 5689 */
							      obj_t aux_1605;
							      obj_t aux_1603;
							      aux_1605 =
								 (obj_t) (inline_body_50_786);
							      aux_1603 =
								 (obj_t) (var_798);
							      arg1503_805 =
								 MAKE_PAIR(aux_1603, aux_1605);
							   }
							   {	/* Inline/simple.scm 125 */
							      obj_t list1504_806;
							      list1504_806 =
								 MAKE_PAIR(arg1503_805, BNIL);
							      arg1501_803 = list1504_806;
							   }
							}
							{	/* Inline/simple.scm 126 */
							   var_bglt res1634_1308;
							   {	/* Inline/simple.scm 126 */
							      variable_bglt variable_1300;
							      variable_1300 =
								 (variable_bglt) (var_798);
							      {		/* ./Ast/node.scm 918 */
								 var_bglt new1210_1301;
								 new1210_1301 =
								    ((var_bglt) BREF(GC_MALLOC(sizeof(struct var))));
								 {	/* ./Ast/node.scm 918 */
								    long arg1601_1302;
								    arg1601_1302 =
								       class_num_218___object(var_ast_node);
								    {	/* ./Ast/node.scm 918 */
								       obj_t obj_1306;
								       obj_1306 =
									  (obj_t) (new1210_1301);
								       (((obj_t) CREF(obj_1306))->header = MAKE_HEADER(arg1601_1302, 0), BUNSPEC);
								    }
								 }
								 {	/* ./Ast/node.scm 918 */
								    object_bglt aux_1614;
								    aux_1614 =
								       (object_bglt) (new1210_1301);
								    OBJECT_WIDENING_SET(aux_1614, BFALSE);
								 }
								 ((((var_bglt) CREF(new1210_1301))->loc) = ((obj_t) loc_764), BUNSPEC);
								 ((((var_bglt) CREF(new1210_1301))->type) = ((type_bglt) type_765), BUNSPEC);
								 ((((var_bglt) CREF(new1210_1301))->variable) = ((variable_bglt) variable_1300), BUNSPEC);
								 res1634_1308 = new1210_1301;
							      }
							   }
							   arg1502_804 = res1634_1308;
							}
							{	/* Inline/simple.scm 121 */
							   let_var_6_bglt res1635_1327;
							   {	/* Inline/simple.scm 121 */
							      obj_t side_effect__165_1311;
							      obj_t key_1312;
							      node_bglt body_1314;
							      side_effect__165_1311 =
								 BBOOL(arg1499_801);
							      key_1312 =
								 BINT(((long) -1));
							      body_1314 =
								 (node_bglt) (arg1502_804);
							      {		/* ./Ast/node.scm 1011 */
								 let_var_6_bglt new1373_1316;
								 new1373_1316 =
								    ((let_var_6_bglt) BREF(GC_MALLOC(sizeof(struct let_var_6))));
								 {	/* ./Ast/node.scm 1011 */
								    long arg1571_1317;
								    arg1571_1317 =
								       class_num_218___object(let_var_6_ast_node);
								    {	/* ./Ast/node.scm 1011 */
								       obj_t obj_1325;
								       obj_1325 =
									  (obj_t) (new1373_1316);
								       (((obj_t) CREF(obj_1325))->header = MAKE_HEADER(arg1571_1317, 0), BUNSPEC);
								    }
								 }
								 {	/* ./Ast/node.scm 1011 */
								    object_bglt aux_1627;
								    aux_1627 =
								       (object_bglt) (new1373_1316);
								    OBJECT_WIDENING_SET(aux_1627, BFALSE);
								 }
								 ((((let_var_6_bglt) CREF(new1373_1316))->loc) = ((obj_t) loc_764), BUNSPEC);
								 ((((let_var_6_bglt) CREF(new1373_1316))->type) = ((type_bglt) type_765), BUNSPEC);
								 ((((let_var_6_bglt) CREF(new1373_1316))->side_effect__165) = ((obj_t) side_effect__165_1311), BUNSPEC);
								 ((((let_var_6_bglt) CREF(new1373_1316))->key) = ((obj_t) key_1312), BUNSPEC);
								 ((((let_var_6_bglt) CREF(new1373_1316))->bindings) = ((obj_t) arg1501_803), BUNSPEC);
								 ((((let_var_6_bglt) CREF(new1373_1316))->body) = ((node_bglt) body_1314), BUNSPEC);
								 ((((let_var_6_bglt) CREF(new1373_1316))->removable__42) = ((bool_t) ((bool_t) 1)), BUNSPEC);
								 res1635_1327 = new1373_1316;
							      }
							   }
							   return
							      (node_bglt) (res1635_1327);
							}
						     }
						  }
					     }
					  }
				       }
				    }
				 }
			      }
			   }
			}
		     }
		  }
	       }
	    }
	 }
      }
   }
}



/* _inline-app-simple */
obj_t 
_inline_app_simple_231_inline_simple(obj_t env_1370, obj_t node_1371, obj_t kfactor_1372, obj_t stack_1373, obj_t msg_1374)
{
   AN_OBJECT;
   {	/* Inline/simple.scm 41 */
      {		/* Inline/simple.scm 41 */
	 node_bglt aux_1638;
	 aux_1638 =
	    inline_app_simple_198_inline_simple(
	    (node_bglt) (node_1371),
	    (long) CINT(kfactor_1372), stack_1373, msg_1374);
	 return
	    (obj_t) (aux_1638);
      }
   }
}



/* method-init */
obj_t 
method_init_76_inline_simple()
{
   AN_OBJECT;
   {	/* Inline/simple.scm 14 */
      return BUNSPEC;
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_inline_simple()
{
   AN_OBJECT;
   {	/* Inline/simple.scm 14 */
      module_initialization_70_tools_trace(((long) 0), "INLINE_SIMPLE");
      module_initialization_70_engine_param(((long) 0), "INLINE_SIMPLE");
      module_initialization_70_type_type(((long) 0), "INLINE_SIMPLE");
      module_initialization_70_type_cache(((long) 0), "INLINE_SIMPLE");
      module_initialization_70_ast_var(((long) 0), "INLINE_SIMPLE");
      module_initialization_70_ast_node(((long) 0), "INLINE_SIMPLE");
      module_initialization_70_ast_local(((long) 0), "INLINE_SIMPLE");
      module_initialization_70_tools_shape(((long) 0), "INLINE_SIMPLE");
      module_initialization_70_tools_speek(((long) 0), "INLINE_SIMPLE");
      module_initialization_70_tools_error(((long) 0), "INLINE_SIMPLE");
      module_initialization_70_inline_inline(((long) 0), "INLINE_SIMPLE");
      module_initialization_70_inline_size(((long) 0), "INLINE_SIMPLE");
      module_initialization_70_ast_alphatize(((long) 0), "INLINE_SIMPLE");
      module_initialization_70_ast_sexp(((long) 0), "INLINE_SIMPLE");
      module_initialization_70_effect_effect(((long) 0), "INLINE_SIMPLE");
      return
	 module_initialization_70_effect_spread(((long) 0), "INLINE_SIMPLE");
   }
}
