/*===========================================================================*/
/*   (Inline/size.scm)                                                       */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;

typedef struct sized_sequence_48
  {
     long size;
  }
                 *sized_sequence_48_bglt;

typedef struct sized_app_52
  {
     long size;
  }
            *sized_app_52_bglt;

typedef struct sized_funcall_46
  {
     long size;
  }
                *sized_funcall_46_bglt;

typedef struct sized_pragma_213
  {
     long size;
  }
                *sized_pragma_213_bglt;

typedef struct sized_conditional_152
  {
     long size;
  }
                     *sized_conditional_152_bglt;

typedef struct sized_fail_63
  {
     long size;
  }
             *sized_fail_63_bglt;

typedef struct sized_select_166
  {
     long size;
  }
                *sized_select_166_bglt;

typedef struct sized_let_fun_188
  {
     long size;
  }
                 *sized_let_fun_188_bglt;

typedef struct sized_let_var_54
  {
     long size;
  }
                *sized_let_var_54_bglt;


extern long node_size_119_inline_size(node_bglt);
static obj_t _allocate_sized_select_175_inline_size(obj_t);
static obj_t method_init_76_inline_size();
extern obj_t make_box_202_ast_node;
extern obj_t funcall_ast_node;
static obj_t _allocate_sized_sequence_167_inline_size(obj_t);
extern long add_inlined_method__244___object(obj_t, obj_t, long);
static long node_size_default1608_243_inline_size(node_bglt);
extern obj_t fail_ast_node;
extern obj_t box_ref_242_ast_node;
extern obj_t sequence_ast_node;
extern obj_t let_var_6_ast_node;
extern obj_t var_ast_node;
static obj_t struct_object__object_sized_conditional1687_142_inline_size(obj_t, obj_t, obj_t);
static obj_t object__struct_sized_fail1681_120_inline_size(obj_t, obj_t);
extern object_bglt struct_object__object_93___object(object_bglt, obj_t);
extern obj_t add_method__1___object(obj_t, obj_t, obj_t);
extern obj_t pragma_ast_node;
static obj_t object__struct_sized_select1677_109_inline_size(obj_t, obj_t);
extern obj_t set_ex_it_116_ast_node;
extern obj_t find_super_class_method_167___object(object_bglt, obj_t, obj_t);
static obj_t object__struct_sized_pragma1689_26_inline_size(obj_t, obj_t);
static let_fun_218_bglt allocate_sized_let_fun_17_inline_size();
static conditional_bglt allocate_sized_conditional_44_inline_size();
static obj_t sized_select_166_inline_size = BUNSPEC;
static obj_t struct_object__object_sized_select1679_20_inline_size(obj_t, obj_t, obj_t);
static obj_t struct_object__object_sized_pragma1691_206_inline_size(obj_t, obj_t, obj_t);
static obj_t object__struct_sized_let_var1668_248_inline_size(obj_t, obj_t);
extern obj_t module_initialization_70_inline_size(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
static obj_t object__struct_sized_let_fun1672_231_inline_size(obj_t, obj_t);
static obj_t sized_funcall_46_inline_size = BUNSPEC;
static obj_t _allocate_sized_pragma_184_inline_size(obj_t);
static obj_t sized_conditional_152_inline_size = BUNSPEC;
extern long list_length(obj_t);
extern long class_num_218___object(obj_t);
static obj_t _allocate_sized_funcall_28_inline_size(obj_t);
static obj_t _node_size_132_inline_size(obj_t, obj_t);
static app_bglt allocate_sized_app_161_inline_size();
static select_bglt allocate_sized_select_168_inline_size();
extern obj_t let_fun_218_ast_node;
static obj_t sized_let_var_54_inline_size = BUNSPEC;
static obj_t imported_modules_init_94_inline_size();
static obj_t _allocate_sized_let_var_200_inline_size(obj_t);
extern obj_t app_ly_162_ast_node;
extern obj_t add_generic__110___object(obj_t, obj_t);
static obj_t struct_object__object_sized_sequence1703_135_inline_size(obj_t, obj_t, obj_t);
static obj_t struct_object__object_sized_funcall1695_115_inline_size(obj_t, obj_t, obj_t);
static sequence_bglt allocate_sized_sequence_56_inline_size();
extern obj_t app_ast_node;
static obj_t library_modules_init_112_inline_size();
static obj_t object__struct_sized_app1697_131_inline_size(obj_t, obj_t);
extern obj_t make_struct(obj_t, long, obj_t);
static obj_t sized_pragma_213_inline_size = BUNSPEC;
extern obj_t atom_ast_node;
extern obj_t cast_ast_node;
static obj_t toplevel_init_63_inline_size();
extern obj_t create_vector(long);
extern obj_t jump_ex_it_184_ast_node;
extern obj_t open_input_string(obj_t);
extern obj_t kwote_ast_node;
static obj_t _allocate_sized_fail_239_inline_size(obj_t);
static obj_t object__struct_sized_sequence1701_59_inline_size(obj_t, obj_t);
extern obj_t setq_ast_node;
extern obj_t box_set__221_ast_node;
static obj_t _node_size_default1608_24_inline_size(obj_t, obj_t);
static obj_t sized_let_fun_188_inline_size = BUNSPEC;
static obj_t sized_app_52_inline_size = BUNSPEC;
static pragma_bglt allocate_sized_pragma_254_inline_size();
static obj_t _allocate_sized_let_fun_213_inline_size(obj_t);
static obj_t struct_object__object_sized_app1699_186_inline_size(obj_t, obj_t, obj_t);
extern obj_t register_class__225___object(obj_t, obj_t, obj_t, long, obj_t, obj_t, obj_t);
static obj_t object__struct_sized_conditional1685_18_inline_size(obj_t, obj_t);
static obj_t sized_sequence_48_inline_size = BUNSPEC;
static obj_t object_init_111_inline_size();
static obj_t struct_object__object_sized_fail1683_173_inline_size(obj_t, obj_t, obj_t);
static obj_t struct_object__object_sized_let_var1670_137_inline_size(obj_t, obj_t, obj_t);
static obj_t struct_object__object_sized_let_fun1674_20_inline_size(obj_t, obj_t, obj_t);
static funcall_bglt allocate_sized_funcall_74_inline_size();
extern obj_t _classes__134___object;
extern obj_t select_ast_node;
extern obj_t read___reader(obj_t);
static fail_bglt allocate_sized_fail_135_inline_size();
static obj_t sized_fail_63_inline_size = BUNSPEC;
static obj_t _allocate_sized_app_5_inline_size(obj_t);
extern obj_t object__struct_50___object(object_bglt);
static obj_t require_initialization_114_inline_size = BUNSPEC;
static let_var_6_bglt allocate_sized_let_var_152_inline_size();
extern obj_t conditional_ast_node;
static obj_t _allocate_sized_conditional_74_inline_size(obj_t);
static obj_t object__struct_sized_funcall1693_245_inline_size(obj_t, obj_t);
static obj_t cnst_init_137_inline_size();
static obj_t __cnst[10];

DEFINE_EXPORT_GENERIC(node_size_env_51_inline_size, _node_size_132_inline_size2131, _node_size_132_inline_size, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2124_inline_size, struct_object__object_sized_sequence1703_135_inline_size2132, struct_object__object_sized_sequence1703_135_inline_size, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2123_inline_size, object__struct_sized_sequence1701_59_inline_size2133, object__struct_sized_sequence1701_59_inline_size, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2122_inline_size, struct_object__object_sized_app1699_186_inline_size2134, struct_object__object_sized_app1699_186_inline_size, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2121_inline_size, object__struct_sized_app1697_131_inline_size2135, object__struct_sized_app1697_131_inline_size, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2119_inline_size, object__struct_sized_funcall1693_245_inline_size2136, object__struct_sized_funcall1693_245_inline_size, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2120_inline_size, struct_object__object_sized_funcall1695_115_inline_size2137, struct_object__object_sized_funcall1695_115_inline_size, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2118_inline_size, struct_object__object_sized_pragma1691_206_inline_size2138, struct_object__object_sized_pragma1691_206_inline_size, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2117_inline_size, object__struct_sized_pragma1689_26_inline_size2139, object__struct_sized_pragma1689_26_inline_size, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2116_inline_size, struct_object__object_sized_conditional1687_142_inline_size2140, struct_object__object_sized_conditional1687_142_inline_size, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2115_inline_size, object__struct_sized_conditional1685_18_inline_size2141, object__struct_sized_conditional1685_18_inline_size, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2114_inline_size, struct_object__object_sized_fail1683_173_inline_size2142, struct_object__object_sized_fail1683_173_inline_size, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2113_inline_size, object__struct_sized_fail1681_120_inline_size2143, object__struct_sized_fail1681_120_inline_size, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2112_inline_size, struct_object__object_sized_select1679_20_inline_size2144, struct_object__object_sized_select1679_20_inline_size, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2111_inline_size, object__struct_sized_select1677_109_inline_size2145, object__struct_sized_select1677_109_inline_size, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2109_inline_size, object__struct_sized_let_fun1672_231_inline_size2146, object__struct_sized_let_fun1672_231_inline_size, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2110_inline_size, struct_object__object_sized_let_fun1674_20_inline_size2147, struct_object__object_sized_let_fun1674_20_inline_size, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2108_inline_size, struct_object__object_sized_let_var1670_137_inline_size2148, struct_object__object_sized_let_var1670_137_inline_size, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2107_inline_size, object__struct_sized_let_var1668_248_inline_size2149, object__struct_sized_let_var1668_248_inline_size, 0L, 1);
DEFINE_STATIC_PROCEDURE(allocate_sized_let_var_env_114_inline_size, _allocate_sized_let_var_200_inline_size2150, _allocate_sized_let_var_200_inline_size, 0L, 0);
DEFINE_STATIC_PROCEDURE(allocate_sized_app_env_53_inline_size, _allocate_sized_app_5_inline_size2151, _allocate_sized_app_5_inline_size, 0L, 0);
DEFINE_STATIC_PROCEDURE(allocate_sized_let_fun_env_195_inline_size, _allocate_sized_let_fun_213_inline_size2152, _allocate_sized_let_fun_213_inline_size, 0L, 0);
extern obj_t struct_object__object_env_209___object;
DEFINE_STATIC_PROCEDURE(allocate_sized_select_env_132_inline_size, _allocate_sized_select_175_inline_size2153, _allocate_sized_select_175_inline_size, 0L, 0);
DEFINE_STATIC_PROCEDURE(allocate_sized_pragma_env_85_inline_size, _allocate_sized_pragma_184_inline_size2154, _allocate_sized_pragma_184_inline_size, 0L, 0);
DEFINE_STATIC_PROCEDURE(allocate_sized_conditional_env_43_inline_size, _allocate_sized_conditional_74_inline_size2155, _allocate_sized_conditional_74_inline_size, 0L, 0);
DEFINE_STRING(string2126_inline_size, string2126_inline_size2156, "NODE-SIZE-DEFAULT1608 SIZED-LET-VAR SIZED-LET-FUN SIZED-SELECT SIZED-FAIL SIZED-CONDITIONAL SIZED-PRAGMA SIZED-FUNCALL SIZED-APP SIZED-SEQUENCE ", 144);
DEFINE_STRING(string2125_inline_size, string2125_inline_size2157, "No method for this object", 25);
DEFINE_STATIC_PROCEDURE(node_size_default1608_env_20_inline_size, _node_size_default1608_24_inline_size2158, _node_size_default1608_24_inline_size, 0L, 1);
DEFINE_STATIC_PROCEDURE(allocate_sized_sequence_env_88_inline_size, _allocate_sized_sequence_167_inline_size2159, _allocate_sized_sequence_167_inline_size, 0L, 0);
extern obj_t object__struct_env_210___object;
DEFINE_STATIC_PROCEDURE(allocate_sized_funcall_env_52_inline_size, _allocate_sized_funcall_28_inline_size2160, _allocate_sized_funcall_28_inline_size, 0L, 0);
DEFINE_STATIC_PROCEDURE(allocate_sized_fail_env_18_inline_size, _allocate_sized_fail_239_inline_size2161, _allocate_sized_fail_239_inline_size, 0L, 0);



/* module-initialization */
obj_t 
module_initialization_70_inline_size(long checksum_2532, char *from_2533)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_inline_size))
	{
	   require_initialization_114_inline_size =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_inline_size();
	   cnst_init_137_inline_size();
	   imported_modules_init_94_inline_size();
	   object_init_111_inline_size();
	   method_init_76_inline_size();
	   toplevel_init_63_inline_size();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_inline_size()
{
   AN_OBJECT;
   {	/* Inline/size.scm 14 */
      module_initialization_70___object(((long) 0), "INLINE_SIZE");
      module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "INLINE_SIZE");
      module_initialization_70___reader(((long) 0), "INLINE_SIZE");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_inline_size()
{
   AN_OBJECT;
   {	/* Inline/size.scm 14 */
      {		/* Inline/size.scm 14 */
	 obj_t cnst_port_138_2525;
	 cnst_port_138_2525 =
	    open_input_string(string2126_inline_size);
	 {
	    long i_2526;
	    i_2526 = ((long) 9);
	  loop_2527:
	    {	/* Inline/size.scm 14 */
	       bool_t test2127_2528;
	       test2127_2528 =
		  (i_2526 == ((long) -1));
	       if (test2127_2528)
		 {	/* Inline/size.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Inline/size.scm 14 */
		    {	/* Inline/size.scm 14 */
		       obj_t arg2128_2529;
		       {	/* Inline/size.scm 14 */
			  obj_t list2129_2530;
			  list2129_2530 =
			     MAKE_PAIR(cnst_port_138_2525, BNIL);
			  arg2128_2529 =
			     read___reader(list2129_2530);
		       }
		       CNST_TABLE_SET(i_2526, arg2128_2529);
		    }
		    {	/* Inline/size.scm 14 */
		       int aux_2531;
		       {	/* Inline/size.scm 14 */
			  long aux_2552;
			  aux_2552 =
			     (i_2526 - ((long) 1));
			  aux_2531 =
			     (int) (aux_2552);
		       }
		       {
			  long i_2555;
			  i_2555 =
			     (long) (aux_2531);
			  i_2526 = i_2555;
			  goto loop_2527;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_inline_size()
{
   AN_OBJECT;
   {	/* Inline/size.scm 14 */
      return BUNSPEC;
   }
}



/* object-init */
obj_t 
object_init_111_inline_size()
{
   AN_OBJECT;
   {	/* Inline/size.scm 14 */
      {		/* Inline/size.scm 14 */
	 obj_t arg1704_984;
	 obj_t arg1705_985;
	 obj_t arg1708_988;
	 arg1704_984 =
	    CNST_TABLE_REF(((long) 0));
	 arg1705_985 = sequence_ast_node;
	 {	/* Inline/size.scm 14 */
	    obj_t v1599_989;
	    v1599_989 =
	       create_vector(((long) 0));
	    arg1708_988 = v1599_989;
	 }
	 sized_sequence_48_inline_size =
	    register_class__225___object(arg1704_984, arg1705_985, allocate_sized_sequence_env_88_inline_size, ((long) 49834), BUNSPEC, BFALSE, arg1708_988);
      }
      {		/* Inline/size.scm 14 */
	 obj_t arg1709_990;
	 obj_t arg1711_991;
	 obj_t arg1714_994;
	 arg1709_990 =
	    CNST_TABLE_REF(((long) 1));
	 arg1711_991 = app_ast_node;
	 {	/* Inline/size.scm 14 */
	    obj_t v1600_995;
	    v1600_995 =
	       create_vector(((long) 0));
	    arg1714_994 = v1600_995;
	 }
	 sized_app_52_inline_size =
	    register_class__225___object(arg1709_990, arg1711_991, allocate_sized_app_env_53_inline_size, ((long) 38290), BUNSPEC, BFALSE, arg1714_994);
      }
      {		/* Inline/size.scm 14 */
	 obj_t arg1715_996;
	 obj_t arg1716_997;
	 obj_t arg1719_1000;
	 arg1715_996 =
	    CNST_TABLE_REF(((long) 2));
	 arg1716_997 = funcall_ast_node;
	 {	/* Inline/size.scm 14 */
	    obj_t v1601_1001;
	    v1601_1001 =
	       create_vector(((long) 0));
	    arg1719_1000 = v1601_1001;
	 }
	 sized_funcall_46_inline_size =
	    register_class__225___object(arg1715_996, arg1716_997, allocate_sized_funcall_env_52_inline_size, ((long) 47950), BUNSPEC, BFALSE, arg1719_1000);
      }
      {		/* Inline/size.scm 14 */
	 obj_t arg1720_1002;
	 obj_t arg1721_1003;
	 obj_t arg1724_1006;
	 arg1720_1002 =
	    CNST_TABLE_REF(((long) 3));
	 arg1721_1003 = pragma_ast_node;
	 {	/* Inline/size.scm 14 */
	    obj_t v1602_1007;
	    v1602_1007 =
	       create_vector(((long) 0));
	    arg1724_1006 = v1602_1007;
	 }
	 sized_pragma_213_inline_size =
	    register_class__225___object(arg1720_1002, arg1721_1003, allocate_sized_pragma_env_85_inline_size, ((long) 18155), BUNSPEC, BFALSE, arg1724_1006);
      }
      {		/* Inline/size.scm 14 */
	 obj_t arg1725_1008;
	 obj_t arg1726_1009;
	 obj_t arg1729_1012;
	 arg1725_1008 =
	    CNST_TABLE_REF(((long) 4));
	 arg1726_1009 = conditional_ast_node;
	 {	/* Inline/size.scm 14 */
	    obj_t v1603_1013;
	    v1603_1013 =
	       create_vector(((long) 0));
	    arg1729_1012 = v1603_1013;
	 }
	 sized_conditional_152_inline_size =
	    register_class__225___object(arg1725_1008, arg1726_1009, allocate_sized_conditional_env_43_inline_size, ((long) 35687), BUNSPEC, BFALSE, arg1729_1012);
      }
      {		/* Inline/size.scm 14 */
	 obj_t arg1730_1014;
	 obj_t arg1731_1015;
	 obj_t arg1734_1018;
	 arg1730_1014 =
	    CNST_TABLE_REF(((long) 5));
	 arg1731_1015 = fail_ast_node;
	 {	/* Inline/size.scm 14 */
	    obj_t v1604_1019;
	    v1604_1019 =
	       create_vector(((long) 0));
	    arg1734_1018 = v1604_1019;
	 }
	 sized_fail_63_inline_size =
	    register_class__225___object(arg1730_1014, arg1731_1015, allocate_sized_fail_env_18_inline_size, ((long) 24655), BUNSPEC, BFALSE, arg1734_1018);
      }
      {		/* Inline/size.scm 14 */
	 obj_t arg1735_1020;
	 obj_t arg1736_1021;
	 obj_t arg1740_1024;
	 arg1735_1020 =
	    CNST_TABLE_REF(((long) 6));
	 arg1736_1021 = select_ast_node;
	 {	/* Inline/size.scm 14 */
	    obj_t v1605_1025;
	    v1605_1025 =
	       create_vector(((long) 0));
	    arg1740_1024 = v1605_1025;
	 }
	 sized_select_166_inline_size =
	    register_class__225___object(arg1735_1020, arg1736_1021, allocate_sized_select_env_132_inline_size, ((long) 52643), BUNSPEC, BFALSE, arg1740_1024);
      }
      {		/* Inline/size.scm 14 */
	 obj_t arg1741_1026;
	 obj_t arg1742_1027;
	 obj_t arg1745_1030;
	 arg1741_1026 =
	    CNST_TABLE_REF(((long) 7));
	 arg1742_1027 = let_fun_218_ast_node;
	 {	/* Inline/size.scm 14 */
	    obj_t v1606_1031;
	    v1606_1031 =
	       create_vector(((long) 0));
	    arg1745_1030 = v1606_1031;
	 }
	 sized_let_fun_188_inline_size =
	    register_class__225___object(arg1741_1026, arg1742_1027, allocate_sized_let_fun_env_195_inline_size, ((long) 5408), BUNSPEC, BFALSE, arg1745_1030);
      }
      {		/* Inline/size.scm 14 */
	 obj_t arg1746_1032;
	 obj_t arg1747_1033;
	 obj_t arg1750_1036;
	 arg1746_1032 =
	    CNST_TABLE_REF(((long) 8));
	 arg1747_1033 = let_var_6_ast_node;
	 {	/* Inline/size.scm 14 */
	    obj_t v1607_1037;
	    v1607_1037 =
	       create_vector(((long) 0));
	    arg1750_1036 = v1607_1037;
	 }
	 sized_let_var_54_inline_size =
	    register_class__225___object(arg1746_1032, arg1747_1033, allocate_sized_let_var_env_114_inline_size, ((long) 6336), BUNSPEC, BFALSE, arg1750_1036);
      }
      return BUNSPEC;
   }
}



/* allocate-sized-let-var */
let_var_6_bglt 
allocate_sized_let_var_152_inline_size()
{
   AN_OBJECT;
   {	/* Inline/size.scm 26 */
      {		/* Inline/size.scm 26 */
	 let_var_6_bglt new1581_1038;
	 new1581_1038 =
	    ((let_var_6_bglt) BREF(GC_MALLOC(sizeof(struct let_var_6))));
	 {	/* Inline/size.scm 26 */
	    long arg1751_1039;
	    arg1751_1039 =
	       class_num_218___object(sized_let_var_54_inline_size);
	    {	/* Inline/size.scm 26 */
	       obj_t obj_1856;
	       obj_1856 =
		  (obj_t) (new1581_1038);
	       (((obj_t) CREF(obj_1856))->header = MAKE_HEADER(arg1751_1039, 0), BUNSPEC);
	    }
	 }
	 {	/* Inline/size.scm 26 */
	    object_bglt aux_2588;
	    aux_2588 =
	       (object_bglt) (new1581_1038);
	    OBJECT_WIDENING_SET(aux_2588, BFALSE);
	 }
	 return new1581_1038;
      }
   }
}



/* _allocate-sized-let-var */
obj_t 
_allocate_sized_let_var_200_inline_size(obj_t env_2452)
{
   AN_OBJECT;
   {	/* Inline/size.scm 26 */
      {		/* Inline/size.scm 26 */
	 let_var_6_bglt aux_2591;
	 aux_2591 =
	    allocate_sized_let_var_152_inline_size();
	 return
	    (obj_t) (aux_2591);
      }
   }
}



/* allocate-sized-let-fun */
let_fun_218_bglt 
allocate_sized_let_fun_17_inline_size()
{
   AN_OBJECT;
   {	/* Inline/size.scm 25 */
      {		/* Inline/size.scm 25 */
	 let_fun_218_bglt new1563_1046;
	 new1563_1046 =
	    ((let_fun_218_bglt) BREF(GC_MALLOC(sizeof(struct let_fun_218))));
	 {	/* Inline/size.scm 25 */
	    long arg1754_1047;
	    arg1754_1047 =
	       class_num_218___object(sized_let_fun_188_inline_size);
	    {	/* Inline/size.scm 25 */
	       obj_t obj_1860;
	       obj_1860 =
		  (obj_t) (new1563_1046);
	       (((obj_t) CREF(obj_1860))->header = MAKE_HEADER(arg1754_1047, 0), BUNSPEC);
	    }
	 }
	 {	/* Inline/size.scm 25 */
	    object_bglt aux_2598;
	    aux_2598 =
	       (object_bglt) (new1563_1046);
	    OBJECT_WIDENING_SET(aux_2598, BFALSE);
	 }
	 return new1563_1046;
      }
   }
}



/* _allocate-sized-let-fun */
obj_t 
_allocate_sized_let_fun_213_inline_size(obj_t env_2451)
{
   AN_OBJECT;
   {	/* Inline/size.scm 25 */
      {		/* Inline/size.scm 25 */
	 let_fun_218_bglt aux_2601;
	 aux_2601 =
	    allocate_sized_let_fun_17_inline_size();
	 return
	    (obj_t) (aux_2601);
      }
   }
}



/* allocate-sized-select */
select_bglt 
allocate_sized_select_168_inline_size()
{
   AN_OBJECT;
   {	/* Inline/size.scm 24 */
      {		/* Inline/size.scm 24 */
	 select_bglt new1546_1054;
	 new1546_1054 =
	    ((select_bglt) BREF(GC_MALLOC(sizeof(struct select))));
	 {	/* Inline/size.scm 24 */
	    long arg1758_1055;
	    arg1758_1055 =
	       class_num_218___object(sized_select_166_inline_size);
	    {	/* Inline/size.scm 24 */
	       obj_t obj_1864;
	       obj_1864 =
		  (obj_t) (new1546_1054);
	       (((obj_t) CREF(obj_1864))->header = MAKE_HEADER(arg1758_1055, 0), BUNSPEC);
	    }
	 }
	 {	/* Inline/size.scm 24 */
	    object_bglt aux_2608;
	    aux_2608 =
	       (object_bglt) (new1546_1054);
	    OBJECT_WIDENING_SET(aux_2608, BFALSE);
	 }
	 return new1546_1054;
      }
   }
}



/* _allocate-sized-select */
obj_t 
_allocate_sized_select_175_inline_size(obj_t env_2450)
{
   AN_OBJECT;
   {	/* Inline/size.scm 24 */
      {		/* Inline/size.scm 24 */
	 select_bglt aux_2611;
	 aux_2611 =
	    allocate_sized_select_168_inline_size();
	 return
	    (obj_t) (aux_2611);
      }
   }
}



/* allocate-sized-fail */
fail_bglt 
allocate_sized_fail_135_inline_size()
{
   AN_OBJECT;
   {	/* Inline/size.scm 23 */
      {		/* Inline/size.scm 23 */
	 fail_bglt new1530_1062;
	 new1530_1062 =
	    ((fail_bglt) BREF(GC_MALLOC(sizeof(struct fail))));
	 {	/* Inline/size.scm 23 */
	    long arg1761_1063;
	    arg1761_1063 =
	       class_num_218___object(sized_fail_63_inline_size);
	    {	/* Inline/size.scm 23 */
	       obj_t obj_1868;
	       obj_1868 =
		  (obj_t) (new1530_1062);
	       (((obj_t) CREF(obj_1868))->header = MAKE_HEADER(arg1761_1063, 0), BUNSPEC);
	    }
	 }
	 {	/* Inline/size.scm 23 */
	    object_bglt aux_2618;
	    aux_2618 =
	       (object_bglt) (new1530_1062);
	    OBJECT_WIDENING_SET(aux_2618, BFALSE);
	 }
	 return new1530_1062;
      }
   }
}



/* _allocate-sized-fail */
obj_t 
_allocate_sized_fail_239_inline_size(obj_t env_2449)
{
   AN_OBJECT;
   {	/* Inline/size.scm 23 */
      {		/* Inline/size.scm 23 */
	 fail_bglt aux_2621;
	 aux_2621 =
	    allocate_sized_fail_135_inline_size();
	 return
	    (obj_t) (aux_2621);
      }
   }
}



/* allocate-sized-conditional */
conditional_bglt 
allocate_sized_conditional_44_inline_size()
{
   AN_OBJECT;
   {	/* Inline/size.scm 22 */
      {		/* Inline/size.scm 22 */
	 conditional_bglt new1514_1070;
	 new1514_1070 =
	    ((conditional_bglt) BREF(GC_MALLOC(sizeof(struct conditional))));
	 {	/* Inline/size.scm 22 */
	    long arg1764_1071;
	    arg1764_1071 =
	       class_num_218___object(sized_conditional_152_inline_size);
	    {	/* Inline/size.scm 22 */
	       obj_t obj_1872;
	       obj_1872 =
		  (obj_t) (new1514_1070);
	       (((obj_t) CREF(obj_1872))->header = MAKE_HEADER(arg1764_1071, 0), BUNSPEC);
	    }
	 }
	 {	/* Inline/size.scm 22 */
	    object_bglt aux_2628;
	    aux_2628 =
	       (object_bglt) (new1514_1070);
	    OBJECT_WIDENING_SET(aux_2628, BFALSE);
	 }
	 return new1514_1070;
      }
   }
}



/* _allocate-sized-conditional */
obj_t 
_allocate_sized_conditional_74_inline_size(obj_t env_2448)
{
   AN_OBJECT;
   {	/* Inline/size.scm 22 */
      {		/* Inline/size.scm 22 */
	 conditional_bglt aux_2631;
	 aux_2631 =
	    allocate_sized_conditional_44_inline_size();
	 return
	    (obj_t) (aux_2631);
      }
   }
}



/* allocate-sized-pragma */
pragma_bglt 
allocate_sized_pragma_254_inline_size()
{
   AN_OBJECT;
   {	/* Inline/size.scm 21 */
      {		/* Inline/size.scm 21 */
	 pragma_bglt new1496_1078;
	 new1496_1078 =
	    ((pragma_bglt) BREF(GC_MALLOC(sizeof(struct pragma))));
	 {	/* Inline/size.scm 21 */
	    long arg1767_1079;
	    arg1767_1079 =
	       class_num_218___object(sized_pragma_213_inline_size);
	    {	/* Inline/size.scm 21 */
	       obj_t obj_1876;
	       obj_1876 =
		  (obj_t) (new1496_1078);
	       (((obj_t) CREF(obj_1876))->header = MAKE_HEADER(arg1767_1079, 0), BUNSPEC);
	    }
	 }
	 {	/* Inline/size.scm 21 */
	    object_bglt aux_2638;
	    aux_2638 =
	       (object_bglt) (new1496_1078);
	    OBJECT_WIDENING_SET(aux_2638, BFALSE);
	 }
	 return new1496_1078;
      }
   }
}



/* _allocate-sized-pragma */
obj_t 
_allocate_sized_pragma_184_inline_size(obj_t env_2447)
{
   AN_OBJECT;
   {	/* Inline/size.scm 21 */
      {		/* Inline/size.scm 21 */
	 pragma_bglt aux_2641;
	 aux_2641 =
	    allocate_sized_pragma_254_inline_size();
	 return
	    (obj_t) (aux_2641);
      }
   }
}



/* allocate-sized-funcall */
funcall_bglt 
allocate_sized_funcall_74_inline_size()
{
   AN_OBJECT;
   {	/* Inline/size.scm 20 */
      {		/* Inline/size.scm 20 */
	 funcall_bglt new1480_1086;
	 new1480_1086 =
	    ((funcall_bglt) BREF(GC_MALLOC(sizeof(struct funcall))));
	 {	/* Inline/size.scm 20 */
	    long arg1770_1087;
	    arg1770_1087 =
	       class_num_218___object(sized_funcall_46_inline_size);
	    {	/* Inline/size.scm 20 */
	       obj_t obj_1880;
	       obj_1880 =
		  (obj_t) (new1480_1086);
	       (((obj_t) CREF(obj_1880))->header = MAKE_HEADER(arg1770_1087, 0), BUNSPEC);
	    }
	 }
	 {	/* Inline/size.scm 20 */
	    object_bglt aux_2648;
	    aux_2648 =
	       (object_bglt) (new1480_1086);
	    OBJECT_WIDENING_SET(aux_2648, BFALSE);
	 }
	 return new1480_1086;
      }
   }
}



/* _allocate-sized-funcall */
obj_t 
_allocate_sized_funcall_28_inline_size(obj_t env_2446)
{
   AN_OBJECT;
   {	/* Inline/size.scm 20 */
      {		/* Inline/size.scm 20 */
	 funcall_bglt aux_2651;
	 aux_2651 =
	    allocate_sized_funcall_74_inline_size();
	 return
	    (obj_t) (aux_2651);
      }
   }
}



/* allocate-sized-app */
app_bglt 
allocate_sized_app_161_inline_size()
{
   AN_OBJECT;
   {	/* Inline/size.scm 19 */
      {		/* Inline/size.scm 19 */
	 app_bglt new1464_1094;
	 new1464_1094 =
	    ((app_bglt) BREF(GC_MALLOC(sizeof(struct app))));
	 {	/* Inline/size.scm 19 */
	    long arg1773_1095;
	    arg1773_1095 =
	       class_num_218___object(sized_app_52_inline_size);
	    {	/* Inline/size.scm 19 */
	       obj_t obj_1884;
	       obj_1884 =
		  (obj_t) (new1464_1094);
	       (((obj_t) CREF(obj_1884))->header = MAKE_HEADER(arg1773_1095, 0), BUNSPEC);
	    }
	 }
	 {	/* Inline/size.scm 19 */
	    object_bglt aux_2658;
	    aux_2658 =
	       (object_bglt) (new1464_1094);
	    OBJECT_WIDENING_SET(aux_2658, BFALSE);
	 }
	 return new1464_1094;
      }
   }
}



/* _allocate-sized-app */
obj_t 
_allocate_sized_app_5_inline_size(obj_t env_2445)
{
   AN_OBJECT;
   {	/* Inline/size.scm 19 */
      {		/* Inline/size.scm 19 */
	 app_bglt aux_2661;
	 aux_2661 =
	    allocate_sized_app_161_inline_size();
	 return
	    (obj_t) (aux_2661);
      }
   }
}



/* allocate-sized-sequence */
sequence_bglt 
allocate_sized_sequence_56_inline_size()
{
   AN_OBJECT;
   {	/* Inline/size.scm 18 */
      {		/* Inline/size.scm 18 */
	 sequence_bglt new1445_1102;
	 new1445_1102 =
	    ((sequence_bglt) BREF(GC_MALLOC(sizeof(struct sequence))));
	 {	/* Inline/size.scm 18 */
	    long arg1776_1103;
	    arg1776_1103 =
	       class_num_218___object(sized_sequence_48_inline_size);
	    {	/* Inline/size.scm 18 */
	       obj_t obj_1888;
	       obj_1888 =
		  (obj_t) (new1445_1102);
	       (((obj_t) CREF(obj_1888))->header = MAKE_HEADER(arg1776_1103, 0), BUNSPEC);
	    }
	 }
	 {	/* Inline/size.scm 18 */
	    object_bglt aux_2668;
	    aux_2668 =
	       (object_bglt) (new1445_1102);
	    OBJECT_WIDENING_SET(aux_2668, BFALSE);
	 }
	 return new1445_1102;
      }
   }
}



/* _allocate-sized-sequence */
obj_t 
_allocate_sized_sequence_167_inline_size(obj_t env_2444)
{
   AN_OBJECT;
   {	/* Inline/size.scm 18 */
      {		/* Inline/size.scm 18 */
	 sequence_bglt aux_2671;
	 aux_2671 =
	    allocate_sized_sequence_56_inline_size();
	 return
	    (obj_t) (aux_2671);
      }
   }
}



/* method-init */
obj_t 
method_init_76_inline_size()
{
   AN_OBJECT;
   {	/* Inline/size.scm 14 */
      add_generic__110___object(node_size_env_51_inline_size, node_size_default1608_env_20_inline_size);
      add_inlined_method__244___object(node_size_env_51_inline_size, atom_ast_node, ((long) 0));
      add_inlined_method__244___object(node_size_env_51_inline_size, var_ast_node, ((long) 1));
      add_inlined_method__244___object(node_size_env_51_inline_size, kwote_ast_node, ((long) 2));
      add_inlined_method__244___object(node_size_env_51_inline_size, sequence_ast_node, ((long) 3));
      add_inlined_method__244___object(node_size_env_51_inline_size, sized_sequence_48_inline_size, ((long) 4));
      add_inlined_method__244___object(node_size_env_51_inline_size, app_ast_node, ((long) 5));
      add_inlined_method__244___object(node_size_env_51_inline_size, sized_app_52_inline_size, ((long) 6));
      add_inlined_method__244___object(node_size_env_51_inline_size, app_ly_162_ast_node, ((long) 7));
      add_inlined_method__244___object(node_size_env_51_inline_size, funcall_ast_node, ((long) 8));
      add_inlined_method__244___object(node_size_env_51_inline_size, sized_funcall_46_inline_size, ((long) 9));
      add_inlined_method__244___object(node_size_env_51_inline_size, sized_pragma_213_inline_size, ((long) 10));
      add_inlined_method__244___object(node_size_env_51_inline_size, cast_ast_node, ((long) 11));
      add_inlined_method__244___object(node_size_env_51_inline_size, pragma_ast_node, ((long) 12));
      add_inlined_method__244___object(node_size_env_51_inline_size, setq_ast_node, ((long) 13));
      add_inlined_method__244___object(node_size_env_51_inline_size, conditional_ast_node, ((long) 14));
      add_inlined_method__244___object(node_size_env_51_inline_size, sized_conditional_152_inline_size, ((long) 15));
      add_inlined_method__244___object(node_size_env_51_inline_size, fail_ast_node, ((long) 16));
      add_inlined_method__244___object(node_size_env_51_inline_size, sized_fail_63_inline_size, ((long) 17));
      add_inlined_method__244___object(node_size_env_51_inline_size, select_ast_node, ((long) 18));
      add_inlined_method__244___object(node_size_env_51_inline_size, sized_select_166_inline_size, ((long) 19));
      add_inlined_method__244___object(node_size_env_51_inline_size, let_fun_218_ast_node, ((long) 20));
      add_inlined_method__244___object(node_size_env_51_inline_size, sized_let_fun_188_inline_size, ((long) 21));
      add_inlined_method__244___object(node_size_env_51_inline_size, let_var_6_ast_node, ((long) 22));
      add_inlined_method__244___object(node_size_env_51_inline_size, sized_let_var_54_inline_size, ((long) 23));
      add_inlined_method__244___object(node_size_env_51_inline_size, set_ex_it_116_ast_node, ((long) 24));
      add_inlined_method__244___object(node_size_env_51_inline_size, jump_ex_it_184_ast_node, ((long) 25));
      add_inlined_method__244___object(node_size_env_51_inline_size, make_box_202_ast_node, ((long) 26));
      add_inlined_method__244___object(node_size_env_51_inline_size, box_ref_242_ast_node, ((long) 27));
      add_inlined_method__244___object(node_size_env_51_inline_size, box_set__221_ast_node, ((long) 28));
      {		/* Inline/size.scm 14 */
	 obj_t object__struct_sized_let_var1668_248_2475;
	 object__struct_sized_let_var1668_248_2475 = proc2107_inline_size;
	 add_method__1___object(object__struct_env_210___object, sized_let_var_54_inline_size, object__struct_sized_let_var1668_248_2475);
      }
      {		/* Inline/size.scm 14 */
	 obj_t struct_object__object_sized_let_var1670_137_2474;
	 struct_object__object_sized_let_var1670_137_2474 = proc2108_inline_size;
	 add_method__1___object(struct_object__object_env_209___object, sized_let_var_54_inline_size, struct_object__object_sized_let_var1670_137_2474);
      }
      {		/* Inline/size.scm 14 */
	 obj_t object__struct_sized_let_fun1672_231_2473;
	 object__struct_sized_let_fun1672_231_2473 = proc2109_inline_size;
	 add_method__1___object(object__struct_env_210___object, sized_let_fun_188_inline_size, object__struct_sized_let_fun1672_231_2473);
      }
      {		/* Inline/size.scm 14 */
	 obj_t struct_object__object_sized_let_fun1674_20_2472;
	 struct_object__object_sized_let_fun1674_20_2472 = proc2110_inline_size;
	 add_method__1___object(struct_object__object_env_209___object, sized_let_fun_188_inline_size, struct_object__object_sized_let_fun1674_20_2472);
      }
      {		/* Inline/size.scm 14 */
	 obj_t object__struct_sized_select1677_109_2471;
	 object__struct_sized_select1677_109_2471 = proc2111_inline_size;
	 add_method__1___object(object__struct_env_210___object, sized_select_166_inline_size, object__struct_sized_select1677_109_2471);
      }
      {		/* Inline/size.scm 14 */
	 obj_t struct_object__object_sized_select1679_20_2470;
	 struct_object__object_sized_select1679_20_2470 = proc2112_inline_size;
	 add_method__1___object(struct_object__object_env_209___object, sized_select_166_inline_size, struct_object__object_sized_select1679_20_2470);
      }
      {		/* Inline/size.scm 14 */
	 obj_t object__struct_sized_fail1681_120_2469;
	 object__struct_sized_fail1681_120_2469 = proc2113_inline_size;
	 add_method__1___object(object__struct_env_210___object, sized_fail_63_inline_size, object__struct_sized_fail1681_120_2469);
      }
      {		/* Inline/size.scm 14 */
	 obj_t struct_object__object_sized_fail1683_173_2468;
	 struct_object__object_sized_fail1683_173_2468 = proc2114_inline_size;
	 add_method__1___object(struct_object__object_env_209___object, sized_fail_63_inline_size, struct_object__object_sized_fail1683_173_2468);
      }
      {		/* Inline/size.scm 14 */
	 obj_t object__struct_sized_conditional1685_18_2467;
	 object__struct_sized_conditional1685_18_2467 = proc2115_inline_size;
	 add_method__1___object(object__struct_env_210___object, sized_conditional_152_inline_size, object__struct_sized_conditional1685_18_2467);
      }
      {		/* Inline/size.scm 14 */
	 obj_t struct_object__object_sized_conditional1687_142_2466;
	 struct_object__object_sized_conditional1687_142_2466 = proc2116_inline_size;
	 add_method__1___object(struct_object__object_env_209___object, sized_conditional_152_inline_size, struct_object__object_sized_conditional1687_142_2466);
      }
      {		/* Inline/size.scm 14 */
	 obj_t object__struct_sized_pragma1689_26_2465;
	 object__struct_sized_pragma1689_26_2465 = proc2117_inline_size;
	 add_method__1___object(object__struct_env_210___object, sized_pragma_213_inline_size, object__struct_sized_pragma1689_26_2465);
      }
      {		/* Inline/size.scm 14 */
	 obj_t struct_object__object_sized_pragma1691_206_2464;
	 struct_object__object_sized_pragma1691_206_2464 = proc2118_inline_size;
	 add_method__1___object(struct_object__object_env_209___object, sized_pragma_213_inline_size, struct_object__object_sized_pragma1691_206_2464);
      }
      {		/* Inline/size.scm 14 */
	 obj_t object__struct_sized_funcall1693_245_2463;
	 object__struct_sized_funcall1693_245_2463 = proc2119_inline_size;
	 add_method__1___object(object__struct_env_210___object, sized_funcall_46_inline_size, object__struct_sized_funcall1693_245_2463);
      }
      {		/* Inline/size.scm 14 */
	 obj_t struct_object__object_sized_funcall1695_115_2462;
	 struct_object__object_sized_funcall1695_115_2462 = proc2120_inline_size;
	 add_method__1___object(struct_object__object_env_209___object, sized_funcall_46_inline_size, struct_object__object_sized_funcall1695_115_2462);
      }
      {		/* Inline/size.scm 14 */
	 obj_t object__struct_sized_app1697_131_2461;
	 object__struct_sized_app1697_131_2461 = proc2121_inline_size;
	 add_method__1___object(object__struct_env_210___object, sized_app_52_inline_size, object__struct_sized_app1697_131_2461);
      }
      {		/* Inline/size.scm 14 */
	 obj_t struct_object__object_sized_app1699_186_2460;
	 struct_object__object_sized_app1699_186_2460 = proc2122_inline_size;
	 add_method__1___object(struct_object__object_env_209___object, sized_app_52_inline_size, struct_object__object_sized_app1699_186_2460);
      }
      {		/* Inline/size.scm 14 */
	 obj_t object__struct_sized_sequence1701_59_2457;
	 object__struct_sized_sequence1701_59_2457 = proc2123_inline_size;
	 add_method__1___object(object__struct_env_210___object, sized_sequence_48_inline_size, object__struct_sized_sequence1701_59_2457);
      }
      {		/* Inline/size.scm 14 */
	 obj_t struct_object__object_sized_sequence1703_135_2453;
	 struct_object__object_sized_sequence1703_135_2453 = proc2124_inline_size;
	 return
	    add_method__1___object(struct_object__object_env_209___object, sized_sequence_48_inline_size, struct_object__object_sized_sequence1703_135_2453);
      }
   }
}



/* struct+object->object-sized-sequence1703 */
obj_t 
struct_object__object_sized_sequence1703_135_inline_size(obj_t env_2476, obj_t o_2477, obj_t s_2478)
{
   AN_OBJECT;
   {	/* Inline/size.scm 18 */
      {
	 sized_sequence_48_bglt o_1622;
	 obj_t s_1623;
	 {	/* Inline/size.scm 18 */
	    sized_sequence_48_bglt aux_2722;
	    o_1622 =
	       (sized_sequence_48_bglt) (o_2477);
	    s_1623 = s_2478;
	    {

	       {	/* Inline/size.scm 18 */
		  obj_t old1450_1626;
		  obj_t aux1451_1627;
		  {	/* Inline/size.scm 18 */
		     obj_t next_method1702_100_1632;
		     next_method1702_100_1632 =
			find_super_class_method_167___object(
			(object_bglt) (o_1622), struct_object__object_env_209___object, sized_sequence_48_inline_size);
		     if (
			PROCEDUREP(next_method1702_100_1632))
		       {	/* Inline/size.scm 18 */
			  old1450_1626 =
			     PROCEDURE_ENTRY(next_method1702_100_1632) (next_method1702_100_1632,
			     (obj_t) (o_1622), s_1623, BEOA);
		       }
		     else
		       {	/* Inline/size.scm 18 */
			  PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method1702_100_1632);
			  {	/* Inline/size.scm 18 */
			     object_bglt aux_2731;
			     aux_2731 =
				struct_object__object_93___object(
				(object_bglt) (o_1622), s_1623);
			     old1450_1626 =
				(obj_t) (aux_2731);
			  }
		       }
		  }
		  aux1451_1627 =
		     STRUCT_REF(s_1623, ((long) 0));
		  {	/* Inline/size.scm 18 */
		     sized_sequence_48_bglt new1452_1628;
		     new1452_1628 =
			((sized_sequence_48_bglt) (old1450_1626));
		     {	/* Inline/size.scm 18 */
			long arg1925_1629;
			arg1925_1629 =
			   class_num_218___object(sized_sequence_48_inline_size);
			{	/* Inline/size.scm 18 */
			   obj_t obj_2234;
			   obj_2234 =
			      (obj_t) (new1452_1628);
			   (((obj_t) CREF(obj_2234))->header = MAKE_HEADER(arg1925_1629, 0), BUNSPEC);
			}
		     }
		     {	/* Inline/size.scm 18 */
			sized_sequence_48_bglt arg1926_1630;
			{	/* Inline/size.scm 18 */
			   sized_sequence_48_bglt res2093_2241;
			   {	/* Inline/size.scm 18 */
			      long size_2238;
			      {		/* Inline/size.scm 18 */
				 obj_t aux_2740;
				 aux_2740 =
				    STRUCT_REF(aux1451_1627, ((long) 0));
				 size_2238 =
				    (long) CINT(aux_2740);
			      }
			      {		/* Inline/size.scm 18 */
				 sized_sequence_48_bglt new1440_2239;
				 new1440_2239 =
				    ((sized_sequence_48_bglt) BREF(GC_MALLOC(sizeof(struct sized_sequence_48))));
				 ((((sized_sequence_48_bglt) CREF(new1440_2239))->size) = ((long) size_2238), BUNSPEC);
				 res2093_2241 = new1440_2239;
			      }
			   }
			   arg1926_1630 = res2093_2241;
			}
			{	/* Inline/size.scm 18 */
			   obj_t aux_2747;
			   object_bglt aux_2745;
			   aux_2747 =
			      (obj_t) (arg1926_1630);
			   aux_2745 =
			      (object_bglt) (new1452_1628);
			   OBJECT_WIDENING_SET(aux_2745, aux_2747);
			}
		     }
		     aux_2722 = new1452_1628;
		  }
	       }
	    }
	    return
	       (obj_t) (aux_2722);
	 }
      }
   }
}



/* object->struct-sized-sequence1701 */
obj_t 
object__struct_sized_sequence1701_59_inline_size(obj_t env_2479, obj_t obj1447_2480)
{
   AN_OBJECT;
   {	/* Inline/size.scm 18 */
      {
	 sized_sequence_48_bglt obj1447_1612;
	 obj1447_1612 =
	    (sized_sequence_48_bglt) (obj1447_2480);
	 {

	    {	/* Inline/size.scm 18 */
	       obj_t res1448_1615;
	       {	/* Inline/size.scm 18 */
		  obj_t next_method1700_175_1620;
		  next_method1700_175_1620 =
		     find_super_class_method_167___object(
		     (object_bglt) (obj1447_1612), object__struct_env_210___object, sized_sequence_48_inline_size);
		  if (
		     PROCEDUREP(next_method1700_175_1620))
		    {	/* Inline/size.scm 18 */
		       res1448_1615 =
			  PROCEDURE_ENTRY(next_method1700_175_1620) (next_method1700_175_1620,
			  (obj_t) (obj1447_1612), BEOA);
		    }
		  else
		    {	/* Inline/size.scm 18 */
		       PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method1700_175_1620);
		       res1448_1615 =
			  object__struct_50___object(
			  (object_bglt) (obj1447_1612));
		    }
	       }
	       {	/* Inline/size.scm 18 */
		  obj_t aux1449_1616;
		  {	/* ./Llib/struct.scm 1415 */
		     obj_t aux_2762;
		     aux_2762 =
			CNST_TABLE_REF(((long) 0));
		     aux1449_1616 =
			make_struct(aux_2762, ((long) 1), BUNSPEC);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_2765;
		     {	/* Inline/size.scm 18 */
			long aux_2766;
			{
			   obj_t aux_2767;
			   {	/* Inline/size.scm 18 */
			      object_bglt aux_2768;
			      aux_2768 =
				 (object_bglt) (obj1447_1612);
			      aux_2767 =
				 OBJECT_WIDENING(aux_2768);
			   }
			   aux_2766 =
			      (((sized_sequence_48_bglt) CREF(aux_2767))->size);
			}
			aux_2765 =
			   BINT(aux_2766);
		     }
		     STRUCT_SET(aux1449_1616, ((long) 0), aux_2765);
		  }
		  STRUCT_SET(res1448_1615, ((long) 0), aux1449_1616);
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_2775;
		     aux_2775 =
			STRUCT_KEY(res1448_1615);
		     STRUCT_KEY_SET(aux1449_1616, aux_2775);
		  }
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_2778;
		     aux_2778 =
			CNST_TABLE_REF(((long) 0));
		     STRUCT_KEY_SET(res1448_1615, aux_2778);
		  }
		  return res1448_1615;
	       }
	    }
	 }
      }
   }
}



/* struct+object->object-sized-app1699 */
obj_t 
struct_object__object_sized_app1699_186_inline_size(obj_t env_2481, obj_t o_2482, obj_t s_2483)
{
   AN_OBJECT;
   {	/* Inline/size.scm 19 */
      {
	 sized_app_52_bglt o_1600;
	 obj_t s_1601;
	 {	/* Inline/size.scm 19 */
	    sized_app_52_bglt aux_2782;
	    o_1600 =
	       (sized_app_52_bglt) (o_2482);
	    s_1601 = s_2483;
	    {

	       {	/* Inline/size.scm 19 */
		  obj_t old1468_1604;
		  obj_t aux1469_1605;
		  {	/* Inline/size.scm 19 */
		     obj_t next_method1698_193_1610;
		     next_method1698_193_1610 =
			find_super_class_method_167___object(
			(object_bglt) (o_1600), struct_object__object_env_209___object, sized_app_52_inline_size);
		     if (
			PROCEDUREP(next_method1698_193_1610))
		       {	/* Inline/size.scm 19 */
			  old1468_1604 =
			     PROCEDURE_ENTRY(next_method1698_193_1610) (next_method1698_193_1610,
			     (obj_t) (o_1600), s_1601, BEOA);
		       }
		     else
		       {	/* Inline/size.scm 19 */
			  PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method1698_193_1610);
			  {	/* Inline/size.scm 19 */
			     object_bglt aux_2791;
			     aux_2791 =
				struct_object__object_93___object(
				(object_bglt) (o_1600), s_1601);
			     old1468_1604 =
				(obj_t) (aux_2791);
			  }
		       }
		  }
		  aux1469_1605 =
		     STRUCT_REF(s_1601, ((long) 0));
		  {	/* Inline/size.scm 19 */
		     sized_app_52_bglt new1470_1606;
		     new1470_1606 =
			((sized_app_52_bglt) (old1468_1604));
		     {	/* Inline/size.scm 19 */
			long arg1916_1607;
			arg1916_1607 =
			   class_num_218___object(sized_app_52_inline_size);
			{	/* Inline/size.scm 19 */
			   obj_t obj_2205;
			   obj_2205 =
			      (obj_t) (new1470_1606);
			   (((obj_t) CREF(obj_2205))->header = MAKE_HEADER(arg1916_1607, 0), BUNSPEC);
			}
		     }
		     {	/* Inline/size.scm 19 */
			sized_app_52_bglt arg1917_1608;
			{	/* Inline/size.scm 19 */
			   sized_app_52_bglt res2092_2212;
			   {	/* Inline/size.scm 19 */
			      long size_2209;
			      {		/* Inline/size.scm 19 */
				 obj_t aux_2800;
				 aux_2800 =
				    STRUCT_REF(aux1469_1605, ((long) 0));
				 size_2209 =
				    (long) CINT(aux_2800);
			      }
			      {		/* Inline/size.scm 19 */
				 sized_app_52_bglt new1459_2210;
				 new1459_2210 =
				    ((sized_app_52_bglt) BREF(GC_MALLOC(sizeof(struct sized_app_52))));
				 ((((sized_app_52_bglt) CREF(new1459_2210))->size) = ((long) size_2209), BUNSPEC);
				 res2092_2212 = new1459_2210;
			      }
			   }
			   arg1917_1608 = res2092_2212;
			}
			{	/* Inline/size.scm 19 */
			   obj_t aux_2807;
			   object_bglt aux_2805;
			   aux_2807 =
			      (obj_t) (arg1917_1608);
			   aux_2805 =
			      (object_bglt) (new1470_1606);
			   OBJECT_WIDENING_SET(aux_2805, aux_2807);
			}
		     }
		     aux_2782 = new1470_1606;
		  }
	       }
	    }
	    return
	       (obj_t) (aux_2782);
	 }
      }
   }
}



/* object->struct-sized-app1697 */
obj_t 
object__struct_sized_app1697_131_inline_size(obj_t env_2484, obj_t obj1465_2485)
{
   AN_OBJECT;
   {	/* Inline/size.scm 19 */
      {
	 sized_app_52_bglt obj1465_1590;
	 obj1465_1590 =
	    (sized_app_52_bglt) (obj1465_2485);
	 {

	    {	/* Inline/size.scm 19 */
	       obj_t res1466_1593;
	       {	/* Inline/size.scm 19 */
		  obj_t next_method1696_232_1598;
		  next_method1696_232_1598 =
		     find_super_class_method_167___object(
		     (object_bglt) (obj1465_1590), object__struct_env_210___object, sized_app_52_inline_size);
		  if (
		     PROCEDUREP(next_method1696_232_1598))
		    {	/* Inline/size.scm 19 */
		       res1466_1593 =
			  PROCEDURE_ENTRY(next_method1696_232_1598) (next_method1696_232_1598,
			  (obj_t) (obj1465_1590), BEOA);
		    }
		  else
		    {	/* Inline/size.scm 19 */
		       PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method1696_232_1598);
		       res1466_1593 =
			  object__struct_50___object(
			  (object_bglt) (obj1465_1590));
		    }
	       }
	       {	/* Inline/size.scm 19 */
		  obj_t aux1467_1594;
		  {	/* ./Llib/struct.scm 1415 */
		     obj_t aux_2822;
		     aux_2822 =
			CNST_TABLE_REF(((long) 1));
		     aux1467_1594 =
			make_struct(aux_2822, ((long) 1), BUNSPEC);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_2825;
		     {	/* Inline/size.scm 19 */
			long aux_2826;
			{
			   obj_t aux_2827;
			   {	/* Inline/size.scm 19 */
			      object_bglt aux_2828;
			      aux_2828 =
				 (object_bglt) (obj1465_1590);
			      aux_2827 =
				 OBJECT_WIDENING(aux_2828);
			   }
			   aux_2826 =
			      (((sized_app_52_bglt) CREF(aux_2827))->size);
			}
			aux_2825 =
			   BINT(aux_2826);
		     }
		     STRUCT_SET(aux1467_1594, ((long) 0), aux_2825);
		  }
		  STRUCT_SET(res1466_1593, ((long) 0), aux1467_1594);
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_2835;
		     aux_2835 =
			STRUCT_KEY(res1466_1593);
		     STRUCT_KEY_SET(aux1467_1594, aux_2835);
		  }
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_2838;
		     aux_2838 =
			CNST_TABLE_REF(((long) 1));
		     STRUCT_KEY_SET(res1466_1593, aux_2838);
		  }
		  return res1466_1593;
	       }
	    }
	 }
      }
   }
}



/* struct+object->object-sized-funcall1695 */
obj_t 
struct_object__object_sized_funcall1695_115_inline_size(obj_t env_2486, obj_t o_2487, obj_t s_2488)
{
   AN_OBJECT;
   {	/* Inline/size.scm 20 */
      {
	 sized_funcall_46_bglt o_1578;
	 obj_t s_1579;
	 {	/* Inline/size.scm 20 */
	    sized_funcall_46_bglt aux_2842;
	    o_1578 =
	       (sized_funcall_46_bglt) (o_2487);
	    s_1579 = s_2488;
	    {

	       {	/* Inline/size.scm 20 */
		  obj_t old1484_1582;
		  obj_t aux1485_1583;
		  {	/* Inline/size.scm 20 */
		     obj_t next_method1694_108_1588;
		     next_method1694_108_1588 =
			find_super_class_method_167___object(
			(object_bglt) (o_1578), struct_object__object_env_209___object, sized_funcall_46_inline_size);
		     if (
			PROCEDUREP(next_method1694_108_1588))
		       {	/* Inline/size.scm 20 */
			  old1484_1582 =
			     PROCEDURE_ENTRY(next_method1694_108_1588) (next_method1694_108_1588,
			     (obj_t) (o_1578), s_1579, BEOA);
		       }
		     else
		       {	/* Inline/size.scm 20 */
			  PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method1694_108_1588);
			  {	/* Inline/size.scm 20 */
			     object_bglt aux_2851;
			     aux_2851 =
				struct_object__object_93___object(
				(object_bglt) (o_1578), s_1579);
			     old1484_1582 =
				(obj_t) (aux_2851);
			  }
		       }
		  }
		  aux1485_1583 =
		     STRUCT_REF(s_1579, ((long) 0));
		  {	/* Inline/size.scm 20 */
		     sized_funcall_46_bglt new1486_1584;
		     new1486_1584 =
			((sized_funcall_46_bglt) (old1484_1582));
		     {	/* Inline/size.scm 20 */
			long arg1907_1585;
			arg1907_1585 =
			   class_num_218___object(sized_funcall_46_inline_size);
			{	/* Inline/size.scm 20 */
			   obj_t obj_2176;
			   obj_2176 =
			      (obj_t) (new1486_1584);
			   (((obj_t) CREF(obj_2176))->header = MAKE_HEADER(arg1907_1585, 0), BUNSPEC);
			}
		     }
		     {	/* Inline/size.scm 20 */
			sized_funcall_46_bglt arg1909_1586;
			{	/* Inline/size.scm 20 */
			   sized_funcall_46_bglt res2091_2183;
			   {	/* Inline/size.scm 20 */
			      long size_2180;
			      {		/* Inline/size.scm 20 */
				 obj_t aux_2860;
				 aux_2860 =
				    STRUCT_REF(aux1485_1583, ((long) 0));
				 size_2180 =
				    (long) CINT(aux_2860);
			      }
			      {		/* Inline/size.scm 20 */
				 sized_funcall_46_bglt new1475_2181;
				 new1475_2181 =
				    ((sized_funcall_46_bglt) BREF(GC_MALLOC(sizeof(struct sized_funcall_46))));
				 ((((sized_funcall_46_bglt) CREF(new1475_2181))->size) = ((long) size_2180), BUNSPEC);
				 res2091_2183 = new1475_2181;
			      }
			   }
			   arg1909_1586 = res2091_2183;
			}
			{	/* Inline/size.scm 20 */
			   obj_t aux_2867;
			   object_bglt aux_2865;
			   aux_2867 =
			      (obj_t) (arg1909_1586);
			   aux_2865 =
			      (object_bglt) (new1486_1584);
			   OBJECT_WIDENING_SET(aux_2865, aux_2867);
			}
		     }
		     aux_2842 = new1486_1584;
		  }
	       }
	    }
	    return
	       (obj_t) (aux_2842);
	 }
      }
   }
}



/* object->struct-sized-funcall1693 */
obj_t 
object__struct_sized_funcall1693_245_inline_size(obj_t env_2489, obj_t obj1481_2490)
{
   AN_OBJECT;
   {	/* Inline/size.scm 20 */
      {
	 sized_funcall_46_bglt obj1481_1568;
	 obj1481_1568 =
	    (sized_funcall_46_bglt) (obj1481_2490);
	 {

	    {	/* Inline/size.scm 20 */
	       obj_t res1482_1571;
	       {	/* Inline/size.scm 20 */
		  obj_t next_method1692_137_1576;
		  next_method1692_137_1576 =
		     find_super_class_method_167___object(
		     (object_bglt) (obj1481_1568), object__struct_env_210___object, sized_funcall_46_inline_size);
		  if (
		     PROCEDUREP(next_method1692_137_1576))
		    {	/* Inline/size.scm 20 */
		       res1482_1571 =
			  PROCEDURE_ENTRY(next_method1692_137_1576) (next_method1692_137_1576,
			  (obj_t) (obj1481_1568), BEOA);
		    }
		  else
		    {	/* Inline/size.scm 20 */
		       PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method1692_137_1576);
		       res1482_1571 =
			  object__struct_50___object(
			  (object_bglt) (obj1481_1568));
		    }
	       }
	       {	/* Inline/size.scm 20 */
		  obj_t aux1483_1572;
		  {	/* ./Llib/struct.scm 1415 */
		     obj_t aux_2882;
		     aux_2882 =
			CNST_TABLE_REF(((long) 2));
		     aux1483_1572 =
			make_struct(aux_2882, ((long) 1), BUNSPEC);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_2885;
		     {	/* Inline/size.scm 20 */
			long aux_2886;
			{
			   obj_t aux_2887;
			   {	/* Inline/size.scm 20 */
			      object_bglt aux_2888;
			      aux_2888 =
				 (object_bglt) (obj1481_1568);
			      aux_2887 =
				 OBJECT_WIDENING(aux_2888);
			   }
			   aux_2886 =
			      (((sized_funcall_46_bglt) CREF(aux_2887))->size);
			}
			aux_2885 =
			   BINT(aux_2886);
		     }
		     STRUCT_SET(aux1483_1572, ((long) 0), aux_2885);
		  }
		  STRUCT_SET(res1482_1571, ((long) 0), aux1483_1572);
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_2895;
		     aux_2895 =
			STRUCT_KEY(res1482_1571);
		     STRUCT_KEY_SET(aux1483_1572, aux_2895);
		  }
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_2898;
		     aux_2898 =
			CNST_TABLE_REF(((long) 2));
		     STRUCT_KEY_SET(res1482_1571, aux_2898);
		  }
		  return res1482_1571;
	       }
	    }
	 }
      }
   }
}



/* struct+object->object-sized-pragma1691 */
obj_t 
struct_object__object_sized_pragma1691_206_inline_size(obj_t env_2491, obj_t o_2492, obj_t s_2493)
{
   AN_OBJECT;
   {	/* Inline/size.scm 21 */
      {
	 sized_pragma_213_bglt o_1556;
	 obj_t s_1557;
	 {	/* Inline/size.scm 21 */
	    sized_pragma_213_bglt aux_2902;
	    o_1556 =
	       (sized_pragma_213_bglt) (o_2492);
	    s_1557 = s_2493;
	    {

	       {	/* Inline/size.scm 21 */
		  obj_t old1500_1560;
		  obj_t aux1501_1561;
		  {	/* Inline/size.scm 21 */
		     obj_t next_method1690_74_1566;
		     next_method1690_74_1566 =
			find_super_class_method_167___object(
			(object_bglt) (o_1556), struct_object__object_env_209___object, sized_pragma_213_inline_size);
		     if (
			PROCEDUREP(next_method1690_74_1566))
		       {	/* Inline/size.scm 21 */
			  old1500_1560 =
			     PROCEDURE_ENTRY(next_method1690_74_1566) (next_method1690_74_1566,
			     (obj_t) (o_1556), s_1557, BEOA);
		       }
		     else
		       {	/* Inline/size.scm 21 */
			  PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method1690_74_1566);
			  {	/* Inline/size.scm 21 */
			     object_bglt aux_2911;
			     aux_2911 =
				struct_object__object_93___object(
				(object_bglt) (o_1556), s_1557);
			     old1500_1560 =
				(obj_t) (aux_2911);
			  }
		       }
		  }
		  aux1501_1561 =
		     STRUCT_REF(s_1557, ((long) 0));
		  {	/* Inline/size.scm 21 */
		     sized_pragma_213_bglt new1502_1562;
		     new1502_1562 =
			((sized_pragma_213_bglt) (old1500_1560));
		     {	/* Inline/size.scm 21 */
			long arg1899_1563;
			arg1899_1563 =
			   class_num_218___object(sized_pragma_213_inline_size);
			{	/* Inline/size.scm 21 */
			   obj_t obj_2147;
			   obj_2147 =
			      (obj_t) (new1502_1562);
			   (((obj_t) CREF(obj_2147))->header = MAKE_HEADER(arg1899_1563, 0), BUNSPEC);
			}
		     }
		     {	/* Inline/size.scm 21 */
			sized_pragma_213_bglt arg1900_1564;
			{	/* Inline/size.scm 21 */
			   sized_pragma_213_bglt res2090_2154;
			   {	/* Inline/size.scm 21 */
			      long size_2151;
			      {		/* Inline/size.scm 21 */
				 obj_t aux_2920;
				 aux_2920 =
				    STRUCT_REF(aux1501_1561, ((long) 0));
				 size_2151 =
				    (long) CINT(aux_2920);
			      }
			      {		/* Inline/size.scm 21 */
				 sized_pragma_213_bglt new1491_2152;
				 new1491_2152 =
				    ((sized_pragma_213_bglt) BREF(GC_MALLOC(sizeof(struct sized_pragma_213))));
				 ((((sized_pragma_213_bglt) CREF(new1491_2152))->size) = ((long) size_2151), BUNSPEC);
				 res2090_2154 = new1491_2152;
			      }
			   }
			   arg1900_1564 = res2090_2154;
			}
			{	/* Inline/size.scm 21 */
			   obj_t aux_2927;
			   object_bglt aux_2925;
			   aux_2927 =
			      (obj_t) (arg1900_1564);
			   aux_2925 =
			      (object_bglt) (new1502_1562);
			   OBJECT_WIDENING_SET(aux_2925, aux_2927);
			}
		     }
		     aux_2902 = new1502_1562;
		  }
	       }
	    }
	    return
	       (obj_t) (aux_2902);
	 }
      }
   }
}



/* object->struct-sized-pragma1689 */
obj_t 
object__struct_sized_pragma1689_26_inline_size(obj_t env_2494, obj_t obj1497_2495)
{
   AN_OBJECT;
   {	/* Inline/size.scm 21 */
      {
	 sized_pragma_213_bglt obj1497_1546;
	 obj1497_1546 =
	    (sized_pragma_213_bglt) (obj1497_2495);
	 {

	    {	/* Inline/size.scm 21 */
	       obj_t res1498_1549;
	       {	/* Inline/size.scm 21 */
		  obj_t next_method1688_120_1554;
		  next_method1688_120_1554 =
		     find_super_class_method_167___object(
		     (object_bglt) (obj1497_1546), object__struct_env_210___object, sized_pragma_213_inline_size);
		  if (
		     PROCEDUREP(next_method1688_120_1554))
		    {	/* Inline/size.scm 21 */
		       res1498_1549 =
			  PROCEDURE_ENTRY(next_method1688_120_1554) (next_method1688_120_1554,
			  (obj_t) (obj1497_1546), BEOA);
		    }
		  else
		    {	/* Inline/size.scm 21 */
		       PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method1688_120_1554);
		       res1498_1549 =
			  object__struct_50___object(
			  (object_bglt) (obj1497_1546));
		    }
	       }
	       {	/* Inline/size.scm 21 */
		  obj_t aux1499_1550;
		  {	/* ./Llib/struct.scm 1415 */
		     obj_t aux_2942;
		     aux_2942 =
			CNST_TABLE_REF(((long) 3));
		     aux1499_1550 =
			make_struct(aux_2942, ((long) 1), BUNSPEC);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_2945;
		     {	/* Inline/size.scm 21 */
			long aux_2946;
			{
			   obj_t aux_2947;
			   {	/* Inline/size.scm 21 */
			      object_bglt aux_2948;
			      aux_2948 =
				 (object_bglt) (obj1497_1546);
			      aux_2947 =
				 OBJECT_WIDENING(aux_2948);
			   }
			   aux_2946 =
			      (((sized_pragma_213_bglt) CREF(aux_2947))->size);
			}
			aux_2945 =
			   BINT(aux_2946);
		     }
		     STRUCT_SET(aux1499_1550, ((long) 0), aux_2945);
		  }
		  STRUCT_SET(res1498_1549, ((long) 0), aux1499_1550);
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_2955;
		     aux_2955 =
			STRUCT_KEY(res1498_1549);
		     STRUCT_KEY_SET(aux1499_1550, aux_2955);
		  }
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_2958;
		     aux_2958 =
			CNST_TABLE_REF(((long) 3));
		     STRUCT_KEY_SET(res1498_1549, aux_2958);
		  }
		  return res1498_1549;
	       }
	    }
	 }
      }
   }
}



/* struct+object->object-sized-conditional1687 */
obj_t 
struct_object__object_sized_conditional1687_142_inline_size(obj_t env_2496, obj_t o_2497, obj_t s_2498)
{
   AN_OBJECT;
   {	/* Inline/size.scm 22 */
      {
	 sized_conditional_152_bglt o_1534;
	 obj_t s_1535;
	 {	/* Inline/size.scm 22 */
	    sized_conditional_152_bglt aux_2962;
	    o_1534 =
	       (sized_conditional_152_bglt) (o_2497);
	    s_1535 = s_2498;
	    {

	       {	/* Inline/size.scm 22 */
		  obj_t old1518_1538;
		  obj_t aux1519_1539;
		  {	/* Inline/size.scm 22 */
		     obj_t next_method1686_163_1544;
		     next_method1686_163_1544 =
			find_super_class_method_167___object(
			(object_bglt) (o_1534), struct_object__object_env_209___object, sized_conditional_152_inline_size);
		     if (
			PROCEDUREP(next_method1686_163_1544))
		       {	/* Inline/size.scm 22 */
			  old1518_1538 =
			     PROCEDURE_ENTRY(next_method1686_163_1544) (next_method1686_163_1544,
			     (obj_t) (o_1534), s_1535, BEOA);
		       }
		     else
		       {	/* Inline/size.scm 22 */
			  PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method1686_163_1544);
			  {	/* Inline/size.scm 22 */
			     object_bglt aux_2971;
			     aux_2971 =
				struct_object__object_93___object(
				(object_bglt) (o_1534), s_1535);
			     old1518_1538 =
				(obj_t) (aux_2971);
			  }
		       }
		  }
		  aux1519_1539 =
		     STRUCT_REF(s_1535, ((long) 0));
		  {	/* Inline/size.scm 22 */
		     sized_conditional_152_bglt new1520_1540;
		     new1520_1540 =
			((sized_conditional_152_bglt) (old1518_1538));
		     {	/* Inline/size.scm 22 */
			long arg1891_1541;
			arg1891_1541 =
			   class_num_218___object(sized_conditional_152_inline_size);
			{	/* Inline/size.scm 22 */
			   obj_t obj_2118;
			   obj_2118 =
			      (obj_t) (new1520_1540);
			   (((obj_t) CREF(obj_2118))->header = MAKE_HEADER(arg1891_1541, 0), BUNSPEC);
			}
		     }
		     {	/* Inline/size.scm 22 */
			sized_conditional_152_bglt arg1892_1542;
			{	/* Inline/size.scm 22 */
			   sized_conditional_152_bglt res2089_2125;
			   {	/* Inline/size.scm 22 */
			      long size_2122;
			      {		/* Inline/size.scm 22 */
				 obj_t aux_2980;
				 aux_2980 =
				    STRUCT_REF(aux1519_1539, ((long) 0));
				 size_2122 =
				    (long) CINT(aux_2980);
			      }
			      {		/* Inline/size.scm 22 */
				 sized_conditional_152_bglt new1509_2123;
				 new1509_2123 =
				    ((sized_conditional_152_bglt) BREF(GC_MALLOC(sizeof(struct sized_conditional_152))));
				 ((((sized_conditional_152_bglt) CREF(new1509_2123))->size) = ((long) size_2122), BUNSPEC);
				 res2089_2125 = new1509_2123;
			      }
			   }
			   arg1892_1542 = res2089_2125;
			}
			{	/* Inline/size.scm 22 */
			   obj_t aux_2987;
			   object_bglt aux_2985;
			   aux_2987 =
			      (obj_t) (arg1892_1542);
			   aux_2985 =
			      (object_bglt) (new1520_1540);
			   OBJECT_WIDENING_SET(aux_2985, aux_2987);
			}
		     }
		     aux_2962 = new1520_1540;
		  }
	       }
	    }
	    return
	       (obj_t) (aux_2962);
	 }
      }
   }
}



/* object->struct-sized-conditional1685 */
obj_t 
object__struct_sized_conditional1685_18_inline_size(obj_t env_2499, obj_t obj1515_2500)
{
   AN_OBJECT;
   {	/* Inline/size.scm 22 */
      {
	 sized_conditional_152_bglt obj1515_1524;
	 obj1515_1524 =
	    (sized_conditional_152_bglt) (obj1515_2500);
	 {

	    {	/* Inline/size.scm 22 */
	       obj_t res1516_1527;
	       {	/* Inline/size.scm 22 */
		  obj_t next_method1684_222_1532;
		  next_method1684_222_1532 =
		     find_super_class_method_167___object(
		     (object_bglt) (obj1515_1524), object__struct_env_210___object, sized_conditional_152_inline_size);
		  if (
		     PROCEDUREP(next_method1684_222_1532))
		    {	/* Inline/size.scm 22 */
		       res1516_1527 =
			  PROCEDURE_ENTRY(next_method1684_222_1532) (next_method1684_222_1532,
			  (obj_t) (obj1515_1524), BEOA);
		    }
		  else
		    {	/* Inline/size.scm 22 */
		       PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method1684_222_1532);
		       res1516_1527 =
			  object__struct_50___object(
			  (object_bglt) (obj1515_1524));
		    }
	       }
	       {	/* Inline/size.scm 22 */
		  obj_t aux1517_1528;
		  {	/* ./Llib/struct.scm 1415 */
		     obj_t aux_3002;
		     aux_3002 =
			CNST_TABLE_REF(((long) 4));
		     aux1517_1528 =
			make_struct(aux_3002, ((long) 1), BUNSPEC);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_3005;
		     {	/* Inline/size.scm 22 */
			long aux_3006;
			{
			   obj_t aux_3007;
			   {	/* Inline/size.scm 22 */
			      object_bglt aux_3008;
			      aux_3008 =
				 (object_bglt) (obj1515_1524);
			      aux_3007 =
				 OBJECT_WIDENING(aux_3008);
			   }
			   aux_3006 =
			      (((sized_conditional_152_bglt) CREF(aux_3007))->size);
			}
			aux_3005 =
			   BINT(aux_3006);
		     }
		     STRUCT_SET(aux1517_1528, ((long) 0), aux_3005);
		  }
		  STRUCT_SET(res1516_1527, ((long) 0), aux1517_1528);
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_3015;
		     aux_3015 =
			STRUCT_KEY(res1516_1527);
		     STRUCT_KEY_SET(aux1517_1528, aux_3015);
		  }
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_3018;
		     aux_3018 =
			CNST_TABLE_REF(((long) 4));
		     STRUCT_KEY_SET(res1516_1527, aux_3018);
		  }
		  return res1516_1527;
	       }
	    }
	 }
      }
   }
}



/* struct+object->object-sized-fail1683 */
obj_t 
struct_object__object_sized_fail1683_173_inline_size(obj_t env_2501, obj_t o_2502, obj_t s_2503)
{
   AN_OBJECT;
   {	/* Inline/size.scm 23 */
      {
	 sized_fail_63_bglt o_1512;
	 obj_t s_1513;
	 {	/* Inline/size.scm 23 */
	    sized_fail_63_bglt aux_3022;
	    o_1512 =
	       (sized_fail_63_bglt) (o_2502);
	    s_1513 = s_2503;
	    {

	       {	/* Inline/size.scm 23 */
		  obj_t old1534_1516;
		  obj_t aux1535_1517;
		  {	/* Inline/size.scm 23 */
		     obj_t next_method1682_248_1522;
		     next_method1682_248_1522 =
			find_super_class_method_167___object(
			(object_bglt) (o_1512), struct_object__object_env_209___object, sized_fail_63_inline_size);
		     if (
			PROCEDUREP(next_method1682_248_1522))
		       {	/* Inline/size.scm 23 */
			  old1534_1516 =
			     PROCEDURE_ENTRY(next_method1682_248_1522) (next_method1682_248_1522,
			     (obj_t) (o_1512), s_1513, BEOA);
		       }
		     else
		       {	/* Inline/size.scm 23 */
			  PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method1682_248_1522);
			  {	/* Inline/size.scm 23 */
			     object_bglt aux_3031;
			     aux_3031 =
				struct_object__object_93___object(
				(object_bglt) (o_1512), s_1513);
			     old1534_1516 =
				(obj_t) (aux_3031);
			  }
		       }
		  }
		  aux1535_1517 =
		     STRUCT_REF(s_1513, ((long) 0));
		  {	/* Inline/size.scm 23 */
		     sized_fail_63_bglt new1536_1518;
		     new1536_1518 =
			((sized_fail_63_bglt) (old1534_1516));
		     {	/* Inline/size.scm 23 */
			long arg1883_1519;
			arg1883_1519 =
			   class_num_218___object(sized_fail_63_inline_size);
			{	/* Inline/size.scm 23 */
			   obj_t obj_2089;
			   obj_2089 =
			      (obj_t) (new1536_1518);
			   (((obj_t) CREF(obj_2089))->header = MAKE_HEADER(arg1883_1519, 0), BUNSPEC);
			}
		     }
		     {	/* Inline/size.scm 23 */
			sized_fail_63_bglt arg1884_1520;
			{	/* Inline/size.scm 23 */
			   sized_fail_63_bglt res2088_2096;
			   {	/* Inline/size.scm 23 */
			      long size_2093;
			      {		/* Inline/size.scm 23 */
				 obj_t aux_3040;
				 aux_3040 =
				    STRUCT_REF(aux1535_1517, ((long) 0));
				 size_2093 =
				    (long) CINT(aux_3040);
			      }
			      {		/* Inline/size.scm 23 */
				 sized_fail_63_bglt new1525_2094;
				 new1525_2094 =
				    ((sized_fail_63_bglt) BREF(GC_MALLOC(sizeof(struct sized_fail_63))));
				 ((((sized_fail_63_bglt) CREF(new1525_2094))->size) = ((long) size_2093), BUNSPEC);
				 res2088_2096 = new1525_2094;
			      }
			   }
			   arg1884_1520 = res2088_2096;
			}
			{	/* Inline/size.scm 23 */
			   obj_t aux_3047;
			   object_bglt aux_3045;
			   aux_3047 =
			      (obj_t) (arg1884_1520);
			   aux_3045 =
			      (object_bglt) (new1536_1518);
			   OBJECT_WIDENING_SET(aux_3045, aux_3047);
			}
		     }
		     aux_3022 = new1536_1518;
		  }
	       }
	    }
	    return
	       (obj_t) (aux_3022);
	 }
      }
   }
}



/* object->struct-sized-fail1681 */
obj_t 
object__struct_sized_fail1681_120_inline_size(obj_t env_2504, obj_t obj1531_2505)
{
   AN_OBJECT;
   {	/* Inline/size.scm 23 */
      {
	 sized_fail_63_bglt obj1531_1502;
	 obj1531_1502 =
	    (sized_fail_63_bglt) (obj1531_2505);
	 {

	    {	/* Inline/size.scm 23 */
	       obj_t res1532_1505;
	       {	/* Inline/size.scm 23 */
		  obj_t next_method1680_219_1510;
		  next_method1680_219_1510 =
		     find_super_class_method_167___object(
		     (object_bglt) (obj1531_1502), object__struct_env_210___object, sized_fail_63_inline_size);
		  if (
		     PROCEDUREP(next_method1680_219_1510))
		    {	/* Inline/size.scm 23 */
		       res1532_1505 =
			  PROCEDURE_ENTRY(next_method1680_219_1510) (next_method1680_219_1510,
			  (obj_t) (obj1531_1502), BEOA);
		    }
		  else
		    {	/* Inline/size.scm 23 */
		       PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method1680_219_1510);
		       res1532_1505 =
			  object__struct_50___object(
			  (object_bglt) (obj1531_1502));
		    }
	       }
	       {	/* Inline/size.scm 23 */
		  obj_t aux1533_1506;
		  {	/* ./Llib/struct.scm 1415 */
		     obj_t aux_3062;
		     aux_3062 =
			CNST_TABLE_REF(((long) 5));
		     aux1533_1506 =
			make_struct(aux_3062, ((long) 1), BUNSPEC);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_3065;
		     {	/* Inline/size.scm 23 */
			long aux_3066;
			{
			   obj_t aux_3067;
			   {	/* Inline/size.scm 23 */
			      object_bglt aux_3068;
			      aux_3068 =
				 (object_bglt) (obj1531_1502);
			      aux_3067 =
				 OBJECT_WIDENING(aux_3068);
			   }
			   aux_3066 =
			      (((sized_fail_63_bglt) CREF(aux_3067))->size);
			}
			aux_3065 =
			   BINT(aux_3066);
		     }
		     STRUCT_SET(aux1533_1506, ((long) 0), aux_3065);
		  }
		  STRUCT_SET(res1532_1505, ((long) 0), aux1533_1506);
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_3075;
		     aux_3075 =
			STRUCT_KEY(res1532_1505);
		     STRUCT_KEY_SET(aux1533_1506, aux_3075);
		  }
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_3078;
		     aux_3078 =
			CNST_TABLE_REF(((long) 5));
		     STRUCT_KEY_SET(res1532_1505, aux_3078);
		  }
		  return res1532_1505;
	       }
	    }
	 }
      }
   }
}



/* struct+object->object-sized-select1679 */
obj_t 
struct_object__object_sized_select1679_20_inline_size(obj_t env_2506, obj_t o_2507, obj_t s_2508)
{
   AN_OBJECT;
   {	/* Inline/size.scm 24 */
      {
	 sized_select_166_bglt o_1490;
	 obj_t s_1491;
	 {	/* Inline/size.scm 24 */
	    sized_select_166_bglt aux_3082;
	    o_1490 =
	       (sized_select_166_bglt) (o_2507);
	    s_1491 = s_2508;
	    {

	       {	/* Inline/size.scm 24 */
		  obj_t old1550_1494;
		  obj_t aux1551_1495;
		  {	/* Inline/size.scm 24 */
		     obj_t next_method1678_187_1500;
		     next_method1678_187_1500 =
			find_super_class_method_167___object(
			(object_bglt) (o_1490), struct_object__object_env_209___object, sized_select_166_inline_size);
		     if (
			PROCEDUREP(next_method1678_187_1500))
		       {	/* Inline/size.scm 24 */
			  old1550_1494 =
			     PROCEDURE_ENTRY(next_method1678_187_1500) (next_method1678_187_1500,
			     (obj_t) (o_1490), s_1491, BEOA);
		       }
		     else
		       {	/* Inline/size.scm 24 */
			  PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method1678_187_1500);
			  {	/* Inline/size.scm 24 */
			     object_bglt aux_3091;
			     aux_3091 =
				struct_object__object_93___object(
				(object_bglt) (o_1490), s_1491);
			     old1550_1494 =
				(obj_t) (aux_3091);
			  }
		       }
		  }
		  aux1551_1495 =
		     STRUCT_REF(s_1491, ((long) 0));
		  {	/* Inline/size.scm 24 */
		     sized_select_166_bglt new1552_1496;
		     new1552_1496 =
			((sized_select_166_bglt) (old1550_1494));
		     {	/* Inline/size.scm 24 */
			long arg1875_1497;
			arg1875_1497 =
			   class_num_218___object(sized_select_166_inline_size);
			{	/* Inline/size.scm 24 */
			   obj_t obj_2060;
			   obj_2060 =
			      (obj_t) (new1552_1496);
			   (((obj_t) CREF(obj_2060))->header = MAKE_HEADER(arg1875_1497, 0), BUNSPEC);
			}
		     }
		     {	/* Inline/size.scm 24 */
			sized_select_166_bglt arg1876_1498;
			{	/* Inline/size.scm 24 */
			   sized_select_166_bglt res2087_2067;
			   {	/* Inline/size.scm 24 */
			      long size_2064;
			      {		/* Inline/size.scm 24 */
				 obj_t aux_3100;
				 aux_3100 =
				    STRUCT_REF(aux1551_1495, ((long) 0));
				 size_2064 =
				    (long) CINT(aux_3100);
			      }
			      {		/* Inline/size.scm 24 */
				 sized_select_166_bglt new1541_2065;
				 new1541_2065 =
				    ((sized_select_166_bglt) BREF(GC_MALLOC(sizeof(struct sized_select_166))));
				 ((((sized_select_166_bglt) CREF(new1541_2065))->size) = ((long) size_2064), BUNSPEC);
				 res2087_2067 = new1541_2065;
			      }
			   }
			   arg1876_1498 = res2087_2067;
			}
			{	/* Inline/size.scm 24 */
			   obj_t aux_3107;
			   object_bglt aux_3105;
			   aux_3107 =
			      (obj_t) (arg1876_1498);
			   aux_3105 =
			      (object_bglt) (new1552_1496);
			   OBJECT_WIDENING_SET(aux_3105, aux_3107);
			}
		     }
		     aux_3082 = new1552_1496;
		  }
	       }
	    }
	    return
	       (obj_t) (aux_3082);
	 }
      }
   }
}



/* object->struct-sized-select1677 */
obj_t 
object__struct_sized_select1677_109_inline_size(obj_t env_2509, obj_t obj1547_2510)
{
   AN_OBJECT;
   {	/* Inline/size.scm 24 */
      {
	 sized_select_166_bglt obj1547_1480;
	 obj1547_1480 =
	    (sized_select_166_bglt) (obj1547_2510);
	 {

	    {	/* Inline/size.scm 24 */
	       obj_t res1548_1483;
	       {	/* Inline/size.scm 24 */
		  obj_t next_method1676_212_1488;
		  next_method1676_212_1488 =
		     find_super_class_method_167___object(
		     (object_bglt) (obj1547_1480), object__struct_env_210___object, sized_select_166_inline_size);
		  if (
		     PROCEDUREP(next_method1676_212_1488))
		    {	/* Inline/size.scm 24 */
		       res1548_1483 =
			  PROCEDURE_ENTRY(next_method1676_212_1488) (next_method1676_212_1488,
			  (obj_t) (obj1547_1480), BEOA);
		    }
		  else
		    {	/* Inline/size.scm 24 */
		       PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method1676_212_1488);
		       res1548_1483 =
			  object__struct_50___object(
			  (object_bglt) (obj1547_1480));
		    }
	       }
	       {	/* Inline/size.scm 24 */
		  obj_t aux1549_1484;
		  {	/* ./Llib/struct.scm 1415 */
		     obj_t aux_3122;
		     aux_3122 =
			CNST_TABLE_REF(((long) 6));
		     aux1549_1484 =
			make_struct(aux_3122, ((long) 1), BUNSPEC);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_3125;
		     {	/* Inline/size.scm 24 */
			long aux_3126;
			{
			   obj_t aux_3127;
			   {	/* Inline/size.scm 24 */
			      object_bglt aux_3128;
			      aux_3128 =
				 (object_bglt) (obj1547_1480);
			      aux_3127 =
				 OBJECT_WIDENING(aux_3128);
			   }
			   aux_3126 =
			      (((sized_select_166_bglt) CREF(aux_3127))->size);
			}
			aux_3125 =
			   BINT(aux_3126);
		     }
		     STRUCT_SET(aux1549_1484, ((long) 0), aux_3125);
		  }
		  STRUCT_SET(res1548_1483, ((long) 0), aux1549_1484);
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_3135;
		     aux_3135 =
			STRUCT_KEY(res1548_1483);
		     STRUCT_KEY_SET(aux1549_1484, aux_3135);
		  }
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_3138;
		     aux_3138 =
			CNST_TABLE_REF(((long) 6));
		     STRUCT_KEY_SET(res1548_1483, aux_3138);
		  }
		  return res1548_1483;
	       }
	    }
	 }
      }
   }
}



/* struct+object->object-sized-let-fun1674 */
obj_t 
struct_object__object_sized_let_fun1674_20_inline_size(obj_t env_2511, obj_t o_2512, obj_t s_2513)
{
   AN_OBJECT;
   {	/* Inline/size.scm 25 */
      {
	 sized_let_fun_188_bglt o_1468;
	 obj_t s_1469;
	 {	/* Inline/size.scm 25 */
	    sized_let_fun_188_bglt aux_3142;
	    o_1468 =
	       (sized_let_fun_188_bglt) (o_2512);
	    s_1469 = s_2513;
	    {

	       {	/* Inline/size.scm 25 */
		  obj_t old1567_1472;
		  obj_t aux1568_1473;
		  {	/* Inline/size.scm 25 */
		     obj_t next_method1673_196_1478;
		     next_method1673_196_1478 =
			find_super_class_method_167___object(
			(object_bglt) (o_1468), struct_object__object_env_209___object, sized_let_fun_188_inline_size);
		     if (
			PROCEDUREP(next_method1673_196_1478))
		       {	/* Inline/size.scm 25 */
			  old1567_1472 =
			     PROCEDURE_ENTRY(next_method1673_196_1478) (next_method1673_196_1478,
			     (obj_t) (o_1468), s_1469, BEOA);
		       }
		     else
		       {	/* Inline/size.scm 25 */
			  PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method1673_196_1478);
			  {	/* Inline/size.scm 25 */
			     object_bglt aux_3151;
			     aux_3151 =
				struct_object__object_93___object(
				(object_bglt) (o_1468), s_1469);
			     old1567_1472 =
				(obj_t) (aux_3151);
			  }
		       }
		  }
		  aux1568_1473 =
		     STRUCT_REF(s_1469, ((long) 0));
		  {	/* Inline/size.scm 25 */
		     sized_let_fun_188_bglt new1569_1474;
		     new1569_1474 =
			((sized_let_fun_188_bglt) (old1567_1472));
		     {	/* Inline/size.scm 25 */
			long arg1867_1475;
			arg1867_1475 =
			   class_num_218___object(sized_let_fun_188_inline_size);
			{	/* Inline/size.scm 25 */
			   obj_t obj_2031;
			   obj_2031 =
			      (obj_t) (new1569_1474);
			   (((obj_t) CREF(obj_2031))->header = MAKE_HEADER(arg1867_1475, 0), BUNSPEC);
			}
		     }
		     {	/* Inline/size.scm 25 */
			sized_let_fun_188_bglt arg1868_1476;
			{	/* Inline/size.scm 25 */
			   sized_let_fun_188_bglt res2086_2038;
			   {	/* Inline/size.scm 25 */
			      long size_2035;
			      {		/* Inline/size.scm 25 */
				 obj_t aux_3160;
				 aux_3160 =
				    STRUCT_REF(aux1568_1473, ((long) 0));
				 size_2035 =
				    (long) CINT(aux_3160);
			      }
			      {		/* Inline/size.scm 25 */
				 sized_let_fun_188_bglt new1558_2036;
				 new1558_2036 =
				    ((sized_let_fun_188_bglt) BREF(GC_MALLOC(sizeof(struct sized_let_fun_188))));
				 ((((sized_let_fun_188_bglt) CREF(new1558_2036))->size) = ((long) size_2035), BUNSPEC);
				 res2086_2038 = new1558_2036;
			      }
			   }
			   arg1868_1476 = res2086_2038;
			}
			{	/* Inline/size.scm 25 */
			   obj_t aux_3167;
			   object_bglt aux_3165;
			   aux_3167 =
			      (obj_t) (arg1868_1476);
			   aux_3165 =
			      (object_bglt) (new1569_1474);
			   OBJECT_WIDENING_SET(aux_3165, aux_3167);
			}
		     }
		     aux_3142 = new1569_1474;
		  }
	       }
	    }
	    return
	       (obj_t) (aux_3142);
	 }
      }
   }
}



/* object->struct-sized-let-fun1672 */
obj_t 
object__struct_sized_let_fun1672_231_inline_size(obj_t env_2514, obj_t obj1564_2515)
{
   AN_OBJECT;
   {	/* Inline/size.scm 25 */
      {
	 sized_let_fun_188_bglt obj1564_1458;
	 obj1564_1458 =
	    (sized_let_fun_188_bglt) (obj1564_2515);
	 {

	    {	/* Inline/size.scm 25 */
	       obj_t res1565_1461;
	       {	/* Inline/size.scm 25 */
		  obj_t next_method1671_247_1466;
		  next_method1671_247_1466 =
		     find_super_class_method_167___object(
		     (object_bglt) (obj1564_1458), object__struct_env_210___object, sized_let_fun_188_inline_size);
		  if (
		     PROCEDUREP(next_method1671_247_1466))
		    {	/* Inline/size.scm 25 */
		       res1565_1461 =
			  PROCEDURE_ENTRY(next_method1671_247_1466) (next_method1671_247_1466,
			  (obj_t) (obj1564_1458), BEOA);
		    }
		  else
		    {	/* Inline/size.scm 25 */
		       PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method1671_247_1466);
		       res1565_1461 =
			  object__struct_50___object(
			  (object_bglt) (obj1564_1458));
		    }
	       }
	       {	/* Inline/size.scm 25 */
		  obj_t aux1566_1462;
		  {	/* ./Llib/struct.scm 1415 */
		     obj_t aux_3182;
		     aux_3182 =
			CNST_TABLE_REF(((long) 7));
		     aux1566_1462 =
			make_struct(aux_3182, ((long) 1), BUNSPEC);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_3185;
		     {	/* Inline/size.scm 25 */
			long aux_3186;
			{
			   obj_t aux_3187;
			   {	/* Inline/size.scm 25 */
			      object_bglt aux_3188;
			      aux_3188 =
				 (object_bglt) (obj1564_1458);
			      aux_3187 =
				 OBJECT_WIDENING(aux_3188);
			   }
			   aux_3186 =
			      (((sized_let_fun_188_bglt) CREF(aux_3187))->size);
			}
			aux_3185 =
			   BINT(aux_3186);
		     }
		     STRUCT_SET(aux1566_1462, ((long) 0), aux_3185);
		  }
		  STRUCT_SET(res1565_1461, ((long) 0), aux1566_1462);
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_3195;
		     aux_3195 =
			STRUCT_KEY(res1565_1461);
		     STRUCT_KEY_SET(aux1566_1462, aux_3195);
		  }
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_3198;
		     aux_3198 =
			CNST_TABLE_REF(((long) 7));
		     STRUCT_KEY_SET(res1565_1461, aux_3198);
		  }
		  return res1565_1461;
	       }
	    }
	 }
      }
   }
}



/* struct+object->object-sized-let-var1670 */
obj_t 
struct_object__object_sized_let_var1670_137_inline_size(obj_t env_2516, obj_t o_2517, obj_t s_2518)
{
   AN_OBJECT;
   {	/* Inline/size.scm 26 */
      {
	 sized_let_var_54_bglt o_1446;
	 obj_t s_1447;
	 {	/* Inline/size.scm 26 */
	    sized_let_var_54_bglt aux_3202;
	    o_1446 =
	       (sized_let_var_54_bglt) (o_2517);
	    s_1447 = s_2518;
	    {

	       {	/* Inline/size.scm 26 */
		  obj_t old1585_1450;
		  obj_t aux1586_1451;
		  {	/* Inline/size.scm 26 */
		     obj_t next_method1669_93_1456;
		     next_method1669_93_1456 =
			find_super_class_method_167___object(
			(object_bglt) (o_1446), struct_object__object_env_209___object, sized_let_var_54_inline_size);
		     if (
			PROCEDUREP(next_method1669_93_1456))
		       {	/* Inline/size.scm 26 */
			  old1585_1450 =
			     PROCEDURE_ENTRY(next_method1669_93_1456) (next_method1669_93_1456,
			     (obj_t) (o_1446), s_1447, BEOA);
		       }
		     else
		       {	/* Inline/size.scm 26 */
			  PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method1669_93_1456);
			  {	/* Inline/size.scm 26 */
			     object_bglt aux_3211;
			     aux_3211 =
				struct_object__object_93___object(
				(object_bglt) (o_1446), s_1447);
			     old1585_1450 =
				(obj_t) (aux_3211);
			  }
		       }
		  }
		  aux1586_1451 =
		     STRUCT_REF(s_1447, ((long) 0));
		  {	/* Inline/size.scm 26 */
		     sized_let_var_54_bglt new1587_1452;
		     new1587_1452 =
			((sized_let_var_54_bglt) (old1585_1450));
		     {	/* Inline/size.scm 26 */
			long arg1859_1453;
			arg1859_1453 =
			   class_num_218___object(sized_let_var_54_inline_size);
			{	/* Inline/size.scm 26 */
			   obj_t obj_2002;
			   obj_2002 =
			      (obj_t) (new1587_1452);
			   (((obj_t) CREF(obj_2002))->header = MAKE_HEADER(arg1859_1453, 0), BUNSPEC);
			}
		     }
		     {	/* Inline/size.scm 26 */
			sized_let_var_54_bglt arg1860_1454;
			{	/* Inline/size.scm 26 */
			   sized_let_var_54_bglt res2085_2009;
			   {	/* Inline/size.scm 26 */
			      long size_2006;
			      {		/* Inline/size.scm 26 */
				 obj_t aux_3220;
				 aux_3220 =
				    STRUCT_REF(aux1586_1451, ((long) 0));
				 size_2006 =
				    (long) CINT(aux_3220);
			      }
			      {		/* Inline/size.scm 26 */
				 sized_let_var_54_bglt new1576_2007;
				 new1576_2007 =
				    ((sized_let_var_54_bglt) BREF(GC_MALLOC(sizeof(struct sized_let_var_54))));
				 ((((sized_let_var_54_bglt) CREF(new1576_2007))->size) = ((long) size_2006), BUNSPEC);
				 res2085_2009 = new1576_2007;
			      }
			   }
			   arg1860_1454 = res2085_2009;
			}
			{	/* Inline/size.scm 26 */
			   obj_t aux_3227;
			   object_bglt aux_3225;
			   aux_3227 =
			      (obj_t) (arg1860_1454);
			   aux_3225 =
			      (object_bglt) (new1587_1452);
			   OBJECT_WIDENING_SET(aux_3225, aux_3227);
			}
		     }
		     aux_3202 = new1587_1452;
		  }
	       }
	    }
	    return
	       (obj_t) (aux_3202);
	 }
      }
   }
}



/* object->struct-sized-let-var1668 */
obj_t 
object__struct_sized_let_var1668_248_inline_size(obj_t env_2519, obj_t obj1582_2520)
{
   AN_OBJECT;
   {	/* Inline/size.scm 26 */
      {
	 sized_let_var_54_bglt obj1582_1436;
	 obj1582_1436 =
	    (sized_let_var_54_bglt) (obj1582_2520);
	 {

	    {	/* Inline/size.scm 26 */
	       obj_t res1583_1439;
	       {	/* Inline/size.scm 26 */
		  obj_t next_method1667_218_1444;
		  next_method1667_218_1444 =
		     find_super_class_method_167___object(
		     (object_bglt) (obj1582_1436), object__struct_env_210___object, sized_let_var_54_inline_size);
		  if (
		     PROCEDUREP(next_method1667_218_1444))
		    {	/* Inline/size.scm 26 */
		       res1583_1439 =
			  PROCEDURE_ENTRY(next_method1667_218_1444) (next_method1667_218_1444,
			  (obj_t) (obj1582_1436), BEOA);
		    }
		  else
		    {	/* Inline/size.scm 26 */
		       PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method1667_218_1444);
		       res1583_1439 =
			  object__struct_50___object(
			  (object_bglt) (obj1582_1436));
		    }
	       }
	       {	/* Inline/size.scm 26 */
		  obj_t aux1584_1440;
		  {	/* ./Llib/struct.scm 1415 */
		     obj_t aux_3242;
		     aux_3242 =
			CNST_TABLE_REF(((long) 8));
		     aux1584_1440 =
			make_struct(aux_3242, ((long) 1), BUNSPEC);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_3245;
		     {	/* Inline/size.scm 26 */
			long aux_3246;
			{
			   obj_t aux_3247;
			   {	/* Inline/size.scm 26 */
			      object_bglt aux_3248;
			      aux_3248 =
				 (object_bglt) (obj1582_1436);
			      aux_3247 =
				 OBJECT_WIDENING(aux_3248);
			   }
			   aux_3246 =
			      (((sized_let_var_54_bglt) CREF(aux_3247))->size);
			}
			aux_3245 =
			   BINT(aux_3246);
		     }
		     STRUCT_SET(aux1584_1440, ((long) 0), aux_3245);
		  }
		  STRUCT_SET(res1583_1439, ((long) 0), aux1584_1440);
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_3255;
		     aux_3255 =
			STRUCT_KEY(res1583_1439);
		     STRUCT_KEY_SET(aux1584_1440, aux_3255);
		  }
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_3258;
		     aux_3258 =
			CNST_TABLE_REF(((long) 8));
		     STRUCT_KEY_SET(res1583_1439, aux_3258);
		  }
		  return res1583_1439;
	       }
	    }
	 }
      }
   }
}



/* node-size */
long 
node_size_119_inline_size(node_bglt node_1)
{
   AN_OBJECT;
   {	/* Inline/size.scm 33 */
      {
	 obj_t method1930_1638;
	 obj_t class1935_1639;
	 {	/* Inline/size.scm 33 */
	    obj_t arg1938_1636;
	    obj_t arg1939_1637;
	    {	/* Inline/size.scm 33 */
	       object_bglt obj_2244;
	       obj_2244 =
		  (object_bglt) (node_1);
	       {	/* ./Llib/object.scm 2926 */
		  obj_t pre_method_105_2245;
		  pre_method_105_2245 =
		     PROCEDURE_REF(node_size_env_51_inline_size, ((long) 2));
		  if (
		     INTEGERP(pre_method_105_2245))
		    {	/* ./Llib/object.scm 2927 */
		       PROCEDURE_SET(node_size_env_51_inline_size, ((long) 2), BUNSPEC);
		       arg1938_1636 = pre_method_105_2245;
		    }
		  else
		    {	/* ./Llib/object.scm 2914 */
		       long obj_class_num_177_2250;
		       obj_class_num_177_2250 =
			  TYPE(obj_2244);
		       {	/* ./Llib/object.scm 2915 */
			  obj_t arg1176_2251;
			  arg1176_2251 =
			     PROCEDURE_REF(node_size_env_51_inline_size, ((long) 1));
			  {	/* ./Llib/object.scm 2738 */
			     long arg1177_2255;
			     {	/* ./Llib/object.scm 2738 */
				long arg1178_2256;
				arg1178_2256 =
				   OBJECT_TYPE;
				arg1177_2255 =
				   (obj_class_num_177_2250 - arg1178_2256);
			     }
			     arg1938_1636 =
				VECTOR_REF(arg1176_2251, arg1177_2255);
			  }
		       }
		    }
	       }
	    }
	    {	/* Inline/size.scm 33 */
	       object_bglt object_2261;
	       object_2261 =
		  (object_bglt) (node_1);
	       {	/* ./Llib/object.scm 2695 */
		  long arg1179_2262;
		  {	/* ./Llib/object.scm 2695 */
		     long arg1180_2263;
		     long arg1181_2264;
		     arg1180_2263 =
			TYPE(object_2261);
		     arg1181_2264 =
			OBJECT_TYPE;
		     arg1179_2262 =
			(arg1180_2263 - arg1181_2264);
		  }
		  {	/* ./Llib/object.scm 2695 */
		     obj_t vector_2268;
		     vector_2268 = _classes__134___object;
		     arg1939_1637 =
			VECTOR_REF(vector_2268, arg1179_2262);
		  }
	       }
	    }
	    {	/* Inline/size.scm 33 */
	       obj_t aux_3277;
	       method1930_1638 = arg1938_1636;
	       class1935_1639 = arg1939_1637;
	       {

		  if (
		     INTEGERP(method1930_1638))
		    {	/* Inline/size.scm 33 */
		       switch (
			  (long) CINT(method1930_1638))
			 {
			 case ((long) 0):

			    aux_3277 =
			       BINT(((long) 1));
			    break;
			 case ((long) 1):

			    aux_3277 =
			       BINT(((long) 1));
			    break;
			 case ((long) 2):

			    aux_3277 =
			       BINT(((long) 1));
			    break;
			 case ((long) 3):

			    {	/* Inline/size.scm 57 */
			       sequence_bglt node_1648;
			       node_1648 =
				  (sequence_bglt) (node_1);
			       {
				  obj_t nodes_1649;
				  long size_1650;
				  {	/* Inline/size.scm 57 */
				     long aux_3284;
				     nodes_1649 =
					(((sequence_bglt) CREF(node_1648))->nodes);
				     size_1650 = ((long) 0);
				   loop_1651:
				     if (
					NULLP(nodes_1649))
				       {	/* Inline/size.scm 59 */
					  {	/* Inline/size.scm 61 */
					     sized_sequence_48_bglt obj1588_1655;
					     obj1588_1655 =
						((sized_sequence_48_bglt) (node_1648));
					     {	/* Inline/size.scm 61 */
						sized_sequence_48_bglt arg1945_1656;
						{	/* Inline/size.scm 61 */
						   sized_sequence_48_bglt res2094_2275;
						   {	/* Inline/size.scm 18 */
						      sized_sequence_48_bglt new1440_2273;
						      new1440_2273 =
							 ((sized_sequence_48_bglt) BREF(GC_MALLOC(sizeof(struct sized_sequence_48))));
						      ((((sized_sequence_48_bglt) CREF(new1440_2273))->size) = ((long) size_1650), BUNSPEC);
						      res2094_2275 = new1440_2273;
						   }
						   arg1945_1656 = res2094_2275;
						}
						{	/* Inline/size.scm 61 */
						   obj_t aux_3292;
						   object_bglt aux_3290;
						   aux_3292 =
						      (obj_t) (arg1945_1656);
						   aux_3290 =
						      (object_bglt) (obj1588_1655);
						   OBJECT_WIDENING_SET(aux_3290, aux_3292);
						}
					     }
					     {	/* Inline/size.scm 61 */
						long arg1948_1658;
						arg1948_1658 =
						   class_num_218___object(sized_sequence_48_inline_size);
						{	/* Inline/size.scm 61 */
						   obj_t obj_2276;
						   obj_2276 =
						      (obj_t) (obj1588_1655);
						   (((obj_t) CREF(obj_2276))->header = MAKE_HEADER(arg1948_1658, 0), BUNSPEC);
						}
					     }
					     obj1588_1655;
					  }
					  aux_3284 = size_1650;
				       }
				     else
				       {	/* Inline/size.scm 63 */
					  obj_t arg1949_1659;
					  long arg1950_1660;
					  arg1949_1659 =
					     CDR(nodes_1649);
					  {	/* Inline/size.scm 64 */
					     long arg1951_1661;
					     {	/* Inline/size.scm 64 */
						node_bglt aux_3299;
						{	/* Inline/size.scm 64 */
						   obj_t aux_3300;
						   aux_3300 =
						      CAR(nodes_1649);
						   aux_3299 =
						      (node_bglt) (aux_3300);
						}
						arg1951_1661 =
						   node_size_119_inline_size(aux_3299);
					     }
					     arg1950_1660 =
						(size_1650 + arg1951_1661);
					  }
					  {
					     long size_3306;
					     obj_t nodes_3305;
					     nodes_3305 = arg1949_1659;
					     size_3306 = arg1950_1660;
					     size_1650 = size_3306;
					     nodes_1649 = nodes_3305;
					     goto loop_1651;
					  }
				       }
				     aux_3277 =
					BINT(aux_3284);
				  }
			       }
			    }
			    break;
			 case ((long) 4):

			    {	/* Inline/size.scm 70 */
			       sized_sequence_48_bglt node_1663;
			       node_1663 =
				  (sized_sequence_48_bglt) (node_1);
			       {	/* Inline/size.scm 18 */
				  long aux_3310;
				  {
				     obj_t aux_3311;
				     {	/* Inline/size.scm 18 */
					object_bglt aux_3312;
					aux_3312 =
					   (object_bglt) (node_1663);
					aux_3311 =
					   OBJECT_WIDENING(aux_3312);
				     }
				     aux_3310 =
					(((sized_sequence_48_bglt) CREF(aux_3311))->size);
				  }
				  aux_3277 =
				     BINT(aux_3310);
			       }
			    }
			    break;
			 case ((long) 5):

			    {	/* Inline/size.scm 76 */
			       app_bglt node_1664;
			       node_1664 =
				  (app_bglt) (node_1);
			       {
				  obj_t args_1665;
				  long size_1666;
				  {	/* Inline/size.scm 76 */
				     obj_t arg1953_1668;
				     long arg1954_1669;
				     arg1953_1668 =
					(((app_bglt) CREF(node_1664))->args);
				     {	/* Inline/size.scm 77 */
					node_bglt aux_3319;
					{	/* Inline/size.scm 77 */
					   var_bglt aux_3320;
					   aux_3320 =
					      (((app_bglt) CREF(node_1664))->fun);
					   aux_3319 =
					      (node_bglt) (aux_3320);
					}
					arg1954_1669 =
					   node_size_119_inline_size(aux_3319);
				     }
				     {	/* Inline/size.scm 76 */
					long aux_3324;
					args_1665 = arg1953_1668;
					size_1666 = arg1954_1669;
				      loop_1667:
					if (
					   NULLP(args_1665))
					  {	/* Inline/size.scm 78 */
					     {	/* Inline/size.scm 80 */
						sized_app_52_bglt obj1589_1672;
						obj1589_1672 =
						   ((sized_app_52_bglt) (node_1664));
						{	/* Inline/size.scm 80 */
						   sized_app_52_bglt arg1957_1673;
						   {	/* Inline/size.scm 80 */
						      sized_app_52_bglt res2095_2289;
						      {		/* Inline/size.scm 19 */
							 sized_app_52_bglt new1459_2287;
							 new1459_2287 =
							    ((sized_app_52_bglt) BREF(GC_MALLOC(sizeof(struct sized_app_52))));
							 ((((sized_app_52_bglt) CREF(new1459_2287))->size) = ((long) size_1666), BUNSPEC);
							 res2095_2289 = new1459_2287;
						      }
						      arg1957_1673 = res2095_2289;
						   }
						   {	/* Inline/size.scm 80 */
						      obj_t aux_3332;
						      object_bglt aux_3330;
						      aux_3332 =
							 (obj_t) (arg1957_1673);
						      aux_3330 =
							 (object_bglt) (obj1589_1672);
						      OBJECT_WIDENING_SET(aux_3330, aux_3332);
						   }
						}
						{	/* Inline/size.scm 80 */
						   long arg1959_1675;
						   arg1959_1675 =
						      class_num_218___object(sized_app_52_inline_size);
						   {	/* Inline/size.scm 80 */
						      obj_t obj_2290;
						      obj_2290 =
							 (obj_t) (obj1589_1672);
						      (((obj_t) CREF(obj_2290))->header = MAKE_HEADER(arg1959_1675, 0), BUNSPEC);
						   }
						}
						obj1589_1672;
					     }
					     aux_3324 = size_1666;
					  }
					else
					  {	/* Inline/size.scm 82 */
					     obj_t arg1960_1676;
					     long arg1961_1677;
					     arg1960_1676 =
						CDR(args_1665);
					     {	/* Inline/size.scm 83 */
						long arg1962_1678;
						{	/* Inline/size.scm 83 */
						   node_bglt aux_3339;
						   {	/* Inline/size.scm 83 */
						      obj_t aux_3340;
						      aux_3340 =
							 CAR(args_1665);
						      aux_3339 =
							 (node_bglt) (aux_3340);
						   }
						   arg1962_1678 =
						      node_size_119_inline_size(aux_3339);
						}
						arg1961_1677 =
						   (size_1666 + arg1962_1678);
					     }
					     {
						long size_3346;
						obj_t args_3345;
						args_3345 = arg1960_1676;
						size_3346 = arg1961_1677;
						size_1666 = size_3346;
						args_1665 = args_3345;
						goto loop_1667;
					     }
					  }
					aux_3277 =
					   BINT(aux_3324);
				     }
				  }
			       }
			    }
			    break;
			 case ((long) 6):

			    {	/* Inline/size.scm 89 */
			       sized_app_52_bglt node_1680;
			       node_1680 =
				  (sized_app_52_bglt) (node_1);
			       {	/* Inline/size.scm 19 */
				  long aux_3349;
				  {
				     obj_t aux_3350;
				     {	/* Inline/size.scm 19 */
					object_bglt aux_3351;
					aux_3351 =
					   (object_bglt) (node_1680);
					aux_3350 =
					   OBJECT_WIDENING(aux_3351);
				     }
				     aux_3349 =
					(((sized_app_52_bglt) CREF(aux_3350))->size);
				  }
				  aux_3277 =
				     BINT(aux_3349);
			       }
			    }
			    break;
			 case ((long) 7):

			    {	/* Inline/size.scm 95 */
			       app_ly_162_bglt node_1681;
			       node_1681 =
				  (app_ly_162_bglt) (node_1);
			       {	/* Inline/size.scm 95 */
				  long arg1965_1683;
				  {	/* Inline/size.scm 95 */
				     long arg1966_1684;
				     long arg1967_1685;
				     arg1966_1684 =
					node_size_119_inline_size(
					(((app_ly_162_bglt) CREF(node_1681))->fun));
				     arg1967_1685 =
					node_size_119_inline_size(
					(((app_ly_162_bglt) CREF(node_1681))->arg));
				     arg1965_1683 =
					(arg1966_1684 + arg1967_1685);
				  }
				  {	/* ./Ieee/fixnum.scm 7193 */
				     long aux_3362;
				     aux_3362 =
					(((long) 1) + arg1965_1683);
				     aux_3277 =
					BINT(aux_3362);
				  }
			       }
			    }
			    break;
			 case ((long) 8):

			    {	/* Inline/size.scm 101 */
			       funcall_bglt node_1688;
			       node_1688 =
				  (funcall_bglt) (node_1);
			       {
				  obj_t args_1689;
				  long size_1690;
				  {	/* Inline/size.scm 101 */
				     obj_t arg1970_1692;
				     long arg1971_1693;
				     arg1970_1692 =
					(((funcall_bglt) CREF(node_1688))->args);
				     arg1971_1693 =
					node_size_119_inline_size(
					(((funcall_bglt) CREF(node_1688))->fun));
				     {	/* Inline/size.scm 101 */
					long aux_3369;
					args_1689 = arg1970_1692;
					size_1690 = arg1971_1693;
				      loop_1691:
					if (
					   NULLP(args_1689))
					  {	/* Inline/size.scm 103 */
					     {	/* Inline/size.scm 105 */
						sized_funcall_46_bglt obj1590_1696;
						obj1590_1696 =
						   ((sized_funcall_46_bglt) (node_1688));
						{	/* Inline/size.scm 105 */
						   sized_funcall_46_bglt arg1974_1697;
						   {	/* Inline/size.scm 105 */
						      sized_funcall_46_bglt res2096_2309;
						      {		/* Inline/size.scm 20 */
							 sized_funcall_46_bglt new1475_2307;
							 new1475_2307 =
							    ((sized_funcall_46_bglt) BREF(GC_MALLOC(sizeof(struct sized_funcall_46))));
							 ((((sized_funcall_46_bglt) CREF(new1475_2307))->size) = ((long) size_1690), BUNSPEC);
							 res2096_2309 = new1475_2307;
						      }
						      arg1974_1697 = res2096_2309;
						   }
						   {	/* Inline/size.scm 105 */
						      obj_t aux_3377;
						      object_bglt aux_3375;
						      aux_3377 =
							 (obj_t) (arg1974_1697);
						      aux_3375 =
							 (object_bglt) (obj1590_1696);
						      OBJECT_WIDENING_SET(aux_3375, aux_3377);
						   }
						}
						{	/* Inline/size.scm 105 */
						   long arg1977_1699;
						   arg1977_1699 =
						      class_num_218___object(sized_funcall_46_inline_size);
						   {	/* Inline/size.scm 105 */
						      obj_t obj_2310;
						      obj_2310 =
							 (obj_t) (obj1590_1696);
						      (((obj_t) CREF(obj_2310))->header = MAKE_HEADER(arg1977_1699, 0), BUNSPEC);
						   }
						}
						obj1590_1696;
					     }
					     aux_3369 = size_1690;
					  }
					else
					  {	/* Inline/size.scm 107 */
					     obj_t arg1979_1700;
					     long arg1980_1701;
					     arg1979_1700 =
						CDR(args_1689);
					     {	/* Inline/size.scm 108 */
						long arg1981_1702;
						{	/* Inline/size.scm 108 */
						   node_bglt aux_3384;
						   {	/* Inline/size.scm 108 */
						      obj_t aux_3385;
						      aux_3385 =
							 CAR(args_1689);
						      aux_3384 =
							 (node_bglt) (aux_3385);
						   }
						   arg1981_1702 =
						      node_size_119_inline_size(aux_3384);
						}
						arg1980_1701 =
						   (size_1690 + arg1981_1702);
					     }
					     {
						long size_3391;
						obj_t args_3390;
						args_3390 = arg1979_1700;
						size_3391 = arg1980_1701;
						size_1690 = size_3391;
						args_1689 = args_3390;
						goto loop_1691;
					     }
					  }
					aux_3277 =
					   BINT(aux_3369);
				     }
				  }
			       }
			    }
			    break;
			 case ((long) 9):

			    {	/* Inline/size.scm 114 */
			       sized_funcall_46_bglt node_1704;
			       node_1704 =
				  (sized_funcall_46_bglt) (node_1);
			       {	/* Inline/size.scm 20 */
				  long aux_3394;
				  {
				     obj_t aux_3395;
				     {	/* Inline/size.scm 20 */
					object_bglt aux_3396;
					aux_3396 =
					   (object_bglt) (node_1704);
					aux_3395 =
					   OBJECT_WIDENING(aux_3396);
				     }
				     aux_3394 =
					(((sized_funcall_46_bglt) CREF(aux_3395))->size);
				  }
				  aux_3277 =
				     BINT(aux_3394);
			       }
			    }
			    break;
			 case ((long) 10):

			    {	/* Inline/size.scm 120 */
			       sized_pragma_213_bglt node_1705;
			       node_1705 =
				  (sized_pragma_213_bglt) (node_1);
			       {	/* Inline/size.scm 21 */
				  long aux_3402;
				  {
				     obj_t aux_3403;
				     {	/* Inline/size.scm 21 */
					object_bglt aux_3404;
					aux_3404 =
					   (object_bglt) (node_1705);
					aux_3403 =
					   OBJECT_WIDENING(aux_3404);
				     }
				     aux_3402 =
					(((sized_pragma_213_bglt) CREF(aux_3403))->size);
				  }
				  aux_3277 =
				     BINT(aux_3402);
			       }
			    }
			    break;
			 case ((long) 11):

			    {	/* Inline/size.scm 126 */
			       cast_bglt node_1706;
			       node_1706 =
				  (cast_bglt) (node_1);
			       {	/* Inline/size.scm 127 */
				  long aux_3410;
				  aux_3410 =
				     node_size_119_inline_size(
				     (((cast_bglt) CREF(node_1706))->arg));
				  aux_3277 =
				     BINT(aux_3410);
			       }
			    }
			    break;
			 case ((long) 12):

			    {	/* Inline/size.scm 133 */
			       pragma_bglt node_1709;
			       node_1709 =
				  (pragma_bglt) (node_1);
			       {
				  obj_t args_1710;
				  long size_1711;
				  {	/* Inline/size.scm 133 */
				     long aux_3415;
				     args_1710 =
					(((pragma_bglt) CREF(node_1709))->args);
				     size_1711 = ((long) 1);
				   loop_1712:
				     if (
					NULLP(args_1710))
				       {	/* Inline/size.scm 135 */
					  {	/* Inline/size.scm 137 */
					     sized_pragma_213_bglt obj1592_1716;
					     obj1592_1716 =
						((sized_pragma_213_bglt) (node_1709));
					     {	/* Inline/size.scm 137 */
						sized_pragma_213_bglt arg1987_1717;
						{	/* Inline/size.scm 137 */
						   sized_pragma_213_bglt res2097_2324;
						   {	/* Inline/size.scm 21 */
						      sized_pragma_213_bglt new1491_2322;
						      new1491_2322 =
							 ((sized_pragma_213_bglt) BREF(GC_MALLOC(sizeof(struct sized_pragma_213))));
						      ((((sized_pragma_213_bglt) CREF(new1491_2322))->size) = ((long) size_1711), BUNSPEC);
						      res2097_2324 = new1491_2322;
						   }
						   arg1987_1717 = res2097_2324;
						}
						{	/* Inline/size.scm 137 */
						   obj_t aux_3423;
						   object_bglt aux_3421;
						   aux_3423 =
						      (obj_t) (arg1987_1717);
						   aux_3421 =
						      (object_bglt) (obj1592_1716);
						   OBJECT_WIDENING_SET(aux_3421, aux_3423);
						}
					     }
					     {	/* Inline/size.scm 137 */
						long arg1989_1719;
						arg1989_1719 =
						   class_num_218___object(sized_pragma_213_inline_size);
						{	/* Inline/size.scm 137 */
						   obj_t obj_2325;
						   obj_2325 =
						      (obj_t) (obj1592_1716);
						   (((obj_t) CREF(obj_2325))->header = MAKE_HEADER(arg1989_1719, 0), BUNSPEC);
						}
					     }
					     obj1592_1716;
					  }
					  aux_3415 = size_1711;
				       }
				     else
				       {	/* Inline/size.scm 139 */
					  obj_t arg1990_1720;
					  long arg1991_1721;
					  arg1990_1720 =
					     CDR(args_1710);
					  {	/* Inline/size.scm 140 */
					     long arg1992_1722;
					     {	/* Inline/size.scm 140 */
						node_bglt aux_3430;
						{	/* Inline/size.scm 140 */
						   obj_t aux_3431;
						   aux_3431 =
						      CAR(args_1710);
						   aux_3430 =
						      (node_bglt) (aux_3431);
						}
						arg1992_1722 =
						   node_size_119_inline_size(aux_3430);
					     }
					     arg1991_1721 =
						(size_1711 + arg1992_1722);
					  }
					  {
					     long size_3437;
					     obj_t args_3436;
					     args_3436 = arg1990_1720;
					     size_3437 = arg1991_1721;
					     size_1711 = size_3437;
					     args_1710 = args_3436;
					     goto loop_1712;
					  }
				       }
				     aux_3277 =
					BINT(aux_3415);
				  }
			       }
			    }
			    break;
			 case ((long) 13):

			    {	/* Inline/size.scm 146 */
			       setq_bglt node_1724;
			       node_1724 =
				  (setq_bglt) (node_1);
			       {	/* Inline/size.scm 146 */
				  long arg1995_1726;
				  arg1995_1726 =
				     node_size_119_inline_size(
				     (((setq_bglt) CREF(node_1724))->value));
				  {	/* ./Ieee/fixnum.scm 7193 */
				     long aux_3443;
				     aux_3443 =
					(((long) 2) + arg1995_1726);
				     aux_3277 =
					BINT(aux_3443);
				  }
			       }
			    }
			    break;
			 case ((long) 14):

			    {	/* Inline/size.scm 152 */
			       conditional_bglt node_1728;
			       node_1728 =
				  (conditional_bglt) (node_1);
			       {	/* Inline/size.scm 152 */
				  long test_size_137_1729;
				  test_size_137_1729 =
				     node_size_119_inline_size(
				     (((conditional_bglt) CREF(node_1728))->test));
				  {	/* Inline/size.scm 152 */
				     long true_size_36_1730;
				     true_size_36_1730 =
					node_size_119_inline_size(
					(((conditional_bglt) CREF(node_1728))->true));
				     {	/* Inline/size.scm 153 */
					long false_size_136_1731;
					false_size_136_1731 =
					   node_size_119_inline_size(
					   (((conditional_bglt) CREF(node_1728))->false));
					{	/* Inline/size.scm 154 */
					   long size_1732;
					   {	/* ./Ieee/fixnum.scm 7193 */
					      long aux_3453;
					      {		/* ./Ieee/fixnum.scm 7193 */
						 long aux_3454;
						 aux_3454 =
						    (true_size_36_1730 + false_size_136_1731);
						 aux_3453 =
						    (test_size_137_1729 + aux_3454);
					      }
					      size_1732 =
						 (((long) 1) + aux_3453);
					   }
					   {	/* Inline/size.scm 155 */

					      {		/* Inline/size.scm 156 */
						 sized_conditional_152_bglt obj1593_1733;
						 obj1593_1733 =
						    ((sized_conditional_152_bglt) (node_1728));
						 {	/* Inline/size.scm 156 */
						    sized_conditional_152_bglt arg1997_1734;
						    {	/* Inline/size.scm 156 */
						       sized_conditional_152_bglt res2098_2346;
						       {	/* Inline/size.scm 22 */
							  sized_conditional_152_bglt new1509_2344;
							  new1509_2344 =
							     ((sized_conditional_152_bglt) BREF(GC_MALLOC(sizeof(struct sized_conditional_152))));
							  ((((sized_conditional_152_bglt) CREF(new1509_2344))->size) = ((long) size_1732), BUNSPEC);
							  res2098_2346 = new1509_2344;
						       }
						       arg1997_1734 = res2098_2346;
						    }
						    {	/* Inline/size.scm 156 */
						       obj_t aux_3463;
						       object_bglt aux_3461;
						       aux_3463 =
							  (obj_t) (arg1997_1734);
						       aux_3461 =
							  (object_bglt) (obj1593_1733);
						       OBJECT_WIDENING_SET(aux_3461, aux_3463);
						    }
						 }
						 {	/* Inline/size.scm 156 */
						    long arg1999_1736;
						    arg1999_1736 =
						       class_num_218___object(sized_conditional_152_inline_size);
						    {	/* Inline/size.scm 156 */
						       obj_t obj_2347;
						       obj_2347 =
							  (obj_t) (obj1593_1733);
						       (((obj_t) CREF(obj_2347))->header = MAKE_HEADER(arg1999_1736, 0), BUNSPEC);
						    }
						 }
						 obj1593_1733;
					      }
					      aux_3277 =
						 BINT(size_1732);
					   }
					}
				     }
				  }
			       }
			    }
			    break;
			 case ((long) 15):

			    {	/* Inline/size.scm 163 */
			       sized_conditional_152_bglt node_1743;
			       node_1743 =
				  (sized_conditional_152_bglt) (node_1);
			       {	/* Inline/size.scm 22 */
				  long aux_3471;
				  {
				     obj_t aux_3472;
				     {	/* Inline/size.scm 22 */
					object_bglt aux_3473;
					aux_3473 =
					   (object_bglt) (node_1743);
					aux_3472 =
					   OBJECT_WIDENING(aux_3473);
				     }
				     aux_3471 =
					(((sized_conditional_152_bglt) CREF(aux_3472))->size);
				  }
				  aux_3277 =
				     BINT(aux_3471);
			       }
			    }
			    break;
			 case ((long) 16):

			    {	/* Inline/size.scm 169 */
			       fail_bglt node_1744;
			       node_1744 =
				  (fail_bglt) (node_1);
			       {	/* Inline/size.scm 169 */
				  long proc_size_203_1745;
				  proc_size_203_1745 =
				     node_size_119_inline_size(
				     (((fail_bglt) CREF(node_1744))->proc));
				  {	/* Inline/size.scm 169 */
				     long msg_size_252_1746;
				     msg_size_252_1746 =
					node_size_119_inline_size(
					(((fail_bglt) CREF(node_1744))->msg));
				     {	/* Inline/size.scm 170 */
					long obj_size_35_1747;
					obj_size_35_1747 =
					   node_size_119_inline_size(
					   (((fail_bglt) CREF(node_1744))->obj));
					{	/* Inline/size.scm 171 */
					   long size_1748;
					   {	/* ./Ieee/fixnum.scm 7193 */
					      long aux_3485;
					      {		/* ./Ieee/fixnum.scm 7193 */
						 long aux_3486;
						 aux_3486 =
						    (msg_size_252_1746 + obj_size_35_1747);
						 aux_3485 =
						    (proc_size_203_1745 + aux_3486);
					      }
					      size_1748 =
						 (((long) 2) + aux_3485);
					   }
					   {	/* Inline/size.scm 172 */

					      {		/* Inline/size.scm 173 */
						 sized_fail_63_bglt obj1594_1749;
						 obj1594_1749 =
						    ((sized_fail_63_bglt) (node_1744));
						 {	/* Inline/size.scm 173 */
						    sized_fail_63_bglt arg2006_1750;
						    {	/* Inline/size.scm 173 */
						       sized_fail_63_bglt res2099_2362;
						       {	/* Inline/size.scm 23 */
							  sized_fail_63_bglt new1525_2360;
							  new1525_2360 =
							     ((sized_fail_63_bglt) BREF(GC_MALLOC(sizeof(struct sized_fail_63))));
							  ((((sized_fail_63_bglt) CREF(new1525_2360))->size) = ((long) size_1748), BUNSPEC);
							  res2099_2362 = new1525_2360;
						       }
						       arg2006_1750 = res2099_2362;
						    }
						    {	/* Inline/size.scm 173 */
						       obj_t aux_3495;
						       object_bglt aux_3493;
						       aux_3495 =
							  (obj_t) (arg2006_1750);
						       aux_3493 =
							  (object_bglt) (obj1594_1749);
						       OBJECT_WIDENING_SET(aux_3493, aux_3495);
						    }
						 }
						 {	/* Inline/size.scm 173 */
						    long arg2008_1752;
						    arg2008_1752 =
						       class_num_218___object(sized_fail_63_inline_size);
						    {	/* Inline/size.scm 173 */
						       obj_t obj_2363;
						       obj_2363 =
							  (obj_t) (obj1594_1749);
						       (((obj_t) CREF(obj_2363))->header = MAKE_HEADER(arg2008_1752, 0), BUNSPEC);
						    }
						 }
						 obj1594_1749;
					      }
					      aux_3277 =
						 BINT(size_1748);
					   }
					}
				     }
				  }
			       }
			    }
			    break;
			 case ((long) 17):

			    {	/* Inline/size.scm 180 */
			       sized_fail_63_bglt node_1759;
			       node_1759 =
				  (sized_fail_63_bglt) (node_1);
			       {	/* Inline/size.scm 23 */
				  long aux_3503;
				  {
				     obj_t aux_3504;
				     {	/* Inline/size.scm 23 */
					object_bglt aux_3505;
					aux_3505 =
					   (object_bglt) (node_1759);
					aux_3504 =
					   OBJECT_WIDENING(aux_3505);
				     }
				     aux_3503 =
					(((sized_fail_63_bglt) CREF(aux_3504))->size);
				  }
				  aux_3277 =
				     BINT(aux_3503);
			       }
			    }
			    break;
			 case ((long) 18):

			    {	/* Inline/size.scm 186 */
			       select_bglt node_1760;
			       node_1760 =
				  (select_bglt) (node_1);
			       {
				  obj_t clauses_1761;
				  long size_1762;
				  {	/* Inline/size.scm 186 */
				     obj_t arg2015_1764;
				     long arg2016_1765;
				     arg2015_1764 =
					(((select_bglt) CREF(node_1760))->clauses);
				     {	/* Inline/size.scm 187 */
					long arg2018_1767;
					arg2018_1767 =
					   node_size_119_inline_size(
					   (((select_bglt) CREF(node_1760))->test));
					arg2016_1765 =
					   (((long) 1) + arg2018_1767);
				     }
				     {	/* Inline/size.scm 186 */
					long aux_3515;
					clauses_1761 = arg2015_1764;
					size_1762 = arg2016_1765;
				      loop_1763:
					if (
					   NULLP(clauses_1761))
					  {	/* Inline/size.scm 188 */
					     {	/* Inline/size.scm 190 */
						sized_select_166_bglt obj1595_1770;
						obj1595_1770 =
						   ((sized_select_166_bglt) (node_1760));
						{	/* Inline/size.scm 190 */
						   sized_select_166_bglt arg2021_1771;
						   {	/* Inline/size.scm 190 */
						      sized_select_166_bglt res2100_2374;
						      {		/* Inline/size.scm 24 */
							 sized_select_166_bglt new1541_2372;
							 new1541_2372 =
							    ((sized_select_166_bglt) BREF(GC_MALLOC(sizeof(struct sized_select_166))));
							 ((((sized_select_166_bglt) CREF(new1541_2372))->size) = ((long) size_1762), BUNSPEC);
							 res2100_2374 = new1541_2372;
						      }
						      arg2021_1771 = res2100_2374;
						   }
						   {	/* Inline/size.scm 190 */
						      obj_t aux_3523;
						      object_bglt aux_3521;
						      aux_3523 =
							 (obj_t) (arg2021_1771);
						      aux_3521 =
							 (object_bglt) (obj1595_1770);
						      OBJECT_WIDENING_SET(aux_3521, aux_3523);
						   }
						}
						{	/* Inline/size.scm 190 */
						   long arg2023_1773;
						   arg2023_1773 =
						      class_num_218___object(sized_select_166_inline_size);
						   {	/* Inline/size.scm 190 */
						      obj_t obj_2375;
						      obj_2375 =
							 (obj_t) (obj1595_1770);
						      (((obj_t) CREF(obj_2375))->header = MAKE_HEADER(arg2023_1773, 0), BUNSPEC);
						   }
						}
						obj1595_1770;
					     }
					     aux_3515 = size_1762;
					  }
					else
					  {	/* Inline/size.scm 192 */
					     obj_t arg2024_1774;
					     long arg2025_1775;
					     arg2024_1774 =
						CDR(clauses_1761);
					     {	/* Inline/size.scm 193 */
						long arg2026_1776;
						{	/* Inline/size.scm 193 */
						   long arg2027_1777;
						   long arg2028_1778;
						   {	/* Inline/size.scm 193 */
						      bool_t test_3530;
						      {		/* ./Ieee/pair-list.scm 5669 */
							 obj_t aux_3531;
							 {	/* ./Ieee/pair-list.scm 5701 */
							    obj_t aux_3532;
							    aux_3532 =
							       CAR(clauses_1761);
							    aux_3531 =
							       CAR(aux_3532);
							 }
							 test_3530 =
							    PAIRP(aux_3531);
						      }
						      if (test_3530)
							{	/* Inline/size.scm 194 */
							   obj_t aux_3536;
							   {	/* ./Ieee/pair-list.scm 5701 */
							      obj_t aux_3537;
							      aux_3537 =
								 CAR(clauses_1761);
							      aux_3536 =
								 CAR(aux_3537);
							   }
							   arg2027_1777 =
							      list_length(aux_3536);
							}
						      else
							{	/* Inline/size.scm 193 */
							   arg2027_1777 = ((long) 1);
							}
						   }
						   {	/* Inline/size.scm 196 */
						      node_bglt aux_3541;
						      {		/* Inline/size.scm 196 */
							 obj_t aux_3542;
							 {	/* ./Ieee/pair-list.scm 5707 */
							    obj_t aux_3543;
							    aux_3543 =
							       CAR(clauses_1761);
							    aux_3542 =
							       CDR(aux_3543);
							 }
							 aux_3541 =
							    (node_bglt) (aux_3542);
						      }
						      arg2028_1778 =
							 node_size_119_inline_size(aux_3541);
						   }
						   arg2026_1776 =
						      (arg2027_1777 + arg2028_1778);
						}
						arg2025_1775 =
						   (size_1762 + arg2026_1776);
					     }
					     {
						long size_3551;
						obj_t clauses_3550;
						clauses_3550 = arg2024_1774;
						size_3551 = arg2025_1775;
						size_1762 = size_3551;
						clauses_1761 = clauses_3550;
						goto loop_1763;
					     }
					  }
					aux_3277 =
					   BINT(aux_3515);
				     }
				  }
			       }
			    }
			    break;
			 case ((long) 19):

			    {	/* Inline/size.scm 202 */
			       sized_select_166_bglt node_1786;
			       node_1786 =
				  (sized_select_166_bglt) (node_1);
			       {	/* Inline/size.scm 24 */
				  long aux_3554;
				  {
				     obj_t aux_3555;
				     {	/* Inline/size.scm 24 */
					object_bglt aux_3556;
					aux_3556 =
					   (object_bglt) (node_1786);
					aux_3555 =
					   OBJECT_WIDENING(aux_3556);
				     }
				     aux_3554 =
					(((sized_select_166_bglt) CREF(aux_3555))->size);
				  }
				  aux_3277 =
				     BINT(aux_3554);
			       }
			    }
			    break;
			 case ((long) 20):

			    {	/* Inline/size.scm 208 */
			       let_fun_218_bglt node_1787;
			       node_1787 =
				  (let_fun_218_bglt) (node_1);
			       {
				  obj_t locals_1788;
				  long size_1789;
				  {	/* Inline/size.scm 208 */
				     obj_t arg2036_1791;
				     long arg2037_1792;
				     arg2036_1791 =
					(((let_fun_218_bglt) CREF(node_1787))->locals);
				     {	/* Inline/size.scm 209 */
					long arg2038_1793;
					long arg2039_1794;
					arg2038_1793 =
					   list_length(
					   (((let_fun_218_bglt) CREF(node_1787))->locals));
					arg2039_1794 =
					   node_size_119_inline_size(
					   (((let_fun_218_bglt) CREF(node_1787))->body));
					arg2037_1792 =
					   (arg2038_1793 + arg2039_1794);
				     }
				     {	/* Inline/size.scm 208 */
					long aux_3568;
					locals_1788 = arg2036_1791;
					size_1789 = arg2037_1792;
				      loop_1790:
					if (
					   NULLP(locals_1788))
					  {	/* Inline/size.scm 211 */
					     {	/* Inline/size.scm 213 */
						sized_let_fun_188_bglt obj1596_1798;
						obj1596_1798 =
						   ((sized_let_fun_188_bglt) (node_1787));
						{	/* Inline/size.scm 213 */
						   sized_let_fun_188_bglt arg2043_1799;
						   {	/* Inline/size.scm 213 */
						      sized_let_fun_188_bglt res2101_2399;
						      {		/* Inline/size.scm 25 */
							 sized_let_fun_188_bglt new1558_2397;
							 new1558_2397 =
							    ((sized_let_fun_188_bglt) BREF(GC_MALLOC(sizeof(struct sized_let_fun_188))));
							 ((((sized_let_fun_188_bglt) CREF(new1558_2397))->size) = ((long) size_1789), BUNSPEC);
							 res2101_2399 = new1558_2397;
						      }
						      arg2043_1799 = res2101_2399;
						   }
						   {	/* Inline/size.scm 213 */
						      obj_t aux_3576;
						      object_bglt aux_3574;
						      aux_3576 =
							 (obj_t) (arg2043_1799);
						      aux_3574 =
							 (object_bglt) (obj1596_1798);
						      OBJECT_WIDENING_SET(aux_3574, aux_3576);
						   }
						}
						{	/* Inline/size.scm 213 */
						   long arg2045_1801;
						   arg2045_1801 =
						      class_num_218___object(sized_let_fun_188_inline_size);
						   {	/* Inline/size.scm 213 */
						      obj_t obj_2400;
						      obj_2400 =
							 (obj_t) (obj1596_1798);
						      (((obj_t) CREF(obj_2400))->header = MAKE_HEADER(arg2045_1801, 0), BUNSPEC);
						   }
						}
						obj1596_1798;
					     }
					     aux_3568 = size_1789;
					  }
					else
					  {	/* Inline/size.scm 215 */
					     obj_t arg2046_1802;
					     long arg2047_1803;
					     arg2046_1802 =
						CDR(locals_1788);
					     {	/* Inline/size.scm 217 */
						long arg2048_1804;
						{	/* Inline/size.scm 217 */
						   node_bglt aux_3583;
						   {	/* Inline/size.scm 217 */
						      obj_t aux_3584;
						      {		/* Inline/size.scm 217 */
							 sfun_bglt obj_2405;
							 {	/* Inline/size.scm 217 */
							    value_bglt aux_3585;
							    {	/* Inline/size.scm 217 */
							       local_bglt obj_2404;
							       {	/* Inline/size.scm 217 */
								  obj_t aux_3586;
								  aux_3586 =
								     CAR(locals_1788);
								  obj_2404 =
								     (local_bglt) (aux_3586);
							       }
							       aux_3585 =
								  (((local_bglt) CREF(obj_2404))->value);
							    }
							    obj_2405 =
							       (sfun_bglt) (aux_3585);
							 }
							 aux_3584 =
							    (((sfun_bglt) CREF(obj_2405))->body);
						      }
						      aux_3583 =
							 (node_bglt) (aux_3584);
						   }
						   arg2048_1804 =
						      node_size_119_inline_size(aux_3583);
						}
						arg2047_1803 =
						   (size_1789 + arg2048_1804);
					     }
					     {
						long size_3596;
						obj_t locals_3595;
						locals_3595 = arg2046_1802;
						size_3596 = arg2047_1803;
						size_1789 = size_3596;
						locals_1788 = locals_3595;
						goto loop_1790;
					     }
					  }
					aux_3277 =
					   BINT(aux_3568);
				     }
				  }
			       }
			    }
			    break;
			 case ((long) 21):

			    {	/* Inline/size.scm 223 */
			       sized_let_fun_188_bglt node_1808;
			       node_1808 =
				  (sized_let_fun_188_bglt) (node_1);
			       {	/* Inline/size.scm 25 */
				  long aux_3599;
				  {
				     obj_t aux_3600;
				     {	/* Inline/size.scm 25 */
					object_bglt aux_3601;
					aux_3601 =
					   (object_bglt) (node_1808);
					aux_3600 =
					   OBJECT_WIDENING(aux_3601);
				     }
				     aux_3599 =
					(((sized_let_fun_188_bglt) CREF(aux_3600))->size);
				  }
				  aux_3277 =
				     BINT(aux_3599);
			       }
			    }
			    break;
			 case ((long) 22):

			    {	/* Inline/size.scm 229 */
			       let_var_6_bglt node_1809;
			       node_1809 =
				  (let_var_6_bglt) (node_1);
			       {
				  obj_t bindings_1810;
				  long size_1811;
				  {	/* Inline/size.scm 229 */
				     obj_t arg2052_1813;
				     long arg2053_1814;
				     arg2052_1813 =
					(((let_var_6_bglt) CREF(node_1809))->bindings);
				     arg2053_1814 =
					node_size_119_inline_size(
					(((let_var_6_bglt) CREF(node_1809))->body));
				     {	/* Inline/size.scm 229 */
					long aux_3610;
					bindings_1810 = arg2052_1813;
					size_1811 = arg2053_1814;
				      loop_1812:
					if (
					   NULLP(bindings_1810))
					  {	/* Inline/size.scm 231 */
					     {	/* Inline/size.scm 233 */
						sized_let_var_54_bglt obj1598_1817;
						obj1598_1817 =
						   ((sized_let_var_54_bglt) (node_1809));
						{	/* Inline/size.scm 233 */
						   sized_let_var_54_bglt arg2056_1818;
						   {	/* Inline/size.scm 233 */
						      sized_let_var_54_bglt res2102_2415;
						      {		/* Inline/size.scm 26 */
							 sized_let_var_54_bglt new1576_2413;
							 new1576_2413 =
							    ((sized_let_var_54_bglt) BREF(GC_MALLOC(sizeof(struct sized_let_var_54))));
							 ((((sized_let_var_54_bglt) CREF(new1576_2413))->size) = ((long) size_1811), BUNSPEC);
							 res2102_2415 = new1576_2413;
						      }
						      arg2056_1818 = res2102_2415;
						   }
						   {	/* Inline/size.scm 233 */
						      obj_t aux_3618;
						      object_bglt aux_3616;
						      aux_3618 =
							 (obj_t) (arg2056_1818);
						      aux_3616 =
							 (object_bglt) (obj1598_1817);
						      OBJECT_WIDENING_SET(aux_3616, aux_3618);
						   }
						}
						{	/* Inline/size.scm 233 */
						   long arg2058_1820;
						   arg2058_1820 =
						      class_num_218___object(sized_let_var_54_inline_size);
						   {	/* Inline/size.scm 233 */
						      obj_t obj_2416;
						      obj_2416 =
							 (obj_t) (obj1598_1817);
						      (((obj_t) CREF(obj_2416))->header = MAKE_HEADER(arg2058_1820, 0), BUNSPEC);
						   }
						}
						obj1598_1817;
					     }
					     aux_3610 = size_1811;
					  }
					else
					  {	/* Inline/size.scm 235 */
					     obj_t arg2059_1821;
					     long arg2060_1822;
					     arg2059_1821 =
						CDR(bindings_1810);
					     {	/* Inline/size.scm 236 */
						long arg2061_1823;
						{	/* Inline/size.scm 236 */
						   node_bglt aux_3625;
						   {	/* Inline/size.scm 236 */
						      obj_t aux_3626;
						      {		/* ./Ieee/pair-list.scm 5707 */
							 obj_t aux_3627;
							 aux_3627 =
							    CAR(bindings_1810);
							 aux_3626 =
							    CDR(aux_3627);
						      }
						      aux_3625 =
							 (node_bglt) (aux_3626);
						   }
						   arg2061_1823 =
						      node_size_119_inline_size(aux_3625);
						}
						arg2060_1822 =
						   (size_1811 + arg2061_1823);
					     }
					     {
						long size_3634;
						obj_t bindings_3633;
						bindings_3633 = arg2059_1821;
						size_3634 = arg2060_1822;
						size_1811 = size_3634;
						bindings_1810 = bindings_3633;
						goto loop_1812;
					     }
					  }
					aux_3277 =
					   BINT(aux_3610);
				     }
				  }
			       }
			    }
			    break;
			 case ((long) 23):

			    {	/* Inline/size.scm 242 */
			       sized_let_var_54_bglt node_1826;
			       node_1826 =
				  (sized_let_var_54_bglt) (node_1);
			       {	/* Inline/size.scm 26 */
				  long aux_3637;
				  {
				     obj_t aux_3638;
				     {	/* Inline/size.scm 26 */
					object_bglt aux_3639;
					aux_3639 =
					   (object_bglt) (node_1826);
					aux_3638 =
					   OBJECT_WIDENING(aux_3639);
				     }
				     aux_3637 =
					(((sized_let_var_54_bglt) CREF(aux_3638))->size);
				  }
				  aux_3277 =
				     BINT(aux_3637);
			       }
			    }
			    break;
			 case ((long) 24):

			    {	/* Inline/size.scm 248 */
			       set_ex_it_116_bglt node_1827;
			       node_1827 =
				  (set_ex_it_116_bglt) (node_1);
			       {	/* Inline/size.scm 248 */
				  long arg2065_1829;
				  arg2065_1829 =
				     node_size_119_inline_size(
				     (((set_ex_it_116_bglt) CREF(node_1827))->body));
				  {	/* ./Ieee/fixnum.scm 7193 */
				     long aux_3647;
				     aux_3647 =
					(((long) 2) + arg2065_1829);
				     aux_3277 =
					BINT(aux_3647);
				  }
			       }
			    }
			    break;
			 case ((long) 25):

			    {	/* Inline/size.scm 254 */
			       jump_ex_it_184_bglt node_1831;
			       node_1831 =
				  (jump_ex_it_184_bglt) (node_1);
			       {	/* Inline/size.scm 254 */
				  long arg2068_1833;
				  {	/* Inline/size.scm 255 */
				     long arg2069_1834;
				     long arg2070_1835;
				     arg2069_1834 =
					node_size_119_inline_size(
					(((jump_ex_it_184_bglt) CREF(node_1831))->exit));
				     arg2070_1835 =
					node_size_119_inline_size(
					(((jump_ex_it_184_bglt) CREF(node_1831))->value));
				     arg2068_1833 =
					(arg2069_1834 + arg2070_1835);
				  }
				  {	/* ./Ieee/fixnum.scm 7193 */
				     long aux_3656;
				     aux_3656 =
					(((long) 1) + arg2068_1833);
				     aux_3277 =
					BINT(aux_3656);
				  }
			       }
			    }
			    break;
			 case ((long) 26):

			    {	/* Inline/size.scm 262 */
			       make_box_202_bglt node_1838;
			       node_1838 =
				  (make_box_202_bglt) (node_1);
			       {	/* Inline/size.scm 262 */
				  long arg2074_1840;
				  arg2074_1840 =
				     node_size_119_inline_size(
				     (((make_box_202_bglt) CREF(node_1838))->value));
				  {	/* ./Ieee/fixnum.scm 7193 */
				     long aux_3662;
				     aux_3662 =
					(((long) 1) + arg2074_1840);
				     aux_3277 =
					BINT(aux_3662);
				  }
			       }
			    }
			    break;
			 case ((long) 27):

			    aux_3277 =
			       BINT(((long) 2));
			    break;
			 case ((long) 28):

			    {	/* Inline/size.scm 274 */
			       box_set__221_bglt node_1843;
			       node_1843 =
				  (box_set__221_bglt) (node_1);
			       {	/* Inline/size.scm 274 */
				  long arg2078_1845;
				  arg2078_1845 =
				     node_size_119_inline_size(
				     (((box_set__221_bglt) CREF(node_1843))->value));
				  {	/* ./Ieee/fixnum.scm 7193 */
				     long aux_3669;
				     aux_3669 =
					(((long) 2) + arg2078_1845);
				     aux_3277 =
					BINT(aux_3669);
				  }
			       }
			    }
			    break;
			 default:
			  case_else1936_1642:
			    if (
			       PROCEDUREP(method1930_1638))
			      {		/* Inline/size.scm 33 */
				 aux_3277 =
				    PROCEDURE_ENTRY(method1930_1638) (method1930_1638,
				    (obj_t) (node_1), BEOA)
				    ;
			      }
			    else
			      {		/* Inline/size.scm 33 */
				 obj_t fun1929_1634;
				 fun1929_1634 =
				    PROCEDURE_REF(node_size_env_51_inline_size, ((long) 0));
				 aux_3277 =
				    PROCEDURE_ENTRY(fun1929_1634) (fun1929_1634,
				    (obj_t) (node_1), BEOA);
			      }
			 }
		    }
		  else
		    {	/* Inline/size.scm 33 */
		       goto case_else1936_1642;
		    }
	       }
	       return
		  (long) CINT(aux_3277);
	    }
	 }
      }
   }
}



/* _node-size */
obj_t 
_node_size_132_inline_size(obj_t env_2521, obj_t node_2522)
{
   AN_OBJECT;
   {	/* Inline/size.scm 33 */
      {		/* Inline/size.scm 33 */
	 long aux_3684;
	 aux_3684 =
	    node_size_119_inline_size(
	    (node_bglt) (node_2522));
	 return
	    BINT(aux_3684);
      }
   }
}



/* node-size-default1608 */
long 
node_size_default1608_243_inline_size(node_bglt node_2)
{
   AN_OBJECT;
   {	/* Inline/size.scm 14 */
      FAILURE(
	 CNST_TABLE_REF(((long) 9)), string2125_inline_size,
	 (obj_t) (node_2));
   }
}



/* _node-size-default1608 */
obj_t 
_node_size_default1608_24_inline_size(obj_t env_2523, obj_t node_2524)
{
   AN_OBJECT;
   {	/* Inline/size.scm 14 */
      {		/* Inline/size.scm 14 */
	 long aux_3691;
	 aux_3691 =
	    node_size_default1608_243_inline_size(
	    (node_bglt) (node_2524));
	 return
	    BINT(aux_3691);
      }
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_inline_size()
{
   AN_OBJECT;
   {	/* Inline/size.scm 14 */
      module_initialization_70_type_type(((long) 0), "INLINE_SIZE");
      module_initialization_70_ast_var(((long) 0), "INLINE_SIZE");
      return
	 module_initialization_70_ast_node(((long) 0), "INLINE_SIZE");
   }
}
