/*===========================================================================*/
/*   (Inline/variant.scm)                                                    */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;

typedef struct local_variant_63
  {
     bool_t variant;
  }
                *local_variant_63_bglt;


static obj_t _local_variant_type_159_inline_variant(obj_t, obj_t);
static obj_t method_init_76_inline_variant();
extern obj_t local_variant_name_14_inline_variant(local_bglt);
static obj_t _local_variant_variant_set__191_inline_variant(obj_t, obj_t, obj_t);
extern obj_t local_variant_access_set__216_inline_variant(local_bglt, obj_t);
static obj_t _local_variant_removable_217_inline_variant(obj_t, obj_t);
static obj_t _local_variant_removable_set__119_inline_variant(obj_t, obj_t, obj_t);
extern obj_t var_ast_node;
static obj_t _remove_invariant_args__205_inline_variant(obj_t, obj_t);
extern obj_t local_variant_fast_alpha_set__19_inline_variant(local_bglt, obj_t);
static obj_t _local_variant_type_set__203_inline_variant(obj_t, obj_t, obj_t);
static obj_t _local_variant_value_97_inline_variant(obj_t, obj_t);
extern object_bglt struct_object__object_93___object(object_bglt, obj_t);
extern obj_t add_method__1___object(obj_t, obj_t, obj_t);
extern obj_t find_super_class_method_167___object(object_bglt, obj_t, obj_t);
extern obj_t local_variant_access_191_inline_variant(local_bglt);
static obj_t _make_local_variant_201_inline_variant(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t _widening_local_variant_102_inline_variant(obj_t, obj_t);
static obj_t _local_variant_occurrence_set__31_inline_variant(obj_t, obj_t, obj_t);
extern bool_t is_a__118___object(obj_t, obj_t);
static obj_t struct_object__object_local_variant1475_65_inline_variant(obj_t, obj_t, obj_t);
static obj_t _substitutions_inline_variant(obj_t, obj_t, obj_t, obj_t);
extern obj_t module_initialization_70_inline_variant(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t local_variant_variant_set__103_inline_variant(local_variant_63_bglt, bool_t);
static obj_t _local_variant_user__set__250_inline_variant(obj_t, obj_t, obj_t);
extern obj_t shrink_args__237_inline_variant(variable_bglt);
static obj_t _local_variant_name_set__17_inline_variant(obj_t, obj_t, obj_t);
static obj_t _local_variant_variant_49_inline_variant(obj_t, obj_t);
extern long class_num_218___object(obj_t);
static obj_t _local_variant_occurrence_135_inline_variant(obj_t, obj_t);
extern value_bglt local_variant_value_31_inline_variant(local_bglt);
static obj_t imported_modules_init_94_inline_variant();
extern obj_t local_variant_user__set__143_inline_variant(local_bglt, bool_t);
extern type_bglt local_variant_type_2_inline_variant(local_bglt);
static obj_t _invariant_args_88_inline_variant(obj_t, obj_t, obj_t);
extern local_bglt allocate_local_variant_108_inline_variant();
static obj_t _local_variant__184_inline_variant(obj_t, obj_t);
static obj_t library_modules_init_112_inline_variant();
extern obj_t local_variant_removable_17_inline_variant(local_bglt);
extern obj_t local_variant_occurrence_set__206_inline_variant(local_bglt, long);
extern obj_t make_struct(obj_t, long, obj_t);
static obj_t _local_variant_name_117_inline_variant(obj_t, obj_t);
extern obj_t variant_args_126_inline_variant(variable_bglt);
extern long local_variant_occurrence_19_inline_variant(local_bglt);
static obj_t _local_variant_access_set__197_inline_variant(obj_t, obj_t, obj_t);
static obj_t _shrink_args__107_inline_variant(obj_t, obj_t);
extern obj_t create_vector(long);
extern obj_t open_input_string(obj_t);
extern obj_t local_variant_type_set__179_inline_variant(local_bglt, type_bglt);
extern app_bglt remove_invariant_args__113_inline_variant(app_bglt);
static obj_t _local_variant_value_set__43_inline_variant(obj_t, obj_t, obj_t);
static obj_t _local_variant_id_32_inline_variant(obj_t, obj_t);
static obj_t _local_variant_fast_alpha_53_inline_variant(obj_t, obj_t);
static obj_t _local_variant_key_59_inline_variant(obj_t, obj_t);
extern obj_t invariant_args_254_inline_variant(variable_bglt, obj_t);
extern local_variant_63_bglt make_local_variant_132_inline_variant(obj_t, obj_t, type_bglt, value_bglt, obj_t, obj_t, obj_t, long, bool_t, long, bool_t);
extern obj_t local_ast_var;
static obj_t _local_variant_user__212_inline_variant(obj_t, obj_t);
extern long local_variant_key_71_inline_variant(local_bglt);
extern bool_t local_variant_variant_215_inline_variant(local_variant_63_bglt);
extern bool_t local_variant__1_inline_variant(obj_t);
static obj_t object__struct_local_variant1473_69_inline_variant(obj_t, obj_t);
extern local_variant_63_bglt widening_local_variant_142_inline_variant(bool_t);
extern obj_t substitutions_inline_variant(variable_bglt, obj_t, obj_t);
extern obj_t register_class__225___object(obj_t, obj_t, obj_t, long, obj_t, obj_t, obj_t);
extern obj_t local_variant_id_153_inline_variant(local_bglt);
extern obj_t local_variant_name_set__245_inline_variant(local_bglt, obj_t);
static obj_t object_init_111_inline_variant();
extern obj_t local_variant_value_set__67_inline_variant(local_bglt, value_bglt);
extern obj_t local_variant_fast_alpha_32_inline_variant(local_bglt);
static obj_t _local_variant_fast_alpha_set__238_inline_variant(obj_t, obj_t, obj_t);
static obj_t _variant_args_237_inline_variant(obj_t, obj_t);
extern obj_t _classes__134___object;
extern obj_t read___reader(obj_t);
extern obj_t local_variant_removable_set__23_inline_variant(local_bglt, obj_t);
extern obj_t object__struct_50___object(object_bglt);
static obj_t require_initialization_114_inline_variant = BUNSPEC;
static obj_t _local_variant_access_113_inline_variant(obj_t, obj_t);
extern obj_t class_super_145___object(obj_t);
extern bool_t local_variant_user__42_inline_variant(local_bglt);
obj_t local_variant_63_inline_variant = BUNSPEC;
static obj_t cnst_init_137_inline_variant();
extern obj_t reverse__39___r4_pairs_and_lists_6_3(obj_t);
static obj_t _allocate_local_variant_45_inline_variant(obj_t);
static obj_t __cnst[3];

DEFINE_EXPORT_PROCEDURE(variant_args_env_178_inline_variant, _variant_args_237_inline_variant1672, _variant_args_237_inline_variant, 0L, 1);
DEFINE_EXPORT_PROCEDURE(local_variant_access_env_2_inline_variant, _local_variant_access_113_inline_variant1673, _local_variant_access_113_inline_variant, 0L, 1);
DEFINE_EXPORT_PROCEDURE(local_variant_fast_alpha_env_250_inline_variant, _local_variant_fast_alpha_53_inline_variant1674, _local_variant_fast_alpha_53_inline_variant, 0L, 1);
DEFINE_EXPORT_PROCEDURE(local_variant_name_set__env_113_inline_variant, _local_variant_name_set__17_inline_variant1675, _local_variant_name_set__17_inline_variant, 0L, 2);
DEFINE_EXPORT_PROCEDURE(local_variant_variant_env_167_inline_variant, _local_variant_variant_49_inline_variant1676, _local_variant_variant_49_inline_variant, 0L, 1);
DEFINE_EXPORT_PROCEDURE(local_variant_user__env_73_inline_variant, _local_variant_user__212_inline_variant1677, _local_variant_user__212_inline_variant, 0L, 1);
DEFINE_EXPORT_PROCEDURE(local_variant_id_env_216_inline_variant, _local_variant_id_32_inline_variant1678, _local_variant_id_32_inline_variant, 0L, 1);
DEFINE_EXPORT_PROCEDURE(local_variant_removable_env_195_inline_variant, _local_variant_removable_217_inline_variant1679, _local_variant_removable_217_inline_variant, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc1665_inline_variant, struct_object__object_local_variant1475_65_inline_variant1680, struct_object__object_local_variant1475_65_inline_variant, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc1664_inline_variant, object__struct_local_variant1473_69_inline_variant1681, object__struct_local_variant1473_69_inline_variant, 0L, 1);
extern obj_t struct_object__object_env_209___object;
DEFINE_EXPORT_PROCEDURE(local_variant_type_set__env_112_inline_variant, _local_variant_type_set__203_inline_variant1682, _local_variant_type_set__203_inline_variant, 0L, 2);
DEFINE_EXPORT_PROCEDURE(local_variant_name_env_225_inline_variant, _local_variant_name_117_inline_variant1683, _local_variant_name_117_inline_variant, 0L, 1);
DEFINE_EXPORT_PROCEDURE(local_variant_value_set__env_109_inline_variant, _local_variant_value_set__43_inline_variant1684, _local_variant_value_set__43_inline_variant, 0L, 2);
DEFINE_EXPORT_PROCEDURE(local_variant_value_env_99_inline_variant, _local_variant_value_97_inline_variant1685, _local_variant_value_97_inline_variant, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_local_variant_env_104_inline_variant, _make_local_variant_201_inline_variant1686, _make_local_variant_201_inline_variant, 0L, 11);
DEFINE_EXPORT_PROCEDURE(local_variant_access_set__env_213_inline_variant, _local_variant_access_set__197_inline_variant1687, _local_variant_access_set__197_inline_variant, 0L, 2);
DEFINE_EXPORT_PROCEDURE(allocate_local_variant_env_26_inline_variant, _allocate_local_variant_45_inline_variant1688, _allocate_local_variant_45_inline_variant, 0L, 0);
DEFINE_EXPORT_PROCEDURE(local_variant_occurrence_set__env_227_inline_variant, _local_variant_occurrence_set__31_inline_variant1689, _local_variant_occurrence_set__31_inline_variant, 0L, 2);
DEFINE_EXPORT_PROCEDURE(substitutions_env_195_inline_variant, _substitutions_inline_variant1690, _substitutions_inline_variant, 0L, 3);
DEFINE_EXPORT_PROCEDURE(remove_invariant_args__env_39_inline_variant, _remove_invariant_args__205_inline_variant1691, _remove_invariant_args__205_inline_variant, 0L, 1);
DEFINE_EXPORT_PROCEDURE(local_variant_fast_alpha_set__env_102_inline_variant, _local_variant_fast_alpha_set__238_inline_variant1692, _local_variant_fast_alpha_set__238_inline_variant, 0L, 2);
DEFINE_EXPORT_PROCEDURE(local_variant_removable_set__env_241_inline_variant, _local_variant_removable_set__119_inline_variant1693, _local_variant_removable_set__119_inline_variant, 0L, 2);
DEFINE_EXPORT_PROCEDURE(local_variant_user__set__env_42_inline_variant, _local_variant_user__set__250_inline_variant1694, _local_variant_user__set__250_inline_variant, 0L, 2);
DEFINE_EXPORT_PROCEDURE(invariant_args_env_85_inline_variant, _invariant_args_88_inline_variant1695, _invariant_args_88_inline_variant, 0L, 2);
DEFINE_EXPORT_PROCEDURE(shrink_args__env_30_inline_variant, _shrink_args__107_inline_variant1696, _shrink_args__107_inline_variant, 0L, 1);
DEFINE_STRING(string1666_inline_variant, string1666_inline_variant1697, "LOCAL/VARIANT DONE READ ", 24);
DEFINE_EXPORT_PROCEDURE(local_variant_variant_set__env_21_inline_variant, _local_variant_variant_set__191_inline_variant1698, _local_variant_variant_set__191_inline_variant, 0L, 2);
DEFINE_EXPORT_PROCEDURE(local_variant_occurrence_env_102_inline_variant, _local_variant_occurrence_135_inline_variant1699, _local_variant_occurrence_135_inline_variant, 0L, 1);
DEFINE_EXPORT_PROCEDURE(widening_local_variant_env_160_inline_variant, _widening_local_variant_102_inline_variant1700, _widening_local_variant_102_inline_variant, 0L, 1);
DEFINE_EXPORT_PROCEDURE(local_variant_key_env_136_inline_variant, _local_variant_key_59_inline_variant1701, _local_variant_key_59_inline_variant, 0L, 1);
extern obj_t object__struct_env_210___object;
DEFINE_EXPORT_PROCEDURE(local_variant__env_233_inline_variant, _local_variant__184_inline_variant1702, _local_variant__184_inline_variant, 0L, 1);
DEFINE_EXPORT_PROCEDURE(local_variant_type_env_146_inline_variant, _local_variant_type_159_inline_variant1703, _local_variant_type_159_inline_variant, 0L, 1);



/* module-initialization */
obj_t 
module_initialization_70_inline_variant(long checksum_1533, char *from_1534)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_inline_variant))
	{
	   require_initialization_114_inline_variant =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_inline_variant();
	   cnst_init_137_inline_variant();
	   imported_modules_init_94_inline_variant();
	   object_init_111_inline_variant();
	   method_init_76_inline_variant();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_inline_variant()
{
   AN_OBJECT;
   {	/* Inline/variant.scm 14 */
      module_initialization_70___object(((long) 0), "INLINE_VARIANT");
      module_initialization_70___reader(((long) 0), "INLINE_VARIANT");
      module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "INLINE_VARIANT");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_inline_variant()
{
   AN_OBJECT;
   {	/* Inline/variant.scm 14 */
      {		/* Inline/variant.scm 14 */
	 obj_t cnst_port_138_1526;
	 cnst_port_138_1526 =
	    open_input_string(string1666_inline_variant);
	 {
	    long i_1527;
	    i_1527 = ((long) 2);
	  loop_1528:
	    {	/* Inline/variant.scm 14 */
	       bool_t test1667_1529;
	       test1667_1529 =
		  (i_1527 == ((long) -1));
	       if (test1667_1529)
		 {	/* Inline/variant.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Inline/variant.scm 14 */
		    {	/* Inline/variant.scm 14 */
		       obj_t arg1669_1530;
		       {	/* Inline/variant.scm 14 */
			  obj_t list1670_1531;
			  list1670_1531 =
			     MAKE_PAIR(cnst_port_138_1526, BNIL);
			  arg1669_1530 =
			     read___reader(list1670_1531);
		       }
		       CNST_TABLE_SET(i_1527, arg1669_1530);
		    }
		    {	/* Inline/variant.scm 14 */
		       int aux_1532;
		       {	/* Inline/variant.scm 14 */
			  long aux_1552;
			  aux_1552 =
			     (i_1527 - ((long) 1));
			  aux_1532 =
			     (int) (aux_1552);
		       }
		       {
			  long i_1555;
			  i_1555 =
			     (long) (aux_1532);
			  i_1527 = i_1555;
			  goto loop_1528;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* invariant-args */
obj_t 
invariant_args_254_inline_variant(variable_bglt var_1, obj_t calls_2)
{
   AN_OBJECT;
   {	/* Inline/variant.scm 33 */
      {		/* Inline/variant.scm 34 */
	 obj_t args_750;
	 {	/* Inline/variant.scm 35 */
	    sfun_bglt obj_1235;
	    {	/* Inline/variant.scm 35 */
	       value_bglt aux_1557;
	       aux_1557 =
		  (((variable_bglt) CREF(var_1))->value);
	       obj_1235 =
		  (sfun_bglt) (aux_1557);
	    }
	    args_750 =
	       (((sfun_bglt) CREF(obj_1235))->args);
	 }
	 {	/* Inline/variant.scm 35 */

	    {
	       obj_t l1459_751;
	       l1459_751 = args_750;
	     lname1460_752:
	       if (
		  PAIRP(l1459_751))
		 {	/* Inline/variant.scm 37 */
		    {	/* Inline/variant.scm 38 */
		       obj_t local_754;
		       local_754 =
			  CAR(l1459_751);
		       {	/* Inline/variant.scm 38 */
			  bool_t test_1564;
			  {	/* ./Ieee/equiv.scm 5508 */
			     obj_t aux_1568;
			     obj_t aux_1565;
			     aux_1568 =
				CNST_TABLE_REF(((long) 0));
			     {	/* Inline/variant.scm 38 */
				local_bglt obj_1238;
				obj_1238 =
				   (local_bglt) (local_754);
				aux_1565 =
				   (((local_bglt) CREF(obj_1238))->access);
			     }
			     test_1564 =
				(aux_1565 == aux_1568);
			  }
			  if (test_1564)
			    {	/* Inline/variant.scm 39 */
			       local_variant_63_bglt obj1461_756;
			       obj1461_756 =
				  ((local_variant_63_bglt) (local_754));
			       {	/* Inline/variant.scm 39 */
				  local_variant_63_bglt arg1478_757;
				  {	/* Inline/variant.scm 39 */
				     local_variant_63_bglt res1655_1244;
				     {	/* Inline/variant.scm 19 */
					local_variant_63_bglt new1446_1242;
					new1446_1242 =
					   ((local_variant_63_bglt) BREF(GC_MALLOC(sizeof(struct local_variant_63))));
					((((local_variant_63_bglt) CREF(new1446_1242))->variant) = ((bool_t) ((bool_t) 0)), BUNSPEC);
					res1655_1244 = new1446_1242;
				     }
				     arg1478_757 = res1655_1244;
				  }
				  {	/* Inline/variant.scm 39 */
				     obj_t aux_1576;
				     object_bglt aux_1574;
				     aux_1576 =
					(obj_t) (arg1478_757);
				     aux_1574 =
					(object_bglt) (obj1461_756);
				     OBJECT_WIDENING_SET(aux_1574, aux_1576);
				  }
			       }
			       {	/* Inline/variant.scm 39 */
				  long arg1480_759;
				  arg1480_759 =
				     class_num_218___object(local_variant_63_inline_variant);
				  {	/* Inline/variant.scm 39 */
				     obj_t obj_1245;
				     obj_1245 =
					(obj_t) (obj1461_756);
				     (((obj_t) CREF(obj_1245))->header = MAKE_HEADER(arg1480_759, 0), BUNSPEC);
				  }
			       }
			       obj1461_756;
			    }
			  else
			    {	/* Inline/variant.scm 40 */
			       local_variant_63_bglt obj1462_760;
			       obj1462_760 =
				  ((local_variant_63_bglt) (local_754));
			       {	/* Inline/variant.scm 40 */
				  local_variant_63_bglt arg1481_761;
				  {	/* Inline/variant.scm 40 */
				     local_variant_63_bglt res1656_1250;
				     {	/* Inline/variant.scm 19 */
					local_variant_63_bglt new1446_1248;
					new1446_1248 =
					   ((local_variant_63_bglt) BREF(GC_MALLOC(sizeof(struct local_variant_63))));
					((((local_variant_63_bglt) CREF(new1446_1248))->variant) = ((bool_t) ((bool_t) 1)), BUNSPEC);
					res1656_1250 = new1446_1248;
				     }
				     arg1481_761 = res1656_1250;
				  }
				  {	/* Inline/variant.scm 40 */
				     obj_t aux_1587;
				     object_bglt aux_1585;
				     aux_1587 =
					(obj_t) (arg1481_761);
				     aux_1585 =
					(object_bglt) (obj1462_760);
				     OBJECT_WIDENING_SET(aux_1585, aux_1587);
				  }
			       }
			       {	/* Inline/variant.scm 40 */
				  long arg1483_763;
				  arg1483_763 =
				     class_num_218___object(local_variant_63_inline_variant);
				  {	/* Inline/variant.scm 40 */
				     obj_t obj_1251;
				     obj_1251 =
					(obj_t) (obj1462_760);
				     (((obj_t) CREF(obj_1251))->header = MAKE_HEADER(arg1483_763, 0), BUNSPEC);
				  }
			       }
			       obj1462_760;
			    }
		       }
		    }
		    {
		       obj_t l1459_1593;
		       l1459_1593 =
			  CDR(l1459_751);
		       l1459_751 = l1459_1593;
		       goto lname1460_752;
		    }
		 }
	       else
		 {	/* Inline/variant.scm 37 */
		    ((bool_t) 1);
		 }
	    }
	    {
	       obj_t l1463_767;
	       l1463_767 = calls_2;
	     lname1464_768:
	       if (
		  PAIRP(l1463_767))
		 {	/* Inline/variant.scm 43 */
		    {	/* Inline/variant.scm 44 */
		       app_bglt app_770;
		       {	/* ./Ieee/pair-list.scm 5701 */
			  obj_t aux_1597;
			  aux_1597 =
			     CAR(l1463_767);
			  app_770 =
			     (app_bglt) (aux_1597);
		       }
		       {
			  obj_t actuals_771;
			  obj_t args_772;
			  actuals_771 =
			     (((app_bglt) CREF(app_770))->args);
			  args_772 = args_750;
			loop_773:
			  if (
			     NULLP(args_772))
			    {	/* Inline/variant.scm 47 */
			       CNST_TABLE_REF(((long) 1));
			    }
			  else
			    {	/* Inline/variant.scm 47 */
			       if (
				  NULLP(actuals_771))
				 {	/* Inline/variant.scm 49 */
				    {
				       obj_t l1465_777;
				       {	/* Inline/variant.scm 50 */
					  bool_t aux_1605;
					  l1465_777 = args_772;
					lname1466_778:
					  if (
					     PAIRP(l1465_777))
					    {	/* Inline/variant.scm 50 */
					       {	/* Inline/variant.scm 51 */
						  local_variant_63_bglt obj_1261;
						  {	/* Inline/variant.scm 51 */
						     obj_t aux_1608;
						     aux_1608 =
							CAR(l1465_777);
						     obj_1261 =
							(local_variant_63_bglt) (aux_1608);
						  }
						  {
						     obj_t aux_1611;
						     {	/* Inline/variant.scm 19 */
							object_bglt aux_1612;
							aux_1612 =
							   (object_bglt) (obj_1261);
							aux_1611 =
							   OBJECT_WIDENING(aux_1612);
						     }
						     ((((local_variant_63_bglt) CREF(aux_1611))->variant) = ((bool_t) ((bool_t) 1)), BUNSPEC);
						  }
					       }
					       {
						  obj_t l1465_1616;
						  l1465_1616 =
						     CDR(l1465_777);
						  l1465_777 = l1465_1616;
						  goto lname1466_778;
					       }
					    }
					  else
					    {	/* Inline/variant.scm 50 */
					       aux_1605 = ((bool_t) 1);
					    }
					  BBOOL(aux_1605);
				       }
				    }
				 }
			       else
				 {	/* Inline/variant.scm 53 */
				    bool_t test1494_782;
				    {	/* Inline/variant.scm 53 */
				       bool_t test1500_788;
				       test1500_788 =
					  is_a__118___object(
					  CAR(actuals_771), var_ast_node);
				       if (test1500_788)
					 {	/* ./Ieee/equiv.scm 5508 */
					    obj_t aux_1629;
					    obj_t aux_1622;
					    aux_1629 =
					       CAR(args_772);
					    {	/* Inline/variant.scm 54 */
					       variable_bglt aux_1623;
					       {	/* Inline/variant.scm 54 */
						  var_bglt obj_1267;
						  {	/* Inline/variant.scm 54 */
						     obj_t aux_1624;
						     aux_1624 =
							CAR(actuals_771);
						     obj_1267 =
							(var_bglt) (aux_1624);
						  }
						  aux_1623 =
						     (((var_bglt) CREF(obj_1267))->variable);
					       }
					       aux_1622 =
						  (obj_t) (aux_1623);
					    }
					    test1494_782 =
					       (aux_1622 == aux_1629);
					 }
				       else
					 {	/* Inline/variant.scm 53 */
					    test1494_782 = ((bool_t) 0);
					 }
				    }
				    if (test1494_782)
				      {		/* Inline/variant.scm 53 */
					 {
					    obj_t args_1635;
					    obj_t actuals_1633;
					    actuals_1633 =
					       CDR(actuals_771);
					    args_1635 =
					       CDR(args_772);
					    args_772 = args_1635;
					    actuals_771 = actuals_1633;
					    goto loop_773;
					 }
				      }
				    else
				      {		/* Inline/variant.scm 53 */
					 {	/* Inline/variant.scm 57 */
					    local_variant_63_bglt obj_1274;
					    {	/* Inline/variant.scm 57 */
					       obj_t aux_1637;
					       aux_1637 =
						  CAR(args_772);
					       obj_1274 =
						  (local_variant_63_bglt) (aux_1637);
					    }
					    {
					       obj_t aux_1640;
					       {	/* Inline/variant.scm 19 */
						  object_bglt aux_1641;
						  aux_1641 =
						     (object_bglt) (obj_1274);
						  aux_1640 =
						     OBJECT_WIDENING(aux_1641);
					       }
					       ((((local_variant_63_bglt) CREF(aux_1640))->variant) = ((bool_t) ((bool_t) 1)), BUNSPEC);
					    }
					 }
					 {
					    obj_t args_1647;
					    obj_t actuals_1645;
					    actuals_1645 =
					       CDR(actuals_771);
					    args_1647 =
					       CDR(args_772);
					    args_772 = args_1647;
					    actuals_771 = actuals_1645;
					    goto loop_773;
					 }
				      }
				 }
			    }
		       }
		    }
		    {
		       obj_t l1463_1650;
		       l1463_1650 =
			  CDR(l1463_767);
		       l1463_767 = l1463_1650;
		       goto lname1464_768;
		    }
		 }
	       else
		 {	/* Inline/variant.scm 43 */
		    ((bool_t) 1);
		 }
	    }
	    {
	       obj_t args_794;
	       obj_t invariant_795;
	       args_794 = args_750;
	       invariant_795 = BNIL;
	     loop_796:
	       if (
		  NULLP(args_794))
		 {	/* Inline/variant.scm 63 */
		    return
		       reverse__39___r4_pairs_and_lists_6_3(invariant_795);
		 }
	       else
		 {	/* Inline/variant.scm 65 */
		    obj_t arg1508_798;
		    obj_t arg1509_799;
		    arg1508_798 =
		       CDR(args_794);
		    {	/* Inline/variant.scm 66 */
		       bool_t test_1656;
		       {	/* Inline/variant.scm 66 */
			  local_variant_63_bglt obj_1282;
			  {	/* Inline/variant.scm 66 */
			     obj_t aux_1657;
			     aux_1657 =
				CAR(args_794);
			     obj_1282 =
				(local_variant_63_bglt) (aux_1657);
			  }
			  {
			     obj_t aux_1660;
			     {	/* Inline/variant.scm 19 */
				object_bglt aux_1661;
				aux_1661 =
				   (object_bglt) (obj_1282);
				aux_1660 =
				   OBJECT_WIDENING(aux_1661);
			     }
			     test_1656 =
				(((local_variant_63_bglt) CREF(aux_1660))->variant);
			  }
		       }
		       if (test_1656)
			 {	/* Inline/variant.scm 66 */
			    arg1509_799 = invariant_795;
			 }
		       else
			 {	/* ./Ieee/pair-list.scm 5689 */
			    obj_t aux_1665;
			    aux_1665 =
			       CAR(args_794);
			    arg1509_799 =
			       MAKE_PAIR(aux_1665, invariant_795);
			 }
		    }
		    {
		       obj_t invariant_1669;
		       obj_t args_1668;
		       args_1668 = arg1508_798;
		       invariant_1669 = arg1509_799;
		       invariant_795 = invariant_1669;
		       args_794 = args_1668;
		       goto loop_796;
		    }
		 }
	    }
	 }
      }
   }
}



/* _invariant-args */
obj_t 
_invariant_args_88_inline_variant(obj_t env_1435, obj_t var_1436, obj_t calls_1437)
{
   AN_OBJECT;
   {	/* Inline/variant.scm 33 */
      return
	 invariant_args_254_inline_variant(
	 (variable_bglt) (var_1436), calls_1437);
   }
}



/* variant-args */
obj_t 
variant_args_126_inline_variant(variable_bglt var_3)
{
   AN_OBJECT;
   {	/* Inline/variant.scm 75 */
      {		/* Inline/variant.scm 77 */

	 {
	    obj_t args_805;
	    obj_t variant_806;
	    {	/* Inline/variant.scm 77 */
	       sfun_bglt obj_1287;
	       {	/* Inline/variant.scm 77 */
		  value_bglt aux_1690;
		  aux_1690 =
		     (((variable_bglt) CREF(var_3))->value);
		  obj_1287 =
		     (sfun_bglt) (aux_1690);
	       }
	       args_805 =
		  (((sfun_bglt) CREF(obj_1287))->args);
	    }
	    variant_806 = BNIL;
	  loop_807:
	    if (
	       NULLP(args_805))
	      {		/* Inline/variant.scm 80 */
		 return
		    reverse__39___r4_pairs_and_lists_6_3(variant_806);
	      }
	    else
	      {		/* Inline/variant.scm 82 */
		 obj_t arg1514_809;
		 obj_t arg1515_810;
		 arg1514_809 =
		    CDR(args_805);
		 {	/* Inline/variant.scm 83 */
		    bool_t test_1676;
		    {	/* Inline/variant.scm 83 */
		       local_variant_63_bglt obj_1291;
		       {	/* Inline/variant.scm 83 */
			  obj_t aux_1677;
			  aux_1677 =
			     CAR(args_805);
			  obj_1291 =
			     (local_variant_63_bglt) (aux_1677);
		       }
		       {
			  obj_t aux_1680;
			  {	/* Inline/variant.scm 19 */
			     object_bglt aux_1681;
			     aux_1681 =
				(object_bglt) (obj_1291);
			     aux_1680 =
				OBJECT_WIDENING(aux_1681);
			  }
			  test_1676 =
			     (((local_variant_63_bglt) CREF(aux_1680))->variant);
		       }
		    }
		    if (test_1676)
		      {		/* ./Ieee/pair-list.scm 5689 */
			 obj_t aux_1685;
			 aux_1685 =
			    CAR(args_805);
			 arg1515_810 =
			    MAKE_PAIR(aux_1685, variant_806);
		      }
		    else
		      {		/* Inline/variant.scm 83 */
			 arg1515_810 = variant_806;
		      }
		 }
		 {
		    obj_t variant_1689;
		    obj_t args_1688;
		    args_1688 = arg1514_809;
		    variant_1689 = arg1515_810;
		    variant_806 = variant_1689;
		    args_805 = args_1688;
		    goto loop_807;
		 }
	      }
	 }
      }
   }
}



/* _variant-args */
obj_t 
_variant_args_237_inline_variant(obj_t env_1438, obj_t var_1439)
{
   AN_OBJECT;
   {	/* Inline/variant.scm 75 */
      return
	 variant_args_126_inline_variant(
	 (variable_bglt) (var_1439));
   }
}



/* substitutions */
obj_t 
substitutions_inline_variant(variable_bglt var_4, obj_t actuals_5, obj_t var_args_195_6)
{
   AN_OBJECT;
   {	/* Inline/variant.scm 90 */
      {		/* Inline/variant.scm 92 */

	 {
	    obj_t actuals_816;
	    obj_t all_args_251_817;
	    obj_t var_args_195_818;
	    obj_t substitutions_819;
	    actuals_816 = actuals_5;
	    {	/* Inline/variant.scm 92 */
	       sfun_bglt obj_1296;
	       {	/* Inline/variant.scm 92 */
		  value_bglt aux_1734;
		  aux_1734 =
		     (((variable_bglt) CREF(var_4))->value);
		  obj_1296 =
		     (sfun_bglt) (aux_1734);
	       }
	       all_args_251_817 =
		  (((sfun_bglt) CREF(obj_1296))->args);
	    }
	    var_args_195_818 = var_args_195_6;
	    substitutions_819 = BNIL;
	  loop_820:
	    if (
	       NULLP(all_args_251_817))
	      {		/* Inline/variant.scm 98 */
		 return
		    reverse__39___r4_pairs_and_lists_6_3(substitutions_819);
	      }
	    else
	      {		/* Inline/variant.scm 100 */
		 bool_t test_1699;
		 {	/* Inline/variant.scm 100 */
		    local_variant_63_bglt obj_1299;
		    {	/* Inline/variant.scm 100 */
		       obj_t aux_1700;
		       aux_1700 =
			  CAR(all_args_251_817);
		       obj_1299 =
			  (local_variant_63_bglt) (aux_1700);
		    }
		    {
		       obj_t aux_1703;
		       {	/* Inline/variant.scm 19 */
			  object_bglt aux_1704;
			  aux_1704 =
			     (object_bglt) (obj_1299);
			  aux_1703 =
			     OBJECT_WIDENING(aux_1704);
		       }
		       test_1699 =
			  (((local_variant_63_bglt) CREF(aux_1703))->variant);
		    }
		 }
		 if (test_1699)
		   {	/* Inline/variant.scm 100 */
		      {		/* Inline/variant.scm 101 */
			 obj_t arg1522_823;
			 obj_t arg1523_824;
			 obj_t arg1525_825;
			 obj_t arg1526_826;
			 arg1522_823 =
			    CDR(actuals_816);
			 arg1523_824 =
			    CDR(all_args_251_817);
			 arg1525_825 =
			    CDR(var_args_195_818);
			 {	/* ./Ieee/pair-list.scm 5689 */
			    obj_t aux_1711;
			    aux_1711 =
			       CAR(var_args_195_818);
			    arg1526_826 =
			       MAKE_PAIR(aux_1711, substitutions_819);
			 }
			 {
			    obj_t substitutions_1717;
			    obj_t var_args_195_1716;
			    obj_t all_args_251_1715;
			    obj_t actuals_1714;
			    actuals_1714 = arg1522_823;
			    all_args_251_1715 = arg1523_824;
			    var_args_195_1716 = arg1525_825;
			    substitutions_1717 = arg1526_826;
			    substitutions_819 = substitutions_1717;
			    var_args_195_818 = var_args_195_1716;
			    all_args_251_817 = all_args_251_1715;
			    actuals_816 = actuals_1714;
			    goto loop_820;
			 }
		      }
		   }
		 else
		   {	/* Inline/variant.scm 100 */
		      {		/* Inline/variant.scm 106 */
			 obj_t arg1528_828;
			 obj_t arg1529_829;
			 obj_t arg1530_830;
			 arg1528_828 =
			    CDR(actuals_816);
			 arg1529_829 =
			    CDR(all_args_251_817);
			 {	/* Inline/variant.scm 109 */
			    obj_t arg1532_831;
			    {	/* Inline/variant.scm 109 */
			       bool_t test1533_832;
			       test1533_832 =
				  is_a__118___object(
				  CAR(actuals_816), var_ast_node);
			       if (test1533_832)
				 {	/* Inline/variant.scm 110 */
				    var_bglt obj_1311;
				    {	/* Inline/variant.scm 110 */
				       obj_t aux_1723;
				       aux_1723 =
					  CAR(actuals_816);
				       obj_1311 =
					  (var_bglt) (aux_1723);
				    }
				    {	/* ./Ast/node.scm 690 */
				       variable_bglt aux_1726;
				       aux_1726 =
					  (((var_bglt) CREF(obj_1311))->variable);
				       arg1532_831 =
					  (obj_t) (aux_1726);
				    }
				 }
			       else
				 {	/* Inline/variant.scm 109 */
				    arg1532_831 =
				       CAR(actuals_816);
				 }
			    }
			    arg1530_830 =
			       MAKE_PAIR(arg1532_831, substitutions_819);
			 }
			 {
			    obj_t substitutions_1733;
			    obj_t all_args_251_1732;
			    obj_t actuals_1731;
			    actuals_1731 = arg1528_828;
			    all_args_251_1732 = arg1529_829;
			    substitutions_1733 = arg1530_830;
			    substitutions_819 = substitutions_1733;
			    all_args_251_817 = all_args_251_1732;
			    actuals_816 = actuals_1731;
			    goto loop_820;
			 }
		      }
		   }
	      }
	 }
      }
   }
}



/* _substitutions */
obj_t 
_substitutions_inline_variant(obj_t env_1440, obj_t var_1441, obj_t actuals_1442, obj_t var_args_195_1443)
{
   AN_OBJECT;
   {	/* Inline/variant.scm 90 */
      return
	 substitutions_inline_variant(
	 (variable_bglt) (var_1441), actuals_1442, var_args_195_1443);
   }
}



/* shrink-args! */
obj_t 
shrink_args__237_inline_variant(variable_bglt var_7)
{
   AN_OBJECT;
   {	/* Inline/variant.scm 117 */
      {		/* Inline/variant.scm 119 */

	 {
	    obj_t l1467_838;
	    {	/* Inline/variant.scm 120 */
	       bool_t aux_1740;
	       {	/* Inline/variant.scm 119 */
		  sfun_bglt obj_1316;
		  {	/* Inline/variant.scm 119 */
		     value_bglt aux_1764;
		     aux_1764 =
			(((variable_bglt) CREF(var_7))->value);
		     obj_1316 =
			(sfun_bglt) (aux_1764);
		  }
		  l1467_838 =
		     (((sfun_bglt) CREF(obj_1316))->args);
	       }
	     lname1468_839:
	       if (
		  PAIRP(l1467_838))
		 {	/* Inline/variant.scm 120 */
		    {	/* Inline/variant.scm 120 */
		       obj_t a_841;
		       a_841 =
			  CAR(l1467_838);
		       {	/* Inline/variant.scm 120 */
			  bool_t test_1744;
			  {	/* ./Llib/object.scm 3045 */
			     bool_t test_1745;
			     {	/* ./Llib/object.scm 3045 */
				obj_t aux_1746;
				{	/* ./Llib/object.scm 3045 */
				   object_bglt aux_1747;
				   aux_1747 =
				      (object_bglt) (a_841);
				   aux_1746 =
				      OBJECT_WIDENING(aux_1747);
				}
				test_1745 =
				   CBOOL(aux_1746);
			     }
			     if (test_1745)
			       {	/* ./Llib/object.scm 3045 */
				  test_1744 = ((bool_t) 1)
				     ;
			       }
			     else
			       {	/* ./Llib/object.scm 3045 */
				  test_1744 = ((bool_t) 0)
				     ;
			       }
			  }
			  if (test_1744)
			    {	/* Inline/variant.scm 120 */
			       {	/* Inline/variant.scm 120 */
				  long arg1539_844;
				  {	/* Inline/variant.scm 120 */
				     obj_t arg1540_845;
				     {	/* Inline/variant.scm 120 */
					obj_t arg1541_846;
					{	/* Inline/variant.scm 120 */
					   object_bglt object_1322;
					   object_1322 =
					      (object_bglt) (a_841);
					   {	/* ./Llib/object.scm 2695 */
					      long arg1179_1323;
					      {		/* ./Llib/object.scm 2695 */
						 long arg1180_1324;
						 long arg1181_1325;
						 arg1180_1324 =
						    TYPE(object_1322);
						 arg1181_1325 =
						    OBJECT_TYPE;
						 arg1179_1323 =
						    (arg1180_1324 - arg1181_1325);
					      }
					      {		/* ./Llib/object.scm 2695 */
						 obj_t vector_1329;
						 vector_1329 = _classes__134___object;
						 arg1541_846 =
						    VECTOR_REF(vector_1329, arg1179_1323);
					      }
					   }
					}
					arg1540_845 =
					   class_super_145___object(arg1541_846);
				     }
				     arg1539_844 =
					class_num_218___object(arg1540_845);
				  }
				  (((obj_t) CREF(a_841))->header = MAKE_HEADER(arg1539_844, 0), BUNSPEC);
			       }
			       {	/* Inline/variant.scm 120 */
				  object_bglt aux_1759;
				  aux_1759 =
				     (object_bglt) (a_841);
				  OBJECT_WIDENING_SET(aux_1759, BFALSE);
			       }
			       a_841;
			    }
			  else
			    {	/* Inline/variant.scm 120 */
			       BUNSPEC;
			    }
		       }
		    }
		    {
		       obj_t l1467_1762;
		       l1467_1762 =
			  CDR(l1467_838);
		       l1467_838 = l1467_1762;
		       goto lname1468_839;
		    }
		 }
	       else
		 {	/* Inline/variant.scm 120 */
		    aux_1740 = ((bool_t) 1);
		 }
	       return
		  BBOOL(aux_1740);
	    }
	 }
      }
   }
}



/* _shrink-args! */
obj_t 
_shrink_args__107_inline_variant(obj_t env_1444, obj_t var_1445)
{
   AN_OBJECT;
   {	/* Inline/variant.scm 117 */
      return
	 shrink_args__237_inline_variant(
	 (variable_bglt) (var_1445));
   }
}



/* remove-invariant-args! */
app_bglt 
remove_invariant_args__113_inline_variant(app_bglt app_8)
{
   AN_OBJECT;
   {	/* Inline/variant.scm 131 */
      {
	 obj_t formals_849;
	 obj_t old_args_130_850;
	 obj_t new_args_235_851;
	 {	/* Inline/variant.scm 133 */
	    sfun_bglt obj_1337;
	    {	/* Inline/variant.scm 133 */
	       value_bglt aux_1800;
	       {	/* Inline/variant.scm 133 */
		  variable_bglt arg1549_857;
		  {	/* Inline/variant.scm 133 */
		     var_bglt arg1550_858;
		     arg1550_858 =
			(((app_bglt) CREF(app_8))->fun);
		     arg1549_857 =
			(((var_bglt) CREF(arg1550_858))->variable);
		  }
		  aux_1800 =
		     (((variable_bglt) CREF(arg1549_857))->value);
	       }
	       obj_1337 =
		  (sfun_bglt) (aux_1800);
	    }
	    formals_849 =
	       (((sfun_bglt) CREF(obj_1337))->args);
	 }
	 old_args_130_850 =
	    (((app_bglt) CREF(app_8))->args);
	 new_args_235_851 = BNIL;
       loop_852:
	 if (
	    NULLP(old_args_130_850))
	   {	/* Inline/variant.scm 137 */
	      {		/* Inline/variant.scm 138 */
		 obj_t arg1552_860;
		 arg1552_860 =
		    reverse__39___r4_pairs_and_lists_6_3(new_args_235_851);
		 ((((app_bglt) CREF(app_8))->args) = ((obj_t) arg1552_860), BUNSPEC);
	      }
	      return app_8;
	   }
	 else
	   {	/* Inline/variant.scm 140 */
	      bool_t test1553_861;
	      {		/* Inline/variant.scm 140 */
		 bool_t test1561_868;
		 test1561_868 =
		    is_a__118___object(
		    CAR(formals_849), local_variant_63_inline_variant);
		 if (test1561_868)
		   {	/* Inline/variant.scm 141 */
		      bool_t test_1778;
		      {		/* Inline/variant.scm 141 */
			 local_variant_63_bglt obj_1345;
			 {	/* Inline/variant.scm 141 */
			    obj_t aux_1779;
			    aux_1779 =
			       CAR(formals_849);
			    obj_1345 =
			       (local_variant_63_bglt) (aux_1779);
			 }
			 {
			    obj_t aux_1782;
			    {	/* Inline/variant.scm 19 */
			       object_bglt aux_1783;
			       aux_1783 =
				  (object_bglt) (obj_1345);
			       aux_1782 =
				  OBJECT_WIDENING(aux_1783);
			    }
			    test_1778 =
			       (((local_variant_63_bglt) CREF(aux_1782))->variant);
			 }
		      }
		      if (test_1778)
			{	/* Inline/variant.scm 141 */
			   test1553_861 = ((bool_t) 0);
			}
		      else
			{	/* Inline/variant.scm 141 */
			   test1553_861 = ((bool_t) 1);
			}
		   }
		 else
		   {	/* Inline/variant.scm 140 */
		      test1553_861 = ((bool_t) 0);
		   }
	      }
	      if (test1553_861)
		{	/* Inline/variant.scm 140 */
		   {
		      obj_t old_args_130_1790;
		      obj_t formals_1788;
		      formals_1788 =
			 CDR(formals_849);
		      old_args_130_1790 =
			 CDR(old_args_130_850);
		      old_args_130_850 = old_args_130_1790;
		      formals_849 = formals_1788;
		      goto loop_852;
		   }
		}
	      else
		{	/* Inline/variant.scm 140 */
		   {	/* Inline/variant.scm 146 */
		      obj_t arg1557_864;
		      obj_t arg1558_865;
		      obj_t arg1559_866;
		      arg1557_864 =
			 CDR(formals_849);
		      arg1558_865 =
			 CDR(old_args_130_850);
		      {		/* ./Ieee/pair-list.scm 5689 */
			 obj_t aux_1794;
			 aux_1794 =
			    CAR(old_args_130_850);
			 arg1559_866 =
			    MAKE_PAIR(aux_1794, new_args_235_851);
		      }
		      {
			 obj_t new_args_235_1799;
			 obj_t old_args_130_1798;
			 obj_t formals_1797;
			 formals_1797 = arg1557_864;
			 old_args_130_1798 = arg1558_865;
			 new_args_235_1799 = arg1559_866;
			 new_args_235_851 = new_args_235_1799;
			 old_args_130_850 = old_args_130_1798;
			 formals_849 = formals_1797;
			 goto loop_852;
		      }
		   }
		}
	   }
      }
   }
}



/* _remove-invariant-args! */
obj_t 
_remove_invariant_args__205_inline_variant(obj_t env_1446, obj_t app_1447)
{
   AN_OBJECT;
   {	/* Inline/variant.scm 131 */
      {		/* Inline/variant.scm 131 */
	 app_bglt aux_1807;
	 aux_1807 =
	    remove_invariant_args__113_inline_variant(
	    (app_bglt) (app_1447));
	 return
	    (obj_t) (aux_1807);
      }
   }
}



/* object-init */
obj_t 
object_init_111_inline_variant()
{
   AN_OBJECT;
   {	/* Inline/variant.scm 14 */
      {		/* Inline/variant.scm 14 */
	 obj_t arg1565_872;
	 obj_t arg1566_873;
	 obj_t arg1569_876;
	 arg1565_872 =
	    CNST_TABLE_REF(((long) 2));
	 arg1566_873 = local_ast_var;
	 {	/* Inline/variant.scm 14 */
	    obj_t v1471_877;
	    v1471_877 =
	       create_vector(((long) 0));
	    arg1569_876 = v1471_877;
	 }
	 local_variant_63_inline_variant =
	    register_class__225___object(arg1565_872, arg1566_873, allocate_local_variant_env_26_inline_variant, ((long) 1562), BUNSPEC, BFALSE, arg1569_876);
      }
      return BUNSPEC;
   }
}



/* allocate-local/variant */
local_bglt 
allocate_local_variant_108_inline_variant()
{
   AN_OBJECT;
   {	/* Inline/variant.scm 19 */
      {		/* Inline/variant.scm 19 */
	 local_bglt new1451_878;
	 new1451_878 =
	    ((local_bglt) BREF(GC_MALLOC(sizeof(struct local))));
	 {	/* Inline/variant.scm 19 */
	    long arg1571_879;
	    arg1571_879 =
	       class_num_218___object(local_variant_63_inline_variant);
	    {	/* Inline/variant.scm 19 */
	       obj_t obj_1353;
	       obj_1353 =
		  (obj_t) (new1451_878);
	       (((obj_t) CREF(obj_1353))->header = MAKE_HEADER(arg1571_879, 0), BUNSPEC);
	    }
	 }
	 {	/* Inline/variant.scm 19 */
	    object_bglt aux_1818;
	    aux_1818 =
	       (object_bglt) (new1451_878);
	    OBJECT_WIDENING_SET(aux_1818, BFALSE);
	 }
	 return new1451_878;
      }
   }
}



/* _allocate-local/variant */
obj_t 
_allocate_local_variant_45_inline_variant(obj_t env_1448)
{
   AN_OBJECT;
   {	/* Inline/variant.scm 19 */
      {		/* Inline/variant.scm 19 */
	 local_bglt aux_1821;
	 aux_1821 =
	    allocate_local_variant_108_inline_variant();
	 return
	    (obj_t) (aux_1821);
      }
   }
}



/* local/variant? */
bool_t 
local_variant__1_inline_variant(obj_t obj_12)
{
   AN_OBJECT;
   {	/* Inline/variant.scm 19 */
      return
	 is_a__118___object(obj_12, local_variant_63_inline_variant);
   }
}



/* _local/variant? */
obj_t 
_local_variant__184_inline_variant(obj_t env_1449, obj_t obj_1450)
{
   AN_OBJECT;
   {	/* Inline/variant.scm 19 */
      {		/* Inline/variant.scm 19 */
	 bool_t aux_1825;
	 aux_1825 =
	    local_variant__1_inline_variant(obj_1450);
	 return
	    BBOOL(aux_1825);
      }
   }
}



/* widening-local/variant */
local_variant_63_bglt 
widening_local_variant_142_inline_variant(bool_t variant_13)
{
   AN_OBJECT;
   {	/* Inline/variant.scm 19 */
      {		/* Inline/variant.scm 19 */
	 local_variant_63_bglt new1446_1355;
	 new1446_1355 =
	    ((local_variant_63_bglt) BREF(GC_MALLOC(sizeof(struct local_variant_63))));
	 ((((local_variant_63_bglt) CREF(new1446_1355))->variant) = ((bool_t) variant_13), BUNSPEC);
	 return new1446_1355;
      }
   }
}



/* _widening-local/variant */
obj_t 
_widening_local_variant_102_inline_variant(obj_t env_1451, obj_t variant_1452)
{
   AN_OBJECT;
   {	/* Inline/variant.scm 19 */
      {		/* Inline/variant.scm 19 */
	 local_variant_63_bglt aux_1830;
	 aux_1830 =
	    widening_local_variant_142_inline_variant(
	    CBOOL(variant_1452));
	 return
	    (obj_t) (aux_1830);
      }
   }
}



/* make-local/variant */
local_variant_63_bglt 
make_local_variant_132_inline_variant(obj_t id_14, obj_t name_15, type_bglt type_16, value_bglt value_17, obj_t access_18, obj_t fast_alpha_7_19, obj_t removable_20, long occurrence_21, bool_t user__32_22, long key_23, bool_t variant_24)
{
   AN_OBJECT;
   {	/* Inline/variant.scm 19 */
      {		/* Inline/variant.scm 19 */
	 local_bglt aux1449_1357;
	 {	/* Inline/variant.scm 19 */
	    local_bglt res1658_1385;
	    {	/* ./Ast/var.scm 576 */
	       local_bglt new1089_1371;
	       new1089_1371 =
		  ((local_bglt) BREF(GC_MALLOC(sizeof(struct local))));
	       {	/* ./Ast/var.scm 576 */
		  long arg1637_1372;
		  arg1637_1372 =
		     class_num_218___object(local_ast_var);
		  {	/* ./Ast/var.scm 576 */
		     obj_t obj_1383;
		     obj_1383 =
			(obj_t) (new1089_1371);
		     (((obj_t) CREF(obj_1383))->header = MAKE_HEADER(arg1637_1372, 0), BUNSPEC);
		  }
	       }
	       {	/* ./Ast/var.scm 576 */
		  object_bglt aux_1838;
		  aux_1838 =
		     (object_bglt) (new1089_1371);
		  OBJECT_WIDENING_SET(aux_1838, BFALSE);
	       }
	       ((((local_bglt) CREF(new1089_1371))->id) = ((obj_t) id_14), BUNSPEC);
	       ((((local_bglt) CREF(new1089_1371))->name) = ((obj_t) name_15), BUNSPEC);
	       ((((local_bglt) CREF(new1089_1371))->type) = ((type_bglt) type_16), BUNSPEC);
	       ((((local_bglt) CREF(new1089_1371))->value) = ((value_bglt) value_17), BUNSPEC);
	       ((((local_bglt) CREF(new1089_1371))->access) = ((obj_t) access_18), BUNSPEC);
	       ((((local_bglt) CREF(new1089_1371))->fast_alpha_7) = ((obj_t) fast_alpha_7_19), BUNSPEC);
	       ((((local_bglt) CREF(new1089_1371))->removable) = ((obj_t) removable_20), BUNSPEC);
	       ((((local_bglt) CREF(new1089_1371))->occurrence) = ((long) occurrence_21), BUNSPEC);
	       ((((local_bglt) CREF(new1089_1371))->user__32) = ((bool_t) user__32_22), BUNSPEC);
	       ((((local_bglt) CREF(new1089_1371))->key) = ((long) key_23), BUNSPEC);
	       res1658_1385 = new1089_1371;
	    }
	    aux1449_1357 = res1658_1385;
	 }
	 {	/* Inline/variant.scm 19 */
	    local_variant_63_bglt new1450_1358;
	    new1450_1358 =
	       ((local_variant_63_bglt) (aux1449_1357));
	    {	/* Inline/variant.scm 19 */
	       long arg1572_1359;
	       arg1572_1359 =
		  class_num_218___object(local_variant_63_inline_variant);
	       {	/* Inline/variant.scm 19 */
		  obj_t obj_1386;
		  obj_1386 =
		     (obj_t) (new1450_1358);
		  (((obj_t) CREF(obj_1386))->header = MAKE_HEADER(arg1572_1359, 0), BUNSPEC);
	       }
	    }
	    {	/* Inline/variant.scm 19 */
	       local_variant_63_bglt arg1573_1360;
	       {	/* Inline/variant.scm 19 */
		  local_variant_63_bglt res1659_1391;
		  {	/* Inline/variant.scm 19 */
		     local_variant_63_bglt new1446_1389;
		     new1446_1389 =
			((local_variant_63_bglt) BREF(GC_MALLOC(sizeof(struct local_variant_63))));
		     ((((local_variant_63_bglt) CREF(new1446_1389))->variant) = ((bool_t) variant_24), BUNSPEC);
		     res1659_1391 = new1446_1389;
		  }
		  arg1573_1360 = res1659_1391;
	       }
	       {	/* Inline/variant.scm 19 */
		  obj_t aux_1859;
		  object_bglt aux_1857;
		  aux_1859 =
		     (obj_t) (arg1573_1360);
		  aux_1857 =
		     (object_bglt) (new1450_1358);
		  OBJECT_WIDENING_SET(aux_1857, aux_1859);
	       }
	    }
	    return new1450_1358;
	 }
      }
   }
}



/* _make-local/variant */
obj_t 
_make_local_variant_201_inline_variant(obj_t env_1453, obj_t id_1454, obj_t name_1455, obj_t type_1456, obj_t value_1457, obj_t access_1458, obj_t fast_alpha_7_1459, obj_t removable_1460, obj_t occurrence_1461, obj_t user__32_1462, obj_t key_1463, obj_t variant_1464)
{
   AN_OBJECT;
   {	/* Inline/variant.scm 19 */
      {		/* Inline/variant.scm 19 */
	 local_variant_63_bglt aux_1862;
	 aux_1862 =
	    make_local_variant_132_inline_variant(id_1454, name_1455,
	    (type_bglt) (type_1456),
	    (value_bglt) (value_1457), access_1458, fast_alpha_7_1459, removable_1460,
	    (long) CINT(occurrence_1461),
	    CBOOL(user__32_1462),
	    (long) CINT(key_1463),
	    CBOOL(variant_1464));
	 return
	    (obj_t) (aux_1862);
      }
   }
}



/* local/variant-id */
obj_t 
local_variant_id_153_inline_variant(local_bglt obj_25)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 535 */
      return
	 (((local_bglt) CREF(obj_25))->id);
   }
}



/* _local/variant-id */
obj_t 
_local_variant_id_32_inline_variant(obj_t env_1465, obj_t obj_1466)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 535 */
      return
	 local_variant_id_153_inline_variant(
	 (local_bglt) (obj_1466));
   }
}



/* local/variant-name-set! */
obj_t 
local_variant_name_set__245_inline_variant(local_bglt obj_26, obj_t val1437_27)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 537 */
      return
	 ((((local_bglt) CREF(obj_26))->name) = ((obj_t) val1437_27), BUNSPEC);
   }
}



/* _local/variant-name-set! */
obj_t 
_local_variant_name_set__17_inline_variant(obj_t env_1467, obj_t obj_1468, obj_t val1437_1469)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 537 */
      return
	 local_variant_name_set__245_inline_variant(
	 (local_bglt) (obj_1468), val1437_1469);
   }
}



/* local/variant-name */
obj_t 
local_variant_name_14_inline_variant(local_bglt obj_28)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 537 */
      return
	 (((local_bglt) CREF(obj_28))->name);
   }
}



/* _local/variant-name */
obj_t 
_local_variant_name_117_inline_variant(obj_t env_1470, obj_t obj_1471)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 537 */
      return
	 local_variant_name_14_inline_variant(
	 (local_bglt) (obj_1471));
   }
}



/* local/variant-type-set! */
obj_t 
local_variant_type_set__179_inline_variant(local_bglt obj_29, type_bglt val1438_30)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 539 */
      return
	 ((((local_bglt) CREF(obj_29))->type) = ((type_bglt) val1438_30), BUNSPEC);
   }
}



/* _local/variant-type-set! */
obj_t 
_local_variant_type_set__203_inline_variant(obj_t env_1472, obj_t obj_1473, obj_t val1438_1474)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 539 */
      return
	 local_variant_type_set__179_inline_variant(
	 (local_bglt) (obj_1473),
	 (type_bglt) (val1438_1474));
   }
}



/* local/variant-type */
type_bglt 
local_variant_type_2_inline_variant(local_bglt obj_31)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 539 */
      return
	 (((local_bglt) CREF(obj_31))->type);
   }
}



/* _local/variant-type */
obj_t 
_local_variant_type_159_inline_variant(obj_t env_1475, obj_t obj_1476)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 539 */
      {		/* ./Ast/var.scm 539 */
	 type_bglt aux_1885;
	 aux_1885 =
	    local_variant_type_2_inline_variant(
	    (local_bglt) (obj_1476));
	 return
	    (obj_t) (aux_1885);
      }
   }
}



/* local/variant-value-set! */
obj_t 
local_variant_value_set__67_inline_variant(local_bglt obj_32, value_bglt val1439_33)
{
   AN_OBJECT;
   {	/* Inline/variant.scm 19 */
      return
	 ((((local_bglt) CREF(obj_32))->value) = ((value_bglt) val1439_33), BUNSPEC);
   }
}



/* _local/variant-value-set! */
obj_t 
_local_variant_value_set__43_inline_variant(obj_t env_1477, obj_t obj_1478, obj_t val1439_1479)
{
   AN_OBJECT;
   {	/* Inline/variant.scm 19 */
      return
	 local_variant_value_set__67_inline_variant(
	 (local_bglt) (obj_1478),
	 (value_bglt) (val1439_1479));
   }
}



/* local/variant-value */
value_bglt 
local_variant_value_31_inline_variant(local_bglt obj_34)
{
   AN_OBJECT;
   {	/* Inline/variant.scm 19 */
      return
	 (((local_bglt) CREF(obj_34))->value);
   }
}



/* _local/variant-value */
obj_t 
_local_variant_value_97_inline_variant(obj_t env_1480, obj_t obj_1481)
{
   AN_OBJECT;
   {	/* Inline/variant.scm 19 */
      {		/* Inline/variant.scm 19 */
	 value_bglt aux_1894;
	 aux_1894 =
	    local_variant_value_31_inline_variant(
	    (local_bglt) (obj_1481));
	 return
	    (obj_t) (aux_1894);
      }
   }
}



/* local/variant-access-set! */
obj_t 
local_variant_access_set__216_inline_variant(local_bglt obj_35, obj_t val1440_36)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 543 */
      return
	 ((((local_bglt) CREF(obj_35))->access) = ((obj_t) val1440_36), BUNSPEC);
   }
}



/* _local/variant-access-set! */
obj_t 
_local_variant_access_set__197_inline_variant(obj_t env_1482, obj_t obj_1483, obj_t val1440_1484)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 543 */
      return
	 local_variant_access_set__216_inline_variant(
	 (local_bglt) (obj_1483), val1440_1484);
   }
}



/* local/variant-access */
obj_t 
local_variant_access_191_inline_variant(local_bglt obj_37)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 543 */
      return
	 (((local_bglt) CREF(obj_37))->access);
   }
}



/* _local/variant-access */
obj_t 
_local_variant_access_113_inline_variant(obj_t env_1485, obj_t obj_1486)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 543 */
      return
	 local_variant_access_191_inline_variant(
	 (local_bglt) (obj_1486));
   }
}



/* local/variant-fast-alpha-set! */
obj_t 
local_variant_fast_alpha_set__19_inline_variant(local_bglt obj_38, obj_t val1441_39)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 550 */
      return
	 ((((local_bglt) CREF(obj_38))->fast_alpha_7) = ((obj_t) val1441_39), BUNSPEC);
   }
}



/* _local/variant-fast-alpha-set! */
obj_t 
_local_variant_fast_alpha_set__238_inline_variant(obj_t env_1487, obj_t obj_1488, obj_t val1441_1489)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 550 */
      return
	 local_variant_fast_alpha_set__19_inline_variant(
	 (local_bglt) (obj_1488), val1441_1489);
   }
}



/* local/variant-fast-alpha */
obj_t 
local_variant_fast_alpha_32_inline_variant(local_bglt obj_40)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 550 */
      return
	 (((local_bglt) CREF(obj_40))->fast_alpha_7);
   }
}



/* _local/variant-fast-alpha */
obj_t 
_local_variant_fast_alpha_53_inline_variant(obj_t env_1490, obj_t obj_1491)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 550 */
      return
	 local_variant_fast_alpha_32_inline_variant(
	 (local_bglt) (obj_1491));
   }
}



/* local/variant-removable-set! */
obj_t 
local_variant_removable_set__23_inline_variant(local_bglt obj_41, obj_t val1442_42)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 552 */
      return
	 ((((local_bglt) CREF(obj_41))->removable) = ((obj_t) val1442_42), BUNSPEC);
   }
}



/* _local/variant-removable-set! */
obj_t 
_local_variant_removable_set__119_inline_variant(obj_t env_1492, obj_t obj_1493, obj_t val1442_1494)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 552 */
      return
	 local_variant_removable_set__23_inline_variant(
	 (local_bglt) (obj_1493), val1442_1494);
   }
}



/* local/variant-removable */
obj_t 
local_variant_removable_17_inline_variant(local_bglt obj_43)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 552 */
      return
	 (((local_bglt) CREF(obj_43))->removable);
   }
}



/* _local/variant-removable */
obj_t 
_local_variant_removable_217_inline_variant(obj_t env_1495, obj_t obj_1496)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 552 */
      return
	 local_variant_removable_17_inline_variant(
	 (local_bglt) (obj_1496));
   }
}



/* local/variant-occurrence-set! */
obj_t 
local_variant_occurrence_set__206_inline_variant(local_bglt obj_44, long val1443_45)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 554 */
      return
	 ((((local_bglt) CREF(obj_44))->occurrence) = ((long) val1443_45), BUNSPEC);
   }
}



/* _local/variant-occurrence-set! */
obj_t 
_local_variant_occurrence_set__31_inline_variant(obj_t env_1497, obj_t obj_1498, obj_t val1443_1499)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 554 */
      return
	 local_variant_occurrence_set__206_inline_variant(
	 (local_bglt) (obj_1498),
	 (long) CINT(val1443_1499));
   }
}



/* local/variant-occurrence */
long 
local_variant_occurrence_19_inline_variant(local_bglt obj_46)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 554 */
      return
	 (((local_bglt) CREF(obj_46))->occurrence);
   }
}



/* _local/variant-occurrence */
obj_t 
_local_variant_occurrence_135_inline_variant(obj_t env_1500, obj_t obj_1501)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 554 */
      {		/* ./Ast/var.scm 554 */
	 long aux_1921;
	 aux_1921 =
	    local_variant_occurrence_19_inline_variant(
	    (local_bglt) (obj_1501));
	 return
	    BINT(aux_1921);
      }
   }
}



/* local/variant-user?-set! */
obj_t 
local_variant_user__set__143_inline_variant(local_bglt obj_47, bool_t val1444_48)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 578 */
      return
	 ((((local_bglt) CREF(obj_47))->user__32) = ((bool_t) val1444_48), BUNSPEC);
   }
}



/* _local/variant-user?-set! */
obj_t 
_local_variant_user__set__250_inline_variant(obj_t env_1502, obj_t obj_1503, obj_t val1444_1504)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 578 */
      return
	 local_variant_user__set__143_inline_variant(
	 (local_bglt) (obj_1503),
	 CBOOL(val1444_1504));
   }
}



/* local/variant-user? */
bool_t 
local_variant_user__42_inline_variant(local_bglt obj_49)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 578 */
      return
	 (((local_bglt) CREF(obj_49))->user__32);
   }
}



/* _local/variant-user? */
obj_t 
_local_variant_user__212_inline_variant(obj_t env_1505, obj_t obj_1506)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 578 */
      {		/* ./Ast/var.scm 578 */
	 bool_t aux_1930;
	 aux_1930 =
	    local_variant_user__42_inline_variant(
	    (local_bglt) (obj_1506));
	 return
	    BBOOL(aux_1930);
      }
   }
}



/* local/variant-key */
long 
local_variant_key_71_inline_variant(local_bglt obj_50)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 580 */
      return
	 (((local_bglt) CREF(obj_50))->key);
   }
}



/* _local/variant-key */
obj_t 
_local_variant_key_59_inline_variant(obj_t env_1507, obj_t obj_1508)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 580 */
      {		/* ./Ast/var.scm 580 */
	 long aux_1935;
	 aux_1935 =
	    local_variant_key_71_inline_variant(
	    (local_bglt) (obj_1508));
	 return
	    BINT(aux_1935);
      }
   }
}



/* local/variant-variant-set! */
obj_t 
local_variant_variant_set__103_inline_variant(local_variant_63_bglt obj_51, bool_t val1445_52)
{
   AN_OBJECT;
   {	/* Inline/variant.scm 19 */
      {
	 obj_t aux_1939;
	 {	/* Inline/variant.scm 19 */
	    object_bglt aux_1940;
	    aux_1940 =
	       (object_bglt) (obj_51);
	    aux_1939 =
	       OBJECT_WIDENING(aux_1940);
	 }
	 return
	    ((((local_variant_63_bglt) CREF(aux_1939))->variant) = ((bool_t) val1445_52), BUNSPEC);
      }
   }
}



/* _local/variant-variant-set! */
obj_t 
_local_variant_variant_set__191_inline_variant(obj_t env_1509, obj_t obj_1510, obj_t val1445_1511)
{
   AN_OBJECT;
   {	/* Inline/variant.scm 19 */
      return
	 local_variant_variant_set__103_inline_variant(
	 (local_variant_63_bglt) (obj_1510),
	 CBOOL(val1445_1511));
   }
}



/* local/variant-variant */
bool_t 
local_variant_variant_215_inline_variant(local_variant_63_bglt obj_53)
{
   AN_OBJECT;
   {	/* Inline/variant.scm 19 */
      {
	 obj_t aux_1947;
	 {	/* Inline/variant.scm 19 */
	    object_bglt aux_1948;
	    aux_1948 =
	       (object_bglt) (obj_53);
	    aux_1947 =
	       OBJECT_WIDENING(aux_1948);
	 }
	 return
	    (((local_variant_63_bglt) CREF(aux_1947))->variant);
      }
   }
}



/* _local/variant-variant */
obj_t 
_local_variant_variant_49_inline_variant(obj_t env_1512, obj_t obj_1513)
{
   AN_OBJECT;
   {	/* Inline/variant.scm 19 */
      {		/* Inline/variant.scm 19 */
	 bool_t aux_1952;
	 aux_1952 =
	    local_variant_variant_215_inline_variant(
	    (local_variant_63_bglt) (obj_1513));
	 return
	    BBOOL(aux_1952);
      }
   }
}



/* method-init */
obj_t 
method_init_76_inline_variant()
{
   AN_OBJECT;
   {	/* Inline/variant.scm 14 */
      {		/* Inline/variant.scm 14 */
	 obj_t object__struct_local_variant1473_69_1518;
	 object__struct_local_variant1473_69_1518 = proc1664_inline_variant;
	 add_method__1___object(object__struct_env_210___object, local_variant_63_inline_variant, object__struct_local_variant1473_69_1518);
      }
      {		/* Inline/variant.scm 14 */
	 obj_t struct_object__object_local_variant1475_65_1514;
	 struct_object__object_local_variant1475_65_1514 = proc1665_inline_variant;
	 return
	    add_method__1___object(struct_object__object_env_209___object, local_variant_63_inline_variant, struct_object__object_local_variant1475_65_1514);
      }
   }
}



/* struct+object->object-local/variant1475 */
obj_t 
struct_object__object_local_variant1475_65_inline_variant(obj_t env_1521, obj_t o_1522, obj_t s_1523)
{
   AN_OBJECT;
   {	/* Inline/variant.scm 19 */
      {
	 local_variant_63_bglt o_1222;
	 obj_t s_1223;
	 {	/* Inline/variant.scm 19 */
	    local_variant_63_bglt aux_1958;
	    o_1222 =
	       (local_variant_63_bglt) (o_1522);
	    s_1223 = s_1523;
	    {

	       {	/* Inline/variant.scm 19 */
		  obj_t old1456_1226;
		  obj_t aux1457_1227;
		  {	/* Inline/variant.scm 19 */
		     obj_t next_method1474_219_1232;
		     next_method1474_219_1232 =
			find_super_class_method_167___object(
			(object_bglt) (o_1222), struct_object__object_env_209___object, local_variant_63_inline_variant);
		     if (
			PROCEDUREP(next_method1474_219_1232))
		       {	/* Inline/variant.scm 19 */
			  old1456_1226 =
			     PROCEDURE_ENTRY(next_method1474_219_1232) (next_method1474_219_1232,
			     (obj_t) (o_1222), s_1223, BEOA);
		       }
		     else
		       {	/* Inline/variant.scm 19 */
			  PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method1474_219_1232);
			  {	/* Inline/variant.scm 19 */
			     object_bglt aux_1967;
			     aux_1967 =
				struct_object__object_93___object(
				(object_bglt) (o_1222), s_1223);
			     old1456_1226 =
				(obj_t) (aux_1967);
			  }
		       }
		  }
		  aux1457_1227 =
		     STRUCT_REF(s_1223, ((long) 0));
		  {	/* Inline/variant.scm 19 */
		     local_variant_63_bglt new1458_1228;
		     new1458_1228 =
			((local_variant_63_bglt) (old1456_1226));
		     {	/* Inline/variant.scm 19 */
			long arg1651_1229;
			arg1651_1229 =
			   class_num_218___object(local_variant_63_inline_variant);
			{	/* Inline/variant.scm 19 */
			   obj_t obj_1425;
			   obj_1425 =
			      (obj_t) (new1458_1228);
			   (((obj_t) CREF(obj_1425))->header = MAKE_HEADER(arg1651_1229, 0), BUNSPEC);
			}
		     }
		     {	/* Inline/variant.scm 19 */
			local_variant_63_bglt arg1652_1230;
			{	/* Inline/variant.scm 19 */
			   local_variant_63_bglt res1660_1432;
			   {	/* Inline/variant.scm 19 */
			      bool_t variant_1429;
			      {		/* Inline/variant.scm 19 */
				 obj_t aux_1976;
				 aux_1976 =
				    STRUCT_REF(aux1457_1227, ((long) 0));
				 variant_1429 =
				    CBOOL(aux_1976);
			      }
			      {		/* Inline/variant.scm 19 */
				 local_variant_63_bglt new1446_1430;
				 new1446_1430 =
				    ((local_variant_63_bglt) BREF(GC_MALLOC(sizeof(struct local_variant_63))));
				 ((((local_variant_63_bglt) CREF(new1446_1430))->variant) = ((bool_t) variant_1429), BUNSPEC);
				 res1660_1432 = new1446_1430;
			      }
			   }
			   arg1652_1230 = res1660_1432;
			}
			{	/* Inline/variant.scm 19 */
			   obj_t aux_1983;
			   object_bglt aux_1981;
			   aux_1983 =
			      (obj_t) (arg1652_1230);
			   aux_1981 =
			      (object_bglt) (new1458_1228);
			   OBJECT_WIDENING_SET(aux_1981, aux_1983);
			}
		     }
		     aux_1958 = new1458_1228;
		  }
	       }
	    }
	    return
	       (obj_t) (aux_1958);
	 }
      }
   }
}



/* object->struct-local/variant1473 */
obj_t 
object__struct_local_variant1473_69_inline_variant(obj_t env_1524, obj_t obj1453_1525)
{
   AN_OBJECT;
   {	/* Inline/variant.scm 19 */
      {
	 local_variant_63_bglt obj1453_1212;
	 obj1453_1212 =
	    (local_variant_63_bglt) (obj1453_1525);
	 {

	    {	/* Inline/variant.scm 19 */
	       obj_t res1454_1215;
	       {	/* Inline/variant.scm 19 */
		  obj_t next_method1472_163_1220;
		  next_method1472_163_1220 =
		     find_super_class_method_167___object(
		     (object_bglt) (obj1453_1212), object__struct_env_210___object, local_variant_63_inline_variant);
		  if (
		     PROCEDUREP(next_method1472_163_1220))
		    {	/* Inline/variant.scm 19 */
		       res1454_1215 =
			  PROCEDURE_ENTRY(next_method1472_163_1220) (next_method1472_163_1220,
			  (obj_t) (obj1453_1212), BEOA);
		    }
		  else
		    {	/* Inline/variant.scm 19 */
		       PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method1472_163_1220);
		       res1454_1215 =
			  object__struct_50___object(
			  (object_bglt) (obj1453_1212));
		    }
	       }
	       {	/* Inline/variant.scm 19 */
		  obj_t aux1455_1216;
		  {	/* ./Llib/struct.scm 1415 */
		     obj_t aux_1998;
		     aux_1998 =
			CNST_TABLE_REF(((long) 2));
		     aux1455_1216 =
			make_struct(aux_1998, ((long) 1), BUNSPEC);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_2001;
		     {	/* Inline/variant.scm 19 */
			bool_t aux_2002;
			{
			   obj_t aux_2003;
			   {	/* Inline/variant.scm 19 */
			      object_bglt aux_2004;
			      aux_2004 =
				 (object_bglt) (obj1453_1212);
			      aux_2003 =
				 OBJECT_WIDENING(aux_2004);
			   }
			   aux_2002 =
			      (((local_variant_63_bglt) CREF(aux_2003))->variant);
			}
			aux_2001 =
			   BBOOL(aux_2002);
		     }
		     STRUCT_SET(aux1455_1216, ((long) 0), aux_2001);
		  }
		  STRUCT_SET(res1454_1215, ((long) 0), aux1455_1216);
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_2011;
		     aux_2011 =
			STRUCT_KEY(res1454_1215);
		     STRUCT_KEY_SET(aux1455_1216, aux_2011);
		  }
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_2014;
		     aux_2014 =
			CNST_TABLE_REF(((long) 2));
		     STRUCT_KEY_SET(res1454_1215, aux_2014);
		  }
		  return res1454_1215;
	       }
	    }
	 }
      }
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_inline_variant()
{
   AN_OBJECT;
   {	/* Inline/variant.scm 14 */
      module_initialization_70_tools_trace(((long) 0), "INLINE_VARIANT");
      module_initialization_70_type_type(((long) 0), "INLINE_VARIANT");
      module_initialization_70_ast_var(((long) 0), "INLINE_VARIANT");
      return
	 module_initialization_70_ast_node(((long) 0), "INLINE_VARIANT");
   }
}
