/*===========================================================================*/
/*   (Inline/walk.scm)                                                       */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;

typedef struct ccomp
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t producer;
     obj_t consumer;
     obj_t finalizer;
     obj_t checksummer;
  }
     *ccomp_bglt;


static obj_t show_stat__192_inline_walk();
static obj_t method_init_76_inline_walk();
extern obj_t inline_sfun__229_inline_inline(variable_bglt, long, obj_t);
extern obj_t _optim__89_engine_param;
extern obj_t current_error_port;
extern obj_t _inlining_kfactor__130_engine_param;
extern obj_t _nb_error_on_pass__70_tools_error;
extern obj_t leave_function_170_tools_error();
static obj_t _reset_stat__205_inline_walk(obj_t);
extern obj_t notify_assert_fail_37___eval(obj_t, obj_t, obj_t);
extern obj_t verbose_tools_speek(obj_t, obj_t);
static obj_t reset_stat__225_inline_walk();
extern obj_t module_initialization_70_inline_walk(long, char *);
extern obj_t module_initialization_70_tools_speek(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_engine_pass(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_module_module(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_ast_remove(long, char *);
extern obj_t module_initialization_70_inline_inline(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___eval(long, char *);
extern obj_t module_initialization_70___evenv(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_numbers_6_5(long, char *);
extern obj_t module_initialization_70___r4_output_6_10_3(long, char *);
static obj_t _show_stat__92_inline_walk(obj_t);
extern obj_t define_primop_ref__105___evenv(obj_t, obj_t);
extern obj_t display_2_122___r4_output_6_10_3(obj_t, obj_t);
static obj_t _inline_setup__52_inline_walk(obj_t, obj_t);
static obj_t imported_modules_init_94_inline_walk();
extern obj_t unbind_primop__163___evenv(obj_t);
static obj_t library_modules_init_112_inline_walk();
static obj_t toplevel_init_63_inline_walk();
extern obj_t open_input_string(obj_t);
obj_t _non_inlined_calls__201_inline_walk = BUNSPEC;
extern obj_t string_to_bstring(char *);
extern obj_t inline_walk__185_inline_walk(obj_t, obj_t);
extern obj_t enter_function_81_tools_error(obj_t);
extern obj_t memq___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern obj_t remove_var_123_ast_remove(obj_t, obj_t);
extern obj_t internal_error_43_tools_error(obj_t, obj_t, obj_t);
extern obj_t _module__166_module_module;
obj_t _kfactor__149_inline_walk = BUNSPEC;
extern bool_t _2__206___r4_numbers_6_5(obj_t, obj_t);
extern obj_t read___reader(obj_t);
obj_t _inlined_calls__118_inline_walk = BUNSPEC;
extern obj_t inline_setup__219_inline_walk(obj_t);
static obj_t require_initialization_114_inline_walk = BUNSPEC;
static obj_t cnst_init_137_inline_walk();
extern obj_t reverse__39___r4_pairs_and_lists_6_3(obj_t);
extern obj_t _current_pass__25_engine_pass;
static obj_t _inline_walk__25_inline_walk(obj_t, obj_t, obj_t);
static obj_t __cnst[12];

DEFINE_STATIC_PROCEDURE(show_stat__env_142_inline_walk, _show_stat__92_inline_walk1612, _show_stat__92_inline_walk, 0L, 0);
DEFINE_STATIC_PROCEDURE(reset_stat__env_118_inline_walk, _reset_stat__205_inline_walk1613, _reset_stat__205_inline_walk, 0L, 0);
DEFINE_EXPORT_PROCEDURE(inline_setup__env_11_inline_walk, _inline_setup__52_inline_walk1614, _inline_setup__52_inline_walk, 0L, 1);
DEFINE_EXPORT_PROCEDURE(inline_walk__env_203_inline_walk, _inline_walk__25_inline_walk1615, _inline_walk__25_inline_walk, 0L, 2);
DEFINE_STRING(string1599_inline_walk, string1599_inline_walk1616, " error", 6);
DEFINE_STRING(string1598_inline_walk, string1598_inline_walk1617, "failure during prelude hook", 27);
DEFINE_STRING(string1597_inline_walk, string1597_inline_walk1618, "   . ", 5);
DEFINE_STRING(string1607_inline_walk, string1607_inline_walk1619, "REDUCER ALL (SHOW-STAT!) INLINE SIFUN (RESET-STAT!) PASS-STARTED (\"/home/tahoe2/serrano/tmp/bigloo/comptime/Inline/walk.scm\" . 1514) (BEGIN (MEMQ WHAT (QUOTE (ALL REDUCER)))) (WHAT) WHAT (ALL REDUCER) ", 201);
DEFINE_STRING(string1596_inline_walk, string1596_inline_walk1620, "Inlining", 8);
DEFINE_STRING(string1606_inline_walk, string1606_inline_walk1621, "Illegal mode", 12);
DEFINE_STRING(string1605_inline_walk, string1605_inline_walk1622, "inline-setup!", 13);
DEFINE_STRING(string1604_inline_walk, string1604_inline_walk1623, "      (non inlined calls : ", 27);
DEFINE_STRING(string1603_inline_walk, string1603_inline_walk1624, "      (inlined calls     : ", 27);
DEFINE_STRING(string1602_inline_walk, string1602_inline_walk1625, ")\n", 2);
DEFINE_STRING(string1601_inline_walk, string1601_inline_walk1626, "failure during postlude hook", 28);
DEFINE_STRING(string1600_inline_walk, string1600_inline_walk1627, " occured, ending ...", 20);



/* module-initialization */
obj_t 
module_initialization_70_inline_walk(long checksum_1175, char *from_1176)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_inline_walk))
	{
	   require_initialization_114_inline_walk =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_inline_walk();
	   cnst_init_137_inline_walk();
	   imported_modules_init_94_inline_walk();
	   method_init_76_inline_walk();
	   toplevel_init_63_inline_walk();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_inline_walk()
{
   AN_OBJECT;
   {	/* Inline/walk.scm 14 */
      module_initialization_70___eval(((long) 0), "INLINE_WALK");
      module_initialization_70___evenv(((long) 0), "INLINE_WALK");
      module_initialization_70___r4_output_6_10_3(((long) 0), "INLINE_WALK");
      module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "INLINE_WALK");
      module_initialization_70___r4_numbers_6_5(((long) 0), "INLINE_WALK");
      module_initialization_70___reader(((long) 0), "INLINE_WALK");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_inline_walk()
{
   AN_OBJECT;
   {	/* Inline/walk.scm 14 */
      {		/* Inline/walk.scm 14 */
	 obj_t cnst_port_138_1168;
	 cnst_port_138_1168 =
	    open_input_string(string1607_inline_walk);
	 {
	    long i_1169;
	    i_1169 = ((long) 11);
	  loop_1170:
	    {	/* Inline/walk.scm 14 */
	       bool_t test1608_1171;
	       test1608_1171 =
		  (i_1169 == ((long) -1));
	       if (test1608_1171)
		 {	/* Inline/walk.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Inline/walk.scm 14 */
		    {	/* Inline/walk.scm 14 */
		       obj_t arg1609_1172;
		       {	/* Inline/walk.scm 14 */
			  obj_t list1610_1173;
			  list1610_1173 =
			     MAKE_PAIR(cnst_port_138_1168, BNIL);
			  arg1609_1172 =
			     read___reader(list1610_1173);
		       }
		       CNST_TABLE_SET(i_1169, arg1609_1172);
		    }
		    {	/* Inline/walk.scm 14 */
		       int aux_1174;
		       {	/* Inline/walk.scm 14 */
			  long aux_1197;
			  aux_1197 =
			     (i_1169 - ((long) 1));
			  aux_1174 =
			     (int) (aux_1197);
		       }
		       {
			  long i_1200;
			  i_1200 =
			     (long) (aux_1174);
			  i_1169 = i_1200;
			  goto loop_1170;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_inline_walk()
{
   AN_OBJECT;
   {	/* Inline/walk.scm 14 */
      _inlined_calls__118_inline_walk =
	 BINT(((long) 0));
      _non_inlined_calls__201_inline_walk =
	 BINT(((long) 0));
      return (
	 _kfactor__149_inline_walk =
	 BINT(((long) 1)), BUNSPEC);
   }
}



/* inline-walk! */
obj_t 
inline_walk__185_inline_walk(obj_t globals_1, obj_t what_2)
{
   AN_OBJECT;
   {	/* Inline/walk.scm 33 */
      {		/* Inline/walk.scm 34 */
	 bool_t test_1205;
	 {	/* Inline/walk.scm 34 */
	    obj_t aux_1206;
	    aux_1206 =
	       memq___r4_pairs_and_lists_6_3(what_2,
	       CNST_TABLE_REF(((long) 0)));
	    test_1205 =
	       CBOOL(aux_1206);
	 }
	 if (test_1205)
	   {	/* Inline/walk.scm 34 */
	      BUNSPEC;
	   }
	 else
	   {	/* Inline/walk.scm 34 */
	      {		/* Inline/walk.scm 34 */
		 obj_t arg1449_711;
		 obj_t arg1450_712;
		 arg1449_711 =
		    CNST_TABLE_REF(((long) 1));
		 arg1450_712 =
		    __EVMEANING_ADDRESS(what_2);
		 define_primop_ref__105___evenv(arg1449_711, arg1450_712);
	      }
	      notify_assert_fail_37___eval(
		 CNST_TABLE_REF(((long) 2)),
		 CNST_TABLE_REF(((long) 3)),
		 CNST_TABLE_REF(((long) 4)));
	      unbind_primop__163___evenv(
		 CNST_TABLE_REF(((long) 1)));
	   }
      }
      {		/* Inline/walk.scm 34 */
	 obj_t list1451_713;
	 {	/* Inline/walk.scm 34 */
	    obj_t arg1454_715;
	    {	/* Inline/walk.scm 34 */
	       obj_t arg1456_717;
	       {	/* Inline/walk.scm 34 */
		  obj_t aux_1219;
		  aux_1219 =
		     BCHAR(((unsigned char) '\n'));
		  arg1456_717 =
		     MAKE_PAIR(aux_1219, BNIL);
	       }
	       arg1454_715 =
		  MAKE_PAIR(string1596_inline_walk, arg1456_717);
	    }
	    list1451_713 =
	       MAKE_PAIR(string1597_inline_walk, arg1454_715);
	 }
	 verbose_tools_speek(
	    BINT(((long) 1)), list1451_713);
      }
      _nb_error_on_pass__70_tools_error =
	 BINT(((long) 0));
      _current_pass__25_engine_pass = string1596_inline_walk;
      {
	 obj_t hooks_718;
	 obj_t hnames_719;
	 {	/* Inline/walk.scm 34 */
	    obj_t arg1457_721;
	    obj_t arg1458_722;
	    {	/* Inline/walk.scm 34 */
	       obj_t list1459_723;
	       list1459_723 =
		  MAKE_PAIR(reset_stat__env_118_inline_walk, BNIL);
	       arg1457_721 = list1459_723;
	    }
	    arg1458_722 =
	       CNST_TABLE_REF(((long) 6));
	    hooks_718 = arg1457_721;
	    hnames_719 = arg1458_722;
	  loop_720:
	    if (
	       NULLP(hooks_718))
	      {		/* Inline/walk.scm 34 */
		 CNST_TABLE_REF(((long) 5));
	      }
	    else
	      {		/* Inline/walk.scm 34 */
		 bool_t test1461_725;
		 {	/* Inline/walk.scm 34 */
		    obj_t fun1470_731;
		    fun1470_731 =
		       CAR(hooks_718);
		    {	/* Inline/walk.scm 34 */
		       obj_t aux_1233;
		       aux_1233 =
			  PROCEDURE_ENTRY(fun1470_731) (fun1470_731, BEOA);
		       test1461_725 =
			  CBOOL(aux_1233);
		    }
		 }
		 if (test1461_725)
		   {	/* Inline/walk.scm 34 */
		      {
			 obj_t hnames_1240;
			 obj_t hooks_1238;
			 hooks_1238 =
			    CDR(hooks_718);
			 hnames_1240 =
			    CDR(hnames_719);
			 hnames_719 = hnames_1240;
			 hooks_718 = hooks_1238;
			 goto loop_720;
		      }
		   }
		 else
		   {	/* Inline/walk.scm 34 */
		      internal_error_43_tools_error(string1596_inline_walk, string1598_inline_walk,
			 CAR(hnames_719));
		   }
	      }
	 }
      }
      inline_setup__219_inline_walk(what_2);
      {
	 obj_t l1445_732;
	 l1445_732 = globals_1;
       lname1446_733:
	 if (
	    PAIRP(l1445_732))
	   {	/* Inline/walk.scm 39 */
	      {		/* Inline/walk.scm 40 */
		 obj_t g_735;
		 g_735 =
		    CAR(l1445_732);
		 {	/* Inline/walk.scm 40 */
		    obj_t kfactor_736;
		    {	/* Inline/walk.scm 40 */
		       bool_t test_1248;
		       {	/* ./Ieee/equiv.scm 5508 */
			  obj_t aux_1255;
			  obj_t aux_1249;
			  aux_1255 =
			     CNST_TABLE_REF(((long) 7));
			  {	/* Inline/walk.scm 40 */
			     sfun_bglt obj_1130;
			     {	/* Inline/walk.scm 40 */
				value_bglt aux_1250;
				{	/* Inline/walk.scm 40 */
				   global_bglt obj_1129;
				   obj_1129 =
				      (global_bglt) (g_735);
				   aux_1250 =
				      (((global_bglt) CREF(obj_1129))->value);
				}
				obj_1130 =
				   (sfun_bglt) (aux_1250);
			     }
			     aux_1249 =
				(((sfun_bglt) CREF(obj_1130))->class);
			  }
			  test_1248 =
			     (aux_1249 == aux_1255);
		       }
		       if (test_1248)
			 {	/* Inline/walk.scm 40 */
			    kfactor_736 =
			       BINT(((long) 1));
			 }
		       else
			 {	/* Inline/walk.scm 40 */
			    kfactor_736 = _kfactor__149_inline_walk;
			 }
		    }
		    {	/* Inline/walk.scm 46 */
		       obj_t aux_1259;
		       {	/* Inline/walk.scm 46 */
			  global_bglt obj_1133;
			  obj_1133 =
			     (global_bglt) (g_735);
			  aux_1259 =
			     (((global_bglt) CREF(obj_1133))->id);
		       }
		       enter_function_81_tools_error(aux_1259);
		    }
		    inline_sfun__229_inline_inline(
		       (variable_bglt) (g_735),
		       (long) CINT(kfactor_736), BNIL);
		    leave_function_170_tools_error();
		 }
	      }
	      {
		 obj_t l1445_1267;
		 l1445_1267 =
		    CDR(l1445_732);
		 l1445_732 = l1445_1267;
		 goto lname1446_733;
	      }
	   }
	 else
	   {	/* Inline/walk.scm 39 */
	      ((bool_t) 1);
	   }
      }
      {
	 obj_t globals_743;
	 obj_t new_globals_42_744;
	 globals_743 = globals_1;
	 new_globals_42_744 = BNIL;
       loop_745:
	 if (
	    NULLP(globals_743))
	   {	/* Inline/walk.scm 54 */
	      {		/* Inline/walk.scm 55 */
		 obj_t value_747;
		 {	/* Inline/walk.scm 55 */
		    obj_t arg1493_766;
		    obj_t arg1494_767;
		    arg1493_766 =
		       CNST_TABLE_REF(((long) 8));
		    arg1494_767 =
		       reverse__39___r4_pairs_and_lists_6_3(new_globals_42_744);
		    value_747 =
		       remove_var_123_ast_remove(arg1493_766, arg1494_767);
		 }
		 {	/* Inline/walk.scm 55 */
		    bool_t test1479_748;
		    {	/* Inline/walk.scm 55 */
		       long n1_1136;
		       n1_1136 =
			  (long) CINT(_nb_error_on_pass__70_tools_error);
		       test1479_748 =
			  (n1_1136 > ((long) 0));
		    }
		    if (test1479_748)
		      {		/* Inline/walk.scm 55 */
			 display_2_122___r4_output_6_10_3(_nb_error_on_pass__70_tools_error, current_error_port);
			 display_2_122___r4_output_6_10_3(string1599_inline_walk, current_error_port);
			 {	/* Inline/walk.scm 55 */
			    char *arg1480_750;
			    {	/* Inline/walk.scm 55 */
			       bool_t test1481_751;
			       {	/* Inline/walk.scm 55 */
				  bool_t test1482_752;
				  {	/* Inline/walk.scm 55 */
				     obj_t obj_1138;
				     obj_1138 = _nb_error_on_pass__70_tools_error;
				     test1482_752 =
					INTEGERP(obj_1138);
				  }
				  if (test1482_752)
				    {	/* Inline/walk.scm 55 */
				       test1481_751 =
					  _2__206___r4_numbers_6_5(_nb_error_on_pass__70_tools_error,
					  BINT(((long) 1)));
				    }
				  else
				    {	/* Inline/walk.scm 55 */
				       test1481_751 = ((bool_t) 0);
				    }
			       }
			       if (test1481_751)
				 {	/* Inline/walk.scm 55 */
				    arg1480_750 = "s";
				 }
			       else
				 {	/* Inline/walk.scm 55 */
				    arg1480_750 = "";
				 }
			    }
			    display_2_122___r4_output_6_10_3(
			       string_to_bstring(arg1480_750), current_error_port);
			 }
			 display_2_122___r4_output_6_10_3(string1600_inline_walk, current_error_port);
			 WRITE_CHAR(((unsigned char) '\n'), current_error_port);
			 {	/* Inline/walk.scm 55 */
			    obj_t res1595_1141;
			    exit(((long) -1));
			    res1595_1141 =
			       BINT(((long) -1));
			    return res1595_1141;
			 }
		      }
		    else
		      {
			 obj_t hooks_753;
			 obj_t hnames_754;
			 {	/* Inline/walk.scm 55 */
			    obj_t arg1483_756;
			    obj_t arg1484_757;
			    {	/* Inline/walk.scm 55 */
			       obj_t list1485_758;
			       list1485_758 =
				  MAKE_PAIR(show_stat__env_142_inline_walk, BNIL);
			       arg1483_756 = list1485_758;
			    }
			    arg1484_757 =
			       CNST_TABLE_REF(((long) 9));
			    hooks_753 = arg1483_756;
			    hnames_754 = arg1484_757;
			  loop_755:
			    if (
			       NULLP(hooks_753))
			      {		/* Inline/walk.scm 55 */
				 return value_747;
			      }
			    else
			      {		/* Inline/walk.scm 55 */
				 bool_t test1487_760;
				 {	/* Inline/walk.scm 55 */
				    obj_t fun1492_765;
				    fun1492_765 =
				       CAR(hooks_753);
				    {	/* Inline/walk.scm 55 */
				       obj_t aux_1295;
				       aux_1295 =
					  PROCEDURE_ENTRY(fun1492_765) (fun1492_765, BEOA);
				       test1487_760 =
					  CBOOL(aux_1295);
				    }
				 }
				 if (test1487_760)
				   {	/* Inline/walk.scm 55 */
				      {
					 obj_t hnames_1302;
					 obj_t hooks_1300;
					 hooks_1300 =
					    CDR(hooks_753);
					 hnames_1302 =
					    CDR(hnames_754);
					 hnames_754 = hnames_1302;
					 hooks_753 = hooks_1300;
					 goto loop_755;
				      }
				   }
				 else
				   {	/* Inline/walk.scm 55 */
				      return
					 internal_error_43_tools_error(_current_pass__25_engine_pass, string1601_inline_walk,
					 CAR(hnames_754));
				   }
			      }
			 }
		      }
		 }
	      }
	   }
	 else
	   {	/* Inline/walk.scm 57 */
	      bool_t test1495_768;
	      {		/* Inline/walk.scm 57 */
		 obj_t obj2_1151;
		 obj2_1151 = _module__166_module_module;
		 {	/* ./Ieee/equiv.scm 5508 */
		    obj_t aux_1306;
		    {	/* Inline/walk.scm 57 */
		       global_bglt obj_1149;
		       {	/* Inline/walk.scm 57 */
			  obj_t aux_1307;
			  aux_1307 =
			     CAR(globals_743);
			  obj_1149 =
			     (global_bglt) (aux_1307);
		       }
		       aux_1306 =
			  (((global_bglt) CREF(obj_1149))->module);
		    }
		    test1495_768 =
		       (aux_1306 == obj2_1151);
		 }
	      }
	      if (test1495_768)
		{	/* Inline/walk.scm 57 */
		   {	/* Inline/walk.scm 58 */
		      obj_t arg1496_769;
		      obj_t arg1497_770;
		      arg1496_769 =
			 CDR(globals_743);
		      {		/* ./Ieee/pair-list.scm 5689 */
			 obj_t aux_1314;
			 aux_1314 =
			    CAR(globals_743);
			 arg1497_770 =
			    MAKE_PAIR(aux_1314, new_globals_42_744);
		      }
		      {
			 obj_t new_globals_42_1318;
			 obj_t globals_1317;
			 globals_1317 = arg1496_769;
			 new_globals_42_1318 = arg1497_770;
			 new_globals_42_744 = new_globals_42_1318;
			 globals_743 = globals_1317;
			 goto loop_745;
		      }
		   }
		}
	      else
		{	/* Inline/walk.scm 57 */
		   {
		      obj_t globals_1319;
		      globals_1319 =
			 CDR(globals_743);
		      globals_743 = globals_1319;
		      goto loop_745;
		   }
		}
	   }
      }
   }
}



/* _inline-walk! */
obj_t 
_inline_walk__25_inline_walk(obj_t env_1161, obj_t globals_1162, obj_t what_1163)
{
   AN_OBJECT;
   {	/* Inline/walk.scm 33 */
      return
	 inline_walk__185_inline_walk(globals_1162, what_1163);
   }
}



/* reset-stat! */
obj_t 
reset_stat__225_inline_walk()
{
   AN_OBJECT;
   {	/* Inline/walk.scm 71 */
      _inlined_calls__118_inline_walk =
	 BINT(((long) 0));
      return (
	 _non_inlined_calls__201_inline_walk =
	 BINT(((long) 0)), BUNSPEC);
   }
}



/* _reset-stat! */
obj_t 
_reset_stat__205_inline_walk(obj_t env_1164)
{
   AN_OBJECT;
   {	/* Inline/walk.scm 71 */
      return
	 reset_stat__225_inline_walk();
   }
}



/* show-stat! */
obj_t 
show_stat__192_inline_walk()
{
   AN_OBJECT;
   {	/* Inline/walk.scm 78 */
      {		/* Inline/walk.scm 79 */
	 obj_t list1502_775;
	 {	/* Inline/walk.scm 79 */
	    obj_t arg1504_777;
	    {	/* Inline/walk.scm 79 */
	       obj_t arg1505_778;
	       arg1505_778 =
		  MAKE_PAIR(string1602_inline_walk, BNIL);
	       arg1504_777 =
		  MAKE_PAIR(_inlined_calls__118_inline_walk, arg1505_778);
	    }
	    list1502_775 =
	       MAKE_PAIR(string1603_inline_walk, arg1504_777);
	 }
	 verbose_tools_speek(
	    BINT(((long) 2)), list1502_775);
      }
      {		/* Inline/walk.scm 80 */
	 obj_t list1506_779;
	 {	/* Inline/walk.scm 80 */
	    obj_t arg1509_781;
	    {	/* Inline/walk.scm 80 */
	       obj_t arg1510_782;
	       arg1510_782 =
		  MAKE_PAIR(string1602_inline_walk, BNIL);
	       arg1509_781 =
		  MAKE_PAIR(_non_inlined_calls__201_inline_walk, arg1510_782);
	    }
	    list1506_779 =
	       MAKE_PAIR(string1604_inline_walk, arg1509_781);
	 }
	 return
	    verbose_tools_speek(
	    BINT(((long) 2)), list1506_779);
      }
   }
}



/* _show-stat! */
obj_t 
_show_stat__92_inline_walk(obj_t env_1165)
{
   AN_OBJECT;
   {	/* Inline/walk.scm 78 */
      return
	 show_stat__192_inline_walk();
   }
}



/* inline-setup! */
obj_t 
inline_setup__219_inline_walk(obj_t what_3)
{
   AN_OBJECT;
   {	/* Inline/walk.scm 86 */
      {		/* Inline/walk.scm 88 */
	 bool_t test_1336;
	 {	/* ./Ieee/equiv.scm 5508 */
	    obj_t aux_1337;
	    aux_1337 =
	       CNST_TABLE_REF(((long) 10));
	    test_1336 =
	       (what_3 == aux_1337);
	 }
	 if (test_1336)
	   {	/* Inline/walk.scm 88 */
	      return (
		 _kfactor__149_inline_walk =
		 PROCEDURE_ENTRY(_inlining_kfactor__130_engine_param) (_inlining_kfactor__130_engine_param, _optim__89_engine_param, BEOA), BUNSPEC);
	   }
	 else
	   {	/* Inline/walk.scm 88 */
	      bool_t test_1342;
	      {		/* ./Ieee/equiv.scm 5508 */
		 obj_t aux_1343;
		 aux_1343 =
		    CNST_TABLE_REF(((long) 11));
		 test_1342 =
		    (what_3 == aux_1343);
	      }
	      if (test_1342)
		{	/* Inline/walk.scm 88 */
		   return (
		      _kfactor__149_inline_walk =
		      BINT(((long) 1)), BUNSPEC);
		}
	      else
		{	/* Inline/walk.scm 88 */
		   return
		      internal_error_43_tools_error(string1605_inline_walk, string1606_inline_walk, what_3);
		}
	   }
      }
   }
}



/* _inline-setup! */
obj_t 
_inline_setup__52_inline_walk(obj_t env_1166, obj_t what_1167)
{
   AN_OBJECT;
   {	/* Inline/walk.scm 86 */
      return
	 inline_setup__219_inline_walk(what_1167);
   }
}



/* method-init */
obj_t 
method_init_76_inline_walk()
{
   AN_OBJECT;
   {	/* Inline/walk.scm 14 */
      return BUNSPEC;
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_inline_walk()
{
   AN_OBJECT;
   {	/* Inline/walk.scm 14 */
      module_initialization_70_tools_speek(((long) 0), "INLINE_WALK");
      module_initialization_70_tools_error(((long) 0), "INLINE_WALK");
      module_initialization_70_engine_pass(((long) 0), "INLINE_WALK");
      module_initialization_70_tools_trace(((long) 0), "INLINE_WALK");
      module_initialization_70_type_type(((long) 0), "INLINE_WALK");
      module_initialization_70_ast_var(((long) 0), "INLINE_WALK");
      module_initialization_70_ast_node(((long) 0), "INLINE_WALK");
      module_initialization_70_tools_shape(((long) 0), "INLINE_WALK");
      module_initialization_70_module_module(((long) 0), "INLINE_WALK");
      module_initialization_70_engine_param(((long) 0), "INLINE_WALK");
      module_initialization_70_ast_remove(((long) 0), "INLINE_WALK");
      return
	 module_initialization_70_inline_inline(((long) 0), "INLINE_WALK");
   }
}
