/*===========================================================================*/
/*   (Integrate/a.scm)                                                       */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;

typedef struct svar_iinfo_76
  {
     obj_t f_mark_181;
     obj_t u_mark_209;
     bool_t kaptured__204;
     bool_t celled__113;
  }
             *svar_iinfo_76_bglt;

typedef struct sexit_iinfo_190
  {
     obj_t f_mark_181;
     obj_t u_mark_209;
     bool_t kaptured__204;
     bool_t celled__113;
  }
               *sexit_iinfo_190_bglt;

typedef struct sfun_iinfo_105
  {
     obj_t owner;
     obj_t free;
     obj_t bound;
     obj_t cfrom;
     obj_t cto;
     obj_t k;
     obj_t k__190;
     obj_t u;
     obj_t cn;
     obj_t ct;
     obj_t kont;
     bool_t g__219;
     obj_t l;
     obj_t led;
     obj_t istamp;
     obj_t global;
     obj_t kaptured;
  }
              *sfun_iinfo_105_bglt;


static bool_t initialize_fun__49_integrate_a(variable_bglt, variable_bglt);
static obj_t method_init_76_integrate_a();
extern obj_t make_box_202_ast_node;
extern obj_t funcall_ast_node;
extern long add_inlined_method__244___object(obj_t, obj_t, long);
extern obj_t fail_ast_node;
extern obj_t box_ref_242_ast_node;
extern obj_t sequence_ast_node;
extern obj_t let_var_6_ast_node;
extern obj_t var_ast_node;
extern obj_t closure_ast_node;
extern obj_t global_ast_var;
static obj_t _node_a1838_171_integrate_a(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t pragma_ast_node;
extern obj_t set_ex_it_116_ast_node;
static obj_t get_new_kont_177_integrate_a();
extern obj_t sfun_iinfo_105_integrate_info;
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t module_initialization_70_integrate_a(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_integrate_info(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
static obj_t node_a_default1540_44_integrate_a(node_bglt, variable_bglt, obj_t, obj_t);
extern obj_t sexit_iinfo_190_integrate_info;
extern obj_t svar_iinfo_76_integrate_info;
extern long class_num_218___object(obj_t);
static obj_t _a1837_integrate_a(obj_t, obj_t, obj_t);
extern obj_t let_fun_218_ast_node;
static obj_t node_a_141_integrate_a(node_bglt, variable_bglt, obj_t, obj_t);
static obj_t imported_modules_init_94_integrate_a();
extern obj_t app_ly_162_ast_node;
extern obj_t add_generic__110___object(obj_t, obj_t);
extern obj_t app_ast_node;
static obj_t library_modules_init_112_integrate_a();
extern obj_t atom_ast_node;
static obj_t _kont__191_integrate_a = BUNSPEC;
extern obj_t cast_ast_node;
static obj_t toplevel_init_63_integrate_a();
extern obj_t jump_ex_it_184_ast_node;
extern obj_t open_input_string(obj_t);
extern obj_t kwote_ast_node;
extern obj_t setq_ast_node;
extern obj_t box_set__221_ast_node;
extern obj_t local_ast_var;
extern obj_t shape_tools_shape(obj_t);
extern obj_t internal_error_43_tools_error(obj_t, obj_t, obj_t);
static obj_t _node_a_default1540_102_integrate_a(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t _classes__134___object;
extern obj_t select_ast_node;
extern obj_t read___reader(obj_t);
obj_t _phi__105_integrate_a = BUNSPEC;
static obj_t require_initialization_114_integrate_a = BUNSPEC;
extern obj_t conditional_ast_node;
extern obj_t a_integrate_a(global_bglt, node_bglt);
static obj_t cnst_init_137_integrate_a();
static obj_t __cnst[2];

DEFINE_STATIC_PROCEDURE(node_a_default1540_env_43_integrate_a, _node_a_default1540_102_integrate_a1847, _node_a_default1540_102_integrate_a, 0L, 4);
DEFINE_STATIC_GENERIC(node_a_env_232_integrate_a, _node_a1838_171_integrate_a1848, _node_a1838_171_integrate_a, 0L, 4);
DEFINE_EXPORT_PROCEDURE(a_env_12_integrate_a, _a1837_integrate_a1849, _a1837_integrate_a, 0L, 2);
DEFINE_STRING(string1842_integrate_a, string1842_integrate_a1850, "NODE-A-DEFAULT1540 TAIL ", 24);
DEFINE_STRING(string1841_integrate_a, string1841_integrate_a1851, "No method for this object", 25);
DEFINE_STRING(string1839_integrate_a, string1839_integrate_a1852, "node-A", 6);
DEFINE_STRING(string1840_integrate_a, string1840_integrate_a1853, "Unexpected closure", 18);



/* module-initialization */
obj_t 
module_initialization_70_integrate_a(long checksum_1940, char *from_1941)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_integrate_a))
	{
	   require_initialization_114_integrate_a =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_integrate_a();
	   cnst_init_137_integrate_a();
	   imported_modules_init_94_integrate_a();
	   method_init_76_integrate_a();
	   toplevel_init_63_integrate_a();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_integrate_a()
{
   AN_OBJECT;
   {	/* Integrate/a.scm 17 */
      module_initialization_70___object(((long) 0), "INTEGRATE_A");
      module_initialization_70___reader(((long) 0), "INTEGRATE_A");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_integrate_a()
{
   AN_OBJECT;
   {	/* Integrate/a.scm 17 */
      {		/* Integrate/a.scm 17 */
	 obj_t cnst_port_138_1933;
	 cnst_port_138_1933 =
	    open_input_string(string1842_integrate_a);
	 {
	    long i_1934;
	    i_1934 = ((long) 1);
	  loop_1935:
	    {	/* Integrate/a.scm 17 */
	       bool_t test1843_1936;
	       test1843_1936 =
		  (i_1934 == ((long) -1));
	       if (test1843_1936)
		 {	/* Integrate/a.scm 17 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Integrate/a.scm 17 */
		    {	/* Integrate/a.scm 17 */
		       obj_t arg1844_1937;
		       {	/* Integrate/a.scm 17 */
			  obj_t list1845_1938;
			  list1845_1938 =
			     MAKE_PAIR(cnst_port_138_1933, BNIL);
			  arg1844_1937 =
			     read___reader(list1845_1938);
		       }
		       CNST_TABLE_SET(i_1934, arg1844_1937);
		    }
		    {	/* Integrate/a.scm 17 */
		       int aux_1939;
		       {	/* Integrate/a.scm 17 */
			  long aux_1958;
			  aux_1958 =
			     (i_1934 - ((long) 1));
			  aux_1939 =
			     (int) (aux_1958);
		       }
		       {
			  long i_1961;
			  i_1961 =
			     (long) (aux_1939);
			  i_1934 = i_1961;
			  goto loop_1935;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_integrate_a()
{
   AN_OBJECT;
   {	/* Integrate/a.scm 17 */
      _phi__105_integrate_a = BUNSPEC;
      _kont__191_integrate_a = BUNSPEC;
      return BUNSPEC;
   }
}



/* a */
obj_t 
a_integrate_a(global_bglt global_1, node_bglt node_2)
{
   AN_OBJECT;
   {	/* Integrate/a.scm 39 */
      {		/* Integrate/a.scm 41 */
	 obj_t list1587_979;
	 {	/* Integrate/a.scm 41 */
	    obj_t aux_1963;
	    aux_1963 =
	       (obj_t) (global_1);
	    list1587_979 =
	       MAKE_PAIR(aux_1963, BNIL);
	 }
	 _phi__105_integrate_a = list1587_979;
      }
      _kont__191_integrate_a =
	 BINT(((long) 0));
      initialize_fun__49_integrate_a(
	 (variable_bglt) (global_1),
	 (variable_bglt) (global_1));
      {		/* Integrate/a.scm 45 */
	 obj_t a_980;
	 a_980 =
	    node_a_141_integrate_a(node_2,
	    (variable_bglt) (global_1),
	    CNST_TABLE_REF(((long) 0)), BNIL);
	 return a_980;
      }
   }
}



/* _a1837 */
obj_t 
_a1837_integrate_a(obj_t env_1920, obj_t global_1921, obj_t node_1922)
{
   AN_OBJECT;
   {	/* Integrate/a.scm 39 */
      return
	 a_integrate_a(
	 (global_bglt) (global_1921),
	 (node_bglt) (node_1922));
   }
}



/* initialize-fun! */
bool_t 
initialize_fun__49_integrate_a(variable_bglt fun_3, variable_bglt owner_4)
{
   AN_OBJECT;
   {	/* Integrate/a.scm 52 */
      {		/* Integrate/a.scm 53 */
	 sfun_iinfo_105_bglt obj1516_981;
	 obj1516_981 =
	    ((sfun_iinfo_105_bglt) (
	       (((variable_bglt) CREF(fun_3))->value)));
	 {	/* Integrate/a.scm 53 */
	    sfun_iinfo_105_bglt arg1588_982;
	    {	/* Integrate/a.scm 53 */
	       bool_t arg1598_992;
	       arg1598_992 =
		  is_a__118___object(
		  (obj_t) (fun_3), global_ast_var);
	       {	/* Integrate/a.scm 53 */
		  sfun_iinfo_105_bglt res1832_1689;
		  {	/* Integrate/a.scm 53 */
		     obj_t owner_1654;
		     owner_1654 =
			(obj_t) (owner_4);
		     {	/* ./Integrate/iinfo.scm 1120 */
			sfun_iinfo_105_bglt new1494_1671;
			new1494_1671 =
			   ((sfun_iinfo_105_bglt) BREF(GC_MALLOC(sizeof(struct sfun_iinfo_105))));
			((((sfun_iinfo_105_bglt) CREF(new1494_1671))->owner) = ((obj_t) owner_1654), BUNSPEC);
			((((sfun_iinfo_105_bglt) CREF(new1494_1671))->free) = ((obj_t) BUNSPEC), BUNSPEC);
			((((sfun_iinfo_105_bglt) CREF(new1494_1671))->bound) = ((obj_t) BNIL), BUNSPEC);
			((((sfun_iinfo_105_bglt) CREF(new1494_1671))->cfrom) = ((obj_t) BNIL), BUNSPEC);
			((((sfun_iinfo_105_bglt) CREF(new1494_1671))->cto) = ((obj_t) BNIL), BUNSPEC);
			((((sfun_iinfo_105_bglt) CREF(new1494_1671))->k) = ((obj_t) BNIL), BUNSPEC);
			((((sfun_iinfo_105_bglt) CREF(new1494_1671))->k__190) = ((obj_t) BNIL), BUNSPEC);
			((((sfun_iinfo_105_bglt) CREF(new1494_1671))->u) = ((obj_t) BUNSPEC), BUNSPEC);
			((((sfun_iinfo_105_bglt) CREF(new1494_1671))->cn) = ((obj_t) BNIL), BUNSPEC);
			((((sfun_iinfo_105_bglt) CREF(new1494_1671))->ct) = ((obj_t) BNIL), BUNSPEC);
			((((sfun_iinfo_105_bglt) CREF(new1494_1671))->kont) = ((obj_t) BNIL), BUNSPEC);
			((((sfun_iinfo_105_bglt) CREF(new1494_1671))->g__219) = ((bool_t) arg1598_992), BUNSPEC);
			((((sfun_iinfo_105_bglt) CREF(new1494_1671))->l) = ((obj_t) BUNSPEC), BUNSPEC);
			((((sfun_iinfo_105_bglt) CREF(new1494_1671))->led) = ((obj_t) BNIL), BUNSPEC);
			((((sfun_iinfo_105_bglt) CREF(new1494_1671))->istamp) = ((obj_t) BUNSPEC), BUNSPEC);
			((((sfun_iinfo_105_bglt) CREF(new1494_1671))->global) = ((obj_t) BUNSPEC), BUNSPEC);
			((((sfun_iinfo_105_bglt) CREF(new1494_1671))->kaptured) = ((obj_t) BUNSPEC), BUNSPEC);
			res1832_1689 = new1494_1671;
		     }
		  }
		  arg1588_982 = res1832_1689;
	       }
	    }
	    {	/* Integrate/a.scm 53 */
	       obj_t aux_2001;
	       object_bglt aux_1999;
	       aux_2001 =
		  (obj_t) (arg1588_982);
	       aux_1999 =
		  (object_bglt) (obj1516_981);
	       OBJECT_WIDENING_SET(aux_1999, aux_2001);
	    }
	 }
	 {	/* Integrate/a.scm 53 */
	    long arg1600_994;
	    arg1600_994 =
	       class_num_218___object(sfun_iinfo_105_integrate_info);
	    {	/* Integrate/a.scm 53 */
	       obj_t obj_1690;
	       obj_1690 =
		  (obj_t) (obj1516_981);
	       (((obj_t) CREF(obj_1690))->header = MAKE_HEADER(arg1600_994, 0), BUNSPEC);
	    }
	 }
	 obj1516_981;
      }
      {
	 obj_t l1517_995;
	 {	/* Integrate/a.scm 58 */
	    sfun_bglt obj_1693;
	    {	/* Integrate/a.scm 58 */
	       value_bglt aux_2029;
	       aux_2029 =
		  (((variable_bglt) CREF(fun_3))->value);
	       obj_1693 =
		  (sfun_bglt) (aux_2029);
	    }
	    l1517_995 =
	       (((sfun_bglt) CREF(obj_1693))->args);
	 }
       lname1518_996:
	 if (
	    PAIRP(l1517_995))
	   {	/* Integrate/a.scm 56 */
	      {		/* Integrate/a.scm 57 */
		 obj_t x_1000;
		 x_1000 =
		    CAR(l1517_995);
		 {	/* Integrate/a.scm 57 */
		    svar_iinfo_76_bglt obj1519_1001;
		    {
		       value_bglt aux_2010;
		       {	/* Integrate/a.scm 57 */
			  local_bglt obj_1696;
			  obj_1696 =
			     (local_bglt) (x_1000);
			  aux_2010 =
			     (((local_bglt) CREF(obj_1696))->value);
		       }
		       obj1519_1001 =
			  ((svar_iinfo_76_bglt) (aux_2010));
		    }
		    {	/* Integrate/a.scm 57 */
		       svar_iinfo_76_bglt arg1604_1002;
		       {	/* Integrate/a.scm 57 */
			  svar_iinfo_76_bglt res1833_1706;
			  {	/* ./Integrate/iinfo.scm 1100 */
			     svar_iinfo_76_bglt new1442_1701;
			     new1442_1701 =
				((svar_iinfo_76_bglt) BREF(GC_MALLOC(sizeof(struct svar_iinfo_76))));
			     ((((svar_iinfo_76_bglt) CREF(new1442_1701))->f_mark_181) = ((obj_t) BUNSPEC), BUNSPEC);
			     ((((svar_iinfo_76_bglt) CREF(new1442_1701))->u_mark_209) = ((obj_t) BUNSPEC), BUNSPEC);
			     ((((svar_iinfo_76_bglt) CREF(new1442_1701))->kaptured__204) = ((bool_t) ((bool_t) 0)), BUNSPEC);
			     ((((svar_iinfo_76_bglt) CREF(new1442_1701))->celled__113) = ((bool_t) ((bool_t) 0)), BUNSPEC);
			     res1833_1706 = new1442_1701;
			  }
			  arg1604_1002 = res1833_1706;
		       }
		       {	/* Integrate/a.scm 57 */
			  obj_t aux_2021;
			  object_bglt aux_2019;
			  aux_2021 =
			     (obj_t) (arg1604_1002);
			  aux_2019 =
			     (object_bglt) (obj1519_1001);
			  OBJECT_WIDENING_SET(aux_2019, aux_2021);
		       }
		    }
		    {	/* Integrate/a.scm 57 */
		       long arg1605_1003;
		       arg1605_1003 =
			  class_num_218___object(svar_iinfo_76_integrate_info);
		       {	/* Integrate/a.scm 57 */
			  obj_t obj_1707;
			  obj_1707 =
			     (obj_t) (obj1519_1001);
			  (((obj_t) CREF(obj_1707))->header = MAKE_HEADER(arg1605_1003, 0), BUNSPEC);
		       }
		    }
		    obj1519_1001;
		 }
	      }
	      {
		 obj_t l1517_2027;
		 l1517_2027 =
		    CDR(l1517_995);
		 l1517_995 = l1517_2027;
		 goto lname1518_996;
	      }
	   }
	 else
	   {	/* Integrate/a.scm 56 */
	      return ((bool_t) 1);
	   }
      }
   }
}



/* get-new-kont */
obj_t 
get_new_kont_177_integrate_a()
{
   AN_OBJECT;
   {	/* Integrate/a.scm 68 */
      {		/* Integrate/a.scm 69 */
	 long z2_1711;
	 z2_1711 =
	    (long) CINT(_kont__191_integrate_a);
	 {	/* ./Ieee/fixnum.scm 7193 */
	    long aux_2034;
	    aux_2034 =
	       (((long) 1) + z2_1711);
	    _kont__191_integrate_a =
	       BINT(aux_2034);
	 }
      }
      return _kont__191_integrate_a;
   }
}



/* method-init */
obj_t 
method_init_76_integrate_a()
{
   AN_OBJECT;
   {	/* Integrate/a.scm 17 */
      add_generic__110___object(node_a_env_232_integrate_a, node_a_default1540_env_43_integrate_a);
      add_inlined_method__244___object(node_a_env_232_integrate_a, atom_ast_node, ((long) 0));
      add_inlined_method__244___object(node_a_env_232_integrate_a, kwote_ast_node, ((long) 1));
      add_inlined_method__244___object(node_a_env_232_integrate_a, var_ast_node, ((long) 2));
      add_inlined_method__244___object(node_a_env_232_integrate_a, closure_ast_node, ((long) 3));
      add_inlined_method__244___object(node_a_env_232_integrate_a, sequence_ast_node, ((long) 4));
      add_inlined_method__244___object(node_a_env_232_integrate_a, app_ast_node, ((long) 5));
      add_inlined_method__244___object(node_a_env_232_integrate_a, app_ly_162_ast_node, ((long) 6));
      add_inlined_method__244___object(node_a_env_232_integrate_a, funcall_ast_node, ((long) 7));
      add_inlined_method__244___object(node_a_env_232_integrate_a, pragma_ast_node, ((long) 8));
      add_inlined_method__244___object(node_a_env_232_integrate_a, cast_ast_node, ((long) 9));
      add_inlined_method__244___object(node_a_env_232_integrate_a, setq_ast_node, ((long) 10));
      add_inlined_method__244___object(node_a_env_232_integrate_a, conditional_ast_node, ((long) 11));
      add_inlined_method__244___object(node_a_env_232_integrate_a, fail_ast_node, ((long) 12));
      add_inlined_method__244___object(node_a_env_232_integrate_a, select_ast_node, ((long) 13));
      add_inlined_method__244___object(node_a_env_232_integrate_a, let_fun_218_ast_node, ((long) 14));
      add_inlined_method__244___object(node_a_env_232_integrate_a, let_var_6_ast_node, ((long) 15));
      add_inlined_method__244___object(node_a_env_232_integrate_a, set_ex_it_116_ast_node, ((long) 16));
      add_inlined_method__244___object(node_a_env_232_integrate_a, jump_ex_it_184_ast_node, ((long) 17));
      add_inlined_method__244___object(node_a_env_232_integrate_a, make_box_202_ast_node, ((long) 18));
      add_inlined_method__244___object(node_a_env_232_integrate_a, box_set__221_ast_node, ((long) 19));
      {		/* Integrate/a.scm 17 */
	 long aux_2058;
	 aux_2058 =
	    add_inlined_method__244___object(node_a_env_232_integrate_a, box_ref_242_ast_node, ((long) 20));
	 return
	    BINT(aux_2058);
      }
   }
}



/* node-a */
obj_t 
node_a_141_integrate_a(node_bglt node_6, variable_bglt host_7, obj_t k_8, obj_t a_9)
{
   AN_OBJECT;
   {	/* Integrate/a.scm 93 */
    node_a_141_integrate_a:
      {
	 obj_t method1691_1381;
	 obj_t class1696_1382;
	 {	/* Integrate/a.scm 93 */
	    obj_t arg1699_1379;
	    obj_t arg1700_1380;
	    {	/* Integrate/a.scm 93 */
	       object_bglt obj_1767;
	       obj_1767 =
		  (object_bglt) (node_6);
	       {	/* ./Llib/object.scm 2926 */
		  obj_t pre_method_105_1768;
		  pre_method_105_1768 =
		     PROCEDURE_REF(node_a_env_232_integrate_a, ((long) 2));
		  if (
		     INTEGERP(pre_method_105_1768))
		    {	/* ./Llib/object.scm 2927 */
		       PROCEDURE_SET(node_a_env_232_integrate_a, ((long) 2), BUNSPEC);
		       arg1699_1379 = pre_method_105_1768;
		    }
		  else
		    {	/* ./Llib/object.scm 2914 */
		       long obj_class_num_177_1773;
		       obj_class_num_177_1773 =
			  TYPE(obj_1767);
		       {	/* ./Llib/object.scm 2915 */
			  obj_t arg1176_1774;
			  arg1176_1774 =
			     PROCEDURE_REF(node_a_env_232_integrate_a, ((long) 1));
			  {	/* ./Llib/object.scm 2738 */
			     long arg1177_1778;
			     {	/* ./Llib/object.scm 2738 */
				long arg1178_1779;
				arg1178_1779 =
				   OBJECT_TYPE;
				arg1177_1778 =
				   (obj_class_num_177_1773 - arg1178_1779);
			     }
			     arg1699_1379 =
				VECTOR_REF(arg1176_1774, arg1177_1778);
			  }
		       }
		    }
	       }
	    }
	    {	/* Integrate/a.scm 93 */
	       object_bglt object_1784;
	       object_1784 =
		  (object_bglt) (node_6);
	       {	/* ./Llib/object.scm 2695 */
		  long arg1179_1785;
		  {	/* ./Llib/object.scm 2695 */
		     long arg1180_1786;
		     long arg1181_1787;
		     arg1180_1786 =
			TYPE(object_1784);
		     arg1181_1787 =
			OBJECT_TYPE;
		     arg1179_1785 =
			(arg1180_1786 - arg1181_1787);
		  }
		  {	/* ./Llib/object.scm 2695 */
		     obj_t vector_1791;
		     vector_1791 = _classes__134___object;
		     arg1700_1380 =
			VECTOR_REF(vector_1791, arg1179_1785);
		  }
	       }
	    }
	    method1691_1381 = arg1699_1379;
	    class1696_1382 = arg1700_1380;
	    {

	       if (
		  INTEGERP(method1691_1381))
		 {	/* Integrate/a.scm 93 */
		    switch (
		       (long) CINT(method1691_1381))
		      {
		      case ((long) 0):

			 return a_9;
			 break;
		      case ((long) 1):

			 return a_9;
			 break;
		      case ((long) 2):

			 return a_9;
			 break;
		      case ((long) 3):

			 {	/* Integrate/a.scm 117 */
			    obj_t arg1705_1406;
			    {	/* Integrate/a.scm 117 */
			       obj_t aux_2078;
			       {	/* Integrate/a.scm 117 */
				  closure_bglt aux_2079;
				  aux_2079 =
				     (closure_bglt) (node_6);
				  aux_2078 =
				     (obj_t) (aux_2079);
			       }
			       arg1705_1406 =
				  shape_tools_shape(aux_2078);
			    }
			    return
			       internal_error_43_tools_error(string1839_integrate_a, string1840_integrate_a, arg1705_1406);
			 }
			 break;
		      case ((long) 4):

			 {	/* Integrate/a.scm 123 */
			    sequence_bglt node_1407;
			    node_1407 =
			       (sequence_bglt) (node_6);
			    {	/* Integrate/a.scm 124 */
			       bool_t test_2085;
			       {	/* ./Ieee/pair-list.scm 5912 */
				  obj_t aux_2086;
				  aux_2086 =
				     (((sequence_bglt) CREF(node_1407))->nodes);
				  test_2085 =
				     NULLP(aux_2086);
			       }
			       if (test_2085)
				 {	/* Integrate/a.scm 124 */
				    return a_9;
				 }
			       else
				 {
				    obj_t nds_1413;
				    obj_t a_1414;
				    nds_1413 =
				       (((sequence_bglt) CREF(node_1407))->nodes);
				    a_1414 = a_9;
				  liip_1415:
				    {	/* Integrate/a.scm 128 */
				       bool_t test_2089;
				       {	/* ./Ieee/pair-list.scm 5912 */
					  obj_t aux_2090;
					  aux_2090 =
					     CDR(nds_1413);
					  test_2089 =
					     NULLP(aux_2090);
				       }
				       if (test_2089)
					 {
					    obj_t a_2097;
					    node_bglt node_2093;
					    {	/* Integrate/a.scm 129 */
					       obj_t aux_2094;
					       aux_2094 =
						  CAR(nds_1413);
					       node_2093 =
						  (node_bglt) (aux_2094);
					    }
					    a_2097 = a_1414;
					    a_9 = a_2097;
					    node_6 = node_2093;
					    goto node_a_141_integrate_a;
					 }
				       else
					 {	/* Integrate/a.scm 130 */
					    obj_t arg1711_1419;
					    obj_t arg1712_1420;
					    arg1711_1419 =
					       CDR(nds_1413);
					    {	/* Integrate/a.scm 131 */
					       obj_t arg1713_1421;
					       obj_t arg1714_1422;
					       arg1713_1421 =
						  CAR(nds_1413);
					       arg1714_1422 =
						  get_new_kont_177_integrate_a();
					       arg1712_1420 =
						  node_a_141_integrate_a(
						  (node_bglt) (arg1713_1421), host_7, arg1714_1422, a_1414);
					    }
					    {
					       obj_t a_2104;
					       obj_t nds_2103;
					       nds_2103 = arg1711_1419;
					       a_2104 = arg1712_1420;
					       a_1414 = a_2104;
					       nds_1413 = nds_2103;
					       goto liip_1415;
					    }
					 }
				    }
				 }
			    }
			 }
			 break;
		      case ((long) 5):

			 {	/* Integrate/a.scm 137 */
			    app_bglt node_1425;
			    node_1425 =
			       (app_bglt) (node_6);
			    {	/* Integrate/a.scm 138 */
			       variable_bglt callee_1430;
			       {	/* Integrate/a.scm 138 */
				  var_bglt arg1727_1444;
				  arg1727_1444 =
				     (((app_bglt) CREF(node_1425))->fun);
				  callee_1430 =
				     (((var_bglt) CREF(arg1727_1444))->variable);
			       }
			       {
				  obj_t args_1431;
				  obj_t a_1432;
				  args_1431 =
				     (((app_bglt) CREF(node_1425))->args);
				  a_1432 = a_9;
				liip_1433:
				  if (
				     NULLP(args_1431))
				    {	/* Integrate/a.scm 144 */
				       bool_t test1719_1436;
				       test1719_1436 =
					  is_a__118___object(
					  (obj_t) (callee_1430), local_ast_var);
				       if (test1719_1436)
					 {	/* Integrate/a.scm 144 */
					    {	/* Integrate/a.scm 145 */
					       obj_t arg1720_1437;
					       {	/* Integrate/a.scm 145 */
						  obj_t arg1721_1438;
						  {	/* Integrate/a.scm 145 */
						     obj_t arg1722_1439;
						     arg1722_1439 =
							MAKE_PAIR(k_8, BNIL);
						     {	/* ./Ieee/pair-list.scm 5689 */
							obj_t aux_2115;
							aux_2115 =
							   (obj_t) (callee_1430);
							arg1721_1438 =
							   MAKE_PAIR(aux_2115, arg1722_1439);
						     }
						  }
						  {	/* ./Ieee/pair-list.scm 5689 */
						     obj_t aux_2118;
						     aux_2118 =
							(obj_t) (host_7);
						     arg1720_1437 =
							MAKE_PAIR(aux_2118, arg1721_1438);
						  }
					       }
					       return
						  MAKE_PAIR(arg1720_1437, a_1432);
					    }
					 }
				       else
					 {	/* Integrate/a.scm 144 */
					    return a_1432;
					 }
				    }
				  else
				    {	/* Integrate/a.scm 148 */
				       obj_t arg1723_1440;
				       obj_t arg1724_1441;
				       arg1723_1440 =
					  CDR(args_1431);
				       {	/* Integrate/a.scm 149 */
					  obj_t arg1725_1442;
					  obj_t arg1726_1443;
					  arg1725_1442 =
					     CAR(args_1431);
					  arg1726_1443 =
					     get_new_kont_177_integrate_a();
					  arg1724_1441 =
					     node_a_141_integrate_a(
					     (node_bglt) (arg1725_1442), host_7, arg1726_1443, a_1432);
				       }
				       {
					  obj_t a_2128;
					  obj_t args_2127;
					  args_2127 = arg1723_1440;
					  a_2128 = arg1724_1441;
					  a_1432 = a_2128;
					  args_1431 = args_2127;
					  goto liip_1433;
				       }
				    }
			       }
			    }
			 }
			 break;
		      case ((long) 6):

			 {	/* Integrate/a.scm 158 */
			    app_ly_162_bglt node_1445;
			    node_1445 =
			       (app_ly_162_bglt) (node_6);
			    {	/* Integrate/a.scm 159 */
			       node_bglt arg1728_1450;
			       obj_t arg1729_1451;
			       obj_t arg1730_1452;
			       arg1728_1450 =
				  (((app_ly_162_bglt) CREF(node_1445))->fun);
			       arg1729_1451 =
				  get_new_kont_177_integrate_a();
			       {	/* Integrate/a.scm 159 */
				  node_bglt arg1731_1453;
				  obj_t arg1732_1454;
				  arg1731_1453 =
				     (((app_ly_162_bglt) CREF(node_1445))->arg);
				  arg1732_1454 =
				     get_new_kont_177_integrate_a();
				  arg1730_1452 =
				     node_a_141_integrate_a(arg1731_1453, host_7, arg1732_1454, a_9);
			       }
			       {
				  obj_t a_2138;
				  obj_t k_2137;
				  node_bglt node_2136;
				  node_2136 = arg1728_1450;
				  k_2137 = arg1729_1451;
				  a_2138 = arg1730_1452;
				  a_9 = a_2138;
				  k_8 = k_2137;
				  node_6 = node_2136;
				  goto node_a_141_integrate_a;
			       }
			    }
			 }
			 break;
		      case ((long) 7):

			 {	/* Integrate/a.scm 165 */
			    funcall_bglt node_1455;
			    node_1455 =
			       (funcall_bglt) (node_6);
			    {	/* Integrate/a.scm 166 */
			       node_bglt arg1733_1460;
			       obj_t arg1734_1461;
			       obj_t arg1735_1462;
			       arg1733_1460 =
				  (((funcall_bglt) CREF(node_1455))->fun);
			       arg1734_1461 =
				  get_new_kont_177_integrate_a();
			       {
				  obj_t args_1463;
				  obj_t a_1464;
				  args_1463 =
				     (((funcall_bglt) CREF(node_1455))->args);
				  a_1464 = a_9;
				liip_1465:
				  if (
				     NULLP(args_1463))
				    {	/* Integrate/a.scm 171 */
				       arg1735_1462 = a_1464;
				    }
				  else
				    {	/* Integrate/a.scm 173 */
				       obj_t arg1738_1468;
				       obj_t arg1739_1469;
				       arg1738_1468 =
					  CDR(args_1463);
				       {	/* Integrate/a.scm 174 */
					  obj_t arg1740_1470;
					  obj_t arg1741_1471;
					  arg1740_1470 =
					     CAR(args_1463);
					  arg1741_1471 =
					     get_new_kont_177_integrate_a();
					  arg1739_1469 =
					     node_a_141_integrate_a(
					     (node_bglt) (arg1740_1470), host_7, arg1741_1471, a_1464);
				       }
				       {
					  obj_t a_2150;
					  obj_t args_2149;
					  args_2149 = arg1738_1468;
					  a_2150 = arg1739_1469;
					  a_1464 = a_2150;
					  args_1463 = args_2149;
					  goto liip_1465;
				       }
				    }
			       }
			       {
				  obj_t a_2154;
				  obj_t k_2153;
				  node_bglt node_2152;
				  node_2152 = arg1733_1460;
				  k_2153 = arg1734_1461;
				  a_2154 = arg1735_1462;
				  a_9 = a_2154;
				  k_8 = k_2153;
				  node_6 = node_2152;
				  goto node_a_141_integrate_a;
			       }
			    }
			 }
			 break;
		      case ((long) 8):

			 {	/* Integrate/a.scm 180 */
			    pragma_bglt node_1472;
			    node_1472 =
			       (pragma_bglt) (node_6);
			    {
			       obj_t asts_1477;
			       obj_t a_1478;
			       asts_1477 =
				  (((pragma_bglt) CREF(node_1472))->args);
			       a_1478 = a_9;
			     liip_1479:
			       if (
				  NULLP(asts_1477))
				 {	/* Integrate/a.scm 183 */
				    return a_1478;
				 }
			       else
				 {	/* Integrate/a.scm 185 */
				    obj_t arg1744_1482;
				    obj_t arg1745_1483;
				    arg1744_1482 =
				       CDR(asts_1477);
				    {	/* Integrate/a.scm 186 */
				       obj_t arg1746_1484;
				       obj_t arg1747_1485;
				       arg1746_1484 =
					  CAR(asts_1477);
				       arg1747_1485 =
					  get_new_kont_177_integrate_a();
				       arg1745_1483 =
					  node_a_141_integrate_a(
					  (node_bglt) (arg1746_1484), host_7, arg1747_1485, a_1478);
				    }
				    {
				       obj_t a_2164;
				       obj_t asts_2163;
				       asts_2163 = arg1744_1482;
				       a_2164 = arg1745_1483;
				       a_1478 = a_2164;
				       asts_1477 = asts_2163;
				       goto liip_1479;
				    }
				 }
			    }
			 }
			 break;
		      case ((long) 9):

			 {	/* Integrate/a.scm 192 */
			    cast_bglt node_1486;
			    node_1486 =
			       (cast_bglt) (node_6);
			    {	/* Integrate/a.scm 193 */
			       node_bglt arg1748_1491;
			       obj_t arg1749_1492;
			       arg1748_1491 =
				  (((cast_bglt) CREF(node_1486))->arg);
			       arg1749_1492 =
				  get_new_kont_177_integrate_a();
			       {
				  obj_t k_2170;
				  node_bglt node_2169;
				  node_2169 = arg1748_1491;
				  k_2170 = arg1749_1492;
				  k_8 = k_2170;
				  node_6 = node_2169;
				  goto node_a_141_integrate_a;
			       }
			    }
			 }
			 break;
		      case ((long) 10):

			 {	/* Integrate/a.scm 199 */
			    setq_bglt node_1493;
			    node_1493 =
			       (setq_bglt) (node_6);
			    {	/* Integrate/a.scm 200 */
			       node_bglt arg1750_1498;
			       obj_t arg1751_1499;
			       arg1750_1498 =
				  (((setq_bglt) CREF(node_1493))->value);
			       arg1751_1499 =
				  get_new_kont_177_integrate_a();
			       {
				  obj_t k_2175;
				  node_bglt node_2174;
				  node_2174 = arg1750_1498;
				  k_2175 = arg1751_1499;
				  k_8 = k_2175;
				  node_6 = node_2174;
				  goto node_a_141_integrate_a;
			       }
			    }
			 }
			 break;
		      case ((long) 11):

			 {	/* Integrate/a.scm 206 */
			    conditional_bglt node_1500;
			    node_1500 =
			       (conditional_bglt) (node_6);
			    {	/* Integrate/a.scm 207 */
			       obj_t a_1505;
			       {	/* Integrate/a.scm 207 */
				  node_bglt arg1755_1509;
				  obj_t arg1756_1510;
				  arg1755_1509 =
				     (((conditional_bglt) CREF(node_1500))->test);
				  arg1756_1510 =
				     get_new_kont_177_integrate_a();
				  a_1505 =
				     node_a_141_integrate_a(arg1755_1509, host_7, arg1756_1510, a_9);
			       }
			       {	/* Integrate/a.scm 208 */
				  node_bglt arg1752_1506;
				  obj_t arg1753_1507;
				  arg1752_1506 =
				     (((conditional_bglt) CREF(node_1500))->true);
				  arg1753_1507 =
				     node_a_141_integrate_a(
				     (((conditional_bglt) CREF(node_1500))->false), host_7, k_8, a_1505);
				  {
				     obj_t a_2184;
				     node_bglt node_2183;
				     node_2183 = arg1752_1506;
				     a_2184 = arg1753_1507;
				     a_9 = a_2184;
				     node_6 = node_2183;
				     goto node_a_141_integrate_a;
				  }
			       }
			    }
			 }
			 break;
		      case ((long) 12):

			 {	/* Integrate/a.scm 214 */
			    fail_bglt node_1511;
			    node_1511 =
			       (fail_bglt) (node_6);
			    {	/* Integrate/a.scm 215 */
			       node_bglt arg1758_1516;
			       obj_t arg1759_1517;
			       obj_t arg1760_1518;
			       arg1758_1516 =
				  (((fail_bglt) CREF(node_1511))->proc);
			       arg1759_1517 =
				  get_new_kont_177_integrate_a();
			       {	/* Integrate/a.scm 218 */
				  node_bglt arg1761_1519;
				  obj_t arg1762_1520;
				  obj_t arg1763_1521;
				  arg1761_1519 =
				     (((fail_bglt) CREF(node_1511))->msg);
				  arg1762_1520 =
				     get_new_kont_177_integrate_a();
				  {	/* Integrate/a.scm 221 */
				     node_bglt arg1764_1522;
				     obj_t arg1765_1523;
				     arg1764_1522 =
					(((fail_bglt) CREF(node_1511))->obj);
				     arg1765_1523 =
					get_new_kont_177_integrate_a();
				     arg1763_1521 =
					node_a_141_integrate_a(arg1764_1522, host_7, arg1765_1523, a_9);
				  }
				  arg1760_1518 =
				     node_a_141_integrate_a(arg1761_1519, host_7, arg1762_1520, arg1763_1521);
			       }
			       {
				  obj_t a_2196;
				  obj_t k_2195;
				  node_bglt node_2194;
				  node_2194 = arg1758_1516;
				  k_2195 = arg1759_1517;
				  a_2196 = arg1760_1518;
				  a_9 = a_2196;
				  k_8 = k_2195;
				  node_6 = node_2194;
				  goto node_a_141_integrate_a;
			       }
			    }
			 }
			 break;
		      case ((long) 13):

			 {	/* Integrate/a.scm 227 */
			    select_bglt node_1524;
			    node_1524 =
			       (select_bglt) (node_6);
			    {
			       obj_t clauses_1529;
			       obj_t a_1530;
			       {	/* Integrate/a.scm 228 */
				  obj_t arg1766_1532;
				  obj_t arg1767_1533;
				  arg1766_1532 =
				     (((select_bglt) CREF(node_1524))->clauses);
				  {	/* Integrate/a.scm 229 */
				     node_bglt arg1768_1534;
				     obj_t arg1769_1535;
				     arg1768_1534 =
					(((select_bglt) CREF(node_1524))->test);
				     arg1769_1535 =
					get_new_kont_177_integrate_a();
				     arg1767_1533 =
					node_a_141_integrate_a(arg1768_1534, host_7, arg1769_1535, a_9);
				  }
				  clauses_1529 = arg1766_1532;
				  a_1530 = arg1767_1533;
				liip_1531:
				  if (
				     NULLP(clauses_1529))
				    {	/* Integrate/a.scm 233 */
				       return a_1530;
				    }
				  else
				    {	/* Integrate/a.scm 235 */
				       obj_t arg1771_1537;
				       obj_t arg1772_1538;
				       arg1771_1537 =
					  CDR(clauses_1529);
				       {	/* Integrate/a.scm 236 */
					  node_bglt aux_2205;
					  {	/* Integrate/a.scm 236 */
					     obj_t aux_2206;
					     {	/* ./Ieee/pair-list.scm 5707 */
						obj_t aux_2207;
						aux_2207 =
						   CAR(clauses_1529);
						aux_2206 =
						   CDR(aux_2207);
					     }
					     aux_2205 =
						(node_bglt) (aux_2206);
					  }
					  arg1772_1538 =
					     node_a_141_integrate_a(aux_2205, host_7, k_8, a_1530);
				       }
				       {
					  obj_t a_2213;
					  obj_t clauses_2212;
					  clauses_2212 = arg1771_1537;
					  a_2213 = arg1772_1538;
					  a_1530 = a_2213;
					  clauses_1529 = clauses_2212;
					  goto liip_1531;
				       }
				    }
			       }
			    }
			 }
			 break;
		      case ((long) 14):

			 {	/* Integrate/a.scm 242 */
			    let_fun_218_bglt node_1541;
			    node_1541 =
			       (let_fun_218_bglt) (node_6);
			    {
			       obj_t l1531_1546;
			       l1531_1546 =
				  (((let_fun_218_bglt) CREF(node_1541))->locals);
			     lname1532_1547:
			       if (
				  PAIRP(l1531_1546))
				 {	/* Integrate/a.scm 244 */
				    {	/* Integrate/a.scm 244 */
				       obj_t f_1550;
				       f_1550 =
					  CAR(l1531_1546);
				       initialize_fun__49_integrate_a(
					  (variable_bglt) (f_1550), host_7);
				       {	/* Integrate/a.scm 246 */
					  obj_t obj2_1845;
					  obj2_1845 = _phi__105_integrate_a;
					  _phi__105_integrate_a =
					     MAKE_PAIR(f_1550, obj2_1845);
				       }
				    }
				    {
				       obj_t l1531_2221;
				       l1531_2221 =
					  CDR(l1531_1546);
				       l1531_1546 = l1531_2221;
				       goto lname1532_1547;
				    }
				 }
			       else
				 {	/* Integrate/a.scm 244 */
				    ((bool_t) 1);
				 }
			    }
			    {
			       obj_t locals_1552;
			       obj_t a_1553;
			       locals_1552 =
				  (((let_fun_218_bglt) CREF(node_1541))->locals);
			       a_1553 = a_9;
			     liip_1554:
			       if (
				  NULLP(locals_1552))
				 {
				    obj_t a_2228;
				    node_bglt node_2226;
				    node_2226 =
				       (((let_fun_218_bglt) CREF(node_1541))->body);
				    a_2228 = a_1553;
				    a_9 = a_2228;
				    node_6 = node_2226;
				    goto node_a_141_integrate_a;
				 }
			       else
				 {	/* Integrate/a.scm 253 */
				    obj_t arg1781_1558;
				    obj_t arg1782_1559;
				    arg1781_1558 =
				       CDR(locals_1552);
				    {	/* Integrate/a.scm 254 */
				       variable_bglt aux_2240;
				       node_bglt aux_2230;
				       {	/* Integrate/a.scm 254 */
					  obj_t aux_2241;
					  aux_2241 =
					     CAR(locals_1552);
					  aux_2240 =
					     (variable_bglt) (aux_2241);
				       }
				       {	/* Integrate/a.scm 254 */
					  obj_t aux_2231;
					  {	/* Integrate/a.scm 254 */
					     sfun_bglt obj_1853;
					     {	/* Integrate/a.scm 254 */
						value_bglt aux_2232;
						{	/* Integrate/a.scm 254 */
						   local_bglt obj_1852;
						   {	/* Integrate/a.scm 254 */
						      obj_t aux_2233;
						      aux_2233 =
							 CAR(locals_1552);
						      obj_1852 =
							 (local_bglt) (aux_2233);
						   }
						   aux_2232 =
						      (((local_bglt) CREF(obj_1852))->value);
						}
						obj_1853 =
						   (sfun_bglt) (aux_2232);
					     }
					     aux_2231 =
						(((sfun_bglt) CREF(obj_1853))->body);
					  }
					  aux_2230 =
					     (node_bglt) (aux_2231);
				       }
				       arg1782_1559 =
					  node_a_141_integrate_a(aux_2230, aux_2240,
					  CNST_TABLE_REF(((long) 0)), a_1553);
				    }
				    {
				       obj_t a_2247;
				       obj_t locals_2246;
				       locals_2246 = arg1781_1558;
				       a_2247 = arg1782_1559;
				       a_1553 = a_2247;
				       locals_1552 = locals_2246;
				       goto liip_1554;
				    }
				 }
			    }
			 }
			 break;
		      case ((long) 15):

			 {	/* Integrate/a.scm 263 */
			    let_var_6_bglt node_1565;
			    node_1565 =
			       (let_var_6_bglt) (node_6);
			    {
			       obj_t bindings_1570;
			       obj_t a_1571;
			       bindings_1570 =
				  (((let_var_6_bglt) CREF(node_1565))->bindings);
			       a_1571 = a_9;
			     liip_1572:
			       if (
				  NULLP(bindings_1570))
				 {
				    obj_t a_2254;
				    node_bglt node_2252;
				    node_2252 =
				       (((let_var_6_bglt) CREF(node_1565))->body);
				    a_2254 = a_1571;
				    a_9 = a_2254;
				    node_6 = node_2252;
				    goto node_a_141_integrate_a;
				 }
			       else
				 {	/* Integrate/a.scm 268 */
				    obj_t binding_1576;
				    binding_1576 =
				       CAR(bindings_1570);
				    {	/* Integrate/a.scm 268 */
				       obj_t var_1577;
				       var_1577 =
					  CAR(binding_1576);
				       {	/* Integrate/a.scm 269 */
					  obj_t val_1578;
					  val_1578 =
					     CDR(binding_1576);
					  {	/* Integrate/a.scm 270 */

					     {	/* Integrate/a.scm 271 */
						svar_iinfo_76_bglt obj1534_1579;
						{
						   value_bglt aux_2258;
						   {	/* Integrate/a.scm 271 */
						      local_bglt obj_1861;
						      obj_1861 =
							 (local_bglt) (var_1577);
						      aux_2258 =
							 (((local_bglt) CREF(obj_1861))->value);
						   }
						   obj1534_1579 =
						      ((svar_iinfo_76_bglt) (aux_2258));
						}
						{	/* Integrate/a.scm 271 */
						   svar_iinfo_76_bglt arg1791_1580;
						   {	/* Integrate/a.scm 271 */
						      svar_iinfo_76_bglt res1834_1871;
						      {		/* ./Integrate/iinfo.scm 1100 */
							 svar_iinfo_76_bglt new1442_1866;
							 new1442_1866 =
							    ((svar_iinfo_76_bglt) BREF(GC_MALLOC(sizeof(struct svar_iinfo_76))));
							 ((((svar_iinfo_76_bglt) CREF(new1442_1866))->f_mark_181) = ((obj_t) BUNSPEC), BUNSPEC);
							 ((((svar_iinfo_76_bglt) CREF(new1442_1866))->u_mark_209) = ((obj_t) BUNSPEC), BUNSPEC);
							 ((((svar_iinfo_76_bglt) CREF(new1442_1866))->kaptured__204) = ((bool_t) ((bool_t) 0)), BUNSPEC);
							 ((((svar_iinfo_76_bglt) CREF(new1442_1866))->celled__113) = ((bool_t) ((bool_t) 0)), BUNSPEC);
							 res1834_1871 = new1442_1866;
						      }
						      arg1791_1580 = res1834_1871;
						   }
						   {	/* Integrate/a.scm 271 */
						      obj_t aux_2269;
						      object_bglt aux_2267;
						      aux_2269 =
							 (obj_t) (arg1791_1580);
						      aux_2267 =
							 (object_bglt) (obj1534_1579);
						      OBJECT_WIDENING_SET(aux_2267, aux_2269);
						   }
						}
						{	/* Integrate/a.scm 271 */
						   long arg1792_1581;
						   arg1792_1581 =
						      class_num_218___object(svar_iinfo_76_integrate_info);
						   {	/* Integrate/a.scm 271 */
						      obj_t obj_1872;
						      obj_1872 =
							 (obj_t) (obj1534_1579);
						      (((obj_t) CREF(obj_1872))->header = MAKE_HEADER(arg1792_1581, 0), BUNSPEC);
						   }
						}
						obj1534_1579;
					     }
					     {	/* Integrate/a.scm 272 */
						obj_t arg1793_1582;
						obj_t arg1794_1583;
						arg1793_1582 =
						   CDR(bindings_1570);
						{	/* Integrate/a.scm 273 */
						   obj_t arg1795_1584;
						   arg1795_1584 =
						      get_new_kont_177_integrate_a();
						   arg1794_1583 =
						      node_a_141_integrate_a(
						      (node_bglt) (val_1578), host_7, arg1795_1584, a_1571);
						}
						{
						   obj_t a_2280;
						   obj_t bindings_2279;
						   bindings_2279 = arg1793_1582;
						   a_2280 = arg1794_1583;
						   a_1571 = a_2280;
						   bindings_1570 = bindings_2279;
						   goto liip_1572;
						}
					     }
					  }
				       }
				    }
				 }
			    }
			 }
			 break;
		      case ((long) 16):

			 {	/* Integrate/a.scm 279 */
			    set_ex_it_116_bglt node_1585;
			    node_1585 =
			       (set_ex_it_116_bglt) (node_6);
			    {	/* Integrate/a.scm 284 */
			       variable_bglt exit_1590;
			       {	/* Integrate/a.scm 284 */
				  var_bglt arg1815_1612;
				  arg1815_1612 =
				     (((set_ex_it_116_bglt) CREF(node_1585))->var);
				  exit_1590 =
				     (((var_bglt) CREF(arg1815_1612))->variable);
			       }
			       {	/* Integrate/a.scm 284 */
				  obj_t hdlg_1591;
				  {	/* Integrate/a.scm 285 */
				     sexit_bglt obj_1878;
				     {	/* Integrate/a.scm 285 */
					value_bglt aux_2285;
					{	/* Integrate/a.scm 285 */
					   local_bglt obj_1877;
					   obj_1877 =
					      (local_bglt) (exit_1590);
					   aux_2285 =
					      (((local_bglt) CREF(obj_1877))->value);
					}
					obj_1878 =
					   (sexit_bglt) (aux_2285);
				     }
				     hdlg_1591 =
					(((sexit_bglt) CREF(obj_1878))->handler);
				  }
				  {	/* Integrate/a.scm 285 */

				     {	/* Integrate/a.scm 286 */
					sexit_iinfo_190_bglt obj1536_1592;
					{
					   value_bglt aux_2290;
					   {	/* Integrate/a.scm 286 */
					      local_bglt obj_1879;
					      obj_1879 =
						 (local_bglt) (exit_1590);
					      aux_2290 =
						 (((local_bglt) CREF(obj_1879))->value);
					   }
					   obj1536_1592 =
					      ((sexit_iinfo_190_bglt) (aux_2290));
					}
					{	/* Integrate/a.scm 286 */
					   sexit_iinfo_190_bglt arg1796_1593;
					   {	/* Integrate/a.scm 286 */
					      sexit_iinfo_190_bglt res1835_1889;
					      {		/* ./Integrate/iinfo.scm 1110 */
						 sexit_iinfo_190_bglt new1457_1884;
						 new1457_1884 =
						    ((sexit_iinfo_190_bglt) BREF(GC_MALLOC(sizeof(struct sexit_iinfo_190))));
						 ((((sexit_iinfo_190_bglt) CREF(new1457_1884))->f_mark_181) = ((obj_t) BUNSPEC), BUNSPEC);
						 ((((sexit_iinfo_190_bglt) CREF(new1457_1884))->u_mark_209) = ((obj_t) BUNSPEC), BUNSPEC);
						 ((((sexit_iinfo_190_bglt) CREF(new1457_1884))->kaptured__204) = ((bool_t) ((bool_t) 0)), BUNSPEC);
						 ((((sexit_iinfo_190_bglt) CREF(new1457_1884))->celled__113) = ((bool_t) ((bool_t) 0)), BUNSPEC);
						 res1835_1889 = new1457_1884;
					      }
					      arg1796_1593 = res1835_1889;
					   }
					   {	/* Integrate/a.scm 286 */
					      obj_t aux_2301;
					      object_bglt aux_2299;
					      aux_2301 =
						 (obj_t) (arg1796_1593);
					      aux_2299 =
						 (object_bglt) (obj1536_1592);
					      OBJECT_WIDENING_SET(aux_2299, aux_2301);
					   }
					}
					{	/* Integrate/a.scm 286 */
					   long arg1797_1594;
					   arg1797_1594 =
					      class_num_218___object(sexit_iinfo_190_integrate_info);
					   {	/* Integrate/a.scm 286 */
					      obj_t obj_1890;
					      obj_1890 =
						 (obj_t) (obj1536_1592);
					      (((obj_t) CREF(obj_1890))->header = MAKE_HEADER(arg1797_1594, 0), BUNSPEC);
					   }
					}
					obj1536_1592;
				     }
				     {	/* Integrate/a.scm 287 */
					bool_t test_2307;
					{	/* Integrate/a.scm 287 */
					   sexit_bglt obj_1893;
					   {	/* Integrate/a.scm 287 */
					      value_bglt aux_2308;
					      {		/* Integrate/a.scm 287 */
						 local_bglt obj_1892;
						 obj_1892 =
						    (local_bglt) (exit_1590);
						 aux_2308 =
						    (((local_bglt) CREF(obj_1892))->value);
					      }
					      obj_1893 =
						 (sexit_bglt) (aux_2308);
					   }
					   test_2307 =
					      (((sexit_bglt) CREF(obj_1893))->detached__120);
					}
					if (test_2307)
					  {	/* Integrate/a.scm 287 */
					     return a_9;
					  }
					else
					  {	/* Integrate/a.scm 288 */
					     obj_t call_1_215_1596;
					     obj_t call_2_162_1597;
					     {	/* Integrate/a.scm 288 */
						obj_t arg1804_1602;
						{	/* Integrate/a.scm 288 */
						   obj_t arg1805_1603;
						   {	/* Integrate/a.scm 288 */
						      obj_t arg1806_1604;
						      arg1806_1604 =
							 get_new_kont_177_integrate_a();
						      arg1805_1603 =
							 MAKE_PAIR(arg1806_1604, BNIL);
						   }
						   arg1804_1602 =
						      MAKE_PAIR(hdlg_1591, arg1805_1603);
						}
						call_1_215_1596 =
						   MAKE_PAIR(hdlg_1591, arg1804_1602);
					     }
					     {	/* Integrate/a.scm 289 */
						obj_t arg1809_1606;
						{	/* Integrate/a.scm 289 */
						   obj_t arg1810_1607;
						   {	/* Integrate/a.scm 289 */
						      obj_t arg1811_1608;
						      arg1811_1608 =
							 get_new_kont_177_integrate_a();
						      arg1810_1607 =
							 MAKE_PAIR(arg1811_1608, BNIL);
						   }
						   arg1809_1606 =
						      MAKE_PAIR(hdlg_1591, arg1810_1607);
						}
						call_2_162_1597 =
						   MAKE_PAIR(hdlg_1591, arg1809_1606);
					     }
					     {	/* Integrate/a.scm 290 */
						node_bglt arg1800_1598;
						obj_t arg1801_1599;
						obj_t arg1802_1600;
						arg1800_1598 =
						   (((set_ex_it_116_bglt) CREF(node_1585))->body);
						arg1801_1599 =
						   get_new_kont_177_integrate_a();
						{	/* Integrate/a.scm 293 */
						   obj_t arg1803_1601;
						   arg1803_1601 =
						      MAKE_PAIR(call_2_162_1597, a_9);
						   arg1802_1600 =
						      MAKE_PAIR(call_1_215_1596, arg1803_1601);
						}
						{
						   obj_t a_2327;
						   obj_t k_2326;
						   node_bglt node_2325;
						   node_2325 = arg1800_1598;
						   k_2326 = arg1801_1599;
						   a_2327 = arg1802_1600;
						   a_9 = a_2327;
						   k_8 = k_2326;
						   node_6 = node_2325;
						   goto node_a_141_integrate_a;
						}
					     }
					  }
				     }
				  }
			       }
			    }
			 }
			 break;
		      case ((long) 17):

			 {	/* Integrate/a.scm 300 */
			    jump_ex_it_184_bglt node_1613;
			    node_1613 =
			       (jump_ex_it_184_bglt) (node_6);
			    {	/* Integrate/a.scm 301 */
			       node_bglt arg1816_1618;
			       obj_t arg1817_1619;
			       obj_t arg1818_1620;
			       arg1816_1618 =
				  (((jump_ex_it_184_bglt) CREF(node_1613))->exit);
			       arg1817_1619 =
				  get_new_kont_177_integrate_a();
			       {	/* Integrate/a.scm 301 */
				  node_bglt arg1820_1621;
				  obj_t arg1821_1622;
				  arg1820_1621 =
				     (((jump_ex_it_184_bglt) CREF(node_1613))->value);
				  arg1821_1622 =
				     get_new_kont_177_integrate_a();
				  arg1818_1620 =
				     node_a_141_integrate_a(arg1820_1621, host_7, arg1821_1622, a_9);
			       }
			       {
				  obj_t a_2336;
				  obj_t k_2335;
				  node_bglt node_2334;
				  node_2334 = arg1816_1618;
				  k_2335 = arg1817_1619;
				  a_2336 = arg1818_1620;
				  a_9 = a_2336;
				  k_8 = k_2335;
				  node_6 = node_2334;
				  goto node_a_141_integrate_a;
			       }
			    }
			 }
			 break;
		      case ((long) 18):

			 {	/* Integrate/a.scm 307 */
			    make_box_202_bglt node_1623;
			    node_1623 =
			       (make_box_202_bglt) (node_6);
			    {	/* Integrate/a.scm 308 */
			       node_bglt arg1822_1628;
			       obj_t arg1823_1629;
			       arg1822_1628 =
				  (((make_box_202_bglt) CREF(node_1623))->value);
			       arg1823_1629 =
				  get_new_kont_177_integrate_a();
			       {
				  obj_t k_2341;
				  node_bglt node_2340;
				  node_2340 = arg1822_1628;
				  k_2341 = arg1823_1629;
				  k_8 = k_2341;
				  node_6 = node_2340;
				  goto node_a_141_integrate_a;
			       }
			    }
			 }
			 break;
		      case ((long) 19):

			 {	/* Integrate/a.scm 314 */
			    box_set__221_bglt node_1630;
			    node_1630 =
			       (box_set__221_bglt) (node_6);
			    {	/* Integrate/a.scm 315 */
			       node_bglt arg1824_1635;
			       obj_t arg1825_1636;
			       arg1824_1635 =
				  (((box_set__221_bglt) CREF(node_1630))->value);
			       arg1825_1636 =
				  get_new_kont_177_integrate_a();
			       {
				  obj_t k_2346;
				  node_bglt node_2345;
				  node_2345 = arg1824_1635;
				  k_2346 = arg1825_1636;
				  k_8 = k_2346;
				  node_6 = node_2345;
				  goto node_a_141_integrate_a;
			       }
			    }
			 }
			 break;
		      case ((long) 20):

			 return a_9;
			 break;
		      default:
		       case_else1697_1385:
			 if (
			    PROCEDUREP(method1691_1381))
			   {	/* Integrate/a.scm 93 */
			      return
				 PROCEDURE_ENTRY(method1691_1381) (method1691_1381,
				 (obj_t) (node_6),
				 (obj_t) (host_7), k_8, a_9, BEOA);
			   }
			 else
			   {	/* Integrate/a.scm 93 */
			      obj_t fun1690_1377;
			      fun1690_1377 =
				 PROCEDURE_REF(node_a_env_232_integrate_a, ((long) 0));
			      return
				 PROCEDURE_ENTRY(fun1690_1377) (fun1690_1377,
				 (obj_t) (node_6),
				 (obj_t) (host_7), k_8, a_9, BEOA);
			   }
		      }
		 }
	       else
		 {	/* Integrate/a.scm 93 */
		    goto case_else1697_1385;
		 }
	    }
	 }
      }
   }
}



/* _node-a1838 */
obj_t 
_node_a1838_171_integrate_a(obj_t env_1923, obj_t node_1924, obj_t host_1925, obj_t k_1926, obj_t a_1927)
{
   AN_OBJECT;
   {	/* Integrate/a.scm 93 */
      return
	 node_a_141_integrate_a(
	 (node_bglt) (node_1924),
	 (variable_bglt) (host_1925), k_1926, a_1927);
   }
}



/* node-a-default1540 */
obj_t 
node_a_default1540_44_integrate_a(node_bglt node_10, variable_bglt host_11, obj_t k_12, obj_t a_13)
{
   AN_OBJECT;
   {	/* Integrate/a.scm 17 */
      FAILURE(
	 CNST_TABLE_REF(((long) 1)), string1841_integrate_a,
	 (obj_t) (node_10));
   }
}



/* _node-a-default1540 */
obj_t 
_node_a_default1540_102_integrate_a(obj_t env_1928, obj_t node_1929, obj_t host_1930, obj_t k_1931, obj_t a_1932)
{
   AN_OBJECT;
   {	/* Integrate/a.scm 17 */
      return
	 node_a_default1540_44_integrate_a(
	 (node_bglt) (node_1929),
	 (variable_bglt) (host_1930), k_1931, a_1932);
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_integrate_a()
{
   AN_OBJECT;
   {	/* Integrate/a.scm 17 */
      module_initialization_70_tools_trace(((long) 0), "INTEGRATE_A");
      module_initialization_70_tools_shape(((long) 0), "INTEGRATE_A");
      module_initialization_70_tools_error(((long) 0), "INTEGRATE_A");
      module_initialization_70_type_type(((long) 0), "INTEGRATE_A");
      module_initialization_70_ast_var(((long) 0), "INTEGRATE_A");
      module_initialization_70_ast_node(((long) 0), "INTEGRATE_A");
      return
	 module_initialization_70_integrate_info(((long) 0), "INTEGRATE_A");
   }
}
