/*===========================================================================*/
/*   (Integrate/ctn.scm)                                                     */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;

typedef struct svar_iinfo_76
  {
     obj_t f_mark_181;
     obj_t u_mark_209;
     bool_t kaptured__204;
     bool_t celled__113;
  }
             *svar_iinfo_76_bglt;

typedef struct sexit_iinfo_190
  {
     obj_t f_mark_181;
     obj_t u_mark_209;
     bool_t kaptured__204;
     bool_t celled__113;
  }
               *sexit_iinfo_190_bglt;

typedef struct sfun_iinfo_105
  {
     obj_t owner;
     obj_t free;
     obj_t bound;
     obj_t cfrom;
     obj_t cto;
     obj_t k;
     obj_t k__190;
     obj_t u;
     obj_t cn;
     obj_t ct;
     obj_t kont;
     bool_t g__219;
     obj_t l;
     obj_t led;
     obj_t istamp;
     obj_t global;
     obj_t kaptured;
  }
              *sfun_iinfo_105_bglt;


static obj_t method_init_76_integrate_ctn();
extern obj_t global_ast_var;
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t module_initialization_70_integrate_ctn(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_integrate_info(long, char *);
extern obj_t module_initialization_70_integrate_a(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
static obj_t imported_modules_init_94_integrate_ctn();
static obj_t library_modules_init_112_integrate_ctn();
extern obj_t open_input_string(obj_t);
extern obj_t memq___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern obj_t read___reader(obj_t);
extern obj_t cn_ct__54_integrate_ctn(obj_t);
static obj_t require_initialization_114_integrate_ctn = BUNSPEC;
static obj_t cnst_init_137_integrate_ctn();
static obj_t _cn_ct__5_integrate_ctn(obj_t, obj_t);
static obj_t __cnst[2];

DEFINE_EXPORT_PROCEDURE(cn_ct__env_19_integrate_ctn, _cn_ct__5_integrate_ctn1642, _cn_ct__5_integrate_ctn, 0L, 1);
DEFINE_STRING(string1637_integrate_ctn, string1637_integrate_ctn1643, "ESCAPE TAIL ", 12);



/* module-initialization */
obj_t 
module_initialization_70_integrate_ctn(long checksum_1428, char *from_1429)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_integrate_ctn))
	{
	   require_initialization_114_integrate_ctn =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_integrate_ctn();
	   cnst_init_137_integrate_ctn();
	   imported_modules_init_94_integrate_ctn();
	   method_init_76_integrate_ctn();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_integrate_ctn()
{
   AN_OBJECT;
   {	/* Integrate/ctn.scm 14 */
      module_initialization_70___object(((long) 0), "INTEGRATE_CTN");
      module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "INTEGRATE_CTN");
      module_initialization_70___reader(((long) 0), "INTEGRATE_CTN");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_integrate_ctn()
{
   AN_OBJECT;
   {	/* Integrate/ctn.scm 14 */
      {		/* Integrate/ctn.scm 14 */
	 obj_t cnst_port_138_1421;
	 cnst_port_138_1421 =
	    open_input_string(string1637_integrate_ctn);
	 {
	    long i_1422;
	    i_1422 = ((long) 1);
	  loop_1423:
	    {	/* Integrate/ctn.scm 14 */
	       bool_t test1638_1424;
	       test1638_1424 =
		  (i_1422 == ((long) -1));
	       if (test1638_1424)
		 {	/* Integrate/ctn.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Integrate/ctn.scm 14 */
		    {	/* Integrate/ctn.scm 14 */
		       obj_t arg1639_1425;
		       {	/* Integrate/ctn.scm 14 */
			  obj_t list1640_1426;
			  list1640_1426 =
			     MAKE_PAIR(cnst_port_138_1421, BNIL);
			  arg1639_1425 =
			     read___reader(list1640_1426);
		       }
		       CNST_TABLE_SET(i_1422, arg1639_1425);
		    }
		    {	/* Integrate/ctn.scm 14 */
		       int aux_1427;
		       {	/* Integrate/ctn.scm 14 */
			  long aux_1446;
			  aux_1446 =
			     (i_1422 - ((long) 1));
			  aux_1427 =
			     (int) (aux_1446);
		       }
		       {
			  long i_1449;
			  i_1449 =
			     (long) (aux_1427);
			  i_1422 = i_1449;
			  goto loop_1423;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* cn&ct! */
obj_t 
cn_ct__54_integrate_ctn(obj_t a_1)
{
   AN_OBJECT;
   {	/* Integrate/ctn.scm 30 */
      {
	 obj_t as_883;
	 obj_t g_cn_224_884;
	 as_883 = a_1;
	 g_cn_224_884 = BNIL;
       loop_885:
	 if (
	    NULLP(as_883))
	   {	/* Integrate/ctn.scm 33 */
	      return g_cn_224_884;
	   }
	 else
	   {	/* Integrate/ctn.scm 37 */
	      obj_t a_887;
	      a_887 =
		 CAR(as_883);
	      {		/* Integrate/ctn.scm 37 */
		 obj_t f_888;
		 f_888 =
		    CAR(a_887);
		 {	/* Integrate/ctn.scm 38 */
		    obj_t g_889;
		    {	/* ./Ieee/pair-list.scm 5701 */
		       obj_t aux_1455;
		       aux_1455 =
			  CDR(a_887);
		       g_889 =
			  CAR(aux_1455);
		    }
		    {	/* Integrate/ctn.scm 39 */
		       obj_t k_890;
		       {	/* ./Ieee/pair-list.scm 5701 */
			  obj_t aux_1458;
			  {	/* ./Ieee/pair-list.scm 5707 */
			     obj_t aux_1459;
			     aux_1459 =
				CDR(a_887);
			     aux_1458 =
				CDR(aux_1459);
			  }
			  k_890 =
			     CAR(aux_1458);
		       }
		       {	/* Integrate/ctn.scm 40 */
			  value_bglt fi_891;
			  {	/* Integrate/ctn.scm 41 */
			     variable_bglt obj_1310;
			     obj_1310 =
				(variable_bglt) (f_888);
			     fi_891 =
				(((variable_bglt) CREF(obj_1310))->value);
			  }
			  {	/* Integrate/ctn.scm 41 */
			     value_bglt gi_892;
			     {	/* Integrate/ctn.scm 42 */
				variable_bglt obj_1311;
				obj_1311 =
				   (variable_bglt) (g_889);
				gi_892 =
				   (((variable_bglt) CREF(obj_1311))->value);
			     }
			     {	/* Integrate/ctn.scm 42 */

				{	/* Integrate/ctn.scm 44 */
				   bool_t test1517_893;
				   test1517_893 =
				      is_a__118___object(g_889, global_ast_var);
				   if (test1517_893)
				     {	/* Integrate/ctn.scm 44 */
					{
					   obj_t as_1469;
					   as_1469 =
					      CDR(as_883);
					   as_883 = as_1469;
					   goto loop_885;
					}
				     }
				   else
				     {	/* Integrate/ctn.scm 46 */
					bool_t test_1471;
					{	/* ./Ieee/equiv.scm 5508 */
					   obj_t aux_1472;
					   aux_1472 =
					      CNST_TABLE_REF(((long) 0));
					   test_1471 =
					      (k_890 == aux_1472);
					}
					if (test_1471)
					  {	/* Integrate/ctn.scm 46 */
					     {	/* Integrate/ctn.scm 47 */
						obj_t arg1521_896;
						{	/* ./Ieee/pair-list.scm 5689 */
						   obj_t aux_1475;
						   {	/* Integrate/ctn.scm 47 */
						      sfun_iinfo_105_bglt obj_1316;
						      obj_1316 =
							 (sfun_iinfo_105_bglt) (fi_891);
						      {
							 obj_t aux_1477;
							 {	/* ./Integrate/iinfo.scm 861 */
							    object_bglt aux_1478;
							    aux_1478 =
							       (object_bglt) (obj_1316);
							    aux_1477 =
							       OBJECT_WIDENING(aux_1478);
							 }
							 aux_1475 =
							    (((sfun_iinfo_105_bglt) CREF(aux_1477))->ct);
						      }
						   }
						   arg1521_896 =
						      MAKE_PAIR(g_889, aux_1475);
						}
						{	/* Integrate/ctn.scm 47 */
						   sfun_iinfo_105_bglt obj_1319;
						   obj_1319 =
						      (sfun_iinfo_105_bglt) (fi_891);
						   {
						      obj_t aux_1484;
						      {		/* ./Integrate/iinfo.scm 861 */
							 object_bglt aux_1485;
							 aux_1485 =
							    (object_bglt) (obj_1319);
							 aux_1484 =
							    OBJECT_WIDENING(aux_1485);
						      }
						      ((((sfun_iinfo_105_bglt) CREF(aux_1484))->ct) = ((obj_t) arg1521_896), BUNSPEC);
						   }
						}
					     }
					     {	/* Integrate/ctn.scm 48 */
						bool_t test_1489;
						if (
						   (f_888 == g_889))
						  {	/* Integrate/ctn.scm 48 */
						     test_1489 = ((bool_t) 0)
							;
						  }
						else
						  {	/* Integrate/ctn.scm 49 */
						     bool_t test_1492;
						     {	/* Integrate/ctn.scm 49 */
							obj_t aux_1493;
							{	/* Integrate/ctn.scm 49 */
							   obj_t aux_1494;
							   {	/* Integrate/ctn.scm 49 */
							      sfun_iinfo_105_bglt obj_1323;
							      obj_1323 =
								 (sfun_iinfo_105_bglt) (fi_891);
							      {
								 obj_t aux_1496;
								 {	/* ./Integrate/iinfo.scm 863 */
								    object_bglt aux_1497;
								    aux_1497 =
								       (object_bglt) (obj_1323);
								    aux_1496 =
								       OBJECT_WIDENING(aux_1497);
								 }
								 aux_1494 =
								    (((sfun_iinfo_105_bglt) CREF(aux_1496))->kont);
							      }
							   }
							   aux_1493 =
							      memq___r4_pairs_and_lists_6_3(g_889, aux_1494);
							}
							test_1492 =
							   CBOOL(aux_1493);
						     }
						     if (test_1492)
						       {	/* Integrate/ctn.scm 49 */
							  test_1489 = ((bool_t) 0)
							     ;
						       }
						     else
						       {	/* Integrate/ctn.scm 49 */
							  test_1489 = ((bool_t) 1)
							     ;
						       }
						  }
						if (test_1489)
						  {	/* Integrate/ctn.scm 50 */
						     obj_t arg1525_899;
						     {	/* ./Ieee/pair-list.scm 5689 */
							obj_t aux_1503;
							{	/* Integrate/ctn.scm 50 */
							   sfun_iinfo_105_bglt obj_1324;
							   obj_1324 =
							      (sfun_iinfo_105_bglt) (fi_891);
							   {
							      obj_t aux_1505;
							      {		/* ./Integrate/iinfo.scm 863 */
								 object_bglt aux_1506;
								 aux_1506 =
								    (object_bglt) (obj_1324);
								 aux_1505 =
								    OBJECT_WIDENING(aux_1506);
							      }
							      aux_1503 =
								 (((sfun_iinfo_105_bglt) CREF(aux_1505))->kont);
							   }
							}
							arg1525_899 =
							   MAKE_PAIR(g_889, aux_1503);
						     }
						     {	/* Integrate/ctn.scm 50 */
							sfun_iinfo_105_bglt obj_1327;
							obj_1327 =
							   (sfun_iinfo_105_bglt) (fi_891);
							{
							   obj_t aux_1512;
							   {	/* ./Integrate/iinfo.scm 863 */
							      object_bglt aux_1513;
							      aux_1513 =
								 (object_bglt) (obj_1327);
							      aux_1512 =
								 OBJECT_WIDENING(aux_1513);
							   }
							   ((((sfun_iinfo_105_bglt) CREF(aux_1512))->kont) = ((obj_t) arg1525_899), BUNSPEC);
							}
						     }
						  }
						else
						  {	/* Integrate/ctn.scm 48 */
						     BUNSPEC;
						  }
					     }
					     {
						obj_t as_1517;
						as_1517 =
						   CDR(as_883);
						as_883 = as_1517;
						goto loop_885;
					     }
					  }
					else
					  {	/* Integrate/ctn.scm 52 */
					     bool_t test_1519;
					     {	/* ./Ieee/equiv.scm 5508 */
						obj_t aux_1520;
						aux_1520 =
						   CNST_TABLE_REF(((long) 1));
						test_1519 =
						   (k_890 == aux_1520);
					     }
					     if (test_1519)
					       {	/* Integrate/ctn.scm 52 */
						  {	/* Integrate/ctn.scm 53 */
						     bool_t test_1523;
						     {	/* Integrate/ctn.scm 53 */
							obj_t aux_1524;
							{	/* Integrate/ctn.scm 53 */
							   obj_t aux_1525;
							   {	/* Integrate/ctn.scm 53 */
							      sfun_iinfo_105_bglt obj_1332;
							      obj_1332 =
								 (sfun_iinfo_105_bglt) (fi_891);
							      {
								 obj_t aux_1527;
								 {	/* ./Integrate/iinfo.scm 863 */
								    object_bglt aux_1528;
								    aux_1528 =
								       (object_bglt) (obj_1332);
								    aux_1527 =
								       OBJECT_WIDENING(aux_1528);
								 }
								 aux_1525 =
								    (((sfun_iinfo_105_bglt) CREF(aux_1527))->kont);
							      }
							   }
							   aux_1524 =
							      memq___r4_pairs_and_lists_6_3(g_889, aux_1525);
							}
							test_1523 =
							   CBOOL(aux_1524);
						     }
						     if (test_1523)
						       {	/* Integrate/ctn.scm 53 */
							  BUNSPEC;
						       }
						     else
						       {	/* Integrate/ctn.scm 54 */
							  obj_t arg1533_907;
							  {	/* ./Ieee/pair-list.scm 5689 */
							     obj_t aux_1534;
							     {	/* Integrate/ctn.scm 54 */
								sfun_iinfo_105_bglt obj_1333;
								obj_1333 =
								   (sfun_iinfo_105_bglt) (fi_891);
								{
								   obj_t aux_1536;
								   {	/* ./Integrate/iinfo.scm 863 */
								      object_bglt aux_1537;
								      aux_1537 =
									 (object_bglt) (obj_1333);
								      aux_1536 =
									 OBJECT_WIDENING(aux_1537);
								   }
								   aux_1534 =
								      (((sfun_iinfo_105_bglt) CREF(aux_1536))->kont);
								}
							     }
							     arg1533_907 =
								MAKE_PAIR(g_889, aux_1534);
							  }
							  {	/* Integrate/ctn.scm 54 */
							     sfun_iinfo_105_bglt obj_1336;
							     obj_1336 =
								(sfun_iinfo_105_bglt) (fi_891);
							     {
								obj_t aux_1543;
								{	/* ./Integrate/iinfo.scm 863 */
								   object_bglt aux_1544;
								   aux_1544 =
								      (object_bglt) (obj_1336);
								   aux_1543 =
								      OBJECT_WIDENING(aux_1544);
								}
								((((sfun_iinfo_105_bglt) CREF(aux_1543))->kont) = ((obj_t) arg1533_907), BUNSPEC);
							     }
							  }
						       }
						  }
						  {
						     obj_t as_1548;
						     as_1548 =
							CDR(as_883);
						     as_883 = as_1548;
						     goto loop_885;
						  }
					       }
					     else
					       {	/* Integrate/ctn.scm 56 */
						  bool_t test_1550;
						  {	/* Integrate/ctn.scm 56 */
						     sfun_iinfo_105_bglt obj_1339;
						     obj_1339 =
							(sfun_iinfo_105_bglt) (gi_892);
						     {	/* ./Integrate/iinfo.scm 857 */
							obj_t aux_1552;
							{
							   obj_t aux_1553;
							   {	/* ./Integrate/iinfo.scm 857 */
							      object_bglt aux_1554;
							      aux_1554 =
								 (object_bglt) (obj_1339);
							      aux_1553 =
								 OBJECT_WIDENING(aux_1554);
							   }
							   aux_1552 =
							      (((sfun_iinfo_105_bglt) CREF(aux_1553))->u);
							}
							test_1550 =
							   CBOOL(aux_1552);
						     }
						  }
						  if (test_1550)
						    {	/* Integrate/ctn.scm 56 */
						       {	/* Integrate/ctn.scm 57 */
							  obj_t arg1539_912;
							  {	/* ./Ieee/pair-list.scm 5689 */
							     obj_t aux_1559;
							     {	/* Integrate/ctn.scm 57 */
								sfun_iinfo_105_bglt obj_1340;
								obj_1340 =
								   (sfun_iinfo_105_bglt) (fi_891);
								{
								   obj_t aux_1561;
								   {	/* ./Integrate/iinfo.scm 861 */
								      object_bglt aux_1562;
								      aux_1562 =
									 (object_bglt) (obj_1340);
								      aux_1561 =
									 OBJECT_WIDENING(aux_1562);
								   }
								   aux_1559 =
								      (((sfun_iinfo_105_bglt) CREF(aux_1561))->ct);
								}
							     }
							     arg1539_912 =
								MAKE_PAIR(g_889, aux_1559);
							  }
							  {	/* Integrate/ctn.scm 57 */
							     sfun_iinfo_105_bglt obj_1343;
							     obj_1343 =
								(sfun_iinfo_105_bglt) (fi_891);
							     {
								obj_t aux_1568;
								{	/* ./Integrate/iinfo.scm 861 */
								   object_bglt aux_1569;
								   aux_1569 =
								      (object_bglt) (obj_1343);
								   aux_1568 =
								      OBJECT_WIDENING(aux_1569);
								}
								((((sfun_iinfo_105_bglt) CREF(aux_1568))->ct) = ((obj_t) arg1539_912), BUNSPEC);
							     }
							  }
						       }
						       {	/* Integrate/ctn.scm 58 */
							  bool_t test_1573;
							  {	/* Integrate/ctn.scm 58 */
							     obj_t aux_1574;
							     {	/* Integrate/ctn.scm 58 */
								obj_t aux_1575;
								{	/* Integrate/ctn.scm 58 */
								   sfun_iinfo_105_bglt obj_1345;
								   obj_1345 =
								      (sfun_iinfo_105_bglt) (fi_891);
								   {
								      obj_t aux_1577;
								      {		/* ./Integrate/iinfo.scm 863 */
									 object_bglt aux_1578;
									 aux_1578 =
									    (object_bglt) (obj_1345);
									 aux_1577 =
									    OBJECT_WIDENING(aux_1578);
								      }
								      aux_1575 =
									 (((sfun_iinfo_105_bglt) CREF(aux_1577))->kont);
								   }
								}
								aux_1574 =
								   memq___r4_pairs_and_lists_6_3(g_889, aux_1575);
							     }
							     test_1573 =
								CBOOL(aux_1574);
							  }
							  if (test_1573)
							    {	/* Integrate/ctn.scm 58 */
							       BUNSPEC;
							    }
							  else
							    {	/* Integrate/ctn.scm 59 */
							       obj_t arg1543_915;
							       {	/* ./Ieee/pair-list.scm 5689 */
								  obj_t aux_1584;
								  {	/* Integrate/ctn.scm 59 */
								     sfun_iinfo_105_bglt obj_1346;
								     obj_1346 =
									(sfun_iinfo_105_bglt) (fi_891);
								     {
									obj_t aux_1586;
									{	/* ./Integrate/iinfo.scm 863 */
									   object_bglt aux_1587;
									   aux_1587 =
									      (object_bglt) (obj_1346);
									   aux_1586 =
									      OBJECT_WIDENING(aux_1587);
									}
									aux_1584 =
									   (((sfun_iinfo_105_bglt) CREF(aux_1586))->kont);
								     }
								  }
								  arg1543_915 =
								     MAKE_PAIR(g_889, aux_1584);
							       }
							       {	/* Integrate/ctn.scm 59 */
								  sfun_iinfo_105_bglt obj_1349;
								  obj_1349 =
								     (sfun_iinfo_105_bglt) (fi_891);
								  {
								     obj_t aux_1593;
								     {	/* ./Integrate/iinfo.scm 863 */
									object_bglt aux_1594;
									aux_1594 =
									   (object_bglt) (obj_1349);
									aux_1593 =
									   OBJECT_WIDENING(aux_1594);
								     }
								     ((((sfun_iinfo_105_bglt) CREF(aux_1593))->kont) = ((obj_t) arg1543_915), BUNSPEC);
								  }
							       }
							    }
						       }
						       {
							  obj_t as_1598;
							  as_1598 =
							     CDR(as_883);
							  as_883 = as_1598;
							  goto loop_885;
						       }
						    }
						  else
						    {	/* Integrate/ctn.scm 56 */
						       {	/* Integrate/ctn.scm 62 */
							  obj_t arg1548_919;
							  {	/* ./Ieee/pair-list.scm 5689 */
							     obj_t aux_1600;
							     {	/* Integrate/ctn.scm 62 */
								sfun_iinfo_105_bglt obj_1352;
								obj_1352 =
								   (sfun_iinfo_105_bglt) (fi_891);
								{
								   obj_t aux_1602;
								   {	/* ./Integrate/iinfo.scm 859 */
								      object_bglt aux_1603;
								      aux_1603 =
									 (object_bglt) (obj_1352);
								      aux_1602 =
									 OBJECT_WIDENING(aux_1603);
								   }
								   aux_1600 =
								      (((sfun_iinfo_105_bglt) CREF(aux_1602))->cn);
								}
							     }
							     arg1548_919 =
								MAKE_PAIR(g_889, aux_1600);
							  }
							  {	/* Integrate/ctn.scm 62 */
							     sfun_iinfo_105_bglt obj_1355;
							     obj_1355 =
								(sfun_iinfo_105_bglt) (fi_891);
							     {
								obj_t aux_1609;
								{	/* ./Integrate/iinfo.scm 859 */
								   object_bglt aux_1610;
								   aux_1610 =
								      (object_bglt) (obj_1355);
								   aux_1609 =
								      OBJECT_WIDENING(aux_1610);
								}
								((((sfun_iinfo_105_bglt) CREF(aux_1609))->cn) = ((obj_t) arg1548_919), BUNSPEC);
							     }
							  }
						       }
						       {	/* Integrate/ctn.scm 63 */
							  bool_t test_1614;
							  {	/* Integrate/ctn.scm 63 */
							     sfun_iinfo_105_bglt obj_1357;
							     obj_1357 =
								(sfun_iinfo_105_bglt) (gi_892);
							     {
								obj_t aux_1616;
								{	/* ./Integrate/iinfo.scm 841 */
								   object_bglt aux_1617;
								   aux_1617 =
								      (object_bglt) (obj_1357);
								   aux_1616 =
								      OBJECT_WIDENING(aux_1617);
								}
								test_1614 =
								   (((sfun_iinfo_105_bglt) CREF(aux_1616))->g__219);
							     }
							  }
							  if (test_1614)
							    {
							       obj_t as_1621;
							       as_1621 =
								  CDR(as_883);
							       as_883 = as_1621;
							       goto loop_885;
							    }
							  else
							    {	/* Integrate/ctn.scm 63 */
							       {	/* Integrate/ctn.scm 65 */
								  sfun_iinfo_105_bglt obj_1359;
								  obj_1359 =
								     (sfun_iinfo_105_bglt) (gi_892);
								  {
								     obj_t aux_1624;
								     {	/* ./Integrate/iinfo.scm 841 */
									object_bglt aux_1625;
									aux_1625 =
									   (object_bglt) (obj_1359);
									aux_1624 =
									   OBJECT_WIDENING(aux_1625);
								     }
								     ((((sfun_iinfo_105_bglt) CREF(aux_1624))->g__219) = ((bool_t) ((bool_t) 1)), BUNSPEC);
								  }
							       }
							       {	/* Integrate/ctn.scm 66 */
								  obj_t arg1552_923;
								  obj_t arg1553_924;
								  arg1552_923 =
								     CDR(as_883);
								  arg1553_924 =
								     MAKE_PAIR(g_889, g_cn_224_884);
								  {
								     obj_t g_cn_224_1632;
								     obj_t as_1631;
								     as_1631 = arg1552_923;
								     g_cn_224_1632 = arg1553_924;
								     g_cn_224_884 = g_cn_224_1632;
								     as_883 = as_1631;
								     goto loop_885;
								  }
							       }
							    }
						       }
						    }
					       }
					  }
				     }
				}
			     }
			  }
		       }
		    }
		 }
	      }
	   }
      }
   }
}



/* _cn&ct! */
obj_t 
_cn_ct__5_integrate_ctn(obj_t env_1419, obj_t a_1420)
{
   AN_OBJECT;
   {	/* Integrate/ctn.scm 30 */
      return
	 cn_ct__54_integrate_ctn(a_1420);
   }
}



/* method-init */
obj_t 
method_init_76_integrate_ctn()
{
   AN_OBJECT;
   {	/* Integrate/ctn.scm 14 */
      return BUNSPEC;
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_integrate_ctn()
{
   AN_OBJECT;
   {	/* Integrate/ctn.scm 14 */
      module_initialization_70_tools_trace(((long) 0), "INTEGRATE_CTN");
      module_initialization_70_tools_shape(((long) 0), "INTEGRATE_CTN");
      module_initialization_70_type_type(((long) 0), "INTEGRATE_CTN");
      module_initialization_70_ast_var(((long) 0), "INTEGRATE_CTN");
      module_initialization_70_ast_node(((long) 0), "INTEGRATE_CTN");
      module_initialization_70_integrate_info(((long) 0), "INTEGRATE_CTN");
      return
	 module_initialization_70_integrate_a(((long) 0), "INTEGRATE_CTN");
   }
}
