/*===========================================================================*/
/*   (Integrate/cto.scm)                                                     */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;

typedef struct svar_iinfo_76
  {
     obj_t f_mark_181;
     obj_t u_mark_209;
     bool_t kaptured__204;
     bool_t celled__113;
  }
             *svar_iinfo_76_bglt;

typedef struct sexit_iinfo_190
  {
     obj_t f_mark_181;
     obj_t u_mark_209;
     bool_t kaptured__204;
     bool_t celled__113;
  }
               *sexit_iinfo_190_bglt;

typedef struct sfun_iinfo_105
  {
     obj_t owner;
     obj_t free;
     obj_t bound;
     obj_t cfrom;
     obj_t cto;
     obj_t k;
     obj_t k__190;
     obj_t u;
     obj_t cn;
     obj_t ct;
     obj_t kont;
     bool_t g__219;
     obj_t l;
     obj_t led;
     obj_t istamp;
     obj_t global;
     obj_t kaptured;
  }
              *sfun_iinfo_105_bglt;


static obj_t method_init_76_integrate_cto();
extern obj_t make_box_202_ast_node;
extern obj_t funcall_ast_node;
extern long add_inlined_method__244___object(obj_t, obj_t, long);
extern obj_t fail_ast_node;
extern obj_t box_ref_242_ast_node;
extern obj_t sequence_ast_node;
extern obj_t let_var_6_ast_node;
extern obj_t var_ast_node;
extern obj_t closure_ast_node;
extern obj_t set_cto__5_integrate_cto(node_bglt, local_bglt);
extern obj_t pragma_ast_node;
extern obj_t set_ex_it_116_ast_node;
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t module_initialization_70_integrate_cto(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_integrate_info(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t let_fun_218_ast_node;
static obj_t imported_modules_init_94_integrate_cto();
extern obj_t app_ly_162_ast_node;
extern obj_t add_generic__110___object(obj_t, obj_t);
static obj_t _set_cto__default1538_20_integrate_cto(obj_t, obj_t, obj_t);
extern obj_t app_ast_node;
static obj_t library_modules_init_112_integrate_cto();
extern obj_t atom_ast_node;
extern obj_t cast_ast_node;
static obj_t toplevel_init_63_integrate_cto();
extern obj_t jump_ex_it_184_ast_node;
extern obj_t open_input_string(obj_t);
extern obj_t kwote_ast_node;
extern obj_t setq_ast_node;
extern obj_t box_set__221_ast_node;
extern obj_t local_ast_var;
extern obj_t memq___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern obj_t shape_tools_shape(obj_t);
static obj_t set_cto__default1538_228_integrate_cto(node_bglt, local_bglt);
extern obj_t internal_error_43_tools_error(obj_t, obj_t, obj_t);
static obj_t _set_cto_1755_109_integrate_cto(obj_t, obj_t, obj_t);
extern obj_t _classes__134___object;
extern obj_t select_ast_node;
extern obj_t read___reader(obj_t);
static obj_t require_initialization_114_integrate_cto = BUNSPEC;
extern obj_t conditional_ast_node;
static obj_t cnst_init_137_integrate_cto();
static obj_t __cnst[1];

DEFINE_STATIC_PROCEDURE(set_cto__default1538_env_140_integrate_cto, _set_cto__default1538_20_integrate_cto1764, _set_cto__default1538_20_integrate_cto, 0L, 2);
DEFINE_STRING(string1759_integrate_cto, string1759_integrate_cto1765, "SET-CTO!-DEFAULT1538 ", 21);
DEFINE_STRING(string1758_integrate_cto, string1758_integrate_cto1766, "No method for this object", 25);
DEFINE_STRING(string1757_integrate_cto, string1757_integrate_cto1767, "Unexpected closure", 18);
DEFINE_STRING(string1756_integrate_cto, string1756_integrate_cto1768, "set-cto!", 8);
DEFINE_EXPORT_GENERIC(set_cto__env_185_integrate_cto, _set_cto_1755_109_integrate_cto1769, _set_cto_1755_109_integrate_cto, 0L, 2);



/* module-initialization */
obj_t 
module_initialization_70_integrate_cto(long checksum_1641, char *from_1642)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_integrate_cto))
	{
	   require_initialization_114_integrate_cto =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_integrate_cto();
	   cnst_init_137_integrate_cto();
	   imported_modules_init_94_integrate_cto();
	   method_init_76_integrate_cto();
	   toplevel_init_63_integrate_cto();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_integrate_cto()
{
   AN_OBJECT;
   {	/* Integrate/cto.scm 14 */
      module_initialization_70___object(((long) 0), "INTEGRATE_CTO");
      module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "INTEGRATE_CTO");
      module_initialization_70___reader(((long) 0), "INTEGRATE_CTO");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_integrate_cto()
{
   AN_OBJECT;
   {	/* Integrate/cto.scm 14 */
      {		/* Integrate/cto.scm 14 */
	 obj_t cnst_port_138_1634;
	 cnst_port_138_1634 =
	    open_input_string(string1759_integrate_cto);
	 {
	    long i_1635;
	    i_1635 = ((long) 0);
	  loop_1636:
	    {	/* Integrate/cto.scm 14 */
	       bool_t test1760_1637;
	       test1760_1637 =
		  (i_1635 == ((long) -1));
	       if (test1760_1637)
		 {	/* Integrate/cto.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Integrate/cto.scm 14 */
		    {	/* Integrate/cto.scm 14 */
		       obj_t arg1761_1638;
		       {	/* Integrate/cto.scm 14 */
			  obj_t list1762_1639;
			  list1762_1639 =
			     MAKE_PAIR(cnst_port_138_1634, BNIL);
			  arg1761_1638 =
			     read___reader(list1762_1639);
		       }
		       CNST_TABLE_SET(i_1635, arg1761_1638);
		    }
		    {	/* Integrate/cto.scm 14 */
		       int aux_1640;
		       {	/* Integrate/cto.scm 14 */
			  long aux_1660;
			  aux_1660 =
			     (i_1635 - ((long) 1));
			  aux_1640 =
			     (int) (aux_1660);
		       }
		       {
			  long i_1663;
			  i_1663 =
			     (long) (aux_1640);
			  i_1635 = i_1663;
			  goto loop_1636;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_integrate_cto()
{
   AN_OBJECT;
   {	/* Integrate/cto.scm 14 */
      return BUNSPEC;
   }
}



/* method-init */
obj_t 
method_init_76_integrate_cto()
{
   AN_OBJECT;
   {	/* Integrate/cto.scm 14 */
      add_generic__110___object(set_cto__env_185_integrate_cto, set_cto__default1538_env_140_integrate_cto);
      add_inlined_method__244___object(set_cto__env_185_integrate_cto, atom_ast_node, ((long) 0));
      add_inlined_method__244___object(set_cto__env_185_integrate_cto, kwote_ast_node, ((long) 1));
      add_inlined_method__244___object(set_cto__env_185_integrate_cto, var_ast_node, ((long) 2));
      add_inlined_method__244___object(set_cto__env_185_integrate_cto, closure_ast_node, ((long) 3));
      add_inlined_method__244___object(set_cto__env_185_integrate_cto, sequence_ast_node, ((long) 4));
      add_inlined_method__244___object(set_cto__env_185_integrate_cto, app_ast_node, ((long) 5));
      add_inlined_method__244___object(set_cto__env_185_integrate_cto, app_ly_162_ast_node, ((long) 6));
      add_inlined_method__244___object(set_cto__env_185_integrate_cto, funcall_ast_node, ((long) 7));
      add_inlined_method__244___object(set_cto__env_185_integrate_cto, pragma_ast_node, ((long) 8));
      add_inlined_method__244___object(set_cto__env_185_integrate_cto, cast_ast_node, ((long) 9));
      add_inlined_method__244___object(set_cto__env_185_integrate_cto, setq_ast_node, ((long) 10));
      add_inlined_method__244___object(set_cto__env_185_integrate_cto, conditional_ast_node, ((long) 11));
      add_inlined_method__244___object(set_cto__env_185_integrate_cto, fail_ast_node, ((long) 12));
      add_inlined_method__244___object(set_cto__env_185_integrate_cto, select_ast_node, ((long) 13));
      add_inlined_method__244___object(set_cto__env_185_integrate_cto, let_fun_218_ast_node, ((long) 14));
      add_inlined_method__244___object(set_cto__env_185_integrate_cto, let_var_6_ast_node, ((long) 15));
      add_inlined_method__244___object(set_cto__env_185_integrate_cto, set_ex_it_116_ast_node, ((long) 16));
      add_inlined_method__244___object(set_cto__env_185_integrate_cto, jump_ex_it_184_ast_node, ((long) 17));
      add_inlined_method__244___object(set_cto__env_185_integrate_cto, make_box_202_ast_node, ((long) 18));
      add_inlined_method__244___object(set_cto__env_185_integrate_cto, box_set__221_ast_node, ((long) 19));
      {		/* Integrate/cto.scm 14 */
	 long aux_1686;
	 aux_1686 =
	    add_inlined_method__244___object(set_cto__env_185_integrate_cto, box_ref_242_ast_node, ((long) 20));
	 return
	    BINT(aux_1686);
      }
   }
}



/* set-cto! */
obj_t 
set_cto__5_integrate_cto(node_bglt node_1, local_bglt local_2)
{
   AN_OBJECT;
   {	/* Integrate/cto.scm 27 */
    set_cto__5_integrate_cto:
      {
	 obj_t method1666_1304;
	 obj_t class1671_1305;
	 {	/* Integrate/cto.scm 27 */
	    obj_t arg1674_1302;
	    obj_t arg1675_1303;
	    {	/* Integrate/cto.scm 27 */
	       object_bglt obj_1523;
	       obj_1523 =
		  (object_bglt) (node_1);
	       {	/* ./Llib/object.scm 2926 */
		  obj_t pre_method_105_1524;
		  pre_method_105_1524 =
		     PROCEDURE_REF(set_cto__env_185_integrate_cto, ((long) 2));
		  if (
		     INTEGERP(pre_method_105_1524))
		    {	/* ./Llib/object.scm 2927 */
		       PROCEDURE_SET(set_cto__env_185_integrate_cto, ((long) 2), BUNSPEC);
		       arg1674_1302 = pre_method_105_1524;
		    }
		  else
		    {	/* ./Llib/object.scm 2914 */
		       long obj_class_num_177_1529;
		       obj_class_num_177_1529 =
			  TYPE(obj_1523);
		       {	/* ./Llib/object.scm 2915 */
			  obj_t arg1176_1530;
			  arg1176_1530 =
			     PROCEDURE_REF(set_cto__env_185_integrate_cto, ((long) 1));
			  {	/* ./Llib/object.scm 2738 */
			     long arg1177_1534;
			     {	/* ./Llib/object.scm 2738 */
				long arg1178_1535;
				arg1178_1535 =
				   OBJECT_TYPE;
				arg1177_1534 =
				   (obj_class_num_177_1529 - arg1178_1535);
			     }
			     arg1674_1302 =
				VECTOR_REF(arg1176_1530, arg1177_1534);
			  }
		       }
		    }
	       }
	    }
	    {	/* Integrate/cto.scm 27 */
	       object_bglt object_1540;
	       object_1540 =
		  (object_bglt) (node_1);
	       {	/* ./Llib/object.scm 2695 */
		  long arg1179_1541;
		  {	/* ./Llib/object.scm 2695 */
		     long arg1180_1542;
		     long arg1181_1543;
		     arg1180_1542 =
			TYPE(object_1540);
		     arg1181_1543 =
			OBJECT_TYPE;
		     arg1179_1541 =
			(arg1180_1542 - arg1181_1543);
		  }
		  {	/* ./Llib/object.scm 2695 */
		     obj_t vector_1547;
		     vector_1547 = _classes__134___object;
		     arg1675_1303 =
			VECTOR_REF(vector_1547, arg1179_1541);
		  }
	       }
	    }
	    method1666_1304 = arg1674_1302;
	    class1671_1305 = arg1675_1303;
	    {

	       if (
		  INTEGERP(method1666_1304))
		 {	/* Integrate/cto.scm 27 */
		    switch (
		       (long) CINT(method1666_1304))
		      {
		      case ((long) 0):

			 return BUNSPEC;
			 break;
		      case ((long) 1):

			 return BUNSPEC;
			 break;
		      case ((long) 2):

			 return BUNSPEC;
			 break;
		      case ((long) 3):

			 {	/* Integrate/cto.scm 51 */
			    obj_t arg1680_1321;
			    {	/* Integrate/cto.scm 51 */
			       obj_t aux_1706;
			       {	/* Integrate/cto.scm 51 */
				  closure_bglt aux_1707;
				  aux_1707 =
				     (closure_bglt) (node_1);
				  aux_1706 =
				     (obj_t) (aux_1707);
			       }
			       arg1680_1321 =
				  shape_tools_shape(aux_1706);
			    }
			    return
			       internal_error_43_tools_error(string1756_integrate_cto, string1757_integrate_cto, arg1680_1321);
			 }
			 break;
		      case ((long) 4):

			 {	/* Integrate/cto.scm 57 */
			    sequence_bglt node_1322;
			    node_1322 =
			       (sequence_bglt) (node_1);
			    {
			       obj_t l1517_1325;
			       {	/* Integrate/cto.scm 58 */
				  bool_t aux_1713;
				  l1517_1325 =
				     (((sequence_bglt) CREF(node_1322))->nodes);
				lname1518_1326:
				  if (
				     PAIRP(l1517_1325))
				    {	/* Integrate/cto.scm 58 */
				       {	/* Integrate/cto.scm 58 */
					  node_bglt aux_1716;
					  {	/* Integrate/cto.scm 58 */
					     obj_t aux_1717;
					     aux_1717 =
						CAR(l1517_1325);
					     aux_1716 =
						(node_bglt) (aux_1717);
					  }
					  set_cto__5_integrate_cto(aux_1716, local_2);
				       }
				       {
					  obj_t l1517_1721;
					  l1517_1721 =
					     CDR(l1517_1325);
					  l1517_1325 = l1517_1721;
					  goto lname1518_1326;
				       }
				    }
				  else
				    {	/* Integrate/cto.scm 58 */
				       aux_1713 = ((bool_t) 1);
				    }
				  return
				     BBOOL(aux_1713);
			       }
			    }
			 }
			 break;
		      case ((long) 5):

			 {	/* Integrate/cto.scm 64 */
			    app_bglt node_1331;
			    node_1331 =
			       (app_bglt) (node_1);
			    {	/* Integrate/cto.scm 67 */
			       variable_bglt fun_1334;
			       {	/* Integrate/cto.scm 67 */
				  var_bglt arg1699_1350;
				  arg1699_1350 =
				     (((app_bglt) CREF(node_1331))->fun);
				  fun_1334 =
				     (((var_bglt) CREF(arg1699_1350))->variable);
			       }
			       {	/* Integrate/cto.scm 68 */
				  bool_t test1684_1335;
				  {	/* Integrate/cto.scm 68 */
				     bool_t test1685_1336;
				     test1685_1336 =
					is_a__118___object(
					(obj_t) (fun_1334), local_ast_var);
				     if (test1685_1336)
				       {	/* Integrate/cto.scm 68 */
					  bool_t test_1731;
					  {	/* ./Ieee/equiv.scm 5508 */
					     obj_t aux_1734;
					     obj_t aux_1732;
					     aux_1734 =
						(obj_t) (fun_1334);
					     aux_1732 =
						(obj_t) (local_2);
					     test_1731 =
						(aux_1732 == aux_1734);
					  }
					  if (test_1731)
					    {	/* Integrate/cto.scm 68 */
					       test1684_1335 = ((bool_t) 0);
					    }
					  else
					    {	/* Integrate/cto.scm 68 */
					       test1684_1335 = ((bool_t) 1);
					    }
				       }
				     else
				       {	/* Integrate/cto.scm 68 */
					  test1684_1335 = ((bool_t) 0);
				       }
				  }
				  if (test1684_1335)
				    {	/* Integrate/cto.scm 68 */
				       BUNSPEC;
				    }
				  else
				    {	/* Integrate/cto.scm 68 */
				       BUNSPEC;
				    }
			       }
			       {	/* Integrate/cto.scm 75 */
				  bool_t test1687_1338;
				  {	/* Integrate/cto.scm 75 */
				     bool_t test1692_1343;
				     test1692_1343 =
					is_a__118___object(
					(obj_t) (fun_1334), local_ast_var);
				     if (test1692_1343)
				       {	/* Integrate/cto.scm 76 */
					  bool_t test_1741;
					  {	/* Integrate/cto.scm 76 */
					     sfun_iinfo_105_bglt obj_1560;
					     {	/* Integrate/cto.scm 76 */
						value_bglt aux_1742;
						{	/* Integrate/cto.scm 76 */
						   local_bglt obj_1559;
						   obj_1559 =
						      (local_bglt) (fun_1334);
						   aux_1742 =
						      (((local_bglt) CREF(obj_1559))->value);
						}
						obj_1560 =
						   (sfun_iinfo_105_bglt) (aux_1742);
					     }
					     {
						obj_t aux_1746;
						{	/* ./Integrate/iinfo.scm 1029 */
						   object_bglt aux_1747;
						   aux_1747 =
						      (object_bglt) (obj_1560);
						   aux_1746 =
						      OBJECT_WIDENING(aux_1747);
						}
						test_1741 =
						   (((sfun_iinfo_105_bglt) CREF(aux_1746))->g__219);
					     }
					  }
					  if (test_1741)
					    {	/* Integrate/cto.scm 77 */
					       bool_t test_1751;
					       {	/* ./Ieee/equiv.scm 5508 */
						  obj_t aux_1754;
						  obj_t aux_1752;
						  aux_1754 =
						     (obj_t) (fun_1334);
						  aux_1752 =
						     (obj_t) (local_2);
						  test_1751 =
						     (aux_1752 == aux_1754);
					       }
					       if (test_1751)
						 {	/* Integrate/cto.scm 77 */
						    test1687_1338 = ((bool_t) 0);
						 }
					       else
						 {	/* Integrate/cto.scm 78 */
						    bool_t test_1757;
						    {	/* Integrate/cto.scm 78 */
						       obj_t aux_1758;
						       {	/* Integrate/cto.scm 78 */
							  obj_t aux_1759;
							  {	/* Integrate/cto.scm 78 */
							     sfun_iinfo_105_bglt obj_1564;
							     {	/* Integrate/cto.scm 78 */
								value_bglt aux_1761;
								aux_1761 =
								   (((local_bglt) CREF(local_2))->value);
								obj_1564 =
								   (sfun_iinfo_105_bglt) (aux_1761);
							     }
							     {
								obj_t aux_1764;
								{	/* ./Integrate/iinfo.scm 1039 */
								   object_bglt aux_1765;
								   aux_1765 =
								      (object_bglt) (obj_1564);
								   aux_1764 =
								      OBJECT_WIDENING(aux_1765);
								}
								aux_1759 =
								   (((sfun_iinfo_105_bglt) CREF(aux_1764))->cto);
							     }
							  }
							  aux_1758 =
							     memq___r4_pairs_and_lists_6_3(
							     (obj_t) (fun_1334), aux_1759);
						       }
						       test_1757 =
							  CBOOL(aux_1758);
						    }
						    if (test_1757)
						      {		/* Integrate/cto.scm 78 */
							 test1687_1338 = ((bool_t) 0);
						      }
						    else
						      {		/* Integrate/cto.scm 78 */
							 test1687_1338 = ((bool_t) 1);
						      }
						 }
					    }
					  else
					    {	/* Integrate/cto.scm 76 */
					       test1687_1338 = ((bool_t) 0);
					    }
				       }
				     else
				       {	/* Integrate/cto.scm 75 */
					  test1687_1338 = ((bool_t) 0);
				       }
				  }
				  if (test1687_1338)
				    {	/* Integrate/cto.scm 79 */
				       value_bglt arg1688_1339;
				       obj_t arg1689_1340;
				       arg1688_1339 =
					  (((local_bglt) CREF(local_2))->value);
				       {	/* ./Ieee/pair-list.scm 5689 */
					  obj_t aux_1775;
					  obj_t aux_1773;
					  {	/* Integrate/cto.scm 81 */
					     sfun_iinfo_105_bglt obj_1567;
					     {	/* Integrate/cto.scm 81 */
						value_bglt aux_1776;
						aux_1776 =
						   (((local_bglt) CREF(local_2))->value);
						obj_1567 =
						   (sfun_iinfo_105_bglt) (aux_1776);
					     }
					     {
						obj_t aux_1779;
						{	/* ./Integrate/iinfo.scm 1039 */
						   object_bglt aux_1780;
						   aux_1780 =
						      (object_bglt) (obj_1567);
						   aux_1779 =
						      OBJECT_WIDENING(aux_1780);
						}
						aux_1775 =
						   (((sfun_iinfo_105_bglt) CREF(aux_1779))->cto);
					     }
					  }
					  aux_1773 =
					     (obj_t) (fun_1334);
					  arg1689_1340 =
					     MAKE_PAIR(aux_1773, aux_1775);
				       }
				       {	/* Integrate/cto.scm 79 */
					  sfun_iinfo_105_bglt obj_1570;
					  obj_1570 =
					     (sfun_iinfo_105_bglt) (arg1688_1339);
					  {
					     obj_t aux_1786;
					     {	/* ./Integrate/iinfo.scm 1039 */
						object_bglt aux_1787;
						aux_1787 =
						   (object_bglt) (obj_1570);
						aux_1786 =
						   OBJECT_WIDENING(aux_1787);
					     }
					     ((((sfun_iinfo_105_bglt) CREF(aux_1786))->cto) = ((obj_t) arg1689_1340), BUNSPEC);
					  }
				       }
				    }
				  else
				    {	/* Integrate/cto.scm 75 */
				       BUNSPEC;
				    }
			       }
			    }
			    {
			       obj_t asts_1351;
			       asts_1351 =
				  (((app_bglt) CREF(node_1331))->args);
			     liip_1352:
			       if (
				  NULLP(asts_1351))
				 {	/* Integrate/cto.scm 84 */
				    return BUNSPEC;
				 }
			       else
				 {	/* Integrate/cto.scm 84 */
				    {	/* Integrate/cto.scm 87 */
				       node_bglt aux_1793;
				       {	/* Integrate/cto.scm 87 */
					  obj_t aux_1794;
					  aux_1794 =
					     CAR(asts_1351);
					  aux_1793 =
					     (node_bglt) (aux_1794);
				       }
				       set_cto__5_integrate_cto(aux_1793, local_2);
				    }
				    {
				       obj_t asts_1798;
				       asts_1798 =
					  CDR(asts_1351);
				       asts_1351 = asts_1798;
				       goto liip_1352;
				    }
				 }
			    }
			 }
			 break;
		      case ((long) 6):

			 {	/* Integrate/cto.scm 94 */
			    app_ly_162_bglt node_1357;
			    node_1357 =
			       (app_ly_162_bglt) (node_1);
			    set_cto__5_integrate_cto(
			       (((app_ly_162_bglt) CREF(node_1357))->fun), local_2);
			    {
			       node_bglt node_1804;
			       node_1804 =
				  (((app_ly_162_bglt) CREF(node_1357))->arg);
			       node_1 = node_1804;
			       goto set_cto__5_integrate_cto;
			    }
			 }
			 break;
		      case ((long) 7):

			 {	/* Integrate/cto.scm 102 */
			    funcall_bglt node_1362;
			    node_1362 =
			       (funcall_bglt) (node_1);
			    {
			       obj_t asts_1365;
			       asts_1365 =
				  (((funcall_bglt) CREF(node_1362))->args);
			     liip_1366:
			       if (
				  NULLP(asts_1365))
				 {
				    node_bglt node_1809;
				    node_1809 =
				       (((funcall_bglt) CREF(node_1362))->fun);
				    node_1 = node_1809;
				    goto set_cto__5_integrate_cto;
				 }
			       else
				 {	/* Integrate/cto.scm 104 */
				    {	/* Integrate/cto.scm 107 */
				       node_bglt aux_1811;
				       {	/* Integrate/cto.scm 107 */
					  obj_t aux_1812;
					  aux_1812 =
					     CAR(asts_1365);
					  aux_1811 =
					     (node_bglt) (aux_1812);
				       }
				       set_cto__5_integrate_cto(aux_1811, local_2);
				    }
				    {
				       obj_t asts_1816;
				       asts_1816 =
					  CDR(asts_1365);
				       asts_1365 = asts_1816;
				       goto liip_1366;
				    }
				 }
			    }
			 }
			 break;
		      case ((long) 8):

			 {	/* Integrate/cto.scm 114 */
			    pragma_bglt node_1372;
			    node_1372 =
			       (pragma_bglt) (node_1);
			    {
			       obj_t l1523_1375;
			       {	/* Integrate/cto.scm 115 */
				  bool_t aux_1820;
				  l1523_1375 =
				     (((pragma_bglt) CREF(node_1372))->args);
				lname1524_1376:
				  if (
				     PAIRP(l1523_1375))
				    {	/* Integrate/cto.scm 115 */
				       {	/* Integrate/cto.scm 115 */
					  node_bglt aux_1823;
					  {	/* Integrate/cto.scm 115 */
					     obj_t aux_1824;
					     aux_1824 =
						CAR(l1523_1375);
					     aux_1823 =
						(node_bglt) (aux_1824);
					  }
					  set_cto__5_integrate_cto(aux_1823, local_2);
				       }
				       {
					  obj_t l1523_1828;
					  l1523_1828 =
					     CDR(l1523_1375);
					  l1523_1375 = l1523_1828;
					  goto lname1524_1376;
				       }
				    }
				  else
				    {	/* Integrate/cto.scm 115 */
				       aux_1820 = ((bool_t) 1);
				    }
				  return
				     BBOOL(aux_1820);
			       }
			    }
			 }
			 break;
		      case ((long) 9):

			 {	/* Integrate/cto.scm 121 */
			    cast_bglt node_1381;
			    node_1381 =
			       (cast_bglt) (node_1);
			    {
			       node_bglt node_1833;
			       node_1833 =
				  (((cast_bglt) CREF(node_1381))->arg);
			       node_1 = node_1833;
			       goto set_cto__5_integrate_cto;
			    }
			 }
			 break;
		      case ((long) 10):

			 {	/* Integrate/cto.scm 128 */
			    setq_bglt node_1385;
			    node_1385 =
			       (setq_bglt) (node_1);
			    {	/* Integrate/cto.scm 129 */
			       node_bglt aux_1836;
			       {	/* Integrate/cto.scm 129 */
				  var_bglt aux_1837;
				  aux_1837 =
				     (((setq_bglt) CREF(node_1385))->var);
				  aux_1836 =
				     (node_bglt) (aux_1837);
			       }
			       set_cto__5_integrate_cto(aux_1836, local_2);
			    }
			    {
			       node_bglt node_1841;
			       node_1841 =
				  (((setq_bglt) CREF(node_1385))->value);
			       node_1 = node_1841;
			       goto set_cto__5_integrate_cto;
			    }
			 }
			 break;
		      case ((long) 11):

			 {	/* Integrate/cto.scm 136 */
			    conditional_bglt node_1390;
			    node_1390 =
			       (conditional_bglt) (node_1);
			    set_cto__5_integrate_cto(
			       (((conditional_bglt) CREF(node_1390))->test), local_2);
			    set_cto__5_integrate_cto(
			       (((conditional_bglt) CREF(node_1390))->true), local_2);
			    {
			       node_bglt node_1848;
			       node_1848 =
				  (((conditional_bglt) CREF(node_1390))->false);
			       node_1 = node_1848;
			       goto set_cto__5_integrate_cto;
			    }
			 }
			 break;
		      case ((long) 12):

			 {	/* Integrate/cto.scm 145 */
			    fail_bglt node_1396;
			    node_1396 =
			       (fail_bglt) (node_1);
			    set_cto__5_integrate_cto(
			       (((fail_bglt) CREF(node_1396))->proc), local_2);
			    set_cto__5_integrate_cto(
			       (((fail_bglt) CREF(node_1396))->msg), local_2);
			    {
			       node_bglt node_1855;
			       node_1855 =
				  (((fail_bglt) CREF(node_1396))->obj);
			       node_1 = node_1855;
			       goto set_cto__5_integrate_cto;
			    }
			 }
			 break;
		      case ((long) 13):

			 {	/* Integrate/cto.scm 154 */
			    select_bglt node_1402;
			    node_1402 =
			       (select_bglt) (node_1);
			    {
			       obj_t clauses_1405;
			       clauses_1405 =
				  (((select_bglt) CREF(node_1402))->clauses);
			     liip_1406:
			       if (
				  NULLP(clauses_1405))
				 {
				    node_bglt node_1860;
				    node_1860 =
				       (((select_bglt) CREF(node_1402))->test);
				    node_1 = node_1860;
				    goto set_cto__5_integrate_cto;
				 }
			       else
				 {	/* Integrate/cto.scm 156 */
				    {	/* Integrate/cto.scm 159 */
				       node_bglt aux_1862;
				       {	/* Integrate/cto.scm 159 */
					  obj_t aux_1863;
					  {	/* ./Ieee/pair-list.scm 5707 */
					     obj_t aux_1864;
					     aux_1864 =
						CAR(clauses_1405);
					     aux_1863 =
						CDR(aux_1864);
					  }
					  aux_1862 =
					     (node_bglt) (aux_1863);
				       }
				       set_cto__5_integrate_cto(aux_1862, local_2);
				    }
				    {
				       obj_t clauses_1869;
				       clauses_1869 =
					  CDR(clauses_1405);
				       clauses_1405 = clauses_1869;
				       goto liip_1406;
				    }
				 }
			    }
			 }
			 break;
		      case ((long) 14):

			 {	/* Integrate/cto.scm 166 */
			    let_fun_218_bglt node_1413;
			    node_1413 =
			       (let_fun_218_bglt) (node_1);
			    {
			       obj_t locals_1416;
			       locals_1416 =
				  (((let_fun_218_bglt) CREF(node_1413))->locals);
			     liip_1417:
			       if (
				  NULLP(locals_1416))
				 {
				    node_bglt node_1875;
				    node_1875 =
				       (((let_fun_218_bglt) CREF(node_1413))->body);
				    node_1 = node_1875;
				    goto set_cto__5_integrate_cto;
				 }
			       else
				 {	/* Integrate/cto.scm 172 */

				    {	/* Integrate/cto.scm 174 */
				       node_bglt aux_1877;
				       {	/* Integrate/cto.scm 174 */
					  obj_t aux_1878;
					  {	/* Integrate/cto.scm 174 */
					     sfun_bglt obj_1608;
					     {	/* Integrate/cto.scm 174 */
						value_bglt aux_1879;
						{	/* Integrate/cto.scm 171 */
						   local_bglt obj_1606;
						   {	/* Integrate/cto.scm 171 */
						      obj_t aux_1880;
						      aux_1880 =
							 CAR(locals_1416);
						      obj_1606 =
							 (local_bglt) (aux_1880);
						   }
						   aux_1879 =
						      (((local_bglt) CREF(obj_1606))->value);
						}
						obj_1608 =
						   (sfun_bglt) (aux_1879);
					     }
					     aux_1878 =
						(((sfun_bglt) CREF(obj_1608))->body);
					  }
					  aux_1877 =
					     (node_bglt) (aux_1878);
				       }
				       set_cto__5_integrate_cto(aux_1877, local_2);
				    }
				    {
				       obj_t locals_1888;
				       locals_1888 =
					  CDR(locals_1416);
				       locals_1416 = locals_1888;
				       goto liip_1417;
				    }
				 }
			    }
			 }
			 break;
		      case ((long) 15):

			 {	/* Integrate/cto.scm 181 */
			    let_var_6_bglt node_1426;
			    node_1426 =
			       (let_var_6_bglt) (node_1);
			    {
			       obj_t bindings_1429;
			       bindings_1429 =
				  (((let_var_6_bglt) CREF(node_1426))->bindings);
			     liip_1430:
			       if (
				  NULLP(bindings_1429))
				 {
				    node_bglt node_1894;
				    node_1894 =
				       (((let_var_6_bglt) CREF(node_1426))->body);
				    node_1 = node_1894;
				    goto set_cto__5_integrate_cto;
				 }
			       else
				 {	/* Integrate/cto.scm 183 */
				    {	/* Integrate/cto.scm 186 */
				       node_bglt aux_1896;
				       {	/* Integrate/cto.scm 186 */
					  obj_t aux_1897;
					  {	/* ./Ieee/pair-list.scm 5707 */
					     obj_t aux_1898;
					     aux_1898 =
						CAR(bindings_1429);
					     aux_1897 =
						CDR(aux_1898);
					  }
					  aux_1896 =
					     (node_bglt) (aux_1897);
				       }
				       set_cto__5_integrate_cto(aux_1896, local_2);
				    }
				    {
				       obj_t bindings_1903;
				       bindings_1903 =
					  CDR(bindings_1429);
				       bindings_1429 = bindings_1903;
				       goto liip_1430;
				    }
				 }
			    }
			 }
			 break;
		      case ((long) 16):

			 {	/* Integrate/cto.scm 193 */
			    set_ex_it_116_bglt node_1437;
			    node_1437 =
			       (set_ex_it_116_bglt) (node_1);
			    {
			       node_bglt node_1907;
			       node_1907 =
				  (((set_ex_it_116_bglt) CREF(node_1437))->body);
			       node_1 = node_1907;
			       goto set_cto__5_integrate_cto;
			    }
			 }
			 break;
		      case ((long) 17):

			 {	/* Integrate/cto.scm 200 */
			    jump_ex_it_184_bglt node_1441;
			    node_1441 =
			       (jump_ex_it_184_bglt) (node_1);
			    set_cto__5_integrate_cto(
			       (((jump_ex_it_184_bglt) CREF(node_1441))->exit), local_2);
			    {
			       node_bglt node_1912;
			       node_1912 =
				  (((jump_ex_it_184_bglt) CREF(node_1441))->value);
			       node_1 = node_1912;
			       goto set_cto__5_integrate_cto;
			    }
			 }
			 break;
		      case ((long) 18):

			 {	/* Integrate/cto.scm 208 */
			    make_box_202_bglt node_1446;
			    node_1446 =
			       (make_box_202_bglt) (node_1);
			    {
			       node_bglt node_1915;
			       node_1915 =
				  (((make_box_202_bglt) CREF(node_1446))->value);
			       node_1 = node_1915;
			       goto set_cto__5_integrate_cto;
			    }
			 }
			 break;
		      case ((long) 19):

			 {	/* Integrate/cto.scm 215 */
			    box_set__221_bglt node_1450;
			    node_1450 =
			       (box_set__221_bglt) (node_1);
			    {	/* Integrate/cto.scm 216 */
			       node_bglt aux_1918;
			       {	/* Integrate/cto.scm 216 */
				  var_bglt aux_1919;
				  aux_1919 =
				     (((box_set__221_bglt) CREF(node_1450))->var);
				  aux_1918 =
				     (node_bglt) (aux_1919);
			       }
			       set_cto__5_integrate_cto(aux_1918, local_2);
			    }
			    {
			       node_bglt node_1923;
			       node_1923 =
				  (((box_set__221_bglt) CREF(node_1450))->value);
			       node_1 = node_1923;
			       goto set_cto__5_integrate_cto;
			    }
			 }
			 break;
		      case ((long) 20):

			 {	/* Integrate/cto.scm 223 */
			    box_ref_242_bglt node_1455;
			    node_1455 =
			       (box_ref_242_bglt) (node_1);
			    {
			       node_bglt node_1926;
			       {	/* Integrate/cto.scm 224 */
				  var_bglt aux_1927;
				  aux_1927 =
				     (((box_ref_242_bglt) CREF(node_1455))->var);
				  node_1926 =
				     (node_bglt) (aux_1927);
			       }
			       node_1 = node_1926;
			       goto set_cto__5_integrate_cto;
			    }
			 }
			 break;
		      default:
		       case_else1672_1308:
			 if (
			    PROCEDUREP(method1666_1304))
			   {	/* Integrate/cto.scm 27 */
			      return
				 PROCEDURE_ENTRY(method1666_1304) (method1666_1304,
				 (obj_t) (node_1),
				 (obj_t) (local_2), BEOA);
			   }
			 else
			   {	/* Integrate/cto.scm 27 */
			      obj_t fun1665_1300;
			      fun1665_1300 =
				 PROCEDURE_REF(set_cto__env_185_integrate_cto, ((long) 0));
			      return
				 PROCEDURE_ENTRY(fun1665_1300) (fun1665_1300,
				 (obj_t) (node_1),
				 (obj_t) (local_2), BEOA);
			   }
		      }
		 }
	       else
		 {	/* Integrate/cto.scm 27 */
		    goto case_else1672_1308;
		 }
	    }
	 }
      }
   }
}



/* _set-cto!1755 */
obj_t 
_set_cto_1755_109_integrate_cto(obj_t env_1628, obj_t node_1629, obj_t local_1630)
{
   AN_OBJECT;
   {	/* Integrate/cto.scm 27 */
      return
	 set_cto__5_integrate_cto(
	 (node_bglt) (node_1629),
	 (local_bglt) (local_1630));
   }
}



/* set-cto!-default1538 */
obj_t 
set_cto__default1538_228_integrate_cto(node_bglt node_3, local_bglt local_4)
{
   AN_OBJECT;
   {	/* Integrate/cto.scm 14 */
      FAILURE(
	 CNST_TABLE_REF(((long) 0)), string1758_integrate_cto,
	 (obj_t) (node_3));
   }
}



/* _set-cto!-default1538 */
obj_t 
_set_cto__default1538_20_integrate_cto(obj_t env_1631, obj_t node_1632, obj_t local_1633)
{
   AN_OBJECT;
   {	/* Integrate/cto.scm 14 */
      return
	 set_cto__default1538_228_integrate_cto(
	 (node_bglt) (node_1632),
	 (local_bglt) (local_1633));
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_integrate_cto()
{
   AN_OBJECT;
   {	/* Integrate/cto.scm 14 */
      module_initialization_70_tools_trace(((long) 0), "INTEGRATE_CTO");
      module_initialization_70_tools_shape(((long) 0), "INTEGRATE_CTO");
      module_initialization_70_tools_error(((long) 0), "INTEGRATE_CTO");
      module_initialization_70_type_type(((long) 0), "INTEGRATE_CTO");
      module_initialization_70_ast_var(((long) 0), "INTEGRATE_CTO");
      module_initialization_70_ast_node(((long) 0), "INTEGRATE_CTO");
      return
	 module_initialization_70_integrate_info(((long) 0), "INTEGRATE_CTO");
   }
}
