/*===========================================================================*/
/*   (Integrate/definition.scm)                                              */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;

typedef struct svar_iinfo_76
  {
     obj_t f_mark_181;
     obj_t u_mark_209;
     bool_t kaptured__204;
     bool_t celled__113;
  }
             *svar_iinfo_76_bglt;

typedef struct sexit_iinfo_190
  {
     obj_t f_mark_181;
     obj_t u_mark_209;
     bool_t kaptured__204;
     bool_t celled__113;
  }
               *sexit_iinfo_190_bglt;

typedef struct sfun_iinfo_105
  {
     obj_t owner;
     obj_t free;
     obj_t bound;
     obj_t cfrom;
     obj_t cto;
     obj_t k;
     obj_t k__190;
     obj_t u;
     obj_t cn;
     obj_t ct;
     obj_t kont;
     bool_t g__219;
     obj_t l;
     obj_t led;
     obj_t istamp;
     obj_t global;
     obj_t kaptured;
  }
              *sfun_iinfo_105_bglt;


static obj_t method_init_76_integrate_definition();
extern obj_t _verbose__1_engine_param;
extern obj_t integrate_definition__136_integrate_definition(obj_t);
extern obj_t set_kaptured__104_integrate_kaptured(obj_t);
extern obj_t globalize__167_integrate_node(node_bglt, variable_bglt, obj_t);
extern obj_t verbose_tools_speek(obj_t, obj_t);
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t module_initialization_70_integrate_definition(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_speek(long, char *);
extern obj_t module_initialization_70_integrate_info(long, char *);
extern obj_t module_initialization_70_integrate_a(long, char *);
extern obj_t module_initialization_70_integrate_kk(long, char *);
extern obj_t module_initialization_70_integrate_u(long, char *);
extern obj_t module_initialization_70_integrate_ctn(long, char *);
extern obj_t module_initialization_70_integrate_g(long, char *);
extern obj_t module_initialization_70_integrate_kaptured(long, char *);
extern obj_t module_initialization_70_integrate_let_fun_158(long, char *);
extern obj_t module_initialization_70_integrate_node(long, char *);
extern obj_t module_initialization_70_integrate_local__global_163(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___r4_numbers_6_5(long, char *);
extern obj_t local__global_40_integrate_local__global_163(local_bglt);
extern obj_t displace_let_fun__199_integrate_let_fun_158(obj_t);
extern obj_t k___139_integrate_kk(obj_t);
static obj_t imported_modules_init_94_integrate_definition();
static obj_t library_modules_init_112_integrate_definition();
static obj_t _integrate_definition__196_integrate_definition(obj_t, obj_t);
extern obj_t local_ast_var;
extern obj_t shape_tools_shape(obj_t);
extern obj_t u__31_integrate_u();
static bool_t verb_globalization_175_integrate_definition(obj_t);
extern obj_t k__48_integrate_kk(obj_t, global_bglt);
extern obj_t g__63_integrate_g(obj_t);
extern bool_t ___161___r4_numbers_6_5(obj_t, obj_t, obj_t);
extern obj_t cn_ct__54_integrate_ctn(obj_t);
extern obj_t _phi__105_integrate_a;
static obj_t require_initialization_114_integrate_definition = BUNSPEC;
extern obj_t a_integrate_a(global_bglt, node_bglt);
static obj_t *__cnst;

DEFINE_EXPORT_PROCEDURE(integrate_definition__env_137_integrate_definition, _integrate_definition__196_integrate_definition1655, _integrate_definition__196_integrate_definition, 0L, 1);
DEFINE_STRING(string1653_integrate_definition, string1653_integrate_definition1656, "           ", 11);
DEFINE_STRING(string1652_integrate_definition, string1652_integrate_definition1657, " -->", 4);



/* module-initialization */
obj_t 
module_initialization_70_integrate_definition(long checksum_1413, char *from_1414)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_integrate_definition))
	{
	   require_initialization_114_integrate_definition =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_integrate_definition();
	   imported_modules_init_94_integrate_definition();
	   method_init_76_integrate_definition();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_integrate_definition()
{
   AN_OBJECT;
   {	/* Integrate/definition.scm 14 */
      module_initialization_70___object(((long) 0), "INTEGRATE_DEFINITION");
      module_initialization_70___r4_numbers_6_5(((long) 0), "INTEGRATE_DEFINITION");
      return BUNSPEC;
   }
}



/* integrate-definition! */
obj_t 
integrate_definition__136_integrate_definition(obj_t global_1)
{
   AN_OBJECT;
   {	/* Integrate/definition.scm 55 */
      {		/* Integrate/definition.scm 60 */
	 value_bglt fun_884;
	 {	/* Integrate/definition.scm 60 */
	    global_bglt obj_1316;
	    obj_1316 =
	       (global_bglt) (global_1);
	    fun_884 =
	       (((global_bglt) CREF(obj_1316))->value);
	 }
	 {	/* Integrate/definition.scm 60 */
	    obj_t body_885;
	    {	/* Integrate/definition.scm 61 */
	       sfun_bglt obj_1317;
	       obj_1317 =
		  (sfun_bglt) (fun_884);
	       body_885 =
		  (((sfun_bglt) CREF(obj_1317))->body);
	    }
	    {	/* Integrate/definition.scm 61 */
	       obj_t a_886;
	       a_886 =
		  a_integrate_a(
		  (global_bglt) (global_1),
		  (node_bglt) (body_885));
	       {	/* Integrate/definition.scm 62 */

		  {	/* Integrate/definition.scm 63 */
		     obj_t arg1528_887;
		     arg1528_887 =
			k__48_integrate_kk(a_886,
			(global_bglt) (global_1));
		     k___139_integrate_kk(arg1528_887);
		  }
		  u__31_integrate_u();
		  {	/* Integrate/definition.scm 65 */
		     obj_t g_888;
		     {	/* Integrate/definition.scm 65 */
			obj_t arg1557_928;
			arg1557_928 =
			   cn_ct__54_integrate_ctn(a_886);
			g_888 =
			   g__63_integrate_g(arg1557_928);
		     }
		     if (
			NULLP(g_888))
		       {	/* Integrate/definition.scm 71 */
			  obj_t list1530_890;
			  list1530_890 =
			     MAKE_PAIR(global_1, BNIL);
			  return list1530_890;
		       }
		     else
		       {	/* Integrate/definition.scm 69 */
			  verb_globalization_175_integrate_definition(g_888);
			  {
			     obj_t l1516_891;
			     l1516_891 = _phi__105_integrate_a;
			   lname1517_892:
			     if (
				PAIRP(l1516_891))
			       {	/* Integrate/definition.scm 75 */
				  {	/* Integrate/definition.scm 77 */
				     obj_t f_894;
				     f_894 =
					CAR(l1516_891);
				     {	/* Integrate/definition.scm 77 */
					bool_t test1532_895;
					{	/* Integrate/definition.scm 77 */
					   bool_t test1536_901;
					   test1536_901 =
					      is_a__118___object(f_894, local_ast_var);
					   if (test1536_901)
					     {	/* Integrate/definition.scm 78 */
						bool_t test_1445;
						{	/* Integrate/definition.scm 78 */
						   sfun_iinfo_105_bglt obj_1324;
						   {	/* Integrate/definition.scm 78 */
						      value_bglt aux_1446;
						      {		/* Integrate/definition.scm 78 */
							 local_bglt obj_1323;
							 obj_1323 =
							    (local_bglt) (f_894);
							 aux_1446 =
							    (((local_bglt) CREF(obj_1323))->value);
						      }
						      obj_1324 =
							 (sfun_iinfo_105_bglt) (aux_1446);
						   }
						   {
						      obj_t aux_1450;
						      {		/* ./Integrate/iinfo.scm 1053 */
							 object_bglt aux_1451;
							 aux_1451 =
							    (object_bglt) (obj_1324);
							 aux_1450 =
							    OBJECT_WIDENING(aux_1451);
						      }
						      test_1445 =
							 (((sfun_iinfo_105_bglt) CREF(aux_1450))->g__219);
						   }
						}
						if (test_1445)
						  {	/* Integrate/definition.scm 78 */
						     test1532_895 = ((bool_t) 0);
						  }
						else
						  {	/* Integrate/definition.scm 78 */
						     test1532_895 = ((bool_t) 1);
						  }
					     }
					   else
					     {	/* Integrate/definition.scm 77 */
						test1532_895 = ((bool_t) 0);
					     }
					}
					if (test1532_895)
					  {	/* Integrate/definition.scm 79 */
					     value_bglt ifu_897;
					     {	/* Integrate/definition.scm 80 */
						variable_bglt obj_1327;
						{	/* Integrate/definition.scm 80 */
						   obj_t aux_1456;
						   {	/* Integrate/definition.scm 79 */
						      sfun_iinfo_105_bglt obj_1326;
						      {		/* Integrate/definition.scm 79 */
							 value_bglt aux_1457;
							 {	/* Integrate/definition.scm 79 */
							    local_bglt obj_1325;
							    obj_1325 =
							       (local_bglt) (f_894);
							    aux_1457 =
							       (((local_bglt) CREF(obj_1325))->value);
							 }
							 obj_1326 =
							    (sfun_iinfo_105_bglt) (aux_1457);
						      }
						      {
							 obj_t aux_1461;
							 {	/* ./Integrate/iinfo.scm 1079 */
							    object_bglt aux_1462;
							    aux_1462 =
							       (object_bglt) (obj_1326);
							    aux_1461 =
							       OBJECT_WIDENING(aux_1462);
							 }
							 aux_1456 =
							    (((sfun_iinfo_105_bglt) CREF(aux_1461))->l);
						      }
						   }
						   obj_1327 =
						      (variable_bglt) (aux_1456);
						}
						ifu_897 =
						   (((variable_bglt) CREF(obj_1327))->value);
					     }
					     {	/* Integrate/definition.scm 80 */

						{	/* Integrate/definition.scm 83 */
						   obj_t arg1533_898;
						   {	/* ./Ieee/pair-list.scm 5689 */
						      obj_t aux_1468;
						      {		/* Integrate/definition.scm 83 */
							 sfun_iinfo_105_bglt obj_1328;
							 obj_1328 =
							    (sfun_iinfo_105_bglt) (ifu_897);
							 {
							    obj_t aux_1470;
							    {	/* ./Integrate/iinfo.scm 1081 */
							       object_bglt aux_1471;
							       aux_1471 =
								  (object_bglt) (obj_1328);
							       aux_1470 =
								  OBJECT_WIDENING(aux_1471);
							    }
							    aux_1468 =
							       (((sfun_iinfo_105_bglt) CREF(aux_1470))->led);
							 }
						      }
						      arg1533_898 =
							 MAKE_PAIR(f_894, aux_1468);
						   }
						   {	/* Integrate/definition.scm 81 */
						      sfun_iinfo_105_bglt obj_1331;
						      obj_1331 =
							 (sfun_iinfo_105_bglt) (ifu_897);
						      {
							 obj_t aux_1477;
							 {	/* ./Integrate/iinfo.scm 1081 */
							    object_bglt aux_1478;
							    aux_1478 =
							       (object_bglt) (obj_1331);
							    aux_1477 =
							       OBJECT_WIDENING(aux_1478);
							 }
							 ((((sfun_iinfo_105_bglt) CREF(aux_1477))->led) = ((obj_t) arg1533_898), BUNSPEC);
						      }
						   }
						}
					     }
					  }
					else
					  {	/* Integrate/definition.scm 77 */
					     BUNSPEC;
					  }
				     }
				  }
				  {
				     obj_t l1516_1482;
				     l1516_1482 =
					CDR(l1516_891);
				     l1516_891 = l1516_1482;
				     goto lname1517_892;
				  }
			       }
			     else
			       {	/* Integrate/definition.scm 75 */
				  ((bool_t) 1);
			       }
			  }
			  {
			     obj_t l1518_905;
			     l1518_905 = g_888;
			   lname1519_906:
			     if (
				PAIRP(l1518_905))
			       {	/* Integrate/definition.scm 87 */
				  displace_let_fun__199_integrate_let_fun_158(
				     CAR(l1518_905));
				  {
				     obj_t l1518_1488;
				     l1518_1488 =
					CDR(l1518_905);
				     l1518_905 = l1518_1488;
				     goto lname1519_906;
				  }
			       }
			     else
			       {	/* Integrate/definition.scm 87 */
				  ((bool_t) 1);
			       }
			  }
			  displace_let_fun__199_integrate_let_fun_158(global_1);
			  set_kaptured__104_integrate_kaptured(g_888);
			  {	/* Integrate/definition.scm 96 */
			     obj_t new_g_67_910;
			     if (
				NULLP(g_888))
			       {	/* Integrate/definition.scm 96 */
				  new_g_67_910 = BNIL;
			       }
			     else
			       {	/* Integrate/definition.scm 96 */
				  obj_t head1522_914;
				  {	/* Integrate/definition.scm 96 */
				     obj_t arg1553_925;
				     {	/* Integrate/definition.scm 96 */
					local_bglt aux_1494;
					{	/* Integrate/definition.scm 96 */
					   obj_t aux_1495;
					   aux_1495 =
					      CAR(g_888);
					   aux_1494 =
					      (local_bglt) (aux_1495);
					}
					arg1553_925 =
					   local__global_40_integrate_local__global_163(aux_1494);
				     }
				     head1522_914 =
					MAKE_PAIR(arg1553_925, BNIL);
				  }
				  {
				     obj_t l1520_915;
				     obj_t tail1523_916;
				     l1520_915 =
					CDR(g_888);
				     tail1523_916 = head1522_914;
				   lname1521_917:
				     if (
					NULLP(l1520_915))
				       {	/* Integrate/definition.scm 96 */
					  new_g_67_910 = head1522_914;
				       }
				     else
				       {	/* Integrate/definition.scm 96 */
					  obj_t newtail1524_920;
					  {	/* Integrate/definition.scm 96 */
					     obj_t arg1550_922;
					     {	/* Integrate/definition.scm 96 */
						local_bglt aux_1502;
						{	/* Integrate/definition.scm 96 */
						   obj_t aux_1503;
						   aux_1503 =
						      CAR(l1520_915);
						   aux_1502 =
						      (local_bglt) (aux_1503);
						}
						arg1550_922 =
						   local__global_40_integrate_local__global_163(aux_1502);
					     }
					     newtail1524_920 =
						MAKE_PAIR(arg1550_922, BNIL);
					  }
					  SET_CDR(tail1523_916, newtail1524_920);
					  {
					     obj_t tail1523_1511;
					     obj_t l1520_1509;
					     l1520_1509 =
						CDR(l1520_915);
					     tail1523_1511 = newtail1524_920;
					     tail1523_916 = tail1523_1511;
					     l1520_915 = l1520_1509;
					     goto lname1521_917;
					  }
				       }
				  }
			       }
			     {	/* Integrate/definition.scm 97 */
				obj_t arg1545_911;
				arg1545_911 =
				   globalize__167_integrate_node(
				   (node_bglt) (body_885),
				   (variable_bglt) (global_1), BNIL);
				{	/* Integrate/definition.scm 97 */
				   sfun_bglt obj_1349;
				   obj_1349 =
				      (sfun_bglt) (fun_884);
				   ((((sfun_bglt) CREF(obj_1349))->body) = ((obj_t) arg1545_911), BUNSPEC);
				}
			     }
			     return
				MAKE_PAIR(global_1, new_g_67_910);
			  }
		       }
		  }
	       }
	    }
	 }
      }
   }
}



/* _integrate-definition! */
obj_t 
_integrate_definition__196_integrate_definition(obj_t env_1411, obj_t global_1412)
{
   AN_OBJECT;
   {	/* Integrate/definition.scm 55 */
      return
	 integrate_definition__136_integrate_definition(global_1412);
   }
}



/* verb-globalization */
bool_t 
verb_globalization_175_integrate_definition(obj_t g_2)
{
   AN_OBJECT;
   {	/* Integrate/definition.scm 104 */
      {
	 obj_t l1525_929;
	 l1525_929 = g_2;
       lname1526_930:
	 if (
	    PAIRP(l1525_929))
	   {	/* Integrate/definition.scm 105 */
	      {		/* Integrate/definition.scm 106 */
		 obj_t local_932;
		 local_932 =
		    CAR(l1525_929);
		 {	/* Integrate/definition.scm 106 */
		    bool_t test1559_934;
		    test1559_934 =
		       ___161___r4_numbers_6_5(
		       BINT(((long) 3)), _verbose__1_engine_param, BNIL);
		    if (test1559_934)
		      {		/* Integrate/definition.scm 106 */
			 obj_t arg1561_936;
			 arg1561_936 =
			    shape_tools_shape(local_932);
			 {	/* Integrate/definition.scm 106 */
			    obj_t list1563_938;
			    {	/* Integrate/definition.scm 106 */
			       obj_t arg1564_939;
			       {	/* Integrate/definition.scm 106 */
				  obj_t arg1565_940;
				  {	/* Integrate/definition.scm 106 */
				     obj_t arg1566_941;
				     {	/* Integrate/definition.scm 106 */
					obj_t aux_1527;
					aux_1527 =
					   BCHAR(((unsigned char) '\n'));
					arg1566_941 =
					   MAKE_PAIR(aux_1527, BNIL);
				     }
				     arg1565_940 =
					MAKE_PAIR(string1652_integrate_definition, arg1566_941);
				  }
				  arg1564_939 =
				     MAKE_PAIR(arg1561_936, arg1565_940);
			       }
			       list1563_938 =
				  MAKE_PAIR(string1653_integrate_definition, arg1564_939);
			    }
			    verbose_tools_speek(
			       BINT(((long) 3)), list1563_938);
			 }
		      }
		    else
		      {		/* Integrate/definition.scm 106 */
			 BUNSPEC;
		      }
		 }
	      }
	      {
		 obj_t l1525_1535;
		 l1525_1535 =
		    CDR(l1525_929);
		 l1525_929 = l1525_1535;
		 goto lname1526_930;
	      }
	   }
	 else
	   {	/* Integrate/definition.scm 105 */
	      return ((bool_t) 1);
	   }
      }
   }
}



/* method-init */
obj_t 
method_init_76_integrate_definition()
{
   AN_OBJECT;
   {	/* Integrate/definition.scm 14 */
      return BUNSPEC;
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_integrate_definition()
{
   AN_OBJECT;
   {	/* Integrate/definition.scm 14 */
      module_initialization_70_tools_trace(((long) 0), "INTEGRATE_DEFINITION");
      module_initialization_70_engine_param(((long) 0), "INTEGRATE_DEFINITION");
      module_initialization_70_type_type(((long) 0), "INTEGRATE_DEFINITION");
      module_initialization_70_ast_var(((long) 0), "INTEGRATE_DEFINITION");
      module_initialization_70_ast_node(((long) 0), "INTEGRATE_DEFINITION");
      module_initialization_70_tools_shape(((long) 0), "INTEGRATE_DEFINITION");
      module_initialization_70_tools_speek(((long) 0), "INTEGRATE_DEFINITION");
      module_initialization_70_integrate_info(((long) 0), "INTEGRATE_DEFINITION");
      module_initialization_70_integrate_a(((long) 0), "INTEGRATE_DEFINITION");
      module_initialization_70_integrate_kk(((long) 0), "INTEGRATE_DEFINITION");
      module_initialization_70_integrate_u(((long) 0), "INTEGRATE_DEFINITION");
      module_initialization_70_integrate_ctn(((long) 0), "INTEGRATE_DEFINITION");
      module_initialization_70_integrate_g(((long) 0), "INTEGRATE_DEFINITION");
      module_initialization_70_integrate_kaptured(((long) 0), "INTEGRATE_DEFINITION");
      module_initialization_70_integrate_let_fun_158(((long) 0), "INTEGRATE_DEFINITION");
      module_initialization_70_integrate_node(((long) 0), "INTEGRATE_DEFINITION");
      return
	 module_initialization_70_integrate_local__global_163(((long) 0), "INTEGRATE_DEFINITION");
   }
}
