/*===========================================================================*/
/*   (Integrate/free.scm)                                                    */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;

typedef struct svar_iinfo_76
  {
     obj_t f_mark_181;
     obj_t u_mark_209;
     bool_t kaptured__204;
     bool_t celled__113;
  }
             *svar_iinfo_76_bglt;

typedef struct sexit_iinfo_190
  {
     obj_t f_mark_181;
     obj_t u_mark_209;
     bool_t kaptured__204;
     bool_t celled__113;
  }
               *sexit_iinfo_190_bglt;

typedef struct sfun_iinfo_105
  {
     obj_t owner;
     obj_t free;
     obj_t bound;
     obj_t cfrom;
     obj_t cto;
     obj_t k;
     obj_t k__190;
     obj_t u;
     obj_t cn;
     obj_t ct;
     obj_t kont;
     bool_t g__219;
     obj_t l;
     obj_t led;
     obj_t istamp;
     obj_t global;
     obj_t kaptured;
  }
              *sfun_iinfo_105_bglt;


static obj_t internal_get_free_vars__185_integrate_free(node_bglt, local_bglt);
static obj_t method_init_76_integrate_free();
extern obj_t make_box_202_ast_node;
extern obj_t funcall_ast_node;
extern long add_inlined_method__244___object(obj_t, obj_t, long);
extern obj_t fail_ast_node;
static obj_t _get_free_vars1803_247_integrate_free(obj_t, obj_t, obj_t);
extern obj_t box_ref_242_ast_node;
static obj_t _node_free_default1546_115_integrate_free(obj_t, obj_t, obj_t);
extern obj_t sequence_ast_node;
extern obj_t let_var_6_ast_node;
extern obj_t var_ast_node;
static long _round__57_integrate_free;
extern obj_t closure_ast_node;
extern obj_t global_ast_var;
static obj_t node_free_158_integrate_free(node_bglt, obj_t);
extern obj_t pragma_ast_node;
static obj_t _integrator__235_integrate_free = BUNSPEC;
extern obj_t set_ex_it_116_ast_node;
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t module_initialization_70_integrate_free(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_speek(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_local(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_ast_sexp(long, char *);
extern obj_t module_initialization_70_ast_glo_def_117(long, char *);
extern obj_t module_initialization_70_integrate_info(long, char *);
extern obj_t module_initialization_70_integrate_node(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70___object(long, char *);
static obj_t mark_variable__104_integrate_free(local_bglt);
extern obj_t sexit_iinfo_190_integrate_info;
extern obj_t svar_iinfo_76_integrate_info;
extern obj_t let_fun_218_ast_node;
static obj_t imported_modules_init_94_integrate_free();
extern obj_t app_ly_162_ast_node;
extern obj_t add_generic__110___object(obj_t, obj_t);
static obj_t node_free_default1546_176_integrate_free(node_bglt, obj_t);
extern obj_t app_ast_node;
static obj_t library_modules_init_112_integrate_free();
static obj_t _node_free1805_184_integrate_free(obj_t, obj_t, obj_t);
extern obj_t cast_ast_node;
static obj_t toplevel_init_63_integrate_free();
extern obj_t jump_ex_it_184_ast_node;
extern obj_t setq_ast_node;
extern obj_t box_set__221_ast_node;
static obj_t node_free__199_integrate_free(obj_t, obj_t);
extern obj_t get_free_vars_244_integrate_free(node_bglt, local_bglt);
static obj_t free_variable__181_integrate_free(obj_t);
extern obj_t shape_tools_shape(obj_t);
extern obj_t internal_error_43_tools_error(obj_t, obj_t, obj_t);
static obj_t _free_from1804_251_integrate_free(obj_t, obj_t, obj_t);
extern obj_t _classes__134___object;
extern obj_t select_ast_node;
extern obj_t free_from_222_integrate_free(obj_t, local_bglt);
static obj_t bind_variable__14_integrate_free(local_bglt, local_bglt);
static obj_t require_initialization_114_integrate_free = BUNSPEC;
extern obj_t conditional_ast_node;
static obj_t *__cnst;

DEFINE_STATIC_PROCEDURE(node_free_default1546_env_239_integrate_free, _node_free_default1546_115_integrate_free1811, _node_free_default1546_115_integrate_free, 0L, 2);
DEFINE_STATIC_GENERIC(node_free_env_48_integrate_free, _node_free1805_184_integrate_free1812, _node_free1805_184_integrate_free, 0L, 2);
DEFINE_EXPORT_PROCEDURE(get_free_vars_env_212_integrate_free, _get_free_vars1803_247_integrate_free1813, _get_free_vars1803_247_integrate_free, 0L, 2);
DEFINE_EXPORT_PROCEDURE(free_from_env_97_integrate_free, _free_from1804_251_integrate_free1814, _free_from1804_251_integrate_free, 0L, 2);
DEFINE_STRING(string1809_integrate_free, string1809_integrate_free1815, "Unexepected `closure' node", 26);
DEFINE_STRING(string1808_integrate_free, string1808_integrate_free1816, "node-free", 9);
DEFINE_STRING(string1807_integrate_free, string1807_integrate_free1817, "Unknown variable type", 21);
DEFINE_STRING(string1806_integrate_free, string1806_integrate_free1818, "free-variable?", 14);



/* module-initialization */
obj_t 
module_initialization_70_integrate_free(long checksum_1753, char *from_1754)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_integrate_free))
	{
	   require_initialization_114_integrate_free =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_integrate_free();
	   imported_modules_init_94_integrate_free();
	   method_init_76_integrate_free();
	   toplevel_init_63_integrate_free();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_integrate_free()
{
   AN_OBJECT;
   {	/* Integrate/free.scm 14 */
      module_initialization_70___object(((long) 0), "INTEGRATE_FREE");
      return BUNSPEC;
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_integrate_free()
{
   AN_OBJECT;
   {	/* Integrate/free.scm 14 */
      _round__57_integrate_free = ((long) 0);
      _integrator__235_integrate_free = BUNSPEC;
      return BUNSPEC;
   }
}



/* mark-variable! */
obj_t 
mark_variable__104_integrate_free(local_bglt local_1)
{
   AN_OBJECT;
   {	/* Integrate/free.scm 40 */
      {		/* Integrate/free.scm 41 */
	 value_bglt info_936;
	 info_936 =
	    (((local_bglt) CREF(local_1))->value);
	 {	/* Integrate/free.scm 43 */
	    bool_t test1589_937;
	    test1589_937 =
	       is_a__118___object(
	       (obj_t) (info_936), svar_iinfo_76_integrate_info);
	    if (test1589_937)
	      {		/* Integrate/free.scm 43 */
		 {	/* Integrate/free.scm 44 */
		    svar_iinfo_76_bglt obj_1534;
		    obj_t val1438_1535;
		    obj_1534 =
		       (svar_iinfo_76_bglt) (info_936);
		    val1438_1535 =
		       BINT(_round__57_integrate_free);
		    {
		       obj_t aux_1769;
		       {	/* ./Integrate/iinfo.scm 1343 */
			  object_bglt aux_1770;
			  aux_1770 =
			     (object_bglt) (obj_1534);
			  aux_1769 =
			     OBJECT_WIDENING(aux_1770);
		       }
		       return
			  ((((svar_iinfo_76_bglt) CREF(aux_1769))->f_mark_181) = ((obj_t) val1438_1535), BUNSPEC);
		    }
		 }
	      }
	    else
	      {		/* Integrate/free.scm 45 */
		 bool_t test1590_938;
		 test1590_938 =
		    is_a__118___object(
		    (obj_t) (info_936), sexit_iinfo_190_integrate_info);
		 if (test1590_938)
		   {	/* Integrate/free.scm 45 */
		      {		/* Integrate/free.scm 46 */
			 sexit_iinfo_190_bglt obj_1537;
			 obj_t val1453_1538;
			 obj_1537 =
			    (sexit_iinfo_190_bglt) (info_936);
			 val1453_1538 =
			    BINT(_round__57_integrate_free);
			 {
			    obj_t aux_1779;
			    {	/* ./Integrate/iinfo.scm 1353 */
			       object_bglt aux_1780;
			       aux_1780 =
				  (object_bglt) (obj_1537);
			       aux_1779 =
				  OBJECT_WIDENING(aux_1780);
			    }
			    return
			       ((((sexit_iinfo_190_bglt) CREF(aux_1779))->f_mark_181) = ((obj_t) val1453_1538), BUNSPEC);
			 }
		      }
		   }
		 else
		   {	/* Integrate/free.scm 45 */
		      return BFALSE;
		   }
	      }
	 }
      }
   }
}



/* bind-variable! */
obj_t 
bind_variable__14_integrate_free(local_bglt local_2, local_bglt integrator_3)
{
   AN_OBJECT;
   {	/* Integrate/free.scm 51 */
      {		/* Integrate/free.scm 52 */
	 value_bglt finfo_939;
	 finfo_939 =
	    (((local_bglt) CREF(integrator_3))->value);
	 {	/* Integrate/free.scm 53 */
	    obj_t arg1591_940;
	    {	/* ./Ieee/pair-list.scm 5689 */
	       obj_t aux_1787;
	       obj_t aux_1785;
	       {	/* Integrate/free.scm 53 */
		  sfun_iinfo_105_bglt obj_1540;
		  obj_1540 =
		     (sfun_iinfo_105_bglt) (finfo_939);
		  {
		     obj_t aux_1789;
		     {	/* ./Integrate/iinfo.scm 1367 */
			object_bglt aux_1790;
			aux_1790 =
			   (object_bglt) (obj_1540);
			aux_1789 =
			   OBJECT_WIDENING(aux_1790);
		     }
		     aux_1787 =
			(((sfun_iinfo_105_bglt) CREF(aux_1789))->bound);
		  }
	       }
	       aux_1785 =
		  (obj_t) (local_2);
	       arg1591_940 =
		  MAKE_PAIR(aux_1785, aux_1787);
	    }
	    {	/* Integrate/free.scm 53 */
	       sfun_iinfo_105_bglt obj_1543;
	       obj_1543 =
		  (sfun_iinfo_105_bglt) (finfo_939);
	       {
		  obj_t aux_1796;
		  {	/* ./Integrate/iinfo.scm 1367 */
		     object_bglt aux_1797;
		     aux_1797 =
			(object_bglt) (obj_1543);
		     aux_1796 =
			OBJECT_WIDENING(aux_1797);
		  }
		  ((((sfun_iinfo_105_bglt) CREF(aux_1796))->bound) = ((obj_t) arg1591_940), BUNSPEC);
	       }
	    }
	 }
	 return
	    mark_variable__104_integrate_free(local_2);
      }
   }
}



/* free-variable? */
obj_t 
free_variable__181_integrate_free(obj_t local_4)
{
   AN_OBJECT;
   {	/* Integrate/free.scm 59 */
      {		/* Integrate/free.scm 60 */
	 value_bglt info_942;
	 {	/* Integrate/free.scm 60 */
	    local_bglt obj_1545;
	    obj_1545 =
	       (local_bglt) (local_4);
	    info_942 =
	       (((local_bglt) CREF(obj_1545))->value);
	 }
	 {	/* Integrate/free.scm 62 */
	    bool_t test1593_943;
	    test1593_943 =
	       is_a__118___object(
	       (obj_t) (info_942), svar_iinfo_76_integrate_info);
	    if (test1593_943)
	      {		/* Integrate/free.scm 62 */
		 {	/* Integrate/free.scm 63 */
		    bool_t test1594_944;
		    {	/* Integrate/free.scm 63 */
		       obj_t arg1595_945;
		       {	/* Integrate/free.scm 63 */
			  svar_iinfo_76_bglt obj_1547;
			  obj_1547 =
			     (svar_iinfo_76_bglt) (info_942);
			  {
			     obj_t aux_1808;
			     {	/* ./Integrate/iinfo.scm 1343 */
				object_bglt aux_1809;
				aux_1809 =
				   (object_bglt) (obj_1547);
				aux_1808 =
				   OBJECT_WIDENING(aux_1809);
			     }
			     arg1595_945 =
				(((svar_iinfo_76_bglt) CREF(aux_1808))->f_mark_181);
			  }
		       }
		       {	/* Integrate/free.scm 63 */
			  obj_t obj2_1549;
			  obj2_1549 =
			     BINT(_round__57_integrate_free);
			  test1594_944 =
			     (arg1595_945 == obj2_1549);
		       }
		    }
		    if (test1594_944)
		      {		/* Integrate/free.scm 63 */
			 return BFALSE;
		      }
		    else
		      {		/* Integrate/free.scm 63 */
			 return BTRUE;
		      }
		 }
	      }
	    else
	      {		/* Integrate/free.scm 64 */
		 bool_t test1596_946;
		 test1596_946 =
		    is_a__118___object(
		    (obj_t) (info_942), sexit_iinfo_190_integrate_info);
		 if (test1596_946)
		   {	/* Integrate/free.scm 64 */
		      {		/* Integrate/free.scm 65 */
			 bool_t test1597_947;
			 {	/* Integrate/free.scm 65 */
			    obj_t arg1598_948;
			    {	/* Integrate/free.scm 65 */
			       sexit_iinfo_190_bglt obj_1551;
			       obj_1551 =
				  (sexit_iinfo_190_bglt) (info_942);
			       {
				  obj_t aux_1820;
				  {	/* ./Integrate/iinfo.scm 1353 */
				     object_bglt aux_1821;
				     aux_1821 =
					(object_bglt) (obj_1551);
				     aux_1820 =
					OBJECT_WIDENING(aux_1821);
				  }
				  arg1598_948 =
				     (((sexit_iinfo_190_bglt) CREF(aux_1820))->f_mark_181);
			       }
			    }
			    {	/* Integrate/free.scm 65 */
			       obj_t obj2_1553;
			       obj2_1553 =
				  BINT(_round__57_integrate_free);
			       test1597_947 =
				  (arg1598_948 == obj2_1553);
			    }
			 }
			 if (test1597_947)
			   {	/* Integrate/free.scm 65 */
			      return BFALSE;
			   }
			 else
			   {	/* Integrate/free.scm 65 */
			      return BTRUE;
			   }
		      }
		   }
		 else
		   {	/* Integrate/free.scm 64 */
		      {		/* Integrate/free.scm 67 */
			 obj_t arg1601_951;
			 {	/* Integrate/free.scm 69 */
			    obj_t arg1602_952;
			    arg1602_952 =
			       shape_tools_shape(local_4);
			    arg1601_951 =
			       MAKE_PAIR(local_4, arg1602_952);
			 }
			 FAILURE(string1806_integrate_free, string1807_integrate_free, arg1601_951);
		      }
		   }
	      }
	 }
      }
   }
}



/* get-free-vars */
obj_t 
get_free_vars_244_integrate_free(node_bglt node_5, local_bglt integrator_6)
{
   AN_OBJECT;
   {	/* Integrate/free.scm 77 */
      {		/* Integrate/free.scm 80 */
	 obj_t free_953;
	 {	/* Integrate/free.scm 80 */
	    sfun_iinfo_105_bglt obj_1560;
	    {	/* Integrate/free.scm 80 */
	       value_bglt aux_1831;
	       aux_1831 =
		  (((local_bglt) CREF(integrator_6))->value);
	       obj_1560 =
		  (sfun_iinfo_105_bglt) (aux_1831);
	    }
	    {
	       obj_t aux_1834;
	       {	/* ./Integrate/iinfo.scm 1365 */
		  object_bglt aux_1835;
		  aux_1835 =
		     (object_bglt) (obj_1560);
		  aux_1834 =
		     OBJECT_WIDENING(aux_1835);
	       }
	       free_953 =
		  (((sfun_iinfo_105_bglt) CREF(aux_1834))->free);
	    }
	 }
	 {	/* Integrate/free.scm 81 */
	    bool_t test_1839;
	    if (
	       NULLP(free_953))
	      {		/* Integrate/free.scm 81 */
		 test_1839 = ((bool_t) 1)
		    ;
	      }
	    else
	      {		/* Integrate/free.scm 81 */
		 test_1839 =
		    PAIRP(free_953)
		    ;
	      }
	    if (test_1839)
	      {		/* Integrate/free.scm 81 */
		 return free_953;
	      }
	    else
	      {		/* Integrate/free.scm 83 */
		 obj_t free_955;
		 free_955 =
		    internal_get_free_vars__185_integrate_free(node_5, integrator_6);
		 {	/* Integrate/free.scm 84 */
		    sfun_iinfo_105_bglt obj_1564;
		    {	/* Integrate/free.scm 84 */
		       value_bglt aux_1844;
		       aux_1844 =
			  (((local_bglt) CREF(integrator_6))->value);
		       obj_1564 =
			  (sfun_iinfo_105_bglt) (aux_1844);
		    }
		    {
		       obj_t aux_1847;
		       {	/* ./Integrate/iinfo.scm 1365 */
			  object_bglt aux_1848;
			  aux_1848 =
			     (object_bglt) (obj_1564);
			  aux_1847 =
			     OBJECT_WIDENING(aux_1848);
		       }
		       ((((sfun_iinfo_105_bglt) CREF(aux_1847))->free) = ((obj_t) free_955), BUNSPEC);
		    }
		 }
		 return free_955;
	      }
	 }
      }
   }
}



/* _get-free-vars1803 */
obj_t 
_get_free_vars1803_247_integrate_free(obj_t env_1741, obj_t node_1742, obj_t integrator_1743)
{
   AN_OBJECT;
   {	/* Integrate/free.scm 77 */
      return
	 get_free_vars_244_integrate_free(
	 (node_bglt) (node_1742),
	 (local_bglt) (integrator_1743));
   }
}



/* internal-get-free-vars! */
obj_t 
internal_get_free_vars__185_integrate_free(node_bglt node_7, local_bglt integrator_8)
{
   AN_OBJECT;
   {	/* Integrate/free.scm 98 */
      {		/* Integrate/free.scm 99 */
	 long z1_1566;
	 z1_1566 = _round__57_integrate_free;
	 _round__57_integrate_free =
	    (z1_1566 + ((long) 1));
      }
      _integrator__235_integrate_free =
	 (obj_t) (integrator_8);
      {
	 obj_t l1516_959;
	 {	/* Integrate/free.scm 103 */
	    sfun_bglt obj_1569;
	    {	/* Integrate/free.scm 103 */
	       value_bglt aux_1866;
	       aux_1866 =
		  (((local_bglt) CREF(integrator_8))->value);
	       obj_1569 =
		  (sfun_bglt) (aux_1866);
	    }
	    l1516_959 =
	       (((sfun_bglt) CREF(obj_1569))->args);
	 }
       lname1517_960:
	 if (
	    PAIRP(l1516_959))
	   {	/* Integrate/free.scm 102 */
	      {		/* Integrate/free.scm 102 */
		 local_bglt aux_1859;
		 {	/* Integrate/free.scm 102 */
		    obj_t aux_1860;
		    aux_1860 =
		       CAR(l1516_959);
		    aux_1859 =
		       (local_bglt) (aux_1860);
		 }
		 bind_variable__14_integrate_free(aux_1859, integrator_8);
	      }
	      {
		 obj_t l1516_1864;
		 l1516_1864 =
		    CDR(l1516_959);
		 l1516_959 = l1516_1864;
		 goto lname1517_960;
	      }
	   }
	 else
	   {	/* Integrate/free.scm 102 */
	      ((bool_t) 1);
	   }
      }
      return
	 node_free_158_integrate_free(node_7, BNIL);
   }
}



/* node-free* */
obj_t 
node_free__199_integrate_free(obj_t node__221_51, obj_t free_52)
{
   AN_OBJECT;
   {	/* Integrate/free.scm 277 */
      {
	 obj_t node__221_966;
	 obj_t free_967;
	 node__221_966 = node__221_51;
	 free_967 = free_52;
       loop_968:
	 if (
	    NULLP(node__221_966))
	   {	/* Integrate/free.scm 280 */
	      return free_967;
	   }
	 else
	   {	/* Integrate/free.scm 282 */
	      obj_t arg1612_970;
	      obj_t arg1613_971;
	      arg1612_970 =
		 CDR(node__221_966);
	      {		/* Integrate/free.scm 283 */
		 node_bglt aux_1874;
		 {	/* Integrate/free.scm 283 */
		    obj_t aux_1875;
		    aux_1875 =
		       CAR(node__221_966);
		    aux_1874 =
		       (node_bglt) (aux_1875);
		 }
		 arg1613_971 =
		    node_free_158_integrate_free(aux_1874, free_967);
	      }
	      {
		 obj_t free_1880;
		 obj_t node__221_1879;
		 node__221_1879 = arg1612_970;
		 free_1880 = arg1613_971;
		 free_967 = free_1880;
		 node__221_966 = node__221_1879;
		 goto loop_968;
	      }
	   }
      }
   }
}



/* free-from */
obj_t 
free_from_222_integrate_free(obj_t sets_53, local_bglt integrator_54)
{
   AN_OBJECT;
   {	/* Integrate/free.scm 288 */
      {		/* Integrate/free.scm 289 */
	 long z1_1576;
	 z1_1576 = _round__57_integrate_free;
	 _round__57_integrate_free =
	    (z1_1576 + ((long) 1));
      }
      {
	 obj_t l1538_974;
	 {	/* Integrate/free.scm 298 */
	    sfun_iinfo_105_bglt obj_1579;
	    {	/* Integrate/free.scm 298 */
	       value_bglt aux_1891;
	       aux_1891 =
		  (((local_bglt) CREF(integrator_54))->value);
	       obj_1579 =
		  (sfun_iinfo_105_bglt) (aux_1891);
	    }
	    {
	       obj_t aux_1894;
	       {	/* ./Integrate/iinfo.scm 1367 */
		  object_bglt aux_1895;
		  aux_1895 =
		     (object_bglt) (obj_1579);
		  aux_1894 =
		     OBJECT_WIDENING(aux_1895);
	       }
	       l1538_974 =
		  (((sfun_iinfo_105_bglt) CREF(aux_1894))->bound);
	    }
	 }
       lname1539_975:
	 if (
	    PAIRP(l1538_974))
	   {	/* Integrate/free.scm 298 */
	      {		/* Integrate/free.scm 298 */
		 local_bglt aux_1884;
		 {	/* Integrate/free.scm 298 */
		    obj_t aux_1885;
		    aux_1885 =
		       CAR(l1538_974);
		    aux_1884 =
		       (local_bglt) (aux_1885);
		 }
		 mark_variable__104_integrate_free(aux_1884);
	      }
	      {
		 obj_t l1538_1889;
		 l1538_1889 =
		    CDR(l1538_974);
		 l1538_974 = l1538_1889;
		 goto lname1539_975;
	      }
	   }
	 else
	   {	/* Integrate/free.scm 298 */
	      ((bool_t) 1);
	   }
      }
      if (
	 NULLP(sets_53))
	{	/* Integrate/free.scm 300 */
	   return BNIL;
	}
      else
	{	/* Integrate/free.scm 300 */
	   obj_t head1542_982;
	   head1542_982 =
	      MAKE_PAIR(BNIL, BNIL);
	   {
	      obj_t l1540_983;
	      obj_t tail1543_984;
	      l1540_983 = sets_53;
	      tail1543_984 = head1542_982;
	    lname1541_985:
	      if (
		 NULLP(l1540_983))
		{	/* Integrate/free.scm 300 */
		   return
		      CDR(head1542_982);
		}
	      else
		{	/* Integrate/free.scm 301 */
		   obj_t newtail1544_987;
		   {	/* Integrate/free.scm 301 */
		      obj_t arg1622_989;
		      {
			 obj_t set_992;
			 obj_t res_993;
			 set_992 =
			    CAR(l1540_983);
			 res_993 = BNIL;
		       loop_994:
			 if (
			    NULLP(set_992))
			   {	/* Integrate/free.scm 304 */
			      arg1622_989 = res_993;
			   }
			 else
			   {	/* Integrate/free.scm 306 */
			      bool_t test1625_996;
			      {		/* Integrate/free.scm 306 */
				 obj_t aux_1907;
				 aux_1907 =
				    free_variable__181_integrate_free(
				    CAR(set_992));
				 test1625_996 =
				    CBOOL(aux_1907);
			      }
			      if (test1625_996)
				{	/* Integrate/free.scm 306 */
				   {	/* Integrate/free.scm 307 */
				      obj_t arg1626_997;
				      obj_t arg1627_998;
				      arg1626_997 =
					 CDR(set_992);
				      {		/* ./Ieee/pair-list.scm 5689 */
					 obj_t aux_1913;
					 aux_1913 =
					    CAR(set_992);
					 arg1627_998 =
					    MAKE_PAIR(aux_1913, res_993);
				      }
				      {
					 obj_t res_1917;
					 obj_t set_1916;
					 set_1916 = arg1626_997;
					 res_1917 = arg1627_998;
					 res_993 = res_1917;
					 set_992 = set_1916;
					 goto loop_994;
				      }
				   }
				}
			      else
				{	/* Integrate/free.scm 306 */
				   {
				      obj_t set_1918;
				      set_1918 =
					 CDR(set_992);
				      set_992 = set_1918;
				      goto loop_994;
				   }
				}
			   }
		      }
		      newtail1544_987 =
			 MAKE_PAIR(arg1622_989, BNIL);
		   }
		   SET_CDR(tail1543_984, newtail1544_987);
		   {
		      obj_t tail1543_1925;
		      obj_t l1540_1923;
		      l1540_1923 =
			 CDR(l1540_983);
		      tail1543_1925 = newtail1544_987;
		      tail1543_984 = tail1543_1925;
		      l1540_983 = l1540_1923;
		      goto lname1541_985;
		   }
		}
	   }
	}
   }
}



/* _free-from1804 */
obj_t 
_free_from1804_251_integrate_free(obj_t env_1744, obj_t sets_1745, obj_t integrator_1746)
{
   AN_OBJECT;
   {	/* Integrate/free.scm 288 */
      return
	 free_from_222_integrate_free(sets_1745,
	 (local_bglt) (integrator_1746));
   }
}



/* method-init */
obj_t 
method_init_76_integrate_free()
{
   AN_OBJECT;
   {	/* Integrate/free.scm 14 */
      add_generic__110___object(node_free_env_48_integrate_free, node_free_default1546_env_239_integrate_free);
      add_inlined_method__244___object(node_free_env_48_integrate_free, var_ast_node, ((long) 0));
      add_inlined_method__244___object(node_free_env_48_integrate_free, closure_ast_node, ((long) 1));
      add_inlined_method__244___object(node_free_env_48_integrate_free, sequence_ast_node, ((long) 2));
      add_inlined_method__244___object(node_free_env_48_integrate_free, app_ast_node, ((long) 3));
      add_inlined_method__244___object(node_free_env_48_integrate_free, app_ly_162_ast_node, ((long) 4));
      add_inlined_method__244___object(node_free_env_48_integrate_free, funcall_ast_node, ((long) 5));
      add_inlined_method__244___object(node_free_env_48_integrate_free, pragma_ast_node, ((long) 6));
      add_inlined_method__244___object(node_free_env_48_integrate_free, cast_ast_node, ((long) 7));
      add_inlined_method__244___object(node_free_env_48_integrate_free, setq_ast_node, ((long) 8));
      add_inlined_method__244___object(node_free_env_48_integrate_free, conditional_ast_node, ((long) 9));
      add_inlined_method__244___object(node_free_env_48_integrate_free, fail_ast_node, ((long) 10));
      add_inlined_method__244___object(node_free_env_48_integrate_free, select_ast_node, ((long) 11));
      add_inlined_method__244___object(node_free_env_48_integrate_free, let_fun_218_ast_node, ((long) 12));
      add_inlined_method__244___object(node_free_env_48_integrate_free, let_var_6_ast_node, ((long) 13));
      add_inlined_method__244___object(node_free_env_48_integrate_free, set_ex_it_116_ast_node, ((long) 14));
      add_inlined_method__244___object(node_free_env_48_integrate_free, jump_ex_it_184_ast_node, ((long) 15));
      add_inlined_method__244___object(node_free_env_48_integrate_free, make_box_202_ast_node, ((long) 16));
      add_inlined_method__244___object(node_free_env_48_integrate_free, box_ref_242_ast_node, ((long) 17));
      {		/* Integrate/free.scm 14 */
	 long aux_1947;
	 aux_1947 =
	    add_inlined_method__244___object(node_free_env_48_integrate_free, box_set__221_ast_node, ((long) 18));
	 return
	    BINT(aux_1947);
      }
   }
}



/* node-free */
obj_t 
node_free_158_integrate_free(node_bglt node_9, obj_t free_10)
{
   AN_OBJECT;
   {	/* Integrate/free.scm 110 */
    node_free_158_integrate_free:
      {
	 obj_t method1714_1378;
	 obj_t class1719_1379;
	 {	/* Integrate/free.scm 110 */
	    obj_t arg1722_1376;
	    obj_t arg1723_1377;
	    {	/* Integrate/free.scm 110 */
	       object_bglt obj_1656;
	       obj_1656 =
		  (object_bglt) (node_9);
	       {	/* ./Llib/object.scm 2926 */
		  obj_t pre_method_105_1657;
		  pre_method_105_1657 =
		     PROCEDURE_REF(node_free_env_48_integrate_free, ((long) 2));
		  if (
		     INTEGERP(pre_method_105_1657))
		    {	/* ./Llib/object.scm 2927 */
		       PROCEDURE_SET(node_free_env_48_integrate_free, ((long) 2), BUNSPEC);
		       arg1722_1376 = pre_method_105_1657;
		    }
		  else
		    {	/* ./Llib/object.scm 2914 */
		       long obj_class_num_177_1662;
		       obj_class_num_177_1662 =
			  TYPE(obj_1656);
		       {	/* ./Llib/object.scm 2915 */
			  obj_t arg1176_1663;
			  arg1176_1663 =
			     PROCEDURE_REF(node_free_env_48_integrate_free, ((long) 1));
			  {	/* ./Llib/object.scm 2738 */
			     long arg1177_1667;
			     {	/* ./Llib/object.scm 2738 */
				long arg1178_1668;
				arg1178_1668 =
				   OBJECT_TYPE;
				arg1177_1667 =
				   (obj_class_num_177_1662 - arg1178_1668);
			     }
			     arg1722_1376 =
				VECTOR_REF(arg1176_1663, arg1177_1667);
			  }
		       }
		    }
	       }
	    }
	    {	/* Integrate/free.scm 110 */
	       object_bglt object_1673;
	       object_1673 =
		  (object_bglt) (node_9);
	       {	/* ./Llib/object.scm 2695 */
		  long arg1179_1674;
		  {	/* ./Llib/object.scm 2695 */
		     long arg1180_1675;
		     long arg1181_1676;
		     arg1180_1675 =
			TYPE(object_1673);
		     arg1181_1676 =
			OBJECT_TYPE;
		     arg1179_1674 =
			(arg1180_1675 - arg1181_1676);
		  }
		  {	/* ./Llib/object.scm 2695 */
		     obj_t vector_1680;
		     vector_1680 = _classes__134___object;
		     arg1723_1377 =
			VECTOR_REF(vector_1680, arg1179_1674);
		  }
	       }
	    }
	    method1714_1378 = arg1722_1376;
	    class1719_1379 = arg1723_1377;
	    {

	       if (
		  INTEGERP(method1714_1378))
		 {	/* Integrate/free.scm 110 */
		    switch (
		       (long) CINT(method1714_1378))
		      {
		      case ((long) 0):

			 {	/* Integrate/free.scm 117 */
			    var_bglt node_1385;
			    node_1385 =
			       (var_bglt) (node_9);
			    {	/* Integrate/free.scm 119 */
			       bool_t test1726_1388;
			       {	/* ./Ast/var.scm 906 */
				  obj_t aux_1968;
				  {	/* Integrate/free.scm 119 */
				     variable_bglt aux_1969;
				     aux_1969 =
					(((var_bglt) CREF(node_1385))->variable);
				     aux_1968 =
					(obj_t) (aux_1969);
				  }
				  test1726_1388 =
				     is_a__118___object(aux_1968, global_ast_var);
			       }
			       if (test1726_1388)
				 {	/* Integrate/free.scm 119 */
				    return free_10;
				 }
			       else
				 {	/* Integrate/free.scm 121 */
				    bool_t test1727_1389;
				    {	/* Integrate/free.scm 121 */
				       obj_t aux_1974;
				       {	/* Integrate/free.scm 121 */
					  obj_t aux_1975;
					  {	/* Integrate/free.scm 121 */
					     variable_bglt aux_1976;
					     aux_1976 =
						(((var_bglt) CREF(node_1385))->variable);
					     aux_1975 =
						(obj_t) (aux_1976);
					  }
					  aux_1974 =
					     free_variable__181_integrate_free(aux_1975);
				       }
				       test1727_1389 =
					  CBOOL(aux_1974);
				    }
				    if (test1727_1389)
				      {		/* Integrate/free.scm 121 */
					 {	/* Integrate/free.scm 122 */
					    local_bglt aux_1982;
					    {	/* Integrate/free.scm 122 */
					       variable_bglt aux_1983;
					       aux_1983 =
						  (((var_bglt) CREF(node_1385))->variable);
					       aux_1982 =
						  (local_bglt) (aux_1983);
					    }
					    mark_variable__104_integrate_free(aux_1982);
					 }
					 {	/* ./Ieee/pair-list.scm 5689 */
					    obj_t aux_1987;
					    {	/* Integrate/free.scm 123 */
					       variable_bglt aux_1988;
					       aux_1988 =
						  (((var_bglt) CREF(node_1385))->variable);
					       aux_1987 =
						  (obj_t) (aux_1988);
					    }
					    return
					       MAKE_PAIR(aux_1987, free_10);
					 }
				      }
				    else
				      {		/* Integrate/free.scm 121 */
					 return free_10;
				      }
				 }
			    }
			 }
			 break;
		      case ((long) 1):

			 {	/* Integrate/free.scm 131 */
			    obj_t arg1734_1398;
			    {	/* Integrate/free.scm 131 */
			       obj_t aux_1992;
			       {	/* Integrate/free.scm 131 */
				  closure_bglt aux_1993;
				  aux_1993 =
				     (closure_bglt) (node_9);
				  aux_1992 =
				     (obj_t) (aux_1993);
			       }
			       arg1734_1398 =
				  shape_tools_shape(aux_1992);
			    }
			    return
			       internal_error_43_tools_error(string1808_integrate_free, string1809_integrate_free, arg1734_1398);
			 }
			 break;
		      case ((long) 2):

			 {	/* Integrate/free.scm 137 */
			    sequence_bglt node_1399;
			    node_1399 =
			       (sequence_bglt) (node_9);
			    return
			       node_free__199_integrate_free(
			       (((sequence_bglt) CREF(node_1399))->nodes), free_10);
			 }
			 break;
		      case ((long) 3):

			 {	/* Integrate/free.scm 144 */
			    app_bglt node_1403;
			    node_1403 =
			       (app_bglt) (node_9);
			    return
			       node_free__199_integrate_free(
			       (((app_bglt) CREF(node_1403))->args), free_10);
			 }
			 break;
		      case ((long) 4):

			 {	/* Integrate/free.scm 151 */
			    app_ly_162_bglt node_1407;
			    node_1407 =
			       (app_ly_162_bglt) (node_9);
			    {	/* Integrate/free.scm 152 */
			       node_bglt arg1738_1410;
			       obj_t arg1739_1411;
			       arg1738_1410 =
				  (((app_ly_162_bglt) CREF(node_1407))->fun);
			       arg1739_1411 =
				  node_free_158_integrate_free(
				  (((app_ly_162_bglt) CREF(node_1407))->arg), free_10);
			       {
				  obj_t free_2009;
				  node_bglt node_2008;
				  node_2008 = arg1738_1410;
				  free_2009 = arg1739_1411;
				  free_10 = free_2009;
				  node_9 = node_2008;
				  goto node_free_158_integrate_free;
			       }
			    }
			 }
			 break;
		      case ((long) 5):

			 {	/* Integrate/free.scm 158 */
			    funcall_bglt node_1413;
			    node_1413 =
			       (funcall_bglt) (node_9);
			    {	/* Integrate/free.scm 159 */
			       node_bglt arg1741_1416;
			       obj_t arg1742_1417;
			       arg1741_1416 =
				  (((funcall_bglt) CREF(node_1413))->fun);
			       arg1742_1417 =
				  node_free__199_integrate_free(
				  (((funcall_bglt) CREF(node_1413))->args), free_10);
			       {
				  obj_t free_2015;
				  node_bglt node_2014;
				  node_2014 = arg1741_1416;
				  free_2015 = arg1742_1417;
				  free_10 = free_2015;
				  node_9 = node_2014;
				  goto node_free_158_integrate_free;
			       }
			    }
			 }
			 break;
		      case ((long) 6):

			 {	/* Integrate/free.scm 165 */
			    pragma_bglt node_1419;
			    node_1419 =
			       (pragma_bglt) (node_9);
			    return
			       node_free__199_integrate_free(
			       (((pragma_bglt) CREF(node_1419))->args), free_10);
			 }
			 break;
		      case ((long) 7):

			 {	/* Integrate/free.scm 172 */
			    cast_bglt node_1423;
			    node_1423 =
			       (cast_bglt) (node_9);
			    {
			       node_bglt node_2020;
			       node_2020 =
				  (((cast_bglt) CREF(node_1423))->arg);
			       node_9 = node_2020;
			       goto node_free_158_integrate_free;
			    }
			 }
			 break;
		      case ((long) 8):

			 {	/* Integrate/free.scm 179 */
			    setq_bglt node_1427;
			    node_1427 =
			       (setq_bglt) (node_9);
			    {	/* Integrate/free.scm 180 */
			       var_bglt arg1746_1430;
			       obj_t arg1747_1431;
			       arg1746_1430 =
				  (((setq_bglt) CREF(node_1427))->var);
			       arg1747_1431 =
				  node_free_158_integrate_free(
				  (((setq_bglt) CREF(node_1427))->value), free_10);
			       {
				  obj_t free_2028;
				  node_bglt node_2026;
				  node_2026 =
				     (node_bglt) (arg1746_1430);
				  free_2028 = arg1747_1431;
				  free_10 = free_2028;
				  node_9 = node_2026;
				  goto node_free_158_integrate_free;
			       }
			    }
			 }
			 break;
		      case ((long) 9):

			 {	/* Integrate/free.scm 186 */
			    conditional_bglt node_1433;
			    node_1433 =
			       (conditional_bglt) (node_9);
			    {	/* Integrate/free.scm 187 */
			       node_bglt arg1749_1436;
			       obj_t arg1750_1437;
			       arg1749_1436 =
				  (((conditional_bglt) CREF(node_1433))->test);
			       {	/* Integrate/free.scm 187 */
				  node_bglt arg1751_1438;
				  obj_t arg1752_1439;
				  arg1751_1438 =
				     (((conditional_bglt) CREF(node_1433))->true);
				  arg1752_1439 =
				     node_free_158_integrate_free(
				     (((conditional_bglt) CREF(node_1433))->false), free_10);
				  arg1750_1437 =
				     node_free_158_integrate_free(arg1751_1438, arg1752_1439);
			       }
			       {
				  obj_t free_2036;
				  node_bglt node_2035;
				  node_2035 = arg1749_1436;
				  free_2036 = arg1750_1437;
				  free_10 = free_2036;
				  node_9 = node_2035;
				  goto node_free_158_integrate_free;
			       }
			    }
			 }
			 break;
		      case ((long) 10):

			 {	/* Integrate/free.scm 193 */
			    fail_bglt node_1441;
			    node_1441 =
			       (fail_bglt) (node_9);
			    {	/* Integrate/free.scm 194 */
			       node_bglt arg1754_1444;
			       obj_t arg1755_1445;
			       arg1754_1444 =
				  (((fail_bglt) CREF(node_1441))->proc);
			       {	/* Integrate/free.scm 194 */
				  node_bglt arg1756_1446;
				  obj_t arg1758_1447;
				  arg1756_1446 =
				     (((fail_bglt) CREF(node_1441))->msg);
				  arg1758_1447 =
				     node_free_158_integrate_free(
				     (((fail_bglt) CREF(node_1441))->obj), free_10);
				  arg1755_1445 =
				     node_free_158_integrate_free(arg1756_1446, arg1758_1447);
			       }
			       {
				  obj_t free_2044;
				  node_bglt node_2043;
				  node_2043 = arg1754_1444;
				  free_2044 = arg1755_1445;
				  free_10 = free_2044;
				  node_9 = node_2043;
				  goto node_free_158_integrate_free;
			       }
			    }
			 }
			 break;
		      case ((long) 11):

			 {	/* Integrate/free.scm 200 */
			    select_bglt node_1449;
			    node_1449 =
			       (select_bglt) (node_9);
			    {
			       obj_t clauses_1452;
			       obj_t free_1453;
			       clauses_1452 =
				  (((select_bglt) CREF(node_1449))->clauses);
			       free_1453 = free_10;
			     loop_1454:
			       if (
				  NULLP(clauses_1452))
				 {
				    obj_t free_2050;
				    node_bglt node_2048;
				    node_2048 =
				       (((select_bglt) CREF(node_1449))->test);
				    free_2050 = free_1453;
				    free_10 = free_2050;
				    node_9 = node_2048;
				    goto node_free_158_integrate_free;
				 }
			       else
				 {	/* Integrate/free.scm 205 */
				    obj_t arg1763_1458;
				    obj_t arg1764_1459;
				    arg1763_1458 =
				       CDR(clauses_1452);
				    {	/* Integrate/free.scm 205 */
				       node_bglt aux_2052;
				       {	/* Integrate/free.scm 205 */
					  obj_t aux_2053;
					  {	/* ./Ieee/pair-list.scm 5707 */
					     obj_t aux_2054;
					     aux_2054 =
						CAR(clauses_1452);
					     aux_2053 =
						CDR(aux_2054);
					  }
					  aux_2052 =
					     (node_bglt) (aux_2053);
				       }
				       arg1764_1459 =
					  node_free_158_integrate_free(aux_2052, free_1453);
				    }
				    {
				       obj_t free_2060;
				       obj_t clauses_2059;
				       clauses_2059 = arg1763_1458;
				       free_2060 = arg1764_1459;
				       free_1453 = free_2060;
				       clauses_1452 = clauses_2059;
				       goto loop_1454;
				    }
				 }
			    }
			 }
			 break;
		      case ((long) 12):

			 {	/* Integrate/free.scm 211 */
			    let_fun_218_bglt node_1462;
			    node_1462 =
			       (let_fun_218_bglt) (node_9);
			    {
			       obj_t locals_1465;
			       obj_t free_1466;
			       locals_1465 =
				  (((let_fun_218_bglt) CREF(node_1462))->locals);
			       free_1466 = free_10;
			     liip_1467:
			       if (
				  NULLP(locals_1465))
				 {
				    obj_t free_2067;
				    node_bglt node_2065;
				    node_2065 =
				       (((let_fun_218_bglt) CREF(node_1462))->body);
				    free_2067 = free_1466;
				    free_10 = free_2067;
				    node_9 = node_2065;
				    goto node_free_158_integrate_free;
				 }
			       else
				 {	/* Integrate/free.scm 217 */
				    value_bglt fun_1472;
				    {	/* Integrate/free.scm 218 */
				       local_bglt obj_1715;
				       {	/* Integrate/free.scm 218 */
					  obj_t aux_2068;
					  aux_2068 =
					     CAR(locals_1465);
					  obj_1715 =
					     (local_bglt) (aux_2068);
				       }
				       fun_1472 =
					  (((local_bglt) CREF(obj_1715))->value);
				    }
				    {	/* Integrate/free.scm 218 */

				       {
					  obj_t l1530_1473;
					  {	/* Integrate/free.scm 220 */
					     sfun_bglt obj_1716;
					     obj_1716 =
						(sfun_bglt) (fun_1472);
					     l1530_1473 =
						(((sfun_bglt) CREF(obj_1716))->args);
					  }
					lname1531_1474:
					  if (
					     PAIRP(l1530_1473))
					    {	/* Integrate/free.scm 219 */
					       {	/* Integrate/free.scm 219 */
						  local_bglt aux_2074;
						  {	/* Integrate/free.scm 219 */
						     obj_t aux_2075;
						     aux_2075 =
							CAR(l1530_1473);
						     aux_2074 =
							(local_bglt) (aux_2075);
						  }
						  bind_variable__14_integrate_free(aux_2074,
						     (local_bglt) (_integrator__235_integrate_free));
					       }
					       {
						  obj_t l1530_2080;
						  l1530_2080 =
						     CDR(l1530_1473);
						  l1530_1473 = l1530_2080;
						  goto lname1531_1474;
					       }
					    }
					  else
					    {	/* Integrate/free.scm 219 */
					       ((bool_t) 1);
					    }
				       }
				       {	/* Integrate/free.scm 221 */
					  obj_t arg1773_1479;
					  obj_t arg1774_1480;
					  arg1773_1479 =
					     CDR(locals_1465);
					  {	/* Integrate/free.scm 222 */
					     node_bglt aux_2085;
					     {	/* Integrate/free.scm 222 */
						obj_t aux_2086;
						{	/* Integrate/free.scm 222 */
						   sfun_bglt obj_1721;
						   obj_1721 =
						      (sfun_bglt) (fun_1472);
						   aux_2086 =
						      (((sfun_bglt) CREF(obj_1721))->body);
						}
						aux_2085 =
						   (node_bglt) (aux_2086);
					     }
					     arg1774_1480 =
						node_free_158_integrate_free(aux_2085, free_1466);
					  }
					  {
					     obj_t free_2092;
					     obj_t locals_2091;
					     locals_2091 = arg1773_1479;
					     free_2092 = arg1774_1480;
					     free_1466 = free_2092;
					     locals_1465 = locals_2091;
					     goto liip_1467;
					  }
				       }
				    }
				 }
			    }
			 }
			 break;
		      case ((long) 13):

			 {	/* Integrate/free.scm 228 */
			    let_var_6_bglt node_1482;
			    node_1482 =
			       (let_var_6_bglt) (node_9);
			    {
			       obj_t bindings_1485;
			       obj_t free_1486;
			       bindings_1485 =
				  (((let_var_6_bglt) CREF(node_1482))->bindings);
			       free_1486 = free_10;
			     loop_1487:
			       if (
				  NULLP(bindings_1485))
				 {
				    obj_t free_2099;
				    node_bglt node_2097;
				    node_2097 =
				       (((let_var_6_bglt) CREF(node_1482))->body);
				    free_2099 = free_1486;
				    free_10 = free_2099;
				    node_9 = node_2097;
				    goto node_free_158_integrate_free;
				 }
			       else
				 {	/* Integrate/free.scm 231 */
				    {	/* Integrate/free.scm 234 */
				       local_bglt aux_2100;
				       {	/* Integrate/free.scm 234 */
					  obj_t aux_2101;
					  {	/* ./Ieee/pair-list.scm 5701 */
					     obj_t aux_2102;
					     aux_2102 =
						CAR(bindings_1485);
					     aux_2101 =
						CAR(aux_2102);
					  }
					  aux_2100 =
					     (local_bglt) (aux_2101);
				       }
				       bind_variable__14_integrate_free(aux_2100,
					  (local_bglt) (_integrator__235_integrate_free));
				    }
				    {	/* Integrate/free.scm 235 */
				       obj_t arg1781_1493;
				       obj_t arg1782_1494;
				       arg1781_1493 =
					  CDR(bindings_1485);
				       {	/* Integrate/free.scm 236 */
					  node_bglt aux_2109;
					  {	/* Integrate/free.scm 236 */
					     obj_t aux_2110;
					     {	/* ./Ieee/pair-list.scm 5707 */
						obj_t aux_2111;
						aux_2111 =
						   CAR(bindings_1485);
						aux_2110 =
						   CDR(aux_2111);
					     }
					     aux_2109 =
						(node_bglt) (aux_2110);
					  }
					  arg1782_1494 =
					     node_free_158_integrate_free(aux_2109, free_1486);
				       }
				       {
					  obj_t free_2117;
					  obj_t bindings_2116;
					  bindings_2116 = arg1781_1493;
					  free_2117 = arg1782_1494;
					  free_1486 = free_2117;
					  bindings_1485 = bindings_2116;
					  goto loop_1487;
				       }
				    }
				 }
			    }
			 }
			 break;
		      case ((long) 14):

			 {	/* Integrate/free.scm 242 */
			    set_ex_it_116_bglt node_1497;
			    node_1497 =
			       (set_ex_it_116_bglt) (node_9);
			    {	/* Integrate/free.scm 243 */
			       local_bglt aux_2120;
			       {	/* Integrate/free.scm 243 */
				  variable_bglt aux_2121;
				  {	/* Integrate/free.scm 243 */
				     var_bglt arg1786_1501;
				     arg1786_1501 =
					(((set_ex_it_116_bglt) CREF(node_1497))->var);
				     aux_2121 =
					(((var_bglt) CREF(arg1786_1501))->variable);
				  }
				  aux_2120 =
				     (local_bglt) (aux_2121);
			       }
			       bind_variable__14_integrate_free(aux_2120,
				  (local_bglt) (_integrator__235_integrate_free));
			    }
			    {
			       node_bglt node_2127;
			       node_2127 =
				  (((set_ex_it_116_bglt) CREF(node_1497))->body);
			       node_9 = node_2127;
			       goto node_free_158_integrate_free;
			    }
			 }
			 break;
		      case ((long) 15):

			 {	/* Integrate/free.scm 250 */
			    jump_ex_it_184_bglt node_1503;
			    node_1503 =
			       (jump_ex_it_184_bglt) (node_9);
			    {	/* Integrate/free.scm 251 */
			       node_bglt arg1788_1506;
			       obj_t arg1789_1507;
			       arg1788_1506 =
				  (((jump_ex_it_184_bglt) CREF(node_1503))->exit);
			       arg1789_1507 =
				  node_free_158_integrate_free(
				  (((jump_ex_it_184_bglt) CREF(node_1503))->value), free_10);
			       {
				  obj_t free_2134;
				  node_bglt node_2133;
				  node_2133 = arg1788_1506;
				  free_2134 = arg1789_1507;
				  free_10 = free_2134;
				  node_9 = node_2133;
				  goto node_free_158_integrate_free;
			       }
			    }
			 }
			 break;
		      case ((long) 16):

			 {	/* Integrate/free.scm 257 */
			    make_box_202_bglt node_1509;
			    node_1509 =
			       (make_box_202_bglt) (node_9);
			    {
			       node_bglt node_2136;
			       node_2136 =
				  (((make_box_202_bglt) CREF(node_1509))->value);
			       node_9 = node_2136;
			       goto node_free_158_integrate_free;
			    }
			 }
			 break;
		      case ((long) 17):

			 {	/* Integrate/free.scm 264 */
			    box_ref_242_bglt node_1513;
			    node_1513 =
			       (box_ref_242_bglt) (node_9);
			    {
			       node_bglt node_2139;
			       {	/* Integrate/free.scm 265 */
				  var_bglt aux_2140;
				  aux_2140 =
				     (((box_ref_242_bglt) CREF(node_1513))->var);
				  node_2139 =
				     (node_bglt) (aux_2140);
			       }
			       node_9 = node_2139;
			       goto node_free_158_integrate_free;
			    }
			 }
			 break;
		      case ((long) 18):

			 {	/* Integrate/free.scm 271 */
			    box_set__221_bglt node_1517;
			    node_1517 =
			       (box_set__221_bglt) (node_9);
			    {	/* Integrate/free.scm 272 */
			       var_bglt arg1793_1520;
			       obj_t arg1794_1521;
			       arg1793_1520 =
				  (((box_set__221_bglt) CREF(node_1517))->var);
			       arg1794_1521 =
				  node_free_158_integrate_free(
				  (((box_set__221_bglt) CREF(node_1517))->value), free_10);
			       {
				  obj_t free_2149;
				  node_bglt node_2147;
				  node_2147 =
				     (node_bglt) (arg1793_1520);
				  free_2149 = arg1794_1521;
				  free_10 = free_2149;
				  node_9 = node_2147;
				  goto node_free_158_integrate_free;
			       }
			    }
			 }
			 break;
		      default:
		       case_else1720_1382:
			 if (
			    PROCEDUREP(method1714_1378))
			   {	/* Integrate/free.scm 110 */
			      return
				 PROCEDURE_ENTRY(method1714_1378) (method1714_1378,
				 (obj_t) (node_9), free_10, BEOA);
			   }
			 else
			   {	/* Integrate/free.scm 110 */
			      obj_t fun1713_1374;
			      fun1713_1374 =
				 PROCEDURE_REF(node_free_env_48_integrate_free, ((long) 0));
			      return
				 PROCEDURE_ENTRY(fun1713_1374) (fun1713_1374,
				 (obj_t) (node_9), free_10, BEOA);
			   }
		      }
		 }
	       else
		 {	/* Integrate/free.scm 110 */
		    goto case_else1720_1382;
		 }
	    }
	 }
      }
   }
}



/* _node-free1805 */
obj_t 
_node_free1805_184_integrate_free(obj_t env_1747, obj_t node_1748, obj_t free_1749)
{
   AN_OBJECT;
   {	/* Integrate/free.scm 110 */
      return
	 node_free_158_integrate_free(
	 (node_bglt) (node_1748), free_1749);
   }
}



/* node-free-default1546 */
obj_t 
node_free_default1546_176_integrate_free(node_bglt node_11, obj_t free_12)
{
   AN_OBJECT;
   {	/* Integrate/free.scm 14 */
      return free_12;
   }
}



/* _node-free-default1546 */
obj_t 
_node_free_default1546_115_integrate_free(obj_t env_1750, obj_t node_1751, obj_t free_1752)
{
   AN_OBJECT;
   {	/* Integrate/free.scm 14 */
      return
	 node_free_default1546_176_integrate_free(
	 (node_bglt) (node_1751), free_1752);
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_integrate_free()
{
   AN_OBJECT;
   {	/* Integrate/free.scm 14 */
      module_initialization_70_tools_trace(((long) 0), "INTEGRATE_FREE");
      module_initialization_70_tools_shape(((long) 0), "INTEGRATE_FREE");
      module_initialization_70_tools_speek(((long) 0), "INTEGRATE_FREE");
      module_initialization_70_tools_error(((long) 0), "INTEGRATE_FREE");
      module_initialization_70_type_type(((long) 0), "INTEGRATE_FREE");
      module_initialization_70_type_cache(((long) 0), "INTEGRATE_FREE");
      module_initialization_70_ast_var(((long) 0), "INTEGRATE_FREE");
      module_initialization_70_ast_local(((long) 0), "INTEGRATE_FREE");
      module_initialization_70_ast_node(((long) 0), "INTEGRATE_FREE");
      module_initialization_70_ast_sexp(((long) 0), "INTEGRATE_FREE");
      module_initialization_70_ast_glo_def_117(((long) 0), "INTEGRATE_FREE");
      module_initialization_70_integrate_info(((long) 0), "INTEGRATE_FREE");
      module_initialization_70_integrate_node(((long) 0), "INTEGRATE_FREE");
      return
	 module_initialization_70_engine_param(((long) 0), "INTEGRATE_FREE");
   }
}
