/*===========================================================================*/
/*   (Integrate/g.scm)                                                       */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;

typedef struct svar_iinfo_76
  {
     obj_t f_mark_181;
     obj_t u_mark_209;
     bool_t kaptured__204;
     bool_t celled__113;
  }
             *svar_iinfo_76_bglt;

typedef struct sexit_iinfo_190
  {
     obj_t f_mark_181;
     obj_t u_mark_209;
     bool_t kaptured__204;
     bool_t celled__113;
  }
               *sexit_iinfo_190_bglt;

typedef struct sfun_iinfo_105
  {
     obj_t owner;
     obj_t free;
     obj_t bound;
     obj_t cfrom;
     obj_t cto;
     obj_t k;
     obj_t k__190;
     obj_t u;
     obj_t cn;
     obj_t ct;
     obj_t kont;
     bool_t g__219;
     obj_t l;
     obj_t led;
     obj_t istamp;
     obj_t global;
     obj_t kaptured;
  }
              *sfun_iinfo_105_bglt;


static obj_t method_init_76_integrate_g();
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t module_initialization_70_integrate_g(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_integrate_info(long, char *);
extern obj_t module_initialization_70_integrate_a(long, char *);
extern obj_t module_initialization_70___object(long, char *);
static bool_t integrate_remaining_local_functions__137_integrate_g();
static obj_t imported_modules_init_94_integrate_g();
static obj_t library_modules_init_112_integrate_g();
extern obj_t variable_ast_var;
extern obj_t local_ast_var;
extern obj_t g__63_integrate_g(obj_t);
extern obj_t _phi__105_integrate_a;
static obj_t require_initialization_114_integrate_g = BUNSPEC;
static obj_t _g__236_integrate_g(obj_t, obj_t);
static obj_t *__cnst;

DEFINE_EXPORT_PROCEDURE(g__env_111_integrate_g, _g__236_integrate_g1662, _g__236_integrate_g, 0L, 1);



/* module-initialization */
obj_t 
module_initialization_70_integrate_g(long checksum_1474, char *from_1475)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_integrate_g))
	{
	   require_initialization_114_integrate_g =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_integrate_g();
	   imported_modules_init_94_integrate_g();
	   method_init_76_integrate_g();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_integrate_g()
{
   AN_OBJECT;
   {	/* Integrate/g.scm 14 */
      module_initialization_70___object(((long) 0), "INTEGRATE_G");
      return BUNSPEC;
   }
}



/* g! */
obj_t 
g__63_integrate_g(obj_t g_cn_224_1)
{
   AN_OBJECT;
   {	/* Integrate/g.scm 31 */
      {
	 bool_t stop__17_883;
	 long stamp_884;
	 obj_t gs_885;
	 stop__17_883 = ((bool_t) 0);
	 stamp_884 = ((long) 0);
	 gs_885 = g_cn_224_1;
       loop_886:
	 if (stop__17_883)
	   {	/* Integrate/g.scm 36 */
	      {
		 obj_t l1516_887;
		 l1516_887 = _phi__105_integrate_a;
	       lname1517_888:
		 if (
		    PAIRP(l1516_887))
		   {	/* Integrate/g.scm 40 */
		      {		/* Integrate/g.scm 41 */
			 obj_t f_890;
			 f_890 =
			    CAR(l1516_887);
			 {	/* Integrate/g.scm 41 */
			    bool_t test1523_891;
			    test1523_891 =
			       is_a__118___object(f_890, local_ast_var);
			    if (test1523_891)
			      {		/* Integrate/g.scm 42 */
				 sfun_iinfo_105_bglt obj_1338;
				 obj_t val1491_1339;
				 {	/* Integrate/g.scm 42 */
				    value_bglt aux_1489;
				    {	/* Integrate/g.scm 42 */
				       local_bglt obj_1337;
				       obj_1337 =
					  (local_bglt) (f_890);
				       aux_1489 =
					  (((local_bglt) CREF(obj_1337))->value);
				    }
				    obj_1338 =
				       (sfun_iinfo_105_bglt) (aux_1489);
				 }
				 val1491_1339 =
				    BINT(((long) -1));
				 {
				    obj_t aux_1494;
				    {	/* ./Integrate/iinfo.scm 934 */
				       object_bglt aux_1495;
				       aux_1495 =
					  (object_bglt) (obj_1338);
				       aux_1494 =
					  OBJECT_WIDENING(aux_1495);
				    }
				    ((((sfun_iinfo_105_bglt) CREF(aux_1494))->istamp) = ((obj_t) val1491_1339), BUNSPEC);
				 }
			      }
			    else
			      {		/* Integrate/g.scm 41 */
				 BUNSPEC;
			      }
			 }
		      }
		      {
			 obj_t l1516_1499;
			 l1516_1499 =
			    CDR(l1516_887);
			 l1516_887 = l1516_1499;
			 goto lname1517_888;
		      }
		   }
		 else
		   {	/* Integrate/g.scm 40 */
		      ((bool_t) 1);
		   }
	      }
	      integrate_remaining_local_functions__137_integrate_g();
	      return gs_885;
	   }
	 else
	   {
	      obj_t phi_895;
	      bool_t stop__17_896;
	      obj_t gs_897;
	      phi_895 = _phi__105_integrate_a;
	      stop__17_896 = ((bool_t) 1);
	      gs_897 = gs_885;
	    liip_898:
	      if (
		 NULLP(phi_895))
		{
		   obj_t gs_1507;
		   long stamp_1505;
		   bool_t stop__17_1504;
		   stop__17_1504 = stop__17_896;
		   stamp_1505 =
		      (stamp_884 + ((long) 1));
		   gs_1507 = gs_897;
		   gs_885 = gs_1507;
		   stamp_884 = stamp_1505;
		   stop__17_883 = stop__17_1504;
		   goto loop_886;
		}
	      else
		{	/* Integrate/g.scm 53 */
		   obj_t f_901;
		   f_901 =
		      CAR(phi_895);
		   {	/* Integrate/g.scm 53 */
		      value_bglt fif_902;
		      {		/* Integrate/g.scm 54 */
			 variable_bglt obj_1345;
			 obj_1345 =
			    (variable_bglt) (f_901);
			 fif_902 =
			    (((variable_bglt) CREF(obj_1345))->value);
		      }
		      {		/* Integrate/g.scm 54 */

			 {
			    obj_t ct_903;
			    bool_t stop__17_904;
			    obj_t gs_905;
			    {	/* Integrate/g.scm 55 */
			       sfun_iinfo_105_bglt obj_1346;
			       obj_1346 =
				  (sfun_iinfo_105_bglt) (fif_902);
			       {
				  obj_t aux_1697;
				  {	/* ./Integrate/iinfo.scm 924 */
				     object_bglt aux_1698;
				     aux_1698 =
					(object_bglt) (obj_1346);
				     aux_1697 =
					OBJECT_WIDENING(aux_1698);
				  }
				  ct_903 =
				     (((sfun_iinfo_105_bglt) CREF(aux_1697))->ct);
			       }
			    }
			    stop__17_904 = stop__17_896;
			    gs_905 = gs_897;
			  laap_906:
			    if (
			       NULLP(ct_903))
			      {
				 obj_t gs_1516;
				 bool_t stop__17_1515;
				 obj_t phi_1513;
				 phi_1513 =
				    CDR(phi_895);
				 stop__17_1515 = stop__17_904;
				 gs_1516 = gs_905;
				 gs_897 = gs_1516;
				 stop__17_896 = stop__17_1515;
				 phi_895 = phi_1513;
				 goto liip_898;
			      }
			    else
			      {		/* Integrate/g.scm 60 */
				 obj_t g_910;
				 g_910 =
				    CAR(ct_903);
				 {	/* Integrate/g.scm 60 */
				    value_bglt gif_911;
				    {	/* Integrate/g.scm 61 */
				       local_bglt obj_1350;
				       obj_1350 =
					  (local_bglt) (g_910);
				       gif_911 =
					  (((local_bglt) CREF(obj_1350))->value);
				    }
				    {	/* Integrate/g.scm 61 */

				       if (
					  (f_901 == g_910))
					 {	/* Integrate/g.scm 70 */
					    {
					       obj_t ct_1522;
					       ct_1522 =
						  CDR(ct_903);
					       ct_903 = ct_1522;
					       goto laap_906;
					    }
					 }
				       else
					 {	/* Integrate/g.scm 72 */
					    bool_t test_1524;
					    {	/* Integrate/g.scm 72 */
					       sfun_iinfo_105_bglt obj_1354;
					       obj_1354 =
						  (sfun_iinfo_105_bglt) (gif_911);
					       {
						  obj_t aux_1526;
						  {	/* ./Integrate/iinfo.scm 904 */
						     object_bglt aux_1527;
						     aux_1527 =
							(object_bglt) (obj_1354);
						     aux_1526 =
							OBJECT_WIDENING(aux_1527);
						  }
						  test_1524 =
						     (((sfun_iinfo_105_bglt) CREF(aux_1526))->g__219);
					       }
					    }
					    if (test_1524)
					      {		/* Integrate/g.scm 72 */
						 {
						    obj_t ct_1531;
						    ct_1531 =
						       CDR(ct_903);
						    ct_903 = ct_1531;
						    goto laap_906;
						 }
					      }
					    else
					      {		/* Integrate/g.scm 74 */
						 bool_t test_1533;
						 {	/* Integrate/g.scm 74 */
						    sfun_iinfo_105_bglt obj_1356;
						    obj_1356 =
						       (sfun_iinfo_105_bglt) (fif_902);
						    {
						       obj_t aux_1535;
						       {	/* ./Integrate/iinfo.scm 904 */
							  object_bglt aux_1536;
							  aux_1536 =
							     (object_bglt) (obj_1356);
							  aux_1535 =
							     OBJECT_WIDENING(aux_1536);
						       }
						       test_1533 =
							  (((sfun_iinfo_105_bglt) CREF(aux_1535))->g__219);
						    }
						 }
						 if (test_1533)
						   {	/* Integrate/g.scm 74 */
						      {		/* Integrate/g.scm 76 */
							 bool_t test1538_917;
							 {	/* ./Ast/var.scm 577 */
							    obj_t aux_1540;
							    {	/* Integrate/g.scm 76 */
							       sfun_iinfo_105_bglt obj_1357;
							       obj_1357 =
								  (sfun_iinfo_105_bglt) (gif_911);
							       {
								  obj_t aux_1542;
								  {	/* ./Integrate/iinfo.scm 930 */
								     object_bglt aux_1543;
								     aux_1543 =
									(object_bglt) (obj_1357);
								     aux_1542 =
									OBJECT_WIDENING(aux_1543);
								  }
								  aux_1540 =
								     (((sfun_iinfo_105_bglt) CREF(aux_1542))->l);
							       }
							    }
							    test1538_917 =
							       is_a__118___object(aux_1540, variable_ast_var);
							 }
							 if (test1538_917)
							   {	/* Integrate/g.scm 83 */
							      bool_t test_1549;
							      {		/* ./Ieee/equiv.scm 5508 */
								 obj_t aux_1550;
								 {	/* Integrate/g.scm 83 */
								    sfun_iinfo_105_bglt obj_1359;
								    obj_1359 =
								       (sfun_iinfo_105_bglt) (gif_911);
								    {
								       obj_t aux_1552;
								       {	/* ./Integrate/iinfo.scm 930 */
									  object_bglt aux_1553;
									  aux_1553 =
									     (object_bglt) (obj_1359);
									  aux_1552 =
									     OBJECT_WIDENING(aux_1553);
								       }
								       aux_1550 =
									  (((sfun_iinfo_105_bglt) CREF(aux_1552))->l);
								    }
								 }
								 test_1549 =
								    (aux_1550 == f_901);
							      }
							      if (test_1549)
								{	/* Integrate/g.scm 83 */
								   {
								      obj_t ct_1558;
								      ct_1558 =
									 CDR(ct_903);
								      ct_903 = ct_1558;
								      goto laap_906;
								   }
								}
							      else
								{	/* Integrate/g.scm 83 */
								   {	/* Integrate/g.scm 86 */
								      sfun_iinfo_105_bglt obj_1363;
								      obj_1363 =
									 (sfun_iinfo_105_bglt) (gif_911);
								      {
									 obj_t aux_1561;
									 {	/* ./Integrate/iinfo.scm 904 */
									    object_bglt aux_1562;
									    aux_1562 =
									       (object_bglt) (obj_1363);
									    aux_1561 =
									       OBJECT_WIDENING(aux_1562);
									 }
									 ((((sfun_iinfo_105_bglt) CREF(aux_1561))->g__219) = ((bool_t) ((bool_t) 1)), BUNSPEC);
								      }
								   }
								   {	/* Integrate/g.scm 90 */
								      obj_t arg1541_920;
								      obj_t arg1543_921;
								      arg1541_920 =
									 CDR(ct_903);
								      arg1543_921 =
									 MAKE_PAIR(g_910, gs_905);
								      {
									 obj_t gs_1570;
									 bool_t stop__17_1569;
									 obj_t ct_1568;
									 ct_1568 = arg1541_920;
									 stop__17_1569 = ((bool_t) 0);
									 gs_1570 = arg1543_921;
									 gs_905 = gs_1570;
									 stop__17_904 = stop__17_1569;
									 ct_903 = ct_1568;
									 goto laap_906;
								      }
								   }
								}
							   }
							 else
							   {	/* Integrate/g.scm 76 */
							      {		/* Integrate/g.scm 81 */
								 sfun_iinfo_105_bglt obj_1368;
								 obj_1368 =
								    (sfun_iinfo_105_bglt) (gif_911);
								 {
								    obj_t aux_1572;
								    {	/* ./Integrate/iinfo.scm 930 */
								       object_bglt aux_1573;
								       aux_1573 =
									  (object_bglt) (obj_1368);
								       aux_1572 =
									  OBJECT_WIDENING(aux_1573);
								    }
								    ((((sfun_iinfo_105_bglt) CREF(aux_1572))->l) = ((obj_t) f_901), BUNSPEC);
								 }
							      }
							      {
								 bool_t stop__17_1579;
								 obj_t ct_1577;
								 ct_1577 =
								    CDR(ct_903);
								 stop__17_1579 = ((bool_t) 0);
								 stop__17_904 = stop__17_1579;
								 ct_903 = ct_1577;
								 goto laap_906;
							      }
							   }
						      }
						   }
						 else
						   {	/* Integrate/g.scm 91 */
						      bool_t test1548_925;
						      {		/* ./Ast/var.scm 577 */
							 obj_t aux_1580;
							 {	/* Integrate/g.scm 91 */
							    sfun_iinfo_105_bglt obj_1371;
							    obj_1371 =
							       (sfun_iinfo_105_bglt) (gif_911);
							    {
							       obj_t aux_1582;
							       {	/* ./Integrate/iinfo.scm 930 */
								  object_bglt aux_1583;
								  aux_1583 =
								     (object_bglt) (obj_1371);
								  aux_1582 =
								     OBJECT_WIDENING(aux_1583);
							       }
							       aux_1580 =
								  (((sfun_iinfo_105_bglt) CREF(aux_1582))->l);
							    }
							 }
							 test1548_925 =
							    is_a__118___object(aux_1580, variable_ast_var);
						      }
						      if (test1548_925)
							{	/* Integrate/g.scm 115 */
							   bool_t test1549_926;
							   {	/* ./Ast/var.scm 577 */
							      obj_t aux_1589;
							      {		/* Integrate/g.scm 115 */
								 sfun_iinfo_105_bglt obj_1373;
								 obj_1373 =
								    (sfun_iinfo_105_bglt) (fif_902);
								 {
								    obj_t aux_1591;
								    {	/* ./Integrate/iinfo.scm 930 */
								       object_bglt aux_1592;
								       aux_1592 =
									  (object_bglt) (obj_1373);
								       aux_1591 =
									  OBJECT_WIDENING(aux_1592);
								    }
								    aux_1589 =
								       (((sfun_iinfo_105_bglt) CREF(aux_1591))->l);
								 }
							      }
							      test1549_926 =
								 is_a__118___object(aux_1589, variable_ast_var);
							   }
							   if (test1549_926)
							     {	/* Integrate/g.scm 123 */
								bool_t test_1598;
								{	/* ./Ieee/equiv.scm 5508 */
								   obj_t aux_1606;
								   obj_t aux_1599;
								   {	/* Integrate/g.scm 123 */
								      sfun_iinfo_105_bglt obj_1376;
								      obj_1376 =
									 (sfun_iinfo_105_bglt) (gif_911);
								      {
									 obj_t aux_1608;
									 {	/* ./Integrate/iinfo.scm 930 */
									    object_bglt aux_1609;
									    aux_1609 =
									       (object_bglt) (obj_1376);
									    aux_1608 =
									       OBJECT_WIDENING(aux_1609);
									 }
									 aux_1606 =
									    (((sfun_iinfo_105_bglt) CREF(aux_1608))->l);
								      }
								   }
								   {	/* Integrate/g.scm 123 */
								      sfun_iinfo_105_bglt obj_1375;
								      obj_1375 =
									 (sfun_iinfo_105_bglt) (fif_902);
								      {
									 obj_t aux_1601;
									 {	/* ./Integrate/iinfo.scm 930 */
									    object_bglt aux_1602;
									    aux_1602 =
									       (object_bglt) (obj_1375);
									    aux_1601 =
									       OBJECT_WIDENING(aux_1602);
									 }
									 aux_1599 =
									    (((sfun_iinfo_105_bglt) CREF(aux_1601))->l);
								      }
								   }
								   test_1598 =
								      (aux_1599 == aux_1606);
								}
								if (test_1598)
								  {	/* Integrate/g.scm 123 */
								     {
									obj_t ct_1614;
									ct_1614 =
									   CDR(ct_903);
									ct_903 = ct_1614;
									goto laap_906;
								     }
								  }
								else
								  {	/* Integrate/g.scm 123 */
								     {	/* Integrate/g.scm 129 */
									sfun_iinfo_105_bglt obj_1380;
									obj_1380 =
									   (sfun_iinfo_105_bglt) (gif_911);
									{
									   obj_t aux_1617;
									   {	/* ./Integrate/iinfo.scm 904 */
									      object_bglt aux_1618;
									      aux_1618 =
										 (object_bglt) (obj_1380);
									      aux_1617 =
										 OBJECT_WIDENING(aux_1618);
									   }
									   ((((sfun_iinfo_105_bglt) CREF(aux_1617))->g__219) = ((bool_t) ((bool_t) 1)), BUNSPEC);
									}
								     }
								     {	/* Integrate/g.scm 132 */
									obj_t arg1552_929;
									obj_t arg1553_930;
									arg1552_929 =
									   CDR(ct_903);
									arg1553_930 =
									   MAKE_PAIR(g_910, gs_905);
									{
									   obj_t gs_1626;
									   bool_t stop__17_1625;
									   obj_t ct_1624;
									   ct_1624 = arg1552_929;
									   stop__17_1625 = ((bool_t) 0);
									   gs_1626 = arg1553_930;
									   gs_905 = gs_1626;
									   stop__17_904 = stop__17_1625;
									   ct_903 = ct_1624;
									   goto laap_906;
									}
								     }
								  }
							     }
							   else
							     {	/* Integrate/g.scm 115 */
								{	/* Integrate/g.scm 121 */
								   obj_t arg1557_933;
								   {	/* Integrate/g.scm 121 */
								      sfun_iinfo_105_bglt obj_1385;
								      obj_1385 =
									 (sfun_iinfo_105_bglt) (gif_911);
								      {
									 obj_t aux_1628;
									 {	/* ./Integrate/iinfo.scm 930 */
									    object_bglt aux_1629;
									    aux_1629 =
									       (object_bglt) (obj_1385);
									    aux_1628 =
									       OBJECT_WIDENING(aux_1629);
									 }
									 arg1557_933 =
									    (((sfun_iinfo_105_bglt) CREF(aux_1628))->l);
								      }
								   }
								   {	/* Integrate/g.scm 121 */
								      sfun_iinfo_105_bglt obj_1386;
								      obj_1386 =
									 (sfun_iinfo_105_bglt) (fif_902);
								      {
									 obj_t aux_1634;
									 {	/* ./Integrate/iinfo.scm 930 */
									    object_bglt aux_1635;
									    aux_1635 =
									       (object_bglt) (obj_1386);
									    aux_1634 =
									       OBJECT_WIDENING(aux_1635);
									 }
									 ((((sfun_iinfo_105_bglt) CREF(aux_1634))->l) = ((obj_t) arg1557_933), BUNSPEC);
								      }
								   }
								}
								{
								   bool_t stop__17_1641;
								   obj_t ct_1639;
								   ct_1639 =
								      CDR(ct_903);
								   stop__17_1641 = ((bool_t) 0);
								   stop__17_904 = stop__17_1641;
								   ct_903 = ct_1639;
								   goto laap_906;
								}
							     }
							}
						      else
							{	/* Integrate/g.scm 91 */
							   {	/* Integrate/g.scm 93 */
							      bool_t test1560_936;
							      {		/* ./Ast/var.scm 577 */
								 obj_t aux_1642;
								 {	/* Integrate/g.scm 93 */
								    sfun_iinfo_105_bglt obj_1389;
								    obj_1389 =
								       (sfun_iinfo_105_bglt) (fif_902);
								    {
								       obj_t aux_1644;
								       {	/* ./Integrate/iinfo.scm 930 */
									  object_bglt aux_1645;
									  aux_1645 =
									     (object_bglt) (obj_1389);
									  aux_1644 =
									     OBJECT_WIDENING(aux_1645);
								       }
								       aux_1642 =
									  (((sfun_iinfo_105_bglt) CREF(aux_1644))->l);
								    }
								 }
								 test1560_936 =
								    is_a__118___object(aux_1642, variable_ast_var);
							      }
							      if (test1560_936)
								{	/* Integrate/g.scm 93 */
								   {	/* Integrate/g.scm 94 */
								      obj_t arg1561_937;
								      {		/* Integrate/g.scm 94 */
									 sfun_iinfo_105_bglt obj_1391;
									 obj_1391 =
									    (sfun_iinfo_105_bglt) (fif_902);
									 {
									    obj_t aux_1652;
									    {	/* ./Integrate/iinfo.scm 930 */
									       object_bglt aux_1653;
									       aux_1653 =
										  (object_bglt) (obj_1391);
									       aux_1652 =
										  OBJECT_WIDENING(aux_1653);
									    }
									    arg1561_937 =
									       (((sfun_iinfo_105_bglt) CREF(aux_1652))->l);
									 }
								      }
								      {		/* Integrate/g.scm 94 */
									 sfun_iinfo_105_bglt obj_1392;
									 obj_1392 =
									    (sfun_iinfo_105_bglt) (gif_911);
									 {
									    obj_t aux_1658;
									    {	/* ./Integrate/iinfo.scm 930 */
									       object_bglt aux_1659;
									       aux_1659 =
										  (object_bglt) (obj_1392);
									       aux_1658 =
										  OBJECT_WIDENING(aux_1659);
									    }
									    ((((sfun_iinfo_105_bglt) CREF(aux_1658))->l) = ((obj_t) arg1561_937), BUNSPEC);
									 }
								      }
								   }
								   {
								      bool_t stop__17_1665;
								      obj_t ct_1663;
								      ct_1663 =
									 CDR(ct_903);
								      stop__17_1665 = ((bool_t) 0);
								      stop__17_904 = stop__17_1665;
								      ct_903 = ct_1663;
								      goto laap_906;
								   }
								}
							      else
								{	/* Integrate/g.scm 93 */
								   {	/* Integrate/g.scm 102 */
								      bool_t stop__17_939;
								      if (stop__17_904)
									{	/* Integrate/g.scm 104 */
									   bool_t test_1667;
									   {	/* ./Ieee/fixnum.scm 7079 */
									      obj_t aux_1668;
									      {		/* Integrate/g.scm 104 */
										 sfun_iinfo_105_bglt obj_1395;
										 obj_1395 =
										    (sfun_iinfo_105_bglt) (fif_902);
										 {
										    obj_t aux_1670;
										    {	/* ./Integrate/iinfo.scm 934 */
										       object_bglt aux_1671;
										       aux_1671 =
											  (object_bglt) (obj_1395);
										       aux_1670 =
											  OBJECT_WIDENING(aux_1671);
										    }
										    aux_1668 =
										       (((sfun_iinfo_105_bglt) CREF(aux_1670))->istamp);
										 }
									      }
									      test_1667 =
										 INTEGERP(aux_1668);
									   }
									   if (test_1667)
									     {	/* ./Ieee/fixnum.scm 7127 */
										long aux_1676;
										{	/* Integrate/g.scm 106 */
										   obj_t aux_1677;
										   {	/* Integrate/g.scm 106 */
										      sfun_iinfo_105_bglt obj_1397;
										      obj_1397 =
											 (sfun_iinfo_105_bglt) (fif_902);
										      {
											 obj_t aux_1679;
											 {	/* ./Integrate/iinfo.scm 934 */
											    object_bglt aux_1680;
											    aux_1680 =
											       (object_bglt) (obj_1397);
											    aux_1679 =
											       OBJECT_WIDENING(aux_1680);
											 }
											 aux_1677 =
											    (((sfun_iinfo_105_bglt) CREF(aux_1679))->istamp);
										      }
										   }
										   aux_1676 =
										      (long) CINT(aux_1677);
										}
										stop__17_939 =
										   (aux_1676 <= stamp_884);
									     }
									   else
									     {	/* Integrate/g.scm 104 */
										stop__17_939 = ((bool_t) 0);
									     }
									}
								      else
									{	/* Integrate/g.scm 102 */
									   stop__17_939 = ((bool_t) 0);
									}
								      {		/* Integrate/g.scm 113 */
									 sfun_iinfo_105_bglt obj_1400;
									 obj_t val1491_1401;
									 obj_1400 =
									    (sfun_iinfo_105_bglt) (fif_902);
									 val1491_1401 =
									    BINT(stamp_884);
									 {
									    obj_t aux_1688;
									    {	/* ./Integrate/iinfo.scm 934 */
									       object_bglt aux_1689;
									       aux_1689 =
										  (object_bglt) (obj_1400);
									       aux_1688 =
										  OBJECT_WIDENING(aux_1689);
									    }
									    ((((sfun_iinfo_105_bglt) CREF(aux_1688))->istamp) = ((obj_t) val1491_1401), BUNSPEC);
									 }
								      }
								      {
									 bool_t stop__17_1695;
									 obj_t ct_1693;
									 ct_1693 =
									    CDR(ct_903);
									 stop__17_1695 = stop__17_939;
									 stop__17_904 = stop__17_1695;
									 ct_903 = ct_1693;
									 goto laap_906;
								      }
								   }
								}
							   }
							}
						   }
					      }
					 }
				    }
				 }
			      }
			 }
		      }
		   }
		}
	   }
      }
   }
}



/* _g! */
obj_t 
_g__236_integrate_g(obj_t env_1472, obj_t g_cn_224_1473)
{
   AN_OBJECT;
   {	/* Integrate/g.scm 31 */
      return
	 g__63_integrate_g(g_cn_224_1473);
   }
}



/* integrate-remaining-local-functions! */
bool_t 
integrate_remaining_local_functions__137_integrate_g()
{
   AN_OBJECT;
   {	/* Integrate/g.scm 142 */
      {
	 obj_t l1520_947;
	 l1520_947 = _phi__105_integrate_a;
       lname1521_948:
	 if (
	    PAIRP(l1520_947))
	   {	/* Integrate/g.scm 143 */
	      {		/* Integrate/g.scm 144 */
		 obj_t f_950;
		 f_950 =
		    CAR(l1520_947);
		 {	/* Integrate/g.scm 144 */
		    bool_t test1569_951;
		    {	/* Integrate/g.scm 144 */
		       bool_t test1574_955;
		       test1574_955 =
			  is_a__118___object(f_950, local_ast_var);
		       if (test1574_955)
			 {	/* Integrate/g.scm 145 */
			    bool_t test_1708;
			    {	/* Integrate/g.scm 145 */
			       sfun_iinfo_105_bglt obj_1407;
			       {	/* Integrate/g.scm 145 */
				  value_bglt aux_1709;
				  {	/* Integrate/g.scm 145 */
				     local_bglt obj_1406;
				     obj_1406 =
					(local_bglt) (f_950);
				     aux_1709 =
					(((local_bglt) CREF(obj_1406))->value);
				  }
				  obj_1407 =
				     (sfun_iinfo_105_bglt) (aux_1709);
			       }
			       {
				  obj_t aux_1713;
				  {	/* ./Integrate/iinfo.scm 904 */
				     object_bglt aux_1714;
				     aux_1714 =
					(object_bglt) (obj_1407);
				     aux_1713 =
					OBJECT_WIDENING(aux_1714);
				  }
				  test_1708 =
				     (((sfun_iinfo_105_bglt) CREF(aux_1713))->g__219);
			       }
			    }
			    if (test_1708)
			      {		/* Integrate/g.scm 145 */
				 test1569_951 = ((bool_t) 0);
			      }
			    else
			      {		/* Integrate/g.scm 146 */
				 bool_t test1576_957;
				 {	/* ./Ast/var.scm 577 */
				    obj_t aux_1718;
				    {	/* Integrate/g.scm 146 */
				       sfun_iinfo_105_bglt obj_1409;
				       {	/* Integrate/g.scm 146 */
					  value_bglt aux_1719;
					  {	/* Integrate/g.scm 146 */
					     local_bglt obj_1408;
					     obj_1408 =
						(local_bglt) (f_950);
					     aux_1719 =
						(((local_bglt) CREF(obj_1408))->value);
					  }
					  obj_1409 =
					     (sfun_iinfo_105_bglt) (aux_1719);
				       }
				       {
					  obj_t aux_1723;
					  {	/* ./Integrate/iinfo.scm 930 */
					     object_bglt aux_1724;
					     aux_1724 =
						(object_bglt) (obj_1409);
					     aux_1723 =
						OBJECT_WIDENING(aux_1724);
					  }
					  aux_1718 =
					     (((sfun_iinfo_105_bglt) CREF(aux_1723))->l);
				       }
				    }
				    test1576_957 =
				       is_a__118___object(aux_1718, variable_ast_var);
				 }
				 if (test1576_957)
				   {	/* Integrate/g.scm 146 */
				      test1569_951 = ((bool_t) 0);
				   }
				 else
				   {	/* Integrate/g.scm 146 */
				      test1569_951 = ((bool_t) 1);
				   }
			      }
			 }
		       else
			 {	/* Integrate/g.scm 144 */
			    test1569_951 = ((bool_t) 0);
			 }
		    }
		    if (test1569_951)
		      {		/* Integrate/g.scm 144 */
			 {	/* Integrate/g.scm 152 */
			    obj_t arg1572_953;
			    {	/* Integrate/g.scm 153 */
			       sfun_iinfo_105_bglt obj_1413;
			       {	/* Integrate/g.scm 153 */
				  value_bglt aux_1731;
				  {	/* Integrate/g.scm 153 */
				     local_bglt obj_1412;
				     obj_1412 =
					(local_bglt) (f_950);
				     aux_1731 =
					(((local_bglt) CREF(obj_1412))->value);
				  }
				  obj_1413 =
				     (sfun_iinfo_105_bglt) (aux_1731);
			       }
			       {
				  obj_t aux_1735;
				  {	/* ./Integrate/iinfo.scm 904 */
				     object_bglt aux_1736;
				     aux_1736 =
					(object_bglt) (obj_1413);
				     aux_1735 =
					OBJECT_WIDENING(aux_1736);
				  }
				  arg1572_953 =
				     (((sfun_iinfo_105_bglt) CREF(aux_1735))->owner);
			       }
			    }
			    {	/* Integrate/g.scm 152 */
			       sfun_iinfo_105_bglt obj_1414;
			       {	/* Integrate/g.scm 152 */
				  value_bglt aux_1740;
				  {	/* Integrate/g.scm 152 */
				     local_bglt obj_1411;
				     obj_1411 =
					(local_bglt) (f_950);
				     aux_1740 =
					(((local_bglt) CREF(obj_1411))->value);
				  }
				  obj_1414 =
				     (sfun_iinfo_105_bglt) (aux_1740);
			       }
			       {
				  obj_t aux_1744;
				  {	/* ./Integrate/iinfo.scm 930 */
				     object_bglt aux_1745;
				     aux_1745 =
					(object_bglt) (obj_1414);
				     aux_1744 =
					OBJECT_WIDENING(aux_1745);
				  }
				  ((((sfun_iinfo_105_bglt) CREF(aux_1744))->l) = ((obj_t) arg1572_953), BUNSPEC);
			       }
			    }
			 }
		      }
		    else
		      {		/* Integrate/g.scm 144 */
			 BUNSPEC;
		      }
		 }
	      }
	      {
		 obj_t l1520_1749;
		 l1520_1749 =
		    CDR(l1520_947);
		 l1520_947 = l1520_1749;
		 goto lname1521_948;
	      }
	   }
	 else
	   {	/* Integrate/g.scm 143 */
	      return ((bool_t) 1);
	   }
      }
   }
}



/* method-init */
obj_t 
method_init_76_integrate_g()
{
   AN_OBJECT;
   {	/* Integrate/g.scm 14 */
      return BUNSPEC;
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_integrate_g()
{
   AN_OBJECT;
   {	/* Integrate/g.scm 14 */
      module_initialization_70_tools_trace(((long) 0), "INTEGRATE_G");
      module_initialization_70_tools_shape(((long) 0), "INTEGRATE_G");
      module_initialization_70_type_type(((long) 0), "INTEGRATE_G");
      module_initialization_70_ast_var(((long) 0), "INTEGRATE_G");
      module_initialization_70_ast_node(((long) 0), "INTEGRATE_G");
      module_initialization_70_integrate_info(((long) 0), "INTEGRATE_G");
      return
	 module_initialization_70_integrate_a(((long) 0), "INTEGRATE_G");
   }
}
