/*===========================================================================*/
/*   (Integrate/kaptured.scm)                                                */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;

typedef struct svar_iinfo_76
  {
     obj_t f_mark_181;
     obj_t u_mark_209;
     bool_t kaptured__204;
     bool_t celled__113;
  }
             *svar_iinfo_76_bglt;

typedef struct sexit_iinfo_190
  {
     obj_t f_mark_181;
     obj_t u_mark_209;
     bool_t kaptured__204;
     bool_t celled__113;
  }
               *sexit_iinfo_190_bglt;

typedef struct sfun_iinfo_105
  {
     obj_t owner;
     obj_t free;
     obj_t bound;
     obj_t cfrom;
     obj_t cto;
     obj_t k;
     obj_t k__190;
     obj_t u;
     obj_t cn;
     obj_t ct;
     obj_t kont;
     bool_t g__219;
     obj_t l;
     obj_t led;
     obj_t istamp;
     obj_t global;
     obj_t kaptured;
  }
              *sfun_iinfo_105_bglt;


static obj_t method_init_76_integrate_kaptured();
extern obj_t set_kaptured__104_integrate_kaptured(obj_t);
extern obj_t set_cto__5_integrate_cto(node_bglt, local_bglt);
extern bool_t is_a__118___object(obj_t, obj_t);
static obj_t set_one_kaptured__205_integrate_kaptured(obj_t, obj_t);
extern obj_t module_initialization_70_integrate_kaptured(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_integrate_info(long, char *);
extern obj_t module_initialization_70_integrate_free(long, char *);
extern obj_t module_initialization_70_integrate_cto(long, char *);
extern obj_t module_initialization_70___object(long, char *);
static obj_t union_3_integrate_kaptured(obj_t);
static obj_t imported_modules_init_94_integrate_kaptured();
static obj_t library_modules_init_112_integrate_kaptured();
static long _union_round__11_integrate_kaptured;
static obj_t toplevel_init_63_integrate_kaptured();
extern obj_t create_vector(long);
static obj_t _set_kaptured__95_integrate_kaptured(obj_t, obj_t);
extern obj_t get_free_vars_244_integrate_free(node_bglt, local_bglt);
extern obj_t local_ast_var;
extern obj_t free_from_222_integrate_free(obj_t, local_bglt);
static obj_t require_initialization_114_integrate_kaptured = BUNSPEC;
static obj_t *__cnst;

DEFINE_EXPORT_PROCEDURE(set_kaptured__env_5_integrate_kaptured, _set_kaptured__95_integrate_kaptured1655, _set_kaptured__95_integrate_kaptured, 0L, 1);



/* module-initialization */
obj_t 
module_initialization_70_integrate_kaptured(long checksum_1484, char *from_1485)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_integrate_kaptured))
	{
	   require_initialization_114_integrate_kaptured =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_integrate_kaptured();
	   imported_modules_init_94_integrate_kaptured();
	   method_init_76_integrate_kaptured();
	   toplevel_init_63_integrate_kaptured();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_integrate_kaptured()
{
   AN_OBJECT;
   {	/* Integrate/kaptured.scm 16 */
      module_initialization_70___object(((long) 0), "INTEGRATE_KAPTURED");
      return BUNSPEC;
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_integrate_kaptured()
{
   AN_OBJECT;
   {	/* Integrate/kaptured.scm 16 */
      return (
	 _union_round__11_integrate_kaptured = ((long) 0), BUNSPEC);
   }
}



/* set-kaptured! */
obj_t 
set_kaptured__104_integrate_kaptured(obj_t local__0_1)
{
   AN_OBJECT;
   {	/* Integrate/kaptured.scm 30 */
      {
	 obj_t l1516_886;
	 {	/* Integrate/kaptured.scm 31 */
	    bool_t aux_1494;
	    l1516_886 = local__0_1;
	  lname1517_887:
	    if (
	       PAIRP(l1516_886))
	      {		/* Integrate/kaptured.scm 31 */
		 {	/* Integrate/kaptured.scm 32 */
		    obj_t local_889;
		    local_889 =
		       CAR(l1516_886);
		    set_one_kaptured__205_integrate_kaptured(local_889, local_889);
		 }
		 {
		    obj_t l1516_1499;
		    l1516_1499 =
		       CDR(l1516_886);
		    l1516_886 = l1516_1499;
		    goto lname1517_887;
		 }
	      }
	    else
	      {		/* Integrate/kaptured.scm 31 */
		 aux_1494 = ((bool_t) 1);
	      }
	    return
	       BBOOL(aux_1494);
	 }
      }
   }
}



/* _set-kaptured! */
obj_t 
_set_kaptured__95_integrate_kaptured(obj_t env_1482, obj_t local__0_1483)
{
   AN_OBJECT;
   {	/* Integrate/kaptured.scm 30 */
      return
	 set_kaptured__104_integrate_kaptured(local__0_1483);
   }
}



/* set-one-kaptured! */
obj_t 
set_one_kaptured__205_integrate_kaptured(obj_t local_2, obj_t locking_3)
{
   AN_OBJECT;
   {	/* Integrate/kaptured.scm 47 */
      {		/* Integrate/kaptured.scm 51 */
	 value_bglt info_891;
	 {	/* Integrate/kaptured.scm 51 */
	    local_bglt obj_1332;
	    obj_1332 =
	       (local_bglt) (local_2);
	    info_891 =
	       (((local_bglt) CREF(obj_1332))->value);
	 }
	 {	/* Integrate/kaptured.scm 51 */
	    obj_t kaptured_892;
	    {	/* Integrate/kaptured.scm 52 */
	       sfun_iinfo_105_bglt obj_1333;
	       obj_1333 =
		  (sfun_iinfo_105_bglt) (info_891);
	       {
		  obj_t aux_1506;
		  {	/* ./Integrate/iinfo.scm 940 */
		     object_bglt aux_1507;
		     aux_1507 =
			(object_bglt) (obj_1333);
		     aux_1506 =
			OBJECT_WIDENING(aux_1507);
		  }
		  kaptured_892 =
		     (((sfun_iinfo_105_bglt) CREF(aux_1506))->kaptured);
	       }
	    }
	    {	/* Integrate/kaptured.scm 52 */

	       {	/* Integrate/kaptured.scm 54 */
		  bool_t test_1511;
		  if (
		     PAIRP(kaptured_892))
		    {	/* Integrate/kaptured.scm 54 */
		       test_1511 = ((bool_t) 1)
			  ;
		    }
		  else
		    {	/* Integrate/kaptured.scm 54 */
		       test_1511 =
			  NULLP(kaptured_892)
			  ;
		    }
		  if (test_1511)
		    {	/* Integrate/kaptured.scm 54 */
		       {	/* Integrate/kaptured.scm 57 */
			  obj_t v1518_894;
			  v1518_894 =
			     create_vector(((long) 3));
			  VECTOR_SET(v1518_894, ((long) 2), kaptured_892);
			  VECTOR_SET(v1518_894, ((long) 1), locking_3);
			  VECTOR_SET(v1518_894, ((long) 0), BTRUE);
			  return v1518_894;
		       }
		    }
		  else
		    {	/* Integrate/kaptured.scm 58 */
		       bool_t test1527_895;
		       test1527_895 =
			  is_a__118___object(kaptured_892, local_ast_var);
		       if (test1527_895)
			 {	/* Integrate/kaptured.scm 58 */
			    {	/* Integrate/kaptured.scm 61 */
			       obj_t v1519_896;
			       v1519_896 =
				  create_vector(((long) 3));
			       VECTOR_SET(v1519_896, ((long) 2), BNIL);
			       VECTOR_SET(v1519_896, ((long) 1), locking_3);
			       VECTOR_SET(v1519_896, ((long) 0), BFALSE);
			       return v1519_896;
			    }
			 }
		       else
			 {	/* Integrate/kaptured.scm 58 */
			    {	/* Integrate/kaptured.scm 63 */
			       obj_t body_897;
			       {	/* Integrate/kaptured.scm 63 */
				  sfun_bglt obj_1356;
				  obj_1356 =
				     (sfun_bglt) (info_891);
				  body_897 =
				     (((sfun_bglt) CREF(obj_1356))->body);
			       }
			       set_cto__5_integrate_cto(
				  (node_bglt) (body_897),
				  (local_bglt) (local_2));
			       {	/* Integrate/kaptured.scm 70 */
				  sfun_iinfo_105_bglt obj_1357;
				  obj_1357 =
				     (sfun_iinfo_105_bglt) (info_891);
				  {
				     obj_t aux_1531;
				     {	/* ./Integrate/iinfo.scm 940 */
					object_bglt aux_1532;
					aux_1532 =
					   (object_bglt) (obj_1357);
					aux_1531 =
					   OBJECT_WIDENING(aux_1532);
				     }
				     ((((sfun_iinfo_105_bglt) CREF(aux_1531))->kaptured) = ((obj_t) local_2), BUNSPEC);
				  }
			       }
			       {
				  obj_t kaptured_898;
				  obj_t cto_899;
				  bool_t setter__165_900;
				  kaptured_898 = BNIL;
				  {	/* Integrate/kaptured.scm 73 */
				     sfun_iinfo_105_bglt obj_1359;
				     obj_1359 =
					(sfun_iinfo_105_bglt) (info_891);
				     {
					obj_t aux_1625;
					{	/* ./Integrate/iinfo.scm 916 */
					   object_bglt aux_1626;
					   aux_1626 =
					      (object_bglt) (obj_1359);
					   aux_1625 =
					      OBJECT_WIDENING(aux_1626);
					}
					cto_899 =
					   (((sfun_iinfo_105_bglt) CREF(aux_1625))->cto);
				     }
				  }
				  setter__165_900 = ((bool_t) 1);
				loop_901:
				  if (
				     NULLP(cto_899))
				    {	/* Integrate/kaptured.scm 81 */
				       {	/* Integrate/kaptured.scm 82 */
					  obj_t free_905;
					  free_905 =
					     get_free_vars_244_integrate_free(
					     (node_bglt) (body_897),
					     (local_bglt) (local_2));
					  {	/* Integrate/kaptured.scm 82 */
					     obj_t fkaptured_906;
					     fkaptured_906 =
						free_from_222_integrate_free(kaptured_898,
						(local_bglt) (local_2));
					     {	/* Integrate/kaptured.scm 83 */
						obj_t rkaptured_907;
						{	/* Integrate/kaptured.scm 84 */
						   obj_t arg1534_915;
						   arg1534_915 =
						      MAKE_PAIR(free_905, fkaptured_906);
						   rkaptured_907 =
						      union_3_integrate_kaptured(arg1534_915);
						}
						{	/* Integrate/kaptured.scm 84 */

						   if (setter__165_900)
						     {	/* Integrate/kaptured.scm 97 */
							{	/* Integrate/kaptured.scm 100 */
							   sfun_iinfo_105_bglt obj_1363;
							   obj_1363 =
							      (sfun_iinfo_105_bglt) (info_891);
							   {
							      obj_t aux_1547;
							      {		/* ./Integrate/iinfo.scm 940 */
								 object_bglt aux_1548;
								 aux_1548 =
								    (object_bglt) (obj_1363);
								 aux_1547 =
								    OBJECT_WIDENING(aux_1548);
							      }
							      ((((sfun_iinfo_105_bglt) CREF(aux_1547))->kaptured) = ((obj_t) rkaptured_907), BUNSPEC);
							   }
							}
							{
							   obj_t l1520_908;
							   {	/* Integrate/kaptured.scm 102 */
							      bool_t aux_1552;
							      l1520_908 = rkaptured_907;
							    lname1521_909:
							      if (
								 PAIRP(l1520_908))
								{	/* Integrate/kaptured.scm 102 */
								   {	/* Integrate/kaptured.scm 103 */
								      svar_iinfo_76_bglt obj_1368;
								      {		/* Integrate/kaptured.scm 103 */
									 value_bglt aux_1555;
									 {	/* Integrate/kaptured.scm 104 */
									    local_bglt obj_1367;
									    {	/* Integrate/kaptured.scm 104 */
									       obj_t aux_1556;
									       aux_1556 =
										  CAR(l1520_908);
									       obj_1367 =
										  (local_bglt) (aux_1556);
									    }
									    aux_1555 =
									       (((local_bglt) CREF(obj_1367))->value);
									 }
									 obj_1368 =
									    (svar_iinfo_76_bglt) (aux_1555);
								      }
								      {
									 obj_t aux_1561;
									 {	/* ./Integrate/iinfo.scm 892 */
									    object_bglt aux_1562;
									    aux_1562 =
									       (object_bglt) (obj_1368);
									    aux_1561 =
									       OBJECT_WIDENING(aux_1562);
									 }
									 ((((svar_iinfo_76_bglt) CREF(aux_1561))->kaptured__204) = ((bool_t) ((bool_t) 1)), BUNSPEC);
								      }
								   }
								   {
								      obj_t l1520_1566;
								      l1520_1566 =
									 CDR(l1520_908);
								      l1520_908 = l1520_1566;
								      goto lname1521_909;
								   }
								}
							      else
								{	/* Integrate/kaptured.scm 102 */
								   aux_1552 = ((bool_t) 1);
								}
							      BBOOL(aux_1552);
							   }
							}
						     }
						   else
						     {	/* Integrate/kaptured.scm 108 */
							sfun_iinfo_105_bglt obj_1371;
							obj_1371 =
							   (sfun_iinfo_105_bglt) (info_891);
							{
							   obj_t aux_1570;
							   {	/* ./Integrate/iinfo.scm 940 */
							      object_bglt aux_1571;
							      aux_1571 =
								 (object_bglt) (obj_1371);
							      aux_1570 =
								 OBJECT_WIDENING(aux_1571);
							   }
							   ((((sfun_iinfo_105_bglt) CREF(aux_1570))->kaptured) = ((obj_t) BUNSPEC), BUNSPEC);
							}
						     }
						   {	/* Integrate/kaptured.scm 109 */
						      obj_t v1522_914;
						      v1522_914 =
							 create_vector(((long) 3));
						      VECTOR_SET(v1522_914, ((long) 2), rkaptured_907);
						      VECTOR_SET(v1522_914, ((long) 1), locking_3);
						      {		/* ./Ieee/vector.scm 8468 */
							 obj_t aux_1578;
							 aux_1578 =
							    BBOOL(setter__165_900);
							 VECTOR_SET(v1522_914, ((long) 0), aux_1578);
						      }
						      return v1522_914;
						   }
						}
					     }
					  }
				       }
				    }
				  else
				    {	/* Integrate/kaptured.scm 110 */
				       bool_t test_1581;
				       {	/* ./Ieee/equiv.scm 5508 */
					  obj_t aux_1582;
					  aux_1582 =
					     CAR(cto_899);
					  test_1581 =
					     (aux_1582 == local_2);
				       }
				       if (test_1581)
					 {	/* Integrate/kaptured.scm 110 */
					    {
					       obj_t cto_1585;
					       cto_1585 =
						  CDR(cto_899);
					       cto_899 = cto_1585;
					       goto loop_901;
					    }
					 }
				       else
					 {	/* Integrate/kaptured.scm 114 */
					    bool_t test_1587;
					    {	/* Integrate/kaptured.scm 114 */
					       sfun_iinfo_105_bglt obj_1388;
					       {	/* Integrate/kaptured.scm 114 */
						  value_bglt aux_1588;
						  {	/* Integrate/kaptured.scm 114 */
						     local_bglt obj_1387;
						     {	/* Integrate/kaptured.scm 114 */
							obj_t aux_1589;
							aux_1589 =
							   CAR(cto_899);
							obj_1387 =
							   (local_bglt) (aux_1589);
						     }
						     aux_1588 =
							(((local_bglt) CREF(obj_1387))->value);
						  }
						  obj_1388 =
						     (sfun_iinfo_105_bglt) (aux_1588);
					       }
					       {
						  obj_t aux_1594;
						  {	/* ./Integrate/iinfo.scm 906 */
						     object_bglt aux_1595;
						     aux_1595 =
							(object_bglt) (obj_1388);
						     aux_1594 =
							OBJECT_WIDENING(aux_1595);
						  }
						  test_1587 =
						     (((sfun_iinfo_105_bglt) CREF(aux_1594))->g__219);
					       }
					    }
					    if (test_1587)
					      {		/* Integrate/kaptured.scm 114 */
						 {	/* Integrate/kaptured.scm 115 */
						    obj_t other_kaptured_142_919;
						    other_kaptured_142_919 =
						       set_one_kaptured__205_integrate_kaptured(
						       CAR(cto_899), locking_3);
						    {	/* Integrate/kaptured.scm 117 */
						       bool_t test_1601;
						       {	/* ./Ieee/vector.scm 8462 */
							  obj_t aux_1602;
							  aux_1602 =
							     VECTOR_REF(other_kaptured_142_919, ((long) 0));
							  test_1601 =
							     CBOOL(aux_1602);
						       }
						       if (test_1601)
							 {	/* Integrate/kaptured.scm 123 */
							    obj_t arg1539_921;
							    obj_t arg1540_922;
							    {	/* ./Ieee/pair-list.scm 5689 */
							       obj_t aux_1605;
							       aux_1605 =
								  VECTOR_REF(other_kaptured_142_919, ((long) 2));
							       arg1539_921 =
								  MAKE_PAIR(aux_1605, kaptured_898);
							    }
							    arg1540_922 =
							       CDR(cto_899);
							    {
							       obj_t cto_1610;
							       obj_t kaptured_1609;
							       kaptured_1609 = arg1539_921;
							       cto_1610 = arg1540_922;
							       cto_899 = cto_1610;
							       kaptured_898 = kaptured_1609;
							       goto loop_901;
							    }
							 }
						       else
							 {	/* Integrate/kaptured.scm 118 */
							    obj_t arg1543_924;
							    obj_t arg1544_925;
							    bool_t arg1545_926;
							    {	/* ./Ieee/pair-list.scm 5689 */
							       obj_t aux_1611;
							       aux_1611 =
								  VECTOR_REF(other_kaptured_142_919, ((long) 2));
							       arg1543_924 =
								  MAKE_PAIR(aux_1611, kaptured_898);
							    }
							    arg1544_925 =
							       CDR(cto_899);
							    if (setter__165_900)
							      {		/* ./Ieee/equiv.scm 5508 */
								 obj_t aux_1616;
								 aux_1616 =
								    VECTOR_REF(other_kaptured_142_919, ((long) 1));
								 arg1545_926 =
								    (aux_1616 == local_2);
							      }
							    else
							      {		/* Integrate/kaptured.scm 120 */
								 arg1545_926 = ((bool_t) 0);
							      }
							    {
							       bool_t setter__165_1621;
							       obj_t cto_1620;
							       obj_t kaptured_1619;
							       kaptured_1619 = arg1543_924;
							       cto_1620 = arg1544_925;
							       setter__165_1621 = arg1545_926;
							       setter__165_900 = setter__165_1621;
							       cto_899 = cto_1620;
							       kaptured_898 = kaptured_1619;
							       goto loop_901;
							    }
							 }
						    }
						 }
					      }
					    else
					      {		/* Integrate/kaptured.scm 114 */
						 {
						    obj_t cto_1622;
						    cto_1622 =
						       CDR(cto_899);
						    cto_899 = cto_1622;
						    goto loop_901;
						 }
					      }
					 }
				    }
			       }
			    }
			 }
		    }
	       }
	    }
	 }
      }
   }
}



/* union */
obj_t 
union_3_integrate_kaptured(obj_t sets_4)
{
   AN_OBJECT;
   {	/* Integrate/kaptured.scm 139 */
      {		/* Integrate/kaptured.scm 140 */
	 long z2_1408;
	 z2_1408 = _union_round__11_integrate_kaptured;
	 _union_round__11_integrate_kaptured =
	    (((long) 1) + z2_1408);
      }
      {
	 obj_t sets_937;
	 obj_t union_938;
	 sets_937 = sets_4;
	 union_938 = BNIL;
       loop_939:
	 if (
	    NULLP(sets_937))
	   {	/* Integrate/kaptured.scm 143 */
	      return union_938;
	   }
	 else
	   {
	      obj_t set_941;
	      obj_t union_942;
	      set_941 =
		 CAR(sets_937);
	      union_942 = union_938;
	    liip_943:
	      if (
		 NULLP(set_941))
		{	/* Integrate/kaptured.scm 148 */
		   {
		      obj_t union_1637;
		      obj_t sets_1635;
		      sets_1635 =
			 CDR(sets_937);
		      union_1637 = union_942;
		      union_938 = union_1637;
		      sets_937 = sets_1635;
		      goto loop_939;
		   }
		}
	      else
		{	/* Integrate/kaptured.scm 150 */
		   bool_t test1561_947;
		   {	/* Integrate/kaptured.scm 150 */
		      obj_t arg1568_954;
		      {		/* Integrate/kaptured.scm 150 */
			 svar_iinfo_76_bglt obj_1415;
			 {	/* Integrate/kaptured.scm 150 */
			    value_bglt aux_1638;
			    {	/* Integrate/kaptured.scm 150 */
			       local_bglt obj_1414;
			       {	/* Integrate/kaptured.scm 150 */
				  obj_t aux_1639;
				  aux_1639 =
				     CAR(set_941);
				  obj_1414 =
				     (local_bglt) (aux_1639);
			       }
			       aux_1638 =
				  (((local_bglt) CREF(obj_1414))->value);
			    }
			    obj_1415 =
			       (svar_iinfo_76_bglt) (aux_1638);
			 }
			 {
			    obj_t aux_1644;
			    {	/* ./Integrate/iinfo.scm 890 */
			       object_bglt aux_1645;
			       aux_1645 =
				  (object_bglt) (obj_1415);
			       aux_1644 =
				  OBJECT_WIDENING(aux_1645);
			    }
			    arg1568_954 =
			       (((svar_iinfo_76_bglt) CREF(aux_1644))->u_mark_209);
			 }
		      }
		      {		/* Integrate/kaptured.scm 150 */
			 obj_t obj2_1417;
			 obj2_1417 =
			    BINT(_union_round__11_integrate_kaptured);
			 test1561_947 =
			    (arg1568_954 == obj2_1417);
		      }
		   }
		   if (test1561_947)
		     {	/* Integrate/kaptured.scm 150 */
			{
			   obj_t set_1652;
			   set_1652 =
			      CDR(set_941);
			   set_941 = set_1652;
			   goto liip_943;
			}
		     }
		   else
		     {	/* Integrate/kaptured.scm 150 */
			{	/* Integrate/kaptured.scm 154 */
			   svar_iinfo_76_bglt obj_1421;
			   obj_t val1439_1422;
			   {	/* Integrate/kaptured.scm 154 */
			      value_bglt aux_1654;
			      {		/* Integrate/kaptured.scm 154 */
				 local_bglt obj_1420;
				 {	/* Integrate/kaptured.scm 154 */
				    obj_t aux_1655;
				    aux_1655 =
				       CAR(set_941);
				    obj_1420 =
				       (local_bglt) (aux_1655);
				 }
				 aux_1654 =
				    (((local_bglt) CREF(obj_1420))->value);
			      }
			      obj_1421 =
				 (svar_iinfo_76_bglt) (aux_1654);
			   }
			   val1439_1422 =
			      BINT(_union_round__11_integrate_kaptured);
			   {
			      obj_t aux_1661;
			      {		/* ./Integrate/iinfo.scm 890 */
				 object_bglt aux_1662;
				 aux_1662 =
				    (object_bglt) (obj_1421);
				 aux_1661 =
				    OBJECT_WIDENING(aux_1662);
			      }
			      ((((svar_iinfo_76_bglt) CREF(aux_1661))->u_mark_209) = ((obj_t) val1439_1422), BUNSPEC);
			   }
			}
			{	/* Integrate/kaptured.scm 155 */
			   obj_t arg1565_951;
			   obj_t arg1566_952;
			   arg1565_951 =
			      CDR(set_941);
			   {	/* ./Ieee/pair-list.scm 5689 */
			      obj_t aux_1667;
			      aux_1667 =
				 CAR(set_941);
			      arg1566_952 =
				 MAKE_PAIR(aux_1667, union_942);
			   }
			   {
			      obj_t union_1671;
			      obj_t set_1670;
			      set_1670 = arg1565_951;
			      union_1671 = arg1566_952;
			      union_942 = union_1671;
			      set_941 = set_1670;
			      goto liip_943;
			   }
			}
		     }
		}
	   }
      }
   }
}



/* method-init */
obj_t 
method_init_76_integrate_kaptured()
{
   AN_OBJECT;
   {	/* Integrate/kaptured.scm 16 */
      return BUNSPEC;
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_integrate_kaptured()
{
   AN_OBJECT;
   {	/* Integrate/kaptured.scm 16 */
      module_initialization_70_tools_trace(((long) 0), "INTEGRATE_KAPTURED");
      module_initialization_70_tools_shape(((long) 0), "INTEGRATE_KAPTURED");
      module_initialization_70_type_type(((long) 0), "INTEGRATE_KAPTURED");
      module_initialization_70_ast_var(((long) 0), "INTEGRATE_KAPTURED");
      module_initialization_70_ast_node(((long) 0), "INTEGRATE_KAPTURED");
      module_initialization_70_integrate_info(((long) 0), "INTEGRATE_KAPTURED");
      module_initialization_70_integrate_free(((long) 0), "INTEGRATE_KAPTURED");
      return
	 module_initialization_70_integrate_cto(((long) 0), "INTEGRATE_KAPTURED");
   }
}
