/*===========================================================================*/
/*   (Integrate/kk.scm)                                                      */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;

typedef struct svar_iinfo_76
  {
     obj_t f_mark_181;
     obj_t u_mark_209;
     bool_t kaptured__204;
     bool_t celled__113;
  }
             *svar_iinfo_76_bglt;

typedef struct sexit_iinfo_190
  {
     obj_t f_mark_181;
     obj_t u_mark_209;
     bool_t kaptured__204;
     bool_t celled__113;
  }
               *sexit_iinfo_190_bglt;

typedef struct sfun_iinfo_105
  {
     obj_t owner;
     obj_t free;
     obj_t bound;
     obj_t cfrom;
     obj_t cto;
     obj_t k;
     obj_t k__190;
     obj_t u;
     obj_t cn;
     obj_t ct;
     obj_t kont;
     bool_t g__219;
     obj_t l;
     obj_t led;
     obj_t istamp;
     obj_t global;
     obj_t kaptured;
  }
              *sfun_iinfo_105_bglt;


static obj_t method_init_76_integrate_kk();
static obj_t _k_1656_19_integrate_kk(obj_t, obj_t, obj_t);
extern obj_t module_initialization_70_integrate_kk(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_integrate_info(long, char *);
extern obj_t module_initialization_70_integrate_a(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t k___139_integrate_kk(obj_t);
static obj_t imported_modules_init_94_integrate_kk();
static obj_t _k___120_integrate_kk(obj_t, obj_t);
static obj_t library_modules_init_112_integrate_kk();
extern obj_t open_input_string(obj_t);
static obj_t k_2__250_integrate_kk(obj_t, obj_t);
static obj_t k_1__214_integrate_kk(obj_t, obj_t);
extern obj_t memq___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern obj_t k__48_integrate_kk(obj_t, global_bglt);
extern obj_t read___reader(obj_t);
static obj_t require_initialization_114_integrate_kk = BUNSPEC;
static obj_t cnst_init_137_integrate_kk();
static obj_t __cnst[2];

DEFINE_EXPORT_PROCEDURE(k___env_116_integrate_kk, _k___120_integrate_kk1662, _k___120_integrate_kk, 0L, 1);
DEFINE_EXPORT_PROCEDURE(k__env_164_integrate_kk, _k_1656_19_integrate_kk1663, _k_1656_19_integrate_kk, 0L, 2);
DEFINE_STRING(string1657_integrate_kk, string1657_integrate_kk1664, "TAIL BOTTOM ", 12);



/* module-initialization */
obj_t 
module_initialization_70_integrate_kk(long checksum_1506, char *from_1507)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_integrate_kk))
	{
	   require_initialization_114_integrate_kk =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_integrate_kk();
	   cnst_init_137_integrate_kk();
	   imported_modules_init_94_integrate_kk();
	   method_init_76_integrate_kk();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_integrate_kk()
{
   AN_OBJECT;
   {	/* Integrate/kk.scm 14 */
      module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "INTEGRATE_KK");
      module_initialization_70___reader(((long) 0), "INTEGRATE_KK");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_integrate_kk()
{
   AN_OBJECT;
   {	/* Integrate/kk.scm 14 */
      {		/* Integrate/kk.scm 14 */
	 obj_t cnst_port_138_1499;
	 cnst_port_138_1499 =
	    open_input_string(string1657_integrate_kk);
	 {
	    long i_1500;
	    i_1500 = ((long) 1);
	  loop_1501:
	    {	/* Integrate/kk.scm 14 */
	       bool_t test1658_1502;
	       test1658_1502 =
		  (i_1500 == ((long) -1));
	       if (test1658_1502)
		 {	/* Integrate/kk.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Integrate/kk.scm 14 */
		    {	/* Integrate/kk.scm 14 */
		       obj_t arg1659_1503;
		       {	/* Integrate/kk.scm 14 */
			  obj_t list1660_1504;
			  list1660_1504 =
			     MAKE_PAIR(cnst_port_138_1499, BNIL);
			  arg1659_1503 =
			     read___reader(list1660_1504);
		       }
		       CNST_TABLE_SET(i_1500, arg1659_1503);
		    }
		    {	/* Integrate/kk.scm 14 */
		       int aux_1505;
		       {	/* Integrate/kk.scm 14 */
			  long aux_1523;
			  aux_1523 =
			     (i_1500 - ((long) 1));
			  aux_1505 =
			     (int) (aux_1523);
		       }
		       {
			  long i_1526;
			  i_1526 =
			     (long) (aux_1505);
			  i_1500 = i_1526;
			  goto loop_1501;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* k! */
obj_t 
k__48_integrate_kk(obj_t a_1, global_bglt var_2)
{
   AN_OBJECT;
   {	/* Integrate/kk.scm 43 */
      {		/* Integrate/kk.scm 49 */
	 value_bglt ifun_889;
	 ifun_889 =
	    (((global_bglt) CREF(var_2))->value);
	 {	/* Integrate/kk.scm 50 */
	    obj_t arg1516_890;
	    {	/* Integrate/kk.scm 50 */
	       obj_t list1517_891;
	       {	/* Integrate/kk.scm 50 */
		  obj_t aux_1529;
		  aux_1529 =
		     CNST_TABLE_REF(((long) 0));
		  list1517_891 =
		     MAKE_PAIR(aux_1529, BNIL);
	       }
	       arg1516_890 = list1517_891;
	    }
	    {	/* Integrate/kk.scm 50 */
	       sfun_iinfo_105_bglt obj_1345;
	       obj_1345 =
		  (sfun_iinfo_105_bglt) (ifun_889);
	       {
		  obj_t aux_1533;
		  {	/* ./Integrate/iinfo.scm 945 */
		     object_bglt aux_1534;
		     aux_1534 =
			(object_bglt) (obj_1345);
		     aux_1533 =
			OBJECT_WIDENING(aux_1534);
		  }
		  ((((sfun_iinfo_105_bglt) CREF(aux_1533))->k) = ((obj_t) arg1516_890), BUNSPEC);
	       }
	    }
	 }
	 {	/* Integrate/kk.scm 51 */
	    obj_t arg1519_892;
	    {	/* Integrate/kk.scm 51 */
	       obj_t list1520_893;
	       {	/* Integrate/kk.scm 51 */
		  obj_t aux_1538;
		  aux_1538 =
		     CNST_TABLE_REF(((long) 0));
		  list1520_893 =
		     MAKE_PAIR(aux_1538, BNIL);
	       }
	       arg1519_892 = list1520_893;
	    }
	    {	/* Integrate/kk.scm 51 */
	       sfun_iinfo_105_bglt obj_1348;
	       obj_1348 =
		  (sfun_iinfo_105_bglt) (ifun_889);
	       {
		  obj_t aux_1542;
		  {	/* ./Integrate/iinfo.scm 947 */
		     object_bglt aux_1543;
		     aux_1543 =
			(object_bglt) (obj_1348);
		     aux_1542 =
			OBJECT_WIDENING(aux_1543);
		  }
		  ((((sfun_iinfo_105_bglt) CREF(aux_1542))->k__190) = ((obj_t) arg1519_892), BUNSPEC);
	       }
	    }
	 }
	 {	/* Integrate/kk.scm 52 */
	    obj_t arg1521_894;
	    arg1521_894 =
	       k_1__214_integrate_kk(a_1, BNIL);
	    return
	       k_2__250_integrate_kk(a_1, arg1521_894);
	 }
      }
   }
}



/* _k!1656 */
obj_t 
_k_1656_19_integrate_kk(obj_t env_1494, obj_t a_1495, obj_t var_1496)
{
   AN_OBJECT;
   {	/* Integrate/kk.scm 43 */
      return
	 k__48_integrate_kk(a_1495,
	 (global_bglt) (var_1496));
   }
}



/* k.1! */
obj_t 
k_1__214_integrate_kk(obj_t a_3, obj_t a_tail_58_4)
{
   AN_OBJECT;
   {	/* Integrate/kk.scm 57 */
    k_1__214_integrate_kk:
      if (
	 NULLP(a_3))
	{	/* Integrate/kk.scm 59 */
	   return a_tail_58_4;
	}
      else
	{	/* Integrate/kk.scm 61 */
	   obj_t pr_896;
	   pr_896 =
	      CAR(a_3);
	   {	/* Integrate/kk.scm 62 */
	      obj_t g_898;
	      {		/* ./Ieee/pair-list.scm 5701 */
		 obj_t aux_1554;
		 aux_1554 =
		    CDR(pr_896);
		 g_898 =
		    CAR(aux_1554);
	      }
	      {		/* Integrate/kk.scm 63 */
		 obj_t k_899;
		 {	/* ./Ieee/pair-list.scm 5701 */
		    obj_t aux_1557;
		    {	/* ./Ieee/pair-list.scm 5707 */
		       obj_t aux_1558;
		       aux_1558 =
			  CDR(pr_896);
		       aux_1557 =
			  CDR(aux_1558);
		    }
		    k_899 =
		       CAR(aux_1557);
		 }
		 {	/* Integrate/kk.scm 64 */

		    {	/* Integrate/kk.scm 66 */
		       bool_t test_1562;
		       {	/* ./Ieee/equiv.scm 5508 */
			  obj_t aux_1563;
			  aux_1563 =
			     CNST_TABLE_REF(((long) 1));
			  test_1562 =
			     (k_899 == aux_1563);
		       }
		       if (test_1562)
			 {	/* Integrate/kk.scm 66 */
			    {	/* Integrate/kk.scm 67 */
			       bool_t test_1566;
			       {	/* ./Ieee/equiv.scm 5508 */
				  obj_t aux_1567;
				  aux_1567 =
				     CAR(pr_896);
				  test_1566 =
				     (aux_1567 == g_898);
			       }
			       if (test_1566)
				 {
				    obj_t a_1570;
				    a_1570 =
				       CDR(a_3);
				    a_3 = a_1570;
				    goto k_1__214_integrate_kk;
				 }
			       else
				 {	/* Integrate/kk.scm 69 */
				    obj_t arg1526_903;
				    obj_t arg1527_904;
				    arg1526_903 =
				       CDR(a_3);
				    arg1527_904 =
				       MAKE_PAIR(pr_896, a_tail_58_4);
				    {
				       obj_t a_tail_58_1575;
				       obj_t a_1574;
				       a_1574 = arg1526_903;
				       a_tail_58_1575 = arg1527_904;
				       a_tail_58_4 = a_tail_58_1575;
				       a_3 = a_1574;
				       goto k_1__214_integrate_kk;
				    }
				 }
			    }
			 }
		       else
			 {	/* Integrate/kk.scm 66 */
			    {	/* Integrate/kk.scm 71 */
			       value_bglt ifun_905;
			       {	/* Integrate/kk.scm 71 */
				  variable_bglt obj_1371;
				  obj_1371 =
				     (variable_bglt) (g_898);
				  ifun_905 =
				     (((variable_bglt) CREF(obj_1371))->value);
			       }
			       {	/* Integrate/kk.scm 72 */
				  bool_t test_1578;
				  {	/* Integrate/kk.scm 72 */
				     obj_t aux_1579;
				     {	/* Integrate/kk.scm 72 */
					obj_t aux_1580;
					{	/* Integrate/kk.scm 72 */
					   sfun_iinfo_105_bglt obj_1372;
					   obj_1372 =
					      (sfun_iinfo_105_bglt) (ifun_905);
					   {
					      obj_t aux_1582;
					      {		/* ./Integrate/iinfo.scm 945 */
						 object_bglt aux_1583;
						 aux_1583 =
						    (object_bglt) (obj_1372);
						 aux_1582 =
						    OBJECT_WIDENING(aux_1583);
					      }
					      aux_1580 =
						 (((sfun_iinfo_105_bglt) CREF(aux_1582))->k);
					   }
					}
					aux_1579 =
					   memq___r4_pairs_and_lists_6_3(k_899, aux_1580);
				     }
				     test_1578 =
					CBOOL(aux_1579);
				  }
				  if (test_1578)
				    {
				       obj_t a_1589;
				       a_1589 =
					  CDR(a_3);
				       a_3 = a_1589;
				       goto k_1__214_integrate_kk;
				    }
				  else
				    {	/* Integrate/kk.scm 72 */
				       {	/* Integrate/kk.scm 75 */
					  obj_t arg1530_908;
					  {	/* ./Ieee/pair-list.scm 5689 */
					     obj_t aux_1591;
					     {	/* Integrate/kk.scm 75 */
						sfun_iinfo_105_bglt obj_1374;
						obj_1374 =
						   (sfun_iinfo_105_bglt) (ifun_905);
						{
						   obj_t aux_1593;
						   {	/* ./Integrate/iinfo.scm 945 */
						      object_bglt aux_1594;
						      aux_1594 =
							 (object_bglt) (obj_1374);
						      aux_1593 =
							 OBJECT_WIDENING(aux_1594);
						   }
						   aux_1591 =
						      (((sfun_iinfo_105_bglt) CREF(aux_1593))->k);
						}
					     }
					     arg1530_908 =
						MAKE_PAIR(k_899, aux_1591);
					  }
					  {	/* Integrate/kk.scm 75 */
					     sfun_iinfo_105_bglt obj_1377;
					     obj_1377 =
						(sfun_iinfo_105_bglt) (ifun_905);
					     {
						obj_t aux_1600;
						{	/* ./Integrate/iinfo.scm 945 */
						   object_bglt aux_1601;
						   aux_1601 =
						      (object_bglt) (obj_1377);
						   aux_1600 =
						      OBJECT_WIDENING(aux_1601);
						}
						((((sfun_iinfo_105_bglt) CREF(aux_1600))->k) = ((obj_t) arg1530_908), BUNSPEC);
					     }
					  }
				       }
				       {	/* Integrate/kk.scm 76 */
					  obj_t arg1533_910;
					  {	/* ./Ieee/pair-list.scm 5689 */
					     obj_t aux_1605;
					     {	/* Integrate/kk.scm 76 */
						sfun_iinfo_105_bglt obj_1379;
						obj_1379 =
						   (sfun_iinfo_105_bglt) (ifun_905);
						{
						   obj_t aux_1607;
						   {	/* ./Integrate/iinfo.scm 947 */
						      object_bglt aux_1608;
						      aux_1608 =
							 (object_bglt) (obj_1379);
						      aux_1607 =
							 OBJECT_WIDENING(aux_1608);
						   }
						   aux_1605 =
						      (((sfun_iinfo_105_bglt) CREF(aux_1607))->k__190);
						}
					     }
					     arg1533_910 =
						MAKE_PAIR(k_899, aux_1605);
					  }
					  {	/* Integrate/kk.scm 76 */
					     sfun_iinfo_105_bglt obj_1382;
					     obj_1382 =
						(sfun_iinfo_105_bglt) (ifun_905);
					     {
						obj_t aux_1614;
						{	/* ./Integrate/iinfo.scm 947 */
						   object_bglt aux_1615;
						   aux_1615 =
						      (object_bglt) (obj_1382);
						   aux_1614 =
						      OBJECT_WIDENING(aux_1615);
						}
						((((sfun_iinfo_105_bglt) CREF(aux_1614))->k__190) = ((obj_t) arg1533_910), BUNSPEC);
					     }
					  }
				       }
				       {
					  obj_t a_1619;
					  a_1619 =
					     CDR(a_3);
					  a_3 = a_1619;
					  goto k_1__214_integrate_kk;
				       }
				    }
			       }
			    }
			 }
		    }
		 }
	      }
	   }
	}
   }
}



/* k.2! */
obj_t 
k_2__250_integrate_kk(obj_t a_5, obj_t a_tail_58_6)
{
   AN_OBJECT;
   {	/* Integrate/kk.scm 82 */
      {
	 bool_t continue_914;
	 continue_914 = ((bool_t) 1);
       loop_915:
	 if (continue_914)
	   {
	      obj_t at_916;
	      bool_t continue_917;
	      at_916 = a_tail_58_6;
	      continue_917 = ((bool_t) 0);
	    liip_918:
	      if (
		 NULLP(at_916))
		{
		   bool_t continue_1624;
		   continue_1624 = continue_917;
		   continue_914 = continue_1624;
		   goto loop_915;
		}
	      else
		{	/* Integrate/kk.scm 94 */
		   value_bglt ifun_920;
		   {	/* Integrate/kk.scm 94 */
		      variable_bglt obj_1388;
		      {		/* Integrate/kk.scm 94 */
			 obj_t aux_1625;
			 {	/* ./Ieee/pair-list.scm 5701 */
			    obj_t aux_1626;
			    aux_1626 =
			       CAR(at_916);
			    aux_1625 =
			       CAR(aux_1626);
			 }
			 obj_1388 =
			    (variable_bglt) (aux_1625);
		      }
		      ifun_920 =
			 (((variable_bglt) CREF(obj_1388))->value);
		   }
		   {	/* Integrate/kk.scm 95 */
		      bool_t test_1631;
		      {		/* ./Ieee/pair-list.scm 5912 */
			 obj_t aux_1632;
			 {	/* Integrate/kk.scm 95 */
			    sfun_iinfo_105_bglt obj_1389;
			    obj_1389 =
			       (sfun_iinfo_105_bglt) (ifun_920);
			    {
			       obj_t aux_1634;
			       {	/* ./Integrate/iinfo.scm 945 */
				  object_bglt aux_1635;
				  aux_1635 =
				     (object_bglt) (obj_1389);
				  aux_1634 =
				     OBJECT_WIDENING(aux_1635);
			       }
			       aux_1632 =
				  (((sfun_iinfo_105_bglt) CREF(aux_1634))->k);
			    }
			 }
			 test_1631 =
			    NULLP(aux_1632);
		      }
		      if (test_1631)
			{
			   obj_t at_1640;
			   at_1640 =
			      CDR(at_916);
			   at_916 = at_1640;
			   goto liip_918;
			}
		      else
			{	/* Integrate/kk.scm 97 */
			   value_bglt gifun_924;
			   {	/* Integrate/kk.scm 98 */
			      variable_bglt obj_1397;
			      {		/* Integrate/kk.scm 98 */
				 obj_t aux_1642;
				 {	/* ./Ieee/pair-list.scm 5701 */
				    obj_t aux_1643;
				    {	/* ./Ieee/pair-list.scm 5707 */
				       obj_t aux_1644;
				       aux_1644 =
					  CAR(at_916);
				       aux_1643 =
					  CDR(aux_1644);
				    }
				    aux_1642 =
				       CAR(aux_1643);
				 }
				 obj_1397 =
				    (variable_bglt) (aux_1642);
			      }
			      gifun_924 =
				 (((variable_bglt) CREF(obj_1397))->value);
			   }
			   {	/* Integrate/kk.scm 98 */

			      {
				 obj_t ks_925;
				 bool_t continue_926;
				 {	/* Integrate/kk.scm 99 */
				    sfun_iinfo_105_bglt obj_1398;
				    obj_1398 =
				       (sfun_iinfo_105_bglt) (ifun_920);
				    {
				       obj_t aux_1701;
				       {	/* ./Integrate/iinfo.scm 945 */
					  object_bglt aux_1702;
					  aux_1702 =
					     (object_bglt) (obj_1398);
					  aux_1701 =
					     OBJECT_WIDENING(aux_1702);
				       }
				       ks_925 =
					  (((sfun_iinfo_105_bglt) CREF(aux_1701))->k);
				    }
				 }
				 continue_926 = continue_917;
			       laap_927:
				 if (
				    NULLP(ks_925))
				   {
				      bool_t continue_1654;
				      obj_t at_1652;
				      at_1652 =
					 CDR(at_916);
				      continue_1654 = continue_926;
				      continue_917 = continue_1654;
				      at_916 = at_1652;
				      goto liip_918;
				   }
				 else
				   {	/* Integrate/kk.scm 106 */
				      obj_t k_931;
				      k_931 =
					 CAR(ks_925);
				      {		/* Integrate/kk.scm 107 */
					 bool_t test_1656;
					 {	/* Integrate/kk.scm 107 */
					    obj_t aux_1657;
					    {	/* Integrate/kk.scm 107 */
					       obj_t aux_1658;
					       {	/* Integrate/kk.scm 107 */
						  sfun_iinfo_105_bglt obj_1402;
						  obj_1402 =
						     (sfun_iinfo_105_bglt) (gifun_924);
						  {
						     obj_t aux_1660;
						     {	/* ./Integrate/iinfo.scm 945 */
							object_bglt aux_1661;
							aux_1661 =
							   (object_bglt) (obj_1402);
							aux_1660 =
							   OBJECT_WIDENING(aux_1661);
						     }
						     aux_1658 =
							(((sfun_iinfo_105_bglt) CREF(aux_1660))->k);
						  }
					       }
					       aux_1657 =
						  memq___r4_pairs_and_lists_6_3(k_931, aux_1658);
					    }
					    test_1656 =
					       CBOOL(aux_1657);
					 }
					 if (test_1656)
					   {
					      obj_t ks_1667;
					      ks_1667 =
						 CDR(ks_925);
					      ks_925 = ks_1667;
					      goto laap_927;
					   }
					 else
					   {	/* Integrate/kk.scm 107 */
					      {		/* Integrate/kk.scm 112 */
						 obj_t arg1547_934;
						 {	/* ./Ieee/pair-list.scm 5689 */
						    obj_t aux_1669;
						    {	/* Integrate/kk.scm 112 */
						       sfun_iinfo_105_bglt obj_1404;
						       obj_1404 =
							  (sfun_iinfo_105_bglt) (gifun_924);
						       {
							  obj_t aux_1671;
							  {	/* ./Integrate/iinfo.scm 945 */
							     object_bglt aux_1672;
							     aux_1672 =
								(object_bglt) (obj_1404);
							     aux_1671 =
								OBJECT_WIDENING(aux_1672);
							  }
							  aux_1669 =
							     (((sfun_iinfo_105_bglt) CREF(aux_1671))->k);
						       }
						    }
						    arg1547_934 =
						       MAKE_PAIR(k_931, aux_1669);
						 }
						 {	/* Integrate/kk.scm 110 */
						    sfun_iinfo_105_bglt obj_1407;
						    obj_1407 =
						       (sfun_iinfo_105_bglt) (gifun_924);
						    {
						       obj_t aux_1678;
						       {	/* ./Integrate/iinfo.scm 945 */
							  object_bglt aux_1679;
							  aux_1679 =
							     (object_bglt) (obj_1407);
							  aux_1678 =
							     OBJECT_WIDENING(aux_1679);
						       }
						       ((((sfun_iinfo_105_bglt) CREF(aux_1678))->k) = ((obj_t) arg1547_934), BUNSPEC);
						    }
						 }
					      }
					      {		/* Integrate/kk.scm 116 */
						 obj_t arg1549_936;
						 {	/* ./Ieee/pair-list.scm 5689 */
						    obj_t aux_1683;
						    {	/* Integrate/kk.scm 116 */
						       sfun_iinfo_105_bglt obj_1409;
						       obj_1409 =
							  (sfun_iinfo_105_bglt) (gifun_924);
						       {
							  obj_t aux_1685;
							  {	/* ./Integrate/iinfo.scm 947 */
							     object_bglt aux_1686;
							     aux_1686 =
								(object_bglt) (obj_1409);
							     aux_1685 =
								OBJECT_WIDENING(aux_1686);
							  }
							  aux_1683 =
							     (((sfun_iinfo_105_bglt) CREF(aux_1685))->k__190);
						       }
						    }
						    arg1549_936 =
						       MAKE_PAIR(k_931, aux_1683);
						 }
						 {	/* Integrate/kk.scm 114 */
						    sfun_iinfo_105_bglt obj_1412;
						    obj_1412 =
						       (sfun_iinfo_105_bglt) (gifun_924);
						    {
						       obj_t aux_1692;
						       {	/* ./Integrate/iinfo.scm 947 */
							  object_bglt aux_1693;
							  aux_1693 =
							     (object_bglt) (obj_1412);
							  aux_1692 =
							     OBJECT_WIDENING(aux_1693);
						       }
						       ((((sfun_iinfo_105_bglt) CREF(aux_1692))->k__190) = ((obj_t) arg1549_936), BUNSPEC);
						    }
						 }
					      }
					      {
						 bool_t continue_1699;
						 obj_t ks_1697;
						 ks_1697 =
						    CDR(ks_925);
						 continue_1699 = ((bool_t) 1);
						 continue_926 = continue_1699;
						 ks_925 = ks_1697;
						 goto laap_927;
					      }
					   }
				      }
				   }
			      }
			   }
			}
		   }
		}
	   }
	 else
	   {	/* Integrate/kk.scm 85 */
	      return a_tail_58_6;
	   }
      }
   }
}



/* k*! */
obj_t 
k___139_integrate_kk(obj_t a_tail_58_7)
{
   AN_OBJECT;
   {	/* Integrate/kk.scm 133 */
      {
	 bool_t continue_944;
	 continue_944 = ((bool_t) 1);
       loop_945:
	 if (continue_944)
	   {
	      obj_t at_946;
	      bool_t continue_947;
	      at_946 = a_tail_58_7;
	      continue_947 = ((bool_t) 0);
	    liip_948:
	      if (
		 NULLP(at_946))
		{
		   bool_t continue_1709;
		   continue_1709 = continue_947;
		   continue_944 = continue_1709;
		   goto loop_945;
		}
	      else
		{	/* Integrate/kk.scm 142 */
		   value_bglt ifun_950;
		   {	/* Integrate/kk.scm 142 */
		      variable_bglt obj_1421;
		      {		/* Integrate/kk.scm 142 */
			 obj_t aux_1710;
			 {	/* ./Ieee/pair-list.scm 5701 */
			    obj_t aux_1711;
			    {	/* ./Ieee/pair-list.scm 5707 */
			       obj_t aux_1712;
			       aux_1712 =
				  CAR(at_946);
			       aux_1711 =
				  CDR(aux_1712);
			    }
			    aux_1710 =
			       CAR(aux_1711);
			 }
			 obj_1421 =
			    (variable_bglt) (aux_1710);
		      }
		      ifun_950 =
			 (((variable_bglt) CREF(obj_1421))->value);
		   }
		   {	/* Integrate/kk.scm 143 */
		      bool_t test_1718;
		      {		/* ./Ieee/pair-list.scm 5912 */
			 obj_t aux_1719;
			 {	/* Integrate/kk.scm 143 */
			    sfun_iinfo_105_bglt obj_1422;
			    obj_1422 =
			       (sfun_iinfo_105_bglt) (ifun_950);
			    {
			       obj_t aux_1721;
			       {	/* ./Integrate/iinfo.scm 947 */
				  object_bglt aux_1722;
				  aux_1722 =
				     (object_bglt) (obj_1422);
				  aux_1721 =
				     OBJECT_WIDENING(aux_1722);
			       }
			       aux_1719 =
				  (((sfun_iinfo_105_bglt) CREF(aux_1721))->k__190);
			    }
			 }
			 test_1718 =
			    NULLP(aux_1719);
		      }
		      if (test_1718)
			{
			   bool_t continue_1727;
			   continue_1727 = continue_947;
			   continue_944 = continue_1727;
			   goto loop_945;
			}
		      else
			{
			   obj_t ks_952;
			   bool_t continue_953;
			   {	/* Integrate/kk.scm 145 */
			      sfun_iinfo_105_bglt obj_1424;
			      obj_1424 =
				 (sfun_iinfo_105_bglt) (ifun_950);
			      {
				 obj_t aux_1771;
				 {	/* ./Integrate/iinfo.scm 947 */
				    object_bglt aux_1772;
				    aux_1772 =
				       (object_bglt) (obj_1424);
				    aux_1771 =
				       OBJECT_WIDENING(aux_1772);
				 }
				 ks_952 =
				    (((sfun_iinfo_105_bglt) CREF(aux_1771))->k__190);
			      }
			   }
			   continue_953 = continue_947;
			 laap_954:
			   if (
			      NULLP(ks_952))
			     {
				bool_t continue_1732;
				obj_t at_1730;
				at_1730 =
				   CDR(at_946);
				continue_1732 = continue_953;
				continue_947 = continue_1732;
				at_946 = at_1730;
				goto liip_948;
			     }
			   else
			     {	/* Integrate/kk.scm 149 */
				value_bglt fifun_959;
				{	/* Integrate/kk.scm 150 */
				   variable_bglt obj_1429;
				   {	/* Integrate/kk.scm 150 */
				      obj_t aux_1733;
				      {		/* ./Ieee/pair-list.scm 5701 */
					 obj_t aux_1734;
					 aux_1734 =
					    CAR(at_946);
					 aux_1733 =
					    CAR(aux_1734);
				      }
				      obj_1429 =
					 (variable_bglt) (aux_1733);
				   }
				   fifun_959 =
				      (((variable_bglt) CREF(obj_1429))->value);
				}
				{	/* Integrate/kk.scm 150 */
				   obj_t k_960;
				   k_960 =
				      CAR(ks_952);
				   {	/* Integrate/kk.scm 151 */

				      {		/* Integrate/kk.scm 152 */
					 bool_t test_1740;
					 {	/* Integrate/kk.scm 152 */
					    obj_t aux_1741;
					    {	/* Integrate/kk.scm 152 */
					       obj_t aux_1742;
					       {	/* Integrate/kk.scm 152 */
						  sfun_iinfo_105_bglt obj_1431;
						  obj_1431 =
						     (sfun_iinfo_105_bglt) (fifun_959);
						  {
						     obj_t aux_1744;
						     {	/* ./Integrate/iinfo.scm 947 */
							object_bglt aux_1745;
							aux_1745 =
							   (object_bglt) (obj_1431);
							aux_1744 =
							   OBJECT_WIDENING(aux_1745);
						     }
						     aux_1742 =
							(((sfun_iinfo_105_bglt) CREF(aux_1744))->k__190);
						  }
					       }
					       aux_1741 =
						  memq___r4_pairs_and_lists_6_3(k_960, aux_1742);
					    }
					    test_1740 =
					       CBOOL(aux_1741);
					 }
					 if (test_1740)
					   {
					      obj_t ks_1751;
					      ks_1751 =
						 CDR(ks_952);
					      ks_952 = ks_1751;
					      goto laap_954;
					   }
					 else
					   {	/* Integrate/kk.scm 152 */
					      {		/* Integrate/kk.scm 157 */
						 obj_t arg1565_963;
						 {	/* ./Ieee/pair-list.scm 5689 */
						    obj_t aux_1753;
						    {	/* Integrate/kk.scm 157 */
						       sfun_iinfo_105_bglt obj_1433;
						       obj_1433 =
							  (sfun_iinfo_105_bglt) (fifun_959);
						       {
							  obj_t aux_1755;
							  {	/* ./Integrate/iinfo.scm 947 */
							     object_bglt aux_1756;
							     aux_1756 =
								(object_bglt) (obj_1433);
							     aux_1755 =
								OBJECT_WIDENING(aux_1756);
							  }
							  aux_1753 =
							     (((sfun_iinfo_105_bglt) CREF(aux_1755))->k__190);
						       }
						    }
						    arg1565_963 =
						       MAKE_PAIR(k_960, aux_1753);
						 }
						 {	/* Integrate/kk.scm 155 */
						    sfun_iinfo_105_bglt obj_1436;
						    obj_1436 =
						       (sfun_iinfo_105_bglt) (fifun_959);
						    {
						       obj_t aux_1762;
						       {	/* ./Integrate/iinfo.scm 947 */
							  object_bglt aux_1763;
							  aux_1763 =
							     (object_bglt) (obj_1436);
							  aux_1762 =
							     OBJECT_WIDENING(aux_1763);
						       }
						       ((((sfun_iinfo_105_bglt) CREF(aux_1762))->k__190) = ((obj_t) arg1565_963), BUNSPEC);
						    }
						 }
					      }
					      {
						 bool_t continue_1769;
						 obj_t ks_1767;
						 ks_1767 =
						    CDR(ks_952);
						 continue_1769 = ((bool_t) 1);
						 continue_953 = continue_1769;
						 ks_952 = ks_1767;
						 goto laap_954;
					      }
					   }
				      }
				   }
				}
			     }
			}
		   }
		}
	   }
	 else
	   {	/* Integrate/kk.scm 136 */
	      return BUNSPEC;
	   }
      }
   }
}



/* _k*! */
obj_t 
_k___120_integrate_kk(obj_t env_1497, obj_t a_tail_58_1498)
{
   AN_OBJECT;
   {	/* Integrate/kk.scm 133 */
      return
	 k___139_integrate_kk(a_tail_58_1498);
   }
}



/* method-init */
obj_t 
method_init_76_integrate_kk()
{
   AN_OBJECT;
   {	/* Integrate/kk.scm 14 */
      return BUNSPEC;
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_integrate_kk()
{
   AN_OBJECT;
   {	/* Integrate/kk.scm 14 */
      module_initialization_70_tools_trace(((long) 0), "INTEGRATE_KK");
      module_initialization_70_tools_shape(((long) 0), "INTEGRATE_KK");
      module_initialization_70_type_type(((long) 0), "INTEGRATE_KK");
      module_initialization_70_ast_var(((long) 0), "INTEGRATE_KK");
      module_initialization_70_ast_node(((long) 0), "INTEGRATE_KK");
      module_initialization_70_integrate_info(((long) 0), "INTEGRATE_KK");
      return
	 module_initialization_70_integrate_a(((long) 0), "INTEGRATE_KK");
   }
}
