/*===========================================================================*/
/*   (Integrate/let-fun.scm)                                                 */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;

typedef struct svar_iinfo_76
  {
     obj_t f_mark_181;
     obj_t u_mark_209;
     bool_t kaptured__204;
     bool_t celled__113;
  }
             *svar_iinfo_76_bglt;

typedef struct sexit_iinfo_190
  {
     obj_t f_mark_181;
     obj_t u_mark_209;
     bool_t kaptured__204;
     bool_t celled__113;
  }
               *sexit_iinfo_190_bglt;

typedef struct sfun_iinfo_105
  {
     obj_t owner;
     obj_t free;
     obj_t bound;
     obj_t cfrom;
     obj_t cto;
     obj_t k;
     obj_t k__190;
     obj_t u;
     obj_t cn;
     obj_t ct;
     obj_t kont;
     bool_t g__219;
     obj_t l;
     obj_t led;
     obj_t istamp;
     obj_t global;
     obj_t kaptured;
  }
              *sfun_iinfo_105_bglt;


static obj_t method_init_76_integrate_let_fun_158();
extern obj_t make_box_202_ast_node;
extern obj_t funcall_ast_node;
static obj_t _displace_let_fun_node__default1538_48_integrate_let_fun_158(obj_t, obj_t, obj_t);
extern long add_inlined_method__244___object(obj_t, obj_t, long);
extern obj_t fail_ast_node;
static obj_t _displace_let_fun_node_1771_7_integrate_let_fun_158(obj_t, obj_t, obj_t);
extern obj_t box_ref_242_ast_node;
extern obj_t sequence_ast_node;
static obj_t displace_let_fun_node__default1538_40_integrate_let_fun_158(node_bglt, variable_bglt);
extern obj_t let_var_6_ast_node;
extern obj_t var_ast_node;
extern obj_t closure_ast_node;
extern obj_t pragma_ast_node;
extern obj_t set_ex_it_116_ast_node;
extern bool_t is_a__118___object(obj_t, obj_t);
static long _stamp__29_integrate_let_fun_158;
extern obj_t module_initialization_70_integrate_let_fun_158(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_integrate_info(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
static obj_t displace_let_fun_node__83_integrate_let_fun_158(node_bglt, variable_bglt);
static obj_t _displace_let_fun__244_integrate_let_fun_158(obj_t, obj_t);
extern long class_num_218___object(obj_t);
extern obj_t displace_let_fun__199_integrate_let_fun_158(obj_t);
extern obj_t let_fun_218_ast_node;
static obj_t imported_modules_init_94_integrate_let_fun_158();
extern obj_t app_ly_162_ast_node;
extern obj_t add_generic__110___object(obj_t, obj_t);
extern obj_t app_ast_node;
static obj_t library_modules_init_112_integrate_let_fun_158();
extern obj_t atom_ast_node;
extern obj_t cast_ast_node;
static obj_t toplevel_init_63_integrate_let_fun_158();
extern obj_t jump_ex_it_184_ast_node;
extern obj_t open_input_string(obj_t);
extern obj_t kwote_ast_node;
extern obj_t setq_ast_node;
extern obj_t box_set__221_ast_node;
extern obj_t local_ast_var;
extern obj_t shape_tools_shape(obj_t);
extern obj_t internal_error_43_tools_error(obj_t, obj_t, obj_t);
static obj_t bind_fun__68_integrate_let_fun_158(obj_t);
static bool_t free_fun__183_integrate_let_fun_158(obj_t);
extern obj_t _classes__134___object;
extern obj_t select_ast_node;
extern obj_t read___reader(obj_t);
extern obj_t ____74_type_cache;
static obj_t require_initialization_114_integrate_let_fun_158 = BUNSPEC;
extern obj_t conditional_ast_node;
static obj_t cnst_init_137_integrate_let_fun_158();
static obj_t __cnst[1];

DEFINE_STATIC_PROCEDURE(displace_let_fun_node__default1538_env_170_integrate_let_fun_158, _displace_let_fun_node__default1538_48_integrate_let_fun_1581780, _displace_let_fun_node__default1538_48_integrate_let_fun_158, 0L, 2);
DEFINE_STATIC_GENERIC(displace_let_fun_node__env_245_integrate_let_fun_158, _displace_let_fun_node_1771_7_integrate_let_fun_1581781, _displace_let_fun_node_1771_7_integrate_let_fun_158, 0L, 2);
DEFINE_STRING(string1775_integrate_let_fun_158, string1775_integrate_let_fun_1581782, "DISPLACE-LET-FUN-NODE!-DEFAULT1538 ", 35);
DEFINE_STRING(string1774_integrate_let_fun_158, string1774_integrate_let_fun_1581783, "No method for this object", 25);
DEFINE_STRING(string1773_integrate_let_fun_158, string1773_integrate_let_fun_1581784, "Unexpected closure", 18);
DEFINE_STRING(string1772_integrate_let_fun_158, string1772_integrate_let_fun_1581785, "displace-let-fun-node", 21);
DEFINE_EXPORT_PROCEDURE(displace_let_fun__env_206_integrate_let_fun_158, _displace_let_fun__244_integrate_let_fun_1581786, _displace_let_fun__244_integrate_let_fun_158, 0L, 1);



/* module-initialization */
obj_t 
module_initialization_70_integrate_let_fun_158(long checksum_1716, char *from_1717)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_integrate_let_fun_158))
	{
	   require_initialization_114_integrate_let_fun_158 =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_integrate_let_fun_158();
	   cnst_init_137_integrate_let_fun_158();
	   imported_modules_init_94_integrate_let_fun_158();
	   method_init_76_integrate_let_fun_158();
	   toplevel_init_63_integrate_let_fun_158();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_integrate_let_fun_158()
{
   AN_OBJECT;
   {	/* Integrate/let-fun.scm 15 */
      module_initialization_70___object(((long) 0), "INTEGRATE_LET-FUN");
      module_initialization_70___reader(((long) 0), "INTEGRATE_LET-FUN");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_integrate_let_fun_158()
{
   AN_OBJECT;
   {	/* Integrate/let-fun.scm 15 */
      {		/* Integrate/let-fun.scm 15 */
	 obj_t cnst_port_138_1709;
	 cnst_port_138_1709 =
	    open_input_string(string1775_integrate_let_fun_158);
	 {
	    long i_1710;
	    i_1710 = ((long) 0);
	  loop_1711:
	    {	/* Integrate/let-fun.scm 15 */
	       bool_t test1776_1712;
	       test1776_1712 =
		  (i_1710 == ((long) -1));
	       if (test1776_1712)
		 {	/* Integrate/let-fun.scm 15 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Integrate/let-fun.scm 15 */
		    {	/* Integrate/let-fun.scm 15 */
		       obj_t arg1777_1713;
		       {	/* Integrate/let-fun.scm 15 */
			  obj_t list1778_1714;
			  list1778_1714 =
			     MAKE_PAIR(cnst_port_138_1709, BNIL);
			  arg1777_1713 =
			     read___reader(list1778_1714);
		       }
		       CNST_TABLE_SET(i_1710, arg1777_1713);
		    }
		    {	/* Integrate/let-fun.scm 15 */
		       int aux_1715;
		       {	/* Integrate/let-fun.scm 15 */
			  long aux_1734;
			  aux_1734 =
			     (i_1710 - ((long) 1));
			  aux_1715 =
			     (int) (aux_1734);
		       }
		       {
			  long i_1737;
			  i_1737 =
			     (long) (aux_1715);
			  i_1710 = i_1737;
			  goto loop_1711;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_integrate_let_fun_158()
{
   AN_OBJECT;
   {	/* Integrate/let-fun.scm 15 */
      _stamp__29_integrate_let_fun_158 = ((long) 0);
      return BUNSPEC;
   }
}



/* bind-fun! */
obj_t 
bind_fun__68_integrate_let_fun_158(obj_t var_1)
{
   AN_OBJECT;
   {	/* Integrate/let-fun.scm 34 */
      {		/* Integrate/let-fun.scm 36 */
	 bool_t test1585_931;
	 test1585_931 =
	    is_a__118___object(var_1, local_ast_var);
	 if (test1585_931)
	   {	/* Integrate/let-fun.scm 37 */
	      sfun_iinfo_105_bglt obj_1495;
	      obj_t val1491_1496;
	      {		/* Integrate/let-fun.scm 37 */
		 value_bglt aux_1741;
		 {	/* Integrate/let-fun.scm 37 */
		    local_bglt obj_1494;
		    obj_1494 =
		       (local_bglt) (var_1);
		    aux_1741 =
		       (((local_bglt) CREF(obj_1494))->value);
		 }
		 obj_1495 =
		    (sfun_iinfo_105_bglt) (aux_1741);
	      }
	      val1491_1496 =
		 BINT(_stamp__29_integrate_let_fun_158);
	      {
		 obj_t aux_1746;
		 {	/* ./Integrate/iinfo.scm 1208 */
		    object_bglt aux_1747;
		    aux_1747 =
		       (object_bglt) (obj_1495);
		    aux_1746 =
		       OBJECT_WIDENING(aux_1747);
		 }
		 return
		    ((((sfun_iinfo_105_bglt) CREF(aux_1746))->istamp) = ((obj_t) val1491_1496), BUNSPEC);
	      }
	   }
	 else
	   {	/* Integrate/let-fun.scm 36 */
	      return BUNSPEC;
	   }
      }
   }
}



/* free-fun? */
bool_t 
free_fun__183_integrate_let_fun_158(obj_t local_2)
{
   AN_OBJECT;
   {	/* Integrate/let-fun.scm 42 */
      {		/* Integrate/let-fun.scm 44 */
	 bool_t test1587_933;
	 {	/* Integrate/let-fun.scm 44 */
	    obj_t arg1588_934;
	    {	/* Integrate/let-fun.scm 44 */
	       sfun_iinfo_105_bglt obj_1498;
	       {	/* Integrate/let-fun.scm 44 */
		  value_bglt aux_1751;
		  {	/* Integrate/let-fun.scm 44 */
		     local_bglt obj_1497;
		     obj_1497 =
			(local_bglt) (local_2);
		     aux_1751 =
			(((local_bglt) CREF(obj_1497))->value);
		  }
		  obj_1498 =
		     (sfun_iinfo_105_bglt) (aux_1751);
	       }
	       {
		  obj_t aux_1755;
		  {	/* ./Integrate/iinfo.scm 1208 */
		     object_bglt aux_1756;
		     aux_1756 =
			(object_bglt) (obj_1498);
		     aux_1755 =
			OBJECT_WIDENING(aux_1756);
		  }
		  arg1588_934 =
		     (((sfun_iinfo_105_bglt) CREF(aux_1755))->istamp);
	       }
	    }
	    {	/* Integrate/let-fun.scm 44 */
	       obj_t obj2_1500;
	       obj2_1500 =
		  BINT(_stamp__29_integrate_let_fun_158);
	       test1587_933 =
		  (arg1588_934 == obj2_1500);
	    }
	 }
	 if (test1587_933)
	   {	/* Integrate/let-fun.scm 44 */
	      return ((bool_t) 0);
	   }
	 else
	   {	/* Integrate/let-fun.scm 44 */
	      return ((bool_t) 1);
	   }
      }
   }
}



/* displace-let-fun! */
obj_t 
displace_let_fun__199_integrate_let_fun_158(obj_t var_3)
{
   AN_OBJECT;
   {	/* Integrate/let-fun.scm 49 */
      {		/* Integrate/let-fun.scm 55 */
	 long z2_1502;
	 z2_1502 = _stamp__29_integrate_let_fun_158;
	 _stamp__29_integrate_let_fun_158 =
	    (((long) 1) + z2_1502);
      }
      {		/* Integrate/let-fun.scm 56 */
	 node_bglt aux_1764;
	 {	/* Integrate/let-fun.scm 56 */
	    obj_t aux_1765;
	    {	/* Integrate/let-fun.scm 56 */
	       sfun_bglt obj_1504;
	       {	/* Integrate/let-fun.scm 56 */
		  value_bglt aux_1766;
		  {	/* Integrate/let-fun.scm 56 */
		     variable_bglt obj_1503;
		     obj_1503 =
			(variable_bglt) (var_3);
		     aux_1766 =
			(((variable_bglt) CREF(obj_1503))->value);
		  }
		  obj_1504 =
		     (sfun_bglt) (aux_1766);
	       }
	       aux_1765 =
		  (((sfun_bglt) CREF(obj_1504))->body);
	    }
	    aux_1764 =
	       (node_bglt) (aux_1765);
	 }
	 displace_let_fun_node__83_integrate_let_fun_158(aux_1764,
	    (variable_bglt) (var_3));
      }
      {		/* Integrate/let-fun.scm 65 */
	 obj_t led_938;
	 {	/* Integrate/let-fun.scm 65 */
	    sfun_iinfo_105_bglt obj_1506;
	    {	/* Integrate/let-fun.scm 65 */
	       value_bglt aux_1774;
	       {	/* Integrate/let-fun.scm 65 */
		  variable_bglt obj_1505;
		  obj_1505 =
		     (variable_bglt) (var_3);
		  aux_1774 =
		     (((variable_bglt) CREF(obj_1505))->value);
	       }
	       obj_1506 =
		  (sfun_iinfo_105_bglt) (aux_1774);
	    }
	    {
	       obj_t aux_1778;
	       {	/* ./Integrate/iinfo.scm 1206 */
		  object_bglt aux_1779;
		  aux_1779 =
		     (object_bglt) (obj_1506);
		  aux_1778 =
		     OBJECT_WIDENING(aux_1779);
	       }
	       led_938 =
		  (((sfun_iinfo_105_bglt) CREF(aux_1778))->led);
	    }
	 }
	 {
	    obj_t l1516_939;
	    l1516_939 = led_938;
	  lname1517_940:
	    if (
	       PAIRP(l1516_939))
	      {		/* Integrate/let-fun.scm 66 */
		 {	/* Integrate/let-fun.scm 66 */
		    obj_t l_942;
		    l_942 =
		       CAR(l1516_939);
		    if (
		       free_fun__183_integrate_let_fun_158(l_942))
		      {		/* Integrate/let-fun.scm 77 */
			 node_bglt aux_1788;
			 {	/* Integrate/let-fun.scm 77 */
			    obj_t aux_1789;
			    {	/* Integrate/let-fun.scm 77 */
			       sfun_bglt obj_1510;
			       {	/* Integrate/let-fun.scm 77 */
				  value_bglt aux_1790;
				  {	/* Integrate/let-fun.scm 77 */
				     variable_bglt obj_1509;
				     obj_1509 =
					(variable_bglt) (l_942);
				     aux_1790 =
					(((variable_bglt) CREF(obj_1509))->value);
				  }
				  obj_1510 =
				     (sfun_bglt) (aux_1790);
			       }
			       aux_1789 =
				  (((sfun_bglt) CREF(obj_1510))->body);
			    }
			    aux_1788 =
			       (node_bglt) (aux_1789);
			 }
			 displace_let_fun_node__83_integrate_let_fun_158(aux_1788,
			    (variable_bglt) (var_3));
		      }
		    else
		      {		/* Integrate/let-fun.scm 71 */
			 BUNSPEC;
		      }
		 }
		 {
		    obj_t l1516_1798;
		    l1516_1798 =
		       CDR(l1516_939);
		    l1516_939 = l1516_1798;
		    goto lname1517_940;
		 }
	      }
	    else
	      {		/* Integrate/let-fun.scm 66 */
		 ((bool_t) 1);
	      }
	 }
	 {
	    obj_t led_947;
	    obj_t added_948;
	    led_947 = led_938;
	    added_948 = BNIL;
	  loop_949:
	    if (
	       NULLP(led_947))
	      {		/* Integrate/let-fun.scm 83 */
		 if (
		    PAIRP(added_948))
		   {	/* Integrate/let-fun.scm 86 */
		      obj_t old_body_129_952;
		      {		/* Integrate/let-fun.scm 86 */
			 sfun_bglt obj_1515;
			 {	/* Integrate/let-fun.scm 86 */
			    value_bglt aux_1804;
			    {	/* Integrate/let-fun.scm 86 */
			       variable_bglt obj_1514;
			       obj_1514 =
				  (variable_bglt) (var_3);
			       aux_1804 =
				  (((variable_bglt) CREF(obj_1514))->value);
			    }
			    obj_1515 =
			       (sfun_bglt) (aux_1804);
			 }
			 old_body_129_952 =
			    (((sfun_bglt) CREF(obj_1515))->body);
		      }
		      {		/* Integrate/let-fun.scm 86 */
			 let_fun_218_bglt new_body_215_953;
			 {	/* Integrate/let-fun.scm 88 */
			    obj_t arg1600_955;
			    obj_t arg1601_956;
			    {	/* Integrate/let-fun.scm 88 */
			       node_bglt obj_1516;
			       obj_1516 =
				  (node_bglt) (old_body_129_952);
			       arg1600_955 =
				  (((node_bglt) CREF(obj_1516))->loc);
			    }
			    arg1601_956 = ____74_type_cache;
			    {	/* Integrate/let-fun.scm 87 */
			       let_fun_218_bglt res1769_1533;
			       {	/* Integrate/let-fun.scm 87 */
				  type_bglt type_1518;
				  obj_t key_1520;
				  node_bglt body_1522;
				  type_1518 =
				     (type_bglt) (arg1601_956);
				  key_1520 =
				     BINT(((long) -1));
				  body_1522 =
				     (node_bglt) (old_body_129_952);
				  {	/* ./Ast/node.scm 1094 */
				     let_fun_218_bglt new1358_1523;
				     new1358_1523 =
					((let_fun_218_bglt) BREF(GC_MALLOC(sizeof(struct let_fun_218))));
				     {	/* ./Ast/node.scm 1094 */
					long arg1635_1524;
					arg1635_1524 =
					   class_num_218___object(let_fun_218_ast_node);
					{	/* ./Ast/node.scm 1094 */
					   obj_t obj_1531;
					   obj_1531 =
					      (obj_t) (new1358_1523);
					   (((obj_t) CREF(obj_1531))->header = MAKE_HEADER(arg1635_1524, 0), BUNSPEC);
					}
				     }
				     {	/* ./Ast/node.scm 1094 */
					object_bglt aux_1818;
					aux_1818 =
					   (object_bglt) (new1358_1523);
					OBJECT_WIDENING_SET(aux_1818, BFALSE);
				     }
				     ((((let_fun_218_bglt) CREF(new1358_1523))->loc) = ((obj_t) arg1600_955), BUNSPEC);
				     ((((let_fun_218_bglt) CREF(new1358_1523))->type) = ((type_bglt) type_1518), BUNSPEC);
				     ((((let_fun_218_bglt) CREF(new1358_1523))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
				     ((((let_fun_218_bglt) CREF(new1358_1523))->key) = ((obj_t) key_1520), BUNSPEC);
				     ((((let_fun_218_bglt) CREF(new1358_1523))->locals) = ((obj_t) added_948), BUNSPEC);
				     ((((let_fun_218_bglt) CREF(new1358_1523))->body) = ((node_bglt) body_1522), BUNSPEC);
				     res1769_1533 = new1358_1523;
				  }
			       }
			       new_body_215_953 = res1769_1533;
			    }
			 }
			 {	/* Integrate/let-fun.scm 87 */

			    {	/* Integrate/let-fun.scm 95 */
			       sfun_bglt obj_1535;
			       obj_t val1123_1536;
			       {	/* Integrate/let-fun.scm 95 */
				  value_bglt aux_1827;
				  {	/* Integrate/let-fun.scm 95 */
				     variable_bglt obj_1534;
				     obj_1534 =
					(variable_bglt) (var_3);
				     aux_1827 =
					(((variable_bglt) CREF(obj_1534))->value);
				  }
				  obj_1535 =
				     (sfun_bglt) (aux_1827);
			       }
			       val1123_1536 =
				  (obj_t) (new_body_215_953);
			       ((((sfun_bglt) CREF(obj_1535))->body) = ((obj_t) val1123_1536), BUNSPEC);
			    }
			    return
			       (obj_t) (new_body_215_953);
			 }
		      }
		   }
		 else
		   {	/* Integrate/let-fun.scm 85 */
		      return BUNSPEC;
		   }
	      }
	    else
	      {		/* Integrate/let-fun.scm 83 */
		 if (
		    free_fun__183_integrate_let_fun_158(
		       CAR(led_947)))
		   {	/* Integrate/let-fun.scm 97 */
		      {		/* Integrate/let-fun.scm 99 */
			 obj_t arg1607_962;
			 obj_t arg1608_963;
			 arg1607_962 =
			    CDR(led_947);
			 {	/* ./Ieee/pair-list.scm 5689 */
			    obj_t aux_1838;
			    aux_1838 =
			       CAR(led_947);
			    arg1608_963 =
			       MAKE_PAIR(aux_1838, added_948);
			 }
			 {
			    obj_t added_1842;
			    obj_t led_1841;
			    led_1841 = arg1607_962;
			    added_1842 = arg1608_963;
			    added_948 = added_1842;
			    led_947 = led_1841;
			    goto loop_949;
			 }
		      }
		   }
		 else
		   {	/* Integrate/let-fun.scm 97 */
		      {
			 obj_t led_1843;
			 led_1843 =
			    CDR(led_947);
			 led_947 = led_1843;
			 goto loop_949;
		      }
		   }
	      }
	 }
      }
   }
}



/* _displace-let-fun! */
obj_t 
_displace_let_fun__244_integrate_let_fun_158(obj_t env_1701, obj_t var_1702)
{
   AN_OBJECT;
   {	/* Integrate/let-fun.scm 49 */
      return
	 displace_let_fun__199_integrate_let_fun_158(var_1702);
   }
}



/* method-init */
obj_t 
method_init_76_integrate_let_fun_158()
{
   AN_OBJECT;
   {	/* Integrate/let-fun.scm 15 */
      add_generic__110___object(displace_let_fun_node__env_245_integrate_let_fun_158, displace_let_fun_node__default1538_env_170_integrate_let_fun_158);
      add_inlined_method__244___object(displace_let_fun_node__env_245_integrate_let_fun_158, atom_ast_node, ((long) 0));
      add_inlined_method__244___object(displace_let_fun_node__env_245_integrate_let_fun_158, kwote_ast_node, ((long) 1));
      add_inlined_method__244___object(displace_let_fun_node__env_245_integrate_let_fun_158, var_ast_node, ((long) 2));
      add_inlined_method__244___object(displace_let_fun_node__env_245_integrate_let_fun_158, closure_ast_node, ((long) 3));
      add_inlined_method__244___object(displace_let_fun_node__env_245_integrate_let_fun_158, sequence_ast_node, ((long) 4));
      add_inlined_method__244___object(displace_let_fun_node__env_245_integrate_let_fun_158, app_ast_node, ((long) 5));
      add_inlined_method__244___object(displace_let_fun_node__env_245_integrate_let_fun_158, app_ly_162_ast_node, ((long) 6));
      add_inlined_method__244___object(displace_let_fun_node__env_245_integrate_let_fun_158, funcall_ast_node, ((long) 7));
      add_inlined_method__244___object(displace_let_fun_node__env_245_integrate_let_fun_158, pragma_ast_node, ((long) 8));
      add_inlined_method__244___object(displace_let_fun_node__env_245_integrate_let_fun_158, cast_ast_node, ((long) 9));
      add_inlined_method__244___object(displace_let_fun_node__env_245_integrate_let_fun_158, setq_ast_node, ((long) 10));
      add_inlined_method__244___object(displace_let_fun_node__env_245_integrate_let_fun_158, conditional_ast_node, ((long) 11));
      add_inlined_method__244___object(displace_let_fun_node__env_245_integrate_let_fun_158, fail_ast_node, ((long) 12));
      add_inlined_method__244___object(displace_let_fun_node__env_245_integrate_let_fun_158, select_ast_node, ((long) 13));
      add_inlined_method__244___object(displace_let_fun_node__env_245_integrate_let_fun_158, let_fun_218_ast_node, ((long) 14));
      add_inlined_method__244___object(displace_let_fun_node__env_245_integrate_let_fun_158, let_var_6_ast_node, ((long) 15));
      add_inlined_method__244___object(displace_let_fun_node__env_245_integrate_let_fun_158, set_ex_it_116_ast_node, ((long) 16));
      add_inlined_method__244___object(displace_let_fun_node__env_245_integrate_let_fun_158, jump_ex_it_184_ast_node, ((long) 17));
      add_inlined_method__244___object(displace_let_fun_node__env_245_integrate_let_fun_158, make_box_202_ast_node, ((long) 18));
      add_inlined_method__244___object(displace_let_fun_node__env_245_integrate_let_fun_158, box_set__221_ast_node, ((long) 19));
      {		/* Integrate/let-fun.scm 15 */
	 long aux_1867;
	 aux_1867 =
	    add_inlined_method__244___object(displace_let_fun_node__env_245_integrate_let_fun_158, box_ref_242_ast_node, ((long) 20));
	 return
	    BINT(aux_1867);
      }
   }
}



/* displace-let-fun-node! */
obj_t 
displace_let_fun_node__83_integrate_let_fun_158(node_bglt node_4, variable_bglt variable_5)
{
   AN_OBJECT;
   {	/* Integrate/let-fun.scm 112 */
    displace_let_fun_node__83_integrate_let_fun_158:
      {
	 obj_t method1695_1344;
	 obj_t class1700_1345;
	 {	/* Integrate/let-fun.scm 112 */
	    obj_t arg1703_1342;
	    obj_t arg1704_1343;
	    {	/* Integrate/let-fun.scm 112 */
	       object_bglt obj_1608;
	       obj_1608 =
		  (object_bglt) (node_4);
	       {	/* ./Llib/object.scm 2926 */
		  obj_t pre_method_105_1609;
		  pre_method_105_1609 =
		     PROCEDURE_REF(displace_let_fun_node__env_245_integrate_let_fun_158, ((long) 2));
		  if (
		     INTEGERP(pre_method_105_1609))
		    {	/* ./Llib/object.scm 2927 */
		       PROCEDURE_SET(displace_let_fun_node__env_245_integrate_let_fun_158, ((long) 2), BUNSPEC);
		       arg1703_1342 = pre_method_105_1609;
		    }
		  else
		    {	/* ./Llib/object.scm 2914 */
		       long obj_class_num_177_1614;
		       obj_class_num_177_1614 =
			  TYPE(obj_1608);
		       {	/* ./Llib/object.scm 2915 */
			  obj_t arg1176_1615;
			  arg1176_1615 =
			     PROCEDURE_REF(displace_let_fun_node__env_245_integrate_let_fun_158, ((long) 1));
			  {	/* ./Llib/object.scm 2738 */
			     long arg1177_1619;
			     {	/* ./Llib/object.scm 2738 */
				long arg1178_1620;
				arg1178_1620 =
				   OBJECT_TYPE;
				arg1177_1619 =
				   (obj_class_num_177_1614 - arg1178_1620);
			     }
			     arg1703_1342 =
				VECTOR_REF(arg1176_1615, arg1177_1619);
			  }
		       }
		    }
	       }
	    }
	    {	/* Integrate/let-fun.scm 112 */
	       object_bglt object_1625;
	       object_1625 =
		  (object_bglt) (node_4);
	       {	/* ./Llib/object.scm 2695 */
		  long arg1179_1626;
		  {	/* ./Llib/object.scm 2695 */
		     long arg1180_1627;
		     long arg1181_1628;
		     arg1180_1627 =
			TYPE(object_1625);
		     arg1181_1628 =
			OBJECT_TYPE;
		     arg1179_1626 =
			(arg1180_1627 - arg1181_1628);
		  }
		  {	/* ./Llib/object.scm 2695 */
		     obj_t vector_1632;
		     vector_1632 = _classes__134___object;
		     arg1704_1343 =
			VECTOR_REF(vector_1632, arg1179_1626);
		  }
	       }
	    }
	    method1695_1344 = arg1703_1342;
	    class1700_1345 = arg1704_1343;
	    {

	       if (
		  INTEGERP(method1695_1344))
		 {	/* Integrate/let-fun.scm 112 */
		    switch (
		       (long) CINT(method1695_1344))
		      {
		      case ((long) 0):

			 return BUNSPEC;
			 break;
		      case ((long) 1):

			 return BUNSPEC;
			 break;
		      case ((long) 2):

			 return BUNSPEC;
			 break;
		      case ((long) 3):

			 {	/* Integrate/let-fun.scm 136 */
			    obj_t arg1709_1361;
			    {	/* Integrate/let-fun.scm 136 */
			       obj_t aux_1887;
			       {	/* Integrate/let-fun.scm 136 */
				  closure_bglt aux_1888;
				  aux_1888 =
				     (closure_bglt) (node_4);
				  aux_1887 =
				     (obj_t) (aux_1888);
			       }
			       arg1709_1361 =
				  shape_tools_shape(aux_1887);
			    }
			    return
			       internal_error_43_tools_error(string1772_integrate_let_fun_158, string1773_integrate_let_fun_158, arg1709_1361);
			 }
			 break;
		      case ((long) 4):

			 {	/* Integrate/let-fun.scm 142 */
			    sequence_bglt node_1362;
			    node_1362 =
			       (sequence_bglt) (node_4);
			    {
			       obj_t l1520_1365;
			       {	/* Integrate/let-fun.scm 143 */
				  bool_t aux_1894;
				  l1520_1365 =
				     (((sequence_bglt) CREF(node_1362))->nodes);
				lname1521_1366:
				  if (
				     PAIRP(l1520_1365))
				    {	/* Integrate/let-fun.scm 143 */
				       {	/* Integrate/let-fun.scm 143 */
					  node_bglt aux_1897;
					  {	/* Integrate/let-fun.scm 143 */
					     obj_t aux_1898;
					     aux_1898 =
						CAR(l1520_1365);
					     aux_1897 =
						(node_bglt) (aux_1898);
					  }
					  displace_let_fun_node__83_integrate_let_fun_158(aux_1897, variable_5);
				       }
				       {
					  obj_t l1520_1902;
					  l1520_1902 =
					     CDR(l1520_1365);
					  l1520_1365 = l1520_1902;
					  goto lname1521_1366;
				       }
				    }
				  else
				    {	/* Integrate/let-fun.scm 143 */
				       aux_1894 = ((bool_t) 1);
				    }
				  return
				     BBOOL(aux_1894);
			       }
			    }
			 }
			 break;
		      case ((long) 5):

			 {	/* Integrate/let-fun.scm 149 */
			    app_bglt node_1371;
			    node_1371 =
			       (app_bglt) (node_4);
			    {
			       obj_t args_1373;
			       args_1373 =
				  (((app_bglt) CREF(node_1371))->args);
			     liip_1374:
			       if (
				  NULLP(args_1373))
				 {	/* Integrate/let-fun.scm 150 */
				    return BUNSPEC;
				 }
			       else
				 {	/* Integrate/let-fun.scm 150 */
				    {	/* Integrate/let-fun.scm 153 */
				       node_bglt aux_1909;
				       {	/* Integrate/let-fun.scm 153 */
					  obj_t aux_1910;
					  aux_1910 =
					     CAR(args_1373);
					  aux_1909 =
					     (node_bglt) (aux_1910);
				       }
				       displace_let_fun_node__83_integrate_let_fun_158(aux_1909, variable_5);
				    }
				    {
				       obj_t args_1914;
				       args_1914 =
					  CDR(args_1373);
				       args_1373 = args_1914;
				       goto liip_1374;
				    }
				 }
			    }
			 }
			 break;
		      case ((long) 6):

			 {	/* Integrate/let-fun.scm 160 */
			    app_ly_162_bglt node_1379;
			    node_1379 =
			       (app_ly_162_bglt) (node_4);
			    displace_let_fun_node__83_integrate_let_fun_158(
			       (((app_ly_162_bglt) CREF(node_1379))->fun), variable_5);
			    {
			       node_bglt node_1920;
			       node_1920 =
				  (((app_ly_162_bglt) CREF(node_1379))->arg);
			       node_4 = node_1920;
			       goto displace_let_fun_node__83_integrate_let_fun_158;
			    }
			 }
			 break;
		      case ((long) 7):

			 {	/* Integrate/let-fun.scm 168 */
			    funcall_bglt node_1384;
			    node_1384 =
			       (funcall_bglt) (node_4);
			    {
			       obj_t asts_1387;
			       asts_1387 =
				  (((funcall_bglt) CREF(node_1384))->args);
			     liip_1388:
			       if (
				  NULLP(asts_1387))
				 {
				    node_bglt node_1925;
				    node_1925 =
				       (((funcall_bglt) CREF(node_1384))->fun);
				    node_4 = node_1925;
				    goto displace_let_fun_node__83_integrate_let_fun_158;
				 }
			       else
				 {	/* Integrate/let-fun.scm 170 */
				    {	/* Integrate/let-fun.scm 173 */
				       node_bglt aux_1927;
				       {	/* Integrate/let-fun.scm 173 */
					  obj_t aux_1928;
					  aux_1928 =
					     CAR(asts_1387);
					  aux_1927 =
					     (node_bglt) (aux_1928);
				       }
				       displace_let_fun_node__83_integrate_let_fun_158(aux_1927, variable_5);
				    }
				    {
				       obj_t asts_1932;
				       asts_1932 =
					  CDR(asts_1387);
				       asts_1387 = asts_1932;
				       goto liip_1388;
				    }
				 }
			    }
			 }
			 break;
		      case ((long) 8):

			 {	/* Integrate/let-fun.scm 180 */
			    pragma_bglt node_1394;
			    node_1394 =
			       (pragma_bglt) (node_4);
			    {
			       obj_t l1525_1397;
			       {	/* Integrate/let-fun.scm 181 */
				  bool_t aux_1936;
				  l1525_1397 =
				     (((pragma_bglt) CREF(node_1394))->args);
				lname1526_1398:
				  if (
				     PAIRP(l1525_1397))
				    {	/* Integrate/let-fun.scm 181 */
				       {	/* Integrate/let-fun.scm 181 */
					  node_bglt aux_1939;
					  {	/* Integrate/let-fun.scm 181 */
					     obj_t aux_1940;
					     aux_1940 =
						CAR(l1525_1397);
					     aux_1939 =
						(node_bglt) (aux_1940);
					  }
					  displace_let_fun_node__83_integrate_let_fun_158(aux_1939, variable_5);
				       }
				       {
					  obj_t l1525_1944;
					  l1525_1944 =
					     CDR(l1525_1397);
					  l1525_1397 = l1525_1944;
					  goto lname1526_1398;
				       }
				    }
				  else
				    {	/* Integrate/let-fun.scm 181 */
				       aux_1936 = ((bool_t) 1);
				    }
				  return
				     BBOOL(aux_1936);
			       }
			    }
			 }
			 break;
		      case ((long) 9):

			 {	/* Integrate/let-fun.scm 187 */
			    cast_bglt node_1403;
			    node_1403 =
			       (cast_bglt) (node_4);
			    {
			       node_bglt node_1949;
			       node_1949 =
				  (((cast_bglt) CREF(node_1403))->arg);
			       node_4 = node_1949;
			       goto displace_let_fun_node__83_integrate_let_fun_158;
			    }
			 }
			 break;
		      case ((long) 10):

			 {	/* Integrate/let-fun.scm 194 */
			    setq_bglt node_1407;
			    node_1407 =
			       (setq_bglt) (node_4);
			    {
			       node_bglt node_1952;
			       node_1952 =
				  (((setq_bglt) CREF(node_1407))->value);
			       node_4 = node_1952;
			       goto displace_let_fun_node__83_integrate_let_fun_158;
			    }
			 }
			 break;
		      case ((long) 11):

			 {	/* Integrate/let-fun.scm 201 */
			    conditional_bglt node_1411;
			    node_1411 =
			       (conditional_bglt) (node_4);
			    displace_let_fun_node__83_integrate_let_fun_158(
			       (((conditional_bglt) CREF(node_1411))->test), variable_5);
			    displace_let_fun_node__83_integrate_let_fun_158(
			       (((conditional_bglt) CREF(node_1411))->true), variable_5);
			    {
			       node_bglt node_1959;
			       node_1959 =
				  (((conditional_bglt) CREF(node_1411))->false);
			       node_4 = node_1959;
			       goto displace_let_fun_node__83_integrate_let_fun_158;
			    }
			 }
			 break;
		      case ((long) 12):

			 {	/* Integrate/let-fun.scm 210 */
			    fail_bglt node_1417;
			    node_1417 =
			       (fail_bglt) (node_4);
			    displace_let_fun_node__83_integrate_let_fun_158(
			       (((fail_bglt) CREF(node_1417))->proc), variable_5);
			    displace_let_fun_node__83_integrate_let_fun_158(
			       (((fail_bglt) CREF(node_1417))->msg), variable_5);
			    {
			       node_bglt node_1966;
			       node_1966 =
				  (((fail_bglt) CREF(node_1417))->obj);
			       node_4 = node_1966;
			       goto displace_let_fun_node__83_integrate_let_fun_158;
			    }
			 }
			 break;
		      case ((long) 13):

			 {	/* Integrate/let-fun.scm 219 */
			    select_bglt node_1423;
			    node_1423 =
			       (select_bglt) (node_4);
			    {
			       obj_t clauses_1426;
			       clauses_1426 =
				  (((select_bglt) CREF(node_1423))->clauses);
			     liip_1427:
			       if (
				  NULLP(clauses_1426))
				 {
				    node_bglt node_1971;
				    node_1971 =
				       (((select_bglt) CREF(node_1423))->test);
				    node_4 = node_1971;
				    goto displace_let_fun_node__83_integrate_let_fun_158;
				 }
			       else
				 {	/* Integrate/let-fun.scm 221 */
				    {	/* Integrate/let-fun.scm 224 */
				       node_bglt aux_1973;
				       {	/* Integrate/let-fun.scm 224 */
					  obj_t aux_1974;
					  {	/* ./Ieee/pair-list.scm 5707 */
					     obj_t aux_1975;
					     aux_1975 =
						CAR(clauses_1426);
					     aux_1974 =
						CDR(aux_1975);
					  }
					  aux_1973 =
					     (node_bglt) (aux_1974);
				       }
				       displace_let_fun_node__83_integrate_let_fun_158(aux_1973, variable_5);
				    }
				    {
				       obj_t clauses_1980;
				       clauses_1980 =
					  CDR(clauses_1426);
				       clauses_1426 = clauses_1980;
				       goto liip_1427;
				    }
				 }
			    }
			 }
			 break;
		      case ((long) 14):

			 {	/* Integrate/let-fun.scm 112 */
			    let_fun_218_bglt node_1434;
			    node_1434 =
			       (let_fun_218_bglt) (node_4);
			    {
			       obj_t old_1437;
			       obj_t new_1438;
			       old_1437 =
				  (((let_fun_218_bglt) CREF(node_1434))->locals);
			       new_1438 = BNIL;
			     liip_1439:
			       if (
				  NULLP(old_1437))
				 {	/* Integrate/let-fun.scm 245 */
				    ((((let_fun_218_bglt) CREF(node_1434))->locals) = ((obj_t) new_1438), BUNSPEC);
				    {
				       node_bglt node_1987;
				       node_1987 =
					  (((let_fun_218_bglt) CREF(node_1434))->body);
				       node_4 = node_1987;
				       goto displace_let_fun_node__83_integrate_let_fun_158;
				    }
				 }
			       else
				 {	/* Integrate/let-fun.scm 248 */
				    bool_t test_1989;
				    {	/* ./Ieee/equiv.scm 5508 */
				       obj_t aux_2002;
				       obj_t aux_1990;
				       aux_2002 =
					  (obj_t) (variable_5);
				       {	/* Integrate/let-fun.scm 248 */
					  sfun_iinfo_105_bglt obj_1675;
					  {	/* Integrate/let-fun.scm 248 */
					     value_bglt aux_1991;
					     {	/* Integrate/let-fun.scm 248 */
						local_bglt obj_1674;
						{	/* Integrate/let-fun.scm 248 */
						   obj_t aux_1992;
						   aux_1992 =
						      CAR(old_1437);
						   obj_1674 =
						      (local_bglt) (aux_1992);
						}
						aux_1991 =
						   (((local_bglt) CREF(obj_1674))->value);
					     }
					     obj_1675 =
						(sfun_iinfo_105_bglt) (aux_1991);
					  }
					  {
					     obj_t aux_1997;
					     {	/* ./Integrate/iinfo.scm 1204 */
						object_bglt aux_1998;
						aux_1998 =
						   (object_bglt) (obj_1675);
						aux_1997 =
						   OBJECT_WIDENING(aux_1998);
					     }
					     aux_1990 =
						(((sfun_iinfo_105_bglt) CREF(aux_1997))->l);
					  }
				       }
				       test_1989 =
					  (aux_1990 == aux_2002);
				    }
				    if (test_1989)
				      {		/* Integrate/let-fun.scm 248 */
					 {	/* Integrate/let-fun.scm 249 */
					    obj_t l_1446;
					    l_1446 =
					       CAR(old_1437);
					    bind_fun__68_integrate_let_fun_158(l_1446);
					    {	/* Integrate/let-fun.scm 251 */
					       node_bglt aux_2007;
					       {	/* Integrate/let-fun.scm 251 */
						  obj_t aux_2008;
						  {	/* Integrate/let-fun.scm 251 */
						     sfun_bglt obj_1680;
						     {	/* Integrate/let-fun.scm 251 */
							value_bglt aux_2009;
							{	/* Integrate/let-fun.scm 251 */
							   local_bglt obj_1679;
							   obj_1679 =
							      (local_bglt) (l_1446);
							   aux_2009 =
							      (((local_bglt) CREF(obj_1679))->value);
							}
							obj_1680 =
							   (sfun_bglt) (aux_2009);
						     }
						     aux_2008 =
							(((sfun_bglt) CREF(obj_1680))->body);
						  }
						  aux_2007 =
						     (node_bglt) (aux_2008);
					       }
					       displace_let_fun_node__83_integrate_let_fun_158(aux_2007, variable_5);
					    }
					    {	/* Integrate/let-fun.scm 252 */
					       obj_t arg1750_1449;
					       obj_t arg1751_1450;
					       arg1750_1449 =
						  CDR(old_1437);
					       arg1751_1450 =
						  MAKE_PAIR(l_1446, new_1438);
					       {
						  obj_t new_2019;
						  obj_t old_2018;
						  old_2018 = arg1750_1449;
						  new_2019 = arg1751_1450;
						  new_1438 = new_2019;
						  old_1437 = old_2018;
						  goto liip_1439;
					       }
					    }
					 }
				      }
				    else
				      {		/* Integrate/let-fun.scm 248 */
					 {
					    obj_t old_2020;
					    old_2020 =
					       CDR(old_1437);
					    old_1437 = old_2020;
					    goto liip_1439;
					 }
				      }
				 }
			    }
			 }
			 break;
		      case ((long) 15):

			 {	/* Integrate/let-fun.scm 260 */
			    let_var_6_bglt node_1455;
			    node_1455 =
			       (let_var_6_bglt) (node_4);
			    {
			       obj_t bindings_1458;
			       bindings_1458 =
				  (((let_var_6_bglt) CREF(node_1455))->bindings);
			     liip_1459:
			       if (
				  NULLP(bindings_1458))
				 {
				    node_bglt node_2026;
				    node_2026 =
				       (((let_var_6_bglt) CREF(node_1455))->body);
				    node_4 = node_2026;
				    goto displace_let_fun_node__83_integrate_let_fun_158;
				 }
			       else
				 {	/* Integrate/let-fun.scm 266 */

				    {	/* Integrate/let-fun.scm 267 */
				       node_bglt aux_2028;
				       {	/* Integrate/let-fun.scm 267 */
					  obj_t aux_2029;
					  {	/* ./Ieee/pair-list.scm 5707 */
					     obj_t aux_2030;
					     aux_2030 =
						CAR(bindings_1458);
					     aux_2029 =
						CDR(aux_2030);
					  }
					  aux_2028 =
					     (node_bglt) (aux_2029);
				       }
				       displace_let_fun_node__83_integrate_let_fun_158(aux_2028, variable_5);
				    }
				    {
				       obj_t bindings_2035;
				       bindings_2035 =
					  CDR(bindings_1458);
				       bindings_1458 = bindings_2035;
				       goto liip_1459;
				    }
				 }
			    }
			 }
			 break;
		      case ((long) 16):

			 {	/* Integrate/let-fun.scm 274 */
			    set_ex_it_116_bglt node_1467;
			    node_1467 =
			       (set_ex_it_116_bglt) (node_4);
			    {
			       node_bglt node_2039;
			       node_2039 =
				  (((set_ex_it_116_bglt) CREF(node_1467))->body);
			       node_4 = node_2039;
			       goto displace_let_fun_node__83_integrate_let_fun_158;
			    }
			 }
			 break;
		      case ((long) 17):

			 {	/* Integrate/let-fun.scm 281 */
			    jump_ex_it_184_bglt node_1471;
			    node_1471 =
			       (jump_ex_it_184_bglt) (node_4);
			    displace_let_fun_node__83_integrate_let_fun_158(
			       (((jump_ex_it_184_bglt) CREF(node_1471))->exit), variable_5);
			    {
			       node_bglt node_2044;
			       node_2044 =
				  (((jump_ex_it_184_bglt) CREF(node_1471))->value);
			       node_4 = node_2044;
			       goto displace_let_fun_node__83_integrate_let_fun_158;
			    }
			 }
			 break;
		      case ((long) 18):

			 {	/* Integrate/let-fun.scm 289 */
			    make_box_202_bglt node_1476;
			    node_1476 =
			       (make_box_202_bglt) (node_4);
			    {
			       node_bglt node_2047;
			       node_2047 =
				  (((make_box_202_bglt) CREF(node_1476))->value);
			       node_4 = node_2047;
			       goto displace_let_fun_node__83_integrate_let_fun_158;
			    }
			 }
			 break;
		      case ((long) 19):

			 return BUNSPEC;
			 break;
		      case ((long) 20):

			 return BUNSPEC;
			 break;
		      default:
		       case_else1701_1348:
			 if (
			    PROCEDUREP(method1695_1344))
			   {	/* Integrate/let-fun.scm 112 */
			      return
				 PROCEDURE_ENTRY(method1695_1344) (method1695_1344,
				 (obj_t) (node_4),
				 (obj_t) (variable_5), BEOA);
			   }
			 else
			   {	/* Integrate/let-fun.scm 112 */
			      obj_t fun1694_1340;
			      fun1694_1340 =
				 PROCEDURE_REF(displace_let_fun_node__env_245_integrate_let_fun_158, ((long) 0));
			      return
				 PROCEDURE_ENTRY(fun1694_1340) (fun1694_1340,
				 (obj_t) (node_4),
				 (obj_t) (variable_5), BEOA);
			   }
		      }
		 }
	       else
		 {	/* Integrate/let-fun.scm 112 */
		    goto case_else1701_1348;
		 }
	    }
	 }
      }
   }
}



/* _displace-let-fun-node!1771 */
obj_t 
_displace_let_fun_node_1771_7_integrate_let_fun_158(obj_t env_1703, obj_t node_1704, obj_t variable_1705)
{
   AN_OBJECT;
   {	/* Integrate/let-fun.scm 112 */
      return
	 displace_let_fun_node__83_integrate_let_fun_158(
	 (node_bglt) (node_1704),
	 (variable_bglt) (variable_1705));
   }
}



/* displace-let-fun-node!-default1538 */
obj_t 
displace_let_fun_node__default1538_40_integrate_let_fun_158(node_bglt node_6, variable_bglt variable_7)
{
   AN_OBJECT;
   {	/* Integrate/let-fun.scm 15 */
      FAILURE(
	 CNST_TABLE_REF(((long) 0)), string1774_integrate_let_fun_158,
	 (obj_t) (node_6));
   }
}



/* _displace-let-fun-node!-default1538 */
obj_t 
_displace_let_fun_node__default1538_48_integrate_let_fun_158(obj_t env_1706, obj_t node_1707, obj_t variable_1708)
{
   AN_OBJECT;
   {	/* Integrate/let-fun.scm 15 */
      return
	 displace_let_fun_node__default1538_40_integrate_let_fun_158(
	 (node_bglt) (node_1707),
	 (variable_bglt) (variable_1708));
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_integrate_let_fun_158()
{
   AN_OBJECT;
   {	/* Integrate/let-fun.scm 15 */
      module_initialization_70_tools_trace(((long) 0), "INTEGRATE_LET-FUN");
      module_initialization_70_tools_shape(((long) 0), "INTEGRATE_LET-FUN");
      module_initialization_70_tools_error(((long) 0), "INTEGRATE_LET-FUN");
      module_initialization_70_type_type(((long) 0), "INTEGRATE_LET-FUN");
      module_initialization_70_type_cache(((long) 0), "INTEGRATE_LET-FUN");
      module_initialization_70_ast_var(((long) 0), "INTEGRATE_LET-FUN");
      module_initialization_70_ast_node(((long) 0), "INTEGRATE_LET-FUN");
      return
	 module_initialization_70_integrate_info(((long) 0), "INTEGRATE_LET-FUN");
   }
}
