/*===========================================================================*/
/*   (Integrate/loc2glo.scm)                                                 */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct ccomp
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t producer;
     obj_t consumer;
     obj_t finalizer;
     obj_t checksummer;
  }
     *ccomp_bglt;

typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;

typedef struct svar_iinfo_76
  {
     obj_t f_mark_181;
     obj_t u_mark_209;
     bool_t kaptured__204;
     bool_t celled__113;
  }
             *svar_iinfo_76_bglt;

typedef struct sexit_iinfo_190
  {
     obj_t f_mark_181;
     obj_t u_mark_209;
     bool_t kaptured__204;
     bool_t celled__113;
  }
               *sexit_iinfo_190_bglt;

typedef struct sfun_iinfo_105
  {
     obj_t owner;
     obj_t free;
     obj_t bound;
     obj_t cfrom;
     obj_t cto;
     obj_t k;
     obj_t k__190;
     obj_t u;
     obj_t cn;
     obj_t ct;
     obj_t kont;
     bool_t g__219;
     obj_t l;
     obj_t led;
     obj_t istamp;
     obj_t global;
     obj_t kaptured;
  }
              *sfun_iinfo_105_bglt;


static obj_t method_init_76_integrate_local__global_163();
extern obj_t string_to_symbol(char *);
extern obj_t find_global_module_25_ast_env(obj_t, obj_t);
extern obj_t symbol_append_197___r4_symbols_6_4(obj_t);
static obj_t _the_global1699_138_integrate_local__global_163(obj_t, obj_t);
extern obj_t global_ast_var;
static obj_t _local__global1698_140_integrate_local__global_163(obj_t, obj_t);
extern obj_t _obj__252_type_cache;
extern local_bglt clone_local_230_ast_local(local_bglt, value_bglt);
extern obj_t globalize__167_integrate_node(node_bglt, variable_bglt, obj_t);
extern obj_t reverse___r4_pairs_and_lists_6_3(obj_t);
extern bool_t integrate_celled__59_integrate_node(local_bglt);
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t module_initialization_70_integrate_local__global_163(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_args(long, char *);
extern obj_t module_initialization_70_module_module(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_ast_glo_def_117(long, char *);
extern obj_t module_initialization_70_ast_env(long, char *);
extern obj_t module_initialization_70_ast_local(long, char *);
extern obj_t module_initialization_70_integrate_info(long, char *);
extern obj_t module_initialization_70_integrate_node(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_symbols_6_4(long, char *);
extern obj_t svar_iinfo_76_integrate_info;
extern long list_length(obj_t);
extern long class_num_218___object(obj_t);
extern obj_t svar_ast_var;
extern obj_t local__global_40_integrate_local__global_163(local_bglt);
static obj_t imported_modules_init_94_integrate_local__global_163();
extern obj_t append_2_18___r4_pairs_and_lists_6_3(obj_t, obj_t);
static obj_t library_modules_init_112_integrate_local__global_163();
static obj_t toplevel_init_63_integrate_local__global_163();
extern obj_t open_input_string(obj_t);
extern obj_t sfun_ast_var;
extern obj_t the_global_201_integrate_local__global_163(local_bglt);
extern global_bglt def_global_sfun_no_warning__10_ast_glo_def_117(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t local_id__global_id_246_integrate_local__global_163(local_bglt);
static obj_t symbol_quote_158_integrate_local__global_163 = BUNSPEC;
extern obj_t __arity_132_tools_args(obj_t, obj_t);
extern obj_t _module__166_module_module;
extern obj_t read___reader(obj_t);
static obj_t require_initialization_114_integrate_local__global_163 = BUNSPEC;
static obj_t cnst_init_137_integrate_local__global_163();
static obj_t __cnst[3];

DEFINE_EXPORT_PROCEDURE(local__global_env_170_integrate_local__global_163, _local__global1698_140_integrate_local__global_1631706, _local__global1698_140_integrate_local__global_163, 0L, 1);
DEFINE_EXPORT_PROCEDURE(the_global_env_148_integrate_local__global_163, _the_global1699_138_integrate_local__global_1631707, _the_global1699_138_integrate_local__global_163, 0L, 1);
DEFINE_STRING(string1701_integrate_local__global_163, string1701_integrate_local__global_1631708, "NOW A-INTEGRATED-BODY SFUN ", 27);
DEFINE_STRING(string1700_integrate_local__global_163, string1700_integrate_local__global_1631709, "'", 1);



/* module-initialization */
obj_t 
module_initialization_70_integrate_local__global_163(long checksum_1607, char *from_1608)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_integrate_local__global_163))
	{
	   require_initialization_114_integrate_local__global_163 =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_integrate_local__global_163();
	   cnst_init_137_integrate_local__global_163();
	   imported_modules_init_94_integrate_local__global_163();
	   method_init_76_integrate_local__global_163();
	   toplevel_init_63_integrate_local__global_163();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_integrate_local__global_163()
{
   AN_OBJECT;
   {	/* Integrate/loc2glo.scm 14 */
      module_initialization_70___r4_symbols_6_4(((long) 0), "INTEGRATE_LOCAL->GLOBAL");
      module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "INTEGRATE_LOCAL->GLOBAL");
      module_initialization_70___object(((long) 0), "INTEGRATE_LOCAL->GLOBAL");
      module_initialization_70___reader(((long) 0), "INTEGRATE_LOCAL->GLOBAL");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_integrate_local__global_163()
{
   AN_OBJECT;
   {	/* Integrate/loc2glo.scm 14 */
      {		/* Integrate/loc2glo.scm 14 */
	 obj_t cnst_port_138_1600;
	 cnst_port_138_1600 =
	    open_input_string(string1701_integrate_local__global_163);
	 {
	    long i_1601;
	    i_1601 = ((long) 2);
	  loop_1602:
	    {	/* Integrate/loc2glo.scm 14 */
	       bool_t test1702_1603;
	       test1702_1603 =
		  (i_1601 == ((long) -1));
	       if (test1702_1603)
		 {	/* Integrate/loc2glo.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Integrate/loc2glo.scm 14 */
		    {	/* Integrate/loc2glo.scm 14 */
		       obj_t arg1703_1604;
		       {	/* Integrate/loc2glo.scm 14 */
			  obj_t list1704_1605;
			  list1704_1605 =
			     MAKE_PAIR(cnst_port_138_1600, BNIL);
			  arg1703_1604 =
			     read___reader(list1704_1605);
		       }
		       CNST_TABLE_SET(i_1601, arg1703_1604);
		    }
		    {	/* Integrate/loc2glo.scm 14 */
		       int aux_1606;
		       {	/* Integrate/loc2glo.scm 14 */
			  long aux_1627;
			  aux_1627 =
			     (i_1601 - ((long) 1));
			  aux_1606 =
			     (int) (aux_1627);
		       }
		       {
			  long i_1630;
			  i_1630 =
			     (long) (aux_1606);
			  i_1601 = i_1630;
			  goto loop_1602;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_integrate_local__global_163()
{
   AN_OBJECT;
   {	/* Integrate/loc2glo.scm 14 */
      {		/* ./Ieee/symbol.scm 6027 */
	 char *aux_1632;
	 aux_1632 =
	    BSTRING_TO_STRING(string1700_integrate_local__global_163);
	 return (
	    symbol_quote_158_integrate_local__global_163 =
	    string_to_symbol(aux_1632), BUNSPEC);
      }
   }
}



/* local->global */
obj_t 
local__global_40_integrate_local__global_163(local_bglt local_1)
{
   AN_OBJECT;
   {	/* Integrate/loc2glo.scm 34 */
      {		/* Integrate/loc2glo.scm 36 */
	 obj_t global_896;
	 global_896 =
	    the_global_201_integrate_local__global_163(local_1);
	 {	/* Integrate/loc2glo.scm 36 */
	    obj_t kaptured_897;
	    {	/* Integrate/loc2glo.scm 37 */
	       sfun_iinfo_105_bglt obj_1375;
	       {	/* Integrate/loc2glo.scm 37 */
		  value_bglt aux_1636;
		  aux_1636 =
		     (((local_bglt) CREF(local_1))->value);
		  obj_1375 =
		     (sfun_iinfo_105_bglt) (aux_1636);
	       }
	       {
		  obj_t aux_1639;
		  {	/* ./Integrate/iinfo.scm 1235 */
		     object_bglt aux_1640;
		     aux_1640 =
			(object_bglt) (obj_1375);
		     aux_1639 =
			OBJECT_WIDENING(aux_1640);
		  }
		  kaptured_897 =
		     (((sfun_iinfo_105_bglt) CREF(aux_1639))->kaptured);
	       }
	    }
	    {	/* Integrate/loc2glo.scm 37 */
	       obj_t add_args_4_898;
	       if (
		  NULLP(kaptured_897))
		 {	/* Integrate/loc2glo.scm 38 */
		    add_args_4_898 = BNIL;
		 }
	       else
		 {	/* Integrate/loc2glo.scm 38 */
		    obj_t head1526_954;
		    head1526_954 =
		       MAKE_PAIR(BNIL, BNIL);
		    {
		       obj_t l1524_955;
		       obj_t tail1527_956;
		       l1524_955 = kaptured_897;
		       tail1527_956 = head1526_954;
		     lname1525_957:
		       if (
			  NULLP(l1524_955))
			 {	/* Integrate/loc2glo.scm 38 */
			    add_args_4_898 =
			       CDR(head1526_954);
			 }
		       else
			 {	/* Integrate/loc2glo.scm 39 */
			    obj_t newtail1528_959;
			    {	/* Integrate/loc2glo.scm 39 */
			       local_bglt arg1587_961;
			       {	/* Integrate/loc2glo.scm 39 */
				  obj_t old_963;
				  old_963 =
				     CAR(l1524_955);
				  {	/* Integrate/loc2glo.scm 40 */
				     svar_iinfo_76_bglt arg1589_964;
				     {	/* Integrate/loc2glo.scm 40 */
					svar_iinfo_76_bglt duplicated1529_965;
					{	/* Integrate/loc2glo.scm 41 */
					   local_bglt obj_1382;
					   obj_1382 =
					      (local_bglt) (old_963);
					   {	/* ./Ast/var.scm 778 */
					      value_bglt aux_1652;
					      aux_1652 =
						 (((local_bglt) CREF(obj_1382))->value);
					      duplicated1529_965 =
						 (svar_iinfo_76_bglt) (aux_1652);
					   }
					}
					{	/* Integrate/loc2glo.scm 40 */
					   svar_iinfo_76_bglt new1530_966;
					   {	/* Integrate/loc2glo.scm 40 */
					      obj_t arg1590_967;
					      obj_t arg1591_968;
					      obj_t arg1592_969;
					      bool_t arg1593_970;
					      bool_t arg1594_971;
					      {		/* Integrate/loc2glo.scm 40 */
						 svar_bglt obj_1383;
						 obj_1383 =
						    (svar_bglt) (duplicated1529_965);
						 arg1590_967 =
						    (((svar_bglt) CREF(obj_1383))->loc);
					      }
					      {
						 obj_t aux_1657;
						 {	/* ./Integrate/iinfo.scm 1183 */
						    object_bglt aux_1658;
						    aux_1658 =
						       (object_bglt) (duplicated1529_965);
						    aux_1657 =
						       OBJECT_WIDENING(aux_1658);
						 }
						 arg1591_968 =
						    (((svar_iinfo_76_bglt) CREF(aux_1657))->f_mark_181);
					      }
					      {
						 obj_t aux_1662;
						 {	/* ./Integrate/iinfo.scm 1185 */
						    object_bglt aux_1663;
						    aux_1663 =
						       (object_bglt) (duplicated1529_965);
						    aux_1662 =
						       OBJECT_WIDENING(aux_1663);
						 }
						 arg1592_969 =
						    (((svar_iinfo_76_bglt) CREF(aux_1662))->u_mark_209);
					      }
					      {
						 obj_t aux_1667;
						 {	/* ./Integrate/iinfo.scm 1187 */
						    object_bglt aux_1668;
						    aux_1668 =
						       (object_bglt) (duplicated1529_965);
						    aux_1667 =
						       OBJECT_WIDENING(aux_1668);
						 }
						 arg1593_970 =
						    (((svar_iinfo_76_bglt) CREF(aux_1667))->kaptured__204);
					      }
					      {
						 obj_t aux_1672;
						 {	/* ./Integrate/iinfo.scm 1189 */
						    object_bglt aux_1673;
						    aux_1673 =
						       (object_bglt) (duplicated1529_965);
						    aux_1672 =
						       OBJECT_WIDENING(aux_1673);
						 }
						 arg1594_971 =
						    (((svar_iinfo_76_bglt) CREF(aux_1672))->celled__113);
					      }
					      {		/* Integrate/loc2glo.scm 40 */
						 svar_iinfo_76_bglt res1694_1416;
						 {	/* ./Integrate/iinfo.scm 1181 */
						    svar_bglt aux1456_1393;
						    {	/* ./Integrate/iinfo.scm 1181 */
						       svar_bglt res1692_1403;
						       {	/* ./Ast/var.scm 827 */
							  svar_bglt new1169_1398;
							  new1169_1398 =
							     ((svar_bglt) BREF(GC_MALLOC(sizeof(struct svar))));
							  {	/* ./Ast/var.scm 827 */
							     long arg1673_1399;
							     arg1673_1399 =
								class_num_218___object(svar_ast_var);
							     {	/* ./Ast/var.scm 827 */
								obj_t obj_1401;
								obj_1401 =
								   (obj_t) (new1169_1398);
								(((obj_t) CREF(obj_1401))->header = MAKE_HEADER(arg1673_1399, 0), BUNSPEC);
							     }
							  }
							  {	/* ./Ast/var.scm 827 */
							     object_bglt aux_1681;
							     aux_1681 =
								(object_bglt) (new1169_1398);
							     OBJECT_WIDENING_SET(aux_1681, BFALSE);
							  }
							  ((((svar_bglt) CREF(new1169_1398))->loc) = ((obj_t) arg1590_967), BUNSPEC);
							  res1692_1403 = new1169_1398;
						       }
						       aux1456_1393 = res1692_1403;
						    }
						    {	/* ./Integrate/iinfo.scm 1181 */
						       svar_iinfo_76_bglt new1457_1394;
						       new1457_1394 =
							  ((svar_iinfo_76_bglt) (aux1456_1393));
						       {	/* ./Integrate/iinfo.scm 1181 */
							  long arg1616_1395;
							  arg1616_1395 =
							     class_num_218___object(svar_iinfo_76_integrate_info);
							  {	/* ./Integrate/iinfo.scm 1181 */
							     obj_t obj_1404;
							     obj_1404 =
								(obj_t) (new1457_1394);
							     (((obj_t) CREF(obj_1404))->header = MAKE_HEADER(arg1616_1395, 0), BUNSPEC);
							  }
						       }
						       {	/* ./Integrate/iinfo.scm 1181 */
							  svar_iinfo_76_bglt arg1617_1396;
							  {	/* ./Integrate/iinfo.scm 1181 */
							     svar_iinfo_76_bglt res1693_1415;
							     {	/* ./Integrate/iinfo.scm 1181 */
								svar_iinfo_76_bglt new1450_1410;
								new1450_1410 =
								   ((svar_iinfo_76_bglt) BREF(GC_MALLOC(sizeof(struct svar_iinfo_76))));
								((((svar_iinfo_76_bglt) CREF(new1450_1410))->f_mark_181) = ((obj_t) arg1591_968), BUNSPEC);
								((((svar_iinfo_76_bglt) CREF(new1450_1410))->u_mark_209) = ((obj_t) arg1592_969), BUNSPEC);
								((((svar_iinfo_76_bglt) CREF(new1450_1410))->kaptured__204) = ((bool_t) arg1593_970), BUNSPEC);
								((((svar_iinfo_76_bglt) CREF(new1450_1410))->celled__113) = ((bool_t) arg1594_971), BUNSPEC);
								res1693_1415 = new1450_1410;
							     }
							     arg1617_1396 = res1693_1415;
							  }
							  {	/* ./Integrate/iinfo.scm 1181 */
							     obj_t aux_1696;
							     object_bglt aux_1694;
							     aux_1696 =
								(obj_t) (arg1617_1396);
							     aux_1694 =
								(object_bglt) (new1457_1394);
							     OBJECT_WIDENING_SET(aux_1694, aux_1696);
							  }
						       }
						       res1694_1416 = new1457_1394;
						    }
						 }
						 new1530_966 = res1694_1416;
					      }
					   }
					   {	/* Integrate/loc2glo.scm 40 */

					      arg1589_964 = new1530_966;
					   }
					}
				     }
				     arg1587_961 =
					clone_local_230_ast_local(
					(local_bglt) (old_963),
					(value_bglt) (arg1589_964));
				  }
			       }
			       {	/* ./Ieee/pair-list.scm 5689 */
				  obj_t aux_1702;
				  aux_1702 =
				     (obj_t) (arg1587_961);
				  newtail1528_959 =
				     MAKE_PAIR(aux_1702, BNIL);
			       }
			    }
			    SET_CDR(tail1527_956, newtail1528_959);
			    {
			       obj_t tail1527_1708;
			       obj_t l1524_1706;
			       l1524_1706 =
				  CDR(l1524_955);
			       tail1527_1708 = newtail1528_959;
			       tail1527_956 = tail1527_1708;
			       l1524_955 = l1524_1706;
			       goto lname1525_957;
			    }
			 }
		    }
		 }
	       {	/* Integrate/loc2glo.scm 38 */
		  value_bglt old_fun_147_899;
		  old_fun_147_899 =
		     (((local_bglt) CREF(local_1))->value);
		  {	/* Integrate/loc2glo.scm 43 */
		     sfun_bglt new_fun_115_900;
		     {	/* Integrate/loc2glo.scm 44 */
			sfun_bglt duplicated1531_934;
			duplicated1531_934 =
			   (sfun_bglt) (old_fun_147_899);
			{	/* Integrate/loc2glo.scm 45 */
			   sfun_bglt new1532_935;
			   {	/* Integrate/loc2glo.scm 45 */
			      obj_t arg1565_936;
			      obj_t arg1566_937;
			      obj_t arg1567_938;
			      obj_t arg1568_939;
			      bool_t arg1569_940;
			      obj_t arg1571_941;
			      obj_t arg1572_942;
			      obj_t arg1573_943;
			      obj_t arg1576_944;
			      obj_t arg1577_945;
			      obj_t arg1578_946;
			      obj_t arg1579_947;
			      {		/* Integrate/loc2glo.scm 45 */
				 obj_t aux_1715;
				 obj_t aux_1711;
				 {	/* Integrate/loc2glo.scm 45 */
				    long aux_1716;
				    aux_1716 =
				       list_length(add_args_4_898);
				    aux_1715 =
				       BINT(aux_1716);
				 }
				 {	/* Integrate/loc2glo.scm 45 */
				    long aux_1712;
				    aux_1712 =
				       (((sfun_bglt) CREF(duplicated1531_934))->arity);
				    aux_1711 =
				       BINT(aux_1712);
				 }
				 arg1565_936 =
				    __arity_132_tools_args(aux_1711, aux_1715);
			      }
			      arg1566_937 =
				 (((sfun_bglt) CREF(duplicated1531_934))->side_effect__165);
			      arg1567_938 =
				 (((sfun_bglt) CREF(duplicated1531_934))->predicate_of_78);
			      arg1568_939 =
				 (((sfun_bglt) CREF(duplicated1531_934))->stack_allocator_172);
			      arg1569_940 =
				 (((sfun_bglt) CREF(duplicated1531_934))->top__138);
			      arg1571_941 =
				 (((sfun_bglt) CREF(duplicated1531_934))->the_closure_238);
			      arg1572_942 =
				 (((sfun_bglt) CREF(duplicated1531_934))->property);
			      arg1573_943 =
				 append_2_18___r4_pairs_and_lists_6_3(
				 reverse___r4_pairs_and_lists_6_3(add_args_4_898),
				 (((sfun_bglt) CREF(duplicated1531_934))->args));
			      arg1576_944 =
				 (((sfun_bglt) CREF(duplicated1531_934))->body);
			      arg1577_945 =
				 (((sfun_bglt) CREF(duplicated1531_934))->class);
			      arg1578_946 =
				 (((sfun_bglt) CREF(duplicated1531_934))->dsssl_keywords_243);
			      arg1579_947 =
				 (((sfun_bglt) CREF(duplicated1531_934))->loc);
			      {		/* Integrate/loc2glo.scm 44 */
				 sfun_bglt res1695_1463;
				 {	/* Integrate/loc2glo.scm 44 */
				    long arity_1435;
				    arity_1435 =
				       (long) CINT(arg1565_936);
				    {	/* ./Ast/var.scm 798 */
				       sfun_bglt new1135_1447;
				       new1135_1447 =
					  ((sfun_bglt) BREF(GC_MALLOC(sizeof(struct sfun))));
				       {	/* ./Ast/var.scm 798 */
					  long arg1677_1448;
					  arg1677_1448 =
					     class_num_218___object(sfun_ast_var);
					  {	/* ./Ast/var.scm 798 */
					     obj_t obj_1461;
					     obj_1461 =
						(obj_t) (new1135_1447);
					     (((obj_t) CREF(obj_1461))->header = MAKE_HEADER(arg1677_1448, 0), BUNSPEC);
					  }
				       }
				       {	/* ./Ast/var.scm 798 */
					  object_bglt aux_1738;
					  aux_1738 =
					     (object_bglt) (new1135_1447);
					  OBJECT_WIDENING_SET(aux_1738, BFALSE);
				       }
				       ((((sfun_bglt) CREF(new1135_1447))->arity) = ((long) arity_1435), BUNSPEC);
				       ((((sfun_bglt) CREF(new1135_1447))->side_effect__165) = ((obj_t) arg1566_937), BUNSPEC);
				       ((((sfun_bglt) CREF(new1135_1447))->predicate_of_78) = ((obj_t) arg1567_938), BUNSPEC);
				       ((((sfun_bglt) CREF(new1135_1447))->stack_allocator_172) = ((obj_t) arg1568_939), BUNSPEC);
				       ((((sfun_bglt) CREF(new1135_1447))->top__138) = ((bool_t) arg1569_940), BUNSPEC);
				       ((((sfun_bglt) CREF(new1135_1447))->the_closure_238) = ((obj_t) arg1571_941), BUNSPEC);
				       ((((sfun_bglt) CREF(new1135_1447))->property) = ((obj_t) arg1572_942), BUNSPEC);
				       ((((sfun_bglt) CREF(new1135_1447))->args) = ((obj_t) arg1573_943), BUNSPEC);
				       ((((sfun_bglt) CREF(new1135_1447))->body) = ((obj_t) arg1576_944), BUNSPEC);
				       ((((sfun_bglt) CREF(new1135_1447))->class) = ((obj_t) arg1577_945), BUNSPEC);
				       ((((sfun_bglt) CREF(new1135_1447))->dsssl_keywords_243) = ((obj_t) arg1578_946), BUNSPEC);
				       ((((sfun_bglt) CREF(new1135_1447))->loc) = ((obj_t) arg1579_947), BUNSPEC);
				       res1695_1463 = new1135_1447;
				    }
				 }
				 new1532_935 = res1695_1463;
			      }
			   }
			   {	/* Integrate/loc2glo.scm 44 */

			      new_fun_115_900 = new1532_935;
			   }
			}
		     }
		     {	/* Integrate/loc2glo.scm 44 */

			{	/* Integrate/loc2glo.scm 49 */
			   type_bglt arg1541_901;
			   arg1541_901 =
			      (((local_bglt) CREF(local_1))->type);
			   {	/* Integrate/loc2glo.scm 49 */
			      global_bglt obj_1465;
			      obj_1465 =
				 (global_bglt) (global_896);
			      ((((global_bglt) CREF(obj_1465))->type) = ((type_bglt) arg1541_901), BUNSPEC);
			   }
			}
			{
			   obj_t l1533_902;
			   l1533_902 =
			      (((sfun_bglt) CREF(new_fun_115_900))->args);
			 lname1534_903:
			   if (
			      PAIRP(l1533_902))
			     {	/* Integrate/loc2glo.scm 50 */
				{	/* Integrate/loc2glo.scm 51 */
				   obj_t l_906;
				   l_906 =
				      CAR(l1533_902);
				   {	/* Integrate/loc2glo.scm 51 */
				      bool_t test1545_907;
				      test1545_907 =
					 integrate_celled__59_integrate_node(
					 (local_bglt) (l_906));
				      if (test1545_907)
					{	/* Integrate/loc2glo.scm 52 */
					   local_bglt obj_1470;
					   type_bglt val1090_1471;
					   obj_1470 =
					      (local_bglt) (l_906);
					   val1090_1471 =
					      (type_bglt) (_obj__252_type_cache);
					   ((((local_bglt) CREF(obj_1470))->type) = ((type_bglt) val1090_1471), BUNSPEC);
					}
				      else
					{	/* Integrate/loc2glo.scm 51 */
					   BUNSPEC;
					}
				   }
				}
				{
				   obj_t l1533_1765;
				   l1533_1765 =
				      CDR(l1533_902);
				   l1533_902 = l1533_1765;
				   goto lname1534_903;
				}
			     }
			   else
			     {	/* Integrate/loc2glo.scm 50 */
				((bool_t) 1);
			     }
			}
			{	/* Integrate/loc2glo.scm 55 */
			   obj_t arg1548_909;
			   {	/* Integrate/loc2glo.scm 55 */
			      obj_t arg1549_910;
			      obj_t arg1550_911;
			      {		/* Integrate/loc2glo.scm 55 */
				 sfun_bglt obj_1473;
				 obj_1473 =
				    (sfun_bglt) (old_fun_147_899);
				 arg1549_910 =
				    (((sfun_bglt) CREF(obj_1473))->body);
			      }
			      if (
				 NULLP(kaptured_897))
				{	/* Integrate/loc2glo.scm 57 */
				   arg1550_911 = BNIL;
				}
			      else
				{	/* Integrate/loc2glo.scm 57 */
				   obj_t head1537_915;
				   {	/* Integrate/loc2glo.scm 57 */
				      obj_t arg1561_930;
				      {		/* ./Ieee/pair-list.scm 5689 */
					 obj_t aux_1774;
					 obj_t aux_1772;
					 aux_1774 =
					    CAR(add_args_4_898);
					 aux_1772 =
					    CAR(kaptured_897);
					 arg1561_930 =
					    MAKE_PAIR(aux_1772, aux_1774);
				      }
				      head1537_915 =
					 MAKE_PAIR(arg1561_930, BNIL);
				   }
				   {
				      obj_t ll1535_916;
				      obj_t ll1536_917;
				      obj_t tail1538_918;
				      ll1535_916 =
					 CDR(kaptured_897);
				      ll1536_917 =
					 CDR(add_args_4_898);
				      tail1538_918 = head1537_915;
				    lname1540_919:
				      if (
					 NULLP(ll1535_916))
					{	/* Integrate/loc2glo.scm 57 */
					   arg1550_911 = head1537_915;
					}
				      else
					{	/* Integrate/loc2glo.scm 57 */
					   obj_t newtail1539_923;
					   {	/* Integrate/loc2glo.scm 57 */
					      obj_t arg1557_926;
					      {		/* ./Ieee/pair-list.scm 5689 */
						 obj_t aux_1782;
						 obj_t aux_1780;
						 aux_1782 =
						    CAR(ll1536_917);
						 aux_1780 =
						    CAR(ll1535_916);
						 arg1557_926 =
						    MAKE_PAIR(aux_1780, aux_1782);
					      }
					      newtail1539_923 =
						 MAKE_PAIR(arg1557_926, BNIL);
					   }
					   SET_CDR(tail1538_918, newtail1539_923);
					   {
					      obj_t tail1538_1791;
					      obj_t ll1536_1789;
					      obj_t ll1535_1787;
					      ll1535_1787 =
						 CDR(ll1535_916);
					      ll1536_1789 =
						 CDR(ll1536_917);
					      tail1538_1791 = newtail1539_923;
					      tail1538_918 = tail1538_1791;
					      ll1536_917 = ll1536_1789;
					      ll1535_916 = ll1535_1787;
					      goto lname1540_919;
					   }
					}
				   }
				}
			      arg1548_909 =
				 globalize__167_integrate_node(
				 (node_bglt) (arg1549_910),
				 (variable_bglt) (local_1), arg1550_911);
			   }
			   ((((sfun_bglt) CREF(new_fun_115_900))->body) = ((obj_t) arg1548_909), BUNSPEC);
			}
			{	/* Integrate/loc2glo.scm 58 */
			   global_bglt obj_1496;
			   value_bglt val1061_1497;
			   obj_1496 =
			      (global_bglt) (global_896);
			   val1061_1497 =
			      (value_bglt) (new_fun_115_900);
			   ((((global_bglt) CREF(obj_1496))->value) = ((value_bglt) val1061_1497), BUNSPEC);
			}
			return global_896;
		     }
		  }
	       }
	    }
	 }
      }
   }
}



/* _local->global1698 */
obj_t 
_local__global1698_140_integrate_local__global_163(obj_t env_1596, obj_t local_1597)
{
   AN_OBJECT;
   {	/* Integrate/loc2glo.scm 34 */
      return
	 local__global_40_integrate_local__global_163(
	 (local_bglt) (local_1597));
   }
}



/* local-id->global-id */
obj_t 
local_id__global_id_246_integrate_local__global_163(local_bglt local_2)
{
   AN_OBJECT;
   {	/* Integrate/loc2glo.scm 71 */
      {
	 obj_t id_974;
	 id_974 =
	    (((local_bglt) CREF(local_2))->id);
       loop_975:
	 {	/* Integrate/loc2glo.scm 74 */
	    bool_t test1597_977;
	    {	/* Integrate/loc2glo.scm 74 */
	       obj_t arg1601_981;
	       arg1601_981 =
		  find_global_module_25_ast_env(id_974, _module__166_module_module);
	       test1597_977 =
		  is_a__118___object(arg1601_981, global_ast_var);
	    }
	    if (test1597_977)
	      {		/* Integrate/loc2glo.scm 75 */
		 obj_t arg1598_978;
		 {	/* Integrate/loc2glo.scm 75 */
		    obj_t list1599_979;
		    {	/* Integrate/loc2glo.scm 75 */
		       obj_t arg1600_980;
		       arg1600_980 =
			  MAKE_PAIR(symbol_quote_158_integrate_local__global_163, BNIL);
		       list1599_979 =
			  MAKE_PAIR(id_974, arg1600_980);
		    }
		    arg1598_978 =
		       symbol_append_197___r4_symbols_6_4(list1599_979);
		 }
		 {
		    obj_t id_1809;
		    id_1809 = arg1598_978;
		    id_974 = id_1809;
		    goto loop_975;
		 }
	      }
	    else
	      {		/* Integrate/loc2glo.scm 74 */
		 return id_974;
	      }
	 }
      }
   }
}



/* the-global */
obj_t 
the_global_201_integrate_local__global_163(local_bglt local_3)
{
   AN_OBJECT;
   {	/* Integrate/loc2glo.scm 81 */
      {		/* Integrate/loc2glo.scm 82 */
	 value_bglt value_982;
	 value_982 =
	    (((local_bglt) CREF(local_3))->value);
	 {	/* Integrate/loc2glo.scm 83 */
	    bool_t test1602_983;
	    {	/* ./Ast/var.scm 758 */
	       obj_t aux_1812;
	       {	/* Integrate/loc2glo.scm 83 */
		  sfun_iinfo_105_bglt obj_1502;
		  obj_1502 =
		     (sfun_iinfo_105_bglt) (value_982);
		  {
		     obj_t aux_1814;
		     {	/* ./Integrate/iinfo.scm 1233 */
			object_bglt aux_1815;
			aux_1815 =
			   (object_bglt) (obj_1502);
			aux_1814 =
			   OBJECT_WIDENING(aux_1815);
		     }
		     aux_1812 =
			(((sfun_iinfo_105_bglt) CREF(aux_1814))->global);
		  }
	       }
	       test1602_983 =
		  is_a__118___object(aux_1812, global_ast_var);
	    }
	    if (test1602_983)
	      {		/* Integrate/loc2glo.scm 84 */
		 sfun_iinfo_105_bglt obj_1504;
		 obj_1504 =
		    (sfun_iinfo_105_bglt) (value_982);
		 {
		    obj_t aux_1822;
		    {	/* ./Integrate/iinfo.scm 1233 */
		       object_bglt aux_1823;
		       aux_1823 =
			  (object_bglt) (obj_1504);
		       aux_1822 =
			  OBJECT_WIDENING(aux_1823);
		    }
		    return
		       (((sfun_iinfo_105_bglt) CREF(aux_1822))->global);
		 }
	      }
	    else
	      {		/* Integrate/loc2glo.scm 85 */
		 obj_t id_984;
		 id_984 =
		    local_id__global_id_246_integrate_local__global_163(local_3);
		 {	/* Integrate/loc2glo.scm 85 */
		    global_bglt global_985;
		    global_985 =
		       def_global_sfun_no_warning__10_ast_glo_def_117(id_984, BNIL, BNIL, _module__166_module_module,
		       CNST_TABLE_REF(((long) 0)),
		       CNST_TABLE_REF(((long) 1)),
		       CNST_TABLE_REF(((long) 2)), BUNSPEC);
		    {	/* Integrate/loc2glo.scm 86 */

		       {	/* Integrate/loc2glo.scm 99 */
			  obj_t arg1604_987;
			  {	/* Integrate/loc2glo.scm 99 */
			     sfun_bglt obj_1506;
			     obj_1506 =
				(sfun_bglt) (value_982);
			     arg1604_987 =
				(((sfun_bglt) CREF(obj_1506))->loc);
			  }
			  {	/* Integrate/loc2glo.scm 99 */
			     sfun_bglt obj_1507;
			     {	/* Integrate/loc2glo.scm 99 */
				value_bglt aux_1834;
				aux_1834 =
				   (((global_bglt) CREF(global_985))->value);
				obj_1507 =
				   (sfun_bglt) (aux_1834);
			     }
			     ((((sfun_bglt) CREF(obj_1507))->loc) = ((obj_t) arg1604_987), BUNSPEC);
			  }
		       }
		       if (
			  (((local_bglt) CREF(local_3))->user__32))
			 {	/* Integrate/loc2glo.scm 101 */
			    BUNSPEC;
			 }
		       else
			 {	/* Integrate/loc2glo.scm 101 */
			    ((((global_bglt) CREF(global_985))->user__32) = ((bool_t) ((bool_t) 0)), BUNSPEC);
			 }
		       {	/* Integrate/loc2glo.scm 103 */
			  sfun_iinfo_105_bglt obj_1512;
			  obj_t val1500_1513;
			  obj_1512 =
			     (sfun_iinfo_105_bglt) (value_982);
			  val1500_1513 =
			     (obj_t) (global_985);
			  {
			     obj_t aux_1843;
			     {	/* ./Integrate/iinfo.scm 1233 */
				object_bglt aux_1844;
				aux_1844 =
				   (object_bglt) (obj_1512);
				aux_1843 =
				   OBJECT_WIDENING(aux_1844);
			     }
			     ((((sfun_iinfo_105_bglt) CREF(aux_1843))->global) = ((obj_t) val1500_1513), BUNSPEC);
			  }
		       }
		       {	/* Integrate/loc2glo.scm 104 */
			  obj_t arg1607_990;
			  {	/* Integrate/loc2glo.scm 105 */
			     sfun_bglt obj_1515;
			     obj_1515 =
				(sfun_bglt) (value_982);
			     arg1607_990 =
				(((sfun_bglt) CREF(obj_1515))->side_effect__165);
			  }
			  {	/* Integrate/loc2glo.scm 104 */
			     sfun_bglt obj_1516;
			     {	/* Integrate/loc2glo.scm 104 */
				value_bglt aux_1850;
				aux_1850 =
				   (((global_bglt) CREF(global_985))->value);
				obj_1516 =
				   (sfun_bglt) (aux_1850);
			     }
			     ((((sfun_bglt) CREF(obj_1516))->side_effect__165) = ((obj_t) arg1607_990), BUNSPEC);
			  }
		       }
		       return
			  (obj_t) (global_985);
		    }
		 }
	      }
	 }
      }
   }
}



/* _the-global1699 */
obj_t 
_the_global1699_138_integrate_local__global_163(obj_t env_1598, obj_t local_1599)
{
   AN_OBJECT;
   {	/* Integrate/loc2glo.scm 81 */
      return
	 the_global_201_integrate_local__global_163(
	 (local_bglt) (local_1599));
   }
}



/* method-init */
obj_t 
method_init_76_integrate_local__global_163()
{
   AN_OBJECT;
   {	/* Integrate/loc2glo.scm 14 */
      return BUNSPEC;
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_integrate_local__global_163()
{
   AN_OBJECT;
   {	/* Integrate/loc2glo.scm 14 */
      module_initialization_70_tools_trace(((long) 0), "INTEGRATE_LOCAL->GLOBAL");
      module_initialization_70_tools_shape(((long) 0), "INTEGRATE_LOCAL->GLOBAL");
      module_initialization_70_tools_args(((long) 0), "INTEGRATE_LOCAL->GLOBAL");
      module_initialization_70_module_module(((long) 0), "INTEGRATE_LOCAL->GLOBAL");
      module_initialization_70_type_type(((long) 0), "INTEGRATE_LOCAL->GLOBAL");
      module_initialization_70_type_cache(((long) 0), "INTEGRATE_LOCAL->GLOBAL");
      module_initialization_70_ast_var(((long) 0), "INTEGRATE_LOCAL->GLOBAL");
      module_initialization_70_ast_node(((long) 0), "INTEGRATE_LOCAL->GLOBAL");
      module_initialization_70_ast_glo_def_117(((long) 0), "INTEGRATE_LOCAL->GLOBAL");
      module_initialization_70_ast_env(((long) 0), "INTEGRATE_LOCAL->GLOBAL");
      module_initialization_70_ast_local(((long) 0), "INTEGRATE_LOCAL->GLOBAL");
      module_initialization_70_integrate_info(((long) 0), "INTEGRATE_LOCAL->GLOBAL");
      return
	 module_initialization_70_integrate_node(((long) 0), "INTEGRATE_LOCAL->GLOBAL");
   }
}
