/*===========================================================================*/
/*   (Integrate/node.scm)                                                    */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;

typedef struct svar_iinfo_76
  {
     obj_t f_mark_181;
     obj_t u_mark_209;
     bool_t kaptured__204;
     bool_t celled__113;
  }
             *svar_iinfo_76_bglt;

typedef struct sexit_iinfo_190
  {
     obj_t f_mark_181;
     obj_t u_mark_209;
     bool_t kaptured__204;
     bool_t celled__113;
  }
               *sexit_iinfo_190_bglt;

typedef struct sfun_iinfo_105
  {
     obj_t owner;
     obj_t free;
     obj_t bound;
     obj_t cfrom;
     obj_t cto;
     obj_t k;
     obj_t k__190;
     obj_t u;
     obj_t cn;
     obj_t ct;
     obj_t kont;
     bool_t g__219;
     obj_t l;
     obj_t led;
     obj_t istamp;
     obj_t global;
     obj_t kaptured;
  }
              *sfun_iinfo_105_bglt;


static obj_t method_init_76_integrate_node();
extern obj_t make_box_202_ast_node;
extern obj_t funcall_ast_node;
extern long add_inlined_method__244___object(obj_t, obj_t, long);
extern obj_t fail_ast_node;
static obj_t glo___241_integrate_node(obj_t, variable_bglt);
extern obj_t box_ref_242_ast_node;
extern obj_t sequence_ast_node;
extern obj_t let_var_6_ast_node;
extern obj_t var_ast_node;
extern obj_t closure_ast_node;
extern obj_t global_ast_var;
extern obj_t _obj__252_type_cache;
extern obj_t pragma_ast_node;
extern obj_t globalize__167_integrate_node(node_bglt, variable_bglt, obj_t);
extern obj_t set_ex_it_116_ast_node;
extern bool_t integrate_celled__59_integrate_node(local_bglt);
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t module_initialization_70_integrate_node(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_ast_local(long, char *);
extern obj_t module_initialization_70_integrate_info(long, char *);
extern obj_t module_initialization_70_integrate_local__global_163(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t svar_iinfo_76_integrate_info;
extern local_bglt make_local_svar_140_ast_local(obj_t, type_bglt);
extern long class_num_218___object(obj_t);
extern obj_t let_fun_218_ast_node;
static obj_t imported_modules_init_94_integrate_node();
static obj_t celled_bindings_3_integrate_node(obj_t);
extern obj_t app_ly_162_ast_node;
extern obj_t add_generic__110___object(obj_t, obj_t);
static obj_t _glo__107_integrate_node(obj_t, obj_t, obj_t);
extern obj_t app_ast_node;
extern obj_t append_2_18___r4_pairs_and_lists_6_3(obj_t, obj_t);
static obj_t library_modules_init_112_integrate_node();
static obj_t _globalize__140_integrate_node(obj_t, obj_t, obj_t, obj_t);
extern obj_t atom_ast_node;
extern obj_t cast_ast_node;
static obj_t toplevel_init_63_integrate_node();
extern obj_t jump_ex_it_184_ast_node;
extern obj_t open_input_string(obj_t);
extern obj_t kwote_ast_node;
static make_box_202_bglt a_make_cell_117_integrate_node(node_bglt, variable_bglt);
extern obj_t setq_ast_node;
extern obj_t box_set__221_ast_node;
static node_bglt glo__115_integrate_node(node_bglt, variable_bglt);
extern obj_t local_ast_var;
static obj_t cell_formals_12_integrate_node(obj_t, node_bglt);
extern obj_t the_global_201_integrate_local__global_163(local_bglt);
extern obj_t memq___r4_pairs_and_lists_6_3(obj_t, obj_t);
static obj_t _integrate_celled_1915_213_integrate_node(obj_t, obj_t);
extern obj_t shape_tools_shape(obj_t);
extern obj_t internal_error_43_tools_error(obj_t, obj_t, obj_t);
static obj_t _glo__default1567_20_integrate_node(obj_t, obj_t, obj_t);
extern obj_t _classes__134___object;
extern obj_t select_ast_node;
extern obj_t read___reader(obj_t);
static node_bglt glo__default1567_251_integrate_node(node_bglt, variable_bglt);
extern obj_t ____74_type_cache;
static obj_t require_initialization_114_integrate_node = BUNSPEC;
extern obj_t conditional_ast_node;
static obj_t globalize_local_fun__50_integrate_node(local_bglt, variable_bglt);
static obj_t cnst_init_137_integrate_node();
static obj_t __cnst[5];

DEFINE_STATIC_PROCEDURE(glo__default1567_env_173_integrate_node, _glo__default1567_20_integrate_node1924, _glo__default1567_20_integrate_node, 0L, 2);
DEFINE_STATIC_GENERIC(glo__env_172_integrate_node, _glo__107_integrate_node1925, _glo__107_integrate_node, 0L, 2);
DEFINE_EXPORT_PROCEDURE(globalize__env_187_integrate_node, _globalize__140_integrate_node1926, _globalize__140_integrate_node, 0L, 3);
DEFINE_EXPORT_PROCEDURE(integrate_celled__env_119_integrate_node, _integrate_celled_1915_213_integrate_node1927, _integrate_celled_1915_213_integrate_node, 0L, 1);
DEFINE_STRING(string1919_integrate_node, string1919_integrate_node1928, "GLO!-DEFAULT1567 AUX DONE (WRITE CELL-INTEGRATE) CELL-INTEGRATE ", 64);
DEFINE_STRING(string1918_integrate_node, string1918_integrate_node1929, "No method for this object", 25);
DEFINE_STRING(string1917_integrate_node, string1917_integrate_node1930, "Unexepected `closure' node", 26);
DEFINE_STRING(string1916_integrate_node, string1916_integrate_node1931, "node-free", 9);



/* module-initialization */
obj_t 
module_initialization_70_integrate_node(long checksum_2181, char *from_2182)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_integrate_node))
	{
	   require_initialization_114_integrate_node =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_integrate_node();
	   cnst_init_137_integrate_node();
	   imported_modules_init_94_integrate_node();
	   method_init_76_integrate_node();
	   toplevel_init_63_integrate_node();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_integrate_node()
{
   AN_OBJECT;
   {	/* Integrate/node.scm 14 */
      module_initialization_70___object(((long) 0), "INTEGRATE_NODE");
      module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "INTEGRATE_NODE");
      module_initialization_70___reader(((long) 0), "INTEGRATE_NODE");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_integrate_node()
{
   AN_OBJECT;
   {	/* Integrate/node.scm 14 */
      {		/* Integrate/node.scm 14 */
	 obj_t cnst_port_138_2174;
	 cnst_port_138_2174 =
	    open_input_string(string1919_integrate_node);
	 {
	    long i_2175;
	    i_2175 = ((long) 4);
	  loop_2176:
	    {	/* Integrate/node.scm 14 */
	       bool_t test1920_2177;
	       test1920_2177 =
		  (i_2175 == ((long) -1));
	       if (test1920_2177)
		 {	/* Integrate/node.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Integrate/node.scm 14 */
		    {	/* Integrate/node.scm 14 */
		       obj_t arg1921_2178;
		       {	/* Integrate/node.scm 14 */
			  obj_t list1922_2179;
			  list1922_2179 =
			     MAKE_PAIR(cnst_port_138_2174, BNIL);
			  arg1921_2178 =
			     read___reader(list1922_2179);
		       }
		       CNST_TABLE_SET(i_2175, arg1921_2178);
		    }
		    {	/* Integrate/node.scm 14 */
		       int aux_2180;
		       {	/* Integrate/node.scm 14 */
			  long aux_2200;
			  aux_2200 =
			     (i_2175 - ((long) 1));
			  aux_2180 =
			     (int) (aux_2200);
		       }
		       {
			  long i_2203;
			  i_2203 =
			     (long) (aux_2180);
			  i_2175 = i_2203;
			  goto loop_2176;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_integrate_node()
{
   AN_OBJECT;
   {	/* Integrate/node.scm 14 */
      return BUNSPEC;
   }
}



/* globalize! */
obj_t 
globalize__167_integrate_node(node_bglt ast_1, variable_bglt integrator_2, obj_t what_by__117_3)
{
   AN_OBJECT;
   {	/* Integrate/node.scm 34 */
      {		/* Integrate/node.scm 40 */
	 obj_t celled_942;
	 {	/* Integrate/node.scm 41 */
	    obj_t aux_2205;
	    {	/* Integrate/node.scm 41 */
	       sfun_bglt obj_1650;
	       {	/* Integrate/node.scm 41 */
		  value_bglt aux_2206;
		  aux_2206 =
		     (((variable_bglt) CREF(integrator_2))->value);
		  obj_1650 =
		     (sfun_bglt) (aux_2206);
	       }
	       aux_2205 =
		  (((sfun_bglt) CREF(obj_1650))->args);
	    }
	    celled_942 =
	       celled_bindings_3_integrate_node(aux_2205);
	 }
	 {	/* Integrate/node.scm 41 */
	    obj_t what_by__117_943;
	    what_by__117_943 =
	       append_2_18___r4_pairs_and_lists_6_3(celled_942, what_by__117_3);
	    {	/* Integrate/node.scm 42 */

	       {
		  obj_t l1516_944;
		  l1516_944 = what_by__117_943;
		lname1517_945:
		  if (
		     PAIRP(l1516_944))
		    {	/* Integrate/node.scm 44 */
		       {	/* Integrate/node.scm 45 */
			  obj_t w_b_127_947;
			  w_b_127_947 =
			     CAR(l1516_944);
			  {	/* Integrate/node.scm 45 */
			     obj_t arg1612_949;
			     arg1612_949 =
				CDR(w_b_127_947);
			     {	/* Integrate/node.scm 45 */
				local_bglt obj_1655;
				{	/* Integrate/node.scm 45 */
				   obj_t aux_2216;
				   aux_2216 =
				      CAR(w_b_127_947);
				   obj_1655 =
				      (local_bglt) (aux_2216);
				}
				((((local_bglt) CREF(obj_1655))->fast_alpha_7) = ((obj_t) arg1612_949), BUNSPEC);
			     }
			  }
		       }
		       {
			  obj_t l1516_2220;
			  l1516_2220 =
			     CDR(l1516_944);
			  l1516_944 = l1516_2220;
			  goto lname1517_945;
		       }
		    }
		  else
		    {	/* Integrate/node.scm 44 */
		       ((bool_t) 1);
		    }
	       }
	       {	/* Integrate/node.scm 47 */
		  obj_t res_951;
		  {	/* Integrate/node.scm 47 */
		     node_bglt arg1617_958;
		     arg1617_958 =
			glo__115_integrate_node(ast_1, integrator_2);
		     res_951 =
			cell_formals_12_integrate_node(celled_942, arg1617_958);
		  }
		  {
		     obj_t l1518_952;
		     l1518_952 = what_by__117_943;
		   lname1519_953:
		     if (
			PAIRP(l1518_952))
		       {	/* Integrate/node.scm 49 */
			  {	/* Integrate/node.scm 50 */
			     local_bglt obj_1661;
			     {	/* Integrate/node.scm 50 */
				obj_t aux_2226;
				{	/* ./Ieee/pair-list.scm 5701 */
				   obj_t aux_2227;
				   aux_2227 =
				      CAR(l1518_952);
				   aux_2226 =
				      CAR(aux_2227);
				}
				obj_1661 =
				   (local_bglt) (aux_2226);
			     }
			     ((((local_bglt) CREF(obj_1661))->fast_alpha_7) = ((obj_t) BUNSPEC), BUNSPEC);
			  }
			  {
			     obj_t l1518_2232;
			     l1518_2232 =
				CDR(l1518_952);
			     l1518_952 = l1518_2232;
			     goto lname1519_953;
			  }
		       }
		     else
		       {	/* Integrate/node.scm 49 */
			  ((bool_t) 1);
		       }
		  }
		  return res_951;
	       }
	    }
	 }
      }
   }
}



/* _globalize! */
obj_t 
_globalize__140_integrate_node(obj_t env_2162, obj_t ast_2163, obj_t integrator_2164, obj_t what_by__117_2165)
{
   AN_OBJECT;
   {	/* Integrate/node.scm 34 */
      return
	 globalize__167_integrate_node(
	 (node_bglt) (ast_2163),
	 (variable_bglt) (integrator_2164), what_by__117_2165);
   }
}



/* celled-bindings */
obj_t 
celled_bindings_3_integrate_node(obj_t formals_4)
{
   AN_OBJECT;
   {	/* Integrate/node.scm 57 */
      {
	 obj_t celled_960;
	 obj_t formals_961;
	 celled_960 = BNIL;
	 formals_961 = formals_4;
       loop_962:
	 if (
	    NULLP(formals_961))
	   {	/* Integrate/node.scm 61 */
	      return celled_960;
	   }
	 else
	   {	/* Integrate/node.scm 63 */
	      bool_t test_2239;
	      {		/* Integrate/node.scm 63 */
		 local_bglt aux_2240;
		 {	/* Integrate/node.scm 63 */
		    obj_t aux_2241;
		    aux_2241 =
		       CAR(formals_961);
		    aux_2240 =
		       (local_bglt) (aux_2241);
		 }
		 test_2239 =
		    integrate_celled__59_integrate_node(aux_2240);
	      }
	      if (test_2239)
		{	/* Integrate/node.scm 63 */
		   {	/* Integrate/node.scm 66 */
		      local_bglt var_965;
		      {		/* Integrate/node.scm 66 */
			 obj_t aux_2245;
			 {	/* Integrate/node.scm 66 */
			    local_bglt obj_1667;
			    {	/* Integrate/node.scm 66 */
			       obj_t aux_2246;
			       aux_2246 =
				  CAR(formals_961);
			       obj_1667 =
				  (local_bglt) (aux_2246);
			    }
			    aux_2245 =
			       (((local_bglt) CREF(obj_1667))->id);
			 }
			 var_965 =
			    make_local_svar_140_ast_local(aux_2245,
			    (type_bglt) (_obj__252_type_cache));
		      }
		      {		/* Integrate/node.scm 66 */
			 obj_t o_n_168_966;
			 {	/* ./Ieee/pair-list.scm 5689 */
			    obj_t aux_2254;
			    obj_t aux_2252;
			    aux_2254 =
			       (obj_t) (var_965);
			    aux_2252 =
			       CAR(formals_961);
			    o_n_168_966 =
			       MAKE_PAIR(aux_2252, aux_2254);
			 }
			 {	/* Integrate/node.scm 67 */

			    {	/* Integrate/node.scm 68 */
			       obj_t val1084_1672;
			       val1084_1672 =
				  CNST_TABLE_REF(((long) 0));
			       ((((local_bglt) CREF(var_965))->access) = ((obj_t) val1084_1672), BUNSPEC);
			    }
			    {	/* Integrate/node.scm 69 */
			       svar_iinfo_76_bglt obj1520_967;
			       obj1520_967 =
				  ((svar_iinfo_76_bglt) (
				     (((local_bglt) CREF(var_965))->value)));
			       {	/* Integrate/node.scm 69 */
				  svar_iinfo_76_bglt arg1621_968;
				  {	/* Integrate/node.scm 69 */
				     svar_iinfo_76_bglt res1903_1683;
				     {	/* ./Integrate/iinfo.scm 1306 */
					svar_iinfo_76_bglt new1442_1678;
					new1442_1678 =
					   ((svar_iinfo_76_bglt) BREF(GC_MALLOC(sizeof(struct svar_iinfo_76))));
					((((svar_iinfo_76_bglt) CREF(new1442_1678))->f_mark_181) = ((obj_t) BUNSPEC), BUNSPEC);
					((((svar_iinfo_76_bglt) CREF(new1442_1678))->u_mark_209) = ((obj_t) BUNSPEC), BUNSPEC);
					((((svar_iinfo_76_bglt) CREF(new1442_1678))->kaptured__204) = ((bool_t) ((bool_t) 1)), BUNSPEC);
					((((svar_iinfo_76_bglt) CREF(new1442_1678))->celled__113) = ((bool_t) ((bool_t) 1)), BUNSPEC);
					res1903_1683 = new1442_1678;
				     }
				     arg1621_968 = res1903_1683;
				  }
				  {	/* Integrate/node.scm 69 */
				     obj_t aux_2268;
				     object_bglt aux_2266;
				     aux_2268 =
					(obj_t) (arg1621_968);
				     aux_2266 =
					(object_bglt) (obj1520_967);
				     OBJECT_WIDENING_SET(aux_2266, aux_2268);
				  }
			       }
			       {	/* Integrate/node.scm 69 */
				  long arg1624_971;
				  arg1624_971 =
				     class_num_218___object(svar_iinfo_76_integrate_info);
				  {	/* Integrate/node.scm 69 */
				     obj_t obj_1684;
				     obj_1684 =
					(obj_t) (obj1520_967);
				     (((obj_t) CREF(obj_1684))->header = MAKE_HEADER(arg1624_971, 0), BUNSPEC);
				  }
			       }
			       obj1520_967;
			    }
			    {	/* Integrate/node.scm 72 */
			       obj_t arg1625_972;
			       obj_t arg1626_973;
			       arg1625_972 =
				  MAKE_PAIR(o_n_168_966, celled_960);
			       arg1626_973 =
				  CDR(formals_961);
			       {
				  obj_t formals_2277;
				  obj_t celled_2276;
				  celled_2276 = arg1625_972;
				  formals_2277 = arg1626_973;
				  formals_961 = formals_2277;
				  celled_960 = celled_2276;
				  goto loop_962;
			       }
			    }
			 }
		      }
		   }
		}
	      else
		{	/* Integrate/node.scm 63 */
		   {
		      obj_t formals_2278;
		      formals_2278 =
			 CDR(formals_961);
		      formals_961 = formals_2278;
		      goto loop_962;
		   }
		}
	   }
      }
   }
}



/* cell-formals */
obj_t 
cell_formals_12_integrate_node(obj_t celled_5, node_bglt body_6)
{
   AN_OBJECT;
   {	/* Integrate/node.scm 77 */
      {		/* Integrate/node.scm 78 */
	 bool_t test1632_979;
	 test1632_979 =
	    NULLP(celled_5);
	 if (test1632_979)
	   {	/* Integrate/node.scm 78 */
	      return
		 (obj_t) (body_6);
	   }
	 else
	   {	/* Integrate/node.scm 80 */
	      obj_t loc_980;
	      loc_980 =
		 (((node_bglt) CREF(body_6))->loc);
	      {		/* Integrate/node.scm 81 */
		 obj_t arg1634_982;
		 obj_t arg1636_984;
		 arg1634_982 = ____74_type_cache;
		 if (test1632_979)
		   {	/* Integrate/node.scm 85 */
		      arg1636_984 = BNIL;
		   }
		 else
		   {	/* Integrate/node.scm 85 */
		      obj_t head1524_988;
		      head1524_988 =
			 MAKE_PAIR(BNIL, BNIL);
		      {
			 obj_t l1522_989;
			 obj_t tail1525_990;
			 l1522_989 = celled_5;
			 tail1525_990 = head1524_988;
		       lname1523_991:
			 if (
			    NULLP(l1522_989))
			   {	/* Integrate/node.scm 85 */
			      arg1636_984 =
				 CDR(head1524_988);
			   }
			 else
			   {	/* Integrate/node.scm 86 */
			      obj_t newtail1526_993;
			      {		/* Integrate/node.scm 86 */
				 obj_t arg1641_995;
				 {	/* Integrate/node.scm 86 */
				    obj_t o_n_168_997;
				    o_n_168_997 =
				       CAR(l1522_989);
				    {	/* Integrate/node.scm 86 */
				       obj_t arg1643_998;
				       make_box_202_bglt arg1644_999;
				       arg1643_998 =
					  CDR(o_n_168_997);
				       {	/* Integrate/node.scm 87 */
					  var_bglt arg1646_1000;
					  obj_t arg1647_1001;
					  {	/* Integrate/node.scm 87 */
					     obj_t arg1649_1003;
					     arg1649_1003 = ____74_type_cache;
					     {	/* Integrate/node.scm 87 */
						var_bglt res1904_1710;
						{	/* Integrate/node.scm 87 */
						   type_bglt type_1701;
						   variable_bglt variable_1702;
						   type_1701 =
						      (type_bglt) (arg1649_1003);
						   {	/* Integrate/node.scm 87 */
						      obj_t aux_2292;
						      aux_2292 =
							 CAR(o_n_168_997);
						      variable_1702 =
							 (variable_bglt) (aux_2292);
						   }
						   {	/* ./Ast/node.scm 1127 */
						      var_bglt new1210_1703;
						      new1210_1703 =
							 ((var_bglt) BREF(GC_MALLOC(sizeof(struct var))));
						      {		/* ./Ast/node.scm 1127 */
							 long arg1725_1704;
							 arg1725_1704 =
							    class_num_218___object(var_ast_node);
							 {	/* ./Ast/node.scm 1127 */
							    obj_t obj_1708;
							    obj_1708 =
							       (obj_t) (new1210_1703);
							    (((obj_t) CREF(obj_1708))->header = MAKE_HEADER(arg1725_1704, 0), BUNSPEC);
							 }
						      }
						      {		/* ./Ast/node.scm 1127 */
							 object_bglt aux_2299;
							 aux_2299 =
							    (object_bglt) (new1210_1703);
							 OBJECT_WIDENING_SET(aux_2299, BFALSE);
						      }
						      ((((var_bglt) CREF(new1210_1703))->loc) = ((obj_t) loc_980), BUNSPEC);
						      ((((var_bglt) CREF(new1210_1703))->type) = ((type_bglt) type_1701), BUNSPEC);
						      ((((var_bglt) CREF(new1210_1703))->variable) = ((variable_bglt) variable_1702), BUNSPEC);
						      res1904_1710 = new1210_1703;
						   }
						}
						arg1646_1000 = res1904_1710;
					     }
					  }
					  arg1647_1001 =
					     CAR(o_n_168_997);
					  arg1644_999 =
					     a_make_cell_117_integrate_node(
					     (node_bglt) (arg1646_1000),
					     (variable_bglt) (arg1647_1001));
				       }
				       {	/* ./Ieee/pair-list.scm 5689 */
					  obj_t aux_2309;
					  aux_2309 =
					     (obj_t) (arg1644_999);
					  arg1641_995 =
					     MAKE_PAIR(arg1643_998, aux_2309);
				       }
				    }
				 }
				 newtail1526_993 =
				    MAKE_PAIR(arg1641_995, BNIL);
			      }
			      SET_CDR(tail1525_990, newtail1526_993);
			      {
				 obj_t tail1525_2316;
				 obj_t l1522_2314;
				 l1522_2314 =
				    CDR(l1522_989);
				 tail1525_2316 = newtail1526_993;
				 tail1525_990 = tail1525_2316;
				 l1522_989 = l1522_2314;
				 goto lname1523_991;
			      }
			   }
		      }
		   }
		 {	/* Integrate/node.scm 81 */
		    let_var_6_bglt res1905_1737;
		    {	/* Integrate/node.scm 81 */
		       type_bglt type_1720;
		       obj_t key_1722;
		       type_1720 =
			  (type_bglt) (arg1634_982);
		       key_1722 =
			  BINT(((long) -1));
		       {	/* ./Ast/node.scm 1220 */
			  let_var_6_bglt new1373_1726;
			  new1373_1726 =
			     ((let_var_6_bglt) BREF(GC_MALLOC(sizeof(struct let_var_6))));
			  {	/* ./Ast/node.scm 1220 */
			     long arg1696_1727;
			     arg1696_1727 =
				class_num_218___object(let_var_6_ast_node);
			     {	/* ./Ast/node.scm 1220 */
				obj_t obj_1735;
				obj_1735 =
				   (obj_t) (new1373_1726);
				(((obj_t) CREF(obj_1735))->header = MAKE_HEADER(arg1696_1727, 0), BUNSPEC);
			     }
			  }
			  {	/* ./Ast/node.scm 1220 */
			     object_bglt aux_2323;
			     aux_2323 =
				(object_bglt) (new1373_1726);
			     OBJECT_WIDENING_SET(aux_2323, BFALSE);
			  }
			  ((((let_var_6_bglt) CREF(new1373_1726))->loc) = ((obj_t) loc_980), BUNSPEC);
			  ((((let_var_6_bglt) CREF(new1373_1726))->type) = ((type_bglt) type_1720), BUNSPEC);
			  ((((let_var_6_bglt) CREF(new1373_1726))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
			  ((((let_var_6_bglt) CREF(new1373_1726))->key) = ((obj_t) key_1722), BUNSPEC);
			  ((((let_var_6_bglt) CREF(new1373_1726))->bindings) = ((obj_t) arg1636_984), BUNSPEC);
			  ((((let_var_6_bglt) CREF(new1373_1726))->body) = ((node_bglt) body_6), BUNSPEC);
			  ((((let_var_6_bglt) CREF(new1373_1726))->removable__42) = ((bool_t) ((bool_t) 1)), BUNSPEC);
			  res1905_1737 = new1373_1726;
		       }
		    }
		    return
		       (obj_t) (res1905_1737);
		 }
	      }
	   }
      }
   }
}



/* a-make-cell */
make_box_202_bglt 
a_make_cell_117_integrate_node(node_bglt node_7, variable_bglt variable_8)
{
   AN_OBJECT;
   {	/* Integrate/node.scm 97 */
      {		/* Integrate/node.scm 101 */
	 local_bglt obj_1738;
	 obj_t val1084_1739;
	 obj_1738 =
	    (local_bglt) (variable_8);
	 val1084_1739 =
	    CNST_TABLE_REF(((long) 0));
	 ((((local_bglt) CREF(obj_1738))->access) = ((obj_t) val1084_1739), BUNSPEC);
      }
      {		/* Integrate/node.scm 102 */
	 svar_iinfo_76_bglt obj_1741;
	 {	/* Integrate/node.scm 102 */
	    value_bglt aux_2337;
	    aux_2337 =
	       (((variable_bglt) CREF(variable_8))->value);
	    obj_1741 =
	       (svar_iinfo_76_bglt) (aux_2337);
	 }
	 {
	    obj_t aux_2340;
	    {	/* ./Integrate/iinfo.scm 1314 */
	       object_bglt aux_2341;
	       aux_2341 =
		  (object_bglt) (obj_1741);
	       aux_2340 =
		  OBJECT_WIDENING(aux_2341);
	    }
	    ((((svar_iinfo_76_bglt) CREF(aux_2340))->celled__113) = ((bool_t) ((bool_t) 1)), BUNSPEC);
	 }
      }
      {		/* Integrate/node.scm 103 */
	 obj_t arg1652_1007;
	 obj_t arg1653_1008;
	 arg1652_1007 =
	    (((node_bglt) CREF(node_7))->loc);
	 arg1653_1008 = ____74_type_cache;
	 {	/* Integrate/node.scm 103 */
	    make_box_202_bglt res1906_1758;
	    {	/* Integrate/node.scm 103 */
	       type_bglt type_1745;
	       obj_t key_1747;
	       type_1745 =
		  (type_bglt) (arg1653_1008);
	       key_1747 =
		  BINT(((long) -1));
	       {	/* ./Ast/node.scm 1243 */
		  make_box_202_bglt new1407_1749;
		  new1407_1749 =
		     ((make_box_202_bglt) BREF(GC_MALLOC(sizeof(struct make_box_202))));
		  {	/* ./Ast/node.scm 1243 */
		     long arg1690_1750;
		     arg1690_1750 =
			class_num_218___object(make_box_202_ast_node);
		     {	/* ./Ast/node.scm 1243 */
			obj_t obj_1756;
			obj_1756 =
			   (obj_t) (new1407_1749);
			(((obj_t) CREF(obj_1756))->header = MAKE_HEADER(arg1690_1750, 0), BUNSPEC);
		     }
		  }
		  {	/* ./Ast/node.scm 1243 */
		     object_bglt aux_2352;
		     aux_2352 =
			(object_bglt) (new1407_1749);
		     OBJECT_WIDENING_SET(aux_2352, BFALSE);
		  }
		  ((((make_box_202_bglt) CREF(new1407_1749))->loc) = ((obj_t) arg1652_1007), BUNSPEC);
		  ((((make_box_202_bglt) CREF(new1407_1749))->type) = ((type_bglt) type_1745), BUNSPEC);
		  ((((make_box_202_bglt) CREF(new1407_1749))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
		  ((((make_box_202_bglt) CREF(new1407_1749))->key) = ((obj_t) key_1747), BUNSPEC);
		  ((((make_box_202_bglt) CREF(new1407_1749))->value) = ((node_bglt) node_7), BUNSPEC);
		  res1906_1758 = new1407_1749;
	       }
	    }
	    return res1906_1758;
	 }
      }
   }
}



/* integrate-celled? */
bool_t 
integrate_celled__59_integrate_node(local_bglt variable_9)
{
   AN_OBJECT;
   {	/* Integrate/node.scm 108 */
      {		/* Integrate/node.scm 119 */
	 bool_t _andtest_1530_1011;
	 {	/* ./Integrate/iinfo.scm 1306 */
	    obj_t aux_2360;
	    {	/* Integrate/node.scm 119 */
	       value_bglt aux_2361;
	       {	/* Integrate/node.scm 119 */
		  variable_bglt obj_1759;
		  obj_1759 =
		     (variable_bglt) (variable_9);
		  aux_2361 =
		     (((variable_bglt) CREF(obj_1759))->value);
	       }
	       aux_2360 =
		  (obj_t) (aux_2361);
	    }
	    _andtest_1530_1011 =
	       is_a__118___object(aux_2360, svar_iinfo_76_integrate_info);
	 }
	 if (_andtest_1530_1011)
	   {	/* Integrate/node.scm 120 */
	      bool_t _ortest_1531_1012;
	      {		/* Integrate/node.scm 120 */
		 svar_iinfo_76_bglt obj_1762;
		 {	/* Integrate/node.scm 120 */
		    value_bglt aux_2367;
		    {	/* Integrate/node.scm 120 */
		       variable_bglt obj_1761;
		       obj_1761 =
			  (variable_bglt) (variable_9);
		       aux_2367 =
			  (((variable_bglt) CREF(obj_1761))->value);
		    }
		    obj_1762 =
		       (svar_iinfo_76_bglt) (aux_2367);
		 }
		 {
		    obj_t aux_2371;
		    {	/* ./Integrate/iinfo.scm 1314 */
		       object_bglt aux_2372;
		       aux_2372 =
			  (object_bglt) (obj_1762);
		       aux_2371 =
			  OBJECT_WIDENING(aux_2372);
		    }
		    _ortest_1531_1012 =
		       (((svar_iinfo_76_bglt) CREF(aux_2371))->celled__113);
		 }
	      }
	      if (_ortest_1531_1012)
		{	/* Integrate/node.scm 120 */
		   return _ortest_1531_1012;
		}
	      else
		{	/* Integrate/node.scm 121 */
		   bool_t test_2377;
		   {	/* Integrate/node.scm 121 */
		      obj_t aux_2378;
		      {		/* Integrate/node.scm 121 */
			 obj_t aux_2379;
			 {	/* Integrate/node.scm 121 */
			    variable_bglt obj_1763;
			    obj_1763 =
			       (variable_bglt) (variable_9);
			    aux_2379 =
			       (((variable_bglt) CREF(obj_1763))->access);
			 }
			 aux_2378 =
			    memq___r4_pairs_and_lists_6_3(aux_2379,
			    CNST_TABLE_REF(((long) 1)));
		      }
		      test_2377 =
			 CBOOL(aux_2378);
		   }
		   if (test_2377)
		     {	/* Integrate/node.scm 122 */
			svar_iinfo_76_bglt obj_1765;
			{	/* Integrate/node.scm 122 */
			   value_bglt aux_2385;
			   {	/* Integrate/node.scm 122 */
			      variable_bglt obj_1764;
			      obj_1764 =
				 (variable_bglt) (variable_9);
			      aux_2385 =
				 (((variable_bglt) CREF(obj_1764))->value);
			   }
			   obj_1765 =
			      (svar_iinfo_76_bglt) (aux_2385);
			}
			{
			   obj_t aux_2389;
			   {	/* ./Integrate/iinfo.scm 1312 */
			      object_bglt aux_2390;
			      aux_2390 =
				 (object_bglt) (obj_1765);
			      aux_2389 =
				 OBJECT_WIDENING(aux_2390);
			   }
			   return
			      (((svar_iinfo_76_bglt) CREF(aux_2389))->kaptured__204);
			}
		     }
		   else
		     {	/* Integrate/node.scm 121 */
			return ((bool_t) 0);
		     }
		}
	   }
	 else
	   {	/* Integrate/node.scm 119 */
	      return ((bool_t) 0);
	   }
      }
   }
}



/* _integrate-celled?1915 */
obj_t 
_integrate_celled_1915_213_integrate_node(obj_t env_2166, obj_t variable_2167)
{
   AN_OBJECT;
   {	/* Integrate/node.scm 108 */
      {		/* Integrate/node.scm 108 */
	 bool_t aux_2394;
	 aux_2394 =
	    integrate_celled__59_integrate_node(
	    (local_bglt) (variable_2167));
	 return
	    BBOOL(aux_2394);
      }
   }
}



/* glo*! */
obj_t 
glo___241_integrate_node(obj_t node__221_56, variable_bglt integrator_57)
{
   AN_OBJECT;
   {	/* Integrate/node.scm 394 */
      {
	 obj_t node__221_1019;
	 node__221_1019 = node__221_56;
       loop_1020:
	 if (
	    NULLP(node__221_1019))
	   {	/* Integrate/node.scm 396 */
	      return
		 CNST_TABLE_REF(((long) 2));
	   }
	 else
	   {	/* Integrate/node.scm 396 */
	      {		/* Integrate/node.scm 399 */
		 node_bglt arg1662_1022;
		 {	/* Integrate/node.scm 399 */
		    node_bglt aux_2401;
		    {	/* Integrate/node.scm 399 */
		       obj_t aux_2402;
		       aux_2402 =
			  CAR(node__221_1019);
		       aux_2401 =
			  (node_bglt) (aux_2402);
		    }
		    arg1662_1022 =
		       glo__115_integrate_node(aux_2401, integrator_57);
		 }
		 {	/* ./Ieee/pair-list.scm 5890 */
		    obj_t aux_2406;
		    aux_2406 =
		       (obj_t) (arg1662_1022);
		    SET_CAR(node__221_1019, aux_2406);
		 }
	      }
	      {
		 obj_t node__221_2409;
		 node__221_2409 =
		    CDR(node__221_1019);
		 node__221_1019 = node__221_2409;
		 goto loop_1020;
	      }
	   }
      }
   }
}



/* globalize-local-fun! */
obj_t 
globalize_local_fun__50_integrate_node(local_bglt local_58, variable_bglt integrator_59)
{
   AN_OBJECT;
   {	/* Integrate/node.scm 405 */
      {		/* Integrate/node.scm 408 */
	 value_bglt fun_1025;
	 fun_1025 =
	    (((local_bglt) CREF(local_58))->value);
	 {	/* Integrate/node.scm 408 */
	    obj_t obody_1026;
	    {	/* Integrate/node.scm 409 */
	       sfun_bglt obj_1772;
	       obj_1772 =
		  (sfun_bglt) (fun_1025);
	       obody_1026 =
		  (((sfun_bglt) CREF(obj_1772))->body);
	    }
	    {	/* Integrate/node.scm 409 */

	       {	/* Integrate/node.scm 410 */
		  bool_t test_2414;
		  {	/* ./Ieee/equiv.scm 5508 */
		     obj_t aux_2417;
		     obj_t aux_2415;
		     aux_2417 =
			(obj_t) (integrator_59);
		     aux_2415 =
			(obj_t) (local_58);
		     test_2414 =
			(aux_2415 == aux_2417);
		  }
		  if (test_2414)
		    {	/* Integrate/node.scm 411 */
		       node_bglt arg1666_1028;
		       arg1666_1028 =
			  glo__115_integrate_node(
			  (node_bglt) (obody_1026), integrator_59);
		       {	/* Integrate/node.scm 411 */
			  sfun_bglt obj_1775;
			  obj_t val1123_1776;
			  obj_1775 =
			     (sfun_bglt) (fun_1025);
			  val1123_1776 =
			     (obj_t) (arg1666_1028);
			  return
			     ((((sfun_bglt) CREF(obj_1775))->body) = ((obj_t) val1123_1776), BUNSPEC);
		       }
		    }
		  else
		    {	/* Integrate/node.scm 412 */
		       obj_t celled_1029;
		       {	/* Integrate/node.scm 412 */
			  obj_t aux_2425;
			  {	/* Integrate/node.scm 412 */
			     sfun_bglt obj_1777;
			     obj_1777 =
				(sfun_bglt) (fun_1025);
			     aux_2425 =
				(((sfun_bglt) CREF(obj_1777))->args);
			  }
			  celled_1029 =
			     celled_bindings_3_integrate_node(aux_2425);
		       }
		       {
			  obj_t l1563_1030;
			  l1563_1030 = celled_1029;
			lname1564_1031:
			  if (
			     PAIRP(l1563_1030))
			    {	/* Integrate/node.scm 413 */
			       {	/* Integrate/node.scm 414 */
				  obj_t w_b_127_1033;
				  w_b_127_1033 =
				     CAR(l1563_1030);
				  {	/* Integrate/node.scm 414 */
				     obj_t arg1670_1035;
				     arg1670_1035 =
					CDR(w_b_127_1033);
				     {	/* Integrate/node.scm 414 */
					variable_bglt obj_1782;
					{	/* Integrate/node.scm 414 */
					   obj_t aux_2433;
					   aux_2433 =
					      CAR(w_b_127_1033);
					   obj_1782 =
					      (variable_bglt) (aux_2433);
					}
					((((variable_bglt) CREF(obj_1782))->fast_alpha_7) = ((obj_t) arg1670_1035), BUNSPEC);
				     }
				  }
			       }
			       {
				  obj_t l1563_2437;
				  l1563_2437 =
				     CDR(l1563_1030);
				  l1563_1030 = l1563_2437;
				  goto lname1564_1031;
			       }
			    }
			  else
			    {	/* Integrate/node.scm 413 */
			       ((bool_t) 1);
			    }
		       }
		       {	/* Integrate/node.scm 416 */
			  node_bglt nbody1_1037;
			  nbody1_1037 =
			     glo__115_integrate_node(
			     (node_bglt) (obody_1026), integrator_59);
			  {	/* Integrate/node.scm 416 */
			     obj_t nbody2_1038;
			     nbody2_1038 =
				cell_formals_12_integrate_node(celled_1029, nbody1_1037);
			     {	/* Integrate/node.scm 417 */

				{
				   obj_t l1565_1039;
				   l1565_1039 = celled_1029;
				 lname1566_1040:
				   if (
				      PAIRP(l1565_1039))
				     {	/* Integrate/node.scm 418 */
					{	/* Integrate/node.scm 419 */
					   variable_bglt obj_1788;
					   {	/* Integrate/node.scm 419 */
					      obj_t aux_2444;
					      {		/* ./Ieee/pair-list.scm 5701 */
						 obj_t aux_2445;
						 aux_2445 =
						    CAR(l1565_1039);
						 aux_2444 =
						    CAR(aux_2445);
					      }
					      obj_1788 =
						 (variable_bglt) (aux_2444);
					   }
					   ((((variable_bglt) CREF(obj_1788))->fast_alpha_7) = ((obj_t) BUNSPEC), BUNSPEC);
					}
					{
					   obj_t l1565_2450;
					   l1565_2450 =
					      CDR(l1565_1039);
					   l1565_1039 = l1565_2450;
					   goto lname1566_1040;
					}
				     }
				   else
				     {	/* Integrate/node.scm 418 */
					((bool_t) 1);
				     }
				}
				{	/* Integrate/node.scm 421 */
				   sfun_bglt obj_1791;
				   obj_1791 =
				      (sfun_bglt) (fun_1025);
				   return
				      ((((sfun_bglt) CREF(obj_1791))->body) = ((obj_t) nbody2_1038), BUNSPEC);
				}
			     }
			  }
		       }
		    }
	       }
	    }
	 }
      }
   }
}



/* method-init */
obj_t 
method_init_76_integrate_node()
{
   AN_OBJECT;
   {	/* Integrate/node.scm 14 */
      add_generic__110___object(glo__env_172_integrate_node, glo__default1567_env_173_integrate_node);
      add_inlined_method__244___object(glo__env_172_integrate_node, atom_ast_node, ((long) 0));
      add_inlined_method__244___object(glo__env_172_integrate_node, kwote_ast_node, ((long) 1));
      add_inlined_method__244___object(glo__env_172_integrate_node, var_ast_node, ((long) 2));
      add_inlined_method__244___object(glo__env_172_integrate_node, closure_ast_node, ((long) 3));
      add_inlined_method__244___object(glo__env_172_integrate_node, sequence_ast_node, ((long) 4));
      add_inlined_method__244___object(glo__env_172_integrate_node, app_ast_node, ((long) 5));
      add_inlined_method__244___object(glo__env_172_integrate_node, app_ly_162_ast_node, ((long) 6));
      add_inlined_method__244___object(glo__env_172_integrate_node, funcall_ast_node, ((long) 7));
      add_inlined_method__244___object(glo__env_172_integrate_node, pragma_ast_node, ((long) 8));
      add_inlined_method__244___object(glo__env_172_integrate_node, cast_ast_node, ((long) 9));
      add_inlined_method__244___object(glo__env_172_integrate_node, setq_ast_node, ((long) 10));
      add_inlined_method__244___object(glo__env_172_integrate_node, conditional_ast_node, ((long) 11));
      add_inlined_method__244___object(glo__env_172_integrate_node, fail_ast_node, ((long) 12));
      add_inlined_method__244___object(glo__env_172_integrate_node, select_ast_node, ((long) 13));
      add_inlined_method__244___object(glo__env_172_integrate_node, let_fun_218_ast_node, ((long) 14));
      add_inlined_method__244___object(glo__env_172_integrate_node, let_var_6_ast_node, ((long) 15));
      add_inlined_method__244___object(glo__env_172_integrate_node, set_ex_it_116_ast_node, ((long) 16));
      add_inlined_method__244___object(glo__env_172_integrate_node, jump_ex_it_184_ast_node, ((long) 17));
      add_inlined_method__244___object(glo__env_172_integrate_node, make_box_202_ast_node, ((long) 18));
      add_inlined_method__244___object(glo__env_172_integrate_node, box_ref_242_ast_node, ((long) 19));
      {		/* Integrate/node.scm 14 */
	 long aux_2475;
	 aux_2475 =
	    add_inlined_method__244___object(glo__env_172_integrate_node, box_set__221_ast_node, ((long) 20));
	 return
	    BINT(aux_2475);
      }
   }
}



/* glo! */
node_bglt 
glo__115_integrate_node(node_bglt node_10, variable_bglt integrator_11)
{
   AN_OBJECT;
   {	/* Integrate/node.scm 127 */
      {
	 obj_t method1758_1422;
	 obj_t class1763_1423;
	 {	/* Integrate/node.scm 127 */
	    obj_t arg1766_1420;
	    obj_t arg1767_1421;
	    {	/* Integrate/node.scm 127 */
	       object_bglt obj_1892;
	       obj_1892 =
		  (object_bglt) (node_10);
	       {	/* ./Llib/object.scm 2926 */
		  obj_t pre_method_105_1893;
		  pre_method_105_1893 =
		     PROCEDURE_REF(glo__env_172_integrate_node, ((long) 2));
		  if (
		     INTEGERP(pre_method_105_1893))
		    {	/* ./Llib/object.scm 2927 */
		       PROCEDURE_SET(glo__env_172_integrate_node, ((long) 2), BUNSPEC);
		       arg1766_1420 = pre_method_105_1893;
		    }
		  else
		    {	/* ./Llib/object.scm 2914 */
		       long obj_class_num_177_1898;
		       obj_class_num_177_1898 =
			  TYPE(obj_1892);
		       {	/* ./Llib/object.scm 2915 */
			  obj_t arg1176_1899;
			  arg1176_1899 =
			     PROCEDURE_REF(glo__env_172_integrate_node, ((long) 1));
			  {	/* ./Llib/object.scm 2738 */
			     long arg1177_1903;
			     {	/* ./Llib/object.scm 2738 */
				long arg1178_1904;
				arg1178_1904 =
				   OBJECT_TYPE;
				arg1177_1903 =
				   (obj_class_num_177_1898 - arg1178_1904);
			     }
			     arg1766_1420 =
				VECTOR_REF(arg1176_1899, arg1177_1903);
			  }
		       }
		    }
	       }
	    }
	    {	/* Integrate/node.scm 127 */
	       object_bglt object_1909;
	       object_1909 =
		  (object_bglt) (node_10);
	       {	/* ./Llib/object.scm 2695 */
		  long arg1179_1910;
		  {	/* ./Llib/object.scm 2695 */
		     long arg1180_1911;
		     long arg1181_1912;
		     arg1180_1911 =
			TYPE(object_1909);
		     arg1181_1912 =
			OBJECT_TYPE;
		     arg1179_1910 =
			(arg1180_1911 - arg1181_1912);
		  }
		  {	/* ./Llib/object.scm 2695 */
		     obj_t vector_1916;
		     vector_1916 = _classes__134___object;
		     arg1767_1421 =
			VECTOR_REF(vector_1916, arg1179_1910);
		  }
	       }
	    }
	    {	/* Integrate/node.scm 127 */
	       obj_t aux_2493;
	       method1758_1422 = arg1766_1420;
	       class1763_1423 = arg1767_1421;
	       {

		  if (
		     INTEGERP(method1758_1422))
		    {	/* Integrate/node.scm 127 */
		       switch (
			  (long) CINT(method1758_1422))
			 {
			 case ((long) 0):

			    {	/* Integrate/node.scm 127 */
			       atom_bglt aux_2496;
			       aux_2496 =
				  (atom_bglt) (node_10);
			       aux_2493 =
				  (obj_t) (aux_2496);
			    }
			    break;
			 case ((long) 1):

			    {	/* Integrate/node.scm 127 */
			       kwote_bglt aux_2499;
			       aux_2499 =
				  (kwote_bglt) (node_10);
			       aux_2493 =
				  (obj_t) (aux_2499);
			    }
			    break;
			 case ((long) 2):

			    {	/* Integrate/node.scm 145 */
			       var_bglt node_1433;
			       node_1433 =
				  (var_bglt) (node_10);
			       {	/* Integrate/node.scm 145 */
				  variable_bglt var_1435;
				  var_1435 =
				     (((var_bglt) CREF(node_1433))->variable);
				  {	/* Integrate/node.scm 145 */
				     obj_t alpha_1436;
				     alpha_1436 =
					(((variable_bglt) CREF(var_1435))->fast_alpha_7);
				     {	/* Integrate/node.scm 146 */

					{	/* Integrate/node.scm 148 */
					   bool_t test1770_1437;
					   test1770_1437 =
					      is_a__118___object(alpha_1436, local_ast_var);
					   if (test1770_1437)
					     {	/* Integrate/node.scm 148 */
						{	/* Integrate/node.scm 149 */
						   variable_bglt val1209_1922;
						   val1209_1922 =
						      (variable_bglt) (alpha_1436);
						   ((((var_bglt) CREF(node_1433))->variable) = ((variable_bglt) val1209_1922), BUNSPEC);
						}
						{	/* Integrate/node.scm 150 */
						   node_bglt aux_2509;
						   aux_2509 =
						      glo__115_integrate_node(
						      (node_bglt) (node_1433), integrator_11);
						   aux_2493 =
						      (obj_t) (aux_2509);
						}
					     }
					   else
					     {	/* Integrate/node.scm 151 */
						bool_t test1771_1438;
						test1771_1438 =
						   is_a__118___object(
						   (obj_t) (var_1435), global_ast_var);
						if (test1771_1438)
						  {	/* Integrate/node.scm 151 */
						     aux_2493 =
							(obj_t) (node_1433);
						  }
						else
						  {	/* Integrate/node.scm 151 */
						     if (
							integrate_celled__59_integrate_node(
							   (local_bglt) (var_1435)))
						       {	/* Integrate/node.scm 153 */
							  {	/* Integrate/node.scm 154 */
							     local_bglt obj_1924;
							     obj_t val1084_1925;
							     obj_1924 =
								(local_bglt) (var_1435);
							     val1084_1925 =
								CNST_TABLE_REF(((long) 0));
							     ((((local_bglt) CREF(obj_1924))->access) = ((obj_t) val1084_1925), BUNSPEC);
							  }
							  {	/* Integrate/node.scm 156 */
							     obj_t arg1773_1440;
							     type_bglt arg1774_1441;
							     {	/* Integrate/node.scm 156 */
								node_bglt obj_1926;
								obj_1926 =
								   (node_bglt) (node_1433);
								arg1773_1440 =
								   (((node_bglt) CREF(obj_1926))->loc);
							     }
							     {	/* Integrate/node.scm 157 */
								node_bglt obj_1927;
								obj_1927 =
								   (node_bglt) (node_1433);
								arg1774_1441 =
								   (((node_bglt) CREF(obj_1927))->type);
							     }
							     {	/* Integrate/node.scm 155 */
								box_ref_242_bglt res1907_1942;
								{	/* Integrate/node.scm 155 */
								   obj_t key_1931;
								   key_1931 =
								      BINT(((long) -1));
								   {	/* ./Ast/node.scm 1247 */
								      box_ref_242_bglt new1419_1933;
								      new1419_1933 =
									 ((box_ref_242_bglt) BREF(GC_MALLOC(sizeof(struct box_ref_242))));
								      {		/* ./Ast/node.scm 1247 */
									 long arg1688_1934;
									 arg1688_1934 =
									    class_num_218___object(box_ref_242_ast_node);
									 {	/* ./Ast/node.scm 1247 */
									    obj_t obj_1940;
									    obj_1940 =
									       (obj_t) (new1419_1933);
									    (((obj_t) CREF(obj_1940))->header = MAKE_HEADER(arg1688_1934, 0), BUNSPEC);
									 }
								      }
								      {		/* ./Ast/node.scm 1247 */
									 object_bglt aux_2532;
									 aux_2532 =
									    (object_bglt) (new1419_1933);
									 OBJECT_WIDENING_SET(aux_2532, BFALSE);
								      }
								      ((((box_ref_242_bglt) CREF(new1419_1933))->loc) = ((obj_t) arg1773_1440), BUNSPEC);
								      ((((box_ref_242_bglt) CREF(new1419_1933))->type) = ((type_bglt) arg1774_1441), BUNSPEC);
								      ((((box_ref_242_bglt) CREF(new1419_1933))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
								      ((((box_ref_242_bglt) CREF(new1419_1933))->key) = ((obj_t) key_1931), BUNSPEC);
								      ((((box_ref_242_bglt) CREF(new1419_1933))->var) = ((var_bglt) node_1433), BUNSPEC);
								      res1907_1942 = new1419_1933;
								   }
								}
								aux_2493 =
								   (obj_t) (res1907_1942);
							     }
							  }
						       }
						     else
						       {	/* Integrate/node.scm 153 */
							  aux_2493 =
							     (obj_t) (node_1433);
						       }
						  }
					     }
					}
				     }
				  }
			       }
			    }
			    break;
			 case ((long) 3):

			    {	/* Integrate/node.scm 166 */
			       obj_t arg1779_1448;
			       {	/* Integrate/node.scm 166 */
				  obj_t aux_2542;
				  {	/* Integrate/node.scm 166 */
				     closure_bglt aux_2543;
				     aux_2543 =
					(closure_bglt) (node_10);
				     aux_2542 =
					(obj_t) (aux_2543);
				  }
				  arg1779_1448 =
				     shape_tools_shape(aux_2542);
			       }
			       aux_2493 =
				  internal_error_43_tools_error(string1916_integrate_node, string1917_integrate_node, arg1779_1448);
			    }
			    break;
			 case ((long) 4):

			    {	/* Integrate/node.scm 172 */
			       sequence_bglt node_1449;
			       node_1449 =
				  (sequence_bglt) (node_10);
			       glo___241_integrate_node(
				  (((sequence_bglt) CREF(node_1449))->nodes), integrator_11);
			       aux_2493 =
				  (obj_t) (node_1449);
			    }
			    break;
			 case ((long) 5):

			    {	/* Integrate/node.scm 180 */
			       app_bglt node_1453;
			       node_1453 =
				  (app_bglt) (node_10);
			       {	/* Integrate/node.scm 181 */
				  variable_bglt fun_1456;
				  {	/* Integrate/node.scm 181 */
				     var_bglt arg1807_1491;
				     arg1807_1491 =
					(((app_bglt) CREF(node_1453))->fun);
				     fun_1456 =
					(((var_bglt) CREF(arg1807_1491))->variable);
				  }
				  {	/* Integrate/node.scm 181 */
				     value_bglt info_1457;
				     info_1457 =
					(((variable_bglt) CREF(fun_1456))->value);
				     {	/* Integrate/node.scm 182 */

					{	/* Integrate/node.scm 184 */
					   bool_t test1781_1458;
					   {	/* Integrate/node.scm 184 */
					      bool_t test1787_1464;
					      test1787_1464 =
						 is_a__118___object(
						 (obj_t) (fun_1456), local_ast_var);
					      if (test1787_1464)
						{	/* Integrate/node.scm 184 */
						   sfun_iinfo_105_bglt obj_1948;
						   obj_1948 =
						      (sfun_iinfo_105_bglt) (info_1457);
						   {
						      obj_t aux_2560;
						      {		/* ./Integrate/iinfo.scm 1326 */
							 object_bglt aux_2561;
							 aux_2561 =
							    (object_bglt) (obj_1948);
							 aux_2560 =
							    OBJECT_WIDENING(aux_2561);
						      }
						      test1781_1458 =
							 (((sfun_iinfo_105_bglt) CREF(aux_2560))->g__219);
						   }
						}
					      else
						{	/* Integrate/node.scm 184 */
						   test1781_1458 = ((bool_t) 0);
						}
					   }
					   if (test1781_1458)
					     {	/* Integrate/node.scm 186 */
						var_bglt arg1782_1459;
						{	/* Integrate/node.scm 186 */
						   obj_t arg1783_1460;
						   type_bglt arg1784_1461;
						   obj_t arg1785_1462;
						   arg1783_1460 =
						      (((app_bglt) CREF(node_1453))->loc);
						   {	/* Integrate/node.scm 188 */
						      obj_t arg1786_1463;
						      arg1786_1463 =
							 the_global_201_integrate_local__global_163(
							 (local_bglt) (fun_1456));
						      {		/* Integrate/node.scm 188 */
							 variable_bglt obj_1950;
							 obj_1950 =
							    (variable_bglt) (arg1786_1463);
							 arg1784_1461 =
							    (((variable_bglt) CREF(obj_1950))->type);
						      }
						   }
						   arg1785_1462 =
						      the_global_201_integrate_local__global_163(
						      (local_bglt) (fun_1456));
						   {	/* Integrate/node.scm 186 */
						      var_bglt res1908_1961;
						      {		/* Integrate/node.scm 186 */
							 variable_bglt variable_1953;
							 variable_1953 =
							    (variable_bglt) (arg1785_1462);
							 {	/* ./Ast/node.scm 1127 */
							    var_bglt new1210_1954;
							    new1210_1954 =
							       ((var_bglt) BREF(GC_MALLOC(sizeof(struct var))));
							    {	/* ./Ast/node.scm 1127 */
							       long arg1725_1955;
							       arg1725_1955 =
								  class_num_218___object(var_ast_node);
							       {	/* ./Ast/node.scm 1127 */
								  obj_t obj_1959;
								  obj_1959 =
								     (obj_t) (new1210_1954);
								  (((obj_t) CREF(obj_1959))->header = MAKE_HEADER(arg1725_1955, 0), BUNSPEC);
							       }
							    }
							    {	/* ./Ast/node.scm 1127 */
							       object_bglt aux_2578;
							       aux_2578 =
								  (object_bglt) (new1210_1954);
							       OBJECT_WIDENING_SET(aux_2578, BFALSE);
							    }
							    ((((var_bglt) CREF(new1210_1954))->loc) = ((obj_t) arg1783_1460), BUNSPEC);
							    ((((var_bglt) CREF(new1210_1954))->type) = ((type_bglt) arg1784_1461), BUNSPEC);
							    ((((var_bglt) CREF(new1210_1954))->variable) = ((variable_bglt) variable_1953), BUNSPEC);
							    res1908_1961 = new1210_1954;
							 }
						      }
						      arg1782_1459 = res1908_1961;
						   }
						}
						((((app_bglt) CREF(node_1453))->fun) = ((var_bglt) arg1782_1459), BUNSPEC);
					     }
					   else
					     {	/* Integrate/node.scm 184 */
						BUNSPEC;
					     }
					}
					{
					   obj_t nodes_1465;
					   nodes_1465 =
					      (((app_bglt) CREF(node_1453))->args);
					 liip_1466:
					   if (
					      NULLP(nodes_1465))
					     {	/* Integrate/node.scm 193 */
						CNST_TABLE_REF(((long) 2));
					     }
					   else
					     {	/* Integrate/node.scm 193 */
						{	/* Integrate/node.scm 196 */
						   node_bglt arg1790_1469;
						   {	/* Integrate/node.scm 196 */
						      node_bglt aux_2588;
						      {		/* Integrate/node.scm 196 */
							 obj_t aux_2589;
							 aux_2589 =
							    CAR(nodes_1465);
							 aux_2588 =
							    (node_bglt) (aux_2589);
						      }
						      arg1790_1469 =
							 glo__115_integrate_node(aux_2588, integrator_11);
						   }
						   {	/* ./Ieee/pair-list.scm 5890 */
						      obj_t aux_2593;
						      aux_2593 =
							 (obj_t) (arg1790_1469);
						      SET_CAR(nodes_1465, aux_2593);
						   }
						}
						{
						   obj_t nodes_2596;
						   nodes_2596 =
						      CDR(nodes_1465);
						   nodes_1465 = nodes_2596;
						   goto liip_1466;
						}
					     }
					}
					{	/* Integrate/node.scm 199 */
					   bool_t test1793_1472;
					   {	/* Integrate/node.scm 199 */
					      bool_t test1805_1489;
					      test1805_1489 =
						 is_a__118___object(
						 (obj_t) (fun_1456), global_ast_var);
					      if (test1805_1489)
						{	/* Integrate/node.scm 199 */
						   test1793_1472 = ((bool_t) 1);
						}
					      else
						{	/* Integrate/node.scm 199 */
						   bool_t test_2602;
						   {	/* Integrate/node.scm 199 */
						      sfun_iinfo_105_bglt obj_1971;
						      obj_1971 =
							 (sfun_iinfo_105_bglt) (info_1457);
						      {
							 obj_t aux_2604;
							 {	/* ./Integrate/iinfo.scm 1326 */
							    object_bglt aux_2605;
							    aux_2605 =
							       (object_bglt) (obj_1971);
							    aux_2604 =
							       OBJECT_WIDENING(aux_2605);
							 }
							 test_2602 =
							    (((sfun_iinfo_105_bglt) CREF(aux_2604))->g__219);
						      }
						   }
						   if (test_2602)
						     {	/* Integrate/node.scm 199 */
							test1793_1472 = ((bool_t) 0);
						     }
						   else
						     {	/* Integrate/node.scm 199 */
							test1793_1472 = ((bool_t) 1);
						     }
						}
					   }
					   if (test1793_1472)
					     {	/* Integrate/node.scm 199 */
						CNST_TABLE_REF(((long) 2));
					     }
					   else
					     {	/* Integrate/node.scm 199 */
						{
						   obj_t new_actuals_73_1473;
						   obj_t kaptured_1474;
						   new_actuals_73_1473 =
						      (((app_bglt) CREF(node_1453))->args);
						   {	/* Integrate/node.scm 205 */
						      sfun_iinfo_105_bglt obj_1973;
						      obj_1973 =
							 (sfun_iinfo_105_bglt) (info_1457);
						      {
							 obj_t aux_2640;
							 {	/* ./Integrate/iinfo.scm 1360 */
							    object_bglt aux_2641;
							    aux_2641 =
							       (object_bglt) (obj_1973);
							    aux_2640 =
							       OBJECT_WIDENING(aux_2641);
							 }
							 kaptured_1474 =
							    (((sfun_iinfo_105_bglt) CREF(aux_2640))->kaptured);
						      }
						   }
						 loop_1475:
						   if (
						      NULLP(kaptured_1474))
						     {	/* Integrate/node.scm 206 */
							((((app_bglt) CREF(node_1453))->args) = ((obj_t) new_actuals_73_1473), BUNSPEC);
						     }
						   else
						     {	/* Integrate/node.scm 208 */
							obj_t kap_1479;
							kap_1479 =
							   CAR(kaptured_1474);
							{	/* Integrate/node.scm 208 */
							   obj_t alpha_1480;
							   {	/* Integrate/node.scm 209 */
							      local_bglt obj_1978;
							      obj_1978 =
								 (local_bglt) (kap_1479);
							      alpha_1480 =
								 (((local_bglt) CREF(obj_1978))->fast_alpha_7);
							   }
							   {	/* Integrate/node.scm 209 */
							      obj_t var_1481;
							      {		/* Integrate/node.scm 210 */
								 bool_t test1804_1488;
								 test1804_1488 =
								    is_a__118___object(alpha_1480, local_ast_var);
								 if (test1804_1488)
								   {	/* Integrate/node.scm 210 */
								      var_1481 = alpha_1480;
								   }
								 else
								   {	/* Integrate/node.scm 210 */
								      var_1481 = kap_1479;
								   }
							      }
							      {		/* Integrate/node.scm 210 */

								 {	/* Integrate/node.scm 211 */
								    obj_t arg1797_1482;
								    obj_t arg1798_1483;
								    {	/* Integrate/node.scm 211 */
								       var_bglt arg1800_1484;
								       {	/* Integrate/node.scm 211 */
									  obj_t arg1801_1485;
									  obj_t arg1802_1486;
									  arg1801_1485 =
									     (((app_bglt) CREF(node_1453))->loc);
									  arg1802_1486 = ____74_type_cache;
									  {	/* Integrate/node.scm 211 */
									     var_bglt res1909_1991;
									     {	/* Integrate/node.scm 211 */
										type_bglt type_1982;
										variable_bglt variable_1983;
										type_1982 =
										   (type_bglt) (arg1802_1486);
										variable_1983 =
										   (variable_bglt) (var_1481);
										{	/* ./Ast/node.scm 1127 */
										   var_bglt new1210_1984;
										   new1210_1984 =
										      ((var_bglt) BREF(GC_MALLOC(sizeof(struct var))));
										   {	/* ./Ast/node.scm 1127 */
										      long arg1725_1985;
										      arg1725_1985 =
											 class_num_218___object(var_ast_node);
										      {		/* ./Ast/node.scm 1127 */
											 obj_t obj_1989;
											 obj_1989 =
											    (obj_t) (new1210_1984);
											 (((obj_t) CREF(obj_1989))->header = MAKE_HEADER(arg1725_1985, 0), BUNSPEC);
										      }
										   }
										   {	/* ./Ast/node.scm 1127 */
										      object_bglt aux_2626;
										      aux_2626 =
											 (object_bglt) (new1210_1984);
										      OBJECT_WIDENING_SET(aux_2626, BFALSE);
										   }
										   ((((var_bglt) CREF(new1210_1984))->loc) = ((obj_t) arg1801_1485), BUNSPEC);
										   ((((var_bglt) CREF(new1210_1984))->type) = ((type_bglt) type_1982), BUNSPEC);
										   ((((var_bglt) CREF(new1210_1984))->variable) = ((variable_bglt) variable_1983), BUNSPEC);
										   res1909_1991 = new1210_1984;
										}
									     }
									     arg1800_1484 = res1909_1991;
									  }
								       }
								       {	/* ./Ieee/pair-list.scm 5689 */
									  obj_t aux_2632;
									  aux_2632 =
									     (obj_t) (arg1800_1484);
									  arg1797_1482 =
									     MAKE_PAIR(aux_2632, new_actuals_73_1473);
								       }
								    }
								    arg1798_1483 =
								       CDR(kaptured_1474);
								    {
								       obj_t kaptured_2637;
								       obj_t new_actuals_73_2636;
								       new_actuals_73_2636 = arg1797_1482;
								       kaptured_2637 = arg1798_1483;
								       kaptured_1474 = kaptured_2637;
								       new_actuals_73_1473 = new_actuals_73_2636;
								       goto loop_1475;
								    }
								 }
							      }
							   }
							}
						     }
						}
					     }
					}
					aux_2493 =
					   (obj_t) (node_1453);
				     }
				  }
			       }
			    }
			    break;
			 case ((long) 6):

			    {	/* Integrate/node.scm 223 */
			       app_ly_162_bglt node_1492;
			       node_1492 =
				  (app_ly_162_bglt) (node_10);
			       {	/* Integrate/node.scm 224 */
				  node_bglt arg1809_1495;
				  arg1809_1495 =
				     glo__115_integrate_node(
				     (((app_ly_162_bglt) CREF(node_1492))->fun), integrator_11);
				  ((((app_ly_162_bglt) CREF(node_1492))->fun) = ((node_bglt) arg1809_1495), BUNSPEC);
			       }
			       {	/* Integrate/node.scm 225 */
				  node_bglt arg1811_1497;
				  arg1811_1497 =
				     glo__115_integrate_node(
				     (((app_ly_162_bglt) CREF(node_1492))->arg), integrator_11);
				  ((((app_ly_162_bglt) CREF(node_1492))->arg) = ((node_bglt) arg1811_1497), BUNSPEC);
			       }
			       aux_2493 =
				  (obj_t) (node_1492);
			    }
			    break;
			 case ((long) 7):

			    {	/* Integrate/node.scm 232 */
			       funcall_bglt node_1499;
			       node_1499 =
				  (funcall_bglt) (node_10);
			       {	/* Integrate/node.scm 233 */
				  node_bglt arg1813_1502;
				  arg1813_1502 =
				     glo__115_integrate_node(
				     (((funcall_bglt) CREF(node_1499))->fun), integrator_11);
				  ((((funcall_bglt) CREF(node_1499))->fun) = ((node_bglt) arg1813_1502), BUNSPEC);
			       }
			       glo___241_integrate_node(
				  (((funcall_bglt) CREF(node_1499))->args), integrator_11);
			       aux_2493 =
				  (obj_t) (node_1499);
			    }
			    break;
			 case ((long) 8):

			    {	/* Integrate/node.scm 241 */
			       pragma_bglt node_1505;
			       node_1505 =
				  (pragma_bglt) (node_10);
			       glo___241_integrate_node(
				  (((pragma_bglt) CREF(node_1505))->args), integrator_11);
			       aux_2493 =
				  (obj_t) (node_1505);
			    }
			    break;
			 case ((long) 9):

			    {	/* Integrate/node.scm 249 */
			       cast_bglt node_1509;
			       node_1509 =
				  (cast_bglt) (node_10);
			       glo__115_integrate_node(
				  (((cast_bglt) CREF(node_1509))->arg), integrator_11);
			       aux_2493 =
				  (obj_t) (node_1509);
			    }
			    break;
			 case ((long) 10):

			    {	/* Integrate/node.scm 257 */
			       setq_bglt node_1513;
			       node_1513 =
				  (setq_bglt) (node_10);
			       {	/* Integrate/node.scm 258 */
				  node_bglt arg1818_1516;
				  arg1818_1516 =
				     glo__115_integrate_node(
				     (((setq_bglt) CREF(node_1513))->value), integrator_11);
				  ((((setq_bglt) CREF(node_1513))->value) = ((node_bglt) arg1818_1516), BUNSPEC);
			       }
			       {	/* Integrate/node.scm 259 */
				  variable_bglt var_1518;
				  {	/* Integrate/node.scm 259 */
				     var_bglt arg1849_1551;
				     arg1849_1551 =
					(((setq_bglt) CREF(node_1513))->var);
				     var_1518 =
					(((var_bglt) CREF(arg1849_1551))->variable);
				  }
				  {
				     obj_t var_1519;
				     obj_t alpha_1520;
				     var_1519 =
					(obj_t) (var_1518);
				     alpha_1520 =
					(((variable_bglt) CREF(var_1518))->fast_alpha_7);
				   loop_1521:
				     {	/* Integrate/node.scm 262 */
					bool_t test1822_1523;
					test1822_1523 =
					   is_a__118___object(alpha_1520, local_ast_var);
					if (test1822_1523)
					  {	/* Integrate/node.scm 262 */
					     {	/* Integrate/node.scm 264 */
						var_bglt arg1823_1524;
						arg1823_1524 =
						   (((setq_bglt) CREF(node_1513))->var);
						{	/* Integrate/node.scm 264 */
						   variable_bglt val1209_2016;
						   val1209_2016 =
						      (variable_bglt) (alpha_1520);
						   ((((var_bglt) CREF(arg1823_1524))->variable) = ((variable_bglt) val1209_2016), BUNSPEC);
						}
					     }
					     {
						obj_t alpha_2681;
						obj_t var_2680;
						var_2680 = alpha_1520;
						{	/* Integrate/node.scm 265 */
						   variable_bglt obj_2017;
						   obj_2017 =
						      (variable_bglt) (alpha_1520);
						   alpha_2681 =
						      (((variable_bglt) CREF(obj_2017))->fast_alpha_7);
						}
						alpha_1520 = alpha_2681;
						var_1519 = var_2680;
						goto loop_1521;
					     }
					  }
					else
					  {	/* Integrate/node.scm 266 */
					     variable_bglt var_1526;
					     {	/* Integrate/node.scm 266 */
						var_bglt arg1848_1550;
						arg1848_1550 =
						   (((setq_bglt) CREF(node_1513))->var);
						var_1526 =
						   (((var_bglt) CREF(arg1848_1550))->variable);
					     }
					     {	/* Integrate/node.scm 267 */
						bool_t test1825_1527;
						{	/* Integrate/node.scm 267 */
						   bool_t test1847_1549;
						   test1847_1549 =
						      is_a__118___object(
						      (obj_t) (var_1526), local_ast_var);
						   if (test1847_1549)
						     {	/* Integrate/node.scm 267 */
							test1825_1527 =
							   integrate_celled__59_integrate_node(
							   (local_bglt) (var_1526));
						     }
						   else
						     {	/* Integrate/node.scm 267 */
							test1825_1527 = ((bool_t) 0);
						     }
						}
						if (test1825_1527)
						  {	/* Integrate/node.scm 268 */
						     local_bglt a_var_30_1528;
						     obj_t loc_1529;
						     a_var_30_1528 =
							make_local_svar_140_ast_local(
							CNST_TABLE_REF(((long) 3)),
							(type_bglt) (_obj__252_type_cache));
						     {	/* Integrate/node.scm 269 */
							node_bglt obj_2021;
							obj_2021 =
							   (node_bglt) (node_1513);
							loc_1529 =
							   (((node_bglt) CREF(obj_2021))->loc);
						     }
						     {	/* Integrate/node.scm 270 */
							local_bglt obj_2022;
							obj_t val1084_2023;
							obj_2022 =
							   (local_bglt) (var_1526);
							val1084_2023 =
							   CNST_TABLE_REF(((long) 0));
							((((local_bglt) CREF(obj_2022))->access) = ((obj_t) val1084_2023), BUNSPEC);
						     }
						     {	/* Integrate/node.scm 271 */
							svar_iinfo_76_bglt obj1543_1530;
							obj1543_1530 =
							   ((svar_iinfo_76_bglt) (
							      (((local_bglt) CREF(a_var_30_1528))->value)));
							{	/* Integrate/node.scm 271 */
							   svar_iinfo_76_bglt arg1826_1531;
							   {	/* Integrate/node.scm 271 */
							      svar_iinfo_76_bglt res1910_2034;
							      {		/* ./Integrate/iinfo.scm 1306 */
								 svar_iinfo_76_bglt new1442_2029;
								 new1442_2029 =
								    ((svar_iinfo_76_bglt) BREF(GC_MALLOC(sizeof(struct svar_iinfo_76))));
								 ((((svar_iinfo_76_bglt) CREF(new1442_2029))->f_mark_181) = ((obj_t) BUNSPEC), BUNSPEC);
								 ((((svar_iinfo_76_bglt) CREF(new1442_2029))->u_mark_209) = ((obj_t) BUNSPEC), BUNSPEC);
								 ((((svar_iinfo_76_bglt) CREF(new1442_2029))->kaptured__204) = ((bool_t) ((bool_t) 0)), BUNSPEC);
								 ((((svar_iinfo_76_bglt) CREF(new1442_2029))->celled__113) = ((bool_t) ((bool_t) 0)), BUNSPEC);
								 res1910_2034 = new1442_2029;
							      }
							      arg1826_1531 = res1910_2034;
							   }
							   {	/* Integrate/node.scm 271 */
							      obj_t aux_2709;
							      object_bglt aux_2707;
							      aux_2709 =
								 (obj_t) (arg1826_1531);
							      aux_2707 =
								 (object_bglt) (obj1543_1530);
							      OBJECT_WIDENING_SET(aux_2707, aux_2709);
							   }
							}
							{	/* Integrate/node.scm 271 */
							   long arg1828_1533;
							   arg1828_1533 =
							      class_num_218___object(svar_iinfo_76_integrate_info);
							   {	/* Integrate/node.scm 271 */
							      obj_t obj_2035;
							      obj_2035 =
								 (obj_t) (obj1543_1530);
							      (((obj_t) CREF(obj_2035))->header = MAKE_HEADER(arg1828_1533, 0), BUNSPEC);
							   }
							}
							obj1543_1530;
						     }
						     {	/* Integrate/node.scm 273 */
							obj_t arg1831_1535;
							obj_t arg1833_1537;
							box_set__221_bglt arg1834_1538;
							arg1831_1535 = ____74_type_cache;
							{	/* Integrate/node.scm 276 */
							   obj_t arg1835_1539;
							   {	/* ./Ieee/pair-list.scm 5689 */
							      obj_t aux_2717;
							      obj_t aux_2715;
							      {		/* Integrate/node.scm 276 */
								 node_bglt aux_2718;
								 aux_2718 =
								    (((setq_bglt) CREF(node_1513))->value);
								 aux_2717 =
								    (obj_t) (aux_2718);
							      }
							      aux_2715 =
								 (obj_t) (a_var_30_1528);
							      arg1835_1539 =
								 MAKE_PAIR(aux_2715, aux_2717);
							   }
							   {	/* Integrate/node.scm 276 */
							      obj_t list1836_1540;
							      list1836_1540 =
								 MAKE_PAIR(arg1835_1539, BNIL);
							      arg1833_1537 = list1836_1540;
							   }
							}
							{	/* Integrate/node.scm 277 */
							   obj_t arg1841_1543;
							   var_bglt arg1842_1544;
							   var_bglt arg1843_1545;
							   arg1841_1543 = ____74_type_cache;
							   arg1842_1544 =
							      (((setq_bglt) CREF(node_1513))->var);
							   {	/* Integrate/node.scm 281 */
							      obj_t arg1845_1547;
							      arg1845_1547 = ____74_type_cache;
							      {		/* Integrate/node.scm 281 */
								 var_bglt res1911_2052;
								 {	/* Integrate/node.scm 281 */
								    type_bglt type_2043;
								    variable_bglt variable_2044;
								    type_2043 =
								       (type_bglt) (arg1845_1547);
								    variable_2044 =
								       (variable_bglt) (a_var_30_1528);
								    {	/* ./Ast/node.scm 1127 */
								       var_bglt new1210_2045;
								       new1210_2045 =
									  ((var_bglt) BREF(GC_MALLOC(sizeof(struct var))));
								       {	/* ./Ast/node.scm 1127 */
									  long arg1725_2046;
									  arg1725_2046 =
									     class_num_218___object(var_ast_node);
									  {	/* ./Ast/node.scm 1127 */
									     obj_t obj_2050;
									     obj_2050 =
										(obj_t) (new1210_2045);
									     (((obj_t) CREF(obj_2050))->header = MAKE_HEADER(arg1725_2046, 0), BUNSPEC);
									  }
								       }
								       {	/* ./Ast/node.scm 1127 */
									  object_bglt aux_2730;
									  aux_2730 =
									     (object_bglt) (new1210_2045);
									  OBJECT_WIDENING_SET(aux_2730, BFALSE);
								       }
								       ((((var_bglt) CREF(new1210_2045))->loc) = ((obj_t) loc_1529), BUNSPEC);
								       ((((var_bglt) CREF(new1210_2045))->type) = ((type_bglt) type_2043), BUNSPEC);
								       ((((var_bglt) CREF(new1210_2045))->variable) = ((variable_bglt) variable_2044), BUNSPEC);
								       res1911_2052 = new1210_2045;
								    }
								 }
								 arg1843_1545 = res1911_2052;
							      }
							   }
							   {	/* Integrate/node.scm 277 */
							      box_set__221_bglt res1912_2065;
							      {		/* Integrate/node.scm 277 */
								 type_bglt type_2054;
								 node_bglt value_2056;
								 type_2054 =
								    (type_bglt) (arg1841_1543);
								 value_2056 =
								    (node_bglt) (arg1843_1545);
								 {	/* ./Ast/node.scm 1251 */
								    box_set__221_bglt new1430_2057;
								    new1430_2057 =
								       ((box_set__221_bglt) BREF(GC_MALLOC(sizeof(struct box_set__221))));
								    {	/* ./Ast/node.scm 1251 */
								       long arg1686_2058;
								       arg1686_2058 =
									  class_num_218___object(box_set__221_ast_node);
								       {	/* ./Ast/node.scm 1251 */
									  obj_t obj_2063;
									  obj_2063 =
									     (obj_t) (new1430_2057);
									  (((obj_t) CREF(obj_2063))->header = MAKE_HEADER(arg1686_2058, 0), BUNSPEC);
								       }
								    }
								    {	/* ./Ast/node.scm 1251 */
								       object_bglt aux_2742;
								       aux_2742 =
									  (object_bglt) (new1430_2057);
								       OBJECT_WIDENING_SET(aux_2742, BFALSE);
								    }
								    ((((box_set__221_bglt) CREF(new1430_2057))->loc) = ((obj_t) loc_1529), BUNSPEC);
								    ((((box_set__221_bglt) CREF(new1430_2057))->type) = ((type_bglt) type_2054), BUNSPEC);
								    ((((box_set__221_bglt) CREF(new1430_2057))->var) = ((var_bglt) arg1842_1544), BUNSPEC);
								    ((((box_set__221_bglt) CREF(new1430_2057))->value) = ((node_bglt) value_2056), BUNSPEC);
								    res1912_2065 = new1430_2057;
								 }
							      }
							      arg1834_1538 = res1912_2065;
							   }
							}
							{	/* Integrate/node.scm 273 */
							   let_var_6_bglt res1913_2084;
							   {	/* Integrate/node.scm 273 */
							      type_bglt type_2067;
							      obj_t key_2069;
							      node_bglt body_2071;
							      type_2067 =
								 (type_bglt) (arg1831_1535);
							      key_2069 =
								 BINT(((long) -1));
							      body_2071 =
								 (node_bglt) (arg1834_1538);
							      {		/* ./Ast/node.scm 1220 */
								 let_var_6_bglt new1373_2073;
								 new1373_2073 =
								    ((let_var_6_bglt) BREF(GC_MALLOC(sizeof(struct let_var_6))));
								 {	/* ./Ast/node.scm 1220 */
								    long arg1696_2074;
								    arg1696_2074 =
								       class_num_218___object(let_var_6_ast_node);
								    {	/* ./Ast/node.scm 1220 */
								       obj_t obj_2082;
								       obj_2082 =
									  (obj_t) (new1373_2073);
								       (((obj_t) CREF(obj_2082))->header = MAKE_HEADER(arg1696_2074, 0), BUNSPEC);
								    }
								 }
								 {	/* ./Ast/node.scm 1220 */
								    object_bglt aux_2756;
								    aux_2756 =
								       (object_bglt) (new1373_2073);
								    OBJECT_WIDENING_SET(aux_2756, BFALSE);
								 }
								 ((((let_var_6_bglt) CREF(new1373_2073))->loc) = ((obj_t) loc_1529), BUNSPEC);
								 ((((let_var_6_bglt) CREF(new1373_2073))->type) = ((type_bglt) type_2067), BUNSPEC);
								 ((((let_var_6_bglt) CREF(new1373_2073))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
								 ((((let_var_6_bglt) CREF(new1373_2073))->key) = ((obj_t) key_2069), BUNSPEC);
								 ((((let_var_6_bglt) CREF(new1373_2073))->bindings) = ((obj_t) arg1833_1537), BUNSPEC);
								 ((((let_var_6_bglt) CREF(new1373_2073))->body) = ((node_bglt) body_2071), BUNSPEC);
								 ((((let_var_6_bglt) CREF(new1373_2073))->removable__42) = ((bool_t) ((bool_t) 1)), BUNSPEC);
								 res1913_2084 = new1373_2073;
							      }
							   }
							   aux_2493 =
							      (obj_t) (res1913_2084);
							}
						     }
						  }
						else
						  {	/* Integrate/node.scm 267 */
						     aux_2493 =
							(obj_t) (node_1513)
							;
						  }
					     }
					  }
				     }
				  }
			       }
			    }
			    break;
			 case ((long) 11):

			    {	/* Integrate/node.scm 291 */
			       conditional_bglt node_1552;
			       node_1552 =
				  (conditional_bglt) (node_10);
			       {	/* Integrate/node.scm 292 */
				  node_bglt arg1850_1555;
				  arg1850_1555 =
				     glo__115_integrate_node(
				     (((conditional_bglt) CREF(node_1552))->test), integrator_11);
				  ((((conditional_bglt) CREF(node_1552))->test) = ((node_bglt) arg1850_1555), BUNSPEC);
			       }
			       {	/* Integrate/node.scm 293 */
				  node_bglt arg1852_1557;
				  arg1852_1557 =
				     glo__115_integrate_node(
				     (((conditional_bglt) CREF(node_1552))->true), integrator_11);
				  ((((conditional_bglt) CREF(node_1552))->true) = ((node_bglt) arg1852_1557), BUNSPEC);
			       }
			       {	/* Integrate/node.scm 294 */
				  node_bglt arg1854_1559;
				  arg1854_1559 =
				     glo__115_integrate_node(
				     (((conditional_bglt) CREF(node_1552))->false), integrator_11);
				  ((((conditional_bglt) CREF(node_1552))->false) = ((node_bglt) arg1854_1559), BUNSPEC);
			       }
			       aux_2493 =
				  (obj_t) (node_1552);
			    }
			    break;
			 case ((long) 12):

			    {	/* Integrate/node.scm 301 */
			       fail_bglt node_1561;
			       node_1561 =
				  (fail_bglt) (node_10);
			       {	/* Integrate/node.scm 302 */
				  node_bglt arg1856_1564;
				  arg1856_1564 =
				     glo__115_integrate_node(
				     (((fail_bglt) CREF(node_1561))->proc), integrator_11);
				  ((((fail_bglt) CREF(node_1561))->proc) = ((node_bglt) arg1856_1564), BUNSPEC);
			       }
			       {	/* Integrate/node.scm 303 */
				  node_bglt arg1858_1566;
				  arg1858_1566 =
				     glo__115_integrate_node(
				     (((fail_bglt) CREF(node_1561))->msg), integrator_11);
				  ((((fail_bglt) CREF(node_1561))->msg) = ((node_bglt) arg1858_1566), BUNSPEC);
			       }
			       {	/* Integrate/node.scm 304 */
				  node_bglt arg1860_1568;
				  arg1860_1568 =
				     glo__115_integrate_node(
				     (((fail_bglt) CREF(node_1561))->obj), integrator_11);
				  ((((fail_bglt) CREF(node_1561))->obj) = ((node_bglt) arg1860_1568), BUNSPEC);
			       }
			       aux_2493 =
				  (obj_t) (node_1561);
			    }
			    break;
			 case ((long) 13):

			    {	/* Integrate/node.scm 311 */
			       select_bglt node_1570;
			       node_1570 =
				  (select_bglt) (node_10);
			       {	/* Integrate/node.scm 312 */
				  node_bglt arg1862_1573;
				  arg1862_1573 =
				     glo__115_integrate_node(
				     (((select_bglt) CREF(node_1570))->test), integrator_11);
				  ((((select_bglt) CREF(node_1570))->test) = ((node_bglt) arg1862_1573), BUNSPEC);
			       }
			       {
				  obj_t l1550_1575;
				  l1550_1575 =
				     (((select_bglt) CREF(node_1570))->clauses);
				lname1551_1576:
				  if (
				     PAIRP(l1550_1575))
				    {	/* Integrate/node.scm 313 */
				       {	/* Integrate/node.scm 314 */
					  obj_t clause_1579;
					  clause_1579 =
					     CAR(l1550_1575);
					  {	/* Integrate/node.scm 314 */
					     node_bglt arg1866_1580;
					     {	/* Integrate/node.scm 314 */
						node_bglt aux_2799;
						{	/* Integrate/node.scm 314 */
						   obj_t aux_2800;
						   aux_2800 =
						      CDR(clause_1579);
						   aux_2799 =
						      (node_bglt) (aux_2800);
						}
						arg1866_1580 =
						   glo__115_integrate_node(aux_2799, integrator_11);
					     }
					     {	/* ./Ieee/pair-list.scm 5896 */
						obj_t aux_2804;
						aux_2804 =
						   (obj_t) (arg1866_1580);
						SET_CDR(clause_1579, aux_2804);
					     }
					  }
				       }
				       {
					  obj_t l1550_2807;
					  l1550_2807 =
					     CDR(l1550_1575);
					  l1550_1575 = l1550_2807;
					  goto lname1551_1576;
				       }
				    }
				  else
				    {	/* Integrate/node.scm 313 */
				       ((bool_t) 1);
				    }
			       }
			       aux_2493 =
				  (obj_t) (node_1570);
			    }
			    break;
			 case ((long) 14):

			    {	/* Integrate/node.scm 322 */
			       let_fun_218_bglt node_1583;
			       node_1583 =
				  (let_fun_218_bglt) (node_10);
			       {	/* Integrate/node.scm 323 */
				  node_bglt arg1869_1586;
				  arg1869_1586 =
				     glo__115_integrate_node(
				     (((let_fun_218_bglt) CREF(node_1583))->body), integrator_11);
				  ((((let_fun_218_bglt) CREF(node_1583))->body) = ((node_bglt) arg1869_1586), BUNSPEC);
			       }
			       {
				  obj_t l1553_1588;
				  l1553_1588 =
				     (((let_fun_218_bglt) CREF(node_1583))->locals);
				lname1554_1589:
				  if (
				     PAIRP(l1553_1588))
				    {	/* Integrate/node.scm 324 */
				       {	/* Integrate/node.scm 325 */
					  local_bglt aux_2817;
					  {	/* Integrate/node.scm 325 */
					     obj_t aux_2818;
					     aux_2818 =
						CAR(l1553_1588);
					     aux_2817 =
						(local_bglt) (aux_2818);
					  }
					  globalize_local_fun__50_integrate_node(aux_2817, integrator_11);
				       }
				       {
					  obj_t l1553_2822;
					  l1553_2822 =
					     CDR(l1553_1588);
					  l1553_1588 = l1553_2822;
					  goto lname1554_1589;
				       }
				    }
				  else
				    {	/* Integrate/node.scm 324 */
				       ((bool_t) 1);
				    }
			       }
			       aux_2493 =
				  (obj_t) (node_1583);
			    }
			    break;
			 case ((long) 15):

			    {	/* Integrate/node.scm 333 */
			       let_var_6_bglt node_1594;
			       node_1594 =
				  (let_var_6_bglt) (node_10);
			       {
				  obj_t l1556_1597;
				  l1556_1597 =
				     (((let_var_6_bglt) CREF(node_1594))->bindings);
				lname1557_1598:
				  if (
				     PAIRP(l1556_1597))
				    {	/* Integrate/node.scm 334 */
				       {	/* Integrate/node.scm 335 */
					  obj_t binding_1601;
					  binding_1601 =
					     CAR(l1556_1597);
					  {	/* Integrate/node.scm 335 */
					     obj_t var_1602;
					     var_1602 =
						CAR(binding_1601);
					     {	/* Integrate/node.scm 337 */
						node_bglt arg1876_1604;
						{	/* Integrate/node.scm 337 */
						   node_bglt aux_2831;
						   {	/* Integrate/node.scm 337 */
						      obj_t aux_2832;
						      aux_2832 =
							 CDR(binding_1601);
						      aux_2831 =
							 (node_bglt) (aux_2832);
						   }
						   arg1876_1604 =
						      glo__115_integrate_node(aux_2831, integrator_11);
						}
						{	/* ./Ieee/pair-list.scm 5896 */
						   obj_t aux_2836;
						   aux_2836 =
						      (obj_t) (arg1876_1604);
						   SET_CDR(binding_1601, aux_2836);
						}
					     }
					     if (
						integrate_celled__59_integrate_node(
						   (local_bglt) (var_1602)))
					       {	/* Integrate/node.scm 338 */
						  {	/* Integrate/node.scm 340 */
						     local_bglt obj_2127;
						     type_bglt val1082_2128;
						     obj_2127 =
							(local_bglt) (var_1602);
						     val1082_2128 =
							(type_bglt) (_obj__252_type_cache);
						     ((((local_bglt) CREF(obj_2127))->type) = ((type_bglt) val1082_2128), BUNSPEC);
						  }
						  {	/* Integrate/node.scm 341 */
						     make_box_202_bglt arg1879_1606;
						     {	/* Integrate/node.scm 341 */
							node_bglt aux_2845;
							{	/* Integrate/node.scm 341 */
							   obj_t aux_2846;
							   aux_2846 =
							      CDR(binding_1601);
							   aux_2845 =
							      (node_bglt) (aux_2846);
							}
							arg1879_1606 =
							   a_make_cell_117_integrate_node(aux_2845,
							   (variable_bglt) (var_1602));
						     }
						     {	/* ./Ieee/pair-list.scm 5896 */
							obj_t aux_2851;
							aux_2851 =
							   (obj_t) (arg1879_1606);
							SET_CDR(binding_1601, aux_2851);
						     }
						  }
					       }
					     else
					       {	/* Integrate/node.scm 338 */
						  BUNSPEC;
					       }
					  }
				       }
				       {
					  obj_t l1556_2854;
					  l1556_2854 =
					     CDR(l1556_1597);
					  l1556_1597 = l1556_2854;
					  goto lname1557_1598;
				       }
				    }
				  else
				    {	/* Integrate/node.scm 334 */
				       ((bool_t) 1);
				    }
			       }
			       {	/* Integrate/node.scm 344 */
				  node_bglt arg1882_1609;
				  arg1882_1609 =
				     glo__115_integrate_node(
				     (((let_var_6_bglt) CREF(node_1594))->body), integrator_11);
				  ((((let_var_6_bglt) CREF(node_1594))->body) = ((node_bglt) arg1882_1609), BUNSPEC);
			       }
			       aux_2493 =
				  (obj_t) (node_1594);
			    }
			    break;
			 case ((long) 16):

			    {	/* Integrate/node.scm 351 */
			       set_ex_it_116_bglt node_1611;
			       node_1611 =
				  (set_ex_it_116_bglt) (node_10);
			       {	/* Integrate/node.scm 352 */
				  node_bglt arg1884_1614;
				  arg1884_1614 =
				     glo__115_integrate_node(
				     (((set_ex_it_116_bglt) CREF(node_1611))->body), integrator_11);
				  ((((set_ex_it_116_bglt) CREF(node_1611))->body) = ((node_bglt) arg1884_1614), BUNSPEC);
			       }
			       aux_2493 =
				  (obj_t) (node_1611);
			    }
			    break;
			 case ((long) 17):

			    {	/* Integrate/node.scm 359 */
			       jump_ex_it_184_bglt node_1616;
			       node_1616 =
				  (jump_ex_it_184_bglt) (node_10);
			       {	/* Integrate/node.scm 360 */
				  node_bglt arg1886_1619;
				  arg1886_1619 =
				     glo__115_integrate_node(
				     (((jump_ex_it_184_bglt) CREF(node_1616))->exit), integrator_11);
				  ((((jump_ex_it_184_bglt) CREF(node_1616))->exit) = ((node_bglt) arg1886_1619), BUNSPEC);
			       }
			       {	/* Integrate/node.scm 361 */
				  node_bglt arg1888_1621;
				  arg1888_1621 =
				     glo__115_integrate_node(
				     (((jump_ex_it_184_bglt) CREF(node_1616))->value), integrator_11);
				  ((((jump_ex_it_184_bglt) CREF(node_1616))->value) = ((node_bglt) arg1888_1621), BUNSPEC);
			       }
			       aux_2493 =
				  (obj_t) (node_1616);
			    }
			    break;
			 case ((long) 18):

			    {	/* Integrate/node.scm 368 */
			       make_box_202_bglt node_1623;
			       node_1623 =
				  (make_box_202_bglt) (node_10);
			       {	/* Integrate/node.scm 369 */
				  node_bglt arg1890_1626;
				  arg1890_1626 =
				     glo__115_integrate_node(
				     (((make_box_202_bglt) CREF(node_1623))->value), integrator_11);
				  ((((make_box_202_bglt) CREF(node_1623))->value) = ((node_bglt) arg1890_1626), BUNSPEC);
			       }
			       aux_2493 =
				  (obj_t) (node_1623);
			    }
			    break;
			 case ((long) 19):

			    {	/* Integrate/node.scm 127 */
			       box_ref_242_bglt node_1628;
			       node_1628 =
				  (box_ref_242_bglt) (node_10);
			       {	/* Integrate/node.scm 378 */
				  node_bglt arg1892_1631;
				  {	/* Integrate/node.scm 378 */
				     node_bglt aux_2880;
				     {	/* Integrate/node.scm 378 */
					var_bglt aux_2881;
					aux_2881 =
					   (((box_ref_242_bglt) CREF(node_1628))->var);
					aux_2880 =
					   (node_bglt) (aux_2881);
				     }
				     arg1892_1631 =
					glo__115_integrate_node(aux_2880, integrator_11);
				  }
				  {	/* Integrate/node.scm 378 */
				     var_bglt val1418_2150;
				     val1418_2150 =
					(var_bglt) (arg1892_1631);
				     ((((box_ref_242_bglt) CREF(node_1628))->var) = ((var_bglt) val1418_2150), BUNSPEC);
				  }
			       }
			       aux_2493 =
				  (obj_t) (node_1628);
			    }
			    break;
			 case ((long) 20):

			    {	/* Integrate/node.scm 127 */
			       box_set__221_bglt node_1633;
			       node_1633 =
				  (box_set__221_bglt) (node_10);
			       {	/* Integrate/node.scm 387 */
				  node_bglt arg1894_1636;
				  {	/* Integrate/node.scm 387 */
				     node_bglt aux_2889;
				     {	/* Integrate/node.scm 387 */
					var_bglt aux_2890;
					aux_2890 =
					   (((box_set__221_bglt) CREF(node_1633))->var);
					aux_2889 =
					   (node_bglt) (aux_2890);
				     }
				     arg1894_1636 =
					glo__115_integrate_node(aux_2889, integrator_11);
				  }
				  {	/* Integrate/node.scm 387 */
				     var_bglt val1428_2153;
				     val1428_2153 =
					(var_bglt) (arg1894_1636);
				     ((((box_set__221_bglt) CREF(node_1633))->var) = ((var_bglt) val1428_2153), BUNSPEC);
				  }
			       }
			       {	/* Integrate/node.scm 388 */
				  node_bglt arg1896_1638;
				  arg1896_1638 =
				     glo__115_integrate_node(
				     (((box_set__221_bglt) CREF(node_1633))->value), integrator_11);
				  ((((box_set__221_bglt) CREF(node_1633))->value) = ((node_bglt) arg1896_1638), BUNSPEC);
			       }
			       aux_2493 =
				  (obj_t) (node_1633);
			    }
			    break;
			 default:
			  case_else1764_1426:
			    if (
			       PROCEDUREP(method1758_1422))
			      {		/* Integrate/node.scm 127 */
				 aux_2493 =
				    PROCEDURE_ENTRY(method1758_1422) (method1758_1422,
				    (obj_t) (node_10),
				    (obj_t) (integrator_11), BEOA)
				    ;
			      }
			    else
			      {		/* Integrate/node.scm 127 */
				 obj_t fun1757_1418;
				 fun1757_1418 =
				    PROCEDURE_REF(glo__env_172_integrate_node, ((long) 0));
				 aux_2493 =
				    PROCEDURE_ENTRY(fun1757_1418) (fun1757_1418,
				    (obj_t) (node_10),
				    (obj_t) (integrator_11), BEOA);
			      }
			 }
		    }
		  else
		    {	/* Integrate/node.scm 127 */
		       goto case_else1764_1426;
		    }
	       }
	       return
		  (node_bglt) (aux_2493);
	    }
	 }
      }
   }
}



/* _glo! */
obj_t 
_glo__107_integrate_node(obj_t env_2168, obj_t node_2169, obj_t integrator_2170)
{
   AN_OBJECT;
   {	/* Integrate/node.scm 127 */
      {		/* Integrate/node.scm 127 */
	 node_bglt aux_2914;
	 aux_2914 =
	    glo__115_integrate_node(
	    (node_bglt) (node_2169),
	    (variable_bglt) (integrator_2170));
	 return
	    (obj_t) (aux_2914);
      }
   }
}



/* glo!-default1567 */
node_bglt 
glo__default1567_251_integrate_node(node_bglt node_12, variable_bglt integrator_13)
{
   AN_OBJECT;
   {	/* Integrate/node.scm 14 */
      FAILURE(
	 CNST_TABLE_REF(((long) 4)), string1918_integrate_node,
	 (obj_t) (node_12));
   }
}



/* _glo!-default1567 */
obj_t 
_glo__default1567_20_integrate_node(obj_t env_2171, obj_t node_2172, obj_t integrator_2173)
{
   AN_OBJECT;
   {	/* Integrate/node.scm 14 */
      {		/* Integrate/node.scm 14 */
	 node_bglt aux_2922;
	 aux_2922 =
	    glo__default1567_251_integrate_node(
	    (node_bglt) (node_2172),
	    (variable_bglt) (integrator_2173));
	 return
	    (obj_t) (aux_2922);
      }
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_integrate_node()
{
   AN_OBJECT;
   {	/* Integrate/node.scm 14 */
      module_initialization_70_tools_trace(((long) 0), "INTEGRATE_NODE");
      module_initialization_70_tools_shape(((long) 0), "INTEGRATE_NODE");
      module_initialization_70_tools_error(((long) 0), "INTEGRATE_NODE");
      module_initialization_70_type_type(((long) 0), "INTEGRATE_NODE");
      module_initialization_70_type_cache(((long) 0), "INTEGRATE_NODE");
      module_initialization_70_ast_var(((long) 0), "INTEGRATE_NODE");
      module_initialization_70_ast_node(((long) 0), "INTEGRATE_NODE");
      module_initialization_70_ast_local(((long) 0), "INTEGRATE_NODE");
      module_initialization_70_integrate_info(((long) 0), "INTEGRATE_NODE");
      return
	 module_initialization_70_integrate_local__global_163(((long) 0), "INTEGRATE_NODE");
   }
}
