/*===========================================================================*/
/*   (Integrate/u.scm)                                                       */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;

typedef struct svar_iinfo_76
  {
     obj_t f_mark_181;
     obj_t u_mark_209;
     bool_t kaptured__204;
     bool_t celled__113;
  }
             *svar_iinfo_76_bglt;

typedef struct sexit_iinfo_190
  {
     obj_t f_mark_181;
     obj_t u_mark_209;
     bool_t kaptured__204;
     bool_t celled__113;
  }
               *sexit_iinfo_190_bglt;

typedef struct sfun_iinfo_105
  {
     obj_t owner;
     obj_t free;
     obj_t bound;
     obj_t cfrom;
     obj_t cto;
     obj_t k;
     obj_t k__190;
     obj_t u;
     obj_t cn;
     obj_t ct;
     obj_t kont;
     bool_t g__219;
     obj_t l;
     obj_t led;
     obj_t istamp;
     obj_t global;
     obj_t kaptured;
  }
              *sfun_iinfo_105_bglt;


static obj_t method_init_76_integrate_u();
extern obj_t module_initialization_70_integrate_u(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_integrate_info(long, char *);
extern obj_t module_initialization_70_integrate_a(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern long list_length(obj_t);
static obj_t imported_modules_init_94_integrate_u();
static obj_t library_modules_init_112_integrate_u();
extern obj_t u__31_integrate_u();
extern obj_t _phi__105_integrate_a;
static obj_t _u__160_integrate_u(obj_t);
static obj_t require_initialization_114_integrate_u = BUNSPEC;
static obj_t *__cnst;

DEFINE_EXPORT_PROCEDURE(u__env_99_integrate_u, _u__160_integrate_u1612, _u__160_integrate_u, 0L, 0);



/* module-initialization */
obj_t 
module_initialization_70_integrate_u(long checksum_1329, char *from_1330)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_integrate_u))
	{
	   require_initialization_114_integrate_u =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_integrate_u();
	   imported_modules_init_94_integrate_u();
	   method_init_76_integrate_u();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_integrate_u()
{
   AN_OBJECT;
   {	/* Integrate/u.scm 14 */
      module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "INTEGRATE_U");
      return BUNSPEC;
   }
}



/* u! */
obj_t 
u__31_integrate_u()
{
   AN_OBJECT;
   {	/* Integrate/u.scm 27 */
      {
	 obj_t phi_882;
	 phi_882 = _phi__105_integrate_a;
       loop_883:
	 if (
	    NULLP(phi_882))
	   {	/* Integrate/u.scm 29 */
	      return BUNSPEC;
	   }
	 else
	   {	/* Integrate/u.scm 31 */
	      value_bglt ifun_886;
	      {		/* Integrate/u.scm 32 */
		 variable_bglt obj_1266;
		 {	/* Integrate/u.scm 32 */
		    obj_t aux_1340;
		    aux_1340 =
		       CAR(phi_882);
		    obj_1266 =
		       (variable_bglt) (aux_1340);
		 }
		 ifun_886 =
		    (((variable_bglt) CREF(obj_1266))->value);
	      }
	      {		/* Integrate/u.scm 32 */

		 {	/* Integrate/u.scm 33 */
		    sfun_iinfo_105_bglt obj_1270;
		    obj_t val1484_1271;
		    obj_1270 =
		       (sfun_iinfo_105_bglt) (ifun_886);
		    {	/* Integrate/u.scm 33 */
		       bool_t aux_1345;
		       {	/* ./Ieee/fixnum.scm 7109 */
			  long aux_1346;
			  {	/* Integrate/u.scm 33 */
			     obj_t aux_1347;
			     {	/* Integrate/u.scm 33 */
				sfun_iinfo_105_bglt obj_1267;
				obj_1267 =
				   (sfun_iinfo_105_bglt) (ifun_886);
				{
				   obj_t aux_1349;
				   {	/* ./Integrate/iinfo.scm 814 */
				      object_bglt aux_1350;
				      aux_1350 =
					 (object_bglt) (obj_1267);
				      aux_1349 =
					 OBJECT_WIDENING(aux_1350);
				   }
				   aux_1347 =
				      (((sfun_iinfo_105_bglt) CREF(aux_1349))->k__190);
				}
			     }
			     aux_1346 =
				list_length(aux_1347);
			  }
			  aux_1345 =
			     (aux_1346 == ((long) 1));
		       }
		       val1484_1271 =
			  BBOOL(aux_1345);
		    }
		    {
		       obj_t aux_1357;
		       {	/* ./Integrate/iinfo.scm 816 */
			  object_bglt aux_1358;
			  aux_1358 =
			     (object_bglt) (obj_1270);
			  aux_1357 =
			     OBJECT_WIDENING(aux_1358);
		       }
		       ((((sfun_iinfo_105_bglt) CREF(aux_1357))->u) = ((obj_t) val1484_1271), BUNSPEC);
		    }
		 }
		 {
		    obj_t phi_1362;
		    phi_1362 =
		       CDR(phi_882);
		    phi_882 = phi_1362;
		    goto loop_883;
		 }
	      }
	   }
      }
   }
}



/* _u! */
obj_t 
_u__160_integrate_u(obj_t env_1328)
{
   AN_OBJECT;
   {	/* Integrate/u.scm 27 */
      return
	 u__31_integrate_u();
   }
}



/* method-init */
obj_t 
method_init_76_integrate_u()
{
   AN_OBJECT;
   {	/* Integrate/u.scm 14 */
      return BUNSPEC;
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_integrate_u()
{
   AN_OBJECT;
   {	/* Integrate/u.scm 14 */
      module_initialization_70_tools_trace(((long) 0), "INTEGRATE_U");
      module_initialization_70_tools_shape(((long) 0), "INTEGRATE_U");
      module_initialization_70_type_type(((long) 0), "INTEGRATE_U");
      module_initialization_70_ast_var(((long) 0), "INTEGRATE_U");
      module_initialization_70_ast_node(((long) 0), "INTEGRATE_U");
      module_initialization_70_integrate_info(((long) 0), "INTEGRATE_U");
      return
	 module_initialization_70_integrate_a(((long) 0), "INTEGRATE_U");
   }
}
