/*===========================================================================*/
/*   (Integrate/walk.scm)                                                    */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;


static obj_t method_init_76_integrate_walk();
extern obj_t current_error_port;
extern obj_t _nb_error_on_pass__70_tools_error;
extern obj_t integrate_definition__136_integrate_definition(obj_t);
extern obj_t integrate_walk__134_integrate_walk(obj_t);
extern obj_t verbose_tools_speek(obj_t, obj_t);
extern obj_t module_initialization_70_integrate_walk(long, char *);
extern obj_t module_initialization_70_tools_speek(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_engine_pass(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_remove(long, char *);
extern obj_t module_initialization_70_integrate_definition(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_numbers_6_5(long, char *);
extern obj_t module_initialization_70___r4_output_6_10_3(long, char *);
static obj_t _integrate_walk__13_integrate_walk(obj_t, obj_t);
extern obj_t display_2_122___r4_output_6_10_3(obj_t, obj_t);
static obj_t imported_modules_init_94_integrate_walk();
extern obj_t append_2_18___r4_pairs_and_lists_6_3(obj_t, obj_t);
static obj_t library_modules_init_112_integrate_walk();
extern obj_t open_input_string(obj_t);
extern obj_t string_to_bstring(char *);
extern obj_t enter_function_81_tools_error(obj_t);
extern obj_t remove_var_123_ast_remove(obj_t, obj_t);
extern obj_t internal_error_43_tools_error(obj_t, obj_t, obj_t);
extern bool_t _2__206___r4_numbers_6_5(obj_t, obj_t);
extern obj_t read___reader(obj_t);
static obj_t require_initialization_114_integrate_walk = BUNSPEC;
static obj_t cnst_init_137_integrate_walk();
extern obj_t _current_pass__25_engine_pass;
static obj_t __cnst[2];

DEFINE_EXPORT_PROCEDURE(integrate_walk__env_199_integrate_walk, _integrate_walk__13_integrate_walk1270, _integrate_walk__13_integrate_walk, 0L, 1);
DEFINE_STRING(string1265_integrate_walk, string1265_integrate_walk1271, "(INTEGRATE CFA) PASS-STARTED ", 29);
DEFINE_STRING(string1264_integrate_walk, string1264_integrate_walk1272, "failure during postlude hook", 28);
DEFINE_STRING(string1263_integrate_walk, string1263_integrate_walk1273, " occured, ending ...", 20);
DEFINE_STRING(string1262_integrate_walk, string1262_integrate_walk1274, " error", 6);
DEFINE_STRING(string1261_integrate_walk, string1261_integrate_walk1275, "failure during prelude hook", 27);
DEFINE_STRING(string1259_integrate_walk, string1259_integrate_walk1276, "Integration", 11);
DEFINE_STRING(string1260_integrate_walk, string1260_integrate_walk1277, "   . ", 5);



/* module-initialization */
obj_t 
module_initialization_70_integrate_walk(long checksum_512, char *from_513)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_integrate_walk))
	{
	   require_initialization_114_integrate_walk =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_integrate_walk();
	   cnst_init_137_integrate_walk();
	   imported_modules_init_94_integrate_walk();
	   method_init_76_integrate_walk();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_integrate_walk()
{
   AN_OBJECT;
   {	/* Integrate/walk.scm 14 */
      module_initialization_70___r4_output_6_10_3(((long) 0), "INTEGRATE_WALK");
      module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "INTEGRATE_WALK");
      module_initialization_70___r4_numbers_6_5(((long) 0), "INTEGRATE_WALK");
      module_initialization_70___reader(((long) 0), "INTEGRATE_WALK");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_integrate_walk()
{
   AN_OBJECT;
   {	/* Integrate/walk.scm 14 */
      {		/* Integrate/walk.scm 14 */
	 obj_t cnst_port_138_505;
	 cnst_port_138_505 =
	    open_input_string(string1265_integrate_walk);
	 {
	    long i_506;
	    i_506 = ((long) 1);
	  loop_507:
	    {	/* Integrate/walk.scm 14 */
	       bool_t test1266_508;
	       test1266_508 =
		  (i_506 == ((long) -1));
	       if (test1266_508)
		 {	/* Integrate/walk.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Integrate/walk.scm 14 */
		    {	/* Integrate/walk.scm 14 */
		       obj_t arg1267_509;
		       {	/* Integrate/walk.scm 14 */
			  obj_t list1268_510;
			  list1268_510 =
			     MAKE_PAIR(cnst_port_138_505, BNIL);
			  arg1267_509 =
			     read___reader(list1268_510);
		       }
		       CNST_TABLE_SET(i_506, arg1267_509);
		    }
		    {	/* Integrate/walk.scm 14 */
		       int aux_511;
		       {	/* Integrate/walk.scm 14 */
			  long aux_531;
			  aux_531 =
			     (i_506 - ((long) 1));
			  aux_511 =
			     (int) (aux_531);
		       }
		       {
			  long i_534;
			  i_534 =
			     (long) (aux_511);
			  i_506 = i_534;
			  goto loop_507;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* integrate-walk! */
obj_t 
integrate_walk__134_integrate_walk(obj_t globals_1)
{
   AN_OBJECT;
   {	/* Integrate/walk.scm 27 */
      {		/* Integrate/walk.scm 27 */
	 obj_t list1185_306;
	 {	/* Integrate/walk.scm 27 */
	    obj_t arg1188_308;
	    {	/* Integrate/walk.scm 27 */
	       obj_t arg1190_310;
	       {	/* Integrate/walk.scm 27 */
		  obj_t aux_536;
		  aux_536 =
		     BCHAR(((unsigned char) '\n'));
		  arg1190_310 =
		     MAKE_PAIR(aux_536, BNIL);
	       }
	       arg1188_308 =
		  MAKE_PAIR(string1259_integrate_walk, arg1190_310);
	    }
	    list1185_306 =
	       MAKE_PAIR(string1260_integrate_walk, arg1188_308);
	 }
	 verbose_tools_speek(
	    BINT(((long) 1)), list1185_306);
      }
      _nb_error_on_pass__70_tools_error =
	 BINT(((long) 0));
      _current_pass__25_engine_pass = string1259_integrate_walk;
      {
	 obj_t hooks_311;
	 obj_t hnames_312;
	 hooks_311 = BNIL;
	 hnames_312 = BNIL;
       loop_313:
	 if (
	    NULLP(hooks_311))
	   {	/* Integrate/walk.scm 27 */
	      CNST_TABLE_REF(((long) 0));
	   }
	 else
	   {	/* Integrate/walk.scm 27 */
	      bool_t test1196_318;
	      {		/* Integrate/walk.scm 27 */
		 obj_t fun1208_324;
		 fun1208_324 =
		    CAR(hooks_311);
		 {	/* Integrate/walk.scm 27 */
		    obj_t aux_548;
		    aux_548 =
		       PROCEDURE_ENTRY(fun1208_324) (fun1208_324, BEOA);
		    test1196_318 =
		       CBOOL(aux_548);
		 }
	      }
	      if (test1196_318)
		{	/* Integrate/walk.scm 27 */
		   {
		      obj_t hnames_555;
		      obj_t hooks_553;
		      hooks_553 =
			 CDR(hooks_311);
		      hnames_555 =
			 CDR(hnames_312);
		      hnames_312 = hnames_555;
		      hooks_311 = hooks_553;
		      goto loop_313;
		   }
		}
	      else
		{	/* Integrate/walk.scm 27 */
		   internal_error_43_tools_error(string1259_integrate_walk, string1261_integrate_walk,
		      CAR(hnames_312));
		}
	   }
      }
      {
	 obj_t old_325;
	 obj_t new_326;
	 old_325 = globals_1;
	 new_326 = BNIL;
       loop_327:
	 if (
	    NULLP(old_325))
	   {	/* Integrate/walk.scm 32 */
	      obj_t value_329;
	      value_329 =
		 remove_var_123_ast_remove(
		 CNST_TABLE_REF(((long) 1)), new_326);
	      {		/* Integrate/walk.scm 32 */
		 bool_t test1210_330;
		 {	/* Integrate/walk.scm 32 */
		    long n1_488;
		    n1_488 =
		       (long) CINT(_nb_error_on_pass__70_tools_error);
		    test1210_330 =
		       (n1_488 > ((long) 0));
		 }
		 if (test1210_330)
		   {	/* Integrate/walk.scm 32 */
		      display_2_122___r4_output_6_10_3(_nb_error_on_pass__70_tools_error, current_error_port);
		      display_2_122___r4_output_6_10_3(string1262_integrate_walk, current_error_port);
		      {		/* Integrate/walk.scm 32 */
			 char *arg1212_332;
			 {	/* Integrate/walk.scm 32 */
			    bool_t test1213_333;
			    {	/* Integrate/walk.scm 32 */
			       bool_t test1214_334;
			       {	/* Integrate/walk.scm 32 */
				  obj_t obj_490;
				  obj_490 = _nb_error_on_pass__70_tools_error;
				  test1214_334 =
				     INTEGERP(obj_490);
			       }
			       if (test1214_334)
				 {	/* Integrate/walk.scm 32 */
				    test1213_333 =
				       _2__206___r4_numbers_6_5(_nb_error_on_pass__70_tools_error,
				       BINT(((long) 1)));
				 }
			       else
				 {	/* Integrate/walk.scm 32 */
				    test1213_333 = ((bool_t) 0);
				 }
			    }
			    if (test1213_333)
			      {		/* Integrate/walk.scm 32 */
				 arg1212_332 = "s";
			      }
			    else
			      {		/* Integrate/walk.scm 32 */
				 arg1212_332 = "";
			      }
			 }
			 display_2_122___r4_output_6_10_3(
			    string_to_bstring(arg1212_332), current_error_port);
		      }
		      display_2_122___r4_output_6_10_3(string1263_integrate_walk, current_error_port);
		      WRITE_CHAR(((unsigned char) '\n'), current_error_port);
		      {		/* Integrate/walk.scm 32 */
			 obj_t res1258_493;
			 exit(((long) -1));
			 res1258_493 =
			    BINT(((long) -1));
			 return res1258_493;
		      }
		   }
		 else
		   {
		      obj_t hooks_335;
		      obj_t hnames_336;
		      hooks_335 = BNIL;
		      hnames_336 = BNIL;
		    loop_337:
		      if (
			 NULLP(hooks_335))
			{	/* Integrate/walk.scm 32 */
			   return value_329;
			}
		      else
			{	/* Integrate/walk.scm 32 */
			   bool_t test1219_342;
			   {	/* Integrate/walk.scm 32 */
			      obj_t fun1225_347;
			      fun1225_347 =
				 CAR(hooks_335);
			      {		/* Integrate/walk.scm 32 */
				 obj_t aux_582;
				 aux_582 =
				    PROCEDURE_ENTRY(fun1225_347) (fun1225_347, BEOA);
				 test1219_342 =
				    CBOOL(aux_582);
			      }
			   }
			   if (test1219_342)
			     {	/* Integrate/walk.scm 32 */
				{
				   obj_t hnames_589;
				   obj_t hooks_587;
				   hooks_587 =
				      CDR(hooks_335);
				   hnames_589 =
				      CDR(hnames_336);
				   hnames_336 = hnames_589;
				   hooks_335 = hooks_587;
				   goto loop_337;
				}
			     }
			   else
			     {	/* Integrate/walk.scm 32 */
				return
				   internal_error_43_tools_error(_current_pass__25_engine_pass, string1264_integrate_walk,
				   CAR(hnames_336));
			     }
			}
		   }
	      }
	   }
	 else
	   {	/* Integrate/walk.scm 33 */
	      obj_t global_348;
	      global_348 =
		 CAR(old_325);
	      {		/* Integrate/walk.scm 34 */
		 obj_t aux_594;
		 {	/* Integrate/walk.scm 34 */
		    global_bglt obj_501;
		    obj_501 =
		       (global_bglt) (global_348);
		    aux_594 =
		       (((global_bglt) CREF(obj_501))->id);
		 }
		 enter_function_81_tools_error(aux_594);
	      }
	      {		/* Integrate/walk.scm 35 */
		 obj_t arg1227_350;
		 obj_t arg1228_351;
		 arg1227_350 =
		    CDR(old_325);
		 {	/* Integrate/walk.scm 36 */
		    obj_t arg1229_352;
		    arg1229_352 =
		       integrate_definition__136_integrate_definition(global_348);
		    arg1228_351 =
		       append_2_18___r4_pairs_and_lists_6_3(arg1229_352, new_326);
		 }
		 {
		    obj_t new_602;
		    obj_t old_601;
		    old_601 = arg1227_350;
		    new_602 = arg1228_351;
		    new_326 = new_602;
		    old_325 = old_601;
		    goto loop_327;
		 }
	      }
	   }
      }
   }
}



/* _integrate-walk! */
obj_t 
_integrate_walk__13_integrate_walk(obj_t env_503, obj_t globals_504)
{
   AN_OBJECT;
   {	/* Integrate/walk.scm 27 */
      return
	 integrate_walk__134_integrate_walk(globals_504);
   }
}



/* method-init */
obj_t 
method_init_76_integrate_walk()
{
   AN_OBJECT;
   {	/* Integrate/walk.scm 14 */
      return BUNSPEC;
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_integrate_walk()
{
   AN_OBJECT;
   {	/* Integrate/walk.scm 14 */
      module_initialization_70_tools_speek(((long) 0), "INTEGRATE_WALK");
      module_initialization_70_tools_error(((long) 0), "INTEGRATE_WALK");
      module_initialization_70_engine_pass(((long) 0), "INTEGRATE_WALK");
      module_initialization_70_type_type(((long) 0), "INTEGRATE_WALK");
      module_initialization_70_ast_var(((long) 0), "INTEGRATE_WALK");
      module_initialization_70_ast_remove(((long) 0), "INTEGRATE_WALK");
      return
	 module_initialization_70_integrate_definition(((long) 0), "INTEGRATE_WALK");
   }
}
