/*===========================================================================*/
/*   (Module/class.scm)                                                      */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct ccomp
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t producer;
     obj_t consumer;
     obj_t finalizer;
     obj_t checksummer;
  }
     *ccomp_bglt;

typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct tclass
  {
     obj_t its_super_214;
     obj_t slots;
     struct global *holder;
     obj_t widening;
     long depth;
     bool_t final__12;
     obj_t constructor;
     obj_t virtual_slots_number_200;
  }
      *tclass_bglt;


static obj_t method_init_76_module_class();
extern obj_t find_global_module_25_ast_env(obj_t, obj_t);
extern obj_t symbol_append_197___r4_symbols_6_4(obj_t);
extern obj_t _optim__89_engine_param;
extern obj_t import_wide_class_makes__40_object_wide_access_168(obj_t, type_bglt, obj_t, obj_t);
extern obj_t string_append(obj_t, obj_t);
extern obj_t class_finalizer_253_module_class();
extern obj_t type_type_type;
extern obj_t _reflection___104_engine_param;
extern obj_t id_of_id_112_ast_ident(obj_t, obj_t);
extern obj_t _res1__155___r5_control_features_6_4;
static obj_t make_class_fields_146_module_class(obj_t, obj_t, obj_t);
extern obj_t create_struct(obj_t, long);
extern obj_t _bdb_debug__1_engine_param;
static obj_t _declare_class_1820_144_module_class(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t make_wide_class_accessors_sans_makes__153_object_wide_access_168(obj_t, type_bglt, obj_t, obj_t);
extern obj_t fast_id_of_id_130_ast_ident(obj_t, obj_t);
extern obj_t notify_assert_fail_37___eval(obj_t, obj_t, obj_t);
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t get_object_unit_72_module_class();
extern type_bglt declare_class_type__110_object_class(obj_t, global_bglt, obj_t, bool_t, obj_t);
extern obj_t module_initialization_70_module_class(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_module_module(long, char *);
extern obj_t module_initialization_70_module_impuse(long, char *);
extern obj_t module_initialization_70_module_include(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_env(long, char *);
extern obj_t module_initialization_70_ast_ident(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_env(long, char *);
extern obj_t module_initialization_70_object_class(long, char *);
extern obj_t module_initialization_70_object_plain_access_186(long, char *);
extern obj_t module_initialization_70_object_wide_access_168(long, char *);
extern obj_t module_initialization_70_tools_location(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___eval(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_symbols_6_4(long, char *);
extern obj_t module_initialization_70___r4_numbers_6_5_fixnum(long, char *);
extern obj_t module_initialization_70___r4_control_features_6_9(long, char *);
extern obj_t module_initialization_70___r5_control_features_6_4(long, char *);
static obj_t _class_finalizer_205_module_class(obj_t);
static obj_t _declare_wide_class_1821_177_module_class(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t make_slot_field_56_module_class(obj_t, obj_t, obj_t);
extern long get_hash_power_number(char *, long);
extern obj_t make_plain_class_accessors_sans_makes__96_object_plain_access_186(obj_t, type_bglt, obj_t, obj_t);
static obj_t imported_modules_init_94_module_class();
static obj_t _get_object_unit_43_module_class(obj_t);
extern obj_t import_wide_class_accessors__236_object_wide_access_168(obj_t, type_bglt, obj_t, obj_t);
extern obj_t get_method_unit_151_module_class();
static obj_t _get_class_hash1822_166_module_class(obj_t, obj_t, obj_t);
static obj_t _declared_classes__217_module_class = BUNSPEC;
static obj_t force_class_accesses_39_module_class();
extern obj_t produce_module_clause__172_module_module(obj_t);
extern obj_t append_2_18___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern obj_t import_parser_53_module_impuse(obj_t, obj_t);
static obj_t library_modules_init_112_module_class();
static obj_t toplevel_init_63_module_class();
extern obj_t open_input_string(obj_t);
static obj_t _object_unit__229_module_class = BUNSPEC;
static obj_t _method_unit__121_module_class = BUNSPEC;
static obj_t _anonymous_1299__80_module_class(obj_t);
static obj_t _anonymous_1296__4_module_class(obj_t);
static obj_t _anonymous_1293__185_module_class(obj_t);
static obj_t _anonymous_1303__124_module_class(obj_t);
extern char *integer__string_135___r4_numbers_6_5_fixnum(long, obj_t);
static obj_t _get_method_unit_29_module_class(obj_t);
extern obj_t string_to_bstring(char *);
static obj_t _anonymous_1288__199_module_class(obj_t);
extern obj_t tclass_object_class;
static obj_t _class_accesses__244_module_class = BUNSPEC;
static obj_t _anonymous_1277__14_module_class(obj_t);
static obj_t _anonymous_1272__46_module_class(obj_t);
static obj_t _anonymous_1269__252_module_class(obj_t);
static obj_t _anonymous_1265__148_module_class(obj_t);
extern obj_t make_promise_21___r4_control_features_6_9(obj_t);
extern obj_t memq___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern obj_t get_class_hash_100_module_class(obj_t, obj_t);
static obj_t _anonymous_1260__161_module_class(obj_t);
extern obj_t declare_class__31_module_class(obj_t, obj_t, obj_t, bool_t, obj_t);
static obj_t make_add_class__155_module_class(obj_t, obj_t, obj_t, obj_t);
extern obj_t make_plain_class_accessors__206_object_plain_access_186(obj_t, type_bglt, obj_t, obj_t);
extern obj_t import_plain_class_accessors__109_object_plain_access_186(obj_t, type_bglt, obj_t, obj_t);
extern obj_t internal_error_43_tools_error(obj_t, obj_t, obj_t);
extern obj_t read___reader(obj_t);
extern obj_t _profile_mode__105_engine_param;
extern obj_t make_wide_class_accessors__22_object_wide_access_168(obj_t, type_bglt, obj_t, obj_t);
static bool_t read_only__11_module_class(obj_t);
extern obj_t find_location_120_tools_location(obj_t);
extern obj_t declare_wide_class__13_module_class(obj_t, obj_t, obj_t, obj_t);
extern obj_t import_plain_class_makes__28_object_plain_access_186(obj_t, type_bglt, obj_t, obj_t);
extern obj_t get_toplevel_unit_weight_75_module_include();
static obj_t require_initialization_114_module_class = BUNSPEC;
static obj_t cnst_init_137_module_class();
extern obj_t reverse__39___r4_pairs_and_lists_6_3(obj_t);
static obj_t __cnst[31];

DEFINE_EXPORT_PROCEDURE(declare_class__env_99_module_class, _declare_class_1820_144_module_class1833, _declare_class_1820_144_module_class, 0L, 5);
DEFINE_EXPORT_PROCEDURE(declare_wide_class__env_34_module_class, _declare_wide_class_1821_177_module_class1834, _declare_wide_class_1821_177_module_class, 0L, 4);
DEFINE_EXPORT_PROCEDURE(get_object_unit_env_13_module_class, _get_object_unit_43_module_class1835, _get_object_unit_43_module_class, 0L, 0);
DEFINE_EXPORT_PROCEDURE(get_class_hash_env_189_module_class, _get_class_hash1822_166_module_class1836, _get_class_hash1822_166_module_class, 0L, 2);
DEFINE_EXPORT_PROCEDURE(class_finalizer_env_31_module_class, _class_finalizer_205_module_class1837, _class_finalizer_205_module_class, 0L, 0);
DEFINE_EXPORT_PROCEDURE(get_method_unit_env_101_module_class, _get_method_unit_29_module_class1838, _get_method_unit_29_module_class, 0L, 0);
DEFINE_STRING(string1827_module_class, string1827_module_class1839, "METHOD (\"/home/tahoe2/serrano/tmp/bigloo/comptime/Module/class.scm\" . 16525) (BEGIN (<FX 20 (GET-TOPLEVEL-UNIT-WEIGHT))) UNIT (#unspecified) VOID -LEN PRAGMA::LONG OBJECT LAMBDA -REF -SET! - MAKE-CLASS-FIELD GET READ-ONLY LIST + * CONS VECTOR QUOTE __OBJECT REGISTER-CLASS! DEFINE @ ALLOCATE- WIDENING (EXPORT STATIC) USE IMPORT ", 329);
DEFINE_STRING(string1826_module_class, string1826_module_class1840, "Illegal slot definition", 23);
DEFINE_STRING(string1825_module_class, string1825_module_class1841, "make-class-fields", 17);
DEFINE_STRING(string1824_module_class, string1824_module_class1842, "+ ", 2);
DEFINE_STRING(string1823_module_class, string1823_module_class1843, "* ", 2);



/* module-initialization */
obj_t 
module_initialization_70_module_class(long checksum_2200, char *from_2201)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_module_class))
	{
	   require_initialization_114_module_class =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_module_class();
	   cnst_init_137_module_class();
	   imported_modules_init_94_module_class();
	   method_init_76_module_class();
	   toplevel_init_63_module_class();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_module_class()
{
   AN_OBJECT;
   {	/* Module/class.scm 14 */
      module_initialization_70___r4_symbols_6_4(((long) 0), "MODULE_CLASS");
      module_initialization_70___r5_control_features_6_4(((long) 0), "MODULE_CLASS");
      module_initialization_70___eval(((long) 0), "MODULE_CLASS");
      module_initialization_70___object(((long) 0), "MODULE_CLASS");
      module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "MODULE_CLASS");
      module_initialization_70___r4_numbers_6_5_fixnum(((long) 0), "MODULE_CLASS");
      module_initialization_70___r4_control_features_6_9(((long) 0), "MODULE_CLASS");
      module_initialization_70___reader(((long) 0), "MODULE_CLASS");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_module_class()
{
   AN_OBJECT;
   {	/* Module/class.scm 14 */
      {		/* Module/class.scm 14 */
	 obj_t cnst_port_138_2193;
	 cnst_port_138_2193 =
	    open_input_string(string1827_module_class);
	 {
	    long i_2194;
	    i_2194 = ((long) 30);
	  loop_2195:
	    {	/* Module/class.scm 14 */
	       bool_t test1828_2196;
	       test1828_2196 =
		  (i_2194 == ((long) -1));
	       if (test1828_2196)
		 {	/* Module/class.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Module/class.scm 14 */
		    {	/* Module/class.scm 14 */
		       obj_t arg1830_2197;
		       {	/* Module/class.scm 14 */
			  obj_t list1831_2198;
			  list1831_2198 =
			     MAKE_PAIR(cnst_port_138_2193, BNIL);
			  arg1830_2197 =
			     read___reader(list1831_2198);
		       }
		       CNST_TABLE_SET(i_2194, arg1830_2197);
		    }
		    {	/* Module/class.scm 14 */
		       int aux_2199;
		       {	/* Module/class.scm 14 */
			  long aux_2224;
			  aux_2224 =
			     (i_2194 - ((long) 1));
			  aux_2199 =
			     (int) (aux_2224);
		       }
		       {
			  long i_2227;
			  i_2227 =
			     (long) (aux_2199);
			  i_2194 = i_2227;
			  goto loop_2195;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_module_class()
{
   AN_OBJECT;
   {	/* Module/class.scm 14 */
      _object_unit__229_module_class = BUNSPEC;
      _method_unit__121_module_class = BUNSPEC;
      _class_accesses__244_module_class = BNIL;
      return (
	 _declared_classes__217_module_class = BNIL, BUNSPEC);
   }
}



/* get-object-unit */
obj_t 
get_object_unit_72_module_class()
{
   AN_OBJECT;
   {	/* Module/class.scm 49 */
      return _object_unit__229_module_class;
   }
}



/* _get-object-unit */
obj_t 
_get_object_unit_43_module_class(obj_t env_2110)
{
   AN_OBJECT;
   {	/* Module/class.scm 49 */
      return
	 get_object_unit_72_module_class();
   }
}



/* get-method-unit */
obj_t 
get_method_unit_151_module_class()
{
   AN_OBJECT;
   {	/* Module/class.scm 55 */
      return _method_unit__121_module_class;
   }
}



/* _get-method-unit */
obj_t 
_get_method_unit_29_module_class(obj_t env_2111)
{
   AN_OBJECT;
   {	/* Module/class.scm 55 */
      return
	 get_method_unit_151_module_class();
   }
}



/* declare-class! */
obj_t 
declare_class__31_module_class(obj_t class_def_12_89, obj_t module_90, obj_t import_91, bool_t final__12_92, obj_t src_def_101_93)
{
   AN_OBJECT;
   {	/* Module/class.scm 61 */
      {		/* Module/class.scm 65 */
	 obj_t loc_527;
	 loc_527 =
	    find_location_120_tools_location(src_def_101_93);
	 {	/* Module/class.scm 66 */
	    obj_t class_id_86_529;
	    class_id_86_529 =
	       id_of_id_112_ast_ident(
	       CAR(class_def_12_89), loc_527);
	    {	/* Module/class.scm 67 */
	       obj_t holder_530;
	       {	/* Module/class.scm 68 */
		  bool_t test_2234;
		  {	/* Module/class.scm 68 */
		     bool_t test_2235;
		     {	/* ./Ieee/equiv.scm 5508 */
			obj_t aux_2236;
			aux_2236 =
			   CNST_TABLE_REF(((long) 0));
			test_2235 =
			   (import_91 == aux_2236);
		     }
		     if (test_2235)
		       {	/* Module/class.scm 68 */
			  test_2234 = ((bool_t) 1)
			     ;
		       }
		     else
		       {	/* ./Ieee/equiv.scm 5508 */
			  obj_t aux_2239;
			  aux_2239 =
			     CNST_TABLE_REF(((long) 1));
			  test_2234 =
			     (import_91 == aux_2239);
		       }
		  }
		  if (test_2234)
		    {	/* Module/class.scm 68 */
		       holder_530 =
			  import_parser_53_module_impuse(module_90, class_id_86_529);
		    }
		  else
		    {	/* Module/class.scm 68 */
		       {	/* Module/class.scm 71 */
			  obj_t arg1280_569;
			  {	/* Module/class.scm 71 */
			     obj_t arg1281_570;
			     arg1281_570 =
				MAKE_PAIR(class_id_86_529, BNIL);
			     arg1280_569 =
				MAKE_PAIR(import_91, arg1281_570);
			  }
			  produce_module_clause__172_module_module(arg1280_569);
		       }
		       holder_530 =
			  find_global_module_25_ast_env(class_id_86_529, module_90);
		    }
	       }
	       {	/* Module/class.scm 68 */
		  type_bglt type_531;
		  type_531 =
		     declare_class_type__110_object_class(class_def_12_89,
		     (global_bglt) (holder_530), BFALSE, final__12_92, src_def_101_93);
		  {	/* Module/class.scm 73 */

		     {	/* Module/class.scm 75 */
			bool_t test1256_532;
			test1256_532 =
			   is_a__118___object(
			   (obj_t) (type_531), tclass_object_class);
			if (test1256_532)
			  {	/* Module/class.scm 75 */
			     {	/* Module/class.scm 78 */
				bool_t test_2252;
				{	/* Module/class.scm 78 */
				   obj_t aux_2253;
				   aux_2253 =
				      memq___r4_pairs_and_lists_6_3(import_91,
				      CNST_TABLE_REF(((long) 2)));
				   test_2252 =
				      CBOOL(aux_2253);
				}
				if (test_2252)
				  {	/* Module/class.scm 78 */
				     {	/* Module/class.scm 83 */
					obj_t arg1258_534;
					{	/* Module/class.scm 83 */
					   obj_t _anonymous_1260__161_2112;
					   _anonymous_1260__161_2112 =
					      make_fx_procedure(_anonymous_1260__161_module_class, ((long) 0), ((long) 5));
					   PROCEDURE_SET(_anonymous_1260__161_2112, ((long) 0), class_def_12_89);
					   {	/* Module/class.scm 83 */
					      obj_t aux_2259;
					      aux_2259 =
						 (obj_t) (type_531);
					      PROCEDURE_SET(_anonymous_1260__161_2112, ((long) 1), aux_2259);
					   }
					   PROCEDURE_SET(_anonymous_1260__161_2112, ((long) 2), src_def_101_93);
					   PROCEDURE_SET(_anonymous_1260__161_2112, ((long) 3), import_91);
					   PROCEDURE_SET(_anonymous_1260__161_2112, ((long) 4), holder_530);
					   arg1258_534 =
					      make_promise_21___r4_control_features_6_9(_anonymous_1260__161_2112);
					}
					{	/* Module/class.scm 234 */
					   obj_t arg1313_1435;
					   {	/* ./Ieee/pair-list.scm 5689 */
					      obj_t aux_2266;
					      aux_2266 =
						 (obj_t) (type_531);
					      arg1313_1435 =
						 MAKE_PAIR(aux_2266, arg1258_534);
					   }
					   {	/* Module/class.scm 234 */
					      obj_t obj2_1439;
					      obj2_1439 = _class_accesses__244_module_class;
					      _class_accesses__244_module_class =
						 MAKE_PAIR(arg1313_1435, obj2_1439);
					   }
					}
				     }
				  }
				else
				  {	/* Module/class.scm 96 */
				     bool_t test1261_540;
				     {	/* Module/class.scm 96 */
					bool_t test1278_567;
					{	/* Module/class.scm 96 */
					   long n1_1440;
					   n1_1440 =
					      (long) CINT(_optim__89_engine_param);
					   test1278_567 =
					      (n1_1440 >= ((long) 2));
					}
					if (test1278_567)
					  {	/* Module/class.scm 96 */
					     long n1_1442;
					     n1_1442 =
						(long) CINT(_bdb_debug__1_engine_param);
					     test1261_540 =
						(n1_1442 <= ((long) 0));
					  }
					else
					  {	/* Module/class.scm 96 */
					     test1261_540 = ((bool_t) 0);
					  }
				     }
				     if (test1261_540)
				       {	/* Module/class.scm 96 */
					  {	/* Module/class.scm 97 */
					     bool_t test1262_541;
					     {	/* Module/class.scm 97 */
						bool_t test1273_560;
						{	/* Module/class.scm 97 */
						   obj_t obj_1444;
						   obj_1444 = _profile_mode__105_engine_param;
						   test1273_560 =
						      INTEGERP(obj_1444);
						}
						if (test1273_560)
						  {	/* Module/class.scm 98 */
						     long n1_1445;
						     n1_1445 =
							(long) CINT(_profile_mode__105_engine_param);
						     test1262_541 =
							(n1_1445 == ((long) 0));
						  }
						else
						  {	/* Module/class.scm 97 */
						     test1262_541 = ((bool_t) 1);
						  }
					     }
					     if (test1262_541)
					       {	/* Module/class.scm 105 */
						  obj_t arg1263_542;
						  {	/* Module/class.scm 105 */
						     obj_t _anonymous_1265__148_2113;
						     _anonymous_1265__148_2113 =
							make_fx_procedure(_anonymous_1265__148_module_class, ((long) 0), ((long) 4));
						     PROCEDURE_SET(_anonymous_1265__148_2113, ((long) 0), class_def_12_89);
						     {	/* Module/class.scm 105 */
							obj_t aux_2283;
							aux_2283 =
							   (obj_t) (type_531);
							PROCEDURE_SET(_anonymous_1265__148_2113, ((long) 1), aux_2283);
						     }
						     PROCEDURE_SET(_anonymous_1265__148_2113, ((long) 2), src_def_101_93);
						     PROCEDURE_SET(_anonymous_1265__148_2113, ((long) 3), import_91);
						     arg1263_542 =
							make_promise_21___r4_control_features_6_9(_anonymous_1265__148_2113);
						  }
						  {	/* Module/class.scm 234 */
						     obj_t arg1313_1449;
						     {	/* ./Ieee/pair-list.scm 5689 */
							obj_t aux_2289;
							aux_2289 =
							   (obj_t) (type_531);
							arg1313_1449 =
							   MAKE_PAIR(aux_2289, arg1263_542);
						     }
						     {	/* Module/class.scm 234 */
							obj_t obj2_1453;
							obj2_1453 = _class_accesses__244_module_class;
							_class_accesses__244_module_class =
							   MAKE_PAIR(arg1313_1449, obj2_1453);
						     }
						  }
					       }
					     else
					       {	/* Module/class.scm 97 */
						  {	/* Module/class.scm 118 */
						     obj_t arg1267_548;
						     {	/* Module/class.scm 118 */
							obj_t _anonymous_1269__252_2115;
							_anonymous_1269__252_2115 =
							   make_fx_procedure(_anonymous_1269__252_module_class, ((long) 0), ((long) 4));
							PROCEDURE_SET(_anonymous_1269__252_2115, ((long) 0), class_def_12_89);
							{	/* Module/class.scm 118 */
							   obj_t aux_2295;
							   aux_2295 =
							      (obj_t) (type_531);
							   PROCEDURE_SET(_anonymous_1269__252_2115, ((long) 1), aux_2295);
							}
							PROCEDURE_SET(_anonymous_1269__252_2115, ((long) 2), src_def_101_93);
							PROCEDURE_SET(_anonymous_1269__252_2115, ((long) 3), import_91);
							arg1267_548 =
							   make_promise_21___r4_control_features_6_9(_anonymous_1269__252_2115);
						     }
						     {	/* Module/class.scm 234 */
							obj_t arg1313_1456;
							{	/* ./Ieee/pair-list.scm 5689 */
							   obj_t aux_2301;
							   aux_2301 =
							      (obj_t) (type_531);
							   arg1313_1456 =
							      MAKE_PAIR(aux_2301, arg1267_548);
							}
							{	/* Module/class.scm 234 */
							   obj_t obj2_1460;
							   obj2_1460 = _class_accesses__244_module_class;
							   _class_accesses__244_module_class =
							      MAKE_PAIR(arg1313_1456, obj2_1460);
							}
						     }
						  }
						  {	/* Module/class.scm 128 */
						     obj_t arg1270_554;
						     {	/* Module/class.scm 128 */
							obj_t _anonymous_1272__46_2114;
							_anonymous_1272__46_2114 =
							   make_fx_procedure(_anonymous_1272__46_module_class, ((long) 0), ((long) 4));
							PROCEDURE_SET(_anonymous_1272__46_2114, ((long) 0), class_def_12_89);
							{	/* Module/class.scm 128 */
							   obj_t aux_2307;
							   aux_2307 =
							      (obj_t) (type_531);
							   PROCEDURE_SET(_anonymous_1272__46_2114, ((long) 1), aux_2307);
							}
							PROCEDURE_SET(_anonymous_1272__46_2114, ((long) 2), src_def_101_93);
							PROCEDURE_SET(_anonymous_1272__46_2114, ((long) 3), module_90);
							arg1270_554 =
							   make_promise_21___r4_control_features_6_9(_anonymous_1272__46_2114);
						     }
						     {	/* Module/class.scm 234 */
							obj_t arg1313_1463;
							{	/* ./Ieee/pair-list.scm 5689 */
							   obj_t aux_2313;
							   aux_2313 =
							      (obj_t) (type_531);
							   arg1313_1463 =
							      MAKE_PAIR(aux_2313, arg1270_554);
							}
							{	/* Module/class.scm 234 */
							   obj_t obj2_1467;
							   obj2_1467 = _class_accesses__244_module_class;
							   _class_accesses__244_module_class =
							      MAKE_PAIR(arg1313_1463, obj2_1467);
							}
						     }
						  }
					       }
					  }
				       }
				     else
				       {	/* Module/class.scm 96 */
					  {	/* Module/class.scm 139 */
					     obj_t arg1274_561;
					     {	/* Module/class.scm 139 */
						obj_t _anonymous_1277__14_2116;
						_anonymous_1277__14_2116 =
						   make_fx_procedure(_anonymous_1277__14_module_class, ((long) 0), ((long) 4));
						PROCEDURE_SET(_anonymous_1277__14_2116, ((long) 0), class_def_12_89);
						{	/* Module/class.scm 139 */
						   obj_t aux_2319;
						   aux_2319 =
						      (obj_t) (type_531);
						   PROCEDURE_SET(_anonymous_1277__14_2116, ((long) 1), aux_2319);
						}
						PROCEDURE_SET(_anonymous_1277__14_2116, ((long) 2), src_def_101_93);
						PROCEDURE_SET(_anonymous_1277__14_2116, ((long) 3), module_90);
						arg1274_561 =
						   make_promise_21___r4_control_features_6_9(_anonymous_1277__14_2116);
					     }
					     {	/* Module/class.scm 234 */
						obj_t arg1313_1470;
						{	/* ./Ieee/pair-list.scm 5689 */
						   obj_t aux_2325;
						   aux_2325 =
						      (obj_t) (type_531);
						   arg1313_1470 =
						      MAKE_PAIR(aux_2325, arg1274_561);
						}
						{	/* Module/class.scm 234 */
						   obj_t obj2_1474;
						   obj2_1474 = _class_accesses__244_module_class;
						   _class_accesses__244_module_class =
						      MAKE_PAIR(arg1313_1470, obj2_1474);
						}
					     }
					  }
				       }
				  }
			     }
			     return
				(obj_t) (type_531);
			  }
			else
			  {	/* Module/class.scm 75 */
			     return BUNSPEC;
			  }
		     }
		  }
	       }
	    }
	 }
      }
   }
}



/* _declare-class!1820 */
obj_t 
_declare_class_1820_144_module_class(obj_t env_2117, obj_t class_def_12_2118, obj_t module_2119, obj_t import_2120, obj_t final__12_2121, obj_t src_def_101_2122)
{
   AN_OBJECT;
   {	/* Module/class.scm 61 */
      return
	 declare_class__31_module_class(class_def_12_2118, module_2119, import_2120,
	 CBOOL(final__12_2121), src_def_101_2122);
   }
}



/* <anonymous:1260> */
obj_t 
_anonymous_1260__161_module_class(obj_t env_2123)
{
   AN_OBJECT;
   {	/* Module/class.scm 82 */
      {		/* Module/class.scm 83 */
	 obj_t class_def_12_2124;
	 obj_t type_2125;
	 obj_t src_def_101_2126;
	 obj_t import_2127;
	 obj_t holder_2128;
	 class_def_12_2124 =
	    PROCEDURE_REF(env_2123, ((long) 0));
	 type_2125 =
	    PROCEDURE_REF(env_2123, ((long) 1));
	 src_def_101_2126 =
	    PROCEDURE_REF(env_2123, ((long) 2));
	 import_2127 =
	    PROCEDURE_REF(env_2123, ((long) 3));
	 holder_2128 =
	    PROCEDURE_REF(env_2123, ((long) 4));
	 {

	    {	/* Module/class.scm 83 */
	       obj_t accessors_537;
	       accessors_537 =
		  make_plain_class_accessors__206_object_plain_access_186(class_def_12_2124,
		  (type_bglt) (type_2125), src_def_101_2126, import_2127);
	       {	/* Module/class.scm 83 */
		  obj_t virtuals_538;
		  virtuals_538 = _res1__155___r5_control_features_6_4;
		  make_add_class__155_module_class(holder_2128, type_2125, src_def_101_2126, virtuals_538);
		  return accessors_537;
	       }
	    }
	 }
      }
   }
}



/* <anonymous:1265> */
obj_t 
_anonymous_1265__148_module_class(obj_t env_2129)
{
   AN_OBJECT;
   {	/* Module/class.scm 104 */
      {		/* Module/class.scm 105 */
	 obj_t class_def_12_2130;
	 obj_t type_2131;
	 obj_t src_def_101_2132;
	 obj_t import_2133;
	 class_def_12_2130 =
	    PROCEDURE_REF(env_2129, ((long) 0));
	 type_2131 =
	    PROCEDURE_REF(env_2129, ((long) 1));
	 src_def_101_2132 =
	    PROCEDURE_REF(env_2129, ((long) 2));
	 import_2133 =
	    PROCEDURE_REF(env_2129, ((long) 3));
	 {

	    {	/* Module/class.scm 105 */
	       obj_t accessors_545;
	       accessors_545 =
		  make_plain_class_accessors__206_object_plain_access_186(class_def_12_2130,
		  (type_bglt) (type_2131), src_def_101_2132, import_2133);
	       {	/* Module/class.scm 105 */
		  obj_t __186_546;
		  __186_546 = _res1__155___r5_control_features_6_4;
		  return accessors_545;
	       }
	    }
	 }
      }
   }
}



/* <anonymous:1272> */
obj_t 
_anonymous_1272__46_module_class(obj_t env_2134)
{
   AN_OBJECT;
   {	/* Module/class.scm 127 */
      {		/* Module/class.scm 128 */
	 obj_t class_def_12_2135;
	 obj_t type_2136;
	 obj_t src_def_101_2137;
	 obj_t module_2138;
	 class_def_12_2135 =
	    PROCEDURE_REF(env_2134, ((long) 0));
	 type_2136 =
	    PROCEDURE_REF(env_2134, ((long) 1));
	 src_def_101_2137 =
	    PROCEDURE_REF(env_2134, ((long) 2));
	 module_2138 =
	    PROCEDURE_REF(env_2134, ((long) 3));
	 {

	    {	/* Module/class.scm 128 */
	       obj_t accessors_557;
	       accessors_557 =
		  import_plain_class_makes__28_object_plain_access_186(class_def_12_2135,
		  (type_bglt) (type_2136), src_def_101_2137, module_2138);
	       {	/* Module/class.scm 128 */
		  obj_t __186_558;
		  __186_558 = _res1__155___r5_control_features_6_4;
		  return accessors_557;
	       }
	    }
	 }
      }
   }
}



/* <anonymous:1269> */
obj_t 
_anonymous_1269__252_module_class(obj_t env_2139)
{
   AN_OBJECT;
   {	/* Module/class.scm 117 */
      {		/* Module/class.scm 118 */
	 obj_t class_def_12_2140;
	 obj_t type_2141;
	 obj_t src_def_101_2142;
	 obj_t import_2143;
	 class_def_12_2140 =
	    PROCEDURE_REF(env_2139, ((long) 0));
	 type_2141 =
	    PROCEDURE_REF(env_2139, ((long) 1));
	 src_def_101_2142 =
	    PROCEDURE_REF(env_2139, ((long) 2));
	 import_2143 =
	    PROCEDURE_REF(env_2139, ((long) 3));
	 {

	    {	/* Module/class.scm 118 */
	       obj_t accessors_551;
	       accessors_551 =
		  make_plain_class_accessors_sans_makes__96_object_plain_access_186(class_def_12_2140,
		  (type_bglt) (type_2141), src_def_101_2142, import_2143);
	       {	/* Module/class.scm 118 */
		  obj_t __186_552;
		  __186_552 = _res1__155___r5_control_features_6_4;
		  return accessors_551;
	       }
	    }
	 }
      }
   }
}



/* <anonymous:1277> */
obj_t 
_anonymous_1277__14_module_class(obj_t env_2144)
{
   AN_OBJECT;
   {	/* Module/class.scm 138 */
      {		/* Module/class.scm 139 */
	 obj_t class_def_12_2145;
	 obj_t type_2146;
	 obj_t src_def_101_2147;
	 obj_t module_2148;
	 class_def_12_2145 =
	    PROCEDURE_REF(env_2144, ((long) 0));
	 type_2146 =
	    PROCEDURE_REF(env_2144, ((long) 1));
	 src_def_101_2147 =
	    PROCEDURE_REF(env_2144, ((long) 2));
	 module_2148 =
	    PROCEDURE_REF(env_2144, ((long) 3));
	 {

	    {	/* Module/class.scm 139 */
	       obj_t accessors_564;
	       accessors_564 =
		  import_plain_class_accessors__109_object_plain_access_186(class_def_12_2145,
		  (type_bglt) (type_2146), src_def_101_2147, module_2148);
	       {	/* Module/class.scm 139 */
		  obj_t __186_565;
		  __186_565 = _res1__155___r5_control_features_6_4;
		  return accessors_564;
	       }
	    }
	 }
      }
   }
}



/* declare-wide-class! */
obj_t 
declare_wide_class__13_module_class(obj_t class_def_12_94, obj_t module_95, obj_t import_96, obj_t src_def_101_97)
{
   AN_OBJECT;
   {	/* Module/class.scm 151 */
      {		/* Module/class.scm 154 */
	 obj_t loc_572;
	 loc_572 =
	    find_location_120_tools_location(src_def_101_97);
	 {	/* Module/class.scm 155 */
	    obj_t class_id_86_574;
	    class_id_86_574 =
	       id_of_id_112_ast_ident(
	       CAR(class_def_12_94), loc_572);
	    {	/* Module/class.scm 156 */
	       obj_t holder_575;
	       {	/* Module/class.scm 157 */
		  bool_t test_2367;
		  {	/* Module/class.scm 157 */
		     bool_t test_2368;
		     {	/* ./Ieee/equiv.scm 5508 */
			obj_t aux_2369;
			aux_2369 =
			   CNST_TABLE_REF(((long) 0));
			test_2368 =
			   (import_96 == aux_2369);
		     }
		     if (test_2368)
		       {	/* Module/class.scm 157 */
			  test_2367 = ((bool_t) 1)
			     ;
		       }
		     else
		       {	/* ./Ieee/equiv.scm 5508 */
			  obj_t aux_2372;
			  aux_2372 =
			     CNST_TABLE_REF(((long) 1));
			  test_2367 =
			     (import_96 == aux_2372);
		       }
		  }
		  if (test_2367)
		    {	/* Module/class.scm 157 */
		       holder_575 =
			  import_parser_53_module_impuse(module_95, class_id_86_574);
		    }
		  else
		    {	/* Module/class.scm 157 */
		       {	/* Module/class.scm 160 */
			  obj_t arg1307_614;
			  {	/* Module/class.scm 160 */
			     obj_t arg1308_615;
			     arg1308_615 =
				MAKE_PAIR(class_id_86_574, BNIL);
			     arg1307_614 =
				MAKE_PAIR(import_96, arg1308_615);
			  }
			  produce_module_clause__172_module_module(arg1307_614);
		       }
		       holder_575 =
			  find_global_module_25_ast_env(class_id_86_574, module_95);
		    }
	       }
	       {	/* Module/class.scm 157 */
		  type_bglt type_576;
		  type_576 =
		     declare_class_type__110_object_class(class_def_12_94,
		     (global_bglt) (holder_575),
		     CNST_TABLE_REF(((long) 3)), ((bool_t) 0), src_def_101_97);
		  {	/* Module/class.scm 162 */

		     {	/* Module/class.scm 166 */
			bool_t test1283_577;
			test1283_577 =
			   is_a__118___object(
			   (obj_t) (type_576), tclass_object_class);
			if (test1283_577)
			  {	/* Module/class.scm 169 */
			     bool_t test_2386;
			     {	/* Module/class.scm 169 */
				obj_t aux_2387;
				aux_2387 =
				   memq___r4_pairs_and_lists_6_3(import_96,
				   CNST_TABLE_REF(((long) 2)));
				test_2386 =
				   CBOOL(aux_2387);
			     }
			     if (test_2386)
			       {	/* Module/class.scm 169 */
				  {	/* Module/class.scm 174 */
				     obj_t arg1286_579;
				     {	/* Module/class.scm 174 */
					obj_t _anonymous_1288__199_2149;
					_anonymous_1288__199_2149 =
					   make_fx_procedure(_anonymous_1288__199_module_class, ((long) 0), ((long) 5));
					PROCEDURE_SET(_anonymous_1288__199_2149, ((long) 0), class_def_12_94);
					{	/* Module/class.scm 174 */
					   obj_t aux_2393;
					   aux_2393 =
					      (obj_t) (type_576);
					   PROCEDURE_SET(_anonymous_1288__199_2149, ((long) 1), aux_2393);
					}
					PROCEDURE_SET(_anonymous_1288__199_2149, ((long) 2), src_def_101_97);
					PROCEDURE_SET(_anonymous_1288__199_2149, ((long) 3), import_96);
					PROCEDURE_SET(_anonymous_1288__199_2149, ((long) 4), holder_575);
					arg1286_579 =
					   make_promise_21___r4_control_features_6_9(_anonymous_1288__199_2149);
				     }
				     {	/* Module/class.scm 234 */
					obj_t arg1313_1487;
					{	/* ./Ieee/pair-list.scm 5689 */
					   obj_t aux_2400;
					   aux_2400 =
					      (obj_t) (type_576);
					   arg1313_1487 =
					      MAKE_PAIR(aux_2400, arg1286_579);
					}
					{	/* Module/class.scm 234 */
					   obj_t obj2_1491;
					   obj2_1491 = _class_accesses__244_module_class;
					   return (
					      _class_accesses__244_module_class =
					      MAKE_PAIR(arg1313_1487, obj2_1491), BUNSPEC);
					}
				     }
				  }
			       }
			     else
			       {	/* Module/class.scm 181 */
				  bool_t test1289_585;
				  {	/* Module/class.scm 181 */
				     bool_t test1304_612;
				     {	/* Module/class.scm 181 */
					long n1_1492;
					n1_1492 =
					   (long) CINT(_optim__89_engine_param);
					test1304_612 =
					   (n1_1492 >= ((long) 2));
				     }
				     if (test1304_612)
				       {	/* Module/class.scm 181 */
					  long n1_1494;
					  n1_1494 =
					     (long) CINT(_bdb_debug__1_engine_param);
					  test1289_585 =
					     (n1_1494 <= ((long) 0));
				       }
				     else
				       {	/* Module/class.scm 181 */
					  test1289_585 = ((bool_t) 0);
				       }
				  }
				  if (test1289_585)
				    {	/* Module/class.scm 181 */
				       {	/* Module/class.scm 182 */
					  bool_t test1290_586;
					  {	/* Module/class.scm 182 */
					     bool_t test1300_605;
					     {	/* Module/class.scm 182 */
						obj_t obj_1496;
						obj_1496 = _profile_mode__105_engine_param;
						test1300_605 =
						   INTEGERP(obj_1496);
					     }
					     if (test1300_605)
					       {	/* Module/class.scm 183 */
						  long n1_1497;
						  n1_1497 =
						     (long) CINT(_profile_mode__105_engine_param);
						  test1290_586 =
						     (n1_1497 == ((long) 0));
					       }
					     else
					       {	/* Module/class.scm 182 */
						  test1290_586 = ((bool_t) 1);
					       }
					  }
					  if (test1290_586)
					    {	/* Module/class.scm 190 */
					       obj_t arg1291_587;
					       {	/* Module/class.scm 190 */
						  obj_t _anonymous_1293__185_2150;
						  _anonymous_1293__185_2150 =
						     make_fx_procedure(_anonymous_1293__185_module_class, ((long) 0), ((long) 4));
						  PROCEDURE_SET(_anonymous_1293__185_2150, ((long) 0), class_def_12_94);
						  {	/* Module/class.scm 190 */
						     obj_t aux_2417;
						     aux_2417 =
							(obj_t) (type_576);
						     PROCEDURE_SET(_anonymous_1293__185_2150, ((long) 1), aux_2417);
						  }
						  PROCEDURE_SET(_anonymous_1293__185_2150, ((long) 2), src_def_101_97);
						  PROCEDURE_SET(_anonymous_1293__185_2150, ((long) 3), import_96);
						  arg1291_587 =
						     make_promise_21___r4_control_features_6_9(_anonymous_1293__185_2150);
					       }
					       {	/* Module/class.scm 234 */
						  obj_t arg1313_1501;
						  {	/* ./Ieee/pair-list.scm 5689 */
						     obj_t aux_2423;
						     aux_2423 =
							(obj_t) (type_576);
						     arg1313_1501 =
							MAKE_PAIR(aux_2423, arg1291_587);
						  }
						  {	/* Module/class.scm 234 */
						     obj_t obj2_1505;
						     obj2_1505 = _class_accesses__244_module_class;
						     return (
							_class_accesses__244_module_class =
							MAKE_PAIR(arg1313_1501, obj2_1505), BUNSPEC);
						  }
					       }
					    }
					  else
					    {	/* Module/class.scm 182 */
					       {	/* Module/class.scm 203 */
						  obj_t arg1294_593;
						  {	/* Module/class.scm 203 */
						     obj_t _anonymous_1296__4_2152;
						     _anonymous_1296__4_2152 =
							make_fx_procedure(_anonymous_1296__4_module_class, ((long) 0), ((long) 4));
						     PROCEDURE_SET(_anonymous_1296__4_2152, ((long) 0), class_def_12_94);
						     {	/* Module/class.scm 203 */
							obj_t aux_2429;
							aux_2429 =
							   (obj_t) (type_576);
							PROCEDURE_SET(_anonymous_1296__4_2152, ((long) 1), aux_2429);
						     }
						     PROCEDURE_SET(_anonymous_1296__4_2152, ((long) 2), src_def_101_97);
						     PROCEDURE_SET(_anonymous_1296__4_2152, ((long) 3), import_96);
						     arg1294_593 =
							make_promise_21___r4_control_features_6_9(_anonymous_1296__4_2152);
						  }
						  {	/* Module/class.scm 234 */
						     obj_t arg1313_1508;
						     {	/* ./Ieee/pair-list.scm 5689 */
							obj_t aux_2435;
							aux_2435 =
							   (obj_t) (type_576);
							arg1313_1508 =
							   MAKE_PAIR(aux_2435, arg1294_593);
						     }
						     {	/* Module/class.scm 234 */
							obj_t obj2_1512;
							obj2_1512 = _class_accesses__244_module_class;
							_class_accesses__244_module_class =
							   MAKE_PAIR(arg1313_1508, obj2_1512);
						     }
						  }
					       }
					       {	/* Module/class.scm 212 */
						  obj_t arg1297_599;
						  {	/* Module/class.scm 212 */
						     obj_t _anonymous_1299__80_2151;
						     _anonymous_1299__80_2151 =
							make_fx_procedure(_anonymous_1299__80_module_class, ((long) 0), ((long) 4));
						     PROCEDURE_SET(_anonymous_1299__80_2151, ((long) 0), class_def_12_94);
						     {	/* Module/class.scm 212 */
							obj_t aux_2441;
							aux_2441 =
							   (obj_t) (type_576);
							PROCEDURE_SET(_anonymous_1299__80_2151, ((long) 1), aux_2441);
						     }
						     PROCEDURE_SET(_anonymous_1299__80_2151, ((long) 2), src_def_101_97);
						     PROCEDURE_SET(_anonymous_1299__80_2151, ((long) 3), module_95);
						     arg1297_599 =
							make_promise_21___r4_control_features_6_9(_anonymous_1299__80_2151);
						  }
						  {	/* Module/class.scm 234 */
						     obj_t arg1313_1515;
						     {	/* ./Ieee/pair-list.scm 5689 */
							obj_t aux_2447;
							aux_2447 =
							   (obj_t) (type_576);
							arg1313_1515 =
							   MAKE_PAIR(aux_2447, arg1297_599);
						     }
						     {	/* Module/class.scm 234 */
							obj_t obj2_1519;
							obj2_1519 = _class_accesses__244_module_class;
							return (
							   _class_accesses__244_module_class =
							   MAKE_PAIR(arg1313_1515, obj2_1519), BUNSPEC);
						     }
						  }
					       }
					    }
				       }
				    }
				  else
				    {	/* Module/class.scm 181 */
				       {	/* Module/class.scm 223 */
					  obj_t arg1301_606;
					  {	/* Module/class.scm 223 */
					     obj_t _anonymous_1303__124_2153;
					     _anonymous_1303__124_2153 =
						make_fx_procedure(_anonymous_1303__124_module_class, ((long) 0), ((long) 4));
					     PROCEDURE_SET(_anonymous_1303__124_2153, ((long) 0), class_def_12_94);
					     {	/* Module/class.scm 223 */
						obj_t aux_2453;
						aux_2453 =
						   (obj_t) (type_576);
						PROCEDURE_SET(_anonymous_1303__124_2153, ((long) 1), aux_2453);
					     }
					     PROCEDURE_SET(_anonymous_1303__124_2153, ((long) 2), src_def_101_97);
					     PROCEDURE_SET(_anonymous_1303__124_2153, ((long) 3), module_95);
					     arg1301_606 =
						make_promise_21___r4_control_features_6_9(_anonymous_1303__124_2153);
					  }
					  {	/* Module/class.scm 234 */
					     obj_t arg1313_1522;
					     {	/* ./Ieee/pair-list.scm 5689 */
						obj_t aux_2459;
						aux_2459 =
						   (obj_t) (type_576);
						arg1313_1522 =
						   MAKE_PAIR(aux_2459, arg1301_606);
					     }
					     {	/* Module/class.scm 234 */
						obj_t obj2_1526;
						obj2_1526 = _class_accesses__244_module_class;
						return (
						   _class_accesses__244_module_class =
						   MAKE_PAIR(arg1313_1522, obj2_1526), BUNSPEC);
					     }
					  }
				       }
				    }
			       }
			  }
			else
			  {	/* Module/class.scm 166 */
			     return BUNSPEC;
			  }
		     }
		  }
	       }
	    }
	 }
      }
   }
}



/* _declare-wide-class!1821 */
obj_t 
_declare_wide_class_1821_177_module_class(obj_t env_2154, obj_t class_def_12_2155, obj_t module_2156, obj_t import_2157, obj_t src_def_101_2158)
{
   AN_OBJECT;
   {	/* Module/class.scm 151 */
      return
	 declare_wide_class__13_module_class(class_def_12_2155, module_2156, import_2157, src_def_101_2158);
   }
}



/* <anonymous:1288> */
obj_t 
_anonymous_1288__199_module_class(obj_t env_2159)
{
   AN_OBJECT;
   {	/* Module/class.scm 173 */
      {		/* Module/class.scm 174 */
	 obj_t class_def_12_2160;
	 obj_t type_2161;
	 obj_t src_def_101_2162;
	 obj_t import_2163;
	 obj_t holder_2164;
	 class_def_12_2160 =
	    PROCEDURE_REF(env_2159, ((long) 0));
	 type_2161 =
	    PROCEDURE_REF(env_2159, ((long) 1));
	 src_def_101_2162 =
	    PROCEDURE_REF(env_2159, ((long) 2));
	 import_2163 =
	    PROCEDURE_REF(env_2159, ((long) 3));
	 holder_2164 =
	    PROCEDURE_REF(env_2159, ((long) 4));
	 {

	    {	/* Module/class.scm 174 */
	       obj_t accessors_582;
	       accessors_582 =
		  make_wide_class_accessors__22_object_wide_access_168(class_def_12_2160,
		  (type_bglt) (type_2161), src_def_101_2162, import_2163);
	       {	/* Module/class.scm 174 */
		  obj_t virtuals_583;
		  virtuals_583 = _res1__155___r5_control_features_6_4;
		  make_add_class__155_module_class(holder_2164, type_2161, src_def_101_2162, virtuals_583);
		  return accessors_582;
	       }
	    }
	 }
      }
   }
}



/* <anonymous:1293> */
obj_t 
_anonymous_1293__185_module_class(obj_t env_2165)
{
   AN_OBJECT;
   {	/* Module/class.scm 189 */
      {		/* Module/class.scm 190 */
	 obj_t class_def_12_2166;
	 obj_t type_2167;
	 obj_t src_def_101_2168;
	 obj_t import_2169;
	 class_def_12_2166 =
	    PROCEDURE_REF(env_2165, ((long) 0));
	 type_2167 =
	    PROCEDURE_REF(env_2165, ((long) 1));
	 src_def_101_2168 =
	    PROCEDURE_REF(env_2165, ((long) 2));
	 import_2169 =
	    PROCEDURE_REF(env_2165, ((long) 3));
	 {

	    {	/* Module/class.scm 190 */
	       obj_t accessors_590;
	       accessors_590 =
		  make_wide_class_accessors__22_object_wide_access_168(class_def_12_2166,
		  (type_bglt) (type_2167), src_def_101_2168, import_2169);
	       {	/* Module/class.scm 190 */
		  obj_t __186_591;
		  __186_591 = _res1__155___r5_control_features_6_4;
		  return accessors_590;
	       }
	    }
	 }
      }
   }
}



/* <anonymous:1299> */
obj_t 
_anonymous_1299__80_module_class(obj_t env_2170)
{
   AN_OBJECT;
   {	/* Module/class.scm 211 */
      {		/* Module/class.scm 212 */
	 obj_t class_def_12_2171;
	 obj_t type_2172;
	 obj_t src_def_101_2173;
	 obj_t module_2174;
	 class_def_12_2171 =
	    PROCEDURE_REF(env_2170, ((long) 0));
	 type_2172 =
	    PROCEDURE_REF(env_2170, ((long) 1));
	 src_def_101_2173 =
	    PROCEDURE_REF(env_2170, ((long) 2));
	 module_2174 =
	    PROCEDURE_REF(env_2170, ((long) 3));
	 {

	    {	/* Module/class.scm 212 */
	       obj_t accessors_602;
	       accessors_602 =
		  import_wide_class_makes__40_object_wide_access_168(class_def_12_2171,
		  (type_bglt) (type_2172), src_def_101_2173, module_2174);
	       {	/* Module/class.scm 212 */
		  obj_t __186_603;
		  __186_603 = _res1__155___r5_control_features_6_4;
		  return accessors_602;
	       }
	    }
	 }
      }
   }
}



/* <anonymous:1296> */
obj_t 
_anonymous_1296__4_module_class(obj_t env_2175)
{
   AN_OBJECT;
   {	/* Module/class.scm 202 */
      {		/* Module/class.scm 203 */
	 obj_t class_def_12_2176;
	 obj_t type_2177;
	 obj_t src_def_101_2178;
	 obj_t import_2179;
	 class_def_12_2176 =
	    PROCEDURE_REF(env_2175, ((long) 0));
	 type_2177 =
	    PROCEDURE_REF(env_2175, ((long) 1));
	 src_def_101_2178 =
	    PROCEDURE_REF(env_2175, ((long) 2));
	 import_2179 =
	    PROCEDURE_REF(env_2175, ((long) 3));
	 {

	    {	/* Module/class.scm 203 */
	       obj_t accessors_596;
	       accessors_596 =
		  make_wide_class_accessors_sans_makes__153_object_wide_access_168(class_def_12_2176,
		  (type_bglt) (type_2177), src_def_101_2178, import_2179);
	       {	/* Module/class.scm 203 */
		  obj_t __186_597;
		  __186_597 = _res1__155___r5_control_features_6_4;
		  return accessors_596;
	       }
	    }
	 }
      }
   }
}



/* <anonymous:1303> */
obj_t 
_anonymous_1303__124_module_class(obj_t env_2180)
{
   AN_OBJECT;
   {	/* Module/class.scm 222 */
      {		/* Module/class.scm 223 */
	 obj_t class_def_12_2181;
	 obj_t type_2182;
	 obj_t src_def_101_2183;
	 obj_t module_2184;
	 class_def_12_2181 =
	    PROCEDURE_REF(env_2180, ((long) 0));
	 type_2182 =
	    PROCEDURE_REF(env_2180, ((long) 1));
	 src_def_101_2183 =
	    PROCEDURE_REF(env_2180, ((long) 2));
	 module_2184 =
	    PROCEDURE_REF(env_2180, ((long) 3));
	 {

	    {	/* Module/class.scm 223 */
	       obj_t accessors_609;
	       accessors_609 =
		  import_wide_class_accessors__236_object_wide_access_168(class_def_12_2181,
		  (type_bglt) (type_2182), src_def_101_2183, module_2184);
	       {	/* Module/class.scm 223 */
		  obj_t __186_610;
		  __186_610 = _res1__155___r5_control_features_6_4;
		  return accessors_609;
	       }
	    }
	 }
      }
   }
}



/* make-add-class! */
obj_t 
make_add_class__155_module_class(obj_t holder_100, obj_t class_101, obj_t src_def_101_102, obj_t virtuals_103)
{
   AN_OBJECT;
   {	/* Module/class.scm 249 */
      {		/* Module/class.scm 250 */
	 obj_t super_618;
	 {	/* Module/class.scm 250 */
	    tclass_bglt obj_1532;
	    obj_1532 =
	       (tclass_bglt) (class_101);
	    {
	       obj_t aux_2497;
	       {	/* ./Object/class.scm 1597 */
		  object_bglt aux_2498;
		  aux_2498 =
		     (object_bglt) (obj_1532);
		  aux_2497 =
		     OBJECT_WIDENING(aux_2498);
	       }
	       super_618 =
		  (((tclass_bglt) CREF(aux_2497))->its_super_214);
	    }
	 }
	 {	/* Module/class.scm 250 */
	    obj_t holder_id_229_619;
	    {	/* Module/class.scm 251 */
	       global_bglt obj_1533;
	       obj_1533 =
		  (global_bglt) (holder_100);
	       holder_id_229_619 =
		  (((global_bglt) CREF(obj_1533))->id);
	    }
	    {	/* Module/class.scm 251 */
	       obj_t class_id_86_620;
	       {	/* Module/class.scm 252 */
		  type_bglt obj_1534;
		  obj_1534 =
		     (type_bglt) (class_101);
		  class_id_86_620 =
		     (((type_bglt) CREF(obj_1534))->id);
	       }
	       {	/* Module/class.scm 252 */
		  obj_t class_module_252_621;
		  {	/* Module/class.scm 253 */
		     global_bglt obj_1535;
		     obj_1535 =
			(global_bglt) (holder_100);
		     class_module_252_621 =
			(((global_bglt) CREF(obj_1535))->module);
		  }
		  {	/* Module/class.scm 253 */
		     obj_t class_alloc_id_85_622;
		     {	/* Module/class.scm 254 */
			obj_t list1438_742;
			{	/* Module/class.scm 254 */
			   obj_t arg1439_743;
			   obj_t arg1440_744;
			   arg1439_743 =
			      CNST_TABLE_REF(((long) 4));
			   arg1440_744 =
			      MAKE_PAIR(class_id_86_620, BNIL);
			   list1438_742 =
			      MAKE_PAIR(arg1439_743, arg1440_744);
			}
			class_alloc_id_85_622 =
			   symbol_append_197___r4_symbols_6_4(list1438_742);
		     }
		     {	/* Module/class.scm 254 */
			obj_t class_alloc_109_623;
			{	/* Module/class.scm 255 */
			   obj_t arg1435_739;
			   obj_t arg1436_740;
			   arg1435_739 =
			      CNST_TABLE_REF(((long) 5));
			   {	/* Module/class.scm 255 */
			      obj_t arg1437_741;
			      arg1437_741 =
				 MAKE_PAIR(class_module_252_621, BNIL);
			      arg1436_740 =
				 MAKE_PAIR(class_alloc_id_85_622, arg1437_741);
			   }
			   class_alloc_109_623 =
			      MAKE_PAIR(arg1435_739, arg1436_740);
			}
			{	/* Module/class.scm 255 */
			   obj_t hash_624;
			   {	/* Module/class.scm 256 */
			      obj_t aux_2516;
			      {		/* ./Ieee/pair-list.scm 5707 */
				 obj_t aux_2517;
				 aux_2517 =
				    CDR(src_def_101_102);
				 aux_2516 =
				    CDR(aux_2517);
			      }
			      hash_624 =
				 get_class_hash_100_module_class(class_id_86_620, aux_2516);
			   }
			   {	/* Module/class.scm 256 */
			      obj_t constr_625;
			      {		/* Module/class.scm 257 */
				 tclass_bglt obj_1546;
				 obj_1546 =
				    (tclass_bglt) (class_101);
				 {
				    obj_t aux_2522;
				    {	/* ./Object/class.scm 1611 */
				       object_bglt aux_2523;
				       aux_2523 =
					  (object_bglt) (obj_1546);
				       aux_2522 =
					  OBJECT_WIDENING(aux_2523);
				    }
				    constr_625 =
				       (((tclass_bglt) CREF(aux_2522))->constructor);
				 }
			      }
			      {		/* Module/class.scm 257 */
				 obj_t loc_626;
				 loc_626 =
				    find_location_120_tools_location(src_def_101_102);
				 {	/* Module/class.scm 258 */
				    obj_t fields_627;
				    {	/* Module/class.scm 259 */
				       obj_t aux_2528;
				       {	/* ./Ieee/pair-list.scm 5707 */
					  obj_t aux_2529;
					  aux_2529 =
					     CDR(src_def_101_102);
					  aux_2528 =
					     CDR(aux_2529);
				       }
				       fields_627 =
					  make_class_fields_146_module_class(class_id_86_620, aux_2528, loc_626);
				    }
				    {	/* Module/class.scm 259 */

				       {	/* Module/class.scm 261 */
					  obj_t decl_628;
					  {	/* Module/class.scm 261 */
					     bool_t test1314_629;
					     test1314_629 =
						is_a__118___object(super_618, tclass_object_class);
					     if (test1314_629)
					       {	/* Module/class.scm 272 */
						  global_bglt sholder_630;
						  {	/* Module/class.scm 272 */
						     tclass_bglt obj_1552;
						     obj_1552 =
							(tclass_bglt) (super_618);
						     {
							obj_t aux_2536;
							{	/* ./Object/class.scm 1603 */
							   object_bglt aux_2537;
							   aux_2537 =
							      (object_bglt) (obj_1552);
							   aux_2536 =
							      OBJECT_WIDENING(aux_2537);
							}
							sholder_630 =
							   (((tclass_bglt) CREF(aux_2536))->holder);
						     }
						  }
						  {	/* Module/class.scm 272 */
						     obj_t sholder_id_85_631;
						     sholder_id_85_631 =
							(((global_bglt) CREF(sholder_630))->id);
						     {	/* Module/class.scm 274 */

							{	/* Module/class.scm 275 */
							   obj_t arg1315_633;
							   obj_t arg1317_634;
							   arg1315_633 =
							      CNST_TABLE_REF(((long) 6));
							   {	/* Module/class.scm 276 */
							      obj_t arg1318_635;
							      {		/* Module/class.scm 276 */
								 obj_t arg1319_636;
								 {	/* Module/class.scm 276 */
								    obj_t arg1322_638;
								    obj_t arg1323_639;
								    {	/* Module/class.scm 276 */
								       obj_t arg1325_640;
								       obj_t arg1326_641;
								       arg1325_640 =
									  CNST_TABLE_REF(((long) 5));
								       {	/* Module/class.scm 276 */
									  obj_t arg1327_642;
									  obj_t arg1329_643;
									  arg1327_642 =
									     CNST_TABLE_REF(((long) 7));
									  {	/* ./Ieee/pair-list.scm 5689 */
									     obj_t aux_2545;
									     aux_2545 =
										CNST_TABLE_REF(((long) 8));
									     arg1329_643 =
										MAKE_PAIR(aux_2545, BNIL);
									  }
									  arg1326_641 =
									     MAKE_PAIR(arg1327_642, arg1329_643);
								       }
								       arg1322_638 =
									  MAKE_PAIR(arg1325_640, arg1326_641);
								    }
								    {	/* Module/class.scm 277 */
								       obj_t arg1330_644;
								       obj_t arg1331_645;
								       {	/* Module/class.scm 277 */
									  obj_t arg1332_646;
									  obj_t arg1333_647;
									  arg1332_646 =
									     CNST_TABLE_REF(((long) 9));
									  arg1333_647 =
									     MAKE_PAIR(class_id_86_620, BNIL);
									  arg1330_644 =
									     MAKE_PAIR(arg1332_646, arg1333_647);
								       }
								       {	/* Module/class.scm 277 */
									  obj_t arg1334_648;
									  obj_t arg1335_649;
									  {	/* Module/class.scm 277 */
									     obj_t arg1336_650;
									     obj_t arg1337_651;
									     arg1336_650 =
										CNST_TABLE_REF(((long) 5));
									     {	/* Module/class.scm 277 */
										obj_t arg1338_652;
										{	/* ./Ieee/pair-list.scm 5689 */
										   obj_t aux_2554;
										   aux_2554 =
										      (((global_bglt) CREF(sholder_630))->module);
										   arg1338_652 =
										      MAKE_PAIR(aux_2554, BNIL);
										}
										arg1337_651 =
										   MAKE_PAIR(sholder_id_85_631, arg1338_652);
									     }
									     arg1334_648 =
										MAKE_PAIR(arg1336_650, arg1337_651);
									  }
									  {	/* Module/class.scm 280 */
									     obj_t arg1339_653;
									     {	/* Module/class.scm 280 */
										obj_t arg1340_654;
										{	/* Module/class.scm 280 */
										   obj_t arg1342_655;
										   {	/* Module/class.scm 280 */
										      obj_t arg1343_656;
										      {		/* Module/class.scm 280 */
											 obj_t arg1344_657;
											 {	/* Module/class.scm 280 */
											    obj_t arg1347_659;
											    obj_t arg1348_660;
											    arg1347_659 =
											       CNST_TABLE_REF(((long) 10));
											    {	/* Module/class.scm 280 */
											       obj_t arg1350_661;
											       if (
												  NULLP(virtuals_103))
												 {	/* Module/class.scm 280 */
												    arg1350_661 = BNIL;
												 }
											       else
												 {	/* Module/class.scm 280 */
												    obj_t head1228_665;
												    head1228_665 =
												       MAKE_PAIR(BNIL, BNIL);
												    {
												       obj_t l1226_666;
												       obj_t tail1229_667;
												       l1226_666 = virtuals_103;
												       tail1229_667 = head1228_665;
												     lname1227_668:
												       if (
													  NULLP(l1226_666))
													 {	/* Module/class.scm 280 */
													    arg1350_661 =
													       CDR(head1228_665);
													 }
												       else
													 {	/* Module/class.scm 281 */
													    obj_t newtail1230_670;
													    {	/* Module/class.scm 281 */
													       obj_t arg1358_672;
													       {	/* Module/class.scm 281 */
														  obj_t v_674;
														  v_674 =
														     CAR(l1226_666);
														  {	/* Module/class.scm 281 */
														     obj_t arg1361_675;
														     obj_t arg1363_676;
														     arg1361_675 =
															CNST_TABLE_REF(((long) 11));
														     {	/* Module/class.scm 281 */
															obj_t arg1365_677;
															obj_t arg1366_678;
															arg1365_677 =
															   CAR(v_674);
															{	/* Module/class.scm 282 */
															   obj_t arg1367_679;
															   {	/* Module/class.scm 282 */
															      obj_t arg1371_681;
															      obj_t arg1372_682;
															      arg1371_681 =
																 CNST_TABLE_REF(((long) 11));
															      {		/* Module/class.scm 282 */
																 obj_t arg1373_683;
																 obj_t arg1374_684;
																 {	/* ./Ieee/pair-list.scm 5701 */
																    obj_t aux_2570;
																    aux_2570 =
																       CDR(v_674);
																    arg1373_683 =
																       CAR(aux_2570);
																 }
																 {	/* ./Ieee/pair-list.scm 5689 */
																    obj_t aux_2573;
																    {	/* ./Ieee/pair-list.scm 5701 */
																       obj_t aux_2574;
																       {	/* ./Ieee/pair-list.scm 5707 */
																	  obj_t aux_2575;
																	  aux_2575 =
																	     CDR(v_674);
																	  aux_2574 =
																	     CDR(aux_2575);
																       }
																       aux_2573 =
																	  CAR(aux_2574);
																    }
																    arg1374_684 =
																       MAKE_PAIR(aux_2573, BNIL);
																 }
																 arg1372_682 =
																    MAKE_PAIR(arg1373_683, arg1374_684);
															      }
															      arg1367_679 =
																 MAKE_PAIR(arg1371_681, arg1372_682);
															   }
															   arg1366_678 =
															      MAKE_PAIR(arg1367_679, BNIL);
															}
															arg1363_676 =
															   MAKE_PAIR(arg1365_677, arg1366_678);
														     }
														     arg1358_672 =
															MAKE_PAIR(arg1361_675, arg1363_676);
														  }
													       }
													       newtail1230_670 =
														  MAKE_PAIR(arg1358_672, BNIL);
													    }
													    SET_CDR(tail1229_667, newtail1230_670);
													    {
													       obj_t tail1229_2589;
													       obj_t l1226_2587;
													       l1226_2587 =
														  CDR(l1226_666);
													       tail1229_2589 = newtail1230_670;
													       tail1229_667 = tail1229_2589;
													       l1226_666 = l1226_2587;
													       goto lname1227_668;
													    }
													 }
												    }
												 }
											       arg1348_660 =
												  append_2_18___r4_pairs_and_lists_6_3(arg1350_661, BNIL);
											    }
											    arg1344_657 =
											       MAKE_PAIR(arg1347_659, arg1348_660);
											 }
											 arg1343_656 =
											    MAKE_PAIR(arg1344_657, BNIL);
										      }
										      arg1342_655 =
											 MAKE_PAIR(constr_625, arg1343_656);
										   }
										   arg1340_654 =
										      MAKE_PAIR(fields_627, arg1342_655);
										}
										arg1339_653 =
										   MAKE_PAIR(hash_624, arg1340_654);
									     }
									     arg1335_649 =
										MAKE_PAIR(class_alloc_109_623, arg1339_653);
									  }
									  arg1331_645 =
									     MAKE_PAIR(arg1334_648, arg1335_649);
								       }
								       arg1323_639 =
									  MAKE_PAIR(arg1330_644, arg1331_645);
								    }
								    arg1319_636 =
								       MAKE_PAIR(arg1322_638, arg1323_639);
								 }
								 arg1318_635 =
								    MAKE_PAIR(arg1319_636, BNIL);
							      }
							      arg1317_634 =
								 MAKE_PAIR(holder_id_229_619, arg1318_635);
							   }
							   decl_628 =
							      MAKE_PAIR(arg1315_633, arg1317_634);
							}
						     }
						  }
					       }
					     else
					       {	/* Module/class.scm 262 */
						  obj_t arg1377_687;
						  obj_t arg1378_688;
						  arg1377_687 =
						     CNST_TABLE_REF(((long) 6));
						  {	/* Module/class.scm 263 */
						     obj_t arg1379_689;
						     {	/* Module/class.scm 263 */
							obj_t arg1380_690;
							{	/* Module/class.scm 263 */
							   obj_t arg1383_692;
							   obj_t arg1384_693;
							   {	/* Module/class.scm 263 */
							      obj_t arg1385_694;
							      obj_t arg1387_695;
							      arg1385_694 =
								 CNST_TABLE_REF(((long) 5));
							      {		/* Module/class.scm 263 */
								 obj_t arg1389_696;
								 obj_t arg1390_697;
								 arg1389_696 =
								    CNST_TABLE_REF(((long) 7));
								 {	/* ./Ieee/pair-list.scm 5689 */
								    obj_t aux_2606;
								    aux_2606 =
								       CNST_TABLE_REF(((long) 8));
								    arg1390_697 =
								       MAKE_PAIR(aux_2606, BNIL);
								 }
								 arg1387_695 =
								    MAKE_PAIR(arg1389_696, arg1390_697);
							      }
							      arg1383_692 =
								 MAKE_PAIR(arg1385_694, arg1387_695);
							   }
							   {	/* Module/class.scm 264 */
							      obj_t arg1391_698;
							      obj_t arg1393_699;
							      {		/* Module/class.scm 264 */
								 obj_t arg1394_700;
								 obj_t arg1395_701;
								 arg1394_700 =
								    CNST_TABLE_REF(((long) 9));
								 arg1395_701 =
								    MAKE_PAIR(class_id_86_620, BNIL);
								 arg1391_698 =
								    MAKE_PAIR(arg1394_700, arg1395_701);
							      }
							      {		/* Module/class.scm 267 */
								 obj_t arg1397_702;
								 {	/* Module/class.scm 267 */
								    obj_t arg1398_703;
								    {	/* Module/class.scm 267 */
								       obj_t arg1399_704;
								       {	/* Module/class.scm 267 */
									  obj_t arg1400_705;
									  {	/* Module/class.scm 267 */
									     obj_t arg1401_706;
									     {	/* Module/class.scm 267 */
										obj_t arg1402_707;
										{	/* Module/class.scm 267 */
										   obj_t arg1404_709;
										   obj_t arg1405_710;
										   arg1404_709 =
										      CNST_TABLE_REF(((long) 10));
										   {	/* Module/class.scm 267 */
										      obj_t arg1406_711;
										      if (
											 NULLP(virtuals_103))
											{	/* Module/class.scm 267 */
											   arg1406_711 = BNIL;
											}
										      else
											{	/* Module/class.scm 267 */
											   obj_t head1223_715;
											   head1223_715 =
											      MAKE_PAIR(BNIL, BNIL);
											   {
											      obj_t l1221_716;
											      obj_t tail1224_717;
											      l1221_716 = virtuals_103;
											      tail1224_717 = head1223_715;
											    lname1222_718:
											      if (
												 NULLP(l1221_716))
												{	/* Module/class.scm 267 */
												   arg1406_711 =
												      CDR(head1223_715);
												}
											      else
												{	/* Module/class.scm 268 */
												   obj_t newtail1225_720;
												   {	/* Module/class.scm 268 */
												      obj_t arg1415_722;
												      {		/* Module/class.scm 268 */
													 obj_t v_724;
													 v_724 =
													    CAR(l1221_716);
													 {	/* Module/class.scm 268 */
													    obj_t arg1417_725;
													    obj_t arg1419_726;
													    arg1417_725 =
													       CNST_TABLE_REF(((long) 11));
													    {	/* Module/class.scm 268 */
													       obj_t arg1420_727;
													       obj_t arg1422_728;
													       arg1420_727 =
														  CAR(v_724);
													       {	/* Module/class.scm 269 */
														  obj_t arg1424_729;
														  {	/* Module/class.scm 269 */
														     obj_t arg1426_731;
														     obj_t arg1427_732;
														     arg1426_731 =
															CNST_TABLE_REF(((long) 11));
														     {	/* Module/class.scm 269 */
															obj_t arg1428_733;
															obj_t arg1430_734;
															{	/* ./Ieee/pair-list.scm 5701 */
															   obj_t aux_2625;
															   aux_2625 =
															      CDR(v_724);
															   arg1428_733 =
															      CAR(aux_2625);
															}
															{	/* ./Ieee/pair-list.scm 5689 */
															   obj_t aux_2628;
															   {	/* ./Ieee/pair-list.scm 5701 */
															      obj_t aux_2629;
															      {		/* ./Ieee/pair-list.scm 5707 */
																 obj_t aux_2630;
																 aux_2630 =
																    CDR(v_724);
																 aux_2629 =
																    CDR(aux_2630);
															      }
															      aux_2628 =
																 CAR(aux_2629);
															   }
															   arg1430_734 =
															      MAKE_PAIR(aux_2628, BNIL);
															}
															arg1427_732 =
															   MAKE_PAIR(arg1428_733, arg1430_734);
														     }
														     arg1424_729 =
															MAKE_PAIR(arg1426_731, arg1427_732);
														  }
														  arg1422_728 =
														     MAKE_PAIR(arg1424_729, BNIL);
													       }
													       arg1419_726 =
														  MAKE_PAIR(arg1420_727, arg1422_728);
													    }
													    arg1415_722 =
													       MAKE_PAIR(arg1417_725, arg1419_726);
													 }
												      }
												      newtail1225_720 =
													 MAKE_PAIR(arg1415_722, BNIL);
												   }
												   SET_CDR(tail1224_717, newtail1225_720);
												   {
												      obj_t tail1224_2644;
												      obj_t l1221_2642;
												      l1221_2642 =
													 CDR(l1221_716);
												      tail1224_2644 = newtail1225_720;
												      tail1224_717 = tail1224_2644;
												      l1221_716 = l1221_2642;
												      goto lname1222_718;
												   }
												}
											   }
											}
										      arg1405_710 =
											 append_2_18___r4_pairs_and_lists_6_3(arg1406_711, BNIL);
										   }
										   arg1402_707 =
										      MAKE_PAIR(arg1404_709, arg1405_710);
										}
										arg1401_706 =
										   MAKE_PAIR(arg1402_707, BNIL);
									     }
									     arg1400_705 =
										MAKE_PAIR(constr_625, arg1401_706);
									  }
									  arg1399_704 =
									     MAKE_PAIR(fields_627, arg1400_705);
								       }
								       arg1398_703 =
									  MAKE_PAIR(hash_624, arg1399_704);
								    }
								    arg1397_702 =
								       MAKE_PAIR(class_alloc_109_623, arg1398_703);
								 }
								 arg1393_699 =
								    MAKE_PAIR(BFALSE, arg1397_702);
							      }
							      arg1384_693 =
								 MAKE_PAIR(arg1391_698, arg1393_699);
							   }
							   arg1380_690 =
							      MAKE_PAIR(arg1383_692, arg1384_693);
							}
							arg1379_689 =
							   MAKE_PAIR(arg1380_690, BNIL);
						     }
						     arg1378_688 =
							MAKE_PAIR(holder_id_229_619, arg1379_689);
						  }
						  decl_628 =
						     MAKE_PAIR(arg1377_687, arg1378_688);
					       }
					  }
					  {	/* Module/class.scm 285 */
					     obj_t obj2_1698;
					     obj2_1698 = _declared_classes__217_module_class;
					     return (
						_declared_classes__217_module_class =
						MAKE_PAIR(decl_628, obj2_1698), BUNSPEC);
					  }
				       }
				    }
				 }
			      }
			   }
			}
		     }
		  }
	       }
	    }
	 }
      }
   }
}



/* get-class-hash */
obj_t 
get_class_hash_100_module_class(obj_t class_id_86_104, obj_t fields_105)
{
   AN_OBJECT;
   {	/* Module/class.scm 290 */
      {
	 obj_t fields_745;
	 long hash_746;
	 {	/* Module/class.scm 292 */
	    long arg1441_748;
	    {	/* Module/class.scm 292 */
	       obj_t arg1442_749;
	       arg1442_749 =
		  SYMBOL_TO_STRING(class_id_86_104);
	       {	/* ./Llib/hash.scm 1789 */
		  char *aux_2660;
		  aux_2660 =
		     BSTRING_TO_STRING(arg1442_749);
		  arg1441_748 =
		     get_hash_power_number(aux_2660, ((long) 16));
	       }
	    }
	    fields_745 = fields_105;
	    hash_746 = arg1441_748;
	  loop_747:
	    if (
	       NULLP(fields_745))
	      {		/* Module/class.scm 293 */
		 return
		    BINT(hash_746);
	      }
	    else
	      {		/* Module/class.scm 295 */
		 obj_t field_752;
		 field_752 =
		    CAR(fields_745);
		 {
		    obj_t id_768;
		    obj_t att_769;
		    obj_t string_763;
		    obj_t len_764;
		    obj_t id_765;
		    obj_t att_766;
		    obj_t integer_758;
		    obj_t len_759;
		    obj_t id_760;
		    obj_t att_761;
		    obj_t id_755;
		    obj_t att_756;
		    if (
		       PAIRP(field_752))
		      {		/* Module/class.scm 296 */
			 bool_t test_2669;
			 {	/* ./Ieee/equiv.scm 5508 */
			    obj_t aux_2670;
			    aux_2670 =
			       CDR(field_752);
			    test_2669 =
			       (aux_2670 == BNIL);
			 }
			 if (test_2669)
			   {	/* Module/class.scm 296 */
			      {
				 long hash_2675;
				 obj_t fields_2673;
				 fields_2673 =
				    CDR(fields_745);
				 hash_2675 =
				    (hash_746 ^ ((long) 2344));
				 hash_746 = hash_2675;
				 fields_745 = fields_2673;
				 goto loop_747;
			      }
			   }
			 else
			   {	/* Module/class.scm 296 */
			      if (
				 SYMBOLP(field_752))
				{	/* Module/class.scm 296 */
				 tag_121_151_754:
				   {	/* Module/class.scm 301 */
				      obj_t arg1483_823;
				      long arg1484_824;
				      arg1483_823 =
					 CDR(fields_745);
				      {		/* Module/class.scm 304 */
					 long arg1485_825;
					 {	/* Module/class.scm 304 */
					    obj_t arg1486_826;
					    arg1486_826 =
					       SYMBOL_TO_STRING(field_752);
					    {	/* ./Llib/hash.scm 1789 */
					       char *aux_2681;
					       aux_2681 =
						  BSTRING_TO_STRING(arg1486_826);
					       arg1485_825 =
						  get_hash_power_number(aux_2681, ((long) 16));
					    }
					 }
					 arg1484_824 =
					    (hash_746 ^ arg1485_825);
				      }
				      {
					 long hash_2686;
					 obj_t fields_2685;
					 fields_2685 = arg1483_823;
					 hash_2686 = arg1484_824;
					 hash_746 = hash_2686;
					 fields_745 = fields_2685;
					 goto loop_747;
				      }
				   }
				}
			      else
				{	/* Module/class.scm 296 */
				   obj_t cdr_147_183_775;
				   cdr_147_183_775 =
				      CDR(field_752);
				   {	/* Module/class.scm 296 */
				      bool_t test_2688;
				      {		/* ./Ieee/equiv.scm 5508 */
					 obj_t aux_2691;
					 obj_t aux_2689;
					 aux_2691 =
					    CNST_TABLE_REF(((long) 12));
					 aux_2689 =
					    CAR(field_752);
					 test_2688 =
					    (aux_2689 == aux_2691);
				      }
				      if (test_2688)
					{	/* Module/class.scm 296 */
					   if (
					      PAIRP(cdr_147_183_775))
					     {	/* Module/class.scm 296 */
						obj_t car_150_99_778;
						car_150_99_778 =
						   CAR(cdr_147_183_775);
						if (
						   SYMBOLP(car_150_99_778))
						  {	/* Module/class.scm 296 */
						     id_755 = car_150_99_778;
						     att_756 =
							CDR(cdr_147_183_775);
						     {	/* Module/class.scm 307 */
							obj_t arg1489_828;
							long arg1490_829;
							arg1489_828 =
							   CDR(fields_745);
							{	/* Module/class.scm 310 */
							   long arg1491_830;
							   {	/* Module/class.scm 310 */
							      obj_t arg1493_831;
							      {		/* Module/class.scm 310 */
								 obj_t arg1496_834;
								 arg1496_834 =
								    SYMBOL_TO_STRING(id_755);
								 arg1493_831 =
								    string_append(string1823_module_class, arg1496_834);
							      }
							      {		/* ./Llib/hash.scm 1789 */
								 char *aux_2702;
								 aux_2702 =
								    BSTRING_TO_STRING(arg1493_831);
								 arg1491_830 =
								    get_hash_power_number(aux_2702, ((long) 16));
							      }
							   }
							   arg1490_829 =
							      (hash_746 ^ arg1491_830);
							}
							{
							   long hash_2707;
							   obj_t fields_2706;
							   fields_2706 = arg1489_828;
							   hash_2707 = arg1490_829;
							   hash_746 = hash_2707;
							   fields_745 = fields_2706;
							   goto loop_747;
							}
						     }
						  }
						else
						  {	/* Module/class.scm 296 */
						     obj_t car_176_242_781;
						     car_176_242_781 =
							CAR(field_752);
						     if (
							SYMBOLP(car_176_242_781))
						       {	/* Module/class.scm 296 */
							  id_768 = car_176_242_781;
							  att_769 = cdr_147_183_775;
							tag_125_98_770:
							  {	/* Module/class.scm 333 */
							     obj_t arg1516_853;
							     long arg1517_854;
							     arg1516_853 =
								CDR(fields_745);
							     {	/* Module/class.scm 336 */
								long arg1519_855;
								{	/* Module/class.scm 336 */
								   obj_t arg1520_856;
								   arg1520_856 =
								      SYMBOL_TO_STRING(id_768);
								   {	/* ./Llib/hash.scm 1789 */
								      char *aux_2714;
								      aux_2714 =
									 BSTRING_TO_STRING(arg1520_856);
								      arg1519_855 =
									 get_hash_power_number(aux_2714, ((long) 16));
								   }
								}
								arg1517_854 =
								   (hash_746 ^ arg1519_855);
							     }
							     {
								long hash_2719;
								obj_t fields_2718;
								fields_2718 = arg1516_853;
								hash_2719 = arg1517_854;
								hash_746 = hash_2719;
								fields_745 = fields_2718;
								goto loop_747;
							     }
							  }
						       }
						     else
						       {	/* Module/class.scm 296 */
							  return BFALSE;
						       }
						  }
					     }
					   else
					     {	/* Module/class.scm 296 */
						obj_t car_202_51_784;
						car_202_51_784 =
						   CAR(field_752);
						if (
						   SYMBOLP(car_202_51_784))
						  {
						     obj_t att_2724;
						     obj_t id_2723;
						     id_2723 = car_202_51_784;
						     att_2724 = cdr_147_183_775;
						     att_769 = att_2724;
						     id_768 = id_2723;
						     goto tag_125_98_770;
						  }
						else
						  {	/* Module/class.scm 296 */
						     return BFALSE;
						  }
					     }
					}
				      else
					{	/* Module/class.scm 296 */
					   bool_t test_2725;
					   {	/* ./Ieee/equiv.scm 5508 */
					      obj_t aux_2728;
					      obj_t aux_2726;
					      aux_2728 =
						 CNST_TABLE_REF(((long) 13));
					      aux_2726 =
						 CAR(field_752);
					      test_2725 =
						 (aux_2726 == aux_2728);
					   }
					   if (test_2725)
					     {	/* Module/class.scm 296 */
						if (
						   PAIRP(cdr_147_183_775))
						  {	/* Module/class.scm 296 */
						     obj_t car_222_9_790;
						     obj_t cdr_223_81_791;
						     car_222_9_790 =
							CAR(cdr_147_183_775);
						     cdr_223_81_791 =
							CDR(cdr_147_183_775);
						     if (
							PAIRP(cdr_223_81_791))
						       {	/* Module/class.scm 296 */
							  obj_t car_233_238_793;
							  car_233_238_793 =
							     CAR(cdr_223_81_791);
							  if (
							     SYMBOLP(car_233_238_793))
							    {	/* Module/class.scm 296 */
							       integer_758 = car_222_9_790;
							       len_759 = car_222_9_790;
							       id_760 = car_233_238_793;
							       att_761 =
								  CDR(cdr_223_81_791);
							       {	/* Module/class.scm 315 */
								  obj_t arg1497_835;
								  long arg1498_836;
								  arg1497_835 =
								     CDR(fields_745);
								  {	/* Module/class.scm 318 */
								     long arg1499_837;
								     {	/* Module/class.scm 318 */
									obj_t arg1500_838;
									{	/* Module/class.scm 318 */
									   obj_t arg1503_841;
									   {	/* Module/class.scm 320 */
									      char *arg1504_842;
									      obj_t arg1505_843;
									      arg1504_842 =
										 integer__string_135___r4_numbers_6_5_fixnum(
										 (long) CINT(len_759), BNIL);
									      arg1505_843 =
										 SYMBOL_TO_STRING(id_760);
									      {		/* Module/class.scm 318 */
										 obj_t aux_2744;
										 aux_2744 =
										    string_to_bstring(arg1504_842);
										 arg1503_841 =
										    string_append(aux_2744, arg1505_843);
									      }
									   }
									   arg1500_838 =
									      string_append(string1824_module_class, arg1503_841);
									}
									{	/* ./Llib/hash.scm 1789 */
									   char *aux_2748;
									   aux_2748 =
									      BSTRING_TO_STRING(arg1500_838);
									   arg1499_837 =
									      get_hash_power_number(aux_2748, ((long) 16));
									}
								     }
								     arg1498_836 =
									(hash_746 ^ arg1499_837);
								  }
								  {
								     long hash_2753;
								     obj_t fields_2752;
								     fields_2752 = arg1497_835;
								     hash_2753 = arg1498_836;
								     hash_746 = hash_2753;
								     fields_745 = fields_2752;
								     goto loop_747;
								  }
							       }
							    }
							  else
							    {	/* Module/class.scm 296 */
							       obj_t car_254_112_797;
							       obj_t cdr_255_181_798;
							       car_254_112_797 =
								  CAR(cdr_147_183_775);
							       cdr_255_181_798 =
								  CDR(cdr_147_183_775);
							       {	/* Module/class.scm 296 */
								  obj_t car_265_225_799;
								  car_265_225_799 =
								     CAR(cdr_255_181_798);
								  if (
								     SYMBOLP(car_265_225_799))
								    {	/* Module/class.scm 296 */
								       string_763 = car_254_112_797;
								       len_764 = car_254_112_797;
								       id_765 = car_265_225_799;
								       att_766 =
									  CDR(cdr_255_181_798);
								       {	/* Module/class.scm 324 */
									  obj_t arg1508_845;
									  long arg1509_846;
									  arg1508_845 =
									     CDR(fields_745);
									  {	/* Module/class.scm 327 */
									     long arg1510_847;
									     {	/* Module/class.scm 327 */
										obj_t arg1511_848;
										{	/* Module/class.scm 327 */
										   obj_t arg1514_851;
										   {	/* Module/class.scm 330 */
										      obj_t arg1515_852;
										      arg1515_852 =
											 SYMBOL_TO_STRING(id_765);
										      arg1514_851 =
											 string_append(len_764, arg1515_852);
										   }
										   arg1511_848 =
										      string_append(string1824_module_class, arg1514_851);
										}
										{	/* ./Llib/hash.scm 1789 */
										   char *aux_2764;
										   aux_2764 =
										      BSTRING_TO_STRING(arg1511_848);
										   arg1510_847 =
										      get_hash_power_number(aux_2764, ((long) 16));
										}
									     }
									     arg1509_846 =
										(hash_746 ^ arg1510_847);
									  }
									  {
									     long hash_2769;
									     obj_t fields_2768;
									     fields_2768 = arg1508_845;
									     hash_2769 = arg1509_846;
									     hash_746 = hash_2769;
									     fields_745 = fields_2768;
									     goto loop_747;
									  }
								       }
								    }
								  else
								    {	/* Module/class.scm 296 */
								       obj_t car_276_9_802;
								       car_276_9_802 =
									  CAR(field_752);
								       if (
									  SYMBOLP(car_276_9_802))
									 {
									    obj_t att_2775;
									    obj_t id_2774;
									    id_2774 = car_276_9_802;
									    att_2775 = cdr_147_183_775;
									    att_769 = att_2775;
									    id_768 = id_2774;
									    goto tag_125_98_770;
									 }
								       else
									 {	/* Module/class.scm 296 */
									    return BFALSE;
									 }
								    }
							       }
							    }
						       }
						     else
						       {	/* Module/class.scm 296 */
							  obj_t car_293_23_805;
							  car_293_23_805 =
							     CAR(field_752);
							  if (
							     SYMBOLP(car_293_23_805))
							    {
							       obj_t att_2780;
							       obj_t id_2779;
							       id_2779 = car_293_23_805;
							       att_2780 = cdr_147_183_775;
							       att_769 = att_2780;
							       id_768 = id_2779;
							       goto tag_125_98_770;
							    }
							  else
							    {	/* Module/class.scm 296 */
							       return BFALSE;
							    }
						       }
						  }
						else
						  {	/* Module/class.scm 296 */
						     obj_t car_310_10_808;
						     car_310_10_808 =
							CAR(field_752);
						     if (
							SYMBOLP(car_310_10_808))
						       {
							  obj_t att_2785;
							  obj_t id_2784;
							  id_2784 = car_310_10_808;
							  att_2785 = cdr_147_183_775;
							  att_769 = att_2785;
							  id_768 = id_2784;
							  goto tag_125_98_770;
						       }
						     else
						       {	/* Module/class.scm 296 */
							  return BFALSE;
						       }
						  }
					     }
					   else
					     {	/* Module/class.scm 296 */
						obj_t car_327_68_811;
						car_327_68_811 =
						   CAR(field_752);
						if (
						   SYMBOLP(car_327_68_811))
						  {
						     obj_t att_2790;
						     obj_t id_2789;
						     id_2789 = car_327_68_811;
						     att_2790 = cdr_147_183_775;
						     att_769 = att_2790;
						     id_768 = id_2789;
						     goto tag_125_98_770;
						  }
						else
						  {	/* Module/class.scm 296 */
						     return BFALSE;
						  }
					     }
					}
				   }
				}
			   }
		      }
		    else
		      {		/* Module/class.scm 296 */
			 if (
			    SYMBOLP(field_752))
			   {	/* Module/class.scm 296 */
			      goto tag_121_151_754;
			   }
			 else
			   {	/* Module/class.scm 296 */
			      return BFALSE;
			   }
		      }
		 }
	      }
	 }
      }
   }
}



/* _get-class-hash1822 */
obj_t 
_get_class_hash1822_166_module_class(obj_t env_2185, obj_t class_id_86_2186, obj_t fields_2187)
{
   AN_OBJECT;
   {	/* Module/class.scm 290 */
      return
	 get_class_hash_100_module_class(class_id_86_2186, fields_2187);
   }
}



/* make-class-fields */
obj_t 
make_class_fields_146_module_class(obj_t class_id_86_106, obj_t slot_defs_73_107, obj_t loc_108)
{
   AN_OBJECT;
   {	/* Module/class.scm 346 */
      {		/* Module/class.scm 419 */
	 obj_t slot_defs_73_861;
	 if (
	    PAIRP(slot_defs_73_107))
	   {	/* Module/class.scm 419 */
	      obj_t car_596_84_887;
	      car_596_84_887 =
		 CAR(slot_defs_73_107);
	      if (
		 PAIRP(car_596_84_887))
		{	/* Module/class.scm 419 */
		   bool_t test_2799;
		   {	/* ./Ieee/equiv.scm 5508 */
		      obj_t aux_2800;
		      aux_2800 =
			 CDR(car_596_84_887);
		      test_2799 =
			 (aux_2800 == BNIL);
		   }
		   if (test_2799)
		     {	/* Module/class.scm 419 */
			slot_defs_73_861 =
			   CDR(slot_defs_73_107);
		     }
		   else
		     {	/* Module/class.scm 419 */
			slot_defs_73_861 = slot_defs_73_107;
		     }
		}
	      else
		{	/* Module/class.scm 419 */
		   slot_defs_73_861 = slot_defs_73_107;
		}
	   }
	 else
	   {	/* Module/class.scm 419 */
	      slot_defs_73_861 = slot_defs_73_107;
	   }
	 if (
	    CBOOL(_reflection___104_engine_param))
	   {	/* Module/class.scm 425 */
	      obj_t arg1522_862;
	      obj_t arg1523_863;
	      arg1522_862 =
		 CNST_TABLE_REF(((long) 14));
	      {		/* Module/class.scm 425 */
		 obj_t arg1525_864;
		 if (
		    NULLP(slot_defs_73_861))
		   {	/* Module/class.scm 425 */
		      arg1525_864 = BNIL;
		   }
		 else
		   {	/* Module/class.scm 425 */
		      obj_t head1233_868;
		      {		/* Module/class.scm 425 */
			 obj_t arg1535_879;
			 arg1535_879 =
			    make_slot_field_56_module_class(class_id_86_106, loc_108,
			    CAR(slot_defs_73_861));
			 head1233_868 =
			    MAKE_PAIR(arg1535_879, BNIL);
		      }
		      {
			 obj_t l1231_869;
			 obj_t tail1234_870;
			 l1231_869 =
			    CDR(slot_defs_73_861);
			 tail1234_870 = head1233_868;
		       lname1232_871:
			 if (
			    NULLP(l1231_869))
			   {	/* Module/class.scm 425 */
			      arg1525_864 = head1233_868;
			   }
			 else
			   {	/* Module/class.scm 425 */
			      obj_t newtail1235_874;
			      {		/* Module/class.scm 425 */
				 obj_t arg1532_876;
				 arg1532_876 =
				    make_slot_field_56_module_class(class_id_86_106, loc_108,
				    CAR(l1231_869));
				 newtail1235_874 =
				    MAKE_PAIR(arg1532_876, BNIL);
			      }
			      SET_CDR(tail1234_870, newtail1235_874);
			      {
				 obj_t tail1234_2820;
				 obj_t l1231_2818;
				 l1231_2818 =
				    CDR(l1231_869);
				 tail1234_2820 = newtail1235_874;
				 tail1234_870 = tail1234_2820;
				 l1231_869 = l1231_2818;
				 goto lname1232_871;
			      }
			   }
		      }
		   }
		 arg1523_863 =
		    append_2_18___r4_pairs_and_lists_6_3(arg1525_864, BNIL);
	      }
	      return
		 MAKE_PAIR(arg1522_862, arg1523_863);
	   }
	 else
	   {	/* Module/class.scm 424 */
	      return BUNSPEC;
	   }
      }
   }
}



/* read-only? */
bool_t 
read_only__11_module_class(obj_t attr_1124)
{
   AN_OBJECT;
   {	/* Module/class.scm 347 */
      {
	 obj_t attr_1126;
	 attr_1126 = attr_1124;
       loop_1127:
	 if (
	    NULLP(attr_1126))
	   {	/* Module/class.scm 350 */
	      return ((bool_t) 0);
	   }
	 else
	   {	/* Module/class.scm 352 */
	      bool_t test_2826;
	      {		/* ./Ieee/equiv.scm 5508 */
		 obj_t aux_2829;
		 obj_t aux_2827;
		 aux_2829 =
		    CNST_TABLE_REF(((long) 15));
		 aux_2827 =
		    CAR(attr_1126);
		 test_2826 =
		    (aux_2827 == aux_2829);
	      }
	      if (test_2826)
		{	/* Module/class.scm 352 */
		   return ((bool_t) 1);
		}
	      else
		{	/* Module/class.scm 352 */
		   {
		      obj_t attr_2832;
		      attr_2832 =
			 CDR(attr_1126);
		      attr_1126 = attr_2832;
		      goto loop_1127;
		   }
		}
	   }
      }
   }
}



/* make-slot-field */
obj_t 
make_slot_field_56_module_class(obj_t class_id_86_2190, obj_t loc_2189, obj_t slot_893)
{
   AN_OBJECT;
   {	/* Module/class.scm 365 */
      {
	 obj_t attr_1113;
	 {
	    obj_t id_896;
	    obj_t att_897;
	    obj_t integer_899;
	    obj_t len_900;
	    obj_t id_901;
	    obj_t att_902;
	    obj_t string_904;
	    obj_t len_905;
	    obj_t id_906;
	    obj_t att_907;
	    obj_t id_909;
	    obj_t att_910;
	    if (
	       SYMBOLP(slot_893))
	      {		/* Module/class.scm 365 */
		 {	/* Module/class.scm 368 */
		    obj_t id_959;
		    id_959 =
		       fast_id_of_id_130_ast_ident(slot_893, loc_2189);
		    {	/* Module/class.scm 369 */
		       obj_t arg1578_960;
		       obj_t arg1579_961;
		       {	/* Module/class.scm 369 */
			  obj_t arg1580_962;
			  obj_t arg1581_963;
			  arg1580_962 =
			     CNST_TABLE_REF(((long) 5));
			  {	/* Module/class.scm 369 */
			     obj_t arg1582_964;
			     obj_t arg1583_965;
			     arg1582_964 =
				CNST_TABLE_REF(((long) 17));
			     {	/* ./Ieee/pair-list.scm 5689 */
				obj_t aux_2839;
				aux_2839 =
				   CNST_TABLE_REF(((long) 8));
				arg1583_965 =
				   MAKE_PAIR(aux_2839, BNIL);
			     }
			     arg1581_963 =
				MAKE_PAIR(arg1582_964, arg1583_965);
			  }
			  arg1578_960 =
			     MAKE_PAIR(arg1580_962, arg1581_963);
		       }
		       {	/* Module/class.scm 370 */
			  obj_t arg1584_966;
			  obj_t arg1585_967;
			  {	/* Module/class.scm 370 */
			     obj_t arg1586_968;
			     obj_t arg1587_969;
			     arg1586_968 =
				CNST_TABLE_REF(((long) 9));
			     arg1587_969 =
				MAKE_PAIR(slot_893, BNIL);
			     arg1584_966 =
				MAKE_PAIR(arg1586_968, arg1587_969);
			  }
			  {	/* Module/class.scm 371 */
			     obj_t arg1588_970;
			     obj_t arg1589_971;
			     {	/* Module/class.scm 371 */
				obj_t list1590_972;
				{	/* Module/class.scm 371 */
				   obj_t arg1591_973;
				   {	/* Module/class.scm 371 */
				      obj_t arg1592_974;
				      obj_t arg1593_975;
				      arg1592_974 =
					 CNST_TABLE_REF(((long) 18));
				      arg1593_975 =
					 MAKE_PAIR(id_959, BNIL);
				      arg1591_973 =
					 MAKE_PAIR(arg1592_974, arg1593_975);
				   }
				   list1590_972 =
				      MAKE_PAIR(class_id_86_2190, arg1591_973);
				}
				arg1588_970 =
				   symbol_append_197___r4_symbols_6_4(list1590_972);
			     }
			     {	/* Module/class.scm 372 */
				obj_t arg1594_976;
				obj_t arg1595_977;
				{	/* Module/class.scm 372 */
				   obj_t list1596_978;
				   {	/* Module/class.scm 372 */
				      obj_t arg1597_979;
				      {		/* Module/class.scm 372 */
					 obj_t arg1598_980;
					 obj_t arg1599_981;
					 arg1598_980 =
					    CNST_TABLE_REF(((long) 18));
					 {	/* Module/class.scm 372 */
					    obj_t arg1600_982;
					    {	/* Module/class.scm 372 */
					       obj_t aux_2853;
					       aux_2853 =
						  CNST_TABLE_REF(((long) 19));
					       arg1600_982 =
						  MAKE_PAIR(aux_2853, BNIL);
					    }
					    arg1599_981 =
					       MAKE_PAIR(id_959, arg1600_982);
					 }
					 arg1597_979 =
					    MAKE_PAIR(arg1598_980, arg1599_981);
				      }
				      list1596_978 =
					 MAKE_PAIR(class_id_86_2190, arg1597_979);
				   }
				   arg1594_976 =
				      symbol_append_197___r4_symbols_6_4(list1596_978);
				}
				{	/* Module/class.scm 369 */
				   obj_t arg1601_983;
				   arg1601_983 =
				      MAKE_PAIR(BFALSE, BNIL);
				   arg1595_977 =
				      MAKE_PAIR(BUNSPEC, arg1601_983);
				}
				arg1589_971 =
				   MAKE_PAIR(arg1594_976, arg1595_977);
			     }
			     arg1585_967 =
				MAKE_PAIR(arg1588_970, arg1589_971);
			  }
			  arg1579_961 =
			     MAKE_PAIR(arg1584_966, arg1585_967);
		       }
		       return
			  MAKE_PAIR(arg1578_960, arg1579_961);
		    }
		 }
	      }
	    else
	      {		/* Module/class.scm 365 */
		 if (
		    PAIRP(slot_893))
		   {	/* Module/class.scm 365 */
		      obj_t cdr_385_232_916;
		      cdr_385_232_916 =
			 CDR(slot_893);
		      {		/* Module/class.scm 365 */
			 bool_t test_2869;
			 {	/* ./Ieee/equiv.scm 5508 */
			    obj_t aux_2872;
			    obj_t aux_2870;
			    aux_2872 =
			       CNST_TABLE_REF(((long) 12));
			    aux_2870 =
			       CAR(slot_893);
			    test_2869 =
			       (aux_2870 == aux_2872);
			 }
			 if (test_2869)
			   {	/* Module/class.scm 365 */
			      if (
				 PAIRP(cdr_385_232_916))
				{	/* Module/class.scm 365 */
				   obj_t car_388_248_919;
				   car_388_248_919 =
				      CAR(cdr_385_232_916);
				   if (
				      SYMBOLP(car_388_248_919))
				     {	/* Module/class.scm 365 */
					id_896 = car_388_248_919;
					att_897 =
					   CDR(cdr_385_232_916);
					{	/* Module/class.scm 376 */
					   obj_t id_984;
					   id_984 =
					      fast_id_of_id_130_ast_ident(id_896, loc_2189);
					   {	/* Module/class.scm 377 */
					      obj_t arg1602_985;
					      obj_t arg1603_986;
					      {		/* Module/class.scm 377 */
						 obj_t arg1604_987;
						 obj_t arg1605_988;
						 arg1604_987 =
						    CNST_TABLE_REF(((long) 5));
						 {	/* Module/class.scm 377 */
						    obj_t arg1606_989;
						    obj_t arg1607_990;
						    arg1606_989 =
						       CNST_TABLE_REF(((long) 17));
						    {	/* ./Ieee/pair-list.scm 5689 */
						       obj_t aux_2883;
						       aux_2883 =
							  CNST_TABLE_REF(((long) 8));
						       arg1607_990 =
							  MAKE_PAIR(aux_2883, BNIL);
						    }
						    arg1605_988 =
						       MAKE_PAIR(arg1606_989, arg1607_990);
						 }
						 arg1602_985 =
						    MAKE_PAIR(arg1604_987, arg1605_988);
					      }
					      {		/* Module/class.scm 378 */
						 obj_t arg1608_991;
						 obj_t arg1609_992;
						 {	/* Module/class.scm 378 */
						    obj_t arg1610_993;
						    obj_t arg1611_994;
						    arg1610_993 =
						       CNST_TABLE_REF(((long) 9));
						    arg1611_994 =
						       MAKE_PAIR(id_984, BNIL);
						    arg1608_991 =
						       MAKE_PAIR(arg1610_993, arg1611_994);
						 }
						 {	/* Module/class.scm 379 */
						    obj_t arg1612_995;
						    obj_t arg1613_996;
						    {	/* Module/class.scm 379 */
						       obj_t list1614_997;
						       {	/* Module/class.scm 379 */
							  obj_t arg1615_998;
							  {	/* Module/class.scm 379 */
							     obj_t arg1616_999;
							     obj_t arg1617_1000;
							     arg1616_999 =
								CNST_TABLE_REF(((long) 18));
							     {	/* Module/class.scm 379 */
								obj_t arg1618_1001;
								{	/* Module/class.scm 379 */
								   obj_t aux_2892;
								   aux_2892 =
								      CNST_TABLE_REF(((long) 20));
								   arg1618_1001 =
								      MAKE_PAIR(aux_2892, BNIL);
								}
								arg1617_1000 =
								   MAKE_PAIR(id_984, arg1618_1001);
							     }
							     arg1615_998 =
								MAKE_PAIR(arg1616_999, arg1617_1000);
							  }
							  list1614_997 =
							     MAKE_PAIR(class_id_86_2190, arg1615_998);
						       }
						       arg1612_995 =
							  symbol_append_197___r4_symbols_6_4(list1614_997);
						    }
						    {	/* Module/class.scm 380 */
						       obj_t arg1619_1002;
						       obj_t arg1620_1003;
						       if (
							  read_only__11_module_class(att_897))
							 {	/* Module/class.scm 380 */
							    arg1619_1002 = BUNSPEC;
							 }
						       else
							 {	/* Module/class.scm 381 */
							    obj_t list1622_1005;
							    {	/* Module/class.scm 381 */
							       obj_t arg1623_1006;
							       {	/* Module/class.scm 381 */
								  obj_t arg1624_1007;
								  obj_t arg1625_1008;
								  arg1624_1007 =
								     CNST_TABLE_REF(((long) 18));
								  {	/* Module/class.scm 381 */
								     obj_t arg1626_1009;
								     {	/* Module/class.scm 381 */
									obj_t aux_2902;
									aux_2902 =
									   CNST_TABLE_REF(((long) 19));
									arg1626_1009 =
									   MAKE_PAIR(aux_2902, BNIL);
								     }
								     arg1625_1008 =
									MAKE_PAIR(id_984, arg1626_1009);
								  }
								  arg1623_1006 =
								     MAKE_PAIR(arg1624_1007, arg1625_1008);
							       }
							       list1622_1005 =
								  MAKE_PAIR(class_id_86_2190, arg1623_1006);
							    }
							    arg1619_1002 =
							       symbol_append_197___r4_symbols_6_4(list1622_1005);
							 }
						       {	/* Module/class.scm 383 */
							  obj_t arg1627_1010;
							  obj_t arg1628_1011;
							  {	/* Module/class.scm 383 */
							     obj_t list1629_1012;
							     {	/* Module/class.scm 383 */
								obj_t arg1630_1013;
								{	/* Module/class.scm 383 */
								   obj_t arg1631_1014;
								   obj_t arg1632_1015;
								   arg1631_1014 =
								      CNST_TABLE_REF(((long) 18));
								   {	/* Module/class.scm 383 */
								      obj_t arg1633_1016;
								      {		/* Module/class.scm 383 */
									 obj_t aux_2910;
									 aux_2910 =
									    CNST_TABLE_REF(((long) 24));
									 arg1633_1016 =
									    MAKE_PAIR(aux_2910, BNIL);
								      }
								      arg1632_1015 =
									 MAKE_PAIR(id_984, arg1633_1016);
								   }
								   arg1630_1013 =
								      MAKE_PAIR(arg1631_1014, arg1632_1015);
								}
								list1629_1012 =
								   MAKE_PAIR(class_id_86_2190, arg1630_1013);
							     }
							     arg1627_1010 =
								symbol_append_197___r4_symbols_6_4(list1629_1012);
							  }
							  arg1628_1011 =
							     MAKE_PAIR(BFALSE, BNIL);
							  arg1620_1003 =
							     MAKE_PAIR(arg1627_1010, arg1628_1011);
						       }
						       arg1613_996 =
							  MAKE_PAIR(arg1619_1002, arg1620_1003);
						    }
						    arg1609_992 =
						       MAKE_PAIR(arg1612_995, arg1613_996);
						 }
						 arg1603_986 =
						    MAKE_PAIR(arg1608_991, arg1609_992);
					      }
					      return
						 MAKE_PAIR(arg1602_985, arg1603_986);
					   }
					}
				     }
				   else
				     {	/* Module/class.scm 365 */
					obj_t car_414_158_922;
					car_414_158_922 =
					   CAR(slot_893);
					if (
					   SYMBOLP(car_414_158_922))
					  {	/* Module/class.scm 365 */
					     id_909 = car_414_158_922;
					     att_910 = cdr_385_232_916;
					   tag_369_107_911:
					     {	/* Module/class.scm 406 */
						obj_t id_1085;
						id_1085 =
						   fast_id_of_id_130_ast_ident(id_909, loc_2189);
						{	/* Module/class.scm 407 */
						   obj_t arg1702_1086;
						   obj_t arg1703_1087;
						   {	/* Module/class.scm 407 */
						      obj_t arg1704_1088;
						      obj_t arg1705_1089;
						      arg1704_1088 =
							 CNST_TABLE_REF(((long) 5));
						      {		/* Module/class.scm 407 */
							 obj_t arg1706_1090;
							 obj_t arg1707_1091;
							 arg1706_1090 =
							    CNST_TABLE_REF(((long) 17));
							 {	/* ./Ieee/pair-list.scm 5689 */
							    obj_t aux_2930;
							    aux_2930 =
							       CNST_TABLE_REF(((long) 8));
							    arg1707_1091 =
							       MAKE_PAIR(aux_2930, BNIL);
							 }
							 arg1705_1089 =
							    MAKE_PAIR(arg1706_1090, arg1707_1091);
						      }
						      arg1702_1086 =
							 MAKE_PAIR(arg1704_1088, arg1705_1089);
						   }
						   {	/* Module/class.scm 408 */
						      obj_t arg1708_1092;
						      obj_t arg1709_1093;
						      {		/* Module/class.scm 408 */
							 obj_t arg1711_1094;
							 obj_t arg1712_1095;
							 arg1711_1094 =
							    CNST_TABLE_REF(((long) 9));
							 arg1712_1095 =
							    MAKE_PAIR(id_1085, BNIL);
							 arg1708_1092 =
							    MAKE_PAIR(arg1711_1094, arg1712_1095);
						      }
						      {		/* Module/class.scm 409 */
							 obj_t arg1713_1096;
							 obj_t arg1714_1097;
							 {	/* Module/class.scm 409 */
							    obj_t list1715_1098;
							    {	/* Module/class.scm 409 */
							       obj_t arg1716_1099;
							       {	/* Module/class.scm 409 */
								  obj_t arg1717_1100;
								  obj_t arg1718_1101;
								  arg1717_1100 =
								     CNST_TABLE_REF(((long) 18));
								  arg1718_1101 =
								     MAKE_PAIR(id_1085, BNIL);
								  arg1716_1099 =
								     MAKE_PAIR(arg1717_1100, arg1718_1101);
							       }
							       list1715_1098 =
								  MAKE_PAIR(class_id_86_2190, arg1716_1099);
							    }
							    arg1713_1096 =
							       symbol_append_197___r4_symbols_6_4(list1715_1098);
							 }
							 {	/* Module/class.scm 410 */
							    obj_t arg1719_1102;
							    obj_t arg1720_1103;
							    if (
							       read_only__11_module_class(att_910))
							      {		/* Module/class.scm 410 */
								 arg1719_1102 = BUNSPEC;
							      }
							    else
							      {		/* Module/class.scm 411 */
								 obj_t list1722_1105;
								 {	/* Module/class.scm 411 */
								    obj_t arg1723_1106;
								    {	/* Module/class.scm 411 */
								       obj_t arg1724_1107;
								       obj_t arg1725_1108;
								       arg1724_1107 =
									  CNST_TABLE_REF(((long) 18));
								       {	/* Module/class.scm 411 */
									  obj_t arg1726_1109;
									  {	/* Module/class.scm 411 */
									     obj_t aux_2946;
									     aux_2946 =
										CNST_TABLE_REF(((long) 19));
									     arg1726_1109 =
										MAKE_PAIR(aux_2946, BNIL);
									  }
									  arg1725_1108 =
									     MAKE_PAIR(id_1085, arg1726_1109);
								       }
								       arg1723_1106 =
									  MAKE_PAIR(arg1724_1107, arg1725_1108);
								    }
								    list1722_1105 =
								       MAKE_PAIR(class_id_86_2190, arg1723_1106);
								 }
								 arg1719_1102 =
								    symbol_append_197___r4_symbols_6_4(list1722_1105);
							      }
							    {	/* Module/class.scm 414 */
							       obj_t arg1727_1110;
							       {	/* ./Ieee/pair-list.scm 5689 */
								  obj_t aux_2953;
								  {	/* Module/class.scm 407 */
								     bool_t aux_2954;
								     attr_1113 = att_910;
								     {
									obj_t attr_1115;
									attr_1115 = attr_1113;
								      loop_1116:
									if (
									   NULLP(attr_1115))
									  {	/* Module/class.scm 359 */
									     aux_2954 = ((bool_t) 0);
									  }
									else
									  {	/* Module/class.scm 361 */
									     bool_t test_2957;
									     {	/* Module/class.scm 361 */
										bool_t test_2958;
										{	/* ./Ieee/pair-list.scm 5669 */
										   obj_t aux_2959;
										   aux_2959 =
										      CAR(attr_1115);
										   test_2958 =
										      PAIRP(aux_2959);
										}
										if (test_2958)
										  {	/* ./Ieee/equiv.scm 5508 */
										     obj_t aux_2966;
										     obj_t aux_2962;
										     aux_2966 =
											CNST_TABLE_REF(((long) 16));
										     {	/* ./Ieee/pair-list.scm 5701 */
											obj_t aux_2963;
											aux_2963 =
											   CAR(attr_1115);
											aux_2962 =
											   CAR(aux_2963);
										     }
										     test_2957 =
											(aux_2962 == aux_2966);
										  }
										else
										  {	/* Module/class.scm 361 */
										     test_2957 = ((bool_t) 0)
											;
										  }
									     }
									     if (test_2957)
									       {	/* Module/class.scm 361 */
										  aux_2954 = ((bool_t) 1);
									       }
									     else
									       {	/* Module/class.scm 361 */
										  {
										     obj_t attr_2969;
										     attr_2969 =
											CDR(attr_1115);
										     attr_1115 = attr_2969;
										     goto loop_1116;
										  }
									       }
									  }
								     }
								     aux_2953 =
									BBOOL(aux_2954);
								  }
								  arg1727_1110 =
								     MAKE_PAIR(aux_2953, BNIL);
							       }
							       arg1720_1103 =
								  MAKE_PAIR(BUNSPEC, arg1727_1110);
							    }
							    arg1714_1097 =
							       MAKE_PAIR(arg1719_1102, arg1720_1103);
							 }
							 arg1709_1093 =
							    MAKE_PAIR(arg1713_1096, arg1714_1097);
						      }
						      arg1703_1087 =
							 MAKE_PAIR(arg1708_1092, arg1709_1093);
						   }
						   return
						      MAKE_PAIR(arg1702_1086, arg1703_1087);
						}
					     }
					  }
					else
					  {	/* Module/class.scm 365 */
					   tag_370_207_912:
					     return
						internal_error_43_tools_error(string1825_module_class, string1826_module_class, slot_893);
					  }
				     }
				}
			      else
				{	/* Module/class.scm 365 */
				   obj_t car_440_37_925;
				   car_440_37_925 =
				      CAR(slot_893);
				   if (
				      SYMBOLP(car_440_37_925))
				     {
					obj_t att_2983;
					obj_t id_2982;
					id_2982 = car_440_37_925;
					att_2983 = cdr_385_232_916;
					att_910 = att_2983;
					id_909 = id_2982;
					goto tag_369_107_911;
				     }
				   else
				     {	/* Module/class.scm 365 */
					goto tag_370_207_912;
				     }
				}
			   }
			 else
			   {	/* Module/class.scm 365 */
			      bool_t test_2984;
			      {		/* ./Ieee/equiv.scm 5508 */
				 obj_t aux_2987;
				 obj_t aux_2985;
				 aux_2987 =
				    CNST_TABLE_REF(((long) 13));
				 aux_2985 =
				    CAR(slot_893);
				 test_2984 =
				    (aux_2985 == aux_2987);
			      }
			      if (test_2984)
				{	/* Module/class.scm 365 */
				   if (
				      PAIRP(cdr_385_232_916))
				     {	/* Module/class.scm 365 */
					obj_t car_460_249_931;
					obj_t cdr_461_169_932;
					car_460_249_931 =
					   CAR(cdr_385_232_916);
					cdr_461_169_932 =
					   CDR(cdr_385_232_916);
					if (
					   PAIRP(cdr_461_169_932))
					  {	/* Module/class.scm 365 */
					     obj_t car_471_231_934;
					     car_471_231_934 =
						CAR(cdr_461_169_932);
					     if (
						SYMBOLP(car_471_231_934))
					       {	/* Module/class.scm 365 */
						  integer_899 = car_460_249_931;
						  len_900 = car_460_249_931;
						  id_901 = car_471_231_934;
						  att_902 =
						     CDR(cdr_461_169_932);
						  {	/* Module/class.scm 386 */
						     obj_t id_1017;
						     id_1017 =
							fast_id_of_id_130_ast_ident(id_901, loc_2189);
						     {	/* Module/class.scm 387 */
							obj_t arg1634_1018;
							obj_t arg1635_1019;
							{	/* Module/class.scm 387 */
							   obj_t arg1636_1020;
							   obj_t arg1637_1021;
							   arg1636_1020 =
							      CNST_TABLE_REF(((long) 5));
							   {	/* Module/class.scm 387 */
							      obj_t arg1638_1022;
							      obj_t arg1639_1023;
							      arg1638_1022 =
								 CNST_TABLE_REF(((long) 17));
							      {		/* ./Ieee/pair-list.scm 5689 */
								 obj_t aux_3002;
								 aux_3002 =
								    CNST_TABLE_REF(((long) 8));
								 arg1639_1023 =
								    MAKE_PAIR(aux_3002, BNIL);
							      }
							      arg1637_1021 =
								 MAKE_PAIR(arg1638_1022, arg1639_1023);
							   }
							   arg1634_1018 =
							      MAKE_PAIR(arg1636_1020, arg1637_1021);
							}
							{	/* Module/class.scm 388 */
							   obj_t arg1640_1024;
							   obj_t arg1641_1025;
							   {	/* Module/class.scm 388 */
							      obj_t arg1642_1026;
							      obj_t arg1643_1027;
							      arg1642_1026 =
								 CNST_TABLE_REF(((long) 9));
							      arg1643_1027 =
								 MAKE_PAIR(id_1017, BNIL);
							      arg1640_1024 =
								 MAKE_PAIR(arg1642_1026, arg1643_1027);
							   }
							   {	/* Module/class.scm 389 */
							      obj_t arg1644_1028;
							      obj_t arg1646_1029;
							      {		/* Module/class.scm 389 */
								 obj_t list1647_1030;
								 {	/* Module/class.scm 389 */
								    obj_t arg1648_1031;
								    {	/* Module/class.scm 389 */
								       obj_t arg1649_1032;
								       obj_t arg1650_1033;
								       arg1649_1032 =
									  CNST_TABLE_REF(((long) 18));
								       {	/* Module/class.scm 389 */
									  obj_t arg1651_1034;
									  {	/* Module/class.scm 389 */
									     obj_t aux_3011;
									     aux_3011 =
										CNST_TABLE_REF(((long) 20));
									     arg1651_1034 =
										MAKE_PAIR(aux_3011, BNIL);
									  }
									  arg1650_1033 =
									     MAKE_PAIR(id_1017, arg1651_1034);
								       }
								       arg1648_1031 =
									  MAKE_PAIR(arg1649_1032, arg1650_1033);
								    }
								    list1647_1030 =
								       MAKE_PAIR(class_id_86_2190, arg1648_1031);
								 }
								 arg1644_1028 =
								    symbol_append_197___r4_symbols_6_4(list1647_1030);
							      }
							      {		/* Module/class.scm 390 */
								 obj_t arg1652_1035;
								 obj_t arg1653_1036;
								 if (
								    read_only__11_module_class(att_902))
								   {	/* Module/class.scm 390 */
								      arg1652_1035 = BUNSPEC;
								   }
								 else
								   {	/* Module/class.scm 391 */
								      obj_t list1655_1038;
								      {		/* Module/class.scm 391 */
									 obj_t arg1656_1039;
									 {	/* Module/class.scm 391 */
									    obj_t arg1657_1040;
									    obj_t arg1658_1041;
									    arg1657_1040 =
									       CNST_TABLE_REF(((long) 18));
									    {	/* Module/class.scm 391 */
									       obj_t arg1659_1042;
									       {	/* Module/class.scm 391 */
										  obj_t aux_3021;
										  aux_3021 =
										     CNST_TABLE_REF(((long) 19));
										  arg1659_1042 =
										     MAKE_PAIR(aux_3021, BNIL);
									       }
									       arg1658_1041 =
										  MAKE_PAIR(id_1017, arg1659_1042);
									    }
									    arg1656_1039 =
									       MAKE_PAIR(arg1657_1040, arg1658_1041);
									 }
									 list1655_1038 =
									    MAKE_PAIR(class_id_86_2190, arg1656_1039);
								      }
								      arg1652_1035 =
									 symbol_append_197___r4_symbols_6_4(list1655_1038);
								   }
								 {	/* Module/class.scm 393 */
								    obj_t arg1660_1043;
								    obj_t arg1661_1044;
								    {	/* Module/class.scm 393 */
								       obj_t arg1662_1045;
								       obj_t arg1663_1046;
								       arg1662_1045 =
									  CNST_TABLE_REF(((long) 21));
								       {	/* Module/class.scm 393 */
									  obj_t arg1664_1047;
									  obj_t arg1665_1048;
									  {	/* ./Ieee/pair-list.scm 5689 */
									     obj_t aux_3029;
									     aux_3029 =
										CNST_TABLE_REF(((long) 22));
									     arg1664_1047 =
										MAKE_PAIR(aux_3029, BNIL);
									  }
									  arg1665_1048 =
									     MAKE_PAIR(len_900, BNIL);
									  arg1663_1046 =
									     MAKE_PAIR(arg1664_1047, arg1665_1048);
								       }
								       arg1660_1043 =
									  MAKE_PAIR(arg1662_1045, arg1663_1046);
								    }
								    arg1661_1044 =
								       MAKE_PAIR(BFALSE, BNIL);
								    arg1653_1036 =
								       MAKE_PAIR(arg1660_1043, arg1661_1044);
								 }
								 arg1646_1029 =
								    MAKE_PAIR(arg1652_1035, arg1653_1036);
							      }
							      arg1641_1025 =
								 MAKE_PAIR(arg1644_1028, arg1646_1029);
							   }
							   arg1635_1019 =
							      MAKE_PAIR(arg1640_1024, arg1641_1025);
							}
							return
							   MAKE_PAIR(arg1634_1018, arg1635_1019);
						     }
						  }
					       }
					     else
					       {	/* Module/class.scm 365 */
						  obj_t car_492_30_938;
						  obj_t cdr_493_219_939;
						  car_492_30_938 =
						     CAR(cdr_385_232_916);
						  cdr_493_219_939 =
						     CDR(cdr_385_232_916);
						  {	/* Module/class.scm 365 */
						     obj_t car_503_8_940;
						     car_503_8_940 =
							CAR(cdr_493_219_939);
						     if (
							SYMBOLP(car_503_8_940))
						       {	/* Module/class.scm 365 */
							  string_904 = car_492_30_938;
							  len_905 = car_492_30_938;
							  id_906 = car_503_8_940;
							  att_907 =
							     CDR(cdr_493_219_939);
							  {	/* Module/class.scm 396 */
							     obj_t id_1049;
							     id_1049 =
								fast_id_of_id_130_ast_ident(id_906, loc_2189);
							     {	/* Module/class.scm 397 */
								obj_t arg1666_1050;
								obj_t arg1667_1051;
								{	/* Module/class.scm 397 */
								   obj_t arg1669_1052;
								   obj_t arg1670_1053;
								   arg1669_1052 =
								      CNST_TABLE_REF(((long) 5));
								   {	/* Module/class.scm 397 */
								      obj_t arg1671_1054;
								      obj_t arg1672_1055;
								      arg1671_1054 =
									 CNST_TABLE_REF(((long) 17));
								      {		/* ./Ieee/pair-list.scm 5689 */
									 obj_t aux_3050;
									 aux_3050 =
									    CNST_TABLE_REF(((long) 8));
									 arg1672_1055 =
									    MAKE_PAIR(aux_3050, BNIL);
								      }
								      arg1670_1053 =
									 MAKE_PAIR(arg1671_1054, arg1672_1055);
								   }
								   arg1666_1050 =
								      MAKE_PAIR(arg1669_1052, arg1670_1053);
								}
								{	/* Module/class.scm 398 */
								   obj_t arg1673_1056;
								   obj_t arg1674_1057;
								   {	/* Module/class.scm 398 */
								      obj_t arg1675_1058;
								      obj_t arg1676_1059;
								      arg1675_1058 =
									 CNST_TABLE_REF(((long) 9));
								      arg1676_1059 =
									 MAKE_PAIR(id_1049, BNIL);
								      arg1673_1056 =
									 MAKE_PAIR(arg1675_1058, arg1676_1059);
								   }
								   {	/* Module/class.scm 399 */
								      obj_t arg1677_1060;
								      obj_t arg1678_1061;
								      {		/* Module/class.scm 399 */
									 obj_t list1679_1062;
									 {	/* Module/class.scm 399 */
									    obj_t arg1680_1063;
									    {	/* Module/class.scm 399 */
									       obj_t arg1681_1064;
									       obj_t arg1682_1065;
									       arg1681_1064 =
										  CNST_TABLE_REF(((long) 18));
									       {	/* Module/class.scm 399 */
										  obj_t arg1683_1066;
										  {	/* Module/class.scm 399 */
										     obj_t aux_3059;
										     aux_3059 =
											CNST_TABLE_REF(((long) 20));
										     arg1683_1066 =
											MAKE_PAIR(aux_3059, BNIL);
										  }
										  arg1682_1065 =
										     MAKE_PAIR(id_1049, arg1683_1066);
									       }
									       arg1680_1063 =
										  MAKE_PAIR(arg1681_1064, arg1682_1065);
									    }
									    list1679_1062 =
									       MAKE_PAIR(class_id_86_2190, arg1680_1063);
									 }
									 arg1677_1060 =
									    symbol_append_197___r4_symbols_6_4(list1679_1062);
								      }
								      {		/* Module/class.scm 400 */
									 obj_t arg1684_1067;
									 obj_t arg1685_1068;
									 if (
									    read_only__11_module_class(att_907))
									   {	/* Module/class.scm 400 */
									      arg1684_1067 = BUNSPEC;
									   }
									 else
									   {	/* Module/class.scm 401 */
									      obj_t list1687_1070;
									      {		/* Module/class.scm 401 */
										 obj_t arg1688_1071;
										 {	/* Module/class.scm 401 */
										    obj_t arg1689_1072;
										    obj_t arg1690_1073;
										    arg1689_1072 =
										       CNST_TABLE_REF(((long) 18));
										    {	/* Module/class.scm 401 */
										       obj_t arg1691_1074;
										       {	/* Module/class.scm 401 */
											  obj_t aux_3069;
											  aux_3069 =
											     CNST_TABLE_REF(((long) 19));
											  arg1691_1074 =
											     MAKE_PAIR(aux_3069, BNIL);
										       }
										       arg1690_1073 =
											  MAKE_PAIR(id_1049, arg1691_1074);
										    }
										    arg1688_1071 =
										       MAKE_PAIR(arg1689_1072, arg1690_1073);
										 }
										 list1687_1070 =
										    MAKE_PAIR(class_id_86_2190, arg1688_1071);
									      }
									      arg1684_1067 =
										 symbol_append_197___r4_symbols_6_4(list1687_1070);
									   }
									 {	/* Module/class.scm 403 */
									    obj_t arg1692_1075;
									    obj_t arg1693_1076;
									    {	/* Module/class.scm 403 */
									       obj_t arg1694_1077;
									       obj_t arg1695_1078;
									       arg1694_1077 =
										  CNST_TABLE_REF(((long) 21));
									       {	/* Module/class.scm 403 */
										  obj_t arg1696_1079;
										  obj_t arg1697_1080;
										  {	/* ./Ieee/pair-list.scm 5689 */
										     obj_t aux_3077;
										     aux_3077 =
											CNST_TABLE_REF(((long) 22));
										     arg1696_1079 =
											MAKE_PAIR(aux_3077, BNIL);
										  }
										  {	/* Module/class.scm 403 */
										     obj_t arg1698_1081;
										     {	/* Module/class.scm 403 */
											obj_t arg1700_1083;
											obj_t arg1701_1084;
											arg1700_1083 =
											   CNST_TABLE_REF(((long) 23));
											arg1701_1084 =
											   MAKE_PAIR(len_905, BNIL);
											arg1698_1081 =
											   MAKE_PAIR(arg1700_1083, arg1701_1084);
										     }
										     arg1697_1080 =
											MAKE_PAIR(arg1698_1081, BNIL);
										  }
										  arg1695_1078 =
										     MAKE_PAIR(arg1696_1079, arg1697_1080);
									       }
									       arg1692_1075 =
										  MAKE_PAIR(arg1694_1077, arg1695_1078);
									    }
									    arg1693_1076 =
									       MAKE_PAIR(BFALSE, BNIL);
									    arg1685_1068 =
									       MAKE_PAIR(arg1692_1075, arg1693_1076);
									 }
									 arg1678_1061 =
									    MAKE_PAIR(arg1684_1067, arg1685_1068);
								      }
								      arg1674_1057 =
									 MAKE_PAIR(arg1677_1060, arg1678_1061);
								   }
								   arg1667_1051 =
								      MAKE_PAIR(arg1673_1056, arg1674_1057);
								}
								return
								   MAKE_PAIR(arg1666_1050, arg1667_1051);
							     }
							  }
						       }
						     else
						       {	/* Module/class.scm 365 */
							  obj_t car_514_4_943;
							  car_514_4_943 =
							     CAR(slot_893);
							  if (
							     SYMBOLP(car_514_4_943))
							    {
							       obj_t att_3097;
							       obj_t id_3096;
							       id_3096 = car_514_4_943;
							       att_3097 = cdr_385_232_916;
							       att_910 = att_3097;
							       id_909 = id_3096;
							       goto tag_369_107_911;
							    }
							  else
							    {	/* Module/class.scm 365 */
							       goto tag_370_207_912;
							    }
						       }
						  }
					       }
					  }
					else
					  {	/* Module/class.scm 365 */
					     obj_t car_531_80_946;
					     car_531_80_946 =
						CAR(slot_893);
					     if (
						SYMBOLP(car_531_80_946))
					       {
						  obj_t att_3102;
						  obj_t id_3101;
						  id_3101 = car_531_80_946;
						  att_3102 = cdr_385_232_916;
						  att_910 = att_3102;
						  id_909 = id_3101;
						  goto tag_369_107_911;
					       }
					     else
					       {	/* Module/class.scm 365 */
						  goto tag_370_207_912;
					       }
					  }
				     }
				   else
				     {	/* Module/class.scm 365 */
					obj_t car_548_224_949;
					car_548_224_949 =
					   CAR(slot_893);
					if (
					   SYMBOLP(car_548_224_949))
					  {
					     obj_t att_3107;
					     obj_t id_3106;
					     id_3106 = car_548_224_949;
					     att_3107 = cdr_385_232_916;
					     att_910 = att_3107;
					     id_909 = id_3106;
					     goto tag_369_107_911;
					  }
					else
					  {	/* Module/class.scm 365 */
					     goto tag_370_207_912;
					  }
				     }
				}
			      else
				{	/* Module/class.scm 365 */
				   obj_t car_565_0_952;
				   car_565_0_952 =
				      CAR(slot_893);
				   if (
				      SYMBOLP(car_565_0_952))
				     {
					obj_t att_3112;
					obj_t id_3111;
					id_3111 = car_565_0_952;
					att_3112 = cdr_385_232_916;
					att_910 = att_3112;
					id_909 = id_3111;
					goto tag_369_107_911;
				     }
				   else
				     {	/* Module/class.scm 365 */
					goto tag_370_207_912;
				     }
				}
			   }
		      }
		   }
		 else
		   {	/* Module/class.scm 365 */
		      goto tag_370_207_912;
		   }
	      }
	 }
      }
   }
}



/* class-finalizer */
obj_t 
class_finalizer_253_module_class()
{
   AN_OBJECT;
   {	/* Module/class.scm 433 */
      {		/* Module/class.scm 435 */
	 bool_t test1745_1136;
	 {	/* Module/class.scm 435 */
	    obj_t obj_1998;
	    obj_1998 = _class_accesses__244_module_class;
	    test1745_1136 =
	       NULLP(obj_1998);
	 }
	 if (test1745_1136)
	   {	/* Module/class.scm 435 */
	      return
		 CNST_TABLE_REF(((long) 25));
	   }
	 else
	   {	/* Module/class.scm 435 */
	      {		/* Module/class.scm 450 */
		 obj_t body_1137;
		 body_1137 =
		    force_class_accesses_39_module_class();
		 {	/* Module/class.scm 450 */
		    obj_t body_1138;
		    {	/* Module/class.scm 451 */
		       obj_t arg1755_1148;
		       arg1755_1148 =
			  reverse__39___r4_pairs_and_lists_6_3(_declared_classes__217_module_class);
		       body_1138 =
			  append_2_18___r4_pairs_and_lists_6_3(arg1755_1148, body_1137);
		    }
		    {	/* Module/class.scm 451 */

		       {	/* Module/class.scm 452 */
			  obj_t arg1746_1139;
			  obj_t arg1748_1141;
			  arg1746_1139 =
			     CNST_TABLE_REF(((long) 22));
			  if (
			     PAIRP(body_1138))
			    {	/* Module/class.scm 454 */
			       arg1748_1141 = body_1138;
			    }
			  else
			    {	/* Module/class.scm 454 */
			       arg1748_1141 =
				  CNST_TABLE_REF(((long) 26));
			    }
			  {	/* ./Ast/unit.sch 765 */
			     obj_t new_2004;
			     {	/* ./Ast/unit.sch 765 */
				obj_t aux_3123;
				aux_3123 =
				   CNST_TABLE_REF(((long) 27));
				new_2004 =
				   create_struct(aux_3123, ((long) 4));
			     }
			     STRUCT_SET(new_2004, ((long) 3), BTRUE);
			     STRUCT_SET(new_2004, ((long) 2), arg1748_1141);
			     {	/* ./Llib/struct.scm 1463 */
				obj_t aux_3128;
				aux_3128 =
				   BINT(((long) 19));
				STRUCT_SET(new_2004, ((long) 1), aux_3128);
			     }
			     STRUCT_SET(new_2004, ((long) 0), arg1746_1139);
			     _object_unit__229_module_class = new_2004;
			  }
		       }
		       {	/* Module/class.scm 461 */
			  bool_t test1750_1143;
			  {	/* Module/class.scm 461 */
			     obj_t arg1752_1145;
			     arg1752_1145 =
				get_toplevel_unit_weight_75_module_include();
			     {	/* ./Ieee/fixnum.scm 7115 */
				long aux_3133;
				aux_3133 =
				   (long) CINT(arg1752_1145);
				test1750_1143 =
				   (((long) 20) < aux_3133);
			     }
			  }
			  if (test1750_1143)
			    {	/* Module/class.scm 461 */
			       BUNSPEC;
			    }
			  else
			    {	/* Module/class.scm 461 */
			       notify_assert_fail_37___eval(BNIL,
				  CNST_TABLE_REF(((long) 28)),
				  CNST_TABLE_REF(((long) 29)));
			    }
		       }
		       {	/* Module/class.scm 462 */
			  obj_t id_2027;
			  obj_t sexp__30_2029;
			  id_2027 =
			     CNST_TABLE_REF(((long) 30));
			  sexp__30_2029 =
			     CNST_TABLE_REF(((long) 26));
			  {	/* ./Ast/unit.sch 765 */
			     obj_t new_2031;
			     {	/* ./Ast/unit.sch 765 */
				obj_t aux_3142;
				aux_3142 =
				   CNST_TABLE_REF(((long) 27));
				new_2031 =
				   create_struct(aux_3142, ((long) 4));
			     }
			     STRUCT_SET(new_2031, ((long) 3), BTRUE);
			     STRUCT_SET(new_2031, ((long) 2), sexp__30_2029);
			     {	/* ./Llib/struct.scm 1463 */
				obj_t aux_3147;
				aux_3147 =
				   BINT(((long) 20));
				STRUCT_SET(new_2031, ((long) 1), aux_3147);
			     }
			     STRUCT_SET(new_2031, ((long) 0), id_2027);
			     _method_unit__121_module_class = new_2031;
			  }
		       }
		       {	/* Module/class.scm 468 */
			  obj_t list1753_1146;
			  {	/* Module/class.scm 468 */
			     obj_t arg1754_1147;
			     arg1754_1147 =
				MAKE_PAIR(_method_unit__121_module_class, BNIL);
			     list1753_1146 =
				MAKE_PAIR(_object_unit__229_module_class, arg1754_1147);
			  }
			  return list1753_1146;
		       }
		    }
		 }
	      }
	   }
      }
   }
}



/* _class-finalizer */
obj_t 
_class_finalizer_205_module_class(obj_t env_2188)
{
   AN_OBJECT;
   {	/* Module/class.scm 433 */
      return
	 class_finalizer_253_module_class();
   }
}



/* force-class-accesses */
obj_t 
force_class_accesses_39_module_class()
{
   AN_OBJECT;
   {	/* Module/class.scm 477 */
      {
	 obj_t cur_1149;
	 obj_t next_1150;
	 obj_t access_1151;
	 {	/* Module/class.scm 479 */
	    obj_t arg1756_1153;
	    arg1756_1153 =
	       reverse__39___r4_pairs_and_lists_6_3(_class_accesses__244_module_class);
	    cur_1149 = arg1756_1153;
	    next_1150 = BNIL;
	    access_1151 = BNIL;
	  loop_1152:
	    if (
	       NULLP(cur_1149))
	      {		/* Module/class.scm 482 */
		 if (
		    NULLP(next_1150))
		   {	/* Module/class.scm 483 */
		      return access_1151;
		   }
		 else
		   {
		      obj_t next_3160;
		      obj_t cur_3159;
		      cur_3159 = next_1150;
		      next_3160 = BNIL;
		      next_1150 = next_3160;
		      cur_1149 = cur_3159;
		      goto loop_1152;
		   }
	      }
	    else
	      {		/* Module/class.scm 486 */
		 obj_t class_1158;
		 {	/* ./Ieee/pair-list.scm 5701 */
		    obj_t aux_3161;
		    aux_3161 =
		       CAR(cur_1149);
		    class_1158 =
		       CAR(aux_3161);
		 }
		 {	/* Module/class.scm 486 */
		    obj_t super_1159;
		    {	/* Module/class.scm 487 */
		       tclass_bglt obj_2057;
		       obj_2057 =
			  (tclass_bglt) (class_1158);
		       {
			  obj_t aux_3165;
			  {	/* ./Object/class.scm 1597 */
			     object_bglt aux_3166;
			     aux_3166 =
				(object_bglt) (obj_2057);
			     aux_3165 =
				OBJECT_WIDENING(aux_3166);
			  }
			  super_1159 =
			     (((tclass_bglt) CREF(aux_3165))->its_super_214);
		       }
		    }
		    {	/* Module/class.scm 487 */

		       if (
			  (super_1159 == class_1158))
			 {	/* Module/class.scm 489 */
			    {	/* Module/class.scm 491 */
			       obj_t arg1764_1162;
			       {	/* Module/class.scm 493 */
				  obj_t arg1765_1163;
				  {	/* Module/class.scm 493 */
				     obj_t arg1766_1164;
				     {	/* ./Ieee/pair-list.scm 5707 */
					obj_t aux_3172;
					aux_3172 =
					   CAR(cur_1149);
					arg1766_1164 =
					   CDR(aux_3172);
				     }
				     arg1765_1163 =
					PROCEDURE_ENTRY(arg1766_1164) (arg1766_1164, BEOA);
				  }
				  arg1764_1162 =
				     append_2_18___r4_pairs_and_lists_6_3(arg1765_1163, access_1151);
			       }
			       {
				  obj_t access_3180;
				  obj_t cur_3178;
				  cur_3178 =
				     CDR(cur_1149);
				  access_3180 = arg1764_1162;
				  access_1151 = access_3180;
				  cur_1149 = cur_3178;
				  goto loop_1152;
			       }
			    }
			 }
		       else
			 {	/* Module/class.scm 495 */
			    bool_t test1768_1166;
			    test1768_1166 =
			       is_a__118___object(super_1159, tclass_object_class);
			    if (test1768_1166)
			      {		/* Module/class.scm 508 */
				 bool_t test_3183;
				 {	/* ./Ieee/equiv.scm 5508 */
				    obj_t aux_3184;
				    {	/* Module/class.scm 508 */
				       tclass_bglt obj_2065;
				       obj_2065 =
					  (tclass_bglt) (super_1159);
				       {
					  obj_t aux_3186;
					  {	/* ./Object/class.scm 1601 */
					     object_bglt aux_3187;
					     aux_3187 =
						(object_bglt) (obj_2065);
					     aux_3186 =
						OBJECT_WIDENING(aux_3187);
					  }
					  aux_3184 =
					     (((tclass_bglt) CREF(aux_3186))->slots);
				       }
				    }
				    test_3183 =
				       (aux_3184 == BUNSPEC);
				 }
				 if (test_3183)
				   {	/* Module/class.scm 508 */
				      {		/* Module/class.scm 510 */
					 obj_t arg1770_1168;
					 obj_t arg1771_1169;
					 arg1770_1168 =
					    CDR(cur_1149);
					 {	/* ./Ieee/pair-list.scm 5689 */
					    obj_t aux_3193;
					    aux_3193 =
					       CAR(cur_1149);
					    arg1771_1169 =
					       MAKE_PAIR(aux_3193, next_1150);
					 }
					 {
					    obj_t next_3197;
					    obj_t cur_3196;
					    cur_3196 = arg1770_1168;
					    next_3197 = arg1771_1169;
					    next_1150 = next_3197;
					    cur_1149 = cur_3196;
					    goto loop_1152;
					 }
				      }
				   }
				 else
				   {	/* Module/class.scm 508 */
				      {		/* Module/class.scm 515 */
					 obj_t arg1774_1172;
					 {	/* Module/class.scm 517 */
					    obj_t arg1775_1173;
					    {	/* Module/class.scm 517 */
					       obj_t arg1776_1174;
					       {	/* ./Ieee/pair-list.scm 5707 */
						  obj_t aux_3198;
						  aux_3198 =
						     CAR(cur_1149);
						  arg1776_1174 =
						     CDR(aux_3198);
					       }
					       arg1775_1173 =
						  PROCEDURE_ENTRY(arg1776_1174) (arg1776_1174, BEOA);
					    }
					    arg1774_1172 =
					       append_2_18___r4_pairs_and_lists_6_3(arg1775_1173, access_1151);
					 }
					 {
					    obj_t access_3206;
					    obj_t cur_3204;
					    cur_3204 =
					       CDR(cur_1149);
					    access_3206 = arg1774_1172;
					    access_1151 = access_3206;
					    cur_1149 = cur_3204;
					    goto loop_1152;
					 }
				      }
				   }
			      }
			    else
			      {		/* Module/class.scm 495 */
				 {	/* Module/class.scm 496 */
				    bool_t test1779_1177;
				    test1779_1177 =
				       is_a__118___object(super_1159, type_type_type);
				    if (test1779_1177)
				      {		/* Module/class.scm 496 */
					 {	/* Module/class.scm 500 */
					    tclass_bglt obj_2077;
					    obj_2077 =
					       (tclass_bglt) (class_1158);
					    {
					       obj_t aux_3210;
					       {	/* ./Object/class.scm 1601 */
						  object_bglt aux_3211;
						  aux_3211 =
						     (object_bglt) (obj_2077);
						  aux_3210 =
						     OBJECT_WIDENING(aux_3211);
					       }
					       ((((tclass_bglt) CREF(aux_3210))->slots) = ((obj_t) BNIL), BUNSPEC);
					    }
					 }
					 {
					    obj_t cur_3215;
					    cur_3215 =
					       CDR(cur_1149);
					    cur_1149 = cur_3215;
					    goto loop_1152;
					 }
				      }
				    else
				      {		/* Module/class.scm 504 */
					 obj_t arg1782_1180;
					 {	/* Module/class.scm 506 */
					    obj_t arg1783_1181;
					    {	/* Module/class.scm 506 */
					       obj_t arg1784_1182;
					       {	/* ./Ieee/pair-list.scm 5707 */
						  obj_t aux_3217;
						  aux_3217 =
						     CAR(cur_1149);
						  arg1784_1182 =
						     CDR(aux_3217);
					       }
					       arg1783_1181 =
						  PROCEDURE_ENTRY(arg1784_1182) (arg1784_1182, BEOA);
					    }
					    arg1782_1180 =
					       append_2_18___r4_pairs_and_lists_6_3(arg1783_1181, access_1151);
					 }
					 {
					    obj_t access_3225;
					    obj_t cur_3223;
					    cur_3223 =
					       CDR(cur_1149);
					    access_3225 = arg1782_1180;
					    access_1151 = access_3225;
					    cur_1149 = cur_3223;
					    goto loop_1152;
					 }
				      }
				 }
			      }
			 }
		    }
		 }
	      }
	 }
      }
   }
}



/* method-init */
obj_t 
method_init_76_module_class()
{
   AN_OBJECT;
   {	/* Module/class.scm 14 */
      return BUNSPEC;
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_module_class()
{
   AN_OBJECT;
   {	/* Module/class.scm 14 */
      module_initialization_70_tools_trace(((long) 0), "MODULE_CLASS");
      module_initialization_70_module_module(((long) 0), "MODULE_CLASS");
      module_initialization_70_module_impuse(((long) 0), "MODULE_CLASS");
      module_initialization_70_module_include(((long) 0), "MODULE_CLASS");
      module_initialization_70_engine_param(((long) 0), "MODULE_CLASS");
      module_initialization_70_tools_shape(((long) 0), "MODULE_CLASS");
      module_initialization_70_tools_error(((long) 0), "MODULE_CLASS");
      module_initialization_70_type_type(((long) 0), "MODULE_CLASS");
      module_initialization_70_type_env(((long) 0), "MODULE_CLASS");
      module_initialization_70_ast_ident(((long) 0), "MODULE_CLASS");
      module_initialization_70_ast_var(((long) 0), "MODULE_CLASS");
      module_initialization_70_ast_env(((long) 0), "MODULE_CLASS");
      module_initialization_70_object_class(((long) 0), "MODULE_CLASS");
      module_initialization_70_object_plain_access_186(((long) 0), "MODULE_CLASS");
      module_initialization_70_object_wide_access_168(((long) 0), "MODULE_CLASS");
      return
	 module_initialization_70_tools_location(((long) 0), "MODULE_CLASS");
   }
}
