/*===========================================================================*/
/*   (Module/eval.scm)                                                       */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;

typedef struct ccomp
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t producer;
     obj_t consumer;
     obj_t finalizer;
     obj_t checksummer;
  }
     *ccomp_bglt;


extern obj_t ccomp_module_module;
static obj_t method_init_76_module_eval();
extern obj_t find_global_module_25_ast_env(obj_t, obj_t);
static obj_t _make_eval_compiler_216_module_eval(obj_t);
extern obj_t create_struct(obj_t, long);
static bool_t _one_eval___78_module_eval;
static obj_t eval_finalizer_221_module_eval();
extern obj_t global_ast_var;
static bool_t _all_eval___198_module_eval;
extern obj_t _obj__252_type_cache;
extern bool_t bigloo_type__118_type_type(type_bglt);
extern obj_t user_error_151_tools_error(obj_t, obj_t, obj_t, obj_t);
static obj_t _anonymous_1553__118_module_eval(obj_t, obj_t);
static obj_t _eval_producer_136_module_eval(obj_t, obj_t);
extern bool_t is_a__118___object(obj_t, obj_t);
static obj_t _anonymous_1528__227_module_eval(obj_t);
extern obj_t module_initialization_70_module_eval(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_module_module(long, char *);
extern obj_t module_initialization_70_module_include(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_tools_location(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_ast_env(long, char *);
extern obj_t module_initialization_70_ast_glo_decl_237(long, char *);
extern obj_t module_initialization_70_ast_sexp(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_control_features_6_9(long, char *);
extern node_bglt location__node_25_ast_sexp(global_bglt);
extern long class_num_218___object(obj_t);
extern obj_t svar_ast_var;
static obj_t _anonymous_1466__9_module_eval(obj_t, obj_t, obj_t);
static obj_t _anonymous_1465__244_module_eval(obj_t, obj_t, obj_t);
extern obj_t scnst_ast_var;
static obj_t imported_modules_init_94_module_eval();
static obj_t remember_eval_exported__63_module_eval(obj_t, obj_t, obj_t);
extern obj_t append_2_18___r4_pairs_and_lists_6_3(obj_t, obj_t);
static obj_t library_modules_init_112_module_eval();
static obj_t set_eval_types__118_module_eval(obj_t);
static obj_t _eval_exported__84_module_eval = BUNSPEC;
extern obj_t make_eval_compiler_154_module_eval();
extern global_bglt declare_global_svar__200_ast_glo_decl_237(obj_t, obj_t, obj_t, obj_t);
static obj_t toplevel_init_63_module_eval();
extern obj_t open_input_string(obj_t);
extern obj_t sfun_ast_var;
extern node_bglt define_primop__node_141_ast_sexp(global_bglt);
static obj_t eval_producer_250_module_eval(obj_t);
extern obj_t make_promise_21___r4_control_features_6_9(obj_t);
extern obj_t memq___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern obj_t for_each_global__88_ast_env(obj_t);
extern obj_t _module__166_module_module;
static obj_t eval_parser_66_module_eval(obj_t, obj_t);
extern obj_t read___reader(obj_t);
extern obj_t find_location_120_tools_location(obj_t);
static obj_t get_evaluated_globals_117_module_eval();
extern obj_t _lib_mode__85_engine_param;
extern node_bglt define_primop_ref__node_164_ast_sexp(global_bglt, node_bglt);
extern obj_t get_toplevel_unit_weight_75_module_include();
extern obj_t ____74_type_cache;
static obj_t require_initialization_114_module_eval = BUNSPEC;
static obj_t _eval_finalizer_230_module_eval(obj_t);
static obj_t cnst_init_137_module_eval();
extern obj_t reverse__39___r4_pairs_and_lists_6_3(obj_t);
extern obj_t user_error_location_137_tools_error(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t __cnst[11];

DEFINE_STATIC_PROCEDURE(proc1668_module_eval, _anonymous_1528__227_module_eval1679, _anonymous_1528__227_module_eval, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc1664_module_eval, _anonymous_1465__244_module_eval1680, _anonymous_1465__244_module_eval, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc1663_module_eval, _anonymous_1466__9_module_eval1681, _anonymous_1466__9_module_eval, 0L, 2);
DEFINE_STATIC_PROCEDURE(eval_finalizer_env_4_module_eval, _eval_finalizer_230_module_eval1682, _eval_finalizer_230_module_eval, 0L, 0);
DEFINE_STATIC_PROCEDURE(eval_producer_env_150_module_eval, _eval_producer_136_module_eval1683, _eval_producer_136_module_eval, 0L, 1);
DEFINE_STRING(string1674_module_eval, string1674_module_eval1684, "(IMPORT STATIC EXPORT) (#unspecified) WRITE BEGIN VOID UNIT IMPORT @ EXPORT EXPORT-ALL EVAL ", 92);
DEFINE_STRING(string1673_module_eval, string1673_module_eval1685, "Unbound variable", 16);
DEFINE_STRING(string1672_module_eval, string1672_module_eval1686, "This variable cannot be known by eval", 37);
DEFINE_STRING(string1671_module_eval, string1671_module_eval1687, "eval-init", 9);
DEFINE_STRING(string1669_module_eval, string1669_module_eval1688, "eval", 4);
DEFINE_STRING(string1670_module_eval, string1670_module_eval1689, "Non bigloo prototyped value can't be evaluated", 46);
DEFINE_STRING(string1667_module_eval, string1667_module_eval1690, "Illegal `eval clause'", 21);
DEFINE_STRING(string1666_module_eval, string1666_module_eval1691, "Illegal `eval' clause", 21);
DEFINE_STRING(string1665_module_eval, string1665_module_eval1692, "Parse error", 11);
DEFINE_EXPORT_PROCEDURE(make_eval_compiler_env_58_module_eval, _make_eval_compiler_216_module_eval1693, _make_eval_compiler_216_module_eval, 0L, 0);



/* module-initialization */
obj_t 
module_initialization_70_module_eval(long checksum_1474, char *from_1475)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_module_eval))
	{
	   require_initialization_114_module_eval =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_module_eval();
	   cnst_init_137_module_eval();
	   imported_modules_init_94_module_eval();
	   method_init_76_module_eval();
	   toplevel_init_63_module_eval();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_module_eval()
{
   AN_OBJECT;
   {	/* Module/eval.scm 14 */
      module_initialization_70___object(((long) 0), "MODULE_EVAL");
      module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "MODULE_EVAL");
      module_initialization_70___r4_control_features_6_9(((long) 0), "MODULE_EVAL");
      module_initialization_70___reader(((long) 0), "MODULE_EVAL");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_module_eval()
{
   AN_OBJECT;
   {	/* Module/eval.scm 14 */
      {		/* Module/eval.scm 14 */
	 obj_t cnst_port_138_1467;
	 cnst_port_138_1467 =
	    open_input_string(string1674_module_eval);
	 {
	    long i_1468;
	    i_1468 = ((long) 10);
	  loop_1469:
	    {	/* Module/eval.scm 14 */
	       bool_t test1675_1470;
	       test1675_1470 =
		  (i_1468 == ((long) -1));
	       if (test1675_1470)
		 {	/* Module/eval.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Module/eval.scm 14 */
		    {	/* Module/eval.scm 14 */
		       obj_t arg1676_1471;
		       {	/* Module/eval.scm 14 */
			  obj_t list1677_1472;
			  list1677_1472 =
			     MAKE_PAIR(cnst_port_138_1467, BNIL);
			  arg1676_1471 =
			     read___reader(list1677_1472);
		       }
		       CNST_TABLE_SET(i_1468, arg1676_1471);
		    }
		    {	/* Module/eval.scm 14 */
		       int aux_1473;
		       {	/* Module/eval.scm 14 */
			  long aux_1494;
			  aux_1494 =
			     (i_1468 - ((long) 1));
			  aux_1473 =
			     (int) (aux_1494);
		       }
		       {
			  long i_1497;
			  i_1497 =
			     (long) (aux_1473);
			  i_1468 = i_1497;
			  goto loop_1469;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_module_eval()
{
   AN_OBJECT;
   {	/* Module/eval.scm 14 */
      _eval_exported__84_module_eval = BNIL;
      _all_eval___198_module_eval = ((bool_t) 0);
      return (
	 _one_eval___78_module_eval = ((bool_t) 0), BUNSPEC);
   }
}



/* make-eval-compiler */
obj_t 
make_eval_compiler_154_module_eval()
{
   AN_OBJECT;
   {	/* Module/eval.scm 32 */
      {		/* Module/eval.scm 33 */
	 obj_t arg1459_742;
	 arg1459_742 =
	    CNST_TABLE_REF(((long) 0));
	 {	/* ./Module/module.scm 851 */
	    obj_t _anonymous_1466__9_1447;
	    obj_t _anonymous_1465__244_1448;
	    _anonymous_1466__9_1447 = proc1663_module_eval;
	    _anonymous_1465__244_1448 = proc1664_module_eval;
	    {	/* Module/eval.scm 33 */
	       ccomp_bglt res1662_1291;
	       {	/* ./Module/module.scm 843 */
		  ccomp_bglt new1437_1282;
		  new1437_1282 =
		     ((ccomp_bglt) BREF(GC_MALLOC(sizeof(struct ccomp))));
		  {	/* ./Module/module.scm 843 */
		     long arg1589_1283;
		     arg1589_1283 =
			class_num_218___object(ccomp_module_module);
		     {	/* ./Module/module.scm 843 */
			obj_t obj_1289;
			obj_1289 =
			   (obj_t) (new1437_1282);
			(((obj_t) CREF(obj_1289))->header = MAKE_HEADER(arg1589_1283, 0), BUNSPEC);
		     }
		  }
		  {	/* ./Module/module.scm 843 */
		     object_bglt aux_1504;
		     aux_1504 =
			(object_bglt) (new1437_1282);
		     OBJECT_WIDENING_SET(aux_1504, BFALSE);
		  }
		  ((((ccomp_bglt) CREF(new1437_1282))->id) = ((obj_t) arg1459_742), BUNSPEC);
		  ((((ccomp_bglt) CREF(new1437_1282))->producer) = ((obj_t) eval_producer_env_150_module_eval), BUNSPEC);
		  ((((ccomp_bglt) CREF(new1437_1282))->consumer) = ((obj_t) _anonymous_1465__244_1448), BUNSPEC);
		  ((((ccomp_bglt) CREF(new1437_1282))->finalizer) = ((obj_t) eval_finalizer_env_4_module_eval), BUNSPEC);
		  ((((ccomp_bglt) CREF(new1437_1282))->checksummer) = ((obj_t) _anonymous_1466__9_1447), BUNSPEC);
		  res1662_1291 = new1437_1282;
	       }
	       return
		  (obj_t) (res1662_1291);
	    }
	 }
      }
   }
}



/* _make-eval-compiler */
obj_t 
_make_eval_compiler_216_module_eval(obj_t env_1449)
{
   AN_OBJECT;
   {	/* Module/eval.scm 32 */
      return
	 make_eval_compiler_154_module_eval();
   }
}



/* <anonymous:1466> */
obj_t 
_anonymous_1466__9_module_eval(obj_t env_1450, obj_t m_1451, obj_t c_1452)
{
   AN_OBJECT;
   {	/* ./Module/module.scm 856 */
      {
	 obj_t m_750;
	 obj_t c_751;
	 m_750 = m_1451;
	 c_751 = c_1452;
	 return c_751;
      }
   }
}



/* <anonymous:1465> */
obj_t 
_anonymous_1465__244_module_eval(obj_t env_1453, obj_t m_1454, obj_t c_1455)
{
   AN_OBJECT;
   {	/* ./Module/module.scm 851 */
      {
	 obj_t m_747;
	 obj_t c_748;
	 m_747 = m_1454;
	 c_748 = c_1455;
	 return BNIL;
      }
   }
}



/* eval-producer */
obj_t 
eval_producer_250_module_eval(obj_t clause_19)
{
   AN_OBJECT;
   {	/* Module/eval.scm 40 */
      {
	 obj_t protos_755;
	 if (
	    PAIRP(clause_19))
	   {	/* Module/eval.scm 41 */
	      protos_755 =
		 CDR(clause_19);
	      {
		 obj_t l1446_761;
		 l1446_761 = protos_755;
	       lname1447_762:
		 if (
		    PAIRP(l1446_761))
		   {	/* Module/eval.scm 43 */
		      eval_parser_66_module_eval(
			 CAR(l1446_761), clause_19);
		      {
			 obj_t l1446_1520;
			 l1446_1520 =
			    CDR(l1446_761);
			 l1446_761 = l1446_1520;
			 goto lname1447_762;
		      }
		   }
		 else
		   {	/* Module/eval.scm 43 */
		      ((bool_t) 1);
		   }
	      }
	      return BNIL;
	   }
	 else
	   {	/* Module/eval.scm 41 */
	      {		/* Module/eval.scm 46 */
		 obj_t list1472_766;
		 list1472_766 =
		    MAKE_PAIR(BNIL, BNIL);
		 return
		    user_error_151_tools_error(string1665_module_eval, string1666_module_eval, clause_19, list1472_766);
	      }
	   }
      }
   }
}



/* _eval-producer */
obj_t 
_eval_producer_136_module_eval(obj_t env_1456, obj_t clause_1457)
{
   AN_OBJECT;
   {	/* Module/eval.scm 40 */
      return
	 eval_producer_250_module_eval(clause_1457);
   }
}



/* eval-parser */
obj_t 
eval_parser_66_module_eval(obj_t proto_20, obj_t clause_21)
{
   AN_OBJECT;
   {	/* Module/eval.scm 54 */
      {

	 if (
	    PAIRP(proto_20))
	   {	/* Module/eval.scm 55 */
	      bool_t test_1528;
	      {		/* ./Ieee/equiv.scm 5508 */
		 obj_t aux_1531;
		 obj_t aux_1529;
		 aux_1531 =
		    CNST_TABLE_REF(((long) 1));
		 aux_1529 =
		    CAR(proto_20);
		 test_1528 =
		    (aux_1529 == aux_1531);
	      }
	      if (test_1528)
		{	/* Module/eval.scm 55 */
		   bool_t test_1534;
		   {	/* ./Ieee/equiv.scm 5508 */
		      obj_t aux_1535;
		      aux_1535 =
			 CDR(proto_20);
		      test_1534 =
			 (aux_1535 == BNIL);
		   }
		   if (test_1534)
		     {	/* Module/eval.scm 55 */
			return (
			   _all_eval___198_module_eval = ((bool_t) 1), BUNSPEC);
		     }
		   else
		     {	/* Module/eval.scm 55 */
		      tag_113_246_775:
			{	/* Module/eval.scm 67 */
			   obj_t list1512_824;
			   list1512_824 =
			      MAKE_PAIR(BNIL, BNIL);
			   return
			      user_error_151_tools_error(string1665_module_eval, string1667_module_eval, clause_21, list1512_824);
			}
		     }
		}
	      else
		{	/* Module/eval.scm 55 */
		   obj_t cdr_132_143_782;
		   cdr_132_143_782 =
		      CDR(proto_20);
		   {	/* Module/eval.scm 55 */
		      bool_t test_1541;
		      {		/* ./Ieee/equiv.scm 5508 */
			 obj_t aux_1544;
			 obj_t aux_1542;
			 aux_1544 =
			    CNST_TABLE_REF(((long) 2));
			 aux_1542 =
			    CAR(proto_20);
			 test_1541 =
			    (aux_1542 == aux_1544);
		      }
		      if (test_1541)
			{	/* Module/eval.scm 55 */
			   if (
			      PAIRP(cdr_132_143_782))
			     {	/* Module/eval.scm 55 */
				obj_t car_134_159_785;
				car_134_159_785 =
				   CAR(cdr_132_143_782);
				if (
				   SYMBOLP(car_134_159_785))
				  {	/* Module/eval.scm 55 */
				     bool_t test_1552;
				     {	/* ./Ieee/equiv.scm 5508 */
					obj_t aux_1553;
					aux_1553 =
					   CDR(cdr_132_143_782);
					test_1552 =
					   (aux_1553 == BNIL);
				     }
				     if (test_1552)
				       {	/* Module/eval.scm 55 */
					  _one_eval___78_module_eval = ((bool_t) 1);
					  return
					     remember_eval_exported__63_module_eval(car_134_159_785, _module__166_module_module, proto_20);
				       }
				     else
				       {	/* Module/eval.scm 55 */
					  goto tag_113_246_775;
				       }
				  }
				else
				  {	/* Module/eval.scm 55 */
				     obj_t car_153_175_791;
				     car_153_175_791 =
					CAR(cdr_132_143_782);
				     if (
					PAIRP(car_153_175_791))
				       {	/* Module/eval.scm 55 */
					  obj_t cdr_158_238_793;
					  cdr_158_238_793 =
					     CDR(car_153_175_791);
					  {	/* Module/eval.scm 55 */
					     bool_t test_1561;
					     {	/* ./Ieee/equiv.scm 5508 */
						obj_t aux_1564;
						obj_t aux_1562;
						aux_1564 =
						   CNST_TABLE_REF(((long) 3));
						aux_1562 =
						   CAR(car_153_175_791);
						test_1561 =
						   (aux_1562 == aux_1564);
					     }
					     if (test_1561)
					       {	/* Module/eval.scm 55 */
						  if (
						     PAIRP(cdr_158_238_793))
						    {	/* Module/eval.scm 55 */
						       obj_t car_161_104_796;
						       obj_t cdr_162_110_797;
						       car_161_104_796 =
							  CAR(cdr_158_238_793);
						       cdr_162_110_797 =
							  CDR(cdr_158_238_793);
						       if (
							  SYMBOLP(car_161_104_796))
							 {	/* Module/eval.scm 55 */
							    if (
							       PAIRP(cdr_162_110_797))
							      {		/* Module/eval.scm 55 */
								 obj_t car_167_57_800;
								 car_167_57_800 =
								    CAR(cdr_162_110_797);
								 if (
								    SYMBOLP(car_167_57_800))
								   {	/* Module/eval.scm 55 */
								      bool_t test_1578;
								      {		/* ./Ieee/equiv.scm 5508 */
									 obj_t aux_1579;
									 aux_1579 =
									    CDR(cdr_162_110_797);
									 test_1578 =
									    (aux_1579 == BNIL);
								      }
								      if (test_1578)
									{	/* Module/eval.scm 55 */
									   bool_t test_1582;
									   {	/* ./Ieee/equiv.scm 5508 */
									      obj_t aux_1583;
									      aux_1583 =
										 CDR(cdr_132_143_782);
									      test_1582 =
										 (aux_1583 == BNIL);
									   }
									   if (test_1582)
									     {	/* Module/eval.scm 55 */
										_one_eval___78_module_eval = ((bool_t) 1);
										return
										   remember_eval_exported__63_module_eval(car_161_104_796, car_167_57_800, proto_20);
									     }
									   else
									     {	/* Module/eval.scm 55 */
										goto tag_113_246_775;
									     }
									}
								      else
									{	/* Module/eval.scm 55 */
									   goto tag_113_246_775;
									}
								   }
								 else
								   {	/* Module/eval.scm 55 */
								      goto tag_113_246_775;
								   }
							      }
							    else
							      {		/* Module/eval.scm 55 */
								 goto tag_113_246_775;
							      }
							 }
						       else
							 {	/* Module/eval.scm 55 */
							    goto tag_113_246_775;
							 }
						    }
						  else
						    {	/* Module/eval.scm 55 */
						       goto tag_113_246_775;
						    }
					       }
					     else
					       {	/* Module/eval.scm 55 */
						  goto tag_113_246_775;
					       }
					  }
				       }
				     else
				       {	/* Module/eval.scm 55 */
					  goto tag_113_246_775;
				       }
				  }
			     }
			   else
			     {	/* Module/eval.scm 55 */
				goto tag_113_246_775;
			     }
			}
		      else
			{	/* Module/eval.scm 55 */
			   bool_t test_1587;
			   {	/* ./Ieee/equiv.scm 5508 */
			      obj_t aux_1590;
			      obj_t aux_1588;
			      aux_1590 =
				 CNST_TABLE_REF(((long) 4));
			      aux_1588 =
				 CAR(proto_20);
			      test_1587 =
				 (aux_1588 == aux_1590);
			   }
			   if (test_1587)
			     {	/* Module/eval.scm 55 */
				if (
				   PAIRP(cdr_132_143_782))
				  {	/* Module/eval.scm 55 */
				     obj_t car_203_140_813;
				     car_203_140_813 =
					CAR(cdr_132_143_782);
				     if (
					SYMBOLP(car_203_140_813))
				       {	/* Module/eval.scm 55 */
					  bool_t test_1598;
					  {	/* ./Ieee/equiv.scm 5508 */
					     obj_t aux_1599;
					     aux_1599 =
						CDR(cdr_132_143_782);
					     test_1598 =
						(aux_1599 == BNIL);
					  }
					  if (test_1598)
					    {	/* Module/eval.scm 65 */
					       global_bglt aux_1602;
					       aux_1602 =
						  declare_global_svar__200_ast_glo_decl_237(car_203_140_813,
						  CNST_TABLE_REF(((long) 0)),
						  CNST_TABLE_REF(((long) 0)), clause_21);
					       return
						  (obj_t) (aux_1602);
					    }
					  else
					    {	/* Module/eval.scm 55 */
					       goto tag_113_246_775;
					    }
				       }
				     else
				       {	/* Module/eval.scm 55 */
					  goto tag_113_246_775;
				       }
				  }
				else
				  {	/* Module/eval.scm 55 */
				     goto tag_113_246_775;
				  }
			     }
			   else
			     {	/* Module/eval.scm 55 */
				goto tag_113_246_775;
			     }
			}
		   }
		}
	   }
	 else
	   {	/* Module/eval.scm 55 */
	      goto tag_113_246_775;
	   }
      }
   }
}



/* remember-eval-exported! */
obj_t 
remember_eval_exported__63_module_eval(obj_t var_22, obj_t module_23, obj_t loc_24)
{
   AN_OBJECT;
   {	/* Module/eval.scm 77 */
      {		/* Module/eval.scm 78 */
	 obj_t arg1513_825;
	 {	/* Module/eval.scm 78 */
	    obj_t list1514_826;
	    {	/* Module/eval.scm 78 */
	       obj_t arg1515_827;
	       {	/* Module/eval.scm 78 */
		  obj_t arg1516_828;
		  arg1516_828 =
		     MAKE_PAIR(loc_24, BNIL);
		  arg1515_827 =
		     MAKE_PAIR(module_23, arg1516_828);
	       }
	       list1514_826 =
		  MAKE_PAIR(var_22, arg1515_827);
	    }
	    arg1513_825 = list1514_826;
	 }
	 {	/* Module/eval.scm 78 */
	    obj_t obj2_1350;
	    obj2_1350 = _eval_exported__84_module_eval;
	    return (
	       _eval_exported__84_module_eval =
	       MAKE_PAIR(arg1513_825, obj2_1350), BUNSPEC);
	 }
      }
   }
}



/* eval-finalizer */
obj_t 
eval_finalizer_221_module_eval()
{
   AN_OBJECT;
   {	/* Module/eval.scm 93 */
      {		/* Module/eval.scm 94 */
	 bool_t test1517_829;
	 if (_one_eval___78_module_eval)
	   {	/* Module/eval.scm 94 */
	      test1517_829 = ((bool_t) 1);
	   }
	 else
	   {	/* Module/eval.scm 94 */
	      test1517_829 = _all_eval___198_module_eval;
	   }
	 if (test1517_829)
	   {	/* Module/eval.scm 97 */
	      obj_t arg1519_830;
	      {		/* Module/eval.scm 97 */
		 obj_t arg1521_832;
		 long arg1522_833;
		 obj_t arg1523_834;
		 arg1521_832 =
		    CNST_TABLE_REF(((long) 0));
		 {	/* Module/eval.scm 98 */
		    obj_t arg1525_835;
		    arg1525_835 =
		       get_toplevel_unit_weight_75_module_include();
		    {	/* ./Ieee/fixnum.scm 7199 */
		       long aux_1615;
		       aux_1615 =
			  (long) CINT(arg1525_835);
		       arg1522_833 =
			  (aux_1615 - ((long) 2));
		    }
		 }
		 {	/* Module/eval.scm 100 */
		    obj_t _anonymous_1528__227_1459;
		    _anonymous_1528__227_1459 = proc1668_module_eval;
		    arg1523_834 =
		       make_promise_21___r4_control_features_6_9(_anonymous_1528__227_1459);
		 }
		 {	/* ./Ast/unit.sch 426 */
		    obj_t new_1370;
		    {	/* ./Ast/unit.sch 426 */
		       obj_t aux_1619;
		       aux_1619 =
			  CNST_TABLE_REF(((long) 5));
		       new_1370 =
			  create_struct(aux_1619, ((long) 4));
		    }
		    STRUCT_SET(new_1370, ((long) 3), BFALSE);
		    STRUCT_SET(new_1370, ((long) 2), arg1523_834);
		    {	/* ./Llib/struct.scm 1463 */
		       obj_t aux_1624;
		       aux_1624 =
			  BINT(arg1522_833);
		       STRUCT_SET(new_1370, ((long) 1), aux_1624);
		    }
		    STRUCT_SET(new_1370, ((long) 0), arg1521_832);
		    arg1519_830 = new_1370;
		 }
	      }
	      {		/* Module/eval.scm 95 */
		 obj_t list1520_831;
		 list1520_831 =
		    MAKE_PAIR(arg1519_830, BNIL);
		 return list1520_831;
	      }
	   }
	 else
	   {	/* Module/eval.scm 94 */
	      return
		 CNST_TABLE_REF(((long) 6));
	   }
      }
   }
}



/* _eval-finalizer */
obj_t 
_eval_finalizer_230_module_eval(obj_t env_1458)
{
   AN_OBJECT;
   {	/* Module/eval.scm 93 */
      return
	 eval_finalizer_221_module_eval();
   }
}



/* <anonymous:1528> */
obj_t 
_anonymous_1528__227_module_eval(obj_t env_1460)
{
   AN_OBJECT;
   {	/* Module/eval.scm 99 */
      {

	 {
	    obj_t globals_839;
	    obj_t init__202_840;
	    {	/* Module/eval.scm 100 */
	       obj_t arg1529_842;
	       obj_t arg1530_843;
	       arg1529_842 =
		  get_evaluated_globals_117_module_eval();
	       arg1530_843 =
		  CNST_TABLE_REF(((long) 9));
	       globals_839 = arg1529_842;
	       init__202_840 = arg1530_843;
	     loop_841:
	       if (
		  NULLP(globals_839))
		 {	/* Module/eval.scm 103 */
		    obj_t arg1532_845;
		    obj_t arg1533_846;
		    arg1532_845 =
		       CNST_TABLE_REF(((long) 7));
		    {	/* Module/eval.scm 103 */
		       obj_t arg1534_847;
		       arg1534_847 =
			  reverse__39___r4_pairs_and_lists_6_3(init__202_840);
		       arg1533_846 =
			  append_2_18___r4_pairs_and_lists_6_3(arg1534_847, BNIL);
		    }
		    return
		       MAKE_PAIR(arg1532_845, arg1533_846);
		 }
	       else
		 {	/* Module/eval.scm 104 */
		    obj_t g_849;
		    g_849 =
		       CAR(globals_839);
		    set_eval_types__118_module_eval(g_849);
		    {	/* Module/eval.scm 106 */
		       obj_t arg1536_850;
		       obj_t arg1537_851;
		       arg1536_850 =
			  CDR(globals_839);
		       {	/* Module/eval.scm 108 */
			  node_bglt arg1539_852;
			  {	/* Module/eval.scm 108 */
			     bool_t test1540_853;
			     {	/* ./Ast/var.scm 611 */
				obj_t aux_1642;
				{	/* Module/eval.scm 108 */
				   value_bglt aux_1643;
				   {	/* Module/eval.scm 108 */
				      global_bglt obj_1358;
				      obj_1358 =
					 (global_bglt) (g_849);
				      aux_1643 =
					 (((global_bglt) CREF(obj_1358))->value);
				   }
				   aux_1642 =
				      (obj_t) (aux_1643);
				}
				test1540_853 =
				   is_a__118___object(aux_1642, svar_ast_var);
			     }
			     if (test1540_853)
			       {	/* Module/eval.scm 108 */
				  {	/* Module/eval.scm 109 */
				     variable_bglt obj_1360;
				     obj_t val1036_1361;
				     obj_1360 =
					(variable_bglt) (g_849);
				     val1036_1361 =
					CNST_TABLE_REF(((long) 8));
				     ((((variable_bglt) CREF(obj_1360))->access) = ((obj_t) val1036_1361), BUNSPEC);
				  }
				  {	/* Module/eval.scm 111 */
				     node_bglt arg1541_854;
				     arg1541_854 =
					location__node_25_ast_sexp(
					(global_bglt) (g_849));
				     arg1539_852 =
					define_primop_ref__node_164_ast_sexp(
					(global_bglt) (g_849), arg1541_854);
				  }
			       }
			     else
			       {	/* Module/eval.scm 112 */
				  bool_t test1542_855;
				  {	/* ./Ast/var.scm 615 */
				     obj_t aux_1656;
				     {	/* Module/eval.scm 112 */
					value_bglt aux_1657;
					{	/* Module/eval.scm 112 */
					   global_bglt obj_1362;
					   obj_1362 =
					      (global_bglt) (g_849);
					   aux_1657 =
					      (((global_bglt) CREF(obj_1362))->value);
					}
					aux_1656 =
					   (obj_t) (aux_1657);
				     }
				     test1542_855 =
					is_a__118___object(aux_1656, scnst_ast_var);
				  }
				  if (test1542_855)
				    {	/* Module/eval.scm 112 */
				       {	/* Module/eval.scm 114 */
					  node_bglt arg1543_856;
					  arg1543_856 =
					     location__node_25_ast_sexp(
					     (global_bglt) (g_849));
					  arg1539_852 =
					     define_primop_ref__node_164_ast_sexp(
					     (global_bglt) (g_849), arg1543_856);
				       }
				    }
				  else
				    {	/* Module/eval.scm 112 */
				       arg1539_852 =
					  define_primop__node_141_ast_sexp(
					  (global_bglt) (g_849));
				    }
			       }
			  }
			  {	/* ./Ieee/pair-list.scm 5689 */
			     obj_t aux_1669;
			     aux_1669 =
				(obj_t) (arg1539_852);
			     arg1537_851 =
				MAKE_PAIR(aux_1669, init__202_840);
			  }
		       }
		       {
			  obj_t init__202_1673;
			  obj_t globals_1672;
			  globals_1672 = arg1536_850;
			  init__202_1673 = arg1537_851;
			  init__202_840 = init__202_1673;
			  globals_839 = globals_1672;
			  goto loop_841;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* set-eval-types! */
obj_t 
set_eval_types__118_module_eval(obj_t global_25)
{
   AN_OBJECT;
   {	/* Module/eval.scm 127 */
      {		/* Module/eval.scm 129 */
	 bool_t test1546_861;
	 {	/* ./Ast/var.scm 582 */
	    obj_t aux_1674;
	    {	/* Module/eval.scm 129 */
	       value_bglt aux_1675;
	       {	/* Module/eval.scm 128 */
		  global_bglt obj_1392;
		  obj_1392 =
		     (global_bglt) (global_25);
		  aux_1675 =
		     (((global_bglt) CREF(obj_1392))->value);
	       }
	       aux_1674 =
		  (obj_t) (aux_1675);
	    }
	    test1546_861 =
	       is_a__118___object(aux_1674, sfun_ast_var);
	 }
	 if (test1546_861)
	   {	/* Module/eval.scm 129 */
	      return BUNSPEC;
	   }
	 else
	   {	/* Module/eval.scm 130 */
	      type_bglt type_862;
	      {		/* Module/eval.scm 130 */
		 global_bglt obj_1394;
		 obj_1394 =
		    (global_bglt) (global_25);
		 type_862 =
		    (((global_bglt) CREF(obj_1394))->type);
	      }
	      {		/* Module/eval.scm 132 */
		 bool_t test1547_863;
		 {	/* Module/eval.scm 132 */
		    obj_t obj2_1396;
		    obj2_1396 = ____74_type_cache;
		    {	/* ./Ieee/equiv.scm 5508 */
		       obj_t aux_1683;
		       aux_1683 =
			  (obj_t) (type_862);
		       test1547_863 =
			  (aux_1683 == obj2_1396);
		    }
		 }
		 if (test1547_863)
		   {	/* Module/eval.scm 132 */
		      {		/* Module/eval.scm 133 */
			 global_bglt obj_1397;
			 type_bglt val1052_1398;
			 obj_1397 =
			    (global_bglt) (global_25);
			 val1052_1398 =
			    (type_bglt) (_obj__252_type_cache);
			 return
			    ((((global_bglt) CREF(obj_1397))->type) = ((type_bglt) val1052_1398), BUNSPEC);
		      }
		   }
		 else
		   {	/* Module/eval.scm 134 */
		      bool_t test1548_864;
		      test1548_864 =
			 bigloo_type__118_type_type(type_862);
		      if (test1548_864)
			{	/* Module/eval.scm 134 */
			   return BFALSE;
			}
		      else
			{	/* Module/eval.scm 134 */
			   {	/* ./Llib/error.scm 1110 */
			      obj_t aux_1692;
			      {		/* Module/eval.scm 137 */
				 global_bglt obj_1399;
				 obj_1399 =
				    (global_bglt) (global_25);
				 aux_1692 =
				    (((global_bglt) CREF(obj_1399))->id);
			      }
			      FAILURE(string1669_module_eval, string1670_module_eval, aux_1692);
			   }
			}
		   }
	      }
	   }
      }
   }
}



/* get-evaluated-globals */
obj_t 
get_evaluated_globals_117_module_eval()
{
   AN_OBJECT;
   {	/* Module/eval.scm 142 */
      if (_all_eval___198_module_eval)
	{	/* Module/eval.scm 144 */
	   obj_t globals_868;
	   globals_868 =
	      MAKE_CELL(BNIL);
	   {	/* Module/eval.scm 147 */
	      obj_t _anonymous_1553__118_1461;
	      _anonymous_1553__118_1461 =
		 make_fx_procedure(_anonymous_1553__118_module_eval, ((long) 1), ((long) 1));
	      PROCEDURE_SET(_anonymous_1553__118_1461, ((long) 0), globals_868);
	      for_each_global__88_ast_env(_anonymous_1553__118_1461);
	   }
	   return
	      CELL_REF(globals_868);
	}
      else
	{
	   obj_t eval_exported_68_880;
	   obj_t res_881;
	   eval_exported_68_880 = _eval_exported__84_module_eval;
	   res_881 = BNIL;
	 loop_882:
	   if (
	      NULLP(eval_exported_68_880))
	     {	/* Module/eval.scm 154 */
		return res_881;
	     }
	   else
	     {	/* Module/eval.scm 156 */
		obj_t var_module_pos_214_884;
		var_module_pos_214_884 =
		   CAR(eval_exported_68_880);
		{	/* Module/eval.scm 157 */
		   obj_t g_885;
		   {	/* Module/eval.scm 157 */
		      obj_t aux_1703;
		      {		/* ./Ieee/pair-list.scm 5701 */
			 obj_t aux_1705;
			 aux_1705 =
			    CDR(var_module_pos_214_884);
			 aux_1703 =
			    CAR(aux_1705);
		      }
		      g_885 =
			 find_global_module_25_ast_env(
			 CAR(var_module_pos_214_884), aux_1703);
		   }
		   {	/* Module/eval.scm 160 */
		      bool_t test1561_886;
		      test1561_886 =
			 is_a__118___object(g_885, global_ast_var);
		      if (test1561_886)
			{	/* Module/eval.scm 168 */
			   bool_t test1562_887;
			   if (
			      CBOOL(_lib_mode__85_engine_param))
			     {	/* Module/eval.scm 168 */
				test1562_887 = ((bool_t) 0);
			     }
			   else
			     {	/* Module/eval.scm 168 */
				global_bglt obj_1416;
				obj_1416 =
				   (global_bglt) (g_885);
				test1562_887 =
				   (((global_bglt) CREF(obj_1416))->library__255);
			     }
			   if (test1562_887)
			     {	/* Module/eval.scm 168 */
				{
				   obj_t eval_exported_68_1716;
				   eval_exported_68_1716 =
				      CDR(eval_exported_68_880);
				   eval_exported_68_880 = eval_exported_68_1716;
				   goto loop_882;
				}
			     }
			   else
			     {	/* Module/eval.scm 170 */
				bool_t test_1718;
				{	/* Module/eval.scm 170 */
				   global_bglt obj_1418;
				   obj_1418 =
				      (global_bglt) (g_885);
				   test_1718 =
				      (((global_bglt) CREF(obj_1418))->evaluable__248);
				}
				if (test_1718)
				  {	/* Module/eval.scm 170 */
				     {	/* Module/eval.scm 179 */
					obj_t arg1565_890;
					obj_t arg1566_891;
					arg1565_890 =
					   CDR(eval_exported_68_880);
					arg1566_891 =
					   MAKE_PAIR(g_885, res_881);
					{
					   obj_t res_1724;
					   obj_t eval_exported_68_1723;
					   eval_exported_68_1723 = arg1565_890;
					   res_1724 = arg1566_891;
					   res_881 = res_1724;
					   eval_exported_68_880 = eval_exported_68_1723;
					   goto loop_882;
					}
				     }
				  }
				else
				  {	/* Module/eval.scm 170 */
				     {	/* Module/eval.scm 172 */
					obj_t arg1567_892;
					obj_t arg1571_895;
					{	/* Module/eval.scm 171 */
					   obj_t aux_1725;
					   {	/* ./Ieee/pair-list.scm 5701 */
					      obj_t aux_1726;
					      {		/* ./Ieee/pair-list.scm 5707 */
						 obj_t aux_1727;
						 aux_1727 =
						    CDR(var_module_pos_214_884);
						 aux_1726 =
						    CDR(aux_1727);
					      }
					      aux_1725 =
						 CAR(aux_1726);
					   }
					   arg1567_892 =
					      find_location_120_tools_location(aux_1725);
					}
					arg1571_895 =
					   CAR(var_module_pos_214_884);
					{	/* Module/eval.scm 171 */
					   obj_t list1573_897;
					   list1573_897 =
					      MAKE_PAIR(BNIL, BNIL);
					   user_error_location_137_tools_error(arg1567_892, string1671_module_eval, string1672_module_eval, arg1571_895, list1573_897);
					}
				     }
				     {
					obj_t eval_exported_68_1735;
					eval_exported_68_1735 =
					   CDR(eval_exported_68_880);
					eval_exported_68_880 = eval_exported_68_1735;
					goto loop_882;
				     }
				  }
			     }
			}
		      else
			{	/* Module/eval.scm 160 */
			   {	/* Module/eval.scm 162 */
			      obj_t arg1578_900;
			      obj_t arg1581_903;
			      {		/* Module/eval.scm 161 */
				 obj_t aux_1737;
				 {	/* ./Ieee/pair-list.scm 5701 */
				    obj_t aux_1738;
				    {	/* ./Ieee/pair-list.scm 5707 */
				       obj_t aux_1739;
				       aux_1739 =
					  CDR(var_module_pos_214_884);
				       aux_1738 =
					  CDR(aux_1739);
				    }
				    aux_1737 =
				       CAR(aux_1738);
				 }
				 arg1578_900 =
				    find_location_120_tools_location(aux_1737);
			      }
			      arg1581_903 =
				 CAR(var_module_pos_214_884);
			      {		/* Module/eval.scm 161 */
				 obj_t list1583_905;
				 list1583_905 =
				    MAKE_PAIR(BNIL, BNIL);
				 user_error_location_137_tools_error(arg1578_900, string1671_module_eval, string1673_module_eval, arg1581_903, list1583_905);
			      }
			   }
			   {
			      obj_t eval_exported_68_1747;
			      eval_exported_68_1747 =
				 CDR(eval_exported_68_880);
			      eval_exported_68_880 = eval_exported_68_1747;
			      goto loop_882;
			   }
			}
		   }
		}
	     }
	}
   }
}



/* <anonymous:1553> */
obj_t 
_anonymous_1553__118_module_eval(obj_t env_1462, obj_t g_1464)
{
   AN_OBJECT;
   {	/* Module/eval.scm 146 */
      {		/* Module/eval.scm 147 */
	 obj_t globals_1463;
	 globals_1463 =
	    PROCEDURE_REF(env_1462, ((long) 0));
	 {
	    obj_t g_870;
	    g_870 = g_1464;
	    {	/* Module/eval.scm 147 */
	       bool_t test1554_872;
	       {	/* Module/eval.scm 147 */
		  bool_t test_1750;
		  {	/* Module/eval.scm 147 */
		     obj_t aux_1751;
		     {	/* Module/eval.scm 147 */
			obj_t aux_1752;
			{	/* Module/eval.scm 147 */
			   global_bglt obj_1403;
			   obj_1403 =
			      (global_bglt) (g_870);
			   aux_1752 =
			      (((global_bglt) CREF(obj_1403))->import);
			}
			aux_1751 =
			   memq___r4_pairs_and_lists_6_3(aux_1752,
			   CNST_TABLE_REF(((long) 10)));
		     }
		     test_1750 =
			CBOOL(aux_1751);
		  }
		  if (test_1750)
		    {	/* Module/eval.scm 148 */
		       bool_t test_1758;
		       {	/* Module/eval.scm 148 */
			  global_bglt obj_1404;
			  obj_1404 =
			     (global_bglt) (g_870);
			  test_1758 =
			     (((global_bglt) CREF(obj_1404))->evaluable__248);
		       }
		       if (test_1758)
			 {	/* Module/eval.scm 149 */
			    obj_t _ortest_1448_875;
			    _ortest_1448_875 = _lib_mode__85_engine_param;
			    if (
			       CBOOL(_ortest_1448_875))
			      {		/* Module/eval.scm 149 */
				 test1554_872 =
				    CBOOL(_ortest_1448_875);
			      }
			    else
			      {		/* Module/eval.scm 149 */
				 bool_t test_1764;
				 {	/* Module/eval.scm 149 */
				    global_bglt obj_1405;
				    obj_1405 =
				       (global_bglt) (g_870);
				    test_1764 =
				       (((global_bglt) CREF(obj_1405))->library__255);
				 }
				 if (test_1764)
				   {	/* Module/eval.scm 149 */
				      test1554_872 = ((bool_t) 0);
				   }
				 else
				   {	/* Module/eval.scm 149 */
				      test1554_872 = ((bool_t) 1);
				   }
			      }
			 }
		       else
			 {	/* Module/eval.scm 148 */
			    test1554_872 = ((bool_t) 0);
			 }
		    }
		  else
		    {	/* Module/eval.scm 147 */
		       test1554_872 = ((bool_t) 0);
		    }
	       }
	       if (test1554_872)
		 {	/* Module/eval.scm 150 */
		    obj_t aux_1465;
		    {	/* Module/eval.scm 150 */
		       obj_t obj2_1407;
		       obj2_1407 =
			  CELL_REF(globals_1463);
		       aux_1465 =
			  MAKE_PAIR(g_870, obj2_1407);
		    }
		    return
		       CELL_SET(globals_1463, aux_1465);
		 }
	       else
		 {	/* Module/eval.scm 147 */
		    return BUNSPEC;
		 }
	    }
	 }
      }
   }
}



/* method-init */
obj_t 
method_init_76_module_eval()
{
   AN_OBJECT;
   {	/* Module/eval.scm 14 */
      return BUNSPEC;
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_module_eval()
{
   AN_OBJECT;
   {	/* Module/eval.scm 14 */
      module_initialization_70_type_type(((long) 0), "MODULE_EVAL");
      module_initialization_70_ast_var(((long) 0), "MODULE_EVAL");
      module_initialization_70_ast_node(((long) 0), "MODULE_EVAL");
      module_initialization_70_module_module(((long) 0), "MODULE_EVAL");
      module_initialization_70_module_include(((long) 0), "MODULE_EVAL");
      module_initialization_70_engine_param(((long) 0), "MODULE_EVAL");
      module_initialization_70_tools_shape(((long) 0), "MODULE_EVAL");
      module_initialization_70_tools_error(((long) 0), "MODULE_EVAL");
      module_initialization_70_tools_location(((long) 0), "MODULE_EVAL");
      module_initialization_70_type_cache(((long) 0), "MODULE_EVAL");
      module_initialization_70_ast_env(((long) 0), "MODULE_EVAL");
      module_initialization_70_ast_glo_decl_237(((long) 0), "MODULE_EVAL");
      return
	 module_initialization_70_ast_sexp(((long) 0), "MODULE_EVAL");
   }
}
