/*===========================================================================*/
/*   (Module/foreign.scm)                                                    */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct ccomp
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t producer;
     obj_t consumer;
     obj_t finalizer;
     obj_t checksummer;
  }
     *ccomp_bglt;

typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct calias
  {
     bool_t array__248;
  }
      *calias_bglt;

typedef struct cenum
  {
     struct type *btype;
     obj_t literals;
  }
     *cenum_bglt;

typedef struct copaque
  {
     struct type *btype;
  }
       *copaque_bglt;

typedef struct cfunction
  {
     struct type *btype;
     long arity;
     struct type *type_res_48;
     obj_t type_args_244;
  }
         *cfunction_bglt;

typedef struct cptr
  {
     struct type *btype;
     struct type *point_to_164;
     bool_t array__248;
  }
    *cptr_bglt;

typedef struct cstruct
  {
     bool_t struct__46;
     obj_t fields;
     obj_t cstruct__170;
  }
       *cstruct_bglt;

typedef struct cstruct__170
  {
     struct type *btype;
     struct cstruct *cstruct;
  }
            *cstruct__170_bglt;


extern obj_t ccomp_module_module;
extern obj_t find_global_223_ast_env(obj_t, obj_t);
static obj_t method_init_76_module_foreign();
extern obj_t user_warning_location_190_tools_error(obj_t, obj_t, obj_t, obj_t);
extern obj_t symbol_append_197___r4_symbols_6_4(obj_t);
static obj_t foreign_producer_77_module_foreign(obj_t);
extern obj_t make_ctype_accesses__219_foreign_access(type_bglt, type_bglt, obj_t);
extern obj_t type_type_type;
static obj_t _foreign_exported__195_module_foreign = BUNSPEC;
extern obj_t user_warning_209_tools_error(obj_t, obj_t, obj_t);
extern obj_t create_struct(obj_t, long);
extern obj_t make_foreign_compiler_237_module_foreign();
extern type_bglt declare_type__118_type_env(obj_t, obj_t, obj_t);
extern obj_t global_ast_var;
extern obj_t declare_c_type__49_foreign_ctype(obj_t, obj_t, obj_t, obj_t);
extern global_bglt declare_global_cvar__13_ast_glo_decl_237(obj_t, obj_t, obj_t, bool_t, obj_t);
extern obj_t user_error_151_tools_error(obj_t, obj_t, obj_t, obj_t);
static obj_t parse_c_foreign_type_105_module_foreign(obj_t);
extern obj_t member___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern bool_t is_a__118___object(obj_t, obj_t);
extern type_bglt get_default_type_181_type_cache();
extern obj_t module_initialization_70_module_foreign(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_module_module(long, char *);
extern obj_t module_initialization_70_module_checksum(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_ast_glo_decl_237(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_env(long, char *);
extern obj_t module_initialization_70_type_tools(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_env(long, char *);
extern obj_t module_initialization_70_ast_ident(long, char *);
extern obj_t module_initialization_70_foreign_ctype(long, char *);
extern obj_t module_initialization_70_foreign_access(long, char *);
extern obj_t module_initialization_70_tools_location(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_symbols_6_4(long, char *);
extern obj_t module_initialization_70___r4_numbers_6_5(long, char *);
extern long class_num_218___object(obj_t);
extern type_bglt get_default_c_type_186_type_cache();
static obj_t extern_parser_240_module_foreign(obj_t);
static obj_t _foreign_accesses__124_module_foreign = BUNSPEC;
static obj_t imported_modules_init_94_module_foreign();
extern obj_t cstruct_foreign_ctype;
static obj_t _make_extern_compiler_52_module_foreign(obj_t);
static obj_t _foreign_finalizer_56_module_foreign(obj_t);
static obj_t extern_producer_85_module_foreign(obj_t);
extern obj_t append_2_18___r4_pairs_and_lists_6_3(obj_t, obj_t);
static obj_t library_modules_init_112_module_foreign();
static obj_t foreign_finalizer_169_module_foreign();
static obj_t _anonymous_1367__78_module_foreign(obj_t);
static obj_t _anonymous_1366__201_module_foreign(obj_t, obj_t, obj_t);
static obj_t _anonymous_1357__81_module_foreign(obj_t, obj_t, obj_t);
static obj_t toplevel_init_63_module_foreign();
extern obj_t open_input_string(obj_t);
extern global_bglt declare_global_cfun__81_ast_glo_decl_237(obj_t, obj_t, obj_t, obj_t, bool_t, bool_t, obj_t);
static obj_t parse_c_extern_type_73_module_foreign(obj_t);
static obj_t c_extern_type__c_foreign_type_30_module_foreign(obj_t);
extern obj_t parse_id_241_ast_ident(obj_t, obj_t);
static obj_t default_c_type_69_module_foreign(obj_t, obj_t);
static obj_t _extern_producer_53_module_foreign(obj_t, obj_t);
extern obj_t make_extern_compiler_102_module_foreign();
extern obj_t check_id_6_ast_ident(obj_t, obj_t);
extern obj_t _include_foreign__253_engine_param;
static bool_t check_c_foreign_type_exp__43_module_foreign(obj_t);
static obj_t foreign_parser_183_module_foreign(obj_t);
static obj_t _make_foreign_compiler_123_module_foreign(obj_t);
static bool_t check_c_args__102_module_foreign(obj_t);
extern obj_t calias_foreign_ctype;
extern obj_t read___reader(obj_t);
extern obj_t make_pointer_to_name_76_type_tools(type_bglt);
extern obj_t find_location_120_tools_location(obj_t);
static obj_t _foreign_producer_163_module_foreign(obj_t, obj_t);
static obj_t require_initialization_114_module_foreign = BUNSPEC;
static obj_t cnst_init_137_module_foreign();
extern obj_t reverse__39___r4_pairs_and_lists_6_3(obj_t);
static obj_t __cnst[20];

DEFINE_STATIC_PROCEDURE(foreign_producer_env_169_module_foreign, _foreign_producer_163_module_foreign2121, _foreign_producer_163_module_foreign, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_extern_compiler_env_153_module_foreign, _make_extern_compiler_52_module_foreign2122, _make_extern_compiler_52_module_foreign, 0L, 0);
extern obj_t exp_env_94___r4_numbers_6_5;
extern obj_t clause_checksummer_env_74_module_checksum;
DEFINE_STATIC_PROCEDURE(proc2099_module_foreign, _anonymous_1367__78_module_foreign2123, _anonymous_1367__78_module_foreign, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc2098_module_foreign, _anonymous_1357__81_module_foreign2124, _anonymous_1357__81_module_foreign, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2100_module_foreign, _anonymous_1366__201_module_foreign2125, _anonymous_1366__201_module_foreign, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_foreign_compiler_env_30_module_foreign, _make_foreign_compiler_123_module_foreign2126, _make_foreign_compiler_123_module_foreign, 0L, 0);
DEFINE_STRING(string2116_module_foreign, string2116_module_foreign2127, "UNIT UNION* STRUCT* ARRAY ENUM FUNCTION POINTER OPAQUE STRUCT UNION C * MACRO EXPORT TYPE INCLUDE INFIX VOID EXTERN FOREIGN ", 124);
DEFINE_STRING(string2115_module_foreign, string2115_module_foreign2128, "Unspecified C type, using type", 30);
DEFINE_STRING(string2114_module_foreign, string2114_module_foreign2129, "Unbound global variable", 23);
DEFINE_STRING(string2113_module_foreign, string2113_module_foreign2130, "Re-exportation of global variable (ignored)", 43);
DEFINE_STRING(string2112_module_foreign, string2112_module_foreign2131, "Foreign", 7);
DEFINE_STRING(string2111_module_foreign, string2111_module_foreign2132, "Illegal `C extern type'", 23);
DEFINE_STRING(string2109_module_foreign, string2109_module_foreign2133, "Illegal extern form", 19);
DEFINE_STRING(string2110_module_foreign, string2110_module_foreign2134, "Illegal `C foreign type'", 24);
DEFINE_STRING(string2108_module_foreign, string2108_module_foreign2135, "Illegal `variable' form", 23);
DEFINE_STRING(string2107_module_foreign, string2107_module_foreign2136, "Illegal `function' form", 23);
DEFINE_STRING(string2106_module_foreign, string2106_module_foreign2137, "Illegal `macro' form", 20);
DEFINE_STRING(string2105_module_foreign, string2105_module_foreign2138, "Illegal foreign form", 20);
DEFINE_STRING(string2104_module_foreign, string2104_module_foreign2139, "Illegal `include' clause", 24);
DEFINE_STRING(string2103_module_foreign, string2103_module_foreign2140, "Illegal `extern' clause", 23);
DEFINE_STRING(string2102_module_foreign, string2102_module_foreign2141, "Illegal `foreign' clause", 24);
DEFINE_STRING(string2101_module_foreign, string2101_module_foreign2142, "Parse error", 11);
DEFINE_STATIC_PROCEDURE(foreign_finalizer_env_182_module_foreign, _foreign_finalizer_56_module_foreign2143, _foreign_finalizer_56_module_foreign, 0L, 0);
DEFINE_STATIC_PROCEDURE(extern_producer_env_171_module_foreign, _extern_producer_53_module_foreign2144, _extern_producer_53_module_foreign, 0L, 1);



/* module-initialization */
obj_t 
module_initialization_70_module_foreign(long checksum_2935, char *from_2936)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_module_foreign))
	{
	   require_initialization_114_module_foreign =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_module_foreign();
	   cnst_init_137_module_foreign();
	   imported_modules_init_94_module_foreign();
	   method_init_76_module_foreign();
	   toplevel_init_63_module_foreign();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_module_foreign()
{
   AN_OBJECT;
   {	/* Module/foreign.scm 17 */
      module_initialization_70___r4_symbols_6_4(((long) 0), "MODULE_FOREIGN");
      module_initialization_70___r4_numbers_6_5(((long) 0), "MODULE_FOREIGN");
      module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "MODULE_FOREIGN");
      module_initialization_70___object(((long) 0), "MODULE_FOREIGN");
      module_initialization_70___reader(((long) 0), "MODULE_FOREIGN");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_module_foreign()
{
   AN_OBJECT;
   {	/* Module/foreign.scm 17 */
      {		/* Module/foreign.scm 17 */
	 obj_t cnst_port_138_2928;
	 cnst_port_138_2928 =
	    open_input_string(string2116_module_foreign);
	 {
	    long i_2929;
	    i_2929 = ((long) 19);
	  loop_2930:
	    {	/* Module/foreign.scm 17 */
	       bool_t test2117_2931;
	       test2117_2931 =
		  (i_2929 == ((long) -1));
	       if (test2117_2931)
		 {	/* Module/foreign.scm 17 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Module/foreign.scm 17 */
		    {	/* Module/foreign.scm 17 */
		       obj_t arg2118_2932;
		       {	/* Module/foreign.scm 17 */
			  obj_t list2119_2933;
			  list2119_2933 =
			     MAKE_PAIR(cnst_port_138_2928, BNIL);
			  arg2118_2932 =
			     read___reader(list2119_2933);
		       }
		       CNST_TABLE_SET(i_2929, arg2118_2932);
		    }
		    {	/* Module/foreign.scm 17 */
		       int aux_2934;
		       {	/* Module/foreign.scm 17 */
			  long aux_2956;
			  aux_2956 =
			     (i_2929 - ((long) 1));
			  aux_2934 =
			     (int) (aux_2956);
		       }
		       {
			  long i_2959;
			  i_2959 =
			     (long) (aux_2934);
			  i_2929 = i_2959;
			  goto loop_2930;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_module_foreign()
{
   AN_OBJECT;
   {	/* Module/foreign.scm 17 */
      _foreign_accesses__124_module_foreign = BNIL;
      return (
	 _foreign_exported__195_module_foreign = BNIL, BUNSPEC);
   }
}



/* make-foreign-compiler */
obj_t 
make_foreign_compiler_237_module_foreign()
{
   AN_OBJECT;
   {	/* Module/foreign.scm 42 */
      {		/* Module/foreign.scm 43 */
	 obj_t arg1348_764;
	 arg1348_764 =
	    CNST_TABLE_REF(((long) 0));
	 {	/* Module/foreign.scm 45 */
	    obj_t _anonymous_1357__81_2900;
	    _anonymous_1357__81_2900 = proc2098_module_foreign;
	    {	/* Module/foreign.scm 43 */
	       ccomp_bglt res2093_2005;
	       {	/* ./Module/module.scm 748 */
		  ccomp_bglt new1002_1996;
		  new1002_1996 =
		     ((ccomp_bglt) BREF(GC_MALLOC(sizeof(struct ccomp))));
		  {	/* ./Module/module.scm 748 */
		     long arg2091_1997;
		     arg2091_1997 =
			class_num_218___object(ccomp_module_module);
		     {	/* ./Module/module.scm 748 */
			obj_t obj_2003;
			obj_2003 =
			   (obj_t) (new1002_1996);
			(((obj_t) CREF(obj_2003))->header = MAKE_HEADER(arg2091_1997, 0), BUNSPEC);
		     }
		  }
		  {	/* ./Module/module.scm 748 */
		     object_bglt aux_2966;
		     aux_2966 =
			(object_bglt) (new1002_1996);
		     OBJECT_WIDENING_SET(aux_2966, BFALSE);
		  }
		  ((((ccomp_bglt) CREF(new1002_1996))->id) = ((obj_t) arg1348_764), BUNSPEC);
		  ((((ccomp_bglt) CREF(new1002_1996))->producer) = ((obj_t) foreign_producer_env_169_module_foreign), BUNSPEC);
		  ((((ccomp_bglt) CREF(new1002_1996))->consumer) = ((obj_t) _anonymous_1357__81_2900), BUNSPEC);
		  ((((ccomp_bglt) CREF(new1002_1996))->finalizer) = ((obj_t) foreign_finalizer_env_182_module_foreign), BUNSPEC);
		  ((((ccomp_bglt) CREF(new1002_1996))->checksummer) = ((obj_t) clause_checksummer_env_74_module_checksum), BUNSPEC);
		  res2093_2005 = new1002_1996;
	       }
	       return
		  (obj_t) (res2093_2005);
	    }
	 }
      }
   }
}



/* _make-foreign-compiler */
obj_t 
_make_foreign_compiler_123_module_foreign(obj_t env_2901)
{
   AN_OBJECT;
   {	/* Module/foreign.scm 42 */
      return
	 make_foreign_compiler_237_module_foreign();
   }
}



/* <anonymous:1357> */
obj_t 
_anonymous_1357__81_module_foreign(obj_t env_2902, obj_t m_2903, obj_t c_2904)
{
   AN_OBJECT;
   {	/* Module/foreign.scm 45 */
      {
	 obj_t m_769;
	 obj_t c_770;
	 m_769 = m_2903;
	 c_770 = c_2904;
	 return
	    foreign_producer_77_module_foreign(c_770);
      }
   }
}



/* make-extern-compiler */
obj_t 
make_extern_compiler_102_module_foreign()
{
   AN_OBJECT;
   {	/* Module/foreign.scm 52 */
      {		/* Module/foreign.scm 53 */
	 obj_t arg1358_773;
	 arg1358_773 =
	    CNST_TABLE_REF(((long) 1));
	 {	/* Module/foreign.scm 55 */
	    obj_t _anonymous_1367__78_2911;
	    obj_t _anonymous_1366__201_2912;
	    _anonymous_1367__78_2911 = proc2099_module_foreign;
	    _anonymous_1366__201_2912 = proc2100_module_foreign;
	    {	/* Module/foreign.scm 53 */
	       ccomp_bglt res2094_2018;
	       {	/* ./Module/module.scm 748 */
		  ccomp_bglt new1002_2009;
		  new1002_2009 =
		     ((ccomp_bglt) BREF(GC_MALLOC(sizeof(struct ccomp))));
		  {	/* ./Module/module.scm 748 */
		     long arg2091_2010;
		     arg2091_2010 =
			class_num_218___object(ccomp_module_module);
		     {	/* ./Module/module.scm 748 */
			obj_t obj_2016;
			obj_2016 =
			   (obj_t) (new1002_2009);
			(((obj_t) CREF(obj_2016))->header = MAKE_HEADER(arg2091_2010, 0), BUNSPEC);
		     }
		  }
		  {	/* ./Module/module.scm 748 */
		     object_bglt aux_2982;
		     aux_2982 =
			(object_bglt) (new1002_2009);
		     OBJECT_WIDENING_SET(aux_2982, BFALSE);
		  }
		  ((((ccomp_bglt) CREF(new1002_2009))->id) = ((obj_t) arg1358_773), BUNSPEC);
		  ((((ccomp_bglt) CREF(new1002_2009))->producer) = ((obj_t) extern_producer_env_171_module_foreign), BUNSPEC);
		  ((((ccomp_bglt) CREF(new1002_2009))->consumer) = ((obj_t) _anonymous_1366__201_2912), BUNSPEC);
		  ((((ccomp_bglt) CREF(new1002_2009))->finalizer) = ((obj_t) _anonymous_1367__78_2911), BUNSPEC);
		  ((((ccomp_bglt) CREF(new1002_2009))->checksummer) = ((obj_t) clause_checksummer_env_74_module_checksum), BUNSPEC);
		  res2094_2018 = new1002_2009;
	       }
	       return
		  (obj_t) (res2094_2018);
	    }
	 }
      }
   }
}



/* _make-extern-compiler */
obj_t 
_make_extern_compiler_52_module_foreign(obj_t env_2913)
{
   AN_OBJECT;
   {	/* Module/foreign.scm 52 */
      return
	 make_extern_compiler_102_module_foreign();
   }
}



/* <anonymous:1367> */
obj_t 
_anonymous_1367__78_module_foreign(obj_t env_2914)
{
   AN_OBJECT;
   {	/* ./Module/module.scm 758 */
      {

	 return
	    CNST_TABLE_REF(((long) 2));
      }
   }
}



/* <anonymous:1366> */
obj_t 
_anonymous_1366__201_module_foreign(obj_t env_2915, obj_t m_2916, obj_t c_2917)
{
   AN_OBJECT;
   {	/* Module/foreign.scm 55 */
      {
	 obj_t m_778;
	 obj_t c_779;
	 m_778 = m_2916;
	 c_779 = c_2917;
	 return
	    extern_producer_85_module_foreign(c_779);
      }
   }
}



/* foreign-producer */
obj_t 
foreign_producer_77_module_foreign(obj_t clause_19)
{
   AN_OBJECT;
   {	/* Module/foreign.scm 61 */
      {
	 obj_t protos_784;
	 if (
	    PAIRP(clause_19))
	   {	/* Module/foreign.scm 62 */
	      protos_784 =
		 CDR(clause_19);
	      {
		 obj_t l1331_790;
		 l1331_790 = protos_784;
	       lname1332_791:
		 if (
		    PAIRP(l1331_790))
		   {	/* Module/foreign.scm 64 */
		      foreign_parser_183_module_foreign(
			 CAR(l1331_790));
		      {
			 obj_t l1331_3000;
			 l1331_3000 =
			    CDR(l1331_790);
			 l1331_790 = l1331_3000;
			 goto lname1332_791;
		      }
		   }
		 else
		   {	/* Module/foreign.scm 64 */
		      ((bool_t) 1);
		   }
	      }
	      return BNIL;
	   }
	 else
	   {	/* Module/foreign.scm 62 */
	      {		/* Module/foreign.scm 67 */
		 obj_t list1373_795;
		 list1373_795 =
		    MAKE_PAIR(BNIL, BNIL);
		 return
		    user_error_151_tools_error(string2101_module_foreign, string2102_module_foreign, clause_19, list1373_795);
	      }
	   }
      }
   }
}



/* _foreign-producer */
obj_t 
_foreign_producer_163_module_foreign(obj_t env_2905, obj_t clause_2906)
{
   AN_OBJECT;
   {	/* Module/foreign.scm 61 */
      return
	 foreign_producer_77_module_foreign(clause_2906);
   }
}



/* extern-producer */
obj_t 
extern_producer_85_module_foreign(obj_t clause_20)
{
   AN_OBJECT;
   {	/* Module/foreign.scm 75 */
      {
	 obj_t protos_796;
	 if (
	    PAIRP(clause_20))
	   {	/* Module/foreign.scm 76 */
	      protos_796 =
		 CDR(clause_20);
	      {
		 obj_t l1333_802;
		 l1333_802 = protos_796;
	       lname1334_803:
		 if (
		    PAIRP(l1333_802))
		   {	/* Module/foreign.scm 78 */
		      extern_parser_240_module_foreign(
			 CAR(l1333_802));
		      {
			 obj_t l1333_3012;
			 l1333_3012 =
			    CDR(l1333_802);
			 l1333_802 = l1333_3012;
			 goto lname1334_803;
		      }
		   }
		 else
		   {	/* Module/foreign.scm 78 */
		      ((bool_t) 1);
		   }
	      }
	      return BNIL;
	   }
	 else
	   {	/* Module/foreign.scm 76 */
	      {		/* Module/foreign.scm 81 */
		 obj_t list1379_807;
		 list1379_807 =
		    MAKE_PAIR(BNIL, BNIL);
		 return
		    user_error_151_tools_error(string2101_module_foreign, string2103_module_foreign, clause_20, list1379_807);
	      }
	   }
      }
   }
}



/* _extern-producer */
obj_t 
_extern_producer_53_module_foreign(obj_t env_2918, obj_t clause_2919)
{
   AN_OBJECT;
   {	/* Module/foreign.scm 75 */
      return
	 extern_producer_85_module_foreign(clause_2919);
   }
}



/* check-c-args? */
bool_t 
check_c_args__102_module_foreign(obj_t proto_21)
{
   AN_OBJECT;
   {	/* Module/foreign.scm 89 */
      {
	 obj_t proto_808;
	 proto_808 = proto_21;
       loop_809:
	 if (
	    NULLP(proto_808))
	   {	/* Module/foreign.scm 92 */
	      return ((bool_t) 1);
	   }
	 else
	   {	/* Module/foreign.scm 92 */
	      if (
		 SYMBOLP(proto_808))
		{	/* Module/foreign.scm 94 */
		   return ((bool_t) 1);
		}
	      else
		{	/* Module/foreign.scm 94 */
		   if (
		      PAIRP(proto_808))
		     {	/* Module/foreign.scm 98 */
			bool_t test_3024;
			{	/* ./Ieee/symbol.scm 6015 */
			   obj_t aux_3025;
			   aux_3025 =
			      CAR(proto_808);
			   test_3024 =
			      SYMBOLP(aux_3025);
			}
			if (test_3024)
			  {	/* Module/foreign.scm 98 */
			     {
				obj_t proto_3028;
				proto_3028 =
				   CDR(proto_808);
				proto_808 = proto_3028;
				goto loop_809;
			     }
			  }
			else
			  {	/* Module/foreign.scm 98 */
			     return ((bool_t) 0);
			  }
		     }
		   else
		     {	/* Module/foreign.scm 96 */
			return ((bool_t) 0);
		     }
		}
	   }
      }
   }
}



/* foreign-parser */
obj_t 
foreign_parser_183_module_foreign(obj_t foreign_22)
{
   AN_OBJECT;
   {	/* Module/foreign.scm 106 */
      {
	 obj_t type_838;
	 obj_t l_name_185_839;
	 obj_t c_name_211_840;
	 obj_t type_833;
	 obj_t l_name_185_834;
	 obj_t proto_835;
	 obj_t c_name_211_836;
	 obj_t type_828;
	 obj_t l_name_185_829;
	 obj_t c_name_211_830;
	 obj_t type_823;
	 obj_t l_name_185_824;
	 obj_t proto_825;
	 obj_t c_name_211_826;
	 obj_t string_816;
	 if (
	    PAIRP(foreign_22))
	   {	/* Module/foreign.scm 108 */
	      obj_t cdr_156_22_845;
	      cdr_156_22_845 =
		 CDR(foreign_22);
	      {		/* Module/foreign.scm 108 */
		 bool_t test_3033;
		 {	/* ./Ieee/equiv.scm 5508 */
		    obj_t aux_3036;
		    obj_t aux_3034;
		    aux_3036 =
		       CNST_TABLE_REF(((long) 4));
		    aux_3034 =
		       CAR(foreign_22);
		    test_3033 =
		       (aux_3034 == aux_3036);
		 }
		 if (test_3033)
		   {	/* Module/foreign.scm 108 */
		      if (
			 PAIRP(cdr_156_22_845))
			{	/* Module/foreign.scm 108 */
			   bool_t test_3041;
			   {	/* ./Ieee/equiv.scm 5508 */
			      obj_t aux_3042;
			      aux_3042 =
				 CDR(cdr_156_22_845);
			      test_3041 =
				 (aux_3042 == BNIL);
			   }
			   if (test_3041)
			     {	/* Module/foreign.scm 108 */
				string_816 =
				   CAR(cdr_156_22_845);
				if (
				   STRINGP(string_816))
				  {	/* Module/foreign.scm 112 */
				     bool_t test1503_981;
				     {	/* Module/foreign.scm 112 */
					obj_t aux_3047;
					aux_3047 =
					   member___r4_pairs_and_lists_6_3(string_816, _include_foreign__253_engine_param);
					test1503_981 =
					   CBOOL(aux_3047);
				     }
				     if (test1503_981)
				       {	/* Module/foreign.scm 112 */
					  return BUNSPEC;
				       }
				     else
				       {	/* Module/foreign.scm 113 */
					  obj_t obj2_2177;
					  obj2_2177 = _include_foreign__253_engine_param;
					  return (
					     _include_foreign__253_engine_param =
					     MAKE_PAIR(string_816, obj2_2177), BUNSPEC);
				       }
				  }
				else
				  {	/* Module/foreign.scm 111 */
				     obj_t list1504_982;
				     list1504_982 =
					MAKE_PAIR(BNIL, BNIL);
				     return
					user_error_151_tools_error(string2101_module_foreign, string2104_module_foreign, foreign_22, list1504_982);
				  }
			     }
			   else
			     {	/* Module/foreign.scm 108 */
			      tag_139_224_822:
				{	/* Module/foreign.scm 120 */
				   obj_t list1505_983;
				   list1505_983 =
				      MAKE_PAIR(BNIL, BNIL);
				   return
				      user_error_151_tools_error(string2101_module_foreign, string2105_module_foreign, foreign_22, list1505_983);
				}
			     }
			}
		      else
			{	/* Module/foreign.scm 108 */
			   goto tag_139_224_822;
			}
		   }
		 else
		   {	/* Module/foreign.scm 108 */
		      bool_t test_3057;
		      {		/* ./Ieee/equiv.scm 5508 */
			 obj_t aux_3060;
			 obj_t aux_3058;
			 aux_3060 =
			    CNST_TABLE_REF(((long) 5));
			 aux_3058 =
			    CAR(foreign_22);
			 test_3057 =
			    (aux_3058 == aux_3060);
		      }
		      if (test_3057)
			{	/* Module/foreign.scm 108 */
			   return
			      parse_c_foreign_type_105_module_foreign(foreign_22);
			}
		      else
			{	/* Module/foreign.scm 108 */
			   bool_t test_3064;
			   {	/* ./Ieee/equiv.scm 5508 */
			      obj_t aux_3067;
			      obj_t aux_3065;
			      aux_3067 =
				 CNST_TABLE_REF(((long) 6));
			      aux_3065 =
				 CAR(foreign_22);
			      test_3064 =
				 (aux_3065 == aux_3067);
			   }
			   if (test_3064)
			     {	/* Module/foreign.scm 108 */
				if (
				   PAIRP(cdr_156_22_845))
				  {	/* Module/foreign.scm 108 */
				     obj_t cdr_218_104_857;
				     cdr_218_104_857 =
					CDR(cdr_156_22_845);
				     {	/* Module/foreign.scm 108 */
					bool_t test_3073;
					{	/* ./Ieee/symbol.scm 6015 */
					   obj_t aux_3074;
					   aux_3074 =
					      CAR(cdr_156_22_845);
					   test_3073 =
					      SYMBOLP(aux_3074);
					}
					if (test_3073)
					  {	/* Module/foreign.scm 108 */
					     if (
						PAIRP(cdr_218_104_857))
					       {	/* Module/foreign.scm 108 */
						  bool_t test_3079;
						  {	/* ./Ieee/string.scm 8047 */
						     obj_t aux_3080;
						     aux_3080 =
							CAR(cdr_218_104_857);
						     test_3079 =
							STRINGP(aux_3080);
						  }
						  if (test_3079)
						    {	/* Module/foreign.scm 108 */
						       bool_t test_3083;
						       {	/* ./Ieee/equiv.scm 5508 */
							  obj_t aux_3084;
							  aux_3084 =
							     CDR(cdr_218_104_857);
							  test_3083 =
							     (aux_3084 == BNIL);
						       }
						       if (test_3083)
							 {	/* Module/foreign.scm 117 */
							    obj_t obj2_2065;
							    obj2_2065 = _foreign_exported__195_module_foreign;
							    return (
							       _foreign_exported__195_module_foreign =
							       MAKE_PAIR(foreign_22, obj2_2065), BUNSPEC);
							 }
						       else
							 {	/* Module/foreign.scm 108 */
							    goto tag_139_224_822;
							 }
						    }
						  else
						    {	/* Module/foreign.scm 108 */
						       goto tag_139_224_822;
						    }
					       }
					     else
					       {	/* Module/foreign.scm 108 */
						  goto tag_139_224_822;
					       }
					  }
					else
					  {	/* Module/foreign.scm 108 */
					     goto tag_139_224_822;
					  }
				     }
				  }
				else
				  {	/* Module/foreign.scm 108 */
				     goto tag_139_224_822;
				  }
			     }
			   else
			     {	/* Module/foreign.scm 108 */
				bool_t test_3088;
				{	/* ./Ieee/equiv.scm 5508 */
				   obj_t aux_3091;
				   obj_t aux_3089;
				   aux_3091 =
				      CNST_TABLE_REF(((long) 7));
				   aux_3089 =
				      CAR(foreign_22);
				   test_3088 =
				      (aux_3089 == aux_3091);
				}
				if (test_3088)
				  {	/* Module/foreign.scm 108 */
				     if (
					PAIRP(cdr_156_22_845))
				       {	/* Module/foreign.scm 108 */
					  obj_t cdr_276_172_868;
					  cdr_276_172_868 =
					     CDR(cdr_156_22_845);
					  if (
					     PAIRP(cdr_276_172_868))
					    {	/* Module/foreign.scm 108 */
					       obj_t cdr_282_255_870;
					       cdr_282_255_870 =
						  CDR(cdr_276_172_868);
					       if (
						  PAIRP(cdr_282_255_870))
						 {	/* Module/foreign.scm 108 */
						    obj_t cdr_287_201_872;
						    cdr_287_201_872 =
						       CDR(cdr_282_255_870);
						    if (
						       PAIRP(cdr_287_201_872))
						      {		/* Module/foreign.scm 108 */
							 bool_t test_3105;
							 {	/* ./Ieee/equiv.scm 5508 */
							    obj_t aux_3106;
							    aux_3106 =
							       CDR(cdr_287_201_872);
							    test_3105 =
							       (aux_3106 == BNIL);
							 }
							 if (test_3105)
							   {	/* Module/foreign.scm 108 */
							      type_823 =
								 CAR(cdr_156_22_845);
							      l_name_185_824 =
								 CAR(cdr_276_172_868);
							      proto_825 =
								 CAR(cdr_282_255_870);
							      c_name_211_826 =
								 CAR(cdr_287_201_872);
							    tag_140_156_827:
							      {		/* Module/foreign.scm 123 */
								 bool_t test_3109;
								 if (
								    STRINGP(c_name_211_826))
								   {	/* Module/foreign.scm 123 */
								      if (
									 SYMBOLP(type_823))
									{	/* Module/foreign.scm 124 */
									   if (
									      SYMBOLP(l_name_185_824))
									     {	/* Module/foreign.scm 125 */
										test_3109 =
										   check_c_args__102_module_foreign(proto_825)
										   ;
									     }
									   else
									     {	/* Module/foreign.scm 125 */
										test_3109 = ((bool_t) 0)
										   ;
									     }
									}
								      else
									{	/* Module/foreign.scm 124 */
									   test_3109 = ((bool_t) 0)
									      ;
									}
								   }
								 else
								   {	/* Module/foreign.scm 123 */
								      test_3109 = ((bool_t) 0)
									 ;
								   }
								 if (test_3109)
								   {	/* Module/foreign.scm 128 */
								      global_bglt aux_3117;
								      {		/* Module/foreign.scm 128 */
									 bool_t aux_3118;
									 {	/* ./Ieee/equiv.scm 5508 */
									    obj_t aux_3121;
									    obj_t aux_3119;
									    aux_3121 =
									       CNST_TABLE_REF(((long) 3));
									    aux_3119 =
									       CAR(foreign_22);
									    aux_3118 =
									       (aux_3119 == aux_3121);
									 }
									 aux_3117 =
									    declare_global_cfun__81_ast_glo_decl_237(l_name_185_824, c_name_211_826, type_823, proto_825, aux_3118, ((bool_t) 1), foreign_22);
								      }
								      return
									 (obj_t) (aux_3117);
								   }
								 else
								   {	/* Module/foreign.scm 127 */
								      obj_t list1511_988;
								      list1511_988 =
									 MAKE_PAIR(BNIL, BNIL);
								      return
									 user_error_151_tools_error(string2101_module_foreign, string2106_module_foreign, foreign_22, list1511_988);
								   }
							      }
							   }
							 else
							   {	/* Module/foreign.scm 108 */
							    tag_142_79_832:
							      {		/* Module/foreign.scm 142 */
								 obj_t list1519_996;
								 list1519_996 =
								    MAKE_PAIR(BNIL, BNIL);
								 return
								    user_error_151_tools_error(string2101_module_foreign, string2105_module_foreign, foreign_22, list1519_996);
							      }
							   }
						      }
						    else
						      {		/* Module/foreign.scm 108 */
							 obj_t cdr_334_205_882;
							 cdr_334_205_882 =
							    CDR(cdr_156_22_845);
							 {	/* Module/foreign.scm 108 */
							    obj_t cdr_342_170_883;
							    cdr_342_170_883 =
							       CDR(cdr_334_205_882);
							    {	/* Module/foreign.scm 108 */
							       bool_t test_3136;
							       {	/* ./Ieee/equiv.scm 5508 */
								  obj_t aux_3137;
								  aux_3137 =
								     CDR(cdr_342_170_883);
								  test_3136 =
								     (aux_3137 == BNIL);
							       }
							       if (test_3136)
								 {	/* Module/foreign.scm 108 */
								    type_828 =
								       CAR(cdr_156_22_845);
								    l_name_185_829 =
								       CAR(cdr_334_205_882);
								    c_name_211_830 =
								       CAR(cdr_342_170_883);
								    {	/* Module/foreign.scm 136 */
								       bool_t test_3140;
								       if (
									  STRINGP(c_name_211_830))
									 {	/* Module/foreign.scm 136 */
									    if (
									       SYMBOLP(type_828))
									      {		/* Module/foreign.scm 137 */
										 test_3140 =
										    SYMBOLP(l_name_185_829)
										    ;
									      }
									    else
									      {		/* Module/foreign.scm 137 */
										 test_3140 = ((bool_t) 0)
										    ;
									      }
									 }
								       else
									 {	/* Module/foreign.scm 136 */
									    test_3140 = ((bool_t) 0)
									       ;
									 }
								       if (test_3140)
									 {	/* Module/foreign.scm 140 */
									    global_bglt aux_3146;
									    aux_3146 =
									       declare_global_cvar__13_ast_glo_decl_237(l_name_185_829, c_name_211_830, type_828, ((bool_t) 1), foreign_22);
									    return
									       (obj_t) (aux_3146);
									 }
								       else
									 {	/* Module/foreign.scm 139 */
									    obj_t list1516_993;
									    list1516_993 =
									       MAKE_PAIR(BNIL, BNIL);
									    return
									       user_error_151_tools_error(string2101_module_foreign, string2106_module_foreign, foreign_22, list1516_993);
									 }
								    }
								 }
							       else
								 {	/* Module/foreign.scm 108 */
								    goto tag_142_79_832;
								 }
							    }
							 }
						      }
						 }
					       else
						 {	/* Module/foreign.scm 108 */
						    goto tag_142_79_832;
						 }
					    }
					  else
					    {	/* Module/foreign.scm 108 */
					       goto tag_142_79_832;
					    }
				       }
				     else
				       {	/* Module/foreign.scm 108 */
					  goto tag_142_79_832;
				       }
				  }
				else
				  {	/* Module/foreign.scm 108 */
				     bool_t test_3154;
				     {	/* ./Ieee/equiv.scm 5508 */
					obj_t aux_3157;
					obj_t aux_3155;
					aux_3157 =
					   CNST_TABLE_REF(((long) 3));
					aux_3155 =
					   CAR(foreign_22);
					test_3154 =
					   (aux_3155 == aux_3157);
				     }
				     if (test_3154)
				       {	/* Module/foreign.scm 108 */
					  if (
					     PAIRP(cdr_156_22_845))
					    {	/* Module/foreign.scm 108 */
					       obj_t cdr_414_70_893;
					       cdr_414_70_893 =
						  CDR(cdr_156_22_845);
					       {	/* Module/foreign.scm 108 */
						  bool_t test_3163;
						  {	/* ./Ieee/equiv.scm 5508 */
						     obj_t aux_3166;
						     obj_t aux_3164;
						     aux_3166 =
							CNST_TABLE_REF(((long) 7));
						     aux_3164 =
							CAR(cdr_156_22_845);
						     test_3163 =
							(aux_3164 == aux_3166);
						  }
						  if (test_3163)
						    {	/* Module/foreign.scm 108 */
						       if (
							  PAIRP(cdr_414_70_893))
							 {	/* Module/foreign.scm 108 */
							    obj_t cdr_420_191_896;
							    cdr_420_191_896 =
							       CDR(cdr_414_70_893);
							    if (
							       PAIRP(cdr_420_191_896))
							      {		/* Module/foreign.scm 108 */
								 obj_t cdr_426_228_898;
								 cdr_426_228_898 =
								    CDR(cdr_420_191_896);
								 if (
								    PAIRP(cdr_426_228_898))
								   {	/* Module/foreign.scm 108 */
								      obj_t cdr_431_26_900;
								      cdr_431_26_900 =
									 CDR(cdr_426_228_898);
								      if (
									 PAIRP(cdr_431_26_900))
									{	/* Module/foreign.scm 108 */
									   bool_t test_3180;
									   {	/* ./Ieee/equiv.scm 5508 */
									      obj_t aux_3181;
									      aux_3181 =
										 CDR(cdr_431_26_900);
									      test_3180 =
										 (aux_3181 == BNIL);
									   }
									   if (test_3180)
									     {
										obj_t c_name_211_3190;
										obj_t proto_3188;
										obj_t l_name_185_3186;
										obj_t type_3184;
										type_3184 =
										   CAR(cdr_414_70_893);
										l_name_185_3186 =
										   CAR(cdr_420_191_896);
										proto_3188 =
										   CAR(cdr_426_228_898);
										c_name_211_3190 =
										   CAR(cdr_431_26_900);
										c_name_211_826 = c_name_211_3190;
										proto_825 = proto_3188;
										l_name_185_824 = l_name_185_3186;
										type_823 = type_3184;
										goto tag_140_156_827;
									     }
									   else
									     {	/* Module/foreign.scm 108 */
									      tag_145_198_842:
										{	/* Module/foreign.scm 163 */
										   obj_t list1529_1006;
										   list1529_1006 =
										      MAKE_PAIR(BNIL, BNIL);
										   return
										      user_error_151_tools_error(string2101_module_foreign, string2105_module_foreign, foreign_22, list1529_1006);
										}
									     }
									}
								      else
									{	/* Module/foreign.scm 108 */
									   goto tag_145_198_842;
									}
								   }
								 else
								   {	/* Module/foreign.scm 108 */
								      obj_t cdr_523_105_910;
								      cdr_523_105_910 =
									 CDR(cdr_156_22_845);
								      {		/* Module/foreign.scm 108 */
									 obj_t cdr_530_222_911;
									 cdr_530_222_911 =
									    CDR(cdr_523_105_910);
									 {	/* Module/foreign.scm 108 */
									    bool_t test_3196;
									    {	/* ./Ieee/equiv.scm 5508 */
									       obj_t aux_3197;
									       aux_3197 =
										  CDR(cdr_530_222_911);
									       test_3196 =
										  (aux_3197 == BNIL);
									    }
									    if (test_3196)
									      {		/* Module/foreign.scm 108 */
										 type_833 =
										    CAR(foreign_22);
										 l_name_185_834 =
										    CAR(cdr_156_22_845);
										 proto_835 =
										    CAR(cdr_523_105_910);
										 c_name_211_836 =
										    CAR(cdr_530_222_911);
									       tag_143_46_837:
										 {	/* Module/foreign.scm 144 */
										    bool_t test_3200;
										    if (
										       STRINGP(c_name_211_836))
										      {		/* Module/foreign.scm 144 */
											 if (
											    SYMBOLP(type_833))
											   {	/* Module/foreign.scm 145 */
											      if (
												 SYMBOLP(l_name_185_834))
												{	/* Module/foreign.scm 146 */
												   test_3200 =
												      check_c_args__102_module_foreign(proto_835)
												      ;
												}
											      else
												{	/* Module/foreign.scm 146 */
												   test_3200 = ((bool_t) 0)
												      ;
												}
											   }
											 else
											   {	/* Module/foreign.scm 145 */
											      test_3200 = ((bool_t) 0)
												 ;
											   }
										      }
										    else
										      {		/* Module/foreign.scm 144 */
											 test_3200 = ((bool_t) 0)
											    ;
										      }
										    if (test_3200)
										      {		/* Module/foreign.scm 149 */
											 global_bglt aux_3208;
											 aux_3208 =
											    declare_global_cfun__81_ast_glo_decl_237(l_name_185_834, c_name_211_836, type_833, proto_835, ((bool_t) 0), ((bool_t) 0), foreign_22);
											 return
											    (obj_t) (aux_3208);
										      }
										    else
										      {		/* Module/foreign.scm 148 */
											 obj_t list1521_998;
											 list1521_998 =
											    MAKE_PAIR(BNIL, BNIL);
											 return
											    user_error_151_tools_error(string2101_module_foreign, string2107_module_foreign, foreign_22, list1521_998);
										      }
										 }
									      }
									    else
									      {		/* Module/foreign.scm 108 */
										 goto tag_145_198_842;
									      }
									 }
								      }
								   }
							      }
							    else
							      {		/* Module/foreign.scm 108 */
								 obj_t cdr_579_43_920;
								 cdr_579_43_920 =
								    CDR(cdr_156_22_845);
								 {	/* Module/foreign.scm 108 */
								    bool_t test_3218;
								    {	/* ./Ieee/equiv.scm 5508 */
								       obj_t aux_3219;
								       aux_3219 =
									  CDR(cdr_579_43_920);
								       test_3218 =
									  (aux_3219 == BNIL);
								    }
								    if (test_3218)
								      {		/* Module/foreign.scm 108 */
									 type_838 =
									    CAR(foreign_22);
									 l_name_185_839 =
									    CAR(cdr_156_22_845);
									 c_name_211_840 =
									    CAR(cdr_579_43_920);
								       tag_144_168_841:
									 {	/* Module/foreign.scm 157 */
									    bool_t test_3222;
									    if (
									       STRINGP(c_name_211_840))
									      {		/* Module/foreign.scm 157 */
										 if (
										    SYMBOLP(type_838))
										   {	/* Module/foreign.scm 158 */
										      test_3222 =
											 SYMBOLP(l_name_185_839)
											 ;
										   }
										 else
										   {	/* Module/foreign.scm 158 */
										      test_3222 = ((bool_t) 0)
											 ;
										   }
									      }
									    else
									      {		/* Module/foreign.scm 157 */
										 test_3222 = ((bool_t) 0)
										    ;
									      }
									    if (test_3222)
									      {		/* Module/foreign.scm 161 */
										 global_bglt aux_3228;
										 aux_3228 =
										    declare_global_cvar__13_ast_glo_decl_237(l_name_185_839, c_name_211_840, type_838, ((bool_t) 0), foreign_22);
										 return
										    (obj_t) (aux_3228);
									      }
									    else
									      {		/* Module/foreign.scm 160 */
										 obj_t list1526_1003;
										 list1526_1003 =
										    MAKE_PAIR(BNIL, BNIL);
										 return
										    user_error_151_tools_error(string2101_module_foreign, string2108_module_foreign, foreign_22, list1526_1003);
									      }
									 }
								      }
								    else
								      {		/* Module/foreign.scm 108 */
									 goto tag_145_198_842;
								      }
								 }
							      }
							 }
						       else
							 {	/* Module/foreign.scm 108 */
							    goto tag_145_198_842;
							 }
						    }
						  else
						    {	/* Module/foreign.scm 108 */
						       obj_t cdr_638_125_928;
						       cdr_638_125_928 =
							  CDR(cdr_156_22_845);
						       if (
							  PAIRP(cdr_638_125_928))
							 {	/* Module/foreign.scm 108 */
							    obj_t cdr_643_163_930;
							    cdr_643_163_930 =
							       CDR(cdr_638_125_928);
							    if (
							       PAIRP(cdr_643_163_930))
							      {		/* Module/foreign.scm 108 */
								 bool_t test_3242;
								 {	/* ./Ieee/equiv.scm 5508 */
								    obj_t aux_3243;
								    aux_3243 =
								       CDR(cdr_643_163_930);
								    test_3242 =
								       (aux_3243 == BNIL);
								 }
								 if (test_3242)
								   {
								      obj_t c_name_211_3252;
								      obj_t proto_3250;
								      obj_t l_name_185_3248;
								      obj_t type_3246;
								      type_3246 =
									 CAR(foreign_22);
								      l_name_185_3248 =
									 CAR(cdr_156_22_845);
								      proto_3250 =
									 CAR(cdr_638_125_928);
								      c_name_211_3252 =
									 CAR(cdr_643_163_930);
								      c_name_211_836 = c_name_211_3252;
								      proto_835 = proto_3250;
								      l_name_185_834 = l_name_185_3248;
								      type_833 = type_3246;
								      goto tag_143_46_837;
								   }
								 else
								   {	/* Module/foreign.scm 108 */
								      goto tag_145_198_842;
								   }
							      }
							    else
							      {		/* Module/foreign.scm 108 */
								 obj_t cdr_673_88_940;
								 cdr_673_88_940 =
								    CDR(cdr_156_22_845);
								 {	/* Module/foreign.scm 108 */
								    bool_t test_3255;
								    {	/* ./Ieee/equiv.scm 5508 */
								       obj_t aux_3256;
								       aux_3256 =
									  CDR(cdr_673_88_940);
								       test_3255 =
									  (aux_3256 == BNIL);
								    }
								    if (test_3255)
								      {
									 obj_t c_name_211_3263;
									 obj_t l_name_185_3261;
									 obj_t type_3259;
									 type_3259 =
									    CAR(foreign_22);
									 l_name_185_3261 =
									    CAR(cdr_156_22_845);
									 c_name_211_3263 =
									    CAR(cdr_673_88_940);
									 c_name_211_840 = c_name_211_3263;
									 l_name_185_839 = l_name_185_3261;
									 type_838 = type_3259;
									 goto tag_144_168_841;
								      }
								    else
								      {		/* Module/foreign.scm 108 */
									 goto tag_145_198_842;
								      }
								 }
							      }
							 }
						       else
							 {	/* Module/foreign.scm 108 */
							    goto tag_145_198_842;
							 }
						    }
					       }
					    }
					  else
					    {	/* Module/foreign.scm 108 */
					       goto tag_145_198_842;
					    }
				       }
				     else
				       {	/* Module/foreign.scm 108 */
					  if (
					     PAIRP(cdr_156_22_845))
					    {	/* Module/foreign.scm 108 */
					       obj_t cdr_740_201_951;
					       cdr_740_201_951 =
						  CDR(cdr_156_22_845);
					       if (
						  PAIRP(cdr_740_201_951))
						 {	/* Module/foreign.scm 108 */
						    obj_t cdr_745_255_953;
						    cdr_745_255_953 =
						       CDR(cdr_740_201_951);
						    if (
						       PAIRP(cdr_745_255_953))
						      {		/* Module/foreign.scm 108 */
							 bool_t test_3273;
							 {	/* ./Ieee/equiv.scm 5508 */
							    obj_t aux_3274;
							    aux_3274 =
							       CDR(cdr_745_255_953);
							    test_3273 =
							       (aux_3274 == BNIL);
							 }
							 if (test_3273)
							   {
							      obj_t c_name_211_3283;
							      obj_t proto_3281;
							      obj_t l_name_185_3279;
							      obj_t type_3277;
							      type_3277 =
								 CAR(foreign_22);
							      l_name_185_3279 =
								 CAR(cdr_156_22_845);
							      proto_3281 =
								 CAR(cdr_740_201_951);
							      c_name_211_3283 =
								 CAR(cdr_745_255_953);
							      c_name_211_836 = c_name_211_3283;
							      proto_835 = proto_3281;
							      l_name_185_834 = l_name_185_3279;
							      type_833 = type_3277;
							      goto tag_143_46_837;
							   }
							 else
							   {	/* Module/foreign.scm 108 */
							      goto tag_145_198_842;
							   }
						      }
						    else
						      {		/* Module/foreign.scm 108 */
							 obj_t cdr_778_237_963;
							 cdr_778_237_963 =
							    CDR(cdr_156_22_845);
							 {	/* Module/foreign.scm 108 */
							    bool_t test_3286;
							    {	/* ./Ieee/equiv.scm 5508 */
							       obj_t aux_3287;
							       aux_3287 =
								  CDR(cdr_778_237_963);
							       test_3286 =
								  (aux_3287 == BNIL);
							    }
							    if (test_3286)
							      {
								 obj_t c_name_211_3294;
								 obj_t l_name_185_3292;
								 obj_t type_3290;
								 type_3290 =
								    CAR(foreign_22);
								 l_name_185_3292 =
								    CAR(cdr_156_22_845);
								 c_name_211_3294 =
								    CAR(cdr_778_237_963);
								 c_name_211_840 = c_name_211_3294;
								 l_name_185_839 = l_name_185_3292;
								 type_838 = type_3290;
								 goto tag_144_168_841;
							      }
							    else
							      {		/* Module/foreign.scm 108 */
								 goto tag_145_198_842;
							      }
							 }
						      }
						 }
					       else
						 {	/* Module/foreign.scm 108 */
						    goto tag_145_198_842;
						 }
					    }
					  else
					    {	/* Module/foreign.scm 108 */
					       goto tag_145_198_842;
					    }
				       }
				  }
			     }
			}
		   }
	      }
	   }
	 else
	   {	/* Module/foreign.scm 108 */
	      goto tag_145_198_842;
	   }
      }
   }
}



/* extern-parser */
obj_t 
extern_parser_240_module_foreign(obj_t extern_23)
{
   AN_OBJECT;
   {	/* Module/foreign.scm 168 */
      {
	 obj_t id_1021;
	 obj_t c_name_211_1022;
	 obj_t id_1017;
	 obj_t proto_1018;
	 obj_t cn_1019;
	 obj_t id_1013;
	 obj_t c_name_211_1014;
	 obj_t id_1009;
	 obj_t proto_1010;
	 obj_t cn_1011;
	 if (
	    PAIRP(extern_23))
	   {	/* Module/foreign.scm 170 */
	      bool_t test_3298;
	      {		/* ./Ieee/equiv.scm 5508 */
		 obj_t aux_3301;
		 obj_t aux_3299;
		 aux_3301 =
		    CNST_TABLE_REF(((long) 5));
		 aux_3299 =
		    CAR(extern_23);
		 test_3298 =
		    (aux_3299 == aux_3301);
	      }
	      if (test_3298)
		{	/* Module/foreign.scm 170 */
		   return
		      parse_c_extern_type_73_module_foreign(extern_23);
		}
	      else
		{	/* Module/foreign.scm 170 */
		   obj_t car_881_151_1028;
		   car_881_151_1028 =
		      CAR(extern_23);
		   {	/* Module/foreign.scm 170 */
		      bool_t test_3306;
		      {		/* ./Ieee/equiv.scm 5508 */
			 obj_t aux_3307;
			 aux_3307 =
			    CNST_TABLE_REF(((long) 6));
			 test_3306 =
			    (car_881_151_1028 == aux_3307);
		      }
		      if (test_3306)
			{	/* Module/foreign.scm 170 */
			   return
			      foreign_parser_183_module_foreign(extern_23);
			}
		      else
			{	/* Module/foreign.scm 170 */
			   bool_t test_3311;
			   {	/* ./Ieee/equiv.scm 5508 */
			      obj_t aux_3312;
			      aux_3312 =
				 CNST_TABLE_REF(((long) 4));
			      test_3311 =
				 (car_881_151_1028 == aux_3312);
			   }
			   if (test_3311)
			     {	/* Module/foreign.scm 170 */
				return
				   foreign_parser_183_module_foreign(extern_23);
			     }
			   else
			     {	/* Module/foreign.scm 170 */
				obj_t cdr_896_76_1031;
				cdr_896_76_1031 =
				   CDR(extern_23);
				{	/* Module/foreign.scm 170 */
				   bool_t test_3317;
				   {	/* ./Ieee/equiv.scm 5508 */
				      obj_t aux_3318;
				      aux_3318 =
					 CNST_TABLE_REF(((long) 7));
				      test_3317 =
					 (car_881_151_1028 == aux_3318);
				   }
				   if (test_3317)
				     {	/* Module/foreign.scm 170 */
					if (
					   PAIRP(cdr_896_76_1031))
					  {	/* Module/foreign.scm 170 */
					     obj_t car_900_190_1034;
					     obj_t cdr_901_152_1035;
					     car_900_190_1034 =
						CAR(cdr_896_76_1031);
					     cdr_901_152_1035 =
						CDR(cdr_896_76_1031);
					     if (
						SYMBOLP(car_900_190_1034))
					       {	/* Module/foreign.scm 170 */
						  if (
						     PAIRP(cdr_901_152_1035))
						    {	/* Module/foreign.scm 170 */
						       obj_t cdr_908_200_1038;
						       cdr_908_200_1038 =
							  CDR(cdr_901_152_1035);
						       if (
							  PAIRP(cdr_908_200_1038))
							 {	/* Module/foreign.scm 170 */
							    obj_t car_911_5_1040;
							    car_911_5_1040 =
							       CAR(cdr_908_200_1038);
							    if (
							       STRINGP(car_911_5_1040))
							      {		/* Module/foreign.scm 170 */
								 bool_t test_3335;
								 {	/* ./Ieee/equiv.scm 5508 */
								    obj_t aux_3336;
								    aux_3336 =
								       CDR(cdr_908_200_1038);
								    test_3335 =
								       (aux_3336 == BNIL);
								 }
								 if (test_3335)
								   {	/* Module/foreign.scm 170 */
								      id_1009 = car_900_190_1034;
								      proto_1010 =
									 CAR(cdr_901_152_1035);
								      cn_1011 = car_911_5_1040;
								    tag_864_33_1012:
								      {		/* Module/foreign.scm 179 */
									 obj_t pid_1175;
									 {	/* Module/foreign.scm 179 */
									    obj_t arg1640_1187;
									    arg1640_1187 =
									       find_location_120_tools_location(extern_23);
									    pid_1175 =
									       parse_id_241_ast_ident(id_1009, arg1640_1187);
									 }
									 {	/* Module/foreign.scm 179 */
									    obj_t ln_1176;
									    ln_1176 =
									       CAR(pid_1175);
									    {	/* Module/foreign.scm 180 */
									       obj_t type_1177;
									       {	/* Module/foreign.scm 181 */
										  obj_t arg1638_1185;
										  arg1638_1185 =
										     default_c_type_69_module_foreign(
										     CDR(pid_1175), extern_23);
										  {	/* Module/foreign.scm 181 */
										     type_bglt obj_2348;
										     obj_2348 =
											(type_bglt) (arg1638_1185);
										     type_1177 =
											(((type_bglt) CREF(obj_2348))->id);
										  }
									       }
									       {	/* Module/foreign.scm 181 */

										  {	/* Module/foreign.scm 182 */
										     bool_t test1632_1178;
										     {	/* Module/foreign.scm 182 */
											bool_t test1636_1183;
											{	/* Module/foreign.scm 182 */
											   obj_t x_2923;
											   x_2923 =
											      check_id_6_ast_ident(pid_1175, extern_23);
											   test1636_1183 = ((bool_t) 1);
											}
											if (test1636_1183)
											  {	/* Module/foreign.scm 182 */
											     if (
												check_c_args__102_module_foreign(proto_1010))
											       {	/* Module/foreign.scm 183 */
												  test1632_1178 = ((bool_t) 0);
											       }
											     else
											       {	/* Module/foreign.scm 183 */
												  test1632_1178 = ((bool_t) 1);
											       }
											  }
											else
											  {	/* Module/foreign.scm 182 */
											     test1632_1178 = ((bool_t) 1);
											  }
										     }
										     if (test1632_1178)
										       {	/* Module/foreign.scm 184 */
											  obj_t list1633_1179;
											  list1633_1179 =
											     MAKE_PAIR(BNIL, BNIL);
											  return
											     user_error_151_tools_error(string2101_module_foreign, string2109_module_foreign, extern_23, list1633_1179);
										       }
										     else
										       {	/* Module/foreign.scm 186 */
											  global_bglt aux_3353;
											  {	/* Module/foreign.scm 186 */
											     bool_t aux_3354;
											     {	/* ./Ieee/equiv.scm 5508 */
												obj_t aux_3357;
												obj_t aux_3355;
												aux_3357 =
												   CNST_TABLE_REF(((long) 3));
												aux_3355 =
												   CAR(extern_23);
												aux_3354 =
												   (aux_3355 == aux_3357);
											     }
											     aux_3353 =
												declare_global_cfun__81_ast_glo_decl_237(ln_1176, cn_1011, type_1177, proto_1010, aux_3354, ((bool_t) 1), extern_23);
											  }
											  return
											     (obj_t) (aux_3353);
										       }
										  }
									       }
									    }
									 }
								      }
								   }
								 else
								   {	/* Module/foreign.scm 170 */
								    tag_866_189_1016:
								      {		/* Module/foreign.scm 196 */
									 obj_t list1647_1196;
									 list1647_1196 =
									    MAKE_PAIR(BNIL, BNIL);
									 return
									    user_error_151_tools_error(string2101_module_foreign, string2109_module_foreign, extern_23, list1647_1196);
								      }
								   }
							      }
							    else
							      {		/* Module/foreign.scm 170 */
								 goto tag_866_189_1016;
							      }
							 }
						       else
							 {	/* Module/foreign.scm 170 */
							    obj_t car_963_37_1047;
							    obj_t cdr_964_146_1048;
							    car_963_37_1047 =
							       CAR(cdr_896_76_1031);
							    cdr_964_146_1048 =
							       CDR(cdr_896_76_1031);
							    if (
							       SYMBOLP(car_963_37_1047))
							      {		/* Module/foreign.scm 170 */
								 obj_t car_972_152_1050;
								 car_972_152_1050 =
								    CAR(cdr_964_146_1048);
								 if (
								    STRINGP(car_972_152_1050))
								   {	/* Module/foreign.scm 170 */
								      bool_t test_3372;
								      {		/* ./Ieee/equiv.scm 5508 */
									 obj_t aux_3373;
									 aux_3373 =
									    CDR(cdr_964_146_1048);
									 test_3372 =
									    (aux_3373 == BNIL);
								      }
								      if (test_3372)
									{	/* Module/foreign.scm 170 */
									   id_1013 = car_963_37_1047;
									   c_name_211_1014 = car_972_152_1050;
									 tag_865_4_1015:
									   {	/* Module/foreign.scm 189 */
									      obj_t pid_1188;
									      {		/* Module/foreign.scm 189 */
										 obj_t arg1646_1195;
										 arg1646_1195 =
										    find_location_120_tools_location(exp_env_94___r4_numbers_6_5);
										 pid_1188 =
										    parse_id_241_ast_ident(id_1013, arg1646_1195);
									      }
									      {		/* Module/foreign.scm 189 */
										 obj_t l_name_185_1189;
										 l_name_185_1189 =
										    CAR(pid_1188);
										 {	/* Module/foreign.scm 190 */
										    obj_t type_1190;
										    {	/* Module/foreign.scm 191 */
										       obj_t arg1643_1193;
										       arg1643_1193 =
											  default_c_type_69_module_foreign(
											  CDR(pid_1188), extern_23);
										       {	/* Module/foreign.scm 191 */
											  type_bglt obj_2354;
											  obj_2354 =
											     (type_bglt) (arg1643_1193);
											  type_1190 =
											     (((type_bglt) CREF(obj_2354))->id);
										       }
										    }
										    {	/* Module/foreign.scm 191 */

										       {	/* Module/foreign.scm 192 */
											  bool_t test1641_1191;
											  {	/* Module/foreign.scm 192 */
											     obj_t x_2924;
											     x_2924 =
												check_id_6_ast_ident(pid_1188, extern_23);
											     test1641_1191 = ((bool_t) 1);
											  }
											  if (test1641_1191)
											    {	/* Module/foreign.scm 194 */
											       global_bglt aux_3385;
											       aux_3385 =
												  declare_global_cvar__13_ast_glo_decl_237(l_name_185_1189, c_name_211_1014, type_1190, ((bool_t) 1), extern_23);
											       return
												  (obj_t) (aux_3385);
											    }
											  else
											    {	/* Module/foreign.scm 193 */
											       obj_t list1642_1192;
											       list1642_1192 =
												  MAKE_PAIR(BNIL, BNIL);
											       return
												  user_error_151_tools_error(string2101_module_foreign, string2109_module_foreign, extern_23, list1642_1192);
											    }
										       }
										    }
										 }
									      }
									   }
									}
								      else
									{	/* Module/foreign.scm 170 */
									   goto tag_866_189_1016;
									}
								   }
								 else
								   {	/* Module/foreign.scm 170 */
								      goto tag_866_189_1016;
								   }
							      }
							    else
							      {		/* Module/foreign.scm 170 */
								 goto tag_866_189_1016;
							      }
							 }
						    }
						  else
						    {	/* Module/foreign.scm 170 */
						       goto tag_866_189_1016;
						    }
					       }
					     else
					       {	/* Module/foreign.scm 170 */
						  obj_t car_1018_119_1056;
						  obj_t cdr_1019_21_1057;
						  car_1018_119_1056 =
						     CAR(cdr_896_76_1031);
						  cdr_1019_21_1057 =
						     CDR(cdr_896_76_1031);
						  if (
						     SYMBOLP(car_1018_119_1056))
						    {	/* Module/foreign.scm 170 */
						       if (
							  PAIRP(cdr_1019_21_1057))
							 {	/* Module/foreign.scm 170 */
							    obj_t car_1024_80_1060;
							    car_1024_80_1060 =
							       CAR(cdr_1019_21_1057);
							    if (
							       STRINGP(car_1024_80_1060))
							      {		/* Module/foreign.scm 170 */
								 bool_t test_3399;
								 {	/* ./Ieee/equiv.scm 5508 */
								    obj_t aux_3400;
								    aux_3400 =
								       CDR(cdr_1019_21_1057);
								    test_3399 =
								       (aux_3400 == BNIL);
								 }
								 if (test_3399)
								   {
								      obj_t c_name_211_3404;
								      obj_t id_3403;
								      id_3403 = car_1018_119_1056;
								      c_name_211_3404 = car_1024_80_1060;
								      c_name_211_1014 = c_name_211_3404;
								      id_1013 = id_3403;
								      goto tag_865_4_1015;
								   }
								 else
								   {	/* Module/foreign.scm 170 */
								      goto tag_866_189_1016;
								   }
							      }
							    else
							      {		/* Module/foreign.scm 170 */
								 goto tag_866_189_1016;
							      }
							 }
						       else
							 {	/* Module/foreign.scm 170 */
							    goto tag_866_189_1016;
							 }
						    }
						  else
						    {	/* Module/foreign.scm 170 */
						       goto tag_866_189_1016;
						    }
					       }
					  }
					else
					  {	/* Module/foreign.scm 170 */
					     goto tag_866_189_1016;
					  }
				     }
				   else
				     {	/* Module/foreign.scm 170 */
					bool_t test_3405;
					{	/* ./Ieee/equiv.scm 5508 */
					   obj_t aux_3406;
					   aux_3406 =
					      CNST_TABLE_REF(((long) 3));
					   test_3405 =
					      (car_881_151_1028 == aux_3406);
					}
					if (test_3405)
					  {	/* Module/foreign.scm 170 */
					     if (
						PAIRP(cdr_896_76_1031))
					       {	/* Module/foreign.scm 170 */
						  obj_t cdr_1067_84_1068;
						  cdr_1067_84_1068 =
						     CDR(cdr_896_76_1031);
						  {	/* Module/foreign.scm 170 */
						     bool_t test_3412;
						     {	/* ./Ieee/equiv.scm 5508 */
							obj_t aux_3415;
							obj_t aux_3413;
							aux_3415 =
							   CNST_TABLE_REF(((long) 7));
							aux_3413 =
							   CAR(cdr_896_76_1031);
							test_3412 =
							   (aux_3413 == aux_3415);
						     }
						     if (test_3412)
						       {	/* Module/foreign.scm 170 */
							  if (
							     PAIRP(cdr_1067_84_1068))
							    {	/* Module/foreign.scm 170 */
							       obj_t car_1071_20_1071;
							       obj_t cdr_1072_103_1072;
							       car_1071_20_1071 =
								  CAR(cdr_1067_84_1068);
							       cdr_1072_103_1072 =
								  CDR(cdr_1067_84_1068);
							       if (
								  SYMBOLP(car_1071_20_1071))
								 {	/* Module/foreign.scm 170 */
								    if (
								       PAIRP(cdr_1072_103_1072))
								      {		/* Module/foreign.scm 170 */
									 obj_t cdr_1079_167_1075;
									 cdr_1079_167_1075 =
									    CDR(cdr_1072_103_1072);
									 if (
									    PAIRP(cdr_1079_167_1075))
									   {	/* Module/foreign.scm 170 */
									      obj_t car_1082_234_1077;
									      car_1082_234_1077 =
										 CAR(cdr_1079_167_1075);
									      if (
										 STRINGP(car_1082_234_1077))
										{	/* Module/foreign.scm 170 */
										   bool_t test_3432;
										   {	/* ./Ieee/equiv.scm 5508 */
										      obj_t aux_3433;
										      aux_3433 =
											 CDR(cdr_1079_167_1075);
										      test_3432 =
											 (aux_3433 == BNIL);
										   }
										   if (test_3432)
										     {
											obj_t cn_3439;
											obj_t proto_3437;
											obj_t id_3436;
											id_3436 = car_1071_20_1071;
											proto_3437 =
											   CAR(cdr_1072_103_1072);
											cn_3439 = car_1082_234_1077;
											cn_1011 = cn_3439;
											proto_1010 = proto_3437;
											id_1009 = id_3436;
											goto tag_864_33_1012;
										     }
										   else
										     {	/* Module/foreign.scm 170 */
										      tag_869_166_1024:
											{	/* Module/foreign.scm 215 */
											   obj_t list1660_1215;
											   list1660_1215 =
											      MAKE_PAIR(BNIL, BNIL);
											   return
											      user_error_151_tools_error(string2101_module_foreign, string2109_module_foreign, extern_23, list1660_1215);
											}
										     }
										}
									      else
										{	/* Module/foreign.scm 170 */
										   goto tag_869_166_1024;
										}
									   }
									 else
									   {	/* Module/foreign.scm 170 */
									      goto tag_869_166_1024;
									   }
								      }
								    else
								      {		/* Module/foreign.scm 170 */
									 if (
									    SYMBOLP(car_881_151_1028))
									   {	/* Module/foreign.scm 170 */
									      obj_t cdr_1180_170_1086;
									      cdr_1180_170_1086 =
										 CDR(cdr_896_76_1031);
									      {		/* Module/foreign.scm 170 */
										 obj_t car_1184_37_1087;
										 car_1184_37_1087 =
										    CAR(cdr_1180_170_1086);
										 if (
										    STRINGP(car_1184_37_1087))
										   {	/* Module/foreign.scm 170 */
										      bool_t test_3448;
										      {		/* ./Ieee/equiv.scm 5508 */
											 obj_t aux_3449;
											 aux_3449 =
											    CDR(cdr_1180_170_1086);
											 test_3448 =
											    (aux_3449 == BNIL);
										      }
										      if (test_3448)
											{	/* Module/foreign.scm 170 */
											   id_1017 = car_881_151_1028;
											   proto_1018 =
											      CAR(cdr_896_76_1031);
											   cn_1019 = car_1184_37_1087;
											 tag_867_8_1020:
											   {	/* Module/foreign.scm 199 */
											      obj_t pid_1197;
											      {		/* Module/foreign.scm 199 */
												 obj_t arg1654_1206;
												 arg1654_1206 =
												    find_location_120_tools_location(exp_env_94___r4_numbers_6_5);
												 pid_1197 =
												    parse_id_241_ast_ident(id_1017, arg1654_1206);
											      }
											      {		/* Module/foreign.scm 199 */
												 obj_t ln_1198;
												 ln_1198 =
												    CAR(pid_1197);
												 {	/* Module/foreign.scm 200 */
												    obj_t type_1199;
												    {	/* Module/foreign.scm 201 */
												       obj_t arg1652_1204;
												       arg1652_1204 =
													  default_c_type_69_module_foreign(
													  CDR(pid_1197), extern_23);
												       {	/* Module/foreign.scm 201 */
													  type_bglt obj_2357;
													  obj_2357 =
													     (type_bglt) (arg1652_1204);
													  type_1199 =
													     (((type_bglt) CREF(obj_2357))->id);
												       }
												    }
												    {	/* Module/foreign.scm 201 */

												       {	/* Module/foreign.scm 202 */
													  bool_t test1648_1200;
													  {	/* Module/foreign.scm 202 */
													     bool_t test1650_1202;
													     {	/* Module/foreign.scm 202 */
														obj_t x_2925;
														x_2925 =
														   check_id_6_ast_ident(pid_1197, extern_23);
														test1650_1202 = ((bool_t) 1);
													     }
													     if (test1650_1202)
													       {	/* Module/foreign.scm 202 */
														  if (
														     check_c_args__102_module_foreign(proto_1018))
														    {	/* Module/foreign.scm 203 */
														       test1648_1200 = ((bool_t) 0);
														    }
														  else
														    {	/* Module/foreign.scm 203 */
														       test1648_1200 = ((bool_t) 1);
														    }
													       }
													     else
													       {	/* Module/foreign.scm 202 */
														  test1648_1200 = ((bool_t) 1);
													       }
													  }
													  if (test1648_1200)
													    {	/* Module/foreign.scm 204 */
													       obj_t list1649_1201;
													       list1649_1201 =
														  MAKE_PAIR(BNIL, BNIL);
													       return
														  user_error_151_tools_error(string2101_module_foreign, string2109_module_foreign, extern_23, list1649_1201);
													    }
													  else
													    {	/* Module/foreign.scm 205 */
													       global_bglt aux_3466;
													       aux_3466 =
														  declare_global_cfun__81_ast_glo_decl_237(ln_1198, cn_1019, type_1199, proto_1018, ((bool_t) 0), ((bool_t) 0), extern_23);
													       return
														  (obj_t) (aux_3466);
													    }
												       }
												    }
												 }
											      }
											   }
											}
										      else
											{	/* Module/foreign.scm 170 */
											   goto tag_869_166_1024;
											}
										   }
										 else
										   {	/* Module/foreign.scm 170 */
										      goto tag_869_166_1024;
										   }
									      }
									   }
									 else
									   {	/* Module/foreign.scm 170 */
									      goto tag_869_166_1024;
									   }
								      }
								 }
							       else
								 {	/* Module/foreign.scm 170 */
								    if (
								       SYMBOLP(car_881_151_1028))
								      {		/* Module/foreign.scm 170 */
									 obj_t cdr_1228_61_1096;
									 cdr_1228_61_1096 =
									    CDR(cdr_896_76_1031);
									 {	/* Module/foreign.scm 170 */
									    obj_t car_1231_190_1097;
									    car_1231_190_1097 =
									       CAR(cdr_1228_61_1096);
									    if (
									       STRINGP(car_1231_190_1097))
									      {		/* Module/foreign.scm 170 */
										 bool_t test_3476;
										 {	/* ./Ieee/equiv.scm 5508 */
										    obj_t aux_3477;
										    aux_3477 =
										       CDR(cdr_1228_61_1096);
										    test_3476 =
										       (aux_3477 == BNIL);
										 }
										 if (test_3476)
										   {
										      obj_t cn_3483;
										      obj_t proto_3481;
										      obj_t id_3480;
										      id_3480 = car_881_151_1028;
										      proto_3481 =
											 CAR(cdr_896_76_1031);
										      cn_3483 = car_1231_190_1097;
										      cn_1019 = cn_3483;
										      proto_1018 = proto_3481;
										      id_1017 = id_3480;
										      goto tag_867_8_1020;
										   }
										 else
										   {	/* Module/foreign.scm 170 */
										      goto tag_869_166_1024;
										   }
									      }
									    else
									      {		/* Module/foreign.scm 170 */
										 goto tag_869_166_1024;
									      }
									 }
								      }
								    else
								      {		/* Module/foreign.scm 170 */
									 goto tag_869_166_1024;
								      }
								 }
							    }
							  else
							    {	/* Module/foreign.scm 170 */
							       if (
								  SYMBOLP(car_881_151_1028))
								 {	/* Module/foreign.scm 170 */
								    obj_t car_1275_183_1106;
								    car_1275_183_1106 =
								       CAR(cdr_896_76_1031);
								    if (
								       STRINGP(car_1275_183_1106))
								      {		/* Module/foreign.scm 170 */
									 bool_t test_3489;
									 {	/* ./Ieee/equiv.scm 5508 */
									    obj_t aux_3490;
									    aux_3490 =
									       CDR(cdr_896_76_1031);
									    test_3489 =
									       (aux_3490 == BNIL);
									 }
									 if (test_3489)
									   {	/* Module/foreign.scm 170 */
									      id_1021 = car_881_151_1028;
									      c_name_211_1022 = car_1275_183_1106;
									    tag_868_80_1023:
									      {		/* Module/foreign.scm 208 */
										 obj_t pid_1207;
										 {	/* Module/foreign.scm 208 */
										    obj_t arg1659_1214;
										    arg1659_1214 =
										       find_location_120_tools_location(exp_env_94___r4_numbers_6_5);
										    pid_1207 =
										       parse_id_241_ast_ident(id_1021, arg1659_1214);
										 }
										 {	/* Module/foreign.scm 208 */
										    obj_t l_name_185_1208;
										    l_name_185_1208 =
										       CAR(pid_1207);
										    {	/* Module/foreign.scm 209 */
										       obj_t type_1209;
										       {	/* Module/foreign.scm 210 */
											  obj_t arg1657_1212;
											  arg1657_1212 =
											     default_c_type_69_module_foreign(
											     CDR(pid_1207), extern_23);
											  {	/* Module/foreign.scm 210 */
											     type_bglt obj_2360;
											     obj_2360 =
												(type_bglt) (arg1657_1212);
											     type_1209 =
												(((type_bglt) CREF(obj_2360))->id);
											  }
										       }
										       {	/* Module/foreign.scm 210 */

											  {	/* Module/foreign.scm 211 */
											     bool_t test1655_1210;
											     {	/* Module/foreign.scm 211 */
												obj_t x_2926;
												x_2926 =
												   check_id_6_ast_ident(pid_1207, extern_23);
												test1655_1210 = ((bool_t) 1);
											     }
											     if (test1655_1210)
											       {	/* Module/foreign.scm 213 */
												  global_bglt aux_3502;
												  aux_3502 =
												     declare_global_cvar__13_ast_glo_decl_237(l_name_185_1208, c_name_211_1022, type_1209, ((bool_t) 0), extern_23);
												  return
												     (obj_t) (aux_3502);
											       }
											     else
											       {	/* Module/foreign.scm 212 */
												  obj_t list1656_1211;
												  list1656_1211 =
												     MAKE_PAIR(BNIL, BNIL);
												  return
												     user_error_151_tools_error(string2101_module_foreign, string2109_module_foreign, extern_23, list1656_1211);
											       }
											  }
										       }
										    }
										 }
									      }
									   }
									 else
									   {	/* Module/foreign.scm 170 */
									      goto tag_869_166_1024;
									   }
								      }
								    else
								      {		/* Module/foreign.scm 170 */
									 goto tag_869_166_1024;
								      }
								 }
							       else
								 {	/* Module/foreign.scm 170 */
								    goto tag_869_166_1024;
								 }
							    }
						       }
						     else
						       {	/* Module/foreign.scm 170 */
							  if (
							     SYMBOLP(car_881_151_1028))
							    {	/* Module/foreign.scm 170 */
							       obj_t cdr_1305_252_1114;
							       cdr_1305_252_1114 =
								  CDR(cdr_896_76_1031);
							       if (
								  PAIRP(cdr_1305_252_1114))
								 {	/* Module/foreign.scm 170 */
								    obj_t car_1308_218_1116;
								    car_1308_218_1116 =
								       CAR(cdr_1305_252_1114);
								    if (
								       STRINGP(car_1308_218_1116))
								      {		/* Module/foreign.scm 170 */
									 bool_t test_3515;
									 {	/* ./Ieee/equiv.scm 5508 */
									    obj_t aux_3516;
									    aux_3516 =
									       CDR(cdr_1305_252_1114);
									    test_3515 =
									       (aux_3516 == BNIL);
									 }
									 if (test_3515)
									   {
									      obj_t cn_3522;
									      obj_t proto_3520;
									      obj_t id_3519;
									      id_3519 = car_881_151_1028;
									      proto_3520 =
										 CAR(cdr_896_76_1031);
									      cn_3522 = car_1308_218_1116;
									      cn_1019 = cn_3522;
									      proto_1018 = proto_3520;
									      id_1017 = id_3519;
									      goto tag_867_8_1020;
									   }
									 else
									   {	/* Module/foreign.scm 170 */
									      goto tag_869_166_1024;
									   }
								      }
								    else
								      {		/* Module/foreign.scm 170 */
									 goto tag_869_166_1024;
								      }
								 }
							       else
								 {	/* Module/foreign.scm 170 */
								    if (
								       SYMBOLP(car_881_151_1028))
								      {		/* Module/foreign.scm 170 */
									 obj_t car_1335_75_1125;
									 car_1335_75_1125 =
									    CAR(cdr_896_76_1031);
									 if (
									    STRINGP(car_1335_75_1125))
									   {	/* Module/foreign.scm 170 */
									      bool_t test_3528;
									      {		/* ./Ieee/equiv.scm 5508 */
										 obj_t aux_3529;
										 aux_3529 =
										    CDR(cdr_896_76_1031);
										 test_3528 =
										    (aux_3529 == BNIL);
									      }
									      if (test_3528)
										{
										   obj_t c_name_211_3533;
										   obj_t id_3532;
										   id_3532 = car_881_151_1028;
										   c_name_211_3533 = car_1335_75_1125;
										   c_name_211_1022 = c_name_211_3533;
										   id_1021 = id_3532;
										   goto tag_868_80_1023;
										}
									      else
										{	/* Module/foreign.scm 170 */
										   goto tag_869_166_1024;
										}
									   }
									 else
									   {	/* Module/foreign.scm 170 */
									      goto tag_869_166_1024;
									   }
								      }
								    else
								      {		/* Module/foreign.scm 170 */
									 goto tag_869_166_1024;
								      }
								 }
							    }
							  else
							    {	/* Module/foreign.scm 170 */
							       if (
								  SYMBOLP(car_881_151_1028))
								 {	/* Module/foreign.scm 170 */
								    obj_t car_1352_93_1133;
								    car_1352_93_1133 =
								       CAR(cdr_896_76_1031);
								    if (
								       STRINGP(car_1352_93_1133))
								      {		/* Module/foreign.scm 170 */
									 bool_t test_3539;
									 {	/* ./Ieee/equiv.scm 5508 */
									    obj_t aux_3540;
									    aux_3540 =
									       CDR(cdr_896_76_1031);
									    test_3539 =
									       (aux_3540 == BNIL);
									 }
									 if (test_3539)
									   {
									      obj_t c_name_211_3544;
									      obj_t id_3543;
									      id_3543 = car_881_151_1028;
									      c_name_211_3544 = car_1352_93_1133;
									      c_name_211_1022 = c_name_211_3544;
									      id_1021 = id_3543;
									      goto tag_868_80_1023;
									   }
									 else
									   {	/* Module/foreign.scm 170 */
									      goto tag_869_166_1024;
									   }
								      }
								    else
								      {		/* Module/foreign.scm 170 */
									 goto tag_869_166_1024;
								      }
								 }
							       else
								 {	/* Module/foreign.scm 170 */
								    goto tag_869_166_1024;
								 }
							    }
						       }
						  }
					       }
					     else
					       {	/* Module/foreign.scm 170 */
						  goto tag_869_166_1024;
					       }
					  }
					else
					  {	/* Module/foreign.scm 170 */
					     if (
						SYMBOLP(car_881_151_1028))
					       {	/* Module/foreign.scm 170 */
						  if (
						     PAIRP(cdr_896_76_1031))
						    {	/* Module/foreign.scm 170 */
						       obj_t cdr_1403_20_1144;
						       cdr_1403_20_1144 =
							  CDR(cdr_896_76_1031);
						       if (
							  PAIRP(cdr_1403_20_1144))
							 {	/* Module/foreign.scm 170 */
							    obj_t car_1406_60_1146;
							    car_1406_60_1146 =
							       CAR(cdr_1403_20_1144);
							    if (
							       STRINGP(car_1406_60_1146))
							      {		/* Module/foreign.scm 170 */
								 bool_t test_3555;
								 {	/* ./Ieee/equiv.scm 5508 */
								    obj_t aux_3556;
								    aux_3556 =
								       CDR(cdr_1403_20_1144);
								    test_3555 =
								       (aux_3556 == BNIL);
								 }
								 if (test_3555)
								   {
								      obj_t cn_3562;
								      obj_t proto_3560;
								      obj_t id_3559;
								      id_3559 = car_881_151_1028;
								      proto_3560 =
									 CAR(cdr_896_76_1031);
								      cn_3562 = car_1406_60_1146;
								      cn_1019 = cn_3562;
								      proto_1018 = proto_3560;
								      id_1017 = id_3559;
								      goto tag_867_8_1020;
								   }
								 else
								   {	/* Module/foreign.scm 170 */
								      goto tag_869_166_1024;
								   }
							      }
							    else
							      {		/* Module/foreign.scm 170 */
								 goto tag_869_166_1024;
							      }
							 }
						       else
							 {	/* Module/foreign.scm 170 */
							    if (
							       SYMBOLP(car_881_151_1028))
							      {		/* Module/foreign.scm 170 */
								 obj_t car_1438_132_1155;
								 car_1438_132_1155 =
								    CAR(cdr_896_76_1031);
								 if (
								    STRINGP(car_1438_132_1155))
								   {	/* Module/foreign.scm 170 */
								      bool_t test_3568;
								      {		/* ./Ieee/equiv.scm 5508 */
									 obj_t aux_3569;
									 aux_3569 =
									    CDR(cdr_896_76_1031);
									 test_3568 =
									    (aux_3569 == BNIL);
								      }
								      if (test_3568)
									{
									   obj_t c_name_211_3573;
									   obj_t id_3572;
									   id_3572 = car_881_151_1028;
									   c_name_211_3573 = car_1438_132_1155;
									   c_name_211_1022 = c_name_211_3573;
									   id_1021 = id_3572;
									   goto tag_868_80_1023;
									}
								      else
									{	/* Module/foreign.scm 170 */
									   goto tag_869_166_1024;
									}
								   }
								 else
								   {	/* Module/foreign.scm 170 */
								      goto tag_869_166_1024;
								   }
							      }
							    else
							      {		/* Module/foreign.scm 170 */
								 goto tag_869_166_1024;
							      }
							 }
						    }
						  else
						    {	/* Module/foreign.scm 170 */
						       goto tag_869_166_1024;
						    }
					       }
					     else
					       {	/* Module/foreign.scm 170 */
						  if (
						     SYMBOLP(car_881_151_1028))
						    {	/* Module/foreign.scm 170 */
						       if (
							  PAIRP(cdr_896_76_1031))
							 {	/* Module/foreign.scm 170 */
							    obj_t car_1460_196_1164;
							    car_1460_196_1164 =
							       CAR(cdr_896_76_1031);
							    if (
							       STRINGP(car_1460_196_1164))
							      {		/* Module/foreign.scm 170 */
								 bool_t test_3581;
								 {	/* ./Ieee/equiv.scm 5508 */
								    obj_t aux_3582;
								    aux_3582 =
								       CDR(cdr_896_76_1031);
								    test_3581 =
								       (aux_3582 == BNIL);
								 }
								 if (test_3581)
								   {
								      obj_t c_name_211_3586;
								      obj_t id_3585;
								      id_3585 = car_881_151_1028;
								      c_name_211_3586 = car_1460_196_1164;
								      c_name_211_1022 = c_name_211_3586;
								      id_1021 = id_3585;
								      goto tag_868_80_1023;
								   }
								 else
								   {	/* Module/foreign.scm 170 */
								      goto tag_869_166_1024;
								   }
							      }
							    else
							      {		/* Module/foreign.scm 170 */
								 goto tag_869_166_1024;
							      }
							 }
						       else
							 {	/* Module/foreign.scm 170 */
							    goto tag_869_166_1024;
							 }
						    }
						  else
						    {	/* Module/foreign.scm 170 */
						       goto tag_869_166_1024;
						    }
					       }
					  }
				     }
				}
			     }
			}
		   }
		}
	   }
	 else
	   {	/* Module/foreign.scm 170 */
	      goto tag_869_166_1024;
	   }
      }
   }
}



/* parse-c-foreign-type */
obj_t 
parse_c_foreign_type_105_module_foreign(obj_t type_24)
{
   AN_OBJECT;
   {	/* Module/foreign.scm 220 */
      {
	 obj_t id_1219;
	 obj_t t_exp_39_1220;
	 obj_t name_1221;
	 if (
	    PAIRP(type_24))
	   {	/* Module/foreign.scm 221 */
	      obj_t cdr_1514_50_1226;
	      cdr_1514_50_1226 =
		 CDR(type_24);
	      {		/* Module/foreign.scm 221 */
		 bool_t test_3590;
		 {	/* ./Ieee/equiv.scm 5508 */
		    obj_t aux_3593;
		    obj_t aux_3591;
		    aux_3593 =
		       CNST_TABLE_REF(((long) 5));
		    aux_3591 =
		       CAR(type_24);
		    test_3590 =
		       (aux_3591 == aux_3593);
		 }
		 if (test_3590)
		   {	/* Module/foreign.scm 221 */
		      if (
			 PAIRP(cdr_1514_50_1226))
			{	/* Module/foreign.scm 221 */
			   obj_t car_1517_237_1229;
			   obj_t cdr_1518_8_1230;
			   car_1517_237_1229 =
			      CAR(cdr_1514_50_1226);
			   cdr_1518_8_1230 =
			      CDR(cdr_1514_50_1226);
			   if (
			      SYMBOLP(car_1517_237_1229))
			     {	/* Module/foreign.scm 221 */
				if (
				   PAIRP(cdr_1518_8_1230))
				  {	/* Module/foreign.scm 221 */
				     obj_t car_1523_163_1233;
				     car_1523_163_1233 =
					CAR(cdr_1518_8_1230);
				     if (
					STRINGP(car_1523_163_1233))
				       {	/* Module/foreign.scm 221 */
					  bool_t test_3607;
					  {	/* ./Ieee/equiv.scm 5508 */
					     obj_t aux_3608;
					     aux_3608 =
						CDR(cdr_1518_8_1230);
					     test_3607 =
						(aux_3608 == BNIL);
					  }
					  if (test_3607)
					    {	/* Module/foreign.scm 223 */
					       type_bglt aux_3611;
					       aux_3611 =
						  declare_type__118_type_env(car_1517_237_1229, car_1523_163_1233,
						  CNST_TABLE_REF(((long) 9)));
					       return
						  (obj_t) (aux_3611);
					    }
					  else
					    {	/* Module/foreign.scm 221 */
					       obj_t car_1543_197_1237;
					       obj_t cdr_1544_189_1238;
					       car_1543_197_1237 =
						  CAR(cdr_1514_50_1226);
					       cdr_1544_189_1238 =
						  CDR(cdr_1514_50_1226);
					       if (
						  SYMBOLP(car_1543_197_1237))
						 {	/* Module/foreign.scm 221 */
						    obj_t cdr_1554_16_1240;
						    cdr_1554_16_1240 =
						       CDR(cdr_1544_189_1238);
						    if (
						       PAIRP(cdr_1554_16_1240))
						      {		/* Module/foreign.scm 221 */
							 obj_t car_1558_125_1242;
							 car_1558_125_1242 =
							    CAR(cdr_1554_16_1240);
							 if (
							    STRINGP(car_1558_125_1242))
							   {	/* Module/foreign.scm 221 */
							      bool_t test_3625;
							      {		/* ./Ieee/equiv.scm 5508 */
								 obj_t aux_3626;
								 aux_3626 =
								    CDR(cdr_1554_16_1240);
								 test_3625 =
								    (aux_3626 == BNIL);
							      }
							      if (test_3625)
								{	/* Module/foreign.scm 221 */
								   id_1219 = car_1543_197_1237;
								   t_exp_39_1220 =
								      CAR(cdr_1544_189_1238);
								   name_1221 = car_1558_125_1242;
								 tag_1505_107_1222:
								   if (
								      check_c_foreign_type_exp__43_module_foreign(t_exp_39_1220))
								     {	/* Module/foreign.scm 226 */
									obj_t ctype_1278;
									obj_t loc_1279;
									ctype_1278 =
									   declare_c_type__49_foreign_ctype(type_24, id_1219, t_exp_39_1220, name_1221);
									loc_1279 =
									   find_location_120_tools_location(type_24);
									{	/* Module/foreign.scm 230 */
									   bool_t test1695_1280;
									   test1695_1280 =
									      is_a__118___object(ctype_1278, type_type_type);
									   if (test1695_1280)
									     {	/* Module/foreign.scm 231 */
										obj_t accesses_1281;
										accesses_1281 =
										   make_ctype_accesses__219_foreign_access(
										   (type_bglt) (ctype_1278),
										   (type_bglt) (ctype_1278), loc_1279);
										_foreign_accesses__124_module_foreign =
										   append_2_18___r4_pairs_and_lists_6_3(accesses_1281, _foreign_accesses__124_module_foreign);
										{	/* Module/foreign.scm 237 */
										   bool_t test1696_1282;
										   {	/* Module/foreign.scm 237 */
										      bool_t test1710_1296;
										      test1710_1296 =
											 is_a__118___object(ctype_1278, calias_foreign_ctype);
										      if (test1710_1296)
											{	/* ./Foreign/ctype.scm 1694 */
											   obj_t aux_3641;
											   {	/* Module/foreign.scm 237 */
											      type_bglt obj_2417;
											      obj_2417 =
												 (type_bglt) (ctype_1278);
											      aux_3641 =
												 (((type_bglt) CREF(obj_2417))->alias);
											   }
											   test1696_1282 =
											      is_a__118___object(aux_3641, cstruct_foreign_ctype);
											}
										      else
											{	/* Module/foreign.scm 237 */
											   test1696_1282 = ((bool_t) 0);
											}
										   }
										   if (test1696_1282)
										     {	/* Module/foreign.scm 239 */
											obj_t arg1697_1283;
											{	/* Module/foreign.scm 239 */
											   obj_t arg1698_1284;
											   obj_t arg1699_1285;
											   arg1698_1284 =
											      CNST_TABLE_REF(((long) 5));
											   {	/* Module/foreign.scm 239 */
											      obj_t arg1700_1286;
											      obj_t arg1701_1287;
											      {		/* Module/foreign.scm 239 */
												 obj_t list1702_1288;
												 {	/* Module/foreign.scm 239 */
												    obj_t arg1703_1289;
												    {	/* Module/foreign.scm 239 */
												       obj_t aux_3647;
												       aux_3647 =
													  CNST_TABLE_REF(((long) 8));
												       arg1703_1289 =
													  MAKE_PAIR(aux_3647, BNIL);
												    }
												    list1702_1288 =
												       MAKE_PAIR(id_1219, arg1703_1289);
												 }
												 arg1700_1286 =
												    symbol_append_197___r4_symbols_6_4(list1702_1288);
											      }
											      {		/* Module/foreign.scm 240 */
												 obj_t arg1704_1290;
												 obj_t arg1705_1291;
												 {	/* Module/foreign.scm 240 */
												    obj_t list1706_1292;
												    {	/* Module/foreign.scm 240 */
												       obj_t arg1707_1293;
												       {	/* Module/foreign.scm 240 */
													  obj_t aux_3652;
													  aux_3652 =
													     CNST_TABLE_REF(((long) 8));
													  arg1707_1293 =
													     MAKE_PAIR(aux_3652, BNIL);
												       }
												       list1706_1292 =
													  MAKE_PAIR(t_exp_39_1220, arg1707_1293);
												    }
												    arg1704_1290 =
												       symbol_append_197___r4_symbols_6_4(list1706_1292);
												 }
												 {	/* Module/foreign.scm 241 */
												    obj_t arg1708_1294;
												    arg1708_1294 =
												       make_pointer_to_name_76_type_tools(
												       (type_bglt) (ctype_1278));
												    arg1705_1291 =
												       MAKE_PAIR(arg1708_1294, BNIL);
												 }
												 arg1701_1287 =
												    MAKE_PAIR(arg1704_1290, arg1705_1291);
											      }
											      arg1699_1285 =
												 MAKE_PAIR(arg1700_1286, arg1701_1287);
											   }
											   arg1697_1283 =
											      MAKE_PAIR(arg1698_1284, arg1699_1285);
											}
											parse_c_foreign_type_105_module_foreign(arg1697_1283);
										     }
										   else
										     {	/* Module/foreign.scm 237 */
											BUNSPEC;
										     }
										}
									     }
									   else
									     {	/* Module/foreign.scm 230 */
										BUNSPEC;
									     }
									}
									return BUNSPEC;
								     }
								   else
								     {	/* Module/foreign.scm 243 */
									obj_t list1712_1298;
									list1712_1298 =
									   MAKE_PAIR(BNIL, BNIL);
									return
									   user_error_151_tools_error(string2101_module_foreign, string2110_module_foreign, type_24, list1712_1298);
								     }
								}
							      else
								{	/* Module/foreign.scm 221 */
								 tag_1506_87_1223:
								   {	/* Module/foreign.scm 245 */
								      obj_t list1713_1299;
								      list1713_1299 =
									 MAKE_PAIR(BNIL, BNIL);
								      return
									 user_error_151_tools_error(string2101_module_foreign, string2110_module_foreign, type_24, list1713_1299);
								   }
								}
							   }
							 else
							   {	/* Module/foreign.scm 221 */
							      goto tag_1506_87_1223;
							   }
						      }
						    else
						      {		/* Module/foreign.scm 221 */
							 goto tag_1506_87_1223;
						      }
						 }
					       else
						 {	/* Module/foreign.scm 221 */
						    goto tag_1506_87_1223;
						 }
					    }
				       }
				     else
				       {	/* Module/foreign.scm 221 */
					  obj_t car_1576_193_1251;
					  obj_t cdr_1577_233_1252;
					  car_1576_193_1251 =
					     CAR(cdr_1514_50_1226);
					  cdr_1577_233_1252 =
					     CDR(cdr_1514_50_1226);
					  if (
					     SYMBOLP(car_1576_193_1251))
					    {	/* Module/foreign.scm 221 */
					       obj_t cdr_1586_162_1254;
					       cdr_1586_162_1254 =
						  CDR(cdr_1577_233_1252);
					       if (
						  PAIRP(cdr_1586_162_1254))
						 {	/* Module/foreign.scm 221 */
						    obj_t car_1589_208_1256;
						    car_1589_208_1256 =
						       CAR(cdr_1586_162_1254);
						    if (
						       STRINGP(car_1589_208_1256))
						      {		/* Module/foreign.scm 221 */
							 bool_t test_3679;
							 {	/* ./Ieee/equiv.scm 5508 */
							    obj_t aux_3680;
							    aux_3680 =
							       CDR(cdr_1586_162_1254);
							    test_3679 =
							       (aux_3680 == BNIL);
							 }
							 if (test_3679)
							   {
							      obj_t name_3686;
							      obj_t t_exp_39_3684;
							      obj_t id_3683;
							      id_3683 = car_1576_193_1251;
							      t_exp_39_3684 =
								 CAR(cdr_1577_233_1252);
							      name_3686 = car_1589_208_1256;
							      name_1221 = name_3686;
							      t_exp_39_1220 = t_exp_39_3684;
							      id_1219 = id_3683;
							      goto tag_1505_107_1222;
							   }
							 else
							   {	/* Module/foreign.scm 221 */
							      goto tag_1506_87_1223;
							   }
						      }
						    else
						      {		/* Module/foreign.scm 221 */
							 goto tag_1506_87_1223;
						      }
						 }
					       else
						 {	/* Module/foreign.scm 221 */
						    goto tag_1506_87_1223;
						 }
					    }
					  else
					    {	/* Module/foreign.scm 221 */
					       goto tag_1506_87_1223;
					    }
				       }
				  }
				else
				  {	/* Module/foreign.scm 221 */
				     goto tag_1506_87_1223;
				  }
			     }
			   else
			     {	/* Module/foreign.scm 221 */
				obj_t car_1612_95_1263;
				obj_t cdr_1613_147_1264;
				car_1612_95_1263 =
				   CAR(cdr_1514_50_1226);
				cdr_1613_147_1264 =
				   CDR(cdr_1514_50_1226);
				if (
				   SYMBOLP(car_1612_95_1263))
				  {	/* Module/foreign.scm 221 */
				     if (
					PAIRP(cdr_1613_147_1264))
				       {	/* Module/foreign.scm 221 */
					  obj_t cdr_1620_54_1267;
					  cdr_1620_54_1267 =
					     CDR(cdr_1613_147_1264);
					  if (
					     PAIRP(cdr_1620_54_1267))
					    {	/* Module/foreign.scm 221 */
					       obj_t car_1623_216_1269;
					       car_1623_216_1269 =
						  CAR(cdr_1620_54_1267);
					       if (
						  STRINGP(car_1623_216_1269))
						 {	/* Module/foreign.scm 221 */
						    bool_t test_3699;
						    {	/* ./Ieee/equiv.scm 5508 */
						       obj_t aux_3700;
						       aux_3700 =
							  CDR(cdr_1620_54_1267);
						       test_3699 =
							  (aux_3700 == BNIL);
						    }
						    if (test_3699)
						      {
							 obj_t name_3706;
							 obj_t t_exp_39_3704;
							 obj_t id_3703;
							 id_3703 = car_1612_95_1263;
							 t_exp_39_3704 =
							    CAR(cdr_1613_147_1264);
							 name_3706 = car_1623_216_1269;
							 name_1221 = name_3706;
							 t_exp_39_1220 = t_exp_39_3704;
							 id_1219 = id_3703;
							 goto tag_1505_107_1222;
						      }
						    else
						      {		/* Module/foreign.scm 221 */
							 goto tag_1506_87_1223;
						      }
						 }
					       else
						 {	/* Module/foreign.scm 221 */
						    goto tag_1506_87_1223;
						 }
					    }
					  else
					    {	/* Module/foreign.scm 221 */
					       goto tag_1506_87_1223;
					    }
				       }
				     else
				       {	/* Module/foreign.scm 221 */
					  goto tag_1506_87_1223;
				       }
				  }
				else
				  {	/* Module/foreign.scm 221 */
				     goto tag_1506_87_1223;
				  }
			     }
			}
		      else
			{	/* Module/foreign.scm 221 */
			   goto tag_1506_87_1223;
			}
		   }
		 else
		   {	/* Module/foreign.scm 221 */
		      goto tag_1506_87_1223;
		   }
	      }
	   }
	 else
	   {	/* Module/foreign.scm 221 */
	      goto tag_1506_87_1223;
	   }
      }
   }
}



/* check-c-foreign-type-exp? */
bool_t 
check_c_foreign_type_exp__43_module_foreign(obj_t t_exp_39_25)
{
   AN_OBJECT;
   {	/* Module/foreign.scm 250 */
      {
	 obj_t slots_1309;
	 obj_t slots_1301;
	 if (
	    SYMBOLP(t_exp_39_25))
	   {	/* Module/foreign.scm 251 */
	      return ((bool_t) 1);
	   }
	 else
	   {	/* Module/foreign.scm 251 */
	      if (
		 PAIRP(t_exp_39_25))
		{	/* Module/foreign.scm 251 */
		   obj_t car_1661_31_1315;
		   car_1661_31_1315 =
		      CAR(t_exp_39_25);
		   {

		      {		/* Module/foreign.scm 251 */
			 bool_t test_3712;
			 {	/* ./Ieee/equiv.scm 5508 */
			    obj_t aux_3713;
			    aux_3713 =
			       CNST_TABLE_REF(((long) 10));
			    test_3712 =
			       (car_1661_31_1315 == aux_3713);
			 }
			 if (test_3712)
			   {	/* Module/foreign.scm 251 */
			    kap_1663_160_1316:
			      slots_1301 =
				 CDR(t_exp_39_25);
			      {
				 obj_t slots_1443;
				 slots_1443 = slots_1301;
			       loop_1444:
				 if (
				    NULLP(slots_1443))
				   {	/* Module/foreign.scm 256 */
				      return ((bool_t) 1);
				   }
				 else
				   {

				      {		/* Module/foreign.scm 258 */
					 obj_t e_1915_231_1448;
					 e_1915_231_1448 =
					    CAR(slots_1443);
					 if (
					    PAIRP(e_1915_231_1448))
					   {	/* Module/foreign.scm 258 */
					      obj_t cdr_1917_17_1450;
					      cdr_1917_17_1450 =
						 CDR(e_1915_231_1448);
					      {		/* Module/foreign.scm 258 */
						 bool_t test_3722;
						 {	/* ./Ieee/symbol.scm 6015 */
						    obj_t aux_3723;
						    aux_3723 =
						       CAR(e_1915_231_1448);
						    test_3722 =
						       SYMBOLP(aux_3723);
						 }
						 if (test_3722)
						   {	/* Module/foreign.scm 258 */
						      if (
							 PAIRP(cdr_1917_17_1450))
							{	/* Module/foreign.scm 258 */
							   obj_t cdr_1919_207_1453;
							   cdr_1919_207_1453 =
							      CDR(cdr_1917_17_1450);
							   {	/* Module/foreign.scm 258 */
							      bool_t test_3729;
							      {		/* ./Ieee/symbol.scm 6015 */
								 obj_t aux_3730;
								 aux_3730 =
								    CAR(cdr_1917_17_1450);
								 test_3729 =
								    SYMBOLP(aux_3730);
							      }
							      if (test_3729)
								{	/* Module/foreign.scm 258 */
								   if (
								      PAIRP(cdr_1919_207_1453))
								     {	/* Module/foreign.scm 258 */
									bool_t test_3735;
									{	/* ./Ieee/string.scm 8047 */
									   obj_t aux_3736;
									   aux_3736 =
									      CAR(cdr_1919_207_1453);
									   test_3735 =
									      STRINGP(aux_3736);
									}
									if (test_3735)
									  {	/* Module/foreign.scm 258 */
									     bool_t test_3739;
									     {	/* ./Ieee/equiv.scm 5508 */
										obj_t aux_3740;
										aux_3740 =
										   CDR(cdr_1919_207_1453);
										test_3739 =
										   (aux_3740 == BNIL);
									     }
									     if (test_3739)
									       {	/* Module/foreign.scm 258 */
										  {
										     obj_t slots_3743;
										     slots_3743 =
											CDR(slots_1443);
										     slots_1443 = slots_3743;
										     goto loop_1444;
										  }
									       }
									     else
									       {	/* Module/foreign.scm 258 */
										  return ((bool_t) 0);
									       }
									  }
									else
									  {	/* Module/foreign.scm 258 */
									     return ((bool_t) 0);
									  }
								     }
								   else
								     {	/* Module/foreign.scm 258 */
									return ((bool_t) 0);
								     }
								}
							      else
								{	/* Module/foreign.scm 258 */
								   return ((bool_t) 0);
								}
							   }
							}
						      else
							{	/* Module/foreign.scm 258 */
							   return ((bool_t) 0);
							}
						   }
						 else
						   {	/* Module/foreign.scm 258 */
						      return ((bool_t) 0);
						   }
					      }
					   }
					 else
					   {	/* Module/foreign.scm 258 */
					      return ((bool_t) 0);
					   }
				      }
				   }
			      }
			   }
			 else
			   {	/* Module/foreign.scm 251 */
			      bool_t test_3746;
			      {		/* ./Ieee/equiv.scm 5508 */
				 obj_t aux_3747;
				 aux_3747 =
				    CNST_TABLE_REF(((long) 11));
				 test_3746 =
				    (car_1661_31_1315 == aux_3747);
			      }
			      if (test_3746)
				{	/* Module/foreign.scm 251 */
				   goto kap_1663_160_1316;
				}
			      else
				{	/* Module/foreign.scm 251 */
				   bool_t test_3750;
				   {	/* ./Ieee/equiv.scm 5508 */
				      obj_t aux_3751;
				      aux_3751 =
					 CNST_TABLE_REF(((long) 12));
				      test_3750 =
					 (car_1661_31_1315 == aux_3751);
				   }
				   if (test_3750)
				     {	/* Module/foreign.scm 251 */
					bool_t test_3754;
					{	/* ./Ieee/equiv.scm 5508 */
					   obj_t aux_3755;
					   aux_3755 =
					      CDR(t_exp_39_25);
					   test_3754 =
					      (aux_3755 == BNIL);
					}
					if (test_3754)
					  {	/* Module/foreign.scm 251 */
					     return ((bool_t) 1);
					  }
					else
					  {	/* Module/foreign.scm 251 */
					     return ((bool_t) 0);
					  }
				     }
				   else
				     {	/* Module/foreign.scm 251 */
					obj_t cdr_1709_93_1331;
					cdr_1709_93_1331 =
					   CDR(t_exp_39_25);
					{	/* Module/foreign.scm 251 */
					   bool_t test_3759;
					   {	/* ./Ieee/equiv.scm 5508 */
					      obj_t aux_3760;
					      aux_3760 =
						 CNST_TABLE_REF(((long) 13));
					      test_3759 =
						 (car_1661_31_1315 == aux_3760);
					   }
					   if (test_3759)
					     {	/* Module/foreign.scm 251 */
						if (
						   PAIRP(cdr_1709_93_1331))
						  {	/* Module/foreign.scm 251 */
						     bool_t test_3765;
						     {	/* ./Ieee/symbol.scm 6015 */
							obj_t aux_3766;
							aux_3766 =
							   CAR(cdr_1709_93_1331);
							test_3765 =
							   SYMBOLP(aux_3766);
						     }
						     if (test_3765)
						       {	/* Module/foreign.scm 251 */
							  bool_t test_3769;
							  {	/* ./Ieee/equiv.scm 5508 */
							     obj_t aux_3770;
							     aux_3770 =
								CDR(cdr_1709_93_1331);
							     test_3769 =
								(aux_3770 == BNIL);
							  }
							  if (test_3769)
							    {	/* Module/foreign.scm 251 */
							       return ((bool_t) 1);
							    }
							  else
							    {	/* Module/foreign.scm 251 */
							       return ((bool_t) 0);
							    }
						       }
						     else
						       {	/* Module/foreign.scm 251 */
							  return ((bool_t) 0);
						       }
						  }
						else
						  {	/* Module/foreign.scm 251 */
						     return ((bool_t) 0);
						  }
					     }
					   else
					     {

						{	/* Module/foreign.scm 251 */
						   bool_t test_3773;
						   {	/* ./Ieee/equiv.scm 5508 */
						      obj_t aux_3774;
						      aux_3774 =
							 CNST_TABLE_REF(((long) 17));
						      test_3773 =
							 (car_1661_31_1315 == aux_3774);
						   }
						   if (test_3773)
						     {	/* Module/foreign.scm 251 */
						      kap_1762_75_1348:
							if (
							   PAIRP(cdr_1709_93_1331))
							  {	/* Module/foreign.scm 251 */
							     bool_t test_3779;
							     {	/* ./Ieee/symbol.scm 6015 */
								obj_t aux_3780;
								aux_3780 =
								   CAR(cdr_1709_93_1331);
								test_3779 =
								   SYMBOLP(aux_3780);
							     }
							     if (test_3779)
							       {	/* Module/foreign.scm 251 */
								  bool_t test_3783;
								  {	/* ./Ieee/equiv.scm 5508 */
								     obj_t aux_3784;
								     aux_3784 =
									CDR(cdr_1709_93_1331);
								     test_3783 =
									(aux_3784 == BNIL);
								  }
								  if (test_3783)
								    {	/* Module/foreign.scm 251 */
								       return ((bool_t) 1);
								    }
								  else
								    {	/* Module/foreign.scm 251 */
								       obj_t cdr_1771_233_1384;
								       cdr_1771_233_1384 =
									  CDR(t_exp_39_25);
								       {	/* Module/foreign.scm 251 */
									  bool_t test_3788;
									  {	/* ./Ieee/equiv.scm 5508 */
									     obj_t aux_3791;
									     obj_t aux_3789;
									     aux_3791 =
										CNST_TABLE_REF(((long) 14));
									     aux_3789 =
										CAR(t_exp_39_25);
									     test_3788 =
										(aux_3789 == aux_3791);
									  }
									  if (test_3788)
									    {	/* Module/foreign.scm 251 */
									       obj_t cdr_1774_138_1386;
									       cdr_1774_138_1386 =
										  CDR(cdr_1771_233_1384);
									       {	/* Module/foreign.scm 251 */
										  bool_t test_3795;
										  {	/* ./Ieee/symbol.scm 6015 */
										     obj_t aux_3796;
										     aux_3796 =
											CAR(cdr_1771_233_1384);
										     test_3795 =
											SYMBOLP(aux_3796);
										  }
										  if (test_3795)
										    {	/* Module/foreign.scm 251 */
										       if (
											  PAIRP(cdr_1774_138_1386))
											 {	/* Module/foreign.scm 251 */
											    obj_t car_1776_237_1389;
											    car_1776_237_1389 =
											       CAR(cdr_1774_138_1386);
											    {

											       if (
												  (car_1776_237_1389 == BNIL))
												 {	/* Module/foreign.scm 251 */
												  kap_1780_110_1390:
												    {	/* Module/foreign.scm 251 */
												       bool_t test_3804;
												       {	/* ./Ieee/equiv.scm 5508 */
													  obj_t aux_3805;
													  aux_3805 =
													     CDR(cdr_1774_138_1386);
													  test_3804 =
													     (aux_3805 == BNIL);
												       }
												       if (test_3804)
													 {	/* Module/foreign.scm 251 */
													    return
													       check_c_args__102_module_foreign(car_1776_237_1389);
													 }
												       else
													 {	/* Module/foreign.scm 251 */
													    return ((bool_t) 0);
													 }
												    }
												 }
											       else
												 {	/* Module/foreign.scm 251 */
												    if (
												       PAIRP(car_1776_237_1389))
												      {		/* Module/foreign.scm 251 */
													 goto kap_1780_110_1390;
												      }
												    else
												      {		/* Module/foreign.scm 251 */
													 return ((bool_t) 0);
												      }
												 }
											    }
											 }
										       else
											 {	/* Module/foreign.scm 251 */
											    return ((bool_t) 0);
											 }
										    }
										  else
										    {	/* Module/foreign.scm 251 */
										       return ((bool_t) 0);
										    }
									       }
									    }
									  else
									    {	/* Module/foreign.scm 251 */
									       bool_t test_3811;
									       {	/* ./Ieee/equiv.scm 5508 */
										  obj_t aux_3814;
										  obj_t aux_3812;
										  aux_3814 =
										     CNST_TABLE_REF(((long) 15));
										  aux_3812 =
										     CAR(t_exp_39_25);
										  test_3811 =
										     (aux_3812 == aux_3814);
									       }
									       if (test_3811)
										 {	/* Module/foreign.scm 251 */
										    slots_1309 = cdr_1771_233_1384;
										  tag_1653_46_1310:
										    {
										       obj_t slots_1464;
										       slots_1464 = slots_1309;
										     loop_1465:
										       if (
											  NULLP(slots_1464))
											 {	/* Module/foreign.scm 275 */
											    return ((bool_t) 1);
											 }
										       else
											 {

											    {	/* Module/foreign.scm 277 */
											       obj_t e_1924_229_1469;
											       e_1924_229_1469 =
												  CAR(slots_1464);
											       if (
												  PAIRP(e_1924_229_1469))
												 {	/* Module/foreign.scm 277 */
												    obj_t cdr_1926_86_1471;
												    cdr_1926_86_1471 =
												       CDR(e_1924_229_1469);
												    {	/* Module/foreign.scm 277 */
												       bool_t test_3823;
												       {	/* ./Ieee/symbol.scm 6015 */
													  obj_t aux_3824;
													  aux_3824 =
													     CAR(e_1924_229_1469);
													  test_3823 =
													     SYMBOLP(aux_3824);
												       }
												       if (test_3823)
													 {	/* Module/foreign.scm 277 */
													    if (
													       PAIRP(cdr_1926_86_1471))
													      {		/* Module/foreign.scm 277 */
														 bool_t test_3829;
														 {	/* ./Ieee/string.scm 8047 */
														    obj_t aux_3830;
														    aux_3830 =
														       CAR(cdr_1926_86_1471);
														    test_3829 =
														       STRINGP(aux_3830);
														 }
														 if (test_3829)
														   {	/* Module/foreign.scm 277 */
														      bool_t test_3833;
														      {		/* ./Ieee/equiv.scm 5508 */
															 obj_t aux_3834;
															 aux_3834 =
															    CDR(cdr_1926_86_1471);
															 test_3833 =
															    (aux_3834 == BNIL);
														      }
														      if (test_3833)
															{	/* Module/foreign.scm 277 */
															   {
															      obj_t slots_3837;
															      slots_3837 =
																 CDR(slots_1464);
															      slots_1464 = slots_3837;
															      goto loop_1465;
															   }
															}
														      else
															{	/* Module/foreign.scm 277 */
															   return ((bool_t) 0);
															}
														   }
														 else
														   {	/* Module/foreign.scm 277 */
														      return ((bool_t) 0);
														   }
													      }
													    else
													      {		/* Module/foreign.scm 277 */
														 return ((bool_t) 0);
													      }
													 }
												       else
													 {	/* Module/foreign.scm 277 */
													    return ((bool_t) 0);
													 }
												    }
												 }
											       else
												 {	/* Module/foreign.scm 277 */
												    return ((bool_t) 0);
												 }
											    }
											 }
										    }
										 }
									       else
										 {	/* Module/foreign.scm 251 */
										    return ((bool_t) 0);
										 }
									    }
								       }
								    }
							       }
							     else
							       {	/* Module/foreign.scm 251 */
								  obj_t cdr_1798_99_1405;
								  cdr_1798_99_1405 =
								     CDR(t_exp_39_25);
								  {	/* Module/foreign.scm 251 */
								     bool_t test_3840;
								     {	/* ./Ieee/equiv.scm 5508 */
									obj_t aux_3843;
									obj_t aux_3841;
									aux_3843 =
									   CNST_TABLE_REF(((long) 16));
									aux_3841 =
									   CAR(t_exp_39_25);
									test_3840 =
									   (aux_3841 == aux_3843);
								     }
								     if (test_3840)
								       {	/* Module/foreign.scm 251 */
									  bool_t test_3846;
									  {	/* ./Ieee/symbol.scm 6015 */
									     obj_t aux_3847;
									     aux_3847 =
										CAR(cdr_1798_99_1405);
									     test_3846 =
										SYMBOLP(aux_3847);
									  }
									  if (test_3846)
									    {	/* Module/foreign.scm 251 */
									       bool_t test_3850;
									       {	/* ./Ieee/equiv.scm 5508 */
										  obj_t aux_3851;
										  aux_3851 =
										     CDR(cdr_1798_99_1405);
										  test_3850 =
										     (aux_3851 == BNIL);
									       }
									       if (test_3850)
										 {	/* Module/foreign.scm 251 */
										    return ((bool_t) 1);
										 }
									       else
										 {	/* Module/foreign.scm 251 */
										    return ((bool_t) 0);
										 }
									    }
									  else
									    {	/* Module/foreign.scm 251 */
									       return ((bool_t) 0);
									    }
								       }
								     else
								       {	/* Module/foreign.scm 251 */
									  bool_t test_3854;
									  {	/* ./Ieee/equiv.scm 5508 */
									     obj_t aux_3857;
									     obj_t aux_3855;
									     aux_3857 =
										CNST_TABLE_REF(((long) 14));
									     aux_3855 =
										CAR(t_exp_39_25);
									     test_3854 =
										(aux_3855 == aux_3857);
									  }
									  if (test_3854)
									    {	/* Module/foreign.scm 251 */
									       obj_t cdr_1818_115_1414;
									       cdr_1818_115_1414 =
										  CDR(cdr_1798_99_1405);
									       {	/* Module/foreign.scm 251 */
										  bool_t test_3861;
										  {	/* ./Ieee/symbol.scm 6015 */
										     obj_t aux_3862;
										     aux_3862 =
											CAR(cdr_1798_99_1405);
										     test_3861 =
											SYMBOLP(aux_3862);
										  }
										  if (test_3861)
										    {	/* Module/foreign.scm 251 */
										       if (
											  PAIRP(cdr_1818_115_1414))
											 {	/* Module/foreign.scm 251 */
											    obj_t car_1820_80_1417;
											    car_1820_80_1417 =
											       CAR(cdr_1818_115_1414);
											    {

											       if (
												  (car_1820_80_1417 == BNIL))
												 {	/* Module/foreign.scm 251 */
												  kap_1824_242_1418:
												    {	/* Module/foreign.scm 251 */
												       bool_t test_3870;
												       {	/* ./Ieee/equiv.scm 5508 */
													  obj_t aux_3871;
													  aux_3871 =
													     CDR(cdr_1818_115_1414);
													  test_3870 =
													     (aux_3871 == BNIL);
												       }
												       if (test_3870)
													 {	/* Module/foreign.scm 251 */
													    return
													       check_c_args__102_module_foreign(car_1820_80_1417);
													 }
												       else
													 {	/* Module/foreign.scm 251 */
													    return ((bool_t) 0);
													 }
												    }
												 }
											       else
												 {	/* Module/foreign.scm 251 */
												    if (
												       PAIRP(car_1820_80_1417))
												      {		/* Module/foreign.scm 251 */
													 goto kap_1824_242_1418;
												      }
												    else
												      {		/* Module/foreign.scm 251 */
													 return ((bool_t) 0);
												      }
												 }
											    }
											 }
										       else
											 {	/* Module/foreign.scm 251 */
											    return ((bool_t) 0);
											 }
										    }
										  else
										    {	/* Module/foreign.scm 251 */
										       return ((bool_t) 0);
										    }
									       }
									    }
									  else
									    {	/* Module/foreign.scm 251 */
									       bool_t test_3877;
									       {	/* ./Ieee/equiv.scm 5508 */
										  obj_t aux_3880;
										  obj_t aux_3878;
										  aux_3880 =
										     CNST_TABLE_REF(((long) 15));
										  aux_3878 =
										     CAR(t_exp_39_25);
										  test_3877 =
										     (aux_3878 == aux_3880);
									       }
									       if (test_3877)
										 {
										    obj_t slots_3883;
										    slots_3883 = cdr_1798_99_1405;
										    slots_1309 = slots_3883;
										    goto tag_1653_46_1310;
										 }
									       else
										 {	/* Module/foreign.scm 251 */
										    return ((bool_t) 0);
										 }
									    }
								       }
								  }
							       }
							  }
							else
							  {	/* Module/foreign.scm 251 */
							     bool_t test_3884;
							     {	/* ./Ieee/equiv.scm 5508 */
								obj_t aux_3887;
								obj_t aux_3885;
								aux_3887 =
								   CNST_TABLE_REF(((long) 15));
								aux_3885 =
								   CAR(t_exp_39_25);
								test_3884 =
								   (aux_3885 == aux_3887);
							     }
							     if (test_3884)
							       {
								  obj_t slots_3890;
								  slots_3890 =
								     CDR(t_exp_39_25);
								  slots_1309 = slots_3890;
								  goto tag_1653_46_1310;
							       }
							     else
							       {	/* Module/foreign.scm 251 */
								  return ((bool_t) 0);
							       }
							  }
						     }
						   else
						     {	/* Module/foreign.scm 251 */
							bool_t test_3892;
							{	/* ./Ieee/equiv.scm 5508 */
							   obj_t aux_3893;
							   aux_3893 =
							      CNST_TABLE_REF(((long) 18));
							   test_3892 =
							      (car_1661_31_1315 == aux_3893);
							}
							if (test_3892)
							  {	/* Module/foreign.scm 251 */
							     goto kap_1762_75_1348;
							  }
							else
							  {	/* Module/foreign.scm 251 */
							     bool_t test_3896;
							     {	/* ./Ieee/equiv.scm 5508 */
								obj_t aux_3897;
								aux_3897 =
								   CNST_TABLE_REF(((long) 16));
								test_3896 =
								   (car_1661_31_1315 == aux_3897);
							     }
							     if (test_3896)
							       {	/* Module/foreign.scm 251 */
								  if (
								     PAIRP(cdr_1709_93_1331))
								    {	/* Module/foreign.scm 251 */
								       bool_t test_3902;
								       {	/* ./Ieee/symbol.scm 6015 */
									  obj_t aux_3903;
									  aux_3903 =
									     CAR(cdr_1709_93_1331);
									  test_3902 =
									     SYMBOLP(aux_3903);
								       }
								       if (test_3902)
									 {	/* Module/foreign.scm 251 */
									    bool_t test_3906;
									    {	/* ./Ieee/equiv.scm 5508 */
									       obj_t aux_3907;
									       aux_3907 =
										  CDR(cdr_1709_93_1331);
									       test_3906 =
										  (aux_3907 == BNIL);
									    }
									    if (test_3906)
									      {		/* Module/foreign.scm 251 */
										 return ((bool_t) 1);
									      }
									    else
									      {		/* Module/foreign.scm 251 */
										 return ((bool_t) 0);
									      }
									 }
								       else
									 {	/* Module/foreign.scm 251 */
									    return ((bool_t) 0);
									 }
								    }
								  else
								    {	/* Module/foreign.scm 251 */
								       return ((bool_t) 0);
								    }
							       }
							     else
							       {	/* Module/foreign.scm 251 */
								  bool_t test_3910;
								  {	/* ./Ieee/equiv.scm 5508 */
								     obj_t aux_3911;
								     aux_3911 =
									CNST_TABLE_REF(((long) 14));
								     test_3910 =
									(car_1661_31_1315 == aux_3911);
								  }
								  if (test_3910)
								    {	/* Module/foreign.scm 251 */
								       if (
									  PAIRP(cdr_1709_93_1331))
									 {	/* Module/foreign.scm 251 */
									    obj_t cdr_1877_190_1362;
									    cdr_1877_190_1362 =
									       CDR(cdr_1709_93_1331);
									    {	/* Module/foreign.scm 251 */
									       bool_t test_3917;
									       {	/* ./Ieee/symbol.scm 6015 */
										  obj_t aux_3918;
										  aux_3918 =
										     CAR(cdr_1709_93_1331);
										  test_3917 =
										     SYMBOLP(aux_3918);
									       }
									       if (test_3917)
										 {	/* Module/foreign.scm 251 */
										    if (
										       PAIRP(cdr_1877_190_1362))
										      {		/* Module/foreign.scm 251 */
											 obj_t car_1879_5_1365;
											 car_1879_5_1365 =
											    CAR(cdr_1877_190_1362);
											 {

											    if (
											       (car_1879_5_1365 == BNIL))
											      {		/* Module/foreign.scm 251 */
											       kap_1883_195_1366:
												 {	/* Module/foreign.scm 251 */
												    bool_t test_3926;
												    {	/* ./Ieee/equiv.scm 5508 */
												       obj_t aux_3927;
												       aux_3927 =
													  CDR(cdr_1877_190_1362);
												       test_3926 =
													  (aux_3927 == BNIL);
												    }
												    if (test_3926)
												      {		/* Module/foreign.scm 251 */
													 return
													    check_c_args__102_module_foreign(car_1879_5_1365);
												      }
												    else
												      {		/* Module/foreign.scm 251 */
													 return ((bool_t) 0);
												      }
												 }
											      }
											    else
											      {		/* Module/foreign.scm 251 */
												 if (
												    PAIRP(car_1879_5_1365))
												   {	/* Module/foreign.scm 251 */
												      goto kap_1883_195_1366;
												   }
												 else
												   {	/* Module/foreign.scm 251 */
												      return ((bool_t) 0);
												   }
											      }
											 }
										      }
										    else
										      {		/* Module/foreign.scm 251 */
											 return ((bool_t) 0);
										      }
										 }
									       else
										 {	/* Module/foreign.scm 251 */
										    return ((bool_t) 0);
										 }
									    }
									 }
								       else
									 {	/* Module/foreign.scm 251 */
									    return ((bool_t) 0);
									 }
								    }
								  else
								    {	/* Module/foreign.scm 251 */
								       bool_t test_3933;
								       {	/* ./Ieee/equiv.scm 5508 */
									  obj_t aux_3934;
									  aux_3934 =
									     CNST_TABLE_REF(((long) 15));
									  test_3933 =
									     (car_1661_31_1315 == aux_3934);
								       }
								       if (test_3933)
									 {
									    obj_t slots_3937;
									    slots_3937 = cdr_1709_93_1331;
									    slots_1309 = slots_3937;
									    goto tag_1653_46_1310;
									 }
								       else
									 {	/* Module/foreign.scm 251 */
									    return ((bool_t) 0);
									 }
								    }
							       }
							  }
						     }
						}
					     }
					}
				     }
				}
			   }
		      }
		   }
		}
	      else
		{	/* Module/foreign.scm 251 */
		   return ((bool_t) 0);
		}
	   }
      }
   }
}



/* parse-c-extern-type */
obj_t 
parse_c_extern_type_73_module_foreign(obj_t type_26)
{
   AN_OBJECT;
   {	/* Module/foreign.scm 288 */
      {
	 obj_t id_1484;
	 obj_t t_exp_39_1485;
	 if (
	    PAIRP(type_26))
	   {	/* Module/foreign.scm 289 */
	      obj_t cdr_1939_36_1490;
	      cdr_1939_36_1490 =
		 CDR(type_26);
	      {		/* Module/foreign.scm 289 */
		 bool_t test_3941;
		 {	/* ./Ieee/equiv.scm 5508 */
		    obj_t aux_3944;
		    obj_t aux_3942;
		    aux_3944 =
		       CNST_TABLE_REF(((long) 5));
		    aux_3942 =
		       CAR(type_26);
		    test_3941 =
		       (aux_3942 == aux_3944);
		 }
		 if (test_3941)
		   {	/* Module/foreign.scm 289 */
		      if (
			 PAIRP(cdr_1939_36_1490))
			{	/* Module/foreign.scm 289 */
			   obj_t cdr_1943_100_1494;
			   cdr_1943_100_1494 =
			      CDR(cdr_1939_36_1490);
			   {	/* Module/foreign.scm 289 */
			      bool_t test_3950;
			      {		/* ./Ieee/symbol.scm 6015 */
				 obj_t aux_3951;
				 aux_3951 =
				    CAR(cdr_1939_36_1490);
				 test_3950 =
				    SYMBOLP(aux_3951);
			      }
			      if (test_3950)
				{	/* Module/foreign.scm 289 */
				   if (
				      PAIRP(cdr_1943_100_1494))
				     {	/* Module/foreign.scm 289 */
					bool_t test_3956;
					{	/* ./Ieee/string.scm 8047 */
					   obj_t aux_3957;
					   aux_3957 =
					      CAR(cdr_1943_100_1494);
					   test_3956 =
					      STRINGP(aux_3957);
					}
					if (test_3956)
					  {	/* Module/foreign.scm 289 */
					     bool_t test_3960;
					     {	/* ./Ieee/equiv.scm 5508 */
						obj_t aux_3961;
						aux_3961 =
						   CDR(cdr_1943_100_1494);
						test_3960 =
						   (aux_3961 == BNIL);
					     }
					     if (test_3960)
					       {	/* Module/foreign.scm 289 */
						  return
						     parse_c_foreign_type_105_module_foreign(type_26);
					       }
					     else
					       {	/* Module/foreign.scm 289 */
						  obj_t car_1965_30_1501;
						  obj_t cdr_1966_213_1502;
						  car_1965_30_1501 =
						     CAR(cdr_1939_36_1490);
						  cdr_1966_213_1502 =
						     CDR(cdr_1939_36_1490);
						  if (
						     SYMBOLP(car_1965_30_1501))
						    {	/* Module/foreign.scm 289 */
						       obj_t cdr_1975_125_1504;
						       cdr_1975_125_1504 =
							  CDR(cdr_1966_213_1502);
						       if (
							  PAIRP(cdr_1975_125_1504))
							 {	/* Module/foreign.scm 289 */
							    bool_t test_3972;
							    {	/* ./Ieee/string.scm 8047 */
							       obj_t aux_3973;
							       aux_3973 =
								  CAR(cdr_1975_125_1504);
							       test_3972 =
								  STRINGP(aux_3973);
							    }
							    if (test_3972)
							      {		/* Module/foreign.scm 289 */
								 bool_t test_3976;
								 {	/* ./Ieee/equiv.scm 5508 */
								    obj_t aux_3977;
								    aux_3977 =
								       CDR(cdr_1975_125_1504);
								    test_3976 =
								       (aux_3977 == BNIL);
								 }
								 if (test_3976)
								   {	/* Module/foreign.scm 289 */
								      id_1484 = car_1965_30_1501;
								      t_exp_39_1485 =
									 CAR(cdr_1966_213_1502);
								    tag_1930_101_1486:
								      {		/* Module/foreign.scm 293 */
									 obj_t foreign_type_139_1541;
									 foreign_type_139_1541 =
									    c_extern_type__c_foreign_type_30_module_foreign(t_exp_39_1485);
									 if (
									    CBOOL(foreign_type_139_1541))
									   {	/* Module/foreign.scm 294 */
									      return
										 parse_c_foreign_type_105_module_foreign(type_26);
									   }
									 else
									   {	/* Module/foreign.scm 296 */
									      obj_t list1886_1542;
									      list1886_1542 =
										 MAKE_PAIR(BNIL, BNIL);
									      return
										 user_error_151_tools_error(string2101_module_foreign, string2111_module_foreign, type_26, list1886_1542);
									   }
								      }
								   }
								 else
								   {	/* Module/foreign.scm 289 */
								    tag_1931_242_1487:
								      {		/* Module/foreign.scm 298 */
									 obj_t list1887_1543;
									 list1887_1543 =
									    MAKE_PAIR(BNIL, BNIL);
									 return
									    user_error_151_tools_error(string2101_module_foreign, string2111_module_foreign, type_26, list1887_1543);
								      }
								   }
							      }
							    else
							      {		/* Module/foreign.scm 289 */
								 goto tag_1931_242_1487;
							      }
							 }
						       else
							 {	/* Module/foreign.scm 289 */
							    goto tag_1931_242_1487;
							 }
						    }
						  else
						    {	/* Module/foreign.scm 289 */
						       goto tag_1931_242_1487;
						    }
					       }
					  }
					else
					  {	/* Module/foreign.scm 289 */
					     obj_t car_1990_171_1515;
					     obj_t cdr_1991_23_1516;
					     car_1990_171_1515 =
						CAR(cdr_1939_36_1490);
					     cdr_1991_23_1516 =
						CDR(cdr_1939_36_1490);
					     if (
						SYMBOLP(car_1990_171_1515))
					       {	/* Module/foreign.scm 289 */
						  obj_t cdr_1999_38_1518;
						  cdr_1999_38_1518 =
						     CDR(cdr_1991_23_1516);
						  if (
						     PAIRP(cdr_1999_38_1518))
						    {	/* Module/foreign.scm 289 */
						       bool_t test_3996;
						       {	/* ./Ieee/string.scm 8047 */
							  obj_t aux_3997;
							  aux_3997 =
							     CAR(cdr_1999_38_1518);
							  test_3996 =
							     STRINGP(aux_3997);
						       }
						       if (test_3996)
							 {	/* Module/foreign.scm 289 */
							    bool_t test_4000;
							    {	/* ./Ieee/equiv.scm 5508 */
							       obj_t aux_4001;
							       aux_4001 =
								  CDR(cdr_1999_38_1518);
							       test_4000 =
								  (aux_4001 == BNIL);
							    }
							    if (test_4000)
							      {
								 obj_t t_exp_39_4005;
								 obj_t id_4004;
								 id_4004 = car_1990_171_1515;
								 t_exp_39_4005 =
								    CAR(cdr_1991_23_1516);
								 t_exp_39_1485 = t_exp_39_4005;
								 id_1484 = id_4004;
								 goto tag_1930_101_1486;
							      }
							    else
							      {		/* Module/foreign.scm 289 */
								 goto tag_1931_242_1487;
							      }
							 }
						       else
							 {	/* Module/foreign.scm 289 */
							    goto tag_1931_242_1487;
							 }
						    }
						  else
						    {	/* Module/foreign.scm 289 */
						       goto tag_1931_242_1487;
						    }
					       }
					     else
					       {	/* Module/foreign.scm 289 */
						  goto tag_1931_242_1487;
					       }
					  }
				     }
				   else
				     {	/* Module/foreign.scm 289 */
					goto tag_1931_242_1487;
				     }
				}
			      else
				{	/* Module/foreign.scm 289 */
				   obj_t car_2016_186_1527;
				   obj_t cdr_2017_9_1528;
				   car_2016_186_1527 =
				      CAR(cdr_1939_36_1490);
				   cdr_2017_9_1528 =
				      CDR(cdr_1939_36_1490);
				   if (
				      SYMBOLP(car_2016_186_1527))
				     {	/* Module/foreign.scm 289 */
					if (
					   PAIRP(cdr_2017_9_1528))
					  {	/* Module/foreign.scm 289 */
					     obj_t cdr_2023_168_1531;
					     cdr_2023_168_1531 =
						CDR(cdr_2017_9_1528);
					     if (
						PAIRP(cdr_2023_168_1531))
					       {	/* Module/foreign.scm 289 */
						  bool_t test_4016;
						  {	/* ./Ieee/string.scm 8047 */
						     obj_t aux_4017;
						     aux_4017 =
							CAR(cdr_2023_168_1531);
						     test_4016 =
							STRINGP(aux_4017);
						  }
						  if (test_4016)
						    {	/* Module/foreign.scm 289 */
						       bool_t test_4020;
						       {	/* ./Ieee/equiv.scm 5508 */
							  obj_t aux_4021;
							  aux_4021 =
							     CDR(cdr_2023_168_1531);
							  test_4020 =
							     (aux_4021 == BNIL);
						       }
						       if (test_4020)
							 {
							    obj_t t_exp_39_4025;
							    obj_t id_4024;
							    id_4024 = car_2016_186_1527;
							    t_exp_39_4025 =
							       CAR(cdr_2017_9_1528);
							    t_exp_39_1485 = t_exp_39_4025;
							    id_1484 = id_4024;
							    goto tag_1930_101_1486;
							 }
						       else
							 {	/* Module/foreign.scm 289 */
							    goto tag_1931_242_1487;
							 }
						    }
						  else
						    {	/* Module/foreign.scm 289 */
						       goto tag_1931_242_1487;
						    }
					       }
					     else
					       {	/* Module/foreign.scm 289 */
						  goto tag_1931_242_1487;
					       }
					  }
					else
					  {	/* Module/foreign.scm 289 */
					     goto tag_1931_242_1487;
					  }
				     }
				   else
				     {	/* Module/foreign.scm 289 */
					goto tag_1931_242_1487;
				     }
				}
			   }
			}
		      else
			{	/* Module/foreign.scm 289 */
			   goto tag_1931_242_1487;
			}
		   }
		 else
		   {	/* Module/foreign.scm 289 */
		      goto tag_1931_242_1487;
		   }
	      }
	   }
	 else
	   {	/* Module/foreign.scm 289 */
	      goto tag_1931_242_1487;
	   }
      }
   }
}



/* c-extern-type->c-foreign-type */
obj_t 
c_extern_type__c_foreign_type_30_module_foreign(obj_t t_exp_39_27)
{
   AN_OBJECT;
   {	/* Module/foreign.scm 303 */
      {
	 obj_t slots_1552;
	 obj_t slots_1545;
	 if (
	    SYMBOLP(t_exp_39_27))
	   {	/* Module/foreign.scm 304 */
	      return t_exp_39_27;
	   }
	 else
	   {	/* Module/foreign.scm 304 */
	      if (
		 PAIRP(t_exp_39_27))
		{	/* Module/foreign.scm 304 */
		   obj_t car_2054_196_1559;
		   car_2054_196_1559 =
		      CAR(t_exp_39_27);
		   {

		      {		/* Module/foreign.scm 304 */
			 bool_t test_4032;
			 {	/* ./Ieee/equiv.scm 5508 */
			    obj_t aux_4033;
			    aux_4033 =
			       CNST_TABLE_REF(((long) 10));
			    test_4032 =
			       (car_2054_196_1559 == aux_4033);
			 }
			 if (test_4032)
			   {	/* Module/foreign.scm 304 */
			    kap_2056_5_1560:
			      slots_1545 =
				 CDR(t_exp_39_27);
			      {
				 obj_t slots_1685;
				 slots_1685 = slots_1545;
			       loop_1686:
				 if (
				    NULLP(slots_1685))
				   {	/* Module/foreign.scm 309 */
				      return t_exp_39_27;
				   }
				 else
				   {
				      obj_t id_1688;
				      obj_t name_1689;
				      {		/* Module/foreign.scm 311 */
					 obj_t e_2269_242_1692;
					 e_2269_242_1692 =
					    CAR(slots_1685);
					 if (
					    PAIRP(e_2269_242_1692))
					   {	/* Module/foreign.scm 311 */
					      obj_t car_2274_207_1694;
					      obj_t cdr_2275_159_1695;
					      car_2274_207_1694 =
						 CAR(e_2269_242_1692);
					      cdr_2275_159_1695 =
						 CDR(e_2269_242_1692);
					      if (
						 SYMBOLP(car_2274_207_1694))
						{	/* Module/foreign.scm 311 */
						   if (
						      PAIRP(cdr_2275_159_1695))
						     {	/* Module/foreign.scm 311 */
							obj_t car_2279_91_1698;
							car_2279_91_1698 =
							   CAR(cdr_2275_159_1695);
							if (
							   STRINGP(car_2279_91_1698))
							  {	/* Module/foreign.scm 311 */
							     bool_t test_4050;
							     {	/* ./Ieee/equiv.scm 5508 */
								obj_t aux_4051;
								aux_4051 =
								   CDR(cdr_2275_159_1695);
								test_4050 =
								   (aux_4051 == BNIL);
							     }
							     if (test_4050)
							       {	/* Module/foreign.scm 311 */
								  id_1688 = car_2274_207_1694;
								  name_1689 = car_2279_91_1698;
								  {	/* Module/foreign.scm 313 */
								     obj_t pid_1703;
								     {	/* Module/foreign.scm 313 */
									obj_t arg2013_1713;
									arg2013_1713 =
									   find_location_120_tools_location(t_exp_39_27);
									pid_1703 =
									   parse_id_241_ast_ident(id_1688, arg2013_1713);
								     }
								     {	/* Module/foreign.scm 313 */
									obj_t sid_1704;
									sid_1704 =
									   CAR(pid_1703);
									{	/* Module/foreign.scm 314 */
									   obj_t type_1705;
									   {	/* Module/foreign.scm 315 */
									      type_bglt obj_2777;
									      {		/* Module/foreign.scm 315 */
										 obj_t aux_4057;
										 aux_4057 =
										    CDR(pid_1703);
										 obj_2777 =
										    (type_bglt) (aux_4057);
									      }
									      type_1705 =
										 (((type_bglt) CREF(obj_2777))->id);
									   }
									   {	/* Module/foreign.scm 315 */

									      {		/* Module/foreign.scm 316 */
										 bool_t test2006_1706;
										 {	/* Module/foreign.scm 316 */
										    obj_t x_2927;
										    x_2927 =
										       check_id_6_ast_ident(pid_1703, t_exp_39_27);
										    test2006_1706 = ((bool_t) 1);
										 }
										 if (test2006_1706)
										   {	/* Module/foreign.scm 316 */
										      {		/* Module/foreign.scm 319 */
											 obj_t arg2007_1707;
											 obj_t arg2008_1708;
											 arg2007_1707 =
											    CAR(slots_1685);
											 {	/* Module/foreign.scm 319 */
											    obj_t arg2009_1709;
											    arg2009_1709 =
											       MAKE_PAIR(name_1689, BNIL);
											    arg2008_1708 =
											       MAKE_PAIR(sid_1704, arg2009_1709);
											 }
											 SET_CDR(arg2007_1707, arg2008_1708);
										      }
										      {		/* ./Ieee/pair-list.scm 5890 */
											 obj_t aux_4067;
											 aux_4067 =
											    CAR(slots_1685);
											 SET_CAR(aux_4067, type_1705);
										      }
										      {
											 obj_t slots_4070;
											 slots_4070 =
											    CDR(slots_1685);
											 slots_1685 = slots_4070;
											 goto loop_1686;
										      }
										   }
										 else
										   {	/* Module/foreign.scm 316 */
										      return BFALSE;
										   }
									      }
									   }
									}
								     }
								  }
							       }
							     else
							       {	/* Module/foreign.scm 311 */
								  return BFALSE;
							       }
							  }
							else
							  {	/* Module/foreign.scm 311 */
							     return BFALSE;
							  }
						     }
						   else
						     {	/* Module/foreign.scm 311 */
							return BFALSE;
						     }
						}
					      else
						{	/* Module/foreign.scm 311 */
						   return BFALSE;
						}
					   }
					 else
					   {	/* Module/foreign.scm 311 */
					      return BFALSE;
					   }
				      }
				   }
			      }
			   }
			 else
			   {	/* Module/foreign.scm 304 */
			      bool_t test_4073;
			      {		/* ./Ieee/equiv.scm 5508 */
				 obj_t aux_4074;
				 aux_4074 =
				    CNST_TABLE_REF(((long) 11));
				 test_4073 =
				    (car_2054_196_1559 == aux_4074);
			      }
			      if (test_4073)
				{	/* Module/foreign.scm 304 */
				   goto kap_2056_5_1560;
				}
			      else
				{	/* Module/foreign.scm 304 */
				   obj_t cdr_2061_78_1563;
				   cdr_2061_78_1563 =
				      CDR(t_exp_39_27);
				   {	/* Module/foreign.scm 304 */
				      bool_t test_4078;
				      {		/* ./Ieee/equiv.scm 5508 */
					 obj_t aux_4079;
					 aux_4079 =
					    CNST_TABLE_REF(((long) 13));
					 test_4078 =
					    (car_2054_196_1559 == aux_4079);
				      }
				      if (test_4078)
					{	/* Module/foreign.scm 304 */
					   if (
					      PAIRP(cdr_2061_78_1563))
					     {	/* Module/foreign.scm 304 */
						bool_t test_4084;
						{	/* ./Ieee/symbol.scm 6015 */
						   obj_t aux_4085;
						   aux_4085 =
						      CAR(cdr_2061_78_1563);
						   test_4084 =
						      SYMBOLP(aux_4085);
						}
						if (test_4084)
						  {	/* Module/foreign.scm 304 */
						     bool_t test_4088;
						     {	/* ./Ieee/equiv.scm 5508 */
							obj_t aux_4089;
							aux_4089 =
							   CDR(cdr_2061_78_1563);
							test_4088 =
							   (aux_4089 == BNIL);
						     }
						     if (test_4088)
						       {	/* Module/foreign.scm 304 */
							  return t_exp_39_27;
						       }
						     else
						       {	/* Module/foreign.scm 304 */
							  return BFALSE;
						       }
						  }
						else
						  {	/* Module/foreign.scm 304 */
						     return BFALSE;
						  }
					     }
					   else
					     {	/* Module/foreign.scm 304 */
						return BFALSE;
					     }
					}
				      else
					{

					   {	/* Module/foreign.scm 304 */
					      bool_t test_4092;
					      {		/* ./Ieee/equiv.scm 5508 */
						 obj_t aux_4093;
						 aux_4093 =
						    CNST_TABLE_REF(((long) 17));
						 test_4092 =
						    (car_2054_196_1559 == aux_4093);
					      }
					      if (test_4092)
						{	/* Module/foreign.scm 304 */
						 kap_2114_223_1580:
						   if (
						      PAIRP(cdr_2061_78_1563))
						     {	/* Module/foreign.scm 304 */
							bool_t test_4098;
							{	/* ./Ieee/symbol.scm 6015 */
							   obj_t aux_4099;
							   aux_4099 =
							      CAR(cdr_2061_78_1563);
							   test_4098 =
							      SYMBOLP(aux_4099);
							}
							if (test_4098)
							  {	/* Module/foreign.scm 304 */
							     bool_t test_4102;
							     {	/* ./Ieee/equiv.scm 5508 */
								obj_t aux_4103;
								aux_4103 =
								   CDR(cdr_2061_78_1563);
								test_4102 =
								   (aux_4103 == BNIL);
							     }
							     if (test_4102)
							       {	/* Module/foreign.scm 304 */
								  return t_exp_39_27;
							       }
							     else
							       {	/* Module/foreign.scm 304 */
								  obj_t cdr_2123_25_1622;
								  cdr_2123_25_1622 =
								     CDR(t_exp_39_27);
								  {	/* Module/foreign.scm 304 */
								     bool_t test_4107;
								     {	/* ./Ieee/equiv.scm 5508 */
									obj_t aux_4110;
									obj_t aux_4108;
									aux_4110 =
									   CNST_TABLE_REF(((long) 14));
									aux_4108 =
									   CAR(t_exp_39_27);
									test_4107 =
									   (aux_4108 == aux_4110);
								     }
								     if (test_4107)
								       {	/* Module/foreign.scm 304 */
									  obj_t cdr_2126_132_1624;
									  cdr_2126_132_1624 =
									     CDR(cdr_2123_25_1622);
									  {	/* Module/foreign.scm 304 */
									     bool_t test_4114;
									     {	/* ./Ieee/symbol.scm 6015 */
										obj_t aux_4115;
										aux_4115 =
										   CAR(cdr_2123_25_1622);
										test_4114 =
										   SYMBOLP(aux_4115);
									     }
									     if (test_4114)
									       {	/* Module/foreign.scm 304 */
										  if (
										     PAIRP(cdr_2126_132_1624))
										    {	/* Module/foreign.scm 304 */
										       obj_t car_2128_164_1627;
										       car_2128_164_1627 =
											  CAR(cdr_2126_132_1624);
										       {

											  if (
											     (car_2128_164_1627 == BNIL))
											    {	/* Module/foreign.scm 304 */
											     kap_2132_179_1628:
											       {	/* Module/foreign.scm 304 */
												  bool_t test_4123;
												  {	/* ./Ieee/equiv.scm 5508 */
												     obj_t aux_4124;
												     aux_4124 =
													CDR(cdr_2126_132_1624);
												     test_4123 =
													(aux_4124 == BNIL);
												  }
												  if (test_4123)
												    {	/* Module/foreign.scm 304 */
												       if (
													  check_c_args__102_module_foreign(car_2128_164_1627))
													 {	/* Module/foreign.scm 331 */
													    return t_exp_39_27;
													 }
												       else
													 {	/* Module/foreign.scm 331 */
													    return BFALSE;
													 }
												    }
												  else
												    {	/* Module/foreign.scm 304 */
												       return BFALSE;
												    }
											       }
											    }
											  else
											    {	/* Module/foreign.scm 304 */
											       if (
												  PAIRP(car_2128_164_1627))
												 {	/* Module/foreign.scm 304 */
												    goto kap_2132_179_1628;
												 }
											       else
												 {	/* Module/foreign.scm 304 */
												    return BFALSE;
												 }
											    }
										       }
										    }
										  else
										    {	/* Module/foreign.scm 304 */
										       return BFALSE;
										    }
									       }
									     else
									       {	/* Module/foreign.scm 304 */
										  return BFALSE;
									       }
									  }
								       }
								     else
								       {	/* Module/foreign.scm 304 */
									  bool_t test_4131;
									  {	/* ./Ieee/equiv.scm 5508 */
									     obj_t aux_4134;
									     obj_t aux_4132;
									     aux_4134 =
										CNST_TABLE_REF(((long) 15));
									     aux_4132 =
										CAR(t_exp_39_27);
									     test_4131 =
										(aux_4132 == aux_4134);
									  }
									  if (test_4131)
									    {	/* Module/foreign.scm 304 */
									       slots_1552 = cdr_2123_25_1622;
									     tag_2045_244_1553:
									       {
										  obj_t slots_1715;
										  slots_1715 = slots_1552;
										loop_1716:
										  if (
										     NULLP(slots_1715))
										    {	/* Module/foreign.scm 336 */
										       return t_exp_39_27;
										    }
										  else
										    {

										       {	/* Module/foreign.scm 338 */
											  obj_t e_2285_141_1720;
											  e_2285_141_1720 =
											     CAR(slots_1715);
											  if (
											     PAIRP(e_2285_141_1720))
											    {	/* Module/foreign.scm 338 */
											       obj_t cdr_2287_6_1722;
											       cdr_2287_6_1722 =
												  CDR(e_2285_141_1720);
											       {	/* Module/foreign.scm 338 */
												  bool_t test_4143;
												  {	/* ./Ieee/symbol.scm 6015 */
												     obj_t aux_4144;
												     aux_4144 =
													CAR(e_2285_141_1720);
												     test_4143 =
													SYMBOLP(aux_4144);
												  }
												  if (test_4143)
												    {	/* Module/foreign.scm 338 */
												       if (
													  PAIRP(cdr_2287_6_1722))
													 {	/* Module/foreign.scm 338 */
													    bool_t test_4149;
													    {	/* ./Ieee/string.scm 8047 */
													       obj_t aux_4150;
													       aux_4150 =
														  CAR(cdr_2287_6_1722);
													       test_4149 =
														  STRINGP(aux_4150);
													    }
													    if (test_4149)
													      {		/* Module/foreign.scm 338 */
														 bool_t test_4153;
														 {	/* ./Ieee/equiv.scm 5508 */
														    obj_t aux_4154;
														    aux_4154 =
														       CDR(cdr_2287_6_1722);
														    test_4153 =
														       (aux_4154 == BNIL);
														 }
														 if (test_4153)
														   {	/* Module/foreign.scm 338 */
														      {
															 obj_t slots_4157;
															 slots_4157 =
															    CDR(slots_1715);
															 slots_1715 = slots_4157;
															 goto loop_1716;
														      }
														   }
														 else
														   {	/* Module/foreign.scm 338 */
														      return BFALSE;
														   }
													      }
													    else
													      {		/* Module/foreign.scm 338 */
														 return BFALSE;
													      }
													 }
												       else
													 {	/* Module/foreign.scm 338 */
													    return BFALSE;
													 }
												    }
												  else
												    {	/* Module/foreign.scm 338 */
												       return BFALSE;
												    }
											       }
											    }
											  else
											    {	/* Module/foreign.scm 338 */
											       return BFALSE;
											    }
										       }
										    }
									       }
									    }
									  else
									    {	/* Module/foreign.scm 304 */
									       return BFALSE;
									    }
								       }
								  }
							       }
							  }
							else
							  {	/* Module/foreign.scm 304 */
							     obj_t cdr_2150_67_1643;
							     cdr_2150_67_1643 =
								CDR(t_exp_39_27);
							     {	/* Module/foreign.scm 304 */
								bool_t test_4160;
								{	/* ./Ieee/equiv.scm 5508 */
								   obj_t aux_4163;
								   obj_t aux_4161;
								   aux_4163 =
								      CNST_TABLE_REF(((long) 16));
								   aux_4161 =
								      CAR(t_exp_39_27);
								   test_4160 =
								      (aux_4161 == aux_4163);
								}
								if (test_4160)
								  {	/* Module/foreign.scm 304 */
								     bool_t test_4166;
								     {	/* ./Ieee/symbol.scm 6015 */
									obj_t aux_4167;
									aux_4167 =
									   CAR(cdr_2150_67_1643);
									test_4166 =
									   SYMBOLP(aux_4167);
								     }
								     if (test_4166)
								       {	/* Module/foreign.scm 304 */
									  bool_t test_4170;
									  {	/* ./Ieee/equiv.scm 5508 */
									     obj_t aux_4171;
									     aux_4171 =
										CDR(cdr_2150_67_1643);
									     test_4170 =
										(aux_4171 == BNIL);
									  }
									  if (test_4170)
									    {	/* Module/foreign.scm 304 */
									       return t_exp_39_27;
									    }
									  else
									    {	/* Module/foreign.scm 304 */
									       return BFALSE;
									    }
								       }
								     else
								       {	/* Module/foreign.scm 304 */
									  return BFALSE;
								       }
								  }
								else
								  {	/* Module/foreign.scm 304 */
								     bool_t test_4174;
								     {	/* ./Ieee/equiv.scm 5508 */
									obj_t aux_4177;
									obj_t aux_4175;
									aux_4177 =
									   CNST_TABLE_REF(((long) 14));
									aux_4175 =
									   CAR(t_exp_39_27);
									test_4174 =
									   (aux_4175 == aux_4177);
								     }
								     if (test_4174)
								       {	/* Module/foreign.scm 304 */
									  obj_t cdr_2170_105_1652;
									  cdr_2170_105_1652 =
									     CDR(cdr_2150_67_1643);
									  {	/* Module/foreign.scm 304 */
									     bool_t test_4181;
									     {	/* ./Ieee/symbol.scm 6015 */
										obj_t aux_4182;
										aux_4182 =
										   CAR(cdr_2150_67_1643);
										test_4181 =
										   SYMBOLP(aux_4182);
									     }
									     if (test_4181)
									       {	/* Module/foreign.scm 304 */
										  if (
										     PAIRP(cdr_2170_105_1652))
										    {	/* Module/foreign.scm 304 */
										       obj_t car_2172_57_1655;
										       car_2172_57_1655 =
											  CAR(cdr_2170_105_1652);
										       {

											  if (
											     (car_2172_57_1655 == BNIL))
											    {	/* Module/foreign.scm 304 */
											     kap_2176_184_1656:
											       {	/* Module/foreign.scm 304 */
												  bool_t test_4190;
												  {	/* ./Ieee/equiv.scm 5508 */
												     obj_t aux_4191;
												     aux_4191 =
													CDR(cdr_2170_105_1652);
												     test_4190 =
													(aux_4191 == BNIL);
												  }
												  if (test_4190)
												    {	/* Module/foreign.scm 304 */
												       if (
													  check_c_args__102_module_foreign(car_2172_57_1655))
													 {	/* Module/foreign.scm 331 */
													    return t_exp_39_27;
													 }
												       else
													 {	/* Module/foreign.scm 331 */
													    return BFALSE;
													 }
												    }
												  else
												    {	/* Module/foreign.scm 304 */
												       return BFALSE;
												    }
											       }
											    }
											  else
											    {	/* Module/foreign.scm 304 */
											       if (
												  PAIRP(car_2172_57_1655))
												 {	/* Module/foreign.scm 304 */
												    goto kap_2176_184_1656;
												 }
											       else
												 {	/* Module/foreign.scm 304 */
												    return BFALSE;
												 }
											    }
										       }
										    }
										  else
										    {	/* Module/foreign.scm 304 */
										       return BFALSE;
										    }
									       }
									     else
									       {	/* Module/foreign.scm 304 */
										  return BFALSE;
									       }
									  }
								       }
								     else
								       {	/* Module/foreign.scm 304 */
									  bool_t test_4198;
									  {	/* ./Ieee/equiv.scm 5508 */
									     obj_t aux_4201;
									     obj_t aux_4199;
									     aux_4201 =
										CNST_TABLE_REF(((long) 15));
									     aux_4199 =
										CAR(t_exp_39_27);
									     test_4198 =
										(aux_4199 == aux_4201);
									  }
									  if (test_4198)
									    {
									       obj_t slots_4204;
									       slots_4204 = cdr_2150_67_1643;
									       slots_1552 = slots_4204;
									       goto tag_2045_244_1553;
									    }
									  else
									    {	/* Module/foreign.scm 304 */
									       return BFALSE;
									    }
								       }
								  }
							     }
							  }
						     }
						   else
						     {	/* Module/foreign.scm 304 */
							bool_t test_4205;
							{	/* ./Ieee/equiv.scm 5508 */
							   obj_t aux_4208;
							   obj_t aux_4206;
							   aux_4208 =
							      CNST_TABLE_REF(((long) 15));
							   aux_4206 =
							      CAR(t_exp_39_27);
							   test_4205 =
							      (aux_4206 == aux_4208);
							}
							if (test_4205)
							  {
							     obj_t slots_4211;
							     slots_4211 =
								CDR(t_exp_39_27);
							     slots_1552 = slots_4211;
							     goto tag_2045_244_1553;
							  }
							else
							  {	/* Module/foreign.scm 304 */
							     bool_t test_4213;
							     {	/* ./Ieee/equiv.scm 5508 */
								obj_t aux_4216;
								obj_t aux_4214;
								aux_4216 =
								   CNST_TABLE_REF(((long) 12));
								aux_4214 =
								   CAR(t_exp_39_27);
								test_4213 =
								   (aux_4214 == aux_4216);
							     }
							     if (test_4213)
							       {	/* Module/foreign.scm 304 */
								  bool_t test_4219;
								  {	/* ./Ieee/equiv.scm 5508 */
								     obj_t aux_4220;
								     aux_4220 =
									CDR(t_exp_39_27);
								     test_4219 =
									(aux_4220 == BNIL);
								  }
								  if (test_4219)
								    {	/* Module/foreign.scm 304 */
								       return t_exp_39_27;
								    }
								  else
								    {	/* Module/foreign.scm 304 */
								       return BFALSE;
								    }
							       }
							     else
							       {	/* Module/foreign.scm 304 */
								  return BFALSE;
							       }
							  }
						     }
						}
					      else
						{	/* Module/foreign.scm 304 */
						   bool_t test_4223;
						   {	/* ./Ieee/equiv.scm 5508 */
						      obj_t aux_4224;
						      aux_4224 =
							 CNST_TABLE_REF(((long) 18));
						      test_4223 =
							 (car_2054_196_1559 == aux_4224);
						   }
						   if (test_4223)
						     {	/* Module/foreign.scm 304 */
							goto kap_2114_223_1580;
						     }
						   else
						     {	/* Module/foreign.scm 304 */
							bool_t test_4227;
							{	/* ./Ieee/equiv.scm 5508 */
							   obj_t aux_4228;
							   aux_4228 =
							      CNST_TABLE_REF(((long) 16));
							   test_4227 =
							      (car_2054_196_1559 == aux_4228);
							}
							if (test_4227)
							  {	/* Module/foreign.scm 304 */
							     if (
								PAIRP(cdr_2061_78_1563))
							       {	/* Module/foreign.scm 304 */
								  bool_t test_4233;
								  {	/* ./Ieee/symbol.scm 6015 */
								     obj_t aux_4234;
								     aux_4234 =
									CAR(cdr_2061_78_1563);
								     test_4233 =
									SYMBOLP(aux_4234);
								  }
								  if (test_4233)
								    {	/* Module/foreign.scm 304 */
								       bool_t test_4237;
								       {	/* ./Ieee/equiv.scm 5508 */
									  obj_t aux_4238;
									  aux_4238 =
									     CDR(cdr_2061_78_1563);
									  test_4237 =
									     (aux_4238 == BNIL);
								       }
								       if (test_4237)
									 {	/* Module/foreign.scm 304 */
									    return t_exp_39_27;
									 }
								       else
									 {	/* Module/foreign.scm 304 */
									    return BFALSE;
									 }
								    }
								  else
								    {	/* Module/foreign.scm 304 */
								       return BFALSE;
								    }
							       }
							     else
							       {	/* Module/foreign.scm 304 */
								  return BFALSE;
							       }
							  }
							else
							  {	/* Module/foreign.scm 304 */
							     bool_t test_4241;
							     {	/* ./Ieee/equiv.scm 5508 */
								obj_t aux_4242;
								aux_4242 =
								   CNST_TABLE_REF(((long) 14));
								test_4241 =
								   (car_2054_196_1559 == aux_4242);
							     }
							     if (test_4241)
							       {	/* Module/foreign.scm 304 */
								  if (
								     PAIRP(cdr_2061_78_1563))
								    {	/* Module/foreign.scm 304 */
								       obj_t cdr_2231_102_1594;
								       cdr_2231_102_1594 =
									  CDR(cdr_2061_78_1563);
								       {	/* Module/foreign.scm 304 */
									  bool_t test_4248;
									  {	/* ./Ieee/symbol.scm 6015 */
									     obj_t aux_4249;
									     aux_4249 =
										CAR(cdr_2061_78_1563);
									     test_4248 =
										SYMBOLP(aux_4249);
									  }
									  if (test_4248)
									    {	/* Module/foreign.scm 304 */
									       if (
										  PAIRP(cdr_2231_102_1594))
										 {	/* Module/foreign.scm 304 */
										    obj_t car_2233_89_1597;
										    car_2233_89_1597 =
										       CAR(cdr_2231_102_1594);
										    {

										       if (
											  (car_2233_89_1597 == BNIL))
											 {	/* Module/foreign.scm 304 */
											  kap_2237_151_1598:
											    {	/* Module/foreign.scm 304 */
											       bool_t test_4257;
											       {	/* ./Ieee/equiv.scm 5508 */
												  obj_t aux_4258;
												  aux_4258 =
												     CDR(cdr_2231_102_1594);
												  test_4257 =
												     (aux_4258 == BNIL);
											       }
											       if (test_4257)
												 {	/* Module/foreign.scm 304 */
												    if (
												       check_c_args__102_module_foreign(car_2233_89_1597))
												      {		/* Module/foreign.scm 331 */
													 return t_exp_39_27;
												      }
												    else
												      {		/* Module/foreign.scm 331 */
													 return BFALSE;
												      }
												 }
											       else
												 {	/* Module/foreign.scm 304 */
												    return BFALSE;
												 }
											    }
											 }
										       else
											 {	/* Module/foreign.scm 304 */
											    if (
											       PAIRP(car_2233_89_1597))
											      {		/* Module/foreign.scm 304 */
												 goto kap_2237_151_1598;
											      }
											    else
											      {		/* Module/foreign.scm 304 */
												 return BFALSE;
											      }
											 }
										    }
										 }
									       else
										 {	/* Module/foreign.scm 304 */
										    return BFALSE;
										 }
									    }
									  else
									    {	/* Module/foreign.scm 304 */
									       return BFALSE;
									    }
								       }
								    }
								  else
								    {	/* Module/foreign.scm 304 */
								       return BFALSE;
								    }
							       }
							     else
							       {	/* Module/foreign.scm 304 */
								  bool_t test_4265;
								  {	/* ./Ieee/equiv.scm 5508 */
								     obj_t aux_4266;
								     aux_4266 =
									CNST_TABLE_REF(((long) 15));
								     test_4265 =
									(car_2054_196_1559 == aux_4266);
								  }
								  if (test_4265)
								    {
								       obj_t slots_4269;
								       slots_4269 = cdr_2061_78_1563;
								       slots_1552 = slots_4269;
								       goto tag_2045_244_1553;
								    }
								  else
								    {	/* Module/foreign.scm 304 */
								       bool_t test_4270;
								       {	/* ./Ieee/equiv.scm 5508 */
									  obj_t aux_4271;
									  aux_4271 =
									     CNST_TABLE_REF(((long) 12));
									  test_4270 =
									     (car_2054_196_1559 == aux_4271);
								       }
								       if (test_4270)
									 {	/* Module/foreign.scm 304 */
									    if (
									       (cdr_2061_78_1563 == BNIL))
									      {		/* Module/foreign.scm 304 */
										 return t_exp_39_27;
									      }
									    else
									      {		/* Module/foreign.scm 304 */
										 return BFALSE;
									      }
									 }
								       else
									 {	/* Module/foreign.scm 304 */
									    return BFALSE;
									 }
								    }
							       }
							  }
						     }
						}
					   }
					}
				   }
				}
			   }
		      }
		   }
		}
	      else
		{	/* Module/foreign.scm 304 */
		   return BFALSE;
		}
	   }
      }
   }
}



/* foreign-finalizer */
obj_t 
foreign_finalizer_169_module_foreign()
{
   AN_OBJECT;
   {	/* Module/foreign.scm 361 */
      {
	 obj_t l1335_1732;
	 l1335_1732 = _foreign_exported__195_module_foreign;
       lname1336_1733:
	 if (
	    PAIRP(l1335_1732))
	   {	/* Module/foreign.scm 363 */
	      {		/* Module/foreign.scm 364 */
		 obj_t foreign_1735;
		 foreign_1735 =
		    CAR(l1335_1732);
		 {	/* Module/foreign.scm 364 */
		    obj_t global_1736;
		    obj_t name_1737;
		    {	/* Module/foreign.scm 364 */
		       obj_t aux_4279;
		       {	/* ./Ieee/pair-list.scm 5701 */
			  obj_t aux_4280;
			  aux_4280 =
			     CDR(foreign_1735);
			  aux_4279 =
			     CAR(aux_4280);
		       }
		       global_1736 =
			  find_global_223_ast_env(aux_4279, BNIL);
		    }
		    {	/* ./Ieee/pair-list.scm 5701 */
		       obj_t aux_4284;
		       {	/* ./Ieee/pair-list.scm 5707 */
			  obj_t aux_4285;
			  aux_4285 =
			     CDR(foreign_1735);
			  aux_4284 =
			     CDR(aux_4285);
		       }
		       name_1737 =
			  CAR(aux_4284);
		    }
		    {	/* Module/foreign.scm 367 */
		       bool_t test2027_1738;
		       test2027_1738 =
			  is_a__118___object(global_1736, global_ast_var);
		       if (test2027_1738)
			 {	/* Module/foreign.scm 372 */
			    bool_t test_4291;
			    {	/* ./Ieee/string.scm 8047 */
			       obj_t aux_4292;
			       {	/* Module/foreign.scm 372 */
				  global_bglt obj_2816;
				  obj_2816 =
				     (global_bglt) (global_1736);
				  aux_4292 =
				     (((global_bglt) CREF(obj_2816))->name);
			       }
			       test_4291 =
				  STRINGP(aux_4292);
			    }
			    if (test_4291)
			      {		/* Module/foreign.scm 372 */
				 user_warning_209_tools_error(string2112_module_foreign, string2113_module_foreign, foreign_1735);
			      }
			    else
			      {		/* Module/foreign.scm 372 */
				 {	/* Module/foreign.scm 378 */
				    global_bglt obj_2818;
				    obj_2818 =
				       (global_bglt) (global_1736);
				    ((((global_bglt) CREF(obj_2818))->name) = ((obj_t) name_1737), BUNSPEC);
				 }
			      }
			 }
		       else
			 {	/* Module/foreign.scm 367 */
			    {	/* Module/foreign.scm 368 */
			       obj_t list2030_1741;
			       list2030_1741 =
				  MAKE_PAIR(BNIL, BNIL);
			       user_error_151_tools_error(string2112_module_foreign, string2114_module_foreign, foreign_1735, list2030_1741);
			    }
			 }
		    }
		 }
	      }
	      {
		 obj_t l1335_4301;
		 l1335_4301 =
		    CDR(l1335_1732);
		 l1335_1732 = l1335_4301;
		 goto lname1336_1733;
	      }
	   }
	 else
	   {	/* Module/foreign.scm 363 */
	      ((bool_t) 1);
	   }
      }
      _foreign_exported__195_module_foreign = BNIL;
      {		/* Module/foreign.scm 382 */
	 bool_t test2034_1745;
	 {	/* Module/foreign.scm 382 */
	    obj_t obj_2821;
	    obj_2821 = _foreign_accesses__124_module_foreign;
	    test2034_1745 =
	       NULLP(obj_2821);
	 }
	 if (test2034_1745)
	   {	/* Module/foreign.scm 382 */
	      return
		 CNST_TABLE_REF(((long) 2));
	   }
	 else
	   {	/* Module/foreign.scm 384 */
	      obj_t accesses_1746;
	      accesses_1746 =
		 reverse__39___r4_pairs_and_lists_6_3(_foreign_accesses__124_module_foreign);
	      _foreign_accesses__124_module_foreign = BNIL;
	      {		/* Module/foreign.scm 386 */
		 obj_t arg2035_1747;
		 {	/* Module/foreign.scm 386 */
		    obj_t id_2822;
		    id_2822 =
		       CNST_TABLE_REF(((long) 0));
		    {	/* ./Ast/unit.sch 646 */
		       obj_t new_2826;
		       {	/* ./Ast/unit.sch 646 */
			  obj_t aux_4308;
			  aux_4308 =
			     CNST_TABLE_REF(((long) 19));
			  new_2826 =
			     create_struct(aux_4308, ((long) 4));
		       }
		       STRUCT_SET(new_2826, ((long) 3), BTRUE);
		       STRUCT_SET(new_2826, ((long) 2), accesses_1746);
		       {	/* ./Llib/struct.scm 1463 */
			  obj_t aux_4313;
			  aux_4313 =
			     BINT(((long) 48));
			  STRUCT_SET(new_2826, ((long) 1), aux_4313);
		       }
		       STRUCT_SET(new_2826, ((long) 0), id_2822);
		       arg2035_1747 = new_2826;
		    }
		 }
		 {	/* Module/foreign.scm 386 */
		    obj_t list2036_1748;
		    list2036_1748 =
		       MAKE_PAIR(arg2035_1747, BNIL);
		    return list2036_1748;
		 }
	      }
	   }
      }
   }
}



/* _foreign-finalizer */
obj_t 
_foreign_finalizer_56_module_foreign(obj_t env_2907)
{
   AN_OBJECT;
   {	/* Module/foreign.scm 361 */
      return
	 foreign_finalizer_169_module_foreign();
   }
}



/* default-c-type */
obj_t 
default_c_type_69_module_foreign(obj_t type_28, obj_t src_29)
{
   AN_OBJECT;
   {	/* Module/foreign.scm 391 */
      {		/* Module/foreign.scm 392 */
	 bool_t test2037_1749;
	 {	/* Module/foreign.scm 392 */
	    type_bglt arg2042_1755;
	    arg2042_1755 =
	       get_default_type_181_type_cache();
	    {	/* ./Ieee/equiv.scm 5508 */
	       obj_t aux_4320;
	       aux_4320 =
		  (obj_t) (arg2042_1755);
	       test2037_1749 =
		  (type_28 == aux_4320);
	    }
	 }
	 if (test2037_1749)
	   {	/* Module/foreign.scm 393 */
	      type_bglt default_1750;
	      default_1750 =
		 get_default_c_type_186_type_cache();
	      {		/* Module/foreign.scm 394 */
		 obj_t arg2038_1751;
		 obj_t arg2041_1754;
		 arg2038_1751 =
		    find_location_120_tools_location(src_29);
		 arg2041_1754 =
		    (((type_bglt) CREF(default_1750))->id);
		 user_warning_location_190_tools_error(arg2038_1751, string2112_module_foreign, string2115_module_foreign, arg2041_1754);
	      }
	      return
		 (obj_t) (default_1750);
	   }
	 else
	   {	/* Module/foreign.scm 392 */
	      return type_28;
	   }
      }
   }
}



/* method-init */
obj_t 
method_init_76_module_foreign()
{
   AN_OBJECT;
   {	/* Module/foreign.scm 17 */
      return BUNSPEC;
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_module_foreign()
{
   AN_OBJECT;
   {	/* Module/foreign.scm 17 */
      module_initialization_70_tools_trace(((long) 0), "MODULE_FOREIGN");
      module_initialization_70_module_module(((long) 0), "MODULE_FOREIGN");
      module_initialization_70_module_checksum(((long) 0), "MODULE_FOREIGN");
      module_initialization_70_engine_param(((long) 0), "MODULE_FOREIGN");
      module_initialization_70_ast_glo_decl_237(((long) 0), "MODULE_FOREIGN");
      module_initialization_70_tools_error(((long) 0), "MODULE_FOREIGN");
      module_initialization_70_tools_shape(((long) 0), "MODULE_FOREIGN");
      module_initialization_70_type_type(((long) 0), "MODULE_FOREIGN");
      module_initialization_70_type_env(((long) 0), "MODULE_FOREIGN");
      module_initialization_70_type_tools(((long) 0), "MODULE_FOREIGN");
      module_initialization_70_type_cache(((long) 0), "MODULE_FOREIGN");
      module_initialization_70_ast_var(((long) 0), "MODULE_FOREIGN");
      module_initialization_70_ast_env(((long) 0), "MODULE_FOREIGN");
      module_initialization_70_ast_ident(((long) 0), "MODULE_FOREIGN");
      module_initialization_70_foreign_ctype(((long) 0), "MODULE_FOREIGN");
      module_initialization_70_foreign_access(((long) 0), "MODULE_FOREIGN");
      return
	 module_initialization_70_tools_location(((long) 0), "MODULE_FOREIGN");
   }
}
