/*===========================================================================*/
/*   (Module/impuse.scm)                                                     */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct ccomp
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t producer;
     obj_t consumer;
     obj_t finalizer;
     obj_t checksummer;
  }
     *ccomp_bglt;

typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;


extern obj_t unwind_until__178___bexit(obj_t, obj_t);
extern obj_t ccomp_module_module;
extern global_bglt declare_global_sfun__255_ast_glo_decl_237(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t method_init_76_module_impuse();
static obj_t body1200_module_impuse(obj_t);
extern obj_t get_imported_modules_153_module_impuse();
static obj_t import_1_module_184_module_impuse(obj_t, obj_t, obj_t, obj_t);
extern obj_t _access_table__91_engine_param;
extern obj_t inline_finalizer_105_read_inline();
extern obj_t string_append(obj_t, obj_t);
extern obj_t current_error_port;
extern obj_t exitd_top;
extern obj_t _load_path__54___eval;
static obj_t _make_use_compiler_39_module_impuse(obj_t);
extern obj_t type_type_type;
extern obj_t find_file_path_55___os(obj_t, obj_t);
static obj_t _import_parser1609_204_module_impuse(obj_t, obj_t, obj_t);
extern obj_t make_use_compiler_106_module_impuse();
extern obj_t create_struct(obj_t, long);
extern obj_t global_ast_var;
static obj_t handling_function1491_module_impuse(obj_t, obj_t, obj_t, obj_t);
extern obj_t user_error_151_tools_error(obj_t, obj_t, obj_t, obj_t);
extern obj_t fast_id_of_id_130_ast_ident(obj_t, obj_t);
extern obj_t import_with_module__247_module_impuse(obj_t, obj_t);
extern obj_t verbose_tools_speek(obj_t, obj_t);
extern bool_t is_a__118___object(obj_t, obj_t);
static obj_t read_imported_module_112_module_impuse(obj_t);
extern obj_t module_initialization_70_module_impuse(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_read_reader(long, char *);
extern obj_t module_initialization_70_module_module(long, char *);
extern obj_t module_initialization_70_module_prototype(long, char *);
extern obj_t module_initialization_70_module_class(long, char *);
extern obj_t module_initialization_70_module_include(long, char *);
extern obj_t module_initialization_70_tools_speek(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_tools_location(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_read_access(long, char *);
extern obj_t module_initialization_70_read_inline(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_find_gdefs_13(long, char *);
extern obj_t module_initialization_70_ast_glo_decl_237(long, char *);
extern obj_t module_initialization_70_ast_ident(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_init_main(long, char *);
extern obj_t module_initialization_70___error(long, char *);
extern obj_t module_initialization_70___os(long, char *);
extern obj_t module_initialization_70___bexit(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___eval(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_strings_6_7(long, char *);
extern obj_t module_initialization_70___r4_control_features_6_9(long, char *);
extern obj_t module_initialization_70___r4_ports_6_10_1(long, char *);
extern obj_t notify_error_43___error(obj_t, obj_t, obj_t);
extern obj_t consume_module__183_module_module(obj_t, obj_t);
static obj_t _make_import_compiler_114_module_impuse(obj_t);
static obj_t import_wanted_18_module_impuse(obj_t, obj_t, obj_t);
static obj_t _anonymous_1496__28_module_impuse(obj_t);
static obj_t _anonymous_1495__106_module_impuse(obj_t);
extern obj_t compiler_read_18_read_reader(obj_t);
static obj_t impuse_parser_37_module_impuse(obj_t, obj_t);
static obj_t _make_from_compiler_253_module_impuse(obj_t);
static obj_t _import_module_list__76_module_impuse = BUNSPEC;
extern long class_num_218___object(obj_t);
extern obj_t exit_bigloo_229_init_main(obj_t);
extern obj_t module_initialization_id_110_module_module(obj_t);
static obj_t imported_modules_init_94_module_impuse();
static obj_t _imported_module_list__84_module_impuse = BUNSPEC;
extern obj_t reset_include_consumed_code__8_module_include();
extern obj_t string_downcase_77___r4_strings_6_7(obj_t);
static obj_t import_all_module_109_module_impuse(obj_t, obj_t, obj_t);
static obj_t rhandler1199_module_impuse(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t handler_module_impuse(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t get_include_consumed_code_244_module_include();
extern obj_t _module_clause__117_module_module;
extern obj_t append_2_18___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern obj_t import_parser_53_module_impuse(obj_t, obj_t);
static obj_t library_modules_init_112_module_impuse();
static obj_t import_everything_193_module_impuse(obj_t, obj_t);
extern global_bglt declare_global_svar__200_ast_glo_decl_237(obj_t, obj_t, obj_t, obj_t);
extern obj_t make_import_compiler_148_module_impuse();
extern obj_t assq___r4_pairs_and_lists_6_3(obj_t, obj_t);
static obj_t toplevel_init_63_module_impuse();
extern obj_t open_input_string(obj_t);
extern obj_t add_access__140_read_access(obj_t, obj_t);
extern obj_t sfun_ast_var;
extern obj_t get_include_consumed_directive_80_module_include();
extern obj_t look_for_inline_98_read_inline(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t remq__51___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern obj_t string_to_bstring(char *);
static obj_t _impuse_finalizer_29_module_impuse(obj_t);
extern obj_t dynamic_wind_31___r4_control_features_6_9(obj_t, obj_t, obj_t);
static obj_t _import_with_module_1608_46_module_impuse(obj_t, obj_t, obj_t);
extern obj_t memq___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern obj_t declare_class__31_module_class(obj_t, obj_t, obj_t, bool_t, obj_t);
extern obj_t close_input_port(obj_t);
static obj_t impuse_producer_187_module_impuse(obj_t);
static obj_t _get_imported_modules_109_module_impuse(obj_t);
static obj_t _anonymous_1246__233_module_impuse(obj_t, obj_t, obj_t);
static obj_t _anonymous_1245__211_module_impuse(obj_t);
static obj_t _anonymous_1244__114_module_impuse(obj_t, obj_t, obj_t);
static obj_t _anonymous_1236__226_module_impuse(obj_t, obj_t, obj_t);
static obj_t _anonymous_1235__94_module_impuse(obj_t, obj_t, obj_t);
static obj_t _anonymous_1229__9_module_impuse(obj_t, obj_t, obj_t);
static obj_t _anonymous_1228__29_module_impuse(obj_t);
static obj_t _anonymous_1227__149_module_impuse(obj_t, obj_t, obj_t);
extern obj_t checksum_module_8_module_module(obj_t);
extern obj_t _module__166_module_module;
extern obj_t make_from_compiler_140_module_impuse();
extern obj_t remove_error_handler__102___error();
static obj_t import_finalizer_66_module_impuse();
static obj_t impuse_finalizer_42_module_impuse();
extern obj_t read___reader(obj_t);
extern obj_t find_location_120_tools_location(obj_t);
static obj_t escape_module_impuse(obj_t, obj_t);
extern obj_t declare_wide_class__13_module_class(obj_t, obj_t, obj_t, obj_t);
extern obj_t add_error_handler__155___error(obj_t, obj_t);
static obj_t require_initialization_114_module_impuse = BUNSPEC;
extern obj_t parse_prototype_143_module_prototype(obj_t);
static obj_t _impuse_producer_249_module_impuse(obj_t, obj_t);
extern obj_t reset_include_consumed_directive__234_module_include();
extern obj_t open_input_file_61___r4_ports_6_10_1(obj_t, obj_t);
static obj_t cnst_init_137_module_impuse();
extern obj_t reverse__39___r4_pairs_and_lists_6_3(obj_t);
extern obj_t user_error_location_137_tools_error(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t __cnst[20];

DEFINE_STATIC_PROCEDURE(impuse_finalizer_env_73_module_impuse, _impuse_finalizer_29_module_impuse1636, _impuse_finalizer_29_module_impuse, 0L, 0);
DEFINE_EXPORT_PROCEDURE(make_use_compiler_env_17_module_impuse, _make_use_compiler_39_module_impuse1637, _make_use_compiler_39_module_impuse, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc1617_module_impuse, _anonymous_1244__114_module_impuse1638, _anonymous_1244__114_module_impuse, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc1616_module_impuse, _anonymous_1245__211_module_impuse1639, _anonymous_1245__211_module_impuse, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc1615_module_impuse, _anonymous_1246__233_module_impuse1640, _anonymous_1246__233_module_impuse, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc1614_module_impuse, _anonymous_1235__94_module_impuse1641, _anonymous_1235__94_module_impuse, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc1613_module_impuse, _anonymous_1236__226_module_impuse1642, _anonymous_1236__226_module_impuse, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc1612_module_impuse, _anonymous_1227__149_module_impuse1643, _anonymous_1227__149_module_impuse, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc1611_module_impuse, _anonymous_1228__29_module_impuse1644, _anonymous_1228__29_module_impuse, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc1610_module_impuse, _anonymous_1229__9_module_impuse1645, _anonymous_1229__9_module_impuse, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_import_compiler_env_82_module_impuse, _make_import_compiler_114_module_impuse1646, _make_import_compiler_114_module_impuse, 0L, 0);
DEFINE_EXPORT_PROCEDURE(import_parser_env_92_module_impuse, _import_parser1609_204_module_impuse1647, _import_parser1609_204_module_impuse, 0L, 2);
DEFINE_EXPORT_PROCEDURE(import_with_module__env_62_module_impuse, _import_with_module_1608_46_module_impuse1648, _import_with_module_1608_46_module_impuse, 0L, 2);
DEFINE_EXPORT_PROCEDURE(get_imported_modules_env_216_module_impuse, _get_imported_modules_109_module_impuse1649, _get_imported_modules_109_module_impuse, 0L, 0);
DEFINE_STRING(string1631_module_impuse, string1631_module_impuse1650, "SIFUN WIDE-CLASS FINAL-CLASS CLASS SVAR (SFUN SIFUN SGFUN) (IMPORT WITH FROM) @ FROM::STRING CHECKSUM::LONG UNIT IMPORTED-MODULES NOTHING WITH IMODE ALL FROM USE VOID IMPORT ", 174);
DEFINE_STRING(string1629_module_impuse, string1629_module_impuse1651, "Can't find such module", 22);
DEFINE_STRING(string1630_module_impuse, string1630_module_impuse1652, "Can't find exportation for these identifiers", 44);
DEFINE_STRING(string1628_module_impuse, string1628_module_impuse1653, "Can't open such file", 20);
DEFINE_STRING(string1627_module_impuse, string1627_module_impuse1654, "read-imported-module", 20);
DEFINE_STRING(string1626_module_impuse, string1626_module_impuse1655, "      [reading ", 15);
DEFINE_STRING(string1625_module_impuse, string1625_module_impuse1656, " module ", 8);
DEFINE_STRING(string1624_module_impuse, string1624_module_impuse1657, "]", 1);
DEFINE_STRING(string1623_module_impuse, string1623_module_impuse1658, "Illegal prototype", 17);
DEFINE_STRING(string1622_module_impuse, string1622_module_impuse1659, "Illegal `import/use' clause", 27);
DEFINE_STRING(string1621_module_impuse, string1621_module_impuse1660, "Illegal imported clause", 23);
DEFINE_STRING(string1619_module_impuse, string1619_module_impuse1661, "Illegal `", 9);
DEFINE_STRING(string1620_module_impuse, string1620_module_impuse1662, "Parse error", 11);
DEFINE_STRING(string1618_module_impuse, string1618_module_impuse1663, "' clause", 8);
DEFINE_EXPORT_PROCEDURE(make_from_compiler_env_143_module_impuse, _make_from_compiler_253_module_impuse1664, _make_from_compiler_253_module_impuse, 0L, 0);
DEFINE_STATIC_PROCEDURE(impuse_producer_env_151_module_impuse, _impuse_producer_249_module_impuse1665, _impuse_producer_249_module_impuse, 0L, 1);



/* module-initialization */
obj_t 
module_initialization_70_module_impuse(long checksum_1750, char *from_1751)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_module_impuse))
	{
	   require_initialization_114_module_impuse =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_module_impuse();
	   cnst_init_137_module_impuse();
	   imported_modules_init_94_module_impuse();
	   method_init_76_module_impuse();
	   toplevel_init_63_module_impuse();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_module_impuse()
{
   AN_OBJECT;
   {	/* Module/impuse.scm 14 */
      module_initialization_70___bexit(((long) 0), "MODULE_IMPUSE");
      module_initialization_70___eval(((long) 0), "MODULE_IMPUSE");
      module_initialization_70___os(((long) 0), "MODULE_IMPUSE");
      module_initialization_70___object(((long) 0), "MODULE_IMPUSE");
      module_initialization_70___error(((long) 0), "MODULE_IMPUSE");
      module_initialization_70___r4_strings_6_7(((long) 0), "MODULE_IMPUSE");
      module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "MODULE_IMPUSE");
      module_initialization_70___r4_control_features_6_9(((long) 0), "MODULE_IMPUSE");
      module_initialization_70___reader(((long) 0), "MODULE_IMPUSE");
      module_initialization_70___r4_ports_6_10_1(((long) 0), "MODULE_IMPUSE");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_module_impuse()
{
   AN_OBJECT;
   {	/* Module/impuse.scm 14 */
      {		/* Module/impuse.scm 14 */
	 obj_t cnst_port_138_1743;
	 cnst_port_138_1743 =
	    open_input_string(string1631_module_impuse);
	 {
	    long i_1744;
	    i_1744 = ((long) 19);
	  loop_1745:
	    {	/* Module/impuse.scm 14 */
	       bool_t test1632_1746;
	       test1632_1746 =
		  (i_1744 == ((long) -1));
	       if (test1632_1746)
		 {	/* Module/impuse.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Module/impuse.scm 14 */
		    {	/* Module/impuse.scm 14 */
		       obj_t arg1633_1747;
		       {	/* Module/impuse.scm 14 */
			  obj_t list1634_1748;
			  list1634_1748 =
			     MAKE_PAIR(cnst_port_138_1743, BNIL);
			  arg1633_1747 =
			     read___reader(list1634_1748);
		       }
		       CNST_TABLE_SET(i_1744, arg1633_1747);
		    }
		    {	/* Module/impuse.scm 14 */
		       int aux_1749;
		       {	/* Module/impuse.scm 14 */
			  long aux_1776;
			  aux_1776 =
			     (i_1744 - ((long) 1));
			  aux_1749 =
			     (int) (aux_1776);
		       }
		       {
			  long i_1779;
			  i_1779 =
			     (long) (aux_1749);
			  i_1744 = i_1779;
			  goto loop_1745;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_module_impuse()
{
   AN_OBJECT;
   {	/* Module/impuse.scm 14 */
      _import_module_list__76_module_impuse = BNIL;
      return (
	 _imported_module_list__84_module_impuse = BNIL, BUNSPEC);
   }
}



/* make-import-compiler */
obj_t 
make_import_compiler_148_module_impuse()
{
   AN_OBJECT;
   {	/* Module/impuse.scm 47 */
      {		/* Module/impuse.scm 48 */
	 obj_t arg1220_386;
	 arg1220_386 =
	    CNST_TABLE_REF(((long) 0));
	 {	/* ./Module/module.scm 824 */
	    obj_t _anonymous_1229__9_1655;
	    obj_t _anonymous_1228__29_1656;
	    obj_t _anonymous_1227__149_1657;
	    _anonymous_1229__9_1655 = proc1610_module_impuse;
	    _anonymous_1228__29_1656 = proc1611_module_impuse;
	    _anonymous_1227__149_1657 = proc1612_module_impuse;
	    {	/* Module/impuse.scm 48 */
	       ccomp_bglt res1605_1045;
	       {	/* ./Module/module.scm 816 */
		  ccomp_bglt new1002_1036;
		  new1002_1036 =
		     ((ccomp_bglt) BREF(GC_MALLOC(sizeof(struct ccomp))));
		  {	/* ./Module/module.scm 816 */
		     long arg1602_1037;
		     arg1602_1037 =
			class_num_218___object(ccomp_module_module);
		     {	/* ./Module/module.scm 816 */
			obj_t obj_1043;
			obj_1043 =
			   (obj_t) (new1002_1036);
			(((obj_t) CREF(obj_1043))->header = MAKE_HEADER(arg1602_1037, 0), BUNSPEC);
		     }
		  }
		  {	/* ./Module/module.scm 816 */
		     object_bglt aux_1786;
		     aux_1786 =
			(object_bglt) (new1002_1036);
		     OBJECT_WIDENING_SET(aux_1786, BFALSE);
		  }
		  ((((ccomp_bglt) CREF(new1002_1036))->id) = ((obj_t) arg1220_386), BUNSPEC);
		  ((((ccomp_bglt) CREF(new1002_1036))->producer) = ((obj_t) impuse_producer_env_151_module_impuse), BUNSPEC);
		  ((((ccomp_bglt) CREF(new1002_1036))->consumer) = ((obj_t) _anonymous_1227__149_1657), BUNSPEC);
		  ((((ccomp_bglt) CREF(new1002_1036))->finalizer) = ((obj_t) _anonymous_1228__29_1656), BUNSPEC);
		  ((((ccomp_bglt) CREF(new1002_1036))->checksummer) = ((obj_t) _anonymous_1229__9_1655), BUNSPEC);
		  res1605_1045 = new1002_1036;
	       }
	       return
		  (obj_t) (res1605_1045);
	    }
	 }
      }
   }
}



/* _make-import-compiler */
obj_t 
_make_import_compiler_114_module_impuse(obj_t env_1658)
{
   AN_OBJECT;
   {	/* Module/impuse.scm 47 */
      return
	 make_import_compiler_148_module_impuse();
   }
}



/* <anonymous:1229> */
obj_t 
_anonymous_1229__9_module_impuse(obj_t env_1659, obj_t m_1660, obj_t c_1661)
{
   AN_OBJECT;
   {	/* ./Module/module.scm 829 */
      {
	 obj_t m_395;
	 obj_t c_396;
	 m_395 = m_1660;
	 c_396 = c_1661;
	 return c_396;
      }
   }
}



/* <anonymous:1228> */
obj_t 
_anonymous_1228__29_module_impuse(obj_t env_1662)
{
   AN_OBJECT;
   {	/* ./Module/module.scm 826 */
      {

	 return
	    CNST_TABLE_REF(((long) 1));
      }
   }
}



/* <anonymous:1227> */
obj_t 
_anonymous_1227__149_module_impuse(obj_t env_1663, obj_t m_1664, obj_t c_1665)
{
   AN_OBJECT;
   {	/* ./Module/module.scm 824 */
      {
	 obj_t m_391;
	 obj_t c_392;
	 m_391 = m_1664;
	 c_392 = c_1665;
	 return BNIL;
      }
   }
}



/* make-use-compiler */
obj_t 
make_use_compiler_106_module_impuse()
{
   AN_OBJECT;
   {	/* Module/impuse.scm 54 */
      {		/* Module/impuse.scm 55 */
	 obj_t arg1230_401;
	 arg1230_401 =
	    CNST_TABLE_REF(((long) 2));
	 {	/* ./Module/module.scm 824 */
	    obj_t _anonymous_1236__226_1668;
	    obj_t _anonymous_1235__94_1669;
	    _anonymous_1236__226_1668 = proc1613_module_impuse;
	    _anonymous_1235__94_1669 = proc1614_module_impuse;
	    {	/* Module/impuse.scm 55 */
	       ccomp_bglt res1606_1058;
	       {	/* ./Module/module.scm 816 */
		  ccomp_bglt new1002_1049;
		  new1002_1049 =
		     ((ccomp_bglt) BREF(GC_MALLOC(sizeof(struct ccomp))));
		  {	/* ./Module/module.scm 816 */
		     long arg1602_1050;
		     arg1602_1050 =
			class_num_218___object(ccomp_module_module);
		     {	/* ./Module/module.scm 816 */
			obj_t obj_1056;
			obj_1056 =
			   (obj_t) (new1002_1049);
			(((obj_t) CREF(obj_1056))->header = MAKE_HEADER(arg1602_1050, 0), BUNSPEC);
		     }
		  }
		  {	/* ./Module/module.scm 816 */
		     object_bglt aux_1802;
		     aux_1802 =
			(object_bglt) (new1002_1049);
		     OBJECT_WIDENING_SET(aux_1802, BFALSE);
		  }
		  ((((ccomp_bglt) CREF(new1002_1049))->id) = ((obj_t) arg1230_401), BUNSPEC);
		  ((((ccomp_bglt) CREF(new1002_1049))->producer) = ((obj_t) impuse_producer_env_151_module_impuse), BUNSPEC);
		  ((((ccomp_bglt) CREF(new1002_1049))->consumer) = ((obj_t) _anonymous_1235__94_1669), BUNSPEC);
		  ((((ccomp_bglt) CREF(new1002_1049))->finalizer) = ((obj_t) impuse_finalizer_env_73_module_impuse), BUNSPEC);
		  ((((ccomp_bglt) CREF(new1002_1049))->checksummer) = ((obj_t) _anonymous_1236__226_1668), BUNSPEC);
		  res1606_1058 = new1002_1049;
	       }
	       return
		  (obj_t) (res1606_1058);
	    }
	 }
      }
   }
}



/* _make-use-compiler */
obj_t 
_make_use_compiler_39_module_impuse(obj_t env_1670)
{
   AN_OBJECT;
   {	/* Module/impuse.scm 54 */
      return
	 make_use_compiler_106_module_impuse();
   }
}



/* <anonymous:1236> */
obj_t 
_anonymous_1236__226_module_impuse(obj_t env_1671, obj_t m_1672, obj_t c_1673)
{
   AN_OBJECT;
   {	/* ./Module/module.scm 829 */
      {
	 obj_t m_409;
	 obj_t c_410;
	 m_409 = m_1672;
	 c_410 = c_1673;
	 return c_410;
      }
   }
}



/* <anonymous:1235> */
obj_t 
_anonymous_1235__94_module_impuse(obj_t env_1674, obj_t m_1675, obj_t c_1676)
{
   AN_OBJECT;
   {	/* ./Module/module.scm 824 */
      {
	 obj_t m_406;
	 obj_t c_407;
	 m_406 = m_1675;
	 c_407 = c_1676;
	 return BNIL;
      }
   }
}



/* make-from-compiler */
obj_t 
make_from_compiler_140_module_impuse()
{
   AN_OBJECT;
   {	/* Module/impuse.scm 62 */
      {		/* Module/impuse.scm 63 */
	 obj_t arg1237_414;
	 arg1237_414 =
	    CNST_TABLE_REF(((long) 3));
	 {	/* Module/impuse.scm 65 */
	    obj_t _anonymous_1246__233_1678;
	    obj_t _anonymous_1245__211_1679;
	    obj_t _anonymous_1244__114_1680;
	    _anonymous_1246__233_1678 = proc1615_module_impuse;
	    _anonymous_1245__211_1679 = proc1616_module_impuse;
	    _anonymous_1244__114_1680 = proc1617_module_impuse;
	    {	/* Module/impuse.scm 63 */
	       ccomp_bglt res1607_1070;
	       {	/* ./Module/module.scm 816 */
		  ccomp_bglt new1002_1061;
		  new1002_1061 =
		     ((ccomp_bglt) BREF(GC_MALLOC(sizeof(struct ccomp))));
		  {	/* ./Module/module.scm 816 */
		     long arg1602_1062;
		     arg1602_1062 =
			class_num_218___object(ccomp_module_module);
		     {	/* ./Module/module.scm 816 */
			obj_t obj_1068;
			obj_1068 =
			   (obj_t) (new1002_1061);
			(((obj_t) CREF(obj_1068))->header = MAKE_HEADER(arg1602_1062, 0), BUNSPEC);
		     }
		  }
		  {	/* ./Module/module.scm 816 */
		     object_bglt aux_1817;
		     aux_1817 =
			(object_bglt) (new1002_1061);
		     OBJECT_WIDENING_SET(aux_1817, BFALSE);
		  }
		  ((((ccomp_bglt) CREF(new1002_1061))->id) = ((obj_t) arg1237_414), BUNSPEC);
		  ((((ccomp_bglt) CREF(new1002_1061))->producer) = ((obj_t) impuse_producer_env_151_module_impuse), BUNSPEC);
		  ((((ccomp_bglt) CREF(new1002_1061))->consumer) = ((obj_t) _anonymous_1244__114_1680), BUNSPEC);
		  ((((ccomp_bglt) CREF(new1002_1061))->finalizer) = ((obj_t) _anonymous_1245__211_1679), BUNSPEC);
		  ((((ccomp_bglt) CREF(new1002_1061))->checksummer) = ((obj_t) _anonymous_1246__233_1678), BUNSPEC);
		  res1607_1070 = new1002_1061;
	       }
	       return
		  (obj_t) (res1607_1070);
	    }
	 }
      }
   }
}



/* _make-from-compiler */
obj_t 
_make_from_compiler_253_module_impuse(obj_t env_1681)
{
   AN_OBJECT;
   {	/* Module/impuse.scm 62 */
      return
	 make_from_compiler_140_module_impuse();
   }
}



/* <anonymous:1246> */
obj_t 
_anonymous_1246__233_module_impuse(obj_t env_1682, obj_t m_1683, obj_t c_1684)
{
   AN_OBJECT;
   {	/* ./Module/module.scm 829 */
      {
	 obj_t m_423;
	 obj_t c_424;
	 m_423 = m_1683;
	 c_424 = c_1684;
	 return c_424;
      }
   }
}



/* <anonymous:1245> */
obj_t 
_anonymous_1245__211_module_impuse(obj_t env_1685)
{
   AN_OBJECT;
   {	/* ./Module/module.scm 826 */
      {

	 return
	    CNST_TABLE_REF(((long) 1));
      }
   }
}



/* <anonymous:1244> */
obj_t 
_anonymous_1244__114_module_impuse(obj_t env_1686, obj_t module_1687, obj_t clause_1688)
{
   AN_OBJECT;
   {	/* Module/impuse.scm 65 */
      {
	 obj_t module_419;
	 obj_t clause_420;
	 module_419 = module_1687;
	 clause_420 = clause_1688;
	 impuse_producer_187_module_impuse(clause_420);
	 return BNIL;
      }
   }
}



/* impuse-producer */
obj_t 
impuse_producer_187_module_impuse(obj_t clause_19)
{
   AN_OBJECT;
   {	/* Module/impuse.scm 72 */
      {		/* Module/impuse.scm 73 */
	 obj_t mode_429;
	 mode_429 =
	    CAR(clause_19);
	 {
	    obj_t protos_430;
	    if (
	       PAIRP(clause_19))
	      {		/* Module/impuse.scm 74 */
		 bool_t aux_1832;
		 protos_430 =
		    CDR(clause_19);
		 {
		    obj_t l1195_436;
		    l1195_436 = protos_430;
		  lname1196_437:
		    if (
		       PAIRP(l1195_436))
		      {		/* Module/impuse.scm 76 */
			 impuse_parser_37_module_impuse(
			    CAR(l1195_436), mode_429);
			 {
			    obj_t l1195_1837;
			    l1195_1837 =
			       CDR(l1195_436);
			    l1195_436 = l1195_1837;
			    goto lname1196_437;
			 }
		      }
		    else
		      {		/* Module/impuse.scm 76 */
			 aux_1832 = ((bool_t) 1);
		      }
		 }
		 return
		    BBOOL(aux_1832);
	      }
	    else
	      {		/* Module/impuse.scm 74 */
		 {	/* Module/impuse.scm 78 */
		    obj_t arg1251_441;
		    obj_t arg1253_443;
		    arg1251_441 =
		       find_location_120_tools_location(_module_clause__117_module_module);
		    {	/* Module/impuse.scm 80 */
		       obj_t arg1257_447;
		       {	/* Module/impuse.scm 82 */
			  obj_t arg1258_448;
			  {	/* Module/impuse.scm 82 */
			     obj_t arg1260_450;
			     arg1260_450 =
				SYMBOL_TO_STRING(mode_429);
			     arg1258_448 =
				string_downcase_77___r4_strings_6_7(arg1260_450);
			  }
			  arg1257_447 =
			     string_append(arg1258_448, string1618_module_impuse);
		       }
		       arg1253_443 =
			  string_append(string1619_module_impuse, arg1257_447);
		    }
		    {	/* Module/impuse.scm 78 */
		       obj_t list1255_445;
		       list1255_445 =
			  MAKE_PAIR(BNIL, BNIL);
		       return
			  user_error_location_137_tools_error(arg1251_441, string1620_module_impuse, arg1253_443, clause_19, list1255_445);
		    }
		 }
	      }
	 }
      }
   }
}



/* _impuse-producer */
obj_t 
_impuse_producer_249_module_impuse(obj_t env_1666, obj_t clause_1667)
{
   AN_OBJECT;
   {	/* Module/impuse.scm 72 */
      return
	 impuse_producer_187_module_impuse(clause_1667);
   }
}



/* import-all-module */
obj_t 
import_all_module_109_module_impuse(obj_t module_20, obj_t mode_21, obj_t loc_22)
{
   AN_OBJECT;
   {	/* Module/impuse.scm 90 */
      {		/* Module/impuse.scm 91 */
	 obj_t b_451;
	 b_451 =
	    assq___r4_pairs_and_lists_6_3(module_20, _import_module_list__76_module_impuse);
	 if (
	    PAIRP(b_451))
	   {	/* ./Llib/struct.scm 1463 */
	      obj_t x_1742;
	      {		/* ./Llib/struct.scm 1463 */
		 obj_t aux_1854;
		 obj_t aux_1852;
		 aux_1854 =
		    CNST_TABLE_REF(((long) 4));
		 aux_1852 =
		    CDR(b_451);
		 x_1742 =
		    STRUCT_SET(aux_1852, ((long) 2), aux_1854);
	      }
	      return BUNSPEC;
	   }
	 else
	   {	/* Module/impuse.scm 95 */
	      obj_t arg1265_455;
	      {		/* Module/impuse.scm 95 */
		 obj_t arg1267_456;
		 {	/* Module/impuse.scm 95 */
		    obj_t vars_1087;
		    vars_1087 =
		       CNST_TABLE_REF(((long) 4));
		    {	/* Module/impuse.scm 190 */
		       obj_t new_1090;
		       {	/* Module/impuse.scm 190 */
			  obj_t aux_1858;
			  aux_1858 =
			     CNST_TABLE_REF(((long) 5));
			  new_1090 =
			     create_struct(aux_1858, ((long) 5));
		       }
		       STRUCT_SET(new_1090, ((long) 4), loc_22);
		       STRUCT_SET(new_1090, ((long) 3), BUNSPEC);
		       STRUCT_SET(new_1090, ((long) 2), vars_1087);
		       STRUCT_SET(new_1090, ((long) 1), mode_21);
		       STRUCT_SET(new_1090, ((long) 0), module_20);
		       arg1267_456 = new_1090;
		    }
		 }
		 arg1265_455 =
		    MAKE_PAIR(module_20, arg1267_456);
	      }
	      {		/* Module/impuse.scm 95 */
		 obj_t obj2_1119;
		 obj2_1119 = _import_module_list__76_module_impuse;
		 return (
		    _import_module_list__76_module_impuse =
		    MAKE_PAIR(arg1265_455, obj2_1119), BUNSPEC);
	      }
	   }
      }
   }
}



/* import-1-module */
obj_t 
import_1_module_184_module_impuse(obj_t module_23, obj_t var_24, obj_t mode_25, obj_t loc_26)
{
   AN_OBJECT;
   {	/* Module/impuse.scm 101 */
      {		/* Module/impuse.scm 102 */
	 obj_t cell_457;
	 cell_457 =
	    assq___r4_pairs_and_lists_6_3(module_23, _import_module_list__76_module_impuse);
	 if (
	    PAIRP(cell_457))
	   {	/* Module/impuse.scm 111 */
	      obj_t b_459;
	      b_459 =
		 CDR(cell_457);
	      {		/* Module/impuse.scm 112 */
		 obj_t case_value_58_460;
		 case_value_58_460 =
		    STRUCT_REF(b_459, ((long) 2));
		 {	/* Module/impuse.scm 112 */
		    bool_t test_1873;
		    {	/* ./Ieee/equiv.scm 5508 */
		       obj_t aux_1874;
		       aux_1874 =
			  CNST_TABLE_REF(((long) 6));
		       test_1873 =
			  (case_value_58_460 == aux_1874);
		    }
		    if (test_1873)
		      {		/* Module/impuse.scm 112 */
			 STRUCT_SET(b_459, ((long) 1), mode_25);
			 {	/* Module/impuse.scm 115 */
			    obj_t arg1270_462;
			    {	/* Module/impuse.scm 115 */
			       obj_t list1271_463;
			       list1271_463 =
				  MAKE_PAIR(var_24, BNIL);
			       arg1270_462 = list1271_463;
			    }
			    return
			       STRUCT_SET(b_459, ((long) 2), arg1270_462);
			 }
		      }
		    else
		      {		/* Module/impuse.scm 112 */
			 bool_t test_1880;
			 {	/* ./Ieee/equiv.scm 5508 */
			    obj_t aux_1881;
			    aux_1881 =
			       CNST_TABLE_REF(((long) 4));
			    test_1880 =
			       (case_value_58_460 == aux_1881);
			 }
			 if (test_1880)
			   {	/* Module/impuse.scm 112 */
			      return
				 CNST_TABLE_REF(((long) 7));
			   }
			 else
			   {	/* Module/impuse.scm 119 */
			      obj_t arg1273_465;
			      arg1273_465 =
				 MAKE_PAIR(var_24, case_value_58_460);
			      return
				 STRUCT_SET(b_459, ((long) 2), arg1273_465);
			   }
		      }
		 }
	      }
	   }
	 else
	   {	/* Module/impuse.scm 107 */
	      obj_t arg1276_467;
	      {		/* Module/impuse.scm 107 */
		 obj_t arg1277_468;
		 {	/* Module/impuse.scm 107 */
		    obj_t arg1278_469;
		    {	/* Module/impuse.scm 107 */
		       obj_t list1279_470;
		       list1279_470 =
			  MAKE_PAIR(var_24, BNIL);
		       arg1278_469 = list1279_470;
		    }
		    {	/* Module/impuse.scm 190 */
		       obj_t new_1156;
		       {	/* Module/impuse.scm 190 */
			  obj_t aux_1888;
			  aux_1888 =
			     CNST_TABLE_REF(((long) 5));
			  new_1156 =
			     create_struct(aux_1888, ((long) 5));
		       }
		       STRUCT_SET(new_1156, ((long) 4), loc_26);
		       STRUCT_SET(new_1156, ((long) 3), BUNSPEC);
		       STRUCT_SET(new_1156, ((long) 2), arg1278_469);
		       STRUCT_SET(new_1156, ((long) 1), mode_25);
		       STRUCT_SET(new_1156, ((long) 0), module_23);
		       arg1277_468 = new_1156;
		    }
		 }
		 arg1276_467 =
		    MAKE_PAIR(module_23, arg1277_468);
	      }
	      {		/* Module/impuse.scm 105 */
		 obj_t obj2_1185;
		 obj2_1185 = _import_module_list__76_module_impuse;
		 return (
		    _import_module_list__76_module_impuse =
		    MAKE_PAIR(arg1276_467, obj2_1185), BUNSPEC);
	      }
	   }
      }
   }
}



/* import-with-module! */
obj_t 
import_with_module__247_module_impuse(obj_t module_27, obj_t loc_28)
{
   AN_OBJECT;
   {	/* Module/impuse.scm 124 */
      {		/* Module/impuse.scm 125 */
	 obj_t b_471;
	 b_471 =
	    assq___r4_pairs_and_lists_6_3(module_27, _import_module_list__76_module_impuse);
	 if (
	    PAIRP(b_471))
	   {	/* Module/impuse.scm 126 */
	      return BUNSPEC;
	   }
	 else
	   {	/* Module/impuse.scm 128 */
	      obj_t arg1281_473;
	      {		/* Module/impuse.scm 128 */
		 obj_t arg1282_474;
		 {	/* Module/impuse.scm 128 */
		    obj_t mode_1188;
		    mode_1188 =
		       CNST_TABLE_REF(((long) 6));
		    {	/* Module/impuse.scm 190 */
		       obj_t new_1192;
		       {	/* Module/impuse.scm 190 */
			  obj_t aux_1902;
			  aux_1902 =
			     CNST_TABLE_REF(((long) 5));
			  new_1192 =
			     create_struct(aux_1902, ((long) 5));
		       }
		       STRUCT_SET(new_1192, ((long) 4), loc_28);
		       {	/* ./Llib/struct.scm 1463 */
			  obj_t aux_1906;
			  aux_1906 =
			     BINT(((long) 0));
			  STRUCT_SET(new_1192, ((long) 3), aux_1906);
		       }
		       STRUCT_SET(new_1192, ((long) 2), BNIL);
		       STRUCT_SET(new_1192, ((long) 1), mode_1188);
		       STRUCT_SET(new_1192, ((long) 0), module_27);
		       arg1282_474 = new_1192;
		    }
		 }
		 arg1281_473 =
		    MAKE_PAIR(module_27, arg1282_474);
	      }
	      {		/* Module/impuse.scm 128 */
		 obj_t obj2_1221;
		 obj2_1221 = _import_module_list__76_module_impuse;
		 return (
		    _import_module_list__76_module_impuse =
		    MAKE_PAIR(arg1281_473, obj2_1221), BUNSPEC);
	      }
	   }
      }
   }
}



/* _import-with-module!1608 */
obj_t 
_import_with_module_1608_46_module_impuse(obj_t env_1689, obj_t module_1690, obj_t loc_1691)
{
   AN_OBJECT;
   {	/* Module/impuse.scm 124 */
      return
	 import_with_module__247_module_impuse(module_1690, loc_1691);
   }
}



/* impuse-parser */
obj_t 
impuse_parser_37_module_impuse(obj_t prototype_29, obj_t mode_30)
{
   AN_OBJECT;
   {	/* Module/impuse.scm 140 */
      {
	 obj_t v_482;
	 obj_t m_483;
	 obj_t f_484;
	 obj_t rest_485;
	 obj_t module_475;
	 obj_t fname_476;
	 obj_t rest_477;
	 if (
	    PAIRP(prototype_29))
	   {	/* Module/impuse.scm 142 */
	      obj_t car_144_227_492;
	      obj_t cdr_145_238_493;
	      car_144_227_492 =
		 CAR(prototype_29);
	      cdr_145_238_493 =
		 CDR(prototype_29);
	      if (
		 SYMBOLP(car_144_227_492))
		{	/* Module/impuse.scm 142 */
		   if (
		      PAIRP(cdr_145_238_493))
		     {	/* Module/impuse.scm 142 */
			obj_t car_150_99_496;
			car_150_99_496 =
			   CAR(cdr_145_238_493);
			if (
			   STRINGP(car_150_99_496))
			  {	/* Module/impuse.scm 142 */
			     module_475 = car_144_227_492;
			     fname_476 = car_150_99_496;
			     rest_477 =
				CDR(cdr_145_238_493);
			     {
				obj_t rest_605;
				obj_t fnames_606;
				{	/* Module/impuse.scm 146 */
				   obj_t arg1361_608;
				   {	/* Module/impuse.scm 146 */
				      obj_t list1362_609;
				      list1362_609 =
					 MAKE_PAIR(fname_476, BNIL);
				      arg1361_608 = list1362_609;
				   }
				   rest_605 = rest_477;
				   fnames_606 = arg1361_608;
				 loop_607:
				   if (
				      NULLP(rest_605))
				     {	/* Module/impuse.scm 148 */
					{	/* Module/impuse.scm 149 */
					   obj_t arg1365_611;
					   arg1365_611 =
					      reverse__39___r4_pairs_and_lists_6_3(fnames_606);
					   add_access__140_read_access(module_475, arg1365_611);
					}
					{	/* Module/impuse.scm 150 */
					   obj_t arg1366_612;
					   arg1366_612 =
					      find_location_120_tools_location(prototype_29);
					   return
					      import_all_module_109_module_impuse(module_475, mode_30, arg1366_612);
					}
				     }
				   else
				     {	/* Module/impuse.scm 151 */
					bool_t test_1933;
					{	/* ./Ieee/string.scm 8047 */
					   obj_t aux_1934;
					   aux_1934 =
					      CAR(rest_605);
					   test_1933 =
					      STRINGP(aux_1934);
					}
					if (test_1933)
					  {	/* Module/impuse.scm 151 */
					     {	/* Module/impuse.scm 152 */
						obj_t arg1369_614;
						obj_t arg1371_615;
						arg1369_614 =
						   CDR(rest_605);
						{	/* ./Ieee/pair-list.scm 5689 */
						   obj_t aux_1938;
						   aux_1938 =
						      CAR(rest_605);
						   arg1371_615 =
						      MAKE_PAIR(aux_1938, fnames_606);
						}
						{
						   obj_t fnames_1942;
						   obj_t rest_1941;
						   rest_1941 = arg1369_614;
						   fnames_1942 = arg1371_615;
						   fnames_606 = fnames_1942;
						   rest_605 = rest_1941;
						   goto loop_607;
						}
					     }
					  }
					else
					  {	/* Module/impuse.scm 151 */
					     {	/* Module/impuse.scm 155 */
						obj_t list1373_617;
						list1373_617 =
						   MAKE_PAIR(BNIL, BNIL);
						return
						   user_error_151_tools_error(string1620_module_impuse, string1621_module_impuse, prototype_29, list1373_617);
					     }
					  }
				     }
				}
			     }
			  }
			else
			  {	/* Module/impuse.scm 142 */
			     if (
				SYMBOLP(car_144_227_492))
			       {	/* Module/impuse.scm 142 */
				  obj_t car_173_126_502;
				  car_173_126_502 =
				     CAR(cdr_145_238_493);
				  if (
				     SYMBOLP(car_173_126_502))
				    {	/* Module/impuse.scm 142 */
				       bool_t test_1951;
				       {	/* ./Ieee/equiv.scm 5508 */
					  obj_t aux_1952;
					  aux_1952 =
					     CDR(cdr_145_238_493);
					  test_1951 =
					     (aux_1952 == BNIL);
				       }
				       if (test_1951)
					 {	/* Module/impuse.scm 161 */
					    obj_t arg1375_1240;
					    arg1375_1240 =
					       find_location_120_tools_location(prototype_29);
					    return
					       import_1_module_184_module_impuse(car_173_126_502, car_144_227_492, mode_30, arg1375_1240);
					 }
				       else
					 {	/* Module/impuse.scm 142 */
					    if (
					       SYMBOLP(car_144_227_492))
					      {		/* Module/impuse.scm 142 */
						 obj_t car_196_45_508;
						 obj_t cdr_197_63_509;
						 car_196_45_508 =
						    CAR(cdr_145_238_493);
						 cdr_197_63_509 =
						    CDR(cdr_145_238_493);
						 if (
						    SYMBOLP(car_196_45_508))
						   {	/* Module/impuse.scm 142 */
						      if (
							 PAIRP(cdr_197_63_509))
							{	/* Module/impuse.scm 142 */
							   obj_t car_203_140_512;
							   car_203_140_512 =
							      CAR(cdr_197_63_509);
							   if (
							      STRINGP(car_203_140_512))
							     {	/* Module/impuse.scm 142 */
								v_482 = car_144_227_492;
								m_483 = car_196_45_508;
								f_484 = car_203_140_512;
								rest_485 =
								   CDR(cdr_197_63_509);
							      tag_130_214_486:
								{
								   obj_t rest_620;
								   obj_t fnames_621;
								   {	/* Module/impuse.scm 165 */
								      obj_t arg1376_623;
								      {		/* Module/impuse.scm 165 */
									 obj_t list1377_624;
									 list1377_624 =
									    MAKE_PAIR(f_484, BNIL);
									 arg1376_623 = list1377_624;
								      }
								      rest_620 = rest_485;
								      fnames_621 = arg1376_623;
								    loop_622:
								      if (
									 NULLP(rest_620))
									{	/* Module/impuse.scm 167 */
									   {	/* Module/impuse.scm 168 */
									      obj_t arg1379_626;
									      arg1379_626 =
										 reverse__39___r4_pairs_and_lists_6_3(fnames_621);
									      add_access__140_read_access(m_483, arg1379_626);
									   }
									   {	/* Module/impuse.scm 169 */
									      obj_t arg1380_627;
									      arg1380_627 =
										 find_location_120_tools_location(prototype_29);
									      return
										 import_1_module_184_module_impuse(m_483, v_482, mode_30, arg1380_627);
									   }
									}
								      else
									{	/* Module/impuse.scm 170 */
									   bool_t test_1975;
									   {	/* ./Ieee/string.scm 8047 */
									      obj_t aux_1976;
									      aux_1976 =
										 CAR(rest_620);
									      test_1975 =
										 STRINGP(aux_1976);
									   }
									   if (test_1975)
									     {	/* Module/impuse.scm 170 */
										{	/* Module/impuse.scm 171 */
										   obj_t arg1383_629;
										   obj_t arg1384_630;
										   arg1383_629 =
										      CDR(rest_620);
										   {	/* ./Ieee/pair-list.scm 5689 */
										      obj_t aux_1980;
										      aux_1980 =
											 CAR(rest_620);
										      arg1384_630 =
											 MAKE_PAIR(aux_1980, fnames_621);
										   }
										   {
										      obj_t fnames_1984;
										      obj_t rest_1983;
										      rest_1983 = arg1383_629;
										      fnames_1984 = arg1384_630;
										      fnames_621 = fnames_1984;
										      rest_620 = rest_1983;
										      goto loop_622;
										   }
										}
									     }
									   else
									     {	/* Module/impuse.scm 170 */
										{	/* Module/impuse.scm 173 */
										   obj_t list1386_632;
										   list1386_632 =
										      MAKE_PAIR(BNIL, BNIL);
										   return
										      user_error_151_tools_error(string1620_module_impuse, string1621_module_impuse, prototype_29, list1386_632);
										}
									     }
									}
								   }
								}
							     }
							   else
							     {	/* Module/impuse.scm 142 */
								if (
								   SYMBOLP(prototype_29))
								  {	/* Module/impuse.scm 179 */
								     obj_t arg1389_1253;
								     arg1389_1253 =
									find_location_120_tools_location(_module_clause__117_module_module);
								     return
									import_all_module_109_module_impuse(prototype_29, mode_30, arg1389_1253);
								  }
								else
								  {	/* Module/impuse.scm 142 */
								   tag_132_226_489:
								     {	/* Module/impuse.scm 181 */
									obj_t arg1390_635;
									arg1390_635 =
									   find_location_120_tools_location(_module_clause__117_module_module);
									{	/* Module/impuse.scm 181 */
									   obj_t list1395_639;
									   list1395_639 =
									      MAKE_PAIR(BNIL, BNIL);
									   return
									      user_error_location_137_tools_error(arg1390_635, string1620_module_impuse, string1622_module_impuse, prototype_29, list1395_639);
									}
								     }
								  }
							     }
							}
						      else
							{	/* Module/impuse.scm 142 */
							   if (
							      SYMBOLP(prototype_29))
							     {	/* Module/impuse.scm 179 */
								obj_t arg1389_1256;
								arg1389_1256 =
								   find_location_120_tools_location(_module_clause__117_module_module);
								return
								   import_all_module_109_module_impuse(prototype_29, mode_30, arg1389_1256);
							     }
							   else
							     {	/* Module/impuse.scm 142 */
								goto tag_132_226_489;
							     }
							}
						   }
						 else
						   {	/* Module/impuse.scm 142 */
						      if (
							 SYMBOLP(prototype_29))
							{	/* Module/impuse.scm 179 */
							   obj_t arg1389_1259;
							   arg1389_1259 =
							      find_location_120_tools_location(_module_clause__117_module_module);
							   return
							      import_all_module_109_module_impuse(prototype_29, mode_30, arg1389_1259);
							}
						      else
							{	/* Module/impuse.scm 142 */
							   goto tag_132_226_489;
							}
						   }
					      }
					    else
					      {		/* Module/impuse.scm 142 */
						 if (
						    SYMBOLP(prototype_29))
						   {	/* Module/impuse.scm 179 */
						      obj_t arg1389_1262;
						      arg1389_1262 =
							 find_location_120_tools_location(_module_clause__117_module_module);
						      return
							 import_all_module_109_module_impuse(prototype_29, mode_30, arg1389_1262);
						   }
						 else
						   {	/* Module/impuse.scm 142 */
						      goto tag_132_226_489;
						   }
					      }
					 }
				    }
				  else
				    {	/* Module/impuse.scm 142 */
				       if (
					  SYMBOLP(car_144_227_492))
					 {	/* Module/impuse.scm 142 */
					    obj_t car_237_172_524;
					    obj_t cdr_238_48_525;
					    car_237_172_524 =
					       CAR(cdr_145_238_493);
					    cdr_238_48_525 =
					       CDR(cdr_145_238_493);
					    if (
					       SYMBOLP(car_237_172_524))
					      {		/* Module/impuse.scm 142 */
						 if (
						    PAIRP(cdr_238_48_525))
						   {	/* Module/impuse.scm 142 */
						      obj_t car_244_36_528;
						      car_244_36_528 =
							 CAR(cdr_238_48_525);
						      if (
							 STRINGP(car_244_36_528))
							{
							   obj_t rest_2021;
							   obj_t f_2020;
							   obj_t m_2019;
							   obj_t v_2018;
							   v_2018 = car_144_227_492;
							   m_2019 = car_237_172_524;
							   f_2020 = car_244_36_528;
							   rest_2021 =
							      CDR(cdr_238_48_525);
							   rest_485 = rest_2021;
							   f_484 = f_2020;
							   m_483 = m_2019;
							   v_482 = v_2018;
							   goto tag_130_214_486;
							}
						      else
							{	/* Module/impuse.scm 142 */
							   if (
							      SYMBOLP(prototype_29))
							     {	/* Module/impuse.scm 179 */
								obj_t arg1389_1275;
								arg1389_1275 =
								   find_location_120_tools_location(_module_clause__117_module_module);
								return
								   import_all_module_109_module_impuse(prototype_29, mode_30, arg1389_1275);
							     }
							   else
							     {	/* Module/impuse.scm 142 */
								goto tag_132_226_489;
							     }
							}
						   }
						 else
						   {	/* Module/impuse.scm 142 */
						      if (
							 SYMBOLP(prototype_29))
							{	/* Module/impuse.scm 179 */
							   obj_t arg1389_1278;
							   arg1389_1278 =
							      find_location_120_tools_location(_module_clause__117_module_module);
							   return
							      import_all_module_109_module_impuse(prototype_29, mode_30, arg1389_1278);
							}
						      else
							{	/* Module/impuse.scm 142 */
							   goto tag_132_226_489;
							}
						   }
					      }
					    else
					      {		/* Module/impuse.scm 142 */
						 if (
						    SYMBOLP(prototype_29))
						   {	/* Module/impuse.scm 179 */
						      obj_t arg1389_1281;
						      arg1389_1281 =
							 find_location_120_tools_location(_module_clause__117_module_module);
						      return
							 import_all_module_109_module_impuse(prototype_29, mode_30, arg1389_1281);
						   }
						 else
						   {	/* Module/impuse.scm 142 */
						      goto tag_132_226_489;
						   }
					      }
					 }
				       else
					 {	/* Module/impuse.scm 142 */
					    if (
					       SYMBOLP(prototype_29))
					      {		/* Module/impuse.scm 179 */
						 obj_t arg1389_1284;
						 arg1389_1284 =
						    find_location_120_tools_location(_module_clause__117_module_module);
						 return
						    import_all_module_109_module_impuse(prototype_29, mode_30, arg1389_1284);
					      }
					    else
					      {		/* Module/impuse.scm 142 */
						 goto tag_132_226_489;
					      }
					 }
				    }
			       }
			     else
			       {	/* Module/impuse.scm 142 */
				  if (
				     SYMBOLP(car_144_227_492))
				    {	/* Module/impuse.scm 142 */
				       obj_t car_280_133_538;
				       obj_t cdr_281_218_539;
				       car_280_133_538 =
					  CAR(cdr_145_238_493);
				       cdr_281_218_539 =
					  CDR(cdr_145_238_493);
				       if (
					  SYMBOLP(car_280_133_538))
					 {	/* Module/impuse.scm 142 */
					    if (
					       PAIRP(cdr_281_218_539))
					      {		/* Module/impuse.scm 142 */
						 obj_t car_289_221_542;
						 car_289_221_542 =
						    CAR(cdr_281_218_539);
						 if (
						    STRINGP(car_289_221_542))
						   {
						      obj_t rest_2053;
						      obj_t f_2052;
						      obj_t m_2051;
						      obj_t v_2050;
						      v_2050 = car_144_227_492;
						      m_2051 = car_280_133_538;
						      f_2052 = car_289_221_542;
						      rest_2053 =
							 CDR(cdr_281_218_539);
						      rest_485 = rest_2053;
						      f_484 = f_2052;
						      m_483 = m_2051;
						      v_482 = v_2050;
						      goto tag_130_214_486;
						   }
						 else
						   {	/* Module/impuse.scm 142 */
						      if (
							 SYMBOLP(prototype_29))
							{	/* Module/impuse.scm 179 */
							   obj_t arg1389_1297;
							   arg1389_1297 =
							      find_location_120_tools_location(_module_clause__117_module_module);
							   return
							      import_all_module_109_module_impuse(prototype_29, mode_30, arg1389_1297);
							}
						      else
							{	/* Module/impuse.scm 142 */
							   goto tag_132_226_489;
							}
						   }
					      }
					    else
					      {		/* Module/impuse.scm 142 */
						 if (
						    SYMBOLP(prototype_29))
						   {	/* Module/impuse.scm 179 */
						      obj_t arg1389_1300;
						      arg1389_1300 =
							 find_location_120_tools_location(_module_clause__117_module_module);
						      return
							 import_all_module_109_module_impuse(prototype_29, mode_30, arg1389_1300);
						   }
						 else
						   {	/* Module/impuse.scm 142 */
						      goto tag_132_226_489;
						   }
					      }
					 }
				       else
					 {	/* Module/impuse.scm 142 */
					    if (
					       SYMBOLP(prototype_29))
					      {		/* Module/impuse.scm 179 */
						 obj_t arg1389_1303;
						 arg1389_1303 =
						    find_location_120_tools_location(_module_clause__117_module_module);
						 return
						    import_all_module_109_module_impuse(prototype_29, mode_30, arg1389_1303);
					      }
					    else
					      {		/* Module/impuse.scm 142 */
						 goto tag_132_226_489;
					      }
					 }
				    }
				  else
				    {	/* Module/impuse.scm 142 */
				       if (
					  SYMBOLP(prototype_29))
					 {	/* Module/impuse.scm 179 */
					    obj_t arg1389_1306;
					    arg1389_1306 =
					       find_location_120_tools_location(_module_clause__117_module_module);
					    return
					       import_all_module_109_module_impuse(prototype_29, mode_30, arg1389_1306);
					 }
				       else
					 {	/* Module/impuse.scm 142 */
					    goto tag_132_226_489;
					 }
				    }
			       }
			  }
		     }
		   else
		     {	/* Module/impuse.scm 142 */
			if (
			   SYMBOLP(prototype_29))
			  {	/* Module/impuse.scm 179 */
			     obj_t arg1389_1309;
			     arg1389_1309 =
				find_location_120_tools_location(_module_clause__117_module_module);
			     return
				import_all_module_109_module_impuse(prototype_29, mode_30, arg1389_1309);
			  }
			else
			  {	/* Module/impuse.scm 142 */
			     goto tag_132_226_489;
			  }
		     }
		}
	      else
		{	/* Module/impuse.scm 142 */
		   if (
		      SYMBOLP(car_144_227_492))
		     {	/* Module/impuse.scm 142 */
			if (
			   PAIRP(cdr_145_238_493))
			  {	/* Module/impuse.scm 142 */
			     obj_t car_344_246_554;
			     car_344_246_554 =
				CAR(cdr_145_238_493);
			     if (
				SYMBOLP(car_344_246_554))
			       {	/* Module/impuse.scm 142 */
				  bool_t test_2082;
				  {	/* ./Ieee/equiv.scm 5508 */
				     obj_t aux_2083;
				     aux_2083 =
					CDR(cdr_145_238_493);
				     test_2082 =
					(aux_2083 == BNIL);
				  }
				  if (test_2082)
				    {	/* Module/impuse.scm 161 */
				       obj_t arg1375_1321;
				       arg1375_1321 =
					  find_location_120_tools_location(prototype_29);
				       return
					  import_1_module_184_module_impuse(car_344_246_554, car_144_227_492, mode_30, arg1375_1321);
				    }
				  else
				    {	/* Module/impuse.scm 142 */
				       if (
					  SYMBOLP(car_144_227_492))
					 {	/* Module/impuse.scm 142 */
					    obj_t car_367_38_560;
					    obj_t cdr_368_205_561;
					    car_367_38_560 =
					       CAR(cdr_145_238_493);
					    cdr_368_205_561 =
					       CDR(cdr_145_238_493);
					    if (
					       SYMBOLP(car_367_38_560))
					      {		/* Module/impuse.scm 142 */
						 if (
						    PAIRP(cdr_368_205_561))
						   {	/* Module/impuse.scm 142 */
						      obj_t car_376_57_564;
						      car_376_57_564 =
							 CAR(cdr_368_205_561);
						      if (
							 STRINGP(car_376_57_564))
							{
							   obj_t rest_2102;
							   obj_t f_2101;
							   obj_t m_2100;
							   obj_t v_2099;
							   v_2099 = car_144_227_492;
							   m_2100 = car_367_38_560;
							   f_2101 = car_376_57_564;
							   rest_2102 =
							      CDR(cdr_368_205_561);
							   rest_485 = rest_2102;
							   f_484 = f_2101;
							   m_483 = m_2100;
							   v_482 = v_2099;
							   goto tag_130_214_486;
							}
						      else
							{	/* Module/impuse.scm 142 */
							   if (
							      SYMBOLP(prototype_29))
							     {	/* Module/impuse.scm 179 */
								obj_t arg1389_1334;
								arg1389_1334 =
								   find_location_120_tools_location(_module_clause__117_module_module);
								return
								   import_all_module_109_module_impuse(prototype_29, mode_30, arg1389_1334);
							     }
							   else
							     {	/* Module/impuse.scm 142 */
								goto tag_132_226_489;
							     }
							}
						   }
						 else
						   {	/* Module/impuse.scm 142 */
						      if (
							 SYMBOLP(prototype_29))
							{	/* Module/impuse.scm 179 */
							   obj_t arg1389_1337;
							   arg1389_1337 =
							      find_location_120_tools_location(_module_clause__117_module_module);
							   return
							      import_all_module_109_module_impuse(prototype_29, mode_30, arg1389_1337);
							}
						      else
							{	/* Module/impuse.scm 142 */
							   goto tag_132_226_489;
							}
						   }
					      }
					    else
					      {		/* Module/impuse.scm 142 */
						 if (
						    SYMBOLP(prototype_29))
						   {	/* Module/impuse.scm 179 */
						      obj_t arg1389_1340;
						      arg1389_1340 =
							 find_location_120_tools_location(_module_clause__117_module_module);
						      return
							 import_all_module_109_module_impuse(prototype_29, mode_30, arg1389_1340);
						   }
						 else
						   {	/* Module/impuse.scm 142 */
						      goto tag_132_226_489;
						   }
					      }
					 }
				       else
					 {	/* Module/impuse.scm 142 */
					    if (
					       SYMBOLP(prototype_29))
					      {		/* Module/impuse.scm 179 */
						 obj_t arg1389_1343;
						 arg1389_1343 =
						    find_location_120_tools_location(_module_clause__117_module_module);
						 return
						    import_all_module_109_module_impuse(prototype_29, mode_30, arg1389_1343);
					      }
					    else
					      {		/* Module/impuse.scm 142 */
						 goto tag_132_226_489;
					      }
					 }
				    }
			       }
			     else
			       {	/* Module/impuse.scm 142 */
				  if (
				     SYMBOLP(car_144_227_492))
				    {	/* Module/impuse.scm 142 */
				       obj_t car_412_102_576;
				       obj_t cdr_413_22_577;
				       car_412_102_576 =
					  CAR(cdr_145_238_493);
				       cdr_413_22_577 =
					  CDR(cdr_145_238_493);
				       if (
					  SYMBOLP(car_412_102_576))
					 {	/* Module/impuse.scm 142 */
					    if (
					       PAIRP(cdr_413_22_577))
					      {		/* Module/impuse.scm 142 */
						 obj_t car_421_152_580;
						 car_421_152_580 =
						    CAR(cdr_413_22_577);
						 if (
						    STRINGP(car_421_152_580))
						   {
						      obj_t rest_2134;
						      obj_t f_2133;
						      obj_t m_2132;
						      obj_t v_2131;
						      v_2131 = car_144_227_492;
						      m_2132 = car_412_102_576;
						      f_2133 = car_421_152_580;
						      rest_2134 =
							 CDR(cdr_413_22_577);
						      rest_485 = rest_2134;
						      f_484 = f_2133;
						      m_483 = m_2132;
						      v_482 = v_2131;
						      goto tag_130_214_486;
						   }
						 else
						   {	/* Module/impuse.scm 142 */
						      if (
							 SYMBOLP(prototype_29))
							{	/* Module/impuse.scm 179 */
							   obj_t arg1389_1356;
							   arg1389_1356 =
							      find_location_120_tools_location(_module_clause__117_module_module);
							   return
							      import_all_module_109_module_impuse(prototype_29, mode_30, arg1389_1356);
							}
						      else
							{	/* Module/impuse.scm 142 */
							   goto tag_132_226_489;
							}
						   }
					      }
					    else
					      {		/* Module/impuse.scm 142 */
						 if (
						    SYMBOLP(prototype_29))
						   {	/* Module/impuse.scm 179 */
						      obj_t arg1389_1359;
						      arg1389_1359 =
							 find_location_120_tools_location(_module_clause__117_module_module);
						      return
							 import_all_module_109_module_impuse(prototype_29, mode_30, arg1389_1359);
						   }
						 else
						   {	/* Module/impuse.scm 142 */
						      goto tag_132_226_489;
						   }
					      }
					 }
				       else
					 {	/* Module/impuse.scm 142 */
					    if (
					       SYMBOLP(prototype_29))
					      {		/* Module/impuse.scm 179 */
						 obj_t arg1389_1362;
						 arg1389_1362 =
						    find_location_120_tools_location(_module_clause__117_module_module);
						 return
						    import_all_module_109_module_impuse(prototype_29, mode_30, arg1389_1362);
					      }
					    else
					      {		/* Module/impuse.scm 142 */
						 goto tag_132_226_489;
					      }
					 }
				    }
				  else
				    {	/* Module/impuse.scm 142 */
				       if (
					  SYMBOLP(prototype_29))
					 {	/* Module/impuse.scm 179 */
					    obj_t arg1389_1365;
					    arg1389_1365 =
					       find_location_120_tools_location(_module_clause__117_module_module);
					    return
					       import_all_module_109_module_impuse(prototype_29, mode_30, arg1389_1365);
					 }
				       else
					 {	/* Module/impuse.scm 142 */
					    goto tag_132_226_489;
					 }
				    }
			       }
			  }
			else
			  {	/* Module/impuse.scm 142 */
			     if (
				SYMBOLP(prototype_29))
			       {	/* Module/impuse.scm 179 */
				  obj_t arg1389_1368;
				  arg1389_1368 =
				     find_location_120_tools_location(_module_clause__117_module_module);
				  return
				     import_all_module_109_module_impuse(prototype_29, mode_30, arg1389_1368);
			       }
			     else
			       {	/* Module/impuse.scm 142 */
				  goto tag_132_226_489;
			       }
			  }
		     }
		   else
		     {	/* Module/impuse.scm 142 */
			if (
			   SYMBOLP(car_144_227_492))
			  {	/* Module/impuse.scm 142 */
			     if (
				PAIRP(cdr_145_238_493))
			       {	/* Module/impuse.scm 142 */
				  obj_t car_467_136_592;
				  obj_t cdr_468_188_593;
				  car_467_136_592 =
				     CAR(cdr_145_238_493);
				  cdr_468_188_593 =
				     CDR(cdr_145_238_493);
				  if (
				     SYMBOLP(car_467_136_592))
				    {	/* Module/impuse.scm 142 */
				       if (
					  PAIRP(cdr_468_188_593))
					 {	/* Module/impuse.scm 142 */
					    obj_t car_474_202_596;
					    car_474_202_596 =
					       CAR(cdr_468_188_593);
					    if (
					       STRINGP(car_474_202_596))
					      {
						 obj_t rest_2172;
						 obj_t f_2171;
						 obj_t m_2170;
						 obj_t v_2169;
						 v_2169 = car_144_227_492;
						 m_2170 = car_467_136_592;
						 f_2171 = car_474_202_596;
						 rest_2172 =
						    CDR(cdr_468_188_593);
						 rest_485 = rest_2172;
						 f_484 = f_2171;
						 m_483 = m_2170;
						 v_482 = v_2169;
						 goto tag_130_214_486;
					      }
					    else
					      {		/* Module/impuse.scm 142 */
						 if (
						    SYMBOLP(prototype_29))
						   {	/* Module/impuse.scm 179 */
						      obj_t arg1389_1382;
						      arg1389_1382 =
							 find_location_120_tools_location(_module_clause__117_module_module);
						      return
							 import_all_module_109_module_impuse(prototype_29, mode_30, arg1389_1382);
						   }
						 else
						   {	/* Module/impuse.scm 142 */
						      goto tag_132_226_489;
						   }
					      }
					 }
				       else
					 {	/* Module/impuse.scm 142 */
					    if (
					       SYMBOLP(prototype_29))
					      {		/* Module/impuse.scm 179 */
						 obj_t arg1389_1385;
						 arg1389_1385 =
						    find_location_120_tools_location(_module_clause__117_module_module);
						 return
						    import_all_module_109_module_impuse(prototype_29, mode_30, arg1389_1385);
					      }
					    else
					      {		/* Module/impuse.scm 142 */
						 goto tag_132_226_489;
					      }
					 }
				    }
				  else
				    {	/* Module/impuse.scm 142 */
				       if (
					  SYMBOLP(prototype_29))
					 {	/* Module/impuse.scm 179 */
					    obj_t arg1389_1388;
					    arg1389_1388 =
					       find_location_120_tools_location(_module_clause__117_module_module);
					    return
					       import_all_module_109_module_impuse(prototype_29, mode_30, arg1389_1388);
					 }
				       else
					 {	/* Module/impuse.scm 142 */
					    goto tag_132_226_489;
					 }
				    }
			       }
			     else
			       {	/* Module/impuse.scm 142 */
				  if (
				     SYMBOLP(prototype_29))
				    {	/* Module/impuse.scm 179 */
				       obj_t arg1389_1391;
				       arg1389_1391 =
					  find_location_120_tools_location(_module_clause__117_module_module);
				       return
					  import_all_module_109_module_impuse(prototype_29, mode_30, arg1389_1391);
				    }
				  else
				    {	/* Module/impuse.scm 142 */
				       goto tag_132_226_489;
				    }
			       }
			  }
			else
			  {	/* Module/impuse.scm 142 */
			     if (
				SYMBOLP(prototype_29))
			       {	/* Module/impuse.scm 179 */
				  obj_t arg1389_1394;
				  arg1389_1394 =
				     find_location_120_tools_location(_module_clause__117_module_module);
				  return
				     import_all_module_109_module_impuse(prototype_29, mode_30, arg1389_1394);
			       }
			     else
			       {	/* Module/impuse.scm 142 */
				  goto tag_132_226_489;
			       }
			  }
		     }
		}
	   }
	 else
	   {	/* Module/impuse.scm 142 */
	      if (
		 SYMBOLP(prototype_29))
		{	/* Module/impuse.scm 179 */
		   obj_t arg1389_1397;
		   arg1389_1397 =
		      find_location_120_tools_location(_module_clause__117_module_module);
		   return
		      import_all_module_109_module_impuse(prototype_29, mode_30, arg1389_1397);
		}
	      else
		{	/* Module/impuse.scm 142 */
		   goto tag_132_226_489;
		}
	   }
      }
   }
}



/* get-imported-modules */
obj_t 
get_imported_modules_153_module_impuse()
{
   AN_OBJECT;
   {	/* Module/impuse.scm 210 */
      return _imported_module_list__84_module_impuse;
   }
}



/* _get-imported-modules */
obj_t 
_get_imported_modules_109_module_impuse(obj_t env_1692)
{
   AN_OBJECT;
   {	/* Module/impuse.scm 210 */
      return
	 get_imported_modules_153_module_impuse();
   }
}



/* import-finalizer */
obj_t 
import_finalizer_66_module_impuse()
{
   AN_OBJECT;
   {	/* Module/impuse.scm 222 */
      _import_module_list__76_module_impuse =
	 reverse__39___r4_pairs_and_lists_6_3(_import_module_list__76_module_impuse);
      {
	 obj_t init__202_650;
	 init__202_650 = BNIL;
       loop_651:
	 {	/* Module/impuse.scm 228 */
	    bool_t test1405_652;
	    {	/* Module/impuse.scm 228 */
	       obj_t obj_1467;
	       obj_1467 = _import_module_list__76_module_impuse;
	       test1405_652 =
		  NULLP(obj_1467);
	    }
	    if (test1405_652)
	      {		/* Module/impuse.scm 228 */
		 if (
		    PAIRP(init__202_650))
		   {
		      obj_t init__202_654;
		      obj_t init_call__93_655;
		      init__202_654 = init__202_650;
		      init_call__93_655 = BNIL;
		    loop_656:
		      if (
			 NULLP(init__202_654))
			{	/* Module/impuse.scm 236 */
			   obj_t arg1409_658;
			   {	/* Module/impuse.scm 236 */
			      obj_t id_1470;
			      id_1470 =
				 CNST_TABLE_REF(((long) 8));
			      {		/* ./Ast/unit.sch 683 */
				 obj_t new_1474;
				 {	/* ./Ast/unit.sch 683 */
				    obj_t aux_2207;
				    aux_2207 =
				       CNST_TABLE_REF(((long) 9));
				    new_1474 =
				       create_struct(aux_2207, ((long) 4));
				 }
				 STRUCT_SET(new_1474, ((long) 3), BTRUE);
				 STRUCT_SET(new_1474, ((long) 2), init_call__93_655);
				 {	/* ./Llib/struct.scm 1463 */
				    obj_t aux_2212;
				    aux_2212 =
				       BINT(((long) 12));
				    STRUCT_SET(new_1474, ((long) 1), aux_2212);
				 }
				 STRUCT_SET(new_1474, ((long) 0), id_1470);
				 arg1409_658 = new_1474;
			      }
			   }
			   {	/* Module/impuse.scm 236 */
			      obj_t list1410_659;
			      list1410_659 =
				 MAKE_PAIR(arg1409_658, BNIL);
			      return list1410_659;
			   }
			}
		      else
			{	/* Module/impuse.scm 237 */
			   obj_t id_660;
			   {	/* ./Llib/struct.scm 1457 */
			      obj_t aux_2217;
			      aux_2217 =
				 CAR(init__202_654);
			      id_660 =
				 STRUCT_REF(aux_2217, ((long) 0));
			   }
			   {	/* Module/impuse.scm 237 */
			      obj_t checksum_661;
			      {		/* ./Llib/struct.scm 1457 */
				 obj_t aux_2220;
				 aux_2220 =
				    CAR(init__202_654);
				 checksum_661 =
				    STRUCT_REF(aux_2220, ((long) 3));
			      }
			      {		/* Module/impuse.scm 238 */
				 obj_t init_fun_id_230_662;
				 init_fun_id_230_662 =
				    module_initialization_id_110_module_module(id_660);
				 {	/* Module/impuse.scm 239 */

				    {	/* Module/impuse.scm 240 */
				       obj_t global_663;
				       {	/* Module/impuse.scm 241 */
					  obj_t arg1411_664;
					  {	/* Module/impuse.scm 241 */
					     obj_t list1412_665;
					     {	/* Module/impuse.scm 241 */
						obj_t arg1415_666;
						{	/* Module/impuse.scm 241 */
						   obj_t arg1416_667;
						   obj_t arg1417_668;
						   arg1416_667 =
						      CNST_TABLE_REF(((long) 10));
						   {	/* Module/impuse.scm 240 */
						      obj_t aux_2225;
						      aux_2225 =
							 CNST_TABLE_REF(((long) 11));
						      arg1417_668 =
							 MAKE_PAIR(aux_2225, BNIL);
						   }
						   arg1415_666 =
						      MAKE_PAIR(arg1416_667, arg1417_668);
						}
						list1412_665 =
						   MAKE_PAIR(init_fun_id_230_662, arg1415_666);
					     }
					     arg1411_664 = list1412_665;
					  }
					  global_663 =
					     import_parser_53_module_impuse(id_660, arg1411_664);
				       }
				       {	/* Module/impuse.scm 245 */
					  global_bglt obj_1505;
					  obj_1505 =
					     (global_bglt) (global_663);
					  ((((global_bglt) CREF(obj_1505))->evaluable__248) = ((bool_t) ((bool_t) 0)), BUNSPEC);
				       }
				    }
				    {	/* Module/impuse.scm 246 */
				       obj_t arg1419_669;
				       obj_t arg1420_670;
				       arg1419_669 =
					  CDR(init__202_654);
				       {	/* Module/impuse.scm 247 */
					  obj_t arg1422_671;
					  {	/* Module/impuse.scm 247 */
					     obj_t arg1424_672;
					     obj_t arg1425_673;
					     {	/* Module/impuse.scm 247 */
						obj_t arg1426_674;
						obj_t arg1427_675;
						arg1426_674 =
						   CNST_TABLE_REF(((long) 12));
						{	/* Module/impuse.scm 247 */
						   obj_t arg1428_676;
						   arg1428_676 =
						      MAKE_PAIR(id_660, BNIL);
						   arg1427_675 =
						      MAKE_PAIR(init_fun_id_230_662, arg1428_676);
						}
						arg1424_672 =
						   MAKE_PAIR(arg1426_674, arg1427_675);
					     }
					     {	/* Module/impuse.scm 248 */
						obj_t arg1430_677;
						{	/* Module/impuse.scm 248 */
						   obj_t arg1431_678;
						   {	/* Module/impuse.scm 248 */
						      obj_t symbol_1514;
						      symbol_1514 = _module__166_module_module;
						      arg1431_678 =
							 SYMBOL_TO_STRING(symbol_1514);
						   }
						   arg1430_677 =
						      MAKE_PAIR(arg1431_678, BNIL);
						}
						arg1425_673 =
						   MAKE_PAIR(checksum_661, arg1430_677);
					     }
					     arg1422_671 =
						MAKE_PAIR(arg1424_672, arg1425_673);
					  }
					  arg1420_670 =
					     MAKE_PAIR(arg1422_671, init_call__93_655);
				       }
				       {
					  obj_t init_call__93_2244;
					  obj_t init__202_2243;
					  init__202_2243 = arg1419_669;
					  init_call__93_2244 = arg1420_670;
					  init_call__93_655 = init_call__93_2244;
					  init__202_654 = init__202_2243;
					  goto loop_656;
				       }
				    }
				 }
			      }
			   }
			}
		   }
		 else
		   {	/* Module/impuse.scm 229 */
		      return BNIL;
		   }
	      }
	    else
	      {		/* Module/impuse.scm 252 */
		 obj_t module_682;
		 obj_t imode_683;
		 {	/* Module/impuse.scm 252 */
		    obj_t arg1442_691;
		    {	/* Module/impuse.scm 252 */
		       obj_t pair_1523;
		       pair_1523 = _import_module_list__76_module_impuse;
		       arg1442_691 =
			  CAR(pair_1523);
		    }
		    module_682 =
		       CAR(arg1442_691);
		 }
		 {	/* Module/impuse.scm 253 */
		    obj_t arg1443_692;
		    {	/* Module/impuse.scm 253 */
		       obj_t pair_1525;
		       pair_1525 = _import_module_list__76_module_impuse;
		       arg1443_692 =
			  CAR(pair_1525);
		    }
		    imode_683 =
		       CDR(arg1443_692);
		 }
		 {	/* Module/impuse.scm 254 */
		    obj_t pair_1527;
		    pair_1527 = _import_module_list__76_module_impuse;
		    _import_module_list__76_module_impuse =
		       CDR(pair_1527);
		 }
		 {	/* Module/impuse.scm 255 */
		    obj_t obj2_1529;
		    obj2_1529 = _imported_module_list__84_module_impuse;
		    _imported_module_list__84_module_impuse =
		       MAKE_PAIR(module_682, obj2_1529);
		 }
		 {	/* Module/impuse.scm 256 */
		    bool_t test_2251;
		    {	/* ./Ieee/equiv.scm 5508 */
		       obj_t aux_2254;
		       obj_t aux_2252;
		       aux_2254 =
			  CNST_TABLE_REF(((long) 6));
		       aux_2252 =
			  STRUCT_REF(imode_683, ((long) 1));
		       test_2251 =
			  (aux_2252 == aux_2254);
		    }
		    if (test_2251)
		      {		/* Module/impuse.scm 256 */
			 BUNSPEC;
		      }
		    else
		      {		/* Module/impuse.scm 256 */
			 read_imported_module_112_module_impuse(imode_683);
		      }
		 }
		 {	/* Module/impuse.scm 258 */
		    obj_t arg1438_687;
		    {	/* Module/impuse.scm 258 */
		       bool_t test_2258;
		       {	/* Module/impuse.scm 258 */
			  obj_t aux_2259;
			  aux_2259 =
			     memq___r4_pairs_and_lists_6_3(
			     STRUCT_REF(imode_683, ((long) 1)),
			     CNST_TABLE_REF(((long) 13)));
			  test_2258 =
			     CBOOL(aux_2259);
		       }
		       if (test_2258)
			 {	/* Module/impuse.scm 258 */
			    arg1438_687 =
			       MAKE_PAIR(imode_683, init__202_650);
			 }
		       else
			 {	/* Module/impuse.scm 258 */
			    arg1438_687 = init__202_650;
			 }
		    }
		    {
		       obj_t init__202_2265;
		       init__202_2265 = arg1438_687;
		       init__202_650 = init__202_2265;
		       goto loop_651;
		    }
		 }
	      }
	 }
      }
   }
}



/* impuse-finalizer */
obj_t 
impuse_finalizer_42_module_impuse()
{
   AN_OBJECT;
   {	/* Module/impuse.scm 269 */
      {		/* Module/impuse.scm 270 */
	 obj_t import_finalizer_66_693;
	 import_finalizer_66_693 =
	    import_finalizer_66_module_impuse();
	 {	/* Module/impuse.scm 270 */
	    obj_t inline_finalizer_105_694;
	    inline_finalizer_105_694 =
	       inline_finalizer_105_read_inline();
	    {	/* Module/impuse.scm 271 */
	       obj_t finalizers_695;
	       finalizers_695 =
		  append_2_18___r4_pairs_and_lists_6_3(import_finalizer_66_693, inline_finalizer_105_694);
	       {	/* Module/impuse.scm 272 */

		  if (
		     NULLP(finalizers_695))
		    {	/* Module/impuse.scm 273 */
		       return
			  CNST_TABLE_REF(((long) 1));
		    }
		  else
		    {	/* Module/impuse.scm 273 */
		       return finalizers_695;
		    }
	       }
	    }
	 }
      }
   }
}



/* _impuse-finalizer */
obj_t 
_impuse_finalizer_29_module_impuse(obj_t env_1677)
{
   AN_OBJECT;
   {	/* Module/impuse.scm 269 */
      return
	 impuse_finalizer_42_module_impuse();
   }
}



/* import-parser */
obj_t 
import_parser_53_module_impuse(obj_t module_53, obj_t prototype_54)
{
   AN_OBJECT;
   {	/* Module/impuse.scm 280 */
      {		/* Module/impuse.scm 281 */
	 obj_t proto_697;
	 proto_697 =
	    parse_prototype_143_module_prototype(prototype_54);
	 if (
	    PAIRP(proto_697))
	   {	/* Module/impuse.scm 288 */
	      obj_t case_value_58_699;
	      case_value_58_699 =
		 CAR(proto_697);
	      {		/* Module/impuse.scm 288 */
		 bool_t test_2277;
		 {	/* Module/impuse.scm 288 */
		    obj_t aux_2278;
		    aux_2278 =
		       memq___r4_pairs_and_lists_6_3(case_value_58_699,
		       CNST_TABLE_REF(((long) 14)));
		    test_2277 =
		       CBOOL(aux_2278);
		 }
		 if (test_2277)
		   {	/* Module/impuse.scm 290 */
		      global_bglt aux_2282;
		      {		/* Module/impuse.scm 290 */
			 obj_t aux_2287;
			 obj_t aux_2283;
			 {	/* ./Ieee/pair-list.scm 5701 */
			    obj_t aux_2288;
			    {	/* ./Ieee/pair-list.scm 5707 */
			       obj_t aux_2289;
			       aux_2289 =
				  CDR(proto_697);
			       aux_2288 =
				  CDR(aux_2289);
			    }
			    aux_2287 =
			       CAR(aux_2288);
			 }
			 {	/* ./Ieee/pair-list.scm 5701 */
			    obj_t aux_2284;
			    aux_2284 =
			       CDR(proto_697);
			    aux_2283 =
			       CAR(aux_2284);
			 }
			 aux_2282 =
			    declare_global_sfun__255_ast_glo_decl_237(aux_2283, aux_2287, module_53,
			    CNST_TABLE_REF(((long) 0)), case_value_58_699, prototype_54);
		      }
		      return
			 (obj_t) (aux_2282);
		   }
		 else
		   {	/* Module/impuse.scm 288 */
		      bool_t test_2296;
		      {		/* ./Ieee/equiv.scm 5508 */
			 obj_t aux_2297;
			 aux_2297 =
			    CNST_TABLE_REF(((long) 15));
			 test_2296 =
			    (case_value_58_699 == aux_2297);
		      }
		      if (test_2296)
			{	/* Module/impuse.scm 297 */
			   global_bglt aux_2300;
			   {	/* Module/impuse.scm 297 */
			      obj_t aux_2301;
			      {		/* ./Ieee/pair-list.scm 5701 */
				 obj_t aux_2302;
				 aux_2302 =
				    CDR(proto_697);
				 aux_2301 =
				    CAR(aux_2302);
			      }
			      aux_2300 =
				 declare_global_svar__200_ast_glo_decl_237(aux_2301, module_53,
				 CNST_TABLE_REF(((long) 0)), prototype_54);
			   }
			   return
			      (obj_t) (aux_2300);
			}
		      else
			{	/* Module/impuse.scm 288 */
			   bool_t test_2308;
			   {	/* ./Ieee/equiv.scm 5508 */
			      obj_t aux_2309;
			      aux_2309 =
				 CNST_TABLE_REF(((long) 16));
			      test_2308 =
				 (case_value_58_699 == aux_2309);
			   }
			   if (test_2308)
			     {	/* Module/impuse.scm 288 */
				return
				   declare_class__31_module_class(
				   CDR(proto_697), module_53,
				   CNST_TABLE_REF(((long) 0)), ((bool_t) 0), prototype_54);
			     }
			   else
			     {	/* Module/impuse.scm 288 */
				bool_t test_2315;
				{	/* ./Ieee/equiv.scm 5508 */
				   obj_t aux_2316;
				   aux_2316 =
				      CNST_TABLE_REF(((long) 17));
				   test_2315 =
				      (case_value_58_699 == aux_2316);
				}
				if (test_2315)
				  {	/* Module/impuse.scm 288 */
				     return
					declare_class__31_module_class(
					CDR(proto_697), module_53,
					CNST_TABLE_REF(((long) 0)), ((bool_t) 1), prototype_54);
				  }
				else
				  {	/* Module/impuse.scm 288 */
				     bool_t test_2322;
				     {	/* ./Ieee/equiv.scm 5508 */
					obj_t aux_2323;
					aux_2323 =
					   CNST_TABLE_REF(((long) 18));
					test_2322 =
					   (case_value_58_699 == aux_2323);
				     }
				     if (test_2322)
				       {	/* Module/impuse.scm 288 */
					  return
					     declare_wide_class__13_module_class(
					     CDR(proto_697), module_53,
					     CNST_TABLE_REF(((long) 0)), prototype_54);
				       }
				     else
				       {	/* Module/impuse.scm 305 */
					  obj_t list1467_717;
					  list1467_717 =
					     MAKE_PAIR(BNIL, BNIL);
					  return
					     user_error_151_tools_error(string1620_module_impuse, string1623_module_impuse, prototype_54, list1467_717);
				       }
				  }
			     }
			}
		   }
	      }
	   }
	 else
	   {	/* Module/impuse.scm 283 */
	      obj_t arg1469_718;
	      arg1469_718 =
		 find_location_120_tools_location(_module_clause__117_module_module);
	      {		/* Module/impuse.scm 283 */
		 obj_t list1473_722;
		 list1473_722 =
		    MAKE_PAIR(BNIL, BNIL);
		 return
		    user_error_location_137_tools_error(arg1469_718, string1620_module_impuse, string1623_module_impuse, prototype_54, list1473_722);
	      }
	   }
      }
   }
}



/* _import-parser1609 */
obj_t 
_import_parser1609_204_module_impuse(obj_t env_1693, obj_t module_1694, obj_t prototype_1695)
{
   AN_OBJECT;
   {	/* Module/impuse.scm 280 */
      return
	 import_parser_53_module_impuse(module_1694, prototype_1695);
   }
}



/* read-imported-module */
obj_t 
read_imported_module_112_module_impuse(obj_t imode_55)
{
   AN_OBJECT;
   {	/* Module/impuse.scm 310 */
      {		/* Module/impuse.scm 312 */
	 obj_t module_723;
	 module_723 =
	    STRUCT_REF(imode_55, ((long) 0));
	 {	/* Module/impuse.scm 312 */
	    obj_t wanted_724;
	    wanted_724 =
	       STRUCT_REF(imode_55, ((long) 2));
	    {	/* Module/impuse.scm 313 */
	       obj_t b_725;
	       b_725 =
		  assq___r4_pairs_and_lists_6_3(module_723, _access_table__91_engine_param);
	       {	/* Module/impuse.scm 314 */

		  {	/* Module/impuse.scm 315 */
		     char *arg1476_728;
		     {	/* Module/impuse.scm 316 */
			bool_t test_2338;
			{	/* ./Ieee/equiv.scm 5508 */
			   obj_t aux_2341;
			   obj_t aux_2339;
			   aux_2341 =
			      CNST_TABLE_REF(((long) 2));
			   aux_2339 =
			      STRUCT_REF(imode_55, ((long) 1));
			   test_2338 =
			      (aux_2339 == aux_2341);
			}
			if (test_2338)
			  {	/* Module/impuse.scm 316 */
			     arg1476_728 = "used";
			  }
			else
			  {	/* Module/impuse.scm 316 */
			     arg1476_728 = "imported";
			  }
		     }
		     {	/* Module/impuse.scm 315 */
			obj_t list1479_731;
			{	/* Module/impuse.scm 315 */
			   obj_t arg1480_732;
			   {	/* Module/impuse.scm 315 */
			      obj_t arg1481_733;
			      {		/* Module/impuse.scm 315 */
				 obj_t arg1482_734;
				 {	/* Module/impuse.scm 315 */
				    obj_t arg1483_735;
				    {	/* Module/impuse.scm 315 */
				       obj_t arg1484_736;
				       {	/* Module/impuse.scm 315 */
					  obj_t aux_2344;
					  aux_2344 =
					     BCHAR(((unsigned char) '\n'));
					  arg1484_736 =
					     MAKE_PAIR(aux_2344, BNIL);
				       }
				       arg1483_735 =
					  MAKE_PAIR(string1624_module_impuse, arg1484_736);
				    }
				    arg1482_734 =
				       MAKE_PAIR(module_723, arg1483_735);
				 }
				 arg1481_733 =
				    MAKE_PAIR(string1625_module_impuse, arg1482_734);
			      }
			      {		/* Module/impuse.scm 315 */
				 obj_t aux_2350;
				 aux_2350 =
				    string_to_bstring(arg1476_728);
				 arg1480_732 =
				    MAKE_PAIR(aux_2350, arg1481_733);
			      }
			   }
			   list1479_731 =
			      MAKE_PAIR(string1626_module_impuse, arg1480_732);
			}
			verbose_tools_speek(
			   BINT(((long) 2)), list1479_731);
		     }
		  }
		  if (
		     CBOOL(b_725))
		    {	/* Module/impuse.scm 324 */
		       obj_t fnames_740;
		       fnames_740 =
			  CDR(b_725);
		       {	/* Module/impuse.scm 324 */
			  obj_t fname_741;
			  fname_741 =
			     find_file_path_55___os(
			     CAR(fnames_740), _load_path__54___eval);
			  {	/* Module/impuse.scm 325 */

			     if (
				STRINGP(fname_741))
			       {	/* Module/impuse.scm 332 */
				  obj_t port_743;
				  port_743 =
				     open_input_file_61___r4_ports_6_10_1(fname_741, BNIL);
				  if (
				     INPUT_PORTP(port_743))
				    {	/* Module/impuse.scm 340 */
				       obj_t handler_1701;
				       handler_1701 =
					  make_fx_procedure(handler_module_impuse, ((long) 4), ((long) 1));
				       PROCEDURE_SET(handler_1701, ((long) 0), port_743);
				       {	/* Module/impuse.scm 345 */
					  obj_t armed1201_746;
					  obj_t handler1198_747;
					  armed1201_746 =
					     MAKE_CELL(BUNSPEC);
					  handler1198_747 =
					     MAKE_CELL(BUNSPEC);
					  {	/* Module/impuse.scm 345 */
					     obj_t body1200_1697;
					     obj_t rhandler1199_1699;
					     body1200_1697 =
						make_fx_procedure(body1200_module_impuse, ((long) 0), ((long) 5));
					     rhandler1199_1699 =
						make_fx_procedure(rhandler1199_module_impuse, ((long) 4), ((long) 2));
					     PROCEDURE_SET(body1200_1697, ((long) 0), port_743);
					     PROCEDURE_SET(body1200_1697, ((long) 1), module_723);
					     PROCEDURE_SET(body1200_1697, ((long) 2), imode_55);
					     PROCEDURE_SET(body1200_1697, ((long) 3), wanted_724);
					     PROCEDURE_SET(body1200_1697, ((long) 4), fnames_740);
					     PROCEDURE_SET(rhandler1199_1699, ((long) 0), armed1201_746);
					     PROCEDURE_SET(rhandler1199_1699, ((long) 1), handler1198_747);
					     CELL_SET(handler1198_747, handler_1701);
					     CELL_SET(armed1201_746, BTRUE);
					     return
						handling_function1491_module_impuse(body1200_1697, rhandler1199_1699, handler1198_747, armed1201_746);
					  }
				       }
				    }
				  else
				    {	/* Module/impuse.scm 334 */
				       obj_t arg1509_788;
				       obj_t arg1512_791;
				       arg1509_788 =
					  STRUCT_REF(imode_55, ((long) 4));
				       arg1512_791 =
					  CAR(fnames_740);
				       {	/* Module/impuse.scm 334 */
					  obj_t list1514_793;
					  list1514_793 =
					     MAKE_PAIR(BNIL, BNIL);
					  return
					     user_error_location_137_tools_error(arg1509_788, string1627_module_impuse, string1628_module_impuse, arg1512_791, list1514_793);
				       }
				    }
			       }
			     else
			       {	/* Module/impuse.scm 327 */
				  obj_t arg1516_795;
				  obj_t arg1520_798;
				  arg1516_795 =
				     STRUCT_REF(imode_55, ((long) 4));
				  arg1520_798 =
				     CAR(fnames_740);
				  {	/* Module/impuse.scm 327 */
				     obj_t list1522_800;
				     list1522_800 =
					MAKE_PAIR(BNIL, BNIL);
				     return
					user_error_location_137_tools_error(arg1516_795, string1627_module_impuse, string1628_module_impuse, arg1520_798, list1522_800);
				  }
			       }
			  }
		       }
		    }
		  else
		    {	/* Module/impuse.scm 319 */
		       obj_t arg1525_802;
		       arg1525_802 =
			  STRUCT_REF(imode_55, ((long) 4));
		       {	/* Module/impuse.scm 319 */
			  obj_t list1529_806;
			  list1529_806 =
			     MAKE_PAIR(BNIL, BNIL);
			  return
			     user_error_location_137_tools_error(arg1525_802, string1627_module_impuse, string1629_module_impuse, module_723, list1529_806);
		       }
		    }
	       }
	    }
	 }
      }
   }
}



/* handling_function1491 */
obj_t 
handling_function1491_module_impuse(obj_t body1200_1739, obj_t rhandler1199_1738, obj_t handler1198_1737, obj_t armed1201_1736)
{
   AN_OBJECT;
   {	/* Module/impuse.scm 345 */
      jmp_buf jmpbuf;
      obj_t an_exit1202_751;
      if (SET_EXIT(an_exit1202_751))
	{
	   RESTORE_TRACE();
	   return
	      _exit_value_;
	}
      else
	{
	   an_exit1202_751 =
	      (obj_t) jmpbuf;
	   {	/* Module/impuse.scm 345 */

	      PUSH_EXIT(an_exit1202_751, ((bool_t) 1));
	      {		/* Module/impuse.scm 345 */
		 obj_t an_exitd1203_752;
		 an_exitd1203_752 = exitd_top;
		 {	/* Module/impuse.scm 345 */
		    obj_t escape_1698;
		    escape_1698 =
		       make_fx_procedure(escape_module_impuse, ((long) 1), ((long) 1));
		    PROCEDURE_SET(escape_1698, ((long) 0), an_exitd1203_752);
		    {	/* Module/impuse.scm 345 */
		       obj_t res1205_755;
		       {	/* Module/impuse.scm 345 */
			  obj_t _anonymous_1496__28_1696;
			  obj_t _anonymous_1495__106_1700;
			  _anonymous_1496__28_1696 =
			     make_fx_procedure(_anonymous_1496__28_module_impuse, ((long) 0), ((long) 1));
			  _anonymous_1495__106_1700 =
			     make_fx_procedure(_anonymous_1495__106_module_impuse, ((long) 0), ((long) 5));
			  PROCEDURE_SET(_anonymous_1496__28_1696, ((long) 0), armed1201_1736);
			  PROCEDURE_SET(_anonymous_1495__106_1700, ((long) 0), an_exitd1203_752);
			  PROCEDURE_SET(_anonymous_1495__106_1700, ((long) 1), armed1201_1736);
			  PROCEDURE_SET(_anonymous_1495__106_1700, ((long) 2), handler1198_1737);
			  PROCEDURE_SET(_anonymous_1495__106_1700, ((long) 3), rhandler1199_1738);
			  PROCEDURE_SET(_anonymous_1495__106_1700, ((long) 4), escape_1698);
			  res1205_755 =
			     dynamic_wind_31___r4_control_features_6_9(_anonymous_1495__106_1700, body1200_1739, _anonymous_1496__28_1696);
		       }
		       POP_EXIT();
		       return res1205_755;
		    }
		 }
	      }
	   }
	}
   }
}



/* <anonymous:1496> */
obj_t 
_anonymous_1496__28_module_impuse(obj_t env_1702)
{
   AN_OBJECT;
   {	/* Module/impuse.scm 345 */
      {		/* Module/impuse.scm 345 */
	 obj_t armed1201_1703;
	 armed1201_1703 =
	    PROCEDURE_REF(env_1702, ((long) 0));
	 {

	    {	/* Module/impuse.scm 345 */
	       bool_t test_2405;
	       {	/* Module/impuse.scm 345 */
		  obj_t aux_2406;
		  aux_2406 =
		     CELL_REF(armed1201_1703);
		  test_2405 =
		     CBOOL(aux_2406);
	       }
	       if (test_2405)
		 {	/* Module/impuse.scm 345 */
		    CELL_SET(armed1201_1703, BFALSE);
		    return
		       remove_error_handler__102___error();
		 }
	       else
		 {	/* Module/impuse.scm 345 */
		    return BUNSPEC;
		 }
	    }
	 }
      }
   }
}



/* body1200 */
obj_t 
body1200_module_impuse(obj_t env_1705)
{
   AN_OBJECT;
   {	/* Module/impuse.scm 345 */
      {		/* Module/impuse.scm 346 */
	 obj_t port_1706;
	 obj_t module_1707;
	 obj_t imode_1708;
	 obj_t wanted_1709;
	 obj_t fnames_1710;
	 port_1706 =
	    PROCEDURE_REF(env_1705, ((long) 0));
	 module_1707 =
	    PROCEDURE_REF(env_1705, ((long) 1));
	 imode_1708 =
	    PROCEDURE_REF(env_1705, ((long) 2));
	 wanted_1709 =
	    PROCEDURE_REF(env_1705, ((long) 3));
	 fnames_1710 =
	    PROCEDURE_REF(env_1705, ((long) 4));
	 {

	    {	/* Module/impuse.scm 346 */
	       obj_t mdecl_768;
	       {	/* Module/impuse.scm 346 */
		  obj_t list1504_777;
		  {	/* Module/impuse.scm 346 */
		     obj_t arg1505_778;
		     arg1505_778 =
			MAKE_PAIR(BTRUE, BNIL);
		     list1504_777 =
			MAKE_PAIR(port_1706, arg1505_778);
		  }
		  mdecl_768 =
		     compiler_read_18_read_reader(list1504_777);
	       }
	       {	/* Module/impuse.scm 346 */
		  obj_t prov_769;
		  {	/* Module/impuse.scm 347 */
		     obj_t arg1502_775;
		     obj_t arg1503_776;
		     reset_include_consumed_directive__234_module_include();
		     reset_include_consumed_code__8_module_include();
		     arg1502_775 =
			consume_module__183_module_module(module_1707, mdecl_768);
		     arg1503_776 =
			get_include_consumed_directive_80_module_include();
		     prov_769 =
			append_2_18___r4_pairs_and_lists_6_3(arg1502_775, arg1503_776);
		  }
		  {	/* Module/impuse.scm 347 */
		     obj_t code_770;
		     code_770 =
			get_include_consumed_code_244_module_include();
		     {	/* Module/impuse.scm 353 */
			obj_t check_771;
			check_771 =
			   checksum_module_8_module_module(mdecl_768);
			{	/* Module/impuse.scm 354 */

			   STRUCT_SET(imode_1708, ((long) 3), check_771);
			   {	/* Module/impuse.scm 357 */
			      obj_t arg1499_772;
			      obj_t arg1500_773;
			      if (
				 PAIRP(wanted_1709))
				{	/* Module/impuse.scm 357 */
				   arg1499_772 =
				      import_wanted_18_module_impuse(prov_769, wanted_1709, module_1707);
				}
			      else
				{	/* Module/impuse.scm 357 */
				   arg1499_772 =
				      import_everything_193_module_impuse(prov_769, module_1707);
				}
			      arg1500_773 =
				 CDR(fnames_1710);
			      look_for_inline_98_read_inline(arg1499_772, code_770, port_1706, arg1500_773, module_1707);
			   }
			   return
			      close_input_port(port_1706);
			}
		     }
		  }
	       }
	    }
	 }
      }
   }
}



/* <anonymous:1495> */
obj_t 
_anonymous_1495__106_module_impuse(obj_t env_1711)
{
   AN_OBJECT;
   {	/* Module/impuse.scm 345 */
      {		/* Module/impuse.scm 345 */
	 obj_t rhandler1199_1715;
	 obj_t escape_1716;
	 rhandler1199_1715 =
	    PROCEDURE_REF(env_1711, ((long) 3));
	 escape_1716 =
	    PROCEDURE_REF(env_1711, ((long) 4));
	 {

	    return
	       add_error_handler__155___error(rhandler1199_1715, escape_1716);
	 }
      }
   }
}



/* escape */
obj_t 
escape_module_impuse(obj_t env_1717, obj_t val1204_1719)
{
   AN_OBJECT;
   {	/* Module/impuse.scm 345 */
      {		/* Module/impuse.scm 345 */
	 obj_t an_exitd1203_1718;
	 an_exitd1203_1718 =
	    PROCEDURE_REF(env_1717, ((long) 0));
	 {
	    obj_t val1204_753;
	    val1204_753 = val1204_1719;
	    return
	       unwind_until__178___bexit(an_exitd1203_1718, val1204_753);
	 }
      }
   }
}



/* rhandler1199 */
obj_t 
rhandler1199_module_impuse(obj_t env_1720, obj_t esc_1723, obj_t obj_1724, obj_t proc_1725, obj_t msg_1726)
{
   AN_OBJECT;
   {	/* Module/impuse.scm 345 */
      {		/* Module/impuse.scm 345 */
	 obj_t armed1201_1721;
	 obj_t handler1198_1722;
	 armed1201_1721 =
	    PROCEDURE_REF(env_1720, ((long) 0));
	 handler1198_1722 =
	    PROCEDURE_REF(env_1720, ((long) 1));
	 {
	    obj_t esc_762;
	    obj_t obj_763;
	    obj_t proc_764;
	    obj_t msg_765;
	    esc_762 = esc_1723;
	    obj_763 = obj_1724;
	    proc_764 = proc_1725;
	    msg_765 = msg_1726;
	    CELL_SET(armed1201_1721, BFALSE);
	    remove_error_handler__102___error();
	    {	/* Module/impuse.scm 345 */
	       obj_t aux_2441;
	       aux_2441 =
		  CELL_REF(handler1198_1722);
	       return
		  PROCEDURE_ENTRY(aux_2441) (
		  CELL_REF(handler1198_1722), esc_762, obj_763, proc_764, msg_765, BEOA);
	    }
	 }
      }
   }
}



/* handler */
obj_t 
handler_module_impuse(obj_t env_1728, obj_t escape_1730, obj_t proc_1731, obj_t mes_1732, obj_t obj_1733)
{
   AN_OBJECT;
   {	/* Module/impuse.scm 340 */
      {		/* Module/impuse.scm 340 */
	 obj_t port_1729;
	 port_1729 =
	    PROCEDURE_REF(env_1728, ((long) 0));
	 {
	    obj_t escape_781;
	    obj_t proc_782;
	    obj_t mes_783;
	    obj_t obj_784;
	    escape_781 = escape_1730;
	    proc_782 = proc_1731;
	    mes_783 = mes_1732;
	    obj_784 = obj_1733;
	    notify_error_43___error(proc_782, mes_783, obj_784);
	    FLUSH_OUTPUT_PORT(current_error_port);
	    close_input_port(port_1729);
	    return
	       exit_bigloo_229_init_main(
	       BINT(((long) -7)));
	 }
      }
   }
}



/* import-everything */
obj_t 
import_everything_193_module_impuse(obj_t provided_56, obj_t module_57)
{
   AN_OBJECT;
   {	/* Module/impuse.scm 370 */
      {
	 obj_t provided_807;
	 obj_t inline_808;
	 provided_807 = provided_56;
	 inline_808 = BNIL;
       loop_809:
	 if (
	    NULLP(provided_807))
	   {	/* Module/impuse.scm 373 */
	      return inline_808;
	   }
	 else
	   {	/* Module/impuse.scm 375 */
	      obj_t p_811;
	      p_811 =
		 import_parser_53_module_impuse(module_57,
		 CAR(provided_807));
	      {		/* Module/impuse.scm 376 */
		 bool_t test1531_812;
		 test1531_812 =
		    is_a__118___object(p_811, global_ast_var);
		 if (test1531_812)
		   {	/* Module/impuse.scm 377 */
		      value_bglt val_813;
		      {		/* Module/impuse.scm 377 */
			 global_bglt obj_1609;
			 obj_1609 =
			    (global_bglt) (p_811);
			 val_813 =
			    (((global_bglt) CREF(obj_1609))->value);
		      }
		      {		/* Module/impuse.scm 378 */
			 obj_t arg1532_814;
			 obj_t arg1533_815;
			 arg1532_814 =
			    CDR(provided_807);
			 {	/* Module/impuse.scm 380 */
			    bool_t test1534_816;
			    {	/* Module/impuse.scm 380 */
			       bool_t test1542_823;
			       test1542_823 =
				  is_a__118___object(p_811, global_ast_var);
			       if (test1542_823)
				 {	/* Module/impuse.scm 381 */
				    bool_t test1543_824;
				    test1543_824 =
				       is_a__118___object(
				       (obj_t) (val_813), sfun_ast_var);
				    if (test1543_824)
				      {		/* Module/impuse.scm 381 */
					 test1534_816 = ((bool_t) 0);
				      }
				    else
				      {		/* Module/impuse.scm 381 */
					 test1534_816 = ((bool_t) 1);
				      }
				 }
			       else
				 {	/* Module/impuse.scm 380 */
				    test1534_816 = ((bool_t) 1);
				 }
			    }
			    if (test1534_816)
			      {		/* Module/impuse.scm 380 */
				 arg1533_815 = inline_808;
			      }
			    else
			      {		/* Module/impuse.scm 383 */
				 bool_t test_2463;
				 {	/* ./Ieee/equiv.scm 5508 */
				    obj_t aux_2467;
				    obj_t aux_2464;
				    aux_2467 =
				       CNST_TABLE_REF(((long) 19));
				    {	/* Module/impuse.scm 383 */
				       sfun_bglt obj_1613;
				       obj_1613 =
					  (sfun_bglt) (val_813);
				       aux_2464 =
					  (((sfun_bglt) CREF(obj_1613))->class);
				    }
				    test_2463 =
				       (aux_2464 == aux_2467);
				 }
				 if (test_2463)
				   {	/* Module/impuse.scm 383 */
				      {		/* Module/impuse.scm 384 */
					 obj_t arg1536_818;
					 {	/* ./Ieee/pair-list.scm 5689 */
					    obj_t aux_2473;
					    obj_t aux_2470;
					    aux_2473 =
					       CNST_TABLE_REF(((long) 19));
					    {	/* Module/impuse.scm 384 */
					       global_bglt obj_1616;
					       obj_1616 =
						  (global_bglt) (p_811);
					       aux_2470 =
						  (((global_bglt) CREF(obj_1616))->id);
					    }
					    arg1536_818 =
					       MAKE_PAIR(aux_2470, aux_2473);
					 }
					 arg1533_815 =
					    MAKE_PAIR(arg1536_818, inline_808);
				      }
				   }
				 else
				   {	/* Module/impuse.scm 383 */
				      arg1533_815 = inline_808;
				   }
			      }
			 }
			 {
			    obj_t inline_2478;
			    obj_t provided_2477;
			    provided_2477 = arg1532_814;
			    inline_2478 = arg1533_815;
			    inline_808 = inline_2478;
			    provided_807 = provided_2477;
			    goto loop_809;
			 }
		      }
		   }
		 else
		   {
		      obj_t provided_2479;
		      provided_2479 =
			 CDR(provided_807);
		      provided_807 = provided_2479;
		      goto loop_809;
		   }
	      }
	   }
      }
   }
}



/* import-wanted */
obj_t 
import_wanted_18_module_impuse(obj_t provided_58, obj_t wanted_59, obj_t module_60)
{
   AN_OBJECT;
   {	/* Module/impuse.scm 392 */
      {
	 obj_t provided_827;
	 obj_t inline_828;
	 obj_t wanted_829;
	 provided_827 = provided_58;
	 inline_828 = BNIL;
	 wanted_829 = wanted_59;
       loop_830:
	 if (
	    NULLP(wanted_829))
	   {	/* Module/impuse.scm 399 */
	      return inline_828;
	   }
	 else
	   {	/* Module/impuse.scm 399 */
	      if (
		 NULLP(provided_827))
		{	/* Module/impuse.scm 401 */
		   {	/* Module/impuse.scm 402 */
		      obj_t arg1548_833;
		      arg1548_833 =
			 find_location_120_tools_location(_module_clause__117_module_module);
		      {		/* Module/impuse.scm 402 */
			 obj_t list1551_836;
			 list1551_836 =
			    MAKE_PAIR(BNIL, BNIL);
			 return
			    user_error_location_137_tools_error(arg1548_833, module_60, string1630_module_impuse, wanted_829, list1551_836);
		      }
		   }
		}
	      else
		{	/* Module/impuse.scm 401 */
		   {	/* Module/impuse.scm 408 */
		      obj_t proto_837;
		      proto_837 =
			 parse_prototype_143_module_prototype(
			 CAR(provided_827));
		      if (
			 PAIRP(proto_837))
			{	/* Module/impuse.scm 410 */
			   obj_t id_839;
			   {	/* Module/impuse.scm 410 */
			      obj_t arg1569_857;
			      obj_t arg1571_858;
			      {		/* ./Ieee/pair-list.scm 5701 */
				 obj_t aux_2492;
				 aux_2492 =
				    CDR(proto_837);
				 arg1569_857 =
				    CAR(aux_2492);
			      }
			      arg1571_858 =
				 find_location_120_tools_location(
				 CAR(provided_827));
			      id_839 =
				 fast_id_of_id_130_ast_ident(arg1569_857, arg1571_858);
			   }
			   {	/* Module/impuse.scm 412 */
			      bool_t test_2498;
			      {		/* Module/impuse.scm 412 */
				 obj_t aux_2499;
				 aux_2499 =
				    memq___r4_pairs_and_lists_6_3(id_839, wanted_829);
				 test_2498 =
				    CBOOL(aux_2499);
			      }
			      if (test_2498)
				{	/* Module/impuse.scm 416 */
				   obj_t p_841;
				   p_841 =
				      import_parser_53_module_impuse(module_60,
				      CAR(provided_827));
				   {	/* Module/impuse.scm 418 */
				      bool_t test1554_842;
				      test1554_842 =
					 is_a__118___object(p_841, global_ast_var);
				      if (test1554_842)
					{	/* Module/impuse.scm 418 */
					   {	/* Module/impuse.scm 419 */
					      obj_t arg1555_843;
					      obj_t arg1556_844;
					      obj_t arg1557_845;
					      arg1555_843 =
						 CDR(provided_827);
					      {		/* Module/impuse.scm 421 */
						 bool_t test_2507;
						 {	/* ./Ieee/equiv.scm 5508 */
						    obj_t aux_2510;
						    obj_t aux_2508;
						    aux_2510 =
						       CNST_TABLE_REF(((long) 19));
						    aux_2508 =
						       CAR(proto_837);
						    test_2507 =
						       (aux_2508 == aux_2510);
						 }
						 if (test_2507)
						   {	/* Module/impuse.scm 421 */
						      {		/* Module/impuse.scm 422 */
							 obj_t arg1559_847;
							 {	/* ./Ieee/pair-list.scm 5689 */
							    obj_t aux_2513;
							    aux_2513 =
							       CNST_TABLE_REF(((long) 19));
							    arg1559_847 =
							       MAKE_PAIR(id_839, aux_2513);
							 }
							 arg1556_844 =
							    MAKE_PAIR(arg1559_847, inline_828);
						      }
						   }
						 else
						   {	/* Module/impuse.scm 421 */
						      arg1556_844 = inline_828;
						   }
					      }
					      arg1557_845 =
						 remq__51___r4_pairs_and_lists_6_3(id_839, wanted_829);
					      {
						 obj_t wanted_2520;
						 obj_t inline_2519;
						 obj_t provided_2518;
						 provided_2518 = arg1555_843;
						 inline_2519 = arg1556_844;
						 wanted_2520 = arg1557_845;
						 wanted_829 = wanted_2520;
						 inline_828 = inline_2519;
						 provided_827 = provided_2518;
						 goto loop_830;
					      }
					   }
					}
				      else
					{	/* Module/impuse.scm 426 */
					   bool_t test1562_850;
					   test1562_850 =
					      is_a__118___object(p_841, type_type_type);
					   if (test1562_850)
					     {	/* Module/impuse.scm 426 */
						{	/* Module/impuse.scm 427 */
						   obj_t arg1563_851;
						   obj_t arg1564_852;
						   arg1563_851 =
						      CDR(provided_827);
						   arg1564_852 =
						      remq__51___r4_pairs_and_lists_6_3(id_839, wanted_829);
						   {
						      obj_t wanted_2526;
						      obj_t provided_2525;
						      provided_2525 = arg1563_851;
						      wanted_2526 = arg1564_852;
						      wanted_829 = wanted_2526;
						      provided_827 = provided_2525;
						      goto loop_830;
						   }
						}
					     }
					   else
					     {	/* Module/impuse.scm 426 */
						{	/* Module/impuse.scm 431 */
						   obj_t arg1565_853;
						   obj_t arg1566_854;
						   arg1565_853 =
						      CDR(provided_827);
						   arg1566_854 =
						      remq__51___r4_pairs_and_lists_6_3(id_839, wanted_829);
						   {
						      obj_t wanted_2530;
						      obj_t provided_2529;
						      provided_2529 = arg1565_853;
						      wanted_2530 = arg1566_854;
						      wanted_829 = wanted_2530;
						      provided_827 = provided_2529;
						      goto loop_830;
						   }
						}
					     }
					}
				   }
				}
			      else
				{
				   obj_t provided_2531;
				   provided_2531 =
				      CDR(provided_827);
				   provided_827 = provided_2531;
				   goto loop_830;
				}
			   }
			}
		      else
			{
			   obj_t provided_2533;
			   provided_2533 =
			      CDR(provided_827);
			   provided_827 = provided_2533;
			   goto loop_830;
			}
		   }
		}
	   }
      }
   }
}



/* method-init */
obj_t 
method_init_76_module_impuse()
{
   AN_OBJECT;
   {	/* Module/impuse.scm 14 */
      return BUNSPEC;
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_module_impuse()
{
   AN_OBJECT;
   {	/* Module/impuse.scm 14 */
      module_initialization_70_tools_trace(((long) 0), "MODULE_IMPUSE");
      module_initialization_70_read_reader(((long) 0), "MODULE_IMPUSE");
      module_initialization_70_module_module(((long) 0), "MODULE_IMPUSE");
      module_initialization_70_module_prototype(((long) 0), "MODULE_IMPUSE");
      module_initialization_70_module_class(((long) 0), "MODULE_IMPUSE");
      module_initialization_70_module_include(((long) 0), "MODULE_IMPUSE");
      module_initialization_70_tools_speek(((long) 0), "MODULE_IMPUSE");
      module_initialization_70_tools_error(((long) 0), "MODULE_IMPUSE");
      module_initialization_70_tools_location(((long) 0), "MODULE_IMPUSE");
      module_initialization_70_type_type(((long) 0), "MODULE_IMPUSE");
      module_initialization_70_read_access(((long) 0), "MODULE_IMPUSE");
      module_initialization_70_read_inline(((long) 0), "MODULE_IMPUSE");
      module_initialization_70_ast_var(((long) 0), "MODULE_IMPUSE");
      module_initialization_70_ast_find_gdefs_13(((long) 0), "MODULE_IMPUSE");
      module_initialization_70_ast_glo_decl_237(((long) 0), "MODULE_IMPUSE");
      module_initialization_70_ast_ident(((long) 0), "MODULE_IMPUSE");
      module_initialization_70_engine_param(((long) 0), "MODULE_IMPUSE");
      return
	 module_initialization_70_init_main(((long) 0), "MODULE_IMPUSE");
   }
}
