/*===========================================================================*/
/*   (Module/library.scm)                                                    */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct ccomp
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t producer;
     obj_t consumer;
     obj_t finalizer;
     obj_t checksummer;
  }
     *ccomp_bglt;


static obj_t method_init_76_module_library();
extern obj_t get_imported_modules_153_module_impuse();
extern obj_t create_struct(obj_t, long);
extern obj_t _bdb_debug__1_engine_param;
extern obj_t gensym___r4_symbols_6_4;
static obj_t _needed_modules__74_module_library = BUNSPEC;
extern obj_t module_initialization_70_module_library(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_env(long, char *);
extern obj_t module_initialization_70_module_module(long, char *);
extern obj_t module_initialization_70_module_impuse(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_bdb_setting(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_symbols_6_4(long, char *);
static obj_t need_library_module__2_module_library(obj_t);
extern obj_t _bdb_module__96_bdb_setting;
extern obj_t module_initialization_id_110_module_module(obj_t);
static obj_t imported_modules_init_94_module_library();
static obj_t _library_finalizer_48_module_library(obj_t);
static obj_t library_modules_init_112_module_library();
extern obj_t library_finalizer_97_module_library();
static obj_t toplevel_init_63_module_library();
extern obj_t open_input_string(obj_t);
extern obj_t getprop___r4_symbols_6_4(obj_t, obj_t);
extern obj_t for_each_global__88_ast_env(obj_t);
extern obj_t putprop__88___r4_symbols_6_4(obj_t, obj_t, obj_t);
static obj_t _key__82_module_library = BUNSPEC;
extern obj_t _module__166_module_module;
static obj_t _anonymous_1213__216_module_library(obj_t, obj_t);
extern obj_t read___reader(obj_t);
static obj_t require_initialization_114_module_library = BUNSPEC;
static obj_t cnst_init_137_module_library();
static obj_t __cnst[5];

DEFINE_STATIC_PROCEDURE(proc1271_module_library, _anonymous_1213__216_module_library1277, _anonymous_1213__216_module_library, 0L, 1);
DEFINE_EXPORT_PROCEDURE(library_finalizer_env_247_module_library, _library_finalizer_48_module_library1278, _library_finalizer_48_module_library, 0L, 0);
DEFINE_STRING(string1272_module_library, string1272_module_library1279, "(#unspecified) @ UNIT LIBRARY-MODULES FOREIGN ", 46);



/* module-initialization */
obj_t 
module_initialization_70_module_library(long checksum_621, char *from_622)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_module_library))
	{
	   require_initialization_114_module_library =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_module_library();
	   cnst_init_137_module_library();
	   imported_modules_init_94_module_library();
	   method_init_76_module_library();
	   toplevel_init_63_module_library();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_module_library()
{
   AN_OBJECT;
   {	/* Module/library.scm 14 */
      module_initialization_70___r4_symbols_6_4(((long) 0), "MODULE_LIBRARY");
      module_initialization_70___reader(((long) 0), "MODULE_LIBRARY");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_module_library()
{
   AN_OBJECT;
   {	/* Module/library.scm 14 */
      {		/* Module/library.scm 14 */
	 obj_t cnst_port_138_614;
	 cnst_port_138_614 =
	    open_input_string(string1272_module_library);
	 {
	    long i_615;
	    i_615 = ((long) 4);
	  loop_616:
	    {	/* Module/library.scm 14 */
	       bool_t test1273_617;
	       test1273_617 =
		  (i_615 == ((long) -1));
	       if (test1273_617)
		 {	/* Module/library.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Module/library.scm 14 */
		    {	/* Module/library.scm 14 */
		       obj_t arg1274_618;
		       {	/* Module/library.scm 14 */
			  obj_t list1275_619;
			  list1275_619 =
			     MAKE_PAIR(cnst_port_138_614, BNIL);
			  arg1274_618 =
			     read___reader(list1275_619);
		       }
		       CNST_TABLE_SET(i_615, arg1274_618);
		    }
		    {	/* Module/library.scm 14 */
		       int aux_620;
		       {	/* Module/library.scm 14 */
			  long aux_639;
			  aux_639 =
			     (i_615 - ((long) 1));
			  aux_620 =
			     (int) (aux_639);
		       }
		       {
			  long i_642;
			  i_642 =
			     (long) (aux_620);
			  i_615 = i_642;
			  goto loop_616;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_module_library()
{
   AN_OBJECT;
   {	/* Module/library.scm 14 */
      _needed_modules__74_module_library = BNIL;
      return (
	 _key__82_module_library = BUNSPEC, BUNSPEC);
   }
}



/* library-finalizer */
obj_t 
library_finalizer_97_module_library()
{
   AN_OBJECT;
   {	/* Module/library.scm 28 */
      _key__82_module_library =
	 PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4, BEOA);
      {
	 obj_t l1192_345;
	 {	/* Module/library.scm 33 */
	    obj_t arg1207_347;
	    arg1207_347 =
	       get_imported_modules_153_module_impuse();
	    l1192_345 = arg1207_347;
	  lname1193_346:
	    if (
	       PAIRP(l1192_345))
	      {		/* Module/library.scm 32 */
		 putprop__88___r4_symbols_6_4(
		    CAR(l1192_345), _key__82_module_library, BTRUE);
		 {
		    obj_t l1192_651;
		    l1192_651 =
		       CDR(l1192_345);
		    l1192_345 = l1192_651;
		    goto lname1193_346;
		 }
	      }
	    else
	      {		/* Module/library.scm 32 */
		 ((bool_t) 1);
	      }
	 }
      }
      putprop__88___r4_symbols_6_4(
	 CNST_TABLE_REF(((long) 0)), _key__82_module_library, BTRUE);
      putprop__88___r4_symbols_6_4(_module__166_module_module, _key__82_module_library, BTRUE);
      {		/* Module/library.scm 40 */
	 obj_t _anonymous_1213__216_609;
	 _anonymous_1213__216_609 = proc1271_module_library;
	 for_each_global__88_ast_env(_anonymous_1213__216_609);
      }
      {		/* Module/library.scm 44 */
	 bool_t test1221_360;
	 {	/* Module/library.scm 44 */
	    long n1_561;
	    n1_561 =
	       (long) CINT(_bdb_debug__1_engine_param);
	    test1221_360 =
	       (n1_561 > ((long) 0));
	 }
	 if (test1221_360)
	   {	/* Module/library.scm 44 */
	      need_library_module__2_module_library(_bdb_module__96_bdb_setting);
	   }
	 else
	   {	/* Module/library.scm 44 */
	      BUNSPEC;
	   }
      }
      {		/* Module/library.scm 47 */
	 obj_t modules_361;
	 modules_361 = _needed_modules__74_module_library;
	 if (
	    NULLP(modules_361))
	   {	/* Module/library.scm 48 */
	      return BNIL;
	   }
	 else
	   {
	      obj_t modules_363;
	      obj_t init_call__93_364;
	      modules_363 = modules_361;
	      init_call__93_364 =
		 CNST_TABLE_REF(((long) 4));
	    loop_365:
	      if (
		 NULLP(modules_363))
		{	/* Module/library.scm 53 */
		   obj_t id_565;
		   id_565 =
		      CNST_TABLE_REF(((long) 1));
		   {	/* ./Ast/unit.sch 331 */
		      obj_t new_569;
		      {		/* ./Ast/unit.sch 331 */
			 obj_t aux_666;
			 aux_666 =
			    CNST_TABLE_REF(((long) 2));
			 new_569 =
			    create_struct(aux_666, ((long) 4));
		      }
		      STRUCT_SET(new_569, ((long) 3), BTRUE);
		      STRUCT_SET(new_569, ((long) 2), init_call__93_364);
		      {		/* ./Llib/struct.scm 1463 */
			 obj_t aux_671;
			 aux_671 =
			    BINT(((long) 2));
			 STRUCT_SET(new_569, ((long) 1), aux_671);
		      }
		      STRUCT_SET(new_569, ((long) 0), id_565);
		      return new_569;
		   }
		}
	      else
		{	/* Module/library.scm 54 */
		   obj_t id_367;
		   id_367 =
		      CAR(modules_363);
		   {	/* Module/library.scm 54 */
		      obj_t init_fun_id_230_368;
		      init_fun_id_230_368 =
			 module_initialization_id_110_module_module(id_367);
		      {		/* Module/library.scm 55 */

			 {	/* Module/library.scm 56 */
			    obj_t arg1224_369;
			    obj_t arg1226_370;
			    arg1224_369 =
			       CDR(modules_363);
			    {	/* Module/library.scm 57 */
			       obj_t arg1227_371;
			       {	/* Module/library.scm 57 */
				  obj_t arg1228_372;
				  obj_t arg1229_373;
				  {	/* Module/library.scm 57 */
				     obj_t arg1230_374;
				     obj_t arg1231_375;
				     arg1230_374 =
					CNST_TABLE_REF(((long) 3));
				     {	/* Module/library.scm 57 */
					obj_t arg1232_376;
					arg1232_376 =
					   MAKE_PAIR(id_367, BNIL);
					arg1231_375 =
					   MAKE_PAIR(init_fun_id_230_368, arg1232_376);
				     }
				     arg1228_372 =
					MAKE_PAIR(arg1230_374, arg1231_375);
				  }
				  {	/* Module/library.scm 57 */
				     obj_t arg1234_378;
				     {	/* Module/library.scm 62 */
					obj_t arg1235_379;
					{	/* Module/library.scm 62 */
					   obj_t symbol_598;
					   symbol_598 = _module__166_module_module;
					   arg1235_379 =
					      SYMBOL_TO_STRING(symbol_598);
					}
					arg1234_378 =
					   MAKE_PAIR(arg1235_379, BNIL);
				     }
				     {	/* ./Ieee/pair-list.scm 5689 */
					obj_t aux_684;
					aux_684 =
					   BINT(((long) 0));
					arg1229_373 =
					   MAKE_PAIR(aux_684, arg1234_378);
				     }
				  }
				  arg1227_371 =
				     MAKE_PAIR(arg1228_372, arg1229_373);
			       }
			       arg1226_370 =
				  MAKE_PAIR(arg1227_371, init_call__93_364);
			    }
			    {
			       obj_t init_call__93_690;
			       obj_t modules_689;
			       modules_689 = arg1224_369;
			       init_call__93_690 = arg1226_370;
			       init_call__93_364 = init_call__93_690;
			       modules_363 = modules_689;
			       goto loop_365;
			    }
			 }
		      }
		   }
		}
	   }
      }
   }
}



/* _library-finalizer */
obj_t 
_library_finalizer_48_module_library(obj_t env_610)
{
   AN_OBJECT;
   {	/* Module/library.scm 28 */
      return
	 library_finalizer_97_module_library();
   }
}



/* <anonymous:1213> */
obj_t 
_anonymous_1213__216_module_library(obj_t env_611, obj_t global_612)
{
   AN_OBJECT;
   {	/* Module/library.scm 39 */
      {
	 obj_t global_352;
	 global_352 = global_612;
	 {	/* Module/library.scm 40 */
	    bool_t test_693;
	    {	/* Module/library.scm 40 */
	       bool_t test_694;
	       {	/* ./Ieee/fixnum.scm 7121 */
		  long aux_695;
		  {	/* Module/library.scm 40 */
		     global_bglt obj_556;
		     obj_556 =
			(global_bglt) (global_352);
		     aux_695 =
			(((global_bglt) CREF(obj_556))->occurrence);
		  }
		  test_694 =
		     (aux_695 > ((long) 0));
	       }
	       if (test_694)
		 {	/* Module/library.scm 41 */
		    global_bglt obj_559;
		    obj_559 =
		       (global_bglt) (global_352);
		    test_693 =
		       (((global_bglt) CREF(obj_559))->library__255);
		 }
	       else
		 {	/* Module/library.scm 40 */
		    test_693 = ((bool_t) 0)
		       ;
		 }
	    }
	    if (test_693)
	      {		/* Module/library.scm 42 */
		 obj_t aux_701;
		 {	/* Module/library.scm 42 */
		    global_bglt obj_560;
		    obj_560 =
		       (global_bglt) (global_352);
		    aux_701 =
		       (((global_bglt) CREF(obj_560))->module);
		 }
		 return
		    need_library_module__2_module_library(aux_701);
	      }
	    else
	      {		/* Module/library.scm 40 */
		 return BUNSPEC;
	      }
	 }
      }
   }
}



/* need-library-module! */
obj_t 
need_library_module__2_module_library(obj_t module_19)
{
   AN_OBJECT;
   {	/* Module/library.scm 79 */
      {		/* Module/library.scm 80 */
	 bool_t test1237_381;
	 {	/* Module/library.scm 80 */
	    obj_t aux_705;
	    aux_705 =
	       getprop___r4_symbols_6_4(module_19, _key__82_module_library);
	    test1237_381 =
	       CBOOL(aux_705);
	 }
	 if (test1237_381)
	   {	/* Module/library.scm 80 */
	      return BUNSPEC;
	   }
	 else
	   {	/* Module/library.scm 80 */
	      putprop__88___r4_symbols_6_4(module_19, _key__82_module_library, BTRUE);
	      {		/* Module/library.scm 83 */
		 obj_t obj2_608;
		 obj2_608 = _needed_modules__74_module_library;
		 return (
		    _needed_modules__74_module_library =
		    MAKE_PAIR(module_19, obj2_608), BUNSPEC);
	      }
	   }
      }
   }
}



/* method-init */
obj_t 
method_init_76_module_library()
{
   AN_OBJECT;
   {	/* Module/library.scm 14 */
      return BUNSPEC;
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_module_library()
{
   AN_OBJECT;
   {	/* Module/library.scm 14 */
      module_initialization_70_type_type(((long) 0), "MODULE_LIBRARY");
      module_initialization_70_ast_var(((long) 0), "MODULE_LIBRARY");
      module_initialization_70_ast_env(((long) 0), "MODULE_LIBRARY");
      module_initialization_70_module_module(((long) 0), "MODULE_LIBRARY");
      module_initialization_70_module_impuse(((long) 0), "MODULE_LIBRARY");
      module_initialization_70_engine_param(((long) 0), "MODULE_LIBRARY");
      return
	 module_initialization_70_bdb_setting(((long) 0), "MODULE_LIBRARY");
   }
}
