/*===========================================================================*/
/*   (Module/load.scm)                                                       */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct ccomp
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t producer;
     obj_t consumer;
     obj_t finalizer;
     obj_t checksummer;
  }
     *ccomp_bglt;

typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;


extern obj_t ccomp_module_module;
static obj_t method_init_76_module_load();
extern obj_t _access_table__91_engine_param;
static obj_t load_parser_100_module_load(obj_t, obj_t);
extern obj_t user_error_151_tools_error(obj_t, obj_t, obj_t, obj_t);
extern obj_t module_initialization_70_module_load(long, char *);
extern obj_t module_initialization_70_module_module(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_env(long, char *);
extern obj_t module_initialization_70_type_env(long, char *);
extern obj_t module_initialization_70_tools_speek(long, char *);
extern obj_t module_initialization_70_read_load(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t load_module_134_read_load(obj_t, obj_t);
extern long class_num_218___object(obj_t);
static obj_t _make_load_compiler_34_module_load(obj_t);
static obj_t imported_modules_init_94_module_load();
static obj_t library_modules_init_112_module_load();
static obj_t _load_producer_194_module_load(obj_t, obj_t);
extern obj_t assq___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern obj_t open_input_string(obj_t);
static obj_t _anonymous_1205__221_module_load(obj_t, obj_t, obj_t);
static obj_t _anonymous_1204__193_module_load(obj_t);
extern obj_t make_load_compiler_92_module_load();
static obj_t _anonymous_1203__178_module_load(obj_t, obj_t, obj_t);
extern obj_t read___reader(obj_t);
static obj_t require_initialization_114_module_load = BUNSPEC;
static obj_t cnst_init_137_module_load();
static obj_t load_producer_246_module_load(obj_t);
static obj_t __cnst[2];

DEFINE_STATIC_PROCEDURE(load_producer_env_50_module_load, _load_producer_194_module_load1274, _load_producer_194_module_load, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_load_compiler_env_29_module_load, _make_load_compiler_34_module_load1275, _make_load_compiler_34_module_load, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc1263_module_load, _anonymous_1203__178_module_load1276, _anonymous_1203__178_module_load, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc1262_module_load, _anonymous_1204__193_module_load1277, _anonymous_1204__193_module_load, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc1261_module_load, _anonymous_1205__221_module_load1278, _anonymous_1205__221_module_load, 0L, 2);
DEFINE_STRING(string1269_module_load, string1269_module_load1279, "VOID LOAD ", 10);
DEFINE_STRING(string1268_module_load, string1268_module_load1280, "Can't load module", 17);
DEFINE_STRING(string1267_module_load, string1267_module_load1281, "load", 4);
DEFINE_STRING(string1266_module_load, string1266_module_load1282, "Illegal load clause", 19);
DEFINE_STRING(string1265_module_load, string1265_module_load1283, "Illegal `load' clause", 21);
DEFINE_STRING(string1264_module_load, string1264_module_load1284, "Parse error", 11);



/* module-initialization */
obj_t 
module_initialization_70_module_load(long checksum_579, char *from_580)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_module_load))
	{
	   require_initialization_114_module_load =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_module_load();
	   cnst_init_137_module_load();
	   imported_modules_init_94_module_load();
	   method_init_76_module_load();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_module_load()
{
   AN_OBJECT;
   {	/* Module/load.scm 14 */
      module_initialization_70___object(((long) 0), "MODULE_LOAD");
      module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "MODULE_LOAD");
      module_initialization_70___reader(((long) 0), "MODULE_LOAD");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_module_load()
{
   AN_OBJECT;
   {	/* Module/load.scm 14 */
      {		/* Module/load.scm 14 */
	 obj_t cnst_port_138_572;
	 cnst_port_138_572 =
	    open_input_string(string1269_module_load);
	 {
	    long i_573;
	    i_573 = ((long) 1);
	  loop_574:
	    {	/* Module/load.scm 14 */
	       bool_t test1270_575;
	       test1270_575 =
		  (i_573 == ((long) -1));
	       if (test1270_575)
		 {	/* Module/load.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Module/load.scm 14 */
		    {	/* Module/load.scm 14 */
		       obj_t arg1271_576;
		       {	/* Module/load.scm 14 */
			  obj_t list1272_577;
			  list1272_577 =
			     MAKE_PAIR(cnst_port_138_572, BNIL);
			  arg1271_576 =
			     read___reader(list1272_577);
		       }
		       CNST_TABLE_SET(i_573, arg1271_576);
		    }
		    {	/* Module/load.scm 14 */
		       int aux_578;
		       {	/* Module/load.scm 14 */
			  long aux_597;
			  aux_597 =
			     (i_573 - ((long) 1));
			  aux_578 =
			     (int) (aux_597);
		       }
		       {
			  long i_600;
			  i_600 =
			     (long) (aux_578);
			  i_573 = i_600;
			  goto loop_574;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* make-load-compiler */
obj_t 
make_load_compiler_92_module_load()
{
   AN_OBJECT;
   {	/* Module/load.scm 29 */
      {		/* Module/load.scm 30 */
	 obj_t arg1195_319;
	 arg1195_319 =
	    CNST_TABLE_REF(((long) 0));
	 {	/* ./Module/module.scm 347 */
	    obj_t _anonymous_1205__221_559;
	    obj_t _anonymous_1204__193_560;
	    obj_t _anonymous_1203__178_561;
	    _anonymous_1205__221_559 = proc1261_module_load;
	    _anonymous_1204__193_560 = proc1262_module_load;
	    _anonymous_1203__178_561 = proc1263_module_load;
	    {	/* Module/load.scm 30 */
	       ccomp_bglt res1260_525;
	       {	/* ./Module/module.scm 339 */
		  ccomp_bglt new1002_516;
		  new1002_516 =
		     ((ccomp_bglt) BREF(GC_MALLOC(sizeof(struct ccomp))));
		  {	/* ./Module/module.scm 339 */
		     long arg1259_517;
		     arg1259_517 =
			class_num_218___object(ccomp_module_module);
		     {	/* ./Module/module.scm 339 */
			obj_t obj_523;
			obj_523 =
			   (obj_t) (new1002_516);
			(((obj_t) CREF(obj_523))->header = MAKE_HEADER(arg1259_517, 0), BUNSPEC);
		     }
		  }
		  {	/* ./Module/module.scm 339 */
		     object_bglt aux_607;
		     aux_607 =
			(object_bglt) (new1002_516);
		     OBJECT_WIDENING_SET(aux_607, BFALSE);
		  }
		  ((((ccomp_bglt) CREF(new1002_516))->id) = ((obj_t) arg1195_319), BUNSPEC);
		  ((((ccomp_bglt) CREF(new1002_516))->producer) = ((obj_t) load_producer_env_50_module_load), BUNSPEC);
		  ((((ccomp_bglt) CREF(new1002_516))->consumer) = ((obj_t) _anonymous_1203__178_561), BUNSPEC);
		  ((((ccomp_bglt) CREF(new1002_516))->finalizer) = ((obj_t) _anonymous_1204__193_560), BUNSPEC);
		  ((((ccomp_bglt) CREF(new1002_516))->checksummer) = ((obj_t) _anonymous_1205__221_559), BUNSPEC);
		  res1260_525 = new1002_516;
	       }
	       return
		  (obj_t) (res1260_525);
	    }
	 }
      }
   }
}



/* _make-load-compiler */
obj_t 
_make_load_compiler_34_module_load(obj_t env_562)
{
   AN_OBJECT;
   {	/* Module/load.scm 29 */
      return
	 make_load_compiler_92_module_load();
   }
}



/* <anonymous:1205> */
obj_t 
_anonymous_1205__221_module_load(obj_t env_563, obj_t m_564, obj_t c_565)
{
   AN_OBJECT;
   {	/* ./Module/module.scm 352 */
      {
	 obj_t m_328;
	 obj_t c_329;
	 m_328 = m_564;
	 c_329 = c_565;
	 return c_329;
      }
   }
}



/* <anonymous:1204> */
obj_t 
_anonymous_1204__193_module_load(obj_t env_566)
{
   AN_OBJECT;
   {	/* ./Module/module.scm 349 */
      {

	 return
	    CNST_TABLE_REF(((long) 1));
      }
   }
}



/* <anonymous:1203> */
obj_t 
_anonymous_1203__178_module_load(obj_t env_567, obj_t m_568, obj_t c_569)
{
   AN_OBJECT;
   {	/* ./Module/module.scm 347 */
      {
	 obj_t m_324;
	 obj_t c_325;
	 m_324 = m_568;
	 c_325 = c_569;
	 return BNIL;
      }
   }
}



/* load-producer */
obj_t 
load_producer_246_module_load(obj_t clause_1)
{
   AN_OBJECT;
   {	/* Module/load.scm 36 */
      {
	 obj_t protos_334;
	 if (
	    PAIRP(clause_1))
	   {	/* Module/load.scm 37 */
	      bool_t aux_620;
	      protos_334 =
		 CDR(clause_1);
	      {
		 obj_t l1193_340;
		 l1193_340 = protos_334;
	       lname1194_341:
		 if (
		    PAIRP(l1193_340))
		   {	/* Module/load.scm 39 */
		      load_parser_100_module_load(
			 CAR(l1193_340), clause_1);
		      {
			 obj_t l1193_625;
			 l1193_625 =
			    CDR(l1193_340);
			 l1193_340 = l1193_625;
			 goto lname1194_341;
		      }
		   }
		 else
		   {	/* Module/load.scm 39 */
		      aux_620 = ((bool_t) 1);
		   }
	      }
	      return
		 BBOOL(aux_620);
	   }
	 else
	   {	/* Module/load.scm 37 */
	      {		/* Module/load.scm 41 */
		 obj_t list1210_345;
		 list1210_345 =
		    MAKE_PAIR(BNIL, BNIL);
		 return
		    user_error_151_tools_error(string1264_module_load, string1265_module_load, clause_1, list1210_345);
	      }
	   }
      }
   }
}



/* _load-producer */
obj_t 
_load_producer_194_module_load(obj_t env_570, obj_t clause_571)
{
   AN_OBJECT;
   {	/* Module/load.scm 36 */
      return
	 load_producer_246_module_load(clause_571);
   }
}



/* load-parser */
obj_t 
load_parser_100_module_load(obj_t proto_2, obj_t clause_3)
{
   AN_OBJECT;
   {	/* Module/load.scm 49 */
      {
	 obj_t module_346;
	 obj_t file_347;
	 obj_t files_348;
	 if (
	    PAIRP(proto_2))
	   {	/* Module/load.scm 50 */
	      obj_t car_119_235_354;
	      obj_t cdr_120_34_355;
	      car_119_235_354 =
		 CAR(proto_2);
	      cdr_120_34_355 =
		 CDR(proto_2);
	      if (
		 SYMBOLP(car_119_235_354))
		{	/* Module/load.scm 50 */
		   if (
		      PAIRP(cdr_120_34_355))
		     {	/* Module/load.scm 50 */
			obj_t car_125_199_358;
			car_125_199_358 =
			   CAR(cdr_120_34_355);
			if (
			   STRINGP(car_125_199_358))
			  {	/* Module/load.scm 50 */
			     module_346 = car_119_235_354;
			     file_347 = car_125_199_358;
			     files_348 =
				CDR(cdr_120_34_355);
			     {
				obj_t f_365;
				f_365 = files_348;
			      loop_366:
				if (
				   NULLP(f_365))
				  {	/* Module/load.scm 54 */
				     {	/* Module/load.scm 55 */
					obj_t arg1222_368;
					arg1222_368 =
					   MAKE_PAIR(file_347, files_348);
					return
					   load_module_134_read_load(module_346, arg1222_368);
				     }
				  }
				else
				  {	/* Module/load.scm 56 */
				     bool_t test_647;
				     {	/* ./Ieee/string.scm 8047 */
					obj_t aux_648;
					aux_648 =
					   CAR(f_365);
					test_647 =
					   STRINGP(aux_648);
				     }
				     if (test_647)
				       {	/* Module/load.scm 56 */
					  {
					     obj_t f_651;
					     f_651 =
						CDR(f_365);
					     f_365 = f_651;
					     goto loop_366;
					  }
				       }
				     else
				       {	/* Module/load.scm 56 */
					  {	/* Module/load.scm 57 */
					     obj_t list1225_371;
					     list1225_371 =
						MAKE_PAIR(BNIL, BNIL);
					     return
						user_error_151_tools_error(string1264_module_load, string1266_module_load, clause_3, list1225_371);
					  }
				       }
				  }
			     }
			  }
			else
			  {	/* Module/load.scm 50 */
			     if (
				SYMBOLP(proto_2))
			       {	/* Module/load.scm 50 */
				tag_110_179_350:
				  {	/* Module/load.scm 61 */
				     obj_t b_373;
				     b_373 =
					assq___r4_pairs_and_lists_6_3(proto_2, _access_table__91_engine_param);
				     if (
					CBOOL(b_373))
				       {	/* Module/load.scm 62 */
					  return
					     load_module_134_read_load(proto_2,
					     CDR(b_373));
				       }
				     else
				       {	/* Module/load.scm 62 */
					  return
					     user_error_151_tools_error(string1267_module_load, string1268_module_load, proto_2, BNIL);
				       }
				  }
			       }
			     else
			       {	/* Module/load.scm 50 */
				tag_111_62_351:
				  {	/* Module/load.scm 66 */
				     obj_t list1229_376;
				     list1229_376 =
					MAKE_PAIR(BNIL, BNIL);
				     return
					user_error_151_tools_error(string1264_module_load, string1266_module_load, clause_3, list1229_376);
				  }
			       }
			  }
		     }
		   else
		     {	/* Module/load.scm 50 */
			if (
			   SYMBOLP(proto_2))
			  {	/* Module/load.scm 50 */
			     goto tag_110_179_350;
			  }
			else
			  {	/* Module/load.scm 50 */
			     goto tag_111_62_351;
			  }
		     }
		}
	      else
		{	/* Module/load.scm 50 */
		   if (
		      SYMBOLP(proto_2))
		     {	/* Module/load.scm 50 */
			goto tag_110_179_350;
		     }
		   else
		     {	/* Module/load.scm 50 */
			goto tag_111_62_351;
		     }
		}
	   }
	 else
	   {	/* Module/load.scm 50 */
	      if (
		 SYMBOLP(proto_2))
		{	/* Module/load.scm 50 */
		   goto tag_110_179_350;
		}
	      else
		{	/* Module/load.scm 50 */
		   goto tag_111_62_351;
		}
	   }
      }
   }
}



/* method-init */
obj_t 
method_init_76_module_load()
{
   AN_OBJECT;
   {	/* Module/load.scm 14 */
      return BUNSPEC;
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_module_load()
{
   AN_OBJECT;
   {	/* Module/load.scm 14 */
      module_initialization_70_module_module(((long) 0), "MODULE_LOAD");
      module_initialization_70_engine_param(((long) 0), "MODULE_LOAD");
      module_initialization_70_tools_error(((long) 0), "MODULE_LOAD");
      module_initialization_70_type_type(((long) 0), "MODULE_LOAD");
      module_initialization_70_ast_var(((long) 0), "MODULE_LOAD");
      module_initialization_70_ast_env(((long) 0), "MODULE_LOAD");
      module_initialization_70_type_env(((long) 0), "MODULE_LOAD");
      module_initialization_70_tools_speek(((long) 0), "MODULE_LOAD");
      return
	 module_initialization_70_read_load(((long) 0), "MODULE_LOAD");
   }
}
