/*===========================================================================*/
/*   (Module/pragma.scm)                                                     */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct ccomp
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t producer;
     obj_t consumer;
     obj_t finalizer;
     obj_t checksummer;
  }
     *ccomp_bglt;

typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;


extern obj_t ccomp_module_module;
static obj_t method_init_76_module_pragma();
extern obj_t find_global_module_25_ast_env(obj_t, obj_t);
extern obj_t warning___error(obj_t);
extern obj_t global_ast_var;
static obj_t _make_pragma_compiler_94_module_pragma(obj_t);
extern obj_t user_error_151_tools_error(obj_t, obj_t, obj_t, obj_t);
static obj_t pragma_producer_255_module_pragma(obj_t);
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t module_initialization_70_module_pragma(long, char *);
extern obj_t module_initialization_70_module_module(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_env(long, char *);
extern obj_t module_initialization_70_ast_remove(long, char *);
extern obj_t module_initialization_70_type_env(long, char *);
extern obj_t module_initialization_70_tools_location(long, char *);
extern obj_t module_initialization_70___error(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern long class_num_218___object(obj_t);
extern obj_t remove_var_from__148_ast_remove(obj_t, variable_bglt);
extern obj_t fun_ast_var;
static obj_t imported_modules_init_94_module_pragma();
extern obj_t make_pragma_compiler_150_module_pragma();
static obj_t pragma_parser_198_module_pragma(obj_t, obj_t, obj_t);
static obj_t _pragma_list__157_module_pragma = BUNSPEC;
static obj_t library_modules_init_112_module_pragma();
extern obj_t _optim_stack___57_engine_param;
static bool_t set_pragma_properties__114_module_pragma(obj_t, obj_t, obj_t);
extern type_bglt use_type__231_type_env(obj_t, obj_t);
static obj_t toplevel_init_63_module_pragma();
extern obj_t open_input_string(obj_t);
extern obj_t sfun_ast_var;
static obj_t _pragma_finalizer_19_module_pragma(obj_t);
extern obj_t internal_error_43_tools_error(obj_t, obj_t, obj_t);
extern obj_t _module__166_module_module;
static obj_t _anonymous_1211__220_module_pragma(obj_t, obj_t);
static obj_t _anonymous_1210__172_module_pragma(obj_t, obj_t, obj_t);
static obj_t _anonymous_1208__5_module_pragma(obj_t, obj_t, obj_t);
static obj_t set_pragma_property__180_module_pragma(obj_t, obj_t, obj_t);
extern obj_t read___reader(obj_t);
extern obj_t pragma_finalizer_170_module_pragma();
extern obj_t find_location_120_tools_location(obj_t);
static obj_t require_initialization_114_module_pragma = BUNSPEC;
static obj_t cnst_init_137_module_pragma();
static obj_t __cnst[12];

DEFINE_EXPORT_PROCEDURE(make_pragma_compiler_env_9_module_pragma, _make_pragma_compiler_94_module_pragma1357, _make_pragma_compiler_94_module_pragma, 0L, 0);
DEFINE_EXPORT_PROCEDURE(pragma_finalizer_env_89_module_pragma, _pragma_finalizer_19_module_pragma1358, _pragma_finalizer_19_module_pragma, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc1338_module_pragma, _anonymous_1208__5_module_pragma1359, _anonymous_1208__5_module_pragma, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc1337_module_pragma, _anonymous_1210__172_module_pragma1360, _anonymous_1210__172_module_pragma, 0L, 2);
DEFINE_STRING(string1351_module_pragma, string1351_module_pragma1361, "CFA STACK-ALLOC COERCE PREDICATE-OF NO-TRACE ALLOCATOR NO-CFA-TOP SIDE-EFFECT-FREE VOID @ FOREIGN PRAGMA ", 105);
DEFINE_STRING(string1349_module_pragma, string1349_module_pragma1362, "alloctor is not a function", 26);
DEFINE_STRING(string1350_module_pragma, string1350_module_pragma1363, "Can't find stack allocator", 26);
DEFINE_STRING(string1348_module_pragma, string1348_module_pragma1364, "predicate is not associated to a function", 41);
DEFINE_STRING(string1347_module_pragma, string1347_module_pragma1365, "Illegal `pragma' form", 21);
DEFINE_STRING(string1346_module_pragma, string1346_module_pragma1366, "property is not concerning a sfunction", 38);
DEFINE_STRING(string1345_module_pragma, string1345_module_pragma1367, "property is not concerning a function", 37);
DEFINE_STRING(string1344_module_pragma, string1344_module_pragma1368, "pragma", 6);
DEFINE_STRING(string1343_module_pragma, string1343_module_pragma1369, "Illegal `pragma' finalizer form", 31);
DEFINE_STRING(string1342_module_pragma, string1342_module_pragma1370, "pragma-finalizer", 16);
DEFINE_STRING(string1341_module_pragma, string1341_module_pragma1371, "Can't find global variable -- ", 30);
DEFINE_STRING(string1339_module_pragma, string1339_module_pragma1372, "Parse error", 11);
DEFINE_STRING(string1340_module_pragma, string1340_module_pragma1373, "Illegal `pragma' clause", 23);



/* module-initialization */
obj_t 
module_initialization_70_module_pragma(long checksum_755, char *from_756)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_module_pragma))
	{
	   require_initialization_114_module_pragma =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_module_pragma();
	   cnst_init_137_module_pragma();
	   imported_modules_init_94_module_pragma();
	   method_init_76_module_pragma();
	   toplevel_init_63_module_pragma();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_module_pragma()
{
   AN_OBJECT;
   {	/* Module/pragma.scm 14 */
      module_initialization_70___error(((long) 0), "MODULE_PRAGMA");
      module_initialization_70___object(((long) 0), "MODULE_PRAGMA");
      module_initialization_70___reader(((long) 0), "MODULE_PRAGMA");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_module_pragma()
{
   AN_OBJECT;
   {	/* Module/pragma.scm 14 */
      {		/* Module/pragma.scm 14 */
	 obj_t cnst_port_138_748;
	 cnst_port_138_748 =
	    open_input_string(string1351_module_pragma);
	 {
	    long i_749;
	    i_749 = ((long) 11);
	  loop_750:
	    {	/* Module/pragma.scm 14 */
	       bool_t test1352_751;
	       test1352_751 =
		  (i_749 == ((long) -1));
	       if (test1352_751)
		 {	/* Module/pragma.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Module/pragma.scm 14 */
		    {	/* Module/pragma.scm 14 */
		       obj_t arg1354_752;
		       {	/* Module/pragma.scm 14 */
			  obj_t list1355_753;
			  list1355_753 =
			     MAKE_PAIR(cnst_port_138_748, BNIL);
			  arg1354_752 =
			     read___reader(list1355_753);
		       }
		       CNST_TABLE_SET(i_749, arg1354_752);
		    }
		    {	/* Module/pragma.scm 14 */
		       int aux_754;
		       {	/* Module/pragma.scm 14 */
			  long aux_774;
			  aux_774 =
			     (i_749 - ((long) 1));
			  aux_754 =
			     (int) (aux_774);
		       }
		       {
			  long i_777;
			  i_777 =
			     (long) (aux_754);
			  i_749 = i_777;
			  goto loop_750;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_module_pragma()
{
   AN_OBJECT;
   {	/* Module/pragma.scm 14 */
      return (
	 _pragma_list__157_module_pragma = BNIL, BUNSPEC);
   }
}



/* make-pragma-compiler */
obj_t 
make_pragma_compiler_150_module_pragma()
{
   AN_OBJECT;
   {	/* Module/pragma.scm 30 */
      {		/* Module/pragma.scm 31 */
	 obj_t arg1201_326;
	 obj_t arg1202_327;
	 arg1201_326 =
	    CNST_TABLE_REF(((long) 0));
	 arg1202_327 =
	    pragma_producer_255_module_pragma(_module__166_module_module);
	 {	/* Module/pragma.scm 34 */
	    obj_t _anonymous_1210__172_734;
	    obj_t _anonymous_1208__5_735;
	    _anonymous_1210__172_734 = proc1337_module_pragma;
	    _anonymous_1208__5_735 = proc1338_module_pragma;
	    {	/* Module/pragma.scm 31 */
	       ccomp_bglt res1336_624;
	       {	/* ./Module/module.scm 467 */
		  ccomp_bglt new1002_615;
		  new1002_615 =
		     ((ccomp_bglt) BREF(GC_MALLOC(sizeof(struct ccomp))));
		  {	/* ./Module/module.scm 467 */
		     long arg1335_616;
		     arg1335_616 =
			class_num_218___object(ccomp_module_module);
		     {	/* ./Module/module.scm 467 */
			obj_t obj_622;
			obj_622 =
			   (obj_t) (new1002_615);
			(((obj_t) CREF(obj_622))->header = MAKE_HEADER(arg1335_616, 0), BUNSPEC);
		     }
		  }
		  {	/* ./Module/module.scm 467 */
		     object_bglt aux_785;
		     aux_785 =
			(object_bglt) (new1002_615);
		     OBJECT_WIDENING_SET(aux_785, BFALSE);
		  }
		  ((((ccomp_bglt) CREF(new1002_615))->id) = ((obj_t) arg1201_326), BUNSPEC);
		  ((((ccomp_bglt) CREF(new1002_615))->producer) = ((obj_t) arg1202_327), BUNSPEC);
		  ((((ccomp_bglt) CREF(new1002_615))->consumer) = ((obj_t) _anonymous_1208__5_735), BUNSPEC);
		  ((((ccomp_bglt) CREF(new1002_615))->finalizer) = ((obj_t) pragma_finalizer_env_89_module_pragma), BUNSPEC);
		  ((((ccomp_bglt) CREF(new1002_615))->checksummer) = ((obj_t) _anonymous_1210__172_734), BUNSPEC);
		  res1336_624 = new1002_615;
	       }
	       return
		  (obj_t) (res1336_624);
	    }
	 }
      }
   }
}



/* _make-pragma-compiler */
obj_t 
_make_pragma_compiler_94_module_pragma(obj_t env_736)
{
   AN_OBJECT;
   {	/* Module/pragma.scm 30 */
      return
	 make_pragma_compiler_150_module_pragma();
   }
}



/* <anonymous:1210> */
obj_t 
_anonymous_1210__172_module_pragma(obj_t env_737, obj_t m_738, obj_t c_739)
{
   AN_OBJECT;
   {	/* ./Module/module.scm 480 */
      {
	 obj_t m_335;
	 obj_t c_336;
	 m_335 = m_738;
	 c_336 = c_739;
	 return c_336;
      }
   }
}



/* <anonymous:1208> */
obj_t 
_anonymous_1208__5_module_pragma(obj_t env_740, obj_t m_741, obj_t c_742)
{
   AN_OBJECT;
   {	/* Module/pragma.scm 33 */
      {
	 obj_t m_331;
	 obj_t c_332;
	 m_331 = m_741;
	 c_332 = c_742;
	 {	/* Module/pragma.scm 34 */
	    obj_t fun1209_625;
	    fun1209_625 =
	       pragma_producer_255_module_pragma(m_331);
	    return
	       PROCEDURE_ENTRY(fun1209_625) (fun1209_625, c_332, BEOA);
	 }
      }
   }
}



/* pragma-producer */
obj_t 
pragma_producer_255_module_pragma(obj_t module_1)
{
   AN_OBJECT;
   {	/* Module/pragma.scm 40 */
      {		/* Module/pragma.scm 41 */
	 obj_t _anonymous_1211__220_744;
	 _anonymous_1211__220_744 =
	    make_fx_procedure(_anonymous_1211__220_module_pragma, ((long) 1), ((long) 1));
	 PROCEDURE_SET(_anonymous_1211__220_744, ((long) 0), module_1);
	 return _anonymous_1211__220_744;
      }
   }
}



/* <anonymous:1211> */
obj_t 
_anonymous_1211__220_module_pragma(obj_t env_745, obj_t clause_747)
{
   AN_OBJECT;
   {	/* Module/pragma.scm 41 */
      {		/* Module/pragma.scm 41 */
	 obj_t module_746;
	 module_746 =
	    PROCEDURE_REF(env_745, ((long) 0));
	 {
	    obj_t clause_340;
	    clause_340 = clause_747;
	    {
	       obj_t protos_342;
	       if (
		  PAIRP(clause_340))
		 {	/* Module/pragma.scm 41 */
		    protos_342 =
		       CDR(clause_340);
		    {
		       obj_t l1193_348;
		       l1193_348 = protos_342;
		     lname1194_349:
		       if (
			  PAIRP(l1193_348))
			 {	/* Module/pragma.scm 44 */
			    pragma_parser_198_module_pragma(
			       CAR(l1193_348), module_746, clause_340);
			    {
			       obj_t l1193_807;
			       l1193_807 =
				  CDR(l1193_348);
			       l1193_348 = l1193_807;
			       goto lname1194_349;
			    }
			 }
		       else
			 {	/* Module/pragma.scm 44 */
			    ((bool_t) 1);
			 }
		    }
		    return BNIL;
		 }
	       else
		 {	/* Module/pragma.scm 41 */
		    {	/* Module/pragma.scm 48 */
		       obj_t list1216_353;
		       list1216_353 =
			  MAKE_PAIR(BNIL, BNIL);
		       return
			  user_error_151_tools_error(string1339_module_pragma, string1340_module_pragma, clause_340, list1216_353);
		    }
		 }
	    }
	 }
      }
   }
}



/* pragma-parser */
obj_t 
pragma_parser_198_module_pragma(obj_t proto_2, obj_t module_3, obj_t clause_4)
{
   AN_OBJECT;
   {	/* Module/pragma.scm 56 */
      {
	 obj_t id_354;
	 obj_t prop_355;
	 if (
	    PAIRP(proto_2))
	   {	/* Module/pragma.scm 57 */
	      obj_t car_116_203_360;
	      car_116_203_360 =
		 CAR(proto_2);
	      if (
		 SYMBOLP(car_116_203_360))
		{	/* Module/pragma.scm 57 */
		   id_354 = car_116_203_360;
		   prop_355 =
		      CDR(proto_2);
		   {	/* Module/pragma.scm 59 */
		      obj_t arg1222_363;
		      {		/* Module/pragma.scm 59 */
			 obj_t list1223_364;
			 {	/* Module/pragma.scm 59 */
			    obj_t arg1224_365;
			    {	/* Module/pragma.scm 59 */
			       obj_t arg1226_366;
			       {	/* Module/pragma.scm 59 */
				  obj_t arg1227_367;
				  arg1227_367 =
				     MAKE_PAIR(clause_4, BNIL);
				  arg1226_366 =
				     MAKE_PAIR(prop_355, arg1227_367);
			       }
			       arg1224_365 =
				  MAKE_PAIR(module_3, arg1226_366);
			    }
			    list1223_364 =
			       MAKE_PAIR(id_354, arg1224_365);
			 }
			 arg1222_363 = list1223_364;
		      }
		      {		/* Module/pragma.scm 59 */
			 obj_t obj2_637;
			 obj2_637 = _pragma_list__157_module_pragma;
			 return (
			    _pragma_list__157_module_pragma =
			    MAKE_PAIR(arg1222_363, obj2_637), BUNSPEC);
		      }
		   }
		}
	      else
		{	/* Module/pragma.scm 57 */
		 tag_110_179_357:
		   {	/* Module/pragma.scm 61 */
		      obj_t list1228_368;
		      list1228_368 =
			 MAKE_PAIR(BNIL, BNIL);
		      return
			 user_error_151_tools_error(string1339_module_pragma, string1340_module_pragma, clause_4, list1228_368);
		   }
		}
	   }
	 else
	   {	/* Module/pragma.scm 57 */
	      goto tag_110_179_357;
	   }
      }
   }
}



/* pragma-finalizer */
obj_t 
pragma_finalizer_170_module_pragma()
{
   AN_OBJECT;
   {	/* Module/pragma.scm 71 */
      {
	 obj_t l1195_369;
	 l1195_369 = _pragma_list__157_module_pragma;
       lname1196_370:
	 if (
	    PAIRP(l1195_369))
	   {	/* Module/pragma.scm 72 */
	      {		/* Module/pragma.scm 73 */
		 obj_t pragma_372;
		 pragma_372 =
		    CAR(l1195_369);
		 {
		    obj_t id_373;
		    obj_t module_374;
		    obj_t prop__131_375;
		    obj_t clause_376;
		    if (
		       PAIRP(pragma_372))
		      {		/* Module/pragma.scm 73 */
			 obj_t cdr_133_55_381;
			 cdr_133_55_381 =
			    CDR(pragma_372);
			 if (
			    PAIRP(cdr_133_55_381))
			   {	/* Module/pragma.scm 73 */
			      obj_t cdr_139_72_383;
			      cdr_139_72_383 =
				 CDR(cdr_133_55_381);
			      if (
				 PAIRP(cdr_139_72_383))
				{	/* Module/pragma.scm 73 */
				   obj_t cdr_144_157_385;
				   cdr_144_157_385 =
				      CDR(cdr_139_72_383);
				   if (
				      PAIRP(cdr_144_157_385))
				     {	/* Module/pragma.scm 73 */
					bool_t test_839;
					{	/* ./Ieee/equiv.scm 5508 */
					   obj_t aux_840;
					   aux_840 =
					      CDR(cdr_144_157_385);
					   test_839 =
					      (aux_840 == BNIL);
					}
					if (test_839)
					  {	/* Module/pragma.scm 73 */
					     id_373 =
						CAR(pragma_372);
					     module_374 =
						CAR(cdr_133_55_381);
					     prop__131_375 =
						CAR(cdr_139_72_383);
					     clause_376 =
						CAR(cdr_144_157_385);
					     {	/* Module/pragma.scm 75 */
						obj_t global_394;
						{	/* Module/pragma.scm 75 */
						   obj_t global_405;
						   global_405 =
						      find_global_module_25_ast_env(id_373, module_374);
						   {	/* Module/pragma.scm 77 */
						      bool_t test1253_406;
						      test1253_406 =
							 is_a__118___object(global_405, global_ast_var);
						      if (test1253_406)
							{	/* Module/pragma.scm 77 */
							   global_394 = global_405;
							}
						      else
							{	/* Module/pragma.scm 77 */
							   global_394 =
							      find_global_module_25_ast_env(id_373,
							      CNST_TABLE_REF(((long) 1)));
							}
						   }
						}
						{	/* Module/pragma.scm 80 */
						   bool_t test1242_395;
						   test1242_395 =
						      is_a__118___object(global_394, global_ast_var);
						   if (test1242_395)
						     {	/* Module/pragma.scm 84 */
							bool_t aux_850;
							aux_850 =
							   set_pragma_properties__114_module_pragma(global_394, prop__131_375, clause_376);
							BBOOL(aux_850);
						     }
						   else
						     {	/* Module/pragma.scm 81 */
							obj_t arg1246_398;
							{	/* Module/pragma.scm 83 */
							   obj_t arg1250_402;
							   obj_t arg1251_403;
							   arg1250_402 =
							      CNST_TABLE_REF(((long) 2));
							   {	/* Module/pragma.scm 83 */
							      obj_t arg1252_404;
							      arg1252_404 =
								 MAKE_PAIR(module_374, BNIL);
							      arg1251_403 =
								 MAKE_PAIR(id_373, arg1252_404);
							   }
							   arg1246_398 =
							      MAKE_PAIR(arg1250_402, arg1251_403);
							}
							{	/* Module/pragma.scm 81 */
							   obj_t list1247_399;
							   {	/* Module/pragma.scm 81 */
							      obj_t arg1248_400;
							      {		/* Module/pragma.scm 81 */
								 obj_t arg1249_401;
								 arg1249_401 =
								    MAKE_PAIR(arg1246_398, BNIL);
								 arg1248_400 =
								    MAKE_PAIR(string1341_module_pragma, arg1249_401);
							      }
							      list1247_399 =
								 MAKE_PAIR(string1342_module_pragma, arg1248_400);
							   }
							   warning___error(list1247_399);
							}
						     }
						}
					     }
					  }
					else
					  {	/* Module/pragma.scm 73 */
					   tag_122_225_378:
					     internal_error_43_tools_error(string1342_module_pragma, string1343_module_pragma, pragma_372);
					  }
				     }
				   else
				     {	/* Module/pragma.scm 73 */
					goto tag_122_225_378;
				     }
				}
			      else
				{	/* Module/pragma.scm 73 */
				   goto tag_122_225_378;
				}
			   }
			 else
			   {	/* Module/pragma.scm 73 */
			      goto tag_122_225_378;
			   }
		      }
		    else
		      {		/* Module/pragma.scm 73 */
			 goto tag_122_225_378;
		      }
		 }
	      }
	      {
		 obj_t l1195_866;
		 l1195_866 =
		    CDR(l1195_369);
		 l1195_369 = l1195_866;
		 goto lname1196_370;
	      }
	   }
	 else
	   {	/* Module/pragma.scm 72 */
	      ((bool_t) 1);
	   }
      }
      _pragma_list__157_module_pragma = BNIL;
      return
	 CNST_TABLE_REF(((long) 3));
   }
}



/* _pragma-finalizer */
obj_t 
_pragma_finalizer_19_module_pragma(obj_t env_743)
{
   AN_OBJECT;
   {	/* Module/pragma.scm 71 */
      return
	 pragma_finalizer_170_module_pragma();
   }
}



/* set-pragma-properties! */
bool_t 
set_pragma_properties__114_module_pragma(obj_t global_5, obj_t prop__131_6, obj_t clause_7)
{
   AN_OBJECT;
   {	/* Module/pragma.scm 96 */
      {
	 obj_t l1197_408;
	 l1197_408 = prop__131_6;
       lname1198_409:
	 if (
	    PAIRP(l1197_408))
	   {	/* Module/pragma.scm 97 */
	      set_pragma_property__180_module_pragma(global_5,
		 CAR(l1197_408), clause_7);
	      {
		 obj_t l1197_874;
		 l1197_874 =
		    CDR(l1197_408);
		 l1197_408 = l1197_874;
		 goto lname1198_409;
	      }
	   }
	 else
	   {	/* Module/pragma.scm 97 */
	      return ((bool_t) 1);
	   }
      }
   }
}



/* set-pragma-property! */
obj_t 
set_pragma_property__180_module_pragma(obj_t global_8, obj_t prop_9, obj_t clause_10)
{
   AN_OBJECT;
   {	/* Module/pragma.scm 103 */
      {
	 obj_t key_414;
	 obj_t value_415;
	 if (
	    SYMBOLP(prop_9))
	   {	/* Module/pragma.scm 104 */
	      {		/* Module/pragma.scm 106 */
		 bool_t test_878;
		 {	/* ./Ieee/equiv.scm 5508 */
		    obj_t aux_879;
		    aux_879 =
		       CNST_TABLE_REF(((long) 4));
		    test_878 =
		       (prop_9 == aux_879);
		 }
		 if (test_878)
		   {	/* Module/pragma.scm 109 */
		      value_bglt value_432;
		      {		/* Module/pragma.scm 109 */
			 global_bglt obj_679;
			 obj_679 =
			    (global_bglt) (global_8);
			 value_432 =
			    (((global_bglt) CREF(obj_679))->value);
		      }
		      {		/* Module/pragma.scm 110 */
			 bool_t test1266_433;
			 test1266_433 =
			    is_a__118___object(
			    (obj_t) (value_432), fun_ast_var);
			 if (test1266_433)
			   {	/* Module/pragma.scm 115 */
			      fun_bglt obj_681;
			      obj_t val1110_682;
			      obj_681 =
				 (fun_bglt) (value_432);
			      val1110_682 = BFALSE;
			      return
				 ((((fun_bglt) CREF(obj_681))->side_effect__165) = ((obj_t) val1110_682), BUNSPEC);
			   }
			 else
			   {	/* Module/pragma.scm 111 */
			      obj_t list1267_434;
			      list1267_434 =
				 MAKE_PAIR(BNIL, BNIL);
			      return
				 user_error_151_tools_error(string1344_module_pragma, string1345_module_pragma, prop_9, list1267_434);
			   }
		      }
		   }
		 else
		   {	/* Module/pragma.scm 106 */
		      bool_t test_891;
		      {		/* ./Ieee/equiv.scm 5508 */
			 obj_t aux_892;
			 aux_892 =
			    CNST_TABLE_REF(((long) 5));
			 test_891 =
			    (prop_9 == aux_892);
		      }
		      if (test_891)
			{	/* Module/pragma.scm 118 */
			   value_bglt value_436;
			   {	/* Module/pragma.scm 118 */
			      global_bglt obj_685;
			      obj_685 =
				 (global_bglt) (global_8);
			      value_436 =
				 (((global_bglt) CREF(obj_685))->value);
			   }
			   {	/* Module/pragma.scm 119 */
			      bool_t test1269_437;
			      test1269_437 =
				 is_a__118___object(
				 (obj_t) (value_436), fun_ast_var);
			      if (test1269_437)
				{	/* Module/pragma.scm 124 */
				   fun_bglt obj_687;
				   obj_687 =
				      (fun_bglt) (value_436);
				   return
				      ((((fun_bglt) CREF(obj_687))->top__138) = ((bool_t) ((bool_t) 0)), BUNSPEC);
				}
			      else
				{	/* Module/pragma.scm 120 */
				   obj_t list1270_438;
				   list1270_438 =
				      MAKE_PAIR(BNIL, BNIL);
				   return
				      user_error_151_tools_error(string1344_module_pragma, string1345_module_pragma, prop_9, list1270_438);
				}
			   }
			}
		      else
			{	/* Module/pragma.scm 106 */
			   bool_t test_904;
			   {	/* ./Ieee/equiv.scm 5508 */
			      obj_t aux_905;
			      aux_905 =
				 CNST_TABLE_REF(((long) 6));
			      test_904 =
				 (prop_9 == aux_905);
			   }
			   if (test_904)
			     {	/* Module/pragma.scm 128 */
				value_bglt value_440;
				{	/* Module/pragma.scm 128 */
				   global_bglt obj_691;
				   obj_691 =
				      (global_bglt) (global_8);
				   value_440 =
				      (((global_bglt) CREF(obj_691))->value);
				}
				{	/* Module/pragma.scm 129 */
				   bool_t test1272_441;
				   test1272_441 =
				      is_a__118___object(
				      (obj_t) (value_440), sfun_ast_var);
				   if (test1272_441)
				     {	/* Module/pragma.scm 135 */
					obj_t arg1273_442;
					{	/* ./Ieee/pair-list.scm 5689 */
					   obj_t aux_913;
					   {	/* Module/pragma.scm 135 */
					      sfun_bglt obj_693;
					      obj_693 =
						 (sfun_bglt) (value_440);
					      aux_913 =
						 (((sfun_bglt) CREF(obj_693))->property);
					   }
					   arg1273_442 =
					      MAKE_PAIR(prop_9, aux_913);
					}
					{	/* Module/pragma.scm 134 */
					   sfun_bglt obj_696;
					   obj_696 =
					      (sfun_bglt) (value_440);
					   return
					      ((((sfun_bglt) CREF(obj_696))->property) = ((obj_t) arg1273_442), BUNSPEC);
					}
				     }
				   else
				     {	/* Module/pragma.scm 130 */
					obj_t list1275_444;
					list1275_444 =
					   MAKE_PAIR(BNIL, BNIL);
					return
					   user_error_151_tools_error(string1344_module_pragma, string1346_module_pragma, prop_9, list1275_444);
				     }
				}
			     }
			   else
			     {	/* Module/pragma.scm 106 */
				bool_t test_921;
				{	/* ./Ieee/equiv.scm 5508 */
				   obj_t aux_922;
				   aux_922 =
				      CNST_TABLE_REF(((long) 7));
				   test_921 =
				      (prop_9 == aux_922);
				}
				if (test_921)
				  {	/* Module/pragma.scm 137 */
				     value_bglt value_446;
				     {	/* Module/pragma.scm 137 */
					global_bglt obj_700;
					obj_700 =
					   (global_bglt) (global_8);
					value_446 =
					   (((global_bglt) CREF(obj_700))->value);
				     }
				     {	/* Module/pragma.scm 138 */
					bool_t test1277_447;
					test1277_447 =
					   is_a__118___object(
					   (obj_t) (value_446), sfun_ast_var);
					if (test1277_447)
					  {	/* Module/pragma.scm 144 */
					     obj_t arg1278_448;
					     {	/* ./Ieee/pair-list.scm 5689 */
						obj_t aux_930;
						{	/* Module/pragma.scm 144 */
						   sfun_bglt obj_702;
						   obj_702 =
						      (sfun_bglt) (value_446);
						   aux_930 =
						      (((sfun_bglt) CREF(obj_702))->property);
						}
						arg1278_448 =
						   MAKE_PAIR(prop_9, aux_930);
					     }
					     {	/* Module/pragma.scm 143 */
						sfun_bglt obj_705;
						obj_705 =
						   (sfun_bglt) (value_446);
						return
						   ((((sfun_bglt) CREF(obj_705))->property) = ((obj_t) arg1278_448), BUNSPEC);
					     }
					  }
					else
					  {	/* Module/pragma.scm 139 */
					     obj_t list1281_450;
					     list1281_450 =
						MAKE_PAIR(BNIL, BNIL);
					     return
						user_error_151_tools_error(string1344_module_pragma, string1346_module_pragma, prop_9, list1281_450);
					  }
				     }
				  }
				else
				  {	/* Module/pragma.scm 146 */
				     obj_t list1282_451;
				     list1282_451 =
					MAKE_PAIR(BNIL, BNIL);
				     return
					user_error_151_tools_error(string1339_module_pragma, string1347_module_pragma, clause_10, list1282_451);
				  }
			     }
			}
		   }
	      }
	   }
	 else
	   {	/* Module/pragma.scm 104 */
	      if (
		 PAIRP(prop_9))
		{	/* Module/pragma.scm 104 */
		   obj_t car_160_190_421;
		   obj_t cdr_161_14_422;
		   car_160_190_421 =
		      CAR(prop_9);
		   cdr_161_14_422 =
		      CDR(prop_9);
		   if (
		      SYMBOLP(car_160_190_421))
		     {	/* Module/pragma.scm 104 */
			if (
			   PAIRP(cdr_161_14_422))
			  {	/* Module/pragma.scm 104 */
			     obj_t car_166_211_425;
			     car_166_211_425 =
				CAR(cdr_161_14_422);
			     if (
				SYMBOLP(car_166_211_425))
			       {	/* Module/pragma.scm 104 */
				  bool_t test_951;
				  {	/* ./Ieee/equiv.scm 5508 */
				     obj_t aux_952;
				     aux_952 =
					CDR(cdr_161_14_422);
				     test_951 =
					(aux_952 == BNIL);
				  }
				  if (test_951)
				    {	/* Module/pragma.scm 104 */
				       key_414 = car_160_190_421;
				       value_415 = car_166_211_425;
				       {	/* Module/pragma.scm 148 */
					  bool_t test_955;
					  {	/* ./Ieee/equiv.scm 5508 */
					     obj_t aux_956;
					     aux_956 =
						CNST_TABLE_REF(((long) 8));
					     test_955 =
						(key_414 == aux_956);
					  }
					  if (test_955)
					    {	/* Module/pragma.scm 151 */
					       type_bglt type_454;
					       value_bglt value_455;
					       {	/* Module/pragma.scm 151 */
						  obj_t arg1286_458;
						  arg1286_458 =
						     find_location_120_tools_location(prop_9);
						  type_454 =
						     use_type__231_type_env(value_415, arg1286_458);
					       }
					       {	/* Module/pragma.scm 152 */
						  global_bglt obj_709;
						  obj_709 =
						     (global_bglt) (global_8);
						  value_455 =
						     (((global_bglt) CREF(obj_709))->value);
					       }
					       {	/* Module/pragma.scm 153 */
						  bool_t test1284_456;
						  test1284_456 =
						     is_a__118___object(
						     (obj_t) (value_455), fun_ast_var);
						  if (test1284_456)
						    {	/* Module/pragma.scm 153 */
						       {	/* Module/pragma.scm 159 */
							  fun_bglt obj_711;
							  obj_t val1111_712;
							  obj_711 =
							     (fun_bglt) (value_455);
							  val1111_712 =
							     (obj_t) (type_454);
							  ((((fun_bglt) CREF(obj_711))->predicate_of_78) = ((obj_t) val1111_712), BUNSPEC);
						       }
						       remove_var_from__148_ast_remove(
							  CNST_TABLE_REF(((long) 9)),
							  (variable_bglt) (global_8));
						       {	/* Module/pragma.scm 165 */
							  fun_bglt obj_713;
							  obj_t val1110_714;
							  obj_713 =
							     (fun_bglt) (value_455);
							  val1110_714 = BFALSE;
							  return
							     ((((fun_bglt) CREF(obj_713))->side_effect__165) = ((obj_t) val1110_714), BUNSPEC);
						       }
						    }
						  else
						    {	/* Module/pragma.scm 154 */
						       obj_t list1285_457;
						       list1285_457 =
							  MAKE_PAIR(BNIL, BNIL);
						       return
							  user_error_151_tools_error(string1344_module_pragma, string1348_module_pragma, prop_9, list1285_457);
						    }
					       }
					    }
					  else
					    {	/* Module/pragma.scm 148 */
					       bool_t test_976;
					       {	/* ./Ieee/equiv.scm 5508 */
						  obj_t aux_977;
						  aux_977 =
						     CNST_TABLE_REF(((long) 10));
						  test_976 =
						     (key_414 == aux_977);
					       }
					       if (test_976)
						 {	/* Module/pragma.scm 168 */
						    obj_t stack_alloc_52_460;
						    {	/* Module/pragma.scm 168 */
						       obj_t aux_980;
						       {	/* Module/pragma.scm 169 */
							  global_bglt obj_717;
							  obj_717 =
							     (global_bglt) (global_8);
							  aux_980 =
							     (((global_bglt) CREF(obj_717))->module);
						       }
						       stack_alloc_52_460 =
							  find_global_module_25_ast_env(value_415, aux_980);
						    }
						    {	/* Module/pragma.scm 171 */
						       bool_t test1288_461;
						       test1288_461 =
							  is_a__118___object(stack_alloc_52_460, global_ast_var);
						       if (test1288_461)
							 {	/* Module/pragma.scm 176 */
							    bool_t test1289_462;
							    {	/* ./Ast/var.scm 827 */
							       obj_t aux_986;
							       {	/* Module/pragma.scm 176 */
								  value_bglt aux_987;
								  {	/* Module/pragma.scm 176 */
								     global_bglt obj_719;
								     obj_719 =
									(global_bglt) (global_8);
								     aux_987 =
									(((global_bglt) CREF(obj_719))->value);
								  }
								  aux_986 =
								     (obj_t) (aux_987);
							       }
							       test1289_462 =
								  is_a__118___object(aux_986, fun_ast_var);
							    }
							    if (test1289_462)
							      {		/* Module/pragma.scm 176 */
								 if (
								    CBOOL(_optim_stack___57_engine_param))
								   {	/* Module/pragma.scm 184 */
								      remove_var_from__148_ast_remove(
									 CNST_TABLE_REF(((long) 11)),
									 (variable_bglt) (stack_alloc_52_460));
								   }
								 else
								   {	/* Module/pragma.scm 184 */
								      BUNSPEC;
								   }
								 {	/* Module/pragma.scm 186 */
								    fun_bglt obj_722;
								    {	/* Module/pragma.scm 186 */
								       value_bglt aux_998;
								       {	/* Module/pragma.scm 186 */
									  global_bglt obj_721;
									  obj_721 =
									     (global_bglt) (global_8);
									  aux_998 =
									     (((global_bglt) CREF(obj_721))->value);
								       }
								       obj_722 =
									  (fun_bglt) (aux_998);
								    }
								    return
								       ((((fun_bglt) CREF(obj_722))->stack_allocator_172) = ((obj_t) stack_alloc_52_460), BUNSPEC);
								 }
							      }
							    else
							      {		/* Module/pragma.scm 176 */
								 {	/* Module/pragma.scm 177 */
								    obj_t list1291_464;
								    list1291_464 =
								       MAKE_PAIR(BNIL, BNIL);
								    return
								       user_error_151_tools_error(string1344_module_pragma, string1349_module_pragma, prop_9, list1291_464);
								 }
							      }
							 }
						       else
							 {	/* Module/pragma.scm 171 */
							    {	/* Module/pragma.scm 172 */
							       obj_t list1293_466;
							       list1293_466 =
								  MAKE_PAIR(BNIL, BNIL);
							       return
								  user_error_151_tools_error(string1344_module_pragma, string1350_module_pragma, prop_9, list1293_466);
							    }
							 }
						    }
						 }
					       else
						 {	/* Module/pragma.scm 189 */
						    obj_t list1295_468;
						    list1295_468 =
						       MAKE_PAIR(BNIL, BNIL);
						    return
						       user_error_151_tools_error(string1339_module_pragma, string1347_module_pragma, prop_9, list1295_468);
						 }
					    }
				       }
				    }
				  else
				    {	/* Module/pragma.scm 104 */
				     tag_152_149_417:
				       {	/* Module/pragma.scm 191 */
					  obj_t arg1298_471;
					  if (
					     PAIRP(prop_9))
					    {	/* Module/pragma.scm 193 */
					       arg1298_471 = prop_9;
					    }
					  else
					    {	/* Module/pragma.scm 193 */
					       arg1298_471 = clause_10;
					    }
					  {	/* Module/pragma.scm 191 */
					     obj_t list1300_473;
					     list1300_473 =
						MAKE_PAIR(BNIL, BNIL);
					     return
						user_error_151_tools_error(string1339_module_pragma, string1347_module_pragma, arg1298_471, list1300_473);
					  }
				       }
				    }
			       }
			     else
			       {	/* Module/pragma.scm 104 */
				  goto tag_152_149_417;
			       }
			  }
			else
			  {	/* Module/pragma.scm 104 */
			     goto tag_152_149_417;
			  }
		     }
		   else
		     {	/* Module/pragma.scm 104 */
			goto tag_152_149_417;
		     }
		}
	      else
		{	/* Module/pragma.scm 104 */
		   goto tag_152_149_417;
		}
	   }
      }
   }
}



/* method-init */
obj_t 
method_init_76_module_pragma()
{
   AN_OBJECT;
   {	/* Module/pragma.scm 14 */
      return BUNSPEC;
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_module_pragma()
{
   AN_OBJECT;
   {	/* Module/pragma.scm 14 */
      module_initialization_70_module_module(((long) 0), "MODULE_PRAGMA");
      module_initialization_70_tools_error(((long) 0), "MODULE_PRAGMA");
      module_initialization_70_type_type(((long) 0), "MODULE_PRAGMA");
      module_initialization_70_engine_param(((long) 0), "MODULE_PRAGMA");
      module_initialization_70_ast_var(((long) 0), "MODULE_PRAGMA");
      module_initialization_70_ast_env(((long) 0), "MODULE_PRAGMA");
      module_initialization_70_ast_remove(((long) 0), "MODULE_PRAGMA");
      module_initialization_70_type_env(((long) 0), "MODULE_PRAGMA");
      return
	 module_initialization_70_tools_location(((long) 0), "MODULE_PRAGMA");
   }
}
