/*===========================================================================*/
/*   (Module/statexp.scm)                                                    */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct ccomp
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t producer;
     obj_t consumer;
     obj_t finalizer;
     obj_t checksummer;
  }
     *ccomp_bglt;

typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;


extern obj_t ccomp_module_module;
static obj_t statexp_parser_81_module_statexp(obj_t, obj_t);
extern global_bglt declare_global_sfun__255_ast_glo_decl_237(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t method_init_76_module_statexp();
extern obj_t string_append(obj_t, obj_t);
extern obj_t class_finalizer_253_module_class();
static obj_t export_checksummer_174_module_statexp(obj_t, obj_t);
static obj_t _export_consumer_28_module_statexp(obj_t, obj_t, obj_t);
static obj_t _make_export_compiler_160_module_statexp(obj_t);
extern obj_t user_error_151_tools_error(obj_t, obj_t, obj_t, obj_t);
static obj_t _local_classes__10_module_statexp = BUNSPEC;
extern type_bglt type_of_id_183_ast_ident(obj_t, obj_t);
static obj_t _statexp_producer_253_module_statexp(obj_t, obj_t);
extern obj_t module_initialization_70_module_statexp(long, char *);
extern obj_t module_initialization_70_module_module(long, char *);
extern obj_t module_initialization_70_module_prototype(long, char *);
extern obj_t module_initialization_70_module_class(long, char *);
extern obj_t module_initialization_70_module_checksum(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_tools_args(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_ident(long, char *);
extern obj_t module_initialization_70_ast_find_gdefs_13(long, char *);
extern obj_t module_initialization_70_ast_glo_decl_237(long, char *);
extern obj_t module_initialization_70_tools_location(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_strings_6_7(long, char *);
extern obj_t module_initialization_70___r4_control_features_6_9(long, char *);
extern long get_hash_power_number(char *, long);
extern long class_num_218___object(obj_t);
static obj_t _statexp_finalizer_125_module_statexp(obj_t);
static obj_t statexp_producer_46_module_statexp(obj_t);
static obj_t statexp_finalizer_204_module_statexp();
extern obj_t make_export_compiler_49_module_statexp();
static obj_t imported_modules_init_94_module_statexp();
extern obj_t string_downcase_77___r4_strings_6_7(obj_t);
static obj_t _make_static_compiler_13_module_statexp(obj_t);
extern obj_t _module_clause__117_module_module;
static obj_t library_modules_init_112_module_statexp();
extern global_bglt declare_global_svar__200_ast_glo_decl_237(obj_t, obj_t, obj_t, obj_t);
static obj_t toplevel_init_63_module_statexp();
extern obj_t open_input_string(obj_t);
extern int arity_tools_args(obj_t);
static obj_t _export_checksummer_163_module_statexp(obj_t, obj_t, obj_t);
static obj_t _anonymous_1277__14_module_statexp(obj_t);
static obj_t _anonymous_1271__21_module_statexp(obj_t);
extern obj_t to_be_define__131_ast_find_gdefs_13(global_bglt);
static obj_t _anonymous_1265__148_module_statexp(obj_t);
extern obj_t make_promise_21___r4_control_features_6_9(obj_t);
extern obj_t memq___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern obj_t get_class_hash_100_module_class(obj_t, obj_t);
extern obj_t declare_class__31_module_class(obj_t, obj_t, obj_t, bool_t, obj_t);
extern obj_t make_static_compiler_70_module_statexp();
extern obj_t _module__166_module_module;
static obj_t _anonymous_1220__40_module_statexp(obj_t, obj_t, obj_t);
static obj_t _anonymous_1219__7_module_statexp(obj_t);
static obj_t _anonymous_1218__46_module_statexp(obj_t, obj_t, obj_t);
extern obj_t read___reader(obj_t);
extern obj_t find_location_120_tools_location(obj_t);
static obj_t export_consumer_235_module_statexp(obj_t, obj_t);
extern obj_t declare_wide_class__13_module_class(obj_t, obj_t, obj_t, obj_t);
static obj_t require_initialization_114_module_statexp = BUNSPEC;
extern obj_t parse_prototype_143_module_prototype(obj_t);
static obj_t cnst_init_137_module_statexp();
extern obj_t reverse__39___r4_pairs_and_lists_6_3(obj_t);
extern obj_t user_error_location_137_tools_error(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t __cnst[9];

DEFINE_STATIC_PROCEDURE(statexp_producer_env_28_module_statexp, _statexp_producer_253_module_statexp1414, _statexp_producer_253_module_statexp, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_static_compiler_env_79_module_statexp, _make_static_compiler_13_module_statexp1415, _make_static_compiler_13_module_statexp, 0L, 0);
DEFINE_EXPORT_PROCEDURE(make_export_compiler_env_110_module_statexp, _make_export_compiler_160_module_statexp1416, _make_export_compiler_160_module_statexp, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc1403_module_statexp, _anonymous_1218__46_module_statexp1417, _anonymous_1218__46_module_statexp, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc1402_module_statexp, _anonymous_1219__7_module_statexp1418, _anonymous_1219__7_module_statexp, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc1401_module_statexp, _anonymous_1220__40_module_statexp1419, _anonymous_1220__40_module_statexp, 0L, 2);
DEFINE_STATIC_PROCEDURE(statexp_finalizer_env_236_module_statexp, _statexp_finalizer_125_module_statexp1420, _statexp_finalizer_125_module_statexp, 0L, 0);
DEFINE_STATIC_PROCEDURE(export_checksummer_env_156_module_statexp, _export_checksummer_163_module_statexp1421, _export_checksummer_163_module_statexp, 0L, 2);
DEFINE_STATIC_PROCEDURE(export_consumer_env_201_module_statexp, _export_consumer_28_module_statexp1422, _export_consumer_28_module_statexp, 0L, 2);
DEFINE_STRING(string1409_module_statexp, string1409_module_statexp1423, "OBJ WIDE-CLASS FINAL-CLASS CLASS SVAR (SFUN SIFUN SGFUN) EXPORT VOID STATIC ", 76);
DEFINE_STRING(string1408_module_statexp, string1408_module_statexp1424, "Illegal prototype", 17);
DEFINE_STRING(string1407_module_statexp, string1407_module_statexp1425, "Illegal `export' clause", 23);
DEFINE_STRING(string1406_module_statexp, string1406_module_statexp1426, "Parse error", 11);
DEFINE_STRING(string1405_module_statexp, string1405_module_statexp1427, "Illegal `", 9);
DEFINE_STRING(string1404_module_statexp, string1404_module_statexp1428, "' clause", 8);



/* module-initialization */
obj_t 
module_initialization_70_module_statexp(long checksum_921, char *from_922)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_module_statexp))
	{
	   require_initialization_114_module_statexp =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_module_statexp();
	   cnst_init_137_module_statexp();
	   imported_modules_init_94_module_statexp();
	   method_init_76_module_statexp();
	   toplevel_init_63_module_statexp();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_module_statexp()
{
   AN_OBJECT;
   {	/* Module/statexp.scm 14 */
      module_initialization_70___object(((long) 0), "MODULE_STATEXP");
      module_initialization_70___r4_strings_6_7(((long) 0), "MODULE_STATEXP");
      module_initialization_70___r4_control_features_6_9(((long) 0), "MODULE_STATEXP");
      module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "MODULE_STATEXP");
      module_initialization_70___reader(((long) 0), "MODULE_STATEXP");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_module_statexp()
{
   AN_OBJECT;
   {	/* Module/statexp.scm 14 */
      {		/* Module/statexp.scm 14 */
	 obj_t cnst_port_138_914;
	 cnst_port_138_914 =
	    open_input_string(string1409_module_statexp);
	 {
	    long i_915;
	    i_915 = ((long) 8);
	  loop_916:
	    {	/* Module/statexp.scm 14 */
	       bool_t test1410_917;
	       test1410_917 =
		  (i_915 == ((long) -1));
	       if (test1410_917)
		 {	/* Module/statexp.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Module/statexp.scm 14 */
		    {	/* Module/statexp.scm 14 */
		       obj_t arg1411_918;
		       {	/* Module/statexp.scm 14 */
			  obj_t list1412_919;
			  list1412_919 =
			     MAKE_PAIR(cnst_port_138_914, BNIL);
			  arg1411_918 =
			     read___reader(list1412_919);
		       }
		       CNST_TABLE_SET(i_915, arg1411_918);
		    }
		    {	/* Module/statexp.scm 14 */
		       int aux_920;
		       {	/* Module/statexp.scm 14 */
			  long aux_942;
			  aux_942 =
			     (i_915 - ((long) 1));
			  aux_920 =
			     (int) (aux_942);
		       }
		       {
			  long i_945;
			  i_945 =
			     (long) (aux_920);
			  i_915 = i_945;
			  goto loop_916;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_module_statexp()
{
   AN_OBJECT;
   {	/* Module/statexp.scm 14 */
      return (
	 _local_classes__10_module_statexp = BNIL, BUNSPEC);
   }
}



/* make-static-compiler */
obj_t 
make_static_compiler_70_module_statexp()
{
   AN_OBJECT;
   {	/* Module/statexp.scm 34 */
      {		/* Module/statexp.scm 35 */
	 obj_t arg1213_352;
	 arg1213_352 =
	    CNST_TABLE_REF(((long) 0));
	 {	/* ./Module/module.scm 506 */
	    obj_t _anonymous_1220__40_877;
	    obj_t _anonymous_1219__7_878;
	    obj_t _anonymous_1218__46_879;
	    _anonymous_1220__40_877 = proc1401_module_statexp;
	    _anonymous_1219__7_878 = proc1402_module_statexp;
	    _anonymous_1218__46_879 = proc1403_module_statexp;
	    {	/* Module/statexp.scm 35 */
	       ccomp_bglt res1399_683;
	       {	/* ./Module/module.scm 498 */
		  ccomp_bglt new1002_674;
		  new1002_674 =
		     ((ccomp_bglt) BREF(GC_MALLOC(sizeof(struct ccomp))));
		  {	/* ./Module/module.scm 498 */
		     long arg1397_675;
		     arg1397_675 =
			class_num_218___object(ccomp_module_module);
		     {	/* ./Module/module.scm 498 */
			obj_t obj_681;
			obj_681 =
			   (obj_t) (new1002_674);
			(((obj_t) CREF(obj_681))->header = MAKE_HEADER(arg1397_675, 0), BUNSPEC);
		     }
		  }
		  {	/* ./Module/module.scm 498 */
		     object_bglt aux_952;
		     aux_952 =
			(object_bglt) (new1002_674);
		     OBJECT_WIDENING_SET(aux_952, BFALSE);
		  }
		  ((((ccomp_bglt) CREF(new1002_674))->id) = ((obj_t) arg1213_352), BUNSPEC);
		  ((((ccomp_bglt) CREF(new1002_674))->producer) = ((obj_t) statexp_producer_env_28_module_statexp), BUNSPEC);
		  ((((ccomp_bglt) CREF(new1002_674))->consumer) = ((obj_t) _anonymous_1218__46_879), BUNSPEC);
		  ((((ccomp_bglt) CREF(new1002_674))->finalizer) = ((obj_t) _anonymous_1219__7_878), BUNSPEC);
		  ((((ccomp_bglt) CREF(new1002_674))->checksummer) = ((obj_t) _anonymous_1220__40_877), BUNSPEC);
		  res1399_683 = new1002_674;
	       }
	       return
		  (obj_t) (res1399_683);
	    }
	 }
      }
   }
}



/* _make-static-compiler */
obj_t 
_make_static_compiler_13_module_statexp(obj_t env_880)
{
   AN_OBJECT;
   {	/* Module/statexp.scm 34 */
      return
	 make_static_compiler_70_module_statexp();
   }
}



/* <anonymous:1220> */
obj_t 
_anonymous_1220__40_module_statexp(obj_t env_881, obj_t m_882, obj_t c_883)
{
   AN_OBJECT;
   {	/* ./Module/module.scm 511 */
      {
	 obj_t m_361;
	 obj_t c_362;
	 m_361 = m_882;
	 c_362 = c_883;
	 return c_362;
      }
   }
}



/* <anonymous:1219> */
obj_t 
_anonymous_1219__7_module_statexp(obj_t env_884)
{
   AN_OBJECT;
   {	/* ./Module/module.scm 508 */
      {

	 return
	    CNST_TABLE_REF(((long) 1));
      }
   }
}



/* <anonymous:1218> */
obj_t 
_anonymous_1218__46_module_statexp(obj_t env_885, obj_t m_886, obj_t c_887)
{
   AN_OBJECT;
   {	/* ./Module/module.scm 506 */
      {
	 obj_t m_357;
	 obj_t c_358;
	 m_357 = m_886;
	 c_358 = c_887;
	 return BNIL;
      }
   }
}



/* make-export-compiler */
obj_t 
make_export_compiler_49_module_statexp()
{
   AN_OBJECT;
   {	/* Module/statexp.scm 41 */
      {		/* Module/statexp.scm 42 */
	 obj_t arg1222_367;
	 arg1222_367 =
	    CNST_TABLE_REF(((long) 2));
	 {	/* Module/statexp.scm 42 */
	    ccomp_bglt res1400_698;
	    {	/* ./Module/module.scm 498 */
	       ccomp_bglt new1002_689;
	       new1002_689 =
		  ((ccomp_bglt) BREF(GC_MALLOC(sizeof(struct ccomp))));
	       {	/* ./Module/module.scm 498 */
		  long arg1397_690;
		  arg1397_690 =
		     class_num_218___object(ccomp_module_module);
		  {	/* ./Module/module.scm 498 */
		     obj_t obj_696;
		     obj_696 =
			(obj_t) (new1002_689);
		     (((obj_t) CREF(obj_696))->header = MAKE_HEADER(arg1397_690, 0), BUNSPEC);
		  }
	       }
	       {	/* ./Module/module.scm 498 */
		  object_bglt aux_968;
		  aux_968 =
		     (object_bglt) (new1002_689);
		  OBJECT_WIDENING_SET(aux_968, BFALSE);
	       }
	       ((((ccomp_bglt) CREF(new1002_689))->id) = ((obj_t) arg1222_367), BUNSPEC);
	       ((((ccomp_bglt) CREF(new1002_689))->producer) = ((obj_t) statexp_producer_env_28_module_statexp), BUNSPEC);
	       ((((ccomp_bglt) CREF(new1002_689))->consumer) = ((obj_t) export_consumer_env_201_module_statexp), BUNSPEC);
	       ((((ccomp_bglt) CREF(new1002_689))->finalizer) = ((obj_t) statexp_finalizer_env_236_module_statexp), BUNSPEC);
	       ((((ccomp_bglt) CREF(new1002_689))->checksummer) = ((obj_t) export_checksummer_env_156_module_statexp), BUNSPEC);
	       res1400_698 = new1002_689;
	    }
	    return
	       (obj_t) (res1400_698);
	 }
      }
   }
}



/* _make-export-compiler */
obj_t 
_make_export_compiler_160_module_statexp(obj_t env_890)
{
   AN_OBJECT;
   {	/* Module/statexp.scm 41 */
      return
	 make_export_compiler_49_module_statexp();
   }
}



/* statexp-producer */
obj_t 
statexp_producer_46_module_statexp(obj_t clause_19)
{
   AN_OBJECT;
   {	/* Module/statexp.scm 51 */
      {		/* Module/statexp.scm 52 */
	 obj_t mode_372;
	 mode_372 =
	    CAR(clause_19);
	 {
	    obj_t protos_373;
	    if (
	       PAIRP(clause_19))
	      {		/* Module/statexp.scm 53 */
		 protos_373 =
		    CDR(clause_19);
		 {
		    obj_t l1194_379;
		    l1194_379 = protos_373;
		  lname1195_380:
		    if (
		       PAIRP(l1194_379))
		      {		/* Module/statexp.scm 55 */
			 statexp_parser_81_module_statexp(
			    CAR(l1194_379), mode_372);
			 {
			    obj_t l1194_985;
			    l1194_985 =
			       CDR(l1194_379);
			    l1194_379 = l1194_985;
			    goto lname1195_380;
			 }
		      }
		    else
		      {		/* Module/statexp.scm 55 */
			 ((bool_t) 1);
		      }
		 }
		 return BNIL;
	      }
	    else
	      {		/* Module/statexp.scm 53 */
		 {	/* Module/statexp.scm 58 */
		    obj_t arg1232_384;
		    obj_t arg1234_386;
		    arg1232_384 =
		       find_location_120_tools_location(_module_clause__117_module_module);
		    {	/* Module/statexp.scm 60 */
		       obj_t arg1238_390;
		       {	/* Module/statexp.scm 62 */
			  obj_t arg1240_391;
			  {	/* Module/statexp.scm 62 */
			     obj_t arg1243_393;
			     arg1243_393 =
				SYMBOL_TO_STRING(mode_372);
			     arg1240_391 =
				string_downcase_77___r4_strings_6_7(arg1243_393);
			  }
			  arg1238_390 =
			     string_append(arg1240_391, string1404_module_statexp);
		       }
		       arg1234_386 =
			  string_append(string1405_module_statexp, arg1238_390);
		    }
		    {	/* Module/statexp.scm 58 */
		       obj_t list1236_388;
		       list1236_388 =
			  MAKE_PAIR(BNIL, BNIL);
		       return
			  user_error_location_137_tools_error(arg1232_384, string1406_module_statexp, arg1234_386, clause_19, list1236_388);
		    }
		 }
	      }
	 }
      }
   }
}



/* _statexp-producer */
obj_t 
_statexp_producer_253_module_statexp(obj_t env_888, obj_t clause_889)
{
   AN_OBJECT;
   {	/* Module/statexp.scm 51 */
      return
	 statexp_producer_46_module_statexp(clause_889);
   }
}



/* export-consumer */
obj_t 
export_consumer_235_module_statexp(obj_t module_20, obj_t clause_21)
{
   AN_OBJECT;
   {	/* Module/statexp.scm 70 */
      {

	 if (
	    PAIRP(clause_21))
	   {	/* Module/statexp.scm 71 */
	      return
		 CDR(clause_21);
	   }
	 else
	   {	/* Module/statexp.scm 71 */
	      {		/* Module/statexp.scm 75 */
		 obj_t arg1246_400;
		 arg1246_400 =
		    find_location_120_tools_location(_module_clause__117_module_module);
		 {	/* Module/statexp.scm 75 */
		    obj_t list1251_404;
		    list1251_404 =
		       MAKE_PAIR(BNIL, BNIL);
		    return
		       user_error_location_137_tools_error(arg1246_400, string1406_module_statexp, string1407_module_statexp, clause_21, list1251_404);
		 }
	      }
	   }
      }
   }
}



/* _export-consumer */
obj_t 
_export_consumer_28_module_statexp(obj_t env_891, obj_t module_892, obj_t clause_893)
{
   AN_OBJECT;
   {	/* Module/statexp.scm 70 */
      return
	 export_consumer_235_module_statexp(module_892, clause_893);
   }
}



/* statexp-parser */
obj_t 
statexp_parser_81_module_statexp(obj_t prototype_22, obj_t import_23)
{
   AN_OBJECT;
   {	/* Module/statexp.scm 84 */
      {		/* Module/statexp.scm 85 */
	 obj_t proto_405;
	 proto_405 =
	    parse_prototype_143_module_prototype(prototype_22);
	 if (
	    PAIRP(proto_405))
	   {	/* Module/statexp.scm 92 */
	      obj_t case_value_58_407;
	      case_value_58_407 =
		 CAR(proto_405);
	      {		/* Module/statexp.scm 92 */
		 bool_t test_1007;
		 {	/* Module/statexp.scm 92 */
		    obj_t aux_1008;
		    aux_1008 =
		       memq___r4_pairs_and_lists_6_3(case_value_58_407,
		       CNST_TABLE_REF(((long) 3)));
		    test_1007 =
		       CBOOL(aux_1008);
		 }
		 if (test_1007)
		   {	/* Module/statexp.scm 94 */
		      global_bglt arg1254_409;
		      {		/* Module/statexp.scm 94 */
			 obj_t aux_1016;
			 obj_t aux_1012;
			 {	/* ./Ieee/pair-list.scm 5701 */
			    obj_t aux_1017;
			    {	/* ./Ieee/pair-list.scm 5707 */
			       obj_t aux_1018;
			       aux_1018 =
				  CDR(proto_405);
			       aux_1017 =
				  CDR(aux_1018);
			    }
			    aux_1016 =
			       CAR(aux_1017);
			 }
			 {	/* ./Ieee/pair-list.scm 5701 */
			    obj_t aux_1013;
			    aux_1013 =
			       CDR(proto_405);
			    aux_1012 =
			       CAR(aux_1013);
			 }
			 arg1254_409 =
			    declare_global_sfun__255_ast_glo_decl_237(aux_1012, aux_1016, _module__166_module_module, import_23, case_value_58_407, prototype_22);
		      }
		      return
			 to_be_define__131_ast_find_gdefs_13(arg1254_409);
		   }
		 else
		   {	/* Module/statexp.scm 92 */
		      bool_t test_1024;
		      {		/* ./Ieee/equiv.scm 5508 */
			 obj_t aux_1025;
			 aux_1025 =
			    CNST_TABLE_REF(((long) 4));
			 test_1024 =
			    (case_value_58_407 == aux_1025);
		      }
		      if (test_1024)
			{	/* Module/statexp.scm 101 */
			   global_bglt arg1259_414;
			   {	/* Module/statexp.scm 101 */
			      obj_t aux_1028;
			      {		/* ./Ieee/pair-list.scm 5701 */
				 obj_t aux_1029;
				 aux_1029 =
				    CDR(proto_405);
				 aux_1028 =
				    CAR(aux_1029);
			      }
			      arg1259_414 =
				 declare_global_svar__200_ast_glo_decl_237(aux_1028, _module__166_module_module, import_23, prototype_22);
			   }
			   return
			      to_be_define__131_ast_find_gdefs_13(arg1259_414);
			}
		      else
			{	/* Module/statexp.scm 92 */
			   bool_t test_1034;
			   {	/* ./Ieee/equiv.scm 5508 */
			      obj_t aux_1035;
			      aux_1035 =
				 CNST_TABLE_REF(((long) 5));
			      test_1034 =
				 (case_value_58_407 == aux_1035);
			   }
			   if (test_1034)
			     {	/* Module/statexp.scm 106 */
				obj_t arg1263_417;
				{	/* Module/statexp.scm 106 */
				   obj_t _anonymous_1265__148_898;
				   _anonymous_1265__148_898 =
				      make_fx_procedure(_anonymous_1265__148_module_statexp, ((long) 0), ((long) 3));
				   PROCEDURE_SET(_anonymous_1265__148_898, ((long) 0), proto_405);
				   PROCEDURE_SET(_anonymous_1265__148_898, ((long) 1), import_23);
				   PROCEDURE_SET(_anonymous_1265__148_898, ((long) 2), prototype_22);
				   arg1263_417 =
				      make_promise_21___r4_control_features_6_9(_anonymous_1265__148_898);
				}
				{	/* Module/statexp.scm 134 */
				   obj_t obj2_733;
				   obj2_733 = _local_classes__10_module_statexp;
				   return (
				      _local_classes__10_module_statexp =
				      MAKE_PAIR(arg1263_417, obj2_733), BUNSPEC);
				}
			     }
			   else
			     {	/* Module/statexp.scm 92 */
				bool_t test_1044;
				{	/* ./Ieee/equiv.scm 5508 */
				   obj_t aux_1045;
				   aux_1045 =
				      CNST_TABLE_REF(((long) 6));
				   test_1044 =
				      (case_value_58_407 == aux_1045);
				}
				if (test_1044)
				  {	/* Module/statexp.scm 112 */
				     obj_t arg1269_423;
				     {	/* Module/statexp.scm 112 */
					obj_t _anonymous_1271__21_899;
					_anonymous_1271__21_899 =
					   make_fx_procedure(_anonymous_1271__21_module_statexp, ((long) 0), ((long) 3));
					PROCEDURE_SET(_anonymous_1271__21_899, ((long) 0), proto_405);
					PROCEDURE_SET(_anonymous_1271__21_899, ((long) 1), import_23);
					PROCEDURE_SET(_anonymous_1271__21_899, ((long) 2), prototype_22);
					arg1269_423 =
					   make_promise_21___r4_control_features_6_9(_anonymous_1271__21_899);
				     }
				     {	/* Module/statexp.scm 134 */
					obj_t obj2_739;
					obj2_739 = _local_classes__10_module_statexp;
					return (
					   _local_classes__10_module_statexp =
					   MAKE_PAIR(arg1269_423, obj2_739), BUNSPEC);
				     }
				  }
				else
				  {	/* Module/statexp.scm 92 */
				     bool_t test_1054;
				     {	/* ./Ieee/equiv.scm 5508 */
					obj_t aux_1055;
					aux_1055 =
					   CNST_TABLE_REF(((long) 7));
					test_1054 =
					   (case_value_58_407 == aux_1055);
				     }
				     if (test_1054)
				       {	/* Module/statexp.scm 118 */
					  obj_t arg1274_429;
					  {	/* Module/statexp.scm 118 */
					     obj_t _anonymous_1277__14_900;
					     _anonymous_1277__14_900 =
						make_fx_procedure(_anonymous_1277__14_module_statexp, ((long) 0), ((long) 3));
					     PROCEDURE_SET(_anonymous_1277__14_900, ((long) 0), proto_405);
					     PROCEDURE_SET(_anonymous_1277__14_900, ((long) 1), import_23);
					     PROCEDURE_SET(_anonymous_1277__14_900, ((long) 2), prototype_22);
					     arg1274_429 =
						make_promise_21___r4_control_features_6_9(_anonymous_1277__14_900);
					  }
					  {	/* Module/statexp.scm 134 */
					     obj_t obj2_745;
					     obj2_745 = _local_classes__10_module_statexp;
					     return (
						_local_classes__10_module_statexp =
						MAKE_PAIR(arg1274_429, obj2_745), BUNSPEC);
					  }
				       }
				     else
				       {	/* Module/statexp.scm 123 */
					  obj_t list1279_434;
					  list1279_434 =
					     MAKE_PAIR(BNIL, BNIL);
					  return
					     user_error_151_tools_error(string1406_module_statexp, string1408_module_statexp, prototype_22, list1279_434);
				       }
				  }
			     }
			}
		   }
	      }
	   }
	 else
	   {	/* Module/statexp.scm 87 */
	      obj_t arg1280_435;
	      arg1280_435 =
		 find_location_120_tools_location(_module_clause__117_module_module);
	      {		/* Module/statexp.scm 87 */
		 obj_t list1287_439;
		 list1287_439 =
		    MAKE_PAIR(BNIL, BNIL);
		 return
		    user_error_location_137_tools_error(arg1280_435, string1406_module_statexp, string1408_module_statexp, prototype_22, list1287_439);
	      }
	   }
      }
   }
}



/* <anonymous:1265> */
obj_t 
_anonymous_1265__148_module_statexp(obj_t env_901)
{
   AN_OBJECT;
   {	/* Module/statexp.scm 106 */
      {		/* Module/statexp.scm 106 */
	 obj_t proto_902;
	 obj_t import_903;
	 obj_t prototype_904;
	 proto_902 =
	    PROCEDURE_REF(env_901, ((long) 0));
	 import_903 =
	    PROCEDURE_REF(env_901, ((long) 1));
	 prototype_904 =
	    PROCEDURE_REF(env_901, ((long) 2));
	 {

	    return
	       declare_class__31_module_class(
	       CDR(proto_902), _module__166_module_module, import_903, ((bool_t) 0), prototype_904);
	 }
      }
   }
}



/* <anonymous:1271> */
obj_t 
_anonymous_1271__21_module_statexp(obj_t env_905)
{
   AN_OBJECT;
   {	/* Module/statexp.scm 112 */
      {		/* Module/statexp.scm 112 */
	 obj_t proto_906;
	 obj_t import_907;
	 obj_t prototype_908;
	 proto_906 =
	    PROCEDURE_REF(env_905, ((long) 0));
	 import_907 =
	    PROCEDURE_REF(env_905, ((long) 1));
	 prototype_908 =
	    PROCEDURE_REF(env_905, ((long) 2));
	 {

	    return
	       declare_class__31_module_class(
	       CDR(proto_906), _module__166_module_module, import_907, ((bool_t) 1), prototype_908);
	 }
      }
   }
}



/* <anonymous:1277> */
obj_t 
_anonymous_1277__14_module_statexp(obj_t env_909)
{
   AN_OBJECT;
   {	/* Module/statexp.scm 118 */
      {		/* Module/statexp.scm 118 */
	 obj_t proto_910;
	 obj_t import_911;
	 obj_t prototype_912;
	 proto_910 =
	    PROCEDURE_REF(env_909, ((long) 0));
	 import_911 =
	    PROCEDURE_REF(env_909, ((long) 1));
	 prototype_912 =
	    PROCEDURE_REF(env_909, ((long) 2));
	 {

	    return
	       declare_wide_class__13_module_class(
	       CDR(proto_910), _module__166_module_module, import_911, prototype_912);
	 }
      }
   }
}



/* statexp-finalizer */
obj_t 
statexp_finalizer_204_module_statexp()
{
   AN_OBJECT;
   {	/* Module/statexp.scm 145 */
      {
	 obj_t l1196_440;
	 {	/* Module/statexp.scm 147 */
	    obj_t arg1289_442;
	    arg1289_442 =
	       reverse__39___r4_pairs_and_lists_6_3(_local_classes__10_module_statexp);
	    l1196_440 = arg1289_442;
	  lname1197_441:
	    if (
	       PAIRP(l1196_440))
	      {		/* Module/statexp.scm 147 */
		 {	/* Module/statexp.scm 147 */
		    obj_t arg1291_444;
		    arg1291_444 =
		       CAR(l1196_440);
		    PROCEDURE_ENTRY(arg1291_444) (arg1291_444, BEOA);
		 }
		 {
		    obj_t l1196_1090;
		    l1196_1090 =
		       CDR(l1196_440);
		    l1196_440 = l1196_1090;
		    goto lname1197_441;
		 }
	      }
	    else
	      {		/* Module/statexp.scm 147 */
		 ((bool_t) 1);
	      }
	 }
      }
      _local_classes__10_module_statexp = BNIL;
      {		/* Module/statexp.scm 150 */
	 obj_t classes_446;
	 classes_446 =
	    class_finalizer_253_module_class();
	 if (
	    PAIRP(classes_446))
	   {	/* Module/statexp.scm 151 */
	      return classes_446;
	   }
	 else
	   {	/* Module/statexp.scm 151 */
	      return
		 CNST_TABLE_REF(((long) 1));
	   }
      }
   }
}



/* _statexp-finalizer */
obj_t 
_statexp_finalizer_125_module_statexp(obj_t env_894)
{
   AN_OBJECT;
   {	/* Module/statexp.scm 145 */
      return
	 statexp_finalizer_204_module_statexp();
   }
}



/* export-checksummer */
obj_t 
export_checksummer_174_module_statexp(obj_t eclause_25, obj_t checksum_26)
{
   AN_OBJECT;
   {	/* Module/statexp.scm 160 */
      {
	 obj_t clause_457;
	 obj_t checksum_458;
	 {
	    obj_t clauses_449;
	    obj_t checksum_450;
	    clauses_449 =
	       CDR(eclause_25);
	    checksum_450 = checksum_26;
	  loop_451:
	    if (
	       NULLP(clauses_449))
	      {		/* Module/statexp.scm 209 */
		 return checksum_450;
	      }
	    else
	      {		/* Module/statexp.scm 211 */
		 obj_t arg1296_454;
		 obj_t arg1297_455;
		 arg1296_454 =
		    CDR(clauses_449);
		 clause_457 =
		    CAR(clauses_449);
		 checksum_458 = checksum_450;
		 {	/* Module/statexp.scm 162 */
		    obj_t proto_460;
		    proto_460 =
		       parse_prototype_143_module_prototype(clause_457);
		    if (
		       PAIRP(proto_460))
		      {		/* Module/statexp.scm 171 */
			 obj_t case_value_58_463;
			 case_value_58_463 =
			    CAR(proto_460);
			 {	/* Module/statexp.scm 171 */
			    bool_t test_1104;
			    {	/* Module/statexp.scm 171 */
			       obj_t aux_1105;
			       aux_1105 =
				  memq___r4_pairs_and_lists_6_3(case_value_58_463,
				  CNST_TABLE_REF(((long) 3)));
			       test_1104 =
				  CBOOL(aux_1105);
			    }
			    if (test_1104)
			      {
				 long checksum_465;
				 obj_t args_466;
				 {	/* Module/statexp.scm 174 */
				    long arg1302_468;
				    obj_t arg1303_469;
				    {	/* Module/statexp.scm 174 */
				       long arg1304_470;
				       long arg1305_471;
				       {	/* Module/statexp.scm 164 */
					  obj_t arg1361_761;
					  arg1361_761 =
					     SYMBOL_TO_STRING(case_value_58_463);
					  {	/* ./Llib/hash.scm 1789 */
					     char *aux_1110;
					     aux_1110 =
						BSTRING_TO_STRING(arg1361_761);
					     arg1304_470 =
						get_hash_power_number(aux_1110, ((long) 16));
					  }
				       }
				       {	/* Module/statexp.scm 175 */
					  long arg1308_473;
					  long arg1309_474;
					  {	/* Module/statexp.scm 164 */
					     obj_t arg1361_771;
					     {	/* ./Ieee/symbol.scm 6021 */
						obj_t aux_1113;
						{	/* ./Ieee/pair-list.scm 5701 */
						   obj_t aux_1114;
						   aux_1114 =
						      CDR(proto_460);
						   aux_1113 =
						      CAR(aux_1114);
						}
						arg1361_771 =
						   SYMBOL_TO_STRING(aux_1113);
					     }
					     {	/* ./Llib/hash.scm 1789 */
						char *aux_1118;
						aux_1118 =
						   BSTRING_TO_STRING(arg1361_771);
						arg1308_473 =
						   get_hash_power_number(aux_1118, ((long) 16));
					     }
					  }
					  {	/* Module/statexp.scm 176 */
					     int arg1314_476;
					     {	/* Module/statexp.scm 176 */
						obj_t aux_1121;
						{	/* ./Ieee/pair-list.scm 5701 */
						   obj_t aux_1122;
						   {	/* ./Ieee/pair-list.scm 5707 */
						      obj_t aux_1123;
						      aux_1123 =
							 CDR(proto_460);
						      aux_1122 =
							 CDR(aux_1123);
						   }
						   aux_1121 =
						      CAR(aux_1122);
						}
						arg1314_476 =
						   arity_tools_args(aux_1121);
					     }
					     {	/* ./Llib/bit.scm 1973 */
						long aux_1130;
						long aux_1128;
						aux_1130 =
						   (long) CINT(checksum_458);
						aux_1128 =
						   (long) (arg1314_476);
						arg1309_474 =
						   (aux_1128 ^ aux_1130);
					     }
					  }
					  arg1305_471 =
					     (arg1308_473 ^ arg1309_474);
				       }
				       arg1302_468 =
					  (arg1304_470 ^ arg1305_471);
				    }
				    {	/* ./Ieee/pair-list.scm 5701 */
				       obj_t aux_1135;
				       {	/* ./Ieee/pair-list.scm 5707 */
					  obj_t aux_1136;
					  aux_1136 =
					     CDR(proto_460);
					  aux_1135 =
					     CDR(aux_1136);
				       }
				       arg1303_469 =
					  CAR(aux_1135);
				    }
				    {	/* Module/statexp.scm 173 */
				       long aux_1140;
				       checksum_465 = arg1302_468;
				       args_466 = arg1303_469;
				     loop_467:
				       if (
					  NULLP(args_466))
					 {	/* Module/statexp.scm 180 */
					    aux_1140 = checksum_465;
					 }
				       else
					 {	/* Module/statexp.scm 180 */
					    if (
					       PAIRP(args_466))
					      {		/* Module/statexp.scm 184 */
						 bool_t test_1145;
						 {	/* ./Llib/bigloo.scm 945 */
						    obj_t aux_1146;
						    aux_1146 =
						       CAR(args_466);
						    test_1145 =
						       CNSTP(aux_1146);
						 }
						 if (test_1145)
						   {	/* Module/statexp.scm 184 */
						      {		/* Module/statexp.scm 185 */
							 long arg1319_481;
							 obj_t arg1320_482;
							 {	/* Module/statexp.scm 185 */
							    long arg1322_483;
							    {	/* Module/statexp.scm 185 */
							       obj_t aux_1149;
							       aux_1149 =
								  CAR(args_466);
							       arg1322_483 =
								  CCNST(aux_1149);
							    }
							    arg1319_481 =
							       (arg1322_483 ^ checksum_465);
							 }
							 arg1320_482 =
							    CDR(args_466);
							 {
							    obj_t args_1155;
							    long checksum_1154;
							    checksum_1154 = arg1319_481;
							    args_1155 = arg1320_482;
							    args_466 = args_1155;
							    checksum_465 = checksum_1154;
							    goto loop_467;
							 }
						      }
						   }
						 else
						   {	/* Module/statexp.scm 184 */
						      {		/* Module/statexp.scm 188 */
							 type_bglt type_485;
							 {	/* Module/statexp.scm 188 */
							    obj_t arg1329_490;
							    obj_t arg1330_491;
							    arg1329_490 =
							       CAR(args_466);
							    arg1330_491 =
							       find_location_120_tools_location(clause_457);
							    type_485 =
							       type_of_id_183_ast_ident(arg1329_490, arg1330_491);
							 }
							 {	/* Module/statexp.scm 190 */

							    {	/* Module/statexp.scm 191 */
							       long arg1325_487;
							       obj_t arg1326_488;
							       {	/* Module/statexp.scm 191 */
								  long arg1327_489;
								  {	/* Module/statexp.scm 164 */
								     obj_t arg1361_805;
								     {	/* ./Ieee/symbol.scm 6021 */
									obj_t aux_1159;
									aux_1159 =
									   (((type_bglt) CREF(type_485))->id);
									arg1361_805 =
									   SYMBOL_TO_STRING(aux_1159);
								     }
								     {	/* ./Llib/hash.scm 1789 */
									char *aux_1162;
									aux_1162 =
									   BSTRING_TO_STRING(arg1361_805);
									arg1327_489 =
									   get_hash_power_number(aux_1162, ((long) 16));
								     }
								  }
								  arg1325_487 =
								     (arg1327_489 ^ checksum_465);
							       }
							       arg1326_488 =
								  CDR(args_466);
							       {
								  obj_t args_1168;
								  long checksum_1167;
								  checksum_1167 = arg1325_487;
								  args_1168 = arg1326_488;
								  args_466 = args_1168;
								  checksum_465 = checksum_1167;
								  goto loop_467;
							       }
							    }
							 }
						      }
						   }
					      }
					    else
					      {		/* Module/statexp.scm 182 */
						 {	/* Module/statexp.scm 183 */
						    long arg1332_493;
						    {	/* Module/statexp.scm 164 */
						       obj_t arg1361_814;
						       {	/* ./Ieee/symbol.scm 6021 */
							  obj_t aux_1169;
							  aux_1169 =
							     CNST_TABLE_REF(((long) 8));
							  arg1361_814 =
							     SYMBOL_TO_STRING(aux_1169);
						       }
						       {	/* ./Llib/hash.scm 1789 */
							  char *aux_1172;
							  aux_1172 =
							     BSTRING_TO_STRING(arg1361_814);
							  arg1332_493 =
							     get_hash_power_number(aux_1172, ((long) 16));
						       }
						    }
						    aux_1140 =
						       (arg1332_493 ^ checksum_465);
						 }
					      }
					 }
				       arg1297_455 =
					  BINT(aux_1140);
				    }
				 }
			      }
			    else
			      {		/* Module/statexp.scm 171 */
				 bool_t test_1177;
				 {	/* ./Ieee/equiv.scm 5508 */
				    obj_t aux_1178;
				    aux_1178 =
				       CNST_TABLE_REF(((long) 4));
				    test_1177 =
				       (case_value_58_463 == aux_1178);
				 }
				 if (test_1177)
				   {	/* Module/statexp.scm 194 */
				      long arg1334_495;
				      {		/* Module/statexp.scm 164 */
					 obj_t arg1361_828;
					 {	/* ./Ieee/symbol.scm 6021 */
					    obj_t aux_1181;
					    {	/* ./Ieee/pair-list.scm 5701 */
					       obj_t aux_1182;
					       aux_1182 =
						  CDR(proto_460);
					       aux_1181 =
						  CAR(aux_1182);
					    }
					    arg1361_828 =
					       SYMBOL_TO_STRING(aux_1181);
					 }
					 {	/* ./Llib/hash.scm 1789 */
					    char *aux_1186;
					    aux_1186 =
					       BSTRING_TO_STRING(arg1361_828);
					    arg1334_495 =
					       get_hash_power_number(aux_1186, ((long) 16));
					 }
				      }
				      {		/* ./Llib/bit.scm 1973 */
					 long aux_1189;
					 {	/* ./Llib/bit.scm 1973 */
					    long aux_1190;
					    aux_1190 =
					       (long) CINT(checksum_458);
					    aux_1189 =
					       (aux_1190 ^ arg1334_495);
					 }
					 arg1297_455 =
					    BINT(aux_1189);
				      }
				   }
				 else
				   {	/* Module/statexp.scm 171 */
				      bool_t test_1194;
				      {		/* ./Ieee/equiv.scm 5508 */
					 obj_t aux_1195;
					 aux_1195 =
					    CNST_TABLE_REF(((long) 5));
					 test_1194 =
					    (case_value_58_463 == aux_1195);
				      }
				      if (test_1194)
					{	/* Module/statexp.scm 196 */
					   obj_t arg1337_498;
					   {	/* Module/statexp.scm 196 */
					      obj_t aux_1198;
					      {		/* ./Ieee/pair-list.scm 5701 */
						 obj_t aux_1199;
						 aux_1199 =
						    CDR(proto_460);
						 aux_1198 =
						    CAR(aux_1199);
					      }
					      arg1337_498 =
						 get_class_hash_100_module_class(aux_1198, clause_457);
					   }
					   {	/* ./Llib/bit.scm 1973 */
					      long aux_1203;
					      {		/* ./Llib/bit.scm 1973 */
						 long aux_1206;
						 long aux_1204;
						 aux_1206 =
						    (long) CINT(arg1337_498);
						 aux_1204 =
						    (long) CINT(checksum_458);
						 aux_1203 =
						    (aux_1204 ^ aux_1206);
					      }
					      arg1297_455 =
						 BINT(aux_1203);
					   }
					}
				      else
					{	/* Module/statexp.scm 171 */
					   bool_t test_1210;
					   {	/* ./Ieee/equiv.scm 5508 */
					      obj_t aux_1211;
					      aux_1211 =
						 CNST_TABLE_REF(((long) 6));
					      test_1210 =
						 (case_value_58_463 == aux_1211);
					   }
					   if (test_1210)
					     {	/* Module/statexp.scm 199 */
						long arg1340_501;
						{	/* Module/statexp.scm 199 */
						   obj_t arg1343_503;
						   {	/* Module/statexp.scm 200 */
						      obj_t aux_1214;
						      {		/* ./Ieee/pair-list.scm 5701 */
							 obj_t aux_1215;
							 aux_1215 =
							    CDR(proto_460);
							 aux_1214 =
							    CAR(aux_1215);
						      }
						      arg1343_503 =
							 get_class_hash_100_module_class(aux_1214, clause_457);
						   }
						   {	/* ./Llib/bit.scm 1973 */
						      long aux_1219;
						      aux_1219 =
							 (long) CINT(arg1343_503);
						      arg1340_501 =
							 (((long) 12543) ^ aux_1219);
						   }
						}
						{	/* ./Llib/bit.scm 1973 */
						   long aux_1222;
						   {	/* ./Llib/bit.scm 1973 */
						      long aux_1223;
						      aux_1223 =
							 (long) CINT(checksum_458);
						      aux_1222 =
							 (aux_1223 ^ arg1340_501);
						   }
						   arg1297_455 =
						      BINT(aux_1222);
						}
					     }
					   else
					     {	/* Module/statexp.scm 171 */
						bool_t test_1227;
						{	/* ./Ieee/equiv.scm 5508 */
						   obj_t aux_1228;
						   aux_1228 =
						      CNST_TABLE_REF(((long) 7));
						   test_1227 =
						      (case_value_58_463 == aux_1228);
						}
						if (test_1227)
						  {	/* Module/statexp.scm 203 */
						     long arg1346_506;
						     {	/* Module/statexp.scm 203 */
							obj_t arg1348_508;
							{	/* Module/statexp.scm 204 */
							   obj_t aux_1231;
							   {	/* ./Ieee/pair-list.scm 5701 */
							      obj_t aux_1232;
							      aux_1232 =
								 CDR(proto_460);
							      aux_1231 =
								 CAR(aux_1232);
							   }
							   arg1348_508 =
							      get_class_hash_100_module_class(aux_1231, clause_457);
							}
							{	/* ./Llib/bit.scm 1973 */
							   long aux_1236;
							   aux_1236 =
							      (long) CINT(arg1348_508);
							   arg1346_506 =
							      (((long) 456747) ^ aux_1236);
							}
						     }
						     {	/* ./Llib/bit.scm 1973 */
							long aux_1239;
							{	/* ./Llib/bit.scm 1973 */
							   long aux_1240;
							   aux_1240 =
							      (long) CINT(checksum_458);
							   aux_1239 =
							      (aux_1240 ^ arg1346_506);
							}
							arg1297_455 =
							   BINT(aux_1239);
						     }
						  }
						else
						  {	/* Module/statexp.scm 206 */
						     obj_t list1351_510;
						     list1351_510 =
							MAKE_PAIR(BNIL, BNIL);
						     arg1297_455 =
							user_error_151_tools_error(string1406_module_statexp, string1408_module_statexp, clause_457, list1351_510);
						  }
					     }
					}
				   }
			      }
			 }
		      }
		    else
		      {		/* Module/statexp.scm 166 */
			 obj_t arg1354_511;
			 arg1354_511 =
			    find_location_120_tools_location(_module_clause__117_module_module);
			 {	/* Module/statexp.scm 166 */
			    obj_t list1358_515;
			    list1358_515 =
			       MAKE_PAIR(BNIL, BNIL);
			    arg1297_455 =
			       user_error_location_137_tools_error(arg1354_511, string1406_module_statexp, string1408_module_statexp, eclause_25, list1358_515);
			 }
		      }
		 }
		 {
		    obj_t checksum_1251;
		    obj_t clauses_1250;
		    clauses_1250 = arg1296_454;
		    checksum_1251 = arg1297_455;
		    checksum_450 = checksum_1251;
		    clauses_449 = clauses_1250;
		    goto loop_451;
		 }
	      }
	 }
      }
   }
}



/* _export-checksummer */
obj_t 
_export_checksummer_163_module_statexp(obj_t env_895, obj_t eclause_896, obj_t checksum_897)
{
   AN_OBJECT;
   {	/* Module/statexp.scm 160 */
      return
	 export_checksummer_174_module_statexp(eclause_896, checksum_897);
   }
}



/* method-init */
obj_t 
method_init_76_module_statexp()
{
   AN_OBJECT;
   {	/* Module/statexp.scm 14 */
      return BUNSPEC;
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_module_statexp()
{
   AN_OBJECT;
   {	/* Module/statexp.scm 14 */
      module_initialization_70_module_module(((long) 0), "MODULE_STATEXP");
      module_initialization_70_module_prototype(((long) 0), "MODULE_STATEXP");
      module_initialization_70_module_class(((long) 0), "MODULE_STATEXP");
      module_initialization_70_module_checksum(((long) 0), "MODULE_STATEXP");
      module_initialization_70_tools_error(((long) 0), "MODULE_STATEXP");
      module_initialization_70_tools_args(((long) 0), "MODULE_STATEXP");
      module_initialization_70_type_type(((long) 0), "MODULE_STATEXP");
      module_initialization_70_ast_var(((long) 0), "MODULE_STATEXP");
      module_initialization_70_ast_ident(((long) 0), "MODULE_STATEXP");
      module_initialization_70_ast_find_gdefs_13(((long) 0), "MODULE_STATEXP");
      module_initialization_70_ast_glo_decl_237(((long) 0), "MODULE_STATEXP");
      return
	 module_initialization_70_tools_location(((long) 0), "MODULE_STATEXP");
   }
}
