/*===========================================================================*/
/*   (Object/class.scm)                                                      */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct ccomp
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t producer;
     obj_t consumer;
     obj_t finalizer;
     obj_t checksummer;
  }
     *ccomp_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct tclass
  {
     obj_t its_super_214;
     obj_t slots;
     struct global *holder;
     obj_t widening;
     long depth;
     bool_t final__12;
     obj_t constructor;
     obj_t virtual_slots_number_200;
  }
      *tclass_bglt;


static obj_t method_init_76_object_class();
extern obj_t tclass_constructor_36_object_class(tclass_bglt);
static obj_t _tclass_depth1449_93_object_class(obj_t, obj_t);
static obj_t _declare_class_type__21_object_class(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t tclass_parents_set__36_object_class(type_bglt, obj_t);
extern global_bglt tclass_holder_146_object_class(tclass_bglt);
static obj_t _type_subclass__143_object_class(obj_t, obj_t, obj_t);
static obj_t _tclass__1433_221_object_class(obj_t, obj_t);
extern obj_t tclass_alias_101_object_class(type_bglt);
extern obj_t tclass_init__set__98_object_class(type_bglt, bool_t);
extern obj_t tclass_slots_1_object_class(tclass_bglt);
extern obj_t tclass_size_set__204_object_class(type_bglt, obj_t);
extern obj_t string_append(obj_t, obj_t);
static obj_t _tclass_parents_set_1426_200_object_class(obj_t, obj_t, obj_t);
static obj_t _tclass_holder1446_150_object_class(obj_t, obj_t);
extern obj_t type_type_type;
static obj_t _tclass_depth_set_1448_223_object_class(obj_t, obj_t, obj_t);
extern obj_t tclass_parents_63_object_class(type_bglt);
static obj_t _tclass__82_object_class(obj_t, obj_t);
static obj_t _tclass_magic_1431_234_object_class(obj_t, obj_t);
extern bool_t tclass_final__60_object_class(tclass_bglt);
static obj_t _find_class_constructors1414_66_object_class(obj_t, obj_t);
extern object_bglt struct_object__object_93___object(object_bglt, obj_t);
extern bool_t tclass_magic__27_object_class(type_bglt);
extern type_bglt declare_type__118_type_env(obj_t, obj_t, obj_t);
extern obj_t add_method__1___object(obj_t, obj_t, obj_t);
extern obj_t tclass___set__194_object_class(type_bglt, obj_t);
extern obj_t tclass_its_super_set__222_object_class(tclass_bglt, obj_t);
extern obj_t get_object_type_154_type_cache();
static obj_t _tclass_constructor1451_233_object_class(obj_t, obj_t);
static obj_t _tclass_tvector1439_32_object_class(obj_t, obj_t);
extern obj_t find_super_class_method_167___object(object_bglt, obj_t, obj_t);
extern bool_t type_subclass__90_object_class(type_bglt, type_bglt);
static obj_t _final_class__214_object_class(obj_t, obj_t);
static obj_t _wide_class__223_object_class(obj_t, obj_t);
extern bool_t is_a__118___object(obj_t, obj_t);
static obj_t _tclass_parents1427_107_object_class(obj_t, obj_t);
extern obj_t tclass_widening_127_object_class(tclass_bglt);
extern bool_t tclass__65_object_class(obj_t);
extern type_bglt declare_class_type__110_object_class(obj_t, global_bglt, obj_t, bool_t, obj_t);
extern obj_t module_initialization_70_object_class(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_type_env(long, char *);
extern obj_t module_initialization_70_object_tools(long, char *);
extern obj_t module_initialization_70_module_module(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_ident(long, char *);
extern obj_t module_initialization_70_tools_location(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_strings_6_7(long, char *);
extern obj_t module_initialization_70___r4_output_6_10_3(long, char *);
static obj_t _tclass_final_1450_45_object_class(obj_t, obj_t);
extern long tclass_depth_100_object_class(tclass_bglt);
extern obj_t tclass_id_40_object_class(type_bglt);
extern bool_t wide_class__100_object_class(obj_t);
static obj_t _tclass_slots1445_136_object_class(obj_t, obj_t);
static obj_t _tclass_pointed_to_by_set_1436_191_object_class(obj_t, obj_t, obj_t);
static obj_t _tclass_coerce_to_set_1424_50_object_class(obj_t, obj_t, obj_t);
extern long class_num_218___object(obj_t);
static obj_t _tclass_virtual_slots_number_232_object_class(obj_t, obj_t);
extern obj_t tclass_magic__set__202_object_class(type_bglt, bool_t);
extern obj_t display_2_122___r4_output_6_10_3(obj_t, obj_t);
static obj_t imported_modules_init_94_object_class();
extern obj_t tclass_location_110_object_class(type_bglt);
static obj_t _tclass_init__set_1428_55_object_class(obj_t, obj_t, obj_t);
extern obj_t string_downcase_77___r4_strings_6_7(obj_t);
extern obj_t tclass_alias_set__162_object_class(type_bglt, obj_t);
extern type_bglt allocate_tclass_43_object_class();
static obj_t _tclass_class1423_144_object_class(obj_t, obj_t);
static obj_t _tclass_its_super_set_1442_52_object_class(obj_t, obj_t, obj_t);
extern obj_t tclass_tvector_243_object_class(type_bglt);
static obj_t _tclass_its_super1443_237_object_class(obj_t, obj_t);
extern obj_t tclass___165_object_class(type_bglt);
extern obj_t tclass_its_super_153_object_class(tclass_bglt);
extern obj_t tclass_pointed_to_by_195_object_class(type_bglt);
extern obj_t id__name_228_ast_ident(obj_t);
extern obj_t heap_add_class__147_object_class(tclass_bglt);
extern obj_t tclass_slots_set__141_object_class(tclass_bglt, obj_t);
static obj_t library_modules_init_112_object_class();
extern obj_t tclass_location_set__32_object_class(type_bglt, obj_t);
static obj_t _tclass_virtual_slots_number_set__15_object_class(obj_t, obj_t, obj_t);
extern obj_t make_struct(obj_t, long, obj_t);
extern obj_t tclass_class_set__74_object_class(type_bglt, obj_t);
static obj_t toplevel_init_63_object_class();
extern obj_t create_vector(long);
extern obj_t open_input_string(obj_t);
extern obj_t tclass_tvector_set__109_object_class(type_bglt, obj_t);
static obj_t _tclass_alias_set_1434_9_object_class(obj_t, obj_t, obj_t);
static obj_t _tclass_size_set_1420_133_object_class(obj_t, obj_t, obj_t);
static obj_t _tclass_tvector_set_1438_182_object_class(obj_t, obj_t, obj_t);
static obj_t _tclass_magic__set_1430_2_object_class(obj_t, obj_t, obj_t);
static obj_t _allocate_tclass_237_object_class(obj_t);
static obj_t _tclass_widening1447_28_object_class(obj_t, obj_t);
static obj_t _tclass_class_set_1422_67_object_class(obj_t, obj_t, obj_t);
extern obj_t parse_id_241_ast_ident(obj_t, obj_t);
obj_t tclass_object_class = BUNSPEC;
extern obj_t _case_sensitive__90_engine_param;
static obj_t _tclass_location_set_1440_194_object_class(obj_t, obj_t, obj_t);
extern tclass_bglt widening_tclass_201_object_class(obj_t, obj_t, global_bglt, obj_t, long, bool_t, obj_t, obj_t);
extern obj_t register_class__225___object(obj_t, obj_t, obj_t, long, obj_t, obj_t, obj_t);
extern tclass_bglt make_tclass_121_object_class(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, bool_t, bool_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, global_bglt, obj_t, long, bool_t, obj_t, obj_t);
extern obj_t tclass_virtual_slots_number_set__141_object_class(tclass_bglt, obj_t);
extern obj_t tclass_name_set__133_object_class(type_bglt, obj_t);
static obj_t _class_type_list__185_object_class = BUNSPEC;
extern obj_t tclass_depth_set__40_object_class(tclass_bglt, long);
static obj_t object_init_111_object_class();
extern obj_t tclass_virtual_slots_number_1_object_class(tclass_bglt);
static obj_t _tclass_name1419_105_object_class(obj_t, obj_t);
extern obj_t tclass_size_44_object_class(type_bglt);
extern bool_t tclass_init__162_object_class(type_bglt);
static obj_t _emit_class_types_128_object_class(obj_t, obj_t);
static obj_t _tclass_size1421_63_object_class(obj_t, obj_t);
static obj_t struct_object__object_tclass1252_108_object_class(obj_t, obj_t, obj_t);
static obj_t _tclass_name_set_1418_78_object_class(obj_t, obj_t, obj_t);
static obj_t cross_name_74_object_class(obj_t);
static obj_t _tclass_location1441_164_object_class(obj_t, obj_t);
static obj_t _tclass___set_1432_43_object_class(obj_t, obj_t, obj_t);
static obj_t _tclass_alias1435_253_object_class(obj_t, obj_t);
extern obj_t read___reader(obj_t);
static obj_t _heap_add_class_1413_210_object_class(obj_t, obj_t);
static obj_t _make_tclass1416_86_object_class(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t tclass_name_252_object_class(type_bglt);
static obj_t _tclass_coerce_to1425_210_object_class(obj_t, obj_t);
extern obj_t find_location_120_tools_location(obj_t);
extern obj_t tclass_pointed_to_by_set__241_object_class(type_bglt, obj_t);
extern obj_t object__struct_50___object(object_bglt);
static obj_t _tclass_id1417_114_object_class(obj_t, obj_t);
static obj_t object__struct_tclass1250_93_object_class(obj_t, obj_t);
static obj_t _tclass_init_1429_249_object_class(obj_t, obj_t);
extern obj_t emit_class_types_26_object_class(obj_t);
extern obj_t ____74_type_cache;
static obj_t require_initialization_114_object_class = BUNSPEC;
extern obj_t tclass_class_106_object_class(type_bglt);
extern bool_t final_class__126_object_class(obj_t);
static obj_t _tclass_slots_set_1444_107_object_class(obj_t, obj_t, obj_t);
extern obj_t tclass_coerce_to_set__105_object_class(type_bglt, obj_t);
static obj_t _widening_tclass1415_69_object_class(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t tclass_coerce_to_203_object_class(type_bglt);
extern obj_t find_class_constructors_231_object_class(tclass_bglt);
static obj_t cnst_init_137_object_class();
extern obj_t reverse__39___r4_pairs_and_lists_6_3(obj_t);
static obj_t _tclass_pointed_to_by1437_239_object_class(obj_t, obj_t);
static obj_t __cnst[2];

DEFINE_EXPORT_PROCEDURE(tclass_constructor_env_174_object_class, _tclass_constructor1451_233_object_class1478, _tclass_constructor1451_233_object_class, 0L, 1);
DEFINE_EXPORT_PROCEDURE(tclass_parents_env_111_object_class, _tclass_parents1427_107_object_class1479, _tclass_parents1427_107_object_class, 0L, 1);
DEFINE_EXPORT_PROCEDURE(tclass___env_35_object_class, _tclass__1433_221_object_class1480, _tclass__1433_221_object_class, 0L, 1);
DEFINE_EXPORT_PROCEDURE(tclass_its_super_env_216_object_class, _tclass_its_super1443_237_object_class1481, _tclass_its_super1443_237_object_class, 0L, 1);
DEFINE_EXPORT_PROCEDURE(tclass_coerce_to_set__env_166_object_class, _tclass_coerce_to_set_1424_50_object_class1482, _tclass_coerce_to_set_1424_50_object_class, 0L, 2);
DEFINE_EXPORT_PROCEDURE(tclass_init__set__env_65_object_class, _tclass_init__set_1428_55_object_class1483, _tclass_init__set_1428_55_object_class, 0L, 2);
DEFINE_EXPORT_PROCEDURE(wide_class__env_189_object_class, _wide_class__223_object_class1484, _wide_class__223_object_class, 0L, 1);
DEFINE_EXPORT_PROCEDURE(tclass_size_set__env_236_object_class, _tclass_size_set_1420_133_object_class1485, _tclass_size_set_1420_133_object_class, 0L, 2);
DEFINE_EXPORT_PROCEDURE(tclass_location_set__env_250_object_class, _tclass_location_set_1440_194_object_class1486, _tclass_location_set_1440_194_object_class, 0L, 2);
DEFINE_EXPORT_PROCEDURE(tclass_widening_env_254_object_class, _tclass_widening1447_28_object_class1487, _tclass_widening1447_28_object_class, 0L, 1);
DEFINE_EXPORT_PROCEDURE(tclass___set__env_246_object_class, _tclass___set_1432_43_object_class1488, _tclass___set_1432_43_object_class, 0L, 2);
DEFINE_EXPORT_PROCEDURE(tclass_its_super_set__env_97_object_class, _tclass_its_super_set_1442_52_object_class1489, _tclass_its_super_set_1442_52_object_class, 0L, 2);
DEFINE_EXPORT_PROCEDURE(declare_class_type__env_128_object_class, _declare_class_type__21_object_class1490, _declare_class_type__21_object_class, 0L, 5);
DEFINE_EXPORT_PROCEDURE(tclass_alias_env_25_object_class, _tclass_alias1435_253_object_class1491, _tclass_alias1435_253_object_class, 0L, 1);
extern obj_t struct_object__object_env_209___object;
DEFINE_EXPORT_PROCEDURE(tclass_alias_set__env_197_object_class, _tclass_alias_set_1434_9_object_class1492, _tclass_alias_set_1434_9_object_class, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc1472_object_class, struct_object__object_tclass1252_108_object_class1493, struct_object__object_tclass1252_108_object_class, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc1471_object_class, object__struct_tclass1250_93_object_class1494, object__struct_tclass1250_93_object_class, 0L, 1);
DEFINE_EXPORT_PROCEDURE(tclass_class_set__env_52_object_class, _tclass_class_set_1422_67_object_class1495, _tclass_class_set_1422_67_object_class, 0L, 2);
DEFINE_EXPORT_PROCEDURE(tclass_init__env_197_object_class, _tclass_init_1429_249_object_class1496, _tclass_init_1429_249_object_class, 0L, 1);
DEFINE_EXPORT_PROCEDURE(tclass_name_set__env_248_object_class, _tclass_name_set_1418_78_object_class1497, _tclass_name_set_1418_78_object_class, 0L, 2);
DEFINE_EXPORT_PROCEDURE(tclass_location_env_128_object_class, _tclass_location1441_164_object_class1498, _tclass_location1441_164_object_class, 0L, 1);
DEFINE_EXPORT_PROCEDURE(tclass_tvector_set__env_45_object_class, _tclass_tvector_set_1438_182_object_class1499, _tclass_tvector_set_1438_182_object_class, 0L, 2);
DEFINE_EXPORT_PROCEDURE(heap_add_class__env_177_object_class, _heap_add_class_1413_210_object_class1500, _heap_add_class_1413_210_object_class, 0L, 1);
DEFINE_EXPORT_PROCEDURE(tclass_depth_env_189_object_class, _tclass_depth1449_93_object_class1501, _tclass_depth1449_93_object_class, 0L, 1);
DEFINE_EXPORT_PROCEDURE(tclass_holder_env_211_object_class, _tclass_holder1446_150_object_class1502, _tclass_holder1446_150_object_class, 0L, 1);
DEFINE_EXPORT_PROCEDURE(tclass_magic__set__env_69_object_class, _tclass_magic__set_1430_2_object_class1503, _tclass_magic__set_1430_2_object_class, 0L, 2);
DEFINE_EXPORT_PROCEDURE(tclass_pointed_to_by_env_57_object_class, _tclass_pointed_to_by1437_239_object_class1504, _tclass_pointed_to_by1437_239_object_class, 0L, 1);
DEFINE_EXPORT_PROCEDURE(tclass_coerce_to_env_223_object_class, _tclass_coerce_to1425_210_object_class1505, _tclass_coerce_to1425_210_object_class, 0L, 1);
DEFINE_EXPORT_PROCEDURE(final_class__env_178_object_class, _final_class__214_object_class1506, _final_class__214_object_class, 0L, 1);
DEFINE_EXPORT_PROCEDURE(widening_tclass_env_148_object_class, _widening_tclass1415_69_object_class1507, _widening_tclass1415_69_object_class, 0L, 8);
DEFINE_EXPORT_PROCEDURE(tclass_magic__env_64_object_class, _tclass_magic_1431_234_object_class1508, _tclass_magic_1431_234_object_class, 0L, 1);
DEFINE_EXPORT_PROCEDURE(tclass_virtual_slots_number_env_233_object_class, _tclass_virtual_slots_number_232_object_class1509, _tclass_virtual_slots_number_232_object_class, 0L, 1);
DEFINE_EXPORT_PROCEDURE(tclass_slots_set__env_232_object_class, _tclass_slots_set_1444_107_object_class1510, _tclass_slots_set_1444_107_object_class, 0L, 2);
DEFINE_EXPORT_PROCEDURE(tclass_final__env_46_object_class, _tclass_final_1450_45_object_class1511, _tclass_final_1450_45_object_class, 0L, 1);
DEFINE_EXPORT_PROCEDURE(emit_class_types_env_252_object_class, _emit_class_types_128_object_class1512, _emit_class_types_128_object_class, 0L, 1);
DEFINE_EXPORT_PROCEDURE(tclass_id_env_170_object_class, _tclass_id1417_114_object_class1513, _tclass_id1417_114_object_class, 0L, 1);
DEFINE_EXPORT_PROCEDURE(tclass_slots_env_233_object_class, _tclass_slots1445_136_object_class1514, _tclass_slots1445_136_object_class, 0L, 1);
DEFINE_EXPORT_PROCEDURE(allocate_tclass_env_37_object_class, _allocate_tclass_237_object_class1515, _allocate_tclass_237_object_class, 0L, 0);
DEFINE_EXPORT_PROCEDURE(tclass_virtual_slots_number_set__env_232_object_class, _tclass_virtual_slots_number_set__15_object_class1516, _tclass_virtual_slots_number_set__15_object_class, 0L, 2);
DEFINE_EXPORT_PROCEDURE(tclass_depth_set__env_170_object_class, _tclass_depth_set_1448_223_object_class1517, _tclass_depth_set_1448_223_object_class, 0L, 2);
DEFINE_EXPORT_PROCEDURE(tclass_parents_set__env_174_object_class, _tclass_parents_set_1426_200_object_class1518, _tclass_parents_set_1426_200_object_class, 0L, 2);
DEFINE_EXPORT_PROCEDURE(tclass__env_32_object_class, _tclass__82_object_class1519, _tclass__82_object_class, 0L, 1);
DEFINE_EXPORT_PROCEDURE(tclass_class_env_17_object_class, _tclass_class1423_144_object_class1520, _tclass_class1423_144_object_class, 0L, 1);
DEFINE_STRING(string1473_object_class, string1473_object_class1521, "TCLASS BIGLOO ", 14);
DEFINE_STRING(string1469_object_class, string1469_object_class1522, "} *", 3);
DEFINE_STRING(string1470_object_class, string1470_object_class1523, ";\n", 2);
DEFINE_STRING(string1468_object_class, string1468_object_class1524, " ]", 2);
DEFINE_STRING(string1467_object_class, string1467_object_class1525, "[ ", 2);
DEFINE_STRING(string1466_object_class, string1466_object_class1526, " ", 1);
DEFINE_STRING(string1465_object_class, string1465_object_class1527, ";", 1);
DEFINE_STRING(string1464_object_class, string1464_object_class1528, "   ", 3);
DEFINE_STRING(string1463_object_class, string1463_object_class1529, "   obj_t    widening;", 21);
DEFINE_STRING(string1462_object_class, string1462_object_class1530, "   header_t header;", 19);
DEFINE_STRING(string1461_object_class, string1461_object_class1531, "   char dummy;", 14);
DEFINE_STRING(string1459_object_class, string1459_object_class1532, "typedef ", 8);
DEFINE_STRING(string1460_object_class, string1460_object_class1533, " {", 2);
DEFINE_STRING(string1458_object_class, string1458_object_class1534, "/* Object type definitions */", 29);
DEFINE_STRING(string1457_object_class, string1457_object_class1535, " *", 2);
DEFINE_STRING(string1456_object_class, string1456_object_class1536, "_bglt", 5);
DEFINE_STRING(string1455_object_class, string1455_object_class1537, "struct ", 7);
DEFINE_EXPORT_PROCEDURE(tclass_name_env_175_object_class, _tclass_name1419_105_object_class1538, _tclass_name1419_105_object_class, 0L, 1);
DEFINE_EXPORT_PROCEDURE(find_class_constructors_env_198_object_class, _find_class_constructors1414_66_object_class1539, _find_class_constructors1414_66_object_class, 0L, 1);
DEFINE_EXPORT_PROCEDURE(type_subclass__env_237_object_class, _type_subclass__143_object_class1540, _type_subclass__143_object_class, 0L, 2);
DEFINE_EXPORT_PROCEDURE(tclass_size_env_43_object_class, _tclass_size1421_63_object_class1541, _tclass_size1421_63_object_class, 0L, 1);
DEFINE_EXPORT_PROCEDURE(tclass_pointed_to_by_set__env_180_object_class, _tclass_pointed_to_by_set_1436_191_object_class1542, _tclass_pointed_to_by_set_1436_191_object_class, 0L, 2);
extern obj_t object__struct_env_210___object;
DEFINE_EXPORT_PROCEDURE(make_tclass_env_100_object_class, _make_tclass1416_86_object_class1543, _make_tclass1416_86_object_class, 0L, 21);
DEFINE_EXPORT_PROCEDURE(tclass_tvector_env_20_object_class, _tclass_tvector1439_32_object_class1544, _tclass_tvector1439_32_object_class, 0L, 1);



/* module-initialization */
obj_t 
module_initialization_70_object_class(long checksum_1299, char *from_1300)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_object_class))
	{
	   require_initialization_114_object_class =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_object_class();
	   cnst_init_137_object_class();
	   imported_modules_init_94_object_class();
	   object_init_111_object_class();
	   method_init_76_object_class();
	   toplevel_init_63_object_class();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_object_class()
{
   AN_OBJECT;
   {	/* Object/class.scm 14 */
      module_initialization_70___object(((long) 0), "OBJECT_CLASS");
      module_initialization_70___r4_output_6_10_3(((long) 0), "OBJECT_CLASS");
      module_initialization_70___r4_strings_6_7(((long) 0), "OBJECT_CLASS");
      module_initialization_70___reader(((long) 0), "OBJECT_CLASS");
      module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "OBJECT_CLASS");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_object_class()
{
   AN_OBJECT;
   {	/* Object/class.scm 14 */
      {		/* Object/class.scm 14 */
	 obj_t cnst_port_138_1292;
	 cnst_port_138_1292 =
	    open_input_string(string1473_object_class);
	 {
	    long i_1293;
	    i_1293 = ((long) 1);
	  loop_1294:
	    {	/* Object/class.scm 14 */
	       bool_t test1474_1295;
	       test1474_1295 =
		  (i_1293 == ((long) -1));
	       if (test1474_1295)
		 {	/* Object/class.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Object/class.scm 14 */
		    {	/* Object/class.scm 14 */
		       obj_t arg1475_1296;
		       {	/* Object/class.scm 14 */
			  obj_t list1476_1297;
			  list1476_1297 =
			     MAKE_PAIR(cnst_port_138_1292, BNIL);
			  arg1475_1296 =
			     read___reader(list1476_1297);
		       }
		       CNST_TABLE_SET(i_1293, arg1475_1296);
		    }
		    {	/* Object/class.scm 14 */
		       int aux_1298;
		       {	/* Object/class.scm 14 */
			  long aux_1321;
			  aux_1321 =
			     (i_1293 - ((long) 1));
			  aux_1298 =
			     (int) (aux_1321);
		       }
		       {
			  long i_1324;
			  i_1324 =
			     (long) (aux_1298);
			  i_1293 = i_1324;
			  goto loop_1294;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_object_class()
{
   AN_OBJECT;
   {	/* Object/class.scm 14 */
      return (
	 _class_type_list__185_object_class = BNIL, BUNSPEC);
   }
}



/* heap-add-class! */
obj_t 
heap_add_class__147_object_class(tclass_bglt type_71)
{
   AN_OBJECT;
   {	/* Object/class.scm 66 */
      {		/* Object/class.scm 67 */
	 obj_t obj2_851;
	 obj2_851 = _class_type_list__185_object_class;
	 {	/* ./Ieee/pair-list.scm 5689 */
	    obj_t aux_1326;
	    aux_1326 =
	       (obj_t) (type_71);
	    return (
	       _class_type_list__185_object_class =
	       MAKE_PAIR(aux_1326, obj2_851), BUNSPEC);
	 }
      }
   }
}



/* _heap-add-class!1413 */
obj_t 
_heap_add_class_1413_210_object_class(obj_t env_1136, obj_t type_1137)
{
   AN_OBJECT;
   {	/* Object/class.scm 66 */
      return
	 heap_add_class__147_object_class(
	 (tclass_bglt) (type_1137));
   }
}



/* declare-class-type! */
type_bglt 
declare_class_type__110_object_class(obj_t class_def_12_72, global_bglt class_holder_88_73, obj_t widening_74, bool_t final__12_75, obj_t src_76)
{
   AN_OBJECT;
   {	/* Object/class.scm 80 */
      {		/* Object/class.scm 81 */
	 obj_t class_ident_60_495;
	 {	/* Object/class.scm 81 */
	    obj_t arg1281_520;
	    obj_t arg1282_521;
	    arg1281_520 =
	       CAR(class_def_12_72);
	    arg1282_521 =
	       find_location_120_tools_location(src_76);
	    class_ident_60_495 =
	       parse_id_241_ast_ident(arg1281_520, arg1282_521);
	 }
	 {	/* Object/class.scm 81 */
	    obj_t class_id_86_496;
	    class_id_86_496 =
	       CAR(class_ident_60_495);
	    {	/* Object/class.scm 82 */
	       obj_t super_497;
	       {	/* Object/class.scm 83 */
		  obj_t super_516;
		  super_516 =
		     CDR(class_ident_60_495);
		  {	/* Object/class.scm 85 */
		     bool_t test_1336;
		     {	/* ./Ieee/equiv.scm 5508 */
			obj_t aux_1337;
			{	/* Object/class.scm 85 */
			   type_bglt obj_855;
			   obj_855 =
			      (type_bglt) (super_516);
			   aux_1337 =
			      (((type_bglt) CREF(obj_855))->id);
			}
			test_1336 =
			   (aux_1337 == class_id_86_496);
		     }
		     if (test_1336)
		       {	/* Object/class.scm 85 */
			  super_497 = BFALSE;
		       }
		     else
		       {	/* Object/class.scm 87 */
			  bool_t test1279_518;
			  {	/* Object/class.scm 87 */
			     obj_t obj2_859;
			     obj2_859 = ____74_type_cache;
			     test1279_518 =
				(super_516 == obj2_859);
			  }
			  if (test1279_518)
			    {	/* Object/class.scm 87 */
			       super_497 =
				  get_object_type_154_type_cache();
			    }
			  else
			    {	/* Object/class.scm 87 */
			       super_497 = super_516;
			    }
		       }
		  }
	       }
	       {	/* Object/class.scm 83 */
		  obj_t name_498;
		  if (
		     CBOOL(_case_sensitive__90_engine_param))
		    {	/* Object/class.scm 91 */
		       name_498 =
			  id__name_228_ast_ident(class_id_86_496);
		    }
		  else
		    {	/* Object/class.scm 93 */
		       obj_t arg1277_515;
		       arg1277_515 =
			  id__name_228_ast_ident(class_id_86_496);
		       name_498 =
			  string_downcase_77___r4_strings_6_7(arg1277_515);
		    }
		  {	/* Object/class.scm 91 */
		     obj_t sizeof_499;
		     sizeof_499 =
			string_append(string1455_object_class, name_498);
		     {	/* Object/class.scm 94 */
			obj_t t_name_82_500;
			t_name_82_500 =
			   string_append(name_498, string1456_object_class);
			{	/* Object/class.scm 95 */
			   type_bglt type_501;
			   type_501 =
			      declare_type__118_type_env(class_id_86_496, t_name_82_500,
			      CNST_TABLE_REF(((long) 0)));
			   {	/* Object/class.scm 96 */

			      {		/* Object/class.scm 100 */
				 tclass_bglt obj1228_502;
				 obj1228_502 =
				    ((tclass_bglt) (type_501));
				 {	/* Object/class.scm 100 */
				    tclass_bglt arg1263_503;
				    {	/* Object/class.scm 100 */
				       long arg1268_507;
				       obj_t arg1270_509;
				       {	/* Object/class.scm 102 */
					  bool_t test1272_511;
					  test1272_511 =
					     is_a__118___object(super_497, tclass_object_class);
					  if (test1272_511)
					    {	/* ./Ieee/fixnum.scm 7193 */
					       long aux_1356;
					       {	/* Object/class.scm 104 */
						  tclass_bglt obj_861;
						  obj_861 =
						     (tclass_bglt) (super_497);
						  {
						     obj_t aux_1358;
						     {	/* Object/class.scm 39 */
							object_bglt aux_1359;
							aux_1359 =
							   (object_bglt) (obj_861);
							aux_1358 =
							   OBJECT_WIDENING(aux_1359);
						     }
						     aux_1356 =
							(((tclass_bglt) CREF(aux_1358))->depth);
						  }
					       }
					       arg1268_507 =
						  (aux_1356 + ((long) 1));
					    }
					  else
					    {	/* Object/class.scm 102 */
					       arg1268_507 = ((long) 0);
					    }
				       }
				       {	/* ./Ieee/pair-list.scm 5701 */
					  obj_t aux_1364;
					  aux_1364 =
					     CDR(class_def_12_72);
					  arg1270_509 =
					     CAR(aux_1364);
				       }
				       {	/* Object/class.scm 100 */
					  tclass_bglt res1409_885;
					  {	/* Object/class.scm 100 */
					     obj_t virtual_slots_number_200_875;
					     virtual_slots_number_200_875 =
						BINT(((long) 0));
					     {	/* Object/class.scm 29 */
						tclass_bglt new1208_876;
						new1208_876 =
						   ((tclass_bglt) BREF(GC_MALLOC(sizeof(struct tclass))));
						((((tclass_bglt) CREF(new1208_876))->its_super_214) = ((obj_t) super_497), BUNSPEC);
						((((tclass_bglt) CREF(new1208_876))->slots) = ((obj_t) BUNSPEC), BUNSPEC);
						((((tclass_bglt) CREF(new1208_876))->holder) = ((global_bglt) class_holder_88_73), BUNSPEC);
						((((tclass_bglt) CREF(new1208_876))->widening) = ((obj_t) widening_74), BUNSPEC);
						((((tclass_bglt) CREF(new1208_876))->depth) = ((long) arg1268_507), BUNSPEC);
						((((tclass_bglt) CREF(new1208_876))->final__12) = ((bool_t) final__12_75), BUNSPEC);
						((((tclass_bglt) CREF(new1208_876))->constructor) = ((obj_t) arg1270_509), BUNSPEC);
						((((tclass_bglt) CREF(new1208_876))->virtual_slots_number_200) = ((obj_t) virtual_slots_number_200_875), BUNSPEC);
						res1409_885 = new1208_876;
					     }
					  }
					  arg1263_503 = res1409_885;
				       }
				    }
				    {	/* Object/class.scm 100 */
				       obj_t aux_1379;
				       object_bglt aux_1377;
				       aux_1379 =
					  (obj_t) (arg1263_503);
				       aux_1377 =
					  (object_bglt) (obj1228_502);
				       OBJECT_WIDENING_SET(aux_1377, aux_1379);
				    }
				 }
				 {	/* Object/class.scm 100 */
				    long arg1276_514;
				    arg1276_514 =
				       class_num_218___object(tclass_object_class);
				    {	/* Object/class.scm 100 */
				       obj_t obj_886;
				       obj_886 =
					  (obj_t) (obj1228_502);
				       (((obj_t) CREF(obj_886))->header = MAKE_HEADER(arg1276_514, 0), BUNSPEC);
				    }
				 }
				 obj1228_502;
			      }
			      ((((type_bglt) CREF(type_501))->size) = ((obj_t) sizeof_499), BUNSPEC);
			      {		/* Object/class.scm 112 */
				 obj_t obj2_891;
				 obj2_891 = _class_type_list__185_object_class;
				 {	/* ./Ieee/pair-list.scm 5689 */
				    obj_t aux_1386;
				    aux_1386 =
				       (obj_t) (type_501);
				    _class_type_list__185_object_class =
				       MAKE_PAIR(aux_1386, obj2_891);
				 }
			      }
			      return type_501;
			   }
			}
		     }
		  }
	       }
	    }
	 }
      }
   }
}



/* _declare-class-type! */
obj_t 
_declare_class_type__21_object_class(obj_t env_1138, obj_t class_def_12_1139, obj_t class_holder_88_1140, obj_t widening_1141, obj_t final__12_1142, obj_t src_1143)
{
   AN_OBJECT;
   {	/* Object/class.scm 80 */
      {		/* Object/class.scm 80 */
	 type_bglt aux_1389;
	 aux_1389 =
	    declare_class_type__110_object_class(class_def_12_1139,
	    (global_bglt) (class_holder_88_1140), widening_1141,
	    CBOOL(final__12_1142), src_1143);
	 return
	    (obj_t) (aux_1389);
      }
   }
}



/* cross-name */
obj_t 
cross_name_74_object_class(obj_t type_77)
{
   AN_OBJECT;
   {	/* Object/class.scm 123 */
      {		/* Object/class.scm 124 */
	 bool_t test1283_522;
	 test1283_522 =
	    is_a__118___object(type_77, tclass_object_class);
	 if (test1283_522)
	   {	/* Object/class.scm 125 */
	      obj_t aux_1396;
	      {		/* Object/class.scm 125 */
		 type_bglt obj_893;
		 obj_893 =
		    (type_bglt) (type_77);
		 aux_1396 =
		    (((type_bglt) CREF(obj_893))->size);
	      }
	      return
		 string_append(aux_1396, string1457_object_class);
	   }
	 else
	   {	/* Object/class.scm 126 */
	      type_bglt obj_894;
	      obj_894 =
		 (type_bglt) (type_77);
	      return
		 (((type_bglt) CREF(obj_894))->name);
	   }
      }
   }
}



/* emit-class-types */
obj_t 
emit_class_types_26_object_class(obj_t oport_78)
{
   AN_OBJECT;
   {	/* Object/class.scm 131 */
      {		/* Object/class.scm 132 */
	 bool_t test1288_525;
	 {	/* Object/class.scm 132 */
	    obj_t obj_895;
	    obj_895 = _class_type_list__185_object_class;
	    test1288_525 =
	       PAIRP(obj_895);
	 }
	 if (test1288_525)
	   {	/* Object/class.scm 132 */
	      display_2_122___r4_output_6_10_3(
		 BCHAR(((unsigned char) '\n')), oport_78);
	      display_2_122___r4_output_6_10_3(string1458_object_class, oport_78);
	      {		/* ./Ieee/output.scm 9332 */
		 unsigned char aux_1407;
		 aux_1407 =
		    WRITE_CHAR(((unsigned char) '\n'), oport_78);
		 BCHAR(aux_1407);
	      }
	   }
	 else
	   {	/* Object/class.scm 132 */
	      BUNSPEC;
	   }
      }
      {
	 obj_t l1230_527;
	 {	/* Object/class.scm 179 */
	    obj_t arg1289_529;
	    arg1289_529 =
	       reverse__39___r4_pairs_and_lists_6_3(_class_type_list__185_object_class);
	    l1230_527 = arg1289_529;
	  lname1231_528:
	    if (
	       PAIRP(l1230_527))
	      {		/* Object/class.scm 134 */
		 {	/* Object/class.scm 135 */
		    obj_t class_531;
		    class_531 =
		       CAR(l1230_527);
		    {	/* Object/class.scm 135 */
		       bool_t test1291_532;
		       {	/* Object/class.scm 135 */
			  obj_t arg1309_561;
			  arg1309_561 =
			     get_object_type_154_type_cache();
			  test1291_532 =
			     (class_531 == arg1309_561);
		       }
		       if (test1291_532)
			 {	/* Object/class.scm 135 */
			    BUNSPEC;
			 }
		       else
			 {	/* Object/class.scm 135 */
			    display_2_122___r4_output_6_10_3(string1459_object_class, oport_78);
			    {	/* Object/class.scm 137 */
			       obj_t aux_1418;
			       {	/* Object/class.scm 137 */
				  type_bglt obj_901;
				  obj_901 =
				     (type_bglt) (class_531);
				  aux_1418 =
				     (((type_bglt) CREF(obj_901))->size);
			       }
			       display_2_122___r4_output_6_10_3(aux_1418, oport_78);
			    }
			    display_2_122___r4_output_6_10_3(string1460_object_class, oport_78);
			    WRITE_CHAR(((unsigned char) '\n'), oport_78);
			    {	/* Object/class.scm 138 */
			       bool_t test_1424;
			       {	/* Object/class.scm 138 */
				  tclass_bglt obj_903;
				  obj_903 =
				     (tclass_bglt) (class_531);
				  {	/* Object/class.scm 37 */
				     obj_t aux_1426;
				     {
					obj_t aux_1427;
					{	/* Object/class.scm 37 */
					   object_bglt aux_1428;
					   aux_1428 =
					      (object_bglt) (obj_903);
					   aux_1427 =
					      OBJECT_WIDENING(aux_1428);
					}
					aux_1426 =
					   (((tclass_bglt) CREF(aux_1427))->widening);
				     }
				     test_1424 =
					CBOOL(aux_1426);
				  }
			       }
			       if (test_1424)
				 {	/* Object/class.scm 142 */
				    bool_t test_1433;
				    {	/* ./Ieee/pair-list.scm 5912 */
				       obj_t aux_1434;
				       {	/* Object/class.scm 142 */
					  tclass_bglt obj_904;
					  obj_904 =
					     (tclass_bglt) (class_531);
					  {
					     obj_t aux_1436;
					     {	/* Object/class.scm 33 */
						object_bglt aux_1437;
						aux_1437 =
						   (object_bglt) (obj_904);
						aux_1436 =
						   OBJECT_WIDENING(aux_1437);
					     }
					     aux_1434 =
						(((tclass_bglt) CREF(aux_1436))->slots);
					  }
				       }
				       test_1433 =
					  NULLP(aux_1434);
				    }
				    if (test_1433)
				      {		/* Object/class.scm 142 */
					 display_2_122___r4_output_6_10_3(string1461_object_class, oport_78);
					 {	/* ./Ieee/output.scm 9332 */
					    unsigned char aux_1443;
					    aux_1443 =
					       WRITE_CHAR(((unsigned char) '\n'), oport_78);
					    BCHAR(aux_1443);
					 }
				      }
				    else
				      {		/* Object/class.scm 142 */
					 BUNSPEC;
				      }
				 }
			       else
				 {	/* Object/class.scm 138 */
				    display_2_122___r4_output_6_10_3(string1462_object_class, oport_78);
				    WRITE_CHAR(((unsigned char) '\n'), oport_78);
				    display_2_122___r4_output_6_10_3(string1463_object_class, oport_78);
				    {	/* ./Ieee/output.scm 9332 */
				       unsigned char aux_1449;
				       aux_1449 =
					  WRITE_CHAR(((unsigned char) '\n'), oport_78);
				       BCHAR(aux_1449);
				    }
				 }
			    }
			    {
			       obj_t l1236_541;
			       {	/* Object/class.scm 177 */
				  tclass_bglt obj_909;
				  obj_909 =
				     (tclass_bglt) (class_531);
				  {
				     obj_t aux_1503;
				     {	/* Object/class.scm 33 */
					object_bglt aux_1504;
					aux_1504 =
					   (object_bglt) (obj_909);
					aux_1503 =
					   OBJECT_WIDENING(aux_1504);
				     }
				     l1236_541 =
					(((tclass_bglt) CREF(aux_1503))->slots);
				  }
			       }
			     lname1237_542:
			       if (
				  PAIRP(l1236_541))
				 {	/* Object/class.scm 149 */
				    {	/* Object/class.scm 150 */
				       obj_t slot_545;
				       slot_545 =
					  CAR(l1236_541);
				       {	/* Object/class.scm 150 */
					  obj_t name_546;
					  name_546 =
					     cross_name_74_object_class(
					     STRUCT_REF(slot_545, ((long) 2)));
					  {	/* Object/class.scm 151 */
					     bool_t test_1457;
					     {	/* ./Llib/struct.scm 1457 */
						obj_t aux_1458;
						aux_1458 =
						   STRUCT_REF(slot_545, ((long) 11));
						test_1457 =
						   CBOOL(aux_1458);
					     }
					     if (test_1457)
					       {	/* Object/class.scm 151 */
						  BUNSPEC;
					       }
					     else
					       {	/* Object/class.scm 153 */
						  bool_t test_1461;
						  {	/* ./Llib/struct.scm 1457 */
						     obj_t aux_1462;
						     aux_1462 =
							STRUCT_REF(slot_545, ((long) 5));
						     test_1461 =
							CBOOL(aux_1462);
						  }
						  if (test_1461)
						    {	/* Object/class.scm 153 */
						       display_2_122___r4_output_6_10_3(string1464_object_class, oport_78);
						       display_2_122___r4_output_6_10_3(name_546, oport_78);
						       display_2_122___r4_output_6_10_3(string1457_object_class, oport_78);
						       display_2_122___r4_output_6_10_3(
							  STRUCT_REF(slot_545, ((long) 1)), oport_78);
						       display_2_122___r4_output_6_10_3(string1465_object_class, oport_78);
						       {	/* ./Ieee/output.scm 9332 */
							  unsigned char aux_1471;
							  aux_1471 =
							     WRITE_CHAR(((unsigned char) '\n'), oport_78);
							  BCHAR(aux_1471);
						       }
						    }
						  else
						    {	/* Object/class.scm 160 */
						       bool_t test_1474;
						       {	/* ./Llib/struct.scm 1457 */
							  obj_t aux_1475;
							  aux_1475 =
							     STRUCT_REF(slot_545, ((long) 3));
							  test_1474 =
							     CBOOL(aux_1475);
						       }
						       if (test_1474)
							 {	/* Object/class.scm 160 */
							    display_2_122___r4_output_6_10_3(string1464_object_class, oport_78);
							    display_2_122___r4_output_6_10_3(name_546, oport_78);
							    display_2_122___r4_output_6_10_3(string1466_object_class, oport_78);
							    display_2_122___r4_output_6_10_3(
							       STRUCT_REF(slot_545, ((long) 1)), oport_78);
							    display_2_122___r4_output_6_10_3(string1467_object_class, oport_78);
							    display_2_122___r4_output_6_10_3(
							       STRUCT_REF(slot_545, ((long) 4)), oport_78);
							    display_2_122___r4_output_6_10_3(string1468_object_class, oport_78);
							    display_2_122___r4_output_6_10_3(string1465_object_class, oport_78);
							    {	/* ./Ieee/output.scm 9332 */
							       unsigned char aux_1488;
							       aux_1488 =
								  WRITE_CHAR(((unsigned char) '\n'), oport_78);
							       BCHAR(aux_1488);
							    }
							 }
						       else
							 {	/* Object/class.scm 160 */
							    display_2_122___r4_output_6_10_3(string1464_object_class, oport_78);
							    display_2_122___r4_output_6_10_3(name_546, oport_78);
							    display_2_122___r4_output_6_10_3(string1466_object_class, oport_78);
							    display_2_122___r4_output_6_10_3(
							       STRUCT_REF(slot_545, ((long) 1)), oport_78);
							    display_2_122___r4_output_6_10_3(string1465_object_class, oport_78);
							    {	/* ./Ieee/output.scm 9332 */
							       unsigned char aux_1497;
							       aux_1497 =
								  WRITE_CHAR(((unsigned char) '\n'), oport_78);
							       BCHAR(aux_1497);
							    }
							 }
						    }
					       }
					  }
				       }
				    }
				    {
				       obj_t l1236_1500;
				       l1236_1500 =
					  CDR(l1236_541);
				       l1236_541 = l1236_1500;
				       goto lname1237_542;
				    }
				 }
			       else
				 {	/* Object/class.scm 149 */
				    ((bool_t) 1);
				 }
			    }
			    display_2_122___r4_output_6_10_3(string1469_object_class, oport_78);
			    {	/* Object/class.scm 178 */
			       obj_t aux_1509;
			       {	/* Object/class.scm 178 */
				  type_bglt obj_940;
				  obj_940 =
				     (type_bglt) (class_531);
				  aux_1509 =
				     (((type_bglt) CREF(obj_940))->name);
			       }
			       display_2_122___r4_output_6_10_3(aux_1509, oport_78);
			    }
			    display_2_122___r4_output_6_10_3(string1470_object_class, oport_78);
			    {	/* ./Ieee/output.scm 9332 */
			       unsigned char aux_1514;
			       aux_1514 =
				  WRITE_CHAR(((unsigned char) '\n'), oport_78);
			       BCHAR(aux_1514);
			    }
			 }
		    }
		 }
		 {
		    obj_t l1230_1517;
		    l1230_1517 =
		       CDR(l1230_527);
		    l1230_527 = l1230_1517;
		    goto lname1231_528;
		 }
	      }
	    else
	      {		/* Object/class.scm 134 */
		 ((bool_t) 1);
	      }
	 }
      }
      {		/* Object/class.scm 180 */
	 bool_t test1314_563;
	 {	/* Object/class.scm 180 */
	    obj_t obj_943;
	    obj_943 = _class_type_list__185_object_class;
	    test1314_563 =
	       PAIRP(obj_943);
	 }
	 if (test1314_563)
	   {	/* ./Ieee/output.scm 9332 */
	      unsigned char aux_1521;
	      aux_1521 =
		 WRITE_CHAR(((unsigned char) '\n'), oport_78);
	      return
		 BCHAR(aux_1521);
	   }
	 else
	   {	/* Object/class.scm 180 */
	      return BUNSPEC;
	   }
      }
   }
}



/* _emit-class-types */
obj_t 
_emit_class_types_128_object_class(obj_t env_1144, obj_t oport_1145)
{
   AN_OBJECT;
   {	/* Object/class.scm 131 */
      return
	 emit_class_types_26_object_class(oport_1145);
   }
}



/* final-class? */
bool_t 
final_class__126_object_class(obj_t class_79)
{
   AN_OBJECT;
   {	/* Object/class.scm 188 */
      {		/* Object/class.scm 189 */
	 bool_t _andtest_1242_945;
	 _andtest_1242_945 =
	    is_a__118___object(class_79, tclass_object_class);
	 if (_andtest_1242_945)
	   {	/* Object/class.scm 189 */
	      tclass_bglt obj_947;
	      obj_947 =
		 (tclass_bglt) (class_79);
	      {
		 obj_t aux_1528;
		 {	/* Object/class.scm 41 */
		    object_bglt aux_1529;
		    aux_1529 =
		       (object_bglt) (obj_947);
		    aux_1528 =
		       OBJECT_WIDENING(aux_1529);
		 }
		 return
		    (((tclass_bglt) CREF(aux_1528))->final__12);
	      }
	   }
	 else
	   {	/* Object/class.scm 189 */
	      return ((bool_t) 0);
	   }
      }
   }
}



/* _final-class? */
obj_t 
_final_class__214_object_class(obj_t env_1146, obj_t class_1147)
{
   AN_OBJECT;
   {	/* Object/class.scm 188 */
      {		/* Object/class.scm 188 */
	 bool_t aux_1533;
	 aux_1533 =
	    final_class__126_object_class(class_1147);
	 return
	    BBOOL(aux_1533);
      }
   }
}



/* wide-class? */
bool_t 
wide_class__100_object_class(obj_t class_80)
{
   AN_OBJECT;
   {	/* Object/class.scm 196 */
      {		/* Object/class.scm 197 */
	 bool_t _andtest_1243_948;
	 _andtest_1243_948 =
	    is_a__118___object(class_80, tclass_object_class);
	 if (_andtest_1243_948)
	   {	/* Object/class.scm 197 */
	      tclass_bglt obj_950;
	      obj_950 =
		 (tclass_bglt) (class_80);
	      {		/* Object/class.scm 37 */
		 obj_t aux_1539;
		 {
		    obj_t aux_1540;
		    {	/* Object/class.scm 37 */
		       object_bglt aux_1541;
		       aux_1541 =
			  (object_bglt) (obj_950);
		       aux_1540 =
			  OBJECT_WIDENING(aux_1541);
		    }
		    aux_1539 =
		       (((tclass_bglt) CREF(aux_1540))->widening);
		 }
		 return
		    CBOOL(aux_1539);
	      }
	   }
	 else
	   {	/* Object/class.scm 197 */
	      return ((bool_t) 0);
	   }
      }
   }
}



/* _wide-class? */
obj_t 
_wide_class__223_object_class(obj_t env_1148, obj_t class_1149)
{
   AN_OBJECT;
   {	/* Object/class.scm 196 */
      {		/* Object/class.scm 196 */
	 bool_t aux_1546;
	 aux_1546 =
	    wide_class__100_object_class(class_1149);
	 return
	    BBOOL(aux_1546);
      }
   }
}



/* type-subclass? */
bool_t 
type_subclass__90_object_class(type_bglt subclass_81, type_bglt class_82)
{
   AN_OBJECT;
   {	/* Object/class.scm 202 */
      {		/* Object/class.scm 204 */
	 bool_t test1315_566;
	 test1315_566 =
	    is_a__118___object(
	    (obj_t) (class_82), tclass_object_class);
	 if (test1315_566)
	   {	/* Object/class.scm 206 */
	      bool_t test1316_567;
	      test1316_567 =
		 is_a__118___object(
		 (obj_t) (subclass_81), tclass_object_class);
	      if (test1316_567)
		{	/* Object/class.scm 206 */
		   {
		      obj_t subclass_568;
		      subclass_568 =
			 (obj_t) (subclass_81);
		    loop_569:
		      {		/* Object/class.scm 211 */
			 bool_t test_1555;
			 {	/* ./Ieee/equiv.scm 5508 */
			    obj_t aux_1556;
			    aux_1556 =
			       (obj_t) (class_82);
			    test_1555 =
			       (subclass_568 == aux_1556);
			 }
			 if (test_1555)
			   {	/* Object/class.scm 211 */
			      return ((bool_t) 1);
			   }
			 else
			   {	/* Object/class.scm 213 */
			      bool_t test1318_571;
			      test1318_571 =
				 is_a__118___object(subclass_568, tclass_object_class);
			      if (test1318_571)
				{	/* Object/class.scm 215 */
				   bool_t test_1561;
				   {	/* ./Ieee/equiv.scm 5508 */
				      obj_t aux_1562;
				      {		/* Object/class.scm 215 */
					 tclass_bglt obj_956;
					 obj_956 =
					    (tclass_bglt) (subclass_568);
					 {
					    obj_t aux_1564;
					    {	/* Object/class.scm 29 */
					       object_bglt aux_1565;
					       aux_1565 =
						  (object_bglt) (obj_956);
					       aux_1564 =
						  OBJECT_WIDENING(aux_1565);
					    }
					    aux_1562 =
					       (((tclass_bglt) CREF(aux_1564))->its_super_214);
					 }
				      }
				      test_1561 =
					 (aux_1562 == subclass_568);
				   }
				   if (test_1561)
				     {	/* Object/class.scm 215 */
					return ((bool_t) 0);
				     }
				   else
				     {	/* Object/class.scm 215 */
					{
					   obj_t subclass_1570;
					   {	/* Object/class.scm 218 */
					      tclass_bglt obj_959;
					      obj_959 =
						 (tclass_bglt) (subclass_568);
					      {
						 obj_t aux_1572;
						 {	/* Object/class.scm 29 */
						    object_bglt aux_1573;
						    aux_1573 =
						       (object_bglt) (obj_959);
						    aux_1572 =
						       OBJECT_WIDENING(aux_1573);
						 }
						 subclass_1570 =
						    (((tclass_bglt) CREF(aux_1572))->its_super_214);
					      }
					   }
					   subclass_568 = subclass_1570;
					   goto loop_569;
					}
				     }
				}
			      else
				{	/* Object/class.scm 213 */
				   return ((bool_t) 0);
				}
			   }
		      }
		   }
		}
	      else
		{	/* Object/class.scm 206 */
		   return ((bool_t) 0);
		}
	   }
	 else
	   {	/* Object/class.scm 204 */
	      return ((bool_t) 0);
	   }
      }
   }
}



/* _type-subclass? */
obj_t 
_type_subclass__143_object_class(obj_t env_1150, obj_t subclass_1151, obj_t class_1152)
{
   AN_OBJECT;
   {	/* Object/class.scm 202 */
      {		/* Object/class.scm 202 */
	 bool_t aux_1578;
	 aux_1578 =
	    type_subclass__90_object_class(
	    (type_bglt) (subclass_1151),
	    (type_bglt) (class_1152));
	 return
	    BBOOL(aux_1578);
      }
   }
}



/* find-class-constructors */
obj_t 
find_class_constructors_231_object_class(tclass_bglt class_83)
{
   AN_OBJECT;
   {	/* Object/class.scm 229 */
      {
	 obj_t class_575;
	 class_575 =
	    (obj_t) (class_83);
       loop_576:
	 {	/* Object/class.scm 233 */
	    bool_t test1323_578;
	    {	/* Object/class.scm 233 */
	       bool_t test1328_583;
	       test1328_583 =
		  is_a__118___object(class_575, tclass_object_class);
	       if (test1328_583)
		 {	/* ./Ieee/equiv.scm 5508 */
		    obj_t aux_1585;
		    {	/* Object/class.scm 233 */
		       tclass_bglt obj_961;
		       obj_961 =
			  (tclass_bglt) (class_575);
		       {
			  obj_t aux_1587;
			  {	/* Object/class.scm 29 */
			     object_bglt aux_1588;
			     aux_1588 =
				(object_bglt) (obj_961);
			     aux_1587 =
				OBJECT_WIDENING(aux_1588);
			  }
			  aux_1585 =
			     (((tclass_bglt) CREF(aux_1587))->its_super_214);
		       }
		    }
		    test1323_578 =
		       (class_575 == aux_1585);
		 }
	       else
		 {	/* Object/class.scm 233 */
		    test1323_578 = ((bool_t) 1);
		 }
	    }
	    if (test1323_578)
	      {		/* Object/class.scm 233 */
		 return BNIL;
	      }
	    else
	      {		/* Object/class.scm 235 */
		 bool_t test_1594;
		 {	/* Object/class.scm 235 */
		    tclass_bglt obj_964;
		    obj_964 =
		       (tclass_bglt) (class_575);
		    {	/* Object/class.scm 43 */
		       obj_t aux_1596;
		       {
			  obj_t aux_1597;
			  {	/* Object/class.scm 43 */
			     object_bglt aux_1598;
			     aux_1598 =
				(object_bglt) (obj_964);
			     aux_1597 =
				OBJECT_WIDENING(aux_1598);
			  }
			  aux_1596 =
			     (((tclass_bglt) CREF(aux_1597))->constructor);
		       }
		       test_1594 =
			  CBOOL(aux_1596);
		    }
		 }
		 if (test_1594)
		   {	/* Object/class.scm 235 */
		      {		/* Object/class.scm 236 */
			 obj_t list1326_581;
			 {	/* Object/class.scm 236 */
			    obj_t aux_1603;
			    {	/* Object/class.scm 236 */
			       tclass_bglt obj_965;
			       obj_965 =
				  (tclass_bglt) (class_575);
			       {
				  obj_t aux_1605;
				  {	/* Object/class.scm 43 */
				     object_bglt aux_1606;
				     aux_1606 =
					(object_bglt) (obj_965);
				     aux_1605 =
					OBJECT_WIDENING(aux_1606);
				  }
				  aux_1603 =
				     (((tclass_bglt) CREF(aux_1605))->constructor);
			       }
			    }
			    list1326_581 =
			       MAKE_PAIR(aux_1603, BNIL);
			 }
			 return list1326_581;
		      }
		   }
		 else
		   {	/* Object/class.scm 235 */
		      {
			 obj_t class_1611;
			 {	/* Object/class.scm 238 */
			    tclass_bglt obj_967;
			    obj_967 =
			       (tclass_bglt) (class_575);
			    {
			       obj_t aux_1613;
			       {	/* Object/class.scm 29 */
				  object_bglt aux_1614;
				  aux_1614 =
				     (object_bglt) (obj_967);
				  aux_1613 =
				     OBJECT_WIDENING(aux_1614);
			       }
			       class_1611 =
				  (((tclass_bglt) CREF(aux_1613))->its_super_214);
			    }
			 }
			 class_575 = class_1611;
			 goto loop_576;
		      }
		   }
	      }
	 }
      }
   }
}



/* _find-class-constructors1414 */
obj_t 
_find_class_constructors1414_66_object_class(obj_t env_1153, obj_t class_1154)
{
   AN_OBJECT;
   {	/* Object/class.scm 229 */
      return
	 find_class_constructors_231_object_class(
	 (tclass_bglt) (class_1154));
   }
}



/* object-init */
obj_t 
object_init_111_object_class()
{
   AN_OBJECT;
   {	/* Object/class.scm 14 */
      {		/* Object/class.scm 14 */
	 obj_t arg1330_585;
	 obj_t arg1331_586;
	 obj_t arg1334_589;
	 arg1330_585 =
	    CNST_TABLE_REF(((long) 1));
	 arg1331_586 = type_type_type;
	 {	/* Object/class.scm 14 */
	    obj_t v1245_590;
	    v1245_590 =
	       create_vector(((long) 0));
	    arg1334_589 = v1245_590;
	 }
	 tclass_object_class =
	    register_class__225___object(arg1330_585, arg1331_586, allocate_tclass_env_37_object_class, ((long) 36436), BUNSPEC, BFALSE, arg1334_589);
      }
      return BUNSPEC;
   }
}



/* allocate-tclass */
type_bglt 
allocate_tclass_43_object_class()
{
   AN_OBJECT;
   {	/* Object/class.scm 29 */
      {		/* Object/class.scm 29 */
	 type_bglt new1220_591;
	 new1220_591 =
	    ((type_bglt) BREF(GC_MALLOC(sizeof(struct type))));
	 {	/* Object/class.scm 29 */
	    long arg1335_592;
	    arg1335_592 =
	       class_num_218___object(tclass_object_class);
	    {	/* Object/class.scm 29 */
	       obj_t obj_968;
	       obj_968 =
		  (obj_t) (new1220_591);
	       (((obj_t) CREF(obj_968))->header = MAKE_HEADER(arg1335_592, 0), BUNSPEC);
	    }
	 }
	 {	/* Object/class.scm 29 */
	    object_bglt aux_1628;
	    aux_1628 =
	       (object_bglt) (new1220_591);
	    OBJECT_WIDENING_SET(aux_1628, BFALSE);
	 }
	 return new1220_591;
      }
   }
}



/* _allocate-tclass */
obj_t 
_allocate_tclass_237_object_class(obj_t env_1155)
{
   AN_OBJECT;
   {	/* Object/class.scm 29 */
      {		/* Object/class.scm 29 */
	 type_bglt aux_1631;
	 aux_1631 =
	    allocate_tclass_43_object_class();
	 return
	    (obj_t) (aux_1631);
      }
   }
}



/* tclass? */
bool_t 
tclass__65_object_class(obj_t obj_87)
{
   AN_OBJECT;
   {	/* Object/class.scm 29 */
      return
	 is_a__118___object(obj_87, tclass_object_class);
   }
}



/* _tclass? */
obj_t 
_tclass__82_object_class(obj_t env_1156, obj_t obj_1157)
{
   AN_OBJECT;
   {	/* Object/class.scm 29 */
      {		/* Object/class.scm 29 */
	 bool_t aux_1635;
	 aux_1635 =
	    tclass__65_object_class(obj_1157);
	 return
	    BBOOL(aux_1635);
      }
   }
}



/* widening-tclass */
tclass_bglt 
widening_tclass_201_object_class(obj_t its_super_214_88, obj_t slots_89, global_bglt holder_90, obj_t widening_91, long depth_92, bool_t final__12_93, obj_t constructor_94, obj_t virtual_slots_number_200_95)
{
   AN_OBJECT;
   {	/* Object/class.scm 29 */
      {		/* Object/class.scm 29 */
	 tclass_bglt new1208_970;
	 new1208_970 =
	    ((tclass_bglt) BREF(GC_MALLOC(sizeof(struct tclass))));
	 ((((tclass_bglt) CREF(new1208_970))->its_super_214) = ((obj_t) its_super_214_88), BUNSPEC);
	 ((((tclass_bglt) CREF(new1208_970))->slots) = ((obj_t) slots_89), BUNSPEC);
	 ((((tclass_bglt) CREF(new1208_970))->holder) = ((global_bglt) holder_90), BUNSPEC);
	 ((((tclass_bglt) CREF(new1208_970))->widening) = ((obj_t) widening_91), BUNSPEC);
	 ((((tclass_bglt) CREF(new1208_970))->depth) = ((long) depth_92), BUNSPEC);
	 ((((tclass_bglt) CREF(new1208_970))->final__12) = ((bool_t) final__12_93), BUNSPEC);
	 ((((tclass_bglt) CREF(new1208_970))->constructor) = ((obj_t) constructor_94), BUNSPEC);
	 ((((tclass_bglt) CREF(new1208_970))->virtual_slots_number_200) = ((obj_t) virtual_slots_number_200_95), BUNSPEC);
	 return new1208_970;
      }
   }
}



/* _widening-tclass1415 */
obj_t 
_widening_tclass1415_69_object_class(obj_t env_1158, obj_t its_super_214_1159, obj_t slots_1160, obj_t holder_1161, obj_t widening_1162, obj_t depth_1163, obj_t final__12_1164, obj_t constructor_1165, obj_t virtual_slots_number_200_1166)
{
   AN_OBJECT;
   {	/* Object/class.scm 29 */
      {		/* Object/class.scm 29 */
	 tclass_bglt aux_1647;
	 aux_1647 =
	    widening_tclass_201_object_class(its_super_214_1159, slots_1160,
	    (global_bglt) (holder_1161), widening_1162,
	    (long) CINT(depth_1163),
	    CBOOL(final__12_1164), constructor_1165, virtual_slots_number_200_1166);
	 return
	    (obj_t) (aux_1647);
      }
   }
}



/* make-tclass */
tclass_bglt 
make_tclass_121_object_class(obj_t id_96, obj_t name_97, obj_t size_98, obj_t class_99, obj_t coerce_to_204_100, obj_t parents_101, bool_t init__47_102, bool_t magic__53_103, obj_t __57_104, obj_t alias_105, obj_t pointed_to_by_76_106, obj_t tvector_107, obj_t location_108, obj_t its_super_214_109, obj_t slots_110, global_bglt holder_111, obj_t widening_112, long depth_113, bool_t final__12_114, obj_t constructor_115, obj_t virtual_slots_number_200_116)
{
   AN_OBJECT;
   {	/* Object/class.scm 29 */
      {		/* Object/class.scm 29 */
	 type_bglt aux1218_979;
	 {	/* Object/class.scm 29 */
	    type_bglt res1410_1013;
	    {	/* ./Type/type.scm 571 */
	       type_bglt new1014_996;
	       new1014_996 =
		  ((type_bglt) BREF(GC_MALLOC(sizeof(struct type))));
	       {	/* ./Type/type.scm 571 */
		  long arg1374_997;
		  arg1374_997 =
		     class_num_218___object(type_type_type);
		  {	/* ./Type/type.scm 571 */
		     obj_t obj_1011;
		     obj_1011 =
			(obj_t) (new1014_996);
		     (((obj_t) CREF(obj_1011))->header = MAKE_HEADER(arg1374_997, 0), BUNSPEC);
		  }
	       }
	       {	/* ./Type/type.scm 571 */
		  object_bglt aux_1657;
		  aux_1657 =
		     (object_bglt) (new1014_996);
		  OBJECT_WIDENING_SET(aux_1657, BFALSE);
	       }
	       ((((type_bglt) CREF(new1014_996))->id) = ((obj_t) id_96), BUNSPEC);
	       ((((type_bglt) CREF(new1014_996))->name) = ((obj_t) name_97), BUNSPEC);
	       ((((type_bglt) CREF(new1014_996))->size) = ((obj_t) size_98), BUNSPEC);
	       ((((type_bglt) CREF(new1014_996))->class) = ((obj_t) class_99), BUNSPEC);
	       ((((type_bglt) CREF(new1014_996))->coerce_to_204) = ((obj_t) coerce_to_204_100), BUNSPEC);
	       ((((type_bglt) CREF(new1014_996))->parents) = ((obj_t) parents_101), BUNSPEC);
	       ((((type_bglt) CREF(new1014_996))->init__47) = ((bool_t) init__47_102), BUNSPEC);
	       ((((type_bglt) CREF(new1014_996))->magic__53) = ((bool_t) magic__53_103), BUNSPEC);
	       ((((type_bglt) CREF(new1014_996))->__57) = ((obj_t) __57_104), BUNSPEC);
	       ((((type_bglt) CREF(new1014_996))->alias) = ((obj_t) alias_105), BUNSPEC);
	       ((((type_bglt) CREF(new1014_996))->pointed_to_by_76) = ((obj_t) pointed_to_by_76_106), BUNSPEC);
	       ((((type_bglt) CREF(new1014_996))->tvector) = ((obj_t) tvector_107), BUNSPEC);
	       ((((type_bglt) CREF(new1014_996))->location) = ((obj_t) location_108), BUNSPEC);
	       res1410_1013 = new1014_996;
	    }
	    aux1218_979 = res1410_1013;
	 }
	 {	/* Object/class.scm 29 */
	    tclass_bglt new1219_980;
	    new1219_980 =
	       ((tclass_bglt) (aux1218_979));
	    {	/* Object/class.scm 29 */
	       long arg1336_981;
	       arg1336_981 =
		  class_num_218___object(tclass_object_class);
	       {	/* Object/class.scm 29 */
		  obj_t obj_1014;
		  obj_1014 =
		     (obj_t) (new1219_980);
		  (((obj_t) CREF(obj_1014))->header = MAKE_HEADER(arg1336_981, 0), BUNSPEC);
	       }
	    }
	    {	/* Object/class.scm 29 */
	       tclass_bglt arg1337_982;
	       {	/* Object/class.scm 29 */
		  tclass_bglt res1411_1033;
		  {	/* Object/class.scm 29 */
		     tclass_bglt new1208_1024;
		     new1208_1024 =
			((tclass_bglt) BREF(GC_MALLOC(sizeof(struct tclass))));
		     ((((tclass_bglt) CREF(new1208_1024))->its_super_214) = ((obj_t) its_super_214_109), BUNSPEC);
		     ((((tclass_bglt) CREF(new1208_1024))->slots) = ((obj_t) slots_110), BUNSPEC);
		     ((((tclass_bglt) CREF(new1208_1024))->holder) = ((global_bglt) holder_111), BUNSPEC);
		     ((((tclass_bglt) CREF(new1208_1024))->widening) = ((obj_t) widening_112), BUNSPEC);
		     ((((tclass_bglt) CREF(new1208_1024))->depth) = ((long) depth_113), BUNSPEC);
		     ((((tclass_bglt) CREF(new1208_1024))->final__12) = ((bool_t) final__12_114), BUNSPEC);
		     ((((tclass_bglt) CREF(new1208_1024))->constructor) = ((obj_t) constructor_115), BUNSPEC);
		     ((((tclass_bglt) CREF(new1208_1024))->virtual_slots_number_200) = ((obj_t) virtual_slots_number_200_116), BUNSPEC);
		     res1411_1033 = new1208_1024;
		  }
		  arg1337_982 = res1411_1033;
	       }
	       {	/* Object/class.scm 29 */
		  obj_t aux_1688;
		  object_bglt aux_1686;
		  aux_1688 =
		     (obj_t) (arg1337_982);
		  aux_1686 =
		     (object_bglt) (new1219_980);
		  OBJECT_WIDENING_SET(aux_1686, aux_1688);
	       }
	    }
	    return new1219_980;
	 }
      }
   }
}



/* _make-tclass1416 */
obj_t 
_make_tclass1416_86_object_class(obj_t env_1167, obj_t id_1168, obj_t name_1169, obj_t size_1170, obj_t class_1171, obj_t coerce_to_204_1172, obj_t parents_1173, obj_t init__47_1174, obj_t magic__53_1175, obj_t __57_1176, obj_t alias_1177, obj_t pointed_to_by_76_1178, obj_t tvector_1179, obj_t location_1180, obj_t its_super_214_1181, obj_t slots_1182, obj_t holder_1183, obj_t widening_1184, obj_t depth_1185, obj_t final__12_1186, obj_t constructor_1187, obj_t virtual_slots_number_200_1188)
{
   AN_OBJECT;
   {	/* Object/class.scm 29 */
      {		/* Object/class.scm 29 */
	 tclass_bglt aux_1691;
	 aux_1691 =
	    make_tclass_121_object_class(id_1168, name_1169, size_1170, class_1171, coerce_to_204_1172, parents_1173,
	    CBOOL(init__47_1174),
	    CBOOL(magic__53_1175), __57_1176, alias_1177, pointed_to_by_76_1178, tvector_1179, location_1180, its_super_214_1181, slots_1182,
	    (global_bglt) (holder_1183), widening_1184,
	    (long) CINT(depth_1185),
	    CBOOL(final__12_1186), constructor_1187, virtual_slots_number_200_1188);
	 return
	    (obj_t) (aux_1691);
      }
   }
}



/* tclass-id */
obj_t 
tclass_id_40_object_class(type_bglt obj_117)
{
   AN_OBJECT;
   {	/* ./Type/type.scm 573 */
      return
	 (((type_bglt) CREF(obj_117))->id);
   }
}



/* _tclass-id1417 */
obj_t 
_tclass_id1417_114_object_class(obj_t env_1189, obj_t obj_1190)
{
   AN_OBJECT;
   {	/* ./Type/type.scm 573 */
      return
	 tclass_id_40_object_class(
	 (type_bglt) (obj_1190));
   }
}



/* tclass-name-set! */
obj_t 
tclass_name_set__133_object_class(type_bglt obj_118, obj_t val1192_119)
{
   AN_OBJECT;
   {	/* ./Type/type.scm 575 */
      return
	 ((((type_bglt) CREF(obj_118))->name) = ((obj_t) val1192_119), BUNSPEC);
   }
}



/* _tclass-name-set!1418 */
obj_t 
_tclass_name_set_1418_78_object_class(obj_t env_1191, obj_t obj_1192, obj_t val1192_1193)
{
   AN_OBJECT;
   {	/* ./Type/type.scm 575 */
      return
	 tclass_name_set__133_object_class(
	 (type_bglt) (obj_1192), val1192_1193);
   }
}



/* tclass-name */
obj_t 
tclass_name_252_object_class(type_bglt obj_120)
{
   AN_OBJECT;
   {	/* ./Type/type.scm 575 */
      return
	 (((type_bglt) CREF(obj_120))->name);
   }
}



/* _tclass-name1419 */
obj_t 
_tclass_name1419_105_object_class(obj_t env_1194, obj_t obj_1195)
{
   AN_OBJECT;
   {	/* ./Type/type.scm 575 */
      return
	 tclass_name_252_object_class(
	 (type_bglt) (obj_1195));
   }
}



/* tclass-size-set! */
obj_t 
tclass_size_set__204_object_class(type_bglt obj_121, obj_t val1193_122)
{
   AN_OBJECT;
   {	/* ./Type/type.scm 577 */
      return
	 ((((type_bglt) CREF(obj_121))->size) = ((obj_t) val1193_122), BUNSPEC);
   }
}



/* _tclass-size-set!1420 */
obj_t 
_tclass_size_set_1420_133_object_class(obj_t env_1196, obj_t obj_1197, obj_t val1193_1198)
{
   AN_OBJECT;
   {	/* ./Type/type.scm 577 */
      return
	 tclass_size_set__204_object_class(
	 (type_bglt) (obj_1197), val1193_1198);
   }
}



/* tclass-size */
obj_t 
tclass_size_44_object_class(type_bglt obj_123)
{
   AN_OBJECT;
   {	/* ./Type/type.scm 577 */
      return
	 (((type_bglt) CREF(obj_123))->size);
   }
}



/* _tclass-size1421 */
obj_t 
_tclass_size1421_63_object_class(obj_t env_1199, obj_t obj_1200)
{
   AN_OBJECT;
   {	/* ./Type/type.scm 577 */
      return
	 tclass_size_44_object_class(
	 (type_bglt) (obj_1200));
   }
}



/* tclass-class-set! */
obj_t 
tclass_class_set__74_object_class(type_bglt obj_124, obj_t val1194_125)
{
   AN_OBJECT;
   {	/* ./Type/type.scm 579 */
      return
	 ((((type_bglt) CREF(obj_124))->class) = ((obj_t) val1194_125), BUNSPEC);
   }
}



/* _tclass-class-set!1422 */
obj_t 
_tclass_class_set_1422_67_object_class(obj_t env_1201, obj_t obj_1202, obj_t val1194_1203)
{
   AN_OBJECT;
   {	/* ./Type/type.scm 579 */
      return
	 tclass_class_set__74_object_class(
	 (type_bglt) (obj_1202), val1194_1203);
   }
}



/* tclass-class */
obj_t 
tclass_class_106_object_class(type_bglt obj_126)
{
   AN_OBJECT;
   {	/* ./Type/type.scm 579 */
      return
	 (((type_bglt) CREF(obj_126))->class);
   }
}



/* _tclass-class1423 */
obj_t 
_tclass_class1423_144_object_class(obj_t env_1204, obj_t obj_1205)
{
   AN_OBJECT;
   {	/* ./Type/type.scm 579 */
      return
	 tclass_class_106_object_class(
	 (type_bglt) (obj_1205));
   }
}



/* tclass-coerce-to-set! */
obj_t 
tclass_coerce_to_set__105_object_class(type_bglt obj_127, obj_t val1195_128)
{
   AN_OBJECT;
   {	/* ./Type/type.scm 582 */
      return
	 ((((type_bglt) CREF(obj_127))->coerce_to_204) = ((obj_t) val1195_128), BUNSPEC);
   }
}



/* _tclass-coerce-to-set!1424 */
obj_t 
_tclass_coerce_to_set_1424_50_object_class(obj_t env_1206, obj_t obj_1207, obj_t val1195_1208)
{
   AN_OBJECT;
   {	/* ./Type/type.scm 582 */
      return
	 tclass_coerce_to_set__105_object_class(
	 (type_bglt) (obj_1207), val1195_1208);
   }
}



/* tclass-coerce-to */
obj_t 
tclass_coerce_to_203_object_class(type_bglt obj_129)
{
   AN_OBJECT;
   {	/* ./Type/type.scm 582 */
      return
	 (((type_bglt) CREF(obj_129))->coerce_to_204);
   }
}



/* _tclass-coerce-to1425 */
obj_t 
_tclass_coerce_to1425_210_object_class(obj_t env_1209, obj_t obj_1210)
{
   AN_OBJECT;
   {	/* ./Type/type.scm 582 */
      return
	 tclass_coerce_to_203_object_class(
	 (type_bglt) (obj_1210));
   }
}



/* tclass-parents-set! */
obj_t 
tclass_parents_set__36_object_class(type_bglt obj_130, obj_t val1196_131)
{
   AN_OBJECT;
   {	/* ./Type/type.scm 584 */
      return
	 ((((type_bglt) CREF(obj_130))->parents) = ((obj_t) val1196_131), BUNSPEC);
   }
}



/* _tclass-parents-set!1426 */
obj_t 
_tclass_parents_set_1426_200_object_class(obj_t env_1211, obj_t obj_1212, obj_t val1196_1213)
{
   AN_OBJECT;
   {	/* ./Type/type.scm 584 */
      return
	 tclass_parents_set__36_object_class(
	 (type_bglt) (obj_1212), val1196_1213);
   }
}



/* tclass-parents */
obj_t 
tclass_parents_63_object_class(type_bglt obj_132)
{
   AN_OBJECT;
   {	/* ./Type/type.scm 584 */
      return
	 (((type_bglt) CREF(obj_132))->parents);
   }
}



/* _tclass-parents1427 */
obj_t 
_tclass_parents1427_107_object_class(obj_t env_1214, obj_t obj_1215)
{
   AN_OBJECT;
   {	/* ./Type/type.scm 584 */
      return
	 tclass_parents_63_object_class(
	 (type_bglt) (obj_1215));
   }
}



/* tclass-init?-set! */
obj_t 
tclass_init__set__98_object_class(type_bglt obj_133, bool_t val1197_134)
{
   AN_OBJECT;
   {	/* Object/class.scm 29 */
      return
	 ((((type_bglt) CREF(obj_133))->init__47) = ((bool_t) val1197_134), BUNSPEC);
   }
}



/* _tclass-init?-set!1428 */
obj_t 
_tclass_init__set_1428_55_object_class(obj_t env_1216, obj_t obj_1217, obj_t val1197_1218)
{
   AN_OBJECT;
   {	/* Object/class.scm 29 */
      return
	 tclass_init__set__98_object_class(
	 (type_bglt) (obj_1217),
	 CBOOL(val1197_1218));
   }
}



/* tclass-init? */
bool_t 
tclass_init__162_object_class(type_bglt obj_135)
{
   AN_OBJECT;
   {	/* Object/class.scm 29 */
      return
	 (((type_bglt) CREF(obj_135))->init__47);
   }
}



/* _tclass-init?1429 */
obj_t 
_tclass_init_1429_249_object_class(obj_t env_1219, obj_t obj_1220)
{
   AN_OBJECT;
   {	/* Object/class.scm 29 */
      {		/* Object/class.scm 29 */
	 bool_t aux_1737;
	 aux_1737 =
	    tclass_init__162_object_class(
	    (type_bglt) (obj_1220));
	 return
	    BBOOL(aux_1737);
      }
   }
}



/* tclass-magic?-set! */
obj_t 
tclass_magic__set__202_object_class(type_bglt obj_136, bool_t val1198_137)
{
   AN_OBJECT;
   {	/* ./Type/type.scm 588 */
      return
	 ((((type_bglt) CREF(obj_136))->magic__53) = ((bool_t) val1198_137), BUNSPEC);
   }
}



/* _tclass-magic?-set!1430 */
obj_t 
_tclass_magic__set_1430_2_object_class(obj_t env_1221, obj_t obj_1222, obj_t val1198_1223)
{
   AN_OBJECT;
   {	/* ./Type/type.scm 588 */
      return
	 tclass_magic__set__202_object_class(
	 (type_bglt) (obj_1222),
	 CBOOL(val1198_1223));
   }
}



/* tclass-magic? */
bool_t 
tclass_magic__27_object_class(type_bglt obj_138)
{
   AN_OBJECT;
   {	/* ./Type/type.scm 588 */
      return
	 (((type_bglt) CREF(obj_138))->magic__53);
   }
}



/* _tclass-magic?1431 */
obj_t 
_tclass_magic_1431_234_object_class(obj_t env_1224, obj_t obj_1225)
{
   AN_OBJECT;
   {	/* ./Type/type.scm 588 */
      {		/* ./Type/type.scm 588 */
	 bool_t aux_1746;
	 aux_1746 =
	    tclass_magic__27_object_class(
	    (type_bglt) (obj_1225));
	 return
	    BBOOL(aux_1746);
      }
   }
}



/* tclass-$-set! */
obj_t 
tclass___set__194_object_class(type_bglt obj_139, obj_t val1199_140)
{
   AN_OBJECT;
   {	/* ./Type/type.scm 590 */
      return
	 ((((type_bglt) CREF(obj_139))->__57) = ((obj_t) val1199_140), BUNSPEC);
   }
}



/* _tclass-$-set!1432 */
obj_t 
_tclass___set_1432_43_object_class(obj_t env_1226, obj_t obj_1227, obj_t val1199_1228)
{
   AN_OBJECT;
   {	/* ./Type/type.scm 590 */
      return
	 tclass___set__194_object_class(
	 (type_bglt) (obj_1227), val1199_1228);
   }
}



/* tclass-$ */
obj_t 
tclass___165_object_class(type_bglt obj_141)
{
   AN_OBJECT;
   {	/* ./Type/type.scm 590 */
      return
	 (((type_bglt) CREF(obj_141))->__57);
   }
}



/* _tclass-$1433 */
obj_t 
_tclass__1433_221_object_class(obj_t env_1229, obj_t obj_1230)
{
   AN_OBJECT;
   {	/* ./Type/type.scm 590 */
      return
	 tclass___165_object_class(
	 (type_bglt) (obj_1230));
   }
}



/* tclass-alias-set! */
obj_t 
tclass_alias_set__162_object_class(type_bglt obj_142, obj_t val1200_143)
{
   AN_OBJECT;
   {	/* ./Type/type.scm 592 */
      return
	 ((((type_bglt) CREF(obj_142))->alias) = ((obj_t) val1200_143), BUNSPEC);
   }
}



/* _tclass-alias-set!1434 */
obj_t 
_tclass_alias_set_1434_9_object_class(obj_t env_1231, obj_t obj_1232, obj_t val1200_1233)
{
   AN_OBJECT;
   {	/* ./Type/type.scm 592 */
      return
	 tclass_alias_set__162_object_class(
	 (type_bglt) (obj_1232), val1200_1233);
   }
}



/* tclass-alias */
obj_t 
tclass_alias_101_object_class(type_bglt obj_144)
{
   AN_OBJECT;
   {	/* ./Type/type.scm 592 */
      return
	 (((type_bglt) CREF(obj_144))->alias);
   }
}



/* _tclass-alias1435 */
obj_t 
_tclass_alias1435_253_object_class(obj_t env_1234, obj_t obj_1235)
{
   AN_OBJECT;
   {	/* ./Type/type.scm 592 */
      return
	 tclass_alias_101_object_class(
	 (type_bglt) (obj_1235));
   }
}



/* tclass-pointed-to-by-set! */
obj_t 
tclass_pointed_to_by_set__241_object_class(type_bglt obj_145, obj_t val1201_146)
{
   AN_OBJECT;
   {	/* ./Type/type.scm 594 */
      return
	 ((((type_bglt) CREF(obj_145))->pointed_to_by_76) = ((obj_t) val1201_146), BUNSPEC);
   }
}



/* _tclass-pointed-to-by-set!1436 */
obj_t 
_tclass_pointed_to_by_set_1436_191_object_class(obj_t env_1236, obj_t obj_1237, obj_t val1201_1238)
{
   AN_OBJECT;
   {	/* ./Type/type.scm 594 */
      return
	 tclass_pointed_to_by_set__241_object_class(
	 (type_bglt) (obj_1237), val1201_1238);
   }
}



/* tclass-pointed-to-by */
obj_t 
tclass_pointed_to_by_195_object_class(type_bglt obj_147)
{
   AN_OBJECT;
   {	/* ./Type/type.scm 594 */
      return
	 (((type_bglt) CREF(obj_147))->pointed_to_by_76);
   }
}



/* _tclass-pointed-to-by1437 */
obj_t 
_tclass_pointed_to_by1437_239_object_class(obj_t env_1239, obj_t obj_1240)
{
   AN_OBJECT;
   {	/* ./Type/type.scm 594 */
      return
	 tclass_pointed_to_by_195_object_class(
	 (type_bglt) (obj_1240));
   }
}



/* tclass-tvector-set! */
obj_t 
tclass_tvector_set__109_object_class(type_bglt obj_148, obj_t val1202_149)
{
   AN_OBJECT;
   {	/* ./Type/type.scm 597 */
      return
	 ((((type_bglt) CREF(obj_148))->tvector) = ((obj_t) val1202_149), BUNSPEC);
   }
}



/* _tclass-tvector-set!1438 */
obj_t 
_tclass_tvector_set_1438_182_object_class(obj_t env_1241, obj_t obj_1242, obj_t val1202_1243)
{
   AN_OBJECT;
   {	/* ./Type/type.scm 597 */
      return
	 tclass_tvector_set__109_object_class(
	 (type_bglt) (obj_1242), val1202_1243);
   }
}



/* tclass-tvector */
obj_t 
tclass_tvector_243_object_class(type_bglt obj_150)
{
   AN_OBJECT;
   {	/* ./Type/type.scm 597 */
      return
	 (((type_bglt) CREF(obj_150))->tvector);
   }
}



/* _tclass-tvector1439 */
obj_t 
_tclass_tvector1439_32_object_class(obj_t env_1244, obj_t obj_1245)
{
   AN_OBJECT;
   {	/* ./Type/type.scm 597 */
      return
	 tclass_tvector_243_object_class(
	 (type_bglt) (obj_1245));
   }
}



/* tclass-location-set! */
obj_t 
tclass_location_set__32_object_class(type_bglt obj_151, obj_t val1203_152)
{
   AN_OBJECT;
   {	/* ./Type/type.scm 599 */
      return
	 ((((type_bglt) CREF(obj_151))->location) = ((obj_t) val1203_152), BUNSPEC);
   }
}



/* _tclass-location-set!1440 */
obj_t 
_tclass_location_set_1440_194_object_class(obj_t env_1246, obj_t obj_1247, obj_t val1203_1248)
{
   AN_OBJECT;
   {	/* ./Type/type.scm 599 */
      return
	 tclass_location_set__32_object_class(
	 (type_bglt) (obj_1247), val1203_1248);
   }
}



/* tclass-location */
obj_t 
tclass_location_110_object_class(type_bglt obj_153)
{
   AN_OBJECT;
   {	/* ./Type/type.scm 599 */
      return
	 (((type_bglt) CREF(obj_153))->location);
   }
}



/* _tclass-location1441 */
obj_t 
_tclass_location1441_164_object_class(obj_t env_1249, obj_t obj_1250)
{
   AN_OBJECT;
   {	/* ./Type/type.scm 599 */
      return
	 tclass_location_110_object_class(
	 (type_bglt) (obj_1250));
   }
}



/* tclass-its-super-set! */
obj_t 
tclass_its_super_set__222_object_class(tclass_bglt obj_154, obj_t val1204_155)
{
   AN_OBJECT;
   {	/* Object/class.scm 29 */
      {
	 obj_t aux_1780;
	 {	/* Object/class.scm 29 */
	    object_bglt aux_1781;
	    aux_1781 =
	       (object_bglt) (obj_154);
	    aux_1780 =
	       OBJECT_WIDENING(aux_1781);
	 }
	 return
	    ((((tclass_bglt) CREF(aux_1780))->its_super_214) = ((obj_t) val1204_155), BUNSPEC);
      }
   }
}



/* _tclass-its-super-set!1442 */
obj_t 
_tclass_its_super_set_1442_52_object_class(obj_t env_1251, obj_t obj_1252, obj_t val1204_1253)
{
   AN_OBJECT;
   {	/* Object/class.scm 29 */
      return
	 tclass_its_super_set__222_object_class(
	 (tclass_bglt) (obj_1252), val1204_1253);
   }
}



/* tclass-its-super */
obj_t 
tclass_its_super_153_object_class(tclass_bglt obj_156)
{
   AN_OBJECT;
   {	/* Object/class.scm 29 */
      {
	 obj_t aux_1787;
	 {	/* Object/class.scm 29 */
	    object_bglt aux_1788;
	    aux_1788 =
	       (object_bglt) (obj_156);
	    aux_1787 =
	       OBJECT_WIDENING(aux_1788);
	 }
	 return
	    (((tclass_bglt) CREF(aux_1787))->its_super_214);
      }
   }
}



/* _tclass-its-super1443 */
obj_t 
_tclass_its_super1443_237_object_class(obj_t env_1254, obj_t obj_1255)
{
   AN_OBJECT;
   {	/* Object/class.scm 29 */
      return
	 tclass_its_super_153_object_class(
	 (tclass_bglt) (obj_1255));
   }
}



/* tclass-slots-set! */
obj_t 
tclass_slots_set__141_object_class(tclass_bglt obj_157, obj_t val1205_158)
{
   AN_OBJECT;
   {	/* Object/class.scm 33 */
      {
	 obj_t aux_1794;
	 {	/* Object/class.scm 33 */
	    object_bglt aux_1795;
	    aux_1795 =
	       (object_bglt) (obj_157);
	    aux_1794 =
	       OBJECT_WIDENING(aux_1795);
	 }
	 return
	    ((((tclass_bglt) CREF(aux_1794))->slots) = ((obj_t) val1205_158), BUNSPEC);
      }
   }
}



/* _tclass-slots-set!1444 */
obj_t 
_tclass_slots_set_1444_107_object_class(obj_t env_1256, obj_t obj_1257, obj_t val1205_1258)
{
   AN_OBJECT;
   {	/* Object/class.scm 33 */
      return
	 tclass_slots_set__141_object_class(
	 (tclass_bglt) (obj_1257), val1205_1258);
   }
}



/* tclass-slots */
obj_t 
tclass_slots_1_object_class(tclass_bglt obj_159)
{
   AN_OBJECT;
   {	/* Object/class.scm 33 */
      {
	 obj_t aux_1801;
	 {	/* Object/class.scm 33 */
	    object_bglt aux_1802;
	    aux_1802 =
	       (object_bglt) (obj_159);
	    aux_1801 =
	       OBJECT_WIDENING(aux_1802);
	 }
	 return
	    (((tclass_bglt) CREF(aux_1801))->slots);
      }
   }
}



/* _tclass-slots1445 */
obj_t 
_tclass_slots1445_136_object_class(obj_t env_1259, obj_t obj_1260)
{
   AN_OBJECT;
   {	/* Object/class.scm 33 */
      return
	 tclass_slots_1_object_class(
	 (tclass_bglt) (obj_1260));
   }
}



/* tclass-holder */
global_bglt 
tclass_holder_146_object_class(tclass_bglt obj_160)
{
   AN_OBJECT;
   {	/* Object/class.scm 35 */
      {
	 obj_t aux_1808;
	 {	/* Object/class.scm 35 */
	    object_bglt aux_1809;
	    aux_1809 =
	       (object_bglt) (obj_160);
	    aux_1808 =
	       OBJECT_WIDENING(aux_1809);
	 }
	 return
	    (((tclass_bglt) CREF(aux_1808))->holder);
      }
   }
}



/* _tclass-holder1446 */
obj_t 
_tclass_holder1446_150_object_class(obj_t env_1261, obj_t obj_1262)
{
   AN_OBJECT;
   {	/* Object/class.scm 35 */
      {		/* Object/class.scm 35 */
	 global_bglt aux_1813;
	 aux_1813 =
	    tclass_holder_146_object_class(
	    (tclass_bglt) (obj_1262));
	 return
	    (obj_t) (aux_1813);
      }
   }
}



/* tclass-widening */
obj_t 
tclass_widening_127_object_class(tclass_bglt obj_161)
{
   AN_OBJECT;
   {	/* Object/class.scm 37 */
      {
	 obj_t aux_1817;
	 {	/* Object/class.scm 37 */
	    object_bglt aux_1818;
	    aux_1818 =
	       (object_bglt) (obj_161);
	    aux_1817 =
	       OBJECT_WIDENING(aux_1818);
	 }
	 return
	    (((tclass_bglt) CREF(aux_1817))->widening);
      }
   }
}



/* _tclass-widening1447 */
obj_t 
_tclass_widening1447_28_object_class(obj_t env_1263, obj_t obj_1264)
{
   AN_OBJECT;
   {	/* Object/class.scm 37 */
      return
	 tclass_widening_127_object_class(
	 (tclass_bglt) (obj_1264));
   }
}



/* tclass-depth-set! */
obj_t 
tclass_depth_set__40_object_class(tclass_bglt obj_162, long val1206_163)
{
   AN_OBJECT;
   {	/* Object/class.scm 39 */
      {
	 obj_t aux_1824;
	 {	/* Object/class.scm 39 */
	    object_bglt aux_1825;
	    aux_1825 =
	       (object_bglt) (obj_162);
	    aux_1824 =
	       OBJECT_WIDENING(aux_1825);
	 }
	 return
	    ((((tclass_bglt) CREF(aux_1824))->depth) = ((long) val1206_163), BUNSPEC);
      }
   }
}



/* _tclass-depth-set!1448 */
obj_t 
_tclass_depth_set_1448_223_object_class(obj_t env_1265, obj_t obj_1266, obj_t val1206_1267)
{
   AN_OBJECT;
   {	/* Object/class.scm 39 */
      return
	 tclass_depth_set__40_object_class(
	 (tclass_bglt) (obj_1266),
	 (long) CINT(val1206_1267));
   }
}



/* tclass-depth */
long 
tclass_depth_100_object_class(tclass_bglt obj_164)
{
   AN_OBJECT;
   {	/* Object/class.scm 39 */
      {
	 obj_t aux_1832;
	 {	/* Object/class.scm 39 */
	    object_bglt aux_1833;
	    aux_1833 =
	       (object_bglt) (obj_164);
	    aux_1832 =
	       OBJECT_WIDENING(aux_1833);
	 }
	 return
	    (((tclass_bglt) CREF(aux_1832))->depth);
      }
   }
}



/* _tclass-depth1449 */
obj_t 
_tclass_depth1449_93_object_class(obj_t env_1268, obj_t obj_1269)
{
   AN_OBJECT;
   {	/* Object/class.scm 39 */
      {		/* Object/class.scm 39 */
	 long aux_1837;
	 aux_1837 =
	    tclass_depth_100_object_class(
	    (tclass_bglt) (obj_1269));
	 return
	    BINT(aux_1837);
      }
   }
}



/* tclass-final? */
bool_t 
tclass_final__60_object_class(tclass_bglt obj_165)
{
   AN_OBJECT;
   {	/* Object/class.scm 41 */
      {
	 obj_t aux_1841;
	 {	/* Object/class.scm 41 */
	    object_bglt aux_1842;
	    aux_1842 =
	       (object_bglt) (obj_165);
	    aux_1841 =
	       OBJECT_WIDENING(aux_1842);
	 }
	 return
	    (((tclass_bglt) CREF(aux_1841))->final__12);
      }
   }
}



/* _tclass-final?1450 */
obj_t 
_tclass_final_1450_45_object_class(obj_t env_1270, obj_t obj_1271)
{
   AN_OBJECT;
   {	/* Object/class.scm 41 */
      {		/* Object/class.scm 41 */
	 bool_t aux_1846;
	 aux_1846 =
	    tclass_final__60_object_class(
	    (tclass_bglt) (obj_1271));
	 return
	    BBOOL(aux_1846);
      }
   }
}



/* tclass-constructor */
obj_t 
tclass_constructor_36_object_class(tclass_bglt obj_166)
{
   AN_OBJECT;
   {	/* Object/class.scm 43 */
      {
	 obj_t aux_1850;
	 {	/* Object/class.scm 43 */
	    object_bglt aux_1851;
	    aux_1851 =
	       (object_bglt) (obj_166);
	    aux_1850 =
	       OBJECT_WIDENING(aux_1851);
	 }
	 return
	    (((tclass_bglt) CREF(aux_1850))->constructor);
      }
   }
}



/* _tclass-constructor1451 */
obj_t 
_tclass_constructor1451_233_object_class(obj_t env_1272, obj_t obj_1273)
{
   AN_OBJECT;
   {	/* Object/class.scm 43 */
      return
	 tclass_constructor_36_object_class(
	 (tclass_bglt) (obj_1273));
   }
}



/* tclass-virtual-slots-number-set! */
obj_t 
tclass_virtual_slots_number_set__141_object_class(tclass_bglt obj_167, obj_t val1207_168)
{
   AN_OBJECT;
   {	/* Object/class.scm 45 */
      {
	 obj_t aux_1857;
	 {	/* Object/class.scm 45 */
	    object_bglt aux_1858;
	    aux_1858 =
	       (object_bglt) (obj_167);
	    aux_1857 =
	       OBJECT_WIDENING(aux_1858);
	 }
	 return
	    ((((tclass_bglt) CREF(aux_1857))->virtual_slots_number_200) = ((obj_t) val1207_168), BUNSPEC);
      }
   }
}



/* _tclass-virtual-slots-number-set! */
obj_t 
_tclass_virtual_slots_number_set__15_object_class(obj_t env_1274, obj_t obj_1275, obj_t val1207_1276)
{
   AN_OBJECT;
   {	/* Object/class.scm 45 */
      return
	 tclass_virtual_slots_number_set__141_object_class(
	 (tclass_bglt) (obj_1275), val1207_1276);
   }
}



/* tclass-virtual-slots-number */
obj_t 
tclass_virtual_slots_number_1_object_class(tclass_bglt obj_169)
{
   AN_OBJECT;
   {	/* Object/class.scm 45 */
      {
	 obj_t aux_1864;
	 {	/* Object/class.scm 45 */
	    object_bglt aux_1865;
	    aux_1865 =
	       (object_bglt) (obj_169);
	    aux_1864 =
	       OBJECT_WIDENING(aux_1865);
	 }
	 return
	    (((tclass_bglt) CREF(aux_1864))->virtual_slots_number_200);
      }
   }
}



/* _tclass-virtual-slots-number */
obj_t 
_tclass_virtual_slots_number_232_object_class(obj_t env_1277, obj_t obj_1278)
{
   AN_OBJECT;
   {	/* Object/class.scm 45 */
      return
	 tclass_virtual_slots_number_1_object_class(
	 (tclass_bglt) (obj_1278));
   }
}



/* method-init */
obj_t 
method_init_76_object_class()
{
   AN_OBJECT;
   {	/* Object/class.scm 14 */
      {		/* Object/class.scm 14 */
	 obj_t object__struct_tclass1250_93_1283;
	 object__struct_tclass1250_93_1283 = proc1471_object_class;
	 add_method__1___object(object__struct_env_210___object, tclass_object_class, object__struct_tclass1250_93_1283);
      }
      {		/* Object/class.scm 14 */
	 obj_t struct_object__object_tclass1252_108_1279;
	 struct_object__object_tclass1252_108_1279 = proc1472_object_class;
	 return
	    add_method__1___object(struct_object__object_env_209___object, tclass_object_class, struct_object__object_tclass1252_108_1279);
      }
   }
}



/* struct+object->object-tclass1252 */
obj_t 
struct_object__object_tclass1252_108_object_class(obj_t env_1286, obj_t o_1287, obj_t s_1288)
{
   AN_OBJECT;
   {	/* Object/class.scm 29 */
      {
	 tclass_bglt o_767;
	 obj_t s_768;
	 {	/* Object/class.scm 29 */
	    tclass_bglt aux_1873;
	    o_767 =
	       (tclass_bglt) (o_1287);
	    s_768 = s_1288;
	    {

	       {	/* Object/class.scm 29 */
		  obj_t old1225_771;
		  obj_t aux1226_772;
		  {	/* Object/class.scm 29 */
		     obj_t next_method1251_206_784;
		     next_method1251_206_784 =
			find_super_class_method_167___object(
			(object_bglt) (o_767), struct_object__object_env_209___object, tclass_object_class);
		     if (
			PROCEDUREP(next_method1251_206_784))
		       {	/* Object/class.scm 29 */
			  old1225_771 =
			     PROCEDURE_ENTRY(next_method1251_206_784) (next_method1251_206_784,
			     (obj_t) (o_767), s_768, BEOA);
		       }
		     else
		       {	/* Object/class.scm 29 */
			  PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method1251_206_784);
			  {	/* Object/class.scm 29 */
			     object_bglt aux_1882;
			     aux_1882 =
				struct_object__object_93___object(
				(object_bglt) (o_767), s_768);
			     old1225_771 =
				(obj_t) (aux_1882);
			  }
		       }
		  }
		  aux1226_772 =
		     STRUCT_REF(s_768, ((long) 0));
		  {	/* Object/class.scm 29 */
		     tclass_bglt new1227_773;
		     new1227_773 =
			((tclass_bglt) (old1225_771));
		     {	/* Object/class.scm 29 */
			long arg1397_774;
			arg1397_774 =
			   class_num_218___object(tclass_object_class);
			{	/* Object/class.scm 29 */
			   obj_t obj_1098;
			   obj_1098 =
			      (obj_t) (new1227_773);
			   (((obj_t) CREF(obj_1098))->header = MAKE_HEADER(arg1397_774, 0), BUNSPEC);
			}
		     }
		     {	/* Object/class.scm 29 */
			tclass_bglt arg1398_775;
			{	/* Object/class.scm 29 */
			   obj_t arg1399_776;
			   obj_t arg1400_777;
			   obj_t arg1402_779;
			   obj_t arg1405_782;
			   obj_t arg1406_783;
			   arg1399_776 =
			      STRUCT_REF(aux1226_772, ((long) 0));
			   arg1400_777 =
			      STRUCT_REF(aux1226_772, ((long) 1));
			   arg1402_779 =
			      STRUCT_REF(aux1226_772, ((long) 3));
			   arg1405_782 =
			      STRUCT_REF(aux1226_772, ((long) 6));
			   arg1406_783 =
			      STRUCT_REF(aux1226_772, ((long) 7));
			   {	/* Object/class.scm 29 */
			      tclass_bglt res1412_1133;
			      {		/* Object/class.scm 29 */
				 global_bglt holder_1118;
				 long depth_1120;
				 bool_t final__12_1121;
				 {	/* Object/class.scm 29 */
				    obj_t aux_1896;
				    aux_1896 =
				       STRUCT_REF(aux1226_772, ((long) 2));
				    holder_1118 =
				       (global_bglt) (aux_1896);
				 }
				 {	/* Object/class.scm 29 */
				    obj_t aux_1899;
				    aux_1899 =
				       STRUCT_REF(aux1226_772, ((long) 4));
				    depth_1120 =
				       (long) CINT(aux_1899);
				 }
				 {	/* Object/class.scm 29 */
				    obj_t aux_1902;
				    aux_1902 =
				       STRUCT_REF(aux1226_772, ((long) 5));
				    final__12_1121 =
				       CBOOL(aux_1902);
				 }
				 {	/* Object/class.scm 29 */
				    tclass_bglt new1208_1124;
				    new1208_1124 =
				       ((tclass_bglt) BREF(GC_MALLOC(sizeof(struct tclass))));
				    ((((tclass_bglt) CREF(new1208_1124))->its_super_214) = ((obj_t) arg1399_776), BUNSPEC);
				    ((((tclass_bglt) CREF(new1208_1124))->slots) = ((obj_t) arg1400_777), BUNSPEC);
				    ((((tclass_bglt) CREF(new1208_1124))->holder) = ((global_bglt) holder_1118), BUNSPEC);
				    ((((tclass_bglt) CREF(new1208_1124))->widening) = ((obj_t) arg1402_779), BUNSPEC);
				    ((((tclass_bglt) CREF(new1208_1124))->depth) = ((long) depth_1120), BUNSPEC);
				    ((((tclass_bglt) CREF(new1208_1124))->final__12) = ((bool_t) final__12_1121), BUNSPEC);
				    ((((tclass_bglt) CREF(new1208_1124))->constructor) = ((obj_t) arg1405_782), BUNSPEC);
				    ((((tclass_bglt) CREF(new1208_1124))->virtual_slots_number_200) = ((obj_t) arg1406_783), BUNSPEC);
				    res1412_1133 = new1208_1124;
				 }
			      }
			      arg1398_775 = res1412_1133;
			   }
			}
			{	/* Object/class.scm 29 */
			   obj_t aux_1916;
			   object_bglt aux_1914;
			   aux_1916 =
			      (obj_t) (arg1398_775);
			   aux_1914 =
			      (object_bglt) (new1227_773);
			   OBJECT_WIDENING_SET(aux_1914, aux_1916);
			}
		     }
		     aux_1873 = new1227_773;
		  }
	       }
	    }
	    return
	       (obj_t) (aux_1873);
	 }
      }
   }
}



/* object->struct-tclass1250 */
obj_t 
object__struct_tclass1250_93_object_class(obj_t env_1289, obj_t obj1222_1290)
{
   AN_OBJECT;
   {	/* Object/class.scm 29 */
      {
	 tclass_bglt obj1222_743;
	 obj1222_743 =
	    (tclass_bglt) (obj1222_1290);
	 {

	    {	/* Object/class.scm 29 */
	       obj_t res1223_746;
	       {	/* Object/class.scm 29 */
		  obj_t next_method1249_122_765;
		  next_method1249_122_765 =
		     find_super_class_method_167___object(
		     (object_bglt) (obj1222_743), object__struct_env_210___object, tclass_object_class);
		  if (
		     PROCEDUREP(next_method1249_122_765))
		    {	/* Object/class.scm 29 */
		       res1223_746 =
			  PROCEDURE_ENTRY(next_method1249_122_765) (next_method1249_122_765,
			  (obj_t) (obj1222_743), BEOA);
		    }
		  else
		    {	/* Object/class.scm 29 */
		       PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method1249_122_765);
		       res1223_746 =
			  object__struct_50___object(
			  (object_bglt) (obj1222_743));
		    }
	       }
	       {	/* Object/class.scm 29 */
		  obj_t aux1224_747;
		  {	/* ./Llib/struct.scm 1415 */
		     obj_t aux_1931;
		     aux_1931 =
			CNST_TABLE_REF(((long) 1));
		     aux1224_747 =
			make_struct(aux_1931, ((long) 8), BUNSPEC);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_1934;
		     {
			obj_t aux_1935;
			{	/* Object/class.scm 29 */
			   object_bglt aux_1936;
			   aux_1936 =
			      (object_bglt) (obj1222_743);
			   aux_1935 =
			      OBJECT_WIDENING(aux_1936);
			}
			aux_1934 =
			   (((tclass_bglt) CREF(aux_1935))->its_super_214);
		     }
		     STRUCT_SET(aux1224_747, ((long) 0), aux_1934);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_1941;
		     {
			obj_t aux_1942;
			{	/* Object/class.scm 33 */
			   object_bglt aux_1943;
			   aux_1943 =
			      (object_bglt) (obj1222_743);
			   aux_1942 =
			      OBJECT_WIDENING(aux_1943);
			}
			aux_1941 =
			   (((tclass_bglt) CREF(aux_1942))->slots);
		     }
		     STRUCT_SET(aux1224_747, ((long) 1), aux_1941);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_1948;
		     {	/* Object/class.scm 29 */
			global_bglt aux_1949;
			{
			   obj_t aux_1950;
			   {	/* Object/class.scm 35 */
			      object_bglt aux_1951;
			      aux_1951 =
				 (object_bglt) (obj1222_743);
			      aux_1950 =
				 OBJECT_WIDENING(aux_1951);
			   }
			   aux_1949 =
			      (((tclass_bglt) CREF(aux_1950))->holder);
			}
			aux_1948 =
			   (obj_t) (aux_1949);
		     }
		     STRUCT_SET(aux1224_747, ((long) 2), aux_1948);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_1957;
		     {
			obj_t aux_1958;
			{	/* Object/class.scm 37 */
			   object_bglt aux_1959;
			   aux_1959 =
			      (object_bglt) (obj1222_743);
			   aux_1958 =
			      OBJECT_WIDENING(aux_1959);
			}
			aux_1957 =
			   (((tclass_bglt) CREF(aux_1958))->widening);
		     }
		     STRUCT_SET(aux1224_747, ((long) 3), aux_1957);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_1964;
		     {	/* Object/class.scm 29 */
			long aux_1965;
			{
			   obj_t aux_1966;
			   {	/* Object/class.scm 39 */
			      object_bglt aux_1967;
			      aux_1967 =
				 (object_bglt) (obj1222_743);
			      aux_1966 =
				 OBJECT_WIDENING(aux_1967);
			   }
			   aux_1965 =
			      (((tclass_bglt) CREF(aux_1966))->depth);
			}
			aux_1964 =
			   BINT(aux_1965);
		     }
		     STRUCT_SET(aux1224_747, ((long) 4), aux_1964);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_1973;
		     {	/* Object/class.scm 29 */
			bool_t aux_1974;
			{
			   obj_t aux_1975;
			   {	/* Object/class.scm 41 */
			      object_bglt aux_1976;
			      aux_1976 =
				 (object_bglt) (obj1222_743);
			      aux_1975 =
				 OBJECT_WIDENING(aux_1976);
			   }
			   aux_1974 =
			      (((tclass_bglt) CREF(aux_1975))->final__12);
			}
			aux_1973 =
			   BBOOL(aux_1974);
		     }
		     STRUCT_SET(aux1224_747, ((long) 5), aux_1973);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_1982;
		     {
			obj_t aux_1983;
			{	/* Object/class.scm 43 */
			   object_bglt aux_1984;
			   aux_1984 =
			      (object_bglt) (obj1222_743);
			   aux_1983 =
			      OBJECT_WIDENING(aux_1984);
			}
			aux_1982 =
			   (((tclass_bglt) CREF(aux_1983))->constructor);
		     }
		     STRUCT_SET(aux1224_747, ((long) 6), aux_1982);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_1989;
		     {
			obj_t aux_1990;
			{	/* Object/class.scm 45 */
			   object_bglt aux_1991;
			   aux_1991 =
			      (object_bglt) (obj1222_743);
			   aux_1990 =
			      OBJECT_WIDENING(aux_1991);
			}
			aux_1989 =
			   (((tclass_bglt) CREF(aux_1990))->virtual_slots_number_200);
		     }
		     STRUCT_SET(aux1224_747, ((long) 7), aux_1989);
		  }
		  STRUCT_SET(res1223_746, ((long) 0), aux1224_747);
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_1997;
		     aux_1997 =
			STRUCT_KEY(res1223_746);
		     STRUCT_KEY_SET(aux1224_747, aux_1997);
		  }
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_2000;
		     aux_2000 =
			CNST_TABLE_REF(((long) 1));
		     STRUCT_KEY_SET(res1223_746, aux_2000);
		  }
		  return res1223_746;
	       }
	    }
	 }
      }
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_object_class()
{
   AN_OBJECT;
   {	/* Object/class.scm 14 */
      module_initialization_70_tools_error(((long) 0), "OBJECT_CLASS");
      module_initialization_70_type_type(((long) 0), "OBJECT_CLASS");
      module_initialization_70_type_cache(((long) 0), "OBJECT_CLASS");
      module_initialization_70_type_env(((long) 0), "OBJECT_CLASS");
      module_initialization_70_object_tools(((long) 0), "OBJECT_CLASS");
      module_initialization_70_module_module(((long) 0), "OBJECT_CLASS");
      module_initialization_70_engine_param(((long) 0), "OBJECT_CLASS");
      module_initialization_70_ast_var(((long) 0), "OBJECT_CLASS");
      module_initialization_70_ast_ident(((long) 0), "OBJECT_CLASS");
      return
	 module_initialization_70_tools_location(((long) 0), "OBJECT_CLASS");
   }
}
