/*===========================================================================*/
/*   (Object/generic.scm)                                                    */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct tclass
  {
     obj_t its_super_214;
     obj_t slots;
     struct global *holder;
     obj_t widening;
     long depth;
     bool_t final__12;
     obj_t constructor;
     obj_t virtual_slots_number_200;
  }
      *tclass_bglt;

typedef struct ccomp
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t producer;
     obj_t consumer;
     obj_t finalizer;
     obj_t checksummer;
  }
     *ccomp_bglt;


static obj_t method_init_76_object_generic();
extern obj_t symbol_append_197___r4_symbols_6_4(obj_t);
extern obj_t type_type_type;
extern obj_t mark_symbol_non_user__17_ast_ident(obj_t);
extern obj_t gensym___r4_symbols_6_4;
extern obj_t _obj__252_type_cache;
static obj_t make_generic_non_inlined_body_250_object_generic(obj_t, obj_t, obj_t, obj_t);
extern obj_t user_error_151_tools_error(obj_t, obj_t, obj_t, obj_t);
extern bool_t is_a__118___object(obj_t, obj_t);
static obj_t make_generic_inlined_body_246_object_generic(obj_t, obj_t, obj_t, obj_t);
extern type_bglt get_default_type_181_type_cache();
extern obj_t module_initialization_70_object_generic(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_tools_args(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_ident(long, char *);
extern obj_t module_initialization_70_object_class(long, char *);
extern obj_t module_initialization_70_object_inline(long, char *);
extern obj_t module_initialization_70_module_module(long, char *);
extern obj_t module_initialization_70_tools_location(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_symbols_6_4(long, char *);
extern bool_t method_inlining_enabled__91_object_inline();
static obj_t imported_modules_init_94_object_generic();
static obj_t _make_generic_body1453_118_object_generic(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t append_2_18___r4_pairs_and_lists_6_3(obj_t, obj_t);
static obj_t library_modules_init_112_object_generic();
extern obj_t open_input_string(obj_t);
extern int arity_tools_args(obj_t);
extern obj_t parse_id_241_ast_ident(obj_t, obj_t);
extern obj_t tclass_object_class;
extern obj_t _module__166_module_module;
extern obj_t make_generic_body_233_object_generic(obj_t, obj_t, obj_t, obj_t);
extern obj_t read___reader(obj_t);
extern obj_t find_location_120_tools_location(obj_t);
static obj_t require_initialization_114_object_generic = BUNSPEC;
static obj_t cnst_init_137_object_generic();
static obj_t __cnst[14];

DEFINE_EXPORT_PROCEDURE(make_generic_body_env_40_object_generic, _make_generic_body1453_118_object_generic1461, _make_generic_body1453_118_object_generic, 0L, 4);
DEFINE_STRING(string1456_object_generic, string1456_object_generic1462, "OBJECT? LAMBDA (QUOTE GENERIC-DEFINITION-ERROR) PROCEDURE? IF FIND-METHOD LET -DEFAULT METHOD __R4_PAIRS_AND_LISTS_6_3 CONS* APPLY @ GENERIC-DEFAULT ", 149);
DEFINE_STRING(string1455_object_generic, string1455_object_generic1463, "generic function has a non-class dispatching type arg", 53);
DEFINE_STRING(string1454_object_generic, string1454_object_generic1464, "Illegal generic definition (no formal arguments provided)", 57);



/* module-initialization */
obj_t 
module_initialization_70_object_generic(long checksum_976, char *from_977)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_object_generic))
	{
	   require_initialization_114_object_generic =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_object_generic();
	   cnst_init_137_object_generic();
	   imported_modules_init_94_object_generic();
	   method_init_76_object_generic();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_object_generic()
{
   AN_OBJECT;
   {	/* Object/generic.scm 14 */
      module_initialization_70___r4_symbols_6_4(((long) 0), "OBJECT_GENERIC");
      module_initialization_70___object(((long) 0), "OBJECT_GENERIC");
      module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "OBJECT_GENERIC");
      module_initialization_70___reader(((long) 0), "OBJECT_GENERIC");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_object_generic()
{
   AN_OBJECT;
   {	/* Object/generic.scm 14 */
      {		/* Object/generic.scm 14 */
	 obj_t cnst_port_138_969;
	 cnst_port_138_969 =
	    open_input_string(string1456_object_generic);
	 {
	    long i_970;
	    i_970 = ((long) 13);
	  loop_971:
	    {	/* Object/generic.scm 14 */
	       bool_t test1457_972;
	       test1457_972 =
		  (i_970 == ((long) -1));
	       if (test1457_972)
		 {	/* Object/generic.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Object/generic.scm 14 */
		    {	/* Object/generic.scm 14 */
		       obj_t arg1458_973;
		       {	/* Object/generic.scm 14 */
			  obj_t list1459_974;
			  list1459_974 =
			     MAKE_PAIR(cnst_port_138_969, BNIL);
			  arg1458_973 =
			     read___reader(list1459_974);
		       }
		       CNST_TABLE_SET(i_970, arg1458_973);
		    }
		    {	/* Object/generic.scm 14 */
		       int aux_975;
		       {	/* Object/generic.scm 14 */
			  long aux_995;
			  aux_995 =
			     (i_970 - ((long) 1));
			  aux_975 =
			     (int) (aux_995);
		       }
		       {
			  long i_998;
			  i_998 =
			     (long) (aux_975);
			  i_970 = i_998;
			  goto loop_971;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* make-generic-body */
obj_t 
make_generic_body_233_object_generic(obj_t id_1, obj_t locals_2, obj_t args_3, obj_t src_4)
{
   AN_OBJECT;
   {	/* Object/generic.scm 31 */
      {		/* Object/generic.scm 32 */
	 bool_t test1231_744;
	 test1231_744 =
	    method_inlining_enabled__91_object_inline();
	 if (test1231_744)
	   {	/* Object/generic.scm 32 */
	      return
		 make_generic_inlined_body_246_object_generic(id_1, locals_2, args_3, src_4);
	   }
	 else
	   {	/* Object/generic.scm 32 */
	      return
		 make_generic_non_inlined_body_250_object_generic(id_1, locals_2, args_3, src_4);
	   }
      }
   }
}



/* _make-generic-body1453 */
obj_t 
_make_generic_body1453_118_object_generic(obj_t env_964, obj_t id_965, obj_t locals_966, obj_t args_967, obj_t src_968)
{
   AN_OBJECT;
   {	/* Object/generic.scm 31 */
      return
	 make_generic_body_233_object_generic(id_965, locals_966, args_967, src_968);
   }
}



/* make-generic-non-inlined-body */
obj_t 
make_generic_non_inlined_body_250_object_generic(obj_t id_5, obj_t locals_6, obj_t args_7, obj_t src_8)
{
   AN_OBJECT;
   {	/* Object/generic.scm 39 */
      if (
	 NULLP(args_7))
	{	/* Object/generic.scm 41 */
	   obj_t list1233_413;
	   list1233_413 =
	      MAKE_PAIR(BNIL, BNIL);
	   return
	      user_error_151_tools_error(id_5, string1454_object_generic, src_8, list1233_413);
	}
      else
	{	/* Object/generic.scm 45 */
	   obj_t pid_414;
	   {	/* Object/generic.scm 45 */
	      obj_t arg1373_544;
	      arg1373_544 =
		 find_location_120_tools_location(src_8);
	      pid_414 =
		 parse_id_241_ast_ident(id_5, arg1373_544);
	   }
	   {	/* Object/generic.scm 45 */
	      obj_t id_415;
	      id_415 =
		 CAR(pid_414);
	      {		/* Object/generic.scm 46 */
		 int arity_416;
		 arity_416 =
		    arity_tools_args(args_7);
		 {	/* Object/generic.scm 47 */
		    obj_t args_id_103_417;
		    if (
		       NULLP(locals_6))
		      {		/* Object/generic.scm 48 */
			 args_id_103_417 = BNIL;
		      }
		    else
		      {		/* Object/generic.scm 48 */
			 obj_t head1223_530;
			 {	/* ./Ieee/pair-list.scm 5689 */
			    obj_t aux_1015;
			    {	/* Object/generic.scm 48 */
			       local_bglt obj_749;
			       {	/* Object/generic.scm 48 */
				  obj_t aux_1016;
				  aux_1016 =
				     CAR(locals_6);
				  obj_749 =
				     (local_bglt) (aux_1016);
			       }
			       aux_1015 =
				  (((local_bglt) CREF(obj_749))->id);
			    }
			    head1223_530 =
			       MAKE_PAIR(aux_1015, BNIL);
			 }
			 {
			    obj_t l1221_531;
			    obj_t tail1224_532;
			    l1221_531 =
			       CDR(locals_6);
			    tail1224_532 = head1223_530;
			  lname1222_533:
			    if (
			       NULLP(l1221_531))
			      {		/* Object/generic.scm 48 */
				 args_id_103_417 = head1223_530;
			      }
			    else
			      {		/* Object/generic.scm 48 */
				 obj_t newtail1225_536;
				 {	/* ./Ieee/pair-list.scm 5689 */
				    obj_t aux_1023;
				    {	/* Object/generic.scm 48 */
				       local_bglt obj_755;
				       {	/* Object/generic.scm 48 */
					  obj_t aux_1024;
					  aux_1024 =
					     CAR(l1221_531);
					  obj_755 =
					     (local_bglt) (aux_1024);
				       }
				       aux_1023 =
					  (((local_bglt) CREF(obj_755))->id);
				    }
				    newtail1225_536 =
				       MAKE_PAIR(aux_1023, BNIL);
				 }
				 SET_CDR(tail1224_532, newtail1225_536);
				 {
				    obj_t tail1224_1032;
				    obj_t l1221_1030;
				    l1221_1030 =
				       CDR(l1221_531);
				    tail1224_1032 = newtail1225_536;
				    tail1224_532 = tail1224_1032;
				    l1221_531 = l1221_1030;
				    goto lname1222_533;
				 }
			      }
			 }
		      }
		    {	/* Object/generic.scm 48 */
		       obj_t default_body_201_418;
		       {	/* Object/generic.scm 49 */
			  bool_t test_1034;
			  {	/* ./Ieee/fixnum.scm 7133 */
			     long aux_1035;
			     aux_1035 =
				(long) (arity_416);
			     test_1034 =
				(aux_1035 >= ((long) 0));
			  }
			  if (test_1034)
			    {	/* Object/generic.scm 50 */
			       obj_t arg1325_500;
			       obj_t arg1326_501;
			       {	/* Object/generic.scm 50 */
				  obj_t arg1327_502;
				  obj_t arg1329_503;
				  arg1327_502 =
				     CNST_TABLE_REF(((long) 0));
				  {	/* Object/generic.scm 51 */
				     obj_t arg1330_504;
				     {	/* Object/generic.scm 51 */
					obj_t arg1332_506;
					obj_t arg1333_507;
					arg1332_506 =
					   CNST_TABLE_REF(((long) 1));
					{	/* Object/generic.scm 51 */
					   obj_t arg1334_508;
					   {	/* Object/generic.scm 51 */
					      obj_t obj1_763;
					      obj1_763 = _module__166_module_module;
					      arg1334_508 =
						 MAKE_PAIR(obj1_763, BNIL);
					   }
					   arg1333_507 =
					      MAKE_PAIR(id_415, arg1334_508);
					}
					arg1330_504 =
					   MAKE_PAIR(arg1332_506, arg1333_507);
				     }
				     arg1329_503 =
					MAKE_PAIR(arg1330_504, BNIL);
				  }
				  arg1325_500 =
				     MAKE_PAIR(arg1327_502, arg1329_503);
			       }
			       arg1326_501 =
				  append_2_18___r4_pairs_and_lists_6_3(args_id_103_417, BNIL);
			       default_body_201_418 =
				  MAKE_PAIR(arg1325_500, arg1326_501);
			    }
			  else
			    {	/* Object/generic.scm 53 */
			       obj_t arg1335_509;
			       obj_t arg1336_510;
			       arg1335_509 =
				  CNST_TABLE_REF(((long) 2));
			       {	/* Object/generic.scm 53 */
				  obj_t arg1337_511;
				  obj_t arg1338_512;
				  {	/* Object/generic.scm 53 */
				     obj_t arg1339_513;
				     obj_t arg1340_514;
				     arg1339_513 =
					CNST_TABLE_REF(((long) 0));
				     {	/* Object/generic.scm 54 */
					obj_t arg1342_515;
					{	/* Object/generic.scm 54 */
					   obj_t arg1344_517;
					   obj_t arg1346_518;
					   arg1344_517 =
					      CNST_TABLE_REF(((long) 1));
					   {	/* Object/generic.scm 54 */
					      obj_t arg1347_519;
					      {		/* Object/generic.scm 54 */
						 obj_t obj1_775;
						 obj1_775 = _module__166_module_module;
						 arg1347_519 =
						    MAKE_PAIR(obj1_775, BNIL);
					      }
					      arg1346_518 =
						 MAKE_PAIR(id_415, arg1347_519);
					   }
					   arg1342_515 =
					      MAKE_PAIR(arg1344_517, arg1346_518);
					}
					arg1340_514 =
					   MAKE_PAIR(arg1342_515, BNIL);
				     }
				     arg1337_511 =
					MAKE_PAIR(arg1339_513, arg1340_514);
				  }
				  {	/* Object/generic.scm 55 */
				     obj_t arg1348_520;
				     {	/* Object/generic.scm 55 */
					obj_t arg1354_522;
					obj_t arg1355_523;
					{	/* Object/generic.scm 55 */
					   obj_t arg1356_524;
					   obj_t arg1357_525;
					   arg1356_524 =
					      CNST_TABLE_REF(((long) 1));
					   {	/* Object/generic.scm 55 */
					      obj_t arg1358_526;
					      obj_t arg1359_527;
					      arg1358_526 =
						 CNST_TABLE_REF(((long) 3));
					      {		/* ./Ieee/pair-list.scm 5689 */
						 obj_t aux_1057;
						 aux_1057 =
						    CNST_TABLE_REF(((long) 4));
						 arg1359_527 =
						    MAKE_PAIR(aux_1057, BNIL);
					      }
					      arg1357_525 =
						 MAKE_PAIR(arg1358_526, arg1359_527);
					   }
					   arg1354_522 =
					      MAKE_PAIR(arg1356_524, arg1357_525);
					}
					arg1355_523 =
					   append_2_18___r4_pairs_and_lists_6_3(args_id_103_417, BNIL);
					arg1348_520 =
					   MAKE_PAIR(arg1354_522, arg1355_523);
				     }
				     arg1338_512 =
					MAKE_PAIR(arg1348_520, BNIL);
				  }
				  arg1336_510 =
				     MAKE_PAIR(arg1337_511, arg1338_512);
			       }
			       default_body_201_418 =
				  MAKE_PAIR(arg1335_509, arg1336_510);
			    }
		       }
		       {	/* Object/generic.scm 49 */
			  obj_t method_arg_150_419;
			  method_arg_150_419 =
			     CAR(locals_6);
			  {	/* Object/generic.scm 58 */
			     obj_t method_arg_id_251_420;
			     {	/* Object/generic.scm 59 */
				local_bglt obj_800;
				obj_800 =
				   (local_bglt) (method_arg_150_419);
				method_arg_id_251_420 =
				   (((local_bglt) CREF(obj_800))->id);
			     }
			     {	/* Object/generic.scm 59 */
				type_bglt method_arg_type_249_421;
				{	/* Object/generic.scm 60 */
				   local_bglt obj_801;
				   obj_801 =
				      (local_bglt) (method_arg_150_419);
				   method_arg_type_249_421 =
				      (((local_bglt) CREF(obj_801))->type);
				}
				{	/* Object/generic.scm 60 */
				   obj_t method_422;
				   method_422 =
				      PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4,
				      CNST_TABLE_REF(((long) 5)), BEOA);
				   {	/* Object/generic.scm 61 */
				      obj_t default_name_11_423;
				      {		/* Object/generic.scm 63 */
					 obj_t arg1320_496;
					 {	/* Object/generic.scm 63 */
					    obj_t list1321_497;
					    {	/* Object/generic.scm 63 */
					       obj_t arg1322_498;
					       {	/* Object/generic.scm 63 */
						  obj_t aux_1075;
						  aux_1075 =
						     CNST_TABLE_REF(((long) 6));
						  arg1322_498 =
						     MAKE_PAIR(aux_1075, BNIL);
					       }
					       list1321_497 =
						  MAKE_PAIR(id_415, arg1322_498);
					    }
					    arg1320_496 =
					       symbol_append_197___r4_symbols_6_4(list1321_497);
					 }
					 default_name_11_423 =
					    mark_symbol_non_user__17_ast_ident(arg1320_496);
				      }
				      {		/* Object/generic.scm 62 */
					 obj_t method_name_182_424;
					 method_name_182_424 =
					    PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4,
					    CNST_TABLE_REF(((long) 5)), BEOA);
					 {	/* Object/generic.scm 64 */
					    obj_t app_ly_method_58_425;
					    {	/* Object/generic.scm 65 */
					       obj_t arg1271_458;
					       obj_t arg1272_459;
					       arg1271_458 =
						  CNST_TABLE_REF(((long) 7));
					       {	/* Object/generic.scm 65 */
						  obj_t arg1273_460;
						  obj_t arg1274_461;
						  {	/* Object/generic.scm 65 */
						     obj_t arg1276_462;
						     {	/* Object/generic.scm 65 */
							obj_t arg1278_464;
							{	/* Object/generic.scm 65 */
							   obj_t arg1280_465;
							   {	/* Object/generic.scm 65 */
							      obj_t arg1282_467;
							      obj_t arg1286_468;
							      arg1282_467 =
								 CNST_TABLE_REF(((long) 8));
							      {		/* Object/generic.scm 66 */
								 obj_t arg1287_469;
								 {	/* Object/generic.scm 66 */
								    obj_t arg1289_470;
								    {	/* Object/generic.scm 66 */
								       obj_t arg1291_472;
								       obj_t arg1292_473;
								       arg1291_472 =
									  CNST_TABLE_REF(((long) 1));
								       {	/* Object/generic.scm 66 */
									  obj_t arg1293_474;
									  {	/* Object/generic.scm 66 */
									     obj_t obj1_802;
									     obj1_802 = _module__166_module_module;
									     arg1293_474 =
										MAKE_PAIR(obj1_802, BNIL);
									  }
									  arg1292_473 =
									     MAKE_PAIR(id_415, arg1293_474);
								       }
								       arg1289_470 =
									  MAKE_PAIR(arg1291_472, arg1292_473);
								    }
								    arg1287_469 =
								       MAKE_PAIR(arg1289_470, BNIL);
								 }
								 arg1286_468 =
								    MAKE_PAIR(method_arg_id_251_420, arg1287_469);
							      }
							      arg1280_465 =
								 MAKE_PAIR(arg1282_467, arg1286_468);
							   }
							   arg1278_464 =
							      MAKE_PAIR(arg1280_465, BNIL);
							}
							arg1276_462 =
							   MAKE_PAIR(method_422, arg1278_464);
						     }
						     arg1273_460 =
							MAKE_PAIR(arg1276_462, BNIL);
						  }
						  {	/* Object/generic.scm 68 */
						     obj_t arg1294_475;
						     {	/* Object/generic.scm 68 */
							obj_t arg1296_477;
							obj_t arg1297_478;
							arg1296_477 =
							   CNST_TABLE_REF(((long) 9));
							{	/* Object/generic.scm 68 */
							   obj_t arg1298_479;
							   obj_t arg1299_480;
							   {	/* Object/generic.scm 68 */
							      obj_t arg1300_481;
							      obj_t arg1301_482;
							      arg1300_481 =
								 CNST_TABLE_REF(((long) 10));
							      arg1301_482 =
								 MAKE_PAIR(method_422, BNIL);
							      arg1298_479 =
								 MAKE_PAIR(arg1300_481, arg1301_482);
							   }
							   {	/* Object/generic.scm 69 */
							      obj_t arg1302_483;
							      obj_t arg1303_484;
							      {		/* Object/generic.scm 69 */
								 bool_t test_1100;
								 {	/* ./Ieee/fixnum.scm 7133 */
								    long aux_1101;
								    aux_1101 =
								       (long) (arity_416);
								    test_1100 =
								       (aux_1101 >= ((long) 0));
								 }
								 if (test_1100)
								   {	/* ./Ieee/pair-list.scm 5689 */
								      obj_t aux_1104;
								      aux_1104 =
									 append_2_18___r4_pairs_and_lists_6_3(args_id_103_417, BNIL);
								      arg1302_483 =
									 MAKE_PAIR(method_422, aux_1104);
								   }
								 else
								   {	/* Object/generic.scm 71 */
								      obj_t arg1307_487;
								      obj_t arg1308_488;
								      arg1307_487 =
									 CNST_TABLE_REF(((long) 2));
								      {		/* Object/generic.scm 71 */
									 obj_t arg1309_489;
									 {	/* Object/generic.scm 71 */
									    obj_t arg1313_490;
									    {	/* ./Ieee/pair-list.scm 5689 */
									       obj_t aux_1110;
									       obj_t aux_1108;
									       aux_1110 =
										  append_2_18___r4_pairs_and_lists_6_3(args_id_103_417, BNIL);
									       aux_1108 =
										  CNST_TABLE_REF(((long) 3));
									       arg1313_490 =
										  MAKE_PAIR(aux_1108, aux_1110);
									    }
									    arg1309_489 =
									       MAKE_PAIR(arg1313_490, BNIL);
									 }
									 arg1308_488 =
									    MAKE_PAIR(method_422, arg1309_489);
								      }
								      arg1302_483 =
									 MAKE_PAIR(arg1307_487, arg1308_488);
								   }
							      }
							      {		/* Object/generic.scm 72 */
								 obj_t arg1318_494;
								 arg1318_494 =
								    MAKE_PAIR(default_name_11_423, BNIL);
								 arg1303_484 =
								    MAKE_PAIR(arg1318_494, BNIL);
							      }
							      arg1299_480 =
								 MAKE_PAIR(arg1302_483, arg1303_484);
							   }
							   arg1297_478 =
							      MAKE_PAIR(arg1298_479, arg1299_480);
							}
							arg1294_475 =
							   MAKE_PAIR(arg1296_477, arg1297_478);
						     }
						     arg1274_461 =
							MAKE_PAIR(arg1294_475, BNIL);
						  }
						  arg1272_459 =
						     MAKE_PAIR(arg1273_460, arg1274_461);
					       }
					       app_ly_method_58_425 =
						  MAKE_PAIR(arg1271_458, arg1272_459);
					    }
					    {	/* Object/generic.scm 65 */

					       {	/* Object/generic.scm 74 */
						  bool_t test1234_426;
						  {	/* Object/generic.scm 74 */
						     bool_t test1266_453;
						     test1266_453 =
							is_a__118___object(
							(obj_t) (method_arg_type_249_421), type_type_type);
						     if (test1266_453)
						       {	/* Object/generic.scm 75 */
							  bool_t test1267_454;
							  {	/* Object/generic.scm 75 */
							     obj_t obj2_854;
							     obj2_854 = _obj__252_type_cache;
							     {	/* ./Ieee/equiv.scm 5508 */
								obj_t aux_1127;
								aux_1127 =
								   (obj_t) (method_arg_type_249_421);
								test1267_454 =
								   (aux_1127 == obj2_854);
							     }
							  }
							  if (test1267_454)
							    {	/* Object/generic.scm 75 */
							       test1234_426 = ((bool_t) 0);
							    }
							  else
							    {	/* Object/generic.scm 76 */
							       bool_t test1268_455;
							       {	/* Object/generic.scm 76 */
								  type_bglt arg1270_457;
								  arg1270_457 =
								     get_default_type_181_type_cache();
								  {	/* ./Ieee/equiv.scm 5508 */
								     obj_t aux_1134;
								     obj_t aux_1132;
								     aux_1134 =
									(obj_t) (arg1270_457);
								     aux_1132 =
									(obj_t) (method_arg_type_249_421);
								     test1268_455 =
									(aux_1132 == aux_1134);
								  }
							       }
							       if (test1268_455)
								 {	/* Object/generic.scm 76 */
								    test1234_426 = ((bool_t) 0);
								 }
							       else
								 {	/* Object/generic.scm 77 */
								    bool_t test1269_456;
								    test1269_456 =
								       is_a__118___object(
								       (obj_t) (method_arg_type_249_421), tclass_object_class);
								    if (test1269_456)
								      {		/* Object/generic.scm 77 */
									 test1234_426 = ((bool_t) 0);
								      }
								    else
								      {		/* Object/generic.scm 77 */
									 test1234_426 = ((bool_t) 1);
								      }
								 }
							    }
						       }
						     else
						       {	/* Object/generic.scm 74 */
							  test1234_426 = ((bool_t) 0);
						       }
						  }
						  if (test1234_426)
						    {	/* Object/generic.scm 78 */
						       obj_t list1235_427;
						       {	/* Object/generic.scm 78 */
							  obj_t aux_1142;
							  aux_1142 =
							     CNST_TABLE_REF(((long) 11));
							  list1235_427 =
							     MAKE_PAIR(aux_1142, BNIL);
						       }
						       return
							  user_error_151_tools_error(id_415, string1455_object_generic, src_8, list1235_427);
						    }
						  else
						    {	/* Object/generic.scm 84 */
						       obj_t arg1236_428;
						       obj_t arg1237_429;
						       arg1236_428 =
							  CNST_TABLE_REF(((long) 7));
						       {	/* Object/generic.scm 84 */
							  obj_t arg1238_430;
							  obj_t arg1240_431;
							  {	/* Object/generic.scm 84 */
							     obj_t arg1241_432;
							     {	/* Object/generic.scm 84 */
								obj_t arg1245_434;
								{	/* Object/generic.scm 84 */
								   obj_t arg1246_435;
								   {	/* Object/generic.scm 84 */
								      obj_t arg1249_437;
								      obj_t arg1250_438;
								      arg1249_437 =
									 CNST_TABLE_REF(((long) 12));
								      {		/* Object/generic.scm 84 */
									 obj_t arg1252_440;
									 arg1252_440 =
									    MAKE_PAIR(default_body_201_418, BNIL);
									 arg1250_438 =
									    MAKE_PAIR(BNIL, arg1252_440);
								      }
								      arg1246_435 =
									 MAKE_PAIR(arg1249_437, arg1250_438);
								   }
								   arg1245_434 =
								      MAKE_PAIR(arg1246_435, BNIL);
								}
								arg1241_432 =
								   MAKE_PAIR(default_name_11_423, arg1245_434);
							     }
							     arg1238_430 =
								MAKE_PAIR(arg1241_432, BNIL);
							  }
							  {	/* Object/generic.scm 85 */
							     obj_t arg1253_441;
							     {	/* Object/generic.scm 85 */
								bool_t test1255_443;
								test1255_443 =
								   is_a__118___object(
								   (obj_t) (method_arg_type_249_421), tclass_object_class);
								if (test1255_443)
								  {	/* Object/generic.scm 85 */
								     arg1253_441 = app_ly_method_58_425;
								  }
								else
								  {	/* Object/generic.scm 87 */
								     obj_t arg1256_444;
								     obj_t arg1257_445;
								     arg1256_444 =
									CNST_TABLE_REF(((long) 9));
								     {	/* Object/generic.scm 87 */
									obj_t arg1258_446;
									obj_t arg1259_447;
									{	/* Object/generic.scm 87 */
									   obj_t arg1260_448;
									   obj_t arg1261_449;
									   arg1260_448 =
									      CNST_TABLE_REF(((long) 13));
									   arg1261_449 =
									      MAKE_PAIR(method_arg_id_251_420, BNIL);
									   arg1258_446 =
									      MAKE_PAIR(arg1260_448, arg1261_449);
									}
									{	/* Object/generic.scm 89 */
									   obj_t arg1263_450;
									   {	/* Object/generic.scm 89 */
									      obj_t arg1264_451;
									      arg1264_451 =
										 MAKE_PAIR(default_name_11_423, BNIL);
									      arg1263_450 =
										 MAKE_PAIR(arg1264_451, BNIL);
									   }
									   arg1259_447 =
									      MAKE_PAIR(app_ly_method_58_425, arg1263_450);
									}
									arg1257_445 =
									   MAKE_PAIR(arg1258_446, arg1259_447);
								     }
								     arg1253_441 =
									MAKE_PAIR(arg1256_444, arg1257_445);
								  }
							     }
							     arg1240_431 =
								MAKE_PAIR(arg1253_441, BNIL);
							  }
							  arg1237_429 =
							     MAKE_PAIR(arg1238_430, arg1240_431);
						       }
						       return
							  MAKE_PAIR(arg1236_428, arg1237_429);
						    }
					       }
					    }
					 }
				      }
				   }
				}
			     }
			  }
		       }
		    }
		 }
	      }
	   }
	}
   }
}



/* make-generic-inlined-body */
obj_t 
make_generic_inlined_body_246_object_generic(obj_t id_9, obj_t locals_10, obj_t args_11, obj_t src_12)
{
   AN_OBJECT;
   {	/* Object/generic.scm 94 */
      {		/* Object/generic.scm 95 */
	 obj_t pid_545;
	 {	/* Object/generic.scm 95 */
	    obj_t arg1419_591;
	    arg1419_591 =
	       find_location_120_tools_location(src_12);
	    pid_545 =
	       parse_id_241_ast_ident(id_9, arg1419_591);
	 }
	 {	/* Object/generic.scm 95 */
	    obj_t id_546;
	    id_546 =
	       CAR(pid_545);
	    {	/* Object/generic.scm 96 */
	       int arity_547;
	       arity_547 =
		  arity_tools_args(args_11);
	       {	/* Object/generic.scm 97 */
		  obj_t args_id_103_548;
		  if (
		     NULLP(locals_10))
		    {	/* Object/generic.scm 98 */
		       args_id_103_548 = BNIL;
		    }
		  else
		    {	/* Object/generic.scm 98 */
		       obj_t head1228_577;
		       {	/* ./Ieee/pair-list.scm 5689 */
			  obj_t aux_1175;
			  {	/* Object/generic.scm 98 */
			     local_bglt obj_894;
			     {	/* Object/generic.scm 98 */
				obj_t aux_1176;
				aux_1176 =
				   CAR(locals_10);
				obj_894 =
				   (local_bglt) (aux_1176);
			     }
			     aux_1175 =
				(((local_bglt) CREF(obj_894))->id);
			  }
			  head1228_577 =
			     MAKE_PAIR(aux_1175, BNIL);
		       }
		       {
			  obj_t l1226_578;
			  obj_t tail1229_579;
			  l1226_578 =
			     CDR(locals_10);
			  tail1229_579 = head1228_577;
			lname1227_580:
			  if (
			     NULLP(l1226_578))
			    {	/* Object/generic.scm 98 */
			       args_id_103_548 = head1228_577;
			    }
			  else
			    {	/* Object/generic.scm 98 */
			       obj_t newtail1230_583;
			       {	/* ./Ieee/pair-list.scm 5689 */
				  obj_t aux_1183;
				  {	/* Object/generic.scm 98 */
				     local_bglt obj_900;
				     {	/* Object/generic.scm 98 */
					obj_t aux_1184;
					aux_1184 =
					   CAR(l1226_578);
					obj_900 =
					   (local_bglt) (aux_1184);
				     }
				     aux_1183 =
					(((local_bglt) CREF(obj_900))->id);
				  }
				  newtail1230_583 =
				     MAKE_PAIR(aux_1183, BNIL);
			       }
			       SET_CDR(tail1229_579, newtail1230_583);
			       {
				  obj_t tail1229_1192;
				  obj_t l1226_1190;
				  l1226_1190 =
				     CDR(l1226_578);
				  tail1229_1192 = newtail1230_583;
				  tail1229_579 = tail1229_1192;
				  l1226_578 = l1226_1190;
				  goto lname1227_580;
			       }
			    }
		       }
		    }
		  {	/* Object/generic.scm 98 */
		     obj_t body_549;
		     {	/* Object/generic.scm 99 */
			bool_t test_1194;
			{	/* ./Ieee/fixnum.scm 7133 */
			   long aux_1195;
			   aux_1195 =
			      (long) (arity_547);
			   test_1194 =
			      (aux_1195 >= ((long) 0));
			}
			if (test_1194)
			  {	/* Object/generic.scm 100 */
			     obj_t arg1375_551;
			     obj_t arg1376_552;
			     {	/* Object/generic.scm 100 */
				obj_t arg1377_553;
				obj_t arg1378_554;
				arg1377_553 =
				   CNST_TABLE_REF(((long) 0));
				{	/* Object/generic.scm 100 */
				   obj_t arg1379_555;
				   {	/* Object/generic.scm 100 */
				      obj_t arg1381_557;
				      obj_t arg1383_558;
				      arg1381_557 =
					 CNST_TABLE_REF(((long) 1));
				      {		/* Object/generic.scm 100 */
					 obj_t arg1384_559;
					 {	/* Object/generic.scm 100 */
					    obj_t obj1_908;
					    obj1_908 = _module__166_module_module;
					    arg1384_559 =
					       MAKE_PAIR(obj1_908, BNIL);
					 }
					 arg1383_558 =
					    MAKE_PAIR(id_546, arg1384_559);
				      }
				      arg1379_555 =
					 MAKE_PAIR(arg1381_557, arg1383_558);
				   }
				   arg1378_554 =
				      MAKE_PAIR(arg1379_555, BNIL);
				}
				arg1375_551 =
				   MAKE_PAIR(arg1377_553, arg1378_554);
			     }
			     arg1376_552 =
				append_2_18___r4_pairs_and_lists_6_3(args_id_103_548, BNIL);
			     body_549 =
				MAKE_PAIR(arg1375_551, arg1376_552);
			  }
			else
			  {	/* Object/generic.scm 101 */
			     obj_t arg1385_560;
			     obj_t arg1387_561;
			     arg1385_560 =
				CNST_TABLE_REF(((long) 2));
			     {	/* Object/generic.scm 101 */
				obj_t arg1389_562;
				obj_t arg1390_563;
				{	/* Object/generic.scm 101 */
				   obj_t arg1391_564;
				   obj_t arg1393_565;
				   arg1391_564 =
				      CNST_TABLE_REF(((long) 0));
				   {	/* Object/generic.scm 101 */
				      obj_t arg1394_566;
				      {		/* Object/generic.scm 101 */
					 obj_t arg1397_568;
					 obj_t arg1398_569;
					 arg1397_568 =
					    CNST_TABLE_REF(((long) 1));
					 {	/* Object/generic.scm 101 */
					    obj_t arg1399_570;
					    {	/* Object/generic.scm 101 */
					       obj_t obj1_920;
					       obj1_920 = _module__166_module_module;
					       arg1399_570 =
						  MAKE_PAIR(obj1_920, BNIL);
					    }
					    arg1398_569 =
					       MAKE_PAIR(id_546, arg1399_570);
					 }
					 arg1394_566 =
					    MAKE_PAIR(arg1397_568, arg1398_569);
				      }
				      arg1393_565 =
					 MAKE_PAIR(arg1394_566, BNIL);
				   }
				   arg1389_562 =
				      MAKE_PAIR(arg1391_564, arg1393_565);
				}
				{	/* Object/generic.scm 102 */
				   obj_t arg1400_571;
				   {	/* ./Ieee/pair-list.scm 5689 */
				      obj_t aux_1217;
				      obj_t aux_1215;
				      aux_1217 =
					 append_2_18___r4_pairs_and_lists_6_3(args_id_103_548, BNIL);
				      aux_1215 =
					 CNST_TABLE_REF(((long) 3));
				      arg1400_571 =
					 MAKE_PAIR(aux_1215, aux_1217);
				   }
				   arg1390_563 =
				      MAKE_PAIR(arg1400_571, BNIL);
				}
				arg1387_561 =
				   MAKE_PAIR(arg1389_562, arg1390_563);
			     }
			     body_549 =
				MAKE_PAIR(arg1385_560, arg1387_561);
			  }
		     }
		     {	/* Object/generic.scm 99 */

			return body_549;
		     }
		  }
	       }
	    }
	 }
      }
   }
}



/* method-init */
obj_t 
method_init_76_object_generic()
{
   AN_OBJECT;
   {	/* Object/generic.scm 14 */
      return BUNSPEC;
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_object_generic()
{
   AN_OBJECT;
   {	/* Object/generic.scm 14 */
      module_initialization_70_engine_param(((long) 0), "OBJECT_GENERIC");
      module_initialization_70_tools_args(((long) 0), "OBJECT_GENERIC");
      module_initialization_70_tools_error(((long) 0), "OBJECT_GENERIC");
      module_initialization_70_type_type(((long) 0), "OBJECT_GENERIC");
      module_initialization_70_type_cache(((long) 0), "OBJECT_GENERIC");
      module_initialization_70_ast_var(((long) 0), "OBJECT_GENERIC");
      module_initialization_70_ast_ident(((long) 0), "OBJECT_GENERIC");
      module_initialization_70_object_class(((long) 0), "OBJECT_GENERIC");
      module_initialization_70_object_inline(((long) 0), "OBJECT_GENERIC");
      module_initialization_70_module_module(((long) 0), "OBJECT_GENERIC");
      return
	 module_initialization_70_tools_location(((long) 0), "OBJECT_GENERIC");
   }
}
