/*===========================================================================*/
/*   (Object/inline.scm)                                                     */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;

typedef struct tclass
  {
     obj_t its_super_214;
     obj_t slots;
     struct global *holder;
     obj_t widening;
     long depth;
     bool_t final__12;
     obj_t constructor;
     obj_t virtual_slots_number_200;
  }
      *tclass_bglt;


static obj_t method_init_76_object_inline();
extern long add_generic_method__111_object_inline(global_bglt, type_bglt, obj_t, obj_t);
extern obj_t inline_methods__72_object_inline();
static obj_t _intern_generic__171_object_inline = BUNSPEC;
static obj_t make_case_clauses_101_object_inline(obj_t, obj_t);
extern obj_t create_struct(obj_t, long);
extern obj_t gensym___r4_symbols_6_4;
static obj_t _method_inlining_enabled__235_object_inline(obj_t);
extern obj_t args___args_list_50_tools_args(obj_t);
extern obj_t notify_assert_fail_37___eval(obj_t, obj_t, obj_t);
extern obj_t verbose_tools_speek(obj_t, obj_t);
extern bool_t is_a__118___object(obj_t, obj_t);
static obj_t disable_method_inlining__113_object_inline();
extern obj_t module_initialization_70_object_inline(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_speek(long, char *);
extern obj_t module_initialization_70_tools_args(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_expand_eps(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_ast_sexp(long, char *);
extern obj_t module_initialization_70_object_class(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___eval(long, char *);
extern obj_t module_initialization_70___evenv(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_symbols_6_4(long, char *);
static obj_t _inline_methods__227_object_inline(obj_t);
extern bool_t method_inlining_enabled__91_object_inline();
extern obj_t define_primop_ref__105___evenv(obj_t, obj_t);
static obj_t imported_modules_init_94_object_inline();
extern obj_t unbind_primop__163___evenv(obj_t);
static obj_t inline_method_clause_150_object_inline(obj_t, obj_t);
static obj_t _add_generic_for_method_inlining__161_object_inline(obj_t, obj_t);
extern obj_t _optim_inline_method___30_engine_param;
extern obj_t append_2_18___r4_pairs_and_lists_6_3(obj_t, obj_t);
static obj_t library_modules_init_112_object_inline();
extern obj_t assq___r4_pairs_and_lists_6_3(obj_t, obj_t);
static obj_t toplevel_init_63_object_inline();
extern node_bglt sexp__node_235_ast_sexp(obj_t, obj_t, obj_t, obj_t);
extern obj_t open_input_string(obj_t);
extern obj_t comptime_expand_37_expand_eps(obj_t);
extern obj_t tclass_object_class;
extern obj_t add_generic_for_method_inlining__147_object_inline(obj_t);
static obj_t _add_generic_method_1776_119_object_inline(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t inline_method__105_object_inline(obj_t);
extern obj_t read___reader(obj_t);
static obj_t require_initialization_114_object_inline = BUNSPEC;
static obj_t cnst_init_137_object_inline();
extern obj_t reverse__39___r4_pairs_and_lists_6_3(obj_t);
static obj_t __cnst[31];

DEFINE_EXPORT_PROCEDURE(add_generic_for_method_inlining__env_177_object_inline, _add_generic_for_method_inlining__161_object_inline1783, _add_generic_for_method_inlining__161_object_inline, 0L, 1);
DEFINE_EXPORT_PROCEDURE(add_generic_method__env_190_object_inline, _add_generic_method_1776_119_object_inline1784, _add_generic_method_1776_119_object_inline, 0L, 4);
DEFINE_EXPORT_PROCEDURE(inline_methods__env_13_object_inline, _inline_methods__227_object_inline1785, _inline_methods__227_object_inline, 0L, 0);
DEFINE_EXPORT_PROCEDURE(method_inlining_enabled__env_87_object_inline, _method_inlining_enabled__235_object_inline1786, _method_inlining_enabled__235_object_inline, 0L, 0);
DEFINE_STRING(string1778_object_inline, string1778_object_inline1787, "VALUE OBJECT? OBJECT-CLASS FIND-INLINE-METHOD ELSE CASE CAR CDR FIND-METHOD-FROM CLASS-SUPER CLASS? LET* CALL-NEXT-METHOD LET LAMBDA LETREC CLASS CONS* APPLY PROCEDURE? IF LARG AUX SUPER LOOP METHOD IMETHOD (\"/home/tahoe2/serrano/tmp/bigloo/comptime/Object/inline.scm\" . 4617) (BEGIN (PAIR? CELL)) (CELL) CELL ", 310);
DEFINE_STRING(string1777_object_inline, string1777_object_inline1788, "   . Method inlining", 20);



/* module-initialization */
obj_t 
module_initialization_70_object_inline(long checksum_1763, char *from_1764)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_object_inline))
	{
	   require_initialization_114_object_inline =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_object_inline();
	   cnst_init_137_object_inline();
	   imported_modules_init_94_object_inline();
	   method_init_76_object_inline();
	   toplevel_init_63_object_inline();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_object_inline()
{
   AN_OBJECT;
   {	/* Object/inline.scm 33 */
      module_initialization_70___r4_symbols_6_4(((long) 0), "OBJECT_INLINE");
      module_initialization_70___eval(((long) 0), "OBJECT_INLINE");
      module_initialization_70___object(((long) 0), "OBJECT_INLINE");
      module_initialization_70___evenv(((long) 0), "OBJECT_INLINE");
      module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "OBJECT_INLINE");
      module_initialization_70___reader(((long) 0), "OBJECT_INLINE");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_object_inline()
{
   AN_OBJECT;
   {	/* Object/inline.scm 33 */
      {		/* Object/inline.scm 33 */
	 obj_t cnst_port_138_1756;
	 cnst_port_138_1756 =
	    open_input_string(string1778_object_inline);
	 {
	    long i_1757;
	    i_1757 = ((long) 30);
	  loop_1758:
	    {	/* Object/inline.scm 33 */
	       bool_t test1779_1759;
	       test1779_1759 =
		  (i_1757 == ((long) -1));
	       if (test1779_1759)
		 {	/* Object/inline.scm 33 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Object/inline.scm 33 */
		    {	/* Object/inline.scm 33 */
		       obj_t arg1780_1760;
		       {	/* Object/inline.scm 33 */
			  obj_t list1781_1761;
			  list1781_1761 =
			     MAKE_PAIR(cnst_port_138_1756, BNIL);
			  arg1780_1760 =
			     read___reader(list1781_1761);
		       }
		       CNST_TABLE_SET(i_1757, arg1780_1760);
		    }
		    {	/* Object/inline.scm 33 */
		       int aux_1762;
		       {	/* Object/inline.scm 33 */
			  long aux_1785;
			  aux_1785 =
			     (i_1757 - ((long) 1));
			  aux_1762 =
			     (int) (aux_1785);
		       }
		       {
			  long i_1788;
			  i_1788 =
			     (long) (aux_1762);
			  i_1757 = i_1788;
			  goto loop_1758;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_object_inline()
{
   AN_OBJECT;
   {	/* Object/inline.scm 33 */
      _intern_generic__171_object_inline = BNIL;
      return BUNSPEC;
   }
}



/* method-inlining-enabled? */
bool_t 
method_inlining_enabled__91_object_inline()
{
   AN_OBJECT;
   {	/* Object/inline.scm 53 */
      return
	 CBOOL(_optim_inline_method___30_engine_param);
   }
}



/* _method-inlining-enabled? */
obj_t 
_method_inlining_enabled__235_object_inline(obj_t env_1746)
{
   AN_OBJECT;
   {	/* Object/inline.scm 53 */
      {		/* Object/inline.scm 53 */
	 bool_t aux_1791;
	 aux_1791 =
	    method_inlining_enabled__91_object_inline();
	 return
	    BBOOL(aux_1791);
      }
   }
}



/* disable-method-inlining! */
obj_t 
disable_method_inlining__113_object_inline()
{
   AN_OBJECT;
   {	/* Object/inline.scm 59 */
      _intern_generic__171_object_inline = BNIL;
      return (
	 _optim_inline_method___30_engine_param = BFALSE, BUNSPEC);
   }
}



/* add-generic-for-method-inlining! */
obj_t 
add_generic_for_method_inlining__147_object_inline(obj_t generic_1)
{
   AN_OBJECT;
   {	/* Object/inline.scm 66 */
      {		/* Object/inline.scm 67 */
	 bool_t test1479_803;
	 {	/* Object/inline.scm 67 */
	    bool_t test1482_806;
	    {	/* Object/inline.scm 67 */
	       bool_t res1774_1389;
	       res1774_1389 =
		  CBOOL(_optim_inline_method___30_engine_param);
	       test1482_806 = res1774_1389;
	    }
	    if (test1482_806)
	      {		/* Object/inline.scm 68 */
		 bool_t test1483_807;
		 {	/* Object/inline.scm 68 */
		    obj_t arg1484_808;
		    arg1484_808 =
		       assq___r4_pairs_and_lists_6_3(generic_1, _intern_generic__171_object_inline);
		    test1483_807 =
		       PAIRP(arg1484_808);
		 }
		 if (test1483_807)
		   {	/* Object/inline.scm 68 */
		      test1479_803 = ((bool_t) 0);
		   }
		 else
		   {	/* Object/inline.scm 68 */
		      test1479_803 = ((bool_t) 1);
		   }
	      }
	    else
	      {		/* Object/inline.scm 67 */
		 test1479_803 = ((bool_t) 0);
	      }
	 }
	 if (test1479_803)
	   {	/* Object/inline.scm 69 */
	      obj_t arg1480_804;
	      {		/* Object/inline.scm 69 */
		 obj_t arg1481_805;
		 {	/* ./Ieee/pair-list.scm 5689 */
		    obj_t aux_1800;
		    aux_1800 =
		       BINT(((long) 0));
		    arg1481_805 =
		       MAKE_PAIR(aux_1800, BNIL);
		 }
		 arg1480_804 =
		    MAKE_PAIR(generic_1, arg1481_805);
	      }
	      {		/* Object/inline.scm 69 */
		 obj_t obj2_1396;
		 obj2_1396 = _intern_generic__171_object_inline;
		 return (
		    _intern_generic__171_object_inline =
		    MAKE_PAIR(arg1480_804, obj2_1396), BUNSPEC);
	      }
	   }
	 else
	   {	/* Object/inline.scm 67 */
	      return BUNSPEC;
	   }
      }
   }
}



/* _add-generic-for-method-inlining! */
obj_t 
_add_generic_for_method_inlining__161_object_inline(obj_t env_1747, obj_t generic_1748)
{
   AN_OBJECT;
   {	/* Object/inline.scm 66 */
      return
	 add_generic_for_method_inlining__147_object_inline(generic_1748);
   }
}



/* add-generic-method! */
long 
add_generic_method__111_object_inline(global_bglt generic_16, type_bglt type_17, obj_t args_18, obj_t body_19)
{
   AN_OBJECT;
   {	/* Object/inline.scm 85 */
      {		/* Object/inline.scm 86 */
	 obj_t cell_819;
	 cell_819 =
	    assq___r4_pairs_and_lists_6_3(
	    (obj_t) (generic_16), _intern_generic__171_object_inline);
	 if (
	    PAIRP(cell_819))
	   {	/* Object/inline.scm 87 */
	      BUNSPEC;
	   }
	 else
	   {	/* Object/inline.scm 87 */
	      {		/* Object/inline.scm 87 */
		 obj_t arg1496_821;
		 obj_t arg1497_822;
		 arg1496_821 =
		    CNST_TABLE_REF(((long) 0));
		 arg1497_822 =
		    __EVMEANING_ADDRESS(cell_819);
		 define_primop_ref__105___evenv(arg1496_821, arg1497_822);
	      }
	      notify_assert_fail_37___eval(
		 CNST_TABLE_REF(((long) 1)),
		 CNST_TABLE_REF(((long) 2)),
		 CNST_TABLE_REF(((long) 3)));
	      unbind_primop__163___evenv(
		 CNST_TABLE_REF(((long) 0)));
	   }
	 {	/* Object/inline.scm 88 */
	    obj_t num_823;
	    {	/* ./Ieee/pair-list.scm 5701 */
	       obj_t aux_1819;
	       aux_1819 =
		  CDR(cell_819);
	       num_823 =
		  CAR(aux_1819);
	    }
	    {	/* ./Ieee/pair-list.scm 5890 */
	       obj_t aux_1824;
	       obj_t aux_1822;
	       {	/* Object/inline.scm 89 */
		  long aux_1825;
		  {	/* ./Ieee/fixnum.scm 7193 */
		     long aux_1826;
		     aux_1826 =
			(long) CINT(num_823);
		     aux_1825 =
			(aux_1826 + ((long) 1));
		  }
		  aux_1824 =
		     BINT(aux_1825);
	       }
	       aux_1822 =
		  CDR(cell_819);
	       SET_CAR(aux_1822, aux_1824);
	    }
	    {	/* Object/inline.scm 90 */
	       obj_t arg1500_826;
	       obj_t arg1501_827;
	       arg1500_826 =
		  CDR(cell_819);
	       {	/* Object/inline.scm 90 */
		  obj_t arg1502_828;
		  obj_t arg1503_829;
		  {	/* Object/inline.scm 80 */
		     obj_t new_1442;
		     {	/* Object/inline.scm 80 */
			obj_t aux_1832;
			aux_1832 =
			   CNST_TABLE_REF(((long) 4));
			new_1442 =
			   create_struct(aux_1832, ((long) 3));
		     }
		     STRUCT_SET(new_1442, ((long) 2), num_823);
		     STRUCT_SET(new_1442, ((long) 1), body_19);
		     STRUCT_SET(new_1442, ((long) 0), args_18);
		     arg1502_828 = new_1442;
		  }
		  {	/* ./Ieee/pair-list.scm 5707 */
		     obj_t aux_1838;
		     aux_1838 =
			CDR(cell_819);
		     arg1503_829 =
			CDR(aux_1838);
		  }
		  arg1501_827 =
		     MAKE_PAIR(arg1502_828, arg1503_829);
	       }
	       SET_CDR(arg1500_826, arg1501_827);
	    }
	    return
	       (long) CINT(num_823);
	 }
      }
   }
}



/* _add-generic-method!1776 */
obj_t 
_add_generic_method_1776_119_object_inline(obj_t env_1749, obj_t generic_1750, obj_t type_1751, obj_t args_1752, obj_t body_1753)
{
   AN_OBJECT;
   {	/* Object/inline.scm 85 */
      {		/* Object/inline.scm 85 */
	 long aux_1844;
	 aux_1844 =
	    add_generic_method__111_object_inline(
	    (global_bglt) (generic_1750),
	    (type_bglt) (type_1751), args_1752, body_1753);
	 return
	    BINT(aux_1844);
      }
   }
}



/* inline-methods! */
obj_t 
inline_methods__72_object_inline()
{
   AN_OBJECT;
   {	/* Object/inline.scm 96 */
      {		/* Object/inline.scm 97 */
	 bool_t test1504_830;
	 {	/* Object/inline.scm 97 */
	    bool_t test1512_839;
	    {	/* Object/inline.scm 97 */
	       bool_t res1775_1466;
	       res1775_1466 =
		  CBOOL(_optim_inline_method___30_engine_param);
	       test1512_839 = res1775_1466;
	    }
	    if (test1512_839)
	      {		/* Object/inline.scm 97 */
		 obj_t obj_1467;
		 obj_1467 = _intern_generic__171_object_inline;
		 test1504_830 =
		    PAIRP(obj_1467);
	      }
	    else
	      {		/* Object/inline.scm 97 */
		 test1504_830 = ((bool_t) 0);
	      }
	 }
	 if (test1504_830)
	   {	/* Object/inline.scm 97 */
	      {		/* Object/inline.scm 99 */
		 obj_t list1505_831;
		 {	/* Object/inline.scm 99 */
		    obj_t arg1508_833;
		    {	/* Object/inline.scm 99 */
		       obj_t aux_1853;
		       aux_1853 =
			  BCHAR(((unsigned char) '\n'));
		       arg1508_833 =
			  MAKE_PAIR(aux_1853, BNIL);
		    }
		    list1505_831 =
		       MAKE_PAIR(string1777_object_inline, arg1508_833);
		 }
		 verbose_tools_speek(
		    BINT(((long) 1)), list1505_831);
	      }
	      {
		 obj_t l1466_834;
		 l1466_834 = _intern_generic__171_object_inline;
	       lname1467_835:
		 if (
		    PAIRP(l1466_834))
		   {	/* Object/inline.scm 100 */
		      inline_method__105_object_inline(
			 CAR(l1466_834));
		      {
			 obj_t l1466_1863;
			 l1466_1863 =
			    CDR(l1466_834);
			 l1466_834 = l1466_1863;
			 goto lname1467_835;
		      }
		   }
		 else
		   {	/* Object/inline.scm 100 */
		      ((bool_t) 1);
		   }
	      }
	      return
		 disable_method_inlining__113_object_inline();
	   }
	 else
	   {	/* Object/inline.scm 97 */
	      return BUNSPEC;
	   }
      }
   }
}



/* _inline-methods! */
obj_t 
_inline_methods__227_object_inline(obj_t env_1754)
{
   AN_OBJECT;
   {	/* Object/inline.scm 96 */
      return
	 inline_methods__72_object_inline();
   }
}



/* inline-method! */
obj_t 
inline_method__105_object_inline(obj_t cell_20)
{
   AN_OBJECT;
   {	/* Object/inline.scm 106 */
      {		/* Object/inline.scm 107 */
	 obj_t generic_840;
	 generic_840 =
	    CAR(cell_20);
	 {	/* Object/inline.scm 107 */
	    obj_t imethods_841;
	    {	/* Object/inline.scm 108 */
	       obj_t aux_1868;
	       {	/* ./Ieee/pair-list.scm 5707 */
		  obj_t aux_1869;
		  aux_1869 =
		     CDR(cell_20);
		  aux_1868 =
		     CDR(aux_1869);
	       }
	       imethods_841 =
		  reverse__39___r4_pairs_and_lists_6_3(aux_1868);
	    }
	    {	/* Object/inline.scm 108 */
	       value_bglt sfun_842;
	       {	/* Object/inline.scm 109 */
		  global_bglt obj_1476;
		  obj_1476 =
		     (global_bglt) (generic_840);
		  sfun_842 =
		     (((global_bglt) CREF(obj_1476))->value);
	       }
	       {	/* Object/inline.scm 110 */
		  obj_t old_body_129_844;
		  {	/* Object/inline.scm 111 */
		     sfun_bglt obj_1478;
		     obj_1478 =
			(sfun_bglt) (sfun_842);
		     old_body_129_844 =
			(((sfun_bglt) CREF(obj_1478))->body);
		  }
		  {	/* Object/inline.scm 111 */
		     obj_t args_845;
		     {	/* Object/inline.scm 112 */
			sfun_bglt obj_1479;
			obj_1479 =
			   (sfun_bglt) (sfun_842);
			args_845 =
			   (((sfun_bglt) CREF(obj_1479))->args);
		     }
		     {	/* Object/inline.scm 112 */
			long arity_846;
			{	/* Object/inline.scm 113 */
			   sfun_bglt obj_1480;
			   obj_1480 =
			      (sfun_bglt) (sfun_842);
			   arity_846 =
			      (((sfun_bglt) CREF(obj_1480))->arity);
			}
			{	/* Object/inline.scm 113 */
			   obj_t marg_847;
			   marg_847 =
			      CAR(args_845);
			   {	/* Object/inline.scm 114 */
			      obj_t method_848;
			      method_848 =
				 PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4,
				 CNST_TABLE_REF(((long) 5)), BEOA);
			      {		/* Object/inline.scm 115 */
				 obj_t loop_849;
				 loop_849 =
				    PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4,
				    CNST_TABLE_REF(((long) 6)), BEOA);
				 {	/* Object/inline.scm 116 */
				    obj_t super_850;
				    super_850 =
				       PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4,
				       CNST_TABLE_REF(((long) 7)), BEOA);
				    {	/* Object/inline.scm 117 */
				       obj_t aux_851;
				       aux_851 =
					  PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4,
					  CNST_TABLE_REF(((long) 8)), BEOA);
				       {	/* Object/inline.scm 118 */
					  obj_t larg_852;
					  larg_852 =
					     PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4,
					     CNST_TABLE_REF(((long) 9)), BEOA);
					  {	/* Object/inline.scm 119 */
					     obj_t largs_853;
					     {	/* ./Ieee/pair-list.scm 5689 */
						obj_t aux_1897;
						aux_1897 =
						   CDR(args_845);
						largs_853 =
						   MAKE_PAIR(larg_852, aux_1897);
					     }
					     {	/* Object/inline.scm 120 */
						obj_t other_body_17_854;
						{	/* Object/inline.scm 121 */
						   obj_t arg1646_979;
						   obj_t arg1647_980;
						   arg1646_979 =
						      CNST_TABLE_REF(((long) 10));
						   {	/* Object/inline.scm 121 */
						      obj_t arg1648_981;
						      obj_t arg1649_982;
						      {		/* Object/inline.scm 121 */
							 obj_t arg1650_983;
							 obj_t arg1651_984;
							 arg1650_983 =
							    CNST_TABLE_REF(((long) 11));
							 arg1651_984 =
							    MAKE_PAIR(method_848, BNIL);
							 arg1648_981 =
							    MAKE_PAIR(arg1650_983, arg1651_984);
						      }
						      {		/* Object/inline.scm 122 */
							 obj_t arg1652_985;
							 obj_t arg1653_986;
							 if (
							    (arity_846 >= ((long) 0)))
							   {	/* ./Ieee/pair-list.scm 5689 */
							      obj_t aux_1906;
							      aux_1906 =
								 append_2_18___r4_pairs_and_lists_6_3(args_845, BNIL);
							      arg1652_985 =
								 MAKE_PAIR(method_848, aux_1906);
							   }
							 else
							   {	/* Object/inline.scm 124 */
							      obj_t arg1656_989;
							      obj_t arg1657_990;
							      arg1656_989 =
								 CNST_TABLE_REF(((long) 12));
							      {		/* Object/inline.scm 124 */
								 obj_t arg1658_991;
								 {	/* Object/inline.scm 124 */
								    obj_t arg1659_992;
								    {	/* ./Ieee/pair-list.scm 5689 */
								       obj_t aux_1912;
								       obj_t aux_1910;
								       aux_1912 =
									  append_2_18___r4_pairs_and_lists_6_3(args_845, BNIL);
								       aux_1910 =
									  CNST_TABLE_REF(((long) 13));
								       arg1659_992 =
									  MAKE_PAIR(aux_1910, aux_1912);
								    }
								    arg1658_991 =
								       MAKE_PAIR(arg1659_992, BNIL);
								 }
								 arg1657_990 =
								    MAKE_PAIR(method_848, arg1658_991);
							      }
							      arg1652_985 =
								 MAKE_PAIR(arg1656_989, arg1657_990);
							   }
							 arg1653_986 =
							    MAKE_PAIR(old_body_129_844, BNIL);
							 arg1649_982 =
							    MAKE_PAIR(arg1652_985, arg1653_986);
						      }
						      arg1647_980 =
							 MAKE_PAIR(arg1648_981, arg1649_982);
						   }
						   other_body_17_854 =
						      MAKE_PAIR(arg1646_979, arg1647_980);
						}
						{	/* Object/inline.scm 121 */
						   obj_t class_855;
						   class_855 =
						      PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4,
						      CNST_TABLE_REF(((long) 14)), BEOA);
						   {	/* Object/inline.scm 126 */

						      {		/* Object/inline.scm 127 */
							 obj_t new_body_215_856;
							 {	/* Object/inline.scm 129 */
							    obj_t arg1516_860;
							    {	/* Object/inline.scm 129 */
							       obj_t arg1517_861;
							       obj_t arg1519_862;
							       arg1517_861 =
								  CNST_TABLE_REF(((long) 15));
							       {	/* Object/inline.scm 129 */
								  obj_t arg1520_863;
								  obj_t arg1521_864;
								  {	/* Object/inline.scm 129 */
								     obj_t arg1522_865;
								     {	/* Object/inline.scm 129 */
									obj_t arg1525_867;
									{	/* Object/inline.scm 129 */
									   obj_t arg1526_868;
									   {	/* Object/inline.scm 129 */
									      obj_t arg1528_870;
									      obj_t arg1529_871;
									      arg1528_870 =
										 CNST_TABLE_REF(((long) 16));
									      {		/* Object/inline.scm 129 */
										 obj_t arg1530_872;
										 obj_t arg1532_873;
										 {	/* Object/inline.scm 129 */
										    obj_t arg1533_874;
										    arg1533_874 =
										       MAKE_PAIR(class_855, BNIL);
										    arg1530_872 =
										       MAKE_PAIR(method_848, arg1533_874);
										 }
										 {	/* Object/inline.scm 130 */
										    obj_t arg1534_875;
										    {	/* Object/inline.scm 130 */
										       obj_t arg1536_877;
										       obj_t arg1537_878;
										       arg1536_877 =
											  CNST_TABLE_REF(((long) 17));
										       {	/* Object/inline.scm 130 */
											  obj_t arg1539_879;
											  obj_t arg1540_880;
											  {	/* Object/inline.scm 130 */
											     obj_t arg1541_881;
											     {	/* Object/inline.scm 130 */
												obj_t arg1544_883;
												obj_t arg1545_884;
												arg1544_883 =
												   CNST_TABLE_REF(((long) 18));
												{	/* Object/inline.scm 131 */
												   obj_t arg1547_885;
												   {	/* Object/inline.scm 131 */
												      obj_t arg1549_887;
												      obj_t arg1550_888;
												      arg1549_887 =
													 CNST_TABLE_REF(((long) 16));
												      {		/* Object/inline.scm 131 */
													 obj_t arg1552_890;
													 {	/* Object/inline.scm 132 */
													    obj_t arg1553_891;
													    {	/* Object/inline.scm 132 */
													       obj_t arg1556_893;
													       obj_t arg1557_894;
													       arg1556_893 =
														  CNST_TABLE_REF(((long) 19));
													       {	/* Object/inline.scm 132 */
														  obj_t arg1558_895;
														  obj_t arg1559_896;
														  {	/* Object/inline.scm 132 */
														     obj_t arg1560_897;
														     obj_t arg1561_898;
														     {	/* Object/inline.scm 132 */
															obj_t arg1562_899;
															{	/* Object/inline.scm 132 */
															   obj_t arg1563_900;
															   {	/* Object/inline.scm 132 */
															      obj_t arg1565_902;
															      obj_t arg1566_903;
															      arg1565_902 =
																 CNST_TABLE_REF(((long) 10));
															      {		/* Object/inline.scm 132 */
																 obj_t arg1567_904;
																 obj_t arg1568_905;
																 {	/* Object/inline.scm 132 */
																    obj_t arg1569_906;
																    obj_t arg1571_907;
																    arg1569_906 =
																       CNST_TABLE_REF(((long) 20));
																    arg1571_907 =
																       MAKE_PAIR(class_855, BNIL);
																    arg1567_904 =
																       MAKE_PAIR(arg1569_906, arg1571_907);
																 }
																 {	/* Object/inline.scm 133 */
																    obj_t arg1572_908;
																    obj_t arg1573_909;
																    {	/* Object/inline.scm 133 */
																       obj_t arg1576_910;
																       obj_t arg1577_911;
																       arg1576_910 =
																	  CNST_TABLE_REF(((long) 21));
																       arg1577_911 =
																	  MAKE_PAIR(class_855, BNIL);
																       arg1572_908 =
																	  MAKE_PAIR(arg1576_910, arg1577_911);
																    }
																    arg1573_909 =
																       MAKE_PAIR(BFALSE, BNIL);
																    arg1568_905 =
																       MAKE_PAIR(arg1572_908, arg1573_909);
																 }
																 arg1566_903 =
																    MAKE_PAIR(arg1567_904, arg1568_905);
															      }
															      arg1563_900 =
																 MAKE_PAIR(arg1565_902, arg1566_903);
															   }
															   arg1562_899 =
															      MAKE_PAIR(arg1563_900, BNIL);
															}
															arg1560_897 =
															   MAKE_PAIR(super_850, arg1562_899);
														     }
														     {	/* Object/inline.scm 136 */
															obj_t arg1578_912;
															{	/* Object/inline.scm 136 */
															   obj_t arg1580_914;
															   {	/* Object/inline.scm 136 */
															      obj_t arg1581_915;
															      {		/* Object/inline.scm 136 */
																 obj_t arg1583_917;
																 obj_t arg1584_918;
																 arg1583_917 =
																    CNST_TABLE_REF(((long) 22));
																 {	/* Object/inline.scm 136 */
																    obj_t arg1585_919;
																    {	/* Object/inline.scm 136 */
																       obj_t arg1586_920;
																       arg1586_920 =
																	  MAKE_PAIR(super_850, BNIL);
																       arg1585_919 =
																	  MAKE_PAIR(generic_840, arg1586_920);
																    }
																    arg1584_918 =
																       MAKE_PAIR(marg_847, arg1585_919);
																 }
																 arg1581_915 =
																    MAKE_PAIR(arg1583_917, arg1584_918);
															      }
															      arg1580_914 =
																 MAKE_PAIR(arg1581_915, BNIL);
															   }
															   arg1578_912 =
															      MAKE_PAIR(aux_851, arg1580_914);
															}
															arg1561_898 =
															   MAKE_PAIR(arg1578_912, BNIL);
														     }
														     arg1558_895 =
															MAKE_PAIR(arg1560_897, arg1561_898);
														  }
														  {	/* Object/inline.scm 140 */
														     obj_t arg1587_921;
														     {	/* Object/inline.scm 140 */
															obj_t arg1589_923;
															{	/* Object/inline.scm 140 */
															   obj_t arg1590_924;
															   obj_t arg1591_925;
															   {	/* Object/inline.scm 140 */
															      obj_t arg1592_926;
															      obj_t arg1593_927;
															      arg1592_926 =
																 CNST_TABLE_REF(((long) 23));
															      arg1593_927 =
																 MAKE_PAIR(aux_851, BNIL);
															      arg1590_924 =
																 MAKE_PAIR(arg1592_926, arg1593_927);
															   }
															   {	/* Object/inline.scm 141 */
															      obj_t arg1594_928;
															      {		/* Object/inline.scm 141 */
																 obj_t arg1596_930;
																 obj_t arg1597_931;
																 arg1596_930 =
																    CNST_TABLE_REF(((long) 24));
																 arg1597_931 =
																    MAKE_PAIR(aux_851, BNIL);
																 arg1594_928 =
																    MAKE_PAIR(arg1596_930, arg1597_931);
															      }
															      arg1591_925 =
																 MAKE_PAIR(arg1594_928, BNIL);
															   }
															   arg1589_923 =
															      MAKE_PAIR(arg1590_924, arg1591_925);
															}
															arg1587_921 =
															   MAKE_PAIR(loop_849, arg1589_923);
														     }
														     arg1559_896 =
															MAKE_PAIR(arg1587_921, BNIL);
														  }
														  arg1557_894 =
														     MAKE_PAIR(arg1558_895, arg1559_896);
													       }
													       arg1553_891 =
														  MAKE_PAIR(arg1556_893, arg1557_894);
													    }
													    arg1552_890 =
													       MAKE_PAIR(arg1553_891, BNIL);
													 }
													 arg1550_888 =
													    MAKE_PAIR(BNIL, arg1552_890);
												      }
												      arg1547_885 =
													 MAKE_PAIR(arg1549_887, arg1550_888);
												   }
												   arg1545_884 =
												      MAKE_PAIR(arg1547_885, BNIL);
												}
												arg1541_881 =
												   MAKE_PAIR(arg1544_883, arg1545_884);
											     }
											     arg1539_879 =
												MAKE_PAIR(arg1541_881, BNIL);
											  }
											  {	/* Object/inline.scm 142 */
											     obj_t arg1598_932;
											     {	/* Object/inline.scm 142 */
												obj_t arg1600_934;
												obj_t arg1601_935;
												arg1600_934 =
												   CNST_TABLE_REF(((long) 25));
												{	/* Object/inline.scm 143 */
												   obj_t arg1602_936;
												   {	/* Object/inline.scm 143 */
												      obj_t arg1603_937;
												      obj_t arg1604_938;
												      arg1603_937 =
													 make_case_clauses_101_object_inline(args_845, imethods_841);
												      {		/* Object/inline.scm 144 */
													 obj_t arg1605_939;
													 {	/* Object/inline.scm 144 */
													    obj_t arg1607_941;
													    obj_t arg1608_942;
													    arg1607_941 =
													       CNST_TABLE_REF(((long) 26));
													    arg1608_942 =
													       MAKE_PAIR(other_body_17_854, BNIL);
													    arg1605_939 =
													       MAKE_PAIR(arg1607_941, arg1608_942);
													 }
													 arg1604_938 =
													    MAKE_PAIR(arg1605_939, BNIL);
												      }
												      arg1602_936 =
													 append_2_18___r4_pairs_and_lists_6_3(arg1603_937, arg1604_938);
												   }
												   arg1601_935 =
												      MAKE_PAIR(method_848, arg1602_936);
												}
												arg1598_932 =
												   MAKE_PAIR(arg1600_934, arg1601_935);
											     }
											     arg1540_880 =
												MAKE_PAIR(arg1598_932, BNIL);
											  }
											  arg1537_878 =
											     MAKE_PAIR(arg1539_879, arg1540_880);
										       }
										       arg1534_875 =
											  MAKE_PAIR(arg1536_877, arg1537_878);
										    }
										    arg1532_873 =
										       MAKE_PAIR(arg1534_875, BNIL);
										 }
										 arg1529_871 =
										    MAKE_PAIR(arg1530_872, arg1532_873);
									      }
									      arg1526_868 =
										 MAKE_PAIR(arg1528_870, arg1529_871);
									   }
									   arg1525_867 =
									      MAKE_PAIR(arg1526_868, BNIL);
									}
									arg1522_865 =
									   MAKE_PAIR(loop_849, arg1525_867);
								     }
								     arg1520_863 =
									MAKE_PAIR(arg1522_865, BNIL);
								  }
								  {	/* Object/inline.scm 146 */
								     obj_t arg1609_943;
								     {	/* Object/inline.scm 146 */
									bool_t test1611_945;
									{	/* ./Object/class.scm 1227 */
									   obj_t aux_1991;
									   {	/* Object/inline.scm 146 */
									      type_bglt aux_1992;
									      {		/* Object/inline.scm 146 */
										 local_bglt obj_1609;
										 obj_1609 =
										    (local_bglt) (marg_847);
										 aux_1992 =
										    (((local_bglt) CREF(obj_1609))->type);
									      }
									      aux_1991 =
										 (obj_t) (aux_1992);
									   }
									   test1611_945 =
									      is_a__118___object(aux_1991, tclass_object_class);
									}
									if (test1611_945)
									  {	/* Object/inline.scm 147 */
									     obj_t arg1612_946;
									     {	/* Object/inline.scm 147 */
										obj_t arg1613_947;
										obj_t arg1614_948;
										{	/* Object/inline.scm 147 */
										   obj_t arg1615_949;
										   obj_t arg1616_950;
										   arg1615_949 =
										      CNST_TABLE_REF(((long) 27));
										   {	/* Object/inline.scm 147 */
										      obj_t arg1617_951;
										      arg1617_951 =
											 MAKE_PAIR(generic_840, BNIL);
										      arg1616_950 =
											 MAKE_PAIR(marg_847, arg1617_951);
										   }
										   arg1613_947 =
										      MAKE_PAIR(arg1615_949, arg1616_950);
										}
										{	/* Object/inline.scm 148 */
										   obj_t arg1618_952;
										   {	/* Object/inline.scm 148 */
										      obj_t arg1620_954;
										      obj_t arg1621_955;
										      arg1620_954 =
											 CNST_TABLE_REF(((long) 28));
										      arg1621_955 =
											 MAKE_PAIR(marg_847, BNIL);
										      arg1618_952 =
											 MAKE_PAIR(arg1620_954, arg1621_955);
										   }
										   arg1614_948 =
										      MAKE_PAIR(arg1618_952, BNIL);
										}
										arg1612_946 =
										   MAKE_PAIR(arg1613_947, arg1614_948);
									     }
									     arg1609_943 =
										MAKE_PAIR(loop_849, arg1612_946);
									  }
									else
									  {	/* Object/inline.scm 149 */
									     obj_t arg1622_956;
									     obj_t arg1623_957;
									     arg1622_956 =
										CNST_TABLE_REF(((long) 10));
									     {	/* Object/inline.scm 149 */
										obj_t arg1624_958;
										obj_t arg1625_959;
										{	/* Object/inline.scm 149 */
										   obj_t arg1626_960;
										   obj_t arg1627_961;
										   arg1626_960 =
										      CNST_TABLE_REF(((long) 29));
										   arg1627_961 =
										      MAKE_PAIR(marg_847, BNIL);
										   arg1624_958 =
										      MAKE_PAIR(arg1626_960, arg1627_961);
										}
										{	/* Object/inline.scm 150 */
										   obj_t arg1628_962;
										   obj_t arg1629_963;
										   {	/* Object/inline.scm 150 */
										      obj_t arg1630_964;
										      {		/* Object/inline.scm 150 */
											 obj_t arg1631_965;
											 obj_t arg1632_966;
											 {	/* Object/inline.scm 150 */
											    obj_t arg1633_967;
											    obj_t arg1634_968;
											    arg1633_967 =
											       CNST_TABLE_REF(((long) 27));
											    {	/* Object/inline.scm 150 */
											       obj_t arg1635_969;
											       arg1635_969 =
												  MAKE_PAIR(generic_840, BNIL);
											       arg1634_968 =
												  MAKE_PAIR(marg_847, arg1635_969);
											    }
											    arg1631_965 =
											       MAKE_PAIR(arg1633_967, arg1634_968);
											 }
											 {	/* Object/inline.scm 151 */
											    obj_t arg1636_970;
											    {	/* Object/inline.scm 151 */
											       obj_t arg1638_972;
											       obj_t arg1639_973;
											       arg1638_972 =
												  CNST_TABLE_REF(((long) 28));
											       arg1639_973 =
												  MAKE_PAIR(marg_847, BNIL);
											       arg1636_970 =
												  MAKE_PAIR(arg1638_972, arg1639_973);
											    }
											    arg1632_966 =
											       MAKE_PAIR(arg1636_970, BNIL);
											 }
											 arg1630_964 =
											    MAKE_PAIR(arg1631_965, arg1632_966);
										      }
										      arg1628_962 =
											 MAKE_PAIR(loop_849, arg1630_964);
										   }
										   {	/* Object/inline.scm 152 */
										      obj_t arg1640_974;
										      {		/* Object/inline.scm 152 */
											 obj_t arg1642_976;
											 {	/* Object/inline.scm 152 */
											    obj_t arg1643_977;
											    arg1643_977 =
											       MAKE_PAIR(BFALSE, BNIL);
											    arg1642_976 =
											       MAKE_PAIR(BFALSE, arg1643_977);
											 }
											 arg1640_974 =
											    MAKE_PAIR(loop_849, arg1642_976);
										      }
										      arg1629_963 =
											 MAKE_PAIR(arg1640_974, BNIL);
										   }
										   arg1625_959 =
										      MAKE_PAIR(arg1628_962, arg1629_963);
										}
										arg1623_957 =
										   MAKE_PAIR(arg1624_958, arg1625_959);
									     }
									     arg1609_943 =
										MAKE_PAIR(arg1622_956, arg1623_957);
									  }
								     }
								     arg1521_864 =
									MAKE_PAIR(arg1609_943, BNIL);
								  }
								  arg1519_862 =
								     MAKE_PAIR(arg1520_863, arg1521_864);
							       }
							       arg1516_860 =
								  MAKE_PAIR(arg1517_861, arg1519_862);
							    }
							    new_body_215_856 =
							       comptime_expand_37_expand_eps(arg1516_860);
							 }
							 {	/* Object/inline.scm 155 */
							    node_bglt arg1513_857;
							    {	/* Object/inline.scm 153 */
							       obj_t aux_2033;
							       {	/* Object/inline.scm 155 */
								  node_bglt obj_1667;
								  obj_1667 =
								     (node_bglt) (old_body_129_844);
								  aux_2033 =
								     (((node_bglt) CREF(obj_1667))->loc);
							       }
							       arg1513_857 =
								  sexp__node_235_ast_sexp(new_body_215_856, args_845, aux_2033,
								  CNST_TABLE_REF(((long) 30)));
							    }
							    {	/* Object/inline.scm 153 */
							       sfun_bglt obj_1668;
							       obj_t val1123_1669;
							       obj_1668 =
								  (sfun_bglt) (sfun_842);
							       val1123_1669 =
								  (obj_t) (arg1513_857);
							       return
								  ((((sfun_bglt) CREF(obj_1668))->body) = ((obj_t) val1123_1669), BUNSPEC);
							    }
							 }
						      }
						   }
						}
					     }
					  }
				       }
				    }
				 }
			      }
			   }
			}
		     }
		  }
	       }
	    }
	 }
      }
   }
}



/* make-case-clauses */
obj_t 
make_case_clauses_101_object_inline(obj_t args_21, obj_t imethods_22)
{
   AN_OBJECT;
   {	/* Object/inline.scm 161 */
      if (
	 NULLP(imethods_22))
	{	/* Object/inline.scm 162 */
	   return BNIL;
	}
      else
	{	/* Object/inline.scm 162 */
	   obj_t head1470_1000;
	   head1470_1000 =
	      MAKE_PAIR(BNIL, BNIL);
	   {
	      obj_t l1468_1001;
	      obj_t tail1471_1002;
	      l1468_1001 = imethods_22;
	      tail1471_1002 = head1470_1000;
	    lname1469_1003:
	      if (
		 NULLP(l1468_1001))
		{	/* Object/inline.scm 162 */
		   return
		      CDR(head1470_1000);
		}
	      else
		{	/* Object/inline.scm 162 */
		   obj_t newtail1472_1005;
		   {	/* Object/inline.scm 162 */
		      obj_t arg1669_1007;
		      arg1669_1007 =
			 inline_method_clause_150_object_inline(args_21,
			 CAR(l1468_1001));
		      newtail1472_1005 =
			 MAKE_PAIR(arg1669_1007, BNIL);
		   }
		   SET_CDR(tail1471_1002, newtail1472_1005);
		   {
		      obj_t tail1471_2053;
		      obj_t l1468_2051;
		      l1468_2051 =
			 CDR(l1468_1001);
		      tail1471_2053 = newtail1472_1005;
		      tail1471_1002 = tail1471_2053;
		      l1468_1001 = l1468_2051;
		      goto lname1469_1003;
		   }
		}
	   }
	}
   }
}



/* inline-method-clause */
obj_t 
inline_method_clause_150_object_inline(obj_t generic_args_72_23, obj_t imethod_24)
{
   AN_OBJECT;
   {	/* Object/inline.scm 167 */
      {		/* Object/inline.scm 171 */
	 obj_t arg1671_1013;
	 obj_t arg1672_1014;
	 {	/* ./Ieee/pair-list.scm 5689 */
	    obj_t aux_2054;
	    aux_2054 =
	       STRUCT_REF(imethod_24, ((long) 2));
	    arg1671_1013 =
	       MAKE_PAIR(aux_2054, BNIL);
	 }
	 {	/* Object/inline.scm 171 */
	    obj_t arg1673_1015;
	    {	/* Object/inline.scm 171 */
	       obj_t arg1675_1017;
	       obj_t arg1676_1018;
	       arg1675_1017 =
		  CNST_TABLE_REF(((long) 17));
	       {	/* Object/inline.scm 171 */
		  obj_t arg1677_1019;
		  obj_t arg1678_1020;
		  {	/* Object/inline.scm 171 */
		     obj_t ll1473_1021;
		     ll1473_1021 =
			args___args_list_50_tools_args(
			STRUCT_REF(imethod_24, ((long) 0)));
		     if (
			NULLP(ll1473_1021))
		       {	/* Object/inline.scm 171 */
			  arg1677_1019 = BNIL;
		       }
		     else
		       {	/* Object/inline.scm 171 */
			  obj_t head1475_1024;
			  {	/* Object/inline.scm 171 */
			     obj_t arg1691_1041;
			     {	/* Object/inline.scm 171 */
				obj_t arg1693_1043;
				arg1693_1043 =
				   CAR(ll1473_1021);
				{	/* Object/inline.scm 171 */
				   obj_t list1695_1045;
				   {	/* Object/inline.scm 171 */
				      obj_t arg1696_1046;
				      {		/* Object/inline.scm 171 */
					 obj_t aux_2063;
					 aux_2063 =
					    CAR(generic_args_72_23);
					 arg1696_1046 =
					    MAKE_PAIR(aux_2063, BNIL);
				      }
				      list1695_1045 =
					 MAKE_PAIR(arg1693_1043, arg1696_1046);
				   }
				   arg1691_1041 = list1695_1045;
				}
			     }
			     head1475_1024 =
				MAKE_PAIR(arg1691_1041, BNIL);
			  }
			  {
			     obj_t ll1473_1025;
			     obj_t ll1474_1026;
			     obj_t tail1476_1027;
			     ll1473_1025 =
				CDR(ll1473_1021);
			     ll1474_1026 =
				CDR(generic_args_72_23);
			     tail1476_1027 = head1475_1024;
			   lname1478_1028:
			     if (
				NULLP(ll1473_1025))
			       {	/* Object/inline.scm 171 */
				  arg1677_1019 = head1475_1024;
			       }
			     else
			       {	/* Object/inline.scm 171 */
				  obj_t newtail1477_1032;
				  {	/* Object/inline.scm 171 */
				     obj_t arg1685_1035;
				     {	/* Object/inline.scm 171 */
					obj_t arg1687_1037;
					arg1687_1037 =
					   CAR(ll1473_1025);
					{	/* Object/inline.scm 171 */
					   obj_t list1689_1039;
					   {	/* Object/inline.scm 171 */
					      obj_t arg1690_1040;
					      {		/* Object/inline.scm 171 */
						 obj_t aux_2071;
						 aux_2071 =
						    CAR(ll1474_1026);
						 arg1690_1040 =
						    MAKE_PAIR(aux_2071, BNIL);
					      }
					      list1689_1039 =
						 MAKE_PAIR(arg1687_1037, arg1690_1040);
					   }
					   arg1685_1035 = list1689_1039;
					}
				     }
				     newtail1477_1032 =
					MAKE_PAIR(arg1685_1035, BNIL);
				  }
				  SET_CDR(tail1476_1027, newtail1477_1032);
				  {
				     obj_t tail1476_2081;
				     obj_t ll1474_2079;
				     obj_t ll1473_2077;
				     ll1473_2077 =
					CDR(ll1473_1025);
				     ll1474_2079 =
					CDR(ll1474_1026);
				     tail1476_2081 = newtail1477_1032;
				     tail1476_1027 = tail1476_2081;
				     ll1474_1026 = ll1474_2079;
				     ll1473_1025 = ll1473_2077;
				     goto lname1478_1028;
				  }
			       }
			  }
		       }
		  }
		  {	/* ./Ieee/pair-list.scm 5689 */
		     obj_t aux_2084;
		     aux_2084 =
			STRUCT_REF(imethod_24, ((long) 1));
		     arg1678_1020 =
			MAKE_PAIR(aux_2084, BNIL);
		  }
		  arg1676_1018 =
		     MAKE_PAIR(arg1677_1019, arg1678_1020);
	       }
	       arg1673_1015 =
		  MAKE_PAIR(arg1675_1017, arg1676_1018);
	    }
	    arg1672_1014 =
	       MAKE_PAIR(arg1673_1015, BNIL);
	 }
	 return
	    MAKE_PAIR(arg1671_1013, arg1672_1014);
      }
   }
}



/* method-init */
obj_t 
method_init_76_object_inline()
{
   AN_OBJECT;
   {	/* Object/inline.scm 33 */
      return BUNSPEC;
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_object_inline()
{
   AN_OBJECT;
   {	/* Object/inline.scm 33 */
      module_initialization_70_tools_trace(((long) 0), "OBJECT_INLINE");
      module_initialization_70_engine_param(((long) 0), "OBJECT_INLINE");
      module_initialization_70_tools_shape(((long) 0), "OBJECT_INLINE");
      module_initialization_70_tools_speek(((long) 0), "OBJECT_INLINE");
      module_initialization_70_tools_args(((long) 0), "OBJECT_INLINE");
      module_initialization_70_type_type(((long) 0), "OBJECT_INLINE");
      module_initialization_70_expand_eps(((long) 0), "OBJECT_INLINE");
      module_initialization_70_ast_var(((long) 0), "OBJECT_INLINE");
      module_initialization_70_ast_node(((long) 0), "OBJECT_INLINE");
      module_initialization_70_ast_sexp(((long) 0), "OBJECT_INLINE");
      return
	 module_initialization_70_object_class(((long) 0), "OBJECT_INLINE");
   }
}
