/*===========================================================================*/
/*   (Object/method.scm)                                                     */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct tclass
  {
     obj_t its_super_214;
     obj_t slots;
     struct global *holder;
     obj_t widening;
     long depth;
     bool_t final__12;
     obj_t constructor;
     obj_t virtual_slots_number_200;
  }
      *tclass_bglt;


extern obj_t find_global_223_ast_env(obj_t, obj_t);
static obj_t method_init_76_object_method();
extern obj_t symbol_append_197___r4_symbols_6_4(obj_t);
extern long add_generic_method__111_object_inline(global_bglt, type_bglt, obj_t, obj_t);
extern obj_t id_of_id_112_ast_ident(obj_t, obj_t);
extern obj_t mark_symbol_non_user__17_ast_ident(obj_t);
extern obj_t global_ast_var;
extern obj_t gensym___r4_symbols_6_4;
extern obj_t user_error_151_tools_error(obj_t, obj_t, obj_t, obj_t);
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t module_initialization_70_object_method(long, char *);
extern obj_t module_initialization_70_tools_args(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_tools_misc(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_ident(long, char *);
extern obj_t module_initialization_70_ast_env(long, char *);
extern obj_t module_initialization_70_object_class(long, char *);
extern obj_t module_initialization_70_object_inline(long, char *);
extern obj_t module_initialization_70_tools_location(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_symbols_6_4(long, char *);
extern bool_t method_inlining_enabled__91_object_inline();
static obj_t imported_modules_init_94_object_method();
extern obj_t append_2_18___r4_pairs_and_lists_6_3(obj_t, obj_t);
static obj_t library_modules_init_112_object_method();
extern obj_t open_input_string(obj_t);
extern int arity_tools_args(obj_t);
extern obj_t tclass_object_class;
extern obj_t add_generic_for_method_inlining__147_object_inline(obj_t);
static obj_t _make_method_body_16_object_method(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t read___reader(obj_t);
extern obj_t find_location_120_tools_location(obj_t);
extern obj_t make_method_body_103_object_method(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t require_initialization_114_object_method = BUNSPEC;
static obj_t cnst_init_137_object_method();
static obj_t __cnst[17];

DEFINE_EXPORT_PROCEDURE(make_method_body_env_21_object_method, _make_method_body_16_object_method1434, _make_method_body_16_object_method, 0L, 5);
DEFINE_STRING(string1429_object_method, string1429_object_method1435, "(QUOTE METHOD-DEFINITION-ERROR) ADD-INLINED-METHOD! ADD-METHOD! GENERIC-PRE-METHOD-SET! BEGIN CONS* APPLY PROCEDURE? IF @ FIND-SUPER-CLASS-METHOD LET CALL-NEXT-METHOD LABELS IMPORT - NEXT-METHOD ", 195);
DEFINE_STRING(string1428_object_method, string1428_object_method1436, "method has a non-class dispatching type arg", 43);
DEFINE_STRING(string1427_object_method, string1427_object_method1437, "Can't find generic for method", 29);
DEFINE_STRING(string1426_object_method, string1426_object_method1438, "Type `extended pair' expected for expression", 44);
DEFINE_STRING(string1425_object_method, string1425_object_method1439, "cer", 3);



/* module-initialization */
obj_t 
module_initialization_70_object_method(long checksum_938, char *from_939)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_object_method))
	{
	   require_initialization_114_object_method =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_object_method();
	   cnst_init_137_object_method();
	   imported_modules_init_94_object_method();
	   method_init_76_object_method();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_object_method()
{
   AN_OBJECT;
   {	/* Object/method.scm 14 */
      module_initialization_70___r4_symbols_6_4(((long) 0), "OBJECT_METHOD");
      module_initialization_70___object(((long) 0), "OBJECT_METHOD");
      module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "OBJECT_METHOD");
      module_initialization_70___reader(((long) 0), "OBJECT_METHOD");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_object_method()
{
   AN_OBJECT;
   {	/* Object/method.scm 14 */
      {		/* Object/method.scm 14 */
	 obj_t cnst_port_138_931;
	 cnst_port_138_931 =
	    open_input_string(string1429_object_method);
	 {
	    long i_932;
	    i_932 = ((long) 16);
	  loop_933:
	    {	/* Object/method.scm 14 */
	       bool_t test1430_934;
	       test1430_934 =
		  (i_932 == ((long) -1));
	       if (test1430_934)
		 {	/* Object/method.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Object/method.scm 14 */
		    {	/* Object/method.scm 14 */
		       obj_t arg1431_935;
		       {	/* Object/method.scm 14 */
			  obj_t list1432_936;
			  list1432_936 =
			     MAKE_PAIR(cnst_port_138_931, BNIL);
			  arg1431_935 =
			     read___reader(list1432_936);
		       }
		       CNST_TABLE_SET(i_932, arg1431_935);
		    }
		    {	/* Object/method.scm 14 */
		       int aux_937;
		       {	/* Object/method.scm 14 */
			  long aux_957;
			  aux_957 =
			     (i_932 - ((long) 1));
			  aux_937 =
			     (int) (aux_957);
		       }
		       {
			  long i_960;
			  i_960 =
			     (long) (aux_937);
			  i_932 = i_960;
			  goto loop_933;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* make-method-body */
obj_t 
make_method_body_103_object_method(obj_t id_1, obj_t args_2, obj_t locals_3, obj_t body_4, obj_t src_5)
{
   AN_OBJECT;
   {	/* Object/method.scm 30 */
      {		/* Object/method.scm 31 */
	 obj_t id_396;
	 {	/* Object/method.scm 31 */
	    obj_t arg1384_550;
	    arg1384_550 =
	       find_location_120_tools_location(src_5);
	    id_396 =
	       id_of_id_112_ast_ident(id_1, arg1384_550);
	 }
	 {	/* Object/method.scm 31 */
	    obj_t method_397;
	    method_397 =
	       PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4,
	       CNST_TABLE_REF(((long) 0)), BEOA);
	    {	/* Object/method.scm 32 */
	       int arity_398;
	       arity_398 =
		  arity_tools_args(args_2);
	       {	/* Object/method.scm 33 */
		  obj_t args_id_103_399;
		  if (
		     NULLP(locals_3))
		    {	/* Object/method.scm 34 */
		       args_id_103_399 = BNIL;
		    }
		  else
		    {	/* Object/method.scm 34 */
		       obj_t head1215_536;
		       {	/* ./Ieee/pair-list.scm 5689 */
			  obj_t aux_970;
			  {	/* Object/method.scm 34 */
			     local_bglt obj_699;
			     {	/* Object/method.scm 34 */
				obj_t aux_971;
				aux_971 =
				   CAR(locals_3);
				obj_699 =
				   (local_bglt) (aux_971);
			     }
			     aux_970 =
				(((local_bglt) CREF(obj_699))->id);
			  }
			  head1215_536 =
			     MAKE_PAIR(aux_970, BNIL);
		       }
		       {
			  obj_t l1213_537;
			  obj_t tail1216_538;
			  l1213_537 =
			     CDR(locals_3);
			  tail1216_538 = head1215_536;
			lname1214_539:
			  if (
			     NULLP(l1213_537))
			    {	/* Object/method.scm 34 */
			       args_id_103_399 = head1215_536;
			    }
			  else
			    {	/* Object/method.scm 34 */
			       obj_t newtail1217_542;
			       {	/* ./Ieee/pair-list.scm 5689 */
				  obj_t aux_978;
				  {	/* Object/method.scm 34 */
				     local_bglt obj_705;
				     {	/* Object/method.scm 34 */
					obj_t aux_979;
					aux_979 =
					   CAR(l1213_537);
					obj_705 =
					   (local_bglt) (aux_979);
				     }
				     aux_978 =
					(((local_bglt) CREF(obj_705))->id);
				  }
				  newtail1217_542 =
				     MAKE_PAIR(aux_978, BNIL);
			       }
			       SET_CDR(tail1216_538, newtail1217_542);
			       {
				  obj_t tail1216_987;
				  obj_t l1213_985;
				  l1213_985 =
				     CDR(l1213_537);
				  tail1216_987 = newtail1217_542;
				  tail1216_538 = tail1216_987;
				  l1213_537 = l1213_985;
				  goto lname1214_539;
			       }
			    }
		       }
		    }
		  {	/* Object/method.scm 34 */
		     type_bglt type_400;
		     {	/* Object/method.scm 35 */
			local_bglt obj_712;
			{	/* Object/method.scm 35 */
			   obj_t aux_989;
			   aux_989 =
			      CAR(locals_3);
			   obj_712 =
			      (local_bglt) (aux_989);
			}
			type_400 =
			   (((local_bglt) CREF(obj_712))->type);
		     }
		     {	/* Object/method.scm 35 */
			obj_t m_id_75_401;
			{	/* Object/method.scm 41 */
			   obj_t arg1363_526;
			   {	/* Object/method.scm 41 */
			      obj_t arg1365_527;
			      {		/* Object/method.scm 41 */
				 obj_t arg1366_528;
				 arg1366_528 =
				    CNST_TABLE_REF(((long) 1));
				 {	/* Object/method.scm 41 */
				    obj_t list1368_530;
				    {	/* Object/method.scm 41 */
				       obj_t arg1369_531;
				       {	/* Object/method.scm 41 */
					  obj_t arg1371_532;
					  {	/* Object/method.scm 41 */
					     obj_t aux_994;
					     aux_994 =
						(((type_bglt) CREF(type_400))->id);
					     arg1371_532 =
						MAKE_PAIR(aux_994, BNIL);
					  }
					  arg1369_531 =
					     MAKE_PAIR(arg1366_528, arg1371_532);
				       }
				       list1368_530 =
					  MAKE_PAIR(id_396, arg1369_531);
				    }
				    arg1365_527 =
				       symbol_append_197___r4_symbols_6_4(list1368_530);
				 }
			      }
			      arg1363_526 =
				 PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4, arg1365_527, BEOA);
			   }
			   m_id_75_401 =
			      mark_symbol_non_user__17_ast_ident(arg1363_526);
			}
			{	/* Object/method.scm 40 */

			   {	/* Object/method.scm 42 */
			      bool_t test1218_402;
			      test1218_402 =
				 is_a__118___object(
				 (obj_t) (type_400), tclass_object_class);
			      if (test1218_402)
				{	/* Object/method.scm 44 */
				   global_bglt holder_403;
				   {	/* Object/method.scm 44 */
				      tclass_bglt obj_715;
				      obj_715 =
					 (tclass_bglt) (type_400);
				      {
					 obj_t aux_1007;
					 {	/* ./Object/class.scm 761 */
					    object_bglt aux_1008;
					    aux_1008 =
					       (object_bglt) (obj_715);
					    aux_1007 =
					       OBJECT_WIDENING(aux_1008);
					 }
					 holder_403 =
					    (((tclass_bglt) CREF(aux_1007))->holder);
				      }
				   }
				   {	/* Object/method.scm 44 */
				      obj_t module_404;
				      module_404 =
					 (((global_bglt) CREF(holder_403))->module);
				      {		/* Object/method.scm 45 */
					 obj_t generic_405;
					 generic_405 =
					    find_global_223_ast_env(id_396, BNIL);
					 {	/* Object/method.scm 46 */

					    {	/* Object/method.scm 48 */
					       bool_t test1219_406;
					       test1219_406 =
						  is_a__118___object(generic_405, global_ast_var);
					       if (test1219_406)
						 {	/* Object/method.scm 50 */
						    bool_t test1220_407;
						    {	/* Object/method.scm 50 */
						       bool_t test1358_522;
						       test1358_522 =
							  method_inlining_enabled__91_object_inline();
						       if (test1358_522)
							 {	/* ./Ieee/equiv.scm 5508 */
							    obj_t aux_1021;
							    obj_t aux_1018;
							    aux_1021 =
							       CNST_TABLE_REF(((long) 2));
							    {	/* Object/method.scm 51 */
							       global_bglt obj_718;
							       obj_718 =
								  (global_bglt) (generic_405);
							       aux_1018 =
								  (((global_bglt) CREF(obj_718))->import);
							    }
							    test1220_407 =
							       (aux_1018 == aux_1021);
							 }
						       else
							 {	/* Object/method.scm 50 */
							    test1220_407 = ((bool_t) 1);
							 }
						    }
						    if (test1220_407)
						      {		/* Object/method.scm 50 */
							 {	/* Object/method.scm 52 */
							    obj_t body_408;
							    {	/* Object/method.scm 52 */
							       obj_t arg1254_439;
							       obj_t arg1255_440;
							       arg1254_439 =
								  CNST_TABLE_REF(((long) 3));
							       {	/* Object/method.scm 52 */
								  obj_t arg1256_441;
								  obj_t arg1257_442;
								  {	/* Object/method.scm 52 */
								     obj_t arg1258_443;
								     {	/* Object/method.scm 52 */
									obj_t arg1260_445;
									obj_t arg1261_446;
									arg1260_445 =
									   CNST_TABLE_REF(((long) 4));
									{	/* Object/method.scm 52 */
									   obj_t arg1264_448;
									   {	/* Object/method.scm 53 */
									      obj_t arg1265_449;
									      {		/* Object/method.scm 53 */
										 obj_t arg1268_451;
										 obj_t arg1269_452;
										 arg1268_451 =
										    CNST_TABLE_REF(((long) 5));
										 {	/* Object/method.scm 53 */
										    obj_t arg1270_453;
										    obj_t arg1271_454;
										    {	/* Object/method.scm 53 */
										       obj_t arg1272_455;
										       {	/* Object/method.scm 53 */
											  obj_t arg1274_457;
											  {	/* Object/method.scm 53 */
											     obj_t arg1276_458;
											     {	/* Object/method.scm 53 */
												obj_t arg1278_460;
												obj_t arg1280_461;
												arg1278_460 =
												   CNST_TABLE_REF(((long) 6));
												{	/* Object/method.scm 54 */
												   obj_t arg1281_462;
												   obj_t arg1282_463;
												   arg1281_462 =
												      CAR(args_id_103_399);
												   {	/* Object/method.scm 56 */
												      obj_t arg1286_464;
												      {		/* Object/method.scm 56 */
													 obj_t arg1287_465;
													 {	/* Object/method.scm 56 */
													    obj_t arg1290_467;
													    obj_t arg1291_468;
													    arg1290_467 =
													       CNST_TABLE_REF(((long) 7));
													    {	/* Object/method.scm 56 */
													       obj_t arg1292_469;
													       obj_t arg1293_470;
													       arg1292_469 =
														  (((global_bglt) CREF(holder_403))->id);
													       arg1293_470 =
														  MAKE_PAIR(module_404, BNIL);
													       arg1291_468 =
														  MAKE_PAIR(arg1292_469, arg1293_470);
													    }
													    arg1287_465 =
													       MAKE_PAIR(arg1290_467, arg1291_468);
													 }
													 arg1286_464 =
													    MAKE_PAIR(arg1287_465, BNIL);
												      }
												      arg1282_463 =
													 MAKE_PAIR(id_396, arg1286_464);
												   }
												   arg1280_461 =
												      MAKE_PAIR(arg1281_462, arg1282_463);
												}
												arg1276_458 =
												   MAKE_PAIR(arg1278_460, arg1280_461);
											     }
											     arg1274_457 =
												MAKE_PAIR(arg1276_458, BNIL);
											  }
											  arg1272_455 =
											     MAKE_PAIR(method_397, arg1274_457);
										       }
										       arg1270_453 =
											  MAKE_PAIR(arg1272_455, BNIL);
										    }
										    {	/* Object/method.scm 58 */
										       obj_t arg1294_471;
										       {	/* Object/method.scm 58 */
											  obj_t arg1296_473;
											  obj_t arg1297_474;
											  arg1296_473 =
											     CNST_TABLE_REF(((long) 8));
											  {	/* Object/method.scm 58 */
											     obj_t arg1298_475;
											     obj_t arg1299_476;
											     {	/* Object/method.scm 58 */
												obj_t arg1300_477;
												obj_t arg1301_478;
												arg1300_477 =
												   CNST_TABLE_REF(((long) 9));
												arg1301_478 =
												   MAKE_PAIR(method_397, BNIL);
												arg1298_475 =
												   MAKE_PAIR(arg1300_477, arg1301_478);
											     }
											     {	/* Object/method.scm 59 */
												obj_t arg1302_479;
												obj_t arg1303_480;
												{	/* Object/method.scm 59 */
												   bool_t test_1046;
												   {	/* ./Ieee/fixnum.scm 7133 */
												      long aux_1047;
												      aux_1047 =
													 (long) (arity_398);
												      test_1046 =
													 (aux_1047 >= ((long) 0));
												   }
												   if (test_1046)
												     {	/* ./Ieee/pair-list.scm 5689 */
													obj_t aux_1050;
													aux_1050 =
													   append_2_18___r4_pairs_and_lists_6_3(args_id_103_399, BNIL);
													arg1302_479 =
													   MAKE_PAIR(method_397, aux_1050);
												     }
												   else
												     {	/* Object/method.scm 61 */
													obj_t arg1307_483;
													obj_t arg1308_484;
													arg1307_483 =
													   CNST_TABLE_REF(((long) 10));
													{	/* Object/method.scm 62 */
													   obj_t arg1309_485;
													   {	/* Object/method.scm 62 */
													      obj_t arg1313_486;
													      {		/* ./Ieee/pair-list.scm 5689 */
														 obj_t aux_1056;
														 obj_t aux_1054;
														 aux_1056 =
														    append_2_18___r4_pairs_and_lists_6_3(args_id_103_399, BNIL);
														 aux_1054 =
														    CNST_TABLE_REF(((long) 11));
														 arg1313_486 =
														    MAKE_PAIR(aux_1054, aux_1056);
													      }
													      arg1309_485 =
														 MAKE_PAIR(arg1313_486, BNIL);
													   }
													   arg1308_484 =
													      MAKE_PAIR(method_397, arg1309_485);
													}
													arg1302_479 =
													   MAKE_PAIR(arg1307_483, arg1308_484);
												     }
												}
												{	/* Object/method.scm 63 */
												   obj_t arg1318_490;
												   {	/* Object/method.scm 63 */
												      obj_t arg1320_492;
												      obj_t arg1322_493;
												      arg1320_492 =
													 CNST_TABLE_REF(((long) 12));
												      {		/* Object/method.scm 64 */
													 obj_t arg1323_494;
													 obj_t arg1325_495;
													 {	/* Object/method.scm 64 */
													    obj_t arg1326_496;
													    obj_t arg1327_497;
													    arg1326_496 =
													       CNST_TABLE_REF(((long) 13));
													    {	/* Object/method.scm 64 */
													       obj_t arg1329_498;
													       arg1329_498 =
														  MAKE_PAIR(method_397, BNIL);
													       arg1327_497 =
														  MAKE_PAIR(id_396, arg1329_498);
													    }
													    arg1323_494 =
													       MAKE_PAIR(arg1326_496, arg1327_497);
													 }
													 {	/* Object/method.scm 66 */
													    obj_t arg1330_499;
													    {	/* Object/method.scm 66 */
													       bool_t test_1067;
													       {	/* ./Ieee/fixnum.scm 7133 */
														  long aux_1068;
														  aux_1068 =
														     (long) (arity_398);
														  test_1067 =
														     (aux_1068 >= ((long) 0));
													       }
													       if (test_1067)
														 {	/* ./Ieee/pair-list.scm 5689 */
														    obj_t aux_1071;
														    aux_1071 =
														       append_2_18___r4_pairs_and_lists_6_3(args_id_103_399, BNIL);
														    arg1330_499 =
														       MAKE_PAIR(id_396, aux_1071);
														 }
													       else
														 {	/* Object/method.scm 68 */
														    obj_t arg1334_503;
														    obj_t arg1335_504;
														    arg1334_503 =
														       CNST_TABLE_REF(((long) 10));
														    {	/* Object/method.scm 70 */
														       obj_t arg1336_505;
														       {	/* Object/method.scm 70 */
															  obj_t arg1337_506;
															  {	/* ./Ieee/pair-list.scm 5689 */
															     obj_t aux_1077;
															     obj_t aux_1075;
															     aux_1077 =
																append_2_18___r4_pairs_and_lists_6_3(args_id_103_399, BNIL);
															     aux_1075 =
																CNST_TABLE_REF(((long) 11));
															     arg1337_506 =
																MAKE_PAIR(aux_1075, aux_1077);
															  }
															  arg1336_505 =
															     MAKE_PAIR(arg1337_506, BNIL);
														       }
														       arg1335_504 =
															  MAKE_PAIR(id_396, arg1336_505);
														    }
														    arg1330_499 =
														       MAKE_PAIR(arg1334_503, arg1335_504);
														 }
													    }
													    arg1325_495 =
													       MAKE_PAIR(arg1330_499, BNIL);
													 }
													 arg1322_493 =
													    MAKE_PAIR(arg1323_494, arg1325_495);
												      }
												      arg1318_490 =
													 MAKE_PAIR(arg1320_492, arg1322_493);
												   }
												   arg1303_480 =
												      MAKE_PAIR(arg1318_490, BNIL);
												}
												arg1299_476 =
												   MAKE_PAIR(arg1302_479, arg1303_480);
											     }
											     arg1297_474 =
												MAKE_PAIR(arg1298_475, arg1299_476);
											  }
											  arg1294_471 =
											     MAKE_PAIR(arg1296_473, arg1297_474);
										       }
										       arg1271_454 =
											  MAKE_PAIR(arg1294_471, BNIL);
										    }
										    arg1269_452 =
										       MAKE_PAIR(arg1270_453, arg1271_454);
										 }
										 arg1265_449 =
										    MAKE_PAIR(arg1268_451, arg1269_452);
									      }
									      arg1264_448 =
										 MAKE_PAIR(arg1265_449, BNIL);
									   }
									   arg1261_446 =
									      MAKE_PAIR(BNIL, arg1264_448);
									}
									arg1258_443 =
									   MAKE_PAIR(arg1260_445, arg1261_446);
								     }
								     arg1256_441 =
									MAKE_PAIR(arg1258_443, BNIL);
								  }
								  arg1257_442 =
								     MAKE_PAIR(body_4, BNIL);
								  arg1255_440 =
								     MAKE_PAIR(arg1256_441, arg1257_442);
							       }
							       body_408 =
								  MAKE_PAIR(arg1254_439, arg1255_440);
							    }
							    {	/* Object/method.scm 52 */
							       obj_t ebody_409;
							       {	/* Object/method.scm 72 */
								  bool_t test1250_435;
								  test1250_435 =
								     EXTENDED_PAIRP(src_5);
								  if (test1250_435)
								    {	/* Object/method.scm 73 */
								       obj_t arg1251_436;
								       obj_t arg1252_437;
								       obj_t arg1253_438;
								       arg1251_436 =
									  CAR(body_408);
								       arg1252_437 =
									  CDR(body_408);
								       {	/* ./Ieee/pair-list.scm 5713 */
									  bool_t test1136_815;
									  test1136_815 =
									     EXTENDED_PAIRP(src_5);
									  if (test1136_815)
									    {	/* ./Ieee/pair-list.scm 5713 */
									       arg1253_438 =
										  CER(src_5);
									    }
									  else
									    {	/* ./Ieee/pair-list.scm 5713 */
									       FAILURE(string1425_object_method, string1426_object_method, src_5);
									    }
								       }
								       ebody_409 =
									  MAKE_EXTENDED_PAIR(arg1251_436, arg1252_437, arg1253_438);
								    }
								  else
								    {	/* Object/method.scm 72 */
								       ebody_409 = body_408;
								    }
							       }
							       {	/* Object/method.scm 72 */
								  obj_t bdg_410;
								  {	/* Object/method.scm 75 */
								     obj_t arg1248_433;
								     {	/* Object/method.scm 75 */
									obj_t arg1249_434;
									arg1249_434 =
									   MAKE_PAIR(ebody_409, BNIL);
									arg1248_433 =
									   MAKE_PAIR(args_2, arg1249_434);
								     }
								     bdg_410 =
									MAKE_PAIR(m_id_75_401, arg1248_433);
								  }
								  {	/* Object/method.scm 75 */
								     obj_t ebdg_411;
								     {	/* Object/method.scm 76 */
									bool_t test1241_429;
									test1241_429 =
									   EXTENDED_PAIRP(src_5);
									if (test1241_429)
									  {	/* Object/method.scm 77 */
									     obj_t arg1243_430;
									     obj_t arg1245_431;
									     obj_t arg1246_432;
									     arg1243_430 =
										CAR(bdg_410);
									     arg1245_431 =
										CDR(bdg_410);
									     {	/* ./Ieee/pair-list.scm 5713 */
										bool_t test1136_833;
										test1136_833 =
										   EXTENDED_PAIRP(src_5);
										if (test1136_833)
										  {	/* ./Ieee/pair-list.scm 5713 */
										     arg1246_432 =
											CER(src_5);
										  }
										else
										  {	/* ./Ieee/pair-list.scm 5713 */
										     FAILURE(string1425_object_method, string1426_object_method, src_5);
										  }
									     }
									     ebdg_411 =
										MAKE_EXTENDED_PAIR(arg1243_430, arg1245_431, arg1246_432);
									  }
									else
									  {	/* Object/method.scm 76 */
									     ebdg_411 = bdg_410;
									  }
								     }
								     {	/* Object/method.scm 76 */

									{	/* Object/method.scm 79 */
									   obj_t arg1222_412;
									   {	/* Object/method.scm 79 */
									      obj_t arg1224_414;
									      obj_t arg1226_415;
									      arg1224_414 =
										 CNST_TABLE_REF(((long) 3));
									      {		/* Object/method.scm 79 */
										 obj_t arg1227_416;
										 obj_t arg1228_417;
										 arg1227_416 =
										    MAKE_PAIR(ebdg_411, BNIL);
										 {	/* Object/method.scm 80 */
										    obj_t arg1229_418;
										    {	/* Object/method.scm 80 */
										       obj_t arg1231_420;
										       obj_t arg1232_421;
										       arg1231_420 =
											  CNST_TABLE_REF(((long) 14));
										       {	/* Object/method.scm 81 */
											  obj_t arg1233_422;
											  {	/* Object/method.scm 81 */
											     obj_t arg1234_423;
											     obj_t arg1235_424;
											     {	/* Object/method.scm 81 */
												obj_t arg1236_425;
												obj_t arg1237_426;
												arg1236_425 =
												   CNST_TABLE_REF(((long) 7));
												{	/* Object/method.scm 81 */
												   obj_t arg1238_427;
												   obj_t arg1240_428;
												   arg1238_427 =
												      (((global_bglt) CREF(holder_403))->id);
												   arg1240_428 =
												      MAKE_PAIR(module_404, BNIL);
												   arg1237_426 =
												      MAKE_PAIR(arg1238_427, arg1240_428);
												}
												arg1234_423 =
												   MAKE_PAIR(arg1236_425, arg1237_426);
											     }
											     arg1235_424 =
												MAKE_PAIR(m_id_75_401, BNIL);
											     arg1233_422 =
												MAKE_PAIR(arg1234_423, arg1235_424);
											  }
											  arg1232_421 =
											     MAKE_PAIR(id_396, arg1233_422);
										       }
										       arg1229_418 =
											  MAKE_PAIR(arg1231_420, arg1232_421);
										    }
										    arg1228_417 =
										       MAKE_PAIR(arg1229_418, BNIL);
										 }
										 arg1226_415 =
										    MAKE_PAIR(arg1227_416, arg1228_417);
									      }
									      arg1222_412 =
										 MAKE_PAIR(arg1224_414, arg1226_415);
									   }
									   {	/* Object/method.scm 79 */
									      obj_t list1223_413;
									      list1223_413 =
										 MAKE_PAIR(arg1222_412, BNIL);
									      return list1223_413;
									   }
									}
								     }
								  }
							       }
							    }
							 }
						      }
						    else
						      {		/* Object/method.scm 50 */
							 add_generic_for_method_inlining__147_object_inline(generic_405);
							 {	/* Object/method.scm 89 */
							    long num_510;
							    num_510 =
							       add_generic_method__111_object_inline(
							       (global_bglt) (generic_405), type_400, args_2, body_4);
							    {	/* Object/method.scm 90 */
							       obj_t arg1342_511;
							       {	/* Object/method.scm 90 */
								  obj_t arg1344_513;
								  obj_t arg1346_514;
								  arg1344_513 =
								     CNST_TABLE_REF(((long) 15));
								  {	/* Object/method.scm 92 */
								     obj_t arg1347_515;
								     {	/* Object/method.scm 92 */
									obj_t arg1348_516;
									obj_t arg1350_517;
									{	/* Object/method.scm 92 */
									   obj_t arg1354_518;
									   obj_t arg1355_519;
									   arg1354_518 =
									      CNST_TABLE_REF(((long) 7));
									   {	/* Object/method.scm 92 */
									      obj_t arg1356_520;
									      obj_t arg1357_521;
									      arg1356_520 =
										 (((global_bglt) CREF(holder_403))->id);
									      arg1357_521 =
										 MAKE_PAIR(module_404, BNIL);
									      arg1355_519 =
										 MAKE_PAIR(arg1356_520, arg1357_521);
									   }
									   arg1348_516 =
									      MAKE_PAIR(arg1354_518, arg1355_519);
									}
									{	/* ./Ieee/pair-list.scm 5689 */
									   obj_t aux_1146;
									   aux_1146 =
									      BINT(num_510);
									   arg1350_517 =
									      MAKE_PAIR(aux_1146, BNIL);
									}
									arg1347_515 =
									   MAKE_PAIR(arg1348_516, arg1350_517);
								     }
								     arg1346_514 =
									MAKE_PAIR(id_396, arg1347_515);
								  }
								  arg1342_511 =
								     MAKE_PAIR(arg1344_513, arg1346_514);
							       }
							       {	/* Object/method.scm 90 */
								  obj_t list1343_512;
								  list1343_512 =
								     MAKE_PAIR(arg1342_511, BNIL);
								  return list1343_512;
							       }
							    }
							 }
						      }
						 }
					       else
						 {	/* Object/method.scm 48 */
						    {	/* Object/method.scm 99 */
						       obj_t arg1385_884;
						       {	/* Object/method.scm 99 */
							  obj_t list1387_885;
							  {	/* Object/method.scm 99 */
							     obj_t aux_1153;
							     aux_1153 =
								CNST_TABLE_REF(((long) 16));
							     list1387_885 =
								MAKE_PAIR(aux_1153, BNIL);
							  }
							  arg1385_884 = list1387_885;
						       }
						       {	/* Object/method.scm 99 */
							  obj_t list1386_886;
							  list1386_886 =
							     MAKE_PAIR(arg1385_884, BNIL);
							  return
							     user_error_151_tools_error(id_396, string1427_object_method, src_5, list1386_886);
						       }
						    }
						 }
					    }
					 }
				      }
				   }
				}
			      else
				{	/* Object/method.scm 99 */
				   obj_t arg1385_891;
				   {	/* Object/method.scm 99 */
				      obj_t list1387_892;
				      {		/* Object/method.scm 99 */
					 obj_t aux_1158;
					 aux_1158 =
					    CNST_TABLE_REF(((long) 16));
					 list1387_892 =
					    MAKE_PAIR(aux_1158, BNIL);
				      }
				      arg1385_891 = list1387_892;
				   }
				   {	/* Object/method.scm 99 */
				      obj_t list1386_893;
				      list1386_893 =
					 MAKE_PAIR(arg1385_891, BNIL);
				      return
					 user_error_151_tools_error(id_396, string1428_object_method, src_5, list1386_893);
				   }
				}
			   }
			}
		     }
		  }
	       }
	    }
	 }
      }
   }
}



/* _make-method-body */
obj_t 
_make_method_body_16_object_method(obj_t env_925, obj_t id_926, obj_t args_927, obj_t locals_928, obj_t body_929, obj_t src_930)
{
   AN_OBJECT;
   {	/* Object/method.scm 30 */
      return
	 make_method_body_103_object_method(id_926, args_927, locals_928, body_929, src_930);
   }
}



/* method-init */
obj_t 
method_init_76_object_method()
{
   AN_OBJECT;
   {	/* Object/method.scm 14 */
      return BUNSPEC;
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_object_method()
{
   AN_OBJECT;
   {	/* Object/method.scm 14 */
      module_initialization_70_tools_args(((long) 0), "OBJECT_METHOD");
      module_initialization_70_tools_error(((long) 0), "OBJECT_METHOD");
      module_initialization_70_tools_misc(((long) 0), "OBJECT_METHOD");
      module_initialization_70_type_type(((long) 0), "OBJECT_METHOD");
      module_initialization_70_ast_var(((long) 0), "OBJECT_METHOD");
      module_initialization_70_ast_ident(((long) 0), "OBJECT_METHOD");
      module_initialization_70_ast_env(((long) 0), "OBJECT_METHOD");
      module_initialization_70_object_class(((long) 0), "OBJECT_METHOD");
      module_initialization_70_object_inline(((long) 0), "OBJECT_METHOD");
      return
	 module_initialization_70_tools_location(((long) 0), "OBJECT_METHOD");
   }
}
