/*===========================================================================*/
/*   (Object/plain-access.scm)                                               */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct tclass
  {
     obj_t its_super_214;
     obj_t slots;
     struct global *holder;
     obj_t widening;
     long depth;
     bool_t final__12;
     obj_t constructor;
     obj_t virtual_slots_number_200;
  }
      *tclass_bglt;

typedef struct ccomp
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t producer;
     obj_t consumer;
     obj_t finalizer;
     obj_t checksummer;
  }
     *ccomp_bglt;


extern obj_t append___r4_pairs_and_lists_6_3(obj_t);
static obj_t method_init_76_object_plain_access_186();
extern obj_t string_append(obj_t, obj_t);
extern obj_t type_type_type;
extern obj_t make_class_makes__132_object_access(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static bool_t correct_plain_class__49_object_plain_access_186(type_bglt, obj_t);
extern obj_t _res1__155___r5_control_features_6_4;
extern obj_t make_struct__object_35_object_struct(obj_t, type_bglt, obj_t, obj_t, obj_t);
extern obj_t global_ast_var;
extern obj_t user_error_151_tools_error(obj_t, obj_t, obj_t, obj_t);
extern obj_t make_class_pred__174_object_access(obj_t, tclass_bglt, obj_t, obj_t);
extern obj_t make_class_slots_205_object_slots(tclass_bglt, obj_t, obj_t, int, obj_t);
extern obj_t notify_assert_fail_37___eval(obj_t, obj_t, obj_t);
extern obj_t make_class_coercers_236_object_access(obj_t);
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t module_initialization_70_object_plain_access_186(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_tools_misc(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_env(long, char *);
extern obj_t module_initialization_70_type_tools(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_ident(long, char *);
extern obj_t module_initialization_70_object_class(long, char *);
extern obj_t module_initialization_70_object_struct(long, char *);
extern obj_t module_initialization_70_object_slots(long, char *);
extern obj_t module_initialization_70_object_tools(long, char *);
extern obj_t module_initialization_70_object_access(long, char *);
extern obj_t module_initialization_70_module_module(long, char *);
extern obj_t module_initialization_70_module_impuse(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___eval(long, char *);
extern obj_t module_initialization_70___evenv(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r5_control_features_6_4(long, char *);
extern bool_t wide_class__100_object_class(obj_t);
static obj_t _make_plain_class_accessors__116_object_plain_access_186(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t make_class_slots_access__80_object_access(tclass_bglt, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t define_primop_ref__105___evenv(obj_t, obj_t);
extern obj_t make_plain_class_accessors_sans_makes__96_object_plain_access_186(obj_t, type_bglt, obj_t, obj_t);
static obj_t imported_modules_init_94_object_plain_access_186();
extern obj_t unbind_primop__163___evenv(obj_t);
extern obj_t make_coercion_clause_209_object_access(obj_t, obj_t);
static obj_t _import_plain_class_accessors__22_object_plain_access_186(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t get_local_virtual_slots_number_139_object_slots(tclass_bglt, obj_t);
extern obj_t make_object__struct_189_object_struct(obj_t, type_bglt, obj_t, obj_t, obj_t);
extern obj_t produce_module_clause__172_module_module(obj_t);
extern obj_t append_2_18___r4_pairs_and_lists_6_3(obj_t, obj_t);
static obj_t library_modules_init_112_object_plain_access_186();
extern obj_t import_class_slots_access__39_object_access(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t _make_plain_class_accessors_sans_makes_1379_236_object_plain_access_186(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t toplevel_init_63_object_plain_access_186();
extern obj_t open_input_string(obj_t);
extern obj_t import_class_pred__91_object_access(obj_t, tclass_bglt, obj_t, obj_t);
extern obj_t tclass_object_class;
extern obj_t memq___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern obj_t make_plain_class_accessors__206_object_plain_access_186(obj_t, type_bglt, obj_t, obj_t);
static obj_t _import_plain_class_makes_1380_177_object_plain_access_186(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t import_plain_class_accessors__109_object_plain_access_186(obj_t, type_bglt, obj_t, obj_t);
extern obj_t internal_error_43_tools_error(obj_t, obj_t, obj_t);
extern obj_t _res_number__75___r5_control_features_6_4;
extern obj_t _module__166_module_module;
extern obj_t read___reader(obj_t);
extern obj_t import_class_makes__192_object_access(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t import_plain_class_makes__28_object_plain_access_186(obj_t, type_bglt, obj_t, obj_t);
extern obj_t make_class_allocate__44_object_access(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t require_initialization_114_object_plain_access_186 = BUNSPEC;
extern bool_t final_class__126_object_class(obj_t);
static obj_t cnst_init_137_object_plain_access_186();
static obj_t __cnst[11];

DEFINE_EXPORT_PROCEDURE(import_plain_class_makes__env_131_object_plain_access_186, _import_plain_class_makes_1380_177_object_plain_access_1861392, _import_plain_class_makes_1380_177_object_plain_access_186, 0L, 4);
DEFINE_EXPORT_PROCEDURE(make_plain_class_accessors__env_227_object_plain_access_186, _make_plain_class_accessors__116_object_plain_access_1861393, _make_plain_class_accessors__116_object_plain_access_186, 0L, 4);
DEFINE_EXPORT_PROCEDURE(make_plain_class_accessors_sans_makes__env_158_object_plain_access_186, _make_plain_class_accessors_sans_makes_1379_236_object_plain_access_1861394, _make_plain_class_accessors_sans_makes_1379_236_object_plain_access_186, 0L, 4);
DEFINE_EXPORT_PROCEDURE(import_plain_class_accessors__env_45_object_plain_access_186, _import_plain_class_accessors__22_object_plain_access_1861395, _import_plain_class_accessors__22_object_plain_access_186, 0L, 4);
DEFINE_STRING(string1387_object_plain_access_186, string1387_object_plain_access_1861396, "(\"/home/tahoe2/serrano/tmp/bigloo/comptime/Object/plain-access.scm\" . 9460) (\"/home/tahoe2/serrano/tmp/bigloo/comptime/Object/plain-access.scm\" . 8068) (\"/home/tahoe2/serrano/tmp/bigloo/comptime/Object/plain-access.scm\" . 5951) MAKE FOREIGN (\"/home/tahoe2/serrano/tmp/bigloo/comptime/Object/plain-access.scm\" . 3471) (BEGIN (GLOBAL? HOLDER)) (HOLDER) HOLDER STATIC (EXPORT STATIC) ", 381);
DEFINE_STRING(string1386_object_plain_access_186, string1386_object_plain_access_1861397, "Only wide classes can inherit of final classes", 46);
DEFINE_STRING(string1385_object_plain_access_186, string1385_object_plain_access_1861398, "' is a wide class", 17);
DEFINE_STRING(string1384_object_plain_access_186, string1384_object_plain_access_1861399, "Should not be able to see a wide class here", 43);
DEFINE_STRING(string1383_object_plain_access_186, string1383_object_plain_access_1861400, "make-class-accesses!", 20);
DEFINE_STRING(string1382_object_plain_access_186, string1382_object_plain_access_1861401, "super of `", 10);
DEFINE_STRING(string1381_object_plain_access_186, string1381_object_plain_access_1861402, "' is not a class", 16);



/* module-initialization */
obj_t 
module_initialization_70_object_plain_access_186(long checksum_987, char *from_988)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_object_plain_access_186))
	{
	   require_initialization_114_object_plain_access_186 =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_object_plain_access_186();
	   cnst_init_137_object_plain_access_186();
	   imported_modules_init_94_object_plain_access_186();
	   method_init_76_object_plain_access_186();
	   toplevel_init_63_object_plain_access_186();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_object_plain_access_186()
{
   AN_OBJECT;
   {	/* Object/plain-access.scm 20 */
      module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "OBJECT_PLAIN-ACCESS");
      module_initialization_70___r5_control_features_6_4(((long) 0), "OBJECT_PLAIN-ACCESS");
      module_initialization_70___eval(((long) 0), "OBJECT_PLAIN-ACCESS");
      module_initialization_70___object(((long) 0), "OBJECT_PLAIN-ACCESS");
      module_initialization_70___evenv(((long) 0), "OBJECT_PLAIN-ACCESS");
      module_initialization_70___reader(((long) 0), "OBJECT_PLAIN-ACCESS");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_object_plain_access_186()
{
   AN_OBJECT;
   {	/* Object/plain-access.scm 20 */
      {		/* Object/plain-access.scm 20 */
	 obj_t cnst_port_138_980;
	 cnst_port_138_980 =
	    open_input_string(string1387_object_plain_access_186);
	 {
	    long i_981;
	    i_981 = ((long) 10);
	  loop_982:
	    {	/* Object/plain-access.scm 20 */
	       bool_t test1388_983;
	       test1388_983 =
		  (i_981 == ((long) -1));
	       if (test1388_983)
		 {	/* Object/plain-access.scm 20 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Object/plain-access.scm 20 */
		    {	/* Object/plain-access.scm 20 */
		       obj_t arg1389_984;
		       {	/* Object/plain-access.scm 20 */
			  obj_t list1390_985;
			  list1390_985 =
			     MAKE_PAIR(cnst_port_138_980, BNIL);
			  arg1389_984 =
			     read___reader(list1390_985);
		       }
		       CNST_TABLE_SET(i_981, arg1389_984);
		    }
		    {	/* Object/plain-access.scm 20 */
		       int aux_986;
		       {	/* Object/plain-access.scm 20 */
			  long aux_1009;
			  aux_1009 =
			     (i_981 - ((long) 1));
			  aux_986 =
			     (int) (aux_1009);
		       }
		       {
			  long i_1012;
			  i_1012 =
			     (long) (aux_986);
			  i_981 = i_1012;
			  goto loop_982;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_object_plain_access_186()
{
   AN_OBJECT;
   {	/* Object/plain-access.scm 20 */
      return BUNSPEC;
   }
}



/* make-plain-class-accessors! */
obj_t 
make_plain_class_accessors__206_object_plain_access_186(obj_t class_def_12_71, type_bglt class_72, obj_t src_def_101_73, obj_t import_74)
{
   AN_OBJECT;
   {	/* Object/plain-access.scm 47 */
      {		/* Object/plain-access.scm 50 */
	 bool_t test1234_497;
	 test1234_497 =
	    correct_plain_class__49_object_plain_access_186(class_72, src_def_101_73);
	 if (test1234_497)
	   {	/* Object/plain-access.scm 51 */
	      obj_t super_498;
	      {		/* Object/plain-access.scm 51 */
		 tclass_bglt obj_838;
		 obj_838 =
		    (tclass_bglt) (class_72);
		 {
		    obj_t aux_1017;
		    {	/* ./Object/class.scm 1118 */
		       object_bglt aux_1018;
		       aux_1018 =
			  (object_bglt) (obj_838);
		       aux_1017 =
			  OBJECT_WIDENING(aux_1018);
		    }
		    super_498 =
		       (((tclass_bglt) CREF(aux_1017))->its_super_214);
		 }
	      }
	      {		/* Object/plain-access.scm 51 */
		 obj_t super_vnum_51_499;
		 {	/* Object/plain-access.scm 52 */
		    bool_t test1262_536;
		    test1262_536 =
		       is_a__118___object(super_498, tclass_object_class);
		    if (test1262_536)
		      {		/* Object/plain-access.scm 53 */
			 tclass_bglt obj_840;
			 obj_840 =
			    (tclass_bglt) (super_498);
			 {
			    obj_t aux_1025;
			    {	/* ./Object/class.scm 1134 */
			       object_bglt aux_1026;
			       aux_1026 =
				  (object_bglt) (obj_840);
			       aux_1025 =
				  OBJECT_WIDENING(aux_1026);
			    }
			    super_vnum_51_499 =
			       (((tclass_bglt) CREF(aux_1025))->virtual_slots_number_200);
			 }
		      }
		    else
		      {		/* Object/plain-access.scm 52 */
			 super_vnum_51_499 =
			    BINT(((long) 0));
		      }
		 }
		 {	/* Object/plain-access.scm 52 */
		    obj_t domestic__170_500;
		    domestic__170_500 =
		       memq___r4_pairs_and_lists_6_3(import_74,
		       CNST_TABLE_REF(((long) 0)));
		    {	/* Object/plain-access.scm 56 */
		       obj_t cslots_502;
		       {	/* Object/plain-access.scm 57 */
			  obj_t aux_1038;
			  obj_t aux_1033;
			  {	/* Object/plain-access.scm 58 */
			     bool_t test_1039;
			     {	/* ./Ieee/equiv.scm 5508 */
				obj_t aux_1040;
				aux_1040 =
				   (obj_t) (class_72);
				test_1039 =
				   (super_498 == aux_1040);
			     }
			     if (test_1039)
			       {	/* Object/plain-access.scm 58 */
				  aux_1038 = BFALSE
				     ;
			       }
			     else
			       {	/* Object/plain-access.scm 58 */
				  aux_1038 = super_498
				     ;
			       }
			  }
			  {	/* ./Ieee/pair-list.scm 5707 */
			     obj_t aux_1035;
			     aux_1035 =
				CDR(class_def_12_71);
			     aux_1033 =
				CDR(aux_1035);
			  }
			  cslots_502 =
			     make_class_slots_205_object_slots(
			     (tclass_bglt) (class_72), aux_1033, aux_1038,
			     CINT(super_vnum_51_499), src_def_101_73);
		       }
		       {	/* Object/plain-access.scm 57 */
			  obj_t class_id_86_503;
			  class_id_86_503 =
			     (((type_bglt) CREF(class_72))->id);
			  {	/* Object/plain-access.scm 62 */
			     global_bglt holder_505;
			     {	/* Object/plain-access.scm 63 */
				tclass_bglt obj_849;
				obj_849 =
				   (tclass_bglt) (class_72);
				{
				   obj_t aux_1047;
				   {	/* ./Object/class.scm 1124 */
				      object_bglt aux_1048;
				      aux_1048 =
					 (object_bglt) (obj_849);
				      aux_1047 =
					 OBJECT_WIDENING(aux_1048);
				   }
				   holder_505 =
				      (((tclass_bglt) CREF(aux_1047))->holder);
				}
			     }
			     {	/* Object/plain-access.scm 63 */
				obj_t import_506;
				if (
				   CBOOL(domestic__170_500))
				  {	/* Object/plain-access.scm 64 */
				     import_506 = import_74;
				  }
				else
				  {	/* Object/plain-access.scm 64 */
				     import_506 =
					CNST_TABLE_REF(((long) 1));
				  }
				{	/* Object/plain-access.scm 64 */
				   obj_t local_vnum_209_507;
				   local_vnum_209_507 =
				      get_local_virtual_slots_number_139_object_slots(
				      (tclass_bglt) (class_72), cslots_502);
				   {	/* Object/plain-access.scm 67 */

				      {		/* Object/plain-access.scm 74 */
					 tclass_bglt obj_850;
					 obj_850 =
					    (tclass_bglt) (class_72);
					 {
					    obj_t aux_1058;
					    {	/* ./Object/class.scm 1134 */
					       object_bglt aux_1059;
					       aux_1059 =
						  (object_bglt) (obj_850);
					       aux_1058 =
						  OBJECT_WIDENING(aux_1059);
					    }
					    ((((tclass_bglt) CREF(aux_1058))->virtual_slots_number_200) = ((obj_t) local_vnum_209_507), BUNSPEC);
					 }
				      }
				      {		/* Object/plain-access.scm 77 */
					 obj_t arg1235_508;
					 arg1235_508 =
					    make_coercion_clause_209_object_access(class_id_86_503, super_498);
					 produce_module_clause__172_module_module(arg1235_508);
				      }
				      {		/* Object/plain-access.scm 78 */
					 bool_t test1236_509;
					 test1236_509 =
					    is_a__118___object(
					    (obj_t) (holder_505), global_ast_var);
					 if (test1236_509)
					   {	/* Object/plain-access.scm 78 */
					      BUNSPEC;
					   }
					 else
					   {	/* Object/plain-access.scm 78 */
					      {		/* Object/plain-access.scm 78 */
						 obj_t arg1237_510;
						 obj_t arg1238_511;
						 arg1237_510 =
						    CNST_TABLE_REF(((long) 2));
						 {	/* Object/plain-access.scm 78 */
						    obj_t aux_1069;
						    aux_1069 =
						       (obj_t) (holder_505);
						    arg1238_511 =
						       __EVMEANING_ADDRESS(aux_1069);
						 }
						 define_primop_ref__105___evenv(arg1237_510, arg1238_511);
					      }
					      notify_assert_fail_37___eval(
						 CNST_TABLE_REF(((long) 3)),
						 CNST_TABLE_REF(((long) 4)),
						 CNST_TABLE_REF(((long) 5)));
					      unbind_primop__163___evenv(
						 CNST_TABLE_REF(((long) 2)));
					   }
				      }
				      {		/* Object/plain-access.scm 79 */
					 tclass_bglt obj_853;
					 obj_853 =
					    (tclass_bglt) (class_72);
					 {
					    obj_t aux_1080;
					    {	/* ./Object/class.scm 1122 */
					       object_bglt aux_1081;
					       aux_1081 =
						  (object_bglt) (obj_853);
					       aux_1080 =
						  OBJECT_WIDENING(aux_1081);
					    }
					    ((((tclass_bglt) CREF(aux_1080))->slots) = ((obj_t) cslots_502), BUNSPEC);
					 }
				      }
				      {		/* Object/plain-access.scm 81 */
					 obj_t arg1240_512;
					 {	/* Object/plain-access.scm 81 */
					    obj_t arg1241_513;
					    obj_t arg1243_514;
					    arg1241_513 =
					       CNST_TABLE_REF(((long) 6));
					    {	/* Object/plain-access.scm 81 */
					       obj_t arg1245_515;
					       arg1245_515 =
						  make_class_coercers_236_object_access(
						  (obj_t) (class_72));
					       arg1243_514 =
						  append_2_18___r4_pairs_and_lists_6_3(arg1245_515, BNIL);
					    }
					    arg1240_512 =
					       MAKE_PAIR(arg1241_513, arg1243_514);
					 }
					 produce_module_clause__172_module_module(arg1240_512);
				      }
				      {		/* Object/plain-access.scm 83 */
					 obj_t access_517;
					 access_517 =
					    make_class_slots_access__80_object_access(
					    (tclass_bglt) (class_72),
					    (obj_t) (class_72), cslots_502, BFALSE, src_def_101_73, import_506);
					 {	/* Object/plain-access.scm 85 */
					    obj_t virtuals_518;
					    virtuals_518 = _res1__155___r5_control_features_6_4;
					    {	/* Object/plain-access.scm 85 */
					       obj_t accs_519;
					       {	/* Object/plain-access.scm 85 */
						  obj_t arg1255_529;
						  obj_t arg1256_530;
						  arg1255_529 =
						     make_class_pred__174_object_access(class_id_86_503,
						     (tclass_bglt) (class_72), src_def_101_73, import_506);
						  arg1256_530 =
						     make_class_makes__132_object_access(
						     CNST_TABLE_REF(((long) 7)),
						     CNST_TABLE_REF(((long) 7)), class_id_86_503,
						     (obj_t) (class_72), cslots_502, src_def_101_73, import_506);
						  {	/* Object/plain-access.scm 85 */
						     obj_t list1257_531;
						     {	/* Object/plain-access.scm 85 */
							obj_t arg1258_532;
							{	/* Object/plain-access.scm 85 */
							   obj_t arg1259_533;
							   arg1259_533 =
							      MAKE_PAIR(access_517, BNIL);
							   arg1258_532 =
							      MAKE_PAIR(arg1256_530, arg1259_533);
							}
							list1257_531 =
							   MAKE_PAIR(arg1255_529, arg1258_532);
						     }
						     accs_519 =
							append___r4_pairs_and_lists_6_3(list1257_531);
						  }
					       }
					       {	/* Object/plain-access.scm 92 */
						  obj_t val0_1221_520;
						  {	/* Object/plain-access.scm 93 */
						     obj_t arg1248_522;
						     obj_t arg1249_523;
						     arg1248_522 =
							make_class_allocate__44_object_access(class_id_86_503,
							(obj_t) (class_72),
							(obj_t) (holder_505), src_def_101_73, import_506);
						     {	/* Object/plain-access.scm 95 */
							bool_t test1250_524;
							{	/* ./Type/type.scm 704 */
							   obj_t aux_1107;
							   {	/* Object/plain-access.scm 95 */
							      tclass_bglt obj_857;
							      obj_857 =
								 (tclass_bglt) (class_72);
							      {
								 obj_t aux_1109;
								 {	/* ./Object/class.scm 1118 */
								    object_bglt aux_1110;
								    aux_1110 =
								       (object_bglt) (obj_857);
								    aux_1109 =
								       OBJECT_WIDENING(aux_1110);
								 }
								 aux_1107 =
								    (((tclass_bglt) CREF(aux_1109))->its_super_214);
							      }
							   }
							   test1250_524 =
							      is_a__118___object(aux_1107, type_type_type);
							}
							if (test1250_524)
							  {	/* Object/plain-access.scm 95 */
							     if (
								CBOOL(domestic__170_500))
							       {	/* Object/plain-access.scm 98 */
								  obj_t arg1251_525;
								  obj_t arg1252_526;
								  arg1251_525 =
								     make_object__struct_189_object_struct(class_id_86_503, class_72, _module__166_module_module, cslots_502, src_def_101_73);
								  {	/* Object/plain-access.scm 101 */
								     obj_t arg1253_527;
								     arg1253_527 =
									make_struct__object_35_object_struct(class_id_86_503, class_72, _module__166_module_module, cslots_502, src_def_101_73);
								     arg1252_526 =
									MAKE_PAIR(arg1253_527, accs_519);
								  }
								  arg1249_523 =
								     MAKE_PAIR(arg1251_525, arg1252_526);
							       }
							     else
							       {	/* Object/plain-access.scm 96 */
								  arg1249_523 = accs_519;
							       }
							  }
							else
							  {	/* Object/plain-access.scm 95 */
							     arg1249_523 = accs_519;
							  }
						     }
						     val0_1221_520 =
							MAKE_PAIR(arg1248_522, arg1249_523);
						  }
						  _res_number__75___r5_control_features_6_4 =
						     BINT(((long) 2));
						  _res1__155___r5_control_features_6_4 = virtuals_518;
						  return val0_1221_520;
					       }
					    }
					 }
				      }
				   }
				}
			     }
			  }
		       }
		    }
		 }
	      }
	   }
	 else
	   {	/* Object/plain-access.scm 50 */
	      return BNIL;
	   }
      }
   }
}



/* _make-plain-class-accessors! */
obj_t 
_make_plain_class_accessors__116_object_plain_access_186(obj_t env_959, obj_t class_def_12_960, obj_t class_961, obj_t src_def_101_962, obj_t import_963)
{
   AN_OBJECT;
   {	/* Object/plain-access.scm 47 */
      return
	 make_plain_class_accessors__206_object_plain_access_186(class_def_12_960,
	 (type_bglt) (class_961), src_def_101_962, import_963);
   }
}



/* make-plain-class-accessors-sans-makes! */
obj_t 
make_plain_class_accessors_sans_makes__96_object_plain_access_186(obj_t class_def_12_75, type_bglt class_76, obj_t src_def_101_77, obj_t import_78)
{
   AN_OBJECT;
   {	/* Object/plain-access.scm 113 */
      {		/* Object/plain-access.scm 116 */
	 bool_t test1263_537;
	 test1263_537 =
	    correct_plain_class__49_object_plain_access_186(class_76, src_def_101_77);
	 if (test1263_537)
	   {	/* Object/plain-access.scm 117 */
	      obj_t super_538;
	      {		/* Object/plain-access.scm 117 */
		 tclass_bglt obj_865;
		 obj_865 =
		    (tclass_bglt) (class_76);
		 {
		    obj_t aux_1129;
		    {	/* ./Object/class.scm 1118 */
		       object_bglt aux_1130;
		       aux_1130 =
			  (object_bglt) (obj_865);
		       aux_1129 =
			  OBJECT_WIDENING(aux_1130);
		    }
		    super_538 =
		       (((tclass_bglt) CREF(aux_1129))->its_super_214);
		 }
	      }
	      {		/* Object/plain-access.scm 117 */
		 obj_t super_vnum_51_539;
		 {	/* Object/plain-access.scm 118 */
		    bool_t test1289_572;
		    test1289_572 =
		       is_a__118___object(super_538, tclass_object_class);
		    if (test1289_572)
		      {		/* Object/plain-access.scm 119 */
			 tclass_bglt obj_867;
			 obj_867 =
			    (tclass_bglt) (super_538);
			 {
			    obj_t aux_1137;
			    {	/* ./Object/class.scm 1134 */
			       object_bglt aux_1138;
			       aux_1138 =
				  (object_bglt) (obj_867);
			       aux_1137 =
				  OBJECT_WIDENING(aux_1138);
			    }
			    super_vnum_51_539 =
			       (((tclass_bglt) CREF(aux_1137))->virtual_slots_number_200);
			 }
		      }
		    else
		      {		/* Object/plain-access.scm 118 */
			 super_vnum_51_539 =
			    BINT(((long) 0));
		      }
		 }
		 {	/* Object/plain-access.scm 118 */
		    obj_t domestic__170_540;
		    domestic__170_540 =
		       memq___r4_pairs_and_lists_6_3(import_78,
		       CNST_TABLE_REF(((long) 0)));
		    {	/* Object/plain-access.scm 122 */
		       obj_t cslots_542;
		       {	/* Object/plain-access.scm 123 */
			  obj_t aux_1150;
			  obj_t aux_1145;
			  {	/* Object/plain-access.scm 124 */
			     bool_t test_1151;
			     {	/* ./Ieee/equiv.scm 5508 */
				obj_t aux_1152;
				aux_1152 =
				   (obj_t) (class_76);
				test_1151 =
				   (super_538 == aux_1152);
			     }
			     if (test_1151)
			       {	/* Object/plain-access.scm 124 */
				  aux_1150 = BFALSE
				     ;
			       }
			     else
			       {	/* Object/plain-access.scm 124 */
				  aux_1150 = super_538
				     ;
			       }
			  }
			  {	/* ./Ieee/pair-list.scm 5707 */
			     obj_t aux_1147;
			     aux_1147 =
				CDR(class_def_12_75);
			     aux_1145 =
				CDR(aux_1147);
			  }
			  cslots_542 =
			     make_class_slots_205_object_slots(
			     (tclass_bglt) (class_76), aux_1145, aux_1150,
			     CINT(super_vnum_51_539), src_def_101_77);
		       }
		       {	/* Object/plain-access.scm 123 */
			  obj_t class_id_86_543;
			  class_id_86_543 =
			     (((type_bglt) CREF(class_76))->id);
			  {	/* Object/plain-access.scm 128 */
			     global_bglt holder_545;
			     {	/* Object/plain-access.scm 129 */
				tclass_bglt obj_876;
				obj_876 =
				   (tclass_bglt) (class_76);
				{
				   obj_t aux_1159;
				   {	/* ./Object/class.scm 1124 */
				      object_bglt aux_1160;
				      aux_1160 =
					 (object_bglt) (obj_876);
				      aux_1159 =
					 OBJECT_WIDENING(aux_1160);
				   }
				   holder_545 =
				      (((tclass_bglt) CREF(aux_1159))->holder);
				}
			     }
			     {	/* Object/plain-access.scm 129 */
				obj_t import_546;
				if (
				   CBOOL(domestic__170_540))
				  {	/* Object/plain-access.scm 130 */
				     import_546 = import_78;
				  }
				else
				  {	/* Object/plain-access.scm 130 */
				     import_546 =
					CNST_TABLE_REF(((long) 1));
				  }
				{	/* Object/plain-access.scm 130 */
				   obj_t local_vnum_209_547;
				   local_vnum_209_547 =
				      get_local_virtual_slots_number_139_object_slots(
				      (tclass_bglt) (class_76), cslots_542);
				   {	/* Object/plain-access.scm 133 */

				      {		/* Object/plain-access.scm 140 */
					 tclass_bglt obj_877;
					 obj_877 =
					    (tclass_bglt) (class_76);
					 {
					    obj_t aux_1170;
					    {	/* ./Object/class.scm 1134 */
					       object_bglt aux_1171;
					       aux_1171 =
						  (object_bglt) (obj_877);
					       aux_1170 =
						  OBJECT_WIDENING(aux_1171);
					    }
					    ((((tclass_bglt) CREF(aux_1170))->virtual_slots_number_200) = ((obj_t) local_vnum_209_547), BUNSPEC);
					 }
				      }
				      {		/* Object/plain-access.scm 143 */
					 obj_t arg1264_548;
					 arg1264_548 =
					    make_coercion_clause_209_object_access(class_id_86_543, super_538);
					 produce_module_clause__172_module_module(arg1264_548);
				      }
				      {		/* Object/plain-access.scm 144 */
					 bool_t test1265_549;
					 test1265_549 =
					    is_a__118___object(
					    (obj_t) (holder_545), global_ast_var);
					 if (test1265_549)
					   {	/* Object/plain-access.scm 144 */
					      BUNSPEC;
					   }
					 else
					   {	/* Object/plain-access.scm 144 */
					      {		/* Object/plain-access.scm 144 */
						 obj_t arg1267_550;
						 obj_t arg1268_551;
						 arg1267_550 =
						    CNST_TABLE_REF(((long) 2));
						 {	/* Object/plain-access.scm 144 */
						    obj_t aux_1181;
						    aux_1181 =
						       (obj_t) (holder_545);
						    arg1268_551 =
						       __EVMEANING_ADDRESS(aux_1181);
						 }
						 define_primop_ref__105___evenv(arg1267_550, arg1268_551);
					      }
					      notify_assert_fail_37___eval(
						 CNST_TABLE_REF(((long) 3)),
						 CNST_TABLE_REF(((long) 4)),
						 CNST_TABLE_REF(((long) 8)));
					      unbind_primop__163___evenv(
						 CNST_TABLE_REF(((long) 2)));
					   }
				      }
				      {		/* Object/plain-access.scm 145 */
					 tclass_bglt obj_880;
					 obj_880 =
					    (tclass_bglt) (class_76);
					 {
					    obj_t aux_1192;
					    {	/* ./Object/class.scm 1122 */
					       object_bglt aux_1193;
					       aux_1193 =
						  (object_bglt) (obj_880);
					       aux_1192 =
						  OBJECT_WIDENING(aux_1193);
					    }
					    ((((tclass_bglt) CREF(aux_1192))->slots) = ((obj_t) cslots_542), BUNSPEC);
					 }
				      }
				      {		/* Object/plain-access.scm 147 */
					 obj_t arg1269_552;
					 {	/* Object/plain-access.scm 147 */
					    obj_t arg1270_553;
					    obj_t arg1271_554;
					    arg1270_553 =
					       CNST_TABLE_REF(((long) 6));
					    {	/* Object/plain-access.scm 147 */
					       obj_t arg1272_555;
					       arg1272_555 =
						  make_class_coercers_236_object_access(
						  (obj_t) (class_76));
					       arg1271_554 =
						  append_2_18___r4_pairs_and_lists_6_3(arg1272_555, BNIL);
					    }
					    arg1269_552 =
					       MAKE_PAIR(arg1270_553, arg1271_554);
					 }
					 produce_module_clause__172_module_module(arg1269_552);
				      }
				      {		/* Object/plain-access.scm 149 */
					 obj_t access_557;
					 access_557 =
					    make_class_slots_access__80_object_access(
					    (tclass_bglt) (class_76),
					    (obj_t) (class_76), cslots_542, BFALSE, src_def_101_77, import_546);
					 {	/* Object/plain-access.scm 151 */
					    obj_t virtuals_558;
					    virtuals_558 = _res1__155___r5_control_features_6_4;
					    {	/* Object/plain-access.scm 151 */
					       obj_t accs_559;
					       {	/* Object/plain-access.scm 151 */
						  obj_t arg1286_569;
						  arg1286_569 =
						     make_class_pred__174_object_access(class_id_86_543,
						     (tclass_bglt) (class_76), src_def_101_77, import_546);
						  accs_559 =
						     append_2_18___r4_pairs_and_lists_6_3(arg1286_569, access_557);
					       }
					       {	/* Object/plain-access.scm 154 */
						  obj_t val0_1223_560;
						  {	/* Object/plain-access.scm 155 */
						     obj_t arg1274_562;
						     obj_t arg1276_563;
						     arg1274_562 =
							make_class_allocate__44_object_access(class_id_86_543,
							(obj_t) (class_76),
							(obj_t) (holder_545), src_def_101_77, import_546);
						     {	/* Object/plain-access.scm 157 */
							bool_t test1277_564;
							{	/* ./Type/type.scm 704 */
							   obj_t aux_1212;
							   {	/* Object/plain-access.scm 157 */
							      tclass_bglt obj_884;
							      obj_884 =
								 (tclass_bglt) (class_76);
							      {
								 obj_t aux_1214;
								 {	/* ./Object/class.scm 1118 */
								    object_bglt aux_1215;
								    aux_1215 =
								       (object_bglt) (obj_884);
								    aux_1214 =
								       OBJECT_WIDENING(aux_1215);
								 }
								 aux_1212 =
								    (((tclass_bglt) CREF(aux_1214))->its_super_214);
							      }
							   }
							   test1277_564 =
							      is_a__118___object(aux_1212, type_type_type);
							}
							if (test1277_564)
							  {	/* Object/plain-access.scm 157 */
							     if (
								CBOOL(domestic__170_540))
							       {	/* Object/plain-access.scm 160 */
								  obj_t arg1278_565;
								  obj_t arg1280_566;
								  arg1278_565 =
								     make_object__struct_189_object_struct(class_id_86_543, class_76, _module__166_module_module, cslots_542, src_def_101_77);
								  {	/* Object/plain-access.scm 163 */
								     obj_t arg1281_567;
								     arg1281_567 =
									make_struct__object_35_object_struct(class_id_86_543, class_76, _module__166_module_module, cslots_542, src_def_101_77);
								     arg1280_566 =
									MAKE_PAIR(arg1281_567, accs_559);
								  }
								  arg1276_563 =
								     MAKE_PAIR(arg1278_565, arg1280_566);
							       }
							     else
							       {	/* Object/plain-access.scm 158 */
								  arg1276_563 = accs_559;
							       }
							  }
							else
							  {	/* Object/plain-access.scm 157 */
							     arg1276_563 = accs_559;
							  }
						     }
						     val0_1223_560 =
							MAKE_PAIR(arg1274_562, arg1276_563);
						  }
						  _res_number__75___r5_control_features_6_4 =
						     BINT(((long) 2));
						  _res1__155___r5_control_features_6_4 = virtuals_558;
						  return val0_1223_560;
					       }
					    }
					 }
				      }
				   }
				}
			     }
			  }
		       }
		    }
		 }
	      }
	   }
	 else
	   {	/* Object/plain-access.scm 116 */
	      return BNIL;
	   }
      }
   }
}



/* _make-plain-class-accessors-sans-makes!1379 */
obj_t 
_make_plain_class_accessors_sans_makes_1379_236_object_plain_access_186(obj_t env_964, obj_t class_def_12_965, obj_t class_966, obj_t src_def_101_967, obj_t import_968)
{
   AN_OBJECT;
   {	/* Object/plain-access.scm 113 */
      return
	 make_plain_class_accessors_sans_makes__96_object_plain_access_186(class_def_12_965,
	 (type_bglt) (class_966), src_def_101_967, import_968);
   }
}



/* import-plain-class-accessors! */
obj_t 
import_plain_class_accessors__109_object_plain_access_186(obj_t class_def_12_79, type_bglt class_80, obj_t src_def_101_81, obj_t module_82)
{
   AN_OBJECT;
   {	/* Object/plain-access.scm 175 */
      {		/* Object/plain-access.scm 178 */
	 bool_t test1290_573;
	 test1290_573 =
	    correct_plain_class__49_object_plain_access_186(class_80, src_def_101_81);
	 if (test1290_573)
	   {	/* Object/plain-access.scm 179 */
	      obj_t super_574;
	      {		/* Object/plain-access.scm 179 */
		 tclass_bglt obj_892;
		 obj_892 =
		    (tclass_bglt) (class_80);
		 {
		    obj_t aux_1234;
		    {	/* ./Object/class.scm 1118 */
		       object_bglt aux_1235;
		       aux_1235 =
			  (object_bglt) (obj_892);
		       aux_1234 =
			  OBJECT_WIDENING(aux_1235);
		    }
		    super_574 =
		       (((tclass_bglt) CREF(aux_1234))->its_super_214);
		 }
	      }
	      {		/* Object/plain-access.scm 179 */
		 obj_t super_vnum_51_575;
		 {	/* Object/plain-access.scm 180 */
		    bool_t test1302_593;
		    test1302_593 =
		       is_a__118___object(super_574, tclass_object_class);
		    if (test1302_593)
		      {		/* Object/plain-access.scm 181 */
			 tclass_bglt obj_894;
			 obj_894 =
			    (tclass_bglt) (super_574);
			 {
			    obj_t aux_1242;
			    {	/* ./Object/class.scm 1134 */
			       object_bglt aux_1243;
			       aux_1243 =
				  (object_bglt) (obj_894);
			       aux_1242 =
				  OBJECT_WIDENING(aux_1243);
			    }
			    super_vnum_51_575 =
			       (((tclass_bglt) CREF(aux_1242))->virtual_slots_number_200);
			 }
		      }
		    else
		      {		/* Object/plain-access.scm 180 */
			 super_vnum_51_575 =
			    BINT(((long) 0));
		      }
		 }
		 {	/* Object/plain-access.scm 183 */
		    obj_t cslots_577;
		    {	/* Object/plain-access.scm 184 */
		       obj_t aux_1253;
		       obj_t aux_1248;
		       {	/* Object/plain-access.scm 185 */
			  bool_t test_1254;
			  {	/* ./Ieee/equiv.scm 5508 */
			     obj_t aux_1255;
			     aux_1255 =
				(obj_t) (class_80);
			     test_1254 =
				(super_574 == aux_1255);
			  }
			  if (test_1254)
			    {	/* Object/plain-access.scm 185 */
			       aux_1253 = BFALSE
				  ;
			    }
			  else
			    {	/* Object/plain-access.scm 185 */
			       aux_1253 = super_574
				  ;
			    }
		       }
		       {	/* ./Ieee/pair-list.scm 5707 */
			  obj_t aux_1250;
			  aux_1250 =
			     CDR(class_def_12_79);
			  aux_1248 =
			     CDR(aux_1250);
		       }
		       cslots_577 =
			  make_class_slots_205_object_slots(
			  (tclass_bglt) (class_80), aux_1248, aux_1253,
			  CINT(super_vnum_51_575), src_def_101_81);
		    }
		    {	/* Object/plain-access.scm 184 */
		       obj_t class_id_86_578;
		       class_id_86_578 =
			  (((type_bglt) CREF(class_80))->id);
		       {	/* Object/plain-access.scm 189 */
			  global_bglt holder_580;
			  {	/* Object/plain-access.scm 190 */
			     tclass_bglt obj_903;
			     obj_903 =
				(tclass_bglt) (class_80);
			     {
				obj_t aux_1262;
				{	/* ./Object/class.scm 1124 */
				   object_bglt aux_1263;
				   aux_1263 =
				      (object_bglt) (obj_903);
				   aux_1262 =
				      OBJECT_WIDENING(aux_1263);
				}
				holder_580 =
				   (((tclass_bglt) CREF(aux_1262))->holder);
			     }
			  }
			  {	/* Object/plain-access.scm 190 */
			     obj_t local_vnum_209_581;
			     local_vnum_209_581 =
				get_local_virtual_slots_number_139_object_slots(
				(tclass_bglt) (class_80), cslots_577);
			     {	/* Object/plain-access.scm 191 */

				{	/* Object/plain-access.scm 193 */
				   tclass_bglt obj_904;
				   obj_904 =
				      (tclass_bglt) (class_80);
				   {
				      obj_t aux_1270;
				      {		/* ./Object/class.scm 1134 */
					 object_bglt aux_1271;
					 aux_1271 =
					    (object_bglt) (obj_904);
					 aux_1270 =
					    OBJECT_WIDENING(aux_1271);
				      }
				      ((((tclass_bglt) CREF(aux_1270))->virtual_slots_number_200) = ((obj_t) local_vnum_209_581), BUNSPEC);
				   }
				}
				{	/* Object/plain-access.scm 196 */
				   obj_t arg1291_582;
				   arg1291_582 =
				      make_coercion_clause_209_object_access(class_id_86_578, super_574);
				   produce_module_clause__172_module_module(arg1291_582);
				}
				{	/* Object/plain-access.scm 197 */
				   bool_t test1292_583;
				   test1292_583 =
				      is_a__118___object(
				      (obj_t) (holder_580), global_ast_var);
				   if (test1292_583)
				     {	/* Object/plain-access.scm 197 */
					BUNSPEC;
				     }
				   else
				     {	/* Object/plain-access.scm 197 */
					{	/* Object/plain-access.scm 197 */
					   obj_t arg1293_584;
					   obj_t arg1294_585;
					   arg1293_584 =
					      CNST_TABLE_REF(((long) 2));
					   {	/* Object/plain-access.scm 197 */
					      obj_t aux_1281;
					      aux_1281 =
						 (obj_t) (holder_580);
					      arg1294_585 =
						 __EVMEANING_ADDRESS(aux_1281);
					   }
					   define_primop_ref__105___evenv(arg1293_584, arg1294_585);
					}
					notify_assert_fail_37___eval(
					   CNST_TABLE_REF(((long) 3)),
					   CNST_TABLE_REF(((long) 4)),
					   CNST_TABLE_REF(((long) 9)));
					unbind_primop__163___evenv(
					   CNST_TABLE_REF(((long) 2)));
				     }
				}
				{	/* Object/plain-access.scm 198 */
				   tclass_bglt obj_907;
				   obj_907 =
				      (tclass_bglt) (class_80);
				   {
				      obj_t aux_1292;
				      {		/* ./Object/class.scm 1122 */
					 object_bglt aux_1293;
					 aux_1293 =
					    (object_bglt) (obj_907);
					 aux_1292 =
					    OBJECT_WIDENING(aux_1293);
				      }
				      ((((tclass_bglt) CREF(aux_1292))->slots) = ((obj_t) cslots_577), BUNSPEC);
				   }
				}
				{	/* Object/plain-access.scm 200 */
				   obj_t arg1295_586;
				   {	/* Object/plain-access.scm 200 */
				      obj_t arg1296_587;
				      obj_t arg1297_588;
				      arg1296_587 =
					 CNST_TABLE_REF(((long) 6));
				      {		/* Object/plain-access.scm 200 */
					 obj_t arg1298_589;
					 arg1298_589 =
					    make_class_coercers_236_object_access(
					    (obj_t) (class_80));
					 arg1297_588 =
					    append_2_18___r4_pairs_and_lists_6_3(arg1298_589, BNIL);
				      }
				      arg1295_586 =
					 MAKE_PAIR(arg1296_587, arg1297_588);
				   }
				   produce_module_clause__172_module_module(arg1295_586);
				}
				import_class_pred__91_object_access(class_id_86_578,
				   (tclass_bglt) (class_80), src_def_101_81, module_82);
				import_class_makes__192_object_access(
				   CNST_TABLE_REF(((long) 7)), class_id_86_578,
				   (obj_t) (class_80), cslots_577, src_def_101_81, module_82);
				import_class_slots_access__39_object_access(class_id_86_578,
				   (obj_t) (class_80), cslots_577, src_def_101_81, module_82);
			     }
			  }
		       }
		    }
		 }
	      }
	   }
	 else
	   {	/* Object/plain-access.scm 178 */
	      BUNSPEC;
	   }
      }
      return BNIL;
   }
}



/* _import-plain-class-accessors! */
obj_t 
_import_plain_class_accessors__22_object_plain_access_186(obj_t env_969, obj_t class_def_12_970, obj_t class_971, obj_t src_def_101_972, obj_t module_973)
{
   AN_OBJECT;
   {	/* Object/plain-access.scm 175 */
      return
	 import_plain_class_accessors__109_object_plain_access_186(class_def_12_970,
	 (type_bglt) (class_971), src_def_101_972, module_973);
   }
}



/* import-plain-class-makes! */
obj_t 
import_plain_class_makes__28_object_plain_access_186(obj_t class_def_12_83, type_bglt class_84, obj_t src_def_101_85, obj_t module_86)
{
   AN_OBJECT;
   {	/* Object/plain-access.scm 210 */
      {		/* Object/plain-access.scm 213 */
	 bool_t test1303_594;
	 test1303_594 =
	    correct_plain_class__49_object_plain_access_186(class_84, src_def_101_85);
	 if (test1303_594)
	   {	/* Object/plain-access.scm 214 */
	      obj_t super_595;
	      {		/* Object/plain-access.scm 214 */
		 tclass_bglt obj_911;
		 obj_911 =
		    (tclass_bglt) (class_84);
		 {
		    obj_t aux_1315;
		    {	/* ./Object/class.scm 1118 */
		       object_bglt aux_1316;
		       aux_1316 =
			  (object_bglt) (obj_911);
		       aux_1315 =
			  OBJECT_WIDENING(aux_1316);
		    }
		    super_595 =
		       (((tclass_bglt) CREF(aux_1315))->its_super_214);
		 }
	      }
	      {		/* Object/plain-access.scm 214 */
		 obj_t super_vnum_51_596;
		 {	/* Object/plain-access.scm 215 */
		    bool_t test1310_608;
		    test1310_608 =
		       is_a__118___object(super_595, tclass_object_class);
		    if (test1310_608)
		      {		/* Object/plain-access.scm 216 */
			 tclass_bglt obj_913;
			 obj_913 =
			    (tclass_bglt) (super_595);
			 {
			    obj_t aux_1323;
			    {	/* ./Object/class.scm 1134 */
			       object_bglt aux_1324;
			       aux_1324 =
				  (object_bglt) (obj_913);
			       aux_1323 =
				  OBJECT_WIDENING(aux_1324);
			    }
			    super_vnum_51_596 =
			       (((tclass_bglt) CREF(aux_1323))->virtual_slots_number_200);
			 }
		      }
		    else
		      {		/* Object/plain-access.scm 215 */
			 super_vnum_51_596 =
			    BINT(((long) 0));
		      }
		 }
		 {	/* Object/plain-access.scm 218 */
		    obj_t cslots_598;
		    {	/* Object/plain-access.scm 219 */
		       obj_t aux_1334;
		       obj_t aux_1329;
		       {	/* Object/plain-access.scm 220 */
			  bool_t test_1335;
			  {	/* ./Ieee/equiv.scm 5508 */
			     obj_t aux_1336;
			     aux_1336 =
				(obj_t) (class_84);
			     test_1335 =
				(super_595 == aux_1336);
			  }
			  if (test_1335)
			    {	/* Object/plain-access.scm 220 */
			       aux_1334 = BFALSE
				  ;
			    }
			  else
			    {	/* Object/plain-access.scm 220 */
			       aux_1334 = super_595
				  ;
			    }
		       }
		       {	/* ./Ieee/pair-list.scm 5707 */
			  obj_t aux_1331;
			  aux_1331 =
			     CDR(class_def_12_83);
			  aux_1329 =
			     CDR(aux_1331);
		       }
		       cslots_598 =
			  make_class_slots_205_object_slots(
			  (tclass_bglt) (class_84), aux_1329, aux_1334,
			  CINT(super_vnum_51_596), src_def_101_85);
		    }
		    {	/* Object/plain-access.scm 219 */
		       obj_t class_id_86_599;
		       class_id_86_599 =
			  (((type_bglt) CREF(class_84))->id);
		       {	/* Object/plain-access.scm 224 */
			  global_bglt holder_601;
			  {	/* Object/plain-access.scm 225 */
			     tclass_bglt obj_922;
			     obj_922 =
				(tclass_bglt) (class_84);
			     {
				obj_t aux_1343;
				{	/* ./Object/class.scm 1124 */
				   object_bglt aux_1344;
				   aux_1344 =
				      (object_bglt) (obj_922);
				   aux_1343 =
				      OBJECT_WIDENING(aux_1344);
				}
				holder_601 =
				   (((tclass_bglt) CREF(aux_1343))->holder);
			     }
			  }
			  {	/* Object/plain-access.scm 225 */
			     obj_t local_vnum_209_602;
			     local_vnum_209_602 =
				get_local_virtual_slots_number_139_object_slots(
				(tclass_bglt) (class_84), cslots_598);
			     {	/* Object/plain-access.scm 226 */

				{	/* Object/plain-access.scm 227 */
				   bool_t test1304_603;
				   test1304_603 =
				      is_a__118___object(
				      (obj_t) (holder_601), global_ast_var);
				   if (test1304_603)
				     {	/* Object/plain-access.scm 227 */
					BUNSPEC;
				     }
				   else
				     {	/* Object/plain-access.scm 227 */
					{	/* Object/plain-access.scm 227 */
					   obj_t arg1305_604;
					   obj_t arg1307_605;
					   arg1305_604 =
					      CNST_TABLE_REF(((long) 2));
					   {	/* Object/plain-access.scm 227 */
					      obj_t aux_1354;
					      aux_1354 =
						 (obj_t) (holder_601);
					      arg1307_605 =
						 __EVMEANING_ADDRESS(aux_1354);
					   }
					   define_primop_ref__105___evenv(arg1305_604, arg1307_605);
					}
					notify_assert_fail_37___eval(
					   CNST_TABLE_REF(((long) 3)),
					   CNST_TABLE_REF(((long) 4)),
					   CNST_TABLE_REF(((long) 10)));
					unbind_primop__163___evenv(
					   CNST_TABLE_REF(((long) 2)));
				     }
				}
				import_class_makes__192_object_access(
				   CNST_TABLE_REF(((long) 7)), class_id_86_599,
				   (obj_t) (class_84), cslots_598, src_def_101_85, module_86);
			     }
			  }
		       }
		    }
		 }
	      }
	   }
	 else
	   {	/* Object/plain-access.scm 213 */
	      BUNSPEC;
	   }
      }
      return BNIL;
   }
}



/* _import-plain-class-makes!1380 */
obj_t 
_import_plain_class_makes_1380_177_object_plain_access_186(obj_t env_974, obj_t class_def_12_975, obj_t class_976, obj_t src_def_101_977, obj_t module_978)
{
   AN_OBJECT;
   {	/* Object/plain-access.scm 210 */
      return
	 import_plain_class_makes__28_object_plain_access_186(class_def_12_975,
	 (type_bglt) (class_976), src_def_101_977, module_978);
   }
}



/* correct-plain-class? */
bool_t 
correct_plain_class__49_object_plain_access_186(type_bglt class_87, obj_t src_def_101_88)
{
   AN_OBJECT;
   {	/* Object/plain-access.scm 239 */
      {		/* Object/plain-access.scm 240 */
	 obj_t super_609;
	 obj_t class_id_86_610;
	 {	/* Object/plain-access.scm 240 */
	    tclass_bglt obj_924;
	    obj_924 =
	       (tclass_bglt) (class_87);
	    {
	       obj_t aux_1370;
	       {	/* ./Object/class.scm 1118 */
		  object_bglt aux_1371;
		  aux_1371 =
		     (object_bglt) (obj_924);
		  aux_1370 =
		     OBJECT_WIDENING(aux_1371);
	       }
	       super_609 =
		  (((tclass_bglt) CREF(aux_1370))->its_super_214);
	    }
	 }
	 class_id_86_610 =
	    (((type_bglt) CREF(class_87))->id);
	 {	/* Object/plain-access.scm 245 */
	    bool_t test1311_611;
	    {	/* Object/plain-access.scm 245 */
	       bool_t test1336_632;
	       test1336_632 =
		  is_a__118___object(super_609, type_type_type);
	       if (test1336_632)
		 {	/* Object/plain-access.scm 245 */
		    bool_t test1337_633;
		    test1337_633 =
		       is_a__118___object(super_609, tclass_object_class);
		    if (test1337_633)
		      {		/* Object/plain-access.scm 245 */
			 test1311_611 = ((bool_t) 0);
		      }
		    else
		      {		/* Object/plain-access.scm 245 */
			 test1311_611 = ((bool_t) 1);
		      }
		 }
	       else
		 {	/* Object/plain-access.scm 245 */
		    test1311_611 = ((bool_t) 0);
		 }
	    }
	    if (test1311_611)
	      {		/* Object/plain-access.scm 245 */
		 {	/* Object/plain-access.scm 246 */
		    obj_t arg1313_612;
		    obj_t arg1314_613;
		    {	/* Object/plain-access.scm 246 */
		       type_bglt obj_928;
		       obj_928 =
			  (type_bglt) (super_609);
		       arg1313_612 =
			  (((type_bglt) CREF(obj_928))->id);
		    }
		    {	/* Object/plain-access.scm 247 */
		       obj_t arg1318_616;
		       {	/* Object/plain-access.scm 248 */
			  obj_t arg1319_617;
			  arg1319_617 =
			     SYMBOL_TO_STRING(class_id_86_610);
			  arg1318_616 =
			     string_append(arg1319_617, string1381_object_plain_access_186);
		       }
		       arg1314_613 =
			  string_append(string1382_object_plain_access_186, arg1318_616);
		    }
		    {	/* Object/plain-access.scm 246 */
		       obj_t list1315_614;
		       list1315_614 =
			  MAKE_PAIR(type_type_type, BNIL);
		       user_error_151_tools_error(arg1313_612, arg1314_613, src_def_101_88, list1315_614);
		    }
		 }
		 return ((bool_t) 0);
	      }
	    else
	      {		/* Object/plain-access.scm 253 */
		 bool_t test1321_619;
		 test1321_619 =
		    wide_class__100_object_class(
		    (obj_t) (class_87));
		 if (test1321_619)
		   {	/* Object/plain-access.scm 253 */
		      internal_error_43_tools_error(string1383_object_plain_access_186, string1384_object_plain_access_186, src_def_101_88);
		      return ((bool_t) 0);
		   }
		 else
		   {	/* Object/plain-access.scm 260 */
		      bool_t test1322_620;
		      test1322_620 =
			 wide_class__100_object_class(super_609);
		      if (test1322_620)
			{	/* Object/plain-access.scm 260 */
			   {	/* Object/plain-access.scm 262 */
			      obj_t arg1323_621;
			      obj_t arg1325_622;
			      {		/* Object/plain-access.scm 262 */
				 type_bglt obj_930;
				 obj_930 =
				    (type_bglt) (super_609);
				 arg1323_621 =
				    (((type_bglt) CREF(obj_930))->id);
			      }
			      {		/* Object/plain-access.scm 263 */
				 obj_t arg1329_625;
				 {	/* Object/plain-access.scm 264 */
				    obj_t arg1330_626;
				    arg1330_626 =
				       SYMBOL_TO_STRING(class_id_86_610);
				    arg1329_625 =
				       string_append(arg1330_626, string1385_object_plain_access_186);
				 }
				 arg1325_622 =
				    string_append(string1382_object_plain_access_186, arg1329_625);
			      }
			      {		/* Object/plain-access.scm 262 */
				 obj_t list1326_623;
				 list1326_623 =
				    MAKE_PAIR(type_type_type, BNIL);
				 user_error_151_tools_error(arg1323_621, arg1325_622, src_def_101_88, list1326_623);
			      }
			   }
			   return ((bool_t) 0);
			}
		      else
			{	/* Object/plain-access.scm 269 */
			   bool_t test1332_628;
			   test1332_628 =
			      final_class__126_object_class(super_609);
			   if (test1332_628)
			     {	/* Object/plain-access.scm 269 */
				{	/* Object/plain-access.scm 271 */
				   obj_t arg1333_629;
				   {	/* Object/plain-access.scm 271 */
				      type_bglt obj_932;
				      obj_932 =
					 (type_bglt) (super_609);
				      arg1333_629 =
					 (((type_bglt) CREF(obj_932))->id);
				   }
				   {	/* Object/plain-access.scm 271 */
				      obj_t list1335_631;
				      list1335_631 =
					 MAKE_PAIR(type_type_type, BNIL);
				      user_error_151_tools_error(arg1333_629, string1386_object_plain_access_186, src_def_101_88, list1335_631);
				   }
				}
				return ((bool_t) 0);
			     }
			   else
			     {	/* Object/plain-access.scm 269 */
				return ((bool_t) 1);
			     }
			}
		   }
	      }
	 }
      }
   }
}



/* method-init */
obj_t 
method_init_76_object_plain_access_186()
{
   AN_OBJECT;
   {	/* Object/plain-access.scm 20 */
      return BUNSPEC;
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_object_plain_access_186()
{
   AN_OBJECT;
   {	/* Object/plain-access.scm 20 */
      module_initialization_70_tools_trace(((long) 0), "OBJECT_PLAIN-ACCESS");
      module_initialization_70_tools_error(((long) 0), "OBJECT_PLAIN-ACCESS");
      module_initialization_70_tools_misc(((long) 0), "OBJECT_PLAIN-ACCESS");
      module_initialization_70_type_type(((long) 0), "OBJECT_PLAIN-ACCESS");
      module_initialization_70_type_env(((long) 0), "OBJECT_PLAIN-ACCESS");
      module_initialization_70_type_tools(((long) 0), "OBJECT_PLAIN-ACCESS");
      module_initialization_70_type_cache(((long) 0), "OBJECT_PLAIN-ACCESS");
      module_initialization_70_ast_var(((long) 0), "OBJECT_PLAIN-ACCESS");
      module_initialization_70_ast_ident(((long) 0), "OBJECT_PLAIN-ACCESS");
      module_initialization_70_object_class(((long) 0), "OBJECT_PLAIN-ACCESS");
      module_initialization_70_object_struct(((long) 0), "OBJECT_PLAIN-ACCESS");
      module_initialization_70_object_slots(((long) 0), "OBJECT_PLAIN-ACCESS");
      module_initialization_70_object_tools(((long) 0), "OBJECT_PLAIN-ACCESS");
      module_initialization_70_object_access(((long) 0), "OBJECT_PLAIN-ACCESS");
      module_initialization_70_module_module(((long) 0), "OBJECT_PLAIN-ACCESS");
      module_initialization_70_module_impuse(((long) 0), "OBJECT_PLAIN-ACCESS");
      return
	 module_initialization_70_engine_param(((long) 0), "OBJECT_PLAIN-ACCESS");
   }
}
