/*===========================================================================*/
/*   (Object/slots.scm)                                                      */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct tclass
  {
     obj_t its_super_214;
     obj_t slots;
     struct global *holder;
     obj_t widening;
     long depth;
     bool_t final__12;
     obj_t constructor;
     obj_t virtual_slots_number_200;
  }
      *tclass_bglt;


extern obj_t _long__149_type_cache;
static obj_t find_assert_attr_93_object_slots(obj_t);
static obj_t method_init_76_object_slots();
extern obj_t user_warning_location_190_tools_error(obj_t, obj_t, obj_t, obj_t);
extern obj_t symbol_append_197___r4_symbols_6_4(obj_t);
static obj_t _make_class_slots1643_214_object_slots(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t type_type_type;
extern obj_t create_struct(obj_t, long);
extern obj_t _obj__252_type_cache;
extern obj_t user_error_151_tools_error(obj_t, obj_t, obj_t, obj_t);
extern obj_t make_class_slots_205_object_slots(tclass_bglt, obj_t, obj_t, int, obj_t);
extern obj_t reverse___r4_pairs_and_lists_6_3(obj_t);
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t module_initialization_70_object_slots(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_ident(long, char *);
extern obj_t module_initialization_70_object_class(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_tools_location(long, char *);
extern obj_t module_initialization_70___error(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_symbols_6_4(long, char *);
extern obj_t module_initialization_70___r4_numbers_6_5(long, char *);
extern obj_t module_initialization_70___r4_strings_6_7(long, char *);
extern obj_t _warning__61___error;
static obj_t imported_modules_init_94_object_slots();
extern obj_t string_downcase_77___r4_strings_6_7(obj_t);
extern obj_t get_local_virtual_slots_number_139_object_slots(tclass_bglt, obj_t);
extern obj_t id__name_228_ast_ident(obj_t);
static obj_t find_virtual_attr_39_object_slots(obj_t);
static obj_t library_modules_init_112_object_slots();
static obj_t find_default_attr_77_object_slots(obj_t);
static obj_t toplevel_init_63_object_slots();
static obj_t _get_local_virtual_slots_number1644_185_object_slots(obj_t, obj_t, obj_t);
extern obj_t open_input_string(obj_t);
extern obj_t tclass_object_class;
extern obj_t _case_sensitive__90_engine_param;
extern obj_t memq___r4_pairs_and_lists_6_3(obj_t, obj_t);
static obj_t scheme_symbol__c_string_183_object_slots(obj_t);
extern bool_t _2___235___r4_numbers_6_5(obj_t, obj_t);
static obj_t ensure_type_defined__128_object_slots(type_bglt, obj_t);
extern obj_t _2__168___r4_numbers_6_5(obj_t, obj_t);
extern obj_t read___reader(obj_t);
extern obj_t find_location_120_tools_location(obj_t);
extern obj_t ____74_type_cache;
static obj_t require_initialization_114_object_slots = BUNSPEC;
static obj_t cnst_init_137_object_slots();
extern obj_t user_error_location_137_tools_error(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t __cnst[12];

DEFINE_EXPORT_PROCEDURE(get_local_virtual_slots_number_env_116_object_slots, _get_local_virtual_slots_number1644_185_object_slots1660, _get_local_virtual_slots_number1644_185_object_slots, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_class_slots_env_76_object_slots, _make_class_slots1643_214_object_slots1661, _make_class_slots1643_214_object_slots, 0L, 5);
DEFINE_STRING(string1655_object_slots, string1655_object_slots1662, "SET GET ASSERT LAMBDA (#f . #unspecified) DEFAULT + ID * -LEN READ-ONLY SLOT ", 77);
DEFINE_STRING(string1654_object_slots, string1654_object_slots1663, "virtual slot can't be indexed", 29);
DEFINE_STRING(string1653_object_slots, string1653_object_slots1664, "illegal virtual slot (missing setter)", 37);
DEFINE_STRING(string1652_object_slots, string1652_object_slots1665, "illegal virtual slot (read-only)", 32);
DEFINE_STRING(string1651_object_slots, string1651_object_slots1666, "illegal virtual slot (missing getter)", 37);
DEFINE_STRING(string1649_object_slots, string1649_object_slots1667, "Parse error", 11);
DEFINE_STRING(string1650_object_slots, string1650_object_slots1668, "Unknown class slot type", 23);
DEFINE_STRING(string1648_object_slots, string1648_object_slots1669, "Overriden virtual slot", 22);
DEFINE_STRING(string1647_object_slots, string1647_object_slots1670, "Illegal duplicated virtual slot", 31);
DEFINE_STRING(string1646_object_slots, string1646_object_slots1671, "Class declarator", 16);
DEFINE_STRING(string1645_object_slots, string1645_object_slots1672, "Can't find type definition", 26);



/* module-initialization */
obj_t 
module_initialization_70_object_slots(long checksum_2226, char *from_2227)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_object_slots))
	{
	   require_initialization_114_object_slots =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_object_slots();
	   cnst_init_137_object_slots();
	   imported_modules_init_94_object_slots();
	   method_init_76_object_slots();
	   toplevel_init_63_object_slots();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_object_slots()
{
   AN_OBJECT;
   {	/* Object/slots.scm 14 */
      module_initialization_70___r4_symbols_6_4(((long) 0), "OBJECT_SLOTS");
      module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "OBJECT_SLOTS");
      module_initialization_70___object(((long) 0), "OBJECT_SLOTS");
      module_initialization_70___error(((long) 0), "OBJECT_SLOTS");
      module_initialization_70___r4_strings_6_7(((long) 0), "OBJECT_SLOTS");
      module_initialization_70___r4_numbers_6_5(((long) 0), "OBJECT_SLOTS");
      module_initialization_70___reader(((long) 0), "OBJECT_SLOTS");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_object_slots()
{
   AN_OBJECT;
   {	/* Object/slots.scm 14 */
      {		/* Object/slots.scm 14 */
	 obj_t cnst_port_138_2219;
	 cnst_port_138_2219 =
	    open_input_string(string1655_object_slots);
	 {
	    long i_2220;
	    i_2220 = ((long) 11);
	  loop_2221:
	    {	/* Object/slots.scm 14 */
	       bool_t test1656_2222;
	       test1656_2222 =
		  (i_2220 == ((long) -1));
	       if (test1656_2222)
		 {	/* Object/slots.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Object/slots.scm 14 */
		    {	/* Object/slots.scm 14 */
		       obj_t arg1657_2223;
		       {	/* Object/slots.scm 14 */
			  obj_t list1658_2224;
			  list1658_2224 =
			     MAKE_PAIR(cnst_port_138_2219, BNIL);
			  arg1657_2223 =
			     read___reader(list1658_2224);
		       }
		       CNST_TABLE_SET(i_2220, arg1657_2223);
		    }
		    {	/* Object/slots.scm 14 */
		       int aux_2225;
		       {	/* Object/slots.scm 14 */
			  long aux_2249;
			  aux_2249 =
			     (i_2220 - ((long) 1));
			  aux_2225 =
			     (int) (aux_2249);
		       }
		       {
			  long i_2252;
			  i_2252 =
			     (long) (aux_2225);
			  i_2220 = i_2252;
			  goto loop_2221;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_object_slots()
{
   AN_OBJECT;
   {	/* Object/slots.scm 14 */
      return BUNSPEC;
   }
}



/* ensure-type-defined! */
obj_t 
ensure_type_defined__128_object_slots(type_bglt type_71, obj_t src_72)
{
   AN_OBJECT;
   {	/* Object/slots.scm 31 */
      if (
	 (((type_bglt) CREF(type_71))->init__47))
	{	/* Object/slots.scm 32 */
	   return BUNSPEC;
	}
      else
	{	/* Object/slots.scm 32 */
	   return
	      user_error_151_tools_error(string1645_object_slots,
	      (((type_bglt) CREF(type_71))->id), src_72, BNIL);
	}
   }
}



/* make-class-slots */
obj_t 
make_class_slots_205_object_slots(tclass_bglt class_73, obj_t slots_74, obj_t super_75, int vnum_76, obj_t src_77)
{
   AN_OBJECT;
   {	/* Object/slots.scm 38 */
      {
	 obj_t slots_799;
	 obj_t slot_829;
	 obj_t slot_list_182_830;
	 {
	    obj_t slots_488;
	    obj_t res_489;
	    obj_t vnum_490;
	    {	/* Object/slots.scm 126 */
	       obj_t arg1231_492;
	       {	/* Object/slots.scm 126 */
		  bool_t test1232_493;
		  test1232_493 =
		     is_a__118___object(super_75, type_type_type);
		  if (test1232_493)
		    {	/* Object/slots.scm 128 */
		       bool_t test1233_494;
		       test1233_494 =
			  is_a__118___object(super_75, tclass_object_class);
		       if (test1233_494)
			 {	/* Object/slots.scm 128 */
			    {	/* Object/slots.scm 135 */
			       obj_t aux_2262;
			       {	/* Object/slots.scm 135 */
				  tclass_bglt obj_1259;
				  obj_1259 =
				     (tclass_bglt) (super_75);
				  {
				     obj_t aux_2264;
				     {	/* ./Object/class.scm 1064 */
					object_bglt aux_2265;
					aux_2265 =
					   (object_bglt) (obj_1259);
					aux_2264 =
					   OBJECT_WIDENING(aux_2265);
				     }
				     aux_2262 =
					(((tclass_bglt) CREF(aux_2264))->slots);
				  }
			       }
			       arg1231_492 =
				  reverse___r4_pairs_and_lists_6_3(aux_2262);
			    }
			 }
		       else
			 {	/* Object/slots.scm 128 */
			    arg1231_492 = BNIL;
			 }
		    }
		  else
		    {	/* Object/slots.scm 126 */
		       arg1231_492 = BNIL;
		    }
	       }
	       slots_488 = slots_74;
	       res_489 = arg1231_492;
	       vnum_490 =
		  BINT(vnum_76);
	     loop_491:
	       if (
		  NULLP(slots_488))
		 {	/* Object/slots.scm 137 */
		    slots_799 = res_489;
		    {
		       obj_t slots_801;
		       obj_t res_802;
		       slots_801 = slots_799;
		       res_802 = BNIL;
		     loop_803:
		       if (
			  NULLP(slots_801))
			 {	/* Object/slots.scm 95 */
			    return res_802;
			 }
		       else
			 {	/* Object/slots.scm 97 */
			    bool_t test_2274;
			    {	/* ./Llib/struct.scm 1457 */
			       obj_t aux_2275;
			       {	/* ./Llib/struct.scm 1457 */
				  obj_t aux_2276;
				  aux_2276 =
				     CAR(slots_801);
				  aux_2275 =
				     STRUCT_REF(aux_2276, ((long) 11));
			       }
			       test_2274 =
				  CBOOL(aux_2275);
			    }
			    if (test_2274)
			      {		/* Object/slots.scm 97 */
				 {	/* Object/slots.scm 98 */
				    obj_t other_806;
				    slot_829 =
				       CAR(slots_801);
				    slot_list_182_830 = res_802;
				    {	/* Object/slots.scm 81 */
				       obj_t id_832;
				       id_832 =
					  STRUCT_REF(slot_829, ((long) 0));
				       {
					  obj_t slot_list_182_833;
					  slot_list_182_833 = slot_list_182_830;
					loop_834:
					  if (
					     NULLP(slot_list_182_833))
					    {	/* Object/slots.scm 84 */
					       other_806 = BFALSE;
					    }
					  else
					    {	/* Object/slots.scm 86 */
					       bool_t test_2283;
					       {	/* ./Ieee/equiv.scm 5508 */
						  obj_t aux_2284;
						  {	/* ./Llib/struct.scm 1457 */
						     obj_t aux_2285;
						     aux_2285 =
							CAR(slot_list_182_833);
						     aux_2284 =
							STRUCT_REF(aux_2285, ((long) 0));
						  }
						  test_2283 =
						     (aux_2284 == id_832);
					       }
					       if (test_2283)
						 {	/* Object/slots.scm 86 */
						    other_806 =
						       CAR(slot_list_182_833);
						 }
					       else
						 {	/* Object/slots.scm 86 */
						    {
						       obj_t slot_list_182_2290;
						       slot_list_182_2290 =
							  CDR(slot_list_182_833);
						       slot_list_182_833 = slot_list_182_2290;
						       goto loop_834;
						    }
						 }
					    }
				       }
				    }
				    {	/* Object/slots.scm 99 */
				       bool_t test_2293;
				       if (
					  STRUCTP(other_806))
					 {	/* ./Ieee/equiv.scm 5508 */
					    obj_t aux_2298;
					    obj_t aux_2296;
					    aux_2298 =
					       CNST_TABLE_REF(((long) 0));
					    aux_2296 =
					       STRUCT_KEY(other_806);
					    test_2293 =
					       (aux_2296 == aux_2298);
					 }
				       else
					 {	/* ./Object/class.sch 590 */
					    test_2293 = ((bool_t) 0)
					       ;
					 }
				       if (test_2293)
					 {	/* Object/slots.scm 100 */
					    obj_t loc_808;
					    obj_t id_809;
					    loc_808 =
					       find_location_120_tools_location(src_77);
					    {	/* ./Llib/struct.scm 1457 */
					       obj_t aux_2302;
					       aux_2302 =
						  CAR(slots_801);
					       id_809 =
						  STRUCT_REF(aux_2302, ((long) 0));
					    }
					    {	/* Object/slots.scm 102 */
					       bool_t test_2305;
					       {	/* ./Ieee/equiv.scm 5508 */
						  obj_t aux_2310;
						  obj_t aux_2306;
						  aux_2310 =
						     STRUCT_REF(other_806, ((long) 16));
						  {	/* ./Llib/struct.scm 1457 */
						     obj_t aux_2307;
						     aux_2307 =
							CAR(slots_801);
						     aux_2306 =
							STRUCT_REF(aux_2307, ((long) 16));
						  }
						  test_2305 =
						     (aux_2306 == aux_2310);
					       }
					       if (test_2305)
						 {	/* Object/slots.scm 102 */
						    return
						       user_error_location_137_tools_error(loc_808, string1646_object_slots, string1647_object_slots, id_809, BNIL);
						 }
					       else
						 {	/* Object/slots.scm 102 */
						    {	/* ./Llib/struct.scm 1463 */
						       obj_t aux_2314;
						       {	/* ./Llib/struct.scm 1457 */
							  obj_t aux_2315;
							  aux_2315 =
							     CAR(slots_801);
							  aux_2314 =
							     STRUCT_REF(aux_2315, ((long) 12));
						       }
						       STRUCT_SET(other_806, ((long) 12), aux_2314);
						    }
						    {	/* Object/slots.scm 114 */
						       bool_t test1510_813;
						       {	/* Object/slots.scm 114 */
							  bool_t test1511_814;
							  {	/* Object/slots.scm 114 */
							     bool_t res1642_2068;
							     {	/* Object/slots.scm 114 */
								obj_t obj_2064;
								obj_2064 = _warning__61___error;
								if (
								   INTEGERP(obj_2064))
								  {	/* ./Ieee/number.scm 6283 */
								     res1642_2068 = ((bool_t) 1);
								  }
								else
								  {	/* ./Ieee/number.scm 6283 */
								     res1642_2068 =
									REALP(obj_2064);
								  }
							     }
							     test1511_814 = res1642_2068;
							  }
							  if (test1511_814)
							    {	/* Object/slots.scm 114 */
							       test1510_813 =
								  _2___235___r4_numbers_6_5(_warning__61___error,
								  BINT(((long) 2)));
							    }
							  else
							    {	/* Object/slots.scm 114 */
							       test1510_813 = ((bool_t) 0);
							    }
						       }
						       if (test1510_813)
							 {	/* Object/slots.scm 114 */
							    user_warning_location_190_tools_error(loc_808, string1646_object_slots, string1648_object_slots, id_809);
							 }
						       else
							 {	/* Object/slots.scm 114 */
							    BUNSPEC;
							 }
						    }
						    {
						       obj_t slots_2327;
						       slots_2327 =
							  CDR(slots_801);
						       slots_801 = slots_2327;
						       goto loop_803;
						    }
						 }
					    }
					 }
				       else
					 {	/* Object/slots.scm 121 */
					    obj_t arg1519_821;
					    obj_t arg1520_822;
					    arg1519_821 =
					       CDR(slots_801);
					    {	/* ./Ieee/pair-list.scm 5689 */
					       obj_t aux_2330;
					       aux_2330 =
						  CAR(slots_801);
					       arg1520_822 =
						  MAKE_PAIR(aux_2330, res_802);
					    }
					    {
					       obj_t res_2334;
					       obj_t slots_2333;
					       slots_2333 = arg1519_821;
					       res_2334 = arg1520_822;
					       res_802 = res_2334;
					       slots_801 = slots_2333;
					       goto loop_803;
					    }
					 }
				    }
				 }
			      }
			    else
			      {		/* Object/slots.scm 97 */
				 {	/* Object/slots.scm 123 */
				    obj_t arg1523_825;
				    obj_t arg1525_826;
				    arg1523_825 =
				       CDR(slots_801);
				    {	/* ./Ieee/pair-list.scm 5689 */
				       obj_t aux_2336;
				       aux_2336 =
					  CAR(slots_801);
				       arg1525_826 =
					  MAKE_PAIR(aux_2336, res_802);
				    }
				    {
				       obj_t res_2340;
				       obj_t slots_2339;
				       slots_2339 = arg1523_825;
				       res_2340 = arg1525_826;
				       res_802 = res_2340;
				       slots_801 = slots_2339;
				       goto loop_803;
				    }
				 }
			      }
			 }
		    }
		 }
	       else
		 {	/* Object/slots.scm 143 */
		    obj_t s_497;
		    s_497 =
		       CAR(slots_488);
		    {
		       obj_t slot_id_111_498;
		       obj_t attr_499;
		       obj_t len_501;
		       obj_t slot_id_111_502;
		       obj_t attr_503;
		       obj_t slot_id_111_505;
		       obj_t attr_506;
		       obj_t slot_id_111_508;
		       if (
			  PAIRP(s_497))
			 {	/* Object/slots.scm 144 */
			    obj_t cdr_197_63_513;
			    cdr_197_63_513 =
			       CDR(s_497);
			    {	/* Object/slots.scm 144 */
			       bool_t test_2345;
			       {	/* ./Ieee/equiv.scm 5508 */
				  obj_t aux_2348;
				  obj_t aux_2346;
				  aux_2348 =
				     CNST_TABLE_REF(((long) 3));
				  aux_2346 =
				     CAR(s_497);
				  test_2345 =
				     (aux_2346 == aux_2348);
			       }
			       if (test_2345)
				 {	/* Object/slots.scm 144 */
				    if (
				       PAIRP(cdr_197_63_513))
				      {		/* Object/slots.scm 144 */
					 obj_t car_200_233_516;
					 car_200_233_516 =
					    CAR(cdr_197_63_513);
					 if (
					    PAIRP(car_200_233_516))
					   {	/* Object/slots.scm 144 */
					      obj_t cdr_204_81_518;
					      cdr_204_81_518 =
						 CDR(car_200_233_516);
					      {		/* Object/slots.scm 144 */
						 bool_t test_2357;
						 {	/* ./Ieee/equiv.scm 5508 */
						    obj_t aux_2360;
						    obj_t aux_2358;
						    aux_2360 =
						       CNST_TABLE_REF(((long) 4));
						    aux_2358 =
						       CAR(car_200_233_516);
						    test_2357 =
						       (aux_2358 == aux_2360);
						 }
						 if (test_2357)
						   {	/* Object/slots.scm 144 */
						      if (
							 PAIRP(cdr_204_81_518))
							{	/* Object/slots.scm 144 */
							   bool_t test_2365;
							   {	/* ./Ieee/equiv.scm 5508 */
							      obj_t aux_2366;
							      aux_2366 =
								 CDR(cdr_204_81_518);
							      test_2365 =
								 (aux_2366 == BNIL);
							   }
							   if (test_2365)
							     {	/* Object/slots.scm 144 */
								slot_id_111_498 =
								   CAR(cdr_204_81_518);
								attr_499 =
								   CDR(cdr_197_63_513);
								{	/* Object/slots.scm 146 */
								   obj_t id_703;
								   obj_t default_704;
								   obj_t a_exp_20_705;
								   obj_t virtual_706;
								   obj_t type_707;
								   {	/* Object/slots.scm 146 */
								      obj_t arg1439_725;
								      arg1439_725 =
									 CAR(slot_id_111_498);
								      {		/* Object/slots.scm 146 */
									 obj_t list1441_727;
									 {	/* Object/slots.scm 146 */
									    obj_t arg1442_728;
									    {	/* Object/slots.scm 146 */
									       obj_t aux_2370;
									       aux_2370 =
										  CNST_TABLE_REF(((long) 2));
									       arg1442_728 =
										  MAKE_PAIR(aux_2370, BNIL);
									    }
									    list1441_727 =
									       MAKE_PAIR(arg1439_725, arg1442_728);
									 }
									 id_703 =
									    symbol_append_197___r4_symbols_6_4(list1441_727);
								      }
								   }
								   default_704 =
								      find_default_attr_77_object_slots(attr_499);
								   a_exp_20_705 =
								      find_assert_attr_93_object_slots(attr_499);
								   virtual_706 =
								      find_virtual_attr_39_object_slots(attr_499);
								   {	/* Object/slots.scm 150 */
								      bool_t test1443_729;
								      {		/* Object/slots.scm 150 */
									 obj_t obj2_1456;
									 obj2_1456 = ____74_type_cache;
									 {	/* ./Ieee/equiv.scm 5508 */
									    obj_t aux_2378;
									    aux_2378 =
									       CDR(slot_id_111_498);
									    test1443_729 =
									       (aux_2378 == obj2_1456);
									 }
								      }
								      if (test1443_729)
									{	/* Object/slots.scm 150 */
									   type_707 = _obj__252_type_cache;
									}
								      else
									{	/* Object/slots.scm 150 */
									   type_707 =
									      CDR(slot_id_111_498);
									}
								   }
								   ensure_type_defined__128_object_slots(
								      (type_bglt) (type_707), src_77);
								   {	/* Object/slots.scm 154 */
								      bool_t test_2385;
								      {		/* Object/slots.scm 154 */
									 bool_t test_2386;
									 {	/* ./Ieee/pair-list.scm 5701 */
									    obj_t aux_2387;
									    aux_2387 =
									       CAR(virtual_706);
									    test_2386 =
									       CBOOL(aux_2387);
									 }
									 if (test_2386)
									   {	/* Object/slots.scm 154 */
									      test_2385 = ((bool_t) 1)
										 ;
									   }
									 else
									   {	/* ./Ieee/pair-list.scm 5707 */
									      obj_t aux_2390;
									      aux_2390 =
										 CDR(virtual_706);
									      test_2385 =
										 CBOOL(aux_2390);
									   }
								      }
								      if (test_2385)
									{	/* Object/slots.scm 155 */
									   obj_t list1422_709;
									   list1422_709 =
									      MAKE_PAIR(BNIL, BNIL);
									   user_error_151_tools_error(string1649_object_slots, string1654_object_slots, s_497, list1422_709);
									}
								      else
									{	/* Object/slots.scm 154 */
									   BUNSPEC;
									}
								   }
								   {	/* Object/slots.scm 159 */
								      obj_t arg1424_711;
								      obj_t arg1425_712;
								      arg1424_711 =
									 CDR(slots_488);
								      {		/* Object/slots.scm 160 */
									 obj_t arg1426_713;
									 obj_t arg1427_714;
									 {	/* Object/slots.scm 160 */
									    obj_t arg1428_715;
									    obj_t arg1430_716;
									    obj_t arg1431_717;
									    obj_t arg1432_718;
									    obj_t arg1433_719;
									    arg1428_715 =
									       CAR(slot_id_111_498);
									    arg1430_716 =
									       scheme_symbol__c_string_183_object_slots(
									       CAR(slot_id_111_498));
									    arg1431_717 =
									       memq___r4_pairs_and_lists_6_3(
									       CNST_TABLE_REF(((long) 1)), attr_499);
									    arg1432_718 =
									       CAR(default_704);
									    arg1433_719 =
									       CDR(default_704);
									    {	/* ./Object/class.sch 590 */
									       obj_t new_1482;
									       {	/* ./Object/class.sch 590 */
										  obj_t aux_2403;
										  aux_2403 =
										     CNST_TABLE_REF(((long) 0));
										  new_1482 =
										     create_struct(aux_2403, ((long) 17));
									       }
									       {	/* ./Llib/struct.scm 1463 */
										  obj_t aux_2406;
										  aux_2406 =
										     (obj_t) (class_73);
										  STRUCT_SET(new_1482, ((long) 16), aux_2406);
									       }
									       STRUCT_SET(new_1482, ((long) 15), s_497);
									       STRUCT_SET(new_1482, ((long) 14), BFALSE);
									       STRUCT_SET(new_1482, ((long) 13), BFALSE);
									       {	/* ./Llib/struct.scm 1463 */
										  obj_t aux_2412;
										  aux_2412 =
										     BINT(((long) 0));
										  STRUCT_SET(new_1482, ((long) 12), aux_2412);
									       }
									       STRUCT_SET(new_1482, ((long) 11), BFALSE);
									       STRUCT_SET(new_1482, ((long) 10), a_exp_20_705);
									       STRUCT_SET(new_1482, ((long) 9), arg1433_719);
									       STRUCT_SET(new_1482, ((long) 8), arg1432_718);
									       STRUCT_SET(new_1482, ((long) 7), arg1431_717);
									       STRUCT_SET(new_1482, ((long) 6), BFALSE);
									       STRUCT_SET(new_1482, ((long) 5), BTRUE);
									       STRUCT_SET(new_1482, ((long) 4), BUNSPEC);
									       STRUCT_SET(new_1482, ((long) 3), BFALSE);
									       STRUCT_SET(new_1482, ((long) 2), type_707);
									       STRUCT_SET(new_1482, ((long) 1), arg1430_716);
									       STRUCT_SET(new_1482, ((long) 0), arg1428_715);
									       arg1426_713 = new_1482;
									    }
									 }
									 {	/* Object/slots.scm 179 */
									    obj_t arg1436_722;
									    {	/* Object/slots.scm 179 */
									       obj_t arg1437_723;
									       arg1437_723 =
										  scheme_symbol__c_string_183_object_slots(id_703);
									       {	/* Object/slots.scm 178 */
										  obj_t type_1570;
										  type_1570 = _long__149_type_cache;
										  {	/* ./Object/class.sch 590 */
										     obj_t new_1585;
										     {	/* ./Object/class.sch 590 */
											obj_t aux_2428;
											aux_2428 =
											   CNST_TABLE_REF(((long) 0));
											new_1585 =
											   create_struct(aux_2428, ((long) 17));
										     }
										     {	/* ./Llib/struct.scm 1463 */
											obj_t aux_2431;
											aux_2431 =
											   (obj_t) (class_73);
											STRUCT_SET(new_1585, ((long) 16), aux_2431);
										     }
										     STRUCT_SET(new_1585, ((long) 15), s_497);
										     STRUCT_SET(new_1585, ((long) 14), BFALSE);
										     STRUCT_SET(new_1585, ((long) 13), BFALSE);
										     {	/* ./Llib/struct.scm 1463 */
											obj_t aux_2437;
											aux_2437 =
											   BINT(((long) 0));
											STRUCT_SET(new_1585, ((long) 12), aux_2437);
										     }
										     STRUCT_SET(new_1585, ((long) 11), BFALSE);
										     STRUCT_SET(new_1585, ((long) 10), BFALSE);
										     STRUCT_SET(new_1585, ((long) 9), BUNSPEC);
										     STRUCT_SET(new_1585, ((long) 8), BFALSE);
										     STRUCT_SET(new_1585, ((long) 7), BTRUE);
										     STRUCT_SET(new_1585, ((long) 6), BTRUE);
										     STRUCT_SET(new_1585, ((long) 5), BFALSE);
										     STRUCT_SET(new_1585, ((long) 4), BUNSPEC);
										     STRUCT_SET(new_1585, ((long) 3), BFALSE);
										     STRUCT_SET(new_1585, ((long) 2), type_1570);
										     STRUCT_SET(new_1585, ((long) 1), arg1437_723);
										     STRUCT_SET(new_1585, ((long) 0), id_703);
										     arg1436_722 = new_1585;
										  }
									       }
									    }
									    arg1427_714 =
									       MAKE_PAIR(arg1436_722, res_489);
									 }
									 arg1425_712 =
									    MAKE_PAIR(arg1426_713, arg1427_714);
								      }
								      {
									 obj_t res_2455;
									 obj_t slots_2454;
									 slots_2454 = arg1424_711;
									 res_2455 = arg1425_712;
									 res_489 = res_2455;
									 slots_488 = slots_2454;
									 goto loop_491;
								      }
								   }
								}
							     }
							   else
							     {	/* Object/slots.scm 144 */
								obj_t car_220_3_524;
								car_220_3_524 =
								   CAR(s_497);
								if (
								   PAIRP(car_220_3_524))
								  {	/* Object/slots.scm 144 */
								     obj_t cdr_224_17_526;
								     cdr_224_17_526 =
									CDR(car_220_3_524);
								     {	/* Object/slots.scm 144 */
									bool_t test_2462;
									{	/* ./Ieee/equiv.scm 5508 */
									   obj_t aux_2465;
									   obj_t aux_2463;
									   aux_2465 =
									      CNST_TABLE_REF(((long) 4));
									   aux_2463 =
									      CAR(car_220_3_524);
									   test_2462 =
									      (aux_2463 == aux_2465);
									}
									if (test_2462)
									  {	/* Object/slots.scm 144 */
									     if (
										PAIRP(cdr_224_17_526))
									       {	/* Object/slots.scm 144 */
										  bool_t test_2470;
										  {	/* ./Ieee/equiv.scm 5508 */
										     obj_t aux_2471;
										     aux_2471 =
											CDR(cdr_224_17_526);
										     test_2470 =
											(aux_2471 == BNIL);
										  }
										  if (test_2470)
										    {	/* Object/slots.scm 144 */
										       slot_id_111_505 =
											  CAR(cdr_224_17_526);
										       attr_506 = cdr_197_63_513;
										     tag_187_23_507:
										       {	/* Object/slots.scm 232 */
											  obj_t default_755;
											  default_755 =
											     find_default_attr_77_object_slots(attr_506);
											  {	/* Object/slots.scm 232 */
											     obj_t a_exp_20_756;
											     a_exp_20_756 =
												find_assert_attr_93_object_slots(attr_506);
											     {	/* Object/slots.scm 233 */
												obj_t virtual_757;
												virtual_757 =
												   find_virtual_attr_39_object_slots(attr_506);
												{	/* Object/slots.scm 234 */
												   obj_t virtual__80_758;
												   {	/* Object/slots.scm 235 */
												      obj_t _ortest_1213_787;
												      _ortest_1213_787 =
													 CAR(virtual_757);
												      if (
													 CBOOL(_ortest_1213_787))
													{	/* Object/slots.scm 235 */
													   virtual__80_758 = _ortest_1213_787;
													}
												      else
													{	/* Object/slots.scm 235 */
													   virtual__80_758 =
													      CDR(virtual_757);
													}
												   }
												   {	/* Object/slots.scm 235 */
												      obj_t reado__215_759;
												      reado__215_759 =
													 memq___r4_pairs_and_lists_6_3(
													 CNST_TABLE_REF(((long) 1)), attr_506);
												      {		/* Object/slots.scm 236 */
													 obj_t type_760;
													 {	/* Object/slots.scm 237 */
													    bool_t test1492_785;
													    {	/* Object/slots.scm 237 */
													       obj_t obj2_1796;
													       obj2_1796 = ____74_type_cache;
													       {	/* ./Ieee/equiv.scm 5508 */
														  obj_t aux_2483;
														  aux_2483 =
														     CDR(slot_id_111_505);
														  test1492_785 =
														     (aux_2483 == obj2_1796);
													       }
													    }
													    if (test1492_785)
													      {		/* Object/slots.scm 237 */
														 type_760 = _obj__252_type_cache;
													      }
													    else
													      {		/* Object/slots.scm 237 */
														 type_760 =
														    CDR(slot_id_111_505);
													      }
													 }
													 {	/* Object/slots.scm 237 */

													    {	/* Object/slots.scm 241 */
													       bool_t test_2488;
													       {	/* Object/slots.scm 241 */
														  bool_t test_2489;
														  {	/* ./Ieee/pair-list.scm 5707 */
														     obj_t aux_2490;
														     aux_2490 =
															CDR(virtual_757);
														     test_2489 =
															CBOOL(aux_2490);
														  }
														  if (test_2489)
														    {	/* Object/slots.scm 241 */
														       bool_t test_2493;
														       {	/* ./Ieee/pair-list.scm 5701 */
															  obj_t aux_2494;
															  aux_2494 =
															     CAR(virtual_757);
															  test_2493 =
															     CBOOL(aux_2494);
														       }
														       if (test_2493)
															 {	/* Object/slots.scm 241 */
															    test_2488 = ((bool_t) 0)
															       ;
															 }
														       else
															 {	/* Object/slots.scm 241 */
															    test_2488 = ((bool_t) 1)
															       ;
															 }
														    }
														  else
														    {	/* Object/slots.scm 241 */
														       test_2488 = ((bool_t) 0)
															  ;
														    }
													       }
													       if (test_2488)
														 {	/* Object/slots.scm 241 */
														    {	/* Object/slots.scm 242 */
														       obj_t list1468_762;
														       list1468_762 =
															  MAKE_PAIR(BNIL, BNIL);
														       user_error_151_tools_error(string1649_object_slots, string1651_object_slots, s_497, list1468_762);
														    }
														 }
													       else
														 {	/* Object/slots.scm 246 */
														    bool_t test_2499;
														    {	/* Object/slots.scm 246 */
														       bool_t test_2500;
														       {	/* ./Ieee/pair-list.scm 5701 */
															  obj_t aux_2501;
															  aux_2501 =
															     CAR(virtual_757);
															  test_2500 =
															     CBOOL(aux_2501);
														       }
														       if (test_2500)
															 {	/* Object/slots.scm 246 */
															    bool_t test_2504;
															    {	/* ./Ieee/pair-list.scm 5707 */
															       obj_t aux_2505;
															       aux_2505 =
																  CDR(virtual_757);
															       test_2504 =
																  CBOOL(aux_2505);
															    }
															    if (test_2504)
															      {		/* Object/slots.scm 246 */
																 test_2499 =
																    CBOOL(reado__215_759)
																    ;
															      }
															    else
															      {		/* Object/slots.scm 246 */
																 test_2499 = ((bool_t) 0)
																    ;
															      }
															 }
														       else
															 {	/* Object/slots.scm 246 */
															    test_2499 = ((bool_t) 0)
															       ;
															 }
														    }
														    if (test_2499)
														      {		/* Object/slots.scm 246 */
															 {	/* Object/slots.scm 247 */
															    obj_t list1470_764;
															    list1470_764 =
															       MAKE_PAIR(BNIL, BNIL);
															    user_error_151_tools_error(string1649_object_slots, string1652_object_slots, s_497, list1470_764);
															 }
														      }
														    else
														      {		/* Object/slots.scm 251 */
															 bool_t test_2511;
															 {	/* Object/slots.scm 251 */
															    bool_t test_2512;
															    {	/* ./Ieee/pair-list.scm 5701 */
															       obj_t aux_2513;
															       aux_2513 =
																  CAR(virtual_757);
															       test_2512 =
																  CBOOL(aux_2513);
															    }
															    if (test_2512)
															      {		/* Object/slots.scm 251 */
																 bool_t test_2516;
																 {	/* ./Ieee/pair-list.scm 5707 */
																    obj_t aux_2517;
																    aux_2517 =
																       CDR(virtual_757);
																    test_2516 =
																       CBOOL(aux_2517);
																 }
																 if (test_2516)
																   {	/* Object/slots.scm 251 */
																      test_2511 = ((bool_t) 0)
																	 ;
																   }
																 else
																   {	/* Object/slots.scm 251 */
																      if (
																	 CBOOL(reado__215_759))
																	{	/* Object/slots.scm 251 */
																	   test_2511 = ((bool_t) 0)
																	      ;
																	}
																      else
																	{	/* Object/slots.scm 251 */
																	   test_2511 = ((bool_t) 1)
																	      ;
																	}
																   }
															      }
															    else
															      {		/* Object/slots.scm 251 */
																 test_2511 = ((bool_t) 0)
																    ;
															      }
															 }
															 if (test_2511)
															   {	/* Object/slots.scm 251 */
															      {		/* Object/slots.scm 252 */
																 obj_t list1472_766;
																 list1472_766 =
																    MAKE_PAIR(BNIL, BNIL);
																 user_error_151_tools_error(string1649_object_slots, string1653_object_slots, s_497, list1472_766);
															      }
															   }
															 else
															   {	/* Object/slots.scm 251 */
															      BFALSE;
															   }
														      }
														 }
													    }
													    ensure_type_defined__128_object_slots(
													       (type_bglt) (type_760), src_77);
													    {	/* Object/slots.scm 257 */
													       obj_t arg1479_773;
													       obj_t arg1480_774;
													       obj_t arg1481_775;
													       arg1479_773 =
														  CDR(slots_488);
													       {	/* Object/slots.scm 258 */
														  obj_t arg1482_776;
														  {	/* Object/slots.scm 258 */
														     obj_t arg1483_777;
														     obj_t arg1484_778;
														     obj_t arg1485_779;
														     obj_t arg1486_780;
														     obj_t arg1488_781;
														     obj_t arg1489_782;
														     obj_t arg1490_783;
														     arg1483_777 =
															CAR(slot_id_111_505);
														     arg1484_778 =
															scheme_symbol__c_string_183_object_slots(
															CAR(slot_id_111_505));
														     arg1485_779 =
															CAR(default_755);
														     arg1486_780 =
															CDR(default_755);
														     if (
															CBOOL(virtual__80_758))
														       {	/* Object/slots.scm 270 */
															  arg1488_781 = vnum_490;
														       }
														     else
														       {	/* Object/slots.scm 270 */
															  arg1488_781 =
															     BINT(((long) 0));
														       }
														     arg1489_782 =
															CAR(virtual_757);
														     arg1490_783 =
															CDR(virtual_757);
														     {	/* ./Object/class.sch 590 */
															obj_t new_1828;
															{	/* ./Object/class.sch 590 */
															   obj_t aux_2537;
															   aux_2537 =
															      CNST_TABLE_REF(((long) 0));
															   new_1828 =
															      create_struct(aux_2537, ((long) 17));
															}
															{	/* ./Llib/struct.scm 1463 */
															   obj_t aux_2540;
															   aux_2540 =
															      (obj_t) (class_73);
															   STRUCT_SET(new_1828, ((long) 16), aux_2540);
															}
															STRUCT_SET(new_1828, ((long) 15), s_497);
															STRUCT_SET(new_1828, ((long) 14), arg1490_783);
															STRUCT_SET(new_1828, ((long) 13), arg1489_782);
															STRUCT_SET(new_1828, ((long) 12), arg1488_781);
															STRUCT_SET(new_1828, ((long) 11), virtual__80_758);
															STRUCT_SET(new_1828, ((long) 10), a_exp_20_756);
															STRUCT_SET(new_1828, ((long) 9), arg1486_780);
															STRUCT_SET(new_1828, ((long) 8), arg1485_779);
															STRUCT_SET(new_1828, ((long) 7), reado__215_759);
															STRUCT_SET(new_1828, ((long) 6), BFALSE);
															STRUCT_SET(new_1828, ((long) 5), BFALSE);
															STRUCT_SET(new_1828, ((long) 4), BUNSPEC);
															STRUCT_SET(new_1828, ((long) 3), BFALSE);
															STRUCT_SET(new_1828, ((long) 2), type_760);
															STRUCT_SET(new_1828, ((long) 1), arg1484_778);
															STRUCT_SET(new_1828, ((long) 0), arg1483_777);
															arg1482_776 = new_1828;
														     }
														  }
														  arg1480_774 =
														     MAKE_PAIR(arg1482_776, res_489);
													       }
													       if (
														  CBOOL(virtual__80_758))
														 {	/* Object/slots.scm 276 */
														    arg1481_775 =
														       _2__168___r4_numbers_6_5(vnum_490,
														       BINT(((long) 1)));
														 }
													       else
														 {	/* Object/slots.scm 276 */
														    arg1481_775 = vnum_490;
														 }
													       {
														  obj_t vnum_2566;
														  obj_t res_2565;
														  obj_t slots_2564;
														  slots_2564 = arg1479_773;
														  res_2565 = arg1480_774;
														  vnum_2566 = arg1481_775;
														  vnum_490 = vnum_2566;
														  res_489 = res_2565;
														  slots_488 = slots_2564;
														  goto loop_491;
													       }
													    }
													 }
												      }
												   }
												}
											     }
											  }
										       }
										    }
										  else
										    {	/* Object/slots.scm 144 */
										     tag_189_52_510:
										       {	/* Object/slots.scm 303 */
											  obj_t list1503_798;
											  list1503_798 =
											     MAKE_PAIR(BNIL, BNIL);
											  return
											     user_error_151_tools_error(string1649_object_slots, string1650_object_slots, s_497, list1503_798);
										       }
										    }
									       }
									     else
									       {	/* Object/slots.scm 144 */
										  goto tag_189_52_510;
									       }
									  }
									else
									  {	/* Object/slots.scm 144 */
									     goto tag_189_52_510;
									  }
								     }
								  }
								else
								  {	/* Object/slots.scm 144 */
								     goto tag_189_52_510;
								  }
							     }
							}
						      else
							{	/* Object/slots.scm 144 */
							   obj_t car_248_177_538;
							   car_248_177_538 =
							      CAR(s_497);
							   if (
							      PAIRP(car_248_177_538))
							     {	/* Object/slots.scm 144 */
								obj_t cdr_252_75_540;
								cdr_252_75_540 =
								   CDR(car_248_177_538);
								{	/* Object/slots.scm 144 */
								   bool_t test_2574;
								   {	/* ./Ieee/equiv.scm 5508 */
								      obj_t aux_2577;
								      obj_t aux_2575;
								      aux_2577 =
									 CNST_TABLE_REF(((long) 4));
								      aux_2575 =
									 CAR(car_248_177_538);
								      test_2574 =
									 (aux_2575 == aux_2577);
								   }
								   if (test_2574)
								     {	/* Object/slots.scm 144 */
									if (
									   PAIRP(cdr_252_75_540))
									  {	/* Object/slots.scm 144 */
									     bool_t test_2582;
									     {	/* ./Ieee/equiv.scm 5508 */
										obj_t aux_2583;
										aux_2583 =
										   CDR(cdr_252_75_540);
										test_2582 =
										   (aux_2583 == BNIL);
									     }
									     if (test_2582)
									       {
										  obj_t attr_2588;
										  obj_t slot_id_111_2586;
										  slot_id_111_2586 =
										     CAR(cdr_252_75_540);
										  attr_2588 = cdr_197_63_513;
										  attr_506 = attr_2588;
										  slot_id_111_505 = slot_id_111_2586;
										  goto tag_187_23_507;
									       }
									     else
									       {	/* Object/slots.scm 144 */
										  goto tag_189_52_510;
									       }
									  }
									else
									  {	/* Object/slots.scm 144 */
									     goto tag_189_52_510;
									  }
								     }
								   else
								     {	/* Object/slots.scm 144 */
									goto tag_189_52_510;
								     }
								}
							     }
							   else
							     {	/* Object/slots.scm 144 */
								goto tag_189_52_510;
							     }
							}
						   }
						 else
						   {	/* Object/slots.scm 144 */
						      obj_t car_276_9_550;
						      car_276_9_550 =
							 CAR(s_497);
						      if (
							 PAIRP(car_276_9_550))
							{	/* Object/slots.scm 144 */
							   obj_t cdr_280_102_552;
							   cdr_280_102_552 =
							      CDR(car_276_9_550);
							   {	/* Object/slots.scm 144 */
							      bool_t test_2593;
							      {		/* ./Ieee/equiv.scm 5508 */
								 obj_t aux_2596;
								 obj_t aux_2594;
								 aux_2596 =
								    CNST_TABLE_REF(((long) 4));
								 aux_2594 =
								    CAR(car_276_9_550);
								 test_2593 =
								    (aux_2594 == aux_2596);
							      }
							      if (test_2593)
								{	/* Object/slots.scm 144 */
								   if (
								      PAIRP(cdr_280_102_552))
								     {	/* Object/slots.scm 144 */
									bool_t test_2601;
									{	/* ./Ieee/equiv.scm 5508 */
									   obj_t aux_2602;
									   aux_2602 =
									      CDR(cdr_280_102_552);
									   test_2601 =
									      (aux_2602 == BNIL);
									}
									if (test_2601)
									  {
									     obj_t attr_2607;
									     obj_t slot_id_111_2605;
									     slot_id_111_2605 =
										CAR(cdr_280_102_552);
									     attr_2607 = cdr_197_63_513;
									     attr_506 = attr_2607;
									     slot_id_111_505 = slot_id_111_2605;
									     goto tag_187_23_507;
									  }
									else
									  {	/* Object/slots.scm 144 */
									     goto tag_189_52_510;
									  }
								     }
								   else
								     {	/* Object/slots.scm 144 */
									goto tag_189_52_510;
								     }
								}
							      else
								{	/* Object/slots.scm 144 */
								   goto tag_189_52_510;
								}
							   }
							}
						      else
							{	/* Object/slots.scm 144 */
							   goto tag_189_52_510;
							}
						   }
					      }
					   }
					 else
					   {	/* Object/slots.scm 144 */
					      obj_t car_304_194_564;
					      car_304_194_564 =
						 CAR(s_497);
					      if (
						 PAIRP(car_304_194_564))
						{	/* Object/slots.scm 144 */
						   obj_t cdr_308_122_566;
						   cdr_308_122_566 =
						      CDR(car_304_194_564);
						   {	/* Object/slots.scm 144 */
						      bool_t test_2612;
						      {		/* ./Ieee/equiv.scm 5508 */
							 obj_t aux_2615;
							 obj_t aux_2613;
							 aux_2615 =
							    CNST_TABLE_REF(((long) 4));
							 aux_2613 =
							    CAR(car_304_194_564);
							 test_2612 =
							    (aux_2613 == aux_2615);
						      }
						      if (test_2612)
							{	/* Object/slots.scm 144 */
							   if (
							      PAIRP(cdr_308_122_566))
							     {	/* Object/slots.scm 144 */
								bool_t test_2620;
								{	/* ./Ieee/equiv.scm 5508 */
								   obj_t aux_2621;
								   aux_2621 =
								      CDR(cdr_308_122_566);
								   test_2620 =
								      (aux_2621 == BNIL);
								}
								if (test_2620)
								  {
								     obj_t attr_2626;
								     obj_t slot_id_111_2624;
								     slot_id_111_2624 =
									CAR(cdr_308_122_566);
								     attr_2626 = cdr_197_63_513;
								     attr_506 = attr_2626;
								     slot_id_111_505 = slot_id_111_2624;
								     goto tag_187_23_507;
								  }
								else
								  {	/* Object/slots.scm 144 */
								     goto tag_189_52_510;
								  }
							     }
							   else
							     {	/* Object/slots.scm 144 */
								goto tag_189_52_510;
							     }
							}
						      else
							{	/* Object/slots.scm 144 */
							   goto tag_189_52_510;
							}
						   }
						}
					      else
						{	/* Object/slots.scm 144 */
						   goto tag_189_52_510;
						}
					   }
				      }
				    else
				      {		/* Object/slots.scm 144 */
					 obj_t car_332_144_576;
					 car_332_144_576 =
					    CAR(s_497);
					 if (
					    PAIRP(car_332_144_576))
					   {	/* Object/slots.scm 144 */
					      obj_t cdr_336_47_578;
					      cdr_336_47_578 =
						 CDR(car_332_144_576);
					      {		/* Object/slots.scm 144 */
						 bool_t test_2631;
						 {	/* ./Ieee/equiv.scm 5508 */
						    obj_t aux_2634;
						    obj_t aux_2632;
						    aux_2634 =
						       CNST_TABLE_REF(((long) 4));
						    aux_2632 =
						       CAR(car_332_144_576);
						    test_2631 =
						       (aux_2632 == aux_2634);
						 }
						 if (test_2631)
						   {	/* Object/slots.scm 144 */
						      if (
							 PAIRP(cdr_336_47_578))
							{	/* Object/slots.scm 144 */
							   bool_t test_2639;
							   {	/* ./Ieee/equiv.scm 5508 */
							      obj_t aux_2640;
							      aux_2640 =
								 CDR(cdr_336_47_578);
							      test_2639 =
								 (aux_2640 == BNIL);
							   }
							   if (test_2639)
							     {
								obj_t attr_2645;
								obj_t slot_id_111_2643;
								slot_id_111_2643 =
								   CAR(cdr_336_47_578);
								attr_2645 = cdr_197_63_513;
								attr_506 = attr_2645;
								slot_id_111_505 = slot_id_111_2643;
								goto tag_187_23_507;
							     }
							   else
							     {	/* Object/slots.scm 144 */
								goto tag_189_52_510;
							     }
							}
						      else
							{	/* Object/slots.scm 144 */
							   goto tag_189_52_510;
							}
						   }
						 else
						   {	/* Object/slots.scm 144 */
						      goto tag_189_52_510;
						   }
					      }
					   }
					 else
					   {	/* Object/slots.scm 144 */
					      goto tag_189_52_510;
					   }
				      }
				 }
			       else
				 {	/* Object/slots.scm 144 */
				    bool_t test_2646;
				    {	/* ./Ieee/equiv.scm 5508 */
				       obj_t aux_2649;
				       obj_t aux_2647;
				       aux_2649 =
					  CNST_TABLE_REF(((long) 5));
				       aux_2647 =
					  CAR(s_497);
				       test_2646 =
					  (aux_2647 == aux_2649);
				    }
				    if (test_2646)
				      {		/* Object/slots.scm 144 */
					 if (
					    PAIRP(cdr_197_63_513))
					   {	/* Object/slots.scm 144 */
					      obj_t cdr_362_246_591;
					      cdr_362_246_591 =
						 CDR(cdr_197_63_513);
					      if (
						 PAIRP(cdr_362_246_591))
						{	/* Object/slots.scm 144 */
						   obj_t car_366_44_593;
						   car_366_44_593 =
						      CAR(cdr_362_246_591);
						   if (
						      PAIRP(car_366_44_593))
						     {	/* Object/slots.scm 144 */
							obj_t cdr_370_220_595;
							cdr_370_220_595 =
							   CDR(car_366_44_593);
							{	/* Object/slots.scm 144 */
							   bool_t test_2661;
							   {	/* ./Ieee/equiv.scm 5508 */
							      obj_t aux_2664;
							      obj_t aux_2662;
							      aux_2664 =
								 CNST_TABLE_REF(((long) 4));
							      aux_2662 =
								 CAR(car_366_44_593);
							      test_2661 =
								 (aux_2662 == aux_2664);
							   }
							   if (test_2661)
							     {	/* Object/slots.scm 144 */
								if (
								   PAIRP(cdr_370_220_595))
								  {	/* Object/slots.scm 144 */
								     bool_t test_2669;
								     {	/* ./Ieee/equiv.scm 5508 */
									obj_t aux_2670;
									aux_2670 =
									   CDR(cdr_370_220_595);
									test_2669 =
									   (aux_2670 == BNIL);
								     }
								     if (test_2669)
								       {	/* Object/slots.scm 144 */
									  len_501 =
									     CAR(cdr_197_63_513);
									  slot_id_111_502 =
									     CAR(cdr_370_220_595);
									  attr_503 =
									     CDR(cdr_362_246_591);
									  {	/* Object/slots.scm 198 */
									     obj_t id_731;
									     obj_t default_732;
									     obj_t a_exp_20_733;
									     obj_t virtual_734;
									     obj_t type_735;
									     {	/* Object/slots.scm 198 */
										obj_t arg1461_749;
										arg1461_749 =
										   CAR(slot_id_111_502);
										{	/* Object/slots.scm 198 */
										   obj_t list1463_751;
										   {	/* Object/slots.scm 198 */
										      obj_t arg1464_752;
										      {		/* Object/slots.scm 198 */
											 obj_t aux_2674;
											 aux_2674 =
											    CNST_TABLE_REF(((long) 2));
											 arg1464_752 =
											    MAKE_PAIR(aux_2674, BNIL);
										      }
										      list1463_751 =
											 MAKE_PAIR(arg1461_749, arg1464_752);
										   }
										   id_731 =
										      symbol_append_197___r4_symbols_6_4(list1463_751);
										}
									     }
									     default_732 =
										find_default_attr_77_object_slots(attr_503);
									     a_exp_20_733 =
										find_assert_attr_93_object_slots(attr_503);
									     virtual_734 =
										find_virtual_attr_39_object_slots(attr_503);
									     {	/* Object/slots.scm 202 */
										bool_t test1465_753;
										{	/* Object/slots.scm 202 */
										   obj_t obj2_1678;
										   obj2_1678 = ____74_type_cache;
										   {	/* ./Ieee/equiv.scm 5508 */
										      obj_t aux_2682;
										      aux_2682 =
											 CDR(slot_id_111_502);
										      test1465_753 =
											 (aux_2682 == obj2_1678);
										   }
										}
										if (test1465_753)
										  {	/* Object/slots.scm 202 */
										     type_735 = _obj__252_type_cache;
										  }
										else
										  {	/* Object/slots.scm 202 */
										     type_735 =
											CDR(slot_id_111_502);
										  }
									     }
									     ensure_type_defined__128_object_slots(
										(type_bglt) (type_735), src_77);
									     {	/* Object/slots.scm 206 */
										bool_t test_2689;
										{	/* Object/slots.scm 206 */
										   bool_t test_2690;
										   {	/* ./Ieee/pair-list.scm 5701 */
										      obj_t aux_2691;
										      aux_2691 =
											 CAR(virtual_734);
										      test_2690 =
											 CBOOL(aux_2691);
										   }
										   if (test_2690)
										     {	/* Object/slots.scm 206 */
											test_2689 = ((bool_t) 1)
											   ;
										     }
										   else
										     {	/* ./Ieee/pair-list.scm 5707 */
											obj_t aux_2694;
											aux_2694 =
											   CDR(virtual_734);
											test_2689 =
											   CBOOL(aux_2694);
										     }
										}
										if (test_2689)
										  {	/* Object/slots.scm 207 */
										     obj_t list1446_737;
										     list1446_737 =
											MAKE_PAIR(BNIL, BNIL);
										     user_error_151_tools_error(string1649_object_slots, string1654_object_slots, s_497, list1446_737);
										  }
										else
										  {	/* Object/slots.scm 206 */
										     BUNSPEC;
										  }
									     }
									     {	/* Object/slots.scm 211 */
										obj_t arg1449_739;
										obj_t arg1450_740;
										arg1449_739 =
										   CDR(slots_488);
										{	/* Object/slots.scm 212 */
										   obj_t arg1451_741;
										   {	/* Object/slots.scm 212 */
										      obj_t arg1452_742;
										      obj_t arg1454_743;
										      obj_t arg1455_744;
										      obj_t arg1456_745;
										      obj_t arg1457_746;
										      arg1452_742 =
											 CAR(slot_id_111_502);
										      arg1454_743 =
											 scheme_symbol__c_string_183_object_slots(
											 CAR(slot_id_111_502));
										      arg1455_744 =
											 memq___r4_pairs_and_lists_6_3(
											 CNST_TABLE_REF(((long) 1)), attr_503);
										      arg1456_745 =
											 CAR(default_732);
										      arg1457_746 =
											 CDR(default_732);
										      {		/* ./Object/class.sch 590 */
											 obj_t new_1704;
											 {	/* ./Object/class.sch 590 */
											    obj_t aux_2707;
											    aux_2707 =
											       CNST_TABLE_REF(((long) 0));
											    new_1704 =
											       create_struct(aux_2707, ((long) 17));
											 }
											 {	/* ./Llib/struct.scm 1463 */
											    obj_t aux_2710;
											    aux_2710 =
											       (obj_t) (class_73);
											    STRUCT_SET(new_1704, ((long) 16), aux_2710);
											 }
											 STRUCT_SET(new_1704, ((long) 15), s_497);
											 STRUCT_SET(new_1704, ((long) 14), BFALSE);
											 STRUCT_SET(new_1704, ((long) 13), BFALSE);
											 {	/* ./Llib/struct.scm 1463 */
											    obj_t aux_2716;
											    aux_2716 =
											       BINT(((long) 0));
											    STRUCT_SET(new_1704, ((long) 12), aux_2716);
											 }
											 STRUCT_SET(new_1704, ((long) 11), BFALSE);
											 STRUCT_SET(new_1704, ((long) 10), a_exp_20_733);
											 STRUCT_SET(new_1704, ((long) 9), arg1457_746);
											 STRUCT_SET(new_1704, ((long) 8), arg1456_745);
											 STRUCT_SET(new_1704, ((long) 7), arg1455_744);
											 STRUCT_SET(new_1704, ((long) 6), BFALSE);
											 STRUCT_SET(new_1704, ((long) 5), BFALSE);
											 STRUCT_SET(new_1704, ((long) 4), len_501);
											 STRUCT_SET(new_1704, ((long) 3), BTRUE);
											 STRUCT_SET(new_1704, ((long) 2), type_735);
											 STRUCT_SET(new_1704, ((long) 1), arg1454_743);
											 STRUCT_SET(new_1704, ((long) 0), arg1452_742);
											 arg1451_741 = new_1704;
										      }
										   }
										   arg1450_740 =
										      MAKE_PAIR(arg1451_741, res_489);
										}
										{
										   obj_t res_2733;
										   obj_t slots_2732;
										   slots_2732 = arg1449_739;
										   res_2733 = arg1450_740;
										   res_489 = res_2733;
										   slots_488 = slots_2732;
										   goto loop_491;
										}
									     }
									  }
								       }
								     else
								       {	/* Object/slots.scm 144 */
									  obj_t car_380_203_602;
									  car_380_203_602 =
									     CAR(s_497);
									  if (
									     PAIRP(car_380_203_602))
									    {	/* Object/slots.scm 144 */
									       obj_t cdr_384_139_604;
									       cdr_384_139_604 =
										  CDR(car_380_203_602);
									       {	/* Object/slots.scm 144 */
										  bool_t test_2741;
										  {	/* ./Ieee/equiv.scm 5508 */
										     obj_t aux_2744;
										     obj_t aux_2742;
										     aux_2744 =
											CNST_TABLE_REF(((long) 4));
										     aux_2742 =
											CAR(car_380_203_602);
										     test_2741 =
											(aux_2742 == aux_2744);
										  }
										  if (test_2741)
										    {	/* Object/slots.scm 144 */
										       if (
											  PAIRP(cdr_384_139_604))
											 {	/* Object/slots.scm 144 */
											    bool_t test_2749;
											    {	/* ./Ieee/equiv.scm 5508 */
											       obj_t aux_2750;
											       aux_2750 =
												  CDR(cdr_384_139_604);
											       test_2749 =
												  (aux_2750 == BNIL);
											    }
											    if (test_2749)
											      {
												 obj_t attr_2755;
												 obj_t slot_id_111_2753;
												 slot_id_111_2753 =
												    CAR(cdr_384_139_604);
												 attr_2755 = cdr_197_63_513;
												 attr_506 = attr_2755;
												 slot_id_111_505 = slot_id_111_2753;
												 goto tag_187_23_507;
											      }
											    else
											      {		/* Object/slots.scm 144 */
												 goto tag_189_52_510;
											      }
											 }
										       else
											 {	/* Object/slots.scm 144 */
											    goto tag_189_52_510;
											 }
										    }
										  else
										    {	/* Object/slots.scm 144 */
										       goto tag_189_52_510;
										    }
									       }
									    }
									  else
									    {	/* Object/slots.scm 144 */
									       goto tag_189_52_510;
									    }
								       }
								  }
								else
								  {	/* Object/slots.scm 144 */
								     obj_t car_402_35_616;
								     car_402_35_616 =
									CAR(s_497);
								     if (
									PAIRP(car_402_35_616))
								       {	/* Object/slots.scm 144 */
									  obj_t cdr_406_48_618;
									  cdr_406_48_618 =
									     CDR(car_402_35_616);
									  {	/* Object/slots.scm 144 */
									     bool_t test_2760;
									     {	/* ./Ieee/equiv.scm 5508 */
										obj_t aux_2763;
										obj_t aux_2761;
										aux_2763 =
										   CNST_TABLE_REF(((long) 4));
										aux_2761 =
										   CAR(car_402_35_616);
										test_2760 =
										   (aux_2761 == aux_2763);
									     }
									     if (test_2760)
									       {	/* Object/slots.scm 144 */
										  if (
										     PAIRP(cdr_406_48_618))
										    {	/* Object/slots.scm 144 */
										       bool_t test_2768;
										       {	/* ./Ieee/equiv.scm 5508 */
											  obj_t aux_2769;
											  aux_2769 =
											     CDR(cdr_406_48_618);
											  test_2768 =
											     (aux_2769 == BNIL);
										       }
										       if (test_2768)
											 {
											    obj_t attr_2774;
											    obj_t slot_id_111_2772;
											    slot_id_111_2772 =
											       CAR(cdr_406_48_618);
											    attr_2774 = cdr_197_63_513;
											    attr_506 = attr_2774;
											    slot_id_111_505 = slot_id_111_2772;
											    goto tag_187_23_507;
											 }
										       else
											 {	/* Object/slots.scm 144 */
											    goto tag_189_52_510;
											 }
										    }
										  else
										    {	/* Object/slots.scm 144 */
										       goto tag_189_52_510;
										    }
									       }
									     else
									       {	/* Object/slots.scm 144 */
										  goto tag_189_52_510;
									       }
									  }
								       }
								     else
								       {	/* Object/slots.scm 144 */
									  goto tag_189_52_510;
								       }
								  }
							     }
							   else
							     {	/* Object/slots.scm 144 */
								obj_t car_424_76_628;
								car_424_76_628 =
								   CAR(s_497);
								if (
								   PAIRP(car_424_76_628))
								  {	/* Object/slots.scm 144 */
								     obj_t cdr_428_171_630;
								     cdr_428_171_630 =
									CDR(car_424_76_628);
								     {	/* Object/slots.scm 144 */
									bool_t test_2779;
									{	/* ./Ieee/equiv.scm 5508 */
									   obj_t aux_2782;
									   obj_t aux_2780;
									   aux_2782 =
									      CNST_TABLE_REF(((long) 4));
									   aux_2780 =
									      CAR(car_424_76_628);
									   test_2779 =
									      (aux_2780 == aux_2782);
									}
									if (test_2779)
									  {	/* Object/slots.scm 144 */
									     if (
										PAIRP(cdr_428_171_630))
									       {	/* Object/slots.scm 144 */
										  bool_t test_2787;
										  {	/* ./Ieee/equiv.scm 5508 */
										     obj_t aux_2788;
										     aux_2788 =
											CDR(cdr_428_171_630);
										     test_2787 =
											(aux_2788 == BNIL);
										  }
										  if (test_2787)
										    {
										       obj_t attr_2793;
										       obj_t slot_id_111_2791;
										       slot_id_111_2791 =
											  CAR(cdr_428_171_630);
										       attr_2793 = cdr_197_63_513;
										       attr_506 = attr_2793;
										       slot_id_111_505 = slot_id_111_2791;
										       goto tag_187_23_507;
										    }
										  else
										    {	/* Object/slots.scm 144 */
										       goto tag_189_52_510;
										    }
									       }
									     else
									       {	/* Object/slots.scm 144 */
										  goto tag_189_52_510;
									       }
									  }
									else
									  {	/* Object/slots.scm 144 */
									     goto tag_189_52_510;
									  }
								     }
								  }
								else
								  {	/* Object/slots.scm 144 */
								     goto tag_189_52_510;
								  }
							     }
							}
						     }
						   else
						     {	/* Object/slots.scm 144 */
							obj_t car_446_39_642;
							car_446_39_642 =
							   CAR(s_497);
							if (
							   PAIRP(car_446_39_642))
							  {	/* Object/slots.scm 144 */
							     obj_t cdr_450_30_644;
							     cdr_450_30_644 =
								CDR(car_446_39_642);
							     {	/* Object/slots.scm 144 */
								bool_t test_2798;
								{	/* ./Ieee/equiv.scm 5508 */
								   obj_t aux_2801;
								   obj_t aux_2799;
								   aux_2801 =
								      CNST_TABLE_REF(((long) 4));
								   aux_2799 =
								      CAR(car_446_39_642);
								   test_2798 =
								      (aux_2799 == aux_2801);
								}
								if (test_2798)
								  {	/* Object/slots.scm 144 */
								     if (
									PAIRP(cdr_450_30_644))
								       {	/* Object/slots.scm 144 */
									  bool_t test_2806;
									  {	/* ./Ieee/equiv.scm 5508 */
									     obj_t aux_2807;
									     aux_2807 =
										CDR(cdr_450_30_644);
									     test_2806 =
										(aux_2807 == BNIL);
									  }
									  if (test_2806)
									    {
									       obj_t attr_2812;
									       obj_t slot_id_111_2810;
									       slot_id_111_2810 =
										  CAR(cdr_450_30_644);
									       attr_2812 = cdr_197_63_513;
									       attr_506 = attr_2812;
									       slot_id_111_505 = slot_id_111_2810;
									       goto tag_187_23_507;
									    }
									  else
									    {	/* Object/slots.scm 144 */
									       goto tag_189_52_510;
									    }
								       }
								     else
								       {	/* Object/slots.scm 144 */
									  goto tag_189_52_510;
								       }
								  }
								else
								  {	/* Object/slots.scm 144 */
								     goto tag_189_52_510;
								  }
							     }
							  }
							else
							  {	/* Object/slots.scm 144 */
							     goto tag_189_52_510;
							  }
						     }
						}
					      else
						{	/* Object/slots.scm 144 */
						   obj_t car_468_129_654;
						   car_468_129_654 =
						      CAR(s_497);
						   if (
						      PAIRP(car_468_129_654))
						     {	/* Object/slots.scm 144 */
							obj_t cdr_472_34_656;
							cdr_472_34_656 =
							   CDR(car_468_129_654);
							{	/* Object/slots.scm 144 */
							   bool_t test_2817;
							   {	/* ./Ieee/equiv.scm 5508 */
							      obj_t aux_2820;
							      obj_t aux_2818;
							      aux_2820 =
								 CNST_TABLE_REF(((long) 4));
							      aux_2818 =
								 CAR(car_468_129_654);
							      test_2817 =
								 (aux_2818 == aux_2820);
							   }
							   if (test_2817)
							     {	/* Object/slots.scm 144 */
								if (
								   PAIRP(cdr_472_34_656))
								  {	/* Object/slots.scm 144 */
								     bool_t test_2825;
								     {	/* ./Ieee/equiv.scm 5508 */
									obj_t aux_2826;
									aux_2826 =
									   CDR(cdr_472_34_656);
									test_2825 =
									   (aux_2826 == BNIL);
								     }
								     if (test_2825)
								       {
									  obj_t attr_2831;
									  obj_t slot_id_111_2829;
									  slot_id_111_2829 =
									     CAR(cdr_472_34_656);
									  attr_2831 = cdr_197_63_513;
									  attr_506 = attr_2831;
									  slot_id_111_505 = slot_id_111_2829;
									  goto tag_187_23_507;
								       }
								     else
								       {	/* Object/slots.scm 144 */
									  goto tag_189_52_510;
								       }
								  }
								else
								  {	/* Object/slots.scm 144 */
								     goto tag_189_52_510;
								  }
							     }
							   else
							     {	/* Object/slots.scm 144 */
								goto tag_189_52_510;
							     }
							}
						     }
						   else
						     {	/* Object/slots.scm 144 */
							goto tag_189_52_510;
						     }
						}
					   }
					 else
					   {	/* Object/slots.scm 144 */
					      obj_t car_490_173_666;
					      car_490_173_666 =
						 CAR(s_497);
					      if (
						 PAIRP(car_490_173_666))
						{	/* Object/slots.scm 144 */
						   obj_t cdr_494_200_668;
						   cdr_494_200_668 =
						      CDR(car_490_173_666);
						   {	/* Object/slots.scm 144 */
						      bool_t test_2836;
						      {		/* ./Ieee/equiv.scm 5508 */
							 obj_t aux_2839;
							 obj_t aux_2837;
							 aux_2839 =
							    CNST_TABLE_REF(((long) 4));
							 aux_2837 =
							    CAR(car_490_173_666);
							 test_2836 =
							    (aux_2837 == aux_2839);
						      }
						      if (test_2836)
							{	/* Object/slots.scm 144 */
							   if (
							      PAIRP(cdr_494_200_668))
							     {	/* Object/slots.scm 144 */
								bool_t test_2844;
								{	/* ./Ieee/equiv.scm 5508 */
								   obj_t aux_2845;
								   aux_2845 =
								      CDR(cdr_494_200_668);
								   test_2844 =
								      (aux_2845 == BNIL);
								}
								if (test_2844)
								  {
								     obj_t attr_2850;
								     obj_t slot_id_111_2848;
								     slot_id_111_2848 =
									CAR(cdr_494_200_668);
								     attr_2850 = cdr_197_63_513;
								     attr_506 = attr_2850;
								     slot_id_111_505 = slot_id_111_2848;
								     goto tag_187_23_507;
								  }
								else
								  {	/* Object/slots.scm 144 */
								     goto tag_189_52_510;
								  }
							     }
							   else
							     {	/* Object/slots.scm 144 */
								goto tag_189_52_510;
							     }
							}
						      else
							{	/* Object/slots.scm 144 */
							   goto tag_189_52_510;
							}
						   }
						}
					      else
						{	/* Object/slots.scm 144 */
						   goto tag_189_52_510;
						}
					   }
				      }
				    else
				      {		/* Object/slots.scm 144 */
					 obj_t car_512_16_678;
					 car_512_16_678 =
					    CAR(s_497);
					 if (
					    PAIRP(car_512_16_678))
					   {	/* Object/slots.scm 144 */
					      obj_t cdr_516_101_680;
					      cdr_516_101_680 =
						 CDR(car_512_16_678);
					      {		/* Object/slots.scm 144 */
						 bool_t test_2855;
						 {	/* ./Ieee/equiv.scm 5508 */
						    obj_t aux_2858;
						    obj_t aux_2856;
						    aux_2858 =
						       CNST_TABLE_REF(((long) 4));
						    aux_2856 =
						       CAR(car_512_16_678);
						    test_2855 =
						       (aux_2856 == aux_2858);
						 }
						 if (test_2855)
						   {	/* Object/slots.scm 144 */
						      if (
							 PAIRP(cdr_516_101_680))
							{	/* Object/slots.scm 144 */
							   bool_t test_2863;
							   {	/* ./Ieee/equiv.scm 5508 */
							      obj_t aux_2864;
							      aux_2864 =
								 CDR(cdr_516_101_680);
							      test_2863 =
								 (aux_2864 == BNIL);
							   }
							   if (test_2863)
							     {
								obj_t attr_2869;
								obj_t slot_id_111_2867;
								slot_id_111_2867 =
								   CAR(cdr_516_101_680);
								attr_2869 = cdr_197_63_513;
								attr_506 = attr_2869;
								slot_id_111_505 = slot_id_111_2867;
								goto tag_187_23_507;
							     }
							   else
							     {	/* Object/slots.scm 144 */
								goto tag_189_52_510;
							     }
							}
						      else
							{	/* Object/slots.scm 144 */
							   goto tag_189_52_510;
							}
						   }
						 else
						   {	/* Object/slots.scm 144 */
						      goto tag_189_52_510;
						   }
					      }
					   }
					 else
					   {	/* Object/slots.scm 144 */
					      bool_t test_2870;
					      {		/* ./Ieee/equiv.scm 5508 */
						 obj_t aux_2871;
						 aux_2871 =
						    CNST_TABLE_REF(((long) 4));
						 test_2870 =
						    (car_512_16_678 == aux_2871);
					      }
					      if (test_2870)
						{	/* Object/slots.scm 144 */
						   if (
						      PAIRP(cdr_197_63_513))
						     {	/* Object/slots.scm 144 */
							bool_t test_2876;
							{	/* ./Ieee/equiv.scm 5508 */
							   obj_t aux_2877;
							   aux_2877 =
							      CDR(cdr_197_63_513);
							   test_2876 =
							      (aux_2877 == BNIL);
							}
							if (test_2876)
							  {	/* Object/slots.scm 144 */
							     slot_id_111_508 =
								CAR(cdr_197_63_513);
							     {	/* Object/slots.scm 278 */
								obj_t type_788;
								{	/* Object/slots.scm 278 */
								   bool_t test1501_796;
								   {	/* Object/slots.scm 278 */
								      obj_t obj2_1918;
								      obj2_1918 = ____74_type_cache;
								      {		/* ./Ieee/equiv.scm 5508 */
									 obj_t aux_2880;
									 aux_2880 =
									    CDR(slot_id_111_508);
									 test1501_796 =
									    (aux_2880 == obj2_1918);
								      }
								   }
								   if (test1501_796)
								     {	/* Object/slots.scm 278 */
									type_788 = _obj__252_type_cache;
								     }
								   else
								     {	/* Object/slots.scm 278 */
									type_788 =
									   CDR(slot_id_111_508);
								     }
								}
								ensure_type_defined__128_object_slots(
								   (type_bglt) (type_788), src_77);
								{	/* Object/slots.scm 282 */
								   obj_t arg1494_789;
								   obj_t arg1495_790;
								   arg1494_789 =
								      CDR(slots_488);
								   {	/* Object/slots.scm 283 */
								      obj_t arg1496_791;
								      {		/* Object/slots.scm 283 */
									 obj_t arg1497_792;
									 obj_t arg1498_793;
									 arg1497_792 =
									    CAR(slot_id_111_508);
									 arg1498_793 =
									    scheme_symbol__c_string_183_object_slots(
									    CAR(slot_id_111_508));
									 {	/* ./Object/class.sch 590 */
									    obj_t new_1940;
									    {	/* ./Object/class.sch 590 */
									       obj_t aux_2891;
									       aux_2891 =
										  CNST_TABLE_REF(((long) 0));
									       new_1940 =
										  create_struct(aux_2891, ((long) 17));
									    }
									    {	/* ./Llib/struct.scm 1463 */
									       obj_t aux_2894;
									       aux_2894 =
										  (obj_t) (class_73);
									       STRUCT_SET(new_1940, ((long) 16), aux_2894);
									    }
									    STRUCT_SET(new_1940, ((long) 15), s_497);
									    STRUCT_SET(new_1940, ((long) 14), BFALSE);
									    STRUCT_SET(new_1940, ((long) 13), BFALSE);
									    {	/* ./Llib/struct.scm 1463 */
									       obj_t aux_2900;
									       aux_2900 =
										  BINT(((long) 0));
									       STRUCT_SET(new_1940, ((long) 12), aux_2900);
									    }
									    STRUCT_SET(new_1940, ((long) 11), BFALSE);
									    STRUCT_SET(new_1940, ((long) 10), BFALSE);
									    STRUCT_SET(new_1940, ((long) 9), BUNSPEC);
									    STRUCT_SET(new_1940, ((long) 8), BFALSE);
									    STRUCT_SET(new_1940, ((long) 7), BFALSE);
									    STRUCT_SET(new_1940, ((long) 6), BFALSE);
									    STRUCT_SET(new_1940, ((long) 5), BFALSE);
									    STRUCT_SET(new_1940, ((long) 4), BUNSPEC);
									    STRUCT_SET(new_1940, ((long) 3), BFALSE);
									    STRUCT_SET(new_1940, ((long) 2), type_788);
									    STRUCT_SET(new_1940, ((long) 1), arg1498_793);
									    STRUCT_SET(new_1940, ((long) 0), arg1497_792);
									    arg1496_791 = new_1940;
									 }
								      }
								      arg1495_790 =
									 MAKE_PAIR(arg1496_791, res_489);
								   }
								   {
								      obj_t res_2917;
								      obj_t slots_2916;
								      slots_2916 = arg1494_789;
								      res_2917 = arg1495_790;
								      res_489 = res_2917;
								      slots_488 = slots_2916;
								      goto loop_491;
								   }
								}
							     }
							  }
							else
							  {	/* Object/slots.scm 144 */
							     goto tag_189_52_510;
							  }
						     }
						   else
						     {	/* Object/slots.scm 144 */
							goto tag_189_52_510;
						     }
						}
					      else
						{	/* Object/slots.scm 144 */
						   goto tag_189_52_510;
						}
					   }
				      }
				 }
			    }
			 }
		       else
			 {	/* Object/slots.scm 144 */
			    goto tag_189_52_510;
			 }
		    }
		 }
	    }
	 }
      }
   }
}



/* find-default-attr */
obj_t 
find_default_attr_77_object_slots(obj_t attr_922)
{
   AN_OBJECT;
   {	/* Object/slots.scm 40 */
    find_default_attr_77_object_slots:
      if (
	 PAIRP(attr_922))
	{

	   {	/* Object/slots.scm 43 */
	      obj_t e_122_11_928;
	      e_122_11_928 =
		 CAR(attr_922);
	      if (
		 PAIRP(e_122_11_928))
		{	/* Object/slots.scm 43 */
		   obj_t cdr_126_195_930;
		   cdr_126_195_930 =
		      CDR(e_122_11_928);
		   {	/* Object/slots.scm 43 */
		      bool_t test_2926;
		      {		/* ./Ieee/equiv.scm 5508 */
			 obj_t aux_2929;
			 obj_t aux_2927;
			 aux_2929 =
			    CNST_TABLE_REF(((long) 6));
			 aux_2927 =
			    CAR(e_122_11_928);
			 test_2926 =
			    (aux_2927 == aux_2929);
		      }
		      if (test_2926)
			{	/* Object/slots.scm 43 */
			   if (
			      PAIRP(cdr_126_195_930))
			     {	/* Object/slots.scm 43 */
				bool_t test_2934;
				{	/* ./Ieee/equiv.scm 5508 */
				   obj_t aux_2935;
				   aux_2935 =
				      CDR(cdr_126_195_930);
				   test_2934 =
				      (aux_2935 == BNIL);
				}
				if (test_2934)
				  {	/* ./Ieee/pair-list.scm 5689 */
				     obj_t aux_2938;
				     aux_2938 =
					CAR(cdr_126_195_930);
				     return
					MAKE_PAIR(BTRUE, aux_2938);
				  }
				else
				  {	/* Object/slots.scm 43 */
				   tag_121_151_927:
				     {
					obj_t attr_2941;
					attr_2941 =
					   CDR(attr_922);
					attr_922 = attr_2941;
					goto find_default_attr_77_object_slots;
				     }
				  }
			     }
			   else
			     {	/* Object/slots.scm 43 */
				goto tag_121_151_927;
			     }
			}
		      else
			{	/* Object/slots.scm 43 */
			   goto tag_121_151_927;
			}
		   }
		}
	      else
		{	/* Object/slots.scm 43 */
		   goto tag_121_151_927;
		}
	   }
	}
      else
	{	/* Object/slots.scm 41 */
	   return
	      CNST_TABLE_REF(((long) 7));
	}
   }
}



/* find-assert-attr */
obj_t 
find_assert_attr_93_object_slots(obj_t attr_893)
{
   AN_OBJECT;
   {	/* Object/slots.scm 48 */
    find_assert_attr_93_object_slots:
      if (
	 PAIRP(attr_893))
	{
	   obj_t value_896;
	   {	/* Object/slots.scm 51 */
	      obj_t e_133_49_899;
	      e_133_49_899 =
		 CAR(attr_893);
	      if (
		 PAIRP(e_133_49_899))
		{	/* Object/slots.scm 51 */
		   obj_t cdr_137_164_901;
		   cdr_137_164_901 =
		      CDR(e_133_49_899);
		   {	/* Object/slots.scm 51 */
		      bool_t test_2950;
		      {		/* ./Ieee/equiv.scm 5508 */
			 obj_t aux_2953;
			 obj_t aux_2951;
			 aux_2953 =
			    CNST_TABLE_REF(((long) 9));
			 aux_2951 =
			    CAR(e_133_49_899);
			 test_2950 =
			    (aux_2951 == aux_2953);
		      }
		      if (test_2950)
			{	/* Object/slots.scm 51 */
			   if (
			      PAIRP(cdr_137_164_901))
			     {	/* Object/slots.scm 51 */
				obj_t car_139_240_904;
				obj_t cdr_140_144_905;
				car_139_240_904 =
				   CAR(cdr_137_164_901);
				cdr_140_144_905 =
				   CDR(cdr_137_164_901);
				if (
				   PAIRP(car_139_240_904))
				  {	/* Object/slots.scm 51 */
				     bool_t test_2962;
				     {	/* ./Ieee/symbol.scm 6015 */
					obj_t aux_2963;
					aux_2963 =
					   CAR(car_139_240_904);
					test_2962 =
					   SYMBOLP(aux_2963);
				     }
				     if (test_2962)
				       {	/* Object/slots.scm 51 */
					  bool_t test_2966;
					  {	/* ./Ieee/equiv.scm 5508 */
					     obj_t aux_2967;
					     aux_2967 =
						CDR(car_139_240_904);
					     test_2966 =
						(aux_2967 == BNIL);
					  }
					  if (test_2966)
					    {	/* Object/slots.scm 51 */
					       if (
						  PAIRP(cdr_140_144_905))
						 {	/* Object/slots.scm 51 */
						    bool_t test_2972;
						    {	/* ./Ieee/equiv.scm 5508 */
						       obj_t aux_2973;
						       aux_2973 =
							  CDR(cdr_140_144_905);
						       test_2972 =
							  (aux_2973 == BNIL);
						    }
						    if (test_2972)
						      {		/* Object/slots.scm 51 */
							 value_896 =
							    CAR(cdr_140_144_905);
							 {	/* ./Ieee/pair-list.scm 5890 */
							    obj_t aux_2978;
							    obj_t aux_2976;
							    aux_2978 =
							       CNST_TABLE_REF(((long) 8));
							    aux_2976 =
							       CAR(attr_893);
							    SET_CAR(aux_2976, aux_2978);
							 }
							 return
							    CAR(attr_893);
						      }
						    else
						      {		/* Object/slots.scm 51 */
						       tag_132_226_898:
							 {
							    obj_t attr_2983;
							    attr_2983 =
							       CDR(attr_893);
							    attr_893 = attr_2983;
							    goto find_assert_attr_93_object_slots;
							 }
						      }
						 }
					       else
						 {	/* Object/slots.scm 51 */
						    goto tag_132_226_898;
						 }
					    }
					  else
					    {	/* Object/slots.scm 51 */
					       goto tag_132_226_898;
					    }
				       }
				     else
				       {	/* Object/slots.scm 51 */
					  goto tag_132_226_898;
				       }
				  }
				else
				  {	/* Object/slots.scm 51 */
				     goto tag_132_226_898;
				  }
			     }
			   else
			     {	/* Object/slots.scm 51 */
				goto tag_132_226_898;
			     }
			}
		      else
			{	/* Object/slots.scm 51 */
			   goto tag_132_226_898;
			}
		   }
		}
	      else
		{	/* Object/slots.scm 51 */
		   goto tag_132_226_898;
		}
	   }
	}
      else
	{	/* Object/slots.scm 49 */
	   return BFALSE;
	}
   }
}



/* find-virtual-attr */
obj_t 
find_virtual_attr_39_object_slots(obj_t attr_858)
{
   AN_OBJECT;
   {	/* Object/slots.scm 57 */
      {
	 obj_t attr_860;
	 obj_t get_861;
	 obj_t set_862;
	 attr_860 = attr_858;
	 get_861 = BFALSE;
	 set_862 = BFALSE;
       loop_863:
	 if (
	    PAIRP(attr_860))
	   {

	      {		/* Object/slots.scm 63 */
		 obj_t e_150_23_870;
		 e_150_23_870 =
		    CAR(attr_860);
		 if (
		    PAIRP(e_150_23_870))
		   {	/* Object/slots.scm 63 */
		      obj_t cdr_155_78_872;
		      cdr_155_78_872 =
			 CDR(e_150_23_870);
		      {		/* Object/slots.scm 63 */
			 bool_t test_2991;
			 {	/* ./Ieee/equiv.scm 5508 */
			    obj_t aux_2994;
			    obj_t aux_2992;
			    aux_2994 =
			       CNST_TABLE_REF(((long) 10));
			    aux_2992 =
			       CAR(e_150_23_870);
			    test_2991 =
			       (aux_2992 == aux_2994);
			 }
			 if (test_2991)
			   {	/* Object/slots.scm 63 */
			      if (
				 PAIRP(cdr_155_78_872))
				{	/* Object/slots.scm 63 */
				   bool_t test_2999;
				   {	/* ./Ieee/equiv.scm 5508 */
				      obj_t aux_3000;
				      aux_3000 =
					 CDR(cdr_155_78_872);
				      test_2999 =
					 (aux_3000 == BNIL);
				   }
				   if (test_2999)
				     {
					obj_t get_3005;
					obj_t attr_3003;
					attr_3003 =
					   CDR(attr_860);
					get_3005 =
					   CAR(cdr_155_78_872);
					get_861 = get_3005;
					attr_860 = attr_3003;
					goto loop_863;
				     }
				   else
				     {	/* Object/slots.scm 63 */
				      tag_149_161_869:
					{
					   obj_t attr_3007;
					   attr_3007 =
					      CDR(attr_860);
					   attr_860 = attr_3007;
					   goto loop_863;
					}
				     }
				}
			      else
				{	/* Object/slots.scm 63 */
				   goto tag_149_161_869;
				}
			   }
			 else
			   {	/* Object/slots.scm 63 */
			      bool_t test_3009;
			      {		/* ./Ieee/equiv.scm 5508 */
				 obj_t aux_3012;
				 obj_t aux_3010;
				 aux_3012 =
				    CNST_TABLE_REF(((long) 11));
				 aux_3010 =
				    CAR(e_150_23_870);
				 test_3009 =
				    (aux_3010 == aux_3012);
			      }
			      if (test_3009)
				{	/* Object/slots.scm 63 */
				   if (
				      PAIRP(cdr_155_78_872))
				     {	/* Object/slots.scm 63 */
					bool_t test_3017;
					{	/* ./Ieee/equiv.scm 5508 */
					   obj_t aux_3018;
					   aux_3018 =
					      CDR(cdr_155_78_872);
					   test_3017 =
					      (aux_3018 == BNIL);
					}
					if (test_3017)
					  {
					     obj_t set_3023;
					     obj_t attr_3021;
					     attr_3021 =
						CDR(attr_860);
					     set_3023 =
						CAR(cdr_155_78_872);
					     set_862 = set_3023;
					     attr_860 = attr_3021;
					     goto loop_863;
					  }
					else
					  {	/* Object/slots.scm 63 */
					     goto tag_149_161_869;
					  }
				     }
				   else
				     {	/* Object/slots.scm 63 */
					goto tag_149_161_869;
				     }
				}
			      else
				{	/* Object/slots.scm 63 */
				   goto tag_149_161_869;
				}
			   }
		      }
		   }
		 else
		   {	/* Object/slots.scm 63 */
		      goto tag_149_161_869;
		   }
	      }
	   }
	 else
	   {	/* Object/slots.scm 61 */
	      return
		 MAKE_PAIR(get_861, set_862);
	   }
      }
   }
}



/* _make-class-slots1643 */
obj_t 
_make_class_slots1643_214_object_slots(obj_t env_2209, obj_t class_2210, obj_t slots_2211, obj_t super_2212, obj_t vnum_2213, obj_t src_2214)
{
   AN_OBJECT;
   {	/* Object/slots.scm 38 */
      return
	 make_class_slots_205_object_slots(
	 (tclass_bglt) (class_2210), slots_2211, super_2212,
	 CINT(vnum_2213), src_2214);
   }
}



/* scheme-symbol->c-string */
obj_t 
scheme_symbol__c_string_183_object_slots(obj_t symbol_78)
{
   AN_OBJECT;
   {	/* Object/slots.scm 311 */
      if (
	 CBOOL(_case_sensitive__90_engine_param))
	{	/* Object/slots.scm 312 */
	   return
	      id__name_228_ast_ident(symbol_78);
	}
      else
	{	/* Object/slots.scm 314 */
	   obj_t arg1605_946;
	   arg1605_946 =
	      id__name_228_ast_ident(symbol_78);
	   return
	      string_downcase_77___r4_strings_6_7(arg1605_946);
	}
   }
}



/* get-local-virtual-slots-number */
obj_t 
get_local_virtual_slots_number_139_object_slots(tclass_bglt class_79, obj_t slots_80)
{
   AN_OBJECT;
   {	/* Object/slots.scm 328 */
      {
	 obj_t slots_947;
	 obj_t num_948;
	 {	/* Object/slots.scm 329 */
	    long aux_3034;
	    slots_947 = slots_80;
	    num_948 =
	       BINT(((long) -1));
	  loop_949:
	    if (
	       NULLP(slots_947))
	      {		/* Object/slots.scm 332 */
		 {	/* ./Ieee/fixnum.scm 7193 */
		    long aux_3037;
		    aux_3037 =
		       (long) CINT(num_948);
		    aux_3034 =
		       (aux_3037 + ((long) 1));
		 }
	      }
	    else
	      {		/* Object/slots.scm 334 */
		 bool_t test_3040;
		 {	/* ./Llib/struct.scm 1457 */
		    obj_t aux_3041;
		    {	/* ./Llib/struct.scm 1457 */
		       obj_t aux_3042;
		       aux_3042 =
			  CAR(slots_947);
		       aux_3041 =
			  STRUCT_REF(aux_3042, ((long) 11));
		    }
		    test_3040 =
		       CBOOL(aux_3041);
		 }
		 if (test_3040)
		   {	/* Object/slots.scm 334 */
		      {		/* Object/slots.scm 335 */
			 obj_t lnum_952;
			 {	/* ./Llib/struct.scm 1457 */
			    obj_t aux_3046;
			    aux_3046 =
			       CAR(slots_947);
			    lnum_952 =
			       STRUCT_REF(aux_3046, ((long) 12));
			 }
			 {
			    obj_t num_3051;
			    obj_t slots_3049;
			    slots_3049 =
			       CDR(slots_947);
			    {	/* Object/slots.scm 337 */
			       bool_t test_3052;
			       {	/* ./Ieee/fixnum.scm 7121 */
				  long aux_3055;
				  long aux_3053;
				  aux_3055 =
				     (long) CINT(num_948);
				  aux_3053 =
				     (long) CINT(lnum_952);
				  test_3052 =
				     (aux_3053 > aux_3055);
			       }
			       if (test_3052)
				 {	/* Object/slots.scm 337 */
				    num_3051 = lnum_952;
				 }
			       else
				 {	/* Object/slots.scm 337 */
				    num_3051 = num_948;
				 }
			    }
			    num_948 = num_3051;
			    slots_947 = slots_3049;
			    goto loop_949;
			 }
		      }
		   }
		 else
		   {	/* Object/slots.scm 334 */
		      {
			 obj_t slots_3058;
			 slots_3058 =
			    CDR(slots_947);
			 slots_947 = slots_3058;
			 goto loop_949;
		      }
		   }
	      }
	    return
	       BINT(aux_3034);
	 }
      }
   }
}



/* _get-local-virtual-slots-number1644 */
obj_t 
_get_local_virtual_slots_number1644_185_object_slots(obj_t env_2215, obj_t class_2216, obj_t slots_2217)
{
   AN_OBJECT;
   {	/* Object/slots.scm 328 */
      return
	 get_local_virtual_slots_number_139_object_slots(
	 (tclass_bglt) (class_2216), slots_2217);
   }
}



/* method-init */
obj_t 
method_init_76_object_slots()
{
   AN_OBJECT;
   {	/* Object/slots.scm 14 */
      return BUNSPEC;
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_object_slots()
{
   AN_OBJECT;
   {	/* Object/slots.scm 14 */
      module_initialization_70_tools_trace(((long) 0), "OBJECT_SLOTS");
      module_initialization_70_tools_error(((long) 0), "OBJECT_SLOTS");
      module_initialization_70_type_type(((long) 0), "OBJECT_SLOTS");
      module_initialization_70_type_cache(((long) 0), "OBJECT_SLOTS");
      module_initialization_70_ast_var(((long) 0), "OBJECT_SLOTS");
      module_initialization_70_ast_ident(((long) 0), "OBJECT_SLOTS");
      module_initialization_70_object_class(((long) 0), "OBJECT_SLOTS");
      module_initialization_70_engine_param(((long) 0), "OBJECT_SLOTS");
      return
	 module_initialization_70_tools_location(((long) 0), "OBJECT_SLOTS");
   }
}
