/*===========================================================================*/
/*   (Object/struct.scm)                                                     */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct tclass
  {
     obj_t its_super_214;
     obj_t slots;
     struct global *holder;
     obj_t widening;
     long depth;
     bool_t final__12;
     obj_t constructor;
     obj_t virtual_slots_number_200;
  }
      *tclass_bglt;


extern obj_t make_struct__wide_object_7_object_struct(obj_t, type_bglt, obj_t, obj_t, obj_t);
static obj_t method_init_76_object_struct();
extern obj_t symbol_append_197___r4_symbols_6_4(obj_t);
extern obj_t string_append(obj_t, obj_t);
extern obj_t make_wide_object__struct_148_object_struct(obj_t, type_bglt, obj_t, obj_t, obj_t);
static obj_t _make_wide_object__struct1983_229_object_struct(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t make_struct__object_35_object_struct(obj_t, type_bglt, obj_t, obj_t, obj_t);
extern obj_t gensym___r4_symbols_6_4;
extern obj_t module_initialization_70_object_struct(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_tools_misc(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_env(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_type_tools(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_env(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_object_class(long, char *);
extern obj_t module_initialization_70_object_tools(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_symbols_6_4(long, char *);
static obj_t _make_object__struct1982_224_object_struct(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t save_slot_187_object_struct(obj_t, obj_t, obj_t, long, obj_t);
static obj_t imported_modules_init_94_object_struct();
extern obj_t make_object__struct_189_object_struct(obj_t, type_bglt, obj_t, obj_t, obj_t);
extern obj_t append_2_18___r4_pairs_and_lists_6_3(obj_t, obj_t);
static obj_t library_modules_init_112_object_struct();
static obj_t _make_struct__wide_object1985_101_object_struct(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t toplevel_init_63_object_struct();
extern obj_t malloc_object_tools(type_bglt, obj_t);
extern obj_t open_input_string(obj_t);
extern obj_t epairify_tools_misc(obj_t, obj_t);
extern obj_t make_pragma_indexed_init_set__66_object_tools(type_bglt, obj_t, obj_t, obj_t);
static obj_t restore_slot_6_object_struct(obj_t, obj_t, obj_t, type_bglt, long, obj_t);
extern obj_t _4dots_199_tools_misc;
static long slots_length_21_object_struct(obj_t);
extern obj_t make_pragma_direct_set__7_object_tools(type_bglt, obj_t, obj_t, obj_t);
extern obj_t read___reader(obj_t);
static obj_t _make_struct__object1984_115_object_struct(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t require_initialization_114_object_struct = BUNSPEC;
static obj_t cnst_init_137_object_struct();
extern obj_t reverse__39___r4_pairs_and_lists_6_3(obj_t);
extern obj_t make_pragma_indexed_set__175_object_tools(type_bglt, obj_t, obj_t, obj_t, obj_t);
static obj_t __cnst[46];

DEFINE_EXPORT_PROCEDURE(make_object__struct_env_214_object_struct, _make_object__struct1982_224_object_struct1993, _make_object__struct1982_224_object_struct, 0L, 5);
DEFINE_EXPORT_PROCEDURE(make_wide_object__struct_env_82_object_struct, _make_wide_object__struct1983_229_object_struct1994, _make_wide_object__struct1983_229_object_struct, 0L, 5);
DEFINE_EXPORT_PROCEDURE(make_struct__wide_object_env_183_object_struct, _make_struct__wide_object1985_101_object_struct1995, _make_struct__wide_object1985_101_object_struct, 0L, 5);
DEFINE_STRING(string1988_object_struct, string1988_object_struct1996, "@ CLASS-NUM OBJECT-CLASS-NUM-SET! PRAGMA NEW OLD OBJECT-WIDENING-SET! S::STRUCT STRUCT+OBJECT->OBJECT::OBJECT VECTOR-REF-UR DONE O VECTOR-LENGTH S STRUCT-REF ::LONG V I STRUCT-KEY STRUCT-KEY-SET! CALL-NEXT-METHOD AUX ::STRUCT QUOTE MAKE-STRUCT OBJECT->STRUCT::STRUCT DEFINE-METHOD RES OBJ -LEN +FX -REF VECTOR-SET-UR! BEGIN =FX IF LABELS MAKE-VECTOR PRAGMA::LONG LET LEN LOOP J VEC - STRUCT-SET! ", 396);
DEFINE_STRING(string1987_object_struct, string1987_object_struct1997, "((", 2);
DEFINE_STRING(string1986_object_struct, string1986_object_struct1998, ")($1))", 6);
DEFINE_EXPORT_PROCEDURE(make_struct__object_env_44_object_struct, _make_struct__object1984_115_object_struct1999, _make_struct__object1984_115_object_struct, 0L, 5);



/* module-initialization */
obj_t 
module_initialization_70_object_struct(long checksum_2260, char *from_2261)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_object_struct))
	{
	   require_initialization_114_object_struct =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_object_struct();
	   cnst_init_137_object_struct();
	   imported_modules_init_94_object_struct();
	   method_init_76_object_struct();
	   toplevel_init_63_object_struct();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_object_struct()
{
   AN_OBJECT;
   {	/* Object/struct.scm 14 */
      module_initialization_70___r4_symbols_6_4(((long) 0), "OBJECT_STRUCT");
      module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "OBJECT_STRUCT");
      module_initialization_70___reader(((long) 0), "OBJECT_STRUCT");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_object_struct()
{
   AN_OBJECT;
   {	/* Object/struct.scm 14 */
      {		/* Object/struct.scm 14 */
	 obj_t cnst_port_138_2253;
	 cnst_port_138_2253 =
	    open_input_string(string1988_object_struct);
	 {
	    long i_2254;
	    i_2254 = ((long) 45);
	  loop_2255:
	    {	/* Object/struct.scm 14 */
	       bool_t test1989_2256;
	       test1989_2256 =
		  (i_2254 == ((long) -1));
	       if (test1989_2256)
		 {	/* Object/struct.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Object/struct.scm 14 */
		    {	/* Object/struct.scm 14 */
		       obj_t arg1990_2257;
		       {	/* Object/struct.scm 14 */
			  obj_t list1991_2258;
			  list1991_2258 =
			     MAKE_PAIR(cnst_port_138_2253, BNIL);
			  arg1990_2257 =
			     read___reader(list1991_2258);
		       }
		       CNST_TABLE_SET(i_2254, arg1990_2257);
		    }
		    {	/* Object/struct.scm 14 */
		       int aux_2259;
		       {	/* Object/struct.scm 14 */
			  long aux_2279;
			  aux_2279 =
			     (i_2254 - ((long) 1));
			  aux_2259 =
			     (int) (aux_2279);
		       }
		       {
			  long i_2282;
			  i_2282 =
			     (long) (aux_2259);
			  i_2254 = i_2282;
			  goto loop_2255;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_object_struct()
{
   AN_OBJECT;
   {	/* Object/struct.scm 14 */
      return BUNSPEC;
   }
}



/* save-slot */
obj_t 
save_slot_187_object_struct(obj_t oname_71, obj_t sname_72, obj_t cname_73, long i_74, obj_t slot_75)
{
   AN_OBJECT;
   {	/* Object/struct.scm 36 */
      {

	 {	/* Object/struct.scm 85 */
	    bool_t test_2284;
	    {	/* ./Llib/struct.scm 1457 */
	       obj_t aux_2285;
	       aux_2285 =
		  STRUCT_REF(slot_75, ((long) 5));
	       test_2284 =
		  CBOOL(aux_2285);
	    }
	    if (test_2284)
	      {		/* Object/struct.scm 85 */
		 {	/* Object/struct.scm 38 */
		    obj_t vec_611;
		    obj_t j_612;
		    obj_t loop_613;
		    obj_t len_614;
		    vec_611 =
		       PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4,
		       CNST_TABLE_REF(((long) 2)), BEOA);
		    j_612 =
		       PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4,
		       CNST_TABLE_REF(((long) 3)), BEOA);
		    loop_613 =
		       PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4,
		       CNST_TABLE_REF(((long) 4)), BEOA);
		    len_614 =
		       PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4,
		       CNST_TABLE_REF(((long) 5)), BEOA);
		    {	/* Object/struct.scm 42 */
		       obj_t arg1350_615;
		       obj_t arg1354_616;
		       arg1350_615 =
			  CNST_TABLE_REF(((long) 6));
		       {	/* Object/struct.scm 42 */
			  obj_t arg1355_617;
			  obj_t arg1356_618;
			  {	/* Object/struct.scm 42 */
			     obj_t arg1357_619;
			     {	/* Object/struct.scm 42 */
				obj_t arg1359_621;
				{	/* Object/struct.scm 42 */
				   obj_t arg1361_622;
				   {	/* Object/struct.scm 42 */
				      obj_t arg1365_624;
				      obj_t arg1366_625;
				      {		/* Object/struct.scm 42 */
					 obj_t arg1367_626;
					 obj_t arg1369_627;
					 arg1367_626 =
					    CNST_TABLE_REF(((long) 1));
					 arg1369_627 =
					    STRUCT_REF(slot_75, ((long) 0));
					 {	/* Object/struct.scm 42 */
					    obj_t list1372_629;
					    {	/* Object/struct.scm 42 */
					       obj_t arg1373_630;
					       {	/* Object/struct.scm 42 */
						  obj_t arg1374_631;
						  {	/* Object/struct.scm 42 */
						     obj_t arg1375_632;
						     {	/* Object/struct.scm 42 */
							obj_t aux_2303;
							aux_2303 =
							   CNST_TABLE_REF(((long) 16));
							arg1375_632 =
							   MAKE_PAIR(aux_2303, BNIL);
						     }
						     arg1374_631 =
							MAKE_PAIR(arg1369_627, arg1375_632);
						  }
						  arg1373_630 =
						     MAKE_PAIR(arg1367_626, arg1374_631);
					       }
					       list1372_629 =
						  MAKE_PAIR(cname_73, arg1373_630);
					    }
					    arg1365_624 =
					       symbol_append_197___r4_symbols_6_4(list1372_629);
					 }
				      }
				      arg1366_625 =
					 MAKE_PAIR(oname_71, BNIL);
				      arg1361_622 =
					 MAKE_PAIR(arg1365_624, arg1366_625);
				   }
				   arg1359_621 =
				      MAKE_PAIR(arg1361_622, BNIL);
				}
				arg1357_619 =
				   MAKE_PAIR(len_614, arg1359_621);
			     }
			     arg1355_617 =
				MAKE_PAIR(arg1357_619, BNIL);
			  }
			  {	/* Object/struct.scm 43 */
			     obj_t arg1376_633;
			     {	/* Object/struct.scm 43 */
				obj_t arg1378_635;
				obj_t arg1379_636;
				arg1378_635 =
				   CNST_TABLE_REF(((long) 6));
				{	/* Object/struct.scm 43 */
				   obj_t arg1380_637;
				   obj_t arg1381_638;
				   {	/* Object/struct.scm 43 */
				      obj_t arg1383_639;
				      {		/* Object/struct.scm 43 */
					 obj_t arg1385_641;
					 {	/* Object/struct.scm 43 */
					    obj_t arg1387_642;
					    {	/* Object/struct.scm 43 */
					       obj_t arg1390_644;
					       obj_t arg1391_645;
					       arg1390_644 =
						  CNST_TABLE_REF(((long) 8));
					       arg1391_645 =
						  MAKE_PAIR(len_614, BNIL);
					       arg1387_642 =
						  MAKE_PAIR(arg1390_644, arg1391_645);
					    }
					    arg1385_641 =
					       MAKE_PAIR(arg1387_642, BNIL);
					 }
					 arg1383_639 =
					    MAKE_PAIR(vec_611, arg1385_641);
				      }
				      arg1380_637 =
					 MAKE_PAIR(arg1383_639, BNIL);
				   }
				   {	/* Object/struct.scm 44 */
				      obj_t arg1393_646;
				      {		/* Object/struct.scm 44 */
					 obj_t arg1395_648;
					 obj_t arg1397_649;
					 arg1395_648 =
					    CNST_TABLE_REF(((long) 9));
					 {	/* Object/struct.scm 44 */
					    obj_t arg1398_650;
					    obj_t arg1399_651;
					    {	/* Object/struct.scm 44 */
					       obj_t arg1400_652;
					       {	/* Object/struct.scm 44 */
						  obj_t arg1402_654;
						  {	/* Object/struct.scm 44 */
						     obj_t arg1403_655;
						     obj_t arg1404_656;
						     arg1403_655 =
							MAKE_PAIR(j_612, BNIL);
						     {	/* Object/struct.scm 44 */
							obj_t arg1405_657;
							{	/* Object/struct.scm 44 */
							   obj_t arg1409_659;
							   obj_t arg1410_660;
							   arg1409_659 =
							      CNST_TABLE_REF(((long) 10));
							   {	/* Object/struct.scm 44 */
							      obj_t arg1411_661;
							      obj_t arg1412_662;
							      {		/* Object/struct.scm 44 */
								 obj_t arg1415_663;
								 obj_t arg1416_664;
								 arg1415_663 =
								    CNST_TABLE_REF(((long) 11));
								 {	/* Object/struct.scm 44 */
								    obj_t arg1417_665;
								    arg1417_665 =
								       MAKE_PAIR(len_614, BNIL);
								    arg1416_664 =
								       MAKE_PAIR(j_612, arg1417_665);
								 }
								 arg1411_661 =
								    MAKE_PAIR(arg1415_663, arg1416_664);
							      }
							      {		/* Object/struct.scm 45 */
								 obj_t arg1419_666;
								 obj_t arg1420_667;
								 {	/* Object/struct.scm 45 */
								    obj_t arg1422_668;
								    obj_t arg1424_669;
								    arg1422_668 =
								       CNST_TABLE_REF(((long) 0));
								    {	/* Object/struct.scm 45 */
								       obj_t arg1425_670;
								       {	/* Object/struct.scm 45 */
									  obj_t arg1426_671;
									  arg1426_671 =
									     MAKE_PAIR(vec_611, BNIL);
									  {	/* ./Ieee/pair-list.scm 5689 */
									     obj_t aux_2331;
									     aux_2331 =
										BINT(i_74);
									     arg1425_670 =
										MAKE_PAIR(aux_2331, arg1426_671);
									  }
								       }
								       arg1424_669 =
									  MAKE_PAIR(sname_72, arg1425_670);
								    }
								    arg1419_666 =
								       MAKE_PAIR(arg1422_668, arg1424_669);
								 }
								 {	/* Object/struct.scm 46 */
								    obj_t arg1427_672;
								    {	/* Object/struct.scm 46 */
								       obj_t arg1430_674;
								       obj_t arg1431_675;
								       arg1430_674 =
									  CNST_TABLE_REF(((long) 12));
								       {	/* Object/struct.scm 47 */
									  obj_t arg1432_676;
									  obj_t arg1433_677;
									  {	/* Object/struct.scm 47 */
									     obj_t arg1434_678;
									     obj_t arg1435_679;
									     arg1434_678 =
										CNST_TABLE_REF(((long) 13));
									     {	/* Object/struct.scm 51 */
										obj_t arg1436_680;
										{	/* Object/struct.scm 51 */
										   obj_t arg1437_681;
										   {	/* Object/struct.scm 51 */
										      obj_t arg1438_682;
										      {		/* Object/struct.scm 51 */
											 obj_t arg1440_684;
											 obj_t arg1441_685;
											 {	/* Object/struct.scm 51 */
											    obj_t arg1442_686;
											    obj_t arg1443_687;
											    arg1442_686 =
											       CNST_TABLE_REF(((long) 1));
											    arg1443_687 =
											       STRUCT_REF(slot_75, ((long) 0));
											    {	/* Object/struct.scm 50 */
											       obj_t list1445_689;
											       {	/* Object/struct.scm 50 */
												  obj_t arg1446_690;
												  {	/* Object/struct.scm 50 */
												     obj_t arg1447_691;
												     {	/* Object/struct.scm 50 */
													obj_t arg1449_692;
													{	/* Object/struct.scm 50 */
													   obj_t aux_2340;
													   aux_2340 =
													      CNST_TABLE_REF(((long) 14));
													   arg1449_692 =
													      MAKE_PAIR(aux_2340, BNIL);
													}
													arg1447_691 =
													   MAKE_PAIR(arg1443_687, arg1449_692);
												     }
												     arg1446_690 =
													MAKE_PAIR(arg1442_686, arg1447_691);
												  }
												  list1445_689 =
												     MAKE_PAIR(cname_73, arg1446_690);
											       }
											       arg1440_684 =
												  symbol_append_197___r4_symbols_6_4(list1445_689);
											    }
											 }
											 {	/* Object/struct.scm 50 */
											    obj_t arg1450_693;
											    arg1450_693 =
											       MAKE_PAIR(j_612, BNIL);
											    arg1441_685 =
											       MAKE_PAIR(oname_71, arg1450_693);
											 }
											 arg1438_682 =
											    MAKE_PAIR(arg1440_684, arg1441_685);
										      }
										      arg1437_681 =
											 MAKE_PAIR(arg1438_682, BNIL);
										   }
										   arg1436_680 =
										      MAKE_PAIR(j_612, arg1437_681);
										}
										arg1435_679 =
										   MAKE_PAIR(vec_611, arg1436_680);
									     }
									     arg1432_676 =
										MAKE_PAIR(arg1434_678, arg1435_679);
									  }
									  {	/* Object/struct.scm 56 */
									     obj_t arg1451_694;
									     {	/* Object/struct.scm 56 */
										obj_t arg1454_696;
										{	/* Object/struct.scm 56 */
										   obj_t arg1455_697;
										   {	/* Object/struct.scm 56 */
										      obj_t arg1457_699;
										      obj_t arg1458_700;
										      arg1457_699 =
											 CNST_TABLE_REF(((long) 15));
										      {		/* Object/struct.scm 56 */
											 obj_t arg1459_701;
											 {	/* ./Ieee/pair-list.scm 5689 */
											    obj_t aux_2355;
											    aux_2355 =
											       BINT(((long) 1));
											    arg1459_701 =
											       MAKE_PAIR(aux_2355, BNIL);
											 }
											 arg1458_700 =
											    MAKE_PAIR(j_612, arg1459_701);
										      }
										      arg1455_697 =
											 MAKE_PAIR(arg1457_699, arg1458_700);
										   }
										   arg1454_696 =
										      MAKE_PAIR(arg1455_697, BNIL);
										}
										arg1451_694 =
										   MAKE_PAIR(loop_613, arg1454_696);
									     }
									     arg1433_677 =
										MAKE_PAIR(arg1451_694, BNIL);
									  }
									  arg1431_675 =
									     MAKE_PAIR(arg1432_676, arg1433_677);
								       }
								       arg1427_672 =
									  MAKE_PAIR(arg1430_674, arg1431_675);
								    }
								    arg1420_667 =
								       MAKE_PAIR(arg1427_672, BNIL);
								 }
								 arg1412_662 =
								    MAKE_PAIR(arg1419_666, arg1420_667);
							      }
							      arg1410_660 =
								 MAKE_PAIR(arg1411_661, arg1412_662);
							   }
							   arg1405_657 =
							      MAKE_PAIR(arg1409_659, arg1410_660);
							}
							arg1404_656 =
							   MAKE_PAIR(arg1405_657, BNIL);
						     }
						     arg1402_654 =
							MAKE_PAIR(arg1403_655, arg1404_656);
						  }
						  arg1400_652 =
						     MAKE_PAIR(loop_613, arg1402_654);
					       }
					       arg1398_650 =
						  MAKE_PAIR(arg1400_652, BNIL);
					    }
					    {	/* Object/struct.scm 57 */
					       obj_t arg1461_702;
					       {	/* Object/struct.scm 57 */
						  obj_t arg1463_704;
						  {	/* ./Ieee/pair-list.scm 5689 */
						     obj_t aux_2373;
						     aux_2373 =
							BINT(((long) 0));
						     arg1463_704 =
							MAKE_PAIR(aux_2373, BNIL);
						  }
						  arg1461_702 =
						     MAKE_PAIR(loop_613, arg1463_704);
					       }
					       arg1399_651 =
						  MAKE_PAIR(arg1461_702, BNIL);
					    }
					    arg1397_649 =
					       MAKE_PAIR(arg1398_650, arg1399_651);
					 }
					 arg1393_646 =
					    MAKE_PAIR(arg1395_648, arg1397_649);
				      }
				      arg1381_638 =
					 MAKE_PAIR(arg1393_646, BNIL);
				   }
				   arg1379_636 =
				      MAKE_PAIR(arg1380_637, arg1381_638);
				}
				arg1376_633 =
				   MAKE_PAIR(arg1378_635, arg1379_636);
			     }
			     arg1356_618 =
				MAKE_PAIR(arg1376_633, BNIL);
			  }
			  arg1354_616 =
			     MAKE_PAIR(arg1355_617, arg1356_618);
		       }
		       return
			  MAKE_PAIR(arg1350_615, arg1354_616);
		    }
		 }
	      }
	    else
	      {		/* Object/struct.scm 87 */
		 bool_t test_2386;
		 {	/* ./Llib/struct.scm 1457 */
		    obj_t aux_2387;
		    aux_2387 =
		       STRUCT_REF(slot_75, ((long) 3));
		    test_2386 =
		       CBOOL(aux_2387);
		 }
		 if (test_2386)
		   {	/* Object/struct.scm 87 */
		      {		/* Object/struct.scm 59 */
			 obj_t vec_521;
			 obj_t j_522;
			 obj_t loop_523;
			 obj_t len_524;
			 vec_521 =
			    PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4,
			    CNST_TABLE_REF(((long) 2)), BEOA);
			 j_522 =
			    PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4,
			    CNST_TABLE_REF(((long) 3)), BEOA);
			 loop_523 =
			    PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4,
			    CNST_TABLE_REF(((long) 4)), BEOA);
			 len_524 =
			    PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4,
			    CNST_TABLE_REF(((long) 5)), BEOA);
			 {	/* Object/struct.scm 63 */
			    obj_t arg1243_525;
			    obj_t arg1245_526;
			    arg1243_525 =
			       CNST_TABLE_REF(((long) 6));
			    {	/* Object/struct.scm 63 */
			       obj_t arg1246_527;
			       obj_t arg1248_528;
			       {	/* Object/struct.scm 63 */
				  obj_t arg1249_529;
				  {	/* Object/struct.scm 63 */
				     obj_t arg1251_531;
				     {	/* Object/struct.scm 63 */
					obj_t arg1252_532;
					{	/* Object/struct.scm 63 */
					   obj_t arg1254_534;
					   obj_t arg1255_535;
					   arg1254_534 =
					      CNST_TABLE_REF(((long) 7));
					   {	/* ./Ieee/pair-list.scm 5689 */
					      obj_t aux_2404;
					      aux_2404 =
						 STRUCT_REF(slot_75, ((long) 4));
					      arg1255_535 =
						 MAKE_PAIR(aux_2404, BNIL);
					   }
					   arg1252_532 =
					      MAKE_PAIR(arg1254_534, arg1255_535);
					}
					arg1251_531 =
					   MAKE_PAIR(arg1252_532, BNIL);
				     }
				     arg1249_529 =
					MAKE_PAIR(len_524, arg1251_531);
				  }
				  arg1246_527 =
				     MAKE_PAIR(arg1249_529, BNIL);
			       }
			       {	/* Object/struct.scm 64 */
				  obj_t arg1258_538;
				  {	/* Object/struct.scm 64 */
				     obj_t arg1260_540;
				     obj_t arg1261_541;
				     arg1260_540 =
					CNST_TABLE_REF(((long) 6));
				     {	/* Object/struct.scm 64 */
					obj_t arg1263_542;
					obj_t arg1264_543;
					{	/* Object/struct.scm 64 */
					   obj_t arg1265_544;
					   {	/* Object/struct.scm 64 */
					      obj_t arg1268_546;
					      {		/* Object/struct.scm 64 */
						 obj_t arg1269_547;
						 {	/* Object/struct.scm 64 */
						    obj_t arg1271_549;
						    obj_t arg1272_550;
						    arg1271_549 =
						       CNST_TABLE_REF(((long) 8));
						    arg1272_550 =
						       MAKE_PAIR(len_524, BNIL);
						    arg1269_547 =
						       MAKE_PAIR(arg1271_549, arg1272_550);
						 }
						 arg1268_546 =
						    MAKE_PAIR(arg1269_547, BNIL);
					      }
					      arg1265_544 =
						 MAKE_PAIR(vec_521, arg1268_546);
					   }
					   arg1263_542 =
					      MAKE_PAIR(arg1265_544, BNIL);
					}
					{	/* Object/struct.scm 65 */
					   obj_t arg1273_551;
					   {	/* Object/struct.scm 65 */
					      obj_t arg1276_553;
					      obj_t arg1277_554;
					      arg1276_553 =
						 CNST_TABLE_REF(((long) 9));
					      {		/* Object/struct.scm 65 */
						 obj_t arg1278_555;
						 obj_t arg1280_556;
						 {	/* Object/struct.scm 65 */
						    obj_t arg1281_557;
						    {	/* Object/struct.scm 65 */
						       obj_t arg1286_559;
						       {	/* Object/struct.scm 65 */
							  obj_t arg1287_560;
							  obj_t arg1289_561;
							  arg1287_560 =
							     MAKE_PAIR(j_522, BNIL);
							  {	/* Object/struct.scm 65 */
							     obj_t arg1290_562;
							     {	/* Object/struct.scm 65 */
								obj_t arg1292_564;
								obj_t arg1293_565;
								arg1292_564 =
								   CNST_TABLE_REF(((long) 10));
								{	/* Object/struct.scm 65 */
								   obj_t arg1294_566;
								   obj_t arg1295_567;
								   {	/* Object/struct.scm 65 */
								      obj_t arg1296_568;
								      obj_t arg1297_569;
								      arg1296_568 =
									 CNST_TABLE_REF(((long) 11));
								      {		/* Object/struct.scm 65 */
									 obj_t arg1298_570;
									 arg1298_570 =
									    MAKE_PAIR(len_524, BNIL);
									 arg1297_569 =
									    MAKE_PAIR(j_522, arg1298_570);
								      }
								      arg1294_566 =
									 MAKE_PAIR(arg1296_568, arg1297_569);
								   }
								   {	/* Object/struct.scm 66 */
								      obj_t arg1299_571;
								      obj_t arg1300_572;
								      {		/* Object/struct.scm 66 */
									 obj_t arg1301_573;
									 obj_t arg1302_574;
									 arg1301_573 =
									    CNST_TABLE_REF(((long) 0));
									 {	/* Object/struct.scm 66 */
									    obj_t arg1303_575;
									    {	/* Object/struct.scm 66 */
									       obj_t arg1304_576;
									       arg1304_576 =
										  MAKE_PAIR(vec_521, BNIL);
									       {	/* ./Ieee/pair-list.scm 5689 */
										  obj_t aux_2427;
										  aux_2427 =
										     BINT(i_74);
										  arg1303_575 =
										     MAKE_PAIR(aux_2427, arg1304_576);
									       }
									    }
									    arg1302_574 =
									       MAKE_PAIR(sname_72, arg1303_575);
									 }
									 arg1299_571 =
									    MAKE_PAIR(arg1301_573, arg1302_574);
								      }
								      {		/* Object/struct.scm 67 */
									 obj_t arg1305_577;
									 {	/* Object/struct.scm 67 */
									    obj_t arg1308_579;
									    obj_t arg1309_580;
									    arg1308_579 =
									       CNST_TABLE_REF(((long) 12));
									    {	/* Object/struct.scm 68 */
									       obj_t arg1313_581;
									       obj_t arg1314_582;
									       {	/* Object/struct.scm 68 */
										  obj_t arg1315_583;
										  obj_t arg1317_584;
										  arg1315_583 =
										     CNST_TABLE_REF(((long) 13));
										  {	/* Object/struct.scm 72 */
										     obj_t arg1318_585;
										     {	/* Object/struct.scm 72 */
											obj_t arg1319_586;
											{	/* Object/struct.scm 72 */
											   obj_t arg1320_587;
											   {	/* Object/struct.scm 72 */
											      obj_t arg1323_589;
											      obj_t arg1325_590;
											      {		/* Object/struct.scm 72 */
												 obj_t arg1326_591;
												 obj_t arg1327_592;
												 arg1326_591 =
												    CNST_TABLE_REF(((long) 1));
												 arg1327_592 =
												    STRUCT_REF(slot_75, ((long) 0));
												 {	/* Object/struct.scm 71 */
												    obj_t list1330_594;
												    {	/* Object/struct.scm 71 */
												       obj_t arg1331_595;
												       {	/* Object/struct.scm 71 */
													  obj_t arg1332_596;
													  {	/* Object/struct.scm 71 */
													     obj_t arg1333_597;
													     {	/* Object/struct.scm 71 */
														obj_t aux_2436;
														aux_2436 =
														   CNST_TABLE_REF(((long) 14));
														arg1333_597 =
														   MAKE_PAIR(aux_2436, BNIL);
													     }
													     arg1332_596 =
														MAKE_PAIR(arg1327_592, arg1333_597);
													  }
													  arg1331_595 =
													     MAKE_PAIR(arg1326_591, arg1332_596);
												       }
												       list1330_594 =
													  MAKE_PAIR(cname_73, arg1331_595);
												    }
												    arg1323_589 =
												       symbol_append_197___r4_symbols_6_4(list1330_594);
												 }
											      }
											      {		/* Object/struct.scm 71 */
												 obj_t arg1334_598;
												 arg1334_598 =
												    MAKE_PAIR(j_522, BNIL);
												 arg1325_590 =
												    MAKE_PAIR(oname_71, arg1334_598);
											      }
											      arg1320_587 =
												 MAKE_PAIR(arg1323_589, arg1325_590);
											   }
											   arg1319_586 =
											      MAKE_PAIR(arg1320_587, BNIL);
											}
											arg1318_585 =
											   MAKE_PAIR(j_522, arg1319_586);
										     }
										     arg1317_584 =
											MAKE_PAIR(vec_521, arg1318_585);
										  }
										  arg1313_581 =
										     MAKE_PAIR(arg1315_583, arg1317_584);
									       }
									       {	/* Object/struct.scm 77 */
										  obj_t arg1335_599;
										  {	/* Object/struct.scm 77 */
										     obj_t arg1337_601;
										     {	/* Object/struct.scm 77 */
											obj_t arg1338_602;
											{	/* Object/struct.scm 77 */
											   obj_t arg1340_604;
											   obj_t arg1342_605;
											   arg1340_604 =
											      CNST_TABLE_REF(((long) 15));
											   {	/* Object/struct.scm 77 */
											      obj_t arg1343_606;
											      {		/* ./Ieee/pair-list.scm 5689 */
												 obj_t aux_2451;
												 aux_2451 =
												    BINT(((long) 1));
												 arg1343_606 =
												    MAKE_PAIR(aux_2451, BNIL);
											      }
											      arg1342_605 =
												 MAKE_PAIR(j_522, arg1343_606);
											   }
											   arg1338_602 =
											      MAKE_PAIR(arg1340_604, arg1342_605);
											}
											arg1337_601 =
											   MAKE_PAIR(arg1338_602, BNIL);
										     }
										     arg1335_599 =
											MAKE_PAIR(loop_523, arg1337_601);
										  }
										  arg1314_582 =
										     MAKE_PAIR(arg1335_599, BNIL);
									       }
									       arg1309_580 =
										  MAKE_PAIR(arg1313_581, arg1314_582);
									    }
									    arg1305_577 =
									       MAKE_PAIR(arg1308_579, arg1309_580);
									 }
									 arg1300_572 =
									    MAKE_PAIR(arg1305_577, BNIL);
								      }
								      arg1295_567 =
									 MAKE_PAIR(arg1299_571, arg1300_572);
								   }
								   arg1293_565 =
								      MAKE_PAIR(arg1294_566, arg1295_567);
								}
								arg1290_562 =
								   MAKE_PAIR(arg1292_564, arg1293_565);
							     }
							     arg1289_561 =
								MAKE_PAIR(arg1290_562, BNIL);
							  }
							  arg1286_559 =
							     MAKE_PAIR(arg1287_560, arg1289_561);
						       }
						       arg1281_557 =
							  MAKE_PAIR(loop_523, arg1286_559);
						    }
						    arg1278_555 =
						       MAKE_PAIR(arg1281_557, BNIL);
						 }
						 {	/* Object/struct.scm 78 */
						    obj_t arg1344_607;
						    {	/* Object/struct.scm 78 */
						       obj_t arg1347_609;
						       {	/* ./Ieee/pair-list.scm 5689 */
							  obj_t aux_2469;
							  aux_2469 =
							     BINT(((long) 0));
							  arg1347_609 =
							     MAKE_PAIR(aux_2469, BNIL);
						       }
						       arg1344_607 =
							  MAKE_PAIR(loop_523, arg1347_609);
						    }
						    arg1280_556 =
						       MAKE_PAIR(arg1344_607, BNIL);
						 }
						 arg1277_554 =
						    MAKE_PAIR(arg1278_555, arg1280_556);
					      }
					      arg1273_551 =
						 MAKE_PAIR(arg1276_553, arg1277_554);
					   }
					   arg1264_543 =
					      MAKE_PAIR(arg1273_551, BNIL);
					}
					arg1261_541 =
					   MAKE_PAIR(arg1263_542, arg1264_543);
				     }
				     arg1258_538 =
					MAKE_PAIR(arg1260_540, arg1261_541);
				  }
				  arg1248_528 =
				     MAKE_PAIR(arg1258_538, BNIL);
			       }
			       arg1245_526 =
				  MAKE_PAIR(arg1246_527, arg1248_528);
			    }
			    return
			       MAKE_PAIR(arg1243_525, arg1245_526);
			 }
		      }
		   }
		 else
		   {	/* Object/struct.scm 89 */
		      bool_t test_2482;
		      {		/* ./Llib/struct.scm 1457 */
			 obj_t aux_2483;
			 aux_2483 =
			    STRUCT_REF(slot_75, ((long) 11));
			 test_2482 =
			    CBOOL(aux_2483);
		      }
		      if (test_2482)
			{	/* Object/struct.scm 89 */
			   return BUNSPEC;
			}
		      else
			{	/* Object/struct.scm 89 */
			   {	/* Object/struct.scm 80 */
			      obj_t arg1228_507;
			      obj_t arg1229_508;
			      arg1228_507 =
				 CNST_TABLE_REF(((long) 0));
			      {		/* Object/struct.scm 82 */
				 obj_t arg1230_509;
				 {	/* Object/struct.scm 82 */
				    obj_t arg1231_510;
				    {	/* Object/struct.scm 82 */
				       obj_t arg1232_511;
				       {	/* Object/struct.scm 82 */
					  obj_t arg1234_513;
					  obj_t arg1235_514;
					  {	/* Object/struct.scm 82 */
					     obj_t arg1236_515;
					     arg1236_515 =
						CNST_TABLE_REF(((long) 1));
					     {	/* Object/struct.scm 82 */
						obj_t list1238_517;
						{	/* Object/struct.scm 82 */
						   obj_t arg1240_518;
						   {	/* Object/struct.scm 82 */
						      obj_t arg1241_519;
						      {		/* Object/struct.scm 82 */
							 obj_t aux_2488;
							 aux_2488 =
							    STRUCT_REF(slot_75, ((long) 0));
							 arg1241_519 =
							    MAKE_PAIR(aux_2488, BNIL);
						      }
						      arg1240_518 =
							 MAKE_PAIR(arg1236_515, arg1241_519);
						   }
						   list1238_517 =
						      MAKE_PAIR(cname_73, arg1240_518);
						}
						arg1234_513 =
						   symbol_append_197___r4_symbols_6_4(list1238_517);
					     }
					  }
					  arg1235_514 =
					     MAKE_PAIR(oname_71, BNIL);
					  arg1232_511 =
					     MAKE_PAIR(arg1234_513, arg1235_514);
				       }
				       arg1231_510 =
					  MAKE_PAIR(arg1232_511, BNIL);
				    }
				    {	/* ./Ieee/pair-list.scm 5689 */
				       obj_t aux_2497;
				       aux_2497 =
					  BINT(i_74);
				       arg1230_509 =
					  MAKE_PAIR(aux_2497, arg1231_510);
				    }
				 }
				 arg1229_508 =
				    MAKE_PAIR(sname_72, arg1230_509);
			      }
			      return
				 MAKE_PAIR(arg1228_507, arg1229_508);
			   }
			}
		   }
	      }
	 }
      }
   }
}



/* slots-length */
long 
slots_length_21_object_struct(obj_t slots_76)
{
   AN_OBJECT;
   {	/* Object/struct.scm 97 */
      {
	 obj_t slots_708;
	 long len_709;
	 slots_708 = slots_76;
	 len_709 = ((long) 0);
       loop_710:
	 if (
	    NULLP(slots_708))
	   {	/* Object/struct.scm 101 */
	      return len_709;
	   }
	 else
	   {	/* Object/struct.scm 103 */
	      bool_t test_2504;
	      {		/* ./Llib/struct.scm 1457 */
		 obj_t aux_2505;
		 {	/* ./Llib/struct.scm 1457 */
		    obj_t aux_2506;
		    aux_2506 =
		       CAR(slots_708);
		    aux_2505 =
		       STRUCT_REF(aux_2506, ((long) 11));
		 }
		 test_2504 =
		    CBOOL(aux_2505);
	      }
	      if (test_2504)
		{	/* Object/struct.scm 103 */
		   {
		      obj_t slots_2510;
		      slots_2510 =
			 CDR(slots_708);
		      slots_708 = slots_2510;
		      goto loop_710;
		   }
		}
	      else
		{	/* Object/struct.scm 103 */
		   {
		      long len_2514;
		      obj_t slots_2512;
		      slots_2512 =
			 CDR(slots_708);
		      len_2514 =
			 (((long) 1) + len_709);
		      len_709 = len_2514;
		      slots_708 = slots_2512;
		      goto loop_710;
		   }
		}
	   }
      }
   }
}



/* make-object->struct */
obj_t 
make_object__struct_189_object_struct(obj_t cname_77, type_bglt type_78, obj_t module_79, obj_t slots_80, obj_t src_def_101_81)
{
   AN_OBJECT;
   {	/* Object/struct.scm 111 */
      {		/* Object/struct.scm 112 */
	 long len_717;
	 obj_t oname_718;
	 obj_t sname_719;
	 {	/* ./Ieee/fixnum.scm 7193 */
	    long aux_2516;
	    aux_2516 =
	       slots_length_21_object_struct(slots_80);
	    len_717 =
	       (((long) 1) + aux_2516);
	 }
	 oname_718 =
	    PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4,
	    CNST_TABLE_REF(((long) 17)), BEOA);
	 sname_719 =
	    PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4,
	    CNST_TABLE_REF(((long) 18)), BEOA);
	 {	/* Object/struct.scm 116 */
	    obj_t arg1471_720;
	    {	/* Object/struct.scm 116 */
	       obj_t arg1472_721;
	       obj_t arg1473_722;
	       arg1472_721 =
		  CNST_TABLE_REF(((long) 19));
	       {	/* Object/struct.scm 116 */
		  obj_t arg1474_723;
		  obj_t arg1475_724;
		  {	/* Object/struct.scm 116 */
		     obj_t arg1476_725;
		     obj_t arg1477_726;
		     arg1476_725 =
			CNST_TABLE_REF(((long) 20));
		     {	/* Object/struct.scm 116 */
			obj_t arg1478_727;
			{	/* Object/struct.scm 116 */
			   obj_t list1480_729;
			   {	/* Object/struct.scm 116 */
			      obj_t arg1481_730;
			      {		/* Object/struct.scm 116 */
				 obj_t arg1482_731;
				 arg1482_731 =
				    MAKE_PAIR(cname_77, BNIL);
				 arg1481_730 =
				    MAKE_PAIR(_4dots_199_tools_misc, arg1482_731);
			      }
			      list1480_729 =
				 MAKE_PAIR(oname_718, arg1481_730);
			   }
			   arg1478_727 =
			      symbol_append_197___r4_symbols_6_4(list1480_729);
			}
			arg1477_726 =
			   MAKE_PAIR(arg1478_727, BNIL);
		     }
		     arg1474_723 =
			MAKE_PAIR(arg1476_725, arg1477_726);
		  }
		  {	/* Object/struct.scm 117 */
		     obj_t arg1483_732;
		     {	/* Object/struct.scm 117 */
			obj_t arg1485_734;
			obj_t arg1486_735;
			arg1485_734 =
			   CNST_TABLE_REF(((long) 6));
			{	/* Object/struct.scm 117 */
			   obj_t arg1488_736;
			   obj_t arg1489_737;
			   {	/* Object/struct.scm 117 */
			      obj_t arg1490_738;
			      {		/* Object/struct.scm 117 */
				 obj_t arg1493_740;
				 {	/* Object/struct.scm 117 */
				    obj_t arg1494_741;
				    {	/* Object/struct.scm 117 */
				       obj_t arg1496_743;
				       obj_t arg1497_744;
				       arg1496_743 =
					  CNST_TABLE_REF(((long) 21));
				       {	/* Object/struct.scm 117 */
					  obj_t arg1498_745;
					  obj_t arg1499_746;
					  {	/* Object/struct.scm 117 */
					     obj_t arg1500_747;
					     obj_t arg1501_748;
					     arg1500_747 =
						CNST_TABLE_REF(((long) 22));
					     arg1501_748 =
						MAKE_PAIR(cname_77, BNIL);
					     arg1498_745 =
						MAKE_PAIR(arg1500_747, arg1501_748);
					  }
					  {	/* Object/struct.scm 117 */
					     obj_t arg1502_749;
					     arg1502_749 =
						MAKE_PAIR(BUNSPEC, BNIL);
					     {	/* ./Ieee/pair-list.scm 5689 */
						obj_t aux_2539;
						aux_2539 =
						   BINT(len_717);
						arg1499_746 =
						   MAKE_PAIR(aux_2539, arg1502_749);
					     }
					  }
					  arg1497_744 =
					     MAKE_PAIR(arg1498_745, arg1499_746);
				       }
				       arg1494_741 =
					  MAKE_PAIR(arg1496_743, arg1497_744);
				    }
				    arg1493_740 =
				       MAKE_PAIR(arg1494_741, BNIL);
				 }
				 arg1490_738 =
				    MAKE_PAIR(sname_719, arg1493_740);
			      }
			      arg1488_736 =
				 MAKE_PAIR(arg1490_738, BNIL);
			   }
			   {	/* Object/struct.scm 118 */
			      obj_t arg1503_750;
			      {		/* Object/struct.scm 118 */
				 obj_t arg1505_752;
				 obj_t arg1506_753;
				 arg1505_752 =
				    CNST_TABLE_REF(((long) 12));
				 {	/* Object/struct.scm 119 */
				    obj_t arg1508_754;
				    obj_t arg1509_755;
				    {	/* Object/struct.scm 119 */
				       obj_t arg1510_756;
				       obj_t arg1511_757;
				       arg1510_756 =
					  CNST_TABLE_REF(((long) 0));
				       {	/* Object/struct.scm 119 */
					  obj_t arg1512_758;
					  {	/* Object/struct.scm 119 */
					     obj_t arg1514_760;
					     arg1514_760 =
						MAKE_PAIR(BFALSE, BNIL);
					     {	/* ./Ieee/pair-list.scm 5689 */
						obj_t aux_2550;
						aux_2550 =
						   BINT(((long) 0));
						arg1512_758 =
						   MAKE_PAIR(aux_2550, arg1514_760);
					     }
					  }
					  arg1511_757 =
					     MAKE_PAIR(sname_719, arg1512_758);
				       }
				       arg1508_754 =
					  MAKE_PAIR(arg1510_756, arg1511_757);
				    }
				    {	/* Object/struct.scm 120 */
				       obj_t arg1515_761;
				       obj_t arg1516_762;
				       {
					  long i_763;
					  obj_t slots_764;
					  obj_t res_765;
					  i_763 = ((long) 1);
					  slots_764 = slots_80;
					  res_765 = BNIL;
					loop_766:
					  if (
					     (i_763 == len_717))
					    {	/* Object/struct.scm 124 */
					       arg1515_761 =
						  reverse__39___r4_pairs_and_lists_6_3(res_765);
					    }
					  else
					    {	/* Object/struct.scm 126 */
					       bool_t test_2558;
					       {	/* ./Llib/struct.scm 1457 */
						  obj_t aux_2559;
						  {	/* ./Llib/struct.scm 1457 */
						     obj_t aux_2560;
						     aux_2560 =
							CAR(slots_764);
						     aux_2559 =
							STRUCT_REF(aux_2560, ((long) 11));
						  }
						  test_2558 =
						     CBOOL(aux_2559);
					       }
					       if (test_2558)
						 {	/* Object/struct.scm 126 */
						    {
						       obj_t slots_2566;
						       long i_2564;
						       i_2564 =
							  (i_763 + ((long) 1));
						       slots_2566 =
							  CDR(slots_764);
						       slots_764 = slots_2566;
						       i_763 = i_2564;
						       goto loop_766;
						    }
						 }
					       else
						 {	/* Object/struct.scm 126 */
						    {	/* Object/struct.scm 131 */
						       long arg1521_771;
						       obj_t arg1522_772;
						       obj_t arg1523_773;
						       arg1521_771 =
							  (i_763 + ((long) 1));
						       arg1522_772 =
							  CDR(slots_764);
						       {	/* Object/struct.scm 137 */
							  obj_t arg1525_774;
							  arg1525_774 =
							     save_slot_187_object_struct(oname_718, sname_719, cname_77, i_763,
							     CAR(slots_764));
							  arg1523_773 =
							     MAKE_PAIR(arg1525_774, res_765);
						       }
						       {
							  obj_t res_2575;
							  obj_t slots_2574;
							  long i_2573;
							  i_2573 = arg1521_771;
							  slots_2574 = arg1522_772;
							  res_2575 = arg1523_773;
							  res_765 = res_2575;
							  slots_764 = slots_2574;
							  i_763 = i_2573;
							  goto loop_766;
						       }
						    }
						 }
					    }
				       }
				       arg1516_762 =
					  MAKE_PAIR(sname_719, BNIL);
				       arg1509_755 =
					  append_2_18___r4_pairs_and_lists_6_3(arg1515_761, arg1516_762);
				    }
				    arg1506_753 =
				       MAKE_PAIR(arg1508_754, arg1509_755);
				 }
				 arg1503_750 =
				    MAKE_PAIR(arg1505_752, arg1506_753);
			      }
			      arg1489_737 =
				 MAKE_PAIR(arg1503_750, BNIL);
			   }
			   arg1486_735 =
			      MAKE_PAIR(arg1488_736, arg1489_737);
			}
			arg1483_732 =
			   MAKE_PAIR(arg1485_734, arg1486_735);
		     }
		     arg1475_724 =
			MAKE_PAIR(arg1483_732, BNIL);
		  }
		  arg1473_722 =
		     MAKE_PAIR(arg1474_723, arg1475_724);
	       }
	       arg1471_720 =
		  MAKE_PAIR(arg1472_721, arg1473_722);
	    }
	    return
	       epairify_tools_misc(arg1471_720, src_def_101_81);
	 }
      }
   }
}



/* _make-object->struct1982 */
obj_t 
_make_object__struct1982_224_object_struct(obj_t env_2228, obj_t cname_2229, obj_t type_2230, obj_t module_2231, obj_t slots_2232, obj_t src_def_101_2233)
{
   AN_OBJECT;
   {	/* Object/struct.scm 111 */
      return
	 make_object__struct_189_object_struct(cname_2229,
	 (type_bglt) (type_2230), module_2231, slots_2232, src_def_101_2233);
   }
}



/* make-wide-object->struct */
obj_t 
make_wide_object__struct_148_object_struct(obj_t cname_82, type_bglt type_83, obj_t module_84, obj_t slots_85, obj_t src_def_101_86)
{
   AN_OBJECT;
   {	/* Object/struct.scm 145 */
      {		/* Object/struct.scm 146 */
	 long len_779;
	 len_779 =
	    slots_length_21_object_struct(slots_85);
	 {	/* Object/struct.scm 146 */
	    obj_t oname_780;
	    oname_780 =
	       PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4,
	       CNST_TABLE_REF(((long) 17)), BEOA);
	    {	/* Object/struct.scm 147 */
	       obj_t res_781;
	       res_781 =
		  PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4,
		  CNST_TABLE_REF(((long) 18)), BEOA);
	       {	/* Object/struct.scm 148 */
		  obj_t tres_782;
		  {	/* Object/struct.scm 149 */
		     obj_t list1616_866;
		     {	/* Object/struct.scm 149 */
			obj_t arg1617_867;
			{	/* Object/struct.scm 149 */
			   obj_t aux_2596;
			   aux_2596 =
			      CNST_TABLE_REF(((long) 23));
			   arg1617_867 =
			      MAKE_PAIR(aux_2596, BNIL);
			}
			list1616_866 =
			   MAKE_PAIR(res_781, arg1617_867);
		     }
		     tres_782 =
			symbol_append_197___r4_symbols_6_4(list1616_866);
		  }
		  {	/* Object/struct.scm 149 */
		     obj_t aux_783;
		     aux_783 =
			PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4,
			CNST_TABLE_REF(((long) 24)), BEOA);
		     {	/* Object/struct.scm 150 */

			{	/* Object/struct.scm 152 */
			   obj_t arg1530_784;
			   {	/* Object/struct.scm 152 */
			      obj_t arg1532_785;
			      obj_t arg1533_786;
			      arg1532_785 =
				 CNST_TABLE_REF(((long) 19));
			      {		/* Object/struct.scm 152 */
				 obj_t arg1534_787;
				 obj_t arg1535_788;
				 {	/* Object/struct.scm 152 */
				    obj_t arg1536_789;
				    obj_t arg1537_790;
				    arg1536_789 =
				       CNST_TABLE_REF(((long) 20));
				    {	/* Object/struct.scm 152 */
				       obj_t arg1539_791;
				       {	/* Object/struct.scm 152 */
					  obj_t list1541_793;
					  {	/* Object/struct.scm 152 */
					     obj_t arg1543_794;
					     {	/* Object/struct.scm 152 */
						obj_t arg1544_795;
						arg1544_795 =
						   MAKE_PAIR(cname_82, BNIL);
						arg1543_794 =
						   MAKE_PAIR(_4dots_199_tools_misc, arg1544_795);
					     }
					     list1541_793 =
						MAKE_PAIR(oname_780, arg1543_794);
					  }
					  arg1539_791 =
					     symbol_append_197___r4_symbols_6_4(list1541_793);
				       }
				       arg1537_790 =
					  MAKE_PAIR(arg1539_791, BNIL);
				    }
				    arg1534_787 =
				       MAKE_PAIR(arg1536_789, arg1537_790);
				 }
				 {	/* Object/struct.scm 153 */
				    obj_t arg1545_796;
				    {	/* Object/struct.scm 153 */
				       obj_t arg1548_798;
				       obj_t arg1549_799;
				       arg1548_798 =
					  CNST_TABLE_REF(((long) 6));
				       {	/* Object/struct.scm 153 */
					  obj_t arg1550_800;
					  obj_t arg1551_801;
					  {	/* Object/struct.scm 153 */
					     obj_t arg1552_802;
					     {	/* Object/struct.scm 153 */
						obj_t arg1555_804;
						{	/* Object/struct.scm 153 */
						   obj_t arg1556_805;
						   {	/* ./Ieee/pair-list.scm 5689 */
						      obj_t aux_2613;
						      aux_2613 =
							 CNST_TABLE_REF(((long) 25));
						      arg1556_805 =
							 MAKE_PAIR(aux_2613, BNIL);
						   }
						   arg1555_804 =
						      MAKE_PAIR(arg1556_805, BNIL);
						}
						arg1552_802 =
						   MAKE_PAIR(tres_782, arg1555_804);
					     }
					     arg1550_800 =
						MAKE_PAIR(arg1552_802, BNIL);
					  }
					  {	/* Object/struct.scm 154 */
					     obj_t arg1558_807;
					     {	/* Object/struct.scm 154 */
						obj_t arg1560_809;
						obj_t arg1561_810;
						arg1560_809 =
						   CNST_TABLE_REF(((long) 6));
						{	/* Object/struct.scm 154 */
						   obj_t arg1562_811;
						   obj_t arg1563_812;
						   {	/* Object/struct.scm 154 */
						      obj_t arg1564_813;
						      {		/* Object/struct.scm 154 */
							 obj_t arg1566_815;
							 {	/* Object/struct.scm 154 */
							    obj_t arg1567_816;
							    {	/* Object/struct.scm 154 */
							       obj_t arg1569_818;
							       obj_t arg1571_819;
							       arg1569_818 =
								  CNST_TABLE_REF(((long) 21));
							       {	/* Object/struct.scm 154 */
								  obj_t arg1572_820;
								  obj_t arg1573_821;
								  {	/* Object/struct.scm 154 */
								     obj_t arg1576_822;
								     obj_t arg1577_823;
								     arg1576_822 =
									CNST_TABLE_REF(((long) 22));
								     arg1577_823 =
									MAKE_PAIR(cname_82, BNIL);
								     arg1572_820 =
									MAKE_PAIR(arg1576_822, arg1577_823);
								  }
								  {	/* Object/struct.scm 154 */
								     obj_t arg1578_824;
								     arg1578_824 =
									MAKE_PAIR(BUNSPEC, BNIL);
								     {	/* ./Ieee/pair-list.scm 5689 */
									obj_t aux_2625;
									aux_2625 =
									   BINT(len_779);
									arg1573_821 =
									   MAKE_PAIR(aux_2625, arg1578_824);
								     }
								  }
								  arg1571_819 =
								     MAKE_PAIR(arg1572_820, arg1573_821);
							       }
							       arg1567_816 =
								  MAKE_PAIR(arg1569_818, arg1571_819);
							    }
							    arg1566_815 =
							       MAKE_PAIR(arg1567_816, BNIL);
							 }
							 arg1564_813 =
							    MAKE_PAIR(aux_783, arg1566_815);
						      }
						      arg1562_811 =
							 MAKE_PAIR(arg1564_813, BNIL);
						   }
						   {	/* Object/struct.scm 155 */
						      obj_t arg1579_825;
						      obj_t arg1580_826;
						      {
							 long i_827;
							 obj_t slots_828;
							 obj_t res_829;
							 i_827 = ((long) 0);
							 slots_828 = slots_85;
							 res_829 = BNIL;
						       loop_830:
							 if (
							    (i_827 == len_779))
							   {	/* Object/struct.scm 159 */
							      arg1579_825 =
								 reverse__39___r4_pairs_and_lists_6_3(res_829);
							   }
							 else
							   {	/* Object/struct.scm 161 */
							      bool_t test_2636;
							      {		/* ./Llib/struct.scm 1457 */
								 obj_t aux_2637;
								 {	/* ./Llib/struct.scm 1457 */
								    obj_t aux_2638;
								    aux_2638 =
								       CAR(slots_828);
								    aux_2637 =
								       STRUCT_REF(aux_2638, ((long) 11));
								 }
								 test_2636 =
								    CBOOL(aux_2637);
							      }
							      if (test_2636)
								{	/* Object/struct.scm 161 */
								   {
								      obj_t slots_2644;
								      long i_2642;
								      i_2642 =
									 (i_827 + ((long) 1));
								      slots_2644 =
									 CDR(slots_828);
								      slots_828 = slots_2644;
								      i_827 = i_2642;
								      goto loop_830;
								   }
								}
							      else
								{	/* Object/struct.scm 161 */
								   {	/* Object/struct.scm 166 */
								      long arg1585_835;
								      obj_t arg1586_836;
								      obj_t arg1587_837;
								      arg1585_835 =
									 (i_827 + ((long) 1));
								      arg1586_836 =
									 CDR(slots_828);
								      {		/* Object/struct.scm 168 */
									 obj_t arg1588_838;
									 arg1588_838 =
									    save_slot_187_object_struct(oname_780, aux_783, cname_82, i_827,
									    CAR(slots_828));
									 arg1587_837 =
									    MAKE_PAIR(arg1588_838, res_829);
								      }
								      {
									 obj_t res_2653;
									 obj_t slots_2652;
									 long i_2651;
									 i_2651 = arg1585_835;
									 slots_2652 = arg1586_836;
									 res_2653 = arg1587_837;
									 res_829 = res_2653;
									 slots_828 = slots_2652;
									 i_827 = i_2651;
									 goto loop_830;
								      }
								   }
								}
							   }
						      }
						      {		/* Object/struct.scm 170 */
							 obj_t arg1591_841;
							 obj_t arg1592_842;
							 {	/* Object/struct.scm 170 */
							    obj_t arg1593_843;
							    obj_t arg1594_844;
							    arg1593_843 =
							       CNST_TABLE_REF(((long) 0));
							    {	/* Object/struct.scm 170 */
							       obj_t arg1595_845;
							       {	/* Object/struct.scm 170 */
								  obj_t arg1597_847;
								  arg1597_847 =
								     MAKE_PAIR(aux_783, BNIL);
								  {	/* ./Ieee/pair-list.scm 5689 */
								     obj_t aux_2656;
								     aux_2656 =
									BINT(((long) 0));
								     arg1595_845 =
									MAKE_PAIR(aux_2656, arg1597_847);
								  }
							       }
							       arg1594_844 =
								  MAKE_PAIR(res_781, arg1595_845);
							    }
							    arg1591_841 =
							       MAKE_PAIR(arg1593_843, arg1594_844);
							 }
							 {	/* Object/struct.scm 172 */
							    obj_t arg1598_848;
							    obj_t arg1599_849;
							    {	/* Object/struct.scm 172 */
							       obj_t arg1600_850;
							       obj_t arg1601_851;
							       arg1600_850 =
								  CNST_TABLE_REF(((long) 26));
							       {	/* Object/struct.scm 172 */
								  obj_t arg1602_852;
								  {	/* Object/struct.scm 172 */
								     obj_t arg1603_853;
								     {	/* Object/struct.scm 172 */
									obj_t arg1605_855;
									obj_t arg1606_856;
									arg1605_855 =
									   CNST_TABLE_REF(((long) 27));
									arg1606_856 =
									   MAKE_PAIR(res_781, BNIL);
									arg1603_853 =
									   MAKE_PAIR(arg1605_855, arg1606_856);
								     }
								     arg1602_852 =
									MAKE_PAIR(arg1603_853, BNIL);
								  }
								  arg1601_851 =
								     MAKE_PAIR(aux_783, arg1602_852);
							       }
							       arg1598_848 =
								  MAKE_PAIR(arg1600_850, arg1601_851);
							    }
							    {	/* Object/struct.scm 173 */
							       obj_t arg1607_857;
							       obj_t arg1608_858;
							       {	/* Object/struct.scm 173 */
								  obj_t arg1609_859;
								  obj_t arg1610_860;
								  arg1609_859 =
								     CNST_TABLE_REF(((long) 26));
								  {	/* Object/struct.scm 173 */
								     obj_t arg1611_861;
								     {	/* Object/struct.scm 173 */
									obj_t arg1612_862;
									{	/* Object/struct.scm 173 */
									   obj_t arg1614_864;
									   obj_t arg1615_865;
									   arg1614_864 =
									      CNST_TABLE_REF(((long) 22));
									   arg1615_865 =
									      MAKE_PAIR(cname_82, BNIL);
									   arg1612_862 =
									      MAKE_PAIR(arg1614_864, arg1615_865);
									}
									arg1611_861 =
									   MAKE_PAIR(arg1612_862, BNIL);
								     }
								     arg1610_860 =
									MAKE_PAIR(res_781, arg1611_861);
								  }
								  arg1607_857 =
								     MAKE_PAIR(arg1609_859, arg1610_860);
							       }
							       arg1608_858 =
								  MAKE_PAIR(res_781, BNIL);
							       arg1599_849 =
								  MAKE_PAIR(arg1607_857, arg1608_858);
							    }
							    arg1592_842 =
							       MAKE_PAIR(arg1598_848, arg1599_849);
							 }
							 arg1580_826 =
							    MAKE_PAIR(arg1591_841, arg1592_842);
						      }
						      arg1563_812 =
							 append_2_18___r4_pairs_and_lists_6_3(arg1579_825, arg1580_826);
						   }
						   arg1561_810 =
						      MAKE_PAIR(arg1562_811, arg1563_812);
						}
						arg1558_807 =
						   MAKE_PAIR(arg1560_809, arg1561_810);
					     }
					     arg1551_801 =
						MAKE_PAIR(arg1558_807, BNIL);
					  }
					  arg1549_799 =
					     MAKE_PAIR(arg1550_800, arg1551_801);
				       }
				       arg1545_796 =
					  MAKE_PAIR(arg1548_798, arg1549_799);
				    }
				    arg1535_788 =
				       MAKE_PAIR(arg1545_796, BNIL);
				 }
				 arg1533_786 =
				    MAKE_PAIR(arg1534_787, arg1535_788);
			      }
			      arg1530_784 =
				 MAKE_PAIR(arg1532_785, arg1533_786);
			   }
			   return
			      epairify_tools_misc(arg1530_784, src_def_101_86);
			}
		     }
		  }
	       }
	    }
	 }
      }
   }
}



/* _make-wide-object->struct1983 */
obj_t 
_make_wide_object__struct1983_229_object_struct(obj_t env_2234, obj_t cname_2235, obj_t type_2236, obj_t module_2237, obj_t slots_2238, obj_t src_def_101_2239)
{
   AN_OBJECT;
   {	/* Object/struct.scm 145 */
      return
	 make_wide_object__struct_148_object_struct(cname_2235,
	 (type_bglt) (type_2236), module_2237, slots_2238, src_def_101_2239);
   }
}



/* restore-slot */
obj_t 
restore_slot_6_object_struct(obj_t oname_87, obj_t sname_88, obj_t cname_89, type_bglt type_90, long i_91, obj_t slot_92)
{
   AN_OBJECT;
   {	/* Object/struct.scm 181 */
      {		/* Object/struct.scm 182 */
	 obj_t loop_868;
	 loop_868 =
	    PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4,
	    CNST_TABLE_REF(((long) 4)), BEOA);
	 {	/* Object/struct.scm 182 */
	    obj_t runner_869;
	    runner_869 =
	       PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4,
	       CNST_TABLE_REF(((long) 28)), BEOA);
	    {	/* Object/struct.scm 183 */
	       obj_t v_870;
	       v_870 =
		  PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4,
		  CNST_TABLE_REF(((long) 29)), BEOA);
	       {	/* Object/struct.scm 184 */
		  obj_t len_871;
		  len_871 =
		     PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4,
		     CNST_TABLE_REF(((long) 5)), BEOA);
		  {	/* Object/struct.scm 185 */
		     obj_t runner_typed_89_872;
		     {	/* Object/struct.scm 186 */
			obj_t list1792_1042;
			{	/* Object/struct.scm 186 */
			   obj_t arg1793_1043;
			   {	/* Object/struct.scm 186 */
			      obj_t aux_2703;
			      aux_2703 =
				 CNST_TABLE_REF(((long) 30));
			      arg1793_1043 =
				 MAKE_PAIR(aux_2703, BNIL);
			   }
			   list1792_1042 =
			      MAKE_PAIR(runner_869, arg1793_1043);
			}
			runner_typed_89_872 =
			   symbol_append_197___r4_symbols_6_4(list1792_1042);
		     }
		     {	/* Object/struct.scm 186 */

			{	/* Object/struct.scm 188 */
			   bool_t test_2708;
			   {	/* ./Llib/struct.scm 1457 */
			      obj_t aux_2709;
			      aux_2709 =
				 STRUCT_REF(slot_92, ((long) 5));
			      test_2708 =
				 CBOOL(aux_2709);
			   }
			   if (test_2708)
			     {	/* Object/struct.scm 188 */
				{	/* Object/struct.scm 191 */
				   obj_t arg1619_874;
				   obj_t arg1620_875;
				   arg1619_874 =
				      CNST_TABLE_REF(((long) 6));
				   {	/* Object/struct.scm 191 */
				      obj_t arg1621_876;
				      obj_t arg1622_877;
				      {		/* Object/struct.scm 191 */
					 obj_t arg1623_878;
					 {	/* Object/struct.scm 191 */
					    obj_t arg1625_880;
					    {	/* Object/struct.scm 191 */
					       obj_t arg1626_881;
					       {	/* Object/struct.scm 191 */
						  obj_t arg1628_883;
						  obj_t arg1629_884;
						  arg1628_883 =
						     CNST_TABLE_REF(((long) 31));
						  {	/* Object/struct.scm 191 */
						     obj_t arg1630_885;
						     obj_t arg1631_886;
						     arg1630_885 =
							CNST_TABLE_REF(((long) 32));
						     {	/* ./Ieee/pair-list.scm 5689 */
							obj_t aux_2715;
							aux_2715 =
							   BINT(i_91);
							arg1631_886 =
							   MAKE_PAIR(aux_2715, BNIL);
						     }
						     arg1629_884 =
							MAKE_PAIR(arg1630_885, arg1631_886);
						  }
						  arg1626_881 =
						     MAKE_PAIR(arg1628_883, arg1629_884);
					       }
					       arg1625_880 =
						  MAKE_PAIR(arg1626_881, BNIL);
					    }
					    arg1623_878 =
					       MAKE_PAIR(v_870, arg1625_880);
					 }
					 arg1621_876 =
					    MAKE_PAIR(arg1623_878, BNIL);
				      }
				      {		/* Object/struct.scm 192 */
					 obj_t arg1632_887;
					 {	/* Object/struct.scm 192 */
					    obj_t arg1634_889;
					    obj_t arg1635_890;
					    arg1634_889 =
					       CNST_TABLE_REF(((long) 6));
					    {	/* Object/struct.scm 192 */
					       obj_t arg1636_891;
					       obj_t arg1637_892;
					       {	/* Object/struct.scm 192 */
						  obj_t arg1638_893;
						  {	/* Object/struct.scm 192 */
						     obj_t arg1640_895;
						     obj_t arg1641_896;
						     {	/* Object/struct.scm 192 */
							obj_t list1642_897;
							{	/* Object/struct.scm 192 */
							   obj_t arg1643_898;
							   {	/* Object/struct.scm 192 */
							      obj_t aux_2724;
							      aux_2724 =
								 CNST_TABLE_REF(((long) 30));
							      arg1643_898 =
								 MAKE_PAIR(aux_2724, BNIL);
							   }
							   list1642_897 =
							      MAKE_PAIR(len_871, arg1643_898);
							}
							arg1640_895 =
							   symbol_append_197___r4_symbols_6_4(list1642_897);
						     }
						     {	/* Object/struct.scm 192 */
							obj_t arg1644_899;
							{	/* Object/struct.scm 192 */
							   obj_t arg1647_901;
							   obj_t arg1648_902;
							   arg1647_901 =
							      CNST_TABLE_REF(((long) 33));
							   arg1648_902 =
							      MAKE_PAIR(v_870, BNIL);
							   arg1644_899 =
							      MAKE_PAIR(arg1647_901, arg1648_902);
							}
							arg1641_896 =
							   MAKE_PAIR(arg1644_899, BNIL);
						     }
						     arg1638_893 =
							MAKE_PAIR(arg1640_895, arg1641_896);
						  }
						  arg1636_891 =
						     MAKE_PAIR(arg1638_893, BNIL);
					       }
					       {	/* Object/struct.scm 196 */
						  obj_t arg1649_903;
						  obj_t arg1650_904;
						  {	/* Object/struct.scm 196 */
						     obj_t arg1651_905;
						     obj_t arg1652_906;
						     arg1651_905 =
							CNST_TABLE_REF(((long) 34));
						     {	/* Object/struct.scm 197 */
							type_bglt aux_2736;
							{	/* Object/struct.scm 197 */
							   obj_t aux_2737;
							   aux_2737 =
							      STRUCT_REF(slot_92, ((long) 2));
							   aux_2736 =
							      (type_bglt) (aux_2737);
							}
							arg1652_906 =
							   malloc_object_tools(aux_2736, len_871);
						     }
						     arg1649_903 =
							make_pragma_indexed_init_set__66_object_tools(type_90, slot_92, arg1651_905, arg1652_906);
						  }
						  {	/* Object/struct.scm 199 */
						     obj_t arg1654_908;
						     {	/* Object/struct.scm 199 */
							obj_t arg1656_910;
							obj_t arg1657_911;
							arg1656_910 =
							   CNST_TABLE_REF(((long) 9));
							{	/* Object/struct.scm 199 */
							   obj_t arg1658_912;
							   obj_t arg1659_913;
							   {	/* Object/struct.scm 199 */
							      obj_t arg1660_914;
							      {		/* Object/struct.scm 199 */
								 obj_t arg1662_916;
								 {	/* Object/struct.scm 199 */
								    obj_t arg1663_917;
								    obj_t arg1664_918;
								    arg1663_917 =
								       MAKE_PAIR(runner_typed_89_872, BNIL);
								    {	/* Object/struct.scm 200 */
								       obj_t arg1665_919;
								       {	/* Object/struct.scm 200 */
									  obj_t arg1667_921;
									  obj_t arg1669_922;
									  arg1667_921 =
									     CNST_TABLE_REF(((long) 10));
									  {	/* Object/struct.scm 200 */
									     obj_t arg1670_923;
									     obj_t arg1671_924;
									     {	/* Object/struct.scm 200 */
										obj_t arg1672_925;
										obj_t arg1673_926;
										arg1672_925 =
										   CNST_TABLE_REF(((long) 11));
										{	/* Object/struct.scm 200 */
										   obj_t arg1674_927;
										   arg1674_927 =
										      MAKE_PAIR(len_871, BNIL);
										   arg1673_926 =
										      MAKE_PAIR(runner_869, arg1674_927);
										}
										arg1670_923 =
										   MAKE_PAIR(arg1672_925, arg1673_926);
									     }
									     {	/* Object/struct.scm 201 */
										obj_t arg1675_928;
										obj_t arg1676_929;
										{	/* Object/struct.scm 201 */
										   obj_t arg1677_930;
										   obj_t arg1678_931;
										   arg1677_930 =
										      CNST_TABLE_REF(((long) 22));
										   {	/* ./Ieee/pair-list.scm 5689 */
										      obj_t aux_2750;
										      aux_2750 =
											 CNST_TABLE_REF(((long) 35));
										      arg1678_931 =
											 MAKE_PAIR(aux_2750, BNIL);
										   }
										   arg1675_928 =
										      MAKE_PAIR(arg1677_930, arg1678_931);
										}
										{	/* Object/struct.scm 202 */
										   obj_t arg1679_932;
										   {	/* Object/struct.scm 202 */
										      obj_t arg1681_934;
										      obj_t arg1682_935;
										      arg1681_934 =
											 CNST_TABLE_REF(((long) 12));
										      {		/* Object/struct.scm 206 */
											 obj_t arg1683_936;
											 obj_t arg1684_937;
											 {	/* Object/struct.scm 206 */
											    obj_t arg1685_938;
											    obj_t arg1686_939;
											    arg1685_938 =
											       CNST_TABLE_REF(((long) 34));
											    {	/* Object/struct.scm 207 */
											       obj_t arg1687_940;
											       obj_t arg1688_941;
											       arg1687_940 =
												  CNST_TABLE_REF(((long) 36));
											       {	/* Object/struct.scm 207 */
												  obj_t arg1689_942;
												  arg1689_942 =
												     MAKE_PAIR(runner_869, BNIL);
												  arg1688_941 =
												     MAKE_PAIR(v_870, arg1689_942);
											       }
											       arg1686_939 =
												  MAKE_PAIR(arg1687_940, arg1688_941);
											    }
											    arg1683_936 =
											       make_pragma_indexed_set__175_object_tools(type_90, slot_92, arg1685_938, arg1686_939, runner_869);
											 }
											 {	/* Object/struct.scm 209 */
											    obj_t arg1690_943;
											    {	/* Object/struct.scm 209 */
											       obj_t arg1692_945;
											       {	/* Object/struct.scm 209 */
												  obj_t arg1693_946;
												  {	/* Object/struct.scm 209 */
												     obj_t arg1695_948;
												     obj_t arg1696_949;
												     arg1695_948 =
													CNST_TABLE_REF(((long) 15));
												     {	/* Object/struct.scm 209 */
													obj_t arg1697_950;
													{	/* ./Ieee/pair-list.scm 5689 */
													   obj_t aux_2762;
													   aux_2762 =
													      BINT(((long) 1));
													   arg1697_950 =
													      MAKE_PAIR(aux_2762, BNIL);
													}
													arg1696_949 =
													   MAKE_PAIR(runner_869, arg1697_950);
												     }
												     arg1693_946 =
													MAKE_PAIR(arg1695_948, arg1696_949);
												  }
												  arg1692_945 =
												     MAKE_PAIR(arg1693_946, BNIL);
											       }
											       arg1690_943 =
												  MAKE_PAIR(loop_868, arg1692_945);
											    }
											    arg1684_937 =
											       MAKE_PAIR(arg1690_943, BNIL);
											 }
											 arg1682_935 =
											    MAKE_PAIR(arg1683_936, arg1684_937);
										      }
										      arg1679_932 =
											 MAKE_PAIR(arg1681_934, arg1682_935);
										   }
										   arg1676_929 =
										      MAKE_PAIR(arg1679_932, BNIL);
										}
										arg1671_924 =
										   MAKE_PAIR(arg1675_928, arg1676_929);
									     }
									     arg1669_922 =
										MAKE_PAIR(arg1670_923, arg1671_924);
									  }
									  arg1665_919 =
									     MAKE_PAIR(arg1667_921, arg1669_922);
								       }
								       arg1664_918 =
									  MAKE_PAIR(arg1665_919, BNIL);
								    }
								    arg1662_916 =
								       MAKE_PAIR(arg1663_917, arg1664_918);
								 }
								 arg1660_914 =
								    MAKE_PAIR(loop_868, arg1662_916);
							      }
							      arg1658_912 =
								 MAKE_PAIR(arg1660_914, BNIL);
							   }
							   {	/* Object/struct.scm 210 */
							      obj_t arg1698_951;
							      {		/* Object/struct.scm 210 */
								 obj_t arg1700_953;
								 {	/* ./Ieee/pair-list.scm 5689 */
								    obj_t aux_2780;
								    aux_2780 =
								       BINT(((long) 0));
								    arg1700_953 =
								       MAKE_PAIR(aux_2780, BNIL);
								 }
								 arg1698_951 =
								    MAKE_PAIR(loop_868, arg1700_953);
							      }
							      arg1659_913 =
								 MAKE_PAIR(arg1698_951, BNIL);
							   }
							   arg1657_911 =
							      MAKE_PAIR(arg1658_912, arg1659_913);
							}
							arg1654_908 =
							   MAKE_PAIR(arg1656_910, arg1657_911);
						     }
						     arg1650_904 =
							MAKE_PAIR(arg1654_908, BNIL);
						  }
						  arg1637_892 =
						     MAKE_PAIR(arg1649_903, arg1650_904);
					       }
					       arg1635_890 =
						  MAKE_PAIR(arg1636_891, arg1637_892);
					    }
					    arg1632_887 =
					       MAKE_PAIR(arg1634_889, arg1635_890);
					 }
					 arg1622_877 =
					    MAKE_PAIR(arg1632_887, BNIL);
				      }
				      arg1620_875 =
					 MAKE_PAIR(arg1621_876, arg1622_877);
				   }
				   return
				      MAKE_PAIR(arg1619_874, arg1620_875);
				}
			     }
			   else
			     {	/* Object/struct.scm 211 */
				bool_t test_2794;
				{	/* ./Llib/struct.scm 1457 */
				   obj_t aux_2795;
				   aux_2795 =
				      STRUCT_REF(slot_92, ((long) 3));
				   test_2794 =
				      CBOOL(aux_2795);
				}
				if (test_2794)
				  {	/* Object/struct.scm 211 */
				     {	/* Object/struct.scm 213 */
					obj_t arg1702_955;
					obj_t arg1703_956;
					arg1702_955 =
					   CNST_TABLE_REF(((long) 6));
					{	/* Object/struct.scm 213 */
					   obj_t arg1704_957;
					   obj_t arg1705_958;
					   {	/* Object/struct.scm 213 */
					      obj_t arg1706_959;
					      {		/* Object/struct.scm 213 */
						 obj_t arg1708_961;
						 {	/* Object/struct.scm 213 */
						    obj_t arg1709_962;
						    {	/* Object/struct.scm 213 */
						       obj_t arg1712_964;
						       obj_t arg1713_965;
						       arg1712_964 =
							  CNST_TABLE_REF(((long) 31));
						       {	/* Object/struct.scm 213 */
							  obj_t arg1714_966;
							  obj_t arg1715_967;
							  arg1714_966 =
							     CNST_TABLE_REF(((long) 32));
							  {	/* ./Ieee/pair-list.scm 5689 */
							     obj_t aux_2801;
							     aux_2801 =
								BINT(i_91);
							     arg1715_967 =
								MAKE_PAIR(aux_2801, BNIL);
							  }
							  arg1713_965 =
							     MAKE_PAIR(arg1714_966, arg1715_967);
						       }
						       arg1709_962 =
							  MAKE_PAIR(arg1712_964, arg1713_965);
						    }
						    arg1708_961 =
						       MAKE_PAIR(arg1709_962, BNIL);
						 }
						 arg1706_959 =
						    MAKE_PAIR(v_870, arg1708_961);
					      }
					      arg1704_957 =
						 MAKE_PAIR(arg1706_959, BNIL);
					   }
					   {	/* Object/struct.scm 214 */
					      obj_t arg1716_968;
					      {		/* Object/struct.scm 214 */
						 obj_t arg1718_970;
						 obj_t arg1719_971;
						 arg1718_970 =
						    CNST_TABLE_REF(((long) 9));
						 {	/* Object/struct.scm 214 */
						    obj_t arg1720_972;
						    obj_t arg1721_973;
						    {	/* Object/struct.scm 214 */
						       obj_t arg1722_974;
						       {	/* Object/struct.scm 214 */
							  obj_t arg1724_976;
							  {	/* Object/struct.scm 214 */
							     obj_t arg1725_977;
							     obj_t arg1726_978;
							     arg1725_977 =
								MAKE_PAIR(runner_typed_89_872, BNIL);
							     {	/* Object/struct.scm 215 */
								obj_t arg1727_979;
								{	/* Object/struct.scm 215 */
								   obj_t arg1729_981;
								   obj_t arg1730_982;
								   arg1729_981 =
								      CNST_TABLE_REF(((long) 10));
								   {	/* Object/struct.scm 215 */
								      obj_t arg1731_983;
								      obj_t arg1732_984;
								      {		/* Object/struct.scm 215 */
									 obj_t arg1733_985;
									 obj_t arg1734_986;
									 arg1733_985 =
									    CNST_TABLE_REF(((long) 11));
									 {	/* Object/struct.scm 216 */
									    obj_t arg1735_987;
									    {	/* Object/struct.scm 216 */
									       obj_t arg1736_988;
									       {	/* Object/struct.scm 216 */
										  obj_t arg1739_990;
										  obj_t arg1740_991;
										  arg1739_990 =
										     CNST_TABLE_REF(((long) 7));
										  {	/* ./Ieee/pair-list.scm 5689 */
										     obj_t aux_2814;
										     aux_2814 =
											STRUCT_REF(slot_92, ((long) 4));
										     arg1740_991 =
											MAKE_PAIR(aux_2814, BNIL);
										  }
										  arg1736_988 =
										     MAKE_PAIR(arg1739_990, arg1740_991);
									       }
									       arg1735_987 =
										  MAKE_PAIR(arg1736_988, BNIL);
									    }
									    arg1734_986 =
									       MAKE_PAIR(runner_869, arg1735_987);
									 }
									 arg1731_983 =
									    MAKE_PAIR(arg1733_985, arg1734_986);
								      }
								      {		/* Object/struct.scm 217 */
									 obj_t arg1743_994;
									 obj_t arg1744_995;
									 {	/* Object/struct.scm 217 */
									    obj_t arg1745_996;
									    obj_t arg1746_997;
									    arg1745_996 =
									       CNST_TABLE_REF(((long) 22));
									    {	/* ./Ieee/pair-list.scm 5689 */
									       obj_t aux_2822;
									       aux_2822 =
										  CNST_TABLE_REF(((long) 35));
									       arg1746_997 =
										  MAKE_PAIR(aux_2822, BNIL);
									    }
									    arg1743_994 =
									       MAKE_PAIR(arg1745_996, arg1746_997);
									 }
									 {	/* Object/struct.scm 218 */
									    obj_t arg1747_998;
									    {	/* Object/struct.scm 218 */
									       obj_t arg1749_1000;
									       obj_t arg1750_1001;
									       arg1749_1000 =
										  CNST_TABLE_REF(((long) 12));
									       {	/* Object/struct.scm 222 */
										  obj_t arg1751_1002;
										  obj_t arg1752_1003;
										  {	/* Object/struct.scm 222 */
										     obj_t arg1753_1004;
										     obj_t arg1754_1005;
										     arg1753_1004 =
											CNST_TABLE_REF(((long) 34));
										     {	/* Object/struct.scm 223 */
											obj_t arg1755_1006;
											obj_t arg1756_1007;
											arg1755_1006 =
											   CNST_TABLE_REF(((long) 36));
											{	/* Object/struct.scm 223 */
											   obj_t arg1758_1008;
											   arg1758_1008 =
											      MAKE_PAIR(runner_869, BNIL);
											   arg1756_1007 =
											      MAKE_PAIR(v_870, arg1758_1008);
											}
											arg1754_1005 =
											   MAKE_PAIR(arg1755_1006, arg1756_1007);
										     }
										     arg1751_1002 =
											make_pragma_indexed_set__175_object_tools(type_90, slot_92, arg1753_1004, arg1754_1005, runner_869);
										  }
										  {	/* Object/struct.scm 225 */
										     obj_t arg1759_1009;
										     {	/* Object/struct.scm 225 */
											obj_t arg1761_1011;
											{	/* Object/struct.scm 225 */
											   obj_t arg1762_1012;
											   {	/* Object/struct.scm 225 */
											      obj_t arg1764_1014;
											      obj_t arg1765_1015;
											      arg1764_1014 =
												 CNST_TABLE_REF(((long) 15));
											      {		/* Object/struct.scm 225 */
												 obj_t arg1766_1016;
												 {	/* ./Ieee/pair-list.scm 5689 */
												    obj_t aux_2834;
												    aux_2834 =
												       BINT(((long) 1));
												    arg1766_1016 =
												       MAKE_PAIR(aux_2834, BNIL);
												 }
												 arg1765_1015 =
												    MAKE_PAIR(runner_869, arg1766_1016);
											      }
											      arg1762_1012 =
												 MAKE_PAIR(arg1764_1014, arg1765_1015);
											   }
											   arg1761_1011 =
											      MAKE_PAIR(arg1762_1012, BNIL);
											}
											arg1759_1009 =
											   MAKE_PAIR(loop_868, arg1761_1011);
										     }
										     arg1752_1003 =
											MAKE_PAIR(arg1759_1009, BNIL);
										  }
										  arg1750_1001 =
										     MAKE_PAIR(arg1751_1002, arg1752_1003);
									       }
									       arg1747_998 =
										  MAKE_PAIR(arg1749_1000, arg1750_1001);
									    }
									    arg1744_995 =
									       MAKE_PAIR(arg1747_998, BNIL);
									 }
									 arg1732_984 =
									    MAKE_PAIR(arg1743_994, arg1744_995);
								      }
								      arg1730_982 =
									 MAKE_PAIR(arg1731_983, arg1732_984);
								   }
								   arg1727_979 =
								      MAKE_PAIR(arg1729_981, arg1730_982);
								}
								arg1726_978 =
								   MAKE_PAIR(arg1727_979, BNIL);
							     }
							     arg1724_976 =
								MAKE_PAIR(arg1725_977, arg1726_978);
							  }
							  arg1722_974 =
							     MAKE_PAIR(loop_868, arg1724_976);
						       }
						       arg1720_972 =
							  MAKE_PAIR(arg1722_974, BNIL);
						    }
						    {	/* Object/struct.scm 226 */
						       obj_t arg1767_1017;
						       {	/* Object/struct.scm 226 */
							  obj_t arg1769_1019;
							  {	/* ./Ieee/pair-list.scm 5689 */
							     obj_t aux_2852;
							     aux_2852 =
								BINT(((long) 0));
							     arg1769_1019 =
								MAKE_PAIR(aux_2852, BNIL);
							  }
							  arg1767_1017 =
							     MAKE_PAIR(loop_868, arg1769_1019);
						       }
						       arg1721_973 =
							  MAKE_PAIR(arg1767_1017, BNIL);
						    }
						    arg1719_971 =
						       MAKE_PAIR(arg1720_972, arg1721_973);
						 }
						 arg1716_968 =
						    MAKE_PAIR(arg1718_970, arg1719_971);
					      }
					      arg1705_958 =
						 MAKE_PAIR(arg1716_968, BNIL);
					   }
					   arg1703_956 =
					      MAKE_PAIR(arg1704_957, arg1705_958);
					}
					return
					   MAKE_PAIR(arg1702_955, arg1703_956);
				     }
				  }
				else
				  {	/* Object/struct.scm 227 */
				     bool_t test_2862;
				     {	/* ./Llib/struct.scm 1457 */
					obj_t aux_2863;
					aux_2863 =
					   STRUCT_REF(slot_92, ((long) 11));
					test_2862 =
					   CBOOL(aux_2863);
				     }
				     if (test_2862)
				       {	/* Object/struct.scm 227 */
					  return BUNSPEC;
				       }
				     else
				       {	/* Object/struct.scm 227 */
					  {	/* Object/struct.scm 230 */
					     obj_t arg1771_1021;
					     obj_t arg1772_1022;
					     arg1771_1021 =
						CNST_TABLE_REF(((long) 6));
					     {	/* Object/struct.scm 230 */
						obj_t arg1773_1023;
						obj_t arg1774_1024;
						{	/* Object/struct.scm 230 */
						   obj_t arg1775_1025;
						   {	/* Object/struct.scm 230 */
						      obj_t arg1777_1027;
						      obj_t arg1778_1028;
						      {		/* Object/struct.scm 230 */
							 obj_t list1780_1030;
							 {	/* Object/struct.scm 230 */
							    obj_t arg1781_1031;
							    {	/* Object/struct.scm 230 */
							       obj_t arg1782_1032;
							       {	/* Object/struct.scm 230 */
								  obj_t aux_2867;
								  {	/* Object/struct.scm 230 */
								     type_bglt obj_2028;
								     {	/* Object/struct.scm 230 */
									obj_t aux_2868;
									aux_2868 =
									   STRUCT_REF(slot_92, ((long) 2));
									obj_2028 =
									   (type_bglt) (aux_2868);
								     }
								     aux_2867 =
									(((type_bglt) CREF(obj_2028))->id);
								  }
								  arg1782_1032 =
								     MAKE_PAIR(aux_2867, BNIL);
							       }
							       arg1781_1031 =
								  MAKE_PAIR(_4dots_199_tools_misc, arg1782_1032);
							    }
							    list1780_1030 =
							       MAKE_PAIR(v_870, arg1781_1031);
							 }
							 arg1777_1027 =
							    symbol_append_197___r4_symbols_6_4(list1780_1030);
						      }
						      {		/* Object/struct.scm 231 */
							 obj_t arg1784_1034;
							 {	/* Object/struct.scm 231 */
							    obj_t arg1786_1036;
							    obj_t arg1787_1037;
							    arg1786_1036 =
							       CNST_TABLE_REF(((long) 31));
							    {	/* Object/struct.scm 231 */
							       obj_t arg1788_1038;
							       obj_t arg1789_1039;
							       arg1788_1038 =
								  CNST_TABLE_REF(((long) 32));
							       {	/* ./Ieee/pair-list.scm 5689 */
								  obj_t aux_2878;
								  aux_2878 =
								     BINT(i_91);
								  arg1789_1039 =
								     MAKE_PAIR(aux_2878, BNIL);
							       }
							       arg1787_1037 =
								  MAKE_PAIR(arg1788_1038, arg1789_1039);
							    }
							    arg1784_1034 =
							       MAKE_PAIR(arg1786_1036, arg1787_1037);
							 }
							 arg1778_1028 =
							    MAKE_PAIR(arg1784_1034, BNIL);
						      }
						      arg1775_1025 =
							 MAKE_PAIR(arg1777_1027, arg1778_1028);
						   }
						   arg1773_1023 =
						      MAKE_PAIR(arg1775_1025, BNIL);
						}
						{	/* Object/struct.scm 232 */
						   obj_t arg1790_1040;
						   arg1790_1040 =
						      make_pragma_direct_set__7_object_tools(type_90, slot_92,
						      CNST_TABLE_REF(((long) 34)), v_870);
						   arg1774_1024 =
						      MAKE_PAIR(arg1790_1040, BNIL);
						}
						arg1772_1022 =
						   MAKE_PAIR(arg1773_1023, arg1774_1024);
					     }
					     return
						MAKE_PAIR(arg1771_1021, arg1772_1022);
					  }
				       }
				  }
			     }
			}
		     }
		  }
	       }
	    }
	 }
      }
   }
}



/* make-struct->object */
obj_t 
make_struct__object_35_object_struct(obj_t cname_93, type_bglt type_94, obj_t module_95, obj_t slots_96, obj_t src_def_101_97)
{
   AN_OBJECT;
   {	/* Object/struct.scm 243 */
      {		/* Object/struct.scm 245 */
	 obj_t arg1794_1044;
	 {	/* Object/struct.scm 245 */
	    obj_t arg1795_1045;
	    obj_t arg1796_1046;
	    arg1795_1045 =
	       CNST_TABLE_REF(((long) 19));
	    {	/* Object/struct.scm 245 */
	       obj_t arg1797_1047;
	       obj_t arg1798_1048;
	       {	/* Object/struct.scm 245 */
		  obj_t arg1800_1049;
		  obj_t arg1801_1050;
		  arg1800_1049 =
		     CNST_TABLE_REF(((long) 37));
		  {	/* Object/struct.scm 245 */
		     obj_t arg1802_1051;
		     obj_t arg1803_1052;
		     {	/* Object/struct.scm 245 */
			obj_t list1804_1053;
			{	/* Object/struct.scm 245 */
			   obj_t arg1805_1054;
			   obj_t arg1806_1055;
			   arg1805_1054 =
			      CNST_TABLE_REF(((long) 34));
			   {	/* Object/struct.scm 245 */
			      obj_t arg1807_1056;
			      arg1807_1056 =
				 MAKE_PAIR(cname_93, BNIL);
			      arg1806_1055 =
				 MAKE_PAIR(_4dots_199_tools_misc, arg1807_1056);
			   }
			   list1804_1053 =
			      MAKE_PAIR(arg1805_1054, arg1806_1055);
			}
			arg1802_1051 =
			   symbol_append_197___r4_symbols_6_4(list1804_1053);
		     }
		     {	/* ./Ieee/pair-list.scm 5689 */
			obj_t aux_2898;
			aux_2898 =
			   CNST_TABLE_REF(((long) 38));
			arg1803_1052 =
			   MAKE_PAIR(aux_2898, BNIL);
		     }
		     arg1801_1050 =
			MAKE_PAIR(arg1802_1051, arg1803_1052);
		  }
		  arg1797_1047 =
		     MAKE_PAIR(arg1800_1049, arg1801_1050);
	       }
	       {	/* Object/struct.scm 249 */
		  obj_t arg1809_1057;
		  {	/* Object/struct.scm 249 */
		     obj_t arg1811_1059;
		     obj_t arg1812_1060;
		     arg1811_1059 =
			CNST_TABLE_REF(((long) 12));
		     {	/* Object/struct.scm 250 */
			obj_t arg1813_1061;
			obj_t arg1814_1062;
			{	/* Object/struct.scm 250 */
			   obj_t arg1815_1063;
			   obj_t arg1816_1064;
			   arg1815_1063 =
			      CNST_TABLE_REF(((long) 39));
			   {	/* Object/struct.scm 250 */
			      obj_t arg1817_1065;
			      obj_t arg1818_1066;
			      arg1817_1065 =
				 CNST_TABLE_REF(((long) 34));
			      {		/* Object/struct.scm 250 */
				 obj_t arg1820_1067;
				 {	/* Object/struct.scm 250 */
				    obj_t arg1822_1069;
				    obj_t arg1823_1070;
				    arg1822_1069 =
				       CNST_TABLE_REF(((long) 31));
				    {	/* Object/struct.scm 250 */
				       obj_t arg1824_1071;
				       obj_t arg1825_1072;
				       arg1824_1071 =
					  CNST_TABLE_REF(((long) 32));
				       {	/* ./Ieee/pair-list.scm 5689 */
					  obj_t aux_2908;
					  aux_2908 =
					     BINT(((long) 0));
					  arg1825_1072 =
					     MAKE_PAIR(aux_2908, BNIL);
				       }
				       arg1823_1070 =
					  MAKE_PAIR(arg1824_1071, arg1825_1072);
				    }
				    arg1820_1067 =
				       MAKE_PAIR(arg1822_1069, arg1823_1070);
				 }
				 arg1818_1066 =
				    MAKE_PAIR(arg1820_1067, BNIL);
			      }
			      arg1816_1064 =
				 MAKE_PAIR(arg1817_1065, arg1818_1066);
			   }
			   arg1813_1061 =
			      MAKE_PAIR(arg1815_1063, arg1816_1064);
			}
			{	/* Object/struct.scm 251 */
			   obj_t arg1826_1073;
			   obj_t arg1827_1074;
			   {
			      long i_1075;
			      obj_t slots_1076;
			      obj_t res_1077;
			      i_1075 = ((long) 1);
			      slots_1076 = slots_96;
			      res_1077 = BNIL;
			    loop_1078:
			      if (
				 NULLP(slots_1076))
				{	/* Object/struct.scm 255 */
				   arg1826_1073 =
				      reverse__39___r4_pairs_and_lists_6_3(res_1077);
				}
			      else
				{	/* Object/struct.scm 257 */
				   bool_t test_2919;
				   {	/* ./Llib/struct.scm 1457 */
				      obj_t aux_2920;
				      {		/* ./Llib/struct.scm 1457 */
					 obj_t aux_2921;
					 aux_2921 =
					    CAR(slots_1076);
					 aux_2920 =
					    STRUCT_REF(aux_2921, ((long) 11));
				      }
				      test_2919 =
					 CBOOL(aux_2920);
				   }
				   if (test_2919)
				     {	/* Object/struct.scm 257 */
					{
					   obj_t slots_2927;
					   long i_2925;
					   i_2925 =
					      (i_1075 + ((long) 1));
					   slots_2927 =
					      CDR(slots_1076);
					   slots_1076 = slots_2927;
					   i_1075 = i_2925;
					   goto loop_1078;
					}
				     }
				   else
				     {	/* Object/struct.scm 257 */
					{	/* Object/struct.scm 262 */
					   obj_t new_1083;
					   new_1083 =
					      restore_slot_6_object_struct(
					      CNST_TABLE_REF(((long) 34)),
					      CNST_TABLE_REF(((long) 32)), cname_93, type_94, i_1075,
					      CAR(slots_1076));
					   {	/* Object/struct.scm 263 */
					      long arg1832_1084;
					      obj_t arg1833_1085;
					      obj_t arg1834_1086;
					      arg1832_1084 =
						 (i_1075 + ((long) 1));
					      arg1833_1085 =
						 CDR(slots_1076);
					      arg1834_1086 =
						 MAKE_PAIR(new_1083, res_1077);
					      {
						 obj_t res_2938;
						 obj_t slots_2937;
						 long i_2936;
						 i_2936 = arg1832_1084;
						 slots_2937 = arg1833_1085;
						 res_2938 = arg1834_1086;
						 res_1077 = res_2938;
						 slots_1076 = slots_2937;
						 i_1075 = i_2936;
						 goto loop_1078;
					      }
					   }
					}
				     }
				}
			   }
			   {	/* ./Ieee/pair-list.scm 5689 */
			      obj_t aux_2939;
			      aux_2939 =
				 CNST_TABLE_REF(((long) 34));
			      arg1827_1074 =
				 MAKE_PAIR(aux_2939, BNIL);
			   }
			   arg1814_1062 =
			      append_2_18___r4_pairs_and_lists_6_3(arg1826_1073, arg1827_1074);
			}
			arg1812_1060 =
			   MAKE_PAIR(arg1813_1061, arg1814_1062);
		     }
		     arg1809_1057 =
			MAKE_PAIR(arg1811_1059, arg1812_1060);
		  }
		  arg1798_1048 =
		     MAKE_PAIR(arg1809_1057, BNIL);
	       }
	       arg1796_1046 =
		  MAKE_PAIR(arg1797_1047, arg1798_1048);
	    }
	    arg1794_1044 =
	       MAKE_PAIR(arg1795_1045, arg1796_1046);
	 }
	 return
	    epairify_tools_misc(arg1794_1044, src_def_101_97);
      }
   }
}



/* _make-struct->object1984 */
obj_t 
_make_struct__object1984_115_object_struct(obj_t env_2240, obj_t cname_2241, obj_t type_2242, obj_t module_2243, obj_t slots_2244, obj_t src_def_101_2245)
{
   AN_OBJECT;
   {	/* Object/struct.scm 243 */
      return
	 make_struct__object_35_object_struct(cname_2241,
	 (type_bglt) (type_2242), module_2243, slots_2244, src_def_101_2245);
   }
}



/* make-struct->wide-object */
obj_t 
make_struct__wide_object_7_object_struct(obj_t cname_98, type_bglt type_99, obj_t module_100, obj_t slots_101, obj_t src_def_101_102)
{
   AN_OBJECT;
   {	/* Object/struct.scm 272 */
      {		/* Object/struct.scm 273 */
	 obj_t old_1091;
	 old_1091 =
	    PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4,
	    CNST_TABLE_REF(((long) 40)), BEOA);
	 {	/* Object/struct.scm 273 */
	    long len_1092;
	    len_1092 =
	       slots_length_21_object_struct(slots_101);
	    {	/* Object/struct.scm 274 */
	       obj_t aux_1093;
	       aux_1093 =
		  PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4,
		  CNST_TABLE_REF(((long) 24)), BEOA);
	       {	/* Object/struct.scm 275 */
		  obj_t taux_1094;
		  {	/* Object/struct.scm 276 */
		     obj_t list1950_1208;
		     {	/* Object/struct.scm 276 */
			obj_t arg1951_1209;
			{	/* Object/struct.scm 276 */
			   obj_t aux_2958;
			   aux_2958 =
			      CNST_TABLE_REF(((long) 23));
			   arg1951_1209 =
			      MAKE_PAIR(aux_2958, BNIL);
			}
			list1950_1208 =
			   MAKE_PAIR(aux_1093, arg1951_1209);
		     }
		     taux_1094 =
			symbol_append_197___r4_symbols_6_4(list1950_1208);
		  }
		  {	/* Object/struct.scm 276 */
		     obj_t new_1095;
		     new_1095 =
			PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4,
			CNST_TABLE_REF(((long) 41)), BEOA);
		     {	/* Object/struct.scm 277 */
			obj_t tid_1096;
			tid_1096 =
			   (((type_bglt) CREF(type_99))->id);
			{	/* Object/struct.scm 278 */
			   global_bglt holder_1097;
			   {	/* Object/struct.scm 279 */
			      tclass_bglt obj_2092;
			      obj_2092 =
				 (tclass_bglt) (type_99);
			      {
				 obj_t aux_2968;
				 {	/* ./Object/class.scm 1283 */
				    object_bglt aux_2969;
				    aux_2969 =
				       (object_bglt) (obj_2092);
				    aux_2968 =
				       OBJECT_WIDENING(aux_2969);
				 }
				 holder_1097 =
				    (((tclass_bglt) CREF(aux_2968))->holder);
			      }
			   }
			   {	/* Object/struct.scm 279 */
			      obj_t widening_1098;
			      {		/* Object/struct.scm 280 */
				 obj_t arg1944_1202;
				 obj_t arg1945_1203;
				 {	/* Object/struct.scm 280 */
				    tclass_bglt obj_2093;
				    obj_2093 =
				       (tclass_bglt) (type_99);
				    {
				       obj_t aux_2974;
				       {	/* ./Object/class.scm 1285 */
					  object_bglt aux_2975;
					  aux_2975 =
					     (object_bglt) (obj_2093);
					  aux_2974 =
					     OBJECT_WIDENING(aux_2975);
				       }
				       arg1944_1202 =
					  (((tclass_bglt) CREF(aux_2974))->widening);
				    }
				 }
				 arg1945_1203 =
				    CNST_TABLE_REF(((long) 1));
				 {	/* Object/struct.scm 280 */
				    obj_t list1947_1205;
				    {	/* Object/struct.scm 280 */
				       obj_t arg1948_1206;
				       {	/* Object/struct.scm 280 */
					  obj_t arg1949_1207;
					  {	/* Object/struct.scm 280 */
					     obj_t aux_2980;
					     aux_2980 =
						(((type_bglt) CREF(type_99))->id);
					     arg1949_1207 =
						MAKE_PAIR(aux_2980, BNIL);
					  }
					  arg1948_1206 =
					     MAKE_PAIR(arg1945_1203, arg1949_1207);
				       }
				       list1947_1205 =
					  MAKE_PAIR(arg1944_1202, arg1948_1206);
				    }
				    widening_1098 =
				       symbol_append_197___r4_symbols_6_4(list1947_1205);
				 }
			      }
			      {		/* Object/struct.scm 280 */

				 {	/* Object/struct.scm 284 */
				    obj_t arg1841_1099;
				    {	/* Object/struct.scm 284 */
				       obj_t arg1842_1100;
				       obj_t arg1843_1101;
				       arg1842_1100 =
					  CNST_TABLE_REF(((long) 19));
				       {	/* Object/struct.scm 284 */
					  obj_t arg1844_1102;
					  obj_t arg1845_1103;
					  {	/* Object/struct.scm 284 */
					     obj_t arg1846_1104;
					     obj_t arg1847_1105;
					     arg1846_1104 =
						CNST_TABLE_REF(((long) 37));
					     {	/* Object/struct.scm 285 */
						obj_t arg1848_1106;
						obj_t arg1849_1107;
						{	/* Object/struct.scm 285 */
						   obj_t list1850_1108;
						   {	/* Object/struct.scm 285 */
						      obj_t arg1851_1109;
						      obj_t arg1852_1110;
						      arg1851_1109 =
							 CNST_TABLE_REF(((long) 34));
						      {		/* Object/struct.scm 285 */
							 obj_t arg1853_1111;
							 arg1853_1111 =
							    MAKE_PAIR(cname_98, BNIL);
							 arg1852_1110 =
							    MAKE_PAIR(_4dots_199_tools_misc, arg1853_1111);
						      }
						      list1850_1108 =
							 MAKE_PAIR(arg1851_1109, arg1852_1110);
						   }
						   arg1848_1106 =
						      symbol_append_197___r4_symbols_6_4(list1850_1108);
						}
						{	/* ./Ieee/pair-list.scm 5689 */
						   obj_t aux_2993;
						   aux_2993 =
						      CNST_TABLE_REF(((long) 38));
						   arg1849_1107 =
						      MAKE_PAIR(aux_2993, BNIL);
						}
						arg1847_1105 =
						   MAKE_PAIR(arg1848_1106, arg1849_1107);
					     }
					     arg1844_1102 =
						MAKE_PAIR(arg1846_1104, arg1847_1105);
					  }
					  {	/* Object/struct.scm 287 */
					     obj_t arg1854_1112;
					     {	/* Object/struct.scm 287 */
						obj_t arg1856_1114;
						obj_t arg1857_1115;
						arg1856_1114 =
						   CNST_TABLE_REF(((long) 6));
						{	/* Object/struct.scm 287 */
						   obj_t arg1858_1116;
						   obj_t arg1859_1117;
						   {	/* Object/struct.scm 287 */
						      obj_t arg1860_1118;
						      obj_t arg1861_1119;
						      {		/* Object/struct.scm 287 */
							 obj_t arg1862_1120;
							 {	/* Object/struct.scm 287 */
							    obj_t arg1863_1121;
							    {	/* ./Ieee/pair-list.scm 5689 */
							       obj_t aux_2999;
							       aux_2999 =
								  CNST_TABLE_REF(((long) 25));
							       arg1863_1121 =
								  MAKE_PAIR(aux_2999, BNIL);
							    }
							    arg1862_1120 =
							       MAKE_PAIR(arg1863_1121, BNIL);
							 }
							 arg1860_1118 =
							    MAKE_PAIR(old_1091, arg1862_1120);
						      }
						      {		/* Object/struct.scm 288 */
							 obj_t arg1865_1123;
							 {	/* Object/struct.scm 288 */
							    obj_t arg1867_1125;
							    {	/* Object/struct.scm 288 */
							       obj_t arg1868_1126;
							       {	/* Object/struct.scm 288 */
								  obj_t arg1870_1128;
								  obj_t arg1871_1129;
								  arg1870_1128 =
								     CNST_TABLE_REF(((long) 31));
								  {	/* Object/struct.scm 288 */
								     obj_t arg1872_1130;
								     obj_t arg1873_1131;
								     arg1872_1130 =
									CNST_TABLE_REF(((long) 32));
								     {	/* ./Ieee/pair-list.scm 5689 */
									obj_t aux_3006;
									aux_3006 =
									   BINT(((long) 0));
									arg1873_1131 =
									   MAKE_PAIR(aux_3006, BNIL);
								     }
								     arg1871_1129 =
									MAKE_PAIR(arg1872_1130, arg1873_1131);
								  }
								  arg1868_1126 =
								     MAKE_PAIR(arg1870_1128, arg1871_1129);
							       }
							       arg1867_1125 =
								  MAKE_PAIR(arg1868_1126, BNIL);
							    }
							    arg1865_1123 =
							       MAKE_PAIR(taux_1094, arg1867_1125);
							 }
							 arg1861_1119 =
							    MAKE_PAIR(arg1865_1123, BNIL);
						      }
						      arg1858_1116 =
							 MAKE_PAIR(arg1860_1118, arg1861_1119);
						   }
						   {	/* Object/struct.scm 289 */
						      obj_t arg1874_1132;
						      {		/* Object/struct.scm 289 */
							 obj_t arg1876_1134;
							 obj_t arg1877_1135;
							 arg1876_1134 =
							    CNST_TABLE_REF(((long) 6));
							 {	/* Object/struct.scm 289 */
							    obj_t arg1879_1136;
							    obj_t arg1880_1137;
							    {	/* Object/struct.scm 289 */
							       obj_t arg1881_1138;
							       {	/* Object/struct.scm 289 */
								  obj_t arg1883_1140;
								  obj_t arg1884_1141;
								  {	/* Object/struct.scm 289 */
								     obj_t list1885_1142;
								     {	/* Object/struct.scm 289 */
									obj_t arg1886_1143;
									{	/* Object/struct.scm 289 */
									   obj_t arg1887_1144;
									   arg1887_1144 =
									      MAKE_PAIR(tid_1096, BNIL);
									   arg1886_1143 =
									      MAKE_PAIR(_4dots_199_tools_misc, arg1887_1144);
									}
									list1885_1142 =
									   MAKE_PAIR(new_1095, arg1886_1143);
								     }
								     arg1883_1140 =
									symbol_append_197___r4_symbols_6_4(list1885_1142);
								  }
								  {	/* Object/struct.scm 290 */
								     obj_t arg1888_1145;
								     {	/* Object/struct.scm 290 */
									obj_t arg1890_1147;
									obj_t arg1891_1148;
									{	/* Object/struct.scm 290 */
									   obj_t list1892_1149;
									   {	/* Object/struct.scm 290 */
									      obj_t arg1893_1150;
									      obj_t arg1894_1151;
									      arg1893_1150 =
										 CNST_TABLE_REF(((long) 42));
									      {		/* Object/struct.scm 290 */
										 obj_t arg1895_1152;
										 arg1895_1152 =
										    MAKE_PAIR(tid_1096, BNIL);
										 arg1894_1151 =
										    MAKE_PAIR(_4dots_199_tools_misc, arg1895_1152);
									      }
									      list1892_1149 =
										 MAKE_PAIR(arg1893_1150, arg1894_1151);
									   }
									   arg1890_1147 =
									      symbol_append_197___r4_symbols_6_4(list1892_1149);
									}
									{	/* Object/struct.scm 291 */
									   obj_t arg1896_1153;
									   obj_t arg1897_1154;
									   {	/* Object/struct.scm 291 */
									      obj_t arg1899_1156;
									      {		/* Object/struct.scm 291 */
										 obj_t aux_3025;
										 aux_3025 =
										    (((type_bglt) CREF(type_99))->name);
										 arg1899_1156 =
										    string_append(aux_3025, string1986_object_struct);
									      }
									      arg1896_1153 =
										 string_append(string1987_object_struct, arg1899_1156);
									   }
									   arg1897_1154 =
									      MAKE_PAIR(old_1091, BNIL);
									   arg1891_1148 =
									      MAKE_PAIR(arg1896_1153, arg1897_1154);
									}
									arg1888_1145 =
									   MAKE_PAIR(arg1890_1147, arg1891_1148);
								     }
								     arg1884_1141 =
									MAKE_PAIR(arg1888_1145, BNIL);
								  }
								  arg1881_1138 =
								     MAKE_PAIR(arg1883_1140, arg1884_1141);
							       }
							       arg1879_1136 =
								  MAKE_PAIR(arg1881_1138, BNIL);
							    }
							    {	/* Object/struct.scm 293 */
							       obj_t arg1902_1159;
							       obj_t arg1903_1160;
							       {	/* Object/struct.scm 293 */
								  obj_t arg1904_1161;
								  obj_t arg1905_1162;
								  arg1904_1161 =
								     CNST_TABLE_REF(((long) 43));
								  {	/* Object/struct.scm 294 */
								     obj_t arg1906_1163;
								     {	/* Object/struct.scm 294 */
									obj_t arg1907_1164;
									{	/* Object/struct.scm 294 */
									   obj_t arg1910_1166;
									   obj_t arg1912_1167;
									   arg1910_1166 =
									      CNST_TABLE_REF(((long) 44));
									   {	/* Object/struct.scm 295 */
									      obj_t arg1913_1168;
									      {		/* Object/struct.scm 295 */
										 obj_t arg1915_1170;
										 obj_t arg1916_1171;
										 arg1915_1170 =
										    CNST_TABLE_REF(((long) 45));
										 {	/* Object/struct.scm 295 */
										    obj_t arg1917_1172;
										    obj_t arg1919_1173;
										    arg1917_1172 =
										       (((global_bglt) CREF(holder_1097))->id);
										    {	/* ./Ieee/pair-list.scm 5689 */
										       obj_t aux_3039;
										       aux_3039 =
											  (((global_bglt) CREF(holder_1097))->module);
										       arg1919_1173 =
											  MAKE_PAIR(aux_3039, BNIL);
										    }
										    arg1916_1171 =
										       MAKE_PAIR(arg1917_1172, arg1919_1173);
										 }
										 arg1913_1168 =
										    MAKE_PAIR(arg1915_1170, arg1916_1171);
									      }
									      arg1912_1167 =
										 MAKE_PAIR(arg1913_1168, BNIL);
									   }
									   arg1907_1164 =
									      MAKE_PAIR(arg1910_1166, arg1912_1167);
									}
									arg1906_1163 =
									   MAKE_PAIR(arg1907_1164, BNIL);
								     }
								     arg1905_1162 =
									MAKE_PAIR(new_1095, arg1906_1163);
								  }
								  arg1902_1159 =
								     MAKE_PAIR(arg1904_1161, arg1905_1162);
							       }
							       {	/* Object/struct.scm 297 */
								  obj_t arg1922_1176;
								  obj_t arg1923_1177;
								  {	/* Object/struct.scm 297 */
								     obj_t arg1924_1178;
								     obj_t arg1925_1179;
								     arg1924_1178 =
									CNST_TABLE_REF(((long) 39));
								     {	/* Object/struct.scm 299 */
									obj_t arg1926_1180;
									{	/* Object/struct.scm 299 */
									   obj_t arg1927_1181;
									   {	/* Object/struct.scm 299 */
									      obj_t arg1929_1183;
									      {		/* Object/struct.scm 299 */
										 obj_t arg1930_1184;
										 {
										    long i_1186;
										    obj_t slots_1187;
										    obj_t ref__130_1188;
										    i_1186 = ((long) 0);
										    slots_1187 = slots_101;
										    ref__130_1188 = BNIL;
										  loop_1189:
										    if (
										       (i_1186 == len_1092))
										      {		/* Object/struct.scm 303 */
											 arg1930_1184 =
											    reverse__39___r4_pairs_and_lists_6_3(ref__130_1188);
										      }
										    else
										      {		/* Object/struct.scm 305 */
											 bool_t test_3053;
											 {	/* ./Llib/struct.scm 1457 */
											    obj_t aux_3054;
											    {	/* ./Llib/struct.scm 1457 */
											       obj_t aux_3055;
											       aux_3055 =
												  CAR(slots_1187);
											       aux_3054 =
												  STRUCT_REF(aux_3055, ((long) 11));
											    }
											    test_3053 =
											       CBOOL(aux_3054);
											 }
											 if (test_3053)
											   {	/* Object/struct.scm 305 */
											      {
												 obj_t slots_3061;
												 long i_3059;
												 i_3059 =
												    (i_1186 + ((long) 1));
												 slots_3061 =
												    CDR(slots_1187);
												 slots_1187 = slots_3061;
												 i_1186 = i_3059;
												 goto loop_1189;
											      }
											   }
											 else
											   {	/* Object/struct.scm 305 */
											      {		/* Object/struct.scm 310 */
												 long arg1936_1194;
												 obj_t arg1937_1195;
												 obj_t arg1938_1196;
												 arg1936_1194 =
												    (i_1186 + ((long) 1));
												 arg1937_1195 =
												    CDR(slots_1187);
												 {	/* Object/struct.scm 312 */
												    obj_t arg1939_1197;
												    {	/* Object/struct.scm 312 */
												       obj_t arg1940_1198;
												       obj_t arg1941_1199;
												       arg1940_1198 =
													  CNST_TABLE_REF(((long) 31));
												       {	/* Object/struct.scm 312 */
													  obj_t arg1942_1200;
													  {	/* ./Ieee/pair-list.scm 5689 */
													     obj_t aux_3066;
													     aux_3066 =
														BINT(i_1186);
													     arg1942_1200 =
														MAKE_PAIR(aux_3066, BNIL);
													  }
													  arg1941_1199 =
													     MAKE_PAIR(aux_1093, arg1942_1200);
												       }
												       arg1939_1197 =
													  MAKE_PAIR(arg1940_1198, arg1941_1199);
												    }
												    arg1938_1196 =
												       MAKE_PAIR(arg1939_1197, ref__130_1188);
												 }
												 {
												    obj_t ref__130_3074;
												    obj_t slots_3073;
												    long i_3072;
												    i_3072 = arg1936_1194;
												    slots_3073 = arg1937_1195;
												    ref__130_3074 = arg1938_1196;
												    ref__130_1188 = ref__130_3074;
												    slots_1187 = slots_3073;
												    i_1186 = i_3072;
												    goto loop_1189;
												 }
											      }
											   }
										      }
										 }
										 arg1929_1183 =
										    append_2_18___r4_pairs_and_lists_6_3(arg1930_1184, BNIL);
									      }
									      arg1927_1181 =
										 MAKE_PAIR(widening_1098, arg1929_1183);
									   }
									   arg1926_1180 =
									      MAKE_PAIR(arg1927_1181, BNIL);
									}
									arg1925_1179 =
									   MAKE_PAIR(new_1095, arg1926_1180);
								     }
								     arg1922_1176 =
									MAKE_PAIR(arg1924_1178, arg1925_1179);
								  }
								  arg1923_1177 =
								     MAKE_PAIR(new_1095, BNIL);
								  arg1903_1160 =
								     MAKE_PAIR(arg1922_1176, arg1923_1177);
							       }
							       arg1880_1137 =
								  MAKE_PAIR(arg1902_1159, arg1903_1160);
							    }
							    arg1877_1135 =
							       MAKE_PAIR(arg1879_1136, arg1880_1137);
							 }
							 arg1874_1132 =
							    MAKE_PAIR(arg1876_1134, arg1877_1135);
						      }
						      arg1859_1117 =
							 MAKE_PAIR(arg1874_1132, BNIL);
						   }
						   arg1857_1115 =
						      MAKE_PAIR(arg1858_1116, arg1859_1117);
						}
						arg1854_1112 =
						   MAKE_PAIR(arg1856_1114, arg1857_1115);
					     }
					     arg1845_1103 =
						MAKE_PAIR(arg1854_1112, BNIL);
					  }
					  arg1843_1101 =
					     MAKE_PAIR(arg1844_1102, arg1845_1103);
				       }
				       arg1841_1099 =
					  MAKE_PAIR(arg1842_1100, arg1843_1101);
				    }
				    return
				       epairify_tools_misc(arg1841_1099, src_def_101_102);
				 }
			      }
			   }
			}
		     }
		  }
	       }
	    }
	 }
      }
   }
}



/* _make-struct->wide-object1985 */
obj_t 
_make_struct__wide_object1985_101_object_struct(obj_t env_2246, obj_t cname_2247, obj_t type_2248, obj_t module_2249, obj_t slots_2250, obj_t src_def_101_2251)
{
   AN_OBJECT;
   {	/* Object/struct.scm 272 */
      return
	 make_struct__wide_object_7_object_struct(cname_2247,
	 (type_bglt) (type_2248), module_2249, slots_2250, src_def_101_2251);
   }
}



/* method-init */
obj_t 
method_init_76_object_struct()
{
   AN_OBJECT;
   {	/* Object/struct.scm 14 */
      return BUNSPEC;
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_object_struct()
{
   AN_OBJECT;
   {	/* Object/struct.scm 14 */
      module_initialization_70_tools_error(((long) 0), "OBJECT_STRUCT");
      module_initialization_70_tools_misc(((long) 0), "OBJECT_STRUCT");
      module_initialization_70_type_type(((long) 0), "OBJECT_STRUCT");
      module_initialization_70_type_env(((long) 0), "OBJECT_STRUCT");
      module_initialization_70_type_cache(((long) 0), "OBJECT_STRUCT");
      module_initialization_70_type_tools(((long) 0), "OBJECT_STRUCT");
      module_initialization_70_ast_var(((long) 0), "OBJECT_STRUCT");
      module_initialization_70_ast_env(((long) 0), "OBJECT_STRUCT");
      module_initialization_70_engine_param(((long) 0), "OBJECT_STRUCT");
      module_initialization_70_object_class(((long) 0), "OBJECT_STRUCT");
      return
	 module_initialization_70_object_tools(((long) 0), "OBJECT_STRUCT");
   }
}
