/*===========================================================================*/
/*   (Object/tools.scm)                                                      */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct tclass
  {
     obj_t its_super_214;
     obj_t slots;
     struct global *holder;
     obj_t widening;
     long depth;
     bool_t final__12;
     obj_t constructor;
     obj_t virtual_slots_number_200;
  }
      *tclass_bglt;


static obj_t make_pragma_direct_ref_209_object_tools(type_bglt, obj_t, obj_t);
static obj_t method_init_76_object_tools();
static obj_t _make_pragma_direct_set__widening_61_object_tools(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t symbol_append_197___r4_symbols_6_4(obj_t);
static obj_t malloc_allocator_153_object_tools(obj_t, type_bglt, obj_t);
static obj_t _make_pragma_indexed_set__widening_42_object_tools(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t string_append(obj_t, obj_t);
extern obj_t string_sans___40_type_tools(obj_t);
static obj_t _class__id_49_object_tools(obj_t, obj_t);
static obj_t _class__obj_id_208_object_tools(obj_t, obj_t);
extern obj_t make_pragma_direct_set__widening_17_object_tools(type_bglt, obj_t, obj_t, obj_t, obj_t);
static obj_t _make_pragma_indexed_ref_widening_107_object_tools(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t module_initialization_70_object_tools(long, char *);
extern obj_t module_initialization_70_tools_misc(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_env(long, char *);
extern obj_t module_initialization_70_type_tools(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_object_class(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_symbols_6_4(long, char *);
static obj_t _make_pragma_direct_set__177_object_tools(obj_t, obj_t, obj_t, obj_t, obj_t);
extern type_bglt find_type_26_type_env(obj_t);
static obj_t imported_modules_init_94_object_tools();
static obj_t _make_pragma_indexed_init_set__29_object_tools(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t make_pragma_indexed_ref_widening_28_object_tools(type_bglt, obj_t, obj_t, obj_t, obj_t);
static obj_t _obj__class_id_160_object_tools(obj_t, obj_t);
static obj_t make_pragma_indexed_ref_228_object_tools(type_bglt, obj_t, obj_t, obj_t);
static obj_t library_modules_init_112_object_tools();
extern obj_t class__super_id_210_object_tools(obj_t, obj_t);
static obj_t toplevel_init_63_object_tools();
extern obj_t malloc_object_tools(type_bglt, obj_t);
extern obj_t open_input_string(obj_t);
extern obj_t class__obj_id_219_object_tools(obj_t);
static obj_t _malloc_object_tools(obj_t, obj_t, obj_t);
extern obj_t make_pragma_indexed_init_set__66_object_tools(type_bglt, obj_t, obj_t, obj_t);
extern obj_t super__class_id_210_object_tools(obj_t, obj_t);
static obj_t _class__super_id_254_object_tools(obj_t, obj_t, obj_t);
static obj_t _make_pragma_direct_ref_widening_149_object_tools(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t _make_pragma_indexed_set__138_object_tools(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t _4dots_199_tools_misc;
extern obj_t class__id_80_object_tools(obj_t);
extern obj_t make_pragma_direct_set__7_object_tools(type_bglt, obj_t, obj_t, obj_t);
extern obj_t read___reader(obj_t);
extern obj_t obj__class_id_9_object_tools(obj_t);
extern obj_t make_pragma_direct_ref_widening_240_object_tools(type_bglt, obj_t, obj_t, obj_t);
static obj_t require_initialization_114_object_tools = BUNSPEC;
static obj_t _super__class_id_61_object_tools(obj_t, obj_t, obj_t);
extern obj_t make_pragma_indexed_set__widening_24_object_tools(type_bglt, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t cnst_init_137_object_tools();
extern obj_t make_pragma_indexed_set__175_object_tools(type_bglt, obj_t, obj_t, obj_t, obj_t);
static obj_t __cnst[8];

DEFINE_EXPORT_PROCEDURE(make_pragma_direct_set__widening_env_195_object_tools, _make_pragma_direct_set__widening_61_object_tools1467, _make_pragma_direct_set__widening_61_object_tools, 0L, 5);
DEFINE_EXPORT_PROCEDURE(class__obj_id_env_11_object_tools, _class__obj_id_208_object_tools1468, _class__obj_id_208_object_tools, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_pragma_indexed_set__widening_env_6_object_tools, _make_pragma_indexed_set__widening_42_object_tools1469, _make_pragma_indexed_set__widening_42_object_tools, 0L, 6);
DEFINE_EXPORT_PROCEDURE(obj__class_id_env_107_object_tools, _obj__class_id_160_object_tools1470, _obj__class_id_160_object_tools, 0L, 1);
DEFINE_EXPORT_PROCEDURE(super__class_id_env_38_object_tools, _super__class_id_61_object_tools1471, _super__class_id_61_object_tools, 0L, 2);
DEFINE_EXPORT_PROCEDURE(malloc_env_105_object_tools, _malloc_object_tools1472, _malloc_object_tools, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_pragma_indexed_ref_widening_env_131_object_tools, _make_pragma_indexed_ref_widening_107_object_tools1473, _make_pragma_indexed_ref_widening_107_object_tools, 0L, 5);
DEFINE_EXPORT_PROCEDURE(class__id_env_134_object_tools, _class__id_49_object_tools1474, _class__id_49_object_tools, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_pragma_indexed_init_set__env_86_object_tools, _make_pragma_indexed_init_set__29_object_tools1475, _make_pragma_indexed_init_set__29_object_tools, 0L, 4);
DEFINE_EXPORT_PROCEDURE(class__super_id_env_38_object_tools, _class__super_id_254_object_tools1476, _class__super_id_254_object_tools, 0L, 2);
DEFINE_STRING(string1462_object_tools, string1462_object_tools1477, "VOID* PRAGMA::OBJ OBJECT-WIDENING FREE-PRAGMA -> ? OBJ-> ->OBJ ", 63);
DEFINE_STRING(string1461_object_tools, string1461_object_tools1478, "GC_MALLOC", 9);
DEFINE_STRING(string1459_object_tools, string1459_object_tools1479, ")BREF( ", 7);
DEFINE_STRING(string1460_object_tools, string1460_object_tools1480, "((", 2);
DEFINE_STRING(string1458_object_tools, string1458_object_tools1481, ") )))", 5);
DEFINE_STRING(string1457_object_tools, string1457_object_tools1482, "( sizeof(", 9);
DEFINE_STRING(string1456_object_tools, string1456_object_tools1483, ") * $1 )", 8);
DEFINE_STRING(string1455_object_tools, string1455_object_tools1484, ")[ $2 ] = ((", 12);
DEFINE_STRING(string1454_object_tools, string1454_object_tools1485, ")$3), BUNSPEC)", 14);
DEFINE_STRING(string1453_object_tools, string1453_object_tools1486, " *)$2), BUNSPEC)", 16);
DEFINE_STRING(string1452_object_tools, string1452_object_tools1487, "((((", 4);
DEFINE_STRING(string1451_object_tools, string1451_object_tools1488, ") = ((", 6);
DEFINE_STRING(string1449_object_tools, string1449_object_tools1489, ")[ $2 ]", 7);
DEFINE_STRING(string1450_object_tools, string1450_object_tools1490, ")$2), BUNSPEC)", 14);
DEFINE_STRING(string1448_object_tools, string1448_object_tools1491, "(((", 3);
DEFINE_STRING(string1447_object_tools, string1447_object_tools1492, ")CREF($1))->", 12);
DEFINE_STRING(string1446_object_tools, string1446_object_tools1493, ")", 1);
DEFINE_EXPORT_PROCEDURE(make_pragma_direct_set__env_183_object_tools, _make_pragma_direct_set__177_object_tools1494, _make_pragma_direct_set__177_object_tools, 0L, 4);
DEFINE_EXPORT_PROCEDURE(make_pragma_direct_ref_widening_env_95_object_tools, _make_pragma_direct_ref_widening_149_object_tools1495, _make_pragma_direct_ref_widening_149_object_tools, 0L, 4);
DEFINE_EXPORT_PROCEDURE(make_pragma_indexed_set__env_176_object_tools, _make_pragma_indexed_set__138_object_tools1496, _make_pragma_indexed_set__138_object_tools, 0L, 5);



/* module-initialization */
obj_t 
module_initialization_70_object_tools(long checksum_1091, char *from_1092)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_object_tools))
	{
	   require_initialization_114_object_tools =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_object_tools();
	   cnst_init_137_object_tools();
	   imported_modules_init_94_object_tools();
	   method_init_76_object_tools();
	   toplevel_init_63_object_tools();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_object_tools()
{
   AN_OBJECT;
   {	/* Object/tools.scm 14 */
      module_initialization_70___r4_symbols_6_4(((long) 0), "OBJECT_TOOLS");
      module_initialization_70___reader(((long) 0), "OBJECT_TOOLS");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_object_tools()
{
   AN_OBJECT;
   {	/* Object/tools.scm 14 */
      {		/* Object/tools.scm 14 */
	 obj_t cnst_port_138_1084;
	 cnst_port_138_1084 =
	    open_input_string(string1462_object_tools);
	 {
	    long i_1085;
	    i_1085 = ((long) 7);
	  loop_1086:
	    {	/* Object/tools.scm 14 */
	       bool_t test1463_1087;
	       test1463_1087 =
		  (i_1085 == ((long) -1));
	       if (test1463_1087)
		 {	/* Object/tools.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Object/tools.scm 14 */
		    {	/* Object/tools.scm 14 */
		       obj_t arg1464_1088;
		       {	/* Object/tools.scm 14 */
			  obj_t list1465_1089;
			  list1465_1089 =
			     MAKE_PAIR(cnst_port_138_1084, BNIL);
			  arg1464_1088 =
			     read___reader(list1465_1089);
		       }
		       CNST_TABLE_SET(i_1085, arg1464_1088);
		    }
		    {	/* Object/tools.scm 14 */
		       int aux_1090;
		       {	/* Object/tools.scm 14 */
			  long aux_1109;
			  aux_1109 =
			     (i_1085 - ((long) 1));
			  aux_1090 =
			     (int) (aux_1109);
		       }
		       {
			  long i_1112;
			  i_1112 =
			     (long) (aux_1090);
			  i_1085 = i_1112;
			  goto loop_1086;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_object_tools()
{
   AN_OBJECT;
   {	/* Object/tools.scm 14 */
      return BUNSPEC;
   }
}



/* class->obj-id */
obj_t 
class__obj_id_219_object_tools(obj_t id_71)
{
   AN_OBJECT;
   {	/* Object/tools.scm 39 */
      {		/* Object/tools.scm 40 */
	 obj_t list1224_520;
	 {	/* Object/tools.scm 40 */
	    obj_t arg1226_521;
	    {	/* Object/tools.scm 40 */
	       obj_t aux_1114;
	       aux_1114 =
		  CNST_TABLE_REF(((long) 0));
	       arg1226_521 =
		  MAKE_PAIR(aux_1114, BNIL);
	    }
	    list1224_520 =
	       MAKE_PAIR(id_71, arg1226_521);
	 }
	 return
	    symbol_append_197___r4_symbols_6_4(list1224_520);
      }
   }
}



/* _class->obj-id */
obj_t 
_class__obj_id_208_object_tools(obj_t env_1028, obj_t id_1029)
{
   AN_OBJECT;
   {	/* Object/tools.scm 39 */
      return
	 class__obj_id_219_object_tools(id_1029);
   }
}



/* obj->class-id */
obj_t 
obj__class_id_9_object_tools(obj_t id_72)
{
   AN_OBJECT;
   {	/* Object/tools.scm 45 */
      {		/* Object/tools.scm 46 */
	 obj_t list1227_522;
	 {	/* Object/tools.scm 46 */
	    obj_t arg1228_523;
	    obj_t arg1229_524;
	    arg1228_523 =
	       CNST_TABLE_REF(((long) 1));
	    arg1229_524 =
	       MAKE_PAIR(id_72, BNIL);
	    list1227_522 =
	       MAKE_PAIR(arg1228_523, arg1229_524);
	 }
	 return
	    symbol_append_197___r4_symbols_6_4(list1227_522);
      }
   }
}



/* _obj->class-id */
obj_t 
_obj__class_id_160_object_tools(obj_t env_1030, obj_t id_1031)
{
   AN_OBJECT;
   {	/* Object/tools.scm 45 */
      return
	 obj__class_id_9_object_tools(id_1031);
   }
}



/* class?-id */
obj_t 
class__id_80_object_tools(obj_t id_73)
{
   AN_OBJECT;
   {	/* Object/tools.scm 51 */
      {		/* Object/tools.scm 52 */
	 obj_t list1230_525;
	 {	/* Object/tools.scm 52 */
	    obj_t arg1231_526;
	    {	/* Object/tools.scm 52 */
	       obj_t aux_1125;
	       aux_1125 =
		  CNST_TABLE_REF(((long) 2));
	       arg1231_526 =
		  MAKE_PAIR(aux_1125, BNIL);
	    }
	    list1230_525 =
	       MAKE_PAIR(id_73, arg1231_526);
	 }
	 return
	    symbol_append_197___r4_symbols_6_4(list1230_525);
      }
   }
}



/* _class?-id */
obj_t 
_class__id_49_object_tools(obj_t env_1032, obj_t id_1033)
{
   AN_OBJECT;
   {	/* Object/tools.scm 51 */
      return
	 class__id_80_object_tools(id_1033);
   }
}



/* class->super-id */
obj_t 
class__super_id_210_object_tools(obj_t class_74, obj_t super_75)
{
   AN_OBJECT;
   {	/* Object/tools.scm 57 */
      {		/* Object/tools.scm 58 */
	 obj_t list1232_527;
	 {	/* Object/tools.scm 58 */
	    obj_t arg1233_528;
	    {	/* Object/tools.scm 58 */
	       obj_t arg1234_529;
	       obj_t arg1235_530;
	       arg1234_529 =
		  CNST_TABLE_REF(((long) 3));
	       arg1235_530 =
		  MAKE_PAIR(super_75, BNIL);
	       arg1233_528 =
		  MAKE_PAIR(arg1234_529, arg1235_530);
	    }
	    list1232_527 =
	       MAKE_PAIR(class_74, arg1233_528);
	 }
	 return
	    symbol_append_197___r4_symbols_6_4(list1232_527);
      }
   }
}



/* _class->super-id */
obj_t 
_class__super_id_254_object_tools(obj_t env_1034, obj_t class_1035, obj_t super_1036)
{
   AN_OBJECT;
   {	/* Object/tools.scm 57 */
      return
	 class__super_id_210_object_tools(class_1035, super_1036);
   }
}



/* super->class-id */
obj_t 
super__class_id_210_object_tools(obj_t super_76, obj_t class_77)
{
   AN_OBJECT;
   {	/* Object/tools.scm 63 */
      {		/* Object/tools.scm 64 */
	 obj_t list1236_531;
	 {	/* Object/tools.scm 64 */
	    obj_t arg1237_532;
	    {	/* Object/tools.scm 64 */
	       obj_t arg1238_533;
	       obj_t arg1240_534;
	       arg1238_533 =
		  CNST_TABLE_REF(((long) 3));
	       arg1240_534 =
		  MAKE_PAIR(class_77, BNIL);
	       arg1237_532 =
		  MAKE_PAIR(arg1238_533, arg1240_534);
	    }
	    list1236_531 =
	       MAKE_PAIR(super_76, arg1237_532);
	 }
	 return
	    symbol_append_197___r4_symbols_6_4(list1236_531);
      }
   }
}



/* _super->class-id */
obj_t 
_super__class_id_61_object_tools(obj_t env_1037, obj_t super_1038, obj_t class_1039)
{
   AN_OBJECT;
   {	/* Object/tools.scm 63 */
      return
	 super__class_id_210_object_tools(super_1038, class_1039);
   }
}



/* make-pragma-direct-ref */
obj_t 
make_pragma_direct_ref_209_object_tools(type_bglt type_78, obj_t slot_79, obj_t obj_80)
{
   AN_OBJECT;
   {	/* Object/tools.scm 69 */
      {		/* Object/tools.scm 70 */
	 obj_t arg1241_535;
	 obj_t arg1243_536;
	 {	/* Object/tools.scm 70 */
	    obj_t arg1245_537;
	    arg1245_537 =
	       CNST_TABLE_REF(((long) 4));
	    {	/* Object/tools.scm 70 */
	       obj_t list1247_539;
	       {	/* Object/tools.scm 70 */
		  obj_t arg1248_540;
		  {	/* Object/tools.scm 70 */
		     obj_t arg1249_541;
		     {	/* Object/tools.scm 70 */
			obj_t aux_1144;
			{	/* Object/tools.scm 70 */
			   type_bglt obj_878;
			   {	/* Object/tools.scm 70 */
			      obj_t aux_1145;
			      aux_1145 =
				 STRUCT_REF(slot_79, ((long) 2));
			      obj_878 =
				 (type_bglt) (aux_1145);
			   }
			   aux_1144 =
			      (((type_bglt) CREF(obj_878))->id);
			}
			arg1249_541 =
			   MAKE_PAIR(aux_1144, BNIL);
		     }
		     arg1248_540 =
			MAKE_PAIR(_4dots_199_tools_misc, arg1249_541);
		  }
		  list1247_539 =
		     MAKE_PAIR(arg1245_537, arg1248_540);
	       }
	       arg1241_535 =
		  symbol_append_197___r4_symbols_6_4(list1247_539);
	    }
	 }
	 {	/* Object/tools.scm 71 */
	    obj_t arg1251_543;
	    obj_t arg1252_544;
	    {	/* Object/tools.scm 71 */
	       obj_t arg1254_546;
	       {	/* Object/tools.scm 71 */
		  obj_t arg1255_547;
		  obj_t arg1256_548;
		  arg1255_547 =
		     (((type_bglt) CREF(type_78))->name);
		  {	/* Object/tools.scm 71 */
		     obj_t arg1258_550;
		     {	/* Object/tools.scm 71 */
			obj_t aux_1154;
			aux_1154 =
			   STRUCT_REF(slot_79, ((long) 1));
			arg1258_550 =
			   string_append(aux_1154, string1446_object_tools);
		     }
		     arg1256_548 =
			string_append(string1447_object_tools, arg1258_550);
		  }
		  arg1254_546 =
		     string_append(arg1255_547, arg1256_548);
	       }
	       arg1251_543 =
		  string_append(string1448_object_tools, arg1254_546);
	    }
	    arg1252_544 =
	       MAKE_PAIR(obj_80, BNIL);
	    arg1243_536 =
	       MAKE_PAIR(arg1251_543, arg1252_544);
	 }
	 return
	    MAKE_PAIR(arg1241_535, arg1243_536);
      }
   }
}



/* make-pragma-direct-ref/widening */
obj_t 
make_pragma_direct_ref_widening_240_object_tools(type_bglt type_81, obj_t slot_82, obj_t obj_83, obj_t widening_84)
{
   AN_OBJECT;
   {	/* Object/tools.scm 78 */
      if (
	 CBOOL(widening_84))
	{	/* Object/tools.scm 81 */
	   obj_t arg1261_889;
	   {	/* Object/tools.scm 81 */
	      obj_t arg1263_890;
	      obj_t arg1264_891;
	      arg1263_890 =
		 CNST_TABLE_REF(((long) 5));
	      arg1264_891 =
		 MAKE_PAIR(obj_83, BNIL);
	      arg1261_889 =
		 MAKE_PAIR(arg1263_890, arg1264_891);
	   }
	   return
	      make_pragma_direct_ref_209_object_tools(type_81, slot_82, arg1261_889);
	}
      else
	{	/* Object/tools.scm 79 */
	   return
	      make_pragma_direct_ref_209_object_tools(type_81, slot_82, obj_83);
	}
   }
}



/* _make-pragma-direct-ref/widening */
obj_t 
_make_pragma_direct_ref_widening_149_object_tools(obj_t env_1040, obj_t type_1041, obj_t slot_1042, obj_t obj_1043, obj_t widening_1044)
{
   AN_OBJECT;
   {	/* Object/tools.scm 78 */
      return
	 make_pragma_direct_ref_widening_240_object_tools(
	 (type_bglt) (type_1041), slot_1042, obj_1043, widening_1044);
   }
}



/* make-pragma-indexed-ref */
obj_t 
make_pragma_indexed_ref_228_object_tools(type_bglt type_85, obj_t slot_86, obj_t obj_87, obj_t index_88)
{
   AN_OBJECT;
   {	/* Object/tools.scm 86 */
      {		/* Object/tools.scm 87 */
	 obj_t arg1265_556;
	 obj_t arg1267_557;
	 {	/* Object/tools.scm 87 */
	    obj_t arg1268_558;
	    arg1268_558 =
	       CNST_TABLE_REF(((long) 4));
	    {	/* Object/tools.scm 87 */
	       obj_t list1270_560;
	       {	/* Object/tools.scm 87 */
		  obj_t arg1271_561;
		  {	/* Object/tools.scm 87 */
		     obj_t arg1272_562;
		     {	/* Object/tools.scm 87 */
			obj_t aux_1173;
			{	/* Object/tools.scm 87 */
			   type_bglt obj_899;
			   {	/* Object/tools.scm 87 */
			      obj_t aux_1174;
			      aux_1174 =
				 STRUCT_REF(slot_86, ((long) 2));
			      obj_899 =
				 (type_bglt) (aux_1174);
			   }
			   aux_1173 =
			      (((type_bglt) CREF(obj_899))->id);
			}
			arg1272_562 =
			   MAKE_PAIR(aux_1173, BNIL);
		     }
		     arg1271_561 =
			MAKE_PAIR(_4dots_199_tools_misc, arg1272_562);
		  }
		  list1270_560 =
		     MAKE_PAIR(arg1268_558, arg1271_561);
	       }
	       arg1265_556 =
		  symbol_append_197___r4_symbols_6_4(list1270_560);
	    }
	 }
	 {	/* Object/tools.scm 88 */
	    obj_t arg1274_564;
	    obj_t arg1276_565;
	    {	/* Object/tools.scm 88 */
	       obj_t arg1278_567;
	       {	/* Object/tools.scm 88 */
		  obj_t arg1280_568;
		  obj_t arg1281_569;
		  arg1280_568 =
		     (((type_bglt) CREF(type_85))->name);
		  {	/* Object/tools.scm 88 */
		     obj_t arg1286_571;
		     {	/* Object/tools.scm 88 */
			obj_t aux_1183;
			aux_1183 =
			   STRUCT_REF(slot_86, ((long) 1));
			arg1286_571 =
			   string_append(aux_1183, string1449_object_tools);
		     }
		     arg1281_569 =
			string_append(string1447_object_tools, arg1286_571);
		  }
		  arg1278_567 =
		     string_append(arg1280_568, arg1281_569);
	       }
	       arg1274_564 =
		  string_append(string1448_object_tools, arg1278_567);
	    }
	    {	/* Object/tools.scm 87 */
	       obj_t arg1290_574;
	       arg1290_574 =
		  MAKE_PAIR(index_88, BNIL);
	       arg1276_565 =
		  MAKE_PAIR(obj_87, arg1290_574);
	    }
	    arg1267_557 =
	       MAKE_PAIR(arg1274_564, arg1276_565);
	 }
	 return
	    MAKE_PAIR(arg1265_556, arg1267_557);
      }
   }
}



/* make-pragma-indexed-ref/widening */
obj_t 
make_pragma_indexed_ref_widening_28_object_tools(type_bglt type_89, obj_t slot_90, obj_t obj_91, obj_t index_92, obj_t widening_93)
{
   AN_OBJECT;
   {	/* Object/tools.scm 96 */
      if (
	 CBOOL(widening_93))
	{	/* Object/tools.scm 99 */
	   obj_t arg1291_912;
	   {	/* Object/tools.scm 99 */
	      obj_t arg1292_913;
	      obj_t arg1293_914;
	      arg1292_913 =
		 CNST_TABLE_REF(((long) 5));
	      arg1293_914 =
		 MAKE_PAIR(obj_91, BNIL);
	      arg1291_912 =
		 MAKE_PAIR(arg1292_913, arg1293_914);
	   }
	   return
	      make_pragma_indexed_ref_228_object_tools(type_89, slot_90, arg1291_912, index_92);
	}
      else
	{	/* Object/tools.scm 97 */
	   return
	      make_pragma_indexed_ref_228_object_tools(type_89, slot_90, obj_91, index_92);
	}
   }
}



/* _make-pragma-indexed-ref/widening */
obj_t 
_make_pragma_indexed_ref_widening_107_object_tools(obj_t env_1045, obj_t type_1046, obj_t slot_1047, obj_t obj_1048, obj_t index_1049, obj_t widening_1050)
{
   AN_OBJECT;
   {	/* Object/tools.scm 96 */
      return
	 make_pragma_indexed_ref_widening_28_object_tools(
	 (type_bglt) (type_1046), slot_1047, obj_1048, index_1049, widening_1050);
   }
}



/* make-pragma-direct-set! */
obj_t 
make_pragma_direct_set__7_object_tools(type_bglt type_94, obj_t slot_95, obj_t obj_96, obj_t val_97)
{
   AN_OBJECT;
   {	/* Object/tools.scm 104 */
      {		/* Object/tools.scm 105 */
	 obj_t arg1294_578;
	 obj_t arg1295_579;
	 arg1294_578 =
	    CNST_TABLE_REF(((long) 6));
	 {	/* Object/tools.scm 106 */
	    obj_t arg1296_580;
	    obj_t arg1297_581;
	    {	/* Object/tools.scm 106 */
	       obj_t arg1299_583;
	       {	/* Object/tools.scm 106 */
		  obj_t arg1300_584;
		  obj_t arg1301_585;
		  arg1300_584 =
		     (((type_bglt) CREF(type_94))->name);
		  {	/* Object/tools.scm 106 */
		     obj_t arg1303_587;
		     {	/* Object/tools.scm 106 */
			obj_t arg1304_588;
			obj_t arg1305_589;
			arg1304_588 =
			   STRUCT_REF(slot_95, ((long) 1));
			{	/* Object/tools.scm 106 */
			   obj_t arg1308_591;
			   {	/* Object/tools.scm 106 */
			      obj_t aux_1205;
			      {		/* Object/tools.scm 107 */
				 type_bglt obj_926;
				 {	/* Object/tools.scm 107 */
				    obj_t aux_1206;
				    aux_1206 =
				       STRUCT_REF(slot_95, ((long) 2));
				    obj_926 =
				       (type_bglt) (aux_1206);
				 }
				 aux_1205 =
				    (((type_bglt) CREF(obj_926))->name);
			      }
			      arg1308_591 =
				 string_append(aux_1205, string1450_object_tools);
			   }
			   arg1305_589 =
			      string_append(string1451_object_tools, arg1308_591);
			}
			arg1303_587 =
			   string_append(arg1304_588, arg1305_589);
		     }
		     arg1301_585 =
			string_append(string1447_object_tools, arg1303_587);
		  }
		  arg1299_583 =
		     string_append(arg1300_584, arg1301_585);
	       }
	       arg1296_580 =
		  string_append(string1452_object_tools, arg1299_583);
	    }
	    {	/* Object/tools.scm 105 */
	       obj_t arg1315_595;
	       arg1315_595 =
		  MAKE_PAIR(val_97, BNIL);
	       arg1297_581 =
		  MAKE_PAIR(obj_96, arg1315_595);
	    }
	    arg1295_579 =
	       MAKE_PAIR(arg1296_580, arg1297_581);
	 }
	 return
	    MAKE_PAIR(arg1294_578, arg1295_579);
      }
   }
}



/* _make-pragma-direct-set! */
obj_t 
_make_pragma_direct_set__177_object_tools(obj_t env_1051, obj_t type_1052, obj_t slot_1053, obj_t obj_1054, obj_t val_1055)
{
   AN_OBJECT;
   {	/* Object/tools.scm 104 */
      return
	 make_pragma_direct_set__7_object_tools(
	 (type_bglt) (type_1052), slot_1053, obj_1054, val_1055);
   }
}



/* make-pragma-direct-set!/widening */
obj_t 
make_pragma_direct_set__widening_17_object_tools(type_bglt type_98, obj_t slot_99, obj_t obj_100, obj_t val_101, obj_t widening_102)
{
   AN_OBJECT;
   {	/* Object/tools.scm 114 */
      if (
	 CBOOL(widening_102))
	{	/* Object/tools.scm 117 */
	   obj_t arg1317_935;
	   {	/* Object/tools.scm 117 */
	      obj_t arg1318_936;
	      obj_t arg1319_937;
	      arg1318_936 =
		 CNST_TABLE_REF(((long) 5));
	      arg1319_937 =
		 MAKE_PAIR(obj_100, BNIL);
	      arg1317_935 =
		 MAKE_PAIR(arg1318_936, arg1319_937);
	   }
	   return
	      make_pragma_direct_set__7_object_tools(type_98, slot_99, arg1317_935, val_101);
	}
      else
	{	/* Object/tools.scm 115 */
	   return
	      make_pragma_direct_set__7_object_tools(type_98, slot_99, obj_100, val_101);
	}
   }
}



/* _make-pragma-direct-set!/widening */
obj_t 
_make_pragma_direct_set__widening_61_object_tools(obj_t env_1056, obj_t type_1057, obj_t slot_1058, obj_t obj_1059, obj_t val_1060, obj_t widening_1061)
{
   AN_OBJECT;
   {	/* Object/tools.scm 114 */
      return
	 make_pragma_direct_set__widening_17_object_tools(
	 (type_bglt) (type_1057), slot_1058, obj_1059, val_1060, widening_1061);
   }
}



/* make-pragma-indexed-init-set! */
obj_t 
make_pragma_indexed_init_set__66_object_tools(type_bglt type_103, obj_t slot_104, obj_t obj_105, obj_t val_106)
{
   AN_OBJECT;
   {	/* Object/tools.scm 122 */
      {		/* Object/tools.scm 123 */
	 obj_t arg1320_599;
	 obj_t arg1322_600;
	 arg1320_599 =
	    CNST_TABLE_REF(((long) 6));
	 {	/* Object/tools.scm 124 */
	    obj_t arg1323_601;
	    obj_t arg1325_602;
	    {	/* Object/tools.scm 124 */
	       obj_t arg1327_604;
	       {	/* Object/tools.scm 124 */
		  obj_t arg1329_605;
		  obj_t arg1330_606;
		  arg1329_605 =
		     (((type_bglt) CREF(type_103))->name);
		  {	/* Object/tools.scm 124 */
		     obj_t arg1332_608;
		     {	/* Object/tools.scm 124 */
			obj_t arg1333_609;
			obj_t arg1334_610;
			arg1333_609 =
			   STRUCT_REF(slot_104, ((long) 1));
			{	/* Object/tools.scm 124 */
			   obj_t arg1336_612;
			   {	/* Object/tools.scm 124 */
			      obj_t aux_1234;
			      {		/* Object/tools.scm 125 */
				 type_bglt obj_949;
				 {	/* Object/tools.scm 125 */
				    obj_t aux_1235;
				    aux_1235 =
				       STRUCT_REF(slot_104, ((long) 2));
				    obj_949 =
				       (type_bglt) (aux_1235);
				 }
				 aux_1234 =
				    (((type_bglt) CREF(obj_949))->name);
			      }
			      arg1336_612 =
				 string_append(aux_1234, string1453_object_tools);
			   }
			   arg1334_610 =
			      string_append(string1451_object_tools, arg1336_612);
			}
			arg1332_608 =
			   string_append(arg1333_609, arg1334_610);
		     }
		     arg1330_606 =
			string_append(string1447_object_tools, arg1332_608);
		  }
		  arg1327_604 =
		     string_append(arg1329_605, arg1330_606);
	       }
	       arg1323_601 =
		  string_append(string1452_object_tools, arg1327_604);
	    }
	    {	/* Object/tools.scm 123 */
	       obj_t arg1340_616;
	       arg1340_616 =
		  MAKE_PAIR(val_106, BNIL);
	       arg1325_602 =
		  MAKE_PAIR(obj_105, arg1340_616);
	    }
	    arg1322_600 =
	       MAKE_PAIR(arg1323_601, arg1325_602);
	 }
	 return
	    MAKE_PAIR(arg1320_599, arg1322_600);
      }
   }
}



/* _make-pragma-indexed-init-set! */
obj_t 
_make_pragma_indexed_init_set__29_object_tools(obj_t env_1062, obj_t type_1063, obj_t slot_1064, obj_t obj_1065, obj_t val_1066)
{
   AN_OBJECT;
   {	/* Object/tools.scm 122 */
      return
	 make_pragma_indexed_init_set__66_object_tools(
	 (type_bglt) (type_1063), slot_1064, obj_1065, val_1066);
   }
}



/* make-pragma-indexed-set! */
obj_t 
make_pragma_indexed_set__175_object_tools(type_bglt type_107, obj_t slot_108, obj_t obj_109, obj_t val_110, obj_t index_111)
{
   AN_OBJECT;
   {	/* Object/tools.scm 132 */
      {		/* Object/tools.scm 133 */
	 obj_t arg1342_617;
	 obj_t arg1343_618;
	 arg1342_617 =
	    CNST_TABLE_REF(((long) 6));
	 {	/* Object/tools.scm 134 */
	    obj_t arg1344_619;
	    obj_t arg1346_620;
	    {	/* Object/tools.scm 134 */
	       obj_t arg1348_622;
	       {	/* Object/tools.scm 134 */
		  obj_t arg1350_623;
		  obj_t arg1354_624;
		  arg1350_623 =
		     (((type_bglt) CREF(type_107))->name);
		  {	/* Object/tools.scm 134 */
		     obj_t arg1356_626;
		     {	/* Object/tools.scm 134 */
			obj_t arg1357_627;
			obj_t arg1358_628;
			arg1357_627 =
			   STRUCT_REF(slot_108, ((long) 1));
			{	/* Object/tools.scm 134 */
			   obj_t arg1361_630;
			   {	/* Object/tools.scm 134 */
			      obj_t aux_1254;
			      {		/* Object/tools.scm 135 */
				 type_bglt obj_965;
				 {	/* Object/tools.scm 135 */
				    obj_t aux_1255;
				    aux_1255 =
				       STRUCT_REF(slot_108, ((long) 2));
				    obj_965 =
				       (type_bglt) (aux_1255);
				 }
				 aux_1254 =
				    (((type_bglt) CREF(obj_965))->name);
			      }
			      arg1361_630 =
				 string_append(aux_1254, string1454_object_tools);
			   }
			   arg1358_628 =
			      string_append(string1455_object_tools, arg1361_630);
			}
			arg1356_626 =
			   string_append(arg1357_627, arg1358_628);
		     }
		     arg1354_624 =
			string_append(string1447_object_tools, arg1356_626);
		  }
		  arg1348_622 =
		     string_append(arg1350_623, arg1354_624);
	       }
	       arg1344_619 =
		  string_append(string1452_object_tools, arg1348_622);
	    }
	    {	/* Object/tools.scm 133 */
	       obj_t arg1367_634;
	       {	/* Object/tools.scm 133 */
		  obj_t arg1369_635;
		  arg1369_635 =
		     MAKE_PAIR(val_110, BNIL);
		  arg1367_634 =
		     MAKE_PAIR(index_111, arg1369_635);
	       }
	       arg1346_620 =
		  MAKE_PAIR(obj_109, arg1367_634);
	    }
	    arg1343_618 =
	       MAKE_PAIR(arg1344_619, arg1346_620);
	 }
	 return
	    MAKE_PAIR(arg1342_617, arg1343_618);
      }
   }
}



/* _make-pragma-indexed-set! */
obj_t 
_make_pragma_indexed_set__138_object_tools(obj_t env_1067, obj_t type_1068, obj_t slot_1069, obj_t obj_1070, obj_t val_1071, obj_t index_1072)
{
   AN_OBJECT;
   {	/* Object/tools.scm 132 */
      return
	 make_pragma_indexed_set__175_object_tools(
	 (type_bglt) (type_1068), slot_1069, obj_1070, val_1071, index_1072);
   }
}



/* make-pragma-indexed-set!/widening */
obj_t 
make_pragma_indexed_set__widening_24_object_tools(type_bglt type_112, obj_t slot_113, obj_t obj_114, obj_t val_115, obj_t index_116, obj_t widening_117)
{
   AN_OBJECT;
   {	/* Object/tools.scm 144 */
      if (
	 CBOOL(widening_117))
	{	/* Object/tools.scm 147 */
	   obj_t arg1371_976;
	   {	/* Object/tools.scm 147 */
	      obj_t arg1372_977;
	      obj_t arg1373_978;
	      arg1372_977 =
		 CNST_TABLE_REF(((long) 5));
	      arg1373_978 =
		 MAKE_PAIR(obj_114, BNIL);
	      arg1371_976 =
		 MAKE_PAIR(arg1372_977, arg1373_978);
	   }
	   return
	      make_pragma_indexed_set__175_object_tools(type_112, slot_113, arg1371_976, val_115, index_116);
	}
      else
	{	/* Object/tools.scm 145 */
	   return
	      make_pragma_indexed_set__175_object_tools(type_112, slot_113, obj_114, val_115, index_116);
	}
   }
}



/* _make-pragma-indexed-set!/widening */
obj_t 
_make_pragma_indexed_set__widening_42_object_tools(obj_t env_1073, obj_t type_1074, obj_t slot_1075, obj_t obj_1076, obj_t val_1077, obj_t index_1078, obj_t widening_1079)
{
   AN_OBJECT;
   {	/* Object/tools.scm 144 */
      return
	 make_pragma_indexed_set__widening_24_object_tools(
	 (type_bglt) (type_1074), slot_1075, obj_1076, val_1077, index_1078, widening_1079);
   }
}



/* malloc/allocator */
obj_t 
malloc_allocator_153_object_tools(obj_t allocator_118, type_bglt type_119, obj_t size_120)
{
   AN_OBJECT;
   {	/* Object/tools.scm 152 */
      {		/* Object/tools.scm 153 */
	 obj_t tid_639;
	 obj_t tname_640;
	 obj_t sizeof_641;
	 tid_639 =
	    (((type_bglt) CREF(type_119))->id);
	 tname_640 =
	    string_sans___40_type_tools(
	    (((type_bglt) CREF(type_119))->name));
	 {	/* Object/tools.scm 155 */
	    bool_t test_1284;
	    {	/* ./Ieee/string.scm 8047 */
	       obj_t aux_1285;
	       aux_1285 =
		  (((type_bglt) CREF(type_119))->size);
	       test_1284 =
		  STRINGP(aux_1285);
	    }
	    if (test_1284)
	      {		/* Object/tools.scm 155 */
		 sizeof_641 =
		    (((type_bglt) CREF(type_119))->size);
	      }
	    else
	      {		/* Object/tools.scm 155 */
		 sizeof_641 =
		    (((type_bglt) CREF(type_119))->name);
	      }
	 }
	 if (
	    SYMBOLP(size_120))
	   {	/* Object/tools.scm 162 */
	      type_bglt void__131_643;
	      void__131_643 =
		 find_type_26_type_env(
		 CNST_TABLE_REF(((long) 7)));
	      {		/* Object/tools.scm 164 */

		 {	/* Object/tools.scm 165 */
		    obj_t arg1375_646;
		    obj_t arg1376_647;
		    {	/* Object/tools.scm 165 */
		       obj_t list1377_648;
		       {	/* Object/tools.scm 165 */
			  obj_t arg1378_649;
			  obj_t arg1379_650;
			  arg1378_649 =
			     CNST_TABLE_REF(((long) 4));
			  {	/* Object/tools.scm 165 */
			     obj_t arg1380_651;
			     {	/* Object/tools.scm 165 */
				obj_t aux_1295;
				aux_1295 =
				   (((type_bglt) CREF(void__131_643))->id);
				arg1380_651 =
				   MAKE_PAIR(aux_1295, BNIL);
			     }
			     arg1379_650 =
				MAKE_PAIR(_4dots_199_tools_misc, arg1380_651);
			  }
			  list1377_648 =
			     MAKE_PAIR(arg1378_649, arg1379_650);
		       }
		       arg1375_646 =
			  symbol_append_197___r4_symbols_6_4(list1377_648);
		    }
		    {	/* Object/tools.scm 166 */
		       obj_t arg1381_652;
		       obj_t arg1383_653;
		       {	/* Object/tools.scm 166 */
			  obj_t arg1384_654;
			  {	/* Object/tools.scm 166 */
			     obj_t arg1387_656;
			     arg1387_656 =
				string_append(sizeof_641, string1456_object_tools);
			     arg1384_654 =
				string_append(string1457_object_tools, arg1387_656);
			  }
			  arg1381_652 =
			     string_append(allocator_118, arg1384_654);
		       }
		       arg1383_653 =
			  MAKE_PAIR(size_120, BNIL);
		       arg1376_647 =
			  MAKE_PAIR(arg1381_652, arg1383_653);
		    }
		    return
		       MAKE_PAIR(arg1375_646, arg1376_647);
		 }
	      }
	   }
	 else
	   {	/* Object/tools.scm 159 */
	      obj_t arg1389_657;
	      obj_t arg1390_658;
	      {		/* Object/tools.scm 159 */
		 obj_t list1391_659;
		 {	/* Object/tools.scm 159 */
		    obj_t arg1393_660;
		    obj_t arg1394_661;
		    arg1393_660 =
		       CNST_TABLE_REF(((long) 4));
		    {	/* Object/tools.scm 159 */
		       obj_t arg1395_662;
		       arg1395_662 =
			  MAKE_PAIR(tid_639, BNIL);
		       arg1394_661 =
			  MAKE_PAIR(_4dots_199_tools_misc, arg1395_662);
		    }
		    list1391_659 =
		       MAKE_PAIR(arg1393_660, arg1394_661);
		 }
		 arg1389_657 =
		    symbol_append_197___r4_symbols_6_4(list1391_659);
	      }
	      {		/* Object/tools.scm 160 */
		 obj_t arg1397_663;
		 {	/* Object/tools.scm 160 */
		    obj_t arg1400_666;
		    {	/* Object/tools.scm 160 */
		       obj_t arg1401_667;
		       {	/* Object/tools.scm 160 */
			  obj_t arg1403_669;
			  {	/* Object/tools.scm 160 */
			     obj_t arg1404_670;
			     {	/* Object/tools.scm 160 */
				obj_t arg1406_672;
				arg1406_672 =
				   string_append(sizeof_641, string1458_object_tools);
				arg1404_670 =
				   string_append(string1457_object_tools, arg1406_672);
			     }
			     arg1403_669 =
				string_append(allocator_118, arg1404_670);
			  }
			  arg1401_667 =
			     string_append(string1459_object_tools, arg1403_669);
		       }
		       arg1400_666 =
			  string_append(tname_640, arg1401_667);
		    }
		    arg1397_663 =
		       string_append(string1460_object_tools, arg1400_666);
		 }
		 arg1390_658 =
		    MAKE_PAIR(arg1397_663, BNIL);
	      }
	      return
		 MAKE_PAIR(arg1389_657, arg1390_658);
	   }
      }
   }
}



/* malloc */
obj_t 
malloc_object_tools(type_bglt type_121, obj_t size_122)
{
   AN_OBJECT;
   {	/* Object/tools.scm 172 */
      return
	 malloc_allocator_153_object_tools(string1461_object_tools, type_121, size_122);
   }
}



/* _malloc */
obj_t 
_malloc_object_tools(obj_t env_1080, obj_t type_1081, obj_t size_1082)
{
   AN_OBJECT;
   {	/* Object/tools.scm 172 */
      return
	 malloc_object_tools(
	 (type_bglt) (type_1081), size_1082);
   }
}



/* method-init */
obj_t 
method_init_76_object_tools()
{
   AN_OBJECT;
   {	/* Object/tools.scm 14 */
      return BUNSPEC;
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_object_tools()
{
   AN_OBJECT;
   {	/* Object/tools.scm 14 */
      module_initialization_70_tools_misc(((long) 0), "OBJECT_TOOLS");
      module_initialization_70_type_type(((long) 0), "OBJECT_TOOLS");
      module_initialization_70_type_env(((long) 0), "OBJECT_TOOLS");
      module_initialization_70_type_tools(((long) 0), "OBJECT_TOOLS");
      module_initialization_70_ast_var(((long) 0), "OBJECT_TOOLS");
      return
	 module_initialization_70_object_class(((long) 0), "OBJECT_TOOLS");
   }
}
