/*===========================================================================*/
/*   (Object/wide-access.scm)                                                */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct tclass
  {
     obj_t its_super_214;
     obj_t slots;
     struct global *holder;
     obj_t widening;
     long depth;
     bool_t final__12;
     obj_t constructor;
     obj_t virtual_slots_number_200;
  }
      *tclass_bglt;

typedef struct ccomp
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t producer;
     obj_t consumer;
     obj_t finalizer;
     obj_t checksummer;
  }
     *ccomp_bglt;


extern obj_t append___r4_pairs_and_lists_6_3(obj_t);
extern obj_t make_struct__wide_object_7_object_struct(obj_t, type_bglt, obj_t, obj_t, obj_t);
static obj_t import_wide_class_make__56_object_wide_access_168(obj_t, obj_t, type_bglt, obj_t, obj_t, obj_t, obj_t);
static obj_t method_init_76_object_wide_access_168();
extern obj_t symbol_append_197___r4_symbols_6_4(obj_t);
extern obj_t _optim__89_engine_param;
extern obj_t import_wide_class_makes__40_object_wide_access_168(obj_t, type_bglt, obj_t, obj_t);
extern obj_t string_append(obj_t, obj_t);
extern obj_t type_type_type;
extern obj_t make_class_makes__132_object_access(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t make_wide_object__struct_148_object_struct(obj_t, type_bglt, obj_t, obj_t, obj_t);
extern obj_t _res1__155___r5_control_features_6_4;
extern obj_t global_ast_var;
extern obj_t gensym___r4_symbols_6_4;
extern obj_t user_error_151_tools_error(obj_t, obj_t, obj_t, obj_t);
extern obj_t make_class_pred__174_object_access(obj_t, tclass_bglt, obj_t, obj_t);
extern obj_t make_wide_class_accessors_sans_makes__153_object_wide_access_168(obj_t, type_bglt, obj_t, obj_t);
extern obj_t make_class_slots_205_object_slots(tclass_bglt, obj_t, obj_t, int, obj_t);
extern obj_t notify_assert_fail_37___eval(obj_t, obj_t, obj_t);
extern obj_t make_class_coercers_236_object_access(obj_t);
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t module_initialization_70_object_wide_access_168(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_tools_misc(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_env(long, char *);
extern obj_t module_initialization_70_type_tools(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_ident(long, char *);
extern obj_t module_initialization_70_object_class(long, char *);
extern obj_t module_initialization_70_object_struct(long, char *);
extern obj_t module_initialization_70_object_slots(long, char *);
extern obj_t module_initialization_70_object_tools(long, char *);
extern obj_t module_initialization_70_object_access(long, char *);
extern obj_t module_initialization_70_module_module(long, char *);
extern obj_t module_initialization_70_module_impuse(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___eval(long, char *);
extern obj_t module_initialization_70___evenv(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_symbols_6_4(long, char *);
extern obj_t module_initialization_70___r5_control_features_6_4(long, char *);
extern obj_t make_class_make_typed_formals_184_object_access(obj_t);
extern bool_t wide_class__100_object_class(obj_t);
extern obj_t make_class_slots_access__80_object_access(tclass_bglt, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t define_primop_ref__105___evenv(obj_t, obj_t);
static obj_t imported_modules_init_94_object_wide_access_168();
extern obj_t unbind_primop__163___evenv(obj_t);
extern obj_t make_coercion_clause_209_object_access(obj_t, obj_t);
extern obj_t import_wide_class_accessors__236_object_wide_access_168(obj_t, type_bglt, obj_t, obj_t);
extern obj_t get_local_virtual_slots_number_139_object_slots(tclass_bglt, obj_t);
extern obj_t produce_module_clause__172_module_module(obj_t);
extern obj_t append_2_18___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern obj_t import_parser_53_module_impuse(obj_t, obj_t);
extern obj_t epairify__149_object_access(obj_t, obj_t);
static obj_t library_modules_init_112_object_wide_access_168();
extern obj_t import_class_slots_access__39_object_access(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t toplevel_init_63_object_wide_access_168();
extern obj_t open_input_string(obj_t);
extern obj_t import_class_pred__91_object_access(obj_t, tclass_bglt, obj_t, obj_t);
static obj_t _make_wide_class_accessors__205_object_wide_access_168(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t _import_wide_class_accessors__85_object_wide_access_168(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t correct_wide_class__226_object_wide_access_168(type_bglt, obj_t);
extern obj_t tclass_object_class;
extern obj_t memq___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern obj_t make_class_make_formals_23_object_access(obj_t);
extern obj_t internal_error_43_tools_error(obj_t, obj_t, obj_t);
extern obj_t _res_number__75___r5_control_features_6_4;
static obj_t make_wide_class_make__242_object_wide_access_168(obj_t, obj_t, type_bglt, obj_t, obj_t, obj_t, obj_t);
extern obj_t _module__166_module_module;
extern obj_t _4dots_199_tools_misc;
extern obj_t read___reader(obj_t);
extern obj_t _profile_mode__105_engine_param;
extern obj_t import_class_makes__192_object_access(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t make_wide_class_accessors__22_object_wide_access_168(obj_t, type_bglt, obj_t, obj_t);
static obj_t _import_wide_class_makes_1588_100_object_wide_access_168(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t _make_wide_class_accessors_sans_makes_1587_81_object_wide_access_168(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t make_class_allocate__44_object_access(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t require_initialization_114_object_wide_access_168 = BUNSPEC;
extern bool_t final_class__126_object_class(obj_t);
extern obj_t find_class_constructors_231_object_class(tclass_bglt);
static obj_t cnst_init_137_object_wide_access_168();
static obj_t __cnst[25];

DEFINE_EXPORT_PROCEDURE(import_wide_class_makes__env_170_object_wide_access_168, _import_wide_class_makes_1588_100_object_wide_access_1681604, _import_wide_class_makes_1588_100_object_wide_access_168, 0L, 4);
DEFINE_EXPORT_PROCEDURE(make_wide_class_accessors_sans_makes__env_216_object_wide_access_168, _make_wide_class_accessors_sans_makes_1587_81_object_wide_access_1681605, _make_wide_class_accessors_sans_makes_1587_81_object_wide_access_168, 0L, 4);
DEFINE_EXPORT_PROCEDURE(import_wide_class_accessors__env_94_object_wide_access_168, _import_wide_class_accessors__85_object_wide_access_1681606, _import_wide_class_accessors__85_object_wide_access_168, 0L, 4);
DEFINE_STRING(string1599_object_wide_access_168, string1599_object_wide_access_1681607, "OBJECT-WIDENING-SET! @ CLASS-NUM OBJECT-CLASS-NUM-SET! FREE-PRAGMA LET DEFINE DEFINE-INLINE (INLINE) NEW AUX MAKE (\"/home/tahoe2/serrano/tmp/bigloo/comptime/Object/wide-access.scm\" . 10509) (\"/home/tahoe2/serrano/tmp/bigloo/comptime/Object/wide-access.scm\" . 8910) (\"/home/tahoe2/serrano/tmp/bigloo/comptime/Object/wide-access.scm\" . 6395) - MAKE- WIDENING FOREIGN (\"/home/tahoe2/serrano/tmp/bigloo/comptime/Object/wide-access.scm\" . 3466) (BEGIN (GLOBAL? HOLDER)) (HOLDER) HOLDER STATIC (EXPORT STATIC) ", 504);
DEFINE_STRING(string1598_object_wide_access_168, string1598_object_wide_access_1681608, "((", 2);
DEFINE_STRING(string1597_object_wide_access_168, string1597_object_wide_access_1681609, ")($1))", 6);
DEFINE_STRING(string1596_object_wide_access_168, string1596_object_wide_access_1681610, "Should not be able to see a plain class here", 44);
DEFINE_STRING(string1595_object_wide_access_168, string1595_object_wide_access_1681611, "make-wide-class-accesses!", 25);
DEFINE_STRING(string1594_object_wide_access_168, string1594_object_wide_access_1681612, "super of wide class `", 21);
DEFINE_STRING(string1593_object_wide_access_168, string1593_object_wide_access_1681613, "' is not a final class", 22);
DEFINE_STRING(string1592_object_wide_access_168, string1592_object_wide_access_1681614, "A class can't be `wide' and `final'", 35);
DEFINE_STRING(string1591_object_wide_access_168, string1591_object_wide_access_1681615, "' is a wide class", 17);
DEFINE_STRING(string1589_object_wide_access_168, string1589_object_wide_access_1681616, "' is not a class", 16);
DEFINE_STRING(string1590_object_wide_access_168, string1590_object_wide_access_1681617, "super of `", 10);
DEFINE_EXPORT_PROCEDURE(make_wide_class_accessors__env_98_object_wide_access_168, _make_wide_class_accessors__205_object_wide_access_1681618, _make_wide_class_accessors__205_object_wide_access_168, 0L, 4);



/* module-initialization */
obj_t 
module_initialization_70_object_wide_access_168(long checksum_1462, char *from_1463)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_object_wide_access_168))
	{
	   require_initialization_114_object_wide_access_168 =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_object_wide_access_168();
	   cnst_init_137_object_wide_access_168();
	   imported_modules_init_94_object_wide_access_168();
	   method_init_76_object_wide_access_168();
	   toplevel_init_63_object_wide_access_168();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_object_wide_access_168()
{
   AN_OBJECT;
   {	/* Object/wide-access.scm 20 */
      module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "OBJECT_WIDE-ACCESS");
      module_initialization_70___r4_symbols_6_4(((long) 0), "OBJECT_WIDE-ACCESS");
      module_initialization_70___r5_control_features_6_4(((long) 0), "OBJECT_WIDE-ACCESS");
      module_initialization_70___eval(((long) 0), "OBJECT_WIDE-ACCESS");
      module_initialization_70___object(((long) 0), "OBJECT_WIDE-ACCESS");
      module_initialization_70___evenv(((long) 0), "OBJECT_WIDE-ACCESS");
      module_initialization_70___reader(((long) 0), "OBJECT_WIDE-ACCESS");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_object_wide_access_168()
{
   AN_OBJECT;
   {	/* Object/wide-access.scm 20 */
      {		/* Object/wide-access.scm 20 */
	 obj_t cnst_port_138_1455;
	 cnst_port_138_1455 =
	    open_input_string(string1599_object_wide_access_168);
	 {
	    long i_1456;
	    i_1456 = ((long) 24);
	  loop_1457:
	    {	/* Object/wide-access.scm 20 */
	       bool_t test1600_1458;
	       test1600_1458 =
		  (i_1456 == ((long) -1));
	       if (test1600_1458)
		 {	/* Object/wide-access.scm 20 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Object/wide-access.scm 20 */
		    {	/* Object/wide-access.scm 20 */
		       obj_t arg1601_1459;
		       {	/* Object/wide-access.scm 20 */
			  obj_t list1602_1460;
			  list1602_1460 =
			     MAKE_PAIR(cnst_port_138_1455, BNIL);
			  arg1601_1459 =
			     read___reader(list1602_1460);
		       }
		       CNST_TABLE_SET(i_1456, arg1601_1459);
		    }
		    {	/* Object/wide-access.scm 20 */
		       int aux_1461;
		       {	/* Object/wide-access.scm 20 */
			  long aux_1485;
			  aux_1485 =
			     (i_1456 - ((long) 1));
			  aux_1461 =
			     (int) (aux_1485);
		       }
		       {
			  long i_1488;
			  i_1488 =
			     (long) (aux_1461);
			  i_1456 = i_1488;
			  goto loop_1457;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_object_wide_access_168()
{
   AN_OBJECT;
   {	/* Object/wide-access.scm 20 */
      return BUNSPEC;
   }
}



/* make-wide-class-accessors! */
obj_t 
make_wide_class_accessors__22_object_wide_access_168(obj_t class_def_12_71, type_bglt class_72, obj_t src_def_101_73, obj_t import_74)
{
   AN_OBJECT;
   {	/* Object/wide-access.scm 47 */
      {		/* Object/wide-access.scm 48 */
	 bool_t test1253_523;
	 {	/* Object/wide-access.scm 48 */
	    bool_t test1282_569;
	    test1282_569 =
	       is_a__118___object(
	       (obj_t) (class_72), tclass_object_class);
	    if (test1282_569)
	      {		/* ./Object/class.scm 1257 */
		 obj_t aux_1493;
		 {	/* Object/wide-access.scm 48 */
		    tclass_bglt obj_1095;
		    obj_1095 =
		       (tclass_bglt) (class_72);
		    {
		       obj_t aux_1495;
		       {	/* ./Object/class.scm 1257 */
			  object_bglt aux_1496;
			  aux_1496 =
			     (object_bglt) (obj_1095);
			  aux_1495 =
			     OBJECT_WIDENING(aux_1496);
		       }
		       aux_1493 =
			  (((tclass_bglt) CREF(aux_1495))->its_super_214);
		    }
		 }
		 test1253_523 =
		    is_a__118___object(aux_1493, tclass_object_class);
	      }
	    else
	      {		/* Object/wide-access.scm 48 */
		 test1253_523 = ((bool_t) 0);
	      }
	 }
	 if (test1253_523)
	   {	/* Object/wide-access.scm 49 */
	      bool_t test1254_524;
	      {		/* Object/wide-access.scm 49 */
		 obj_t aux_1502;
		 aux_1502 =
		    correct_wide_class__226_object_wide_access_168(class_72, src_def_101_73);
		 test1254_524 =
		    CBOOL(aux_1502);
	      }
	      if (test1254_524)
		{	/* Object/wide-access.scm 50 */
		   obj_t super_525;
		   {	/* Object/wide-access.scm 50 */
		      tclass_bglt obj_1097;
		      obj_1097 =
			 (tclass_bglt) (class_72);
		      {
			 obj_t aux_1507;
			 {	/* ./Object/class.scm 1257 */
			    object_bglt aux_1508;
			    aux_1508 =
			       (object_bglt) (obj_1097);
			    aux_1507 =
			       OBJECT_WIDENING(aux_1508);
			 }
			 super_525 =
			    (((tclass_bglt) CREF(aux_1507))->its_super_214);
		      }
		   }
		   {	/* Object/wide-access.scm 50 */
		      obj_t domestic__170_526;
		      domestic__170_526 =
			 memq___r4_pairs_and_lists_6_3(import_74,
			 CNST_TABLE_REF(((long) 0)));
		      {		/* Object/wide-access.scm 51 */
			 obj_t sslots_527;
			 {	/* Object/wide-access.scm 52 */
			    tclass_bglt obj_1098;
			    obj_1098 =
			       (tclass_bglt) (super_525);
			    {
			       obj_t aux_1515;
			       {	/* ./Object/class.scm 1261 */
				  object_bglt aux_1516;
				  aux_1516 =
				     (object_bglt) (obj_1098);
				  aux_1515 =
				     OBJECT_WIDENING(aux_1516);
			       }
			       sslots_527 =
				  (((tclass_bglt) CREF(aux_1515))->slots);
			    }
			 }
			 {	/* Object/wide-access.scm 52 */
			    obj_t slots_528;
			    {	/* ./Ieee/pair-list.scm 5707 */
			       obj_t aux_1520;
			       aux_1520 =
				  CDR(class_def_12_71);
			       slots_528 =
				  CDR(aux_1520);
			    }
			    {	/* Object/wide-access.scm 53 */
			       obj_t super_vnum_51_529;
			       {	/* Object/wide-access.scm 54 */
				  bool_t test1281_568;
				  test1281_568 =
				     is_a__118___object(super_525, tclass_object_class);
				  if (test1281_568)
				    {	/* Object/wide-access.scm 55 */
				       tclass_bglt obj_1104;
				       obj_1104 =
					  (tclass_bglt) (super_525);
				       {
					  obj_t aux_1526;
					  {	/* ./Object/class.scm 1273 */
					     object_bglt aux_1527;
					     aux_1527 =
						(object_bglt) (obj_1104);
					     aux_1526 =
						OBJECT_WIDENING(aux_1527);
					  }
					  super_vnum_51_529 =
					     (((tclass_bglt) CREF(aux_1526))->virtual_slots_number_200);
				       }
				    }
				  else
				    {	/* Object/wide-access.scm 54 */
				       super_vnum_51_529 =
					  BINT(((long) 0));
				    }
			       }
			       {	/* Object/wide-access.scm 54 */
				  obj_t cslots_530;
				  cslots_530 =
				     make_class_slots_205_object_slots(
				     (tclass_bglt) (class_72), slots_528, BFALSE,
				     CINT(super_vnum_51_529), src_def_101_73);
				  {	/* Object/wide-access.scm 57 */
				     obj_t class_id_86_531;
				     class_id_86_531 =
					(((type_bglt) CREF(class_72))->id);
				     {	/* Object/wide-access.scm 61 */
					global_bglt holder_533;
					{	/* Object/wide-access.scm 62 */
					   tclass_bglt obj_1107;
					   obj_1107 =
					      (tclass_bglt) (class_72);
					   {
					      obj_t aux_1537;
					      {		/* ./Object/class.scm 1263 */
						 object_bglt aux_1538;
						 aux_1538 =
						    (object_bglt) (obj_1107);
						 aux_1537 =
						    OBJECT_WIDENING(aux_1538);
					      }
					      holder_533 =
						 (((tclass_bglt) CREF(aux_1537))->holder);
					   }
					}
					{	/* Object/wide-access.scm 63 */
					   obj_t widening_535;
					   {	/* Object/wide-access.scm 64 */
					      tclass_bglt obj_1109;
					      obj_1109 =
						 (tclass_bglt) (class_72);
					      {
						 obj_t aux_1543;
						 {	/* ./Object/class.scm 1265 */
						    object_bglt aux_1544;
						    aux_1544 =
						       (object_bglt) (obj_1109);
						    aux_1543 =
						       OBJECT_WIDENING(aux_1544);
						 }
						 widening_535 =
						    (((tclass_bglt) CREF(aux_1543))->widening);
					      }
					   }
					   {	/* Object/wide-access.scm 64 */
					      obj_t import_536;
					      if (
						 CBOOL(domestic__170_526))
						{	/* Object/wide-access.scm 65 */
						   import_536 = import_74;
						}
					      else
						{	/* Object/wide-access.scm 65 */
						   import_536 =
						      CNST_TABLE_REF(((long) 1));
						}
					      {		/* Object/wide-access.scm 65 */
						 obj_t local_vnum_209_537;
						 local_vnum_209_537 =
						    get_local_virtual_slots_number_139_object_slots(
						    (tclass_bglt) (class_72), cslots_530);
						 {	/* Object/wide-access.scm 69 */

						    {	/* Object/wide-access.scm 71 */
						       tclass_bglt obj_1112;
						       obj_t val1199_1113;
						       obj_1112 =
							  (tclass_bglt) (class_72);
						       {	/* Object/wide-access.scm 71 */
							  long aux_1554;
							  {	/* ./Ieee/fixnum.scm 7193 */
							     long aux_1557;
							     long aux_1555;
							     aux_1557 =
								(long) CINT(local_vnum_209_537);
							     aux_1555 =
								(long) CINT(super_vnum_51_529);
							     aux_1554 =
								(aux_1555 + aux_1557);
							  }
							  val1199_1113 =
							     BINT(aux_1554);
						       }
						       {
							  obj_t aux_1561;
							  {	/* ./Object/class.scm 1273 */
							     object_bglt aux_1562;
							     aux_1562 =
								(object_bglt) (obj_1112);
							     aux_1561 =
								OBJECT_WIDENING(aux_1562);
							  }
							  ((((tclass_bglt) CREF(aux_1561))->virtual_slots_number_200) = ((obj_t) val1199_1113), BUNSPEC);
						       }
						    }
						    {	/* Object/wide-access.scm 76 */
						       obj_t arg1255_539;
						       arg1255_539 =
							  make_coercion_clause_209_object_access(class_id_86_531, super_525);
						       produce_module_clause__172_module_module(arg1255_539);
						    }
						    {	/* Object/wide-access.scm 77 */
						       bool_t test1256_540;
						       test1256_540 =
							  is_a__118___object(
							  (obj_t) (holder_533), global_ast_var);
						       if (test1256_540)
							 {	/* Object/wide-access.scm 77 */
							    BUNSPEC;
							 }
						       else
							 {	/* Object/wide-access.scm 77 */
							    {	/* Object/wide-access.scm 77 */
							       obj_t arg1257_541;
							       obj_t arg1258_542;
							       arg1257_541 =
								  CNST_TABLE_REF(((long) 2));
							       {	/* Object/wide-access.scm 77 */
								  obj_t aux_1572;
								  aux_1572 =
								     (obj_t) (holder_533);
								  arg1258_542 =
								     __EVMEANING_ADDRESS(aux_1572);
							       }
							       define_primop_ref__105___evenv(arg1257_541, arg1258_542);
							    }
							    notify_assert_fail_37___eval(
							       CNST_TABLE_REF(((long) 3)),
							       CNST_TABLE_REF(((long) 4)),
							       CNST_TABLE_REF(((long) 5)));
							    unbind_primop__163___evenv(
							       CNST_TABLE_REF(((long) 2)));
							 }
						    }
						    {	/* Object/wide-access.scm 78 */
						       tclass_bglt obj_1115;
						       obj_1115 =
							  (tclass_bglt) (class_72);
						       {
							  obj_t aux_1583;
							  {	/* ./Object/class.scm 1261 */
							     object_bglt aux_1584;
							     aux_1584 =
								(object_bglt) (obj_1115);
							     aux_1583 =
								OBJECT_WIDENING(aux_1584);
							  }
							  ((((tclass_bglt) CREF(aux_1583))->slots) = ((obj_t) cslots_530), BUNSPEC);
						       }
						    }
						    {	/* Object/wide-access.scm 80 */
						       obj_t arg1259_543;
						       {	/* Object/wide-access.scm 80 */
							  obj_t arg1260_544;
							  obj_t arg1261_545;
							  arg1260_544 =
							     CNST_TABLE_REF(((long) 6));
							  {	/* Object/wide-access.scm 80 */
							     obj_t arg1263_546;
							     arg1263_546 =
								make_class_coercers_236_object_access(
								(obj_t) (class_72));
							     arg1261_545 =
								append_2_18___r4_pairs_and_lists_6_3(arg1263_546, BNIL);
							  }
							  arg1259_543 =
							     MAKE_PAIR(arg1260_544, arg1261_545);
						       }
						       produce_module_clause__172_module_module(arg1259_543);
						    }
						    {	/* Object/wide-access.scm 82 */
						       obj_t plain_access_84_548;
						       plain_access_84_548 =
							  make_class_slots_access__80_object_access(
							  (tclass_bglt) (class_72), super_525, sslots_527, BFALSE, src_def_101_73, import_536);
						       {	/* Object/wide-access.scm 85 */
							  obj_t plain_virtuals_71_549;
							  plain_virtuals_71_549 = _res1__155___r5_control_features_6_4;
							  {	/* Object/wide-access.scm 85 */
							     obj_t wide_access_149_550;
							     wide_access_149_550 =
								make_class_slots_access__80_object_access(
								(tclass_bglt) (class_72),
								(obj_t) (class_72), cslots_530,
								(obj_t) (class_72), src_def_101_73, import_536);
							     {	/* Object/wide-access.scm 89 */
								obj_t wide_virtuals_12_551;
								wide_virtuals_12_551 = _res1__155___r5_control_features_6_4;
								{	/* Object/wide-access.scm 89 */
								   obj_t accs_552;
								   {	/* Object/wide-access.scm 89 */
								      obj_t arg1271_560;
								      obj_t arg1272_561;
								      obj_t arg1273_562;
								      arg1271_560 =
									 make_class_pred__174_object_access(class_id_86_531,
									 (tclass_bglt) (class_72), src_def_101_73, import_536);
								      arg1272_561 =
									 make_class_makes__132_object_access(
									 CNST_TABLE_REF(((long) 7)), widening_535, class_id_86_531,
									 (obj_t) (class_72), cslots_530, src_def_101_73, import_536);
								      {		/* Object/wide-access.scm 330 */
									 obj_t mk_heap_id_73_1125;
									 {	/* Object/wide-access.scm 330 */
									    obj_t list1378_1126;
									    {	/* Object/wide-access.scm 330 */
									       obj_t arg1379_1127;
									       obj_t arg1380_1128;
									       arg1379_1127 =
										  CNST_TABLE_REF(((long) 8));
									       arg1380_1128 =
										  MAKE_PAIR(class_id_86_531, BNIL);
									       list1378_1126 =
										  MAKE_PAIR(arg1379_1127, arg1380_1128);
									    }
									    mk_heap_id_73_1125 =
									       symbol_append_197___r4_symbols_6_4(list1378_1126);
									 }
									 {	/* Object/wide-access.scm 331 */
									    obj_t arg1376_1129;
									    arg1376_1129 =
									       make_wide_class_make__242_object_wide_access_168(
									       CNST_TABLE_REF(((long) 9)), class_id_86_531, class_72, cslots_530, sslots_527, src_def_101_73, import_536);
									    {	/* Object/wide-access.scm 331 */
									       obj_t list1377_1130;
									       list1377_1130 =
										  MAKE_PAIR(arg1376_1129, BNIL);
									       arg1273_562 = list1377_1130;
									    }
									 }
								      }
								      {		/* Object/wide-access.scm 89 */
									 obj_t list1274_563;
									 {	/* Object/wide-access.scm 89 */
									    obj_t arg1276_564;
									    {	/* Object/wide-access.scm 89 */
									       obj_t arg1277_565;
									       {	/* Object/wide-access.scm 89 */
										  obj_t arg1278_566;
										  {	/* Object/wide-access.scm 89 */
										     obj_t arg1280_567;
										     arg1280_567 =
											MAKE_PAIR(wide_access_149_550, BNIL);
										     arg1278_566 =
											MAKE_PAIR(plain_access_84_548, arg1280_567);
										  }
										  arg1277_565 =
										     MAKE_PAIR(arg1273_562, arg1278_566);
									       }
									       arg1276_564 =
										  MAKE_PAIR(arg1272_561, arg1277_565);
									    }
									    list1274_563 =
									       MAKE_PAIR(arg1271_560, arg1276_564);
									 }
									 accs_552 =
									    append___r4_pairs_and_lists_6_3(list1274_563);
								      }
								   }
								   {	/* Object/wide-access.scm 108 */
								      obj_t val0_1221_553;
								      obj_t val1_1222_554;
								      {		/* Object/wide-access.scm 108 */
									 obj_t arg1265_555;
									 obj_t arg1267_556;
									 arg1265_555 =
									    make_class_allocate__44_object_access(class_id_86_531, super_525,
									    (obj_t) (holder_533), src_def_101_73, import_536);
									 if (
									    CBOOL(domestic__170_526))
									   {	/* Object/wide-access.scm 115 */
									      obj_t arg1268_557;
									      obj_t arg1269_558;
									      arg1268_557 =
										 make_wide_object__struct_148_object_struct(class_id_86_531, class_72, _module__166_module_module, cslots_530, src_def_101_73);
									      {		/* Object/wide-access.scm 120 */
										 obj_t arg1270_559;
										 arg1270_559 =
										    make_struct__wide_object_7_object_struct(class_id_86_531, class_72, _module__166_module_module, cslots_530, src_def_101_73);
										 arg1269_558 =
										    MAKE_PAIR(arg1270_559, accs_552);
									      }
									      arg1267_556 =
										 MAKE_PAIR(arg1268_557, arg1269_558);
									   }
									 else
									   {	/* Object/wide-access.scm 113 */
									      arg1267_556 = accs_552;
									   }
									 val0_1221_553 =
									    MAKE_PAIR(arg1265_555, arg1267_556);
								      }
								      val1_1222_554 =
									 append_2_18___r4_pairs_and_lists_6_3(plain_virtuals_71_549, wide_virtuals_12_551);
								      _res_number__75___r5_control_features_6_4 =
									 BINT(((long) 2));
								      _res1__155___r5_control_features_6_4 = val1_1222_554;
								      return val0_1221_553;
								   }
								}
							     }
							  }
						       }
						    }
						 }
					      }
					   }
					}
				     }
				  }
			       }
			    }
			 }
		      }
		   }
		}
	      else
		{	/* Object/wide-access.scm 49 */
		   return BUNSPEC;
		}
	   }
	 else
	   {	/* Object/wide-access.scm 48 */
	      return BNIL;
	   }
      }
   }
}



/* _make-wide-class-accessors! */
obj_t 
_make_wide_class_accessors__205_object_wide_access_168(obj_t env_1434, obj_t class_def_12_1435, obj_t class_1436, obj_t src_def_101_1437, obj_t import_1438)
{
   AN_OBJECT;
   {	/* Object/wide-access.scm 47 */
      return
	 make_wide_class_accessors__22_object_wide_access_168(class_def_12_1435,
	 (type_bglt) (class_1436), src_def_101_1437, import_1438);
   }
}



/* make-wide-class-accessors-sans-makes! */
obj_t 
make_wide_class_accessors_sans_makes__153_object_wide_access_168(obj_t class_def_12_75, type_bglt class_76, obj_t src_def_101_77, obj_t import_78)
{
   AN_OBJECT;
   {	/* Object/wide-access.scm 133 */
      {		/* Object/wide-access.scm 134 */
	 bool_t test1287_571;
	 {	/* Object/wide-access.scm 134 */
	    bool_t test1309_613;
	    test1309_613 =
	       is_a__118___object(
	       (obj_t) (class_76), tclass_object_class);
	    if (test1309_613)
	      {		/* ./Object/class.scm 1257 */
		 obj_t aux_1634;
		 {	/* Object/wide-access.scm 134 */
		    tclass_bglt obj_1139;
		    obj_1139 =
		       (tclass_bglt) (class_76);
		    {
		       obj_t aux_1636;
		       {	/* ./Object/class.scm 1257 */
			  object_bglt aux_1637;
			  aux_1637 =
			     (object_bglt) (obj_1139);
			  aux_1636 =
			     OBJECT_WIDENING(aux_1637);
		       }
		       aux_1634 =
			  (((tclass_bglt) CREF(aux_1636))->its_super_214);
		    }
		 }
		 test1287_571 =
		    is_a__118___object(aux_1634, tclass_object_class);
	      }
	    else
	      {		/* Object/wide-access.scm 134 */
		 test1287_571 = ((bool_t) 0);
	      }
	 }
	 if (test1287_571)
	   {	/* Object/wide-access.scm 135 */
	      bool_t test1288_572;
	      {		/* Object/wide-access.scm 135 */
		 obj_t aux_1643;
		 aux_1643 =
		    correct_wide_class__226_object_wide_access_168(class_76, src_def_101_77);
		 test1288_572 =
		    CBOOL(aux_1643);
	      }
	      if (test1288_572)
		{	/* Object/wide-access.scm 136 */
		   obj_t super_573;
		   {	/* Object/wide-access.scm 136 */
		      tclass_bglt obj_1141;
		      obj_1141 =
			 (tclass_bglt) (class_76);
		      {
			 obj_t aux_1648;
			 {	/* ./Object/class.scm 1257 */
			    object_bglt aux_1649;
			    aux_1649 =
			       (object_bglt) (obj_1141);
			    aux_1648 =
			       OBJECT_WIDENING(aux_1649);
			 }
			 super_573 =
			    (((tclass_bglt) CREF(aux_1648))->its_super_214);
		      }
		   }
		   {	/* Object/wide-access.scm 136 */
		      obj_t domestic__170_574;
		      domestic__170_574 =
			 memq___r4_pairs_and_lists_6_3(import_78,
			 CNST_TABLE_REF(((long) 0)));
		      {		/* Object/wide-access.scm 137 */
			 obj_t sslots_575;
			 {	/* Object/wide-access.scm 138 */
			    tclass_bglt obj_1142;
			    obj_1142 =
			       (tclass_bglt) (super_573);
			    {
			       obj_t aux_1656;
			       {	/* ./Object/class.scm 1261 */
				  object_bglt aux_1657;
				  aux_1657 =
				     (object_bglt) (obj_1142);
				  aux_1656 =
				     OBJECT_WIDENING(aux_1657);
			       }
			       sslots_575 =
				  (((tclass_bglt) CREF(aux_1656))->slots);
			    }
			 }
			 {	/* Object/wide-access.scm 138 */
			    obj_t slots_576;
			    {	/* ./Ieee/pair-list.scm 5707 */
			       obj_t aux_1661;
			       aux_1661 =
				  CDR(class_def_12_75);
			       slots_576 =
				  CDR(aux_1661);
			    }
			    {	/* Object/wide-access.scm 139 */
			       obj_t super_vnum_51_577;
			       {	/* Object/wide-access.scm 140 */
				  bool_t test1308_612;
				  test1308_612 =
				     is_a__118___object(super_573, tclass_object_class);
				  if (test1308_612)
				    {	/* Object/wide-access.scm 141 */
				       tclass_bglt obj_1148;
				       obj_1148 =
					  (tclass_bglt) (super_573);
				       {
					  obj_t aux_1667;
					  {	/* ./Object/class.scm 1273 */
					     object_bglt aux_1668;
					     aux_1668 =
						(object_bglt) (obj_1148);
					     aux_1667 =
						OBJECT_WIDENING(aux_1668);
					  }
					  super_vnum_51_577 =
					     (((tclass_bglt) CREF(aux_1667))->virtual_slots_number_200);
				       }
				    }
				  else
				    {	/* Object/wide-access.scm 140 */
				       super_vnum_51_577 =
					  BINT(((long) 0));
				    }
			       }
			       {	/* Object/wide-access.scm 140 */
				  obj_t cslots_578;
				  cslots_578 =
				     make_class_slots_205_object_slots(
				     (tclass_bglt) (class_76), slots_576, BFALSE,
				     CINT(super_vnum_51_577), src_def_101_77);
				  {	/* Object/wide-access.scm 143 */
				     obj_t class_id_86_579;
				     class_id_86_579 =
					(((type_bglt) CREF(class_76))->id);
				     {	/* Object/wide-access.scm 147 */
					global_bglt holder_581;
					{	/* Object/wide-access.scm 148 */
					   tclass_bglt obj_1151;
					   obj_1151 =
					      (tclass_bglt) (class_76);
					   {
					      obj_t aux_1678;
					      {		/* ./Object/class.scm 1263 */
						 object_bglt aux_1679;
						 aux_1679 =
						    (object_bglt) (obj_1151);
						 aux_1678 =
						    OBJECT_WIDENING(aux_1679);
					      }
					      holder_581 =
						 (((tclass_bglt) CREF(aux_1678))->holder);
					   }
					}
					{	/* Object/wide-access.scm 150 */
					   obj_t import_584;
					   if (
					      CBOOL(domestic__170_574))
					     {	/* Object/wide-access.scm 151 */
						import_584 = import_78;
					     }
					   else
					     {	/* Object/wide-access.scm 151 */
						import_584 =
						   CNST_TABLE_REF(((long) 1));
					     }
					   {	/* Object/wide-access.scm 151 */
					      obj_t local_vnum_209_585;
					      local_vnum_209_585 =
						 get_local_virtual_slots_number_139_object_slots(
						 (tclass_bglt) (class_76), cslots_578);
					      {		/* Object/wide-access.scm 155 */

						 {	/* Object/wide-access.scm 157 */
						    tclass_bglt obj_1156;
						    obj_t val1199_1157;
						    obj_1156 =
						       (tclass_bglt) (class_76);
						    {	/* Object/wide-access.scm 157 */
						       long aux_1689;
						       {	/* ./Ieee/fixnum.scm 7193 */
							  long aux_1692;
							  long aux_1690;
							  aux_1692 =
							     (long) CINT(local_vnum_209_585);
							  aux_1690 =
							     (long) CINT(super_vnum_51_577);
							  aux_1689 =
							     (aux_1690 + aux_1692);
						       }
						       val1199_1157 =
							  BINT(aux_1689);
						    }
						    {
						       obj_t aux_1696;
						       {	/* ./Object/class.scm 1273 */
							  object_bglt aux_1697;
							  aux_1697 =
							     (object_bglt) (obj_1156);
							  aux_1696 =
							     OBJECT_WIDENING(aux_1697);
						       }
						       ((((tclass_bglt) CREF(aux_1696))->virtual_slots_number_200) = ((obj_t) val1199_1157), BUNSPEC);
						    }
						 }
						 {	/* Object/wide-access.scm 162 */
						    obj_t arg1289_587;
						    arg1289_587 =
						       make_coercion_clause_209_object_access(class_id_86_579, super_573);
						    produce_module_clause__172_module_module(arg1289_587);
						 }
						 {	/* Object/wide-access.scm 163 */
						    bool_t test1290_588;
						    test1290_588 =
						       is_a__118___object(
						       (obj_t) (holder_581), global_ast_var);
						    if (test1290_588)
						      {		/* Object/wide-access.scm 163 */
							 BUNSPEC;
						      }
						    else
						      {		/* Object/wide-access.scm 163 */
							 {	/* Object/wide-access.scm 163 */
							    obj_t arg1291_589;
							    obj_t arg1292_590;
							    arg1291_589 =
							       CNST_TABLE_REF(((long) 2));
							    {	/* Object/wide-access.scm 163 */
							       obj_t aux_1707;
							       aux_1707 =
								  (obj_t) (holder_581);
							       arg1292_590 =
								  __EVMEANING_ADDRESS(aux_1707);
							    }
							    define_primop_ref__105___evenv(arg1291_589, arg1292_590);
							 }
							 notify_assert_fail_37___eval(
							    CNST_TABLE_REF(((long) 3)),
							    CNST_TABLE_REF(((long) 4)),
							    CNST_TABLE_REF(((long) 10)));
							 unbind_primop__163___evenv(
							    CNST_TABLE_REF(((long) 2)));
						      }
						 }
						 {	/* Object/wide-access.scm 164 */
						    tclass_bglt obj_1159;
						    obj_1159 =
						       (tclass_bglt) (class_76);
						    {
						       obj_t aux_1718;
						       {	/* ./Object/class.scm 1261 */
							  object_bglt aux_1719;
							  aux_1719 =
							     (object_bglt) (obj_1159);
							  aux_1718 =
							     OBJECT_WIDENING(aux_1719);
						       }
						       ((((tclass_bglt) CREF(aux_1718))->slots) = ((obj_t) cslots_578), BUNSPEC);
						    }
						 }
						 {	/* Object/wide-access.scm 166 */
						    obj_t arg1293_591;
						    {	/* Object/wide-access.scm 166 */
						       obj_t arg1294_592;
						       obj_t arg1295_593;
						       arg1294_592 =
							  CNST_TABLE_REF(((long) 6));
						       {	/* Object/wide-access.scm 166 */
							  obj_t arg1296_594;
							  arg1296_594 =
							     make_class_coercers_236_object_access(
							     (obj_t) (class_76));
							  arg1295_593 =
							     append_2_18___r4_pairs_and_lists_6_3(arg1296_594, BNIL);
						       }
						       arg1293_591 =
							  MAKE_PAIR(arg1294_592, arg1295_593);
						    }
						    produce_module_clause__172_module_module(arg1293_591);
						 }
						 {	/* Object/wide-access.scm 168 */
						    obj_t plain_access_84_596;
						    plain_access_84_596 =
						       make_class_slots_access__80_object_access(
						       (tclass_bglt) (class_76), super_573, sslots_575, BFALSE, src_def_101_77, import_584);
						    {	/* Object/wide-access.scm 171 */
						       obj_t plain_virtuals_71_597;
						       plain_virtuals_71_597 = _res1__155___r5_control_features_6_4;
						       {	/* Object/wide-access.scm 171 */
							  obj_t wide_access_149_598;
							  wide_access_149_598 =
							     make_class_slots_access__80_object_access(
							     (tclass_bglt) (class_76),
							     (obj_t) (class_76), cslots_578,
							     (obj_t) (class_76), src_def_101_77, import_584);
							  {	/* Object/wide-access.scm 175 */
							     obj_t wide_virtuals_12_599;
							     wide_virtuals_12_599 = _res1__155___r5_control_features_6_4;
							     {	/* Object/wide-access.scm 175 */
								obj_t accs_600;
								{	/* Object/wide-access.scm 175 */
								   obj_t arg1303_608;
								   arg1303_608 =
								      make_class_pred__174_object_access(class_id_86_579,
								      (tclass_bglt) (class_76), src_def_101_77, import_584);
								   {	/* Object/wide-access.scm 175 */
								      obj_t list1304_609;
								      {		/* Object/wide-access.scm 175 */
									 obj_t arg1305_610;
									 {	/* Object/wide-access.scm 175 */
									    obj_t arg1307_611;
									    arg1307_611 =
									       MAKE_PAIR(wide_access_149_598, BNIL);
									    arg1305_610 =
									       MAKE_PAIR(plain_access_84_596, arg1307_611);
									 }
									 list1304_609 =
									    MAKE_PAIR(arg1303_608, arg1305_610);
								      }
								      accs_600 =
									 append___r4_pairs_and_lists_6_3(list1304_609);
								   }
								}
								{	/* Object/wide-access.scm 181 */
								   obj_t val0_1223_601;
								   obj_t val1_1224_602;
								   {	/* Object/wide-access.scm 181 */
								      obj_t arg1298_603;
								      obj_t arg1299_604;
								      arg1298_603 =
									 make_class_allocate__44_object_access(class_id_86_579, super_573,
									 (obj_t) (holder_581), src_def_101_77, import_584);
								      if (
									 CBOOL(domestic__170_574))
									{	/* Object/wide-access.scm 188 */
									   obj_t arg1300_605;
									   obj_t arg1301_606;
									   arg1300_605 =
									      make_wide_object__struct_148_object_struct(class_id_86_579, class_76, _module__166_module_module, cslots_578, src_def_101_77);
									   {	/* Object/wide-access.scm 193 */
									      obj_t arg1302_607;
									      arg1302_607 =
										 make_struct__wide_object_7_object_struct(class_id_86_579, class_76, _module__166_module_module, cslots_578, src_def_101_77);
									      arg1301_606 =
										 MAKE_PAIR(arg1302_607, accs_600);
									   }
									   arg1299_604 =
									      MAKE_PAIR(arg1300_605, arg1301_606);
									}
								      else
									{	/* Object/wide-access.scm 186 */
									   arg1299_604 = accs_600;
									}
								      val0_1223_601 =
									 MAKE_PAIR(arg1298_603, arg1299_604);
								   }
								   val1_1224_602 =
								      append_2_18___r4_pairs_and_lists_6_3(plain_virtuals_71_597, wide_virtuals_12_599);
								   _res_number__75___r5_control_features_6_4 =
								      BINT(((long) 2));
								   _res1__155___r5_control_features_6_4 = val1_1224_602;
								   return val0_1223_601;
								}
							     }
							  }
						       }
						    }
						 }
					      }
					   }
					}
				     }
				  }
			       }
			    }
			 }
		      }
		   }
		}
	      else
		{	/* Object/wide-access.scm 135 */
		   return BUNSPEC;
		}
	   }
	 else
	   {	/* Object/wide-access.scm 134 */
	      return BNIL;
	   }
      }
   }
}



/* _make-wide-class-accessors-sans-makes!1587 */
obj_t 
_make_wide_class_accessors_sans_makes_1587_81_object_wide_access_168(obj_t env_1439, obj_t class_def_12_1440, obj_t class_1441, obj_t src_def_101_1442, obj_t import_1443)
{
   AN_OBJECT;
   {	/* Object/wide-access.scm 133 */
      return
	 make_wide_class_accessors_sans_makes__153_object_wide_access_168(class_def_12_1440,
	 (type_bglt) (class_1441), src_def_101_1442, import_1443);
   }
}



/* import-wide-class-accessors! */
obj_t 
import_wide_class_accessors__236_object_wide_access_168(obj_t class_def_12_79, type_bglt class_80, obj_t src_def_101_81, obj_t module_82)
{
   AN_OBJECT;
   {	/* Object/wide-access.scm 206 */
      {		/* Object/wide-access.scm 207 */
	 bool_t test1314_615;
	 {	/* Object/wide-access.scm 207 */
	    bool_t test1329_638;
	    test1329_638 =
	       is_a__118___object(
	       (obj_t) (class_80), tclass_object_class);
	    if (test1329_638)
	      {		/* ./Object/class.scm 1257 */
		 obj_t aux_1757;
		 {	/* Object/wide-access.scm 207 */
		    tclass_bglt obj_1170;
		    obj_1170 =
		       (tclass_bglt) (class_80);
		    {
		       obj_t aux_1759;
		       {	/* ./Object/class.scm 1257 */
			  object_bglt aux_1760;
			  aux_1760 =
			     (object_bglt) (obj_1170);
			  aux_1759 =
			     OBJECT_WIDENING(aux_1760);
		       }
		       aux_1757 =
			  (((tclass_bglt) CREF(aux_1759))->its_super_214);
		    }
		 }
		 test1314_615 =
		    is_a__118___object(aux_1757, tclass_object_class);
	      }
	    else
	      {		/* Object/wide-access.scm 207 */
		 test1314_615 = ((bool_t) 0);
	      }
	 }
	 if (test1314_615)
	   {	/* Object/wide-access.scm 208 */
	      bool_t test1315_616;
	      {		/* Object/wide-access.scm 208 */
		 obj_t aux_1766;
		 aux_1766 =
		    correct_wide_class__226_object_wide_access_168(class_80, src_def_101_81);
		 test1315_616 =
		    CBOOL(aux_1766);
	      }
	      if (test1315_616)
		{	/* Object/wide-access.scm 209 */
		   obj_t super_617;
		   {	/* Object/wide-access.scm 209 */
		      tclass_bglt obj_1172;
		      obj_1172 =
			 (tclass_bglt) (class_80);
		      {
			 obj_t aux_1771;
			 {	/* ./Object/class.scm 1257 */
			    object_bglt aux_1772;
			    aux_1772 =
			       (object_bglt) (obj_1172);
			    aux_1771 =
			       OBJECT_WIDENING(aux_1772);
			 }
			 super_617 =
			    (((tclass_bglt) CREF(aux_1771))->its_super_214);
		      }
		   }
		   {	/* Object/wide-access.scm 209 */
		      obj_t super_vnum_51_618;
		      {		/* Object/wide-access.scm 210 */
			 bool_t test1328_637;
			 test1328_637 =
			    is_a__118___object(super_617, tclass_object_class);
			 if (test1328_637)
			   {	/* Object/wide-access.scm 211 */
			      tclass_bglt obj_1174;
			      obj_1174 =
				 (tclass_bglt) (super_617);
			      {
				 obj_t aux_1779;
				 {	/* ./Object/class.scm 1273 */
				    object_bglt aux_1780;
				    aux_1780 =
				       (object_bglt) (obj_1174);
				    aux_1779 =
				       OBJECT_WIDENING(aux_1780);
				 }
				 super_vnum_51_618 =
				    (((tclass_bglt) CREF(aux_1779))->virtual_slots_number_200);
			      }
			   }
			 else
			   {	/* Object/wide-access.scm 210 */
			      super_vnum_51_618 =
				 BINT(((long) 0));
			   }
		      }
		      {		/* Object/wide-access.scm 210 */
			 obj_t sslots_619;
			 {	/* Object/wide-access.scm 213 */
			    tclass_bglt obj_1175;
			    obj_1175 =
			       (tclass_bglt) (super_617);
			    {
			       obj_t aux_1786;
			       {	/* ./Object/class.scm 1261 */
				  object_bglt aux_1787;
				  aux_1787 =
				     (object_bglt) (obj_1175);
				  aux_1786 =
				     OBJECT_WIDENING(aux_1787);
			       }
			       sslots_619 =
				  (((tclass_bglt) CREF(aux_1786))->slots);
			    }
			 }
			 {	/* Object/wide-access.scm 214 */
			    obj_t cslots_621;
			    {	/* Object/wide-access.scm 215 */
			       obj_t aux_1791;
			       {	/* ./Ieee/pair-list.scm 5707 */
				  obj_t aux_1793;
				  aux_1793 =
				     CDR(class_def_12_79);
				  aux_1791 =
				     CDR(aux_1793);
			       }
			       cslots_621 =
				  make_class_slots_205_object_slots(
				  (tclass_bglt) (class_80), aux_1791, BFALSE,
				  CINT(super_vnum_51_618), src_def_101_81);
			    }
			    {	/* Object/wide-access.scm 215 */
			       obj_t class_id_86_622;
			       class_id_86_622 =
				  (((type_bglt) CREF(class_80))->id);
			       {	/* Object/wide-access.scm 219 */
				  global_bglt holder_624;
				  {	/* Object/wide-access.scm 220 */
				     tclass_bglt obj_1182;
				     obj_1182 =
					(tclass_bglt) (class_80);
				     {
					obj_t aux_1800;
					{	/* ./Object/class.scm 1263 */
					   object_bglt aux_1801;
					   aux_1801 =
					      (object_bglt) (obj_1182);
					   aux_1800 =
					      OBJECT_WIDENING(aux_1801);
					}
					holder_624 =
					   (((tclass_bglt) CREF(aux_1800))->holder);
				     }
				  }
				  {	/* Object/wide-access.scm 220 */
				     obj_t module_625;
				     module_625 =
					(((global_bglt) CREF(holder_624))->module);
				     {	/* Object/wide-access.scm 221 */
					obj_t widening_626;
					{	/* Object/wide-access.scm 222 */
					   tclass_bglt obj_1184;
					   obj_1184 =
					      (tclass_bglt) (class_80);
					   {
					      obj_t aux_1807;
					      {		/* ./Object/class.scm 1265 */
						 object_bglt aux_1808;
						 aux_1808 =
						    (object_bglt) (obj_1184);
						 aux_1807 =
						    OBJECT_WIDENING(aux_1808);
					      }
					      widening_626 =
						 (((tclass_bglt) CREF(aux_1807))->widening);
					   }
					}
					{	/* Object/wide-access.scm 222 */
					   obj_t local_vnum_209_627;
					   local_vnum_209_627 =
					      get_local_virtual_slots_number_139_object_slots(
					      (tclass_bglt) (class_80), cslots_621);
					   {	/* Object/wide-access.scm 223 */

					      {		/* Object/wide-access.scm 225 */
						 tclass_bglt obj_1185;
						 obj_1185 =
						    (tclass_bglt) (class_80);
						 {
						    obj_t aux_1815;
						    {	/* ./Object/class.scm 1273 */
						       object_bglt aux_1816;
						       aux_1816 =
							  (object_bglt) (obj_1185);
						       aux_1815 =
							  OBJECT_WIDENING(aux_1816);
						    }
						    ((((tclass_bglt) CREF(aux_1815))->virtual_slots_number_200) = ((obj_t) local_vnum_209_627), BUNSPEC);
						 }
					      }
					      {		/* Object/wide-access.scm 230 */
						 obj_t arg1317_628;
						 arg1317_628 =
						    make_coercion_clause_209_object_access(class_id_86_622, super_617);
						 produce_module_clause__172_module_module(arg1317_628);
					      }
					      {		/* Object/wide-access.scm 231 */
						 bool_t test1318_629;
						 test1318_629 =
						    is_a__118___object(
						    (obj_t) (holder_624), global_ast_var);
						 if (test1318_629)
						   {	/* Object/wide-access.scm 231 */
						      BUNSPEC;
						   }
						 else
						   {	/* Object/wide-access.scm 231 */
						      {		/* Object/wide-access.scm 231 */
							 obj_t arg1319_630;
							 obj_t arg1320_631;
							 arg1319_630 =
							    CNST_TABLE_REF(((long) 2));
							 {	/* Object/wide-access.scm 231 */
							    obj_t aux_1826;
							    aux_1826 =
							       (obj_t) (holder_624);
							    arg1320_631 =
							       __EVMEANING_ADDRESS(aux_1826);
							 }
							 define_primop_ref__105___evenv(arg1319_630, arg1320_631);
						      }
						      notify_assert_fail_37___eval(
							 CNST_TABLE_REF(((long) 3)),
							 CNST_TABLE_REF(((long) 4)),
							 CNST_TABLE_REF(((long) 11)));
						      unbind_primop__163___evenv(
							 CNST_TABLE_REF(((long) 2)));
						   }
					      }
					      {		/* Object/wide-access.scm 232 */
						 tclass_bglt obj_1188;
						 obj_1188 =
						    (tclass_bglt) (class_80);
						 {
						    obj_t aux_1837;
						    {	/* ./Object/class.scm 1261 */
						       object_bglt aux_1838;
						       aux_1838 =
							  (object_bglt) (obj_1188);
						       aux_1837 =
							  OBJECT_WIDENING(aux_1838);
						    }
						    ((((tclass_bglt) CREF(aux_1837))->slots) = ((obj_t) cslots_621), BUNSPEC);
						 }
					      }
					      {		/* Object/wide-access.scm 234 */
						 obj_t arg1322_632;
						 {	/* Object/wide-access.scm 234 */
						    obj_t arg1323_633;
						    obj_t arg1325_634;
						    arg1323_633 =
						       CNST_TABLE_REF(((long) 6));
						    {	/* Object/wide-access.scm 234 */
						       obj_t arg1326_635;
						       arg1326_635 =
							  make_class_coercers_236_object_access(
							  (obj_t) (class_80));
						       arg1325_634 =
							  append_2_18___r4_pairs_and_lists_6_3(arg1326_635, BNIL);
						    }
						    arg1322_632 =
						       MAKE_PAIR(arg1323_633, arg1325_634);
						 }
						 produce_module_clause__172_module_module(arg1322_632);
					      }
					      import_class_pred__91_object_access(class_id_86_622,
						 (tclass_bglt) (class_80), src_def_101_81, module_625);
					      import_class_makes__192_object_access(widening_626, class_id_86_622,
						 (obj_t) (class_80), cslots_621, src_def_101_81, module_625);
					      {		/* Object/wide-access.scm 396 */
						 obj_t mk_heap_id_73_1198;
						 {	/* Object/wide-access.scm 396 */
						    obj_t list1513_1199;
						    {	/* Object/wide-access.scm 396 */
						       obj_t arg1514_1200;
						       obj_t arg1515_1201;
						       arg1514_1200 =
							  CNST_TABLE_REF(((long) 8));
						       arg1515_1201 =
							  MAKE_PAIR(class_id_86_622, BNIL);
						       list1513_1199 =
							  MAKE_PAIR(arg1514_1200, arg1515_1201);
						    }
						    mk_heap_id_73_1198 =
						       symbol_append_197___r4_symbols_6_4(list1513_1199);
						 }
						 {	/* Object/wide-access.scm 397 */
						    obj_t arg1511_1202;
						    arg1511_1202 =
						       import_wide_class_make__56_object_wide_access_168(
						       CNST_TABLE_REF(((long) 9)), class_id_86_622, class_80, cslots_621, sslots_619, src_def_101_81, module_625);
						    {	/* Object/wide-access.scm 397 */
						       obj_t list1512_1203;
						       list1512_1203 =
							  MAKE_PAIR(arg1511_1202, BNIL);
						       list1512_1203;
						    }
						 }
					      }
					      import_class_slots_access__39_object_access(class_id_86_622, super_617, sslots_619, src_def_101_81, module_625);
					      import_class_slots_access__39_object_access(class_id_86_622,
						 (obj_t) (class_80), cslots_621, src_def_101_81, module_625);
					   }
					}
				     }
				  }
			       }
			    }
			 }
		      }
		   }
		}
	      else
		{	/* Object/wide-access.scm 208 */
		   BUNSPEC;
		}
	   }
	 else
	   {	/* Object/wide-access.scm 207 */
	      BUNSPEC;
	   }
      }
      return BNIL;
   }
}



/* _import-wide-class-accessors! */
obj_t 
_import_wide_class_accessors__85_object_wide_access_168(obj_t env_1444, obj_t class_def_12_1445, obj_t class_1446, obj_t src_def_101_1447, obj_t module_1448)
{
   AN_OBJECT;
   {	/* Object/wide-access.scm 206 */
      return
	 import_wide_class_accessors__236_object_wide_access_168(class_def_12_1445,
	 (type_bglt) (class_1446), src_def_101_1447, module_1448);
   }
}



/* import-wide-class-makes! */
obj_t 
import_wide_class_makes__40_object_wide_access_168(obj_t class_def_12_83, type_bglt class_84, obj_t src_def_101_85, obj_t module_86)
{
   AN_OBJECT;
   {	/* Object/wide-access.scm 250 */
      {		/* Object/wide-access.scm 251 */
	 bool_t test1331_640;
	 {	/* Object/wide-access.scm 251 */
	    bool_t test1337_657;
	    test1337_657 =
	       is_a__118___object(
	       (obj_t) (class_84), tclass_object_class);
	    if (test1337_657)
	      {		/* ./Object/class.scm 1257 */
		 obj_t aux_1867;
		 {	/* Object/wide-access.scm 251 */
		    tclass_bglt obj_1206;
		    obj_1206 =
		       (tclass_bglt) (class_84);
		    {
		       obj_t aux_1869;
		       {	/* ./Object/class.scm 1257 */
			  object_bglt aux_1870;
			  aux_1870 =
			     (object_bglt) (obj_1206);
			  aux_1869 =
			     OBJECT_WIDENING(aux_1870);
		       }
		       aux_1867 =
			  (((tclass_bglt) CREF(aux_1869))->its_super_214);
		    }
		 }
		 test1331_640 =
		    is_a__118___object(aux_1867, tclass_object_class);
	      }
	    else
	      {		/* Object/wide-access.scm 251 */
		 test1331_640 = ((bool_t) 0);
	      }
	 }
	 if (test1331_640)
	   {	/* Object/wide-access.scm 252 */
	      bool_t test1332_641;
	      {		/* Object/wide-access.scm 252 */
		 obj_t aux_1876;
		 aux_1876 =
		    correct_wide_class__226_object_wide_access_168(class_84, src_def_101_85);
		 test1332_641 =
		    CBOOL(aux_1876);
	      }
	      if (test1332_641)
		{	/* Object/wide-access.scm 253 */
		   obj_t super_642;
		   {	/* Object/wide-access.scm 253 */
		      tclass_bglt obj_1208;
		      obj_1208 =
			 (tclass_bglt) (class_84);
		      {
			 obj_t aux_1881;
			 {	/* ./Object/class.scm 1257 */
			    object_bglt aux_1882;
			    aux_1882 =
			       (object_bglt) (obj_1208);
			    aux_1881 =
			       OBJECT_WIDENING(aux_1882);
			 }
			 super_642 =
			    (((tclass_bglt) CREF(aux_1881))->its_super_214);
		      }
		   }
		   {	/* Object/wide-access.scm 253 */
		      obj_t super_vnum_51_643;
		      {		/* Object/wide-access.scm 254 */
			 bool_t test1336_656;
			 test1336_656 =
			    is_a__118___object(super_642, tclass_object_class);
			 if (test1336_656)
			   {	/* Object/wide-access.scm 255 */
			      tclass_bglt obj_1210;
			      obj_1210 =
				 (tclass_bglt) (super_642);
			      {
				 obj_t aux_1889;
				 {	/* ./Object/class.scm 1273 */
				    object_bglt aux_1890;
				    aux_1890 =
				       (object_bglt) (obj_1210);
				    aux_1889 =
				       OBJECT_WIDENING(aux_1890);
				 }
				 super_vnum_51_643 =
				    (((tclass_bglt) CREF(aux_1889))->virtual_slots_number_200);
			      }
			   }
			 else
			   {	/* Object/wide-access.scm 254 */
			      super_vnum_51_643 =
				 BINT(((long) 0));
			   }
		      }
		      {		/* Object/wide-access.scm 254 */
			 obj_t sslots_644;
			 {	/* Object/wide-access.scm 257 */
			    tclass_bglt obj_1211;
			    obj_1211 =
			       (tclass_bglt) (super_642);
			    {
			       obj_t aux_1896;
			       {	/* ./Object/class.scm 1261 */
				  object_bglt aux_1897;
				  aux_1897 =
				     (object_bglt) (obj_1211);
				  aux_1896 =
				     OBJECT_WIDENING(aux_1897);
			       }
			       sslots_644 =
				  (((tclass_bglt) CREF(aux_1896))->slots);
			    }
			 }
			 {	/* Object/wide-access.scm 258 */
			    obj_t cslots_646;
			    {	/* Object/wide-access.scm 259 */
			       obj_t aux_1901;
			       {	/* ./Ieee/pair-list.scm 5707 */
				  obj_t aux_1903;
				  aux_1903 =
				     CDR(class_def_12_83);
				  aux_1901 =
				     CDR(aux_1903);
			       }
			       cslots_646 =
				  make_class_slots_205_object_slots(
				  (tclass_bglt) (class_84), aux_1901, BFALSE,
				  CINT(super_vnum_51_643), src_def_101_85);
			    }
			    {	/* Object/wide-access.scm 259 */
			       obj_t class_id_86_647;
			       class_id_86_647 =
				  (((type_bglt) CREF(class_84))->id);
			       {	/* Object/wide-access.scm 263 */
				  global_bglt holder_649;
				  {	/* Object/wide-access.scm 264 */
				     tclass_bglt obj_1218;
				     obj_1218 =
					(tclass_bglt) (class_84);
				     {
					obj_t aux_1910;
					{	/* ./Object/class.scm 1263 */
					   object_bglt aux_1911;
					   aux_1911 =
					      (object_bglt) (obj_1218);
					   aux_1910 =
					      OBJECT_WIDENING(aux_1911);
					}
					holder_649 =
					   (((tclass_bglt) CREF(aux_1910))->holder);
				     }
				  }
				  {	/* Object/wide-access.scm 264 */
				     obj_t module_650;
				     module_650 =
					(((global_bglt) CREF(holder_649))->module);
				     {	/* Object/wide-access.scm 265 */
					obj_t widening_651;
					{	/* Object/wide-access.scm 266 */
					   tclass_bglt obj_1220;
					   obj_1220 =
					      (tclass_bglt) (class_84);
					   {
					      obj_t aux_1917;
					      {		/* ./Object/class.scm 1265 */
						 object_bglt aux_1918;
						 aux_1918 =
						    (object_bglt) (obj_1220);
						 aux_1917 =
						    OBJECT_WIDENING(aux_1918);
					      }
					      widening_651 =
						 (((tclass_bglt) CREF(aux_1917))->widening);
					   }
					}
					{	/* Object/wide-access.scm 266 */
					   obj_t local_vnum_209_652;
					   local_vnum_209_652 =
					      get_local_virtual_slots_number_139_object_slots(
					      (tclass_bglt) (class_84), cslots_646);
					   {	/* Object/wide-access.scm 267 */

					      {		/* Object/wide-access.scm 268 */
						 bool_t test1333_653;
						 test1333_653 =
						    is_a__118___object(
						    (obj_t) (holder_649), global_ast_var);
						 if (test1333_653)
						   {	/* Object/wide-access.scm 268 */
						      BUNSPEC;
						   }
						 else
						   {	/* Object/wide-access.scm 268 */
						      {		/* Object/wide-access.scm 268 */
							 obj_t arg1334_654;
							 obj_t arg1335_655;
							 arg1334_654 =
							    CNST_TABLE_REF(((long) 2));
							 {	/* Object/wide-access.scm 268 */
							    obj_t aux_1928;
							    aux_1928 =
							       (obj_t) (holder_649);
							    arg1335_655 =
							       __EVMEANING_ADDRESS(aux_1928);
							 }
							 define_primop_ref__105___evenv(arg1334_654, arg1335_655);
						      }
						      notify_assert_fail_37___eval(
							 CNST_TABLE_REF(((long) 3)),
							 CNST_TABLE_REF(((long) 4)),
							 CNST_TABLE_REF(((long) 12)));
						      unbind_primop__163___evenv(
							 CNST_TABLE_REF(((long) 2)));
						   }
					      }
					      import_class_makes__192_object_access(widening_651, class_id_86_647,
						 (obj_t) (class_84), cslots_646, src_def_101_85, module_650);
					      {		/* Object/wide-access.scm 396 */
						 obj_t mk_heap_id_73_1228;
						 {	/* Object/wide-access.scm 396 */
						    obj_t list1513_1229;
						    {	/* Object/wide-access.scm 396 */
						       obj_t arg1514_1230;
						       obj_t arg1515_1231;
						       arg1514_1230 =
							  CNST_TABLE_REF(((long) 8));
						       arg1515_1231 =
							  MAKE_PAIR(class_id_86_647, BNIL);
						       list1513_1229 =
							  MAKE_PAIR(arg1514_1230, arg1515_1231);
						    }
						    mk_heap_id_73_1228 =
						       symbol_append_197___r4_symbols_6_4(list1513_1229);
						 }
						 {	/* Object/wide-access.scm 397 */
						    obj_t arg1511_1232;
						    arg1511_1232 =
						       import_wide_class_make__56_object_wide_access_168(
						       CNST_TABLE_REF(((long) 9)), class_id_86_647, class_84, cslots_646, sslots_644, src_def_101_85, module_650);
						    {	/* Object/wide-access.scm 397 */
						       obj_t list1512_1233;
						       list1512_1233 =
							  MAKE_PAIR(arg1511_1232, BNIL);
						       list1512_1233;
						    }
						 }
					      }
					   }
					}
				     }
				  }
			       }
			    }
			 }
		      }
		   }
		}
	      else
		{	/* Object/wide-access.scm 252 */
		   BUNSPEC;
		}
	   }
	 else
	   {	/* Object/wide-access.scm 251 */
	      BUNSPEC;
	   }
      }
      return BNIL;
   }
}



/* _import-wide-class-makes!1588 */
obj_t 
_import_wide_class_makes_1588_100_object_wide_access_168(obj_t env_1449, obj_t class_def_12_1450, obj_t class_1451, obj_t src_def_101_1452, obj_t module_1453)
{
   AN_OBJECT;
   {	/* Object/wide-access.scm 250 */
      return
	 import_wide_class_makes__40_object_wide_access_168(class_def_12_1450,
	 (type_bglt) (class_1451), src_def_101_1452, module_1453);
   }
}



/* correct-wide-class? */
obj_t 
correct_wide_class__226_object_wide_access_168(type_bglt class_87, obj_t src_def_101_88)
{
   AN_OBJECT;
   {	/* Object/wide-access.scm 282 */
      {		/* Object/wide-access.scm 283 */
	 obj_t super_659;
	 {	/* Object/wide-access.scm 283 */
	    tclass_bglt obj_1235;
	    obj_1235 =
	       (tclass_bglt) (class_87);
	    {
	       obj_t aux_1950;
	       {	/* ./Object/class.scm 1257 */
		  object_bglt aux_1951;
		  aux_1951 =
		     (object_bglt) (obj_1235);
		  aux_1950 =
		     OBJECT_WIDENING(aux_1951);
	       }
	       super_659 =
		  (((tclass_bglt) CREF(aux_1950))->its_super_214);
	    }
	 }
	 {	/* Object/wide-access.scm 283 */
	    obj_t class_id_86_660;
	    class_id_86_660 =
	       (((type_bglt) CREF(class_87))->id);
	    {	/* Object/wide-access.scm 284 */

	       {	/* Object/wide-access.scm 288 */
		  bool_t test1339_661;
		  {	/* Object/wide-access.scm 288 */
		     bool_t test1374_688;
		     test1374_688 =
			is_a__118___object(super_659, type_type_type);
		     if (test1374_688)
		       {	/* Object/wide-access.scm 288 */
			  bool_t test1375_689;
			  test1375_689 =
			     is_a__118___object(super_659, tclass_object_class);
			  if (test1375_689)
			    {	/* Object/wide-access.scm 288 */
			       test1339_661 = ((bool_t) 0);
			    }
			  else
			    {	/* Object/wide-access.scm 288 */
			       test1339_661 = ((bool_t) 1);
			    }
		       }
		     else
		       {	/* Object/wide-access.scm 288 */
			  test1339_661 = ((bool_t) 0);
		       }
		  }
		  if (test1339_661)
		    {	/* Object/wide-access.scm 288 */
		       {	/* Object/wide-access.scm 289 */
			  obj_t arg1340_662;
			  obj_t arg1342_663;
			  {	/* Object/wide-access.scm 289 */
			     type_bglt obj_1239;
			     obj_1239 =
				(type_bglt) (super_659);
			     arg1340_662 =
				(((type_bglt) CREF(obj_1239))->id);
			  }
			  {	/* Object/wide-access.scm 290 */
			     obj_t arg1346_666;
			     {	/* Object/wide-access.scm 291 */
				obj_t arg1347_667;
				arg1347_667 =
				   SYMBOL_TO_STRING(class_id_86_660);
				arg1346_666 =
				   string_append(arg1347_667, string1589_object_wide_access_168);
			     }
			     arg1342_663 =
				string_append(string1590_object_wide_access_168, arg1346_666);
			  }
			  {	/* Object/wide-access.scm 289 */
			     obj_t list1343_664;
			     list1343_664 =
				MAKE_PAIR(type_type_type, BNIL);
			     return
				user_error_151_tools_error(arg1340_662, arg1342_663, src_def_101_88, list1343_664);
			  }
		       }
		    }
		  else
		    {	/* Object/wide-access.scm 295 */
		       bool_t test1349_669;
		       test1349_669 =
			  wide_class__100_object_class(
			  (obj_t) (class_87));
		       if (test1349_669)
			 {	/* Object/wide-access.scm 301 */
			    bool_t test1350_670;
			    test1350_670 =
			       wide_class__100_object_class(super_659);
			    if (test1350_670)
			      {		/* Object/wide-access.scm 301 */
				 {	/* Object/wide-access.scm 303 */
				    obj_t arg1354_671;
				    obj_t arg1355_672;
				    {	/* Object/wide-access.scm 303 */
				       type_bglt obj_1241;
				       obj_1241 =
					  (type_bglt) (super_659);
				       arg1354_671 =
					  (((type_bglt) CREF(obj_1241))->id);
				    }
				    {	/* Object/wide-access.scm 304 */
				       obj_t arg1358_675;
				       {	/* Object/wide-access.scm 305 */
					  obj_t arg1359_676;
					  arg1359_676 =
					     SYMBOL_TO_STRING(class_id_86_660);
					  arg1358_675 =
					     string_append(arg1359_676, string1591_object_wide_access_168);
				       }
				       arg1355_672 =
					  string_append(string1590_object_wide_access_168, arg1358_675);
				    }
				    {	/* Object/wide-access.scm 303 */
				       obj_t list1356_673;
				       list1356_673 =
					  MAKE_PAIR(type_type_type, BNIL);
				       return
					  user_error_151_tools_error(arg1354_671, arg1355_672, src_def_101_88, list1356_673);
				    }
				 }
			      }
			    else
			      {		/* Object/wide-access.scm 309 */
				 bool_t test1362_678;
				 test1362_678 =
				    final_class__126_object_class(super_659);
				 if (test1362_678)
				   {	/* Object/wide-access.scm 317 */
				      bool_t test1363_679;
				      test1363_679 =
					 final_class__126_object_class(
					 (obj_t) (class_87));
				      if (test1363_679)
					{	/* Object/wide-access.scm 317 */
					   {	/* Object/wide-access.scm 319 */
					      obj_t list1364_680;
					      list1364_680 =
						 MAKE_PAIR(type_type_type, BNIL);
					      return
						 user_error_151_tools_error(class_id_86_660, string1592_object_wide_access_168, src_def_101_88, list1364_680);
					   }
					}
				      else
					{	/* Object/wide-access.scm 317 */
					   return BTRUE;
					}
				   }
				 else
				   {	/* Object/wide-access.scm 309 */
				      {		/* Object/wide-access.scm 311 */
					 obj_t arg1365_681;
					 obj_t arg1366_682;
					 {	/* Object/wide-access.scm 311 */
					    type_bglt obj_1243;
					    obj_1243 =
					       (type_bglt) (super_659);
					    arg1365_681 =
					       (((type_bglt) CREF(obj_1243))->id);
					 }
					 {	/* Object/wide-access.scm 312 */
					    obj_t arg1371_685;
					    {	/* Object/wide-access.scm 313 */
					       obj_t arg1372_686;
					       arg1372_686 =
						  SYMBOL_TO_STRING(class_id_86_660);
					       arg1371_685 =
						  string_append(arg1372_686, string1593_object_wide_access_168);
					    }
					    arg1366_682 =
					       string_append(string1594_object_wide_access_168, arg1371_685);
					 }
					 {	/* Object/wide-access.scm 311 */
					    obj_t list1367_683;
					    list1367_683 =
					       MAKE_PAIR(type_type_type, BNIL);
					    return
					       user_error_151_tools_error(arg1365_681, arg1366_682, src_def_101_88, list1367_683);
					 }
				      }
				   }
			      }
			 }
		       else
			 {	/* Object/wide-access.scm 295 */
			    return
			       internal_error_43_tools_error(string1595_object_wide_access_168, string1596_object_wide_access_168, src_def_101_88);
			 }
		    }
	       }
	    }
	 }
      }
   }
}



/* make-wide-class-make! */
obj_t 
make_wide_class_make__242_object_wide_access_168(obj_t mk_region_180_95, obj_t id_96, type_bglt type_97, obj_t slots_98, obj_t sslots_99, obj_t src_def_101_100, obj_t import_101)
{
   AN_OBJECT;
   {	/* Object/wide-access.scm 336 */
      {		/* Object/wide-access.scm 337 */
	 obj_t super_696;
	 {	/* Object/wide-access.scm 337 */
	    tclass_bglt obj_1252;
	    obj_1252 =
	       (tclass_bglt) (type_97);
	    {
	       obj_t aux_1996;
	       {	/* ./Object/class.scm 1257 */
		  object_bglt aux_1997;
		  aux_1997 =
		     (object_bglt) (obj_1252);
		  aux_1996 =
		     OBJECT_WIDENING(aux_1997);
	       }
	       super_696 =
		  (((tclass_bglt) CREF(aux_1996))->its_super_214);
	    }
	 }
	 {	/* Object/wide-access.scm 337 */
	    global_bglt holder_697;
	    {	/* Object/wide-access.scm 338 */
	       tclass_bglt obj_1253;
	       obj_1253 =
		  (tclass_bglt) (type_97);
	       {
		  obj_t aux_2002;
		  {	/* ./Object/class.scm 1263 */
		     object_bglt aux_2003;
		     aux_2003 =
			(object_bglt) (obj_1253);
		     aux_2002 =
			OBJECT_WIDENING(aux_2003);
		  }
		  holder_697 =
		     (((tclass_bglt) CREF(aux_2002))->holder);
	       }
	    }
	    {	/* Object/wide-access.scm 338 */
	       obj_t constrs_698;
	       constrs_698 =
		  find_class_constructors_231_object_class(
		  (tclass_bglt) (type_97));
	       {	/* Object/wide-access.scm 339 */
		  obj_t tid_699;
		  tid_699 =
		     (((type_bglt) CREF(type_97))->id);
		  {	/* Object/wide-access.scm 340 */
		     obj_t stid_700;
		     {	/* Object/wide-access.scm 341 */
			type_bglt obj_1255;
			obj_1255 =
			   (type_bglt) (super_696);
			stid_700 =
			   (((type_bglt) CREF(obj_1255))->id);
		     }
		     {	/* Object/wide-access.scm 341 */
			obj_t mk_tid_99_701;
			{	/* Object/wide-access.scm 342 */
			   obj_t list1504_825;
			   {	/* Object/wide-access.scm 342 */
			      obj_t arg1505_826;
			      obj_t arg1506_827;
			      arg1505_826 =
				 CNST_TABLE_REF(((long) 13));
			      {		/* Object/wide-access.scm 342 */
				 obj_t arg1508_828;
				 {	/* Object/wide-access.scm 342 */
				    obj_t arg1509_829;
				    {	/* Object/wide-access.scm 342 */
				       obj_t arg1510_830;
				       arg1510_830 =
					  MAKE_PAIR(tid_699, BNIL);
				       arg1509_829 =
					  MAKE_PAIR(_4dots_199_tools_misc, arg1510_830);
				    }
				    arg1508_828 =
				       MAKE_PAIR(id_96, arg1509_829);
				 }
				 arg1506_827 =
				    MAKE_PAIR(mk_region_180_95, arg1508_828);
			      }
			      list1504_825 =
				 MAKE_PAIR(arg1505_826, arg1506_827);
			   }
			   mk_tid_99_701 =
			      symbol_append_197___r4_symbols_6_4(list1504_825);
			}
			{	/* Object/wide-access.scm 342 */
			   obj_t f_ids_164_702;
			   f_ids_164_702 =
			      make_class_make_formals_23_object_access(slots_98);
			   {	/* Object/wide-access.scm 343 */
			      obj_t sf_ids_190_703;
			      sf_ids_190_703 =
				 make_class_make_formals_23_object_access(sslots_99);
			      {		/* Object/wide-access.scm 344 */
				 obj_t f_tids_193_704;
				 f_tids_193_704 =
				    make_class_make_typed_formals_184_object_access(slots_98);
				 {	/* Object/wide-access.scm 345 */
				    obj_t sf_tids_42_705;
				    sf_tids_42_705 =
				       make_class_make_typed_formals_184_object_access(sslots_99);
				    {	/* Object/wide-access.scm 346 */
				       obj_t widening_706;
				       {	/* Object/wide-access.scm 347 */
					  obj_t arg1499_820;
					  {	/* Object/wide-access.scm 347 */
					     tclass_bglt obj_1256;
					     obj_1256 =
						(tclass_bglt) (type_97);
					     {
						obj_t aux_2024;
						{	/* ./Object/class.scm 1265 */
						   object_bglt aux_2025;
						   aux_2025 =
						      (object_bglt) (obj_1256);
						   aux_2024 =
						      OBJECT_WIDENING(aux_2025);
						}
						arg1499_820 =
						   (((tclass_bglt) CREF(aux_2024))->widening);
					     }
					  }
					  {	/* Object/wide-access.scm 347 */
					     obj_t list1501_822;
					     {	/* Object/wide-access.scm 347 */
						obj_t arg1502_823;
						{	/* Object/wide-access.scm 347 */
						   obj_t arg1503_824;
						   {	/* Object/wide-access.scm 347 */
						      obj_t aux_2029;
						      aux_2029 =
							 (((type_bglt) CREF(type_97))->id);
						      arg1503_824 =
							 MAKE_PAIR(aux_2029, BNIL);
						   }
						   arg1502_823 =
						      MAKE_PAIR(mk_region_180_95, arg1503_824);
						}
						list1501_822 =
						   MAKE_PAIR(arg1499_820, arg1502_823);
					     }
					     widening_706 =
						symbol_append_197___r4_symbols_6_4(list1501_822);
					  }
				       }
				       {	/* Object/wide-access.scm 347 */
					  obj_t aux_707;
					  aux_707 =
					     PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4,
					     CNST_TABLE_REF(((long) 14)), BEOA);
					  {	/* Object/wide-access.scm 350 */
					     obj_t new_708;
					     new_708 =
						PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4,
						CNST_TABLE_REF(((long) 15)), BEOA);
					     {	/* Object/wide-access.scm 351 */
						obj_t mk_class_id_234_709;
						{	/* Object/wide-access.scm 352 */
						   obj_t list1495_816;
						   {	/* Object/wide-access.scm 352 */
						      obj_t arg1496_817;
						      obj_t arg1497_818;
						      arg1496_817 =
							 CNST_TABLE_REF(((long) 13));
						      {		/* Object/wide-access.scm 352 */
							 obj_t arg1498_819;
							 arg1498_819 =
							    MAKE_PAIR(stid_700, BNIL);
							 arg1497_818 =
							    MAKE_PAIR(mk_region_180_95, arg1498_819);
						      }
						      list1495_816 =
							 MAKE_PAIR(arg1496_817, arg1497_818);
						   }
						   mk_class_id_234_709 =
						      symbol_append_197___r4_symbols_6_4(list1495_816);
						}
						{	/* Object/wide-access.scm 352 */
						   bool_t inline__228_710;
						   {	/* Object/wide-access.scm 353 */
						      bool_t _andtest_1225_813;
						      {		/* Object/wide-access.scm 353 */
							 long n1_1258;
							 n1_1258 =
							    (long) CINT(_optim__89_engine_param);
							 _andtest_1225_813 =
							    (n1_1258 >= ((long) 2));
						      }
						      if (_andtest_1225_813)
							{	/* Object/wide-access.scm 354 */
							   bool_t _ortest_1226_814;
							   {	/* Object/wide-access.scm 354 */
							      bool_t test1494_815;
							      {		/* Object/wide-access.scm 354 */
								 bool_t res1586_1264;
								 {	/* Object/wide-access.scm 354 */
								    obj_t obj_1260;
								    obj_1260 = _profile_mode__105_engine_param;
								    if (
								       INTEGERP(obj_1260))
								      {		/* ./Ieee/number.scm 6283 */
									 res1586_1264 = ((bool_t) 1);
								      }
								    else
								      {		/* ./Ieee/number.scm 6283 */
									 res1586_1264 =
									    REALP(obj_1260);
								      }
								 }
								 test1494_815 = res1586_1264;
							      }
							      if (test1494_815)
								{	/* Object/wide-access.scm 354 */
								   _ortest_1226_814 = ((bool_t) 0);
								}
							      else
								{	/* Object/wide-access.scm 354 */
								   _ortest_1226_814 = ((bool_t) 1);
								}
							   }
							   if (_ortest_1226_814)
							     {	/* Object/wide-access.scm 354 */
								inline__228_710 = _ortest_1226_814;
							     }
							   else
							     {	/* Object/wide-access.scm 355 */
								long n1_1265;
								n1_1265 =
								   (long) CINT(_profile_mode__105_engine_param);
								inline__228_710 =
								   (n1_1265 < ((long) 1));
							     }
							}
						      else
							{	/* Object/wide-access.scm 353 */
							   inline__228_710 = ((bool_t) 0);
							}
						   }
						   {	/* Object/wide-access.scm 353 */

						      {		/* Object/wide-access.scm 359 */
							 obj_t arg1381_711;
							 {	/* Object/wide-access.scm 359 */
							    obj_t arg1383_712;
							    {	/* Object/wide-access.scm 359 */
							       obj_t arg1384_713;
							       {	/* Object/wide-access.scm 359 */
								  obj_t arg1387_715;
								  obj_t arg1389_716;
								  if (inline__228_710)
								    {	/* Object/wide-access.scm 359 */
								       arg1387_715 =
									  CNST_TABLE_REF(((long) 16));
								    }
								  else
								    {	/* Object/wide-access.scm 359 */
								       arg1387_715 = BNIL;
								    }
								  {	/* ./Ieee/pair-list.scm 5689 */
								     obj_t aux_2058;
								     aux_2058 =
									append_2_18___r4_pairs_and_lists_6_3(sf_tids_42_705,
									append_2_18___r4_pairs_and_lists_6_3(f_tids_193_704, BNIL));
								     arg1389_716 =
									MAKE_PAIR(mk_tid_99_701, aux_2058);
								  }
								  arg1384_713 =
								     append_2_18___r4_pairs_and_lists_6_3(arg1387_715, arg1389_716);
							       }
							       arg1383_712 =
								  MAKE_PAIR(arg1384_713, BNIL);
							    }
							    arg1381_711 =
							       MAKE_PAIR(import_101, arg1383_712);
							 }
							 produce_module_clause__172_module_module(arg1381_711);
						      }
						      {		/* Object/wide-access.scm 361 */
							 obj_t arg1393_719;
							 {	/* Object/wide-access.scm 361 */
							    obj_t arg1395_721;
							    obj_t arg1397_722;
							    if (inline__228_710)
							      {		/* Object/wide-access.scm 361 */
								 arg1395_721 =
								    CNST_TABLE_REF(((long) 17));
							      }
							    else
							      {		/* Object/wide-access.scm 361 */
								 arg1395_721 =
								    CNST_TABLE_REF(((long) 18));
							      }
							    {	/* Object/wide-access.scm 362 */
							       obj_t arg1398_723;
							       obj_t arg1399_724;
							       {	/* ./Ieee/pair-list.scm 5689 */
								  obj_t aux_2069;
								  aux_2069 =
								     append_2_18___r4_pairs_and_lists_6_3(sf_tids_42_705,
								     append_2_18___r4_pairs_and_lists_6_3(f_tids_193_704, BNIL));
								  arg1398_723 =
								     MAKE_PAIR(mk_tid_99_701, aux_2069);
							       }
							       {	/* Object/wide-access.scm 365 */
								  obj_t arg1402_727;
								  {	/* Object/wide-access.scm 365 */
								     obj_t arg1404_729;
								     obj_t arg1405_730;
								     arg1404_729 =
									CNST_TABLE_REF(((long) 19));
								     {	/* Object/wide-access.scm 365 */
									obj_t arg1406_731;
									obj_t arg1409_732;
									{	/* Object/wide-access.scm 365 */
									   obj_t arg1410_733;
									   {	/* Object/wide-access.scm 365 */
									      obj_t arg1412_735;
									      obj_t arg1415_736;
									      {		/* Object/wide-access.scm 365 */
										 obj_t list1416_737;
										 {	/* Object/wide-access.scm 365 */
										    obj_t arg1417_738;
										    {	/* Object/wide-access.scm 365 */
										       obj_t arg1419_739;
										       arg1419_739 =
											  MAKE_PAIR(stid_700, BNIL);
										       arg1417_738 =
											  MAKE_PAIR(_4dots_199_tools_misc, arg1419_739);
										    }
										    list1416_737 =
										       MAKE_PAIR(aux_707, arg1417_738);
										 }
										 arg1412_735 =
										    symbol_append_197___r4_symbols_6_4(list1416_737);
									      }
									      {		/* Object/wide-access.scm 366 */
										 obj_t arg1420_740;
										 {	/* ./Ieee/pair-list.scm 5689 */
										    obj_t aux_2078;
										    aux_2078 =
										       append_2_18___r4_pairs_and_lists_6_3(sf_ids_190_703, BNIL);
										    arg1420_740 =
										       MAKE_PAIR(mk_class_id_234_709, aux_2078);
										 }
										 arg1415_736 =
										    MAKE_PAIR(arg1420_740, BNIL);
									      }
									      arg1410_733 =
										 MAKE_PAIR(arg1412_735, arg1415_736);
									   }
									   arg1406_731 =
									      MAKE_PAIR(arg1410_733, BNIL);
									}
									{	/* Object/wide-access.scm 369 */
									   obj_t arg1425_743;
									   {	/* Object/wide-access.scm 369 */
									      obj_t arg1427_745;
									      obj_t arg1428_746;
									      arg1427_745 =
										 CNST_TABLE_REF(((long) 19));
									      {		/* Object/wide-access.scm 369 */
										 obj_t arg1430_747;
										 obj_t arg1431_748;
										 {	/* Object/wide-access.scm 369 */
										    obj_t arg1432_749;
										    {	/* Object/wide-access.scm 369 */
										       obj_t arg1434_751;
										       obj_t arg1435_752;
										       {	/* Object/wide-access.scm 369 */
											  obj_t list1436_753;
											  {	/* Object/wide-access.scm 369 */
											     obj_t arg1437_754;
											     {	/* Object/wide-access.scm 369 */
												obj_t arg1438_755;
												arg1438_755 =
												   MAKE_PAIR(tid_699, BNIL);
												arg1437_754 =
												   MAKE_PAIR(_4dots_199_tools_misc, arg1438_755);
											     }
											     list1436_753 =
												MAKE_PAIR(new_708, arg1437_754);
											  }
											  arg1434_751 =
											     symbol_append_197___r4_symbols_6_4(list1436_753);
										       }
										       {	/* Object/wide-access.scm 370 */
											  obj_t arg1439_756;
											  {	/* Object/wide-access.scm 370 */
											     obj_t arg1441_758;
											     obj_t arg1442_759;
											     {	/* Object/wide-access.scm 370 */
												obj_t list1443_760;
												{	/* Object/wide-access.scm 370 */
												   obj_t arg1444_761;
												   obj_t arg1445_762;
												   arg1444_761 =
												      CNST_TABLE_REF(((long) 20));
												   {	/* Object/wide-access.scm 370 */
												      obj_t arg1446_763;
												      arg1446_763 =
													 MAKE_PAIR(tid_699, BNIL);
												      arg1445_762 =
													 MAKE_PAIR(_4dots_199_tools_misc, arg1446_763);
												   }
												   list1443_760 =
												      MAKE_PAIR(arg1444_761, arg1445_762);
												}
												arg1441_758 =
												   symbol_append_197___r4_symbols_6_4(list1443_760);
											     }
											     {	/* Object/wide-access.scm 371 */
												obj_t arg1447_764;
												obj_t arg1449_765;
												{	/* Object/wide-access.scm 371 */
												   obj_t arg1451_767;
												   {	/* Object/wide-access.scm 371 */
												      obj_t aux_2094;
												      aux_2094 =
													 (((type_bglt) CREF(type_97))->name);
												      arg1451_767 =
													 string_append(aux_2094, string1597_object_wide_access_168);
												   }
												   arg1447_764 =
												      string_append(string1598_object_wide_access_168, arg1451_767);
												}
												arg1449_765 =
												   MAKE_PAIR(aux_707, BNIL);
												arg1442_759 =
												   MAKE_PAIR(arg1447_764, arg1449_765);
											     }
											     arg1439_756 =
												MAKE_PAIR(arg1441_758, arg1442_759);
											  }
											  arg1435_752 =
											     MAKE_PAIR(arg1439_756, BNIL);
										       }
										       arg1432_749 =
											  MAKE_PAIR(arg1434_751, arg1435_752);
										    }
										    arg1430_747 =
										       MAKE_PAIR(arg1432_749, BNIL);
										 }
										 {	/* Object/wide-access.scm 374 */
										    obj_t arg1455_770;
										    obj_t arg1456_771;
										    {	/* Object/wide-access.scm 374 */
										       obj_t arg1457_772;
										       obj_t arg1458_773;
										       arg1457_772 =
											  CNST_TABLE_REF(((long) 21));
										       {	/* Object/wide-access.scm 376 */
											  obj_t arg1459_774;
											  {	/* Object/wide-access.scm 376 */
											     obj_t arg1461_775;
											     {	/* Object/wide-access.scm 376 */
												obj_t arg1463_777;
												obj_t arg1464_778;
												arg1463_777 =
												   CNST_TABLE_REF(((long) 22));
												{	/* Object/wide-access.scm 376 */
												   obj_t arg1466_779;
												   {	/* Object/wide-access.scm 376 */
												      obj_t arg1469_781;
												      obj_t arg1470_782;
												      arg1469_781 =
													 CNST_TABLE_REF(((long) 23));
												      {		/* Object/wide-access.scm 376 */
													 obj_t arg1471_783;
													 obj_t arg1472_784;
													 arg1471_783 =
													    (((global_bglt) CREF(holder_697))->id);
													 {	/* ./Ieee/pair-list.scm 5689 */
													    obj_t aux_2108;
													    aux_2108 =
													       (((global_bglt) CREF(holder_697))->module);
													    arg1472_784 =
													       MAKE_PAIR(aux_2108, BNIL);
													 }
													 arg1470_782 =
													    MAKE_PAIR(arg1471_783, arg1472_784);
												      }
												      arg1466_779 =
													 MAKE_PAIR(arg1469_781, arg1470_782);
												   }
												   arg1464_778 =
												      MAKE_PAIR(arg1466_779, BNIL);
												}
												arg1461_775 =
												   MAKE_PAIR(arg1463_777, arg1464_778);
											     }
											     arg1459_774 =
												MAKE_PAIR(arg1461_775, BNIL);
											  }
											  arg1458_773 =
											     MAKE_PAIR(new_708, arg1459_774);
										       }
										       arg1455_770 =
											  MAKE_PAIR(arg1457_772, arg1458_773);
										    }
										    {	/* Object/wide-access.scm 379 */
										       obj_t arg1475_787;
										       obj_t arg1476_788;
										       {	/* Object/wide-access.scm 379 */
											  obj_t arg1477_789;
											  obj_t arg1478_790;
											  arg1477_789 =
											     CNST_TABLE_REF(((long) 24));
											  {	/* Object/wide-access.scm 379 */
											     obj_t arg1479_791;
											     {	/* Object/wide-access.scm 379 */
												obj_t arg1480_792;
												{	/* ./Ieee/pair-list.scm 5689 */
												   obj_t aux_2119;
												   aux_2119 =
												      append_2_18___r4_pairs_and_lists_6_3(f_ids_164_702, BNIL);
												   arg1480_792 =
												      MAKE_PAIR(widening_706, aux_2119);
												}
												arg1479_791 =
												   MAKE_PAIR(arg1480_792, BNIL);
											     }
											     arg1478_790 =
												MAKE_PAIR(new_708, arg1479_791);
											  }
											  arg1475_787 =
											     MAKE_PAIR(arg1477_789, arg1478_790);
										       }
										       {	/* Object/wide-access.scm 382 */
											  obj_t arg1483_795;
											  obj_t arg1484_796;
											  {	/* Object/wide-access.scm 382 */
											     bool_t test_2125;
											     if (
												PAIRP(constrs_698))
											       {	/* Object/wide-access.scm 383 */
												  bool_t test_2128;
												  {	/* ./Ieee/equiv.scm 5508 */
												     obj_t aux_2129;
												     aux_2129 =
													CNST_TABLE_REF(((long) 7));
												     test_2128 =
													(widening_706 == aux_2129);
												  }
												  if (test_2128)
												    {	/* Object/wide-access.scm 383 */
												       test_2125 = ((bool_t) 0)
													  ;
												    }
												  else
												    {	/* Object/wide-access.scm 383 */
												       test_2125 = ((bool_t) 1)
													  ;
												    }
											       }
											     else
											       {	/* Object/wide-access.scm 382 */
												  test_2125 = ((bool_t) 0)
												     ;
											       }
											     if (test_2125)
											       {	/* Object/wide-access.scm 382 */
												  if (
												     NULLP(constrs_698))
												    {	/* Object/wide-access.scm 384 */
												       arg1483_795 = BNIL;
												    }
												  else
												    {	/* Object/wide-access.scm 384 */
												       obj_t head1229_800;
												       head1229_800 =
													  MAKE_PAIR(BNIL, BNIL);
												       {
													  obj_t l1227_801;
													  obj_t tail1230_802;
													  l1227_801 = constrs_698;
													  tail1230_802 = head1229_800;
													lname1228_803:
													  if (
													     NULLP(l1227_801))
													    {	/* Object/wide-access.scm 384 */
													       arg1483_795 =
														  CDR(head1229_800);
													    }
													  else
													    {	/* Object/wide-access.scm 385 */
													       obj_t newtail1231_805;
													       {	/* Object/wide-access.scm 385 */
														  obj_t arg1489_807;
														  {	/* Object/wide-access.scm 385 */
														     obj_t constr_809;
														     constr_809 =
															CAR(l1227_801);
														     {	/* Object/wide-access.scm 385 */
															obj_t arg1491_810;
															arg1491_810 =
															   MAKE_PAIR(new_708, BNIL);
															arg1489_807 =
															   MAKE_PAIR(constr_809, arg1491_810);
														     }
														  }
														  newtail1231_805 =
														     MAKE_PAIR(arg1489_807, BNIL);
													       }
													       SET_CDR(tail1230_802, newtail1231_805);
													       {
														  obj_t tail1230_2145;
														  obj_t l1227_2143;
														  l1227_2143 =
														     CDR(l1227_801);
														  tail1230_2145 = newtail1231_805;
														  tail1230_802 = tail1230_2145;
														  l1227_801 = l1227_2143;
														  goto lname1228_803;
													       }
													    }
												       }
												    }
											       }
											     else
											       {	/* Object/wide-access.scm 382 */
												  arg1483_795 = BNIL;
											       }
											  }
											  arg1484_796 =
											     MAKE_PAIR(new_708, BNIL);
											  arg1476_788 =
											     append_2_18___r4_pairs_and_lists_6_3(arg1483_795, arg1484_796);
										       }
										       arg1456_771 =
											  MAKE_PAIR(arg1475_787, arg1476_788);
										    }
										    arg1431_748 =
										       MAKE_PAIR(arg1455_770, arg1456_771);
										 }
										 arg1428_746 =
										    MAKE_PAIR(arg1430_747, arg1431_748);
									      }
									      arg1425_743 =
										 MAKE_PAIR(arg1427_745, arg1428_746);
									   }
									   arg1409_732 =
									      MAKE_PAIR(arg1425_743, BNIL);
									}
									arg1405_730 =
									   MAKE_PAIR(arg1406_731, arg1409_732);
								     }
								     arg1402_727 =
									MAKE_PAIR(arg1404_729, arg1405_730);
								  }
								  arg1399_724 =
								     MAKE_PAIR(arg1402_727, BNIL);
							       }
							       arg1397_722 =
								  MAKE_PAIR(arg1398_723, arg1399_724);
							    }
							    arg1393_719 =
							       MAKE_PAIR(arg1395_721, arg1397_722);
							 }
							 {	/* Object/wide-access.scm 361 */
							    obj_t list1394_720;
							    list1394_720 =
							       MAKE_PAIR(src_def_101_100, BNIL);
							    return
							       epairify__149_object_access(arg1393_719, list1394_720);
							 }
						      }
						   }
						}
					     }
					  }
				       }
				    }
				 }
			      }
			   }
			}
		     }
		  }
	       }
	    }
	 }
      }
   }
}



/* import-wide-class-make! */
obj_t 
import_wide_class_make__56_object_wide_access_168(obj_t mk_region_180_108, obj_t id_109, type_bglt type_110, obj_t slots_111, obj_t sslots_112, obj_t src_def_101_113, obj_t module_114)
{
   AN_OBJECT;
   {	/* Object/wide-access.scm 402 */
      {		/* Object/wide-access.scm 403 */
	 obj_t mk_tid_99_838;
	 {	/* Object/wide-access.scm 404 */
	    obj_t list1546_880;
	    {	/* Object/wide-access.scm 404 */
	       obj_t arg1547_881;
	       obj_t arg1548_882;
	       arg1547_881 =
		  CNST_TABLE_REF(((long) 13));
	       {	/* Object/wide-access.scm 404 */
		  obj_t arg1549_883;
		  {	/* Object/wide-access.scm 404 */
		     obj_t arg1550_884;
		     {	/* Object/wide-access.scm 404 */
			obj_t arg1551_885;
			{	/* Object/wide-access.scm 404 */
			   obj_t aux_2161;
			   aux_2161 =
			      (((type_bglt) CREF(type_110))->id);
			   arg1551_885 =
			      MAKE_PAIR(aux_2161, BNIL);
			}
			arg1550_884 =
			   MAKE_PAIR(_4dots_199_tools_misc, arg1551_885);
		     }
		     arg1549_883 =
			MAKE_PAIR(id_109, arg1550_884);
		  }
		  arg1548_882 =
		     MAKE_PAIR(mk_region_180_108, arg1549_883);
	       }
	       list1546_880 =
		  MAKE_PAIR(arg1547_881, arg1548_882);
	    }
	    mk_tid_99_838 =
	       symbol_append_197___r4_symbols_6_4(list1546_880);
	 }
	 {	/* Object/wide-access.scm 404 */
	    obj_t f_tids_193_839;
	    if (
	       NULLP(slots_111))
	      {		/* Object/wide-access.scm 405 */
		 f_tids_193_839 = BNIL;
	      }
	    else
	      {		/* Object/wide-access.scm 405 */
		 obj_t head1234_864;
		 head1234_864 =
		    MAKE_PAIR(BNIL, BNIL);
		 {
		    obj_t l1232_865;
		    obj_t tail1235_866;
		    l1232_865 = slots_111;
		    tail1235_866 = head1234_864;
		  lname1233_867:
		    if (
		       NULLP(l1232_865))
		      {		/* Object/wide-access.scm 405 */
			 f_tids_193_839 =
			    CDR(head1234_864);
		      }
		    else
		      {		/* Object/wide-access.scm 406 */
			 obj_t newtail1236_869;
			 {	/* Object/wide-access.scm 406 */
			    obj_t arg1536_871;
			    {	/* Object/wide-access.scm 406 */
			       obj_t slot_873;
			       slot_873 =
				  CAR(l1232_865);
			       {	/* Object/wide-access.scm 407 */
				  obj_t arg1539_874;
				  arg1539_874 =
				     STRUCT_REF(slot_873, ((long) 0));
				  {	/* Object/wide-access.scm 406 */
				     obj_t list1541_876;
				     {	/* Object/wide-access.scm 406 */
					obj_t arg1543_877;
					{	/* Object/wide-access.scm 406 */
					   obj_t arg1544_878;
					   {	/* Object/wide-access.scm 406 */
					      obj_t aux_2177;
					      {		/* Object/wide-access.scm 409 */
						 type_bglt obj_1382;
						 {	/* Object/wide-access.scm 409 */
						    obj_t aux_2178;
						    aux_2178 =
						       STRUCT_REF(slot_873, ((long) 2));
						    obj_1382 =
						       (type_bglt) (aux_2178);
						 }
						 aux_2177 =
						    (((type_bglt) CREF(obj_1382))->id);
					      }
					      arg1544_878 =
						 MAKE_PAIR(aux_2177, BNIL);
					   }
					   arg1543_877 =
					      MAKE_PAIR(_4dots_199_tools_misc, arg1544_878);
					}
					list1541_876 =
					   MAKE_PAIR(arg1539_874, arg1543_877);
				     }
				     arg1536_871 =
					symbol_append_197___r4_symbols_6_4(list1541_876);
				  }
			       }
			    }
			    newtail1236_869 =
			       MAKE_PAIR(arg1536_871, BNIL);
			 }
			 SET_CDR(tail1235_866, newtail1236_869);
			 {
			    obj_t tail1235_2190;
			    obj_t l1232_2188;
			    l1232_2188 =
			       CDR(l1232_865);
			    tail1235_2190 = newtail1236_869;
			    tail1235_866 = tail1235_2190;
			    l1232_865 = l1232_2188;
			    goto lname1233_867;
			 }
		      }
		 }
	      }
	    {	/* Object/wide-access.scm 405 */
	       obj_t sf_tids_42_840;
	       if (
		  NULLP(sslots_112))
		 {	/* Object/wide-access.scm 411 */
		    sf_tids_42_840 = BNIL;
		 }
	       else
		 {	/* Object/wide-access.scm 411 */
		    obj_t head1239_846;
		    head1239_846 =
		       MAKE_PAIR(BNIL, BNIL);
		    {
		       obj_t l1237_847;
		       obj_t tail1240_848;
		       l1237_847 = sslots_112;
		       tail1240_848 = head1239_846;
		     lname1238_849:
		       if (
			  NULLP(l1237_847))
			 {	/* Object/wide-access.scm 411 */
			    sf_tids_42_840 =
			       CDR(head1239_846);
			 }
		       else
			 {	/* Object/wide-access.scm 412 */
			    obj_t newtail1241_851;
			    {	/* Object/wide-access.scm 412 */
			       obj_t arg1523_853;
			       {	/* Object/wide-access.scm 412 */
				  obj_t slot_855;
				  slot_855 =
				     CAR(l1237_847);
				  {	/* Object/wide-access.scm 413 */
				     obj_t arg1526_856;
				     arg1526_856 =
					STRUCT_REF(slot_855, ((long) 0));
				     {	/* Object/wide-access.scm 412 */
					obj_t list1528_858;
					{	/* Object/wide-access.scm 412 */
					   obj_t arg1529_859;
					   {	/* Object/wide-access.scm 412 */
					      obj_t arg1530_860;
					      {		/* Object/wide-access.scm 412 */
						 obj_t aux_2199;
						 {	/* Object/wide-access.scm 415 */
						    type_bglt obj_1400;
						    {	/* Object/wide-access.scm 415 */
						       obj_t aux_2200;
						       aux_2200 =
							  STRUCT_REF(slot_855, ((long) 2));
						       obj_1400 =
							  (type_bglt) (aux_2200);
						    }
						    aux_2199 =
						       (((type_bglt) CREF(obj_1400))->id);
						 }
						 arg1530_860 =
						    MAKE_PAIR(aux_2199, BNIL);
					      }
					      arg1529_859 =
						 MAKE_PAIR(_4dots_199_tools_misc, arg1530_860);
					   }
					   list1528_858 =
					      MAKE_PAIR(arg1526_856, arg1529_859);
					}
					arg1523_853 =
					   symbol_append_197___r4_symbols_6_4(list1528_858);
				     }
				  }
			       }
			       newtail1241_851 =
				  MAKE_PAIR(arg1523_853, BNIL);
			    }
			    SET_CDR(tail1240_848, newtail1241_851);
			    {
			       obj_t tail1240_2212;
			       obj_t l1237_2210;
			       l1237_2210 =
				  CDR(l1237_847);
			       tail1240_2212 = newtail1241_851;
			       tail1240_848 = tail1240_2212;
			       l1237_847 = l1237_2210;
			       goto lname1238_849;
			    }
			 }
		    }
		 }
	       {	/* Object/wide-access.scm 411 */

		  {	/* Object/wide-access.scm 418 */
		     obj_t arg1516_841;
		     {	/* ./Ieee/pair-list.scm 5689 */
			obj_t aux_2213;
			aux_2213 =
			   append_2_18___r4_pairs_and_lists_6_3(sf_tids_42_840,
			   append_2_18___r4_pairs_and_lists_6_3(f_tids_193_839, BNIL));
			arg1516_841 =
			   MAKE_PAIR(mk_tid_99_838, aux_2213);
		     }
		     return
			import_parser_53_module_impuse(module_114, arg1516_841);
		  }
	       }
	    }
	 }
      }
   }
}



/* method-init */
obj_t 
method_init_76_object_wide_access_168()
{
   AN_OBJECT;
   {	/* Object/wide-access.scm 20 */
      return BUNSPEC;
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_object_wide_access_168()
{
   AN_OBJECT;
   {	/* Object/wide-access.scm 20 */
      module_initialization_70_tools_trace(((long) 0), "OBJECT_WIDE-ACCESS");
      module_initialization_70_tools_error(((long) 0), "OBJECT_WIDE-ACCESS");
      module_initialization_70_tools_misc(((long) 0), "OBJECT_WIDE-ACCESS");
      module_initialization_70_type_type(((long) 0), "OBJECT_WIDE-ACCESS");
      module_initialization_70_type_env(((long) 0), "OBJECT_WIDE-ACCESS");
      module_initialization_70_type_tools(((long) 0), "OBJECT_WIDE-ACCESS");
      module_initialization_70_type_cache(((long) 0), "OBJECT_WIDE-ACCESS");
      module_initialization_70_ast_var(((long) 0), "OBJECT_WIDE-ACCESS");
      module_initialization_70_ast_ident(((long) 0), "OBJECT_WIDE-ACCESS");
      module_initialization_70_object_class(((long) 0), "OBJECT_WIDE-ACCESS");
      module_initialization_70_object_struct(((long) 0), "OBJECT_WIDE-ACCESS");
      module_initialization_70_object_slots(((long) 0), "OBJECT_WIDE-ACCESS");
      module_initialization_70_object_tools(((long) 0), "OBJECT_WIDE-ACCESS");
      module_initialization_70_object_access(((long) 0), "OBJECT_WIDE-ACCESS");
      module_initialization_70_module_module(((long) 0), "OBJECT_WIDE-ACCESS");
      module_initialization_70_module_impuse(((long) 0), "OBJECT_WIDE-ACCESS");
      return
	 module_initialization_70_engine_param(((long) 0), "OBJECT_WIDE-ACCESS");
   }
}
