/*===========================================================================*/
/*   (Prof/emit.scm)                                                         */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;

typedef struct ccomp
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t producer;
     obj_t consumer;
     obj_t finalizer;
     obj_t checksummer;
  }
     *ccomp_bglt;


static obj_t method_init_76_prof_emit();
static obj_t _emit_prof_info_49_prof_emit(obj_t, obj_t, obj_t);
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t module_initialization_70_prof_emit(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_tools_misc(long, char *);
extern obj_t module_initialization_70_type_env(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_ast_sexp(long, char *);
extern obj_t module_initialization_70_ast_env(long, char *);
extern obj_t module_initialization_70_ast_ident(long, char *);
extern obj_t module_initialization_70_ast_unit(long, char *);
extern obj_t module_initialization_70_module_module(long, char *);
extern obj_t module_initialization_70_module_include(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_cgen_prototype(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_output_6_10_3(long, char *);
static obj_t _anonymous_1481__152_prof_emit(obj_t, obj_t);
extern obj_t display_2_122___r4_output_6_10_3(obj_t, obj_t);
extern obj_t emit_prof_info_80_prof_emit(obj_t, obj_t);
static obj_t imported_modules_init_94_prof_emit();
extern obj_t _prof_table_name__107_engine_param;
static obj_t library_modules_init_112_prof_emit();
static obj_t toplevel_init_63_prof_emit();
extern obj_t open_input_string(obj_t);
extern obj_t sfun_ast_var;
extern obj_t string_to_bstring(char *);
extern obj_t memq___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern obj_t for_each_global__88_ast_env(obj_t);
static unsigned char emit_global__151_prof_emit(obj_t, obj_t);
extern obj_t set_variable_name__102_cgen_prototype(obj_t);
extern obj_t read___reader(obj_t);
static obj_t require_initialization_114_prof_emit = BUNSPEC;
static obj_t cnst_init_137_prof_emit();
static obj_t __cnst[2];

DEFINE_EXPORT_PROCEDURE(emit_prof_info_env_134_prof_emit, _emit_prof_info_49_prof_emit1608, _emit_prof_info_49_prof_emit, 0L, 2);
DEFINE_STRING(string1599_prof_emit, string1599_prof_emit1609, "}\n", 2);
DEFINE_STRING(string1598_prof_emit, string1598_prof_emit1610, "   return BUNSPEC;", 18);
DEFINE_STRING(string1597_prof_emit, string1597_prof_emit1611, "   GC_profile_init();", 21);
DEFINE_STRING(string1596_prof_emit, string1596_prof_emit1612, "   }", 4);
DEFINE_STRING(string1595_prof_emit, string1595_prof_emit1613, ")\\n\" );", 7);
DEFINE_STRING(string1594_prof_emit, string1594_prof_emit1614, "\\\"", 2);
DEFINE_STRING(string1593_prof_emit, string1593_prof_emit1615, "make_pair", 9);
DEFINE_STRING(string1603_prof_emit, string1603_prof_emit1616, "LOCATION ALLOCATOR ", 19);
DEFINE_STRING(string1592_prof_emit, string1592_prof_emit1617, "\\\" \\\"", 5);
DEFINE_STRING(string1602_prof_emit, string1602_prof_emit1618, ") \\\"", 4);
DEFINE_STRING(string1591_prof_emit, string1591_prof_emit1619, "CONS", 4);
DEFINE_STRING(string1601_prof_emit, string1601_prof_emit1620, "\\\" ", 3);
DEFINE_STRING(string1589_prof_emit, string1589_prof_emit1621, "   if( bprof_port ) {", 21);
DEFINE_STRING(string1590_prof_emit, string1590_prof_emit1622, "      fprintf( (FILE *)bprof_port, \"(\\\"", 39);
DEFINE_STRING(string1600_prof_emit, string1600_prof_emit1623, "      fprintf( (FILE *)bprof_port, \"((\\\"", 40);
DEFINE_STRING(string1588_prof_emit, string1588_prof_emit1624, "\", \"w\" );", 9);
DEFINE_STRING(string1587_prof_emit, string1587_prof_emit1625, "   if( bprof_port == BUNSPEC ) bprof_port = (obj_t)fopen( \"", 59);
DEFINE_STRING(string1586_prof_emit, string1586_prof_emit1626, "   extern obj_t bprof_port;", 27);
DEFINE_STRING(string1585_prof_emit, string1585_prof_emit1627, "static obj_t write_bprof_table() {", 34);
DEFINE_STRING(string1584_prof_emit, string1584_prof_emit1628, "/* prof association table */", 28);



/* module-initialization */
obj_t 
module_initialization_70_prof_emit(long checksum_1239, char *from_1240)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_prof_emit))
	{
	   require_initialization_114_prof_emit =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_prof_emit();
	   cnst_init_137_prof_emit();
	   imported_modules_init_94_prof_emit();
	   method_init_76_prof_emit();
	   toplevel_init_63_prof_emit();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_prof_emit()
{
   AN_OBJECT;
   {	/* Prof/emit.scm 14 */
      module_initialization_70___object(((long) 0), "PROF_EMIT");
      module_initialization_70___r4_output_6_10_3(((long) 0), "PROF_EMIT");
      module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "PROF_EMIT");
      module_initialization_70___reader(((long) 0), "PROF_EMIT");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_prof_emit()
{
   AN_OBJECT;
   {	/* Prof/emit.scm 14 */
      {		/* Prof/emit.scm 14 */
	 obj_t cnst_port_138_1232;
	 cnst_port_138_1232 =
	    open_input_string(string1603_prof_emit);
	 {
	    long i_1233;
	    i_1233 = ((long) 1);
	  loop_1234:
	    {	/* Prof/emit.scm 14 */
	       bool_t test1604_1235;
	       test1604_1235 =
		  (i_1233 == ((long) -1));
	       if (test1604_1235)
		 {	/* Prof/emit.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Prof/emit.scm 14 */
		    {	/* Prof/emit.scm 14 */
		       obj_t arg1605_1236;
		       {	/* Prof/emit.scm 14 */
			  obj_t list1606_1237;
			  list1606_1237 =
			     MAKE_PAIR(cnst_port_138_1232, BNIL);
			  arg1605_1236 =
			     read___reader(list1606_1237);
		       }
		       CNST_TABLE_SET(i_1233, arg1605_1236);
		    }
		    {	/* Prof/emit.scm 14 */
		       int aux_1238;
		       {	/* Prof/emit.scm 14 */
			  long aux_1259;
			  aux_1259 =
			     (i_1233 - ((long) 1));
			  aux_1238 =
			     (int) (aux_1259);
		       }
		       {
			  long i_1262;
			  i_1262 =
			     (long) (aux_1238);
			  i_1233 = i_1262;
			  goto loop_1234;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_prof_emit()
{
   AN_OBJECT;
   {	/* Prof/emit.scm 14 */
      return BUNSPEC;
   }
}



/* emit-prof-info */
obj_t 
emit_prof_info_80_prof_emit(obj_t globals_33, obj_t port_34)
{
   AN_OBJECT;
   {	/* Prof/emit.scm 36 */
      WRITE_CHAR(((unsigned char) '\n'), port_34);
      WRITE_CHAR(((unsigned char) '\n'), port_34);
      display_2_122___r4_output_6_10_3(string1584_prof_emit, port_34);
      WRITE_CHAR(((unsigned char) '\n'), port_34);
      display_2_122___r4_output_6_10_3(string1585_prof_emit, port_34);
      WRITE_CHAR(((unsigned char) '\n'), port_34);
      display_2_122___r4_output_6_10_3(string1586_prof_emit, port_34);
      WRITE_CHAR(((unsigned char) '\n'), port_34);
      display_2_122___r4_output_6_10_3(string1587_prof_emit, port_34);
      display_2_122___r4_output_6_10_3(_prof_table_name__107_engine_param, port_34);
      display_2_122___r4_output_6_10_3(string1588_prof_emit, port_34);
      WRITE_CHAR(((unsigned char) '\n'), port_34);
      display_2_122___r4_output_6_10_3(string1589_prof_emit, port_34);
      WRITE_CHAR(((unsigned char) '\n'), port_34);
      {		/* Prof/emit.scm 77 */
	 obj_t _anonymous_1481__152_1222;
	 _anonymous_1481__152_1222 =
	    make_fx_procedure(_anonymous_1481__152_prof_emit, ((long) 1), ((long) 1));
	 PROCEDURE_SET(_anonymous_1481__152_1222, ((long) 0), port_34);
	 for_each_global__88_ast_env(_anonymous_1481__152_1222);
      }
      {
	 obj_t l1454_776;
	 l1454_776 = globals_33;
       lname1455_777:
	 if (
	    PAIRP(l1454_776))
	   {	/* Prof/emit.scm 82 */
	      {		/* Prof/emit.scm 83 */
		 obj_t global_779;
		 global_779 =
		    CAR(l1454_776);
		 {	/* Prof/emit.scm 83 */
		    bool_t test_1284;
		    {	/* Prof/emit.scm 83 */
		       global_bglt obj_1190;
		       obj_1190 =
			  (global_bglt) (global_779);
		       test_1284 =
			  (((global_bglt) CREF(obj_1190))->user__32);
		    }
		    if (test_1284)
		      {		/* Prof/emit.scm 84 */
			 unsigned char aux_1287;
			 aux_1287 =
			    emit_global__151_prof_emit(port_34, global_779);
			 BCHAR(aux_1287);
		      }
		    else
		      {		/* Prof/emit.scm 83 */
			 BUNSPEC;
		      }
		 }
	      }
	      {
		 obj_t l1454_1290;
		 l1454_1290 =
		    CDR(l1454_776);
		 l1454_776 = l1454_1290;
		 goto lname1455_777;
	      }
	   }
	 else
	   {	/* Prof/emit.scm 82 */
	      ((bool_t) 1);
	   }
      }
      display_2_122___r4_output_6_10_3(string1590_prof_emit, port_34);
      display_2_122___r4_output_6_10_3(string1591_prof_emit, port_34);
      display_2_122___r4_output_6_10_3(string1592_prof_emit, port_34);
      display_2_122___r4_output_6_10_3(string1593_prof_emit, port_34);
      display_2_122___r4_output_6_10_3(string1594_prof_emit, port_34);
      display_2_122___r4_output_6_10_3(string1595_prof_emit, port_34);
      WRITE_CHAR(((unsigned char) '\n'), port_34);
      display_2_122___r4_output_6_10_3(string1596_prof_emit, port_34);
      WRITE_CHAR(((unsigned char) '\n'), port_34);
      display_2_122___r4_output_6_10_3(string1597_prof_emit, port_34);
      WRITE_CHAR(((unsigned char) '\n'), port_34);
      display_2_122___r4_output_6_10_3(string1598_prof_emit, port_34);
      WRITE_CHAR(((unsigned char) '\n'), port_34);
      display_2_122___r4_output_6_10_3(string1599_prof_emit, port_34);
      {		/* ./Ieee/output.scm 9332 */
	 unsigned char aux_1306;
	 aux_1306 =
	    WRITE_CHAR(((unsigned char) '\n'), port_34);
	 return
	    BCHAR(aux_1306);
      }
   }
}



/* _emit-prof-info */
obj_t 
_emit_prof_info_49_prof_emit(obj_t env_1223, obj_t globals_1224, obj_t port_1225)
{
   AN_OBJECT;
   {	/* Prof/emit.scm 36 */
      return
	 emit_prof_info_80_prof_emit(globals_1224, port_1225);
   }
}



/* emit-global! */
unsigned char 
emit_global__151_prof_emit(obj_t port_1226, obj_t global_787)
{
   AN_OBJECT;
   {	/* Prof/emit.scm 37 */
      {		/* Prof/emit.scm 38 */
	 value_bglt sfun_789;
	 {	/* Prof/emit.scm 38 */
	    global_bglt obj_1197;
	    obj_1197 =
	       (global_bglt) (global_787);
	    sfun_789 =
	       (((global_bglt) CREF(obj_1197))->value);
	 }
	 {	/* Prof/emit.scm 39 */

	    set_variable_name__102_cgen_prototype(global_787);
	    {	/* Prof/emit.scm 41 */
	       obj_t id_791;
	       obj_t c_name_211_792;
	       obj_t alloc__191_793;
	       obj_t loc_794;
	       {	/* Prof/emit.scm 41 */
		  global_bglt obj_1199;
		  obj_1199 =
		     (global_bglt) (global_787);
		  id_791 =
		     (((global_bglt) CREF(obj_1199))->id);
	       }
	       {	/* Prof/emit.scm 42 */
		  global_bglt obj_1200;
		  obj_1200 =
		     (global_bglt) (global_787);
		  c_name_211_792 =
		     (((global_bglt) CREF(obj_1200))->name);
	       }
	       {	/* Prof/emit.scm 43 */
		  bool_t _andtest_1445_802;
		  _andtest_1445_802 =
		     is_a__118___object(
		     (obj_t) (sfun_789), sfun_ast_var);
		  if (_andtest_1445_802)
		    {	/* Prof/emit.scm 44 */
		       obj_t aux_1320;
		       {	/* Prof/emit.scm 44 */
			  sfun_bglt obj_1202;
			  obj_1202 =
			     (sfun_bglt) (sfun_789);
			  aux_1320 =
			     (((sfun_bglt) CREF(obj_1202))->property);
		       }
		       alloc__191_793 =
			  memq___r4_pairs_and_lists_6_3(
			  CNST_TABLE_REF(((long) 0)), aux_1320);
		    }
		  else
		    {	/* Prof/emit.scm 43 */
		       alloc__191_793 = BFALSE;
		    }
	       }
	       {	/* Prof/emit.scm 45 */
		  bool_t _andtest_1446_805;
		  _andtest_1446_805 =
		     is_a__118___object(
		     (obj_t) (sfun_789), sfun_ast_var);
		  if (_andtest_1446_805)
		    {	/* Prof/emit.scm 46 */
		       sfun_bglt obj_1204;
		       obj_1204 =
			  (sfun_bglt) (sfun_789);
		       loc_794 =
			  (((sfun_bglt) CREF(obj_1204))->loc);
		    }
		  else
		    {	/* Prof/emit.scm 45 */
		       loc_794 = BFALSE;
		    }
	       }
	       {	/* Prof/emit.scm 47 */
		  bool_t test_1330;
		  if (
		     STRUCTP(loc_794))
		    {	/* ./Ieee/equiv.scm 5508 */
		       obj_t aux_1335;
		       obj_t aux_1333;
		       aux_1335 =
			  CNST_TABLE_REF(((long) 1));
		       aux_1333 =
			  STRUCT_KEY(loc_794);
		       test_1330 =
			  (aux_1333 == aux_1335);
		    }
		  else
		    {	/* ./Tools/location.sch 368 */
		       test_1330 = ((bool_t) 0)
			  ;
		    }
		  if (test_1330)
		    {	/* Prof/emit.scm 47 */
		       display_2_122___r4_output_6_10_3(string1600_prof_emit, port_1226);
		       display_2_122___r4_output_6_10_3(id_791, port_1226);
		       display_2_122___r4_output_6_10_3(string1601_prof_emit, port_1226);
		       display_2_122___r4_output_6_10_3(string1594_prof_emit, port_1226);
		       display_2_122___r4_output_6_10_3(
			  STRUCT_REF(loc_794, ((long) 0)), port_1226);
		       display_2_122___r4_output_6_10_3(string1601_prof_emit, port_1226);
		       display_2_122___r4_output_6_10_3(
			  STRUCT_REF(loc_794, ((long) 1)), port_1226);
		       display_2_122___r4_output_6_10_3(string1602_prof_emit, port_1226);
		       display_2_122___r4_output_6_10_3(c_name_211_792, port_1226);
		       display_2_122___r4_output_6_10_3(string1594_prof_emit, port_1226);
		       {	/* Prof/emit.scm 48 */
			  obj_t aux_1350;
			  {	/* Prof/emit.scm 48 */
			     char *aux_1351;
			     if (
				CBOOL(alloc__191_793))
			       {	/* Prof/emit.scm 56 */
				  aux_1351 = " allocator"
				     ;
			       }
			     else
			       {	/* Prof/emit.scm 56 */
				  aux_1351 = ""
				     ;
			       }
			     aux_1350 =
				string_to_bstring(aux_1351);
			  }
			  display_2_122___r4_output_6_10_3(aux_1350, port_1226);
		       }
		       display_2_122___r4_output_6_10_3(string1595_prof_emit, port_1226);
		       return
			  WRITE_CHAR(((unsigned char) '\n'), port_1226);
		    }
		  else
		    {	/* Prof/emit.scm 47 */
		       display_2_122___r4_output_6_10_3(string1590_prof_emit, port_1226);
		       display_2_122___r4_output_6_10_3(id_791, port_1226);
		       display_2_122___r4_output_6_10_3(string1592_prof_emit, port_1226);
		       display_2_122___r4_output_6_10_3(c_name_211_792, port_1226);
		       display_2_122___r4_output_6_10_3(string1594_prof_emit, port_1226);
		       {	/* Prof/emit.scm 58 */
			  obj_t aux_1363;
			  {	/* Prof/emit.scm 58 */
			     char *aux_1364;
			     if (
				CBOOL(alloc__191_793))
			       {	/* Prof/emit.scm 63 */
				  aux_1364 = " allocator"
				     ;
			       }
			     else
			       {	/* Prof/emit.scm 63 */
				  aux_1364 = ""
				     ;
			       }
			     aux_1363 =
				string_to_bstring(aux_1364);
			  }
			  display_2_122___r4_output_6_10_3(aux_1363, port_1226);
		       }
		       display_2_122___r4_output_6_10_3(string1595_prof_emit, port_1226);
		       return
			  WRITE_CHAR(((unsigned char) '\n'), port_1226);
		    }
	       }
	    }
	 }
      }
   }
}



/* <anonymous:1481> */
obj_t 
_anonymous_1481__152_prof_emit(obj_t env_1227, obj_t g_1229)
{
   AN_OBJECT;
   {	/* Prof/emit.scm 76 */
      {		/* Prof/emit.scm 77 */
	 obj_t port_1228;
	 port_1228 =
	    PROCEDURE_REF(env_1227, ((long) 0));
	 {
	    obj_t g_768;
	    g_768 = g_1229;
	    {	/* Prof/emit.scm 77 */
	       bool_t test_1372;
	       {	/* Prof/emit.scm 77 */
		  bool_t test_1373;
		  {	/* ./Ieee/fixnum.scm 7121 */
		     long aux_1374;
		     {	/* Prof/emit.scm 77 */
			global_bglt obj_1183;
			obj_1183 =
			   (global_bglt) (g_768);
			aux_1374 =
			   (((global_bglt) CREF(obj_1183))->occurrence);
		     }
		     test_1373 =
			(aux_1374 > ((long) 0));
		  }
		  if (test_1373)
		    {	/* Prof/emit.scm 78 */
		       bool_t test_1378;
		       {	/* Prof/emit.scm 78 */
			  global_bglt obj_1186;
			  obj_1186 =
			     (global_bglt) (g_768);
			  test_1378 =
			     (((global_bglt) CREF(obj_1186))->library__255);
		       }
		       if (test_1378)
			 {	/* Prof/emit.scm 79 */
			    global_bglt obj_1187;
			    obj_1187 =
			       (global_bglt) (g_768);
			    test_1372 =
			       (((global_bglt) CREF(obj_1187))->user__32);
			 }
		       else
			 {	/* Prof/emit.scm 78 */
			    test_1372 = ((bool_t) 0)
			       ;
			 }
		    }
		  else
		    {	/* Prof/emit.scm 77 */
		       test_1372 = ((bool_t) 0)
			  ;
		    }
	       }
	       if (test_1372)
		 {	/* Prof/emit.scm 80 */
		    unsigned char aux_1383;
		    aux_1383 =
		       emit_global__151_prof_emit(port_1228, g_768);
		    return
		       BCHAR(aux_1383);
		 }
	       else
		 {	/* Prof/emit.scm 77 */
		    return BUNSPEC;
		 }
	    }
	 }
      }
   }
}



/* method-init */
obj_t 
method_init_76_prof_emit()
{
   AN_OBJECT;
   {	/* Prof/emit.scm 14 */
      return BUNSPEC;
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_prof_emit()
{
   AN_OBJECT;
   {	/* Prof/emit.scm 14 */
      module_initialization_70_type_type(((long) 0), "PROF_EMIT");
      module_initialization_70_ast_var(((long) 0), "PROF_EMIT");
      module_initialization_70_ast_node(((long) 0), "PROF_EMIT");
      module_initialization_70_tools_shape(((long) 0), "PROF_EMIT");
      module_initialization_70_tools_error(((long) 0), "PROF_EMIT");
      module_initialization_70_tools_misc(((long) 0), "PROF_EMIT");
      module_initialization_70_type_env(((long) 0), "PROF_EMIT");
      module_initialization_70_type_cache(((long) 0), "PROF_EMIT");
      module_initialization_70_ast_sexp(((long) 0), "PROF_EMIT");
      module_initialization_70_ast_env(((long) 0), "PROF_EMIT");
      module_initialization_70_ast_ident(((long) 0), "PROF_EMIT");
      module_initialization_70_ast_unit(((long) 0), "PROF_EMIT");
      module_initialization_70_module_module(((long) 0), "PROF_EMIT");
      module_initialization_70_module_include(((long) 0), "PROF_EMIT");
      module_initialization_70_engine_param(((long) 0), "PROF_EMIT");
      return
	 module_initialization_70_cgen_prototype(((long) 0), "PROF_EMIT");
   }
}
