/*===========================================================================*/
/*   (Prof/unit.scm)                                                         */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;


static obj_t method_init_76_prof_walk();
extern obj_t _nb_error_on_pass__70_tools_error;
extern obj_t create_struct(obj_t, long);
extern obj_t verbose_tools_speek(obj_t, obj_t);
extern obj_t module_initialization_70_prof_walk(long, char *);
extern obj_t module_initialization_70_tools_speek(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_engine_pass(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_module_include(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_numbers_6_5(long, char *);
static obj_t imported_modules_init_94_prof_walk();
static obj_t library_modules_init_112_prof_walk();
static obj_t toplevel_init_63_prof_walk();
static obj_t _make_prof_unit_78_prof_walk(obj_t);
extern obj_t open_input_string(obj_t);
extern obj_t internal_error_43_tools_error(obj_t, obj_t, obj_t);
extern obj_t make_prof_unit_161_prof_walk();
extern obj_t _2__168___r4_numbers_6_5(obj_t, obj_t);
extern obj_t read___reader(obj_t);
extern obj_t get_toplevel_unit_weight_75_module_include();
static obj_t require_initialization_114_prof_walk = BUNSPEC;
static obj_t cnst_init_137_prof_walk();
extern obj_t _current_pass__25_engine_pass;
static obj_t __cnst[4];

DEFINE_EXPORT_PROCEDURE(make_prof_unit_env_53_prof_walk, _make_prof_unit_78_prof_walk1560, _make_prof_unit_78_prof_walk, 0L, 0);
DEFINE_STRING(string1555_prof_walk, string1555_prof_walk1561, "UNIT (BEGIN (PRAGMA \"write_bprof_table()\")) PROF PASS-STARTED ", 62);
DEFINE_STRING(string1554_prof_walk, string1554_prof_walk1562, "failure during prelude hook", 27);
DEFINE_STRING(string1553_prof_walk, string1553_prof_walk1563, "   . ", 5);
DEFINE_STRING(string1552_prof_walk, string1552_prof_walk1564, "Prof", 4);



/* module-initialization */
obj_t 
module_initialization_70_prof_walk(long checksum_1148, char *from_1149)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_prof_walk))
	{
	   require_initialization_114_prof_walk =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_prof_walk();
	   cnst_init_137_prof_walk();
	   imported_modules_init_94_prof_walk();
	   method_init_76_prof_walk();
	   toplevel_init_63_prof_walk();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_prof_walk()
{
   AN_OBJECT;
   {	/* Prof/unit.scm 14 */
      module_initialization_70___r4_numbers_6_5(((long) 0), "PROF_WALK");
      module_initialization_70___reader(((long) 0), "PROF_WALK");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_prof_walk()
{
   AN_OBJECT;
   {	/* Prof/unit.scm 14 */
      {		/* Prof/unit.scm 14 */
	 obj_t cnst_port_138_1141;
	 cnst_port_138_1141 =
	    open_input_string(string1555_prof_walk);
	 {
	    long i_1142;
	    i_1142 = ((long) 3);
	  loop_1143:
	    {	/* Prof/unit.scm 14 */
	       bool_t test1556_1144;
	       test1556_1144 =
		  (i_1142 == ((long) -1));
	       if (test1556_1144)
		 {	/* Prof/unit.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Prof/unit.scm 14 */
		    {	/* Prof/unit.scm 14 */
		       obj_t arg1557_1145;
		       {	/* Prof/unit.scm 14 */
			  obj_t list1558_1146;
			  list1558_1146 =
			     MAKE_PAIR(cnst_port_138_1141, BNIL);
			  arg1557_1145 =
			     read___reader(list1558_1146);
		       }
		       CNST_TABLE_SET(i_1142, arg1557_1145);
		    }
		    {	/* Prof/unit.scm 14 */
		       int aux_1147;
		       {	/* Prof/unit.scm 14 */
			  long aux_1166;
			  aux_1166 =
			     (i_1142 - ((long) 1));
			  aux_1147 =
			     (int) (aux_1166);
		       }
		       {
			  long i_1169;
			  i_1169 =
			     (long) (aux_1147);
			  i_1142 = i_1169;
			  goto loop_1143;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_prof_walk()
{
   AN_OBJECT;
   {	/* Prof/unit.scm 14 */
      return BUNSPEC;
   }
}



/* make-prof-unit */
obj_t 
make_prof_unit_161_prof_walk()
{
   AN_OBJECT;
   {	/* Prof/unit.scm 29 */
      {		/* Prof/unit.scm 29 */
	 obj_t list1446_724;
	 {	/* Prof/unit.scm 29 */
	    obj_t arg1449_726;
	    {	/* Prof/unit.scm 29 */
	       obj_t arg1451_728;
	       {	/* Prof/unit.scm 29 */
		  obj_t aux_1171;
		  aux_1171 =
		     BCHAR(((unsigned char) '\n'));
		  arg1451_728 =
		     MAKE_PAIR(aux_1171, BNIL);
	       }
	       arg1449_726 =
		  MAKE_PAIR(string1552_prof_walk, arg1451_728);
	    }
	    list1446_724 =
	       MAKE_PAIR(string1553_prof_walk, arg1449_726);
	 }
	 verbose_tools_speek(
	    BINT(((long) 1)), list1446_724);
      }
      _nb_error_on_pass__70_tools_error =
	 BINT(((long) 0));
      _current_pass__25_engine_pass = string1552_prof_walk;
      {
	 obj_t hooks_729;
	 obj_t hnames_730;
	 hooks_729 = BNIL;
	 hnames_730 = BNIL;
       loop_731:
	 if (
	    NULLP(hooks_729))
	   {	/* Prof/unit.scm 29 */
	      CNST_TABLE_REF(((long) 0));
	   }
	 else
	   {	/* Prof/unit.scm 29 */
	      bool_t test1457_736;
	      {		/* Prof/unit.scm 29 */
		 obj_t fun1464_742;
		 fun1464_742 =
		    CAR(hooks_729);
		 {	/* Prof/unit.scm 29 */
		    obj_t aux_1183;
		    aux_1183 =
		       PROCEDURE_ENTRY(fun1464_742) (fun1464_742, BEOA);
		    test1457_736 =
		       CBOOL(aux_1183);
		 }
	      }
	      if (test1457_736)
		{	/* Prof/unit.scm 29 */
		   {
		      obj_t hnames_1190;
		      obj_t hooks_1188;
		      hooks_1188 =
			 CDR(hooks_729);
		      hnames_1190 =
			 CDR(hnames_730);
		      hnames_730 = hnames_1190;
		      hooks_729 = hooks_1188;
		      goto loop_731;
		   }
		}
	      else
		{	/* Prof/unit.scm 29 */
		   internal_error_43_tools_error(string1552_prof_walk, string1554_prof_walk,
		      CAR(hnames_730));
		}
	   }
      }
      {		/* Prof/unit.scm 31 */
	 obj_t arg1466_743;
	 obj_t arg1467_744;
	 obj_t arg1469_745;
	 arg1466_743 =
	    CNST_TABLE_REF(((long) 1));
	 {	/* Prof/unit.scm 32 */
	    obj_t arg1471_747;
	    arg1471_747 =
	       get_toplevel_unit_weight_75_module_include();
	    arg1467_744 =
	       _2__168___r4_numbers_6_5(
	       BINT(((long) 100)), arg1471_747);
	 }
	 arg1469_745 =
	    CNST_TABLE_REF(((long) 2));
	 {	/* ./Ast/unit.sch 352 */
	    obj_t new_1118;
	    {	/* ./Ast/unit.sch 352 */
	       obj_t aux_1199;
	       aux_1199 =
		  CNST_TABLE_REF(((long) 3));
	       new_1118 =
		  create_struct(aux_1199, ((long) 4));
	    }
	    STRUCT_SET(new_1118, ((long) 3), BTRUE);
	    STRUCT_SET(new_1118, ((long) 2), arg1469_745);
	    STRUCT_SET(new_1118, ((long) 1), arg1467_744);
	    STRUCT_SET(new_1118, ((long) 0), arg1466_743);
	    return new_1118;
	 }
      }
   }
}



/* _make-prof-unit */
obj_t 
_make_prof_unit_78_prof_walk(obj_t env_1139)
{
   AN_OBJECT;
   {	/* Prof/unit.scm 29 */
      return
	 make_prof_unit_161_prof_walk();
   }
}



/* method-init */
obj_t 
method_init_76_prof_walk()
{
   AN_OBJECT;
   {	/* Prof/unit.scm 14 */
      return BUNSPEC;
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_prof_walk()
{
   AN_OBJECT;
   {	/* Prof/unit.scm 14 */
      module_initialization_70_tools_speek(((long) 0), "PROF_WALK");
      module_initialization_70_tools_error(((long) 0), "PROF_WALK");
      module_initialization_70_engine_pass(((long) 0), "PROF_WALK");
      module_initialization_70_tools_shape(((long) 0), "PROF_WALK");
      module_initialization_70_engine_param(((long) 0), "PROF_WALK");
      module_initialization_70_type_type(((long) 0), "PROF_WALK");
      module_initialization_70_module_include(((long) 0), "PROF_WALK");
      module_initialization_70_ast_var(((long) 0), "PROF_WALK");
      return
	 module_initialization_70_ast_node(((long) 0), "PROF_WALK");
   }
}
