/*===========================================================================*/
/*   (Read/inline.scm)                                                       */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;


extern obj_t unwind_until__178___bexit(obj_t, obj_t);
static obj_t method_init_76_read_inline();
static obj_t _inline_definitions__29_read_inline = BUNSPEC;
extern obj_t inline_finalizer_105_read_inline();
extern obj_t _load_path__54___eval;
extern obj_t find_file_path_55___os(obj_t, obj_t);
extern obj_t id_of_id_112_ast_ident(obj_t, obj_t);
extern obj_t create_struct(obj_t, long);
extern obj_t user_error_151_tools_error(obj_t, obj_t, obj_t, obj_t);
static obj_t handling_function1235_read_inline(obj_t, obj_t, obj_t, obj_t);
static obj_t look_for_inline_exp_95_read_inline(obj_t, obj_t, obj_t);
extern obj_t module_initialization_70_read_inline(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_read_reader(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_tools_speek(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_ast_ident(long, char *);
extern obj_t module_initialization_70_ast_env(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_tools_location(long, char *);
extern obj_t module_initialization_70___os(long, char *);
extern obj_t module_initialization_70___bexit(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___eval(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_ports_6_10_1(long, char *);
extern obj_t compiler_read_18_read_reader(obj_t);
static obj_t imported_modules_init_94_read_inline();
static obj_t library_modules_init_112_read_inline();
extern obj_t assq___r4_pairs_and_lists_6_3(obj_t, obj_t);
static obj_t toplevel_init_63_read_inline();
extern obj_t open_input_string(obj_t);
extern obj_t look_for_inline_98_read_inline(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t remq__51___r4_pairs_and_lists_6_3(obj_t, obj_t);
static obj_t loop_read_inline(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t close_input_port(obj_t);
static obj_t _look_for_inline_143_read_inline(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t read___reader(obj_t);
extern obj_t find_location_120_tools_location(obj_t);
static obj_t _inline_finalizer_140_read_inline(obj_t);
extern obj_t val_from_exit__100___bexit(obj_t);
static obj_t require_initialization_114_read_inline = BUNSPEC;
extern obj_t open_input_file_61___r4_ports_6_10_1(obj_t, obj_t);
static obj_t cnst_init_137_read_inline();
static obj_t __cnst[7];

DEFINE_EXPORT_PROCEDURE(look_for_inline_env_65_read_inline, _look_for_inline_143_read_inline1328, _look_for_inline_143_read_inline, 0L, 5);
DEFINE_EXPORT_PROCEDURE(inline_finalizer_env_166_read_inline, _inline_finalizer_140_read_inline1329, _inline_finalizer_140_read_inline, 0L, 0);
DEFINE_STRING(string1322_read_inline, string1322_read_inline1330, "UNIT IMPORTED-INLINES BEGIN DEFINE-INLINE @ SIFUN DONE ", 55);
DEFINE_STRING(string1321_read_inline, string1321_read_inline1331, "Can't find file", 15);
DEFINE_STRING(string1319_read_inline, string1319_read_inline1332, "import", 6);
DEFINE_STRING(string1320_read_inline, string1320_read_inline1333, "Can't find inline/generic definition(s)", 39);



/* module-initialization */
obj_t 
module_initialization_70_read_inline(long checksum_708, char *from_709)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_read_inline))
	{
	   require_initialization_114_read_inline =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_read_inline();
	   cnst_init_137_read_inline();
	   imported_modules_init_94_read_inline();
	   method_init_76_read_inline();
	   toplevel_init_63_read_inline();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_read_inline()
{
   AN_OBJECT;
   {	/* Read/inline.scm 14 */
      module_initialization_70___bexit(((long) 0), "READ_INLINE");
      module_initialization_70___eval(((long) 0), "READ_INLINE");
      module_initialization_70___os(((long) 0), "READ_INLINE");
      module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "READ_INLINE");
      module_initialization_70___reader(((long) 0), "READ_INLINE");
      module_initialization_70___r4_ports_6_10_1(((long) 0), "READ_INLINE");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_read_inline()
{
   AN_OBJECT;
   {	/* Read/inline.scm 14 */
      {		/* Read/inline.scm 14 */
	 obj_t cnst_port_138_701;
	 cnst_port_138_701 =
	    open_input_string(string1322_read_inline);
	 {
	    long i_702;
	    i_702 = ((long) 6);
	  loop_703:
	    {	/* Read/inline.scm 14 */
	       bool_t test1323_704;
	       test1323_704 =
		  (i_702 == ((long) -1));
	       if (test1323_704)
		 {	/* Read/inline.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Read/inline.scm 14 */
		    {	/* Read/inline.scm 14 */
		       obj_t arg1325_705;
		       {	/* Read/inline.scm 14 */
			  obj_t list1326_706;
			  list1326_706 =
			     MAKE_PAIR(cnst_port_138_701, BNIL);
			  arg1325_705 =
			     read___reader(list1326_706);
		       }
		       CNST_TABLE_SET(i_702, arg1325_705);
		    }
		    {	/* Read/inline.scm 14 */
		       int aux_707;
		       {	/* Read/inline.scm 14 */
			  long aux_730;
			  aux_730 =
			     (i_702 - ((long) 1));
			  aux_707 =
			     (int) (aux_730);
		       }
		       {
			  long i_733;
			  i_733 =
			     (long) (aux_707);
			  i_702 = i_733;
			  goto loop_703;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_read_inline()
{
   AN_OBJECT;
   {	/* Read/inline.scm 14 */
      return (
	 _inline_definitions__29_read_inline = BNIL, BUNSPEC);
   }
}



/* look-for-inline */
obj_t 
look_for_inline_98_read_inline(obj_t inlines_19, obj_t code_20, obj_t port_21, obj_t fnames_22, obj_t module_23)
{
   AN_OBJECT;
   {	/* Read/inline.scm 34 */
      {		/* Read/inline.scm 35 */
	 obj_t arg1204_346;
	 obj_t arg1206_347;
	 arg1204_346 =
	    look_for_inline_exp_95_read_inline(inlines_19, code_20, module_23);
	 {	/* Read/inline.scm 36 */
	    obj_t list1207_348;
	    {	/* Read/inline.scm 36 */
	       obj_t arg1209_349;
	       arg1209_349 =
		  MAKE_PAIR(BTRUE, BNIL);
	       list1207_348 =
		  MAKE_PAIR(port_21, arg1209_349);
	    }
	    arg1206_347 =
	       compiler_read_18_read_reader(list1207_348);
	 }
	 return
	    loop_read_inline(module_23, arg1204_346, arg1206_347, fnames_22, port_21);
      }
   }
}



/* loop */
obj_t 
loop_read_inline(obj_t module_695, obj_t inlines_341, obj_t exp_342, obj_t fnames_343, obj_t port_344)
{
   AN_OBJECT;
   {	/* Read/inline.scm 35 */
    loop_read_inline:
      {		/* Read/inline.scm 40 */
	 bool_t test1210_350;
	 test1210_350 =
	    NULLP(inlines_341);
	 if (test1210_350)
	   {	/* Read/inline.scm 40 */
	      return
		 CNST_TABLE_REF(((long) 0));
	   }
	 else
	   {	/* Read/inline.scm 42 */
	      bool_t test1211_351;
	      test1211_351 =
		 EOF_OBJECTP(exp_342);
	      if (test1211_351)
		{	/* Read/inline.scm 42 */
		   if (
		      NULLP(fnames_343))
		     {	/* Read/inline.scm 44 */
			obj_t arg1215_355;
			if (test1210_350)
			  {	/* Read/inline.scm 46 */
			     arg1215_355 = BNIL;
			  }
			else
			  {	/* Read/inline.scm 46 */
			     obj_t head1186_359;
			     {	/* ./Ieee/pair-list.scm 5689 */
				obj_t aux_748;
				{	/* ./Ieee/pair-list.scm 5701 */
				   obj_t aux_749;
				   aux_749 =
				      CAR(inlines_341);
				   aux_748 =
				      CAR(aux_749);
				}
				head1186_359 =
				   MAKE_PAIR(aux_748, BNIL);
			     }
			     {
				obj_t l1184_360;
				obj_t tail1187_361;
				l1184_360 =
				   CDR(inlines_341);
				tail1187_361 = head1186_359;
			      lname1185_362:
				if (
				   NULLP(l1184_360))
				  {	/* Read/inline.scm 46 */
				     arg1215_355 = head1186_359;
				  }
				else
				  {	/* Read/inline.scm 46 */
				     obj_t newtail1188_365;
				     {	/* ./Ieee/pair-list.scm 5689 */
					obj_t aux_755;
					{	/* ./Ieee/pair-list.scm 5701 */
					   obj_t aux_756;
					   aux_756 =
					      CAR(l1184_360);
					   aux_755 =
					      CAR(aux_756);
					}
					newtail1188_365 =
					   MAKE_PAIR(aux_755, BNIL);
				     }
				     SET_CDR(tail1187_361, newtail1188_365);
				     {
					obj_t tail1187_763;
					obj_t l1184_761;
					l1184_761 =
					   CDR(l1184_360);
					tail1187_763 = newtail1188_365;
					tail1187_361 = tail1187_763;
					l1184_360 = l1184_761;
					goto lname1185_362;
				     }
				  }
			     }
			  }
			return
			   user_error_151_tools_error(string1319_read_inline, string1320_read_inline, arg1215_355, BNIL);
		     }
		   else
		     {	/* Read/inline.scm 47 */
			obj_t fname_373;
			fname_373 =
			   find_file_path_55___os(
			   CAR(fnames_343), _load_path__54___eval);
			if (
			   STRINGP(fname_373))
			  {	/* Read/inline.scm 50 */
			     obj_t port_375;
			     port_375 =
				open_input_file_61___r4_ports_6_10_1(fname_373, BNIL);
			     {	/* Read/inline.scm 51 */
				obj_t val1189_376;
				val1189_376 =
				   handling_function1235_read_inline(inlines_341, fnames_343, port_375, module_695);
				if (
				   INPUT_PORTP(port_375))
				  {	/* Read/inline.scm 55 */
				     close_input_port(port_375);
				  }
				else
				  {	/* Read/inline.scm 55 */
				     BUNSPEC;
				  }
				{	/* Read/inline.scm 55 */
				   bool_t test1232_378;
				   {	/* Read/inline.scm 55 */
				      obj_t aux_775;
				      aux_775 =
					 val_from_exit__100___bexit(val1189_376);
				      test1232_378 =
					 CBOOL(aux_775);
				   }
				   if (test1232_378)
				     {	/* Read/inline.scm 55 */
					return
					   unwind_until__178___bexit(
					   CAR(val1189_376),
					   CDR(val1189_376));
				     }
				   else
				     {	/* Read/inline.scm 55 */
					return val1189_376;
				     }
				}
			     }
			  }
			else
			  {	/* Read/inline.scm 48 */
			     return
				user_error_151_tools_error(string1319_read_inline, string1321_read_inline,
				CAR(fnames_343), BNIL);
			  }
		     }
		}
	      else
		{	/* Read/inline.scm 42 */
		   {	/* Read/inline.scm 58 */
		      obj_t arg1249_394;
		      obj_t arg1250_395;
		      arg1249_394 =
			 look_for_inline_exp_95_read_inline(inlines_341, exp_342, module_695);
		      {		/* Read/inline.scm 59 */
			 obj_t list1251_396;
			 {	/* Read/inline.scm 59 */
			    obj_t arg1252_397;
			    arg1252_397 =
			       MAKE_PAIR(BTRUE, BNIL);
			    list1251_396 =
			       MAKE_PAIR(port_344, arg1252_397);
			 }
			 arg1250_395 =
			    compiler_read_18_read_reader(list1251_396);
		      }
		      {
			 obj_t exp_789;
			 obj_t inlines_788;
			 inlines_788 = arg1249_394;
			 exp_789 = arg1250_395;
			 exp_342 = exp_789;
			 inlines_341 = inlines_788;
			 goto loop_read_inline;
		      }
		   }
		}
	   }
      }
   }
}



/* handling_function1235 */
obj_t 
handling_function1235_read_inline(obj_t inlines_699, obj_t fnames_698, obj_t port_697, obj_t module_696)
{
   AN_OBJECT;
   {	/* Read/inline.scm 55 */
      jmp_buf jmpbuf;
      obj_t an_exit1190_382;
      if (SET_EXIT(an_exit1190_382))
	{
	   RESTORE_TRACE();
	   return
	      _exit_value_;
	}
      else
	{
	   an_exit1190_382 =
	      (obj_t) jmpbuf;
	   {	/* Read/inline.scm 55 */

	      PUSH_EXIT(an_exit1190_382, ((bool_t) 0));
	      {		/* Read/inline.scm 52 */
		 obj_t val1191_383;
		 {	/* Read/inline.scm 52 */
		    obj_t arg1236_384;
		    obj_t arg1237_385;
		    {	/* Read/inline.scm 52 */
		       obj_t list1238_386;
		       {	/* Read/inline.scm 52 */
			  obj_t arg1240_387;
			  arg1240_387 =
			     MAKE_PAIR(BTRUE, BNIL);
			  list1238_386 =
			     MAKE_PAIR(port_697, arg1240_387);
		       }
		       arg1236_384 =
			  compiler_read_18_read_reader(list1238_386);
		    }
		    arg1237_385 =
		       CDR(fnames_698);
		    val1191_383 =
		       loop_read_inline(module_696, inlines_699, arg1236_384, arg1237_385, port_697);
		 }
		 POP_EXIT();
		 return val1191_383;
	      }
	   }
	}
   }
}



/* _look-for-inline */
obj_t 
_look_for_inline_143_read_inline(obj_t env_688, obj_t inlines_689, obj_t code_690, obj_t port_691, obj_t fnames_692, obj_t module_693)
{
   AN_OBJECT;
   {	/* Read/inline.scm 34 */
      return
	 look_for_inline_98_read_inline(inlines_689, code_690, port_691, fnames_692, module_693);
   }
}



/* look-for-inline/exp */
obj_t 
look_for_inline_exp_95_read_inline(obj_t inlines_24, obj_t exp_25, obj_t module_26)
{
   AN_OBJECT;
   {	/* Read/inline.scm 66 */
      if (
	 NULLP(inlines_24))
	{	/* Read/inline.scm 67 */
	   return BNIL;
	}
      else
	{
	   obj_t exp__153_403;
	   obj_t proto_399;
	   obj_t name_400;
	   obj_t body_401;
	   if (
	      PAIRP(exp_25))
	     {	/* Read/inline.scm 69 */
		obj_t cdr_132_143_408;
		cdr_132_143_408 =
		   CDR(exp_25);
		{	/* Read/inline.scm 69 */
		   bool_t test_805;
		   {	/* ./Ieee/equiv.scm 5508 */
		      obj_t aux_808;
		      obj_t aux_806;
		      aux_808 =
			 CNST_TABLE_REF(((long) 3));
		      aux_806 =
			 CAR(exp_25);
		      test_805 =
			 (aux_806 == aux_808);
		   }
		   if (test_805)
		     {	/* Read/inline.scm 69 */
			if (
			   PAIRP(cdr_132_143_408))
			  {	/* Read/inline.scm 69 */
			     obj_t car_136_42_411;
			     car_136_42_411 =
				CAR(cdr_132_143_408);
			     if (
				PAIRP(car_136_42_411))
			       {	/* Read/inline.scm 69 */
				  proto_399 = car_136_42_411;
				  name_400 =
				     CAR(car_136_42_411);
				  body_401 =
				     CDR(cdr_132_143_408);
				  {	/* Read/inline.scm 71 */
				     obj_t id_421;
				     {	/* Read/inline.scm 71 */
					obj_t arg1277_431;
					arg1277_431 =
					   find_location_120_tools_location(exp_25);
					id_421 =
					   id_of_id_112_ast_ident(name_400, arg1277_431);
				     }
				     {	/* Read/inline.scm 71 */
					obj_t cell_422;
					cell_422 =
					   assq___r4_pairs_and_lists_6_3(id_421, inlines_24);
					{	/* Read/inline.scm 72 */

					   {	/* Read/inline.scm 73 */
					      bool_t test_819;
					      if (
						 PAIRP(cell_422))
						{	/* ./Ieee/equiv.scm 5508 */
						   obj_t aux_824;
						   obj_t aux_822;
						   aux_824 =
						      CNST_TABLE_REF(((long) 1));
						   aux_822 =
						      CDR(cell_422);
						   test_819 =
						      (aux_822 == aux_824);
						}
					      else
						{	/* Read/inline.scm 73 */
						   test_819 = ((bool_t) 0)
						      ;
						}
					      if (test_819)
						{	/* Read/inline.scm 73 */
						   {	/* Read/inline.scm 75 */
						      obj_t arg1269_424;
						      {		/* Read/inline.scm 75 */
							 obj_t arg1270_425;
							 obj_t arg1271_426;
							 arg1270_425 =
							    CNST_TABLE_REF(((long) 2));
							 {	/* Read/inline.scm 75 */
							    obj_t arg1272_427;
							    arg1272_427 =
							       MAKE_PAIR(module_26, BNIL);
							    arg1271_426 =
							       MAKE_PAIR(id_421, arg1272_427);
							 }
							 arg1269_424 =
							    MAKE_PAIR(arg1270_425, arg1271_426);
						      }
						      SET_CAR(proto_399, arg1269_424);
						   }
						   {	/* Read/inline.scm 77 */
						      obj_t obj2_657;
						      obj2_657 = _inline_definitions__29_read_inline;
						      _inline_definitions__29_read_inline =
							 MAKE_PAIR(exp_25, obj2_657);
						   }
						   return
						      remq__51___r4_pairs_and_lists_6_3(cell_422, inlines_24);
						}
					      else
						{	/* Read/inline.scm 73 */
						   return inlines_24;
						}
					   }
					}
				     }
				  }
			       }
			     else
			       {	/* Read/inline.scm 69 */
				  return inlines_24;
			       }
			  }
			else
			  {	/* Read/inline.scm 69 */
			     return inlines_24;
			  }
		     }
		   else
		     {	/* Read/inline.scm 69 */
			bool_t test_836;
			{	/* ./Ieee/equiv.scm 5508 */
			   obj_t aux_839;
			   obj_t aux_837;
			   aux_839 =
			      CNST_TABLE_REF(((long) 4));
			   aux_837 =
			      CAR(exp_25);
			   test_836 =
			      (aux_837 == aux_839);
			}
			if (test_836)
			  {	/* Read/inline.scm 69 */
			     exp__153_403 = cdr_132_143_408;
			     {
				obj_t inlines_432;
				obj_t exp__153_433;
				inlines_432 = inlines_24;
				exp__153_433 = exp__153_403;
			      loop_434:
				if (
				   NULLP(exp__153_433))
				  {	/* Read/inline.scm 83 */
				     return inlines_432;
				  }
				else
				  {	/* Read/inline.scm 85 */
				     obj_t arg1280_436;
				     obj_t arg1281_437;
				     arg1280_436 =
					look_for_inline_exp_95_read_inline(inlines_432,
					CAR(exp__153_433), module_26);
				     arg1281_437 =
					CDR(exp__153_433);
				     {
					obj_t exp__153_848;
					obj_t inlines_847;
					inlines_847 = arg1280_436;
					exp__153_848 = arg1281_437;
					exp__153_433 = exp__153_848;
					inlines_432 = inlines_847;
					goto loop_434;
				     }
				  }
			     }
			  }
			else
			  {	/* Read/inline.scm 69 */
			     return inlines_24;
			  }
		     }
		}
	     }
	   else
	     {	/* Read/inline.scm 69 */
		return inlines_24;
	     }
	}
   }
}



/* inline-finalizer */
obj_t 
inline_finalizer_105_read_inline()
{
   AN_OBJECT;
   {	/* Read/inline.scm 98 */
      {		/* Read/inline.scm 99 */
	 bool_t test1283_439;
	 {	/* Read/inline.scm 99 */
	    obj_t obj_661;
	    obj_661 = _inline_definitions__29_read_inline;
	    test1283_439 =
	       NULLP(obj_661);
	 }
	 if (test1283_439)
	   {	/* Read/inline.scm 99 */
	      return BNIL;
	   }
	 else
	   {	/* Read/inline.scm 101 */
	      obj_t arg1286_440;
	      {		/* Read/inline.scm 101 */
		 obj_t id_662;
		 obj_t sexp__30_664;
		 id_662 =
		    CNST_TABLE_REF(((long) 5));
		 sexp__30_664 = _inline_definitions__29_read_inline;
		 {	/* ./Ast/unit.sch 391 */
		    obj_t new_666;
		    {	/* ./Ast/unit.sch 391 */
		       obj_t aux_852;
		       aux_852 =
			  CNST_TABLE_REF(((long) 6));
		       new_666 =
			  create_struct(aux_852, ((long) 4));
		    }
		    STRUCT_SET(new_666, ((long) 3), BTRUE);
		    STRUCT_SET(new_666, ((long) 2), sexp__30_664);
		    {	/* ./Llib/struct.scm 1463 */
		       obj_t aux_857;
		       aux_857 =
			  BINT(((long) 0));
		       STRUCT_SET(new_666, ((long) 1), aux_857);
		    }
		    STRUCT_SET(new_666, ((long) 0), id_662);
		    arg1286_440 = new_666;
		 }
	      }
	      {		/* Read/inline.scm 101 */
		 obj_t list1287_441;
		 list1287_441 =
		    MAKE_PAIR(arg1286_440, BNIL);
		 return list1287_441;
	      }
	   }
      }
   }
}



/* _inline-finalizer */
obj_t 
_inline_finalizer_140_read_inline(obj_t env_694)
{
   AN_OBJECT;
   {	/* Read/inline.scm 98 */
      return
	 inline_finalizer_105_read_inline();
   }
}



/* method-init */
obj_t 
method_init_76_read_inline()
{
   AN_OBJECT;
   {	/* Read/inline.scm 14 */
      return BUNSPEC;
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_read_inline()
{
   AN_OBJECT;
   {	/* Read/inline.scm 14 */
      module_initialization_70_tools_trace(((long) 0), "READ_INLINE");
      module_initialization_70_read_reader(((long) 0), "READ_INLINE");
      module_initialization_70_tools_error(((long) 0), "READ_INLINE");
      module_initialization_70_tools_speek(((long) 0), "READ_INLINE");
      module_initialization_70_tools_shape(((long) 0), "READ_INLINE");
      module_initialization_70_ast_ident(((long) 0), "READ_INLINE");
      module_initialization_70_ast_env(((long) 0), "READ_INLINE");
      module_initialization_70_type_type(((long) 0), "READ_INLINE");
      module_initialization_70_ast_var(((long) 0), "READ_INLINE");
      return
	 module_initialization_70_tools_location(((long) 0), "READ_INLINE");
   }
}
