/*===========================================================================*/
/*   (Reduce/1occ.scm)                                                       */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;


static obj_t method_init_76_reduce_1occ();
extern obj_t make_box_202_ast_node;
extern obj_t funcall_ast_node;
extern long add_inlined_method__244___object(obj_t, obj_t, long);
extern obj_t fail_ast_node;
static obj_t _node_1occ__default1513_136_reduce_1occ(obj_t, obj_t, obj_t);
static obj_t node_1occ___233_reduce_1occ(obj_t, obj_t);
extern obj_t box_ref_242_ast_node;
extern obj_t _res1__155___r5_control_features_6_4;
extern obj_t sequence_ast_node;
extern obj_t let_var_6_ast_node;
extern obj_t var_ast_node;
extern obj_t closure_ast_node;
extern obj_t pragma_ast_node;
extern obj_t set_ex_it_116_ast_node;
extern obj_t verbose_tools_speek(obj_t, obj_t);
extern obj_t module_initialization_70_reduce_1occ(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_speek(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_coerce_typeof(long, char *);
extern obj_t module_initialization_70_coerce_coerce(long, char *);
extern obj_t module_initialization_70_effect_effect(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_ast_lvtype(long, char *);
extern obj_t module_initialization_70_ast_occur(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r5_control_features_6_4(long, char *);
extern obj_t reduce_1occ__237_reduce_1occ(obj_t);
extern obj_t let_fun_218_ast_node;
static long _variable_removed__90_reduce_1occ;
static obj_t imported_modules_init_94_reduce_1occ();
extern obj_t app_ly_162_ast_node;
extern obj_t add_generic__110___object(obj_t, obj_t);
extern obj_t app_ast_node;
extern obj_t append_2_18___r4_pairs_and_lists_6_3(obj_t, obj_t);
static obj_t library_modules_init_112_reduce_1occ();
extern obj_t occur_var_108_ast_occur(obj_t);
extern obj_t atom_ast_node;
static obj_t node_1occ__default1513_193_reduce_1occ(node_bglt, obj_t);
extern obj_t cast_ast_node;
extern obj_t assq___r4_pairs_and_lists_6_3(obj_t, obj_t);
static obj_t toplevel_init_63_reduce_1occ();
static obj_t _reduce_1occ__206_reduce_1occ(obj_t, obj_t);
extern obj_t jump_ex_it_184_ast_node;
extern obj_t open_input_string(obj_t);
extern obj_t kwote_ast_node;
extern bool_t side_effect__165_effect_effect(node_bglt);
extern obj_t setq_ast_node;
extern obj_t box_set__221_ast_node;
extern obj_t _res_number__75___r5_control_features_6_4;
extern obj_t _classes__134___object;
extern obj_t select_ast_node;
extern obj_t read___reader(obj_t);
static obj_t node_1occ__69_reduce_1occ(node_bglt, obj_t);
static obj_t _node_1occ_1758_177_reduce_1occ(obj_t, obj_t, obj_t);
static obj_t require_initialization_114_reduce_1occ = BUNSPEC;
extern obj_t conditional_ast_node;
static obj_t cnst_init_137_reduce_1occ();
extern obj_t reverse__39___r4_pairs_and_lists_6_3(obj_t);
static obj_t __cnst[2];

DEFINE_STATIC_PROCEDURE(node_1occ__default1513_env_149_reduce_1occ, _node_1occ__default1513_136_reduce_1occ1767, _node_1occ__default1513_136_reduce_1occ, 0L, 2);
DEFINE_EXPORT_PROCEDURE(reduce_1occ__env_30_reduce_1occ, _reduce_1occ__206_reduce_1occ1768, _reduce_1occ__206_reduce_1occ, 0L, 1);
DEFINE_STATIC_GENERIC(node_1occ__env_84_reduce_1occ, _node_1occ_1758_177_reduce_1occ1769, _node_1occ_1758_177_reduce_1occ, 0L, 2);
DEFINE_STRING(string1762_reduce_1occ, string1762_reduce_1occ1770, "NODE-1OCC!-DEFAULT1513 READ ", 28);
DEFINE_STRING(string1761_reduce_1occ, string1761_reduce_1occ1771, "No method for this object", 25);
DEFINE_STRING(string1759_reduce_1occ, string1759_reduce_1occ1772, "      single occurrence      ", 29);
DEFINE_STRING(string1760_reduce_1occ, string1760_reduce_1occ1773, "(removed : ", 11);



/* module-initialization */
obj_t 
module_initialization_70_reduce_1occ(long checksum_1596, char *from_1597)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_reduce_1occ))
	{
	   require_initialization_114_reduce_1occ =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_reduce_1occ();
	   cnst_init_137_reduce_1occ();
	   imported_modules_init_94_reduce_1occ();
	   method_init_76_reduce_1occ();
	   toplevel_init_63_reduce_1occ();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_reduce_1occ()
{
   AN_OBJECT;
   {	/* Reduce/1occ.scm 15 */
      module_initialization_70___object(((long) 0), "REDUCE_1OCC");
      module_initialization_70___r5_control_features_6_4(((long) 0), "REDUCE_1OCC");
      module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "REDUCE_1OCC");
      module_initialization_70___reader(((long) 0), "REDUCE_1OCC");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_reduce_1occ()
{
   AN_OBJECT;
   {	/* Reduce/1occ.scm 15 */
      {		/* Reduce/1occ.scm 15 */
	 obj_t cnst_port_138_1589;
	 cnst_port_138_1589 =
	    open_input_string(string1762_reduce_1occ);
	 {
	    long i_1590;
	    i_1590 = ((long) 1);
	  loop_1591:
	    {	/* Reduce/1occ.scm 15 */
	       bool_t test1763_1592;
	       test1763_1592 =
		  (i_1590 == ((long) -1));
	       if (test1763_1592)
		 {	/* Reduce/1occ.scm 15 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Reduce/1occ.scm 15 */
		    {	/* Reduce/1occ.scm 15 */
		       obj_t arg1764_1593;
		       {	/* Reduce/1occ.scm 15 */
			  obj_t list1765_1594;
			  list1765_1594 =
			     MAKE_PAIR(cnst_port_138_1589, BNIL);
			  arg1764_1593 =
			     read___reader(list1765_1594);
		       }
		       CNST_TABLE_SET(i_1590, arg1764_1593);
		    }
		    {	/* Reduce/1occ.scm 15 */
		       int aux_1595;
		       {	/* Reduce/1occ.scm 15 */
			  long aux_1616;
			  aux_1616 =
			     (i_1590 - ((long) 1));
			  aux_1595 =
			     (int) (aux_1616);
		       }
		       {
			  long i_1619;
			  i_1619 =
			     (long) (aux_1595);
			  i_1590 = i_1619;
			  goto loop_1591;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_reduce_1occ()
{
   AN_OBJECT;
   {	/* Reduce/1occ.scm 15 */
      _variable_removed__90_reduce_1occ = ((long) 0);
      return BUNSPEC;
   }
}



/* reduce-1occ! */
obj_t 
reduce_1occ__237_reduce_1occ(obj_t globals_1)
{
   AN_OBJECT;
   {	/* Reduce/1occ.scm 34 */
      {		/* Reduce/1occ.scm 35 */
	 obj_t list1560_745;
	 list1560_745 =
	    MAKE_PAIR(string1759_reduce_1occ, BNIL);
	 verbose_tools_speek(
	    BINT(((long) 2)), list1560_745);
      }
      occur_var_108_ast_occur(globals_1);
      _variable_removed__90_reduce_1occ = ((long) 0);
      {
	 obj_t l1437_746;
	 l1437_746 = globals_1;
       lname1438_747:
	 if (
	    PAIRP(l1437_746))
	   {	/* Reduce/1occ.scm 41 */
	      {		/* Reduce/1occ.scm 42 */
		 value_bglt fun_750;
		 {	/* Reduce/1occ.scm 42 */
		    global_bglt obj_1402;
		    {	/* Reduce/1occ.scm 42 */
		       obj_t aux_1627;
		       aux_1627 =
			  CAR(l1437_746);
		       obj_1402 =
			  (global_bglt) (aux_1627);
		    }
		    fun_750 =
		       (((global_bglt) CREF(obj_1402))->value);
		 }
		 {	/* Reduce/1occ.scm 43 */

		    {	/* Reduce/1occ.scm 44 */
		       obj_t arg1562_752;
		       {	/* Reduce/1occ.scm 44 */
			  obj_t __753;
			  {	/* Reduce/1occ.scm 45 */
			     node_bglt aux_1631;
			     {	/* Reduce/1occ.scm 45 */
				obj_t aux_1632;
				{	/* Reduce/1occ.scm 43 */
				   sfun_bglt obj_1403;
				   obj_1403 =
				      (sfun_bglt) (fun_750);
				   aux_1632 =
				      (((sfun_bglt) CREF(obj_1403))->body);
				}
				aux_1631 =
				   (node_bglt) (aux_1632);
			     }
			     __753 =
				node_1occ__69_reduce_1occ(aux_1631, BNIL);
			  }
			  {	/* Reduce/1occ.scm 44 */
			     obj_t node_754;
			     node_754 = _res1__155___r5_control_features_6_4;
			     arg1562_752 = node_754;
			  }
		       }
		       {	/* Reduce/1occ.scm 44 */
			  sfun_bglt obj_1404;
			  obj_1404 =
			     (sfun_bglt) (fun_750);
			  ((((sfun_bglt) CREF(obj_1404))->body) = ((obj_t) arg1562_752), BUNSPEC);
		       }
		    }
		    BUNSPEC;
		 }
	      }
	      {
		 obj_t l1437_1639;
		 l1437_1639 =
		    CDR(l1437_746);
		 l1437_746 = l1437_1639;
		 goto lname1438_747;
	      }
	   }
	 else
	   {	/* Reduce/1occ.scm 41 */
	      ((bool_t) 1);
	   }
      }
      {		/* Reduce/1occ.scm 49 */
	 obj_t list1564_756;
	 {	/* Reduce/1occ.scm 49 */
	    obj_t arg1566_758;
	    {	/* Reduce/1occ.scm 49 */
	       obj_t arg1567_759;
	       {	/* Reduce/1occ.scm 49 */
		  obj_t arg1568_760;
		  {	/* Reduce/1occ.scm 49 */
		     obj_t aux_1641;
		     aux_1641 =
			BCHAR(((unsigned char) '\n'));
		     arg1568_760 =
			MAKE_PAIR(aux_1641, BNIL);
		  }
		  {	/* Reduce/1occ.scm 49 */
		     obj_t aux_1644;
		     aux_1644 =
			BCHAR(((unsigned char) ')'));
		     arg1567_759 =
			MAKE_PAIR(aux_1644, arg1568_760);
		  }
	       }
	       {	/* Reduce/1occ.scm 49 */
		  obj_t aux_1647;
		  aux_1647 =
		     BINT(_variable_removed__90_reduce_1occ);
		  arg1566_758 =
		     MAKE_PAIR(aux_1647, arg1567_759);
	       }
	    }
	    list1564_756 =
	       MAKE_PAIR(string1760_reduce_1occ, arg1566_758);
	 }
	 verbose_tools_speek(
	    BINT(((long) 2)), list1564_756);
      }
      return globals_1;
   }
}



/* _reduce-1occ! */
obj_t 
_reduce_1occ__206_reduce_1occ(obj_t env_1581, obj_t globals_1582)
{
   AN_OBJECT;
   {	/* Reduce/1occ.scm 34 */
      return
	 reduce_1occ__237_reduce_1occ(globals_1582);
   }
}



/* node-1occ*! */
obj_t 
node_1occ___233_reduce_1occ(obj_t node__221_48, obj_t _1_exp__141_49)
{
   AN_OBJECT;
   {	/* Reduce/1occ.scm 382 */
      {
	 obj_t node__221_761;
	 bool_t reset_762;
	 obj_t _1_exp__141_763;
	 node__221_761 = node__221_48;
	 reset_762 = ((bool_t) 0);
	 _1_exp__141_763 = _1_exp__141_49;
       loop_764:
	 if (
	    NULLP(node__221_761))
	   {	/* Reduce/1occ.scm 387 */
	      return
		 BBOOL(reset_762);
	   }
	 else
	   {	/* Reduce/1occ.scm 389 */
	      bool_t test_1657;
	      {		/* ./Ieee/pair-list.scm 5912 */
		 obj_t aux_1658;
		 aux_1658 =
		    CDR(node__221_761);
		 test_1657 =
		    NULLP(aux_1658);
	      }
	      if (test_1657)
		{	/* Reduce/1occ.scm 389 */
		   {	/* Reduce/1occ.scm 390 */
		      obj_t reset__69_767;
		      {		/* Reduce/1occ.scm 391 */
			 node_bglt aux_1661;
			 {	/* Reduce/1occ.scm 391 */
			    obj_t aux_1662;
			    aux_1662 =
			       CAR(node__221_761);
			    aux_1661 =
			       (node_bglt) (aux_1662);
			 }
			 reset__69_767 =
			    node_1occ__69_reduce_1occ(aux_1661, _1_exp__141_763);
		      }
		      {		/* Reduce/1occ.scm 390 */
			 obj_t node_768;
			 node_768 = _res1__155___r5_control_features_6_4;
			 SET_CAR(node__221_761, node_768);
			 if (reset_762)
			   {	/* Reduce/1occ.scm 393 */
			      return
				 BBOOL(reset_762);
			   }
			 else
			   {	/* Reduce/1occ.scm 393 */
			      return reset__69_767;
			   }
		      }
		   }
		}
	      else
		{	/* Reduce/1occ.scm 389 */
		   {	/* Reduce/1occ.scm 395 */
		      obj_t reset__69_771;
		      {		/* Reduce/1occ.scm 396 */
			 node_bglt aux_1669;
			 {	/* Reduce/1occ.scm 396 */
			    obj_t aux_1670;
			    aux_1670 =
			       CAR(node__221_761);
			    aux_1669 =
			       (node_bglt) (aux_1670);
			 }
			 reset__69_771 =
			    node_1occ__69_reduce_1occ(aux_1669, _1_exp__141_763);
		      }
		      {		/* Reduce/1occ.scm 395 */
			 obj_t node_772;
			 node_772 = _res1__155___r5_control_features_6_4;
			 SET_CAR(node__221_761, node_772);
			 {	/* Reduce/1occ.scm 398 */
			    bool_t test_1675;
			    if (reset_762)
			      {		/* Reduce/1occ.scm 398 */
				 test_1675 = ((bool_t) 1)
				    ;
			      }
			    else
			      {		/* Reduce/1occ.scm 398 */
				 test_1675 =
				    CBOOL(reset__69_771)
				    ;
			      }
			    if (test_1675)
			      {
				 obj_t _1_exp__141_1681;
				 bool_t reset_1680;
				 obj_t node__221_1678;
				 node__221_1678 =
				    CDR(node__221_761);
				 reset_1680 = ((bool_t) 1);
				 _1_exp__141_1681 = BNIL;
				 _1_exp__141_763 = _1_exp__141_1681;
				 reset_762 = reset_1680;
				 node__221_761 = node__221_1678;
				 goto loop_764;
			      }
			    else
			      {
				 bool_t reset_1684;
				 obj_t node__221_1682;
				 node__221_1682 =
				    CDR(node__221_761);
				 reset_1684 = ((bool_t) 0);
				 reset_762 = reset_1684;
				 node__221_761 = node__221_1682;
				 goto loop_764;
			      }
			 }
		      }
		   }
		}
	   }
      }
   }
}



/* method-init */
obj_t 
method_init_76_reduce_1occ()
{
   AN_OBJECT;
   {	/* Reduce/1occ.scm 15 */
      add_generic__110___object(node_1occ__env_84_reduce_1occ, node_1occ__default1513_env_149_reduce_1occ);
      add_inlined_method__244___object(node_1occ__env_84_reduce_1occ, atom_ast_node, ((long) 0));
      add_inlined_method__244___object(node_1occ__env_84_reduce_1occ, kwote_ast_node, ((long) 1));
      add_inlined_method__244___object(node_1occ__env_84_reduce_1occ, var_ast_node, ((long) 2));
      add_inlined_method__244___object(node_1occ__env_84_reduce_1occ, closure_ast_node, ((long) 3));
      add_inlined_method__244___object(node_1occ__env_84_reduce_1occ, sequence_ast_node, ((long) 4));
      add_inlined_method__244___object(node_1occ__env_84_reduce_1occ, app_ly_162_ast_node, ((long) 5));
      add_inlined_method__244___object(node_1occ__env_84_reduce_1occ, funcall_ast_node, ((long) 6));
      add_inlined_method__244___object(node_1occ__env_84_reduce_1occ, pragma_ast_node, ((long) 7));
      add_inlined_method__244___object(node_1occ__env_84_reduce_1occ, cast_ast_node, ((long) 8));
      add_inlined_method__244___object(node_1occ__env_84_reduce_1occ, setq_ast_node, ((long) 9));
      add_inlined_method__244___object(node_1occ__env_84_reduce_1occ, conditional_ast_node, ((long) 10));
      add_inlined_method__244___object(node_1occ__env_84_reduce_1occ, fail_ast_node, ((long) 11));
      add_inlined_method__244___object(node_1occ__env_84_reduce_1occ, select_ast_node, ((long) 12));
      add_inlined_method__244___object(node_1occ__env_84_reduce_1occ, let_fun_218_ast_node, ((long) 13));
      add_inlined_method__244___object(node_1occ__env_84_reduce_1occ, let_var_6_ast_node, ((long) 14));
      add_inlined_method__244___object(node_1occ__env_84_reduce_1occ, set_ex_it_116_ast_node, ((long) 15));
      add_inlined_method__244___object(node_1occ__env_84_reduce_1occ, jump_ex_it_184_ast_node, ((long) 16));
      add_inlined_method__244___object(node_1occ__env_84_reduce_1occ, make_box_202_ast_node, ((long) 17));
      add_inlined_method__244___object(node_1occ__env_84_reduce_1occ, box_set__221_ast_node, ((long) 18));
      add_inlined_method__244___object(node_1occ__env_84_reduce_1occ, box_ref_242_ast_node, ((long) 19));
      {		/* Reduce/1occ.scm 15 */
	 long aux_1706;
	 aux_1706 =
	    add_inlined_method__244___object(node_1occ__env_84_reduce_1occ, app_ast_node, ((long) 20));
	 return
	    BINT(aux_1706);
      }
   }
}



/* node-1occ! */
obj_t 
node_1occ__69_reduce_1occ(node_bglt node_2, obj_t _1_exp__141_3)
{
   AN_OBJECT;
   {	/* Reduce/1occ.scm 65 */
    node_1occ__69_reduce_1occ:
      {
	 obj_t method1652_1109;
	 obj_t class1657_1110;
	 {	/* Reduce/1occ.scm 65 */
	    obj_t arg1660_1107;
	    obj_t arg1661_1108;
	    {	/* Reduce/1occ.scm 65 */
	       object_bglt obj_1418;
	       obj_1418 =
		  (object_bglt) (node_2);
	       {	/* ./Llib/object.scm 2926 */
		  obj_t pre_method_105_1419;
		  pre_method_105_1419 =
		     PROCEDURE_REF(node_1occ__env_84_reduce_1occ, ((long) 2));
		  if (
		     INTEGERP(pre_method_105_1419))
		    {	/* ./Llib/object.scm 2927 */
		       PROCEDURE_SET(node_1occ__env_84_reduce_1occ, ((long) 2), BUNSPEC);
		       arg1660_1107 = pre_method_105_1419;
		    }
		  else
		    {	/* ./Llib/object.scm 2914 */
		       long obj_class_num_177_1424;
		       obj_class_num_177_1424 =
			  TYPE(obj_1418);
		       {	/* ./Llib/object.scm 2915 */
			  obj_t arg1176_1425;
			  arg1176_1425 =
			     PROCEDURE_REF(node_1occ__env_84_reduce_1occ, ((long) 1));
			  {	/* ./Llib/object.scm 2738 */
			     long arg1177_1429;
			     {	/* ./Llib/object.scm 2738 */
				long arg1178_1430;
				arg1178_1430 =
				   OBJECT_TYPE;
				arg1177_1429 =
				   (obj_class_num_177_1424 - arg1178_1430);
			     }
			     arg1660_1107 =
				VECTOR_REF(arg1176_1425, arg1177_1429);
			  }
		       }
		    }
	       }
	    }
	    {	/* Reduce/1occ.scm 65 */
	       object_bglt object_1435;
	       object_1435 =
		  (object_bglt) (node_2);
	       {	/* ./Llib/object.scm 2695 */
		  long arg1179_1436;
		  {	/* ./Llib/object.scm 2695 */
		     long arg1180_1437;
		     long arg1181_1438;
		     arg1180_1437 =
			TYPE(object_1435);
		     arg1181_1438 =
			OBJECT_TYPE;
		     arg1179_1436 =
			(arg1180_1437 - arg1181_1438);
		  }
		  {	/* ./Llib/object.scm 2695 */
		     obj_t vector_1442;
		     vector_1442 = _classes__134___object;
		     arg1661_1108 =
			VECTOR_REF(vector_1442, arg1179_1436);
		  }
	       }
	    }
	    method1652_1109 = arg1660_1107;
	    class1657_1110 = arg1661_1108;
	    {

	       if (
		  INTEGERP(method1652_1109))
		 {	/* Reduce/1occ.scm 65 */
		    switch (
		       (long) CINT(method1652_1109))
		      {
		      case ((long) 0):

			 _res_number__75___r5_control_features_6_4 =
			    BINT(((long) 2));
			 {	/* Reduce/1occ.scm 71 */
			    atom_bglt aux_1727;
			    aux_1727 =
			       (atom_bglt) (node_2);
			    _res1__155___r5_control_features_6_4 =
			       (obj_t) (aux_1727);
			 }
			 return BFALSE;
			 break;
		      case ((long) 1):

			 _res_number__75___r5_control_features_6_4 =
			    BINT(((long) 2));
			 {	/* Reduce/1occ.scm 77 */
			    kwote_bglt aux_1731;
			    aux_1731 =
			       (kwote_bglt) (node_2);
			    _res1__155___r5_control_features_6_4 =
			       (obj_t) (aux_1731);
			 }
			 return BFALSE;
			 break;
		      case ((long) 2):

			 {	/* Reduce/1occ.scm 83 */
			    var_bglt node_1124;
			    node_1124 =
			       (var_bglt) (node_2);
			    {	/* Reduce/1occ.scm 83 */
			       variable_bglt v_1126;
			       v_1126 =
				  (((var_bglt) CREF(node_1124))->variable);
			       {	/* Reduce/1occ.scm 84 */
				  obj_t falpha_1127;
				  falpha_1127 =
				     assq___r4_pairs_and_lists_6_3(
				     (obj_t) (v_1126), _1_exp__141_3);
				  if (
				     PAIRP(falpha_1127))
				    {	/* Reduce/1occ.scm 85 */
				       {	/* Reduce/1occ.scm 87 */
					  long arg1665_1129;
					  {	/* ./Ieee/fixnum.scm 7199 */
					     long aux_1740;
					     aux_1740 =
						(((variable_bglt) CREF(v_1126))->occurrence);
					     arg1665_1129 =
						(aux_1740 - ((long) 1));
					  }
					  ((((variable_bglt) CREF(v_1126))->occurrence) = ((long) arg1665_1129), BUNSPEC);
				       }
				       {	/* Reduce/1occ.scm 88 */
					  long z1_1451;
					  z1_1451 = _variable_removed__90_reduce_1occ;
					  _variable_removed__90_reduce_1occ =
					     (z1_1451 + ((long) 1));
				       }
				       {
					  node_bglt node_1745;
					  {	/* Reduce/1occ.scm 89 */
					     obj_t aux_1746;
					     aux_1746 =
						CDR(falpha_1127);
					     node_1745 =
						(node_bglt) (aux_1746);
					  }
					  node_2 = node_1745;
					  goto node_1occ__69_reduce_1occ;
				       }
				    }
				  else
				    {	/* Reduce/1occ.scm 85 */
				       _res_number__75___r5_control_features_6_4 =
					  BINT(((long) 2));
				       _res1__155___r5_control_features_6_4 =
					  (obj_t) (node_1124);
				       return BFALSE;
				    }
			       }
			    }
			 }
			 break;
		      case ((long) 3):

			 _res_number__75___r5_control_features_6_4 =
			    BINT(((long) 2));
			 {	/* Reduce/1occ.scm 96 */
			    closure_bglt aux_1752;
			    aux_1752 =
			       (closure_bglt) (node_2);
			    _res1__155___r5_control_features_6_4 =
			       (obj_t) (aux_1752);
			 }
			 return BFALSE;
			 break;
		      case ((long) 4):

			 {	/* Reduce/1occ.scm 102 */
			    sequence_bglt node_1139;
			    node_1139 =
			       (sequence_bglt) (node_2);
			    {	/* Reduce/1occ.scm 103 */
			       obj_t val0_1448_1142;
			       val0_1448_1142 =
				  node_1occ___233_reduce_1occ(
				  (((sequence_bglt) CREF(node_1139))->nodes), _1_exp__141_3);
			       _res_number__75___r5_control_features_6_4 =
				  BINT(((long) 2));
			       _res1__155___r5_control_features_6_4 =
				  (obj_t) (node_1139);
			       return val0_1448_1142;
			    }
			 }
			 break;
		      case ((long) 5):

			 {	/* Reduce/1occ.scm 109 */
			    app_ly_162_bglt node_1145;
			    node_1145 =
			       (app_ly_162_bglt) (node_2);
			    {	/* Reduce/1occ.scm 110 */
			       obj_t reset_1148;
			       reset_1148 =
				  node_1occ__69_reduce_1occ(
				  (((app_ly_162_bglt) CREF(node_1145))->fun), _1_exp__141_3);
			       {	/* Reduce/1occ.scm 110 */
				  obj_t nfun_1149;
				  nfun_1149 = _res1__155___r5_control_features_6_4;
				  {	/* Reduce/1occ.scm 112 */
				     node_bglt val1259_1457;
				     val1259_1457 =
					(node_bglt) (nfun_1149);
				     ((((app_ly_162_bglt) CREF(node_1145))->fun) = ((node_bglt) val1259_1457), BUNSPEC);
				  }
				  {	/* Reduce/1occ.scm 113 */
				     obj_t reset__69_1150;
				     {	/* Reduce/1occ.scm 114 */
					obj_t aux_1765;
					if (
					   CBOOL(reset_1148))
					  {	/* Reduce/1occ.scm 114 */
					     aux_1765 = BNIL
						;
					  }
					else
					  {	/* Reduce/1occ.scm 114 */
					     aux_1765 = _1_exp__141_3
						;
					  }
					reset__69_1150 =
					   node_1occ__69_reduce_1occ(
					   (((app_ly_162_bglt) CREF(node_1145))->arg), aux_1765);
				     }
				     {	/* Reduce/1occ.scm 113 */
					obj_t narg_1151;
					narg_1151 = _res1__155___r5_control_features_6_4;
					{	/* Reduce/1occ.scm 115 */
					   node_bglt val1260_1460;
					   val1260_1460 =
					      (node_bglt) (narg_1151);
					   ((((app_ly_162_bglt) CREF(node_1145))->arg) = ((node_bglt) val1260_1460), BUNSPEC);
					}
					_res_number__75___r5_control_features_6_4 =
					   BINT(((long) 2));
					_res1__155___r5_control_features_6_4 =
					   (obj_t) (node_1145);
					if (
					   CBOOL(reset_1148))
					  {	/* Reduce/1occ.scm 116 */
					     return reset_1148;
					  }
					else
					  {	/* Reduce/1occ.scm 116 */
					     return reset__69_1150;
					  }
				     }
				  }
			       }
			    }
			 }
			 break;
		      case ((long) 6):

			 {	/* Reduce/1occ.scm 122 */
			    funcall_bglt node_1158;
			    node_1158 =
			       (funcall_bglt) (node_2);
			    {	/* Reduce/1occ.scm 123 */
			       obj_t reset__69_1161;
			       reset__69_1161 =
				  node_1occ___233_reduce_1occ(
				  (((funcall_bglt) CREF(node_1158))->args), _1_exp__141_3);
			       _res_number__75___r5_control_features_6_4 =
				  BINT(((long) 2));
			       _res1__155___r5_control_features_6_4 =
				  (obj_t) (node_1158);
			       return reset__69_1161;
			    }
			 }
			 break;
		      case ((long) 7):

			 {	/* Reduce/1occ.scm 133 */
			    pragma_bglt node_1165;
			    node_1165 =
			       (pragma_bglt) (node_2);
			    {	/* Reduce/1occ.scm 134 */
			       bool_t val0_1458_1168;
			       val0_1458_1168 =
				  side_effect__165_effect_effect(
				  (node_bglt) (node_1165));
			       _res_number__75___r5_control_features_6_4 =
				  BINT(((long) 2));
			       _res1__155___r5_control_features_6_4 =
				  (obj_t) (node_1165);
			       return
				  BBOOL(val0_1458_1168);
			    }
			 }
			 break;
		      case ((long) 8):

			 {	/* Reduce/1occ.scm 140 */
			    cast_bglt node_1170;
			    node_1170 =
			       (cast_bglt) (node_2);
			    {	/* Reduce/1occ.scm 141 */
			       obj_t reset_1173;
			       reset_1173 =
				  node_1occ__69_reduce_1occ(
				  (((cast_bglt) CREF(node_1170))->arg), _1_exp__141_3);
			       {	/* Reduce/1occ.scm 141 */
				  obj_t narg_1174;
				  narg_1174 = _res1__155___r5_control_features_6_4;
				  {	/* Reduce/1occ.scm 143 */
				     node_bglt val1294_1464;
				     val1294_1464 =
					(node_bglt) (narg_1174);
				     ((((cast_bglt) CREF(node_1170))->arg) = ((node_bglt) val1294_1464), BUNSPEC);
				  }
				  _res_number__75___r5_control_features_6_4 =
				     BINT(((long) 2));
				  _res1__155___r5_control_features_6_4 =
				     (obj_t) (node_1170);
				  return reset_1173;
			       }
			    }
			 }
			 break;
		      case ((long) 9):

			 {	/* Reduce/1occ.scm 150 */
			    setq_bglt node_1178;
			    node_1178 =
			       (setq_bglt) (node_2);
			    {	/* Reduce/1occ.scm 151 */
			       obj_t reset_1181;
			       reset_1181 =
				  node_1occ__69_reduce_1occ(
				  (((setq_bglt) CREF(node_1178))->value), _1_exp__141_3);
			       {	/* Reduce/1occ.scm 151 */
				  obj_t nvalue_1182;
				  nvalue_1182 = _res1__155___r5_control_features_6_4;
				  {	/* Reduce/1occ.scm 153 */
				     node_bglt val1303_1467;
				     val1303_1467 =
					(node_bglt) (nvalue_1182);
				     ((((setq_bglt) CREF(node_1178))->value) = ((node_bglt) val1303_1467), BUNSPEC);
				  }
				  _res_number__75___r5_control_features_6_4 =
				     BINT(((long) 2));
				  _res1__155___r5_control_features_6_4 =
				     (obj_t) (node_1178);
				  return reset_1181;
			       }
			    }
			 }
			 break;
		      case ((long) 10):

			 {	/* Reduce/1occ.scm 160 */
			    conditional_bglt node_1186;
			    node_1186 =
			       (conditional_bglt) (node_2);
			    {	/* Reduce/1occ.scm 161 */
			       obj_t reset_1189;
			       reset_1189 =
				  node_1occ__69_reduce_1occ(
				  (((conditional_bglt) CREF(node_1186))->test), _1_exp__141_3);
			       {	/* Reduce/1occ.scm 161 */
				  obj_t ntest_1190;
				  ntest_1190 = _res1__155___r5_control_features_6_4;
				  {	/* Reduce/1occ.scm 163 */
				     node_bglt val1314_1470;
				     val1314_1470 =
					(node_bglt) (ntest_1190);
				     ((((conditional_bglt) CREF(node_1186))->test) = ((node_bglt) val1314_1470), BUNSPEC);
				  }
				  {	/* Reduce/1occ.scm 164 */
				     obj_t _1_exp___225_1191;
				     if (
					CBOOL(reset_1189))
				       {	/* Reduce/1occ.scm 164 */
					  _1_exp___225_1191 = BNIL;
				       }
				     else
				       {	/* Reduce/1occ.scm 164 */
					  _1_exp___225_1191 = _1_exp__141_3;
				       }
				     {	/* Reduce/1occ.scm 165 */
					obj_t reset__69_1192;
					reset__69_1192 =
					   node_1occ__69_reduce_1occ(
					   (((conditional_bglt) CREF(node_1186))->true), _1_exp___225_1191);
					{	/* Reduce/1occ.scm 165 */
					   obj_t ntrue_1193;
					   ntrue_1193 = _res1__155___r5_control_features_6_4;
					   {	/* Reduce/1occ.scm 167 */
					      node_bglt val1315_1473;
					      val1315_1473 =
						 (node_bglt) (ntrue_1193);
					      ((((conditional_bglt) CREF(node_1186))->true) = ((node_bglt) val1315_1473), BUNSPEC);
					   }
					   {	/* Reduce/1occ.scm 168 */
					      obj_t reset___255_1194;
					      reset___255_1194 =
						 node_1occ__69_reduce_1occ(
						 (((conditional_bglt) CREF(node_1186))->false), _1_exp___225_1191);
					      {		/* Reduce/1occ.scm 168 */
						 obj_t nfalse_1195;
						 nfalse_1195 = _res1__155___r5_control_features_6_4;
						 {	/* Reduce/1occ.scm 170 */
						    node_bglt val1316_1476;
						    val1316_1476 =
						       (node_bglt) (nfalse_1195);
						    ((((conditional_bglt) CREF(node_1186))->false) = ((node_bglt) val1316_1476), BUNSPEC);
						 }
						 _res_number__75___r5_control_features_6_4 =
						    BINT(((long) 2));
						 _res1__155___r5_control_features_6_4 =
						    (obj_t) (node_1186);
						 if (
						    CBOOL(reset_1189))
						   {	/* Reduce/1occ.scm 171 */
						      return reset_1189;
						   }
						 else
						   {	/* Reduce/1occ.scm 171 */
						      if (
							 CBOOL(reset__69_1192))
							{	/* Reduce/1occ.scm 171 */
							   return reset__69_1192;
							}
						      else
							{	/* Reduce/1occ.scm 171 */
							   return reset___255_1194;
							}
						   }
					      }
					   }
					}
				     }
				  }
			       }
			    }
			 }
			 break;
		      case ((long) 11):

			 {	/* Reduce/1occ.scm 177 */
			    fail_bglt node_1203;
			    node_1203 =
			       (fail_bglt) (node_2);
			    {	/* Reduce/1occ.scm 178 */
			       obj_t reset_1206;
			       reset_1206 =
				  node_1occ__69_reduce_1occ(
				  (((fail_bglt) CREF(node_1203))->proc), _1_exp__141_3);
			       {	/* Reduce/1occ.scm 178 */
				  obj_t nproc_1207;
				  nproc_1207 = _res1__155___r5_control_features_6_4;
				  {	/* Reduce/1occ.scm 180 */
				     node_bglt val1328_1479;
				     val1328_1479 =
					(node_bglt) (nproc_1207);
				     ((((fail_bglt) CREF(node_1203))->proc) = ((node_bglt) val1328_1479), BUNSPEC);
				  }
				  {	/* Reduce/1occ.scm 181 */
				     obj_t _1_exp___225_1208;
				     if (
					CBOOL(reset_1206))
				       {	/* Reduce/1occ.scm 181 */
					  _1_exp___225_1208 = BNIL;
				       }
				     else
				       {	/* Reduce/1occ.scm 181 */
					  _1_exp___225_1208 = _1_exp__141_3;
				       }
				     {	/* Reduce/1occ.scm 182 */
					obj_t reset__69_1209;
					reset__69_1209 =
					   node_1occ__69_reduce_1occ(
					   (((fail_bglt) CREF(node_1203))->msg), _1_exp___225_1208);
					{	/* Reduce/1occ.scm 182 */
					   obj_t nmsg_1210;
					   nmsg_1210 = _res1__155___r5_control_features_6_4;
					   {	/* Reduce/1occ.scm 184 */
					      node_bglt val1329_1482;
					      val1329_1482 =
						 (node_bglt) (nmsg_1210);
					      ((((fail_bglt) CREF(node_1203))->msg) = ((node_bglt) val1329_1482), BUNSPEC);
					   }
					   {	/* Reduce/1occ.scm 186 */
					      obj_t reset___255_1212;
					      {		/* Reduce/1occ.scm 187 */
						 obj_t aux_1833;
						 if (
						    CBOOL(reset__69_1209))
						   {	/* Reduce/1occ.scm 185 */
						      aux_1833 = BNIL
							 ;
						   }
						 else
						   {	/* Reduce/1occ.scm 185 */
						      aux_1833 = _1_exp___225_1208
							 ;
						   }
						 reset___255_1212 =
						    node_1occ__69_reduce_1occ(
						    (((fail_bglt) CREF(node_1203))->obj), aux_1833);
					      }
					      {		/* Reduce/1occ.scm 186 */
						 obj_t nobj_1213;
						 nobj_1213 = _res1__155___r5_control_features_6_4;
						 {	/* Reduce/1occ.scm 188 */
						    node_bglt val1330_1485;
						    val1330_1485 =
						       (node_bglt) (nobj_1213);
						    ((((fail_bglt) CREF(node_1203))->obj) = ((node_bglt) val1330_1485), BUNSPEC);
						 }
						 _res_number__75___r5_control_features_6_4 =
						    BINT(((long) 2));
						 _res1__155___r5_control_features_6_4 =
						    (obj_t) (node_1203);
						 if (
						    CBOOL(reset_1206))
						   {	/* Reduce/1occ.scm 189 */
						      return reset_1206;
						   }
						 else
						   {	/* Reduce/1occ.scm 189 */
						      if (
							 CBOOL(reset__69_1209))
							{	/* Reduce/1occ.scm 189 */
							   return reset__69_1209;
							}
						      else
							{	/* Reduce/1occ.scm 189 */
							   return reset___255_1212;
							}
						   }
					      }
					   }
					}
				     }
				  }
			       }
			    }
			 }
			 break;
		      case ((long) 12):

			 {	/* Reduce/1occ.scm 195 */
			    select_bglt node_1221;
			    node_1221 =
			       (select_bglt) (node_2);
			    {	/* Reduce/1occ.scm 196 */
			       obj_t reset_1224;
			       reset_1224 =
				  node_1occ__69_reduce_1occ(
				  (((select_bglt) CREF(node_1221))->test), _1_exp__141_3);
			       {	/* Reduce/1occ.scm 196 */
				  obj_t ntest_1225;
				  ntest_1225 = _res1__155___r5_control_features_6_4;
				  {	/* Reduce/1occ.scm 198 */
				     node_bglt val1342_1488;
				     val1342_1488 =
					(node_bglt) (ntest_1225);
				     ((((select_bglt) CREF(node_1221))->test) = ((node_bglt) val1342_1488), BUNSPEC);
				  }
				  {
				     obj_t clauses_1227;
				     obj_t reset_1228;
				     clauses_1227 =
					(((select_bglt) CREF(node_1221))->clauses);
				     reset_1228 = reset_1224;
				   loop_1229:
				     if (
					NULLP(clauses_1227))
				       {	/* Reduce/1occ.scm 202 */
					  _res_number__75___r5_control_features_6_4 =
					     BINT(((long) 2));
					  _res1__155___r5_control_features_6_4 =
					     (obj_t) (node_1221);
					  return reset_1228;
				       }
				     else
				       {	/* Reduce/1occ.scm 204 */
					  obj_t clause_1234;
					  clause_1234 =
					     CAR(clauses_1227);
					  {	/* Reduce/1occ.scm 205 */
					     obj_t reset__69_1235;
					     {	/* Reduce/1occ.scm 206 */
						node_bglt aux_1856;
						{	/* Reduce/1occ.scm 206 */
						   obj_t aux_1857;
						   aux_1857 =
						      CDR(clause_1234);
						   aux_1856 =
						      (node_bglt) (aux_1857);
						}
						reset__69_1235 =
						   node_1occ__69_reduce_1occ(aux_1856, _1_exp__141_3);
					     }
					     {	/* Reduce/1occ.scm 205 */
						obj_t nclause_1236;
						nclause_1236 = _res1__155___r5_control_features_6_4;
						SET_CDR(clause_1234, nclause_1236);
						{
						   obj_t reset_1864;
						   obj_t clauses_1862;
						   clauses_1862 =
						      CDR(clauses_1227);
						   if (
						      CBOOL(reset_1228))
						     {	/* Reduce/1occ.scm 208 */
							reset_1864 = reset_1228;
						     }
						   else
						     {	/* Reduce/1occ.scm 208 */
							reset_1864 = reset__69_1235;
						     }
						   reset_1228 = reset_1864;
						   clauses_1227 = clauses_1862;
						   goto loop_1229;
						}
					     }
					  }
				       }
				  }
			       }
			    }
			 }
			 break;
		      case ((long) 13):

			 {	/* Reduce/1occ.scm 214 */
			    let_fun_218_bglt node_1242;
			    node_1242 =
			       (let_fun_218_bglt) (node_2);
			    {	/* Reduce/1occ.scm 215 */
			       obj_t reset_1245;
			       reset_1245 =
				  node_1occ__69_reduce_1occ(
				  (((let_fun_218_bglt) CREF(node_1242))->body), _1_exp__141_3);
			       {	/* Reduce/1occ.scm 215 */
				  obj_t nbody_1246;
				  nbody_1246 = _res1__155___r5_control_features_6_4;
				  {	/* Reduce/1occ.scm 217 */
				     node_bglt val1357_1498;
				     val1357_1498 =
					(node_bglt) (nbody_1246);
				     ((((let_fun_218_bglt) CREF(node_1242))->body) = ((node_bglt) val1357_1498), BUNSPEC);
				  }
				  {
				     obj_t locals_1247;
				     obj_t reset_1248;
				     locals_1247 =
					(((let_fun_218_bglt) CREF(node_1242))->locals);
				     reset_1248 = reset_1245;
				   loop_1249:
				     if (
					NULLP(locals_1247))
				       {	/* Reduce/1occ.scm 220 */
					  _res_number__75___r5_control_features_6_4 =
					     BINT(((long) 2));
					  _res1__155___r5_control_features_6_4 =
					     (obj_t) (node_1242);
					  return reset_1248;
				       }
				     else
				       {	/* Reduce/1occ.scm 222 */
					  value_bglt sfun_1255;
					  {	/* Reduce/1occ.scm 223 */
					     local_bglt obj_1502;
					     {	/* Reduce/1occ.scm 223 */
						obj_t aux_1877;
						aux_1877 =
						   CAR(locals_1247);
						obj_1502 =
						   (local_bglt) (aux_1877);
					     }
					     sfun_1255 =
						(((local_bglt) CREF(obj_1502))->value);
					  }
					  {	/* Reduce/1occ.scm 223 */

					     {	/* Reduce/1occ.scm 224 */
						obj_t reset__69_1256;
						{	/* Reduce/1occ.scm 225 */
						   node_bglt aux_1881;
						   {	/* Reduce/1occ.scm 225 */
						      obj_t aux_1882;
						      {		/* Reduce/1occ.scm 225 */
							 sfun_bglt obj_1503;
							 obj_1503 =
							    (sfun_bglt) (sfun_1255);
							 aux_1882 =
							    (((sfun_bglt) CREF(obj_1503))->body);
						      }
						      aux_1881 =
							 (node_bglt) (aux_1882);
						   }
						   reset__69_1256 =
						      node_1occ__69_reduce_1occ(aux_1881, BNIL);
						}
						{	/* Reduce/1occ.scm 224 */
						   obj_t nbody_1257;
						   nbody_1257 = _res1__155___r5_control_features_6_4;
						   {	/* Reduce/1occ.scm 226 */
						      sfun_bglt obj_1504;
						      obj_1504 =
							 (sfun_bglt) (sfun_1255);
						      ((((sfun_bglt) CREF(obj_1504))->body) = ((obj_t) nbody_1257), BUNSPEC);
						   }
						   {
						      obj_t reset_1891;
						      obj_t locals_1889;
						      locals_1889 =
							 CDR(locals_1247);
						      if (
							 CBOOL(reset_1248))
							{	/* Reduce/1occ.scm 227 */
							   reset_1891 = reset_1248;
							}
						      else
							{	/* Reduce/1occ.scm 227 */
							   reset_1891 = reset__69_1256;
							}
						      reset_1248 = reset_1891;
						      locals_1247 = locals_1889;
						      goto loop_1249;
						   }
						}
					     }
					  }
				       }
				  }
			       }
			    }
			 }
			 break;
		      case ((long) 14):

			 {	/* Reduce/1occ.scm 233 */
			    let_var_6_bglt node_1264;
			    node_1264 =
			       (let_var_6_bglt) (node_2);
			    {
			       obj_t obindings_1267;
			       bool_t reset_1268;
			       obj_t extend_1269;
			       obindings_1267 =
				  (((let_var_6_bglt) CREF(node_1264))->bindings);
			       reset_1268 = ((bool_t) 0);
			       extend_1269 = BNIL;
			     loop_1270:
			       if (
				  NULLP(obindings_1267))
				 {	/* Reduce/1occ.scm 237 */
				    if (reset_1268)
				      {		/* Reduce/1occ.scm 239 */
					 obj_t reset__69_1274;
					 reset__69_1274 =
					    node_1occ__69_reduce_1occ(
					    (((let_var_6_bglt) CREF(node_1264))->body), BNIL);
					 {	/* Reduce/1occ.scm 239 */
					    obj_t nbody_1275;
					    nbody_1275 = _res1__155___r5_control_features_6_4;
					    {	/* Reduce/1occ.scm 241 */
					       node_bglt val1371_1511;
					       val1371_1511 =
						  (node_bglt) (nbody_1275);
					       ((((let_var_6_bglt) CREF(node_1264))->body) = ((node_bglt) val1371_1511), BUNSPEC);
					    }
					    _res_number__75___r5_control_features_6_4 =
					       BINT(((long) 2));
					    _res1__155___r5_control_features_6_4 =
					       (obj_t) (node_1264);
					    return BTRUE;
					 }
				      }
				    else
				      {		/* Reduce/1occ.scm 244 */
					 obj_t reset__69_1281;
					 reset__69_1281 =
					    node_1occ__69_reduce_1occ(
					    (((let_var_6_bglt) CREF(node_1264))->body),
					    append_2_18___r4_pairs_and_lists_6_3(extend_1269, _1_exp__141_3));
					 {	/* Reduce/1occ.scm 244 */
					    obj_t nbody_1282;
					    nbody_1282 = _res1__155___r5_control_features_6_4;
					    {	/* Reduce/1occ.scm 246 */
					       node_bglt val1371_1514;
					       val1371_1514 =
						  (node_bglt) (nbody_1282);
					       ((((let_var_6_bglt) CREF(node_1264))->body) = ((node_bglt) val1371_1514), BUNSPEC);
					    }
					    {
					       obj_t obindings_1283;
					       obj_t nbindings_1284;
					       obindings_1283 =
						  (((let_var_6_bglt) CREF(node_1264))->bindings);
					       nbindings_1284 = BNIL;
					     loop_1285:
					       if (
						  NULLP(obindings_1283))
						 {	/* Reduce/1occ.scm 252 */
						    {	/* Reduce/1occ.scm 253 */
						       bool_t test_1912;
						       if (
							  (((let_var_6_bglt) CREF(node_1264))->removable__42))
							 {	/* Reduce/1occ.scm 253 */
							    test_1912 =
							       NULLP(nbindings_1284)
							       ;
							 }
						       else
							 {	/* Reduce/1occ.scm 253 */
							    test_1912 = ((bool_t) 0)
							       ;
							 }
						       if (test_1912)
							 {	/* Reduce/1occ.scm 253 */
							    _res_number__75___r5_control_features_6_4 =
							       BINT(((long) 2));
							    {	/* Reduce/1occ.scm 259 */
							       node_bglt aux_1917;
							       aux_1917 =
								  (((let_var_6_bglt) CREF(node_1264))->body);
							       _res1__155___r5_control_features_6_4 =
								  (obj_t) (aux_1917);
							    }
							    return reset__69_1281;
							 }
						       else
							 {	/* Reduce/1occ.scm 253 */
							    {	/* Reduce/1occ.scm 261 */
							       obj_t arg1705_1292;
							       arg1705_1292 =
								  reverse__39___r4_pairs_and_lists_6_3(nbindings_1284);
							       ((((let_var_6_bglt) CREF(node_1264))->bindings) = ((obj_t) arg1705_1292), BUNSPEC);
							    }
							    _res_number__75___r5_control_features_6_4 =
							       BINT(((long) 2));
							    _res1__155___r5_control_features_6_4 =
							       (obj_t) (node_1264);
							    return reset__69_1281;
							 }
						    }
						 }
					       else
						 {	/* Reduce/1occ.scm 263 */
						    bool_t test1707_1296;
						    {	/* Reduce/1occ.scm 265 */
						       bool_t test_1924;
						       {	/* ./Ieee/fixnum.scm 7109 */
							  long aux_1925;
							  {	/* Reduce/1occ.scm 265 */
							     local_bglt obj_1526;
							     {	/* Reduce/1occ.scm 265 */
								obj_t aux_1926;
								{	/* ./Ieee/pair-list.scm 5701 */
								   obj_t aux_1927;
								   aux_1927 =
								      CAR(obindings_1283);
								   aux_1926 =
								      CAR(aux_1927);
								}
								obj_1526 =
								   (local_bglt) (aux_1926);
							     }
							     aux_1925 =
								(((local_bglt) CREF(obj_1526))->occurrence);
							  }
							  test_1924 =
							     (aux_1925 == ((long) 0));
						       }
						       if (test_1924)
							 {	/* Reduce/1occ.scm 266 */
							    bool_t test1713_1304;
							    {	/* Reduce/1occ.scm 266 */
							       node_bglt aux_1933;
							       {	/* Reduce/1occ.scm 266 */
								  obj_t aux_1934;
								  {	/* ./Ieee/pair-list.scm 5707 */
								     obj_t aux_1935;
								     aux_1935 =
									CAR(obindings_1283);
								     aux_1934 =
									CDR(aux_1935);
								  }
								  aux_1933 =
								     (node_bglt) (aux_1934);
							       }
							       test1713_1304 =
								  side_effect__165_effect_effect(aux_1933);
							    }
							    if (test1713_1304)
							      {		/* Reduce/1occ.scm 266 */
								 test1707_1296 = ((bool_t) 0);
							      }
							    else
							      {		/* Reduce/1occ.scm 266 */
								 test1707_1296 = ((bool_t) 1);
							      }
							 }
						       else
							 {	/* Reduce/1occ.scm 265 */
							    test1707_1296 = ((bool_t) 0);
							 }
						    }
						    if (test1707_1296)
						      {		/* Reduce/1occ.scm 263 */
							 {
							    obj_t obindings_1942;
							    obindings_1942 =
							       CDR(obindings_1283);
							    obindings_1283 = obindings_1942;
							    goto loop_1285;
							 }
						      }
						    else
						      {		/* Reduce/1occ.scm 263 */
							 {	/* Reduce/1occ.scm 273 */
							    obj_t arg1709_1298;
							    obj_t arg1711_1299;
							    arg1709_1298 =
							       CDR(obindings_1283);
							    {	/* ./Ieee/pair-list.scm 5689 */
							       obj_t aux_1945;
							       aux_1945 =
								  CAR(obindings_1283);
							       arg1711_1299 =
								  MAKE_PAIR(aux_1945, nbindings_1284);
							    }
							    {
							       obj_t nbindings_1949;
							       obj_t obindings_1948;
							       obindings_1948 = arg1709_1298;
							       nbindings_1949 = arg1711_1299;
							       nbindings_1284 = nbindings_1949;
							       obindings_1283 = obindings_1948;
							       goto loop_1285;
							    }
							 }
						      }
						 }
					    }
					 }
				      }
				 }
			       else
				 {	/* Reduce/1occ.scm 275 */
				    obj_t binding_1310;
				    binding_1310 =
				       CAR(obindings_1267);
				    {	/* Reduce/1occ.scm 276 */
				       obj_t var_1311;
				       obj_t val_1312;
				       var_1311 =
					  CAR(binding_1310);
				       val_1312 =
					  CDR(binding_1310);
				       {	/* Reduce/1occ.scm 278 */
					  obj_t reset__69_1313;
					  reset__69_1313 =
					     node_1occ__69_reduce_1occ(
					     (node_bglt) (val_1312), _1_exp__141_3);
					  {	/* Reduce/1occ.scm 278 */
					     obj_t nval_1314;
					     nval_1314 = _res1__155___r5_control_features_6_4;
					     SET_CDR(binding_1310, nval_1314);
					     {	/* Reduce/1occ.scm 282 */
						bool_t test_1957;
						if (reset_1268)
						  {	/* Reduce/1occ.scm 282 */
						     test_1957 = ((bool_t) 1)
							;
						  }
						else
						  {	/* Reduce/1occ.scm 282 */
						     test_1957 =
							CBOOL(reset__69_1313)
							;
						  }
						if (test_1957)
						  {	/* Reduce/1occ.scm 282 */
						     {
							obj_t extend_1963;
							bool_t reset_1962;
							obj_t obindings_1960;
							obindings_1960 =
							   CDR(obindings_1267);
							reset_1962 = ((bool_t) 1);
							extend_1963 = BNIL;
							extend_1269 = extend_1963;
							reset_1268 = reset_1962;
							obindings_1267 = obindings_1960;
							goto loop_1270;
						     }
						  }
						else
						  {	/* Reduce/1occ.scm 286 */
						     bool_t test1722_1318;
						     {	/* ./Ieee/equiv.scm 5508 */
							obj_t aux_1967;
							obj_t aux_1964;
							aux_1967 =
							   CNST_TABLE_REF(((long) 0));
							{	/* Reduce/1occ.scm 286 */
							   local_bglt obj_1540;
							   obj_1540 =
							      (local_bglt) (var_1311);
							   aux_1964 =
							      (((local_bglt) CREF(obj_1540))->access);
							}
							test1722_1318 =
							   (aux_1964 == aux_1967);
						     }
						     if (test1722_1318)
						       {	/* Reduce/1occ.scm 290 */
							  bool_t test1723_1319;
							  {	/* Reduce/1occ.scm 290 */
							     bool_t test_1971;
							     {	/* ./Ieee/fixnum.scm 7109 */
								long aux_1972;
								{	/* Reduce/1occ.scm 290 */
								   local_bglt obj_1543;
								   obj_1543 =
								      (local_bglt) (var_1311);
								   aux_1972 =
								      (((local_bglt) CREF(obj_1543))->occurrence);
								}
								test_1971 =
								   (aux_1972 == ((long) 1));
							     }
							     if (test_1971)
							       {	/* Reduce/1occ.scm 290 */
								  if (test1722_1318)
								    {	/* Reduce/1occ.scm 292 */
								       bool_t test1736_1332;
								       test1736_1332 =
									  side_effect__165_effect_effect(
									  (node_bglt) (val_1312));
								       if (test1736_1332)
									 {	/* Reduce/1occ.scm 292 */
									    test1723_1319 = ((bool_t) 0);
									 }
								       else
									 {	/* Reduce/1occ.scm 292 */
									    test1723_1319 = ((bool_t) 1);
									 }
								    }
								  else
								    {	/* Reduce/1occ.scm 291 */
								       test1723_1319 = ((bool_t) 0);
								    }
							       }
							     else
							       {	/* Reduce/1occ.scm 290 */
								  test1723_1319 = ((bool_t) 0);
							       }
							  }
							  if (test1723_1319)
							    {	/* Reduce/1occ.scm 290 */
							       {	/* Reduce/1occ.scm 299 */
								  obj_t arg1724_1320;
								  obj_t arg1725_1321;
								  arg1724_1320 =
								     CDR(obindings_1267);
								  arg1725_1321 =
								     MAKE_PAIR(binding_1310, extend_1269);
								  {
								     obj_t extend_1985;
								     bool_t reset_1984;
								     obj_t obindings_1983;
								     obindings_1983 = arg1724_1320;
								     reset_1984 = ((bool_t) 0);
								     extend_1985 = arg1725_1321;
								     extend_1269 = extend_1985;
								     reset_1268 = reset_1984;
								     obindings_1267 = obindings_1983;
								     goto loop_1270;
								  }
							       }
							    }
							  else
							    {	/* Reduce/1occ.scm 290 */
							       {	/* Reduce/1occ.scm 303 */
								  bool_t test1726_1322;
								  {	/* Reduce/1occ.scm 303 */
								     bool_t test_1986;
								     {	/* ./Ieee/fixnum.scm 7109 */
									long aux_1987;
									{	/* Reduce/1occ.scm 303 */
									   local_bglt obj_1552;
									   obj_1552 =
									      (local_bglt) (var_1311);
									   aux_1987 =
									      (((local_bglt) CREF(obj_1552))->occurrence);
									}
									test_1986 =
									   (aux_1987 == ((long) 1));
								     }
								     if (test_1986)
								       {	/* Reduce/1occ.scm 303 */
									  if (test1722_1318)
									    {	/* Reduce/1occ.scm 304 */
									       test1726_1322 =
										  side_effect__165_effect_effect(
										  (node_bglt) (val_1312));
									    }
									  else
									    {	/* Reduce/1occ.scm 304 */
									       test1726_1322 = ((bool_t) 0);
									    }
								       }
								     else
								       {	/* Reduce/1occ.scm 303 */
									  test1726_1322 = ((bool_t) 0);
								       }
								  }
								  if (test1726_1322)
								    {	/* Reduce/1occ.scm 303 */
								       BUNSPEC;
								    }
								  else
								    {	/* Reduce/1occ.scm 303 */
								       BUNSPEC;
								    }
							       }
							       {
								  bool_t reset_1997;
								  obj_t obindings_1995;
								  obindings_1995 =
								     CDR(obindings_1267);
								  reset_1997 = ((bool_t) 0);
								  reset_1268 = reset_1997;
								  obindings_1267 = obindings_1995;
								  goto loop_1270;
							       }
							    }
						       }
						     else
						       {	/* Reduce/1occ.scm 286 */
							  {
							     bool_t reset_2000;
							     obj_t obindings_1998;
							     obindings_1998 =
								CDR(obindings_1267);
							     reset_2000 = ((bool_t) 0);
							     reset_1268 = reset_2000;
							     obindings_1267 = obindings_1998;
							     goto loop_1270;
							  }
						       }
						  }
					     }
					  }
				       }
				    }
				 }
			    }
			 }
			 break;
		      case ((long) 15):

			 {	/* Reduce/1occ.scm 320 */
			    set_ex_it_116_bglt node_1340;
			    node_1340 =
			       (set_ex_it_116_bglt) (node_2);
			    {	/* Reduce/1occ.scm 321 */
			       obj_t reset_1343;
			       reset_1343 =
				  node_1occ__69_reduce_1occ(
				  (((set_ex_it_116_bglt) CREF(node_1340))->body), _1_exp__141_3);
			       {	/* Reduce/1occ.scm 321 */
				  obj_t nbody_1344;
				  nbody_1344 = _res1__155___r5_control_features_6_4;
				  {	/* Reduce/1occ.scm 323 */
				     node_bglt val1385_1562;
				     val1385_1562 =
					(node_bglt) (nbody_1344);
				     ((((set_ex_it_116_bglt) CREF(node_1340))->body) = ((node_bglt) val1385_1562), BUNSPEC);
				  }
				  _res_number__75___r5_control_features_6_4 =
				     BINT(((long) 2));
				  _res1__155___r5_control_features_6_4 =
				     (obj_t) (node_1340);
				  return reset_1343;
			       }
			    }
			 }
			 break;
		      case ((long) 16):

			 {	/* Reduce/1occ.scm 330 */
			    jump_ex_it_184_bglt node_1348;
			    node_1348 =
			       (jump_ex_it_184_bglt) (node_2);
			    {	/* Reduce/1occ.scm 331 */
			       obj_t reset_1351;
			       reset_1351 =
				  node_1occ__69_reduce_1occ(
				  (((jump_ex_it_184_bglt) CREF(node_1348))->exit), _1_exp__141_3);
			       {	/* Reduce/1occ.scm 331 */
				  obj_t nexit_1352;
				  nexit_1352 = _res1__155___r5_control_features_6_4;
				  {	/* Reduce/1occ.scm 333 */
				     node_bglt val1394_1565;
				     val1394_1565 =
					(node_bglt) (nexit_1352);
				     ((((jump_ex_it_184_bglt) CREF(node_1348))->exit) = ((node_bglt) val1394_1565), BUNSPEC);
				  }
				  {	/* Reduce/1occ.scm 335 */
				     obj_t reset__69_1354;
				     {	/* Reduce/1occ.scm 336 */
					obj_t aux_2014;
					if (
					   CBOOL(reset_1351))
					  {	/* Reduce/1occ.scm 334 */
					     aux_2014 = BNIL
						;
					  }
					else
					  {	/* Reduce/1occ.scm 334 */
					     aux_2014 = _1_exp__141_3
						;
					  }
					reset__69_1354 =
					   node_1occ__69_reduce_1occ(
					   (((jump_ex_it_184_bglt) CREF(node_1348))->value), aux_2014);
				     }
				     {	/* Reduce/1occ.scm 335 */
					obj_t nvalue_1355;
					nvalue_1355 = _res1__155___r5_control_features_6_4;
					{	/* Reduce/1occ.scm 337 */
					   node_bglt val1395_1568;
					   val1395_1568 =
					      (node_bglt) (nvalue_1355);
					   ((((jump_ex_it_184_bglt) CREF(node_1348))->value) = ((node_bglt) val1395_1568), BUNSPEC);
					}
					_res_number__75___r5_control_features_6_4 =
					   BINT(((long) 2));
					_res1__155___r5_control_features_6_4 =
					   (obj_t) (node_1348);
					if (
					   CBOOL(reset_1351))
					  {	/* Reduce/1occ.scm 338 */
					     return reset_1351;
					  }
					else
					  {	/* Reduce/1occ.scm 338 */
					     return reset__69_1354;
					  }
				     }
				  }
			       }
			    }
			 }
			 break;
		      case ((long) 17):

			 {	/* Reduce/1occ.scm 344 */
			    make_box_202_bglt node_1361;
			    node_1361 =
			       (make_box_202_bglt) (node_2);
			    {	/* Reduce/1occ.scm 345 */
			       obj_t reset_1364;
			       reset_1364 =
				  node_1occ__69_reduce_1occ(
				  (((make_box_202_bglt) CREF(node_1361))->value), _1_exp__141_3);
			       {	/* Reduce/1occ.scm 345 */
				  obj_t nvalue_1365;
				  nvalue_1365 = _res1__155___r5_control_features_6_4;
				  {	/* Reduce/1occ.scm 347 */
				     node_bglt val1406_1571;
				     val1406_1571 =
					(node_bglt) (nvalue_1365);
				     ((((make_box_202_bglt) CREF(node_1361))->value) = ((node_bglt) val1406_1571), BUNSPEC);
				  }
				  _res_number__75___r5_control_features_6_4 =
				     BINT(((long) 2));
				  _res1__155___r5_control_features_6_4 =
				     (obj_t) (node_1361);
				  return reset_1364;
			       }
			    }
			 }
			 break;
		      case ((long) 18):

			 {	/* Reduce/1occ.scm 354 */
			    box_set__221_bglt node_1369;
			    node_1369 =
			       (box_set__221_bglt) (node_2);
			    {	/* Reduce/1occ.scm 355 */
			       obj_t reset_1372;
			       reset_1372 =
				  node_1occ__69_reduce_1occ(
				  (((box_set__221_bglt) CREF(node_1369))->value), _1_exp__141_3);
			       {	/* Reduce/1occ.scm 355 */
				  obj_t nvalue_1373;
				  nvalue_1373 = _res1__155___r5_control_features_6_4;
				  {	/* Reduce/1occ.scm 357 */
				     node_bglt val1429_1574;
				     val1429_1574 =
					(node_bglt) (nvalue_1373);
				     ((((box_set__221_bglt) CREF(node_1369))->value) = ((node_bglt) val1429_1574), BUNSPEC);
				  }
				  _res_number__75___r5_control_features_6_4 =
				     BINT(((long) 2));
				  _res1__155___r5_control_features_6_4 =
				     (obj_t) (node_1369);
				  return reset_1372;
			       }
			    }
			 }
			 break;
		      case ((long) 19):

			 _res_number__75___r5_control_features_6_4 =
			    BINT(((long) 2));
			 {	/* Reduce/1occ.scm 364 */
			    box_ref_242_bglt aux_2040;
			    aux_2040 =
			       (box_ref_242_bglt) (node_2);
			    _res1__155___r5_control_features_6_4 =
			       (obj_t) (aux_2040);
			 }
			 return BFALSE;
			 break;
		      case ((long) 20):

			 {	/* Reduce/1occ.scm 370 */
			    app_bglt node_1381;
			    node_1381 =
			       (app_bglt) (node_2);
			    {	/* Reduce/1occ.scm 371 */
			       obj_t reset_1384;
			       reset_1384 =
				  node_1occ___233_reduce_1occ(
				  (((app_bglt) CREF(node_1381))->args), _1_exp__141_3);
			       {	/* Reduce/1occ.scm 372 */
				  bool_t test1750_1385;
				  if (
				     CBOOL(reset_1384))
				    {	/* Reduce/1occ.scm 372 */
				       test1750_1385 = ((bool_t) 1);
				    }
				  else
				    {	/* Reduce/1occ.scm 372 */
				       test1750_1385 =
					  side_effect__165_effect_effect(
					  (node_bglt) (node_1381));
				    }
				  if (test1750_1385)
				    {	/* Reduce/1occ.scm 372 */
				       _res_number__75___r5_control_features_6_4 =
					  BINT(((long) 2));
				       _res1__155___r5_control_features_6_4 =
					  (obj_t) (node_1381);
				       return BTRUE;
				    }
				  else
				    {	/* Reduce/1occ.scm 372 */
				       _res_number__75___r5_control_features_6_4 =
					  BINT(((long) 2));
				       _res1__155___r5_control_features_6_4 =
					  (obj_t) (node_1381);
				       return BFALSE;
				    }
			       }
			    }
			 }
			 break;
		      default:
		       case_else1658_1113:
			 if (
			    PROCEDUREP(method1652_1109))
			   {	/* Reduce/1occ.scm 65 */
			      return
				 PROCEDURE_ENTRY(method1652_1109) (method1652_1109,
				 (obj_t) (node_2), _1_exp__141_3, BEOA);
			   }
			 else
			   {	/* Reduce/1occ.scm 65 */
			      obj_t fun1651_1105;
			      fun1651_1105 =
				 PROCEDURE_REF(node_1occ__env_84_reduce_1occ, ((long) 0));
			      return
				 PROCEDURE_ENTRY(fun1651_1105) (fun1651_1105,
				 (obj_t) (node_2), _1_exp__141_3, BEOA);
			   }
		      }
		 }
	       else
		 {	/* Reduce/1occ.scm 65 */
		    goto case_else1658_1113;
		 }
	    }
	 }
      }
   }
}



/* _node-1occ!1758 */
obj_t 
_node_1occ_1758_177_reduce_1occ(obj_t env_1583, obj_t node_1584, obj_t _1_exp__141_1585)
{
   AN_OBJECT;
   {	/* Reduce/1occ.scm 65 */
      return
	 node_1occ__69_reduce_1occ(
	 (node_bglt) (node_1584), _1_exp__141_1585);
   }
}



/* node-1occ!-default1513 */
obj_t 
node_1occ__default1513_193_reduce_1occ(node_bglt node_4, obj_t _1_exp__141_5)
{
   AN_OBJECT;
   {	/* Reduce/1occ.scm 15 */
      FAILURE(
	 CNST_TABLE_REF(((long) 1)), string1761_reduce_1occ,
	 (obj_t) (node_4));
   }
}



/* _node-1occ!-default1513 */
obj_t 
_node_1occ__default1513_136_reduce_1occ(obj_t env_1586, obj_t node_1587, obj_t _1_exp__141_1588)
{
   AN_OBJECT;
   {	/* Reduce/1occ.scm 15 */
      return
	 node_1occ__default1513_193_reduce_1occ(
	 (node_bglt) (node_1587), _1_exp__141_1588);
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_reduce_1occ()
{
   AN_OBJECT;
   {	/* Reduce/1occ.scm 15 */
      module_initialization_70_tools_trace(((long) 0), "REDUCE_1OCC");
      module_initialization_70_tools_shape(((long) 0), "REDUCE_1OCC");
      module_initialization_70_tools_speek(((long) 0), "REDUCE_1OCC");
      module_initialization_70_tools_error(((long) 0), "REDUCE_1OCC");
      module_initialization_70_type_type(((long) 0), "REDUCE_1OCC");
      module_initialization_70_type_cache(((long) 0), "REDUCE_1OCC");
      module_initialization_70_coerce_typeof(((long) 0), "REDUCE_1OCC");
      module_initialization_70_coerce_coerce(((long) 0), "REDUCE_1OCC");
      module_initialization_70_effect_effect(((long) 0), "REDUCE_1OCC");
      module_initialization_70_ast_var(((long) 0), "REDUCE_1OCC");
      module_initialization_70_ast_node(((long) 0), "REDUCE_1OCC");
      module_initialization_70_ast_lvtype(((long) 0), "REDUCE_1OCC");
      return
	 module_initialization_70_ast_occur(((long) 0), "REDUCE_1OCC");
   }
}
