/*===========================================================================*/
/*   (Reduce/cond.scm)                                                       */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;


static obj_t method_init_76_reduce_cond();
extern obj_t make_box_202_ast_node;
extern obj_t funcall_ast_node;
extern long add_inlined_method__244___object(obj_t, obj_t, long);
extern obj_t fail_ast_node;
extern obj_t box_ref_242_ast_node;
extern obj_t sequence_ast_node;
extern obj_t let_var_6_ast_node;
extern obj_t var_ast_node;
static obj_t _node_cond_1688_254_reduce_cond(obj_t, obj_t);
extern obj_t closure_ast_node;
extern obj_t pragma_ast_node;
extern obj_t set_ex_it_116_ast_node;
extern obj_t verbose_tools_speek(obj_t, obj_t);
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t module_initialization_70_reduce_cond(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_speek(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
static obj_t _reduce_conditional__210_reduce_cond(obj_t, obj_t);
static obj_t _node_cond__default1462_181_reduce_cond(obj_t, obj_t);
extern obj_t let_fun_218_ast_node;
static obj_t imported_modules_init_94_reduce_cond();
extern obj_t app_ly_162_ast_node;
extern obj_t add_generic__110___object(obj_t, obj_t);
extern obj_t app_ast_node;
static obj_t library_modules_init_112_reduce_cond();
extern obj_t reduce_conditional__50_reduce_cond(obj_t);
extern obj_t atom_ast_node;
extern obj_t cast_ast_node;
static obj_t toplevel_init_63_reduce_cond();
extern obj_t jump_ex_it_184_ast_node;
extern obj_t open_input_string(obj_t);
extern obj_t kwote_ast_node;
static obj_t node_cond___88_reduce_cond(obj_t);
static long _cond_reduced__35_reduce_cond;
extern obj_t setq_ast_node;
extern obj_t box_set__221_ast_node;
static node_bglt node_cond__default1462_197_reduce_cond(node_bglt);
static node_bglt node_cond__1_reduce_cond(node_bglt);
extern obj_t _classes__134___object;
extern obj_t select_ast_node;
extern obj_t read___reader(obj_t);
static obj_t require_initialization_114_reduce_cond = BUNSPEC;
extern obj_t conditional_ast_node;
static obj_t cnst_init_137_reduce_cond();
static obj_t __cnst[2];

DEFINE_STATIC_PROCEDURE(node_cond__default1462_env_244_reduce_cond, _node_cond__default1462_181_reduce_cond1697, _node_cond__default1462_181_reduce_cond, 0L, 1);
DEFINE_EXPORT_PROCEDURE(reduce_conditional__env_210_reduce_cond, _reduce_conditional__210_reduce_cond1698, _reduce_conditional__210_reduce_cond, 0L, 1);
DEFINE_STATIC_GENERIC(node_cond__env_233_reduce_cond, _node_cond_1688_254_reduce_cond1699, _node_cond_1688_254_reduce_cond, 0L, 1);
DEFINE_STRING(string1692_reduce_cond, string1692_reduce_cond1700, "NODE-COND!-DEFAULT1462 DONE ", 28);
DEFINE_STRING(string1691_reduce_cond, string1691_reduce_cond1701, "No method for this object", 25);
DEFINE_STRING(string1689_reduce_cond, string1689_reduce_cond1702, "      conditional expression ", 29);
DEFINE_STRING(string1690_reduce_cond, string1690_reduce_cond1703, "(reduced : ", 11);



/* module-initialization */
obj_t 
module_initialization_70_reduce_cond(long checksum_1360, char *from_1361)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_reduce_cond))
	{
	   require_initialization_114_reduce_cond =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_reduce_cond();
	   cnst_init_137_reduce_cond();
	   imported_modules_init_94_reduce_cond();
	   method_init_76_reduce_cond();
	   toplevel_init_63_reduce_cond();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_reduce_cond()
{
   AN_OBJECT;
   {	/* Reduce/cond.scm 14 */
      module_initialization_70___object(((long) 0), "REDUCE_COND");
      module_initialization_70___reader(((long) 0), "REDUCE_COND");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_reduce_cond()
{
   AN_OBJECT;
   {	/* Reduce/cond.scm 14 */
      {		/* Reduce/cond.scm 14 */
	 obj_t cnst_port_138_1353;
	 cnst_port_138_1353 =
	    open_input_string(string1692_reduce_cond);
	 {
	    long i_1354;
	    i_1354 = ((long) 1);
	  loop_1355:
	    {	/* Reduce/cond.scm 14 */
	       bool_t test1693_1356;
	       test1693_1356 =
		  (i_1354 == ((long) -1));
	       if (test1693_1356)
		 {	/* Reduce/cond.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Reduce/cond.scm 14 */
		    {	/* Reduce/cond.scm 14 */
		       obj_t arg1694_1357;
		       {	/* Reduce/cond.scm 14 */
			  obj_t list1695_1358;
			  list1695_1358 =
			     MAKE_PAIR(cnst_port_138_1353, BNIL);
			  arg1694_1357 =
			     read___reader(list1695_1358);
		       }
		       CNST_TABLE_SET(i_1354, arg1694_1357);
		    }
		    {	/* Reduce/cond.scm 14 */
		       int aux_1359;
		       {	/* Reduce/cond.scm 14 */
			  long aux_1378;
			  aux_1378 =
			     (i_1354 - ((long) 1));
			  aux_1359 =
			     (int) (aux_1378);
		       }
		       {
			  long i_1381;
			  i_1381 =
			     (long) (aux_1359);
			  i_1354 = i_1381;
			  goto loop_1355;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_reduce_cond()
{
   AN_OBJECT;
   {	/* Reduce/cond.scm 14 */
      _cond_reduced__35_reduce_cond = ((long) 0);
      return BUNSPEC;
   }
}



/* reduce-conditional! */
obj_t 
reduce_conditional__50_reduce_cond(obj_t globals_1)
{
   AN_OBJECT;
   {	/* Reduce/cond.scm 27 */
      {		/* Reduce/cond.scm 28 */
	 obj_t list1506_721;
	 list1506_721 =
	    MAKE_PAIR(string1689_reduce_cond, BNIL);
	 verbose_tools_speek(
	    BINT(((long) 2)), list1506_721);
      }
      {
	 obj_t l1437_722;
	 l1437_722 = globals_1;
       lname1438_723:
	 if (
	    PAIRP(l1437_722))
	   {	/* Reduce/cond.scm 29 */
	      {		/* Reduce/cond.scm 30 */
		 value_bglt fun_726;
		 {	/* Reduce/cond.scm 30 */
		    global_bglt obj_1205;
		    {	/* Reduce/cond.scm 30 */
		       obj_t aux_1388;
		       aux_1388 =
			  CAR(l1437_722);
		       obj_1205 =
			  (global_bglt) (aux_1388);
		    }
		    fun_726 =
		       (((global_bglt) CREF(obj_1205))->value);
		 }
		 {	/* Reduce/cond.scm 31 */

		    {	/* Reduce/cond.scm 32 */
		       node_bglt arg1508_728;
		       {	/* Reduce/cond.scm 32 */
			  node_bglt aux_1392;
			  {	/* Reduce/cond.scm 32 */
			     obj_t aux_1393;
			     {	/* Reduce/cond.scm 31 */
				sfun_bglt obj_1206;
				obj_1206 =
				   (sfun_bglt) (fun_726);
				aux_1393 =
				   (((sfun_bglt) CREF(obj_1206))->body);
			     }
			     aux_1392 =
				(node_bglt) (aux_1393);
			  }
			  arg1508_728 =
			     node_cond__1_reduce_cond(aux_1392);
		       }
		       {	/* Reduce/cond.scm 32 */
			  sfun_bglt obj_1207;
			  obj_t val1123_1208;
			  obj_1207 =
			     (sfun_bglt) (fun_726);
			  val1123_1208 =
			     (obj_t) (arg1508_728);
			  ((((sfun_bglt) CREF(obj_1207))->body) = ((obj_t) val1123_1208), BUNSPEC);
		       }
		    }
		    BUNSPEC;
		 }
	      }
	      {
		 obj_t l1437_1401;
		 l1437_1401 =
		    CDR(l1437_722);
		 l1437_722 = l1437_1401;
		 goto lname1438_723;
	      }
	   }
	 else
	   {	/* Reduce/cond.scm 29 */
	      ((bool_t) 1);
	   }
      }
      {		/* Reduce/cond.scm 35 */
	 obj_t list1510_730;
	 {	/* Reduce/cond.scm 35 */
	    obj_t arg1512_732;
	    {	/* Reduce/cond.scm 35 */
	       obj_t arg1513_733;
	       {	/* Reduce/cond.scm 35 */
		  obj_t arg1514_734;
		  {	/* Reduce/cond.scm 35 */
		     obj_t aux_1403;
		     aux_1403 =
			BCHAR(((unsigned char) '\n'));
		     arg1514_734 =
			MAKE_PAIR(aux_1403, BNIL);
		  }
		  {	/* Reduce/cond.scm 35 */
		     obj_t aux_1406;
		     aux_1406 =
			BCHAR(((unsigned char) ')'));
		     arg1513_733 =
			MAKE_PAIR(aux_1406, arg1514_734);
		  }
	       }
	       {	/* Reduce/cond.scm 35 */
		  obj_t aux_1409;
		  aux_1409 =
		     BINT(_cond_reduced__35_reduce_cond);
		  arg1512_732 =
		     MAKE_PAIR(aux_1409, arg1513_733);
	       }
	    }
	    list1510_730 =
	       MAKE_PAIR(string1690_reduce_cond, arg1512_732);
	 }
	 verbose_tools_speek(
	    BINT(((long) 2)), list1510_730);
      }
      return globals_1;
   }
}



/* _reduce-conditional! */
obj_t 
_reduce_conditional__210_reduce_cond(obj_t env_1347, obj_t globals_1348)
{
   AN_OBJECT;
   {	/* Reduce/cond.scm 27 */
      return
	 reduce_conditional__50_reduce_cond(globals_1348);
   }
}



/* node-cond*! */
obj_t 
node_cond___88_reduce_cond(obj_t node__221_25)
{
   AN_OBJECT;
   {	/* Reduce/cond.scm 238 */
      {
	 obj_t node__221_735;
	 node__221_735 = node__221_25;
       loop_736:
	 if (
	    NULLP(node__221_735))
	   {	/* Reduce/cond.scm 240 */
	      return
		 CNST_TABLE_REF(((long) 0));
	   }
	 else
	   {	/* Reduce/cond.scm 240 */
	      {		/* Reduce/cond.scm 243 */
		 node_bglt arg1516_738;
		 {	/* Reduce/cond.scm 243 */
		    node_bglt aux_1419;
		    {	/* Reduce/cond.scm 243 */
		       obj_t aux_1420;
		       aux_1420 =
			  CAR(node__221_735);
		       aux_1419 =
			  (node_bglt) (aux_1420);
		    }
		    arg1516_738 =
		       node_cond__1_reduce_cond(aux_1419);
		 }
		 {	/* ./Ieee/pair-list.scm 5890 */
		    obj_t aux_1424;
		    aux_1424 =
		       (obj_t) (arg1516_738);
		    SET_CAR(node__221_735, aux_1424);
		 }
	      }
	      {
		 obj_t node__221_1427;
		 node__221_1427 =
		    CDR(node__221_735);
		 node__221_735 = node__221_1427;
		 goto loop_736;
	      }
	   }
      }
   }
}



/* method-init */
obj_t 
method_init_76_reduce_cond()
{
   AN_OBJECT;
   {	/* Reduce/cond.scm 14 */
      add_generic__110___object(node_cond__env_233_reduce_cond, node_cond__default1462_env_244_reduce_cond);
      add_inlined_method__244___object(node_cond__env_233_reduce_cond, atom_ast_node, ((long) 0));
      add_inlined_method__244___object(node_cond__env_233_reduce_cond, kwote_ast_node, ((long) 1));
      add_inlined_method__244___object(node_cond__env_233_reduce_cond, var_ast_node, ((long) 2));
      add_inlined_method__244___object(node_cond__env_233_reduce_cond, closure_ast_node, ((long) 3));
      add_inlined_method__244___object(node_cond__env_233_reduce_cond, sequence_ast_node, ((long) 4));
      add_inlined_method__244___object(node_cond__env_233_reduce_cond, app_ast_node, ((long) 5));
      add_inlined_method__244___object(node_cond__env_233_reduce_cond, app_ly_162_ast_node, ((long) 6));
      add_inlined_method__244___object(node_cond__env_233_reduce_cond, funcall_ast_node, ((long) 7));
      add_inlined_method__244___object(node_cond__env_233_reduce_cond, pragma_ast_node, ((long) 8));
      add_inlined_method__244___object(node_cond__env_233_reduce_cond, cast_ast_node, ((long) 9));
      add_inlined_method__244___object(node_cond__env_233_reduce_cond, setq_ast_node, ((long) 10));
      add_inlined_method__244___object(node_cond__env_233_reduce_cond, conditional_ast_node, ((long) 11));
      add_inlined_method__244___object(node_cond__env_233_reduce_cond, fail_ast_node, ((long) 12));
      add_inlined_method__244___object(node_cond__env_233_reduce_cond, select_ast_node, ((long) 13));
      add_inlined_method__244___object(node_cond__env_233_reduce_cond, let_fun_218_ast_node, ((long) 14));
      add_inlined_method__244___object(node_cond__env_233_reduce_cond, let_var_6_ast_node, ((long) 15));
      add_inlined_method__244___object(node_cond__env_233_reduce_cond, set_ex_it_116_ast_node, ((long) 16));
      add_inlined_method__244___object(node_cond__env_233_reduce_cond, jump_ex_it_184_ast_node, ((long) 17));
      add_inlined_method__244___object(node_cond__env_233_reduce_cond, make_box_202_ast_node, ((long) 18));
      add_inlined_method__244___object(node_cond__env_233_reduce_cond, box_set__221_ast_node, ((long) 19));
      {		/* Reduce/cond.scm 14 */
	 long aux_1450;
	 aux_1450 =
	    add_inlined_method__244___object(node_cond__env_233_reduce_cond, box_ref_242_ast_node, ((long) 20));
	 return
	    BINT(aux_1450);
      }
   }
}



/* node-cond! */
node_bglt 
node_cond__1_reduce_cond(node_bglt node_2)
{
   AN_OBJECT;
   {	/* Reduce/cond.scm 46 */
      {
	 obj_t method1600_1071;
	 obj_t class1605_1072;
	 {	/* Reduce/cond.scm 46 */
	    obj_t arg1608_1069;
	    obj_t arg1609_1070;
	    {	/* Reduce/cond.scm 46 */
	       object_bglt obj_1215;
	       obj_1215 =
		  (object_bglt) (node_2);
	       {	/* ./Llib/object.scm 2926 */
		  obj_t pre_method_105_1216;
		  pre_method_105_1216 =
		     PROCEDURE_REF(node_cond__env_233_reduce_cond, ((long) 2));
		  if (
		     INTEGERP(pre_method_105_1216))
		    {	/* ./Llib/object.scm 2927 */
		       PROCEDURE_SET(node_cond__env_233_reduce_cond, ((long) 2), BUNSPEC);
		       arg1608_1069 = pre_method_105_1216;
		    }
		  else
		    {	/* ./Llib/object.scm 2914 */
		       long obj_class_num_177_1221;
		       obj_class_num_177_1221 =
			  TYPE(obj_1215);
		       {	/* ./Llib/object.scm 2915 */
			  obj_t arg1176_1222;
			  arg1176_1222 =
			     PROCEDURE_REF(node_cond__env_233_reduce_cond, ((long) 1));
			  {	/* ./Llib/object.scm 2738 */
			     long arg1177_1226;
			     {	/* ./Llib/object.scm 2738 */
				long arg1178_1227;
				arg1178_1227 =
				   OBJECT_TYPE;
				arg1177_1226 =
				   (obj_class_num_177_1221 - arg1178_1227);
			     }
			     arg1608_1069 =
				VECTOR_REF(arg1176_1222, arg1177_1226);
			  }
		       }
		    }
	       }
	    }
	    {	/* Reduce/cond.scm 46 */
	       object_bglt object_1232;
	       object_1232 =
		  (object_bglt) (node_2);
	       {	/* ./Llib/object.scm 2695 */
		  long arg1179_1233;
		  {	/* ./Llib/object.scm 2695 */
		     long arg1180_1234;
		     long arg1181_1235;
		     arg1180_1234 =
			TYPE(object_1232);
		     arg1181_1235 =
			OBJECT_TYPE;
		     arg1179_1233 =
			(arg1180_1234 - arg1181_1235);
		  }
		  {	/* ./Llib/object.scm 2695 */
		     obj_t vector_1239;
		     vector_1239 = _classes__134___object;
		     arg1609_1070 =
			VECTOR_REF(vector_1239, arg1179_1233);
		  }
	       }
	    }
	    {	/* Reduce/cond.scm 46 */
	       obj_t aux_1468;
	       method1600_1071 = arg1608_1069;
	       class1605_1072 = arg1609_1070;
	       {

		  if (
		     INTEGERP(method1600_1071))
		    {	/* Reduce/cond.scm 46 */
		       switch (
			  (long) CINT(method1600_1071))
			 {
			 case ((long) 0):

			    {	/* Reduce/cond.scm 46 */
			       atom_bglt aux_1471;
			       aux_1471 =
				  (atom_bglt) (node_2);
			       aux_1468 =
				  (obj_t) (aux_1471);
			    }
			    break;
			 case ((long) 1):

			    {	/* Reduce/cond.scm 46 */
			       kwote_bglt aux_1474;
			       aux_1474 =
				  (kwote_bglt) (node_2);
			       aux_1468 =
				  (obj_t) (aux_1474);
			    }
			    break;
			 case ((long) 2):

			    {	/* Reduce/cond.scm 46 */
			       var_bglt aux_1477;
			       aux_1477 =
				  (var_bglt) (node_2);
			       aux_1468 =
				  (obj_t) (aux_1477);
			    }
			    break;
			 case ((long) 3):

			    {	/* Reduce/cond.scm 46 */
			       closure_bglt aux_1480;
			       aux_1480 =
				  (closure_bglt) (node_2);
			       aux_1468 =
				  (obj_t) (aux_1480);
			    }
			    break;
			 case ((long) 4):

			    {	/* Reduce/cond.scm 76 */
			       sequence_bglt node_1082;
			       node_1082 =
				  (sequence_bglt) (node_2);
			       node_cond___88_reduce_cond(
				  (((sequence_bglt) CREF(node_1082))->nodes));
			       aux_1468 =
				  (obj_t) (node_1082);
			    }
			    break;
			 case ((long) 5):

			    {	/* Reduce/cond.scm 84 */
			       app_bglt node_1085;
			       node_1085 =
				  (app_bglt) (node_2);
			       node_cond___88_reduce_cond(
				  (((app_bglt) CREF(node_1085))->args));
			       aux_1468 =
				  (obj_t) (node_1085);
			    }
			    break;
			 case ((long) 6):

			    {	/* Reduce/cond.scm 92 */
			       app_ly_162_bglt node_1088;
			       node_1088 =
				  (app_ly_162_bglt) (node_2);
			       {	/* Reduce/cond.scm 93 */
				  node_bglt arg1614_1090;
				  arg1614_1090 =
				     node_cond__1_reduce_cond(
				     (((app_ly_162_bglt) CREF(node_1088))->fun));
				  ((((app_ly_162_bglt) CREF(node_1088))->fun) = ((node_bglt) arg1614_1090), BUNSPEC);
			       }
			       {	/* Reduce/cond.scm 94 */
				  node_bglt arg1616_1092;
				  arg1616_1092 =
				     node_cond__1_reduce_cond(
				     (((app_ly_162_bglt) CREF(node_1088))->arg));
				  ((((app_ly_162_bglt) CREF(node_1088))->arg) = ((node_bglt) arg1616_1092), BUNSPEC);
			       }
			       aux_1468 =
				  (obj_t) (node_1088);
			    }
			    break;
			 case ((long) 7):

			    {	/* Reduce/cond.scm 101 */
			       funcall_bglt node_1094;
			       node_1094 =
				  (funcall_bglt) (node_2);
			       {	/* Reduce/cond.scm 102 */
				  node_bglt arg1618_1096;
				  arg1618_1096 =
				     node_cond__1_reduce_cond(
				     (((funcall_bglt) CREF(node_1094))->fun));
				  ((((funcall_bglt) CREF(node_1094))->fun) = ((node_bglt) arg1618_1096), BUNSPEC);
			       }
			       node_cond___88_reduce_cond(
				  (((funcall_bglt) CREF(node_1094))->args));
			       aux_1468 =
				  (obj_t) (node_1094);
			    }
			    break;
			 case ((long) 8):

			    {	/* Reduce/cond.scm 110 */
			       pragma_bglt node_1099;
			       node_1099 =
				  (pragma_bglt) (node_2);
			       node_cond___88_reduce_cond(
				  (((pragma_bglt) CREF(node_1099))->args));
			       aux_1468 =
				  (obj_t) (node_1099);
			    }
			    break;
			 case ((long) 9):

			    {	/* Reduce/cond.scm 118 */
			       cast_bglt node_1102;
			       node_1102 =
				  (cast_bglt) (node_2);
			       node_cond__1_reduce_cond(
				  (((cast_bglt) CREF(node_1102))->arg));
			       aux_1468 =
				  (obj_t) (node_1102);
			    }
			    break;
			 case ((long) 10):

			    {	/* Reduce/cond.scm 126 */
			       setq_bglt node_1105;
			       node_1105 =
				  (setq_bglt) (node_2);
			       {	/* Reduce/cond.scm 127 */
				  node_bglt arg1623_1107;
				  arg1623_1107 =
				     node_cond__1_reduce_cond(
				     (((setq_bglt) CREF(node_1105))->value));
				  ((((setq_bglt) CREF(node_1105))->value) = ((node_bglt) arg1623_1107), BUNSPEC);
			       }
			       {	/* Reduce/cond.scm 128 */
				  node_bglt arg1625_1109;
				  {	/* Reduce/cond.scm 128 */
				     node_bglt aux_1518;
				     {	/* Reduce/cond.scm 128 */
					var_bglt aux_1519;
					aux_1519 =
					   (((setq_bglt) CREF(node_1105))->var);
					aux_1518 =
					   (node_bglt) (aux_1519);
				     }
				     arg1625_1109 =
					node_cond__1_reduce_cond(aux_1518);
				  }
				  {	/* Reduce/cond.scm 128 */
				     var_bglt val1302_1260;
				     val1302_1260 =
					(var_bglt) (arg1625_1109);
				     ((((setq_bglt) CREF(node_1105))->var) = ((var_bglt) val1302_1260), BUNSPEC);
				  }
			       }
			       aux_1468 =
				  (obj_t) (node_1105);
			    }
			    break;
			 case ((long) 11):

			    {	/* Reduce/cond.scm 135 */
			       conditional_bglt node_1111;
			       node_1111 =
				  (conditional_bglt) (node_2);
			       {	/* Reduce/cond.scm 136 */
				  node_bglt arg1627_1113;
				  arg1627_1113 =
				     node_cond__1_reduce_cond(
				     (((conditional_bglt) CREF(node_1111))->test));
				  ((((conditional_bglt) CREF(node_1111))->test) = ((node_bglt) arg1627_1113), BUNSPEC);
			       }
			       {	/* Reduce/cond.scm 137 */
				  node_bglt arg1629_1115;
				  arg1629_1115 =
				     node_cond__1_reduce_cond(
				     (((conditional_bglt) CREF(node_1111))->true));
				  ((((conditional_bglt) CREF(node_1111))->true) = ((node_bglt) arg1629_1115), BUNSPEC);
			       }
			       {	/* Reduce/cond.scm 138 */
				  node_bglt arg1631_1117;
				  arg1631_1117 =
				     node_cond__1_reduce_cond(
				     (((conditional_bglt) CREF(node_1111))->false));
				  ((((conditional_bglt) CREF(node_1111))->false) = ((node_bglt) arg1631_1117), BUNSPEC);
			       }
			       {	/* Reduce/cond.scm 139 */
				  bool_t test1633_1119;
				  {	/* ./Ast/node.scm 890 */
				     obj_t aux_1536;
				     {	/* Reduce/cond.scm 139 */
					node_bglt aux_1537;
					aux_1537 =
					   (((conditional_bglt) CREF(node_1111))->test);
					aux_1536 =
					   (obj_t) (aux_1537);
				     }
				     test1633_1119 =
					is_a__118___object(aux_1536, atom_ast_node);
				  }
				  if (test1633_1119)
				    {	/* Reduce/cond.scm 139 */
				       {	/* Reduce/cond.scm 141 */
					  long z2_1273;
					  z2_1273 = _cond_reduced__35_reduce_cond;
					  _cond_reduced__35_reduce_cond =
					     (((long) 1) + z2_1273);
				       }
				       {	/* Reduce/cond.scm 143 */
					  bool_t test_1543;
					  {	/* Reduce/cond.scm 143 */
					     atom_bglt obj_1275;
					     {	/* Reduce/cond.scm 143 */
						node_bglt aux_1544;
						aux_1544 =
						   (((conditional_bglt) CREF(node_1111))->test);
						obj_1275 =
						   (atom_bglt) (aux_1544);
					     }
					     {	/* ./Ast/node.scm 890 */
						obj_t aux_1547;
						aux_1547 =
						   (((atom_bglt) CREF(obj_1275))->value);
						test_1543 =
						   CBOOL(aux_1547);
					     }
					  }
					  if (test_1543)
					    {	/* ./Ast/node.scm 956 */
					       node_bglt aux_1550;
					       aux_1550 =
						  (((conditional_bglt) CREF(node_1111))->true);
					       aux_1468 =
						  (obj_t) (aux_1550);
					    }
					  else
					    {	/* ./Ast/node.scm 956 */
					       node_bglt aux_1553;
					       aux_1553 =
						  (((conditional_bglt) CREF(node_1111))->false);
					       aux_1468 =
						  (obj_t) (aux_1553);
					    }
				       }
				    }
				  else
				    {	/* Reduce/cond.scm 139 */
				       aux_1468 =
					  (obj_t) (node_1111)
					  ;
				    }
			       }
			    }
			    break;
			 case ((long) 12):

			    {	/* Reduce/cond.scm 152 */
			       fail_bglt node_1123;
			       node_1123 =
				  (fail_bglt) (node_2);
			       {	/* Reduce/cond.scm 153 */
				  node_bglt arg1637_1125;
				  arg1637_1125 =
				     node_cond__1_reduce_cond(
				     (((fail_bglt) CREF(node_1123))->proc));
				  ((((fail_bglt) CREF(node_1123))->proc) = ((node_bglt) arg1637_1125), BUNSPEC);
			       }
			       {	/* Reduce/cond.scm 154 */
				  node_bglt arg1639_1127;
				  arg1639_1127 =
				     node_cond__1_reduce_cond(
				     (((fail_bglt) CREF(node_1123))->msg));
				  ((((fail_bglt) CREF(node_1123))->msg) = ((node_bglt) arg1639_1127), BUNSPEC);
			       }
			       {	/* Reduce/cond.scm 155 */
				  node_bglt arg1641_1129;
				  arg1641_1129 =
				     node_cond__1_reduce_cond(
				     (((fail_bglt) CREF(node_1123))->obj));
				  ((((fail_bglt) CREF(node_1123))->obj) = ((node_bglt) arg1641_1129), BUNSPEC);
			       }
			       aux_1468 =
				  (obj_t) (node_1123);
			    }
			    break;
			 case ((long) 13):

			    {	/* Reduce/cond.scm 162 */
			       select_bglt node_1131;
			       node_1131 =
				  (select_bglt) (node_2);
			       {	/* Reduce/cond.scm 163 */
				  node_bglt arg1643_1133;
				  arg1643_1133 =
				     node_cond__1_reduce_cond(
				     (((select_bglt) CREF(node_1131))->test));
				  ((((select_bglt) CREF(node_1131))->test) = ((node_bglt) arg1643_1133), BUNSPEC);
			       }
			       {
				  obj_t l1449_1135;
				  l1449_1135 =
				     (((select_bglt) CREF(node_1131))->clauses);
				lname1450_1136:
				  if (
				     PAIRP(l1449_1135))
				    {	/* Reduce/cond.scm 164 */
				       {	/* Reduce/cond.scm 165 */
					  obj_t clause_1139;
					  clause_1139 =
					     CAR(l1449_1135);
					  {	/* Reduce/cond.scm 165 */
					     node_bglt arg1648_1140;
					     {	/* Reduce/cond.scm 165 */
						node_bglt aux_1575;
						{	/* Reduce/cond.scm 165 */
						   obj_t aux_1576;
						   aux_1576 =
						      CDR(clause_1139);
						   aux_1575 =
						      (node_bglt) (aux_1576);
						}
						arg1648_1140 =
						   node_cond__1_reduce_cond(aux_1575);
					     }
					     {	/* ./Ieee/pair-list.scm 5896 */
						obj_t aux_1580;
						aux_1580 =
						   (obj_t) (arg1648_1140);
						SET_CDR(clause_1139, aux_1580);
					     }
					  }
				       }
				       {
					  obj_t l1449_1583;
					  l1449_1583 =
					     CDR(l1449_1135);
					  l1449_1135 = l1449_1583;
					  goto lname1450_1136;
				       }
				    }
				  else
				    {	/* Reduce/cond.scm 164 */
				       ((bool_t) 1);
				    }
			       }
			       aux_1468 =
				  (obj_t) (node_1131);
			    }
			    break;
			 case ((long) 14):

			    {	/* Reduce/cond.scm 173 */
			       let_fun_218_bglt node_1143;
			       node_1143 =
				  (let_fun_218_bglt) (node_2);
			       {
				  obj_t l1452_1145;
				  l1452_1145 =
				     (((let_fun_218_bglt) CREF(node_1143))->locals);
				lname1453_1146:
				  if (
				     PAIRP(l1452_1145))
				    {	/* Reduce/cond.scm 174 */
				       {	/* Reduce/cond.scm 175 */
					  value_bglt fun_1150;
					  {	/* Reduce/cond.scm 175 */
					     local_bglt obj_1300;
					     {	/* Reduce/cond.scm 175 */
						obj_t aux_1590;
						aux_1590 =
						   CAR(l1452_1145);
						obj_1300 =
						   (local_bglt) (aux_1590);
					     }
					     fun_1150 =
						(((local_bglt) CREF(obj_1300))->value);
					  }
					  {	/* Reduce/cond.scm 176 */
					     node_bglt arg1653_1151;
					     {	/* Reduce/cond.scm 176 */
						node_bglt aux_1594;
						{	/* Reduce/cond.scm 176 */
						   obj_t aux_1595;
						   {	/* Reduce/cond.scm 176 */
						      sfun_bglt obj_1301;
						      obj_1301 =
							 (sfun_bglt) (fun_1150);
						      aux_1595 =
							 (((sfun_bglt) CREF(obj_1301))->body);
						   }
						   aux_1594 =
						      (node_bglt) (aux_1595);
						}
						arg1653_1151 =
						   node_cond__1_reduce_cond(aux_1594);
					     }
					     {	/* Reduce/cond.scm 176 */
						sfun_bglt obj_1302;
						obj_t val1123_1303;
						obj_1302 =
						   (sfun_bglt) (fun_1150);
						val1123_1303 =
						   (obj_t) (arg1653_1151);
						((((sfun_bglt) CREF(obj_1302))->body) = ((obj_t) val1123_1303), BUNSPEC);
					     }
					  }
				       }
				       {
					  obj_t l1452_1603;
					  l1452_1603 =
					     CDR(l1452_1145);
					  l1452_1145 = l1452_1603;
					  goto lname1453_1146;
				       }
				    }
				  else
				    {	/* Reduce/cond.scm 174 */
				       ((bool_t) 1);
				    }
			       }
			       {	/* Reduce/cond.scm 178 */
				  node_bglt arg1656_1154;
				  arg1656_1154 =
				     node_cond__1_reduce_cond(
				     (((let_fun_218_bglt) CREF(node_1143))->body));
				  ((((let_fun_218_bglt) CREF(node_1143))->body) = ((node_bglt) arg1656_1154), BUNSPEC);
			       }
			       aux_1468 =
				  (obj_t) (node_1143);
			    }
			    break;
			 case ((long) 15):

			    {	/* Reduce/cond.scm 185 */
			       let_var_6_bglt node_1156;
			       node_1156 =
				  (let_var_6_bglt) (node_2);
			       {
				  obj_t l1455_1158;
				  l1455_1158 =
				     (((let_var_6_bglt) CREF(node_1156))->bindings);
				lname1456_1159:
				  if (
				     PAIRP(l1455_1158))
				    {	/* Reduce/cond.scm 186 */
				       {	/* Reduce/cond.scm 187 */
					  obj_t binding_1162;
					  binding_1162 =
					     CAR(l1455_1158);
					  {	/* Reduce/cond.scm 187 */
					     node_bglt arg1660_1163;
					     {	/* Reduce/cond.scm 187 */
						node_bglt aux_1614;
						{	/* Reduce/cond.scm 187 */
						   obj_t aux_1615;
						   aux_1615 =
						      CDR(binding_1162);
						   aux_1614 =
						      (node_bglt) (aux_1615);
						}
						arg1660_1163 =
						   node_cond__1_reduce_cond(aux_1614);
					     }
					     {	/* ./Ieee/pair-list.scm 5896 */
						obj_t aux_1619;
						aux_1619 =
						   (obj_t) (arg1660_1163);
						SET_CDR(binding_1162, aux_1619);
					     }
					  }
				       }
				       {
					  obj_t l1455_1622;
					  l1455_1622 =
					     CDR(l1455_1158);
					  l1455_1158 = l1455_1622;
					  goto lname1456_1159;
				       }
				    }
				  else
				    {	/* Reduce/cond.scm 186 */
				       ((bool_t) 1);
				    }
			       }
			       {	/* Reduce/cond.scm 189 */
				  node_bglt arg1663_1166;
				  arg1663_1166 =
				     node_cond__1_reduce_cond(
				     (((let_var_6_bglt) CREF(node_1156))->body));
				  ((((let_var_6_bglt) CREF(node_1156))->body) = ((node_bglt) arg1663_1166), BUNSPEC);
			       }
			       aux_1468 =
				  (obj_t) (node_1156);
			    }
			    break;
			 case ((long) 16):

			    {	/* Reduce/cond.scm 196 */
			       set_ex_it_116_bglt node_1168;
			       node_1168 =
				  (set_ex_it_116_bglt) (node_2);
			       {	/* Reduce/cond.scm 197 */
				  node_bglt arg1665_1170;
				  arg1665_1170 =
				     node_cond__1_reduce_cond(
				     (((set_ex_it_116_bglt) CREF(node_1168))->body));
				  ((((set_ex_it_116_bglt) CREF(node_1168))->body) = ((node_bglt) arg1665_1170), BUNSPEC);
			       }
			       {	/* Reduce/cond.scm 198 */
				  node_bglt arg1667_1172;
				  {	/* Reduce/cond.scm 198 */
				     node_bglt aux_1633;
				     {	/* Reduce/cond.scm 198 */
					var_bglt aux_1634;
					aux_1634 =
					   (((set_ex_it_116_bglt) CREF(node_1168))->var);
					aux_1633 =
					   (node_bglt) (aux_1634);
				     }
				     arg1667_1172 =
					node_cond__1_reduce_cond(aux_1633);
				  }
				  {	/* Reduce/cond.scm 198 */
				     var_bglt val1384_1323;
				     val1384_1323 =
					(var_bglt) (arg1667_1172);
				     ((((set_ex_it_116_bglt) CREF(node_1168))->var) = ((var_bglt) val1384_1323), BUNSPEC);
				  }
			       }
			       aux_1468 =
				  (obj_t) (node_1168);
			    }
			    break;
			 case ((long) 17):

			    {	/* Reduce/cond.scm 205 */
			       jump_ex_it_184_bglt node_1174;
			       node_1174 =
				  (jump_ex_it_184_bglt) (node_2);
			       {	/* Reduce/cond.scm 206 */
				  node_bglt arg1670_1176;
				  arg1670_1176 =
				     node_cond__1_reduce_cond(
				     (((jump_ex_it_184_bglt) CREF(node_1174))->exit));
				  ((((jump_ex_it_184_bglt) CREF(node_1174))->exit) = ((node_bglt) arg1670_1176), BUNSPEC);
			       }
			       {	/* Reduce/cond.scm 207 */
				  node_bglt arg1672_1178;
				  arg1672_1178 =
				     node_cond__1_reduce_cond(
				     (((jump_ex_it_184_bglt) CREF(node_1174))->value));
				  ((((jump_ex_it_184_bglt) CREF(node_1174))->value) = ((node_bglt) arg1672_1178), BUNSPEC);
			       }
			       aux_1468 =
				  (obj_t) (node_1174);
			    }
			    break;
			 case ((long) 18):

			    {	/* Reduce/cond.scm 214 */
			       make_box_202_bglt node_1180;
			       node_1180 =
				  (make_box_202_bglt) (node_2);
			       {	/* Reduce/cond.scm 215 */
				  node_bglt arg1674_1182;
				  arg1674_1182 =
				     node_cond__1_reduce_cond(
				     (((make_box_202_bglt) CREF(node_1180))->value));
				  ((((make_box_202_bglt) CREF(node_1180))->value) = ((node_bglt) arg1674_1182), BUNSPEC);
			       }
			       aux_1468 =
				  (obj_t) (node_1180);
			    }
			    break;
			 case ((long) 19):

			    {	/* Reduce/cond.scm 222 */
			       box_set__221_bglt node_1184;
			       node_1184 =
				  (box_set__221_bglt) (node_2);
			       {	/* Reduce/cond.scm 223 */
				  node_bglt arg1676_1186;
				  {	/* Reduce/cond.scm 223 */
				     node_bglt aux_1655;
				     {	/* Reduce/cond.scm 223 */
					var_bglt aux_1656;
					aux_1656 =
					   (((box_set__221_bglt) CREF(node_1184))->var);
					aux_1655 =
					   (node_bglt) (aux_1656);
				     }
				     arg1676_1186 =
					node_cond__1_reduce_cond(aux_1655);
				  }
				  {	/* Reduce/cond.scm 223 */
				     var_bglt val1428_1335;
				     val1428_1335 =
					(var_bglt) (arg1676_1186);
				     ((((box_set__221_bglt) CREF(node_1184))->var) = ((var_bglt) val1428_1335), BUNSPEC);
				  }
			       }
			       {	/* Reduce/cond.scm 224 */
				  node_bglt arg1678_1188;
				  arg1678_1188 =
				     node_cond__1_reduce_cond(
				     (((box_set__221_bglt) CREF(node_1184))->value));
				  ((((box_set__221_bglt) CREF(node_1184))->value) = ((node_bglt) arg1678_1188), BUNSPEC);
			       }
			       aux_1468 =
				  (obj_t) (node_1184);
			    }
			    break;
			 case ((long) 20):

			    {	/* Reduce/cond.scm 231 */
			       box_ref_242_bglt node_1190;
			       node_1190 =
				  (box_ref_242_bglt) (node_2);
			       {	/* Reduce/cond.scm 232 */
				  node_bglt arg1680_1192;
				  {	/* Reduce/cond.scm 232 */
				     node_bglt aux_1667;
				     {	/* Reduce/cond.scm 232 */
					var_bglt aux_1668;
					aux_1668 =
					   (((box_ref_242_bglt) CREF(node_1190))->var);
					aux_1667 =
					   (node_bglt) (aux_1668);
				     }
				     arg1680_1192 =
					node_cond__1_reduce_cond(aux_1667);
				  }
				  {	/* Reduce/cond.scm 232 */
				     var_bglt val1418_1341;
				     val1418_1341 =
					(var_bglt) (arg1680_1192);
				     ((((box_ref_242_bglt) CREF(node_1190))->var) = ((var_bglt) val1418_1341), BUNSPEC);
				  }
			       }
			       aux_1468 =
				  (obj_t) (node_1190);
			    }
			    break;
			 default:
			  case_else1606_1075:
			    if (
			       PROCEDUREP(method1600_1071))
			      {		/* Reduce/cond.scm 46 */
				 aux_1468 =
				    PROCEDURE_ENTRY(method1600_1071) (method1600_1071,
				    (obj_t) (node_2), BEOA)
				    ;
			      }
			    else
			      {		/* Reduce/cond.scm 46 */
				 obj_t fun1599_1067;
				 fun1599_1067 =
				    PROCEDURE_REF(node_cond__env_233_reduce_cond, ((long) 0));
				 aux_1468 =
				    PROCEDURE_ENTRY(fun1599_1067) (fun1599_1067,
				    (obj_t) (node_2), BEOA);
			      }
			 }
		    }
		  else
		    {	/* Reduce/cond.scm 46 */
		       goto case_else1606_1075;
		    }
	       }
	       return
		  (node_bglt) (aux_1468);
	    }
	 }
      }
   }
}



/* _node-cond!1688 */
obj_t 
_node_cond_1688_254_reduce_cond(obj_t env_1349, obj_t node_1350)
{
   AN_OBJECT;
   {	/* Reduce/cond.scm 46 */
      {		/* Reduce/cond.scm 46 */
	 node_bglt aux_1687;
	 aux_1687 =
	    node_cond__1_reduce_cond(
	    (node_bglt) (node_1350));
	 return
	    (obj_t) (aux_1687);
      }
   }
}



/* node-cond!-default1462 */
node_bglt 
node_cond__default1462_197_reduce_cond(node_bglt node_3)
{
   AN_OBJECT;
   {	/* Reduce/cond.scm 14 */
      FAILURE(
	 CNST_TABLE_REF(((long) 1)), string1691_reduce_cond,
	 (obj_t) (node_3));
   }
}



/* _node-cond!-default1462 */
obj_t 
_node_cond__default1462_181_reduce_cond(obj_t env_1351, obj_t node_1352)
{
   AN_OBJECT;
   {	/* Reduce/cond.scm 14 */
      {		/* Reduce/cond.scm 14 */
	 node_bglt aux_1694;
	 aux_1694 =
	    node_cond__default1462_197_reduce_cond(
	    (node_bglt) (node_1352));
	 return
	    (obj_t) (aux_1694);
      }
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_reduce_cond()
{
   AN_OBJECT;
   {	/* Reduce/cond.scm 14 */
      module_initialization_70_tools_trace(((long) 0), "REDUCE_COND");
      module_initialization_70_tools_shape(((long) 0), "REDUCE_COND");
      module_initialization_70_tools_speek(((long) 0), "REDUCE_COND");
      module_initialization_70_tools_error(((long) 0), "REDUCE_COND");
      module_initialization_70_type_type(((long) 0), "REDUCE_COND");
      module_initialization_70_ast_var(((long) 0), "REDUCE_COND");
      return
	 module_initialization_70_ast_node(((long) 0), "REDUCE_COND");
   }
}
