/*===========================================================================*/
/*   (Reduce/copy.scm)                                                       */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;


static obj_t method_init_76_reduce_copy();
extern obj_t make_box_202_ast_node;
extern obj_t funcall_ast_node;
static node_bglt node_copy__default1461_109_reduce_copy(node_bglt);
extern long add_inlined_method__244___object(obj_t, obj_t, long);
extern obj_t fail_ast_node;
extern obj_t box_ref_242_ast_node;
extern obj_t sequence_ast_node;
extern obj_t let_var_6_ast_node;
extern obj_t var_ast_node;
extern obj_t closure_ast_node;
extern obj_t reduce_copy__103_reduce_copy(obj_t);
extern obj_t pragma_ast_node;
extern obj_t set_ex_it_116_ast_node;
extern obj_t verbose_tools_speek(obj_t, obj_t);
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t module_initialization_70_reduce_copy(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_speek(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_coerce_typeof(long, char *);
extern obj_t module_initialization_70_coerce_coerce(long, char *);
extern obj_t module_initialization_70_effect_effect(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_ast_lvtype(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t let_fun_218_ast_node;
static obj_t imported_modules_init_94_reduce_copy();
static obj_t _reduce_copy__94_reduce_copy(obj_t, obj_t);
extern obj_t app_ly_162_ast_node;
extern obj_t add_generic__110___object(obj_t, obj_t);
extern obj_t app_ast_node;
static obj_t library_modules_init_112_reduce_copy();
static obj_t _node_copy__default1461_43_reduce_copy(obj_t, obj_t);
extern obj_t atom_ast_node;
extern obj_t cast_ast_node;
static obj_t toplevel_init_63_reduce_copy();
extern obj_t jump_ex_it_184_ast_node;
extern obj_t open_input_string(obj_t);
extern obj_t kwote_ast_node;
extern obj_t setq_ast_node;
extern obj_t box_set__221_ast_node;
static node_bglt node_copy__175_reduce_copy(node_bglt);
static obj_t node_copy___108_reduce_copy(obj_t);
extern obj_t _classes__134___object;
extern obj_t select_ast_node;
extern obj_t read___reader(obj_t);
static obj_t _node_copy_1698_111_reduce_copy(obj_t, obj_t);
static obj_t require_initialization_114_reduce_copy = BUNSPEC;
extern obj_t conditional_ast_node;
static long _copy_removed__156_reduce_copy;
static obj_t cnst_init_137_reduce_copy();
static obj_t __cnst[3];

DEFINE_EXPORT_PROCEDURE(reduce_copy__env_21_reduce_copy, _reduce_copy__94_reduce_copy1707, _reduce_copy__94_reduce_copy, 0L, 1);
DEFINE_STATIC_GENERIC(node_copy__env_176_reduce_copy, _node_copy_1698_111_reduce_copy1708, _node_copy_1698_111_reduce_copy, 0L, 1);
DEFINE_STRING(string1699_reduce_copy, string1699_reduce_copy1709, "      copy propagation       ", 29);
DEFINE_STRING(string1702_reduce_copy, string1702_reduce_copy1710, "NODE-COPY!-DEFAULT1461 READ DONE ", 33);
DEFINE_STRING(string1701_reduce_copy, string1701_reduce_copy1711, "No method for this object", 25);
DEFINE_STRING(string1700_reduce_copy, string1700_reduce_copy1712, "(removed : ", 11);
DEFINE_STATIC_PROCEDURE(node_copy__default1461_env_45_reduce_copy, _node_copy__default1461_43_reduce_copy1713, _node_copy__default1461_43_reduce_copy, 0L, 1);



/* module-initialization */
obj_t 
module_initialization_70_reduce_copy(long checksum_1397, char *from_1398)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_reduce_copy))
	{
	   require_initialization_114_reduce_copy =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_reduce_copy();
	   cnst_init_137_reduce_copy();
	   imported_modules_init_94_reduce_copy();
	   method_init_76_reduce_copy();
	   toplevel_init_63_reduce_copy();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_reduce_copy()
{
   AN_OBJECT;
   {	/* Reduce/copy.scm 14 */
      module_initialization_70___object(((long) 0), "REDUCE_COPY");
      module_initialization_70___reader(((long) 0), "REDUCE_COPY");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_reduce_copy()
{
   AN_OBJECT;
   {	/* Reduce/copy.scm 14 */
      {		/* Reduce/copy.scm 14 */
	 obj_t cnst_port_138_1390;
	 cnst_port_138_1390 =
	    open_input_string(string1702_reduce_copy);
	 {
	    long i_1391;
	    i_1391 = ((long) 2);
	  loop_1392:
	    {	/* Reduce/copy.scm 14 */
	       bool_t test1703_1393;
	       test1703_1393 =
		  (i_1391 == ((long) -1));
	       if (test1703_1393)
		 {	/* Reduce/copy.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Reduce/copy.scm 14 */
		    {	/* Reduce/copy.scm 14 */
		       obj_t arg1704_1394;
		       {	/* Reduce/copy.scm 14 */
			  obj_t list1705_1395;
			  list1705_1395 =
			     MAKE_PAIR(cnst_port_138_1390, BNIL);
			  arg1704_1394 =
			     read___reader(list1705_1395);
		       }
		       CNST_TABLE_SET(i_1391, arg1704_1394);
		    }
		    {	/* Reduce/copy.scm 14 */
		       int aux_1396;
		       {	/* Reduce/copy.scm 14 */
			  long aux_1415;
			  aux_1415 =
			     (i_1391 - ((long) 1));
			  aux_1396 =
			     (int) (aux_1415);
		       }
		       {
			  long i_1418;
			  i_1418 =
			     (long) (aux_1396);
			  i_1391 = i_1418;
			  goto loop_1392;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_reduce_copy()
{
   AN_OBJECT;
   {	/* Reduce/copy.scm 14 */
      _copy_removed__156_reduce_copy = ((long) 0);
      return BUNSPEC;
   }
}



/* reduce-copy! */
obj_t 
reduce_copy__103_reduce_copy(obj_t globals_1)
{
   AN_OBJECT;
   {	/* Reduce/copy.scm 32 */
      {		/* Reduce/copy.scm 33 */
	 obj_t list1504_721;
	 list1504_721 =
	    MAKE_PAIR(string1699_reduce_copy, BNIL);
	 verbose_tools_speek(
	    BINT(((long) 2)), list1504_721);
      }
      _copy_removed__156_reduce_copy = ((long) 0);
      {
	 obj_t l1437_722;
	 l1437_722 = globals_1;
       lname1438_723:
	 if (
	    PAIRP(l1437_722))
	   {	/* Reduce/copy.scm 35 */
	      {		/* Reduce/copy.scm 36 */
		 value_bglt fun_726;
		 {	/* Reduce/copy.scm 36 */
		    global_bglt obj_1222;
		    {	/* Reduce/copy.scm 36 */
		       obj_t aux_1425;
		       aux_1425 =
			  CAR(l1437_722);
		       obj_1222 =
			  (global_bglt) (aux_1425);
		    }
		    fun_726 =
		       (((global_bglt) CREF(obj_1222))->value);
		 }
		 {	/* Reduce/copy.scm 37 */

		    {	/* Reduce/copy.scm 38 */
		       node_bglt arg1506_728;
		       {	/* Reduce/copy.scm 38 */
			  node_bglt aux_1429;
			  {	/* Reduce/copy.scm 38 */
			     obj_t aux_1430;
			     {	/* Reduce/copy.scm 37 */
				sfun_bglt obj_1223;
				obj_1223 =
				   (sfun_bglt) (fun_726);
				aux_1430 =
				   (((sfun_bglt) CREF(obj_1223))->body);
			     }
			     aux_1429 =
				(node_bglt) (aux_1430);
			  }
			  arg1506_728 =
			     node_copy__175_reduce_copy(aux_1429);
		       }
		       {	/* Reduce/copy.scm 38 */
			  sfun_bglt obj_1224;
			  obj_t val1123_1225;
			  obj_1224 =
			     (sfun_bglt) (fun_726);
			  val1123_1225 =
			     (obj_t) (arg1506_728);
			  ((((sfun_bglt) CREF(obj_1224))->body) = ((obj_t) val1123_1225), BUNSPEC);
		       }
		    }
		    BUNSPEC;
		 }
	      }
	      {
		 obj_t l1437_1438;
		 l1437_1438 =
		    CDR(l1437_722);
		 l1437_722 = l1437_1438;
		 goto lname1438_723;
	      }
	   }
	 else
	   {	/* Reduce/copy.scm 35 */
	      ((bool_t) 1);
	   }
      }
      {		/* Reduce/copy.scm 41 */
	 obj_t list1509_730;
	 {	/* Reduce/copy.scm 41 */
	    obj_t arg1511_732;
	    {	/* Reduce/copy.scm 41 */
	       obj_t arg1512_733;
	       {	/* Reduce/copy.scm 41 */
		  obj_t arg1513_734;
		  {	/* Reduce/copy.scm 41 */
		     obj_t aux_1440;
		     aux_1440 =
			BCHAR(((unsigned char) '\n'));
		     arg1513_734 =
			MAKE_PAIR(aux_1440, BNIL);
		  }
		  {	/* Reduce/copy.scm 41 */
		     obj_t aux_1443;
		     aux_1443 =
			BCHAR(((unsigned char) ')'));
		     arg1512_733 =
			MAKE_PAIR(aux_1443, arg1513_734);
		  }
	       }
	       {	/* Reduce/copy.scm 41 */
		  obj_t aux_1446;
		  aux_1446 =
		     BINT(_copy_removed__156_reduce_copy);
		  arg1511_732 =
		     MAKE_PAIR(aux_1446, arg1512_733);
	       }
	    }
	    list1509_730 =
	       MAKE_PAIR(string1700_reduce_copy, arg1511_732);
	 }
	 verbose_tools_speek(
	    BINT(((long) 2)), list1509_730);
      }
      return globals_1;
   }
}



/* _reduce-copy! */
obj_t 
_reduce_copy__94_reduce_copy(obj_t env_1384, obj_t globals_1385)
{
   AN_OBJECT;
   {	/* Reduce/copy.scm 32 */
      return
	 reduce_copy__103_reduce_copy(globals_1385);
   }
}



/* node-copy*! */
obj_t 
node_copy___108_reduce_copy(obj_t node__221_25)
{
   AN_OBJECT;
   {	/* Reduce/copy.scm 270 */
      {
	 obj_t node__221_735;
	 node__221_735 = node__221_25;
       loop_736:
	 if (
	    NULLP(node__221_735))
	   {	/* Reduce/copy.scm 272 */
	      return
		 CNST_TABLE_REF(((long) 0));
	   }
	 else
	   {	/* Reduce/copy.scm 272 */
	      {		/* Reduce/copy.scm 275 */
		 node_bglt arg1515_738;
		 {	/* Reduce/copy.scm 275 */
		    node_bglt aux_1456;
		    {	/* Reduce/copy.scm 275 */
		       obj_t aux_1457;
		       aux_1457 =
			  CAR(node__221_735);
		       aux_1456 =
			  (node_bglt) (aux_1457);
		    }
		    arg1515_738 =
		       node_copy__175_reduce_copy(aux_1456);
		 }
		 {	/* ./Ieee/pair-list.scm 5890 */
		    obj_t aux_1461;
		    aux_1461 =
		       (obj_t) (arg1515_738);
		    SET_CAR(node__221_735, aux_1461);
		 }
	      }
	      {
		 obj_t node__221_1464;
		 node__221_1464 =
		    CDR(node__221_735);
		 node__221_735 = node__221_1464;
		 goto loop_736;
	      }
	   }
      }
   }
}



/* method-init */
obj_t 
method_init_76_reduce_copy()
{
   AN_OBJECT;
   {	/* Reduce/copy.scm 14 */
      add_generic__110___object(node_copy__env_176_reduce_copy, node_copy__default1461_env_45_reduce_copy);
      add_inlined_method__244___object(node_copy__env_176_reduce_copy, atom_ast_node, ((long) 0));
      add_inlined_method__244___object(node_copy__env_176_reduce_copy, kwote_ast_node, ((long) 1));
      add_inlined_method__244___object(node_copy__env_176_reduce_copy, var_ast_node, ((long) 2));
      add_inlined_method__244___object(node_copy__env_176_reduce_copy, closure_ast_node, ((long) 3));
      add_inlined_method__244___object(node_copy__env_176_reduce_copy, sequence_ast_node, ((long) 4));
      add_inlined_method__244___object(node_copy__env_176_reduce_copy, app_ly_162_ast_node, ((long) 5));
      add_inlined_method__244___object(node_copy__env_176_reduce_copy, funcall_ast_node, ((long) 6));
      add_inlined_method__244___object(node_copy__env_176_reduce_copy, pragma_ast_node, ((long) 7));
      add_inlined_method__244___object(node_copy__env_176_reduce_copy, cast_ast_node, ((long) 8));
      add_inlined_method__244___object(node_copy__env_176_reduce_copy, setq_ast_node, ((long) 9));
      add_inlined_method__244___object(node_copy__env_176_reduce_copy, conditional_ast_node, ((long) 10));
      add_inlined_method__244___object(node_copy__env_176_reduce_copy, fail_ast_node, ((long) 11));
      add_inlined_method__244___object(node_copy__env_176_reduce_copy, select_ast_node, ((long) 12));
      add_inlined_method__244___object(node_copy__env_176_reduce_copy, let_fun_218_ast_node, ((long) 13));
      add_inlined_method__244___object(node_copy__env_176_reduce_copy, let_var_6_ast_node, ((long) 14));
      add_inlined_method__244___object(node_copy__env_176_reduce_copy, set_ex_it_116_ast_node, ((long) 15));
      add_inlined_method__244___object(node_copy__env_176_reduce_copy, jump_ex_it_184_ast_node, ((long) 16));
      add_inlined_method__244___object(node_copy__env_176_reduce_copy, make_box_202_ast_node, ((long) 17));
      add_inlined_method__244___object(node_copy__env_176_reduce_copy, box_set__221_ast_node, ((long) 18));
      add_inlined_method__244___object(node_copy__env_176_reduce_copy, box_ref_242_ast_node, ((long) 19));
      {		/* Reduce/copy.scm 14 */
	 long aux_1487;
	 aux_1487 =
	    add_inlined_method__244___object(node_copy__env_176_reduce_copy, app_ast_node, ((long) 20));
	 return
	    BINT(aux_1487);
      }
   }
}



/* node-copy! */
node_bglt 
node_copy__175_reduce_copy(node_bglt node_2)
{
   AN_OBJECT;
   {	/* Reduce/copy.scm 53 */
      {
	 obj_t method1599_1071;
	 obj_t class1604_1072;
	 {	/* Reduce/copy.scm 53 */
	    obj_t arg1607_1069;
	    obj_t arg1608_1070;
	    {	/* Reduce/copy.scm 53 */
	       object_bglt obj_1232;
	       obj_1232 =
		  (object_bglt) (node_2);
	       {	/* ./Llib/object.scm 2926 */
		  obj_t pre_method_105_1233;
		  pre_method_105_1233 =
		     PROCEDURE_REF(node_copy__env_176_reduce_copy, ((long) 2));
		  if (
		     INTEGERP(pre_method_105_1233))
		    {	/* ./Llib/object.scm 2927 */
		       PROCEDURE_SET(node_copy__env_176_reduce_copy, ((long) 2), BUNSPEC);
		       arg1607_1069 = pre_method_105_1233;
		    }
		  else
		    {	/* ./Llib/object.scm 2914 */
		       long obj_class_num_177_1238;
		       obj_class_num_177_1238 =
			  TYPE(obj_1232);
		       {	/* ./Llib/object.scm 2915 */
			  obj_t arg1176_1239;
			  arg1176_1239 =
			     PROCEDURE_REF(node_copy__env_176_reduce_copy, ((long) 1));
			  {	/* ./Llib/object.scm 2738 */
			     long arg1177_1243;
			     {	/* ./Llib/object.scm 2738 */
				long arg1178_1244;
				arg1178_1244 =
				   OBJECT_TYPE;
				arg1177_1243 =
				   (obj_class_num_177_1238 - arg1178_1244);
			     }
			     arg1607_1069 =
				VECTOR_REF(arg1176_1239, arg1177_1243);
			  }
		       }
		    }
	       }
	    }
	    {	/* Reduce/copy.scm 53 */
	       object_bglt object_1249;
	       object_1249 =
		  (object_bglt) (node_2);
	       {	/* ./Llib/object.scm 2695 */
		  long arg1179_1250;
		  {	/* ./Llib/object.scm 2695 */
		     long arg1180_1251;
		     long arg1181_1252;
		     arg1180_1251 =
			TYPE(object_1249);
		     arg1181_1252 =
			OBJECT_TYPE;
		     arg1179_1250 =
			(arg1180_1251 - arg1181_1252);
		  }
		  {	/* ./Llib/object.scm 2695 */
		     obj_t vector_1256;
		     vector_1256 = _classes__134___object;
		     arg1608_1070 =
			VECTOR_REF(vector_1256, arg1179_1250);
		  }
	       }
	    }
	    {	/* Reduce/copy.scm 53 */
	       obj_t aux_1505;
	       method1599_1071 = arg1607_1069;
	       class1604_1072 = arg1608_1070;
	       {

		  if (
		     INTEGERP(method1599_1071))
		    {	/* Reduce/copy.scm 53 */
		       switch (
			  (long) CINT(method1599_1071))
			 {
			 case ((long) 0):

			    {	/* Reduce/copy.scm 53 */
			       atom_bglt aux_1508;
			       aux_1508 =
				  (atom_bglt) (node_2);
			       aux_1505 =
				  (obj_t) (aux_1508);
			    }
			    break;
			 case ((long) 1):

			    {	/* Reduce/copy.scm 53 */
			       kwote_bglt aux_1511;
			       aux_1511 =
				  (kwote_bglt) (node_2);
			       aux_1505 =
				  (obj_t) (aux_1511);
			    }
			    break;
			 case ((long) 2):

			    {	/* Reduce/copy.scm 71 */
			       var_bglt node_1080;
			       node_1080 =
				  (var_bglt) (node_2);
			       {	/* Reduce/copy.scm 71 */
				  variable_bglt v_1081;
				  v_1081 =
				     (((var_bglt) CREF(node_1080))->variable);
				  {	/* Reduce/copy.scm 72 */
				     obj_t falpha_1082;
				     falpha_1082 =
					(((variable_bglt) CREF(v_1081))->fast_alpha_7);
				     if (
					(falpha_1082 == BUNSPEC))
				       {	/* Reduce/copy.scm 73 */
					  aux_1505 =
					     (obj_t) (node_1080)
					     ;
				       }
				     else
				       {	/* Reduce/copy.scm 74 */
					  node_bglt aux_1520;
					  aux_1520 =
					     node_copy__175_reduce_copy(
					     (node_bglt) (falpha_1082));
					  aux_1505 =
					     (obj_t) (aux_1520);
				       }
				  }
			       }
			    }
			    break;
			 case ((long) 3):

			    {	/* Reduce/copy.scm 53 */
			       closure_bglt aux_1524;
			       aux_1524 =
				  (closure_bglt) (node_2);
			       aux_1505 =
				  (obj_t) (aux_1524);
			    }
			    break;
			 case ((long) 4):

			    {	/* Reduce/copy.scm 87 */
			       sequence_bglt node_1085;
			       node_1085 =
				  (sequence_bglt) (node_2);
			       node_copy___108_reduce_copy(
				  (((sequence_bglt) CREF(node_1085))->nodes));
			       aux_1505 =
				  (obj_t) (node_1085);
			    }
			    break;
			 case ((long) 5):

			    {	/* Reduce/copy.scm 95 */
			       app_ly_162_bglt node_1088;
			       node_1088 =
				  (app_ly_162_bglt) (node_2);
			       {	/* Reduce/copy.scm 96 */
				  node_bglt arg1613_1090;
				  arg1613_1090 =
				     node_copy__175_reduce_copy(
				     (((app_ly_162_bglt) CREF(node_1088))->fun));
				  ((((app_ly_162_bglt) CREF(node_1088))->fun) = ((node_bglt) arg1613_1090), BUNSPEC);
			       }
			       {	/* Reduce/copy.scm 97 */
				  node_bglt arg1615_1092;
				  arg1615_1092 =
				     node_copy__175_reduce_copy(
				     (((app_ly_162_bglt) CREF(node_1088))->arg));
				  ((((app_ly_162_bglt) CREF(node_1088))->arg) = ((node_bglt) arg1615_1092), BUNSPEC);
			       }
			       aux_1505 =
				  (obj_t) (node_1088);
			    }
			    break;
			 case ((long) 6):

			    {	/* Reduce/copy.scm 104 */
			       funcall_bglt node_1094;
			       node_1094 =
				  (funcall_bglt) (node_2);
			       {	/* Reduce/copy.scm 105 */
				  node_bglt arg1617_1096;
				  arg1617_1096 =
				     node_copy__175_reduce_copy(
				     (((funcall_bglt) CREF(node_1094))->fun));
				  ((((funcall_bglt) CREF(node_1094))->fun) = ((node_bglt) arg1617_1096), BUNSPEC);
			       }
			       node_copy___108_reduce_copy(
				  (((funcall_bglt) CREF(node_1094))->args));
			       aux_1505 =
				  (obj_t) (node_1094);
			    }
			    break;
			 case ((long) 7):

			    {	/* Reduce/copy.scm 113 */
			       pragma_bglt node_1099;
			       node_1099 =
				  (pragma_bglt) (node_2);
			       node_copy___108_reduce_copy(
				  (((pragma_bglt) CREF(node_1099))->args));
			       aux_1505 =
				  (obj_t) (node_1099);
			    }
			    break;
			 case ((long) 8):

			    {	/* Reduce/copy.scm 121 */
			       cast_bglt node_1102;
			       node_1102 =
				  (cast_bglt) (node_2);
			       {	/* Reduce/copy.scm 122 */
				  node_bglt arg1621_1104;
				  arg1621_1104 =
				     node_copy__175_reduce_copy(
				     (((cast_bglt) CREF(node_1102))->arg));
				  ((((cast_bglt) CREF(node_1102))->arg) = ((node_bglt) arg1621_1104), BUNSPEC);
			       }
			       aux_1505 =
				  (obj_t) (node_1102);
			    }
			    break;
			 case ((long) 9):

			    {	/* Reduce/copy.scm 129 */
			       setq_bglt node_1106;
			       node_1106 =
				  (setq_bglt) (node_2);
			       {	/* Reduce/copy.scm 130 */
				  node_bglt arg1623_1108;
				  arg1623_1108 =
				     node_copy__175_reduce_copy(
				     (((setq_bglt) CREF(node_1106))->value));
				  ((((setq_bglt) CREF(node_1106))->value) = ((node_bglt) arg1623_1108), BUNSPEC);
			       }
			       {	/* Reduce/copy.scm 131 */
				  node_bglt arg1625_1110;
				  {	/* Reduce/copy.scm 131 */
				     node_bglt aux_1559;
				     {	/* Reduce/copy.scm 131 */
					var_bglt aux_1560;
					aux_1560 =
					   (((setq_bglt) CREF(node_1106))->var);
					aux_1559 =
					   (node_bglt) (aux_1560);
				     }
				     arg1625_1110 =
					node_copy__175_reduce_copy(aux_1559);
				  }
				  {	/* Reduce/copy.scm 131 */
				     var_bglt val1302_1282;
				     val1302_1282 =
					(var_bglt) (arg1625_1110);
				     ((((setq_bglt) CREF(node_1106))->var) = ((var_bglt) val1302_1282), BUNSPEC);
				  }
			       }
			       aux_1505 =
				  (obj_t) (node_1106);
			    }
			    break;
			 case ((long) 10):

			    {	/* Reduce/copy.scm 138 */
			       conditional_bglt node_1112;
			       node_1112 =
				  (conditional_bglt) (node_2);
			       {	/* Reduce/copy.scm 139 */
				  node_bglt arg1627_1114;
				  arg1627_1114 =
				     node_copy__175_reduce_copy(
				     (((conditional_bglt) CREF(node_1112))->test));
				  ((((conditional_bglt) CREF(node_1112))->test) = ((node_bglt) arg1627_1114), BUNSPEC);
			       }
			       {	/* Reduce/copy.scm 140 */
				  node_bglt arg1629_1116;
				  arg1629_1116 =
				     node_copy__175_reduce_copy(
				     (((conditional_bglt) CREF(node_1112))->true));
				  ((((conditional_bglt) CREF(node_1112))->true) = ((node_bglt) arg1629_1116), BUNSPEC);
			       }
			       {	/* Reduce/copy.scm 141 */
				  node_bglt arg1631_1118;
				  arg1631_1118 =
				     node_copy__175_reduce_copy(
				     (((conditional_bglt) CREF(node_1112))->false));
				  ((((conditional_bglt) CREF(node_1112))->false) = ((node_bglt) arg1631_1118), BUNSPEC);
			       }
			       aux_1505 =
				  (obj_t) (node_1112);
			    }
			    break;
			 case ((long) 11):

			    {	/* Reduce/copy.scm 148 */
			       fail_bglt node_1120;
			       node_1120 =
				  (fail_bglt) (node_2);
			       {	/* Reduce/copy.scm 149 */
				  node_bglt arg1633_1122;
				  arg1633_1122 =
				     node_copy__175_reduce_copy(
				     (((fail_bglt) CREF(node_1120))->proc));
				  ((((fail_bglt) CREF(node_1120))->proc) = ((node_bglt) arg1633_1122), BUNSPEC);
			       }
			       {	/* Reduce/copy.scm 150 */
				  node_bglt arg1635_1124;
				  arg1635_1124 =
				     node_copy__175_reduce_copy(
				     (((fail_bglt) CREF(node_1120))->msg));
				  ((((fail_bglt) CREF(node_1120))->msg) = ((node_bglt) arg1635_1124), BUNSPEC);
			       }
			       {	/* Reduce/copy.scm 151 */
				  node_bglt arg1637_1126;
				  arg1637_1126 =
				     node_copy__175_reduce_copy(
				     (((fail_bglt) CREF(node_1120))->obj));
				  ((((fail_bglt) CREF(node_1120))->obj) = ((node_bglt) arg1637_1126), BUNSPEC);
			       }
			       aux_1505 =
				  (obj_t) (node_1120);
			    }
			    break;
			 case ((long) 12):

			    {	/* Reduce/copy.scm 158 */
			       select_bglt node_1128;
			       node_1128 =
				  (select_bglt) (node_2);
			       {	/* Reduce/copy.scm 159 */
				  node_bglt arg1639_1130;
				  arg1639_1130 =
				     node_copy__175_reduce_copy(
				     (((select_bglt) CREF(node_1128))->test));
				  ((((select_bglt) CREF(node_1128))->test) = ((node_bglt) arg1639_1130), BUNSPEC);
			       }
			       {
				  obj_t l1448_1132;
				  l1448_1132 =
				     (((select_bglt) CREF(node_1128))->clauses);
				lname1449_1133:
				  if (
				     PAIRP(l1448_1132))
				    {	/* Reduce/copy.scm 160 */
				       {	/* Reduce/copy.scm 161 */
					  obj_t clause_1136;
					  clause_1136 =
					     CAR(l1448_1132);
					  {	/* Reduce/copy.scm 161 */
					     node_bglt arg1643_1137;
					     {	/* Reduce/copy.scm 161 */
						node_bglt aux_1596;
						{	/* Reduce/copy.scm 161 */
						   obj_t aux_1597;
						   aux_1597 =
						      CDR(clause_1136);
						   aux_1596 =
						      (node_bglt) (aux_1597);
						}
						arg1643_1137 =
						   node_copy__175_reduce_copy(aux_1596);
					     }
					     {	/* ./Ieee/pair-list.scm 5896 */
						obj_t aux_1601;
						aux_1601 =
						   (obj_t) (arg1643_1137);
						SET_CDR(clause_1136, aux_1601);
					     }
					  }
				       }
				       {
					  obj_t l1448_1604;
					  l1448_1604 =
					     CDR(l1448_1132);
					  l1448_1132 = l1448_1604;
					  goto lname1449_1133;
				       }
				    }
				  else
				    {	/* Reduce/copy.scm 160 */
				       ((bool_t) 1);
				    }
			       }
			       aux_1505 =
				  (obj_t) (node_1128);
			    }
			    break;
			 case ((long) 13):

			    {	/* Reduce/copy.scm 169 */
			       let_fun_218_bglt node_1140;
			       node_1140 =
				  (let_fun_218_bglt) (node_2);
			       {
				  obj_t l1451_1142;
				  l1451_1142 =
				     (((let_fun_218_bglt) CREF(node_1140))->locals);
				lname1452_1143:
				  if (
				     PAIRP(l1451_1142))
				    {	/* Reduce/copy.scm 170 */
				       {	/* Reduce/copy.scm 171 */
					  value_bglt fun_1147;
					  {	/* Reduce/copy.scm 171 */
					     local_bglt obj_1314;
					     {	/* Reduce/copy.scm 171 */
						obj_t aux_1611;
						aux_1611 =
						   CAR(l1451_1142);
						obj_1314 =
						   (local_bglt) (aux_1611);
					     }
					     fun_1147 =
						(((local_bglt) CREF(obj_1314))->value);
					  }
					  {	/* Reduce/copy.scm 172 */
					     node_bglt arg1649_1148;
					     {	/* Reduce/copy.scm 172 */
						node_bglt aux_1615;
						{	/* Reduce/copy.scm 172 */
						   obj_t aux_1616;
						   {	/* Reduce/copy.scm 172 */
						      sfun_bglt obj_1315;
						      obj_1315 =
							 (sfun_bglt) (fun_1147);
						      aux_1616 =
							 (((sfun_bglt) CREF(obj_1315))->body);
						   }
						   aux_1615 =
						      (node_bglt) (aux_1616);
						}
						arg1649_1148 =
						   node_copy__175_reduce_copy(aux_1615);
					     }
					     {	/* Reduce/copy.scm 172 */
						sfun_bglt obj_1316;
						obj_t val1123_1317;
						obj_1316 =
						   (sfun_bglt) (fun_1147);
						val1123_1317 =
						   (obj_t) (arg1649_1148);
						((((sfun_bglt) CREF(obj_1316))->body) = ((obj_t) val1123_1317), BUNSPEC);
					     }
					  }
				       }
				       {
					  obj_t l1451_1624;
					  l1451_1624 =
					     CDR(l1451_1142);
					  l1451_1142 = l1451_1624;
					  goto lname1452_1143;
				       }
				    }
				  else
				    {	/* Reduce/copy.scm 170 */
				       ((bool_t) 1);
				    }
			       }
			       {	/* Reduce/copy.scm 174 */
				  node_bglt arg1652_1151;
				  arg1652_1151 =
				     node_copy__175_reduce_copy(
				     (((let_fun_218_bglt) CREF(node_1140))->body));
				  ((((let_fun_218_bglt) CREF(node_1140))->body) = ((node_bglt) arg1652_1151), BUNSPEC);
			       }
			       aux_1505 =
				  (obj_t) (node_1140);
			    }
			    break;
			 case ((long) 14):

			    {	/* Reduce/copy.scm 181 */
			       let_var_6_bglt node_1153;
			       node_1153 =
				  (let_var_6_bglt) (node_2);
			       {
				  obj_t obindings_1155;
				  obj_t nbindings_1156;
				  obindings_1155 =
				     (((let_var_6_bglt) CREF(node_1153))->bindings);
				  nbindings_1156 = BNIL;
				loop_1157:
				  if (
				     NULLP(obindings_1155))
				    {	/* Reduce/copy.scm 185 */
				       bool_t test_1634;
				       if (
					  NULLP(nbindings_1156))
					 {	/* Reduce/copy.scm 185 */
					    test_1634 =
					       (((let_var_6_bglt) CREF(node_1153))->removable__42)
					       ;
					 }
				       else
					 {	/* Reduce/copy.scm 185 */
					    test_1634 = ((bool_t) 0)
					       ;
					 }
				       if (test_1634)
					 {	/* Reduce/copy.scm 186 */
					    node_bglt aux_1638;
					    aux_1638 =
					       node_copy__175_reduce_copy(
					       (((let_var_6_bglt) CREF(node_1153))->body));
					    aux_1505 =
					       (obj_t) (aux_1638);
					 }
				       else
					 {	/* Reduce/copy.scm 185 */
					    ((((let_var_6_bglt) CREF(node_1153))->bindings) = ((obj_t) nbindings_1156), BUNSPEC);
					    {	/* Reduce/copy.scm 189 */
					       node_bglt arg1659_1163;
					       arg1659_1163 =
						  node_copy__175_reduce_copy(
						  (((let_var_6_bglt) CREF(node_1153))->body));
					       ((((let_var_6_bglt) CREF(node_1153))->body) = ((node_bglt) arg1659_1163), BUNSPEC);
					    }
					    aux_1505 =
					       (obj_t) (node_1153);
					 }
				    }
				  else
				    {	/* Reduce/copy.scm 191 */
				       obj_t binding_1166;
				       binding_1166 =
					  CAR(obindings_1155);
				       {	/* Reduce/copy.scm 191 */
					  obj_t var_1167;
					  var_1167 =
					     CAR(binding_1166);
					  {	/* Reduce/copy.scm 192 */
					     node_bglt val_1168;
					     {	/* Reduce/copy.scm 193 */
						node_bglt aux_1649;
						{	/* Reduce/copy.scm 193 */
						   obj_t aux_1650;
						   aux_1650 =
						      CDR(binding_1166);
						   aux_1649 =
						      (node_bglt) (aux_1650);
						}
						val_1168 =
						   node_copy__175_reduce_copy(aux_1649);
					     }
					     {	/* Reduce/copy.scm 193 */

						{	/* ./Ieee/pair-list.scm 5896 */
						   obj_t aux_1654;
						   aux_1654 =
						      (obj_t) (val_1168);
						   SET_CDR(binding_1166, aux_1654);
						}
						{	/* Reduce/copy.scm 203 */
						   bool_t test1662_1169;
						   {	/* Reduce/copy.scm 203 */
						      bool_t test1666_1173;
						      {		/* Reduce/copy.scm 203 */
							 bool_t test1670_1176;
							 test1670_1176 =
							    is_a__118___object(
							    (obj_t) (val_1168), atom_ast_node);
							 if (test1670_1176)
							   {	/* Reduce/copy.scm 203 */
							      test1666_1173 = ((bool_t) 1);
							   }
							 else
							   {	/* Reduce/copy.scm 204 */
							      bool_t _andtest_1454_1177;
							      _andtest_1454_1177 =
								 is_a__118___object(
								 (obj_t) (val_1168), var_ast_node);
							      if (_andtest_1454_1177)
								{	/* ./Ieee/equiv.scm 5508 */
								   obj_t aux_1667;
								   obj_t aux_1663;
								   aux_1667 =
								      CNST_TABLE_REF(((long) 1));
								   {	/* Reduce/copy.scm 205 */
								      variable_bglt arg1673_1180;
								      {		/* Reduce/copy.scm 205 */
									 var_bglt obj_1339;
									 obj_1339 =
									    (var_bglt) (val_1168);
									 arg1673_1180 =
									    (((var_bglt) CREF(obj_1339))->variable);
								      }
								      aux_1663 =
									 (((variable_bglt) CREF(arg1673_1180))->access);
								   }
								   test1666_1173 =
								      (aux_1663 == aux_1667);
								}
							      else
								{	/* Reduce/copy.scm 204 */
								   test1666_1173 = ((bool_t) 0);
								}
							   }
						      }
						      if (test1666_1173)
							{	/* ./Ieee/equiv.scm 5508 */
							   obj_t aux_1674;
							   obj_t aux_1671;
							   aux_1674 =
							      CNST_TABLE_REF(((long) 1));
							   {	/* Reduce/copy.scm 207 */
							      variable_bglt obj_1343;
							      obj_1343 =
								 (variable_bglt) (var_1167);
							      aux_1671 =
								 (((variable_bglt) CREF(obj_1343))->access);
							   }
							   test1662_1169 =
							      (aux_1671 == aux_1674);
							}
						      else
							{	/* Reduce/copy.scm 203 */
							   test1662_1169 = ((bool_t) 0);
							}
						   }
						   if (test1662_1169)
						     {	/* Reduce/copy.scm 203 */
							{	/* Reduce/copy.scm 211 */
							   long z1_1346;
							   z1_1346 = _copy_removed__156_reduce_copy;
							   _copy_removed__156_reduce_copy =
							      (z1_1346 + ((long) 1));
							}
							{	/* Reduce/copy.scm 212 */
							   variable_bglt obj_1348;
							   obj_t val1037_1349;
							   obj_1348 =
							      (variable_bglt) (var_1167);
							   val1037_1349 =
							      (obj_t) (val_1168);
							   ((((variable_bglt) CREF(obj_1348))->fast_alpha_7) = ((obj_t) val1037_1349), BUNSPEC);
							}
							{
							   obj_t obindings_1682;
							   obindings_1682 =
							      CDR(obindings_1155);
							   obindings_1155 = obindings_1682;
							   goto loop_1157;
							}
						     }
						   else
						     {	/* Reduce/copy.scm 214 */
							obj_t arg1664_1171;
							obj_t arg1665_1172;
							arg1664_1171 =
							   CDR(obindings_1155);
							arg1665_1172 =
							   MAKE_PAIR(binding_1166, nbindings_1156);
							{
							   obj_t nbindings_1687;
							   obj_t obindings_1686;
							   obindings_1686 = arg1664_1171;
							   nbindings_1687 = arg1665_1172;
							   nbindings_1156 = nbindings_1687;
							   obindings_1155 = obindings_1686;
							   goto loop_1157;
							}
						     }
						}
					     }
					  }
				       }
				    }
			       }
			    }
			    break;
			 case ((long) 15):

			    {	/* Reduce/copy.scm 220 */
			       set_ex_it_116_bglt node_1182;
			       node_1182 =
				  (set_ex_it_116_bglt) (node_2);
			       {	/* Reduce/copy.scm 221 */
				  node_bglt arg1675_1184;
				  arg1675_1184 =
				     node_copy__175_reduce_copy(
				     (((set_ex_it_116_bglt) CREF(node_1182))->body));
				  ((((set_ex_it_116_bglt) CREF(node_1182))->body) = ((node_bglt) arg1675_1184), BUNSPEC);
			       }
			       {	/* Reduce/copy.scm 222 */
				  node_bglt arg1677_1186;
				  {	/* Reduce/copy.scm 222 */
				     node_bglt aux_1693;
				     {	/* Reduce/copy.scm 222 */
					var_bglt aux_1694;
					aux_1694 =
					   (((set_ex_it_116_bglt) CREF(node_1182))->var);
					aux_1693 =
					   (node_bglt) (aux_1694);
				     }
				     arg1677_1186 =
					node_copy__175_reduce_copy(aux_1693);
				  }
				  {	/* Reduce/copy.scm 222 */
				     var_bglt val1384_1359;
				     val1384_1359 =
					(var_bglt) (arg1677_1186);
				     ((((set_ex_it_116_bglt) CREF(node_1182))->var) = ((var_bglt) val1384_1359), BUNSPEC);
				  }
			       }
			       aux_1505 =
				  (obj_t) (node_1182);
			    }
			    break;
			 case ((long) 16):

			    {	/* Reduce/copy.scm 229 */
			       jump_ex_it_184_bglt node_1188;
			       node_1188 =
				  (jump_ex_it_184_bglt) (node_2);
			       {	/* Reduce/copy.scm 230 */
				  node_bglt arg1679_1190;
				  arg1679_1190 =
				     node_copy__175_reduce_copy(
				     (((jump_ex_it_184_bglt) CREF(node_1188))->exit));
				  ((((jump_ex_it_184_bglt) CREF(node_1188))->exit) = ((node_bglt) arg1679_1190), BUNSPEC);
			       }
			       {	/* Reduce/copy.scm 231 */
				  node_bglt arg1681_1192;
				  arg1681_1192 =
				     node_copy__175_reduce_copy(
				     (((jump_ex_it_184_bglt) CREF(node_1188))->value));
				  ((((jump_ex_it_184_bglt) CREF(node_1188))->value) = ((node_bglt) arg1681_1192), BUNSPEC);
			       }
			       aux_1505 =
				  (obj_t) (node_1188);
			    }
			    break;
			 case ((long) 17):

			    {	/* Reduce/copy.scm 238 */
			       make_box_202_bglt node_1194;
			       node_1194 =
				  (make_box_202_bglt) (node_2);
			       {	/* Reduce/copy.scm 239 */
				  node_bglt arg1683_1196;
				  arg1683_1196 =
				     node_copy__175_reduce_copy(
				     (((make_box_202_bglt) CREF(node_1194))->value));
				  ((((make_box_202_bglt) CREF(node_1194))->value) = ((node_bglt) arg1683_1196), BUNSPEC);
			       }
			       aux_1505 =
				  (obj_t) (node_1194);
			    }
			    break;
			 case ((long) 18):

			    {	/* Reduce/copy.scm 246 */
			       box_set__221_bglt node_1198;
			       node_1198 =
				  (box_set__221_bglt) (node_2);
			       {	/* Reduce/copy.scm 247 */
				  node_bglt arg1685_1200;
				  {	/* Reduce/copy.scm 247 */
				     node_bglt aux_1715;
				     {	/* Reduce/copy.scm 247 */
					var_bglt aux_1716;
					aux_1716 =
					   (((box_set__221_bglt) CREF(node_1198))->var);
					aux_1715 =
					   (node_bglt) (aux_1716);
				     }
				     arg1685_1200 =
					node_copy__175_reduce_copy(aux_1715);
				  }
				  {	/* Reduce/copy.scm 247 */
				     var_bglt val1428_1371;
				     val1428_1371 =
					(var_bglt) (arg1685_1200);
				     ((((box_set__221_bglt) CREF(node_1198))->var) = ((var_bglt) val1428_1371), BUNSPEC);
				  }
			       }
			       {	/* Reduce/copy.scm 248 */
				  node_bglt arg1687_1202;
				  arg1687_1202 =
				     node_copy__175_reduce_copy(
				     (((box_set__221_bglt) CREF(node_1198))->value));
				  ((((box_set__221_bglt) CREF(node_1198))->value) = ((node_bglt) arg1687_1202), BUNSPEC);
			       }
			       aux_1505 =
				  (obj_t) (node_1198);
			    }
			    break;
			 case ((long) 19):

			    {	/* Reduce/copy.scm 255 */
			       box_ref_242_bglt node_1204;
			       node_1204 =
				  (box_ref_242_bglt) (node_2);
			       {	/* Reduce/copy.scm 256 */
				  node_bglt arg1689_1206;
				  {	/* Reduce/copy.scm 256 */
				     node_bglt aux_1727;
				     {	/* Reduce/copy.scm 256 */
					var_bglt aux_1728;
					aux_1728 =
					   (((box_ref_242_bglt) CREF(node_1204))->var);
					aux_1727 =
					   (node_bglt) (aux_1728);
				     }
				     arg1689_1206 =
					node_copy__175_reduce_copy(aux_1727);
				  }
				  {	/* Reduce/copy.scm 256 */
				     var_bglt val1418_1377;
				     val1418_1377 =
					(var_bglt) (arg1689_1206);
				     ((((box_ref_242_bglt) CREF(node_1204))->var) = ((var_bglt) val1418_1377), BUNSPEC);
				  }
			       }
			       aux_1505 =
				  (obj_t) (node_1204);
			    }
			    break;
			 case ((long) 20):

			    {	/* Reduce/copy.scm 263 */
			       app_bglt node_1208;
			       node_1208 =
				  (app_bglt) (node_2);
			       node_copy___108_reduce_copy(
				  (((app_bglt) CREF(node_1208))->args));
			       aux_1505 =
				  (obj_t) (node_1208);
			    }
			    break;
			 default:
			  case_else1605_1075:
			    if (
			       PROCEDUREP(method1599_1071))
			      {		/* Reduce/copy.scm 53 */
				 aux_1505 =
				    PROCEDURE_ENTRY(method1599_1071) (method1599_1071,
				    (obj_t) (node_2), BEOA)
				    ;
			      }
			    else
			      {		/* Reduce/copy.scm 53 */
				 obj_t fun1598_1067;
				 fun1598_1067 =
				    PROCEDURE_REF(node_copy__env_176_reduce_copy, ((long) 0));
				 aux_1505 =
				    PROCEDURE_ENTRY(fun1598_1067) (fun1598_1067,
				    (obj_t) (node_2), BEOA);
			      }
			 }
		    }
		  else
		    {	/* Reduce/copy.scm 53 */
		       goto case_else1605_1075;
		    }
	       }
	       return
		  (node_bglt) (aux_1505);
	    }
	 }
      }
   }
}



/* _node-copy!1698 */
obj_t 
_node_copy_1698_111_reduce_copy(obj_t env_1386, obj_t node_1387)
{
   AN_OBJECT;
   {	/* Reduce/copy.scm 53 */
      {		/* Reduce/copy.scm 53 */
	 node_bglt aux_1751;
	 aux_1751 =
	    node_copy__175_reduce_copy(
	    (node_bglt) (node_1387));
	 return
	    (obj_t) (aux_1751);
      }
   }
}



/* node-copy!-default1461 */
node_bglt 
node_copy__default1461_109_reduce_copy(node_bglt node_3)
{
   AN_OBJECT;
   {	/* Reduce/copy.scm 14 */
      FAILURE(
	 CNST_TABLE_REF(((long) 2)), string1701_reduce_copy,
	 (obj_t) (node_3));
   }
}



/* _node-copy!-default1461 */
obj_t 
_node_copy__default1461_43_reduce_copy(obj_t env_1388, obj_t node_1389)
{
   AN_OBJECT;
   {	/* Reduce/copy.scm 14 */
      {		/* Reduce/copy.scm 14 */
	 node_bglt aux_1758;
	 aux_1758 =
	    node_copy__default1461_109_reduce_copy(
	    (node_bglt) (node_1389));
	 return
	    (obj_t) (aux_1758);
      }
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_reduce_copy()
{
   AN_OBJECT;
   {	/* Reduce/copy.scm 14 */
      module_initialization_70_tools_trace(((long) 0), "REDUCE_COPY");
      module_initialization_70_tools_shape(((long) 0), "REDUCE_COPY");
      module_initialization_70_tools_speek(((long) 0), "REDUCE_COPY");
      module_initialization_70_tools_error(((long) 0), "REDUCE_COPY");
      module_initialization_70_type_type(((long) 0), "REDUCE_COPY");
      module_initialization_70_type_cache(((long) 0), "REDUCE_COPY");
      module_initialization_70_coerce_typeof(((long) 0), "REDUCE_COPY");
      module_initialization_70_coerce_coerce(((long) 0), "REDUCE_COPY");
      module_initialization_70_effect_effect(((long) 0), "REDUCE_COPY");
      module_initialization_70_ast_var(((long) 0), "REDUCE_COPY");
      module_initialization_70_ast_node(((long) 0), "REDUCE_COPY");
      return
	 module_initialization_70_ast_lvtype(((long) 0), "REDUCE_COPY");
   }
}
