/*===========================================================================*/
/*   (Reduce/cse.scm)                                                        */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;


static obj_t method_init_76_reduce_cse();
extern obj_t make_box_202_ast_node;
extern obj_t funcall_ast_node;
extern long add_inlined_method__244___object(obj_t, obj_t, long);
extern obj_t fail_ast_node;
extern obj_t box_ref_242_ast_node;
static long _cse_removed__19_reduce_cse;
extern obj_t _res1__155___r5_control_features_6_4;
extern obj_t sequence_ast_node;
extern obj_t let_var_6_ast_node;
extern obj_t var_ast_node;
extern obj_t closure_ast_node;
extern obj_t create_struct(obj_t, long);
static obj_t node_cse__default1518_121_reduce_cse(node_bglt, obj_t);
extern obj_t pragma_ast_node;
extern obj_t set_ex_it_116_ast_node;
extern obj_t verbose_tools_speek(obj_t, obj_t);
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t module_initialization_70_reduce_cse(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_speek(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_coerce_typeof(long, char *);
extern obj_t module_initialization_70_coerce_coerce(long, char *);
extern obj_t module_initialization_70_effect_effect(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_ast_lvtype(long, char *);
extern obj_t module_initialization_70_reduce_same(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r5_control_features_6_4(long, char *);
extern long class_num_218___object(obj_t);
static obj_t node_cse___11_reduce_cse(obj_t, obj_t);
extern obj_t let_fun_218_ast_node;
static obj_t imported_modules_init_94_reduce_cse();
extern obj_t app_ly_162_ast_node;
extern obj_t add_generic__110___object(obj_t, obj_t);
static obj_t find_stack_136_reduce_cse(node_bglt, obj_t);
extern obj_t app_ast_node;
extern obj_t append_2_18___r4_pairs_and_lists_6_3(obj_t, obj_t);
static obj_t library_modules_init_112_reduce_cse();
extern obj_t atom_ast_node;
extern obj_t cast_ast_node;
static obj_t toplevel_init_63_reduce_cse();
extern obj_t jump_ex_it_184_ast_node;
extern obj_t open_input_string(obj_t);
extern obj_t kwote_ast_node;
extern bool_t side_effect__165_effect_effect(node_bglt);
static obj_t _node_cse_1765_100_reduce_cse(obj_t, obj_t, obj_t);
extern obj_t setq_ast_node;
extern obj_t box_set__221_ast_node;
extern obj_t variable_ast_var;
extern obj_t node_cse__231_reduce_cse(node_bglt, obj_t);
static obj_t _reduce_cse__182_reduce_cse(obj_t, obj_t);
extern obj_t _res_number__75___r5_control_features_6_4;
static obj_t _node_cse__default1518_154_reduce_cse(obj_t, obj_t, obj_t);
extern obj_t _classes__134___object;
extern obj_t select_ast_node;
extern obj_t reduce_cse__211_reduce_cse(obj_t);
extern obj_t read___reader(obj_t);
extern bool_t same_node__38_reduce_same(node_bglt, node_bglt, obj_t);
static obj_t require_initialization_114_reduce_cse = BUNSPEC;
extern obj_t conditional_ast_node;
static obj_t cnst_init_137_reduce_cse();
static obj_t __cnst[3];

DEFINE_STATIC_PROCEDURE(node_cse__default1518_env_100_reduce_cse, _node_cse__default1518_154_reduce_cse1774, _node_cse__default1518_154_reduce_cse, 0L, 2);
DEFINE_EXPORT_PROCEDURE(reduce_cse__env_219_reduce_cse, _reduce_cse__182_reduce_cse1775, _reduce_cse__182_reduce_cse, 0L, 1);
DEFINE_EXPORT_GENERIC(node_cse__env_198_reduce_cse, _node_cse_1765_100_reduce_cse1776, _node_cse_1765_100_reduce_cse, 0L, 2);
DEFINE_STRING(string1769_reduce_cse, string1769_reduce_cse1777, "NODE-CSE!-DEFAULT1518 CALL READ ", 32);
DEFINE_STRING(string1768_reduce_cse, string1768_reduce_cse1778, "No method for this object", 25);
DEFINE_STRING(string1767_reduce_cse, string1767_reduce_cse1779, "(removed : ", 11);
DEFINE_STRING(string1766_reduce_cse, string1766_reduce_cse1780, "      cse                    ", 29);



/* module-initialization */
obj_t 
module_initialization_70_reduce_cse(long checksum_1645, char *from_1646)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_reduce_cse))
	{
	   require_initialization_114_reduce_cse =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_reduce_cse();
	   cnst_init_137_reduce_cse();
	   imported_modules_init_94_reduce_cse();
	   method_init_76_reduce_cse();
	   toplevel_init_63_reduce_cse();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_reduce_cse()
{
   AN_OBJECT;
   {	/* Reduce/cse.scm 14 */
      module_initialization_70___object(((long) 0), "REDUCE_CSE");
      module_initialization_70___r5_control_features_6_4(((long) 0), "REDUCE_CSE");
      module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "REDUCE_CSE");
      module_initialization_70___reader(((long) 0), "REDUCE_CSE");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_reduce_cse()
{
   AN_OBJECT;
   {	/* Reduce/cse.scm 14 */
      {		/* Reduce/cse.scm 14 */
	 obj_t cnst_port_138_1638;
	 cnst_port_138_1638 =
	    open_input_string(string1769_reduce_cse);
	 {
	    long i_1639;
	    i_1639 = ((long) 2);
	  loop_1640:
	    {	/* Reduce/cse.scm 14 */
	       bool_t test1770_1641;
	       test1770_1641 =
		  (i_1639 == ((long) -1));
	       if (test1770_1641)
		 {	/* Reduce/cse.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Reduce/cse.scm 14 */
		    {	/* Reduce/cse.scm 14 */
		       obj_t arg1771_1642;
		       {	/* Reduce/cse.scm 14 */
			  obj_t list1772_1643;
			  list1772_1643 =
			     MAKE_PAIR(cnst_port_138_1638, BNIL);
			  arg1771_1642 =
			     read___reader(list1772_1643);
		       }
		       CNST_TABLE_SET(i_1639, arg1771_1642);
		    }
		    {	/* Reduce/cse.scm 14 */
		       int aux_1644;
		       {	/* Reduce/cse.scm 14 */
			  long aux_1665;
			  aux_1665 =
			     (i_1639 - ((long) 1));
			  aux_1644 =
			     (int) (aux_1665);
		       }
		       {
			  long i_1668;
			  i_1668 =
			     (long) (aux_1644);
			  i_1639 = i_1668;
			  goto loop_1640;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_reduce_cse()
{
   AN_OBJECT;
   {	/* Reduce/cse.scm 14 */
      _cse_removed__19_reduce_cse = ((long) 0);
      return BUNSPEC;
   }
}



/* reduce-cse! */
obj_t 
reduce_cse__211_reduce_cse(obj_t globals_1)
{
   AN_OBJECT;
   {	/* Reduce/cse.scm 34 */
      {		/* Reduce/cse.scm 35 */
	 obj_t list1569_757;
	 list1569_757 =
	    MAKE_PAIR(string1766_reduce_cse, BNIL);
	 verbose_tools_speek(
	    BINT(((long) 2)), list1569_757);
      }
      _cse_removed__19_reduce_cse = ((long) 0);
      {
	 obj_t l1437_758;
	 l1437_758 = globals_1;
       lname1438_759:
	 if (
	    PAIRP(l1437_758))
	   {	/* Reduce/cse.scm 37 */
	      {		/* Reduce/cse.scm 38 */
		 value_bglt fun_762;
		 {	/* Reduce/cse.scm 38 */
		    global_bglt obj_1408;
		    {	/* Reduce/cse.scm 38 */
		       obj_t aux_1675;
		       aux_1675 =
			  CAR(l1437_758);
		       obj_1408 =
			  (global_bglt) (aux_1675);
		    }
		    fun_762 =
		       (((global_bglt) CREF(obj_1408))->value);
		 }
		 {	/* Reduce/cse.scm 39 */

		    {	/* Reduce/cse.scm 40 */
		       obj_t arg1571_764;
		       {	/* Reduce/cse.scm 40 */
			  obj_t __765;
			  {	/* Reduce/cse.scm 41 */
			     node_bglt aux_1679;
			     {	/* Reduce/cse.scm 41 */
				obj_t aux_1680;
				{	/* Reduce/cse.scm 39 */
				   sfun_bglt obj_1409;
				   obj_1409 =
				      (sfun_bglt) (fun_762);
				   aux_1680 =
				      (((sfun_bglt) CREF(obj_1409))->body);
				}
				aux_1679 =
				   (node_bglt) (aux_1680);
			     }
			     __765 =
				node_cse__231_reduce_cse(aux_1679, BNIL);
			  }
			  {	/* Reduce/cse.scm 40 */
			     obj_t node_766;
			     node_766 = _res1__155___r5_control_features_6_4;
			     arg1571_764 = node_766;
			  }
		       }
		       {	/* Reduce/cse.scm 40 */
			  sfun_bglt obj_1410;
			  obj_1410 =
			     (sfun_bglt) (fun_762);
			  ((((sfun_bglt) CREF(obj_1410))->body) = ((obj_t) arg1571_764), BUNSPEC);
		       }
		    }
		    BUNSPEC;
		 }
	      }
	      {
		 obj_t l1437_1687;
		 l1437_1687 =
		    CDR(l1437_758);
		 l1437_758 = l1437_1687;
		 goto lname1438_759;
	      }
	   }
	 else
	   {	/* Reduce/cse.scm 37 */
	      ((bool_t) 1);
	   }
      }
      {		/* Reduce/cse.scm 45 */
	 obj_t list1573_768;
	 {	/* Reduce/cse.scm 45 */
	    obj_t arg1577_770;
	    {	/* Reduce/cse.scm 45 */
	       obj_t arg1578_771;
	       {	/* Reduce/cse.scm 45 */
		  obj_t arg1579_772;
		  {	/* Reduce/cse.scm 45 */
		     obj_t aux_1689;
		     aux_1689 =
			BCHAR(((unsigned char) '\n'));
		     arg1579_772 =
			MAKE_PAIR(aux_1689, BNIL);
		  }
		  {	/* Reduce/cse.scm 45 */
		     obj_t aux_1692;
		     aux_1692 =
			BCHAR(((unsigned char) ')'));
		     arg1578_771 =
			MAKE_PAIR(aux_1692, arg1579_772);
		  }
	       }
	       {	/* Reduce/cse.scm 45 */
		  obj_t aux_1695;
		  aux_1695 =
		     BINT(_cse_removed__19_reduce_cse);
		  arg1577_770 =
		     MAKE_PAIR(aux_1695, arg1578_771);
	       }
	    }
	    list1573_768 =
	       MAKE_PAIR(string1767_reduce_cse, arg1577_770);
	 }
	 verbose_tools_speek(
	    BINT(((long) 2)), list1573_768);
      }
      return globals_1;
   }
}



/* _reduce-cse! */
obj_t 
_reduce_cse__182_reduce_cse(obj_t env_1629, obj_t globals_1630)
{
   AN_OBJECT;
   {	/* Reduce/cse.scm 34 */
      return
	 reduce_cse__211_reduce_cse(globals_1630);
   }
}



/* node-cse*! */
obj_t 
node_cse___11_reduce_cse(obj_t node__221_48, obj_t stack_49)
{
   AN_OBJECT;
   {	/* Reduce/cse.scm 347 */
      {
	 obj_t node__221_773;
	 bool_t reset_774;
	 obj_t stack_775;
	 node__221_773 = node__221_48;
	 reset_774 = ((bool_t) 0);
	 stack_775 = stack_49;
       loop_776:
	 if (
	    NULLP(node__221_773))
	   {	/* Reduce/cse.scm 352 */
	      return
		 BBOOL(reset_774);
	   }
	 else
	   {	/* Reduce/cse.scm 354 */
	      bool_t test_1705;
	      {		/* ./Ieee/pair-list.scm 5912 */
		 obj_t aux_1706;
		 aux_1706 =
		    CDR(node__221_773);
		 test_1705 =
		    NULLP(aux_1706);
	      }
	      if (test_1705)
		{	/* Reduce/cse.scm 354 */
		   {	/* Reduce/cse.scm 355 */
		      obj_t reset__69_779;
		      {		/* Reduce/cse.scm 356 */
			 node_bglt aux_1709;
			 {	/* Reduce/cse.scm 356 */
			    obj_t aux_1710;
			    aux_1710 =
			       CAR(node__221_773);
			    aux_1709 =
			       (node_bglt) (aux_1710);
			 }
			 reset__69_779 =
			    node_cse__231_reduce_cse(aux_1709, stack_775);
		      }
		      {		/* Reduce/cse.scm 355 */
			 obj_t node_780;
			 node_780 = _res1__155___r5_control_features_6_4;
			 SET_CAR(node__221_773, node_780);
			 if (reset_774)
			   {	/* Reduce/cse.scm 358 */
			      return
				 BBOOL(reset_774);
			   }
			 else
			   {	/* Reduce/cse.scm 358 */
			      return reset__69_779;
			   }
		      }
		   }
		}
	      else
		{	/* Reduce/cse.scm 354 */
		   {	/* Reduce/cse.scm 360 */
		      obj_t reset__69_783;
		      {		/* Reduce/cse.scm 361 */
			 node_bglt aux_1717;
			 {	/* Reduce/cse.scm 361 */
			    obj_t aux_1718;
			    aux_1718 =
			       CAR(node__221_773);
			    aux_1717 =
			       (node_bglt) (aux_1718);
			 }
			 reset__69_783 =
			    node_cse__231_reduce_cse(aux_1717, stack_775);
		      }
		      {		/* Reduce/cse.scm 360 */
			 obj_t node_784;
			 node_784 = _res1__155___r5_control_features_6_4;
			 SET_CAR(node__221_773, node_784);
			 {	/* Reduce/cse.scm 363 */
			    bool_t test_1723;
			    if (reset_774)
			      {		/* Reduce/cse.scm 363 */
				 test_1723 = ((bool_t) 1)
				    ;
			      }
			    else
			      {		/* Reduce/cse.scm 363 */
				 test_1723 =
				    CBOOL(reset__69_783)
				    ;
			      }
			    if (test_1723)
			      {
				 obj_t stack_1729;
				 bool_t reset_1728;
				 obj_t node__221_1726;
				 node__221_1726 =
				    CDR(node__221_773);
				 reset_1728 = ((bool_t) 1);
				 stack_1729 = BNIL;
				 stack_775 = stack_1729;
				 reset_774 = reset_1728;
				 node__221_773 = node__221_1726;
				 goto loop_776;
			      }
			    else
			      {
				 bool_t reset_1732;
				 obj_t node__221_1730;
				 node__221_1730 =
				    CDR(node__221_773);
				 reset_1732 = ((bool_t) 0);
				 reset_774 = reset_1732;
				 node__221_773 = node__221_1730;
				 goto loop_776;
			      }
			 }
		      }
		   }
		}
	   }
      }
   }
}



/* find-stack */
obj_t 
find_stack_136_reduce_cse(node_bglt node_60, obj_t stack_61)
{
   AN_OBJECT;
   {	/* Reduce/cse.scm 379 */
      {
	 obj_t stack_801;
	 stack_801 = stack_61;
       loop_802:
	 if (
	    NULLP(stack_801))
	   {	/* Reduce/cse.scm 383 */
	      return BFALSE;
	   }
	 else
	   {	/* Reduce/cse.scm 385 */
	      bool_t test1599_804;
	      {		/* Reduce/cse.scm 385 */
		 node_bglt aux_1735;
		 {	/* Reduce/cse.scm 385 */
		    obj_t aux_1736;
		    {	/* ./Llib/struct.scm 1457 */
		       obj_t aux_1737;
		       aux_1737 =
			  CAR(stack_801);
		       aux_1736 =
			  STRUCT_REF(aux_1737, ((long) 0));
		    }
		    aux_1735 =
		       (node_bglt) (aux_1736);
		 }
		 test1599_804 =
		    same_node__38_reduce_same(node_60, aux_1735, BNIL);
	      }
	      if (test1599_804)
		{	/* Reduce/cse.scm 385 */
		   {	/* ./Llib/struct.scm 1457 */
		      obj_t aux_1743;
		      aux_1743 =
			 CAR(stack_801);
		      return
			 STRUCT_REF(aux_1743, ((long) 1));
		   }
		}
	      else
		{	/* Reduce/cse.scm 385 */
		   {
		      obj_t stack_1746;
		      stack_1746 =
			 CDR(stack_801);
		      stack_801 = stack_1746;
		      goto loop_802;
		   }
		}
	   }
      }
   }
}



/* method-init */
obj_t 
method_init_76_reduce_cse()
{
   AN_OBJECT;
   {	/* Reduce/cse.scm 14 */
      add_generic__110___object(node_cse__env_198_reduce_cse, node_cse__default1518_env_100_reduce_cse);
      add_inlined_method__244___object(node_cse__env_198_reduce_cse, atom_ast_node, ((long) 0));
      add_inlined_method__244___object(node_cse__env_198_reduce_cse, kwote_ast_node, ((long) 1));
      add_inlined_method__244___object(node_cse__env_198_reduce_cse, var_ast_node, ((long) 2));
      add_inlined_method__244___object(node_cse__env_198_reduce_cse, closure_ast_node, ((long) 3));
      add_inlined_method__244___object(node_cse__env_198_reduce_cse, sequence_ast_node, ((long) 4));
      add_inlined_method__244___object(node_cse__env_198_reduce_cse, app_ly_162_ast_node, ((long) 5));
      add_inlined_method__244___object(node_cse__env_198_reduce_cse, funcall_ast_node, ((long) 6));
      add_inlined_method__244___object(node_cse__env_198_reduce_cse, pragma_ast_node, ((long) 7));
      add_inlined_method__244___object(node_cse__env_198_reduce_cse, cast_ast_node, ((long) 8));
      add_inlined_method__244___object(node_cse__env_198_reduce_cse, setq_ast_node, ((long) 9));
      add_inlined_method__244___object(node_cse__env_198_reduce_cse, conditional_ast_node, ((long) 10));
      add_inlined_method__244___object(node_cse__env_198_reduce_cse, fail_ast_node, ((long) 11));
      add_inlined_method__244___object(node_cse__env_198_reduce_cse, select_ast_node, ((long) 12));
      add_inlined_method__244___object(node_cse__env_198_reduce_cse, let_fun_218_ast_node, ((long) 13));
      add_inlined_method__244___object(node_cse__env_198_reduce_cse, set_ex_it_116_ast_node, ((long) 14));
      add_inlined_method__244___object(node_cse__env_198_reduce_cse, jump_ex_it_184_ast_node, ((long) 15));
      add_inlined_method__244___object(node_cse__env_198_reduce_cse, make_box_202_ast_node, ((long) 16));
      add_inlined_method__244___object(node_cse__env_198_reduce_cse, box_set__221_ast_node, ((long) 17));
      add_inlined_method__244___object(node_cse__env_198_reduce_cse, box_ref_242_ast_node, ((long) 18));
      add_inlined_method__244___object(node_cse__env_198_reduce_cse, app_ast_node, ((long) 19));
      {		/* Reduce/cse.scm 14 */
	 long aux_1769;
	 aux_1769 =
	    add_inlined_method__244___object(node_cse__env_198_reduce_cse, let_var_6_ast_node, ((long) 20));
	 return
	    BINT(aux_1769);
      }
   }
}



/* node-cse! */
obj_t 
node_cse__231_reduce_cse(node_bglt node_2, obj_t stack_3)
{
   AN_OBJECT;
   {	/* Reduce/cse.scm 58 */
      {
	 obj_t method1680_1140;
	 obj_t class1685_1141;
	 {	/* Reduce/cse.scm 58 */
	    obj_t arg1688_1138;
	    obj_t arg1689_1139;
	    {	/* Reduce/cse.scm 58 */
	       object_bglt obj_1462;
	       obj_1462 =
		  (object_bglt) (node_2);
	       {	/* ./Llib/object.scm 2926 */
		  obj_t pre_method_105_1463;
		  pre_method_105_1463 =
		     PROCEDURE_REF(node_cse__env_198_reduce_cse, ((long) 2));
		  if (
		     INTEGERP(pre_method_105_1463))
		    {	/* ./Llib/object.scm 2927 */
		       PROCEDURE_SET(node_cse__env_198_reduce_cse, ((long) 2), BUNSPEC);
		       arg1688_1138 = pre_method_105_1463;
		    }
		  else
		    {	/* ./Llib/object.scm 2914 */
		       long obj_class_num_177_1468;
		       obj_class_num_177_1468 =
			  TYPE(obj_1462);
		       {	/* ./Llib/object.scm 2915 */
			  obj_t arg1176_1469;
			  arg1176_1469 =
			     PROCEDURE_REF(node_cse__env_198_reduce_cse, ((long) 1));
			  {	/* ./Llib/object.scm 2738 */
			     long arg1177_1473;
			     {	/* ./Llib/object.scm 2738 */
				long arg1178_1474;
				arg1178_1474 =
				   OBJECT_TYPE;
				arg1177_1473 =
				   (obj_class_num_177_1468 - arg1178_1474);
			     }
			     arg1688_1138 =
				VECTOR_REF(arg1176_1469, arg1177_1473);
			  }
		       }
		    }
	       }
	    }
	    {	/* Reduce/cse.scm 58 */
	       object_bglt object_1479;
	       object_1479 =
		  (object_bglt) (node_2);
	       {	/* ./Llib/object.scm 2695 */
		  long arg1179_1480;
		  {	/* ./Llib/object.scm 2695 */
		     long arg1180_1481;
		     long arg1181_1482;
		     arg1180_1481 =
			TYPE(object_1479);
		     arg1181_1482 =
			OBJECT_TYPE;
		     arg1179_1480 =
			(arg1180_1481 - arg1181_1482);
		  }
		  {	/* ./Llib/object.scm 2695 */
		     obj_t vector_1486;
		     vector_1486 = _classes__134___object;
		     arg1689_1139 =
			VECTOR_REF(vector_1486, arg1179_1480);
		  }
	       }
	    }
	    method1680_1140 = arg1688_1138;
	    class1685_1141 = arg1689_1139;
	    {

	       if (
		  INTEGERP(method1680_1140))
		 {	/* Reduce/cse.scm 58 */
		    switch (
		       (long) CINT(method1680_1140))
		      {
		      case ((long) 0):

			 _res_number__75___r5_control_features_6_4 =
			    BINT(((long) 2));
			 {	/* Reduce/cse.scm 64 */
			    atom_bglt aux_1790;
			    aux_1790 =
			       (atom_bglt) (node_2);
			    _res1__155___r5_control_features_6_4 =
			       (obj_t) (aux_1790);
			 }
			 return BFALSE;
			 break;
		      case ((long) 1):

			 _res_number__75___r5_control_features_6_4 =
			    BINT(((long) 2));
			 {	/* Reduce/cse.scm 70 */
			    kwote_bglt aux_1794;
			    aux_1794 =
			       (kwote_bglt) (node_2);
			    _res1__155___r5_control_features_6_4 =
			       (obj_t) (aux_1794);
			 }
			 return BFALSE;
			 break;
		      case ((long) 2):

			 _res_number__75___r5_control_features_6_4 =
			    BINT(((long) 2));
			 {	/* Reduce/cse.scm 76 */
			    var_bglt aux_1798;
			    aux_1798 =
			       (var_bglt) (node_2);
			    _res1__155___r5_control_features_6_4 =
			       (obj_t) (aux_1798);
			 }
			 return BFALSE;
			 break;
		      case ((long) 3):

			 _res_number__75___r5_control_features_6_4 =
			    BINT(((long) 2));
			 {	/* Reduce/cse.scm 82 */
			    closure_bglt aux_1802;
			    aux_1802 =
			       (closure_bglt) (node_2);
			    _res1__155___r5_control_features_6_4 =
			       (obj_t) (aux_1802);
			 }
			 return BFALSE;
			 break;
		      case ((long) 4):

			 {	/* Reduce/cse.scm 88 */
			    sequence_bglt node_1163;
			    node_1163 =
			       (sequence_bglt) (node_2);
			    {	/* Reduce/cse.scm 89 */
			       obj_t val0_1448_1166;
			       val0_1448_1166 =
				  node_cse___11_reduce_cse(
				  (((sequence_bglt) CREF(node_1163))->nodes), stack_3);
			       _res_number__75___r5_control_features_6_4 =
				  BINT(((long) 2));
			       _res1__155___r5_control_features_6_4 =
				  (obj_t) (node_1163);
			       return val0_1448_1166;
			    }
			 }
			 break;
		      case ((long) 5):

			 {	/* Reduce/cse.scm 95 */
			    app_ly_162_bglt node_1169;
			    node_1169 =
			       (app_ly_162_bglt) (node_2);
			    {	/* Reduce/cse.scm 96 */
			       obj_t reset_1172;
			       reset_1172 =
				  node_cse__231_reduce_cse(
				  (((app_ly_162_bglt) CREF(node_1169))->fun), stack_3);
			       {	/* Reduce/cse.scm 96 */
				  obj_t nfun_1173;
				  nfun_1173 = _res1__155___r5_control_features_6_4;
				  {	/* Reduce/cse.scm 98 */
				     node_bglt val1259_1491;
				     val1259_1491 =
					(node_bglt) (nfun_1173);
				     ((((app_ly_162_bglt) CREF(node_1169))->fun) = ((node_bglt) val1259_1491), BUNSPEC);
				  }
				  {	/* Reduce/cse.scm 99 */
				     obj_t reset__69_1174;
				     {	/* Reduce/cse.scm 100 */
					obj_t aux_1815;
					if (
					   CBOOL(reset_1172))
					  {	/* Reduce/cse.scm 100 */
					     aux_1815 = BNIL
						;
					  }
					else
					  {	/* Reduce/cse.scm 100 */
					     aux_1815 = stack_3
						;
					  }
					reset__69_1174 =
					   node_cse__231_reduce_cse(
					   (((app_ly_162_bglt) CREF(node_1169))->arg), aux_1815);
				     }
				     {	/* Reduce/cse.scm 99 */
					obj_t narg_1175;
					narg_1175 = _res1__155___r5_control_features_6_4;
					{	/* Reduce/cse.scm 101 */
					   node_bglt val1260_1494;
					   val1260_1494 =
					      (node_bglt) (narg_1175);
					   ((((app_ly_162_bglt) CREF(node_1169))->arg) = ((node_bglt) val1260_1494), BUNSPEC);
					}
					_res_number__75___r5_control_features_6_4 =
					   BINT(((long) 2));
					_res1__155___r5_control_features_6_4 =
					   (obj_t) (node_1169);
					if (
					   CBOOL(reset_1172))
					  {	/* Reduce/cse.scm 102 */
					     return reset_1172;
					  }
					else
					  {	/* Reduce/cse.scm 102 */
					     return reset__69_1174;
					  }
				     }
				  }
			       }
			    }
			 }
			 break;
		      case ((long) 6):

			 {	/* Reduce/cse.scm 108 */
			    funcall_bglt node_1182;
			    node_1182 =
			       (funcall_bglt) (node_2);
			    {	/* Reduce/cse.scm 109 */
			       obj_t reset__69_1185;
			       reset__69_1185 =
				  node_cse___11_reduce_cse(
				  (((funcall_bglt) CREF(node_1182))->args), stack_3);
			       _res_number__75___r5_control_features_6_4 =
				  BINT(((long) 2));
			       _res1__155___r5_control_features_6_4 =
				  (obj_t) (node_1182);
			       return reset__69_1185;
			    }
			 }
			 break;
		      case ((long) 7):

			 {	/* Reduce/cse.scm 116 */
			    pragma_bglt node_1189;
			    node_1189 =
			       (pragma_bglt) (node_2);
			    {	/* Reduce/cse.scm 117 */
			       obj_t reset__69_1192;
			       reset__69_1192 =
				  node_cse___11_reduce_cse(
				  (((pragma_bglt) CREF(node_1189))->args), stack_3);
			       _res_number__75___r5_control_features_6_4 =
				  BINT(((long) 2));
			       _res1__155___r5_control_features_6_4 =
				  (obj_t) (node_1189);
			       return reset__69_1192;
			    }
			 }
			 break;
		      case ((long) 8):

			 {	/* Reduce/cse.scm 124 */
			    cast_bglt node_1196;
			    node_1196 =
			       (cast_bglt) (node_2);
			    {	/* Reduce/cse.scm 125 */
			       obj_t reset_1199;
			       reset_1199 =
				  node_cse__231_reduce_cse(
				  (((cast_bglt) CREF(node_1196))->arg), stack_3);
			       {	/* Reduce/cse.scm 125 */
				  obj_t narg_1200;
				  narg_1200 = _res1__155___r5_control_features_6_4;
				  {	/* Reduce/cse.scm 127 */
				     node_bglt val1294_1499;
				     val1294_1499 =
					(node_bglt) (narg_1200);
				     ((((cast_bglt) CREF(node_1196))->arg) = ((node_bglt) val1294_1499), BUNSPEC);
				  }
				  _res_number__75___r5_control_features_6_4 =
				     BINT(((long) 2));
				  _res1__155___r5_control_features_6_4 =
				     (obj_t) (node_1196);
				  return reset_1199;
			       }
			    }
			 }
			 break;
		      case ((long) 9):

			 {	/* Reduce/cse.scm 134 */
			    setq_bglt node_1204;
			    node_1204 =
			       (setq_bglt) (node_2);
			    {	/* Reduce/cse.scm 135 */
			       obj_t reset_1207;
			       reset_1207 =
				  node_cse__231_reduce_cse(
				  (((setq_bglt) CREF(node_1204))->value), stack_3);
			       {	/* Reduce/cse.scm 135 */
				  obj_t nvalue_1208;
				  nvalue_1208 = _res1__155___r5_control_features_6_4;
				  {	/* Reduce/cse.scm 137 */
				     node_bglt val1303_1502;
				     val1303_1502 =
					(node_bglt) (nvalue_1208);
				     ((((setq_bglt) CREF(node_1204))->value) = ((node_bglt) val1303_1502), BUNSPEC);
				  }
				  _res_number__75___r5_control_features_6_4 =
				     BINT(((long) 2));
				  _res1__155___r5_control_features_6_4 =
				     (obj_t) (node_1204);
				  return reset_1207;
			       }
			    }
			 }
			 break;
		      case ((long) 10):

			 {	/* Reduce/cse.scm 144 */
			    conditional_bglt node_1212;
			    node_1212 =
			       (conditional_bglt) (node_2);
			    {	/* Reduce/cse.scm 145 */
			       obj_t reset_1215;
			       reset_1215 =
				  node_cse__231_reduce_cse(
				  (((conditional_bglt) CREF(node_1212))->test), stack_3);
			       {	/* Reduce/cse.scm 145 */
				  obj_t ntest_1216;
				  ntest_1216 = _res1__155___r5_control_features_6_4;
				  {	/* Reduce/cse.scm 147 */
				     node_bglt val1314_1505;
				     val1314_1505 =
					(node_bglt) (ntest_1216);
				     ((((conditional_bglt) CREF(node_1212))->test) = ((node_bglt) val1314_1505), BUNSPEC);
				  }
				  {	/* Reduce/cse.scm 148 */
				     obj_t stack__1_1217;
				     if (
					CBOOL(reset_1215))
				       {	/* Reduce/cse.scm 148 */
					  stack__1_1217 = BNIL;
				       }
				     else
				       {	/* Reduce/cse.scm 148 */
					  stack__1_1217 = stack_3;
				       }
				     {	/* Reduce/cse.scm 149 */
					obj_t reset__69_1218;
					reset__69_1218 =
					   node_cse__231_reduce_cse(
					   (((conditional_bglt) CREF(node_1212))->true), stack__1_1217);
					{	/* Reduce/cse.scm 149 */
					   obj_t ntrue_1219;
					   ntrue_1219 = _res1__155___r5_control_features_6_4;
					   {	/* Reduce/cse.scm 151 */
					      node_bglt val1315_1508;
					      val1315_1508 =
						 (node_bglt) (ntrue_1219);
					      ((((conditional_bglt) CREF(node_1212))->true) = ((node_bglt) val1315_1508), BUNSPEC);
					   }
					   {	/* Reduce/cse.scm 152 */
					      obj_t reset___255_1220;
					      reset___255_1220 =
						 node_cse__231_reduce_cse(
						 (((conditional_bglt) CREF(node_1212))->false), stack__1_1217);
					      {		/* Reduce/cse.scm 152 */
						 obj_t nfalse_1221;
						 nfalse_1221 = _res1__155___r5_control_features_6_4;
						 {	/* Reduce/cse.scm 154 */
						    node_bglt val1316_1511;
						    val1316_1511 =
						       (node_bglt) (nfalse_1221);
						    ((((conditional_bglt) CREF(node_1212))->false) = ((node_bglt) val1316_1511), BUNSPEC);
						 }
						 _res_number__75___r5_control_features_6_4 =
						    BINT(((long) 2));
						 _res1__155___r5_control_features_6_4 =
						    (obj_t) (node_1212);
						 if (
						    CBOOL(reset_1215))
						   {	/* Reduce/cse.scm 155 */
						      return reset_1215;
						   }
						 else
						   {	/* Reduce/cse.scm 155 */
						      if (
							 CBOOL(reset__69_1218))
							{	/* Reduce/cse.scm 155 */
							   return reset__69_1218;
							}
						      else
							{	/* Reduce/cse.scm 155 */
							   return reset___255_1220;
							}
						   }
					      }
					   }
					}
				     }
				  }
			       }
			    }
			 }
			 break;
		      case ((long) 11):

			 {	/* Reduce/cse.scm 161 */
			    fail_bglt node_1229;
			    node_1229 =
			       (fail_bglt) (node_2);
			    {	/* Reduce/cse.scm 162 */
			       obj_t reset_1232;
			       reset_1232 =
				  node_cse__231_reduce_cse(
				  (((fail_bglt) CREF(node_1229))->proc), stack_3);
			       {	/* Reduce/cse.scm 162 */
				  obj_t nproc_1233;
				  nproc_1233 = _res1__155___r5_control_features_6_4;
				  {	/* Reduce/cse.scm 164 */
				     node_bglt val1328_1514;
				     val1328_1514 =
					(node_bglt) (nproc_1233);
				     ((((fail_bglt) CREF(node_1229))->proc) = ((node_bglt) val1328_1514), BUNSPEC);
				  }
				  {	/* Reduce/cse.scm 165 */
				     obj_t stack__1_1234;
				     if (
					CBOOL(reset_1232))
				       {	/* Reduce/cse.scm 165 */
					  stack__1_1234 = BNIL;
				       }
				     else
				       {	/* Reduce/cse.scm 165 */
					  stack__1_1234 = stack_3;
				       }
				     {	/* Reduce/cse.scm 166 */
					obj_t reset__69_1235;
					reset__69_1235 =
					   node_cse__231_reduce_cse(
					   (((fail_bglt) CREF(node_1229))->msg), stack__1_1234);
					{	/* Reduce/cse.scm 166 */
					   obj_t nmsg_1236;
					   nmsg_1236 = _res1__155___r5_control_features_6_4;
					   {	/* Reduce/cse.scm 168 */
					      node_bglt val1329_1517;
					      val1329_1517 =
						 (node_bglt) (nmsg_1236);
					      ((((fail_bglt) CREF(node_1229))->msg) = ((node_bglt) val1329_1517), BUNSPEC);
					   }
					   {	/* Reduce/cse.scm 170 */
					      obj_t reset___255_1238;
					      {		/* Reduce/cse.scm 171 */
						 obj_t aux_1882;
						 if (
						    CBOOL(reset__69_1235))
						   {	/* Reduce/cse.scm 169 */
						      aux_1882 = BNIL
							 ;
						   }
						 else
						   {	/* Reduce/cse.scm 169 */
						      aux_1882 = stack__1_1234
							 ;
						   }
						 reset___255_1238 =
						    node_cse__231_reduce_cse(
						    (((fail_bglt) CREF(node_1229))->obj), aux_1882);
					      }
					      {		/* Reduce/cse.scm 170 */
						 obj_t nobj_1239;
						 nobj_1239 = _res1__155___r5_control_features_6_4;
						 {	/* Reduce/cse.scm 172 */
						    node_bglt val1330_1520;
						    val1330_1520 =
						       (node_bglt) (nobj_1239);
						    ((((fail_bglt) CREF(node_1229))->obj) = ((node_bglt) val1330_1520), BUNSPEC);
						 }
						 _res_number__75___r5_control_features_6_4 =
						    BINT(((long) 2));
						 _res1__155___r5_control_features_6_4 =
						    (obj_t) (node_1229);
						 if (
						    CBOOL(reset_1232))
						   {	/* Reduce/cse.scm 173 */
						      return reset_1232;
						   }
						 else
						   {	/* Reduce/cse.scm 173 */
						      if (
							 CBOOL(reset__69_1235))
							{	/* Reduce/cse.scm 173 */
							   return reset__69_1235;
							}
						      else
							{	/* Reduce/cse.scm 173 */
							   return reset___255_1238;
							}
						   }
					      }
					   }
					}
				     }
				  }
			       }
			    }
			 }
			 break;
		      case ((long) 12):

			 {	/* Reduce/cse.scm 179 */
			    select_bglt node_1247;
			    node_1247 =
			       (select_bglt) (node_2);
			    {	/* Reduce/cse.scm 180 */
			       obj_t reset_1250;
			       reset_1250 =
				  node_cse__231_reduce_cse(
				  (((select_bglt) CREF(node_1247))->test), stack_3);
			       {	/* Reduce/cse.scm 180 */
				  obj_t ntest_1251;
				  ntest_1251 = _res1__155___r5_control_features_6_4;
				  {	/* Reduce/cse.scm 182 */
				     node_bglt val1342_1523;
				     val1342_1523 =
					(node_bglt) (ntest_1251);
				     ((((select_bglt) CREF(node_1247))->test) = ((node_bglt) val1342_1523), BUNSPEC);
				  }
				  {
				     obj_t clauses_1253;
				     obj_t reset_1254;
				     clauses_1253 =
					(((select_bglt) CREF(node_1247))->clauses);
				     reset_1254 = reset_1250;
				   loop_1255:
				     if (
					NULLP(clauses_1253))
				       {	/* Reduce/cse.scm 186 */
					  _res_number__75___r5_control_features_6_4 =
					     BINT(((long) 2));
					  _res1__155___r5_control_features_6_4 =
					     (obj_t) (node_1247);
					  return reset_1254;
				       }
				     else
				       {	/* Reduce/cse.scm 188 */
					  obj_t clause_1260;
					  clause_1260 =
					     CAR(clauses_1253);
					  {	/* Reduce/cse.scm 189 */
					     obj_t reset__69_1261;
					     {	/* Reduce/cse.scm 190 */
						node_bglt aux_1905;
						{	/* Reduce/cse.scm 190 */
						   obj_t aux_1906;
						   aux_1906 =
						      CDR(clause_1260);
						   aux_1905 =
						      (node_bglt) (aux_1906);
						}
						reset__69_1261 =
						   node_cse__231_reduce_cse(aux_1905, stack_3);
					     }
					     {	/* Reduce/cse.scm 189 */
						obj_t nclause_1262;
						nclause_1262 = _res1__155___r5_control_features_6_4;
						SET_CDR(clause_1260, nclause_1262);
						{
						   obj_t reset_1913;
						   obj_t clauses_1911;
						   clauses_1911 =
						      CDR(clauses_1253);
						   if (
						      CBOOL(reset_1254))
						     {	/* Reduce/cse.scm 192 */
							reset_1913 = reset_1254;
						     }
						   else
						     {	/* Reduce/cse.scm 192 */
							reset_1913 = reset__69_1261;
						     }
						   reset_1254 = reset_1913;
						   clauses_1253 = clauses_1911;
						   goto loop_1255;
						}
					     }
					  }
				       }
				  }
			       }
			    }
			 }
			 break;
		      case ((long) 13):

			 {	/* Reduce/cse.scm 198 */
			    let_fun_218_bglt node_1268;
			    node_1268 =
			       (let_fun_218_bglt) (node_2);
			    {	/* Reduce/cse.scm 199 */
			       obj_t reset_1271;
			       reset_1271 =
				  node_cse__231_reduce_cse(
				  (((let_fun_218_bglt) CREF(node_1268))->body), stack_3);
			       {	/* Reduce/cse.scm 199 */
				  obj_t nbody_1272;
				  nbody_1272 = _res1__155___r5_control_features_6_4;
				  {	/* Reduce/cse.scm 201 */
				     node_bglt val1357_1533;
				     val1357_1533 =
					(node_bglt) (nbody_1272);
				     ((((let_fun_218_bglt) CREF(node_1268))->body) = ((node_bglt) val1357_1533), BUNSPEC);
				  }
				  {
				     obj_t locals_1273;
				     obj_t reset_1274;
				     locals_1273 =
					(((let_fun_218_bglt) CREF(node_1268))->locals);
				     reset_1274 = reset_1271;
				   loop_1275:
				     if (
					NULLP(locals_1273))
				       {	/* Reduce/cse.scm 204 */
					  _res_number__75___r5_control_features_6_4 =
					     BINT(((long) 2));
					  _res1__155___r5_control_features_6_4 =
					     (obj_t) (node_1268);
					  return reset_1274;
				       }
				     else
				       {	/* Reduce/cse.scm 206 */
					  value_bglt sfun_1281;
					  {	/* Reduce/cse.scm 207 */
					     local_bglt obj_1537;
					     {	/* Reduce/cse.scm 207 */
						obj_t aux_1926;
						aux_1926 =
						   CAR(locals_1273);
						obj_1537 =
						   (local_bglt) (aux_1926);
					     }
					     sfun_1281 =
						(((local_bglt) CREF(obj_1537))->value);
					  }
					  {	/* Reduce/cse.scm 207 */

					     {	/* Reduce/cse.scm 208 */
						obj_t reset__69_1282;
						{	/* Reduce/cse.scm 209 */
						   node_bglt aux_1930;
						   {	/* Reduce/cse.scm 209 */
						      obj_t aux_1931;
						      {		/* Reduce/cse.scm 209 */
							 sfun_bglt obj_1538;
							 obj_1538 =
							    (sfun_bglt) (sfun_1281);
							 aux_1931 =
							    (((sfun_bglt) CREF(obj_1538))->body);
						      }
						      aux_1930 =
							 (node_bglt) (aux_1931);
						   }
						   reset__69_1282 =
						      node_cse__231_reduce_cse(aux_1930, BNIL);
						}
						{	/* Reduce/cse.scm 208 */
						   obj_t nbody_1283;
						   nbody_1283 = _res1__155___r5_control_features_6_4;
						   {	/* Reduce/cse.scm 210 */
						      sfun_bglt obj_1539;
						      obj_1539 =
							 (sfun_bglt) (sfun_1281);
						      ((((sfun_bglt) CREF(obj_1539))->body) = ((obj_t) nbody_1283), BUNSPEC);
						   }
						   {
						      obj_t reset_1940;
						      obj_t locals_1938;
						      locals_1938 =
							 CDR(locals_1273);
						      if (
							 CBOOL(reset_1274))
							{	/* Reduce/cse.scm 211 */
							   reset_1940 = reset_1274;
							}
						      else
							{	/* Reduce/cse.scm 211 */
							   reset_1940 = reset__69_1282;
							}
						      reset_1274 = reset_1940;
						      locals_1273 = locals_1938;
						      goto loop_1275;
						   }
						}
					     }
					  }
				       }
				  }
			       }
			    }
			 }
			 break;
		      case ((long) 14):

			 {	/* Reduce/cse.scm 217 */
			    set_ex_it_116_bglt node_1290;
			    node_1290 =
			       (set_ex_it_116_bglt) (node_2);
			    {	/* Reduce/cse.scm 218 */
			       obj_t reset_1293;
			       reset_1293 =
				  node_cse__231_reduce_cse(
				  (((set_ex_it_116_bglt) CREF(node_1290))->body), BNIL);
			       {	/* Reduce/cse.scm 218 */
				  obj_t nbody_1294;
				  nbody_1294 = _res1__155___r5_control_features_6_4;
				  {	/* Reduce/cse.scm 220 */
				     node_bglt val1385_1544;
				     val1385_1544 =
					(node_bglt) (nbody_1294);
				     ((((set_ex_it_116_bglt) CREF(node_1290))->body) = ((node_bglt) val1385_1544), BUNSPEC);
				  }
				  _res_number__75___r5_control_features_6_4 =
				     BINT(((long) 2));
				  _res1__155___r5_control_features_6_4 =
				     (obj_t) (node_1290);
				  return reset_1293;
			       }
			    }
			 }
			 break;
		      case ((long) 15):

			 {	/* Reduce/cse.scm 227 */
			    jump_ex_it_184_bglt node_1299;
			    node_1299 =
			       (jump_ex_it_184_bglt) (node_2);
			    {	/* Reduce/cse.scm 228 */
			       obj_t reset_1302;
			       reset_1302 =
				  node_cse__231_reduce_cse(
				  (((jump_ex_it_184_bglt) CREF(node_1299))->exit), stack_3);
			       {	/* Reduce/cse.scm 228 */
				  obj_t nexit_1303;
				  nexit_1303 = _res1__155___r5_control_features_6_4;
				  {	/* Reduce/cse.scm 230 */
				     node_bglt val1394_1547;
				     val1394_1547 =
					(node_bglt) (nexit_1303);
				     ((((jump_ex_it_184_bglt) CREF(node_1299))->exit) = ((node_bglt) val1394_1547), BUNSPEC);
				  }
				  {	/* Reduce/cse.scm 232 */
				     obj_t reset__69_1305;
				     {	/* Reduce/cse.scm 233 */
					obj_t aux_1956;
					if (
					   CBOOL(reset_1302))
					  {	/* Reduce/cse.scm 231 */
					     aux_1956 = BNIL
						;
					  }
					else
					  {	/* Reduce/cse.scm 231 */
					     aux_1956 = stack_3
						;
					  }
					reset__69_1305 =
					   node_cse__231_reduce_cse(
					   (((jump_ex_it_184_bglt) CREF(node_1299))->value), aux_1956);
				     }
				     {	/* Reduce/cse.scm 232 */
					obj_t nvalue_1306;
					nvalue_1306 = _res1__155___r5_control_features_6_4;
					{	/* Reduce/cse.scm 234 */
					   node_bglt val1395_1550;
					   val1395_1550 =
					      (node_bglt) (nvalue_1306);
					   ((((jump_ex_it_184_bglt) CREF(node_1299))->value) = ((node_bglt) val1395_1550), BUNSPEC);
					}
					_res_number__75___r5_control_features_6_4 =
					   BINT(((long) 2));
					_res1__155___r5_control_features_6_4 =
					   (obj_t) (node_1299);
					if (
					   CBOOL(reset_1302))
					  {	/* Reduce/cse.scm 235 */
					     return reset_1302;
					  }
					else
					  {	/* Reduce/cse.scm 235 */
					     return reset__69_1305;
					  }
				     }
				  }
			       }
			    }
			 }
			 break;
		      case ((long) 16):

			 {	/* Reduce/cse.scm 241 */
			    make_box_202_bglt node_1312;
			    node_1312 =
			       (make_box_202_bglt) (node_2);
			    {	/* Reduce/cse.scm 242 */
			       obj_t reset_1315;
			       reset_1315 =
				  node_cse__231_reduce_cse(
				  (((make_box_202_bglt) CREF(node_1312))->value), stack_3);
			       {	/* Reduce/cse.scm 242 */
				  obj_t nvalue_1316;
				  nvalue_1316 = _res1__155___r5_control_features_6_4;
				  {	/* Reduce/cse.scm 244 */
				     node_bglt val1406_1553;
				     val1406_1553 =
					(node_bglt) (nvalue_1316);
				     ((((make_box_202_bglt) CREF(node_1312))->value) = ((node_bglt) val1406_1553), BUNSPEC);
				  }
				  _res_number__75___r5_control_features_6_4 =
				     BINT(((long) 2));
				  _res1__155___r5_control_features_6_4 =
				     (obj_t) (node_1312);
				  return reset_1315;
			       }
			    }
			 }
			 break;
		      case ((long) 17):

			 {	/* Reduce/cse.scm 251 */
			    box_set__221_bglt node_1320;
			    node_1320 =
			       (box_set__221_bglt) (node_2);
			    {	/* Reduce/cse.scm 252 */
			       obj_t reset_1323;
			       reset_1323 =
				  node_cse__231_reduce_cse(
				  (((box_set__221_bglt) CREF(node_1320))->value), stack_3);
			       {	/* Reduce/cse.scm 252 */
				  obj_t nvalue_1324;
				  nvalue_1324 = _res1__155___r5_control_features_6_4;
				  {	/* Reduce/cse.scm 254 */
				     node_bglt val1429_1556;
				     val1429_1556 =
					(node_bglt) (nvalue_1324);
				     ((((box_set__221_bglt) CREF(node_1320))->value) = ((node_bglt) val1429_1556), BUNSPEC);
				  }
				  _res_number__75___r5_control_features_6_4 =
				     BINT(((long) 2));
				  _res1__155___r5_control_features_6_4 =
				     (obj_t) (node_1320);
				  return reset_1323;
			       }
			    }
			 }
			 break;
		      case ((long) 18):

			 _res_number__75___r5_control_features_6_4 =
			    BINT(((long) 2));
			 {	/* Reduce/cse.scm 261 */
			    box_ref_242_bglt aux_1982;
			    aux_1982 =
			       (box_ref_242_bglt) (node_2);
			    _res1__155___r5_control_features_6_4 =
			       (obj_t) (aux_1982);
			 }
			 return BFALSE;
			 break;
		      case ((long) 19):

			 {	/* Reduce/cse.scm 267 */
			    app_bglt node_1332;
			    node_1332 =
			       (app_bglt) (node_2);
			    {	/* Reduce/cse.scm 268 */
			       obj_t reset_1335;
			       reset_1335 =
				  node_cse___11_reduce_cse(
				  (((app_bglt) CREF(node_1332))->args), stack_3);
			       {	/* Reduce/cse.scm 269 */
				  bool_t test1726_1336;
				  if (
				     CBOOL(reset_1335))
				    {	/* Reduce/cse.scm 269 */
				       test1726_1336 = ((bool_t) 1);
				    }
				  else
				    {	/* Reduce/cse.scm 269 */
				       test1726_1336 =
					  side_effect__165_effect_effect(
					  (node_bglt) (node_1332));
				    }
				  if (test1726_1336)
				    {	/* Reduce/cse.scm 269 */
				       _res_number__75___r5_control_features_6_4 =
					  BINT(((long) 2));
				       _res1__155___r5_control_features_6_4 =
					  (obj_t) (node_1332);
				       return BTRUE;
				    }
				  else
				    {	/* Reduce/cse.scm 274 */
				       obj_t previous_1339;
				       previous_1339 =
					  find_stack_136_reduce_cse(
					  (node_bglt) (node_1332), stack_3);
				       {	/* Reduce/cse.scm 276 */
					  bool_t test1727_1340;
					  test1727_1340 =
					     is_a__118___object(previous_1339, variable_ast_var);
					  if (test1727_1340)
					    {	/* Reduce/cse.scm 276 */
					       {	/* Reduce/cse.scm 277 */
						  long z2_1560;
						  z2_1560 = _cse_removed__19_reduce_cse;
						  _cse_removed__19_reduce_cse =
						     (((long) 1) + z2_1560);
					       }
					       {	/* Reduce/cse.scm 279 */
						  var_bglt val1_1503_1342;
						  {	/* Reduce/cse.scm 279 */
						     obj_t arg1728_1343;
						     type_bglt arg1729_1344;
						     arg1728_1343 =
							(((app_bglt) CREF(node_1332))->loc);
						     arg1729_1344 =
							(((app_bglt) CREF(node_1332))->type);
						     {	/* Reduce/cse.scm 279 */
							var_bglt res1762_1573;
							{	/* Reduce/cse.scm 279 */
							   variable_bglt variable_1565;
							   variable_1565 =
							      (variable_bglt) (previous_1339);
							   {	/* ./Ast/node.scm 1207 */
							      var_bglt new1210_1566;
							      new1210_1566 =
								 ((var_bglt) BREF(GC_MALLOC(sizeof(struct var))));
							      {		/* ./Ast/node.scm 1207 */
								 long arg1644_1567;
								 arg1644_1567 =
								    class_num_218___object(var_ast_node);
								 {	/* ./Ast/node.scm 1207 */
								    obj_t obj_1571;
								    obj_1571 =
								       (obj_t) (new1210_1566);
								    (((obj_t) CREF(obj_1571))->header = MAKE_HEADER(arg1644_1567, 0), BUNSPEC);
								 }
							      }
							      {		/* ./Ast/node.scm 1207 */
								 object_bglt aux_2007;
								 aux_2007 =
								    (object_bglt) (new1210_1566);
								 OBJECT_WIDENING_SET(aux_2007, BFALSE);
							      }
							      ((((var_bglt) CREF(new1210_1566))->loc) = ((obj_t) arg1728_1343), BUNSPEC);
							      ((((var_bglt) CREF(new1210_1566))->type) = ((type_bglt) arg1729_1344), BUNSPEC);
							      ((((var_bglt) CREF(new1210_1566))->variable) = ((variable_bglt) variable_1565), BUNSPEC);
							      res1762_1573 = new1210_1566;
							   }
							}
							val1_1503_1342 = res1762_1573;
						     }
						  }
						  _res_number__75___r5_control_features_6_4 =
						     BINT(((long) 2));
						  _res1__155___r5_control_features_6_4 =
						     (obj_t) (val1_1503_1342);
						  return stack_3;
					       }
					    }
					  else
					    {	/* Reduce/cse.scm 276 */
					       _res_number__75___r5_control_features_6_4 =
						  BINT(((long) 2));
					       _res1__155___r5_control_features_6_4 =
						  (obj_t) (node_1332);
					       return BFALSE;
					    }
				       }
				    }
			       }
			    }
			 }
			 break;
		      case ((long) 20):

			 {	/* Reduce/cse.scm 293 */
			    let_var_6_bglt node_1349;
			    node_1349 =
			       (let_var_6_bglt) (node_2);
			    {
			       obj_t bindings_1352;
			       bool_t reset_1353;
			       obj_t extend_1354;
			       bindings_1352 =
				  (((let_var_6_bglt) CREF(node_1349))->bindings);
			       reset_1353 = ((bool_t) 0);
			       extend_1354 = BNIL;
			     loop_1355:
			       if (
				  NULLP(bindings_1352))
				 {	/* Reduce/cse.scm 298 */
				    obj_t stack__1_1359;
				    if (reset_1353)
				      {		/* Reduce/cse.scm 298 */
					 stack__1_1359 = BNIL;
				      }
				    else
				      {		/* Reduce/cse.scm 298 */
					 stack__1_1359 =
					    append_2_18___r4_pairs_and_lists_6_3(extend_1354, stack_3);
				      }
				    {	/* Reduce/cse.scm 299 */
				       obj_t reset__69_1360;
				       reset__69_1360 =
					  node_cse__231_reduce_cse(
					  (((let_var_6_bglt) CREF(node_1349))->body), stack__1_1359);
				       {	/* Reduce/cse.scm 299 */
					  obj_t nbody_1361;
					  nbody_1361 = _res1__155___r5_control_features_6_4;
					  {	/* Reduce/cse.scm 301 */
					     node_bglt val1371_1578;
					     val1371_1578 =
						(node_bglt) (nbody_1361);
					     ((((let_var_6_bglt) CREF(node_1349))->body) = ((node_bglt) val1371_1578), BUNSPEC);
					  }
					  {	/* Reduce/cse.scm 303 */
					     bool_t test_2026;
					     if (reset_1353)
					       {	/* Reduce/cse.scm 303 */
						  test_2026 = ((bool_t) 1)
						     ;
					       }
					     else
					       {	/* Reduce/cse.scm 303 */
						  test_2026 =
						     CBOOL(reset__69_1360)
						     ;
					       }
					     if (test_2026)
					       {	/* Reduce/cse.scm 303 */
						  _res_number__75___r5_control_features_6_4 =
						     BINT(((long) 2));
						  _res1__155___r5_control_features_6_4 =
						     (obj_t) (node_1349);
						  return BTRUE;
					       }
					     else
					       {	/* Reduce/cse.scm 305 */
						  bool_t test1736_1365;
						  test1736_1365 =
						     side_effect__165_effect_effect(
						     (node_bglt) (node_1349));
						  if (test1736_1365)
						    {	/* Reduce/cse.scm 305 */
						       _res_number__75___r5_control_features_6_4 =
							  BINT(((long) 2));
						       _res1__155___r5_control_features_6_4 =
							  (obj_t) (node_1349);
						       return BFALSE;
						    }
						  else
						    {	/* Reduce/cse.scm 305 */
						       {	/* Reduce/cse.scm 308 */
							  obj_t previous_1368;
							  previous_1368 =
							     find_stack_136_reduce_cse(
							     (node_bglt) (node_1349), stack_3);
							  {	/* Reduce/cse.scm 310 */
							     bool_t test1737_1369;
							     test1737_1369 =
								is_a__118___object(previous_1368, variable_ast_var);
							     if (test1737_1369)
							       {	/* Reduce/cse.scm 310 */
								  {	/* Reduce/cse.scm 311 */
								     long z2_1581;
								     z2_1581 = _cse_removed__19_reduce_cse;
								     _cse_removed__19_reduce_cse =
									(((long) 1) + z2_1581);
								  }
								  {	/* Reduce/cse.scm 314 */
								     var_bglt val1_1513_1371;
								     {	/* Reduce/cse.scm 314 */
									obj_t arg1738_1372;
									type_bglt arg1739_1373;
									arg1738_1372 =
									   (((let_var_6_bglt) CREF(node_1349))->loc);
									arg1739_1373 =
									   (((let_var_6_bglt) CREF(node_1349))->type);
									{	/* Reduce/cse.scm 314 */
									   var_bglt res1763_1594;
									   {	/* Reduce/cse.scm 314 */
									      variable_bglt variable_1586;
									      variable_1586 =
										 (variable_bglt) (previous_1368);
									      {		/* ./Ast/node.scm 1207 */
										 var_bglt new1210_1587;
										 new1210_1587 =
										    ((var_bglt) BREF(GC_MALLOC(sizeof(struct var))));
										 {	/* ./Ast/node.scm 1207 */
										    long arg1644_1588;
										    arg1644_1588 =
										       class_num_218___object(var_ast_node);
										    {	/* ./Ast/node.scm 1207 */
										       obj_t obj_1592;
										       obj_1592 =
											  (obj_t) (new1210_1587);
										       (((obj_t) CREF(obj_1592))->header = MAKE_HEADER(arg1644_1588, 0), BUNSPEC);
										    }
										 }
										 {	/* ./Ast/node.scm 1207 */
										    object_bglt aux_2048;
										    aux_2048 =
										       (object_bglt) (new1210_1587);
										    OBJECT_WIDENING_SET(aux_2048, BFALSE);
										 }
										 ((((var_bglt) CREF(new1210_1587))->loc) = ((obj_t) arg1738_1372), BUNSPEC);
										 ((((var_bglt) CREF(new1210_1587))->type) = ((type_bglt) arg1739_1373), BUNSPEC);
										 ((((var_bglt) CREF(new1210_1587))->variable) = ((variable_bglt) variable_1586), BUNSPEC);
										 res1763_1594 = new1210_1587;
									      }
									   }
									   val1_1513_1371 = res1763_1594;
									}
								     }
								     _res_number__75___r5_control_features_6_4 =
									BINT(((long) 2));
								     _res1__155___r5_control_features_6_4 =
									(obj_t) (val1_1513_1371);
								     return stack__1_1359;
								  }
							       }
							     else
							       {	/* Reduce/cse.scm 310 */
								  _res_number__75___r5_control_features_6_4 =
								     BINT(((long) 2));
								  _res1__155___r5_control_features_6_4 =
								     (obj_t) (node_1349);
								  return BFALSE;
							       }
							  }
						       }
						    }
					       }
					  }
				       }
				    }
				 }
			       else
				 {	/* Reduce/cse.scm 320 */
				    obj_t binding_1378;
				    binding_1378 =
				       CAR(bindings_1352);
				    {	/* Reduce/cse.scm 321 */
				       obj_t var_1379;
				       obj_t val_1380;
				       var_1379 =
					  CAR(binding_1378);
				       val_1380 =
					  CDR(binding_1378);
				       {	/* Reduce/cse.scm 323 */
					  obj_t reset__69_1381;
					  reset__69_1381 =
					     node_cse__231_reduce_cse(
					     (node_bglt) (val_1380), stack_3);
					  {	/* Reduce/cse.scm 323 */
					     obj_t nval_1382;
					     nval_1382 = _res1__155___r5_control_features_6_4;
					     SET_CDR(binding_1378, nval_1382);
					     {	/* Reduce/cse.scm 327 */
						bool_t test_2064;
						if (reset_1353)
						  {	/* Reduce/cse.scm 327 */
						     test_2064 = ((bool_t) 1)
							;
						  }
						else
						  {	/* Reduce/cse.scm 327 */
						     test_2064 =
							CBOOL(reset__69_1381)
							;
						  }
						if (test_2064)
						  {	/* Reduce/cse.scm 327 */
						     {
							obj_t extend_2069;
							obj_t bindings_2067;
							bindings_2067 =
							   CDR(bindings_1352);
							extend_2069 = BNIL;
							extend_1354 = extend_2069;
							bindings_1352 = bindings_2067;
							goto loop_1355;
						     }
						  }
						else
						  {	/* Reduce/cse.scm 331 */
						     bool_t test_2070;
						     {	/* ./Ieee/equiv.scm 5508 */
							obj_t aux_2074;
							obj_t aux_2071;
							aux_2074 =
							   CNST_TABLE_REF(((long) 0));
							{	/* Reduce/cse.scm 331 */
							   local_bglt obj_1601;
							   obj_1601 =
							      (local_bglt) (var_1379);
							   aux_2071 =
							      (((local_bglt) CREF(obj_1601))->access);
							}
							test_2070 =
							   (aux_2071 == aux_2074);
						     }
						     if (test_2070)
						       {	/* Reduce/cse.scm 335 */
							  bool_t test1746_1387;
							  {	/* Reduce/cse.scm 335 */
							     bool_t test1751_1392;
							     test1751_1392 =
								is_a__118___object(val_1380, app_ast_node);
							     if (test1751_1392)
							       {	/* Reduce/cse.scm 335 */
								  test1746_1387 = ((bool_t) 1);
							       }
							     else
							       {	/* Reduce/cse.scm 335 */
								  test1746_1387 =
								     is_a__118___object(val_1380, let_var_6_ast_node);
							       }
							  }
							  if (test1746_1387)
							    {	/* Reduce/cse.scm 335 */
							       {	/* Reduce/cse.scm 336 */
								  obj_t arg1747_1388;
								  obj_t arg1748_1389;
								  arg1747_1388 =
								     CDR(bindings_1352);
								  {	/* Reduce/cse.scm 338 */
								     obj_t arg1749_1390;
								     {	/* Reduce/cse.scm 370 */
									obj_t new_1609;
									{	/* Reduce/cse.scm 370 */
									   obj_t aux_2082;
									   aux_2082 =
									      CNST_TABLE_REF(((long) 1));
									   new_1609 =
									      create_struct(aux_2082, ((long) 2));
									}
									STRUCT_SET(new_1609, ((long) 1), var_1379);
									STRUCT_SET(new_1609, ((long) 0), val_1380);
									arg1749_1390 = new_1609;
								     }
								     arg1748_1389 =
									MAKE_PAIR(arg1749_1390, extend_1354);
								  }
								  {
								     obj_t extend_2090;
								     bool_t reset_2089;
								     obj_t bindings_2088;
								     bindings_2088 = arg1747_1388;
								     reset_2089 = ((bool_t) 0);
								     extend_2090 = arg1748_1389;
								     extend_1354 = extend_2090;
								     reset_1353 = reset_2089;
								     bindings_1352 = bindings_2088;
								     goto loop_1355;
								  }
							       }
							    }
							  else
							    {	/* Reduce/cse.scm 335 */
							       {
								  bool_t reset_2093;
								  obj_t bindings_2091;
								  bindings_2091 =
								     CDR(bindings_1352);
								  reset_2093 = ((bool_t) 0);
								  reset_1353 = reset_2093;
								  bindings_1352 = bindings_2091;
								  goto loop_1355;
							       }
							    }
						       }
						     else
						       {	/* Reduce/cse.scm 331 */
							  {
							     bool_t reset_2096;
							     obj_t bindings_2094;
							     bindings_2094 =
								CDR(bindings_1352);
							     reset_2096 = ((bool_t) 0);
							     reset_1353 = reset_2096;
							     bindings_1352 = bindings_2094;
							     goto loop_1355;
							  }
						       }
						  }
					     }
					  }
				       }
				    }
				 }
			    }
			 }
			 break;
		      default:
		       case_else1686_1144:
			 if (
			    PROCEDUREP(method1680_1140))
			   {	/* Reduce/cse.scm 58 */
			      return
				 PROCEDURE_ENTRY(method1680_1140) (method1680_1140,
				 (obj_t) (node_2), stack_3, BEOA);
			   }
			 else
			   {	/* Reduce/cse.scm 58 */
			      obj_t fun1679_1136;
			      fun1679_1136 =
				 PROCEDURE_REF(node_cse__env_198_reduce_cse, ((long) 0));
			      return
				 PROCEDURE_ENTRY(fun1679_1136) (fun1679_1136,
				 (obj_t) (node_2), stack_3, BEOA);
			   }
		      }
		 }
	       else
		 {	/* Reduce/cse.scm 58 */
		    goto case_else1686_1144;
		 }
	    }
	 }
      }
   }
}



/* _node-cse!1765 */
obj_t 
_node_cse_1765_100_reduce_cse(obj_t env_1631, obj_t node_1632, obj_t stack_1633)
{
   AN_OBJECT;
   {	/* Reduce/cse.scm 58 */
      return
	 node_cse__231_reduce_cse(
	 (node_bglt) (node_1632), stack_1633);
   }
}



/* node-cse!-default1518 */
obj_t 
node_cse__default1518_121_reduce_cse(node_bglt node_4, obj_t stack_5)
{
   AN_OBJECT;
   {	/* Reduce/cse.scm 14 */
      FAILURE(
	 CNST_TABLE_REF(((long) 2)), string1768_reduce_cse,
	 (obj_t) (node_4));
   }
}



/* _node-cse!-default1518 */
obj_t 
_node_cse__default1518_154_reduce_cse(obj_t env_1634, obj_t node_1635, obj_t stack_1636)
{
   AN_OBJECT;
   {	/* Reduce/cse.scm 14 */
      return
	 node_cse__default1518_121_reduce_cse(
	 (node_bglt) (node_1635), stack_1636);
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_reduce_cse()
{
   AN_OBJECT;
   {	/* Reduce/cse.scm 14 */
      module_initialization_70_tools_trace(((long) 0), "REDUCE_CSE");
      module_initialization_70_tools_shape(((long) 0), "REDUCE_CSE");
      module_initialization_70_tools_speek(((long) 0), "REDUCE_CSE");
      module_initialization_70_tools_error(((long) 0), "REDUCE_CSE");
      module_initialization_70_type_type(((long) 0), "REDUCE_CSE");
      module_initialization_70_type_cache(((long) 0), "REDUCE_CSE");
      module_initialization_70_coerce_typeof(((long) 0), "REDUCE_CSE");
      module_initialization_70_coerce_coerce(((long) 0), "REDUCE_CSE");
      module_initialization_70_effect_effect(((long) 0), "REDUCE_CSE");
      module_initialization_70_ast_var(((long) 0), "REDUCE_CSE");
      module_initialization_70_ast_node(((long) 0), "REDUCE_CSE");
      module_initialization_70_ast_lvtype(((long) 0), "REDUCE_CSE");
      return
	 module_initialization_70_reduce_same(((long) 0), "REDUCE_CSE");
   }
}
