/*===========================================================================*/
/*   (Reduce/same.scm)                                                       */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;


static obj_t method_init_76_reduce_same();
extern obj_t funcall_ast_node;
extern obj_t append__79___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern long add_inlined_method__244___object(obj_t, obj_t, long);
extern obj_t fail_ast_node;
extern obj_t sequence_ast_node;
extern obj_t let_var_6_ast_node;
extern obj_t var_ast_node;
extern obj_t pragma_ast_node;
static bool_t same_node___136_reduce_same(obj_t, obj_t, obj_t);
static obj_t _same_node__185_reduce_same(obj_t, obj_t, obj_t, obj_t);
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t module_initialization_70_reduce_same(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_equivalence_6_2(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern long list_length(obj_t);
static obj_t imported_modules_init_94_reduce_same();
static bool_t same_node__default1480_60_reduce_same(node_bglt, node_bglt, obj_t);
extern obj_t app_ly_162_ast_node;
extern obj_t add_generic__110___object(obj_t, obj_t);
extern bool_t bigloo_strcmp(obj_t, obj_t);
extern obj_t app_ast_node;
static obj_t library_modules_init_112_reduce_same();
extern obj_t atom_ast_node;
extern obj_t cast_ast_node;
static obj_t toplevel_init_63_reduce_same();
extern obj_t open_input_string(obj_t);
extern obj_t kwote_ast_node;
extern obj_t _classes__134___object;
static bool_t aliased__149_reduce_same(variable_bglt, variable_bglt, obj_t);
extern obj_t read___reader(obj_t);
extern bool_t same_node__38_reduce_same(node_bglt, node_bglt, obj_t);
extern bool_t equal__25___r4_equivalence_6_2(obj_t, obj_t);
static obj_t require_initialization_114_reduce_same = BUNSPEC;
extern obj_t conditional_ast_node;
static obj_t _same_node__default1480_134_reduce_same(obj_t, obj_t, obj_t, obj_t);
static obj_t cnst_init_137_reduce_same();
static obj_t __cnst[1];

DEFINE_STATIC_PROCEDURE(same_node__default1480_env_46_reduce_same, _same_node__default1480_134_reduce_same1735, _same_node__default1480_134_reduce_same, 0L, 3);
DEFINE_STRING(string1730_reduce_same, string1730_reduce_same1736, "READ ", 5);
DEFINE_EXPORT_GENERIC(same_node__env_162_reduce_same, _same_node__185_reduce_same1737, _same_node__185_reduce_same, 0L, 3);



/* module-initialization */
obj_t 
module_initialization_70_reduce_same(long checksum_1525, char *from_1526)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_reduce_same))
	{
	   require_initialization_114_reduce_same =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_reduce_same();
	   cnst_init_137_reduce_same();
	   imported_modules_init_94_reduce_same();
	   method_init_76_reduce_same();
	   toplevel_init_63_reduce_same();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_reduce_same()
{
   AN_OBJECT;
   {	/* Reduce/same.scm 14 */
      module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "REDUCE_SAME");
      module_initialization_70___object(((long) 0), "REDUCE_SAME");
      module_initialization_70___reader(((long) 0), "REDUCE_SAME");
      module_initialization_70___r4_equivalence_6_2(((long) 0), "REDUCE_SAME");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_reduce_same()
{
   AN_OBJECT;
   {	/* Reduce/same.scm 14 */
      {		/* Reduce/same.scm 14 */
	 obj_t cnst_port_138_1518;
	 cnst_port_138_1518 =
	    open_input_string(string1730_reduce_same);
	 {
	    long i_1519;
	    i_1519 = ((long) 0);
	  loop_1520:
	    {	/* Reduce/same.scm 14 */
	       bool_t test1731_1521;
	       test1731_1521 =
		  (i_1519 == ((long) -1));
	       if (test1731_1521)
		 {	/* Reduce/same.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Reduce/same.scm 14 */
		    {	/* Reduce/same.scm 14 */
		       obj_t arg1732_1522;
		       {	/* Reduce/same.scm 14 */
			  obj_t list1733_1523;
			  list1733_1523 =
			     MAKE_PAIR(cnst_port_138_1518, BNIL);
			  arg1732_1522 =
			     read___reader(list1733_1523);
		       }
		       CNST_TABLE_SET(i_1519, arg1732_1522);
		    }
		    {	/* Reduce/same.scm 14 */
		       int aux_1524;
		       {	/* Reduce/same.scm 14 */
			  long aux_1545;
			  aux_1545 =
			     (i_1519 - ((long) 1));
			  aux_1524 =
			     (int) (aux_1545);
		       }
		       {
			  long i_1548;
			  i_1548 =
			     (long) (aux_1524);
			  i_1519 = i_1548;
			  goto loop_1520;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_reduce_same()
{
   AN_OBJECT;
   {	/* Reduce/same.scm 14 */
      return BUNSPEC;
   }
}



/* same-node*? */
bool_t 
same_node___136_reduce_same(obj_t node1_43, obj_t node2_44, obj_t alias_45)
{
   AN_OBJECT;
   {	/* Reduce/same.scm 180 */
    same_node___136_reduce_same:
      if (
	 NULLP(node1_43))
	{	/* Reduce/same.scm 182 */
	   return
	      NULLP(node2_44);
	}
      else
	{	/* Reduce/same.scm 182 */
	   if (
	      NULLP(node2_44))
	     {	/* Reduce/same.scm 184 */
		return ((bool_t) 0);
	     }
	   else
	     {	/* Reduce/same.scm 186 */
		bool_t test1507_746;
		{	/* Reduce/same.scm 186 */
		   node_bglt aux_1559;
		   node_bglt aux_1555;
		   {	/* Reduce/same.scm 186 */
		      obj_t aux_1560;
		      aux_1560 =
			 CAR(node2_44);
		      aux_1559 =
			 (node_bglt) (aux_1560);
		   }
		   {	/* Reduce/same.scm 186 */
		      obj_t aux_1556;
		      aux_1556 =
			 CAR(node1_43);
		      aux_1555 =
			 (node_bglt) (aux_1556);
		   }
		   test1507_746 =
		      same_node__38_reduce_same(aux_1555, aux_1559, alias_45);
		}
		if (test1507_746)
		  {	/* Reduce/same.scm 186 */
		     {
			obj_t node2_1567;
			obj_t node1_1565;
			node1_1565 =
			   CDR(node1_43);
			node2_1567 =
			   CDR(node2_44);
			node2_44 = node2_1567;
			node1_43 = node1_1565;
			goto same_node___136_reduce_same;
		     }
		  }
		else
		  {	/* Reduce/same.scm 186 */
		     return ((bool_t) 0);
		  }
	     }
	}
   }
}



/* aliased? */
bool_t 
aliased__149_reduce_same(variable_bglt var1_46, variable_bglt var2_47, obj_t alias_48)
{
   AN_OBJECT;
   {	/* Reduce/same.scm 194 */
      {
	 obj_t alias_751;
	 alias_751 = alias_48;
       loop_752:
	 if (
	    NULLP(alias_751))
	   {	/* Reduce/same.scm 197 */
	      return ((bool_t) 0);
	   }
	 else
	   {	/* Reduce/same.scm 199 */
	      bool_t test_1571;
	      {		/* ./Ieee/equiv.scm 5508 */
		 obj_t aux_1576;
		 obj_t aux_1572;
		 aux_1576 =
		    (obj_t) (var1_46);
		 {	/* ./Ieee/pair-list.scm 5701 */
		    obj_t aux_1573;
		    aux_1573 =
		       CAR(alias_751);
		    aux_1572 =
		       CAR(aux_1573);
		 }
		 test_1571 =
		    (aux_1572 == aux_1576);
	      }
	      if (test_1571)
		{	/* Reduce/same.scm 199 */
		   {	/* Reduce/same.scm 200 */
		      bool_t test_1579;
		      {		/* ./Ieee/equiv.scm 5508 */
			 obj_t aux_1584;
			 obj_t aux_1580;
			 aux_1584 =
			    (obj_t) (var2_47);
			 {	/* ./Ieee/pair-list.scm 5707 */
			    obj_t aux_1581;
			    aux_1581 =
			       CAR(alias_751);
			    aux_1580 =
			       CDR(aux_1581);
			 }
			 test_1579 =
			    (aux_1580 == aux_1584);
		      }
		      if (test_1579)
			{	/* Reduce/same.scm 200 */
			   return ((bool_t) 1);
			}
		      else
			{
			   obj_t alias_1587;
			   alias_1587 =
			      CDR(alias_751);
			   alias_751 = alias_1587;
			   goto loop_752;
			}
		   }
		}
	      else
		{	/* Reduce/same.scm 203 */
		   bool_t test_1589;
		   {	/* ./Ieee/equiv.scm 5508 */
		      obj_t aux_1594;
		      obj_t aux_1590;
		      aux_1594 =
			 (obj_t) (var2_47);
		      {		/* ./Ieee/pair-list.scm 5701 */
			 obj_t aux_1591;
			 aux_1591 =
			    CAR(alias_751);
			 aux_1590 =
			    CAR(aux_1591);
		      }
		      test_1589 =
			 (aux_1590 == aux_1594);
		   }
		   if (test_1589)
		     {	/* Reduce/same.scm 203 */
			{	/* Reduce/same.scm 204 */
			   bool_t test_1597;
			   {	/* ./Ieee/equiv.scm 5508 */
			      obj_t aux_1602;
			      obj_t aux_1598;
			      aux_1602 =
				 (obj_t) (var1_46);
			      {		/* ./Ieee/pair-list.scm 5707 */
				 obj_t aux_1599;
				 aux_1599 =
				    CAR(alias_751);
				 aux_1598 =
				    CDR(aux_1599);
			      }
			      test_1597 =
				 (aux_1598 == aux_1602);
			   }
			   if (test_1597)
			     {	/* Reduce/same.scm 204 */
				return ((bool_t) 1);
			     }
			   else
			     {
				obj_t alias_1605;
				alias_1605 =
				   CDR(alias_751);
				alias_751 = alias_1605;
				goto loop_752;
			     }
			}
		     }
		   else
		     {	/* Reduce/same.scm 203 */
			{
			   obj_t alias_1607;
			   alias_1607 =
			      CDR(alias_751);
			   alias_751 = alias_1607;
			   goto loop_752;
			}
		     }
		}
	   }
      }
   }
}



/* method-init */
obj_t 
method_init_76_reduce_same()
{
   AN_OBJECT;
   {	/* Reduce/same.scm 14 */
      add_generic__110___object(same_node__env_162_reduce_same, same_node__default1480_env_46_reduce_same);
      add_inlined_method__244___object(same_node__env_162_reduce_same, atom_ast_node, ((long) 0));
      add_inlined_method__244___object(same_node__env_162_reduce_same, kwote_ast_node, ((long) 1));
      add_inlined_method__244___object(same_node__env_162_reduce_same, var_ast_node, ((long) 2));
      add_inlined_method__244___object(same_node__env_162_reduce_same, sequence_ast_node, ((long) 3));
      add_inlined_method__244___object(same_node__env_162_reduce_same, app_ly_162_ast_node, ((long) 4));
      add_inlined_method__244___object(same_node__env_162_reduce_same, funcall_ast_node, ((long) 5));
      add_inlined_method__244___object(same_node__env_162_reduce_same, app_ast_node, ((long) 6));
      add_inlined_method__244___object(same_node__env_162_reduce_same, pragma_ast_node, ((long) 7));
      add_inlined_method__244___object(same_node__env_162_reduce_same, cast_ast_node, ((long) 8));
      add_inlined_method__244___object(same_node__env_162_reduce_same, conditional_ast_node, ((long) 9));
      add_inlined_method__244___object(same_node__env_162_reduce_same, fail_ast_node, ((long) 10));
      {		/* Reduce/same.scm 14 */
	 long aux_1621;
	 aux_1621 =
	    add_inlined_method__244___object(same_node__env_162_reduce_same, let_var_6_ast_node, ((long) 11));
	 return
	    BINT(aux_1621);
      }
   }
}



/* same-node? */
bool_t 
same_node__38_reduce_same(node_bglt node1_1, node_bglt node2_2, obj_t alias_3)
{
   AN_OBJECT;
   {	/* Reduce/same.scm 25 */
      {
	 obj_t method1608_1099;
	 obj_t class1613_1100;
	 {	/* Reduce/same.scm 25 */
	    obj_t arg1616_1097;
	    obj_t arg1617_1098;
	    {	/* Reduce/same.scm 25 */
	       object_bglt obj_1330;
	       obj_1330 =
		  (object_bglt) (node1_1);
	       {	/* ./Llib/object.scm 2926 */
		  obj_t pre_method_105_1331;
		  pre_method_105_1331 =
		     PROCEDURE_REF(same_node__env_162_reduce_same, ((long) 2));
		  if (
		     INTEGERP(pre_method_105_1331))
		    {	/* ./Llib/object.scm 2927 */
		       PROCEDURE_SET(same_node__env_162_reduce_same, ((long) 2), BUNSPEC);
		       arg1616_1097 = pre_method_105_1331;
		    }
		  else
		    {	/* ./Llib/object.scm 2914 */
		       long obj_class_num_177_1336;
		       obj_class_num_177_1336 =
			  TYPE(obj_1330);
		       {	/* ./Llib/object.scm 2915 */
			  obj_t arg1176_1337;
			  arg1176_1337 =
			     PROCEDURE_REF(same_node__env_162_reduce_same, ((long) 1));
			  {	/* ./Llib/object.scm 2738 */
			     long arg1177_1341;
			     {	/* ./Llib/object.scm 2738 */
				long arg1178_1342;
				arg1178_1342 =
				   OBJECT_TYPE;
				arg1177_1341 =
				   (obj_class_num_177_1336 - arg1178_1342);
			     }
			     arg1616_1097 =
				VECTOR_REF(arg1176_1337, arg1177_1341);
			  }
		       }
		    }
	       }
	    }
	    {	/* Reduce/same.scm 25 */
	       object_bglt object_1347;
	       object_1347 =
		  (object_bglt) (node1_1);
	       {	/* ./Llib/object.scm 2695 */
		  long arg1179_1348;
		  {	/* ./Llib/object.scm 2695 */
		     long arg1180_1349;
		     long arg1181_1350;
		     arg1180_1349 =
			TYPE(object_1347);
		     arg1181_1350 =
			OBJECT_TYPE;
		     arg1179_1348 =
			(arg1180_1349 - arg1181_1350);
		  }
		  {	/* ./Llib/object.scm 2695 */
		     obj_t vector_1354;
		     vector_1354 = _classes__134___object;
		     arg1617_1098 =
			VECTOR_REF(vector_1354, arg1179_1348);
		  }
	       }
	    }
	    {	/* Reduce/same.scm 25 */
	       obj_t aux_1639;
	       method1608_1099 = arg1616_1097;
	       class1613_1100 = arg1617_1098;
	       {

		  if (
		     INTEGERP(method1608_1099))
		    {	/* Reduce/same.scm 25 */
		       switch (
			  (long) CINT(method1608_1099))
			 {
			 case ((long) 0):

			    {	/* Reduce/same.scm 25 */
			       atom_bglt node_1106;
			       node_1106 =
				  (atom_bglt) (node1_1);
			       {	/* Reduce/same.scm 35 */
				  bool_t _andtest_1437_1109;
				  _andtest_1437_1109 =
				     is_a__118___object(
				     (obj_t) (node2_2), atom_ast_node);
				  if (_andtest_1437_1109)
				    {	/* Reduce/same.scm 36 */
				       bool_t test_1646;
				       {	/* ./Ieee/equiv.scm 5508 */
					  obj_t aux_1652;
					  obj_t aux_1647;
					  {	/* Reduce/same.scm 36 */
					     type_bglt aux_1653;
					     aux_1653 =
						(((node_bglt) CREF(node2_2))->type);
					     aux_1652 =
						(obj_t) (aux_1653);
					  }
					  {	/* Reduce/same.scm 36 */
					     type_bglt aux_1648;
					     {	/* Reduce/same.scm 36 */
						node_bglt obj_1357;
						obj_1357 =
						   (node_bglt) (node_1106);
						aux_1648 =
						   (((node_bglt) CREF(obj_1357))->type);
					     }
					     aux_1647 =
						(obj_t) (aux_1648);
					  }
					  test_1646 =
					     (aux_1647 == aux_1652);
				       }
				       if (test_1646)
					 {	/* Reduce/same.scm 37 */
					    bool_t aux_1657;
					    {	/* Reduce/same.scm 37 */
					       obj_t aux_1658;
					       {	/* Reduce/same.scm 37 */
						  atom_bglt obj_1362;
						  obj_1362 =
						     (atom_bglt) (node2_2);
						  aux_1658 =
						     (((atom_bglt) CREF(obj_1362))->value);
					       }
					       aux_1657 =
						  equal__25___r4_equivalence_6_2(
						  (((atom_bglt) CREF(node_1106))->value), aux_1658);
					    }
					    aux_1639 =
					       BBOOL(aux_1657);
					 }
				       else
					 {	/* Reduce/same.scm 36 */
					    aux_1639 = BFALSE
					       ;
					 }
				    }
				  else
				    {	/* Reduce/same.scm 35 */
				       aux_1639 = BFALSE
					  ;
				    }
			       }
			    }
			    break;
			 case ((long) 1):

			    {	/* Reduce/same.scm 25 */
			       kwote_bglt node_1115;
			       node_1115 =
				  (kwote_bglt) (node1_1);
			       {	/* Reduce/same.scm 46 */
				  bool_t _andtest_1439_1118;
				  _andtest_1439_1118 =
				     is_a__118___object(
				     (obj_t) (node2_2), kwote_ast_node);
				  if (_andtest_1439_1118)
				    {	/* Reduce/same.scm 47 */
				       bool_t test_1668;
				       {	/* ./Ieee/equiv.scm 5508 */
					  obj_t aux_1674;
					  obj_t aux_1669;
					  {	/* Reduce/same.scm 47 */
					     type_bglt aux_1675;
					     aux_1675 =
						(((node_bglt) CREF(node2_2))->type);
					     aux_1674 =
						(obj_t) (aux_1675);
					  }
					  {	/* Reduce/same.scm 47 */
					     type_bglt aux_1670;
					     {	/* Reduce/same.scm 47 */
						node_bglt obj_1364;
						obj_1364 =
						   (node_bglt) (node_1115);
						aux_1670 =
						   (((node_bglt) CREF(obj_1364))->type);
					     }
					     aux_1669 =
						(obj_t) (aux_1670);
					  }
					  test_1668 =
					     (aux_1669 == aux_1674);
				       }
				       if (test_1668)
					 {	/* Reduce/same.scm 48 */
					    bool_t aux_1679;
					    {	/* Reduce/same.scm 48 */
					       obj_t aux_1680;
					       {	/* Reduce/same.scm 48 */
						  kwote_bglt obj_1369;
						  obj_1369 =
						     (kwote_bglt) (node2_2);
						  aux_1680 =
						     (((kwote_bglt) CREF(obj_1369))->value);
					       }
					       aux_1679 =
						  equal__25___r4_equivalence_6_2(
						  (((kwote_bglt) CREF(node_1115))->value), aux_1680);
					    }
					    aux_1639 =
					       BBOOL(aux_1679);
					 }
				       else
					 {	/* Reduce/same.scm 47 */
					    aux_1639 = BFALSE
					       ;
					 }
				    }
				  else
				    {	/* Reduce/same.scm 46 */
				       aux_1639 = BFALSE
					  ;
				    }
			       }
			    }
			    break;
			 case ((long) 2):

			    {	/* Reduce/same.scm 25 */
			       var_bglt node_1124;
			       node_1124 =
				  (var_bglt) (node1_1);
			       {	/* Reduce/same.scm 57 */
				  bool_t _andtest_1441_1127;
				  _andtest_1441_1127 =
				     is_a__118___object(
				     (obj_t) (node2_2), var_ast_node);
				  if (_andtest_1441_1127)
				    {	/* Reduce/same.scm 58 */
				       bool_t test_1690;
				       {	/* ./Ieee/equiv.scm 5508 */
					  obj_t aux_1694;
					  obj_t aux_1691;
					  aux_1694 =
					     CNST_TABLE_REF(((long) 0));
					  {	/* Reduce/same.scm 58 */
					     variable_bglt arg1636_1139;
					     arg1636_1139 =
						(((var_bglt) CREF(node_1124))->variable);
					     aux_1691 =
						(((variable_bglt) CREF(arg1636_1139))->access);
					  }
					  test_1690 =
					     (aux_1691 == aux_1694);
				       }
				       if (test_1690)
					 {	/* Reduce/same.scm 59 */
					    bool_t test_1697;
					    {	/* ./Ieee/equiv.scm 5508 */
					       obj_t aux_1703;
					       obj_t aux_1698;
					       {	/* Reduce/same.scm 59 */
						  type_bglt aux_1704;
						  aux_1704 =
						     (((node_bglt) CREF(node2_2))->type);
						  aux_1703 =
						     (obj_t) (aux_1704);
					       }
					       {	/* Reduce/same.scm 59 */
						  type_bglt aux_1699;
						  {	/* Reduce/same.scm 59 */
						     node_bglt obj_1375;
						     obj_1375 =
							(node_bglt) (node_1124);
						     aux_1699 =
							(((node_bglt) CREF(obj_1375))->type);
						  }
						  aux_1698 =
						     (obj_t) (aux_1699);
					       }
					       test_1697 =
						  (aux_1698 == aux_1703);
					    }
					    if (test_1697)
					      {		/* Reduce/same.scm 60 */
						 bool_t _ortest_1444_1130;
						 {	/* ./Ieee/equiv.scm 5508 */
						    obj_t aux_1712;
						    obj_t aux_1708;
						    {	/* Reduce/same.scm 60 */
						       variable_bglt aux_1713;
						       {	/* Reduce/same.scm 60 */
							  var_bglt obj_1380;
							  obj_1380 =
							     (var_bglt) (node2_2);
							  aux_1713 =
							     (((var_bglt) CREF(obj_1380))->variable);
						       }
						       aux_1712 =
							  (obj_t) (aux_1713);
						    }
						    {	/* Reduce/same.scm 60 */
						       variable_bglt aux_1709;
						       aux_1709 =
							  (((var_bglt) CREF(node_1124))->variable);
						       aux_1708 =
							  (obj_t) (aux_1709);
						    }
						    _ortest_1444_1130 =
						       (aux_1708 == aux_1712);
						 }
						 if (_ortest_1444_1130)
						   {	/* Reduce/same.scm 60 */
						      aux_1639 =
							 BBOOL(_ortest_1444_1130)
							 ;
						   }
						 else
						   {	/* Reduce/same.scm 61 */
						      bool_t aux_1720;
						      {		/* Reduce/same.scm 61 */
							 variable_bglt aux_1721;
							 {	/* Reduce/same.scm 61 */
							    var_bglt obj_1384;
							    obj_1384 =
							       (var_bglt) (node2_2);
							    aux_1721 =
							       (((var_bglt) CREF(obj_1384))->variable);
							 }
							 aux_1720 =
							    aliased__149_reduce_same(
							    (((var_bglt) CREF(node_1124))->variable), aux_1721, alias_3);
						      }
						      aux_1639 =
							 BBOOL(aux_1720);
						   }
					      }
					    else
					      {		/* Reduce/same.scm 59 */
						 aux_1639 = BFALSE
						    ;
					      }
					 }
				       else
					 {	/* Reduce/same.scm 58 */
					    aux_1639 = BFALSE
					       ;
					 }
				    }
				  else
				    {	/* Reduce/same.scm 57 */
				       aux_1639 = BFALSE
					  ;
				    }
			       }
			    }
			    break;
			 case ((long) 3):

			    {	/* Reduce/same.scm 67 */
			       sequence_bglt node_1140;
			       node_1140 =
				  (sequence_bglt) (node1_1);
			       {	/* Reduce/same.scm 67 */
				  bool_t _andtest_1445_1143;
				  _andtest_1445_1143 =
				     is_a__118___object(
				     (obj_t) (node2_2), sequence_ast_node);
				  if (_andtest_1445_1143)
				    {	/* Reduce/same.scm 68 */
				       bool_t test_1731;
				       {	/* ./Ieee/equiv.scm 5508 */
					  obj_t aux_1737;
					  obj_t aux_1732;
					  {	/* Reduce/same.scm 68 */
					     type_bglt aux_1738;
					     aux_1738 =
						(((node_bglt) CREF(node2_2))->type);
					     aux_1737 =
						(obj_t) (aux_1738);
					  }
					  {	/* Reduce/same.scm 68 */
					     type_bglt aux_1733;
					     {	/* Reduce/same.scm 68 */
						node_bglt obj_1386;
						obj_1386 =
						   (node_bglt) (node_1140);
						aux_1733 =
						   (((node_bglt) CREF(obj_1386))->type);
					     }
					     aux_1732 =
						(obj_t) (aux_1733);
					  }
					  test_1731 =
					     (aux_1732 == aux_1737);
				       }
				       if (test_1731)
					 {	/* Reduce/same.scm 69 */
					    bool_t aux_1742;
					    {	/* Reduce/same.scm 69 */
					       obj_t aux_1743;
					       {	/* Reduce/same.scm 70 */
						  sequence_bglt obj_1391;
						  obj_1391 =
						     (sequence_bglt) (node2_2);
						  aux_1743 =
						     (((sequence_bglt) CREF(obj_1391))->nodes);
					       }
					       aux_1742 =
						  same_node___136_reduce_same(
						  (((sequence_bglt) CREF(node_1140))->nodes), aux_1743, alias_3);
					    }
					    aux_1639 =
					       BBOOL(aux_1742);
					 }
				       else
					 {	/* Reduce/same.scm 68 */
					    aux_1639 = BFALSE
					       ;
					 }
				    }
				  else
				    {	/* Reduce/same.scm 67 */
				       aux_1639 = BFALSE
					  ;
				    }
			       }
			    }
			    break;
			 case ((long) 4):

			    {	/* Reduce/same.scm 77 */
			       app_ly_162_bglt node_1149;
			       node_1149 =
				  (app_ly_162_bglt) (node1_1);
			       {	/* Reduce/same.scm 77 */
				  bool_t _andtest_1447_1152;
				  _andtest_1447_1152 =
				     is_a__118___object(
				     (obj_t) (node2_2), app_ly_162_ast_node);
				  if (_andtest_1447_1152)
				    {	/* Reduce/same.scm 78 */
				       bool_t test_1753;
				       {	/* ./Ieee/equiv.scm 5508 */
					  obj_t aux_1759;
					  obj_t aux_1754;
					  {	/* Reduce/same.scm 78 */
					     type_bglt aux_1760;
					     aux_1760 =
						(((node_bglt) CREF(node2_2))->type);
					     aux_1759 =
						(obj_t) (aux_1760);
					  }
					  {	/* Reduce/same.scm 78 */
					     type_bglt aux_1755;
					     {	/* Reduce/same.scm 78 */
						node_bglt obj_1393;
						obj_1393 =
						   (node_bglt) (node_1149);
						aux_1755 =
						   (((node_bglt) CREF(obj_1393))->type);
					     }
					     aux_1754 =
						(obj_t) (aux_1755);
					  }
					  test_1753 =
					     (aux_1754 == aux_1759);
				       }
				       if (test_1753)
					 {	/* Reduce/same.scm 79 */
					    bool_t _andtest_1449_1154;
					    {	/* Reduce/same.scm 79 */
					       node_bglt aux_1764;
					       {	/* Reduce/same.scm 79 */
						  app_ly_162_bglt obj_1398;
						  obj_1398 =
						     (app_ly_162_bglt) (node2_2);
						  aux_1764 =
						     (((app_ly_162_bglt) CREF(obj_1398))->fun);
					       }
					       _andtest_1449_1154 =
						  same_node__38_reduce_same(
						  (((app_ly_162_bglt) CREF(node_1149))->fun), aux_1764, alias_3);
					    }
					    if (_andtest_1449_1154)
					      {		/* Reduce/same.scm 80 */
						 bool_t aux_1770;
						 {	/* Reduce/same.scm 80 */
						    node_bglt aux_1771;
						    {	/* Reduce/same.scm 80 */
						       app_ly_162_bglt obj_1400;
						       obj_1400 =
							  (app_ly_162_bglt) (node2_2);
						       aux_1771 =
							  (((app_ly_162_bglt) CREF(obj_1400))->arg);
						    }
						    aux_1770 =
						       same_node__38_reduce_same(
						       (((app_ly_162_bglt) CREF(node_1149))->arg), aux_1771, alias_3);
						 }
						 aux_1639 =
						    BBOOL(aux_1770);
					      }
					    else
					      {		/* Reduce/same.scm 79 */
						 aux_1639 = BFALSE
						    ;
					      }
					 }
				       else
					 {	/* Reduce/same.scm 78 */
					    aux_1639 = BFALSE
					       ;
					 }
				    }
				  else
				    {	/* Reduce/same.scm 77 */
				       aux_1639 = BFALSE
					  ;
				    }
			       }
			    }
			    break;
			 case ((long) 5):

			    {	/* Reduce/same.scm 86 */
			       funcall_bglt node_1161;
			       node_1161 =
				  (funcall_bglt) (node1_1);
			       {	/* Reduce/same.scm 86 */
				  bool_t _andtest_1450_1164;
				  _andtest_1450_1164 =
				     is_a__118___object(
				     (obj_t) (node2_2), funcall_ast_node);
				  if (_andtest_1450_1164)
				    {	/* Reduce/same.scm 87 */
				       bool_t test_1781;
				       {	/* ./Ieee/equiv.scm 5508 */
					  obj_t aux_1787;
					  obj_t aux_1782;
					  {	/* Reduce/same.scm 87 */
					     type_bglt aux_1788;
					     aux_1788 =
						(((node_bglt) CREF(node2_2))->type);
					     aux_1787 =
						(obj_t) (aux_1788);
					  }
					  {	/* Reduce/same.scm 87 */
					     type_bglt aux_1783;
					     {	/* Reduce/same.scm 87 */
						node_bglt obj_1402;
						obj_1402 =
						   (node_bglt) (node_1161);
						aux_1783 =
						   (((node_bglt) CREF(obj_1402))->type);
					     }
					     aux_1782 =
						(obj_t) (aux_1783);
					  }
					  test_1781 =
					     (aux_1782 == aux_1787);
				       }
				       if (test_1781)
					 {	/* Reduce/same.scm 88 */
					    bool_t _andtest_1452_1166;
					    {	/* Reduce/same.scm 88 */
					       node_bglt aux_1792;
					       {	/* Reduce/same.scm 88 */
						  funcall_bglt obj_1407;
						  obj_1407 =
						     (funcall_bglt) (node2_2);
						  aux_1792 =
						     (((funcall_bglt) CREF(obj_1407))->fun);
					       }
					       _andtest_1452_1166 =
						  same_node__38_reduce_same(
						  (((funcall_bglt) CREF(node_1161))->fun), aux_1792, alias_3);
					    }
					    if (_andtest_1452_1166)
					      {		/* Reduce/same.scm 89 */
						 bool_t aux_1798;
						 {	/* Reduce/same.scm 89 */
						    obj_t aux_1799;
						    {	/* Reduce/same.scm 89 */
						       funcall_bglt obj_1409;
						       obj_1409 =
							  (funcall_bglt) (node2_2);
						       aux_1799 =
							  (((funcall_bglt) CREF(obj_1409))->args);
						    }
						    aux_1798 =
						       same_node___136_reduce_same(
						       (((funcall_bglt) CREF(node_1161))->args), aux_1799, alias_3);
						 }
						 aux_1639 =
						    BBOOL(aux_1798);
					      }
					    else
					      {		/* Reduce/same.scm 88 */
						 aux_1639 = BFALSE
						    ;
					      }
					 }
				       else
					 {	/* Reduce/same.scm 87 */
					    aux_1639 = BFALSE
					       ;
					 }
				    }
				  else
				    {	/* Reduce/same.scm 86 */
				       aux_1639 = BFALSE
					  ;
				    }
			       }
			    }
			    break;
			 case ((long) 6):

			    {	/* Reduce/same.scm 95 */
			       app_bglt node_1173;
			       node_1173 =
				  (app_bglt) (node1_1);
			       {	/* Reduce/same.scm 95 */
				  bool_t _andtest_1453_1176;
				  _andtest_1453_1176 =
				     is_a__118___object(
				     (obj_t) (node2_2), app_ast_node);
				  if (_andtest_1453_1176)
				    {	/* Reduce/same.scm 96 */
				       bool_t test_1809;
				       {	/* ./Ieee/equiv.scm 5508 */
					  obj_t aux_1815;
					  obj_t aux_1810;
					  {	/* Reduce/same.scm 96 */
					     type_bglt aux_1816;
					     aux_1816 =
						(((node_bglt) CREF(node2_2))->type);
					     aux_1815 =
						(obj_t) (aux_1816);
					  }
					  {	/* Reduce/same.scm 96 */
					     type_bglt aux_1811;
					     {	/* Reduce/same.scm 96 */
						node_bglt obj_1411;
						obj_1411 =
						   (node_bglt) (node_1173);
						aux_1811 =
						   (((node_bglt) CREF(obj_1411))->type);
					     }
					     aux_1810 =
						(obj_t) (aux_1811);
					  }
					  test_1809 =
					     (aux_1810 == aux_1815);
				       }
				       if (test_1809)
					 {	/* Reduce/same.scm 97 */
					    bool_t _andtest_1455_1178;
					    {	/* Reduce/same.scm 97 */
					       node_bglt aux_1824;
					       node_bglt aux_1820;
					       {	/* Reduce/same.scm 97 */
						  var_bglt aux_1825;
						  {	/* Reduce/same.scm 97 */
						     app_bglt obj_1416;
						     obj_1416 =
							(app_bglt) (node2_2);
						     aux_1825 =
							(((app_bglt) CREF(obj_1416))->fun);
						  }
						  aux_1824 =
						     (node_bglt) (aux_1825);
					       }
					       {	/* Reduce/same.scm 97 */
						  var_bglt aux_1821;
						  aux_1821 =
						     (((app_bglt) CREF(node_1173))->fun);
						  aux_1820 =
						     (node_bglt) (aux_1821);
					       }
					       _andtest_1455_1178 =
						  same_node__38_reduce_same(aux_1820, aux_1824, alias_3);
					    }
					    if (_andtest_1455_1178)
					      {		/* Reduce/same.scm 98 */
						 bool_t aux_1831;
						 {	/* Reduce/same.scm 98 */
						    obj_t aux_1832;
						    {	/* Reduce/same.scm 98 */
						       app_bglt obj_1418;
						       obj_1418 =
							  (app_bglt) (node2_2);
						       aux_1832 =
							  (((app_bglt) CREF(obj_1418))->args);
						    }
						    aux_1831 =
						       same_node___136_reduce_same(
						       (((app_bglt) CREF(node_1173))->args), aux_1832, alias_3);
						 }
						 aux_1639 =
						    BBOOL(aux_1831);
					      }
					    else
					      {		/* Reduce/same.scm 97 */
						 aux_1639 = BFALSE
						    ;
					      }
					 }
				       else
					 {	/* Reduce/same.scm 96 */
					    aux_1639 = BFALSE
					       ;
					 }
				    }
				  else
				    {	/* Reduce/same.scm 95 */
				       aux_1639 = BFALSE
					  ;
				    }
			       }
			    }
			    break;
			 case ((long) 7):

			    {	/* Reduce/same.scm 104 */
			       pragma_bglt node_1185;
			       node_1185 =
				  (pragma_bglt) (node1_1);
			       {	/* Reduce/same.scm 104 */
				  bool_t _andtest_1456_1188;
				  _andtest_1456_1188 =
				     is_a__118___object(
				     (obj_t) (node2_2), pragma_ast_node);
				  if (_andtest_1456_1188)
				    {	/* Reduce/same.scm 105 */
				       bool_t test_1842;
				       {	/* ./Ieee/equiv.scm 5508 */
					  obj_t aux_1848;
					  obj_t aux_1843;
					  {	/* Reduce/same.scm 105 */
					     type_bglt aux_1849;
					     aux_1849 =
						(((node_bglt) CREF(node2_2))->type);
					     aux_1848 =
						(obj_t) (aux_1849);
					  }
					  {	/* Reduce/same.scm 105 */
					     type_bglt aux_1844;
					     {	/* Reduce/same.scm 105 */
						node_bglt obj_1420;
						obj_1420 =
						   (node_bglt) (node_1185);
						aux_1844 =
						   (((node_bglt) CREF(obj_1420))->type);
					     }
					     aux_1843 =
						(obj_t) (aux_1844);
					  }
					  test_1842 =
					     (aux_1843 == aux_1848);
				       }
				       if (test_1842)
					 {	/* Reduce/same.scm 106 */
					    bool_t _andtest_1458_1190;
					    {	/* ./Ieee/string.scm 8101 */
					       obj_t aux_1855;
					       obj_t aux_1853;
					       {	/* Reduce/same.scm 106 */
						  pragma_bglt obj_1425;
						  obj_1425 =
						     (pragma_bglt) (node2_2);
						  aux_1855 =
						     (((pragma_bglt) CREF(obj_1425))->format);
					       }
					       aux_1853 =
						  (((pragma_bglt) CREF(node_1185))->format);
					       _andtest_1458_1190 =
						  bigloo_strcmp(aux_1853, aux_1855);
					    }
					    if (_andtest_1458_1190)
					      {		/* Reduce/same.scm 107 */
						 bool_t aux_1860;
						 {	/* Reduce/same.scm 107 */
						    obj_t aux_1861;
						    {	/* Reduce/same.scm 107 */
						       pragma_bglt obj_1429;
						       obj_1429 =
							  (pragma_bglt) (node2_2);
						       aux_1861 =
							  (((pragma_bglt) CREF(obj_1429))->args);
						    }
						    aux_1860 =
						       same_node___136_reduce_same(
						       (((pragma_bglt) CREF(node_1185))->args), aux_1861, alias_3);
						 }
						 aux_1639 =
						    BBOOL(aux_1860);
					      }
					    else
					      {		/* Reduce/same.scm 106 */
						 aux_1639 = BFALSE
						    ;
					      }
					 }
				       else
					 {	/* Reduce/same.scm 105 */
					    aux_1639 = BFALSE
					       ;
					 }
				    }
				  else
				    {	/* Reduce/same.scm 104 */
				       aux_1639 = BFALSE
					  ;
				    }
			       }
			    }
			    break;
			 case ((long) 8):

			    {	/* Reduce/same.scm 113 */
			       cast_bglt node_1197;
			       node_1197 =
				  (cast_bglt) (node1_1);
			       {	/* Reduce/same.scm 113 */
				  bool_t _andtest_1459_1200;
				  _andtest_1459_1200 =
				     is_a__118___object(
				     (obj_t) (node2_2), cast_ast_node);
				  if (_andtest_1459_1200)
				    {	/* Reduce/same.scm 114 */
				       bool_t test_1871;
				       {	/* ./Ieee/equiv.scm 5508 */
					  obj_t aux_1877;
					  obj_t aux_1872;
					  {	/* Reduce/same.scm 114 */
					     type_bglt aux_1878;
					     aux_1878 =
						(((node_bglt) CREF(node2_2))->type);
					     aux_1877 =
						(obj_t) (aux_1878);
					  }
					  {	/* Reduce/same.scm 114 */
					     type_bglt aux_1873;
					     {	/* Reduce/same.scm 114 */
						node_bglt obj_1431;
						obj_1431 =
						   (node_bglt) (node_1197);
						aux_1873 =
						   (((node_bglt) CREF(obj_1431))->type);
					     }
					     aux_1872 =
						(obj_t) (aux_1873);
					  }
					  test_1871 =
					     (aux_1872 == aux_1877);
				       }
				       if (test_1871)
					 {	/* Reduce/same.scm 115 */
					    bool_t aux_1882;
					    {	/* Reduce/same.scm 115 */
					       node_bglt aux_1883;
					       {	/* Reduce/same.scm 115 */
						  cast_bglt obj_1436;
						  obj_1436 =
						     (cast_bglt) (node2_2);
						  aux_1883 =
						     (((cast_bglt) CREF(obj_1436))->arg);
					       }
					       aux_1882 =
						  same_node__38_reduce_same(
						  (((cast_bglt) CREF(node_1197))->arg), aux_1883, alias_3);
					    }
					    aux_1639 =
					       BBOOL(aux_1882);
					 }
				       else
					 {	/* Reduce/same.scm 114 */
					    aux_1639 = BFALSE
					       ;
					 }
				    }
				  else
				    {	/* Reduce/same.scm 113 */
				       aux_1639 = BFALSE
					  ;
				    }
			       }
			    }
			    break;
			 case ((long) 9):

			    {	/* Reduce/same.scm 25 */
			       conditional_bglt node_1206;
			       node_1206 =
				  (conditional_bglt) (node1_1);
			       {	/* Reduce/same.scm 124 */
				  bool_t _andtest_1461_1209;
				  _andtest_1461_1209 =
				     is_a__118___object(
				     (obj_t) (node2_2), conditional_ast_node);
				  if (_andtest_1461_1209)
				    {	/* Reduce/same.scm 125 */
				       bool_t test_1893;
				       {	/* ./Ieee/equiv.scm 5508 */
					  obj_t aux_1899;
					  obj_t aux_1894;
					  {	/* Reduce/same.scm 125 */
					     type_bglt aux_1900;
					     aux_1900 =
						(((node_bglt) CREF(node2_2))->type);
					     aux_1899 =
						(obj_t) (aux_1900);
					  }
					  {	/* Reduce/same.scm 125 */
					     type_bglt aux_1895;
					     {	/* Reduce/same.scm 125 */
						node_bglt obj_1438;
						obj_1438 =
						   (node_bglt) (node_1206);
						aux_1895 =
						   (((node_bglt) CREF(obj_1438))->type);
					     }
					     aux_1894 =
						(obj_t) (aux_1895);
					  }
					  test_1893 =
					     (aux_1894 == aux_1899);
				       }
				       if (test_1893)
					 {	/* Reduce/same.scm 126 */
					    bool_t _andtest_1463_1211;
					    {	/* Reduce/same.scm 126 */
					       node_bglt aux_1904;
					       {	/* Reduce/same.scm 126 */
						  conditional_bglt obj_1443;
						  obj_1443 =
						     (conditional_bglt) (node2_2);
						  aux_1904 =
						     (((conditional_bglt) CREF(obj_1443))->false);
					       }
					       _andtest_1463_1211 =
						  same_node__38_reduce_same(
						  (((conditional_bglt) CREF(node_1206))->false), aux_1904, alias_3);
					    }
					    if (_andtest_1463_1211)
					      {		/* Reduce/same.scm 127 */
						 bool_t _andtest_1464_1212;
						 {	/* Reduce/same.scm 127 */
						    node_bglt aux_1910;
						    {	/* Reduce/same.scm 127 */
						       conditional_bglt obj_1445;
						       obj_1445 =
							  (conditional_bglt) (node2_2);
						       aux_1910 =
							  (((conditional_bglt) CREF(obj_1445))->true);
						    }
						    _andtest_1464_1212 =
						       same_node__38_reduce_same(
						       (((conditional_bglt) CREF(node_1206))->true), aux_1910, alias_3);
						 }
						 if (_andtest_1464_1212)
						   {	/* Reduce/same.scm 128 */
						      bool_t aux_1916;
						      {		/* Reduce/same.scm 128 */
							 node_bglt aux_1917;
							 {	/* Reduce/same.scm 128 */
							    conditional_bglt obj_1447;
							    obj_1447 =
							       (conditional_bglt) (node2_2);
							    aux_1917 =
							       (((conditional_bglt) CREF(obj_1447))->test);
							 }
							 aux_1916 =
							    same_node__38_reduce_same(
							    (((conditional_bglt) CREF(node_1206))->test), aux_1917, alias_3);
						      }
						      aux_1639 =
							 BBOOL(aux_1916);
						   }
						 else
						   {	/* Reduce/same.scm 127 */
						      aux_1639 = BFALSE
							 ;
						   }
					      }
					    else
					      {		/* Reduce/same.scm 126 */
						 aux_1639 = BFALSE
						    ;
					      }
					 }
				       else
					 {	/* Reduce/same.scm 125 */
					    aux_1639 = BFALSE
					       ;
					 }
				    }
				  else
				    {	/* Reduce/same.scm 124 */
				       aux_1639 = BFALSE
					  ;
				    }
			       }
			    }
			    break;
			 case ((long) 10):

			    {	/* Reduce/same.scm 25 */
			       fail_bglt node_1221;
			       node_1221 =
				  (fail_bglt) (node1_1);
			       {	/* Reduce/same.scm 137 */
				  bool_t _andtest_1465_1224;
				  _andtest_1465_1224 =
				     is_a__118___object(
				     (obj_t) (node2_2), fail_ast_node);
				  if (_andtest_1465_1224)
				    {	/* Reduce/same.scm 138 */
				       bool_t test_1927;
				       {	/* ./Ieee/equiv.scm 5508 */
					  obj_t aux_1933;
					  obj_t aux_1928;
					  {	/* Reduce/same.scm 138 */
					     type_bglt aux_1934;
					     aux_1934 =
						(((node_bglt) CREF(node2_2))->type);
					     aux_1933 =
						(obj_t) (aux_1934);
					  }
					  {	/* Reduce/same.scm 138 */
					     type_bglt aux_1929;
					     {	/* Reduce/same.scm 138 */
						node_bglt obj_1449;
						obj_1449 =
						   (node_bglt) (node_1221);
						aux_1929 =
						   (((node_bglt) CREF(obj_1449))->type);
					     }
					     aux_1928 =
						(obj_t) (aux_1929);
					  }
					  test_1927 =
					     (aux_1928 == aux_1933);
				       }
				       if (test_1927)
					 {	/* Reduce/same.scm 139 */
					    bool_t _andtest_1467_1226;
					    {	/* Reduce/same.scm 139 */
					       node_bglt aux_1938;
					       {	/* Reduce/same.scm 139 */
						  fail_bglt obj_1454;
						  obj_1454 =
						     (fail_bglt) (node2_2);
						  aux_1938 =
						     (((fail_bglt) CREF(obj_1454))->msg);
					       }
					       _andtest_1467_1226 =
						  same_node__38_reduce_same(
						  (((fail_bglt) CREF(node_1221))->msg), aux_1938, alias_3);
					    }
					    if (_andtest_1467_1226)
					      {		/* Reduce/same.scm 140 */
						 bool_t _andtest_1468_1227;
						 {	/* Reduce/same.scm 140 */
						    node_bglt aux_1944;
						    {	/* Reduce/same.scm 140 */
						       fail_bglt obj_1456;
						       obj_1456 =
							  (fail_bglt) (node2_2);
						       aux_1944 =
							  (((fail_bglt) CREF(obj_1456))->proc);
						    }
						    _andtest_1468_1227 =
						       same_node__38_reduce_same(
						       (((fail_bglt) CREF(node_1221))->proc), aux_1944, alias_3);
						 }
						 if (_andtest_1468_1227)
						   {	/* Reduce/same.scm 141 */
						      bool_t aux_1950;
						      {		/* Reduce/same.scm 141 */
							 node_bglt aux_1951;
							 {	/* Reduce/same.scm 141 */
							    fail_bglt obj_1458;
							    obj_1458 =
							       (fail_bglt) (node2_2);
							    aux_1951 =
							       (((fail_bglt) CREF(obj_1458))->obj);
							 }
							 aux_1950 =
							    same_node__38_reduce_same(
							    (((fail_bglt) CREF(node_1221))->obj), aux_1951, alias_3);
						      }
						      aux_1639 =
							 BBOOL(aux_1950);
						   }
						 else
						   {	/* Reduce/same.scm 140 */
						      aux_1639 = BFALSE
							 ;
						   }
					      }
					    else
					      {		/* Reduce/same.scm 139 */
						 aux_1639 = BFALSE
						    ;
					      }
					 }
				       else
					 {	/* Reduce/same.scm 138 */
					    aux_1639 = BFALSE
					       ;
					 }
				    }
				  else
				    {	/* Reduce/same.scm 137 */
				       aux_1639 = BFALSE
					  ;
				    }
			       }
			    }
			    break;
			 case ((long) 11):

			    {	/* Reduce/same.scm 25 */
			       let_var_6_bglt node_1236;
			       node_1236 =
				  (let_var_6_bglt) (node1_1);
			       {	/* Reduce/same.scm 151 */
				  bool_t _andtest_1469_1239;
				  _andtest_1469_1239 =
				     is_a__118___object(
				     (obj_t) (node2_2), let_var_6_ast_node);
				  if (_andtest_1469_1239)
				    {	/* Reduce/same.scm 152 */
				       bool_t test_1961;
				       {	/* ./Ieee/equiv.scm 5508 */
					  obj_t aux_1967;
					  obj_t aux_1962;
					  {	/* Reduce/same.scm 152 */
					     type_bglt aux_1968;
					     aux_1968 =
						(((node_bglt) CREF(node2_2))->type);
					     aux_1967 =
						(obj_t) (aux_1968);
					  }
					  {	/* Reduce/same.scm 152 */
					     type_bglt aux_1963;
					     {	/* Reduce/same.scm 152 */
						node_bglt obj_1460;
						obj_1460 =
						   (node_bglt) (node_1236);
						aux_1963 =
						   (((node_bglt) CREF(obj_1460))->type);
					     }
					     aux_1962 =
						(obj_t) (aux_1963);
					  }
					  test_1961 =
					     (aux_1962 == aux_1967);
				       }
				       if (test_1961)
					 {	/* Reduce/same.scm 153 */
					    bool_t test_1972;
					    {	/* ./Ieee/equiv.scm 5508 */
					       obj_t aux_1978;
					       obj_t aux_1973;
					       {	/* Reduce/same.scm 153 */
						  long aux_1979;
						  {	/* Reduce/same.scm 154 */
						     obj_t aux_1980;
						     {	/* Reduce/same.scm 154 */
							let_var_6_bglt obj_1465;
							obj_1465 =
							   (let_var_6_bglt) (node2_2);
							aux_1980 =
							   (((let_var_6_bglt) CREF(obj_1465))->bindings);
						     }
						     aux_1979 =
							list_length(aux_1980);
						  }
						  aux_1978 =
						     BINT(aux_1979);
					       }
					       {	/* Reduce/same.scm 153 */
						  long aux_1974;
						  aux_1974 =
						     list_length(
						     (((let_var_6_bglt) CREF(node_1236))->bindings));
						  aux_1973 =
						     BINT(aux_1974);
					       }
					       test_1972 =
						  (aux_1973 == aux_1978);
					    }
					    if (test_1972)
					      {		/* Reduce/same.scm 155 */
						 obj_t new_alias_67_1242;
						 {	/* Reduce/same.scm 155 */
						    obj_t arg1709_1269;
						    {	/* Reduce/same.scm 155 */
						       obj_t ll1472_1270;
						       obj_t ll1473_1271;
						       ll1472_1270 =
							  (((let_var_6_bglt) CREF(node_1236))->bindings);
						       {	/* Reduce/same.scm 158 */
							  let_var_6_bglt obj_1469;
							  obj_1469 =
							     (let_var_6_bglt) (node2_2);
							  ll1473_1271 =
							     (((let_var_6_bglt) CREF(obj_1469))->bindings);
						       }
						       if (
							  NULLP(ll1472_1270))
							 {	/* Reduce/same.scm 155 */
							    arg1709_1269 = BNIL;
							 }
						       else
							 {	/* Reduce/same.scm 155 */
							    obj_t head1474_1273;
							    head1474_1273 =
							       MAKE_PAIR(BNIL, BNIL);
							    {
							       obj_t ll1472_1274;
							       obj_t ll1473_1275;
							       obj_t tail1475_1276;
							       ll1472_1274 = ll1472_1270;
							       ll1473_1275 = ll1473_1271;
							       tail1475_1276 = head1474_1273;
							     lname1477_1277:
							       if (
								  NULLP(ll1472_1274))
								 {	/* Reduce/same.scm 155 */
								    arg1709_1269 =
								       CDR(head1474_1273);
								 }
							       else
								 {	/* Reduce/same.scm 156 */
								    obj_t newtail1476_1279;
								    {	/* Reduce/same.scm 156 */
								       obj_t arg1714_1282;
								       {	/* ./Ieee/pair-list.scm 5689 */
									  obj_t aux_1999;
									  obj_t aux_1995;
									  {	/* ./Ieee/pair-list.scm 5701 */
									     obj_t aux_2000;
									     aux_2000 =
										CAR(ll1473_1275);
									     aux_1999 =
										CAR(aux_2000);
									  }
									  {	/* ./Ieee/pair-list.scm 5701 */
									     obj_t aux_1996;
									     aux_1996 =
										CAR(ll1472_1274);
									     aux_1995 =
										CAR(aux_1996);
									  }
									  arg1714_1282 =
									     MAKE_PAIR(aux_1995, aux_1999);
								       }
								       newtail1476_1279 =
									  MAKE_PAIR(arg1714_1282, BNIL);
								    }
								    SET_CDR(tail1475_1276, newtail1476_1279);
								    {
								       obj_t tail1475_2010;
								       obj_t ll1473_2008;
								       obj_t ll1472_2006;
								       ll1472_2006 =
									  CDR(ll1472_1274);
								       ll1473_2008 =
									  CDR(ll1473_1275);
								       tail1475_2010 = newtail1476_1279;
								       tail1475_1276 = tail1475_2010;
								       ll1473_1275 = ll1473_2008;
								       ll1472_1274 = ll1472_2006;
								       goto lname1477_1277;
								    }
								 }
							    }
							 }
						    }
						    new_alias_67_1242 =
						       append__79___r4_pairs_and_lists_6_3(arg1709_1269, alias_3);
						 }
						 {	/* Reduce/same.scm 160 */
						    bool_t _andtest_1478_1243;
						    {	/* Reduce/same.scm 160 */
						       node_bglt aux_2012;
						       {	/* Reduce/same.scm 160 */
							  let_var_6_bglt obj_1488;
							  obj_1488 =
							     (let_var_6_bglt) (node2_2);
							  aux_2012 =
							     (((let_var_6_bglt) CREF(obj_1488))->body);
						       }
						       _andtest_1478_1243 =
							  same_node__38_reduce_same(
							  (((let_var_6_bglt) CREF(node_1236))->body), aux_2012, new_alias_67_1242);
						    }
						    if (_andtest_1478_1243)
						      {
							 obj_t bindings1_1244;
							 obj_t bindings2_1245;
							 {	/* Reduce/same.scm 161 */
							    bool_t aux_2018;
							    bindings1_1244 =
							       (((let_var_6_bglt) CREF(node_1236))->bindings);
							    {	/* Reduce/same.scm 162 */
							       let_var_6_bglt obj_1490;
							       obj_1490 =
								  (let_var_6_bglt) (node2_2);
							       bindings2_1245 =
								  (((let_var_6_bglt) CREF(obj_1490))->bindings);
							    }
							  loop_1246:
							    if (
							       NULLP(bindings1_1244))
							      {		/* Reduce/same.scm 164 */
								 aux_2018 = ((bool_t) 1);
							      }
							    else
							      {		/* Reduce/same.scm 166 */
								 bool_t test_2021;
								 {	/* Reduce/same.scm 167 */
								    bool_t test_2022;
								    {	/* ./Ieee/equiv.scm 5508 */
								       obj_t aux_2030;
								       obj_t aux_2023;
								       aux_2030 =
									  CNST_TABLE_REF(((long) 0));
								       {	/* Reduce/same.scm 167 */
									  local_bglt obj_1494;
									  {	/* Reduce/same.scm 167 */
									     obj_t aux_2024;
									     {	/* ./Ieee/pair-list.scm 5701 */
										obj_t aux_2025;
										aux_2025 =
										   CAR(bindings1_1244);
										aux_2024 =
										   CAR(aux_2025);
									     }
									     obj_1494 =
										(local_bglt) (aux_2024);
									  }
									  aux_2023 =
									     (((local_bglt) CREF(obj_1494))->access);
								       }
								       test_2022 =
									  (aux_2023 == aux_2030);
								    }
								    if (test_2022)
								      {		/* ./Ieee/equiv.scm 5508 */
									 obj_t aux_2040;
									 obj_t aux_2033;
									 aux_2040 =
									    CNST_TABLE_REF(((long) 0));
									 {	/* Reduce/same.scm 168 */
									    local_bglt obj_1499;
									    {	/* Reduce/same.scm 168 */
									       obj_t aux_2034;
									       {	/* ./Ieee/pair-list.scm 5701 */
										  obj_t aux_2035;
										  aux_2035 =
										     CAR(bindings2_1245);
										  aux_2034 =
										     CAR(aux_2035);
									       }
									       obj_1499 =
										  (local_bglt) (aux_2034);
									    }
									    aux_2033 =
									       (((local_bglt) CREF(obj_1499))->access);
									 }
									 test_2021 =
									    (aux_2033 == aux_2040);
								      }
								    else
								      {		/* Reduce/same.scm 167 */
									 test_2021 = ((bool_t) 0)
									    ;
								      }
								 }
								 if (test_2021)
								   {	/* Reduce/same.scm 170 */
								      bool_t test1691_1251;
								      {		/* Reduce/same.scm 170 */
									 node_bglt aux_2049;
									 node_bglt aux_2043;
									 {	/* Reduce/same.scm 170 */
									    obj_t aux_2050;
									    {	/* ./Ieee/pair-list.scm 5707 */
									       obj_t aux_2051;
									       aux_2051 =
										  CAR(bindings2_1245);
									       aux_2050 =
										  CDR(aux_2051);
									    }
									    aux_2049 =
									       (node_bglt) (aux_2050);
									 }
									 {	/* Reduce/same.scm 170 */
									    obj_t aux_2044;
									    {	/* ./Ieee/pair-list.scm 5707 */
									       obj_t aux_2045;
									       aux_2045 =
										  CAR(bindings1_1244);
									       aux_2044 =
										  CDR(aux_2045);
									    }
									    aux_2043 =
									       (node_bglt) (aux_2044);
									 }
									 test1691_1251 =
									    same_node__38_reduce_same(aux_2043, aux_2049, alias_3);
								      }
								      if (test1691_1251)
									{	/* Reduce/same.scm 170 */
									   {
									      obj_t bindings2_2059;
									      obj_t bindings1_2057;
									      bindings1_2057 =
										 CDR(bindings1_1244);
									      bindings2_2059 =
										 CDR(bindings2_1245);
									      bindings2_1245 = bindings2_2059;
									      bindings1_1244 = bindings1_2057;
									      goto loop_1246;
									   }
									}
								      else
									{	/* Reduce/same.scm 170 */
									   aux_2018 = ((bool_t) 0);
									}
								   }
								 else
								   {	/* Reduce/same.scm 166 */
								      aux_2018 = ((bool_t) 0);
								   }
							      }
							    aux_1639 =
							       BBOOL(aux_2018);
							 }
						      }
						    else
						      {		/* Reduce/same.scm 160 */
							 aux_1639 = BFALSE
							    ;
						      }
						 }
					      }
					    else
					      {		/* Reduce/same.scm 153 */
						 aux_1639 = BFALSE
						    ;
					      }
					 }
				       else
					 {	/* Reduce/same.scm 152 */
					    aux_1639 = BFALSE
					       ;
					 }
				    }
				  else
				    {	/* Reduce/same.scm 151 */
				       aux_1639 = BFALSE
					  ;
				    }
			       }
			    }
			    break;
			 default:
			  case_else1614_1103:
			    if (
			       PROCEDUREP(method1608_1099))
			      {		/* Reduce/same.scm 25 */
				 aux_1639 =
				    PROCEDURE_ENTRY(method1608_1099) (method1608_1099,
				    (obj_t) (node1_1),
				    (obj_t) (node2_2), alias_3, BEOA)
				    ;
			      }
			    else
			      {		/* Reduce/same.scm 25 */
				 obj_t fun1607_1095;
				 fun1607_1095 =
				    PROCEDURE_REF(same_node__env_162_reduce_same, ((long) 0));
				 aux_1639 =
				    PROCEDURE_ENTRY(fun1607_1095) (fun1607_1095,
				    (obj_t) (node1_1),
				    (obj_t) (node2_2), alias_3, BEOA);
			      }
			 }
		    }
		  else
		    {	/* Reduce/same.scm 25 */
		       goto case_else1614_1103;
		    }
	       }
	       return
		  CBOOL(aux_1639);
	    }
	 }
      }
   }
}



/* _same-node? */
obj_t 
_same_node__185_reduce_same(obj_t env_1510, obj_t node1_1511, obj_t node2_1512, obj_t alias_1513)
{
   AN_OBJECT;
   {	/* Reduce/same.scm 25 */
      {		/* Reduce/same.scm 25 */
	 bool_t aux_2079;
	 aux_2079 =
	    same_node__38_reduce_same(
	    (node_bglt) (node1_1511),
	    (node_bglt) (node2_1512), alias_1513);
	 return
	    BBOOL(aux_2079);
      }
   }
}



/* same-node?-default1480 */
bool_t 
same_node__default1480_60_reduce_same(node_bglt node1_4, node_bglt node2_5, obj_t alias_6)
{
   AN_OBJECT;
   {	/* Reduce/same.scm 14 */
      return ((bool_t) 0);
   }
}



/* _same-node?-default1480 */
obj_t 
_same_node__default1480_134_reduce_same(obj_t env_1514, obj_t node1_1515, obj_t node2_1516, obj_t alias_1517)
{
   AN_OBJECT;
   {	/* Reduce/same.scm 14 */
      {		/* Reduce/same.scm 14 */
	 bool_t aux_2084;
	 aux_2084 =
	    same_node__default1480_60_reduce_same(
	    (node_bglt) (node1_1515),
	    (node_bglt) (node2_1516), alias_1517);
	 return
	    BBOOL(aux_2084);
      }
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_reduce_same()
{
   AN_OBJECT;
   {	/* Reduce/same.scm 14 */
      module_initialization_70_tools_trace(((long) 0), "REDUCE_SAME");
      module_initialization_70_tools_shape(((long) 0), "REDUCE_SAME");
      module_initialization_70_type_type(((long) 0), "REDUCE_SAME");
      module_initialization_70_ast_var(((long) 0), "REDUCE_SAME");
      return
	 module_initialization_70_ast_node(((long) 0), "REDUCE_SAME");
   }
}
