/*===========================================================================*/
/*   (Reduce/typec.scm)                                                      */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;

typedef struct tclass
  {
     obj_t its_super_214;
     obj_t slots;
     struct global *holder;
     obj_t widening;
     long depth;
     bool_t final__12;
     obj_t constructor;
     obj_t virtual_slots_number_200;
  }
      *tclass_bglt;


static obj_t _node_typec__214_reduce_typec(obj_t, obj_t);
static obj_t method_init_76_reduce_typec();
extern obj_t make_box_202_ast_node;
extern obj_t funcall_ast_node;
extern long add_inlined_method__244___object(obj_t, obj_t, long);
extern obj_t fail_ast_node;
static node_bglt node_typec__103_reduce_typec(node_bglt);
extern obj_t type_type_type;
extern obj_t box_ref_242_ast_node;
static long _type_checks_remaining__47_reduce_typec;
extern obj_t sequence_ast_node;
extern obj_t let_var_6_ast_node;
extern obj_t var_ast_node;
extern obj_t closure_ast_node;
extern obj_t _pair__244_type_cache;
extern obj_t lvtype_node__58_ast_lvtype(node_bglt);
extern obj_t _obj__252_type_cache;
extern obj_t pragma_ast_node;
static node_bglt node_typec__default1493_108_reduce_typec(node_bglt);
extern obj_t set_ex_it_116_ast_node;
extern bool_t type_subclass__90_object_class(type_bglt, type_bglt);
extern obj_t verbose_tools_speek(obj_t, obj_t);
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t module_initialization_70_reduce_typec(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_speek(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_coerce_typeof(long, char *);
extern obj_t module_initialization_70_coerce_coerce(long, char *);
extern obj_t module_initialization_70_effect_effect(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_ast_lvtype(long, char *);
extern obj_t module_initialization_70_object_class(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t _bnil__15_type_cache;
static obj_t _reduce_type_check__78_reduce_typec(obj_t, obj_t);
extern long class_num_218___object(obj_t);
extern obj_t let_fun_218_ast_node;
static obj_t imported_modules_init_94_reduce_typec();
extern obj_t app_ly_162_ast_node;
extern obj_t add_generic__110___object(obj_t, obj_t);
static long _type_checks_removed__34_reduce_typec;
extern node_bglt coerce__182_coerce_coerce(node_bglt, type_bglt);
extern obj_t app_ast_node;
static obj_t library_modules_init_112_reduce_typec();
extern obj_t _pair_nil__157_type_cache;
extern obj_t atom_ast_node;
extern obj_t cast_ast_node;
static obj_t toplevel_init_63_reduce_typec();
extern obj_t jump_ex_it_184_ast_node;
extern obj_t open_input_string(obj_t);
extern obj_t kwote_ast_node;
extern bool_t side_effect__165_effect_effect(node_bglt);
extern obj_t setq_ast_node;
extern obj_t box_set__221_ast_node;
extern type_bglt typeof_coerce_typeof(node_bglt);
static obj_t _node_typec__default1493_149_reduce_typec(obj_t, obj_t);
extern obj_t reduce_type_check__95_reduce_typec(obj_t);
static obj_t node_typec___130_reduce_typec(obj_t);
extern obj_t _classes__134___object;
extern obj_t select_ast_node;
extern obj_t read___reader(obj_t);
static obj_t require_initialization_114_reduce_typec = BUNSPEC;
extern obj_t conditional_ast_node;
static obj_t cnst_init_137_reduce_typec();
static obj_t __cnst[2];

DEFINE_EXPORT_PROCEDURE(reduce_type_check__env_147_reduce_typec, _reduce_type_check__78_reduce_typec1759, _reduce_type_check__78_reduce_typec, 0L, 1);
DEFINE_STATIC_PROCEDURE(node_typec__default1493_env_26_reduce_typec, _node_typec__default1493_149_reduce_typec1760, _node_typec__default1493_149_reduce_typec, 0L, 1);
DEFINE_STRING(string1754_reduce_typec, string1754_reduce_typec1761, "NODE-TYPEC!-DEFAULT1493 DONE ", 29);
DEFINE_STRING(string1753_reduce_typec, string1753_reduce_typec1762, "No method for this object", 25);
DEFINE_STRING(string1752_reduce_typec, string1752_reduce_typec1763, "(remaining : ", 13);
DEFINE_STRING(string1751_reduce_typec, string1751_reduce_typec1764, "(removed : ", 11);
DEFINE_STRING(string1749_reduce_typec, string1749_reduce_typec1765, "      type check             ", 29);
DEFINE_STRING(string1750_reduce_typec, string1750_reduce_typec1766, ")\t", 2);
DEFINE_STATIC_GENERIC(node_typec__env_21_reduce_typec, _node_typec__214_reduce_typec1767, _node_typec__214_reduce_typec, 0L, 1);



/* module-initialization */
obj_t 
module_initialization_70_reduce_typec(long checksum_1571, char *from_1572)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_reduce_typec))
	{
	   require_initialization_114_reduce_typec =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_reduce_typec();
	   cnst_init_137_reduce_typec();
	   imported_modules_init_94_reduce_typec();
	   method_init_76_reduce_typec();
	   toplevel_init_63_reduce_typec();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_reduce_typec()
{
   AN_OBJECT;
   {	/* Reduce/typec.scm 14 */
      module_initialization_70___object(((long) 0), "REDUCE_TYPEC");
      module_initialization_70___reader(((long) 0), "REDUCE_TYPEC");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_reduce_typec()
{
   AN_OBJECT;
   {	/* Reduce/typec.scm 14 */
      {		/* Reduce/typec.scm 14 */
	 obj_t cnst_port_138_1564;
	 cnst_port_138_1564 =
	    open_input_string(string1754_reduce_typec);
	 {
	    long i_1565;
	    i_1565 = ((long) 1);
	  loop_1566:
	    {	/* Reduce/typec.scm 14 */
	       bool_t test1755_1567;
	       test1755_1567 =
		  (i_1565 == ((long) -1));
	       if (test1755_1567)
		 {	/* Reduce/typec.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Reduce/typec.scm 14 */
		    {	/* Reduce/typec.scm 14 */
		       obj_t arg1756_1568;
		       {	/* Reduce/typec.scm 14 */
			  obj_t list1757_1569;
			  list1757_1569 =
			     MAKE_PAIR(cnst_port_138_1564, BNIL);
			  arg1756_1568 =
			     read___reader(list1757_1569);
		       }
		       CNST_TABLE_SET(i_1565, arg1756_1568);
		    }
		    {	/* Reduce/typec.scm 14 */
		       int aux_1570;
		       {	/* Reduce/typec.scm 14 */
			  long aux_1589;
			  aux_1589 =
			     (i_1565 - ((long) 1));
			  aux_1570 =
			     (int) (aux_1589);
		       }
		       {
			  long i_1592;
			  i_1592 =
			     (long) (aux_1570);
			  i_1565 = i_1592;
			  goto loop_1566;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_reduce_typec()
{
   AN_OBJECT;
   {	/* Reduce/typec.scm 14 */
      _type_checks_remaining__47_reduce_typec = ((long) 0);
      _type_checks_removed__34_reduce_typec = ((long) 0);
      return BUNSPEC;
   }
}



/* reduce-type-check! */
obj_t 
reduce_type_check__95_reduce_typec(obj_t globals_1)
{
   AN_OBJECT;
   {	/* Reduce/typec.scm 33 */
      {		/* Reduce/typec.scm 34 */
	 obj_t list1536_804;
	 list1536_804 =
	    MAKE_PAIR(string1749_reduce_typec, BNIL);
	 verbose_tools_speek(
	    BINT(((long) 2)), list1536_804);
      }
      {
	 obj_t l1466_805;
	 l1466_805 = globals_1;
       lname1467_806:
	 if (
	    PAIRP(l1466_805))
	   {	/* Reduce/typec.scm 35 */
	      {		/* Reduce/typec.scm 36 */
		 value_bglt fun_809;
		 {	/* Reduce/typec.scm 36 */
		    global_bglt obj_1343;
		    {	/* Reduce/typec.scm 36 */
		       obj_t aux_1599;
		       aux_1599 =
			  CAR(l1466_805);
		       obj_1343 =
			  (global_bglt) (aux_1599);
		    }
		    fun_809 =
		       (((global_bglt) CREF(obj_1343))->value);
		 }
		 {	/* Reduce/typec.scm 37 */

		    {	/* Reduce/typec.scm 38 */
		       node_bglt arg1539_811;
		       {	/* Reduce/typec.scm 38 */
			  node_bglt aux_1603;
			  {	/* Reduce/typec.scm 38 */
			     obj_t aux_1604;
			     {	/* Reduce/typec.scm 37 */
				sfun_bglt obj_1344;
				obj_1344 =
				   (sfun_bglt) (fun_809);
				aux_1604 =
				   (((sfun_bglt) CREF(obj_1344))->body);
			     }
			     aux_1603 =
				(node_bglt) (aux_1604);
			  }
			  arg1539_811 =
			     node_typec__103_reduce_typec(aux_1603);
		       }
		       {	/* Reduce/typec.scm 38 */
			  sfun_bglt obj_1345;
			  obj_t val1123_1346;
			  obj_1345 =
			     (sfun_bglt) (fun_809);
			  val1123_1346 =
			     (obj_t) (arg1539_811);
			  ((((sfun_bglt) CREF(obj_1345))->body) = ((obj_t) val1123_1346), BUNSPEC);
		       }
		    }
		    BUNSPEC;
		 }
	      }
	      {
		 obj_t l1466_1612;
		 l1466_1612 =
		    CDR(l1466_805);
		 l1466_805 = l1466_1612;
		 goto lname1467_806;
	      }
	   }
	 else
	   {	/* Reduce/typec.scm 35 */
	      ((bool_t) 1);
	   }
      }
      {		/* Reduce/typec.scm 41 */
	 obj_t list1541_813;
	 {	/* Reduce/typec.scm 41 */
	    obj_t arg1544_815;
	    {	/* Reduce/typec.scm 41 */
	       obj_t arg1545_816;
	       arg1545_816 =
		  MAKE_PAIR(string1750_reduce_typec, BNIL);
	       {	/* Reduce/typec.scm 41 */
		  obj_t aux_1615;
		  aux_1615 =
		     BINT(_type_checks_removed__34_reduce_typec);
		  arg1544_815 =
		     MAKE_PAIR(aux_1615, arg1545_816);
	       }
	    }
	    list1541_813 =
	       MAKE_PAIR(string1751_reduce_typec, arg1544_815);
	 }
	 verbose_tools_speek(
	    BINT(((long) 2)), list1541_813);
      }
      {		/* Reduce/typec.scm 42 */
	 obj_t list1546_817;
	 {	/* Reduce/typec.scm 42 */
	    obj_t arg1548_819;
	    {	/* Reduce/typec.scm 42 */
	       obj_t arg1549_820;
	       {	/* Reduce/typec.scm 42 */
		  obj_t arg1550_821;
		  {	/* Reduce/typec.scm 42 */
		     obj_t aux_1621;
		     aux_1621 =
			BCHAR(((unsigned char) '\n'));
		     arg1550_821 =
			MAKE_PAIR(aux_1621, BNIL);
		  }
		  {	/* Reduce/typec.scm 42 */
		     obj_t aux_1624;
		     aux_1624 =
			BCHAR(((unsigned char) ')'));
		     arg1549_820 =
			MAKE_PAIR(aux_1624, arg1550_821);
		  }
	       }
	       {	/* Reduce/typec.scm 42 */
		  obj_t aux_1627;
		  aux_1627 =
		     BINT(_type_checks_remaining__47_reduce_typec);
		  arg1548_819 =
		     MAKE_PAIR(aux_1627, arg1549_820);
	       }
	    }
	    list1546_817 =
	       MAKE_PAIR(string1752_reduce_typec, arg1548_819);
	 }
	 verbose_tools_speek(
	    BINT(((long) 2)), list1546_817);
      }
      return globals_1;
   }
}



/* _reduce-type-check! */
obj_t 
_reduce_type_check__78_reduce_typec(obj_t env_1558, obj_t globals_1559)
{
   AN_OBJECT;
   {	/* Reduce/typec.scm 33 */
      return
	 reduce_type_check__95_reduce_typec(globals_1559);
   }
}



/* node-typec*! */
obj_t 
node_typec___130_reduce_typec(obj_t node__221_24)
{
   AN_OBJECT;
   {	/* Reduce/typec.scm 232 */
      {
	 obj_t node__221_822;
	 node__221_822 = node__221_24;
       loop_823:
	 if (
	    NULLP(node__221_822))
	   {	/* Reduce/typec.scm 234 */
	      return
		 CNST_TABLE_REF(((long) 0));
	   }
	 else
	   {	/* Reduce/typec.scm 234 */
	      {		/* Reduce/typec.scm 237 */
		 node_bglt arg1552_825;
		 {	/* Reduce/typec.scm 237 */
		    node_bglt aux_1637;
		    {	/* Reduce/typec.scm 237 */
		       obj_t aux_1638;
		       aux_1638 =
			  CAR(node__221_822);
		       aux_1637 =
			  (node_bglt) (aux_1638);
		    }
		    arg1552_825 =
		       node_typec__103_reduce_typec(aux_1637);
		 }
		 {	/* ./Ieee/pair-list.scm 5890 */
		    obj_t aux_1642;
		    aux_1642 =
		       (obj_t) (arg1552_825);
		    SET_CAR(node__221_822, aux_1642);
		 }
	      }
	      {
		 obj_t node__221_1645;
		 node__221_1645 =
		    CDR(node__221_822);
		 node__221_822 = node__221_1645;
		 goto loop_823;
	      }
	   }
      }
   }
}



/* method-init */
obj_t 
method_init_76_reduce_typec()
{
   AN_OBJECT;
   {	/* Reduce/typec.scm 14 */
      add_generic__110___object(node_typec__env_21_reduce_typec, node_typec__default1493_env_26_reduce_typec);
      add_inlined_method__244___object(node_typec__env_21_reduce_typec, atom_ast_node, ((long) 0));
      add_inlined_method__244___object(node_typec__env_21_reduce_typec, kwote_ast_node, ((long) 1));
      add_inlined_method__244___object(node_typec__env_21_reduce_typec, var_ast_node, ((long) 2));
      add_inlined_method__244___object(node_typec__env_21_reduce_typec, closure_ast_node, ((long) 3));
      add_inlined_method__244___object(node_typec__env_21_reduce_typec, sequence_ast_node, ((long) 4));
      add_inlined_method__244___object(node_typec__env_21_reduce_typec, app_ly_162_ast_node, ((long) 5));
      add_inlined_method__244___object(node_typec__env_21_reduce_typec, funcall_ast_node, ((long) 6));
      add_inlined_method__244___object(node_typec__env_21_reduce_typec, pragma_ast_node, ((long) 7));
      add_inlined_method__244___object(node_typec__env_21_reduce_typec, cast_ast_node, ((long) 8));
      add_inlined_method__244___object(node_typec__env_21_reduce_typec, setq_ast_node, ((long) 9));
      add_inlined_method__244___object(node_typec__env_21_reduce_typec, conditional_ast_node, ((long) 10));
      add_inlined_method__244___object(node_typec__env_21_reduce_typec, fail_ast_node, ((long) 11));
      add_inlined_method__244___object(node_typec__env_21_reduce_typec, select_ast_node, ((long) 12));
      add_inlined_method__244___object(node_typec__env_21_reduce_typec, let_fun_218_ast_node, ((long) 13));
      add_inlined_method__244___object(node_typec__env_21_reduce_typec, let_var_6_ast_node, ((long) 14));
      add_inlined_method__244___object(node_typec__env_21_reduce_typec, set_ex_it_116_ast_node, ((long) 15));
      add_inlined_method__244___object(node_typec__env_21_reduce_typec, jump_ex_it_184_ast_node, ((long) 16));
      add_inlined_method__244___object(node_typec__env_21_reduce_typec, make_box_202_ast_node, ((long) 17));
      add_inlined_method__244___object(node_typec__env_21_reduce_typec, box_set__221_ast_node, ((long) 18));
      add_inlined_method__244___object(node_typec__env_21_reduce_typec, box_ref_242_ast_node, ((long) 19));
      {		/* Reduce/typec.scm 14 */
	 long aux_1668;
	 aux_1668 =
	    add_inlined_method__244___object(node_typec__env_21_reduce_typec, app_ast_node, ((long) 20));
	 return
	    BINT(aux_1668);
      }
   }
}



/* node-typec! */
node_bglt 
node_typec__103_reduce_typec(node_bglt node_2)
{
   AN_OBJECT;
   {	/* Reduce/typec.scm 55 */
      {
	 obj_t method1633_1173;
	 obj_t class1638_1174;
	 {	/* Reduce/typec.scm 55 */
	    obj_t arg1641_1171;
	    obj_t arg1642_1172;
	    {	/* Reduce/typec.scm 55 */
	       object_bglt obj_1386;
	       obj_1386 =
		  (object_bglt) (node_2);
	       {	/* ./Llib/object.scm 2926 */
		  obj_t pre_method_105_1387;
		  pre_method_105_1387 =
		     PROCEDURE_REF(node_typec__env_21_reduce_typec, ((long) 2));
		  if (
		     INTEGERP(pre_method_105_1387))
		    {	/* ./Llib/object.scm 2927 */
		       PROCEDURE_SET(node_typec__env_21_reduce_typec, ((long) 2), BUNSPEC);
		       arg1641_1171 = pre_method_105_1387;
		    }
		  else
		    {	/* ./Llib/object.scm 2914 */
		       long obj_class_num_177_1392;
		       obj_class_num_177_1392 =
			  TYPE(obj_1386);
		       {	/* ./Llib/object.scm 2915 */
			  obj_t arg1176_1393;
			  arg1176_1393 =
			     PROCEDURE_REF(node_typec__env_21_reduce_typec, ((long) 1));
			  {	/* ./Llib/object.scm 2738 */
			     long arg1177_1397;
			     {	/* ./Llib/object.scm 2738 */
				long arg1178_1398;
				arg1178_1398 =
				   OBJECT_TYPE;
				arg1177_1397 =
				   (obj_class_num_177_1392 - arg1178_1398);
			     }
			     arg1641_1171 =
				VECTOR_REF(arg1176_1393, arg1177_1397);
			  }
		       }
		    }
	       }
	    }
	    {	/* Reduce/typec.scm 55 */
	       object_bglt object_1403;
	       object_1403 =
		  (object_bglt) (node_2);
	       {	/* ./Llib/object.scm 2695 */
		  long arg1179_1404;
		  {	/* ./Llib/object.scm 2695 */
		     long arg1180_1405;
		     long arg1181_1406;
		     arg1180_1405 =
			TYPE(object_1403);
		     arg1181_1406 =
			OBJECT_TYPE;
		     arg1179_1404 =
			(arg1180_1405 - arg1181_1406);
		  }
		  {	/* ./Llib/object.scm 2695 */
		     obj_t vector_1410;
		     vector_1410 = _classes__134___object;
		     arg1642_1172 =
			VECTOR_REF(vector_1410, arg1179_1404);
		  }
	       }
	    }
	    {	/* Reduce/typec.scm 55 */
	       obj_t aux_1686;
	       method1633_1173 = arg1641_1171;
	       class1638_1174 = arg1642_1172;
	       {

		  if (
		     INTEGERP(method1633_1173))
		    {	/* Reduce/typec.scm 55 */
		       switch (
			  (long) CINT(method1633_1173))
			 {
			 case ((long) 0):

			    {	/* Reduce/typec.scm 55 */
			       atom_bglt aux_1689;
			       aux_1689 =
				  (atom_bglt) (node_2);
			       aux_1686 =
				  (obj_t) (aux_1689);
			    }
			    break;
			 case ((long) 1):

			    {	/* Reduce/typec.scm 55 */
			       kwote_bglt aux_1692;
			       aux_1692 =
				  (kwote_bglt) (node_2);
			       aux_1686 =
				  (obj_t) (aux_1692);
			    }
			    break;
			 case ((long) 2):

			    {	/* Reduce/typec.scm 55 */
			       var_bglt aux_1695;
			       aux_1695 =
				  (var_bglt) (node_2);
			       aux_1686 =
				  (obj_t) (aux_1695);
			    }
			    break;
			 case ((long) 3):

			    {	/* Reduce/typec.scm 55 */
			       closure_bglt aux_1698;
			       aux_1698 =
				  (closure_bglt) (node_2);
			       aux_1686 =
				  (obj_t) (aux_1698);
			    }
			    break;
			 case ((long) 4):

			    {	/* Reduce/typec.scm 85 */
			       sequence_bglt node_1184;
			       node_1184 =
				  (sequence_bglt) (node_2);
			       node_typec___130_reduce_typec(
				  (((sequence_bglt) CREF(node_1184))->nodes));
			       aux_1686 =
				  (obj_t) (node_1184);
			    }
			    break;
			 case ((long) 5):

			    {	/* Reduce/typec.scm 93 */
			       app_ly_162_bglt node_1187;
			       node_1187 =
				  (app_ly_162_bglt) (node_2);
			       {	/* Reduce/typec.scm 94 */
				  node_bglt arg1647_1189;
				  arg1647_1189 =
				     node_typec__103_reduce_typec(
				     (((app_ly_162_bglt) CREF(node_1187))->fun));
				  ((((app_ly_162_bglt) CREF(node_1187))->fun) = ((node_bglt) arg1647_1189), BUNSPEC);
			       }
			       {	/* Reduce/typec.scm 95 */
				  node_bglt arg1649_1191;
				  arg1649_1191 =
				     node_typec__103_reduce_typec(
				     (((app_ly_162_bglt) CREF(node_1187))->arg));
				  ((((app_ly_162_bglt) CREF(node_1187))->arg) = ((node_bglt) arg1649_1191), BUNSPEC);
			       }
			       aux_1686 =
				  (obj_t) (node_1187);
			    }
			    break;
			 case ((long) 6):

			    {	/* Reduce/typec.scm 102 */
			       funcall_bglt node_1193;
			       node_1193 =
				  (funcall_bglt) (node_2);
			       {	/* Reduce/typec.scm 103 */
				  node_bglt arg1651_1195;
				  arg1651_1195 =
				     node_typec__103_reduce_typec(
				     (((funcall_bglt) CREF(node_1193))->fun));
				  ((((funcall_bglt) CREF(node_1193))->fun) = ((node_bglt) arg1651_1195), BUNSPEC);
			       }
			       node_typec___130_reduce_typec(
				  (((funcall_bglt) CREF(node_1193))->args));
			       aux_1686 =
				  (obj_t) (node_1193);
			    }
			    break;
			 case ((long) 7):

			    {	/* Reduce/typec.scm 111 */
			       pragma_bglt node_1198;
			       node_1198 =
				  (pragma_bglt) (node_2);
			       node_typec___130_reduce_typec(
				  (((pragma_bglt) CREF(node_1198))->args));
			       aux_1686 =
				  (obj_t) (node_1198);
			    }
			    break;
			 case ((long) 8):

			    {	/* Reduce/typec.scm 119 */
			       cast_bglt node_1201;
			       node_1201 =
				  (cast_bglt) (node_2);
			       node_typec__103_reduce_typec(
				  (((cast_bglt) CREF(node_1201))->arg));
			       aux_1686 =
				  (obj_t) (node_1201);
			    }
			    break;
			 case ((long) 9):

			    {	/* Reduce/typec.scm 127 */
			       setq_bglt node_1204;
			       node_1204 =
				  (setq_bglt) (node_2);
			       {	/* Reduce/typec.scm 128 */
				  node_bglt arg1656_1206;
				  arg1656_1206 =
				     node_typec__103_reduce_typec(
				     (((setq_bglt) CREF(node_1204))->value));
				  ((((setq_bglt) CREF(node_1204))->value) = ((node_bglt) arg1656_1206), BUNSPEC);
			       }
			       {	/* Reduce/typec.scm 129 */
				  node_bglt arg1658_1208;
				  {	/* Reduce/typec.scm 129 */
				     node_bglt aux_1732;
				     {	/* Reduce/typec.scm 129 */
					var_bglt aux_1733;
					aux_1733 =
					   (((setq_bglt) CREF(node_1204))->var);
					aux_1732 =
					   (node_bglt) (aux_1733);
				     }
				     arg1658_1208 =
					node_typec__103_reduce_typec(aux_1732);
				  }
				  {	/* Reduce/typec.scm 129 */
				     var_bglt val1302_1430;
				     val1302_1430 =
					(var_bglt) (arg1658_1208);
				     ((((setq_bglt) CREF(node_1204))->var) = ((var_bglt) val1302_1430), BUNSPEC);
				  }
			       }
			       aux_1686 =
				  (obj_t) (node_1204);
			    }
			    break;
			 case ((long) 10):

			    {	/* Reduce/typec.scm 136 */
			       conditional_bglt node_1210;
			       node_1210 =
				  (conditional_bglt) (node_2);
			       {	/* Reduce/typec.scm 137 */
				  node_bglt arg1660_1212;
				  arg1660_1212 =
				     node_typec__103_reduce_typec(
				     (((conditional_bglt) CREF(node_1210))->test));
				  ((((conditional_bglt) CREF(node_1210))->test) = ((node_bglt) arg1660_1212), BUNSPEC);
			       }
			       {	/* Reduce/typec.scm 138 */
				  node_bglt arg1662_1214;
				  arg1662_1214 =
				     node_typec__103_reduce_typec(
				     (((conditional_bglt) CREF(node_1210))->true));
				  ((((conditional_bglt) CREF(node_1210))->true) = ((node_bglt) arg1662_1214), BUNSPEC);
			       }
			       {	/* Reduce/typec.scm 139 */
				  node_bglt arg1664_1216;
				  arg1664_1216 =
				     node_typec__103_reduce_typec(
				     (((conditional_bglt) CREF(node_1210))->false));
				  ((((conditional_bglt) CREF(node_1210))->false) = ((node_bglt) arg1664_1216), BUNSPEC);
			       }
			       aux_1686 =
				  (obj_t) (node_1210);
			    }
			    break;
			 case ((long) 11):

			    {	/* Reduce/typec.scm 146 */
			       fail_bglt node_1218;
			       node_1218 =
				  (fail_bglt) (node_2);
			       {	/* Reduce/typec.scm 147 */
				  node_bglt arg1666_1220;
				  arg1666_1220 =
				     node_typec__103_reduce_typec(
				     (((fail_bglt) CREF(node_1218))->proc));
				  ((((fail_bglt) CREF(node_1218))->proc) = ((node_bglt) arg1666_1220), BUNSPEC);
			       }
			       {	/* Reduce/typec.scm 148 */
				  node_bglt arg1669_1222;
				  arg1669_1222 =
				     node_typec__103_reduce_typec(
				     (((fail_bglt) CREF(node_1218))->msg));
				  ((((fail_bglt) CREF(node_1218))->msg) = ((node_bglt) arg1669_1222), BUNSPEC);
			       }
			       {	/* Reduce/typec.scm 149 */
				  node_bglt arg1671_1224;
				  arg1671_1224 =
				     node_typec__103_reduce_typec(
				     (((fail_bglt) CREF(node_1218))->obj));
				  ((((fail_bglt) CREF(node_1218))->obj) = ((node_bglt) arg1671_1224), BUNSPEC);
			       }
			       aux_1686 =
				  (obj_t) (node_1218);
			    }
			    break;
			 case ((long) 12):

			    {	/* Reduce/typec.scm 156 */
			       select_bglt node_1226;
			       node_1226 =
				  (select_bglt) (node_2);
			       {	/* Reduce/typec.scm 157 */
				  node_bglt arg1673_1228;
				  arg1673_1228 =
				     node_typec__103_reduce_typec(
				     (((select_bglt) CREF(node_1226))->test));
				  ((((select_bglt) CREF(node_1226))->test) = ((node_bglt) arg1673_1228), BUNSPEC);
			       }
			       {
				  obj_t l1477_1230;
				  l1477_1230 =
				     (((select_bglt) CREF(node_1226))->clauses);
				lname1478_1231:
				  if (
				     PAIRP(l1477_1230))
				    {	/* Reduce/typec.scm 158 */
				       {	/* Reduce/typec.scm 159 */
					  obj_t clause_1234;
					  clause_1234 =
					     CAR(l1477_1230);
					  {	/* Reduce/typec.scm 159 */
					     node_bglt arg1677_1235;
					     {	/* Reduce/typec.scm 159 */
						node_bglt aux_1769;
						{	/* Reduce/typec.scm 159 */
						   obj_t aux_1770;
						   aux_1770 =
						      CDR(clause_1234);
						   aux_1769 =
						      (node_bglt) (aux_1770);
						}
						arg1677_1235 =
						   node_typec__103_reduce_typec(aux_1769);
					     }
					     {	/* ./Ieee/pair-list.scm 5896 */
						obj_t aux_1774;
						aux_1774 =
						   (obj_t) (arg1677_1235);
						SET_CDR(clause_1234, aux_1774);
					     }
					  }
				       }
				       {
					  obj_t l1477_1777;
					  l1477_1777 =
					     CDR(l1477_1230);
					  l1477_1230 = l1477_1777;
					  goto lname1478_1231;
				       }
				    }
				  else
				    {	/* Reduce/typec.scm 158 */
				       ((bool_t) 1);
				    }
			       }
			       aux_1686 =
				  (obj_t) (node_1226);
			    }
			    break;
			 case ((long) 13):

			    {	/* Reduce/typec.scm 167 */
			       let_fun_218_bglt node_1238;
			       node_1238 =
				  (let_fun_218_bglt) (node_2);
			       {
				  obj_t l1480_1240;
				  l1480_1240 =
				     (((let_fun_218_bglt) CREF(node_1238))->locals);
				lname1481_1241:
				  if (
				     PAIRP(l1480_1240))
				    {	/* Reduce/typec.scm 168 */
				       {	/* Reduce/typec.scm 169 */
					  value_bglt fun_1245;
					  {	/* Reduce/typec.scm 169 */
					     local_bglt obj_1462;
					     {	/* Reduce/typec.scm 169 */
						obj_t aux_1784;
						aux_1784 =
						   CAR(l1480_1240);
						obj_1462 =
						   (local_bglt) (aux_1784);
					     }
					     fun_1245 =
						(((local_bglt) CREF(obj_1462))->value);
					  }
					  {	/* Reduce/typec.scm 170 */
					     node_bglt arg1682_1246;
					     {	/* Reduce/typec.scm 170 */
						node_bglt aux_1788;
						{	/* Reduce/typec.scm 170 */
						   obj_t aux_1789;
						   {	/* Reduce/typec.scm 170 */
						      sfun_bglt obj_1463;
						      obj_1463 =
							 (sfun_bglt) (fun_1245);
						      aux_1789 =
							 (((sfun_bglt) CREF(obj_1463))->body);
						   }
						   aux_1788 =
						      (node_bglt) (aux_1789);
						}
						arg1682_1246 =
						   node_typec__103_reduce_typec(aux_1788);
					     }
					     {	/* Reduce/typec.scm 170 */
						sfun_bglt obj_1464;
						obj_t val1123_1465;
						obj_1464 =
						   (sfun_bglt) (fun_1245);
						val1123_1465 =
						   (obj_t) (arg1682_1246);
						((((sfun_bglt) CREF(obj_1464))->body) = ((obj_t) val1123_1465), BUNSPEC);
					     }
					  }
				       }
				       {
					  obj_t l1480_1797;
					  l1480_1797 =
					     CDR(l1480_1240);
					  l1480_1240 = l1480_1797;
					  goto lname1481_1241;
				       }
				    }
				  else
				    {	/* Reduce/typec.scm 168 */
				       ((bool_t) 1);
				    }
			       }
			       {	/* Reduce/typec.scm 172 */
				  node_bglt arg1685_1249;
				  arg1685_1249 =
				     node_typec__103_reduce_typec(
				     (((let_fun_218_bglt) CREF(node_1238))->body));
				  ((((let_fun_218_bglt) CREF(node_1238))->body) = ((node_bglt) arg1685_1249), BUNSPEC);
			       }
			       aux_1686 =
				  (obj_t) (node_1238);
			    }
			    break;
			 case ((long) 14):

			    {	/* Reduce/typec.scm 179 */
			       let_var_6_bglt node_1251;
			       node_1251 =
				  (let_var_6_bglt) (node_2);
			       {
				  obj_t l1483_1253;
				  l1483_1253 =
				     (((let_var_6_bglt) CREF(node_1251))->bindings);
				lname1484_1254:
				  if (
				     PAIRP(l1483_1253))
				    {	/* Reduce/typec.scm 180 */
				       {	/* Reduce/typec.scm 181 */
					  obj_t binding_1257;
					  binding_1257 =
					     CAR(l1483_1253);
					  {	/* Reduce/typec.scm 181 */
					     node_bglt arg1689_1258;
					     {	/* Reduce/typec.scm 181 */
						node_bglt aux_1808;
						{	/* Reduce/typec.scm 181 */
						   obj_t aux_1809;
						   aux_1809 =
						      CDR(binding_1257);
						   aux_1808 =
						      (node_bglt) (aux_1809);
						}
						arg1689_1258 =
						   node_typec__103_reduce_typec(aux_1808);
					     }
					     {	/* ./Ieee/pair-list.scm 5896 */
						obj_t aux_1813;
						aux_1813 =
						   (obj_t) (arg1689_1258);
						SET_CDR(binding_1257, aux_1813);
					     }
					  }
				       }
				       {
					  obj_t l1483_1816;
					  l1483_1816 =
					     CDR(l1483_1253);
					  l1483_1253 = l1483_1816;
					  goto lname1484_1254;
				       }
				    }
				  else
				    {	/* Reduce/typec.scm 180 */
				       ((bool_t) 1);
				    }
			       }
			       {	/* Reduce/typec.scm 183 */
				  node_bglt arg1692_1261;
				  arg1692_1261 =
				     node_typec__103_reduce_typec(
				     (((let_var_6_bglt) CREF(node_1251))->body));
				  ((((let_var_6_bglt) CREF(node_1251))->body) = ((node_bglt) arg1692_1261), BUNSPEC);
			       }
			       aux_1686 =
				  (obj_t) (node_1251);
			    }
			    break;
			 case ((long) 15):

			    {	/* Reduce/typec.scm 190 */
			       set_ex_it_116_bglt node_1263;
			       node_1263 =
				  (set_ex_it_116_bglt) (node_2);
			       {	/* Reduce/typec.scm 191 */
				  node_bglt arg1694_1265;
				  arg1694_1265 =
				     node_typec__103_reduce_typec(
				     (((set_ex_it_116_bglt) CREF(node_1263))->body));
				  ((((set_ex_it_116_bglt) CREF(node_1263))->body) = ((node_bglt) arg1694_1265), BUNSPEC);
			       }
			       {	/* Reduce/typec.scm 192 */
				  node_bglt arg1696_1267;
				  {	/* Reduce/typec.scm 192 */
				     node_bglt aux_1827;
				     {	/* Reduce/typec.scm 192 */
					var_bglt aux_1828;
					aux_1828 =
					   (((set_ex_it_116_bglt) CREF(node_1263))->var);
					aux_1827 =
					   (node_bglt) (aux_1828);
				     }
				     arg1696_1267 =
					node_typec__103_reduce_typec(aux_1827);
				  }
				  {	/* Reduce/typec.scm 192 */
				     var_bglt val1384_1485;
				     val1384_1485 =
					(var_bglt) (arg1696_1267);
				     ((((set_ex_it_116_bglt) CREF(node_1263))->var) = ((var_bglt) val1384_1485), BUNSPEC);
				  }
			       }
			       aux_1686 =
				  (obj_t) (node_1263);
			    }
			    break;
			 case ((long) 16):

			    {	/* Reduce/typec.scm 199 */
			       jump_ex_it_184_bglt node_1269;
			       node_1269 =
				  (jump_ex_it_184_bglt) (node_2);
			       {	/* Reduce/typec.scm 200 */
				  node_bglt arg1698_1271;
				  arg1698_1271 =
				     node_typec__103_reduce_typec(
				     (((jump_ex_it_184_bglt) CREF(node_1269))->exit));
				  ((((jump_ex_it_184_bglt) CREF(node_1269))->exit) = ((node_bglt) arg1698_1271), BUNSPEC);
			       }
			       {	/* Reduce/typec.scm 201 */
				  node_bglt arg1700_1273;
				  arg1700_1273 =
				     node_typec__103_reduce_typec(
				     (((jump_ex_it_184_bglt) CREF(node_1269))->value));
				  ((((jump_ex_it_184_bglt) CREF(node_1269))->value) = ((node_bglt) arg1700_1273), BUNSPEC);
			       }
			       aux_1686 =
				  (obj_t) (node_1269);
			    }
			    break;
			 case ((long) 17):

			    {	/* Reduce/typec.scm 208 */
			       make_box_202_bglt node_1275;
			       node_1275 =
				  (make_box_202_bglt) (node_2);
			       {	/* Reduce/typec.scm 209 */
				  node_bglt arg1702_1277;
				  arg1702_1277 =
				     node_typec__103_reduce_typec(
				     (((make_box_202_bglt) CREF(node_1275))->value));
				  ((((make_box_202_bglt) CREF(node_1275))->value) = ((node_bglt) arg1702_1277), BUNSPEC);
			       }
			       aux_1686 =
				  (obj_t) (node_1275);
			    }
			    break;
			 case ((long) 18):

			    {	/* Reduce/typec.scm 216 */
			       box_set__221_bglt node_1279;
			       node_1279 =
				  (box_set__221_bglt) (node_2);
			       {	/* Reduce/typec.scm 217 */
				  node_bglt arg1704_1281;
				  {	/* Reduce/typec.scm 217 */
				     node_bglt aux_1849;
				     {	/* Reduce/typec.scm 217 */
					var_bglt aux_1850;
					aux_1850 =
					   (((box_set__221_bglt) CREF(node_1279))->var);
					aux_1849 =
					   (node_bglt) (aux_1850);
				     }
				     arg1704_1281 =
					node_typec__103_reduce_typec(aux_1849);
				  }
				  {	/* Reduce/typec.scm 217 */
				     var_bglt val1428_1497;
				     val1428_1497 =
					(var_bglt) (arg1704_1281);
				     ((((box_set__221_bglt) CREF(node_1279))->var) = ((var_bglt) val1428_1497), BUNSPEC);
				  }
			       }
			       {	/* Reduce/typec.scm 218 */
				  node_bglt arg1706_1283;
				  arg1706_1283 =
				     node_typec__103_reduce_typec(
				     (((box_set__221_bglt) CREF(node_1279))->value));
				  ((((box_set__221_bglt) CREF(node_1279))->value) = ((node_bglt) arg1706_1283), BUNSPEC);
			       }
			       aux_1686 =
				  (obj_t) (node_1279);
			    }
			    break;
			 case ((long) 19):

			    {	/* Reduce/typec.scm 225 */
			       box_ref_242_bglt node_1285;
			       node_1285 =
				  (box_ref_242_bglt) (node_2);
			       {	/* Reduce/typec.scm 226 */
				  node_bglt arg1708_1287;
				  {	/* Reduce/typec.scm 226 */
				     node_bglt aux_1861;
				     {	/* Reduce/typec.scm 226 */
					var_bglt aux_1862;
					aux_1862 =
					   (((box_ref_242_bglt) CREF(node_1285))->var);
					aux_1861 =
					   (node_bglt) (aux_1862);
				     }
				     arg1708_1287 =
					node_typec__103_reduce_typec(aux_1861);
				  }
				  {	/* Reduce/typec.scm 226 */
				     var_bglt val1418_1503;
				     val1418_1503 =
					(var_bglt) (arg1708_1287);
				     ((((box_ref_242_bglt) CREF(node_1285))->var) = ((var_bglt) val1418_1503), BUNSPEC);
				  }
			       }
			       aux_1686 =
				  (obj_t) (node_1285);
			    }
			    break;
			 case ((long) 20):

			    {	/* Reduce/typec.scm 55 */
			       app_bglt node_1289;
			       node_1289 =
				  (app_bglt) (node_2);
			       {
				  obj_t typec_1323;
				  type_bglt typep_1324;
				  node_typec___130_reduce_typec(
				     (((app_bglt) CREF(node_1289))->args));
				  {	/* Reduce/typec.scm 262 */
				     variable_bglt var_1293;
				     {	/* Reduce/typec.scm 262 */
					var_bglt arg1735_1322;
					arg1735_1322 =
					   (((app_bglt) CREF(node_1289))->fun);
					var_1293 =
					   (((var_bglt) CREF(arg1735_1322))->variable);
				     }
				     {	/* Reduce/typec.scm 262 */
					obj_t typec_1294;
					{	/* Reduce/typec.scm 263 */
					   fun_bglt obj_1508;
					   {	/* Reduce/typec.scm 263 */
					      value_bglt aux_1874;
					      aux_1874 =
						 (((variable_bglt) CREF(var_1293))->value);
					      obj_1508 =
						 (fun_bglt) (aux_1874);
					   }
					   typec_1294 =
					      (((fun_bglt) CREF(obj_1508))->predicate_of_78);
					}
					{	/* Reduce/typec.scm 263 */
					   type_bglt type_1295;
					   type_1295 =
					      typeof_coerce_typeof(
					      (node_bglt) (node_1289));
					   {	/* Reduce/typec.scm 264 */

					      {		/* Reduce/typec.scm 265 */
						 bool_t test1712_1296;
						 {	/* Reduce/typec.scm 265 */
						    bool_t test_1880;
						    {	/* ./Ieee/pair-list.scm 5669 */
						       obj_t aux_1881;
						       aux_1881 =
							  (((app_bglt) CREF(node_1289))->args);
						       test_1880 =
							  PAIRP(aux_1881);
						    }
						    if (test_1880)
						      {		/* Reduce/typec.scm 266 */
							 bool_t test_1884;
							 {	/* ./Ieee/pair-list.scm 5912 */
							    obj_t aux_1885;
							    {	/* ./Ieee/pair-list.scm 5707 */
							       obj_t aux_1886;
							       aux_1886 =
								  (((app_bglt) CREF(node_1289))->args);
							       aux_1885 =
								  CDR(aux_1886);
							    }
							    test_1884 =
							       NULLP(aux_1885);
							 }
							 if (test_1884)
							   {	/* Reduce/typec.scm 267 */
							      bool_t test1727_1314;
							      test1727_1314 =
								 is_a__118___object(typec_1294, type_type_type);
							      if (test1727_1314)
								{	/* Reduce/typec.scm 268 */
								   bool_t test1728_1315;
								   {	/* Reduce/typec.scm 268 */
								      node_bglt aux_1892;
								      {		/* Reduce/typec.scm 268 */
									 obj_t aux_1893;
									 {	/* ./Ieee/pair-list.scm 5701 */
									    obj_t aux_1894;
									    aux_1894 =
									       (((app_bglt) CREF(node_1289))->args);
									    aux_1893 =
									       CAR(aux_1894);
									 }
									 aux_1892 =
									    (node_bglt) (aux_1893);
								      }
								      test1728_1315 =
									 side_effect__165_effect_effect(aux_1892);
								   }
								   if (test1728_1315)
								     {	/* Reduce/typec.scm 268 */
									test1712_1296 = ((bool_t) 0);
								     }
								   else
								     {	/* Reduce/typec.scm 268 */
									test1712_1296 = ((bool_t) 1);
								     }
								}
							      else
								{	/* Reduce/typec.scm 267 */
								   test1712_1296 = ((bool_t) 0);
								}
							   }
							 else
							   {	/* Reduce/typec.scm 266 */
							      test1712_1296 = ((bool_t) 0);
							   }
						      }
						    else
						      {		/* Reduce/typec.scm 265 */
							 test1712_1296 = ((bool_t) 0);
						      }
						 }
						 if (test1712_1296)
						   {	/* Reduce/typec.scm 269 */
						      type_bglt typep_1297;
						      {		/* Reduce/typec.scm 269 */
							 node_bglt aux_1901;
							 {	/* Reduce/typec.scm 269 */
							    obj_t aux_1902;
							    {	/* ./Ieee/pair-list.scm 5701 */
							       obj_t aux_1903;
							       aux_1903 =
								  (((app_bglt) CREF(node_1289))->args);
							       aux_1902 =
								  CAR(aux_1903);
							    }
							    aux_1901 =
							       (node_bglt) (aux_1902);
							 }
							 typep_1297 =
							    typeof_coerce_typeof(aux_1901);
						      }
						      {		/* Reduce/typec.scm 271 */
							 bool_t test1713_1298;
							 {	/* Reduce/typec.scm 271 */
							    bool_t test1718_1305;
							    {	/* Reduce/typec.scm 271 */
							       obj_t obj2_1520;
							       obj2_1520 = _obj__252_type_cache;
							       {	/* ./Ieee/equiv.scm 5508 */
								  obj_t aux_1908;
								  aux_1908 =
								     (obj_t) (typep_1297);
								  test1718_1305 =
								     (aux_1908 == obj2_1520);
							       }
							    }
							    if (test1718_1305)
							      {		/* Reduce/typec.scm 271 */
								 test1713_1298 = ((bool_t) 1);
							      }
							    else
							      {		/* Reduce/typec.scm 271 */
								 bool_t test1719_1306;
								 test1719_1306 =
								    type_subclass__90_object_class(
								    (type_bglt) (typec_1294), typep_1297);
								 if (test1719_1306)
								   {	/* Reduce/typec.scm 271 */
								      test1713_1298 = ((bool_t) 1);
								   }
								 else
								   {	/* Reduce/typec.scm 272 */
								      bool_t test1720_1307;
								      {		/* Reduce/typec.scm 272 */
									 bool_t test1721_1308;
									 {	/* Reduce/typec.scm 272 */
									    bool_t test1722_1309;
									    {	/* Reduce/typec.scm 272 */
									       obj_t obj2_1522;
									       obj2_1522 = _pair__244_type_cache;
									       {	/* ./Ieee/equiv.scm 5508 */
										  obj_t aux_1915;
										  aux_1915 =
										     (obj_t) (typep_1297);
										  test1722_1309 =
										     (aux_1915 == obj2_1522);
									       }
									    }
									    if (test1722_1309)
									      {		/* Reduce/typec.scm 272 */
										 test1721_1308 = ((bool_t) 1);
									      }
									    else
									      {		/* Reduce/typec.scm 272 */
										 obj_t obj2_1524;
										 obj2_1524 = _bnil__15_type_cache;
										 {	/* ./Ieee/equiv.scm 5508 */
										    obj_t aux_1919;
										    aux_1919 =
										       (obj_t) (typep_1297);
										    test1721_1308 =
										       (aux_1919 == obj2_1524);
										 }
									      }
									 }
									 if (test1721_1308)
									   {	/* Reduce/typec.scm 273 */
									      obj_t obj2_1526;
									      obj2_1526 = _pair_nil__157_type_cache;
									      test1720_1307 =
										 (typec_1294 == obj2_1526);
									   }
									 else
									   {	/* Reduce/typec.scm 272 */
									      test1720_1307 = ((bool_t) 0);
									   }
								      }
								      if (test1720_1307)
									{	/* Reduce/typec.scm 272 */
									   test1713_1298 = ((bool_t) 1);
									}
								      else
									{	/* Reduce/typec.scm 274 */
									   obj_t obj2_1528;
									   obj2_1528 = _pair_nil__157_type_cache;
									   {	/* ./Ieee/equiv.scm 5508 */
									      obj_t aux_1925;
									      aux_1925 =
										 (obj_t) (typep_1297);
									      test1713_1298 =
										 (aux_1925 == obj2_1528);
									   }
									}
								   }
							      }
							 }
							 if (test1713_1298)
							   {	/* Reduce/typec.scm 271 */
							      {		/* Reduce/typec.scm 276 */
								 long z2_1530;
								 z2_1530 = _type_checks_remaining__47_reduce_typec;
								 _type_checks_remaining__47_reduce_typec =
								    (((long) 1) + z2_1530);
							      }
							      aux_1686 =
								 (obj_t) (node_1289);
							   }
							 else
							   {	/* Reduce/typec.scm 271 */
							      {		/* Reduce/typec.scm 285 */
								 long z2_1532;
								 z2_1532 = _type_checks_removed__34_reduce_typec;
								 _type_checks_removed__34_reduce_typec =
								    (((long) 1) + z2_1532);
							      }
							      {		/* Reduce/typec.scm 286 */
								 bool_t check_val_123_1299;
								 typec_1323 = typec_1294;
								 typep_1324 = typep_1297;
								 {	/* Reduce/typec.scm 251 */
								    bool_t test_1932;
								    {	/* ./Ieee/equiv.scm 5508 */
								       obj_t aux_1933;
								       aux_1933 =
									  (obj_t) (typep_1324);
								       test_1932 =
									  (typec_1323 == aux_1933);
								    }
								    if (test_1932)
								      {		/* Reduce/typec.scm 251 */
									 check_val_123_1299 = ((bool_t) 1);
								      }
								    else
								      {		/* Reduce/typec.scm 253 */
									 bool_t test1738_1327;
									 test1738_1327 =
									    type_subclass__90_object_class(typep_1324,
									    (type_bglt) (typec_1323));
									 if (test1738_1327)
									   {	/* Reduce/typec.scm 253 */
									      check_val_123_1299 = ((bool_t) 1);
									   }
									 else
									   {	/* Reduce/typec.scm 255 */
									      bool_t test1739_1328;
									      {		/* Reduce/typec.scm 255 */
										 bool_t test1740_1329;
										 {	/* Reduce/typec.scm 255 */
										    bool_t test1741_1330;
										    {	/* Reduce/typec.scm 255 */
										       obj_t obj2_1548;
										       obj2_1548 = _pair__244_type_cache;
										       test1741_1330 =
											  (typec_1323 == obj2_1548);
										    }
										    if (test1741_1330)
										      {		/* Reduce/typec.scm 255 */
											 test1740_1329 = ((bool_t) 1);
										      }
										    else
										      {		/* Reduce/typec.scm 255 */
											 obj_t obj2_1550;
											 obj2_1550 = _bnil__15_type_cache;
											 test1740_1329 =
											    (typec_1323 == obj2_1550);
										      }
										 }
										 if (test1740_1329)
										   {	/* Reduce/typec.scm 256 */
										      obj_t obj2_1552;
										      obj2_1552 = _pair_nil__157_type_cache;
										      {		/* ./Ieee/equiv.scm 5508 */
											 obj_t aux_1943;
											 aux_1943 =
											    (obj_t) (typep_1324);
											 test1739_1328 =
											    (aux_1943 == obj2_1552);
										      }
										   }
										 else
										   {	/* Reduce/typec.scm 255 */
										      test1739_1328 = ((bool_t) 0);
										   }
									      }
									      if (test1739_1328)
										{	/* Reduce/typec.scm 255 */
										   check_val_123_1299 = ((bool_t) 1);
										}
									      else
										{	/* Reduce/typec.scm 255 */
										   check_val_123_1299 = ((bool_t) 0);
										}
									   }
								      }
								 }
								 {	/* Reduce/typec.scm 287 */
								    node_bglt node_1300;
								    {	/* Reduce/typec.scm 287 */
								       atom_bglt arg1714_1301;
								       {	/* Reduce/typec.scm 287 */
									  obj_t arg1715_1302;
									  arg1715_1302 =
									     (((app_bglt) CREF(node_1289))->loc);
									  {	/* Reduce/typec.scm 287 */
									     atom_bglt res1747_1544;
									     {	/* Reduce/typec.scm 287 */
										obj_t value_1536;
										value_1536 =
										   BBOOL(check_val_123_1299);
										{	/* ./Ast/node.scm 1108 */
										   atom_bglt new1202_1537;
										   new1202_1537 =
										      ((atom_bglt) BREF(GC_MALLOC(sizeof(struct atom))));
										   {	/* ./Ast/node.scm 1108 */
										      long arg1603_1538;
										      arg1603_1538 =
											 class_num_218___object(atom_ast_node);
										      {		/* ./Ast/node.scm 1108 */
											 obj_t obj_1542;
											 obj_1542 =
											    (obj_t) (new1202_1537);
											 (((obj_t) CREF(obj_1542))->header = MAKE_HEADER(arg1603_1538, 0), BUNSPEC);
										      }
										   }
										   {	/* ./Ast/node.scm 1108 */
										      object_bglt aux_1953;
										      aux_1953 =
											 (object_bglt) (new1202_1537);
										      OBJECT_WIDENING_SET(aux_1953, BFALSE);
										   }
										   ((((atom_bglt) CREF(new1202_1537))->loc) = ((obj_t) arg1715_1302), BUNSPEC);
										   ((((atom_bglt) CREF(new1202_1537))->type) = ((type_bglt) type_1295), BUNSPEC);
										   ((((atom_bglt) CREF(new1202_1537))->value) = ((obj_t) value_1536), BUNSPEC);
										   res1747_1544 = new1202_1537;
										}
									     }
									     arg1714_1301 = res1747_1544;
									  }
								       }
								       node_1300 =
									  coerce__182_coerce_coerce(
									  (node_bglt) (arg1714_1301), type_1295);
								    }
								    lvtype_node__58_ast_lvtype(node_1300);
								    aux_1686 =
								       (obj_t) (node_1300);
								 }
							      }
							   }
						      }
						   }
						 else
						   {	/* Reduce/typec.scm 265 */
						      aux_1686 =
							 (obj_t) (node_1289)
							 ;
						   }
					      }
					   }
					}
				     }
				  }
			       }
			    }
			    break;
			 default:
			  case_else1639_1177:
			    if (
			       PROCEDUREP(method1633_1173))
			      {		/* Reduce/typec.scm 55 */
				 aux_1686 =
				    PROCEDURE_ENTRY(method1633_1173) (method1633_1173,
				    (obj_t) (node_2), BEOA)
				    ;
			      }
			    else
			      {		/* Reduce/typec.scm 55 */
				 obj_t fun1632_1169;
				 fun1632_1169 =
				    PROCEDURE_REF(node_typec__env_21_reduce_typec, ((long) 0));
				 aux_1686 =
				    PROCEDURE_ENTRY(fun1632_1169) (fun1632_1169,
				    (obj_t) (node_2), BEOA);
			      }
			 }
		    }
		  else
		    {	/* Reduce/typec.scm 55 */
		       goto case_else1639_1177;
		    }
	       }
	       return
		  (node_bglt) (aux_1686);
	    }
	 }
      }
   }
}



/* _node-typec! */
obj_t 
_node_typec__214_reduce_typec(obj_t env_1560, obj_t node_1561)
{
   AN_OBJECT;
   {	/* Reduce/typec.scm 55 */
      {		/* Reduce/typec.scm 55 */
	 node_bglt aux_1976;
	 aux_1976 =
	    node_typec__103_reduce_typec(
	    (node_bglt) (node_1561));
	 return
	    (obj_t) (aux_1976);
      }
   }
}



/* node-typec!-default1493 */
node_bglt 
node_typec__default1493_108_reduce_typec(node_bglt node_3)
{
   AN_OBJECT;
   {	/* Reduce/typec.scm 14 */
      FAILURE(
	 CNST_TABLE_REF(((long) 1)), string1753_reduce_typec,
	 (obj_t) (node_3));
   }
}



/* _node-typec!-default1493 */
obj_t 
_node_typec__default1493_149_reduce_typec(obj_t env_1562, obj_t node_1563)
{
   AN_OBJECT;
   {	/* Reduce/typec.scm 14 */
      {		/* Reduce/typec.scm 14 */
	 node_bglt aux_1983;
	 aux_1983 =
	    node_typec__default1493_108_reduce_typec(
	    (node_bglt) (node_1563));
	 return
	    (obj_t) (aux_1983);
      }
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_reduce_typec()
{
   AN_OBJECT;
   {	/* Reduce/typec.scm 14 */
      module_initialization_70_tools_trace(((long) 0), "REDUCE_TYPEC");
      module_initialization_70_tools_shape(((long) 0), "REDUCE_TYPEC");
      module_initialization_70_tools_speek(((long) 0), "REDUCE_TYPEC");
      module_initialization_70_tools_error(((long) 0), "REDUCE_TYPEC");
      module_initialization_70_type_type(((long) 0), "REDUCE_TYPEC");
      module_initialization_70_type_cache(((long) 0), "REDUCE_TYPEC");
      module_initialization_70_coerce_typeof(((long) 0), "REDUCE_TYPEC");
      module_initialization_70_coerce_coerce(((long) 0), "REDUCE_TYPEC");
      module_initialization_70_effect_effect(((long) 0), "REDUCE_TYPEC");
      module_initialization_70_ast_var(((long) 0), "REDUCE_TYPEC");
      module_initialization_70_ast_node(((long) 0), "REDUCE_TYPEC");
      module_initialization_70_ast_lvtype(((long) 0), "REDUCE_TYPEC");
      return
	 module_initialization_70_object_class(((long) 0), "REDUCE_TYPEC");
   }
}
