/*===========================================================================*/
/*   (Reduce/walk.scm)                                                       */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;


static obj_t method_init_76_reduce_walk();
static obj_t _reduce_walk__13_reduce_walk(obj_t, obj_t);
extern obj_t _optim__89_engine_param;
extern obj_t current_error_port;
extern obj_t _nb_error_on_pass__70_tools_error;
extern obj_t reduce_copy__103_reduce_copy(obj_t);
extern obj_t verbose_tools_speek(obj_t, obj_t);
extern obj_t module_initialization_70_reduce_walk(long, char *);
extern obj_t module_initialization_70_tools_speek(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_engine_pass(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_reduce_copy(long, char *);
extern obj_t module_initialization_70_reduce_cse(long, char *);
extern obj_t module_initialization_70_reduce_cond(long, char *);
extern obj_t module_initialization_70_reduce_typec(long, char *);
extern obj_t module_initialization_70_reduce_1occ(long, char *);
extern obj_t module_initialization_70_ast_remove(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_numbers_6_5(long, char *);
extern obj_t module_initialization_70___r4_output_6_10_3(long, char *);
extern obj_t reduce_1occ__237_reduce_1occ(obj_t);
extern obj_t display_2_122___r4_output_6_10_3(obj_t, obj_t);
static obj_t imported_modules_init_94_reduce_walk();
static obj_t library_modules_init_112_reduce_walk();
extern obj_t reduce_conditional__50_reduce_cond(obj_t);
extern obj_t open_input_string(obj_t);
extern obj_t string_to_bstring(char *);
extern obj_t reduce_walk__148_reduce_walk(obj_t);
extern obj_t remove_var_123_ast_remove(obj_t, obj_t);
extern obj_t internal_error_43_tools_error(obj_t, obj_t, obj_t);
extern obj_t reduce_type_check__95_reduce_typec(obj_t);
extern obj_t reduce_cse__211_reduce_cse(obj_t);
extern bool_t _2__206___r4_numbers_6_5(obj_t, obj_t);
extern obj_t read___reader(obj_t);
static obj_t require_initialization_114_reduce_walk = BUNSPEC;
static obj_t cnst_init_137_reduce_walk();
extern obj_t _current_pass__25_engine_pass;
static obj_t __cnst[2];

DEFINE_EXPORT_PROCEDURE(reduce_walk__env_82_reduce_walk, _reduce_walk__13_reduce_walk1563, _reduce_walk__13_reduce_walk, 0L, 1);
DEFINE_STRING(string1558_reduce_walk, string1558_reduce_walk1564, "REDUCE PASS-STARTED ", 20);
DEFINE_STRING(string1557_reduce_walk, string1557_reduce_walk1565, "failure during postlude hook", 28);
DEFINE_STRING(string1556_reduce_walk, string1556_reduce_walk1566, " occured, ending ...", 20);
DEFINE_STRING(string1555_reduce_walk, string1555_reduce_walk1567, " error", 6);
DEFINE_STRING(string1554_reduce_walk, string1554_reduce_walk1568, "failure during prelude hook", 27);
DEFINE_STRING(string1553_reduce_walk, string1553_reduce_walk1569, "   . ", 5);
DEFINE_STRING(string1552_reduce_walk, string1552_reduce_walk1570, "Reduction", 9);



/* module-initialization */
obj_t 
module_initialization_70_reduce_walk(long checksum_1091, char *from_1092)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_reduce_walk))
	{
	   require_initialization_114_reduce_walk =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_reduce_walk();
	   cnst_init_137_reduce_walk();
	   imported_modules_init_94_reduce_walk();
	   method_init_76_reduce_walk();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_reduce_walk()
{
   AN_OBJECT;
   {	/* Reduce/walk.scm 14 */
      module_initialization_70___r4_output_6_10_3(((long) 0), "REDUCE_WALK");
      module_initialization_70___r4_numbers_6_5(((long) 0), "REDUCE_WALK");
      module_initialization_70___reader(((long) 0), "REDUCE_WALK");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_reduce_walk()
{
   AN_OBJECT;
   {	/* Reduce/walk.scm 14 */
      {		/* Reduce/walk.scm 14 */
	 obj_t cnst_port_138_1084;
	 cnst_port_138_1084 =
	    open_input_string(string1558_reduce_walk);
	 {
	    long i_1085;
	    i_1085 = ((long) 1);
	  loop_1086:
	    {	/* Reduce/walk.scm 14 */
	       bool_t test1559_1087;
	       test1559_1087 =
		  (i_1085 == ((long) -1));
	       if (test1559_1087)
		 {	/* Reduce/walk.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Reduce/walk.scm 14 */
		    {	/* Reduce/walk.scm 14 */
		       obj_t arg1560_1088;
		       {	/* Reduce/walk.scm 14 */
			  obj_t list1561_1089;
			  list1561_1089 =
			     MAKE_PAIR(cnst_port_138_1084, BNIL);
			  arg1560_1088 =
			     read___reader(list1561_1089);
		       }
		       CNST_TABLE_SET(i_1085, arg1560_1088);
		    }
		    {	/* Reduce/walk.scm 14 */
		       int aux_1090;
		       {	/* Reduce/walk.scm 14 */
			  long aux_1109;
			  aux_1109 =
			     (i_1085 - ((long) 1));
			  aux_1090 =
			     (int) (aux_1109);
		       }
		       {
			  long i_1112;
			  i_1112 =
			     (long) (aux_1090);
			  i_1085 = i_1112;
			  goto loop_1086;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* reduce-walk! */
obj_t 
reduce_walk__148_reduce_walk(obj_t globals_1)
{
   AN_OBJECT;
   {	/* Reduce/walk.scm 33 */
      {		/* Reduce/walk.scm 33 */
	 obj_t list1438_697;
	 {	/* Reduce/walk.scm 33 */
	    obj_t arg1440_699;
	    {	/* Reduce/walk.scm 33 */
	       obj_t arg1442_701;
	       {	/* Reduce/walk.scm 33 */
		  obj_t aux_1114;
		  aux_1114 =
		     BCHAR(((unsigned char) '\n'));
		  arg1442_701 =
		     MAKE_PAIR(aux_1114, BNIL);
	       }
	       arg1440_699 =
		  MAKE_PAIR(string1552_reduce_walk, arg1442_701);
	    }
	    list1438_697 =
	       MAKE_PAIR(string1553_reduce_walk, arg1440_699);
	 }
	 verbose_tools_speek(
	    BINT(((long) 1)), list1438_697);
      }
      _nb_error_on_pass__70_tools_error =
	 BINT(((long) 0));
      _current_pass__25_engine_pass = string1552_reduce_walk;
      {
	 obj_t hooks_702;
	 obj_t hnames_703;
	 hooks_702 = BNIL;
	 hnames_703 = BNIL;
       loop_704:
	 if (
	    NULLP(hooks_702))
	   {	/* Reduce/walk.scm 33 */
	      CNST_TABLE_REF(((long) 0));
	   }
	 else
	   {	/* Reduce/walk.scm 33 */
	      bool_t test1447_709;
	      {		/* Reduce/walk.scm 33 */
		 obj_t fun1455_715;
		 fun1455_715 =
		    CAR(hooks_702);
		 {	/* Reduce/walk.scm 33 */
		    obj_t aux_1126;
		    aux_1126 =
		       PROCEDURE_ENTRY(fun1455_715) (fun1455_715, BEOA);
		    test1447_709 =
		       CBOOL(aux_1126);
		 }
	      }
	      if (test1447_709)
		{	/* Reduce/walk.scm 33 */
		   {
		      obj_t hnames_1133;
		      obj_t hooks_1131;
		      hooks_1131 =
			 CDR(hooks_702);
		      hnames_1133 =
			 CDR(hnames_703);
		      hnames_703 = hnames_1133;
		      hooks_702 = hooks_1131;
		      goto loop_704;
		   }
		}
	      else
		{	/* Reduce/walk.scm 33 */
		   internal_error_43_tools_error(string1552_reduce_walk, string1554_reduce_walk,
		      CAR(hnames_703));
		}
	   }
      }
      reduce_copy__103_reduce_copy(globals_1);
      {		/* Reduce/walk.scm 36 */
	 bool_t test1456_716;
	 {	/* Reduce/walk.scm 36 */
	    long n1_1068;
	    n1_1068 =
	       (long) CINT(_optim__89_engine_param);
	    test1456_716 =
	       (n1_1068 >= ((long) 2));
	 }
	 if (test1456_716)
	   {	/* Reduce/walk.scm 36 */
	      reduce_cse__211_reduce_cse(globals_1);
	   }
	 else
	   {	/* Reduce/walk.scm 36 */
	      BUNSPEC;
	   }
      }
      reduce_type_check__95_reduce_typec(globals_1);
      reduce_copy__103_reduce_copy(globals_1);
      reduce_conditional__50_reduce_cond(globals_1);
      reduce_1occ__237_reduce_1occ(globals_1);
      {		/* Reduce/walk.scm 41 */
	 obj_t value_717;
	 value_717 =
	    remove_var_123_ast_remove(
	    CNST_TABLE_REF(((long) 1)), globals_1);
	 {	/* Reduce/walk.scm 41 */
	    bool_t test1457_718;
	    {	/* Reduce/walk.scm 41 */
	       long n1_1070;
	       n1_1070 =
		  (long) CINT(_nb_error_on_pass__70_tools_error);
	       test1457_718 =
		  (n1_1070 > ((long) 0));
	    }
	    if (test1457_718)
	      {		/* Reduce/walk.scm 41 */
		 display_2_122___r4_output_6_10_3(_nb_error_on_pass__70_tools_error, current_error_port);
		 display_2_122___r4_output_6_10_3(string1555_reduce_walk, current_error_port);
		 {	/* Reduce/walk.scm 41 */
		    char *arg1458_720;
		    {	/* Reduce/walk.scm 41 */
		       bool_t test1459_721;
		       {	/* Reduce/walk.scm 41 */
			  bool_t test1460_722;
			  {	/* Reduce/walk.scm 41 */
			     obj_t obj_1072;
			     obj_1072 = _nb_error_on_pass__70_tools_error;
			     test1460_722 =
				INTEGERP(obj_1072);
			  }
			  if (test1460_722)
			    {	/* Reduce/walk.scm 41 */
			       test1459_721 =
				  _2__206___r4_numbers_6_5(_nb_error_on_pass__70_tools_error,
				  BINT(((long) 1)));
			    }
			  else
			    {	/* Reduce/walk.scm 41 */
			       test1459_721 = ((bool_t) 0);
			    }
		       }
		       if (test1459_721)
			 {	/* Reduce/walk.scm 41 */
			    arg1458_720 = "s";
			 }
		       else
			 {	/* Reduce/walk.scm 41 */
			    arg1458_720 = "";
			 }
		    }
		    display_2_122___r4_output_6_10_3(
		       string_to_bstring(arg1458_720), current_error_port);
		 }
		 display_2_122___r4_output_6_10_3(string1556_reduce_walk, current_error_port);
		 WRITE_CHAR(((unsigned char) '\n'), current_error_port);
		 {	/* Reduce/walk.scm 41 */
		    obj_t res1551_1075;
		    exit(((long) -1));
		    res1551_1075 =
		       BINT(((long) -1));
		    return res1551_1075;
		 }
	      }
	    else
	      {
		 obj_t hooks_723;
		 obj_t hnames_724;
		 hooks_723 = BNIL;
		 hnames_724 = BNIL;
	       loop_725:
		 if (
		    NULLP(hooks_723))
		   {	/* Reduce/walk.scm 41 */
		      return value_717;
		   }
		 else
		   {	/* Reduce/walk.scm 41 */
		      bool_t test1465_730;
		      {		/* Reduce/walk.scm 41 */
			 obj_t fun1471_735;
			 fun1471_735 =
			    CAR(hooks_723);
			 {	/* Reduce/walk.scm 41 */
			    obj_t aux_1167;
			    aux_1167 =
			       PROCEDURE_ENTRY(fun1471_735) (fun1471_735, BEOA);
			    test1465_730 =
			       CBOOL(aux_1167);
			 }
		      }
		      if (test1465_730)
			{	/* Reduce/walk.scm 41 */
			   {
			      obj_t hnames_1174;
			      obj_t hooks_1172;
			      hooks_1172 =
				 CDR(hooks_723);
			      hnames_1174 =
				 CDR(hnames_724);
			      hnames_724 = hnames_1174;
			      hooks_723 = hooks_1172;
			      goto loop_725;
			   }
			}
		      else
			{	/* Reduce/walk.scm 41 */
			   return
			      internal_error_43_tools_error(_current_pass__25_engine_pass, string1557_reduce_walk,
			      CAR(hnames_724));
			}
		   }
	      }
	 }
      }
   }
}



/* _reduce-walk! */
obj_t 
_reduce_walk__13_reduce_walk(obj_t env_1082, obj_t globals_1083)
{
   AN_OBJECT;
   {	/* Reduce/walk.scm 33 */
      return
	 reduce_walk__148_reduce_walk(globals_1083);
   }
}



/* method-init */
obj_t 
method_init_76_reduce_walk()
{
   AN_OBJECT;
   {	/* Reduce/walk.scm 14 */
      return BUNSPEC;
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_reduce_walk()
{
   AN_OBJECT;
   {	/* Reduce/walk.scm 14 */
      module_initialization_70_tools_speek(((long) 0), "REDUCE_WALK");
      module_initialization_70_tools_error(((long) 0), "REDUCE_WALK");
      module_initialization_70_engine_pass(((long) 0), "REDUCE_WALK");
      module_initialization_70_tools_shape(((long) 0), "REDUCE_WALK");
      module_initialization_70_engine_param(((long) 0), "REDUCE_WALK");
      module_initialization_70_type_type(((long) 0), "REDUCE_WALK");
      module_initialization_70_ast_var(((long) 0), "REDUCE_WALK");
      module_initialization_70_ast_node(((long) 0), "REDUCE_WALK");
      module_initialization_70_reduce_copy(((long) 0), "REDUCE_WALK");
      module_initialization_70_reduce_cse(((long) 0), "REDUCE_WALK");
      module_initialization_70_reduce_cond(((long) 0), "REDUCE_WALK");
      module_initialization_70_reduce_typec(((long) 0), "REDUCE_WALK");
      module_initialization_70_reduce_1occ(((long) 0), "REDUCE_WALK");
      return
	 module_initialization_70_ast_remove(((long) 0), "REDUCE_WALK");
   }
}
