/*===========================================================================*/
/*   (Tools/error.scm)                                                       */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;


extern obj_t unwind_until__178___bexit(obj_t, obj_t);
static obj_t method_init_76_tools_error();
extern obj_t string_to_symbol(char *);
extern obj_t user_warning_location_190_tools_error(obj_t, obj_t, obj_t, obj_t);
extern obj_t string_append(obj_t, obj_t);
extern obj_t current_error_port;
extern obj_t exitd_top;
obj_t _nb_error_on_pass__70_tools_error = BUNSPEC;
static obj_t _enter_function1608_4_tools_error(obj_t, obj_t);
extern obj_t leave_function_170_tools_error();
static obj_t _no_warning_207_tools_error(obj_t, obj_t);
extern obj_t user_warning_209_tools_error(obj_t, obj_t, obj_t);
static obj_t _current_function_148_tools_error(obj_t);
extern obj_t warning___error(obj_t);
static obj_t handling_function1505_tools_error(obj_t, obj_t, obj_t, obj_t);
static obj_t handling_function1493_tools_error(obj_t, obj_t, obj_t, obj_t);
extern obj_t user_error_151_tools_error(obj_t, obj_t, obj_t, obj_t);
extern obj_t current_function_76_tools_error();
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_engine_pass(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_tools_location(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_init_main(long, char *);
extern obj_t module_initialization_70___error(long, char *);
extern obj_t module_initialization_70___bexit(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_control_features_6_9(long, char *);
extern obj_t module_initialization_70___r4_output_6_10_3(long, char *);
static obj_t sharp_symbol_247_tools_error = BUNSPEC;
extern obj_t _warning__61___error;
extern obj_t notify_error_43___error(obj_t, obj_t, obj_t);
static obj_t _anonymous_1510__10_tools_error(obj_t);
static obj_t _anonymous_1509__243_tools_error(obj_t);
static obj_t _anonymous_1497__161_tools_error(obj_t);
static obj_t _anonymous_1496__28_tools_error(obj_t);
extern obj_t error_location_112___error(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t exit_bigloo_229_init_main(obj_t);
extern obj_t display_2_122___r4_output_6_10_3(obj_t, obj_t);
static obj_t _user_warning_49_tools_error(obj_t, obj_t, obj_t, obj_t);
static obj_t imported_modules_init_94_tools_error();
static obj_t rhandler1451_tools_error(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t rhandler1443_tools_error(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t handler_tools_error(obj_t, obj_t, obj_t, obj_t, obj_t);
extern bool_t bigloo_strcmp(obj_t, obj_t);
static obj_t _user_error_251_tools_error(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t library_modules_init_112_tools_error();
static obj_t toplevel_init_63_tools_error();
static obj_t _internal_error_86_tools_error(obj_t, obj_t, obj_t, obj_t);
extern obj_t open_input_string(obj_t);
extern obj_t warning_location_135___error(obj_t, obj_t, obj_t);
static obj_t _user_warning_location_217_tools_error(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t _bigloo_author__68_engine_param;
extern obj_t _trace_port__84_tools_trace;
extern obj_t close_output_port(obj_t);
extern obj_t enter_function_81_tools_error(obj_t);
extern obj_t dynamic_wind_31___r4_control_features_6_9(obj_t, obj_t, obj_t);
static obj_t _user_error_location_187_tools_error(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t c_substring(obj_t, long, long);
extern obj_t open_output_string();
extern obj_t internal_error_43_tools_error(obj_t, obj_t, obj_t);
extern obj_t no_warning_128_tools_error(obj_t);
extern obj_t remove_error_handler__102___error();
extern obj_t read___reader(obj_t);
static obj_t _sfun_stack__205_tools_error = BUNSPEC;
extern obj_t find_location_120_tools_location(obj_t);
static obj_t _leave_function_100_tools_error(obj_t);
static obj_t escape_tools_error(obj_t, obj_t);
extern obj_t _bigloo_email__0_engine_param;
extern obj_t add_error_handler__155___error(obj_t, obj_t);
static obj_t require_initialization_114_tools_error = BUNSPEC;
static obj_t escape_1607_tools_error(obj_t, obj_t);
static obj_t body1452_tools_error(obj_t);
static obj_t body1444_tools_error(obj_t);
static obj_t cnst_init_137_tools_error();
extern obj_t user_error_location_137_tools_error(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t _current_pass__25_engine_pass;
static obj_t __cnst[2];

DEFINE_EXPORT_PROCEDURE(internal_error_env_37_tools_error, _internal_error_86_tools_error1624, _internal_error_86_tools_error, 0L, 3);
DEFINE_EXPORT_PROCEDURE(user_warning_location_env_188_tools_error, _user_warning_location_217_tools_error1625, _user_warning_location_217_tools_error, 0L, 4);
DEFINE_EXPORT_PROCEDURE(leave_function_env_89_tools_error, _leave_function_100_tools_error1626, _leave_function_100_tools_error, 0L, 0);
DEFINE_EXPORT_PROCEDURE(no_warning_env_80_tools_error, _no_warning_207_tools_error1627, _no_warning_207_tools_error, 0L, 1);
DEFINE_EXPORT_PROCEDURE(user_warning_env_78_tools_error, _user_warning_49_tools_error1628, _user_warning_49_tools_error, 0L, 3);
DEFINE_EXPORT_PROCEDURE(user_error_env_101_tools_error, _user_error_251_tools_error1629, va_generic_entry, _user_error_251_tools_error, -4);
DEFINE_EXPORT_PROCEDURE(user_error_location_env_77_tools_error, _user_error_location_187_tools_error1630, va_generic_entry, _user_error_location_187_tools_error, -5);
DEFINE_EXPORT_PROCEDURE(current_function_env_22_tools_error, _current_function_148_tools_error1631, _current_function_148_tools_error, 0L, 0);
DEFINE_STRING(string1619_tools_error, string1619_tools_error1632, "LOCATION (TOP-LEVEL) ", 21);
DEFINE_STRING(string1618_tools_error, string1618_tools_error1633, " ...", 4);
DEFINE_STRING(string1617_tools_error, string1617_tools_error1634, "*** ERROR:", 10);
DEFINE_STRING(string1616_tools_error, string1616_tools_error1635, " -- ", 4);
DEFINE_STRING(string1615_tools_error, string1615_tools_error1636, "], thank you.)", 14);
DEFINE_STRING(string1614_tools_error, string1614_tools_error1637, " [", 2);
DEFINE_STRING(string1613_tools_error, string1613_tools_error1638, "(Would you, please, send this error report and the source file to", 65);
DEFINE_STRING(string1612_tools_error, string1612_tools_error1639, "*** INTERNAL-ERROR in pass: ", 28);
DEFINE_STRING(string1611_tools_error, string1611_tools_error1640, ":", 1);
DEFINE_STRING(string1609_tools_error, string1609_tools_error1641, "#", 1);
DEFINE_STRING(string1610_tools_error, string1610_tools_error1642, "*** ERROR: ", 11);
DEFINE_EXPORT_PROCEDURE(enter_function_env_226_tools_error, _enter_function1608_4_tools_error1643, _enter_function1608_4_tools_error, 0L, 1);



/* module-initialization */
obj_t 
module_initialization_70_tools_error(long checksum_1391, char *from_1392)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_tools_error))
	{
	   require_initialization_114_tools_error =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_tools_error();
	   cnst_init_137_tools_error();
	   imported_modules_init_94_tools_error();
	   method_init_76_tools_error();
	   toplevel_init_63_tools_error();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_tools_error()
{
   AN_OBJECT;
   {	/* Tools/error.scm 14 */
      module_initialization_70___bexit(((long) 0), "TOOLS_ERROR");
      module_initialization_70___error(((long) 0), "TOOLS_ERROR");
      module_initialization_70___r4_output_6_10_3(((long) 0), "TOOLS_ERROR");
      module_initialization_70___r4_control_features_6_9(((long) 0), "TOOLS_ERROR");
      module_initialization_70___reader(((long) 0), "TOOLS_ERROR");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_tools_error()
{
   AN_OBJECT;
   {	/* Tools/error.scm 14 */
      {		/* Tools/error.scm 14 */
	 obj_t cnst_port_138_1384;
	 cnst_port_138_1384 =
	    open_input_string(string1619_tools_error);
	 {
	    long i_1385;
	    i_1385 = ((long) 1);
	  loop_1386:
	    {	/* Tools/error.scm 14 */
	       bool_t test1620_1387;
	       test1620_1387 =
		  (i_1385 == ((long) -1));
	       if (test1620_1387)
		 {	/* Tools/error.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Tools/error.scm 14 */
		    {	/* Tools/error.scm 14 */
		       obj_t arg1621_1388;
		       {	/* Tools/error.scm 14 */
			  obj_t list1622_1389;
			  list1622_1389 =
			     MAKE_PAIR(cnst_port_138_1384, BNIL);
			  arg1621_1388 =
			     read___reader(list1622_1389);
		       }
		       CNST_TABLE_SET(i_1385, arg1621_1388);
		    }
		    {	/* Tools/error.scm 14 */
		       int aux_1390;
		       {	/* Tools/error.scm 14 */
			  long aux_1412;
			  aux_1412 =
			     (i_1385 - ((long) 1));
			  aux_1390 =
			     (int) (aux_1412);
		       }
		       {
			  long i_1415;
			  i_1415 =
			     (long) (aux_1390);
			  i_1385 = i_1415;
			  goto loop_1386;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_tools_error()
{
   AN_OBJECT;
   {	/* Tools/error.scm 14 */
      _nb_error_on_pass__70_tools_error =
	 BINT(((long) 0));
      _sfun_stack__205_tools_error =
	 CNST_TABLE_REF(((long) 0));
      {		/* ./Ieee/symbol.scm 6027 */
	 char *aux_1419;
	 aux_1419 =
	    BSTRING_TO_STRING(string1609_tools_error);
	 return (
	    sharp_symbol_247_tools_error =
	    string_to_symbol(aux_1419), BUNSPEC);
      }
   }
}



/* internal-error */
obj_t 
internal_error_43_tools_error(obj_t proc_15, obj_t mes_16, obj_t obj_17)
{
   AN_OBJECT;
   {	/* Tools/error.scm 42 */
      {		/* Tools/error.scm 43 */
	 bool_t test1468_741;
	 {	/* Tools/error.scm 43 */
	    obj_t obj_1198;
	    obj_1198 = _trace_port__84_tools_trace;
	    test1468_741 =
	       OUTPUT_PORTP(obj_1198);
	 }
	 if (test1468_741)
	   {	/* Tools/error.scm 44 */
	      obj_t port1437_742;
	      port1437_742 = _trace_port__84_tools_trace;
	      display_2_122___r4_output_6_10_3(string1610_tools_error, port1437_742);
	      display_2_122___r4_output_6_10_3(proc_15, port1437_742);
	      display_2_122___r4_output_6_10_3(string1611_tools_error, port1437_742);
	      display_2_122___r4_output_6_10_3(mes_16, port1437_742);
	      display_2_122___r4_output_6_10_3(string1611_tools_error, port1437_742);
	      display_2_122___r4_output_6_10_3(obj_17, port1437_742);
	      {		/* ./Ieee/output.scm 9332 */
		 unsigned char aux_1430;
		 aux_1430 =
		    WRITE_CHAR(((unsigned char) '\n'), port1437_742);
		 BCHAR(aux_1430);
	      }
	   }
	 else
	   {	/* Tools/error.scm 43 */
	      BUNSPEC;
	   }
      }
      display_2_122___r4_output_6_10_3(string1612_tools_error, current_error_port);
      display_2_122___r4_output_6_10_3(_current_pass__25_engine_pass, current_error_port);
      WRITE_CHAR(((unsigned char) '\n'), current_error_port);
      display_2_122___r4_output_6_10_3(string1613_tools_error, current_error_port);
      display_2_122___r4_output_6_10_3(
	 BCHAR(((unsigned char) '\n')), current_error_port);
      display_2_122___r4_output_6_10_3(_bigloo_author__68_engine_param, current_error_port);
      display_2_122___r4_output_6_10_3(string1614_tools_error, current_error_port);
      display_2_122___r4_output_6_10_3(_bigloo_email__0_engine_param, current_error_port);
      display_2_122___r4_output_6_10_3(string1615_tools_error, current_error_port);
      WRITE_CHAR(((unsigned char) '\n'), current_error_port);
      FAILURE(proc_15, mes_16, obj_17);
   }
}



/* _internal-error */
obj_t 
_internal_error_86_tools_error(obj_t env_1275, obj_t proc_1276, obj_t mes_1277, obj_t obj_1278)
{
   AN_OBJECT;
   {	/* Tools/error.scm 42 */
      return
	 internal_error_43_tools_error(proc_1276, mes_1277, obj_1278);
   }
}



/* user-warning/location */
obj_t 
user_warning_location_190_tools_error(obj_t loc_18, obj_t proc_19, obj_t mes_20, obj_t obj_21)
{
   AN_OBJECT;
   {	/* Tools/error.scm 57 */
      {		/* Tools/error.scm 58 */
	 bool_t test_1448;
	 if (
	    STRUCTP(loc_18))
	   {	/* ./Ieee/equiv.scm 5508 */
	      obj_t aux_1453;
	      obj_t aux_1451;
	      aux_1453 =
		 CNST_TABLE_REF(((long) 1));
	      aux_1451 =
		 STRUCT_KEY(loc_18);
	      test_1448 =
		 (aux_1451 == aux_1453);
	   }
	 else
	   {	/* ./Tools/location.sch 410 */
	      test_1448 = ((bool_t) 0)
		 ;
	   }
	 if (test_1448)
	   {	/* Tools/error.scm 60 */
	      obj_t arg1470_746;
	      obj_t arg1471_747;
	      arg1470_746 =
		 STRUCT_REF(loc_18, ((long) 0));
	      arg1471_747 =
		 STRUCT_REF(loc_18, ((long) 1));
	      {		/* Tools/error.scm 60 */
		 obj_t list1473_749;
		 {	/* Tools/error.scm 60 */
		    obj_t arg1474_750;
		    {	/* Tools/error.scm 60 */
		       obj_t arg1475_751;
		       {	/* Tools/error.scm 60 */
			  obj_t arg1476_752;
			  arg1476_752 =
			     MAKE_PAIR(obj_21, BNIL);
			  arg1475_751 =
			     MAKE_PAIR(string1616_tools_error, arg1476_752);
		       }
		       arg1474_750 =
			  MAKE_PAIR(mes_20, arg1475_751);
		    }
		    list1473_749 =
		       MAKE_PAIR(proc_19, arg1474_750);
		 }
		 return
		    warning_location_135___error(arg1470_746, arg1471_747, list1473_749);
	      }
	   }
	 else
	   {	/* Tools/error.scm 59 */
	      obj_t list1477_753;
	      {		/* Tools/error.scm 59 */
		 obj_t arg1478_754;
		 {	/* Tools/error.scm 59 */
		    obj_t arg1479_755;
		    {	/* Tools/error.scm 59 */
		       obj_t arg1481_757;
		       arg1481_757 =
			  MAKE_PAIR(obj_21, BNIL);
		       arg1479_755 =
			  MAKE_PAIR(string1616_tools_error, arg1481_757);
		    }
		    arg1478_754 =
		       MAKE_PAIR(mes_20, arg1479_755);
		 }
		 list1477_753 =
		    MAKE_PAIR(proc_19, arg1478_754);
	      }
	      return
		 warning___error(list1477_753);
	   }
      }
   }
}



/* _user-warning/location */
obj_t 
_user_warning_location_217_tools_error(obj_t env_1279, obj_t loc_1280, obj_t proc_1281, obj_t mes_1282, obj_t obj_1283)
{
   AN_OBJECT;
   {	/* Tools/error.scm 57 */
      return
	 user_warning_location_190_tools_error(loc_1280, proc_1281, mes_1282, obj_1283);
   }
}



/* user-warning */
obj_t 
user_warning_209_tools_error(obj_t proc_22, obj_t mes_23, obj_t obj_24)
{
   AN_OBJECT;
   {	/* Tools/error.scm 70 */
      {		/* Tools/error.scm 71 */
	 obj_t arg1482_1219;
	 arg1482_1219 =
	    find_location_120_tools_location(obj_24);
	 return
	    user_warning_location_190_tools_error(arg1482_1219, proc_22, mes_23, obj_24);
      }
   }
}



/* _user-warning */
obj_t 
_user_warning_49_tools_error(obj_t env_1284, obj_t proc_1285, obj_t mes_1286, obj_t obj_1287)
{
   AN_OBJECT;
   {	/* Tools/error.scm 70 */
      return
	 user_warning_209_tools_error(proc_1285, mes_1286, obj_1287);
   }
}



/* no-warning */
obj_t 
no_warning_128_tools_error(obj_t thunk_25)
{
   AN_OBJECT;
   {	/* Tools/error.scm 76 */
      {		/* Tools/error.scm 77 */
	 obj_t warning_759;
	 warning_759 = _warning__61___error;
	 _warning__61___error = BFALSE;
	 {	/* Tools/error.scm 79 */
	    obj_t val_760;
	    val_760 =
	       PROCEDURE_ENTRY(thunk_25) (thunk_25, BEOA);
	    _warning__61___error = warning_759;
	    return val_760;
	 }
      }
   }
}



/* _no-warning */
obj_t 
_no_warning_207_tools_error(obj_t env_1288, obj_t thunk_1289)
{
   AN_OBJECT;
   {	/* Tools/error.scm 76 */
      return
	 no_warning_128_tools_error(thunk_1289);
   }
}



/* user-error */
obj_t 
user_error_151_tools_error(obj_t proc_26, obj_t mes_27, obj_t obj_28, obj_t continue_29)
{
   AN_OBJECT;
   {	/* Tools/error.scm 86 */
      if (
	 PAIRP(continue_29))
	{	/* Tools/error.scm 88 */
	   obj_t arg1484_762;
	   obj_t arg1485_763;
	   arg1484_762 =
	      find_location_120_tools_location(obj_28);
	   arg1485_763 =
	      CAR(continue_29);
	   {	/* Tools/error.scm 88 */
	      obj_t list1486_764;
	      list1486_764 =
		 MAKE_PAIR(arg1485_763, BNIL);
	      return
		 user_error_location_137_tools_error(arg1484_762, proc_26, mes_27, obj_28, list1486_764);
	   }
	}
      else
	{	/* Tools/error.scm 90 */
	   obj_t arg1488_765;
	   arg1488_765 =
	      find_location_120_tools_location(obj_28);
	   return
	      user_error_location_137_tools_error(arg1488_765, proc_26, mes_27, obj_28, BNIL);
	}
   }
}



/* _user-error */
obj_t 
_user_error_251_tools_error(obj_t env_1290, obj_t proc_1291, obj_t mes_1292, obj_t obj_1293, obj_t continue_1294)
{
   AN_OBJECT;
   {	/* Tools/error.scm 86 */
      return
	 user_error_151_tools_error(proc_1291, mes_1292, obj_1293, continue_1294);
   }
}



/* user-error/location */
obj_t 
user_error_location_137_tools_error(obj_t loc_30, obj_t proc_31, obj_t mes_32, obj_t obj_33, obj_t continue_34)
{
   AN_OBJECT;
   {	/* Tools/error.scm 95 */
      {		/* Tools/error.scm 96 */
	 bool_t test1490_767;
	 {	/* Tools/error.scm 96 */
	    obj_t obj_1222;
	    obj_1222 = _trace_port__84_tools_trace;
	    test1490_767 =
	       OUTPUT_PORTP(obj_1222);
	 }
	 if (test1490_767)
	   {	/* Tools/error.scm 97 */
	      obj_t port1440_768;
	      port1440_768 = _trace_port__84_tools_trace;
	      display_2_122___r4_output_6_10_3(string1617_tools_error, port1440_768);
	      display_2_122___r4_output_6_10_3(proc_31, port1440_768);
	      display_2_122___r4_output_6_10_3(string1611_tools_error, port1440_768);
	      display_2_122___r4_output_6_10_3(mes_32, port1440_768);
	      display_2_122___r4_output_6_10_3(string1611_tools_error, port1440_768);
	      display_2_122___r4_output_6_10_3(obj_33, port1440_768);
	      {		/* ./Ieee/output.scm 9332 */
		 unsigned char aux_1492;
		 aux_1492 =
		    WRITE_CHAR(((unsigned char) '\n'), port1440_768);
		 BCHAR(aux_1492);
	      }
	   }
	 else
	   {	/* Tools/error.scm 96 */
	      BUNSPEC;
	   }
      }
      {		/* Tools/error.scm 98 */
	 long z1_1224;
	 z1_1224 =
	    (long) CINT(_nb_error_on_pass__70_tools_error);
	 {	/* ./Ieee/fixnum.scm 7193 */
	    long aux_1496;
	    aux_1496 =
	       (z1_1224 + ((long) 1));
	    _nb_error_on_pass__70_tools_error =
	       BINT(aux_1496);
	 }
      }
      {		/* Tools/error.scm 99 */
	 obj_t proc_string_5_769;
	 if (
	    STRINGP(proc_31))
	   {	/* Tools/error.scm 100 */
	      proc_string_5_769 = proc_31;
	   }
	 else
	   {	/* Tools/error.scm 100 */
	      if (
		 SYMBOLP(proc_31))
		{	/* Tools/error.scm 102 */
		   proc_string_5_769 =
		      SYMBOL_TO_STRING(proc_31);
		}
	      else
		{	/* Tools/error.scm 102 */
		   proc_string_5_769 = BFALSE;
		}
	   }
	 {	/* Tools/error.scm 99 */
	    obj_t fun_string_157_770;
	    {	/* Tools/error.scm 106 */
	       obj_t arg1525_847;
	       {	/* Tools/error.scm 159 */
		  obj_t pair_1229;
		  pair_1229 = _sfun_stack__205_tools_error;
		  arg1525_847 =
		     CAR(pair_1229);
	       }
	       fun_string_157_770 =
		  SYMBOL_TO_STRING(arg1525_847);
	    }
	    {	/* Tools/error.scm 106 */
	       obj_t proc_771;
	       {	/* Tools/error.scm 107 */
		  bool_t test1520_843;
		  if (
		     STRINGP(proc_string_5_769))
		    {	/* Tools/error.scm 108 */
		       bool_t test1523_846;
		       test1523_846 =
			  bigloo_strcmp(proc_string_5_769, fun_string_157_770);
		       if (test1523_846)
			 {	/* Tools/error.scm 108 */
			    test1520_843 = ((bool_t) 0);
			 }
		       else
			 {	/* Tools/error.scm 108 */
			    test1520_843 = ((bool_t) 1);
			 }
		    }
		  else
		    {	/* Tools/error.scm 107 */
		       test1520_843 = ((bool_t) 0);
		    }
		  if (test1520_843)
		    {	/* Tools/error.scm 109 */
		       obj_t arg1521_844;
		       arg1521_844 =
			  string_append(string1611_tools_error, proc_string_5_769);
		       proc_771 =
			  string_append(fun_string_157_770, arg1521_844);
		    }
		  else
		    {	/* Tools/error.scm 107 */
		       proc_771 = fun_string_157_770;
		    }
	       }
	       {	/* Tools/error.scm 107 */

		  {	/* Tools/error.scm 111 */
		     obj_t obj_prn_210_772;
		     {	/* Tools/error.scm 111 */
			obj_t port_829;
			port_829 =
			   open_output_string();
			display_2_122___r4_output_6_10_3(obj_33, port_829);
			{	/* Tools/error.scm 113 */
			   obj_t string_830;
			   string_830 =
			      close_output_port(port_829);
			   {	/* Tools/error.scm 114 */
			      bool_t test_1516;
			      {		/* ./Ieee/fixnum.scm 7121 */
				 long aux_1517;
				 aux_1517 =
				    STRING_LENGTH(string_830);
				 test_1516 =
				    (aux_1517 > ((long) 45));
			      }
			      if (test_1516)
				{	/* Tools/error.scm 115 */
				   obj_t arg1514_832;
				   arg1514_832 =
				      c_substring(string_830, ((long) 0), ((long) 44));
				   obj_prn_210_772 =
				      string_append(arg1514_832, string1618_tools_error);
				}
			      else
				{	/* Tools/error.scm 114 */
				   obj_prn_210_772 = string_830;
				}
			   }
			}
		     }
		     {	/* Tools/error.scm 117 */
			obj_t handler_1305;
			handler_1305 =
			   make_fx_procedure(handler_tools_error, ((long) 4), ((long) 1));
			PROCEDURE_SET(handler_1305, ((long) 0), continue_34);
			{	/* Tools/error.scm 120 */
			   bool_t test_1524;
			   if (
			      STRUCTP(loc_30))
			     {	/* ./Ieee/equiv.scm 5508 */
				obj_t aux_1529;
				obj_t aux_1527;
				aux_1529 =
				   CNST_TABLE_REF(((long) 1));
				aux_1527 =
				   STRUCT_KEY(loc_30);
				test_1524 =
				   (aux_1527 == aux_1529);
			     }
			   else
			     {	/* ./Tools/location.sch 410 */
				test_1524 = ((bool_t) 0)
				   ;
			     }
			   if (test_1524)
			     {	/* Tools/error.scm 120 */
				if (
				   PAIRP(continue_34))
				  {	/* Tools/error.scm 122 */
				     obj_t armed1445_776;
				     obj_t handler1442_777;
				     armed1445_776 =
					MAKE_CELL(BUNSPEC);
				     handler1442_777 =
					MAKE_CELL(BUNSPEC);
				     {	/* Tools/error.scm 122 */
					obj_t body1444_1296;
					obj_t rhandler1443_1298;
					body1444_1296 =
					   make_fx_procedure(body1444_tools_error, ((long) 0), ((long) 4));
					rhandler1443_1298 =
					   make_fx_procedure(rhandler1443_tools_error, ((long) 4), ((long) 2));
					PROCEDURE_SET(body1444_1296, ((long) 0), loc_30);
					PROCEDURE_SET(body1444_1296, ((long) 1), proc_771);
					PROCEDURE_SET(body1444_1296, ((long) 2), mes_32);
					PROCEDURE_SET(body1444_1296, ((long) 3), obj_prn_210_772);
					PROCEDURE_SET(rhandler1443_1298, ((long) 0), armed1445_776);
					PROCEDURE_SET(rhandler1443_1298, ((long) 1), handler1442_777);
					CELL_SET(handler1442_777, handler_1305);
					CELL_SET(armed1445_776, BTRUE);
					return
					   handling_function1493_tools_error(body1444_1296, rhandler1443_1298, handler1442_777, armed1445_776);
				     }
				  }
				else
				  {	/* Tools/error.scm 121 */
				     return
					error_location_112___error(proc_771, mes_32, obj_prn_210_772,
					STRUCT_REF(loc_30, ((long) 0)),
					STRUCT_REF(loc_30, ((long) 1)));
				  }
			     }
			   else
			     {	/* Tools/error.scm 120 */
				if (
				   PAIRP(continue_34))
				  {	/* Tools/error.scm 134 */
				     obj_t armed1453_805;
				     obj_t handler1450_806;
				     armed1453_805 =
					MAKE_CELL(BUNSPEC);
				     handler1450_806 =
					MAKE_CELL(BUNSPEC);
				     {	/* Tools/error.scm 134 */
					obj_t body1452_1301;
					obj_t rhandler1451_1303;
					body1452_1301 =
					   make_fx_procedure(body1452_tools_error, ((long) 0), ((long) 3));
					rhandler1451_1303 =
					   make_fx_procedure(rhandler1451_tools_error, ((long) 4), ((long) 2));
					PROCEDURE_SET(body1452_1301, ((long) 0), proc_771);
					PROCEDURE_SET(body1452_1301, ((long) 1), mes_32);
					PROCEDURE_SET(body1452_1301, ((long) 2), obj_33);
					PROCEDURE_SET(rhandler1451_1303, ((long) 0), armed1453_805);
					PROCEDURE_SET(rhandler1451_1303, ((long) 1), handler1450_806);
					CELL_SET(handler1450_806, handler_1305);
					CELL_SET(armed1453_805, BTRUE);
					return
					   handling_function1505_tools_error(body1452_1301, rhandler1451_1303, handler1450_806, armed1453_805);
				     }
				  }
				else
				  {	/* Tools/error.scm 133 */
				     FAILURE(proc_771, mes_32, obj_33);
				  }
			     }
			}
		     }
		  }
	       }
	    }
	 }
      }
   }
}



/* handling_function1505 */
obj_t 
handling_function1505_tools_error(obj_t body1452_1378, obj_t rhandler1451_1377, obj_t handler1450_1376, obj_t armed1453_1375)
{
   AN_OBJECT;
   {	/* Tools/error.scm 134 */
      jmp_buf jmpbuf;
      obj_t an_exit1454_810;
      if (SET_EXIT(an_exit1454_810))
	{
	   RESTORE_TRACE();
	   return
	      _exit_value_;
	}
      else
	{
	   an_exit1454_810 =
	      (obj_t) jmpbuf;
	   {	/* Tools/error.scm 134 */

	      PUSH_EXIT(an_exit1454_810, ((bool_t) 1));
	      {		/* Tools/error.scm 134 */
		 obj_t an_exitd1455_811;
		 an_exitd1455_811 = exitd_top;
		 {	/* Tools/error.scm 134 */
		    obj_t escape_1302;
		    escape_1302 =
		       make_fx_procedure(escape_1607_tools_error, ((long) 1), ((long) 1));
		    PROCEDURE_SET(escape_1302, ((long) 0), an_exitd1455_811);
		    {	/* Tools/error.scm 134 */
		       obj_t res1457_814;
		       {	/* Tools/error.scm 134 */
			  obj_t _anonymous_1510__10_1300;
			  obj_t _anonymous_1509__243_1304;
			  _anonymous_1510__10_1300 =
			     make_fx_procedure(_anonymous_1510__10_tools_error, ((long) 0), ((long) 1));
			  _anonymous_1509__243_1304 =
			     make_fx_procedure(_anonymous_1509__243_tools_error, ((long) 0), ((long) 5));
			  PROCEDURE_SET(_anonymous_1510__10_1300, ((long) 0), armed1453_1375);
			  PROCEDURE_SET(_anonymous_1509__243_1304, ((long) 0), an_exitd1455_811);
			  PROCEDURE_SET(_anonymous_1509__243_1304, ((long) 1), armed1453_1375);
			  PROCEDURE_SET(_anonymous_1509__243_1304, ((long) 2), handler1450_1376);
			  PROCEDURE_SET(_anonymous_1509__243_1304, ((long) 3), rhandler1451_1377);
			  PROCEDURE_SET(_anonymous_1509__243_1304, ((long) 4), escape_1302);
			  res1457_814 =
			     dynamic_wind_31___r4_control_features_6_9(_anonymous_1509__243_1304, body1452_1378, _anonymous_1510__10_1300);
		       }
		       POP_EXIT();
		       return res1457_814;
		    }
		 }
	      }
	   }
	}
   }
}



/* handling_function1493 */
obj_t 
handling_function1493_tools_error(obj_t body1444_1382, obj_t rhandler1443_1381, obj_t handler1442_1380, obj_t armed1445_1379)
{
   AN_OBJECT;
   {	/* Tools/error.scm 122 */
      jmp_buf jmpbuf;
      obj_t an_exit1446_781;
      if (SET_EXIT(an_exit1446_781))
	{
	   RESTORE_TRACE();
	   return
	      _exit_value_;
	}
      else
	{
	   an_exit1446_781 =
	      (obj_t) jmpbuf;
	   {	/* Tools/error.scm 122 */

	      PUSH_EXIT(an_exit1446_781, ((bool_t) 1));
	      {		/* Tools/error.scm 122 */
		 obj_t an_exitd1447_782;
		 an_exitd1447_782 = exitd_top;
		 {	/* Tools/error.scm 122 */
		    obj_t escape_1297;
		    escape_1297 =
		       make_fx_procedure(escape_tools_error, ((long) 1), ((long) 1));
		    PROCEDURE_SET(escape_1297, ((long) 0), an_exitd1447_782);
		    {	/* Tools/error.scm 122 */
		       obj_t res1449_785;
		       {	/* Tools/error.scm 122 */
			  obj_t _anonymous_1497__161_1295;
			  obj_t _anonymous_1496__28_1299;
			  _anonymous_1497__161_1295 =
			     make_fx_procedure(_anonymous_1497__161_tools_error, ((long) 0), ((long) 1));
			  _anonymous_1496__28_1299 =
			     make_fx_procedure(_anonymous_1496__28_tools_error, ((long) 0), ((long) 5));
			  PROCEDURE_SET(_anonymous_1497__161_1295, ((long) 0), armed1445_1379);
			  PROCEDURE_SET(_anonymous_1496__28_1299, ((long) 0), an_exitd1447_782);
			  PROCEDURE_SET(_anonymous_1496__28_1299, ((long) 1), armed1445_1379);
			  PROCEDURE_SET(_anonymous_1496__28_1299, ((long) 2), handler1442_1380);
			  PROCEDURE_SET(_anonymous_1496__28_1299, ((long) 3), rhandler1443_1381);
			  PROCEDURE_SET(_anonymous_1496__28_1299, ((long) 4), escape_1297);
			  res1449_785 =
			     dynamic_wind_31___r4_control_features_6_9(_anonymous_1496__28_1299, body1444_1382, _anonymous_1497__161_1295);
		       }
		       POP_EXIT();
		       return res1449_785;
		    }
		 }
	      }
	   }
	}
   }
}



/* _user-error/location */
obj_t 
_user_error_location_187_tools_error(obj_t env_1306, obj_t loc_1307, obj_t proc_1308, obj_t mes_1309, obj_t obj_1310, obj_t continue_1311)
{
   AN_OBJECT;
   {	/* Tools/error.scm 95 */
      return
	 user_error_location_137_tools_error(loc_1307, proc_1308, mes_1309, obj_1310, continue_1311);
   }
}



/* <anonymous:1497> */
obj_t 
_anonymous_1497__161_tools_error(obj_t env_1312)
{
   AN_OBJECT;
   {	/* Tools/error.scm 122 */
      {		/* Tools/error.scm 122 */
	 obj_t armed1445_1313;
	 armed1445_1313 =
	    PROCEDURE_REF(env_1312, ((long) 0));
	 {

	    {	/* Tools/error.scm 122 */
	       bool_t test_1589;
	       {	/* Tools/error.scm 122 */
		  obj_t aux_1590;
		  aux_1590 =
		     CELL_REF(armed1445_1313);
		  test_1589 =
		     CBOOL(aux_1590);
	       }
	       if (test_1589)
		 {	/* Tools/error.scm 122 */
		    CELL_SET(armed1445_1313, BFALSE);
		    return
		       remove_error_handler__102___error();
		 }
	       else
		 {	/* Tools/error.scm 122 */
		    return BUNSPEC;
		 }
	    }
	 }
      }
   }
}



/* body1444 */
obj_t 
body1444_tools_error(obj_t env_1315)
{
   AN_OBJECT;
   {	/* Tools/error.scm 122 */
      {		/* Tools/error.scm 125 */
	 obj_t loc_1316;
	 obj_t proc_1317;
	 obj_t mes_1318;
	 obj_t obj_prn_210_1319;
	 loc_1316 =
	    PROCEDURE_REF(env_1315, ((long) 0));
	 proc_1317 =
	    PROCEDURE_REF(env_1315, ((long) 1));
	 mes_1318 =
	    PROCEDURE_REF(env_1315, ((long) 2));
	 obj_prn_210_1319 =
	    PROCEDURE_REF(env_1315, ((long) 3));
	 {

	    return
	       error_location_112___error(proc_1317, mes_1318, obj_prn_210_1319,
	       STRUCT_REF(loc_1316, ((long) 0)),
	       STRUCT_REF(loc_1316, ((long) 1)));
	 }
      }
   }
}



/* <anonymous:1496> */
obj_t 
_anonymous_1496__28_tools_error(obj_t env_1320)
{
   AN_OBJECT;
   {	/* Tools/error.scm 122 */
      {		/* Tools/error.scm 122 */
	 obj_t rhandler1443_1324;
	 obj_t escape_1325;
	 rhandler1443_1324 =
	    PROCEDURE_REF(env_1320, ((long) 3));
	 escape_1325 =
	    PROCEDURE_REF(env_1320, ((long) 4));
	 {

	    return
	       add_error_handler__155___error(rhandler1443_1324, escape_1325);
	 }
      }
   }
}



/* escape */
obj_t 
escape_tools_error(obj_t env_1326, obj_t val1448_1328)
{
   AN_OBJECT;
   {	/* Tools/error.scm 122 */
      {		/* Tools/error.scm 122 */
	 obj_t an_exitd1447_1327;
	 an_exitd1447_1327 =
	    PROCEDURE_REF(env_1326, ((long) 0));
	 {
	    obj_t val1448_783;
	    val1448_783 = val1448_1328;
	    return
	       unwind_until__178___bexit(an_exitd1447_1327, val1448_783);
	 }
      }
   }
}



/* rhandler1443 */
obj_t 
rhandler1443_tools_error(obj_t env_1329, obj_t esc_1332, obj_t obj_1333, obj_t proc_1334, obj_t msg_1335)
{
   AN_OBJECT;
   {	/* Tools/error.scm 122 */
      {		/* Tools/error.scm 122 */
	 obj_t armed1445_1330;
	 obj_t handler1442_1331;
	 armed1445_1330 =
	    PROCEDURE_REF(env_1329, ((long) 0));
	 handler1442_1331 =
	    PROCEDURE_REF(env_1329, ((long) 1));
	 {
	    obj_t esc_792;
	    obj_t obj_793;
	    obj_t proc_794;
	    obj_t msg_795;
	    esc_792 = esc_1332;
	    obj_793 = obj_1333;
	    proc_794 = proc_1334;
	    msg_795 = msg_1335;
	    CELL_SET(armed1445_1330, BFALSE);
	    remove_error_handler__102___error();
	    {	/* Tools/error.scm 122 */
	       obj_t aux_1609;
	       aux_1609 =
		  CELL_REF(handler1442_1331);
	       return
		  PROCEDURE_ENTRY(aux_1609) (
		  CELL_REF(handler1442_1331), esc_792, obj_793, proc_794, msg_795, BEOA);
	    }
	 }
      }
   }
}



/* <anonymous:1510> */
obj_t 
_anonymous_1510__10_tools_error(obj_t env_1337)
{
   AN_OBJECT;
   {	/* Tools/error.scm 134 */
      {		/* Tools/error.scm 134 */
	 obj_t armed1453_1338;
	 armed1453_1338 =
	    PROCEDURE_REF(env_1337, ((long) 0));
	 {

	    {	/* Tools/error.scm 134 */
	       bool_t test_1611;
	       {	/* Tools/error.scm 134 */
		  obj_t aux_1612;
		  aux_1612 =
		     CELL_REF(armed1453_1338);
		  test_1611 =
		     CBOOL(aux_1612);
	       }
	       if (test_1611)
		 {	/* Tools/error.scm 134 */
		    CELL_SET(armed1453_1338, BFALSE);
		    return
		       remove_error_handler__102___error();
		 }
	       else
		 {	/* Tools/error.scm 134 */
		    return BUNSPEC;
		 }
	    }
	 }
      }
   }
}



/* body1452 */
obj_t 
body1452_tools_error(obj_t env_1340)
{
   AN_OBJECT;
   {	/* Tools/error.scm 134 */
      {		/* Tools/error.scm 134 */
	 obj_t proc_1341;
	 obj_t mes_1342;
	 obj_t obj_1343;
	 proc_1341 =
	    PROCEDURE_REF(env_1340, ((long) 0));
	 mes_1342 =
	    PROCEDURE_REF(env_1340, ((long) 1));
	 obj_1343 =
	    PROCEDURE_REF(env_1340, ((long) 2));
	 {

	    FAILURE(proc_1341, mes_1342, obj_1343);
	 }
      }
   }
}



/* <anonymous:1509> */
obj_t 
_anonymous_1509__243_tools_error(obj_t env_1344)
{
   AN_OBJECT;
   {	/* Tools/error.scm 134 */
      {		/* Tools/error.scm 134 */
	 obj_t rhandler1451_1348;
	 obj_t escape_1349;
	 rhandler1451_1348 =
	    PROCEDURE_REF(env_1344, ((long) 3));
	 escape_1349 =
	    PROCEDURE_REF(env_1344, ((long) 4));
	 {

	    return
	       add_error_handler__155___error(rhandler1451_1348, escape_1349);
	 }
      }
   }
}



/* escape_1607 */
obj_t 
escape_1607_tools_error(obj_t env_1350, obj_t val1456_1352)
{
   AN_OBJECT;
   {	/* Tools/error.scm 134 */
      {		/* Tools/error.scm 134 */
	 obj_t an_exitd1455_1351;
	 an_exitd1455_1351 =
	    PROCEDURE_REF(env_1350, ((long) 0));
	 {
	    obj_t val1456_812;
	    val1456_812 = val1456_1352;
	    return
	       unwind_until__178___bexit(an_exitd1455_1351, val1456_812);
	 }
      }
   }
}



/* rhandler1451 */
obj_t 
rhandler1451_tools_error(obj_t env_1353, obj_t esc_1356, obj_t obj_1357, obj_t proc_1358, obj_t msg_1359)
{
   AN_OBJECT;
   {	/* Tools/error.scm 134 */
      {		/* Tools/error.scm 134 */
	 obj_t armed1453_1354;
	 obj_t handler1450_1355;
	 armed1453_1354 =
	    PROCEDURE_REF(env_1353, ((long) 0));
	 handler1450_1355 =
	    PROCEDURE_REF(env_1353, ((long) 1));
	 {
	    obj_t esc_821;
	    obj_t obj_822;
	    obj_t proc_823;
	    obj_t msg_824;
	    esc_821 = esc_1356;
	    obj_822 = obj_1357;
	    proc_823 = proc_1358;
	    msg_824 = msg_1359;
	    CELL_SET(armed1453_1354, BFALSE);
	    remove_error_handler__102___error();
	    {	/* Tools/error.scm 134 */
	       obj_t aux_1628;
	       aux_1628 =
		  CELL_REF(handler1450_1355);
	       return
		  PROCEDURE_ENTRY(aux_1628) (
		  CELL_REF(handler1450_1355), esc_821, obj_822, proc_823, msg_824, BEOA);
	    }
	 }
      }
   }
}



/* handler */
obj_t 
handler_tools_error(obj_t env_1361, obj_t escape_1363, obj_t proc_1364, obj_t mes_1365, obj_t obj_1366)
{
   AN_OBJECT;
   {	/* Tools/error.scm 117 */
      {		/* Tools/error.scm 117 */
	 obj_t continue_1362;
	 continue_1362 =
	    PROCEDURE_REF(env_1361, ((long) 0));
	 {
	    obj_t escape_836;
	    obj_t proc_837;
	    obj_t mes_838;
	    obj_t obj_839;
	    escape_836 = escape_1363;
	    proc_837 = proc_1364;
	    mes_838 = mes_1365;
	    obj_839 = obj_1366;
	    notify_error_43___error(proc_837, mes_838, obj_839);
	    return
	       PROCEDURE_ENTRY(escape_836) (escape_836,
	       CAR(continue_1362), BEOA);
	 }
      }
   }
}



/* enter-function */
obj_t 
enter_function_81_tools_error(obj_t var_35)
{
   AN_OBJECT;
   {	/* Tools/error.scm 146 */
      {		/* Tools/error.scm 147 */
	 obj_t obj2_1272;
	 obj2_1272 = _sfun_stack__205_tools_error;
	 return (
	    _sfun_stack__205_tools_error =
	    MAKE_PAIR(var_35, obj2_1272), BUNSPEC);
      }
   }
}



/* _enter-function1608 */
obj_t 
_enter_function1608_4_tools_error(obj_t env_1371, obj_t var_1372)
{
   AN_OBJECT;
   {	/* Tools/error.scm 146 */
      return
	 enter_function_81_tools_error(var_1372);
   }
}



/* leave-function */
obj_t 
leave_function_170_tools_error()
{
   AN_OBJECT;
   {	/* Tools/error.scm 152 */
      {		/* Tools/error.scm 153 */
	 obj_t pair_1273;
	 pair_1273 = _sfun_stack__205_tools_error;
	 return (
	    _sfun_stack__205_tools_error =
	    CDR(pair_1273), BUNSPEC);
      }
   }
}



/* _leave-function */
obj_t 
_leave_function_100_tools_error(obj_t env_1373)
{
   AN_OBJECT;
   {	/* Tools/error.scm 152 */
      return
	 leave_function_170_tools_error();
   }
}



/* current-function */
obj_t 
current_function_76_tools_error()
{
   AN_OBJECT;
   {	/* Tools/error.scm 158 */
      {		/* Tools/error.scm 159 */
	 obj_t pair_1274;
	 pair_1274 = _sfun_stack__205_tools_error;
	 return
	    CAR(pair_1274);
      }
   }
}



/* _current-function */
obj_t 
_current_function_148_tools_error(obj_t env_1374)
{
   AN_OBJECT;
   {	/* Tools/error.scm 158 */
      return
	 current_function_76_tools_error();
   }
}



/* method-init */
obj_t 
method_init_76_tools_error()
{
   AN_OBJECT;
   {	/* Tools/error.scm 14 */
      return BUNSPEC;
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_tools_error()
{
   AN_OBJECT;
   {	/* Tools/error.scm 14 */
      module_initialization_70_type_type(((long) 0), "TOOLS_ERROR");
      module_initialization_70_ast_var(((long) 0), "TOOLS_ERROR");
      module_initialization_70_ast_node(((long) 0), "TOOLS_ERROR");
      module_initialization_70_engine_pass(((long) 0), "TOOLS_ERROR");
      module_initialization_70_engine_param(((long) 0), "TOOLS_ERROR");
      module_initialization_70_tools_location(((long) 0), "TOOLS_ERROR");
      module_initialization_70_tools_trace(((long) 0), "TOOLS_ERROR");
      return
	 module_initialization_70_init_main(((long) 0), "TOOLS_ERROR");
   }
}
