/*===========================================================================*/
/*   (Tools/shape.scm)                                                       */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;


static obj_t method_init_76_tools_shape();
extern obj_t string_to_symbol(char *);
extern obj_t symbol_append_197___r4_symbols_6_4(obj_t);
extern long add_inlined_method__244___object(obj_t, obj_t, long);
extern obj_t string_append(obj_t, obj_t);
extern obj_t _type_shape___78_engine_param;
extern obj_t type_type_type;
extern obj_t create_struct(obj_t, long);
extern obj_t _access_shape___50_engine_param;
extern obj_t global_ast_var;
static obj_t _shape_tools_shape(obj_t, obj_t);
extern obj_t global_bucket_position_189_ast_env(obj_t, obj_t);
extern obj_t node__sexp_247_ast_dump(node_bglt);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_ast_dump(long, char *);
extern obj_t module_initialization_70_ast_env(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_symbols_6_4(long, char *);
extern obj_t module_initialization_70___r4_numbers_6_5_fixnum(long, char *);
extern obj_t module_initialization_70___r4_strings_6_7(long, char *);
extern obj_t node_ast_node;
extern obj_t _module_shape___145_engine_param;
static obj_t imported_modules_init_94_tools_shape();
extern obj_t string_downcase_77___r4_strings_6_7(obj_t);
extern obj_t add_generic__110___object(obj_t, obj_t);
static obj_t library_modules_init_112_tools_shape();
extern obj_t make_struct(obj_t, long, obj_t);
static obj_t _shape_default1439_79_tools_shape(obj_t, obj_t);
extern obj_t _key_shape___172_engine_param;
static obj_t toplevel_init_63_tools_shape();
extern obj_t open_input_string(obj_t);
static obj_t shape_default1439_162_tools_shape(obj_t);
extern char *integer__string_135___r4_numbers_6_5_fixnum(long, obj_t);
extern obj_t string_to_bstring(char *);
extern obj_t local_ast_var;
static obj_t loop_tools_shape(obj_t);
extern obj_t _case_sensitive__90_engine_param;
extern obj_t shape_tools_shape(obj_t);
extern obj_t internal_error_43_tools_error(obj_t, obj_t, obj_t);
extern obj_t _classes__134___object;
extern obj_t read___reader(obj_t);
extern obj_t _user_shape___227_engine_param;
static obj_t require_initialization_114_tools_shape = BUNSPEC;
static obj_t cnst_init_137_tools_shape();
extern obj_t make_vector(long, obj_t);
static obj_t __cnst[3];

DEFINE_STATIC_PROCEDURE(shape_default1439_env_197_tools_shape, _shape_default1439_79_tools_shape1679, _shape_default1439_79_tools_shape, 0L, 1);
DEFINE_EXPORT_GENERIC(shape_env_98_tools_shape, _shape_tools_shape1680, _shape_tools_shape, 0L, 1);
DEFINE_STRING(string1674_tools_shape, string1674_tools_shape1681, "A-TVECTOR _ @ ", 14);
DEFINE_STRING(string1673_tools_shape, string1673_tools_shape1682, "Type `extended pair' expected for expression", 44);
DEFINE_STRING(string1672_tools_shape, string1672_tools_shape1683, "cer", 3);
DEFINE_STRING(string1671_tools_shape, string1671_tools_shape1684, "Can't find global any more", 26);
DEFINE_STRING(string1669_tools_shape, string1669_tools_shape1685, "@", 1);
DEFINE_STRING(string1670_tools_shape, string1670_tools_shape1686, "global-shape", 12);
DEFINE_STRING(string1668_tools_shape, string1668_tools_shape1687, "{", 1);
DEFINE_STRING(string1667_tools_shape, string1667_tools_shape1688, "}", 1);
DEFINE_STRING(string1666_tools_shape, string1666_tools_shape1689, "", 0);
DEFINE_STRING(string1665_tools_shape, string1665_tools_shape1690, "::", 2);



/* module-initialization */
obj_t 
module_initialization_70_tools_shape(long checksum_1397, char *from_1398)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_tools_shape))
	{
	   require_initialization_114_tools_shape =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_tools_shape();
	   cnst_init_137_tools_shape();
	   imported_modules_init_94_tools_shape();
	   method_init_76_tools_shape();
	   toplevel_init_63_tools_shape();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_tools_shape()
{
   AN_OBJECT;
   {	/* Tools/shape.scm 15 */
      module_initialization_70___r4_symbols_6_4(((long) 0), "TOOLS_SHAPE");
      module_initialization_70___object(((long) 0), "TOOLS_SHAPE");
      module_initialization_70___r4_strings_6_7(((long) 0), "TOOLS_SHAPE");
      module_initialization_70___r4_numbers_6_5_fixnum(((long) 0), "TOOLS_SHAPE");
      module_initialization_70___reader(((long) 0), "TOOLS_SHAPE");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_tools_shape()
{
   AN_OBJECT;
   {	/* Tools/shape.scm 15 */
      {		/* Tools/shape.scm 15 */
	 obj_t cnst_port_138_1390;
	 cnst_port_138_1390 =
	    open_input_string(string1674_tools_shape);
	 {
	    long i_1391;
	    i_1391 = ((long) 2);
	  loop_1392:
	    {	/* Tools/shape.scm 15 */
	       bool_t test1675_1393;
	       test1675_1393 =
		  (i_1391 == ((long) -1));
	       if (test1675_1393)
		 {	/* Tools/shape.scm 15 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Tools/shape.scm 15 */
		    {	/* Tools/shape.scm 15 */
		       obj_t arg1676_1394;
		       {	/* Tools/shape.scm 15 */
			  obj_t list1677_1395;
			  list1677_1395 =
			     MAKE_PAIR(cnst_port_138_1390, BNIL);
			  arg1676_1394 =
			     read___reader(list1677_1395);
		       }
		       CNST_TABLE_SET(i_1391, arg1676_1394);
		    }
		    {	/* Tools/shape.scm 15 */
		       int aux_1396;
		       {	/* Tools/shape.scm 15 */
			  long aux_1418;
			  aux_1418 =
			     (i_1391 - ((long) 1));
			  aux_1396 =
			     (int) (aux_1418);
		       }
		       {
			  long i_1421;
			  i_1421 =
			     (long) (aux_1396);
			  i_1391 = i_1421;
			  goto loop_1392;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_tools_shape()
{
   AN_OBJECT;
   {	/* Tools/shape.scm 15 */
      return BUNSPEC;
   }
}



/* method-init */
obj_t 
method_init_76_tools_shape()
{
   AN_OBJECT;
   {	/* Tools/shape.scm 15 */
      add_generic__110___object(shape_env_98_tools_shape, shape_default1439_env_197_tools_shape);
      add_inlined_method__244___object(shape_env_98_tools_shape, global_ast_var, ((long) 0));
      add_inlined_method__244___object(shape_env_98_tools_shape, local_ast_var, ((long) 1));
      add_inlined_method__244___object(shape_env_98_tools_shape, type_type_type, ((long) 2));
      {		/* Tools/shape.scm 15 */
	 long aux_1427;
	 aux_1427 =
	    add_inlined_method__244___object(shape_env_98_tools_shape, node_ast_node, ((long) 3));
	 return
	    BINT(aux_1427);
      }
   }
}



/* shape */
obj_t 
shape_tools_shape(obj_t exp_12)
{
   AN_OBJECT;
   {	/* Tools/shape.scm 35 */
      {
	 obj_t method1568_1093;
	 obj_t class1573_1094;
	 {	/* Tools/shape.scm 35 */
	    bool_t test1578_1090;
	    test1578_1090 =
	       (POINTERP(exp_12) && (TYPE(exp_12) >= OBJECT_TYPE));
	    if (test1578_1090)
	      {		/* Tools/shape.scm 35 */
		 obj_t arg1579_1091;
		 obj_t arg1580_1092;
		 {	/* Tools/shape.scm 35 */
		    object_bglt obj_1235;
		    obj_1235 =
		       (object_bglt) (exp_12);
		    {	/* ./Llib/object.scm 2926 */
		       obj_t pre_method_105_1236;
		       pre_method_105_1236 =
			  PROCEDURE_REF(shape_env_98_tools_shape, ((long) 2));
		       if (
			  INTEGERP(pre_method_105_1236))
			 {	/* ./Llib/object.scm 2927 */
			    PROCEDURE_SET(shape_env_98_tools_shape, ((long) 2), BUNSPEC);
			    arg1579_1091 = pre_method_105_1236;
			 }
		       else
			 {	/* ./Llib/object.scm 2914 */
			    long obj_class_num_177_1241;
			    obj_class_num_177_1241 =
			       TYPE(obj_1235);
			    {	/* ./Llib/object.scm 2915 */
			       obj_t arg1176_1242;
			       arg1176_1242 =
				  PROCEDURE_REF(shape_env_98_tools_shape, ((long) 1));
			       {	/* ./Llib/object.scm 2738 */
				  long arg1177_1246;
				  {	/* ./Llib/object.scm 2738 */
				     long arg1178_1247;
				     arg1178_1247 =
					OBJECT_TYPE;
				     arg1177_1246 =
					(obj_class_num_177_1241 - arg1178_1247);
				  }
				  arg1579_1091 =
				     VECTOR_REF(arg1176_1242, arg1177_1246);
			       }
			    }
			 }
		    }
		 }
		 {	/* Tools/shape.scm 35 */
		    object_bglt object_1252;
		    object_1252 =
		       (object_bglt) (exp_12);
		    {	/* ./Llib/object.scm 2695 */
		       long arg1179_1253;
		       {	/* ./Llib/object.scm 2695 */
			  long arg1180_1254;
			  long arg1181_1255;
			  arg1180_1254 =
			     TYPE(object_1252);
			  arg1181_1255 =
			     OBJECT_TYPE;
			  arg1179_1253 =
			     (arg1180_1254 - arg1181_1255);
		       }
		       {	/* ./Llib/object.scm 2695 */
			  obj_t vector_1259;
			  vector_1259 = _classes__134___object;
			  arg1580_1092 =
			     VECTOR_REF(vector_1259, arg1179_1253);
		       }
		    }
		 }
		 method1568_1093 = arg1579_1091;
		 class1573_1094 = arg1580_1092;
	       _anonymous_1581__195_1095:
		 {

		    if (
		       INTEGERP(method1568_1093))
		      {		/* Tools/shape.scm 35 */
			 switch (
			    (long) CINT(method1568_1093))
			   {
			   case ((long) 0):

			      {		/* Tools/shape.scm 80 */
				 global_bglt var_1100;
				 var_1100 =
				    (global_bglt) (exp_12);
				 {	/* Tools/shape.scm 80 */
				    obj_t str_id_3_1101;
				    {	/* Tools/shape.scm 80 */
				       obj_t arg1631_1161;
				       {	/* ./Ieee/symbol.scm 6021 */
					  obj_t aux_1450;
					  aux_1450 =
					     (((global_bglt) CREF(var_1100))->id);
					  arg1631_1161 =
					     SYMBOL_TO_STRING(aux_1450);
				       }
				       if (
					  CBOOL(_case_sensitive__90_engine_param))
					 {	/* Tools/shape.scm 28 */
					    str_id_3_1101 = arg1631_1161;
					 }
				       else
					 {	/* Tools/shape.scm 28 */
					    str_id_3_1101 =
					       string_downcase_77___r4_strings_6_7(arg1631_1161);
					 }
				    }
				    {	/* Tools/shape.scm 80 */
				       obj_t id_1102;
				       {	/* ./Ieee/symbol.scm 6027 */
					  char *aux_1456;
					  aux_1456 =
					     BSTRING_TO_STRING(str_id_3_1101);
					  id_1102 =
					     string_to_symbol(aux_1456);
				       }
				       {	/* Tools/shape.scm 81 */
					  obj_t module_1103;
					  {	/* Tools/shape.scm 82 */
					     obj_t arg1629_1159;
					     {	/* ./Ieee/symbol.scm 6021 */
						obj_t aux_1459;
						aux_1459 =
						   (((global_bglt) CREF(var_1100))->module);
						arg1629_1159 =
						   SYMBOL_TO_STRING(aux_1459);
					     }
					     if (
						CBOOL(_case_sensitive__90_engine_param))
					       {	/* Tools/shape.scm 28 */
						  module_1103 = arg1629_1159;
					       }
					     else
					       {	/* Tools/shape.scm 28 */
						  module_1103 =
						     string_downcase_77___r4_strings_6_7(arg1629_1159);
					       }
					  }
					  {	/* Tools/shape.scm 82 */
					     type_bglt type_1104;
					     type_1104 =
						(((global_bglt) CREF(var_1100))->type);
					     {	/* Tools/shape.scm 83 */
						obj_t tshape_1105;
						if (
						   CBOOL(_type_shape___78_engine_param))
						  {	/* Tools/shape.scm 86 */
						     obj_t arg1628_1158;
						     arg1628_1158 =
							shape_tools_shape(
							(obj_t) (type_1104));
						     tshape_1105 =
							string_append(string1665_tools_shape, arg1628_1158);
						  }
						else
						  {	/* Tools/shape.scm 84 */
						     tshape_1105 = string1666_tools_shape;
						  }
						{	/* Tools/shape.scm 84 */
						   char *ushape_1106;
						   if (
						      CBOOL(_user_shape___227_engine_param))
						     {	/* Tools/shape.scm 87 */
							if (
							   (((global_bglt) CREF(var_1100))->user__32))
							  {	/* Tools/shape.scm 89 */
							     ushape_1106 = "-<user>";
							  }
							else
							  {	/* Tools/shape.scm 89 */
							     ushape_1106 = "-<no-user>";
							  }
						     }
						   else
						     {	/* Tools/shape.scm 87 */
							ushape_1106 = "";
						     }
						   {	/* Tools/shape.scm 87 */
						      obj_t ashape_1107;
						      if (
							 CBOOL(_access_shape___50_engine_param))
							{	/* Tools/shape.scm 93 */
							   {	/* Tools/shape.scm 96 */
							      obj_t arg1621_1151;
							      {		/* Tools/shape.scm 98 */
								 obj_t arg1622_1152;
								 {	/* Tools/shape.scm 98 */
								    obj_t arg1624_1154;
								    {	/* ./Ieee/symbol.scm 6021 */
								       obj_t aux_1477;
								       aux_1477 =
									  (((global_bglt) CREF(var_1100))->access);
								       arg1624_1154 =
									  SYMBOL_TO_STRING(aux_1477);
								    }
								    if (
								       CBOOL(_case_sensitive__90_engine_param))
								      {		/* Tools/shape.scm 28 */
									 arg1622_1152 = arg1624_1154;
								      }
								    else
								      {		/* Tools/shape.scm 28 */
									 arg1622_1152 =
									    string_downcase_77___r4_strings_6_7(arg1624_1154);
								      }
								 }
								 arg1621_1151 =
								    string_append(arg1622_1152, string1667_tools_shape);
							      }
							      ashape_1107 =
								 string_append(string1668_tools_shape, arg1621_1151);
							   }
							}
						      else
							{	/* Tools/shape.scm 93 */
							   ashape_1107 = string1666_tools_shape;
							}
						      {		/* Tools/shape.scm 92 */

							 if (
							    CBOOL(_module_shape___145_engine_param))
							   {	/* Tools/shape.scm 101 */
							      {		/* Tools/shape.scm 102 */
								 obj_t arg1583_1108;
								 {	/* Tools/shape.scm 102 */
								    obj_t arg1584_1109;
								    {	/* Tools/shape.scm 102 */
								       obj_t arg1586_1111;
								       {	/* Tools/shape.scm 102 */
									  obj_t arg1587_1112;
									  {	/* Tools/shape.scm 102 */
									     obj_t arg1588_1113;
									     {	/* Tools/shape.scm 102 */
										obj_t aux_1487;
										aux_1487 =
										   string_to_bstring(ushape_1106);
										arg1588_1113 =
										   string_append(aux_1487, ashape_1107);
									     }
									     arg1587_1112 =
										string_append(tshape_1105, arg1588_1113);
									  }
									  arg1586_1111 =
									     string_append(module_1103, arg1587_1112);
								       }
								       arg1584_1109 =
									  string_append(string1669_tools_shape, arg1586_1111);
								    }
								    arg1583_1108 =
								       string_append(str_id_3_1101, arg1584_1109);
								 }
								 {	/* ./Ieee/symbol.scm 6027 */
								    char *aux_1494;
								    aux_1494 =
								       BSTRING_TO_STRING(arg1583_1108);
								    return
								       string_to_symbol(aux_1494);
								 }
							      }
							   }
							 else
							   {	/* Tools/shape.scm 101 */
							      {

								 {	/* Tools/shape.scm 109 */
								    obj_t aux1438_1115;
								    aux1438_1115 =
								       global_bucket_position_189_ast_env(
								       (((global_bglt) CREF(var_1100))->id),
								       (((global_bglt) CREF(var_1100))->module));
								    {	/* Tools/shape.scm 109 */
								       bool_t test1589_1116;
								       test1589_1116 =
									  INTEGERP(aux1438_1115);
								       if (test1589_1116)
									 {	/* Tools/shape.scm 109 */
									    if (test1589_1116)
									      {		/* Tools/shape.scm 109 */
										 switch (
										    (long) CINT(aux1438_1115))
										   {
										   case ((long) -1):

										      {		/* Tools/shape.scm 111 */
											 obj_t arg1593_1122;
											 {	/* Tools/shape.scm 113 */
											    obj_t arg1594_1123;
											    obj_t arg1595_1124;
											    arg1594_1123 =
											       CNST_TABLE_REF(((long) 0));
											    {	/* Tools/shape.scm 113 */
											       obj_t arg1596_1125;
											       {	/* ./Ieee/pair-list.scm 5689 */
												  obj_t aux_1504;
												  aux_1504 =
												     (((global_bglt) CREF(var_1100))->module);
												  arg1596_1125 =
												     MAKE_PAIR(aux_1504, BNIL);
											       }
											       arg1595_1124 =
												  MAKE_PAIR(id_1102, arg1596_1125);
											    }
											    arg1593_1122 =
											       MAKE_PAIR(arg1594_1123, arg1595_1124);
											 }
											 return
											    internal_error_43_tools_error(string1670_tools_shape, string1671_tools_shape, arg1593_1122);
										      }
										      break;
										   case ((long) 0):

										      {		/* Tools/shape.scm 116 */
											 obj_t arg1599_1128;
											 obj_t arg1600_1129;
											 obj_t arg1601_1130;
											 {	/* ./Ieee/symbol.scm 6027 */
											    char *aux_1510;
											    aux_1510 =
											       BSTRING_TO_STRING(tshape_1105);
											    arg1599_1128 =
											       string_to_symbol(aux_1510);
											 }
											 {	/* ./Ieee/symbol.scm 6027 */
											    char *aux_1513;
											    {	/* ./Ieee/symbol.scm 6027 */
											       obj_t aux_1514;
											       aux_1514 =
												  string_to_bstring(ushape_1106);
											       aux_1513 =
												  BSTRING_TO_STRING(aux_1514);
											    }
											    arg1600_1129 =
											       string_to_symbol(aux_1513);
											 }
											 {	/* ./Ieee/symbol.scm 6027 */
											    char *aux_1518;
											    aux_1518 =
											       BSTRING_TO_STRING(ashape_1107);
											    arg1601_1130 =
											       string_to_symbol(aux_1518);
											 }
											 {	/* Tools/shape.scm 115 */
											    obj_t list1602_1131;
											    {	/* Tools/shape.scm 115 */
											       obj_t arg1603_1132;
											       {	/* Tools/shape.scm 115 */
												  obj_t arg1604_1133;
												  {	/* Tools/shape.scm 115 */
												     obj_t arg1605_1134;
												     arg1605_1134 =
													MAKE_PAIR(arg1601_1130, BNIL);
												     arg1604_1133 =
													MAKE_PAIR(arg1600_1129, arg1605_1134);
												  }
												  arg1603_1132 =
												     MAKE_PAIR(arg1599_1128, arg1604_1133);
											       }
											       list1602_1131 =
												  MAKE_PAIR(id_1102, arg1603_1132);
											    }
											    return
											       symbol_append_197___r4_symbols_6_4(list1602_1131);
											 }
										      }
										      break;
										   default:
										    case_else1437_1114:
										      {		/* Tools/shape.scm 120 */
											 obj_t sym_1137;
											 {	/* Tools/shape.scm 121 */
											    obj_t arg1613_1143;
											    obj_t arg1614_1144;
											    obj_t arg1615_1145;
											    {	/* ./Ieee/symbol.scm 6027 */
											       char *aux_1526;
											       aux_1526 =
												  BSTRING_TO_STRING(tshape_1105);
											       arg1613_1143 =
												  string_to_symbol(aux_1526);
											    }
											    {	/* ./Ieee/symbol.scm 6027 */
											       char *aux_1529;
											       {	/* ./Ieee/symbol.scm 6027 */
												  obj_t aux_1530;
												  aux_1530 =
												     string_to_bstring(ushape_1106);
												  aux_1529 =
												     BSTRING_TO_STRING(aux_1530);
											       }
											       arg1614_1144 =
												  string_to_symbol(aux_1529);
											    }
											    {	/* ./Ieee/symbol.scm 6027 */
											       char *aux_1534;
											       aux_1534 =
												  BSTRING_TO_STRING(ashape_1107);
											       arg1615_1145 =
												  string_to_symbol(aux_1534);
											    }
											    {	/* Tools/shape.scm 120 */
											       obj_t list1616_1146;
											       {	/* Tools/shape.scm 120 */
												  obj_t arg1617_1147;
												  {	/* Tools/shape.scm 120 */
												     obj_t arg1618_1148;
												     {	/* Tools/shape.scm 120 */
													obj_t arg1619_1149;
													arg1619_1149 =
													   MAKE_PAIR(arg1615_1145, BNIL);
													arg1618_1148 =
													   MAKE_PAIR(arg1614_1144, arg1619_1149);
												     }
												     arg1617_1147 =
													MAKE_PAIR(arg1613_1143, arg1618_1148);
												  }
												  list1616_1146 =
												     MAKE_PAIR(id_1102, arg1617_1147);
											       }
											       sym_1137 =
												  symbol_append_197___r4_symbols_6_4(list1616_1146);
											    }
											 }
											 {	/* Tools/shape.scm 124 */
											    obj_t arg1608_1138;
											    obj_t arg1609_1139;
											    arg1608_1138 =
											       CNST_TABLE_REF(((long) 0));
											    {	/* Tools/shape.scm 124 */
											       obj_t arg1610_1140;
											       {	/* Tools/shape.scm 124 */
												  obj_t arg1611_1141;
												  {	/* ./Ieee/symbol.scm 6027 */
												     char *aux_1543;
												     aux_1543 =
													BSTRING_TO_STRING(module_1103);
												     arg1611_1141 =
													string_to_symbol(aux_1543);
												  }
												  arg1610_1140 =
												     MAKE_PAIR(arg1611_1141, BNIL);
											       }
											       arg1609_1139 =
												  MAKE_PAIR(sym_1137, arg1610_1140);
											    }
											    return
											       MAKE_PAIR(arg1608_1138, arg1609_1139);
											 }
										      }
										   }
									      }
									    else
									      {		/* Tools/shape.scm 109 */
										 goto case_else1437_1114;
									      }
									 }
								       else
									 {	/* Tools/shape.scm 109 */
									    goto case_else1437_1114;
									 }
								    }
								 }
							      }
							   }
						      }
						   }
						}
					     }
					  }
				       }
				    }
				 }
			      }
			      break;
			   case ((long) 1):

			      {		/* Tools/shape.scm 130 */
				 local_bglt var_1163;
				 var_1163 =
				    (local_bglt) (exp_12);
				 {	/* Tools/shape.scm 130 */
				    obj_t sym_1164;
				    if (
				       CBOOL(_key_shape___172_engine_param))
				      {		/* Tools/shape.scm 131 */
					 obj_t arg1647_1183;
					 obj_t arg1648_1184;
					 obj_t arg1649_1185;
					 arg1647_1183 =
					    (((local_bglt) CREF(var_1163))->id);
					 arg1648_1184 =
					    CNST_TABLE_REF(((long) 1));
					 {	/* ./Ieee/symbol.scm 6027 */
					    char *aux_1556;
					    {	/* ./Ieee/symbol.scm 6027 */
					       obj_t aux_1557;
					       {	/* Tools/shape.scm 133 */
						  char *aux_1558;
						  aux_1558 =
						     integer__string_135___r4_numbers_6_5_fixnum(
						     (((local_bglt) CREF(var_1163))->key), BNIL);
						  aux_1557 =
						     string_to_bstring(aux_1558);
					       }
					       aux_1556 =
						  BSTRING_TO_STRING(aux_1557);
					    }
					    arg1649_1185 =
					       string_to_symbol(aux_1556);
					 }
					 {	/* Tools/shape.scm 131 */
					    obj_t list1650_1186;
					    {	/* Tools/shape.scm 131 */
					       obj_t arg1651_1187;
					       {	/* Tools/shape.scm 131 */
						  obj_t arg1652_1188;
						  arg1652_1188 =
						     MAKE_PAIR(arg1649_1185, BNIL);
						  arg1651_1187 =
						     MAKE_PAIR(arg1648_1184, arg1652_1188);
					       }
					       list1650_1186 =
						  MAKE_PAIR(arg1647_1183, arg1651_1187);
					    }
					    sym_1164 =
					       symbol_append_197___r4_symbols_6_4(list1650_1186);
					 }
				      }
				    else
				      {		/* Tools/shape.scm 130 */
					 sym_1164 =
					    (((local_bglt) CREF(var_1163))->id);
				      }
				    {	/* Tools/shape.scm 130 */
				       obj_t sym_1165;
				       {	/* Tools/shape.scm 136 */
					  obj_t arg1646_1182;
					  arg1646_1182 =
					     SYMBOL_TO_STRING(sym_1164);
					  if (
					     CBOOL(_case_sensitive__90_engine_param))
					    {	/* Tools/shape.scm 28 */
					       sym_1165 = arg1646_1182;
					    }
					  else
					    {	/* Tools/shape.scm 28 */
					       sym_1165 =
						  string_downcase_77___r4_strings_6_7(arg1646_1182);
					    }
				       }
				       {	/* Tools/shape.scm 136 */
					  type_bglt type_1166;
					  type_1166 =
					     (((local_bglt) CREF(var_1163))->type);
					  {	/* Tools/shape.scm 137 */
					     obj_t tshape_1167;
					     if (
						CBOOL(_type_shape___78_engine_param))
					       {	/* Tools/shape.scm 140 */
						  obj_t arg1644_1181;
						  arg1644_1181 =
						     shape_tools_shape(
						     (obj_t) (type_1166));
						  tshape_1167 =
						     string_append(string1665_tools_shape, arg1644_1181);
					       }
					     else
					       {	/* Tools/shape.scm 138 */
						  tshape_1167 = string1666_tools_shape;
					       }
					     {	/* Tools/shape.scm 138 */
						char *ushape_1168;
						if (
						   CBOOL(_user_shape___227_engine_param))
						  {	/* Tools/shape.scm 141 */
						     if (
							(((local_bglt) CREF(var_1163))->user__32))
						       {	/* Tools/shape.scm 143 */
							  ushape_1168 = "-<user>";
						       }
						     else
						       {	/* Tools/shape.scm 143 */
							  ushape_1168 = "-<no-user>";
						       }
						  }
						else
						  {	/* Tools/shape.scm 141 */
						     ushape_1168 = "";
						  }
						{	/* Tools/shape.scm 141 */
						   obj_t ashape_1169;
						   if (
						      CBOOL(_access_shape___50_engine_param))
						     {	/* Tools/shape.scm 147 */
							{	/* Tools/shape.scm 150 */
							   obj_t arg1637_1174;
							   {	/* Tools/shape.scm 152 */
							      obj_t arg1638_1175;
							      {		/* Tools/shape.scm 152 */
								 obj_t arg1640_1177;
								 {	/* ./Ieee/symbol.scm 6021 */
								    obj_t aux_1585;
								    aux_1585 =
								       (((local_bglt) CREF(var_1163))->access);
								    arg1640_1177 =
								       SYMBOL_TO_STRING(aux_1585);
								 }
								 if (
								    CBOOL(_case_sensitive__90_engine_param))
								   {	/* Tools/shape.scm 28 */
								      arg1638_1175 = arg1640_1177;
								   }
								 else
								   {	/* Tools/shape.scm 28 */
								      arg1638_1175 =
									 string_downcase_77___r4_strings_6_7(arg1640_1177);
								   }
							      }
							      arg1637_1174 =
								 string_append(arg1638_1175, string1667_tools_shape);
							   }
							   ashape_1169 =
							      string_append(string1668_tools_shape, arg1637_1174);
							}
						     }
						   else
						     {	/* Tools/shape.scm 147 */
							ashape_1169 = string1666_tools_shape;
						     }
						   {	/* Tools/shape.scm 146 */

						      {		/* Tools/shape.scm 154 */
							 obj_t arg1633_1170;
							 {	/* Tools/shape.scm 154 */
							    obj_t arg1634_1171;
							    {	/* Tools/shape.scm 154 */
							       obj_t arg1635_1172;
							       {	/* Tools/shape.scm 154 */
								  obj_t aux_1593;
								  aux_1593 =
								     string_to_bstring(ushape_1168);
								  arg1635_1172 =
								     string_append(aux_1593, ashape_1169);
							       }
							       arg1634_1171 =
								  string_append(tshape_1167, arg1635_1172);
							    }
							    arg1633_1170 =
							       string_append(sym_1165, arg1634_1171);
							 }
							 {	/* ./Ieee/symbol.scm 6027 */
							    char *aux_1598;
							    aux_1598 =
							       BSTRING_TO_STRING(arg1633_1170);
							    return
							       string_to_symbol(aux_1598);
							 }
						      }
						   }
						}
					     }
					  }
				       }
				    }
				 }
			      }
			      break;
			   case ((long) 2):

			      {		/* Tools/shape.scm 160 */
				 type_bglt type_1192;
				 type_1192 =
				    (type_bglt) (exp_12);
				 {	/* Tools/shape.scm 160 */
				    obj_t arg1656_1193;
				    {	/* ./Ieee/symbol.scm 6021 */
				       obj_t aux_1602;
				       aux_1602 =
					  (((type_bglt) CREF(type_1192))->id);
				       arg1656_1193 =
					  SYMBOL_TO_STRING(aux_1602);
				    }
				    if (
				       CBOOL(_case_sensitive__90_engine_param))
				      {		/* Tools/shape.scm 28 */
					 return arg1656_1193;
				      }
				    else
				      {		/* Tools/shape.scm 28 */
					 return
					    string_downcase_77___r4_strings_6_7(arg1656_1193);
				      }
				 }
			      }
			      break;
			   case ((long) 3):

			      return
				 node__sexp_247_ast_dump(
				 (node_bglt) (exp_12));
			      break;
			   default:
			    case_else1574_1097:
			      if (
				 PROCEDUREP(method1568_1093))
				{	/* Tools/shape.scm 35 */
				   return
				      PROCEDURE_ENTRY(method1568_1093) (method1568_1093, exp_12, BEOA);
				}
			      else
				{	/* Tools/shape.scm 35 */
				   obj_t fun1537_1049;
				   fun1537_1049 =
				      PROCEDURE_REF(shape_env_98_tools_shape, ((long) 0));
				   return
				      PROCEDURE_ENTRY(fun1537_1049) (fun1537_1049, exp_12, BEOA);
				}
			   }
		      }
		    else
		      {		/* Tools/shape.scm 35 */
			 goto case_else1574_1097;
		      }
		 }
	      }
	    else
	      {
		 obj_t class1573_1620;
		 obj_t method1568_1619;
		 method1568_1619 = BFALSE;
		 class1573_1620 = BFALSE;
		 class1573_1094 = class1573_1620;
		 method1568_1093 = method1568_1619;
		 goto _anonymous_1581__195_1095;
	      }
	 }
      }
   }
}



/* _shape */
obj_t 
_shape_tools_shape(obj_t env_1385, obj_t exp_1386)
{
   AN_OBJECT;
   {	/* Tools/shape.scm 35 */
      return
	 shape_tools_shape(exp_1386);
   }
}



/* shape-default1439 */
obj_t 
shape_default1439_162_tools_shape(obj_t exp_13)
{
   AN_OBJECT;
   {	/* Tools/shape.scm 15 */
      if (
	 PAIRP(exp_13))
	{	/* Tools/shape.scm 37 */
	   return
	      loop_tools_shape(exp_13);
	}
      else
	{	/* Tools/shape.scm 37 */
	   if (
	      VECTORP(exp_13))
	     {	/* Tools/shape.scm 48 */
		{	/* Tools/shape.scm 49 */
		   long len_1066;
		   len_1066 =
		      VECTOR_LENGTH(exp_13);
		   {	/* Tools/shape.scm 49 */
		      obj_t res_1067;
		      res_1067 =
			 make_vector(len_1066, BNIL);
		      {		/* Tools/shape.scm 50 */

			 {
			    long indice_1068;
			    indice_1068 = ((long) 0);
			  loop_1069:
			    if (
			       (indice_1068 == len_1066))
			      {		/* Tools/shape.scm 52 */
				 return res_1067;
			      }
			    else
			      {		/* Tools/shape.scm 52 */
				 {	/* Tools/shape.scm 57 */
				    obj_t arg1555_1071;
				    arg1555_1071 =
				       shape_tools_shape(
				       VECTOR_REF(exp_13, indice_1068));
				    VECTOR_SET(res_1067, indice_1068, arg1555_1071);
				 }
				 {
				    long indice_1634;
				    indice_1634 =
				       (indice_1068 + ((long) 1));
				    indice_1068 = indice_1634;
				    goto loop_1069;
				 }
			      }
			 }
		      }
		   }
		}
	     }
	   else
	     {	/* Tools/shape.scm 59 */
		bool_t test_1636;
		if (
		   STRUCTP(exp_13))
		  {	/* ./Ieee/equiv.scm 5508 */
		     obj_t aux_1641;
		     obj_t aux_1639;
		     aux_1641 =
			CNST_TABLE_REF(((long) 2));
		     aux_1639 =
			STRUCT_KEY(exp_13);
		     test_1636 =
			(aux_1639 == aux_1641);
		  }
		else
		  {	/* ./Tvector/tvector.sch 434 */
		     test_1636 = ((bool_t) 0)
			;
		  }
		if (test_1636)
		  {	/* Tools/shape.scm 59 */
		     {	/* Tools/shape.scm 60 */
			obj_t arg1559_1075;
			obj_t arg1560_1076;
			arg1559_1075 =
			   shape_tools_shape(
			   STRUCT_REF(exp_13, ((long) 0)));
			arg1560_1076 =
			   shape_tools_shape(
			   STRUCT_REF(exp_13, ((long) 1)));
			{	/* ./Tvector/tvector.sch 434 */
			   obj_t new_1359;
			   {	/* ./Tvector/tvector.sch 434 */
			      obj_t aux_1648;
			      aux_1648 =
				 CNST_TABLE_REF(((long) 2));
			      new_1359 =
				 create_struct(aux_1648, ((long) 2));
			   }
			   STRUCT_SET(new_1359, ((long) 1), arg1560_1076);
			   STRUCT_SET(new_1359, ((long) 0), arg1559_1075);
			   return new_1359;
			}
		     }
		  }
		else
		  {	/* Tools/shape.scm 59 */
		     if (
			STRUCTP(exp_13))
		       {	/* Tools/shape.scm 61 */
			  {	/* Tools/shape.scm 62 */
			     long len_1081;
			     len_1081 =
				STRUCT_LENGTH(exp_13);
			     {	/* Tools/shape.scm 63 */
				obj_t res_1082;
				{	/* ./Llib/struct.scm 1415 */
				   obj_t aux_1656;
				   aux_1656 =
				      STRUCT_KEY(exp_13);
				   res_1082 =
				      make_struct(aux_1656, len_1081, BNIL);
				}
				{	/* Tools/shape.scm 64 */

				   {
				      long indice_1083;
				      indice_1083 = ((long) 0);
				    loop_1084:
				      if (
					 (indice_1083 == len_1081))
					{	/* Tools/shape.scm 66 */
					   return res_1082;
					}
				      else
					{	/* Tools/shape.scm 66 */
					   {	/* Tools/shape.scm 71 */
					      obj_t arg1565_1086;
					      arg1565_1086 =
						 shape_tools_shape(
						 STRUCT_REF(exp_13, indice_1083));
					      STRUCT_SET(res_1082, indice_1083, arg1565_1086);
					   }
					   {
					      long indice_1664;
					      indice_1664 =
						 (indice_1083 + ((long) 1));
					      indice_1083 = indice_1664;
					      goto loop_1084;
					   }
					}
				   }
				}
			     }
			  }
		       }
		     else
		       {	/* Tools/shape.scm 61 */
			  return exp_13;
		       }
		  }
	     }
	}
   }
}



/* loop */
obj_t 
loop_tools_shape(obj_t exp_1051)
{
   AN_OBJECT;
   {	/* Tools/shape.scm 38 */
      if (
	 NULLP(exp_1051))
	{	/* Tools/shape.scm 40 */
	   return BNIL;
	}
      else
	{	/* Tools/shape.scm 40 */
	   if (
	      PAIRP(exp_1051))
	     {	/* Tools/shape.scm 44 */
		bool_t test1541_1055;
		test1541_1055 =
		   EXTENDED_PAIRP(exp_1051);
		if (test1541_1055)
		  {	/* Tools/shape.scm 44 */
		     {	/* Tools/shape.scm 45 */
			obj_t arg1543_1056;
			obj_t arg1544_1057;
			obj_t arg1545_1058;
			arg1543_1056 =
			   shape_tools_shape(
			   CAR(exp_1051));
			arg1544_1057 =
			   loop_tools_shape(
			   CDR(exp_1051));
			{	/* ./Ieee/pair-list.scm 5713 */
			   bool_t test1136_1320;
			   test1136_1320 =
			      EXTENDED_PAIRP(exp_1051);
			   if (test1136_1320)
			     {	/* ./Ieee/pair-list.scm 5713 */
				arg1545_1058 =
				   CER(exp_1051);
			     }
			   else
			     {	/* ./Ieee/pair-list.scm 5713 */
				FAILURE(string1672_tools_shape, string1673_tools_shape, exp_1051);
			     }
			}
			return
			   MAKE_EXTENDED_PAIR(arg1543_1056, arg1544_1057, arg1545_1058);
		     }
		  }
		else
		  {	/* Tools/shape.scm 44 */
		     {	/* Tools/shape.scm 47 */
			obj_t arg1549_1061;
			obj_t arg1550_1062;
			arg1549_1061 =
			   shape_tools_shape(
			   CAR(exp_1051));
			arg1550_1062 =
			   loop_tools_shape(
			   CDR(exp_1051));
			return
			   MAKE_PAIR(arg1549_1061, arg1550_1062);
		     }
		  }
	     }
	   else
	     {	/* Tools/shape.scm 42 */
		return
		   shape_tools_shape(exp_1051);
	     }
	}
   }
}



/* _shape-default1439 */
obj_t 
_shape_default1439_79_tools_shape(obj_t env_1387, obj_t exp_1388)
{
   AN_OBJECT;
   {	/* Tools/shape.scm 15 */
      return
	 shape_default1439_162_tools_shape(exp_1388);
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_tools_shape()
{
   AN_OBJECT;
   {	/* Tools/shape.scm 15 */
      module_initialization_70_type_type(((long) 0), "TOOLS_SHAPE");
      module_initialization_70_ast_var(((long) 0), "TOOLS_SHAPE");
      module_initialization_70_ast_node(((long) 0), "TOOLS_SHAPE");
      module_initialization_70_ast_dump(((long) 0), "TOOLS_SHAPE");
      module_initialization_70_ast_env(((long) 0), "TOOLS_SHAPE");
      module_initialization_70_engine_param(((long) 0), "TOOLS_SHAPE");
      return
	 module_initialization_70_tools_error(((long) 0), "TOOLS_SHAPE");
   }
}
