/*===========================================================================*/
/*   (Trace/walk.scm)                                                        */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;

typedef struct ccomp
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t producer;
     obj_t consumer;
     obj_t finalizer;
     obj_t checksummer;
  }
     *ccomp_bglt;


extern obj_t find_global_223_ast_env(obj_t, obj_t);
static obj_t method_init_76_trace_walk();
extern obj_t make_box_202_ast_node;
extern obj_t funcall_ast_node;
extern obj_t symbol_append_197___r4_symbols_6_4(obj_t);
static node_bglt trace_node_95_trace_walk(node_bglt);
extern long add_inlined_method__244___object(obj_t, obj_t, long);
extern obj_t current_error_port;
extern obj_t fail_ast_node;
extern obj_t _nb_error_on_pass__70_tools_error;
extern obj_t box_ref_242_ast_node;
extern obj_t leave_function_170_tools_error();
extern obj_t mark_symbol_non_user__17_ast_ident(obj_t);
extern obj_t sequence_ast_node;
extern obj_t let_var_6_ast_node;
extern obj_t var_ast_node;
extern obj_t global_ast_var;
extern obj_t gensym___r4_symbols_6_4;
extern obj_t pragma_ast_node;
extern obj_t set_ex_it_116_ast_node;
extern obj_t verbose_tools_speek(obj_t, obj_t);
extern bool_t is_a__118___object(obj_t, obj_t);
static obj_t _trace_walk__101_trace_walk(obj_t, obj_t);
extern obj_t module_initialization_70_trace_walk(long, char *);
extern obj_t module_initialization_70_tools_speek(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_engine_pass(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_misc(long, char *);
extern obj_t module_initialization_70_type_env(long, char *);
extern obj_t module_initialization_70_ast_sexp(long, char *);
extern obj_t module_initialization_70_module_module(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_ast_ident(long, char *);
extern obj_t module_initialization_70_ast_env(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_symbols_6_4(long, char *);
extern obj_t module_initialization_70___r4_numbers_6_5(long, char *);
extern obj_t module_initialization_70___r4_output_6_10_3(long, char *);
static obj_t trace_fun__23_trace_walk(obj_t);
static let_var_6_bglt make_traced_node_44_trace_walk(node_bglt, type_bglt, obj_t);
extern obj_t trace_walk__65_trace_walk(obj_t);
static obj_t _trace_node_88_trace_walk(obj_t, obj_t);
extern obj_t display_2_122___r4_output_6_10_3(obj_t, obj_t);
extern obj_t let_fun_218_ast_node;
static obj_t imported_modules_init_94_trace_walk();
static node_bglt toplevel_trace_node_251_trace_walk(node_bglt);
extern obj_t app_ly_162_ast_node;
extern obj_t add_generic__110___object(obj_t, obj_t);
static obj_t _trace_node_default1468_12_trace_walk(obj_t, obj_t);
extern obj_t app_ast_node;
static obj_t library_modules_init_112_trace_walk();
static obj_t _toplevel_trace_node_default1504_138_trace_walk(obj_t, obj_t);
extern obj_t atom_ast_node;
extern obj_t cast_ast_node;
static obj_t toplevel_init_63_trace_walk();
extern node_bglt sexp__node_235_ast_sexp(obj_t, obj_t, obj_t, obj_t);
extern obj_t jump_ex_it_184_ast_node;
extern obj_t open_input_string(obj_t);
extern obj_t kwote_ast_node;
extern obj_t setq_ast_node;
static node_bglt toplevel_trace_node_default1504_69_trace_walk(node_bglt);
extern obj_t box_set__221_ast_node;
extern obj_t string_to_bstring(char *);
extern obj_t enter_function_81_tools_error(obj_t);
static obj_t _toplevel_trace_node1815_104_trace_walk(obj_t, obj_t);
extern obj_t memq___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern obj_t _compiler_debug__134_engine_param;
static obj_t toplevel_trace_node___112_trace_walk(obj_t);
extern obj_t internal_error_43_tools_error(obj_t, obj_t, obj_t);
extern obj_t _module__166_module_module;
extern obj_t _4dots_199_tools_misc;
static obj_t trace_id_33_trace_walk(obj_t);
extern obj_t _classes__134___object;
extern obj_t select_ast_node;
extern bool_t _2__206___r4_numbers_6_5(obj_t, obj_t);
extern obj_t read___reader(obj_t);
static obj_t require_initialization_114_trace_walk = BUNSPEC;
extern obj_t conditional_ast_node;
static obj_t trace_node___31_trace_walk(obj_t);
static obj_t cnst_init_137_trace_walk();
extern obj_t _current_pass__25_engine_pass;
static node_bglt trace_node_default1468_7_trace_walk(node_bglt);
static obj_t __cnst[13];

DEFINE_STATIC_GENERIC(trace_node_env_147_trace_walk, _trace_node_88_trace_walk1827, _trace_node_88_trace_walk, 0L, 1);
DEFINE_STATIC_PROCEDURE(toplevel_trace_node_default1504_env_84_trace_walk, _toplevel_trace_node_default1504_138_trace_walk1828, _toplevel_trace_node_default1504_138_trace_walk, 0L, 1);
DEFINE_STATIC_GENERIC(toplevel_trace_node_env_173_trace_walk, _toplevel_trace_node1815_104_trace_walk1829, _toplevel_trace_node1815_104_trace_walk, 0L, 1);
DEFINE_EXPORT_PROCEDURE(trace_walk__env_32_trace_walk, _trace_walk__101_trace_walk1830, _trace_walk__101_trace_walk, 0L, 1);
DEFINE_STRING(string1822_trace_walk, string1822_trace_walk1831, "DONE VALUE C-POP-TRACE SET! C-PUSH-TRACE QUOTE LET SYMBOL AUX NO-TRACE @ TOPLEVEL-INIT PASS-STARTED ", 100);
DEFINE_STRING(string1821_trace_walk, string1821_trace_walk1832, "failure during postlude hook", 28);
DEFINE_STRING(string1819_trace_walk, string1819_trace_walk1833, " error", 6);
DEFINE_STRING(string1820_trace_walk, string1820_trace_walk1834, " occured, ending ...", 20);
DEFINE_STRING(string1818_trace_walk, string1818_trace_walk1835, "failure during prelude hook", 27);
DEFINE_STRING(string1817_trace_walk, string1817_trace_walk1836, "   . ", 5);
DEFINE_STRING(string1816_trace_walk, string1816_trace_walk1837, "Trace", 5);
DEFINE_STATIC_PROCEDURE(trace_node_default1468_env_183_trace_walk, _trace_node_default1468_12_trace_walk1838, _trace_node_default1468_12_trace_walk, 0L, 1);



/* module-initialization */
obj_t 
module_initialization_70_trace_walk(long checksum_1646, char *from_1647)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_trace_walk))
	{
	   require_initialization_114_trace_walk =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_trace_walk();
	   cnst_init_137_trace_walk();
	   imported_modules_init_94_trace_walk();
	   method_init_76_trace_walk();
	   toplevel_init_63_trace_walk();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_trace_walk()
{
   AN_OBJECT;
   {	/* Trace/walk.scm 14 */
      module_initialization_70___r4_symbols_6_4(((long) 0), "TRACE_WALK");
      module_initialization_70___object(((long) 0), "TRACE_WALK");
      module_initialization_70___r4_output_6_10_3(((long) 0), "TRACE_WALK");
      module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "TRACE_WALK");
      module_initialization_70___r4_numbers_6_5(((long) 0), "TRACE_WALK");
      module_initialization_70___reader(((long) 0), "TRACE_WALK");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_trace_walk()
{
   AN_OBJECT;
   {	/* Trace/walk.scm 14 */
      {		/* Trace/walk.scm 14 */
	 obj_t cnst_port_138_1639;
	 cnst_port_138_1639 =
	    open_input_string(string1822_trace_walk);
	 {
	    long i_1640;
	    i_1640 = ((long) 12);
	  loop_1641:
	    {	/* Trace/walk.scm 14 */
	       bool_t test1823_1642;
	       test1823_1642 =
		  (i_1640 == ((long) -1));
	       if (test1823_1642)
		 {	/* Trace/walk.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Trace/walk.scm 14 */
		    {	/* Trace/walk.scm 14 */
		       obj_t arg1824_1643;
		       {	/* Trace/walk.scm 14 */
			  obj_t list1825_1644;
			  list1825_1644 =
			     MAKE_PAIR(cnst_port_138_1639, BNIL);
			  arg1824_1643 =
			     read___reader(list1825_1644);
		       }
		       CNST_TABLE_SET(i_1640, arg1824_1643);
		    }
		    {	/* Trace/walk.scm 14 */
		       int aux_1645;
		       {	/* Trace/walk.scm 14 */
			  long aux_1668;
			  aux_1668 =
			     (i_1640 - ((long) 1));
			  aux_1645 =
			     (int) (aux_1668);
		       }
		       {
			  long i_1671;
			  i_1671 =
			     (long) (aux_1645);
			  i_1640 = i_1671;
			  goto loop_1641;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_trace_walk()
{
   AN_OBJECT;
   {	/* Trace/walk.scm 14 */
      return BUNSPEC;
   }
}



/* trace-walk! */
obj_t 
trace_walk__65_trace_walk(obj_t globals_1)
{
   AN_OBJECT;
   {	/* Trace/walk.scm 31 */
      {		/* Trace/walk.scm 31 */
	 obj_t list1509_738;
	 {	/* Trace/walk.scm 31 */
	    obj_t arg1511_740;
	    {	/* Trace/walk.scm 31 */
	       obj_t arg1513_742;
	       {	/* Trace/walk.scm 31 */
		  obj_t aux_1673;
		  aux_1673 =
		     BCHAR(((unsigned char) '\n'));
		  arg1513_742 =
		     MAKE_PAIR(aux_1673, BNIL);
	       }
	       arg1511_740 =
		  MAKE_PAIR(string1816_trace_walk, arg1513_742);
	    }
	    list1509_738 =
	       MAKE_PAIR(string1817_trace_walk, arg1511_740);
	 }
	 verbose_tools_speek(
	    BINT(((long) 1)), list1509_738);
      }
      _nb_error_on_pass__70_tools_error =
	 BINT(((long) 0));
      _current_pass__25_engine_pass = string1816_trace_walk;
      {
	 obj_t hooks_743;
	 obj_t hnames_744;
	 hooks_743 = BNIL;
	 hnames_744 = BNIL;
       loop_745:
	 if (
	    NULLP(hooks_743))
	   {	/* Trace/walk.scm 31 */
	      CNST_TABLE_REF(((long) 0));
	   }
	 else
	   {	/* Trace/walk.scm 31 */
	      bool_t test1518_750;
	      {		/* Trace/walk.scm 31 */
		 obj_t fun1525_756;
		 fun1525_756 =
		    CAR(hooks_743);
		 {	/* Trace/walk.scm 31 */
		    obj_t aux_1685;
		    aux_1685 =
		       PROCEDURE_ENTRY(fun1525_756) (fun1525_756, BEOA);
		    test1518_750 =
		       CBOOL(aux_1685);
		 }
	      }
	      if (test1518_750)
		{	/* Trace/walk.scm 31 */
		   {
		      obj_t hnames_1692;
		      obj_t hooks_1690;
		      hooks_1690 =
			 CDR(hooks_743);
		      hnames_1692 =
			 CDR(hnames_744);
		      hnames_744 = hnames_1692;
		      hooks_743 = hooks_1690;
		      goto loop_745;
		   }
		}
	      else
		{	/* Trace/walk.scm 31 */
		   internal_error_43_tools_error(string1816_trace_walk, string1818_trace_walk,
		      CAR(hnames_744));
		}
	   }
      }
      {		/* Trace/walk.scm 38 */
	 obj_t id_757;
	 id_757 =
	    CNST_TABLE_REF(((long) 1));
	 {	/* Trace/walk.scm 38 */
	    obj_t glo_758;
	    {	/* Trace/walk.scm 39 */
	       obj_t list1529_763;
	       list1529_763 =
		  MAKE_PAIR(_module__166_module_module, BNIL);
	       glo_758 =
		  find_global_223_ast_env(id_757, list1529_763);
	    }
	    {	/* Trace/walk.scm 39 */

	       {	/* Trace/walk.scm 40 */
		  bool_t test1526_759;
		  test1526_759 =
		     is_a__118___object(glo_758, global_ast_var);
		  if (test1526_759)
		    {	/* Trace/walk.scm 41 */
		       value_bglt instance1445_760;
		       {	/* Trace/walk.scm 41 */
			  global_bglt obj_1367;
			  obj_1367 =
			     (global_bglt) (glo_758);
			  instance1445_760 =
			     (((global_bglt) CREF(obj_1367))->value);
		       }
		       {	/* Trace/walk.scm 42 */
			  node_bglt arg1527_761;
			  {	/* Trace/walk.scm 42 */
			     node_bglt aux_1703;
			     {	/* Trace/walk.scm 42 */
				obj_t aux_1704;
				{	/* Trace/walk.scm 42 */
				   sfun_bglt obj_1368;
				   obj_1368 =
				      (sfun_bglt) (instance1445_760);
				   aux_1704 =
				      (((sfun_bglt) CREF(obj_1368))->body);
				}
				aux_1703 =
				   (node_bglt) (aux_1704);
			     }
			     arg1527_761 =
				toplevel_trace_node_251_trace_walk(aux_1703);
			  }
			  {	/* Trace/walk.scm 42 */
			     sfun_bglt obj_1369;
			     obj_t val1123_1370;
			     obj_1369 =
				(sfun_bglt) (instance1445_760);
			     val1123_1370 =
				(obj_t) (arg1527_761);
			     ((((sfun_bglt) CREF(obj_1369))->body) = ((obj_t) val1123_1370), BUNSPEC);
			  }
		       }
		    }
		  else
		    {	/* Trace/walk.scm 40 */
		       BUNSPEC;
		    }
	       }
	    }
	 }
      }
      {
	 obj_t l1446_764;
	 l1446_764 = globals_1;
       lname1447_765:
	 if (
	    PAIRP(l1446_764))
	   {	/* Trace/walk.scm 44 */
	      trace_fun__23_trace_walk(
		 CAR(l1446_764));
	      {
		 obj_t l1446_1716;
		 l1446_1716 =
		    CDR(l1446_764);
		 l1446_764 = l1446_1716;
		 goto lname1447_765;
	      }
	   }
	 else
	   {	/* Trace/walk.scm 44 */
	      ((bool_t) 1);
	   }
      }
      {		/* Trace/walk.scm 45 */
	 bool_t test1534_770;
	 {	/* Trace/walk.scm 45 */
	    long n1_1374;
	    n1_1374 =
	       (long) CINT(_nb_error_on_pass__70_tools_error);
	    test1534_770 =
	       (n1_1374 > ((long) 0));
	 }
	 if (test1534_770)
	   {	/* Trace/walk.scm 45 */
	      display_2_122___r4_output_6_10_3(_nb_error_on_pass__70_tools_error, current_error_port);
	      display_2_122___r4_output_6_10_3(string1819_trace_walk, current_error_port);
	      {		/* Trace/walk.scm 45 */
		 char *arg1535_772;
		 {	/* Trace/walk.scm 45 */
		    bool_t test1536_773;
		    {	/* Trace/walk.scm 45 */
		       bool_t test1537_774;
		       {	/* Trace/walk.scm 45 */
			  obj_t obj_1376;
			  obj_1376 = _nb_error_on_pass__70_tools_error;
			  test1537_774 =
			     INTEGERP(obj_1376);
		       }
		       if (test1537_774)
			 {	/* Trace/walk.scm 45 */
			    test1536_773 =
			       _2__206___r4_numbers_6_5(_nb_error_on_pass__70_tools_error,
			       BINT(((long) 1)));
			 }
		       else
			 {	/* Trace/walk.scm 45 */
			    test1536_773 = ((bool_t) 0);
			 }
		    }
		    if (test1536_773)
		      {		/* Trace/walk.scm 45 */
			 arg1535_772 = "s";
		      }
		    else
		      {		/* Trace/walk.scm 45 */
			 arg1535_772 = "";
		      }
		 }
		 display_2_122___r4_output_6_10_3(
		    string_to_bstring(arg1535_772), current_error_port);
	      }
	      display_2_122___r4_output_6_10_3(string1820_trace_walk, current_error_port);
	      WRITE_CHAR(((unsigned char) '\n'), current_error_port);
	      {		/* Trace/walk.scm 45 */
		 obj_t res1812_1379;
		 exit(((long) -1));
		 res1812_1379 =
		    BINT(((long) -1));
		 return res1812_1379;
	      }
	   }
	 else
	   {
	      obj_t hooks_775;
	      obj_t hnames_776;
	      hooks_775 = BNIL;
	      hnames_776 = BNIL;
	    loop_777:
	      if (
		 NULLP(hooks_775))
		{	/* Trace/walk.scm 45 */
		   return globals_1;
		}
	      else
		{	/* Trace/walk.scm 45 */
		   bool_t test1543_782;
		   {	/* Trace/walk.scm 45 */
		      obj_t fun1550_787;
		      fun1550_787 =
			 CAR(hooks_775);
		      {		/* Trace/walk.scm 45 */
			 obj_t aux_1737;
			 aux_1737 =
			    PROCEDURE_ENTRY(fun1550_787) (fun1550_787, BEOA);
			 test1543_782 =
			    CBOOL(aux_1737);
		      }
		   }
		   if (test1543_782)
		     {	/* Trace/walk.scm 45 */
			{
			   obj_t hnames_1744;
			   obj_t hooks_1742;
			   hooks_1742 =
			      CDR(hooks_775);
			   hnames_1744 =
			      CDR(hnames_776);
			   hnames_776 = hnames_1744;
			   hooks_775 = hooks_1742;
			   goto loop_777;
			}
		     }
		   else
		     {	/* Trace/walk.scm 45 */
			return
			   internal_error_43_tools_error(_current_pass__25_engine_pass, string1821_trace_walk,
			   CAR(hnames_776));
		     }
		}
	   }
      }
   }
}



/* _trace-walk! */
obj_t 
_trace_walk__101_trace_walk(obj_t env_1629, obj_t globals_1630)
{
   AN_OBJECT;
   {	/* Trace/walk.scm 31 */
      return
	 trace_walk__65_trace_walk(globals_1630);
   }
}



/* trace-id */
obj_t 
trace_id_33_trace_walk(obj_t variable_2)
{
   AN_OBJECT;
   {	/* Trace/walk.scm 56 */
      {		/* Trace/walk.scm 57 */
	 bool_t test1551_788;
	 {	/* Trace/walk.scm 57 */
	    bool_t test1556_793;
	    test1556_793 =
	       is_a__118___object(variable_2, global_ast_var);
	    if (test1556_793)
	      {		/* ./Ieee/equiv.scm 5508 */
		 obj_t aux_1754;
		 obj_t aux_1751;
		 aux_1754 =
		    CNST_TABLE_REF(((long) 1));
		 {	/* Trace/walk.scm 57 */
		    global_bglt obj_1387;
		    obj_1387 =
		       (global_bglt) (variable_2);
		    aux_1751 =
		       (((global_bglt) CREF(obj_1387))->id);
		 }
		 test1551_788 =
		    (aux_1751 == aux_1754);
	      }
	    else
	      {		/* Trace/walk.scm 57 */
		 test1551_788 = ((bool_t) 0);
	      }
	 }
	 if (test1551_788)
	   {	/* Trace/walk.scm 58 */
	      obj_t arg1552_789;
	      arg1552_789 =
		 CNST_TABLE_REF(((long) 2));
	      {		/* Trace/walk.scm 58 */
		 obj_t list1554_791;
		 {	/* Trace/walk.scm 58 */
		    obj_t arg1555_792;
		    {	/* Trace/walk.scm 58 */
		       obj_t aux_1759;
		       {	/* Trace/walk.scm 58 */
			  global_bglt obj_1390;
			  obj_1390 =
			     (global_bglt) (variable_2);
			  aux_1759 =
			     (((global_bglt) CREF(obj_1390))->module);
		       }
		       arg1555_792 =
			  MAKE_PAIR(aux_1759, BNIL);
		    }
		    list1554_791 =
		       MAKE_PAIR(arg1552_789, arg1555_792);
		 }
		 return
		    symbol_append_197___r4_symbols_6_4(list1554_791);
	      }
	   }
	 else
	   {	/* Trace/walk.scm 59 */
	      variable_bglt obj_1391;
	      obj_1391 =
		 (variable_bglt) (variable_2);
	      return
		 (((variable_bglt) CREF(obj_1391))->id);
	   }
      }
   }
}



/* trace-fun! */
obj_t 
trace_fun__23_trace_walk(obj_t var_3)
{
   AN_OBJECT;
   {	/* Trace/walk.scm 67 */
      {		/* Trace/walk.scm 68 */
	 value_bglt fun_796;
	 {	/* Trace/walk.scm 68 */
	    variable_bglt obj_1392;
	    obj_1392 =
	       (variable_bglt) (var_3);
	    fun_796 =
	       (((variable_bglt) CREF(obj_1392))->value);
	 }
	 {	/* Trace/walk.scm 68 */
	    obj_t body_797;
	    {	/* Trace/walk.scm 69 */
	       sfun_bglt obj_1393;
	       obj_1393 =
		  (sfun_bglt) (fun_796);
	       body_797 =
		  (((sfun_bglt) CREF(obj_1393))->body);
	    }
	    {	/* Trace/walk.scm 69 */
	       type_bglt type_798;
	       {	/* Trace/walk.scm 70 */
		  variable_bglt obj_1394;
		  obj_1394 =
		     (variable_bglt) (var_3);
		  type_798 =
		     (((variable_bglt) CREF(obj_1394))->type);
	       }
	       {	/* Trace/walk.scm 70 */

		  {	/* Trace/walk.scm 71 */
		     bool_t test_1773;
		     {	/* Trace/walk.scm 71 */
			bool_t test_1774;
			{	/* Trace/walk.scm 71 */
			   fun_bglt obj_1395;
			   obj_1395 =
			      (fun_bglt) (fun_796);
			   {	/* ./Ast/var.scm 871 */
			      obj_t aux_1776;
			      aux_1776 =
				 (((fun_bglt) CREF(obj_1395))->predicate_of_78);
			      test_1774 =
				 CBOOL(aux_1776);
			   }
			}
			if (test_1774)
			  {	/* Trace/walk.scm 71 */
			     test_1773 = ((bool_t) 0)
				;
			  }
			else
			  {	/* Trace/walk.scm 72 */
			     bool_t test_1779;
			     {	/* Trace/walk.scm 72 */
				obj_t aux_1780;
				{	/* Trace/walk.scm 72 */
				   obj_t aux_1781;
				   {	/* Trace/walk.scm 72 */
				      sfun_bglt obj_1396;
				      obj_1396 =
					 (sfun_bglt) (fun_796);
				      aux_1781 =
					 (((sfun_bglt) CREF(obj_1396))->property);
				   }
				   aux_1780 =
				      memq___r4_pairs_and_lists_6_3(
				      CNST_TABLE_REF(((long) 3)), aux_1781);
				}
				test_1779 =
				   CBOOL(aux_1780);
			     }
			     if (test_1779)
			       {	/* Trace/walk.scm 72 */
				  test_1773 = ((bool_t) 0)
				     ;
			       }
			     else
			       {	/* Trace/walk.scm 72 */
				  test_1773 = ((bool_t) 1)
				     ;
			       }
			  }
		     }
		     if (test_1773)
		       {	/* Trace/walk.scm 71 */
			  {	/* Trace/walk.scm 74 */
			     obj_t arg1560_800;
			     arg1560_800 =
				trace_id_33_trace_walk(var_3);
			     enter_function_81_tools_error(arg1560_800);
			  }
			  {	/* Trace/walk.scm 75 */
			     obj_t new_body_215_801;
			     {	/* Trace/walk.scm 75 */
				bool_t test1562_804;
				{	/* Trace/walk.scm 75 */
				   bool_t test1563_805;
				   {	/* Trace/walk.scm 75 */
				      long n1_1397;
				      n1_1397 =
					 (long) CINT(_compiler_debug__134_engine_param);
				      test1563_805 =
					 (n1_1397 >= ((long) 2));
				   }
				   if (test1563_805)
				     {	/* Trace/walk.scm 75 */
					test1562_804 = ((bool_t) 1);
				     }
				   else
				     {	/* Trace/walk.scm 76 */
					bool_t _andtest_1449_806;
					_andtest_1449_806 =
					   is_a__118___object(var_3, global_ast_var);
					if (_andtest_1449_806)
					  {	/* ./Ieee/equiv.scm 5508 */
					     obj_t aux_1797;
					     obj_t aux_1794;
					     aux_1797 =
						CNST_TABLE_REF(((long) 1));
					     {	/* Trace/walk.scm 77 */
						global_bglt obj_1400;
						obj_1400 =
						   (global_bglt) (var_3);
						aux_1794 =
						   (((global_bglt) CREF(obj_1400))->id);
					     }
					     test1562_804 =
						(aux_1794 == aux_1797);
					  }
					else
					  {	/* Trace/walk.scm 76 */
					     test1562_804 = ((bool_t) 0);
					  }
				     }
				}
				if (test1562_804)
				  {	/* Trace/walk.scm 86 */
				     node_bglt aux_1801;
				     aux_1801 =
					trace_node_95_trace_walk(
					(node_bglt) (body_797));
				     new_body_215_801 =
					(obj_t) (aux_1801);
				  }
				else
				  {	/* Trace/walk.scm 75 */
				     new_body_215_801 = body_797;
				  }
			     }
			     {	/* Trace/walk.scm 75 */
				let_var_6_bglt new2_body_172_802;
				{	/* Trace/walk.scm 90 */
				   obj_t arg1561_803;
				   arg1561_803 =
				      trace_id_33_trace_walk(var_3);
				   new2_body_172_802 =
				      make_traced_node_44_trace_walk(
				      (node_bglt) (new_body_215_801), type_798, arg1561_803);
				}
				{	/* Trace/walk.scm 88 */

				   {	/* Trace/walk.scm 91 */
				      sfun_bglt obj_1403;
				      obj_t val1123_1404;
				      obj_1403 =
					 (sfun_bglt) (fun_796);
				      val1123_1404 =
					 (obj_t) (new2_body_172_802);
				      ((((sfun_bglt) CREF(obj_1403))->body) = ((obj_t) val1123_1404), BUNSPEC);
				   }
				   return
				      leave_function_170_tools_error();
				}
			     }
			  }
		       }
		     else
		       {	/* Trace/walk.scm 71 */
			  return BUNSPEC;
		       }
		  }
	       }
	    }
	 }
      }
   }
}



/* make-traced-node */
let_var_6_bglt 
make_traced_node_44_trace_walk(node_bglt node_4, type_bglt type_5, obj_t symbol_6)
{
   AN_OBJECT;
   {	/* Trace/walk.scm 97 */
      {		/* Trace/walk.scm 98 */
	 obj_t loc_813;
	 loc_813 =
	    (((node_bglt) CREF(node_4))->loc);
	 {	/* Trace/walk.scm 98 */
	    obj_t aux_814;
	    {	/* Trace/walk.scm 99 */
	       obj_t arg1615_861;
	       arg1615_861 =
		  PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4,
		  CNST_TABLE_REF(((long) 4)), BEOA);
	       aux_814 =
		  mark_symbol_non_user__17_ast_ident(arg1615_861);
	    }
	    {	/* Trace/walk.scm 99 */
	       obj_t taux_815;
	       {	/* Trace/walk.scm 100 */
		  obj_t list1612_858;
		  {	/* Trace/walk.scm 100 */
		     obj_t arg1613_859;
		     {	/* Trace/walk.scm 100 */
			obj_t arg1614_860;
			{	/* Trace/walk.scm 100 */
			   obj_t aux_1817;
			   aux_1817 =
			      (((type_bglt) CREF(type_5))->id);
			   arg1614_860 =
			      MAKE_PAIR(aux_1817, BNIL);
			}
			arg1613_859 =
			   MAKE_PAIR(_4dots_199_tools_misc, arg1614_860);
		     }
		     list1612_858 =
			MAKE_PAIR(aux_814, arg1613_859);
		  }
		  taux_815 =
		     symbol_append_197___r4_symbols_6_4(list1612_858);
	       }
	       {	/* Trace/walk.scm 100 */
		  obj_t sym_816;
		  {	/* Trace/walk.scm 101 */
		     obj_t arg1610_856;
		     arg1610_856 =
			PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4,
			CNST_TABLE_REF(((long) 5)), BEOA);
		     sym_816 =
			mark_symbol_non_user__17_ast_ident(arg1610_856);
		  }
		  {	/* Trace/walk.scm 101 */
		     obj_t exp_817;
		     {	/* Trace/walk.scm 102 */
			obj_t arg1571_819;
			obj_t arg1572_820;
			arg1571_819 =
			   CNST_TABLE_REF(((long) 6));
			{	/* Trace/walk.scm 102 */
			   obj_t arg1573_821;
			   obj_t arg1576_822;
			   {	/* Trace/walk.scm 102 */
			      obj_t arg1577_823;
			      {		/* Trace/walk.scm 102 */
				 obj_t arg1579_825;
				 {	/* Trace/walk.scm 102 */
				    obj_t arg1580_826;
				    {	/* Trace/walk.scm 102 */
				       obj_t arg1582_828;
				       obj_t arg1583_829;
				       arg1582_828 =
					  CNST_TABLE_REF(((long) 7));
				       arg1583_829 =
					  MAKE_PAIR(symbol_6, BNIL);
				       arg1580_826 =
					  MAKE_PAIR(arg1582_828, arg1583_829);
				    }
				    arg1579_825 =
				       MAKE_PAIR(arg1580_826, BNIL);
				 }
				 arg1577_823 =
				    MAKE_PAIR(sym_816, arg1579_825);
			      }
			      arg1573_821 =
				 MAKE_PAIR(arg1577_823, BNIL);
			   }
			   {	/* Trace/walk.scm 103 */
			      obj_t arg1584_830;
			      {		/* Trace/walk.scm 103 */
				 obj_t arg1586_832;
				 obj_t arg1587_833;
				 arg1586_832 =
				    CNST_TABLE_REF(((long) 6));
				 {	/* Trace/walk.scm 103 */
				    obj_t arg1589_835;
				    {	/* Trace/walk.scm 104 */
				       obj_t arg1590_836;
				       obj_t arg1591_837;
				       {	/* Trace/walk.scm 104 */
					  obj_t arg1592_838;
					  obj_t arg1593_839;
					  arg1592_838 =
					     CNST_TABLE_REF(((long) 8));
					  arg1593_839 =
					     MAKE_PAIR(sym_816, BNIL);
					  arg1590_836 =
					     MAKE_PAIR(arg1592_838, arg1593_839);
				       }
				       {	/* Trace/walk.scm 109 */
					  obj_t arg1594_840;
					  obj_t arg1595_841;
					  {	/* Trace/walk.scm 109 */
					     obj_t arg1596_842;
					     obj_t arg1597_843;
					     arg1596_842 =
						CNST_TABLE_REF(((long) 9));
					     {	/* Trace/walk.scm 109 */
						obj_t arg1598_844;
						arg1598_844 =
						   MAKE_PAIR(sym_816, BNIL);
						arg1597_843 =
						   MAKE_PAIR(sym_816, arg1598_844);
					     }
					     arg1594_840 =
						MAKE_PAIR(arg1596_842, arg1597_843);
					  }
					  {	/* Trace/walk.scm 110 */
					     obj_t arg1599_845;
					     {	/* Trace/walk.scm 110 */
						obj_t arg1601_847;
						obj_t arg1602_848;
						arg1601_847 =
						   CNST_TABLE_REF(((long) 6));
						{	/* Trace/walk.scm 110 */
						   obj_t arg1603_849;
						   obj_t arg1604_850;
						   {	/* Trace/walk.scm 110 */
						      obj_t arg1605_851;
						      {		/* Trace/walk.scm 110 */
							 obj_t arg1607_853;
							 {	/* ./Ieee/pair-list.scm 5689 */
							    obj_t aux_1843;
							    aux_1843 =
							       (obj_t) (node_4);
							    arg1607_853 =
							       MAKE_PAIR(aux_1843, BNIL);
							 }
							 arg1605_851 =
							    MAKE_PAIR(taux_815, arg1607_853);
						      }
						      arg1603_849 =
							 MAKE_PAIR(arg1605_851, BNIL);
						   }
						   {	/* Trace/walk.scm 111 */
						      obj_t arg1608_854;
						      obj_t arg1609_855;
						      {		/* ./Ieee/pair-list.scm 5689 */
							 obj_t aux_1848;
							 aux_1848 =
							    CNST_TABLE_REF(((long) 10));
							 arg1608_854 =
							    MAKE_PAIR(aux_1848, BNIL);
						      }
						      arg1609_855 =
							 MAKE_PAIR(aux_814, BNIL);
						      arg1604_850 =
							 MAKE_PAIR(arg1608_854, arg1609_855);
						   }
						   arg1602_848 =
						      MAKE_PAIR(arg1603_849, arg1604_850);
						}
						arg1599_845 =
						   MAKE_PAIR(arg1601_847, arg1602_848);
					     }
					     arg1595_841 =
						MAKE_PAIR(arg1599_845, BNIL);
					  }
					  arg1591_837 =
					     MAKE_PAIR(arg1594_840, arg1595_841);
				       }
				       arg1589_835 =
					  MAKE_PAIR(arg1590_836, arg1591_837);
				    }
				    arg1587_833 =
				       MAKE_PAIR(BNIL, arg1589_835);
				 }
				 arg1584_830 =
				    MAKE_PAIR(arg1586_832, arg1587_833);
			      }
			      arg1576_822 =
				 MAKE_PAIR(arg1584_830, BNIL);
			   }
			   arg1572_820 =
			      MAKE_PAIR(arg1573_821, arg1576_822);
			}
			exp_817 =
			   MAKE_PAIR(arg1571_819, arg1572_820);
		     }
		     {	/* Trace/walk.scm 102 */
			node_bglt node_818;
			node_818 =
			   sexp__node_235_ast_sexp(exp_817, BNIL, loc_813,
			   CNST_TABLE_REF(((long) 11)));
			{	/* Trace/walk.scm 113 */

			   {	/* Trace/walk.scm 114 */
			      let_var_6_bglt obj_1459;
			      obj_1459 =
				 (let_var_6_bglt) (node_818);
			      ((((let_var_6_bglt) CREF(obj_1459))->removable__42) = ((bool_t) ((bool_t) 0)), BUNSPEC);
			   }
			   return
			      (let_var_6_bglt) (node_818);
			}
		     }
		  }
	       }
	    }
	 }
      }
   }
}



/* trace-node*! */
obj_t 
trace_node___31_trace_walk(obj_t node__221_26)
{
   AN_OBJECT;
   {	/* Trace/walk.scm 269 */
    trace_node___31_trace_walk:
      if (
	 NULLP(node__221_26))
	{	/* Trace/walk.scm 270 */
	   return
	      CNST_TABLE_REF(((long) 12));
	}
      else
	{	/* Trace/walk.scm 270 */
	   {	/* Trace/walk.scm 273 */
	      node_bglt arg1617_863;
	      {		/* Trace/walk.scm 273 */
		 node_bglt aux_1871;
		 {	/* Trace/walk.scm 273 */
		    obj_t aux_1872;
		    aux_1872 =
		       CAR(node__221_26);
		    aux_1871 =
		       (node_bglt) (aux_1872);
		 }
		 arg1617_863 =
		    trace_node_95_trace_walk(aux_1871);
	      }
	      {		/* ./Ieee/pair-list.scm 5890 */
		 obj_t aux_1876;
		 aux_1876 =
		    (obj_t) (arg1617_863);
		 SET_CAR(node__221_26, aux_1876);
	      }
	   }
	   {
	      obj_t node__221_1879;
	      node__221_1879 =
		 CDR(node__221_26);
	      node__221_26 = node__221_1879;
	      goto trace_node___31_trace_walk;
	   }
	}
   }
}



/* toplevel-trace-node*! */
obj_t 
toplevel_trace_node___112_trace_walk(obj_t node__221_31)
{
   AN_OBJECT;
   {	/* Trace/walk.scm 314 */
    toplevel_trace_node___112_trace_walk:
      if (
	 NULLP(node__221_31))
	{	/* Trace/walk.scm 315 */
	   return
	      CNST_TABLE_REF(((long) 12));
	}
      else
	{	/* Trace/walk.scm 315 */
	   {	/* Trace/walk.scm 318 */
	      node_bglt arg1621_867;
	      {		/* Trace/walk.scm 318 */
		 node_bglt aux_1884;
		 {	/* Trace/walk.scm 318 */
		    obj_t aux_1885;
		    aux_1885 =
		       CAR(node__221_31);
		    aux_1884 =
		       (node_bglt) (aux_1885);
		 }
		 arg1621_867 =
		    toplevel_trace_node_251_trace_walk(aux_1884);
	      }
	      {		/* ./Ieee/pair-list.scm 5890 */
		 obj_t aux_1889;
		 aux_1889 =
		    (obj_t) (arg1621_867);
		 SET_CAR(node__221_31, aux_1889);
	      }
	   }
	   {
	      obj_t node__221_1892;
	      node__221_1892 =
		 CDR(node__221_31);
	      node__221_31 = node__221_1892;
	      goto toplevel_trace_node___112_trace_walk;
	   }
	}
   }
}



/* method-init */
obj_t 
method_init_76_trace_walk()
{
   AN_OBJECT;
   {	/* Trace/walk.scm 14 */
      add_generic__110___object(trace_node_env_147_trace_walk, trace_node_default1468_env_183_trace_walk);
      add_inlined_method__244___object(trace_node_env_147_trace_walk, sequence_ast_node, ((long) 0));
      add_inlined_method__244___object(trace_node_env_147_trace_walk, app_ast_node, ((long) 1));
      add_inlined_method__244___object(trace_node_env_147_trace_walk, app_ly_162_ast_node, ((long) 2));
      add_inlined_method__244___object(trace_node_env_147_trace_walk, funcall_ast_node, ((long) 3));
      add_inlined_method__244___object(trace_node_env_147_trace_walk, pragma_ast_node, ((long) 4));
      add_inlined_method__244___object(trace_node_env_147_trace_walk, cast_ast_node, ((long) 5));
      add_inlined_method__244___object(trace_node_env_147_trace_walk, setq_ast_node, ((long) 6));
      add_inlined_method__244___object(trace_node_env_147_trace_walk, conditional_ast_node, ((long) 7));
      add_inlined_method__244___object(trace_node_env_147_trace_walk, fail_ast_node, ((long) 8));
      add_inlined_method__244___object(trace_node_env_147_trace_walk, select_ast_node, ((long) 9));
      add_inlined_method__244___object(trace_node_env_147_trace_walk, let_fun_218_ast_node, ((long) 10));
      add_inlined_method__244___object(trace_node_env_147_trace_walk, let_var_6_ast_node, ((long) 11));
      add_inlined_method__244___object(trace_node_env_147_trace_walk, set_ex_it_116_ast_node, ((long) 12));
      add_inlined_method__244___object(trace_node_env_147_trace_walk, jump_ex_it_184_ast_node, ((long) 13));
      add_inlined_method__244___object(trace_node_env_147_trace_walk, make_box_202_ast_node, ((long) 14));
      add_inlined_method__244___object(trace_node_env_147_trace_walk, box_ref_242_ast_node, ((long) 15));
      add_inlined_method__244___object(trace_node_env_147_trace_walk, box_set__221_ast_node, ((long) 16));
      add_generic__110___object(toplevel_trace_node_env_173_trace_walk, toplevel_trace_node_default1504_env_84_trace_walk);
      add_inlined_method__244___object(toplevel_trace_node_env_173_trace_walk, sequence_ast_node, ((long) 0));
      {		/* Trace/walk.scm 14 */
	 long aux_1914;
	 aux_1914 =
	    add_inlined_method__244___object(toplevel_trace_node_env_173_trace_walk, setq_ast_node, ((long) 1));
	 return
	    BINT(aux_1914);
      }
   }
}



/* trace-node */
node_bglt 
trace_node_95_trace_walk(node_bglt node_7)
{
   AN_OBJECT;
   {	/* Trace/walk.scm 120 */
      {
	 obj_t method1734_1251;
	 obj_t class1739_1252;
	 {	/* Trace/walk.scm 120 */
	    obj_t arg1742_1249;
	    obj_t arg1743_1250;
	    {	/* Trace/walk.scm 120 */
	       object_bglt obj_1471;
	       obj_1471 =
		  (object_bglt) (node_7);
	       {	/* ./Llib/object.scm 2926 */
		  obj_t pre_method_105_1472;
		  pre_method_105_1472 =
		     PROCEDURE_REF(trace_node_env_147_trace_walk, ((long) 2));
		  if (
		     INTEGERP(pre_method_105_1472))
		    {	/* ./Llib/object.scm 2927 */
		       PROCEDURE_SET(trace_node_env_147_trace_walk, ((long) 2), BUNSPEC);
		       arg1742_1249 = pre_method_105_1472;
		    }
		  else
		    {	/* ./Llib/object.scm 2914 */
		       long obj_class_num_177_1477;
		       obj_class_num_177_1477 =
			  TYPE(obj_1471);
		       {	/* ./Llib/object.scm 2915 */
			  obj_t arg1176_1478;
			  arg1176_1478 =
			     PROCEDURE_REF(trace_node_env_147_trace_walk, ((long) 1));
			  {	/* ./Llib/object.scm 2738 */
			     long arg1177_1482;
			     {	/* ./Llib/object.scm 2738 */
				long arg1178_1483;
				arg1178_1483 =
				   OBJECT_TYPE;
				arg1177_1482 =
				   (obj_class_num_177_1477 - arg1178_1483);
			     }
			     arg1742_1249 =
				VECTOR_REF(arg1176_1478, arg1177_1482);
			  }
		       }
		    }
	       }
	    }
	    {	/* Trace/walk.scm 120 */
	       object_bglt object_1488;
	       object_1488 =
		  (object_bglt) (node_7);
	       {	/* ./Llib/object.scm 2695 */
		  long arg1179_1489;
		  {	/* ./Llib/object.scm 2695 */
		     long arg1180_1490;
		     long arg1181_1491;
		     arg1180_1490 =
			TYPE(object_1488);
		     arg1181_1491 =
			OBJECT_TYPE;
		     arg1179_1489 =
			(arg1180_1490 - arg1181_1491);
		  }
		  {	/* ./Llib/object.scm 2695 */
		     obj_t vector_1495;
		     vector_1495 = _classes__134___object;
		     arg1743_1250 =
			VECTOR_REF(vector_1495, arg1179_1489);
		  }
	       }
	    }
	    {	/* Trace/walk.scm 120 */
	       obj_t aux_1932;
	       method1734_1251 = arg1742_1249;
	       class1739_1252 = arg1743_1250;
	       {

		  if (
		     INTEGERP(method1734_1251))
		    {	/* Trace/walk.scm 120 */
		       switch (
			  (long) CINT(method1734_1251))
			 {
			 case ((long) 0):

			    {	/* Trace/walk.scm 120 */
			       sequence_bglt node_1258;
			       node_1258 =
				  (sequence_bglt) (node_7);
			       trace_node___31_trace_walk(
				  (((sequence_bglt) CREF(node_1258))->nodes));
			       aux_1932 =
				  (obj_t) (node_1258);
			    }
			    break;
			 case ((long) 1):

			    {	/* Trace/walk.scm 120 */
			       app_bglt node_1260;
			       node_1260 =
				  (app_bglt) (node_7);
			       trace_node___31_trace_walk(
				  (((app_bglt) CREF(node_1260))->args));
			       aux_1932 =
				  (obj_t) (node_1260);
			    }
			    break;
			 case ((long) 2):

			    {	/* Trace/walk.scm 141 */
			       app_ly_162_bglt node_1262;
			       node_1262 =
				  (app_ly_162_bglt) (node_7);
			       {	/* Trace/walk.scm 142 */
				  node_bglt arg1748_1264;
				  arg1748_1264 =
				     trace_node_95_trace_walk(
				     (((app_ly_162_bglt) CREF(node_1262))->fun));
				  ((((app_ly_162_bglt) CREF(node_1262))->fun) = ((node_bglt) arg1748_1264), BUNSPEC);
			       }
			       {	/* Trace/walk.scm 143 */
				  node_bglt arg1750_1266;
				  arg1750_1266 =
				     trace_node_95_trace_walk(
				     (((app_ly_162_bglt) CREF(node_1262))->arg));
				  ((((app_ly_162_bglt) CREF(node_1262))->arg) = ((node_bglt) arg1750_1266), BUNSPEC);
			       }
			       aux_1932 =
				  (obj_t) (node_1262);
			    }
			    break;
			 case ((long) 3):

			    {	/* Trace/walk.scm 150 */
			       funcall_bglt node_1268;
			       node_1268 =
				  (funcall_bglt) (node_7);
			       {	/* Trace/walk.scm 151 */
				  node_bglt arg1752_1270;
				  arg1752_1270 =
				     trace_node_95_trace_walk(
				     (((funcall_bglt) CREF(node_1268))->fun));
				  ((((funcall_bglt) CREF(node_1268))->fun) = ((node_bglt) arg1752_1270), BUNSPEC);
			       }
			       trace_node___31_trace_walk(
				  (((funcall_bglt) CREF(node_1268))->args));
			       aux_1932 =
				  (obj_t) (node_1268);
			    }
			    break;
			 case ((long) 4):

			    {	/* Trace/walk.scm 120 */
			       pragma_bglt node_1273;
			       node_1273 =
				  (pragma_bglt) (node_7);
			       trace_node___31_trace_walk(
				  (((pragma_bglt) CREF(node_1273))->args));
			       aux_1932 =
				  (obj_t) (node_1273);
			    }
			    break;
			 case ((long) 5):

			    {	/* Trace/walk.scm 120 */
			       cast_bglt node_1275;
			       node_1275 =
				  (cast_bglt) (node_7);
			       trace_node_95_trace_walk(
				  (((cast_bglt) CREF(node_1275))->arg));
			       aux_1932 =
				  (obj_t) (node_1275);
			    }
			    break;
			 case ((long) 6):

			    {	/* Trace/walk.scm 120 */
			       setq_bglt node_1277;
			       node_1277 =
				  (setq_bglt) (node_7);
			       {	/* Trace/walk.scm 173 */
				  node_bglt arg1758_1278;
				  arg1758_1278 =
				     trace_node_95_trace_walk(
				     (((setq_bglt) CREF(node_1277))->value));
				  ((((setq_bglt) CREF(node_1277))->value) = ((node_bglt) arg1758_1278), BUNSPEC);
			       }
			       aux_1932 =
				  (obj_t) (node_1277);
			    }
			    break;
			 case ((long) 7):

			    {	/* Trace/walk.scm 180 */
			       conditional_bglt node_1280;
			       node_1280 =
				  (conditional_bglt) (node_7);
			       {	/* Trace/walk.scm 181 */
				  node_bglt arg1760_1282;
				  arg1760_1282 =
				     trace_node_95_trace_walk(
				     (((conditional_bglt) CREF(node_1280))->test));
				  ((((conditional_bglt) CREF(node_1280))->test) = ((node_bglt) arg1760_1282), BUNSPEC);
			       }
			       {	/* Trace/walk.scm 182 */
				  node_bglt arg1762_1284;
				  arg1762_1284 =
				     trace_node_95_trace_walk(
				     (((conditional_bglt) CREF(node_1280))->true));
				  ((((conditional_bglt) CREF(node_1280))->true) = ((node_bglt) arg1762_1284), BUNSPEC);
			       }
			       {	/* Trace/walk.scm 183 */
				  node_bglt arg1764_1286;
				  arg1764_1286 =
				     trace_node_95_trace_walk(
				     (((conditional_bglt) CREF(node_1280))->false));
				  ((((conditional_bglt) CREF(node_1280))->false) = ((node_bglt) arg1764_1286), BUNSPEC);
			       }
			       aux_1932 =
				  (obj_t) (node_1280);
			    }
			    break;
			 case ((long) 8):

			    {	/* Trace/walk.scm 190 */
			       fail_bglt node_1288;
			       node_1288 =
				  (fail_bglt) (node_7);
			       {	/* Trace/walk.scm 191 */
				  node_bglt arg1766_1290;
				  arg1766_1290 =
				     trace_node_95_trace_walk(
				     (((fail_bglt) CREF(node_1288))->proc));
				  ((((fail_bglt) CREF(node_1288))->proc) = ((node_bglt) arg1766_1290), BUNSPEC);
			       }
			       {	/* Trace/walk.scm 192 */
				  node_bglt arg1768_1292;
				  arg1768_1292 =
				     trace_node_95_trace_walk(
				     (((fail_bglt) CREF(node_1288))->msg));
				  ((((fail_bglt) CREF(node_1288))->msg) = ((node_bglt) arg1768_1292), BUNSPEC);
			       }
			       {	/* Trace/walk.scm 193 */
				  node_bglt arg1770_1294;
				  arg1770_1294 =
				     trace_node_95_trace_walk(
				     (((fail_bglt) CREF(node_1288))->obj));
				  ((((fail_bglt) CREF(node_1288))->obj) = ((node_bglt) arg1770_1294), BUNSPEC);
			       }
			       aux_1932 =
				  (obj_t) (node_1288);
			    }
			    break;
			 case ((long) 9):

			    {	/* Trace/walk.scm 200 */
			       select_bglt node_1296;
			       node_1296 =
				  (select_bglt) (node_7);
			       {	/* Trace/walk.scm 201 */
				  node_bglt arg1772_1298;
				  arg1772_1298 =
				     trace_node_95_trace_walk(
				     (((select_bglt) CREF(node_1296))->test));
				  ((((select_bglt) CREF(node_1296))->test) = ((node_bglt) arg1772_1298), BUNSPEC);
			       }
			       {
				  obj_t l1455_1300;
				  l1455_1300 =
				     (((select_bglt) CREF(node_1296))->clauses);
				lname1456_1301:
				  if (
				     PAIRP(l1455_1300))
				    {	/* Trace/walk.scm 202 */
				       {	/* Trace/walk.scm 203 */
					  obj_t clause_1304;
					  clause_1304 =
					     CAR(l1455_1300);
					  {	/* Trace/walk.scm 203 */
					     node_bglt arg1776_1305;
					     {	/* Trace/walk.scm 203 */
						node_bglt aux_2000;
						{	/* Trace/walk.scm 203 */
						   obj_t aux_2001;
						   aux_2001 =
						      CDR(clause_1304);
						   aux_2000 =
						      (node_bglt) (aux_2001);
						}
						arg1776_1305 =
						   trace_node_95_trace_walk(aux_2000);
					     }
					     {	/* ./Ieee/pair-list.scm 5896 */
						obj_t aux_2005;
						aux_2005 =
						   (obj_t) (arg1776_1305);
						SET_CDR(clause_1304, aux_2005);
					     }
					  }
				       }
				       {
					  obj_t l1455_2008;
					  l1455_2008 =
					     CDR(l1455_1300);
					  l1455_1300 = l1455_2008;
					  goto lname1456_1301;
				       }
				    }
				  else
				    {	/* Trace/walk.scm 202 */
				       ((bool_t) 1);
				    }
			       }
			       aux_1932 =
				  (obj_t) (node_1296);
			    }
			    break;
			 case ((long) 10):

			    {	/* Trace/walk.scm 211 */
			       let_fun_218_bglt node_1308;
			       node_1308 =
				  (let_fun_218_bglt) (node_7);
			       {
				  obj_t l1458_1310;
				  l1458_1310 =
				     (((let_fun_218_bglt) CREF(node_1308))->locals);
				lname1459_1311:
				  if (
				     PAIRP(l1458_1310))
				    {	/* Trace/walk.scm 212 */
				       trace_fun__23_trace_walk(
					  CAR(l1458_1310));
				       {
					  obj_t l1458_2017;
					  l1458_2017 =
					     CDR(l1458_1310);
					  l1458_1310 = l1458_2017;
					  goto lname1459_1311;
				       }
				    }
				  else
				    {	/* Trace/walk.scm 212 */
				       ((bool_t) 1);
				    }
			       }
			       {	/* Trace/walk.scm 213 */
				  node_bglt arg1783_1316;
				  arg1783_1316 =
				     trace_node_95_trace_walk(
				     (((let_fun_218_bglt) CREF(node_1308))->body));
				  ((((let_fun_218_bglt) CREF(node_1308))->body) = ((node_bglt) arg1783_1316), BUNSPEC);
			       }
			       aux_1932 =
				  (obj_t) (node_1308);
			    }
			    break;
			 case ((long) 11):

			    {	/* Trace/walk.scm 220 */
			       let_var_6_bglt node_1318;
			       node_1318 =
				  (let_var_6_bglt) (node_7);
			       {
				  obj_t l1461_1320;
				  l1461_1320 =
				     (((let_var_6_bglt) CREF(node_1318))->bindings);
				lname1462_1321:
				  if (
				     PAIRP(l1461_1320))
				    {	/* Trace/walk.scm 221 */
				       {	/* Trace/walk.scm 222 */
					  obj_t binding_1324;
					  binding_1324 =
					     CAR(l1461_1320);
					  {	/* Trace/walk.scm 222 */
					     node_bglt arg1787_1325;
					     {	/* Trace/walk.scm 222 */
						node_bglt aux_2028;
						{	/* Trace/walk.scm 222 */
						   obj_t aux_2029;
						   aux_2029 =
						      CDR(binding_1324);
						   aux_2028 =
						      (node_bglt) (aux_2029);
						}
						arg1787_1325 =
						   trace_node_95_trace_walk(aux_2028);
					     }
					     {	/* ./Ieee/pair-list.scm 5896 */
						obj_t aux_2033;
						aux_2033 =
						   (obj_t) (arg1787_1325);
						SET_CDR(binding_1324, aux_2033);
					     }
					  }
				       }
				       {
					  obj_t l1461_2036;
					  l1461_2036 =
					     CDR(l1461_1320);
					  l1461_1320 = l1461_2036;
					  goto lname1462_1321;
				       }
				    }
				  else
				    {	/* Trace/walk.scm 221 */
				       ((bool_t) 1);
				    }
			       }
			       {	/* Trace/walk.scm 224 */
				  node_bglt arg1790_1328;
				  arg1790_1328 =
				     trace_node_95_trace_walk(
				     (((let_var_6_bglt) CREF(node_1318))->body));
				  ((((let_var_6_bglt) CREF(node_1318))->body) = ((node_bglt) arg1790_1328), BUNSPEC);
			       }
			       aux_1932 =
				  (obj_t) (node_1318);
			    }
			    break;
			 case ((long) 12):

			    {	/* Trace/walk.scm 120 */
			       set_ex_it_116_bglt node_1330;
			       node_1330 =
				  (set_ex_it_116_bglt) (node_7);
			       {	/* Trace/walk.scm 231 */
				  node_bglt arg1792_1331;
				  arg1792_1331 =
				     trace_node_95_trace_walk(
				     (((set_ex_it_116_bglt) CREF(node_1330))->body));
				  ((((set_ex_it_116_bglt) CREF(node_1330))->body) = ((node_bglt) arg1792_1331), BUNSPEC);
			       }
			       aux_1932 =
				  (obj_t) (node_1330);
			    }
			    break;
			 case ((long) 13):

			    {	/* Trace/walk.scm 238 */
			       jump_ex_it_184_bglt node_1333;
			       node_1333 =
				  (jump_ex_it_184_bglt) (node_7);
			       {	/* Trace/walk.scm 239 */
				  node_bglt arg1794_1335;
				  arg1794_1335 =
				     trace_node_95_trace_walk(
				     (((jump_ex_it_184_bglt) CREF(node_1333))->exit));
				  ((((jump_ex_it_184_bglt) CREF(node_1333))->exit) = ((node_bglt) arg1794_1335), BUNSPEC);
			       }
			       {	/* Trace/walk.scm 240 */
				  node_bglt arg1796_1337;
				  arg1796_1337 =
				     trace_node_95_trace_walk(
				     (((jump_ex_it_184_bglt) CREF(node_1333))->value));
				  ((((jump_ex_it_184_bglt) CREF(node_1333))->value) = ((node_bglt) arg1796_1337), BUNSPEC);
			       }
			       aux_1932 =
				  (obj_t) (node_1333);
			    }
			    break;
			 case ((long) 14):

			    {	/* Trace/walk.scm 120 */
			       make_box_202_bglt node_1339;
			       node_1339 =
				  (make_box_202_bglt) (node_7);
			       {	/* Trace/walk.scm 247 */
				  node_bglt arg1798_1340;
				  arg1798_1340 =
				     trace_node_95_trace_walk(
				     (((make_box_202_bglt) CREF(node_1339))->value));
				  ((((make_box_202_bglt) CREF(node_1339))->value) = ((node_bglt) arg1798_1340), BUNSPEC);
			       }
			       aux_1932 =
				  (obj_t) (node_1339);
			    }
			    break;
			 case ((long) 15):

			    {	/* Trace/walk.scm 120 */
			       box_ref_242_bglt node_1342;
			       node_1342 =
				  (box_ref_242_bglt) (node_7);
			       {	/* Trace/walk.scm 254 */
				  node_bglt arg1801_1343;
				  {	/* Trace/walk.scm 254 */
				     node_bglt aux_2062;
				     {	/* Trace/walk.scm 254 */
					var_bglt aux_2063;
					aux_2063 =
					   (((box_ref_242_bglt) CREF(node_1342))->var);
					aux_2062 =
					   (node_bglt) (aux_2063);
				     }
				     arg1801_1343 =
					trace_node_95_trace_walk(aux_2062);
				  }
				  {	/* Trace/walk.scm 254 */
				     var_bglt val1418_1573;
				     val1418_1573 =
					(var_bglt) (arg1801_1343);
				     ((((box_ref_242_bglt) CREF(node_1342))->var) = ((var_bglt) val1418_1573), BUNSPEC);
				  }
			       }
			       aux_1932 =
				  (obj_t) (node_1342);
			    }
			    break;
			 case ((long) 16):

			    {	/* Trace/walk.scm 261 */
			       box_set__221_bglt node_1345;
			       node_1345 =
				  (box_set__221_bglt) (node_7);
			       {	/* Trace/walk.scm 262 */
				  node_bglt arg1803_1347;
				  {	/* Trace/walk.scm 262 */
				     node_bglt aux_2071;
				     {	/* Trace/walk.scm 262 */
					var_bglt aux_2072;
					aux_2072 =
					   (((box_set__221_bglt) CREF(node_1345))->var);
					aux_2071 =
					   (node_bglt) (aux_2072);
				     }
				     arg1803_1347 =
					trace_node_95_trace_walk(aux_2071);
				  }
				  {	/* Trace/walk.scm 262 */
				     var_bglt val1428_1576;
				     val1428_1576 =
					(var_bglt) (arg1803_1347);
				     ((((box_set__221_bglt) CREF(node_1345))->var) = ((var_bglt) val1428_1576), BUNSPEC);
				  }
			       }
			       {	/* Trace/walk.scm 263 */
				  node_bglt arg1805_1349;
				  arg1805_1349 =
				     trace_node_95_trace_walk(
				     (((box_set__221_bglt) CREF(node_1345))->value));
				  ((((box_set__221_bglt) CREF(node_1345))->value) = ((node_bglt) arg1805_1349), BUNSPEC);
			       }
			       aux_1932 =
				  (obj_t) (node_1345);
			    }
			    break;
			 default:
			  case_else1740_1255:
			    if (
			       PROCEDUREP(method1734_1251))
			      {		/* Trace/walk.scm 120 */
				 aux_1932 =
				    PROCEDURE_ENTRY(method1734_1251) (method1734_1251,
				    (obj_t) (node_7), BEOA)
				    ;
			      }
			    else
			      {		/* Trace/walk.scm 120 */
				 obj_t fun1699_1205;
				 fun1699_1205 =
				    PROCEDURE_REF(trace_node_env_147_trace_walk, ((long) 0));
				 aux_1932 =
				    PROCEDURE_ENTRY(fun1699_1205) (fun1699_1205,
				    (obj_t) (node_7), BEOA);
			      }
			 }
		    }
		  else
		    {	/* Trace/walk.scm 120 */
		       goto case_else1740_1255;
		    }
	       }
	       return
		  (node_bglt) (aux_1932);
	    }
	 }
      }
   }
}



/* _trace-node */
obj_t 
_trace_node_88_trace_walk(obj_t env_1631, obj_t node_1632)
{
   AN_OBJECT;
   {	/* Trace/walk.scm 120 */
      {		/* Trace/walk.scm 120 */
	 node_bglt aux_2094;
	 aux_2094 =
	    trace_node_95_trace_walk(
	    (node_bglt) (node_1632));
	 return
	    (obj_t) (aux_2094);
      }
   }
}



/* trace-node-default1468 */
node_bglt 
trace_node_default1468_7_trace_walk(node_bglt node_8)
{
   AN_OBJECT;
   {	/* Trace/walk.scm 14 */
      return node_8;
   }
}



/* _trace-node-default1468 */
obj_t 
_trace_node_default1468_12_trace_walk(obj_t env_1633, obj_t node_1634)
{
   AN_OBJECT;
   {	/* Trace/walk.scm 14 */
      {		/* Trace/walk.scm 14 */
	 node_bglt aux_2098;
	 aux_2098 =
	    trace_node_default1468_7_trace_walk(
	    (node_bglt) (node_1634));
	 return
	    (obj_t) (aux_2098);
      }
   }
}



/* toplevel-trace-node */
node_bglt 
toplevel_trace_node_251_trace_walk(node_bglt node_27)
{
   AN_OBJECT;
   {	/* Trace/walk.scm 279 */
      {
	 obj_t method1701_1210;
	 obj_t class1706_1211;
	 {	/* Trace/walk.scm 279 */
	    obj_t arg1709_1208;
	    obj_t arg1711_1209;
	    {	/* Trace/walk.scm 279 */
	       object_bglt obj_1582;
	       obj_1582 =
		  (object_bglt) (node_27);
	       {	/* ./Llib/object.scm 2926 */
		  obj_t pre_method_105_1583;
		  pre_method_105_1583 =
		     PROCEDURE_REF(toplevel_trace_node_env_173_trace_walk, ((long) 2));
		  if (
		     INTEGERP(pre_method_105_1583))
		    {	/* ./Llib/object.scm 2927 */
		       PROCEDURE_SET(toplevel_trace_node_env_173_trace_walk, ((long) 2), BUNSPEC);
		       arg1709_1208 = pre_method_105_1583;
		    }
		  else
		    {	/* ./Llib/object.scm 2914 */
		       long obj_class_num_177_1588;
		       obj_class_num_177_1588 =
			  TYPE(obj_1582);
		       {	/* ./Llib/object.scm 2915 */
			  obj_t arg1176_1589;
			  arg1176_1589 =
			     PROCEDURE_REF(toplevel_trace_node_env_173_trace_walk, ((long) 1));
			  {	/* ./Llib/object.scm 2738 */
			     long arg1177_1593;
			     {	/* ./Llib/object.scm 2738 */
				long arg1178_1594;
				arg1178_1594 =
				   OBJECT_TYPE;
				arg1177_1593 =
				   (obj_class_num_177_1588 - arg1178_1594);
			     }
			     arg1709_1208 =
				VECTOR_REF(arg1176_1589, arg1177_1593);
			  }
		       }
		    }
	       }
	    }
	    {	/* Trace/walk.scm 279 */
	       object_bglt object_1599;
	       object_1599 =
		  (object_bglt) (node_27);
	       {	/* ./Llib/object.scm 2695 */
		  long arg1179_1600;
		  {	/* ./Llib/object.scm 2695 */
		     long arg1180_1601;
		     long arg1181_1602;
		     arg1180_1601 =
			TYPE(object_1599);
		     arg1181_1602 =
			OBJECT_TYPE;
		     arg1179_1600 =
			(arg1180_1601 - arg1181_1602);
		  }
		  {	/* ./Llib/object.scm 2695 */
		     obj_t vector_1606;
		     vector_1606 = _classes__134___object;
		     arg1711_1209 =
			VECTOR_REF(vector_1606, arg1179_1600);
		  }
	       }
	    }
	    {	/* Trace/walk.scm 279 */
	       obj_t aux_2117;
	       method1701_1210 = arg1709_1208;
	       class1706_1211 = arg1711_1209;
	       {

		  if (
		     INTEGERP(method1701_1210))
		    {	/* Trace/walk.scm 279 */
		       switch (
			  (long) CINT(method1701_1210))
			 {
			 case ((long) 0):

			    {	/* Trace/walk.scm 279 */
			       sequence_bglt node_1217;
			       node_1217 =
				  (sequence_bglt) (node_27);
			       toplevel_trace_node___112_trace_walk(
				  (((sequence_bglt) CREF(node_1217))->nodes));
			       aux_2117 =
				  (obj_t) (node_1217);
			    }
			    break;
			 case ((long) 1):

			    {	/* Trace/walk.scm 279 */
			       setq_bglt node_1219;
			       node_1219 =
				  (setq_bglt) (node_27);
			       {	/* Trace/walk.scm 299 */
				  var_bglt instance1466_1221;
				  instance1466_1221 =
				     (((setq_bglt) CREF(node_1219))->var);
				  {	/* Trace/walk.scm 300 */
				     bool_t test1715_1222;
				     {	/* Trace/walk.scm 300 */
					bool_t test1719_1229;
					{	/* ./Ast/var.scm 839 */
					   obj_t aux_2126;
					   {	/* Trace/walk.scm 300 */
					      variable_bglt aux_2127;
					      aux_2127 =
						 (((var_bglt) CREF(instance1466_1221))->variable);
					      aux_2126 =
						 (obj_t) (aux_2127);
					   }
					   test1719_1229 =
					      is_a__118___object(aux_2126, global_ast_var);
					}
					if (test1719_1229)
					  {	/* Trace/walk.scm 301 */
					     bool_t test1720_1230;
					     {	/* Trace/walk.scm 301 */
						bool_t test1721_1231;
						{	/* ./Ast/node.scm 968 */
						   obj_t aux_2132;
						   {	/* Trace/walk.scm 301 */
						      node_bglt aux_2133;
						      aux_2133 =
							 (((setq_bglt) CREF(node_1219))->value);
						      aux_2132 =
							 (obj_t) (aux_2133);
						   }
						   test1721_1231 =
						      is_a__118___object(aux_2132, atom_ast_node);
						}
						if (test1721_1231)
						  {	/* Trace/walk.scm 301 */
						     test1720_1230 = ((bool_t) 1);
						  }
						else
						  {	/* Trace/walk.scm 302 */
						     bool_t test1722_1232;
						     {	/* ./Ast/node.scm 973 */
							obj_t aux_2138;
							{	/* Trace/walk.scm 302 */
							   node_bglt aux_2139;
							   aux_2139 =
							      (((setq_bglt) CREF(node_1219))->value);
							   aux_2138 =
							      (obj_t) (aux_2139);
							}
							test1722_1232 =
							   is_a__118___object(aux_2138, var_ast_node);
						     }
						     if (test1722_1232)
						       {	/* Trace/walk.scm 302 */
							  test1720_1230 = ((bool_t) 1);
						       }
						     else
						       {	/* Trace/walk.scm 303 */
							  bool_t test1723_1233;
							  {	/* ./Ast/node.scm 981 */
							     obj_t aux_2144;
							     {	/* Trace/walk.scm 303 */
								node_bglt aux_2145;
								aux_2145 =
								   (((setq_bglt) CREF(node_1219))->value);
								aux_2144 =
								   (obj_t) (aux_2145);
							     }
							     test1723_1233 =
								is_a__118___object(aux_2144, kwote_ast_node);
							  }
							  if (test1723_1233)
							    {	/* Trace/walk.scm 303 */
							       test1720_1230 = ((bool_t) 1);
							    }
							  else
							    {	/* ./Ast/node.scm 1017 */
							       obj_t aux_2150;
							       {	/* Trace/walk.scm 304 */
								  node_bglt aux_2151;
								  aux_2151 =
								     (((setq_bglt) CREF(node_1219))->value);
								  aux_2150 =
								     (obj_t) (aux_2151);
							       }
							       test1720_1230 =
								  is_a__118___object(aux_2150, pragma_ast_node);
							    }
						       }
						  }
					     }
					     if (test1720_1230)
					       {	/* Trace/walk.scm 301 */
						  test1715_1222 = ((bool_t) 0);
					       }
					     else
					       {	/* Trace/walk.scm 301 */
						  test1715_1222 = ((bool_t) 1);
					       }
					  }
					else
					  {	/* Trace/walk.scm 300 */
					     test1715_1222 = ((bool_t) 0);
					  }
				     }
				     if (test1715_1222)
				       {	/* Trace/walk.scm 306 */
					  let_var_6_bglt trace_1225;
					  {	/* Trace/walk.scm 307 */
					     obj_t aux_2163;
					     type_bglt aux_2157;
					     {	/* Trace/walk.scm 305 */
						global_bglt obj_1621;
						{	/* Trace/walk.scm 305 */
						   variable_bglt aux_2164;
						   aux_2164 =
						      (((var_bglt) CREF(instance1466_1221))->variable);
						   obj_1621 =
						      (global_bglt) (aux_2164);
						}
						aux_2163 =
						   (((global_bglt) CREF(obj_1621))->id);
					     }
					     {	/* Trace/walk.scm 306 */
						global_bglt obj_1623;
						{	/* Trace/walk.scm 306 */
						   variable_bglt aux_2159;
						   aux_2159 =
						      (((var_bglt) CREF(instance1466_1221))->variable);
						   obj_1623 =
						      (global_bglt) (aux_2159);
						}
						aux_2157 =
						   (((global_bglt) CREF(obj_1623))->type);
					     }
					     trace_1225 =
						make_traced_node_44_trace_walk(
						(((setq_bglt) CREF(node_1219))->value), aux_2157, aux_2163);
					  }
					  {	/* Trace/walk.scm 307 */

					     {	/* Trace/walk.scm 308 */
						node_bglt val1303_1626;
						val1303_1626 =
						   (node_bglt) (trace_1225);
						((((setq_bglt) CREF(node_1219))->value) = ((node_bglt) val1303_1626), BUNSPEC);
					     }
					  }
				       }
				     else
				       {	/* Trace/walk.scm 300 */
					  BUNSPEC;
				       }
				  }
			       }
			       aux_2117 =
				  (obj_t) (node_1219);
			    }
			    break;
			 default:
			  case_else1707_1214:
			    if (
			       PROCEDUREP(method1701_1210))
			      {		/* Trace/walk.scm 279 */
				 aux_2117 =
				    PROCEDURE_ENTRY(method1701_1210) (method1701_1210,
				    (obj_t) (node_27), BEOA)
				    ;
			      }
			    else
			      {		/* Trace/walk.scm 279 */
				 obj_t fun1700_1206;
				 fun1700_1206 =
				    PROCEDURE_REF(toplevel_trace_node_env_173_trace_walk, ((long) 0));
				 aux_2117 =
				    PROCEDURE_ENTRY(fun1700_1206) (fun1700_1206,
				    (obj_t) (node_27), BEOA);
			      }
			 }
		    }
		  else
		    {	/* Trace/walk.scm 279 */
		       goto case_else1707_1214;
		    }
	       }
	       return
		  (node_bglt) (aux_2117);
	    }
	 }
      }
   }
}



/* _toplevel-trace-node1815 */
obj_t 
_toplevel_trace_node1815_104_trace_walk(obj_t env_1635, obj_t node_1636)
{
   AN_OBJECT;
   {	/* Trace/walk.scm 279 */
      {		/* Trace/walk.scm 279 */
	 node_bglt aux_2184;
	 aux_2184 =
	    toplevel_trace_node_251_trace_walk(
	    (node_bglt) (node_1636));
	 return
	    (obj_t) (aux_2184);
      }
   }
}



/* toplevel-trace-node-default1504 */
node_bglt 
toplevel_trace_node_default1504_69_trace_walk(node_bglt node_28)
{
   AN_OBJECT;
   {	/* Trace/walk.scm 14 */
      return node_28;
   }
}



/* _toplevel-trace-node-default1504 */
obj_t 
_toplevel_trace_node_default1504_138_trace_walk(obj_t env_1637, obj_t node_1638)
{
   AN_OBJECT;
   {	/* Trace/walk.scm 14 */
      {		/* Trace/walk.scm 14 */
	 node_bglt aux_2188;
	 aux_2188 =
	    toplevel_trace_node_default1504_69_trace_walk(
	    (node_bglt) (node_1638));
	 return
	    (obj_t) (aux_2188);
      }
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_trace_walk()
{
   AN_OBJECT;
   {	/* Trace/walk.scm 14 */
      module_initialization_70_tools_speek(((long) 0), "TRACE_WALK");
      module_initialization_70_tools_error(((long) 0), "TRACE_WALK");
      module_initialization_70_engine_pass(((long) 0), "TRACE_WALK");
      module_initialization_70_type_type(((long) 0), "TRACE_WALK");
      module_initialization_70_ast_var(((long) 0), "TRACE_WALK");
      module_initialization_70_ast_node(((long) 0), "TRACE_WALK");
      module_initialization_70_tools_shape(((long) 0), "TRACE_WALK");
      module_initialization_70_tools_misc(((long) 0), "TRACE_WALK");
      module_initialization_70_type_env(((long) 0), "TRACE_WALK");
      module_initialization_70_ast_sexp(((long) 0), "TRACE_WALK");
      module_initialization_70_module_module(((long) 0), "TRACE_WALK");
      module_initialization_70_engine_param(((long) 0), "TRACE_WALK");
      module_initialization_70_ast_ident(((long) 0), "TRACE_WALK");
      return
	 module_initialization_70_ast_env(((long) 0), "TRACE_WALK");
   }
}
