/*===========================================================================*/
/*   (Type/pptype.scm)                                                       */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;


static obj_t method_init_76_type_pptype();
extern obj_t string_append(obj_t, obj_t);
static obj_t _variable_type__string_13_type_pptype(obj_t, obj_t);
extern obj_t module_initialization_70_type_pptype(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70___r4_strings_6_7(long, char *);
static obj_t _function_type__string_239_type_pptype(obj_t, obj_t);
static obj_t imported_modules_init_94_type_pptype();
extern obj_t string_downcase_77___r4_strings_6_7(obj_t);
extern obj_t variable_type__string_186_type_pptype(variable_bglt);
static obj_t library_modules_init_112_type_pptype();
extern obj_t string_to_bstring(char *);
static obj_t loop_type_pptype(obj_t);
extern obj_t function_type__string_79_type_pptype(variable_bglt);
static obj_t require_initialization_114_type_pptype = BUNSPEC;
static obj_t *__cnst;

DEFINE_EXPORT_PROCEDURE(variable_type__string_env_196_type_pptype, _variable_type__string_13_type_pptype1256, _variable_type__string_13_type_pptype, 0L, 1);
DEFINE_EXPORT_PROCEDURE(function_type__string_env_141_type_pptype, _function_type__string_239_type_pptype1257, _function_type__string_239_type_pptype, 0L, 1);
DEFINE_STRING(string1254_type_pptype, string1254_type_pptype1258, "", 0);
DEFINE_STRING(string1253_type_pptype, string1253_type_pptype1259, " -> ", 4);



/* module-initialization */
obj_t 
module_initialization_70_type_pptype(long checksum_485, char *from_486)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_type_pptype))
	{
	   require_initialization_114_type_pptype =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_type_pptype();
	   imported_modules_init_94_type_pptype();
	   method_init_76_type_pptype();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_type_pptype()
{
   AN_OBJECT;
   {	/* Type/pptype.scm 14 */
      module_initialization_70___r4_strings_6_7(((long) 0), "TYPE_PPTYPE");
      return BUNSPEC;
   }
}



/* function-type->string */
obj_t 
function_type__string_79_type_pptype(variable_bglt variable_2)
{
   AN_OBJECT;
   {	/* Type/pptype.scm 31 */
      {		/* Type/pptype.scm 33 */
	 obj_t arg1189_312;
	 obj_t arg1190_313;
	 {	/* Type/pptype.scm 33 */
	    obj_t aux_494;
	    {	/* Type/pptype.scm 33 */
	       sfun_bglt obj_466;
	       {	/* Type/pptype.scm 33 */
		  value_bglt aux_495;
		  aux_495 =
		     (((variable_bglt) CREF(variable_2))->value);
		  obj_466 =
		     (sfun_bglt) (aux_495);
	       }
	       aux_494 =
		  (((sfun_bglt) CREF(obj_466))->args);
	    }
	    arg1189_312 =
	       loop_type_pptype(aux_494);
	 }
	 {	/* Type/pptype.scm 33 */
	    obj_t arg1214_330;
	    {	/* Type/pptype.scm 46 */
	       obj_t arg1215_331;
	       {	/* ./Ieee/symbol.scm 6021 */
		  obj_t aux_500;
		  {	/* Type/pptype.scm 46 */
		     type_bglt arg1217_333;
		     arg1217_333 =
			(((variable_bglt) CREF(variable_2))->type);
		     aux_500 =
			(((type_bglt) CREF(arg1217_333))->id);
		  }
		  arg1215_331 =
		     SYMBOL_TO_STRING(aux_500);
	       }
	       arg1214_330 =
		  string_downcase_77___r4_strings_6_7(arg1215_331);
	    }
	    arg1190_313 =
	       string_append(string1253_type_pptype, arg1214_330);
	 }
	 return
	    string_append(arg1189_312, arg1190_313);
      }
   }
}



/* loop */
obj_t 
loop_type_pptype(obj_t args_314)
{
   AN_OBJECT;
   {	/* Type/pptype.scm 33 */
      if (
	 NULLP(args_314))
	{	/* Type/pptype.scm 34 */
	   return string1254_type_pptype;
	}
      else
	{	/* Type/pptype.scm 39 */
	   obj_t arg1194_318;
	   obj_t arg1195_319;
	   {	/* Type/pptype.scm 39 */
	      obj_t arg1196_320;
	      {		/* ./Ieee/symbol.scm 6021 */
		 obj_t aux_509;
		 {	/* Type/pptype.scm 39 */
		    type_bglt arg1201_322;
		    {	/* Type/pptype.scm 39 */
		       local_bglt obj_469;
		       {	/* Type/pptype.scm 39 */
			  obj_t aux_510;
			  aux_510 =
			     CAR(args_314);
			  obj_469 =
			     (local_bglt) (aux_510);
		       }
		       arg1201_322 =
			  (((local_bglt) CREF(obj_469))->type);
		    }
		    aux_509 =
		       (((type_bglt) CREF(arg1201_322))->id);
		 }
		 arg1196_320 =
		    SYMBOL_TO_STRING(aux_509);
	      }
	      arg1194_318 =
		 string_downcase_77___r4_strings_6_7(arg1196_320);
	   }
	   {	/* Type/pptype.scm 40 */
	      char *arg1204_324;
	      obj_t arg1206_325;
	      {		/* Type/pptype.scm 40 */
		 bool_t test_517;
		 {	/* ./Ieee/pair-list.scm 5912 */
		    obj_t aux_518;
		    aux_518 =
		       CDR(args_314);
		    test_517 =
		       NULLP(aux_518);
		 }
		 if (test_517)
		   {	/* Type/pptype.scm 40 */
		      arg1204_324 = "";
		   }
		 else
		   {	/* Type/pptype.scm 40 */
		      arg1204_324 = " x ";
		   }
	      }
	      arg1206_325 =
		 loop_type_pptype(
		 CDR(args_314));
	      {		/* Type/pptype.scm 36 */
		 obj_t aux_523;
		 aux_523 =
		    string_to_bstring(arg1204_324);
		 arg1195_319 =
		    string_append(aux_523, arg1206_325);
	      }
	   }
	   return
	      string_append(arg1194_318, arg1195_319);
	}
   }
}



/* _function-type->string */
obj_t 
_function_type__string_239_type_pptype(obj_t env_481, obj_t variable_482)
{
   AN_OBJECT;
   {	/* Type/pptype.scm 31 */
      return
	 function_type__string_79_type_pptype(
	 (variable_bglt) (variable_482));
   }
}



/* variable-type->string */
obj_t 
variable_type__string_186_type_pptype(variable_bglt variable_3)
{
   AN_OBJECT;
   {	/* Type/pptype.scm 51 */
      {		/* Type/pptype.scm 52 */
	 obj_t arg1220_334;
	 {	/* ./Ieee/symbol.scm 6021 */
	    obj_t aux_529;
	    {	/* Type/pptype.scm 52 */
	       type_bglt arg1223_336;
	       arg1223_336 =
		  (((variable_bglt) CREF(variable_3))->type);
	       aux_529 =
		  (((type_bglt) CREF(arg1223_336))->id);
	    }
	    arg1220_334 =
	       SYMBOL_TO_STRING(aux_529);
	 }
	 return
	    string_downcase_77___r4_strings_6_7(arg1220_334);
      }
   }
}



/* _variable-type->string */
obj_t 
_variable_type__string_13_type_pptype(obj_t env_483, obj_t variable_484)
{
   AN_OBJECT;
   {	/* Type/pptype.scm 51 */
      return
	 variable_type__string_186_type_pptype(
	 (variable_bglt) (variable_484));
   }
}



/* method-init */
obj_t 
method_init_76_type_pptype()
{
   AN_OBJECT;
   {	/* Type/pptype.scm 14 */
      return BUNSPEC;
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_type_pptype()
{
   AN_OBJECT;
   {	/* Type/pptype.scm 14 */
      module_initialization_70_type_type(((long) 0), "TYPE_PPTYPE");
      return
	 module_initialization_70_ast_var(((long) 0), "TYPE_PPTYPE");
   }
}
