/*===========================================================================*/
/*   (Type/tenv.scm)                                                         */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct ccomp
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t producer;
     obj_t consumer;
     obj_t finalizer;
     obj_t checksummer;
  }
     *ccomp_bglt;

typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct tclass
  {
     obj_t its_super_214;
     obj_t slots;
     struct global *holder;
     obj_t widening;
     long depth;
     bool_t final__12;
     obj_t constructor;
     obj_t virtual_slots_number_200;
  }
      *tclass_bglt;


static obj_t method_init_76_type_env();
extern obj_t for_each_hash_105___hash(obj_t, obj_t);
extern obj_t get_tenv_245_type_env();
static type_bglt bind_type__113_type_env(obj_t, bool_t, obj_t);
static obj_t _add_tenv__212_type_env(obj_t, obj_t);
extern obj_t type_type_type;
extern type_bglt declare_type__118_type_env(obj_t, obj_t, obj_t);
extern type_bglt declare_aliastype__27_type_env(obj_t, obj_t, obj_t, type_bglt);
extern obj_t user_error_151_tools_error(obj_t, obj_t, obj_t, obj_t);
extern obj_t __in_name__215_type_tools(obj_t);
extern obj_t notify_assert_fail_37___eval(obj_t, obj_t, obj_t);
extern obj_t get_hash_29___hash(obj_t, obj_t);
extern bool_t is_a__118___object(obj_t, obj_t);
static obj_t _set_tenv__160_type_env(obj_t, obj_t);
extern type_bglt get_default_type_181_type_cache();
extern obj_t module_initialization_70_type_env(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_ast_ident(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_module_module(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_tools(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_object_class(long, char *);
extern obj_t module_initialization_70___hash(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___eval(long, char *);
extern obj_t module_initialization_70___evenv(long, char *);
extern obj_t module_initialization_70___r4_equivalence_6_2(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern bool_t sub_type__174_type_env(type_bglt, type_bglt);
static bool_t _types_already_checked___82_type_env;
extern long get_hash_power_number(char *, long);
extern obj_t make_hash_table_174___hash(long, obj_t, obj_t, obj_t, obj_t);
static obj_t _initialize_tenv__4_type_env(obj_t);
extern long class_num_218___object(obj_t);
extern obj_t define_primop_ref__105___evenv(obj_t, obj_t);
extern type_bglt find_type_26_type_env(obj_t);
extern bool_t list__240___r4_pairs_and_lists_6_3(obj_t);
static obj_t imported_modules_init_94_type_env();
extern obj_t unbind_primop__163___evenv(obj_t);
extern obj_t initialize_tenv__150_type_env();
extern bool_t type_exists__12_type_env(obj_t);
extern obj_t heap_add_class__147_object_class(tclass_bglt);
static obj_t _check_types_155_type_env(obj_t);
static obj_t library_modules_init_112_type_env();
extern type_bglt use_type__231_type_env(obj_t, obj_t);
static obj_t toplevel_init_63_type_env();
extern obj_t check_types_141_type_env();
static obj_t _anonymous_1336__10_type_env(obj_t, obj_t);
extern obj_t open_input_string(obj_t);
static obj_t _type_id_65_type_env(obj_t, obj_t);
extern obj_t put_hash__129___hash(obj_t, obj_t);
static obj_t _use_foreign_type__63_type_env(obj_t, obj_t, obj_t);
static obj_t _sub_type__69_type_env(obj_t, obj_t, obj_t);
static obj_t _for_each_type__79_type_env(obj_t, obj_t);
static long get_hash_number_100_type_env(obj_t);
extern obj_t parse_id_241_ast_ident(obj_t, obj_t);
extern obj_t tclass_object_class;
extern type_bglt use_foreign_type__12_type_env(obj_t, obj_t);
static obj_t _declare_type__130_type_env(obj_t, obj_t, obj_t, obj_t);
static obj_t _declare_aliastype__93_type_env(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t add_tenv__100_type_env(obj_t);
extern obj_t memq___r4_pairs_and_lists_6_3(obj_t, obj_t);
static obj_t _anonymous_1260__161_type_env(obj_t, obj_t);
extern obj_t shape_tools_shape(obj_t);
static obj_t _type_exists__25_type_env(obj_t, obj_t);
static obj_t type_id_229_type_env(type_bglt);
static obj_t _anonymous_1247__18_type_env(obj_t, obj_t);
static obj_t uninitialized_types_97_type_env();
static obj_t _find_type_214_type_env(obj_t, obj_t);
extern obj_t _module__166_module_module;
static obj_t _declare_subtype__52_type_env(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t for_each_type__69_type_env(obj_t);
static obj_t _get_hash_number_209_type_env(obj_t, obj_t);
extern obj_t read___reader(obj_t);
extern obj_t set_tenv__70_type_env(obj_t);
extern obj_t _lib_mode__85_engine_param;
extern type_bglt declare_subtype__66_type_env(obj_t, obj_t, obj_t, obj_t);
static obj_t _tenv__6_type_env = BUNSPEC;
static obj_t require_initialization_114_type_env = BUNSPEC;
static obj_t _use_type__224_type_env(obj_t, obj_t, obj_t);
static obj_t _get_tenv_246_type_env(obj_t);
static obj_t cnst_init_137_type_env();
extern obj_t user_error_location_137_tools_error(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t __cnst[10];

DEFINE_STATIC_PROCEDURE(get_hash_number_env_189_type_env, _get_hash_number_209_type_env1412, _get_hash_number_209_type_env, 0L, 1);
extern obj_t eq__env_189___r4_equivalence_6_2;
DEFINE_STATIC_PROCEDURE(proc1396_type_env, _anonymous_1260__161_type_env1413, _anonymous_1260__161_type_env, 0L, 1);
DEFINE_EXPORT_PROCEDURE(get_tenv_env_113_type_env, _get_tenv_246_type_env1414, _get_tenv_246_type_env, 0L, 0);
DEFINE_EXPORT_PROCEDURE(initialize_tenv__env_9_type_env, _initialize_tenv__4_type_env1415, _initialize_tenv__4_type_env, 0L, 0);
DEFINE_EXPORT_PROCEDURE(use_type__env_198_type_env, _use_type__224_type_env1416, _use_type__224_type_env, 0L, 2);
DEFINE_EXPORT_PROCEDURE(declare_aliastype__env_64_type_env, _declare_aliastype__93_type_env1417, _declare_aliastype__93_type_env, 0L, 4);
DEFINE_EXPORT_PROCEDURE(set_tenv__env_79_type_env, _set_tenv__160_type_env1418, _set_tenv__160_type_env, 0L, 1);
DEFINE_EXPORT_PROCEDURE(declare_type__env_220_type_env, _declare_type__130_type_env1419, _declare_type__130_type_env, 0L, 3);
DEFINE_EXPORT_PROCEDURE(add_tenv__env_189_type_env, _add_tenv__212_type_env1420, _add_tenv__212_type_env, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sub_type__env_156_type_env, _sub_type__69_type_env1421, _sub_type__69_type_env, 0L, 2);
DEFINE_EXPORT_PROCEDURE(type_exists__env_74_type_env, _type_exists__25_type_env1422, _type_exists__25_type_env, 0L, 1);
DEFINE_EXPORT_PROCEDURE(for_each_type__env_84_type_env, _for_each_type__79_type_env1423, _for_each_type__79_type_env, 0L, 1);
DEFINE_EXPORT_PROCEDURE(use_foreign_type__env_74_type_env, _use_foreign_type__63_type_env1424, _use_foreign_type__63_type_env, 0L, 2);
DEFINE_STRING(string1399_type_env, string1399_type_env1425, "Can't find type", 15);
DEFINE_STRING(string1398_type_env, string1398_type_env1426, "find-type", 9);
DEFINE_STRING(string1397_type_env, string1397_type_env1427, "Illegal type heap redefinition", 30);
DEFINE_STRING(string1406_type_env, string1406_type_env1428, "(\"/home/tahoe2/serrano/tmp/bigloo/comptime/Type/tenv.scm\" . 11547) (BEGIN (LIST? PARENTS)) (PARENTS) PARENTS (BIGLOO C _) BIGLOO EQ? TYPE-ID GET-HASH-NUMBER THE-GLOBAL-ENVIRONMENT ", 180);
DEFINE_STRING(string1395_type_env, string1395_type_env1429, "Can't find super class of", 25);
DEFINE_STRING(string1405_type_env, string1405_type_env1430, "These types are used but not defined", 36);
DEFINE_STRING(string1394_type_env, string1394_type_env1431, "add-Tenv", 8);
DEFINE_STRING(string1404_type_env, string1404_type_env1432, "Illegal type class", 18);
DEFINE_STRING(string1403_type_env, string1403_type_env1433, "declare-type!", 13);
DEFINE_STRING(string1402_type_env, string1402_type_env1434, "use-type!", 9);
DEFINE_STRING(string1401_type_env, string1401_type_env1435, "Type redefinition", 17);
DEFINE_STRING(string1400_type_env, string1400_type_env1436, "bind-type!", 10);
DEFINE_EXPORT_PROCEDURE(find_type_env_252_type_env, _find_type_214_type_env1437, _find_type_214_type_env, 0L, 1);
DEFINE_EXPORT_PROCEDURE(check_types_env_232_type_env, _check_types_155_type_env1438, _check_types_155_type_env, 0L, 0);
DEFINE_STATIC_PROCEDURE(type_id_env_218_type_env, _type_id_65_type_env1439, _type_id_65_type_env, 0L, 1);
DEFINE_EXPORT_PROCEDURE(declare_subtype__env_86_type_env, _declare_subtype__52_type_env1440, _declare_subtype__52_type_env, 0L, 4);



/* module-initialization */
obj_t 
module_initialization_70_type_env(long checksum_1046, char *from_1047)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_type_env))
	{
	   require_initialization_114_type_env =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_type_env();
	   cnst_init_137_type_env();
	   imported_modules_init_94_type_env();
	   method_init_76_type_env();
	   toplevel_init_63_type_env();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_type_env()
{
   AN_OBJECT;
   {	/* Type/tenv.scm 14 */
      module_initialization_70___hash(((long) 0), "TYPE_ENV");
      module_initialization_70___eval(((long) 0), "TYPE_ENV");
      module_initialization_70___object(((long) 0), "TYPE_ENV");
      module_initialization_70___r4_equivalence_6_2(((long) 0), "TYPE_ENV");
      module_initialization_70___evenv(((long) 0), "TYPE_ENV");
      module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "TYPE_ENV");
      module_initialization_70___reader(((long) 0), "TYPE_ENV");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_type_env()
{
   AN_OBJECT;
   {	/* Type/tenv.scm 14 */
      {		/* Type/tenv.scm 14 */
	 obj_t cnst_port_138_1039;
	 cnst_port_138_1039 =
	    open_input_string(string1406_type_env);
	 {
	    long i_1040;
	    i_1040 = ((long) 9);
	  loop_1041:
	    {	/* Type/tenv.scm 14 */
	       bool_t test1407_1042;
	       test1407_1042 =
		  (i_1040 == ((long) -1));
	       if (test1407_1042)
		 {	/* Type/tenv.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Type/tenv.scm 14 */
		    {	/* Type/tenv.scm 14 */
		       obj_t arg1409_1043;
		       {	/* Type/tenv.scm 14 */
			  obj_t list1410_1044;
			  list1410_1044 =
			     MAKE_PAIR(cnst_port_138_1039, BNIL);
			  arg1409_1043 =
			     read___reader(list1410_1044);
		       }
		       CNST_TABLE_SET(i_1040, arg1409_1043);
		    }
		    {	/* Type/tenv.scm 14 */
		       int aux_1045;
		       {	/* Type/tenv.scm 14 */
			  long aux_1069;
			  aux_1069 =
			     (i_1040 - ((long) 1));
			  aux_1045 =
			     (int) (aux_1069);
		       }
		       {
			  long i_1072;
			  i_1072 =
			     (long) (aux_1045);
			  i_1040 = i_1072;
			  goto loop_1041;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_type_env()
{
   AN_OBJECT;
   {	/* Type/tenv.scm 14 */
      _tenv__6_type_env =
	 CNST_TABLE_REF(((long) 0));
      return (
	 _types_already_checked___82_type_env = ((bool_t) 0), BUNSPEC);
   }
}



/* get-hash-number */
long 
get_hash_number_100_type_env(obj_t o_19)
{
   AN_OBJECT;
   {	/* Type/tenv.scm 58 */
      {		/* Type/tenv.scm 59 */
	 obj_t arg1243_775;
	 arg1243_775 =
	    SYMBOL_TO_STRING(o_19);
	 {	/* ./Llib/hash.scm 1789 */
	    char *aux_1076;
	    aux_1076 =
	       BSTRING_TO_STRING(arg1243_775);
	    return
	       get_hash_power_number(aux_1076, ((long) 10));
	 }
      }
   }
}



/* _get-hash-number */
obj_t 
_get_hash_number_209_type_env(obj_t env_982, obj_t o_983)
{
   AN_OBJECT;
   {	/* Type/tenv.scm 58 */
      {		/* Type/tenv.scm 58 */
	 long aux_1079;
	 aux_1079 =
	    get_hash_number_100_type_env(o_983);
	 return
	    BINT(aux_1079);
      }
   }
}



/* set-tenv! */
obj_t 
set_tenv__70_type_env(obj_t tenv_20)
{
   AN_OBJECT;
   {	/* Type/tenv.scm 64 */
      _tenv__6_type_env = tenv_20;
      {		/* Type/tenv.scm 66 */
	 obj_t s_780;
	 s_780 = _tenv__6_type_env;
	 STRUCT_SET(s_780, ((long) 2), get_hash_number_env_189_type_env);
      }
      {		/* Type/tenv.scm 67 */
	 obj_t s_782;
	 s_782 = _tenv__6_type_env;
	 STRUCT_SET(s_782, ((long) 3), type_id_env_218_type_env);
      }
      {		/* Type/tenv.scm 68 */
	 obj_t s_784;
	 s_784 = _tenv__6_type_env;
	 return
	    STRUCT_SET(s_784, ((long) 5), eq__env_189___r4_equivalence_6_2);
      }
   }
}



/* _set-tenv! */
obj_t 
_set_tenv__160_type_env(obj_t env_984, obj_t tenv_985)
{
   AN_OBJECT;
   {	/* Type/tenv.scm 64 */
      return
	 set_tenv__70_type_env(tenv_985);
   }
}



/* add-tenv! */
obj_t 
add_tenv__100_type_env(obj_t tenv_21)
{
   AN_OBJECT;
   {	/* Type/tenv.scm 73 */
      {		/* Type/tenv.scm 104 */
	 obj_t remember_list_194_458;
	 remember_list_194_458 =
	    MAKE_CELL(BNIL);
	 {	/* Type/tenv.scm 112 */
	    obj_t _anonymous_1247__18_992;
	    _anonymous_1247__18_992 =
	       make_fx_procedure(_anonymous_1247__18_type_env, ((long) 1), ((long) 1));
	    PROCEDURE_SET(_anonymous_1247__18_992, ((long) 0), remember_list_194_458);
	    for_each_hash_105___hash(_anonymous_1247__18_992, tenv_21);
	 }
	 {
	    obj_t l1225_468;
	    l1225_468 =
	       CELL_REF(remember_list_194_458);
	  lname1226_469:
	    if (
	       PAIRP(l1225_468))
	      {		/* Type/tenv.scm 134 */
		 {	/* Type/tenv.scm 135 */
		    obj_t new_471;
		    new_471 =
		       CAR(l1225_468);
		    {	/* Type/tenv.scm 135 */
		       bool_t test1252_472;
		       test1252_472 =
			  is_a__118___object(new_471, tclass_object_class);
		       if (test1252_472)
			 {	/* Type/tenv.scm 136 */
			    obj_t super_473;
			    {	/* Type/tenv.scm 136 */
			       tclass_bglt obj_798;
			       obj_798 =
				  (tclass_bglt) (new_471);
			       {
				  obj_t aux_1095;
				  {	/* ./Object/class.scm 1348 */
				     object_bglt aux_1096;
				     aux_1096 =
					(object_bglt) (obj_798);
				     aux_1095 =
					OBJECT_WIDENING(aux_1096);
				  }
				  super_473 =
				     (((tclass_bglt) CREF(aux_1095))->its_super_214);
			       }
			    }
			    {	/* Type/tenv.scm 137 */
			       bool_t test1253_474;
			       test1253_474 =
				  is_a__118___object(super_473, tclass_object_class);
			       if (test1253_474)
				 {	/* Type/tenv.scm 138 */
				    type_bglt old_s_201_476;
				    {	/* Type/tenv.scm 139 */
				       obj_t aux_1102;
				       {	/* Type/tenv.scm 138 */
					  type_bglt obj_800;
					  obj_800 =
					     (type_bglt) (super_473);
					  aux_1102 =
					     (((type_bglt) CREF(obj_800))->id);
				       }
				       old_s_201_476 =
					  find_type_26_type_env(aux_1102);
				    }
				    {	/* Type/tenv.scm 139 */

				       {	/* Type/tenv.scm 140 */
					  bool_t test1254_477;
					  test1254_477 =
					     is_a__118___object(
					     (obj_t) (old_s_201_476), tclass_object_class);
					  if (test1254_477)
					    {	/* Type/tenv.scm 144 */
					       tclass_bglt obj_802;
					       obj_t val1204_803;
					       obj_802 =
						  (tclass_bglt) (new_471);
					       val1204_803 =
						  (obj_t) (old_s_201_476);
					       {
						  obj_t aux_1111;
						  {	/* ./Object/class.scm 1348 */
						     object_bglt aux_1112;
						     aux_1112 =
							(object_bglt) (obj_802);
						     aux_1111 =
							OBJECT_WIDENING(aux_1112);
						  }
						  ((((tclass_bglt) CREF(aux_1111))->its_super_214) = ((obj_t) val1204_803), BUNSPEC);
					       }
					    }
					  else
					    {	/* ./Llib/error.scm 1110 */
					       obj_t aux_1116;
					       {	/* Type/tenv.scm 143 */
						  type_bglt obj_804;
						  obj_804 =
						     (type_bglt) (new_471);
						  aux_1116 =
						     (((type_bglt) CREF(obj_804))->name);
					       }
					       FAILURE(string1394_type_env, string1395_type_env, aux_1116);
					    }
				       }
				    }
				 }
			       else
				 {	/* Type/tenv.scm 137 */
				    BUNSPEC;
				 }
			    }
			 }
		       else
			 {	/* Type/tenv.scm 135 */
			    BUNSPEC;
			 }
		    }
		 }
		 {
		    obj_t l1225_1120;
		    l1225_1120 =
		       CDR(l1225_468);
		    l1225_468 = l1225_1120;
		    goto lname1226_469;
		 }
	      }
	    else
	      {		/* Type/tenv.scm 134 */
		 ((bool_t) 1);
	      }
	 }
      }
      {		/* Type/tenv.scm 153 */
	 obj_t _anonymous_1260__161_991;
	 _anonymous_1260__161_991 = proc1396_type_env;
	 return
	    for_each_hash_105___hash(_anonymous_1260__161_991, _tenv__6_type_env);
      }
   }
}



/* _add-tenv! */
obj_t 
_add_tenv__212_type_env(obj_t env_993, obj_t tenv_994)
{
   AN_OBJECT;
   {	/* Type/tenv.scm 73 */
      return
	 add_tenv__100_type_env(tenv_994);
   }
}



/* <anonymous:1260> */
obj_t 
_anonymous_1260__161_type_env(obj_t env_995, obj_t new_996)
{
   AN_OBJECT;
   {	/* Type/tenv.scm 152 */
      {
	 obj_t new_483;
	 {	/* Type/tenv.scm 153 */
	    bool_t aux_1124;
	    new_483 = new_996;
	    {
	       obj_t type_515;
	       type_515 = new_483;
	       {
		  obj_t l1221_517;
		  {	/* Type/tenv.scm 80 */
		     type_bglt obj_835;
		     obj_835 =
			(type_bglt) (type_515);
		     l1221_517 =
			(((type_bglt) CREF(obj_835))->coerce_to_204);
		  }
		lname1222_518:
		  if (
		     PAIRP(l1221_517))
		    {	/* Type/tenv.scm 75 */
		       {	/* Type/tenv.scm 76 */
			  obj_t coercer_521;
			  coercer_521 =
			     CAR(l1221_517);
			  {	/* Type/tenv.scm 76 */
			     obj_t to_523;
			     to_523 =
				STRUCT_REF(coercer_521, ((long) 1));
			     {	/* Type/tenv.scm 78 */
				type_bglt arg1282_524;
				{	/* Type/tenv.scm 78 */
				   obj_t aux_1129;
				   {	/* Type/tenv.scm 78 */
				      type_bglt obj_844;
				      {		/* Type/tenv.scm 78 */
					 obj_t aux_1130;
					 aux_1130 =
					    STRUCT_REF(coercer_521, ((long) 0));
					 obj_844 =
					    (type_bglt) (aux_1130);
				      }
				      aux_1129 =
					 (((type_bglt) CREF(obj_844))->id);
				   }
				   arg1282_524 =
				      find_type_26_type_env(aux_1129);
				}
				{	/* ./Llib/struct.scm 1463 */
				   obj_t aux_1135;
				   aux_1135 =
				      (obj_t) (arg1282_524);
				   STRUCT_SET(coercer_521, ((long) 0), aux_1135);
				}
			     }
			     {	/* Type/tenv.scm 79 */
				type_bglt arg1287_526;
				{	/* Type/tenv.scm 79 */
				   obj_t aux_1138;
				   {	/* Type/tenv.scm 79 */
				      type_bglt obj_850;
				      obj_850 =
					 (type_bglt) (to_523);
				      aux_1138 =
					 (((type_bglt) CREF(obj_850))->id);
				   }
				   arg1287_526 =
				      find_type_26_type_env(aux_1138);
				}
				{	/* ./Llib/struct.scm 1463 */
				   obj_t aux_1142;
				   aux_1142 =
				      (obj_t) (arg1287_526);
				   STRUCT_SET(coercer_521, ((long) 1), aux_1142);
				}
			     }
			  }
		       }
		       {
			  obj_t l1221_1145;
			  l1221_1145 =
			     CDR(l1221_517);
			  l1221_517 = l1221_1145;
			  goto lname1222_518;
		       }
		    }
		  else
		    {	/* Type/tenv.scm 75 */
		       aux_1124 = ((bool_t) 1);
		    }
	       }
	    }
	    return
	       BBOOL(aux_1124);
	 }
      }
   }
}



/* <anonymous:1247> */
obj_t 
_anonymous_1247__18_type_env(obj_t env_997, obj_t new_999)
{
   AN_OBJECT;
   {	/* Type/tenv.scm 111 */
      {		/* Type/tenv.scm 112 */
	 obj_t remember_list_194_998;
	 remember_list_194_998 =
	    PROCEDURE_REF(env_997, ((long) 0));
	 {
	    obj_t new_460;
	    new_460 = new_999;
	    {
	       obj_t old_486;
	       obj_t new_487;
	       obj_t from_504;
	       type_bglt to_505;
	       {	/* Type/tenv.scm 112 */
		  obj_t id_462;
		  {	/* Type/tenv.scm 112 */
		     type_bglt obj_786;
		     obj_786 =
			(type_bglt) (new_460);
		     id_462 =
			(((type_bglt) CREF(obj_786))->id);
		  }
		  {	/* Type/tenv.scm 112 */
		     obj_t old_463;
		     old_463 =
			get_hash_29___hash(id_462, _tenv__6_type_env);
		     {	/* Type/tenv.scm 113 */

			{	/* Type/tenv.scm 115 */
			   bool_t test1248_464;
			   test1248_464 =
			      is_a__118___object(old_463, type_type_type);
			   if (test1248_464)
			     {	/* Type/tenv.scm 122 */
				bool_t test_1156;
				{	/* Type/tenv.scm 122 */
				   type_bglt obj_788;
				   obj_788 =
				      (type_bglt) (old_463);
				   test_1156 =
				      (((type_bglt) CREF(obj_788))->init__47);
				}
				if (test_1156)
				  {	/* Type/tenv.scm 122 */
				     {	/* Type/tenv.scm 130 */
					bool_t aux_1159;
					old_486 = old_463;
					new_487 = new_460;
					{
					   obj_t l1223_489;
					   {	/* Type/tenv.scm 101 */
					      type_bglt obj_809;
					      obj_809 =
						 (type_bglt) (new_487);
					      l1223_489 =
						 (((type_bglt) CREF(obj_809))->coerce_to_204);
					   }
					 lname1224_490:
					   if (
					      PAIRP(l1223_489))
					     {	/* Type/tenv.scm 91 */
						{	/* Type/tenv.scm 92 */
						   obj_t coercer_493;
						   coercer_493 =
						      CAR(l1223_489);
						   {	/* Type/tenv.scm 93 */
						      obj_t tid_496;
						      {		/* Type/tenv.scm 94 */
							 type_bglt obj_818;
							 {	/* Type/tenv.scm 94 */
							    obj_t aux_1163;
							    aux_1163 =
							       STRUCT_REF(coercer_493, ((long) 1));
							    obj_818 =
							       (type_bglt) (aux_1163);
							 }
							 tid_496 =
							    (((type_bglt) CREF(obj_818))->id);
						      }
						      {		/* Type/tenv.scm 95 */

							 {	/* Type/tenv.scm 96 */
							    bool_t test1265_498;
							    if (
							       type_exists__12_type_env(tid_496))
							      {		/* Type/tenv.scm 97 */
								 bool_t test1269_501;
								 {	/* Type/tenv.scm 97 */
								    type_bglt arg1270_502;
								    arg1270_502 =
								       find_type_26_type_env(tid_496);
								    {	/* Type/tenv.scm 97 */
								       obj_t aux_1170;
								       from_504 = old_486;
								       to_505 = arg1270_502;
								       {
									  obj_t coercer_507;
									  {	/* Type/tenv.scm 82 */
									     type_bglt obj_825;
									     obj_825 =
										(type_bglt) (from_504);
									     coercer_507 =
										(((type_bglt) CREF(obj_825))->coerce_to_204);
									  }
									loop_508:
									  if (
									     NULLP(coercer_507))
									    {	/* Type/tenv.scm 84 */
									       aux_1170 = BFALSE;
									    }
									  else
									    {	/* Type/tenv.scm 86 */
									       bool_t test_1173;
									       {	/* ./Ieee/equiv.scm 5508 */
										  obj_t aux_1178;
										  obj_t aux_1174;
										  aux_1178 =
										     (obj_t) (to_505);
										  {	/* ./Llib/struct.scm 1457 */
										     obj_t aux_1175;
										     aux_1175 =
											CAR(coercer_507);
										     aux_1174 =
											STRUCT_REF(aux_1175, ((long) 1));
										  }
										  test_1173 =
										     (aux_1174 == aux_1178);
									       }
									       if (test_1173)
										 {	/* Type/tenv.scm 86 */
										    aux_1170 =
										       CAR(coercer_507);
										 }
									       else
										 {	/* Type/tenv.scm 86 */
										    {
										       obj_t coercer_1182;
										       coercer_1182 =
											  CDR(coercer_507);
										       coercer_507 = coercer_1182;
										       goto loop_508;
										    }
										 }
									    }
								       }
								       test1269_501 =
									  CBOOL(aux_1170);
								    }
								 }
								 if (test1269_501)
								   {	/* Type/tenv.scm 97 */
								      test1265_498 = ((bool_t) 0);
								   }
								 else
								   {	/* Type/tenv.scm 97 */
								      test1265_498 = ((bool_t) 1);
								   }
							      }
							    else
							      {		/* Type/tenv.scm 96 */
								 test1265_498 = ((bool_t) 1);
							      }
							    if (test1265_498)
							      {		/* Type/tenv.scm 100 */
								 obj_t arg1267_499;
								 {	/* ./Ieee/pair-list.scm 5689 */
								    obj_t aux_1189;
								    {	/* Type/tenv.scm 100 */
								       type_bglt obj_819;
								       obj_819 =
									  (type_bglt) (old_486);
								       aux_1189 =
									  (((type_bglt) CREF(obj_819))->coerce_to_204);
								    }
								    arg1267_499 =
								       MAKE_PAIR(coercer_493, aux_1189);
								 }
								 {	/* Type/tenv.scm 98 */
								    type_bglt obj_822;
								    obj_822 =
								       (type_bglt) (old_486);
								    ((((type_bglt) CREF(obj_822))->coerce_to_204) = ((obj_t) arg1267_499), BUNSPEC);
								 }
							      }
							    else
							      {		/* Type/tenv.scm 96 */
								 BUNSPEC;
							      }
							 }
						      }
						   }
						}
						{
						   obj_t l1223_1195;
						   l1223_1195 =
						      CDR(l1223_489);
						   l1223_489 = l1223_1195;
						   goto lname1224_490;
						}
					     }
					   else
					     {	/* Type/tenv.scm 91 */
						aux_1159 = ((bool_t) 1);
					     }
					}
					return
					   BBOOL(aux_1159);
				     }
				  }
				else
				  {	/* Type/tenv.scm 122 */
				     FAILURE(string1394_type_env, string1397_type_env, id_462);
				  }
			     }
			   else
			     {	/* Type/tenv.scm 115 */
				put_hash__129___hash(new_460, _tenv__6_type_env);
				{	/* Type/tenv.scm 117 */
				   bool_t test1250_466;
				   test1250_466 =
				      is_a__118___object(new_460, tclass_object_class);
				   if (test1250_466)
				     {	/* Type/tenv.scm 117 */
					heap_add_class__147_object_class(
					   (tclass_bglt) (new_460));
					{	/* Type/tenv.scm 120 */
					   obj_t aux_1000;
					   {	/* Type/tenv.scm 121 */
					      obj_t obj2_794;
					      obj2_794 =
						 CELL_REF(remember_list_194_998);
					      aux_1000 =
						 MAKE_PAIR(new_460, obj2_794);
					   }
					   return
					      CELL_SET(remember_list_194_998, aux_1000);
					}
				     }
				   else
				     {	/* Type/tenv.scm 117 */
					return BUNSPEC;
				     }
				}
			     }
			}
		     }
		  }
	       }
	    }
	 }
      }
   }
}



/* get-tenv */
obj_t 
get_tenv_245_type_env()
{
   AN_OBJECT;
   {	/* Type/tenv.scm 159 */
      {		/* Type/tenv.scm 160 */
	 obj_t s_857;
	 s_857 = _tenv__6_type_env;
	 {	/* ./Llib/struct.scm 1463 */
	    obj_t aux_1210;
	    aux_1210 =
	       CNST_TABLE_REF(((long) 1));
	    STRUCT_SET(s_857, ((long) 2), aux_1210);
	 }
      }
      {		/* Type/tenv.scm 161 */
	 obj_t s_860;
	 s_860 = _tenv__6_type_env;
	 {	/* ./Llib/struct.scm 1463 */
	    obj_t aux_1213;
	    aux_1213 =
	       CNST_TABLE_REF(((long) 2));
	    STRUCT_SET(s_860, ((long) 3), aux_1213);
	 }
      }
      {		/* Type/tenv.scm 162 */
	 obj_t s_863;
	 s_863 = _tenv__6_type_env;
	 {	/* ./Llib/struct.scm 1463 */
	    obj_t aux_1216;
	    aux_1216 =
	       CNST_TABLE_REF(((long) 3));
	    STRUCT_SET(s_863, ((long) 5), aux_1216);
	 }
      }
      return _tenv__6_type_env;
   }
}



/* _get-tenv */
obj_t 
_get_tenv_246_type_env(obj_t env_1001)
{
   AN_OBJECT;
   {	/* Type/tenv.scm 159 */
      return
	 get_tenv_245_type_env();
   }
}



/* initialize-tenv! */
obj_t 
initialize_tenv__150_type_env()
{
   AN_OBJECT;
   {	/* Type/tenv.scm 168 */
      {		/* Type/tenv.scm 170 */
	 obj_t list1291_532;
	 {	/* Type/tenv.scm 170 */
	    obj_t aux_1220;
	    aux_1220 =
	       BINT(((long) 256));
	    list1291_532 =
	       MAKE_PAIR(aux_1220, BNIL);
	 }
	 return (
	    _tenv__6_type_env =
	    make_hash_table_174___hash(((long) 1024), get_hash_number_env_189_type_env, type_id_env_218_type_env, eq__env_189___r4_equivalence_6_2, list1291_532), BUNSPEC);
      }
   }
}



/* _initialize-tenv! */
obj_t 
_initialize_tenv__4_type_env(obj_t env_1002)
{
   AN_OBJECT;
   {	/* Type/tenv.scm 168 */
      return
	 initialize_tenv__150_type_env();
   }
}



/* find-type */
type_bglt 
find_type_26_type_env(obj_t id_22)
{
   AN_OBJECT;
   {	/* Type/tenv.scm 175 */
      {		/* Type/tenv.scm 176 */
	 obj_t type_533;
	 type_533 =
	    get_hash_29___hash(id_22, _tenv__6_type_env);
	 {	/* Type/tenv.scm 177 */
	    bool_t test1292_534;
	    test1292_534 =
	       is_a__118___object(type_533, type_type_type);
	    if (test1292_534)
	      {		/* Type/tenv.scm 177 */
		 return
		    (type_bglt) (type_533);
	      }
	    else
	      {		/* Type/tenv.scm 177 */
		 FAILURE(string1398_type_env, string1399_type_env, id_22);
	      }
	 }
      }
   }
}



/* _find-type */
obj_t 
_find_type_214_type_env(obj_t env_1003, obj_t id_1004)
{
   AN_OBJECT;
   {	/* Type/tenv.scm 175 */
      {		/* Type/tenv.scm 175 */
	 type_bglt aux_1230;
	 aux_1230 =
	    find_type_26_type_env(id_1004);
	 return
	    (obj_t) (aux_1230);
      }
   }
}



/* type-exists? */
bool_t 
type_exists__12_type_env(obj_t id_23)
{
   AN_OBJECT;
   {	/* Type/tenv.scm 186 */
      {		/* Type/tenv.scm 187 */
	 obj_t type_535;
	 type_535 =
	    get_hash_29___hash(id_23, _tenv__6_type_env);
	 {	/* Type/tenv.scm 188 */
	    bool_t test1293_536;
	    test1293_536 =
	       is_a__118___object(type_535, type_type_type);
	    if (test1293_536)
	      {		/* Type/tenv.scm 190 */
		 type_bglt obj_871;
		 obj_871 =
		    (type_bglt) (type_535);
		 return
		    (((type_bglt) CREF(obj_871))->init__47);
	      }
	    else
	      {		/* Type/tenv.scm 188 */
		 return ((bool_t) 0);
	      }
	 }
      }
   }
}



/* _type-exists? */
obj_t 
_type_exists__25_type_env(obj_t env_1005, obj_t id_1006)
{
   AN_OBJECT;
   {	/* Type/tenv.scm 186 */
      {		/* Type/tenv.scm 186 */
	 bool_t aux_1238;
	 aux_1238 =
	    type_exists__12_type_env(id_1006);
	 return
	    BBOOL(aux_1238);
      }
   }
}



/* bind-type! */
type_bglt 
bind_type__113_type_env(obj_t id_24, bool_t init__47_25, obj_t loc_26)
{
   AN_OBJECT;
   {	/* Type/tenv.scm 195 */
      {		/* Type/tenv.scm 196 */
	 obj_t type_537;
	 type_537 =
	    get_hash_29___hash(id_24, _tenv__6_type_env);
	 {	/* Type/tenv.scm 197 */
	    bool_t test1294_538;
	    test1294_538 =
	       is_a__118___object(type_537, type_type_type);
	    if (test1294_538)
	      {		/* Type/tenv.scm 198 */
		 bool_t test1295_539;
		 if (
		    CBOOL(_lib_mode__85_engine_param))
		   {	/* Type/tenv.scm 198 */
		      test1295_539 = ((bool_t) 0);
		   }
		 else
		   {	/* Type/tenv.scm 198 */
		      type_bglt obj_873;
		      obj_873 =
			 (type_bglt) (type_537);
		      test1295_539 =
			 (((type_bglt) CREF(obj_873))->init__47);
		   }
		 if (test1295_539)
		   {	/* Type/tenv.scm 199 */
		      obj_t arg1298_542;
		      arg1298_542 =
			 shape_tools_shape(type_537);
		      {		/* Type/tenv.scm 199 */
			 obj_t aux_1250;
			 aux_1250 =
			    user_error_151_tools_error(string1400_type_env, string1401_type_env, arg1298_542, BNIL);
			 return
			    (type_bglt) (aux_1250);
		      }
		   }
		 else
		   {	/* Type/tenv.scm 198 */
		      if (init__47_25)
			{	/* Type/tenv.scm 203 */
			   type_bglt obj_874;
			   obj_874 =
			      (type_bglt) (type_537);
			   ((((type_bglt) CREF(obj_874))->init__47) = ((bool_t) ((bool_t) 1)), BUNSPEC);
			}
		      else
			{	/* Type/tenv.scm 203 */
			   BUNSPEC;
			}
		      return
			 (type_bglt) (type_537);
		   }
	      }
	    else
	      {		/* Type/tenv.scm 206 */
		 type_bglt new_544;
		 {	/* Type/tenv.scm 206 */
		    obj_t arg1301_546;
		    arg1301_546 =
		       CNST_TABLE_REF(((long) 4));
		    {	/* Type/tenv.scm 206 */
		       type_bglt res1393_906;
		       {	/* Type/tenv.scm 206 */
			  obj_t __57_884;
			  obj_t alias_885;
			  obj_t pointed_to_by_76_886;
			  __57_884 = BTRUE;
			  alias_885 = BFALSE;
			  pointed_to_by_76_886 = BFALSE;
			  {	/* ./Type/type.scm 1159 */
			     type_bglt new1176_889;
			     new1176_889 =
				((type_bglt) BREF(GC_MALLOC(sizeof(struct type))));
			     {	/* ./Type/type.scm 1159 */
				long arg1359_890;
				arg1359_890 =
				   class_num_218___object(type_type_type);
				{	/* ./Type/type.scm 1159 */
				   obj_t obj_904;
				   obj_904 =
				      (obj_t) (new1176_889);
				   (((obj_t) CREF(obj_904))->header = MAKE_HEADER(arg1359_890, 0), BUNSPEC);
				}
			     }
			     {	/* ./Type/type.scm 1159 */
				object_bglt aux_1262;
				aux_1262 =
				   (object_bglt) (new1176_889);
				OBJECT_WIDENING_SET(aux_1262, alias_885);
			     }
			     ((((type_bglt) CREF(new1176_889))->id) = ((obj_t) id_24), BUNSPEC);
			     ((((type_bglt) CREF(new1176_889))->name) = ((obj_t) BUNSPEC), BUNSPEC);
			     ((((type_bglt) CREF(new1176_889))->size) = ((obj_t) BUNSPEC), BUNSPEC);
			     ((((type_bglt) CREF(new1176_889))->class) = ((obj_t) arg1301_546), BUNSPEC);
			     ((((type_bglt) CREF(new1176_889))->coerce_to_204) = ((obj_t) BNIL), BUNSPEC);
			     ((((type_bglt) CREF(new1176_889))->parents) = ((obj_t) BNIL), BUNSPEC);
			     ((((type_bglt) CREF(new1176_889))->init__47) = ((bool_t) init__47_25), BUNSPEC);
			     ((((type_bglt) CREF(new1176_889))->magic__53) = ((bool_t) ((bool_t) 0)), BUNSPEC);
			     ((((type_bglt) CREF(new1176_889))->__57) = ((obj_t) __57_884), BUNSPEC);
			     ((((type_bglt) CREF(new1176_889))->alias) = ((obj_t) alias_885), BUNSPEC);
			     ((((type_bglt) CREF(new1176_889))->pointed_to_by_76) = ((obj_t) pointed_to_by_76_886), BUNSPEC);
			     ((((type_bglt) CREF(new1176_889))->tvector) = ((obj_t) BUNSPEC), BUNSPEC);
			     ((((type_bglt) CREF(new1176_889))->location) = ((obj_t) loc_26), BUNSPEC);
			     res1393_906 = new1176_889;
			  }
		       }
		       new_544 = res1393_906;
		    }
		 }
		 put_hash__129___hash(
		    (obj_t) (new_544), _tenv__6_type_env);
		 return new_544;
	      }
	 }
      }
   }
}



/* use-type! */
type_bglt 
use_type__231_type_env(obj_t id_27, obj_t loc_28)
{
   AN_OBJECT;
   {	/* Type/tenv.scm 213 */
      {		/* Type/tenv.scm 215 */
	 obj_t type_551;
	 type_551 =
	    get_hash_29___hash(id_27, _tenv__6_type_env);
	 {	/* Type/tenv.scm 217 */
	    bool_t test1306_552;
	    test1306_552 =
	       is_a__118___object(type_551, type_type_type);
	    if (test1306_552)
	      {		/* Type/tenv.scm 217 */
		 return
		    (type_bglt) (type_551);
	      }
	    else
	      {		/* Type/tenv.scm 217 */
		 if (_types_already_checked___82_type_env)
		   {	/* Type/tenv.scm 219 */
		      {		/* Type/tenv.scm 220 */
			 obj_t aux_1285;
			 aux_1285 =
			    user_error_location_137_tools_error(loc_28, string1402_type_env, string1399_type_env, id_27, BNIL);
			 return
			    (type_bglt) (aux_1285);
		      }
		   }
		 else
		   {	/* Type/tenv.scm 219 */
		      return
			 bind_type__113_type_env(id_27, ((bool_t) 0), loc_28);
		   }
	      }
	 }
      }
   }
}



/* _use-type! */
obj_t 
_use_type__224_type_env(obj_t env_1007, obj_t id_1008, obj_t loc_1009)
{
   AN_OBJECT;
   {	/* Type/tenv.scm 213 */
      {		/* Type/tenv.scm 213 */
	 type_bglt aux_1289;
	 aux_1289 =
	    use_type__231_type_env(id_1008, loc_1009);
	 return
	    (obj_t) (aux_1289);
      }
   }
}



/* use-foreign-type! */
type_bglt 
use_foreign_type__12_type_env(obj_t id_29, obj_t loc_30)
{
   AN_OBJECT;
   {	/* Type/tenv.scm 234 */
      {		/* Type/tenv.scm 236 */
	 obj_t tid_554;
	 tid_554 =
	    parse_id_241_ast_ident(id_29, loc_30);
	 {	/* Type/tenv.scm 241 */
	    bool_t test1308_555;
	    {	/* Type/tenv.scm 241 */
	       obj_t arg1313_557;
	       type_bglt arg1314_558;
	       arg1313_557 =
		  CDR(tid_554);
	       arg1314_558 =
		  get_default_type_181_type_cache();
	       {	/* ./Ieee/equiv.scm 5508 */
		  obj_t aux_1295;
		  aux_1295 =
		     (obj_t) (arg1314_558);
		  test1308_555 =
		     (arg1313_557 == aux_1295);
	       }
	    }
	    if (test1308_555)
	      {		/* Type/tenv.scm 241 */
		 return
		    use_type__231_type_env(
		    CAR(tid_554), loc_30);
	      }
	    else
	      {		/* ./Ieee/pair-list.scm 5707 */
		 obj_t aux_1301;
		 aux_1301 =
		    CDR(tid_554);
		 return
		    (type_bglt) (aux_1301);
	      }
	 }
      }
   }
}



/* _use-foreign-type! */
obj_t 
_use_foreign_type__63_type_env(obj_t env_1010, obj_t id_1011, obj_t loc_1012)
{
   AN_OBJECT;
   {	/* Type/tenv.scm 234 */
      {		/* Type/tenv.scm 234 */
	 type_bglt aux_1304;
	 aux_1304 =
	    use_foreign_type__12_type_env(id_1011, loc_1012);
	 return
	    (obj_t) (aux_1304);
      }
   }
}



/* declare-type! */
type_bglt 
declare_type__118_type_env(obj_t id_31, obj_t name_32, obj_t class_33)
{
   AN_OBJECT;
   {	/* Type/tenv.scm 250 */
      {		/* Type/tenv.scm 252 */
	 bool_t test_1307;
	 {	/* Type/tenv.scm 252 */
	    obj_t aux_1308;
	    aux_1308 =
	       memq___r4_pairs_and_lists_6_3(class_33,
	       CNST_TABLE_REF(((long) 5)));
	    test_1307 =
	       CBOOL(aux_1308);
	 }
	 if (test_1307)
	   {	/* Type/tenv.scm 256 */
	      type_bglt type_560;
	      type_560 =
		 bind_type__113_type_env(id_31, ((bool_t) 1), BUNSPEC);
	      ((((type_bglt) CREF(type_560))->name) = ((obj_t) name_32), BUNSPEC);
	      {		/* Type/tenv.scm 258 */
		 obj_t arg1317_561;
		 arg1317_561 =
		    __in_name__215_type_tools(name_32);
		 ((((type_bglt) CREF(type_560))->__57) = ((obj_t) arg1317_561), BUNSPEC);
	      }
	      ((((type_bglt) CREF(type_560))->class) = ((obj_t) class_33), BUNSPEC);
	      return type_560;
	   }
	 else
	   {	/* Type/tenv.scm 253 */
	      obj_t aux_1317;
	      aux_1317 =
		 user_error_151_tools_error(string1403_type_env, string1404_type_env, class_33, BNIL);
	      return
		 (type_bglt) (aux_1317);
	   }
      }
   }
}



/* _declare-type! */
obj_t 
_declare_type__130_type_env(obj_t env_1013, obj_t id_1014, obj_t name_1015, obj_t class_1016)
{
   AN_OBJECT;
   {	/* Type/tenv.scm 250 */
      {		/* Type/tenv.scm 250 */
	 type_bglt aux_1320;
	 aux_1320 =
	    declare_type__118_type_env(id_1014, name_1015, class_1016);
	 return
	    (obj_t) (aux_1320);
      }
   }
}



/* declare-subtype! */
type_bglt 
declare_subtype__66_type_env(obj_t id_34, obj_t name_35, obj_t parents_36, obj_t class_37)
{
   AN_OBJECT;
   {	/* Type/tenv.scm 267 */
      if (
	 list__240___r4_pairs_and_lists_6_3(parents_36))
	{	/* Type/tenv.scm 269 */
	   BUNSPEC;
	}
      else
	{	/* Type/tenv.scm 269 */
	   {	/* Type/tenv.scm 269 */
	      obj_t arg1320_564;
	      obj_t arg1322_565;
	      arg1320_564 =
		 CNST_TABLE_REF(((long) 6));
	      arg1322_565 =
		 __EVMEANING_ADDRESS(parents_36);
	      define_primop_ref__105___evenv(arg1320_564, arg1322_565);
	   }
	   notify_assert_fail_37___eval(
	      CNST_TABLE_REF(((long) 7)),
	      CNST_TABLE_REF(((long) 8)),
	      CNST_TABLE_REF(((long) 9)));
	   unbind_primop__163___evenv(
	      CNST_TABLE_REF(((long) 6)));
	}
      {		/* Type/tenv.scm 270 */
	 type_bglt type_566;
	 obj_t parents_567;
	 type_566 =
	    bind_type__113_type_env(id_34, ((bool_t) 1), BUNSPEC);
	 if (
	    NULLP(parents_36))
	   {	/* Type/tenv.scm 271 */
	      parents_567 = BNIL;
	   }
	 else
	   {	/* Type/tenv.scm 271 */
	      obj_t head1230_571;
	      {		/* Type/tenv.scm 271 */
		 type_bglt arg1332_582;
		 arg1332_582 =
		    find_type_26_type_env(
		    CAR(parents_36));
		 {	/* ./Ieee/pair-list.scm 5689 */
		    obj_t aux_1339;
		    aux_1339 =
		       (obj_t) (arg1332_582);
		    head1230_571 =
		       MAKE_PAIR(aux_1339, BNIL);
		 }
	      }
	      {
		 obj_t l1228_572;
		 obj_t tail1231_573;
		 l1228_572 =
		    CDR(parents_36);
		 tail1231_573 = head1230_571;
	       lname1229_574:
		 if (
		    NULLP(l1228_572))
		   {	/* Type/tenv.scm 271 */
		      parents_567 = head1230_571;
		   }
		 else
		   {	/* Type/tenv.scm 271 */
		      obj_t newtail1232_577;
		      {		/* Type/tenv.scm 271 */
			 type_bglt arg1329_579;
			 arg1329_579 =
			    find_type_26_type_env(
			    CAR(l1228_572));
			 {	/* ./Ieee/pair-list.scm 5689 */
			    obj_t aux_1346;
			    aux_1346 =
			       (obj_t) (arg1329_579);
			    newtail1232_577 =
			       MAKE_PAIR(aux_1346, BNIL);
			 }
		      }
		      SET_CDR(tail1231_573, newtail1232_577);
		      {
			 obj_t tail1231_1352;
			 obj_t l1228_1350;
			 l1228_1350 =
			    CDR(l1228_572);
			 tail1231_1352 = newtail1232_577;
			 tail1231_573 = tail1231_1352;
			 l1228_572 = l1228_1350;
			 goto lname1229_574;
		      }
		   }
	      }
	   }
	 ((((type_bglt) CREF(type_566))->name) = ((obj_t) name_35), BUNSPEC);
	 {	/* Type/tenv.scm 273 */
	    obj_t arg1323_568;
	    arg1323_568 =
	       __in_name__215_type_tools(name_35);
	    ((((type_bglt) CREF(type_566))->__57) = ((obj_t) arg1323_568), BUNSPEC);
	 }
	 ((((type_bglt) CREF(type_566))->class) = ((obj_t) class_37), BUNSPEC);
	 ((((type_bglt) CREF(type_566))->parents) = ((obj_t) parents_567), BUNSPEC);
	 return type_566;
      }
   }
}



/* _declare-subtype! */
obj_t 
_declare_subtype__52_type_env(obj_t env_1017, obj_t id_1018, obj_t name_1019, obj_t parents_1020, obj_t class_1021)
{
   AN_OBJECT;
   {	/* Type/tenv.scm 267 */
      {		/* Type/tenv.scm 267 */
	 type_bglt aux_1359;
	 aux_1359 =
	    declare_subtype__66_type_env(id_1018, name_1019, parents_1020, class_1021);
	 return
	    (obj_t) (aux_1359);
      }
   }
}



/* declare-aliastype! */
type_bglt 
declare_aliastype__27_type_env(obj_t id_38, obj_t name_39, obj_t class_40, type_bglt alias_41)
{
   AN_OBJECT;
   {	/* Type/tenv.scm 281 */
      {		/* Type/tenv.scm 283 */
	 type_bglt type_939;
	 type_939 =
	    declare_type__118_type_env(id_38, name_39, class_40);
	 {	/* Type/tenv.scm 284 */
	    obj_t val1172_941;
	    val1172_941 =
	       (obj_t) (alias_41);
	    ((((type_bglt) CREF(type_939))->alias) = ((obj_t) val1172_941), BUNSPEC);
	 }
	 return type_939;
      }
   }
}



/* _declare-aliastype! */
obj_t 
_declare_aliastype__93_type_env(obj_t env_1022, obj_t id_1023, obj_t name_1024, obj_t class_1025, obj_t alias_1026)
{
   AN_OBJECT;
   {	/* Type/tenv.scm 281 */
      {		/* Type/tenv.scm 281 */
	 type_bglt aux_1365;
	 aux_1365 =
	    declare_aliastype__27_type_env(id_1023, name_1024, class_1025,
	    (type_bglt) (alias_1026));
	 return
	    (obj_t) (aux_1365);
      }
   }
}



/* for-each-type! */
obj_t 
for_each_type__69_type_env(obj_t proc_42)
{
   AN_OBJECT;
   {	/* Type/tenv.scm 290 */
      return
	 for_each_hash_105___hash(proc_42, _tenv__6_type_env);
   }
}



/* _for-each-type! */
obj_t 
_for_each_type__79_type_env(obj_t env_1027, obj_t proc_1028)
{
   AN_OBJECT;
   {	/* Type/tenv.scm 290 */
      return
	 for_each_type__69_type_env(proc_1028);
   }
}



/* uninitialized-types */
obj_t 
uninitialized_types_97_type_env()
{
   AN_OBJECT;
   {	/* Type/tenv.scm 298 */
      {		/* Type/tenv.scm 299 */
	 obj_t uninit_586;
	 uninit_586 =
	    MAKE_CELL(BNIL);
	 {	/* Type/tenv.scm 301 */
	    obj_t _anonymous_1336__10_1029;
	    _anonymous_1336__10_1029 =
	       make_fx_procedure(_anonymous_1336__10_type_env, ((long) 1), ((long) 1));
	    PROCEDURE_SET(_anonymous_1336__10_1029, ((long) 0), uninit_586);
	    for_each_hash_105___hash(_anonymous_1336__10_1029, _tenv__6_type_env);
	 }
	 return
	    CELL_REF(uninit_586);
      }
   }
}



/* <anonymous:1336> */
obj_t 
_anonymous_1336__10_type_env(obj_t env_1030, obj_t t_1032)
{
   AN_OBJECT;
   {	/* Type/tenv.scm 300 */
      {		/* Type/tenv.scm 301 */
	 obj_t uninit_1031;
	 uninit_1031 =
	    PROCEDURE_REF(env_1030, ((long) 0));
	 {
	    obj_t t_588;
	    t_588 = t_1032;
	    {	/* Type/tenv.scm 301 */
	       bool_t test_1375;
	       {	/* Type/tenv.scm 301 */
		  type_bglt obj_942;
		  obj_942 =
		     (type_bglt) (t_588);
		  test_1375 =
		     (((type_bglt) CREF(obj_942))->init__47);
	       }
	       if (test_1375)
		 {	/* Type/tenv.scm 301 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Type/tenv.scm 302 */
		    obj_t aux_1033;
		    {	/* Type/tenv.scm 302 */
		       obj_t obj2_944;
		       obj2_944 =
			  CELL_REF(uninit_1031);
		       aux_1033 =
			  MAKE_PAIR(t_588, obj2_944);
		    }
		    return
		       CELL_SET(uninit_1031, aux_1033);
		 }
	    }
	 }
      }
   }
}



/* check-types */
obj_t 
check_types_141_type_env()
{
   AN_OBJECT;
   {	/* Type/tenv.scm 319 */
      {		/* Type/tenv.scm 320 */
	 obj_t ut_592;
	 ut_592 =
	    uninitialized_types_97_type_env();
	 if (
	    PAIRP(ut_592))
	   {	/* Type/tenv.scm 322 */
	      bool_t test1339_594;
	      test1339_594 =
		 is_a__118___object(
		 CAR(ut_592), type_type_type);
	      if (test1339_594)
		{	/* Type/tenv.scm 323 */
		   obj_t arg1340_595;
		   obj_t arg1343_597;
		   {	/* Type/tenv.scm 323 */
		      type_bglt obj_949;
		      {		/* Type/tenv.scm 323 */
			 obj_t aux_1385;
			 aux_1385 =
			    CAR(ut_592);
			 obj_949 =
			    (type_bglt) (aux_1385);
		      }
		      arg1340_595 =
			 (((type_bglt) CREF(obj_949))->location);
		   }
		   arg1343_597 =
		      shape_tools_shape(ut_592);
		   return
		      user_error_location_137_tools_error(arg1340_595, _module__166_module_module, string1405_type_env, arg1343_597, BNIL);
		}
	      else
		{	/* Type/tenv.scm 327 */
		   obj_t arg1348_601;
		   arg1348_601 =
		      shape_tools_shape(ut_592);
		   {	/* Type/tenv.scm 327 */
		      obj_t proc_950;
		      proc_950 = _module__166_module_module;
		      FAILURE(proc_950, string1405_type_env, arg1348_601);
		   }
		}
	   }
	 else
	   {	/* Type/tenv.scm 321 */
	      return (
		 _types_already_checked___82_type_env = ((bool_t) 1), BUNSPEC);
	   }
      }
   }
}



/* _check-types */
obj_t 
_check_types_155_type_env(obj_t env_1034)
{
   AN_OBJECT;
   {	/* Type/tenv.scm 319 */
      return
	 check_types_141_type_env();
   }
}



/* sub-type? */
bool_t 
sub_type__174_type_env(type_bglt minor_43, type_bglt major_44)
{
   AN_OBJECT;
   {	/* Type/tenv.scm 337 */
      {		/* Type/tenv.scm 339 */
	 bool_t test_1394;
	 {	/* ./Ieee/equiv.scm 5508 */
	    obj_t aux_1397;
	    obj_t aux_1395;
	    aux_1397 =
	       (obj_t) (major_44);
	    aux_1395 =
	       (obj_t) (minor_43);
	    test_1394 =
	       (aux_1395 == aux_1397);
	 }
	 if (test_1394)
	   {	/* Type/tenv.scm 339 */
	      return ((bool_t) 1);
	   }
	 else
	   {	/* Type/tenv.scm 341 */
	      bool_t test_1400;
	      {		/* Type/tenv.scm 341 */
		 obj_t aux_1401;
		 aux_1401 =
		    memq___r4_pairs_and_lists_6_3(
		    (obj_t) (major_44),
		    (((type_bglt) CREF(minor_43))->parents));
		 test_1400 =
		    CBOOL(aux_1401);
	      }
	      if (test_1400)
		{	/* Type/tenv.scm 341 */
		   return ((bool_t) 1);
		}
	      else
		{	/* Type/tenv.scm 341 */
		   return ((bool_t) 0);
		}
	   }
      }
   }
}



/* _sub-type? */
obj_t 
_sub_type__69_type_env(obj_t env_1035, obj_t minor_1036, obj_t major_1037)
{
   AN_OBJECT;
   {	/* Type/tenv.scm 337 */
      {		/* Type/tenv.scm 337 */
	 bool_t aux_1406;
	 aux_1406 =
	    sub_type__174_type_env(
	    (type_bglt) (minor_1036),
	    (type_bglt) (major_1037));
	 return
	    BBOOL(aux_1406);
      }
   }
}



/* type-id */
obj_t 
type_id_229_type_env(type_bglt obj_142)
{
   AN_OBJECT;
   {	/* ./Type/type.scm 1161 */
      return
	 (((type_bglt) CREF(obj_142))->id);
   }
}



/* _type-id */
obj_t 
_type_id_65_type_env(obj_t env_986, obj_t obj_987)
{
   AN_OBJECT;
   {	/* ./Type/type.scm 1161 */
      return
	 type_id_229_type_env(
	 (type_bglt) (obj_987));
   }
}



/* method-init */
obj_t 
method_init_76_type_env()
{
   AN_OBJECT;
   {	/* Type/tenv.scm 14 */
      return BUNSPEC;
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_type_env()
{
   AN_OBJECT;
   {	/* Type/tenv.scm 14 */
      module_initialization_70_tools_trace(((long) 0), "TYPE_ENV");
      module_initialization_70_tools_shape(((long) 0), "TYPE_ENV");
      module_initialization_70_tools_error(((long) 0), "TYPE_ENV");
      module_initialization_70_ast_ident(((long) 0), "TYPE_ENV");
      module_initialization_70_ast_var(((long) 0), "TYPE_ENV");
      module_initialization_70_engine_param(((long) 0), "TYPE_ENV");
      module_initialization_70_module_module(((long) 0), "TYPE_ENV");
      module_initialization_70_type_type(((long) 0), "TYPE_ENV");
      module_initialization_70_type_tools(((long) 0), "TYPE_ENV");
      module_initialization_70_type_cache(((long) 0), "TYPE_ENV");
      return
	 module_initialization_70_object_class(((long) 0), "TYPE_ENV");
   }
}
