/*===========================================================================*/
/*   (Write/ast.scm)                                                         */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;


extern obj_t unwind_until__178___bexit(obj_t, obj_t);
extern char *number__string_214___r4_numbers_6_5(obj_t, obj_t);
extern obj_t _src_files__222_engine_param;
static obj_t method_init_76_write_ast();
extern obj_t current_output_port;
extern obj_t string_append(obj_t, obj_t);
extern obj_t exitd_top;
extern obj_t type_type_type;
extern obj_t write_scheme_comment_102_write_scheme(obj_t, obj_t);
static obj_t handling_function1457_write_ast(obj_t, obj_t, obj_t, obj_t);
static obj_t make_sfun_sinfo_243_write_ast(global_bglt);
extern bool_t is_a__118___object(obj_t, obj_t);
static obj_t atom__string_243_write_ast(obj_t);
extern obj_t module_initialization_70_write_ast(long, char *);
extern obj_t module_initialization_70_tools_speek(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_engine_pass(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_init_main(long, char *);
extern obj_t module_initialization_70_write_scheme(long, char *);
extern obj_t module_initialization_70_type_pptype(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_args(long, char *);
extern obj_t module_initialization_70___error(long, char *);
extern obj_t module_initialization_70___os(long, char *);
extern obj_t module_initialization_70___bexit(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___pp(long, char *);
extern obj_t module_initialization_70___r4_numbers_6_5(long, char *);
extern obj_t module_initialization_70___r4_numbers_6_5_fixnum(long, char *);
extern obj_t module_initialization_70___r4_strings_6_7(long, char *);
extern obj_t module_initialization_70___r4_control_features_6_9(long, char *);
extern obj_t module_initialization_70___r4_output_6_10_3(long, char *);
extern obj_t notify_error_43___error(obj_t, obj_t, obj_t);
extern obj_t write_ast_133_write_ast(obj_t);
static obj_t _anonymous_1461__212_write_ast(obj_t);
static obj_t _anonymous_1460__158_write_ast(obj_t);
extern obj_t exit_bigloo_229_init_main(obj_t);
extern obj_t display_2_122___r4_output_6_10_3(obj_t, obj_t);
static obj_t imported_modules_init_94_write_ast();
static obj_t rhandler1439_write_ast(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t string_downcase_77___r4_strings_6_7(obj_t);
extern obj_t _pp_case__242___pp;
extern obj_t _dest__217_engine_param;
static obj_t handler_write_ast(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t prefix___os(obj_t);
static obj_t library_modules_init_112_write_ast();
extern obj_t open_input_string(obj_t);
static obj_t _write_ast_58_write_ast(obj_t, obj_t);
extern char *integer__string_135___r4_numbers_6_5_fixnum(long, obj_t);
extern obj_t close_output_port(obj_t);
extern obj_t string_to_bstring(char *);
extern obj_t _case_sensitive__90_engine_param;
extern obj_t dynamic_wind_31___r4_control_features_6_9(obj_t, obj_t, obj_t);
extern obj_t shape_tools_shape(obj_t);
extern obj_t function_type__string_79_type_pptype(variable_bglt);
extern obj_t open_output_string();
extern obj_t pp___pp(obj_t, obj_t);
extern obj_t remove_error_handler__102___error();
extern obj_t read___reader(obj_t);
extern obj_t args_list__args__33_tools_args(obj_t, obj_t);
static obj_t escape_write_ast(obj_t, obj_t);
extern obj_t add_error_handler__155___error(obj_t, obj_t);
extern obj_t open_output_file(obj_t);
static obj_t require_initialization_114_write_ast = BUNSPEC;
extern obj_t write_scheme_file_header_174_write_scheme(obj_t, obj_t);
static obj_t body1440_write_ast(obj_t);
static obj_t cnst_init_137_write_ast();
extern obj_t _current_pass__25_engine_pass;
static obj_t __cnst[8];

DEFINE_STRING(string1655_write_ast, string1655_write_ast1660, "DEFINE DEFINE-METHOD SMFUN DEFINE-INLINE SIFUN DEFINE-GENERIC SGFUN LOWER ", 74);
DEFINE_STRING(string1654_write_ast, string1654_write_ast1661, "#unspecified", 12);
DEFINE_STRING(string1653_write_ast, string1653_write_ast1662, "#f", 2);
DEFINE_STRING(string1652_write_ast, string1652_write_ast1663, "#t", 2);
DEFINE_STRING(string1651_write_ast, string1651_write_ast1664, "[", 1);
DEFINE_STRING(string1649_write_ast, string1649_write_ast1665, "  occ: ", 7);
DEFINE_STRING(string1650_write_ast, string1650_write_ast1666, "  side-effect: ", 15);
DEFINE_STRING(string1648_write_ast, string1648_write_ast1667, "  rm: ", 6);
DEFINE_STRING(string1647_write_ast, string1647_write_ast1668, "  loc: ", 7);
DEFINE_STRING(string1646_write_ast, string1646_write_ast1669, "]", 1);
DEFINE_STRING(string1645_write_ast, string1645_write_ast1670, "", 0);
DEFINE_STRING(string1644_write_ast, string1644_write_ast1671, "  predicate-of: ", 16);
DEFINE_STRING(string1643_write_ast, string1643_write_ast1672, "The AST (", 9);
DEFINE_STRING(string1642_write_ast, string1642_write_ast1673, ")", 1);
DEFINE_STRING(string1641_write_ast, string1641_write_ast1674, "Can't open output file", 22);
DEFINE_STRING(string1639_write_ast, string1639_write_ast1675, ".ast", 4);
DEFINE_STRING(string1640_write_ast, string1640_write_ast1676, "write-ast", 9);
DEFINE_EXPORT_PROCEDURE(write_ast_env_248_write_ast, _write_ast_58_write_ast1677, _write_ast_58_write_ast, 0L, 1);



/* module-initialization */
obj_t 
module_initialization_70_write_ast(long checksum_1290, char *from_1291)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_write_ast))
	{
	   require_initialization_114_write_ast =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_write_ast();
	   cnst_init_137_write_ast();
	   imported_modules_init_94_write_ast();
	   method_init_76_write_ast();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_write_ast()
{
   AN_OBJECT;
   {	/* Write/ast.scm 14 */
      module_initialization_70___bexit(((long) 0), "WRITE_AST");
      module_initialization_70___r4_numbers_6_5(((long) 0), "WRITE_AST");
      module_initialization_70___object(((long) 0), "WRITE_AST");
      module_initialization_70___error(((long) 0), "WRITE_AST");
      module_initialization_70___r4_output_6_10_3(((long) 0), "WRITE_AST");
      module_initialization_70___r4_strings_6_7(((long) 0), "WRITE_AST");
      module_initialization_70___pp(((long) 0), "WRITE_AST");
      module_initialization_70___os(((long) 0), "WRITE_AST");
      module_initialization_70___r4_numbers_6_5_fixnum(((long) 0), "WRITE_AST");
      module_initialization_70___r4_control_features_6_9(((long) 0), "WRITE_AST");
      module_initialization_70___reader(((long) 0), "WRITE_AST");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_write_ast()
{
   AN_OBJECT;
   {	/* Write/ast.scm 14 */
      {		/* Write/ast.scm 14 */
	 obj_t cnst_port_138_1283;
	 cnst_port_138_1283 =
	    open_input_string(string1655_write_ast);
	 {
	    long i_1284;
	    i_1284 = ((long) 7);
	  loop_1285:
	    {	/* Write/ast.scm 14 */
	       bool_t test1656_1286;
	       test1656_1286 =
		  (i_1284 == ((long) -1));
	       if (test1656_1286)
		 {	/* Write/ast.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Write/ast.scm 14 */
		    {	/* Write/ast.scm 14 */
		       obj_t arg1657_1287;
		       {	/* Write/ast.scm 14 */
			  obj_t list1658_1288;
			  list1658_1288 =
			     MAKE_PAIR(cnst_port_138_1283, BNIL);
			  arg1657_1287 =
			     read___reader(list1658_1288);
		       }
		       CNST_TABLE_SET(i_1284, arg1657_1287);
		    }
		    {	/* Write/ast.scm 14 */
		       int aux_1289;
		       {	/* Write/ast.scm 14 */
			  long aux_1316;
			  aux_1316 =
			     (i_1284 - ((long) 1));
			  aux_1289 =
			     (int) (aux_1316);
		       }
		       {
			  long i_1319;
			  i_1319 =
			     (long) (aux_1289);
			  i_1284 = i_1319;
			  goto loop_1285;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* write-ast */
obj_t 
write_ast_133_write_ast(obj_t globals_1)
{
   AN_OBJECT;
   {	/* Write/ast.scm 28 */
      {		/* Write/ast.scm 31 */
	 obj_t output_name_205_698;
	 {	/* Write/ast.scm 31 */
	    bool_t test1506_781;
	    {	/* Write/ast.scm 31 */
	       obj_t obj_1169;
	       obj_1169 = _dest__217_engine_param;
	       test1506_781 =
		  STRINGP(obj_1169);
	    }
	    if (test1506_781)
	      {		/* Write/ast.scm 31 */
		 output_name_205_698 = _dest__217_engine_param;
	      }
	    else
	      {		/* Write/ast.scm 33 */
		 bool_t test1507_782;
		 {	/* Write/ast.scm 33 */
		    bool_t test1511_786;
		    {	/* Write/ast.scm 33 */
		       obj_t obj_1170;
		       obj_1170 = _src_files__222_engine_param;
		       test1511_786 =
			  PAIRP(obj_1170);
		    }
		    if (test1511_786)
		      {		/* Write/ast.scm 34 */
			 obj_t arg1512_787;
			 {	/* Write/ast.scm 34 */
			    obj_t pair_1171;
			    pair_1171 = _src_files__222_engine_param;
			    arg1512_787 =
			       CAR(pair_1171);
			 }
			 test1507_782 =
			    STRINGP(arg1512_787);
		      }
		    else
		      {		/* Write/ast.scm 33 */
			 test1507_782 = ((bool_t) 0);
		      }
		 }
		 if (test1507_782)
		   {	/* Write/ast.scm 35 */
		      obj_t arg1508_783;
		      {		/* Write/ast.scm 35 */
			 obj_t arg1510_785;
			 {	/* Write/ast.scm 35 */
			    obj_t pair_1173;
			    pair_1173 = _src_files__222_engine_param;
			    arg1510_785 =
			       CAR(pair_1173);
			 }
			 arg1508_783 =
			    prefix___os(arg1510_785);
		      }
		      output_name_205_698 =
			 string_append(arg1508_783, string1639_write_ast);
		   }
		 else
		   {	/* Write/ast.scm 33 */
		      output_name_205_698 = BFALSE;
		   }
	      }
	 }
	 {	/* Write/ast.scm 31 */
	    obj_t port_699;
	    if (
	       STRINGP(output_name_205_698))
	      {		/* Write/ast.scm 38 */
		 port_699 =
		    open_output_file(output_name_205_698);
	      }
	    else
	      {		/* Write/ast.scm 38 */
		 port_699 = current_output_port;
	      }
	    {	/* Write/ast.scm 38 */

	       if (
		  OUTPUT_PORTP(port_699))
		 {	/* Write/ast.scm 43 */
		    obj_t handler_1245;
		    handler_1245 =
		       make_fx_procedure(handler_write_ast, ((long) 4), ((long) 1));
		    PROCEDURE_SET(handler_1245, ((long) 0), port_699);
		    {	/* Write/ast.scm 47 */
		       obj_t armed1441_702;
		       obj_t handler1438_703;
		       armed1441_702 =
			  MAKE_CELL(BUNSPEC);
		       handler1438_703 =
			  MAKE_CELL(BUNSPEC);
		       {	/* Write/ast.scm 47 */
			  obj_t body1440_1241;
			  obj_t rhandler1439_1243;
			  body1440_1241 =
			     make_fx_procedure(body1440_write_ast, ((long) 0), ((long) 2));
			  rhandler1439_1243 =
			     make_fx_procedure(rhandler1439_write_ast, ((long) 4), ((long) 2));
			  PROCEDURE_SET(body1440_1241, ((long) 0), port_699);
			  PROCEDURE_SET(body1440_1241, ((long) 1), globals_1);
			  PROCEDURE_SET(rhandler1439_1243, ((long) 0), armed1441_702);
			  PROCEDURE_SET(rhandler1439_1243, ((long) 1), handler1438_703);
			  CELL_SET(handler1438_703, handler_1245);
			  CELL_SET(armed1441_702, BTRUE);
			  return
			     handling_function1457_write_ast(body1440_1241, rhandler1439_1243, handler1438_703, armed1441_702);
		       }
		    }
		 }
	       else
		 {	/* Write/ast.scm 41 */
		    FAILURE(string1640_write_ast, string1641_write_ast, output_name_205_698);
		 }
	    }
	 }
      }
   }
}



/* handling_function1457 */
obj_t 
handling_function1457_write_ast(obj_t body1440_1282, obj_t rhandler1439_1281, obj_t handler1438_1280, obj_t armed1441_1279)
{
   AN_OBJECT;
   {	/* Write/ast.scm 47 */
      jmp_buf jmpbuf;
      obj_t an_exit1449_707;
      if (SET_EXIT(an_exit1449_707))
	{
	   RESTORE_TRACE();
	   return
	      _exit_value_;
	}
      else
	{
	   an_exit1449_707 =
	      (obj_t) jmpbuf;
	   {	/* Write/ast.scm 47 */

	      PUSH_EXIT(an_exit1449_707, ((bool_t) 1));
	      {		/* Write/ast.scm 47 */
		 obj_t an_exitd1450_708;
		 an_exitd1450_708 = exitd_top;
		 {	/* Write/ast.scm 47 */
		    obj_t escape_1242;
		    escape_1242 =
		       make_fx_procedure(escape_write_ast, ((long) 1), ((long) 1));
		    PROCEDURE_SET(escape_1242, ((long) 0), an_exitd1450_708);
		    {	/* Write/ast.scm 47 */
		       obj_t res1452_711;
		       {	/* Write/ast.scm 47 */
			  obj_t _anonymous_1461__212_1240;
			  obj_t _anonymous_1460__158_1244;
			  _anonymous_1461__212_1240 =
			     make_fx_procedure(_anonymous_1461__212_write_ast, ((long) 0), ((long) 1));
			  _anonymous_1460__158_1244 =
			     make_fx_procedure(_anonymous_1460__158_write_ast, ((long) 0), ((long) 5));
			  PROCEDURE_SET(_anonymous_1461__212_1240, ((long) 0), armed1441_1279);
			  PROCEDURE_SET(_anonymous_1460__158_1244, ((long) 0), an_exitd1450_708);
			  PROCEDURE_SET(_anonymous_1460__158_1244, ((long) 1), armed1441_1279);
			  PROCEDURE_SET(_anonymous_1460__158_1244, ((long) 2), handler1438_1280);
			  PROCEDURE_SET(_anonymous_1460__158_1244, ((long) 3), rhandler1439_1281);
			  PROCEDURE_SET(_anonymous_1460__158_1244, ((long) 4), escape_1242);
			  res1452_711 =
			     dynamic_wind_31___r4_control_features_6_9(_anonymous_1460__158_1244, body1440_1282, _anonymous_1461__212_1240);
		       }
		       POP_EXIT();
		       return res1452_711;
		    }
		 }
	      }
	   }
	}
   }
}



/* _write-ast */
obj_t 
_write_ast_58_write_ast(obj_t env_1246, obj_t globals_1247)
{
   AN_OBJECT;
   {	/* Write/ast.scm 28 */
      return
	 write_ast_133_write_ast(globals_1247);
   }
}



/* <anonymous:1461> */
obj_t 
_anonymous_1461__212_write_ast(obj_t env_1248)
{
   AN_OBJECT;
   {	/* Write/ast.scm 47 */
      {		/* Write/ast.scm 47 */
	 obj_t armed1441_1249;
	 armed1441_1249 =
	    PROCEDURE_REF(env_1248, ((long) 0));
	 {

	    {	/* Write/ast.scm 47 */
	       bool_t test_1363;
	       {	/* Write/ast.scm 47 */
		  obj_t aux_1364;
		  aux_1364 =
		     CELL_REF(armed1441_1249);
		  test_1363 =
		     CBOOL(aux_1364);
	       }
	       if (test_1363)
		 {	/* Write/ast.scm 47 */
		    CELL_SET(armed1441_1249, BFALSE);
		    return
		       remove_error_handler__102___error();
		 }
	       else
		 {	/* Write/ast.scm 47 */
		    return BUNSPEC;
		 }
	    }
	 }
      }
   }
}



/* body1440 */
obj_t 
body1440_write_ast(obj_t env_1251)
{
   AN_OBJECT;
   {	/* Write/ast.scm 47 */
      {		/* Write/ast.scm 47 */
	 obj_t port_1252;
	 obj_t globals_1253;
	 port_1252 =
	    PROCEDURE_REF(env_1251, ((long) 0));
	 globals_1253 =
	    PROCEDURE_REF(env_1251, ((long) 1));
	 {

	    if (
	       CBOOL(_case_sensitive__90_engine_param))
	      {		/* Write/ast.scm 48 */
		 BUNSPEC;
	      }
	    else
	      {		/* Write/ast.scm 48 */
		 _pp_case__242___pp =
		    CNST_TABLE_REF(((long) 0));
	      }
	    {	/* Write/ast.scm 51 */
	       obj_t arg1464_724;
	       {	/* Write/ast.scm 51 */
		  obj_t arg1467_726;
		  arg1467_726 =
		     string_append(_current_pass__25_engine_pass, string1642_write_ast);
		  arg1464_724 =
		     string_append(string1643_write_ast, arg1467_726);
	       }
	       write_scheme_file_header_174_write_scheme(port_1252, arg1464_724);
	    }
	    {
	       obj_t l1442_727;
	       l1442_727 = globals_1253;
	     lname1443_728:
	       if (
		  PAIRP(l1442_727))
		 {	/* Write/ast.scm 54 */
		    {	/* Write/ast.scm 56 */
		       obj_t g_730;
		       g_730 =
			  CAR(l1442_727);
		       {	/* Write/ast.scm 56 */
			  value_bglt fun_731;
			  {	/* Write/ast.scm 56 */
			     global_bglt obj_1179;
			     obj_1179 =
				(global_bglt) (g_730);
			     fun_731 =
				(((global_bglt) CREF(obj_1179))->value);
			  }
			  {	/* Write/ast.scm 57 */
			     obj_t arg1469_732;
			     arg1469_732 =
				shape_tools_shape(g_730);
			     {	/* Write/ast.scm 57 */
				obj_t list1470_733;
				list1470_733 =
				   MAKE_PAIR(arg1469_732, BNIL);
				write_scheme_comment_102_write_scheme(port_1252, list1470_733);
			     }
			  }
			  {	/* Write/ast.scm 59 */
			     obj_t arg1471_734;
			     arg1471_734 =
				function_type__string_79_type_pptype(
				(variable_bglt) (g_730));
			     {	/* Write/ast.scm 58 */
				obj_t list1472_735;
				list1472_735 =
				   MAKE_PAIR(arg1471_734, BNIL);
				write_scheme_comment_102_write_scheme(port_1252, list1472_735);
			     }
			  }
			  {	/* Write/ast.scm 60 */
			     obj_t arg1473_736;
			     arg1473_736 =
				make_sfun_sinfo_243_write_ast(
				(global_bglt) (g_730));
			     {	/* Write/ast.scm 60 */
				obj_t list1474_737;
				list1474_737 =
				   MAKE_PAIR(arg1473_736, BNIL);
				write_scheme_comment_102_write_scheme(port_1252, list1474_737);
			     }
			  }
			  {	/* Write/ast.scm 61 */
			     obj_t arg1475_738;
			     {	/* Write/ast.scm 61 */
				obj_t arg1477_740;
				obj_t arg1478_741;
				{	/* Write/ast.scm 61 */
				   obj_t case_value_58_742;
				   {	/* Write/ast.scm 61 */
				      sfun_bglt obj_1180;
				      obj_1180 =
					 (sfun_bglt) (fun_731);
				      case_value_58_742 =
					 (((sfun_bglt) CREF(obj_1180))->class);
				   }
				   {	/* Write/ast.scm 61 */
				      bool_t test_1393;
				      {		/* ./Ieee/equiv.scm 5508 */
					 obj_t aux_1394;
					 aux_1394 =
					    CNST_TABLE_REF(((long) 1));
					 test_1393 =
					    (case_value_58_742 == aux_1394);
				      }
				      if (test_1393)
					{	/* Write/ast.scm 61 */
					   arg1477_740 =
					      CNST_TABLE_REF(((long) 2));
					}
				      else
					{	/* Write/ast.scm 61 */
					   bool_t test_1398;
					   {	/* ./Ieee/equiv.scm 5508 */
					      obj_t aux_1399;
					      aux_1399 =
						 CNST_TABLE_REF(((long) 3));
					      test_1398 =
						 (case_value_58_742 == aux_1399);
					   }
					   if (test_1398)
					     {	/* Write/ast.scm 61 */
						arg1477_740 =
						   CNST_TABLE_REF(((long) 4));
					     }
					   else
					     {	/* Write/ast.scm 61 */
						bool_t test_1403;
						{	/* ./Ieee/equiv.scm 5508 */
						   obj_t aux_1404;
						   aux_1404 =
						      CNST_TABLE_REF(((long) 5));
						   test_1403 =
						      (case_value_58_742 == aux_1404);
						}
						if (test_1403)
						  {	/* Write/ast.scm 61 */
						     arg1477_740 =
							CNST_TABLE_REF(((long) 6));
						  }
						else
						  {	/* Write/ast.scm 61 */
						     arg1477_740 =
							CNST_TABLE_REF(((long) 7));
						  }
					     }
					}
				   }
				}
				{	/* Write/ast.scm 70 */
				   obj_t arg1482_746;
				   obj_t arg1483_747;
				   {	/* Write/ast.scm 70 */
				      obj_t arg1484_748;
				      obj_t arg1485_749;
				      arg1484_748 =
					 shape_tools_shape(g_730);
				      {		/* Write/ast.scm 72 */
					 obj_t arg1486_750;
					 long arg1488_751;
					 {	/* Write/ast.scm 72 */
					    obj_t l1444_752;
					    {	/* Write/ast.scm 72 */
					       sfun_bglt obj_1187;
					       obj_1187 =
						  (sfun_bglt) (fun_731);
					       l1444_752 =
						  (((sfun_bglt) CREF(obj_1187))->args);
					    }
					    if (
					       NULLP(l1444_752))
					      {		/* Write/ast.scm 72 */
						 arg1486_750 = BNIL;
					      }
					    else
					      {		/* Write/ast.scm 72 */
						 obj_t head1446_754;
						 {	/* Write/ast.scm 72 */
						    obj_t arg1497_765;
						    arg1497_765 =
						       shape_tools_shape(
						       CAR(l1444_752));
						    head1446_754 =
						       MAKE_PAIR(arg1497_765, BNIL);
						 }
						 {
						    obj_t l1444_755;
						    obj_t tail1447_756;
						    l1444_755 =
						       CDR(l1444_752);
						    tail1447_756 = head1446_754;
						  lname1445_757:
						    if (
						       NULLP(l1444_755))
						      {		/* Write/ast.scm 72 */
							 arg1486_750 = head1446_754;
						      }
						    else
						      {		/* Write/ast.scm 72 */
							 obj_t newtail1448_760;
							 {	/* Write/ast.scm 72 */
							    obj_t arg1494_762;
							    arg1494_762 =
							       shape_tools_shape(
							       CAR(l1444_755));
							    newtail1448_760 =
							       MAKE_PAIR(arg1494_762, BNIL);
							 }
							 SET_CDR(tail1447_756, newtail1448_760);
							 {
							    obj_t tail1447_1425;
							    obj_t l1444_1423;
							    l1444_1423 =
							       CDR(l1444_755);
							    tail1447_1425 = newtail1448_760;
							    tail1447_756 = tail1447_1425;
							    l1444_755 = l1444_1423;
							    goto lname1445_757;
							 }
						      }
						 }
					      }
					 }
					 {	/* Write/ast.scm 73 */
					    sfun_bglt obj_1200;
					    obj_1200 =
					       (sfun_bglt) (fun_731);
					    arg1488_751 =
					       (((sfun_bglt) CREF(obj_1200))->arity);
					 }
					 arg1485_749 =
					    args_list__args__33_tools_args(arg1486_750,
					    BINT(arg1488_751));
				      }
				      arg1482_746 =
					 MAKE_PAIR(arg1484_748, arg1485_749);
				   }
				   {	/* Write/ast.scm 74 */
				      obj_t arg1500_768;
				      {		/* Write/ast.scm 74 */
					 obj_t aux_1432;
					 {	/* Write/ast.scm 74 */
					    sfun_bglt obj_1203;
					    obj_1203 =
					       (sfun_bglt) (fun_731);
					    aux_1432 =
					       (((sfun_bglt) CREF(obj_1203))->body);
					 }
					 arg1500_768 =
					    shape_tools_shape(aux_1432);
				      }
				      arg1483_747 =
					 MAKE_PAIR(arg1500_768, BNIL);
				   }
				   arg1478_741 =
				      MAKE_PAIR(arg1482_746, arg1483_747);
				}
				arg1475_738 =
				   MAKE_PAIR(arg1477_740, arg1478_741);
			     }
			     {	/* Write/ast.scm 61 */
				obj_t list1476_739;
				list1476_739 =
				   MAKE_PAIR(port_1252, BNIL);
				pp___pp(arg1475_738, list1476_739);
			     }
			  }
		       }
		    }
		    {
		       obj_t l1442_1441;
		       l1442_1441 =
			  CDR(l1442_727);
		       l1442_727 = l1442_1441;
		       goto lname1443_728;
		    }
		 }
	       else
		 {	/* Write/ast.scm 54 */
		    ((bool_t) 1);
		 }
	    }
	    return
	       close_output_port(port_1252);
	 }
      }
   }
}



/* <anonymous:1460> */
obj_t 
_anonymous_1460__158_write_ast(obj_t env_1254)
{
   AN_OBJECT;
   {	/* Write/ast.scm 47 */
      {		/* Write/ast.scm 47 */
	 obj_t rhandler1439_1258;
	 obj_t escape_1259;
	 rhandler1439_1258 =
	    PROCEDURE_REF(env_1254, ((long) 3));
	 escape_1259 =
	    PROCEDURE_REF(env_1254, ((long) 4));
	 {

	    return
	       add_error_handler__155___error(rhandler1439_1258, escape_1259);
	 }
      }
   }
}



/* escape */
obj_t 
escape_write_ast(obj_t env_1260, obj_t val1451_1262)
{
   AN_OBJECT;
   {	/* Write/ast.scm 47 */
      {		/* Write/ast.scm 47 */
	 obj_t an_exitd1450_1261;
	 an_exitd1450_1261 =
	    PROCEDURE_REF(env_1260, ((long) 0));
	 {
	    obj_t val1451_709;
	    val1451_709 = val1451_1262;
	    return
	       unwind_until__178___bexit(an_exitd1450_1261, val1451_709);
	 }
      }
   }
}



/* rhandler1439 */
obj_t 
rhandler1439_write_ast(obj_t env_1263, obj_t esc_1266, obj_t obj_1267, obj_t proc_1268, obj_t msg_1269)
{
   AN_OBJECT;
   {	/* Write/ast.scm 47 */
      {		/* Write/ast.scm 47 */
	 obj_t armed1441_1264;
	 obj_t handler1438_1265;
	 armed1441_1264 =
	    PROCEDURE_REF(env_1263, ((long) 0));
	 handler1438_1265 =
	    PROCEDURE_REF(env_1263, ((long) 1));
	 {
	    obj_t esc_718;
	    obj_t obj_719;
	    obj_t proc_720;
	    obj_t msg_721;
	    esc_718 = esc_1266;
	    obj_719 = obj_1267;
	    proc_720 = proc_1268;
	    msg_721 = msg_1269;
	    CELL_SET(armed1441_1264, BFALSE);
	    remove_error_handler__102___error();
	    {	/* Write/ast.scm 47 */
	       obj_t aux_1453;
	       aux_1453 =
		  CELL_REF(handler1438_1265);
	       return
		  PROCEDURE_ENTRY(aux_1453) (
		  CELL_REF(handler1438_1265), esc_718, obj_719, proc_720, msg_721, BEOA);
	    }
	 }
      }
   }
}



/* handler */
obj_t 
handler_write_ast(obj_t env_1271, obj_t escape_1273, obj_t proc_1274, obj_t mes_1275, obj_t obj_1276)
{
   AN_OBJECT;
   {	/* Write/ast.scm 43 */
      {		/* Write/ast.scm 43 */
	 obj_t port_1272;
	 port_1272 =
	    PROCEDURE_REF(env_1271, ((long) 0));
	 {
	    obj_t escape_774;
	    obj_t proc_775;
	    obj_t mes_776;
	    obj_t obj_777;
	    escape_774 = escape_1273;
	    proc_775 = proc_1274;
	    mes_776 = mes_1275;
	    obj_777 = obj_1276;
	    notify_error_43___error(proc_775, mes_776, obj_777);
	    close_output_port(port_1272);
	    return
	       exit_bigloo_229_init_main(
	       BINT(((long) -8)));
	 }
      }
   }
}



/* make-sfun-sinfo */
obj_t 
make_sfun_sinfo_243_write_ast(global_bglt g_2)
{
   AN_OBJECT;
   {	/* Write/ast.scm 83 */
      {		/* Write/ast.scm 106 */
	 value_bglt sfun_789;
	 sfun_789 =
	    (((global_bglt) CREF(g_2))->value);
	 {	/* Write/ast.scm 107 */
	    obj_t arg1514_791;
	    {	/* Write/ast.scm 108 */
	       obj_t arg1515_792;
	       obj_t arg1516_793;
	       if (
		  CBOOL(_case_sensitive__90_engine_param))
		 {	/* ./Ieee/symbol.scm 6021 */
		    obj_t aux_1462;
		    aux_1462 =
		       (((global_bglt) CREF(g_2))->import);
		    arg1515_792 =
		       SYMBOL_TO_STRING(aux_1462);
		 }
	       else
		 {	/* Write/ast.scm 110 */
		    obj_t arg1519_795;
		    {	/* ./Ieee/symbol.scm 6021 */
		       obj_t aux_1465;
		       aux_1465 =
			  (((global_bglt) CREF(g_2))->import);
		       arg1519_795 =
			  SYMBOL_TO_STRING(aux_1465);
		    }
		    arg1515_792 =
		       string_downcase_77___r4_strings_6_7(arg1519_795);
		 }
	       {	/* Write/ast.scm 107 */
		  obj_t arg1522_798;
		  {	/* Write/ast.scm 111 */
		     obj_t arg1523_799;
		     obj_t arg1525_800;
		     {	/* Write/ast.scm 111 */
			obj_t aux_1469;
			{	/* Write/ast.scm 111 */
			   sfun_bglt obj_1221;
			   obj_1221 =
			      (sfun_bglt) (sfun_789);
			   aux_1469 =
			      (((sfun_bglt) CREF(obj_1221))->side_effect__165);
			}
			arg1523_799 =
			   atom__string_243_write_ast(aux_1469);
		     }
		     {	/* Write/ast.scm 112 */
			obj_t arg1527_802;
			obj_t arg1528_803;
			{	/* Write/ast.scm 112 */
			   obj_t t_804;
			   {	/* Write/ast.scm 112 */
			      sfun_bglt obj_1222;
			      obj_1222 =
				 (sfun_bglt) (sfun_789);
			      t_804 =
				 (((sfun_bglt) CREF(obj_1222))->predicate_of_78);
			   }
			   {	/* Write/ast.scm 113 */
			      bool_t test1529_805;
			      test1529_805 =
				 is_a__118___object(t_804, type_type_type);
			      if (test1529_805)
				{	/* Write/ast.scm 114 */
				   obj_t arg1532_807;
				   {	/* Write/ast.scm 115 */
				      obj_t arg1533_808;
				      arg1533_808 =
					 shape_tools_shape(t_804);
				      arg1532_807 =
					 atom__string_243_write_ast(arg1533_808);
				   }
				   arg1527_802 =
				      string_append(string1644_write_ast, arg1532_807);
				}
			      else
				{	/* Write/ast.scm 113 */
				   arg1527_802 = string1645_write_ast;
				}
			   }
			}
			{	/* Write/ast.scm 107 */
			   obj_t arg1535_810;
			   {	/* Write/ast.scm 117 */
			      char *arg1536_811;
			      obj_t arg1537_812;
			      arg1536_811 =
				 integer__string_135___r4_numbers_6_5_fixnum(
				 (((global_bglt) CREF(g_2))->occurrence), BNIL);
			      {		/* Write/ast.scm 107 */
				 obj_t arg1543_816;
				 {	/* Write/ast.scm 118 */
				    obj_t arg1544_817;
				    obj_t arg1545_818;
				    arg1544_817 =
				       atom__string_243_write_ast(
				       (((global_bglt) CREF(g_2))->removable));
				    {	/* Write/ast.scm 107 */
				       obj_t arg1549_821;
				       {	/* Write/ast.scm 119 */
					  obj_t arg1550_822;
					  obj_t arg1551_823;
					  {	/* Write/ast.scm 119 */
					     obj_t p_824;
					     p_824 =
						open_output_string();
					     {	/* Write/ast.scm 120 */
						obj_t aux_1485;
						{	/* Write/ast.scm 120 */
						   sfun_bglt obj_1226;
						   obj_1226 =
						      (sfun_bglt) (sfun_789);
						   aux_1485 =
						      (((sfun_bglt) CREF(obj_1226))->loc);
						}
						display_2_122___r4_output_6_10_3(aux_1485, p_824);
					     }
					     arg1550_822 =
						close_output_port(p_824);
					  }
					  {	/* Write/ast.scm 107 */
					     obj_t aux_1490;
					     {	/* Write/ast.scm 107 */
						char *aux_1491;
						if (
						   (((global_bglt) CREF(g_2))->user__32))
						  {	/* Write/ast.scm 122 */
						     aux_1491 = "  user?: #t"
							;
						  }
						else
						  {	/* Write/ast.scm 122 */
						     aux_1491 = "  user?: #f"
							;
						  }
						aux_1490 =
						   string_to_bstring(aux_1491);
					     }
					     arg1551_823 =
						string_append(aux_1490, string1646_write_ast);
					  }
					  arg1549_821 =
					     string_append(arg1550_822, arg1551_823);
				       }
				       arg1545_818 =
					  string_append(string1647_write_ast, arg1549_821);
				    }
				    arg1543_816 =
				       string_append(arg1544_817, arg1545_818);
				 }
				 arg1537_812 =
				    string_append(string1648_write_ast, arg1543_816);
			      }
			      {		/* Write/ast.scm 107 */
				 obj_t aux_1500;
				 aux_1500 =
				    string_to_bstring(arg1536_811);
				 arg1535_810 =
				    string_append(aux_1500, arg1537_812);
			      }
			   }
			   arg1528_803 =
			      string_append(string1649_write_ast, arg1535_810);
			}
			arg1525_800 =
			   string_append(arg1527_802, arg1528_803);
		     }
		     arg1522_798 =
			string_append(arg1523_799, arg1525_800);
		  }
		  arg1516_793 =
		     string_append(string1650_write_ast, arg1522_798);
	       }
	       arg1514_791 =
		  string_append(arg1515_792, arg1516_793);
	    }
	    return
	       string_append(string1651_write_ast, arg1514_791);
	 }
      }
   }
}



/* atom->string */
obj_t 
atom__string_243_write_ast(obj_t atom_829)
{
   AN_OBJECT;
   {	/* Write/ast.scm 84 */
      {

	 {	/* Write/ast.scm 85 */
	    long aux1455_832;
	    if (
	       CNSTP(atom_829))
	      {		/* Write/ast.scm 85 */
		 aux1455_832 =
		    CCNST(atom_829);
	      }
	    else
	      {		/* Write/ast.scm 85 */
		 aux1455_832 = ((long) -1);
	      }
	    switch (aux1455_832)
	      {
	      case ((long) 2):

		 return string1652_write_ast;
		 break;
	      case ((long) 1):

		 return string1653_write_ast;
		 break;
	      case ((long) 3):

		 return string1654_write_ast;
		 break;
	      default:
		 if (
		    SYMBOLP(atom_829))
		   {	/* Write/ast.scm 94 */
		      if (
			 CBOOL(_case_sensitive__90_engine_param))
			{	/* Write/ast.scm 95 */
			   return
			      SYMBOL_TO_STRING(atom_829);
			}
		      else
			{	/* Write/ast.scm 97 */
			   obj_t arg1561_837;
			   arg1561_837 =
			      SYMBOL_TO_STRING(atom_829);
			   return
			      string_downcase_77___r4_strings_6_7(arg1561_837);
			}
		   }
		 else
		   {	/* Write/ast.scm 98 */
		      bool_t test_1519;
		      if (
			 INTEGERP(atom_829))
			{	/* ./Ieee/number.scm 6283 */
			   test_1519 = ((bool_t) 1)
			      ;
			}
		      else
			{	/* ./Ieee/number.scm 6283 */
			   test_1519 =
			      REALP(atom_829)
			      ;
			}
		      if (test_1519)
			{	/* Write/ast.scm 98 */
			   {	/* Write/ast.scm 99 */
			      char *aux_1523;
			      aux_1523 =
				 number__string_214___r4_numbers_6_5(atom_829, BNIL);
			      return
				 string_to_bstring(aux_1523);
			   }
			}
		      else
			{	/* Write/ast.scm 98 */
			   if (
			      STRINGP(atom_829))
			     {	/* Write/ast.scm 100 */
				return atom_829;
			     }
			   else
			     {	/* Write/ast.scm 100 */
				{	/* Write/ast.scm 103 */
				   obj_t p_841;
				   p_841 =
				      open_output_string();
				   display_2_122___r4_output_6_10_3(atom_829, p_841);
				   return
				      close_output_port(p_841);
				}
			     }
			}
		   }
	      }
	 }
      }
   }
}



/* method-init */
obj_t 
method_init_76_write_ast()
{
   AN_OBJECT;
   {	/* Write/ast.scm 14 */
      return BUNSPEC;
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_write_ast()
{
   AN_OBJECT;
   {	/* Write/ast.scm 14 */
      module_initialization_70_tools_speek(((long) 0), "WRITE_AST");
      module_initialization_70_tools_error(((long) 0), "WRITE_AST");
      module_initialization_70_engine_pass(((long) 0), "WRITE_AST");
      module_initialization_70_type_type(((long) 0), "WRITE_AST");
      module_initialization_70_ast_var(((long) 0), "WRITE_AST");
      module_initialization_70_ast_node(((long) 0), "WRITE_AST");
      module_initialization_70_engine_param(((long) 0), "WRITE_AST");
      module_initialization_70_init_main(((long) 0), "WRITE_AST");
      module_initialization_70_write_scheme(((long) 0), "WRITE_AST");
      module_initialization_70_type_pptype(((long) 0), "WRITE_AST");
      module_initialization_70_tools_shape(((long) 0), "WRITE_AST");
      return
	 module_initialization_70_tools_args(((long) 0), "WRITE_AST");
   }
}
