/*===========================================================================*/
/*   (Ast/node.scm)                                                          */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;


extern obj_t cast_arg_set__132_ast_node(cast_bglt, node_bglt);
static obj_t struct_object__object_setq1976_146_ast_node(obj_t, obj_t, obj_t);
static obj_t _make_jump_ex_it_55_ast_node(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t object__struct_funcall1986_102_ast_node(obj_t, obj_t);
extern obj_t set_ex_it_type_set__207_ast_node(set_ex_it_116_bglt, type_bglt);
extern obj_t let_fun_locals_set__199_ast_node(let_fun_218_bglt, obj_t);
static obj_t struct_object__object_node2024_88_ast_node(obj_t, obj_t, obj_t);
static obj_t method_init_76_ast_node();
static obj_t _jump_ex_it_exit_set__1_ast_node(obj_t, obj_t, obj_t);
obj_t make_box_202_ast_node = BUNSPEC;
static obj_t _cast_type_set__213_ast_node(obj_t, obj_t, obj_t);
static obj_t _jump_ex_it_loc_220_ast_node(obj_t, obj_t);
static obj_t _let_var_bindings_44_ast_node(obj_t, obj_t);
static obj_t _conditional_test_29_ast_node(obj_t, obj_t);
extern obj_t conditional_true_set__127_ast_node(conditional_bglt, node_bglt);
extern obj_t box_ref_loc_220_ast_node(box_ref_242_bglt);
extern node_bglt jump_ex_it_exit_9_ast_node(jump_ex_it_184_bglt);
static obj_t _pragma_key_set_2526_118_ast_node(obj_t, obj_t, obj_t);
static obj_t struct_object__object_sequence2000_234_ast_node(obj_t, obj_t, obj_t);
obj_t funcall_ast_node = BUNSPEC;
extern obj_t sequence_nodes_243_ast_node(sequence_bglt);
static obj_t _let_fun_side_effect__set__74_ast_node(obj_t, obj_t, obj_t);
static obj_t _closure_variable_249_ast_node(obj_t, obj_t);
static obj_t _var__148_ast_node(obj_t, obj_t);
extern app_bglt make_app_213_ast_node(obj_t, type_bglt, obj_t, obj_t, var_bglt, obj_t, obj_t);
extern bool_t box_set___31_ast_node(obj_t);
extern obj_t app_side_effect__set__78_ast_node(app_bglt, obj_t);
obj_t node_effect_213_ast_node = BUNSPEC;
static obj_t object__struct_select1962_38_ast_node(obj_t, obj_t);
static obj_t object__struct_pragma1982_170_ast_node(obj_t, obj_t);
extern obj_t box_ref_key_221_ast_node(box_ref_242_bglt);
static obj_t _pragma_type_set__65_ast_node(obj_t, obj_t, obj_t);
extern node_bglt jump_ex_it_value_145_ast_node(jump_ex_it_184_bglt);
static obj_t struct_object__object_cast1980_80_ast_node(obj_t, obj_t, obj_t);
extern obj_t funcall_args_151_ast_node(funcall_bglt);
extern obj_t set_ex_it_loc_71_ast_node(set_ex_it_116_bglt);
static obj_t struct_object__object_funcall1988_194_ast_node(obj_t, obj_t, obj_t);
obj_t fail_ast_node = BUNSPEC;
static obj_t _let_fun_side_effect__106_ast_node(obj_t, obj_t);
extern obj_t make_box_side_effect__set__123_ast_node(make_box_202_bglt, obj_t);
extern obj_t fail_type_set__42_ast_node(fail_bglt, type_bglt);
static obj_t _allocate_let_fun_123_ast_node(obj_t);
extern node_bglt allocate_node_189_ast_node();
static obj_t _app_ly_fun_32_ast_node(obj_t, obj_t);
extern node_bglt make_node_187_ast_node(obj_t, type_bglt);
obj_t box_ref_242_ast_node = BUNSPEC;
static obj_t _box_set__value_set__99_ast_node(obj_t, obj_t, obj_t);
static obj_t _let_var__141_ast_node(obj_t, obj_t);
extern type_bglt node_effect_type_0_ast_node(node_effect_213_bglt);
static obj_t struct_object__object_set_ex_it1952_191_ast_node(obj_t, obj_t, obj_t);
extern type_bglt cast_type_139_ast_node(cast_bglt);
extern set_ex_it_116_bglt make_set_ex_it_81_ast_node(obj_t, type_bglt, var_bglt, node_bglt);
extern obj_t node_effect_key_set__83_ast_node(node_effect_213_bglt, obj_t);
static obj_t _let_fun_body_240_ast_node(obj_t, obj_t);
static obj_t _let_var_bindings_set__204_ast_node(obj_t, obj_t, obj_t);
static obj_t _select_test_set__254_ast_node(obj_t, obj_t, obj_t);
extern obj_t select_side_effect__set__210_ast_node(select_bglt, obj_t);
obj_t sequence_ast_node = BUNSPEC;
static obj_t _box_ref_side_effect__222_ast_node(obj_t, obj_t);
obj_t let_var_6_ast_node = BUNSPEC;
static obj_t _fail__57_ast_node(obj_t, obj_t);
static obj_t struct_object__object_app1996_145_ast_node(obj_t, obj_t, obj_t);
static obj_t _pragma_side_effect__set__36_ast_node(obj_t, obj_t, obj_t);
obj_t var_ast_node = BUNSPEC;
static obj_t _let_fun_key_set_2520_62_ast_node(obj_t, obj_t, obj_t);
extern obj_t let_var_bindings_42_ast_node(let_var_6_bglt);
static obj_t _atom_value_84_ast_node(obj_t, obj_t);
extern node_bglt conditional_test_2_ast_node(conditional_bglt);
static obj_t _select_item_type_107_ast_node(obj_t, obj_t);
static obj_t _pragma_args_183_ast_node(obj_t, obj_t);
static obj_t _make_fail_191_ast_node(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t make_box_type_set__149_ast_node(make_box_202_bglt, type_bglt);
extern obj_t make_box_side_effect__247_ast_node(make_box_202_bglt);
static obj_t _allocate_make_box_168_ast_node(obj_t);
static obj_t _make_let_fun_151_ast_node(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t _allocate_pragma_246_ast_node(obj_t);
extern variable_bglt closure_variable_234_ast_node(closure_bglt);
extern obj_t conditional_loc_211_ast_node(conditional_bglt);
extern bool_t sequence__190_ast_node(obj_t);
static obj_t _conditional_false_set__13_ast_node(obj_t, obj_t, obj_t);
static obj_t _make_pragma_8_ast_node(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t _funcall_args_set__216_ast_node(obj_t, obj_t, obj_t);
obj_t closure_ast_node = BUNSPEC;
extern obj_t select_key_set__149_ast_node(select_bglt, obj_t);
extern bool_t let_var__167_ast_node(obj_t);
static obj_t _box_set__type_101_ast_node(obj_t, obj_t);
extern obj_t add_method__1___object(obj_t, obj_t, obj_t);
static obj_t object__struct_app1994_212_ast_node(obj_t, obj_t);
static obj_t _atom_value_set__174_ast_node(obj_t, obj_t, obj_t);
extern obj_t pragma_type_set__19_ast_node(pragma_bglt, type_bglt);
extern bool_t atom__231_ast_node(obj_t);
extern bool_t make_box__243_ast_node(obj_t);
static obj_t object__struct_conditional1970_196_ast_node(obj_t, obj_t);
obj_t pragma_ast_node = BUNSPEC;
extern obj_t conditional_key_55_ast_node(conditional_bglt);
static obj_t _box_ref_key_set_2514_229_ast_node(obj_t, obj_t, obj_t);
static obj_t _app_ly_arg_77_ast_node(obj_t, obj_t);
extern variable_bglt var_variable_114_ast_node(var_bglt);
static obj_t _setq_var_set__53_ast_node(obj_t, obj_t, obj_t);
static obj_t _app_ly__224_ast_node(obj_t, obj_t);
static obj_t _select_clauses_101_ast_node(obj_t, obj_t);
extern let_fun_218_bglt allocate_let_fun_35_ast_node();
static obj_t object__struct_jump_ex_it1946_107_ast_node(obj_t, obj_t);
extern make_box_202_bglt allocate_make_box_201_ast_node();
static obj_t _setq_value_set__101_ast_node(obj_t, obj_t, obj_t);
static obj_t _box_set__type_set__162_ast_node(obj_t, obj_t, obj_t);
static obj_t _conditional_test_set__114_ast_node(obj_t, obj_t, obj_t);
extern type_bglt let_var_type_128_ast_node(let_var_6_bglt);
obj_t set_ex_it_116_ast_node = BUNSPEC;
extern bool_t var__222_ast_node(obj_t);
static obj_t _app_fun_set__100_ast_node(obj_t, obj_t, obj_t);
static obj_t struct_object__object_atom2016_22_ast_node(obj_t, obj_t, obj_t);
static obj_t _app_ly_type_173_ast_node(obj_t, obj_t);
static obj_t _set_ex_it_body_118_ast_node(obj_t, obj_t);
extern obj_t funcall_args_set__108_ast_node(funcall_bglt, obj_t);
extern obj_t cast_type_set__214_ast_node(cast_bglt, type_bglt);
extern obj_t jump_ex_it_loc_88_ast_node(jump_ex_it_184_bglt);
static obj_t _app_loc_227_ast_node(obj_t, obj_t);
extern obj_t pragma_side_effect__84_ast_node(pragma_bglt);
static obj_t _set_ex_it__35_ast_node(obj_t, obj_t);
extern obj_t pragma_args_116_ast_node(pragma_bglt);
static obj_t _box_ref_key2515_204_ast_node(obj_t, obj_t);
extern make_box_202_bglt make_make_box_156_ast_node(obj_t, type_bglt, obj_t, obj_t, node_bglt);
extern app_ly_162_bglt allocate_app_ly_30_ast_node();
static obj_t _select_loc_214_ast_node(obj_t, obj_t);
static obj_t _jump_ex_it_exit_250_ast_node(obj_t, obj_t);
static obj_t struct_object__object_box_set_1936_112_ast_node(obj_t, obj_t, obj_t);
static obj_t object__struct_kwote2002_73_ast_node(obj_t, obj_t);
extern pragma_bglt make_pragma_155_ast_node(obj_t, type_bglt, obj_t, obj_t, obj_t, obj_t);
extern obj_t select_test_set__37_ast_node(select_bglt, node_bglt);
extern bool_t is_a__118___object(obj_t, obj_t);
static obj_t _sequence_type_56_ast_node(obj_t, obj_t);
static obj_t _closure_loc_244_ast_node(obj_t, obj_t);
static obj_t _pragma_loc_176_ast_node(obj_t, obj_t);
extern obj_t make_box_key_set__183_ast_node(make_box_202_bglt, obj_t);
static obj_t _funcall__161_ast_node(obj_t, obj_t);
extern obj_t app_type_set__90_ast_node(app_bglt, type_bglt);
static obj_t _allocate_sequence_156_ast_node(obj_t);
extern obj_t sequence_loc_124_ast_node(sequence_bglt);
extern type_bglt select_item_type_206_ast_node(select_bglt);
extern bool_t cast__213_ast_node(obj_t);
static obj_t _select_type_set__200_ast_node(obj_t, obj_t, obj_t);
static obj_t _box_set__var_set__202_ast_node(obj_t, obj_t, obj_t);
static obj_t _pragma_key2527_152_ast_node(obj_t, obj_t);
extern atom_bglt allocate_atom_199_ast_node();
static obj_t _sequence_side_effect__7_ast_node(obj_t, obj_t);
static obj_t _make_kwote_232_ast_node(obj_t, obj_t, obj_t, obj_t);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t let_fun_key_set__227_ast_node(let_fun_218_bglt, obj_t);
static obj_t _var_type_set__250_ast_node(obj_t, obj_t, obj_t);
extern atom_bglt make_atom_145_ast_node(obj_t, type_bglt, obj_t);
extern obj_t jump_ex_it_exit_set__84_ast_node(jump_ex_it_184_bglt, node_bglt);
extern cast_bglt allocate_cast_68_ast_node();
static obj_t _box_ref_var_set__55_ast_node(obj_t, obj_t, obj_t);
extern cast_bglt make_cast_147_ast_node(obj_t, type_bglt, node_bglt);
static obj_t _node_effect_key2533_45_ast_node(obj_t, obj_t);
static obj_t _funcall_strength_set__93_ast_node(obj_t, obj_t, obj_t);
static obj_t _let_fun_body_set__28_ast_node(obj_t, obj_t, obj_t);
static obj_t _fail_proc_set__112_ast_node(obj_t, obj_t, obj_t);
extern type_bglt app_ly_type_138_ast_node(app_ly_162_bglt);
static obj_t _let_var_removable__set__166_ast_node(obj_t, obj_t, obj_t);
extern obj_t pragma_side_effect__set__174_ast_node(pragma_bglt, obj_t);
extern obj_t sequence_key_75_ast_node(sequence_bglt);
extern obj_t app_ly_arg_set__254_ast_node(app_ly_162_bglt, node_bglt);
extern type_bglt atom_type_43_ast_node(atom_bglt);
static obj_t object__struct_fail1966_121_ast_node(obj_t, obj_t);
extern var_bglt box_set__var_177_ast_node(box_set__221_bglt);
extern obj_t jump_ex_it_value_set__158_ast_node(jump_ex_it_184_bglt, node_bglt);
static obj_t _allocate_fail_214_ast_node(obj_t);
static obj_t _app_args_set__105_ast_node(obj_t, obj_t, obj_t);
extern type_bglt make_box_type_89_ast_node(make_box_202_bglt);
extern sequence_bglt allocate_sequence_235_ast_node();
static obj_t object__struct_let_var1954_71_ast_node(obj_t, obj_t);
extern obj_t let_var_key_set__86_ast_node(let_var_6_bglt, obj_t);
extern bool_t app_ly__191_ast_node(obj_t);
extern type_bglt closure_type_101_ast_node(closure_bglt);
static obj_t _app_fun_176_ast_node(obj_t, obj_t);
extern bool_t funcall__35_ast_node(obj_t);
extern var_bglt allocate_var_186_ast_node();
extern obj_t box_set__var_set__52_ast_node(box_set__221_bglt, var_bglt);
extern obj_t closure_variable_set__129_ast_node(closure_bglt, variable_bglt);
extern type_bglt jump_ex_it_type_39_ast_node(jump_ex_it_184_bglt);
static obj_t _app_type_59_ast_node(obj_t, obj_t);
static obj_t _let_fun_type_set__36_ast_node(obj_t, obj_t, obj_t);
extern obj_t closure_loc_195_ast_node(closure_bglt);
static obj_t _setq_var_146_ast_node(obj_t, obj_t);
static obj_t _closure_type_set__114_ast_node(obj_t, obj_t, obj_t);
static obj_t _make_box_value_set__157_ast_node(obj_t, obj_t, obj_t);
static obj_t _sequence_key_set_2530_26_ast_node(obj_t, obj_t, obj_t);
static obj_t object__struct_let_fun1958_74_ast_node(obj_t, obj_t);
extern obj_t app_loc_208_ast_node(app_bglt);
extern sequence_bglt make_sequence_237_ast_node(obj_t, type_bglt, obj_t, obj_t, obj_t);
extern obj_t let_fun_side_effect__189_ast_node(let_fun_218_bglt);
extern obj_t let_fun_body_set__147_ast_node(let_fun_218_bglt, node_bglt);
static obj_t _allocate_jump_ex_it_189_ast_node(obj_t);
extern obj_t pragma_format_172_ast_node(pragma_bglt);
static obj_t _conditional_type_set__61_ast_node(obj_t, obj_t, obj_t);
extern obj_t box_set__value_set__195_ast_node(box_set__221_bglt, node_bglt);
static obj_t _funcall_args_191_ast_node(obj_t, obj_t);
static obj_t struct_object__object_node_effect2020_69_ast_node(obj_t, obj_t, obj_t);
extern setq_bglt allocate_setq_54_ast_node();
extern long class_num_218___object(obj_t);
extern setq_bglt make_setq_237_ast_node(obj_t, type_bglt, var_bglt, node_bglt);
static obj_t _fail_obj_36_ast_node(obj_t, obj_t);
extern obj_t let_var_side_effect__set__111_ast_node(let_var_6_bglt, obj_t);
static obj_t _conditional_loc_250_ast_node(obj_t, obj_t);
static obj_t _let_var_side_effect__128_ast_node(obj_t, obj_t);
static obj_t _box_ref_type_set__53_ast_node(obj_t, obj_t, obj_t);
static obj_t _fail_msg_237_ast_node(obj_t, obj_t);
static obj_t _setq__97_ast_node(obj_t, obj_t);
extern obj_t app_key_150_ast_node(app_bglt);
static obj_t struct_object__object_let_var1956_48_ast_node(obj_t, obj_t, obj_t);
static obj_t _app_stack_info_121_ast_node(obj_t, obj_t);
extern obj_t let_fun_type_set__1_ast_node(let_fun_218_bglt, type_bglt);
extern obj_t closure_type_set__162_ast_node(closure_bglt, type_bglt);
extern obj_t select_type_set__138_ast_node(select_bglt, type_bglt);
obj_t node_ast_node = BUNSPEC;
static obj_t _fail_msg_set__4_ast_node(obj_t, obj_t, obj_t);
static obj_t _fail_obj_set__94_ast_node(obj_t, obj_t, obj_t);
extern obj_t box_ref_key_set__192_ast_node(box_ref_242_bglt, obj_t);
extern obj_t box_ref_side_effect__200_ast_node(box_ref_242_bglt);
extern obj_t sequence_type_set__237_ast_node(sequence_bglt, type_bglt);
static obj_t _fail_loc_78_ast_node(obj_t, obj_t);
extern type_bglt app_type_114_ast_node(app_bglt);
extern obj_t select_clauses_248_ast_node(select_bglt);
extern bool_t node_effect__37_ast_node(obj_t);
extern var_bglt setq_var_152_ast_node(setq_bglt);
static obj_t struct_object__object_let_fun1960_153_ast_node(obj_t, obj_t, obj_t);
obj_t let_fun_218_ast_node = BUNSPEC;
static obj_t _allocate_set_ex_it_70_ast_node(obj_t);
static obj_t _jump_ex_it__165_ast_node(obj_t, obj_t);
extern node_bglt fail_proc_182_ast_node(fail_bglt);
extern obj_t box_ref_var_set__147_ast_node(box_ref_242_bglt, var_bglt);
static obj_t _kwote_value_210_ast_node(obj_t, obj_t);
static obj_t object__struct_setq1974_190_ast_node(obj_t, obj_t);
static obj_t _box_set___53_ast_node(obj_t, obj_t);
static obj_t _closure__33_ast_node(obj_t, obj_t);
extern node_bglt set_ex_it_body_246_ast_node(set_ex_it_116_bglt);
static obj_t _make_box_set__122_ast_node(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t box_ref_type_set__106_ast_node(box_ref_242_bglt, type_bglt);
static obj_t _funcall_fun_set__5_ast_node(obj_t, obj_t, obj_t);
extern type_bglt let_fun_type_250_ast_node(let_fun_218_bglt);
static obj_t _let_var_removable__112_ast_node(obj_t, obj_t);
static obj_t object__struct_node2022_9_ast_node(obj_t, obj_t);
static obj_t struct_object__object_make_box1944_160_ast_node(obj_t, obj_t, obj_t);
extern obj_t box_ref_side_effect__set__120_ast_node(box_ref_242_bglt, obj_t);
static obj_t imported_modules_init_94_ast_node();
static obj_t _let_var_key_set_2518_35_ast_node(obj_t, obj_t, obj_t);
static obj_t _set_ex_it_var_69_ast_node(obj_t, obj_t);
extern node_bglt fail_obj_122_ast_node(fail_bglt);
extern node_bglt fail_msg_210_ast_node(fail_bglt);
static obj_t object__struct_sequence1998_173_ast_node(obj_t, obj_t);
static obj_t _node_effect_side_effect__113_ast_node(obj_t, obj_t);
extern var_bglt app_fun_173_ast_node(app_bglt);
static obj_t _set_ex_it_var_set__39_ast_node(obj_t, obj_t, obj_t);
static obj_t _allocate_app_ly_138_ast_node(obj_t);
static obj_t _make_app_ly_198_ast_node(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t kwote_loc_85_ast_node(kwote_bglt);
static obj_t _make_node_181_ast_node(obj_t, obj_t, obj_t);
extern obj_t fail_loc_117_ast_node(fail_bglt);
static obj_t _select_side_effect__188_ast_node(obj_t, obj_t);
static obj_t object__struct_box_ref1938_31_ast_node(obj_t, obj_t);
static obj_t object__struct_cast1978_156_ast_node(obj_t, obj_t);
extern obj_t box_set__loc_237_ast_node(box_set__221_bglt);
static obj_t _var_variable_169_ast_node(obj_t, obj_t);
extern obj_t pragma_key_set__102_ast_node(pragma_bglt, obj_t);
obj_t app_ly_162_ast_node = BUNSPEC;
static obj_t _conditional_side_effect__set__126_ast_node(obj_t, obj_t, obj_t);
extern bool_t closure__53_ast_node(obj_t);
extern bool_t jump_ex_it__122_ast_node(obj_t);
static obj_t _app__141_ast_node(obj_t, obj_t);
extern bool_t node__79_ast_node(obj_t);
extern obj_t kwote_value_104_ast_node(kwote_bglt);
extern type_bglt kwote_type_217_ast_node(kwote_bglt);
static obj_t _cast_type_62_ast_node(obj_t, obj_t);
static obj_t _select_type_8_ast_node(obj_t, obj_t);
static obj_t _let_var_type_59_ast_node(obj_t, obj_t);
extern obj_t fail_proc_set__82_ast_node(fail_bglt, node_bglt);
static obj_t _funcall_loc_189_ast_node(obj_t, obj_t);
static obj_t _make_conditional_213_ast_node(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t _node_effect_key_set_2532_214_ast_node(obj_t, obj_t, obj_t);
extern type_bglt setq_type_225_ast_node(setq_bglt);
static obj_t _setq_loc_129_ast_node(obj_t, obj_t);
extern funcall_bglt make_funcall_190_ast_node(obj_t, type_bglt, node_bglt, obj_t, obj_t);
static obj_t _conditional_false_30_ast_node(obj_t, obj_t);
static obj_t _node_loc_236_ast_node(obj_t, obj_t);
static obj_t _app_ly_arg_set__63_ast_node(obj_t, obj_t, obj_t);
extern obj_t let_fun_side_effect__set__106_ast_node(let_fun_218_bglt, obj_t);
extern obj_t let_var_bindings_set__143_ast_node(let_var_6_bglt, obj_t);
obj_t app_ast_node = BUNSPEC;
static obj_t struct_object__object_var2012_86_ast_node(obj_t, obj_t, obj_t);
static obj_t _node_effect_side_effect__set__197_ast_node(obj_t, obj_t, obj_t);
static obj_t _jump_ex_it_type_set__106_ast_node(obj_t, obj_t, obj_t);
static obj_t library_modules_init_112_ast_node();
static obj_t _sequence__76_ast_node(obj_t, obj_t);
extern app_ly_162_bglt make_app_ly_64_ast_node(obj_t, type_bglt, node_bglt, node_bglt);
extern type_bglt node_type_175_ast_node(node_bglt);
static obj_t _cast_arg_set__200_ast_node(obj_t, obj_t, obj_t);
extern bool_t kwote__251_ast_node(obj_t);
extern type_bglt funcall_type_93_ast_node(funcall_bglt);
static obj_t _select_key_set_2522_16_ast_node(obj_t, obj_t, obj_t);
extern obj_t funcall_fun_set__22_ast_node(funcall_bglt, node_bglt);
static obj_t struct_object__object_box_ref1940_82_ast_node(obj_t, obj_t, obj_t);
static obj_t _jump_ex_it_type_189_ast_node(obj_t, obj_t);
static obj_t _var_variable_set__30_ast_node(obj_t, obj_t, obj_t);
static obj_t _sequence_side_effect__set__178_ast_node(obj_t, obj_t, obj_t);
static obj_t _sequence_loc_75_ast_node(obj_t, obj_t);
static obj_t _atom_type_set__37_ast_node(obj_t, obj_t, obj_t);
extern obj_t make_struct(obj_t, long, obj_t);
extern type_bglt fail_type_93_ast_node(fail_bglt);
static obj_t _setq_type_set__95_ast_node(obj_t, obj_t, obj_t);
static obj_t _make_box__204_ast_node(obj_t, obj_t);
extern node_bglt conditional_false_181_ast_node(conditional_bglt);
static obj_t _conditional_side_effect__178_ast_node(obj_t, obj_t);
extern obj_t app_ly_fun_set__208_ast_node(app_ly_162_bglt, node_bglt);
static obj_t _let_fun__236_ast_node(obj_t, obj_t);
static obj_t struct_object__object_kwote2004_147_ast_node(obj_t, obj_t, obj_t);
static obj_t object__struct_var2010_190_ast_node(obj_t, obj_t);
extern box_ref_242_bglt make_box_ref_158_ast_node(obj_t, type_bglt, obj_t, obj_t, var_bglt);
extern type_bglt select_type_6_ast_node(select_bglt);
extern bool_t conditional__146_ast_node(obj_t);
static obj_t _cast_loc_222_ast_node(obj_t, obj_t);
static obj_t _select_key2523_45_ast_node(obj_t, obj_t);
extern obj_t setq_loc_177_ast_node(setq_bglt);
obj_t atom_ast_node = BUNSPEC;
extern obj_t node_loc_29_ast_node(node_bglt);
extern obj_t funcall_loc_117_ast_node(funcall_bglt);
static obj_t _funcall_strength_15_ast_node(obj_t, obj_t);
extern obj_t app_stack_info_87_ast_node(app_bglt);
obj_t cast_ast_node = BUNSPEC;
extern obj_t make_box_value_set__112_ast_node(make_box_202_bglt, node_bglt);
static obj_t toplevel_init_63_ast_node();
static obj_t _pragma_args_set__242_ast_node(obj_t, obj_t, obj_t);
static obj_t _make_var_226_ast_node(obj_t, obj_t, obj_t, obj_t);
static obj_t _var_loc_47_ast_node(obj_t, obj_t);
static obj_t _box_set__var_27_ast_node(obj_t, obj_t);
extern obj_t var_variable_set__90_ast_node(var_bglt, variable_bglt);
static obj_t _make_node_effect_168_ast_node(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t _allocate_conditional_184_ast_node(obj_t);
extern obj_t conditional_test_set__179_ast_node(conditional_bglt, node_bglt);
extern let_var_6_bglt make_let_var_217_ast_node(obj_t, type_bglt, obj_t, obj_t, obj_t, node_bglt, bool_t);
extern jump_ex_it_184_bglt allocate_jump_ex_it_22_ast_node();
extern type_bglt box_ref_type_189_ast_node(box_ref_242_bglt);
static obj_t _funcall_fun_245_ast_node(obj_t, obj_t);
static obj_t _closure_type_29_ast_node(obj_t, obj_t);
extern node_bglt setq_value_119_ast_node(setq_bglt);
extern obj_t node_effect_side_effect__249_ast_node(node_effect_213_bglt);
static obj_t _pragma__23_ast_node(obj_t, obj_t);
static obj_t _allocate_var_93_ast_node(obj_t);
static obj_t _set_ex_it_loc_117_ast_node(obj_t, obj_t);
static obj_t _node_effect_type_set__143_ast_node(obj_t, obj_t, obj_t);
extern obj_t create_vector(long);
static obj_t _app_side_effect__128_ast_node(obj_t, obj_t);
obj_t jump_ex_it_184_ast_node = BUNSPEC;
static obj_t _pragma_type_23_ast_node(obj_t, obj_t);
extern obj_t open_input_string(obj_t);
obj_t kwote_ast_node = BUNSPEC;
extern conditional_bglt make_conditional_43_ast_node(obj_t, type_bglt, obj_t, obj_t, node_bglt, node_bglt, node_bglt);
static obj_t _app_stack_info_set__56_ast_node(obj_t, obj_t, obj_t);
extern select_bglt allocate_select_194_ast_node();
static obj_t _allocate_node_227_ast_node(obj_t);
static obj_t object__struct_atom2014_251_ast_node(obj_t, obj_t);
static obj_t _conditional_key_set_2524_40_ast_node(obj_t, obj_t, obj_t);
static obj_t _kwote__112_ast_node(obj_t, obj_t);
extern obj_t let_var_side_effect__154_ast_node(let_var_6_bglt);
extern bool_t let_fun__0_ast_node(obj_t);
extern closure_bglt make_closure_70_ast_node(obj_t, type_bglt, variable_bglt);
static obj_t _var_type_212_ast_node(obj_t, obj_t);
extern node_bglt let_var_body_232_ast_node(let_var_6_bglt);
static obj_t _conditional_true_set__236_ast_node(obj_t, obj_t, obj_t);
static obj_t _app_key2529_134_ast_node(obj_t, obj_t);
static obj_t _atom__186_ast_node(obj_t, obj_t);
extern obj_t node_effect_loc_61_ast_node(node_effect_213_bglt);
static obj_t _conditional_type_95_ast_node(obj_t, obj_t);
extern obj_t cast_loc_174_ast_node(cast_bglt);
static obj_t _funcall_type_set__146_ast_node(obj_t, obj_t, obj_t);
extern type_bglt box_set__type_38_ast_node(box_set__221_bglt);
static obj_t _let_var_body_set__128_ast_node(obj_t, obj_t, obj_t);
static obj_t _let_fun_locals_153_ast_node(obj_t, obj_t);
static obj_t _make_atom_226_ast_node(obj_t, obj_t, obj_t, obj_t);
static obj_t _app_side_effect__set__107_ast_node(obj_t, obj_t, obj_t);
extern obj_t conditional_false_set__184_ast_node(conditional_bglt, node_bglt);
extern bool_t app__230_ast_node(obj_t);
obj_t setq_ast_node = BUNSPEC;
extern var_bglt make_var_69_ast_node(obj_t, type_bglt, variable_bglt);
static obj_t _make_cast_224_ast_node(obj_t, obj_t, obj_t, obj_t);
static obj_t _let_fun_key2521_19_ast_node(obj_t, obj_t);
extern obj_t app_ly_loc_83_ast_node(app_ly_162_bglt);
extern obj_t make_box_loc_202_ast_node(make_box_202_bglt);
extern obj_t setq_var_set__217_ast_node(setq_bglt, var_bglt);
extern obj_t sequence_side_effect__144_ast_node(sequence_bglt);
static obj_t object__struct_box_set_1934_10_ast_node(obj_t, obj_t);
static obj_t _select__4_ast_node(obj_t, obj_t);
static obj_t _app_key_set_2528_13_ast_node(obj_t, obj_t, obj_t);
static obj_t _atom_type_184_ast_node(obj_t, obj_t);
obj_t box_set__221_ast_node = BUNSPEC;
extern obj_t node_effect_key_249_ast_node(node_effect_213_bglt);
extern bool_t fail__35_ast_node(obj_t);
static obj_t _make_box_type_set__195_ast_node(obj_t, obj_t, obj_t);
extern node_bglt funcall_fun_37_ast_node(funcall_bglt);
extern obj_t funcall_strength_set__57_ast_node(funcall_bglt, obj_t);
extern obj_t box_set__type_set__0_ast_node(box_set__221_bglt, type_bglt);
static obj_t _let_var_type_set__8_ast_node(obj_t, obj_t, obj_t);
static obj_t _node_effect__62_ast_node(obj_t, obj_t);
static obj_t object__struct_node_effect2018_126_ast_node(obj_t, obj_t);
static obj_t struct_object__object_app_ly1992_166_ast_node(obj_t, obj_t, obj_t);
static obj_t _allocate_node_effect_20_ast_node(obj_t);
static obj_t _box_set__value_125_ast_node(obj_t, obj_t);
extern obj_t kwote_type_set__119_ast_node(kwote_bglt, type_bglt);
extern obj_t object___object;
extern type_bglt pragma_type_32_ast_node(pragma_bglt);
extern obj_t funcall_strength_157_ast_node(funcall_bglt);
extern obj_t funcall_type_set__42_ast_node(funcall_bglt, type_bglt);
extern obj_t let_var_body_set__15_ast_node(let_var_6_bglt, node_bglt);
extern obj_t make_box_key_223_ast_node(make_box_202_bglt);
static obj_t _make_box_value_94_ast_node(obj_t, obj_t);
static obj_t _atom_loc_188_ast_node(obj_t, obj_t);
static obj_t _let_fun_type_63_ast_node(obj_t, obj_t);
extern type_bglt var_type_150_ast_node(var_bglt);
extern obj_t pragma_args_set__199_ast_node(pragma_bglt, obj_t);
extern obj_t var_loc_140_ast_node(var_bglt);
extern app_bglt allocate_app_15_ast_node();
extern node_effect_213_bglt make_node_effect_87_ast_node(obj_t, type_bglt, obj_t, obj_t);
extern obj_t app_key_set__45_ast_node(app_bglt, obj_t);
extern type_bglt sequence_type_18_ast_node(sequence_bglt);
static obj_t _allocate_funcall_93_ast_node(obj_t);
static obj_t _allocate_kwote_245_ast_node(obj_t);
static obj_t _cast__220_ast_node(obj_t, obj_t);
extern bool_t pragma__55_ast_node(obj_t);
static obj_t _set_ex_it_body_set__11_ast_node(obj_t, obj_t, obj_t);
extern obj_t select_side_effect__205_ast_node(select_bglt);
extern obj_t conditional_side_effect__145_ast_node(conditional_bglt);
extern obj_t app_side_effect__179_ast_node(app_bglt);
static obj_t _make_setq_227_ast_node(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t let_var_type_set__107_ast_node(let_var_6_bglt, type_bglt);
extern obj_t conditional_type_set__131_ast_node(conditional_bglt, type_bglt);
extern obj_t register_class__225___object(obj_t, obj_t, obj_t, long, obj_t, obj_t, obj_t);
extern obj_t var_type_set__45_ast_node(var_bglt, type_bglt);
static obj_t _node_type_set__147_ast_node(obj_t, obj_t, obj_t);
extern obj_t atom_type_set__253_ast_node(atom_bglt, type_bglt);
extern obj_t setq_type_set__224_ast_node(setq_bglt, type_bglt);
extern type_bglt conditional_type_236_ast_node(conditional_bglt);
extern obj_t let_var_removable__set__39_ast_node(let_var_6_bglt, bool_t);
static obj_t _box_set__loc_195_ast_node(obj_t, obj_t);
static obj_t _set_ex_it_type_set__42_ast_node(obj_t, obj_t, obj_t);
static obj_t _let_fun_locals_set__222_ast_node(obj_t, obj_t, obj_t);
extern obj_t conditional_key_set__247_ast_node(conditional_bglt, obj_t);
extern node_bglt app_ly_fun_107_ast_node(app_ly_162_bglt);
static obj_t _make_box_side_effect__32_ast_node(obj_t, obj_t);
static obj_t _make_make_box_207_ast_node(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t _conditional_true_164_ast_node(obj_t, obj_t);
static obj_t _app_ly_fun_set__19_ast_node(obj_t, obj_t, obj_t);
extern obj_t atom_loc_1_ast_node(atom_bglt);
static obj_t _fail_proc_197_ast_node(obj_t, obj_t);
extern fail_bglt allocate_fail_46_ast_node();
extern obj_t app_args_set__223_ast_node(app_bglt, obj_t);
static obj_t _box_ref_var_228_ast_node(obj_t, obj_t);
static obj_t _allocate_box_ref_230_ast_node(obj_t);
extern fail_bglt make_fail_231_ast_node(obj_t, type_bglt, node_bglt, node_bglt, node_bglt);
static obj_t _cast_arg_8_ast_node(obj_t, obj_t);
static obj_t object__struct_closure2006_234_ast_node(obj_t, obj_t);
static obj_t _make_funcall_77_ast_node(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t jump_ex_it_type_set__142_ast_node(jump_ex_it_184_bglt, type_bglt);
static obj_t _app_type_set__8_ast_node(obj_t, obj_t, obj_t);
extern bool_t select__208_ast_node(obj_t);
static obj_t object__struct_app_ly1990_206_ast_node(obj_t, obj_t);
extern obj_t conditional_side_effect__set__158_ast_node(conditional_bglt, obj_t);
static obj_t _set_ex_it_type_93_ast_node(obj_t, obj_t);
static obj_t _let_var_loc_227_ast_node(obj_t, obj_t);
extern jump_ex_it_184_bglt make_jump_ex_it_21_ast_node(obj_t, type_bglt, node_bglt, node_bglt);
static obj_t object_init_111_ast_node();
static obj_t _box_ref__132_ast_node(obj_t, obj_t);
static obj_t _allocate_box_set__43_ast_node(obj_t);
extern obj_t sequence_side_effect__set__38_ast_node(sequence_bglt, obj_t);
static obj_t _app_ly_type_set__26_ast_node(obj_t, obj_t, obj_t);
static obj_t _allocate_atom_130_ast_node(obj_t);
static obj_t _make_box_side_effect__set__19_ast_node(obj_t, obj_t, obj_t);
static obj_t _kwote_type_169_ast_node(obj_t, obj_t);
static obj_t _allocate_let_var_179_ast_node(obj_t);
static obj_t _funcall_type_115_ast_node(obj_t, obj_t);
static obj_t _let_fun_loc_14_ast_node(obj_t, obj_t);
extern obj_t atom_value_177_ast_node(atom_bglt);
static obj_t _allocate_cast_146_ast_node(obj_t);
static obj_t _make_box_key_set_2516_65_ast_node(obj_t, obj_t, obj_t);
static obj_t _kwote_loc_102_ast_node(obj_t, obj_t);
static obj_t _allocate_select_101_ast_node(obj_t);
extern obj_t node_effect_side_effect__set__83_ast_node(node_effect_213_bglt, obj_t);
static obj_t struct_object__object_jump_ex_it1948_231_ast_node(obj_t, obj_t, obj_t);
extern funcall_bglt allocate_funcall_80_ast_node();
extern obj_t sequence_key_set__139_ast_node(sequence_bglt, obj_t);
static obj_t _make_select_83_ast_node(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t _sequence_key2531_88_ast_node(obj_t, obj_t);
static obj_t _sequence_nodes_186_ast_node(obj_t, obj_t);
extern obj_t let_fun_locals_116_ast_node(let_fun_218_bglt);
static obj_t _make_box_type_123_ast_node(obj_t, obj_t);
extern node_bglt let_fun_body_141_ast_node(let_fun_218_bglt);
static obj_t _allocate_closure_68_ast_node(obj_t);
static obj_t _make_box_ref_87_ast_node(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t struct_object__object_closure2008_247_ast_node(obj_t, obj_t, obj_t);
static obj_t _node_effect_loc_51_ast_node(obj_t, obj_t);
static obj_t object__struct_make_box1942_94_ast_node(obj_t, obj_t);
extern node_bglt cast_arg_174_ast_node(cast_bglt);
static obj_t _conditional__140_ast_node(obj_t, obj_t);
extern obj_t fail_msg_set__47_ast_node(fail_bglt, node_bglt);
extern box_set__221_bglt allocate_box_set__237_ast_node();
extern var_bglt box_ref_var_141_ast_node(box_ref_242_bglt);
extern conditional_bglt allocate_conditional_174_ast_node();
extern obj_t fail_obj_set__117_ast_node(fail_bglt, node_bglt);
static obj_t struct_object__object_conditional1972_48_ast_node(obj_t, obj_t, obj_t);
static obj_t _app_args_203_ast_node(obj_t, obj_t);
obj_t select_ast_node = BUNSPEC;
static obj_t _setq_type_40_ast_node(obj_t, obj_t);
extern obj_t app_stack_info_set__168_ast_node(app_bglt, obj_t);
extern node_bglt app_ly_arg_131_ast_node(app_ly_162_bglt);
extern let_fun_218_bglt make_let_fun_154_ast_node(obj_t, type_bglt, obj_t, obj_t, obj_t, node_bglt);
extern bool_t box_ref__165_ast_node(obj_t);
extern obj_t let_var_loc_249_ast_node(let_var_6_bglt);
static obj_t _select_test_131_ast_node(obj_t, obj_t);
static obj_t _make_sequence_119_ast_node(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern set_ex_it_116_bglt allocate_set_ex_it_57_ast_node();
static obj_t _make_let_var_42_ast_node(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t read___reader(obj_t);
static obj_t _box_ref_type_146_ast_node(obj_t, obj_t);
static obj_t _pragma_format_55_ast_node(obj_t, obj_t);
static obj_t _fail_type_set__134_ast_node(obj_t, obj_t, obj_t);
extern box_set__221_bglt make_box_set__226_ast_node(obj_t, type_bglt, var_bglt, node_bglt);
extern node_bglt conditional_true_226_ast_node(conditional_bglt);
static obj_t _let_var_key2519_62_ast_node(obj_t, obj_t);
extern node_bglt box_set__value_123_ast_node(box_set__221_bglt);
static obj_t _let_var_side_effect__set__107_ast_node(obj_t, obj_t, obj_t);
static obj_t _allocate_setq_253_ast_node(obj_t);
extern box_ref_242_bglt allocate_box_ref_100_ast_node();
extern bool_t let_var_removable__69_ast_node(let_var_6_bglt);
static obj_t struct_object__object_fail1968_208_ast_node(obj_t, obj_t, obj_t);
extern obj_t let_fun_loc_207_ast_node(let_fun_218_bglt);
extern bool_t set_ex_it__46_ast_node(obj_t);
extern node_bglt make_box_value_197_ast_node(make_box_202_bglt);
static obj_t _kwote_type_set__30_ast_node(obj_t, obj_t, obj_t);
extern var_bglt set_ex_it_var_31_ast_node(set_ex_it_116_bglt);
static obj_t _node_type_141_ast_node(obj_t, obj_t);
extern obj_t let_var_key_52_ast_node(let_var_6_bglt);
extern bool_t setq__41_ast_node(obj_t);
extern obj_t select_loc_168_ast_node(select_bglt);
static obj_t _make_closure_27_ast_node(obj_t, obj_t, obj_t, obj_t);
static obj_t _let_var_body_5_ast_node(obj_t, obj_t);
extern obj_t set_ex_it_var_set__67_ast_node(set_ex_it_116_bglt, var_bglt);
extern select_bglt make_select_245_ast_node(obj_t, type_bglt, obj_t, obj_t, node_bglt, obj_t, type_bglt);
static obj_t _conditional_key2525_224_ast_node(obj_t, obj_t);
static obj_t _jump_ex_it_value_set__227_ast_node(obj_t, obj_t, obj_t);
extern kwote_bglt allocate_kwote_110_ast_node();
static obj_t _make_set_ex_it_124_ast_node(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t _fail_type_21_ast_node(obj_t, obj_t);
static obj_t _sequence_type_set__27_ast_node(obj_t, obj_t, obj_t);
static obj_t _setq_value_242_ast_node(obj_t, obj_t);
extern obj_t app_ly_type_set__172_ast_node(app_ly_162_bglt, type_bglt);
extern obj_t pragma_loc_254_ast_node(pragma_bglt);
extern let_var_6_bglt allocate_let_var_32_ast_node();
extern obj_t app_fun_set__26_ast_node(app_bglt, var_bglt);
extern obj_t let_fun_key_253_ast_node(let_fun_218_bglt);
extern obj_t app_args_229_ast_node(app_bglt);
static obj_t _closure_variable_set__83_ast_node(obj_t, obj_t, obj_t);
static obj_t object__struct_set_ex_it1950_247_ast_node(obj_t, obj_t);
static obj_t _node__81_ast_node(obj_t, obj_t);
static obj_t _make_box_loc_121_ast_node(obj_t, obj_t);
static obj_t struct_object__object_select1964_220_ast_node(obj_t, obj_t, obj_t);
extern pragma_bglt allocate_pragma_110_ast_node();
extern obj_t node_type_set__235_ast_node(node_bglt, type_bglt);
static obj_t _box_ref_loc_56_ast_node(obj_t, obj_t);
static obj_t require_initialization_114_ast_node = BUNSPEC;
static obj_t _jump_ex_it_value_253_ast_node(obj_t, obj_t);
extern obj_t select_key_89_ast_node(select_bglt);
static obj_t _box_ref_side_effect__set__188_ast_node(obj_t, obj_t, obj_t);
obj_t conditional_ast_node = BUNSPEC;
extern node_effect_213_bglt allocate_node_effect_98_ast_node();
extern kwote_bglt make_kwote_191_ast_node(obj_t, type_bglt, obj_t);
extern node_bglt select_test_184_ast_node(select_bglt);
static obj_t struct_object__object_pragma1984_236_ast_node(obj_t, obj_t, obj_t);
extern closure_bglt allocate_closure_237_ast_node();
extern obj_t pragma_key_211_ast_node(pragma_bglt);
static obj_t _select_side_effect__set__140_ast_node(obj_t, obj_t, obj_t);
static obj_t _make_app_178_ast_node(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t _pragma_side_effect__63_ast_node(obj_t, obj_t);
extern obj_t atom_value_set__52_ast_node(atom_bglt, obj_t);
extern obj_t set_ex_it_body_set__234_ast_node(set_ex_it_116_bglt, node_bglt);
static obj_t cnst_init_137_ast_node();
static obj_t _app_ly_loc_181_ast_node(obj_t, obj_t);
static obj_t _node_effect_type_42_ast_node(obj_t, obj_t);
static obj_t _allocate_app_162_ast_node(obj_t);
extern type_bglt set_ex_it_type_46_ast_node(set_ex_it_116_bglt);
extern obj_t node_effect_type_set__91_ast_node(node_effect_213_bglt, type_bglt);
extern obj_t setq_value_set__233_ast_node(setq_bglt, node_bglt);
static obj_t _make_box_key2517_6_ast_node(obj_t, obj_t);
static obj_t __cnst[23];

DEFINE_EXPORT_PROCEDURE(funcall_type_env_209_ast_node, _funcall_type_115_ast_node2588, _funcall_type_115_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(setq__env_66_ast_node, _setq__97_ast_node2589, _setq__97_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(app_ly_fun_set__env_54_ast_node, _app_ly_fun_set__19_ast_node2590, _app_ly_fun_set__19_ast_node, 0L, 2);
DEFINE_EXPORT_PROCEDURE(let_var_type_env_80_ast_node, _let_var_type_59_ast_node2591, _let_var_type_59_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(conditional_loc_env_219_ast_node, _conditional_loc_250_ast_node2592, _conditional_loc_250_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(conditional_side_effect__env_1_ast_node, _conditional_side_effect__178_ast_node2593, _conditional_side_effect__178_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(setq_type_set__env_33_ast_node, _setq_type_set__95_ast_node2594, _setq_type_set__95_ast_node, 0L, 2);
DEFINE_EXPORT_PROCEDURE(app_ly_type_env_67_ast_node, _app_ly_type_173_ast_node2595, _app_ly_type_173_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(node__env_141_ast_node, _node__81_ast_node2596, _node__81_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_box_side_effect__set__env_229_ast_node, _make_box_side_effect__set__19_ast_node2597, _make_box_side_effect__set__19_ast_node, 0L, 2);
DEFINE_EXPORT_PROCEDURE(funcall__env_44_ast_node, _funcall__161_ast_node2598, _funcall__161_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(allocate_select_env_246_ast_node, _allocate_select_101_ast_node2599, _allocate_select_101_ast_node, 0L, 0);
DEFINE_EXPORT_PROCEDURE(node_effect_key_env_215_ast_node, _node_effect_key2533_45_ast_node2600, _node_effect_key2533_45_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(funcall_args_set__env_26_ast_node, _funcall_args_set__216_ast_node2601, _funcall_args_set__216_ast_node, 0L, 2);
DEFINE_EXPORT_PROCEDURE(allocate_pragma_env_128_ast_node, _allocate_pragma_246_ast_node2602, _allocate_pragma_246_ast_node, 0L, 0);
DEFINE_EXPORT_PROCEDURE(fail__env_44_ast_node, _fail__57_ast_node2603, _fail__57_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(jump_ex_it_exit_env_107_ast_node, _jump_ex_it_exit_250_ast_node2604, _jump_ex_it_exit_250_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(allocate_box_ref_env_189_ast_node, _allocate_box_ref_230_ast_node2605, _allocate_box_ref_230_ast_node, 0L, 0);
DEFINE_EXPORT_PROCEDURE(select__env_54_ast_node, _select__4_ast_node2606, _select__4_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(let_var_type_set__env_23_ast_node, _let_var_type_set__8_ast_node2607, _let_var_type_set__8_ast_node, 0L, 2);
DEFINE_EXPORT_PROCEDURE(allocate_jump_ex_it_env_98_ast_node, _allocate_jump_ex_it_189_ast_node2608, _allocate_jump_ex_it_189_ast_node, 0L, 0);
DEFINE_EXPORT_PROCEDURE(box_ref_type_env_214_ast_node, _box_ref_type_146_ast_node2609, _box_ref_type_146_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(box_set__type_set__env_93_ast_node, _box_set__type_set__162_ast_node2610, _box_set__type_set__162_ast_node, 0L, 2);
DEFINE_EXPORT_PROCEDURE(fail_proc_set__env_106_ast_node, _fail_proc_set__112_ast_node2611, _fail_proc_set__112_ast_node, 0L, 2);
DEFINE_EXPORT_PROCEDURE(let_var_bindings_env_73_ast_node, _let_var_bindings_44_ast_node2612, _let_var_bindings_44_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(allocate_atom_env_206_ast_node, _allocate_atom_130_ast_node2613, _allocate_atom_130_ast_node, 0L, 0);
DEFINE_EXPORT_PROCEDURE(app_ly_fun_env_23_ast_node, _app_ly_fun_32_ast_node2614, _app_ly_fun_32_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_box_value_env_244_ast_node, _make_box_value_94_ast_node2615, _make_box_value_94_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(var_variable_env_16_ast_node, _var_variable_169_ast_node2616, _var_variable_169_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(conditional_test_env_146_ast_node, _conditional_test_29_ast_node2617, _conditional_test_29_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(box_ref__env_35_ast_node, _box_ref__132_ast_node2618, _box_ref__132_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_atom_env_1_ast_node, _make_atom_226_ast_node2619, _make_atom_226_ast_node, 0L, 3);
DEFINE_EXPORT_PROCEDURE(make_closure_env_79_ast_node, _make_closure_27_ast_node2620, _make_closure_27_ast_node, 0L, 3);
DEFINE_EXPORT_PROCEDURE(app_stack_info_env_234_ast_node, _app_stack_info_121_ast_node2621, _app_stack_info_121_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sequence_nodes_env_20_ast_node, _sequence_nodes_186_ast_node2622, _sequence_nodes_186_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(app_fun_set__env_252_ast_node, _app_fun_set__100_ast_node2623, _app_fun_set__100_ast_node, 0L, 2);
DEFINE_EXPORT_PROCEDURE(cast_arg_env_156_ast_node, _cast_arg_8_ast_node2624, _cast_arg_8_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(box_set___env_99_ast_node, _box_set___53_ast_node2625, _box_set___53_ast_node, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2582_ast_node, struct_object__object_node2024_88_ast_node2626, struct_object__object_node2024_88_ast_node, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2581_ast_node, object__struct_node2022_9_ast_node2627, object__struct_node2022_9_ast_node, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2579_ast_node, object__struct_node_effect2018_126_ast_node2628, object__struct_node_effect2018_126_ast_node, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2580_ast_node, struct_object__object_node_effect2020_69_ast_node2629, struct_object__object_node_effect2020_69_ast_node, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2578_ast_node, struct_object__object_atom2016_22_ast_node2630, struct_object__object_atom2016_22_ast_node, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2577_ast_node, object__struct_atom2014_251_ast_node2631, object__struct_atom2014_251_ast_node, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2576_ast_node, struct_object__object_var2012_86_ast_node2632, struct_object__object_var2012_86_ast_node, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2575_ast_node, object__struct_var2010_190_ast_node2633, object__struct_var2010_190_ast_node, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2574_ast_node, struct_object__object_closure2008_247_ast_node2634, struct_object__object_closure2008_247_ast_node, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2573_ast_node, object__struct_closure2006_234_ast_node2635, object__struct_closure2006_234_ast_node, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2572_ast_node, struct_object__object_kwote2004_147_ast_node2636, struct_object__object_kwote2004_147_ast_node, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2571_ast_node, object__struct_kwote2002_73_ast_node2637, object__struct_kwote2002_73_ast_node, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2569_ast_node, object__struct_sequence1998_173_ast_node2638, object__struct_sequence1998_173_ast_node, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2570_ast_node, struct_object__object_sequence2000_234_ast_node2639, struct_object__object_sequence2000_234_ast_node, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2568_ast_node, struct_object__object_app1996_145_ast_node2640, struct_object__object_app1996_145_ast_node, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2567_ast_node, object__struct_app1994_212_ast_node2641, object__struct_app1994_212_ast_node, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2566_ast_node, struct_object__object_app_ly1992_166_ast_node2642, struct_object__object_app_ly1992_166_ast_node, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2565_ast_node, object__struct_app_ly1990_206_ast_node2643, object__struct_app_ly1990_206_ast_node, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2564_ast_node, struct_object__object_funcall1988_194_ast_node2644, struct_object__object_funcall1988_194_ast_node, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2563_ast_node, object__struct_funcall1986_102_ast_node2645, object__struct_funcall1986_102_ast_node, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2562_ast_node, struct_object__object_pragma1984_236_ast_node2646, struct_object__object_pragma1984_236_ast_node, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2561_ast_node, object__struct_pragma1982_170_ast_node2647, object__struct_pragma1982_170_ast_node, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2559_ast_node, object__struct_cast1978_156_ast_node2648, object__struct_cast1978_156_ast_node, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2560_ast_node, struct_object__object_cast1980_80_ast_node2649, struct_object__object_cast1980_80_ast_node, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2558_ast_node, struct_object__object_setq1976_146_ast_node2650, struct_object__object_setq1976_146_ast_node, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2557_ast_node, object__struct_setq1974_190_ast_node2651, object__struct_setq1974_190_ast_node, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2556_ast_node, struct_object__object_conditional1972_48_ast_node2652, struct_object__object_conditional1972_48_ast_node, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2555_ast_node, object__struct_conditional1970_196_ast_node2653, object__struct_conditional1970_196_ast_node, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2554_ast_node, struct_object__object_fail1968_208_ast_node2654, struct_object__object_fail1968_208_ast_node, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2553_ast_node, object__struct_fail1966_121_ast_node2655, object__struct_fail1966_121_ast_node, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2552_ast_node, struct_object__object_select1964_220_ast_node2656, struct_object__object_select1964_220_ast_node, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2551_ast_node, object__struct_select1962_38_ast_node2657, object__struct_select1962_38_ast_node, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2549_ast_node, object__struct_let_fun1958_74_ast_node2658, object__struct_let_fun1958_74_ast_node, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2550_ast_node, struct_object__object_let_fun1960_153_ast_node2659, struct_object__object_let_fun1960_153_ast_node, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2548_ast_node, struct_object__object_let_var1956_48_ast_node2660, struct_object__object_let_var1956_48_ast_node, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2547_ast_node, object__struct_let_var1954_71_ast_node2661, object__struct_let_var1954_71_ast_node, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2546_ast_node, struct_object__object_set_ex_it1952_191_ast_node2662, struct_object__object_set_ex_it1952_191_ast_node, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2545_ast_node, object__struct_set_ex_it1950_247_ast_node2663, object__struct_set_ex_it1950_247_ast_node, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2544_ast_node, struct_object__object_jump_ex_it1948_231_ast_node2664, struct_object__object_jump_ex_it1948_231_ast_node, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2543_ast_node, object__struct_jump_ex_it1946_107_ast_node2665, object__struct_jump_ex_it1946_107_ast_node, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2542_ast_node, struct_object__object_make_box1944_160_ast_node2666, struct_object__object_make_box1944_160_ast_node, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2541_ast_node, object__struct_make_box1942_94_ast_node2667, object__struct_make_box1942_94_ast_node, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2539_ast_node, object__struct_box_ref1938_31_ast_node2668, object__struct_box_ref1938_31_ast_node, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2540_ast_node, struct_object__object_box_ref1940_82_ast_node2669, struct_object__object_box_ref1940_82_ast_node, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2538_ast_node, struct_object__object_box_set_1936_112_ast_node2670, struct_object__object_box_set_1936_112_ast_node, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2537_ast_node, object__struct_box_set_1934_10_ast_node2671, object__struct_box_set_1934_10_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(var_type_set__env_125_ast_node, _var_type_set__250_ast_node2672, _var_type_set__250_ast_node, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pragma_type_env_250_ast_node, _pragma_type_23_ast_node2673, _pragma_type_23_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(node_effect_key_set__env_245_ast_node, _node_effect_key_set_2532_214_ast_node2674, _node_effect_key_set_2532_214_ast_node, 0L, 2);
DEFINE_EXPORT_PROCEDURE(funcall_args_env_101_ast_node, _funcall_args_191_ast_node2675, _funcall_args_191_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(box_set__loc_env_30_ast_node, _box_set__loc_195_ast_node2676, _box_set__loc_195_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(let_var_key_env_59_ast_node, _let_var_key2519_62_ast_node2677, _let_var_key2519_62_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(box_ref_var_env_232_ast_node, _box_ref_var_228_ast_node2678, _box_ref_var_228_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(let_var_body_set__env_27_ast_node, _let_var_body_set__128_ast_node2679, _let_var_body_set__128_ast_node, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pragma__env_231_ast_node, _pragma__23_ast_node2680, _pragma__23_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(let_var_key_set__env_138_ast_node, _let_var_key_set_2518_35_ast_node2681, _let_var_key_set_2518_35_ast_node, 0L, 2);
DEFINE_EXPORT_PROCEDURE(select_clauses_env_124_ast_node, _select_clauses_101_ast_node2682, _select_clauses_101_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(select_item_type_env_227_ast_node, _select_item_type_107_ast_node2683, _select_item_type_107_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(var__env_97_ast_node, _var__148_ast_node2684, _var__148_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(funcall_fun_set__env_98_ast_node, _funcall_fun_set__5_ast_node2685, _funcall_fun_set__5_ast_node, 0L, 2);
DEFINE_EXPORT_PROCEDURE(sequence__env_188_ast_node, _sequence__76_ast_node2686, _sequence__76_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(setq_var_env_114_ast_node, _setq_var_146_ast_node2687, _setq_var_146_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(app_key_env_9_ast_node, _app_key2529_134_ast_node2688, _app_key2529_134_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(set_ex_it_var_set__env_109_ast_node, _set_ex_it_var_set__39_ast_node2689, _set_ex_it_var_set__39_ast_node, 0L, 2);
DEFINE_EXPORT_PROCEDURE(sequence_key_set__env_116_ast_node, _sequence_key_set_2530_26_ast_node2690, _sequence_key_set_2530_26_ast_node, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_select_env_113_ast_node, _make_select_83_ast_node2691, _make_select_83_ast_node, 0L, 7);
DEFINE_EXPORT_PROCEDURE(closure_variable_set__env_10_ast_node, _closure_variable_set__83_ast_node2692, _closure_variable_set__83_ast_node, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_pragma_env_228_ast_node, _make_pragma_8_ast_node2693, _make_pragma_8_ast_node, 0L, 6);
DEFINE_EXPORT_PROCEDURE(allocate_kwote_env_128_ast_node, _allocate_kwote_245_ast_node2694, _allocate_kwote_245_ast_node, 0L, 0);
DEFINE_EXPORT_PROCEDURE(conditional__env_211_ast_node, _conditional__140_ast_node2695, _conditional__140_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(let_var_bindings_set__env_42_ast_node, _let_var_bindings_set__204_ast_node2696, _let_var_bindings_set__204_ast_node, 0L, 2);
DEFINE_EXPORT_PROCEDURE(app_ly_arg_set__env_85_ast_node, _app_ly_arg_set__63_ast_node2697, _app_ly_arg_set__63_ast_node, 0L, 2);
DEFINE_EXPORT_PROCEDURE(allocate_app_env_27_ast_node, _allocate_app_162_ast_node2698, _allocate_app_162_ast_node, 0L, 0);
DEFINE_EXPORT_PROCEDURE(select_key_env_133_ast_node, _select_key2523_45_ast_node2699, _select_key2523_45_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(app_stack_info_set__env_132_ast_node, _app_stack_info_set__56_ast_node2700, _app_stack_info_set__56_ast_node, 0L, 2);
DEFINE_EXPORT_PROCEDURE(let_fun_loc_env_8_ast_node, _let_fun_loc_14_ast_node2701, _let_fun_loc_14_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pragma_side_effect__env_72_ast_node, _pragma_side_effect__63_ast_node2702, _pragma_side_effect__63_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(app_ly_arg_env_91_ast_node, _app_ly_arg_77_ast_node2703, _app_ly_arg_77_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(select_key_set__env_191_ast_node, _select_key_set_2522_16_ast_node2704, _select_key_set_2522_16_ast_node, 0L, 2);
DEFINE_EXPORT_PROCEDURE(conditional_key_set__env_62_ast_node, _conditional_key_set_2524_40_ast_node2705, _conditional_key_set_2524_40_ast_node, 0L, 2);
DEFINE_EXPORT_PROCEDURE(app_key_set__env_125_ast_node, _app_key_set_2528_13_ast_node2706, _app_key_set_2528_13_ast_node, 0L, 2);
DEFINE_EXPORT_PROCEDURE(conditional_false_set__env_161_ast_node, _conditional_false_set__13_ast_node2707, _conditional_false_set__13_ast_node, 0L, 2);
DEFINE_EXPORT_PROCEDURE(allocate_node_effect_env_65_ast_node, _allocate_node_effect_20_ast_node2708, _allocate_node_effect_20_ast_node, 0L, 0);
DEFINE_EXPORT_PROCEDURE(let_fun_body_env_232_ast_node, _let_fun_body_240_ast_node2709, _let_fun_body_240_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pragma_loc_env_85_ast_node, _pragma_loc_176_ast_node2710, _pragma_loc_176_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_var_env_84_ast_node, _make_var_226_ast_node2711, _make_var_226_ast_node, 0L, 3);
DEFINE_EXPORT_PROCEDURE(conditional_side_effect__set__env_48_ast_node, _conditional_side_effect__set__126_ast_node2712, _conditional_side_effect__set__126_ast_node, 0L, 2);
extern obj_t struct_object__object_env_209___object;
DEFINE_EXPORT_PROCEDURE(let_var_body_env_96_ast_node, _let_var_body_5_ast_node2713, _let_var_body_5_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pragma_args_env_159_ast_node, _pragma_args_183_ast_node2714, _pragma_args_183_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(setq_type_env_118_ast_node, _setq_type_40_ast_node2715, _setq_type_40_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(set_ex_it_type_set__env_8_ast_node, _set_ex_it_type_set__42_ast_node2716, _set_ex_it_type_set__42_ast_node, 0L, 2);
DEFINE_EXPORT_PROCEDURE(atom_loc_env_233_ast_node, _atom_loc_188_ast_node2717, _atom_loc_188_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_sequence_env_30_ast_node, _make_sequence_119_ast_node2718, _make_sequence_119_ast_node, 0L, 5);
DEFINE_EXPORT_PROCEDURE(allocate_closure_env_30_ast_node, _allocate_closure_68_ast_node2719, _allocate_closure_68_ast_node, 0L, 0);
DEFINE_EXPORT_PROCEDURE(make_funcall_env_188_ast_node, _make_funcall_77_ast_node2720, _make_funcall_77_ast_node, 0L, 5);
DEFINE_EXPORT_PROCEDURE(make_box_side_effect__env_62_ast_node, _make_box_side_effect__32_ast_node2721, _make_box_side_effect__32_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sequence_type_set__env_30_ast_node, _sequence_type_set__27_ast_node2722, _sequence_type_set__27_ast_node, 0L, 2);
DEFINE_EXPORT_PROCEDURE(node_effect_loc_env_205_ast_node, _node_effect_loc_51_ast_node2723, _node_effect_loc_51_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pragma_type_set__env_102_ast_node, _pragma_type_set__65_ast_node2724, _pragma_type_set__65_ast_node, 0L, 2);
DEFINE_EXPORT_PROCEDURE(app_args_set__env_126_ast_node, _app_args_set__105_ast_node2725, _app_args_set__105_ast_node, 0L, 2);
DEFINE_EXPORT_PROCEDURE(app_type_env_16_ast_node, _app_type_59_ast_node2726, _app_type_59_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_conditional_env_37_ast_node, _make_conditional_213_ast_node2727, _make_conditional_213_ast_node, 0L, 7);
DEFINE_EXPORT_PROCEDURE(closure_variable_env_144_ast_node, _closure_variable_249_ast_node2728, _closure_variable_249_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(closure_type_env_25_ast_node, _closure_type_29_ast_node2729, _closure_type_29_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(var_variable_set__env_237_ast_node, _var_variable_set__30_ast_node2730, _var_variable_set__30_ast_node, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pragma_format_env_224_ast_node, _pragma_format_55_ast_node2731, _pragma_format_55_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(kwote_type_env_152_ast_node, _kwote_type_169_ast_node2732, _kwote_type_169_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(fail_type_set__env_73_ast_node, _fail_type_set__134_ast_node2733, _fail_type_set__134_ast_node, 0L, 2);
DEFINE_EXPORT_PROCEDURE(let_fun_side_effect__set__env_17_ast_node, _let_fun_side_effect__set__74_ast_node2734, _let_fun_side_effect__set__74_ast_node, 0L, 2);
DEFINE_EXPORT_PROCEDURE(kwote_loc_env_171_ast_node, _kwote_loc_102_ast_node2735, _kwote_loc_102_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(conditional_type_env_94_ast_node, _conditional_type_95_ast_node2736, _conditional_type_95_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(var_type_env_9_ast_node, _var_type_212_ast_node2737, _var_type_212_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(box_set__value_set__env_57_ast_node, _box_set__value_set__99_ast_node2738, _box_set__value_set__99_ast_node, 0L, 2);
DEFINE_EXPORT_PROCEDURE(let_var_removable__set__env_230_ast_node, _let_var_removable__set__166_ast_node2739, _let_var_removable__set__166_ast_node, 0L, 2);
DEFINE_EXPORT_PROCEDURE(sequence_key_env_163_ast_node, _sequence_key2531_88_ast_node2740, _sequence_key2531_88_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(fail_obj_env_238_ast_node, _fail_obj_36_ast_node2741, _fail_obj_36_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(set_ex_it_body_set__env_144_ast_node, _set_ex_it_body_set__11_ast_node2742, _set_ex_it_body_set__11_ast_node, 0L, 2);
DEFINE_EXPORT_PROCEDURE(let_fun_type_set__env_233_ast_node, _let_fun_type_set__36_ast_node2743, _let_fun_type_set__36_ast_node, 0L, 2);
DEFINE_EXPORT_PROCEDURE(jump_ex_it_loc_env_168_ast_node, _jump_ex_it_loc_220_ast_node2744, _jump_ex_it_loc_220_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(let_fun_locals_env_159_ast_node, _let_fun_locals_153_ast_node2745, _let_fun_locals_153_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(set_ex_it__env_28_ast_node, _set_ex_it__35_ast_node2746, _set_ex_it__35_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(fail_loc_env_135_ast_node, _fail_loc_78_ast_node2747, _fail_loc_78_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(select_test_env_161_ast_node, _select_test_131_ast_node2748, _select_test_131_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_kwote_env_2_ast_node, _make_kwote_232_ast_node2749, _make_kwote_232_ast_node, 0L, 3);
DEFINE_EXPORT_PROCEDURE(funcall_loc_env_135_ast_node, _funcall_loc_189_ast_node2750, _funcall_loc_189_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(let_var_loc_env_215_ast_node, _let_var_loc_227_ast_node2751, _let_var_loc_227_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(box_set__var_env_7_ast_node, _box_set__var_27_ast_node2752, _box_set__var_27_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(let_var_side_effect__env_58_ast_node, _let_var_side_effect__128_ast_node2753, _let_var_side_effect__128_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(box_ref_key_env_4_ast_node, _box_ref_key2515_204_ast_node2754, _box_ref_key2515_204_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sequence_type_env_90_ast_node, _sequence_type_56_ast_node2755, _sequence_type_56_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(jump_ex_it_value_set__env_48_ast_node, _jump_ex_it_value_set__227_ast_node2756, _jump_ex_it_value_set__227_ast_node, 0L, 2);
DEFINE_EXPORT_PROCEDURE(let_var_side_effect__set__env_190_ast_node, _let_var_side_effect__set__107_ast_node2757, _let_var_side_effect__set__107_ast_node, 0L, 2);
DEFINE_EXPORT_PROCEDURE(app_side_effect__set__env_249_ast_node, _app_side_effect__set__107_ast_node2758, _app_side_effect__set__107_ast_node, 0L, 2);
DEFINE_EXPORT_PROCEDURE(app_loc_env_54_ast_node, _app_loc_227_ast_node2759, _app_loc_227_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(jump_ex_it_exit_set__env_72_ast_node, _jump_ex_it_exit_set__1_ast_node2760, _jump_ex_it_exit_set__1_ast_node, 0L, 2);
DEFINE_EXPORT_PROCEDURE(app_args_env_218_ast_node, _app_args_203_ast_node2761, _app_args_203_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sequence_side_effect__env_243_ast_node, _sequence_side_effect__7_ast_node2762, _sequence_side_effect__7_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(allocate_sequence_env_201_ast_node, _allocate_sequence_156_ast_node2763, _allocate_sequence_156_ast_node, 0L, 0);
DEFINE_EXPORT_PROCEDURE(set_ex_it_loc_env_136_ast_node, _set_ex_it_loc_117_ast_node2764, _set_ex_it_loc_117_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(funcall_type_set__env_73_ast_node, _funcall_type_set__146_ast_node2765, _funcall_type_set__146_ast_node, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_box_value_set__env_202_ast_node, _make_box_value_set__157_ast_node2766, _make_box_value_set__157_ast_node, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_box_set__env_222_ast_node, _make_box_set__122_ast_node2767, _make_box_set__122_ast_node, 0L, 4);
DEFINE_EXPORT_PROCEDURE(node_type_env_176_ast_node, _node_type_141_ast_node2768, _node_type_141_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(let_fun_body_set__env_177_ast_node, _let_fun_body_set__28_ast_node2769, _let_fun_body_set__28_ast_node, 0L, 2);
DEFINE_EXPORT_PROCEDURE(set_ex_it_type_env_28_ast_node, _set_ex_it_type_93_ast_node2770, _set_ex_it_type_93_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(cast_loc_env_156_ast_node, _cast_loc_222_ast_node2771, _cast_loc_222_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(conditional_true_env_222_ast_node, _conditional_true_164_ast_node2772, _conditional_true_164_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(select_side_effect__env_76_ast_node, _select_side_effect__188_ast_node2773, _select_side_effect__188_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(select_loc_env_132_ast_node, _select_loc_214_ast_node2774, _select_loc_214_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(node_effect__env_121_ast_node, _node_effect__62_ast_node2775, _node_effect__62_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_box_key_env_126_ast_node, _make_box_key2517_6_ast_node2776, _make_box_key2517_6_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(allocate_funcall_env_134_ast_node, _allocate_funcall_93_ast_node2777, _allocate_funcall_93_ast_node, 0L, 0);
DEFINE_EXPORT_PROCEDURE(cast__env_36_ast_node, _cast__220_ast_node2778, _cast__220_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(box_set__value_env_229_ast_node, _box_set__value_125_ast_node2779, _box_set__value_125_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sequence_side_effect__set__env_162_ast_node, _sequence_side_effect__set__178_ast_node2780, _sequence_side_effect__set__178_ast_node, 0L, 2);
DEFINE_EXPORT_PROCEDURE(kwote_value_env_5_ast_node, _kwote_value_210_ast_node2781, _kwote_value_210_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(allocate_var_env_196_ast_node, _allocate_var_93_ast_node2782, _allocate_var_93_ast_node, 0L, 0);
DEFINE_EXPORT_PROCEDURE(box_set__var_set__env_59_ast_node, _box_set__var_set__202_ast_node2783, _box_set__var_set__202_ast_node, 0L, 2);
DEFINE_EXPORT_PROCEDURE(fail_proc_env_127_ast_node, _fail_proc_197_ast_node2784, _fail_proc_197_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(select_test_set__env_121_ast_node, _select_test_set__254_ast_node2785, _select_test_set__254_ast_node, 0L, 2);
DEFINE_EXPORT_PROCEDURE(conditional_test_set__env_112_ast_node, _conditional_test_set__114_ast_node2786, _conditional_test_set__114_ast_node, 0L, 2);
DEFINE_EXPORT_PROCEDURE(var_loc_env_143_ast_node, _var_loc_47_ast_node2787, _var_loc_47_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(atom_type_env_37_ast_node, _atom_type_184_ast_node2788, _atom_type_184_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_let_var_env_152_ast_node, _make_let_var_42_ast_node2789, _make_let_var_42_ast_node, 0L, 7);
DEFINE_EXPORT_PROCEDURE(let_var_removable__env_84_ast_node, _let_var_removable__112_ast_node2790, _let_var_removable__112_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(conditional_key_env_231_ast_node, _conditional_key2525_224_ast_node2791, _conditional_key2525_224_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(jump_ex_it_type_env_230_ast_node, _jump_ex_it_type_189_ast_node2792, _jump_ex_it_type_189_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(fail_msg_env_38_ast_node, _fail_msg_237_ast_node2793, _fail_msg_237_ast_node, 0L, 1);
DEFINE_STRING(string2583_ast_node, string2583_ast_node2794, "BOX-SET! BOX-REF MAKE-BOX JUMP-EX-IT SET-EX-IT LET-VAR LET-FUN SELECT FAIL CONDITIONAL SETQ CAST PRAGMA FUNCALL APP-LY APP SEQUENCE KWOTE CLOSURE VAR ATOM NODE/EFFECT NODE ", 172);
DEFINE_EXPORT_PROCEDURE(make_let_fun_env_58_ast_node, _make_let_fun_151_ast_node2795, _make_let_fun_151_ast_node, 0L, 6);
DEFINE_EXPORT_PROCEDURE(atom_value_env_7_ast_node, _atom_value_84_ast_node2796, _atom_value_84_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(setq_value_env_51_ast_node, _setq_value_242_ast_node2797, _setq_value_242_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(app_ly_type_set__env_224_ast_node, _app_ly_type_set__26_ast_node2798, _app_ly_type_set__26_ast_node, 0L, 2);
DEFINE_EXPORT_PROCEDURE(let_var__env_187_ast_node, _let_var__141_ast_node2799, _let_var__141_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_box_key_set__env_122_ast_node, _make_box_key_set_2516_65_ast_node2800, _make_box_key_set_2516_65_ast_node, 0L, 2);
DEFINE_EXPORT_PROCEDURE(cast_type_env_116_ast_node, _cast_type_62_ast_node2801, _cast_type_62_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(allocate_set_ex_it_env_240_ast_node, _allocate_set_ex_it_70_ast_node2802, _allocate_set_ex_it_70_ast_node, 0L, 0);
DEFINE_EXPORT_PROCEDURE(jump_ex_it_value_env_1_ast_node, _jump_ex_it_value_253_ast_node2803, _jump_ex_it_value_253_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(app_ly_loc_env_245_ast_node, _app_ly_loc_181_ast_node2804, _app_ly_loc_181_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(kwote_type_set__env_51_ast_node, _kwote_type_set__30_ast_node2805, _kwote_type_set__30_ast_node, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_box_type_set__env_191_ast_node, _make_box_type_set__195_ast_node2806, _make_box_type_set__195_ast_node, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_make_box_env_108_ast_node, _make_make_box_207_ast_node2807, _make_make_box_207_ast_node, 0L, 5);
DEFINE_EXPORT_PROCEDURE(conditional_false_env_60_ast_node, _conditional_false_30_ast_node2808, _conditional_false_30_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(fail_msg_set__env_61_ast_node, _fail_msg_set__4_ast_node2809, _fail_msg_set__4_ast_node, 0L, 2);
DEFINE_EXPORT_PROCEDURE(funcall_strength_env_24_ast_node, _funcall_strength_15_ast_node2810, _funcall_strength_15_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(allocate_box_set__env_30_ast_node, _allocate_box_set__43_ast_node2811, _allocate_box_set__43_ast_node, 0L, 0);
DEFINE_EXPORT_PROCEDURE(allocate_app_ly_env_193_ast_node, _allocate_app_ly_138_ast_node2812, _allocate_app_ly_138_ast_node, 0L, 0);
DEFINE_EXPORT_PROCEDURE(pragma_key_set__env_153_ast_node, _pragma_key_set_2526_118_ast_node2813, _pragma_key_set_2526_118_ast_node, 0L, 2);
DEFINE_EXPORT_PROCEDURE(allocate_fail_env_28_ast_node, _allocate_fail_214_ast_node2814, _allocate_fail_214_ast_node, 0L, 0);
DEFINE_EXPORT_PROCEDURE(sequence_loc_env_55_ast_node, _sequence_loc_75_ast_node2815, _sequence_loc_75_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(atom_type_set__env_31_ast_node, _atom_type_set__37_ast_node2816, _atom_type_set__37_ast_node, 0L, 2);
DEFINE_EXPORT_PROCEDURE(box_ref_side_effect__set__env_192_ast_node, _box_ref_side_effect__set__188_ast_node2817, _box_ref_side_effect__set__188_ast_node, 0L, 2);
DEFINE_EXPORT_PROCEDURE(app_ly__env_2_ast_node, _app_ly__224_ast_node2818, _app_ly__224_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(atom__env_198_ast_node, _atom__186_ast_node2819, _atom__186_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(allocate_conditional_env_156_ast_node, _allocate_conditional_184_ast_node2820, _allocate_conditional_184_ast_node, 0L, 0);
DEFINE_EXPORT_PROCEDURE(fail_obj_set__env_135_ast_node, _fail_obj_set__94_ast_node2821, _fail_obj_set__94_ast_node, 0L, 2);
DEFINE_EXPORT_PROCEDURE(node_effect_type_env_93_ast_node, _node_effect_type_42_ast_node2822, _node_effect_type_42_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(node_effect_type_set__env_87_ast_node, _node_effect_type_set__143_ast_node2823, _node_effect_type_set__143_ast_node, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_box__env_20_ast_node, _make_box__204_ast_node2824, _make_box__204_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_fail_env_198_ast_node, _make_fail_191_ast_node2825, _make_fail_191_ast_node, 0L, 5);
DEFINE_EXPORT_PROCEDURE(app_side_effect__env_112_ast_node, _app_side_effect__128_ast_node2826, _app_side_effect__128_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(closure__env_92_ast_node, _closure__33_ast_node2827, _closure__33_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_box_ref_env_48_ast_node, _make_box_ref_87_ast_node2828, _make_box_ref_87_ast_node, 0L, 5);
DEFINE_EXPORT_PROCEDURE(setq_value_set__env_40_ast_node, _setq_value_set__101_ast_node2829, _setq_value_set__101_ast_node, 0L, 2);
DEFINE_EXPORT_PROCEDURE(jump_ex_it__env_238_ast_node, _jump_ex_it__165_ast_node2830, _jump_ex_it__165_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(atom_value_set__env_59_ast_node, _atom_value_set__174_ast_node2831, _atom_value_set__174_ast_node, 0L, 2);
DEFINE_EXPORT_PROCEDURE(cast_arg_set__env_104_ast_node, _cast_arg_set__200_ast_node2832, _cast_arg_set__200_ast_node, 0L, 2);
DEFINE_EXPORT_PROCEDURE(conditional_true_set__env_254_ast_node, _conditional_true_set__236_ast_node2833, _conditional_true_set__236_ast_node, 0L, 2);
DEFINE_EXPORT_PROCEDURE(box_ref_var_set__env_177_ast_node, _box_ref_var_set__55_ast_node2834, _box_ref_var_set__55_ast_node, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pragma_side_effect__set__env_156_ast_node, _pragma_side_effect__set__36_ast_node2835, _pragma_side_effect__set__36_ast_node, 0L, 2);
DEFINE_EXPORT_PROCEDURE(box_ref_loc_env_155_ast_node, _box_ref_loc_56_ast_node2836, _box_ref_loc_56_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(select_type_env_15_ast_node, _select_type_8_ast_node2837, _select_type_8_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pragma_args_set__env_206_ast_node, _pragma_args_set__242_ast_node2838, _pragma_args_set__242_ast_node, 0L, 2);
DEFINE_EXPORT_PROCEDURE(node_type_set__env_201_ast_node, _node_type_set__147_ast_node2839, _node_type_set__147_ast_node, 0L, 2);
DEFINE_EXPORT_PROCEDURE(jump_ex_it_type_set__env_160_ast_node, _jump_ex_it_type_set__106_ast_node2840, _jump_ex_it_type_set__106_ast_node, 0L, 2);
DEFINE_EXPORT_PROCEDURE(funcall_fun_env_121_ast_node, _funcall_fun_245_ast_node2841, _funcall_fun_245_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(funcall_strength_set__env_240_ast_node, _funcall_strength_set__93_ast_node2842, _funcall_strength_set__93_ast_node, 0L, 2);
DEFINE_EXPORT_PROCEDURE(cast_type_set__env_103_ast_node, _cast_type_set__213_ast_node2843, _cast_type_set__213_ast_node, 0L, 2);
DEFINE_EXPORT_PROCEDURE(setq_loc_env_7_ast_node, _setq_loc_129_ast_node2844, _setq_loc_129_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_node_effect_env_234_ast_node, _make_node_effect_168_ast_node2845, _make_node_effect_168_ast_node, 0L, 4);
DEFINE_EXPORT_PROCEDURE(closure_loc_env_57_ast_node, _closure_loc_244_ast_node2846, _closure_loc_244_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(allocate_setq_env_19_ast_node, _allocate_setq_253_ast_node2847, _allocate_setq_253_ast_node, 0L, 0);
DEFINE_EXPORT_PROCEDURE(allocate_node_env_214_ast_node, _allocate_node_227_ast_node2848, _allocate_node_227_ast_node, 0L, 0);
DEFINE_EXPORT_PROCEDURE(closure_type_set__env_197_ast_node, _closure_type_set__114_ast_node2849, _closure_type_set__114_ast_node, 0L, 2);
DEFINE_EXPORT_PROCEDURE(app__env_253_ast_node, _app__141_ast_node2850, _app__141_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(node_effect_side_effect__env_215_ast_node, _node_effect_side_effect__113_ast_node2851, _node_effect_side_effect__113_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(select_type_set__env_67_ast_node, _select_type_set__200_ast_node2852, _select_type_set__200_ast_node, 0L, 2);
DEFINE_EXPORT_PROCEDURE(let_fun_key_set__env_129_ast_node, _let_fun_key_set_2520_62_ast_node2853, _let_fun_key_set_2520_62_ast_node, 0L, 2);
DEFINE_EXPORT_PROCEDURE(node_loc_env_117_ast_node, _node_loc_236_ast_node2854, _node_loc_236_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(set_ex_it_var_env_99_ast_node, _set_ex_it_var_69_ast_node2855, _set_ex_it_var_69_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(app_fun_env_56_ast_node, _app_fun_176_ast_node2856, _app_fun_176_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(conditional_type_set__env_91_ast_node, _conditional_type_set__61_ast_node2857, _conditional_type_set__61_ast_node, 0L, 2);
DEFINE_EXPORT_PROCEDURE(allocate_let_var_env_250_ast_node, _allocate_let_var_179_ast_node2858, _allocate_let_var_179_ast_node, 0L, 0);
DEFINE_EXPORT_PROCEDURE(set_ex_it_body_env_50_ast_node, _set_ex_it_body_118_ast_node2859, _set_ex_it_body_118_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_setq_env_30_ast_node, _make_setq_227_ast_node2860, _make_setq_227_ast_node, 0L, 4);
DEFINE_EXPORT_PROCEDURE(app_type_set__env_237_ast_node, _app_type_set__8_ast_node2861, _app_type_set__8_ast_node, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_jump_ex_it_env_123_ast_node, _make_jump_ex_it_55_ast_node2862, _make_jump_ex_it_55_ast_node, 0L, 4);
DEFINE_EXPORT_PROCEDURE(make_node_env_151_ast_node, _make_node_181_ast_node2863, _make_node_181_ast_node, 0L, 2);
DEFINE_EXPORT_PROCEDURE(let_fun__env_93_ast_node, _let_fun__236_ast_node2864, _let_fun__236_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(fail_type_env_209_ast_node, _fail_type_21_ast_node2865, _fail_type_21_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_set_ex_it_env_226_ast_node, _make_set_ex_it_124_ast_node2866, _make_set_ex_it_124_ast_node, 0L, 4);
DEFINE_EXPORT_PROCEDURE(make_box_type_env_133_ast_node, _make_box_type_123_ast_node2867, _make_box_type_123_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(allocate_let_fun_env_44_ast_node, _allocate_let_fun_123_ast_node2868, _allocate_let_fun_123_ast_node, 0L, 0);
DEFINE_EXPORT_PROCEDURE(make_app_env_36_ast_node, _make_app_178_ast_node2869, _make_app_178_ast_node, 0L, 7);
DEFINE_EXPORT_PROCEDURE(box_ref_type_set__env_17_ast_node, _box_ref_type_set__53_ast_node2870, _box_ref_type_set__53_ast_node, 0L, 2);
DEFINE_EXPORT_PROCEDURE(let_fun_locals_set__env_206_ast_node, _let_fun_locals_set__222_ast_node2871, _let_fun_locals_set__222_ast_node, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_box_loc_env_69_ast_node, _make_box_loc_121_ast_node2872, _make_box_loc_121_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(let_fun_key_env_31_ast_node, _let_fun_key2521_19_ast_node2873, _let_fun_key2521_19_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(box_ref_key_set__env_142_ast_node, _box_ref_key_set_2514_229_ast_node2874, _box_ref_key_set_2514_229_ast_node, 0L, 2);
DEFINE_EXPORT_PROCEDURE(allocate_cast_env_179_ast_node, _allocate_cast_146_ast_node2875, _allocate_cast_146_ast_node, 0L, 0);
DEFINE_EXPORT_PROCEDURE(let_fun_type_env_150_ast_node, _let_fun_type_63_ast_node2876, _let_fun_type_63_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(setq_var_set__env_152_ast_node, _setq_var_set__53_ast_node2877, _setq_var_set__53_ast_node, 0L, 2);
DEFINE_EXPORT_PROCEDURE(allocate_make_box_env_148_ast_node, _allocate_make_box_168_ast_node2878, _allocate_make_box_168_ast_node, 0L, 0);
DEFINE_EXPORT_PROCEDURE(box_ref_side_effect__env_68_ast_node, _box_ref_side_effect__222_ast_node2879, _box_ref_side_effect__222_ast_node, 0L, 1);
extern obj_t object__struct_env_210___object;
DEFINE_EXPORT_PROCEDURE(pragma_key_env_219_ast_node, _pragma_key2527_152_ast_node2880, _pragma_key2527_152_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(let_fun_side_effect__env_214_ast_node, _let_fun_side_effect__106_ast_node2881, _let_fun_side_effect__106_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_app_ly_env_41_ast_node, _make_app_ly_198_ast_node2882, _make_app_ly_198_ast_node, 0L, 4);
DEFINE_EXPORT_PROCEDURE(make_cast_env_177_ast_node, _make_cast_224_ast_node2883, _make_cast_224_ast_node, 0L, 3);
DEFINE_EXPORT_PROCEDURE(kwote__env_173_ast_node, _kwote__112_ast_node2884, _kwote__112_ast_node, 0L, 1);
DEFINE_EXPORT_PROCEDURE(node_effect_side_effect__set__env_245_ast_node, _node_effect_side_effect__set__197_ast_node2885, _node_effect_side_effect__set__197_ast_node, 0L, 2);
DEFINE_EXPORT_PROCEDURE(select_side_effect__set__env_38_ast_node, _select_side_effect__set__140_ast_node2886, _select_side_effect__set__140_ast_node, 0L, 2);
DEFINE_EXPORT_PROCEDURE(box_set__type_env_162_ast_node, _box_set__type_101_ast_node2887, _box_set__type_101_ast_node, 0L, 1);



/* module-initialization */
obj_t 
module_initialization_70_ast_node(long checksum_3727, char *from_3728)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_ast_node))
	{
	   require_initialization_114_ast_node =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_ast_node();
	   cnst_init_137_ast_node();
	   imported_modules_init_94_ast_node();
	   object_init_111_ast_node();
	   method_init_76_ast_node();
	   toplevel_init_63_ast_node();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_ast_node()
{
   AN_OBJECT;
   {	/* Ast/node.scm 14 */
      module_initialization_70___object(((long) 0), "AST_NODE");
      module_initialization_70___reader(((long) 0), "AST_NODE");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_ast_node()
{
   AN_OBJECT;
   {	/* Ast/node.scm 14 */
      {		/* Ast/node.scm 14 */
	 obj_t cnst_port_138_3720;
	 cnst_port_138_3720 =
	    open_input_string(string2583_ast_node);
	 {
	    long i_3721;
	    i_3721 = ((long) 22);
	  loop_3722:
	    {	/* Ast/node.scm 14 */
	       bool_t test2584_3723;
	       test2584_3723 =
		  (i_3721 == ((long) -1));
	       if (test2584_3723)
		 {	/* Ast/node.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Ast/node.scm 14 */
		    {	/* Ast/node.scm 14 */
		       obj_t arg2585_3724;
		       {	/* Ast/node.scm 14 */
			  obj_t list2586_3725;
			  list2586_3725 =
			     MAKE_PAIR(cnst_port_138_3720, BNIL);
			  arg2585_3724 =
			     read___reader(list2586_3725);
		       }
		       CNST_TABLE_SET(i_3721, arg2585_3724);
		    }
		    {	/* Ast/node.scm 14 */
		       int aux_3726;
		       {	/* Ast/node.scm 14 */
			  long aux_3746;
			  aux_3746 =
			     (i_3721 - ((long) 1));
			  aux_3726 =
			     (int) (aux_3746);
		       }
		       {
			  long i_3749;
			  i_3749 =
			     (long) (aux_3726);
			  i_3721 = i_3749;
			  goto loop_3722;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_ast_node()
{
   AN_OBJECT;
   {	/* Ast/node.scm 14 */
      return BUNSPEC;
   }
}



/* object-init */
obj_t 
object_init_111_ast_node()
{
   AN_OBJECT;
   {	/* Ast/node.scm 14 */
      {		/* Ast/node.scm 14 */
	 obj_t arg2025_765;
	 obj_t arg2026_766;
	 obj_t arg2029_769;
	 arg2025_765 =
	    CNST_TABLE_REF(((long) 0));
	 arg2026_766 = object___object;
	 {	/* Ast/node.scm 14 */
	    obj_t v1910_770;
	    v1910_770 =
	       create_vector(((long) 0));
	    arg2029_769 = v1910_770;
	 }
	 node_ast_node =
	    register_class__225___object(arg2025_765, arg2026_766, allocate_node_env_214_ast_node, ((long) 29579), BUNSPEC, BFALSE, arg2029_769);
      }
      {		/* Ast/node.scm 14 */
	 obj_t arg2030_771;
	 obj_t arg2031_772;
	 obj_t arg2034_775;
	 arg2030_771 =
	    CNST_TABLE_REF(((long) 1));
	 arg2031_772 = node_ast_node;
	 {	/* Ast/node.scm 14 */
	    obj_t v1911_776;
	    v1911_776 =
	       create_vector(((long) 0));
	    arg2034_775 = v1911_776;
	 }
	 node_effect_213_ast_node =
	    register_class__225___object(arg2030_771, arg2031_772, allocate_node_effect_env_65_ast_node, ((long) 53365), BUNSPEC, BFALSE, arg2034_775);
      }
      {		/* Ast/node.scm 14 */
	 obj_t arg2035_777;
	 obj_t arg2036_778;
	 obj_t arg2039_781;
	 arg2035_777 =
	    CNST_TABLE_REF(((long) 2));
	 arg2036_778 = node_ast_node;
	 {	/* Ast/node.scm 14 */
	    obj_t v1912_782;
	    v1912_782 =
	       create_vector(((long) 0));
	    arg2039_781 = v1912_782;
	 }
	 atom_ast_node =
	    register_class__225___object(arg2035_777, arg2036_778, allocate_atom_env_206_ast_node, ((long) 51461), BUNSPEC, BFALSE, arg2039_781);
      }
      {		/* Ast/node.scm 14 */
	 obj_t arg2040_783;
	 obj_t arg2041_784;
	 obj_t arg2044_787;
	 arg2040_783 =
	    CNST_TABLE_REF(((long) 3));
	 arg2041_784 = node_ast_node;
	 {	/* Ast/node.scm 14 */
	    obj_t v1913_788;
	    v1913_788 =
	       create_vector(((long) 0));
	    arg2044_787 = v1913_788;
	 }
	 var_ast_node =
	    register_class__225___object(arg2040_783, arg2041_784, allocate_var_env_196_ast_node, ((long) 23313), BUNSPEC, BFALSE, arg2044_787);
      }
      {		/* Ast/node.scm 14 */
	 obj_t arg2045_789;
	 obj_t arg2046_790;
	 obj_t arg2049_793;
	 arg2045_789 =
	    CNST_TABLE_REF(((long) 4));
	 arg2046_790 = var_ast_node;
	 {	/* Ast/node.scm 14 */
	    obj_t v1914_794;
	    v1914_794 =
	       create_vector(((long) 0));
	    arg2049_793 = v1914_794;
	 }
	 closure_ast_node =
	    register_class__225___object(arg2045_789, arg2046_790, allocate_closure_env_30_ast_node, ((long) 48469), BUNSPEC, BFALSE, arg2049_793);
      }
      {		/* Ast/node.scm 14 */
	 obj_t arg2050_795;
	 obj_t arg2051_796;
	 obj_t arg2054_799;
	 arg2050_795 =
	    CNST_TABLE_REF(((long) 5));
	 arg2051_796 = node_ast_node;
	 {	/* Ast/node.scm 14 */
	    obj_t v1915_800;
	    v1915_800 =
	       create_vector(((long) 0));
	    arg2054_799 = v1915_800;
	 }
	 kwote_ast_node =
	    register_class__225___object(arg2050_795, arg2051_796, allocate_kwote_env_128_ast_node, ((long) 35302), BUNSPEC, BFALSE, arg2054_799);
      }
      {		/* Ast/node.scm 14 */
	 obj_t arg2055_801;
	 obj_t arg2056_802;
	 obj_t arg2059_805;
	 arg2055_801 =
	    CNST_TABLE_REF(((long) 6));
	 arg2056_802 = node_effect_213_ast_node;
	 {	/* Ast/node.scm 14 */
	    obj_t v1916_806;
	    v1916_806 =
	       create_vector(((long) 0));
	    arg2059_805 = v1916_806;
	 }
	 sequence_ast_node =
	    register_class__225___object(arg2055_801, arg2056_802, allocate_sequence_env_201_ast_node, ((long) 12441), BUNSPEC, BFALSE, arg2059_805);
      }
      {		/* Ast/node.scm 14 */
	 obj_t arg2060_807;
	 obj_t arg2061_808;
	 obj_t arg2064_811;
	 arg2060_807 =
	    CNST_TABLE_REF(((long) 7));
	 arg2061_808 = node_effect_213_ast_node;
	 {	/* Ast/node.scm 14 */
	    obj_t v1917_812;
	    v1917_812 =
	       create_vector(((long) 0));
	    arg2064_811 = v1917_812;
	 }
	 app_ast_node =
	    register_class__225___object(arg2060_807, arg2061_808, allocate_app_env_27_ast_node, ((long) 50317), BUNSPEC, BFALSE, arg2064_811);
      }
      {		/* Ast/node.scm 14 */
	 obj_t arg2065_813;
	 obj_t arg2066_814;
	 obj_t arg2069_817;
	 arg2065_813 =
	    CNST_TABLE_REF(((long) 8));
	 arg2066_814 = node_ast_node;
	 {	/* Ast/node.scm 14 */
	    obj_t v1918_818;
	    v1918_818 =
	       create_vector(((long) 0));
	    arg2069_817 = v1918_818;
	 }
	 app_ly_162_ast_node =
	    register_class__225___object(arg2065_813, arg2066_814, allocate_app_ly_env_193_ast_node, ((long) 40452), BUNSPEC, BFALSE, arg2069_817);
      }
      {		/* Ast/node.scm 14 */
	 obj_t arg2070_819;
	 obj_t arg2071_820;
	 obj_t arg2074_823;
	 arg2070_819 =
	    CNST_TABLE_REF(((long) 9));
	 arg2071_820 = node_ast_node;
	 {	/* Ast/node.scm 14 */
	    obj_t v1919_824;
	    v1919_824 =
	       create_vector(((long) 0));
	    arg2074_823 = v1919_824;
	 }
	 funcall_ast_node =
	    register_class__225___object(arg2070_819, arg2071_820, allocate_funcall_env_134_ast_node, ((long) 61754), BUNSPEC, BFALSE, arg2074_823);
      }
      {		/* Ast/node.scm 14 */
	 obj_t arg2076_825;
	 obj_t arg2077_826;
	 obj_t arg2080_829;
	 arg2076_825 =
	    CNST_TABLE_REF(((long) 10));
	 arg2077_826 = node_effect_213_ast_node;
	 {	/* Ast/node.scm 14 */
	    obj_t v1920_830;
	    v1920_830 =
	       create_vector(((long) 0));
	    arg2080_829 = v1920_830;
	 }
	 pragma_ast_node =
	    register_class__225___object(arg2076_825, arg2077_826, allocate_pragma_env_128_ast_node, ((long) 8731), BUNSPEC, BFALSE, arg2080_829);
      }
      {		/* Ast/node.scm 14 */
	 obj_t arg2081_831;
	 obj_t arg2082_832;
	 obj_t arg2085_835;
	 arg2081_831 =
	    CNST_TABLE_REF(((long) 11));
	 arg2082_832 = node_ast_node;
	 {	/* Ast/node.scm 14 */
	    obj_t v1921_836;
	    v1921_836 =
	       create_vector(((long) 0));
	    arg2085_835 = v1921_836;
	 }
	 cast_ast_node =
	    register_class__225___object(arg2081_831, arg2082_832, allocate_cast_env_179_ast_node, ((long) 10303), BUNSPEC, BFALSE, arg2085_835);
      }
      {		/* Ast/node.scm 14 */
	 obj_t arg2086_837;
	 obj_t arg2087_838;
	 obj_t arg2091_841;
	 arg2086_837 =
	    CNST_TABLE_REF(((long) 12));
	 arg2087_838 = node_ast_node;
	 {	/* Ast/node.scm 14 */
	    obj_t v1922_842;
	    v1922_842 =
	       create_vector(((long) 0));
	    arg2091_841 = v1922_842;
	 }
	 setq_ast_node =
	    register_class__225___object(arg2086_837, arg2087_838, allocate_setq_env_19_ast_node, ((long) 7212), BUNSPEC, BFALSE, arg2091_841);
      }
      {		/* Ast/node.scm 14 */
	 obj_t arg2092_843;
	 obj_t arg2093_844;
	 obj_t arg2096_847;
	 arg2092_843 =
	    CNST_TABLE_REF(((long) 13));
	 arg2093_844 = node_effect_213_ast_node;
	 {	/* Ast/node.scm 14 */
	    obj_t v1923_848;
	    v1923_848 =
	       create_vector(((long) 0));
	    arg2096_847 = v1923_848;
	 }
	 conditional_ast_node =
	    register_class__225___object(arg2092_843, arg2093_844, allocate_conditional_env_156_ast_node, ((long) 53673), BUNSPEC, BFALSE, arg2096_847);
      }
      {		/* Ast/node.scm 14 */
	 obj_t arg2098_849;
	 obj_t arg2099_850;
	 obj_t arg2103_853;
	 arg2098_849 =
	    CNST_TABLE_REF(((long) 14));
	 arg2099_850 = node_ast_node;
	 {	/* Ast/node.scm 14 */
	    obj_t v1924_854;
	    v1924_854 =
	       create_vector(((long) 0));
	    arg2103_853 = v1924_854;
	 }
	 fail_ast_node =
	    register_class__225___object(arg2098_849, arg2099_850, allocate_fail_env_28_ast_node, ((long) 57614), BUNSPEC, BFALSE, arg2103_853);
      }
      {		/* Ast/node.scm 14 */
	 obj_t arg2104_855;
	 obj_t arg2105_856;
	 obj_t arg2108_859;
	 arg2104_855 =
	    CNST_TABLE_REF(((long) 15));
	 arg2105_856 = node_effect_213_ast_node;
	 {	/* Ast/node.scm 14 */
	    obj_t v1925_860;
	    v1925_860 =
	       create_vector(((long) 0));
	    arg2108_859 = v1925_860;
	 }
	 select_ast_node =
	    register_class__225___object(arg2104_855, arg2105_856, allocate_select_env_246_ast_node, ((long) 25857), BUNSPEC, BFALSE, arg2108_859);
      }
      {		/* Ast/node.scm 14 */
	 obj_t arg2109_861;
	 obj_t arg2110_862;
	 obj_t arg2113_865;
	 arg2109_861 =
	    CNST_TABLE_REF(((long) 16));
	 arg2110_862 = node_effect_213_ast_node;
	 {	/* Ast/node.scm 14 */
	    obj_t v1926_866;
	    v1926_866 =
	       create_vector(((long) 0));
	    arg2113_865 = v1926_866;
	 }
	 let_fun_218_ast_node =
	    register_class__225___object(arg2109_861, arg2110_862, allocate_let_fun_env_44_ast_node, ((long) 49470), BUNSPEC, BFALSE, arg2113_865);
      }
      {		/* Ast/node.scm 14 */
	 obj_t arg2114_867;
	 obj_t arg2115_868;
	 obj_t arg2118_871;
	 arg2114_867 =
	    CNST_TABLE_REF(((long) 17));
	 arg2115_868 = node_effect_213_ast_node;
	 {	/* Ast/node.scm 14 */
	    obj_t v1927_872;
	    v1927_872 =
	       create_vector(((long) 0));
	    arg2118_871 = v1927_872;
	 }
	 let_var_6_ast_node =
	    register_class__225___object(arg2114_867, arg2115_868, allocate_let_var_env_250_ast_node, ((long) 54082), BUNSPEC, BFALSE, arg2118_871);
      }
      {		/* Ast/node.scm 14 */
	 obj_t arg2119_873;
	 obj_t arg2120_874;
	 obj_t arg2124_877;
	 arg2119_873 =
	    CNST_TABLE_REF(((long) 18));
	 arg2120_874 = node_ast_node;
	 {	/* Ast/node.scm 14 */
	    obj_t v1928_878;
	    v1928_878 =
	       create_vector(((long) 0));
	    arg2124_877 = v1928_878;
	 }
	 set_ex_it_116_ast_node =
	    register_class__225___object(arg2119_873, arg2120_874, allocate_set_ex_it_env_240_ast_node, ((long) 21934), BUNSPEC, BFALSE, arg2124_877);
      }
      {		/* Ast/node.scm 14 */
	 obj_t arg2125_879;
	 obj_t arg2126_880;
	 obj_t arg2129_883;
	 arg2125_879 =
	    CNST_TABLE_REF(((long) 19));
	 arg2126_880 = node_ast_node;
	 {	/* Ast/node.scm 14 */
	    obj_t v1929_884;
	    v1929_884 =
	       create_vector(((long) 0));
	    arg2129_883 = v1929_884;
	 }
	 jump_ex_it_184_ast_node =
	    register_class__225___object(arg2125_879, arg2126_880, allocate_jump_ex_it_env_98_ast_node, ((long) 23339), BUNSPEC, BFALSE, arg2129_883);
      }
      {		/* Ast/node.scm 14 */
	 obj_t arg2131_885;
	 obj_t arg2132_886;
	 obj_t arg2135_889;
	 arg2131_885 =
	    CNST_TABLE_REF(((long) 20));
	 arg2132_886 = node_effect_213_ast_node;
	 {	/* Ast/node.scm 14 */
	    obj_t v1930_890;
	    v1930_890 =
	       create_vector(((long) 0));
	    arg2135_889 = v1930_890;
	 }
	 make_box_202_ast_node =
	    register_class__225___object(arg2131_885, arg2132_886, allocate_make_box_env_148_ast_node, ((long) 53395), BUNSPEC, BFALSE, arg2135_889);
      }
      {		/* Ast/node.scm 14 */
	 obj_t arg2136_891;
	 obj_t arg2137_892;
	 obj_t arg2140_895;
	 arg2136_891 =
	    CNST_TABLE_REF(((long) 21));
	 arg2137_892 = node_effect_213_ast_node;
	 {	/* Ast/node.scm 14 */
	    obj_t v1931_896;
	    v1931_896 =
	       create_vector(((long) 0));
	    arg2140_895 = v1931_896;
	 }
	 box_ref_242_ast_node =
	    register_class__225___object(arg2136_891, arg2137_892, allocate_box_ref_env_189_ast_node, ((long) 51205), BUNSPEC, BFALSE, arg2140_895);
      }
      {		/* Ast/node.scm 14 */
	 obj_t arg2141_897;
	 obj_t arg2144_898;
	 obj_t arg2148_901;
	 arg2141_897 =
	    CNST_TABLE_REF(((long) 22));
	 arg2144_898 = node_ast_node;
	 {	/* Ast/node.scm 14 */
	    obj_t v1932_902;
	    v1932_902 =
	       create_vector(((long) 0));
	    arg2148_901 = v1932_902;
	 }
	 box_set__221_ast_node =
	    register_class__225___object(arg2141_897, arg2144_898, allocate_box_set__env_30_ast_node, ((long) 23650), BUNSPEC, BFALSE, arg2148_901);
      }
      return BUNSPEC;
   }
}



/* allocate-box-set! */
box_set__221_bglt 
allocate_box_set__237_ast_node()
{
   AN_OBJECT;
   {	/* Ast/node.scm 165 */
      {		/* Ast/node.scm 165 */
	 box_set__221_bglt new1890_903;
	 new1890_903 =
	    ((box_set__221_bglt) BREF(GC_MALLOC(sizeof(struct box_set__221))));
	 {	/* Ast/node.scm 165 */
	    long arg2149_904;
	    arg2149_904 =
	       class_num_218___object(box_set__221_ast_node);
	    {	/* Ast/node.scm 165 */
	       obj_t obj_1846;
	       obj_1846 =
		  (obj_t) (new1890_903);
	       (((obj_t) CREF(obj_1846))->header = MAKE_HEADER(arg2149_904, 0), BUNSPEC);
	    }
	 }
	 {	/* Ast/node.scm 165 */
	    object_bglt aux_3824;
	    aux_3824 =
	       (object_bglt) (new1890_903);
	    OBJECT_WIDENING_SET(aux_3824, BFALSE);
	 }
	 return new1890_903;
      }
   }
}



/* _allocate-box-set! */
obj_t 
_allocate_box_set__43_ast_node(obj_t env_2932)
{
   AN_OBJECT;
   {	/* Ast/node.scm 165 */
      {		/* Ast/node.scm 165 */
	 box_set__221_bglt aux_3827;
	 aux_3827 =
	    allocate_box_set__237_ast_node();
	 return
	    (obj_t) (aux_3827);
      }
   }
}



/* box-set!? */
bool_t 
box_set___31_ast_node(obj_t obj_4)
{
   AN_OBJECT;
   {	/* Ast/node.scm 165 */
      return
	 is_a__118___object(obj_4, box_set__221_ast_node);
   }
}



/* _box-set!? */
obj_t 
_box_set___53_ast_node(obj_t env_2933, obj_t obj_2934)
{
   AN_OBJECT;
   {	/* Ast/node.scm 165 */
      {		/* Ast/node.scm 165 */
	 bool_t aux_3831;
	 aux_3831 =
	    box_set___31_ast_node(obj_2934);
	 return
	    BBOOL(aux_3831);
      }
   }
}



/* make-box-set! */
box_set__221_bglt 
make_box_set__226_ast_node(obj_t loc_5, type_bglt type_6, var_bglt var_7, node_bglt value_8)
{
   AN_OBJECT;
   {	/* Ast/node.scm 165 */
      {		/* Ast/node.scm 165 */
	 box_set__221_bglt new1884_1848;
	 new1884_1848 =
	    ((box_set__221_bglt) BREF(GC_MALLOC(sizeof(struct box_set__221))));
	 {	/* Ast/node.scm 165 */
	    long arg2150_1849;
	    arg2150_1849 =
	       class_num_218___object(box_set__221_ast_node);
	    {	/* Ast/node.scm 165 */
	       obj_t obj_1854;
	       obj_1854 =
		  (obj_t) (new1884_1848);
	       (((obj_t) CREF(obj_1854))->header = MAKE_HEADER(arg2150_1849, 0), BUNSPEC);
	    }
	 }
	 {	/* Ast/node.scm 165 */
	    object_bglt aux_3838;
	    aux_3838 =
	       (object_bglt) (new1884_1848);
	    OBJECT_WIDENING_SET(aux_3838, BFALSE);
	 }
	 ((((box_set__221_bglt) CREF(new1884_1848))->loc) = ((obj_t) loc_5), BUNSPEC);
	 ((((box_set__221_bglt) CREF(new1884_1848))->type) = ((type_bglt) type_6), BUNSPEC);
	 ((((box_set__221_bglt) CREF(new1884_1848))->var) = ((var_bglt) var_7), BUNSPEC);
	 ((((box_set__221_bglt) CREF(new1884_1848))->value) = ((node_bglt) value_8), BUNSPEC);
	 return new1884_1848;
      }
   }
}



/* _make-box-set! */
obj_t 
_make_box_set__122_ast_node(obj_t env_2935, obj_t loc_2936, obj_t type_2937, obj_t var_2938, obj_t value_2939)
{
   AN_OBJECT;
   {	/* Ast/node.scm 165 */
      {		/* Ast/node.scm 165 */
	 box_set__221_bglt aux_3845;
	 aux_3845 =
	    make_box_set__226_ast_node(loc_2936,
	    (type_bglt) (type_2937),
	    (var_bglt) (var_2938),
	    (node_bglt) (value_2939));
	 return
	    (obj_t) (aux_3845);
      }
   }
}



/* box-set!-loc */
obj_t 
box_set__loc_237_ast_node(box_set__221_bglt obj_9)
{
   AN_OBJECT;
   {	/* Ast/node.scm 21 */
      return
	 (((box_set__221_bglt) CREF(obj_9))->loc);
   }
}



/* _box-set!-loc */
obj_t 
_box_set__loc_195_ast_node(obj_t env_2940, obj_t obj_2941)
{
   AN_OBJECT;
   {	/* Ast/node.scm 21 */
      return
	 box_set__loc_237_ast_node(
	 (box_set__221_bglt) (obj_2941));
   }
}



/* box-set!-type-set! */
obj_t 
box_set__type_set__0_ast_node(box_set__221_bglt obj_10, type_bglt val1881_11)
{
   AN_OBJECT;
   {	/* Ast/node.scm 165 */
      return
	 ((((box_set__221_bglt) CREF(obj_10))->type) = ((type_bglt) val1881_11), BUNSPEC);
   }
}



/* _box-set!-type-set! */
obj_t 
_box_set__type_set__162_ast_node(obj_t env_2942, obj_t obj_2943, obj_t val1881_2944)
{
   AN_OBJECT;
   {	/* Ast/node.scm 165 */
      return
	 box_set__type_set__0_ast_node(
	 (box_set__221_bglt) (obj_2943),
	 (type_bglt) (val1881_2944));
   }
}



/* box-set!-type */
type_bglt 
box_set__type_38_ast_node(box_set__221_bglt obj_12)
{
   AN_OBJECT;
   {	/* Ast/node.scm 165 */
      return
	 (((box_set__221_bglt) CREF(obj_12))->type);
   }
}



/* _box-set!-type */
obj_t 
_box_set__type_101_ast_node(obj_t env_2945, obj_t obj_2946)
{
   AN_OBJECT;
   {	/* Ast/node.scm 165 */
      {		/* Ast/node.scm 165 */
	 type_bglt aux_3859;
	 aux_3859 =
	    box_set__type_38_ast_node(
	    (box_set__221_bglt) (obj_2946));
	 return
	    (obj_t) (aux_3859);
      }
   }
}



/* box-set!-var-set! */
obj_t 
box_set__var_set__52_ast_node(box_set__221_bglt obj_13, var_bglt val1882_14)
{
   AN_OBJECT;
   {	/* Ast/node.scm 165 */
      return
	 ((((box_set__221_bglt) CREF(obj_13))->var) = ((var_bglt) val1882_14), BUNSPEC);
   }
}



/* _box-set!-var-set! */
obj_t 
_box_set__var_set__202_ast_node(obj_t env_2947, obj_t obj_2948, obj_t val1882_2949)
{
   AN_OBJECT;
   {	/* Ast/node.scm 165 */
      return
	 box_set__var_set__52_ast_node(
	 (box_set__221_bglt) (obj_2948),
	 (var_bglt) (val1882_2949));
   }
}



/* box-set!-var */
var_bglt 
box_set__var_177_ast_node(box_set__221_bglt obj_15)
{
   AN_OBJECT;
   {	/* Ast/node.scm 165 */
      return
	 (((box_set__221_bglt) CREF(obj_15))->var);
   }
}



/* _box-set!-var */
obj_t 
_box_set__var_27_ast_node(obj_t env_2950, obj_t obj_2951)
{
   AN_OBJECT;
   {	/* Ast/node.scm 165 */
      {		/* Ast/node.scm 165 */
	 var_bglt aux_3868;
	 aux_3868 =
	    box_set__var_177_ast_node(
	    (box_set__221_bglt) (obj_2951));
	 return
	    (obj_t) (aux_3868);
      }
   }
}



/* box-set!-value-set! */
obj_t 
box_set__value_set__195_ast_node(box_set__221_bglt obj_16, node_bglt val1883_17)
{
   AN_OBJECT;
   {	/* Ast/node.scm 165 */
      return
	 ((((box_set__221_bglt) CREF(obj_16))->value) = ((node_bglt) val1883_17), BUNSPEC);
   }
}



/* _box-set!-value-set! */
obj_t 
_box_set__value_set__99_ast_node(obj_t env_2952, obj_t obj_2953, obj_t val1883_2954)
{
   AN_OBJECT;
   {	/* Ast/node.scm 165 */
      return
	 box_set__value_set__195_ast_node(
	 (box_set__221_bglt) (obj_2953),
	 (node_bglt) (val1883_2954));
   }
}



/* box-set!-value */
node_bglt 
box_set__value_123_ast_node(box_set__221_bglt obj_18)
{
   AN_OBJECT;
   {	/* Ast/node.scm 165 */
      return
	 (((box_set__221_bglt) CREF(obj_18))->value);
   }
}



/* _box-set!-value */
obj_t 
_box_set__value_125_ast_node(obj_t env_2955, obj_t obj_2956)
{
   AN_OBJECT;
   {	/* Ast/node.scm 165 */
      {		/* Ast/node.scm 165 */
	 node_bglt aux_3877;
	 aux_3877 =
	    box_set__value_123_ast_node(
	    (box_set__221_bglt) (obj_2956));
	 return
	    (obj_t) (aux_3877);
      }
   }
}



/* allocate-box-ref */
box_ref_242_bglt 
allocate_box_ref_100_ast_node()
{
   AN_OBJECT;
   {	/* Ast/node.scm 161 */
      {		/* Ast/node.scm 161 */
	 box_ref_242_bglt new1858_911;
	 new1858_911 =
	    ((box_ref_242_bglt) BREF(GC_MALLOC(sizeof(struct box_ref_242))));
	 {	/* Ast/node.scm 161 */
	    long arg2151_912;
	    arg2151_912 =
	       class_num_218___object(box_ref_242_ast_node);
	    {	/* Ast/node.scm 161 */
	       obj_t obj_1856;
	       obj_1856 =
		  (obj_t) (new1858_911);
	       (((obj_t) CREF(obj_1856))->header = MAKE_HEADER(arg2151_912, 0), BUNSPEC);
	    }
	 }
	 {	/* Ast/node.scm 161 */
	    object_bglt aux_3885;
	    aux_3885 =
	       (object_bglt) (new1858_911);
	    OBJECT_WIDENING_SET(aux_3885, BFALSE);
	 }
	 return new1858_911;
      }
   }
}



/* _allocate-box-ref */
obj_t 
_allocate_box_ref_230_ast_node(obj_t env_2931)
{
   AN_OBJECT;
   {	/* Ast/node.scm 161 */
      {		/* Ast/node.scm 161 */
	 box_ref_242_bglt aux_3888;
	 aux_3888 =
	    allocate_box_ref_100_ast_node();
	 return
	    (obj_t) (aux_3888);
      }
   }
}



/* box-ref? */
bool_t 
box_ref__165_ast_node(obj_t obj_22)
{
   AN_OBJECT;
   {	/* Ast/node.scm 161 */
      return
	 is_a__118___object(obj_22, box_ref_242_ast_node);
   }
}



/* _box-ref? */
obj_t 
_box_ref__132_ast_node(obj_t env_2957, obj_t obj_2958)
{
   AN_OBJECT;
   {	/* Ast/node.scm 161 */
      {		/* Ast/node.scm 161 */
	 bool_t aux_3892;
	 aux_3892 =
	    box_ref__165_ast_node(obj_2958);
	 return
	    BBOOL(aux_3892);
      }
   }
}



/* make-box-ref */
box_ref_242_bglt 
make_box_ref_158_ast_node(obj_t loc_23, type_bglt type_24, obj_t side_effect__165_25, obj_t key_26, var_bglt var_27)
{
   AN_OBJECT;
   {	/* Ast/node.scm 161 */
      {		/* Ast/node.scm 161 */
	 box_ref_242_bglt new1851_1858;
	 new1851_1858 =
	    ((box_ref_242_bglt) BREF(GC_MALLOC(sizeof(struct box_ref_242))));
	 {	/* Ast/node.scm 161 */
	    long arg2153_1859;
	    arg2153_1859 =
	       class_num_218___object(box_ref_242_ast_node);
	    {	/* Ast/node.scm 161 */
	       obj_t obj_1865;
	       obj_1865 =
		  (obj_t) (new1851_1858);
	       (((obj_t) CREF(obj_1865))->header = MAKE_HEADER(arg2153_1859, 0), BUNSPEC);
	    }
	 }
	 {	/* Ast/node.scm 161 */
	    object_bglt aux_3899;
	    aux_3899 =
	       (object_bglt) (new1851_1858);
	    OBJECT_WIDENING_SET(aux_3899, BFALSE);
	 }
	 ((((box_ref_242_bglt) CREF(new1851_1858))->loc) = ((obj_t) loc_23), BUNSPEC);
	 ((((box_ref_242_bglt) CREF(new1851_1858))->type) = ((type_bglt) type_24), BUNSPEC);
	 ((((box_ref_242_bglt) CREF(new1851_1858))->side_effect__165) = ((obj_t) side_effect__165_25), BUNSPEC);
	 ((((box_ref_242_bglt) CREF(new1851_1858))->key) = ((obj_t) key_26), BUNSPEC);
	 ((((box_ref_242_bglt) CREF(new1851_1858))->var) = ((var_bglt) var_27), BUNSPEC);
	 return new1851_1858;
      }
   }
}



/* _make-box-ref */
obj_t 
_make_box_ref_87_ast_node(obj_t env_2959, obj_t loc_2960, obj_t type_2961, obj_t side_effect__165_2962, obj_t key_2963, obj_t var_2964)
{
   AN_OBJECT;
   {	/* Ast/node.scm 161 */
      {		/* Ast/node.scm 161 */
	 box_ref_242_bglt aux_3907;
	 aux_3907 =
	    make_box_ref_158_ast_node(loc_2960,
	    (type_bglt) (type_2961), side_effect__165_2962, key_2963,
	    (var_bglt) (var_2964));
	 return
	    (obj_t) (aux_3907);
      }
   }
}



/* box-ref-loc */
obj_t 
box_ref_loc_220_ast_node(box_ref_242_bglt obj_28)
{
   AN_OBJECT;
   {	/* Ast/node.scm 21 */
      return
	 (((box_ref_242_bglt) CREF(obj_28))->loc);
   }
}



/* _box-ref-loc */
obj_t 
_box_ref_loc_56_ast_node(obj_t env_2965, obj_t obj_2966)
{
   AN_OBJECT;
   {	/* Ast/node.scm 21 */
      return
	 box_ref_loc_220_ast_node(
	 (box_ref_242_bglt) (obj_2966));
   }
}



/* box-ref-type-set! */
obj_t 
box_ref_type_set__106_ast_node(box_ref_242_bglt obj_29, type_bglt val1847_30)
{
   AN_OBJECT;
   {	/* Ast/node.scm 161 */
      return
	 ((((box_ref_242_bglt) CREF(obj_29))->type) = ((type_bglt) val1847_30), BUNSPEC);
   }
}



/* _box-ref-type-set! */
obj_t 
_box_ref_type_set__53_ast_node(obj_t env_2967, obj_t obj_2968, obj_t val1847_2969)
{
   AN_OBJECT;
   {	/* Ast/node.scm 161 */
      return
	 box_ref_type_set__106_ast_node(
	 (box_ref_242_bglt) (obj_2968),
	 (type_bglt) (val1847_2969));
   }
}



/* box-ref-type */
type_bglt 
box_ref_type_189_ast_node(box_ref_242_bglt obj_31)
{
   AN_OBJECT;
   {	/* Ast/node.scm 161 */
      return
	 (((box_ref_242_bglt) CREF(obj_31))->type);
   }
}



/* _box-ref-type */
obj_t 
_box_ref_type_146_ast_node(obj_t env_2970, obj_t obj_2971)
{
   AN_OBJECT;
   {	/* Ast/node.scm 161 */
      {		/* Ast/node.scm 161 */
	 type_bglt aux_3920;
	 aux_3920 =
	    box_ref_type_189_ast_node(
	    (box_ref_242_bglt) (obj_2971));
	 return
	    (obj_t) (aux_3920);
      }
   }
}



/* box-ref-side-effect?-set! */
obj_t 
box_ref_side_effect__set__120_ast_node(box_ref_242_bglt obj_32, obj_t val1848_33)
{
   AN_OBJECT;
   {	/* Ast/node.scm 29 */
      return
	 ((((box_ref_242_bglt) CREF(obj_32))->side_effect__165) = ((obj_t) val1848_33), BUNSPEC);
   }
}



/* _box-ref-side-effect?-set! */
obj_t 
_box_ref_side_effect__set__188_ast_node(obj_t env_2972, obj_t obj_2973, obj_t val1848_2974)
{
   AN_OBJECT;
   {	/* Ast/node.scm 29 */
      return
	 box_ref_side_effect__set__120_ast_node(
	 (box_ref_242_bglt) (obj_2973), val1848_2974);
   }
}



/* box-ref-side-effect? */
obj_t 
box_ref_side_effect__200_ast_node(box_ref_242_bglt obj_34)
{
   AN_OBJECT;
   {	/* Ast/node.scm 29 */
      return
	 (((box_ref_242_bglt) CREF(obj_34))->side_effect__165);
   }
}



/* _box-ref-side-effect? */
obj_t 
_box_ref_side_effect__222_ast_node(obj_t env_2975, obj_t obj_2976)
{
   AN_OBJECT;
   {	/* Ast/node.scm 29 */
      return
	 box_ref_side_effect__200_ast_node(
	 (box_ref_242_bglt) (obj_2976));
   }
}



/* box-ref-key-set! */
obj_t 
box_ref_key_set__192_ast_node(box_ref_242_bglt obj_35, obj_t val1849_36)
{
   AN_OBJECT;
   {	/* Ast/node.scm 33 */
      return
	 ((((box_ref_242_bglt) CREF(obj_35))->key) = ((obj_t) val1849_36), BUNSPEC);
   }
}



/* _box-ref-key-set!2514 */
obj_t 
_box_ref_key_set_2514_229_ast_node(obj_t env_2977, obj_t obj_2978, obj_t val1849_2979)
{
   AN_OBJECT;
   {	/* Ast/node.scm 33 */
      return
	 box_ref_key_set__192_ast_node(
	 (box_ref_242_bglt) (obj_2978), val1849_2979);
   }
}



/* box-ref-key */
obj_t 
box_ref_key_221_ast_node(box_ref_242_bglt obj_37)
{
   AN_OBJECT;
   {	/* Ast/node.scm 33 */
      return
	 (((box_ref_242_bglt) CREF(obj_37))->key);
   }
}



/* _box-ref-key2515 */
obj_t 
_box_ref_key2515_204_ast_node(obj_t env_2980, obj_t obj_2981)
{
   AN_OBJECT;
   {	/* Ast/node.scm 33 */
      return
	 box_ref_key_221_ast_node(
	 (box_ref_242_bglt) (obj_2981));
   }
}



/* box-ref-var-set! */
obj_t 
box_ref_var_set__147_ast_node(box_ref_242_bglt obj_38, var_bglt val1850_39)
{
   AN_OBJECT;
   {	/* Ast/node.scm 161 */
      return
	 ((((box_ref_242_bglt) CREF(obj_38))->var) = ((var_bglt) val1850_39), BUNSPEC);
   }
}



/* _box-ref-var-set! */
obj_t 
_box_ref_var_set__55_ast_node(obj_t env_2982, obj_t obj_2983, obj_t val1850_2984)
{
   AN_OBJECT;
   {	/* Ast/node.scm 161 */
      return
	 box_ref_var_set__147_ast_node(
	 (box_ref_242_bglt) (obj_2983),
	 (var_bglt) (val1850_2984));
   }
}



/* box-ref-var */
var_bglt 
box_ref_var_141_ast_node(box_ref_242_bglt obj_40)
{
   AN_OBJECT;
   {	/* Ast/node.scm 161 */
      return
	 (((box_ref_242_bglt) CREF(obj_40))->var);
   }
}



/* _box-ref-var */
obj_t 
_box_ref_var_228_ast_node(obj_t env_2985, obj_t obj_2986)
{
   AN_OBJECT;
   {	/* Ast/node.scm 161 */
      {		/* Ast/node.scm 161 */
	 var_bglt aux_3941;
	 aux_3941 =
	    box_ref_var_141_ast_node(
	    (box_ref_242_bglt) (obj_2986));
	 return
	    (obj_t) (aux_3941);
      }
   }
}



/* allocate-make-box */
make_box_202_bglt 
allocate_make_box_201_ast_node()
{
   AN_OBJECT;
   {	/* Ast/node.scm 157 */
      {		/* Ast/node.scm 157 */
	 make_box_202_bglt new1824_920;
	 new1824_920 =
	    ((make_box_202_bglt) BREF(GC_MALLOC(sizeof(struct make_box_202))));
	 {	/* Ast/node.scm 157 */
	    long arg2154_921;
	    arg2154_921 =
	       class_num_218___object(make_box_202_ast_node);
	    {	/* Ast/node.scm 157 */
	       obj_t obj_1867;
	       obj_1867 =
		  (obj_t) (new1824_920);
	       (((obj_t) CREF(obj_1867))->header = MAKE_HEADER(arg2154_921, 0), BUNSPEC);
	    }
	 }
	 {	/* Ast/node.scm 157 */
	    object_bglt aux_3949;
	    aux_3949 =
	       (object_bglt) (new1824_920);
	    OBJECT_WIDENING_SET(aux_3949, BFALSE);
	 }
	 return new1824_920;
      }
   }
}



/* _allocate-make-box */
obj_t 
_allocate_make_box_168_ast_node(obj_t env_2930)
{
   AN_OBJECT;
   {	/* Ast/node.scm 157 */
      {		/* Ast/node.scm 157 */
	 make_box_202_bglt aux_3952;
	 aux_3952 =
	    allocate_make_box_201_ast_node();
	 return
	    (obj_t) (aux_3952);
      }
   }
}



/* make-box? */
bool_t 
make_box__243_ast_node(obj_t obj_44)
{
   AN_OBJECT;
   {	/* Ast/node.scm 157 */
      return
	 is_a__118___object(obj_44, make_box_202_ast_node);
   }
}



/* _make-box? */
obj_t 
_make_box__204_ast_node(obj_t env_2987, obj_t obj_2988)
{
   AN_OBJECT;
   {	/* Ast/node.scm 157 */
      {		/* Ast/node.scm 157 */
	 bool_t aux_3956;
	 aux_3956 =
	    make_box__243_ast_node(obj_2988);
	 return
	    BBOOL(aux_3956);
      }
   }
}



/* make-make-box */
make_box_202_bglt 
make_make_box_156_ast_node(obj_t loc_45, type_bglt type_46, obj_t side_effect__165_47, obj_t key_48, node_bglt value_49)
{
   AN_OBJECT;
   {	/* Ast/node.scm 157 */
      {		/* Ast/node.scm 157 */
	 make_box_202_bglt new1817_1869;
	 new1817_1869 =
	    ((make_box_202_bglt) BREF(GC_MALLOC(sizeof(struct make_box_202))));
	 {	/* Ast/node.scm 157 */
	    long arg2155_1870;
	    arg2155_1870 =
	       class_num_218___object(make_box_202_ast_node);
	    {	/* Ast/node.scm 157 */
	       obj_t obj_1876;
	       obj_1876 =
		  (obj_t) (new1817_1869);
	       (((obj_t) CREF(obj_1876))->header = MAKE_HEADER(arg2155_1870, 0), BUNSPEC);
	    }
	 }
	 {	/* Ast/node.scm 157 */
	    object_bglt aux_3963;
	    aux_3963 =
	       (object_bglt) (new1817_1869);
	    OBJECT_WIDENING_SET(aux_3963, BFALSE);
	 }
	 ((((make_box_202_bglt) CREF(new1817_1869))->loc) = ((obj_t) loc_45), BUNSPEC);
	 ((((make_box_202_bglt) CREF(new1817_1869))->type) = ((type_bglt) type_46), BUNSPEC);
	 ((((make_box_202_bglt) CREF(new1817_1869))->side_effect__165) = ((obj_t) side_effect__165_47), BUNSPEC);
	 ((((make_box_202_bglt) CREF(new1817_1869))->key) = ((obj_t) key_48), BUNSPEC);
	 ((((make_box_202_bglt) CREF(new1817_1869))->value) = ((node_bglt) value_49), BUNSPEC);
	 return new1817_1869;
      }
   }
}



/* _make-make-box */
obj_t 
_make_make_box_207_ast_node(obj_t env_2989, obj_t loc_2990, obj_t type_2991, obj_t side_effect__165_2992, obj_t key_2993, obj_t value_2994)
{
   AN_OBJECT;
   {	/* Ast/node.scm 157 */
      {		/* Ast/node.scm 157 */
	 make_box_202_bglt aux_3971;
	 aux_3971 =
	    make_make_box_156_ast_node(loc_2990,
	    (type_bglt) (type_2991), side_effect__165_2992, key_2993,
	    (node_bglt) (value_2994));
	 return
	    (obj_t) (aux_3971);
      }
   }
}



/* make-box-loc */
obj_t 
make_box_loc_202_ast_node(make_box_202_bglt obj_50)
{
   AN_OBJECT;
   {	/* Ast/node.scm 21 */
      return
	 (((make_box_202_bglt) CREF(obj_50))->loc);
   }
}



/* _make-box-loc */
obj_t 
_make_box_loc_121_ast_node(obj_t env_2995, obj_t obj_2996)
{
   AN_OBJECT;
   {	/* Ast/node.scm 21 */
      return
	 make_box_loc_202_ast_node(
	 (make_box_202_bglt) (obj_2996));
   }
}



/* make-box-type-set! */
obj_t 
make_box_type_set__149_ast_node(make_box_202_bglt obj_51, type_bglt val1813_52)
{
   AN_OBJECT;
   {	/* Ast/node.scm 157 */
      return
	 ((((make_box_202_bglt) CREF(obj_51))->type) = ((type_bglt) val1813_52), BUNSPEC);
   }
}



/* _make-box-type-set! */
obj_t 
_make_box_type_set__195_ast_node(obj_t env_2997, obj_t obj_2998, obj_t val1813_2999)
{
   AN_OBJECT;
   {	/* Ast/node.scm 157 */
      return
	 make_box_type_set__149_ast_node(
	 (make_box_202_bglt) (obj_2998),
	 (type_bglt) (val1813_2999));
   }
}



/* make-box-type */
type_bglt 
make_box_type_89_ast_node(make_box_202_bglt obj_53)
{
   AN_OBJECT;
   {	/* Ast/node.scm 157 */
      return
	 (((make_box_202_bglt) CREF(obj_53))->type);
   }
}



/* _make-box-type */
obj_t 
_make_box_type_123_ast_node(obj_t env_3000, obj_t obj_3001)
{
   AN_OBJECT;
   {	/* Ast/node.scm 157 */
      {		/* Ast/node.scm 157 */
	 type_bglt aux_3984;
	 aux_3984 =
	    make_box_type_89_ast_node(
	    (make_box_202_bglt) (obj_3001));
	 return
	    (obj_t) (aux_3984);
      }
   }
}



/* make-box-side-effect?-set! */
obj_t 
make_box_side_effect__set__123_ast_node(make_box_202_bglt obj_54, obj_t val1814_55)
{
   AN_OBJECT;
   {	/* Ast/node.scm 29 */
      return
	 ((((make_box_202_bglt) CREF(obj_54))->side_effect__165) = ((obj_t) val1814_55), BUNSPEC);
   }
}



/* _make-box-side-effect?-set! */
obj_t 
_make_box_side_effect__set__19_ast_node(obj_t env_3002, obj_t obj_3003, obj_t val1814_3004)
{
   AN_OBJECT;
   {	/* Ast/node.scm 29 */
      return
	 make_box_side_effect__set__123_ast_node(
	 (make_box_202_bglt) (obj_3003), val1814_3004);
   }
}



/* make-box-side-effect? */
obj_t 
make_box_side_effect__247_ast_node(make_box_202_bglt obj_56)
{
   AN_OBJECT;
   {	/* Ast/node.scm 29 */
      return
	 (((make_box_202_bglt) CREF(obj_56))->side_effect__165);
   }
}



/* _make-box-side-effect? */
obj_t 
_make_box_side_effect__32_ast_node(obj_t env_3005, obj_t obj_3006)
{
   AN_OBJECT;
   {	/* Ast/node.scm 29 */
      return
	 make_box_side_effect__247_ast_node(
	 (make_box_202_bglt) (obj_3006));
   }
}



/* make-box-key-set! */
obj_t 
make_box_key_set__183_ast_node(make_box_202_bglt obj_57, obj_t val1815_58)
{
   AN_OBJECT;
   {	/* Ast/node.scm 33 */
      return
	 ((((make_box_202_bglt) CREF(obj_57))->key) = ((obj_t) val1815_58), BUNSPEC);
   }
}



/* _make-box-key-set!2516 */
obj_t 
_make_box_key_set_2516_65_ast_node(obj_t env_3007, obj_t obj_3008, obj_t val1815_3009)
{
   AN_OBJECT;
   {	/* Ast/node.scm 33 */
      return
	 make_box_key_set__183_ast_node(
	 (make_box_202_bglt) (obj_3008), val1815_3009);
   }
}



/* make-box-key */
obj_t 
make_box_key_223_ast_node(make_box_202_bglt obj_59)
{
   AN_OBJECT;
   {	/* Ast/node.scm 33 */
      return
	 (((make_box_202_bglt) CREF(obj_59))->key);
   }
}



/* _make-box-key2517 */
obj_t 
_make_box_key2517_6_ast_node(obj_t env_3010, obj_t obj_3011)
{
   AN_OBJECT;
   {	/* Ast/node.scm 33 */
      return
	 make_box_key_223_ast_node(
	 (make_box_202_bglt) (obj_3011));
   }
}



/* make-box-value-set! */
obj_t 
make_box_value_set__112_ast_node(make_box_202_bglt obj_60, node_bglt val1816_61)
{
   AN_OBJECT;
   {	/* Ast/node.scm 157 */
      return
	 ((((make_box_202_bglt) CREF(obj_60))->value) = ((node_bglt) val1816_61), BUNSPEC);
   }
}



/* _make-box-value-set! */
obj_t 
_make_box_value_set__157_ast_node(obj_t env_3012, obj_t obj_3013, obj_t val1816_3014)
{
   AN_OBJECT;
   {	/* Ast/node.scm 157 */
      return
	 make_box_value_set__112_ast_node(
	 (make_box_202_bglt) (obj_3013),
	 (node_bglt) (val1816_3014));
   }
}



/* make-box-value */
node_bglt 
make_box_value_197_ast_node(make_box_202_bglt obj_62)
{
   AN_OBJECT;
   {	/* Ast/node.scm 157 */
      return
	 (((make_box_202_bglt) CREF(obj_62))->value);
   }
}



/* _make-box-value */
obj_t 
_make_box_value_94_ast_node(obj_t env_3015, obj_t obj_3016)
{
   AN_OBJECT;
   {	/* Ast/node.scm 157 */
      {		/* Ast/node.scm 157 */
	 node_bglt aux_4005;
	 aux_4005 =
	    make_box_value_197_ast_node(
	    (make_box_202_bglt) (obj_3016));
	 return
	    (obj_t) (aux_4005);
      }
   }
}



/* allocate-jump-ex-it */
jump_ex_it_184_bglt 
allocate_jump_ex_it_22_ast_node()
{
   AN_OBJECT;
   {	/* Ast/node.scm 150 */
      {		/* Ast/node.scm 150 */
	 jump_ex_it_184_bglt new1793_929;
	 new1793_929 =
	    ((jump_ex_it_184_bglt) BREF(GC_MALLOC(sizeof(struct jump_ex_it_184))));
	 {	/* Ast/node.scm 150 */
	    long arg2156_930;
	    arg2156_930 =
	       class_num_218___object(jump_ex_it_184_ast_node);
	    {	/* Ast/node.scm 150 */
	       obj_t obj_1878;
	       obj_1878 =
		  (obj_t) (new1793_929);
	       (((obj_t) CREF(obj_1878))->header = MAKE_HEADER(arg2156_930, 0), BUNSPEC);
	    }
	 }
	 {	/* Ast/node.scm 150 */
	    object_bglt aux_4013;
	    aux_4013 =
	       (object_bglt) (new1793_929);
	    OBJECT_WIDENING_SET(aux_4013, BFALSE);
	 }
	 return new1793_929;
      }
   }
}



/* _allocate-jump-ex-it */
obj_t 
_allocate_jump_ex_it_189_ast_node(obj_t env_2929)
{
   AN_OBJECT;
   {	/* Ast/node.scm 150 */
      {		/* Ast/node.scm 150 */
	 jump_ex_it_184_bglt aux_4016;
	 aux_4016 =
	    allocate_jump_ex_it_22_ast_node();
	 return
	    (obj_t) (aux_4016);
      }
   }
}



/* jump-ex-it? */
bool_t 
jump_ex_it__122_ast_node(obj_t obj_66)
{
   AN_OBJECT;
   {	/* Ast/node.scm 150 */
      return
	 is_a__118___object(obj_66, jump_ex_it_184_ast_node);
   }
}



/* _jump-ex-it? */
obj_t 
_jump_ex_it__165_ast_node(obj_t env_3017, obj_t obj_3018)
{
   AN_OBJECT;
   {	/* Ast/node.scm 150 */
      {		/* Ast/node.scm 150 */
	 bool_t aux_4020;
	 aux_4020 =
	    jump_ex_it__122_ast_node(obj_3018);
	 return
	    BBOOL(aux_4020);
      }
   }
}



/* make-jump-ex-it */
jump_ex_it_184_bglt 
make_jump_ex_it_21_ast_node(obj_t loc_67, type_bglt type_68, node_bglt exit_69, node_bglt value_70)
{
   AN_OBJECT;
   {	/* Ast/node.scm 150 */
      {		/* Ast/node.scm 150 */
	 jump_ex_it_184_bglt new1787_1880;
	 new1787_1880 =
	    ((jump_ex_it_184_bglt) BREF(GC_MALLOC(sizeof(struct jump_ex_it_184))));
	 {	/* Ast/node.scm 150 */
	    long arg2157_1881;
	    arg2157_1881 =
	       class_num_218___object(jump_ex_it_184_ast_node);
	    {	/* Ast/node.scm 150 */
	       obj_t obj_1886;
	       obj_1886 =
		  (obj_t) (new1787_1880);
	       (((obj_t) CREF(obj_1886))->header = MAKE_HEADER(arg2157_1881, 0), BUNSPEC);
	    }
	 }
	 {	/* Ast/node.scm 150 */
	    object_bglt aux_4027;
	    aux_4027 =
	       (object_bglt) (new1787_1880);
	    OBJECT_WIDENING_SET(aux_4027, BFALSE);
	 }
	 ((((jump_ex_it_184_bglt) CREF(new1787_1880))->loc) = ((obj_t) loc_67), BUNSPEC);
	 ((((jump_ex_it_184_bglt) CREF(new1787_1880))->type) = ((type_bglt) type_68), BUNSPEC);
	 ((((jump_ex_it_184_bglt) CREF(new1787_1880))->exit) = ((node_bglt) exit_69), BUNSPEC);
	 ((((jump_ex_it_184_bglt) CREF(new1787_1880))->value) = ((node_bglt) value_70), BUNSPEC);
	 return new1787_1880;
      }
   }
}



/* _make-jump-ex-it */
obj_t 
_make_jump_ex_it_55_ast_node(obj_t env_3019, obj_t loc_3020, obj_t type_3021, obj_t exit_3022, obj_t value_3023)
{
   AN_OBJECT;
   {	/* Ast/node.scm 150 */
      {		/* Ast/node.scm 150 */
	 jump_ex_it_184_bglt aux_4034;
	 aux_4034 =
	    make_jump_ex_it_21_ast_node(loc_3020,
	    (type_bglt) (type_3021),
	    (node_bglt) (exit_3022),
	    (node_bglt) (value_3023));
	 return
	    (obj_t) (aux_4034);
      }
   }
}



/* jump-ex-it-loc */
obj_t 
jump_ex_it_loc_88_ast_node(jump_ex_it_184_bglt obj_71)
{
   AN_OBJECT;
   {	/* Ast/node.scm 21 */
      return
	 (((jump_ex_it_184_bglt) CREF(obj_71))->loc);
   }
}



/* _jump-ex-it-loc */
obj_t 
_jump_ex_it_loc_220_ast_node(obj_t env_3024, obj_t obj_3025)
{
   AN_OBJECT;
   {	/* Ast/node.scm 21 */
      return
	 jump_ex_it_loc_88_ast_node(
	 (jump_ex_it_184_bglt) (obj_3025));
   }
}



/* jump-ex-it-type-set! */
obj_t 
jump_ex_it_type_set__142_ast_node(jump_ex_it_184_bglt obj_72, type_bglt val1784_73)
{
   AN_OBJECT;
   {	/* Ast/node.scm 150 */
      return
	 ((((jump_ex_it_184_bglt) CREF(obj_72))->type) = ((type_bglt) val1784_73), BUNSPEC);
   }
}



/* _jump-ex-it-type-set! */
obj_t 
_jump_ex_it_type_set__106_ast_node(obj_t env_3026, obj_t obj_3027, obj_t val1784_3028)
{
   AN_OBJECT;
   {	/* Ast/node.scm 150 */
      return
	 jump_ex_it_type_set__142_ast_node(
	 (jump_ex_it_184_bglt) (obj_3027),
	 (type_bglt) (val1784_3028));
   }
}



/* jump-ex-it-type */
type_bglt 
jump_ex_it_type_39_ast_node(jump_ex_it_184_bglt obj_74)
{
   AN_OBJECT;
   {	/* Ast/node.scm 150 */
      return
	 (((jump_ex_it_184_bglt) CREF(obj_74))->type);
   }
}



/* _jump-ex-it-type */
obj_t 
_jump_ex_it_type_189_ast_node(obj_t env_3029, obj_t obj_3030)
{
   AN_OBJECT;
   {	/* Ast/node.scm 150 */
      {		/* Ast/node.scm 150 */
	 type_bglt aux_4048;
	 aux_4048 =
	    jump_ex_it_type_39_ast_node(
	    (jump_ex_it_184_bglt) (obj_3030));
	 return
	    (obj_t) (aux_4048);
      }
   }
}



/* jump-ex-it-exit-set! */
obj_t 
jump_ex_it_exit_set__84_ast_node(jump_ex_it_184_bglt obj_75, node_bglt val1785_76)
{
   AN_OBJECT;
   {	/* Ast/node.scm 150 */
      return
	 ((((jump_ex_it_184_bglt) CREF(obj_75))->exit) = ((node_bglt) val1785_76), BUNSPEC);
   }
}



/* _jump-ex-it-exit-set! */
obj_t 
_jump_ex_it_exit_set__1_ast_node(obj_t env_3031, obj_t obj_3032, obj_t val1785_3033)
{
   AN_OBJECT;
   {	/* Ast/node.scm 150 */
      return
	 jump_ex_it_exit_set__84_ast_node(
	 (jump_ex_it_184_bglt) (obj_3032),
	 (node_bglt) (val1785_3033));
   }
}



/* jump-ex-it-exit */
node_bglt 
jump_ex_it_exit_9_ast_node(jump_ex_it_184_bglt obj_77)
{
   AN_OBJECT;
   {	/* Ast/node.scm 150 */
      return
	 (((jump_ex_it_184_bglt) CREF(obj_77))->exit);
   }
}



/* _jump-ex-it-exit */
obj_t 
_jump_ex_it_exit_250_ast_node(obj_t env_3034, obj_t obj_3035)
{
   AN_OBJECT;
   {	/* Ast/node.scm 150 */
      {		/* Ast/node.scm 150 */
	 node_bglt aux_4057;
	 aux_4057 =
	    jump_ex_it_exit_9_ast_node(
	    (jump_ex_it_184_bglt) (obj_3035));
	 return
	    (obj_t) (aux_4057);
      }
   }
}



/* jump-ex-it-value-set! */
obj_t 
jump_ex_it_value_set__158_ast_node(jump_ex_it_184_bglt obj_78, node_bglt val1786_79)
{
   AN_OBJECT;
   {	/* Ast/node.scm 150 */
      return
	 ((((jump_ex_it_184_bglt) CREF(obj_78))->value) = ((node_bglt) val1786_79), BUNSPEC);
   }
}



/* _jump-ex-it-value-set! */
obj_t 
_jump_ex_it_value_set__227_ast_node(obj_t env_3036, obj_t obj_3037, obj_t val1786_3038)
{
   AN_OBJECT;
   {	/* Ast/node.scm 150 */
      return
	 jump_ex_it_value_set__158_ast_node(
	 (jump_ex_it_184_bglt) (obj_3037),
	 (node_bglt) (val1786_3038));
   }
}



/* jump-ex-it-value */
node_bglt 
jump_ex_it_value_145_ast_node(jump_ex_it_184_bglt obj_80)
{
   AN_OBJECT;
   {	/* Ast/node.scm 150 */
      return
	 (((jump_ex_it_184_bglt) CREF(obj_80))->value);
   }
}



/* _jump-ex-it-value */
obj_t 
_jump_ex_it_value_253_ast_node(obj_t env_3039, obj_t obj_3040)
{
   AN_OBJECT;
   {	/* Ast/node.scm 150 */
      {		/* Ast/node.scm 150 */
	 node_bglt aux_4066;
	 aux_4066 =
	    jump_ex_it_value_145_ast_node(
	    (jump_ex_it_184_bglt) (obj_3040));
	 return
	    (obj_t) (aux_4066);
      }
   }
}



/* allocate-set-ex-it */
set_ex_it_116_bglt 
allocate_set_ex_it_57_ast_node()
{
   AN_OBJECT;
   {	/* Ast/node.scm 143 */
      {		/* Ast/node.scm 143 */
	 set_ex_it_116_bglt new1764_937;
	 new1764_937 =
	    ((set_ex_it_116_bglt) BREF(GC_MALLOC(sizeof(struct set_ex_it_116))));
	 {	/* Ast/node.scm 143 */
	    long arg2158_938;
	    arg2158_938 =
	       class_num_218___object(set_ex_it_116_ast_node);
	    {	/* Ast/node.scm 143 */
	       obj_t obj_1888;
	       obj_1888 =
		  (obj_t) (new1764_937);
	       (((obj_t) CREF(obj_1888))->header = MAKE_HEADER(arg2158_938, 0), BUNSPEC);
	    }
	 }
	 {	/* Ast/node.scm 143 */
	    object_bglt aux_4074;
	    aux_4074 =
	       (object_bglt) (new1764_937);
	    OBJECT_WIDENING_SET(aux_4074, BFALSE);
	 }
	 return new1764_937;
      }
   }
}



/* _allocate-set-ex-it */
obj_t 
_allocate_set_ex_it_70_ast_node(obj_t env_2928)
{
   AN_OBJECT;
   {	/* Ast/node.scm 143 */
      {		/* Ast/node.scm 143 */
	 set_ex_it_116_bglt aux_4077;
	 aux_4077 =
	    allocate_set_ex_it_57_ast_node();
	 return
	    (obj_t) (aux_4077);
      }
   }
}



/* set-ex-it? */
bool_t 
set_ex_it__46_ast_node(obj_t obj_84)
{
   AN_OBJECT;
   {	/* Ast/node.scm 143 */
      return
	 is_a__118___object(obj_84, set_ex_it_116_ast_node);
   }
}



/* _set-ex-it? */
obj_t 
_set_ex_it__35_ast_node(obj_t env_3041, obj_t obj_3042)
{
   AN_OBJECT;
   {	/* Ast/node.scm 143 */
      {		/* Ast/node.scm 143 */
	 bool_t aux_4081;
	 aux_4081 =
	    set_ex_it__46_ast_node(obj_3042);
	 return
	    BBOOL(aux_4081);
      }
   }
}



/* make-set-ex-it */
set_ex_it_116_bglt 
make_set_ex_it_81_ast_node(obj_t loc_85, type_bglt type_86, var_bglt var_87, node_bglt body_88)
{
   AN_OBJECT;
   {	/* Ast/node.scm 143 */
      {		/* Ast/node.scm 143 */
	 set_ex_it_116_bglt new1758_1890;
	 new1758_1890 =
	    ((set_ex_it_116_bglt) BREF(GC_MALLOC(sizeof(struct set_ex_it_116))));
	 {	/* Ast/node.scm 143 */
	    long arg2159_1891;
	    arg2159_1891 =
	       class_num_218___object(set_ex_it_116_ast_node);
	    {	/* Ast/node.scm 143 */
	       obj_t obj_1896;
	       obj_1896 =
		  (obj_t) (new1758_1890);
	       (((obj_t) CREF(obj_1896))->header = MAKE_HEADER(arg2159_1891, 0), BUNSPEC);
	    }
	 }
	 {	/* Ast/node.scm 143 */
	    object_bglt aux_4088;
	    aux_4088 =
	       (object_bglt) (new1758_1890);
	    OBJECT_WIDENING_SET(aux_4088, BFALSE);
	 }
	 ((((set_ex_it_116_bglt) CREF(new1758_1890))->loc) = ((obj_t) loc_85), BUNSPEC);
	 ((((set_ex_it_116_bglt) CREF(new1758_1890))->type) = ((type_bglt) type_86), BUNSPEC);
	 ((((set_ex_it_116_bglt) CREF(new1758_1890))->var) = ((var_bglt) var_87), BUNSPEC);
	 ((((set_ex_it_116_bglt) CREF(new1758_1890))->body) = ((node_bglt) body_88), BUNSPEC);
	 return new1758_1890;
      }
   }
}



/* _make-set-ex-it */
obj_t 
_make_set_ex_it_124_ast_node(obj_t env_3043, obj_t loc_3044, obj_t type_3045, obj_t var_3046, obj_t body_3047)
{
   AN_OBJECT;
   {	/* Ast/node.scm 143 */
      {		/* Ast/node.scm 143 */
	 set_ex_it_116_bglt aux_4095;
	 aux_4095 =
	    make_set_ex_it_81_ast_node(loc_3044,
	    (type_bglt) (type_3045),
	    (var_bglt) (var_3046),
	    (node_bglt) (body_3047));
	 return
	    (obj_t) (aux_4095);
      }
   }
}



/* set-ex-it-loc */
obj_t 
set_ex_it_loc_71_ast_node(set_ex_it_116_bglt obj_89)
{
   AN_OBJECT;
   {	/* Ast/node.scm 21 */
      return
	 (((set_ex_it_116_bglt) CREF(obj_89))->loc);
   }
}



/* _set-ex-it-loc */
obj_t 
_set_ex_it_loc_117_ast_node(obj_t env_3048, obj_t obj_3049)
{
   AN_OBJECT;
   {	/* Ast/node.scm 21 */
      return
	 set_ex_it_loc_71_ast_node(
	 (set_ex_it_116_bglt) (obj_3049));
   }
}



/* set-ex-it-type-set! */
obj_t 
set_ex_it_type_set__207_ast_node(set_ex_it_116_bglt obj_90, type_bglt val1755_91)
{
   AN_OBJECT;
   {	/* Ast/node.scm 143 */
      return
	 ((((set_ex_it_116_bglt) CREF(obj_90))->type) = ((type_bglt) val1755_91), BUNSPEC);
   }
}



/* _set-ex-it-type-set! */
obj_t 
_set_ex_it_type_set__42_ast_node(obj_t env_3050, obj_t obj_3051, obj_t val1755_3052)
{
   AN_OBJECT;
   {	/* Ast/node.scm 143 */
      return
	 set_ex_it_type_set__207_ast_node(
	 (set_ex_it_116_bglt) (obj_3051),
	 (type_bglt) (val1755_3052));
   }
}



/* set-ex-it-type */
type_bglt 
set_ex_it_type_46_ast_node(set_ex_it_116_bglt obj_92)
{
   AN_OBJECT;
   {	/* Ast/node.scm 143 */
      return
	 (((set_ex_it_116_bglt) CREF(obj_92))->type);
   }
}



/* _set-ex-it-type */
obj_t 
_set_ex_it_type_93_ast_node(obj_t env_3053, obj_t obj_3054)
{
   AN_OBJECT;
   {	/* Ast/node.scm 143 */
      {		/* Ast/node.scm 143 */
	 type_bglt aux_4109;
	 aux_4109 =
	    set_ex_it_type_46_ast_node(
	    (set_ex_it_116_bglt) (obj_3054));
	 return
	    (obj_t) (aux_4109);
      }
   }
}



/* set-ex-it-var-set! */
obj_t 
set_ex_it_var_set__67_ast_node(set_ex_it_116_bglt obj_93, var_bglt val1756_94)
{
   AN_OBJECT;
   {	/* Ast/node.scm 143 */
      return
	 ((((set_ex_it_116_bglt) CREF(obj_93))->var) = ((var_bglt) val1756_94), BUNSPEC);
   }
}



/* _set-ex-it-var-set! */
obj_t 
_set_ex_it_var_set__39_ast_node(obj_t env_3055, obj_t obj_3056, obj_t val1756_3057)
{
   AN_OBJECT;
   {	/* Ast/node.scm 143 */
      return
	 set_ex_it_var_set__67_ast_node(
	 (set_ex_it_116_bglt) (obj_3056),
	 (var_bglt) (val1756_3057));
   }
}



/* set-ex-it-var */
var_bglt 
set_ex_it_var_31_ast_node(set_ex_it_116_bglt obj_95)
{
   AN_OBJECT;
   {	/* Ast/node.scm 143 */
      return
	 (((set_ex_it_116_bglt) CREF(obj_95))->var);
   }
}



/* _set-ex-it-var */
obj_t 
_set_ex_it_var_69_ast_node(obj_t env_3058, obj_t obj_3059)
{
   AN_OBJECT;
   {	/* Ast/node.scm 143 */
      {		/* Ast/node.scm 143 */
	 var_bglt aux_4118;
	 aux_4118 =
	    set_ex_it_var_31_ast_node(
	    (set_ex_it_116_bglt) (obj_3059));
	 return
	    (obj_t) (aux_4118);
      }
   }
}



/* set-ex-it-body-set! */
obj_t 
set_ex_it_body_set__234_ast_node(set_ex_it_116_bglt obj_96, node_bglt val1757_97)
{
   AN_OBJECT;
   {	/* Ast/node.scm 143 */
      return
	 ((((set_ex_it_116_bglt) CREF(obj_96))->body) = ((node_bglt) val1757_97), BUNSPEC);
   }
}



/* _set-ex-it-body-set! */
obj_t 
_set_ex_it_body_set__11_ast_node(obj_t env_3060, obj_t obj_3061, obj_t val1757_3062)
{
   AN_OBJECT;
   {	/* Ast/node.scm 143 */
      return
	 set_ex_it_body_set__234_ast_node(
	 (set_ex_it_116_bglt) (obj_3061),
	 (node_bglt) (val1757_3062));
   }
}



/* set-ex-it-body */
node_bglt 
set_ex_it_body_246_ast_node(set_ex_it_116_bglt obj_98)
{
   AN_OBJECT;
   {	/* Ast/node.scm 143 */
      return
	 (((set_ex_it_116_bglt) CREF(obj_98))->body);
   }
}



/* _set-ex-it-body */
obj_t 
_set_ex_it_body_118_ast_node(obj_t env_3063, obj_t obj_3064)
{
   AN_OBJECT;
   {	/* Ast/node.scm 143 */
      {		/* Ast/node.scm 143 */
	 node_bglt aux_4127;
	 aux_4127 =
	    set_ex_it_body_246_ast_node(
	    (set_ex_it_116_bglt) (obj_3064));
	 return
	    (obj_t) (aux_4127);
      }
   }
}



/* allocate-let-var */
let_var_6_bglt 
allocate_let_var_32_ast_node()
{
   AN_OBJECT;
   {	/* Ast/node.scm 134 */
      {		/* Ast/node.scm 134 */
	 let_var_6_bglt new1724_945;
	 new1724_945 =
	    ((let_var_6_bglt) BREF(GC_MALLOC(sizeof(struct let_var_6))));
	 {	/* Ast/node.scm 134 */
	    long arg2160_946;
	    arg2160_946 =
	       class_num_218___object(let_var_6_ast_node);
	    {	/* Ast/node.scm 134 */
	       obj_t obj_1898;
	       obj_1898 =
		  (obj_t) (new1724_945);
	       (((obj_t) CREF(obj_1898))->header = MAKE_HEADER(arg2160_946, 0), BUNSPEC);
	    }
	 }
	 {	/* Ast/node.scm 134 */
	    object_bglt aux_4135;
	    aux_4135 =
	       (object_bglt) (new1724_945);
	    OBJECT_WIDENING_SET(aux_4135, BFALSE);
	 }
	 return new1724_945;
      }
   }
}



/* _allocate-let-var */
obj_t 
_allocate_let_var_179_ast_node(obj_t env_2927)
{
   AN_OBJECT;
   {	/* Ast/node.scm 134 */
      {		/* Ast/node.scm 134 */
	 let_var_6_bglt aux_4138;
	 aux_4138 =
	    allocate_let_var_32_ast_node();
	 return
	    (obj_t) (aux_4138);
      }
   }
}



/* let-var? */
bool_t 
let_var__167_ast_node(obj_t obj_102)
{
   AN_OBJECT;
   {	/* Ast/node.scm 134 */
      return
	 is_a__118___object(obj_102, let_var_6_ast_node);
   }
}



/* _let-var? */
obj_t 
_let_var__141_ast_node(obj_t env_3065, obj_t obj_3066)
{
   AN_OBJECT;
   {	/* Ast/node.scm 134 */
      {		/* Ast/node.scm 134 */
	 bool_t aux_4142;
	 aux_4142 =
	    let_var__167_ast_node(obj_3066);
	 return
	    BBOOL(aux_4142);
      }
   }
}



/* make-let-var */
let_var_6_bglt 
make_let_var_217_ast_node(obj_t loc_103, type_bglt type_104, obj_t side_effect__165_105, obj_t key_106, obj_t bindings_107, node_bglt body_108, bool_t removable__42_109)
{
   AN_OBJECT;
   {	/* Ast/node.scm 134 */
      {		/* Ast/node.scm 134 */
	 let_var_6_bglt new1715_1900;
	 new1715_1900 =
	    ((let_var_6_bglt) BREF(GC_MALLOC(sizeof(struct let_var_6))));
	 {	/* Ast/node.scm 134 */
	    long arg2162_1901;
	    arg2162_1901 =
	       class_num_218___object(let_var_6_ast_node);
	    {	/* Ast/node.scm 134 */
	       obj_t obj_1909;
	       obj_1909 =
		  (obj_t) (new1715_1900);
	       (((obj_t) CREF(obj_1909))->header = MAKE_HEADER(arg2162_1901, 0), BUNSPEC);
	    }
	 }
	 {	/* Ast/node.scm 134 */
	    object_bglt aux_4149;
	    aux_4149 =
	       (object_bglt) (new1715_1900);
	    OBJECT_WIDENING_SET(aux_4149, BFALSE);
	 }
	 ((((let_var_6_bglt) CREF(new1715_1900))->loc) = ((obj_t) loc_103), BUNSPEC);
	 ((((let_var_6_bglt) CREF(new1715_1900))->type) = ((type_bglt) type_104), BUNSPEC);
	 ((((let_var_6_bglt) CREF(new1715_1900))->side_effect__165) = ((obj_t) side_effect__165_105), BUNSPEC);
	 ((((let_var_6_bglt) CREF(new1715_1900))->key) = ((obj_t) key_106), BUNSPEC);
	 ((((let_var_6_bglt) CREF(new1715_1900))->bindings) = ((obj_t) bindings_107), BUNSPEC);
	 ((((let_var_6_bglt) CREF(new1715_1900))->body) = ((node_bglt) body_108), BUNSPEC);
	 ((((let_var_6_bglt) CREF(new1715_1900))->removable__42) = ((bool_t) removable__42_109), BUNSPEC);
	 return new1715_1900;
      }
   }
}



/* _make-let-var */
obj_t 
_make_let_var_42_ast_node(obj_t env_3067, obj_t loc_3068, obj_t type_3069, obj_t side_effect__165_3070, obj_t key_3071, obj_t bindings_3072, obj_t body_3073, obj_t removable__42_3074)
{
   AN_OBJECT;
   {	/* Ast/node.scm 134 */
      {		/* Ast/node.scm 134 */
	 let_var_6_bglt aux_4159;
	 aux_4159 =
	    make_let_var_217_ast_node(loc_3068,
	    (type_bglt) (type_3069), side_effect__165_3070, key_3071, bindings_3072,
	    (node_bglt) (body_3073),
	    CBOOL(removable__42_3074));
	 return
	    (obj_t) (aux_4159);
      }
   }
}



/* let-var-loc */
obj_t 
let_var_loc_249_ast_node(let_var_6_bglt obj_110)
{
   AN_OBJECT;
   {	/* Ast/node.scm 21 */
      return
	 (((let_var_6_bglt) CREF(obj_110))->loc);
   }
}



/* _let-var-loc */
obj_t 
_let_var_loc_227_ast_node(obj_t env_3075, obj_t obj_3076)
{
   AN_OBJECT;
   {	/* Ast/node.scm 21 */
      return
	 let_var_loc_249_ast_node(
	 (let_var_6_bglt) (obj_3076));
   }
}



/* let-var-type-set! */
obj_t 
let_var_type_set__107_ast_node(let_var_6_bglt obj_111, type_bglt val1709_112)
{
   AN_OBJECT;
   {	/* Ast/node.scm 134 */
      return
	 ((((let_var_6_bglt) CREF(obj_111))->type) = ((type_bglt) val1709_112), BUNSPEC);
   }
}



/* _let-var-type-set! */
obj_t 
_let_var_type_set__8_ast_node(obj_t env_3077, obj_t obj_3078, obj_t val1709_3079)
{
   AN_OBJECT;
   {	/* Ast/node.scm 134 */
      return
	 let_var_type_set__107_ast_node(
	 (let_var_6_bglt) (obj_3078),
	 (type_bglt) (val1709_3079));
   }
}



/* let-var-type */
type_bglt 
let_var_type_128_ast_node(let_var_6_bglt obj_113)
{
   AN_OBJECT;
   {	/* Ast/node.scm 134 */
      return
	 (((let_var_6_bglt) CREF(obj_113))->type);
   }
}



/* _let-var-type */
obj_t 
_let_var_type_59_ast_node(obj_t env_3080, obj_t obj_3081)
{
   AN_OBJECT;
   {	/* Ast/node.scm 134 */
      {		/* Ast/node.scm 134 */
	 type_bglt aux_4173;
	 aux_4173 =
	    let_var_type_128_ast_node(
	    (let_var_6_bglt) (obj_3081));
	 return
	    (obj_t) (aux_4173);
      }
   }
}



/* let-var-side-effect?-set! */
obj_t 
let_var_side_effect__set__111_ast_node(let_var_6_bglt obj_114, obj_t val1710_115)
{
   AN_OBJECT;
   {	/* Ast/node.scm 29 */
      return
	 ((((let_var_6_bglt) CREF(obj_114))->side_effect__165) = ((obj_t) val1710_115), BUNSPEC);
   }
}



/* _let-var-side-effect?-set! */
obj_t 
_let_var_side_effect__set__107_ast_node(obj_t env_3082, obj_t obj_3083, obj_t val1710_3084)
{
   AN_OBJECT;
   {	/* Ast/node.scm 29 */
      return
	 let_var_side_effect__set__111_ast_node(
	 (let_var_6_bglt) (obj_3083), val1710_3084);
   }
}



/* let-var-side-effect? */
obj_t 
let_var_side_effect__154_ast_node(let_var_6_bglt obj_116)
{
   AN_OBJECT;
   {	/* Ast/node.scm 29 */
      return
	 (((let_var_6_bglt) CREF(obj_116))->side_effect__165);
   }
}



/* _let-var-side-effect? */
obj_t 
_let_var_side_effect__128_ast_node(obj_t env_3085, obj_t obj_3086)
{
   AN_OBJECT;
   {	/* Ast/node.scm 29 */
      return
	 let_var_side_effect__154_ast_node(
	 (let_var_6_bglt) (obj_3086));
   }
}



/* let-var-key-set! */
obj_t 
let_var_key_set__86_ast_node(let_var_6_bglt obj_117, obj_t val1711_118)
{
   AN_OBJECT;
   {	/* Ast/node.scm 33 */
      return
	 ((((let_var_6_bglt) CREF(obj_117))->key) = ((obj_t) val1711_118), BUNSPEC);
   }
}



/* _let-var-key-set!2518 */
obj_t 
_let_var_key_set_2518_35_ast_node(obj_t env_3087, obj_t obj_3088, obj_t val1711_3089)
{
   AN_OBJECT;
   {	/* Ast/node.scm 33 */
      return
	 let_var_key_set__86_ast_node(
	 (let_var_6_bglt) (obj_3088), val1711_3089);
   }
}



/* let-var-key */
obj_t 
let_var_key_52_ast_node(let_var_6_bglt obj_119)
{
   AN_OBJECT;
   {	/* Ast/node.scm 33 */
      return
	 (((let_var_6_bglt) CREF(obj_119))->key);
   }
}



/* _let-var-key2519 */
obj_t 
_let_var_key2519_62_ast_node(obj_t env_3090, obj_t obj_3091)
{
   AN_OBJECT;
   {	/* Ast/node.scm 33 */
      return
	 let_var_key_52_ast_node(
	 (let_var_6_bglt) (obj_3091));
   }
}



/* let-var-bindings-set! */
obj_t 
let_var_bindings_set__143_ast_node(let_var_6_bglt obj_120, obj_t val1712_121)
{
   AN_OBJECT;
   {	/* Ast/node.scm 134 */
      return
	 ((((let_var_6_bglt) CREF(obj_120))->bindings) = ((obj_t) val1712_121), BUNSPEC);
   }
}



/* _let-var-bindings-set! */
obj_t 
_let_var_bindings_set__204_ast_node(obj_t env_3092, obj_t obj_3093, obj_t val1712_3094)
{
   AN_OBJECT;
   {	/* Ast/node.scm 134 */
      return
	 let_var_bindings_set__143_ast_node(
	 (let_var_6_bglt) (obj_3093), val1712_3094);
   }
}



/* let-var-bindings */
obj_t 
let_var_bindings_42_ast_node(let_var_6_bglt obj_122)
{
   AN_OBJECT;
   {	/* Ast/node.scm 134 */
      return
	 (((let_var_6_bglt) CREF(obj_122))->bindings);
   }
}



/* _let-var-bindings */
obj_t 
_let_var_bindings_44_ast_node(obj_t env_3095, obj_t obj_3096)
{
   AN_OBJECT;
   {	/* Ast/node.scm 134 */
      return
	 let_var_bindings_42_ast_node(
	 (let_var_6_bglt) (obj_3096));
   }
}



/* let-var-body-set! */
obj_t 
let_var_body_set__15_ast_node(let_var_6_bglt obj_123, node_bglt val1713_124)
{
   AN_OBJECT;
   {	/* Ast/node.scm 134 */
      return
	 ((((let_var_6_bglt) CREF(obj_123))->body) = ((node_bglt) val1713_124), BUNSPEC);
   }
}



/* _let-var-body-set! */
obj_t 
_let_var_body_set__128_ast_node(obj_t env_3097, obj_t obj_3098, obj_t val1713_3099)
{
   AN_OBJECT;
   {	/* Ast/node.scm 134 */
      return
	 let_var_body_set__15_ast_node(
	 (let_var_6_bglt) (obj_3098),
	 (node_bglt) (val1713_3099));
   }
}



/* let-var-body */
node_bglt 
let_var_body_232_ast_node(let_var_6_bglt obj_125)
{
   AN_OBJECT;
   {	/* Ast/node.scm 134 */
      return
	 (((let_var_6_bglt) CREF(obj_125))->body);
   }
}



/* _let-var-body */
obj_t 
_let_var_body_5_ast_node(obj_t env_3100, obj_t obj_3101)
{
   AN_OBJECT;
   {	/* Ast/node.scm 134 */
      {		/* Ast/node.scm 134 */
	 node_bglt aux_4200;
	 aux_4200 =
	    let_var_body_232_ast_node(
	    (let_var_6_bglt) (obj_3101));
	 return
	    (obj_t) (aux_4200);
      }
   }
}



/* let-var-removable?-set! */
obj_t 
let_var_removable__set__39_ast_node(let_var_6_bglt obj_126, bool_t val1714_127)
{
   AN_OBJECT;
   {	/* Ast/node.scm 140 */
      return
	 ((((let_var_6_bglt) CREF(obj_126))->removable__42) = ((bool_t) val1714_127), BUNSPEC);
   }
}



/* _let-var-removable?-set! */
obj_t 
_let_var_removable__set__166_ast_node(obj_t env_3102, obj_t obj_3103, obj_t val1714_3104)
{
   AN_OBJECT;
   {	/* Ast/node.scm 140 */
      return
	 let_var_removable__set__39_ast_node(
	 (let_var_6_bglt) (obj_3103),
	 CBOOL(val1714_3104));
   }
}



/* let-var-removable? */
bool_t 
let_var_removable__69_ast_node(let_var_6_bglt obj_128)
{
   AN_OBJECT;
   {	/* Ast/node.scm 140 */
      return
	 (((let_var_6_bglt) CREF(obj_128))->removable__42);
   }
}



/* _let-var-removable? */
obj_t 
_let_var_removable__112_ast_node(obj_t env_3105, obj_t obj_3106)
{
   AN_OBJECT;
   {	/* Ast/node.scm 140 */
      {		/* Ast/node.scm 140 */
	 bool_t aux_4209;
	 aux_4209 =
	    let_var_removable__69_ast_node(
	    (let_var_6_bglt) (obj_3106));
	 return
	    BBOOL(aux_4209);
      }
   }
}



/* allocate-let-fun */
let_fun_218_bglt 
allocate_let_fun_35_ast_node()
{
   AN_OBJECT;
   {	/* Ast/node.scm 127 */
      {		/* Ast/node.scm 127 */
	 let_fun_218_bglt new1682_956;
	 new1682_956 =
	    ((let_fun_218_bglt) BREF(GC_MALLOC(sizeof(struct let_fun_218))));
	 {	/* Ast/node.scm 127 */
	    long arg2163_957;
	    arg2163_957 =
	       class_num_218___object(let_fun_218_ast_node);
	    {	/* Ast/node.scm 127 */
	       obj_t obj_1911;
	       obj_1911 =
		  (obj_t) (new1682_956);
	       (((obj_t) CREF(obj_1911))->header = MAKE_HEADER(arg2163_957, 0), BUNSPEC);
	    }
	 }
	 {	/* Ast/node.scm 127 */
	    object_bglt aux_4217;
	    aux_4217 =
	       (object_bglt) (new1682_956);
	    OBJECT_WIDENING_SET(aux_4217, BFALSE);
	 }
	 return new1682_956;
      }
   }
}



/* _allocate-let-fun */
obj_t 
_allocate_let_fun_123_ast_node(obj_t env_2926)
{
   AN_OBJECT;
   {	/* Ast/node.scm 127 */
      {		/* Ast/node.scm 127 */
	 let_fun_218_bglt aux_4220;
	 aux_4220 =
	    allocate_let_fun_35_ast_node();
	 return
	    (obj_t) (aux_4220);
      }
   }
}



/* let-fun? */
bool_t 
let_fun__0_ast_node(obj_t obj_132)
{
   AN_OBJECT;
   {	/* Ast/node.scm 127 */
      return
	 is_a__118___object(obj_132, let_fun_218_ast_node);
   }
}



/* _let-fun? */
obj_t 
_let_fun__236_ast_node(obj_t env_3107, obj_t obj_3108)
{
   AN_OBJECT;
   {	/* Ast/node.scm 127 */
      {		/* Ast/node.scm 127 */
	 bool_t aux_4224;
	 aux_4224 =
	    let_fun__0_ast_node(obj_3108);
	 return
	    BBOOL(aux_4224);
      }
   }
}



/* make-let-fun */
let_fun_218_bglt 
make_let_fun_154_ast_node(obj_t loc_133, type_bglt type_134, obj_t side_effect__165_135, obj_t key_136, obj_t locals_137, node_bglt body_138)
{
   AN_OBJECT;
   {	/* Ast/node.scm 127 */
      {		/* Ast/node.scm 127 */
	 let_fun_218_bglt new1674_1913;
	 new1674_1913 =
	    ((let_fun_218_bglt) BREF(GC_MALLOC(sizeof(struct let_fun_218))));
	 {	/* Ast/node.scm 127 */
	    long arg2164_1914;
	    arg2164_1914 =
	       class_num_218___object(let_fun_218_ast_node);
	    {	/* Ast/node.scm 127 */
	       obj_t obj_1921;
	       obj_1921 =
		  (obj_t) (new1674_1913);
	       (((obj_t) CREF(obj_1921))->header = MAKE_HEADER(arg2164_1914, 0), BUNSPEC);
	    }
	 }
	 {	/* Ast/node.scm 127 */
	    object_bglt aux_4231;
	    aux_4231 =
	       (object_bglt) (new1674_1913);
	    OBJECT_WIDENING_SET(aux_4231, BFALSE);
	 }
	 ((((let_fun_218_bglt) CREF(new1674_1913))->loc) = ((obj_t) loc_133), BUNSPEC);
	 ((((let_fun_218_bglt) CREF(new1674_1913))->type) = ((type_bglt) type_134), BUNSPEC);
	 ((((let_fun_218_bglt) CREF(new1674_1913))->side_effect__165) = ((obj_t) side_effect__165_135), BUNSPEC);
	 ((((let_fun_218_bglt) CREF(new1674_1913))->key) = ((obj_t) key_136), BUNSPEC);
	 ((((let_fun_218_bglt) CREF(new1674_1913))->locals) = ((obj_t) locals_137), BUNSPEC);
	 ((((let_fun_218_bglt) CREF(new1674_1913))->body) = ((node_bglt) body_138), BUNSPEC);
	 return new1674_1913;
      }
   }
}



/* _make-let-fun */
obj_t 
_make_let_fun_151_ast_node(obj_t env_3109, obj_t loc_3110, obj_t type_3111, obj_t side_effect__165_3112, obj_t key_3113, obj_t locals_3114, obj_t body_3115)
{
   AN_OBJECT;
   {	/* Ast/node.scm 127 */
      {		/* Ast/node.scm 127 */
	 let_fun_218_bglt aux_4240;
	 aux_4240 =
	    make_let_fun_154_ast_node(loc_3110,
	    (type_bglt) (type_3111), side_effect__165_3112, key_3113, locals_3114,
	    (node_bglt) (body_3115));
	 return
	    (obj_t) (aux_4240);
      }
   }
}



/* let-fun-loc */
obj_t 
let_fun_loc_207_ast_node(let_fun_218_bglt obj_139)
{
   AN_OBJECT;
   {	/* Ast/node.scm 21 */
      return
	 (((let_fun_218_bglt) CREF(obj_139))->loc);
   }
}



/* _let-fun-loc */
obj_t 
_let_fun_loc_14_ast_node(obj_t env_3116, obj_t obj_3117)
{
   AN_OBJECT;
   {	/* Ast/node.scm 21 */
      return
	 let_fun_loc_207_ast_node(
	 (let_fun_218_bglt) (obj_3117));
   }
}



/* let-fun-type-set! */
obj_t 
let_fun_type_set__1_ast_node(let_fun_218_bglt obj_140, type_bglt val1669_141)
{
   AN_OBJECT;
   {	/* Ast/node.scm 127 */
      return
	 ((((let_fun_218_bglt) CREF(obj_140))->type) = ((type_bglt) val1669_141), BUNSPEC);
   }
}



/* _let-fun-type-set! */
obj_t 
_let_fun_type_set__36_ast_node(obj_t env_3118, obj_t obj_3119, obj_t val1669_3120)
{
   AN_OBJECT;
   {	/* Ast/node.scm 127 */
      return
	 let_fun_type_set__1_ast_node(
	 (let_fun_218_bglt) (obj_3119),
	 (type_bglt) (val1669_3120));
   }
}



/* let-fun-type */
type_bglt 
let_fun_type_250_ast_node(let_fun_218_bglt obj_142)
{
   AN_OBJECT;
   {	/* Ast/node.scm 127 */
      return
	 (((let_fun_218_bglt) CREF(obj_142))->type);
   }
}



/* _let-fun-type */
obj_t 
_let_fun_type_63_ast_node(obj_t env_3121, obj_t obj_3122)
{
   AN_OBJECT;
   {	/* Ast/node.scm 127 */
      {		/* Ast/node.scm 127 */
	 type_bglt aux_4253;
	 aux_4253 =
	    let_fun_type_250_ast_node(
	    (let_fun_218_bglt) (obj_3122));
	 return
	    (obj_t) (aux_4253);
      }
   }
}



/* let-fun-side-effect?-set! */
obj_t 
let_fun_side_effect__set__106_ast_node(let_fun_218_bglt obj_143, obj_t val1670_144)
{
   AN_OBJECT;
   {	/* Ast/node.scm 29 */
      return
	 ((((let_fun_218_bglt) CREF(obj_143))->side_effect__165) = ((obj_t) val1670_144), BUNSPEC);
   }
}



/* _let-fun-side-effect?-set! */
obj_t 
_let_fun_side_effect__set__74_ast_node(obj_t env_3123, obj_t obj_3124, obj_t val1670_3125)
{
   AN_OBJECT;
   {	/* Ast/node.scm 29 */
      return
	 let_fun_side_effect__set__106_ast_node(
	 (let_fun_218_bglt) (obj_3124), val1670_3125);
   }
}



/* let-fun-side-effect? */
obj_t 
let_fun_side_effect__189_ast_node(let_fun_218_bglt obj_145)
{
   AN_OBJECT;
   {	/* Ast/node.scm 29 */
      return
	 (((let_fun_218_bglt) CREF(obj_145))->side_effect__165);
   }
}



/* _let-fun-side-effect? */
obj_t 
_let_fun_side_effect__106_ast_node(obj_t env_3126, obj_t obj_3127)
{
   AN_OBJECT;
   {	/* Ast/node.scm 29 */
      return
	 let_fun_side_effect__189_ast_node(
	 (let_fun_218_bglt) (obj_3127));
   }
}



/* let-fun-key-set! */
obj_t 
let_fun_key_set__227_ast_node(let_fun_218_bglt obj_146, obj_t val1671_147)
{
   AN_OBJECT;
   {	/* Ast/node.scm 33 */
      return
	 ((((let_fun_218_bglt) CREF(obj_146))->key) = ((obj_t) val1671_147), BUNSPEC);
   }
}



/* _let-fun-key-set!2520 */
obj_t 
_let_fun_key_set_2520_62_ast_node(obj_t env_3128, obj_t obj_3129, obj_t val1671_3130)
{
   AN_OBJECT;
   {	/* Ast/node.scm 33 */
      return
	 let_fun_key_set__227_ast_node(
	 (let_fun_218_bglt) (obj_3129), val1671_3130);
   }
}



/* let-fun-key */
obj_t 
let_fun_key_253_ast_node(let_fun_218_bglt obj_148)
{
   AN_OBJECT;
   {	/* Ast/node.scm 33 */
      return
	 (((let_fun_218_bglt) CREF(obj_148))->key);
   }
}



/* _let-fun-key2521 */
obj_t 
_let_fun_key2521_19_ast_node(obj_t env_3131, obj_t obj_3132)
{
   AN_OBJECT;
   {	/* Ast/node.scm 33 */
      return
	 let_fun_key_253_ast_node(
	 (let_fun_218_bglt) (obj_3132));
   }
}



/* let-fun-locals-set! */
obj_t 
let_fun_locals_set__199_ast_node(let_fun_218_bglt obj_149, obj_t val1672_150)
{
   AN_OBJECT;
   {	/* Ast/node.scm 127 */
      return
	 ((((let_fun_218_bglt) CREF(obj_149))->locals) = ((obj_t) val1672_150), BUNSPEC);
   }
}



/* _let-fun-locals-set! */
obj_t 
_let_fun_locals_set__222_ast_node(obj_t env_3133, obj_t obj_3134, obj_t val1672_3135)
{
   AN_OBJECT;
   {	/* Ast/node.scm 127 */
      return
	 let_fun_locals_set__199_ast_node(
	 (let_fun_218_bglt) (obj_3134), val1672_3135);
   }
}



/* let-fun-locals */
obj_t 
let_fun_locals_116_ast_node(let_fun_218_bglt obj_151)
{
   AN_OBJECT;
   {	/* Ast/node.scm 127 */
      return
	 (((let_fun_218_bglt) CREF(obj_151))->locals);
   }
}



/* _let-fun-locals */
obj_t 
_let_fun_locals_153_ast_node(obj_t env_3136, obj_t obj_3137)
{
   AN_OBJECT;
   {	/* Ast/node.scm 127 */
      return
	 let_fun_locals_116_ast_node(
	 (let_fun_218_bglt) (obj_3137));
   }
}



/* let-fun-body-set! */
obj_t 
let_fun_body_set__147_ast_node(let_fun_218_bglt obj_152, node_bglt val1673_153)
{
   AN_OBJECT;
   {	/* Ast/node.scm 127 */
      return
	 ((((let_fun_218_bglt) CREF(obj_152))->body) = ((node_bglt) val1673_153), BUNSPEC);
   }
}



/* _let-fun-body-set! */
obj_t 
_let_fun_body_set__28_ast_node(obj_t env_3138, obj_t obj_3139, obj_t val1673_3140)
{
   AN_OBJECT;
   {	/* Ast/node.scm 127 */
      return
	 let_fun_body_set__147_ast_node(
	 (let_fun_218_bglt) (obj_3139),
	 (node_bglt) (val1673_3140));
   }
}



/* let-fun-body */
node_bglt 
let_fun_body_141_ast_node(let_fun_218_bglt obj_154)
{
   AN_OBJECT;
   {	/* Ast/node.scm 127 */
      return
	 (((let_fun_218_bglt) CREF(obj_154))->body);
   }
}



/* _let-fun-body */
obj_t 
_let_fun_body_240_ast_node(obj_t env_3141, obj_t obj_3142)
{
   AN_OBJECT;
   {	/* Ast/node.scm 127 */
      {		/* Ast/node.scm 127 */
	 node_bglt aux_4280;
	 aux_4280 =
	    let_fun_body_141_ast_node(
	    (let_fun_218_bglt) (obj_3142));
	 return
	    (obj_t) (aux_4280);
      }
   }
}



/* allocate-select */
select_bglt 
allocate_select_194_ast_node()
{
   AN_OBJECT;
   {	/* Ast/node.scm 118 */
      {		/* Ast/node.scm 118 */
	 select_bglt new1638_966;
	 new1638_966 =
	    ((select_bglt) BREF(GC_MALLOC(sizeof(struct select))));
	 {	/* Ast/node.scm 118 */
	    long arg2165_967;
	    arg2165_967 =
	       class_num_218___object(select_ast_node);
	    {	/* Ast/node.scm 118 */
	       obj_t obj_1923;
	       obj_1923 =
		  (obj_t) (new1638_966);
	       (((obj_t) CREF(obj_1923))->header = MAKE_HEADER(arg2165_967, 0), BUNSPEC);
	    }
	 }
	 {	/* Ast/node.scm 118 */
	    object_bglt aux_4288;
	    aux_4288 =
	       (object_bglt) (new1638_966);
	    OBJECT_WIDENING_SET(aux_4288, BFALSE);
	 }
	 return new1638_966;
      }
   }
}



/* _allocate-select */
obj_t 
_allocate_select_101_ast_node(obj_t env_2925)
{
   AN_OBJECT;
   {	/* Ast/node.scm 118 */
      {		/* Ast/node.scm 118 */
	 select_bglt aux_4291;
	 aux_4291 =
	    allocate_select_194_ast_node();
	 return
	    (obj_t) (aux_4291);
      }
   }
}



/* select? */
bool_t 
select__208_ast_node(obj_t obj_158)
{
   AN_OBJECT;
   {	/* Ast/node.scm 118 */
      return
	 is_a__118___object(obj_158, select_ast_node);
   }
}



/* _select? */
obj_t 
_select__4_ast_node(obj_t env_3143, obj_t obj_3144)
{
   AN_OBJECT;
   {	/* Ast/node.scm 118 */
      {		/* Ast/node.scm 118 */
	 bool_t aux_4295;
	 aux_4295 =
	    select__208_ast_node(obj_3144);
	 return
	    BBOOL(aux_4295);
      }
   }
}



/* make-select */
select_bglt 
make_select_245_ast_node(obj_t loc_159, type_bglt type_160, obj_t side_effect__165_161, obj_t key_162, node_bglt test_163, obj_t clauses_164, type_bglt item_type_130_165)
{
   AN_OBJECT;
   {	/* Ast/node.scm 118 */
      {		/* Ast/node.scm 118 */
	 select_bglt new1629_1925;
	 new1629_1925 =
	    ((select_bglt) BREF(GC_MALLOC(sizeof(struct select))));
	 {	/* Ast/node.scm 118 */
	    long arg2166_1926;
	    arg2166_1926 =
	       class_num_218___object(select_ast_node);
	    {	/* Ast/node.scm 118 */
	       obj_t obj_1934;
	       obj_1934 =
		  (obj_t) (new1629_1925);
	       (((obj_t) CREF(obj_1934))->header = MAKE_HEADER(arg2166_1926, 0), BUNSPEC);
	    }
	 }
	 {	/* Ast/node.scm 118 */
	    object_bglt aux_4302;
	    aux_4302 =
	       (object_bglt) (new1629_1925);
	    OBJECT_WIDENING_SET(aux_4302, BFALSE);
	 }
	 ((((select_bglt) CREF(new1629_1925))->loc) = ((obj_t) loc_159), BUNSPEC);
	 ((((select_bglt) CREF(new1629_1925))->type) = ((type_bglt) type_160), BUNSPEC);
	 ((((select_bglt) CREF(new1629_1925))->side_effect__165) = ((obj_t) side_effect__165_161), BUNSPEC);
	 ((((select_bglt) CREF(new1629_1925))->key) = ((obj_t) key_162), BUNSPEC);
	 ((((select_bglt) CREF(new1629_1925))->test) = ((node_bglt) test_163), BUNSPEC);
	 ((((select_bglt) CREF(new1629_1925))->clauses) = ((obj_t) clauses_164), BUNSPEC);
	 ((((select_bglt) CREF(new1629_1925))->item_type_130) = ((type_bglt) item_type_130_165), BUNSPEC);
	 return new1629_1925;
      }
   }
}



/* _make-select */
obj_t 
_make_select_83_ast_node(obj_t env_3145, obj_t loc_3146, obj_t type_3147, obj_t side_effect__165_3148, obj_t key_3149, obj_t test_3150, obj_t clauses_3151, obj_t item_type_130_3152)
{
   AN_OBJECT;
   {	/* Ast/node.scm 118 */
      {		/* Ast/node.scm 118 */
	 select_bglt aux_4312;
	 aux_4312 =
	    make_select_245_ast_node(loc_3146,
	    (type_bglt) (type_3147), side_effect__165_3148, key_3149,
	    (node_bglt) (test_3150), clauses_3151,
	    (type_bglt) (item_type_130_3152));
	 return
	    (obj_t) (aux_4312);
      }
   }
}



/* select-loc */
obj_t 
select_loc_168_ast_node(select_bglt obj_166)
{
   AN_OBJECT;
   {	/* Ast/node.scm 21 */
      return
	 (((select_bglt) CREF(obj_166))->loc);
   }
}



/* _select-loc */
obj_t 
_select_loc_214_ast_node(obj_t env_3153, obj_t obj_3154)
{
   AN_OBJECT;
   {	/* Ast/node.scm 21 */
      return
	 select_loc_168_ast_node(
	 (select_bglt) (obj_3154));
   }
}



/* select-type-set! */
obj_t 
select_type_set__138_ast_node(select_bglt obj_167, type_bglt val1625_168)
{
   AN_OBJECT;
   {	/* Ast/node.scm 118 */
      return
	 ((((select_bglt) CREF(obj_167))->type) = ((type_bglt) val1625_168), BUNSPEC);
   }
}



/* _select-type-set! */
obj_t 
_select_type_set__200_ast_node(obj_t env_3155, obj_t obj_3156, obj_t val1625_3157)
{
   AN_OBJECT;
   {	/* Ast/node.scm 118 */
      return
	 select_type_set__138_ast_node(
	 (select_bglt) (obj_3156),
	 (type_bglt) (val1625_3157));
   }
}



/* select-type */
type_bglt 
select_type_6_ast_node(select_bglt obj_169)
{
   AN_OBJECT;
   {	/* Ast/node.scm 118 */
      return
	 (((select_bglt) CREF(obj_169))->type);
   }
}



/* _select-type */
obj_t 
_select_type_8_ast_node(obj_t env_3158, obj_t obj_3159)
{
   AN_OBJECT;
   {	/* Ast/node.scm 118 */
      {		/* Ast/node.scm 118 */
	 type_bglt aux_4326;
	 aux_4326 =
	    select_type_6_ast_node(
	    (select_bglt) (obj_3159));
	 return
	    (obj_t) (aux_4326);
      }
   }
}



/* select-side-effect?-set! */
obj_t 
select_side_effect__set__210_ast_node(select_bglt obj_170, obj_t val1626_171)
{
   AN_OBJECT;
   {	/* Ast/node.scm 29 */
      return
	 ((((select_bglt) CREF(obj_170))->side_effect__165) = ((obj_t) val1626_171), BUNSPEC);
   }
}



/* _select-side-effect?-set! */
obj_t 
_select_side_effect__set__140_ast_node(obj_t env_3160, obj_t obj_3161, obj_t val1626_3162)
{
   AN_OBJECT;
   {	/* Ast/node.scm 29 */
      return
	 select_side_effect__set__210_ast_node(
	 (select_bglt) (obj_3161), val1626_3162);
   }
}



/* select-side-effect? */
obj_t 
select_side_effect__205_ast_node(select_bglt obj_172)
{
   AN_OBJECT;
   {	/* Ast/node.scm 29 */
      return
	 (((select_bglt) CREF(obj_172))->side_effect__165);
   }
}



/* _select-side-effect? */
obj_t 
_select_side_effect__188_ast_node(obj_t env_3163, obj_t obj_3164)
{
   AN_OBJECT;
   {	/* Ast/node.scm 29 */
      return
	 select_side_effect__205_ast_node(
	 (select_bglt) (obj_3164));
   }
}



/* select-key-set! */
obj_t 
select_key_set__149_ast_node(select_bglt obj_173, obj_t val1627_174)
{
   AN_OBJECT;
   {	/* Ast/node.scm 33 */
      return
	 ((((select_bglt) CREF(obj_173))->key) = ((obj_t) val1627_174), BUNSPEC);
   }
}



/* _select-key-set!2522 */
obj_t 
_select_key_set_2522_16_ast_node(obj_t env_3165, obj_t obj_3166, obj_t val1627_3167)
{
   AN_OBJECT;
   {	/* Ast/node.scm 33 */
      return
	 select_key_set__149_ast_node(
	 (select_bglt) (obj_3166), val1627_3167);
   }
}



/* select-key */
obj_t 
select_key_89_ast_node(select_bglt obj_175)
{
   AN_OBJECT;
   {	/* Ast/node.scm 33 */
      return
	 (((select_bglt) CREF(obj_175))->key);
   }
}



/* _select-key2523 */
obj_t 
_select_key2523_45_ast_node(obj_t env_3168, obj_t obj_3169)
{
   AN_OBJECT;
   {	/* Ast/node.scm 33 */
      return
	 select_key_89_ast_node(
	 (select_bglt) (obj_3169));
   }
}



/* select-test-set! */
obj_t 
select_test_set__37_ast_node(select_bglt obj_176, node_bglt val1628_177)
{
   AN_OBJECT;
   {	/* Ast/node.scm 118 */
      return
	 ((((select_bglt) CREF(obj_176))->test) = ((node_bglt) val1628_177), BUNSPEC);
   }
}



/* _select-test-set! */
obj_t 
_select_test_set__254_ast_node(obj_t env_3170, obj_t obj_3171, obj_t val1628_3172)
{
   AN_OBJECT;
   {	/* Ast/node.scm 118 */
      return
	 select_test_set__37_ast_node(
	 (select_bglt) (obj_3171),
	 (node_bglt) (val1628_3172));
   }
}



/* select-test */
node_bglt 
select_test_184_ast_node(select_bglt obj_178)
{
   AN_OBJECT;
   {	/* Ast/node.scm 118 */
      return
	 (((select_bglt) CREF(obj_178))->test);
   }
}



/* _select-test */
obj_t 
_select_test_131_ast_node(obj_t env_3173, obj_t obj_3174)
{
   AN_OBJECT;
   {	/* Ast/node.scm 118 */
      {		/* Ast/node.scm 118 */
	 node_bglt aux_4347;
	 aux_4347 =
	    select_test_184_ast_node(
	    (select_bglt) (obj_3174));
	 return
	    (obj_t) (aux_4347);
      }
   }
}



/* select-clauses */
obj_t 
select_clauses_248_ast_node(select_bglt obj_179)
{
   AN_OBJECT;
   {	/* Ast/node.scm 122 */
      return
	 (((select_bglt) CREF(obj_179))->clauses);
   }
}



/* _select-clauses */
obj_t 
_select_clauses_101_ast_node(obj_t env_3175, obj_t obj_3176)
{
   AN_OBJECT;
   {	/* Ast/node.scm 122 */
      return
	 select_clauses_248_ast_node(
	 (select_bglt) (obj_3176));
   }
}



/* select-item-type */
type_bglt 
select_item_type_206_ast_node(select_bglt obj_180)
{
   AN_OBJECT;
   {	/* Ast/node.scm 124 */
      return
	 (((select_bglt) CREF(obj_180))->item_type_130);
   }
}



/* _select-item-type */
obj_t 
_select_item_type_107_ast_node(obj_t env_3177, obj_t obj_3178)
{
   AN_OBJECT;
   {	/* Ast/node.scm 124 */
      {		/* Ast/node.scm 124 */
	 type_bglt aux_4355;
	 aux_4355 =
	    select_item_type_206_ast_node(
	    (select_bglt) (obj_3178));
	 return
	    (obj_t) (aux_4355);
      }
   }
}



/* allocate-fail */
fail_bglt 
allocate_fail_46_ast_node()
{
   AN_OBJECT;
   {	/* Ast/node.scm 111 */
      {		/* Ast/node.scm 111 */
	 fail_bglt new1602_977;
	 new1602_977 =
	    ((fail_bglt) BREF(GC_MALLOC(sizeof(struct fail))));
	 {	/* Ast/node.scm 111 */
	    long arg2167_978;
	    arg2167_978 =
	       class_num_218___object(fail_ast_node);
	    {	/* Ast/node.scm 111 */
	       obj_t obj_1936;
	       obj_1936 =
		  (obj_t) (new1602_977);
	       (((obj_t) CREF(obj_1936))->header = MAKE_HEADER(arg2167_978, 0), BUNSPEC);
	    }
	 }
	 {	/* Ast/node.scm 111 */
	    object_bglt aux_4363;
	    aux_4363 =
	       (object_bglt) (new1602_977);
	    OBJECT_WIDENING_SET(aux_4363, BFALSE);
	 }
	 return new1602_977;
      }
   }
}



/* _allocate-fail */
obj_t 
_allocate_fail_214_ast_node(obj_t env_2924)
{
   AN_OBJECT;
   {	/* Ast/node.scm 111 */
      {		/* Ast/node.scm 111 */
	 fail_bglt aux_4366;
	 aux_4366 =
	    allocate_fail_46_ast_node();
	 return
	    (obj_t) (aux_4366);
      }
   }
}



/* fail? */
bool_t 
fail__35_ast_node(obj_t obj_184)
{
   AN_OBJECT;
   {	/* Ast/node.scm 111 */
      return
	 is_a__118___object(obj_184, fail_ast_node);
   }
}



/* _fail? */
obj_t 
_fail__57_ast_node(obj_t env_3179, obj_t obj_3180)
{
   AN_OBJECT;
   {	/* Ast/node.scm 111 */
      {		/* Ast/node.scm 111 */
	 bool_t aux_4370;
	 aux_4370 =
	    fail__35_ast_node(obj_3180);
	 return
	    BBOOL(aux_4370);
      }
   }
}



/* make-fail */
fail_bglt 
make_fail_231_ast_node(obj_t loc_185, type_bglt type_186, node_bglt proc_187, node_bglt msg_188, node_bglt obj_189)
{
   AN_OBJECT;
   {	/* Ast/node.scm 111 */
      {		/* Ast/node.scm 111 */
	 fail_bglt new1595_1938;
	 new1595_1938 =
	    ((fail_bglt) BREF(GC_MALLOC(sizeof(struct fail))));
	 {	/* Ast/node.scm 111 */
	    long arg2168_1939;
	    arg2168_1939 =
	       class_num_218___object(fail_ast_node);
	    {	/* Ast/node.scm 111 */
	       obj_t obj_1945;
	       obj_1945 =
		  (obj_t) (new1595_1938);
	       (((obj_t) CREF(obj_1945))->header = MAKE_HEADER(arg2168_1939, 0), BUNSPEC);
	    }
	 }
	 {	/* Ast/node.scm 111 */
	    object_bglt aux_4377;
	    aux_4377 =
	       (object_bglt) (new1595_1938);
	    OBJECT_WIDENING_SET(aux_4377, BFALSE);
	 }
	 ((((fail_bglt) CREF(new1595_1938))->loc) = ((obj_t) loc_185), BUNSPEC);
	 ((((fail_bglt) CREF(new1595_1938))->type) = ((type_bglt) type_186), BUNSPEC);
	 ((((fail_bglt) CREF(new1595_1938))->proc) = ((node_bglt) proc_187), BUNSPEC);
	 ((((fail_bglt) CREF(new1595_1938))->msg) = ((node_bglt) msg_188), BUNSPEC);
	 ((((fail_bglt) CREF(new1595_1938))->obj) = ((node_bglt) obj_189), BUNSPEC);
	 return new1595_1938;
      }
   }
}



/* _make-fail */
obj_t 
_make_fail_191_ast_node(obj_t env_3181, obj_t loc_3182, obj_t type_3183, obj_t proc_3184, obj_t msg_3185, obj_t obj_3186)
{
   AN_OBJECT;
   {	/* Ast/node.scm 111 */
      {		/* Ast/node.scm 111 */
	 fail_bglt aux_4385;
	 aux_4385 =
	    make_fail_231_ast_node(loc_3182,
	    (type_bglt) (type_3183),
	    (node_bglt) (proc_3184),
	    (node_bglt) (msg_3185),
	    (node_bglt) (obj_3186));
	 return
	    (obj_t) (aux_4385);
      }
   }
}



/* fail-loc */
obj_t 
fail_loc_117_ast_node(fail_bglt obj_190)
{
   AN_OBJECT;
   {	/* Ast/node.scm 21 */
      return
	 (((fail_bglt) CREF(obj_190))->loc);
   }
}



/* _fail-loc */
obj_t 
_fail_loc_78_ast_node(obj_t env_3187, obj_t obj_3188)
{
   AN_OBJECT;
   {	/* Ast/node.scm 21 */
      return
	 fail_loc_117_ast_node(
	 (fail_bglt) (obj_3188));
   }
}



/* fail-type-set! */
obj_t 
fail_type_set__42_ast_node(fail_bglt obj_191, type_bglt val1591_192)
{
   AN_OBJECT;
   {	/* Ast/node.scm 111 */
      return
	 ((((fail_bglt) CREF(obj_191))->type) = ((type_bglt) val1591_192), BUNSPEC);
   }
}



/* _fail-type-set! */
obj_t 
_fail_type_set__134_ast_node(obj_t env_3189, obj_t obj_3190, obj_t val1591_3191)
{
   AN_OBJECT;
   {	/* Ast/node.scm 111 */
      return
	 fail_type_set__42_ast_node(
	 (fail_bglt) (obj_3190),
	 (type_bglt) (val1591_3191));
   }
}



/* fail-type */
type_bglt 
fail_type_93_ast_node(fail_bglt obj_193)
{
   AN_OBJECT;
   {	/* Ast/node.scm 111 */
      return
	 (((fail_bglt) CREF(obj_193))->type);
   }
}



/* _fail-type */
obj_t 
_fail_type_21_ast_node(obj_t env_3192, obj_t obj_3193)
{
   AN_OBJECT;
   {	/* Ast/node.scm 111 */
      {		/* Ast/node.scm 111 */
	 type_bglt aux_4400;
	 aux_4400 =
	    fail_type_93_ast_node(
	    (fail_bglt) (obj_3193));
	 return
	    (obj_t) (aux_4400);
      }
   }
}



/* fail-proc-set! */
obj_t 
fail_proc_set__82_ast_node(fail_bglt obj_194, node_bglt val1592_195)
{
   AN_OBJECT;
   {	/* Ast/node.scm 111 */
      return
	 ((((fail_bglt) CREF(obj_194))->proc) = ((node_bglt) val1592_195), BUNSPEC);
   }
}



/* _fail-proc-set! */
obj_t 
_fail_proc_set__112_ast_node(obj_t env_3194, obj_t obj_3195, obj_t val1592_3196)
{
   AN_OBJECT;
   {	/* Ast/node.scm 111 */
      return
	 fail_proc_set__82_ast_node(
	 (fail_bglt) (obj_3195),
	 (node_bglt) (val1592_3196));
   }
}



/* fail-proc */
node_bglt 
fail_proc_182_ast_node(fail_bglt obj_196)
{
   AN_OBJECT;
   {	/* Ast/node.scm 111 */
      return
	 (((fail_bglt) CREF(obj_196))->proc);
   }
}



/* _fail-proc */
obj_t 
_fail_proc_197_ast_node(obj_t env_3197, obj_t obj_3198)
{
   AN_OBJECT;
   {	/* Ast/node.scm 111 */
      {		/* Ast/node.scm 111 */
	 node_bglt aux_4409;
	 aux_4409 =
	    fail_proc_182_ast_node(
	    (fail_bglt) (obj_3198));
	 return
	    (obj_t) (aux_4409);
      }
   }
}



/* fail-msg-set! */
obj_t 
fail_msg_set__47_ast_node(fail_bglt obj_197, node_bglt val1593_198)
{
   AN_OBJECT;
   {	/* Ast/node.scm 111 */
      return
	 ((((fail_bglt) CREF(obj_197))->msg) = ((node_bglt) val1593_198), BUNSPEC);
   }
}



/* _fail-msg-set! */
obj_t 
_fail_msg_set__4_ast_node(obj_t env_3199, obj_t obj_3200, obj_t val1593_3201)
{
   AN_OBJECT;
   {	/* Ast/node.scm 111 */
      return
	 fail_msg_set__47_ast_node(
	 (fail_bglt) (obj_3200),
	 (node_bglt) (val1593_3201));
   }
}



/* fail-msg */
node_bglt 
fail_msg_210_ast_node(fail_bglt obj_199)
{
   AN_OBJECT;
   {	/* Ast/node.scm 111 */
      return
	 (((fail_bglt) CREF(obj_199))->msg);
   }
}



/* _fail-msg */
obj_t 
_fail_msg_237_ast_node(obj_t env_3202, obj_t obj_3203)
{
   AN_OBJECT;
   {	/* Ast/node.scm 111 */
      {		/* Ast/node.scm 111 */
	 node_bglt aux_4418;
	 aux_4418 =
	    fail_msg_210_ast_node(
	    (fail_bglt) (obj_3203));
	 return
	    (obj_t) (aux_4418);
      }
   }
}



/* fail-obj-set! */
obj_t 
fail_obj_set__117_ast_node(fail_bglt obj_200, node_bglt val1594_201)
{
   AN_OBJECT;
   {	/* Ast/node.scm 111 */
      return
	 ((((fail_bglt) CREF(obj_200))->obj) = ((node_bglt) val1594_201), BUNSPEC);
   }
}



/* _fail-obj-set! */
obj_t 
_fail_obj_set__94_ast_node(obj_t env_3204, obj_t obj_3205, obj_t val1594_3206)
{
   AN_OBJECT;
   {	/* Ast/node.scm 111 */
      return
	 fail_obj_set__117_ast_node(
	 (fail_bglt) (obj_3205),
	 (node_bglt) (val1594_3206));
   }
}



/* fail-obj */
node_bglt 
fail_obj_122_ast_node(fail_bglt obj_202)
{
   AN_OBJECT;
   {	/* Ast/node.scm 111 */
      return
	 (((fail_bglt) CREF(obj_202))->obj);
   }
}



/* _fail-obj */
obj_t 
_fail_obj_36_ast_node(obj_t env_3207, obj_t obj_3208)
{
   AN_OBJECT;
   {	/* Ast/node.scm 111 */
      {		/* Ast/node.scm 111 */
	 node_bglt aux_4427;
	 aux_4427 =
	    fail_obj_122_ast_node(
	    (fail_bglt) (obj_3208));
	 return
	    (obj_t) (aux_4427);
      }
   }
}



/* allocate-conditional */
conditional_bglt 
allocate_conditional_174_ast_node()
{
   AN_OBJECT;
   {	/* Ast/node.scm 102 */
      {		/* Ast/node.scm 102 */
	 conditional_bglt new1560_986;
	 new1560_986 =
	    ((conditional_bglt) BREF(GC_MALLOC(sizeof(struct conditional))));
	 {	/* Ast/node.scm 102 */
	    long arg2169_987;
	    arg2169_987 =
	       class_num_218___object(conditional_ast_node);
	    {	/* Ast/node.scm 102 */
	       obj_t obj_1947;
	       obj_1947 =
		  (obj_t) (new1560_986);
	       (((obj_t) CREF(obj_1947))->header = MAKE_HEADER(arg2169_987, 0), BUNSPEC);
	    }
	 }
	 {	/* Ast/node.scm 102 */
	    object_bglt aux_4435;
	    aux_4435 =
	       (object_bglt) (new1560_986);
	    OBJECT_WIDENING_SET(aux_4435, BFALSE);
	 }
	 return new1560_986;
      }
   }
}



/* _allocate-conditional */
obj_t 
_allocate_conditional_184_ast_node(obj_t env_2923)
{
   AN_OBJECT;
   {	/* Ast/node.scm 102 */
      {		/* Ast/node.scm 102 */
	 conditional_bglt aux_4438;
	 aux_4438 =
	    allocate_conditional_174_ast_node();
	 return
	    (obj_t) (aux_4438);
      }
   }
}



/* conditional? */
bool_t 
conditional__146_ast_node(obj_t obj_206)
{
   AN_OBJECT;
   {	/* Ast/node.scm 102 */
      return
	 is_a__118___object(obj_206, conditional_ast_node);
   }
}



/* _conditional? */
obj_t 
_conditional__140_ast_node(obj_t env_3209, obj_t obj_3210)
{
   AN_OBJECT;
   {	/* Ast/node.scm 102 */
      {		/* Ast/node.scm 102 */
	 bool_t aux_4442;
	 aux_4442 =
	    conditional__146_ast_node(obj_3210);
	 return
	    BBOOL(aux_4442);
      }
   }
}



/* make-conditional */
conditional_bglt 
make_conditional_43_ast_node(obj_t loc_207, type_bglt type_208, obj_t side_effect__165_209, obj_t key_210, node_bglt test_211, node_bglt true_212, node_bglt false_213)
{
   AN_OBJECT;
   {	/* Ast/node.scm 102 */
      {		/* Ast/node.scm 102 */
	 conditional_bglt new1551_1949;
	 new1551_1949 =
	    ((conditional_bglt) BREF(GC_MALLOC(sizeof(struct conditional))));
	 {	/* Ast/node.scm 102 */
	    long arg2170_1950;
	    arg2170_1950 =
	       class_num_218___object(conditional_ast_node);
	    {	/* Ast/node.scm 102 */
	       obj_t obj_1958;
	       obj_1958 =
		  (obj_t) (new1551_1949);
	       (((obj_t) CREF(obj_1958))->header = MAKE_HEADER(arg2170_1950, 0), BUNSPEC);
	    }
	 }
	 {	/* Ast/node.scm 102 */
	    object_bglt aux_4449;
	    aux_4449 =
	       (object_bglt) (new1551_1949);
	    OBJECT_WIDENING_SET(aux_4449, BFALSE);
	 }
	 ((((conditional_bglt) CREF(new1551_1949))->loc) = ((obj_t) loc_207), BUNSPEC);
	 ((((conditional_bglt) CREF(new1551_1949))->type) = ((type_bglt) type_208), BUNSPEC);
	 ((((conditional_bglt) CREF(new1551_1949))->side_effect__165) = ((obj_t) side_effect__165_209), BUNSPEC);
	 ((((conditional_bglt) CREF(new1551_1949))->key) = ((obj_t) key_210), BUNSPEC);
	 ((((conditional_bglt) CREF(new1551_1949))->test) = ((node_bglt) test_211), BUNSPEC);
	 ((((conditional_bglt) CREF(new1551_1949))->true) = ((node_bglt) true_212), BUNSPEC);
	 ((((conditional_bglt) CREF(new1551_1949))->false) = ((node_bglt) false_213), BUNSPEC);
	 return new1551_1949;
      }
   }
}



/* _make-conditional */
obj_t 
_make_conditional_213_ast_node(obj_t env_3211, obj_t loc_3212, obj_t type_3213, obj_t side_effect__165_3214, obj_t key_3215, obj_t test_3216, obj_t true_3217, obj_t false_3218)
{
   AN_OBJECT;
   {	/* Ast/node.scm 102 */
      {		/* Ast/node.scm 102 */
	 conditional_bglt aux_4459;
	 aux_4459 =
	    make_conditional_43_ast_node(loc_3212,
	    (type_bglt) (type_3213), side_effect__165_3214, key_3215,
	    (node_bglt) (test_3216),
	    (node_bglt) (true_3217),
	    (node_bglt) (false_3218));
	 return
	    (obj_t) (aux_4459);
      }
   }
}



/* conditional-loc */
obj_t 
conditional_loc_211_ast_node(conditional_bglt obj_214)
{
   AN_OBJECT;
   {	/* Ast/node.scm 21 */
      return
	 (((conditional_bglt) CREF(obj_214))->loc);
   }
}



/* _conditional-loc */
obj_t 
_conditional_loc_250_ast_node(obj_t env_3219, obj_t obj_3220)
{
   AN_OBJECT;
   {	/* Ast/node.scm 21 */
      return
	 conditional_loc_211_ast_node(
	 (conditional_bglt) (obj_3220));
   }
}



/* conditional-type-set! */
obj_t 
conditional_type_set__131_ast_node(conditional_bglt obj_215, type_bglt val1545_216)
{
   AN_OBJECT;
   {	/* Ast/node.scm 102 */
      return
	 ((((conditional_bglt) CREF(obj_215))->type) = ((type_bglt) val1545_216), BUNSPEC);
   }
}



/* _conditional-type-set! */
obj_t 
_conditional_type_set__61_ast_node(obj_t env_3221, obj_t obj_3222, obj_t val1545_3223)
{
   AN_OBJECT;
   {	/* Ast/node.scm 102 */
      return
	 conditional_type_set__131_ast_node(
	 (conditional_bglt) (obj_3222),
	 (type_bglt) (val1545_3223));
   }
}



/* conditional-type */
type_bglt 
conditional_type_236_ast_node(conditional_bglt obj_217)
{
   AN_OBJECT;
   {	/* Ast/node.scm 102 */
      return
	 (((conditional_bglt) CREF(obj_217))->type);
   }
}



/* _conditional-type */
obj_t 
_conditional_type_95_ast_node(obj_t env_3224, obj_t obj_3225)
{
   AN_OBJECT;
   {	/* Ast/node.scm 102 */
      {		/* Ast/node.scm 102 */
	 type_bglt aux_4474;
	 aux_4474 =
	    conditional_type_236_ast_node(
	    (conditional_bglt) (obj_3225));
	 return
	    (obj_t) (aux_4474);
      }
   }
}



/* conditional-side-effect?-set! */
obj_t 
conditional_side_effect__set__158_ast_node(conditional_bglt obj_218, obj_t val1546_219)
{
   AN_OBJECT;
   {	/* Ast/node.scm 29 */
      return
	 ((((conditional_bglt) CREF(obj_218))->side_effect__165) = ((obj_t) val1546_219), BUNSPEC);
   }
}



/* _conditional-side-effect?-set! */
obj_t 
_conditional_side_effect__set__126_ast_node(obj_t env_3226, obj_t obj_3227, obj_t val1546_3228)
{
   AN_OBJECT;
   {	/* Ast/node.scm 29 */
      return
	 conditional_side_effect__set__158_ast_node(
	 (conditional_bglt) (obj_3227), val1546_3228);
   }
}



/* conditional-side-effect? */
obj_t 
conditional_side_effect__145_ast_node(conditional_bglt obj_220)
{
   AN_OBJECT;
   {	/* Ast/node.scm 29 */
      return
	 (((conditional_bglt) CREF(obj_220))->side_effect__165);
   }
}



/* _conditional-side-effect? */
obj_t 
_conditional_side_effect__178_ast_node(obj_t env_3229, obj_t obj_3230)
{
   AN_OBJECT;
   {	/* Ast/node.scm 29 */
      return
	 conditional_side_effect__145_ast_node(
	 (conditional_bglt) (obj_3230));
   }
}



/* conditional-key-set! */
obj_t 
conditional_key_set__247_ast_node(conditional_bglt obj_221, obj_t val1547_222)
{
   AN_OBJECT;
   {	/* Ast/node.scm 33 */
      return
	 ((((conditional_bglt) CREF(obj_221))->key) = ((obj_t) val1547_222), BUNSPEC);
   }
}



/* _conditional-key-set!2524 */
obj_t 
_conditional_key_set_2524_40_ast_node(obj_t env_3231, obj_t obj_3232, obj_t val1547_3233)
{
   AN_OBJECT;
   {	/* Ast/node.scm 33 */
      return
	 conditional_key_set__247_ast_node(
	 (conditional_bglt) (obj_3232), val1547_3233);
   }
}



/* conditional-key */
obj_t 
conditional_key_55_ast_node(conditional_bglt obj_223)
{
   AN_OBJECT;
   {	/* Ast/node.scm 33 */
      return
	 (((conditional_bglt) CREF(obj_223))->key);
   }
}



/* _conditional-key2525 */
obj_t 
_conditional_key2525_224_ast_node(obj_t env_3234, obj_t obj_3235)
{
   AN_OBJECT;
   {	/* Ast/node.scm 33 */
      return
	 conditional_key_55_ast_node(
	 (conditional_bglt) (obj_3235));
   }
}



/* conditional-test-set! */
obj_t 
conditional_test_set__179_ast_node(conditional_bglt obj_224, node_bglt val1548_225)
{
   AN_OBJECT;
   {	/* Ast/node.scm 102 */
      return
	 ((((conditional_bglt) CREF(obj_224))->test) = ((node_bglt) val1548_225), BUNSPEC);
   }
}



/* _conditional-test-set! */
obj_t 
_conditional_test_set__114_ast_node(obj_t env_3236, obj_t obj_3237, obj_t val1548_3238)
{
   AN_OBJECT;
   {	/* Ast/node.scm 102 */
      return
	 conditional_test_set__179_ast_node(
	 (conditional_bglt) (obj_3237),
	 (node_bglt) (val1548_3238));
   }
}



/* conditional-test */
node_bglt 
conditional_test_2_ast_node(conditional_bglt obj_226)
{
   AN_OBJECT;
   {	/* Ast/node.scm 102 */
      return
	 (((conditional_bglt) CREF(obj_226))->test);
   }
}



/* _conditional-test */
obj_t 
_conditional_test_29_ast_node(obj_t env_3239, obj_t obj_3240)
{
   AN_OBJECT;
   {	/* Ast/node.scm 102 */
      {		/* Ast/node.scm 102 */
	 node_bglt aux_4495;
	 aux_4495 =
	    conditional_test_2_ast_node(
	    (conditional_bglt) (obj_3240));
	 return
	    (obj_t) (aux_4495);
      }
   }
}



/* conditional-true-set! */
obj_t 
conditional_true_set__127_ast_node(conditional_bglt obj_227, node_bglt val1549_228)
{
   AN_OBJECT;
   {	/* Ast/node.scm 102 */
      return
	 ((((conditional_bglt) CREF(obj_227))->true) = ((node_bglt) val1549_228), BUNSPEC);
   }
}



/* _conditional-true-set! */
obj_t 
_conditional_true_set__236_ast_node(obj_t env_3241, obj_t obj_3242, obj_t val1549_3243)
{
   AN_OBJECT;
   {	/* Ast/node.scm 102 */
      return
	 conditional_true_set__127_ast_node(
	 (conditional_bglt) (obj_3242),
	 (node_bglt) (val1549_3243));
   }
}



/* conditional-true */
node_bglt 
conditional_true_226_ast_node(conditional_bglt obj_229)
{
   AN_OBJECT;
   {	/* Ast/node.scm 102 */
      return
	 (((conditional_bglt) CREF(obj_229))->true);
   }
}



/* _conditional-true */
obj_t 
_conditional_true_164_ast_node(obj_t env_3244, obj_t obj_3245)
{
   AN_OBJECT;
   {	/* Ast/node.scm 102 */
      {		/* Ast/node.scm 102 */
	 node_bglt aux_4504;
	 aux_4504 =
	    conditional_true_226_ast_node(
	    (conditional_bglt) (obj_3245));
	 return
	    (obj_t) (aux_4504);
      }
   }
}



/* conditional-false-set! */
obj_t 
conditional_false_set__184_ast_node(conditional_bglt obj_230, node_bglt val1550_231)
{
   AN_OBJECT;
   {	/* Ast/node.scm 102 */
      return
	 ((((conditional_bglt) CREF(obj_230))->false) = ((node_bglt) val1550_231), BUNSPEC);
   }
}



/* _conditional-false-set! */
obj_t 
_conditional_false_set__13_ast_node(obj_t env_3246, obj_t obj_3247, obj_t val1550_3248)
{
   AN_OBJECT;
   {	/* Ast/node.scm 102 */
      return
	 conditional_false_set__184_ast_node(
	 (conditional_bglt) (obj_3247),
	 (node_bglt) (val1550_3248));
   }
}



/* conditional-false */
node_bglt 
conditional_false_181_ast_node(conditional_bglt obj_232)
{
   AN_OBJECT;
   {	/* Ast/node.scm 102 */
      return
	 (((conditional_bglt) CREF(obj_232))->false);
   }
}



/* _conditional-false */
obj_t 
_conditional_false_30_ast_node(obj_t env_3249, obj_t obj_3250)
{
   AN_OBJECT;
   {	/* Ast/node.scm 102 */
      {		/* Ast/node.scm 102 */
	 node_bglt aux_4513;
	 aux_4513 =
	    conditional_false_181_ast_node(
	    (conditional_bglt) (obj_3250));
	 return
	    (obj_t) (aux_4513);
      }
   }
}



/* allocate-setq */
setq_bglt 
allocate_setq_54_ast_node()
{
   AN_OBJECT;
   {	/* Ast/node.scm 95 */
      {		/* Ast/node.scm 95 */
	 setq_bglt new1526_997;
	 new1526_997 =
	    ((setq_bglt) BREF(GC_MALLOC(sizeof(struct setq))));
	 {	/* Ast/node.scm 95 */
	    long arg2171_998;
	    arg2171_998 =
	       class_num_218___object(setq_ast_node);
	    {	/* Ast/node.scm 95 */
	       obj_t obj_1960;
	       obj_1960 =
		  (obj_t) (new1526_997);
	       (((obj_t) CREF(obj_1960))->header = MAKE_HEADER(arg2171_998, 0), BUNSPEC);
	    }
	 }
	 {	/* Ast/node.scm 95 */
	    object_bglt aux_4521;
	    aux_4521 =
	       (object_bglt) (new1526_997);
	    OBJECT_WIDENING_SET(aux_4521, BFALSE);
	 }
	 return new1526_997;
      }
   }
}



/* _allocate-setq */
obj_t 
_allocate_setq_253_ast_node(obj_t env_2922)
{
   AN_OBJECT;
   {	/* Ast/node.scm 95 */
      {		/* Ast/node.scm 95 */
	 setq_bglt aux_4524;
	 aux_4524 =
	    allocate_setq_54_ast_node();
	 return
	    (obj_t) (aux_4524);
      }
   }
}



/* setq? */
bool_t 
setq__41_ast_node(obj_t obj_236)
{
   AN_OBJECT;
   {	/* Ast/node.scm 95 */
      return
	 is_a__118___object(obj_236, setq_ast_node);
   }
}



/* _setq? */
obj_t 
_setq__97_ast_node(obj_t env_3251, obj_t obj_3252)
{
   AN_OBJECT;
   {	/* Ast/node.scm 95 */
      {		/* Ast/node.scm 95 */
	 bool_t aux_4528;
	 aux_4528 =
	    setq__41_ast_node(obj_3252);
	 return
	    BBOOL(aux_4528);
      }
   }
}



/* make-setq */
setq_bglt 
make_setq_237_ast_node(obj_t loc_237, type_bglt type_238, var_bglt var_239, node_bglt value_240)
{
   AN_OBJECT;
   {	/* Ast/node.scm 95 */
      {		/* Ast/node.scm 95 */
	 setq_bglt new1520_1962;
	 new1520_1962 =
	    ((setq_bglt) BREF(GC_MALLOC(sizeof(struct setq))));
	 {	/* Ast/node.scm 95 */
	    long arg2172_1963;
	    arg2172_1963 =
	       class_num_218___object(setq_ast_node);
	    {	/* Ast/node.scm 95 */
	       obj_t obj_1968;
	       obj_1968 =
		  (obj_t) (new1520_1962);
	       (((obj_t) CREF(obj_1968))->header = MAKE_HEADER(arg2172_1963, 0), BUNSPEC);
	    }
	 }
	 {	/* Ast/node.scm 95 */
	    object_bglt aux_4535;
	    aux_4535 =
	       (object_bglt) (new1520_1962);
	    OBJECT_WIDENING_SET(aux_4535, BFALSE);
	 }
	 ((((setq_bglt) CREF(new1520_1962))->loc) = ((obj_t) loc_237), BUNSPEC);
	 ((((setq_bglt) CREF(new1520_1962))->type) = ((type_bglt) type_238), BUNSPEC);
	 ((((setq_bglt) CREF(new1520_1962))->var) = ((var_bglt) var_239), BUNSPEC);
	 ((((setq_bglt) CREF(new1520_1962))->value) = ((node_bglt) value_240), BUNSPEC);
	 return new1520_1962;
      }
   }
}



/* _make-setq */
obj_t 
_make_setq_227_ast_node(obj_t env_3253, obj_t loc_3254, obj_t type_3255, obj_t var_3256, obj_t value_3257)
{
   AN_OBJECT;
   {	/* Ast/node.scm 95 */
      {		/* Ast/node.scm 95 */
	 setq_bglt aux_4542;
	 aux_4542 =
	    make_setq_237_ast_node(loc_3254,
	    (type_bglt) (type_3255),
	    (var_bglt) (var_3256),
	    (node_bglt) (value_3257));
	 return
	    (obj_t) (aux_4542);
      }
   }
}



/* setq-loc */
obj_t 
setq_loc_177_ast_node(setq_bglt obj_241)
{
   AN_OBJECT;
   {	/* Ast/node.scm 21 */
      return
	 (((setq_bglt) CREF(obj_241))->loc);
   }
}



/* _setq-loc */
obj_t 
_setq_loc_129_ast_node(obj_t env_3258, obj_t obj_3259)
{
   AN_OBJECT;
   {	/* Ast/node.scm 21 */
      return
	 setq_loc_177_ast_node(
	 (setq_bglt) (obj_3259));
   }
}



/* setq-type-set! */
obj_t 
setq_type_set__224_ast_node(setq_bglt obj_242, type_bglt val1517_243)
{
   AN_OBJECT;
   {	/* Ast/node.scm 95 */
      return
	 ((((setq_bglt) CREF(obj_242))->type) = ((type_bglt) val1517_243), BUNSPEC);
   }
}



/* _setq-type-set! */
obj_t 
_setq_type_set__95_ast_node(obj_t env_3260, obj_t obj_3261, obj_t val1517_3262)
{
   AN_OBJECT;
   {	/* Ast/node.scm 95 */
      return
	 setq_type_set__224_ast_node(
	 (setq_bglt) (obj_3261),
	 (type_bglt) (val1517_3262));
   }
}



/* setq-type */
type_bglt 
setq_type_225_ast_node(setq_bglt obj_244)
{
   AN_OBJECT;
   {	/* Ast/node.scm 95 */
      return
	 (((setq_bglt) CREF(obj_244))->type);
   }
}



/* _setq-type */
obj_t 
_setq_type_40_ast_node(obj_t env_3263, obj_t obj_3264)
{
   AN_OBJECT;
   {	/* Ast/node.scm 95 */
      {		/* Ast/node.scm 95 */
	 type_bglt aux_4556;
	 aux_4556 =
	    setq_type_225_ast_node(
	    (setq_bglt) (obj_3264));
	 return
	    (obj_t) (aux_4556);
      }
   }
}



/* setq-var-set! */
obj_t 
setq_var_set__217_ast_node(setq_bglt obj_245, var_bglt val1518_246)
{
   AN_OBJECT;
   {	/* Ast/node.scm 95 */
      return
	 ((((setq_bglt) CREF(obj_245))->var) = ((var_bglt) val1518_246), BUNSPEC);
   }
}



/* _setq-var-set! */
obj_t 
_setq_var_set__53_ast_node(obj_t env_3265, obj_t obj_3266, obj_t val1518_3267)
{
   AN_OBJECT;
   {	/* Ast/node.scm 95 */
      return
	 setq_var_set__217_ast_node(
	 (setq_bglt) (obj_3266),
	 (var_bglt) (val1518_3267));
   }
}



/* setq-var */
var_bglt 
setq_var_152_ast_node(setq_bglt obj_247)
{
   AN_OBJECT;
   {	/* Ast/node.scm 95 */
      return
	 (((setq_bglt) CREF(obj_247))->var);
   }
}



/* _setq-var */
obj_t 
_setq_var_146_ast_node(obj_t env_3268, obj_t obj_3269)
{
   AN_OBJECT;
   {	/* Ast/node.scm 95 */
      {		/* Ast/node.scm 95 */
	 var_bglt aux_4565;
	 aux_4565 =
	    setq_var_152_ast_node(
	    (setq_bglt) (obj_3269));
	 return
	    (obj_t) (aux_4565);
      }
   }
}



/* setq-value-set! */
obj_t 
setq_value_set__233_ast_node(setq_bglt obj_248, node_bglt val1519_249)
{
   AN_OBJECT;
   {	/* Ast/node.scm 95 */
      return
	 ((((setq_bglt) CREF(obj_248))->value) = ((node_bglt) val1519_249), BUNSPEC);
   }
}



/* _setq-value-set! */
obj_t 
_setq_value_set__101_ast_node(obj_t env_3270, obj_t obj_3271, obj_t val1519_3272)
{
   AN_OBJECT;
   {	/* Ast/node.scm 95 */
      return
	 setq_value_set__233_ast_node(
	 (setq_bglt) (obj_3271),
	 (node_bglt) (val1519_3272));
   }
}



/* setq-value */
node_bglt 
setq_value_119_ast_node(setq_bglt obj_250)
{
   AN_OBJECT;
   {	/* Ast/node.scm 95 */
      return
	 (((setq_bglt) CREF(obj_250))->value);
   }
}



/* _setq-value */
obj_t 
_setq_value_242_ast_node(obj_t env_3273, obj_t obj_3274)
{
   AN_OBJECT;
   {	/* Ast/node.scm 95 */
      {		/* Ast/node.scm 95 */
	 node_bglt aux_4574;
	 aux_4574 =
	    setq_value_119_ast_node(
	    (setq_bglt) (obj_3274));
	 return
	    (obj_t) (aux_4574);
      }
   }
}



/* allocate-cast */
cast_bglt 
allocate_cast_68_ast_node()
{
   AN_OBJECT;
   {	/* Ast/node.scm 90 */
      {		/* Ast/node.scm 90 */
	 cast_bglt new1502_1005;
	 new1502_1005 =
	    ((cast_bglt) BREF(GC_MALLOC(sizeof(struct cast))));
	 {	/* Ast/node.scm 90 */
	    long arg2173_1006;
	    arg2173_1006 =
	       class_num_218___object(cast_ast_node);
	    {	/* Ast/node.scm 90 */
	       obj_t obj_1970;
	       obj_1970 =
		  (obj_t) (new1502_1005);
	       (((obj_t) CREF(obj_1970))->header = MAKE_HEADER(arg2173_1006, 0), BUNSPEC);
	    }
	 }
	 {	/* Ast/node.scm 90 */
	    object_bglt aux_4582;
	    aux_4582 =
	       (object_bglt) (new1502_1005);
	    OBJECT_WIDENING_SET(aux_4582, BFALSE);
	 }
	 return new1502_1005;
      }
   }
}



/* _allocate-cast */
obj_t 
_allocate_cast_146_ast_node(obj_t env_2921)
{
   AN_OBJECT;
   {	/* Ast/node.scm 90 */
      {		/* Ast/node.scm 90 */
	 cast_bglt aux_4585;
	 aux_4585 =
	    allocate_cast_68_ast_node();
	 return
	    (obj_t) (aux_4585);
      }
   }
}



/* cast? */
bool_t 
cast__213_ast_node(obj_t obj_254)
{
   AN_OBJECT;
   {	/* Ast/node.scm 90 */
      return
	 is_a__118___object(obj_254, cast_ast_node);
   }
}



/* _cast? */
obj_t 
_cast__220_ast_node(obj_t env_3275, obj_t obj_3276)
{
   AN_OBJECT;
   {	/* Ast/node.scm 90 */
      {		/* Ast/node.scm 90 */
	 bool_t aux_4589;
	 aux_4589 =
	    cast__213_ast_node(obj_3276);
	 return
	    BBOOL(aux_4589);
      }
   }
}



/* make-cast */
cast_bglt 
make_cast_147_ast_node(obj_t loc_255, type_bglt type_256, node_bglt arg_257)
{
   AN_OBJECT;
   {	/* Ast/node.scm 90 */
      {		/* Ast/node.scm 90 */
	 cast_bglt new1497_1972;
	 new1497_1972 =
	    ((cast_bglt) BREF(GC_MALLOC(sizeof(struct cast))));
	 {	/* Ast/node.scm 90 */
	    long arg2174_1973;
	    arg2174_1973 =
	       class_num_218___object(cast_ast_node);
	    {	/* Ast/node.scm 90 */
	       obj_t obj_1977;
	       obj_1977 =
		  (obj_t) (new1497_1972);
	       (((obj_t) CREF(obj_1977))->header = MAKE_HEADER(arg2174_1973, 0), BUNSPEC);
	    }
	 }
	 {	/* Ast/node.scm 90 */
	    object_bglt aux_4596;
	    aux_4596 =
	       (object_bglt) (new1497_1972);
	    OBJECT_WIDENING_SET(aux_4596, BFALSE);
	 }
	 ((((cast_bglt) CREF(new1497_1972))->loc) = ((obj_t) loc_255), BUNSPEC);
	 ((((cast_bglt) CREF(new1497_1972))->type) = ((type_bglt) type_256), BUNSPEC);
	 ((((cast_bglt) CREF(new1497_1972))->arg) = ((node_bglt) arg_257), BUNSPEC);
	 return new1497_1972;
      }
   }
}



/* _make-cast */
obj_t 
_make_cast_224_ast_node(obj_t env_3277, obj_t loc_3278, obj_t type_3279, obj_t arg_3280)
{
   AN_OBJECT;
   {	/* Ast/node.scm 90 */
      {		/* Ast/node.scm 90 */
	 cast_bglt aux_4602;
	 aux_4602 =
	    make_cast_147_ast_node(loc_3278,
	    (type_bglt) (type_3279),
	    (node_bglt) (arg_3280));
	 return
	    (obj_t) (aux_4602);
      }
   }
}



/* cast-loc */
obj_t 
cast_loc_174_ast_node(cast_bglt obj_258)
{
   AN_OBJECT;
   {	/* Ast/node.scm 21 */
      return
	 (((cast_bglt) CREF(obj_258))->loc);
   }
}



/* _cast-loc */
obj_t 
_cast_loc_222_ast_node(obj_t env_3281, obj_t obj_3282)
{
   AN_OBJECT;
   {	/* Ast/node.scm 21 */
      return
	 cast_loc_174_ast_node(
	 (cast_bglt) (obj_3282));
   }
}



/* cast-type-set! */
obj_t 
cast_type_set__214_ast_node(cast_bglt obj_259, type_bglt val1495_260)
{
   AN_OBJECT;
   {	/* Ast/node.scm 90 */
      return
	 ((((cast_bglt) CREF(obj_259))->type) = ((type_bglt) val1495_260), BUNSPEC);
   }
}



/* _cast-type-set! */
obj_t 
_cast_type_set__213_ast_node(obj_t env_3283, obj_t obj_3284, obj_t val1495_3285)
{
   AN_OBJECT;
   {	/* Ast/node.scm 90 */
      return
	 cast_type_set__214_ast_node(
	 (cast_bglt) (obj_3284),
	 (type_bglt) (val1495_3285));
   }
}



/* cast-type */
type_bglt 
cast_type_139_ast_node(cast_bglt obj_261)
{
   AN_OBJECT;
   {	/* Ast/node.scm 90 */
      return
	 (((cast_bglt) CREF(obj_261))->type);
   }
}



/* _cast-type */
obj_t 
_cast_type_62_ast_node(obj_t env_3286, obj_t obj_3287)
{
   AN_OBJECT;
   {	/* Ast/node.scm 90 */
      {		/* Ast/node.scm 90 */
	 type_bglt aux_4615;
	 aux_4615 =
	    cast_type_139_ast_node(
	    (cast_bglt) (obj_3287));
	 return
	    (obj_t) (aux_4615);
      }
   }
}



/* cast-arg-set! */
obj_t 
cast_arg_set__132_ast_node(cast_bglt obj_262, node_bglt val1496_263)
{
   AN_OBJECT;
   {	/* Ast/node.scm 90 */
      return
	 ((((cast_bglt) CREF(obj_262))->arg) = ((node_bglt) val1496_263), BUNSPEC);
   }
}



/* _cast-arg-set! */
obj_t 
_cast_arg_set__200_ast_node(obj_t env_3288, obj_t obj_3289, obj_t val1496_3290)
{
   AN_OBJECT;
   {	/* Ast/node.scm 90 */
      return
	 cast_arg_set__132_ast_node(
	 (cast_bglt) (obj_3289),
	 (node_bglt) (val1496_3290));
   }
}



/* cast-arg */
node_bglt 
cast_arg_174_ast_node(cast_bglt obj_264)
{
   AN_OBJECT;
   {	/* Ast/node.scm 90 */
      return
	 (((cast_bglt) CREF(obj_264))->arg);
   }
}



/* _cast-arg */
obj_t 
_cast_arg_8_ast_node(obj_t env_3291, obj_t obj_3292)
{
   AN_OBJECT;
   {	/* Ast/node.scm 90 */
      {		/* Ast/node.scm 90 */
	 node_bglt aux_4624;
	 aux_4624 =
	    cast_arg_174_ast_node(
	    (cast_bglt) (obj_3292));
	 return
	    (obj_t) (aux_4624);
      }
   }
}



/* allocate-pragma */
pragma_bglt 
allocate_pragma_110_ast_node()
{
   AN_OBJECT;
   {	/* Ast/node.scm 85 */
      {		/* Ast/node.scm 85 */
	 pragma_bglt new1468_1012;
	 new1468_1012 =
	    ((pragma_bglt) BREF(GC_MALLOC(sizeof(struct pragma))));
	 {	/* Ast/node.scm 85 */
	    long arg2175_1013;
	    arg2175_1013 =
	       class_num_218___object(pragma_ast_node);
	    {	/* Ast/node.scm 85 */
	       obj_t obj_1979;
	       obj_1979 =
		  (obj_t) (new1468_1012);
	       (((obj_t) CREF(obj_1979))->header = MAKE_HEADER(arg2175_1013, 0), BUNSPEC);
	    }
	 }
	 {	/* Ast/node.scm 85 */
	    object_bglt aux_4632;
	    aux_4632 =
	       (object_bglt) (new1468_1012);
	    OBJECT_WIDENING_SET(aux_4632, BFALSE);
	 }
	 return new1468_1012;
      }
   }
}



/* _allocate-pragma */
obj_t 
_allocate_pragma_246_ast_node(obj_t env_2920)
{
   AN_OBJECT;
   {	/* Ast/node.scm 85 */
      {		/* Ast/node.scm 85 */
	 pragma_bglt aux_4635;
	 aux_4635 =
	    allocate_pragma_110_ast_node();
	 return
	    (obj_t) (aux_4635);
      }
   }
}



/* pragma? */
bool_t 
pragma__55_ast_node(obj_t obj_268)
{
   AN_OBJECT;
   {	/* Ast/node.scm 85 */
      return
	 is_a__118___object(obj_268, pragma_ast_node);
   }
}



/* _pragma? */
obj_t 
_pragma__23_ast_node(obj_t env_3293, obj_t obj_3294)
{
   AN_OBJECT;
   {	/* Ast/node.scm 85 */
      {		/* Ast/node.scm 85 */
	 bool_t aux_4639;
	 aux_4639 =
	    pragma__55_ast_node(obj_3294);
	 return
	    BBOOL(aux_4639);
      }
   }
}



/* make-pragma */
pragma_bglt 
make_pragma_155_ast_node(obj_t loc_269, type_bglt type_270, obj_t side_effect__165_271, obj_t key_272, obj_t format_273, obj_t args_274)
{
   AN_OBJECT;
   {	/* Ast/node.scm 85 */
      {		/* Ast/node.scm 85 */
	 pragma_bglt new1460_1981;
	 new1460_1981 =
	    ((pragma_bglt) BREF(GC_MALLOC(sizeof(struct pragma))));
	 {	/* Ast/node.scm 85 */
	    long arg2176_1982;
	    arg2176_1982 =
	       class_num_218___object(pragma_ast_node);
	    {	/* Ast/node.scm 85 */
	       obj_t obj_1989;
	       obj_1989 =
		  (obj_t) (new1460_1981);
	       (((obj_t) CREF(obj_1989))->header = MAKE_HEADER(arg2176_1982, 0), BUNSPEC);
	    }
	 }
	 {	/* Ast/node.scm 85 */
	    object_bglt aux_4646;
	    aux_4646 =
	       (object_bglt) (new1460_1981);
	    OBJECT_WIDENING_SET(aux_4646, BFALSE);
	 }
	 ((((pragma_bglt) CREF(new1460_1981))->loc) = ((obj_t) loc_269), BUNSPEC);
	 ((((pragma_bglt) CREF(new1460_1981))->type) = ((type_bglt) type_270), BUNSPEC);
	 ((((pragma_bglt) CREF(new1460_1981))->side_effect__165) = ((obj_t) side_effect__165_271), BUNSPEC);
	 ((((pragma_bglt) CREF(new1460_1981))->key) = ((obj_t) key_272), BUNSPEC);
	 ((((pragma_bglt) CREF(new1460_1981))->format) = ((obj_t) format_273), BUNSPEC);
	 ((((pragma_bglt) CREF(new1460_1981))->args) = ((obj_t) args_274), BUNSPEC);
	 return new1460_1981;
      }
   }
}



/* _make-pragma */
obj_t 
_make_pragma_8_ast_node(obj_t env_3295, obj_t loc_3296, obj_t type_3297, obj_t side_effect__165_3298, obj_t key_3299, obj_t format_3300, obj_t args_3301)
{
   AN_OBJECT;
   {	/* Ast/node.scm 85 */
      {		/* Ast/node.scm 85 */
	 pragma_bglt aux_4655;
	 aux_4655 =
	    make_pragma_155_ast_node(loc_3296,
	    (type_bglt) (type_3297), side_effect__165_3298, key_3299, format_3300, args_3301);
	 return
	    (obj_t) (aux_4655);
      }
   }
}



/* pragma-loc */
obj_t 
pragma_loc_254_ast_node(pragma_bglt obj_275)
{
   AN_OBJECT;
   {	/* Ast/node.scm 21 */
      return
	 (((pragma_bglt) CREF(obj_275))->loc);
   }
}



/* _pragma-loc */
obj_t 
_pragma_loc_176_ast_node(obj_t env_3302, obj_t obj_3303)
{
   AN_OBJECT;
   {	/* Ast/node.scm 21 */
      return
	 pragma_loc_254_ast_node(
	 (pragma_bglt) (obj_3303));
   }
}



/* pragma-type-set! */
obj_t 
pragma_type_set__19_ast_node(pragma_bglt obj_276, type_bglt val1456_277)
{
   AN_OBJECT;
   {	/* Ast/node.scm 85 */
      return
	 ((((pragma_bglt) CREF(obj_276))->type) = ((type_bglt) val1456_277), BUNSPEC);
   }
}



/* _pragma-type-set! */
obj_t 
_pragma_type_set__65_ast_node(obj_t env_3304, obj_t obj_3305, obj_t val1456_3306)
{
   AN_OBJECT;
   {	/* Ast/node.scm 85 */
      return
	 pragma_type_set__19_ast_node(
	 (pragma_bglt) (obj_3305),
	 (type_bglt) (val1456_3306));
   }
}



/* pragma-type */
type_bglt 
pragma_type_32_ast_node(pragma_bglt obj_278)
{
   AN_OBJECT;
   {	/* Ast/node.scm 85 */
      return
	 (((pragma_bglt) CREF(obj_278))->type);
   }
}



/* _pragma-type */
obj_t 
_pragma_type_23_ast_node(obj_t env_3307, obj_t obj_3308)
{
   AN_OBJECT;
   {	/* Ast/node.scm 85 */
      {		/* Ast/node.scm 85 */
	 type_bglt aux_4667;
	 aux_4667 =
	    pragma_type_32_ast_node(
	    (pragma_bglt) (obj_3308));
	 return
	    (obj_t) (aux_4667);
      }
   }
}



/* pragma-side-effect?-set! */
obj_t 
pragma_side_effect__set__174_ast_node(pragma_bglt obj_279, obj_t val1457_280)
{
   AN_OBJECT;
   {	/* Ast/node.scm 29 */
      return
	 ((((pragma_bglt) CREF(obj_279))->side_effect__165) = ((obj_t) val1457_280), BUNSPEC);
   }
}



/* _pragma-side-effect?-set! */
obj_t 
_pragma_side_effect__set__36_ast_node(obj_t env_3309, obj_t obj_3310, obj_t val1457_3311)
{
   AN_OBJECT;
   {	/* Ast/node.scm 29 */
      return
	 pragma_side_effect__set__174_ast_node(
	 (pragma_bglt) (obj_3310), val1457_3311);
   }
}



/* pragma-side-effect? */
obj_t 
pragma_side_effect__84_ast_node(pragma_bglt obj_281)
{
   AN_OBJECT;
   {	/* Ast/node.scm 29 */
      return
	 (((pragma_bglt) CREF(obj_281))->side_effect__165);
   }
}



/* _pragma-side-effect? */
obj_t 
_pragma_side_effect__63_ast_node(obj_t env_3312, obj_t obj_3313)
{
   AN_OBJECT;
   {	/* Ast/node.scm 29 */
      return
	 pragma_side_effect__84_ast_node(
	 (pragma_bglt) (obj_3313));
   }
}



/* pragma-key-set! */
obj_t 
pragma_key_set__102_ast_node(pragma_bglt obj_282, obj_t val1458_283)
{
   AN_OBJECT;
   {	/* Ast/node.scm 33 */
      return
	 ((((pragma_bglt) CREF(obj_282))->key) = ((obj_t) val1458_283), BUNSPEC);
   }
}



/* _pragma-key-set!2526 */
obj_t 
_pragma_key_set_2526_118_ast_node(obj_t env_3314, obj_t obj_3315, obj_t val1458_3316)
{
   AN_OBJECT;
   {	/* Ast/node.scm 33 */
      return
	 pragma_key_set__102_ast_node(
	 (pragma_bglt) (obj_3315), val1458_3316);
   }
}



/* pragma-key */
obj_t 
pragma_key_211_ast_node(pragma_bglt obj_284)
{
   AN_OBJECT;
   {	/* Ast/node.scm 33 */
      return
	 (((pragma_bglt) CREF(obj_284))->key);
   }
}



/* _pragma-key2527 */
obj_t 
_pragma_key2527_152_ast_node(obj_t env_3317, obj_t obj_3318)
{
   AN_OBJECT;
   {	/* Ast/node.scm 33 */
      return
	 pragma_key_211_ast_node(
	 (pragma_bglt) (obj_3318));
   }
}



/* pragma-format */
obj_t 
pragma_format_172_ast_node(pragma_bglt obj_285)
{
   AN_OBJECT;
   {	/* Ast/node.scm 86 */
      return
	 (((pragma_bglt) CREF(obj_285))->format);
   }
}



/* _pragma-format */
obj_t 
_pragma_format_55_ast_node(obj_t env_3319, obj_t obj_3320)
{
   AN_OBJECT;
   {	/* Ast/node.scm 86 */
      return
	 pragma_format_172_ast_node(
	 (pragma_bglt) (obj_3320));
   }
}



/* pragma-args-set! */
obj_t 
pragma_args_set__199_ast_node(pragma_bglt obj_286, obj_t val1459_287)
{
   AN_OBJECT;
   {	/* Ast/node.scm 85 */
      return
	 ((((pragma_bglt) CREF(obj_286))->args) = ((obj_t) val1459_287), BUNSPEC);
   }
}



/* _pragma-args-set! */
obj_t 
_pragma_args_set__242_ast_node(obj_t env_3321, obj_t obj_3322, obj_t val1459_3323)
{
   AN_OBJECT;
   {	/* Ast/node.scm 85 */
      return
	 pragma_args_set__199_ast_node(
	 (pragma_bglt) (obj_3322), val1459_3323);
   }
}



/* pragma-args */
obj_t 
pragma_args_116_ast_node(pragma_bglt obj_288)
{
   AN_OBJECT;
   {	/* Ast/node.scm 85 */
      return
	 (((pragma_bglt) CREF(obj_288))->args);
   }
}



/* _pragma-args */
obj_t 
_pragma_args_183_ast_node(obj_t env_3324, obj_t obj_3325)
{
   AN_OBJECT;
   {	/* Ast/node.scm 85 */
      return
	 pragma_args_116_ast_node(
	 (pragma_bglt) (obj_3325));
   }
}



/* allocate-funcall */
funcall_bglt 
allocate_funcall_80_ast_node()
{
   AN_OBJECT;
   {	/* Ast/node.scm 74 */
      {		/* Ast/node.scm 74 */
	 funcall_bglt new1433_1022;
	 new1433_1022 =
	    ((funcall_bglt) BREF(GC_MALLOC(sizeof(struct funcall))));
	 {	/* Ast/node.scm 74 */
	    long arg2177_1023;
	    arg2177_1023 =
	       class_num_218___object(funcall_ast_node);
	    {	/* Ast/node.scm 74 */
	       obj_t obj_1991;
	       obj_1991 =
		  (obj_t) (new1433_1022);
	       (((obj_t) CREF(obj_1991))->header = MAKE_HEADER(arg2177_1023, 0), BUNSPEC);
	    }
	 }
	 {	/* Ast/node.scm 74 */
	    object_bglt aux_4696;
	    aux_4696 =
	       (object_bglt) (new1433_1022);
	    OBJECT_WIDENING_SET(aux_4696, BFALSE);
	 }
	 return new1433_1022;
      }
   }
}



/* _allocate-funcall */
obj_t 
_allocate_funcall_93_ast_node(obj_t env_2919)
{
   AN_OBJECT;
   {	/* Ast/node.scm 74 */
      {		/* Ast/node.scm 74 */
	 funcall_bglt aux_4699;
	 aux_4699 =
	    allocate_funcall_80_ast_node();
	 return
	    (obj_t) (aux_4699);
      }
   }
}



/* funcall? */
bool_t 
funcall__35_ast_node(obj_t obj_292)
{
   AN_OBJECT;
   {	/* Ast/node.scm 74 */
      return
	 is_a__118___object(obj_292, funcall_ast_node);
   }
}



/* _funcall? */
obj_t 
_funcall__161_ast_node(obj_t env_3326, obj_t obj_3327)
{
   AN_OBJECT;
   {	/* Ast/node.scm 74 */
      {		/* Ast/node.scm 74 */
	 bool_t aux_4703;
	 aux_4703 =
	    funcall__35_ast_node(obj_3327);
	 return
	    BBOOL(aux_4703);
      }
   }
}



/* make-funcall */
funcall_bglt 
make_funcall_190_ast_node(obj_t loc_293, type_bglt type_294, node_bglt fun_295, obj_t args_296, obj_t strength_297)
{
   AN_OBJECT;
   {	/* Ast/node.scm 74 */
      {		/* Ast/node.scm 74 */
	 funcall_bglt new1426_1993;
	 new1426_1993 =
	    ((funcall_bglt) BREF(GC_MALLOC(sizeof(struct funcall))));
	 {	/* Ast/node.scm 74 */
	    long arg2178_1994;
	    arg2178_1994 =
	       class_num_218___object(funcall_ast_node);
	    {	/* Ast/node.scm 74 */
	       obj_t obj_2000;
	       obj_2000 =
		  (obj_t) (new1426_1993);
	       (((obj_t) CREF(obj_2000))->header = MAKE_HEADER(arg2178_1994, 0), BUNSPEC);
	    }
	 }
	 {	/* Ast/node.scm 74 */
	    object_bglt aux_4710;
	    aux_4710 =
	       (object_bglt) (new1426_1993);
	    OBJECT_WIDENING_SET(aux_4710, BFALSE);
	 }
	 ((((funcall_bglt) CREF(new1426_1993))->loc) = ((obj_t) loc_293), BUNSPEC);
	 ((((funcall_bglt) CREF(new1426_1993))->type) = ((type_bglt) type_294), BUNSPEC);
	 ((((funcall_bglt) CREF(new1426_1993))->fun) = ((node_bglt) fun_295), BUNSPEC);
	 ((((funcall_bglt) CREF(new1426_1993))->args) = ((obj_t) args_296), BUNSPEC);
	 ((((funcall_bglt) CREF(new1426_1993))->strength) = ((obj_t) strength_297), BUNSPEC);
	 return new1426_1993;
      }
   }
}



/* _make-funcall */
obj_t 
_make_funcall_77_ast_node(obj_t env_3328, obj_t loc_3329, obj_t type_3330, obj_t fun_3331, obj_t args_3332, obj_t strength_3333)
{
   AN_OBJECT;
   {	/* Ast/node.scm 74 */
      {		/* Ast/node.scm 74 */
	 funcall_bglt aux_4718;
	 aux_4718 =
	    make_funcall_190_ast_node(loc_3329,
	    (type_bglt) (type_3330),
	    (node_bglt) (fun_3331), args_3332, strength_3333);
	 return
	    (obj_t) (aux_4718);
      }
   }
}



/* funcall-loc */
obj_t 
funcall_loc_117_ast_node(funcall_bglt obj_298)
{
   AN_OBJECT;
   {	/* Ast/node.scm 21 */
      return
	 (((funcall_bglt) CREF(obj_298))->loc);
   }
}



/* _funcall-loc */
obj_t 
_funcall_loc_189_ast_node(obj_t env_3334, obj_t obj_3335)
{
   AN_OBJECT;
   {	/* Ast/node.scm 21 */
      return
	 funcall_loc_117_ast_node(
	 (funcall_bglt) (obj_3335));
   }
}



/* funcall-type-set! */
obj_t 
funcall_type_set__42_ast_node(funcall_bglt obj_299, type_bglt val1422_300)
{
   AN_OBJECT;
   {	/* Ast/node.scm 74 */
      return
	 ((((funcall_bglt) CREF(obj_299))->type) = ((type_bglt) val1422_300), BUNSPEC);
   }
}



/* _funcall-type-set! */
obj_t 
_funcall_type_set__146_ast_node(obj_t env_3336, obj_t obj_3337, obj_t val1422_3338)
{
   AN_OBJECT;
   {	/* Ast/node.scm 74 */
      return
	 funcall_type_set__42_ast_node(
	 (funcall_bglt) (obj_3337),
	 (type_bglt) (val1422_3338));
   }
}



/* funcall-type */
type_bglt 
funcall_type_93_ast_node(funcall_bglt obj_301)
{
   AN_OBJECT;
   {	/* Ast/node.scm 74 */
      return
	 (((funcall_bglt) CREF(obj_301))->type);
   }
}



/* _funcall-type */
obj_t 
_funcall_type_115_ast_node(obj_t env_3339, obj_t obj_3340)
{
   AN_OBJECT;
   {	/* Ast/node.scm 74 */
      {		/* Ast/node.scm 74 */
	 type_bglt aux_4731;
	 aux_4731 =
	    funcall_type_93_ast_node(
	    (funcall_bglt) (obj_3340));
	 return
	    (obj_t) (aux_4731);
      }
   }
}



/* funcall-fun-set! */
obj_t 
funcall_fun_set__22_ast_node(funcall_bglt obj_302, node_bglt val1423_303)
{
   AN_OBJECT;
   {	/* Ast/node.scm 74 */
      return
	 ((((funcall_bglt) CREF(obj_302))->fun) = ((node_bglt) val1423_303), BUNSPEC);
   }
}



/* _funcall-fun-set! */
obj_t 
_funcall_fun_set__5_ast_node(obj_t env_3341, obj_t obj_3342, obj_t val1423_3343)
{
   AN_OBJECT;
   {	/* Ast/node.scm 74 */
      return
	 funcall_fun_set__22_ast_node(
	 (funcall_bglt) (obj_3342),
	 (node_bglt) (val1423_3343));
   }
}



/* funcall-fun */
node_bglt 
funcall_fun_37_ast_node(funcall_bglt obj_304)
{
   AN_OBJECT;
   {	/* Ast/node.scm 74 */
      return
	 (((funcall_bglt) CREF(obj_304))->fun);
   }
}



/* _funcall-fun */
obj_t 
_funcall_fun_245_ast_node(obj_t env_3344, obj_t obj_3345)
{
   AN_OBJECT;
   {	/* Ast/node.scm 74 */
      {		/* Ast/node.scm 74 */
	 node_bglt aux_4740;
	 aux_4740 =
	    funcall_fun_37_ast_node(
	    (funcall_bglt) (obj_3345));
	 return
	    (obj_t) (aux_4740);
      }
   }
}



/* funcall-args-set! */
obj_t 
funcall_args_set__108_ast_node(funcall_bglt obj_305, obj_t val1424_306)
{
   AN_OBJECT;
   {	/* Ast/node.scm 74 */
      return
	 ((((funcall_bglt) CREF(obj_305))->args) = ((obj_t) val1424_306), BUNSPEC);
   }
}



/* _funcall-args-set! */
obj_t 
_funcall_args_set__216_ast_node(obj_t env_3346, obj_t obj_3347, obj_t val1424_3348)
{
   AN_OBJECT;
   {	/* Ast/node.scm 74 */
      return
	 funcall_args_set__108_ast_node(
	 (funcall_bglt) (obj_3347), val1424_3348);
   }
}



/* funcall-args */
obj_t 
funcall_args_151_ast_node(funcall_bglt obj_307)
{
   AN_OBJECT;
   {	/* Ast/node.scm 74 */
      return
	 (((funcall_bglt) CREF(obj_307))->args);
   }
}



/* _funcall-args */
obj_t 
_funcall_args_191_ast_node(obj_t env_3349, obj_t obj_3350)
{
   AN_OBJECT;
   {	/* Ast/node.scm 74 */
      return
	 funcall_args_151_ast_node(
	 (funcall_bglt) (obj_3350));
   }
}



/* funcall-strength-set! */
obj_t 
funcall_strength_set__57_ast_node(funcall_bglt obj_308, obj_t val1425_309)
{
   AN_OBJECT;
   {	/* Ast/node.scm 80 */
      return
	 ((((funcall_bglt) CREF(obj_308))->strength) = ((obj_t) val1425_309), BUNSPEC);
   }
}



/* _funcall-strength-set! */
obj_t 
_funcall_strength_set__93_ast_node(obj_t env_3351, obj_t obj_3352, obj_t val1425_3353)
{
   AN_OBJECT;
   {	/* Ast/node.scm 80 */
      return
	 funcall_strength_set__57_ast_node(
	 (funcall_bglt) (obj_3352), val1425_3353);
   }
}



/* funcall-strength */
obj_t 
funcall_strength_157_ast_node(funcall_bglt obj_310)
{
   AN_OBJECT;
   {	/* Ast/node.scm 80 */
      return
	 (((funcall_bglt) CREF(obj_310))->strength);
   }
}



/* _funcall-strength */
obj_t 
_funcall_strength_15_ast_node(obj_t env_3354, obj_t obj_3355)
{
   AN_OBJECT;
   {	/* Ast/node.scm 80 */
      return
	 funcall_strength_157_ast_node(
	 (funcall_bglt) (obj_3355));
   }
}



/* allocate-app-ly */
app_ly_162_bglt 
allocate_app_ly_30_ast_node()
{
   AN_OBJECT;
   {	/* Ast/node.scm 67 */
      {		/* Ast/node.scm 67 */
	 app_ly_162_bglt new1403_1031;
	 new1403_1031 =
	    ((app_ly_162_bglt) BREF(GC_MALLOC(sizeof(struct app_ly_162))));
	 {	/* Ast/node.scm 67 */
	    long arg2179_1032;
	    arg2179_1032 =
	       class_num_218___object(app_ly_162_ast_node);
	    {	/* Ast/node.scm 67 */
	       obj_t obj_2002;
	       obj_2002 =
		  (obj_t) (new1403_1031);
	       (((obj_t) CREF(obj_2002))->header = MAKE_HEADER(arg2179_1032, 0), BUNSPEC);
	    }
	 }
	 {	/* Ast/node.scm 67 */
	    object_bglt aux_4760;
	    aux_4760 =
	       (object_bglt) (new1403_1031);
	    OBJECT_WIDENING_SET(aux_4760, BFALSE);
	 }
	 return new1403_1031;
      }
   }
}



/* _allocate-app-ly */
obj_t 
_allocate_app_ly_138_ast_node(obj_t env_2918)
{
   AN_OBJECT;
   {	/* Ast/node.scm 67 */
      {		/* Ast/node.scm 67 */
	 app_ly_162_bglt aux_4763;
	 aux_4763 =
	    allocate_app_ly_30_ast_node();
	 return
	    (obj_t) (aux_4763);
      }
   }
}



/* app-ly? */
bool_t 
app_ly__191_ast_node(obj_t obj_314)
{
   AN_OBJECT;
   {	/* Ast/node.scm 67 */
      return
	 is_a__118___object(obj_314, app_ly_162_ast_node);
   }
}



/* _app-ly? */
obj_t 
_app_ly__224_ast_node(obj_t env_3356, obj_t obj_3357)
{
   AN_OBJECT;
   {	/* Ast/node.scm 67 */
      {		/* Ast/node.scm 67 */
	 bool_t aux_4767;
	 aux_4767 =
	    app_ly__191_ast_node(obj_3357);
	 return
	    BBOOL(aux_4767);
      }
   }
}



/* make-app-ly */
app_ly_162_bglt 
make_app_ly_64_ast_node(obj_t loc_315, type_bglt type_316, node_bglt fun_317, node_bglt arg_318)
{
   AN_OBJECT;
   {	/* Ast/node.scm 67 */
      {		/* Ast/node.scm 67 */
	 app_ly_162_bglt new1397_2004;
	 new1397_2004 =
	    ((app_ly_162_bglt) BREF(GC_MALLOC(sizeof(struct app_ly_162))));
	 {	/* Ast/node.scm 67 */
	    long arg2180_2005;
	    arg2180_2005 =
	       class_num_218___object(app_ly_162_ast_node);
	    {	/* Ast/node.scm 67 */
	       obj_t obj_2010;
	       obj_2010 =
		  (obj_t) (new1397_2004);
	       (((obj_t) CREF(obj_2010))->header = MAKE_HEADER(arg2180_2005, 0), BUNSPEC);
	    }
	 }
	 {	/* Ast/node.scm 67 */
	    object_bglt aux_4774;
	    aux_4774 =
	       (object_bglt) (new1397_2004);
	    OBJECT_WIDENING_SET(aux_4774, BFALSE);
	 }
	 ((((app_ly_162_bglt) CREF(new1397_2004))->loc) = ((obj_t) loc_315), BUNSPEC);
	 ((((app_ly_162_bglt) CREF(new1397_2004))->type) = ((type_bglt) type_316), BUNSPEC);
	 ((((app_ly_162_bglt) CREF(new1397_2004))->fun) = ((node_bglt) fun_317), BUNSPEC);
	 ((((app_ly_162_bglt) CREF(new1397_2004))->arg) = ((node_bglt) arg_318), BUNSPEC);
	 return new1397_2004;
      }
   }
}



/* _make-app-ly */
obj_t 
_make_app_ly_198_ast_node(obj_t env_3358, obj_t loc_3359, obj_t type_3360, obj_t fun_3361, obj_t arg_3362)
{
   AN_OBJECT;
   {	/* Ast/node.scm 67 */
      {		/* Ast/node.scm 67 */
	 app_ly_162_bglt aux_4781;
	 aux_4781 =
	    make_app_ly_64_ast_node(loc_3359,
	    (type_bglt) (type_3360),
	    (node_bglt) (fun_3361),
	    (node_bglt) (arg_3362));
	 return
	    (obj_t) (aux_4781);
      }
   }
}



/* app-ly-loc */
obj_t 
app_ly_loc_83_ast_node(app_ly_162_bglt obj_319)
{
   AN_OBJECT;
   {	/* Ast/node.scm 21 */
      return
	 (((app_ly_162_bglt) CREF(obj_319))->loc);
   }
}



/* _app-ly-loc */
obj_t 
_app_ly_loc_181_ast_node(obj_t env_3363, obj_t obj_3364)
{
   AN_OBJECT;
   {	/* Ast/node.scm 21 */
      return
	 app_ly_loc_83_ast_node(
	 (app_ly_162_bglt) (obj_3364));
   }
}



/* app-ly-type-set! */
obj_t 
app_ly_type_set__172_ast_node(app_ly_162_bglt obj_320, type_bglt val1394_321)
{
   AN_OBJECT;
   {	/* Ast/node.scm 67 */
      return
	 ((((app_ly_162_bglt) CREF(obj_320))->type) = ((type_bglt) val1394_321), BUNSPEC);
   }
}



/* _app-ly-type-set! */
obj_t 
_app_ly_type_set__26_ast_node(obj_t env_3365, obj_t obj_3366, obj_t val1394_3367)
{
   AN_OBJECT;
   {	/* Ast/node.scm 67 */
      return
	 app_ly_type_set__172_ast_node(
	 (app_ly_162_bglt) (obj_3366),
	 (type_bglt) (val1394_3367));
   }
}



/* app-ly-type */
type_bglt 
app_ly_type_138_ast_node(app_ly_162_bglt obj_322)
{
   AN_OBJECT;
   {	/* Ast/node.scm 67 */
      return
	 (((app_ly_162_bglt) CREF(obj_322))->type);
   }
}



/* _app-ly-type */
obj_t 
_app_ly_type_173_ast_node(obj_t env_3368, obj_t obj_3369)
{
   AN_OBJECT;
   {	/* Ast/node.scm 67 */
      {		/* Ast/node.scm 67 */
	 type_bglt aux_4795;
	 aux_4795 =
	    app_ly_type_138_ast_node(
	    (app_ly_162_bglt) (obj_3369));
	 return
	    (obj_t) (aux_4795);
      }
   }
}



/* app-ly-fun-set! */
obj_t 
app_ly_fun_set__208_ast_node(app_ly_162_bglt obj_323, node_bglt val1395_324)
{
   AN_OBJECT;
   {	/* Ast/node.scm 67 */
      return
	 ((((app_ly_162_bglt) CREF(obj_323))->fun) = ((node_bglt) val1395_324), BUNSPEC);
   }
}



/* _app-ly-fun-set! */
obj_t 
_app_ly_fun_set__19_ast_node(obj_t env_3370, obj_t obj_3371, obj_t val1395_3372)
{
   AN_OBJECT;
   {	/* Ast/node.scm 67 */
      return
	 app_ly_fun_set__208_ast_node(
	 (app_ly_162_bglt) (obj_3371),
	 (node_bglt) (val1395_3372));
   }
}



/* app-ly-fun */
node_bglt 
app_ly_fun_107_ast_node(app_ly_162_bglt obj_325)
{
   AN_OBJECT;
   {	/* Ast/node.scm 67 */
      return
	 (((app_ly_162_bglt) CREF(obj_325))->fun);
   }
}



/* _app-ly-fun */
obj_t 
_app_ly_fun_32_ast_node(obj_t env_3373, obj_t obj_3374)
{
   AN_OBJECT;
   {	/* Ast/node.scm 67 */
      {		/* Ast/node.scm 67 */
	 node_bglt aux_4804;
	 aux_4804 =
	    app_ly_fun_107_ast_node(
	    (app_ly_162_bglt) (obj_3374));
	 return
	    (obj_t) (aux_4804);
      }
   }
}



/* app-ly-arg-set! */
obj_t 
app_ly_arg_set__254_ast_node(app_ly_162_bglt obj_326, node_bglt val1396_327)
{
   AN_OBJECT;
   {	/* Ast/node.scm 67 */
      return
	 ((((app_ly_162_bglt) CREF(obj_326))->arg) = ((node_bglt) val1396_327), BUNSPEC);
   }
}



/* _app-ly-arg-set! */
obj_t 
_app_ly_arg_set__63_ast_node(obj_t env_3375, obj_t obj_3376, obj_t val1396_3377)
{
   AN_OBJECT;
   {	/* Ast/node.scm 67 */
      return
	 app_ly_arg_set__254_ast_node(
	 (app_ly_162_bglt) (obj_3376),
	 (node_bglt) (val1396_3377));
   }
}



/* app-ly-arg */
node_bglt 
app_ly_arg_131_ast_node(app_ly_162_bglt obj_328)
{
   AN_OBJECT;
   {	/* Ast/node.scm 67 */
      return
	 (((app_ly_162_bglt) CREF(obj_328))->arg);
   }
}



/* _app-ly-arg */
obj_t 
_app_ly_arg_77_ast_node(obj_t env_3378, obj_t obj_3379)
{
   AN_OBJECT;
   {	/* Ast/node.scm 67 */
      {		/* Ast/node.scm 67 */
	 node_bglt aux_4813;
	 aux_4813 =
	    app_ly_arg_131_ast_node(
	    (app_ly_162_bglt) (obj_3379));
	 return
	    (obj_t) (aux_4813);
      }
   }
}



/* allocate-app */
app_bglt 
allocate_app_15_ast_node()
{
   AN_OBJECT;
   {	/* Ast/node.scm 58 */
      {		/* Ast/node.scm 58 */
	 app_bglt new1363_1039;
	 new1363_1039 =
	    ((app_bglt) BREF(GC_MALLOC(sizeof(struct app))));
	 {	/* Ast/node.scm 58 */
	    long arg2181_1040;
	    arg2181_1040 =
	       class_num_218___object(app_ast_node);
	    {	/* Ast/node.scm 58 */
	       obj_t obj_2012;
	       obj_2012 =
		  (obj_t) (new1363_1039);
	       (((obj_t) CREF(obj_2012))->header = MAKE_HEADER(arg2181_1040, 0), BUNSPEC);
	    }
	 }
	 {	/* Ast/node.scm 58 */
	    object_bglt aux_4821;
	    aux_4821 =
	       (object_bglt) (new1363_1039);
	    OBJECT_WIDENING_SET(aux_4821, BFALSE);
	 }
	 return new1363_1039;
      }
   }
}



/* _allocate-app */
obj_t 
_allocate_app_162_ast_node(obj_t env_2917)
{
   AN_OBJECT;
   {	/* Ast/node.scm 58 */
      {		/* Ast/node.scm 58 */
	 app_bglt aux_4824;
	 aux_4824 =
	    allocate_app_15_ast_node();
	 return
	    (obj_t) (aux_4824);
      }
   }
}



/* app? */
bool_t 
app__230_ast_node(obj_t obj_332)
{
   AN_OBJECT;
   {	/* Ast/node.scm 58 */
      return
	 is_a__118___object(obj_332, app_ast_node);
   }
}



/* _app? */
obj_t 
_app__141_ast_node(obj_t env_3380, obj_t obj_3381)
{
   AN_OBJECT;
   {	/* Ast/node.scm 58 */
      {		/* Ast/node.scm 58 */
	 bool_t aux_4828;
	 aux_4828 =
	    app__230_ast_node(obj_3381);
	 return
	    BBOOL(aux_4828);
      }
   }
}



/* make-app */
app_bglt 
make_app_213_ast_node(obj_t loc_333, type_bglt type_334, obj_t side_effect__165_335, obj_t key_336, var_bglt fun_337, obj_t args_338, obj_t stack_info_255_339)
{
   AN_OBJECT;
   {	/* Ast/node.scm 58 */
      {		/* Ast/node.scm 58 */
	 app_bglt new1354_2014;
	 new1354_2014 =
	    ((app_bglt) BREF(GC_MALLOC(sizeof(struct app))));
	 {	/* Ast/node.scm 58 */
	    long arg2183_2015;
	    arg2183_2015 =
	       class_num_218___object(app_ast_node);
	    {	/* Ast/node.scm 58 */
	       obj_t obj_2023;
	       obj_2023 =
		  (obj_t) (new1354_2014);
	       (((obj_t) CREF(obj_2023))->header = MAKE_HEADER(arg2183_2015, 0), BUNSPEC);
	    }
	 }
	 {	/* Ast/node.scm 58 */
	    object_bglt aux_4835;
	    aux_4835 =
	       (object_bglt) (new1354_2014);
	    OBJECT_WIDENING_SET(aux_4835, BFALSE);
	 }
	 ((((app_bglt) CREF(new1354_2014))->loc) = ((obj_t) loc_333), BUNSPEC);
	 ((((app_bglt) CREF(new1354_2014))->type) = ((type_bglt) type_334), BUNSPEC);
	 ((((app_bglt) CREF(new1354_2014))->side_effect__165) = ((obj_t) side_effect__165_335), BUNSPEC);
	 ((((app_bglt) CREF(new1354_2014))->key) = ((obj_t) key_336), BUNSPEC);
	 ((((app_bglt) CREF(new1354_2014))->fun) = ((var_bglt) fun_337), BUNSPEC);
	 ((((app_bglt) CREF(new1354_2014))->args) = ((obj_t) args_338), BUNSPEC);
	 ((((app_bglt) CREF(new1354_2014))->stack_info_255) = ((obj_t) stack_info_255_339), BUNSPEC);
	 return new1354_2014;
      }
   }
}



/* _make-app */
obj_t 
_make_app_178_ast_node(obj_t env_3382, obj_t loc_3383, obj_t type_3384, obj_t side_effect__165_3385, obj_t key_3386, obj_t fun_3387, obj_t args_3388, obj_t stack_info_255_3389)
{
   AN_OBJECT;
   {	/* Ast/node.scm 58 */
      {		/* Ast/node.scm 58 */
	 app_bglt aux_4845;
	 aux_4845 =
	    make_app_213_ast_node(loc_3383,
	    (type_bglt) (type_3384), side_effect__165_3385, key_3386,
	    (var_bglt) (fun_3387), args_3388, stack_info_255_3389);
	 return
	    (obj_t) (aux_4845);
      }
   }
}



/* app-loc */
obj_t 
app_loc_208_ast_node(app_bglt obj_340)
{
   AN_OBJECT;
   {	/* Ast/node.scm 21 */
      return
	 (((app_bglt) CREF(obj_340))->loc);
   }
}



/* _app-loc */
obj_t 
_app_loc_227_ast_node(obj_t env_3390, obj_t obj_3391)
{
   AN_OBJECT;
   {	/* Ast/node.scm 21 */
      return
	 app_loc_208_ast_node(
	 (app_bglt) (obj_3391));
   }
}



/* app-type-set! */
obj_t 
app_type_set__90_ast_node(app_bglt obj_341, type_bglt val1348_342)
{
   AN_OBJECT;
   {	/* Ast/node.scm 58 */
      return
	 ((((app_bglt) CREF(obj_341))->type) = ((type_bglt) val1348_342), BUNSPEC);
   }
}



/* _app-type-set! */
obj_t 
_app_type_set__8_ast_node(obj_t env_3392, obj_t obj_3393, obj_t val1348_3394)
{
   AN_OBJECT;
   {	/* Ast/node.scm 58 */
      return
	 app_type_set__90_ast_node(
	 (app_bglt) (obj_3393),
	 (type_bglt) (val1348_3394));
   }
}



/* app-type */
type_bglt 
app_type_114_ast_node(app_bglt obj_343)
{
   AN_OBJECT;
   {	/* Ast/node.scm 58 */
      return
	 (((app_bglt) CREF(obj_343))->type);
   }
}



/* _app-type */
obj_t 
_app_type_59_ast_node(obj_t env_3395, obj_t obj_3396)
{
   AN_OBJECT;
   {	/* Ast/node.scm 58 */
      {		/* Ast/node.scm 58 */
	 type_bglt aux_4858;
	 aux_4858 =
	    app_type_114_ast_node(
	    (app_bglt) (obj_3396));
	 return
	    (obj_t) (aux_4858);
      }
   }
}



/* app-side-effect?-set! */
obj_t 
app_side_effect__set__78_ast_node(app_bglt obj_344, obj_t val1349_345)
{
   AN_OBJECT;
   {	/* Ast/node.scm 29 */
      return
	 ((((app_bglt) CREF(obj_344))->side_effect__165) = ((obj_t) val1349_345), BUNSPEC);
   }
}



/* _app-side-effect?-set! */
obj_t 
_app_side_effect__set__107_ast_node(obj_t env_3397, obj_t obj_3398, obj_t val1349_3399)
{
   AN_OBJECT;
   {	/* Ast/node.scm 29 */
      return
	 app_side_effect__set__78_ast_node(
	 (app_bglt) (obj_3398), val1349_3399);
   }
}



/* app-side-effect? */
obj_t 
app_side_effect__179_ast_node(app_bglt obj_346)
{
   AN_OBJECT;
   {	/* Ast/node.scm 29 */
      return
	 (((app_bglt) CREF(obj_346))->side_effect__165);
   }
}



/* _app-side-effect? */
obj_t 
_app_side_effect__128_ast_node(obj_t env_3400, obj_t obj_3401)
{
   AN_OBJECT;
   {	/* Ast/node.scm 29 */
      return
	 app_side_effect__179_ast_node(
	 (app_bglt) (obj_3401));
   }
}



/* app-key-set! */
obj_t 
app_key_set__45_ast_node(app_bglt obj_347, obj_t val1350_348)
{
   AN_OBJECT;
   {	/* Ast/node.scm 33 */
      return
	 ((((app_bglt) CREF(obj_347))->key) = ((obj_t) val1350_348), BUNSPEC);
   }
}



/* _app-key-set!2528 */
obj_t 
_app_key_set_2528_13_ast_node(obj_t env_3402, obj_t obj_3403, obj_t val1350_3404)
{
   AN_OBJECT;
   {	/* Ast/node.scm 33 */
      return
	 app_key_set__45_ast_node(
	 (app_bglt) (obj_3403), val1350_3404);
   }
}



/* app-key */
obj_t 
app_key_150_ast_node(app_bglt obj_349)
{
   AN_OBJECT;
   {	/* Ast/node.scm 33 */
      return
	 (((app_bglt) CREF(obj_349))->key);
   }
}



/* _app-key2529 */
obj_t 
_app_key2529_134_ast_node(obj_t env_3405, obj_t obj_3406)
{
   AN_OBJECT;
   {	/* Ast/node.scm 33 */
      return
	 app_key_150_ast_node(
	 (app_bglt) (obj_3406));
   }
}



/* app-fun-set! */
obj_t 
app_fun_set__26_ast_node(app_bglt obj_350, var_bglt val1351_351)
{
   AN_OBJECT;
   {	/* Ast/node.scm 58 */
      return
	 ((((app_bglt) CREF(obj_350))->fun) = ((var_bglt) val1351_351), BUNSPEC);
   }
}



/* _app-fun-set! */
obj_t 
_app_fun_set__100_ast_node(obj_t env_3407, obj_t obj_3408, obj_t val1351_3409)
{
   AN_OBJECT;
   {	/* Ast/node.scm 58 */
      return
	 app_fun_set__26_ast_node(
	 (app_bglt) (obj_3408),
	 (var_bglt) (val1351_3409));
   }
}



/* app-fun */
var_bglt 
app_fun_173_ast_node(app_bglt obj_352)
{
   AN_OBJECT;
   {	/* Ast/node.scm 58 */
      return
	 (((app_bglt) CREF(obj_352))->fun);
   }
}



/* _app-fun */
obj_t 
_app_fun_176_ast_node(obj_t env_3410, obj_t obj_3411)
{
   AN_OBJECT;
   {	/* Ast/node.scm 58 */
      {		/* Ast/node.scm 58 */
	 var_bglt aux_4879;
	 aux_4879 =
	    app_fun_173_ast_node(
	    (app_bglt) (obj_3411));
	 return
	    (obj_t) (aux_4879);
      }
   }
}



/* app-args-set! */
obj_t 
app_args_set__223_ast_node(app_bglt obj_353, obj_t val1352_354)
{
   AN_OBJECT;
   {	/* Ast/node.scm 58 */
      return
	 ((((app_bglt) CREF(obj_353))->args) = ((obj_t) val1352_354), BUNSPEC);
   }
}



/* _app-args-set! */
obj_t 
_app_args_set__105_ast_node(obj_t env_3412, obj_t obj_3413, obj_t val1352_3414)
{
   AN_OBJECT;
   {	/* Ast/node.scm 58 */
      return
	 app_args_set__223_ast_node(
	 (app_bglt) (obj_3413), val1352_3414);
   }
}



/* app-args */
obj_t 
app_args_229_ast_node(app_bglt obj_355)
{
   AN_OBJECT;
   {	/* Ast/node.scm 58 */
      return
	 (((app_bglt) CREF(obj_355))->args);
   }
}



/* _app-args */
obj_t 
_app_args_203_ast_node(obj_t env_3415, obj_t obj_3416)
{
   AN_OBJECT;
   {	/* Ast/node.scm 58 */
      return
	 app_args_229_ast_node(
	 (app_bglt) (obj_3416));
   }
}



/* app-stack-info-set! */
obj_t 
app_stack_info_set__168_ast_node(app_bglt obj_356, obj_t val1353_357)
{
   AN_OBJECT;
   {	/* Ast/node.scm 64 */
      return
	 ((((app_bglt) CREF(obj_356))->stack_info_255) = ((obj_t) val1353_357), BUNSPEC);
   }
}



/* _app-stack-info-set! */
obj_t 
_app_stack_info_set__56_ast_node(obj_t env_3417, obj_t obj_3418, obj_t val1353_3419)
{
   AN_OBJECT;
   {	/* Ast/node.scm 64 */
      return
	 app_stack_info_set__168_ast_node(
	 (app_bglt) (obj_3418), val1353_3419);
   }
}



/* app-stack-info */
obj_t 
app_stack_info_87_ast_node(app_bglt obj_358)
{
   AN_OBJECT;
   {	/* Ast/node.scm 64 */
      return
	 (((app_bglt) CREF(obj_358))->stack_info_255);
   }
}



/* _app-stack-info */
obj_t 
_app_stack_info_121_ast_node(obj_t env_3420, obj_t obj_3421)
{
   AN_OBJECT;
   {	/* Ast/node.scm 64 */
      return
	 app_stack_info_87_ast_node(
	 (app_bglt) (obj_3421));
   }
}



/* allocate-sequence */
sequence_bglt 
allocate_sequence_235_ast_node()
{
   AN_OBJECT;
   {	/* Ast/node.scm 54 */
      {		/* Ast/node.scm 54 */
	 sequence_bglt new1325_1050;
	 new1325_1050 =
	    ((sequence_bglt) BREF(GC_MALLOC(sizeof(struct sequence))));
	 {	/* Ast/node.scm 54 */
	    long arg2184_1051;
	    arg2184_1051 =
	       class_num_218___object(sequence_ast_node);
	    {	/* Ast/node.scm 54 */
	       obj_t obj_2025;
	       obj_2025 =
		  (obj_t) (new1325_1050);
	       (((obj_t) CREF(obj_2025))->header = MAKE_HEADER(arg2184_1051, 0), BUNSPEC);
	    }
	 }
	 {	/* Ast/node.scm 54 */
	    object_bglt aux_4899;
	    aux_4899 =
	       (object_bglt) (new1325_1050);
	    OBJECT_WIDENING_SET(aux_4899, BFALSE);
	 }
	 return new1325_1050;
      }
   }
}



/* _allocate-sequence */
obj_t 
_allocate_sequence_156_ast_node(obj_t env_2916)
{
   AN_OBJECT;
   {	/* Ast/node.scm 54 */
      {		/* Ast/node.scm 54 */
	 sequence_bglt aux_4902;
	 aux_4902 =
	    allocate_sequence_235_ast_node();
	 return
	    (obj_t) (aux_4902);
      }
   }
}



/* sequence? */
bool_t 
sequence__190_ast_node(obj_t obj_362)
{
   AN_OBJECT;
   {	/* Ast/node.scm 54 */
      return
	 is_a__118___object(obj_362, sequence_ast_node);
   }
}



/* _sequence? */
obj_t 
_sequence__76_ast_node(obj_t env_3422, obj_t obj_3423)
{
   AN_OBJECT;
   {	/* Ast/node.scm 54 */
      {		/* Ast/node.scm 54 */
	 bool_t aux_4906;
	 aux_4906 =
	    sequence__190_ast_node(obj_3423);
	 return
	    BBOOL(aux_4906);
      }
   }
}



/* make-sequence */
sequence_bglt 
make_sequence_237_ast_node(obj_t loc_363, type_bglt type_364, obj_t side_effect__165_365, obj_t key_366, obj_t nodes_367)
{
   AN_OBJECT;
   {	/* Ast/node.scm 54 */
      {		/* Ast/node.scm 54 */
	 sequence_bglt new1318_2027;
	 new1318_2027 =
	    ((sequence_bglt) BREF(GC_MALLOC(sizeof(struct sequence))));
	 {	/* Ast/node.scm 54 */
	    long arg2185_2028;
	    arg2185_2028 =
	       class_num_218___object(sequence_ast_node);
	    {	/* Ast/node.scm 54 */
	       obj_t obj_2034;
	       obj_2034 =
		  (obj_t) (new1318_2027);
	       (((obj_t) CREF(obj_2034))->header = MAKE_HEADER(arg2185_2028, 0), BUNSPEC);
	    }
	 }
	 {	/* Ast/node.scm 54 */
	    object_bglt aux_4913;
	    aux_4913 =
	       (object_bglt) (new1318_2027);
	    OBJECT_WIDENING_SET(aux_4913, BFALSE);
	 }
	 ((((sequence_bglt) CREF(new1318_2027))->loc) = ((obj_t) loc_363), BUNSPEC);
	 ((((sequence_bglt) CREF(new1318_2027))->type) = ((type_bglt) type_364), BUNSPEC);
	 ((((sequence_bglt) CREF(new1318_2027))->side_effect__165) = ((obj_t) side_effect__165_365), BUNSPEC);
	 ((((sequence_bglt) CREF(new1318_2027))->key) = ((obj_t) key_366), BUNSPEC);
	 ((((sequence_bglt) CREF(new1318_2027))->nodes) = ((obj_t) nodes_367), BUNSPEC);
	 return new1318_2027;
      }
   }
}



/* _make-sequence */
obj_t 
_make_sequence_119_ast_node(obj_t env_3424, obj_t loc_3425, obj_t type_3426, obj_t side_effect__165_3427, obj_t key_3428, obj_t nodes_3429)
{
   AN_OBJECT;
   {	/* Ast/node.scm 54 */
      {		/* Ast/node.scm 54 */
	 sequence_bglt aux_4921;
	 aux_4921 =
	    make_sequence_237_ast_node(loc_3425,
	    (type_bglt) (type_3426), side_effect__165_3427, key_3428, nodes_3429);
	 return
	    (obj_t) (aux_4921);
      }
   }
}



/* sequence-loc */
obj_t 
sequence_loc_124_ast_node(sequence_bglt obj_368)
{
   AN_OBJECT;
   {	/* Ast/node.scm 21 */
      return
	 (((sequence_bglt) CREF(obj_368))->loc);
   }
}



/* _sequence-loc */
obj_t 
_sequence_loc_75_ast_node(obj_t env_3430, obj_t obj_3431)
{
   AN_OBJECT;
   {	/* Ast/node.scm 21 */
      return
	 sequence_loc_124_ast_node(
	 (sequence_bglt) (obj_3431));
   }
}



/* sequence-type-set! */
obj_t 
sequence_type_set__237_ast_node(sequence_bglt obj_369, type_bglt val1315_370)
{
   AN_OBJECT;
   {	/* Ast/node.scm 54 */
      return
	 ((((sequence_bglt) CREF(obj_369))->type) = ((type_bglt) val1315_370), BUNSPEC);
   }
}



/* _sequence-type-set! */
obj_t 
_sequence_type_set__27_ast_node(obj_t env_3432, obj_t obj_3433, obj_t val1315_3434)
{
   AN_OBJECT;
   {	/* Ast/node.scm 54 */
      return
	 sequence_type_set__237_ast_node(
	 (sequence_bglt) (obj_3433),
	 (type_bglt) (val1315_3434));
   }
}



/* sequence-type */
type_bglt 
sequence_type_18_ast_node(sequence_bglt obj_371)
{
   AN_OBJECT;
   {	/* Ast/node.scm 54 */
      return
	 (((sequence_bglt) CREF(obj_371))->type);
   }
}



/* _sequence-type */
obj_t 
_sequence_type_56_ast_node(obj_t env_3435, obj_t obj_3436)
{
   AN_OBJECT;
   {	/* Ast/node.scm 54 */
      {		/* Ast/node.scm 54 */
	 type_bglt aux_4933;
	 aux_4933 =
	    sequence_type_18_ast_node(
	    (sequence_bglt) (obj_3436));
	 return
	    (obj_t) (aux_4933);
      }
   }
}



/* sequence-side-effect?-set! */
obj_t 
sequence_side_effect__set__38_ast_node(sequence_bglt obj_372, obj_t val1316_373)
{
   AN_OBJECT;
   {	/* Ast/node.scm 29 */
      return
	 ((((sequence_bglt) CREF(obj_372))->side_effect__165) = ((obj_t) val1316_373), BUNSPEC);
   }
}



/* _sequence-side-effect?-set! */
obj_t 
_sequence_side_effect__set__178_ast_node(obj_t env_3437, obj_t obj_3438, obj_t val1316_3439)
{
   AN_OBJECT;
   {	/* Ast/node.scm 29 */
      return
	 sequence_side_effect__set__38_ast_node(
	 (sequence_bglt) (obj_3438), val1316_3439);
   }
}



/* sequence-side-effect? */
obj_t 
sequence_side_effect__144_ast_node(sequence_bglt obj_374)
{
   AN_OBJECT;
   {	/* Ast/node.scm 29 */
      return
	 (((sequence_bglt) CREF(obj_374))->side_effect__165);
   }
}



/* _sequence-side-effect? */
obj_t 
_sequence_side_effect__7_ast_node(obj_t env_3440, obj_t obj_3441)
{
   AN_OBJECT;
   {	/* Ast/node.scm 29 */
      return
	 sequence_side_effect__144_ast_node(
	 (sequence_bglt) (obj_3441));
   }
}



/* sequence-key-set! */
obj_t 
sequence_key_set__139_ast_node(sequence_bglt obj_375, obj_t val1317_376)
{
   AN_OBJECT;
   {	/* Ast/node.scm 33 */
      return
	 ((((sequence_bglt) CREF(obj_375))->key) = ((obj_t) val1317_376), BUNSPEC);
   }
}



/* _sequence-key-set!2530 */
obj_t 
_sequence_key_set_2530_26_ast_node(obj_t env_3442, obj_t obj_3443, obj_t val1317_3444)
{
   AN_OBJECT;
   {	/* Ast/node.scm 33 */
      return
	 sequence_key_set__139_ast_node(
	 (sequence_bglt) (obj_3443), val1317_3444);
   }
}



/* sequence-key */
obj_t 
sequence_key_75_ast_node(sequence_bglt obj_377)
{
   AN_OBJECT;
   {	/* Ast/node.scm 33 */
      return
	 (((sequence_bglt) CREF(obj_377))->key);
   }
}



/* _sequence-key2531 */
obj_t 
_sequence_key2531_88_ast_node(obj_t env_3445, obj_t obj_3446)
{
   AN_OBJECT;
   {	/* Ast/node.scm 33 */
      return
	 sequence_key_75_ast_node(
	 (sequence_bglt) (obj_3446));
   }
}



/* sequence-nodes */
obj_t 
sequence_nodes_243_ast_node(sequence_bglt obj_378)
{
   AN_OBJECT;
   {	/* Ast/node.scm 55 */
      return
	 (((sequence_bglt) CREF(obj_378))->nodes);
   }
}



/* _sequence-nodes */
obj_t 
_sequence_nodes_186_ast_node(obj_t env_3447, obj_t obj_3448)
{
   AN_OBJECT;
   {	/* Ast/node.scm 55 */
      return
	 sequence_nodes_243_ast_node(
	 (sequence_bglt) (obj_3448));
   }
}



/* allocate-kwote */
kwote_bglt 
allocate_kwote_110_ast_node()
{
   AN_OBJECT;
   {	/* Ast/node.scm 49 */
      {		/* Ast/node.scm 49 */
	 kwote_bglt new1300_1059;
	 new1300_1059 =
	    ((kwote_bglt) BREF(GC_MALLOC(sizeof(struct kwote))));
	 {	/* Ast/node.scm 49 */
	    long arg2187_1060;
	    arg2187_1060 =
	       class_num_218___object(kwote_ast_node);
	    {	/* Ast/node.scm 49 */
	       obj_t obj_2036;
	       obj_2036 =
		  (obj_t) (new1300_1059);
	       (((obj_t) CREF(obj_2036))->header = MAKE_HEADER(arg2187_1060, 0), BUNSPEC);
	    }
	 }
	 {	/* Ast/node.scm 49 */
	    object_bglt aux_4956;
	    aux_4956 =
	       (object_bglt) (new1300_1059);
	    OBJECT_WIDENING_SET(aux_4956, BFALSE);
	 }
	 return new1300_1059;
      }
   }
}



/* _allocate-kwote */
obj_t 
_allocate_kwote_245_ast_node(obj_t env_2915)
{
   AN_OBJECT;
   {	/* Ast/node.scm 49 */
      {		/* Ast/node.scm 49 */
	 kwote_bglt aux_4959;
	 aux_4959 =
	    allocate_kwote_110_ast_node();
	 return
	    (obj_t) (aux_4959);
      }
   }
}



/* kwote? */
bool_t 
kwote__251_ast_node(obj_t obj_382)
{
   AN_OBJECT;
   {	/* Ast/node.scm 49 */
      return
	 is_a__118___object(obj_382, kwote_ast_node);
   }
}



/* _kwote? */
obj_t 
_kwote__112_ast_node(obj_t env_3449, obj_t obj_3450)
{
   AN_OBJECT;
   {	/* Ast/node.scm 49 */
      {		/* Ast/node.scm 49 */
	 bool_t aux_4963;
	 aux_4963 =
	    kwote__251_ast_node(obj_3450);
	 return
	    BBOOL(aux_4963);
      }
   }
}



/* make-kwote */
kwote_bglt 
make_kwote_191_ast_node(obj_t loc_383, type_bglt type_384, obj_t value_385)
{
   AN_OBJECT;
   {	/* Ast/node.scm 49 */
      {		/* Ast/node.scm 49 */
	 kwote_bglt new1295_2038;
	 new1295_2038 =
	    ((kwote_bglt) BREF(GC_MALLOC(sizeof(struct kwote))));
	 {	/* Ast/node.scm 49 */
	    long arg2188_2039;
	    arg2188_2039 =
	       class_num_218___object(kwote_ast_node);
	    {	/* Ast/node.scm 49 */
	       obj_t obj_2043;
	       obj_2043 =
		  (obj_t) (new1295_2038);
	       (((obj_t) CREF(obj_2043))->header = MAKE_HEADER(arg2188_2039, 0), BUNSPEC);
	    }
	 }
	 {	/* Ast/node.scm 49 */
	    object_bglt aux_4970;
	    aux_4970 =
	       (object_bglt) (new1295_2038);
	    OBJECT_WIDENING_SET(aux_4970, BFALSE);
	 }
	 ((((kwote_bglt) CREF(new1295_2038))->loc) = ((obj_t) loc_383), BUNSPEC);
	 ((((kwote_bglt) CREF(new1295_2038))->type) = ((type_bglt) type_384), BUNSPEC);
	 ((((kwote_bglt) CREF(new1295_2038))->value) = ((obj_t) value_385), BUNSPEC);
	 return new1295_2038;
      }
   }
}



/* _make-kwote */
obj_t 
_make_kwote_232_ast_node(obj_t env_3451, obj_t loc_3452, obj_t type_3453, obj_t value_3454)
{
   AN_OBJECT;
   {	/* Ast/node.scm 49 */
      {		/* Ast/node.scm 49 */
	 kwote_bglt aux_4976;
	 aux_4976 =
	    make_kwote_191_ast_node(loc_3452,
	    (type_bglt) (type_3453), value_3454);
	 return
	    (obj_t) (aux_4976);
      }
   }
}



/* kwote-loc */
obj_t 
kwote_loc_85_ast_node(kwote_bglt obj_386)
{
   AN_OBJECT;
   {	/* Ast/node.scm 21 */
      return
	 (((kwote_bglt) CREF(obj_386))->loc);
   }
}



/* _kwote-loc */
obj_t 
_kwote_loc_102_ast_node(obj_t env_3455, obj_t obj_3456)
{
   AN_OBJECT;
   {	/* Ast/node.scm 21 */
      return
	 kwote_loc_85_ast_node(
	 (kwote_bglt) (obj_3456));
   }
}



/* kwote-type-set! */
obj_t 
kwote_type_set__119_ast_node(kwote_bglt obj_387, type_bglt val1294_388)
{
   AN_OBJECT;
   {	/* Ast/node.scm 49 */
      return
	 ((((kwote_bglt) CREF(obj_387))->type) = ((type_bglt) val1294_388), BUNSPEC);
   }
}



/* _kwote-type-set! */
obj_t 
_kwote_type_set__30_ast_node(obj_t env_3457, obj_t obj_3458, obj_t val1294_3459)
{
   AN_OBJECT;
   {	/* Ast/node.scm 49 */
      return
	 kwote_type_set__119_ast_node(
	 (kwote_bglt) (obj_3458),
	 (type_bglt) (val1294_3459));
   }
}



/* kwote-type */
type_bglt 
kwote_type_217_ast_node(kwote_bglt obj_389)
{
   AN_OBJECT;
   {	/* Ast/node.scm 49 */
      return
	 (((kwote_bglt) CREF(obj_389))->type);
   }
}



/* _kwote-type */
obj_t 
_kwote_type_169_ast_node(obj_t env_3460, obj_t obj_3461)
{
   AN_OBJECT;
   {	/* Ast/node.scm 49 */
      {		/* Ast/node.scm 49 */
	 type_bglt aux_4988;
	 aux_4988 =
	    kwote_type_217_ast_node(
	    (kwote_bglt) (obj_3461));
	 return
	    (obj_t) (aux_4988);
      }
   }
}



/* kwote-value */
obj_t 
kwote_value_104_ast_node(kwote_bglt obj_390)
{
   AN_OBJECT;
   {	/* Ast/node.scm 51 */
      return
	 (((kwote_bglt) CREF(obj_390))->value);
   }
}



/* _kwote-value */
obj_t 
_kwote_value_210_ast_node(obj_t env_3462, obj_t obj_3463)
{
   AN_OBJECT;
   {	/* Ast/node.scm 51 */
      return
	 kwote_value_104_ast_node(
	 (kwote_bglt) (obj_3463));
   }
}



/* allocate-closure */
closure_bglt 
allocate_closure_237_ast_node()
{
   AN_OBJECT;
   {	/* Ast/node.scm 46 */
      {		/* Ast/node.scm 46 */
	 closure_bglt new1279_1066;
	 new1279_1066 =
	    ((closure_bglt) BREF(GC_MALLOC(sizeof(struct closure))));
	 {	/* Ast/node.scm 46 */
	    long arg2189_1067;
	    arg2189_1067 =
	       class_num_218___object(closure_ast_node);
	    {	/* Ast/node.scm 46 */
	       obj_t obj_2045;
	       obj_2045 =
		  (obj_t) (new1279_1066);
	       (((obj_t) CREF(obj_2045))->header = MAKE_HEADER(arg2189_1067, 0), BUNSPEC);
	    }
	 }
	 {	/* Ast/node.scm 46 */
	    object_bglt aux_4999;
	    aux_4999 =
	       (object_bglt) (new1279_1066);
	    OBJECT_WIDENING_SET(aux_4999, BFALSE);
	 }
	 return new1279_1066;
      }
   }
}



/* _allocate-closure */
obj_t 
_allocate_closure_68_ast_node(obj_t env_2914)
{
   AN_OBJECT;
   {	/* Ast/node.scm 46 */
      {		/* Ast/node.scm 46 */
	 closure_bglt aux_5002;
	 aux_5002 =
	    allocate_closure_237_ast_node();
	 return
	    (obj_t) (aux_5002);
      }
   }
}



/* closure? */
bool_t 
closure__53_ast_node(obj_t obj_394)
{
   AN_OBJECT;
   {	/* Ast/node.scm 46 */
      return
	 is_a__118___object(obj_394, closure_ast_node);
   }
}



/* _closure? */
obj_t 
_closure__33_ast_node(obj_t env_3464, obj_t obj_3465)
{
   AN_OBJECT;
   {	/* Ast/node.scm 46 */
      {		/* Ast/node.scm 46 */
	 bool_t aux_5006;
	 aux_5006 =
	    closure__53_ast_node(obj_3465);
	 return
	    BBOOL(aux_5006);
      }
   }
}



/* make-closure */
closure_bglt 
make_closure_70_ast_node(obj_t loc_395, type_bglt type_396, variable_bglt variable_397)
{
   AN_OBJECT;
   {	/* Ast/node.scm 46 */
      {		/* Ast/node.scm 46 */
	 closure_bglt new1274_2047;
	 new1274_2047 =
	    ((closure_bglt) BREF(GC_MALLOC(sizeof(struct closure))));
	 {	/* Ast/node.scm 46 */
	    long arg2190_2048;
	    arg2190_2048 =
	       class_num_218___object(closure_ast_node);
	    {	/* Ast/node.scm 46 */
	       obj_t obj_2052;
	       obj_2052 =
		  (obj_t) (new1274_2047);
	       (((obj_t) CREF(obj_2052))->header = MAKE_HEADER(arg2190_2048, 0), BUNSPEC);
	    }
	 }
	 {	/* Ast/node.scm 46 */
	    object_bglt aux_5013;
	    aux_5013 =
	       (object_bglt) (new1274_2047);
	    OBJECT_WIDENING_SET(aux_5013, BFALSE);
	 }
	 ((((closure_bglt) CREF(new1274_2047))->loc) = ((obj_t) loc_395), BUNSPEC);
	 ((((closure_bglt) CREF(new1274_2047))->type) = ((type_bglt) type_396), BUNSPEC);
	 ((((closure_bglt) CREF(new1274_2047))->variable) = ((variable_bglt) variable_397), BUNSPEC);
	 return new1274_2047;
      }
   }
}



/* _make-closure */
obj_t 
_make_closure_27_ast_node(obj_t env_3466, obj_t loc_3467, obj_t type_3468, obj_t variable_3469)
{
   AN_OBJECT;
   {	/* Ast/node.scm 46 */
      {		/* Ast/node.scm 46 */
	 closure_bglt aux_5019;
	 aux_5019 =
	    make_closure_70_ast_node(loc_3467,
	    (type_bglt) (type_3468),
	    (variable_bglt) (variable_3469));
	 return
	    (obj_t) (aux_5019);
      }
   }
}



/* closure-loc */
obj_t 
closure_loc_195_ast_node(closure_bglt obj_398)
{
   AN_OBJECT;
   {	/* Ast/node.scm 21 */
      return
	 (((closure_bglt) CREF(obj_398))->loc);
   }
}



/* _closure-loc */
obj_t 
_closure_loc_244_ast_node(obj_t env_3470, obj_t obj_3471)
{
   AN_OBJECT;
   {	/* Ast/node.scm 21 */
      return
	 closure_loc_195_ast_node(
	 (closure_bglt) (obj_3471));
   }
}



/* closure-type-set! */
obj_t 
closure_type_set__162_ast_node(closure_bglt obj_399, type_bglt val1272_400)
{
   AN_OBJECT;
   {	/* Ast/node.scm 46 */
      return
	 ((((closure_bglt) CREF(obj_399))->type) = ((type_bglt) val1272_400), BUNSPEC);
   }
}



/* _closure-type-set! */
obj_t 
_closure_type_set__114_ast_node(obj_t env_3472, obj_t obj_3473, obj_t val1272_3474)
{
   AN_OBJECT;
   {	/* Ast/node.scm 46 */
      return
	 closure_type_set__162_ast_node(
	 (closure_bglt) (obj_3473),
	 (type_bglt) (val1272_3474));
   }
}



/* closure-type */
type_bglt 
closure_type_101_ast_node(closure_bglt obj_401)
{
   AN_OBJECT;
   {	/* Ast/node.scm 46 */
      return
	 (((closure_bglt) CREF(obj_401))->type);
   }
}



/* _closure-type */
obj_t 
_closure_type_29_ast_node(obj_t env_3475, obj_t obj_3476)
{
   AN_OBJECT;
   {	/* Ast/node.scm 46 */
      {		/* Ast/node.scm 46 */
	 type_bglt aux_5032;
	 aux_5032 =
	    closure_type_101_ast_node(
	    (closure_bglt) (obj_3476));
	 return
	    (obj_t) (aux_5032);
      }
   }
}



/* closure-variable-set! */
obj_t 
closure_variable_set__129_ast_node(closure_bglt obj_402, variable_bglt val1273_403)
{
   AN_OBJECT;
   {	/* Ast/node.scm 46 */
      return
	 ((((closure_bglt) CREF(obj_402))->variable) = ((variable_bglt) val1273_403), BUNSPEC);
   }
}



/* _closure-variable-set! */
obj_t 
_closure_variable_set__83_ast_node(obj_t env_3477, obj_t obj_3478, obj_t val1273_3479)
{
   AN_OBJECT;
   {	/* Ast/node.scm 46 */
      return
	 closure_variable_set__129_ast_node(
	 (closure_bglt) (obj_3478),
	 (variable_bglt) (val1273_3479));
   }
}



/* closure-variable */
variable_bglt 
closure_variable_234_ast_node(closure_bglt obj_404)
{
   AN_OBJECT;
   {	/* Ast/node.scm 46 */
      return
	 (((closure_bglt) CREF(obj_404))->variable);
   }
}



/* _closure-variable */
obj_t 
_closure_variable_249_ast_node(obj_t env_3480, obj_t obj_3481)
{
   AN_OBJECT;
   {	/* Ast/node.scm 46 */
      {		/* Ast/node.scm 46 */
	 variable_bglt aux_5041;
	 aux_5041 =
	    closure_variable_234_ast_node(
	    (closure_bglt) (obj_3481));
	 return
	    (obj_t) (aux_5041);
      }
   }
}



/* allocate-var */
var_bglt 
allocate_var_186_ast_node()
{
   AN_OBJECT;
   {	/* Ast/node.scm 41 */
      {		/* Ast/node.scm 41 */
	 var_bglt new1257_1073;
	 new1257_1073 =
	    ((var_bglt) BREF(GC_MALLOC(sizeof(struct var))));
	 {	/* Ast/node.scm 41 */
	    long arg2191_1074;
	    arg2191_1074 =
	       class_num_218___object(var_ast_node);
	    {	/* Ast/node.scm 41 */
	       obj_t obj_2054;
	       obj_2054 =
		  (obj_t) (new1257_1073);
	       (((obj_t) CREF(obj_2054))->header = MAKE_HEADER(arg2191_1074, 0), BUNSPEC);
	    }
	 }
	 {	/* Ast/node.scm 41 */
	    object_bglt aux_5049;
	    aux_5049 =
	       (object_bglt) (new1257_1073);
	    OBJECT_WIDENING_SET(aux_5049, BFALSE);
	 }
	 return new1257_1073;
      }
   }
}



/* _allocate-var */
obj_t 
_allocate_var_93_ast_node(obj_t env_2913)
{
   AN_OBJECT;
   {	/* Ast/node.scm 41 */
      {		/* Ast/node.scm 41 */
	 var_bglt aux_5052;
	 aux_5052 =
	    allocate_var_186_ast_node();
	 return
	    (obj_t) (aux_5052);
      }
   }
}



/* var? */
bool_t 
var__222_ast_node(obj_t obj_408)
{
   AN_OBJECT;
   {	/* Ast/node.scm 41 */
      return
	 is_a__118___object(obj_408, var_ast_node);
   }
}



/* _var? */
obj_t 
_var__148_ast_node(obj_t env_3482, obj_t obj_3483)
{
   AN_OBJECT;
   {	/* Ast/node.scm 41 */
      {		/* Ast/node.scm 41 */
	 bool_t aux_5056;
	 aux_5056 =
	    var__222_ast_node(obj_3483);
	 return
	    BBOOL(aux_5056);
      }
   }
}



/* make-var */
var_bglt 
make_var_69_ast_node(obj_t loc_409, type_bglt type_410, variable_bglt variable_411)
{
   AN_OBJECT;
   {	/* Ast/node.scm 41 */
      {		/* Ast/node.scm 41 */
	 var_bglt new1252_2056;
	 new1252_2056 =
	    ((var_bglt) BREF(GC_MALLOC(sizeof(struct var))));
	 {	/* Ast/node.scm 41 */
	    long arg2192_2057;
	    arg2192_2057 =
	       class_num_218___object(var_ast_node);
	    {	/* Ast/node.scm 41 */
	       obj_t obj_2061;
	       obj_2061 =
		  (obj_t) (new1252_2056);
	       (((obj_t) CREF(obj_2061))->header = MAKE_HEADER(arg2192_2057, 0), BUNSPEC);
	    }
	 }
	 {	/* Ast/node.scm 41 */
	    object_bglt aux_5063;
	    aux_5063 =
	       (object_bglt) (new1252_2056);
	    OBJECT_WIDENING_SET(aux_5063, BFALSE);
	 }
	 ((((var_bglt) CREF(new1252_2056))->loc) = ((obj_t) loc_409), BUNSPEC);
	 ((((var_bglt) CREF(new1252_2056))->type) = ((type_bglt) type_410), BUNSPEC);
	 ((((var_bglt) CREF(new1252_2056))->variable) = ((variable_bglt) variable_411), BUNSPEC);
	 return new1252_2056;
      }
   }
}



/* _make-var */
obj_t 
_make_var_226_ast_node(obj_t env_3484, obj_t loc_3485, obj_t type_3486, obj_t variable_3487)
{
   AN_OBJECT;
   {	/* Ast/node.scm 41 */
      {		/* Ast/node.scm 41 */
	 var_bglt aux_5069;
	 aux_5069 =
	    make_var_69_ast_node(loc_3485,
	    (type_bglt) (type_3486),
	    (variable_bglt) (variable_3487));
	 return
	    (obj_t) (aux_5069);
      }
   }
}



/* var-loc */
obj_t 
var_loc_140_ast_node(var_bglt obj_412)
{
   AN_OBJECT;
   {	/* Ast/node.scm 21 */
      return
	 (((var_bglt) CREF(obj_412))->loc);
   }
}



/* _var-loc */
obj_t 
_var_loc_47_ast_node(obj_t env_3488, obj_t obj_3489)
{
   AN_OBJECT;
   {	/* Ast/node.scm 21 */
      return
	 var_loc_140_ast_node(
	 (var_bglt) (obj_3489));
   }
}



/* var-type-set! */
obj_t 
var_type_set__45_ast_node(var_bglt obj_413, type_bglt val1250_414)
{
   AN_OBJECT;
   {	/* Ast/node.scm 41 */
      return
	 ((((var_bglt) CREF(obj_413))->type) = ((type_bglt) val1250_414), BUNSPEC);
   }
}



/* _var-type-set! */
obj_t 
_var_type_set__250_ast_node(obj_t env_3490, obj_t obj_3491, obj_t val1250_3492)
{
   AN_OBJECT;
   {	/* Ast/node.scm 41 */
      return
	 var_type_set__45_ast_node(
	 (var_bglt) (obj_3491),
	 (type_bglt) (val1250_3492));
   }
}



/* var-type */
type_bglt 
var_type_150_ast_node(var_bglt obj_415)
{
   AN_OBJECT;
   {	/* Ast/node.scm 41 */
      return
	 (((var_bglt) CREF(obj_415))->type);
   }
}



/* _var-type */
obj_t 
_var_type_212_ast_node(obj_t env_3493, obj_t obj_3494)
{
   AN_OBJECT;
   {	/* Ast/node.scm 41 */
      {		/* Ast/node.scm 41 */
	 type_bglt aux_5082;
	 aux_5082 =
	    var_type_150_ast_node(
	    (var_bglt) (obj_3494));
	 return
	    (obj_t) (aux_5082);
      }
   }
}



/* var-variable-set! */
obj_t 
var_variable_set__90_ast_node(var_bglt obj_416, variable_bglt val1251_417)
{
   AN_OBJECT;
   {	/* Ast/node.scm 41 */
      return
	 ((((var_bglt) CREF(obj_416))->variable) = ((variable_bglt) val1251_417), BUNSPEC);
   }
}



/* _var-variable-set! */
obj_t 
_var_variable_set__30_ast_node(obj_t env_3495, obj_t obj_3496, obj_t val1251_3497)
{
   AN_OBJECT;
   {	/* Ast/node.scm 41 */
      return
	 var_variable_set__90_ast_node(
	 (var_bglt) (obj_3496),
	 (variable_bglt) (val1251_3497));
   }
}



/* var-variable */
variable_bglt 
var_variable_114_ast_node(var_bglt obj_418)
{
   AN_OBJECT;
   {	/* Ast/node.scm 41 */
      return
	 (((var_bglt) CREF(obj_418))->variable);
   }
}



/* _var-variable */
obj_t 
_var_variable_169_ast_node(obj_t env_3498, obj_t obj_3499)
{
   AN_OBJECT;
   {	/* Ast/node.scm 41 */
      {		/* Ast/node.scm 41 */
	 variable_bglt aux_5091;
	 aux_5091 =
	    var_variable_114_ast_node(
	    (var_bglt) (obj_3499));
	 return
	    (obj_t) (aux_5091);
      }
   }
}



/* allocate-atom */
atom_bglt 
allocate_atom_199_ast_node()
{
   AN_OBJECT;
   {	/* Ast/node.scm 36 */
      {		/* Ast/node.scm 36 */
	 atom_bglt new1235_1080;
	 new1235_1080 =
	    ((atom_bglt) BREF(GC_MALLOC(sizeof(struct atom))));
	 {	/* Ast/node.scm 36 */
	    long arg2193_1081;
	    arg2193_1081 =
	       class_num_218___object(atom_ast_node);
	    {	/* Ast/node.scm 36 */
	       obj_t obj_2063;
	       obj_2063 =
		  (obj_t) (new1235_1080);
	       (((obj_t) CREF(obj_2063))->header = MAKE_HEADER(arg2193_1081, 0), BUNSPEC);
	    }
	 }
	 {	/* Ast/node.scm 36 */
	    object_bglt aux_5099;
	    aux_5099 =
	       (object_bglt) (new1235_1080);
	    OBJECT_WIDENING_SET(aux_5099, BFALSE);
	 }
	 return new1235_1080;
      }
   }
}



/* _allocate-atom */
obj_t 
_allocate_atom_130_ast_node(obj_t env_2912)
{
   AN_OBJECT;
   {	/* Ast/node.scm 36 */
      {		/* Ast/node.scm 36 */
	 atom_bglt aux_5102;
	 aux_5102 =
	    allocate_atom_199_ast_node();
	 return
	    (obj_t) (aux_5102);
      }
   }
}



/* atom? */
bool_t 
atom__231_ast_node(obj_t obj_422)
{
   AN_OBJECT;
   {	/* Ast/node.scm 36 */
      return
	 is_a__118___object(obj_422, atom_ast_node);
   }
}



/* _atom? */
obj_t 
_atom__186_ast_node(obj_t env_3500, obj_t obj_3501)
{
   AN_OBJECT;
   {	/* Ast/node.scm 36 */
      {		/* Ast/node.scm 36 */
	 bool_t aux_5106;
	 aux_5106 =
	    atom__231_ast_node(obj_3501);
	 return
	    BBOOL(aux_5106);
      }
   }
}



/* make-atom */
atom_bglt 
make_atom_145_ast_node(obj_t loc_423, type_bglt type_424, obj_t value_425)
{
   AN_OBJECT;
   {	/* Ast/node.scm 36 */
      {		/* Ast/node.scm 36 */
	 atom_bglt new1230_2065;
	 new1230_2065 =
	    ((atom_bglt) BREF(GC_MALLOC(sizeof(struct atom))));
	 {	/* Ast/node.scm 36 */
	    long arg2195_2066;
	    arg2195_2066 =
	       class_num_218___object(atom_ast_node);
	    {	/* Ast/node.scm 36 */
	       obj_t obj_2070;
	       obj_2070 =
		  (obj_t) (new1230_2065);
	       (((obj_t) CREF(obj_2070))->header = MAKE_HEADER(arg2195_2066, 0), BUNSPEC);
	    }
	 }
	 {	/* Ast/node.scm 36 */
	    object_bglt aux_5113;
	    aux_5113 =
	       (object_bglt) (new1230_2065);
	    OBJECT_WIDENING_SET(aux_5113, BFALSE);
	 }
	 ((((atom_bglt) CREF(new1230_2065))->loc) = ((obj_t) loc_423), BUNSPEC);
	 ((((atom_bglt) CREF(new1230_2065))->type) = ((type_bglt) type_424), BUNSPEC);
	 ((((atom_bglt) CREF(new1230_2065))->value) = ((obj_t) value_425), BUNSPEC);
	 return new1230_2065;
      }
   }
}



/* _make-atom */
obj_t 
_make_atom_226_ast_node(obj_t env_3502, obj_t loc_3503, obj_t type_3504, obj_t value_3505)
{
   AN_OBJECT;
   {	/* Ast/node.scm 36 */
      {		/* Ast/node.scm 36 */
	 atom_bglt aux_5119;
	 aux_5119 =
	    make_atom_145_ast_node(loc_3503,
	    (type_bglt) (type_3504), value_3505);
	 return
	    (obj_t) (aux_5119);
      }
   }
}



/* atom-loc */
obj_t 
atom_loc_1_ast_node(atom_bglt obj_426)
{
   AN_OBJECT;
   {	/* Ast/node.scm 21 */
      return
	 (((atom_bglt) CREF(obj_426))->loc);
   }
}



/* _atom-loc */
obj_t 
_atom_loc_188_ast_node(obj_t env_3506, obj_t obj_3507)
{
   AN_OBJECT;
   {	/* Ast/node.scm 21 */
      return
	 atom_loc_1_ast_node(
	 (atom_bglt) (obj_3507));
   }
}



/* atom-type-set! */
obj_t 
atom_type_set__253_ast_node(atom_bglt obj_427, type_bglt val1228_428)
{
   AN_OBJECT;
   {	/* Ast/node.scm 36 */
      return
	 ((((atom_bglt) CREF(obj_427))->type) = ((type_bglt) val1228_428), BUNSPEC);
   }
}



/* _atom-type-set! */
obj_t 
_atom_type_set__37_ast_node(obj_t env_3508, obj_t obj_3509, obj_t val1228_3510)
{
   AN_OBJECT;
   {	/* Ast/node.scm 36 */
      return
	 atom_type_set__253_ast_node(
	 (atom_bglt) (obj_3509),
	 (type_bglt) (val1228_3510));
   }
}



/* atom-type */
type_bglt 
atom_type_43_ast_node(atom_bglt obj_429)
{
   AN_OBJECT;
   {	/* Ast/node.scm 36 */
      return
	 (((atom_bglt) CREF(obj_429))->type);
   }
}



/* _atom-type */
obj_t 
_atom_type_184_ast_node(obj_t env_3511, obj_t obj_3512)
{
   AN_OBJECT;
   {	/* Ast/node.scm 36 */
      {		/* Ast/node.scm 36 */
	 type_bglt aux_5131;
	 aux_5131 =
	    atom_type_43_ast_node(
	    (atom_bglt) (obj_3512));
	 return
	    (obj_t) (aux_5131);
      }
   }
}



/* atom-value-set! */
obj_t 
atom_value_set__52_ast_node(atom_bglt obj_430, obj_t val1229_431)
{
   AN_OBJECT;
   {	/* Ast/node.scm 36 */
      return
	 ((((atom_bglt) CREF(obj_430))->value) = ((obj_t) val1229_431), BUNSPEC);
   }
}



/* _atom-value-set! */
obj_t 
_atom_value_set__174_ast_node(obj_t env_3513, obj_t obj_3514, obj_t val1229_3515)
{
   AN_OBJECT;
   {	/* Ast/node.scm 36 */
      return
	 atom_value_set__52_ast_node(
	 (atom_bglt) (obj_3514), val1229_3515);
   }
}



/* atom-value */
obj_t 
atom_value_177_ast_node(atom_bglt obj_432)
{
   AN_OBJECT;
   {	/* Ast/node.scm 36 */
      return
	 (((atom_bglt) CREF(obj_432))->value);
   }
}



/* _atom-value */
obj_t 
_atom_value_84_ast_node(obj_t env_3516, obj_t obj_3517)
{
   AN_OBJECT;
   {	/* Ast/node.scm 36 */
      return
	 atom_value_177_ast_node(
	 (atom_bglt) (obj_3517));
   }
}



/* allocate-node/effect */
node_effect_213_bglt 
allocate_node_effect_98_ast_node()
{
   AN_OBJECT;
   {	/* Ast/node.scm 27 */
      {		/* Ast/node.scm 27 */
	 node_effect_213_bglt new1209_1087;
	 new1209_1087 =
	    ((node_effect_213_bglt) BREF(GC_MALLOC(sizeof(struct node_effect_213))));
	 {	/* Ast/node.scm 27 */
	    long arg2197_1088;
	    arg2197_1088 =
	       class_num_218___object(node_effect_213_ast_node);
	    {	/* Ast/node.scm 27 */
	       obj_t obj_2072;
	       obj_2072 =
		  (obj_t) (new1209_1087);
	       (((obj_t) CREF(obj_2072))->header = MAKE_HEADER(arg2197_1088, 0), BUNSPEC);
	    }
	 }
	 {	/* Ast/node.scm 27 */
	    object_bglt aux_5145;
	    aux_5145 =
	       (object_bglt) (new1209_1087);
	    OBJECT_WIDENING_SET(aux_5145, BFALSE);
	 }
	 return new1209_1087;
      }
   }
}



/* _allocate-node/effect */
obj_t 
_allocate_node_effect_20_ast_node(obj_t env_2911)
{
   AN_OBJECT;
   {	/* Ast/node.scm 27 */
      {		/* Ast/node.scm 27 */
	 node_effect_213_bglt aux_5148;
	 aux_5148 =
	    allocate_node_effect_98_ast_node();
	 return
	    (obj_t) (aux_5148);
      }
   }
}



/* node/effect? */
bool_t 
node_effect__37_ast_node(obj_t obj_436)
{
   AN_OBJECT;
   {	/* Ast/node.scm 27 */
      return
	 is_a__118___object(obj_436, node_effect_213_ast_node);
   }
}



/* _node/effect? */
obj_t 
_node_effect__62_ast_node(obj_t env_3518, obj_t obj_3519)
{
   AN_OBJECT;
   {	/* Ast/node.scm 27 */
      {		/* Ast/node.scm 27 */
	 bool_t aux_5152;
	 aux_5152 =
	    node_effect__37_ast_node(obj_3519);
	 return
	    BBOOL(aux_5152);
      }
   }
}



/* make-node/effect */
node_effect_213_bglt 
make_node_effect_87_ast_node(obj_t loc_437, type_bglt type_438, obj_t side_effect__165_439, obj_t key_440)
{
   AN_OBJECT;
   {	/* Ast/node.scm 27 */
      {		/* Ast/node.scm 27 */
	 node_effect_213_bglt new1203_2074;
	 new1203_2074 =
	    ((node_effect_213_bglt) BREF(GC_MALLOC(sizeof(struct node_effect_213))));
	 {	/* Ast/node.scm 27 */
	    long arg2198_2075;
	    arg2198_2075 =
	       class_num_218___object(node_effect_213_ast_node);
	    {	/* Ast/node.scm 27 */
	       obj_t obj_2080;
	       obj_2080 =
		  (obj_t) (new1203_2074);
	       (((obj_t) CREF(obj_2080))->header = MAKE_HEADER(arg2198_2075, 0), BUNSPEC);
	    }
	 }
	 {	/* Ast/node.scm 27 */
	    object_bglt aux_5159;
	    aux_5159 =
	       (object_bglt) (new1203_2074);
	    OBJECT_WIDENING_SET(aux_5159, BFALSE);
	 }
	 ((((node_effect_213_bglt) CREF(new1203_2074))->loc) = ((obj_t) loc_437), BUNSPEC);
	 ((((node_effect_213_bglt) CREF(new1203_2074))->type) = ((type_bglt) type_438), BUNSPEC);
	 ((((node_effect_213_bglt) CREF(new1203_2074))->side_effect__165) = ((obj_t) side_effect__165_439), BUNSPEC);
	 ((((node_effect_213_bglt) CREF(new1203_2074))->key) = ((obj_t) key_440), BUNSPEC);
	 return new1203_2074;
      }
   }
}



/* _make-node/effect */
obj_t 
_make_node_effect_168_ast_node(obj_t env_3520, obj_t loc_3521, obj_t type_3522, obj_t side_effect__165_3523, obj_t key_3524)
{
   AN_OBJECT;
   {	/* Ast/node.scm 27 */
      {		/* Ast/node.scm 27 */
	 node_effect_213_bglt aux_5166;
	 aux_5166 =
	    make_node_effect_87_ast_node(loc_3521,
	    (type_bglt) (type_3522), side_effect__165_3523, key_3524);
	 return
	    (obj_t) (aux_5166);
      }
   }
}



/* node/effect-loc */
obj_t 
node_effect_loc_61_ast_node(node_effect_213_bglt obj_441)
{
   AN_OBJECT;
   {	/* Ast/node.scm 21 */
      return
	 (((node_effect_213_bglt) CREF(obj_441))->loc);
   }
}



/* _node/effect-loc */
obj_t 
_node_effect_loc_51_ast_node(obj_t env_3525, obj_t obj_3526)
{
   AN_OBJECT;
   {	/* Ast/node.scm 21 */
      return
	 node_effect_loc_61_ast_node(
	 (node_effect_213_bglt) (obj_3526));
   }
}



/* node/effect-type-set! */
obj_t 
node_effect_type_set__91_ast_node(node_effect_213_bglt obj_442, type_bglt val1200_443)
{
   AN_OBJECT;
   {	/* Ast/node.scm 27 */
      return
	 ((((node_effect_213_bglt) CREF(obj_442))->type) = ((type_bglt) val1200_443), BUNSPEC);
   }
}



/* _node/effect-type-set! */
obj_t 
_node_effect_type_set__143_ast_node(obj_t env_3527, obj_t obj_3528, obj_t val1200_3529)
{
   AN_OBJECT;
   {	/* Ast/node.scm 27 */
      return
	 node_effect_type_set__91_ast_node(
	 (node_effect_213_bglt) (obj_3528),
	 (type_bglt) (val1200_3529));
   }
}



/* node/effect-type */
type_bglt 
node_effect_type_0_ast_node(node_effect_213_bglt obj_444)
{
   AN_OBJECT;
   {	/* Ast/node.scm 27 */
      return
	 (((node_effect_213_bglt) CREF(obj_444))->type);
   }
}



/* _node/effect-type */
obj_t 
_node_effect_type_42_ast_node(obj_t env_3530, obj_t obj_3531)
{
   AN_OBJECT;
   {	/* Ast/node.scm 27 */
      {		/* Ast/node.scm 27 */
	 type_bglt aux_5178;
	 aux_5178 =
	    node_effect_type_0_ast_node(
	    (node_effect_213_bglt) (obj_3531));
	 return
	    (obj_t) (aux_5178);
      }
   }
}



/* node/effect-side-effect?-set! */
obj_t 
node_effect_side_effect__set__83_ast_node(node_effect_213_bglt obj_445, obj_t val1201_446)
{
   AN_OBJECT;
   {	/* Ast/node.scm 29 */
      return
	 ((((node_effect_213_bglt) CREF(obj_445))->side_effect__165) = ((obj_t) val1201_446), BUNSPEC);
   }
}



/* _node/effect-side-effect?-set! */
obj_t 
_node_effect_side_effect__set__197_ast_node(obj_t env_3532, obj_t obj_3533, obj_t val1201_3534)
{
   AN_OBJECT;
   {	/* Ast/node.scm 29 */
      return
	 node_effect_side_effect__set__83_ast_node(
	 (node_effect_213_bglt) (obj_3533), val1201_3534);
   }
}



/* node/effect-side-effect? */
obj_t 
node_effect_side_effect__249_ast_node(node_effect_213_bglt obj_447)
{
   AN_OBJECT;
   {	/* Ast/node.scm 29 */
      return
	 (((node_effect_213_bglt) CREF(obj_447))->side_effect__165);
   }
}



/* _node/effect-side-effect? */
obj_t 
_node_effect_side_effect__113_ast_node(obj_t env_3535, obj_t obj_3536)
{
   AN_OBJECT;
   {	/* Ast/node.scm 29 */
      return
	 node_effect_side_effect__249_ast_node(
	 (node_effect_213_bglt) (obj_3536));
   }
}



/* node/effect-key-set! */
obj_t 
node_effect_key_set__83_ast_node(node_effect_213_bglt obj_448, obj_t val1202_449)
{
   AN_OBJECT;
   {	/* Ast/node.scm 33 */
      return
	 ((((node_effect_213_bglt) CREF(obj_448))->key) = ((obj_t) val1202_449), BUNSPEC);
   }
}



/* _node/effect-key-set!2532 */
obj_t 
_node_effect_key_set_2532_214_ast_node(obj_t env_3537, obj_t obj_3538, obj_t val1202_3539)
{
   AN_OBJECT;
   {	/* Ast/node.scm 33 */
      return
	 node_effect_key_set__83_ast_node(
	 (node_effect_213_bglt) (obj_3538), val1202_3539);
   }
}



/* node/effect-key */
obj_t 
node_effect_key_249_ast_node(node_effect_213_bglt obj_450)
{
   AN_OBJECT;
   {	/* Ast/node.scm 33 */
      return
	 (((node_effect_213_bglt) CREF(obj_450))->key);
   }
}



/* _node/effect-key2533 */
obj_t 
_node_effect_key2533_45_ast_node(obj_t env_3540, obj_t obj_3541)
{
   AN_OBJECT;
   {	/* Ast/node.scm 33 */
      return
	 node_effect_key_249_ast_node(
	 (node_effect_213_bglt) (obj_3541));
   }
}



/* allocate-node */
node_bglt 
allocate_node_189_ast_node()
{
   AN_OBJECT;
   {	/* Ast/node.scm 19 */
      {		/* Ast/node.scm 19 */
	 node_bglt new1189_1095;
	 new1189_1095 =
	    ((node_bglt) BREF(GC_MALLOC(sizeof(struct node))));
	 {	/* Ast/node.scm 19 */
	    long arg2199_1096;
	    arg2199_1096 =
	       class_num_218___object(node_ast_node);
	    {	/* Ast/node.scm 19 */
	       obj_t obj_2082;
	       obj_2082 =
		  (obj_t) (new1189_1095);
	       (((obj_t) CREF(obj_2082))->header = MAKE_HEADER(arg2199_1096, 0), BUNSPEC);
	    }
	 }
	 {	/* Ast/node.scm 19 */
	    object_bglt aux_5198;
	    aux_5198 =
	       (object_bglt) (new1189_1095);
	    OBJECT_WIDENING_SET(aux_5198, BFALSE);
	 }
	 return new1189_1095;
      }
   }
}



/* _allocate-node */
obj_t 
_allocate_node_227_ast_node(obj_t env_2910)
{
   AN_OBJECT;
   {	/* Ast/node.scm 19 */
      {		/* Ast/node.scm 19 */
	 node_bglt aux_5201;
	 aux_5201 =
	    allocate_node_189_ast_node();
	 return
	    (obj_t) (aux_5201);
      }
   }
}



/* node? */
bool_t 
node__79_ast_node(obj_t obj_454)
{
   AN_OBJECT;
   {	/* Ast/node.scm 19 */
      return
	 is_a__118___object(obj_454, node_ast_node);
   }
}



/* _node? */
obj_t 
_node__81_ast_node(obj_t env_3542, obj_t obj_3543)
{
   AN_OBJECT;
   {	/* Ast/node.scm 19 */
      {		/* Ast/node.scm 19 */
	 bool_t aux_5205;
	 aux_5205 =
	    node__79_ast_node(obj_3543);
	 return
	    BBOOL(aux_5205);
      }
   }
}



/* make-node */
node_bglt 
make_node_187_ast_node(obj_t loc_455, type_bglt type_456)
{
   AN_OBJECT;
   {	/* Ast/node.scm 19 */
      {		/* Ast/node.scm 19 */
	 node_bglt new1185_2084;
	 new1185_2084 =
	    ((node_bglt) BREF(GC_MALLOC(sizeof(struct node))));
	 {	/* Ast/node.scm 19 */
	    long arg2200_2085;
	    arg2200_2085 =
	       class_num_218___object(node_ast_node);
	    {	/* Ast/node.scm 19 */
	       obj_t obj_2088;
	       obj_2088 =
		  (obj_t) (new1185_2084);
	       (((obj_t) CREF(obj_2088))->header = MAKE_HEADER(arg2200_2085, 0), BUNSPEC);
	    }
	 }
	 {	/* Ast/node.scm 19 */
	    object_bglt aux_5212;
	    aux_5212 =
	       (object_bglt) (new1185_2084);
	    OBJECT_WIDENING_SET(aux_5212, BFALSE);
	 }
	 ((((node_bglt) CREF(new1185_2084))->loc) = ((obj_t) loc_455), BUNSPEC);
	 ((((node_bglt) CREF(new1185_2084))->type) = ((type_bglt) type_456), BUNSPEC);
	 return new1185_2084;
      }
   }
}



/* _make-node */
obj_t 
_make_node_181_ast_node(obj_t env_3544, obj_t loc_3545, obj_t type_3546)
{
   AN_OBJECT;
   {	/* Ast/node.scm 19 */
      {		/* Ast/node.scm 19 */
	 node_bglt aux_5217;
	 aux_5217 =
	    make_node_187_ast_node(loc_3545,
	    (type_bglt) (type_3546));
	 return
	    (obj_t) (aux_5217);
      }
   }
}



/* node-loc */
obj_t 
node_loc_29_ast_node(node_bglt obj_457)
{
   AN_OBJECT;
   {	/* Ast/node.scm 21 */
      return
	 (((node_bglt) CREF(obj_457))->loc);
   }
}



/* _node-loc */
obj_t 
_node_loc_236_ast_node(obj_t env_3547, obj_t obj_3548)
{
   AN_OBJECT;
   {	/* Ast/node.scm 21 */
      return
	 node_loc_29_ast_node(
	 (node_bglt) (obj_3548));
   }
}



/* node-type-set! */
obj_t 
node_type_set__235_ast_node(node_bglt obj_458, type_bglt val1184_459)
{
   AN_OBJECT;
   {	/* Ast/node.scm 19 */
      return
	 ((((node_bglt) CREF(obj_458))->type) = ((type_bglt) val1184_459), BUNSPEC);
   }
}



/* _node-type-set! */
obj_t 
_node_type_set__147_ast_node(obj_t env_3549, obj_t obj_3550, obj_t val1184_3551)
{
   AN_OBJECT;
   {	/* Ast/node.scm 19 */
      return
	 node_type_set__235_ast_node(
	 (node_bglt) (obj_3550),
	 (type_bglt) (val1184_3551));
   }
}



/* node-type */
type_bglt 
node_type_175_ast_node(node_bglt obj_460)
{
   AN_OBJECT;
   {	/* Ast/node.scm 19 */
      return
	 (((node_bglt) CREF(obj_460))->type);
   }
}



/* _node-type */
obj_t 
_node_type_141_ast_node(obj_t env_3552, obj_t obj_3553)
{
   AN_OBJECT;
   {	/* Ast/node.scm 19 */
      {		/* Ast/node.scm 19 */
	 type_bglt aux_5229;
	 aux_5229 =
	    node_type_175_ast_node(
	    (node_bglt) (obj_3553));
	 return
	    (obj_t) (aux_5229);
      }
   }
}



/* method-init */
obj_t 
method_init_76_ast_node()
{
   AN_OBJECT;
   {	/* Ast/node.scm 14 */
      {		/* Ast/node.scm 14 */
	 obj_t object__struct_box_set_1934_10_3599;
	 object__struct_box_set_1934_10_3599 = proc2537_ast_node;
	 add_method__1___object(object__struct_env_210___object, box_set__221_ast_node, object__struct_box_set_1934_10_3599);
      }
      {		/* Ast/node.scm 14 */
	 obj_t struct_object__object_box_set_1936_112_3598;
	 struct_object__object_box_set_1936_112_3598 = proc2538_ast_node;
	 add_method__1___object(struct_object__object_env_209___object, box_set__221_ast_node, struct_object__object_box_set_1936_112_3598);
      }
      {		/* Ast/node.scm 14 */
	 obj_t object__struct_box_ref1938_31_3597;
	 object__struct_box_ref1938_31_3597 = proc2539_ast_node;
	 add_method__1___object(object__struct_env_210___object, box_ref_242_ast_node, object__struct_box_ref1938_31_3597);
      }
      {		/* Ast/node.scm 14 */
	 obj_t struct_object__object_box_ref1940_82_3596;
	 struct_object__object_box_ref1940_82_3596 = proc2540_ast_node;
	 add_method__1___object(struct_object__object_env_209___object, box_ref_242_ast_node, struct_object__object_box_ref1940_82_3596);
      }
      {		/* Ast/node.scm 14 */
	 obj_t object__struct_make_box1942_94_3595;
	 object__struct_make_box1942_94_3595 = proc2541_ast_node;
	 add_method__1___object(object__struct_env_210___object, make_box_202_ast_node, object__struct_make_box1942_94_3595);
      }
      {		/* Ast/node.scm 14 */
	 obj_t struct_object__object_make_box1944_160_3594;
	 struct_object__object_make_box1944_160_3594 = proc2542_ast_node;
	 add_method__1___object(struct_object__object_env_209___object, make_box_202_ast_node, struct_object__object_make_box1944_160_3594);
      }
      {		/* Ast/node.scm 14 */
	 obj_t object__struct_jump_ex_it1946_107_3593;
	 object__struct_jump_ex_it1946_107_3593 = proc2543_ast_node;
	 add_method__1___object(object__struct_env_210___object, jump_ex_it_184_ast_node, object__struct_jump_ex_it1946_107_3593);
      }
      {		/* Ast/node.scm 14 */
	 obj_t struct_object__object_jump_ex_it1948_231_3592;
	 struct_object__object_jump_ex_it1948_231_3592 = proc2544_ast_node;
	 add_method__1___object(struct_object__object_env_209___object, jump_ex_it_184_ast_node, struct_object__object_jump_ex_it1948_231_3592);
      }
      {		/* Ast/node.scm 14 */
	 obj_t object__struct_set_ex_it1950_247_3591;
	 object__struct_set_ex_it1950_247_3591 = proc2545_ast_node;
	 add_method__1___object(object__struct_env_210___object, set_ex_it_116_ast_node, object__struct_set_ex_it1950_247_3591);
      }
      {		/* Ast/node.scm 14 */
	 obj_t struct_object__object_set_ex_it1952_191_3590;
	 struct_object__object_set_ex_it1952_191_3590 = proc2546_ast_node;
	 add_method__1___object(struct_object__object_env_209___object, set_ex_it_116_ast_node, struct_object__object_set_ex_it1952_191_3590);
      }
      {		/* Ast/node.scm 14 */
	 obj_t object__struct_let_var1954_71_3589;
	 object__struct_let_var1954_71_3589 = proc2547_ast_node;
	 add_method__1___object(object__struct_env_210___object, let_var_6_ast_node, object__struct_let_var1954_71_3589);
      }
      {		/* Ast/node.scm 14 */
	 obj_t struct_object__object_let_var1956_48_3588;
	 struct_object__object_let_var1956_48_3588 = proc2548_ast_node;
	 add_method__1___object(struct_object__object_env_209___object, let_var_6_ast_node, struct_object__object_let_var1956_48_3588);
      }
      {		/* Ast/node.scm 14 */
	 obj_t object__struct_let_fun1958_74_3587;
	 object__struct_let_fun1958_74_3587 = proc2549_ast_node;
	 add_method__1___object(object__struct_env_210___object, let_fun_218_ast_node, object__struct_let_fun1958_74_3587);
      }
      {		/* Ast/node.scm 14 */
	 obj_t struct_object__object_let_fun1960_153_3586;
	 struct_object__object_let_fun1960_153_3586 = proc2550_ast_node;
	 add_method__1___object(struct_object__object_env_209___object, let_fun_218_ast_node, struct_object__object_let_fun1960_153_3586);
      }
      {		/* Ast/node.scm 14 */
	 obj_t object__struct_select1962_38_3585;
	 object__struct_select1962_38_3585 = proc2551_ast_node;
	 add_method__1___object(object__struct_env_210___object, select_ast_node, object__struct_select1962_38_3585);
      }
      {		/* Ast/node.scm 14 */
	 obj_t struct_object__object_select1964_220_3584;
	 struct_object__object_select1964_220_3584 = proc2552_ast_node;
	 add_method__1___object(struct_object__object_env_209___object, select_ast_node, struct_object__object_select1964_220_3584);
      }
      {		/* Ast/node.scm 14 */
	 obj_t object__struct_fail1966_121_3583;
	 object__struct_fail1966_121_3583 = proc2553_ast_node;
	 add_method__1___object(object__struct_env_210___object, fail_ast_node, object__struct_fail1966_121_3583);
      }
      {		/* Ast/node.scm 14 */
	 obj_t struct_object__object_fail1968_208_3582;
	 struct_object__object_fail1968_208_3582 = proc2554_ast_node;
	 add_method__1___object(struct_object__object_env_209___object, fail_ast_node, struct_object__object_fail1968_208_3582);
      }
      {		/* Ast/node.scm 14 */
	 obj_t object__struct_conditional1970_196_3581;
	 object__struct_conditional1970_196_3581 = proc2555_ast_node;
	 add_method__1___object(object__struct_env_210___object, conditional_ast_node, object__struct_conditional1970_196_3581);
      }
      {		/* Ast/node.scm 14 */
	 obj_t struct_object__object_conditional1972_48_3580;
	 struct_object__object_conditional1972_48_3580 = proc2556_ast_node;
	 add_method__1___object(struct_object__object_env_209___object, conditional_ast_node, struct_object__object_conditional1972_48_3580);
      }
      {		/* Ast/node.scm 14 */
	 obj_t object__struct_setq1974_190_3579;
	 object__struct_setq1974_190_3579 = proc2557_ast_node;
	 add_method__1___object(object__struct_env_210___object, setq_ast_node, object__struct_setq1974_190_3579);
      }
      {		/* Ast/node.scm 14 */
	 obj_t struct_object__object_setq1976_146_3578;
	 struct_object__object_setq1976_146_3578 = proc2558_ast_node;
	 add_method__1___object(struct_object__object_env_209___object, setq_ast_node, struct_object__object_setq1976_146_3578);
      }
      {		/* Ast/node.scm 14 */
	 obj_t object__struct_cast1978_156_3577;
	 object__struct_cast1978_156_3577 = proc2559_ast_node;
	 add_method__1___object(object__struct_env_210___object, cast_ast_node, object__struct_cast1978_156_3577);
      }
      {		/* Ast/node.scm 14 */
	 obj_t struct_object__object_cast1980_80_3576;
	 struct_object__object_cast1980_80_3576 = proc2560_ast_node;
	 add_method__1___object(struct_object__object_env_209___object, cast_ast_node, struct_object__object_cast1980_80_3576);
      }
      {		/* Ast/node.scm 14 */
	 obj_t object__struct_pragma1982_170_3575;
	 object__struct_pragma1982_170_3575 = proc2561_ast_node;
	 add_method__1___object(object__struct_env_210___object, pragma_ast_node, object__struct_pragma1982_170_3575);
      }
      {		/* Ast/node.scm 14 */
	 obj_t struct_object__object_pragma1984_236_3574;
	 struct_object__object_pragma1984_236_3574 = proc2562_ast_node;
	 add_method__1___object(struct_object__object_env_209___object, pragma_ast_node, struct_object__object_pragma1984_236_3574);
      }
      {		/* Ast/node.scm 14 */
	 obj_t object__struct_funcall1986_102_3573;
	 object__struct_funcall1986_102_3573 = proc2563_ast_node;
	 add_method__1___object(object__struct_env_210___object, funcall_ast_node, object__struct_funcall1986_102_3573);
      }
      {		/* Ast/node.scm 14 */
	 obj_t struct_object__object_funcall1988_194_3572;
	 struct_object__object_funcall1988_194_3572 = proc2564_ast_node;
	 add_method__1___object(struct_object__object_env_209___object, funcall_ast_node, struct_object__object_funcall1988_194_3572);
      }
      {		/* Ast/node.scm 14 */
	 obj_t object__struct_app_ly1990_206_3571;
	 object__struct_app_ly1990_206_3571 = proc2565_ast_node;
	 add_method__1___object(object__struct_env_210___object, app_ly_162_ast_node, object__struct_app_ly1990_206_3571);
      }
      {		/* Ast/node.scm 14 */
	 obj_t struct_object__object_app_ly1992_166_3570;
	 struct_object__object_app_ly1992_166_3570 = proc2566_ast_node;
	 add_method__1___object(struct_object__object_env_209___object, app_ly_162_ast_node, struct_object__object_app_ly1992_166_3570);
      }
      {		/* Ast/node.scm 14 */
	 obj_t object__struct_app1994_212_3569;
	 object__struct_app1994_212_3569 = proc2567_ast_node;
	 add_method__1___object(object__struct_env_210___object, app_ast_node, object__struct_app1994_212_3569);
      }
      {		/* Ast/node.scm 14 */
	 obj_t struct_object__object_app1996_145_3568;
	 struct_object__object_app1996_145_3568 = proc2568_ast_node;
	 add_method__1___object(struct_object__object_env_209___object, app_ast_node, struct_object__object_app1996_145_3568);
      }
      {		/* Ast/node.scm 14 */
	 obj_t object__struct_sequence1998_173_3567;
	 object__struct_sequence1998_173_3567 = proc2569_ast_node;
	 add_method__1___object(object__struct_env_210___object, sequence_ast_node, object__struct_sequence1998_173_3567);
      }
      {		/* Ast/node.scm 14 */
	 obj_t struct_object__object_sequence2000_234_3566;
	 struct_object__object_sequence2000_234_3566 = proc2570_ast_node;
	 add_method__1___object(struct_object__object_env_209___object, sequence_ast_node, struct_object__object_sequence2000_234_3566);
      }
      {		/* Ast/node.scm 14 */
	 obj_t object__struct_kwote2002_73_3565;
	 object__struct_kwote2002_73_3565 = proc2571_ast_node;
	 add_method__1___object(object__struct_env_210___object, kwote_ast_node, object__struct_kwote2002_73_3565);
      }
      {		/* Ast/node.scm 14 */
	 obj_t struct_object__object_kwote2004_147_3564;
	 struct_object__object_kwote2004_147_3564 = proc2572_ast_node;
	 add_method__1___object(struct_object__object_env_209___object, kwote_ast_node, struct_object__object_kwote2004_147_3564);
      }
      {		/* Ast/node.scm 14 */
	 obj_t object__struct_closure2006_234_3563;
	 object__struct_closure2006_234_3563 = proc2573_ast_node;
	 add_method__1___object(object__struct_env_210___object, closure_ast_node, object__struct_closure2006_234_3563);
      }
      {		/* Ast/node.scm 14 */
	 obj_t struct_object__object_closure2008_247_3562;
	 struct_object__object_closure2008_247_3562 = proc2574_ast_node;
	 add_method__1___object(struct_object__object_env_209___object, closure_ast_node, struct_object__object_closure2008_247_3562);
      }
      {		/* Ast/node.scm 14 */
	 obj_t object__struct_var2010_190_3561;
	 object__struct_var2010_190_3561 = proc2575_ast_node;
	 add_method__1___object(object__struct_env_210___object, var_ast_node, object__struct_var2010_190_3561);
      }
      {		/* Ast/node.scm 14 */
	 obj_t struct_object__object_var2012_86_3560;
	 struct_object__object_var2012_86_3560 = proc2576_ast_node;
	 add_method__1___object(struct_object__object_env_209___object, var_ast_node, struct_object__object_var2012_86_3560);
      }
      {		/* Ast/node.scm 14 */
	 obj_t object__struct_atom2014_251_3559;
	 object__struct_atom2014_251_3559 = proc2577_ast_node;
	 add_method__1___object(object__struct_env_210___object, atom_ast_node, object__struct_atom2014_251_3559);
      }
      {		/* Ast/node.scm 14 */
	 obj_t struct_object__object_atom2016_22_3558;
	 struct_object__object_atom2016_22_3558 = proc2578_ast_node;
	 add_method__1___object(struct_object__object_env_209___object, atom_ast_node, struct_object__object_atom2016_22_3558);
      }
      {		/* Ast/node.scm 14 */
	 obj_t object__struct_node_effect2018_126_3557;
	 object__struct_node_effect2018_126_3557 = proc2579_ast_node;
	 add_method__1___object(object__struct_env_210___object, node_effect_213_ast_node, object__struct_node_effect2018_126_3557);
      }
      {		/* Ast/node.scm 14 */
	 obj_t struct_object__object_node_effect2020_69_3556;
	 struct_object__object_node_effect2020_69_3556 = proc2580_ast_node;
	 add_method__1___object(struct_object__object_env_209___object, node_effect_213_ast_node, struct_object__object_node_effect2020_69_3556);
      }
      {		/* Ast/node.scm 14 */
	 obj_t object__struct_node2022_9_3555;
	 object__struct_node2022_9_3555 = proc2581_ast_node;
	 add_method__1___object(object__struct_env_210___object, node_ast_node, object__struct_node2022_9_3555);
      }
      {		/* Ast/node.scm 14 */
	 obj_t struct_object__object_node2024_88_3554;
	 struct_object__object_node2024_88_3554 = proc2582_ast_node;
	 return
	    add_method__1___object(struct_object__object_env_209___object, node_ast_node, struct_object__object_node2024_88_3554);
      }
   }
}



/* struct+object->object-node2024 */
obj_t 
struct_object__object_node2024_88_ast_node(obj_t env_3600, obj_t o_3601, obj_t s_3602)
{
   AN_OBJECT;
   {	/* Ast/node.scm 19 */
      {
	 node_bglt o_1837;
	 obj_t s_1838;
	 {	/* Ast/node.scm 19 */
	    node_bglt aux_5279;
	    o_1837 =
	       (node_bglt) (o_3601);
	    s_1838 = s_3602;
	    {	/* Ast/node.scm 19 */
	       obj_t aux_5282;
	       object_bglt aux_5280;
	       aux_5282 =
		  STRUCT_REF(s_1838, ((long) 0));
	       aux_5280 =
		  (object_bglt) (o_1837);
	       OBJECT_WIDENING_SET(aux_5280, aux_5282);
	    }
	    {	/* Ast/node.scm 19 */
	       obj_t v1194_1842;
	       v1194_1842 =
		  STRUCT_REF(s_1838, ((long) 1));
	       ((((node_bglt) CREF(o_1837))->loc) = ((obj_t) v1194_1842), BUNSPEC);
	    }
	    {	/* Ast/node.scm 19 */
	       type_bglt v1198_1843;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_5287;
		  aux_5287 =
		     STRUCT_REF(s_1838, ((long) 2));
		  v1198_1843 =
		     (type_bglt) (aux_5287);
	       }
	       ((((node_bglt) CREF(o_1837))->type) = ((type_bglt) v1198_1843), BUNSPEC);
	    }
	    aux_5279 = o_1837;
	    return
	       (obj_t) (aux_5279);
	 }
      }
   }
}



/* object->struct-node2022 */
obj_t 
object__struct_node2022_9_ast_node(obj_t env_3603, obj_t obj1190_3604)
{
   AN_OBJECT;
   {	/* Ast/node.scm 19 */
      {
	 node_bglt obj1190_1827;
	 obj1190_1827 =
	    (node_bglt) (obj1190_3604);
	 {	/* Ast/node.scm 19 */
	    obj_t res1191_1830;
	    {	/* ./Llib/struct.scm 1415 */
	       obj_t aux_5293;
	       aux_5293 =
		  CNST_TABLE_REF(((long) 0));
	       res1191_1830 =
		  make_struct(aux_5293, ((long) 3), BUNSPEC);
	    }
	    STRUCT_SET(res1191_1830, ((long) 0), BFALSE);
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5297;
	       aux_5297 =
		  (((node_bglt) CREF(obj1190_1827))->loc);
	       STRUCT_SET(res1191_1830, ((long) 1), aux_5297);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5300;
	       {	/* Ast/node.scm 19 */
		  type_bglt aux_5301;
		  aux_5301 =
		     (((node_bglt) CREF(obj1190_1827))->type);
		  aux_5300 =
		     (obj_t) (aux_5301);
	       }
	       STRUCT_SET(res1191_1830, ((long) 2), aux_5300);
	    }
	    return res1191_1830;
	 }
      }
   }
}



/* struct+object->object-node/effect2020 */
obj_t 
struct_object__object_node_effect2020_69_ast_node(obj_t env_3605, obj_t o_3606, obj_t s_3607)
{
   AN_OBJECT;
   {	/* Ast/node.scm 27 */
      {
	 node_effect_213_bglt o_1816;
	 obj_t s_1817;
	 {	/* Ast/node.scm 27 */
	    node_effect_213_bglt aux_5306;
	    o_1816 =
	       (node_effect_213_bglt) (o_3606);
	    s_1817 = s_3607;
	    {	/* Ast/node.scm 27 */
	       obj_t aux_5309;
	       object_bglt aux_5307;
	       aux_5309 =
		  STRUCT_REF(s_1817, ((long) 0));
	       aux_5307 =
		  (object_bglt) (o_1816);
	       OBJECT_WIDENING_SET(aux_5307, aux_5309);
	    }
	    {	/* Ast/node.scm 27 */
	       obj_t v1214_1821;
	       v1214_1821 =
		  STRUCT_REF(s_1817, ((long) 1));
	       ((((node_effect_213_bglt) CREF(o_1816))->loc) = ((obj_t) v1214_1821), BUNSPEC);
	    }
	    {	/* Ast/node.scm 27 */
	       type_bglt v1218_1822;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_5314;
		  aux_5314 =
		     STRUCT_REF(s_1817, ((long) 2));
		  v1218_1822 =
		     (type_bglt) (aux_5314);
	       }
	       ((((node_effect_213_bglt) CREF(o_1816))->type) = ((type_bglt) v1218_1822), BUNSPEC);
	    }
	    {	/* Ast/node.scm 27 */
	       obj_t v1222_1823;
	       v1222_1823 =
		  STRUCT_REF(s_1817, ((long) 3));
	       ((((node_effect_213_bglt) CREF(o_1816))->side_effect__165) = ((obj_t) v1222_1823), BUNSPEC);
	    }
	    {	/* Ast/node.scm 27 */
	       obj_t v1226_1824;
	       v1226_1824 =
		  STRUCT_REF(s_1817, ((long) 4));
	       ((((node_effect_213_bglt) CREF(o_1816))->key) = ((obj_t) v1226_1824), BUNSPEC);
	    }
	    aux_5306 = o_1816;
	    return
	       (obj_t) (aux_5306);
	 }
      }
   }
}



/* object->struct-node/effect2018 */
obj_t 
object__struct_node_effect2018_126_ast_node(obj_t env_3608, obj_t obj1210_3609)
{
   AN_OBJECT;
   {	/* Ast/node.scm 27 */
      {
	 node_effect_213_bglt obj1210_1802;
	 obj1210_1802 =
	    (node_effect_213_bglt) (obj1210_3609);
	 {	/* Ast/node.scm 27 */
	    obj_t res1211_1805;
	    {	/* ./Llib/struct.scm 1415 */
	       obj_t aux_5324;
	       aux_5324 =
		  CNST_TABLE_REF(((long) 1));
	       res1211_1805 =
		  make_struct(aux_5324, ((long) 5), BUNSPEC);
	    }
	    STRUCT_SET(res1211_1805, ((long) 0), BFALSE);
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5328;
	       aux_5328 =
		  (((node_effect_213_bglt) CREF(obj1210_1802))->loc);
	       STRUCT_SET(res1211_1805, ((long) 1), aux_5328);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5331;
	       {	/* Ast/node.scm 27 */
		  type_bglt aux_5332;
		  aux_5332 =
		     (((node_effect_213_bglt) CREF(obj1210_1802))->type);
		  aux_5331 =
		     (obj_t) (aux_5332);
	       }
	       STRUCT_SET(res1211_1805, ((long) 2), aux_5331);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5336;
	       aux_5336 =
		  (((node_effect_213_bglt) CREF(obj1210_1802))->side_effect__165);
	       STRUCT_SET(res1211_1805, ((long) 3), aux_5336);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5339;
	       aux_5339 =
		  (((node_effect_213_bglt) CREF(obj1210_1802))->key);
	       STRUCT_SET(res1211_1805, ((long) 4), aux_5339);
	    }
	    return res1211_1805;
	 }
      }
   }
}



/* struct+object->object-atom2016 */
obj_t 
struct_object__object_atom2016_22_ast_node(obj_t env_3610, obj_t o_3611, obj_t s_3612)
{
   AN_OBJECT;
   {	/* Ast/node.scm 36 */
      {
	 atom_bglt o_1792;
	 obj_t s_1793;
	 {	/* Ast/node.scm 36 */
	    atom_bglt aux_5343;
	    o_1792 =
	       (atom_bglt) (o_3611);
	    s_1793 = s_3612;
	    {	/* Ast/node.scm 36 */
	       obj_t aux_5346;
	       object_bglt aux_5344;
	       aux_5346 =
		  STRUCT_REF(s_1793, ((long) 0));
	       aux_5344 =
		  (object_bglt) (o_1792);
	       OBJECT_WIDENING_SET(aux_5344, aux_5346);
	    }
	    {	/* Ast/node.scm 36 */
	       obj_t v1240_1797;
	       v1240_1797 =
		  STRUCT_REF(s_1793, ((long) 1));
	       ((((atom_bglt) CREF(o_1792))->loc) = ((obj_t) v1240_1797), BUNSPEC);
	    }
	    {	/* Ast/node.scm 36 */
	       type_bglt v1244_1798;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_5351;
		  aux_5351 =
		     STRUCT_REF(s_1793, ((long) 2));
		  v1244_1798 =
		     (type_bglt) (aux_5351);
	       }
	       ((((atom_bglt) CREF(o_1792))->type) = ((type_bglt) v1244_1798), BUNSPEC);
	    }
	    {	/* Ast/node.scm 36 */
	       obj_t v1248_1799;
	       v1248_1799 =
		  STRUCT_REF(s_1793, ((long) 3));
	       ((((atom_bglt) CREF(o_1792))->value) = ((obj_t) v1248_1799), BUNSPEC);
	    }
	    aux_5343 = o_1792;
	    return
	       (obj_t) (aux_5343);
	 }
      }
   }
}



/* object->struct-atom2014 */
obj_t 
object__struct_atom2014_251_ast_node(obj_t env_3613, obj_t obj1236_3614)
{
   AN_OBJECT;
   {	/* Ast/node.scm 36 */
      {
	 atom_bglt obj1236_1780;
	 obj1236_1780 =
	    (atom_bglt) (obj1236_3614);
	 {	/* Ast/node.scm 36 */
	    obj_t res1237_1783;
	    {	/* ./Llib/struct.scm 1415 */
	       obj_t aux_5359;
	       aux_5359 =
		  CNST_TABLE_REF(((long) 2));
	       res1237_1783 =
		  make_struct(aux_5359, ((long) 4), BUNSPEC);
	    }
	    STRUCT_SET(res1237_1783, ((long) 0), BFALSE);
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5363;
	       aux_5363 =
		  (((atom_bglt) CREF(obj1236_1780))->loc);
	       STRUCT_SET(res1237_1783, ((long) 1), aux_5363);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5366;
	       {	/* Ast/node.scm 36 */
		  type_bglt aux_5367;
		  aux_5367 =
		     (((atom_bglt) CREF(obj1236_1780))->type);
		  aux_5366 =
		     (obj_t) (aux_5367);
	       }
	       STRUCT_SET(res1237_1783, ((long) 2), aux_5366);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5371;
	       aux_5371 =
		  (((atom_bglt) CREF(obj1236_1780))->value);
	       STRUCT_SET(res1237_1783, ((long) 3), aux_5371);
	    }
	    return res1237_1783;
	 }
      }
   }
}



/* struct+object->object-var2012 */
obj_t 
struct_object__object_var2012_86_ast_node(obj_t env_3615, obj_t o_3616, obj_t s_3617)
{
   AN_OBJECT;
   {	/* Ast/node.scm 41 */
      {
	 var_bglt o_1770;
	 obj_t s_1771;
	 {	/* Ast/node.scm 41 */
	    var_bglt aux_5375;
	    o_1770 =
	       (var_bglt) (o_3616);
	    s_1771 = s_3617;
	    {	/* Ast/node.scm 41 */
	       obj_t aux_5378;
	       object_bglt aux_5376;
	       aux_5378 =
		  STRUCT_REF(s_1771, ((long) 0));
	       aux_5376 =
		  (object_bglt) (o_1770);
	       OBJECT_WIDENING_SET(aux_5376, aux_5378);
	    }
	    {	/* Ast/node.scm 41 */
	       obj_t v1262_1775;
	       v1262_1775 =
		  STRUCT_REF(s_1771, ((long) 1));
	       ((((var_bglt) CREF(o_1770))->loc) = ((obj_t) v1262_1775), BUNSPEC);
	    }
	    {	/* Ast/node.scm 41 */
	       type_bglt v1266_1776;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_5383;
		  aux_5383 =
		     STRUCT_REF(s_1771, ((long) 2));
		  v1266_1776 =
		     (type_bglt) (aux_5383);
	       }
	       ((((var_bglt) CREF(o_1770))->type) = ((type_bglt) v1266_1776), BUNSPEC);
	    }
	    {	/* Ast/node.scm 41 */
	       variable_bglt v1270_1777;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_5387;
		  aux_5387 =
		     STRUCT_REF(s_1771, ((long) 3));
		  v1270_1777 =
		     (variable_bglt) (aux_5387);
	       }
	       ((((var_bglt) CREF(o_1770))->variable) = ((variable_bglt) v1270_1777), BUNSPEC);
	    }
	    aux_5375 = o_1770;
	    return
	       (obj_t) (aux_5375);
	 }
      }
   }
}



/* object->struct-var2010 */
obj_t 
object__struct_var2010_190_ast_node(obj_t env_3618, obj_t obj1258_3619)
{
   AN_OBJECT;
   {	/* Ast/node.scm 41 */
      {
	 var_bglt obj1258_1758;
	 obj1258_1758 =
	    (var_bglt) (obj1258_3619);
	 {	/* Ast/node.scm 41 */
	    obj_t res1259_1761;
	    {	/* ./Llib/struct.scm 1415 */
	       obj_t aux_5393;
	       aux_5393 =
		  CNST_TABLE_REF(((long) 3));
	       res1259_1761 =
		  make_struct(aux_5393, ((long) 4), BUNSPEC);
	    }
	    STRUCT_SET(res1259_1761, ((long) 0), BFALSE);
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5397;
	       aux_5397 =
		  (((var_bglt) CREF(obj1258_1758))->loc);
	       STRUCT_SET(res1259_1761, ((long) 1), aux_5397);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5400;
	       {	/* Ast/node.scm 41 */
		  type_bglt aux_5401;
		  aux_5401 =
		     (((var_bglt) CREF(obj1258_1758))->type);
		  aux_5400 =
		     (obj_t) (aux_5401);
	       }
	       STRUCT_SET(res1259_1761, ((long) 2), aux_5400);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5405;
	       {	/* Ast/node.scm 41 */
		  variable_bglt aux_5406;
		  aux_5406 =
		     (((var_bglt) CREF(obj1258_1758))->variable);
		  aux_5405 =
		     (obj_t) (aux_5406);
	       }
	       STRUCT_SET(res1259_1761, ((long) 3), aux_5405);
	    }
	    return res1259_1761;
	 }
      }
   }
}



/* struct+object->object-closure2008 */
obj_t 
struct_object__object_closure2008_247_ast_node(obj_t env_3620, obj_t o_3621, obj_t s_3622)
{
   AN_OBJECT;
   {	/* Ast/node.scm 46 */
      {
	 closure_bglt o_1748;
	 obj_t s_1749;
	 {	/* Ast/node.scm 46 */
	    closure_bglt aux_5411;
	    o_1748 =
	       (closure_bglt) (o_3621);
	    s_1749 = s_3622;
	    {	/* Ast/node.scm 46 */
	       obj_t aux_5414;
	       object_bglt aux_5412;
	       aux_5414 =
		  STRUCT_REF(s_1749, ((long) 0));
	       aux_5412 =
		  (object_bglt) (o_1748);
	       OBJECT_WIDENING_SET(aux_5412, aux_5414);
	    }
	    {	/* Ast/node.scm 46 */
	       obj_t v1284_1753;
	       v1284_1753 =
		  STRUCT_REF(s_1749, ((long) 1));
	       ((((closure_bglt) CREF(o_1748))->loc) = ((obj_t) v1284_1753), BUNSPEC);
	    }
	    {	/* Ast/node.scm 46 */
	       type_bglt v1288_1754;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_5419;
		  aux_5419 =
		     STRUCT_REF(s_1749, ((long) 2));
		  v1288_1754 =
		     (type_bglt) (aux_5419);
	       }
	       ((((closure_bglt) CREF(o_1748))->type) = ((type_bglt) v1288_1754), BUNSPEC);
	    }
	    {	/* Ast/node.scm 46 */
	       variable_bglt v1292_1755;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_5423;
		  aux_5423 =
		     STRUCT_REF(s_1749, ((long) 3));
		  v1292_1755 =
		     (variable_bglt) (aux_5423);
	       }
	       ((((closure_bglt) CREF(o_1748))->variable) = ((variable_bglt) v1292_1755), BUNSPEC);
	    }
	    aux_5411 = o_1748;
	    return
	       (obj_t) (aux_5411);
	 }
      }
   }
}



/* object->struct-closure2006 */
obj_t 
object__struct_closure2006_234_ast_node(obj_t env_3623, obj_t obj1280_3624)
{
   AN_OBJECT;
   {	/* Ast/node.scm 46 */
      {
	 closure_bglt obj1280_1736;
	 obj1280_1736 =
	    (closure_bglt) (obj1280_3624);
	 {	/* Ast/node.scm 46 */
	    obj_t res1281_1739;
	    {	/* ./Llib/struct.scm 1415 */
	       obj_t aux_5429;
	       aux_5429 =
		  CNST_TABLE_REF(((long) 4));
	       res1281_1739 =
		  make_struct(aux_5429, ((long) 4), BUNSPEC);
	    }
	    STRUCT_SET(res1281_1739, ((long) 0), BFALSE);
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5433;
	       aux_5433 =
		  (((closure_bglt) CREF(obj1280_1736))->loc);
	       STRUCT_SET(res1281_1739, ((long) 1), aux_5433);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5436;
	       {	/* Ast/node.scm 46 */
		  type_bglt aux_5437;
		  aux_5437 =
		     (((closure_bglt) CREF(obj1280_1736))->type);
		  aux_5436 =
		     (obj_t) (aux_5437);
	       }
	       STRUCT_SET(res1281_1739, ((long) 2), aux_5436);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5441;
	       {	/* Ast/node.scm 46 */
		  variable_bglt aux_5442;
		  aux_5442 =
		     (((closure_bglt) CREF(obj1280_1736))->variable);
		  aux_5441 =
		     (obj_t) (aux_5442);
	       }
	       STRUCT_SET(res1281_1739, ((long) 3), aux_5441);
	    }
	    return res1281_1739;
	 }
      }
   }
}



/* struct+object->object-kwote2004 */
obj_t 
struct_object__object_kwote2004_147_ast_node(obj_t env_3625, obj_t o_3626, obj_t s_3627)
{
   AN_OBJECT;
   {	/* Ast/node.scm 49 */
      {
	 kwote_bglt o_1726;
	 obj_t s_1727;
	 {	/* Ast/node.scm 49 */
	    kwote_bglt aux_5447;
	    o_1726 =
	       (kwote_bglt) (o_3626);
	    s_1727 = s_3627;
	    {	/* Ast/node.scm 49 */
	       obj_t aux_5450;
	       object_bglt aux_5448;
	       aux_5450 =
		  STRUCT_REF(s_1727, ((long) 0));
	       aux_5448 =
		  (object_bglt) (o_1726);
	       OBJECT_WIDENING_SET(aux_5448, aux_5450);
	    }
	    {	/* Ast/node.scm 49 */
	       obj_t v1305_1731;
	       v1305_1731 =
		  STRUCT_REF(s_1727, ((long) 1));
	       ((((kwote_bglt) CREF(o_1726))->loc) = ((obj_t) v1305_1731), BUNSPEC);
	    }
	    {	/* Ast/node.scm 49 */
	       type_bglt v1309_1732;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_5455;
		  aux_5455 =
		     STRUCT_REF(s_1727, ((long) 2));
		  v1309_1732 =
		     (type_bglt) (aux_5455);
	       }
	       ((((kwote_bglt) CREF(o_1726))->type) = ((type_bglt) v1309_1732), BUNSPEC);
	    }
	    {	/* Ast/node.scm 49 */
	       obj_t v1313_1733;
	       v1313_1733 =
		  STRUCT_REF(s_1727, ((long) 3));
	       ((((kwote_bglt) CREF(o_1726))->value) = ((obj_t) v1313_1733), BUNSPEC);
	    }
	    aux_5447 = o_1726;
	    return
	       (obj_t) (aux_5447);
	 }
      }
   }
}



/* object->struct-kwote2002 */
obj_t 
object__struct_kwote2002_73_ast_node(obj_t env_3628, obj_t obj1301_3629)
{
   AN_OBJECT;
   {	/* Ast/node.scm 49 */
      {
	 kwote_bglt obj1301_1714;
	 obj1301_1714 =
	    (kwote_bglt) (obj1301_3629);
	 {	/* Ast/node.scm 49 */
	    obj_t res1302_1717;
	    {	/* ./Llib/struct.scm 1415 */
	       obj_t aux_5463;
	       aux_5463 =
		  CNST_TABLE_REF(((long) 5));
	       res1302_1717 =
		  make_struct(aux_5463, ((long) 4), BUNSPEC);
	    }
	    STRUCT_SET(res1302_1717, ((long) 0), BFALSE);
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5467;
	       aux_5467 =
		  (((kwote_bglt) CREF(obj1301_1714))->loc);
	       STRUCT_SET(res1302_1717, ((long) 1), aux_5467);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5470;
	       {	/* Ast/node.scm 49 */
		  type_bglt aux_5471;
		  aux_5471 =
		     (((kwote_bglt) CREF(obj1301_1714))->type);
		  aux_5470 =
		     (obj_t) (aux_5471);
	       }
	       STRUCT_SET(res1302_1717, ((long) 2), aux_5470);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5475;
	       aux_5475 =
		  (((kwote_bglt) CREF(obj1301_1714))->value);
	       STRUCT_SET(res1302_1717, ((long) 3), aux_5475);
	    }
	    return res1302_1717;
	 }
      }
   }
}



/* struct+object->object-sequence2000 */
obj_t 
struct_object__object_sequence2000_234_ast_node(obj_t env_3630, obj_t o_3631, obj_t s_3632)
{
   AN_OBJECT;
   {	/* Ast/node.scm 54 */
      {
	 sequence_bglt o_1702;
	 obj_t s_1703;
	 {	/* Ast/node.scm 54 */
	    sequence_bglt aux_5479;
	    o_1702 =
	       (sequence_bglt) (o_3631);
	    s_1703 = s_3632;
	    {	/* Ast/node.scm 54 */
	       obj_t aux_5482;
	       object_bglt aux_5480;
	       aux_5482 =
		  STRUCT_REF(s_1703, ((long) 0));
	       aux_5480 =
		  (object_bglt) (o_1702);
	       OBJECT_WIDENING_SET(aux_5480, aux_5482);
	    }
	    {	/* Ast/node.scm 54 */
	       obj_t v1330_1707;
	       v1330_1707 =
		  STRUCT_REF(s_1703, ((long) 1));
	       ((((sequence_bglt) CREF(o_1702))->loc) = ((obj_t) v1330_1707), BUNSPEC);
	    }
	    {	/* Ast/node.scm 54 */
	       type_bglt v1334_1708;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_5487;
		  aux_5487 =
		     STRUCT_REF(s_1703, ((long) 2));
		  v1334_1708 =
		     (type_bglt) (aux_5487);
	       }
	       ((((sequence_bglt) CREF(o_1702))->type) = ((type_bglt) v1334_1708), BUNSPEC);
	    }
	    {	/* Ast/node.scm 54 */
	       obj_t v1338_1709;
	       v1338_1709 =
		  STRUCT_REF(s_1703, ((long) 3));
	       ((((sequence_bglt) CREF(o_1702))->side_effect__165) = ((obj_t) v1338_1709), BUNSPEC);
	    }
	    {	/* Ast/node.scm 54 */
	       obj_t v1342_1710;
	       v1342_1710 =
		  STRUCT_REF(s_1703, ((long) 4));
	       ((((sequence_bglt) CREF(o_1702))->key) = ((obj_t) v1342_1710), BUNSPEC);
	    }
	    {	/* Ast/node.scm 54 */
	       obj_t v1346_1711;
	       v1346_1711 =
		  STRUCT_REF(s_1703, ((long) 5));
	       ((((sequence_bglt) CREF(o_1702))->nodes) = ((obj_t) v1346_1711), BUNSPEC);
	    }
	    aux_5479 = o_1702;
	    return
	       (obj_t) (aux_5479);
	 }
      }
   }
}



/* object->struct-sequence1998 */
obj_t 
object__struct_sequence1998_173_ast_node(obj_t env_3633, obj_t obj1326_3634)
{
   AN_OBJECT;
   {	/* Ast/node.scm 54 */
      {
	 sequence_bglt obj1326_1686;
	 obj1326_1686 =
	    (sequence_bglt) (obj1326_3634);
	 {	/* Ast/node.scm 54 */
	    obj_t res1327_1689;
	    {	/* ./Llib/struct.scm 1415 */
	       obj_t aux_5499;
	       aux_5499 =
		  CNST_TABLE_REF(((long) 6));
	       res1327_1689 =
		  make_struct(aux_5499, ((long) 6), BUNSPEC);
	    }
	    STRUCT_SET(res1327_1689, ((long) 0), BFALSE);
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5503;
	       aux_5503 =
		  (((sequence_bglt) CREF(obj1326_1686))->loc);
	       STRUCT_SET(res1327_1689, ((long) 1), aux_5503);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5506;
	       {	/* Ast/node.scm 54 */
		  type_bglt aux_5507;
		  aux_5507 =
		     (((sequence_bglt) CREF(obj1326_1686))->type);
		  aux_5506 =
		     (obj_t) (aux_5507);
	       }
	       STRUCT_SET(res1327_1689, ((long) 2), aux_5506);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5511;
	       aux_5511 =
		  (((sequence_bglt) CREF(obj1326_1686))->side_effect__165);
	       STRUCT_SET(res1327_1689, ((long) 3), aux_5511);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5514;
	       aux_5514 =
		  (((sequence_bglt) CREF(obj1326_1686))->key);
	       STRUCT_SET(res1327_1689, ((long) 4), aux_5514);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5517;
	       aux_5517 =
		  (((sequence_bglt) CREF(obj1326_1686))->nodes);
	       STRUCT_SET(res1327_1689, ((long) 5), aux_5517);
	    }
	    return res1327_1689;
	 }
      }
   }
}



/* struct+object->object-app1996 */
obj_t 
struct_object__object_app1996_145_ast_node(obj_t env_3635, obj_t o_3636, obj_t s_3637)
{
   AN_OBJECT;
   {	/* Ast/node.scm 58 */
      {
	 app_bglt o_1672;
	 obj_t s_1673;
	 {	/* Ast/node.scm 58 */
	    app_bglt aux_5521;
	    o_1672 =
	       (app_bglt) (o_3636);
	    s_1673 = s_3637;
	    {	/* Ast/node.scm 58 */
	       obj_t aux_5524;
	       object_bglt aux_5522;
	       aux_5524 =
		  STRUCT_REF(s_1673, ((long) 0));
	       aux_5522 =
		  (object_bglt) (o_1672);
	       OBJECT_WIDENING_SET(aux_5522, aux_5524);
	    }
	    {	/* Ast/node.scm 58 */
	       obj_t v1368_1677;
	       v1368_1677 =
		  STRUCT_REF(s_1673, ((long) 1));
	       ((((app_bglt) CREF(o_1672))->loc) = ((obj_t) v1368_1677), BUNSPEC);
	    }
	    {	/* Ast/node.scm 58 */
	       type_bglt v1372_1678;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_5529;
		  aux_5529 =
		     STRUCT_REF(s_1673, ((long) 2));
		  v1372_1678 =
		     (type_bglt) (aux_5529);
	       }
	       ((((app_bglt) CREF(o_1672))->type) = ((type_bglt) v1372_1678), BUNSPEC);
	    }
	    {	/* Ast/node.scm 58 */
	       obj_t v1376_1679;
	       v1376_1679 =
		  STRUCT_REF(s_1673, ((long) 3));
	       ((((app_bglt) CREF(o_1672))->side_effect__165) = ((obj_t) v1376_1679), BUNSPEC);
	    }
	    {	/* Ast/node.scm 58 */
	       obj_t v1380_1680;
	       v1380_1680 =
		  STRUCT_REF(s_1673, ((long) 4));
	       ((((app_bglt) CREF(o_1672))->key) = ((obj_t) v1380_1680), BUNSPEC);
	    }
	    {	/* Ast/node.scm 58 */
	       var_bglt v1384_1681;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_5537;
		  aux_5537 =
		     STRUCT_REF(s_1673, ((long) 5));
		  v1384_1681 =
		     (var_bglt) (aux_5537);
	       }
	       ((((app_bglt) CREF(o_1672))->fun) = ((var_bglt) v1384_1681), BUNSPEC);
	    }
	    {	/* Ast/node.scm 58 */
	       obj_t v1388_1682;
	       v1388_1682 =
		  STRUCT_REF(s_1673, ((long) 6));
	       ((((app_bglt) CREF(o_1672))->args) = ((obj_t) v1388_1682), BUNSPEC);
	    }
	    {	/* Ast/node.scm 58 */
	       obj_t v1392_1683;
	       v1392_1683 =
		  STRUCT_REF(s_1673, ((long) 7));
	       ((((app_bglt) CREF(o_1672))->stack_info_255) = ((obj_t) v1392_1683), BUNSPEC);
	    }
	    aux_5521 = o_1672;
	    return
	       (obj_t) (aux_5521);
	 }
      }
   }
}



/* object->struct-app1994 */
obj_t 
object__struct_app1994_212_ast_node(obj_t env_3638, obj_t obj1364_3639)
{
   AN_OBJECT;
   {	/* Ast/node.scm 58 */
      {
	 app_bglt obj1364_1652;
	 obj1364_1652 =
	    (app_bglt) (obj1364_3639);
	 {	/* Ast/node.scm 58 */
	    obj_t res1365_1655;
	    {	/* ./Llib/struct.scm 1415 */
	       obj_t aux_5547;
	       aux_5547 =
		  CNST_TABLE_REF(((long) 7));
	       res1365_1655 =
		  make_struct(aux_5547, ((long) 8), BUNSPEC);
	    }
	    STRUCT_SET(res1365_1655, ((long) 0), BFALSE);
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5551;
	       aux_5551 =
		  (((app_bglt) CREF(obj1364_1652))->loc);
	       STRUCT_SET(res1365_1655, ((long) 1), aux_5551);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5554;
	       {	/* Ast/node.scm 58 */
		  type_bglt aux_5555;
		  aux_5555 =
		     (((app_bglt) CREF(obj1364_1652))->type);
		  aux_5554 =
		     (obj_t) (aux_5555);
	       }
	       STRUCT_SET(res1365_1655, ((long) 2), aux_5554);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5559;
	       aux_5559 =
		  (((app_bglt) CREF(obj1364_1652))->side_effect__165);
	       STRUCT_SET(res1365_1655, ((long) 3), aux_5559);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5562;
	       aux_5562 =
		  (((app_bglt) CREF(obj1364_1652))->key);
	       STRUCT_SET(res1365_1655, ((long) 4), aux_5562);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5565;
	       {	/* Ast/node.scm 58 */
		  var_bglt aux_5566;
		  aux_5566 =
		     (((app_bglt) CREF(obj1364_1652))->fun);
		  aux_5565 =
		     (obj_t) (aux_5566);
	       }
	       STRUCT_SET(res1365_1655, ((long) 5), aux_5565);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5570;
	       aux_5570 =
		  (((app_bglt) CREF(obj1364_1652))->args);
	       STRUCT_SET(res1365_1655, ((long) 6), aux_5570);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5573;
	       aux_5573 =
		  (((app_bglt) CREF(obj1364_1652))->stack_info_255);
	       STRUCT_SET(res1365_1655, ((long) 7), aux_5573);
	    }
	    return res1365_1655;
	 }
      }
   }
}



/* struct+object->object-app-ly1992 */
obj_t 
struct_object__object_app_ly1992_166_ast_node(obj_t env_3640, obj_t o_3641, obj_t s_3642)
{
   AN_OBJECT;
   {	/* Ast/node.scm 67 */
      {
	 app_ly_162_bglt o_1641;
	 obj_t s_1642;
	 {	/* Ast/node.scm 67 */
	    app_ly_162_bglt aux_5577;
	    o_1641 =
	       (app_ly_162_bglt) (o_3641);
	    s_1642 = s_3642;
	    {	/* Ast/node.scm 67 */
	       obj_t aux_5580;
	       object_bglt aux_5578;
	       aux_5580 =
		  STRUCT_REF(s_1642, ((long) 0));
	       aux_5578 =
		  (object_bglt) (o_1641);
	       OBJECT_WIDENING_SET(aux_5578, aux_5580);
	    }
	    {	/* Ast/node.scm 67 */
	       obj_t v1408_1646;
	       v1408_1646 =
		  STRUCT_REF(s_1642, ((long) 1));
	       ((((app_ly_162_bglt) CREF(o_1641))->loc) = ((obj_t) v1408_1646), BUNSPEC);
	    }
	    {	/* Ast/node.scm 67 */
	       type_bglt v1412_1647;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_5585;
		  aux_5585 =
		     STRUCT_REF(s_1642, ((long) 2));
		  v1412_1647 =
		     (type_bglt) (aux_5585);
	       }
	       ((((app_ly_162_bglt) CREF(o_1641))->type) = ((type_bglt) v1412_1647), BUNSPEC);
	    }
	    {	/* Ast/node.scm 67 */
	       node_bglt v1416_1648;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_5589;
		  aux_5589 =
		     STRUCT_REF(s_1642, ((long) 3));
		  v1416_1648 =
		     (node_bglt) (aux_5589);
	       }
	       ((((app_ly_162_bglt) CREF(o_1641))->fun) = ((node_bglt) v1416_1648), BUNSPEC);
	    }
	    {	/* Ast/node.scm 67 */
	       node_bglt v1420_1649;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_5593;
		  aux_5593 =
		     STRUCT_REF(s_1642, ((long) 4));
		  v1420_1649 =
		     (node_bglt) (aux_5593);
	       }
	       ((((app_ly_162_bglt) CREF(o_1641))->arg) = ((node_bglt) v1420_1649), BUNSPEC);
	    }
	    aux_5577 = o_1641;
	    return
	       (obj_t) (aux_5577);
	 }
      }
   }
}



/* object->struct-app-ly1990 */
obj_t 
object__struct_app_ly1990_206_ast_node(obj_t env_3643, obj_t obj1404_3644)
{
   AN_OBJECT;
   {	/* Ast/node.scm 67 */
      {
	 app_ly_162_bglt obj1404_1627;
	 obj1404_1627 =
	    (app_ly_162_bglt) (obj1404_3644);
	 {	/* Ast/node.scm 67 */
	    obj_t res1405_1630;
	    {	/* ./Llib/struct.scm 1415 */
	       obj_t aux_5599;
	       aux_5599 =
		  CNST_TABLE_REF(((long) 8));
	       res1405_1630 =
		  make_struct(aux_5599, ((long) 5), BUNSPEC);
	    }
	    STRUCT_SET(res1405_1630, ((long) 0), BFALSE);
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5603;
	       aux_5603 =
		  (((app_ly_162_bglt) CREF(obj1404_1627))->loc);
	       STRUCT_SET(res1405_1630, ((long) 1), aux_5603);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5606;
	       {	/* Ast/node.scm 67 */
		  type_bglt aux_5607;
		  aux_5607 =
		     (((app_ly_162_bglt) CREF(obj1404_1627))->type);
		  aux_5606 =
		     (obj_t) (aux_5607);
	       }
	       STRUCT_SET(res1405_1630, ((long) 2), aux_5606);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5611;
	       {	/* Ast/node.scm 67 */
		  node_bglt aux_5612;
		  aux_5612 =
		     (((app_ly_162_bglt) CREF(obj1404_1627))->fun);
		  aux_5611 =
		     (obj_t) (aux_5612);
	       }
	       STRUCT_SET(res1405_1630, ((long) 3), aux_5611);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5616;
	       {	/* Ast/node.scm 67 */
		  node_bglt aux_5617;
		  aux_5617 =
		     (((app_ly_162_bglt) CREF(obj1404_1627))->arg);
		  aux_5616 =
		     (obj_t) (aux_5617);
	       }
	       STRUCT_SET(res1405_1630, ((long) 4), aux_5616);
	    }
	    return res1405_1630;
	 }
      }
   }
}



/* struct+object->object-funcall1988 */
obj_t 
struct_object__object_funcall1988_194_ast_node(obj_t env_3645, obj_t o_3646, obj_t s_3647)
{
   AN_OBJECT;
   {	/* Ast/node.scm 74 */
      {
	 funcall_bglt o_1615;
	 obj_t s_1616;
	 {	/* Ast/node.scm 74 */
	    funcall_bglt aux_5622;
	    o_1615 =
	       (funcall_bglt) (o_3646);
	    s_1616 = s_3647;
	    {	/* Ast/node.scm 74 */
	       obj_t aux_5625;
	       object_bglt aux_5623;
	       aux_5625 =
		  STRUCT_REF(s_1616, ((long) 0));
	       aux_5623 =
		  (object_bglt) (o_1615);
	       OBJECT_WIDENING_SET(aux_5623, aux_5625);
	    }
	    {	/* Ast/node.scm 74 */
	       obj_t v1438_1620;
	       v1438_1620 =
		  STRUCT_REF(s_1616, ((long) 1));
	       ((((funcall_bglt) CREF(o_1615))->loc) = ((obj_t) v1438_1620), BUNSPEC);
	    }
	    {	/* Ast/node.scm 74 */
	       type_bglt v1442_1621;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_5630;
		  aux_5630 =
		     STRUCT_REF(s_1616, ((long) 2));
		  v1442_1621 =
		     (type_bglt) (aux_5630);
	       }
	       ((((funcall_bglt) CREF(o_1615))->type) = ((type_bglt) v1442_1621), BUNSPEC);
	    }
	    {	/* Ast/node.scm 74 */
	       node_bglt v1446_1622;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_5634;
		  aux_5634 =
		     STRUCT_REF(s_1616, ((long) 3));
		  v1446_1622 =
		     (node_bglt) (aux_5634);
	       }
	       ((((funcall_bglt) CREF(o_1615))->fun) = ((node_bglt) v1446_1622), BUNSPEC);
	    }
	    {	/* Ast/node.scm 74 */
	       obj_t v1450_1623;
	       v1450_1623 =
		  STRUCT_REF(s_1616, ((long) 4));
	       ((((funcall_bglt) CREF(o_1615))->args) = ((obj_t) v1450_1623), BUNSPEC);
	    }
	    {	/* Ast/node.scm 74 */
	       obj_t v1454_1624;
	       v1454_1624 =
		  STRUCT_REF(s_1616, ((long) 5));
	       ((((funcall_bglt) CREF(o_1615))->strength) = ((obj_t) v1454_1624), BUNSPEC);
	    }
	    aux_5622 = o_1615;
	    return
	       (obj_t) (aux_5622);
	 }
      }
   }
}



/* object->struct-funcall1986 */
obj_t 
object__struct_funcall1986_102_ast_node(obj_t env_3648, obj_t obj1434_3649)
{
   AN_OBJECT;
   {	/* Ast/node.scm 74 */
      {
	 funcall_bglt obj1434_1599;
	 obj1434_1599 =
	    (funcall_bglt) (obj1434_3649);
	 {	/* Ast/node.scm 74 */
	    obj_t res1435_1602;
	    {	/* ./Llib/struct.scm 1415 */
	       obj_t aux_5644;
	       aux_5644 =
		  CNST_TABLE_REF(((long) 9));
	       res1435_1602 =
		  make_struct(aux_5644, ((long) 6), BUNSPEC);
	    }
	    STRUCT_SET(res1435_1602, ((long) 0), BFALSE);
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5648;
	       aux_5648 =
		  (((funcall_bglt) CREF(obj1434_1599))->loc);
	       STRUCT_SET(res1435_1602, ((long) 1), aux_5648);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5651;
	       {	/* Ast/node.scm 74 */
		  type_bglt aux_5652;
		  aux_5652 =
		     (((funcall_bglt) CREF(obj1434_1599))->type);
		  aux_5651 =
		     (obj_t) (aux_5652);
	       }
	       STRUCT_SET(res1435_1602, ((long) 2), aux_5651);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5656;
	       {	/* Ast/node.scm 74 */
		  node_bglt aux_5657;
		  aux_5657 =
		     (((funcall_bglt) CREF(obj1434_1599))->fun);
		  aux_5656 =
		     (obj_t) (aux_5657);
	       }
	       STRUCT_SET(res1435_1602, ((long) 3), aux_5656);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5661;
	       aux_5661 =
		  (((funcall_bglt) CREF(obj1434_1599))->args);
	       STRUCT_SET(res1435_1602, ((long) 4), aux_5661);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5664;
	       aux_5664 =
		  (((funcall_bglt) CREF(obj1434_1599))->strength);
	       STRUCT_SET(res1435_1602, ((long) 5), aux_5664);
	    }
	    return res1435_1602;
	 }
      }
   }
}



/* struct+object->object-pragma1984 */
obj_t 
struct_object__object_pragma1984_236_ast_node(obj_t env_3650, obj_t o_3651, obj_t s_3652)
{
   AN_OBJECT;
   {	/* Ast/node.scm 85 */
      {
	 pragma_bglt o_1586;
	 obj_t s_1587;
	 {	/* Ast/node.scm 85 */
	    pragma_bglt aux_5668;
	    o_1586 =
	       (pragma_bglt) (o_3651);
	    s_1587 = s_3652;
	    {	/* Ast/node.scm 85 */
	       obj_t aux_5671;
	       object_bglt aux_5669;
	       aux_5671 =
		  STRUCT_REF(s_1587, ((long) 0));
	       aux_5669 =
		  (object_bglt) (o_1586);
	       OBJECT_WIDENING_SET(aux_5669, aux_5671);
	    }
	    {	/* Ast/node.scm 85 */
	       obj_t v1473_1591;
	       v1473_1591 =
		  STRUCT_REF(s_1587, ((long) 1));
	       ((((pragma_bglt) CREF(o_1586))->loc) = ((obj_t) v1473_1591), BUNSPEC);
	    }
	    {	/* Ast/node.scm 85 */
	       type_bglt v1477_1592;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_5676;
		  aux_5676 =
		     STRUCT_REF(s_1587, ((long) 2));
		  v1477_1592 =
		     (type_bglt) (aux_5676);
	       }
	       ((((pragma_bglt) CREF(o_1586))->type) = ((type_bglt) v1477_1592), BUNSPEC);
	    }
	    {	/* Ast/node.scm 85 */
	       obj_t v1481_1593;
	       v1481_1593 =
		  STRUCT_REF(s_1587, ((long) 3));
	       ((((pragma_bglt) CREF(o_1586))->side_effect__165) = ((obj_t) v1481_1593), BUNSPEC);
	    }
	    {	/* Ast/node.scm 85 */
	       obj_t v1485_1594;
	       v1485_1594 =
		  STRUCT_REF(s_1587, ((long) 4));
	       ((((pragma_bglt) CREF(o_1586))->key) = ((obj_t) v1485_1594), BUNSPEC);
	    }
	    {	/* Ast/node.scm 85 */
	       obj_t v1489_1595;
	       v1489_1595 =
		  STRUCT_REF(s_1587, ((long) 5));
	       ((((pragma_bglt) CREF(o_1586))->format) = ((obj_t) v1489_1595), BUNSPEC);
	    }
	    {	/* Ast/node.scm 85 */
	       obj_t v1493_1596;
	       v1493_1596 =
		  STRUCT_REF(s_1587, ((long) 6));
	       ((((pragma_bglt) CREF(o_1586))->args) = ((obj_t) v1493_1596), BUNSPEC);
	    }
	    aux_5668 = o_1586;
	    return
	       (obj_t) (aux_5668);
	 }
      }
   }
}



/* object->struct-pragma1982 */
obj_t 
object__struct_pragma1982_170_ast_node(obj_t env_3653, obj_t obj1469_3654)
{
   AN_OBJECT;
   {	/* Ast/node.scm 85 */
      {
	 pragma_bglt obj1469_1568;
	 obj1469_1568 =
	    (pragma_bglt) (obj1469_3654);
	 {	/* Ast/node.scm 85 */
	    obj_t res1470_1571;
	    {	/* ./Llib/struct.scm 1415 */
	       obj_t aux_5690;
	       aux_5690 =
		  CNST_TABLE_REF(((long) 10));
	       res1470_1571 =
		  make_struct(aux_5690, ((long) 7), BUNSPEC);
	    }
	    STRUCT_SET(res1470_1571, ((long) 0), BFALSE);
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5694;
	       aux_5694 =
		  (((pragma_bglt) CREF(obj1469_1568))->loc);
	       STRUCT_SET(res1470_1571, ((long) 1), aux_5694);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5697;
	       {	/* Ast/node.scm 85 */
		  type_bglt aux_5698;
		  aux_5698 =
		     (((pragma_bglt) CREF(obj1469_1568))->type);
		  aux_5697 =
		     (obj_t) (aux_5698);
	       }
	       STRUCT_SET(res1470_1571, ((long) 2), aux_5697);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5702;
	       aux_5702 =
		  (((pragma_bglt) CREF(obj1469_1568))->side_effect__165);
	       STRUCT_SET(res1470_1571, ((long) 3), aux_5702);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5705;
	       aux_5705 =
		  (((pragma_bglt) CREF(obj1469_1568))->key);
	       STRUCT_SET(res1470_1571, ((long) 4), aux_5705);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5708;
	       aux_5708 =
		  (((pragma_bglt) CREF(obj1469_1568))->format);
	       STRUCT_SET(res1470_1571, ((long) 5), aux_5708);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5711;
	       aux_5711 =
		  (((pragma_bglt) CREF(obj1469_1568))->args);
	       STRUCT_SET(res1470_1571, ((long) 6), aux_5711);
	    }
	    return res1470_1571;
	 }
      }
   }
}



/* struct+object->object-cast1980 */
obj_t 
struct_object__object_cast1980_80_ast_node(obj_t env_3655, obj_t o_3656, obj_t s_3657)
{
   AN_OBJECT;
   {	/* Ast/node.scm 90 */
      {
	 cast_bglt o_1558;
	 obj_t s_1559;
	 {	/* Ast/node.scm 90 */
	    cast_bglt aux_5715;
	    o_1558 =
	       (cast_bglt) (o_3656);
	    s_1559 = s_3657;
	    {	/* Ast/node.scm 90 */
	       obj_t aux_5718;
	       object_bglt aux_5716;
	       aux_5718 =
		  STRUCT_REF(s_1559, ((long) 0));
	       aux_5716 =
		  (object_bglt) (o_1558);
	       OBJECT_WIDENING_SET(aux_5716, aux_5718);
	    }
	    {	/* Ast/node.scm 90 */
	       obj_t v1507_1563;
	       v1507_1563 =
		  STRUCT_REF(s_1559, ((long) 1));
	       ((((cast_bglt) CREF(o_1558))->loc) = ((obj_t) v1507_1563), BUNSPEC);
	    }
	    {	/* Ast/node.scm 90 */
	       type_bglt v1511_1564;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_5723;
		  aux_5723 =
		     STRUCT_REF(s_1559, ((long) 2));
		  v1511_1564 =
		     (type_bglt) (aux_5723);
	       }
	       ((((cast_bglt) CREF(o_1558))->type) = ((type_bglt) v1511_1564), BUNSPEC);
	    }
	    {	/* Ast/node.scm 90 */
	       node_bglt v1515_1565;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_5727;
		  aux_5727 =
		     STRUCT_REF(s_1559, ((long) 3));
		  v1515_1565 =
		     (node_bglt) (aux_5727);
	       }
	       ((((cast_bglt) CREF(o_1558))->arg) = ((node_bglt) v1515_1565), BUNSPEC);
	    }
	    aux_5715 = o_1558;
	    return
	       (obj_t) (aux_5715);
	 }
      }
   }
}



/* object->struct-cast1978 */
obj_t 
object__struct_cast1978_156_ast_node(obj_t env_3658, obj_t obj1503_3659)
{
   AN_OBJECT;
   {	/* Ast/node.scm 90 */
      {
	 cast_bglt obj1503_1546;
	 obj1503_1546 =
	    (cast_bglt) (obj1503_3659);
	 {	/* Ast/node.scm 90 */
	    obj_t res1504_1549;
	    {	/* ./Llib/struct.scm 1415 */
	       obj_t aux_5733;
	       aux_5733 =
		  CNST_TABLE_REF(((long) 11));
	       res1504_1549 =
		  make_struct(aux_5733, ((long) 4), BUNSPEC);
	    }
	    STRUCT_SET(res1504_1549, ((long) 0), BFALSE);
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5737;
	       aux_5737 =
		  (((cast_bglt) CREF(obj1503_1546))->loc);
	       STRUCT_SET(res1504_1549, ((long) 1), aux_5737);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5740;
	       {	/* Ast/node.scm 90 */
		  type_bglt aux_5741;
		  aux_5741 =
		     (((cast_bglt) CREF(obj1503_1546))->type);
		  aux_5740 =
		     (obj_t) (aux_5741);
	       }
	       STRUCT_SET(res1504_1549, ((long) 2), aux_5740);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5745;
	       {	/* Ast/node.scm 90 */
		  node_bglt aux_5746;
		  aux_5746 =
		     (((cast_bglt) CREF(obj1503_1546))->arg);
		  aux_5745 =
		     (obj_t) (aux_5746);
	       }
	       STRUCT_SET(res1504_1549, ((long) 3), aux_5745);
	    }
	    return res1504_1549;
	 }
      }
   }
}



/* struct+object->object-setq1976 */
obj_t 
struct_object__object_setq1976_146_ast_node(obj_t env_3660, obj_t o_3661, obj_t s_3662)
{
   AN_OBJECT;
   {	/* Ast/node.scm 95 */
      {
	 setq_bglt o_1535;
	 obj_t s_1536;
	 {	/* Ast/node.scm 95 */
	    setq_bglt aux_5751;
	    o_1535 =
	       (setq_bglt) (o_3661);
	    s_1536 = s_3662;
	    {	/* Ast/node.scm 95 */
	       obj_t aux_5754;
	       object_bglt aux_5752;
	       aux_5754 =
		  STRUCT_REF(s_1536, ((long) 0));
	       aux_5752 =
		  (object_bglt) (o_1535);
	       OBJECT_WIDENING_SET(aux_5752, aux_5754);
	    }
	    {	/* Ast/node.scm 95 */
	       obj_t v1531_1540;
	       v1531_1540 =
		  STRUCT_REF(s_1536, ((long) 1));
	       ((((setq_bglt) CREF(o_1535))->loc) = ((obj_t) v1531_1540), BUNSPEC);
	    }
	    {	/* Ast/node.scm 95 */
	       type_bglt v1535_1541;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_5759;
		  aux_5759 =
		     STRUCT_REF(s_1536, ((long) 2));
		  v1535_1541 =
		     (type_bglt) (aux_5759);
	       }
	       ((((setq_bglt) CREF(o_1535))->type) = ((type_bglt) v1535_1541), BUNSPEC);
	    }
	    {	/* Ast/node.scm 95 */
	       var_bglt v1539_1542;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_5763;
		  aux_5763 =
		     STRUCT_REF(s_1536, ((long) 3));
		  v1539_1542 =
		     (var_bglt) (aux_5763);
	       }
	       ((((setq_bglt) CREF(o_1535))->var) = ((var_bglt) v1539_1542), BUNSPEC);
	    }
	    {	/* Ast/node.scm 95 */
	       node_bglt v1543_1543;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_5767;
		  aux_5767 =
		     STRUCT_REF(s_1536, ((long) 4));
		  v1543_1543 =
		     (node_bglt) (aux_5767);
	       }
	       ((((setq_bglt) CREF(o_1535))->value) = ((node_bglt) v1543_1543), BUNSPEC);
	    }
	    aux_5751 = o_1535;
	    return
	       (obj_t) (aux_5751);
	 }
      }
   }
}



/* object->struct-setq1974 */
obj_t 
object__struct_setq1974_190_ast_node(obj_t env_3663, obj_t obj1527_3664)
{
   AN_OBJECT;
   {	/* Ast/node.scm 95 */
      {
	 setq_bglt obj1527_1521;
	 obj1527_1521 =
	    (setq_bglt) (obj1527_3664);
	 {	/* Ast/node.scm 95 */
	    obj_t res1528_1524;
	    {	/* ./Llib/struct.scm 1415 */
	       obj_t aux_5773;
	       aux_5773 =
		  CNST_TABLE_REF(((long) 12));
	       res1528_1524 =
		  make_struct(aux_5773, ((long) 5), BUNSPEC);
	    }
	    STRUCT_SET(res1528_1524, ((long) 0), BFALSE);
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5777;
	       aux_5777 =
		  (((setq_bglt) CREF(obj1527_1521))->loc);
	       STRUCT_SET(res1528_1524, ((long) 1), aux_5777);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5780;
	       {	/* Ast/node.scm 95 */
		  type_bglt aux_5781;
		  aux_5781 =
		     (((setq_bglt) CREF(obj1527_1521))->type);
		  aux_5780 =
		     (obj_t) (aux_5781);
	       }
	       STRUCT_SET(res1528_1524, ((long) 2), aux_5780);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5785;
	       {	/* Ast/node.scm 95 */
		  var_bglt aux_5786;
		  aux_5786 =
		     (((setq_bglt) CREF(obj1527_1521))->var);
		  aux_5785 =
		     (obj_t) (aux_5786);
	       }
	       STRUCT_SET(res1528_1524, ((long) 3), aux_5785);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5790;
	       {	/* Ast/node.scm 95 */
		  node_bglt aux_5791;
		  aux_5791 =
		     (((setq_bglt) CREF(obj1527_1521))->value);
		  aux_5790 =
		     (obj_t) (aux_5791);
	       }
	       STRUCT_SET(res1528_1524, ((long) 4), aux_5790);
	    }
	    return res1528_1524;
	 }
      }
   }
}



/* struct+object->object-conditional1972 */
obj_t 
struct_object__object_conditional1972_48_ast_node(obj_t env_3665, obj_t o_3666, obj_t s_3667)
{
   AN_OBJECT;
   {	/* Ast/node.scm 102 */
      {
	 conditional_bglt o_1507;
	 obj_t s_1508;
	 {	/* Ast/node.scm 102 */
	    conditional_bglt aux_5796;
	    o_1507 =
	       (conditional_bglt) (o_3666);
	    s_1508 = s_3667;
	    {	/* Ast/node.scm 102 */
	       obj_t aux_5799;
	       object_bglt aux_5797;
	       aux_5799 =
		  STRUCT_REF(s_1508, ((long) 0));
	       aux_5797 =
		  (object_bglt) (o_1507);
	       OBJECT_WIDENING_SET(aux_5797, aux_5799);
	    }
	    {	/* Ast/node.scm 102 */
	       obj_t v1565_1512;
	       v1565_1512 =
		  STRUCT_REF(s_1508, ((long) 1));
	       ((((conditional_bglt) CREF(o_1507))->loc) = ((obj_t) v1565_1512), BUNSPEC);
	    }
	    {	/* Ast/node.scm 102 */
	       type_bglt v1569_1513;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_5804;
		  aux_5804 =
		     STRUCT_REF(s_1508, ((long) 2));
		  v1569_1513 =
		     (type_bglt) (aux_5804);
	       }
	       ((((conditional_bglt) CREF(o_1507))->type) = ((type_bglt) v1569_1513), BUNSPEC);
	    }
	    {	/* Ast/node.scm 102 */
	       obj_t v1573_1514;
	       v1573_1514 =
		  STRUCT_REF(s_1508, ((long) 3));
	       ((((conditional_bglt) CREF(o_1507))->side_effect__165) = ((obj_t) v1573_1514), BUNSPEC);
	    }
	    {	/* Ast/node.scm 102 */
	       obj_t v1577_1515;
	       v1577_1515 =
		  STRUCT_REF(s_1508, ((long) 4));
	       ((((conditional_bglt) CREF(o_1507))->key) = ((obj_t) v1577_1515), BUNSPEC);
	    }
	    {	/* Ast/node.scm 102 */
	       node_bglt v1581_1516;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_5812;
		  aux_5812 =
		     STRUCT_REF(s_1508, ((long) 5));
		  v1581_1516 =
		     (node_bglt) (aux_5812);
	       }
	       ((((conditional_bglt) CREF(o_1507))->test) = ((node_bglt) v1581_1516), BUNSPEC);
	    }
	    {	/* Ast/node.scm 102 */
	       node_bglt v1585_1517;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_5816;
		  aux_5816 =
		     STRUCT_REF(s_1508, ((long) 6));
		  v1585_1517 =
		     (node_bglt) (aux_5816);
	       }
	       ((((conditional_bglt) CREF(o_1507))->true) = ((node_bglt) v1585_1517), BUNSPEC);
	    }
	    {	/* Ast/node.scm 102 */
	       node_bglt v1589_1518;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_5820;
		  aux_5820 =
		     STRUCT_REF(s_1508, ((long) 7));
		  v1589_1518 =
		     (node_bglt) (aux_5820);
	       }
	       ((((conditional_bglt) CREF(o_1507))->false) = ((node_bglt) v1589_1518), BUNSPEC);
	    }
	    aux_5796 = o_1507;
	    return
	       (obj_t) (aux_5796);
	 }
      }
   }
}



/* object->struct-conditional1970 */
obj_t 
object__struct_conditional1970_196_ast_node(obj_t env_3668, obj_t obj1561_3669)
{
   AN_OBJECT;
   {	/* Ast/node.scm 102 */
      {
	 conditional_bglt obj1561_1487;
	 obj1561_1487 =
	    (conditional_bglt) (obj1561_3669);
	 {	/* Ast/node.scm 102 */
	    obj_t res1562_1490;
	    {	/* ./Llib/struct.scm 1415 */
	       obj_t aux_5826;
	       aux_5826 =
		  CNST_TABLE_REF(((long) 13));
	       res1562_1490 =
		  make_struct(aux_5826, ((long) 8), BUNSPEC);
	    }
	    STRUCT_SET(res1562_1490, ((long) 0), BFALSE);
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5830;
	       aux_5830 =
		  (((conditional_bglt) CREF(obj1561_1487))->loc);
	       STRUCT_SET(res1562_1490, ((long) 1), aux_5830);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5833;
	       {	/* Ast/node.scm 102 */
		  type_bglt aux_5834;
		  aux_5834 =
		     (((conditional_bglt) CREF(obj1561_1487))->type);
		  aux_5833 =
		     (obj_t) (aux_5834);
	       }
	       STRUCT_SET(res1562_1490, ((long) 2), aux_5833);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5838;
	       aux_5838 =
		  (((conditional_bglt) CREF(obj1561_1487))->side_effect__165);
	       STRUCT_SET(res1562_1490, ((long) 3), aux_5838);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5841;
	       aux_5841 =
		  (((conditional_bglt) CREF(obj1561_1487))->key);
	       STRUCT_SET(res1562_1490, ((long) 4), aux_5841);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5844;
	       {	/* Ast/node.scm 102 */
		  node_bglt aux_5845;
		  aux_5845 =
		     (((conditional_bglt) CREF(obj1561_1487))->test);
		  aux_5844 =
		     (obj_t) (aux_5845);
	       }
	       STRUCT_SET(res1562_1490, ((long) 5), aux_5844);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5849;
	       {	/* Ast/node.scm 102 */
		  node_bglt aux_5850;
		  aux_5850 =
		     (((conditional_bglt) CREF(obj1561_1487))->true);
		  aux_5849 =
		     (obj_t) (aux_5850);
	       }
	       STRUCT_SET(res1562_1490, ((long) 6), aux_5849);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5854;
	       {	/* Ast/node.scm 102 */
		  node_bglt aux_5855;
		  aux_5855 =
		     (((conditional_bglt) CREF(obj1561_1487))->false);
		  aux_5854 =
		     (obj_t) (aux_5855);
	       }
	       STRUCT_SET(res1562_1490, ((long) 7), aux_5854);
	    }
	    return res1562_1490;
	 }
      }
   }
}



/* struct+object->object-fail1968 */
obj_t 
struct_object__object_fail1968_208_ast_node(obj_t env_3670, obj_t o_3671, obj_t s_3672)
{
   AN_OBJECT;
   {	/* Ast/node.scm 111 */
      {
	 fail_bglt o_1475;
	 obj_t s_1476;
	 {	/* Ast/node.scm 111 */
	    fail_bglt aux_5860;
	    o_1475 =
	       (fail_bglt) (o_3671);
	    s_1476 = s_3672;
	    {	/* Ast/node.scm 111 */
	       obj_t aux_5863;
	       object_bglt aux_5861;
	       aux_5863 =
		  STRUCT_REF(s_1476, ((long) 0));
	       aux_5861 =
		  (object_bglt) (o_1475);
	       OBJECT_WIDENING_SET(aux_5861, aux_5863);
	    }
	    {	/* Ast/node.scm 111 */
	       obj_t v1607_1480;
	       v1607_1480 =
		  STRUCT_REF(s_1476, ((long) 1));
	       ((((fail_bglt) CREF(o_1475))->loc) = ((obj_t) v1607_1480), BUNSPEC);
	    }
	    {	/* Ast/node.scm 111 */
	       type_bglt v1611_1481;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_5868;
		  aux_5868 =
		     STRUCT_REF(s_1476, ((long) 2));
		  v1611_1481 =
		     (type_bglt) (aux_5868);
	       }
	       ((((fail_bglt) CREF(o_1475))->type) = ((type_bglt) v1611_1481), BUNSPEC);
	    }
	    {	/* Ast/node.scm 111 */
	       node_bglt v1615_1482;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_5872;
		  aux_5872 =
		     STRUCT_REF(s_1476, ((long) 3));
		  v1615_1482 =
		     (node_bglt) (aux_5872);
	       }
	       ((((fail_bglt) CREF(o_1475))->proc) = ((node_bglt) v1615_1482), BUNSPEC);
	    }
	    {	/* Ast/node.scm 111 */
	       node_bglt v1619_1483;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_5876;
		  aux_5876 =
		     STRUCT_REF(s_1476, ((long) 4));
		  v1619_1483 =
		     (node_bglt) (aux_5876);
	       }
	       ((((fail_bglt) CREF(o_1475))->msg) = ((node_bglt) v1619_1483), BUNSPEC);
	    }
	    {	/* Ast/node.scm 111 */
	       node_bglt v1623_1484;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_5880;
		  aux_5880 =
		     STRUCT_REF(s_1476, ((long) 5));
		  v1623_1484 =
		     (node_bglt) (aux_5880);
	       }
	       ((((fail_bglt) CREF(o_1475))->obj) = ((node_bglt) v1623_1484), BUNSPEC);
	    }
	    aux_5860 = o_1475;
	    return
	       (obj_t) (aux_5860);
	 }
      }
   }
}



/* object->struct-fail1966 */
obj_t 
object__struct_fail1966_121_ast_node(obj_t env_3673, obj_t obj1603_3674)
{
   AN_OBJECT;
   {	/* Ast/node.scm 111 */
      {
	 fail_bglt obj1603_1459;
	 obj1603_1459 =
	    (fail_bglt) (obj1603_3674);
	 {	/* Ast/node.scm 111 */
	    obj_t res1604_1462;
	    {	/* ./Llib/struct.scm 1415 */
	       obj_t aux_5886;
	       aux_5886 =
		  CNST_TABLE_REF(((long) 14));
	       res1604_1462 =
		  make_struct(aux_5886, ((long) 6), BUNSPEC);
	    }
	    STRUCT_SET(res1604_1462, ((long) 0), BFALSE);
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5890;
	       aux_5890 =
		  (((fail_bglt) CREF(obj1603_1459))->loc);
	       STRUCT_SET(res1604_1462, ((long) 1), aux_5890);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5893;
	       {	/* Ast/node.scm 111 */
		  type_bglt aux_5894;
		  aux_5894 =
		     (((fail_bglt) CREF(obj1603_1459))->type);
		  aux_5893 =
		     (obj_t) (aux_5894);
	       }
	       STRUCT_SET(res1604_1462, ((long) 2), aux_5893);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5898;
	       {	/* Ast/node.scm 111 */
		  node_bglt aux_5899;
		  aux_5899 =
		     (((fail_bglt) CREF(obj1603_1459))->proc);
		  aux_5898 =
		     (obj_t) (aux_5899);
	       }
	       STRUCT_SET(res1604_1462, ((long) 3), aux_5898);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5903;
	       {	/* Ast/node.scm 111 */
		  node_bglt aux_5904;
		  aux_5904 =
		     (((fail_bglt) CREF(obj1603_1459))->msg);
		  aux_5903 =
		     (obj_t) (aux_5904);
	       }
	       STRUCT_SET(res1604_1462, ((long) 4), aux_5903);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5908;
	       {	/* Ast/node.scm 111 */
		  node_bglt aux_5909;
		  aux_5909 =
		     (((fail_bglt) CREF(obj1603_1459))->obj);
		  aux_5908 =
		     (obj_t) (aux_5909);
	       }
	       STRUCT_SET(res1604_1462, ((long) 5), aux_5908);
	    }
	    return res1604_1462;
	 }
      }
   }
}



/* struct+object->object-select1964 */
obj_t 
struct_object__object_select1964_220_ast_node(obj_t env_3675, obj_t o_3676, obj_t s_3677)
{
   AN_OBJECT;
   {	/* Ast/node.scm 118 */
      {
	 select_bglt o_1445;
	 obj_t s_1446;
	 {	/* Ast/node.scm 118 */
	    select_bglt aux_5914;
	    o_1445 =
	       (select_bglt) (o_3676);
	    s_1446 = s_3677;
	    {	/* Ast/node.scm 118 */
	       obj_t aux_5917;
	       object_bglt aux_5915;
	       aux_5917 =
		  STRUCT_REF(s_1446, ((long) 0));
	       aux_5915 =
		  (object_bglt) (o_1445);
	       OBJECT_WIDENING_SET(aux_5915, aux_5917);
	    }
	    {	/* Ast/node.scm 118 */
	       obj_t v1643_1450;
	       v1643_1450 =
		  STRUCT_REF(s_1446, ((long) 1));
	       ((((select_bglt) CREF(o_1445))->loc) = ((obj_t) v1643_1450), BUNSPEC);
	    }
	    {	/* Ast/node.scm 118 */
	       type_bglt v1647_1451;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_5922;
		  aux_5922 =
		     STRUCT_REF(s_1446, ((long) 2));
		  v1647_1451 =
		     (type_bglt) (aux_5922);
	       }
	       ((((select_bglt) CREF(o_1445))->type) = ((type_bglt) v1647_1451), BUNSPEC);
	    }
	    {	/* Ast/node.scm 118 */
	       obj_t v1651_1452;
	       v1651_1452 =
		  STRUCT_REF(s_1446, ((long) 3));
	       ((((select_bglt) CREF(o_1445))->side_effect__165) = ((obj_t) v1651_1452), BUNSPEC);
	    }
	    {	/* Ast/node.scm 118 */
	       obj_t v1655_1453;
	       v1655_1453 =
		  STRUCT_REF(s_1446, ((long) 4));
	       ((((select_bglt) CREF(o_1445))->key) = ((obj_t) v1655_1453), BUNSPEC);
	    }
	    {	/* Ast/node.scm 118 */
	       node_bglt v1659_1454;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_5930;
		  aux_5930 =
		     STRUCT_REF(s_1446, ((long) 5));
		  v1659_1454 =
		     (node_bglt) (aux_5930);
	       }
	       ((((select_bglt) CREF(o_1445))->test) = ((node_bglt) v1659_1454), BUNSPEC);
	    }
	    {	/* Ast/node.scm 118 */
	       obj_t v1663_1455;
	       v1663_1455 =
		  STRUCT_REF(s_1446, ((long) 6));
	       ((((select_bglt) CREF(o_1445))->clauses) = ((obj_t) v1663_1455), BUNSPEC);
	    }
	    {	/* Ast/node.scm 118 */
	       type_bglt v1667_1456;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_5936;
		  aux_5936 =
		     STRUCT_REF(s_1446, ((long) 7));
		  v1667_1456 =
		     (type_bglt) (aux_5936);
	       }
	       ((((select_bglt) CREF(o_1445))->item_type_130) = ((type_bglt) v1667_1456), BUNSPEC);
	    }
	    aux_5914 = o_1445;
	    return
	       (obj_t) (aux_5914);
	 }
      }
   }
}



/* object->struct-select1962 */
obj_t 
object__struct_select1962_38_ast_node(obj_t env_3678, obj_t obj1639_3679)
{
   AN_OBJECT;
   {	/* Ast/node.scm 118 */
      {
	 select_bglt obj1639_1425;
	 obj1639_1425 =
	    (select_bglt) (obj1639_3679);
	 {	/* Ast/node.scm 118 */
	    obj_t res1640_1428;
	    {	/* ./Llib/struct.scm 1415 */
	       obj_t aux_5942;
	       aux_5942 =
		  CNST_TABLE_REF(((long) 15));
	       res1640_1428 =
		  make_struct(aux_5942, ((long) 8), BUNSPEC);
	    }
	    STRUCT_SET(res1640_1428, ((long) 0), BFALSE);
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5946;
	       aux_5946 =
		  (((select_bglt) CREF(obj1639_1425))->loc);
	       STRUCT_SET(res1640_1428, ((long) 1), aux_5946);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5949;
	       {	/* Ast/node.scm 118 */
		  type_bglt aux_5950;
		  aux_5950 =
		     (((select_bglt) CREF(obj1639_1425))->type);
		  aux_5949 =
		     (obj_t) (aux_5950);
	       }
	       STRUCT_SET(res1640_1428, ((long) 2), aux_5949);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5954;
	       aux_5954 =
		  (((select_bglt) CREF(obj1639_1425))->side_effect__165);
	       STRUCT_SET(res1640_1428, ((long) 3), aux_5954);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5957;
	       aux_5957 =
		  (((select_bglt) CREF(obj1639_1425))->key);
	       STRUCT_SET(res1640_1428, ((long) 4), aux_5957);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5960;
	       {	/* Ast/node.scm 118 */
		  node_bglt aux_5961;
		  aux_5961 =
		     (((select_bglt) CREF(obj1639_1425))->test);
		  aux_5960 =
		     (obj_t) (aux_5961);
	       }
	       STRUCT_SET(res1640_1428, ((long) 5), aux_5960);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5965;
	       aux_5965 =
		  (((select_bglt) CREF(obj1639_1425))->clauses);
	       STRUCT_SET(res1640_1428, ((long) 6), aux_5965);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5968;
	       {	/* Ast/node.scm 118 */
		  type_bglt aux_5969;
		  aux_5969 =
		     (((select_bglt) CREF(obj1639_1425))->item_type_130);
		  aux_5968 =
		     (obj_t) (aux_5969);
	       }
	       STRUCT_SET(res1640_1428, ((long) 7), aux_5968);
	    }
	    return res1640_1428;
	 }
      }
   }
}



/* struct+object->object-let-fun1960 */
obj_t 
struct_object__object_let_fun1960_153_ast_node(obj_t env_3680, obj_t o_3681, obj_t s_3682)
{
   AN_OBJECT;
   {	/* Ast/node.scm 127 */
      {
	 let_fun_218_bglt o_1412;
	 obj_t s_1413;
	 {	/* Ast/node.scm 127 */
	    let_fun_218_bglt aux_5974;
	    o_1412 =
	       (let_fun_218_bglt) (o_3681);
	    s_1413 = s_3682;
	    {	/* Ast/node.scm 127 */
	       obj_t aux_5977;
	       object_bglt aux_5975;
	       aux_5977 =
		  STRUCT_REF(s_1413, ((long) 0));
	       aux_5975 =
		  (object_bglt) (o_1412);
	       OBJECT_WIDENING_SET(aux_5975, aux_5977);
	    }
	    {	/* Ast/node.scm 127 */
	       obj_t v1687_1417;
	       v1687_1417 =
		  STRUCT_REF(s_1413, ((long) 1));
	       ((((let_fun_218_bglt) CREF(o_1412))->loc) = ((obj_t) v1687_1417), BUNSPEC);
	    }
	    {	/* Ast/node.scm 127 */
	       type_bglt v1691_1418;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_5982;
		  aux_5982 =
		     STRUCT_REF(s_1413, ((long) 2));
		  v1691_1418 =
		     (type_bglt) (aux_5982);
	       }
	       ((((let_fun_218_bglt) CREF(o_1412))->type) = ((type_bglt) v1691_1418), BUNSPEC);
	    }
	    {	/* Ast/node.scm 127 */
	       obj_t v1695_1419;
	       v1695_1419 =
		  STRUCT_REF(s_1413, ((long) 3));
	       ((((let_fun_218_bglt) CREF(o_1412))->side_effect__165) = ((obj_t) v1695_1419), BUNSPEC);
	    }
	    {	/* Ast/node.scm 127 */
	       obj_t v1699_1420;
	       v1699_1420 =
		  STRUCT_REF(s_1413, ((long) 4));
	       ((((let_fun_218_bglt) CREF(o_1412))->key) = ((obj_t) v1699_1420), BUNSPEC);
	    }
	    {	/* Ast/node.scm 127 */
	       obj_t v1703_1421;
	       v1703_1421 =
		  STRUCT_REF(s_1413, ((long) 5));
	       ((((let_fun_218_bglt) CREF(o_1412))->locals) = ((obj_t) v1703_1421), BUNSPEC);
	    }
	    {	/* Ast/node.scm 127 */
	       node_bglt v1707_1422;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_5992;
		  aux_5992 =
		     STRUCT_REF(s_1413, ((long) 6));
		  v1707_1422 =
		     (node_bglt) (aux_5992);
	       }
	       ((((let_fun_218_bglt) CREF(o_1412))->body) = ((node_bglt) v1707_1422), BUNSPEC);
	    }
	    aux_5974 = o_1412;
	    return
	       (obj_t) (aux_5974);
	 }
      }
   }
}



/* object->struct-let-fun1958 */
obj_t 
object__struct_let_fun1958_74_ast_node(obj_t env_3683, obj_t obj1683_3684)
{
   AN_OBJECT;
   {	/* Ast/node.scm 127 */
      {
	 let_fun_218_bglt obj1683_1394;
	 obj1683_1394 =
	    (let_fun_218_bglt) (obj1683_3684);
	 {	/* Ast/node.scm 127 */
	    obj_t res1684_1397;
	    {	/* ./Llib/struct.scm 1415 */
	       obj_t aux_5998;
	       aux_5998 =
		  CNST_TABLE_REF(((long) 16));
	       res1684_1397 =
		  make_struct(aux_5998, ((long) 7), BUNSPEC);
	    }
	    STRUCT_SET(res1684_1397, ((long) 0), BFALSE);
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_6002;
	       aux_6002 =
		  (((let_fun_218_bglt) CREF(obj1683_1394))->loc);
	       STRUCT_SET(res1684_1397, ((long) 1), aux_6002);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_6005;
	       {	/* Ast/node.scm 127 */
		  type_bglt aux_6006;
		  aux_6006 =
		     (((let_fun_218_bglt) CREF(obj1683_1394))->type);
		  aux_6005 =
		     (obj_t) (aux_6006);
	       }
	       STRUCT_SET(res1684_1397, ((long) 2), aux_6005);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_6010;
	       aux_6010 =
		  (((let_fun_218_bglt) CREF(obj1683_1394))->side_effect__165);
	       STRUCT_SET(res1684_1397, ((long) 3), aux_6010);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_6013;
	       aux_6013 =
		  (((let_fun_218_bglt) CREF(obj1683_1394))->key);
	       STRUCT_SET(res1684_1397, ((long) 4), aux_6013);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_6016;
	       aux_6016 =
		  (((let_fun_218_bglt) CREF(obj1683_1394))->locals);
	       STRUCT_SET(res1684_1397, ((long) 5), aux_6016);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_6019;
	       {	/* Ast/node.scm 127 */
		  node_bglt aux_6020;
		  aux_6020 =
		     (((let_fun_218_bglt) CREF(obj1683_1394))->body);
		  aux_6019 =
		     (obj_t) (aux_6020);
	       }
	       STRUCT_SET(res1684_1397, ((long) 6), aux_6019);
	    }
	    return res1684_1397;
	 }
      }
   }
}



/* struct+object->object-let-var1956 */
obj_t 
struct_object__object_let_var1956_48_ast_node(obj_t env_3685, obj_t o_3686, obj_t s_3687)
{
   AN_OBJECT;
   {	/* Ast/node.scm 134 */
      {
	 let_var_6_bglt o_1380;
	 obj_t s_1381;
	 {	/* Ast/node.scm 134 */
	    let_var_6_bglt aux_6025;
	    o_1380 =
	       (let_var_6_bglt) (o_3686);
	    s_1381 = s_3687;
	    {	/* Ast/node.scm 134 */
	       obj_t aux_6028;
	       object_bglt aux_6026;
	       aux_6028 =
		  STRUCT_REF(s_1381, ((long) 0));
	       aux_6026 =
		  (object_bglt) (o_1380);
	       OBJECT_WIDENING_SET(aux_6026, aux_6028);
	    }
	    {	/* Ast/node.scm 134 */
	       obj_t v1729_1385;
	       v1729_1385 =
		  STRUCT_REF(s_1381, ((long) 1));
	       ((((let_var_6_bglt) CREF(o_1380))->loc) = ((obj_t) v1729_1385), BUNSPEC);
	    }
	    {	/* Ast/node.scm 134 */
	       type_bglt v1733_1386;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_6033;
		  aux_6033 =
		     STRUCT_REF(s_1381, ((long) 2));
		  v1733_1386 =
		     (type_bglt) (aux_6033);
	       }
	       ((((let_var_6_bglt) CREF(o_1380))->type) = ((type_bglt) v1733_1386), BUNSPEC);
	    }
	    {	/* Ast/node.scm 134 */
	       obj_t v1737_1387;
	       v1737_1387 =
		  STRUCT_REF(s_1381, ((long) 3));
	       ((((let_var_6_bglt) CREF(o_1380))->side_effect__165) = ((obj_t) v1737_1387), BUNSPEC);
	    }
	    {	/* Ast/node.scm 134 */
	       obj_t v1741_1388;
	       v1741_1388 =
		  STRUCT_REF(s_1381, ((long) 4));
	       ((((let_var_6_bglt) CREF(o_1380))->key) = ((obj_t) v1741_1388), BUNSPEC);
	    }
	    {	/* Ast/node.scm 134 */
	       obj_t v1745_1389;
	       v1745_1389 =
		  STRUCT_REF(s_1381, ((long) 5));
	       ((((let_var_6_bglt) CREF(o_1380))->bindings) = ((obj_t) v1745_1389), BUNSPEC);
	    }
	    {	/* Ast/node.scm 134 */
	       node_bglt v1749_1390;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_6043;
		  aux_6043 =
		     STRUCT_REF(s_1381, ((long) 6));
		  v1749_1390 =
		     (node_bglt) (aux_6043);
	       }
	       ((((let_var_6_bglt) CREF(o_1380))->body) = ((node_bglt) v1749_1390), BUNSPEC);
	    }
	    {	/* Ast/node.scm 134 */
	       bool_t v1753_1391;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_6047;
		  aux_6047 =
		     STRUCT_REF(s_1381, ((long) 7));
		  v1753_1391 =
		     CBOOL(aux_6047);
	       }
	       ((((let_var_6_bglt) CREF(o_1380))->removable__42) = ((bool_t) v1753_1391), BUNSPEC);
	    }
	    aux_6025 = o_1380;
	    return
	       (obj_t) (aux_6025);
	 }
      }
   }
}



/* object->struct-let-var1954 */
obj_t 
object__struct_let_var1954_71_ast_node(obj_t env_3688, obj_t obj1725_3689)
{
   AN_OBJECT;
   {	/* Ast/node.scm 134 */
      {
	 let_var_6_bglt obj1725_1360;
	 obj1725_1360 =
	    (let_var_6_bglt) (obj1725_3689);
	 {	/* Ast/node.scm 134 */
	    obj_t res1726_1363;
	    {	/* ./Llib/struct.scm 1415 */
	       obj_t aux_6053;
	       aux_6053 =
		  CNST_TABLE_REF(((long) 17));
	       res1726_1363 =
		  make_struct(aux_6053, ((long) 8), BUNSPEC);
	    }
	    STRUCT_SET(res1726_1363, ((long) 0), BFALSE);
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_6057;
	       aux_6057 =
		  (((let_var_6_bglt) CREF(obj1725_1360))->loc);
	       STRUCT_SET(res1726_1363, ((long) 1), aux_6057);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_6060;
	       {	/* Ast/node.scm 134 */
		  type_bglt aux_6061;
		  aux_6061 =
		     (((let_var_6_bglt) CREF(obj1725_1360))->type);
		  aux_6060 =
		     (obj_t) (aux_6061);
	       }
	       STRUCT_SET(res1726_1363, ((long) 2), aux_6060);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_6065;
	       aux_6065 =
		  (((let_var_6_bglt) CREF(obj1725_1360))->side_effect__165);
	       STRUCT_SET(res1726_1363, ((long) 3), aux_6065);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_6068;
	       aux_6068 =
		  (((let_var_6_bglt) CREF(obj1725_1360))->key);
	       STRUCT_SET(res1726_1363, ((long) 4), aux_6068);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_6071;
	       aux_6071 =
		  (((let_var_6_bglt) CREF(obj1725_1360))->bindings);
	       STRUCT_SET(res1726_1363, ((long) 5), aux_6071);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_6074;
	       {	/* Ast/node.scm 134 */
		  node_bglt aux_6075;
		  aux_6075 =
		     (((let_var_6_bglt) CREF(obj1725_1360))->body);
		  aux_6074 =
		     (obj_t) (aux_6075);
	       }
	       STRUCT_SET(res1726_1363, ((long) 6), aux_6074);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_6079;
	       {	/* Ast/node.scm 134 */
		  bool_t aux_6080;
		  aux_6080 =
		     (((let_var_6_bglt) CREF(obj1725_1360))->removable__42);
		  aux_6079 =
		     BBOOL(aux_6080);
	       }
	       STRUCT_SET(res1726_1363, ((long) 7), aux_6079);
	    }
	    return res1726_1363;
	 }
      }
   }
}



/* struct+object->object-set-ex-it1952 */
obj_t 
struct_object__object_set_ex_it1952_191_ast_node(obj_t env_3690, obj_t o_3691, obj_t s_3692)
{
   AN_OBJECT;
   {	/* Ast/node.scm 143 */
      {
	 set_ex_it_116_bglt o_1349;
	 obj_t s_1350;
	 {	/* Ast/node.scm 143 */
	    set_ex_it_116_bglt aux_6085;
	    o_1349 =
	       (set_ex_it_116_bglt) (o_3691);
	    s_1350 = s_3692;
	    {	/* Ast/node.scm 143 */
	       obj_t aux_6088;
	       object_bglt aux_6086;
	       aux_6088 =
		  STRUCT_REF(s_1350, ((long) 0));
	       aux_6086 =
		  (object_bglt) (o_1349);
	       OBJECT_WIDENING_SET(aux_6086, aux_6088);
	    }
	    {	/* Ast/node.scm 143 */
	       obj_t v1770_1354;
	       v1770_1354 =
		  STRUCT_REF(s_1350, ((long) 1));
	       ((((set_ex_it_116_bglt) CREF(o_1349))->loc) = ((obj_t) v1770_1354), BUNSPEC);
	    }
	    {	/* Ast/node.scm 143 */
	       type_bglt v1774_1355;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_6093;
		  aux_6093 =
		     STRUCT_REF(s_1350, ((long) 2));
		  v1774_1355 =
		     (type_bglt) (aux_6093);
	       }
	       ((((set_ex_it_116_bglt) CREF(o_1349))->type) = ((type_bglt) v1774_1355), BUNSPEC);
	    }
	    {	/* Ast/node.scm 143 */
	       var_bglt v1778_1356;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_6097;
		  aux_6097 =
		     STRUCT_REF(s_1350, ((long) 3));
		  v1778_1356 =
		     (var_bglt) (aux_6097);
	       }
	       ((((set_ex_it_116_bglt) CREF(o_1349))->var) = ((var_bglt) v1778_1356), BUNSPEC);
	    }
	    {	/* Ast/node.scm 143 */
	       node_bglt v1782_1357;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_6101;
		  aux_6101 =
		     STRUCT_REF(s_1350, ((long) 4));
		  v1782_1357 =
		     (node_bglt) (aux_6101);
	       }
	       ((((set_ex_it_116_bglt) CREF(o_1349))->body) = ((node_bglt) v1782_1357), BUNSPEC);
	    }
	    aux_6085 = o_1349;
	    return
	       (obj_t) (aux_6085);
	 }
      }
   }
}



/* object->struct-set-ex-it1950 */
obj_t 
object__struct_set_ex_it1950_247_ast_node(obj_t env_3693, obj_t obj1766_3694)
{
   AN_OBJECT;
   {	/* Ast/node.scm 143 */
      {
	 set_ex_it_116_bglt obj1766_1335;
	 obj1766_1335 =
	    (set_ex_it_116_bglt) (obj1766_3694);
	 {	/* Ast/node.scm 143 */
	    obj_t res1767_1338;
	    {	/* ./Llib/struct.scm 1415 */
	       obj_t aux_6107;
	       aux_6107 =
		  CNST_TABLE_REF(((long) 18));
	       res1767_1338 =
		  make_struct(aux_6107, ((long) 5), BUNSPEC);
	    }
	    STRUCT_SET(res1767_1338, ((long) 0), BFALSE);
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_6111;
	       aux_6111 =
		  (((set_ex_it_116_bglt) CREF(obj1766_1335))->loc);
	       STRUCT_SET(res1767_1338, ((long) 1), aux_6111);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_6114;
	       {	/* Ast/node.scm 143 */
		  type_bglt aux_6115;
		  aux_6115 =
		     (((set_ex_it_116_bglt) CREF(obj1766_1335))->type);
		  aux_6114 =
		     (obj_t) (aux_6115);
	       }
	       STRUCT_SET(res1767_1338, ((long) 2), aux_6114);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_6119;
	       {	/* Ast/node.scm 143 */
		  var_bglt aux_6120;
		  aux_6120 =
		     (((set_ex_it_116_bglt) CREF(obj1766_1335))->var);
		  aux_6119 =
		     (obj_t) (aux_6120);
	       }
	       STRUCT_SET(res1767_1338, ((long) 3), aux_6119);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_6124;
	       {	/* Ast/node.scm 143 */
		  node_bglt aux_6125;
		  aux_6125 =
		     (((set_ex_it_116_bglt) CREF(obj1766_1335))->body);
		  aux_6124 =
		     (obj_t) (aux_6125);
	       }
	       STRUCT_SET(res1767_1338, ((long) 4), aux_6124);
	    }
	    return res1767_1338;
	 }
      }
   }
}



/* struct+object->object-jump-ex-it1948 */
obj_t 
struct_object__object_jump_ex_it1948_231_ast_node(obj_t env_3695, obj_t o_3696, obj_t s_3697)
{
   AN_OBJECT;
   {	/* Ast/node.scm 150 */
      {
	 jump_ex_it_184_bglt o_1324;
	 obj_t s_1325;
	 {	/* Ast/node.scm 150 */
	    jump_ex_it_184_bglt aux_6130;
	    o_1324 =
	       (jump_ex_it_184_bglt) (o_3696);
	    s_1325 = s_3697;
	    {	/* Ast/node.scm 150 */
	       obj_t aux_6133;
	       object_bglt aux_6131;
	       aux_6133 =
		  STRUCT_REF(s_1325, ((long) 0));
	       aux_6131 =
		  (object_bglt) (o_1324);
	       OBJECT_WIDENING_SET(aux_6131, aux_6133);
	    }
	    {	/* Ast/node.scm 150 */
	       obj_t v1799_1329;
	       v1799_1329 =
		  STRUCT_REF(s_1325, ((long) 1));
	       ((((jump_ex_it_184_bglt) CREF(o_1324))->loc) = ((obj_t) v1799_1329), BUNSPEC);
	    }
	    {	/* Ast/node.scm 150 */
	       type_bglt v1803_1330;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_6138;
		  aux_6138 =
		     STRUCT_REF(s_1325, ((long) 2));
		  v1803_1330 =
		     (type_bglt) (aux_6138);
	       }
	       ((((jump_ex_it_184_bglt) CREF(o_1324))->type) = ((type_bglt) v1803_1330), BUNSPEC);
	    }
	    {	/* Ast/node.scm 150 */
	       node_bglt v1807_1331;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_6142;
		  aux_6142 =
		     STRUCT_REF(s_1325, ((long) 3));
		  v1807_1331 =
		     (node_bglt) (aux_6142);
	       }
	       ((((jump_ex_it_184_bglt) CREF(o_1324))->exit) = ((node_bglt) v1807_1331), BUNSPEC);
	    }
	    {	/* Ast/node.scm 150 */
	       node_bglt v1811_1332;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_6146;
		  aux_6146 =
		     STRUCT_REF(s_1325, ((long) 4));
		  v1811_1332 =
		     (node_bglt) (aux_6146);
	       }
	       ((((jump_ex_it_184_bglt) CREF(o_1324))->value) = ((node_bglt) v1811_1332), BUNSPEC);
	    }
	    aux_6130 = o_1324;
	    return
	       (obj_t) (aux_6130);
	 }
      }
   }
}



/* object->struct-jump-ex-it1946 */
obj_t 
object__struct_jump_ex_it1946_107_ast_node(obj_t env_3698, obj_t obj1795_3699)
{
   AN_OBJECT;
   {	/* Ast/node.scm 150 */
      {
	 jump_ex_it_184_bglt obj1795_1310;
	 obj1795_1310 =
	    (jump_ex_it_184_bglt) (obj1795_3699);
	 {	/* Ast/node.scm 150 */
	    obj_t res1796_1313;
	    {	/* ./Llib/struct.scm 1415 */
	       obj_t aux_6152;
	       aux_6152 =
		  CNST_TABLE_REF(((long) 19));
	       res1796_1313 =
		  make_struct(aux_6152, ((long) 5), BUNSPEC);
	    }
	    STRUCT_SET(res1796_1313, ((long) 0), BFALSE);
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_6156;
	       aux_6156 =
		  (((jump_ex_it_184_bglt) CREF(obj1795_1310))->loc);
	       STRUCT_SET(res1796_1313, ((long) 1), aux_6156);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_6159;
	       {	/* Ast/node.scm 150 */
		  type_bglt aux_6160;
		  aux_6160 =
		     (((jump_ex_it_184_bglt) CREF(obj1795_1310))->type);
		  aux_6159 =
		     (obj_t) (aux_6160);
	       }
	       STRUCT_SET(res1796_1313, ((long) 2), aux_6159);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_6164;
	       {	/* Ast/node.scm 150 */
		  node_bglt aux_6165;
		  aux_6165 =
		     (((jump_ex_it_184_bglt) CREF(obj1795_1310))->exit);
		  aux_6164 =
		     (obj_t) (aux_6165);
	       }
	       STRUCT_SET(res1796_1313, ((long) 3), aux_6164);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_6169;
	       {	/* Ast/node.scm 150 */
		  node_bglt aux_6170;
		  aux_6170 =
		     (((jump_ex_it_184_bglt) CREF(obj1795_1310))->value);
		  aux_6169 =
		     (obj_t) (aux_6170);
	       }
	       STRUCT_SET(res1796_1313, ((long) 4), aux_6169);
	    }
	    return res1796_1313;
	 }
      }
   }
}



/* struct+object->object-make-box1944 */
obj_t 
struct_object__object_make_box1944_160_ast_node(obj_t env_3700, obj_t o_3701, obj_t s_3702)
{
   AN_OBJECT;
   {	/* Ast/node.scm 157 */
      {
	 make_box_202_bglt o_1298;
	 obj_t s_1299;
	 {	/* Ast/node.scm 157 */
	    make_box_202_bglt aux_6175;
	    o_1298 =
	       (make_box_202_bglt) (o_3701);
	    s_1299 = s_3702;
	    {	/* Ast/node.scm 157 */
	       obj_t aux_6178;
	       object_bglt aux_6176;
	       aux_6178 =
		  STRUCT_REF(s_1299, ((long) 0));
	       aux_6176 =
		  (object_bglt) (o_1298);
	       OBJECT_WIDENING_SET(aux_6176, aux_6178);
	    }
	    {	/* Ast/node.scm 157 */
	       obj_t v1829_1303;
	       v1829_1303 =
		  STRUCT_REF(s_1299, ((long) 1));
	       ((((make_box_202_bglt) CREF(o_1298))->loc) = ((obj_t) v1829_1303), BUNSPEC);
	    }
	    {	/* Ast/node.scm 157 */
	       type_bglt v1833_1304;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_6183;
		  aux_6183 =
		     STRUCT_REF(s_1299, ((long) 2));
		  v1833_1304 =
		     (type_bglt) (aux_6183);
	       }
	       ((((make_box_202_bglt) CREF(o_1298))->type) = ((type_bglt) v1833_1304), BUNSPEC);
	    }
	    {	/* Ast/node.scm 157 */
	       obj_t v1837_1305;
	       v1837_1305 =
		  STRUCT_REF(s_1299, ((long) 3));
	       ((((make_box_202_bglt) CREF(o_1298))->side_effect__165) = ((obj_t) v1837_1305), BUNSPEC);
	    }
	    {	/* Ast/node.scm 157 */
	       obj_t v1841_1306;
	       v1841_1306 =
		  STRUCT_REF(s_1299, ((long) 4));
	       ((((make_box_202_bglt) CREF(o_1298))->key) = ((obj_t) v1841_1306), BUNSPEC);
	    }
	    {	/* Ast/node.scm 157 */
	       node_bglt v1845_1307;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_6191;
		  aux_6191 =
		     STRUCT_REF(s_1299, ((long) 5));
		  v1845_1307 =
		     (node_bglt) (aux_6191);
	       }
	       ((((make_box_202_bglt) CREF(o_1298))->value) = ((node_bglt) v1845_1307), BUNSPEC);
	    }
	    aux_6175 = o_1298;
	    return
	       (obj_t) (aux_6175);
	 }
      }
   }
}



/* object->struct-make-box1942 */
obj_t 
object__struct_make_box1942_94_ast_node(obj_t env_3703, obj_t obj1825_3704)
{
   AN_OBJECT;
   {	/* Ast/node.scm 157 */
      {
	 make_box_202_bglt obj1825_1282;
	 obj1825_1282 =
	    (make_box_202_bglt) (obj1825_3704);
	 {	/* Ast/node.scm 157 */
	    obj_t res1826_1285;
	    {	/* ./Llib/struct.scm 1415 */
	       obj_t aux_6197;
	       aux_6197 =
		  CNST_TABLE_REF(((long) 20));
	       res1826_1285 =
		  make_struct(aux_6197, ((long) 6), BUNSPEC);
	    }
	    STRUCT_SET(res1826_1285, ((long) 0), BFALSE);
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_6201;
	       aux_6201 =
		  (((make_box_202_bglt) CREF(obj1825_1282))->loc);
	       STRUCT_SET(res1826_1285, ((long) 1), aux_6201);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_6204;
	       {	/* Ast/node.scm 157 */
		  type_bglt aux_6205;
		  aux_6205 =
		     (((make_box_202_bglt) CREF(obj1825_1282))->type);
		  aux_6204 =
		     (obj_t) (aux_6205);
	       }
	       STRUCT_SET(res1826_1285, ((long) 2), aux_6204);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_6209;
	       aux_6209 =
		  (((make_box_202_bglt) CREF(obj1825_1282))->side_effect__165);
	       STRUCT_SET(res1826_1285, ((long) 3), aux_6209);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_6212;
	       aux_6212 =
		  (((make_box_202_bglt) CREF(obj1825_1282))->key);
	       STRUCT_SET(res1826_1285, ((long) 4), aux_6212);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_6215;
	       {	/* Ast/node.scm 157 */
		  node_bglt aux_6216;
		  aux_6216 =
		     (((make_box_202_bglt) CREF(obj1825_1282))->value);
		  aux_6215 =
		     (obj_t) (aux_6216);
	       }
	       STRUCT_SET(res1826_1285, ((long) 5), aux_6215);
	    }
	    return res1826_1285;
	 }
      }
   }
}



/* struct+object->object-box-ref1940 */
obj_t 
struct_object__object_box_ref1940_82_ast_node(obj_t env_3705, obj_t o_3706, obj_t s_3707)
{
   AN_OBJECT;
   {	/* Ast/node.scm 161 */
      {
	 box_ref_242_bglt o_1270;
	 obj_t s_1271;
	 {	/* Ast/node.scm 161 */
	    box_ref_242_bglt aux_6221;
	    o_1270 =
	       (box_ref_242_bglt) (o_3706);
	    s_1271 = s_3707;
	    {	/* Ast/node.scm 161 */
	       obj_t aux_6224;
	       object_bglt aux_6222;
	       aux_6224 =
		  STRUCT_REF(s_1271, ((long) 0));
	       aux_6222 =
		  (object_bglt) (o_1270);
	       OBJECT_WIDENING_SET(aux_6222, aux_6224);
	    }
	    {	/* Ast/node.scm 161 */
	       obj_t v1863_1275;
	       v1863_1275 =
		  STRUCT_REF(s_1271, ((long) 1));
	       ((((box_ref_242_bglt) CREF(o_1270))->loc) = ((obj_t) v1863_1275), BUNSPEC);
	    }
	    {	/* Ast/node.scm 161 */
	       type_bglt v1867_1276;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_6229;
		  aux_6229 =
		     STRUCT_REF(s_1271, ((long) 2));
		  v1867_1276 =
		     (type_bglt) (aux_6229);
	       }
	       ((((box_ref_242_bglt) CREF(o_1270))->type) = ((type_bglt) v1867_1276), BUNSPEC);
	    }
	    {	/* Ast/node.scm 161 */
	       obj_t v1871_1277;
	       v1871_1277 =
		  STRUCT_REF(s_1271, ((long) 3));
	       ((((box_ref_242_bglt) CREF(o_1270))->side_effect__165) = ((obj_t) v1871_1277), BUNSPEC);
	    }
	    {	/* Ast/node.scm 161 */
	       obj_t v1875_1278;
	       v1875_1278 =
		  STRUCT_REF(s_1271, ((long) 4));
	       ((((box_ref_242_bglt) CREF(o_1270))->key) = ((obj_t) v1875_1278), BUNSPEC);
	    }
	    {	/* Ast/node.scm 161 */
	       var_bglt v1879_1279;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_6237;
		  aux_6237 =
		     STRUCT_REF(s_1271, ((long) 5));
		  v1879_1279 =
		     (var_bglt) (aux_6237);
	       }
	       ((((box_ref_242_bglt) CREF(o_1270))->var) = ((var_bglt) v1879_1279), BUNSPEC);
	    }
	    aux_6221 = o_1270;
	    return
	       (obj_t) (aux_6221);
	 }
      }
   }
}



/* object->struct-box-ref1938 */
obj_t 
object__struct_box_ref1938_31_ast_node(obj_t env_3708, obj_t obj1859_3709)
{
   AN_OBJECT;
   {	/* Ast/node.scm 161 */
      {
	 box_ref_242_bglt obj1859_1254;
	 obj1859_1254 =
	    (box_ref_242_bglt) (obj1859_3709);
	 {	/* Ast/node.scm 161 */
	    obj_t res1860_1257;
	    {	/* ./Llib/struct.scm 1415 */
	       obj_t aux_6243;
	       aux_6243 =
		  CNST_TABLE_REF(((long) 21));
	       res1860_1257 =
		  make_struct(aux_6243, ((long) 6), BUNSPEC);
	    }
	    STRUCT_SET(res1860_1257, ((long) 0), BFALSE);
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_6247;
	       aux_6247 =
		  (((box_ref_242_bglt) CREF(obj1859_1254))->loc);
	       STRUCT_SET(res1860_1257, ((long) 1), aux_6247);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_6250;
	       {	/* Ast/node.scm 161 */
		  type_bglt aux_6251;
		  aux_6251 =
		     (((box_ref_242_bglt) CREF(obj1859_1254))->type);
		  aux_6250 =
		     (obj_t) (aux_6251);
	       }
	       STRUCT_SET(res1860_1257, ((long) 2), aux_6250);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_6255;
	       aux_6255 =
		  (((box_ref_242_bglt) CREF(obj1859_1254))->side_effect__165);
	       STRUCT_SET(res1860_1257, ((long) 3), aux_6255);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_6258;
	       aux_6258 =
		  (((box_ref_242_bglt) CREF(obj1859_1254))->key);
	       STRUCT_SET(res1860_1257, ((long) 4), aux_6258);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_6261;
	       {	/* Ast/node.scm 161 */
		  var_bglt aux_6262;
		  aux_6262 =
		     (((box_ref_242_bglt) CREF(obj1859_1254))->var);
		  aux_6261 =
		     (obj_t) (aux_6262);
	       }
	       STRUCT_SET(res1860_1257, ((long) 5), aux_6261);
	    }
	    return res1860_1257;
	 }
      }
   }
}



/* struct+object->object-box-set!1936 */
obj_t 
struct_object__object_box_set_1936_112_ast_node(obj_t env_3710, obj_t o_3711, obj_t s_3712)
{
   AN_OBJECT;
   {	/* Ast/node.scm 165 */
      {
	 box_set__221_bglt o_1243;
	 obj_t s_1244;
	 {	/* Ast/node.scm 165 */
	    box_set__221_bglt aux_6267;
	    o_1243 =
	       (box_set__221_bglt) (o_3711);
	    s_1244 = s_3712;
	    {	/* Ast/node.scm 165 */
	       obj_t aux_6270;
	       object_bglt aux_6268;
	       aux_6270 =
		  STRUCT_REF(s_1244, ((long) 0));
	       aux_6268 =
		  (object_bglt) (o_1243);
	       OBJECT_WIDENING_SET(aux_6268, aux_6270);
	    }
	    {	/* Ast/node.scm 165 */
	       obj_t v1896_1248;
	       v1896_1248 =
		  STRUCT_REF(s_1244, ((long) 1));
	       ((((box_set__221_bglt) CREF(o_1243))->loc) = ((obj_t) v1896_1248), BUNSPEC);
	    }
	    {	/* Ast/node.scm 165 */
	       type_bglt v1900_1249;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_6275;
		  aux_6275 =
		     STRUCT_REF(s_1244, ((long) 2));
		  v1900_1249 =
		     (type_bglt) (aux_6275);
	       }
	       ((((box_set__221_bglt) CREF(o_1243))->type) = ((type_bglt) v1900_1249), BUNSPEC);
	    }
	    {	/* Ast/node.scm 165 */
	       var_bglt v1904_1250;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_6279;
		  aux_6279 =
		     STRUCT_REF(s_1244, ((long) 3));
		  v1904_1250 =
		     (var_bglt) (aux_6279);
	       }
	       ((((box_set__221_bglt) CREF(o_1243))->var) = ((var_bglt) v1904_1250), BUNSPEC);
	    }
	    {	/* Ast/node.scm 165 */
	       node_bglt v1908_1251;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_6283;
		  aux_6283 =
		     STRUCT_REF(s_1244, ((long) 4));
		  v1908_1251 =
		     (node_bglt) (aux_6283);
	       }
	       ((((box_set__221_bglt) CREF(o_1243))->value) = ((node_bglt) v1908_1251), BUNSPEC);
	    }
	    aux_6267 = o_1243;
	    return
	       (obj_t) (aux_6267);
	 }
      }
   }
}



/* object->struct-box-set!1934 */
obj_t 
object__struct_box_set_1934_10_ast_node(obj_t env_3713, obj_t obj1892_3714)
{
   AN_OBJECT;
   {	/* Ast/node.scm 165 */
      {
	 box_set__221_bglt obj1892_1229;
	 obj1892_1229 =
	    (box_set__221_bglt) (obj1892_3714);
	 {	/* Ast/node.scm 165 */
	    obj_t res1893_1232;
	    {	/* ./Llib/struct.scm 1415 */
	       obj_t aux_6289;
	       aux_6289 =
		  CNST_TABLE_REF(((long) 22));
	       res1893_1232 =
		  make_struct(aux_6289, ((long) 5), BUNSPEC);
	    }
	    STRUCT_SET(res1893_1232, ((long) 0), BFALSE);
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_6293;
	       aux_6293 =
		  (((box_set__221_bglt) CREF(obj1892_1229))->loc);
	       STRUCT_SET(res1893_1232, ((long) 1), aux_6293);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_6296;
	       {	/* Ast/node.scm 165 */
		  type_bglt aux_6297;
		  aux_6297 =
		     (((box_set__221_bglt) CREF(obj1892_1229))->type);
		  aux_6296 =
		     (obj_t) (aux_6297);
	       }
	       STRUCT_SET(res1893_1232, ((long) 2), aux_6296);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_6301;
	       {	/* Ast/node.scm 165 */
		  var_bglt aux_6302;
		  aux_6302 =
		     (((box_set__221_bglt) CREF(obj1892_1229))->var);
		  aux_6301 =
		     (obj_t) (aux_6302);
	       }
	       STRUCT_SET(res1893_1232, ((long) 3), aux_6301);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_6306;
	       {	/* Ast/node.scm 165 */
		  node_bglt aux_6307;
		  aux_6307 =
		     (((box_set__221_bglt) CREF(obj1892_1229))->value);
		  aux_6306 =
		     (obj_t) (aux_6307);
	       }
	       STRUCT_SET(res1893_1232, ((long) 4), aux_6306);
	    }
	    return res1893_1232;
	 }
      }
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_ast_node()
{
   AN_OBJECT;
   {	/* Ast/node.scm 14 */
      module_initialization_70_type_type(((long) 0), "AST_NODE");
      return
	 module_initialization_70_ast_var(((long) 0), "AST_NODE");
   }
}
