/*===========================================================================*/
/*   (Ast/sexp.scm)                                                          */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;


extern let_fun_218_bglt set_exit__node_102_ast_exit(obj_t, obj_t, obj_t, obj_t);
extern obj_t find_global_223_ast_env(obj_t, obj_t);
static obj_t method_init_76_ast_sexp();
extern obj_t find_global_module_25_ast_env(obj_t, obj_t);
extern obj_t symbol_append_197___r4_symbols_6_4(obj_t);
static obj_t _cache_res__50_ast_sexp = BUNSPEC;
static obj_t lookup_ast_sexp(obj_t, obj_t);
extern obj_t fail_ast_node;
extern obj_t find_location_loc_243_tools_location(obj_t, obj_t);
extern obj_t dsssl_find_first_formal_237_tools_dsssl(obj_t);
extern obj_t mark_symbol_non_user__17_ast_ident(obj_t);
extern obj_t sequence_ast_node;
extern obj_t var_ast_node;
extern obj_t closure_ast_node;
extern node_bglt application__node_43_ast_app(obj_t, obj_t, obj_t, obj_t);
static obj_t _sexp__node2106_107_ast_sexp(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t global_ast_var;
extern obj_t gensym___r4_symbols_6_4;
static obj_t sexp___node_160_ast_sexp(obj_t, obj_t, obj_t, obj_t);
static obj_t _define_primop__node2110_103_ast_sexp(obj_t, obj_t);
extern obj_t notify_assert_fail_37___eval(obj_t, obj_t, obj_t);
extern node_bglt pragma_type__node_160_ast_pragma(bool_t, type_bglt, obj_t, obj_t, obj_t, obj_t);
extern obj_t _magic__144_type_cache;
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t current_function_76_tools_error();
extern obj_t _unspec__87_type_cache;
extern obj_t module_initialization_70_ast_sexp(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_progn(long, char *);
extern obj_t module_initialization_70_tools_location(long, char *);
extern obj_t module_initialization_70_tools_misc(long, char *);
extern obj_t module_initialization_70_tools_dsssl(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_env(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_type_typeof(long, char *);
extern obj_t module_initialization_70_ast_ident(long, char *);
extern obj_t module_initialization_70_ast_env(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_ast_build(long, char *);
extern obj_t module_initialization_70_ast_pragma(long, char *);
extern obj_t module_initialization_70_ast_labels(long, char *);
extern obj_t module_initialization_70_ast_let(long, char *);
extern obj_t module_initialization_70_ast_exit(long, char *);
extern obj_t module_initialization_70_ast_app(long, char *);
extern obj_t module_initialization_70_ast_apply(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___dsssl(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___eval(long, char *);
extern obj_t module_initialization_70___evenv(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_symbols_6_4(long, char *);
extern node_bglt applycation__node_122_ast_apply(obj_t, obj_t, obj_t, obj_t);
extern obj_t _bnil__15_type_cache;
extern node_bglt location__node_25_ast_sexp(global_bglt);
extern jump_ex_it_184_bglt jump_exit__node_34_ast_exit(obj_t, obj_t, obj_t, obj_t);
extern long class_num_218___object(obj_t);
static obj_t _top_level_sexp__node_248_ast_sexp(obj_t, obj_t, obj_t);
extern obj_t define_primop_ref__105___evenv(obj_t, obj_t);
extern obj_t node_ast_node;
extern obj_t fun_ast_var;
static obj_t imported_modules_init_94_ast_sexp();
extern obj_t unbind_primop__163___evenv(obj_t);
extern obj_t normalize_progn_143_tools_progn(obj_t);
static obj_t _define_primop_ref__node2109_67_ast_sexp(obj_t, obj_t, obj_t);
extern obj_t dsssl_named_constant__188_tools_dsssl(obj_t);
extern obj_t app_ast_node;
extern obj_t append_2_18___r4_pairs_and_lists_6_3(obj_t, obj_t);
static obj_t library_modules_init_112_ast_sexp();
static obj_t _cache_stack__44_ast_sexp = BUNSPEC;
static obj_t _use_variable_2107_114_ast_sexp(obj_t, obj_t, obj_t, obj_t);
extern obj_t atom_ast_node;
static obj_t _error_sexp__node2108_6_ast_sexp(obj_t, obj_t, obj_t, obj_t);
static obj_t toplevel_init_63_ast_sexp();
extern node_bglt sexp__node_235_ast_sexp(obj_t, obj_t, obj_t, obj_t);
extern obj_t replace__160_tools_misc(obj_t, obj_t);
extern obj_t open_input_string(obj_t);
extern obj_t epairify_tools_misc(obj_t, obj_t);
extern obj_t kwote_ast_node;
extern obj_t use_variable__4_ast_sexp(variable_bglt, obj_t, obj_t);
extern node_bglt top_level_sexp__node_204_ast_sexp(obj_t, obj_t);
extern node_bglt define_primop__node_141_ast_sexp(global_bglt);
extern obj_t setq_ast_node;
static obj_t _cache_name__178_ast_sexp = BUNSPEC;
static obj_t _sites__81_ast_sexp = BUNSPEC;
extern obj_t parse_id_241_ast_ident(obj_t, obj_t);
extern node_bglt error_sexp__node_157_ast_sexp(obj_t, obj_t, obj_t);
extern obj_t local_ast_var;
static obj_t _anonymous_1839__116_ast_sexp(obj_t, obj_t, obj_t, obj_t);
static obj_t loop_ast_sexp(obj_t, obj_t, obj_t, obj_t);
extern node_bglt let__node_121_ast_let(obj_t, obj_t, obj_t, obj_t);
extern obj_t memq___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern obj_t shape_tools_shape(obj_t);
extern type_bglt typeof_atom_134_type_typeof(obj_t);
static obj_t _location__node2111_80_ast_sexp(obj_t, obj_t);
extern obj_t _4dots_199_tools_misc;
static obj_t liip_ast_sexp(obj_t);
extern obj_t select_ast_node;
extern let_fun_218_bglt labels__node_197_ast_labels(obj_t, obj_t, obj_t, obj_t);
extern obj_t read___reader(obj_t);
extern node_bglt define_primop_ref__node_164_ast_sexp(global_bglt, node_bglt);
extern obj_t make_dsssl_function_prelude_58___dsssl(obj_t, obj_t, obj_t, obj_t);
extern obj_t ____74_type_cache;
static obj_t require_initialization_114_ast_sexp = BUNSPEC;
extern obj_t conditional_ast_node;
static obj_t cnst_init_137_ast_sexp();
extern obj_t reverse__39___r4_pairs_and_lists_6_3(obj_t);
extern obj_t user_error_location_137_tools_error(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t __cnst[38];

DEFINE_EXPORT_PROCEDURE(use_variable__env_235_ast_sexp, _use_variable_2107_114_ast_sexp2135, _use_variable_2107_114_ast_sexp, 0L, 3);
DEFINE_EXPORT_PROCEDURE(define_primop__node_env_232_ast_sexp, _define_primop__node2110_103_ast_sexp2136, _define_primop__node2110_103_ast_sexp, 0L, 1);
DEFINE_EXPORT_PROCEDURE(error_sexp__node_env_24_ast_sexp, _error_sexp__node2108_6_ast_sexp2137, _error_sexp__node2108_6_ast_sexp, 0L, 3);
DEFINE_EXPORT_PROCEDURE(define_primop_ref__node_env_208_ast_sexp, _define_primop_ref__node2109_67_ast_sexp2138, _define_primop_ref__node2109_67_ast_sexp, 0L, 2);
DEFINE_EXPORT_PROCEDURE(top_level_sexp__node_env_236_ast_sexp, _top_level_sexp__node_248_ast_sexp2139, _top_level_sexp__node_248_ast_sexp, 0L, 2);
DEFINE_EXPORT_PROCEDURE(location__node_env_47_ast_sexp, _location__node2111_80_ast_sexp2140, _location__node2111_80_ast_sexp, 0L, 1);
DEFINE_STRING(string2129_ast_sexp, string2129_ast_sexp2141, "Illegal mutation", 16);
DEFINE_STRING(string2130_ast_sexp, string2130_ast_sexp2142, "(@ __EVMEANING_ADDRESS FOREIGN) DEFINE-PRIMOP! DEFINE-PRIMOP-REF! WRITE (\"/home/tahoe2/serrano/tmp/bigloo/comptime/Ast/sexp.scm\" . 19342) CONS (QUOTE ()) APPLY JUMP-EXIT SET-EXIT CASE FAILURE LETREC DEFINE BEGIN QUOTE @ APP EVAL NOT IF ::BOOL TEST LOCATION SET! LET > ELSE LABELS LAMBDA FREE-PRAGMA PRAGMA (\"/home/tahoe2/serrano/tmp/bigloo/comptime/Ast/sexp.scm\" . 2892) (BEGIN (MEMQ SITE *SITES*)) (SITE) SITE VALUE (VALUE APPLY APP SET!) ", 440);
DEFINE_STRING(string2128_ast_sexp, string2128_ast_sexp2143, "Illegal empty sequence", 22);
DEFINE_STRING(string2127_ast_sexp, string2127_ast_sexp2144, "Illegal formal argument", 23);
DEFINE_STRING(string2126_ast_sexp, string2126_ast_sexp2145, "wrong number of argument", 24);
DEFINE_STRING(string2125_ast_sexp, string2125_ast_sexp2146, "Illegal `()' expression", 23);
DEFINE_STRING(string2124_ast_sexp, string2124_ast_sexp2147, "Illegal atom", 12);
DEFINE_STRING(string2123_ast_sexp, string2123_ast_sexp2148, "Unbound variable", 16);
DEFINE_STRING(string2122_ast_sexp, string2122_ast_sexp2149, "Illegal `@' expression", 22);
DEFINE_STRING(string2121_ast_sexp, string2121_ast_sexp2150, "Illegal `quote' expression", 26);
DEFINE_STRING(string2119_ast_sexp, string2119_ast_sexp2151, "illegal `set!' expression", 25);
DEFINE_STRING(string2120_ast_sexp, string2120_ast_sexp2152, "Illegal `if' form", 17);
DEFINE_STRING(string2118_ast_sexp, string2118_ast_sexp2153, "Illegal `set!' form", 19);
DEFINE_STRING(string2117_ast_sexp, string2117_ast_sexp2154, "illegal `define' expression", 27);
DEFINE_STRING(string2116_ast_sexp, string2116_ast_sexp2155, "Illegal `define' form", 21);
DEFINE_STRING(string2115_ast_sexp, string2115_ast_sexp2156, "<ANONYMOUS:", 11);
DEFINE_STRING(string2114_ast_sexp, string2114_ast_sexp2157, "Illegal `failure' form", 22);
DEFINE_STRING(string2113_ast_sexp, string2113_ast_sexp2158, "Illegal `case' form", 19);
DEFINE_STRING(string2112_ast_sexp, string2112_ast_sexp2159, "Illegal `lambda' form", 21);
DEFINE_EXPORT_PROCEDURE(sexp__node_env_201_ast_sexp, _sexp__node2106_107_ast_sexp2160, _sexp__node2106_107_ast_sexp, 0L, 4);



/* module-initialization */
obj_t 
module_initialization_70_ast_sexp(long checksum_2691, char *from_2692)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_ast_sexp))
	{
	   require_initialization_114_ast_sexp =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_ast_sexp();
	   cnst_init_137_ast_sexp();
	   imported_modules_init_94_ast_sexp();
	   method_init_76_ast_sexp();
	   toplevel_init_63_ast_sexp();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_ast_sexp()
{
   AN_OBJECT;
   {	/* Ast/sexp.scm 14 */
      module_initialization_70___r4_symbols_6_4(((long) 0), "AST_SEXP");
      module_initialization_70___eval(((long) 0), "AST_SEXP");
      module_initialization_70___object(((long) 0), "AST_SEXP");
      module_initialization_70___evenv(((long) 0), "AST_SEXP");
      module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "AST_SEXP");
      module_initialization_70___reader(((long) 0), "AST_SEXP");
      module_initialization_70___dsssl(((long) 0), "AST_SEXP");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_ast_sexp()
{
   AN_OBJECT;
   {	/* Ast/sexp.scm 14 */
      {		/* Ast/sexp.scm 14 */
	 obj_t cnst_port_138_2684;
	 cnst_port_138_2684 =
	    open_input_string(string2130_ast_sexp);
	 {
	    long i_2685;
	    i_2685 = ((long) 37);
	  loop_2686:
	    {	/* Ast/sexp.scm 14 */
	       bool_t test2131_2687;
	       test2131_2687 =
		  (i_2685 == ((long) -1));
	       if (test2131_2687)
		 {	/* Ast/sexp.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Ast/sexp.scm 14 */
		    {	/* Ast/sexp.scm 14 */
		       obj_t arg2132_2688;
		       {	/* Ast/sexp.scm 14 */
			  obj_t list2133_2689;
			  list2133_2689 =
			     MAKE_PAIR(cnst_port_138_2684, BNIL);
			  arg2132_2688 =
			     read___reader(list2133_2689);
		       }
		       CNST_TABLE_SET(i_2685, arg2132_2688);
		    }
		    {	/* Ast/sexp.scm 14 */
		       int aux_2690;
		       {	/* Ast/sexp.scm 14 */
			  long aux_2714;
			  aux_2714 =
			     (i_2685 - ((long) 1));
			  aux_2690 =
			     (int) (aux_2714);
		       }
		       {
			  long i_2717;
			  i_2717 =
			     (long) (aux_2690);
			  i_2685 = i_2717;
			  goto loop_2686;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_ast_sexp()
{
   AN_OBJECT;
   {	/* Ast/sexp.scm 14 */
      _sites__81_ast_sexp =
	 CNST_TABLE_REF(((long) 0));
      _cache_name__178_ast_sexp = BFALSE;
      _cache_stack__44_ast_sexp = BFALSE;
      return (
	 _cache_res__50_ast_sexp = BFALSE, BUNSPEC);
   }
}



/* top-level-sexp->node */
node_bglt 
top_level_sexp__node_204_ast_sexp(obj_t exp_15, obj_t loc_16)
{
   AN_OBJECT;
   {	/* Ast/sexp.scm 52 */
      return
	 sexp__node_235_ast_sexp(exp_15, BNIL, loc_16,
	 CNST_TABLE_REF(((long) 1)));
   }
}



/* _top-level-sexp->node */
obj_t 
_top_level_sexp__node_248_ast_sexp(obj_t env_2652, obj_t exp_2653, obj_t loc_2654)
{
   AN_OBJECT;
   {	/* Ast/sexp.scm 52 */
      {		/* Ast/sexp.scm 52 */
	 node_bglt aux_2722;
	 aux_2722 =
	    top_level_sexp__node_204_ast_sexp(exp_2653, loc_2654);
	 return
	    (obj_t) (aux_2722);
      }
   }
}



/* sexp->node */
node_bglt 
sexp__node_235_ast_sexp(obj_t exp_17, obj_t stack_18, obj_t loc_19, obj_t site_20)
{
   AN_OBJECT;
   {	/* Ast/sexp.scm 68 */
    sexp__node_235_ast_sexp:
      {		/* Ast/sexp.scm 69 */
	 bool_t test_2725;
	 {	/* Ast/sexp.scm 69 */
	    obj_t aux_2726;
	    aux_2726 =
	       memq___r4_pairs_and_lists_6_3(site_20, _sites__81_ast_sexp);
	    test_2725 =
	       CBOOL(aux_2726);
	 }
	 if (test_2725)
	   {	/* Ast/sexp.scm 69 */
	      BUNSPEC;
	   }
	 else
	   {	/* Ast/sexp.scm 69 */
	      {		/* Ast/sexp.scm 69 */
		 obj_t arg1469_743;
		 obj_t arg1470_744;
		 arg1469_743 =
		    CNST_TABLE_REF(((long) 2));
		 arg1470_744 =
		    __EVMEANING_ADDRESS(site_20);
		 define_primop_ref__105___evenv(arg1469_743, arg1470_744);
	      }
	      notify_assert_fail_37___eval(
		 CNST_TABLE_REF(((long) 3)),
		 CNST_TABLE_REF(((long) 4)),
		 CNST_TABLE_REF(((long) 5)));
	      unbind_primop__163___evenv(
		 CNST_TABLE_REF(((long) 2)));
	   }
      }
      {
	 obj_t atom_747;
	 obj_t body_751;
	 obj_t body_756;
	 obj_t args_757;
	 obj_t vars_761;
	 obj_t body_762;
	 obj_t args_763;
	 if (
	    (exp_17 == BNIL))
	   {	/* Ast/sexp.scm 71 */
	      return
		 error_sexp__node_157_ast_sexp(string2125_ast_sexp, exp_17, loc_19);
	   }
	 else
	   {	/* Ast/sexp.scm 71 */
	      bool_t test1472_776;
	      test1472_776 =
		 is_a__118___object(exp_17, node_ast_node);
	      if (test1472_776)
		{	/* Ast/sexp.scm 71 */
		   return
		      (node_bglt) (exp_17);
		}
	      else
		{	/* Ast/sexp.scm 71 */
		   if (
		      PAIRP(exp_17))
		     {	/* Ast/sexp.scm 71 */
			bool_t test_2746;
			{	/* ./Ieee/equiv.scm 5508 */
			   obj_t aux_2749;
			   obj_t aux_2747;
			   aux_2749 =
			      CNST_TABLE_REF(((long) 21));
			   aux_2747 =
			      CAR(exp_17);
			   test_2746 =
			      (aux_2747 == aux_2749);
			}
			if (test_2746)
			  {	/* Ast/sexp.scm 71 */
			     obj_t aux_2752;
			     {	/* Ast/sexp.scm 137 */
				obj_t loc_920;
				loc_920 =
				   find_location_loc_243_tools_location(exp_17, loc_19);
				{
				   obj_t name_921;
				   obj_t module_922;
				   if (
				      PAIRP(exp_17))
				     {	/* Ast/sexp.scm 138 */
					obj_t cdr_352_26_927;
					cdr_352_26_927 =
					   CDR(exp_17);
					{	/* Ast/sexp.scm 138 */
					   bool_t test_2757;
					   {	/* ./Ieee/equiv.scm 5508 */
					      obj_t aux_2760;
					      obj_t aux_2758;
					      aux_2760 =
						 CNST_TABLE_REF(((long) 21));
					      aux_2758 =
						 CAR(exp_17);
					      test_2757 =
						 (aux_2758 == aux_2760);
					   }
					   if (test_2757)
					     {	/* Ast/sexp.scm 138 */
						if (
						   PAIRP(cdr_352_26_927))
						  {	/* Ast/sexp.scm 138 */
						     obj_t car_355_218_930;
						     obj_t cdr_356_4_931;
						     car_355_218_930 =
							CAR(cdr_352_26_927);
						     cdr_356_4_931 =
							CDR(cdr_352_26_927);
						     if (
							SYMBOLP(car_355_218_930))
						       {	/* Ast/sexp.scm 138 */
							  if (
							     PAIRP(cdr_356_4_931))
							    {	/* Ast/sexp.scm 138 */
							       obj_t car_361_52_934;
							       car_361_52_934 =
								  CAR(cdr_356_4_931);
							       if (
								  SYMBOLP(car_361_52_934))
								 {	/* Ast/sexp.scm 138 */
								    bool_t test_2774;
								    {	/* ./Ieee/equiv.scm 5508 */
								       obj_t aux_2775;
								       aux_2775 =
									  CDR(cdr_356_4_931);
								       test_2774 =
									  (aux_2775 == BNIL);
								    }
								    if (test_2774)
								      {		/* Ast/sexp.scm 138 */
									 name_921 = car_355_218_930;
									 module_922 = car_361_52_934;
									 {	/* Ast/sexp.scm 140 */
									    obj_t global_941;
									    global_941 =
									       find_global_module_25_ast_env(name_921, module_922);
									    {	/* Ast/sexp.scm 142 */
									       bool_t test1623_942;
									       test1623_942 =
										  is_a__118___object(global_941, global_ast_var);
									       if (test1623_942)
										 {	/* Ast/sexp.scm 144 */
										    bool_t test_2781;
										    {	/* ./Ieee/equiv.scm 5508 */
										       obj_t aux_2785;
										       obj_t aux_2782;
										       aux_2785 =
											  CNST_TABLE_REF(((long) 19));
										       {	/* Ast/sexp.scm 144 */
											  global_bglt obj_2029;
											  obj_2029 =
											     (global_bglt) (global_941);
											  aux_2782 =
											     (((global_bglt) CREF(obj_2029))->import);
										       }
										       test_2781 =
											  (aux_2782 == aux_2785);
										    }
										    if (test_2781)
										      {		/* Ast/sexp.scm 144 */
											 {	/* Ast/sexp.scm 145 */
											    obj_t arg1625_944;
											    {	/* Ast/sexp.scm 145 */
											       obj_t arg1626_945;
											       obj_t arg1627_946;
											       arg1626_945 =
												  CNST_TABLE_REF(((long) 19));
											       {	/* Ast/sexp.scm 145 */
												  obj_t obj1_2032;
												  obj1_2032 = atom_ast_node;
												  arg1627_946 =
												     MAKE_PAIR(obj1_2032, BNIL);
											       }
											       arg1625_944 =
												  MAKE_PAIR(arg1626_945, arg1627_946);
											    }
											    {	/* Ast/sexp.scm 145 */
											       node_bglt aux_2791;
											       aux_2791 =
												  sexp__node_235_ast_sexp(arg1625_944, stack_18, loc_920, site_20);
											       aux_2752 =
												  (obj_t) (aux_2791);
											    }
											 }
										      }
										    else
										      {		/* Ast/sexp.scm 144 */
											 use_variable__4_ast_sexp(
											    (variable_bglt) (global_941), loc_920, site_20);
											 {	/* Ast/sexp.scm 148 */
											    bool_t test1628_947;
											    {	/* Ast/sexp.scm 148 */
											       bool_t test_2796;
											       {	/* ./Ieee/equiv.scm 5508 */
												  obj_t aux_2797;
												  aux_2797 =
												     CNST_TABLE_REF(((long) 20));
												  test_2796 =
												     (site_20 == aux_2797);
											       }
											       if (test_2796)
												 {	/* Ast/sexp.scm 148 */
												    test1628_947 = ((bool_t) 0);
												 }
											       else
												 {	/* ./Ast/var.scm 1543 */
												    obj_t aux_2800;
												    {	/* Ast/sexp.scm 149 */
												       value_bglt aux_2801;
												       {	/* Ast/sexp.scm 149 */
													  global_bglt obj_2038;
													  obj_2038 =
													     (global_bglt) (global_941);
													  aux_2801 =
													     (((global_bglt) CREF(obj_2038))->value);
												       }
												       aux_2800 =
													  (obj_t) (aux_2801);
												    }
												    test1628_947 =
												       is_a__118___object(aux_2800, fun_ast_var);
												 }
											    }
											    if (test1628_947)
											      {		/* Ast/sexp.scm 150 */
												 type_bglt arg1630_949;
												 {	/* Ast/sexp.scm 151 */
												    global_bglt obj_2040;
												    obj_2040 =
												       (global_bglt) (global_941);
												    arg1630_949 =
												       (((global_bglt) CREF(obj_2040))->type);
												 }
												 {	/* Ast/sexp.scm 150 */
												    closure_bglt res2092_2051;
												    {	/* Ast/sexp.scm 150 */
												       variable_bglt variable_2043;
												       variable_2043 =
													  (variable_bglt) (global_941);
												       {	/* ./Ast/node.scm 1656 */
													  closure_bglt new1218_2044;
													  new1218_2044 =
													     ((closure_bglt) BREF(GC_MALLOC(sizeof(struct closure))));
													  {	/* ./Ast/node.scm 1656 */
													     long arg2050_2045;
													     arg2050_2045 =
														class_num_218___object(closure_ast_node);
													     {	/* ./Ast/node.scm 1656 */
														obj_t obj_2049;
														obj_2049 =
														   (obj_t) (new1218_2044);
														(((obj_t) CREF(obj_2049))->header = MAKE_HEADER(arg2050_2045, 0), BUNSPEC);
													     }
													  }
													  {	/* ./Ast/node.scm 1656 */
													     object_bglt aux_2814;
													     aux_2814 =
														(object_bglt) (new1218_2044);
													     OBJECT_WIDENING_SET(aux_2814, BFALSE);
													  }
													  ((((closure_bglt) CREF(new1218_2044))->loc) = ((obj_t) loc_920), BUNSPEC);
													  ((((closure_bglt) CREF(new1218_2044))->type) = ((type_bglt) arg1630_949), BUNSPEC);
													  ((((closure_bglt) CREF(new1218_2044))->variable) = ((variable_bglt) variable_2043), BUNSPEC);
													  res2092_2051 = new1218_2044;
												       }
												    }
												    aux_2752 =
												       (obj_t) (res2092_2051);
												 }
											      }
											    else
											      {		/* Ast/sexp.scm 153 */
												 type_bglt arg1633_952;
												 {	/* Ast/sexp.scm 154 */
												    global_bglt obj_2052;
												    obj_2052 =
												       (global_bglt) (global_941);
												    arg1633_952 =
												       (((global_bglt) CREF(obj_2052))->type);
												 }
												 {	/* Ast/sexp.scm 153 */
												    var_bglt res2093_2063;
												    {	/* Ast/sexp.scm 153 */
												       variable_bglt variable_2055;
												       variable_2055 =
													  (variable_bglt) (global_941);
												       {	/* ./Ast/node.scm 1651 */
													  var_bglt new1210_2056;
													  new1210_2056 =
													     ((var_bglt) BREF(GC_MALLOC(sizeof(struct var))));
													  {	/* ./Ast/node.scm 1651 */
													     long arg2052_2057;
													     arg2052_2057 =
														class_num_218___object(var_ast_node);
													     {	/* ./Ast/node.scm 1651 */
														obj_t obj_2061;
														obj_2061 =
														   (obj_t) (new1210_2056);
														(((obj_t) CREF(obj_2061))->header = MAKE_HEADER(arg2052_2057, 0), BUNSPEC);
													     }
													  }
													  {	/* ./Ast/node.scm 1651 */
													     object_bglt aux_2828;
													     aux_2828 =
														(object_bglt) (new1210_2056);
													     OBJECT_WIDENING_SET(aux_2828, BFALSE);
													  }
													  ((((var_bglt) CREF(new1210_2056))->loc) = ((obj_t) loc_920), BUNSPEC);
													  ((((var_bglt) CREF(new1210_2056))->type) = ((type_bglt) arg1633_952), BUNSPEC);
													  ((((var_bglt) CREF(new1210_2056))->variable) = ((variable_bglt) variable_2055), BUNSPEC);
													  res2093_2063 = new1210_2056;
												       }
												    }
												    aux_2752 =
												       (obj_t) (res2093_2063);
												 }
											      }
											 }
										      }
										 }
									       else
										 {	/* Ast/sexp.scm 142 */
										    {	/* Ast/sexp.scm 143 */
										       node_bglt aux_2835;
										       aux_2835 =
											  error_sexp__node_157_ast_sexp(string2123_ast_sexp, exp_17, loc_920);
										       aux_2752 =
											  (obj_t) (aux_2835);
										    }
										 }
									    }
									 }
								      }
								    else
								      {		/* Ast/sexp.scm 138 */
									 node_bglt aux_2838;
								       tag_345_225_924:
									 aux_2838 =
									    error_sexp__node_157_ast_sexp(string2122_ast_sexp, exp_17, loc_920);
									 aux_2752 =
									    (obj_t) (aux_2838);
								      }
								 }
							       else
								 {	/* Ast/sexp.scm 138 */
								    node_bglt aux_2841;
								    goto tag_345_225_924;
								    aux_2752 =
								       (obj_t) (aux_2841);
								 }
							    }
							  else
							    {	/* Ast/sexp.scm 138 */
							       node_bglt aux_2843;
							       goto tag_345_225_924;
							       aux_2752 =
								  (obj_t) (aux_2843);
							    }
						       }
						     else
						       {	/* Ast/sexp.scm 138 */
							  node_bglt aux_2845;
							  goto tag_345_225_924;
							  aux_2752 =
							     (obj_t) (aux_2845);
						       }
						  }
						else
						  {	/* Ast/sexp.scm 138 */
						     node_bglt aux_2847;
						     goto tag_345_225_924;
						     aux_2752 =
							(obj_t) (aux_2847);
						  }
					     }
					   else
					     {	/* Ast/sexp.scm 138 */
						node_bglt aux_2849;
						goto tag_345_225_924;
						aux_2752 =
						   (obj_t) (aux_2849);
					     }
					}
				     }
				   else
				     {	/* Ast/sexp.scm 138 */
					node_bglt aux_2851;
					goto tag_345_225_924;
					aux_2752 =
					   (obj_t) (aux_2851);
				     }
				}
			     }
			     return
				(node_bglt) (aux_2752);
			  }
			else
			  {	/* Ast/sexp.scm 71 */
			     bool_t test_2854;
			     {	/* ./Ieee/equiv.scm 5508 */
				obj_t aux_2857;
				obj_t aux_2855;
				aux_2857 =
				   CNST_TABLE_REF(((long) 22));
				aux_2855 =
				   CAR(exp_17);
				test_2854 =
				   (aux_2855 == aux_2857);
			     }
			     if (test_2854)
			       {	/* Ast/sexp.scm 71 */
				  obj_t aux_2860;
				  {
				     obj_t value_958;
				     if (
					PAIRP(exp_17))
				       {	/* Ast/sexp.scm 71 */
					  obj_t cdr_372_212_963;
					  cdr_372_212_963 =
					     CDR(exp_17);
					  if (
					     PAIRP(cdr_372_212_963))
					    {	/* Ast/sexp.scm 71 */
					       bool_t test_2866;
					       {	/* ./Ieee/equiv.scm 5508 */
						  obj_t aux_2867;
						  aux_2867 =
						     CDR(cdr_372_212_963);
						  test_2866 =
						     (aux_2867 == BNIL);
					       }
					       if (test_2866)
						 {	/* Ast/sexp.scm 71 */
						    value_958 =
						       CAR(cdr_372_212_963);
						    {	/* Ast/sexp.scm 162 */
						       obj_t loc_969;
						       loc_969 =
							  find_location_loc_243_tools_location(exp_17, loc_19);
						       if (
							  NULLP(value_958))
							 {	/* Ast/sexp.scm 164 */
							    {	/* Ast/sexp.scm 165 */
							       obj_t arg1647_972;
							       arg1647_972 = _bnil__15_type_cache;
							       {	/* Ast/sexp.scm 165 */
								  atom_bglt res2094_2082;
								  {	/* Ast/sexp.scm 165 */
								     type_bglt type_2073;
								     type_2073 =
									(type_bglt) (arg1647_972);
								     {	/* ./Ast/node.scm 1646 */
									atom_bglt new1202_2075;
									new1202_2075 =
									   ((atom_bglt) BREF(GC_MALLOC(sizeof(struct atom))));
									{	/* ./Ast/node.scm 1646 */
									   long arg2054_2076;
									   arg2054_2076 =
									      class_num_218___object(atom_ast_node);
									   {	/* ./Ast/node.scm 1646 */
									      obj_t obj_2080;
									      obj_2080 =
										 (obj_t) (new1202_2075);
									      (((obj_t) CREF(obj_2080))->header = MAKE_HEADER(arg2054_2076, 0), BUNSPEC);
									   }
									}
									{	/* ./Ast/node.scm 1646 */
									   object_bglt aux_2878;
									   aux_2878 =
									      (object_bglt) (new1202_2075);
									   OBJECT_WIDENING_SET(aux_2878, BFALSE);
									}
									((((atom_bglt) CREF(new1202_2075))->loc) = ((obj_t) loc_969), BUNSPEC);
									((((atom_bglt) CREF(new1202_2075))->type) = ((type_bglt) type_2073), BUNSPEC);
									((((atom_bglt) CREF(new1202_2075))->value) = ((obj_t) BNIL), BUNSPEC);
									res2094_2082 = new1202_2075;
								     }
								  }
								  aux_2860 =
								     (obj_t) (res2094_2082);
							       }
							    }
							 }
						       else
							 {	/* Ast/sexp.scm 168 */
							    bool_t test_2885;
							    if (
							       PAIRP(value_958))
							      {		/* Ast/sexp.scm 168 */
								 test_2885 = ((bool_t) 1)
								    ;
							      }
							    else
							      {		/* Ast/sexp.scm 168 */
								 if (
								    VECTORP(value_958))
								   {	/* Ast/sexp.scm 169 */
								      test_2885 = ((bool_t) 1)
									 ;
								   }
								 else
								   {	/* Ast/sexp.scm 169 */
								      if (
									 STRUCTP(value_958))
									{	/* Ast/sexp.scm 170 */
									   test_2885 = ((bool_t) 1)
									      ;
									}
								      else
									{	/* Ast/sexp.scm 170 */
									   if (
									      SYMBOLP(value_958))
									     {	/* Ast/sexp.scm 171 */
										test_2885 = ((bool_t) 1)
										   ;
									     }
									   else
									     {	/* Ast/sexp.scm 171 */
										test_2885 =
										   KEYWORDP(value_958)
										   ;
									     }
									}
								   }
							      }
							    if (test_2885)
							      {		/* Ast/sexp.scm 168 */
								 {	/* Ast/sexp.scm 173 */
								    obj_t arg1651_976;
								    arg1651_976 = ____74_type_cache;
								    {	/* Ast/sexp.scm 173 */
								       kwote_bglt res2095_2098;
								       {	/* Ast/sexp.scm 173 */
									  type_bglt type_2089;
									  type_2089 =
									     (type_bglt) (arg1651_976);
									  {	/* ./Ast/node.scm 1659 */
									     kwote_bglt new1225_2091;
									     new1225_2091 =
										((kwote_bglt) BREF(GC_MALLOC(sizeof(struct kwote))));
									     {	/* ./Ast/node.scm 1659 */
										long arg2048_2092;
										arg2048_2092 =
										   class_num_218___object(kwote_ast_node);
										{	/* ./Ast/node.scm 1659 */
										   obj_t obj_2096;
										   obj_2096 =
										      (obj_t) (new1225_2091);
										   (((obj_t) CREF(obj_2096))->header = MAKE_HEADER(arg2048_2092, 0), BUNSPEC);
										}
									     }
									     {	/* ./Ast/node.scm 1659 */
										object_bglt aux_2900;
										aux_2900 =
										   (object_bglt) (new1225_2091);
										OBJECT_WIDENING_SET(aux_2900, BFALSE);
									     }
									     ((((kwote_bglt) CREF(new1225_2091))->loc) = ((obj_t) loc_969), BUNSPEC);
									     ((((kwote_bglt) CREF(new1225_2091))->type) = ((type_bglt) type_2089), BUNSPEC);
									     ((((kwote_bglt) CREF(new1225_2091))->value) = ((obj_t) value_958), BUNSPEC);
									     res2095_2098 = new1225_2091;
									  }
								       }
								       aux_2860 =
									  (obj_t) (res2095_2098);
								    }
								 }
							      }
							    else
							      {		/* Ast/sexp.scm 176 */
								 bool_t test_2907;
								 {	/* Ast/sexp.scm 176 */
								    bool_t test1654_979;
								    test1654_979 =
								       INTEGERP(value_958);
								    if (test1654_979)
								      {		/* Ast/sexp.scm 176 */
									 test_2907 = ((bool_t) 1)
									    ;
								      }
								    else
								      {		/* Ast/sexp.scm 177 */
									 bool_t test_2910;
									 if (test1654_979)
									   {	/* ./Ieee/flonum.scm 7393 */
									      test_2910 = ((bool_t) 1)
										 ;
									   }
									 else
									   {	/* ./Ieee/flonum.scm 7393 */
									      test_2910 =
										 REALP(value_958)
										 ;
									   }
									 if (test_2910)
									   {	/* Ast/sexp.scm 177 */
									      test_2907 = ((bool_t) 1)
										 ;
									   }
									 else
									   {	/* Ast/sexp.scm 177 */
									      if (
										 STRINGP(value_958))
										{	/* Ast/sexp.scm 178 */
										   test_2907 = ((bool_t) 1)
										      ;
										}
									      else
										{	/* Ast/sexp.scm 178 */
										   if (
										      CNSTP(value_958))
										     {	/* Ast/sexp.scm 179 */
											test_2907 = ((bool_t) 1)
											   ;
										     }
										   else
										     {	/* Ast/sexp.scm 179 */
											if (
											   CHARP(value_958))
											  {	/* Ast/sexp.scm 183 */
											     test_2907 = ((bool_t) 1)
												;
											  }
											else
											  {	/* Ast/sexp.scm 183 */
											     test_2907 =
												BOOLEANP(value_958)
												;
											  }
										     }
										}
									   }
								      }
								 }
								 if (test_2907)
								   {	/* Ast/sexp.scm 176 */
								      {		/* Ast/sexp.scm 185 */
									 node_bglt aux_2920;
									 aux_2920 =
									    sexp__node_235_ast_sexp(value_958, stack_18, loc_969, site_20);
									 aux_2860 =
									    (obj_t) (aux_2920);
								      }
								   }
								 else
								   {	/* Ast/sexp.scm 176 */
								      {		/* Ast/sexp.scm 187 */
									 node_bglt aux_2923;
									 aux_2923 =
									    error_sexp__node_157_ast_sexp(string2121_ast_sexp, exp_17, loc_969);
									 aux_2860 =
									    (obj_t) (aux_2923);
								      }
								   }
							      }
							 }
						    }
						 }
					       else
						 {	/* Ast/sexp.scm 71 */
						    node_bglt aux_2927;
						  tag_367_40_960:
						    aux_2927 =
						       error_sexp__node_157_ast_sexp(string2121_ast_sexp, exp_17, loc_19);
						    aux_2860 =
						       (obj_t) (aux_2927);
						 }
					    }
					  else
					    {	/* Ast/sexp.scm 71 */
					       node_bglt aux_2930;
					       goto tag_367_40_960;
					       aux_2860 =
						  (obj_t) (aux_2930);
					    }
				       }
				     else
				       {	/* Ast/sexp.scm 71 */
					  node_bglt aux_2932;
					  goto tag_367_40_960;
					  aux_2860 =
					     (obj_t) (aux_2932);
				       }
				  }
				  return
				     (node_bglt) (aux_2860);
			       }
			     else
			       {	/* Ast/sexp.scm 71 */
				  bool_t test_2935;
				  {	/* ./Ieee/equiv.scm 5508 */
				     obj_t aux_2938;
				     obj_t aux_2936;
				     aux_2938 =
					CNST_TABLE_REF(((long) 23));
				     aux_2936 =
					CAR(exp_17);
				     test_2935 =
					(aux_2936 == aux_2938);
				  }
				  if (test_2935)
				    {	/* Ast/sexp.scm 71 */
				       sequence_bglt aux_2941;
				       body_751 =
					  CDR(exp_17);
				       {	/* Ast/sexp.scm 192 */
					  obj_t body_988;
					  if (
					     NULLP(body_751))
					    {	/* Ast/sexp.scm 193 */
					       obj_t list1668_996;
					       list1668_996 =
						  MAKE_PAIR(BUNSPEC, BNIL);
					       body_988 = list1668_996;
					    }
					  else
					    {	/* Ast/sexp.scm 192 */
					       body_988 = body_751;
					    }
					  {	/* Ast/sexp.scm 195 */
					     obj_t loc_989;
					     loc_989 =
						find_location_loc_243_tools_location(exp_17, loc_19);
					     {	/* Ast/sexp.scm 195 */
						obj_t nodes_990;
						nodes_990 =
						   sexp___node_160_ast_sexp(body_988, stack_18, loc_989, site_20);
						{	/* Ast/sexp.scm 196 */

						   {	/* Ast/sexp.scm 197 */
						      obj_t arg1664_992;
						      arg1664_992 = ____74_type_cache;
						      {		/* Ast/sexp.scm 197 */
							 sequence_bglt res2097_2123;
							 {	/* Ast/sexp.scm 197 */
							    type_bglt type_2110;
							    obj_t key_2112;
							    type_2110 =
							       (type_bglt) (arg1664_992);
							    key_2112 =
							       BINT(((long) -1));
							    {	/* ./Ast/node.scm 1664 */
							       sequence_bglt new1234_2114;
							       new1234_2114 =
								  ((sequence_bglt) BREF(GC_MALLOC(sizeof(struct sequence))));
							       {	/* ./Ast/node.scm 1664 */
								  long arg2046_2115;
								  arg2046_2115 =
								     class_num_218___object(sequence_ast_node);
								  {	/* ./Ast/node.scm 1664 */
								     obj_t obj_2121;
								     obj_2121 =
									(obj_t) (new1234_2114);
								     (((obj_t) CREF(obj_2121))->header = MAKE_HEADER(arg2046_2115, 0), BUNSPEC);
								  }
							       }
							       {	/* ./Ast/node.scm 1664 */
								  object_bglt aux_2953;
								  aux_2953 =
								     (object_bglt) (new1234_2114);
								  OBJECT_WIDENING_SET(aux_2953, BFALSE);
							       }
							       ((((sequence_bglt) CREF(new1234_2114))->loc) = ((obj_t) loc_989), BUNSPEC);
							       ((((sequence_bglt) CREF(new1234_2114))->type) = ((type_bglt) type_2110), BUNSPEC);
							       ((((sequence_bglt) CREF(new1234_2114))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
							       ((((sequence_bglt) CREF(new1234_2114))->key) = ((obj_t) key_2112), BUNSPEC);
							       ((((sequence_bglt) CREF(new1234_2114))->nodes) = ((obj_t) nodes_990), BUNSPEC);
							       res2097_2123 = new1234_2114;
							    }
							 }
							 aux_2941 = res2097_2123;
						      }
						   }
						}
					     }
					  }
				       }
				       return
					  (node_bglt) (aux_2941);
				    }
				  else
				    {	/* Ast/sexp.scm 71 */
				       bool_t test_2963;
				       {	/* ./Ieee/equiv.scm 5508 */
					  obj_t aux_2966;
					  obj_t aux_2964;
					  aux_2966 =
					     CNST_TABLE_REF(((long) 17));
					  aux_2964 =
					     CAR(exp_17);
					  test_2963 =
					     (aux_2964 == aux_2966);
				       }
				       if (test_2963)
					 {	/* Ast/sexp.scm 71 */
					    obj_t aux_2969;
					    {
					       obj_t si_997;
					       obj_t alors_998;
					       obj_t sinon_999;
					       obj_t si_1001;
					       obj_t alors_1002;
					       if (
						  PAIRP(exp_17))
						 {	/* Ast/sexp.scm 71 */
						    obj_t cdr_388_242_1007;
						    cdr_388_242_1007 =
						       CDR(exp_17);
						    if (
						       PAIRP(cdr_388_242_1007))
						      {		/* Ast/sexp.scm 71 */
							 obj_t cdr_393_75_1009;
							 cdr_393_75_1009 =
							    CDR(cdr_388_242_1007);
							 if (
							    PAIRP(cdr_393_75_1009))
							   {	/* Ast/sexp.scm 71 */
							      obj_t cdr_398_147_1011;
							      cdr_398_147_1011 =
								 CDR(cdr_393_75_1009);
							      if (
								 PAIRP(cdr_398_147_1011))
								{	/* Ast/sexp.scm 71 */
								   bool_t test_2981;
								   {	/* ./Ieee/equiv.scm 5508 */
								      obj_t aux_2982;
								      aux_2982 =
									 CDR(cdr_398_147_1011);
								      test_2981 =
									 (aux_2982 == BNIL);
								   }
								   if (test_2981)
								     {	/* Ast/sexp.scm 71 */
									si_997 =
									   CAR(cdr_388_242_1007);
									alors_998 =
									   CAR(cdr_393_75_1009);
									sinon_999 =
									   CAR(cdr_398_147_1011);
									{
									   obj_t si_1026;
									   if (
									      PAIRP(si_997))
									     {	/* Ast/sexp.scm 71 */
										obj_t cdr_453_73_1031;
										cdr_453_73_1031 =
										   CDR(si_997);
										{	/* Ast/sexp.scm 71 */
										   bool_t test_2988;
										   {	/* ./Ieee/equiv.scm 5508 */
										      obj_t aux_2991;
										      obj_t aux_2989;
										      aux_2991 =
											 CNST_TABLE_REF(((long) 17));
										      aux_2989 =
											 CAR(si_997);
										      test_2988 =
											 (aux_2989 == aux_2991);
										   }
										   if (test_2988)
										     {	/* Ast/sexp.scm 71 */
											if (
											   PAIRP(cdr_453_73_1031))
											  {	/* Ast/sexp.scm 71 */
											     obj_t cdr_456_36_1034;
											     cdr_456_36_1034 =
												CDR(cdr_453_73_1031);
											     if (
												PAIRP(cdr_456_36_1034))
											       {	/* Ast/sexp.scm 71 */
												  obj_t cdr_459_197_1036;
												  cdr_459_197_1036 =
												     CDR(cdr_456_36_1034);
												  {	/* Ast/sexp.scm 71 */
												     bool_t test_3000;
												     {	/* ./Ieee/equiv.scm 5508 */
													obj_t aux_3001;
													aux_3001 =
													   CAR(cdr_456_36_1034);
													test_3000 =
													   (aux_3001 == BFALSE);
												     }
												     if (test_3000)
												       {	/* Ast/sexp.scm 71 */
													  if (
													     PAIRP(cdr_459_197_1036))
													    {	/* Ast/sexp.scm 71 */
													       bool_t test_3006;
													       {	/* ./Ieee/equiv.scm 5508 */
														  obj_t aux_3007;
														  aux_3007 =
														     CAR(cdr_459_197_1036);
														  test_3006 =
														     (aux_3007 == BTRUE);
													       }
													       if (test_3006)
														 {	/* Ast/sexp.scm 71 */
														    bool_t test_3010;
														    {	/* ./Ieee/equiv.scm 5508 */
														       obj_t aux_3011;
														       aux_3011 =
															  CDR(cdr_459_197_1036);
														       test_3010 =
															  (aux_3011 == BNIL);
														    }
														    if (test_3010)
														      {		/* Ast/sexp.scm 71 */
															 node_bglt aux_3014;
															 si_1026 =
															    CAR(cdr_453_73_1031);
														       tag_445_246_1027:
															 {	/* ./Ieee/pair-list.scm 5890 */
															    obj_t aux_3015;
															    aux_3015 =
															       CDR(exp_17);
															    SET_CAR(aux_3015, si_1026);
															 }
															 {	/* ./Ieee/pair-list.scm 5890 */
															    obj_t aux_3018;
															    {	/* ./Ieee/pair-list.scm 5707 */
															       obj_t aux_3019;
															       aux_3019 =
																  CDR(exp_17);
															       aux_3018 =
																  CDR(aux_3019);
															    }
															    SET_CAR(aux_3018, sinon_999);
															 }
															 {	/* ./Ieee/pair-list.scm 5890 */
															    obj_t aux_3023;
															    {	/* ./Ieee/pair-list.scm 5707 */
															       obj_t aux_3024;
															       {	/* ./Ieee/pair-list.scm 5707 */
																  obj_t aux_3025;
																  aux_3025 =
																     CDR(exp_17);
																  aux_3024 =
																     CDR(aux_3025);
															       }
															       aux_3023 =
																  CDR(aux_3024);
															    }
															    SET_CAR(aux_3023, alors_998);
															 }
															 aux_3014 =
															    sexp__node_235_ast_sexp(exp_17, stack_18, loc_19, site_20);
															 aux_2969 =
															    (obj_t) (aux_3014);
														      }
														    else
														      {		/* Ast/sexp.scm 71 */
														       tag_446_179_1028:
															 {	/* Ast/sexp.scm 214 */
															    bool_t test1713_1062;
															    if (
															       SYMBOLP(si_997))
															      {		/* Ast/sexp.scm 214 */
																 test1713_1062 = ((bool_t) 1);
															      }
															    else
															      {		/* Ast/sexp.scm 214 */
																 test1713_1062 =
																    is_a__118___object(si_997, atom_ast_node);
															      }
															    if (test1713_1062)
															      {		/* Ast/sexp.scm 215 */
																 obj_t oloc_1063;
																 oloc_1063 =
																    find_location_loc_243_tools_location(exp_17, loc_19);
																 {	/* Ast/sexp.scm 215 */
																    obj_t l_si_138_1064;
																    l_si_138_1064 =
																       find_location_loc_243_tools_location(si_997, oloc_1063);
																    {	/* Ast/sexp.scm 216 */
																       obj_t l_alors_128_1065;
																       l_alors_128_1065 =
																	  find_location_loc_243_tools_location(alors_998, oloc_1063);
																       {	/* Ast/sexp.scm 217 */
																	  obj_t l_sinon_85_1066;
																	  l_sinon_85_1066 =
																	     find_location_loc_243_tools_location(sinon_999, oloc_1063);
																	  {	/* Ast/sexp.scm 218 */
																	     node_bglt si_1067;
																	     si_1067 =
																		sexp__node_235_ast_sexp(si_997, stack_18, l_si_138_1064,
																		CNST_TABLE_REF(((long) 1)));
																	     {	/* Ast/sexp.scm 219 */
																		node_bglt alors_1068;
																		alors_1068 =
																		   sexp__node_235_ast_sexp(alors_998, stack_18, l_alors_128_1065,
																		   CNST_TABLE_REF(((long) 1)));
																		{	/* Ast/sexp.scm 220 */
																		   node_bglt sinon_1069;
																		   sinon_1069 =
																		      sexp__node_235_ast_sexp(sinon_999, stack_18, l_sinon_85_1066,
																		      CNST_TABLE_REF(((long) 1)));
																		   {	/* Ast/sexp.scm 221 */
																		      obj_t loc_1070;
																		      {		/* Ast/sexp.scm 228 */
																			 obj_t loc_1077;
																			 loc_1077 =
																			    find_location_loc_243_tools_location(exp_17,
																			    (((node_bglt) CREF(si_1067))->loc));
																			 {	/* Ast/sexp.scm 231 */
																			    bool_t test_3049;
																			    if (
																			       STRUCTP(loc_1077))
																			      {		/* ./Ieee/equiv.scm 5508 */
																				 obj_t aux_3054;
																				 obj_t aux_3052;
																				 aux_3054 =
																				    CNST_TABLE_REF(((long) 14));
																				 aux_3052 =
																				    STRUCT_KEY(loc_1077);
																				 test_3049 =
																				    (aux_3052 == aux_3054);
																			      }
																			    else
																			      {		/* ./Tools/location.sch 894 */
																				 test_3049 = ((bool_t) 0)
																				    ;
																			      }
																			    if (test_3049)
																			      {		/* Ast/sexp.scm 231 */
																				 loc_1070 = loc_1077;
																			      }
																			    else
																			      {		/* Ast/sexp.scm 231 */
																				 loc_1070 = oloc_1063;
																			      }
																			 }
																		      }
																		      {		/* Ast/sexp.scm 228 */

																			 {	/* Ast/sexp.scm 234 */
																			    obj_t arg1715_1072;
																			    arg1715_1072 = ____74_type_cache;
																			    {	/* Ast/sexp.scm 234 */
																			       conditional_bglt res2098_2219;
																			       {	/* Ast/sexp.scm 234 */
																				  type_bglt type_2202;
																				  obj_t key_2204;
																				  type_2202 =
																				     (type_bglt) (arg1715_1072);
																				  key_2204 =
																				     BINT(((long) -1));
																				  {	/* ./Ast/node.scm 1712 */
																				     conditional_bglt new1317_2208;
																				     new1317_2208 =
																					((conditional_bglt) BREF(GC_MALLOC(sizeof(struct conditional))));
																				     {	/* ./Ast/node.scm 1712 */
																					long arg2032_2209;
																					arg2032_2209 =
																					   class_num_218___object(conditional_ast_node);
																					{	/* ./Ast/node.scm 1712 */
																					   obj_t obj_2217;
																					   obj_2217 =
																					      (obj_t) (new1317_2208);
																					   (((obj_t) CREF(obj_2217))->header = MAKE_HEADER(arg2032_2209, 0), BUNSPEC);
																					}
																				     }
																				     {	/* ./Ast/node.scm 1712 */
																					object_bglt aux_3063;
																					aux_3063 =
																					   (object_bglt) (new1317_2208);
																					OBJECT_WIDENING_SET(aux_3063, BFALSE);
																				     }
																				     ((((conditional_bglt) CREF(new1317_2208))->loc) = ((obj_t) loc_1070), BUNSPEC);
																				     ((((conditional_bglt) CREF(new1317_2208))->type) = ((type_bglt) type_2202), BUNSPEC);
																				     ((((conditional_bglt) CREF(new1317_2208))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
																				     ((((conditional_bglt) CREF(new1317_2208))->key) = ((obj_t) key_2204), BUNSPEC);
																				     ((((conditional_bglt) CREF(new1317_2208))->test) = ((node_bglt) si_1067), BUNSPEC);
																				     ((((conditional_bglt) CREF(new1317_2208))->true) = ((node_bglt) alors_1068), BUNSPEC);
																				     ((((conditional_bglt) CREF(new1317_2208))->false) = ((node_bglt) sinon_1069), BUNSPEC);
																				     res2098_2219 = new1317_2208;
																				  }
																			       }
																			       aux_2969 =
																				  (obj_t) (res2098_2219);
																			    }
																			 }
																		      }
																		   }
																		}
																	     }
																	  }
																       }
																    }
																 }
															      }
															    else
															      {		/* Ast/sexp.scm 239 */
																 obj_t test_1080;
																 {	/* Ast/sexp.scm 239 */
																    obj_t arg1740_1098;
																    arg1740_1098 =
																       PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4,
																       CNST_TABLE_REF(((long) 15)), BEOA);
																    test_1080 =
																       mark_symbol_non_user__17_ast_ident(arg1740_1098);
																 }
																 {	/* Ast/sexp.scm 241 */
																    obj_t arg1722_1081;
																    {	/* Ast/sexp.scm 241 */
																       obj_t arg1723_1082;
																       obj_t arg1724_1083;
																       arg1723_1082 =
																	  CNST_TABLE_REF(((long) 12));
																       {	/* Ast/sexp.scm 241 */
																	  obj_t arg1725_1084;
																	  obj_t arg1726_1085;
																	  {	/* Ast/sexp.scm 241 */
																	     obj_t arg1727_1086;
																	     {	/* Ast/sexp.scm 241 */
																		obj_t arg1729_1088;
																		obj_t arg1730_1089;
																		{	/* Ast/sexp.scm 241 */
																		   obj_t list1731_1090;
																		   {	/* Ast/sexp.scm 241 */
																		      obj_t arg1732_1091;
																		      {		/* Ast/sexp.scm 241 */
																			 obj_t aux_3079;
																			 aux_3079 =
																			    CNST_TABLE_REF(((long) 16));
																			 arg1732_1091 =
																			    MAKE_PAIR(aux_3079, BNIL);
																		      }
																		      list1731_1090 =
																			 MAKE_PAIR(test_1080, arg1732_1091);
																		   }
																		   arg1729_1088 =
																		      symbol_append_197___r4_symbols_6_4(list1731_1090);
																		}
																		arg1730_1089 =
																		   MAKE_PAIR(si_997, BNIL);
																		arg1727_1086 =
																		   MAKE_PAIR(arg1729_1088, arg1730_1089);
																	     }
																	     arg1725_1084 =
																		MAKE_PAIR(arg1727_1086, BNIL);
																	  }
																	  {	/* Ast/sexp.scm 242 */
																	     obj_t arg1733_1092;
																	     {	/* Ast/sexp.scm 242 */
																		obj_t arg1735_1094;
																		obj_t arg1736_1095;
																		arg1735_1094 =
																		   CNST_TABLE_REF(((long) 17));
																		{	/* Ast/sexp.scm 242 */
																		   obj_t arg1738_1096;
																		   {	/* Ast/sexp.scm 242 */
																		      obj_t arg1739_1097;
																		      arg1739_1097 =
																			 MAKE_PAIR(sinon_999, BNIL);
																		      arg1738_1096 =
																			 MAKE_PAIR(alors_998, arg1739_1097);
																		   }
																		   arg1736_1095 =
																		      MAKE_PAIR(test_1080, arg1738_1096);
																		}
																		arg1733_1092 =
																		   MAKE_PAIR(arg1735_1094, arg1736_1095);
																	     }
																	     arg1726_1085 =
																		MAKE_PAIR(arg1733_1092, BNIL);
																	  }
																	  arg1724_1083 =
																	     MAKE_PAIR(arg1725_1084, arg1726_1085);
																       }
																       arg1722_1081 =
																	  MAKE_PAIR(arg1723_1082, arg1724_1083);
																    }
																    replace__160_tools_misc(exp_17, arg1722_1081);
																 }
																 {	/* Ast/sexp.scm 243 */
																    node_bglt aux_3096;
																    aux_3096 =
																       sexp__node_235_ast_sexp(exp_17, stack_18, loc_19, site_20);
																    aux_2969 =
																       (obj_t) (aux_3096);
																 }
															      }
															 }
														      }
														 }
													       else
														 {	/* Ast/sexp.scm 71 */
														    goto tag_446_179_1028;
														 }
													    }
													  else
													    {	/* Ast/sexp.scm 71 */
													       goto tag_446_179_1028;
													    }
												       }
												     else
												       {	/* Ast/sexp.scm 71 */
													  goto tag_446_179_1028;
												       }
												  }
											       }
											     else
											       {	/* Ast/sexp.scm 71 */
												  goto tag_446_179_1028;
											       }
											  }
											else
											  {	/* Ast/sexp.scm 71 */
											     goto tag_446_179_1028;
											  }
										     }
										   else
										     {	/* Ast/sexp.scm 71 */
											bool_t test_3099;
											{	/* ./Ieee/equiv.scm 5508 */
											   obj_t aux_3102;
											   obj_t aux_3100;
											   aux_3102 =
											      CNST_TABLE_REF(((long) 18));
											   aux_3100 =
											      CAR(si_997);
											   test_3099 =
											      (aux_3100 == aux_3102);
											}
											if (test_3099)
											  {	/* Ast/sexp.scm 71 */
											     if (
												PAIRP(cdr_453_73_1031))
											       {	/* Ast/sexp.scm 71 */
												  bool_t test_3107;
												  {	/* ./Ieee/equiv.scm 5508 */
												     obj_t aux_3108;
												     aux_3108 =
													CDR(cdr_453_73_1031);
												     test_3107 =
													(aux_3108 == BNIL);
												  }
												  if (test_3107)
												    {	/* Ast/sexp.scm 71 */
												       node_bglt aux_3111;
												       {
													  obj_t si_3112;
													  si_3112 =
													     CAR(cdr_453_73_1031);
													  si_1026 = si_3112;
													  goto tag_445_246_1027;
												       }
												       aux_2969 =
													  (obj_t) (aux_3111);
												    }
												  else
												    {	/* Ast/sexp.scm 71 */
												       goto tag_446_179_1028;
												    }
											       }
											     else
											       {	/* Ast/sexp.scm 71 */
												  goto tag_446_179_1028;
											       }
											  }
											else
											  {	/* Ast/sexp.scm 71 */
											     goto tag_446_179_1028;
											  }
										     }
										}
									     }
									   else
									     {	/* Ast/sexp.scm 71 */
										goto tag_446_179_1028;
									     }
									}
								     }
								   else
								     {	/* Ast/sexp.scm 71 */
									node_bglt aux_3118;
								      tag_379_81_1004:
									aux_3118 =
									   error_sexp__node_157_ast_sexp(string2120_ast_sexp, exp_17, loc_19);
									aux_2969 =
									   (obj_t) (aux_3118);
								     }
								}
							      else
								{	/* Ast/sexp.scm 71 */
								   obj_t cdr_423_232_1020;
								   cdr_423_232_1020 =
								      CDR(cdr_388_242_1007);
								   {	/* Ast/sexp.scm 71 */
								      bool_t test_3122;
								      {		/* ./Ieee/equiv.scm 5508 */
									 obj_t aux_3123;
									 aux_3123 =
									    CDR(cdr_423_232_1020);
									 test_3122 =
									    (aux_3123 == BNIL);
								      }
								      if (test_3122)
									{	/* Ast/sexp.scm 71 */
									   node_bglt aux_3126;
									   si_1001 =
									      CAR(cdr_388_242_1007);
									   alors_1002 =
									      CAR(cdr_423_232_1020);
									   {	/* Ast/sexp.scm 245 */
									      obj_t arg1742_1100;
									      obj_t arg1743_1101;
									      {		/* ./Ieee/pair-list.scm 5707 */
										 obj_t aux_3127;
										 aux_3127 =
										    CDR(exp_17);
										 arg1742_1100 =
										    CDR(aux_3127);
									      }
									      {		/* Ast/sexp.scm 245 */
										 obj_t list1744_1102;
										 list1744_1102 =
										    MAKE_PAIR(BUNSPEC, BNIL);
										 arg1743_1101 = list1744_1102;
									      }
									      SET_CDR(arg1742_1100, arg1743_1101);
									   }
									   aux_3126 =
									      sexp__node_235_ast_sexp(exp_17, stack_18, loc_19, site_20);
									   aux_2969 =
									      (obj_t) (aux_3126);
									}
								      else
									{	/* Ast/sexp.scm 71 */
									   node_bglt aux_3136;
									   goto tag_379_81_1004;
									   aux_2969 =
									      (obj_t) (aux_3136);
									}
								   }
								}
							   }
							 else
							   {	/* Ast/sexp.scm 71 */
							      node_bglt aux_3138;
							      goto tag_379_81_1004;
							      aux_2969 =
								 (obj_t) (aux_3138);
							   }
						      }
						    else
						      {		/* Ast/sexp.scm 71 */
							 node_bglt aux_3140;
							 goto tag_379_81_1004;
							 aux_2969 =
							    (obj_t) (aux_3140);
						      }
						 }
					       else
						 {	/* Ast/sexp.scm 71 */
						    node_bglt aux_3142;
						    goto tag_379_81_1004;
						    aux_2969 =
						       (obj_t) (aux_3142);
						 }
					    }
					    return
					       (node_bglt) (aux_2969);
					 }
				       else
					 {	/* Ast/sexp.scm 71 */
					    bool_t test_3145;
					    {	/* ./Ieee/equiv.scm 5508 */
					       obj_t aux_3148;
					       obj_t aux_3146;
					       aux_3148 =
						  CNST_TABLE_REF(((long) 13));
					       aux_3146 =
						  CAR(exp_17);
					       test_3145 =
						  (aux_3146 == aux_3148);
					    }
					    if (test_3145)
					      {		/* Ast/sexp.scm 71 */
						 obj_t aux_3151;
						 {
						    obj_t var_1103;
						    obj_t val_1104;
						    if (
						       PAIRP(exp_17))
						      {		/* Ast/sexp.scm 71 */
							 obj_t cdr_484_240_1109;
							 cdr_484_240_1109 =
							    CDR(exp_17);
							 if (
							    PAIRP(cdr_484_240_1109))
							   {	/* Ast/sexp.scm 71 */
							      obj_t cdr_488_93_1111;
							      cdr_488_93_1111 =
								 CDR(cdr_484_240_1109);
							      if (
								 PAIRP(cdr_488_93_1111))
								{	/* Ast/sexp.scm 71 */
								   bool_t test_3160;
								   {	/* ./Ieee/equiv.scm 5508 */
								      obj_t aux_3161;
								      aux_3161 =
									 CDR(cdr_488_93_1111);
								      test_3160 =
									 (aux_3161 == BNIL);
								   }
								   if (test_3160)
								     {	/* Ast/sexp.scm 71 */
									var_1103 =
									   CAR(cdr_484_240_1109);
									val_1104 =
									   CAR(cdr_488_93_1111);
									{	/* Ast/sexp.scm 253 */
									   obj_t loc_1118;
									   loc_1118 =
									      find_location_loc_243_tools_location(exp_17, loc_19);
									   {	/* Ast/sexp.scm 253 */
									      obj_t val_loc_228_1119;
									      val_loc_228_1119 =
										 find_location_loc_243_tools_location(val_1104, loc_1118);
									      {		/* Ast/sexp.scm 254 */
										 node_bglt val_1120;
										 val_1120 =
										    sexp__node_235_ast_sexp(val_1104, stack_18, val_loc_228_1119,
										    CNST_TABLE_REF(((long) 1)));
										 {	/* Ast/sexp.scm 255 */

										    {	/* Ast/sexp.scm 256 */
										       node_bglt ast_1121;
										       ast_1121 =
											  sexp__node_235_ast_sexp(var_1103, stack_18, loc_1118,
											  CNST_TABLE_REF(((long) 13)));
										       {	/* Ast/sexp.scm 257 */
											  bool_t test1753_1122;
											  test1753_1122 =
											     is_a__118___object(
											     (obj_t) (ast_1121), var_ast_node);
											  if (test1753_1122)
											    {	/* Ast/sexp.scm 258 */
											       obj_t arg1755_1124;
											       arg1755_1124 = _unspec__87_type_cache;
											       {	/* Ast/sexp.scm 258 */
												  setq_bglt res2099_2270;
												  {	/* Ast/sexp.scm 258 */
												     type_bglt type_2259;
												     var_bglt var_2260;
												     type_2259 =
													(type_bglt) (arg1755_1124);
												     var_2260 =
													(var_bglt) (ast_1121);
												     {	/* ./Ast/node.scm 1705 */
													setq_bglt new1304_2262;
													new1304_2262 =
													   ((setq_bglt) BREF(GC_MALLOC(sizeof(struct setq))));
													{	/* ./Ast/node.scm 1705 */
													   long arg2034_2263;
													   arg2034_2263 =
													      class_num_218___object(setq_ast_node);
													   {	/* ./Ast/node.scm 1705 */
													      obj_t obj_2268;
													      obj_2268 =
														 (obj_t) (new1304_2262);
													      (((obj_t) CREF(obj_2268))->header = MAKE_HEADER(arg2034_2263, 0), BUNSPEC);
													   }
													}
													{	/* ./Ast/node.scm 1705 */
													   object_bglt aux_3179;
													   aux_3179 =
													      (object_bglt) (new1304_2262);
													   OBJECT_WIDENING_SET(aux_3179, BFALSE);
													}
													((((setq_bglt) CREF(new1304_2262))->loc) = ((obj_t) loc_1118), BUNSPEC);
													((((setq_bglt) CREF(new1304_2262))->type) = ((type_bglt) type_2259), BUNSPEC);
													((((setq_bglt) CREF(new1304_2262))->var) = ((var_bglt) var_2260), BUNSPEC);
													((((setq_bglt) CREF(new1304_2262))->value) = ((node_bglt) val_1120), BUNSPEC);
													res2099_2270 = new1304_2262;
												     }
												  }
												  aux_3151 =
												     (obj_t) (res2099_2270);
											       }
											    }
											  else
											    {	/* Ast/sexp.scm 263 */
											       node_bglt aux_3187;
											       aux_3187 =
												  error_sexp__node_157_ast_sexp(string2119_ast_sexp, exp_17, loc_1118);
											       aux_3151 =
												  (obj_t) (aux_3187);
											    }
										       }
										    }
										 }
									      }
									   }
									}
								     }
								   else
								     {	/* Ast/sexp.scm 71 */
									node_bglt aux_3192;
								      tag_477_142_1106:
									{	/* Ast/sexp.scm 267 */
									   obj_t arg1760_1128;
									   arg1760_1128 =
									      find_location_loc_243_tools_location(exp_17, loc_19);
									   aux_3192 =
									      error_sexp__node_157_ast_sexp(string2118_ast_sexp, exp_17, arg1760_1128);
									}
									aux_3151 =
									   (obj_t) (aux_3192);
								     }
								}
							      else
								{	/* Ast/sexp.scm 71 */
								   node_bglt aux_3196;
								   goto tag_477_142_1106;
								   aux_3151 =
								      (obj_t) (aux_3196);
								}
							   }
							 else
							   {	/* Ast/sexp.scm 71 */
							      node_bglt aux_3198;
							      goto tag_477_142_1106;
							      aux_3151 =
								 (obj_t) (aux_3198);
							   }
						      }
						    else
						      {		/* Ast/sexp.scm 71 */
							 node_bglt aux_3200;
							 goto tag_477_142_1106;
							 aux_3151 =
							    (obj_t) (aux_3200);
						      }
						 }
						 return
						    (node_bglt) (aux_3151);
					      }
					    else
					      {		/* Ast/sexp.scm 71 */
						 bool_t test_3203;
						 {	/* ./Ieee/equiv.scm 5508 */
						    obj_t aux_3206;
						    obj_t aux_3204;
						    aux_3206 =
						       CNST_TABLE_REF(((long) 24));
						    aux_3204 =
						       CAR(exp_17);
						    test_3203 =
						       (aux_3204 == aux_3206);
						 }
						 if (test_3203)
						   {	/* Ast/sexp.scm 71 */
						      obj_t aux_3209;
						      {
							 obj_t var_1129;
							 obj_t val_1130;
							 if (
							    PAIRP(exp_17))
							   {	/* Ast/sexp.scm 71 */
							      obj_t cdr_502_28_1135;
							      cdr_502_28_1135 =
								 CDR(exp_17);
							      if (
								 PAIRP(cdr_502_28_1135))
								{	/* Ast/sexp.scm 71 */
								   obj_t cdr_506_2_1137;
								   cdr_506_2_1137 =
								      CDR(cdr_502_28_1135);
								   if (
								      PAIRP(cdr_506_2_1137))
								     {	/* Ast/sexp.scm 71 */
									bool_t test_3218;
									{	/* ./Ieee/equiv.scm 5508 */
									   obj_t aux_3219;
									   aux_3219 =
									      CDR(cdr_506_2_1137);
									   test_3218 =
									      (aux_3219 == BNIL);
									}
									if (test_3218)
									  {	/* Ast/sexp.scm 71 */
									     var_1129 =
										CAR(cdr_502_28_1135);
									     val_1130 =
										CAR(cdr_506_2_1137);
									     {	/* Ast/sexp.scm 276 */
										obj_t loc_1144;
										loc_1144 =
										   find_location_loc_243_tools_location(exp_17, loc_19);
										{	/* Ast/sexp.scm 276 */
										   obj_t val_loc_228_1145;
										   val_loc_228_1145 =
										      find_location_loc_243_tools_location(val_1130, loc_1144);
										   {	/* Ast/sexp.scm 277 */
										      node_bglt val_1146;
										      val_1146 =
											 sexp__node_235_ast_sexp(val_1130, stack_18, val_loc_228_1145,
											 CNST_TABLE_REF(((long) 1)));
										      {		/* Ast/sexp.scm 278 */

											 {	/* Ast/sexp.scm 279 */
											    node_bglt ast_1147;
											    ast_1147 =
											       sexp__node_235_ast_sexp(var_1129, stack_18, loc_1144,
											       CNST_TABLE_REF(((long) 1)));
											    {	/* Ast/sexp.scm 280 */
											       bool_t test1769_1148;
											       {	/* Ast/sexp.scm 280 */
												  bool_t test1775_1154;
												  test1775_1154 =
												     is_a__118___object(
												     (obj_t) (ast_1147), var_ast_node);
												  if (test1775_1154)
												    {	/* ./Ast/var.scm 1517 */
												       obj_t aux_3231;
												       {	/* Ast/sexp.scm 280 */
													  variable_bglt aux_3232;
													  {	/* Ast/sexp.scm 280 */
													     var_bglt obj_2282;
													     obj_2282 =
														(var_bglt) (ast_1147);
													     aux_3232 =
														(((var_bglt) CREF(obj_2282))->variable);
													  }
													  aux_3231 =
													     (obj_t) (aux_3232);
												       }
												       test1769_1148 =
													  is_a__118___object(aux_3231, global_ast_var);
												    }
												  else
												    {	/* Ast/sexp.scm 280 */
												       test1769_1148 = ((bool_t) 0);
												    }
											       }
											       if (test1769_1148)
												 {	/* Ast/sexp.scm 280 */
												    {	/* Ast/sexp.scm 282 */
												       global_bglt obj_2285;
												       obj_t val1062_2286;
												       {	/* Ast/sexp.scm 282 */
													  variable_bglt aux_3238;
													  {	/* Ast/sexp.scm 282 */
													     var_bglt obj_2284;
													     obj_2284 =
														(var_bglt) (ast_1147);
													     aux_3238 =
														(((var_bglt) CREF(obj_2284))->variable);
													  }
													  obj_2285 =
													     (global_bglt) (aux_3238);
												       }
												       val1062_2286 =
													  (obj_t) (val_1146);
												       ((((global_bglt) CREF(obj_2285))->src) = ((obj_t) val1062_2286), BUNSPEC);
												    }
												    {	/* Ast/sexp.scm 283 */
												       obj_t arg1772_1151;
												       arg1772_1151 = _unspec__87_type_cache;
												       {	/* Ast/sexp.scm 283 */
													  setq_bglt res2100_2299;
													  {	/* Ast/sexp.scm 283 */
													     type_bglt type_2288;
													     var_bglt var_2289;
													     type_2288 =
														(type_bglt) (arg1772_1151);
													     var_2289 =
														(var_bglt) (ast_1147);
													     {	/* ./Ast/node.scm 1705 */
														setq_bglt new1304_2291;
														new1304_2291 =
														   ((setq_bglt) BREF(GC_MALLOC(sizeof(struct setq))));
														{	/* ./Ast/node.scm 1705 */
														   long arg2034_2292;
														   arg2034_2292 =
														      class_num_218___object(setq_ast_node);
														   {	/* ./Ast/node.scm 1705 */
														      obj_t obj_2297;
														      obj_2297 =
															 (obj_t) (new1304_2291);
														      (((obj_t) CREF(obj_2297))->header = MAKE_HEADER(arg2034_2292, 0), BUNSPEC);
														   }
														}
														{	/* ./Ast/node.scm 1705 */
														   object_bglt aux_3250;
														   aux_3250 =
														      (object_bglt) (new1304_2291);
														   OBJECT_WIDENING_SET(aux_3250, BFALSE);
														}
														((((setq_bglt) CREF(new1304_2291))->loc) = ((obj_t) loc_1144), BUNSPEC);
														((((setq_bglt) CREF(new1304_2291))->type) = ((type_bglt) type_2288), BUNSPEC);
														((((setq_bglt) CREF(new1304_2291))->var) = ((var_bglt) var_2289), BUNSPEC);
														((((setq_bglt) CREF(new1304_2291))->value) = ((node_bglt) val_1146), BUNSPEC);
														res2100_2299 = new1304_2291;
													     }
													  }
													  aux_3209 =
													     (obj_t) (res2100_2299);
												       }
												    }
												 }
											       else
												 {	/* Ast/sexp.scm 288 */
												    node_bglt aux_3258;
												    aux_3258 =
												       error_sexp__node_157_ast_sexp(string2117_ast_sexp, exp_17, loc_1144);
												    aux_3209 =
												       (obj_t) (aux_3258);
												 }
											    }
											 }
										      }
										   }
										}
									     }
									  }
									else
									  {	/* Ast/sexp.scm 71 */
									     node_bglt aux_3263;
									   tag_495_173_1132:
									     {	/* Ast/sexp.scm 292 */
										obj_t arg1778_1157;
										arg1778_1157 =
										   find_location_loc_243_tools_location(exp_17, loc_19);
										aux_3263 =
										   error_sexp__node_157_ast_sexp(string2116_ast_sexp, exp_17, arg1778_1157);
									     }
									     aux_3209 =
										(obj_t) (aux_3263);
									  }
								     }
								   else
								     {	/* Ast/sexp.scm 71 */
									node_bglt aux_3267;
									goto tag_495_173_1132;
									aux_3209 =
									   (obj_t) (aux_3267);
								     }
								}
							      else
								{	/* Ast/sexp.scm 71 */
								   node_bglt aux_3269;
								   goto tag_495_173_1132;
								   aux_3209 =
								      (obj_t) (aux_3269);
								}
							   }
							 else
							   {	/* Ast/sexp.scm 71 */
							      node_bglt aux_3271;
							      goto tag_495_173_1132;
							      aux_3209 =
								 (obj_t) (aux_3271);
							   }
						      }
						      return
							 (node_bglt) (aux_3209);
						   }
						 else
						   {	/* Ast/sexp.scm 71 */
						      obj_t car_196_45_785;
						      car_196_45_785 =
							 CAR(exp_17);
						      if (
							 PAIRP(car_196_45_785))
							{	/* Ast/sexp.scm 71 */
							   obj_t car_199_165_787;
							   obj_t cdr_200_91_788;
							   car_199_165_787 =
							      CAR(car_196_45_785);
							   cdr_200_91_788 =
							      CDR(car_196_45_785);
							   {

							      {		/* Ast/sexp.scm 71 */
								 bool_t test_3279;
								 {	/* ./Ieee/equiv.scm 5508 */
								    obj_t aux_3280;
								    aux_3280 =
								       CNST_TABLE_REF(((long) 12));
								    test_3279 =
								       (car_199_165_787 == aux_3280);
								 }
								 if (test_3279)
								   {	/* Ast/sexp.scm 71 */
								    kap_201_205_789:
								      if (
									 PAIRP(cdr_200_91_788))
									{	/* Ast/sexp.scm 71 */
									   obj_t cdr_204_81_803;
									   cdr_204_81_803 =
									      CDR(cdr_200_91_788);
									   if (
									      PAIRP(cdr_204_81_803))
									     {	/* Ast/sexp.scm 71 */
										bool_t test_3288;
										{	/* ./Ieee/equiv.scm 5508 */
										   obj_t aux_3289;
										   aux_3289 =
										      CDR(cdr_204_81_803);
										   test_3288 =
										      (aux_3289 == BNIL);
										}
										if (test_3288)
										  {	/* Ast/sexp.scm 71 */
										     body_756 =
											CAR(cdr_204_81_803);
										     args_757 =
											CDR(exp_17);
										     {	/* Ast/sexp.scm 297 */
											obj_t let_part_60_1158;
											let_part_60_1158 =
											   CAR(exp_17);
											{	/* Ast/sexp.scm 298 */
											   obj_t arg1779_1159;
											   obj_t arg1780_1160;
											   {	/* ./Ieee/pair-list.scm 5707 */
											      obj_t aux_3293;
											      aux_3293 =
												 CDR(let_part_60_1158);
											      arg1779_1159 =
												 CDR(aux_3293);
											   }
											   {	/* ./Ieee/pair-list.scm 5689 */
											      obj_t aux_3296;
											      aux_3296 =
												 append_2_18___r4_pairs_and_lists_6_3(args_757, BNIL);
											      arg1780_1160 =
												 MAKE_PAIR(body_756, aux_3296);
											   }
											   SET_CAR(arg1779_1159, arg1780_1160);
											}
											{
											   obj_t exp_3300;
											   exp_3300 = let_part_60_1158;
											   exp_17 = exp_3300;
											   goto sexp__node_235_ast_sexp;
											}
										     }
										  }
										else
										  {	/* Ast/sexp.scm 71 */
										     obj_t car_225_42_808;
										     car_225_42_808 =
											CAR(exp_17);
										     {	/* Ast/sexp.scm 71 */
											obj_t cdr_230_49_809;
											cdr_230_49_809 =
											   CDR(car_225_42_808);
											{	/* Ast/sexp.scm 71 */
											   bool_t test_3305;
											   {	/* ./Ieee/equiv.scm 5508 */
											      obj_t aux_3308;
											      obj_t aux_3306;
											      aux_3308 =
												 CNST_TABLE_REF(((long) 8));
											      aux_3306 =
												 CAR(car_225_42_808);
											      test_3305 =
												 (aux_3306 == aux_3308);
											   }
											   if (test_3305)
											     {	/* Ast/sexp.scm 71 */
												vars_761 =
												   CAR(cdr_230_49_809);
												body_762 =
												   CDR(cdr_230_49_809);
												args_763 =
												   CDR(exp_17);
											      tag_132_226_764:
												{	/* Ast/sexp.scm 308 */
												   obj_t loc_1162;
												   loc_1162 =
												      find_location_loc_243_tools_location(exp_17, loc_19);
												   {	/* Ast/sexp.scm 309 */
												      obj_t arg1782_1163;
												      {		/* Ast/sexp.scm 309 */
													 obj_t arg1783_1164;
													 obj_t arg1784_1165;
													 arg1783_1164 =
													    CNST_TABLE_REF(((long) 12));
													 {	/* Ast/sexp.scm 309 */
													    obj_t arg1785_1166;
													    obj_t arg1786_1167;
													    arg1785_1166 =
													       loop_ast_sexp(exp_17, loc_1162, vars_761, args_763);
													    {	/* Ast/sexp.scm 351 */
													       obj_t arg1832_1216;
													       {	/* Ast/sexp.scm 351 */
														  obj_t arg1834_1218;
														  obj_t arg1835_1219;
														  {	/* Ast/sexp.scm 351 */
														     obj_t arg1838_1221;
														     arg1838_1221 =
															current_function_76_tools_error();
														     arg1834_1218 =
															shape_tools_shape(arg1838_1221);
														  }
														  arg1835_1219 =
														     normalize_progn_143_tools_progn(body_762);
														  {	/* Ast/sexp.scm 355 */
														     obj_t _anonymous_1839__116_2655;
														     _anonymous_1839__116_2655 =
															make_fx_procedure(_anonymous_1839__116_ast_sexp, ((long) 3), ((long) 1));
														     PROCEDURE_SET(_anonymous_1839__116_2655, ((long) 0), loc_1162);
														     arg1832_1216 =
															make_dsssl_function_prelude_58___dsssl(arg1834_1218, vars_761, arg1835_1219, _anonymous_1839__116_2655);
														  }
													       }
													       arg1786_1167 =
														  MAKE_PAIR(arg1832_1216, BNIL);
													    }
													    arg1784_1165 =
													       MAKE_PAIR(arg1785_1166, arg1786_1167);
													 }
													 arg1782_1163 =
													    MAKE_PAIR(arg1783_1164, arg1784_1165);
												      }
												      {
													 obj_t loc_3324;
													 obj_t exp_3323;
													 exp_3323 = arg1782_1163;
													 loc_3324 = loc_1162;
													 loc_19 = loc_3324;
													 exp_17 = exp_3323;
													 goto sexp__node_235_ast_sexp;
												      }
												   }
												}
											     }
											   else
											     {	/* Ast/sexp.scm 71 */
											      tag_141_241_773:
												{	/* Ast/sexp.scm 458 */
												   obj_t caller_1338;
												   obj_t loc_1339;
												   caller_1338 =
												      CAR(exp_17);
												   loc_1339 =
												      find_location_loc_243_tools_location(exp_17, loc_19);
												   if (
												      SYMBOLP(caller_1338))
												     {	/* Ast/sexp.scm 462 */
													obj_t pid_1341;
													pid_1341 =
													   parse_id_241_ast_ident(caller_1338, loc_1339);
													{	/* Ast/sexp.scm 462 */
													   obj_t id_1342;
													   id_1342 =
													      CAR(pid_1341);
													   {	/* Ast/sexp.scm 463 */
													      obj_t type_1343;
													      type_1343 =
														 CDR(pid_1341);
													      {		/* Ast/sexp.scm 464 */

														 {	/* Ast/sexp.scm 465 */
														    bool_t test_3335;
														    {	/* ./Ieee/equiv.scm 5508 */
														       obj_t aux_3336;
														       aux_3336 =
															  CNST_TABLE_REF(((long) 6));
														       test_3335 =
															  (id_1342 == aux_3336);
														    }
														    if (test_3335)
														      {		/* Ast/sexp.scm 465 */
															 return
															    pragma_type__node_160_ast_pragma(((bool_t) 0),
															    (type_bglt) (type_1343), exp_17, stack_18, loc_1339, site_20);
														      }
														    else
														      {		/* Ast/sexp.scm 465 */
															 bool_t test_3341;
															 {	/* ./Ieee/equiv.scm 5508 */
															    obj_t aux_3342;
															    aux_3342 =
															       CNST_TABLE_REF(((long) 7));
															    test_3341 =
															       (id_1342 == aux_3342);
															 }
															 if (test_3341)
															   {	/* Ast/sexp.scm 465 */
															      return
																 pragma_type__node_160_ast_pragma(((bool_t) 1),
																 (type_bglt) (type_1343), exp_17, stack_18, loc_1339, site_20);
															   }
															 else
															   {	/* Ast/sexp.scm 465 */
															      bool_t test_3347;
															      {		/* ./Ieee/equiv.scm 5508 */
																 obj_t aux_3348;
																 aux_3348 =
																    CNST_TABLE_REF(((long) 8));
																 test_3347 =
																    (id_1342 == aux_3348);
															      }
															      if (test_3347)
																{
																   obj_t args_1348;
																   obj_t body_1349;
																   if (
																      PAIRP(exp_17))
																     {	/* Ast/sexp.scm 471 */
																	obj_t cdr_576_84_1354;
																	cdr_576_84_1354 =
																	   CDR(exp_17);
																	if (
																	   PAIRP(cdr_576_84_1354))
																	  {	/* Ast/sexp.scm 471 */
																	     args_1348 =
																		CAR(cdr_576_84_1354);
																	     body_1349 =
																		CDR(cdr_576_84_1354);
																	     {	/* Ast/sexp.scm 473 */
																		obj_t loc_1358;
																		loc_1358 =
																		   find_location_loc_243_tools_location(exp_17, loc_1339);
																		{	/* Ast/sexp.scm 473 */
																		   obj_t fun_1359;
																		   {	/* Ast/sexp.scm 474 */
																		      obj_t arg1939_1376;
																		      arg1939_1376 =
																			 PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4,
																			 CNST_TABLE_REF(((long) 8)), BEOA);
																		      fun_1359 =
																			 mark_symbol_non_user__17_ast_ident(arg1939_1376);
																		   }
																		   {	/* Ast/sexp.scm 474 */
																		      obj_t tfun_1360;
																		      {		/* Ast/sexp.scm 475 */
																			 obj_t list1936_1373;
																			 {	/* Ast/sexp.scm 475 */
																			    obj_t arg1937_1374;
																			    {	/* Ast/sexp.scm 475 */
																			       obj_t arg1938_1375;
																			       {	/* Ast/sexp.scm 475 */
																				  obj_t aux_3361;
																				  {	/* Ast/sexp.scm 477 */
																				     type_bglt obj_2445;
																				     obj_2445 =
																					(type_bglt) (type_1343);
																				     aux_3361 =
																					(((type_bglt) CREF(obj_2445))->id);
																				  }
																				  arg1938_1375 =
																				     MAKE_PAIR(aux_3361, BNIL);
																			       }
																			       arg1937_1374 =
																				  MAKE_PAIR(_4dots_199_tools_misc, arg1938_1375);
																			    }
																			    list1936_1373 =
																			       MAKE_PAIR(fun_1359, arg1937_1374);
																			 }
																			 tfun_1360 =
																			    symbol_append_197___r4_symbols_6_4(list1936_1373);
																		      }
																		      {		/* Ast/sexp.scm 475 */

																			 {	/* Ast/sexp.scm 479 */
																			    obj_t arg1924_1361;
																			    {	/* Ast/sexp.scm 479 */
																			       obj_t arg1925_1362;
																			       obj_t arg1926_1363;
																			       arg1925_1362 =
																				  CNST_TABLE_REF(((long) 9));
																			       {	/* Ast/sexp.scm 479 */
																				  obj_t arg1927_1364;
																				  obj_t arg1928_1365;
																				  {	/* Ast/sexp.scm 479 */
																				     obj_t arg1929_1366;
																				     {	/* Ast/sexp.scm 479 */
																					obj_t arg1931_1368;
																					{	/* Ast/sexp.scm 479 */
																					   obj_t arg1932_1369;
																					   {	/* Ast/sexp.scm 479 */
																					      obj_t arg1933_1370;
																					      arg1933_1370 =
																						 normalize_progn_143_tools_progn(body_1349);
																					      arg1932_1369 =
																						 MAKE_PAIR(arg1933_1370, BNIL);
																					   }
																					   arg1931_1368 =
																					      MAKE_PAIR(args_1348, arg1932_1369);
																					}
																					arg1929_1366 =
																					   MAKE_PAIR(tfun_1360, arg1931_1368);
																				     }
																				     arg1927_1364 =
																					MAKE_PAIR(arg1929_1366, BNIL);
																				  }
																				  arg1928_1365 =
																				     MAKE_PAIR(fun_1359, BNIL);
																				  arg1926_1363 =
																				     MAKE_PAIR(arg1927_1364, arg1928_1365);
																			       }
																			       arg1924_1361 =
																				  MAKE_PAIR(arg1925_1362, arg1926_1363);
																			    }
																			    {
																			       obj_t loc_3378;
																			       obj_t exp_3377;
																			       exp_3377 = arg1924_1361;
																			       loc_3378 = loc_1358;
																			       loc_19 = loc_3378;
																			       exp_17 = exp_3377;
																			       goto sexp__node_235_ast_sexp;
																			    }
																			 }
																		      }
																		   }
																		}
																	     }
																	  }
																	else
																	  {	/* Ast/sexp.scm 471 */
																	   tag_569_3_1351:
																	     return
																		error_sexp__node_157_ast_sexp(string2112_ast_sexp, exp_17, loc_1339);
																	  }
																     }
																   else
																     {	/* Ast/sexp.scm 471 */
																	goto tag_569_3_1351;
																     }
																}
															      else
																{	/* Ast/sexp.scm 465 */
																   return
																      application__node_43_ast_app(exp_17, stack_18, loc_1339, site_20);
																}
															   }
														      }
														 }
													      }
													   }
													}
												     }
												   else
												     {	/* Ast/sexp.scm 460 */
													return
													   application__node_43_ast_app(exp_17, stack_18, loc_1339, site_20);
												     }
												}
											     }
											}
										     }
										  }
									     }
									   else
									     {	/* Ast/sexp.scm 71 */
										obj_t car_253_251_818;
										car_253_251_818 =
										   CAR(exp_17);
										{	/* Ast/sexp.scm 71 */
										   obj_t cdr_258_124_819;
										   cdr_258_124_819 =
										      CDR(car_253_251_818);
										   {	/* Ast/sexp.scm 71 */
										      bool_t test_3386;
										      {		/* ./Ieee/equiv.scm 5508 */
											 obj_t aux_3389;
											 obj_t aux_3387;
											 aux_3389 =
											    CNST_TABLE_REF(((long) 8));
											 aux_3387 =
											    CAR(car_253_251_818);
											 test_3386 =
											    (aux_3387 == aux_3389);
										      }
										      if (test_3386)
											{
											   obj_t args_3396;
											   obj_t body_3394;
											   obj_t vars_3392;
											   vars_3392 =
											      CAR(cdr_258_124_819);
											   body_3394 =
											      CDR(cdr_258_124_819);
											   args_3396 =
											      CDR(exp_17);
											   args_763 = args_3396;
											   body_762 = body_3394;
											   vars_761 = vars_3392;
											   goto tag_132_226_764;
											}
										      else
											{	/* Ast/sexp.scm 71 */
											   goto tag_141_241_773;
											}
										   }
										}
									     }
									}
								      else
									{	/* Ast/sexp.scm 71 */
									   goto tag_141_241_773;
									}
								   }
								 else
								   {	/* Ast/sexp.scm 71 */
								      bool_t test_3398;
								      {		/* ./Ieee/equiv.scm 5508 */
									 obj_t aux_3399;
									 aux_3399 =
									    CNST_TABLE_REF(((long) 25));
									 test_3398 =
									    (car_199_165_787 == aux_3399);
								      }
								      if (test_3398)
									{	/* Ast/sexp.scm 71 */
									   goto kap_201_205_789;
									}
								      else
									{	/* Ast/sexp.scm 71 */
									   bool_t test_3402;
									   {	/* ./Ieee/equiv.scm 5508 */
									      obj_t aux_3403;
									      aux_3403 =
										 CNST_TABLE_REF(((long) 9));
									      test_3402 =
										 (car_199_165_787 == aux_3403);
									   }
									   if (test_3402)
									     {	/* Ast/sexp.scm 71 */
										goto kap_201_205_789;
									     }
									   else
									     {	/* Ast/sexp.scm 71 */
										obj_t cdr_302_164_794;
										cdr_302_164_794 =
										   CDR(car_196_45_785);
										{	/* Ast/sexp.scm 71 */
										   bool_t test_3407;
										   {	/* ./Ieee/equiv.scm 5508 */
										      obj_t aux_3410;
										      obj_t aux_3408;
										      aux_3410 =
											 CNST_TABLE_REF(((long) 8));
										      aux_3408 =
											 CAR(car_196_45_785);
										      test_3407 =
											 (aux_3408 == aux_3410);
										   }
										   if (test_3407)
										     {	/* Ast/sexp.scm 71 */
											if (
											   PAIRP(cdr_302_164_794))
											  {
											     obj_t args_3419;
											     obj_t body_3417;
											     obj_t vars_3415;
											     vars_3415 =
												CAR(cdr_302_164_794);
											     body_3417 =
												CDR(cdr_302_164_794);
											     args_3419 =
												CDR(exp_17);
											     args_763 = args_3419;
											     body_762 = body_3417;
											     vars_761 = vars_3415;
											     goto tag_132_226_764;
											  }
											else
											  {	/* Ast/sexp.scm 71 */
											     goto tag_141_241_773;
											  }
										     }
										   else
										     {	/* Ast/sexp.scm 71 */
											goto tag_141_241_773;
										     }
										}
									     }
									}
								   }
							      }
							   }
							}
						      else
							{	/* Ast/sexp.scm 71 */
							   bool_t test_3421;
							   {	/* ./Ieee/equiv.scm 5508 */
							      obj_t aux_3422;
							      aux_3422 =
								 CNST_TABLE_REF(((long) 12));
							      test_3421 =
								 (car_196_45_785 == aux_3422);
							   }
							   if (test_3421)
							     {	/* Ast/sexp.scm 71 */
							      tag_130_214_759:
								return
								   let__node_121_ast_let(exp_17, stack_18, loc_19,
								   CNST_TABLE_REF(((long) 1)));
							     }
							   else
							     {	/* Ast/sexp.scm 71 */
								bool_t test_3427;
								{	/* ./Ieee/equiv.scm 5508 */
								   obj_t aux_3428;
								   aux_3428 =
								      CNST_TABLE_REF(((long) 25));
								   test_3427 =
								      (car_196_45_785 == aux_3428);
								}
								if (test_3427)
								  {	/* Ast/sexp.scm 71 */
								     goto tag_130_214_759;
								  }
								else
								  {	/* Ast/sexp.scm 71 */
								     bool_t test_3431;
								     {	/* ./Ieee/equiv.scm 5508 */
									obj_t aux_3432;
									aux_3432 =
									   CNST_TABLE_REF(((long) 9));
									test_3431 =
									   (car_196_45_785 == aux_3432);
								     }
								     if (test_3431)
								       {	/* Ast/sexp.scm 71 */
									  let_fun_218_bglt aux_3435;
									  aux_3435 =
									     labels__node_197_ast_labels(exp_17, stack_18, loc_19,
									     CNST_TABLE_REF(((long) 1)));
									  return
									     (node_bglt) (aux_3435);
								       }
								     else
								       {	/* Ast/sexp.scm 71 */
									  bool_t test_3439;
									  {	/* ./Ieee/equiv.scm 5508 */
									     obj_t aux_3440;
									     aux_3440 =
										CNST_TABLE_REF(((long) 8));
									     test_3439 =
										(car_196_45_785 == aux_3440);
									  }
									  if (test_3439)
									    {	/* Ast/sexp.scm 71 */
									       {
										  obj_t args_1228;
										  obj_t body_1229;
										  if (
										     PAIRP(exp_17))
										    {	/* Ast/sexp.scm 71 */
										       obj_t cdr_520_55_1234;
										       cdr_520_55_1234 =
											  CDR(exp_17);
										       if (
											  PAIRP(cdr_520_55_1234))
											 {	/* Ast/sexp.scm 71 */
											    args_1228 =
											       CAR(cdr_520_55_1234);
											    body_1229 =
											       CDR(cdr_520_55_1234);
											    {	/* Ast/sexp.scm 363 */
											       obj_t loc_1238;
											       loc_1238 =
												  find_location_loc_243_tools_location(exp_17, loc_19);
											       {	/* Ast/sexp.scm 363 */
												  obj_t fun_1239;
												  {	/* Ast/sexp.scm 364 */
												     obj_t arg1856_1251;
												     arg1856_1251 =
													PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4, string2115_ast_sexp, BEOA);
												     {	/* Ast/sexp.scm 364 */
													obj_t list1858_1253;
													{	/* Ast/sexp.scm 364 */
													   obj_t arg1859_1254;
													   {	/* Ast/sexp.scm 364 */
													      obj_t aux_3451;
													      aux_3451 =
														 CNST_TABLE_REF(((long) 11));
													      arg1859_1254 =
														 MAKE_PAIR(aux_3451, BNIL);
													   }
													   list1858_1253 =
													      MAKE_PAIR(arg1856_1251, arg1859_1254);
													}
													fun_1239 =
													   symbol_append_197___r4_symbols_6_4(list1858_1253);
												     }
												  }
												  {	/* Ast/sexp.scm 364 */

												     {	/* Ast/sexp.scm 365 */
													obj_t arg1845_1240;
													{	/* Ast/sexp.scm 365 */
													   obj_t arg1846_1241;
													   obj_t arg1847_1242;
													   arg1846_1241 =
													      CNST_TABLE_REF(((long) 9));
													   {	/* Ast/sexp.scm 365 */
													      obj_t arg1848_1243;
													      obj_t arg1849_1244;
													      {		/* Ast/sexp.scm 365 */
														 obj_t arg1850_1245;
														 {	/* Ast/sexp.scm 365 */
														    obj_t arg1852_1247;
														    {	/* Ast/sexp.scm 365 */
														       obj_t arg1853_1248;
														       {	/* Ast/sexp.scm 365 */
															  obj_t arg1854_1249;
															  arg1854_1249 =
															     normalize_progn_143_tools_progn(body_1229);
															  arg1853_1248 =
															     MAKE_PAIR(arg1854_1249, BNIL);
														       }
														       arg1852_1247 =
															  MAKE_PAIR(args_1228, arg1853_1248);
														    }
														    arg1850_1245 =
														       MAKE_PAIR(fun_1239, arg1852_1247);
														 }
														 arg1848_1243 =
														    MAKE_PAIR(arg1850_1245, BNIL);
													      }
													      arg1849_1244 =
														 MAKE_PAIR(fun_1239, BNIL);
													      arg1847_1242 =
														 MAKE_PAIR(arg1848_1243, arg1849_1244);
													   }
													   arg1845_1240 =
													      MAKE_PAIR(arg1846_1241, arg1847_1242);
													}
													{
													   obj_t loc_3466;
													   obj_t exp_3465;
													   exp_3465 = arg1845_1240;
													   loc_3466 = loc_1238;
													   loc_19 = loc_3466;
													   exp_17 = exp_3465;
													   goto sexp__node_235_ast_sexp;
													}
												     }
												  }
											       }
											    }
											 }
										       else
											 {	/* Ast/sexp.scm 71 */
											  tag_513_88_1231:
											    {	/* Ast/sexp.scm 370 */
											       obj_t arg1861_1256;
											       arg1861_1256 =
												  find_location_loc_243_tools_location(exp_17, loc_19);
											       return
												  error_sexp__node_157_ast_sexp(string2112_ast_sexp, exp_17, arg1861_1256);
											    }
											 }
										    }
										  else
										    {	/* Ast/sexp.scm 71 */
										       goto tag_513_88_1231;
										    }
									       }
									    }
									  else
									    {	/* Ast/sexp.scm 71 */
									       bool_t test_3471;
									       {	/* ./Ieee/equiv.scm 5508 */
										  obj_t aux_3472;
										  aux_3472 =
										     CNST_TABLE_REF(((long) 6));
										  test_3471 =
										     (car_196_45_785 == aux_3472);
									       }
									       if (test_3471)
										 {	/* Ast/sexp.scm 71 */
										    return
										       pragma_type__node_160_ast_pragma(((bool_t) 0),
										       (type_bglt) (_unspec__87_type_cache), exp_17, stack_18, loc_19, site_20);
										 }
									       else
										 {	/* Ast/sexp.scm 71 */
										    bool_t test_3477;
										    {	/* ./Ieee/equiv.scm 5508 */
										       obj_t aux_3478;
										       aux_3478 =
											  CNST_TABLE_REF(((long) 7));
										       test_3477 =
											  (car_196_45_785 == aux_3478);
										    }
										    if (test_3477)
										      {		/* Ast/sexp.scm 71 */
											 return
											    pragma_type__node_160_ast_pragma(((bool_t) 1),
											    (type_bglt) (_unspec__87_type_cache), exp_17, stack_18, loc_19, site_20);
										      }
										    else
										      {		/* Ast/sexp.scm 71 */
											 bool_t test_3483;
											 {	/* ./Ieee/equiv.scm 5508 */
											    obj_t aux_3484;
											    aux_3484 =
											       CNST_TABLE_REF(((long) 26));
											    test_3483 =
											       (car_196_45_785 == aux_3484);
											 }
											 if (test_3483)
											   {	/* Ast/sexp.scm 71 */
											      obj_t aux_3487;
											      {
												 obj_t proc_1257;
												 obj_t msg_1258;
												 obj_t obj_1259;
												 if (
												    PAIRP(exp_17))
												   {	/* Ast/sexp.scm 71 */
												      obj_t cdr_537_243_1264;
												      cdr_537_243_1264 =
													 CDR(exp_17);
												      if (
													 PAIRP(cdr_537_243_1264))
													{	/* Ast/sexp.scm 71 */
													   obj_t cdr_542_204_1266;
													   cdr_542_204_1266 =
													      CDR(cdr_537_243_1264);
													   if (
													      PAIRP(cdr_542_204_1266))
													     {	/* Ast/sexp.scm 71 */
														obj_t cdr_547_94_1268;
														cdr_547_94_1268 =
														   CDR(cdr_542_204_1266);
														if (
														   PAIRP(cdr_547_94_1268))
														  {	/* Ast/sexp.scm 71 */
														     bool_t test_3499;
														     {	/* ./Ieee/equiv.scm 5508 */
															obj_t aux_3500;
															aux_3500 =
															   CDR(cdr_547_94_1268);
															test_3499 =
															   (aux_3500 == BNIL);
														     }
														     if (test_3499)
														       {	/* Ast/sexp.scm 71 */
															  fail_bglt aux_3503;
															  proc_1257 =
															     CAR(cdr_537_243_1264);
															  msg_1258 =
															     CAR(cdr_542_204_1266);
															  obj_1259 =
															     CAR(cdr_547_94_1268);
															  {	/* Ast/sexp.scm 383 */
															     obj_t loc_1276;
															     loc_1276 =
																find_location_loc_243_tools_location(exp_17, loc_19);
															     {	/* Ast/sexp.scm 383 */
																obj_t loc_proc_248_1277;
																loc_proc_248_1277 =
																   find_location_loc_243_tools_location(proc_1257, loc_1276);
																{	/* Ast/sexp.scm 384 */
																   obj_t loc_msg_36_1278;
																   loc_msg_36_1278 =
																      find_location_loc_243_tools_location(msg_1258, loc_1276);
																   {	/* Ast/sexp.scm 385 */
																      obj_t loc_obj_88_1279;
																      loc_obj_88_1279 =
																	 find_location_loc_243_tools_location(obj_1259, loc_1276);
																      {		/* Ast/sexp.scm 386 */
																	 node_bglt proc_1280;
																	 proc_1280 =
																	    sexp__node_235_ast_sexp(proc_1257, stack_18, loc_proc_248_1277,
																	    CNST_TABLE_REF(((long) 1)));
																	 {	/* Ast/sexp.scm 387 */
																	    node_bglt msg_1281;
																	    msg_1281 =
																	       sexp__node_235_ast_sexp(msg_1258, stack_18, loc_msg_36_1278,
																	       CNST_TABLE_REF(((long) 1)));
																	    {	/* Ast/sexp.scm 388 */
																	       node_bglt obj_1282;
																	       obj_1282 =
																		  sexp__node_235_ast_sexp(obj_1259, stack_18, loc_obj_88_1279,
																		  CNST_TABLE_REF(((long) 1)));
																	       {	/* Ast/sexp.scm 389 */

																		  {	/* Ast/sexp.scm 390 */
																		     obj_t arg1873_1284;
																		     arg1873_1284 = _magic__144_type_cache;
																		     {	/* Ast/sexp.scm 390 */
																			fail_bglt res2101_2388;
																			{	/* Ast/sexp.scm 390 */
																			   type_bglt type_2375;
																			   type_2375 =
																			      (type_bglt) (arg1873_1284);
																			   {	/* ./Ast/node.scm 1721 */
																			      fail_bglt new1331_2379;
																			      new1331_2379 =
																				 ((fail_bglt) BREF(GC_MALLOC(sizeof(struct fail))));
																			      {		/* ./Ast/node.scm 1721 */
																				 long arg2030_2380;
																				 arg2030_2380 =
																				    class_num_218___object(fail_ast_node);
																				 {	/* ./Ast/node.scm 1721 */
																				    obj_t obj_2386;
																				    obj_2386 =
																				       (obj_t) (new1331_2379);
																				    (((obj_t) CREF(obj_2386))->header = MAKE_HEADER(arg2030_2380, 0), BUNSPEC);
																				 }
																			      }
																			      {		/* ./Ast/node.scm 1721 */
																				 object_bglt aux_3519;
																				 aux_3519 =
																				    (object_bglt) (new1331_2379);
																				 OBJECT_WIDENING_SET(aux_3519, BFALSE);
																			      }
																			      ((((fail_bglt) CREF(new1331_2379))->loc) = ((obj_t) loc_1276), BUNSPEC);
																			      ((((fail_bglt) CREF(new1331_2379))->type) = ((type_bglt) type_2375), BUNSPEC);
																			      ((((fail_bglt) CREF(new1331_2379))->proc) = ((node_bglt) proc_1280), BUNSPEC);
																			      ((((fail_bglt) CREF(new1331_2379))->msg) = ((node_bglt) msg_1281), BUNSPEC);
																			      ((((fail_bglt) CREF(new1331_2379))->obj) = ((node_bglt) obj_1282), BUNSPEC);
																			      res2101_2388 = new1331_2379;
																			   }
																			}
																			aux_3503 = res2101_2388;
																		     }
																		  }
																	       }
																	    }
																	 }
																      }
																   }
																}
															     }
															  }
															  aux_3487 =
															     (obj_t) (aux_3503);
														       }
														     else
														       {	/* Ast/sexp.scm 71 */
															  node_bglt aux_3531;
															tag_528_229_1261:
															  {	/* Ast/sexp.scm 396 */
															     obj_t arg1879_1289;
															     arg1879_1289 =
																find_location_loc_243_tools_location(exp_17, loc_19);
															     aux_3531 =
																error_sexp__node_157_ast_sexp(string2114_ast_sexp, exp_17, arg1879_1289);
															  }
															  aux_3487 =
															     (obj_t) (aux_3531);
														       }
														  }
														else
														  {	/* Ast/sexp.scm 71 */
														     node_bglt aux_3535;
														     goto tag_528_229_1261;
														     aux_3487 =
															(obj_t) (aux_3535);
														  }
													     }
													   else
													     {	/* Ast/sexp.scm 71 */
														node_bglt aux_3537;
														goto tag_528_229_1261;
														aux_3487 =
														   (obj_t) (aux_3537);
													     }
													}
												      else
													{	/* Ast/sexp.scm 71 */
													   node_bglt aux_3539;
													   goto tag_528_229_1261;
													   aux_3487 =
													      (obj_t) (aux_3539);
													}
												   }
												 else
												   {	/* Ast/sexp.scm 71 */
												      node_bglt aux_3541;
												      goto tag_528_229_1261;
												      aux_3487 =
													 (obj_t) (aux_3541);
												   }
											      }
											      return
												 (node_bglt) (aux_3487);
											   }
											 else
											   {	/* Ast/sexp.scm 71 */
											      bool_t test_3544;
											      {		/* ./Ieee/equiv.scm 5508 */
												 obj_t aux_3545;
												 aux_3545 =
												    CNST_TABLE_REF(((long) 27));
												 test_3544 =
												    (car_196_45_785 == aux_3545);
											      }
											      if (test_3544)
												{	/* Ast/sexp.scm 71 */
												   obj_t aux_3548;
												   {
												      obj_t test_1290;
												      obj_t clauses_1291;
												      if (
													 PAIRP(exp_17))
													{	/* Ast/sexp.scm 71 */
													   obj_t cdr_561_35_1296;
													   cdr_561_35_1296 =
													      CDR(exp_17);
													   if (
													      PAIRP(cdr_561_35_1296))
													     {	/* Ast/sexp.scm 71 */
														test_1290 =
														   CAR(cdr_561_35_1296);
														clauses_1291 =
														   CDR(cdr_561_35_1296);
														{	/* Ast/sexp.scm 409 */
														   obj_t loc_1300;
														   loc_1300 =
														      find_location_loc_243_tools_location(exp_17, loc_19);
														   {	/* Ast/sexp.scm 409 */
														      node_bglt test_1301;
														      {		/* Ast/sexp.scm 412 */
															 obj_t arg1912_1334;
															 obj_t arg1913_1335;
															 arg1912_1334 =
															    find_location_loc_243_tools_location(test_1290, loc_1300);
															 arg1913_1335 =
															    CNST_TABLE_REF(((long) 1));
															 test_1301 =
															    sexp__node_235_ast_sexp(test_1290, stack_18, arg1912_1334, arg1913_1335);
														      }
														      {		/* Ast/sexp.scm 410 */

															 {
															    obj_t cls_1302;
															    obj_t nclauses_1303;
															    cls_1302 = clauses_1291;
															    nclauses_1303 = BNIL;
															  loop_1304:
															    if (
															       NULLP(cls_1302))
															      {		/* Ast/sexp.scm 417 */
																 obj_t arg1886_1307;
																 obj_t arg1889_1310;
																 type_bglt arg1890_1311;
																 arg1886_1307 = ____74_type_cache;
																 arg1889_1310 =
																    reverse__39___r4_pairs_and_lists_6_3(nclauses_1303);
																 {	/* Ast/sexp.scm 421 */
																    obj_t aux_3561;
																    {	/* ./Ieee/pair-list.scm 5701 */
																       obj_t aux_3562;
																       {	/* ./Ieee/pair-list.scm 5701 */
																	  obj_t aux_3563;
																	  aux_3563 =
																	     CAR(clauses_1291);
																	  aux_3562 =
																	     CAR(aux_3563);
																       }
																       aux_3561 =
																	  CAR(aux_3562);
																    }
																    arg1890_1311 =
																       typeof_atom_134_type_typeof(aux_3561);
																 }
																 {	/* Ast/sexp.scm 417 */
																    select_bglt res2102_2416;
																    {	/* Ast/sexp.scm 417 */
																       type_bglt type_2399;
																       obj_t key_2401;
																       type_2399 =
																	  (type_bglt) (arg1886_1307);
																       key_2401 =
																	  BINT(((long) -1));
																       {	/* ./Ast/node.scm 1728 */
																	  select_bglt new1343_2405;
																	  new1343_2405 =
																	     ((select_bglt) BREF(GC_MALLOC(sizeof(struct select))));
																	  {	/* ./Ast/node.scm 1728 */
																	     long arg2028_2406;
																	     arg2028_2406 =
																		class_num_218___object(select_ast_node);
																	     {	/* ./Ast/node.scm 1728 */
																		obj_t obj_2414;
																		obj_2414 =
																		   (obj_t) (new1343_2405);
																		(((obj_t) CREF(obj_2414))->header = MAKE_HEADER(arg2028_2406, 0), BUNSPEC);
																	     }
																	  }
																	  {	/* ./Ast/node.scm 1728 */
																	     object_bglt aux_3574;
																	     aux_3574 =
																		(object_bglt) (new1343_2405);
																	     OBJECT_WIDENING_SET(aux_3574, BFALSE);
																	  }
																	  ((((select_bglt) CREF(new1343_2405))->loc) = ((obj_t) loc_1300), BUNSPEC);
																	  ((((select_bglt) CREF(new1343_2405))->type) = ((type_bglt) type_2399), BUNSPEC);
																	  ((((select_bglt) CREF(new1343_2405))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
																	  ((((select_bglt) CREF(new1343_2405))->key) = ((obj_t) key_2401), BUNSPEC);
																	  ((((select_bglt) CREF(new1343_2405))->test) = ((node_bglt) test_1301), BUNSPEC);
																	  ((((select_bglt) CREF(new1343_2405))->clauses) = ((obj_t) arg1889_1310), BUNSPEC);
																	  ((((select_bglt) CREF(new1343_2405))->item_type_130) = ((type_bglt) arg1890_1311), BUNSPEC);
																	  res2102_2416 = new1343_2405;
																       }
																    }
																    aux_3548 =
																       (obj_t) (res2102_2416);
																 }
															      }
															    else
															      {		/* Ast/sexp.scm 423 */
																 obj_t clause_1315;
																 clause_1315 =
																    CAR(cls_1302);
																 {	/* Ast/sexp.scm 423 */
																    node_bglt body_1316;
																    {	/* Ast/sexp.scm 424 */
																       obj_t arg1906_1330;
																       obj_t arg1907_1331;
																       obj_t arg1909_1332;
																       arg1906_1330 =
																	  normalize_progn_143_tools_progn(
																	  CDR(clause_1315));
																       arg1907_1331 =
																	  find_location_loc_243_tools_location(clause_1315, loc_1300);
																       arg1909_1332 =
																	  CNST_TABLE_REF(((long) 1));
																       body_1316 =
																	  sexp__node_235_ast_sexp(arg1906_1330, stack_18, arg1907_1331, arg1909_1332);
																    }
																    {	/* Ast/sexp.scm 424 */
																       obj_t nclause_1317;
																       {	/* ./Ieee/pair-list.scm 5689 */
																	  obj_t aux_3593;
																	  obj_t aux_3591;
																	  aux_3593 =
																	     (obj_t) (body_1316);
																	  aux_3591 =
																	     CAR(clause_1315);
																	  nclause_1317 =
																	     MAKE_PAIR(aux_3591, aux_3593);
																       }
																       {	/* Ast/sexp.scm 428 */

																	  {	/* Ast/sexp.scm 430 */
																	     bool_t test_3596;
																	     {	/* Ast/sexp.scm 430 */
																		bool_t test_3597;
																		{	/* ./Ieee/equiv.scm 5508 */
																		   obj_t aux_3600;
																		   obj_t aux_3598;
																		   aux_3600 =
																		      CNST_TABLE_REF(((long) 10));
																		   aux_3598 =
																		      CAR(clause_1315);
																		   test_3597 =
																		      (aux_3598 == aux_3600);
																		}
																		if (test_3597)
																		  {	/* Ast/sexp.scm 431 */
																		     bool_t test_3603;
																		     {	/* ./Ieee/pair-list.scm 5912 */
																			obj_t aux_3604;
																			aux_3604 =
																			   CDR(cls_1302);
																			test_3603 =
																			   NULLP(aux_3604);
																		     }
																		     if (test_3603)
																		       {	/* Ast/sexp.scm 431 */
																			  test_3596 = ((bool_t) 0)
																			     ;
																		       }
																		     else
																		       {	/* Ast/sexp.scm 431 */
																			  test_3596 = ((bool_t) 1)
																			     ;
																		       }
																		  }
																		else
																		  {	/* Ast/sexp.scm 430 */
																		     test_3596 = ((bool_t) 0)
																			;
																		  }
																	     }
																	     if (test_3596)
																	       {	/* Ast/sexp.scm 432 */
																		  obj_t arg1896_1320;
																		  arg1896_1320 =
																		     find_location_loc_243_tools_location(exp_17, loc_1300);
																		  {	/* Ast/sexp.scm 432 */
																		     node_bglt aux_3608;
																		     aux_3608 =
																			error_sexp__node_157_ast_sexp(string2113_ast_sexp, arg1896_1320, exp_17);
																		     aux_3548 =
																			(obj_t) (aux_3608);
																		  }
																	       }
																	     else
																	       {	/* Ast/sexp.scm 435 */
																		  obj_t arg1897_1321;
																		  obj_t arg1898_1322;
																		  arg1897_1321 =
																		     CDR(cls_1302);
																		  {	/* Ast/sexp.scm 436 */
																		     obj_t arg1899_1323;
																		     arg1899_1323 =
																			epairify_tools_misc(nclause_1317, clause_1315);
																		     arg1898_1322 =
																			MAKE_PAIR(arg1899_1323, nclauses_1303);
																		  }
																		  {
																		     obj_t nclauses_3615;
																		     obj_t cls_3614;
																		     cls_3614 = arg1897_1321;
																		     nclauses_3615 = arg1898_1322;
																		     nclauses_1303 = nclauses_3615;
																		     cls_1302 = cls_3614;
																		     goto loop_1304;
																		  }
																	       }
																	  }
																       }
																    }
																 }
															      }
															 }
														      }
														   }
														}
													     }
													   else
													     {	/* Ast/sexp.scm 71 */
														node_bglt aux_3618;
													      tag_554_132_1293:
														{	/* Ast/sexp.scm 439 */
														   obj_t arg1915_1337;
														   arg1915_1337 =
														      find_location_loc_243_tools_location(exp_17, loc_19);
														   aux_3618 =
														      error_sexp__node_157_ast_sexp(string2113_ast_sexp, arg1915_1337, exp_17);
														}
														aux_3548 =
														   (obj_t) (aux_3618);
													     }
													}
												      else
													{	/* Ast/sexp.scm 71 */
													   node_bglt aux_3622;
													   goto tag_554_132_1293;
													   aux_3548 =
													      (obj_t) (aux_3622);
													}
												   }
												   return
												      (node_bglt) (aux_3548);
												}
											      else
												{	/* Ast/sexp.scm 71 */
												   bool_t test_3625;
												   {	/* ./Ieee/equiv.scm 5508 */
												      obj_t aux_3626;
												      aux_3626 =
													 CNST_TABLE_REF(((long) 28));
												      test_3625 =
													 (car_196_45_785 == aux_3626);
												   }
												   if (test_3625)
												     {	/* Ast/sexp.scm 71 */
													let_fun_218_bglt aux_3629;
													aux_3629 =
													   set_exit__node_102_ast_exit(exp_17, stack_18, loc_19, site_20);
													return
													   (node_bglt) (aux_3629);
												     }
												   else
												     {	/* Ast/sexp.scm 71 */
													bool_t test_3632;
													{	/* ./Ieee/equiv.scm 5508 */
													   obj_t aux_3633;
													   aux_3633 =
													      CNST_TABLE_REF(((long) 29));
													   test_3632 =
													      (car_196_45_785 == aux_3633);
													}
													if (test_3632)
													  {	/* Ast/sexp.scm 71 */
													     jump_ex_it_184_bglt aux_3636;
													     aux_3636 =
														jump_exit__node_34_ast_exit(exp_17, stack_18, loc_19, site_20);
													     return
														(node_bglt) (aux_3636);
													  }
													else
													  {	/* Ast/sexp.scm 71 */
													     bool_t test_3639;
													     {	/* ./Ieee/equiv.scm 5508 */
														obj_t aux_3640;
														aux_3640 =
														   CNST_TABLE_REF(((long) 30));
														test_3639 =
														   (car_196_45_785 == aux_3640);
													     }
													     if (test_3639)
													       {	/* Ast/sexp.scm 71 */
														  return
														     applycation__node_122_ast_apply(exp_17, stack_18, loc_19, site_20);
													       }
													     else
													       {	/* Ast/sexp.scm 71 */
														  goto tag_141_241_773;
													       }
													  }
												     }
												}
											   }
										      }
										 }
									    }
								       }
								  }
							     }
							}
						   }
					      }
					 }
				    }
			       }
			  }
		     }
		   else
		     {	/* Ast/sexp.scm 71 */
			obj_t aux_3644;
			atom_747 = exp_17;
			if (
			   SYMBOLP(atom_747))
			  {	/* Ast/sexp.scm 103 */
			     bool_t test1561_869;
			     {	/* Ast/sexp.scm 103 */
				obj_t aux_3647;
				aux_3647 =
				   lookup_ast_sexp(atom_747, stack_18);
				test1561_869 =
				   CBOOL(aux_3647);
			     }
			     if (test1561_869)
			       {	/* Ast/sexp.scm 103 */
				  {	/* Ast/sexp.scm 104 */
				     obj_t local_870;
				     local_870 =
					lookup_ast_sexp(atom_747, stack_18);
				     {	/* Ast/sexp.scm 104 */
					obj_t var_871;
					{	/* Ast/sexp.scm 105 */
					   bool_t test1562_872;
					   {	/* Ast/sexp.scm 105 */
					      bool_t test_3652;
					      {		/* ./Ieee/equiv.scm 5508 */
						 obj_t aux_3653;
						 aux_3653 =
						    CNST_TABLE_REF(((long) 20));
						 test_3652 =
						    (site_20 == aux_3653);
					      }
					      if (test_3652)
						{	/* Ast/sexp.scm 105 */
						   test1562_872 = ((bool_t) 0);
						}
					      else
						{	/* ./Ast/var.scm 1543 */
						   obj_t aux_3656;
						   {	/* Ast/sexp.scm 106 */
						      value_bglt aux_3657;
						      {		/* Ast/sexp.scm 106 */
							 local_bglt obj_1903;
							 obj_1903 =
							    (local_bglt) (local_870);
							 aux_3657 =
							    (((local_bglt) CREF(obj_1903))->value);
						      }
						      aux_3656 =
							 (obj_t) (aux_3657);
						   }
						   test1562_872 =
						      is_a__118___object(aux_3656, fun_ast_var);
						}
					   }
					   if (test1562_872)
					     {	/* Ast/sexp.scm 107 */
						type_bglt arg1564_874;
						{	/* Ast/sexp.scm 109 */
						   local_bglt obj_1905;
						   obj_1905 =
						      (local_bglt) (local_870);
						   arg1564_874 =
						      (((local_bglt) CREF(obj_1905))->type);
						}
						{	/* Ast/sexp.scm 107 */
						   closure_bglt res2085_1916;
						   {	/* Ast/sexp.scm 107 */
						      variable_bglt variable_1908;
						      variable_1908 =
							 (variable_bglt) (local_870);
						      {		/* ./Ast/node.scm 1656 */
							 closure_bglt new1218_1909;
							 new1218_1909 =
							    ((closure_bglt) BREF(GC_MALLOC(sizeof(struct closure))));
							 {	/* ./Ast/node.scm 1656 */
							    long arg2050_1910;
							    arg2050_1910 =
							       class_num_218___object(closure_ast_node);
							    {	/* ./Ast/node.scm 1656 */
							       obj_t obj_1914;
							       obj_1914 =
								  (obj_t) (new1218_1909);
							       (((obj_t) CREF(obj_1914))->header = MAKE_HEADER(arg2050_1910, 0), BUNSPEC);
							    }
							 }
							 {	/* ./Ast/node.scm 1656 */
							    object_bglt aux_3670;
							    aux_3670 =
							       (object_bglt) (new1218_1909);
							    OBJECT_WIDENING_SET(aux_3670, BFALSE);
							 }
							 ((((closure_bglt) CREF(new1218_1909))->loc) = ((obj_t) loc_19), BUNSPEC);
							 ((((closure_bglt) CREF(new1218_1909))->type) = ((type_bglt) arg1564_874), BUNSPEC);
							 ((((closure_bglt) CREF(new1218_1909))->variable) = ((variable_bglt) variable_1908), BUNSPEC);
							 res2085_1916 = new1218_1909;
						      }
						   }
						   var_871 =
						      (obj_t) (res2085_1916);
						}
					     }
					   else
					     {	/* Ast/sexp.scm 111 */
						type_bglt arg1567_877;
						{	/* Ast/sexp.scm 113 */
						   local_bglt obj_1917;
						   obj_1917 =
						      (local_bglt) (local_870);
						   arg1567_877 =
						      (((local_bglt) CREF(obj_1917))->type);
						}
						{	/* Ast/sexp.scm 111 */
						   var_bglt res2086_1928;
						   {	/* Ast/sexp.scm 111 */
						      variable_bglt variable_1920;
						      variable_1920 =
							 (variable_bglt) (local_870);
						      {		/* ./Ast/node.scm 1651 */
							 var_bglt new1210_1921;
							 new1210_1921 =
							    ((var_bglt) BREF(GC_MALLOC(sizeof(struct var))));
							 {	/* ./Ast/node.scm 1651 */
							    long arg2052_1922;
							    arg2052_1922 =
							       class_num_218___object(var_ast_node);
							    {	/* ./Ast/node.scm 1651 */
							       obj_t obj_1926;
							       obj_1926 =
								  (obj_t) (new1210_1921);
							       (((obj_t) CREF(obj_1926))->header = MAKE_HEADER(arg2052_1922, 0), BUNSPEC);
							    }
							 }
							 {	/* ./Ast/node.scm 1651 */
							    object_bglt aux_3684;
							    aux_3684 =
							       (object_bglt) (new1210_1921);
							    OBJECT_WIDENING_SET(aux_3684, BFALSE);
							 }
							 ((((var_bglt) CREF(new1210_1921))->loc) = ((obj_t) loc_19), BUNSPEC);
							 ((((var_bglt) CREF(new1210_1921))->type) = ((type_bglt) arg1567_877), BUNSPEC);
							 ((((var_bglt) CREF(new1210_1921))->variable) = ((variable_bglt) variable_1920), BUNSPEC);
							 res2086_1928 = new1210_1921;
						      }
						   }
						   var_871 =
						      (obj_t) (res2086_1928);
						}
					     }
					}
					{	/* Ast/sexp.scm 105 */

					   use_variable__4_ast_sexp(
					      (variable_bglt) (local_870), loc_19, site_20);
					   aux_3644 = var_871;
					}
				     }
				  }
			       }
			     else
			       {	/* Ast/sexp.scm 103 */
				  {	/* Ast/sexp.scm 118 */
				     obj_t global_881;
				     global_881 =
					find_global_223_ast_env(atom_747, BNIL);
				     {	/* Ast/sexp.scm 120 */
					bool_t test1572_882;
					test1572_882 =
					   is_a__118___object(global_881, global_ast_var);
					if (test1572_882)
					  {	/* Ast/sexp.scm 122 */
					     bool_t test_3696;
					     {	/* ./Ieee/equiv.scm 5508 */
						obj_t aux_3700;
						obj_t aux_3697;
						aux_3700 =
						   CNST_TABLE_REF(((long) 19));
						{	/* Ast/sexp.scm 122 */
						   global_bglt obj_1930;
						   obj_1930 =
						      (global_bglt) (global_881);
						   aux_3697 =
						      (((global_bglt) CREF(obj_1930))->import);
						}
						test_3696 =
						   (aux_3697 == aux_3700);
					     }
					     if (test_3696)
					       {	/* Ast/sexp.scm 122 */
						  {	/* Ast/sexp.scm 123 */
						     obj_t arg1576_884;
						     {	/* Ast/sexp.scm 123 */
							obj_t arg1577_885;
							obj_t arg1578_886;
							arg1577_885 =
							   CNST_TABLE_REF(((long) 19));
							{	/* Ast/sexp.scm 123 */
							   obj_t arg1579_887;
							   {	/* Ast/sexp.scm 123 */
							      obj_t arg1581_889;
							      obj_t arg1582_890;
							      arg1581_889 =
								 CNST_TABLE_REF(((long) 22));
							      arg1582_890 =
								 MAKE_PAIR(atom_747, BNIL);
							      arg1579_887 =
								 MAKE_PAIR(arg1581_889, arg1582_890);
							   }
							   arg1578_886 =
							      MAKE_PAIR(arg1579_887, BNIL);
							}
							arg1576_884 =
							   MAKE_PAIR(arg1577_885, arg1578_886);
						     }
						     {	/* Ast/sexp.scm 123 */
							node_bglt aux_3709;
							aux_3709 =
							   sexp__node_235_ast_sexp(arg1576_884, stack_18, loc_19, site_20);
							aux_3644 =
							   (obj_t) (aux_3709);
						     }
						  }
					       }
					     else
					       {	/* Ast/sexp.scm 122 */
						  use_variable__4_ast_sexp(
						     (variable_bglt) (global_881), loc_19, site_20);
						  {	/* Ast/sexp.scm 126 */
						     bool_t test1583_891;
						     {	/* Ast/sexp.scm 126 */
							bool_t test_3714;
							{	/* ./Ieee/equiv.scm 5508 */
							   obj_t aux_3715;
							   aux_3715 =
							      CNST_TABLE_REF(((long) 20));
							   test_3714 =
							      (site_20 == aux_3715);
							}
							if (test_3714)
							  {	/* Ast/sexp.scm 126 */
							     test1583_891 = ((bool_t) 0);
							  }
							else
							  {	/* ./Ast/var.scm 1543 */
							     obj_t aux_3718;
							     {	/* Ast/sexp.scm 126 */
								value_bglt aux_3719;
								{	/* Ast/sexp.scm 126 */
								   global_bglt obj_1943;
								   obj_1943 =
								      (global_bglt) (global_881);
								   aux_3719 =
								      (((global_bglt) CREF(obj_1943))->value);
								}
								aux_3718 =
								   (obj_t) (aux_3719);
							     }
							     test1583_891 =
								is_a__118___object(aux_3718, fun_ast_var);
							  }
						     }
						     if (test1583_891)
						       {	/* Ast/sexp.scm 127 */
							  type_bglt arg1585_893;
							  {	/* Ast/sexp.scm 129 */
							     global_bglt obj_1945;
							     obj_1945 =
								(global_bglt) (global_881);
							     arg1585_893 =
								(((global_bglt) CREF(obj_1945))->type);
							  }
							  {	/* Ast/sexp.scm 127 */
							     closure_bglt res2087_1956;
							     {	/* Ast/sexp.scm 127 */
								variable_bglt variable_1948;
								variable_1948 =
								   (variable_bglt) (global_881);
								{	/* ./Ast/node.scm 1656 */
								   closure_bglt new1218_1949;
								   new1218_1949 =
								      ((closure_bglt) BREF(GC_MALLOC(sizeof(struct closure))));
								   {	/* ./Ast/node.scm 1656 */
								      long arg2050_1950;
								      arg2050_1950 =
									 class_num_218___object(closure_ast_node);
								      {		/* ./Ast/node.scm 1656 */
									 obj_t obj_1954;
									 obj_1954 =
									    (obj_t) (new1218_1949);
									 (((obj_t) CREF(obj_1954))->header = MAKE_HEADER(arg2050_1950, 0), BUNSPEC);
								      }
								   }
								   {	/* ./Ast/node.scm 1656 */
								      object_bglt aux_3732;
								      aux_3732 =
									 (object_bglt) (new1218_1949);
								      OBJECT_WIDENING_SET(aux_3732, BFALSE);
								   }
								   ((((closure_bglt) CREF(new1218_1949))->loc) = ((obj_t) loc_19), BUNSPEC);
								   ((((closure_bglt) CREF(new1218_1949))->type) = ((type_bglt) arg1585_893), BUNSPEC);
								   ((((closure_bglt) CREF(new1218_1949))->variable) = ((variable_bglt) variable_1948), BUNSPEC);
								   res2087_1956 = new1218_1949;
								}
							     }
							     aux_3644 =
								(obj_t) (res2087_1956);
							  }
						       }
						     else
						       {	/* Ast/sexp.scm 131 */
							  type_bglt arg1588_896;
							  {	/* Ast/sexp.scm 133 */
							     global_bglt obj_1957;
							     obj_1957 =
								(global_bglt) (global_881);
							     arg1588_896 =
								(((global_bglt) CREF(obj_1957))->type);
							  }
							  {	/* Ast/sexp.scm 131 */
							     var_bglt res2088_1968;
							     {	/* Ast/sexp.scm 131 */
								variable_bglt variable_1960;
								variable_1960 =
								   (variable_bglt) (global_881);
								{	/* ./Ast/node.scm 1651 */
								   var_bglt new1210_1961;
								   new1210_1961 =
								      ((var_bglt) BREF(GC_MALLOC(sizeof(struct var))));
								   {	/* ./Ast/node.scm 1651 */
								      long arg2052_1962;
								      arg2052_1962 =
									 class_num_218___object(var_ast_node);
								      {		/* ./Ast/node.scm 1651 */
									 obj_t obj_1966;
									 obj_1966 =
									    (obj_t) (new1210_1961);
									 (((obj_t) CREF(obj_1966))->header = MAKE_HEADER(arg2052_1962, 0), BUNSPEC);
								      }
								   }
								   {	/* ./Ast/node.scm 1651 */
								      object_bglt aux_3746;
								      aux_3746 =
									 (object_bglt) (new1210_1961);
								      OBJECT_WIDENING_SET(aux_3746, BFALSE);
								   }
								   ((((var_bglt) CREF(new1210_1961))->loc) = ((obj_t) loc_19), BUNSPEC);
								   ((((var_bglt) CREF(new1210_1961))->type) = ((type_bglt) arg1588_896), BUNSPEC);
								   ((((var_bglt) CREF(new1210_1961))->variable) = ((variable_bglt) variable_1960), BUNSPEC);
								   res2088_1968 = new1210_1961;
								}
							     }
							     aux_3644 =
								(obj_t) (res2088_1968);
							  }
						       }
						  }
					       }
					  }
					else
					  {	/* Ast/sexp.scm 120 */
					     {	/* Ast/sexp.scm 121 */
						node_bglt aux_3753;
						aux_3753 =
						   error_sexp__node_157_ast_sexp(string2123_ast_sexp, exp_17, loc_19);
						aux_3644 =
						   (obj_t) (aux_3753);
					     }
					  }
				     }
				  }
			       }
			  }
			else
			  {	/* Ast/sexp.scm 81 */
			     {	/* Ast/sexp.scm 83 */
				bool_t test1595_903;
				{	/* Ast/sexp.scm 83 */
				   bool_t test1611_919;
				   test1611_919 =
				      is_a__118___object(atom_747, local_ast_var);
				   if (test1611_919)
				     {	/* Ast/sexp.scm 83 */
					test1595_903 = ((bool_t) 1);
				     }
				   else
				     {	/* Ast/sexp.scm 83 */
					test1595_903 =
					   is_a__118___object(atom_747, global_ast_var);
				     }
				}
				if (test1595_903)
				  {	/* Ast/sexp.scm 83 */
				     use_variable__4_ast_sexp(
					(variable_bglt) (atom_747), loc_19, site_20);
				     {	/* Ast/sexp.scm 85 */
					bool_t test1596_904;
					{	/* Ast/sexp.scm 85 */
					   bool_t test_3762;
					   {	/* ./Ieee/equiv.scm 5508 */
					      obj_t aux_3763;
					      aux_3763 =
						 CNST_TABLE_REF(((long) 20));
					      test_3762 =
						 (site_20 == aux_3763);
					   }
					   if (test_3762)
					     {	/* Ast/sexp.scm 85 */
						test1596_904 = ((bool_t) 0);
					     }
					   else
					     {	/* ./Ast/var.scm 1543 */
						obj_t aux_3766;
						{	/* Ast/sexp.scm 85 */
						   value_bglt aux_3767;
						   {	/* Ast/sexp.scm 85 */
						      variable_bglt obj_1973;
						      obj_1973 =
							 (variable_bglt) (atom_747);
						      aux_3767 =
							 (((variable_bglt) CREF(obj_1973))->value);
						   }
						   aux_3766 =
						      (obj_t) (aux_3767);
						}
						test1596_904 =
						   is_a__118___object(aux_3766, fun_ast_var);
					     }
					}
					if (test1596_904)
					  {	/* Ast/sexp.scm 86 */
					     type_bglt arg1598_906;
					     {	/* Ast/sexp.scm 88 */
						variable_bglt obj_1975;
						obj_1975 =
						   (variable_bglt) (atom_747);
						arg1598_906 =
						   (((variable_bglt) CREF(obj_1975))->type);
					     }
					     {	/* Ast/sexp.scm 86 */
						closure_bglt res2089_1986;
						{	/* Ast/sexp.scm 86 */
						   variable_bglt variable_1978;
						   variable_1978 =
						      (variable_bglt) (atom_747);
						   {	/* ./Ast/node.scm 1656 */
						      closure_bglt new1218_1979;
						      new1218_1979 =
							 ((closure_bglt) BREF(GC_MALLOC(sizeof(struct closure))));
						      {		/* ./Ast/node.scm 1656 */
							 long arg2050_1980;
							 arg2050_1980 =
							    class_num_218___object(closure_ast_node);
							 {	/* ./Ast/node.scm 1656 */
							    obj_t obj_1984;
							    obj_1984 =
							       (obj_t) (new1218_1979);
							    (((obj_t) CREF(obj_1984))->header = MAKE_HEADER(arg2050_1980, 0), BUNSPEC);
							 }
						      }
						      {		/* ./Ast/node.scm 1656 */
							 object_bglt aux_3780;
							 aux_3780 =
							    (object_bglt) (new1218_1979);
							 OBJECT_WIDENING_SET(aux_3780, BFALSE);
						      }
						      ((((closure_bglt) CREF(new1218_1979))->loc) = ((obj_t) loc_19), BUNSPEC);
						      ((((closure_bglt) CREF(new1218_1979))->type) = ((type_bglt) arg1598_906), BUNSPEC);
						      ((((closure_bglt) CREF(new1218_1979))->variable) = ((variable_bglt) variable_1978), BUNSPEC);
						      res2089_1986 = new1218_1979;
						   }
						}
						aux_3644 =
						   (obj_t) (res2089_1986);
					     }
					  }
					else
					  {	/* Ast/sexp.scm 90 */
					     type_bglt arg1601_909;
					     {	/* Ast/sexp.scm 92 */
						variable_bglt obj_1987;
						obj_1987 =
						   (variable_bglt) (atom_747);
						arg1601_909 =
						   (((variable_bglt) CREF(obj_1987))->type);
					     }
					     {	/* Ast/sexp.scm 90 */
						var_bglt res2090_1998;
						{	/* Ast/sexp.scm 90 */
						   variable_bglt variable_1990;
						   variable_1990 =
						      (variable_bglt) (atom_747);
						   {	/* ./Ast/node.scm 1651 */
						      var_bglt new1210_1991;
						      new1210_1991 =
							 ((var_bglt) BREF(GC_MALLOC(sizeof(struct var))));
						      {		/* ./Ast/node.scm 1651 */
							 long arg2052_1992;
							 arg2052_1992 =
							    class_num_218___object(var_ast_node);
							 {	/* ./Ast/node.scm 1651 */
							    obj_t obj_1996;
							    obj_1996 =
							       (obj_t) (new1210_1991);
							    (((obj_t) CREF(obj_1996))->header = MAKE_HEADER(arg2052_1992, 0), BUNSPEC);
							 }
						      }
						      {		/* ./Ast/node.scm 1651 */
							 object_bglt aux_3794;
							 aux_3794 =
							    (object_bglt) (new1210_1991);
							 OBJECT_WIDENING_SET(aux_3794, BFALSE);
						      }
						      ((((var_bglt) CREF(new1210_1991))->loc) = ((obj_t) loc_19), BUNSPEC);
						      ((((var_bglt) CREF(new1210_1991))->type) = ((type_bglt) arg1601_909), BUNSPEC);
						      ((((var_bglt) CREF(new1210_1991))->variable) = ((variable_bglt) variable_1990), BUNSPEC);
						      res2090_1998 = new1210_1991;
						   }
						}
						aux_3644 =
						   (obj_t) (res2090_1998);
					     }
					  }
				     }
				  }
				else
				  {	/* Ast/sexp.scm 94 */
				     bool_t test1605_913;
				     if (
					STRUCTP(atom_747))
				       {	/* Ast/sexp.scm 94 */
					  test1605_913 = ((bool_t) 1);
				       }
				     else
				       {	/* Ast/sexp.scm 94 */
					  if (
					     VECTORP(atom_747))
					    {	/* Ast/sexp.scm 95 */
					       test1605_913 = ((bool_t) 1);
					    }
					  else
					    {	/* Ast/sexp.scm 95 */
					       test1605_913 =
						  (POINTERP(atom_747) && (TYPE(atom_747) >= OBJECT_TYPE));
					    }
				       }
				     if (test1605_913)
				       {	/* Ast/sexp.scm 94 */
					  {	/* Ast/sexp.scm 97 */
					     node_bglt aux_3807;
					     aux_3807 =
						error_sexp__node_157_ast_sexp(string2124_ast_sexp, exp_17, loc_19);
					     aux_3644 =
						(obj_t) (aux_3807);
					  }
				       }
				     else
				       {	/* Ast/sexp.scm 94 */
					  {	/* Ast/sexp.scm 99 */
					     type_bglt arg1607_915;
					     arg1607_915 =
						typeof_atom_134_type_typeof(atom_747);
					     {	/* Ast/sexp.scm 99 */
						atom_bglt res2091_2012;
						{	/* ./Ast/node.scm 1646 */
						   atom_bglt new1202_2005;
						   new1202_2005 =
						      ((atom_bglt) BREF(GC_MALLOC(sizeof(struct atom))));
						   {	/* ./Ast/node.scm 1646 */
						      long arg2054_2006;
						      arg2054_2006 =
							 class_num_218___object(atom_ast_node);
						      {		/* ./Ast/node.scm 1646 */
							 obj_t obj_2010;
							 obj_2010 =
							    (obj_t) (new1202_2005);
							 (((obj_t) CREF(obj_2010))->header = MAKE_HEADER(arg2054_2006, 0), BUNSPEC);
						      }
						   }
						   {	/* ./Ast/node.scm 1646 */
						      object_bglt aux_3815;
						      aux_3815 =
							 (object_bglt) (new1202_2005);
						      OBJECT_WIDENING_SET(aux_3815, BFALSE);
						   }
						   ((((atom_bglt) CREF(new1202_2005))->loc) = ((obj_t) loc_19), BUNSPEC);
						   ((((atom_bglt) CREF(new1202_2005))->type) = ((type_bglt) arg1607_915), BUNSPEC);
						   ((((atom_bglt) CREF(new1202_2005))->value) = ((obj_t) atom_747), BUNSPEC);
						   res2091_2012 = new1202_2005;
						}
						aux_3644 =
						   (obj_t) (res2091_2012);
					     }
					  }
				       }
				  }
			     }
			  }
			return
			   (node_bglt) (aux_3644);
		     }
		}
	   }
      }
   }
}



/* liip */
obj_t 
liip_ast_sexp(obj_t args_1206)
{
   AN_OBJECT;
   {	/* Ast/sexp.scm 324 */
      if (
	 NULLP(args_1206))
	{	/* Ast/sexp.scm 325 */
	   return
	      CNST_TABLE_REF(((long) 31));
	}
      else
	{	/* Ast/sexp.scm 327 */
	   obj_t arg1824_1209;
	   obj_t arg1825_1210;
	   arg1824_1209 =
	      CNST_TABLE_REF(((long) 32));
	   {	/* Ast/sexp.scm 327 */
	      obj_t arg1826_1211;
	      obj_t arg1827_1212;
	      arg1826_1211 =
		 CAR(args_1206);
	      {		/* Ast/sexp.scm 328 */
		 obj_t arg1828_1213;
		 arg1828_1213 =
		    liip_ast_sexp(
		    CDR(args_1206));
		 arg1827_1212 =
		    MAKE_PAIR(arg1828_1213, BNIL);
	      }
	      arg1825_1210 =
		 MAKE_PAIR(arg1826_1211, arg1827_1212);
	   }
	   return
	      MAKE_PAIR(arg1824_1209, arg1825_1210);
	}
   }
}



/* loop */
obj_t 
loop_ast_sexp(obj_t exp_2682, obj_t loc_2681, obj_t vars_1168, obj_t args_1169)
{
   AN_OBJECT;
   {	/* Ast/sexp.scm 309 */
    loop_ast_sexp:
      if (
	 NULLP(vars_1168))
	{	/* Ast/sexp.scm 312 */
	   if (
	      NULLP(args_1169))
	     {	/* Ast/sexp.scm 313 */
		return BNIL;
	     }
	   else
	     {	/* Ast/sexp.scm 317 */
		obj_t arg1789_1173;
		{	/* Ast/sexp.scm 317 */
		   obj_t arg1792_1176;
		   arg1792_1176 =
		      current_function_76_tools_error();
		   arg1789_1173 =
		      shape_tools_shape(arg1792_1176);
		}
		return
		   user_error_location_137_tools_error(loc_2681, arg1789_1173, string2126_ast_sexp, exp_2682, BNIL);
	     }
	}
      else
	{	/* Ast/sexp.scm 312 */
	   if (
	      PAIRP(vars_1168))
	     {	/* Ast/sexp.scm 329 */
		bool_t test1794_1178;
		{	/* Ast/sexp.scm 329 */
		   obj_t aux_3842;
		   aux_3842 =
		      dsssl_named_constant__188_tools_dsssl(
		      CAR(vars_1168));
		   test1794_1178 =
		      CBOOL(aux_3842);
		}
		if (test1794_1178)
		  {	/* Ast/sexp.scm 329 */
		     {	/* Ast/sexp.scm 330 */
			obj_t arg_1179;
			arg_1179 =
			   dsssl_find_first_formal_237_tools_dsssl(
			   CDR(vars_1168));
			if (
			   CBOOL(arg_1179))
			  {
			     obj_t vars_3851;
			     vars_3851 = arg_1179;
			     vars_1168 = vars_3851;
			     goto loop_ast_sexp;
			  }
			else
			  {
			     obj_t vars_3852;
			     vars_3852 = BNIL;
			     vars_1168 = vars_3852;
			     goto loop_ast_sexp;
			  }
		     }
		  }
		else
		  {	/* Ast/sexp.scm 335 */
		     bool_t test_3853;
		     {	/* ./Ieee/symbol.scm 6015 */
			obj_t aux_3854;
			aux_3854 =
			   CAR(vars_1168);
			test_3853 =
			   SYMBOLP(aux_3854);
		     }
		     if (test_3853)
		       {	/* Ast/sexp.scm 335 */
			  if (
			     NULLP(args_1169))
			    {	/* Ast/sexp.scm 341 */
			       {	/* Ast/sexp.scm 344 */
				  obj_t arg1798_1183;
				  {	/* Ast/sexp.scm 344 */
				     obj_t arg1802_1186;
				     arg1802_1186 =
					current_function_76_tools_error();
				     arg1798_1183 =
					shape_tools_shape(arg1802_1186);
				  }
				  return
				     user_error_location_137_tools_error(loc_2681, arg1798_1183, string2126_ast_sexp, exp_2682, BNIL);
			       }
			    }
			  else
			    {	/* Ast/sexp.scm 341 */
			       {	/* Ast/sexp.scm 348 */
				  obj_t arg1803_1187;
				  obj_t arg1804_1188;
				  {	/* Ast/sexp.scm 348 */
				     obj_t arg1805_1189;
				     arg1805_1189 =
					CAR(vars_1168);
				     {	/* Ast/sexp.scm 348 */
					obj_t list1807_1191;
					{	/* Ast/sexp.scm 348 */
					   obj_t arg1809_1192;
					   {	/* Ast/sexp.scm 348 */
					      obj_t aux_3863;
					      aux_3863 =
						 CAR(args_1169);
					      arg1809_1192 =
						 MAKE_PAIR(aux_3863, BNIL);
					   }
					   list1807_1191 =
					      MAKE_PAIR(arg1805_1189, arg1809_1192);
					}
					arg1803_1187 = list1807_1191;
				     }
				  }
				  arg1804_1188 =
				     loop_ast_sexp(exp_2682, loc_2681,
				     CDR(vars_1168),
				     CDR(args_1169));
				  return
				     MAKE_PAIR(arg1803_1187, arg1804_1188);
			       }
			    }
		       }
		     else
		       {	/* Ast/sexp.scm 335 */
			  {	/* Ast/sexp.scm 338 */
			     obj_t arg1812_1195;
			     {	/* Ast/sexp.scm 338 */
				obj_t arg1815_1198;
				arg1815_1198 =
				   current_function_76_tools_error();
				arg1812_1195 =
				   shape_tools_shape(arg1815_1198);
			     }
			     return
				user_error_location_137_tools_error(loc_2681, arg1812_1195, string2127_ast_sexp, exp_2682, BNIL);
			  }
		       }
		  }
	     }
	   else
	     {	/* Ast/sexp.scm 320 */
		{	/* Ast/sexp.scm 324 */
		   obj_t arg1818_1201;
		   {	/* Ast/sexp.scm 324 */
		      obj_t arg1820_1203;
		      arg1820_1203 =
			 liip_ast_sexp(args_1169);
		      {		/* Ast/sexp.scm 322 */
			 obj_t list1821_1204;
			 {	/* Ast/sexp.scm 322 */
			    obj_t arg1822_1205;
			    arg1822_1205 =
			       MAKE_PAIR(arg1820_1203, BNIL);
			    list1821_1204 =
			       MAKE_PAIR(vars_1168, arg1822_1205);
			 }
			 arg1818_1201 = list1821_1204;
		      }
		   }
		   {	/* Ast/sexp.scm 321 */
		      obj_t list1819_1202;
		      list1819_1202 =
			 MAKE_PAIR(arg1818_1201, BNIL);
		      return list1819_1202;
		   }
		}
	     }
	}
   }
}



/* _sexp->node2106 */
obj_t 
_sexp__node2106_107_ast_sexp(obj_t env_2656, obj_t exp_2657, obj_t stack_2658, obj_t loc_2659, obj_t site_2660)
{
   AN_OBJECT;
   {	/* Ast/sexp.scm 68 */
      {		/* Ast/sexp.scm 68 */
	 node_bglt aux_3878;
	 aux_3878 =
	    sexp__node_235_ast_sexp(exp_2657, stack_2658, loc_2659, site_2660);
	 return
	    (obj_t) (aux_3878);
      }
   }
}



/* <anonymous:1839> */
obj_t 
_anonymous_1839__116_ast_sexp(obj_t env_2661, obj_t obj_2663, obj_t proc_2664, obj_t msg_2665)
{
   AN_OBJECT;
   {	/* Ast/sexp.scm 354 */
      {		/* Ast/sexp.scm 355 */
	 obj_t loc_2662;
	 loc_2662 =
	    PROCEDURE_REF(env_2661, ((long) 0));
	 {
	    obj_t obj_1222;
	    obj_t proc_1223;
	    obj_t msg_1224;
	    obj_1222 = obj_2663;
	    proc_1223 = proc_2664;
	    msg_1224 = msg_2665;
	    return
	       user_error_location_137_tools_error(loc_2662, obj_1222, proc_1223, msg_1224, BNIL);
	 }
      }
   }
}



/* sexp*->node */
obj_t 
sexp___node_160_ast_sexp(obj_t exp__153_21, obj_t stack_22, obj_t loc_23, obj_t site_24)
{
   AN_OBJECT;
   {	/* Ast/sexp.scm 495 */
      {
	 obj_t exps_1377;
	 obj_t res_1378;
	 obj_t loc_1379;
	 exps_1377 = exp__153_21;
	 res_1378 = BNIL;
	 loc_1379 = loc_23;
       loop_1380:
	 if (
	    NULLP(exps_1377))
	   {	/* Ast/sexp.scm 500 */
	      {		/* Ast/sexp.scm 501 */
		 node_bglt aux_3885;
		 aux_3885 =
		    error_sexp__node_157_ast_sexp(string2128_ast_sexp, exps_1377, loc_1379);
		 return
		    (obj_t) (aux_3885);
	      }
	   }
	 else
	   {	/* Ast/sexp.scm 502 */
	      bool_t test_3888;
	      {		/* ./Ieee/pair-list.scm 5912 */
		 obj_t aux_3889;
		 aux_3889 =
		    CDR(exps_1377);
		 test_3888 =
		    NULLP(aux_3889);
	      }
	      if (test_3888)
		{	/* Ast/sexp.scm 502 */
		   {	/* Ast/sexp.scm 503 */
		      obj_t loc_1383;
		      loc_1383 =
			 find_location_loc_243_tools_location(
			 CAR(exps_1377), loc_1379);
		      {		/* Ast/sexp.scm 504 */
			 obj_t arg1942_1384;
			 {	/* Ast/sexp.scm 504 */
			    node_bglt arg1943_1385;
			    arg1943_1385 =
			       sexp__node_235_ast_sexp(
			       CAR(exps_1377), stack_22, loc_1383, site_24);
			    {	/* ./Ieee/pair-list.scm 5689 */
			       obj_t aux_3896;
			       aux_3896 =
				  (obj_t) (arg1943_1385);
			       arg1942_1384 =
				  MAKE_PAIR(aux_3896, res_1378);
			    }
			 }
			 return
			    reverse__39___r4_pairs_and_lists_6_3(arg1942_1384);
		      }
		   }
		}
	      else
		{	/* Ast/sexp.scm 502 */
		   {	/* Ast/sexp.scm 506 */
		      obj_t loc_1388;
		      loc_1388 =
			 find_location_loc_243_tools_location(
			 CAR(exps_1377), loc_1379);
		      {		/* Ast/sexp.scm 507 */
			 obj_t arg1946_1389;
			 obj_t arg1948_1390;
			 arg1946_1389 =
			    CDR(exps_1377);
			 {	/* Ast/sexp.scm 508 */
			    node_bglt arg1949_1391;
			    arg1949_1391 =
			       sexp__node_235_ast_sexp(
			       CAR(exps_1377), stack_22, loc_1388,
			       CNST_TABLE_REF(((long) 1)));
			    {	/* ./Ieee/pair-list.scm 5689 */
			       obj_t aux_3906;
			       aux_3906 =
				  (obj_t) (arg1949_1391);
			       arg1948_1390 =
				  MAKE_PAIR(aux_3906, res_1378);
			    }
			 }
			 {
			    obj_t loc_3911;
			    obj_t res_3910;
			    obj_t exps_3909;
			    exps_3909 = arg1946_1389;
			    res_3910 = arg1948_1390;
			    loc_3911 = loc_1388;
			    loc_1379 = loc_3911;
			    res_1378 = res_3910;
			    exps_1377 = exps_3909;
			    goto loop_1380;
			 }
		      }
		   }
		}
	   }
      }
   }
}



/* lookup */
obj_t 
lookup_ast_sexp(obj_t name_25, obj_t stack_26)
{
   AN_OBJECT;
   {	/* Ast/sexp.scm 521 */
      {		/* Ast/sexp.scm 522 */
	 bool_t test1954_1396;
	 {	/* Ast/sexp.scm 522 */
	    bool_t test1960_1404;
	    {	/* Ast/sexp.scm 522 */
	       obj_t obj2_2473;
	       obj2_2473 = _cache_name__178_ast_sexp;
	       test1960_1404 =
		  (name_25 == obj2_2473);
	    }
	    if (test1960_1404)
	      {		/* Ast/sexp.scm 523 */
		 obj_t obj2_2475;
		 obj2_2475 = _cache_stack__44_ast_sexp;
		 test1954_1396 =
		    (stack_26 == obj2_2475);
	      }
	    else
	      {		/* Ast/sexp.scm 522 */
		 test1954_1396 = ((bool_t) 0);
	      }
	 }
	 if (test1954_1396)
	   {	/* Ast/sexp.scm 522 */
	      return _cache_res__50_ast_sexp;
	   }
	 else
	   {	/* Ast/sexp.scm 522 */
	      _cache_name__178_ast_sexp = name_25;
	      _cache_stack__44_ast_sexp = stack_26;
	      {
		 obj_t stack_1397;
		 stack_1397 = stack_26;
	       loop_1398:
		 if (
		    NULLP(stack_1397))
		   {	/* Ast/sexp.scm 530 */
		      _cache_res__50_ast_sexp = BFALSE;
		      return BFALSE;
		   }
		 else
		   {	/* Ast/sexp.scm 533 */
		      bool_t test_3918;
		      {		/* ./Ieee/equiv.scm 5508 */
			 obj_t aux_3919;
			 {	/* Ast/sexp.scm 533 */
			    local_bglt obj_2478;
			    {	/* Ast/sexp.scm 533 */
			       obj_t aux_3920;
			       aux_3920 =
				  CAR(stack_1397);
			       obj_2478 =
				  (local_bglt) (aux_3920);
			    }
			    aux_3919 =
			       (((local_bglt) CREF(obj_2478))->id);
			 }
			 test_3918 =
			    (aux_3919 == name_25);
		      }
		      if (test_3918)
			{	/* Ast/sexp.scm 533 */
			   _cache_res__50_ast_sexp =
			      CAR(stack_1397);
			   return
			      CAR(stack_1397);
			}
		      else
			{	/* Ast/sexp.scm 533 */
			   {
			      obj_t stack_3927;
			      stack_3927 =
				 CDR(stack_1397);
			      stack_1397 = stack_3927;
			      goto loop_1398;
			   }
			}
		   }
	      }
	   }
      }
   }
}



/* use-variable! */
obj_t 
use_variable__4_ast_sexp(variable_bglt var_27, obj_t loc_28, obj_t site_29)
{
   AN_OBJECT;
   {	/* Ast/sexp.scm 542 */
      {		/* Ast/sexp.scm 543 */
	 bool_t test_3929;
	 {	/* Ast/sexp.scm 543 */
	    obj_t aux_3930;
	    aux_3930 =
	       memq___r4_pairs_and_lists_6_3(site_29, _sites__81_ast_sexp);
	    test_3929 =
	       CBOOL(aux_3930);
	 }
	 if (test_3929)
	   {	/* Ast/sexp.scm 543 */
	      BUNSPEC;
	   }
	 else
	   {	/* Ast/sexp.scm 543 */
	      {		/* Ast/sexp.scm 543 */
		 obj_t arg1962_1406;
		 obj_t arg1963_1407;
		 arg1962_1406 =
		    CNST_TABLE_REF(((long) 2));
		 arg1963_1407 =
		    __EVMEANING_ADDRESS(site_29);
		 define_primop_ref__105___evenv(arg1962_1406, arg1963_1407);
	      }
	      notify_assert_fail_37___eval(
		 CNST_TABLE_REF(((long) 3)),
		 CNST_TABLE_REF(((long) 4)),
		 CNST_TABLE_REF(((long) 33)));
	      unbind_primop__163___evenv(
		 CNST_TABLE_REF(((long) 2)));
	   }
      }
      {		/* Ast/sexp.scm 544 */
	 bool_t test_3942;
	 {	/* ./Ieee/equiv.scm 5508 */
	    obj_t aux_3943;
	    aux_3943 =
	       CNST_TABLE_REF(((long) 13));
	    test_3942 =
	       (site_29 == aux_3943);
	 }
	 if (test_3942)
	   {	/* Ast/sexp.scm 545 */
	      obj_t val1036_2487;
	      val1036_2487 =
		 CNST_TABLE_REF(((long) 34));
	      ((((variable_bglt) CREF(var_27))->access) = ((obj_t) val1036_2487), BUNSPEC);
	   }
	 else
	   {	/* Ast/sexp.scm 544 */
	      BUNSPEC;
	   }
      }
      {		/* Ast/sexp.scm 547 */
	 bool_t test1965_1410;
	 {	/* Ast/sexp.scm 547 */
	    bool_t test_3948;
	    {	/* ./Ieee/equiv.scm 5508 */
	       obj_t aux_3949;
	       aux_3949 =
		  CNST_TABLE_REF(((long) 13));
	       test_3948 =
		  (site_29 == aux_3949);
	    }
	    if (test_3948)
	      {		/* ./Ast/var.scm 1543 */
		 obj_t aux_3952;
		 {	/* Ast/sexp.scm 547 */
		    value_bglt aux_3953;
		    aux_3953 =
		       (((variable_bglt) CREF(var_27))->value);
		    aux_3952 =
		       (obj_t) (aux_3953);
		 }
		 test1965_1410 =
		    is_a__118___object(aux_3952, fun_ast_var);
	      }
	    else
	      {		/* Ast/sexp.scm 547 */
		 test1965_1410 = ((bool_t) 0);
	      }
	 }
	 if (test1965_1410)
	   {	/* Ast/sexp.scm 548 */
	      obj_t arg1967_1412;
	      arg1967_1412 =
		 shape_tools_shape(
		 (obj_t) (var_27));
	      {		/* Ast/sexp.scm 548 */
		 node_bglt aux_3960;
		 aux_3960 =
		    error_sexp__node_157_ast_sexp(string2129_ast_sexp, arg1967_1412, loc_28);
		 return
		    (obj_t) (aux_3960);
	      }
	   }
	 else
	   {	/* Ast/sexp.scm 547 */
	      return BUNSPEC;
	   }
      }
   }
}



/* _use-variable!2107 */
obj_t 
_use_variable_2107_114_ast_sexp(obj_t env_2666, obj_t var_2667, obj_t loc_2668, obj_t site_2669)
{
   AN_OBJECT;
   {	/* Ast/sexp.scm 542 */
      return
	 use_variable__4_ast_sexp(
	 (variable_bglt) (var_2667), loc_2668, site_2669);
   }
}



/* error-sexp->node */
node_bglt 
error_sexp__node_157_ast_sexp(obj_t msg_30, obj_t exp_31, obj_t loc_32)
{
   AN_OBJECT;
   {	/* Ast/sexp.scm 553 */
      {		/* Ast/sexp.scm 555 */
	 obj_t arg1969_1414;
	 node_bglt arg1970_1415;
	 {	/* Ast/sexp.scm 555 */
	    obj_t arg1972_1417;
	    arg1972_1417 =
	       current_function_76_tools_error();
	    arg1969_1414 =
	       shape_tools_shape(arg1972_1417);
	 }
	 arg1970_1415 =
	    sexp__node_235_ast_sexp(
	    CNST_TABLE_REF(((long) 31)), BNIL, loc_32,
	    CNST_TABLE_REF(((long) 1)));
	 {	/* Ast/sexp.scm 554 */
	    obj_t list1971_1416;
	    {	/* Ast/sexp.scm 554 */
	       obj_t aux_3970;
	       aux_3970 =
		  (obj_t) (arg1970_1415);
	       list1971_1416 =
		  MAKE_PAIR(aux_3970, BNIL);
	    }
	    {	/* Ast/sexp.scm 554 */
	       obj_t aux_3973;
	       aux_3973 =
		  user_error_location_137_tools_error(loc_32, arg1969_1414, msg_30, exp_31, list1971_1416);
	       return
		  (node_bglt) (aux_3973);
	    }
	 }
      }
   }
}



/* _error-sexp->node2108 */
obj_t 
_error_sexp__node2108_6_ast_sexp(obj_t env_2670, obj_t msg_2671, obj_t exp_2672, obj_t loc_2673)
{
   AN_OBJECT;
   {	/* Ast/sexp.scm 553 */
      {		/* Ast/sexp.scm 553 */
	 node_bglt aux_3976;
	 aux_3976 =
	    error_sexp__node_157_ast_sexp(msg_2671, exp_2672, loc_2673);
	 return
	    (obj_t) (aux_3976);
      }
   }
}



/* define-primop-ref->node */
node_bglt 
define_primop_ref__node_164_ast_sexp(global_bglt global_33, node_bglt ref_34)
{
   AN_OBJECT;
   {	/* Ast/sexp.scm 563 */
      {		/* Ast/sexp.scm 564 */
	 node_bglt fun_1418;
	 fun_1418 =
	    sexp__node_235_ast_sexp(
	    CNST_TABLE_REF(((long) 35)), BNIL, BFALSE,
	    CNST_TABLE_REF(((long) 20)));
	 {	/* Ast/sexp.scm 565 */
	    bool_t test1973_1419;
	    test1973_1419 =
	       is_a__118___object(
	       (obj_t) (fun_1418), var_ast_node);
	    if (test1973_1419)
	      {		/* Ast/sexp.scm 566 */
		 obj_t arg1974_1420;
		 obj_t arg1979_1423;
		 arg1974_1420 = ____74_type_cache;
		 {	/* Ast/sexp.scm 568 */
		    node_bglt arg1980_1424;
		    {	/* Ast/sexp.scm 568 */
		       obj_t arg1983_1427;
		       obj_t arg1985_1429;
		       {	/* Ast/sexp.scm 568 */
			  obj_t arg1986_1430;
			  obj_t arg1987_1431;
			  arg1986_1430 =
			     CNST_TABLE_REF(((long) 22));
			  {	/* ./Ieee/pair-list.scm 5689 */
			     obj_t aux_3986;
			     aux_3986 =
				(((global_bglt) CREF(global_33))->id);
			     arg1987_1431 =
				MAKE_PAIR(aux_3986, BNIL);
			  }
			  arg1983_1427 =
			     MAKE_PAIR(arg1986_1430, arg1987_1431);
		       }
		       arg1985_1429 =
			  CNST_TABLE_REF(((long) 1));
		       arg1980_1424 =
			  sexp__node_235_ast_sexp(arg1983_1427, BNIL, BFALSE, arg1985_1429);
		    }
		    {	/* Ast/sexp.scm 568 */
		       obj_t list1981_1425;
		       {	/* Ast/sexp.scm 568 */
			  obj_t arg1982_1426;
			  {	/* Ast/sexp.scm 568 */
			     obj_t aux_3992;
			     aux_3992 =
				(obj_t) (ref_34);
			     arg1982_1426 =
				MAKE_PAIR(aux_3992, BNIL);
			  }
			  {	/* Ast/sexp.scm 568 */
			     obj_t aux_3995;
			     aux_3995 =
				(obj_t) (arg1980_1424);
			     list1981_1425 =
				MAKE_PAIR(aux_3995, arg1982_1426);
			  }
		       }
		       arg1979_1423 = list1981_1425;
		    }
		 }
		 {	/* Ast/sexp.scm 566 */
		    app_bglt res2103_2517;
		    {	/* Ast/sexp.scm 566 */
		       obj_t loc_2499;
		       type_bglt type_2500;
		       obj_t key_2502;
		       var_bglt fun_2503;
		       loc_2499 = BFALSE;
		       type_2500 =
			  (type_bglt) (arg1974_1420);
		       key_2502 =
			  BINT(((long) -1));
		       fun_2503 =
			  (var_bglt) (fun_1418);
		       {	/* ./Ast/node.scm 1668 */
			  app_bglt new1248_2506;
			  new1248_2506 =
			     ((app_bglt) BREF(GC_MALLOC(sizeof(struct app))));
			  {	/* ./Ast/node.scm 1668 */
			     long arg2044_2507;
			     arg2044_2507 =
				class_num_218___object(app_ast_node);
			     {	/* ./Ast/node.scm 1668 */
				obj_t obj_2515;
				obj_2515 =
				   (obj_t) (new1248_2506);
				(((obj_t) CREF(obj_2515))->header = MAKE_HEADER(arg2044_2507, 0), BUNSPEC);
			     }
			  }
			  {	/* ./Ast/node.scm 1668 */
			     object_bglt aux_4005;
			     aux_4005 =
				(object_bglt) (new1248_2506);
			     OBJECT_WIDENING_SET(aux_4005, loc_2499);
			  }
			  ((((app_bglt) CREF(new1248_2506))->loc) = ((obj_t) loc_2499), BUNSPEC);
			  ((((app_bglt) CREF(new1248_2506))->type) = ((type_bglt) type_2500), BUNSPEC);
			  ((((app_bglt) CREF(new1248_2506))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
			  ((((app_bglt) CREF(new1248_2506))->key) = ((obj_t) key_2502), BUNSPEC);
			  ((((app_bglt) CREF(new1248_2506))->fun) = ((var_bglt) fun_2503), BUNSPEC);
			  ((((app_bglt) CREF(new1248_2506))->args) = ((obj_t) arg1979_1423), BUNSPEC);
			  ((((app_bglt) CREF(new1248_2506))->stack_info_255) = ((obj_t) BUNSPEC), BUNSPEC);
			  res2103_2517 = new1248_2506;
		       }
		    }
		    return
		       (node_bglt) (res2103_2517);
		 }
	      }
	    else
	      {		/* Ast/sexp.scm 565 */
		 return fun_1418;
	      }
	 }
      }
   }
}



/* _define-primop-ref->node2109 */
obj_t 
_define_primop_ref__node2109_67_ast_sexp(obj_t env_2674, obj_t global_2675, obj_t ref_2676)
{
   AN_OBJECT;
   {	/* Ast/sexp.scm 563 */
      {		/* Ast/sexp.scm 563 */
	 node_bglt aux_4016;
	 aux_4016 =
	    define_primop_ref__node_164_ast_sexp(
	    (global_bglt) (global_2675),
	    (node_bglt) (ref_2676));
	 return
	    (obj_t) (aux_4016);
      }
   }
}



/* define-primop->node */
node_bglt 
define_primop__node_141_ast_sexp(global_bglt global_35)
{
   AN_OBJECT;
   {	/* Ast/sexp.scm 578 */
      use_variable__4_ast_sexp(
	 (variable_bglt) (global_35), BFALSE,
	 CNST_TABLE_REF(((long) 1)));
      {		/* Ast/sexp.scm 580 */
	 node_bglt fun_1434;
	 fun_1434 =
	    sexp__node_235_ast_sexp(
	    CNST_TABLE_REF(((long) 36)), BNIL, BFALSE,
	    CNST_TABLE_REF(((long) 20)));
	 {	/* Ast/sexp.scm 581 */
	    bool_t test1990_1435;
	    test1990_1435 =
	       is_a__118___object(
	       (obj_t) (fun_1434), var_ast_node);
	    if (test1990_1435)
	      {		/* Ast/sexp.scm 582 */
		 obj_t arg1991_1436;
		 obj_t arg1994_1439;
		 arg1991_1436 = ____74_type_cache;
		 {	/* Ast/sexp.scm 584 */
		    node_bglt arg1995_1440;
		    node_bglt arg1996_1441;
		    {	/* Ast/sexp.scm 584 */
		       obj_t arg1999_1444;
		       obj_t arg2001_1446;
		       {	/* Ast/sexp.scm 584 */
			  obj_t arg2002_1447;
			  obj_t arg2003_1448;
			  arg2002_1447 =
			     CNST_TABLE_REF(((long) 22));
			  {	/* ./Ieee/pair-list.scm 5689 */
			     obj_t aux_4031;
			     aux_4031 =
				(((global_bglt) CREF(global_35))->id);
			     arg2003_1448 =
				MAKE_PAIR(aux_4031, BNIL);
			  }
			  arg1999_1444 =
			     MAKE_PAIR(arg2002_1447, arg2003_1448);
		       }
		       arg2001_1446 =
			  CNST_TABLE_REF(((long) 1));
		       arg1995_1440 =
			  sexp__node_235_ast_sexp(arg1999_1444, BNIL, BFALSE, arg2001_1446);
		    }
		    arg1996_1441 =
		       sexp__node_235_ast_sexp(
		       (obj_t) (global_35), BNIL, BFALSE,
		       CNST_TABLE_REF(((long) 1)));
		    {	/* Ast/sexp.scm 584 */
		       obj_t list1997_1442;
		       {	/* Ast/sexp.scm 584 */
			  obj_t arg1998_1443;
			  {	/* Ast/sexp.scm 584 */
			     obj_t aux_4040;
			     aux_4040 =
				(obj_t) (arg1996_1441);
			     arg1998_1443 =
				MAKE_PAIR(aux_4040, BNIL);
			  }
			  {	/* Ast/sexp.scm 584 */
			     obj_t aux_4043;
			     aux_4043 =
				(obj_t) (arg1995_1440);
			     list1997_1442 =
				MAKE_PAIR(aux_4043, arg1998_1443);
			  }
		       }
		       arg1994_1439 = list1997_1442;
		    }
		 }
		 {	/* Ast/sexp.scm 582 */
		    app_bglt res2104_2543;
		    {	/* Ast/sexp.scm 582 */
		       obj_t loc_2525;
		       type_bglt type_2526;
		       obj_t key_2528;
		       var_bglt fun_2529;
		       loc_2525 = BFALSE;
		       type_2526 =
			  (type_bglt) (arg1991_1436);
		       key_2528 =
			  BINT(((long) -1));
		       fun_2529 =
			  (var_bglt) (fun_1434);
		       {	/* ./Ast/node.scm 1668 */
			  app_bglt new1248_2532;
			  new1248_2532 =
			     ((app_bglt) BREF(GC_MALLOC(sizeof(struct app))));
			  {	/* ./Ast/node.scm 1668 */
			     long arg2044_2533;
			     arg2044_2533 =
				class_num_218___object(app_ast_node);
			     {	/* ./Ast/node.scm 1668 */
				obj_t obj_2541;
				obj_2541 =
				   (obj_t) (new1248_2532);
				(((obj_t) CREF(obj_2541))->header = MAKE_HEADER(arg2044_2533, 0), BUNSPEC);
			     }
			  }
			  {	/* ./Ast/node.scm 1668 */
			     object_bglt aux_4053;
			     aux_4053 =
				(object_bglt) (new1248_2532);
			     OBJECT_WIDENING_SET(aux_4053, loc_2525);
			  }
			  ((((app_bglt) CREF(new1248_2532))->loc) = ((obj_t) loc_2525), BUNSPEC);
			  ((((app_bglt) CREF(new1248_2532))->type) = ((type_bglt) type_2526), BUNSPEC);
			  ((((app_bglt) CREF(new1248_2532))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
			  ((((app_bglt) CREF(new1248_2532))->key) = ((obj_t) key_2528), BUNSPEC);
			  ((((app_bglt) CREF(new1248_2532))->fun) = ((var_bglt) fun_2529), BUNSPEC);
			  ((((app_bglt) CREF(new1248_2532))->args) = ((obj_t) arg1994_1439), BUNSPEC);
			  ((((app_bglt) CREF(new1248_2532))->stack_info_255) = ((obj_t) BUNSPEC), BUNSPEC);
			  res2104_2543 = new1248_2532;
		       }
		    }
		    return
		       (node_bglt) (res2104_2543);
		 }
	      }
	    else
	      {		/* Ast/sexp.scm 581 */
		 return fun_1434;
	      }
	 }
      }
   }
}



/* _define-primop->node2110 */
obj_t 
_define_primop__node2110_103_ast_sexp(obj_t env_2677, obj_t global_2678)
{
   AN_OBJECT;
   {	/* Ast/sexp.scm 578 */
      {		/* Ast/sexp.scm 578 */
	 node_bglt aux_4064;
	 aux_4064 =
	    define_primop__node_141_ast_sexp(
	    (global_bglt) (global_2678));
	 return
	    (obj_t) (aux_4064);
      }
   }
}



/* location->node */
node_bglt 
location__node_25_ast_sexp(global_bglt global_36)
{
   AN_OBJECT;
   {	/* Ast/sexp.scm 597 */
      use_variable__4_ast_sexp(
	 (variable_bglt) (global_36), BFALSE,
	 CNST_TABLE_REF(((long) 1)));
      {		/* Ast/sexp.scm 599 */
	 node_bglt fun_1451;
	 fun_1451 =
	    sexp__node_235_ast_sexp(
	    CNST_TABLE_REF(((long) 37)), BNIL, BFALSE,
	    CNST_TABLE_REF(((long) 20)));
	 {	/* Ast/sexp.scm 603 */
	    bool_t test2006_1452;
	    test2006_1452 =
	       is_a__118___object(
	       (obj_t) (fun_1451), var_ast_node);
	    if (test2006_1452)
	      {		/* Ast/sexp.scm 604 */
		 obj_t arg2007_1453;
		 obj_t arg2010_1456;
		 arg2007_1453 = ____74_type_cache;
		 {	/* Ast/sexp.scm 606 */
		    node_bglt arg2011_1457;
		    arg2011_1457 =
		       sexp__node_235_ast_sexp(
		       (obj_t) (global_36), BNIL, BFALSE,
		       CNST_TABLE_REF(((long) 1)));
		    {	/* Ast/sexp.scm 606 */
		       obj_t list2012_1458;
		       {	/* Ast/sexp.scm 606 */
			  obj_t aux_4080;
			  aux_4080 =
			     (obj_t) (arg2011_1457);
			  list2012_1458 =
			     MAKE_PAIR(aux_4080, BNIL);
		       }
		       arg2010_1456 = list2012_1458;
		    }
		 }
		 {	/* Ast/sexp.scm 604 */
		    app_bglt res2105_2564;
		    {	/* Ast/sexp.scm 604 */
		       obj_t loc_2546;
		       type_bglt type_2547;
		       obj_t key_2549;
		       var_bglt fun_2550;
		       loc_2546 = BFALSE;
		       type_2547 =
			  (type_bglt) (arg2007_1453);
		       key_2549 =
			  BINT(((long) -1));
		       fun_2550 =
			  (var_bglt) (fun_1451);
		       {	/* ./Ast/node.scm 1668 */
			  app_bglt new1248_2553;
			  new1248_2553 =
			     ((app_bglt) BREF(GC_MALLOC(sizeof(struct app))));
			  {	/* ./Ast/node.scm 1668 */
			     long arg2044_2554;
			     arg2044_2554 =
				class_num_218___object(app_ast_node);
			     {	/* ./Ast/node.scm 1668 */
				obj_t obj_2562;
				obj_2562 =
				   (obj_t) (new1248_2553);
				(((obj_t) CREF(obj_2562))->header = MAKE_HEADER(arg2044_2554, 0), BUNSPEC);
			     }
			  }
			  {	/* ./Ast/node.scm 1668 */
			     object_bglt aux_4090;
			     aux_4090 =
				(object_bglt) (new1248_2553);
			     OBJECT_WIDENING_SET(aux_4090, loc_2546);
			  }
			  ((((app_bglt) CREF(new1248_2553))->loc) = ((obj_t) loc_2546), BUNSPEC);
			  ((((app_bglt) CREF(new1248_2553))->type) = ((type_bglt) type_2547), BUNSPEC);
			  ((((app_bglt) CREF(new1248_2553))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
			  ((((app_bglt) CREF(new1248_2553))->key) = ((obj_t) key_2549), BUNSPEC);
			  ((((app_bglt) CREF(new1248_2553))->fun) = ((var_bglt) fun_2550), BUNSPEC);
			  ((((app_bglt) CREF(new1248_2553))->args) = ((obj_t) arg2010_1456), BUNSPEC);
			  ((((app_bglt) CREF(new1248_2553))->stack_info_255) = ((obj_t) BUNSPEC), BUNSPEC);
			  res2105_2564 = new1248_2553;
		       }
		    }
		    return
		       (node_bglt) (res2105_2564);
		 }
	      }
	    else
	      {		/* Ast/sexp.scm 603 */
		 return fun_1451;
	      }
	 }
      }
   }
}



/* _location->node2111 */
obj_t 
_location__node2111_80_ast_sexp(obj_t env_2679, obj_t global_2680)
{
   AN_OBJECT;
   {	/* Ast/sexp.scm 597 */
      {		/* Ast/sexp.scm 597 */
	 node_bglt aux_4101;
	 aux_4101 =
	    location__node_25_ast_sexp(
	    (global_bglt) (global_2680));
	 return
	    (obj_t) (aux_4101);
      }
   }
}



/* method-init */
obj_t 
method_init_76_ast_sexp()
{
   AN_OBJECT;
   {	/* Ast/sexp.scm 14 */
      return BUNSPEC;
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_ast_sexp()
{
   AN_OBJECT;
   {	/* Ast/sexp.scm 14 */
      module_initialization_70_tools_trace(((long) 0), "AST_SEXP");
      module_initialization_70_tools_error(((long) 0), "AST_SEXP");
      module_initialization_70_tools_shape(((long) 0), "AST_SEXP");
      module_initialization_70_tools_progn(((long) 0), "AST_SEXP");
      module_initialization_70_tools_location(((long) 0), "AST_SEXP");
      module_initialization_70_tools_misc(((long) 0), "AST_SEXP");
      module_initialization_70_tools_dsssl(((long) 0), "AST_SEXP");
      module_initialization_70_type_type(((long) 0), "AST_SEXP");
      module_initialization_70_type_env(((long) 0), "AST_SEXP");
      module_initialization_70_type_cache(((long) 0), "AST_SEXP");
      module_initialization_70_type_typeof(((long) 0), "AST_SEXP");
      module_initialization_70_ast_ident(((long) 0), "AST_SEXP");
      module_initialization_70_ast_env(((long) 0), "AST_SEXP");
      module_initialization_70_ast_var(((long) 0), "AST_SEXP");
      module_initialization_70_ast_node(((long) 0), "AST_SEXP");
      module_initialization_70_ast_build(((long) 0), "AST_SEXP");
      module_initialization_70_ast_pragma(((long) 0), "AST_SEXP");
      module_initialization_70_ast_labels(((long) 0), "AST_SEXP");
      module_initialization_70_ast_let(((long) 0), "AST_SEXP");
      module_initialization_70_ast_exit(((long) 0), "AST_SEXP");
      module_initialization_70_ast_app(((long) 0), "AST_SEXP");
      return
	 module_initialization_70_ast_apply(((long) 0), "AST_SEXP");
   }
}
