/*===========================================================================*/
/*   (Ast/var.scm)                                                           */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;


static obj_t _variable_access_set_1909_13_ast_var(obj_t, obj_t, obj_t);
extern obj_t sfun_side_effect__85_ast_var(sfun_bglt);
extern long fun_arity_132_ast_var(fun_bglt);
static obj_t _local_name1857_233_ast_var(obj_t, obj_t);
extern obj_t fun_stack_allocator_124_ast_var(fun_bglt);
static obj_t _variable_value_set_1907_20_ast_var(obj_t, obj_t, obj_t);
static obj_t _cfun_the_closure_set_1812_176_ast_var(obj_t, obj_t, obj_t);
static obj_t _global_import_set_1890_147_ast_var(obj_t, obj_t, obj_t);
extern type_bglt variable_type_237_ast_var(variable_bglt);
extern obj_t variable_id_167_ast_var(variable_bglt);
static obj_t _global_occurrence1888_193_ast_var(obj_t, obj_t);
static obj_t method_init_76_ast_var();
static obj_t _global_src1900_53_ast_var(obj_t, obj_t);
extern local_bglt allocate_local_177_ast_var();
static obj_t _sfun_args_set_1832_111_ast_var(obj_t, obj_t, obj_t);
static obj_t _global_removable1886_9_ast_var(obj_t, obj_t);
static obj_t _cfun_side_effect_1805_211_ast_var(obj_t, obj_t);
static obj_t _global_fast_alpha_set_1883_62_ast_var(obj_t, obj_t, obj_t);
extern obj_t variable_fast_alpha_set__48_ast_var(variable_bglt, obj_t);
static obj_t _global_type1878_182_ast_var(obj_t, obj_t);
static obj_t _make_scnst_248_ast_var(obj_t, obj_t, obj_t, obj_t);
static obj_t _variable_occurrence_set_1915_49_ast_var(obj_t, obj_t, obj_t);
extern local_bglt make_local_130_ast_var(obj_t, obj_t, type_bglt, value_bglt, obj_t, obj_t, obj_t, long, bool_t, long);
extern obj_t sfun_class_set__158_ast_var(sfun_bglt, obj_t);
static obj_t _local_occurrence1869_253_ast_var(obj_t, obj_t);
extern obj_t global_value_set__118_ast_var(global_bglt, value_bglt);
extern obj_t fun_top__set__55_ast_var(fun_bglt, bool_t);
extern svar_bglt allocate_svar_218_ast_var();
extern obj_t fun_the_closure_217_ast_var(fun_bglt);
extern svar_bglt make_svar_231_ast_var(obj_t);
extern obj_t global_fast_alpha_242_ast_var(global_bglt);
static obj_t _allocate_value_13_ast_var(obj_t);
extern bool_t global_library__62_ast_var(global_bglt);
extern obj_t sfun_predicate_of_set__36_ast_var(sfun_bglt, obj_t);
extern obj_t local_name_set__155_ast_var(local_bglt, obj_t);
static obj_t _variable_fast_alpha_set_1911_129_ast_var(obj_t, obj_t, obj_t);
static obj_t _cfun_arity1803_33_ast_var(obj_t, obj_t);
extern obj_t global_import_set__22_ast_var(global_bglt, obj_t);
static obj_t _variable_removable_set_1913_123_ast_var(obj_t, obj_t, obj_t);
static obj_t _sfun_top__set_1826_236_ast_var(obj_t, obj_t, obj_t);
extern obj_t local_user__set__89_ast_var(local_bglt, bool_t);
static obj_t _variable_access1910_167_ast_var(obj_t, obj_t);
extern bool_t fun_top__228_ast_var(fun_bglt);
static obj_t _global_pragma1898_160_ast_var(obj_t, obj_t);
static obj_t _sexit_detached_1793_72_ast_var(obj_t, obj_t);
extern obj_t cfun_stack_allocator_58_ast_var(cfun_bglt);
extern obj_t scnst_class_set__87_ast_var(scnst_bglt, obj_t);
static obj_t object__struct_svar1500_98_ast_var(obj_t, obj_t);
static obj_t _global_module1889_155_ast_var(obj_t, obj_t);
extern obj_t fun_predicate_of_193_ast_var(fun_bglt);
static obj_t _allocate_global_232_ast_var(obj_t);
static obj_t object__struct_sfun1508_100_ast_var(obj_t, obj_t);
extern sexit_bglt allocate_sexit_47_ast_var();
static obj_t _global_library_1895_187_ast_var(obj_t, obj_t);
static obj_t _local_access1863_55_ast_var(obj_t, obj_t);
static obj_t _sfun_predicate_of1823_228_ast_var(obj_t, obj_t);
static obj_t _sfun_loc_set_1840_150_ast_var(obj_t, obj_t, obj_t);
static obj_t _cfun_predicate_of_set_1806_183_ast_var(obj_t, obj_t, obj_t);
static obj_t _cfun_macro_1815_17_ast_var(obj_t, obj_t);
extern obj_t global_id_179_ast_var(global_bglt);
extern obj_t local_occurrence_set__128_ast_var(local_bglt, long);
static obj_t object__struct_scnst1496_159_ast_var(obj_t, obj_t);
static obj_t _global_library__set_1894_129_ast_var(obj_t, obj_t, obj_t);
static obj_t _sfun_arity1819_181_ast_var(obj_t, obj_t);
extern obj_t add_method__1___object(obj_t, obj_t, obj_t);
static obj_t _fun_side_effect_1845_49_ast_var(obj_t, obj_t);
static obj_t _sfun__63_ast_var(obj_t, obj_t);
obj_t global_ast_var = BUNSPEC;
extern obj_t fun_side_effect__set__185_ast_var(fun_bglt, obj_t);
extern cfun_bglt allocate_cfun_23_ast_var();
static obj_t _global_access_set_1881_141_ast_var(obj_t, obj_t, obj_t);
extern sexit_bglt make_sexit_79_ast_var(obj_t, bool_t);
static obj_t struct_object__object_cvar1494_104_ast_var(obj_t, obj_t, obj_t);
extern cfun_bglt make_cfun_58_ast_var(long, obj_t, obj_t, obj_t, bool_t, obj_t, obj_t, bool_t, bool_t);
static obj_t _make_cfun1802_160_ast_var(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t _local_name_set_1856_6_ast_var(obj_t, obj_t, obj_t);
extern obj_t svar_loc_189_ast_var(svar_bglt);
static obj_t _global_value1880_37_ast_var(obj_t, obj_t);
static obj_t _global_fast_alpha1884_64_ast_var(obj_t, obj_t);
extern long local_occurrence_5_ast_var(local_bglt);
static obj_t _global_type_set_1877_24_ast_var(obj_t, obj_t, obj_t);
extern obj_t global_evaluable__set__201_ast_var(global_bglt, bool_t);
static obj_t struct_object__object_cfun1506_45_ast_var(obj_t, obj_t, obj_t);
obj_t cvar_ast_var = BUNSPEC;
extern obj_t sfun_loc_13_ast_var(sfun_bglt);
extern obj_t sfun_the_closure_set__227_ast_var(sfun_bglt, obj_t);
static obj_t _make_fun1842_242_ast_var(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern global_bglt make_global_89_ast_var(obj_t, obj_t, type_bglt, value_bglt, obj_t, obj_t, obj_t, long, obj_t, obj_t, bool_t, bool_t, bool_t, obj_t, obj_t);
static obj_t _local_fast_alpha1865_218_ast_var(obj_t, obj_t);
extern obj_t cfun_predicate_of_set__65_ast_var(cfun_bglt, obj_t);
extern value_bglt variable_value_212_ast_var(variable_bglt);
extern obj_t fun_side_effect__244_ast_var(fun_bglt);
extern value_bglt local_value_65_ast_var(local_bglt);
extern bool_t is_a__118___object(obj_t, obj_t);
static obj_t struct_object__object_value1531_175_ast_var(obj_t, obj_t, obj_t);
static obj_t _sfun_the_closure_set_1828_16_ast_var(obj_t, obj_t, obj_t);
static obj_t object__struct_local1516_246_ast_var(obj_t, obj_t);
extern obj_t variable_removable_set__218_ast_var(variable_bglt, obj_t);
static obj_t _local_removable_set_1866_226_ast_var(obj_t, obj_t, obj_t);
extern bool_t svar__161_ast_var(obj_t);
extern obj_t global_src_set__223_ast_var(global_bglt, obj_t);
static obj_t _fun_stack_allocator1849_244_ast_var(obj_t, obj_t);
static obj_t _sfun_dsssl_keywords1839_19_ast_var(obj_t, obj_t);
extern value_bglt allocate_value_190_ast_var();
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern bool_t variable__18_ast_var(obj_t);
static obj_t _scnst_class_set_1796_244_ast_var(obj_t, obj_t, obj_t);
static obj_t _make_cvar_142_ast_var(obj_t, obj_t);
static obj_t _scnst_loc1799_179_ast_var(obj_t, obj_t);
extern long variable_occurrence_246_ast_var(variable_bglt);
static obj_t _cfun_predicate_of1807_166_ast_var(obj_t, obj_t);
extern obj_t global_src_229_ast_var(global_bglt);
extern type_bglt global_type_243_ast_var(global_bglt);
static obj_t _cfun_stack_allocator_set_1808_197_ast_var(obj_t, obj_t, obj_t);
static obj_t _variable_type1906_56_ast_var(obj_t, obj_t);
static obj_t _local_user_1871_190_ast_var(obj_t, obj_t);
extern obj_t global_access_222_ast_var(global_bglt);
extern value_bglt make_value_52_ast_var();
extern obj_t scnst_loc_19_ast_var(scnst_bglt);
extern bool_t global_user__208_ast_var(global_bglt);
static obj_t _scnst_class1797_79_ast_var(obj_t, obj_t);
static obj_t _variable_name_set_1903_207_ast_var(obj_t, obj_t, obj_t);
static obj_t _variable_occurrence1916_131_ast_var(obj_t, obj_t);
static obj_t _fun_side_effect__set_1844_232_ast_var(obj_t, obj_t, obj_t);
static obj_t _sfun_loc1841_74_ast_var(obj_t, obj_t);
static obj_t _cvar_macro_1794_97_ast_var(obj_t, obj_t);
extern sfun_bglt allocate_sfun_135_ast_var();
extern long sfun_arity_53_ast_var(sfun_bglt);
extern sfun_bglt make_sfun_19_ast_var(long, obj_t, obj_t, obj_t, bool_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t object__struct_variable1525_164_ast_var(obj_t, obj_t);
static obj_t _cvar__164_ast_var(obj_t, obj_t);
extern bool_t cfun__213_ast_var(obj_t);
extern obj_t cfun_the_closure_set__43_ast_var(cfun_bglt, obj_t);
extern long class_num_218___object(obj_t);
obj_t svar_ast_var = BUNSPEC;
static obj_t _local_removable1867_251_ast_var(obj_t, obj_t);
extern obj_t sfun_class_145_ast_var(sfun_bglt);
extern obj_t global_pragma_105_ast_var(global_bglt);
static obj_t _sfun_predicate_of_set_1822_241_ast_var(obj_t, obj_t, obj_t);
static obj_t _fun_top_1851_134_ast_var(obj_t, obj_t);
obj_t scnst_ast_var = BUNSPEC;
extern obj_t sfun_args_set__132_ast_var(sfun_bglt, obj_t);
static obj_t _variable_id1902_222_ast_var(obj_t, obj_t);
extern obj_t fun_the_closure_set__119_ast_var(fun_bglt, obj_t);
extern obj_t variable_removable_74_ast_var(variable_bglt);
extern bool_t scnst__249_ast_var(obj_t);
static obj_t _fun_the_closure_set_1852_75_ast_var(obj_t, obj_t, obj_t);
extern obj_t cfun_predicate_of_23_ast_var(cfun_bglt);
obj_t fun_ast_var = BUNSPEC;
extern obj_t global_access_set__188_ast_var(global_bglt, obj_t);
static obj_t _cfun_infix_1817_88_ast_var(obj_t, obj_t);
extern obj_t scnst_node_98_ast_var(scnst_bglt);
extern obj_t local_value_set__243_ast_var(local_bglt, value_bglt);
extern bool_t local__163_ast_var(obj_t);
extern obj_t sexit_detached__set__116_ast_var(sexit_bglt, bool_t);
static obj_t imported_modules_init_94_ast_var();
static obj_t _sexit_handler1791_102_ast_var(obj_t, obj_t);
static obj_t _local_occurrence_set_1868_56_ast_var(obj_t, obj_t, obj_t);
extern long local_key_6_ast_var(local_bglt);
extern obj_t variable_occurrence_set__234_ast_var(variable_bglt, long);
static obj_t _make_svar_17_ast_var(obj_t, obj_t);
static obj_t _fun_arity1843_229_ast_var(obj_t, obj_t);
static obj_t _global_id1874_42_ast_var(obj_t, obj_t);
static obj_t object__struct_sexit1488_225_ast_var(obj_t, obj_t);
extern obj_t cfun_top__set__230_ast_var(cfun_bglt, bool_t);
static obj_t _sfun_class_set_1836_206_ast_var(obj_t, obj_t, obj_t);
extern obj_t local_fast_alpha_65_ast_var(local_bglt);
static obj_t _allocate_cvar_101_ast_var(obj_t);
static obj_t _fun_predicate_of1847_244_ast_var(obj_t, obj_t);
extern obj_t global_import_37_ast_var(global_bglt);
extern bool_t cfun_infix__133_ast_var(cfun_bglt);
extern obj_t local_name_136_ast_var(local_bglt);
extern obj_t sexit_handler_set__47_ast_var(sexit_bglt, obj_t);
static obj_t _cfun_top_1811_211_ast_var(obj_t, obj_t);
static obj_t _svar_loc_set_1800_165_ast_var(obj_t, obj_t, obj_t);
static obj_t _local_fast_alpha_set_1864_162_ast_var(obj_t, obj_t, obj_t);
extern obj_t variable_type_set__4_ast_var(variable_bglt, type_bglt);
obj_t cfun_ast_var = BUNSPEC;
extern bool_t sfun_top__45_ast_var(sfun_bglt);
static obj_t _allocate_scnst_4_ast_var(obj_t);
static obj_t struct_object__object_scnst1498_133_ast_var(obj_t, obj_t, obj_t);
static obj_t _global__76_ast_var(obj_t, obj_t);
static obj_t _variable_removable1914_41_ast_var(obj_t, obj_t);
static obj_t _fun__116_ast_var(obj_t, obj_t);
static obj_t _scnst__164_ast_var(obj_t, obj_t);
static obj_t _global_name1876_44_ast_var(obj_t, obj_t);
static obj_t _variable_fast_alpha1912_15_ast_var(obj_t, obj_t);
extern obj_t cfun_side_effect__250_ast_var(cfun_bglt);
static obj_t _local_id1855_79_ast_var(obj_t, obj_t);
static obj_t _make_sexit_67_ast_var(obj_t, obj_t, obj_t);
static obj_t _sfun_property_set_1830_7_ast_var(obj_t, obj_t, obj_t);
extern obj_t variable_value_set__250_ast_var(variable_bglt, value_bglt);
static obj_t _local_access_set_1862_243_ast_var(obj_t, obj_t, obj_t);
extern obj_t sfun_dsssl_keywords_40_ast_var(sfun_bglt);
static obj_t _local__113_ast_var(obj_t, obj_t);
static obj_t library_modules_init_112_ast_var();
extern obj_t sfun_top__set__255_ast_var(sfun_bglt, bool_t);
extern obj_t variable_access_set__102_ast_var(variable_bglt, obj_t);
extern obj_t variable_fast_alpha_132_ast_var(variable_bglt);
extern obj_t cfun_the_closure_97_ast_var(cfun_bglt);
static obj_t _local_type1859_14_ast_var(obj_t, obj_t);
static obj_t _local_type_set_1858_13_ast_var(obj_t, obj_t, obj_t);
extern obj_t global_fast_alpha_set__101_ast_var(global_bglt, obj_t);
static obj_t _variable_value1908_100_ast_var(obj_t, obj_t);
extern obj_t make_struct(obj_t, long, obj_t);
static obj_t struct_object__object_global1523_249_ast_var(obj_t, obj_t, obj_t);
static obj_t _cfun_stack_allocator1809_246_ast_var(obj_t, obj_t);
extern obj_t variable_name_105_ast_var(variable_bglt);
static obj_t _sfun_class1837_29_ast_var(obj_t, obj_t);
static obj_t _svar_loc1801_216_ast_var(obj_t, obj_t);
static obj_t _make_global1873_93_ast_var(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t _sfun_top_1827_49_ast_var(obj_t, obj_t);
static obj_t struct_object__object_local1518_37_ast_var(obj_t, obj_t, obj_t);
extern obj_t variable_access_211_ast_var(variable_bglt);
static obj_t _sfun_stack_allocator1825_161_ast_var(obj_t, obj_t);
static obj_t toplevel_init_63_ast_var();
extern obj_t sfun_property_set__95_ast_var(sfun_bglt, obj_t);
static obj_t object__struct_cvar1492_35_ast_var(obj_t, obj_t);
static obj_t _allocate_svar_73_ast_var(obj_t);
extern obj_t fun_predicate_of_set__163_ast_var(fun_bglt, obj_t);
extern fun_bglt allocate_fun_149_ast_var();
extern obj_t create_vector(long);
extern obj_t global_module_203_ast_var(global_bglt);
extern obj_t open_input_string(obj_t);
extern bool_t global__63_ast_var(obj_t);
extern bool_t sexit__36_ast_var(obj_t);
static obj_t object__struct_cfun1504_204_ast_var(obj_t, obj_t);
static obj_t struct_object__object_fun1514_86_ast_var(obj_t, obj_t, obj_t);
extern obj_t local_access_176_ast_var(local_bglt);
extern long cfun_arity_68_ast_var(cfun_bglt);
static obj_t _sfun_the_closure1829_199_ast_var(obj_t, obj_t);
static obj_t _make_value_202_ast_var(obj_t);
static obj_t _cfun_top__set_1810_137_ast_var(obj_t, obj_t, obj_t);
obj_t sfun_ast_var = BUNSPEC;
extern obj_t cfun_stack_allocator_set__66_ast_var(cfun_bglt, obj_t);
extern obj_t sfun_loc_set__51_ast_var(sfun_bglt, obj_t);
extern obj_t variable_name_set__44_ast_var(variable_bglt, obj_t);
static obj_t _variable__238_ast_var(obj_t, obj_t);
static obj_t _fun_top__set_1850_187_ast_var(obj_t, obj_t, obj_t);
static obj_t object__struct_global1521_59_ast_var(obj_t, obj_t);
extern obj_t sfun_side_effect__set__97_ast_var(sfun_bglt, obj_t);
static obj_t object__struct_fun1512_56_ast_var(obj_t, obj_t);
static obj_t _sfun_args1833_131_ast_var(obj_t, obj_t);
static obj_t _scnst_loc_set_1798_39_ast_var(obj_t, obj_t, obj_t);
static obj_t _sfun_body_set_1834_175_ast_var(obj_t, obj_t, obj_t);
extern bool_t fun__147_ast_var(obj_t);
static obj_t _local_value1861_71_ast_var(obj_t, obj_t);
extern obj_t sexit_handler_210_ast_var(sexit_bglt);
static obj_t _variable_type_set_1905_230_ast_var(obj_t, obj_t, obj_t);
extern obj_t global_removable_57_ast_var(global_bglt);
extern obj_t svar_loc_set__106_ast_var(svar_bglt, obj_t);
extern scnst_bglt allocate_scnst_81_ast_var();
static obj_t _fun_stack_allocator_set_1848_167_ast_var(obj_t, obj_t, obj_t);
extern obj_t object___object;
static obj_t _cfun_side_effect__set_1804_46_ast_var(obj_t, obj_t, obj_t);
obj_t variable_ast_var = BUNSPEC;
extern obj_t sfun_property_40_ast_var(sfun_bglt);
static obj_t _global_value_set_1879_51_ast_var(obj_t, obj_t, obj_t);
static obj_t _global_import1891_46_ast_var(obj_t, obj_t);
extern obj_t sfun_body_150_ast_var(sfun_bglt);
extern bool_t value__43_ast_var(obj_t);
extern obj_t local_access_set__100_ast_var(local_bglt, obj_t);
static obj_t _make_sfun1818_142_ast_var(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
obj_t local_ast_var = BUNSPEC;
static obj_t struct_object__object_svar1502_167_ast_var(obj_t, obj_t, obj_t);
static obj_t _sexit__255_ast_var(obj_t, obj_t);
static obj_t _svar__166_ast_var(obj_t, obj_t);
extern scnst_bglt make_scnst_115_ast_var(obj_t, obj_t, obj_t);
static obj_t _allocate_cfun_27_ast_var(obj_t);
extern obj_t cfun_args_type_30_ast_var(cfun_bglt);
extern bool_t sfun__199_ast_var(obj_t);
static obj_t _global_evaluable__set_1892_147_ast_var(obj_t, obj_t, obj_t);
extern bool_t global_evaluable__170_ast_var(global_bglt);
static obj_t _make_variable1901_144_ast_var(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t _global_src_set_1899_103_ast_var(obj_t, obj_t, obj_t);
extern obj_t global_user__set__116_ast_var(global_bglt, bool_t);
extern obj_t fun_stack_allocator_set__246_ast_var(fun_bglt, obj_t);
static obj_t struct_object__object_sfun1510_23_ast_var(obj_t, obj_t, obj_t);
extern bool_t cfun_top__60_ast_var(cfun_bglt);
static obj_t _local_value_set_1860_93_ast_var(obj_t, obj_t, obj_t);
extern bool_t sexit_detached__208_ast_var(sexit_bglt);
extern obj_t register_class__225___object(obj_t, obj_t, obj_t, long, obj_t, obj_t, obj_t);
static obj_t struct_object__object_sexit1490_65_ast_var(obj_t, obj_t, obj_t);
extern obj_t global_type_set__109_ast_var(global_bglt, type_bglt);
static obj_t _variable_name1904_47_ast_var(obj_t, obj_t);
extern value_bglt global_value_241_ast_var(global_bglt);
extern obj_t sfun_stack_allocator_39_ast_var(sfun_bglt);
extern obj_t local_fast_alpha_set__243_ast_var(local_bglt, obj_t);
static obj_t _sfun_property1831_170_ast_var(obj_t, obj_t);
static obj_t _local_key1872_162_ast_var(obj_t, obj_t);
extern obj_t local_removable_set__151_ast_var(local_bglt, obj_t);
static obj_t _cfun_infix__set_1816_22_ast_var(obj_t, obj_t, obj_t);
extern bool_t local_user__147_ast_var(local_bglt);
static obj_t _scnst_node1795_36_ast_var(obj_t, obj_t);
extern obj_t sfun_dsssl_keywords_set__95_ast_var(sfun_bglt, obj_t);
static obj_t object_init_111_ast_var();
static obj_t _fun_predicate_of_set_1846_195_ast_var(obj_t, obj_t, obj_t);
static obj_t _value__210_ast_var(obj_t, obj_t);
static obj_t _cfun__201_ast_var(obj_t, obj_t);
extern obj_t sfun_the_closure_253_ast_var(sfun_bglt);
static obj_t _global_user_1897_27_ast_var(obj_t, obj_t);
extern obj_t sfun_args_174_ast_var(sfun_bglt);
static obj_t _allocate_local_35_ast_var(obj_t);
extern obj_t sfun_body_set__45_ast_var(sfun_bglt, obj_t);
static obj_t _global_evaluable_1893_132_ast_var(obj_t, obj_t);
extern obj_t cfun_side_effect__set__1_ast_var(cfun_bglt, obj_t);
static obj_t _sfun_body1835_143_ast_var(obj_t, obj_t);
static obj_t _allocate_variable_137_ast_var(obj_t);
extern long global_occurrence_96_ast_var(global_bglt);
extern obj_t local_removable_34_ast_var(local_bglt);
extern obj_t global_name_141_ast_var(global_bglt);
obj_t sexit_ast_var = BUNSPEC;
static obj_t _global_name_set_1875_244_ast_var(obj_t, obj_t, obj_t);
static obj_t _make_local1854_41_ast_var(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t _global_access1882_14_ast_var(obj_t, obj_t);
extern obj_t global_removable_set__21_ast_var(global_bglt, obj_t);
static obj_t _allocate_sfun_141_ast_var(obj_t);
static obj_t _sexit_detached__set_1792_226_ast_var(obj_t, obj_t, obj_t);
static obj_t _allocate_fun_230_ast_var(obj_t);
static obj_t _fun_the_closure1853_244_ast_var(obj_t, obj_t);
extern obj_t read___reader(obj_t);
extern variable_bglt allocate_variable_244_ast_var();
extern obj_t sfun_stack_allocator_set__142_ast_var(sfun_bglt, obj_t);
extern bool_t cvar__118_ast_var(obj_t);
static obj_t _sfun_side_effect_1821_40_ast_var(obj_t, obj_t);
static obj_t _global_user__set_1896_171_ast_var(obj_t, obj_t, obj_t);
extern bool_t cvar_macro__32_ast_var(cvar_bglt);
extern obj_t scnst_loc_set__206_ast_var(scnst_bglt, obj_t);
extern obj_t sfun_predicate_of_63_ast_var(sfun_bglt);
extern type_bglt local_type_242_ast_var(local_bglt);
static obj_t _sfun_side_effect__set_1820_154_ast_var(obj_t, obj_t, obj_t);
extern variable_bglt make_variable_6_ast_var(obj_t, obj_t, type_bglt, value_bglt, obj_t, obj_t, obj_t, long);
extern cvar_bglt allocate_cvar_254_ast_var();
extern obj_t local_type_set__101_ast_var(local_bglt, type_bglt);
extern cvar_bglt make_cvar_132_ast_var(bool_t);
static obj_t _sfun_stack_allocator_set_1824_51_ast_var(obj_t, obj_t, obj_t);
static obj_t _cfun_args_type1814_160_ast_var(obj_t, obj_t);
static obj_t struct_object__object_variable1527_182_ast_var(obj_t, obj_t, obj_t);
static obj_t object__struct_value1529_106_ast_var(obj_t, obj_t);
static obj_t _sfun_dsssl_keywords_set_1838_239_ast_var(obj_t, obj_t, obj_t);
extern obj_t global_name_set__147_ast_var(global_bglt, obj_t);
extern fun_bglt make_fun_37_ast_var(long, obj_t, obj_t, obj_t, bool_t, obj_t);
extern global_bglt allocate_global_222_ast_var();
static obj_t _sexit_handler_set_1790_149_ast_var(obj_t, obj_t, obj_t);
static obj_t _local_user__set_1870_232_ast_var(obj_t, obj_t, obj_t);
extern obj_t local_id_1_ast_var(local_bglt);
extern obj_t global_occurrence_set__154_ast_var(global_bglt, long);
static obj_t require_initialization_114_ast_var = BUNSPEC;
static obj_t _allocate_sexit_130_ast_var(obj_t);
extern obj_t global_library__set__213_ast_var(global_bglt, bool_t);
obj_t value_ast_var = BUNSPEC;
extern obj_t scnst_class_73_ast_var(scnst_bglt);
static obj_t _cfun_the_closure1813_65_ast_var(obj_t, obj_t);
static obj_t _global_removable_set_1885_172_ast_var(obj_t, obj_t, obj_t);
static obj_t cnst_init_137_ast_var();
extern bool_t cfun_macro__119_ast_var(cfun_bglt);
static obj_t _global_occurrence_set_1887_244_ast_var(obj_t, obj_t, obj_t);
extern obj_t cfun_infix__set__175_ast_var(cfun_bglt, bool_t);
static obj_t __cnst[11];

DEFINE_EXPORT_PROCEDURE(allocate_cfun_env_241_ast_var, _allocate_cfun_27_ast_var1947, _allocate_cfun_27_ast_var, 0L, 0);
DEFINE_EXPORT_PROCEDURE(local_removable_env_70_ast_var, _local_removable1867_251_ast_var1948, _local_removable1867_251_ast_var, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_cvar_env_104_ast_var, _make_cvar_142_ast_var1949, _make_cvar_142_ast_var, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sexit__env_174_ast_var, _sexit__255_ast_var1950, _sexit__255_ast_var, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sfun_predicate_of_set__env_174_ast_var, _sfun_predicate_of_set_1822_241_ast_var1951, _sfun_predicate_of_set_1822_241_ast_var, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_cfun_env_81_ast_var, _make_cfun1802_160_ast_var1952, _make_cfun1802_160_ast_var, 0L, 9);
DEFINE_EXPORT_PROCEDURE(cfun__env_36_ast_var, _cfun__201_ast_var1953, _cfun__201_ast_var, 0L, 1);
DEFINE_EXPORT_PROCEDURE(cfun_predicate_of_env_241_ast_var, _cfun_predicate_of1807_166_ast_var1954, _cfun_predicate_of1807_166_ast_var, 0L, 1);
DEFINE_EXPORT_PROCEDURE(global_access_set__env_14_ast_var, _global_access_set_1881_141_ast_var1955, _global_access_set_1881_141_ast_var, 0L, 2);
DEFINE_EXPORT_PROCEDURE(sfun_class_set__env_48_ast_var, _sfun_class_set_1836_206_ast_var1956, _sfun_class_set_1836_206_ast_var, 0L, 2);
DEFINE_EXPORT_PROCEDURE(fun_predicate_of_env_149_ast_var, _fun_predicate_of1847_244_ast_var1957, _fun_predicate_of1847_244_ast_var, 0L, 1);
DEFINE_EXPORT_PROCEDURE(cfun_stack_allocator_env_81_ast_var, _cfun_stack_allocator1809_246_ast_var1958, _cfun_stack_allocator1809_246_ast_var, 0L, 1);
DEFINE_EXPORT_PROCEDURE(fun_top__set__env_231_ast_var, _fun_top__set_1850_187_ast_var1959, _fun_top__set_1850_187_ast_var, 0L, 2);
DEFINE_EXPORT_PROCEDURE(allocate_scnst_env_226_ast_var, _allocate_scnst_4_ast_var1960, _allocate_scnst_4_ast_var, 0L, 0);
DEFINE_EXPORT_PROCEDURE(sfun_the_closure_set__env_129_ast_var, _sfun_the_closure_set_1828_16_ast_var1961, _sfun_the_closure_set_1828_16_ast_var, 0L, 2);
DEFINE_EXPORT_PROCEDURE(fun_stack_allocator_env_55_ast_var, _fun_stack_allocator1849_244_ast_var1962, _fun_stack_allocator1849_244_ast_var, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_value_env_59_ast_var, _make_value_202_ast_var1963, _make_value_202_ast_var, 0L, 0);
DEFINE_EXPORT_PROCEDURE(sfun_dsssl_keywords_env_170_ast_var, _sfun_dsssl_keywords1839_19_ast_var1964, _sfun_dsssl_keywords1839_19_ast_var, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sfun_dsssl_keywords_set__env_147_ast_var, _sfun_dsssl_keywords_set_1838_239_ast_var1965, _sfun_dsssl_keywords_set_1838_239_ast_var, 0L, 2);
DEFINE_EXPORT_PROCEDURE(sfun_stack_allocator_env_230_ast_var, _sfun_stack_allocator1825_161_ast_var1966, _sfun_stack_allocator1825_161_ast_var, 0L, 1);
DEFINE_EXPORT_PROCEDURE(scnst_loc_env_102_ast_var, _scnst_loc1799_179_ast_var1967, _scnst_loc1799_179_ast_var, 0L, 1);
DEFINE_EXPORT_PROCEDURE(local_type_env_200_ast_var, _local_type1859_14_ast_var1968, _local_type1859_14_ast_var, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sfun_class_env_1_ast_var, _sfun_class1837_29_ast_var1969, _sfun_class1837_29_ast_var, 0L, 1);
DEFINE_EXPORT_PROCEDURE(global_import_env_121_ast_var, _global_import1891_46_ast_var1970, _global_import1891_46_ast_var, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_variable_env_15_ast_var, _make_variable1901_144_ast_var1971, _make_variable1901_144_ast_var, 0L, 8);
DEFINE_EXPORT_PROCEDURE(local_type_set__env_25_ast_var, _local_type_set_1858_13_ast_var1972, _local_type_set_1858_13_ast_var, 0L, 2);
DEFINE_EXPORT_PROCEDURE(variable_occurrence_env_50_ast_var, _variable_occurrence1916_131_ast_var1973, _variable_occurrence1916_131_ast_var, 0L, 1);
DEFINE_EXPORT_PROCEDURE(fun_side_effect__set__env_203_ast_var, _fun_side_effect__set_1844_232_ast_var1974, _fun_side_effect__set_1844_232_ast_var, 0L, 2);
DEFINE_EXPORT_PROCEDURE(allocate_local_env_7_ast_var, _allocate_local_35_ast_var1975, _allocate_local_35_ast_var, 0L, 0);
DEFINE_EXPORT_PROCEDURE(sfun_property_env_170_ast_var, _sfun_property1831_170_ast_var1976, _sfun_property1831_170_ast_var, 0L, 1);
DEFINE_EXPORT_PROCEDURE(variable_name_env_166_ast_var, _variable_name1904_47_ast_var1977, _variable_name1904_47_ast_var, 0L, 1);
DEFINE_EXPORT_PROCEDURE(variable_name_set__env_43_ast_var, _variable_name_set_1903_207_ast_var1978, _variable_name_set_1903_207_ast_var, 0L, 2);
DEFINE_EXPORT_PROCEDURE(global_type_env_20_ast_var, _global_type1878_182_ast_var1979, _global_type1878_182_ast_var, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc1941_ast_var, struct_object__object_value1531_175_ast_var1980, struct_object__object_value1531_175_ast_var, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc1939_ast_var, struct_object__object_variable1527_182_ast_var1981, struct_object__object_variable1527_182_ast_var, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc1940_ast_var, object__struct_value1529_106_ast_var1982, object__struct_value1529_106_ast_var, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc1938_ast_var, object__struct_variable1525_164_ast_var1983, object__struct_variable1525_164_ast_var, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc1937_ast_var, struct_object__object_global1523_249_ast_var1984, struct_object__object_global1523_249_ast_var, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc1936_ast_var, object__struct_global1521_59_ast_var1985, object__struct_global1521_59_ast_var, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc1935_ast_var, struct_object__object_local1518_37_ast_var1986, struct_object__object_local1518_37_ast_var, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc1934_ast_var, object__struct_local1516_246_ast_var1987, object__struct_local1516_246_ast_var, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc1933_ast_var, struct_object__object_fun1514_86_ast_var1988, struct_object__object_fun1514_86_ast_var, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc1932_ast_var, object__struct_fun1512_56_ast_var1989, object__struct_fun1512_56_ast_var, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc1931_ast_var, struct_object__object_sfun1510_23_ast_var1990, struct_object__object_sfun1510_23_ast_var, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc1929_ast_var, struct_object__object_cfun1506_45_ast_var1991, struct_object__object_cfun1506_45_ast_var, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc1930_ast_var, object__struct_sfun1508_100_ast_var1992, object__struct_sfun1508_100_ast_var, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc1928_ast_var, object__struct_cfun1504_204_ast_var1993, object__struct_cfun1504_204_ast_var, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc1927_ast_var, struct_object__object_svar1502_167_ast_var1994, struct_object__object_svar1502_167_ast_var, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc1926_ast_var, object__struct_svar1500_98_ast_var1995, object__struct_svar1500_98_ast_var, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc1925_ast_var, struct_object__object_scnst1498_133_ast_var1996, struct_object__object_scnst1498_133_ast_var, 0L, 2);
DEFINE_EXPORT_PROCEDURE(variable_occurrence_set__env_144_ast_var, _variable_occurrence_set_1915_49_ast_var1997, _variable_occurrence_set_1915_49_ast_var, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc1924_ast_var, object__struct_scnst1496_159_ast_var1998, object__struct_scnst1496_159_ast_var, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc1923_ast_var, struct_object__object_cvar1494_104_ast_var1999, struct_object__object_cvar1494_104_ast_var, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc1922_ast_var, object__struct_cvar1492_35_ast_var2000, object__struct_cvar1492_35_ast_var, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc1921_ast_var, struct_object__object_sexit1490_65_ast_var2001, struct_object__object_sexit1490_65_ast_var, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc1920_ast_var, object__struct_sexit1488_225_ast_var2002, object__struct_sexit1488_225_ast_var, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sfun_the_closure_env_31_ast_var, _sfun_the_closure1829_199_ast_var2003, _sfun_the_closure1829_199_ast_var, 0L, 1);
DEFINE_EXPORT_PROCEDURE(fun_arity_env_104_ast_var, _fun_arity1843_229_ast_var2004, _fun_arity1843_229_ast_var, 0L, 1);
DEFINE_EXPORT_PROCEDURE(variable_fast_alpha_set__env_164_ast_var, _variable_fast_alpha_set_1911_129_ast_var2005, _variable_fast_alpha_set_1911_129_ast_var, 0L, 2);
DEFINE_EXPORT_PROCEDURE(local_occurrence_set__env_80_ast_var, _local_occurrence_set_1868_56_ast_var2006, _local_occurrence_set_1868_56_ast_var, 0L, 2);
DEFINE_EXPORT_PROCEDURE(global_id_env_112_ast_var, _global_id1874_42_ast_var2007, _global_id1874_42_ast_var, 0L, 1);
DEFINE_EXPORT_PROCEDURE(local_access_set__env_189_ast_var, _local_access_set_1862_243_ast_var2008, _local_access_set_1862_243_ast_var, 0L, 2);
DEFINE_EXPORT_PROCEDURE(global_access_env_97_ast_var, _global_access1882_14_ast_var2009, _global_access1882_14_ast_var, 0L, 1);
DEFINE_EXPORT_PROCEDURE(cfun_top__env_46_ast_var, _cfun_top_1811_211_ast_var2010, _cfun_top_1811_211_ast_var, 0L, 1);
extern obj_t struct_object__object_env_209___object;
DEFINE_EXPORT_PROCEDURE(make_fun_env_121_ast_var, _make_fun1842_242_ast_var2011, _make_fun1842_242_ast_var, 0L, 6);
DEFINE_EXPORT_PROCEDURE(local_fast_alpha_set__env_20_ast_var, _local_fast_alpha_set_1864_162_ast_var2012, _local_fast_alpha_set_1864_162_ast_var, 0L, 2);
DEFINE_EXPORT_PROCEDURE(global_user__env_54_ast_var, _global_user_1897_27_ast_var2013, _global_user_1897_27_ast_var, 0L, 1);
DEFINE_EXPORT_PROCEDURE(cfun_macro__env_51_ast_var, _cfun_macro_1815_17_ast_var2014, _cfun_macro_1815_17_ast_var, 0L, 1);
DEFINE_EXPORT_PROCEDURE(cfun_side_effect__set__env_233_ast_var, _cfun_side_effect__set_1804_46_ast_var2015, _cfun_side_effect__set_1804_46_ast_var, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_scnst_env_172_ast_var, _make_scnst_248_ast_var2016, _make_scnst_248_ast_var, 0L, 3);
DEFINE_EXPORT_PROCEDURE(variable_fast_alpha_env_104_ast_var, _variable_fast_alpha1912_15_ast_var2017, _variable_fast_alpha1912_15_ast_var, 0L, 1);
DEFINE_EXPORT_PROCEDURE(scnst_node_env_65_ast_var, _scnst_node1795_36_ast_var2018, _scnst_node1795_36_ast_var, 0L, 1);
DEFINE_EXPORT_PROCEDURE(allocate_sexit_env_61_ast_var, _allocate_sexit_130_ast_var2019, _allocate_sexit_130_ast_var, 0L, 0);
DEFINE_EXPORT_PROCEDURE(allocate_variable_env_212_ast_var, _allocate_variable_137_ast_var2020, _allocate_variable_137_ast_var, 0L, 0);
DEFINE_EXPORT_PROCEDURE(global_src_set__env_126_ast_var, _global_src_set_1899_103_ast_var2021, _global_src_set_1899_103_ast_var, 0L, 2);
DEFINE_EXPORT_PROCEDURE(global_evaluable__set__env_148_ast_var, _global_evaluable__set_1892_147_ast_var2022, _global_evaluable__set_1892_147_ast_var, 0L, 2);
DEFINE_EXPORT_PROCEDURE(variable_removable_env_52_ast_var, _variable_removable1914_41_ast_var2023, _variable_removable1914_41_ast_var, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sfun_property_set__env_147_ast_var, _sfun_property_set_1830_7_ast_var2024, _sfun_property_set_1830_7_ast_var, 0L, 2);
DEFINE_EXPORT_PROCEDURE(local_value_set__env_20_ast_var, _local_value_set_1860_93_ast_var2025, _local_value_set_1860_93_ast_var, 0L, 2);
DEFINE_EXPORT_PROCEDURE(local__env_255_ast_var, _local__113_ast_var2026, _local__113_ast_var, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sexit_detached__set__env_159_ast_var, _sexit_detached__set_1792_226_ast_var2027, _sexit_detached__set_1792_226_ast_var, 0L, 2);
DEFINE_EXPORT_PROCEDURE(fun__env_177_ast_var, _fun__116_ast_var2028, _fun__116_ast_var, 0L, 1);
DEFINE_EXPORT_PROCEDURE(variable_value_env_145_ast_var, _variable_value1908_100_ast_var2029, _variable_value1908_100_ast_var, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sfun_top__env_125_ast_var, _sfun_top_1827_49_ast_var2030, _sfun_top_1827_49_ast_var, 0L, 1);
DEFINE_EXPORT_PROCEDURE(cfun_infix__set__env_176_ast_var, _cfun_infix__set_1816_22_ast_var2031, _cfun_infix__set_1816_22_ast_var, 0L, 2);
DEFINE_EXPORT_PROCEDURE(sfun_loc_env_34_ast_var, _sfun_loc1841_74_ast_var2032, _sfun_loc1841_74_ast_var, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_local_env_120_ast_var, _make_local1854_41_ast_var2033, _make_local1854_41_ast_var, 0L, 10);
DEFINE_EXPORT_PROCEDURE(fun_top__env_140_ast_var, _fun_top_1851_134_ast_var2034, _fun_top_1851_134_ast_var, 0L, 1);
DEFINE_EXPORT_PROCEDURE(global_value_set__env_220_ast_var, _global_value_set_1879_51_ast_var2035, _global_value_set_1879_51_ast_var, 0L, 2);
DEFINE_EXPORT_PROCEDURE(value__env_37_ast_var, _value__210_ast_var2036, _value__210_ast_var, 0L, 1);
DEFINE_EXPORT_PROCEDURE(local_user__env_177_ast_var, _local_user_1871_190_ast_var2037, _local_user_1871_190_ast_var, 0L, 1);
DEFINE_EXPORT_PROCEDURE(cfun_top__set__env_253_ast_var, _cfun_top__set_1810_137_ast_var2038, _cfun_top__set_1810_137_ast_var, 0L, 2);
DEFINE_EXPORT_PROCEDURE(scnst_class_env_83_ast_var, _scnst_class1797_79_ast_var2039, _scnst_class1797_79_ast_var, 0L, 1);
DEFINE_EXPORT_PROCEDURE(cvar_macro__env_250_ast_var, _cvar_macro_1794_97_ast_var2040, _cvar_macro_1794_97_ast_var, 0L, 1);
DEFINE_EXPORT_PROCEDURE(global_name_set__env_177_ast_var, _global_name_set_1875_244_ast_var2041, _global_name_set_1875_244_ast_var, 0L, 2);
DEFINE_EXPORT_PROCEDURE(allocate_svar_env_12_ast_var, _allocate_svar_73_ast_var2042, _allocate_svar_73_ast_var, 0L, 0);
DEFINE_EXPORT_PROCEDURE(variable__env_90_ast_var, _variable__238_ast_var2043, _variable__238_ast_var, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sfun_args_env_156_ast_var, _sfun_args1833_131_ast_var2044, _sfun_args1833_131_ast_var, 0L, 1);
DEFINE_EXPORT_PROCEDURE(fun_the_closure_env_152_ast_var, _fun_the_closure1853_244_ast_var2045, _fun_the_closure1853_244_ast_var, 0L, 1);
DEFINE_EXPORT_PROCEDURE(scnst_loc_set__env_227_ast_var, _scnst_loc_set_1798_39_ast_var2046, _scnst_loc_set_1798_39_ast_var, 0L, 2);
DEFINE_EXPORT_PROCEDURE(sfun_body_set__env_125_ast_var, _sfun_body_set_1834_175_ast_var2047, _sfun_body_set_1834_175_ast_var, 0L, 2);
DEFINE_EXPORT_PROCEDURE(allocate_sfun_env_18_ast_var, _allocate_sfun_141_ast_var2048, _allocate_sfun_141_ast_var, 0L, 0);
DEFINE_EXPORT_PROCEDURE(make_svar_env_198_ast_var, _make_svar_17_ast_var2049, _make_svar_17_ast_var, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sfun_side_effect__set__env_247_ast_var, _sfun_side_effect__set_1820_154_ast_var2050, _sfun_side_effect__set_1820_154_ast_var, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_sfun_env_102_ast_var, _make_sfun1818_142_ast_var2051, _make_sfun1818_142_ast_var, 0L, 12);
DEFINE_EXPORT_PROCEDURE(allocate_global_env_97_ast_var, _allocate_global_232_ast_var2052, _allocate_global_232_ast_var, 0L, 0);
DEFINE_EXPORT_PROCEDURE(variable_access_set__env_153_ast_var, _variable_access_set_1909_13_ast_var2053, _variable_access_set_1909_13_ast_var, 0L, 2);
DEFINE_EXPORT_PROCEDURE(global_pragma_env_166_ast_var, _global_pragma1898_160_ast_var2054, _global_pragma1898_160_ast_var, 0L, 1);
DEFINE_EXPORT_PROCEDURE(variable_type_set__env_235_ast_var, _variable_type_set_1905_230_ast_var2055, _variable_type_set_1905_230_ast_var, 0L, 2);
DEFINE_EXPORT_PROCEDURE(variable_id_env_187_ast_var, _variable_id1902_222_ast_var2056, _variable_id1902_222_ast_var, 0L, 1);
DEFINE_EXPORT_PROCEDURE(global_module_env_223_ast_var, _global_module1889_155_ast_var2057, _global_module1889_155_ast_var, 0L, 1);
DEFINE_EXPORT_PROCEDURE(svar__env_53_ast_var, _svar__166_ast_var2058, _svar__166_ast_var, 0L, 1);
DEFINE_EXPORT_PROCEDURE(cfun_infix__env_248_ast_var, _cfun_infix_1817_88_ast_var2059, _cfun_infix_1817_88_ast_var, 0L, 1);
DEFINE_EXPORT_PROCEDURE(local_name_env_137_ast_var, _local_name1857_233_ast_var2060, _local_name1857_233_ast_var, 0L, 1);
DEFINE_EXPORT_PROCEDURE(local_user__set__env_133_ast_var, _local_user__set_1870_232_ast_var2061, _local_user__set_1870_232_ast_var, 0L, 2);
DEFINE_EXPORT_PROCEDURE(sfun_loc_set__env_181_ast_var, _sfun_loc_set_1840_150_ast_var2062, _sfun_loc_set_1840_150_ast_var, 0L, 2);
DEFINE_EXPORT_PROCEDURE(sfun_stack_allocator_set__env_160_ast_var, _sfun_stack_allocator_set_1824_51_ast_var2063, _sfun_stack_allocator_set_1824_51_ast_var, 0L, 2);
DEFINE_EXPORT_PROCEDURE(global_evaluable__env_89_ast_var, _global_evaluable_1893_132_ast_var2064, _global_evaluable_1893_132_ast_var, 0L, 1);
DEFINE_EXPORT_PROCEDURE(global_src_env_218_ast_var, _global_src1900_53_ast_var2065, _global_src1900_53_ast_var, 0L, 1);
DEFINE_EXPORT_PROCEDURE(local_id_env_233_ast_var, _local_id1855_79_ast_var2066, _local_id1855_79_ast_var, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_sexit_env_141_ast_var, _make_sexit_67_ast_var2067, _make_sexit_67_ast_var, 0L, 2);
DEFINE_EXPORT_PROCEDURE(cfun_the_closure_env_247_ast_var, _cfun_the_closure1813_65_ast_var2068, _cfun_the_closure1813_65_ast_var, 0L, 1);
DEFINE_EXPORT_PROCEDURE(scnst__env_215_ast_var, _scnst__164_ast_var2069, _scnst__164_ast_var, 0L, 1);
DEFINE_EXPORT_PROCEDURE(local_key_env_15_ast_var, _local_key1872_162_ast_var2070, _local_key1872_162_ast_var, 0L, 1);
DEFINE_EXPORT_PROCEDURE(global_occurrence_set__env_58_ast_var, _global_occurrence_set_1887_244_ast_var2071, _global_occurrence_set_1887_244_ast_var, 0L, 2);
DEFINE_EXPORT_PROCEDURE(sfun_side_effect__env_171_ast_var, _sfun_side_effect_1821_40_ast_var2072, _sfun_side_effect_1821_40_ast_var, 0L, 1);
DEFINE_EXPORT_PROCEDURE(allocate_fun_env_191_ast_var, _allocate_fun_230_ast_var2073, _allocate_fun_230_ast_var, 0L, 0);
DEFINE_EXPORT_PROCEDURE(fun_predicate_of_set__env_255_ast_var, _fun_predicate_of_set_1846_195_ast_var2074, _fun_predicate_of_set_1846_195_ast_var, 0L, 2);
DEFINE_EXPORT_PROCEDURE(svar_loc_env_214_ast_var, _svar_loc1801_216_ast_var2075, _svar_loc1801_216_ast_var, 0L, 1);
DEFINE_EXPORT_PROCEDURE(cfun_arity_env_179_ast_var, _cfun_arity1803_33_ast_var2076, _cfun_arity1803_33_ast_var, 0L, 1);
DEFINE_EXPORT_PROCEDURE(local_access_env_239_ast_var, _local_access1863_55_ast_var2077, _local_access1863_55_ast_var, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sfun_body_env_9_ast_var, _sfun_body1835_143_ast_var2078, _sfun_body1835_143_ast_var, 0L, 1);
DEFINE_EXPORT_PROCEDURE(global_user__set__env_159_ast_var, _global_user__set_1896_171_ast_var2079, _global_user__set_1896_171_ast_var, 0L, 2);
DEFINE_EXPORT_PROCEDURE(global_removable_env_240_ast_var, _global_removable1886_9_ast_var2080, _global_removable1886_9_ast_var, 0L, 1);
DEFINE_EXPORT_PROCEDURE(global_fast_alpha_set__env_25_ast_var, _global_fast_alpha_set_1883_62_ast_var2081, _global_fast_alpha_set_1883_62_ast_var, 0L, 2);
DEFINE_EXPORT_PROCEDURE(global_name_env_232_ast_var, _global_name1876_44_ast_var2082, _global_name1876_44_ast_var, 0L, 1);
DEFINE_EXPORT_PROCEDURE(global_value_env_180_ast_var, _global_value1880_37_ast_var2083, _global_value1880_37_ast_var, 0L, 1);
DEFINE_EXPORT_PROCEDURE(local_occurrence_env_185_ast_var, _local_occurrence1869_253_ast_var2084, _local_occurrence1869_253_ast_var, 0L, 1);
DEFINE_EXPORT_PROCEDURE(global_library__set__env_36_ast_var, _global_library__set_1894_129_ast_var2085, _global_library__set_1894_129_ast_var, 0L, 2);
DEFINE_EXPORT_PROCEDURE(sexit_detached__env_54_ast_var, _sexit_detached_1793_72_ast_var2086, _sexit_detached_1793_72_ast_var, 0L, 1);
DEFINE_EXPORT_PROCEDURE(variable_type_env_30_ast_var, _variable_type1906_56_ast_var2087, _variable_type1906_56_ast_var, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sfun_arity_env_92_ast_var, _sfun_arity1819_181_ast_var2088, _sfun_arity1819_181_ast_var, 0L, 1);
DEFINE_EXPORT_PROCEDURE(variable_access_env_219_ast_var, _variable_access1910_167_ast_var2089, _variable_access1910_167_ast_var, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_global_env_133_ast_var, _make_global1873_93_ast_var2090, _make_global1873_93_ast_var, 0L, 15);
DEFINE_EXPORT_PROCEDURE(cfun_args_type_env_193_ast_var, _cfun_args_type1814_160_ast_var2091, _cfun_args_type1814_160_ast_var, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sfun__env_206_ast_var, _sfun__63_ast_var2092, _sfun__63_ast_var, 0L, 1);
DEFINE_EXPORT_PROCEDURE(cfun_side_effect__env_150_ast_var, _cfun_side_effect_1805_211_ast_var2093, _cfun_side_effect_1805_211_ast_var, 0L, 1);
DEFINE_STRING(string1942_ast_var, string1942_ast_var2094, "SEXIT CVAR SCNST SVAR CFUN SFUN FUN LOCAL GLOBAL VARIABLE VALUE ", 64);
DEFINE_EXPORT_PROCEDURE(global__env_111_ast_var, _global__76_ast_var2095, _global__76_ast_var, 0L, 1);
DEFINE_EXPORT_PROCEDURE(global_occurrence_env_158_ast_var, _global_occurrence1888_193_ast_var2096, _global_occurrence1888_193_ast_var, 0L, 1);
DEFINE_EXPORT_PROCEDURE(global_library__env_3_ast_var, _global_library_1895_187_ast_var2097, _global_library_1895_187_ast_var, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sexit_handler_set__env_61_ast_var, _sexit_handler_set_1790_149_ast_var2098, _sexit_handler_set_1790_149_ast_var, 0L, 2);
DEFINE_EXPORT_PROCEDURE(cfun_predicate_of_set__env_32_ast_var, _cfun_predicate_of_set_1806_183_ast_var2099, _cfun_predicate_of_set_1806_183_ast_var, 0L, 2);
DEFINE_EXPORT_PROCEDURE(local_removable_set__env_101_ast_var, _local_removable_set_1866_226_ast_var2100, _local_removable_set_1866_226_ast_var, 0L, 2);
DEFINE_EXPORT_PROCEDURE(fun_side_effect__env_212_ast_var, _fun_side_effect_1845_49_ast_var2101, _fun_side_effect_1845_49_ast_var, 0L, 1);
DEFINE_EXPORT_PROCEDURE(cvar__env_220_ast_var, _cvar__164_ast_var2102, _cvar__164_ast_var, 0L, 1);
DEFINE_EXPORT_PROCEDURE(local_name_set__env_228_ast_var, _local_name_set_1856_6_ast_var2103, _local_name_set_1856_6_ast_var, 0L, 2);
DEFINE_EXPORT_PROCEDURE(global_removable_set__env_123_ast_var, _global_removable_set_1885_172_ast_var2104, _global_removable_set_1885_172_ast_var, 0L, 2);
DEFINE_EXPORT_PROCEDURE(local_value_env_32_ast_var, _local_value1861_71_ast_var2105, _local_value1861_71_ast_var, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sexit_handler_env_38_ast_var, _sexit_handler1791_102_ast_var2106, _sexit_handler1791_102_ast_var, 0L, 1);
DEFINE_EXPORT_PROCEDURE(global_type_set__env_45_ast_var, _global_type_set_1877_24_ast_var2107, _global_type_set_1877_24_ast_var, 0L, 2);
DEFINE_EXPORT_PROCEDURE(cfun_the_closure_set__env_37_ast_var, _cfun_the_closure_set_1812_176_ast_var2108, _cfun_the_closure_set_1812_176_ast_var, 0L, 2);
DEFINE_EXPORT_PROCEDURE(allocate_value_env_188_ast_var, _allocate_value_13_ast_var2109, _allocate_value_13_ast_var, 0L, 0);
DEFINE_EXPORT_PROCEDURE(variable_value_set__env_150_ast_var, _variable_value_set_1907_20_ast_var2110, _variable_value_set_1907_20_ast_var, 0L, 2);
DEFINE_EXPORT_PROCEDURE(sfun_args_set__env_104_ast_var, _sfun_args_set_1832_111_ast_var2111, _sfun_args_set_1832_111_ast_var, 0L, 2);
DEFINE_EXPORT_PROCEDURE(fun_stack_allocator_set__env_50_ast_var, _fun_stack_allocator_set_1848_167_ast_var2112, _fun_stack_allocator_set_1848_167_ast_var, 0L, 2);
DEFINE_EXPORT_PROCEDURE(svar_loc_set__env_17_ast_var, _svar_loc_set_1800_165_ast_var2113, _svar_loc_set_1800_165_ast_var, 0L, 2);
DEFINE_EXPORT_PROCEDURE(local_fast_alpha_env_32_ast_var, _local_fast_alpha1865_218_ast_var2114, _local_fast_alpha1865_218_ast_var, 0L, 1);
DEFINE_EXPORT_PROCEDURE(global_import_set__env_98_ast_var, _global_import_set_1890_147_ast_var2115, _global_import_set_1890_147_ast_var, 0L, 2);
DEFINE_EXPORT_PROCEDURE(variable_removable_set__env_12_ast_var, _variable_removable_set_1913_123_ast_var2116, _variable_removable_set_1913_123_ast_var, 0L, 2);
DEFINE_EXPORT_PROCEDURE(scnst_class_set__env_234_ast_var, _scnst_class_set_1796_244_ast_var2117, _scnst_class_set_1796_244_ast_var, 0L, 2);
DEFINE_EXPORT_PROCEDURE(sfun_predicate_of_env_111_ast_var, _sfun_predicate_of1823_228_ast_var2118, _sfun_predicate_of1823_228_ast_var, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sfun_top__set__env_194_ast_var, _sfun_top__set_1826_236_ast_var2119, _sfun_top__set_1826_236_ast_var, 0L, 2);
DEFINE_EXPORT_PROCEDURE(fun_the_closure_set__env_51_ast_var, _fun_the_closure_set_1852_75_ast_var2120, _fun_the_closure_set_1852_75_ast_var, 0L, 2);
extern obj_t object__struct_env_210___object;
DEFINE_EXPORT_PROCEDURE(global_fast_alpha_env_200_ast_var, _global_fast_alpha1884_64_ast_var2121, _global_fast_alpha1884_64_ast_var, 0L, 1);
DEFINE_EXPORT_PROCEDURE(allocate_cvar_env_85_ast_var, _allocate_cvar_101_ast_var2122, _allocate_cvar_101_ast_var, 0L, 0);
DEFINE_EXPORT_PROCEDURE(cfun_stack_allocator_set__env_86_ast_var, _cfun_stack_allocator_set_1808_197_ast_var2123, _cfun_stack_allocator_set_1808_197_ast_var, 0L, 2);



/* module-initialization */
obj_t 
module_initialization_70_ast_var(long checksum_1996, char *from_1997)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_ast_var))
	{
	   require_initialization_114_ast_var =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_ast_var();
	   cnst_init_137_ast_var();
	   imported_modules_init_94_ast_var();
	   object_init_111_ast_var();
	   method_init_76_ast_var();
	   toplevel_init_63_ast_var();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_ast_var()
{
   AN_OBJECT;
   {	/* Ast/var.scm 14 */
      module_initialization_70___object(((long) 0), "AST_VAR");
      module_initialization_70___reader(((long) 0), "AST_VAR");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_ast_var()
{
   AN_OBJECT;
   {	/* Ast/var.scm 14 */
      {		/* Ast/var.scm 14 */
	 obj_t cnst_port_138_1989;
	 cnst_port_138_1989 =
	    open_input_string(string1942_ast_var);
	 {
	    long i_1990;
	    i_1990 = ((long) 10);
	  loop_1991:
	    {	/* Ast/var.scm 14 */
	       bool_t test1943_1992;
	       test1943_1992 =
		  (i_1990 == ((long) -1));
	       if (test1943_1992)
		 {	/* Ast/var.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Ast/var.scm 14 */
		    {	/* Ast/var.scm 14 */
		       obj_t arg1944_1993;
		       {	/* Ast/var.scm 14 */
			  obj_t list1945_1994;
			  list1945_1994 =
			     MAKE_PAIR(cnst_port_138_1989, BNIL);
			  arg1944_1993 =
			     read___reader(list1945_1994);
		       }
		       CNST_TABLE_SET(i_1990, arg1944_1993);
		    }
		    {	/* Ast/var.scm 14 */
		       int aux_1995;
		       {	/* Ast/var.scm 14 */
			  long aux_2015;
			  aux_2015 =
			     (i_1990 - ((long) 1));
			  aux_1995 =
			     (int) (aux_2015);
		       }
		       {
			  long i_2018;
			  i_2018 =
			     (long) (aux_1995);
			  i_1990 = i_2018;
			  goto loop_1991;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_ast_var()
{
   AN_OBJECT;
   {	/* Ast/var.scm 14 */
      return BUNSPEC;
   }
}



/* object-init */
obj_t 
object_init_111_ast_var()
{
   AN_OBJECT;
   {	/* Ast/var.scm 14 */
      {		/* Ast/var.scm 14 */
	 obj_t arg1532_338;
	 obj_t arg1533_339;
	 obj_t arg1536_342;
	 arg1532_338 =
	    CNST_TABLE_REF(((long) 0));
	 arg1533_339 = object___object;
	 {	/* Ast/var.scm 14 */
	    obj_t v1476_343;
	    v1476_343 =
	       create_vector(((long) 0));
	    arg1536_342 = v1476_343;
	 }
	 value_ast_var =
	    register_class__225___object(arg1532_338, arg1533_339, allocate_value_env_188_ast_var, ((long) 28797), BUNSPEC, BFALSE, arg1536_342);
      }
      {		/* Ast/var.scm 14 */
	 obj_t arg1537_344;
	 obj_t arg1539_345;
	 obj_t arg1543_348;
	 arg1537_344 =
	    CNST_TABLE_REF(((long) 1));
	 arg1539_345 = object___object;
	 {	/* Ast/var.scm 14 */
	    obj_t v1477_349;
	    v1477_349 =
	       create_vector(((long) 0));
	    arg1543_348 = v1477_349;
	 }
	 variable_ast_var =
	    register_class__225___object(arg1537_344, arg1539_345, allocate_variable_env_212_ast_var, ((long) 63181), BUNSPEC, BFALSE, arg1543_348);
      }
      {		/* Ast/var.scm 14 */
	 obj_t arg1544_350;
	 obj_t arg1545_351;
	 obj_t arg1549_354;
	 arg1544_350 =
	    CNST_TABLE_REF(((long) 2));
	 arg1545_351 = variable_ast_var;
	 {	/* Ast/var.scm 14 */
	    obj_t v1478_355;
	    v1478_355 =
	       create_vector(((long) 0));
	    arg1549_354 = v1478_355;
	 }
	 global_ast_var =
	    register_class__225___object(arg1544_350, arg1545_351, allocate_global_env_97_ast_var, ((long) 56592), BUNSPEC, BFALSE, arg1549_354);
      }
      {		/* Ast/var.scm 14 */
	 obj_t arg1550_356;
	 obj_t arg1551_357;
	 obj_t arg1555_360;
	 arg1550_356 =
	    CNST_TABLE_REF(((long) 3));
	 arg1551_357 = variable_ast_var;
	 {	/* Ast/var.scm 14 */
	    obj_t v1479_361;
	    v1479_361 =
	       create_vector(((long) 0));
	    arg1555_360 = v1479_361;
	 }
	 local_ast_var =
	    register_class__225___object(arg1550_356, arg1551_357, allocate_local_env_7_ast_var, ((long) 39680), BUNSPEC, BFALSE, arg1555_360);
      }
      {		/* Ast/var.scm 14 */
	 obj_t arg1556_362;
	 obj_t arg1557_363;
	 obj_t arg1560_366;
	 arg1556_362 =
	    CNST_TABLE_REF(((long) 4));
	 arg1557_363 = value_ast_var;
	 {	/* Ast/var.scm 14 */
	    obj_t v1480_367;
	    v1480_367 =
	       create_vector(((long) 0));
	    arg1560_366 = v1480_367;
	 }
	 fun_ast_var =
	    register_class__225___object(arg1556_362, arg1557_363, allocate_fun_env_191_ast_var, ((long) 36716), BUNSPEC, BFALSE, arg1560_366);
      }
      {		/* Ast/var.scm 14 */
	 obj_t arg1561_368;
	 obj_t arg1562_369;
	 obj_t arg1565_372;
	 arg1561_368 =
	    CNST_TABLE_REF(((long) 5));
	 arg1562_369 = fun_ast_var;
	 {	/* Ast/var.scm 14 */
	    obj_t v1481_373;
	    v1481_373 =
	       create_vector(((long) 0));
	    arg1565_372 = v1481_373;
	 }
	 sfun_ast_var =
	    register_class__225___object(arg1561_368, arg1562_369, allocate_sfun_env_18_ast_var, ((long) 16709), BUNSPEC, BFALSE, arg1565_372);
      }
      {		/* Ast/var.scm 14 */
	 obj_t arg1566_374;
	 obj_t arg1567_375;
	 obj_t arg1571_378;
	 arg1566_374 =
	    CNST_TABLE_REF(((long) 6));
	 arg1567_375 = fun_ast_var;
	 {	/* Ast/var.scm 14 */
	    obj_t v1482_379;
	    v1482_379 =
	       create_vector(((long) 0));
	    arg1571_378 = v1482_379;
	 }
	 cfun_ast_var =
	    register_class__225___object(arg1566_374, arg1567_375, allocate_cfun_env_241_ast_var, ((long) 5204), BUNSPEC, BFALSE, arg1571_378);
      }
      {		/* Ast/var.scm 14 */
	 obj_t arg1572_380;
	 obj_t arg1573_381;
	 obj_t arg1578_384;
	 arg1572_380 =
	    CNST_TABLE_REF(((long) 7));
	 arg1573_381 = value_ast_var;
	 {	/* Ast/var.scm 14 */
	    obj_t v1483_385;
	    v1483_385 =
	       create_vector(((long) 0));
	    arg1578_384 = v1483_385;
	 }
	 svar_ast_var =
	    register_class__225___object(arg1572_380, arg1573_381, allocate_svar_env_12_ast_var, ((long) 4410), BUNSPEC, BFALSE, arg1578_384);
      }
      {		/* Ast/var.scm 14 */
	 obj_t arg1579_386;
	 obj_t arg1580_387;
	 obj_t arg1583_390;
	 arg1579_386 =
	    CNST_TABLE_REF(((long) 8));
	 arg1580_387 = value_ast_var;
	 {	/* Ast/var.scm 14 */
	    obj_t v1484_391;
	    v1484_391 =
	       create_vector(((long) 0));
	    arg1583_390 = v1484_391;
	 }
	 scnst_ast_var =
	    register_class__225___object(arg1579_386, arg1580_387, allocate_scnst_env_226_ast_var, ((long) 28261), BUNSPEC, BFALSE, arg1583_390);
      }
      {		/* Ast/var.scm 14 */
	 obj_t arg1584_392;
	 obj_t arg1585_393;
	 obj_t arg1588_396;
	 arg1584_392 =
	    CNST_TABLE_REF(((long) 9));
	 arg1585_393 = value_ast_var;
	 {	/* Ast/var.scm 14 */
	    obj_t v1485_397;
	    v1485_397 =
	       create_vector(((long) 0));
	    arg1588_396 = v1485_397;
	 }
	 cvar_ast_var =
	    register_class__225___object(arg1584_392, arg1585_393, allocate_cvar_env_85_ast_var, ((long) 10029), BUNSPEC, BFALSE, arg1588_396);
      }
      {		/* Ast/var.scm 14 */
	 obj_t arg1589_398;
	 obj_t arg1590_399;
	 obj_t arg1593_402;
	 arg1589_398 =
	    CNST_TABLE_REF(((long) 10));
	 arg1590_399 = value_ast_var;
	 {	/* Ast/var.scm 14 */
	    obj_t v1486_403;
	    v1486_403 =
	       create_vector(((long) 0));
	    arg1593_402 = v1486_403;
	 }
	 sexit_ast_var =
	    register_class__225___object(arg1589_398, arg1590_399, allocate_sexit_env_61_ast_var, ((long) 29641), BUNSPEC, BFALSE, arg1593_402);
      }
      return BUNSPEC;
   }
}



/* allocate-sexit */
sexit_bglt 
allocate_sexit_47_ast_var()
{
   AN_OBJECT;
   {	/* Ast/var.scm 133 */
      {		/* Ast/var.scm 133 */
	 sexit_bglt new1465_404;
	 new1465_404 =
	    ((sexit_bglt) BREF(GC_MALLOC(sizeof(struct sexit))));
	 {	/* Ast/var.scm 133 */
	    long arg1594_405;
	    arg1594_405 =
	       class_num_218___object(sexit_ast_var);
	    {	/* Ast/var.scm 133 */
	       obj_t obj_876;
	       obj_876 =
		  (obj_t) (new1465_404);
	       (((obj_t) CREF(obj_876))->header = MAKE_HEADER(arg1594_405, 0), BUNSPEC);
	    }
	 }
	 {	/* Ast/var.scm 133 */
	    object_bglt aux_2057;
	    aux_2057 =
	       (object_bglt) (new1465_404);
	    OBJECT_WIDENING_SET(aux_2057, BFALSE);
	 }
	 return new1465_404;
      }
   }
}



/* _allocate-sexit */
obj_t 
_allocate_sexit_130_ast_var(obj_t env_1510)
{
   AN_OBJECT;
   {	/* Ast/var.scm 133 */
      {		/* Ast/var.scm 133 */
	 sexit_bglt aux_2060;
	 aux_2060 =
	    allocate_sexit_47_ast_var();
	 return
	    (obj_t) (aux_2060);
      }
   }
}



/* sexit? */
bool_t 
sexit__36_ast_var(obj_t obj_4)
{
   AN_OBJECT;
   {	/* Ast/var.scm 133 */
      return
	 is_a__118___object(obj_4, sexit_ast_var);
   }
}



/* _sexit? */
obj_t 
_sexit__255_ast_var(obj_t env_1511, obj_t obj_1512)
{
   AN_OBJECT;
   {	/* Ast/var.scm 133 */
      {		/* Ast/var.scm 133 */
	 bool_t aux_2064;
	 aux_2064 =
	    sexit__36_ast_var(obj_1512);
	 return
	    BBOOL(aux_2064);
      }
   }
}



/* make-sexit */
sexit_bglt 
make_sexit_79_ast_var(obj_t handler_5, bool_t detached__120_6)
{
   AN_OBJECT;
   {	/* Ast/var.scm 133 */
      {		/* Ast/var.scm 133 */
	 sexit_bglt new1461_878;
	 new1461_878 =
	    ((sexit_bglt) BREF(GC_MALLOC(sizeof(struct sexit))));
	 {	/* Ast/var.scm 133 */
	    long arg1595_879;
	    arg1595_879 =
	       class_num_218___object(sexit_ast_var);
	    {	/* Ast/var.scm 133 */
	       obj_t obj_882;
	       obj_882 =
		  (obj_t) (new1461_878);
	       (((obj_t) CREF(obj_882))->header = MAKE_HEADER(arg1595_879, 0), BUNSPEC);
	    }
	 }
	 {	/* Ast/var.scm 133 */
	    object_bglt aux_2071;
	    aux_2071 =
	       (object_bglt) (new1461_878);
	    OBJECT_WIDENING_SET(aux_2071, BFALSE);
	 }
	 ((((sexit_bglt) CREF(new1461_878))->handler) = ((obj_t) handler_5), BUNSPEC);
	 ((((sexit_bglt) CREF(new1461_878))->detached__120) = ((bool_t) detached__120_6), BUNSPEC);
	 return new1461_878;
      }
   }
}



/* _make-sexit */
obj_t 
_make_sexit_67_ast_var(obj_t env_1513, obj_t handler_1514, obj_t detached__120_1515)
{
   AN_OBJECT;
   {	/* Ast/var.scm 133 */
      {		/* Ast/var.scm 133 */
	 sexit_bglt aux_2076;
	 aux_2076 =
	    make_sexit_79_ast_var(handler_1514,
	    CBOOL(detached__120_1515));
	 return
	    (obj_t) (aux_2076);
      }
   }
}



/* sexit-handler-set! */
obj_t 
sexit_handler_set__47_ast_var(sexit_bglt obj_7, obj_t val1459_8)
{
   AN_OBJECT;
   {	/* Ast/var.scm 133 */
      return
	 ((((sexit_bglt) CREF(obj_7))->handler) = ((obj_t) val1459_8), BUNSPEC);
   }
}



/* _sexit-handler-set!1790 */
obj_t 
_sexit_handler_set_1790_149_ast_var(obj_t env_1516, obj_t obj_1517, obj_t val1459_1518)
{
   AN_OBJECT;
   {	/* Ast/var.scm 133 */
      return
	 sexit_handler_set__47_ast_var(
	 (sexit_bglt) (obj_1517), val1459_1518);
   }
}



/* sexit-handler */
obj_t 
sexit_handler_210_ast_var(sexit_bglt obj_9)
{
   AN_OBJECT;
   {	/* Ast/var.scm 133 */
      return
	 (((sexit_bglt) CREF(obj_9))->handler);
   }
}



/* _sexit-handler1791 */
obj_t 
_sexit_handler1791_102_ast_var(obj_t env_1519, obj_t obj_1520)
{
   AN_OBJECT;
   {	/* Ast/var.scm 133 */
      return
	 sexit_handler_210_ast_var(
	 (sexit_bglt) (obj_1520));
   }
}



/* sexit-detached?-set! */
obj_t 
sexit_detached__set__116_ast_var(sexit_bglt obj_10, bool_t val1460_11)
{
   AN_OBJECT;
   {	/* Ast/var.scm 137 */
      return
	 ((((sexit_bglt) CREF(obj_10))->detached__120) = ((bool_t) val1460_11), BUNSPEC);
   }
}



/* _sexit-detached?-set!1792 */
obj_t 
_sexit_detached__set_1792_226_ast_var(obj_t env_1521, obj_t obj_1522, obj_t val1460_1523)
{
   AN_OBJECT;
   {	/* Ast/var.scm 137 */
      return
	 sexit_detached__set__116_ast_var(
	 (sexit_bglt) (obj_1522),
	 CBOOL(val1460_1523));
   }
}



/* sexit-detached? */
bool_t 
sexit_detached__208_ast_var(sexit_bglt obj_12)
{
   AN_OBJECT;
   {	/* Ast/var.scm 137 */
      return
	 (((sexit_bglt) CREF(obj_12))->detached__120);
   }
}



/* _sexit-detached?1793 */
obj_t 
_sexit_detached_1793_72_ast_var(obj_t env_1524, obj_t obj_1525)
{
   AN_OBJECT;
   {	/* Ast/var.scm 137 */
      {		/* Ast/var.scm 137 */
	 bool_t aux_2091;
	 aux_2091 =
	    sexit_detached__208_ast_var(
	    (sexit_bglt) (obj_1525));
	 return
	    BBOOL(aux_2091);
      }
   }
}



/* allocate-cvar */
cvar_bglt 
allocate_cvar_254_ast_var()
{
   AN_OBJECT;
   {	/* Ast/var.scm 129 */
      {		/* Ast/var.scm 129 */
	 cvar_bglt new1450_410;
	 new1450_410 =
	    ((cvar_bglt) BREF(GC_MALLOC(sizeof(struct cvar))));
	 {	/* Ast/var.scm 129 */
	    long arg1596_411;
	    arg1596_411 =
	       class_num_218___object(cvar_ast_var);
	    {	/* Ast/var.scm 129 */
	       obj_t obj_884;
	       obj_884 =
		  (obj_t) (new1450_410);
	       (((obj_t) CREF(obj_884))->header = MAKE_HEADER(arg1596_411, 0), BUNSPEC);
	    }
	 }
	 {	/* Ast/var.scm 129 */
	    object_bglt aux_2099;
	    aux_2099 =
	       (object_bglt) (new1450_410);
	    OBJECT_WIDENING_SET(aux_2099, BFALSE);
	 }
	 return new1450_410;
      }
   }
}



/* _allocate-cvar */
obj_t 
_allocate_cvar_101_ast_var(obj_t env_1509)
{
   AN_OBJECT;
   {	/* Ast/var.scm 129 */
      {		/* Ast/var.scm 129 */
	 cvar_bglt aux_2102;
	 aux_2102 =
	    allocate_cvar_254_ast_var();
	 return
	    (obj_t) (aux_2102);
      }
   }
}



/* cvar? */
bool_t 
cvar__118_ast_var(obj_t obj_16)
{
   AN_OBJECT;
   {	/* Ast/var.scm 129 */
      return
	 is_a__118___object(obj_16, cvar_ast_var);
   }
}



/* _cvar? */
obj_t 
_cvar__164_ast_var(obj_t env_1526, obj_t obj_1527)
{
   AN_OBJECT;
   {	/* Ast/var.scm 129 */
      {		/* Ast/var.scm 129 */
	 bool_t aux_2106;
	 aux_2106 =
	    cvar__118_ast_var(obj_1527);
	 return
	    BBOOL(aux_2106);
      }
   }
}



/* make-cvar */
cvar_bglt 
make_cvar_132_ast_var(bool_t macro__33_17)
{
   AN_OBJECT;
   {	/* Ast/var.scm 129 */
      {		/* Ast/var.scm 129 */
	 cvar_bglt new1447_886;
	 new1447_886 =
	    ((cvar_bglt) BREF(GC_MALLOC(sizeof(struct cvar))));
	 {	/* Ast/var.scm 129 */
	    long arg1597_887;
	    arg1597_887 =
	       class_num_218___object(cvar_ast_var);
	    {	/* Ast/var.scm 129 */
	       obj_t obj_889;
	       obj_889 =
		  (obj_t) (new1447_886);
	       (((obj_t) CREF(obj_889))->header = MAKE_HEADER(arg1597_887, 0), BUNSPEC);
	    }
	 }
	 {	/* Ast/var.scm 129 */
	    object_bglt aux_2113;
	    aux_2113 =
	       (object_bglt) (new1447_886);
	    OBJECT_WIDENING_SET(aux_2113, BFALSE);
	 }
	 ((((cvar_bglt) CREF(new1447_886))->macro__33) = ((bool_t) macro__33_17), BUNSPEC);
	 return new1447_886;
      }
   }
}



/* _make-cvar */
obj_t 
_make_cvar_142_ast_var(obj_t env_1528, obj_t macro__33_1529)
{
   AN_OBJECT;
   {	/* Ast/var.scm 129 */
      {		/* Ast/var.scm 129 */
	 cvar_bglt aux_2117;
	 aux_2117 =
	    make_cvar_132_ast_var(
	    CBOOL(macro__33_1529));
	 return
	    (obj_t) (aux_2117);
      }
   }
}



/* cvar-macro? */
bool_t 
cvar_macro__32_ast_var(cvar_bglt obj_18)
{
   AN_OBJECT;
   {	/* Ast/var.scm 131 */
      return
	 (((cvar_bglt) CREF(obj_18))->macro__33);
   }
}



/* _cvar-macro?1794 */
obj_t 
_cvar_macro_1794_97_ast_var(obj_t env_1530, obj_t obj_1531)
{
   AN_OBJECT;
   {	/* Ast/var.scm 131 */
      {		/* Ast/var.scm 131 */
	 bool_t aux_2122;
	 aux_2122 =
	    cvar_macro__32_ast_var(
	    (cvar_bglt) (obj_1531));
	 return
	    BBOOL(aux_2122);
      }
   }
}



/* allocate-scnst */
scnst_bglt 
allocate_scnst_81_ast_var()
{
   AN_OBJECT;
   {	/* Ast/var.scm 117 */
      {		/* Ast/var.scm 117 */
	 scnst_bglt new1432_415;
	 new1432_415 =
	    ((scnst_bglt) BREF(GC_MALLOC(sizeof(struct scnst))));
	 {	/* Ast/var.scm 117 */
	    long arg1598_416;
	    arg1598_416 =
	       class_num_218___object(scnst_ast_var);
	    {	/* Ast/var.scm 117 */
	       obj_t obj_891;
	       obj_891 =
		  (obj_t) (new1432_415);
	       (((obj_t) CREF(obj_891))->header = MAKE_HEADER(arg1598_416, 0), BUNSPEC);
	    }
	 }
	 {	/* Ast/var.scm 117 */
	    object_bglt aux_2130;
	    aux_2130 =
	       (object_bglt) (new1432_415);
	    OBJECT_WIDENING_SET(aux_2130, BFALSE);
	 }
	 return new1432_415;
      }
   }
}



/* _allocate-scnst */
obj_t 
_allocate_scnst_4_ast_var(obj_t env_1508)
{
   AN_OBJECT;
   {	/* Ast/var.scm 117 */
      {		/* Ast/var.scm 117 */
	 scnst_bglt aux_2133;
	 aux_2133 =
	    allocate_scnst_81_ast_var();
	 return
	    (obj_t) (aux_2133);
      }
   }
}



/* scnst? */
bool_t 
scnst__249_ast_var(obj_t obj_22)
{
   AN_OBJECT;
   {	/* Ast/var.scm 117 */
      return
	 is_a__118___object(obj_22, scnst_ast_var);
   }
}



/* _scnst? */
obj_t 
_scnst__164_ast_var(obj_t env_1532, obj_t obj_1533)
{
   AN_OBJECT;
   {	/* Ast/var.scm 117 */
      {		/* Ast/var.scm 117 */
	 bool_t aux_2137;
	 aux_2137 =
	    scnst__249_ast_var(obj_1533);
	 return
	    BBOOL(aux_2137);
      }
   }
}



/* make-scnst */
scnst_bglt 
make_scnst_115_ast_var(obj_t node_23, obj_t class_24, obj_t loc_25)
{
   AN_OBJECT;
   {	/* Ast/var.scm 117 */
      {		/* Ast/var.scm 117 */
	 scnst_bglt new1427_893;
	 new1427_893 =
	    ((scnst_bglt) BREF(GC_MALLOC(sizeof(struct scnst))));
	 {	/* Ast/var.scm 117 */
	    long arg1599_894;
	    arg1599_894 =
	       class_num_218___object(scnst_ast_var);
	    {	/* Ast/var.scm 117 */
	       obj_t obj_898;
	       obj_898 =
		  (obj_t) (new1427_893);
	       (((obj_t) CREF(obj_898))->header = MAKE_HEADER(arg1599_894, 0), BUNSPEC);
	    }
	 }
	 {	/* Ast/var.scm 117 */
	    object_bglt aux_2144;
	    aux_2144 =
	       (object_bglt) (new1427_893);
	    OBJECT_WIDENING_SET(aux_2144, BFALSE);
	 }
	 ((((scnst_bglt) CREF(new1427_893))->node) = ((obj_t) node_23), BUNSPEC);
	 ((((scnst_bglt) CREF(new1427_893))->class) = ((obj_t) class_24), BUNSPEC);
	 ((((scnst_bglt) CREF(new1427_893))->loc) = ((obj_t) loc_25), BUNSPEC);
	 return new1427_893;
      }
   }
}



/* _make-scnst */
obj_t 
_make_scnst_248_ast_var(obj_t env_1534, obj_t node_1535, obj_t class_1536, obj_t loc_1537)
{
   AN_OBJECT;
   {	/* Ast/var.scm 117 */
      {		/* Ast/var.scm 117 */
	 scnst_bglt aux_2150;
	 aux_2150 =
	    make_scnst_115_ast_var(node_1535, class_1536, loc_1537);
	 return
	    (obj_t) (aux_2150);
      }
   }
}



/* scnst-node */
obj_t 
scnst_node_98_ast_var(scnst_bglt obj_26)
{
   AN_OBJECT;
   {	/* Ast/var.scm 119 */
      return
	 (((scnst_bglt) CREF(obj_26))->node);
   }
}



/* _scnst-node1795 */
obj_t 
_scnst_node1795_36_ast_var(obj_t env_1538, obj_t obj_1539)
{
   AN_OBJECT;
   {	/* Ast/var.scm 119 */
      return
	 scnst_node_98_ast_var(
	 (scnst_bglt) (obj_1539));
   }
}



/* scnst-class-set! */
obj_t 
scnst_class_set__87_ast_var(scnst_bglt obj_27, obj_t val1425_28)
{
   AN_OBJECT;
   {	/* Ast/var.scm 121 */
      return
	 ((((scnst_bglt) CREF(obj_27))->class) = ((obj_t) val1425_28), BUNSPEC);
   }
}



/* _scnst-class-set!1796 */
obj_t 
_scnst_class_set_1796_244_ast_var(obj_t env_1540, obj_t obj_1541, obj_t val1425_1542)
{
   AN_OBJECT;
   {	/* Ast/var.scm 121 */
      return
	 scnst_class_set__87_ast_var(
	 (scnst_bglt) (obj_1541), val1425_1542);
   }
}



/* scnst-class */
obj_t 
scnst_class_73_ast_var(scnst_bglt obj_29)
{
   AN_OBJECT;
   {	/* Ast/var.scm 121 */
      return
	 (((scnst_bglt) CREF(obj_29))->class);
   }
}



/* _scnst-class1797 */
obj_t 
_scnst_class1797_79_ast_var(obj_t env_1543, obj_t obj_1544)
{
   AN_OBJECT;
   {	/* Ast/var.scm 121 */
      return
	 scnst_class_73_ast_var(
	 (scnst_bglt) (obj_1544));
   }
}



/* scnst-loc-set! */
obj_t 
scnst_loc_set__206_ast_var(scnst_bglt obj_30, obj_t val1426_31)
{
   AN_OBJECT;
   {	/* Ast/var.scm 127 */
      return
	 ((((scnst_bglt) CREF(obj_30))->loc) = ((obj_t) val1426_31), BUNSPEC);
   }
}



/* _scnst-loc-set!1798 */
obj_t 
_scnst_loc_set_1798_39_ast_var(obj_t env_1545, obj_t obj_1546, obj_t val1426_1547)
{
   AN_OBJECT;
   {	/* Ast/var.scm 127 */
      return
	 scnst_loc_set__206_ast_var(
	 (scnst_bglt) (obj_1546), val1426_1547);
   }
}



/* scnst-loc */
obj_t 
scnst_loc_19_ast_var(scnst_bglt obj_32)
{
   AN_OBJECT;
   {	/* Ast/var.scm 127 */
      return
	 (((scnst_bglt) CREF(obj_32))->loc);
   }
}



/* _scnst-loc1799 */
obj_t 
_scnst_loc1799_179_ast_var(obj_t env_1548, obj_t obj_1549)
{
   AN_OBJECT;
   {	/* Ast/var.scm 127 */
      return
	 scnst_loc_19_ast_var(
	 (scnst_bglt) (obj_1549));
   }
}



/* allocate-svar */
svar_bglt 
allocate_svar_218_ast_var()
{
   AN_OBJECT;
   {	/* Ast/var.scm 113 */
      {		/* Ast/var.scm 113 */
	 svar_bglt new1418_422;
	 new1418_422 =
	    ((svar_bglt) BREF(GC_MALLOC(sizeof(struct svar))));
	 {	/* Ast/var.scm 113 */
	    long arg1600_423;
	    arg1600_423 =
	       class_num_218___object(svar_ast_var);
	    {	/* Ast/var.scm 113 */
	       obj_t obj_900;
	       obj_900 =
		  (obj_t) (new1418_422);
	       (((obj_t) CREF(obj_900))->header = MAKE_HEADER(arg1600_423, 0), BUNSPEC);
	    }
	 }
	 {	/* Ast/var.scm 113 */
	    object_bglt aux_2172;
	    aux_2172 =
	       (object_bglt) (new1418_422);
	    OBJECT_WIDENING_SET(aux_2172, BFALSE);
	 }
	 return new1418_422;
      }
   }
}



/* _allocate-svar */
obj_t 
_allocate_svar_73_ast_var(obj_t env_1507)
{
   AN_OBJECT;
   {	/* Ast/var.scm 113 */
      {		/* Ast/var.scm 113 */
	 svar_bglt aux_2175;
	 aux_2175 =
	    allocate_svar_218_ast_var();
	 return
	    (obj_t) (aux_2175);
      }
   }
}



/* svar? */
bool_t 
svar__161_ast_var(obj_t obj_36)
{
   AN_OBJECT;
   {	/* Ast/var.scm 113 */
      return
	 is_a__118___object(obj_36, svar_ast_var);
   }
}



/* _svar? */
obj_t 
_svar__166_ast_var(obj_t env_1550, obj_t obj_1551)
{
   AN_OBJECT;
   {	/* Ast/var.scm 113 */
      {		/* Ast/var.scm 113 */
	 bool_t aux_2179;
	 aux_2179 =
	    svar__161_ast_var(obj_1551);
	 return
	    BBOOL(aux_2179);
      }
   }
}



/* make-svar */
svar_bglt 
make_svar_231_ast_var(obj_t loc_37)
{
   AN_OBJECT;
   {	/* Ast/var.scm 113 */
      {		/* Ast/var.scm 113 */
	 svar_bglt new1415_902;
	 new1415_902 =
	    ((svar_bglt) BREF(GC_MALLOC(sizeof(struct svar))));
	 {	/* Ast/var.scm 113 */
	    long arg1601_903;
	    arg1601_903 =
	       class_num_218___object(svar_ast_var);
	    {	/* Ast/var.scm 113 */
	       obj_t obj_905;
	       obj_905 =
		  (obj_t) (new1415_902);
	       (((obj_t) CREF(obj_905))->header = MAKE_HEADER(arg1601_903, 0), BUNSPEC);
	    }
	 }
	 {	/* Ast/var.scm 113 */
	    object_bglt aux_2186;
	    aux_2186 =
	       (object_bglt) (new1415_902);
	    OBJECT_WIDENING_SET(aux_2186, BFALSE);
	 }
	 ((((svar_bglt) CREF(new1415_902))->loc) = ((obj_t) loc_37), BUNSPEC);
	 return new1415_902;
      }
   }
}



/* _make-svar */
obj_t 
_make_svar_17_ast_var(obj_t env_1552, obj_t loc_1553)
{
   AN_OBJECT;
   {	/* Ast/var.scm 113 */
      {		/* Ast/var.scm 113 */
	 svar_bglt aux_2190;
	 aux_2190 =
	    make_svar_231_ast_var(loc_1553);
	 return
	    (obj_t) (aux_2190);
      }
   }
}



/* svar-loc-set! */
obj_t 
svar_loc_set__106_ast_var(svar_bglt obj_38, obj_t val1414_39)
{
   AN_OBJECT;
   {	/* Ast/var.scm 115 */
      return
	 ((((svar_bglt) CREF(obj_38))->loc) = ((obj_t) val1414_39), BUNSPEC);
   }
}



/* _svar-loc-set!1800 */
obj_t 
_svar_loc_set_1800_165_ast_var(obj_t env_1554, obj_t obj_1555, obj_t val1414_1556)
{
   AN_OBJECT;
   {	/* Ast/var.scm 115 */
      return
	 svar_loc_set__106_ast_var(
	 (svar_bglt) (obj_1555), val1414_1556);
   }
}



/* svar-loc */
obj_t 
svar_loc_189_ast_var(svar_bglt obj_40)
{
   AN_OBJECT;
   {	/* Ast/var.scm 115 */
      return
	 (((svar_bglt) CREF(obj_40))->loc);
   }
}



/* _svar-loc1801 */
obj_t 
_svar_loc1801_216_ast_var(obj_t env_1557, obj_t obj_1558)
{
   AN_OBJECT;
   {	/* Ast/var.scm 115 */
      return
	 svar_loc_189_ast_var(
	 (svar_bglt) (obj_1558));
   }
}



/* allocate-cfun */
cfun_bglt 
allocate_cfun_23_ast_var()
{
   AN_OBJECT;
   {	/* Ast/var.scm 105 */
      {		/* Ast/var.scm 105 */
	 cfun_bglt new1375_427;
	 new1375_427 =
	    ((cfun_bglt) BREF(GC_MALLOC(sizeof(struct cfun))));
	 {	/* Ast/var.scm 105 */
	    long arg1602_428;
	    arg1602_428 =
	       class_num_218___object(cfun_ast_var);
	    {	/* Ast/var.scm 105 */
	       obj_t obj_907;
	       obj_907 =
		  (obj_t) (new1375_427);
	       (((obj_t) CREF(obj_907))->header = MAKE_HEADER(arg1602_428, 0), BUNSPEC);
	    }
	 }
	 {	/* Ast/var.scm 105 */
	    object_bglt aux_2203;
	    aux_2203 =
	       (object_bglt) (new1375_427);
	    OBJECT_WIDENING_SET(aux_2203, BFALSE);
	 }
	 return new1375_427;
      }
   }
}



/* _allocate-cfun */
obj_t 
_allocate_cfun_27_ast_var(obj_t env_1506)
{
   AN_OBJECT;
   {	/* Ast/var.scm 105 */
      {		/* Ast/var.scm 105 */
	 cfun_bglt aux_2206;
	 aux_2206 =
	    allocate_cfun_23_ast_var();
	 return
	    (obj_t) (aux_2206);
      }
   }
}



/* cfun? */
bool_t 
cfun__213_ast_var(obj_t obj_44)
{
   AN_OBJECT;
   {	/* Ast/var.scm 105 */
      return
	 is_a__118___object(obj_44, cfun_ast_var);
   }
}



/* _cfun? */
obj_t 
_cfun__201_ast_var(obj_t env_1559, obj_t obj_1560)
{
   AN_OBJECT;
   {	/* Ast/var.scm 105 */
      {		/* Ast/var.scm 105 */
	 bool_t aux_2210;
	 aux_2210 =
	    cfun__213_ast_var(obj_1560);
	 return
	    BBOOL(aux_2210);
      }
   }
}



/* make-cfun */
cfun_bglt 
make_cfun_58_ast_var(long arity_45, obj_t side_effect__165_46, obj_t predicate_of_78_47, obj_t stack_allocator_172_48, bool_t top__138_49, obj_t the_closure_238_50, obj_t args_type_205_51, bool_t macro__33_52, bool_t infix__163_53)
{
   AN_OBJECT;
   {	/* Ast/var.scm 105 */
      {		/* Ast/var.scm 105 */
	 cfun_bglt new1364_909;
	 new1364_909 =
	    ((cfun_bglt) BREF(GC_MALLOC(sizeof(struct cfun))));
	 {	/* Ast/var.scm 105 */
	    long arg1603_910;
	    arg1603_910 =
	       class_num_218___object(cfun_ast_var);
	    {	/* Ast/var.scm 105 */
	       obj_t obj_920;
	       obj_920 =
		  (obj_t) (new1364_909);
	       (((obj_t) CREF(obj_920))->header = MAKE_HEADER(arg1603_910, 0), BUNSPEC);
	    }
	 }
	 {	/* Ast/var.scm 105 */
	    object_bglt aux_2217;
	    aux_2217 =
	       (object_bglt) (new1364_909);
	    OBJECT_WIDENING_SET(aux_2217, BFALSE);
	 }
	 ((((cfun_bglt) CREF(new1364_909))->arity) = ((long) arity_45), BUNSPEC);
	 ((((cfun_bglt) CREF(new1364_909))->side_effect__165) = ((obj_t) side_effect__165_46), BUNSPEC);
	 ((((cfun_bglt) CREF(new1364_909))->predicate_of_78) = ((obj_t) predicate_of_78_47), BUNSPEC);
	 ((((cfun_bglt) CREF(new1364_909))->stack_allocator_172) = ((obj_t) stack_allocator_172_48), BUNSPEC);
	 ((((cfun_bglt) CREF(new1364_909))->top__138) = ((bool_t) top__138_49), BUNSPEC);
	 ((((cfun_bglt) CREF(new1364_909))->the_closure_238) = ((obj_t) the_closure_238_50), BUNSPEC);
	 ((((cfun_bglt) CREF(new1364_909))->args_type_205) = ((obj_t) args_type_205_51), BUNSPEC);
	 ((((cfun_bglt) CREF(new1364_909))->macro__33) = ((bool_t) macro__33_52), BUNSPEC);
	 ((((cfun_bglt) CREF(new1364_909))->infix__163) = ((bool_t) infix__163_53), BUNSPEC);
	 return new1364_909;
      }
   }
}



/* _make-cfun1802 */
obj_t 
_make_cfun1802_160_ast_var(obj_t env_1561, obj_t arity_1562, obj_t side_effect__165_1563, obj_t predicate_of_78_1564, obj_t stack_allocator_172_1565, obj_t top__138_1566, obj_t the_closure_238_1567, obj_t args_type_205_1568, obj_t macro__33_1569, obj_t infix__163_1570)
{
   AN_OBJECT;
   {	/* Ast/var.scm 105 */
      {		/* Ast/var.scm 105 */
	 cfun_bglt aux_2229;
	 aux_2229 =
	    make_cfun_58_ast_var(
	    (long) CINT(arity_1562), side_effect__165_1563, predicate_of_78_1564, stack_allocator_172_1565,
	    CBOOL(top__138_1566), the_closure_238_1567, args_type_205_1568,
	    CBOOL(macro__33_1569),
	    CBOOL(infix__163_1570));
	 return
	    (obj_t) (aux_2229);
      }
   }
}



/* cfun-arity */
long 
cfun_arity_68_ast_var(cfun_bglt obj_54)
{
   AN_OBJECT;
   {	/* Ast/var.scm 72 */
      return
	 (((cfun_bglt) CREF(obj_54))->arity);
   }
}



/* _cfun-arity1803 */
obj_t 
_cfun_arity1803_33_ast_var(obj_t env_1571, obj_t obj_1572)
{
   AN_OBJECT;
   {	/* Ast/var.scm 72 */
      {		/* Ast/var.scm 72 */
	 long aux_2237;
	 aux_2237 =
	    cfun_arity_68_ast_var(
	    (cfun_bglt) (obj_1572));
	 return
	    BINT(aux_2237);
      }
   }
}



/* cfun-side-effect?-set! */
obj_t 
cfun_side_effect__set__1_ast_var(cfun_bglt obj_55, obj_t val1358_56)
{
   AN_OBJECT;
   {	/* Ast/var.scm 74 */
      return
	 ((((cfun_bglt) CREF(obj_55))->side_effect__165) = ((obj_t) val1358_56), BUNSPEC);
   }
}



/* _cfun-side-effect?-set!1804 */
obj_t 
_cfun_side_effect__set_1804_46_ast_var(obj_t env_1573, obj_t obj_1574, obj_t val1358_1575)
{
   AN_OBJECT;
   {	/* Ast/var.scm 74 */
      return
	 cfun_side_effect__set__1_ast_var(
	 (cfun_bglt) (obj_1574), val1358_1575);
   }
}



/* cfun-side-effect? */
obj_t 
cfun_side_effect__250_ast_var(cfun_bglt obj_57)
{
   AN_OBJECT;
   {	/* Ast/var.scm 74 */
      return
	 (((cfun_bglt) CREF(obj_57))->side_effect__165);
   }
}



/* _cfun-side-effect?1805 */
obj_t 
_cfun_side_effect_1805_211_ast_var(obj_t env_1576, obj_t obj_1577)
{
   AN_OBJECT;
   {	/* Ast/var.scm 74 */
      return
	 cfun_side_effect__250_ast_var(
	 (cfun_bglt) (obj_1577));
   }
}



/* cfun-predicate-of-set! */
obj_t 
cfun_predicate_of_set__65_ast_var(cfun_bglt obj_58, obj_t val1359_59)
{
   AN_OBJECT;
   {	/* Ast/var.scm 76 */
      return
	 ((((cfun_bglt) CREF(obj_58))->predicate_of_78) = ((obj_t) val1359_59), BUNSPEC);
   }
}



/* _cfun-predicate-of-set!1806 */
obj_t 
_cfun_predicate_of_set_1806_183_ast_var(obj_t env_1578, obj_t obj_1579, obj_t val1359_1580)
{
   AN_OBJECT;
   {	/* Ast/var.scm 76 */
      return
	 cfun_predicate_of_set__65_ast_var(
	 (cfun_bglt) (obj_1579), val1359_1580);
   }
}



/* cfun-predicate-of */
obj_t 
cfun_predicate_of_23_ast_var(cfun_bglt obj_60)
{
   AN_OBJECT;
   {	/* Ast/var.scm 76 */
      return
	 (((cfun_bglt) CREF(obj_60))->predicate_of_78);
   }
}



/* _cfun-predicate-of1807 */
obj_t 
_cfun_predicate_of1807_166_ast_var(obj_t env_1581, obj_t obj_1582)
{
   AN_OBJECT;
   {	/* Ast/var.scm 76 */
      return
	 cfun_predicate_of_23_ast_var(
	 (cfun_bglt) (obj_1582));
   }
}



/* cfun-stack-allocator-set! */
obj_t 
cfun_stack_allocator_set__66_ast_var(cfun_bglt obj_61, obj_t val1360_62)
{
   AN_OBJECT;
   {	/* Ast/var.scm 78 */
      return
	 ((((cfun_bglt) CREF(obj_61))->stack_allocator_172) = ((obj_t) val1360_62), BUNSPEC);
   }
}



/* _cfun-stack-allocator-set!1808 */
obj_t 
_cfun_stack_allocator_set_1808_197_ast_var(obj_t env_1583, obj_t obj_1584, obj_t val1360_1585)
{
   AN_OBJECT;
   {	/* Ast/var.scm 78 */
      return
	 cfun_stack_allocator_set__66_ast_var(
	 (cfun_bglt) (obj_1584), val1360_1585);
   }
}



/* cfun-stack-allocator */
obj_t 
cfun_stack_allocator_58_ast_var(cfun_bglt obj_63)
{
   AN_OBJECT;
   {	/* Ast/var.scm 78 */
      return
	 (((cfun_bglt) CREF(obj_63))->stack_allocator_172);
   }
}



/* _cfun-stack-allocator1809 */
obj_t 
_cfun_stack_allocator1809_246_ast_var(obj_t env_1586, obj_t obj_1587)
{
   AN_OBJECT;
   {	/* Ast/var.scm 78 */
      return
	 cfun_stack_allocator_58_ast_var(
	 (cfun_bglt) (obj_1587));
   }
}



/* cfun-top?-set! */
obj_t 
cfun_top__set__230_ast_var(cfun_bglt obj_64, bool_t val1361_65)
{
   AN_OBJECT;
   {	/* Ast/var.scm 80 */
      return
	 ((((cfun_bglt) CREF(obj_64))->top__138) = ((bool_t) val1361_65), BUNSPEC);
   }
}



/* _cfun-top?-set!1810 */
obj_t 
_cfun_top__set_1810_137_ast_var(obj_t env_1588, obj_t obj_1589, obj_t val1361_1590)
{
   AN_OBJECT;
   {	/* Ast/var.scm 80 */
      return
	 cfun_top__set__230_ast_var(
	 (cfun_bglt) (obj_1589),
	 CBOOL(val1361_1590));
   }
}



/* cfun-top? */
bool_t 
cfun_top__60_ast_var(cfun_bglt obj_66)
{
   AN_OBJECT;
   {	/* Ast/var.scm 80 */
      return
	 (((cfun_bglt) CREF(obj_66))->top__138);
   }
}



/* _cfun-top?1811 */
obj_t 
_cfun_top_1811_211_ast_var(obj_t env_1591, obj_t obj_1592)
{
   AN_OBJECT;
   {	/* Ast/var.scm 80 */
      {		/* Ast/var.scm 80 */
	 bool_t aux_2264;
	 aux_2264 =
	    cfun_top__60_ast_var(
	    (cfun_bglt) (obj_1592));
	 return
	    BBOOL(aux_2264);
      }
   }
}



/* cfun-the-closure-set! */
obj_t 
cfun_the_closure_set__43_ast_var(cfun_bglt obj_67, obj_t val1362_68)
{
   AN_OBJECT;
   {	/* Ast/var.scm 82 */
      return
	 ((((cfun_bglt) CREF(obj_67))->the_closure_238) = ((obj_t) val1362_68), BUNSPEC);
   }
}



/* _cfun-the-closure-set!1812 */
obj_t 
_cfun_the_closure_set_1812_176_ast_var(obj_t env_1593, obj_t obj_1594, obj_t val1362_1595)
{
   AN_OBJECT;
   {	/* Ast/var.scm 82 */
      return
	 cfun_the_closure_set__43_ast_var(
	 (cfun_bglt) (obj_1594), val1362_1595);
   }
}



/* cfun-the-closure */
obj_t 
cfun_the_closure_97_ast_var(cfun_bglt obj_69)
{
   AN_OBJECT;
   {	/* Ast/var.scm 82 */
      return
	 (((cfun_bglt) CREF(obj_69))->the_closure_238);
   }
}



/* _cfun-the-closure1813 */
obj_t 
_cfun_the_closure1813_65_ast_var(obj_t env_1596, obj_t obj_1597)
{
   AN_OBJECT;
   {	/* Ast/var.scm 82 */
      return
	 cfun_the_closure_97_ast_var(
	 (cfun_bglt) (obj_1597));
   }
}



/* cfun-args-type */
obj_t 
cfun_args_type_30_ast_var(cfun_bglt obj_70)
{
   AN_OBJECT;
   {	/* Ast/var.scm 107 */
      return
	 (((cfun_bglt) CREF(obj_70))->args_type_205);
   }
}



/* _cfun-args-type1814 */
obj_t 
_cfun_args_type1814_160_ast_var(obj_t env_1598, obj_t obj_1599)
{
   AN_OBJECT;
   {	/* Ast/var.scm 107 */
      return
	 cfun_args_type_30_ast_var(
	 (cfun_bglt) (obj_1599));
   }
}



/* cfun-macro? */
bool_t 
cfun_macro__119_ast_var(cfun_bglt obj_71)
{
   AN_OBJECT;
   {	/* Ast/var.scm 109 */
      return
	 (((cfun_bglt) CREF(obj_71))->macro__33);
   }
}



/* _cfun-macro?1815 */
obj_t 
_cfun_macro_1815_17_ast_var(obj_t env_1600, obj_t obj_1601)
{
   AN_OBJECT;
   {	/* Ast/var.scm 109 */
      {		/* Ast/var.scm 109 */
	 bool_t aux_2278;
	 aux_2278 =
	    cfun_macro__119_ast_var(
	    (cfun_bglt) (obj_1601));
	 return
	    BBOOL(aux_2278);
      }
   }
}



/* cfun-infix?-set! */
obj_t 
cfun_infix__set__175_ast_var(cfun_bglt obj_72, bool_t val1363_73)
{
   AN_OBJECT;
   {	/* Ast/var.scm 111 */
      return
	 ((((cfun_bglt) CREF(obj_72))->infix__163) = ((bool_t) val1363_73), BUNSPEC);
   }
}



/* _cfun-infix?-set!1816 */
obj_t 
_cfun_infix__set_1816_22_ast_var(obj_t env_1602, obj_t obj_1603, obj_t val1363_1604)
{
   AN_OBJECT;
   {	/* Ast/var.scm 111 */
      return
	 cfun_infix__set__175_ast_var(
	 (cfun_bglt) (obj_1603),
	 CBOOL(val1363_1604));
   }
}



/* cfun-infix? */
bool_t 
cfun_infix__133_ast_var(cfun_bglt obj_74)
{
   AN_OBJECT;
   {	/* Ast/var.scm 111 */
      return
	 (((cfun_bglt) CREF(obj_74))->infix__163);
   }
}



/* _cfun-infix?1817 */
obj_t 
_cfun_infix_1817_88_ast_var(obj_t env_1605, obj_t obj_1606)
{
   AN_OBJECT;
   {	/* Ast/var.scm 111 */
      {		/* Ast/var.scm 111 */
	 bool_t aux_2287;
	 aux_2287 =
	    cfun_infix__133_ast_var(
	    (cfun_bglt) (obj_1606));
	 return
	    BBOOL(aux_2287);
      }
   }
}



/* allocate-sfun */
sfun_bglt 
allocate_sfun_135_ast_var()
{
   AN_OBJECT;
   {	/* Ast/var.scm 84 */
      {		/* Ast/var.scm 84 */
	 sfun_bglt new1307_440;
	 new1307_440 =
	    ((sfun_bglt) BREF(GC_MALLOC(sizeof(struct sfun))));
	 {	/* Ast/var.scm 84 */
	    long arg1604_441;
	    arg1604_441 =
	       class_num_218___object(sfun_ast_var);
	    {	/* Ast/var.scm 84 */
	       obj_t obj_922;
	       obj_922 =
		  (obj_t) (new1307_440);
	       (((obj_t) CREF(obj_922))->header = MAKE_HEADER(arg1604_441, 0), BUNSPEC);
	    }
	 }
	 {	/* Ast/var.scm 84 */
	    object_bglt aux_2295;
	    aux_2295 =
	       (object_bglt) (new1307_440);
	    OBJECT_WIDENING_SET(aux_2295, BFALSE);
	 }
	 return new1307_440;
      }
   }
}



/* _allocate-sfun */
obj_t 
_allocate_sfun_141_ast_var(obj_t env_1505)
{
   AN_OBJECT;
   {	/* Ast/var.scm 84 */
      {		/* Ast/var.scm 84 */
	 sfun_bglt aux_2298;
	 aux_2298 =
	    allocate_sfun_135_ast_var();
	 return
	    (obj_t) (aux_2298);
      }
   }
}



/* sfun? */
bool_t 
sfun__199_ast_var(obj_t obj_78)
{
   AN_OBJECT;
   {	/* Ast/var.scm 84 */
      return
	 is_a__118___object(obj_78, sfun_ast_var);
   }
}



/* _sfun? */
obj_t 
_sfun__63_ast_var(obj_t env_1607, obj_t obj_1608)
{
   AN_OBJECT;
   {	/* Ast/var.scm 84 */
      {		/* Ast/var.scm 84 */
	 bool_t aux_2302;
	 aux_2302 =
	    sfun__199_ast_var(obj_1608);
	 return
	    BBOOL(aux_2302);
      }
   }
}



/* make-sfun */
sfun_bglt 
make_sfun_19_ast_var(long arity_79, obj_t side_effect__165_80, obj_t predicate_of_78_81, obj_t stack_allocator_172_82, bool_t top__138_83, obj_t the_closure_238_84, obj_t property_85, obj_t args_86, obj_t body_87, obj_t class_88, obj_t dsssl_keywords_243_89, obj_t loc_90)
{
   AN_OBJECT;
   {	/* Ast/var.scm 84 */
      {		/* Ast/var.scm 84 */
	 sfun_bglt new1293_924;
	 new1293_924 =
	    ((sfun_bglt) BREF(GC_MALLOC(sizeof(struct sfun))));
	 {	/* Ast/var.scm 84 */
	    long arg1605_925;
	    arg1605_925 =
	       class_num_218___object(sfun_ast_var);
	    {	/* Ast/var.scm 84 */
	       obj_t obj_938;
	       obj_938 =
		  (obj_t) (new1293_924);
	       (((obj_t) CREF(obj_938))->header = MAKE_HEADER(arg1605_925, 0), BUNSPEC);
	    }
	 }
	 {	/* Ast/var.scm 84 */
	    object_bglt aux_2309;
	    aux_2309 =
	       (object_bglt) (new1293_924);
	    OBJECT_WIDENING_SET(aux_2309, BFALSE);
	 }
	 ((((sfun_bglt) CREF(new1293_924))->arity) = ((long) arity_79), BUNSPEC);
	 ((((sfun_bglt) CREF(new1293_924))->side_effect__165) = ((obj_t) side_effect__165_80), BUNSPEC);
	 ((((sfun_bglt) CREF(new1293_924))->predicate_of_78) = ((obj_t) predicate_of_78_81), BUNSPEC);
	 ((((sfun_bglt) CREF(new1293_924))->stack_allocator_172) = ((obj_t) stack_allocator_172_82), BUNSPEC);
	 ((((sfun_bglt) CREF(new1293_924))->top__138) = ((bool_t) top__138_83), BUNSPEC);
	 ((((sfun_bglt) CREF(new1293_924))->the_closure_238) = ((obj_t) the_closure_238_84), BUNSPEC);
	 ((((sfun_bglt) CREF(new1293_924))->property) = ((obj_t) property_85), BUNSPEC);
	 ((((sfun_bglt) CREF(new1293_924))->args) = ((obj_t) args_86), BUNSPEC);
	 ((((sfun_bglt) CREF(new1293_924))->body) = ((obj_t) body_87), BUNSPEC);
	 ((((sfun_bglt) CREF(new1293_924))->class) = ((obj_t) class_88), BUNSPEC);
	 ((((sfun_bglt) CREF(new1293_924))->dsssl_keywords_243) = ((obj_t) dsssl_keywords_243_89), BUNSPEC);
	 ((((sfun_bglt) CREF(new1293_924))->loc) = ((obj_t) loc_90), BUNSPEC);
	 return new1293_924;
      }
   }
}



/* _make-sfun1818 */
obj_t 
_make_sfun1818_142_ast_var(obj_t env_1609, obj_t arity_1610, obj_t side_effect__165_1611, obj_t predicate_of_78_1612, obj_t stack_allocator_172_1613, obj_t top__138_1614, obj_t the_closure_238_1615, obj_t property_1616, obj_t args_1617, obj_t body_1618, obj_t class_1619, obj_t dsssl_keywords_243_1620, obj_t loc_1621)
{
   AN_OBJECT;
   {	/* Ast/var.scm 84 */
      {		/* Ast/var.scm 84 */
	 sfun_bglt aux_2324;
	 aux_2324 =
	    make_sfun_19_ast_var(
	    (long) CINT(arity_1610), side_effect__165_1611, predicate_of_78_1612, stack_allocator_172_1613,
	    CBOOL(top__138_1614), the_closure_238_1615, property_1616, args_1617, body_1618, class_1619, dsssl_keywords_243_1620, loc_1621);
	 return
	    (obj_t) (aux_2324);
      }
   }
}



/* sfun-arity */
long 
sfun_arity_53_ast_var(sfun_bglt obj_91)
{
   AN_OBJECT;
   {	/* Ast/var.scm 72 */
      return
	 (((sfun_bglt) CREF(obj_91))->arity);
   }
}



/* _sfun-arity1819 */
obj_t 
_sfun_arity1819_181_ast_var(obj_t env_1622, obj_t obj_1623)
{
   AN_OBJECT;
   {	/* Ast/var.scm 72 */
      {		/* Ast/var.scm 72 */
	 long aux_2330;
	 aux_2330 =
	    sfun_arity_53_ast_var(
	    (sfun_bglt) (obj_1623));
	 return
	    BINT(aux_2330);
      }
   }
}



/* sfun-side-effect?-set! */
obj_t 
sfun_side_effect__set__97_ast_var(sfun_bglt obj_92, obj_t val1282_93)
{
   AN_OBJECT;
   {	/* Ast/var.scm 74 */
      return
	 ((((sfun_bglt) CREF(obj_92))->side_effect__165) = ((obj_t) val1282_93), BUNSPEC);
   }
}



/* _sfun-side-effect?-set!1820 */
obj_t 
_sfun_side_effect__set_1820_154_ast_var(obj_t env_1624, obj_t obj_1625, obj_t val1282_1626)
{
   AN_OBJECT;
   {	/* Ast/var.scm 74 */
      return
	 sfun_side_effect__set__97_ast_var(
	 (sfun_bglt) (obj_1625), val1282_1626);
   }
}



/* sfun-side-effect? */
obj_t 
sfun_side_effect__85_ast_var(sfun_bglt obj_94)
{
   AN_OBJECT;
   {	/* Ast/var.scm 74 */
      return
	 (((sfun_bglt) CREF(obj_94))->side_effect__165);
   }
}



/* _sfun-side-effect?1821 */
obj_t 
_sfun_side_effect_1821_40_ast_var(obj_t env_1627, obj_t obj_1628)
{
   AN_OBJECT;
   {	/* Ast/var.scm 74 */
      return
	 sfun_side_effect__85_ast_var(
	 (sfun_bglt) (obj_1628));
   }
}



/* sfun-predicate-of-set! */
obj_t 
sfun_predicate_of_set__36_ast_var(sfun_bglt obj_95, obj_t val1283_96)
{
   AN_OBJECT;
   {	/* Ast/var.scm 76 */
      return
	 ((((sfun_bglt) CREF(obj_95))->predicate_of_78) = ((obj_t) val1283_96), BUNSPEC);
   }
}



/* _sfun-predicate-of-set!1822 */
obj_t 
_sfun_predicate_of_set_1822_241_ast_var(obj_t env_1629, obj_t obj_1630, obj_t val1283_1631)
{
   AN_OBJECT;
   {	/* Ast/var.scm 76 */
      return
	 sfun_predicate_of_set__36_ast_var(
	 (sfun_bglt) (obj_1630), val1283_1631);
   }
}



/* sfun-predicate-of */
obj_t 
sfun_predicate_of_63_ast_var(sfun_bglt obj_97)
{
   AN_OBJECT;
   {	/* Ast/var.scm 76 */
      return
	 (((sfun_bglt) CREF(obj_97))->predicate_of_78);
   }
}



/* _sfun-predicate-of1823 */
obj_t 
_sfun_predicate_of1823_228_ast_var(obj_t env_1632, obj_t obj_1633)
{
   AN_OBJECT;
   {	/* Ast/var.scm 76 */
      return
	 sfun_predicate_of_63_ast_var(
	 (sfun_bglt) (obj_1633));
   }
}



/* sfun-stack-allocator-set! */
obj_t 
sfun_stack_allocator_set__142_ast_var(sfun_bglt obj_98, obj_t val1284_99)
{
   AN_OBJECT;
   {	/* Ast/var.scm 78 */
      return
	 ((((sfun_bglt) CREF(obj_98))->stack_allocator_172) = ((obj_t) val1284_99), BUNSPEC);
   }
}



/* _sfun-stack-allocator-set!1824 */
obj_t 
_sfun_stack_allocator_set_1824_51_ast_var(obj_t env_1634, obj_t obj_1635, obj_t val1284_1636)
{
   AN_OBJECT;
   {	/* Ast/var.scm 78 */
      return
	 sfun_stack_allocator_set__142_ast_var(
	 (sfun_bglt) (obj_1635), val1284_1636);
   }
}



/* sfun-stack-allocator */
obj_t 
sfun_stack_allocator_39_ast_var(sfun_bglt obj_100)
{
   AN_OBJECT;
   {	/* Ast/var.scm 78 */
      return
	 (((sfun_bglt) CREF(obj_100))->stack_allocator_172);
   }
}



/* _sfun-stack-allocator1825 */
obj_t 
_sfun_stack_allocator1825_161_ast_var(obj_t env_1637, obj_t obj_1638)
{
   AN_OBJECT;
   {	/* Ast/var.scm 78 */
      return
	 sfun_stack_allocator_39_ast_var(
	 (sfun_bglt) (obj_1638));
   }
}



/* sfun-top?-set! */
obj_t 
sfun_top__set__255_ast_var(sfun_bglt obj_101, bool_t val1285_102)
{
   AN_OBJECT;
   {	/* Ast/var.scm 80 */
      return
	 ((((sfun_bglt) CREF(obj_101))->top__138) = ((bool_t) val1285_102), BUNSPEC);
   }
}



/* _sfun-top?-set!1826 */
obj_t 
_sfun_top__set_1826_236_ast_var(obj_t env_1639, obj_t obj_1640, obj_t val1285_1641)
{
   AN_OBJECT;
   {	/* Ast/var.scm 80 */
      return
	 sfun_top__set__255_ast_var(
	 (sfun_bglt) (obj_1640),
	 CBOOL(val1285_1641));
   }
}



/* sfun-top? */
bool_t 
sfun_top__45_ast_var(sfun_bglt obj_103)
{
   AN_OBJECT;
   {	/* Ast/var.scm 80 */
      return
	 (((sfun_bglt) CREF(obj_103))->top__138);
   }
}



/* _sfun-top?1827 */
obj_t 
_sfun_top_1827_49_ast_var(obj_t env_1642, obj_t obj_1643)
{
   AN_OBJECT;
   {	/* Ast/var.scm 80 */
      {		/* Ast/var.scm 80 */
	 bool_t aux_2357;
	 aux_2357 =
	    sfun_top__45_ast_var(
	    (sfun_bglt) (obj_1643));
	 return
	    BBOOL(aux_2357);
      }
   }
}



/* sfun-the-closure-set! */
obj_t 
sfun_the_closure_set__227_ast_var(sfun_bglt obj_104, obj_t val1286_105)
{
   AN_OBJECT;
   {	/* Ast/var.scm 82 */
      return
	 ((((sfun_bglt) CREF(obj_104))->the_closure_238) = ((obj_t) val1286_105), BUNSPEC);
   }
}



/* _sfun-the-closure-set!1828 */
obj_t 
_sfun_the_closure_set_1828_16_ast_var(obj_t env_1644, obj_t obj_1645, obj_t val1286_1646)
{
   AN_OBJECT;
   {	/* Ast/var.scm 82 */
      return
	 sfun_the_closure_set__227_ast_var(
	 (sfun_bglt) (obj_1645), val1286_1646);
   }
}



/* sfun-the-closure */
obj_t 
sfun_the_closure_253_ast_var(sfun_bglt obj_106)
{
   AN_OBJECT;
   {	/* Ast/var.scm 82 */
      return
	 (((sfun_bglt) CREF(obj_106))->the_closure_238);
   }
}



/* _sfun-the-closure1829 */
obj_t 
_sfun_the_closure1829_199_ast_var(obj_t env_1647, obj_t obj_1648)
{
   AN_OBJECT;
   {	/* Ast/var.scm 82 */
      return
	 sfun_the_closure_253_ast_var(
	 (sfun_bglt) (obj_1648));
   }
}



/* sfun-property-set! */
obj_t 
sfun_property_set__95_ast_var(sfun_bglt obj_107, obj_t val1287_108)
{
   AN_OBJECT;
   {	/* Ast/var.scm 86 */
      return
	 ((((sfun_bglt) CREF(obj_107))->property) = ((obj_t) val1287_108), BUNSPEC);
   }
}



/* _sfun-property-set!1830 */
obj_t 
_sfun_property_set_1830_7_ast_var(obj_t env_1649, obj_t obj_1650, obj_t val1287_1651)
{
   AN_OBJECT;
   {	/* Ast/var.scm 86 */
      return
	 sfun_property_set__95_ast_var(
	 (sfun_bglt) (obj_1650), val1287_1651);
   }
}



/* sfun-property */
obj_t 
sfun_property_40_ast_var(sfun_bglt obj_109)
{
   AN_OBJECT;
   {	/* Ast/var.scm 86 */
      return
	 (((sfun_bglt) CREF(obj_109))->property);
   }
}



/* _sfun-property1831 */
obj_t 
_sfun_property1831_170_ast_var(obj_t env_1652, obj_t obj_1653)
{
   AN_OBJECT;
   {	/* Ast/var.scm 86 */
      return
	 sfun_property_40_ast_var(
	 (sfun_bglt) (obj_1653));
   }
}



/* sfun-args-set! */
obj_t 
sfun_args_set__132_ast_var(sfun_bglt obj_110, obj_t val1288_111)
{
   AN_OBJECT;
   {	/* Ast/var.scm 88 */
      return
	 ((((sfun_bglt) CREF(obj_110))->args) = ((obj_t) val1288_111), BUNSPEC);
   }
}



/* _sfun-args-set!1832 */
obj_t 
_sfun_args_set_1832_111_ast_var(obj_t env_1654, obj_t obj_1655, obj_t val1288_1656)
{
   AN_OBJECT;
   {	/* Ast/var.scm 88 */
      return
	 sfun_args_set__132_ast_var(
	 (sfun_bglt) (obj_1655), val1288_1656);
   }
}



/* sfun-args */
obj_t 
sfun_args_174_ast_var(sfun_bglt obj_112)
{
   AN_OBJECT;
   {	/* Ast/var.scm 88 */
      return
	 (((sfun_bglt) CREF(obj_112))->args);
   }
}



/* _sfun-args1833 */
obj_t 
_sfun_args1833_131_ast_var(obj_t env_1657, obj_t obj_1658)
{
   AN_OBJECT;
   {	/* Ast/var.scm 88 */
      return
	 sfun_args_174_ast_var(
	 (sfun_bglt) (obj_1658));
   }
}



/* sfun-body-set! */
obj_t 
sfun_body_set__45_ast_var(sfun_bglt obj_113, obj_t val1289_114)
{
   AN_OBJECT;
   {	/* Ast/var.scm 90 */
      return
	 ((((sfun_bglt) CREF(obj_113))->body) = ((obj_t) val1289_114), BUNSPEC);
   }
}



/* _sfun-body-set!1834 */
obj_t 
_sfun_body_set_1834_175_ast_var(obj_t env_1659, obj_t obj_1660, obj_t val1289_1661)
{
   AN_OBJECT;
   {	/* Ast/var.scm 90 */
      return
	 sfun_body_set__45_ast_var(
	 (sfun_bglt) (obj_1660), val1289_1661);
   }
}



/* sfun-body */
obj_t 
sfun_body_150_ast_var(sfun_bglt obj_115)
{
   AN_OBJECT;
   {	/* Ast/var.scm 90 */
      return
	 (((sfun_bglt) CREF(obj_115))->body);
   }
}



/* _sfun-body1835 */
obj_t 
_sfun_body1835_143_ast_var(obj_t env_1662, obj_t obj_1663)
{
   AN_OBJECT;
   {	/* Ast/var.scm 90 */
      return
	 sfun_body_150_ast_var(
	 (sfun_bglt) (obj_1663));
   }
}



/* sfun-class-set! */
obj_t 
sfun_class_set__158_ast_var(sfun_bglt obj_116, obj_t val1290_117)
{
   AN_OBJECT;
   {	/* Ast/var.scm 92 */
      return
	 ((((sfun_bglt) CREF(obj_116))->class) = ((obj_t) val1290_117), BUNSPEC);
   }
}



/* _sfun-class-set!1836 */
obj_t 
_sfun_class_set_1836_206_ast_var(obj_t env_1664, obj_t obj_1665, obj_t val1290_1666)
{
   AN_OBJECT;
   {	/* Ast/var.scm 92 */
      return
	 sfun_class_set__158_ast_var(
	 (sfun_bglt) (obj_1665), val1290_1666);
   }
}



/* sfun-class */
obj_t 
sfun_class_145_ast_var(sfun_bglt obj_118)
{
   AN_OBJECT;
   {	/* Ast/var.scm 92 */
      return
	 (((sfun_bglt) CREF(obj_118))->class);
   }
}



/* _sfun-class1837 */
obj_t 
_sfun_class1837_29_ast_var(obj_t env_1667, obj_t obj_1668)
{
   AN_OBJECT;
   {	/* Ast/var.scm 92 */
      return
	 sfun_class_145_ast_var(
	 (sfun_bglt) (obj_1668));
   }
}



/* sfun-dsssl-keywords-set! */
obj_t 
sfun_dsssl_keywords_set__95_ast_var(sfun_bglt obj_119, obj_t val1291_120)
{
   AN_OBJECT;
   {	/* Ast/var.scm 98 */
      return
	 ((((sfun_bglt) CREF(obj_119))->dsssl_keywords_243) = ((obj_t) val1291_120), BUNSPEC);
   }
}



/* _sfun-dsssl-keywords-set!1838 */
obj_t 
_sfun_dsssl_keywords_set_1838_239_ast_var(obj_t env_1669, obj_t obj_1670, obj_t val1291_1671)
{
   AN_OBJECT;
   {	/* Ast/var.scm 98 */
      return
	 sfun_dsssl_keywords_set__95_ast_var(
	 (sfun_bglt) (obj_1670), val1291_1671);
   }
}



/* sfun-dsssl-keywords */
obj_t 
sfun_dsssl_keywords_40_ast_var(sfun_bglt obj_121)
{
   AN_OBJECT;
   {	/* Ast/var.scm 98 */
      return
	 (((sfun_bglt) CREF(obj_121))->dsssl_keywords_243);
   }
}



/* _sfun-dsssl-keywords1839 */
obj_t 
_sfun_dsssl_keywords1839_19_ast_var(obj_t env_1672, obj_t obj_1673)
{
   AN_OBJECT;
   {	/* Ast/var.scm 98 */
      return
	 sfun_dsssl_keywords_40_ast_var(
	 (sfun_bglt) (obj_1673));
   }
}



/* sfun-loc-set! */
obj_t 
sfun_loc_set__51_ast_var(sfun_bglt obj_122, obj_t val1292_123)
{
   AN_OBJECT;
   {	/* Ast/var.scm 103 */
      return
	 ((((sfun_bglt) CREF(obj_122))->loc) = ((obj_t) val1292_123), BUNSPEC);
   }
}



/* _sfun-loc-set!1840 */
obj_t 
_sfun_loc_set_1840_150_ast_var(obj_t env_1674, obj_t obj_1675, obj_t val1292_1676)
{
   AN_OBJECT;
   {	/* Ast/var.scm 103 */
      return
	 sfun_loc_set__51_ast_var(
	 (sfun_bglt) (obj_1675), val1292_1676);
   }
}



/* sfun-loc */
obj_t 
sfun_loc_13_ast_var(sfun_bglt obj_124)
{
   AN_OBJECT;
   {	/* Ast/var.scm 103 */
      return
	 (((sfun_bglt) CREF(obj_124))->loc);
   }
}



/* _sfun-loc1841 */
obj_t 
_sfun_loc1841_74_ast_var(obj_t env_1677, obj_t obj_1678)
{
   AN_OBJECT;
   {	/* Ast/var.scm 103 */
      return
	 sfun_loc_13_ast_var(
	 (sfun_bglt) (obj_1678));
   }
}



/* allocate-fun */
fun_bglt 
allocate_fun_149_ast_var()
{
   AN_OBJECT;
   {	/* Ast/var.scm 70 */
      {		/* Ast/var.scm 70 */
	 fun_bglt new1255_456;
	 new1255_456 =
	    ((fun_bglt) BREF(GC_MALLOC(sizeof(struct fun))));
	 {	/* Ast/var.scm 70 */
	    long arg1606_457;
	    arg1606_457 =
	       class_num_218___object(fun_ast_var);
	    {	/* Ast/var.scm 70 */
	       obj_t obj_940;
	       obj_940 =
		  (obj_t) (new1255_456);
	       (((obj_t) CREF(obj_940))->header = MAKE_HEADER(arg1606_457, 0), BUNSPEC);
	    }
	 }
	 {	/* Ast/var.scm 70 */
	    object_bglt aux_2407;
	    aux_2407 =
	       (object_bglt) (new1255_456);
	    OBJECT_WIDENING_SET(aux_2407, BFALSE);
	 }
	 return new1255_456;
      }
   }
}



/* _allocate-fun */
obj_t 
_allocate_fun_230_ast_var(obj_t env_1504)
{
   AN_OBJECT;
   {	/* Ast/var.scm 70 */
      {		/* Ast/var.scm 70 */
	 fun_bglt aux_2410;
	 aux_2410 =
	    allocate_fun_149_ast_var();
	 return
	    (obj_t) (aux_2410);
      }
   }
}



/* fun? */
bool_t 
fun__147_ast_var(obj_t obj_128)
{
   AN_OBJECT;
   {	/* Ast/var.scm 70 */
      return
	 is_a__118___object(obj_128, fun_ast_var);
   }
}



/* _fun? */
obj_t 
_fun__116_ast_var(obj_t env_1679, obj_t obj_1680)
{
   AN_OBJECT;
   {	/* Ast/var.scm 70 */
      {		/* Ast/var.scm 70 */
	 bool_t aux_2414;
	 aux_2414 =
	    fun__147_ast_var(obj_1680);
	 return
	    BBOOL(aux_2414);
      }
   }
}



/* make-fun */
fun_bglt 
make_fun_37_ast_var(long arity_129, obj_t side_effect__165_130, obj_t predicate_of_78_131, obj_t stack_allocator_172_132, bool_t top__138_133, obj_t the_closure_238_134)
{
   AN_OBJECT;
   {	/* Ast/var.scm 70 */
      {		/* Ast/var.scm 70 */
	 fun_bglt new1247_942;
	 new1247_942 =
	    ((fun_bglt) BREF(GC_MALLOC(sizeof(struct fun))));
	 {	/* Ast/var.scm 70 */
	    long arg1607_943;
	    arg1607_943 =
	       class_num_218___object(fun_ast_var);
	    {	/* Ast/var.scm 70 */
	       obj_t obj_950;
	       obj_950 =
		  (obj_t) (new1247_942);
	       (((obj_t) CREF(obj_950))->header = MAKE_HEADER(arg1607_943, 0), BUNSPEC);
	    }
	 }
	 {	/* Ast/var.scm 70 */
	    object_bglt aux_2421;
	    aux_2421 =
	       (object_bglt) (new1247_942);
	    OBJECT_WIDENING_SET(aux_2421, BFALSE);
	 }
	 ((((fun_bglt) CREF(new1247_942))->arity) = ((long) arity_129), BUNSPEC);
	 ((((fun_bglt) CREF(new1247_942))->side_effect__165) = ((obj_t) side_effect__165_130), BUNSPEC);
	 ((((fun_bglt) CREF(new1247_942))->predicate_of_78) = ((obj_t) predicate_of_78_131), BUNSPEC);
	 ((((fun_bglt) CREF(new1247_942))->stack_allocator_172) = ((obj_t) stack_allocator_172_132), BUNSPEC);
	 ((((fun_bglt) CREF(new1247_942))->top__138) = ((bool_t) top__138_133), BUNSPEC);
	 ((((fun_bglt) CREF(new1247_942))->the_closure_238) = ((obj_t) the_closure_238_134), BUNSPEC);
	 return new1247_942;
      }
   }
}



/* _make-fun1842 */
obj_t 
_make_fun1842_242_ast_var(obj_t env_1681, obj_t arity_1682, obj_t side_effect__165_1683, obj_t predicate_of_78_1684, obj_t stack_allocator_172_1685, obj_t top__138_1686, obj_t the_closure_238_1687)
{
   AN_OBJECT;
   {	/* Ast/var.scm 70 */
      {		/* Ast/var.scm 70 */
	 fun_bglt aux_2430;
	 aux_2430 =
	    make_fun_37_ast_var(
	    (long) CINT(arity_1682), side_effect__165_1683, predicate_of_78_1684, stack_allocator_172_1685,
	    CBOOL(top__138_1686), the_closure_238_1687);
	 return
	    (obj_t) (aux_2430);
      }
   }
}



/* fun-arity */
long 
fun_arity_132_ast_var(fun_bglt obj_135)
{
   AN_OBJECT;
   {	/* Ast/var.scm 72 */
      return
	 (((fun_bglt) CREF(obj_135))->arity);
   }
}



/* _fun-arity1843 */
obj_t 
_fun_arity1843_229_ast_var(obj_t env_1688, obj_t obj_1689)
{
   AN_OBJECT;
   {	/* Ast/var.scm 72 */
      {		/* Ast/var.scm 72 */
	 long aux_2436;
	 aux_2436 =
	    fun_arity_132_ast_var(
	    (fun_bglt) (obj_1689));
	 return
	    BINT(aux_2436);
      }
   }
}



/* fun-side-effect?-set! */
obj_t 
fun_side_effect__set__185_ast_var(fun_bglt obj_136, obj_t val1242_137)
{
   AN_OBJECT;
   {	/* Ast/var.scm 74 */
      return
	 ((((fun_bglt) CREF(obj_136))->side_effect__165) = ((obj_t) val1242_137), BUNSPEC);
   }
}



/* _fun-side-effect?-set!1844 */
obj_t 
_fun_side_effect__set_1844_232_ast_var(obj_t env_1690, obj_t obj_1691, obj_t val1242_1692)
{
   AN_OBJECT;
   {	/* Ast/var.scm 74 */
      return
	 fun_side_effect__set__185_ast_var(
	 (fun_bglt) (obj_1691), val1242_1692);
   }
}



/* fun-side-effect? */
obj_t 
fun_side_effect__244_ast_var(fun_bglt obj_138)
{
   AN_OBJECT;
   {	/* Ast/var.scm 74 */
      return
	 (((fun_bglt) CREF(obj_138))->side_effect__165);
   }
}



/* _fun-side-effect?1845 */
obj_t 
_fun_side_effect_1845_49_ast_var(obj_t env_1693, obj_t obj_1694)
{
   AN_OBJECT;
   {	/* Ast/var.scm 74 */
      return
	 fun_side_effect__244_ast_var(
	 (fun_bglt) (obj_1694));
   }
}



/* fun-predicate-of-set! */
obj_t 
fun_predicate_of_set__163_ast_var(fun_bglt obj_139, obj_t val1243_140)
{
   AN_OBJECT;
   {	/* Ast/var.scm 76 */
      return
	 ((((fun_bglt) CREF(obj_139))->predicate_of_78) = ((obj_t) val1243_140), BUNSPEC);
   }
}



/* _fun-predicate-of-set!1846 */
obj_t 
_fun_predicate_of_set_1846_195_ast_var(obj_t env_1695, obj_t obj_1696, obj_t val1243_1697)
{
   AN_OBJECT;
   {	/* Ast/var.scm 76 */
      return
	 fun_predicate_of_set__163_ast_var(
	 (fun_bglt) (obj_1696), val1243_1697);
   }
}



/* fun-predicate-of */
obj_t 
fun_predicate_of_193_ast_var(fun_bglt obj_141)
{
   AN_OBJECT;
   {	/* Ast/var.scm 76 */
      return
	 (((fun_bglt) CREF(obj_141))->predicate_of_78);
   }
}



/* _fun-predicate-of1847 */
obj_t 
_fun_predicate_of1847_244_ast_var(obj_t env_1698, obj_t obj_1699)
{
   AN_OBJECT;
   {	/* Ast/var.scm 76 */
      return
	 fun_predicate_of_193_ast_var(
	 (fun_bglt) (obj_1699));
   }
}



/* fun-stack-allocator-set! */
obj_t 
fun_stack_allocator_set__246_ast_var(fun_bglt obj_142, obj_t val1244_143)
{
   AN_OBJECT;
   {	/* Ast/var.scm 78 */
      return
	 ((((fun_bglt) CREF(obj_142))->stack_allocator_172) = ((obj_t) val1244_143), BUNSPEC);
   }
}



/* _fun-stack-allocator-set!1848 */
obj_t 
_fun_stack_allocator_set_1848_167_ast_var(obj_t env_1700, obj_t obj_1701, obj_t val1244_1702)
{
   AN_OBJECT;
   {	/* Ast/var.scm 78 */
      return
	 fun_stack_allocator_set__246_ast_var(
	 (fun_bglt) (obj_1701), val1244_1702);
   }
}



/* fun-stack-allocator */
obj_t 
fun_stack_allocator_124_ast_var(fun_bglt obj_144)
{
   AN_OBJECT;
   {	/* Ast/var.scm 78 */
      return
	 (((fun_bglt) CREF(obj_144))->stack_allocator_172);
   }
}



/* _fun-stack-allocator1849 */
obj_t 
_fun_stack_allocator1849_244_ast_var(obj_t env_1703, obj_t obj_1704)
{
   AN_OBJECT;
   {	/* Ast/var.scm 78 */
      return
	 fun_stack_allocator_124_ast_var(
	 (fun_bglt) (obj_1704));
   }
}



/* fun-top?-set! */
obj_t 
fun_top__set__55_ast_var(fun_bglt obj_145, bool_t val1245_146)
{
   AN_OBJECT;
   {	/* Ast/var.scm 80 */
      return
	 ((((fun_bglt) CREF(obj_145))->top__138) = ((bool_t) val1245_146), BUNSPEC);
   }
}



/* _fun-top?-set!1850 */
obj_t 
_fun_top__set_1850_187_ast_var(obj_t env_1705, obj_t obj_1706, obj_t val1245_1707)
{
   AN_OBJECT;
   {	/* Ast/var.scm 80 */
      return
	 fun_top__set__55_ast_var(
	 (fun_bglt) (obj_1706),
	 CBOOL(val1245_1707));
   }
}



/* fun-top? */
bool_t 
fun_top__228_ast_var(fun_bglt obj_147)
{
   AN_OBJECT;
   {	/* Ast/var.scm 80 */
      return
	 (((fun_bglt) CREF(obj_147))->top__138);
   }
}



/* _fun-top?1851 */
obj_t 
_fun_top_1851_134_ast_var(obj_t env_1708, obj_t obj_1709)
{
   AN_OBJECT;
   {	/* Ast/var.scm 80 */
      {		/* Ast/var.scm 80 */
	 bool_t aux_2463;
	 aux_2463 =
	    fun_top__228_ast_var(
	    (fun_bglt) (obj_1709));
	 return
	    BBOOL(aux_2463);
      }
   }
}



/* fun-the-closure-set! */
obj_t 
fun_the_closure_set__119_ast_var(fun_bglt obj_148, obj_t val1246_149)
{
   AN_OBJECT;
   {	/* Ast/var.scm 82 */
      return
	 ((((fun_bglt) CREF(obj_148))->the_closure_238) = ((obj_t) val1246_149), BUNSPEC);
   }
}



/* _fun-the-closure-set!1852 */
obj_t 
_fun_the_closure_set_1852_75_ast_var(obj_t env_1710, obj_t obj_1711, obj_t val1246_1712)
{
   AN_OBJECT;
   {	/* Ast/var.scm 82 */
      return
	 fun_the_closure_set__119_ast_var(
	 (fun_bglt) (obj_1711), val1246_1712);
   }
}



/* fun-the-closure */
obj_t 
fun_the_closure_217_ast_var(fun_bglt obj_150)
{
   AN_OBJECT;
   {	/* Ast/var.scm 82 */
      return
	 (((fun_bglt) CREF(obj_150))->the_closure_238);
   }
}



/* _fun-the-closure1853 */
obj_t 
_fun_the_closure1853_244_ast_var(obj_t env_1713, obj_t obj_1714)
{
   AN_OBJECT;
   {	/* Ast/var.scm 82 */
      return
	 fun_the_closure_217_ast_var(
	 (fun_bglt) (obj_1714));
   }
}



/* allocate-local */
local_bglt 
allocate_local_177_ast_var()
{
   AN_OBJECT;
   {	/* Ast/var.scm 64 */
      {		/* Ast/var.scm 64 */
	 local_bglt new1199_466;
	 new1199_466 =
	    ((local_bglt) BREF(GC_MALLOC(sizeof(struct local))));
	 {	/* Ast/var.scm 64 */
	    long arg1608_467;
	    arg1608_467 =
	       class_num_218___object(local_ast_var);
	    {	/* Ast/var.scm 64 */
	       obj_t obj_952;
	       obj_952 =
		  (obj_t) (new1199_466);
	       (((obj_t) CREF(obj_952))->header = MAKE_HEADER(arg1608_467, 0), BUNSPEC);
	    }
	 }
	 {	/* Ast/var.scm 64 */
	    object_bglt aux_2477;
	    aux_2477 =
	       (object_bglt) (new1199_466);
	    OBJECT_WIDENING_SET(aux_2477, BFALSE);
	 }
	 return new1199_466;
      }
   }
}



/* _allocate-local */
obj_t 
_allocate_local_35_ast_var(obj_t env_1503)
{
   AN_OBJECT;
   {	/* Ast/var.scm 64 */
      {		/* Ast/var.scm 64 */
	 local_bglt aux_2480;
	 aux_2480 =
	    allocate_local_177_ast_var();
	 return
	    (obj_t) (aux_2480);
      }
   }
}



/* local? */
bool_t 
local__163_ast_var(obj_t obj_154)
{
   AN_OBJECT;
   {	/* Ast/var.scm 64 */
      return
	 is_a__118___object(obj_154, local_ast_var);
   }
}



/* _local? */
obj_t 
_local__113_ast_var(obj_t env_1715, obj_t obj_1716)
{
   AN_OBJECT;
   {	/* Ast/var.scm 64 */
      {		/* Ast/var.scm 64 */
	 bool_t aux_2484;
	 aux_2484 =
	    local__163_ast_var(obj_1716);
	 return
	    BBOOL(aux_2484);
      }
   }
}



/* make-local */
local_bglt 
make_local_130_ast_var(obj_t id_155, obj_t name_156, type_bglt type_157, value_bglt value_158, obj_t access_159, obj_t fast_alpha_7_160, obj_t removable_161, long occurrence_162, bool_t user__32_163, long key_164)
{
   AN_OBJECT;
   {	/* Ast/var.scm 64 */
      {		/* Ast/var.scm 64 */
	 local_bglt new1187_954;
	 new1187_954 =
	    ((local_bglt) BREF(GC_MALLOC(sizeof(struct local))));
	 {	/* Ast/var.scm 64 */
	    long arg1609_955;
	    arg1609_955 =
	       class_num_218___object(local_ast_var);
	    {	/* Ast/var.scm 64 */
	       obj_t obj_966;
	       obj_966 =
		  (obj_t) (new1187_954);
	       (((obj_t) CREF(obj_966))->header = MAKE_HEADER(arg1609_955, 0), BUNSPEC);
	    }
	 }
	 {	/* Ast/var.scm 64 */
	    object_bglt aux_2491;
	    aux_2491 =
	       (object_bglt) (new1187_954);
	    OBJECT_WIDENING_SET(aux_2491, BFALSE);
	 }
	 ((((local_bglt) CREF(new1187_954))->id) = ((obj_t) id_155), BUNSPEC);
	 ((((local_bglt) CREF(new1187_954))->name) = ((obj_t) name_156), BUNSPEC);
	 ((((local_bglt) CREF(new1187_954))->type) = ((type_bglt) type_157), BUNSPEC);
	 ((((local_bglt) CREF(new1187_954))->value) = ((value_bglt) value_158), BUNSPEC);
	 ((((local_bglt) CREF(new1187_954))->access) = ((obj_t) access_159), BUNSPEC);
	 ((((local_bglt) CREF(new1187_954))->fast_alpha_7) = ((obj_t) fast_alpha_7_160), BUNSPEC);
	 ((((local_bglt) CREF(new1187_954))->removable) = ((obj_t) removable_161), BUNSPEC);
	 ((((local_bglt) CREF(new1187_954))->occurrence) = ((long) occurrence_162), BUNSPEC);
	 ((((local_bglt) CREF(new1187_954))->user__32) = ((bool_t) user__32_163), BUNSPEC);
	 ((((local_bglt) CREF(new1187_954))->key) = ((long) key_164), BUNSPEC);
	 return new1187_954;
      }
   }
}



/* _make-local1854 */
obj_t 
_make_local1854_41_ast_var(obj_t env_1717, obj_t id_1718, obj_t name_1719, obj_t type_1720, obj_t value_1721, obj_t access_1722, obj_t fast_alpha_7_1723, obj_t removable_1724, obj_t occurrence_1725, obj_t user__32_1726, obj_t key_1727)
{
   AN_OBJECT;
   {	/* Ast/var.scm 64 */
      {		/* Ast/var.scm 64 */
	 local_bglt aux_2504;
	 aux_2504 =
	    make_local_130_ast_var(id_1718, name_1719,
	    (type_bglt) (type_1720),
	    (value_bglt) (value_1721), access_1722, fast_alpha_7_1723, removable_1724,
	    (long) CINT(occurrence_1725),
	    CBOOL(user__32_1726),
	    (long) CINT(key_1727));
	 return
	    (obj_t) (aux_2504);
      }
   }
}



/* local-id */
obj_t 
local_id_1_ast_var(local_bglt obj_165)
{
   AN_OBJECT;
   {	/* Ast/var.scm 23 */
      return
	 (((local_bglt) CREF(obj_165))->id);
   }
}



/* _local-id1855 */
obj_t 
_local_id1855_79_ast_var(obj_t env_1728, obj_t obj_1729)
{
   AN_OBJECT;
   {	/* Ast/var.scm 23 */
      return
	 local_id_1_ast_var(
	 (local_bglt) (obj_1729));
   }
}



/* local-name-set! */
obj_t 
local_name_set__155_ast_var(local_bglt obj_166, obj_t val1179_167)
{
   AN_OBJECT;
   {	/* Ast/var.scm 25 */
      return
	 ((((local_bglt) CREF(obj_166))->name) = ((obj_t) val1179_167), BUNSPEC);
   }
}



/* _local-name-set!1856 */
obj_t 
_local_name_set_1856_6_ast_var(obj_t env_1730, obj_t obj_1731, obj_t val1179_1732)
{
   AN_OBJECT;
   {	/* Ast/var.scm 25 */
      return
	 local_name_set__155_ast_var(
	 (local_bglt) (obj_1731), val1179_1732);
   }
}



/* local-name */
obj_t 
local_name_136_ast_var(local_bglt obj_168)
{
   AN_OBJECT;
   {	/* Ast/var.scm 25 */
      return
	 (((local_bglt) CREF(obj_168))->name);
   }
}



/* _local-name1857 */
obj_t 
_local_name1857_233_ast_var(obj_t env_1733, obj_t obj_1734)
{
   AN_OBJECT;
   {	/* Ast/var.scm 25 */
      return
	 local_name_136_ast_var(
	 (local_bglt) (obj_1734));
   }
}



/* local-type-set! */
obj_t 
local_type_set__101_ast_var(local_bglt obj_169, type_bglt val1180_170)
{
   AN_OBJECT;
   {	/* Ast/var.scm 27 */
      return
	 ((((local_bglt) CREF(obj_169))->type) = ((type_bglt) val1180_170), BUNSPEC);
   }
}



/* _local-type-set!1858 */
obj_t 
_local_type_set_1858_13_ast_var(obj_t env_1735, obj_t obj_1736, obj_t val1180_1737)
{
   AN_OBJECT;
   {	/* Ast/var.scm 27 */
      return
	 local_type_set__101_ast_var(
	 (local_bglt) (obj_1736),
	 (type_bglt) (val1180_1737));
   }
}



/* local-type */
type_bglt 
local_type_242_ast_var(local_bglt obj_171)
{
   AN_OBJECT;
   {	/* Ast/var.scm 27 */
      return
	 (((local_bglt) CREF(obj_171))->type);
   }
}



/* _local-type1859 */
obj_t 
_local_type1859_14_ast_var(obj_t env_1738, obj_t obj_1739)
{
   AN_OBJECT;
   {	/* Ast/var.scm 27 */
      {		/* Ast/var.scm 27 */
	 type_bglt aux_2526;
	 aux_2526 =
	    local_type_242_ast_var(
	    (local_bglt) (obj_1739));
	 return
	    (obj_t) (aux_2526);
      }
   }
}



/* local-value-set! */
obj_t 
local_value_set__243_ast_var(local_bglt obj_172, value_bglt val1181_173)
{
   AN_OBJECT;
   {	/* Ast/var.scm 64 */
      return
	 ((((local_bglt) CREF(obj_172))->value) = ((value_bglt) val1181_173), BUNSPEC);
   }
}



/* _local-value-set!1860 */
obj_t 
_local_value_set_1860_93_ast_var(obj_t env_1740, obj_t obj_1741, obj_t val1181_1742)
{
   AN_OBJECT;
   {	/* Ast/var.scm 64 */
      return
	 local_value_set__243_ast_var(
	 (local_bglt) (obj_1741),
	 (value_bglt) (val1181_1742));
   }
}



/* local-value */
value_bglt 
local_value_65_ast_var(local_bglt obj_174)
{
   AN_OBJECT;
   {	/* Ast/var.scm 64 */
      return
	 (((local_bglt) CREF(obj_174))->value);
   }
}



/* _local-value1861 */
obj_t 
_local_value1861_71_ast_var(obj_t env_1743, obj_t obj_1744)
{
   AN_OBJECT;
   {	/* Ast/var.scm 64 */
      {		/* Ast/var.scm 64 */
	 value_bglt aux_2535;
	 aux_2535 =
	    local_value_65_ast_var(
	    (local_bglt) (obj_1744));
	 return
	    (obj_t) (aux_2535);
      }
   }
}



/* local-access-set! */
obj_t 
local_access_set__100_ast_var(local_bglt obj_175, obj_t val1182_176)
{
   AN_OBJECT;
   {	/* Ast/var.scm 31 */
      return
	 ((((local_bglt) CREF(obj_175))->access) = ((obj_t) val1182_176), BUNSPEC);
   }
}



/* _local-access-set!1862 */
obj_t 
_local_access_set_1862_243_ast_var(obj_t env_1745, obj_t obj_1746, obj_t val1182_1747)
{
   AN_OBJECT;
   {	/* Ast/var.scm 31 */
      return
	 local_access_set__100_ast_var(
	 (local_bglt) (obj_1746), val1182_1747);
   }
}



/* local-access */
obj_t 
local_access_176_ast_var(local_bglt obj_177)
{
   AN_OBJECT;
   {	/* Ast/var.scm 31 */
      return
	 (((local_bglt) CREF(obj_177))->access);
   }
}



/* _local-access1863 */
obj_t 
_local_access1863_55_ast_var(obj_t env_1748, obj_t obj_1749)
{
   AN_OBJECT;
   {	/* Ast/var.scm 31 */
      return
	 local_access_176_ast_var(
	 (local_bglt) (obj_1749));
   }
}



/* local-fast-alpha-set! */
obj_t 
local_fast_alpha_set__243_ast_var(local_bglt obj_178, obj_t val1183_179)
{
   AN_OBJECT;
   {	/* Ast/var.scm 38 */
      return
	 ((((local_bglt) CREF(obj_178))->fast_alpha_7) = ((obj_t) val1183_179), BUNSPEC);
   }
}



/* _local-fast-alpha-set!1864 */
obj_t 
_local_fast_alpha_set_1864_162_ast_var(obj_t env_1750, obj_t obj_1751, obj_t val1183_1752)
{
   AN_OBJECT;
   {	/* Ast/var.scm 38 */
      return
	 local_fast_alpha_set__243_ast_var(
	 (local_bglt) (obj_1751), val1183_1752);
   }
}



/* local-fast-alpha */
obj_t 
local_fast_alpha_65_ast_var(local_bglt obj_180)
{
   AN_OBJECT;
   {	/* Ast/var.scm 38 */
      return
	 (((local_bglt) CREF(obj_180))->fast_alpha_7);
   }
}



/* _local-fast-alpha1865 */
obj_t 
_local_fast_alpha1865_218_ast_var(obj_t env_1753, obj_t obj_1754)
{
   AN_OBJECT;
   {	/* Ast/var.scm 38 */
      return
	 local_fast_alpha_65_ast_var(
	 (local_bglt) (obj_1754));
   }
}



/* local-removable-set! */
obj_t 
local_removable_set__151_ast_var(local_bglt obj_181, obj_t val1184_182)
{
   AN_OBJECT;
   {	/* Ast/var.scm 40 */
      return
	 ((((local_bglt) CREF(obj_181))->removable) = ((obj_t) val1184_182), BUNSPEC);
   }
}



/* _local-removable-set!1866 */
obj_t 
_local_removable_set_1866_226_ast_var(obj_t env_1755, obj_t obj_1756, obj_t val1184_1757)
{
   AN_OBJECT;
   {	/* Ast/var.scm 40 */
      return
	 local_removable_set__151_ast_var(
	 (local_bglt) (obj_1756), val1184_1757);
   }
}



/* local-removable */
obj_t 
local_removable_34_ast_var(local_bglt obj_183)
{
   AN_OBJECT;
   {	/* Ast/var.scm 40 */
      return
	 (((local_bglt) CREF(obj_183))->removable);
   }
}



/* _local-removable1867 */
obj_t 
_local_removable1867_251_ast_var(obj_t env_1758, obj_t obj_1759)
{
   AN_OBJECT;
   {	/* Ast/var.scm 40 */
      return
	 local_removable_34_ast_var(
	 (local_bglt) (obj_1759));
   }
}



/* local-occurrence-set! */
obj_t 
local_occurrence_set__128_ast_var(local_bglt obj_184, long val1185_185)
{
   AN_OBJECT;
   {	/* Ast/var.scm 42 */
      return
	 ((((local_bglt) CREF(obj_184))->occurrence) = ((long) val1185_185), BUNSPEC);
   }
}



/* _local-occurrence-set!1868 */
obj_t 
_local_occurrence_set_1868_56_ast_var(obj_t env_1760, obj_t obj_1761, obj_t val1185_1762)
{
   AN_OBJECT;
   {	/* Ast/var.scm 42 */
      return
	 local_occurrence_set__128_ast_var(
	 (local_bglt) (obj_1761),
	 (long) CINT(val1185_1762));
   }
}



/* local-occurrence */
long 
local_occurrence_5_ast_var(local_bglt obj_186)
{
   AN_OBJECT;
   {	/* Ast/var.scm 42 */
      return
	 (((local_bglt) CREF(obj_186))->occurrence);
   }
}



/* _local-occurrence1869 */
obj_t 
_local_occurrence1869_253_ast_var(obj_t env_1763, obj_t obj_1764)
{
   AN_OBJECT;
   {	/* Ast/var.scm 42 */
      {		/* Ast/var.scm 42 */
	 long aux_2562;
	 aux_2562 =
	    local_occurrence_5_ast_var(
	    (local_bglt) (obj_1764));
	 return
	    BINT(aux_2562);
      }
   }
}



/* local-user?-set! */
obj_t 
local_user__set__89_ast_var(local_bglt obj_187, bool_t val1186_188)
{
   AN_OBJECT;
   {	/* Ast/var.scm 66 */
      return
	 ((((local_bglt) CREF(obj_187))->user__32) = ((bool_t) val1186_188), BUNSPEC);
   }
}



/* _local-user?-set!1870 */
obj_t 
_local_user__set_1870_232_ast_var(obj_t env_1765, obj_t obj_1766, obj_t val1186_1767)
{
   AN_OBJECT;
   {	/* Ast/var.scm 66 */
      return
	 local_user__set__89_ast_var(
	 (local_bglt) (obj_1766),
	 CBOOL(val1186_1767));
   }
}



/* local-user? */
bool_t 
local_user__147_ast_var(local_bglt obj_189)
{
   AN_OBJECT;
   {	/* Ast/var.scm 66 */
      return
	 (((local_bglt) CREF(obj_189))->user__32);
   }
}



/* _local-user?1871 */
obj_t 
_local_user_1871_190_ast_var(obj_t env_1768, obj_t obj_1769)
{
   AN_OBJECT;
   {	/* Ast/var.scm 66 */
      {		/* Ast/var.scm 66 */
	 bool_t aux_2571;
	 aux_2571 =
	    local_user__147_ast_var(
	    (local_bglt) (obj_1769));
	 return
	    BBOOL(aux_2571);
      }
   }
}



/* local-key */
long 
local_key_6_ast_var(local_bglt obj_190)
{
   AN_OBJECT;
   {	/* Ast/var.scm 68 */
      return
	 (((local_bglt) CREF(obj_190))->key);
   }
}



/* _local-key1872 */
obj_t 
_local_key1872_162_ast_var(obj_t env_1770, obj_t obj_1771)
{
   AN_OBJECT;
   {	/* Ast/var.scm 68 */
      {		/* Ast/var.scm 68 */
	 long aux_2576;
	 aux_2576 =
	    local_key_6_ast_var(
	    (local_bglt) (obj_1771));
	 return
	    BINT(aux_2576);
      }
   }
}



/* allocate-global */
global_bglt 
allocate_global_222_ast_var()
{
   AN_OBJECT;
   {	/* Ast/var.scm 44 */
      {		/* Ast/var.scm 44 */
	 global_bglt new1116_480;
	 new1116_480 =
	    ((global_bglt) BREF(GC_MALLOC(sizeof(struct global))));
	 {	/* Ast/var.scm 44 */
	    long arg1610_481;
	    arg1610_481 =
	       class_num_218___object(global_ast_var);
	    {	/* Ast/var.scm 44 */
	       obj_t obj_968;
	       obj_968 =
		  (obj_t) (new1116_480);
	       (((obj_t) CREF(obj_968))->header = MAKE_HEADER(arg1610_481, 0), BUNSPEC);
	    }
	 }
	 {	/* Ast/var.scm 44 */
	    object_bglt aux_2584;
	    aux_2584 =
	       (object_bglt) (new1116_480);
	    OBJECT_WIDENING_SET(aux_2584, BFALSE);
	 }
	 return new1116_480;
      }
   }
}



/* _allocate-global */
obj_t 
_allocate_global_232_ast_var(obj_t env_1502)
{
   AN_OBJECT;
   {	/* Ast/var.scm 44 */
      {		/* Ast/var.scm 44 */
	 global_bglt aux_2587;
	 aux_2587 =
	    allocate_global_222_ast_var();
	 return
	    (obj_t) (aux_2587);
      }
   }
}



/* global? */
bool_t 
global__63_ast_var(obj_t obj_194)
{
   AN_OBJECT;
   {	/* Ast/var.scm 44 */
      return
	 is_a__118___object(obj_194, global_ast_var);
   }
}



/* _global? */
obj_t 
_global__76_ast_var(obj_t env_1772, obj_t obj_1773)
{
   AN_OBJECT;
   {	/* Ast/var.scm 44 */
      {		/* Ast/var.scm 44 */
	 bool_t aux_2591;
	 aux_2591 =
	    global__63_ast_var(obj_1773);
	 return
	    BBOOL(aux_2591);
      }
   }
}



/* make-global */
global_bglt 
make_global_89_ast_var(obj_t id_195, obj_t name_196, type_bglt type_197, value_bglt value_198, obj_t access_199, obj_t fast_alpha_7_200, obj_t removable_201, long occurrence_202, obj_t module_203, obj_t import_204, bool_t evaluable__248_205, bool_t library__255_206, bool_t user__32_207, obj_t pragma_208, obj_t src_209)
{
   AN_OBJECT;
   {	/* Ast/var.scm 44 */
      {		/* Ast/var.scm 44 */
	 global_bglt new1099_970;
	 new1099_970 =
	    ((global_bglt) BREF(GC_MALLOC(sizeof(struct global))));
	 {	/* Ast/var.scm 44 */
	    long arg1611_971;
	    arg1611_971 =
	       class_num_218___object(global_ast_var);
	    {	/* Ast/var.scm 44 */
	       obj_t obj_987;
	       obj_987 =
		  (obj_t) (new1099_970);
	       (((obj_t) CREF(obj_987))->header = MAKE_HEADER(arg1611_971, 0), BUNSPEC);
	    }
	 }
	 {	/* Ast/var.scm 44 */
	    object_bglt aux_2598;
	    aux_2598 =
	       (object_bglt) (new1099_970);
	    OBJECT_WIDENING_SET(aux_2598, BFALSE);
	 }
	 ((((global_bglt) CREF(new1099_970))->id) = ((obj_t) id_195), BUNSPEC);
	 ((((global_bglt) CREF(new1099_970))->name) = ((obj_t) name_196), BUNSPEC);
	 ((((global_bglt) CREF(new1099_970))->type) = ((type_bglt) type_197), BUNSPEC);
	 ((((global_bglt) CREF(new1099_970))->value) = ((value_bglt) value_198), BUNSPEC);
	 ((((global_bglt) CREF(new1099_970))->access) = ((obj_t) access_199), BUNSPEC);
	 ((((global_bglt) CREF(new1099_970))->fast_alpha_7) = ((obj_t) fast_alpha_7_200), BUNSPEC);
	 ((((global_bglt) CREF(new1099_970))->removable) = ((obj_t) removable_201), BUNSPEC);
	 ((((global_bglt) CREF(new1099_970))->occurrence) = ((long) occurrence_202), BUNSPEC);
	 ((((global_bglt) CREF(new1099_970))->module) = ((obj_t) module_203), BUNSPEC);
	 ((((global_bglt) CREF(new1099_970))->import) = ((obj_t) import_204), BUNSPEC);
	 ((((global_bglt) CREF(new1099_970))->evaluable__248) = ((bool_t) evaluable__248_205), BUNSPEC);
	 ((((global_bglt) CREF(new1099_970))->library__255) = ((bool_t) library__255_206), BUNSPEC);
	 ((((global_bglt) CREF(new1099_970))->user__32) = ((bool_t) user__32_207), BUNSPEC);
	 ((((global_bglt) CREF(new1099_970))->pragma) = ((obj_t) pragma_208), BUNSPEC);
	 ((((global_bglt) CREF(new1099_970))->src) = ((obj_t) src_209), BUNSPEC);
	 return new1099_970;
      }
   }
}



/* _make-global1873 */
obj_t 
_make_global1873_93_ast_var(obj_t env_1774, obj_t id_1775, obj_t name_1776, obj_t type_1777, obj_t value_1778, obj_t access_1779, obj_t fast_alpha_7_1780, obj_t removable_1781, obj_t occurrence_1782, obj_t module_1783, obj_t import_1784, obj_t evaluable__248_1785, obj_t library__255_1786, obj_t user__32_1787, obj_t pragma_1788, obj_t src_1789)
{
   AN_OBJECT;
   {	/* Ast/var.scm 44 */
      {		/* Ast/var.scm 44 */
	 global_bglt aux_2616;
	 aux_2616 =
	    make_global_89_ast_var(id_1775, name_1776,
	    (type_bglt) (type_1777),
	    (value_bglt) (value_1778), access_1779, fast_alpha_7_1780, removable_1781,
	    (long) CINT(occurrence_1782), module_1783, import_1784,
	    CBOOL(evaluable__248_1785),
	    CBOOL(library__255_1786),
	    CBOOL(user__32_1787), pragma_1788, src_1789);
	 return
	    (obj_t) (aux_2616);
      }
   }
}



/* global-id */
obj_t 
global_id_179_ast_var(global_bglt obj_210)
{
   AN_OBJECT;
   {	/* Ast/var.scm 23 */
      return
	 (((global_bglt) CREF(obj_210))->id);
   }
}



/* _global-id1874 */
obj_t 
_global_id1874_42_ast_var(obj_t env_1790, obj_t obj_1791)
{
   AN_OBJECT;
   {	/* Ast/var.scm 23 */
      return
	 global_id_179_ast_var(
	 (global_bglt) (obj_1791));
   }
}



/* global-name-set! */
obj_t 
global_name_set__147_ast_var(global_bglt obj_211, obj_t val1087_212)
{
   AN_OBJECT;
   {	/* Ast/var.scm 25 */
      return
	 ((((global_bglt) CREF(obj_211))->name) = ((obj_t) val1087_212), BUNSPEC);
   }
}



/* _global-name-set!1875 */
obj_t 
_global_name_set_1875_244_ast_var(obj_t env_1792, obj_t obj_1793, obj_t val1087_1794)
{
   AN_OBJECT;
   {	/* Ast/var.scm 25 */
      return
	 global_name_set__147_ast_var(
	 (global_bglt) (obj_1793), val1087_1794);
   }
}



/* global-name */
obj_t 
global_name_141_ast_var(global_bglt obj_213)
{
   AN_OBJECT;
   {	/* Ast/var.scm 25 */
      return
	 (((global_bglt) CREF(obj_213))->name);
   }
}



/* _global-name1876 */
obj_t 
_global_name1876_44_ast_var(obj_t env_1795, obj_t obj_1796)
{
   AN_OBJECT;
   {	/* Ast/var.scm 25 */
      return
	 global_name_141_ast_var(
	 (global_bglt) (obj_1796));
   }
}



/* global-type-set! */
obj_t 
global_type_set__109_ast_var(global_bglt obj_214, type_bglt val1088_215)
{
   AN_OBJECT;
   {	/* Ast/var.scm 27 */
      return
	 ((((global_bglt) CREF(obj_214))->type) = ((type_bglt) val1088_215), BUNSPEC);
   }
}



/* _global-type-set!1877 */
obj_t 
_global_type_set_1877_24_ast_var(obj_t env_1797, obj_t obj_1798, obj_t val1088_1799)
{
   AN_OBJECT;
   {	/* Ast/var.scm 27 */
      return
	 global_type_set__109_ast_var(
	 (global_bglt) (obj_1798),
	 (type_bglt) (val1088_1799));
   }
}



/* global-type */
type_bglt 
global_type_243_ast_var(global_bglt obj_216)
{
   AN_OBJECT;
   {	/* Ast/var.scm 27 */
      return
	 (((global_bglt) CREF(obj_216))->type);
   }
}



/* _global-type1878 */
obj_t 
_global_type1878_182_ast_var(obj_t env_1800, obj_t obj_1801)
{
   AN_OBJECT;
   {	/* Ast/var.scm 27 */
      {		/* Ast/var.scm 27 */
	 type_bglt aux_2639;
	 aux_2639 =
	    global_type_243_ast_var(
	    (global_bglt) (obj_1801));
	 return
	    (obj_t) (aux_2639);
      }
   }
}



/* global-value-set! */
obj_t 
global_value_set__118_ast_var(global_bglt obj_217, value_bglt val1089_218)
{
   AN_OBJECT;
   {	/* Ast/var.scm 44 */
      return
	 ((((global_bglt) CREF(obj_217))->value) = ((value_bglt) val1089_218), BUNSPEC);
   }
}



/* _global-value-set!1879 */
obj_t 
_global_value_set_1879_51_ast_var(obj_t env_1802, obj_t obj_1803, obj_t val1089_1804)
{
   AN_OBJECT;
   {	/* Ast/var.scm 44 */
      return
	 global_value_set__118_ast_var(
	 (global_bglt) (obj_1803),
	 (value_bglt) (val1089_1804));
   }
}



/* global-value */
value_bglt 
global_value_241_ast_var(global_bglt obj_219)
{
   AN_OBJECT;
   {	/* Ast/var.scm 44 */
      return
	 (((global_bglt) CREF(obj_219))->value);
   }
}



/* _global-value1880 */
obj_t 
_global_value1880_37_ast_var(obj_t env_1805, obj_t obj_1806)
{
   AN_OBJECT;
   {	/* Ast/var.scm 44 */
      {		/* Ast/var.scm 44 */
	 value_bglt aux_2648;
	 aux_2648 =
	    global_value_241_ast_var(
	    (global_bglt) (obj_1806));
	 return
	    (obj_t) (aux_2648);
      }
   }
}



/* global-access-set! */
obj_t 
global_access_set__188_ast_var(global_bglt obj_220, obj_t val1090_221)
{
   AN_OBJECT;
   {	/* Ast/var.scm 31 */
      return
	 ((((global_bglt) CREF(obj_220))->access) = ((obj_t) val1090_221), BUNSPEC);
   }
}



/* _global-access-set!1881 */
obj_t 
_global_access_set_1881_141_ast_var(obj_t env_1807, obj_t obj_1808, obj_t val1090_1809)
{
   AN_OBJECT;
   {	/* Ast/var.scm 31 */
      return
	 global_access_set__188_ast_var(
	 (global_bglt) (obj_1808), val1090_1809);
   }
}



/* global-access */
obj_t 
global_access_222_ast_var(global_bglt obj_222)
{
   AN_OBJECT;
   {	/* Ast/var.scm 31 */
      return
	 (((global_bglt) CREF(obj_222))->access);
   }
}



/* _global-access1882 */
obj_t 
_global_access1882_14_ast_var(obj_t env_1810, obj_t obj_1811)
{
   AN_OBJECT;
   {	/* Ast/var.scm 31 */
      return
	 global_access_222_ast_var(
	 (global_bglt) (obj_1811));
   }
}



/* global-fast-alpha-set! */
obj_t 
global_fast_alpha_set__101_ast_var(global_bglt obj_223, obj_t val1091_224)
{
   AN_OBJECT;
   {	/* Ast/var.scm 38 */
      return
	 ((((global_bglt) CREF(obj_223))->fast_alpha_7) = ((obj_t) val1091_224), BUNSPEC);
   }
}



/* _global-fast-alpha-set!1883 */
obj_t 
_global_fast_alpha_set_1883_62_ast_var(obj_t env_1812, obj_t obj_1813, obj_t val1091_1814)
{
   AN_OBJECT;
   {	/* Ast/var.scm 38 */
      return
	 global_fast_alpha_set__101_ast_var(
	 (global_bglt) (obj_1813), val1091_1814);
   }
}



/* global-fast-alpha */
obj_t 
global_fast_alpha_242_ast_var(global_bglt obj_225)
{
   AN_OBJECT;
   {	/* Ast/var.scm 38 */
      return
	 (((global_bglt) CREF(obj_225))->fast_alpha_7);
   }
}



/* _global-fast-alpha1884 */
obj_t 
_global_fast_alpha1884_64_ast_var(obj_t env_1815, obj_t obj_1816)
{
   AN_OBJECT;
   {	/* Ast/var.scm 38 */
      return
	 global_fast_alpha_242_ast_var(
	 (global_bglt) (obj_1816));
   }
}



/* global-removable-set! */
obj_t 
global_removable_set__21_ast_var(global_bglt obj_226, obj_t val1092_227)
{
   AN_OBJECT;
   {	/* Ast/var.scm 40 */
      return
	 ((((global_bglt) CREF(obj_226))->removable) = ((obj_t) val1092_227), BUNSPEC);
   }
}



/* _global-removable-set!1885 */
obj_t 
_global_removable_set_1885_172_ast_var(obj_t env_1817, obj_t obj_1818, obj_t val1092_1819)
{
   AN_OBJECT;
   {	/* Ast/var.scm 40 */
      return
	 global_removable_set__21_ast_var(
	 (global_bglt) (obj_1818), val1092_1819);
   }
}



/* global-removable */
obj_t 
global_removable_57_ast_var(global_bglt obj_228)
{
   AN_OBJECT;
   {	/* Ast/var.scm 40 */
      return
	 (((global_bglt) CREF(obj_228))->removable);
   }
}



/* _global-removable1886 */
obj_t 
_global_removable1886_9_ast_var(obj_t env_1820, obj_t obj_1821)
{
   AN_OBJECT;
   {	/* Ast/var.scm 40 */
      return
	 global_removable_57_ast_var(
	 (global_bglt) (obj_1821));
   }
}



/* global-occurrence-set! */
obj_t 
global_occurrence_set__154_ast_var(global_bglt obj_229, long val1093_230)
{
   AN_OBJECT;
   {	/* Ast/var.scm 42 */
      return
	 ((((global_bglt) CREF(obj_229))->occurrence) = ((long) val1093_230), BUNSPEC);
   }
}



/* _global-occurrence-set!1887 */
obj_t 
_global_occurrence_set_1887_244_ast_var(obj_t env_1822, obj_t obj_1823, obj_t val1093_1824)
{
   AN_OBJECT;
   {	/* Ast/var.scm 42 */
      return
	 global_occurrence_set__154_ast_var(
	 (global_bglt) (obj_1823),
	 (long) CINT(val1093_1824));
   }
}



/* global-occurrence */
long 
global_occurrence_96_ast_var(global_bglt obj_231)
{
   AN_OBJECT;
   {	/* Ast/var.scm 42 */
      return
	 (((global_bglt) CREF(obj_231))->occurrence);
   }
}



/* _global-occurrence1888 */
obj_t 
_global_occurrence1888_193_ast_var(obj_t env_1825, obj_t obj_1826)
{
   AN_OBJECT;
   {	/* Ast/var.scm 42 */
      {		/* Ast/var.scm 42 */
	 long aux_2675;
	 aux_2675 =
	    global_occurrence_96_ast_var(
	    (global_bglt) (obj_1826));
	 return
	    BINT(aux_2675);
      }
   }
}



/* global-module */
obj_t 
global_module_203_ast_var(global_bglt obj_232)
{
   AN_OBJECT;
   {	/* Ast/var.scm 46 */
      return
	 (((global_bglt) CREF(obj_232))->module);
   }
}



/* _global-module1889 */
obj_t 
_global_module1889_155_ast_var(obj_t env_1827, obj_t obj_1828)
{
   AN_OBJECT;
   {	/* Ast/var.scm 46 */
      return
	 global_module_203_ast_var(
	 (global_bglt) (obj_1828));
   }
}



/* global-import-set! */
obj_t 
global_import_set__22_ast_var(global_bglt obj_233, obj_t val1094_234)
{
   AN_OBJECT;
   {	/* Ast/var.scm 48 */
      return
	 ((((global_bglt) CREF(obj_233))->import) = ((obj_t) val1094_234), BUNSPEC);
   }
}



/* _global-import-set!1890 */
obj_t 
_global_import_set_1890_147_ast_var(obj_t env_1829, obj_t obj_1830, obj_t val1094_1831)
{
   AN_OBJECT;
   {	/* Ast/var.scm 48 */
      return
	 global_import_set__22_ast_var(
	 (global_bglt) (obj_1830), val1094_1831);
   }
}



/* global-import */
obj_t 
global_import_37_ast_var(global_bglt obj_235)
{
   AN_OBJECT;
   {	/* Ast/var.scm 48 */
      return
	 (((global_bglt) CREF(obj_235))->import);
   }
}



/* _global-import1891 */
obj_t 
_global_import1891_46_ast_var(obj_t env_1832, obj_t obj_1833)
{
   AN_OBJECT;
   {	/* Ast/var.scm 48 */
      return
	 global_import_37_ast_var(
	 (global_bglt) (obj_1833));
   }
}



/* global-evaluable?-set! */
obj_t 
global_evaluable__set__201_ast_var(global_bglt obj_236, bool_t val1095_237)
{
   AN_OBJECT;
   {	/* Ast/var.scm 51 */
      return
	 ((((global_bglt) CREF(obj_236))->evaluable__248) = ((bool_t) val1095_237), BUNSPEC);
   }
}



/* _global-evaluable?-set!1892 */
obj_t 
_global_evaluable__set_1892_147_ast_var(obj_t env_1834, obj_t obj_1835, obj_t val1095_1836)
{
   AN_OBJECT;
   {	/* Ast/var.scm 51 */
      return
	 global_evaluable__set__201_ast_var(
	 (global_bglt) (obj_1835),
	 CBOOL(val1095_1836));
   }
}



/* global-evaluable? */
bool_t 
global_evaluable__170_ast_var(global_bglt obj_238)
{
   AN_OBJECT;
   {	/* Ast/var.scm 51 */
      return
	 (((global_bglt) CREF(obj_238))->evaluable__248);
   }
}



/* _global-evaluable?1893 */
obj_t 
_global_evaluable_1893_132_ast_var(obj_t env_1837, obj_t obj_1838)
{
   AN_OBJECT;
   {	/* Ast/var.scm 51 */
      {		/* Ast/var.scm 51 */
	 bool_t aux_2693;
	 aux_2693 =
	    global_evaluable__170_ast_var(
	    (global_bglt) (obj_1838));
	 return
	    BBOOL(aux_2693);
      }
   }
}



/* global-library?-set! */
obj_t 
global_library__set__213_ast_var(global_bglt obj_239, bool_t val1096_240)
{
   AN_OBJECT;
   {	/* Ast/var.scm 53 */
      return
	 ((((global_bglt) CREF(obj_239))->library__255) = ((bool_t) val1096_240), BUNSPEC);
   }
}



/* _global-library?-set!1894 */
obj_t 
_global_library__set_1894_129_ast_var(obj_t env_1839, obj_t obj_1840, obj_t val1096_1841)
{
   AN_OBJECT;
   {	/* Ast/var.scm 53 */
      return
	 global_library__set__213_ast_var(
	 (global_bglt) (obj_1840),
	 CBOOL(val1096_1841));
   }
}



/* global-library? */
bool_t 
global_library__62_ast_var(global_bglt obj_241)
{
   AN_OBJECT;
   {	/* Ast/var.scm 53 */
      return
	 (((global_bglt) CREF(obj_241))->library__255);
   }
}



/* _global-library?1895 */
obj_t 
_global_library_1895_187_ast_var(obj_t env_1842, obj_t obj_1843)
{
   AN_OBJECT;
   {	/* Ast/var.scm 53 */
      {		/* Ast/var.scm 53 */
	 bool_t aux_2702;
	 aux_2702 =
	    global_library__62_ast_var(
	    (global_bglt) (obj_1843));
	 return
	    BBOOL(aux_2702);
      }
   }
}



/* global-user?-set! */
obj_t 
global_user__set__116_ast_var(global_bglt obj_242, bool_t val1097_243)
{
   AN_OBJECT;
   {	/* Ast/var.scm 58 */
      return
	 ((((global_bglt) CREF(obj_242))->user__32) = ((bool_t) val1097_243), BUNSPEC);
   }
}



/* _global-user?-set!1896 */
obj_t 
_global_user__set_1896_171_ast_var(obj_t env_1844, obj_t obj_1845, obj_t val1097_1846)
{
   AN_OBJECT;
   {	/* Ast/var.scm 58 */
      return
	 global_user__set__116_ast_var(
	 (global_bglt) (obj_1845),
	 CBOOL(val1097_1846));
   }
}



/* global-user? */
bool_t 
global_user__208_ast_var(global_bglt obj_244)
{
   AN_OBJECT;
   {	/* Ast/var.scm 58 */
      return
	 (((global_bglt) CREF(obj_244))->user__32);
   }
}



/* _global-user?1897 */
obj_t 
_global_user_1897_27_ast_var(obj_t env_1847, obj_t obj_1848)
{
   AN_OBJECT;
   {	/* Ast/var.scm 58 */
      {		/* Ast/var.scm 58 */
	 bool_t aux_2711;
	 aux_2711 =
	    global_user__208_ast_var(
	    (global_bglt) (obj_1848));
	 return
	    BBOOL(aux_2711);
      }
   }
}



/* global-pragma */
obj_t 
global_pragma_105_ast_var(global_bglt obj_245)
{
   AN_OBJECT;
   {	/* Ast/var.scm 60 */
      return
	 (((global_bglt) CREF(obj_245))->pragma);
   }
}



/* _global-pragma1898 */
obj_t 
_global_pragma1898_160_ast_var(obj_t env_1849, obj_t obj_1850)
{
   AN_OBJECT;
   {	/* Ast/var.scm 60 */
      return
	 global_pragma_105_ast_var(
	 (global_bglt) (obj_1850));
   }
}



/* global-src-set! */
obj_t 
global_src_set__223_ast_var(global_bglt obj_246, obj_t val1098_247)
{
   AN_OBJECT;
   {	/* Ast/var.scm 44 */
      return
	 ((((global_bglt) CREF(obj_246))->src) = ((obj_t) val1098_247), BUNSPEC);
   }
}



/* _global-src-set!1899 */
obj_t 
_global_src_set_1899_103_ast_var(obj_t env_1851, obj_t obj_1852, obj_t val1098_1853)
{
   AN_OBJECT;
   {	/* Ast/var.scm 44 */
      return
	 global_src_set__223_ast_var(
	 (global_bglt) (obj_1852), val1098_1853);
   }
}



/* global-src */
obj_t 
global_src_229_ast_var(global_bglt obj_248)
{
   AN_OBJECT;
   {	/* Ast/var.scm 44 */
      return
	 (((global_bglt) CREF(obj_248))->src);
   }
}



/* _global-src1900 */
obj_t 
_global_src1900_53_ast_var(obj_t env_1854, obj_t obj_1855)
{
   AN_OBJECT;
   {	/* Ast/var.scm 44 */
      return
	 global_src_229_ast_var(
	 (global_bglt) (obj_1855));
   }
}



/* allocate-variable */
variable_bglt 
allocate_variable_244_ast_var()
{
   AN_OBJECT;
   {	/* Ast/var.scm 21 */
      {		/* Ast/var.scm 21 */
	 variable_bglt new1052_499;
	 new1052_499 =
	    ((variable_bglt) BREF(GC_MALLOC(sizeof(struct variable))));
	 {	/* Ast/var.scm 21 */
	    long arg1612_500;
	    arg1612_500 =
	       class_num_218___object(variable_ast_var);
	    {	/* Ast/var.scm 21 */
	       obj_t obj_989;
	       obj_989 =
		  (obj_t) (new1052_499);
	       (((obj_t) CREF(obj_989))->header = MAKE_HEADER(arg1612_500, 0), BUNSPEC);
	    }
	 }
	 {	/* Ast/var.scm 21 */
	    object_bglt aux_2728;
	    aux_2728 =
	       (object_bglt) (new1052_499);
	    OBJECT_WIDENING_SET(aux_2728, BFALSE);
	 }
	 return new1052_499;
      }
   }
}



/* _allocate-variable */
obj_t 
_allocate_variable_137_ast_var(obj_t env_1501)
{
   AN_OBJECT;
   {	/* Ast/var.scm 21 */
      {		/* Ast/var.scm 21 */
	 variable_bglt aux_2731;
	 aux_2731 =
	    allocate_variable_244_ast_var();
	 return
	    (obj_t) (aux_2731);
      }
   }
}



/* variable? */
bool_t 
variable__18_ast_var(obj_t obj_252)
{
   AN_OBJECT;
   {	/* Ast/var.scm 21 */
      return
	 is_a__118___object(obj_252, variable_ast_var);
   }
}



/* _variable? */
obj_t 
_variable__238_ast_var(obj_t env_1856, obj_t obj_1857)
{
   AN_OBJECT;
   {	/* Ast/var.scm 21 */
      {		/* Ast/var.scm 21 */
	 bool_t aux_2735;
	 aux_2735 =
	    variable__18_ast_var(obj_1857);
	 return
	    BBOOL(aux_2735);
      }
   }
}



/* make-variable */
variable_bglt 
make_variable_6_ast_var(obj_t id_253, obj_t name_254, type_bglt type_255, value_bglt value_256, obj_t access_257, obj_t fast_alpha_7_258, obj_t removable_259, long occurrence_260)
{
   AN_OBJECT;
   {	/* Ast/var.scm 21 */
      {		/* Ast/var.scm 21 */
	 variable_bglt new1042_991;
	 new1042_991 =
	    ((variable_bglt) BREF(GC_MALLOC(sizeof(struct variable))));
	 {	/* Ast/var.scm 21 */
	    long arg1613_992;
	    arg1613_992 =
	       class_num_218___object(variable_ast_var);
	    {	/* Ast/var.scm 21 */
	       obj_t obj_1001;
	       obj_1001 =
		  (obj_t) (new1042_991);
	       (((obj_t) CREF(obj_1001))->header = MAKE_HEADER(arg1613_992, 0), BUNSPEC);
	    }
	 }
	 {	/* Ast/var.scm 21 */
	    object_bglt aux_2742;
	    aux_2742 =
	       (object_bglt) (new1042_991);
	    OBJECT_WIDENING_SET(aux_2742, BFALSE);
	 }
	 ((((variable_bglt) CREF(new1042_991))->id) = ((obj_t) id_253), BUNSPEC);
	 ((((variable_bglt) CREF(new1042_991))->name) = ((obj_t) name_254), BUNSPEC);
	 ((((variable_bglt) CREF(new1042_991))->type) = ((type_bglt) type_255), BUNSPEC);
	 ((((variable_bglt) CREF(new1042_991))->value) = ((value_bglt) value_256), BUNSPEC);
	 ((((variable_bglt) CREF(new1042_991))->access) = ((obj_t) access_257), BUNSPEC);
	 ((((variable_bglt) CREF(new1042_991))->fast_alpha_7) = ((obj_t) fast_alpha_7_258), BUNSPEC);
	 ((((variable_bglt) CREF(new1042_991))->removable) = ((obj_t) removable_259), BUNSPEC);
	 ((((variable_bglt) CREF(new1042_991))->occurrence) = ((long) occurrence_260), BUNSPEC);
	 return new1042_991;
      }
   }
}



/* _make-variable1901 */
obj_t 
_make_variable1901_144_ast_var(obj_t env_1858, obj_t id_1859, obj_t name_1860, obj_t type_1861, obj_t value_1862, obj_t access_1863, obj_t fast_alpha_7_1864, obj_t removable_1865, obj_t occurrence_1866)
{
   AN_OBJECT;
   {	/* Ast/var.scm 21 */
      {		/* Ast/var.scm 21 */
	 variable_bglt aux_2753;
	 aux_2753 =
	    make_variable_6_ast_var(id_1859, name_1860,
	    (type_bglt) (type_1861),
	    (value_bglt) (value_1862), access_1863, fast_alpha_7_1864, removable_1865,
	    (long) CINT(occurrence_1866));
	 return
	    (obj_t) (aux_2753);
      }
   }
}



/* variable-id */
obj_t 
variable_id_167_ast_var(variable_bglt obj_261)
{
   AN_OBJECT;
   {	/* Ast/var.scm 23 */
      return
	 (((variable_bglt) CREF(obj_261))->id);
   }
}



/* _variable-id1902 */
obj_t 
_variable_id1902_222_ast_var(obj_t env_1867, obj_t obj_1868)
{
   AN_OBJECT;
   {	/* Ast/var.scm 23 */
      return
	 variable_id_167_ast_var(
	 (variable_bglt) (obj_1868));
   }
}



/* variable-name-set! */
obj_t 
variable_name_set__44_ast_var(variable_bglt obj_262, obj_t val1035_263)
{
   AN_OBJECT;
   {	/* Ast/var.scm 25 */
      return
	 ((((variable_bglt) CREF(obj_262))->name) = ((obj_t) val1035_263), BUNSPEC);
   }
}



/* _variable-name-set!1903 */
obj_t 
_variable_name_set_1903_207_ast_var(obj_t env_1869, obj_t obj_1870, obj_t val1035_1871)
{
   AN_OBJECT;
   {	/* Ast/var.scm 25 */
      return
	 variable_name_set__44_ast_var(
	 (variable_bglt) (obj_1870), val1035_1871);
   }
}



/* variable-name */
obj_t 
variable_name_105_ast_var(variable_bglt obj_264)
{
   AN_OBJECT;
   {	/* Ast/var.scm 25 */
      return
	 (((variable_bglt) CREF(obj_264))->name);
   }
}



/* _variable-name1904 */
obj_t 
_variable_name1904_47_ast_var(obj_t env_1872, obj_t obj_1873)
{
   AN_OBJECT;
   {	/* Ast/var.scm 25 */
      return
	 variable_name_105_ast_var(
	 (variable_bglt) (obj_1873));
   }
}



/* variable-type-set! */
obj_t 
variable_type_set__4_ast_var(variable_bglt obj_265, type_bglt val1036_266)
{
   AN_OBJECT;
   {	/* Ast/var.scm 27 */
      return
	 ((((variable_bglt) CREF(obj_265))->type) = ((type_bglt) val1036_266), BUNSPEC);
   }
}



/* _variable-type-set!1905 */
obj_t 
_variable_type_set_1905_230_ast_var(obj_t env_1874, obj_t obj_1875, obj_t val1036_1876)
{
   AN_OBJECT;
   {	/* Ast/var.scm 27 */
      return
	 variable_type_set__4_ast_var(
	 (variable_bglt) (obj_1875),
	 (type_bglt) (val1036_1876));
   }
}



/* variable-type */
type_bglt 
variable_type_237_ast_var(variable_bglt obj_267)
{
   AN_OBJECT;
   {	/* Ast/var.scm 27 */
      return
	 (((variable_bglt) CREF(obj_267))->type);
   }
}



/* _variable-type1906 */
obj_t 
_variable_type1906_56_ast_var(obj_t env_1877, obj_t obj_1878)
{
   AN_OBJECT;
   {	/* Ast/var.scm 27 */
      {		/* Ast/var.scm 27 */
	 type_bglt aux_2773;
	 aux_2773 =
	    variable_type_237_ast_var(
	    (variable_bglt) (obj_1878));
	 return
	    (obj_t) (aux_2773);
      }
   }
}



/* variable-value-set! */
obj_t 
variable_value_set__250_ast_var(variable_bglt obj_268, value_bglt val1037_269)
{
   AN_OBJECT;
   {	/* Ast/var.scm 21 */
      return
	 ((((variable_bglt) CREF(obj_268))->value) = ((value_bglt) val1037_269), BUNSPEC);
   }
}



/* _variable-value-set!1907 */
obj_t 
_variable_value_set_1907_20_ast_var(obj_t env_1879, obj_t obj_1880, obj_t val1037_1881)
{
   AN_OBJECT;
   {	/* Ast/var.scm 21 */
      return
	 variable_value_set__250_ast_var(
	 (variable_bglt) (obj_1880),
	 (value_bglt) (val1037_1881));
   }
}



/* variable-value */
value_bglt 
variable_value_212_ast_var(variable_bglt obj_270)
{
   AN_OBJECT;
   {	/* Ast/var.scm 21 */
      return
	 (((variable_bglt) CREF(obj_270))->value);
   }
}



/* _variable-value1908 */
obj_t 
_variable_value1908_100_ast_var(obj_t env_1882, obj_t obj_1883)
{
   AN_OBJECT;
   {	/* Ast/var.scm 21 */
      {		/* Ast/var.scm 21 */
	 value_bglt aux_2782;
	 aux_2782 =
	    variable_value_212_ast_var(
	    (variable_bglt) (obj_1883));
	 return
	    (obj_t) (aux_2782);
      }
   }
}



/* variable-access-set! */
obj_t 
variable_access_set__102_ast_var(variable_bglt obj_271, obj_t val1038_272)
{
   AN_OBJECT;
   {	/* Ast/var.scm 31 */
      return
	 ((((variable_bglt) CREF(obj_271))->access) = ((obj_t) val1038_272), BUNSPEC);
   }
}



/* _variable-access-set!1909 */
obj_t 
_variable_access_set_1909_13_ast_var(obj_t env_1884, obj_t obj_1885, obj_t val1038_1886)
{
   AN_OBJECT;
   {	/* Ast/var.scm 31 */
      return
	 variable_access_set__102_ast_var(
	 (variable_bglt) (obj_1885), val1038_1886);
   }
}



/* variable-access */
obj_t 
variable_access_211_ast_var(variable_bglt obj_273)
{
   AN_OBJECT;
   {	/* Ast/var.scm 31 */
      return
	 (((variable_bglt) CREF(obj_273))->access);
   }
}



/* _variable-access1910 */
obj_t 
_variable_access1910_167_ast_var(obj_t env_1887, obj_t obj_1888)
{
   AN_OBJECT;
   {	/* Ast/var.scm 31 */
      return
	 variable_access_211_ast_var(
	 (variable_bglt) (obj_1888));
   }
}



/* variable-fast-alpha-set! */
obj_t 
variable_fast_alpha_set__48_ast_var(variable_bglt obj_274, obj_t val1039_275)
{
   AN_OBJECT;
   {	/* Ast/var.scm 38 */
      return
	 ((((variable_bglt) CREF(obj_274))->fast_alpha_7) = ((obj_t) val1039_275), BUNSPEC);
   }
}



/* _variable-fast-alpha-set!1911 */
obj_t 
_variable_fast_alpha_set_1911_129_ast_var(obj_t env_1889, obj_t obj_1890, obj_t val1039_1891)
{
   AN_OBJECT;
   {	/* Ast/var.scm 38 */
      return
	 variable_fast_alpha_set__48_ast_var(
	 (variable_bglt) (obj_1890), val1039_1891);
   }
}



/* variable-fast-alpha */
obj_t 
variable_fast_alpha_132_ast_var(variable_bglt obj_276)
{
   AN_OBJECT;
   {	/* Ast/var.scm 38 */
      return
	 (((variable_bglt) CREF(obj_276))->fast_alpha_7);
   }
}



/* _variable-fast-alpha1912 */
obj_t 
_variable_fast_alpha1912_15_ast_var(obj_t env_1892, obj_t obj_1893)
{
   AN_OBJECT;
   {	/* Ast/var.scm 38 */
      return
	 variable_fast_alpha_132_ast_var(
	 (variable_bglt) (obj_1893));
   }
}



/* variable-removable-set! */
obj_t 
variable_removable_set__218_ast_var(variable_bglt obj_277, obj_t val1040_278)
{
   AN_OBJECT;
   {	/* Ast/var.scm 40 */
      return
	 ((((variable_bglt) CREF(obj_277))->removable) = ((obj_t) val1040_278), BUNSPEC);
   }
}



/* _variable-removable-set!1913 */
obj_t 
_variable_removable_set_1913_123_ast_var(obj_t env_1894, obj_t obj_1895, obj_t val1040_1896)
{
   AN_OBJECT;
   {	/* Ast/var.scm 40 */
      return
	 variable_removable_set__218_ast_var(
	 (variable_bglt) (obj_1895), val1040_1896);
   }
}



/* variable-removable */
obj_t 
variable_removable_74_ast_var(variable_bglt obj_279)
{
   AN_OBJECT;
   {	/* Ast/var.scm 40 */
      return
	 (((variable_bglt) CREF(obj_279))->removable);
   }
}



/* _variable-removable1914 */
obj_t 
_variable_removable1914_41_ast_var(obj_t env_1897, obj_t obj_1898)
{
   AN_OBJECT;
   {	/* Ast/var.scm 40 */
      return
	 variable_removable_74_ast_var(
	 (variable_bglt) (obj_1898));
   }
}



/* variable-occurrence-set! */
obj_t 
variable_occurrence_set__234_ast_var(variable_bglt obj_280, long val1041_281)
{
   AN_OBJECT;
   {	/* Ast/var.scm 42 */
      return
	 ((((variable_bglt) CREF(obj_280))->occurrence) = ((long) val1041_281), BUNSPEC);
   }
}



/* _variable-occurrence-set!1915 */
obj_t 
_variable_occurrence_set_1915_49_ast_var(obj_t env_1899, obj_t obj_1900, obj_t val1041_1901)
{
   AN_OBJECT;
   {	/* Ast/var.scm 42 */
      return
	 variable_occurrence_set__234_ast_var(
	 (variable_bglt) (obj_1900),
	 (long) CINT(val1041_1901));
   }
}



/* variable-occurrence */
long 
variable_occurrence_246_ast_var(variable_bglt obj_282)
{
   AN_OBJECT;
   {	/* Ast/var.scm 42 */
      return
	 (((variable_bglt) CREF(obj_282))->occurrence);
   }
}



/* _variable-occurrence1916 */
obj_t 
_variable_occurrence1916_131_ast_var(obj_t env_1902, obj_t obj_1903)
{
   AN_OBJECT;
   {	/* Ast/var.scm 42 */
      {		/* Ast/var.scm 42 */
	 long aux_2809;
	 aux_2809 =
	    variable_occurrence_246_ast_var(
	    (variable_bglt) (obj_1903));
	 return
	    BINT(aux_2809);
      }
   }
}



/* allocate-value */
value_bglt 
allocate_value_190_ast_var()
{
   AN_OBJECT;
   {	/* Ast/var.scm 19 */
      {		/* Ast/var.scm 19 */
	 value_bglt new1032_511;
	 new1032_511 =
	    ((value_bglt) BREF(GC_MALLOC(sizeof(struct value))));
	 {	/* Ast/var.scm 19 */
	    long arg1614_512;
	    arg1614_512 =
	       class_num_218___object(value_ast_var);
	    {	/* Ast/var.scm 19 */
	       obj_t obj_1003;
	       obj_1003 =
		  (obj_t) (new1032_511);
	       (((obj_t) CREF(obj_1003))->header = MAKE_HEADER(arg1614_512, 0), BUNSPEC);
	    }
	 }
	 {	/* Ast/var.scm 19 */
	    object_bglt aux_2817;
	    aux_2817 =
	       (object_bglt) (new1032_511);
	    OBJECT_WIDENING_SET(aux_2817, BFALSE);
	 }
	 return new1032_511;
      }
   }
}



/* _allocate-value */
obj_t 
_allocate_value_13_ast_var(obj_t env_1500)
{
   AN_OBJECT;
   {	/* Ast/var.scm 19 */
      {		/* Ast/var.scm 19 */
	 value_bglt aux_2820;
	 aux_2820 =
	    allocate_value_190_ast_var();
	 return
	    (obj_t) (aux_2820);
      }
   }
}



/* value? */
bool_t 
value__43_ast_var(obj_t obj_286)
{
   AN_OBJECT;
   {	/* Ast/var.scm 19 */
      return
	 is_a__118___object(obj_286, value_ast_var);
   }
}



/* _value? */
obj_t 
_value__210_ast_var(obj_t env_1904, obj_t obj_1905)
{
   AN_OBJECT;
   {	/* Ast/var.scm 19 */
      {		/* Ast/var.scm 19 */
	 bool_t aux_2824;
	 aux_2824 =
	    value__43_ast_var(obj_1905);
	 return
	    BBOOL(aux_2824);
      }
   }
}



/* make-value */
value_bglt 
make_value_52_ast_var()
{
   AN_OBJECT;
   {	/* Ast/var.scm 19 */
      {		/* Ast/var.scm 19 */
	 value_bglt new1030_1005;
	 new1030_1005 =
	    ((value_bglt) BREF(GC_MALLOC(sizeof(struct value))));
	 {	/* Ast/var.scm 19 */
	    long arg1615_1006;
	    arg1615_1006 =
	       class_num_218___object(value_ast_var);
	    {	/* Ast/var.scm 19 */
	       obj_t obj_1007;
	       obj_1007 =
		  (obj_t) (new1030_1005);
	       (((obj_t) CREF(obj_1007))->header = MAKE_HEADER(arg1615_1006, 0), BUNSPEC);
	    }
	 }
	 {	/* Ast/var.scm 19 */
	    object_bglt aux_2831;
	    aux_2831 =
	       (object_bglt) (new1030_1005);
	    OBJECT_WIDENING_SET(aux_2831, BFALSE);
	 }
	 {	/* Ast/var.scm 19 */

	    return new1030_1005;
	 }
      }
   }
}



/* _make-value */
obj_t 
_make_value_202_ast_var(obj_t env_1906)
{
   AN_OBJECT;
   {	/* Ast/var.scm 19 */
      {		/* Ast/var.scm 19 */
	 value_bglt aux_2834;
	 aux_2834 =
	    make_value_52_ast_var();
	 return
	    (obj_t) (aux_2834);
      }
   }
}



/* method-init */
obj_t 
method_init_76_ast_var()
{
   AN_OBJECT;
   {	/* Ast/var.scm 14 */
      {		/* Ast/var.scm 14 */
	 obj_t object__struct_sexit1488_225_1928;
	 object__struct_sexit1488_225_1928 = proc1920_ast_var;
	 add_method__1___object(object__struct_env_210___object, sexit_ast_var, object__struct_sexit1488_225_1928);
      }
      {		/* Ast/var.scm 14 */
	 obj_t struct_object__object_sexit1490_65_1927;
	 struct_object__object_sexit1490_65_1927 = proc1921_ast_var;
	 add_method__1___object(struct_object__object_env_209___object, sexit_ast_var, struct_object__object_sexit1490_65_1927);
      }
      {		/* Ast/var.scm 14 */
	 obj_t object__struct_cvar1492_35_1926;
	 object__struct_cvar1492_35_1926 = proc1922_ast_var;
	 add_method__1___object(object__struct_env_210___object, cvar_ast_var, object__struct_cvar1492_35_1926);
      }
      {		/* Ast/var.scm 14 */
	 obj_t struct_object__object_cvar1494_104_1925;
	 struct_object__object_cvar1494_104_1925 = proc1923_ast_var;
	 add_method__1___object(struct_object__object_env_209___object, cvar_ast_var, struct_object__object_cvar1494_104_1925);
      }
      {		/* Ast/var.scm 14 */
	 obj_t object__struct_scnst1496_159_1924;
	 object__struct_scnst1496_159_1924 = proc1924_ast_var;
	 add_method__1___object(object__struct_env_210___object, scnst_ast_var, object__struct_scnst1496_159_1924);
      }
      {		/* Ast/var.scm 14 */
	 obj_t struct_object__object_scnst1498_133_1923;
	 struct_object__object_scnst1498_133_1923 = proc1925_ast_var;
	 add_method__1___object(struct_object__object_env_209___object, scnst_ast_var, struct_object__object_scnst1498_133_1923);
      }
      {		/* Ast/var.scm 14 */
	 obj_t object__struct_svar1500_98_1922;
	 object__struct_svar1500_98_1922 = proc1926_ast_var;
	 add_method__1___object(object__struct_env_210___object, svar_ast_var, object__struct_svar1500_98_1922);
      }
      {		/* Ast/var.scm 14 */
	 obj_t struct_object__object_svar1502_167_1921;
	 struct_object__object_svar1502_167_1921 = proc1927_ast_var;
	 add_method__1___object(struct_object__object_env_209___object, svar_ast_var, struct_object__object_svar1502_167_1921);
      }
      {		/* Ast/var.scm 14 */
	 obj_t object__struct_cfun1504_204_1920;
	 object__struct_cfun1504_204_1920 = proc1928_ast_var;
	 add_method__1___object(object__struct_env_210___object, cfun_ast_var, object__struct_cfun1504_204_1920);
      }
      {		/* Ast/var.scm 14 */
	 obj_t struct_object__object_cfun1506_45_1919;
	 struct_object__object_cfun1506_45_1919 = proc1929_ast_var;
	 add_method__1___object(struct_object__object_env_209___object, cfun_ast_var, struct_object__object_cfun1506_45_1919);
      }
      {		/* Ast/var.scm 14 */
	 obj_t object__struct_sfun1508_100_1918;
	 object__struct_sfun1508_100_1918 = proc1930_ast_var;
	 add_method__1___object(object__struct_env_210___object, sfun_ast_var, object__struct_sfun1508_100_1918);
      }
      {		/* Ast/var.scm 14 */
	 obj_t struct_object__object_sfun1510_23_1917;
	 struct_object__object_sfun1510_23_1917 = proc1931_ast_var;
	 add_method__1___object(struct_object__object_env_209___object, sfun_ast_var, struct_object__object_sfun1510_23_1917);
      }
      {		/* Ast/var.scm 14 */
	 obj_t object__struct_fun1512_56_1916;
	 object__struct_fun1512_56_1916 = proc1932_ast_var;
	 add_method__1___object(object__struct_env_210___object, fun_ast_var, object__struct_fun1512_56_1916);
      }
      {		/* Ast/var.scm 14 */
	 obj_t struct_object__object_fun1514_86_1915;
	 struct_object__object_fun1514_86_1915 = proc1933_ast_var;
	 add_method__1___object(struct_object__object_env_209___object, fun_ast_var, struct_object__object_fun1514_86_1915);
      }
      {		/* Ast/var.scm 14 */
	 obj_t object__struct_local1516_246_1914;
	 object__struct_local1516_246_1914 = proc1934_ast_var;
	 add_method__1___object(object__struct_env_210___object, local_ast_var, object__struct_local1516_246_1914);
      }
      {		/* Ast/var.scm 14 */
	 obj_t struct_object__object_local1518_37_1913;
	 struct_object__object_local1518_37_1913 = proc1935_ast_var;
	 add_method__1___object(struct_object__object_env_209___object, local_ast_var, struct_object__object_local1518_37_1913);
      }
      {		/* Ast/var.scm 14 */
	 obj_t object__struct_global1521_59_1912;
	 object__struct_global1521_59_1912 = proc1936_ast_var;
	 add_method__1___object(object__struct_env_210___object, global_ast_var, object__struct_global1521_59_1912);
      }
      {		/* Ast/var.scm 14 */
	 obj_t struct_object__object_global1523_249_1911;
	 struct_object__object_global1523_249_1911 = proc1937_ast_var;
	 add_method__1___object(struct_object__object_env_209___object, global_ast_var, struct_object__object_global1523_249_1911);
      }
      {		/* Ast/var.scm 14 */
	 obj_t object__struct_variable1525_164_1910;
	 object__struct_variable1525_164_1910 = proc1938_ast_var;
	 add_method__1___object(object__struct_env_210___object, variable_ast_var, object__struct_variable1525_164_1910);
      }
      {		/* Ast/var.scm 14 */
	 obj_t struct_object__object_variable1527_182_1909;
	 struct_object__object_variable1527_182_1909 = proc1939_ast_var;
	 add_method__1___object(struct_object__object_env_209___object, variable_ast_var, struct_object__object_variable1527_182_1909);
      }
      {		/* Ast/var.scm 14 */
	 obj_t object__struct_value1529_106_1908;
	 object__struct_value1529_106_1908 = proc1940_ast_var;
	 add_method__1___object(object__struct_env_210___object, value_ast_var, object__struct_value1529_106_1908);
      }
      {		/* Ast/var.scm 14 */
	 obj_t struct_object__object_value1531_175_1907;
	 struct_object__object_value1531_175_1907 = proc1941_ast_var;
	 return
	    add_method__1___object(struct_object__object_env_209___object, value_ast_var, struct_object__object_value1531_175_1907);
      }
   }
}



/* struct+object->object-value1531 */
obj_t 
struct_object__object_value1531_175_ast_var(obj_t env_1929, obj_t o_1930, obj_t s_1931)
{
   AN_OBJECT;
   {	/* Ast/var.scm 19 */
      {
	 value_bglt o_869;
	 obj_t s_870;
	 {	/* Ast/var.scm 19 */
	    value_bglt aux_2859;
	    o_869 =
	       (value_bglt) (o_1930);
	    s_870 = s_1931;
	    {	/* Ast/var.scm 19 */
	       obj_t aux_2862;
	       object_bglt aux_2860;
	       aux_2862 =
		  STRUCT_REF(s_870, ((long) 0));
	       aux_2860 =
		  (object_bglt) (o_869);
	       OBJECT_WIDENING_SET(aux_2860, aux_2862);
	    }
	    aux_2859 = o_869;
	    return
	       (obj_t) (aux_2859);
	 }
      }
   }
}



/* object->struct-value1529 */
obj_t 
object__struct_value1529_106_ast_var(obj_t env_1932, obj_t obj1033_1933)
{
   AN_OBJECT;
   {	/* Ast/var.scm 19 */
      {
	 value_bglt obj1033_863;
	 obj1033_863 =
	    (value_bglt) (obj1033_1933);
	 {	/* Ast/var.scm 19 */
	    obj_t res1034_866;
	    {	/* ./Llib/struct.scm 1415 */
	       obj_t aux_2867;
	       aux_2867 =
		  CNST_TABLE_REF(((long) 0));
	       res1034_866 =
		  make_struct(aux_2867, ((long) 1), BUNSPEC);
	    }
	    STRUCT_SET(res1034_866, ((long) 0), BFALSE);
	    return res1034_866;
	 }
      }
   }
}



/* struct+object->object-variable1527 */
obj_t 
struct_object__object_variable1527_182_ast_var(obj_t env_1934, obj_t o_1935, obj_t s_1936)
{
   AN_OBJECT;
   {	/* Ast/var.scm 21 */
      {
	 variable_bglt o_848;
	 obj_t s_849;
	 {	/* Ast/var.scm 21 */
	    variable_bglt aux_2872;
	    o_848 =
	       (variable_bglt) (o_1935);
	    s_849 = s_1936;
	    {	/* Ast/var.scm 21 */
	       obj_t aux_2875;
	       object_bglt aux_2873;
	       aux_2875 =
		  STRUCT_REF(s_849, ((long) 0));
	       aux_2873 =
		  (object_bglt) (o_848);
	       OBJECT_WIDENING_SET(aux_2873, aux_2875);
	    }
	    {	/* Ast/var.scm 21 */
	       obj_t v1057_853;
	       v1057_853 =
		  STRUCT_REF(s_849, ((long) 1));
	       ((((variable_bglt) CREF(o_848))->id) = ((obj_t) v1057_853), BUNSPEC);
	    }
	    {	/* Ast/var.scm 21 */
	       obj_t v1061_854;
	       v1061_854 =
		  STRUCT_REF(s_849, ((long) 2));
	       ((((variable_bglt) CREF(o_848))->name) = ((obj_t) v1061_854), BUNSPEC);
	    }
	    {	/* Ast/var.scm 21 */
	       type_bglt v1065_855;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_2882;
		  aux_2882 =
		     STRUCT_REF(s_849, ((long) 3));
		  v1065_855 =
		     (type_bglt) (aux_2882);
	       }
	       ((((variable_bglt) CREF(o_848))->type) = ((type_bglt) v1065_855), BUNSPEC);
	    }
	    {	/* Ast/var.scm 21 */
	       value_bglt v1069_856;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_2886;
		  aux_2886 =
		     STRUCT_REF(s_849, ((long) 4));
		  v1069_856 =
		     (value_bglt) (aux_2886);
	       }
	       ((((variable_bglt) CREF(o_848))->value) = ((value_bglt) v1069_856), BUNSPEC);
	    }
	    {	/* Ast/var.scm 21 */
	       obj_t v1073_857;
	       v1073_857 =
		  STRUCT_REF(s_849, ((long) 5));
	       ((((variable_bglt) CREF(o_848))->access) = ((obj_t) v1073_857), BUNSPEC);
	    }
	    {	/* Ast/var.scm 21 */
	       obj_t v1077_858;
	       v1077_858 =
		  STRUCT_REF(s_849, ((long) 6));
	       ((((variable_bglt) CREF(o_848))->fast_alpha_7) = ((obj_t) v1077_858), BUNSPEC);
	    }
	    {	/* Ast/var.scm 21 */
	       obj_t v1081_859;
	       v1081_859 =
		  STRUCT_REF(s_849, ((long) 7));
	       ((((variable_bglt) CREF(o_848))->removable) = ((obj_t) v1081_859), BUNSPEC);
	    }
	    {	/* Ast/var.scm 21 */
	       long v1085_860;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_2896;
		  aux_2896 =
		     STRUCT_REF(s_849, ((long) 8));
		  v1085_860 =
		     (long) CINT(aux_2896);
	       }
	       ((((variable_bglt) CREF(o_848))->occurrence) = ((long) v1085_860), BUNSPEC);
	    }
	    aux_2872 = o_848;
	    return
	       (obj_t) (aux_2872);
	 }
      }
   }
}



/* object->struct-variable1525 */
obj_t 
object__struct_variable1525_164_ast_var(obj_t env_1937, obj_t obj1053_1938)
{
   AN_OBJECT;
   {	/* Ast/var.scm 21 */
      {
	 variable_bglt obj1053_826;
	 obj1053_826 =
	    (variable_bglt) (obj1053_1938);
	 {	/* Ast/var.scm 21 */
	    obj_t res1054_829;
	    {	/* ./Llib/struct.scm 1415 */
	       obj_t aux_2902;
	       aux_2902 =
		  CNST_TABLE_REF(((long) 1));
	       res1054_829 =
		  make_struct(aux_2902, ((long) 9), BUNSPEC);
	    }
	    STRUCT_SET(res1054_829, ((long) 0), BFALSE);
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_2906;
	       aux_2906 =
		  (((variable_bglt) CREF(obj1053_826))->id);
	       STRUCT_SET(res1054_829, ((long) 1), aux_2906);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_2909;
	       aux_2909 =
		  (((variable_bglt) CREF(obj1053_826))->name);
	       STRUCT_SET(res1054_829, ((long) 2), aux_2909);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_2912;
	       {	/* Ast/var.scm 21 */
		  type_bglt aux_2913;
		  aux_2913 =
		     (((variable_bglt) CREF(obj1053_826))->type);
		  aux_2912 =
		     (obj_t) (aux_2913);
	       }
	       STRUCT_SET(res1054_829, ((long) 3), aux_2912);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_2917;
	       {	/* Ast/var.scm 21 */
		  value_bglt aux_2918;
		  aux_2918 =
		     (((variable_bglt) CREF(obj1053_826))->value);
		  aux_2917 =
		     (obj_t) (aux_2918);
	       }
	       STRUCT_SET(res1054_829, ((long) 4), aux_2917);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_2922;
	       aux_2922 =
		  (((variable_bglt) CREF(obj1053_826))->access);
	       STRUCT_SET(res1054_829, ((long) 5), aux_2922);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_2925;
	       aux_2925 =
		  (((variable_bglt) CREF(obj1053_826))->fast_alpha_7);
	       STRUCT_SET(res1054_829, ((long) 6), aux_2925);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_2928;
	       aux_2928 =
		  (((variable_bglt) CREF(obj1053_826))->removable);
	       STRUCT_SET(res1054_829, ((long) 7), aux_2928);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_2931;
	       {	/* Ast/var.scm 21 */
		  long aux_2932;
		  aux_2932 =
		     (((variable_bglt) CREF(obj1053_826))->occurrence);
		  aux_2931 =
		     BINT(aux_2932);
	       }
	       STRUCT_SET(res1054_829, ((long) 8), aux_2931);
	    }
	    return res1054_829;
	 }
      }
   }
}



/* struct+object->object-global1523 */
obj_t 
struct_object__object_global1523_249_ast_var(obj_t env_1939, obj_t o_1940, obj_t s_1941)
{
   AN_OBJECT;
   {	/* Ast/var.scm 44 */
      {
	 global_bglt o_804;
	 obj_t s_805;
	 {	/* Ast/var.scm 44 */
	    global_bglt aux_2937;
	    o_804 =
	       (global_bglt) (o_1940);
	    s_805 = s_1941;
	    {	/* Ast/var.scm 44 */
	       obj_t aux_2940;
	       object_bglt aux_2938;
	       aux_2940 =
		  STRUCT_REF(s_805, ((long) 0));
	       aux_2938 =
		  (object_bglt) (o_804);
	       OBJECT_WIDENING_SET(aux_2938, aux_2940);
	    }
	    {	/* Ast/var.scm 44 */
	       obj_t v1121_809;
	       v1121_809 =
		  STRUCT_REF(s_805, ((long) 1));
	       ((((global_bglt) CREF(o_804))->id) = ((obj_t) v1121_809), BUNSPEC);
	    }
	    {	/* Ast/var.scm 44 */
	       obj_t v1125_810;
	       v1125_810 =
		  STRUCT_REF(s_805, ((long) 2));
	       ((((global_bglt) CREF(o_804))->name) = ((obj_t) v1125_810), BUNSPEC);
	    }
	    {	/* Ast/var.scm 44 */
	       type_bglt v1129_811;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_2947;
		  aux_2947 =
		     STRUCT_REF(s_805, ((long) 3));
		  v1129_811 =
		     (type_bglt) (aux_2947);
	       }
	       ((((global_bglt) CREF(o_804))->type) = ((type_bglt) v1129_811), BUNSPEC);
	    }
	    {	/* Ast/var.scm 44 */
	       value_bglt v1133_812;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_2951;
		  aux_2951 =
		     STRUCT_REF(s_805, ((long) 4));
		  v1133_812 =
		     (value_bglt) (aux_2951);
	       }
	       ((((global_bglt) CREF(o_804))->value) = ((value_bglt) v1133_812), BUNSPEC);
	    }
	    {	/* Ast/var.scm 44 */
	       obj_t v1137_813;
	       v1137_813 =
		  STRUCT_REF(s_805, ((long) 5));
	       ((((global_bglt) CREF(o_804))->access) = ((obj_t) v1137_813), BUNSPEC);
	    }
	    {	/* Ast/var.scm 44 */
	       obj_t v1141_814;
	       v1141_814 =
		  STRUCT_REF(s_805, ((long) 6));
	       ((((global_bglt) CREF(o_804))->fast_alpha_7) = ((obj_t) v1141_814), BUNSPEC);
	    }
	    {	/* Ast/var.scm 44 */
	       obj_t v1145_815;
	       v1145_815 =
		  STRUCT_REF(s_805, ((long) 7));
	       ((((global_bglt) CREF(o_804))->removable) = ((obj_t) v1145_815), BUNSPEC);
	    }
	    {	/* Ast/var.scm 44 */
	       long v1149_816;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_2961;
		  aux_2961 =
		     STRUCT_REF(s_805, ((long) 8));
		  v1149_816 =
		     (long) CINT(aux_2961);
	       }
	       ((((global_bglt) CREF(o_804))->occurrence) = ((long) v1149_816), BUNSPEC);
	    }
	    {	/* Ast/var.scm 44 */
	       obj_t v1153_817;
	       v1153_817 =
		  STRUCT_REF(s_805, ((long) 9));
	       ((((global_bglt) CREF(o_804))->module) = ((obj_t) v1153_817), BUNSPEC);
	    }
	    {	/* Ast/var.scm 44 */
	       obj_t v1157_818;
	       v1157_818 =
		  STRUCT_REF(s_805, ((long) 10));
	       ((((global_bglt) CREF(o_804))->import) = ((obj_t) v1157_818), BUNSPEC);
	    }
	    {	/* Ast/var.scm 44 */
	       bool_t v1161_819;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_2969;
		  aux_2969 =
		     STRUCT_REF(s_805, ((long) 11));
		  v1161_819 =
		     CBOOL(aux_2969);
	       }
	       ((((global_bglt) CREF(o_804))->evaluable__248) = ((bool_t) v1161_819), BUNSPEC);
	    }
	    {	/* Ast/var.scm 44 */
	       bool_t v1165_820;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_2973;
		  aux_2973 =
		     STRUCT_REF(s_805, ((long) 12));
		  v1165_820 =
		     CBOOL(aux_2973);
	       }
	       ((((global_bglt) CREF(o_804))->library__255) = ((bool_t) v1165_820), BUNSPEC);
	    }
	    {	/* Ast/var.scm 44 */
	       bool_t v1169_821;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_2977;
		  aux_2977 =
		     STRUCT_REF(s_805, ((long) 13));
		  v1169_821 =
		     CBOOL(aux_2977);
	       }
	       ((((global_bglt) CREF(o_804))->user__32) = ((bool_t) v1169_821), BUNSPEC);
	    }
	    {	/* Ast/var.scm 44 */
	       obj_t v1173_822;
	       v1173_822 =
		  STRUCT_REF(s_805, ((long) 14));
	       ((((global_bglt) CREF(o_804))->pragma) = ((obj_t) v1173_822), BUNSPEC);
	    }
	    {	/* Ast/var.scm 44 */
	       obj_t v1177_823;
	       v1177_823 =
		  STRUCT_REF(s_805, ((long) 15));
	       ((((global_bglt) CREF(o_804))->src) = ((obj_t) v1177_823), BUNSPEC);
	    }
	    aux_2937 = o_804;
	    return
	       (obj_t) (aux_2937);
	 }
      }
   }
}



/* object->struct-global1521 */
obj_t 
object__struct_global1521_59_ast_var(obj_t env_1942, obj_t obj1117_1943)
{
   AN_OBJECT;
   {	/* Ast/var.scm 44 */
      {
	 global_bglt obj1117_768;
	 obj1117_768 =
	    (global_bglt) (obj1117_1943);
	 {	/* Ast/var.scm 44 */
	    obj_t res1118_771;
	    {	/* ./Llib/struct.scm 1415 */
	       obj_t aux_2987;
	       aux_2987 =
		  CNST_TABLE_REF(((long) 2));
	       res1118_771 =
		  make_struct(aux_2987, ((long) 16), BUNSPEC);
	    }
	    STRUCT_SET(res1118_771, ((long) 0), BFALSE);
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_2991;
	       aux_2991 =
		  (((global_bglt) CREF(obj1117_768))->id);
	       STRUCT_SET(res1118_771, ((long) 1), aux_2991);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_2994;
	       aux_2994 =
		  (((global_bglt) CREF(obj1117_768))->name);
	       STRUCT_SET(res1118_771, ((long) 2), aux_2994);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_2997;
	       {	/* Ast/var.scm 44 */
		  type_bglt aux_2998;
		  aux_2998 =
		     (((global_bglt) CREF(obj1117_768))->type);
		  aux_2997 =
		     (obj_t) (aux_2998);
	       }
	       STRUCT_SET(res1118_771, ((long) 3), aux_2997);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_3002;
	       {	/* Ast/var.scm 44 */
		  value_bglt aux_3003;
		  aux_3003 =
		     (((global_bglt) CREF(obj1117_768))->value);
		  aux_3002 =
		     (obj_t) (aux_3003);
	       }
	       STRUCT_SET(res1118_771, ((long) 4), aux_3002);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_3007;
	       aux_3007 =
		  (((global_bglt) CREF(obj1117_768))->access);
	       STRUCT_SET(res1118_771, ((long) 5), aux_3007);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_3010;
	       aux_3010 =
		  (((global_bglt) CREF(obj1117_768))->fast_alpha_7);
	       STRUCT_SET(res1118_771, ((long) 6), aux_3010);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_3013;
	       aux_3013 =
		  (((global_bglt) CREF(obj1117_768))->removable);
	       STRUCT_SET(res1118_771, ((long) 7), aux_3013);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_3016;
	       {	/* Ast/var.scm 44 */
		  long aux_3017;
		  aux_3017 =
		     (((global_bglt) CREF(obj1117_768))->occurrence);
		  aux_3016 =
		     BINT(aux_3017);
	       }
	       STRUCT_SET(res1118_771, ((long) 8), aux_3016);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_3021;
	       aux_3021 =
		  (((global_bglt) CREF(obj1117_768))->module);
	       STRUCT_SET(res1118_771, ((long) 9), aux_3021);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_3024;
	       aux_3024 =
		  (((global_bglt) CREF(obj1117_768))->import);
	       STRUCT_SET(res1118_771, ((long) 10), aux_3024);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_3027;
	       {	/* Ast/var.scm 44 */
		  bool_t aux_3028;
		  aux_3028 =
		     (((global_bglt) CREF(obj1117_768))->evaluable__248);
		  aux_3027 =
		     BBOOL(aux_3028);
	       }
	       STRUCT_SET(res1118_771, ((long) 11), aux_3027);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_3032;
	       {	/* Ast/var.scm 44 */
		  bool_t aux_3033;
		  aux_3033 =
		     (((global_bglt) CREF(obj1117_768))->library__255);
		  aux_3032 =
		     BBOOL(aux_3033);
	       }
	       STRUCT_SET(res1118_771, ((long) 12), aux_3032);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_3037;
	       {	/* Ast/var.scm 44 */
		  bool_t aux_3038;
		  aux_3038 =
		     (((global_bglt) CREF(obj1117_768))->user__32);
		  aux_3037 =
		     BBOOL(aux_3038);
	       }
	       STRUCT_SET(res1118_771, ((long) 13), aux_3037);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_3042;
	       aux_3042 =
		  (((global_bglt) CREF(obj1117_768))->pragma);
	       STRUCT_SET(res1118_771, ((long) 14), aux_3042);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_3045;
	       aux_3045 =
		  (((global_bglt) CREF(obj1117_768))->src);
	       STRUCT_SET(res1118_771, ((long) 15), aux_3045);
	    }
	    return res1118_771;
	 }
      }
   }
}



/* struct+object->object-local1518 */
obj_t 
struct_object__object_local1518_37_ast_var(obj_t env_1944, obj_t o_1945, obj_t s_1946)
{
   AN_OBJECT;
   {	/* Ast/var.scm 64 */
      {
	 local_bglt o_751;
	 obj_t s_752;
	 {	/* Ast/var.scm 64 */
	    local_bglt aux_3049;
	    o_751 =
	       (local_bglt) (o_1945);
	    s_752 = s_1946;
	    {	/* Ast/var.scm 64 */
	       obj_t aux_3052;
	       object_bglt aux_3050;
	       aux_3052 =
		  STRUCT_REF(s_752, ((long) 0));
	       aux_3050 =
		  (object_bglt) (o_751);
	       OBJECT_WIDENING_SET(aux_3050, aux_3052);
	    }
	    {	/* Ast/var.scm 64 */
	       obj_t v1204_756;
	       v1204_756 =
		  STRUCT_REF(s_752, ((long) 1));
	       ((((local_bglt) CREF(o_751))->id) = ((obj_t) v1204_756), BUNSPEC);
	    }
	    {	/* Ast/var.scm 64 */
	       obj_t v1208_757;
	       v1208_757 =
		  STRUCT_REF(s_752, ((long) 2));
	       ((((local_bglt) CREF(o_751))->name) = ((obj_t) v1208_757), BUNSPEC);
	    }
	    {	/* Ast/var.scm 64 */
	       type_bglt v1212_758;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_3059;
		  aux_3059 =
		     STRUCT_REF(s_752, ((long) 3));
		  v1212_758 =
		     (type_bglt) (aux_3059);
	       }
	       ((((local_bglt) CREF(o_751))->type) = ((type_bglt) v1212_758), BUNSPEC);
	    }
	    {	/* Ast/var.scm 64 */
	       value_bglt v1216_759;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_3063;
		  aux_3063 =
		     STRUCT_REF(s_752, ((long) 4));
		  v1216_759 =
		     (value_bglt) (aux_3063);
	       }
	       ((((local_bglt) CREF(o_751))->value) = ((value_bglt) v1216_759), BUNSPEC);
	    }
	    {	/* Ast/var.scm 64 */
	       obj_t v1220_760;
	       v1220_760 =
		  STRUCT_REF(s_752, ((long) 5));
	       ((((local_bglt) CREF(o_751))->access) = ((obj_t) v1220_760), BUNSPEC);
	    }
	    {	/* Ast/var.scm 64 */
	       obj_t v1224_761;
	       v1224_761 =
		  STRUCT_REF(s_752, ((long) 6));
	       ((((local_bglt) CREF(o_751))->fast_alpha_7) = ((obj_t) v1224_761), BUNSPEC);
	    }
	    {	/* Ast/var.scm 64 */
	       obj_t v1228_762;
	       v1228_762 =
		  STRUCT_REF(s_752, ((long) 7));
	       ((((local_bglt) CREF(o_751))->removable) = ((obj_t) v1228_762), BUNSPEC);
	    }
	    {	/* Ast/var.scm 64 */
	       long v1232_763;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_3073;
		  aux_3073 =
		     STRUCT_REF(s_752, ((long) 8));
		  v1232_763 =
		     (long) CINT(aux_3073);
	       }
	       ((((local_bglt) CREF(o_751))->occurrence) = ((long) v1232_763), BUNSPEC);
	    }
	    {	/* Ast/var.scm 64 */
	       bool_t v1236_764;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_3077;
		  aux_3077 =
		     STRUCT_REF(s_752, ((long) 9));
		  v1236_764 =
		     CBOOL(aux_3077);
	       }
	       ((((local_bglt) CREF(o_751))->user__32) = ((bool_t) v1236_764), BUNSPEC);
	    }
	    {	/* Ast/var.scm 64 */
	       long v1240_765;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_3081;
		  aux_3081 =
		     STRUCT_REF(s_752, ((long) 10));
		  v1240_765 =
		     (long) CINT(aux_3081);
	       }
	       ((((local_bglt) CREF(o_751))->key) = ((long) v1240_765), BUNSPEC);
	    }
	    aux_3049 = o_751;
	    return
	       (obj_t) (aux_3049);
	 }
      }
   }
}



/* object->struct-local1516 */
obj_t 
object__struct_local1516_246_ast_var(obj_t env_1947, obj_t obj1200_1948)
{
   AN_OBJECT;
   {	/* Ast/var.scm 64 */
      {
	 local_bglt obj1200_725;
	 obj1200_725 =
	    (local_bglt) (obj1200_1948);
	 {	/* Ast/var.scm 64 */
	    obj_t res1201_728;
	    {	/* ./Llib/struct.scm 1415 */
	       obj_t aux_3087;
	       aux_3087 =
		  CNST_TABLE_REF(((long) 3));
	       res1201_728 =
		  make_struct(aux_3087, ((long) 11), BUNSPEC);
	    }
	    STRUCT_SET(res1201_728, ((long) 0), BFALSE);
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_3091;
	       aux_3091 =
		  (((local_bglt) CREF(obj1200_725))->id);
	       STRUCT_SET(res1201_728, ((long) 1), aux_3091);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_3094;
	       aux_3094 =
		  (((local_bglt) CREF(obj1200_725))->name);
	       STRUCT_SET(res1201_728, ((long) 2), aux_3094);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_3097;
	       {	/* Ast/var.scm 64 */
		  type_bglt aux_3098;
		  aux_3098 =
		     (((local_bglt) CREF(obj1200_725))->type);
		  aux_3097 =
		     (obj_t) (aux_3098);
	       }
	       STRUCT_SET(res1201_728, ((long) 3), aux_3097);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_3102;
	       {	/* Ast/var.scm 64 */
		  value_bglt aux_3103;
		  aux_3103 =
		     (((local_bglt) CREF(obj1200_725))->value);
		  aux_3102 =
		     (obj_t) (aux_3103);
	       }
	       STRUCT_SET(res1201_728, ((long) 4), aux_3102);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_3107;
	       aux_3107 =
		  (((local_bglt) CREF(obj1200_725))->access);
	       STRUCT_SET(res1201_728, ((long) 5), aux_3107);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_3110;
	       aux_3110 =
		  (((local_bglt) CREF(obj1200_725))->fast_alpha_7);
	       STRUCT_SET(res1201_728, ((long) 6), aux_3110);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_3113;
	       aux_3113 =
		  (((local_bglt) CREF(obj1200_725))->removable);
	       STRUCT_SET(res1201_728, ((long) 7), aux_3113);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_3116;
	       {	/* Ast/var.scm 64 */
		  long aux_3117;
		  aux_3117 =
		     (((local_bglt) CREF(obj1200_725))->occurrence);
		  aux_3116 =
		     BINT(aux_3117);
	       }
	       STRUCT_SET(res1201_728, ((long) 8), aux_3116);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_3121;
	       {	/* Ast/var.scm 64 */
		  bool_t aux_3122;
		  aux_3122 =
		     (((local_bglt) CREF(obj1200_725))->user__32);
		  aux_3121 =
		     BBOOL(aux_3122);
	       }
	       STRUCT_SET(res1201_728, ((long) 9), aux_3121);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_3126;
	       {	/* Ast/var.scm 64 */
		  long aux_3127;
		  aux_3127 =
		     (((local_bglt) CREF(obj1200_725))->key);
		  aux_3126 =
		     BINT(aux_3127);
	       }
	       STRUCT_SET(res1201_728, ((long) 10), aux_3126);
	    }
	    return res1201_728;
	 }
      }
   }
}



/* struct+object->object-fun1514 */
obj_t 
struct_object__object_fun1514_86_ast_var(obj_t env_1949, obj_t o_1950, obj_t s_1951)
{
   AN_OBJECT;
   {	/* Ast/var.scm 70 */
      {
	 fun_bglt o_712;
	 obj_t s_713;
	 {	/* Ast/var.scm 70 */
	    fun_bglt aux_3132;
	    o_712 =
	       (fun_bglt) (o_1950);
	    s_713 = s_1951;
	    {	/* Ast/var.scm 70 */
	       obj_t aux_3135;
	       object_bglt aux_3133;
	       aux_3135 =
		  STRUCT_REF(s_713, ((long) 0));
	       aux_3133 =
		  (object_bglt) (o_712);
	       OBJECT_WIDENING_SET(aux_3133, aux_3135);
	    }
	    {	/* Ast/var.scm 70 */
	       long v1260_717;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_3138;
		  aux_3138 =
		     STRUCT_REF(s_713, ((long) 1));
		  v1260_717 =
		     (long) CINT(aux_3138);
	       }
	       ((((fun_bglt) CREF(o_712))->arity) = ((long) v1260_717), BUNSPEC);
	    }
	    {	/* Ast/var.scm 70 */
	       obj_t v1264_718;
	       v1264_718 =
		  STRUCT_REF(s_713, ((long) 2));
	       ((((fun_bglt) CREF(o_712))->side_effect__165) = ((obj_t) v1264_718), BUNSPEC);
	    }
	    {	/* Ast/var.scm 70 */
	       obj_t v1268_719;
	       v1268_719 =
		  STRUCT_REF(s_713, ((long) 3));
	       ((((fun_bglt) CREF(o_712))->predicate_of_78) = ((obj_t) v1268_719), BUNSPEC);
	    }
	    {	/* Ast/var.scm 70 */
	       obj_t v1272_720;
	       v1272_720 =
		  STRUCT_REF(s_713, ((long) 4));
	       ((((fun_bglt) CREF(o_712))->stack_allocator_172) = ((obj_t) v1272_720), BUNSPEC);
	    }
	    {	/* Ast/var.scm 70 */
	       bool_t v1276_721;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_3148;
		  aux_3148 =
		     STRUCT_REF(s_713, ((long) 5));
		  v1276_721 =
		     CBOOL(aux_3148);
	       }
	       ((((fun_bglt) CREF(o_712))->top__138) = ((bool_t) v1276_721), BUNSPEC);
	    }
	    {	/* Ast/var.scm 70 */
	       obj_t v1280_722;
	       v1280_722 =
		  STRUCT_REF(s_713, ((long) 6));
	       ((((fun_bglt) CREF(o_712))->the_closure_238) = ((obj_t) v1280_722), BUNSPEC);
	    }
	    aux_3132 = o_712;
	    return
	       (obj_t) (aux_3132);
	 }
      }
   }
}



/* object->struct-fun1512 */
obj_t 
object__struct_fun1512_56_ast_var(obj_t env_1952, obj_t obj1256_1953)
{
   AN_OBJECT;
   {	/* Ast/var.scm 70 */
      {
	 fun_bglt obj1256_694;
	 obj1256_694 =
	    (fun_bglt) (obj1256_1953);
	 {	/* Ast/var.scm 70 */
	    obj_t res1257_697;
	    {	/* ./Llib/struct.scm 1415 */
	       obj_t aux_3156;
	       aux_3156 =
		  CNST_TABLE_REF(((long) 4));
	       res1257_697 =
		  make_struct(aux_3156, ((long) 7), BUNSPEC);
	    }
	    STRUCT_SET(res1257_697, ((long) 0), BFALSE);
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_3160;
	       {	/* Ast/var.scm 70 */
		  long aux_3161;
		  aux_3161 =
		     (((fun_bglt) CREF(obj1256_694))->arity);
		  aux_3160 =
		     BINT(aux_3161);
	       }
	       STRUCT_SET(res1257_697, ((long) 1), aux_3160);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_3165;
	       aux_3165 =
		  (((fun_bglt) CREF(obj1256_694))->side_effect__165);
	       STRUCT_SET(res1257_697, ((long) 2), aux_3165);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_3168;
	       aux_3168 =
		  (((fun_bglt) CREF(obj1256_694))->predicate_of_78);
	       STRUCT_SET(res1257_697, ((long) 3), aux_3168);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_3171;
	       aux_3171 =
		  (((fun_bglt) CREF(obj1256_694))->stack_allocator_172);
	       STRUCT_SET(res1257_697, ((long) 4), aux_3171);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_3174;
	       {	/* Ast/var.scm 70 */
		  bool_t aux_3175;
		  aux_3175 =
		     (((fun_bglt) CREF(obj1256_694))->top__138);
		  aux_3174 =
		     BBOOL(aux_3175);
	       }
	       STRUCT_SET(res1257_697, ((long) 5), aux_3174);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_3179;
	       aux_3179 =
		  (((fun_bglt) CREF(obj1256_694))->the_closure_238);
	       STRUCT_SET(res1257_697, ((long) 6), aux_3179);
	    }
	    return res1257_697;
	 }
      }
   }
}



/* struct+object->object-sfun1510 */
obj_t 
struct_object__object_sfun1510_23_ast_var(obj_t env_1954, obj_t o_1955, obj_t s_1956)
{
   AN_OBJECT;
   {	/* Ast/var.scm 84 */
      {
	 sfun_bglt o_675;
	 obj_t s_676;
	 {	/* Ast/var.scm 84 */
	    sfun_bglt aux_3183;
	    o_675 =
	       (sfun_bglt) (o_1955);
	    s_676 = s_1956;
	    {	/* Ast/var.scm 84 */
	       obj_t aux_3186;
	       object_bglt aux_3184;
	       aux_3186 =
		  STRUCT_REF(s_676, ((long) 0));
	       aux_3184 =
		  (object_bglt) (o_675);
	       OBJECT_WIDENING_SET(aux_3184, aux_3186);
	    }
	    {	/* Ast/var.scm 84 */
	       long v1312_680;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_3189;
		  aux_3189 =
		     STRUCT_REF(s_676, ((long) 1));
		  v1312_680 =
		     (long) CINT(aux_3189);
	       }
	       ((((sfun_bglt) CREF(o_675))->arity) = ((long) v1312_680), BUNSPEC);
	    }
	    {	/* Ast/var.scm 84 */
	       obj_t v1316_681;
	       v1316_681 =
		  STRUCT_REF(s_676, ((long) 2));
	       ((((sfun_bglt) CREF(o_675))->side_effect__165) = ((obj_t) v1316_681), BUNSPEC);
	    }
	    {	/* Ast/var.scm 84 */
	       obj_t v1320_682;
	       v1320_682 =
		  STRUCT_REF(s_676, ((long) 3));
	       ((((sfun_bglt) CREF(o_675))->predicate_of_78) = ((obj_t) v1320_682), BUNSPEC);
	    }
	    {	/* Ast/var.scm 84 */
	       obj_t v1324_683;
	       v1324_683 =
		  STRUCT_REF(s_676, ((long) 4));
	       ((((sfun_bglt) CREF(o_675))->stack_allocator_172) = ((obj_t) v1324_683), BUNSPEC);
	    }
	    {	/* Ast/var.scm 84 */
	       bool_t v1328_684;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_3199;
		  aux_3199 =
		     STRUCT_REF(s_676, ((long) 5));
		  v1328_684 =
		     CBOOL(aux_3199);
	       }
	       ((((sfun_bglt) CREF(o_675))->top__138) = ((bool_t) v1328_684), BUNSPEC);
	    }
	    {	/* Ast/var.scm 84 */
	       obj_t v1332_685;
	       v1332_685 =
		  STRUCT_REF(s_676, ((long) 6));
	       ((((sfun_bglt) CREF(o_675))->the_closure_238) = ((obj_t) v1332_685), BUNSPEC);
	    }
	    {	/* Ast/var.scm 84 */
	       obj_t v1336_686;
	       v1336_686 =
		  STRUCT_REF(s_676, ((long) 7));
	       ((((sfun_bglt) CREF(o_675))->property) = ((obj_t) v1336_686), BUNSPEC);
	    }
	    {	/* Ast/var.scm 84 */
	       obj_t v1340_687;
	       v1340_687 =
		  STRUCT_REF(s_676, ((long) 8));
	       ((((sfun_bglt) CREF(o_675))->args) = ((obj_t) v1340_687), BUNSPEC);
	    }
	    {	/* Ast/var.scm 84 */
	       obj_t v1344_688;
	       v1344_688 =
		  STRUCT_REF(s_676, ((long) 9));
	       ((((sfun_bglt) CREF(o_675))->body) = ((obj_t) v1344_688), BUNSPEC);
	    }
	    {	/* Ast/var.scm 84 */
	       obj_t v1348_689;
	       v1348_689 =
		  STRUCT_REF(s_676, ((long) 10));
	       ((((sfun_bglt) CREF(o_675))->class) = ((obj_t) v1348_689), BUNSPEC);
	    }
	    {	/* Ast/var.scm 84 */
	       obj_t v1352_690;
	       v1352_690 =
		  STRUCT_REF(s_676, ((long) 11));
	       ((((sfun_bglt) CREF(o_675))->dsssl_keywords_243) = ((obj_t) v1352_690), BUNSPEC);
	    }
	    {	/* Ast/var.scm 84 */
	       obj_t v1356_691;
	       v1356_691 =
		  STRUCT_REF(s_676, ((long) 12));
	       ((((sfun_bglt) CREF(o_675))->loc) = ((obj_t) v1356_691), BUNSPEC);
	    }
	    aux_3183 = o_675;
	    return
	       (obj_t) (aux_3183);
	 }
      }
   }
}



/* object->struct-sfun1508 */
obj_t 
object__struct_sfun1508_100_ast_var(obj_t env_1957, obj_t obj1308_1958)
{
   AN_OBJECT;
   {	/* Ast/var.scm 84 */
      {
	 sfun_bglt obj1308_645;
	 obj1308_645 =
	    (sfun_bglt) (obj1308_1958);
	 {	/* Ast/var.scm 84 */
	    obj_t res1309_648;
	    {	/* ./Llib/struct.scm 1415 */
	       obj_t aux_3219;
	       aux_3219 =
		  CNST_TABLE_REF(((long) 5));
	       res1309_648 =
		  make_struct(aux_3219, ((long) 13), BUNSPEC);
	    }
	    STRUCT_SET(res1309_648, ((long) 0), BFALSE);
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_3223;
	       {	/* Ast/var.scm 84 */
		  long aux_3224;
		  aux_3224 =
		     (((sfun_bglt) CREF(obj1308_645))->arity);
		  aux_3223 =
		     BINT(aux_3224);
	       }
	       STRUCT_SET(res1309_648, ((long) 1), aux_3223);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_3228;
	       aux_3228 =
		  (((sfun_bglt) CREF(obj1308_645))->side_effect__165);
	       STRUCT_SET(res1309_648, ((long) 2), aux_3228);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_3231;
	       aux_3231 =
		  (((sfun_bglt) CREF(obj1308_645))->predicate_of_78);
	       STRUCT_SET(res1309_648, ((long) 3), aux_3231);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_3234;
	       aux_3234 =
		  (((sfun_bglt) CREF(obj1308_645))->stack_allocator_172);
	       STRUCT_SET(res1309_648, ((long) 4), aux_3234);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_3237;
	       {	/* Ast/var.scm 84 */
		  bool_t aux_3238;
		  aux_3238 =
		     (((sfun_bglt) CREF(obj1308_645))->top__138);
		  aux_3237 =
		     BBOOL(aux_3238);
	       }
	       STRUCT_SET(res1309_648, ((long) 5), aux_3237);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_3242;
	       aux_3242 =
		  (((sfun_bglt) CREF(obj1308_645))->the_closure_238);
	       STRUCT_SET(res1309_648, ((long) 6), aux_3242);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_3245;
	       aux_3245 =
		  (((sfun_bglt) CREF(obj1308_645))->property);
	       STRUCT_SET(res1309_648, ((long) 7), aux_3245);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_3248;
	       aux_3248 =
		  (((sfun_bglt) CREF(obj1308_645))->args);
	       STRUCT_SET(res1309_648, ((long) 8), aux_3248);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_3251;
	       aux_3251 =
		  (((sfun_bglt) CREF(obj1308_645))->body);
	       STRUCT_SET(res1309_648, ((long) 9), aux_3251);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_3254;
	       aux_3254 =
		  (((sfun_bglt) CREF(obj1308_645))->class);
	       STRUCT_SET(res1309_648, ((long) 10), aux_3254);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_3257;
	       aux_3257 =
		  (((sfun_bglt) CREF(obj1308_645))->dsssl_keywords_243);
	       STRUCT_SET(res1309_648, ((long) 11), aux_3257);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_3260;
	       aux_3260 =
		  (((sfun_bglt) CREF(obj1308_645))->loc);
	       STRUCT_SET(res1309_648, ((long) 12), aux_3260);
	    }
	    return res1309_648;
	 }
      }
   }
}



/* struct+object->object-cfun1506 */
obj_t 
struct_object__object_cfun1506_45_ast_var(obj_t env_1959, obj_t o_1960, obj_t s_1961)
{
   AN_OBJECT;
   {	/* Ast/var.scm 105 */
      {
	 cfun_bglt o_629;
	 obj_t s_630;
	 {	/* Ast/var.scm 105 */
	    cfun_bglt aux_3264;
	    o_629 =
	       (cfun_bglt) (o_1960);
	    s_630 = s_1961;
	    {	/* Ast/var.scm 105 */
	       obj_t aux_3267;
	       object_bglt aux_3265;
	       aux_3267 =
		  STRUCT_REF(s_630, ((long) 0));
	       aux_3265 =
		  (object_bglt) (o_629);
	       OBJECT_WIDENING_SET(aux_3265, aux_3267);
	    }
	    {	/* Ast/var.scm 105 */
	       long v1380_634;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_3270;
		  aux_3270 =
		     STRUCT_REF(s_630, ((long) 1));
		  v1380_634 =
		     (long) CINT(aux_3270);
	       }
	       ((((cfun_bglt) CREF(o_629))->arity) = ((long) v1380_634), BUNSPEC);
	    }
	    {	/* Ast/var.scm 105 */
	       obj_t v1384_635;
	       v1384_635 =
		  STRUCT_REF(s_630, ((long) 2));
	       ((((cfun_bglt) CREF(o_629))->side_effect__165) = ((obj_t) v1384_635), BUNSPEC);
	    }
	    {	/* Ast/var.scm 105 */
	       obj_t v1388_636;
	       v1388_636 =
		  STRUCT_REF(s_630, ((long) 3));
	       ((((cfun_bglt) CREF(o_629))->predicate_of_78) = ((obj_t) v1388_636), BUNSPEC);
	    }
	    {	/* Ast/var.scm 105 */
	       obj_t v1392_637;
	       v1392_637 =
		  STRUCT_REF(s_630, ((long) 4));
	       ((((cfun_bglt) CREF(o_629))->stack_allocator_172) = ((obj_t) v1392_637), BUNSPEC);
	    }
	    {	/* Ast/var.scm 105 */
	       bool_t v1396_638;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_3280;
		  aux_3280 =
		     STRUCT_REF(s_630, ((long) 5));
		  v1396_638 =
		     CBOOL(aux_3280);
	       }
	       ((((cfun_bglt) CREF(o_629))->top__138) = ((bool_t) v1396_638), BUNSPEC);
	    }
	    {	/* Ast/var.scm 105 */
	       obj_t v1400_639;
	       v1400_639 =
		  STRUCT_REF(s_630, ((long) 6));
	       ((((cfun_bglt) CREF(o_629))->the_closure_238) = ((obj_t) v1400_639), BUNSPEC);
	    }
	    {	/* Ast/var.scm 105 */
	       obj_t v1404_640;
	       v1404_640 =
		  STRUCT_REF(s_630, ((long) 7));
	       ((((cfun_bglt) CREF(o_629))->args_type_205) = ((obj_t) v1404_640), BUNSPEC);
	    }
	    {	/* Ast/var.scm 105 */
	       bool_t v1408_641;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_3288;
		  aux_3288 =
		     STRUCT_REF(s_630, ((long) 8));
		  v1408_641 =
		     CBOOL(aux_3288);
	       }
	       ((((cfun_bglt) CREF(o_629))->macro__33) = ((bool_t) v1408_641), BUNSPEC);
	    }
	    {	/* Ast/var.scm 105 */
	       bool_t v1412_642;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_3292;
		  aux_3292 =
		     STRUCT_REF(s_630, ((long) 9));
		  v1412_642 =
		     CBOOL(aux_3292);
	       }
	       ((((cfun_bglt) CREF(o_629))->infix__163) = ((bool_t) v1412_642), BUNSPEC);
	    }
	    aux_3264 = o_629;
	    return
	       (obj_t) (aux_3264);
	 }
      }
   }
}



/* object->struct-cfun1504 */
obj_t 
object__struct_cfun1504_204_ast_var(obj_t env_1962, obj_t obj1376_1963)
{
   AN_OBJECT;
   {	/* Ast/var.scm 105 */
      {
	 cfun_bglt obj1376_605;
	 obj1376_605 =
	    (cfun_bglt) (obj1376_1963);
	 {	/* Ast/var.scm 105 */
	    obj_t res1377_608;
	    {	/* ./Llib/struct.scm 1415 */
	       obj_t aux_3298;
	       aux_3298 =
		  CNST_TABLE_REF(((long) 6));
	       res1377_608 =
		  make_struct(aux_3298, ((long) 10), BUNSPEC);
	    }
	    STRUCT_SET(res1377_608, ((long) 0), BFALSE);
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_3302;
	       {	/* Ast/var.scm 105 */
		  long aux_3303;
		  aux_3303 =
		     (((cfun_bglt) CREF(obj1376_605))->arity);
		  aux_3302 =
		     BINT(aux_3303);
	       }
	       STRUCT_SET(res1377_608, ((long) 1), aux_3302);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_3307;
	       aux_3307 =
		  (((cfun_bglt) CREF(obj1376_605))->side_effect__165);
	       STRUCT_SET(res1377_608, ((long) 2), aux_3307);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_3310;
	       aux_3310 =
		  (((cfun_bglt) CREF(obj1376_605))->predicate_of_78);
	       STRUCT_SET(res1377_608, ((long) 3), aux_3310);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_3313;
	       aux_3313 =
		  (((cfun_bglt) CREF(obj1376_605))->stack_allocator_172);
	       STRUCT_SET(res1377_608, ((long) 4), aux_3313);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_3316;
	       {	/* Ast/var.scm 105 */
		  bool_t aux_3317;
		  aux_3317 =
		     (((cfun_bglt) CREF(obj1376_605))->top__138);
		  aux_3316 =
		     BBOOL(aux_3317);
	       }
	       STRUCT_SET(res1377_608, ((long) 5), aux_3316);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_3321;
	       aux_3321 =
		  (((cfun_bglt) CREF(obj1376_605))->the_closure_238);
	       STRUCT_SET(res1377_608, ((long) 6), aux_3321);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_3324;
	       aux_3324 =
		  (((cfun_bglt) CREF(obj1376_605))->args_type_205);
	       STRUCT_SET(res1377_608, ((long) 7), aux_3324);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_3327;
	       {	/* Ast/var.scm 105 */
		  bool_t aux_3328;
		  aux_3328 =
		     (((cfun_bglt) CREF(obj1376_605))->macro__33);
		  aux_3327 =
		     BBOOL(aux_3328);
	       }
	       STRUCT_SET(res1377_608, ((long) 8), aux_3327);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_3332;
	       {	/* Ast/var.scm 105 */
		  bool_t aux_3333;
		  aux_3333 =
		     (((cfun_bglt) CREF(obj1376_605))->infix__163);
		  aux_3332 =
		     BBOOL(aux_3333);
	       }
	       STRUCT_SET(res1377_608, ((long) 9), aux_3332);
	    }
	    return res1377_608;
	 }
      }
   }
}



/* struct+object->object-svar1502 */
obj_t 
struct_object__object_svar1502_167_ast_var(obj_t env_1964, obj_t o_1965, obj_t s_1966)
{
   AN_OBJECT;
   {	/* Ast/var.scm 113 */
      {
	 svar_bglt o_597;
	 obj_t s_598;
	 {	/* Ast/var.scm 113 */
	    svar_bglt aux_3338;
	    o_597 =
	       (svar_bglt) (o_1965);
	    s_598 = s_1966;
	    {	/* Ast/var.scm 113 */
	       obj_t aux_3341;
	       object_bglt aux_3339;
	       aux_3341 =
		  STRUCT_REF(s_598, ((long) 0));
	       aux_3339 =
		  (object_bglt) (o_597);
	       OBJECT_WIDENING_SET(aux_3339, aux_3341);
	    }
	    {	/* Ast/var.scm 113 */
	       obj_t v1423_602;
	       v1423_602 =
		  STRUCT_REF(s_598, ((long) 1));
	       ((((svar_bglt) CREF(o_597))->loc) = ((obj_t) v1423_602), BUNSPEC);
	    }
	    aux_3338 = o_597;
	    return
	       (obj_t) (aux_3338);
	 }
      }
   }
}



/* object->struct-svar1500 */
obj_t 
object__struct_svar1500_98_ast_var(obj_t env_1967, obj_t obj1419_1968)
{
   AN_OBJECT;
   {	/* Ast/var.scm 113 */
      {
	 svar_bglt obj1419_589;
	 obj1419_589 =
	    (svar_bglt) (obj1419_1968);
	 {	/* Ast/var.scm 113 */
	    obj_t res1420_592;
	    {	/* ./Llib/struct.scm 1415 */
	       obj_t aux_3348;
	       aux_3348 =
		  CNST_TABLE_REF(((long) 7));
	       res1420_592 =
		  make_struct(aux_3348, ((long) 2), BUNSPEC);
	    }
	    STRUCT_SET(res1420_592, ((long) 0), BFALSE);
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_3352;
	       aux_3352 =
		  (((svar_bglt) CREF(obj1419_589))->loc);
	       STRUCT_SET(res1420_592, ((long) 1), aux_3352);
	    }
	    return res1420_592;
	 }
      }
   }
}



/* struct+object->object-scnst1498 */
obj_t 
struct_object__object_scnst1498_133_ast_var(obj_t env_1969, obj_t o_1970, obj_t s_1971)
{
   AN_OBJECT;
   {	/* Ast/var.scm 117 */
      {
	 scnst_bglt o_579;
	 obj_t s_580;
	 {	/* Ast/var.scm 117 */
	    scnst_bglt aux_3356;
	    o_579 =
	       (scnst_bglt) (o_1970);
	    s_580 = s_1971;
	    {	/* Ast/var.scm 117 */
	       obj_t aux_3359;
	       object_bglt aux_3357;
	       aux_3359 =
		  STRUCT_REF(s_580, ((long) 0));
	       aux_3357 =
		  (object_bglt) (o_579);
	       OBJECT_WIDENING_SET(aux_3357, aux_3359);
	    }
	    {	/* Ast/var.scm 117 */
	       obj_t v1437_584;
	       v1437_584 =
		  STRUCT_REF(s_580, ((long) 1));
	       ((((scnst_bglt) CREF(o_579))->node) = ((obj_t) v1437_584), BUNSPEC);
	    }
	    {	/* Ast/var.scm 117 */
	       obj_t v1441_585;
	       v1441_585 =
		  STRUCT_REF(s_580, ((long) 2));
	       ((((scnst_bglt) CREF(o_579))->class) = ((obj_t) v1441_585), BUNSPEC);
	    }
	    {	/* Ast/var.scm 117 */
	       obj_t v1445_586;
	       v1445_586 =
		  STRUCT_REF(s_580, ((long) 3));
	       ((((scnst_bglt) CREF(o_579))->loc) = ((obj_t) v1445_586), BUNSPEC);
	    }
	    aux_3356 = o_579;
	    return
	       (obj_t) (aux_3356);
	 }
      }
   }
}



/* object->struct-scnst1496 */
obj_t 
object__struct_scnst1496_159_ast_var(obj_t env_1972, obj_t obj1433_1973)
{
   AN_OBJECT;
   {	/* Ast/var.scm 117 */
      {
	 scnst_bglt obj1433_567;
	 obj1433_567 =
	    (scnst_bglt) (obj1433_1973);
	 {	/* Ast/var.scm 117 */
	    obj_t res1434_570;
	    {	/* ./Llib/struct.scm 1415 */
	       obj_t aux_3370;
	       aux_3370 =
		  CNST_TABLE_REF(((long) 8));
	       res1434_570 =
		  make_struct(aux_3370, ((long) 4), BUNSPEC);
	    }
	    STRUCT_SET(res1434_570, ((long) 0), BFALSE);
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_3374;
	       aux_3374 =
		  (((scnst_bglt) CREF(obj1433_567))->node);
	       STRUCT_SET(res1434_570, ((long) 1), aux_3374);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_3377;
	       aux_3377 =
		  (((scnst_bglt) CREF(obj1433_567))->class);
	       STRUCT_SET(res1434_570, ((long) 2), aux_3377);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_3380;
	       aux_3380 =
		  (((scnst_bglt) CREF(obj1433_567))->loc);
	       STRUCT_SET(res1434_570, ((long) 3), aux_3380);
	    }
	    return res1434_570;
	 }
      }
   }
}



/* struct+object->object-cvar1494 */
obj_t 
struct_object__object_cvar1494_104_ast_var(obj_t env_1974, obj_t o_1975, obj_t s_1976)
{
   AN_OBJECT;
   {	/* Ast/var.scm 129 */
      {
	 cvar_bglt o_559;
	 obj_t s_560;
	 {	/* Ast/var.scm 129 */
	    cvar_bglt aux_3384;
	    o_559 =
	       (cvar_bglt) (o_1975);
	    s_560 = s_1976;
	    {	/* Ast/var.scm 129 */
	       obj_t aux_3387;
	       object_bglt aux_3385;
	       aux_3387 =
		  STRUCT_REF(s_560, ((long) 0));
	       aux_3385 =
		  (object_bglt) (o_559);
	       OBJECT_WIDENING_SET(aux_3385, aux_3387);
	    }
	    {	/* Ast/var.scm 129 */
	       bool_t v1457_564;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_3390;
		  aux_3390 =
		     STRUCT_REF(s_560, ((long) 1));
		  v1457_564 =
		     CBOOL(aux_3390);
	       }
	       ((((cvar_bglt) CREF(o_559))->macro__33) = ((bool_t) v1457_564), BUNSPEC);
	    }
	    aux_3384 = o_559;
	    return
	       (obj_t) (aux_3384);
	 }
      }
   }
}



/* object->struct-cvar1492 */
obj_t 
object__struct_cvar1492_35_ast_var(obj_t env_1977, obj_t obj1453_1978)
{
   AN_OBJECT;
   {	/* Ast/var.scm 129 */
      {
	 cvar_bglt obj1453_551;
	 obj1453_551 =
	    (cvar_bglt) (obj1453_1978);
	 {	/* Ast/var.scm 129 */
	    obj_t res1454_554;
	    {	/* ./Llib/struct.scm 1415 */
	       obj_t aux_3396;
	       aux_3396 =
		  CNST_TABLE_REF(((long) 9));
	       res1454_554 =
		  make_struct(aux_3396, ((long) 2), BUNSPEC);
	    }
	    STRUCT_SET(res1454_554, ((long) 0), BFALSE);
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_3400;
	       {	/* Ast/var.scm 129 */
		  bool_t aux_3401;
		  aux_3401 =
		     (((cvar_bglt) CREF(obj1453_551))->macro__33);
		  aux_3400 =
		     BBOOL(aux_3401);
	       }
	       STRUCT_SET(res1454_554, ((long) 1), aux_3400);
	    }
	    return res1454_554;
	 }
      }
   }
}



/* struct+object->object-sexit1490 */
obj_t 
struct_object__object_sexit1490_65_ast_var(obj_t env_1979, obj_t o_1980, obj_t s_1981)
{
   AN_OBJECT;
   {	/* Ast/var.scm 133 */
      {
	 sexit_bglt o_542;
	 obj_t s_543;
	 {	/* Ast/var.scm 133 */
	    sexit_bglt aux_3406;
	    o_542 =
	       (sexit_bglt) (o_1980);
	    s_543 = s_1981;
	    {	/* Ast/var.scm 133 */
	       obj_t aux_3409;
	       object_bglt aux_3407;
	       aux_3409 =
		  STRUCT_REF(s_543, ((long) 0));
	       aux_3407 =
		  (object_bglt) (o_542);
	       OBJECT_WIDENING_SET(aux_3407, aux_3409);
	    }
	    {	/* Ast/var.scm 133 */
	       obj_t v1470_547;
	       v1470_547 =
		  STRUCT_REF(s_543, ((long) 1));
	       ((((sexit_bglt) CREF(o_542))->handler) = ((obj_t) v1470_547), BUNSPEC);
	    }
	    {	/* Ast/var.scm 133 */
	       bool_t v1474_548;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_3414;
		  aux_3414 =
		     STRUCT_REF(s_543, ((long) 2));
		  v1474_548 =
		     CBOOL(aux_3414);
	       }
	       ((((sexit_bglt) CREF(o_542))->detached__120) = ((bool_t) v1474_548), BUNSPEC);
	    }
	    aux_3406 = o_542;
	    return
	       (obj_t) (aux_3406);
	 }
      }
   }
}



/* object->struct-sexit1488 */
obj_t 
object__struct_sexit1488_225_ast_var(obj_t env_1982, obj_t obj1466_1983)
{
   AN_OBJECT;
   {	/* Ast/var.scm 133 */
      {
	 sexit_bglt obj1466_532;
	 obj1466_532 =
	    (sexit_bglt) (obj1466_1983);
	 {	/* Ast/var.scm 133 */
	    obj_t res1467_535;
	    {	/* ./Llib/struct.scm 1415 */
	       obj_t aux_3420;
	       aux_3420 =
		  CNST_TABLE_REF(((long) 10));
	       res1467_535 =
		  make_struct(aux_3420, ((long) 3), BUNSPEC);
	    }
	    STRUCT_SET(res1467_535, ((long) 0), BFALSE);
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_3424;
	       aux_3424 =
		  (((sexit_bglt) CREF(obj1466_532))->handler);
	       STRUCT_SET(res1467_535, ((long) 1), aux_3424);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_3427;
	       {	/* Ast/var.scm 133 */
		  bool_t aux_3428;
		  aux_3428 =
		     (((sexit_bglt) CREF(obj1466_532))->detached__120);
		  aux_3427 =
		     BBOOL(aux_3428);
	       }
	       STRUCT_SET(res1467_535, ((long) 2), aux_3427);
	    }
	    return res1467_535;
	 }
      }
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_ast_var()
{
   AN_OBJECT;
   {	/* Ast/var.scm 14 */
      module_initialization_70_engine_param(((long) 0), "AST_VAR");
      return
	 module_initialization_70_type_type(((long) 0), "AST_VAR");
   }
}
