/*===========================================================================*/
/*   (Cfa/cinfo.scm)                                                         */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;

typedef struct approx
  {
     header_t header;
     obj_t widening;
     struct type *type;
     bool_t type_locked__184;
     obj_t allocs;
     bool_t top__138;
     long lost_stamp_114;
  }
      *approx_bglt;

typedef struct cfun_cinfo_200
  {
     struct approx *approx;
  }
              *cfun_cinfo_200_bglt;

typedef struct extern_sfun_cinfo_6
  {
     struct approx *approx;
  }
                   *extern_sfun_cinfo_6_bglt;

typedef struct intern_sfun_cinfo_192
  {
     struct approx *approx;
     long stamp;
  }
                     *intern_sfun_cinfo_192_bglt;

typedef struct scnst_cinfo_0
  {
     struct approx *approx;
  }
             *scnst_cinfo_0_bglt;

typedef struct pre_clo_env_191
  {
     char dummy;
  }
               *pre_clo_env_191_bglt;

typedef struct svar_cinfo_166
  {
     struct approx *approx;
     bool_t clo_env__87;
  }
              *svar_cinfo_166_bglt;

typedef struct cvar_cinfo_53
  {
     struct approx *approx;
  }
             *cvar_cinfo_53_bglt;

typedef struct sexit_cinfo_49
  {
     struct approx *approx;
  }
              *sexit_cinfo_49_bglt;

typedef struct reshaped_local_224
  {
     obj_t binding_value_3;
  }
                  *reshaped_local_224_bglt;

typedef struct reshaped_global_160
  {
     char dummy;
  }
                   *reshaped_global_160_bglt;

typedef struct atom_cinfo_155
  {
     struct approx *approx;
  }
              *atom_cinfo_155_bglt;

typedef struct kwote_node_102
  {
     struct node *node;
  }
              *kwote_node_102_bglt;

typedef struct kwote_cinfo_48
  {
     struct approx *approx;
  }
              *kwote_cinfo_48_bglt;

typedef struct app_ly_cinfo_234
  {
     struct approx *approx;
  }
                *app_ly_cinfo_234_bglt;

typedef struct funcall_cinfo_75
  {
     struct approx *approx;
     struct approx *va_approx_63;
     bool_t arity_error_noticed__118;
     bool_t type_error_noticed__36;
  }
                *funcall_cinfo_75_bglt;

typedef struct pragma_cinfo_220
  {
     struct approx *approx;
  }
                *pragma_cinfo_220_bglt;

typedef struct setq_cinfo_191
  {
     struct approx *approx;
  }
              *setq_cinfo_191_bglt;

typedef struct conditional_cinfo_212
  {
     struct approx *approx;
  }
                     *conditional_cinfo_212_bglt;

typedef struct fail_cinfo_75
  {
     struct approx *approx;
  }
             *fail_cinfo_75_bglt;

typedef struct select_cinfo_150
  {
     struct approx *approx;
  }
                *select_cinfo_150_bglt;

typedef struct set_ex_it_cinfo_168
  {
     struct approx *approx;
  }
                   *set_ex_it_cinfo_168_bglt;

typedef struct jump_ex_it_cinfo_139
  {
     struct approx *approx;
  }
                    *jump_ex_it_cinfo_139_bglt;

typedef struct pre_make_box_186
  {
     char dummy;
  }
                *pre_make_box_186_bglt;

typedef struct make_box_cinfo_127
  {
     struct approx *approx;
  }
                  *make_box_cinfo_127_bglt;

typedef struct make_box_o_cinfo_96
  {
     struct approx *approx;
     struct approx *value_approx_19;
  }
                   *make_box_o_cinfo_96_bglt;

typedef struct box_set__cinfo_94
  {
     struct approx *approx;
  }
                 *box_set__cinfo_94_bglt;

typedef struct box_ref_cinfo_214
  {
     struct approx *approx;
  }
                 *box_ref_cinfo_214_bglt;

typedef struct box_set__o_cinfo_6
  {
     struct approx *approx;
  }
                  *box_set__o_cinfo_6_bglt;

typedef struct box_ref_o_cinfo_98
  {
     struct approx *approx;
  }
                  *box_ref_o_cinfo_98_bglt;


static obj_t _conditional_cinfo_loc2889_186_cfa_info(obj_t, obj_t);
static obj_t _box_ref_cinfo_type_set_2793_113_cfa_info(obj_t, obj_t, obj_t);
extern obj_t conditional_cinfo_loc_197_cfa_info(conditional_bglt);
static obj_t object__struct_setq_cinfo2026_53_cfa_info(obj_t, obj_t);
static obj_t _app_ly_cinfo_type2943_141_cfa_info(obj_t, obj_t);
static obj_t _pre_clo_env_loc_set_3037_152_cfa_info(obj_t, obj_t, obj_t);
extern approx_bglt scnst_cinfo_approx_162_cfa_info(scnst_cinfo_0_bglt);
static obj_t object__struct_cfun_cinfo2090_55_cfa_info(obj_t, obj_t);
static obj_t _pre_make_box_key_set_2839_81_cfa_info(obj_t, obj_t, obj_t);
extern obj_t reshaped_local_access_set__128_cfa_info(local_bglt, obj_t);
static obj_t _make_box_o_cinfo_key_set__74_cfa_info(obj_t, obj_t, obj_t);
extern obj_t extern_sfun_cinfo_side_effect__set__111_cfa_info(sfun_bglt, obj_t);
static obj_t _reshaped_global_module2987_48_cfa_info(obj_t, obj_t);
extern obj_t select_cinfo_side_effect__set__150_cfa_info(select_bglt, obj_t);
extern obj_t atom_cinfo_loc_162_cfa_info(atom_bglt);
static obj_t _sexit_cinfo_detached__set_3023_40_cfa_info(obj_t, obj_t, obj_t);
extern approx_bglt intern_sfun_cinfo_approx_57_cfa_info(intern_sfun_cinfo_192_bglt);
extern obj_t reshaped_local_binding_value_248_cfa_info(reshaped_local_224_bglt);
extern obj_t setq_cinfo_loc_179_cfa_info(setq_bglt);
extern obj_t pre_clo_env_loc_set__78_cfa_info(svar_bglt, obj_t);
static obj_t _cfun_cinfo_infix__set_3116_180_cfa_info(obj_t, obj_t, obj_t);
static obj_t _cfun_cinfo_top__set_3110_80_cfa_info(obj_t, obj_t, obj_t);
static obj_t _set_ex_it_cinfo_type2857_188_cfa_info(obj_t, obj_t);
static obj_t method_init_76_cfa_info();
static obj_t object__struct_sexit_cinfo2062_20_cfa_info(obj_t, obj_t);
extern jump_ex_it_cinfo_139_bglt widening_jump_ex_it_cinfo_85_cfa_info(approx_bglt);
extern obj_t make_box_202_ast_node;
extern obj_t pragma_cinfo_side_effect__231_cfa_info(pragma_bglt);
static obj_t _box_ref_o_cinfo_loc2772_15_cfa_info(obj_t, obj_t);
static obj_t _make_kwote_node2957_50_cfa_info(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t _reshaped_local_id3000_56_cfa_info(obj_t, obj_t);
extern bool_t reshaped_global_evaluable__213_cfa_info(global_bglt);
extern obj_t intern_sfun_cinfo_dsssl_keywords_set__175_cfa_info(sfun_bglt, obj_t);
extern obj_t funcall_cinfo_args_set__97_cfa_info(funcall_bglt, obj_t);
static obj_t _scnst_cinfo_loc3045_122_cfa_info(obj_t, obj_t);
static obj_t _fail_cinfo_type_set_2878_61_cfa_info(obj_t, obj_t, obj_t);
static obj_t struct_object__object_box_set__o_cinfo1984_135_cfa_info(obj_t, obj_t, obj_t);
static obj_t _conditional_cinfo_type2891_50_cfa_info(obj_t, obj_t);
extern bool_t funcall_cinfo_arity_error_noticed__251_cfa_info(funcall_cinfo_75_bglt);
extern obj_t box_set__cinfo_value_set__94_cfa_info(box_set__221_bglt, node_bglt);
static obj_t _extern_sfun_cinfo_args_set_3090_10_cfa_info(obj_t, obj_t, obj_t);
extern obj_t reshaped_global_occurrence_set__92_cfa_info(global_bglt, long);
static obj_t _jump_ex_it_cinfo_type_set_2846_233_cfa_info(obj_t, obj_t, obj_t);
static obj_t _cfun_cinfo_stack_allocator_set_3108_157_cfa_info(obj_t, obj_t, obj_t);
extern obj_t reshaped_global_user__set__184_cfa_info(global_bglt, bool_t);
static obj_t _atom_cinfo_type_set_2966_94_cfa_info(obj_t, obj_t, obj_t);
extern bool_t cvar_cinfo__125_cfa_info(obj_t);
extern obj_t conditional_cinfo_side_effect__set__214_cfa_info(conditional_bglt, obj_t);
extern obj_t funcall_ast_node;
extern obj_t funcall_cinfo_arity_error_noticed__set__137_cfa_info(funcall_cinfo_75_bglt, bool_t);
static obj_t struct_object__object_pragma_cinfo2032_204_cfa_info(obj_t, obj_t, obj_t);
extern obj_t conditional_cinfo_key_148_cfa_info(conditional_bglt);
static obj_t _cfun_cinfo__48_cfa_info(obj_t, obj_t);
extern obj_t extern_sfun_cinfo_the_closure_set__203_cfa_info(sfun_bglt, obj_t);
extern type_bglt reshaped_local_type_195_cfa_info(local_bglt);
extern bool_t svar_cinfo_clo_env__3_cfa_info(svar_cinfo_166_bglt);
extern type_bglt app_ly_cinfo_type_137_cfa_info(app_ly_162_bglt);
extern bool_t box_ref_cinfo__23_cfa_info(obj_t);
extern obj_t svar_cinfo_loc_set__81_cfa_info(svar_bglt, obj_t);
static obj_t _box_ref_o_cinfo_type2774_225_cfa_info(obj_t, obj_t);
extern obj_t jump_ex_it_cinfo_loc_13_cfa_info(jump_ex_it_184_bglt);
static obj_t _widening_app_ly_cinfo2939_88_cfa_info(obj_t, obj_t);
extern obj_t cfun_cinfo_stack_allocator_set__152_cfa_info(cfun_bglt, obj_t);
static obj_t _widening_box_ref_cinfo2790_171_cfa_info(obj_t, obj_t);
static obj_t _widening_set_ex_it_cinfo2853_220_cfa_info(obj_t, obj_t);
extern bool_t reshaped_local_user__5_cfa_info(local_bglt);
static obj_t _allocate_extern_sfun_cinfo_234_cfa_info(obj_t);
static obj_t _kwote_cinfo_loc2951_52_cfa_info(obj_t, obj_t);
extern obj_t make_box_o_cinfo_side_effect__220_cfa_info(make_box_202_bglt);
static obj_t _scnst_cinfo_loc_set_3044_121_cfa_info(obj_t, obj_t, obj_t);
extern obj_t cfun_cinfo_args_type_205_cfa_info(cfun_bglt);
static obj_t _svar_cinfo_clo_env__set_3035_110_cfa_info(obj_t, obj_t, obj_t);
obj_t box_set__cinfo_94_cfa_info = BUNSPEC;
extern node_bglt funcall_cinfo_fun_73_cfa_info(funcall_bglt);
static obj_t object__struct_conditional_cinfo2022_5_cfa_info(obj_t, obj_t);
static obj_t _jump_ex_it_cinfo__23_cfa_info(obj_t, obj_t);
static obj_t _make_intern_sfun_cinfo3048_141_cfa_info(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t make_box_cinfo_side_effect__155_cfa_info(make_box_202_bglt);
static obj_t _pragma_cinfo_key_set__201_cfa_info(obj_t, obj_t, obj_t);
extern intern_sfun_cinfo_192_bglt make_intern_sfun_cinfo_198_cfa_info(long, obj_t, obj_t, obj_t, bool_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, approx_bglt, long);
extern type_bglt make_box_cinfo_type_207_cfa_info(make_box_202_bglt);
extern obj_t funcall_cinfo_strength_set__61_cfa_info(funcall_bglt, obj_t);
extern obj_t extern_sfun_cinfo_args_4_cfa_info(sfun_bglt);
obj_t make_box_cinfo_127_cfa_info = BUNSPEC;
extern make_box_o_cinfo_96_bglt widening_make_box_o_cinfo_32_cfa_info(approx_bglt, approx_bglt);
extern obj_t reshaped_global_name_set__33_cfa_info(global_bglt, obj_t);
static obj_t _pragma_cinfo__129_cfa_info(obj_t, obj_t);
extern obj_t fail_ast_node;
extern bool_t scnst_cinfo__144_cfa_info(obj_t);
extern obj_t set_ex_it_cinfo_var_set__245_cfa_info(set_ex_it_116_bglt, var_bglt);
extern obj_t box_ref_o_cinfo_key_set__15_cfa_info(box_ref_242_bglt, obj_t);
extern obj_t intern_sfun_cinfo_stamp_set__83_cfa_info(intern_sfun_cinfo_192_bglt, long);
static obj_t struct_object__object_svar_cinfo2072_159_cfa_info(obj_t, obj_t, obj_t);
extern kwote_cinfo_48_bglt widening_kwote_cinfo_42_cfa_info(approx_bglt);
extern bool_t sexit_cinfo_detached__124_cfa_info(sexit_bglt);
static obj_t _extern_sfun_cinfo_predicate_of3081_90_cfa_info(obj_t, obj_t);
obj_t funcall_cinfo_75_cfa_info = BUNSPEC;
static obj_t object__struct_make_box_o_cinfo1994_50_cfa_info(obj_t, obj_t);
extern obj_t box_ref_o_cinfo_var_set__204_cfa_info(box_ref_242_bglt, var_bglt);
static obj_t _kwote_node__166_cfa_info(obj_t, obj_t);
static obj_t _allocate_pre_make_box_48_cfa_info(obj_t);
static obj_t _svar_cinfo_loc3033_82_cfa_info(obj_t, obj_t);
obj_t conditional_cinfo_212_cfa_info = BUNSPEC;
static obj_t _reshaped_local_user_3016_191_cfa_info(obj_t, obj_t);
extern obj_t setq_cinfo_var_set__169_cfa_info(setq_bglt, var_bglt);
extern node_bglt kwote_node_node_71_cfa_info(kwote_node_102_bglt);
static obj_t _allocate_scnst_cinfo_162_cfa_info(obj_t);
static obj_t struct_object__object_pre_clo_env2076_139_cfa_info(obj_t, obj_t, obj_t);
extern obj_t box_ref_242_ast_node;
extern obj_t reshaped_global_access_set__53_cfa_info(global_bglt, obj_t);
static obj_t _make_box_o_cinfo_side_effect__set_2815_15_cfa_info(obj_t, obj_t, obj_t);
extern app_ly_162_bglt allocate_app_ly_cinfo_200_cfa_info();
static obj_t _scnst_cinfo_node3041_91_cfa_info(obj_t, obj_t);
static obj_t _extern_sfun_cinfo_approx3100_201_cfa_info(obj_t, obj_t);
static obj_t _setq_cinfo_loc2903_164_cfa_info(obj_t, obj_t);
extern local_bglt allocate_reshaped_local_100_cfa_info();
static obj_t _box_ref_cinfo_type2794_132_cfa_info(obj_t, obj_t);
static obj_t _select_cinfo_clauses2872_12_cfa_info(obj_t, obj_t);
extern var_bglt set_ex_it_cinfo_var_14_cfa_info(set_ex_it_116_bglt);
static obj_t _funcall_cinfo_fun2928_37_cfa_info(obj_t, obj_t);
static obj_t _select_cinfo__186_cfa_info(obj_t, obj_t);
extern obj_t reshaped_global_name_190_cfa_info(global_bglt);
static obj_t _reshaped_global_value_set_2977_126_cfa_info(obj_t, obj_t, obj_t);
static obj_t _kwote_node_node2962_101_cfa_info(obj_t, obj_t);
static obj_t _extern_sfun_cinfo_top__set_3084_123_cfa_info(obj_t, obj_t, obj_t);
static obj_t struct_object__object_intern_sfun_cinfo2084_8_cfa_info(obj_t, obj_t, obj_t);
extern obj_t select_cinfo_key_set__126_cfa_info(select_bglt, obj_t);
extern bool_t jump_ex_it_cinfo__199_cfa_info(obj_t);
extern cfun_bglt allocate_cfun_cinfo_179_cfa_info();
static obj_t struct_object__object_make_box_cinfo2000_189_cfa_info(obj_t, obj_t, obj_t);
extern scnst_cinfo_0_bglt make_scnst_cinfo_57_cfa_info(obj_t, obj_t, obj_t, approx_bglt);
static obj_t _allocate_funcall_cinfo_40_cfa_info(obj_t);
extern obj_t box_set__o_cinfo_loc_249_cfa_info(box_set__221_bglt);
static obj_t _cfun_cinfo_predicate_of3107_190_cfa_info(obj_t, obj_t);
static obj_t _widening_make_box_cinfo2823_164_cfa_info(obj_t, obj_t);
extern bool_t cfun_cinfo__10_cfa_info(obj_t);
static obj_t _intern_sfun_cinfo_args_set_3062_110_cfa_info(obj_t, obj_t, obj_t);
static obj_t _reshaped_local_occurrence_set_3013_144_cfa_info(obj_t, obj_t, obj_t);
static obj_t _conditional_cinfo_side_effect__set_2892_133_cfa_info(obj_t, obj_t, obj_t);
obj_t cfun_cinfo_200_cfa_info = BUNSPEC;
extern svar_cinfo_166_bglt make_svar_cinfo_148_cfa_info(obj_t, approx_bglt, bool_t);
extern obj_t box_ref_cinfo_type_set__65_cfa_info(box_ref_242_bglt, type_bglt);
extern long reshaped_global_occurrence_72_cfa_info(global_bglt);
static obj_t _widening_kwote_node2956_153_cfa_info(obj_t, obj_t);
static obj_t struct_object__object_make_box_o_cinfo1996_29_cfa_info(obj_t, obj_t, obj_t);
static obj_t _reshaped_local_type3004_251_cfa_info(obj_t, obj_t);
static obj_t _make_box_o_cinfo_type2814_18_cfa_info(obj_t, obj_t);
extern value_bglt reshaped_global_value_27_cfa_info(global_bglt);
static obj_t _box_ref_cinfo_loc2792_145_cfa_info(obj_t, obj_t);
static obj_t _approx_type_locked_3122_59_cfa_info(obj_t, obj_t);
extern bool_t approx_top__34_cfa_info(approx_bglt);
static obj_t _make_box_ref_o_cinfo2771_75_cfa_info(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t _cfun_cinfo_arity3103_73_cfa_info(obj_t, obj_t);
static obj_t _make_box_o_cinfo_value_approx2822_53_cfa_info(obj_t, obj_t);
static obj_t object__struct_kwote_node2046_198_cfa_info(obj_t, obj_t);
extern reshaped_global_160_bglt widening_reshaped_global_26_cfa_info();
extern sfun_bglt allocate_intern_sfun_cinfo_151_cfa_info();
static obj_t _fail_cinfo__61_cfa_info(obj_t, obj_t);
static obj_t object__struct_pre_make_box2002_179_cfa_info(obj_t, obj_t);
static obj_t _approx_top__set_3124_85_cfa_info(obj_t, obj_t, obj_t);
extern conditional_cinfo_212_bglt widening_conditional_cinfo_79_cfa_info(approx_bglt);
static obj_t _reshaped_global_src_set_2997_68_cfa_info(obj_t, obj_t, obj_t);
extern obj_t atom_cinfo_value_110_cfa_info(atom_bglt);
static obj_t _intern_sfun_cinfo_class3067_224_cfa_info(obj_t, obj_t);
static obj_t _reshaped_local_fast_alpha_set_3009_148_cfa_info(obj_t, obj_t, obj_t);
extern obj_t kwote_node_loc_4_cfa_info(kwote_bglt);
static obj_t struct_object__object_scnst_cinfo2080_231_cfa_info(obj_t, obj_t, obj_t);
extern box_ref_o_cinfo_98_bglt widening_box_ref_o_cinfo_200_cfa_info(approx_bglt);
static obj_t _box_set__cinfo_loc2802_157_cfa_info(obj_t, obj_t);
extern obj_t box_ref_o_cinfo_side_effect__set__170_cfa_info(box_ref_242_bglt, obj_t);
extern box_set__221_bglt allocate_box_set__o_cinfo_236_cfa_info();
static obj_t _pragma_cinfo_type2915_46_cfa_info(obj_t, obj_t);
static obj_t _conditional_cinfo_true2897_11_cfa_info(obj_t, obj_t);
extern bool_t kwote_node__206_cfa_info(obj_t);
static obj_t _kwote_cinfo__102_cfa_info(obj_t, obj_t);
obj_t reshaped_global_160_cfa_info = BUNSPEC;
extern atom_cinfo_155_bglt make_atom_cinfo_25_cfa_info(obj_t, type_bglt, obj_t, approx_bglt);
extern object_bglt struct_object__object_93___object(object_bglt, obj_t);
static obj_t struct_object__object_box_ref_cinfo1988_119_cfa_info(obj_t, obj_t, obj_t);
extern pre_make_box_186_bglt widening_pre_make_box_219_cfa_info();
extern obj_t add_method__1___object(obj_t, obj_t, obj_t);
static obj_t _cfun_cinfo_approx3118_58_cfa_info(obj_t, obj_t);
extern obj_t box_ref_cinfo_side_effect__63_cfa_info(box_ref_242_bglt);
extern obj_t intern_sfun_cinfo_stack_allocator_82_cfa_info(sfun_bglt);
static obj_t _allocate_select_cinfo_74_cfa_info(obj_t);
static obj_t _reshaped_local_value_set_3005_6_cfa_info(obj_t, obj_t, obj_t);
extern obj_t reshaped_local_occurrence_set__7_cfa_info(local_bglt, long);
extern obj_t global_ast_var;
static obj_t _box_set__o_cinfo_type_set_2783_250_cfa_info(obj_t, obj_t, obj_t);
static obj_t _funcall_cinfo_fun_set_2927_96_cfa_info(obj_t, obj_t, obj_t);
static obj_t _funcall_cinfo_va_approx2934_237_cfa_info(obj_t, obj_t);
extern obj_t reshaped_local_removable_103_cfa_info(local_bglt);
extern type_bglt select_cinfo_type_249_cfa_info(select_bglt);
extern obj_t conditional_cinfo_false_set__59_cfa_info(conditional_bglt, node_bglt);
static obj_t _reshaped_global_library__set_2992_245_cfa_info(obj_t, obj_t, obj_t);
static obj_t _extern_sfun_cinfo_predicate_of_set_3080_197_cfa_info(obj_t, obj_t, obj_t);
extern node_bglt jump_ex_it_cinfo_value_33_cfa_info(jump_ex_it_184_bglt);
static obj_t object__struct_select_cinfo2014_57_cfa_info(obj_t, obj_t);
extern set_ex_it_cinfo_168_bglt widening_set_ex_it_cinfo_59_cfa_info(approx_bglt);
extern obj_t app_ly_cinfo_loc_252_cfa_info(app_ly_162_bglt);
extern svar_bglt allocate_pre_clo_env_40_cfa_info();
extern obj_t conditional_cinfo_key_set__171_cfa_info(conditional_bglt, obj_t);
obj_t box_ref_o_cinfo_98_cfa_info = BUNSPEC;
extern obj_t pragma_ast_node;
extern bool_t funcall_cinfo_type_error_noticed__56_cfa_info(funcall_cinfo_75_bglt);
extern box_ref_242_bglt allocate_box_ref_cinfo_31_cfa_info();
extern obj_t pre_make_box_side_effect__set__136_cfa_info(make_box_202_bglt, obj_t);
static obj_t _intern_sfun_cinfo_top__set_3056_140_cfa_info(obj_t, obj_t, obj_t);
extern obj_t box_set__cinfo_type_set__127_cfa_info(box_set__221_bglt, type_bglt);
static obj_t _pragma_cinfo_format2918_148_cfa_info(obj_t, obj_t);
static obj_t _intern_sfun_cinfo_the_closure3059_177_cfa_info(obj_t, obj_t);
static obj_t _select_cinfo_loc2865_85_cfa_info(obj_t, obj_t);
static obj_t struct_object__object_pre_make_box2004_221_cfa_info(obj_t, obj_t, obj_t);
static obj_t _make_box_o_cinfo_approx2821_80_cfa_info(obj_t, obj_t);
static obj_t object__struct_reshaped_global2054_140_cfa_info(obj_t, obj_t);
extern obj_t cvar_ast_var;
static obj_t struct_object__object_reshaped_local2060_138_cfa_info(obj_t, obj_t, obj_t);
extern obj_t set_ex_it_116_ast_node;
obj_t set_ex_it_cinfo_168_cfa_info = BUNSPEC;
extern jump_ex_it_cinfo_139_bglt make_jump_ex_it_cinfo_16_cfa_info(obj_t, type_bglt, node_bglt, node_bglt, approx_bglt);
static obj_t _cfun_cinfo_the_closure3113_240_cfa_info(obj_t, obj_t);
static obj_t _box_set__cinfo_value_set_2807_175_cfa_info(obj_t, obj_t, obj_t);
extern obj_t make_box_o_cinfo_value_set__222_cfa_info(make_box_202_bglt, node_bglt);
static obj_t _intern_sfun_cinfo_stamp_set_3073_246_cfa_info(obj_t, obj_t, obj_t);
extern obj_t find_super_class_method_167___object(object_bglt, obj_t, obj_t);
extern cvar_bglt allocate_cvar_cinfo_69_cfa_info();
static obj_t _pragma_cinfo_args_set_2919_169_cfa_info(obj_t, obj_t, obj_t);
static obj_t _make_fail_cinfo2876_73_cfa_info(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t make_box_o_cinfo_type_set__41_cfa_info(make_box_202_bglt, type_bglt);
extern obj_t make_box_o_cinfo_loc_160_cfa_info(make_box_202_bglt);
extern bool_t cvar_cinfo_macro__62_cfa_info(cvar_bglt);
obj_t cvar_cinfo_53_cfa_info = BUNSPEC;
extern bool_t fail_cinfo__175_cfa_info(obj_t);
static obj_t object__struct_make_box_cinfo1998_55_cfa_info(obj_t, obj_t);
extern approx_bglt make_box_cinfo_approx_244_cfa_info(make_box_cinfo_127_bglt);
static obj_t _extern_sfun_cinfo_class_set_3094_243_cfa_info(obj_t, obj_t, obj_t);
static obj_t _cfun_cinfo_side_effect__set_3104_38_cfa_info(obj_t, obj_t, obj_t);
static obj_t _reshaped_global_evaluable_2991_2_cfa_info(obj_t, obj_t);
extern approx_bglt sexit_cinfo_approx_118_cfa_info(sexit_cinfo_49_bglt);
obj_t jump_ex_it_cinfo_139_cfa_info = BUNSPEC;
static obj_t _intern_sfun_cinfo_top_3057_117_cfa_info(obj_t, obj_t);
extern obj_t intern_sfun_cinfo_dsssl_keywords_133_cfa_info(sfun_bglt);
static obj_t _atom_cinfo_approx2970_76_cfa_info(obj_t, obj_t);
extern fail_bglt allocate_fail_cinfo_138_cfa_info();
extern obj_t atom_cinfo_value_set__32_cfa_info(atom_bglt, obj_t);
extern extern_sfun_cinfo_6_bglt make_extern_sfun_cinfo_180_cfa_info(long, obj_t, obj_t, obj_t, bool_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, approx_bglt);
static obj_t _intern_sfun_cinfo_predicate_of_set_3052_3_cfa_info(obj_t, obj_t, obj_t);
extern obj_t intern_sfun_cinfo_predicate_of_set__1_cfa_info(sfun_bglt, obj_t);
static obj_t struct_object__object_select_cinfo2016_231_cfa_info(obj_t, obj_t, obj_t);
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t reshaped_local_user__set__128_cfa_info(local_bglt, bool_t);
obj_t fail_cinfo_75_cfa_info = BUNSPEC;
extern node_bglt set_ex_it_cinfo_body_103_cfa_info(set_ex_it_116_bglt);
extern obj_t cfun_cinfo_infix__set__3_cfa_info(cfun_bglt, bool_t);
static obj_t _pre_make_box_value_set_2841_45_cfa_info(obj_t, obj_t, obj_t);
extern obj_t box_ref_o_cinfo_side_effect__156_cfa_info(box_ref_242_bglt);
static obj_t _make_box_o_cinfo_key2817_186_cfa_info(obj_t, obj_t);
static obj_t _make_cvar_cinfo3027_54_cfa_info(obj_t, obj_t, obj_t);
extern obj_t app_ly_cinfo_arg_set__121_cfa_info(app_ly_162_bglt, node_bglt);
static obj_t _funcall_cinfo_type_error_noticed_2938_155_cfa_info(obj_t, obj_t);
static obj_t _make_box_set__cinfo2801_97_cfa_info(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern select_cinfo_150_bglt widening_select_cinfo_152_cfa_info(approx_bglt);
static obj_t _reshaped_global_import_set_2988_212_cfa_info(obj_t, obj_t, obj_t);
extern obj_t reshaped_local_type_set__241_cfa_info(local_bglt, type_bglt);
extern obj_t make_box_o_cinfo_key_140_cfa_info(make_box_202_bglt);
extern obj_t intern_sfun_cinfo_class_set__85_cfa_info(sfun_bglt, obj_t);
extern make_box_o_cinfo_96_bglt make_make_box_o_cinfo_242_cfa_info(obj_t, type_bglt, obj_t, obj_t, node_bglt, approx_bglt, approx_bglt);
obj_t intern_sfun_cinfo_192_cfa_info = BUNSPEC;
extern approx_bglt box_set__cinfo_approx_234_cfa_info(box_set__cinfo_94_bglt);
static obj_t _extern_sfun_cinfo_the_closure_set_3086_194_cfa_info(obj_t, obj_t, obj_t);
extern reshaped_local_224_bglt widening_reshaped_local_92_cfa_info(obj_t);
extern obj_t approx_top__set__151_cfa_info(approx_bglt, bool_t);
static obj_t _extern_sfun_cinfo_dsssl_keywords3097_20_cfa_info(obj_t, obj_t);
static obj_t _reshaped_global_name_set_2973_23_cfa_info(obj_t, obj_t, obj_t);
static obj_t _jump_ex_it_cinfo_loc2845_144_cfa_info(obj_t, obj_t);
extern obj_t set_ex_it_cinfo_loc_59_cfa_info(set_ex_it_116_bglt);
static obj_t _fail_cinfo_approx2886_158_cfa_info(obj_t, obj_t);
static obj_t _widening_intern_sfun_cinfo3047_38_cfa_info(obj_t, obj_t, obj_t);
extern obj_t module_initialization_70_cfa_info(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
static obj_t _extern_sfun_cinfo_dsssl_keywords_set_3096_249_cfa_info(obj_t, obj_t, obj_t);
extern reshaped_global_160_bglt make_reshaped_global_202_cfa_info(obj_t, obj_t, type_bglt, value_bglt, obj_t, obj_t, obj_t, long, obj_t, obj_t, bool_t, bool_t, bool_t, obj_t, obj_t);
static obj_t _reshaped_local_removable_set_3011_28_cfa_info(obj_t, obj_t, obj_t);
extern pre_make_box_186_bglt make_pre_make_box_82_cfa_info(obj_t, type_bglt, obj_t, obj_t, node_bglt);
obj_t pre_clo_env_191_cfa_info = BUNSPEC;
static obj_t _reshaped_global_name2974_143_cfa_info(obj_t, obj_t);
extern node_bglt fail_cinfo_proc_58_cfa_info(fail_bglt);
static obj_t _allocate_pragma_cinfo_82_cfa_info(obj_t);
obj_t make_box_o_cinfo_96_cfa_info = BUNSPEC;
static obj_t _extern_sfun_cinfo_stack_allocator3083_83_cfa_info(obj_t, obj_t);
extern kwote_node_102_bglt widening_kwote_node_16_cfa_info(node_bglt);
extern obj_t reshaped_local_id_99_cfa_info(local_bglt);
extern obj_t box_ref_cinfo_side_effect__set__36_cfa_info(box_ref_242_bglt, obj_t);
extern bool_t approx_type_locked__124_cfa_info(approx_bglt);
extern node_bglt app_ly_cinfo_fun_95_cfa_info(app_ly_162_bglt);
extern obj_t approx_lost_stamp_set__114_cfa_info(approx_bglt, long);
static obj_t _select_cinfo_item_type2873_27_cfa_info(obj_t, obj_t);
extern obj_t reshaped_global_evaluable__set__240_cfa_info(global_bglt, bool_t);
extern obj_t reshaped_global_id_236_cfa_info(global_bglt);
static obj_t _cfun_cinfo_args_type3114_135_cfa_info(obj_t, obj_t);
static obj_t _allocate_kwote_cinfo_178_cfa_info(obj_t);
extern box_ref_o_cinfo_98_bglt make_box_ref_o_cinfo_177_cfa_info(obj_t, type_bglt, obj_t, obj_t, var_bglt, approx_bglt);
extern box_set__o_cinfo_6_bglt widening_box_set__o_cinfo_49_cfa_info(approx_bglt);
static obj_t _box_ref_o_cinfo_side_effect__set_2775_59_cfa_info(obj_t, obj_t, obj_t);
extern approx_bglt pragma_cinfo_approx_152_cfa_info(pragma_cinfo_220_bglt);
static obj_t _widening_funcall_cinfo2922_80_cfa_info(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t _extern_sfun_cinfo_class3095_125_cfa_info(obj_t, obj_t);
static obj_t _reshaped_global_user__set_2994_92_cfa_info(obj_t, obj_t, obj_t);
static obj_t _setq_cinfo_var_set_2906_217_cfa_info(obj_t, obj_t, obj_t);
static obj_t _pre_clo_env_loc3038_171_cfa_info(obj_t, obj_t);
extern cfun_cinfo_200_bglt make_cfun_cinfo_44_cfa_info(long, obj_t, obj_t, obj_t, bool_t, obj_t, obj_t, bool_t, bool_t, approx_bglt);
static obj_t _widening_pragma_cinfo2911_177_cfa_info(obj_t, obj_t);
extern node_bglt fail_cinfo_obj_134_cfa_info(fail_bglt);
obj_t pre_make_box_186_cfa_info = BUNSPEC;
extern obj_t intern_sfun_cinfo_loc_set__209_cfa_info(sfun_bglt, obj_t);
static obj_t _widening_kwote_cinfo2949_69_cfa_info(obj_t, obj_t);
static obj_t _allocate_kwote_node_49_cfa_info(obj_t);
extern node_bglt fail_cinfo_msg_186_cfa_info(fail_bglt);
extern kwote_cinfo_48_bglt make_kwote_cinfo_77_cfa_info(obj_t, type_bglt, obj_t, approx_bglt);
static obj_t _allocate_box_set__cinfo_187_cfa_info(obj_t);
extern set_ex_it_cinfo_168_bglt make_set_ex_it_cinfo_156_cfa_info(obj_t, type_bglt, var_bglt, node_bglt, approx_bglt);
extern sfun_bglt allocate_extern_sfun_cinfo_223_cfa_info();
static obj_t struct_object__object_box_ref_o_cinfo1980_207_cfa_info(obj_t, obj_t, obj_t);
static obj_t _kwote_cinfo_approx2955_234_cfa_info(obj_t, obj_t);
extern intern_sfun_cinfo_192_bglt widening_intern_sfun_cinfo_70_cfa_info(approx_bglt, long);
static obj_t _make_app_ly_cinfo2940_73_cfa_info(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t _make_approx3119_236_cfa_info(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t _widening_fail_cinfo2875_121_cfa_info(obj_t, obj_t);
static obj_t _pre_make_box__20_cfa_info(obj_t, obj_t);
static obj_t _intern_sfun_cinfo_args3063_161_cfa_info(obj_t, obj_t);
static obj_t _allocate_make_box_cinfo_36_cfa_info(obj_t);
static obj_t object__struct_fail_cinfo2018_129_cfa_info(obj_t, obj_t);
static obj_t _box_ref_o_cinfo_var_set_2777_55_cfa_info(obj_t, obj_t, obj_t);
extern type_bglt pragma_cinfo_type_144_cfa_info(pragma_bglt);
static obj_t _pragma_cinfo_args2920_117_cfa_info(obj_t, obj_t);
static obj_t _make_box_o_cinfo_value2819_230_cfa_info(obj_t, obj_t);
extern obj_t kwote_node_value_143_cfa_info(kwote_bglt);
static obj_t _make_svar_cinfo3031_143_cfa_info(obj_t, obj_t, obj_t, obj_t);
static obj_t _kwote_node_type_set_2959_77_cfa_info(obj_t, obj_t, obj_t);
extern obj_t fail_cinfo_loc_64_cfa_info(fail_bglt);
extern long reshaped_local_occurrence_171_cfa_info(local_bglt);
static obj_t _make_kwote_cinfo2950_155_cfa_info(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t _set_ex_it_cinfo_body2861_99_cfa_info(obj_t, obj_t);
static obj_t object__struct_reshaped_local2058_214_cfa_info(obj_t, obj_t);
extern obj_t funcall_cinfo_type_error_noticed__set__27_cfa_info(funcall_cinfo_75_bglt, bool_t);
static obj_t _kwote_node_type2960_123_cfa_info(obj_t, obj_t);
static obj_t _app_ly_cinfo_fun2945_39_cfa_info(obj_t, obj_t);
static obj_t _widening_sexit_cinfo3019_115_cfa_info(obj_t, obj_t);
extern obj_t extern_sfun_cinfo_loc_249_cfa_info(sfun_bglt);
extern type_bglt conditional_cinfo_type_74_cfa_info(conditional_bglt);
extern obj_t jump_ex_it_cinfo_exit_set__81_cfa_info(jump_ex_it_184_bglt, node_bglt);
static obj_t _scnst_cinfo__113_cfa_info(obj_t, obj_t);
extern obj_t reshaped_global_value_set__202_cfa_info(global_bglt, value_bglt);
extern sexit_cinfo_49_bglt widening_sexit_cinfo_97_cfa_info(approx_bglt);
extern obj_t scnst_cinfo_class_89_cfa_info(scnst_bglt);
extern long class_num_218___object(obj_t);
static obj_t _box_ref_o_cinfo_var2778_106_cfa_info(obj_t, obj_t);
static obj_t _reshaped_local_binding_value3018_38_cfa_info(obj_t, obj_t);
static obj_t _widening_cvar_cinfo3026_143_cfa_info(obj_t, obj_t);
extern scnst_bglt allocate_scnst_cinfo_156_cfa_info();
extern bool_t sexit_cinfo__140_cfa_info(obj_t);
extern obj_t svar_ast_var;
static obj_t object__struct_cvar_cinfo2066_213_cfa_info(obj_t, obj_t);
static obj_t _pragma_cinfo_key_170_cfa_info(obj_t, obj_t);
static obj_t _extern_sfun_cinfo_property3089_138_cfa_info(obj_t, obj_t);
static obj_t _set_ex_it_cinfo_type_set_2856_16_cfa_info(obj_t, obj_t, obj_t);
extern bool_t app_ly_cinfo__179_cfa_info(obj_t);
extern obj_t intern_sfun_cinfo_property_154_cfa_info(sfun_bglt);
extern select_cinfo_150_bglt make_select_cinfo_178_cfa_info(obj_t, type_bglt, obj_t, obj_t, node_bglt, obj_t, type_bglt, approx_bglt);
extern pragma_cinfo_220_bglt widening_pragma_cinfo_85_cfa_info(approx_bglt);
static obj_t _conditional_cinfo__117_cfa_info(obj_t, obj_t);
extern type_bglt make_box_o_cinfo_type_235_cfa_info(make_box_202_bglt);
static obj_t _box_set__cinfo_type2804_252_cfa_info(obj_t, obj_t);
extern approx_bglt svar_cinfo_approx_144_cfa_info(svar_cinfo_166_bglt);
extern obj_t reshaped_global_fast_alpha_178_cfa_info(global_bglt);
static obj_t _make_box_cinfo_key_set__204_cfa_info(obj_t, obj_t, obj_t);
static obj_t _intern_sfun_cinfo_property_set_3060_59_cfa_info(obj_t, obj_t, obj_t);
static obj_t _reshaped_local_user__set_3015_24_cfa_info(obj_t, obj_t, obj_t);
extern bool_t intern_sfun_cinfo__209_cfa_info(obj_t);
extern obj_t scnst_ast_var;
static obj_t _box_set__o_cinfo_var_set_2785_45_cfa_info(obj_t, obj_t, obj_t);
static obj_t _make_jump_ex_it_cinfo2844_63_cfa_info(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t _intern_sfun_cinfo_property3061_231_cfa_info(obj_t, obj_t);
static obj_t _cfun_cinfo_top_3111_22_cfa_info(obj_t, obj_t);
obj_t reshaped_local_224_cfa_info = BUNSPEC;
static obj_t _cfun_cinfo_macro_3115_10_cfa_info(obj_t, obj_t);
static obj_t _make_sexit_cinfo3020_88_cfa_info(obj_t, obj_t, obj_t, obj_t);
static obj_t _sexit_cinfo_handler3022_94_cfa_info(obj_t, obj_t);
static obj_t _pre_make_box_key2840_195_cfa_info(obj_t, obj_t);
static obj_t _svar_cinfo__163_cfa_info(obj_t, obj_t);
extern obj_t pre_clo_env_loc_179_cfa_info(svar_bglt);
extern obj_t kwote_cinfo_value_171_cfa_info(kwote_bglt);
extern obj_t make_box_cinfo_type_set__156_cfa_info(make_box_202_bglt, type_bglt);
static obj_t _box_set__o_cinfo_loc2782_255_cfa_info(obj_t, obj_t);
extern node_bglt setq_cinfo_value_181_cfa_info(setq_bglt);
obj_t select_cinfo_150_cfa_info = BUNSPEC;
static obj_t object__struct_extern_sfun_cinfo2086_160_cfa_info(obj_t, obj_t);
extern node_bglt app_ly_cinfo_arg_233_cfa_info(app_ly_162_bglt);
static obj_t _make_box_o_cinfo_approx_set_2820_218_cfa_info(obj_t, obj_t, obj_t);
static obj_t _box_set__o_cinfo_type2784_75_cfa_info(obj_t, obj_t);
extern bool_t cfun_cinfo_infix__163_cfa_info(cfun_bglt);
extern box_ref_cinfo_214_bglt make_box_ref_cinfo_128_cfa_info(obj_t, type_bglt, obj_t, obj_t, var_bglt, approx_bglt);
extern type_bglt box_set__o_cinfo_type_128_cfa_info(box_set__221_bglt);
extern obj_t funcall_cinfo_fun_set__87_cfa_info(funcall_bglt, node_bglt);
extern obj_t intern_sfun_cinfo_args_set__79_cfa_info(sfun_bglt, obj_t);
static obj_t _pre_make_box_type2836_191_cfa_info(obj_t, obj_t);
static obj_t _reshaped_global_user_2995_142_cfa_info(obj_t, obj_t);
static obj_t _make_conditional_cinfo2888_155_cfa_info(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern cvar_cinfo_53_bglt make_cvar_cinfo_209_cfa_info(bool_t, approx_bglt);
extern obj_t kwote_node_type_set__67_cfa_info(kwote_bglt, type_bglt);
extern obj_t make_box_cinfo_loc_173_cfa_info(make_box_202_bglt);
static obj_t _allocate_jump_ex_it_cinfo_34_cfa_info(obj_t);
extern obj_t extern_sfun_cinfo_stack_allocator_17_cfa_info(sfun_bglt);
static obj_t _make_box_cinfo_side_effect_2829_211_cfa_info(obj_t, obj_t);
extern bool_t reshaped_local__109_cfa_info(obj_t);
static obj_t _jump_ex_it_cinfo_type2847_201_cfa_info(obj_t, obj_t);
extern obj_t set_ex_it_cinfo_body_set__25_cfa_info(set_ex_it_116_bglt, node_bglt);
extern node_bglt make_box_o_cinfo_value_153_cfa_info(make_box_202_bglt);
static obj_t struct_object__object_approx2096_124_cfa_info(obj_t, obj_t, obj_t);
static obj_t object__struct_pre_clo_env2074_162_cfa_info(obj_t, obj_t);
extern obj_t extern_sfun_cinfo_predicate_of_set__5_cfa_info(sfun_bglt, obj_t);
static obj_t _box_set__cinfo_value2808_85_cfa_info(obj_t, obj_t);
extern bool_t reshaped_global_library__243_cfa_info(global_bglt);
static obj_t _reshaped_global__169_cfa_info(obj_t, obj_t);
static obj_t _reshaped_global_occurrence2986_61_cfa_info(obj_t, obj_t);
extern obj_t reshaped_local_name_set__115_cfa_info(local_bglt, obj_t);
static obj_t _funcall_cinfo_args_set_2929_237_cfa_info(obj_t, obj_t, obj_t);
static obj_t imported_modules_init_94_cfa_info();
extern type_bglt fail_cinfo_type_26_cfa_info(fail_bglt);
extern fail_cinfo_75_bglt make_fail_cinfo_148_cfa_info(obj_t, type_bglt, node_bglt, node_bglt, node_bglt, approx_bglt);
static obj_t _box_set__o_cinfo_approx2789_243_cfa_info(obj_t, obj_t);
extern obj_t conditional_cinfo_test_set__167_cfa_info(conditional_bglt, node_bglt);
extern obj_t box_set__o_cinfo_value_set__181_cfa_info(box_set__221_bglt, node_bglt);
extern obj_t reshaped_global_src_255_cfa_info(global_bglt);
static obj_t _extern_sfun_cinfo_the_closure3087_249_cfa_info(obj_t, obj_t);
static obj_t _reshaped_global_access_set_2979_29_cfa_info(obj_t, obj_t, obj_t);
static obj_t _reshaped_global_evaluable__set_2990_171_cfa_info(obj_t, obj_t, obj_t);
extern obj_t cfun_cinfo_the_closure_set__73_cfa_info(cfun_bglt, obj_t);
extern box_ref_cinfo_214_bglt widening_box_ref_cinfo_71_cfa_info(approx_bglt);
static obj_t _setq_cinfo_var2907_183_cfa_info(obj_t, obj_t);
obj_t extern_sfun_cinfo_6_cfa_info = BUNSPEC;
extern obj_t pragma_cinfo_loc_22_cfa_info(pragma_bglt);
static obj_t _widening_pre_clo_env_41_cfa_info(obj_t);
extern obj_t extern_sfun_cinfo_predicate_of_245_cfa_info(sfun_bglt);
static obj_t _reshaped_global_removable2984_107_cfa_info(obj_t, obj_t);
extern obj_t reshaped_local_removable_set__25_cfa_info(local_bglt, obj_t);
extern obj_t fail_cinfo_type_set__85_cfa_info(fail_bglt, type_bglt);
static obj_t _widening_svar_cinfo3030_209_cfa_info(obj_t, obj_t, obj_t);
extern obj_t make_box_cinfo_key_12_cfa_info(make_box_202_bglt);
extern obj_t make_box_o_cinfo_approx_set__53_cfa_info(make_box_o_cinfo_96_bglt, approx_bglt);
extern type_bglt atom_cinfo_type_135_cfa_info(atom_bglt);
static obj_t _set_ex_it_cinfo_loc2855_151_cfa_info(obj_t, obj_t);
static obj_t object__struct_svar_cinfo2070_189_cfa_info(obj_t, obj_t);
extern obj_t pragma_cinfo_key_set__146_cfa_info(pragma_bglt, obj_t);
obj_t scnst_cinfo_0_cfa_info = BUNSPEC;
extern obj_t intern_sfun_cinfo_predicate_of_250_cfa_info(sfun_bglt);
extern approx_bglt atom_cinfo_approx_215_cfa_info(atom_cinfo_155_bglt);
static obj_t struct_object__object_funcall_cinfo2036_168_cfa_info(obj_t, obj_t, obj_t);
static obj_t _make_box_set__o_cinfo2781_191_cfa_info(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t struct_object__object_conditional_cinfo2024_17_cfa_info(obj_t, obj_t, obj_t);
extern obj_t set_ex_it_cinfo_type_set__35_cfa_info(set_ex_it_116_bglt, type_bglt);
extern obj_t scnst_cinfo_loc_35_cfa_info(scnst_bglt);
extern obj_t pragma_cinfo_side_effect__set__54_cfa_info(pragma_bglt, obj_t);
extern obj_t pragma_cinfo_args_set__20_cfa_info(pragma_bglt, obj_t);
static obj_t _allocate_make_box_o_cinfo_133_cfa_info(obj_t);
static obj_t _reshaped_local_value3006_248_cfa_info(obj_t, obj_t);
extern approx_bglt box_ref_o_cinfo_approx_223_cfa_info(box_ref_o_cinfo_98_bglt);
extern bool_t svar_cinfo__59_cfa_info(obj_t);
static obj_t _intern_sfun_cinfo_stamp3074_165_cfa_info(obj_t, obj_t);
extern obj_t approx_allocs_203_cfa_info(approx_bglt);
static obj_t _make_box_cinfo_value_set_2830_42_cfa_info(obj_t, obj_t, obj_t);
static obj_t _extern_sfun_cinfo__255_cfa_info(obj_t, obj_t);
extern obj_t extern_sfun_cinfo_property_set__166_cfa_info(sfun_bglt, obj_t);
extern obj_t box_ref_cinfo_key_set__110_cfa_info(box_ref_242_bglt, obj_t);
extern approx_bglt box_ref_cinfo_approx_49_cfa_info(box_ref_cinfo_214_bglt);
static obj_t _box_ref_cinfo_var2798_240_cfa_info(obj_t, obj_t);
extern obj_t svar_cinfo_loc_67_cfa_info(svar_bglt);
extern pragma_cinfo_220_bglt make_pragma_cinfo_123_cfa_info(obj_t, type_bglt, obj_t, obj_t, obj_t, obj_t, approx_bglt);
extern type_bglt box_ref_cinfo_type_23_cfa_info(box_ref_242_bglt);
extern type_bglt setq_cinfo_type_65_cfa_info(setq_bglt);
extern obj_t conditional_cinfo_side_effect__139_cfa_info(conditional_bglt);
extern obj_t pragma_cinfo_key_115_cfa_info(pragma_bglt);
extern obj_t app_ly_162_ast_node;
extern make_box_202_bglt allocate_pre_make_box_175_cfa_info();
extern obj_t scnst_cinfo_loc_set__10_cfa_info(scnst_bglt, obj_t);
extern obj_t pre_make_box_side_effect__126_cfa_info(make_box_202_bglt);
static obj_t _make_set_ex_it_cinfo2854_65_cfa_info(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t _set_ex_it_cinfo_body_set_2860_199_cfa_info(obj_t, obj_t, obj_t);
extern node_bglt conditional_cinfo_true_183_cfa_info(conditional_bglt);
extern obj_t make_box_o_cinfo_key_set__68_cfa_info(make_box_202_bglt, obj_t);
extern obj_t cfun_ast_var;
static obj_t _box_ref_o_cinfo_approx2779_91_cfa_info(obj_t, obj_t);
extern obj_t box_ref_cinfo_var_set__56_cfa_info(box_ref_242_bglt, var_bglt);
extern obj_t extern_sfun_cinfo_dsssl_keywords_3_cfa_info(sfun_bglt);
extern obj_t funcall_cinfo_args_85_cfa_info(funcall_bglt);
extern setq_cinfo_191_bglt widening_setq_cinfo_173_cfa_info(approx_bglt);
static obj_t _select_cinfo_test2871_18_cfa_info(obj_t, obj_t);
extern node_bglt jump_ex_it_cinfo_exit_67_cfa_info(jump_ex_it_184_bglt);
static obj_t _intern_sfun_cinfo_body3065_40_cfa_info(obj_t, obj_t);
extern box_set__o_cinfo_6_bglt make_box_set__o_cinfo_60_cfa_info(obj_t, type_bglt, var_bglt, node_bglt, approx_bglt);
static obj_t _fail_cinfo_obj2885_174_cfa_info(obj_t, obj_t);
static obj_t object__struct_scnst_cinfo2078_132_cfa_info(obj_t, obj_t);
extern obj_t select_cinfo_side_effect__33_cfa_info(select_bglt);
static obj_t _make_box_cinfo_type2827_75_cfa_info(obj_t, obj_t);
static obj_t _reshaped_local_occurrence3014_246_cfa_info(obj_t, obj_t);
extern approx_bglt allocate_approx_85_cfa_info();
static obj_t _set_ex_it_cinfo_approx2862_120_cfa_info(obj_t, obj_t);
static obj_t _intern_sfun_cinfo_the_closure_set_3058_172_cfa_info(obj_t, obj_t, obj_t);
extern extern_sfun_cinfo_6_bglt widening_extern_sfun_cinfo_222_cfa_info(approx_bglt);
static obj_t _box_set__cinfo_var2806_123_cfa_info(obj_t, obj_t);
extern obj_t funcall_cinfo_type_set__85_cfa_info(funcall_bglt, type_bglt);
static obj_t _kwote_node_value2961_201_cfa_info(obj_t, obj_t);
obj_t pragma_cinfo_220_cfa_info = BUNSPEC;
static obj_t _kwote_cinfo_type_set_2952_45_cfa_info(obj_t, obj_t, obj_t);
extern long cfun_cinfo_arity_247_cfa_info(cfun_bglt);
extern value_bglt reshaped_local_value_240_cfa_info(local_bglt);
static obj_t _allocate_setq_cinfo_116_cfa_info(obj_t);
extern obj_t app_ly_cinfo_type_set__211_cfa_info(app_ly_162_bglt, type_bglt);
extern var_bglt box_ref_cinfo_var_121_cfa_info(box_ref_242_bglt);
static obj_t _widening_jump_ex_it_cinfo2843_227_cfa_info(obj_t, obj_t);
obj_t box_set__o_cinfo_6_cfa_info = BUNSPEC;
extern obj_t app_ly_cinfo_fun_set__61_cfa_info(app_ly_162_bglt, node_bglt);
static obj_t _intern_sfun_cinfo_dsssl_keywords_set_3068_50_cfa_info(obj_t, obj_t, obj_t);
static obj_t _make_box_o_cinfo__52_cfa_info(obj_t, obj_t);
extern bool_t intern_sfun_cinfo_top__47_cfa_info(sfun_bglt);
static obj_t _widening_select_cinfo2863_4_cfa_info(obj_t, obj_t);
static obj_t _fail_cinfo_proc2881_18_cfa_info(obj_t, obj_t);
static obj_t _allocate_reshaped_global_82_cfa_info(obj_t);
extern bool_t box_set__cinfo__218_cfa_info(obj_t);
static obj_t library_modules_init_112_cfa_info();
static obj_t _pragma_cinfo_side_effect_2917_92_cfa_info(obj_t, obj_t);
static obj_t object__struct_approx2094_141_cfa_info(obj_t, obj_t);
static obj_t _make_box_o_cinfo_type_set_2813_55_cfa_info(obj_t, obj_t, obj_t);
extern bool_t pre_clo_env__121_cfa_info(obj_t);
static obj_t _approx_lost_stamp_set_3126_117_cfa_info(obj_t, obj_t, obj_t);
static obj_t _svar_cinfo_loc_set_3032_170_cfa_info(obj_t, obj_t, obj_t);
static obj_t _fail_cinfo_loc2877_16_cfa_info(obj_t, obj_t);
static obj_t _jump_ex_it_cinfo_value_set_2850_59_cfa_info(obj_t, obj_t, obj_t);
extern bool_t pragma_cinfo__149_cfa_info(obj_t);
static obj_t _intern_sfun_cinfo_stack_allocator3055_135_cfa_info(obj_t, obj_t);
static obj_t _app_ly_cinfo_arg2947_88_cfa_info(obj_t, obj_t);
static obj_t _cfun_cinfo_the_closure_set_3112_43_cfa_info(obj_t, obj_t, obj_t);
static obj_t object__struct_box_ref_o_cinfo1978_69_cfa_info(obj_t, obj_t);
extern bool_t reshaped_global__139_cfa_info(obj_t);
static obj_t _allocate_box_ref_o_cinfo_197_cfa_info(obj_t);
extern obj_t extern_sfun_cinfo_side_effect__154_cfa_info(sfun_bglt);
static obj_t _reshaped_global_id2972_26_cfa_info(obj_t, obj_t);
extern node_bglt pre_make_box_value_157_cfa_info(make_box_202_bglt);
static obj_t _extern_sfun_cinfo_property_set_3088_67_cfa_info(obj_t, obj_t, obj_t);
extern obj_t make_struct(obj_t, long, obj_t);
extern obj_t intern_sfun_cinfo_top__set__70_cfa_info(sfun_bglt, bool_t);
extern long extern_sfun_cinfo_arity_43_cfa_info(sfun_bglt);
extern obj_t intern_sfun_cinfo_side_effect__206_cfa_info(sfun_bglt);
extern obj_t intern_sfun_cinfo_property_set__111_cfa_info(sfun_bglt, obj_t);
extern obj_t extern_sfun_cinfo_args_set__187_cfa_info(sfun_bglt, obj_t);
extern obj_t sexit_cinfo_handler_set__65_cfa_info(sexit_bglt, obj_t);
static obj_t _approx__184_cfa_info(obj_t, obj_t);
extern long reshaped_local_key_22_cfa_info(local_bglt);
extern type_bglt reshaped_global_type_121_cfa_info(global_bglt);
extern obj_t funcall_cinfo_strength_95_cfa_info(funcall_bglt);
static obj_t _box_set__cinfo_type_set_2803_239_cfa_info(obj_t, obj_t, obj_t);
static obj_t _make_make_box_o_cinfo2811_50_cfa_info(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern kwote_bglt allocate_kwote_cinfo_134_cfa_info();
extern obj_t fail_cinfo_msg_set__145_cfa_info(fail_bglt, node_bglt);
extern approx_bglt kwote_cinfo_approx_226_cfa_info(kwote_cinfo_48_bglt);
static obj_t _make_box_ref_cinfo2791_237_cfa_info(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern kwote_bglt allocate_kwote_node_139_cfa_info();
static obj_t _allocate_set_ex_it_cinfo_22_cfa_info(obj_t);
extern select_bglt allocate_select_cinfo_105_cfa_info();
extern obj_t cfun_cinfo_side_effect__set__194_cfa_info(cfun_bglt, obj_t);
extern obj_t box_ref_o_cinfo_type_set__20_cfa_info(box_ref_242_bglt, type_bglt);
extern obj_t fail_cinfo_obj_set__135_cfa_info(fail_bglt, node_bglt);
extern node_bglt select_cinfo_test_124_cfa_info(select_bglt);
static obj_t _select_cinfo_key_1_cfa_info(obj_t, obj_t);
extern obj_t cfun_cinfo_stack_allocator_172_cfa_info(cfun_bglt);
extern obj_t reshaped_local_value_set__28_cfa_info(local_bglt, value_bglt);
extern bool_t make_box_o_cinfo__221_cfa_info(obj_t);
static obj_t _allocate_sexit_cinfo_64_cfa_info(obj_t);
extern bool_t select_cinfo__151_cfa_info(obj_t);
obj_t kwote_node_102_cfa_info = BUNSPEC;
extern obj_t conditional_cinfo_type_set__218_cfa_info(conditional_bglt, type_bglt);
extern obj_t atom_ast_node;
static obj_t _box_set__o_cinfo__123_cfa_info(obj_t, obj_t);
extern obj_t extern_sfun_cinfo_class_204_cfa_info(sfun_bglt);
extern obj_t box_set__o_cinfo_type_set__107_cfa_info(box_set__221_bglt, type_bglt);
static obj_t _extern_sfun_cinfo_top_3085_170_cfa_info(obj_t, obj_t);
static obj_t _kwote_node_loc2958_66_cfa_info(obj_t, obj_t);
extern node_bglt box_set__cinfo_value_36_cfa_info(box_set__221_bglt);
static obj_t _reshaped_global_library_2993_186_cfa_info(obj_t, obj_t);
static obj_t _make_box_o_cinfo_loc2812_127_cfa_info(obj_t, obj_t);
extern obj_t reshaped_local_fast_alpha_133_cfa_info(local_bglt);
extern approx_bglt cfun_cinfo_approx_232_cfa_info(cfun_cinfo_200_bglt);
static obj_t _funcall_cinfo_arity_error_noticed_2936_199_cfa_info(obj_t, obj_t);
static obj_t _make_box_cinfo_type_set_2826_199_cfa_info(obj_t, obj_t, obj_t);
static obj_t _funcall_cinfo__59_cfa_info(obj_t, obj_t);
static obj_t _reshaped_global_import2989_163_cfa_info(obj_t, obj_t);
static obj_t toplevel_init_63_cfa_info();
static obj_t _make_pragma_cinfo2912_176_cfa_info(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t _extern_sfun_cinfo_loc3099_188_cfa_info(obj_t, obj_t);
extern approx_bglt setq_cinfo_approx_141_cfa_info(setq_cinfo_191_bglt);
extern sexit_cinfo_49_bglt make_sexit_cinfo_207_cfa_info(obj_t, bool_t, approx_bglt);
extern obj_t reshaped_local_name_22_cfa_info(local_bglt);
static obj_t _widening_box_set__o_cinfo2780_213_cfa_info(obj_t, obj_t);
extern obj_t pragma_cinfo_format_141_cfa_info(pragma_bglt);
static obj_t _box_ref_o_cinfo__170_cfa_info(obj_t, obj_t);
static obj_t _reshaped_global_src2998_228_cfa_info(obj_t, obj_t);
static obj_t _reshaped_local_name3002_125_cfa_info(obj_t, obj_t);
extern obj_t approx_type_set__202_cfa_info(approx_bglt, type_bglt);
static obj_t _app_ly_cinfo_fun_set_2944_107_cfa_info(obj_t, obj_t, obj_t);
static obj_t _kwote_cinfo_type2953_68_cfa_info(obj_t, obj_t);
static obj_t _box_ref_cinfo_side_effect_2796_143_cfa_info(obj_t, obj_t);
static obj_t _svar_cinfo_approx3034_160_cfa_info(obj_t, obj_t);
static obj_t _reshaped_global_fast_alpha2982_2_cfa_info(obj_t, obj_t);
static obj_t _conditional_cinfo_false2899_105_cfa_info(obj_t, obj_t);
static obj_t _conditional_cinfo_false_set_2898_0_cfa_info(obj_t, obj_t, obj_t);
extern obj_t create_vector(long);
extern obj_t pre_make_box_loc_183_cfa_info(make_box_202_bglt);
static obj_t _sexit_cinfo_detached_3024_61_cfa_info(obj_t, obj_t);
extern obj_t jump_ex_it_184_ast_node;
extern type_bglt box_ref_o_cinfo_type_224_cfa_info(box_ref_242_bglt);
extern obj_t reshaped_global_src_set__220_cfa_info(global_bglt, obj_t);
extern bool_t make_box_cinfo__176_cfa_info(obj_t);
static obj_t _approx_type_set_3120_213_cfa_info(obj_t, obj_t, obj_t);
extern funcall_bglt allocate_funcall_cinfo_11_cfa_info();
extern obj_t open_input_string(obj_t);
static obj_t _make_box_cinfo_value2831_209_cfa_info(obj_t, obj_t);
extern obj_t kwote_ast_node;
static obj_t _funcall_cinfo_strength_set_2931_178_cfa_info(obj_t, obj_t, obj_t);
static obj_t _pragma_cinfo_approx2921_32_cfa_info(obj_t, obj_t);
extern obj_t extern_sfun_cinfo_class_set__12_cfa_info(sfun_bglt, obj_t);
static obj_t _box_ref_cinfo_approx2799_73_cfa_info(obj_t, obj_t);
static obj_t struct_object__object_atom_cinfo2052_76_cfa_info(obj_t, obj_t, obj_t);
extern obj_t setq_cinfo_type_set__243_cfa_info(setq_bglt, type_bglt);
static obj_t struct_object__object_box_set__cinfo1992_103_cfa_info(obj_t, obj_t, obj_t);
extern obj_t reshaped_global_library__set__109_cfa_info(global_bglt, bool_t);
extern box_set__cinfo_94_bglt make_box_set__cinfo_228_cfa_info(obj_t, type_bglt, var_bglt, node_bglt, approx_bglt);
static obj_t _widening_conditional_cinfo2887_19_cfa_info(obj_t, obj_t);
static obj_t _cfun_cinfo_infix_3117_134_cfa_info(obj_t, obj_t);
static obj_t _reshaped_local__93_cfa_info(obj_t, obj_t);
static obj_t _reshaped_global_type_set_2975_43_cfa_info(obj_t, obj_t, obj_t);
static obj_t _reshaped_local_name_set_3001_16_cfa_info(obj_t, obj_t, obj_t);
extern bool_t box_set__o_cinfo__167_cfa_info(obj_t);
static obj_t struct_object__object_setq_cinfo2028_8_cfa_info(obj_t, obj_t, obj_t);
static obj_t object__struct_box_ref_cinfo1986_188_cfa_info(obj_t, obj_t);
extern obj_t reshaped_global_fast_alpha_set__126_cfa_info(global_bglt, obj_t);
extern make_box_cinfo_127_bglt make_make_box_cinfo_79_cfa_info(obj_t, type_bglt, obj_t, obj_t, node_bglt, approx_bglt);
static obj_t struct_object__object_cfun_cinfo2092_190_cfa_info(obj_t, obj_t, obj_t);
extern obj_t sfun_ast_var;
static obj_t _intern_sfun_cinfo_dsssl_keywords3069_120_cfa_info(obj_t, obj_t);
static obj_t _allocate_reshaped_local_17_cfa_info(obj_t);
extern obj_t reshaped_global_access_146_cfa_info(global_bglt);
static obj_t _sexit_cinfo__68_cfa_info(obj_t, obj_t);
extern obj_t pre_make_box_key_102_cfa_info(make_box_202_bglt);
extern obj_t select_cinfo_loc_246_cfa_info(select_bglt);
static obj_t _conditional_cinfo_key_29_cfa_info(obj_t, obj_t);
extern long intern_sfun_cinfo_stamp_249_cfa_info(intern_sfun_cinfo_192_bglt);
obj_t kwote_cinfo_48_cfa_info = BUNSPEC;
extern obj_t intern_sfun_cinfo_the_closure_231_cfa_info(sfun_bglt);
extern svar_cinfo_166_bglt widening_svar_cinfo_83_cfa_info(approx_bglt, bool_t);
static obj_t _widening_box_set__cinfo2800_31_cfa_info(obj_t, obj_t);
extern obj_t setq_ast_node;
extern obj_t cfun_cinfo_predicate_of_78_cfa_info(cfun_bglt);
extern obj_t extern_sfun_cinfo_loc_set__83_cfa_info(sfun_bglt, obj_t);
static obj_t _reshaped_global_removable_set_2983_192_cfa_info(obj_t, obj_t, obj_t);
extern obj_t intern_sfun_cinfo_loc_54_cfa_info(sfun_bglt);
static obj_t struct_object__object_kwote_cinfo2044_93_cfa_info(obj_t, obj_t, obj_t);
static obj_t _box_ref_cinfo_key_241_cfa_info(obj_t, obj_t);
extern long intern_sfun_cinfo_arity_6_cfa_info(sfun_bglt);
extern obj_t atom_cinfo_type_set__31_cfa_info(atom_bglt, type_bglt);
extern approx_bglt app_ly_cinfo_approx_252_cfa_info(app_ly_cinfo_234_bglt);
extern obj_t box_set__221_ast_node;
obj_t box_ref_cinfo_214_cfa_info = BUNSPEC;
static obj_t _fail_cinfo_proc_set_2880_220_cfa_info(obj_t, obj_t, obj_t);
static obj_t _extern_sfun_cinfo_args3091_190_cfa_info(obj_t, obj_t);
extern pragma_bglt allocate_pragma_cinfo_134_cfa_info();
static obj_t _reshaped_local_fast_alpha3010_58_cfa_info(obj_t, obj_t);
extern bool_t approx__114_cfa_info(obj_t);
extern obj_t pre_make_box_key_set__46_cfa_info(make_box_202_bglt, obj_t);
extern obj_t svar_cinfo_clo_env__set__212_cfa_info(svar_cinfo_166_bglt, bool_t);
static obj_t _conditional_cinfo_test2895_11_cfa_info(obj_t, obj_t);
static obj_t _allocate_svar_cinfo_185_cfa_info(obj_t);
static obj_t _pre_make_box_side_effect__set_2837_191_cfa_info(obj_t, obj_t, obj_t);
static obj_t _pragma_cinfo_loc2913_152_cfa_info(obj_t, obj_t);
extern bool_t reshaped_global_user__181_cfa_info(global_bglt);
extern obj_t box_ref_cinfo_loc_176_cfa_info(box_ref_242_bglt);
static obj_t _extern_sfun_cinfo_body_set_3092_110_cfa_info(obj_t, obj_t, obj_t);
extern obj_t select_cinfo_key_178_cfa_info(select_bglt);
extern approx_bglt jump_ex_it_cinfo_approx_160_cfa_info(jump_ex_it_cinfo_139_bglt);
extern global_bglt allocate_reshaped_global_131_cfa_info();
extern node_bglt make_box_cinfo_value_44_cfa_info(make_box_202_bglt);
static obj_t _select_cinfo_side_effect__set_2868_197_cfa_info(obj_t, obj_t, obj_t);
extern obj_t object___object;
static obj_t struct_object__object_sexit_cinfo2064_242_cfa_info(obj_t, obj_t, obj_t);
extern obj_t intern_sfun_cinfo_class_26_cfa_info(sfun_bglt);
static obj_t _intern_sfun_cinfo_side_effect_3051_57_cfa_info(obj_t, obj_t);
static obj_t _allocate_box_set__o_cinfo_20_cfa_info(obj_t);
extern obj_t sexit_cinfo_detached__set__246_cfa_info(sexit_bglt, bool_t);
static obj_t _widening_make_box_o_cinfo2810_191_cfa_info(obj_t, obj_t, obj_t);
static obj_t _reshaped_global_occurrence_set_2985_192_cfa_info(obj_t, obj_t, obj_t);
static obj_t struct_object__object_set_ex_it_cinfo2012_163_cfa_info(obj_t, obj_t, obj_t);
extern approx_bglt box_set__o_cinfo_approx_180_cfa_info(box_set__o_cinfo_6_bglt);
static obj_t _sexit_cinfo_approx3025_89_cfa_info(obj_t, obj_t);
static obj_t _box_set__o_cinfo_value2788_117_cfa_info(obj_t, obj_t);
static obj_t _cfun_cinfo_predicate_of_set_3106_47_cfa_info(obj_t, obj_t, obj_t);
static obj_t _allocate_box_ref_cinfo_238_cfa_info(obj_t);
extern atom_cinfo_155_bglt widening_atom_cinfo_32_cfa_info(approx_bglt);
extern obj_t extern_sfun_cinfo_top__set__250_cfa_info(sfun_bglt, bool_t);
static obj_t _box_ref_o_cinfo_key_193_cfa_info(obj_t, obj_t);
extern obj_t reshaped_global_pragma_7_cfa_info(global_bglt);
static obj_t _allocate_approx_254_cfa_info(obj_t);
extern box_ref_242_bglt allocate_box_ref_o_cinfo_99_cfa_info();
static obj_t _allocate_conditional_cinfo_139_cfa_info(obj_t);
static obj_t object__struct_intern_sfun_cinfo2082_117_cfa_info(obj_t, obj_t);
extern pre_clo_env_191_bglt widening_pre_clo_env_190_cfa_info();
static obj_t _allocate_app_ly_cinfo_17_cfa_info(obj_t);
static obj_t _make_box_cinfo_approx2832_148_cfa_info(obj_t, obj_t);
static obj_t _widening_box_ref_o_cinfo2770_157_cfa_info(obj_t, obj_t);
extern bool_t box_ref_o_cinfo__192_cfa_info(obj_t);
extern obj_t local_ast_var;
static obj_t _extern_sfun_cinfo_side_effect__set_3078_108_cfa_info(obj_t, obj_t, obj_t);
static obj_t _fail_cinfo_msg2883_50_cfa_info(obj_t, obj_t);
extern obj_t box_set__cinfo_var_set__136_cfa_info(box_set__221_bglt, var_bglt);
static obj_t _make_box_cinfo_side_effect__set_2828_43_cfa_info(obj_t, obj_t, obj_t);
extern obj_t extern_sfun_cinfo_property_112_cfa_info(sfun_bglt);
extern obj_t box_ref_cinfo_key_199_cfa_info(box_ref_242_bglt);
static obj_t _jump_ex_it_cinfo_exit_set_2848_164_cfa_info(obj_t, obj_t, obj_t);
static obj_t _pre_make_box_loc2834_157_cfa_info(obj_t, obj_t);
static obj_t object__struct_app_ly_cinfo2038_18_cfa_info(obj_t, obj_t);
extern obj_t select_cinfo_test_set__246_cfa_info(select_bglt, node_bglt);
static obj_t _select_cinfo_key_set__141_cfa_info(obj_t, obj_t, obj_t);
static obj_t _setq_cinfo_type_set_2904_118_cfa_info(obj_t, obj_t, obj_t);
static obj_t _scnst_cinfo_class3043_119_cfa_info(obj_t, obj_t);
static obj_t _make_make_box_cinfo2824_251_cfa_info(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t _allocate_atom_cinfo_64_cfa_info(obj_t);
extern obj_t extern_sfun_cinfo_stack_allocator_set__23_cfa_info(sfun_bglt, obj_t);
static obj_t _setq_cinfo_value2909_179_cfa_info(obj_t, obj_t);
static obj_t _svar_cinfo_clo_env_3036_74_cfa_info(obj_t, obj_t);
extern set_ex_it_116_bglt allocate_set_ex_it_cinfo_32_cfa_info();
extern obj_t make_box_cinfo_side_effect__set__59_cfa_info(make_box_202_bglt, obj_t);
extern bool_t extern_sfun_cinfo_top__212_cfa_info(sfun_bglt);
static obj_t _box_set__o_cinfo_var2786_188_cfa_info(obj_t, obj_t);
static obj_t _box_ref_o_cinfo_side_effect_2776_96_cfa_info(obj_t, obj_t);
static obj_t _cvar_cinfo_approx3029_161_cfa_info(obj_t, obj_t);
static obj_t _box_set__cinfo__142_cfa_info(obj_t, obj_t);
static obj_t _pre_make_box_side_effect_2838_255_cfa_info(obj_t, obj_t);
static obj_t _reshaped_global_fast_alpha_set_2981_97_cfa_info(obj_t, obj_t, obj_t);
static obj_t _reshaped_global_access2980_133_cfa_info(obj_t, obj_t);
static obj_t _atom_cinfo_value_set_2968_229_cfa_info(obj_t, obj_t, obj_t);
static obj_t _app_ly_cinfo_approx2948_16_cfa_info(obj_t, obj_t);
extern node_bglt conditional_cinfo_test_91_cfa_info(conditional_bglt);
extern node_bglt box_set__o_cinfo_value_185_cfa_info(box_set__221_bglt);
static obj_t _conditional_cinfo_test_set_2894_208_cfa_info(obj_t, obj_t, obj_t);
obj_t approx_cfa_info = BUNSPEC;
extern type_bglt select_cinfo_item_type_151_cfa_info(select_bglt);
static obj_t _funcall_cinfo_strength2932_36_cfa_info(obj_t, obj_t);
static obj_t _select_cinfo_test_set_2870_225_cfa_info(obj_t, obj_t, obj_t);
extern obj_t make_box_o_cinfo_side_effect__set__221_cfa_info(make_box_202_bglt, obj_t);
extern obj_t intern_sfun_cinfo_body_52_cfa_info(sfun_bglt);
extern obj_t register_class__225___object(obj_t, obj_t, obj_t, long, obj_t, obj_t, obj_t);
static obj_t _intern_sfun_cinfo_approx3072_159_cfa_info(obj_t, obj_t);
static obj_t _make_extern_sfun_cinfo3076_187_cfa_info(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t _funcall_cinfo_loc2924_64_cfa_info(obj_t, obj_t);
extern var_bglt box_ref_o_cinfo_var_44_cfa_info(box_ref_242_bglt);
static obj_t _pragma_cinfo_type_set_2914_52_cfa_info(obj_t, obj_t, obj_t);
static obj_t _extern_sfun_cinfo_loc_set_3098_169_cfa_info(obj_t, obj_t, obj_t);
static obj_t _box_set__cinfo_var_set_2805_221_cfa_info(obj_t, obj_t, obj_t);
extern obj_t box_set__o_cinfo_var_set__7_cfa_info(box_set__221_bglt, var_bglt);
static obj_t _atom_cinfo_value2969_57_cfa_info(obj_t, obj_t);
static obj_t _reshaped_local_access3008_115_cfa_info(obj_t, obj_t);
extern kwote_node_102_bglt make_kwote_node_13_cfa_info(obj_t, type_bglt, obj_t, node_bglt);
static obj_t _app_ly_cinfo_type_set_2942_95_cfa_info(obj_t, obj_t, obj_t);
static obj_t object__struct_box_set__cinfo1990_126_cfa_info(obj_t, obj_t);
extern obj_t cfun_cinfo_side_effect__165_cfa_info(cfun_bglt);
extern setq_bglt allocate_setq_cinfo_202_cfa_info();
static obj_t _funcall_cinfo_type_error_noticed__set_2937_206_cfa_info(obj_t, obj_t, obj_t);
static obj_t _box_set__o_cinfo_value_set_2787_108_cfa_info(obj_t, obj_t, obj_t);
static obj_t _make_reshaped_global2971_92_cfa_info(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t _extern_sfun_cinfo_stack_allocator_set_3082_76_cfa_info(obj_t, obj_t, obj_t);
static obj_t _intern_sfun_cinfo_loc_set_3070_249_cfa_info(obj_t, obj_t, obj_t);
static obj_t _intern_sfun_cinfo_arity3049_55_cfa_info(obj_t, obj_t);
static obj_t _make_pre_make_box2833_64_cfa_info(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t make_box_cinfo_value_set__204_cfa_info(make_box_202_bglt, node_bglt);
static obj_t _kwote_cinfo_value2954_71_cfa_info(obj_t, obj_t);
obj_t setq_cinfo_191_cfa_info = BUNSPEC;
static obj_t _fail_cinfo_msg_set_2882_185_cfa_info(obj_t, obj_t, obj_t);
static obj_t _intern_sfun_cinfo_body_set_3064_241_cfa_info(obj_t, obj_t, obj_t);
extern var_bglt box_set__cinfo_var_126_cfa_info(box_set__221_bglt);
static obj_t _intern_sfun_cinfo_side_effect__set_3050_102_cfa_info(obj_t, obj_t, obj_t);
extern obj_t cfun_cinfo_top__set__172_cfa_info(cfun_bglt, bool_t);
static obj_t struct_object__object_kwote_node2048_129_cfa_info(obj_t, obj_t, obj_t);
extern obj_t reshaped_global_import_set__167_cfa_info(global_bglt, obj_t);
extern obj_t extern_sfun_cinfo_dsssl_keywords_set__212_cfa_info(sfun_bglt, obj_t);
static obj_t _box_ref_o_cinfo_type_set_2773_28_cfa_info(obj_t, obj_t, obj_t);
extern obj_t reshaped_local_fast_alpha_set__175_cfa_info(local_bglt, obj_t);
static obj_t struct_object__object_app_ly_cinfo2040_212_cfa_info(obj_t, obj_t, obj_t);
static obj_t _reshaped_global_value2978_206_cfa_info(obj_t, obj_t);
extern box_set__221_bglt allocate_box_set__cinfo_232_cfa_info();
extern obj_t reshaped_global_import_91_cfa_info(global_bglt);
extern bool_t funcall_cinfo__175_cfa_info(obj_t);
static obj_t _widening_pre_make_box_226_cfa_info(obj_t);
extern type_bglt jump_ex_it_cinfo_type_129_cfa_info(jump_ex_it_184_bglt);
static obj_t _set_ex_it_cinfo__175_cfa_info(obj_t, obj_t);
static obj_t _set_ex_it_cinfo_var2859_52_cfa_info(obj_t, obj_t);
static obj_t _funcall_cinfo_type2926_242_cfa_info(obj_t, obj_t);
extern obj_t cfun_cinfo_the_closure_238_cfa_info(cfun_bglt);
extern make_box_202_bglt allocate_make_box_cinfo_213_cfa_info();
static obj_t _scnst_cinfo_approx3046_113_cfa_info(obj_t, obj_t);
extern app_ly_cinfo_234_bglt widening_app_ly_cinfo_231_cfa_info(approx_bglt);
extern approx_bglt make_approx_172_cfa_info(type_bglt, bool_t, obj_t, bool_t, long);
static obj_t object_init_111_cfa_info();
extern bool_t pre_make_box__245_cfa_info(obj_t);
static obj_t _make_reshaped_local2999_202_cfa_info(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t struct_object__object_extern_sfun_cinfo2088_95_cfa_info(obj_t, obj_t, obj_t);
extern obj_t scnst_cinfo_node_230_cfa_info(scnst_bglt);
static obj_t _atom_cinfo__122_cfa_info(obj_t, obj_t);
extern obj_t kwote_cinfo_type_set__163_cfa_info(kwote_bglt, type_bglt);
static obj_t _box_ref_cinfo_var_set_2797_195_cfa_info(obj_t, obj_t, obj_t);
extern approx_bglt select_cinfo_approx_174_cfa_info(select_cinfo_150_bglt);
static obj_t _make_select_cinfo2864_67_cfa_info(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t _reshaped_local_removable3012_168_cfa_info(obj_t, obj_t);
extern approx_bglt conditional_cinfo_approx_37_cfa_info(conditional_cinfo_212_bglt);
extern type_bglt kwote_node_type_31_cfa_info(kwote_bglt);
extern approx_bglt funcall_cinfo_va_approx_93_cfa_info(funcall_cinfo_75_bglt);
static obj_t _widening_reshaped_local_170_cfa_info(obj_t, obj_t);
static obj_t _fail_cinfo_obj_set_2884_198_cfa_info(obj_t, obj_t, obj_t);
static obj_t _jump_ex_it_cinfo_exit2849_23_cfa_info(obj_t, obj_t);
static obj_t _fail_cinfo_type2879_168_cfa_info(obj_t, obj_t);
static obj_t _pre_clo_env__150_cfa_info(obj_t, obj_t);
static obj_t _make_funcall_cinfo2923_185_cfa_info(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern funcall_cinfo_75_bglt make_funcall_cinfo_132_cfa_info(obj_t, type_bglt, node_bglt, obj_t, obj_t, approx_bglt, approx_bglt, bool_t, bool_t);
static obj_t _extern_sfun_cinfo_side_effect_3079_78_cfa_info(obj_t, obj_t);
static obj_t _select_cinfo_side_effect_2869_172_cfa_info(obj_t, obj_t);
static obj_t _approx_type3121_83_cfa_info(obj_t, obj_t);
static obj_t _pragma_cinfo_side_effect__set_2916_3_cfa_info(obj_t, obj_t, obj_t);
static obj_t _make_box_cinfo__189_cfa_info(obj_t, obj_t);
static obj_t _reshaped_global_type2976_28_cfa_info(obj_t, obj_t);
static obj_t _setq_cinfo_value_set_2908_109_cfa_info(obj_t, obj_t, obj_t);
static obj_t _widening_scnst_cinfo3039_53_cfa_info(obj_t, obj_t);
extern type_bglt set_ex_it_cinfo_type_68_cfa_info(set_ex_it_116_bglt);
extern obj_t reshaped_global_removable_146_cfa_info(global_bglt);
extern long approx_lost_stamp_29_cfa_info(approx_bglt);
extern type_bglt pre_make_box_type_57_cfa_info(make_box_202_bglt);
extern obj_t intern_sfun_cinfo_side_effect__set__189_cfa_info(sfun_bglt, obj_t);
static obj_t _make_pre_clo_env_110_cfa_info(obj_t, obj_t);
extern type_bglt box_set__cinfo_type_226_cfa_info(box_set__221_bglt);
extern approx_bglt make_box_o_cinfo_approx_146_cfa_info(make_box_o_cinfo_96_bglt);
static obj_t _set_ex_it_cinfo_var_set_2858_160_cfa_info(obj_t, obj_t, obj_t);
static obj_t _extern_sfun_cinfo_body3093_231_cfa_info(obj_t, obj_t);
static obj_t _box_ref_cinfo_side_effect__set_2795_29_cfa_info(obj_t, obj_t, obj_t);
static obj_t _select_cinfo_type2867_136_cfa_info(obj_t, obj_t);
extern obj_t make_box_cinfo_key_set__72_cfa_info(make_box_202_bglt, obj_t);
extern bool_t cfun_cinfo_top__138_cfa_info(cfun_bglt);
extern sexit_bglt allocate_sexit_cinfo_160_cfa_info();
extern obj_t pre_make_box_value_set__57_cfa_info(make_box_202_bglt, node_bglt);
extern obj_t select_cinfo_clauses_111_cfa_info(select_bglt);
extern cfun_cinfo_200_bglt widening_cfun_cinfo_224_cfa_info(approx_bglt);
extern bool_t conditional_cinfo__69_cfa_info(obj_t);
static obj_t _pre_make_box_value2842_59_cfa_info(obj_t, obj_t);
extern obj_t setq_cinfo_value_set__184_cfa_info(setq_bglt, node_bglt);
static obj_t _make_box_cinfo_loc2825_22_cfa_info(obj_t, obj_t);
extern var_bglt setq_cinfo_var_51_cfa_info(setq_bglt);
extern obj_t intern_sfun_cinfo_body_set__86_cfa_info(sfun_bglt, obj_t);
static obj_t _box_ref_cinfo__65_cfa_info(obj_t, obj_t);
extern obj_t sexit_ast_var;
extern approx_bglt set_ex_it_cinfo_approx_28_cfa_info(set_ex_it_cinfo_168_bglt);
extern funcall_cinfo_75_bglt widening_funcall_cinfo_88_cfa_info(approx_bglt, approx_bglt, bool_t, bool_t);
static obj_t _cfun_cinfo_side_effect_3105_189_cfa_info(obj_t, obj_t);
static obj_t _setq_cinfo_approx2910_5_cfa_info(obj_t, obj_t);
static obj_t _make_scnst_cinfo3040_74_cfa_info(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t intern_sfun_cinfo_args_90_cfa_info(sfun_bglt);
static obj_t _setq_cinfo__245_cfa_info(obj_t, obj_t);
extern obj_t jump_ex_it_cinfo_type_set__231_cfa_info(jump_ex_it_184_bglt, type_bglt);
static obj_t _intern_sfun_cinfo_stack_allocator_set_3054_122_cfa_info(obj_t, obj_t, obj_t);
static obj_t _app_ly_cinfo_arg_set_2946_162_cfa_info(obj_t, obj_t, obj_t);
extern obj_t fail_cinfo_proc_set__66_cfa_info(fail_bglt, node_bglt);
static obj_t _allocate_cfun_cinfo_87_cfa_info(obj_t);
extern obj_t conditional_cinfo_true_set__242_cfa_info(conditional_bglt, node_bglt);
extern obj_t select_cinfo_type_set__83_cfa_info(select_bglt, type_bglt);
extern obj_t select_ast_node;
static obj_t _atom_cinfo_loc2965_122_cfa_info(obj_t, obj_t);
static obj_t _approx_allocs3123_186_cfa_info(obj_t, obj_t);
static obj_t _cfun_cinfo_stack_allocator3109_230_cfa_info(obj_t, obj_t);
static obj_t _make_atom_cinfo2964_82_cfa_info(obj_t, obj_t, obj_t, obj_t, obj_t);
extern approx_bglt cvar_cinfo_approx_12_cfa_info(cvar_cinfo_53_bglt);
extern obj_t pragma_cinfo_args_224_cfa_info(pragma_bglt);
extern obj_t reshaped_global_removable_set__53_cfa_info(global_bglt, obj_t);
extern obj_t extern_sfun_cinfo_the_closure_159_cfa_info(sfun_bglt);
extern approx_bglt funcall_cinfo_approx_11_cfa_info(funcall_cinfo_75_bglt);
static obj_t _allocate_intern_sfun_cinfo_249_cfa_info(obj_t);
extern bool_t atom_cinfo__127_cfa_info(obj_t);
extern obj_t read___reader(obj_t);
extern scnst_cinfo_0_bglt widening_scnst_cinfo_249_cfa_info(approx_bglt);
static obj_t _make_cfun_cinfo3102_0_cfa_info(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t _make_setq_cinfo2902_99_cfa_info(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern jump_ex_it_184_bglt allocate_jump_ex_it_cinfo_167_cfa_info();
extern bool_t kwote_cinfo__51_cfa_info(obj_t);
static obj_t _intern_sfun_cinfo_loc3071_216_cfa_info(obj_t, obj_t);
static obj_t _approx_top_3125_24_cfa_info(obj_t, obj_t);
static obj_t _pre_make_box_type_set_2835_95_cfa_info(obj_t, obj_t, obj_t);
static obj_t _scnst_cinfo_class_set_3042_195_cfa_info(obj_t, obj_t, obj_t);
extern conditional_cinfo_212_bglt make_conditional_cinfo_187_cfa_info(obj_t, type_bglt, obj_t, obj_t, node_bglt, node_bglt, node_bglt, approx_bglt);
static obj_t _app_ly_cinfo__202_cfa_info(obj_t, obj_t);
extern app_ly_cinfo_234_bglt make_app_ly_cinfo_1_cfa_info(obj_t, type_bglt, node_bglt, node_bglt, approx_bglt);
static obj_t _reshaped_local_key3017_67_cfa_info(obj_t, obj_t);
extern bool_t set_ex_it_cinfo__11_cfa_info(obj_t);
static obj_t _intern_sfun_cinfo__158_cfa_info(obj_t, obj_t);
extern obj_t reshaped_global_type_set__56_cfa_info(global_bglt, type_bglt);
extern obj_t intern_sfun_cinfo_the_closure_set__54_cfa_info(sfun_bglt, obj_t);
static obj_t _box_ref_o_cinfo_key_set__163_cfa_info(obj_t, obj_t, obj_t);
static obj_t _extern_sfun_cinfo_arity3077_249_cfa_info(obj_t, obj_t);
static obj_t object__struct_set_ex_it_cinfo2010_16_cfa_info(obj_t, obj_t);
extern obj_t sexit_cinfo_handler_23_cfa_info(sexit_bglt);
extern obj_t box_ref_o_cinfo_loc_36_cfa_info(box_ref_242_bglt);
static obj_t object__struct_funcall_cinfo2034_224_cfa_info(obj_t, obj_t);
static obj_t _conditional_cinfo_key_set__114_cfa_info(obj_t, obj_t, obj_t);
static obj_t _conditional_cinfo_true_set_2896_30_cfa_info(obj_t, obj_t, obj_t);
extern type_bglt kwote_cinfo_type_193_cfa_info(kwote_bglt);
static obj_t _allocate_pre_clo_env_10_cfa_info(obj_t);
obj_t sexit_cinfo_49_cfa_info = BUNSPEC;
obj_t app_ly_cinfo_234_cfa_info = BUNSPEC;
static obj_t _atom_cinfo_type2967_147_cfa_info(obj_t, obj_t);
extern svar_bglt allocate_svar_cinfo_217_cfa_info();
static obj_t object__struct_jump_ex_it_cinfo2006_111_cfa_info(obj_t, obj_t);
static obj_t _jump_ex_it_cinfo_approx2852_36_cfa_info(obj_t, obj_t);
extern bool_t cfun_cinfo_macro__33_cfa_info(cfun_bglt);
extern obj_t object__struct_50___object(object_bglt);
static obj_t _make_box_o_cinfo_value_set_2818_253_cfa_info(obj_t, obj_t, obj_t);
static obj_t _cvar_cinfo_macro_3028_11_cfa_info(obj_t, obj_t);
extern bool_t setq_cinfo__121_cfa_info(obj_t);
static obj_t _reshaped_local_access_set_3007_153_cfa_info(obj_t, obj_t, obj_t);
static obj_t _setq_cinfo_type2905_96_cfa_info(obj_t, obj_t);
extern make_box_202_bglt allocate_make_box_o_cinfo_222_cfa_info();
extern obj_t pragma_cinfo_type_set__38_cfa_info(pragma_bglt, type_bglt);
extern approx_bglt make_box_o_cinfo_value_approx_169_cfa_info(make_box_o_cinfo_96_bglt);
extern cvar_cinfo_53_bglt widening_cvar_cinfo_54_cfa_info(approx_bglt);
obj_t svar_cinfo_166_cfa_info = BUNSPEC;
extern node_bglt conditional_cinfo_false_155_cfa_info(conditional_bglt);
extern type_bglt approx_type_27_cfa_info(approx_bglt);
static obj_t _select_cinfo_approx2874_228_cfa_info(obj_t, obj_t);
extern obj_t box_set__cinfo_loc_149_cfa_info(box_set__221_bglt);
extern bool_t extern_sfun_cinfo__167_cfa_info(obj_t);
extern pre_clo_env_191_bglt make_pre_clo_env_164_cfa_info(obj_t);
extern box_set__cinfo_94_bglt widening_box_set__cinfo_177_cfa_info(approx_bglt);
extern obj_t jump_ex_it_cinfo_value_set__150_cfa_info(jump_ex_it_184_bglt, node_bglt);
extern var_bglt box_set__o_cinfo_var_171_cfa_info(box_set__221_bglt);
extern reshaped_local_224_bglt make_reshaped_local_12_cfa_info(obj_t, obj_t, type_bglt, value_bglt, obj_t, obj_t, obj_t, long, bool_t, long, obj_t);
extern type_bglt funcall_cinfo_type_26_cfa_info(funcall_bglt);
static obj_t _conditional_cinfo_side_effect_2893_157_cfa_info(obj_t, obj_t);
static obj_t require_initialization_114_cfa_info = BUNSPEC;
extern obj_t reshaped_global_module_134_cfa_info(global_bglt);
extern obj_t conditional_ast_node;
extern obj_t kwote_cinfo_loc_185_cfa_info(kwote_bglt);
extern obj_t extern_sfun_cinfo_body_232_cfa_info(sfun_bglt);
extern make_box_cinfo_127_bglt widening_make_box_cinfo_240_cfa_info(approx_bglt);
extern obj_t box_ref_o_cinfo_key_232_cfa_info(box_ref_242_bglt);
extern obj_t intern_sfun_cinfo_stack_allocator_set__130_cfa_info(sfun_bglt, obj_t);
static obj_t _cvar_cinfo__113_cfa_info(obj_t, obj_t);
extern obj_t funcall_cinfo_loc_64_cfa_info(funcall_bglt);
extern setq_cinfo_191_bglt make_setq_cinfo_232_cfa_info(obj_t, type_bglt, var_bglt, node_bglt, approx_bglt);
static obj_t _funcall_cinfo_args2930_9_cfa_info(obj_t, obj_t);
extern obj_t pre_make_box_type_set__21_cfa_info(make_box_202_bglt, type_bglt);
static obj_t _intern_sfun_cinfo_predicate_of3053_13_cfa_info(obj_t, obj_t);
static obj_t _funcall_cinfo_arity_error_noticed__set_2935_11_cfa_info(obj_t, obj_t, obj_t);
static obj_t _funcall_cinfo_type_set_2925_90_cfa_info(obj_t, obj_t, obj_t);
static obj_t _widening_extern_sfun_cinfo3075_199_cfa_info(obj_t, obj_t);
extern fail_cinfo_75_bglt widening_fail_cinfo_81_cfa_info(approx_bglt);
static obj_t struct_object__object_fail_cinfo2020_217_cfa_info(obj_t, obj_t, obj_t);
static obj_t _approx_lost_stamp3127_243_cfa_info(obj_t, obj_t);
static obj_t _allocate_cvar_cinfo_74_cfa_info(obj_t);
static obj_t _jump_ex_it_cinfo_value2851_45_cfa_info(obj_t, obj_t);
static obj_t _sexit_cinfo_handler_set_3021_214_cfa_info(obj_t, obj_t, obj_t);
extern approx_bglt fail_cinfo_approx_11_cfa_info(fail_cinfo_75_bglt);
static obj_t struct_object__object_jump_ex_it_cinfo2008_72_cfa_info(obj_t, obj_t, obj_t);
extern atom_bglt allocate_atom_cinfo_55_cfa_info();
static obj_t _box_ref_cinfo_key_set__118_cfa_info(obj_t, obj_t, obj_t);
static obj_t _make_box_cinfo_key_44_cfa_info(obj_t, obj_t);
static obj_t object__struct_pragma_cinfo2030_152_cfa_info(obj_t, obj_t);
extern conditional_bglt allocate_conditional_cinfo_71_cfa_info();
static obj_t _box_set__cinfo_approx2809_141_cfa_info(obj_t, obj_t);
static obj_t _widening_atom_cinfo2963_144_cfa_info(obj_t, obj_t);
extern obj_t cfun_cinfo_predicate_of_set__153_cfa_info(cfun_bglt, obj_t);
extern approx_bglt extern_sfun_cinfo_approx_180_cfa_info(extern_sfun_cinfo_6_bglt);
static obj_t object__struct_box_set__o_cinfo1982_221_cfa_info(obj_t, obj_t);
static obj_t _widening_reshaped_global_191_cfa_info(obj_t);
static obj_t _funcall_cinfo_approx2933_43_cfa_info(obj_t, obj_t);
static obj_t _reshaped_local_type_set_3003_238_cfa_info(obj_t, obj_t, obj_t);
static obj_t cnst_init_137_cfa_info();
static obj_t _allocate_fail_cinfo_247_cfa_info(obj_t);
obj_t atom_cinfo_155_cfa_info = BUNSPEC;
extern obj_t scnst_cinfo_class_set__149_cfa_info(scnst_bglt, obj_t);
static obj_t _intern_sfun_cinfo_class_set_3066_64_cfa_info(obj_t, obj_t, obj_t);
static obj_t _app_ly_cinfo_loc2941_143_cfa_info(obj_t, obj_t);
static obj_t struct_object__object_reshaped_global2056_155_cfa_info(obj_t, obj_t, obj_t);
static obj_t object__struct_kwote_cinfo2042_186_cfa_info(obj_t, obj_t);
static obj_t _make_box_o_cinfo_side_effect_2816_232_cfa_info(obj_t, obj_t);
static obj_t struct_object__object_cvar_cinfo2068_13_cfa_info(obj_t, obj_t, obj_t);
static obj_t _conditional_cinfo_type_set_2890_68_cfa_info(obj_t, obj_t, obj_t);
static obj_t object__struct_atom_cinfo2050_53_cfa_info(obj_t, obj_t);
static obj_t _widening_cfun_cinfo3101_148_cfa_info(obj_t, obj_t);
static obj_t _select_cinfo_type_set_2866_85_cfa_info(obj_t, obj_t, obj_t);
extern obj_t reshaped_local_access_5_cfa_info(local_bglt);
static obj_t _conditional_cinfo_approx2900_167_cfa_info(obj_t, obj_t);
extern obj_t extern_sfun_cinfo_body_set__15_cfa_info(sfun_bglt, obj_t);
static obj_t _widening_setq_cinfo2901_7_cfa_info(obj_t, obj_t);
static obj_t _reshaped_global_pragma2996_199_cfa_info(obj_t, obj_t);
static obj_t __cnst[30];

DEFINE_EXPORT_PROCEDURE(allocate_make_box_o_cinfo_env_97_cfa_info, _allocate_make_box_o_cinfo_133_cfa_info3196, _allocate_make_box_o_cinfo_133_cfa_info, 0L, 0);
DEFINE_EXPORT_PROCEDURE(cfun_cinfo_arity_env_62_cfa_info, _cfun_cinfo_arity3103_73_cfa_info3197, _cfun_cinfo_arity3103_73_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(jump_ex_it_cinfo_loc_env_34_cfa_info, _jump_ex_it_cinfo_loc2845_144_cfa_info3198, _jump_ex_it_cinfo_loc2845_144_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(scnst_cinfo__env_243_cfa_info, _scnst_cinfo__113_cfa_info3199, _scnst_cinfo__113_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(box_set__cinfo_approx_env_144_cfa_info, _box_set__cinfo_approx2809_141_cfa_info3200, _box_set__cinfo_approx2809_141_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(conditional_cinfo_true_env_122_cfa_info, _conditional_cinfo_true2897_11_cfa_info3201, _conditional_cinfo_true2897_11_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(reshaped_local_name_set__env_172_cfa_info, _reshaped_local_name_set_3001_16_cfa_info3202, _reshaped_local_name_set_3001_16_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(intern_sfun_cinfo_stamp_set__env_245_cfa_info, _intern_sfun_cinfo_stamp_set_3073_246_cfa_info3203, _intern_sfun_cinfo_stamp_set_3073_246_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(approx_top__set__env_101_cfa_info, _approx_top__set_3124_85_cfa_info3204, _approx_top__set_3124_85_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(allocate_kwote_node_env_116_cfa_info, _allocate_kwote_node_49_cfa_info3205, _allocate_kwote_node_49_cfa_info, 0L, 0);
DEFINE_EXPORT_PROCEDURE(funcall_cinfo_fun_set__env_234_cfa_info, _funcall_cinfo_fun_set_2927_96_cfa_info3206, _funcall_cinfo_fun_set_2927_96_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(widening_atom_cinfo_env_250_cfa_info, _widening_atom_cinfo2963_144_cfa_info3207, _widening_atom_cinfo2963_144_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(extern_sfun_cinfo__env_187_cfa_info, _extern_sfun_cinfo__255_cfa_info3208, _extern_sfun_cinfo__255_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(widening_setq_cinfo_env_56_cfa_info, _widening_setq_cinfo2901_7_cfa_info3209, _widening_setq_cinfo2901_7_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(funcall_cinfo_args_env_171_cfa_info, _funcall_cinfo_args2930_9_cfa_info3210, _funcall_cinfo_args2930_9_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(allocate_box_set__cinfo_env_96_cfa_info, _allocate_box_set__cinfo_187_cfa_info3211, _allocate_box_set__cinfo_187_cfa_info, 0L, 0);
DEFINE_EXPORT_PROCEDURE(allocate_set_ex_it_cinfo_env_250_cfa_info, _allocate_set_ex_it_cinfo_22_cfa_info3212, _allocate_set_ex_it_cinfo_22_cfa_info, 0L, 0);
DEFINE_EXPORT_PROCEDURE(extern_sfun_cinfo_class_set__env_74_cfa_info, _extern_sfun_cinfo_class_set_3094_243_cfa_info3213, _extern_sfun_cinfo_class_set_3094_243_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(box_ref_o_cinfo_loc_env_174_cfa_info, _box_ref_o_cinfo_loc2772_15_cfa_info3214, _box_ref_o_cinfo_loc2772_15_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(cfun_cinfo_side_effect__set__env_246_cfa_info, _cfun_cinfo_side_effect__set_3104_38_cfa_info3215, _cfun_cinfo_side_effect__set_3104_38_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(reshaped_global_name_env_188_cfa_info, _reshaped_global_name2974_143_cfa_info3216, _reshaped_global_name2974_143_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(select_cinfo_loc_env_50_cfa_info, _select_cinfo_loc2865_85_cfa_info3217, _select_cinfo_loc2865_85_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(allocate_pre_clo_env_env_170_cfa_info, _allocate_pre_clo_env_10_cfa_info3218, _allocate_pre_clo_env_10_cfa_info, 0L, 0);
DEFINE_EXPORT_PROCEDURE(conditional_cinfo_key_set__env_115_cfa_info, _conditional_cinfo_key_set__114_cfa_info3219, _conditional_cinfo_key_set__114_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_fail_cinfo_env_82_cfa_info, _make_fail_cinfo2876_73_cfa_info3220, _make_fail_cinfo2876_73_cfa_info, 0L, 6);
DEFINE_STATIC_PROCEDURE(proc3189_cfa_info, object__struct_approx2094_141_cfa_info3221, object__struct_approx2094_141_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc3190_cfa_info, struct_object__object_approx2096_124_cfa_info3222, struct_object__object_approx2096_124_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc3188_cfa_info, struct_object__object_cfun_cinfo2092_190_cfa_info3223, struct_object__object_cfun_cinfo2092_190_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc3187_cfa_info, object__struct_cfun_cinfo2090_55_cfa_info3224, object__struct_cfun_cinfo2090_55_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_make_box_key_set__env_28_cfa_info, _pre_make_box_key_set_2839_81_cfa_info3225, _pre_make_box_key_set_2839_81_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc3186_cfa_info, struct_object__object_extern_sfun_cinfo2088_95_cfa_info3226, struct_object__object_extern_sfun_cinfo2088_95_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc3185_cfa_info, object__struct_extern_sfun_cinfo2086_160_cfa_info3227, object__struct_extern_sfun_cinfo2086_160_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc3184_cfa_info, struct_object__object_intern_sfun_cinfo2084_8_cfa_info3228, struct_object__object_intern_sfun_cinfo2084_8_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc3183_cfa_info, object__struct_intern_sfun_cinfo2082_117_cfa_info3229, object__struct_intern_sfun_cinfo2082_117_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc3182_cfa_info, struct_object__object_scnst_cinfo2080_231_cfa_info3230, struct_object__object_scnst_cinfo2080_231_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc3181_cfa_info, object__struct_scnst_cinfo2078_132_cfa_info3231, object__struct_scnst_cinfo2078_132_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc3179_cfa_info, object__struct_pre_clo_env2074_162_cfa_info3232, object__struct_pre_clo_env2074_162_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc3180_cfa_info, struct_object__object_pre_clo_env2076_139_cfa_info3233, struct_object__object_pre_clo_env2076_139_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc3178_cfa_info, struct_object__object_svar_cinfo2072_159_cfa_info3234, struct_object__object_svar_cinfo2072_159_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc3177_cfa_info, object__struct_svar_cinfo2070_189_cfa_info3235, object__struct_svar_cinfo2070_189_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc3176_cfa_info, struct_object__object_cvar_cinfo2068_13_cfa_info3236, struct_object__object_cvar_cinfo2068_13_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc3175_cfa_info, object__struct_cvar_cinfo2066_213_cfa_info3237, object__struct_cvar_cinfo2066_213_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc3174_cfa_info, struct_object__object_sexit_cinfo2064_242_cfa_info3238, struct_object__object_sexit_cinfo2064_242_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc3173_cfa_info, object__struct_sexit_cinfo2062_20_cfa_info3239, object__struct_sexit_cinfo2062_20_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc3172_cfa_info, struct_object__object_reshaped_local2060_138_cfa_info3240, struct_object__object_reshaped_local2060_138_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc3171_cfa_info, object__struct_reshaped_local2058_214_cfa_info3241, object__struct_reshaped_local2058_214_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc3169_cfa_info, object__struct_reshaped_global2054_140_cfa_info3242, object__struct_reshaped_global2054_140_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc3170_cfa_info, struct_object__object_reshaped_global2056_155_cfa_info3243, struct_object__object_reshaped_global2056_155_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc3168_cfa_info, struct_object__object_atom_cinfo2052_76_cfa_info3244, struct_object__object_atom_cinfo2052_76_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc3167_cfa_info, object__struct_atom_cinfo2050_53_cfa_info3245, object__struct_atom_cinfo2050_53_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc3166_cfa_info, struct_object__object_kwote_node2048_129_cfa_info3246, struct_object__object_kwote_node2048_129_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(conditional_cinfo_loc_env_244_cfa_info, _conditional_cinfo_loc2889_186_cfa_info3247, _conditional_cinfo_loc2889_186_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc3165_cfa_info, object__struct_kwote_node2046_198_cfa_info3248, object__struct_kwote_node2046_198_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc3164_cfa_info, struct_object__object_kwote_cinfo2044_93_cfa_info3249, struct_object__object_kwote_cinfo2044_93_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc3163_cfa_info, object__struct_kwote_cinfo2042_186_cfa_info3250, object__struct_kwote_cinfo2042_186_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc3162_cfa_info, struct_object__object_app_ly_cinfo2040_212_cfa_info3251, struct_object__object_app_ly_cinfo2040_212_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc3161_cfa_info, object__struct_app_ly_cinfo2038_18_cfa_info3252, object__struct_app_ly_cinfo2038_18_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc3159_cfa_info, object__struct_funcall_cinfo2034_224_cfa_info3253, object__struct_funcall_cinfo2034_224_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc3160_cfa_info, struct_object__object_funcall_cinfo2036_168_cfa_info3254, struct_object__object_funcall_cinfo2036_168_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc3158_cfa_info, struct_object__object_pragma_cinfo2032_204_cfa_info3255, struct_object__object_pragma_cinfo2032_204_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc3157_cfa_info, object__struct_pragma_cinfo2030_152_cfa_info3256, object__struct_pragma_cinfo2030_152_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc3156_cfa_info, struct_object__object_setq_cinfo2028_8_cfa_info3257, struct_object__object_setq_cinfo2028_8_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(widening_cfun_cinfo_env_33_cfa_info, _widening_cfun_cinfo3101_148_cfa_info3258, _widening_cfun_cinfo3101_148_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc3155_cfa_info, object__struct_setq_cinfo2026_53_cfa_info3259, object__struct_setq_cinfo2026_53_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc3154_cfa_info, struct_object__object_conditional_cinfo2024_17_cfa_info3260, struct_object__object_conditional_cinfo2024_17_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc3153_cfa_info, object__struct_conditional_cinfo2022_5_cfa_info3261, object__struct_conditional_cinfo2022_5_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc3152_cfa_info, struct_object__object_fail_cinfo2020_217_cfa_info3262, struct_object__object_fail_cinfo2020_217_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc3151_cfa_info, object__struct_fail_cinfo2018_129_cfa_info3263, object__struct_fail_cinfo2018_129_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc3149_cfa_info, object__struct_select_cinfo2014_57_cfa_info3264, object__struct_select_cinfo2014_57_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc3150_cfa_info, struct_object__object_select_cinfo2016_231_cfa_info3265, struct_object__object_select_cinfo2016_231_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc3148_cfa_info, struct_object__object_set_ex_it_cinfo2012_163_cfa_info3266, struct_object__object_set_ex_it_cinfo2012_163_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc3147_cfa_info, object__struct_set_ex_it_cinfo2010_16_cfa_info3267, object__struct_set_ex_it_cinfo2010_16_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc3146_cfa_info, struct_object__object_jump_ex_it_cinfo2008_72_cfa_info3268, struct_object__object_jump_ex_it_cinfo2008_72_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc3145_cfa_info, object__struct_jump_ex_it_cinfo2006_111_cfa_info3269, object__struct_jump_ex_it_cinfo2006_111_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc3144_cfa_info, struct_object__object_pre_make_box2004_221_cfa_info3270, struct_object__object_pre_make_box2004_221_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc3143_cfa_info, object__struct_pre_make_box2002_179_cfa_info3271, object__struct_pre_make_box2002_179_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc3142_cfa_info, struct_object__object_make_box_cinfo2000_189_cfa_info3272, struct_object__object_make_box_cinfo2000_189_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc3141_cfa_info, object__struct_make_box_cinfo1998_55_cfa_info3273, object__struct_make_box_cinfo1998_55_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc3139_cfa_info, object__struct_make_box_o_cinfo1994_50_cfa_info3274, object__struct_make_box_o_cinfo1994_50_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc3140_cfa_info, struct_object__object_make_box_o_cinfo1996_29_cfa_info3275, struct_object__object_make_box_o_cinfo1996_29_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc3138_cfa_info, struct_object__object_box_set__cinfo1992_103_cfa_info3276, struct_object__object_box_set__cinfo1992_103_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc3137_cfa_info, object__struct_box_set__cinfo1990_126_cfa_info3277, object__struct_box_set__cinfo1990_126_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc3136_cfa_info, struct_object__object_box_ref_cinfo1988_119_cfa_info3278, struct_object__object_box_ref_cinfo1988_119_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc3135_cfa_info, object__struct_box_ref_cinfo1986_188_cfa_info3279, object__struct_box_ref_cinfo1986_188_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc3134_cfa_info, struct_object__object_box_set__o_cinfo1984_135_cfa_info3280, struct_object__object_box_set__o_cinfo1984_135_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc3133_cfa_info, object__struct_box_set__o_cinfo1982_221_cfa_info3281, object__struct_box_set__o_cinfo1982_221_cfa_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc3132_cfa_info, struct_object__object_box_ref_o_cinfo1980_207_cfa_info3282, struct_object__object_box_ref_o_cinfo1980_207_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(select_cinfo_key_set__env_178_cfa_info, _select_cinfo_key_set__141_cfa_info3283, _select_cinfo_key_set__141_cfa_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc3131_cfa_info, object__struct_box_ref_o_cinfo1978_69_cfa_info3284, object__struct_box_ref_o_cinfo1978_69_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(cfun_cinfo_args_type_env_76_cfa_info, _cfun_cinfo_args_type3114_135_cfa_info3285, _cfun_cinfo_args_type3114_135_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(reshaped_global__env_116_cfa_info, _reshaped_global__169_cfa_info3286, _reshaped_global__169_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(widening_kwote_cinfo_env_73_cfa_info, _widening_kwote_cinfo2949_69_cfa_info3287, _widening_kwote_cinfo2949_69_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(reshaped_local_value_set__env_131_cfa_info, _reshaped_local_value_set_3005_6_cfa_info3288, _reshaped_local_value_set_3005_6_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pragma_cinfo_args_set__env_49_cfa_info, _pragma_cinfo_args_set_2919_169_cfa_info3289, _pragma_cinfo_args_set_2919_169_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(funcall_cinfo_type_error_noticed__env_88_cfa_info, _funcall_cinfo_type_error_noticed_2938_155_cfa_info3290, _funcall_cinfo_type_error_noticed_2938_155_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(widening_box_ref_o_cinfo_env_68_cfa_info, _widening_box_ref_o_cinfo2770_157_cfa_info3291, _widening_box_ref_o_cinfo2770_157_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(funcall_cinfo_fun_env_83_cfa_info, _funcall_cinfo_fun2928_37_cfa_info3292, _funcall_cinfo_fun2928_37_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(jump_ex_it_cinfo_exit_set__env_226_cfa_info, _jump_ex_it_cinfo_exit_set_2848_164_cfa_info3293, _jump_ex_it_cinfo_exit_set_2848_164_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(set_ex_it_cinfo_body_env_21_cfa_info, _set_ex_it_cinfo_body2861_99_cfa_info3294, _set_ex_it_cinfo_body2861_99_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(cfun_cinfo_the_closure_env_75_cfa_info, _cfun_cinfo_the_closure3113_240_cfa_info3295, _cfun_cinfo_the_closure3113_240_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(box_set__cinfo_value_set__env_0_cfa_info, _box_set__cinfo_value_set_2807_175_cfa_info3296, _box_set__cinfo_value_set_2807_175_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(box_ref_cinfo_loc_env_239_cfa_info, _box_ref_cinfo_loc2792_145_cfa_info3297, _box_ref_cinfo_loc2792_145_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(box_ref_o_cinfo_side_effect__set__env_89_cfa_info, _box_ref_o_cinfo_side_effect__set_2775_59_cfa_info3298, _box_ref_o_cinfo_side_effect__set_2775_59_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_cvar_cinfo_env_78_cfa_info, _make_cvar_cinfo3027_54_cfa_info3299, _make_cvar_cinfo3027_54_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(intern_sfun_cinfo_top__env_61_cfa_info, _intern_sfun_cinfo_top_3057_117_cfa_info3300, _intern_sfun_cinfo_top_3057_117_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(kwote_node_type_set__env_109_cfa_info, _kwote_node_type_set_2959_77_cfa_info3301, _kwote_node_type_set_2959_77_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(widening_sexit_cinfo_env_247_cfa_info, _widening_sexit_cinfo3019_115_cfa_info3302, _widening_sexit_cinfo3019_115_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(widening_make_box_cinfo_env_95_cfa_info, _widening_make_box_cinfo2823_164_cfa_info3303, _widening_make_box_cinfo2823_164_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(widening_app_ly_cinfo_env_198_cfa_info, _widening_app_ly_cinfo2939_88_cfa_info3304, _widening_app_ly_cinfo2939_88_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(svar_cinfo__env_119_cfa_info, _svar_cinfo__163_cfa_info3305, _svar_cinfo__163_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(box_set__o_cinfo_loc_env_215_cfa_info, _box_set__o_cinfo_loc2782_255_cfa_info3306, _box_set__o_cinfo_loc2782_255_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(extern_sfun_cinfo_stack_allocator_env_195_cfa_info, _extern_sfun_cinfo_stack_allocator3083_83_cfa_info3307, _extern_sfun_cinfo_stack_allocator3083_83_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_box_cinfo_side_effect__env_228_cfa_info, _make_box_cinfo_side_effect_2829_211_cfa_info3308, _make_box_cinfo_side_effect_2829_211_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(box_ref_o_cinfo__env_142_cfa_info, _box_ref_o_cinfo__170_cfa_info3309, _box_ref_o_cinfo__170_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(allocate_scnst_cinfo_env_108_cfa_info, _allocate_scnst_cinfo_162_cfa_info3310, _allocate_scnst_cinfo_162_cfa_info, 0L, 0);
DEFINE_EXPORT_PROCEDURE(extern_sfun_cinfo_side_effect__set__env_190_cfa_info, _extern_sfun_cinfo_side_effect__set_3078_108_cfa_info3311, _extern_sfun_cinfo_side_effect__set_3078_108_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(select_cinfo_item_type_env_101_cfa_info, _select_cinfo_item_type2873_27_cfa_info3312, _select_cinfo_item_type2873_27_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pragma_cinfo_type_env_243_cfa_info, _pragma_cinfo_type2915_46_cfa_info3313, _pragma_cinfo_type2915_46_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(cfun_cinfo__env_71_cfa_info, _cfun_cinfo__48_cfa_info3314, _cfun_cinfo__48_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(extern_sfun_cinfo_loc_set__env_245_cfa_info, _extern_sfun_cinfo_loc_set_3098_169_cfa_info3315, _extern_sfun_cinfo_loc_set_3098_169_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(cfun_cinfo_predicate_of_env_249_cfa_info, _cfun_cinfo_predicate_of3107_190_cfa_info3316, _cfun_cinfo_predicate_of3107_190_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_clo_env_loc_env_112_cfa_info, _pre_clo_env_loc3038_171_cfa_info3317, _pre_clo_env_loc3038_171_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(box_set__cinfo_value_env_174_cfa_info, _box_set__cinfo_value2808_85_cfa_info3318, _box_set__cinfo_value2808_85_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(svar_cinfo_loc_env_109_cfa_info, _svar_cinfo_loc3033_82_cfa_info3319, _svar_cinfo_loc3033_82_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(setq_cinfo_loc_env_112_cfa_info, _setq_cinfo_loc2903_164_cfa_info3320, _setq_cinfo_loc2903_164_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(reshaped_local_binding_value_env_124_cfa_info, _reshaped_local_binding_value3018_38_cfa_info3321, _reshaped_local_binding_value3018_38_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(intern_sfun_cinfo_approx_env_240_cfa_info, _intern_sfun_cinfo_approx3072_159_cfa_info3322, _intern_sfun_cinfo_approx3072_159_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(intern_sfun_cinfo_loc_set__env_78_cfa_info, _intern_sfun_cinfo_loc_set_3070_249_cfa_info3323, _intern_sfun_cinfo_loc_set_3070_249_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(widening_funcall_cinfo_env_168_cfa_info, _widening_funcall_cinfo2922_80_cfa_info3324, _widening_funcall_cinfo2922_80_cfa_info, 0L, 4);
DEFINE_EXPORT_PROCEDURE(box_ref_cinfo_type_env_241_cfa_info, _box_ref_cinfo_type2794_132_cfa_info3325, _box_ref_cinfo_type2794_132_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(reshaped_global_access_set__env_92_cfa_info, _reshaped_global_access_set_2979_29_cfa_info3326, _reshaped_global_access_set_2979_29_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(cfun_cinfo_approx_env_96_cfa_info, _cfun_cinfo_approx3118_58_cfa_info3327, _cfun_cinfo_approx3118_58_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(intern_sfun_cinfo_side_effect__set__env_214_cfa_info, _intern_sfun_cinfo_side_effect__set_3050_102_cfa_info3328, _intern_sfun_cinfo_side_effect__set_3050_102_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_box_o_cinfo_value_env_216_cfa_info, _make_box_o_cinfo_value2819_230_cfa_info3329, _make_box_o_cinfo_value2819_230_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_box_o_cinfo_type_env_201_cfa_info, _make_box_o_cinfo_type2814_18_cfa_info3330, _make_box_o_cinfo_type2814_18_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_box_o_cinfo_approx_set__env_92_cfa_info, _make_box_o_cinfo_approx_set_2820_218_cfa_info3331, _make_box_o_cinfo_approx_set_2820_218_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(reshaped_local_type_env_57_cfa_info, _reshaped_local_type3004_251_cfa_info3332, _reshaped_local_type3004_251_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(intern_sfun_cinfo_class_env_252_cfa_info, _intern_sfun_cinfo_class3067_224_cfa_info3333, _intern_sfun_cinfo_class3067_224_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_svar_cinfo_env_82_cfa_info, _make_svar_cinfo3031_143_cfa_info3334, _make_svar_cinfo3031_143_cfa_info, 0L, 3);
DEFINE_EXPORT_PROCEDURE(reshaped_global_name_set__env_63_cfa_info, _reshaped_global_name_set_2973_23_cfa_info3335, _reshaped_global_name_set_2973_23_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(intern_sfun_cinfo_the_closure_set__env_19_cfa_info, _intern_sfun_cinfo_the_closure_set_3058_172_cfa_info3336, _intern_sfun_cinfo_the_closure_set_3058_172_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(widening_kwote_node_env_165_cfa_info, _widening_kwote_node2956_153_cfa_info3337, _widening_kwote_node2956_153_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(intern_sfun_cinfo_args_env_237_cfa_info, _intern_sfun_cinfo_args3063_161_cfa_info3338, _intern_sfun_cinfo_args3063_161_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(funcall_cinfo_va_approx_env_209_cfa_info, _funcall_cinfo_va_approx2934_237_cfa_info3339, _funcall_cinfo_va_approx2934_237_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(kwote_node_type_env_99_cfa_info, _kwote_node_type2960_123_cfa_info3340, _kwote_node_type2960_123_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(reshaped_local_removable_env_21_cfa_info, _reshaped_local_removable3012_168_cfa_info3341, _reshaped_local_removable3012_168_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_box_o_cinfo_approx_env_211_cfa_info, _make_box_o_cinfo_approx2821_80_cfa_info3342, _make_box_o_cinfo_approx2821_80_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pragma_cinfo_key_env_172_cfa_info, _pragma_cinfo_key_170_cfa_info3343, _pragma_cinfo_key_170_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(extern_sfun_cinfo_dsssl_keywords_set__env_145_cfa_info, _extern_sfun_cinfo_dsssl_keywords_set_3096_249_cfa_info3344, _extern_sfun_cinfo_dsssl_keywords_set_3096_249_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_kwote_cinfo_env_169_cfa_info, _make_kwote_cinfo2950_155_cfa_info3345, _make_kwote_cinfo2950_155_cfa_info, 0L, 4);
DEFINE_EXPORT_PROCEDURE(app_ly_cinfo_fun_env_147_cfa_info, _app_ly_cinfo_fun2945_39_cfa_info3346, _app_ly_cinfo_fun2945_39_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(approx_type_locked__env_55_cfa_info, _approx_type_locked_3122_59_cfa_info3347, _approx_type_locked_3122_59_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(allocate_fail_cinfo_env_67_cfa_info, _allocate_fail_cinfo_247_cfa_info3348, _allocate_fail_cinfo_247_cfa_info, 0L, 0);
DEFINE_EXPORT_PROCEDURE(reshaped_local_value_env_95_cfa_info, _reshaped_local_value3006_248_cfa_info3349, _reshaped_local_value3006_248_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(funcall_cinfo_type_error_noticed__set__env_64_cfa_info, _funcall_cinfo_type_error_noticed__set_2937_206_cfa_info3350, _funcall_cinfo_type_error_noticed__set_2937_206_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(approx_type_env_64_cfa_info, _approx_type3121_83_cfa_info3351, _approx_type3121_83_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(set_ex_it_cinfo_var_set__env_113_cfa_info, _set_ex_it_cinfo_var_set_2858_160_cfa_info3352, _set_ex_it_cinfo_var_set_2858_160_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_set_ex_it_cinfo_env_108_cfa_info, _make_set_ex_it_cinfo2854_65_cfa_info3353, _make_set_ex_it_cinfo2854_65_cfa_info, 0L, 5);
DEFINE_EXPORT_PROCEDURE(widening_reshaped_local_env_29_cfa_info, _widening_reshaped_local_170_cfa_info3354, _widening_reshaped_local_170_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(atom_cinfo_approx_env_167_cfa_info, _atom_cinfo_approx2970_76_cfa_info3355, _atom_cinfo_approx2970_76_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_make_box_key_env_153_cfa_info, _pre_make_box_key2840_195_cfa_info3356, _pre_make_box_key2840_195_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(box_set__cinfo_loc_env_191_cfa_info, _box_set__cinfo_loc2802_157_cfa_info3357, _box_set__cinfo_loc2802_157_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(extern_sfun_cinfo_stack_allocator_set__env_241_cfa_info, _extern_sfun_cinfo_stack_allocator_set_3082_76_cfa_info3358, _extern_sfun_cinfo_stack_allocator_set_3082_76_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(cfun_cinfo_stack_allocator_set__env_114_cfa_info, _cfun_cinfo_stack_allocator_set_3108_157_cfa_info3359, _cfun_cinfo_stack_allocator_set_3108_157_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_sexit_cinfo_env_8_cfa_info, _make_sexit_cinfo3020_88_cfa_info3360, _make_sexit_cinfo3020_88_cfa_info, 0L, 3);
DEFINE_EXPORT_PROCEDURE(cfun_cinfo_top__env_67_cfa_info, _cfun_cinfo_top_3111_22_cfa_info3361, _cfun_cinfo_top_3111_22_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(extern_sfun_cinfo_dsssl_keywords_env_221_cfa_info, _extern_sfun_cinfo_dsssl_keywords3097_20_cfa_info3362, _extern_sfun_cinfo_dsssl_keywords3097_20_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(allocate_pragma_cinfo_env_199_cfa_info, _allocate_pragma_cinfo_82_cfa_info3363, _allocate_pragma_cinfo_82_cfa_info, 0L, 0);
DEFINE_EXPORT_PROCEDURE(allocate_extern_sfun_cinfo_env_126_cfa_info, _allocate_extern_sfun_cinfo_234_cfa_info3364, _allocate_extern_sfun_cinfo_234_cfa_info, 0L, 0);
DEFINE_EXPORT_PROCEDURE(jump_ex_it_cinfo_value_set__env_9_cfa_info, _jump_ex_it_cinfo_value_set_2850_59_cfa_info3365, _jump_ex_it_cinfo_value_set_2850_59_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pre_make_box_value_set__env_240_cfa_info, _pre_make_box_value_set_2841_45_cfa_info3366, _pre_make_box_value_set_2841_45_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(fail_cinfo_approx_env_186_cfa_info, _fail_cinfo_approx2886_158_cfa_info3367, _fail_cinfo_approx2886_158_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(allocate_cvar_cinfo_env_84_cfa_info, _allocate_cvar_cinfo_74_cfa_info3368, _allocate_cvar_cinfo_74_cfa_info, 0L, 0);
DEFINE_EXPORT_PROCEDURE(set_ex_it_cinfo_type_set__env_44_cfa_info, _set_ex_it_cinfo_type_set_2856_16_cfa_info3369, _set_ex_it_cinfo_type_set_2856_16_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(box_set__o_cinfo_var_set__env_183_cfa_info, _box_set__o_cinfo_var_set_2785_45_cfa_info3370, _box_set__o_cinfo_var_set_2785_45_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pragma_cinfo_format_env_232_cfa_info, _pragma_cinfo_format2918_148_cfa_info3371, _pragma_cinfo_format2918_148_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_conditional_cinfo_env_151_cfa_info, _make_conditional_cinfo2888_155_cfa_info3372, _make_conditional_cinfo2888_155_cfa_info, 0L, 8);
DEFINE_EXPORT_PROCEDURE(funcall_cinfo_arity_error_noticed__env_173_cfa_info, _funcall_cinfo_arity_error_noticed_2936_199_cfa_info3373, _funcall_cinfo_arity_error_noticed_2936_199_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(cfun_cinfo_stack_allocator_env_224_cfa_info, _cfun_cinfo_stack_allocator3109_230_cfa_info3374, _cfun_cinfo_stack_allocator3109_230_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(reshaped_local_user__set__env_80_cfa_info, _reshaped_local_user__set_3015_24_cfa_info3375, _reshaped_local_user__set_3015_24_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(cfun_cinfo_the_closure_set__env_83_cfa_info, _cfun_cinfo_the_closure_set_3112_43_cfa_info3376, _cfun_cinfo_the_closure_set_3112_43_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_box_set__cinfo_env_140_cfa_info, _make_box_set__cinfo2801_97_cfa_info3377, _make_box_set__cinfo2801_97_cfa_info, 0L, 5);
DEFINE_EXPORT_PROCEDURE(approx_top__env_70_cfa_info, _approx_top_3125_24_cfa_info3378, _approx_top_3125_24_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(jump_ex_it_cinfo__env_206_cfa_info, _jump_ex_it_cinfo__23_cfa_info3379, _jump_ex_it_cinfo__23_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_app_ly_cinfo_env_233_cfa_info, _make_app_ly_cinfo2940_73_cfa_info3380, _make_app_ly_cinfo2940_73_cfa_info, 0L, 5);
DEFINE_EXPORT_PROCEDURE(cvar_cinfo__env_217_cfa_info, _cvar_cinfo__113_cfa_info3381, _cvar_cinfo__113_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_box_o_cinfo_loc_env_157_cfa_info, _make_box_o_cinfo_loc2812_127_cfa_info3382, _make_box_o_cinfo_loc2812_127_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pragma_cinfo_args_env_33_cfa_info, _pragma_cinfo_args2920_117_cfa_info3383, _pragma_cinfo_args2920_117_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(kwote_node__env_227_cfa_info, _kwote_node__166_cfa_info3384, _kwote_node__166_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(box_ref_o_cinfo_approx_env_126_cfa_info, _box_ref_o_cinfo_approx2779_91_cfa_info3385, _box_ref_o_cinfo_approx2779_91_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(reshaped_local_access_set__env_80_cfa_info, _reshaped_local_access_set_3007_153_cfa_info3386, _reshaped_local_access_set_3007_153_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(intern_sfun_cinfo_stack_allocator_set__env_120_cfa_info, _intern_sfun_cinfo_stack_allocator_set_3054_122_cfa_info3387, _intern_sfun_cinfo_stack_allocator_set_3054_122_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pre_make_box_side_effect__set__env_137_cfa_info, _pre_make_box_side_effect__set_2837_191_cfa_info3388, _pre_make_box_side_effect__set_2837_191_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(funcall_cinfo_arity_error_noticed__set__env_77_cfa_info, _funcall_cinfo_arity_error_noticed__set_2935_11_cfa_info3389, _funcall_cinfo_arity_error_noticed__set_2935_11_cfa_info, 0L, 2);
extern obj_t struct_object__object_env_209___object;
DEFINE_EXPORT_PROCEDURE(extern_sfun_cinfo_class_env_236_cfa_info, _extern_sfun_cinfo_class3095_125_cfa_info3390, _extern_sfun_cinfo_class3095_125_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(reshaped_global_removable_set__env_92_cfa_info, _reshaped_global_removable_set_2983_192_cfa_info3391, _reshaped_global_removable_set_2983_192_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(select_cinfo_side_effect__set__env_9_cfa_info, _select_cinfo_side_effect__set_2868_197_cfa_info3392, _select_cinfo_side_effect__set_2868_197_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(set_ex_it_cinfo__env_186_cfa_info, _set_ex_it_cinfo__175_cfa_info3393, _set_ex_it_cinfo__175_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_make_box__env_113_cfa_info, _pre_make_box__20_cfa_info3394, _pre_make_box__20_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(allocate_svar_cinfo_env_152_cfa_info, _allocate_svar_cinfo_185_cfa_info3395, _allocate_svar_cinfo_185_cfa_info, 0L, 0);
DEFINE_EXPORT_PROCEDURE(box_set__cinfo__env_12_cfa_info, _box_set__cinfo__142_cfa_info3396, _box_set__cinfo__142_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(funcall_cinfo_strength_set__env_205_cfa_info, _funcall_cinfo_strength_set_2931_178_cfa_info3397, _funcall_cinfo_strength_set_2931_178_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(set_ex_it_cinfo_approx_env_131_cfa_info, _set_ex_it_cinfo_approx2862_120_cfa_info3398, _set_ex_it_cinfo_approx2862_120_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(allocate_reshaped_global_env_91_cfa_info, _allocate_reshaped_global_82_cfa_info3399, _allocate_reshaped_global_82_cfa_info, 0L, 0);
DEFINE_EXPORT_PROCEDURE(make_box_cinfo_value_env_43_cfa_info, _make_box_cinfo_value2831_209_cfa_info3400, _make_box_cinfo_value2831_209_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(box_ref_cinfo_approx_env_110_cfa_info, _box_ref_cinfo_approx2799_73_cfa_info3401, _box_ref_cinfo_approx2799_73_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_box_cinfo_value_set__env_236_cfa_info, _make_box_cinfo_value_set_2830_42_cfa_info3402, _make_box_cinfo_value_set_2830_42_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(intern_sfun_cinfo_side_effect__env_227_cfa_info, _intern_sfun_cinfo_side_effect_3051_57_cfa_info3403, _intern_sfun_cinfo_side_effect_3051_57_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(widening_extern_sfun_cinfo_env_97_cfa_info, _widening_extern_sfun_cinfo3075_199_cfa_info3404, _widening_extern_sfun_cinfo3075_199_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(setq_cinfo_var_set__env_182_cfa_info, _setq_cinfo_var_set_2906_217_cfa_info3405, _setq_cinfo_var_set_2906_217_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(intern_sfun_cinfo_body_env_59_cfa_info, _intern_sfun_cinfo_body3065_40_cfa_info3406, _intern_sfun_cinfo_body3065_40_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(fail_cinfo_proc_env_81_cfa_info, _fail_cinfo_proc2881_18_cfa_info3407, _fail_cinfo_proc2881_18_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(reshaped_global_removable_env_211_cfa_info, _reshaped_global_removable2984_107_cfa_info3408, _reshaped_global_removable2984_107_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(kwote_node_value_env_42_cfa_info, _kwote_node_value2961_201_cfa_info3409, _kwote_node_value2961_201_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(intern_sfun_cinfo_stack_allocator_env_106_cfa_info, _intern_sfun_cinfo_stack_allocator3055_135_cfa_info3410, _intern_sfun_cinfo_stack_allocator3055_135_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_make_box_type_env_240_cfa_info, _pre_make_box_type2836_191_cfa_info3411, _pre_make_box_type2836_191_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(set_ex_it_cinfo_body_set__env_47_cfa_info, _set_ex_it_cinfo_body_set_2860_199_cfa_info3412, _set_ex_it_cinfo_body_set_2860_199_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(widening_pragma_cinfo_env_171_cfa_info, _widening_pragma_cinfo2911_177_cfa_info3413, _widening_pragma_cinfo2911_177_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(widening_fail_cinfo_env_226_cfa_info, _widening_fail_cinfo2875_121_cfa_info3414, _widening_fail_cinfo2875_121_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sexit_cinfo_handler_set__env_32_cfa_info, _sexit_cinfo_handler_set_3021_214_cfa_info3415, _sexit_cinfo_handler_set_3021_214_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(cfun_cinfo_macro__env_63_cfa_info, _cfun_cinfo_macro_3115_10_cfa_info3416, _cfun_cinfo_macro_3115_10_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(reshaped_local_type_set__env_180_cfa_info, _reshaped_local_type_set_3003_238_cfa_info3417, _reshaped_local_type_set_3003_238_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(box_ref_o_cinfo_var_env_43_cfa_info, _box_ref_o_cinfo_var2778_106_cfa_info3418, _box_ref_o_cinfo_var2778_106_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_clo_env__env_100_cfa_info, _pre_clo_env__150_cfa_info3419, _pre_clo_env__150_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(conditional_cinfo_approx_env_121_cfa_info, _conditional_cinfo_approx2900_167_cfa_info3420, _conditional_cinfo_approx2900_167_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sexit_cinfo_detached__set__env_50_cfa_info, _sexit_cinfo_detached__set_3023_40_cfa_info3421, _sexit_cinfo_detached__set_3023_40_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(reshaped_local_occurrence_env_115_cfa_info, _reshaped_local_occurrence3014_246_cfa_info3422, _reshaped_local_occurrence3014_246_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(box_set__cinfo_type_env_222_cfa_info, _box_set__cinfo_type2804_252_cfa_info3423, _box_set__cinfo_type2804_252_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(widening_jump_ex_it_cinfo_env_171_cfa_info, _widening_jump_ex_it_cinfo2843_227_cfa_info3424, _widening_jump_ex_it_cinfo2843_227_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(jump_ex_it_cinfo_type_set__env_198_cfa_info, _jump_ex_it_cinfo_type_set_2846_233_cfa_info3425, _jump_ex_it_cinfo_type_set_2846_233_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(app_ly_cinfo_arg_env_40_cfa_info, _app_ly_cinfo_arg2947_88_cfa_info3426, _app_ly_cinfo_arg2947_88_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(conditional_cinfo_false_set__env_119_cfa_info, _conditional_cinfo_false_set_2898_0_cfa_info3427, _conditional_cinfo_false_set_2898_0_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(allocate_pre_make_box_env_176_cfa_info, _allocate_pre_make_box_48_cfa_info3428, _allocate_pre_make_box_48_cfa_info, 0L, 0);
DEFINE_EXPORT_PROCEDURE(approx_lost_stamp_set__env_16_cfa_info, _approx_lost_stamp_set_3126_117_cfa_info3429, _approx_lost_stamp_set_3126_117_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(widening_cvar_cinfo_env_19_cfa_info, _widening_cvar_cinfo3026_143_cfa_info3430, _widening_cvar_cinfo3026_143_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(kwote_cinfo_approx_env_222_cfa_info, _kwote_cinfo_approx2955_234_cfa_info3431, _kwote_cinfo_approx2955_234_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(fail_cinfo_proc_set__env_86_cfa_info, _fail_cinfo_proc_set_2880_220_cfa_info3432, _fail_cinfo_proc_set_2880_220_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(box_set__o_cinfo_approx_env_154_cfa_info, _box_set__o_cinfo_approx2789_243_cfa_info3433, _box_set__o_cinfo_approx2789_243_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(extern_sfun_cinfo_body_set__env_27_cfa_info, _extern_sfun_cinfo_body_set_3092_110_cfa_info3434, _extern_sfun_cinfo_body_set_3092_110_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pragma_cinfo_side_effect__env_198_cfa_info, _pragma_cinfo_side_effect_2917_92_cfa_info3435, _pragma_cinfo_side_effect_2917_92_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_jump_ex_it_cinfo_env_165_cfa_info, _make_jump_ex_it_cinfo2844_63_cfa_info3436, _make_jump_ex_it_cinfo2844_63_cfa_info, 0L, 5);
DEFINE_EXPORT_PROCEDURE(box_ref_cinfo_var_env_100_cfa_info, _box_ref_cinfo_var2798_240_cfa_info3437, _box_ref_cinfo_var2798_240_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(kwote_cinfo__env_181_cfa_info, _kwote_cinfo__102_cfa_info3438, _kwote_cinfo__102_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(intern_sfun_cinfo_dsssl_keywords_set__env_176_cfa_info, _intern_sfun_cinfo_dsssl_keywords_set_3068_50_cfa_info3439, _intern_sfun_cinfo_dsssl_keywords_set_3068_50_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(sexit_cinfo_handler_env_241_cfa_info, _sexit_cinfo_handler3022_94_cfa_info3440, _sexit_cinfo_handler3022_94_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(box_set__o_cinfo_type_env_80_cfa_info, _box_set__o_cinfo_type2784_75_cfa_info3441, _box_set__o_cinfo_type2784_75_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(widening_set_ex_it_cinfo_env_119_cfa_info, _widening_set_ex_it_cinfo2853_220_cfa_info3442, _widening_set_ex_it_cinfo2853_220_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(funcall_cinfo_args_set__env_247_cfa_info, _funcall_cinfo_args_set_2929_237_cfa_info3443, _funcall_cinfo_args_set_2929_237_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(allocate_select_cinfo_env_166_cfa_info, _allocate_select_cinfo_74_cfa_info3444, _allocate_select_cinfo_74_cfa_info, 0L, 0);
DEFINE_EXPORT_PROCEDURE(extern_sfun_cinfo_top__env_145_cfa_info, _extern_sfun_cinfo_top_3085_170_cfa_info3445, _extern_sfun_cinfo_top_3085_170_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(approx__env_16_cfa_info, _approx__184_cfa_info3446, _approx__184_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(select_cinfo_test_env_55_cfa_info, _select_cinfo_test2871_18_cfa_info3447, _select_cinfo_test2871_18_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_box_o_cinfo_side_effect__env_155_cfa_info, _make_box_o_cinfo_side_effect_2816_232_cfa_info3448, _make_box_o_cinfo_side_effect_2816_232_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(box_set__o_cinfo_var_env_115_cfa_info, _box_set__o_cinfo_var2786_188_cfa_info3449, _box_set__o_cinfo_var2786_188_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(funcall_cinfo__env_176_cfa_info, _funcall_cinfo__59_cfa_info3450, _funcall_cinfo__59_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(reshaped_global_import_env_87_cfa_info, _reshaped_global_import2989_163_cfa_info3451, _reshaped_global_import2989_163_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(box_set__o_cinfo_value_set__env_60_cfa_info, _box_set__o_cinfo_value_set_2787_108_cfa_info3452, _box_set__o_cinfo_value_set_2787_108_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(conditional_cinfo_test_set__env_187_cfa_info, _conditional_cinfo_test_set_2894_208_cfa_info3453, _conditional_cinfo_test_set_2894_208_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(svar_cinfo_clo_env__set__env_145_cfa_info, _svar_cinfo_clo_env__set_3035_110_cfa_info3454, _svar_cinfo_clo_env__set_3035_110_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(kwote_cinfo_type_env_149_cfa_info, _kwote_cinfo_type2953_68_cfa_info3455, _kwote_cinfo_type2953_68_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(widening_box_set__o_cinfo_env_110_cfa_info, _widening_box_set__o_cinfo2780_213_cfa_info3456, _widening_box_set__o_cinfo2780_213_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(jump_ex_it_cinfo_type_env_10_cfa_info, _jump_ex_it_cinfo_type2847_201_cfa_info3457, _jump_ex_it_cinfo_type2847_201_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(setq_cinfo_type_set__env_20_cfa_info, _setq_cinfo_type_set_2904_118_cfa_info3458, _setq_cinfo_type_set_2904_118_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pragma_cinfo_side_effect__set__env_19_cfa_info, _pragma_cinfo_side_effect__set_2916_3_cfa_info3459, _pragma_cinfo_side_effect__set_2916_3_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(approx_type_set__env_69_cfa_info, _approx_type_set_3120_213_cfa_info3460, _approx_type_set_3120_213_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(extern_sfun_cinfo_side_effect__env_58_cfa_info, _extern_sfun_cinfo_side_effect_3079_78_cfa_info3461, _extern_sfun_cinfo_side_effect_3079_78_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(reshaped_global_user__env_60_cfa_info, _reshaped_global_user_2995_142_cfa_info3462, _reshaped_global_user_2995_142_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(set_ex_it_cinfo_loc_env_119_cfa_info, _set_ex_it_cinfo_loc2855_151_cfa_info3463, _set_ex_it_cinfo_loc2855_151_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(intern_sfun_cinfo_stamp_env_215_cfa_info, _intern_sfun_cinfo_stamp3074_165_cfa_info3464, _intern_sfun_cinfo_stamp3074_165_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(setq_cinfo_var_env_181_cfa_info, _setq_cinfo_var2907_183_cfa_info3465, _setq_cinfo_var2907_183_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_box_set__o_cinfo_env_46_cfa_info, _make_box_set__o_cinfo2781_191_cfa_info3466, _make_box_set__o_cinfo2781_191_cfa_info, 0L, 5);
DEFINE_EXPORT_PROCEDURE(reshaped_global_value_set__env_69_cfa_info, _reshaped_global_value_set_2977_126_cfa_info3467, _reshaped_global_value_set_2977_126_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(widening_svar_cinfo_env_245_cfa_info, _widening_svar_cinfo3030_209_cfa_info3468, _widening_svar_cinfo3030_209_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(box_ref_o_cinfo_side_effect__env_108_cfa_info, _box_ref_o_cinfo_side_effect_2776_96_cfa_info3469, _box_ref_o_cinfo_side_effect_2776_96_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(intern_sfun_cinfo_body_set__env_138_cfa_info, _intern_sfun_cinfo_body_set_3064_241_cfa_info3470, _intern_sfun_cinfo_body_set_3064_241_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(widening_pre_clo_env_env_188_cfa_info, _widening_pre_clo_env_41_cfa_info3471, _widening_pre_clo_env_41_cfa_info, 0L, 0);
DEFINE_EXPORT_PROCEDURE(allocate_make_box_cinfo_env_36_cfa_info, _allocate_make_box_cinfo_36_cfa_info3472, _allocate_make_box_cinfo_36_cfa_info, 0L, 0);
DEFINE_EXPORT_PROCEDURE(conditional_cinfo_side_effect__set__env_103_cfa_info, _conditional_cinfo_side_effect__set_2892_133_cfa_info3473, _conditional_cinfo_side_effect__set_2892_133_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(extern_sfun_cinfo_approx_env_154_cfa_info, _extern_sfun_cinfo_approx3100_201_cfa_info3474, _extern_sfun_cinfo_approx3100_201_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(cfun_cinfo_predicate_of_set__env_216_cfa_info, _cfun_cinfo_predicate_of_set_3106_47_cfa_info3475, _cfun_cinfo_predicate_of_set_3106_47_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_reshaped_global_env_69_cfa_info, _make_reshaped_global2971_92_cfa_info3476, _make_reshaped_global2971_92_cfa_info, 0L, 15);
DEFINE_EXPORT_PROCEDURE(approx_allocs_env_223_cfa_info, _approx_allocs3123_186_cfa_info3477, _approx_allocs3123_186_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_box_cinfo_type_env_8_cfa_info, _make_box_cinfo_type2827_75_cfa_info3478, _make_box_cinfo_type2827_75_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(allocate_approx_env_171_cfa_info, _allocate_approx_254_cfa_info3479, _allocate_approx_254_cfa_info, 0L, 0);
DEFINE_EXPORT_PROCEDURE(pragma_cinfo_loc_env_98_cfa_info, _pragma_cinfo_loc2913_152_cfa_info3480, _pragma_cinfo_loc2913_152_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(box_set__o_cinfo_value_env_203_cfa_info, _box_set__o_cinfo_value2788_117_cfa_info3481, _box_set__o_cinfo_value2788_117_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(conditional_cinfo_test_env_87_cfa_info, _conditional_cinfo_test2895_11_cfa_info3482, _conditional_cinfo_test2895_11_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(box_set__o_cinfo_type_set__env_23_cfa_info, _box_set__o_cinfo_type_set_2783_250_cfa_info3483, _box_set__o_cinfo_type_set_2783_250_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(widening_pre_make_box_env_11_cfa_info, _widening_pre_make_box_226_cfa_info3484, _widening_pre_make_box_226_cfa_info, 0L, 0);
DEFINE_EXPORT_PROCEDURE(reshaped_global_type_set__env_88_cfa_info, _reshaped_global_type_set_2975_43_cfa_info3485, _reshaped_global_type_set_2975_43_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(extern_sfun_cinfo_args_env_235_cfa_info, _extern_sfun_cinfo_args3091_190_cfa_info3486, _extern_sfun_cinfo_args3091_190_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(fail_cinfo_obj_env_199_cfa_info, _fail_cinfo_obj2885_174_cfa_info3487, _fail_cinfo_obj2885_174_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(allocate_intern_sfun_cinfo_env_101_cfa_info, _allocate_intern_sfun_cinfo_249_cfa_info3488, _allocate_intern_sfun_cinfo_249_cfa_info, 0L, 0);
DEFINE_EXPORT_PROCEDURE(reshaped_local__env_45_cfa_info, _reshaped_local__93_cfa_info3489, _reshaped_local__93_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(app_ly_cinfo__env_112_cfa_info, _app_ly_cinfo__202_cfa_info3490, _app_ly_cinfo__202_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_make_box_loc_env_122_cfa_info, _pre_make_box_loc2834_157_cfa_info3491, _pre_make_box_loc2834_157_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_pragma_cinfo_env_229_cfa_info, _make_pragma_cinfo2912_176_cfa_info3492, _make_pragma_cinfo2912_176_cfa_info, 0L, 7);
DEFINE_EXPORT_PROCEDURE(box_set__cinfo_var_env_178_cfa_info, _box_set__cinfo_var2806_123_cfa_info3493, _box_set__cinfo_var2806_123_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(intern_sfun_cinfo_property_set__env_190_cfa_info, _intern_sfun_cinfo_property_set_3060_59_cfa_info3494, _intern_sfun_cinfo_property_set_3060_59_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(reshaped_local_fast_alpha_env_248_cfa_info, _reshaped_local_fast_alpha3010_58_cfa_info3495, _reshaped_local_fast_alpha3010_58_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(widening_make_box_o_cinfo_env_250_cfa_info, _widening_make_box_o_cinfo2810_191_cfa_info3496, _widening_make_box_o_cinfo2810_191_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_box_cinfo__env_239_cfa_info, _make_box_cinfo__189_cfa_info3497, _make_box_cinfo__189_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(reshaped_global_src_set__env_155_cfa_info, _reshaped_global_src_set_2997_68_cfa_info3498, _reshaped_global_src_set_2997_68_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(widening_select_cinfo_env_114_cfa_info, _widening_select_cinfo2863_4_cfa_info3499, _widening_select_cinfo2863_4_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(kwote_cinfo_type_set__env_255_cfa_info, _kwote_cinfo_type_set_2952_45_cfa_info3500, _kwote_cinfo_type_set_2952_45_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_box_cinfo_key_env_74_cfa_info, _make_box_cinfo_key_44_cfa_info3501, _make_box_cinfo_key_44_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(setq_cinfo_value_env_60_cfa_info, _setq_cinfo_value2909_179_cfa_info3502, _setq_cinfo_value2909_179_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(widening_scnst_cinfo_env_215_cfa_info, _widening_scnst_cinfo3039_53_cfa_info3503, _widening_scnst_cinfo3039_53_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(svar_cinfo_approx_env_243_cfa_info, _svar_cinfo_approx3034_160_cfa_info3504, _svar_cinfo_approx3034_160_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(reshaped_global_type_env_100_cfa_info, _reshaped_global_type2976_28_cfa_info3505, _reshaped_global_type2976_28_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(svar_cinfo_loc_set__env_226_cfa_info, _svar_cinfo_loc_set_3032_170_cfa_info3506, _svar_cinfo_loc_set_3032_170_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(fail_cinfo_loc_env_41_cfa_info, _fail_cinfo_loc2877_16_cfa_info3507, _fail_cinfo_loc2877_16_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(extern_sfun_cinfo_predicate_of_set__env_185_cfa_info, _extern_sfun_cinfo_predicate_of_set_3080_197_cfa_info3508, _extern_sfun_cinfo_predicate_of_set_3080_197_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(select_cinfo_test_set__env_50_cfa_info, _select_cinfo_test_set_2870_225_cfa_info3509, _select_cinfo_test_set_2870_225_cfa_info, 0L, 2);
DEFINE_STRING(string3191_cfa_info, string3191_cfa_info3510, "BOX-REF/O-CINFO BOX-SET!/O-CINFO BOX-REF/CINFO BOX-SET!/CINFO MAKE-BOX/O-CINFO MAKE-BOX/CINFO PRE-MAKE-BOX JUMP-EX-IT/CINFO SET-EX-IT/CINFO SELECT/CINFO FAIL/CINFO CONDITIONAL/CINFO SETQ/CINFO PRAGMA/CINFO FUNCALL/CINFO APP-LY/CINFO KWOTE/CINFO KWOTE/NODE ATOM/CINFO RESHAPED-GLOBAL RESHAPED-LOCAL SEXIT/CINFO CVAR/CINFO SVAR/CINFO PRE-CLO-ENV SCNST/CINFO INTERN-SFUN/CINFO EXTERN-SFUN/CINFO CFUN/CINFO APPROX ", 410);
DEFINE_EXPORT_PROCEDURE(pragma_cinfo_key_set__env_211_cfa_info, _pragma_cinfo_key_set__201_cfa_info3511, _pragma_cinfo_key_set__201_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(intern_sfun_cinfo_dsssl_keywords_env_248_cfa_info, _intern_sfun_cinfo_dsssl_keywords3069_120_cfa_info3512, _intern_sfun_cinfo_dsssl_keywords3069_120_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(conditional_cinfo_side_effect__env_116_cfa_info, _conditional_cinfo_side_effect_2893_157_cfa_info3513, _conditional_cinfo_side_effect_2893_157_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_make_box_o_cinfo_env_200_cfa_info, _make_make_box_o_cinfo2811_50_cfa_info3514, _make_make_box_o_cinfo2811_50_cfa_info, 0L, 7);
DEFINE_EXPORT_PROCEDURE(funcall_cinfo_strength_env_147_cfa_info, _funcall_cinfo_strength2932_36_cfa_info3515, _funcall_cinfo_strength2932_36_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(reshaped_global_access_env_211_cfa_info, _reshaped_global_access2980_133_cfa_info3516, _reshaped_global_access2980_133_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_box_o_cinfo_value_approx_env_182_cfa_info, _make_box_o_cinfo_value_approx2822_53_cfa_info3517, _make_box_o_cinfo_value_approx2822_53_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pragma_cinfo_type_set__env_162_cfa_info, _pragma_cinfo_type_set_2914_52_cfa_info3518, _pragma_cinfo_type_set_2914_52_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(allocate_kwote_cinfo_env_199_cfa_info, _allocate_kwote_cinfo_178_cfa_info3519, _allocate_kwote_cinfo_178_cfa_info, 0L, 0);
DEFINE_EXPORT_PROCEDURE(conditional_cinfo_false_env_228_cfa_info, _conditional_cinfo_false2899_105_cfa_info3520, _conditional_cinfo_false2899_105_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_extern_sfun_cinfo_env_154_cfa_info, _make_extern_sfun_cinfo3076_187_cfa_info3521, _make_extern_sfun_cinfo3076_187_cfa_info, 0L, 13);
DEFINE_EXPORT_PROCEDURE(pre_make_box_side_effect__env_178_cfa_info, _pre_make_box_side_effect_2838_255_cfa_info3522, _pre_make_box_side_effect_2838_255_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(app_ly_cinfo_type_set__env_219_cfa_info, _app_ly_cinfo_type_set_2942_95_cfa_info3523, _app_ly_cinfo_type_set_2942_95_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(atom_cinfo_value_env_128_cfa_info, _atom_cinfo_value2969_57_cfa_info3524, _atom_cinfo_value2969_57_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(intern_sfun_cinfo_predicate_of_env_150_cfa_info, _intern_sfun_cinfo_predicate_of3053_13_cfa_info3525, _intern_sfun_cinfo_predicate_of3053_13_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(allocate_reshaped_local_env_189_cfa_info, _allocate_reshaped_local_17_cfa_info3526, _allocate_reshaped_local_17_cfa_info, 0L, 0);
DEFINE_EXPORT_PROCEDURE(make_box_ref_cinfo_env_80_cfa_info, _make_box_ref_cinfo2791_237_cfa_info3527, _make_box_ref_cinfo2791_237_cfa_info, 0L, 6);
DEFINE_EXPORT_PROCEDURE(cfun_cinfo_infix__env_255_cfa_info, _cfun_cinfo_infix_3117_134_cfa_info3528, _cfun_cinfo_infix_3117_134_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_box_o_cinfo_key_set__env_179_cfa_info, _make_box_o_cinfo_key_set__74_cfa_info3529, _make_box_o_cinfo_key_set__74_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(reshaped_global_evaluable__env_36_cfa_info, _reshaped_global_evaluable_2991_2_cfa_info3530, _reshaped_global_evaluable_2991_2_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(reshaped_global_evaluable__set__env_95_cfa_info, _reshaped_global_evaluable__set_2990_171_cfa_info3531, _reshaped_global_evaluable__set_2990_171_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_box_cinfo_key_set__env_13_cfa_info, _make_box_cinfo_key_set__204_cfa_info3532, _make_box_cinfo_key_set__204_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(box_ref_cinfo_var_set__env_88_cfa_info, _box_ref_cinfo_var_set_2797_195_cfa_info3533, _box_ref_cinfo_var_set_2797_195_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_box_o_cinfo_value_set__env_97_cfa_info, _make_box_o_cinfo_value_set_2818_253_cfa_info3534, _make_box_o_cinfo_value_set_2818_253_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(conditional_cinfo_true_set__env_200_cfa_info, _conditional_cinfo_true_set_2896_30_cfa_info3535, _conditional_cinfo_true_set_2896_30_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(reshaped_global_id_env_94_cfa_info, _reshaped_global_id2972_26_cfa_info3536, _reshaped_global_id2972_26_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(widening_box_set__cinfo_env_7_cfa_info, _widening_box_set__cinfo2800_31_cfa_info3537, _widening_box_set__cinfo2800_31_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_pre_clo_env_env_208_cfa_info, _make_pre_clo_env_110_cfa_info3538, _make_pre_clo_env_110_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(reshaped_local_name_env_98_cfa_info, _reshaped_local_name3002_125_cfa_info3539, _reshaped_local_name3002_125_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(intern_sfun_cinfo_predicate_of_set__env_233_cfa_info, _intern_sfun_cinfo_predicate_of_set_3052_3_cfa_info3540, _intern_sfun_cinfo_predicate_of_set_3052_3_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(allocate_sexit_cinfo_env_157_cfa_info, _allocate_sexit_cinfo_64_cfa_info3541, _allocate_sexit_cinfo_64_cfa_info, 0L, 0);
DEFINE_EXPORT_PROCEDURE(fail_cinfo_type_env_252_cfa_info, _fail_cinfo_type2879_168_cfa_info3542, _fail_cinfo_type2879_168_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_box_cinfo_side_effect__set__env_119_cfa_info, _make_box_cinfo_side_effect__set_2828_43_cfa_info3543, _make_box_cinfo_side_effect__set_2828_43_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(box_ref_o_cinfo_type_set__env_49_cfa_info, _box_ref_o_cinfo_type_set_2773_28_cfa_info3544, _box_ref_o_cinfo_type_set_2773_28_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(kwote_node_loc_env_235_cfa_info, _kwote_node_loc2958_66_cfa_info3545, _kwote_node_loc2958_66_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(reshaped_global_src_env_194_cfa_info, _reshaped_global_src2998_228_cfa_info3546, _reshaped_global_src2998_228_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(widening_intern_sfun_cinfo_env_79_cfa_info, _widening_intern_sfun_cinfo3047_38_cfa_info3547, _widening_intern_sfun_cinfo3047_38_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(app_ly_cinfo_fun_set__env_205_cfa_info, _app_ly_cinfo_fun_set_2944_107_cfa_info3548, _app_ly_cinfo_fun_set_2944_107_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(extern_sfun_cinfo_loc_env_215_cfa_info, _extern_sfun_cinfo_loc3099_188_cfa_info3549, _extern_sfun_cinfo_loc3099_188_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pragma_cinfo_approx_env_114_cfa_info, _pragma_cinfo_approx2921_32_cfa_info3550, _pragma_cinfo_approx2921_32_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sexit_cinfo_detached__env_55_cfa_info, _sexit_cinfo_detached_3024_61_cfa_info3551, _sexit_cinfo_detached_3024_61_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(reshaped_global_library__set__env_45_cfa_info, _reshaped_global_library__set_2992_245_cfa_info3552, _reshaped_global_library__set_2992_245_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(allocate_box_ref_o_cinfo_env_184_cfa_info, _allocate_box_ref_o_cinfo_197_cfa_info3553, _allocate_box_ref_o_cinfo_197_cfa_info, 0L, 0);
DEFINE_EXPORT_PROCEDURE(select_cinfo__env_101_cfa_info, _select_cinfo__186_cfa_info3554, _select_cinfo__186_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(intern_sfun_cinfo_the_closure_env_198_cfa_info, _intern_sfun_cinfo_the_closure3059_177_cfa_info3555, _intern_sfun_cinfo_the_closure3059_177_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(reshaped_global_user__set__env_161_cfa_info, _reshaped_global_user__set_2994_92_cfa_info3556, _reshaped_global_user__set_2994_92_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(scnst_cinfo_class_env_133_cfa_info, _scnst_cinfo_class3043_119_cfa_info3557, _scnst_cinfo_class3043_119_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(extern_sfun_cinfo_body_env_96_cfa_info, _extern_sfun_cinfo_body3093_231_cfa_info3558, _extern_sfun_cinfo_body3093_231_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(allocate_box_ref_cinfo_env_99_cfa_info, _allocate_box_ref_cinfo_238_cfa_info3559, _allocate_box_ref_cinfo_238_cfa_info, 0L, 0);
DEFINE_EXPORT_PROCEDURE(select_cinfo_side_effect__env_63_cfa_info, _select_cinfo_side_effect_2869_172_cfa_info3560, _select_cinfo_side_effect_2869_172_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(box_ref_o_cinfo_var_set__env_236_cfa_info, _box_ref_o_cinfo_var_set_2777_55_cfa_info3561, _box_ref_o_cinfo_var_set_2777_55_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(conditional_cinfo_type_set__env_12_cfa_info, _conditional_cinfo_type_set_2890_68_cfa_info3562, _conditional_cinfo_type_set_2890_68_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(cvar_cinfo_approx_env_74_cfa_info, _cvar_cinfo_approx3029_161_cfa_info3563, _cvar_cinfo_approx3029_161_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_scnst_cinfo_env_240_cfa_info, _make_scnst_cinfo3040_74_cfa_info3564, _make_scnst_cinfo3040_74_cfa_info, 0L, 4);
DEFINE_EXPORT_PROCEDURE(box_ref_o_cinfo_key_env_96_cfa_info, _box_ref_o_cinfo_key_193_cfa_info3565, _box_ref_o_cinfo_key_193_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(select_cinfo_key_env_204_cfa_info, _select_cinfo_key_1_cfa_info3566, _select_cinfo_key_1_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_atom_cinfo_env_47_cfa_info, _make_atom_cinfo2964_82_cfa_info3567, _make_atom_cinfo2964_82_cfa_info, 0L, 4);
DEFINE_EXPORT_PROCEDURE(sexit_cinfo__env_143_cfa_info, _sexit_cinfo__68_cfa_info3568, _sexit_cinfo__68_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_setq_cinfo_env_96_cfa_info, _make_setq_cinfo2902_99_cfa_info3569, _make_setq_cinfo2902_99_cfa_info, 0L, 5);
DEFINE_EXPORT_PROCEDURE(funcall_cinfo_loc_env_41_cfa_info, _funcall_cinfo_loc2924_64_cfa_info3570, _funcall_cinfo_loc2924_64_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_approx_env_224_cfa_info, _make_approx3119_236_cfa_info3571, _make_approx3119_236_cfa_info, 0L, 5);
DEFINE_EXPORT_PROCEDURE(conditional_cinfo_key_env_82_cfa_info, _conditional_cinfo_key_29_cfa_info3572, _conditional_cinfo_key_29_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_pre_make_box_env_106_cfa_info, _make_pre_make_box2833_64_cfa_info3573, _make_pre_make_box2833_64_cfa_info, 0L, 5);
DEFINE_EXPORT_PROCEDURE(pre_make_box_type_set__env_123_cfa_info, _pre_make_box_type_set_2835_95_cfa_info3574, _pre_make_box_type_set_2835_95_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(funcall_cinfo_approx_env_186_cfa_info, _funcall_cinfo_approx2933_43_cfa_info3575, _funcall_cinfo_approx2933_43_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(box_set__cinfo_var_set__env_137_cfa_info, _box_set__cinfo_var_set_2805_221_cfa_info3576, _box_set__cinfo_var_set_2805_221_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_cfun_cinfo_env_43_cfa_info, _make_cfun_cinfo3102_0_cfa_info3577, _make_cfun_cinfo3102_0_cfa_info, 0L, 10);
DEFINE_EXPORT_PROCEDURE(widening_reshaped_global_env_252_cfa_info, _widening_reshaped_global_191_cfa_info3578, _widening_reshaped_global_191_cfa_info, 0L, 0);
DEFINE_EXPORT_PROCEDURE(box_ref_cinfo_key_set__env_128_cfa_info, _box_ref_cinfo_key_set__118_cfa_info3579, _box_ref_cinfo_key_set__118_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(extern_sfun_cinfo_property_set__env_242_cfa_info, _extern_sfun_cinfo_property_set_3088_67_cfa_info3580, _extern_sfun_cinfo_property_set_3088_67_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(extern_sfun_cinfo_predicate_of_env_113_cfa_info, _extern_sfun_cinfo_predicate_of3081_90_cfa_info3581, _extern_sfun_cinfo_predicate_of3081_90_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_box_o_cinfo_side_effect__set__env_4_cfa_info, _make_box_o_cinfo_side_effect__set_2815_15_cfa_info3582, _make_box_o_cinfo_side_effect__set_2815_15_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(kwote_cinfo_value_env_115_cfa_info, _kwote_cinfo_value2954_71_cfa_info3583, _kwote_cinfo_value2954_71_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(scnst_cinfo_class_set__env_191_cfa_info, _scnst_cinfo_class_set_3042_195_cfa_info3584, _scnst_cinfo_class_set_3042_195_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_make_box_cinfo_env_141_cfa_info, _make_make_box_cinfo2824_251_cfa_info3585, _make_make_box_cinfo2824_251_cfa_info, 0L, 6);
DEFINE_EXPORT_PROCEDURE(make_box_cinfo_approx_env_212_cfa_info, _make_box_cinfo_approx2832_148_cfa_info3586, _make_box_cinfo_approx2832_148_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(set_ex_it_cinfo_type_env_179_cfa_info, _set_ex_it_cinfo_type2857_188_cfa_info3587, _set_ex_it_cinfo_type2857_188_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(box_ref_cinfo_key_env_206_cfa_info, _box_ref_cinfo_key_241_cfa_info3588, _box_ref_cinfo_key_241_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(extern_sfun_cinfo_property_env_202_cfa_info, _extern_sfun_cinfo_property3089_138_cfa_info3589, _extern_sfun_cinfo_property3089_138_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_clo_env_loc_set__env_249_cfa_info, _pre_clo_env_loc_set_3037_152_cfa_info3590, _pre_clo_env_loc_set_3037_152_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(reshaped_local_removable_set__env_47_cfa_info, _reshaped_local_removable_set_3011_28_cfa_info3591, _reshaped_local_removable_set_3011_28_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_select_cinfo_env_204_cfa_info, _make_select_cinfo2864_67_cfa_info3592, _make_select_cinfo2864_67_cfa_info, 0L, 8);
DEFINE_EXPORT_PROCEDURE(intern_sfun_cinfo_property_env_58_cfa_info, _intern_sfun_cinfo_property3061_231_cfa_info3593, _intern_sfun_cinfo_property3061_231_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(fail_cinfo_msg_env_196_cfa_info, _fail_cinfo_msg2883_50_cfa_info3594, _fail_cinfo_msg2883_50_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(box_ref_o_cinfo_type_env_33_cfa_info, _box_ref_o_cinfo_type2774_225_cfa_info3595, _box_ref_o_cinfo_type2774_225_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(extern_sfun_cinfo_args_set__env_151_cfa_info, _extern_sfun_cinfo_args_set_3090_10_cfa_info3596, _extern_sfun_cinfo_args_set_3090_10_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(fail_cinfo_type_set__env_171_cfa_info, _fail_cinfo_type_set_2878_61_cfa_info3597, _fail_cinfo_type_set_2878_61_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(reshaped_local_occurrence_set__env_183_cfa_info, _reshaped_local_occurrence_set_3013_144_cfa_info3598, _reshaped_local_occurrence_set_3013_144_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(setq_cinfo_type_env_32_cfa_info, _setq_cinfo_type2905_96_cfa_info3599, _setq_cinfo_type2905_96_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(atom_cinfo_type_env_18_cfa_info, _atom_cinfo_type2967_147_cfa_info3600, _atom_cinfo_type2967_147_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(svar_cinfo_clo_env__env_221_cfa_info, _svar_cinfo_clo_env_3036_74_cfa_info3601, _svar_cinfo_clo_env_3036_74_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sexit_cinfo_approx_env_220_cfa_info, _sexit_cinfo_approx3025_89_cfa_info3602, _sexit_cinfo_approx3025_89_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(cfun_cinfo_top__set__env_224_cfa_info, _cfun_cinfo_top__set_3110_80_cfa_info3603, _cfun_cinfo_top__set_3110_80_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(intern_sfun_cinfo_arity_env_15_cfa_info, _intern_sfun_cinfo_arity3049_55_cfa_info3604, _intern_sfun_cinfo_arity3049_55_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(app_ly_cinfo_approx_env_175_cfa_info, _app_ly_cinfo_approx2948_16_cfa_info3605, _app_ly_cinfo_approx2948_16_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(atom_cinfo_type_set__env_99_cfa_info, _atom_cinfo_type_set_2966_94_cfa_info3606, _atom_cinfo_type_set_2966_94_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(intern_sfun_cinfo_class_set__env_171_cfa_info, _intern_sfun_cinfo_class_set_3066_64_cfa_info3607, _intern_sfun_cinfo_class_set_3066_64_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(select_cinfo_type_env_215_cfa_info, _select_cinfo_type2867_136_cfa_info3608, _select_cinfo_type2867_136_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(atom_cinfo_value_set__env_250_cfa_info, _atom_cinfo_value_set_2968_229_cfa_info3609, _atom_cinfo_value_set_2968_229_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(jump_ex_it_cinfo_value_env_63_cfa_info, _jump_ex_it_cinfo_value2851_45_cfa_info3610, _jump_ex_it_cinfo_value2851_45_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(scnst_cinfo_loc_set__env_71_cfa_info, _scnst_cinfo_loc_set_3044_121_cfa_info3611, _scnst_cinfo_loc_set_3044_121_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(reshaped_local_fast_alpha_set__env_176_cfa_info, _reshaped_local_fast_alpha_set_3009_148_cfa_info3612, _reshaped_local_fast_alpha_set_3009_148_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(fail_cinfo_msg_set__env_1_cfa_info, _fail_cinfo_msg_set_2882_185_cfa_info3613, _fail_cinfo_msg_set_2882_185_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(reshaped_local_access_env_185_cfa_info, _reshaped_local_access3008_115_cfa_info3614, _reshaped_local_access3008_115_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(reshaped_global_occurrence_env_13_cfa_info, _reshaped_global_occurrence2986_61_cfa_info3615, _reshaped_global_occurrence2986_61_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(box_ref_o_cinfo_key_set__env_27_cfa_info, _box_ref_o_cinfo_key_set__163_cfa_info3616, _box_ref_o_cinfo_key_set__163_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(set_ex_it_cinfo_var_env_225_cfa_info, _set_ex_it_cinfo_var2859_52_cfa_info3617, _set_ex_it_cinfo_var2859_52_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(setq_cinfo_approx_env_232_cfa_info, _setq_cinfo_approx2910_5_cfa_info3618, _setq_cinfo_approx2910_5_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(allocate_jump_ex_it_cinfo_env_187_cfa_info, _allocate_jump_ex_it_cinfo_34_cfa_info3619, _allocate_jump_ex_it_cinfo_34_cfa_info, 0L, 0);
DEFINE_EXPORT_PROCEDURE(intern_sfun_cinfo__env_78_cfa_info, _intern_sfun_cinfo__158_cfa_info3620, _intern_sfun_cinfo__158_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(select_cinfo_type_set__env_245_cfa_info, _select_cinfo_type_set_2866_85_cfa_info3621, _select_cinfo_type_set_2866_85_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(reshaped_local_user__env_185_cfa_info, _reshaped_local_user_3016_191_cfa_info3622, _reshaped_local_user_3016_191_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(extern_sfun_cinfo_top__set__env_150_cfa_info, _extern_sfun_cinfo_top__set_3084_123_cfa_info3623, _extern_sfun_cinfo_top__set_3084_123_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pragma_cinfo__env_191_cfa_info, _pragma_cinfo__129_cfa_info3624, _pragma_cinfo__129_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(app_ly_cinfo_loc_env_175_cfa_info, _app_ly_cinfo_loc2941_143_cfa_info3625, _app_ly_cinfo_loc2941_143_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(select_cinfo_clauses_env_190_cfa_info, _select_cinfo_clauses2872_12_cfa_info3626, _select_cinfo_clauses2872_12_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(fail_cinfo_obj_set__env_18_cfa_info, _fail_cinfo_obj_set_2884_198_cfa_info3627, _fail_cinfo_obj_set_2884_198_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(intern_sfun_cinfo_args_set__env_141_cfa_info, _intern_sfun_cinfo_args_set_3062_110_cfa_info3628, _intern_sfun_cinfo_args_set_3062_110_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(jump_ex_it_cinfo_exit_env_109_cfa_info, _jump_ex_it_cinfo_exit2849_23_cfa_info3629, _jump_ex_it_cinfo_exit2849_23_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(reshaped_global_value_env_64_cfa_info, _reshaped_global_value2978_206_cfa_info3630, _reshaped_global_value2978_206_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_box_ref_o_cinfo_env_7_cfa_info, _make_box_ref_o_cinfo2771_75_cfa_info3631, _make_box_ref_o_cinfo2771_75_cfa_info, 0L, 6);
DEFINE_EXPORT_PROCEDURE(make_reshaped_local_env_74_cfa_info, _make_reshaped_local2999_202_cfa_info3632, _make_reshaped_local2999_202_cfa_info, 0L, 11);
DEFINE_EXPORT_PROCEDURE(conditional_cinfo__env_84_cfa_info, _conditional_cinfo__117_cfa_info3633, _conditional_cinfo__117_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(scnst_cinfo_loc_env_44_cfa_info, _scnst_cinfo_loc3045_122_cfa_info3634, _scnst_cinfo_loc3045_122_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_kwote_node_env_34_cfa_info, _make_kwote_node2957_50_cfa_info3635, _make_kwote_node2957_50_cfa_info, 0L, 4);
DEFINE_EXPORT_PROCEDURE(reshaped_global_pragma_env_183_cfa_info, _reshaped_global_pragma2996_199_cfa_info3636, _reshaped_global_pragma2996_199_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(funcall_cinfo_type_env_252_cfa_info, _funcall_cinfo_type2926_242_cfa_info3637, _funcall_cinfo_type2926_242_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(allocate_atom_cinfo_env_231_cfa_info, _allocate_atom_cinfo_64_cfa_info3638, _allocate_atom_cinfo_64_cfa_info, 0L, 0);
DEFINE_EXPORT_PROCEDURE(make_box_o_cinfo__env_4_cfa_info, _make_box_o_cinfo__52_cfa_info3639, _make_box_o_cinfo__52_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(allocate_setq_cinfo_env_69_cfa_info, _allocate_setq_cinfo_116_cfa_info3640, _allocate_setq_cinfo_116_cfa_info, 0L, 0);
DEFINE_EXPORT_PROCEDURE(cfun_cinfo_side_effect__env_35_cfa_info, _cfun_cinfo_side_effect_3105_189_cfa_info3641, _cfun_cinfo_side_effect_3105_189_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(conditional_cinfo_type_env_52_cfa_info, _conditional_cinfo_type2891_50_cfa_info3642, _conditional_cinfo_type2891_50_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(scnst_cinfo_approx_env_197_cfa_info, _scnst_cinfo_approx3046_113_cfa_info3643, _scnst_cinfo_approx3046_113_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(reshaped_global_module_env_199_cfa_info, _reshaped_global_module2987_48_cfa_info3644, _reshaped_global_module2987_48_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(setq_cinfo_value_set__env_161_cfa_info, _setq_cinfo_value_set_2908_109_cfa_info3645, _setq_cinfo_value_set_2908_109_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(widening_box_ref_cinfo_env_136_cfa_info, _widening_box_ref_cinfo2790_171_cfa_info3646, _widening_box_ref_cinfo2790_171_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(allocate_conditional_cinfo_env_136_cfa_info, _allocate_conditional_cinfo_139_cfa_info3647, _allocate_conditional_cinfo_139_cfa_info, 0L, 0);
DEFINE_EXPORT_PROCEDURE(make_box_o_cinfo_type_set__env_66_cfa_info, _make_box_o_cinfo_type_set_2813_55_cfa_info3648, _make_box_o_cinfo_type_set_2813_55_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(cfun_cinfo_infix__set__env_221_cfa_info, _cfun_cinfo_infix__set_3116_180_cfa_info3649, _cfun_cinfo_infix__set_3116_180_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(reshaped_global_occurrence_set__env_29_cfa_info, _reshaped_global_occurrence_set_2985_192_cfa_info3650, _reshaped_global_occurrence_set_2985_192_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(allocate_box_set__o_cinfo_env_94_cfa_info, _allocate_box_set__o_cinfo_20_cfa_info3651, _allocate_box_set__o_cinfo_20_cfa_info, 0L, 0);
DEFINE_EXPORT_PROCEDURE(make_funcall_cinfo_env_104_cfa_info, _make_funcall_cinfo2923_185_cfa_info3652, _make_funcall_cinfo2923_185_cfa_info, 0L, 9);
DEFINE_EXPORT_PROCEDURE(allocate_cfun_cinfo_env_112_cfa_info, _allocate_cfun_cinfo_87_cfa_info3653, _allocate_cfun_cinfo_87_cfa_info, 0L, 0);
DEFINE_EXPORT_PROCEDURE(kwote_cinfo_loc_env_203_cfa_info, _kwote_cinfo_loc2951_52_cfa_info3654, _kwote_cinfo_loc2951_52_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_box_cinfo_loc_env_56_cfa_info, _make_box_cinfo_loc2825_22_cfa_info3655, _make_box_cinfo_loc2825_22_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_make_box_value_env_24_cfa_info, _pre_make_box_value2842_59_cfa_info3656, _pre_make_box_value2842_59_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(box_set__o_cinfo__env_187_cfa_info, _box_set__o_cinfo__123_cfa_info3657, _box_set__o_cinfo__123_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(cvar_cinfo_macro__env_3_cfa_info, _cvar_cinfo_macro_3028_11_cfa_info3658, _cvar_cinfo_macro_3028_11_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_intern_sfun_cinfo_env_207_cfa_info, _make_intern_sfun_cinfo3048_141_cfa_info3659, _make_intern_sfun_cinfo3048_141_cfa_info, 0L, 14);
DEFINE_EXPORT_PROCEDURE(app_ly_cinfo_arg_set__env_100_cfa_info, _app_ly_cinfo_arg_set_2946_162_cfa_info3660, _app_ly_cinfo_arg_set_2946_162_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(intern_sfun_cinfo_top__set__env_79_cfa_info, _intern_sfun_cinfo_top__set_3056_140_cfa_info3661, _intern_sfun_cinfo_top__set_3056_140_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(jump_ex_it_cinfo_approx_env_157_cfa_info, _jump_ex_it_cinfo_approx2852_36_cfa_info3662, _jump_ex_it_cinfo_approx2852_36_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(reshaped_global_fast_alpha_set__env_178_cfa_info, _reshaped_global_fast_alpha_set_2981_97_cfa_info3663, _reshaped_global_fast_alpha_set_2981_97_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(extern_sfun_cinfo_the_closure_env_139_cfa_info, _extern_sfun_cinfo_the_closure3087_249_cfa_info3664, _extern_sfun_cinfo_the_closure3087_249_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(atom_cinfo_loc_env_197_cfa_info, _atom_cinfo_loc2965_122_cfa_info3665, _atom_cinfo_loc2965_122_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(extern_sfun_cinfo_arity_env_37_cfa_info, _extern_sfun_cinfo_arity3077_249_cfa_info3666, _extern_sfun_cinfo_arity3077_249_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(box_set__cinfo_type_set__env_254_cfa_info, _box_set__cinfo_type_set_2803_239_cfa_info3667, _box_set__cinfo_type_set_2803_239_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(fail_cinfo__env_176_cfa_info, _fail_cinfo__61_cfa_info3668, _fail_cinfo__61_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(scnst_cinfo_node_env_253_cfa_info, _scnst_cinfo_node3041_91_cfa_info3669, _scnst_cinfo_node3041_91_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(kwote_node_node_env_136_cfa_info, _kwote_node_node2962_101_cfa_info3670, _kwote_node_node2962_101_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(extern_sfun_cinfo_the_closure_set__env_223_cfa_info, _extern_sfun_cinfo_the_closure_set_3086_194_cfa_info3671, _extern_sfun_cinfo_the_closure_set_3086_194_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(atom_cinfo__env_254_cfa_info, _atom_cinfo__122_cfa_info3672, _atom_cinfo__122_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(box_ref_cinfo_side_effect__env_111_cfa_info, _box_ref_cinfo_side_effect_2796_143_cfa_info3673, _box_ref_cinfo_side_effect_2796_143_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(approx_lost_stamp_env_117_cfa_info, _approx_lost_stamp3127_243_cfa_info3674, _approx_lost_stamp3127_243_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(intern_sfun_cinfo_loc_env_19_cfa_info, _intern_sfun_cinfo_loc3071_216_cfa_info3675, _intern_sfun_cinfo_loc3071_216_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_box_cinfo_type_set__env_108_cfa_info, _make_box_cinfo_type_set_2826_199_cfa_info3676, _make_box_cinfo_type_set_2826_199_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(funcall_cinfo_type_set__env_171_cfa_info, _funcall_cinfo_type_set_2925_90_cfa_info3677, _funcall_cinfo_type_set_2925_90_cfa_info, 0L, 2);
extern obj_t object__struct_env_210___object;
DEFINE_EXPORT_PROCEDURE(allocate_funcall_cinfo_env_186_cfa_info, _allocate_funcall_cinfo_40_cfa_info3678, _allocate_funcall_cinfo_40_cfa_info, 0L, 0);
DEFINE_EXPORT_PROCEDURE(make_box_o_cinfo_key_env_143_cfa_info, _make_box_o_cinfo_key2817_186_cfa_info3679, _make_box_o_cinfo_key2817_186_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(reshaped_local_key_env_98_cfa_info, _reshaped_local_key3017_67_cfa_info3680, _reshaped_local_key3017_67_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(select_cinfo_approx_env_156_cfa_info, _select_cinfo_approx2874_228_cfa_info3681, _select_cinfo_approx2874_228_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(allocate_app_ly_cinfo_env_68_cfa_info, _allocate_app_ly_cinfo_17_cfa_info3682, _allocate_app_ly_cinfo_17_cfa_info, 0L, 0);
DEFINE_EXPORT_PROCEDURE(box_ref_cinfo__env_241_cfa_info, _box_ref_cinfo__65_cfa_info3683, _box_ref_cinfo__65_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(app_ly_cinfo_type_env_77_cfa_info, _app_ly_cinfo_type2943_141_cfa_info3684, _app_ly_cinfo_type2943_141_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(setq_cinfo__env_100_cfa_info, _setq_cinfo__245_cfa_info3685, _setq_cinfo__245_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(box_ref_cinfo_type_set__env_32_cfa_info, _box_ref_cinfo_type_set_2793_113_cfa_info3686, _box_ref_cinfo_type_set_2793_113_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(box_ref_cinfo_side_effect__set__env_174_cfa_info, _box_ref_cinfo_side_effect__set_2795_29_cfa_info3687, _box_ref_cinfo_side_effect__set_2795_29_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(reshaped_local_id_env_184_cfa_info, _reshaped_local_id3000_56_cfa_info3688, _reshaped_local_id3000_56_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(reshaped_global_import_set__env_187_cfa_info, _reshaped_global_import_set_2988_212_cfa_info3689, _reshaped_global_import_set_2988_212_cfa_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(reshaped_global_library__env_20_cfa_info, _reshaped_global_library_2993_186_cfa_info3690, _reshaped_global_library_2993_186_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(reshaped_global_fast_alpha_env_204_cfa_info, _reshaped_global_fast_alpha2982_2_cfa_info3691, _reshaped_global_fast_alpha2982_2_cfa_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(widening_conditional_cinfo_env_141_cfa_info, _widening_conditional_cinfo2887_19_cfa_info3692, _widening_conditional_cinfo2887_19_cfa_info, 0L, 1);



/* module-initialization */
obj_t 
module_initialization_70_cfa_info(long checksum_6250, char *from_6251)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_cfa_info))
	{
	   require_initialization_114_cfa_info =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_cfa_info();
	   cnst_init_137_cfa_info();
	   imported_modules_init_94_cfa_info();
	   object_init_111_cfa_info();
	   method_init_76_cfa_info();
	   toplevel_init_63_cfa_info();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_cfa_info()
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 14 */
      module_initialization_70___object(((long) 0), "CFA_INFO");
      module_initialization_70___reader(((long) 0), "CFA_INFO");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_cfa_info()
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 14 */
      {		/* Cfa/cinfo.scm 14 */
	 obj_t cnst_port_138_6243;
	 cnst_port_138_6243 =
	    open_input_string(string3191_cfa_info);
	 {
	    long i_6244;
	    i_6244 = ((long) 29);
	  loop_6245:
	    {	/* Cfa/cinfo.scm 14 */
	       bool_t test3192_6246;
	       test3192_6246 =
		  (i_6244 == ((long) -1));
	       if (test3192_6246)
		 {	/* Cfa/cinfo.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Cfa/cinfo.scm 14 */
		    {	/* Cfa/cinfo.scm 14 */
		       obj_t arg3193_6247;
		       {	/* Cfa/cinfo.scm 14 */
			  obj_t list3194_6248;
			  list3194_6248 =
			     MAKE_PAIR(cnst_port_138_6243, BNIL);
			  arg3193_6247 =
			     read___reader(list3194_6248);
		       }
		       CNST_TABLE_SET(i_6244, arg3193_6247);
		    }
		    {	/* Cfa/cinfo.scm 14 */
		       int aux_6249;
		       {	/* Cfa/cinfo.scm 14 */
			  long aux_6269;
			  aux_6269 =
			     (i_6244 - ((long) 1));
			  aux_6249 =
			     (int) (aux_6269);
		       }
		       {
			  long i_6272;
			  i_6272 =
			     (long) (aux_6249);
			  i_6244 = i_6272;
			  goto loop_6245;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_cfa_info()
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 14 */
      return BUNSPEC;
   }
}



/* object-init */
obj_t 
object_init_111_cfa_info()
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 14 */
      {		/* Cfa/cinfo.scm 14 */
	 obj_t arg2098_1482;
	 obj_t arg2099_1483;
	 obj_t arg2103_1486;
	 arg2098_1482 =
	    CNST_TABLE_REF(((long) 0));
	 arg2099_1483 = object___object;
	 {	/* Cfa/cinfo.scm 14 */
	    obj_t v1946_1487;
	    v1946_1487 =
	       create_vector(((long) 0));
	    arg2103_1486 = v1946_1487;
	 }
	 approx_cfa_info =
	    register_class__225___object(arg2098_1482, arg2099_1483, allocate_approx_env_171_cfa_info, ((long) 41446), BUNSPEC, BFALSE, arg2103_1486);
      }
      {		/* Cfa/cinfo.scm 14 */
	 obj_t arg2104_1488;
	 obj_t arg2105_1489;
	 obj_t arg2108_1492;
	 arg2104_1488 =
	    CNST_TABLE_REF(((long) 1));
	 arg2105_1489 = cfun_ast_var;
	 {	/* Cfa/cinfo.scm 14 */
	    obj_t v1947_1493;
	    v1947_1493 =
	       create_vector(((long) 0));
	    arg2108_1492 = v1947_1493;
	 }
	 cfun_cinfo_200_cfa_info =
	    register_class__225___object(arg2104_1488, arg2105_1489, allocate_cfun_cinfo_env_112_cfa_info, ((long) 36674), BUNSPEC, BFALSE, arg2108_1492);
      }
      {		/* Cfa/cinfo.scm 14 */
	 obj_t arg2109_1494;
	 obj_t arg2110_1495;
	 obj_t arg2113_1498;
	 arg2109_1494 =
	    CNST_TABLE_REF(((long) 2));
	 arg2110_1495 = sfun_ast_var;
	 {	/* Cfa/cinfo.scm 14 */
	    obj_t v1948_1499;
	    v1948_1499 =
	       create_vector(((long) 0));
	    arg2113_1498 = v1948_1499;
	 }
	 extern_sfun_cinfo_6_cfa_info =
	    register_class__225___object(arg2109_1494, arg2110_1495, allocate_extern_sfun_cinfo_env_126_cfa_info, ((long) 31309), BUNSPEC, BFALSE, arg2113_1498);
      }
      {		/* Cfa/cinfo.scm 14 */
	 obj_t arg2114_1500;
	 obj_t arg2115_1501;
	 obj_t arg2118_1504;
	 arg2114_1500 =
	    CNST_TABLE_REF(((long) 3));
	 arg2115_1501 = sfun_ast_var;
	 {	/* Cfa/cinfo.scm 14 */
	    obj_t v1949_1505;
	    v1949_1505 =
	       create_vector(((long) 0));
	    arg2118_1504 = v1949_1505;
	 }
	 intern_sfun_cinfo_192_cfa_info =
	    register_class__225___object(arg2114_1500, arg2115_1501, allocate_intern_sfun_cinfo_env_101_cfa_info, ((long) 40550), BUNSPEC, BFALSE, arg2118_1504);
      }
      {		/* Cfa/cinfo.scm 14 */
	 obj_t arg2119_1506;
	 obj_t arg2120_1507;
	 obj_t arg2124_1510;
	 arg2119_1506 =
	    CNST_TABLE_REF(((long) 4));
	 arg2120_1507 = scnst_ast_var;
	 {	/* Cfa/cinfo.scm 14 */
	    obj_t v1950_1511;
	    v1950_1511 =
	       create_vector(((long) 0));
	    arg2124_1510 = v1950_1511;
	 }
	 scnst_cinfo_0_cfa_info =
	    register_class__225___object(arg2119_1506, arg2120_1507, allocate_scnst_cinfo_env_108_cfa_info, ((long) 27137), BUNSPEC, BFALSE, arg2124_1510);
      }
      {		/* Cfa/cinfo.scm 14 */
	 obj_t arg2125_1512;
	 obj_t arg2126_1513;
	 obj_t arg2129_1516;
	 arg2125_1512 =
	    CNST_TABLE_REF(((long) 5));
	 arg2126_1513 = svar_ast_var;
	 {	/* Cfa/cinfo.scm 14 */
	    obj_t v1951_1517;
	    v1951_1517 =
	       create_vector(((long) 0));
	    arg2129_1516 = v1951_1517;
	 }
	 pre_clo_env_191_cfa_info =
	    register_class__225___object(arg2125_1512, arg2126_1513, allocate_pre_clo_env_env_170_cfa_info, ((long) 43896), BUNSPEC, BFALSE, arg2129_1516);
      }
      {		/* Cfa/cinfo.scm 14 */
	 obj_t arg2131_1518;
	 obj_t arg2132_1519;
	 obj_t arg2135_1522;
	 arg2131_1518 =
	    CNST_TABLE_REF(((long) 6));
	 arg2132_1519 = svar_ast_var;
	 {	/* Cfa/cinfo.scm 14 */
	    obj_t v1952_1523;
	    v1952_1523 =
	       create_vector(((long) 0));
	    arg2135_1522 = v1952_1523;
	 }
	 svar_cinfo_166_cfa_info =
	    register_class__225___object(arg2131_1518, arg2132_1519, allocate_svar_cinfo_env_152_cfa_info, ((long) 42337), BUNSPEC, BFALSE, arg2135_1522);
      }
      {		/* Cfa/cinfo.scm 14 */
	 obj_t arg2136_1524;
	 obj_t arg2137_1525;
	 obj_t arg2140_1528;
	 arg2136_1524 =
	    CNST_TABLE_REF(((long) 7));
	 arg2137_1525 = cvar_ast_var;
	 {	/* Cfa/cinfo.scm 14 */
	    obj_t v1953_1529;
	    v1953_1529 =
	       create_vector(((long) 0));
	    arg2140_1528 = v1953_1529;
	 }
	 cvar_cinfo_53_cfa_info =
	    register_class__225___object(arg2136_1524, arg2137_1525, allocate_cvar_cinfo_env_84_cfa_info, ((long) 20194), BUNSPEC, BFALSE, arg2140_1528);
      }
      {		/* Cfa/cinfo.scm 14 */
	 obj_t arg2141_1530;
	 obj_t arg2144_1531;
	 obj_t arg2148_1534;
	 arg2141_1530 =
	    CNST_TABLE_REF(((long) 8));
	 arg2144_1531 = sexit_ast_var;
	 {	/* Cfa/cinfo.scm 14 */
	    obj_t v1954_1535;
	    v1954_1535 =
	       create_vector(((long) 0));
	    arg2148_1534 = v1954_1535;
	 }
	 sexit_cinfo_49_cfa_info =
	    register_class__225___object(arg2141_1530, arg2144_1531, allocate_sexit_cinfo_env_157_cfa_info, ((long) 41891), BUNSPEC, BFALSE, arg2148_1534);
      }
      {		/* Cfa/cinfo.scm 14 */
	 obj_t arg2149_1536;
	 obj_t arg2150_1537;
	 obj_t arg2154_1540;
	 arg2149_1536 =
	    CNST_TABLE_REF(((long) 9));
	 arg2150_1537 = local_ast_var;
	 {	/* Cfa/cinfo.scm 14 */
	    obj_t v1955_1541;
	    v1955_1541 =
	       create_vector(((long) 0));
	    arg2154_1540 = v1955_1541;
	 }
	 reshaped_local_224_cfa_info =
	    register_class__225___object(arg2149_1536, arg2150_1537, allocate_reshaped_local_env_189_cfa_info, ((long) 23233), BUNSPEC, BFALSE, arg2154_1540);
      }
      {		/* Cfa/cinfo.scm 14 */
	 obj_t arg2155_1542;
	 obj_t arg2156_1543;
	 obj_t arg2159_1546;
	 arg2155_1542 =
	    CNST_TABLE_REF(((long) 10));
	 arg2156_1543 = global_ast_var;
	 {	/* Cfa/cinfo.scm 14 */
	    obj_t v1956_1547;
	    v1956_1547 =
	       create_vector(((long) 0));
	    arg2159_1546 = v1956_1547;
	 }
	 reshaped_global_160_cfa_info =
	    register_class__225___object(arg2155_1542, arg2156_1543, allocate_reshaped_global_env_91_cfa_info, ((long) 40250), BUNSPEC, BFALSE, arg2159_1546);
      }
      {		/* Cfa/cinfo.scm 14 */
	 obj_t arg2160_1548;
	 obj_t arg2162_1549;
	 obj_t arg2165_1552;
	 arg2160_1548 =
	    CNST_TABLE_REF(((long) 11));
	 arg2162_1549 = atom_ast_node;
	 {	/* Cfa/cinfo.scm 14 */
	    obj_t v1957_1553;
	    v1957_1553 =
	       create_vector(((long) 0));
	    arg2165_1552 = v1957_1553;
	 }
	 atom_cinfo_155_cfa_info =
	    register_class__225___object(arg2160_1548, arg2162_1549, allocate_atom_cinfo_env_231_cfa_info, ((long) 53911), BUNSPEC, BFALSE, arg2165_1552);
      }
      {		/* Cfa/cinfo.scm 14 */
	 obj_t arg2166_1554;
	 obj_t arg2167_1555;
	 obj_t arg2170_1558;
	 arg2166_1554 =
	    CNST_TABLE_REF(((long) 12));
	 arg2167_1555 = kwote_ast_node;
	 {	/* Cfa/cinfo.scm 14 */
	    obj_t v1958_1559;
	    v1958_1559 =
	       create_vector(((long) 0));
	    arg2170_1558 = v1958_1559;
	 }
	 kwote_node_102_cfa_info =
	    register_class__225___object(arg2166_1554, arg2167_1555, allocate_kwote_node_env_116_cfa_info, ((long) 22839), BUNSPEC, BFALSE, arg2170_1558);
      }
      {		/* Cfa/cinfo.scm 14 */
	 obj_t arg2171_1560;
	 obj_t arg2172_1561;
	 obj_t arg2175_1564;
	 arg2171_1560 =
	    CNST_TABLE_REF(((long) 13));
	 arg2172_1561 = kwote_ast_node;
	 {	/* Cfa/cinfo.scm 14 */
	    obj_t v1959_1565;
	    v1959_1565 =
	       create_vector(((long) 0));
	    arg2175_1564 = v1959_1565;
	 }
	 kwote_cinfo_48_cfa_info =
	    register_class__225___object(arg2171_1560, arg2172_1561, allocate_kwote_cinfo_env_199_cfa_info, ((long) 46904), BUNSPEC, BFALSE, arg2175_1564);
      }
      {		/* Cfa/cinfo.scm 14 */
	 obj_t arg2176_1566;
	 obj_t arg2177_1567;
	 obj_t arg2180_1570;
	 arg2176_1566 =
	    CNST_TABLE_REF(((long) 14));
	 arg2177_1567 = app_ly_162_ast_node;
	 {	/* Cfa/cinfo.scm 14 */
	    obj_t v1960_1571;
	    v1960_1571 =
	       create_vector(((long) 0));
	    arg2180_1570 = v1960_1571;
	 }
	 app_ly_cinfo_234_cfa_info =
	    register_class__225___object(arg2176_1566, arg2177_1567, allocate_app_ly_cinfo_env_68_cfa_info, ((long) 25505), BUNSPEC, BFALSE, arg2180_1570);
      }
      {		/* Cfa/cinfo.scm 14 */
	 obj_t arg2181_1572;
	 obj_t arg2183_1573;
	 obj_t arg2187_1576;
	 arg2181_1572 =
	    CNST_TABLE_REF(((long) 15));
	 arg2183_1573 = funcall_ast_node;
	 {	/* Cfa/cinfo.scm 14 */
	    obj_t v1961_1577;
	    v1961_1577 =
	       create_vector(((long) 0));
	    arg2187_1576 = v1961_1577;
	 }
	 funcall_cinfo_75_cfa_info =
	    register_class__225___object(arg2181_1572, arg2183_1573, allocate_funcall_cinfo_env_186_cfa_info, ((long) 58558), BUNSPEC, BFALSE, arg2187_1576);
      }
      {		/* Cfa/cinfo.scm 14 */
	 obj_t arg2188_1578;
	 obj_t arg2189_1579;
	 obj_t arg2192_1582;
	 arg2188_1578 =
	    CNST_TABLE_REF(((long) 16));
	 arg2189_1579 = pragma_ast_node;
	 {	/* Cfa/cinfo.scm 14 */
	    obj_t v1962_1583;
	    v1962_1583 =
	       create_vector(((long) 0));
	    arg2192_1582 = v1962_1583;
	 }
	 pragma_cinfo_220_cfa_info =
	    register_class__225___object(arg2188_1578, arg2189_1579, allocate_pragma_cinfo_env_199_cfa_info, ((long) 62814), BUNSPEC, BFALSE, arg2192_1582);
      }
      {		/* Cfa/cinfo.scm 14 */
	 obj_t arg2193_1584;
	 obj_t arg2195_1585;
	 obj_t arg2199_1588;
	 arg2193_1584 =
	    CNST_TABLE_REF(((long) 17));
	 arg2195_1585 = setq_ast_node;
	 {	/* Cfa/cinfo.scm 14 */
	    obj_t v1963_1589;
	    v1963_1589 =
	       create_vector(((long) 0));
	    arg2199_1588 = v1963_1589;
	 }
	 setq_cinfo_191_cfa_info =
	    register_class__225___object(arg2193_1584, arg2195_1585, allocate_setq_cinfo_env_69_cfa_info, ((long) 8475), BUNSPEC, BFALSE, arg2199_1588);
      }
      {		/* Cfa/cinfo.scm 14 */
	 obj_t arg2200_1590;
	 obj_t arg2201_1591;
	 obj_t arg2204_1594;
	 arg2200_1590 =
	    CNST_TABLE_REF(((long) 18));
	 arg2201_1591 = conditional_ast_node;
	 {	/* Cfa/cinfo.scm 14 */
	    obj_t v1964_1595;
	    v1964_1595 =
	       create_vector(((long) 0));
	    arg2204_1594 = v1964_1595;
	 }
	 conditional_cinfo_212_cfa_info =
	    register_class__225___object(arg2200_1590, arg2201_1591, allocate_conditional_cinfo_env_136_cfa_info, ((long) 36034), BUNSPEC, BFALSE, arg2204_1594);
      }
      {		/* Cfa/cinfo.scm 14 */
	 obj_t arg2206_1596;
	 obj_t arg2207_1597;
	 obj_t arg2210_1600;
	 arg2206_1596 =
	    CNST_TABLE_REF(((long) 19));
	 arg2207_1597 = fail_ast_node;
	 {	/* Cfa/cinfo.scm 14 */
	    obj_t v1965_1601;
	    v1965_1601 =
	       create_vector(((long) 0));
	    arg2210_1600 = v1965_1601;
	 }
	 fail_cinfo_75_cfa_info =
	    register_class__225___object(arg2206_1596, arg2207_1597, allocate_fail_cinfo_env_67_cfa_info, ((long) 3770), BUNSPEC, BFALSE, arg2210_1600);
      }
      {		/* Cfa/cinfo.scm 14 */
	 obj_t arg2211_1602;
	 obj_t arg2212_1603;
	 obj_t arg2215_1606;
	 arg2211_1602 =
	    CNST_TABLE_REF(((long) 20));
	 arg2212_1603 = select_ast_node;
	 {	/* Cfa/cinfo.scm 14 */
	    obj_t v1966_1607;
	    v1966_1607 =
	       create_vector(((long) 0));
	    arg2215_1606 = v1966_1607;
	 }
	 select_cinfo_150_cfa_info =
	    register_class__225___object(arg2211_1602, arg2212_1603, allocate_select_cinfo_env_166_cfa_info, ((long) 43814), BUNSPEC, BFALSE, arg2215_1606);
      }
      {		/* Cfa/cinfo.scm 14 */
	 obj_t arg2216_1608;
	 obj_t arg2217_1609;
	 obj_t arg2221_1612;
	 arg2216_1608 =
	    CNST_TABLE_REF(((long) 21));
	 arg2217_1609 = set_ex_it_116_ast_node;
	 {	/* Cfa/cinfo.scm 14 */
	    obj_t v1967_1613;
	    v1967_1613 =
	       create_vector(((long) 0));
	    arg2221_1612 = v1967_1613;
	 }
	 set_ex_it_cinfo_168_cfa_info =
	    register_class__225___object(arg2216_1608, arg2217_1609, allocate_set_ex_it_cinfo_env_250_cfa_info, ((long) 24110), BUNSPEC, BFALSE, arg2221_1612);
      }
      {		/* Cfa/cinfo.scm 14 */
	 obj_t arg2223_1614;
	 obj_t arg2224_1615;
	 obj_t arg2227_1618;
	 arg2223_1614 =
	    CNST_TABLE_REF(((long) 22));
	 arg2224_1615 = jump_ex_it_184_ast_node;
	 {	/* Cfa/cinfo.scm 14 */
	    obj_t v1968_1619;
	    v1968_1619 =
	       create_vector(((long) 0));
	    arg2227_1618 = v1968_1619;
	 }
	 jump_ex_it_cinfo_139_cfa_info =
	    register_class__225___object(arg2223_1614, arg2224_1615, allocate_jump_ex_it_cinfo_env_187_cfa_info, ((long) 24206), BUNSPEC, BFALSE, arg2227_1618);
      }
      {		/* Cfa/cinfo.scm 14 */
	 obj_t arg2228_1620;
	 obj_t arg2229_1621;
	 obj_t arg2232_1624;
	 arg2228_1620 =
	    CNST_TABLE_REF(((long) 23));
	 arg2229_1621 = make_box_202_ast_node;
	 {	/* Cfa/cinfo.scm 14 */
	    obj_t v1969_1625;
	    v1969_1625 =
	       create_vector(((long) 0));
	    arg2232_1624 = v1969_1625;
	 }
	 pre_make_box_186_cfa_info =
	    register_class__225___object(arg2228_1620, arg2229_1621, allocate_pre_make_box_env_176_cfa_info, ((long) 11008), BUNSPEC, BFALSE, arg2232_1624);
      }
      {		/* Cfa/cinfo.scm 14 */
	 obj_t arg2233_1626;
	 obj_t arg2234_1627;
	 obj_t arg2239_1630;
	 arg2233_1626 =
	    CNST_TABLE_REF(((long) 24));
	 arg2234_1627 = make_box_202_ast_node;
	 {	/* Cfa/cinfo.scm 14 */
	    obj_t v1970_1631;
	    v1970_1631 =
	       create_vector(((long) 0));
	    arg2239_1630 = v1970_1631;
	 }
	 make_box_cinfo_127_cfa_info =
	    register_class__225___object(arg2233_1626, arg2234_1627, allocate_make_box_cinfo_env_36_cfa_info, ((long) 60506), BUNSPEC, BFALSE, arg2239_1630);
      }
      {		/* Cfa/cinfo.scm 14 */
	 obj_t arg2240_1632;
	 obj_t arg2241_1633;
	 obj_t arg2244_1636;
	 arg2240_1632 =
	    CNST_TABLE_REF(((long) 25));
	 arg2241_1633 = make_box_202_ast_node;
	 {	/* Cfa/cinfo.scm 14 */
	    obj_t v1971_1637;
	    v1971_1637 =
	       create_vector(((long) 0));
	    arg2244_1636 = v1971_1637;
	 }
	 make_box_o_cinfo_96_cfa_info =
	    register_class__225___object(arg2240_1632, arg2241_1633, allocate_make_box_o_cinfo_env_97_cfa_info, ((long) 43380), BUNSPEC, BFALSE, arg2244_1636);
      }
      {		/* Cfa/cinfo.scm 14 */
	 obj_t arg2245_1638;
	 obj_t arg2246_1639;
	 obj_t arg2249_1642;
	 arg2245_1638 =
	    CNST_TABLE_REF(((long) 26));
	 arg2246_1639 = box_set__221_ast_node;
	 {	/* Cfa/cinfo.scm 14 */
	    obj_t v1972_1643;
	    v1972_1643 =
	       create_vector(((long) 0));
	    arg2249_1642 = v1972_1643;
	 }
	 box_set__cinfo_94_cfa_info =
	    register_class__225___object(arg2245_1638, arg2246_1639, allocate_box_set__cinfo_env_96_cfa_info, ((long) 3505), BUNSPEC, BFALSE, arg2249_1642);
      }
      {		/* Cfa/cinfo.scm 14 */
	 obj_t arg2250_1644;
	 obj_t arg2251_1645;
	 obj_t arg2255_1648;
	 arg2250_1644 =
	    CNST_TABLE_REF(((long) 27));
	 arg2251_1645 = box_ref_242_ast_node;
	 {	/* Cfa/cinfo.scm 14 */
	    obj_t v1973_1649;
	    v1973_1649 =
	       create_vector(((long) 0));
	    arg2255_1648 = v1973_1649;
	 }
	 box_ref_cinfo_214_cfa_info =
	    register_class__225___object(arg2250_1644, arg2251_1645, allocate_box_ref_cinfo_env_99_cfa_info, ((long) 51073), BUNSPEC, BFALSE, arg2255_1648);
      }
      {		/* Cfa/cinfo.scm 14 */
	 obj_t arg2256_1650;
	 obj_t arg2257_1651;
	 obj_t arg2260_1654;
	 arg2256_1650 =
	    CNST_TABLE_REF(((long) 28));
	 arg2257_1651 = box_set__221_ast_node;
	 {	/* Cfa/cinfo.scm 14 */
	    obj_t v1974_1655;
	    v1974_1655 =
	       create_vector(((long) 0));
	    arg2260_1654 = v1974_1655;
	 }
	 box_set__o_cinfo_6_cfa_info =
	    register_class__225___object(arg2256_1650, arg2257_1651, allocate_box_set__o_cinfo_env_94_cfa_info, ((long) 17669), BUNSPEC, BFALSE, arg2260_1654);
      }
      {		/* Cfa/cinfo.scm 14 */
	 obj_t arg2261_1656;
	 obj_t arg2263_1657;
	 obj_t arg2266_1660;
	 arg2261_1656 =
	    CNST_TABLE_REF(((long) 29));
	 arg2263_1657 = box_ref_242_ast_node;
	 {	/* Cfa/cinfo.scm 14 */
	    obj_t v1975_1661;
	    v1975_1661 =
	       create_vector(((long) 0));
	    arg2266_1660 = v1975_1661;
	 }
	 box_ref_o_cinfo_98_cfa_info =
	    register_class__225___object(arg2261_1656, arg2263_1657, allocate_box_ref_o_cinfo_env_184_cfa_info, ((long) 28245), BUNSPEC, BFALSE, arg2266_1660);
      }
      return BUNSPEC;
   }
}



/* allocate-box-ref/o-cinfo */
box_ref_242_bglt 
allocate_box_ref_o_cinfo_99_cfa_info()
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 93 */
      {		/* Cfa/cinfo.scm 93 */
	 box_ref_242_bglt new1938_1662;
	 new1938_1662 =
	    ((box_ref_242_bglt) BREF(GC_MALLOC(sizeof(struct box_ref_242))));
	 {	/* Cfa/cinfo.scm 93 */
	    long arg2267_1663;
	    arg2267_1663 =
	       class_num_218___object(box_ref_o_cinfo_98_cfa_info);
	    {	/* Cfa/cinfo.scm 93 */
	       obj_t obj_2907;
	       obj_2907 =
		  (obj_t) (new1938_1662);
	       (((obj_t) CREF(obj_2907))->header = MAKE_HEADER(arg2267_1663, 0), BUNSPEC);
	    }
	 }
	 {	/* Cfa/cinfo.scm 93 */
	    object_bglt aux_6368;
	    aux_6368 =
	       (object_bglt) (new1938_1662);
	    OBJECT_WIDENING_SET(aux_6368, BFALSE);
	 }
	 return new1938_1662;
      }
   }
}



/* _allocate-box-ref/o-cinfo */
obj_t 
_allocate_box_ref_o_cinfo_197_cfa_info(obj_t env_4925)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 93 */
      {		/* Cfa/cinfo.scm 93 */
	 box_ref_242_bglt aux_6371;
	 aux_6371 =
	    allocate_box_ref_o_cinfo_99_cfa_info();
	 return
	    (obj_t) (aux_6371);
      }
   }
}



/* box-ref/o-cinfo? */
bool_t 
box_ref_o_cinfo__192_cfa_info(obj_t obj_4)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 93 */
      return
	 is_a__118___object(obj_4, box_ref_o_cinfo_98_cfa_info);
   }
}



/* _box-ref/o-cinfo? */
obj_t 
_box_ref_o_cinfo__170_cfa_info(obj_t env_4926, obj_t obj_4927)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 93 */
      {		/* Cfa/cinfo.scm 93 */
	 bool_t aux_6375;
	 aux_6375 =
	    box_ref_o_cinfo__192_cfa_info(obj_4927);
	 return
	    BBOOL(aux_6375);
      }
   }
}



/* widening-box-ref/o-cinfo */
box_ref_o_cinfo_98_bglt 
widening_box_ref_o_cinfo_200_cfa_info(approx_bglt approx_5)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 93 */
      {		/* Cfa/cinfo.scm 93 */
	 box_ref_o_cinfo_98_bglt new1933_2909;
	 new1933_2909 =
	    ((box_ref_o_cinfo_98_bglt) BREF(GC_MALLOC(sizeof(struct box_ref_o_cinfo_98))));
	 ((((box_ref_o_cinfo_98_bglt) CREF(new1933_2909))->approx) = ((approx_bglt) approx_5), BUNSPEC);
	 return new1933_2909;
      }
   }
}



/* _widening-box-ref/o-cinfo2770 */
obj_t 
_widening_box_ref_o_cinfo2770_157_cfa_info(obj_t env_4928, obj_t approx_4929)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 93 */
      {		/* Cfa/cinfo.scm 93 */
	 box_ref_o_cinfo_98_bglt aux_6380;
	 aux_6380 =
	    widening_box_ref_o_cinfo_200_cfa_info(
	    (approx_bglt) (approx_4929));
	 return
	    (obj_t) (aux_6380);
      }
   }
}



/* make-box-ref/o-cinfo */
box_ref_o_cinfo_98_bglt 
make_box_ref_o_cinfo_177_cfa_info(obj_t loc_6, type_bglt type_7, obj_t side_effect__165_8, obj_t key_9, var_bglt var_10, approx_bglt approx_11)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 93 */
      {		/* Cfa/cinfo.scm 93 */
	 box_ref_242_bglt aux1936_2911;
	 {	/* Cfa/cinfo.scm 93 */
	    box_ref_242_bglt res2683_2929;
	    {	/* ./Ast/node.scm 764 */
	       box_ref_242_bglt new1419_2920;
	       new1419_2920 =
		  ((box_ref_242_bglt) BREF(GC_MALLOC(sizeof(struct box_ref_242))));
	       {	/* ./Ast/node.scm 764 */
		  long arg2361_2921;
		  arg2361_2921 =
		     class_num_218___object(box_ref_242_ast_node);
		  {	/* ./Ast/node.scm 764 */
		     obj_t obj_2927;
		     obj_2927 =
			(obj_t) (new1419_2920);
		     (((obj_t) CREF(obj_2927))->header = MAKE_HEADER(arg2361_2921, 0), BUNSPEC);
		  }
	       }
	       {	/* ./Ast/node.scm 764 */
		  object_bglt aux_6388;
		  aux_6388 =
		     (object_bglt) (new1419_2920);
		  OBJECT_WIDENING_SET(aux_6388, BFALSE);
	       }
	       ((((box_ref_242_bglt) CREF(new1419_2920))->loc) = ((obj_t) loc_6), BUNSPEC);
	       ((((box_ref_242_bglt) CREF(new1419_2920))->type) = ((type_bglt) type_7), BUNSPEC);
	       ((((box_ref_242_bglt) CREF(new1419_2920))->side_effect__165) = ((obj_t) side_effect__165_8), BUNSPEC);
	       ((((box_ref_242_bglt) CREF(new1419_2920))->key) = ((obj_t) key_9), BUNSPEC);
	       ((((box_ref_242_bglt) CREF(new1419_2920))->var) = ((var_bglt) var_10), BUNSPEC);
	       res2683_2929 = new1419_2920;
	    }
	    aux1936_2911 = res2683_2929;
	 }
	 {	/* Cfa/cinfo.scm 93 */
	    box_ref_o_cinfo_98_bglt new1937_2912;
	    new1937_2912 =
	       ((box_ref_o_cinfo_98_bglt) (aux1936_2911));
	    {	/* Cfa/cinfo.scm 93 */
	       long arg2268_2913;
	       arg2268_2913 =
		  class_num_218___object(box_ref_o_cinfo_98_cfa_info);
	       {	/* Cfa/cinfo.scm 93 */
		  obj_t obj_2930;
		  obj_2930 =
		     (obj_t) (new1937_2912);
		  (((obj_t) CREF(obj_2930))->header = MAKE_HEADER(arg2268_2913, 0), BUNSPEC);
	       }
	    }
	    {	/* Cfa/cinfo.scm 93 */
	       box_ref_o_cinfo_98_bglt arg2269_2914;
	       {	/* Cfa/cinfo.scm 93 */
		  box_ref_o_cinfo_98_bglt res2684_2935;
		  {	/* Cfa/cinfo.scm 93 */
		     box_ref_o_cinfo_98_bglt new1933_2933;
		     new1933_2933 =
			((box_ref_o_cinfo_98_bglt) BREF(GC_MALLOC(sizeof(struct box_ref_o_cinfo_98))));
		     ((((box_ref_o_cinfo_98_bglt) CREF(new1933_2933))->approx) = ((approx_bglt) approx_11), BUNSPEC);
		     res2684_2935 = new1933_2933;
		  }
		  arg2269_2914 = res2684_2935;
	       }
	       {	/* Cfa/cinfo.scm 93 */
		  obj_t aux_6404;
		  object_bglt aux_6402;
		  aux_6404 =
		     (obj_t) (arg2269_2914);
		  aux_6402 =
		     (object_bglt) (new1937_2912);
		  OBJECT_WIDENING_SET(aux_6402, aux_6404);
	       }
	    }
	    return new1937_2912;
	 }
      }
   }
}



/* _make-box-ref/o-cinfo2771 */
obj_t 
_make_box_ref_o_cinfo2771_75_cfa_info(obj_t env_4930, obj_t loc_4931, obj_t type_4932, obj_t side_effect__165_4933, obj_t key_4934, obj_t var_4935, obj_t approx_4936)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 93 */
      {		/* Cfa/cinfo.scm 93 */
	 box_ref_o_cinfo_98_bglt aux_6407;
	 aux_6407 =
	    make_box_ref_o_cinfo_177_cfa_info(loc_4931,
	    (type_bglt) (type_4932), side_effect__165_4933, key_4934,
	    (var_bglt) (var_4935),
	    (approx_bglt) (approx_4936));
	 return
	    (obj_t) (aux_6407);
      }
   }
}



/* box-ref/o-cinfo-loc */
obj_t 
box_ref_o_cinfo_loc_36_cfa_info(box_ref_242_bglt obj_12)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 624 */
      return
	 (((box_ref_242_bglt) CREF(obj_12))->loc);
   }
}



/* _box-ref/o-cinfo-loc2772 */
obj_t 
_box_ref_o_cinfo_loc2772_15_cfa_info(obj_t env_4937, obj_t obj_4938)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 624 */
      return
	 box_ref_o_cinfo_loc_36_cfa_info(
	 (box_ref_242_bglt) (obj_4938));
   }
}



/* box-ref/o-cinfo-type-set! */
obj_t 
box_ref_o_cinfo_type_set__20_cfa_info(box_ref_242_bglt obj_13, type_bglt val1929_14)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 93 */
      return
	 ((((box_ref_242_bglt) CREF(obj_13))->type) = ((type_bglt) val1929_14), BUNSPEC);
   }
}



/* _box-ref/o-cinfo-type-set!2773 */
obj_t 
_box_ref_o_cinfo_type_set_2773_28_cfa_info(obj_t env_4939, obj_t obj_4940, obj_t val1929_4941)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 93 */
      return
	 box_ref_o_cinfo_type_set__20_cfa_info(
	 (box_ref_242_bglt) (obj_4940),
	 (type_bglt) (val1929_4941));
   }
}



/* box-ref/o-cinfo-type */
type_bglt 
box_ref_o_cinfo_type_224_cfa_info(box_ref_242_bglt obj_15)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 93 */
      return
	 (((box_ref_242_bglt) CREF(obj_15))->type);
   }
}



/* _box-ref/o-cinfo-type2774 */
obj_t 
_box_ref_o_cinfo_type2774_225_cfa_info(obj_t env_4942, obj_t obj_4943)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 93 */
      {		/* Cfa/cinfo.scm 93 */
	 type_bglt aux_6421;
	 aux_6421 =
	    box_ref_o_cinfo_type_224_cfa_info(
	    (box_ref_242_bglt) (obj_4943));
	 return
	    (obj_t) (aux_6421);
      }
   }
}



/* box-ref/o-cinfo-side-effect?-set! */
obj_t 
box_ref_o_cinfo_side_effect__set__170_cfa_info(box_ref_242_bglt obj_16, obj_t val1930_17)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 632 */
      return
	 ((((box_ref_242_bglt) CREF(obj_16))->side_effect__165) = ((obj_t) val1930_17), BUNSPEC);
   }
}



/* _box-ref/o-cinfo-side-effect?-set!2775 */
obj_t 
_box_ref_o_cinfo_side_effect__set_2775_59_cfa_info(obj_t env_4944, obj_t obj_4945, obj_t val1930_4946)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 632 */
      return
	 box_ref_o_cinfo_side_effect__set__170_cfa_info(
	 (box_ref_242_bglt) (obj_4945), val1930_4946);
   }
}



/* box-ref/o-cinfo-side-effect? */
obj_t 
box_ref_o_cinfo_side_effect__156_cfa_info(box_ref_242_bglt obj_18)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 632 */
      return
	 (((box_ref_242_bglt) CREF(obj_18))->side_effect__165);
   }
}



/* _box-ref/o-cinfo-side-effect?2776 */
obj_t 
_box_ref_o_cinfo_side_effect_2776_96_cfa_info(obj_t env_4947, obj_t obj_4948)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 632 */
      return
	 box_ref_o_cinfo_side_effect__156_cfa_info(
	 (box_ref_242_bglt) (obj_4948));
   }
}



/* box-ref/o-cinfo-key-set! */
obj_t 
box_ref_o_cinfo_key_set__15_cfa_info(box_ref_242_bglt obj_19, obj_t val1931_20)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 636 */
      return
	 ((((box_ref_242_bglt) CREF(obj_19))->key) = ((obj_t) val1931_20), BUNSPEC);
   }
}



/* _box-ref/o-cinfo-key-set! */
obj_t 
_box_ref_o_cinfo_key_set__163_cfa_info(obj_t env_4949, obj_t obj_4950, obj_t val1931_4951)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 636 */
      return
	 box_ref_o_cinfo_key_set__15_cfa_info(
	 (box_ref_242_bglt) (obj_4950), val1931_4951);
   }
}



/* box-ref/o-cinfo-key */
obj_t 
box_ref_o_cinfo_key_232_cfa_info(box_ref_242_bglt obj_21)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 636 */
      return
	 (((box_ref_242_bglt) CREF(obj_21))->key);
   }
}



/* _box-ref/o-cinfo-key */
obj_t 
_box_ref_o_cinfo_key_193_cfa_info(obj_t env_4952, obj_t obj_4953)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 636 */
      return
	 box_ref_o_cinfo_key_232_cfa_info(
	 (box_ref_242_bglt) (obj_4953));
   }
}



/* box-ref/o-cinfo-var-set! */
obj_t 
box_ref_o_cinfo_var_set__204_cfa_info(box_ref_242_bglt obj_22, var_bglt val1932_23)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 93 */
      return
	 ((((box_ref_242_bglt) CREF(obj_22))->var) = ((var_bglt) val1932_23), BUNSPEC);
   }
}



/* _box-ref/o-cinfo-var-set!2777 */
obj_t 
_box_ref_o_cinfo_var_set_2777_55_cfa_info(obj_t env_4954, obj_t obj_4955, obj_t val1932_4956)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 93 */
      return
	 box_ref_o_cinfo_var_set__204_cfa_info(
	 (box_ref_242_bglt) (obj_4955),
	 (var_bglt) (val1932_4956));
   }
}



/* box-ref/o-cinfo-var */
var_bglt 
box_ref_o_cinfo_var_44_cfa_info(box_ref_242_bglt obj_24)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 93 */
      return
	 (((box_ref_242_bglt) CREF(obj_24))->var);
   }
}



/* _box-ref/o-cinfo-var2778 */
obj_t 
_box_ref_o_cinfo_var2778_106_cfa_info(obj_t env_4957, obj_t obj_4958)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 93 */
      {		/* Cfa/cinfo.scm 93 */
	 var_bglt aux_6442;
	 aux_6442 =
	    box_ref_o_cinfo_var_44_cfa_info(
	    (box_ref_242_bglt) (obj_4958));
	 return
	    (obj_t) (aux_6442);
      }
   }
}



/* box-ref/o-cinfo-approx */
approx_bglt 
box_ref_o_cinfo_approx_223_cfa_info(box_ref_o_cinfo_98_bglt obj_25)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 93 */
      {
	 obj_t aux_6446;
	 {	/* Cfa/cinfo.scm 93 */
	    object_bglt aux_6447;
	    aux_6447 =
	       (object_bglt) (obj_25);
	    aux_6446 =
	       OBJECT_WIDENING(aux_6447);
	 }
	 return
	    (((box_ref_o_cinfo_98_bglt) CREF(aux_6446))->approx);
      }
   }
}



/* _box-ref/o-cinfo-approx2779 */
obj_t 
_box_ref_o_cinfo_approx2779_91_cfa_info(obj_t env_4959, obj_t obj_4960)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 93 */
      {		/* Cfa/cinfo.scm 93 */
	 approx_bglt aux_6451;
	 aux_6451 =
	    box_ref_o_cinfo_approx_223_cfa_info(
	    (box_ref_o_cinfo_98_bglt) (obj_4960));
	 return
	    (obj_t) (aux_6451);
      }
   }
}



/* allocate-box-set!/o-cinfo */
box_set__221_bglt 
allocate_box_set__o_cinfo_236_cfa_info()
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 92 */
      {		/* Cfa/cinfo.scm 92 */
	 box_set__221_bglt new1922_1670;
	 new1922_1670 =
	    ((box_set__221_bglt) BREF(GC_MALLOC(sizeof(struct box_set__221))));
	 {	/* Cfa/cinfo.scm 92 */
	    long arg2270_1671;
	    arg2270_1671 =
	       class_num_218___object(box_set__o_cinfo_6_cfa_info);
	    {	/* Cfa/cinfo.scm 92 */
	       obj_t obj_2936;
	       obj_2936 =
		  (obj_t) (new1922_1670);
	       (((obj_t) CREF(obj_2936))->header = MAKE_HEADER(arg2270_1671, 0), BUNSPEC);
	    }
	 }
	 {	/* Cfa/cinfo.scm 92 */
	    object_bglt aux_6459;
	    aux_6459 =
	       (object_bglt) (new1922_1670);
	    OBJECT_WIDENING_SET(aux_6459, BFALSE);
	 }
	 return new1922_1670;
      }
   }
}



/* _allocate-box-set!/o-cinfo */
obj_t 
_allocate_box_set__o_cinfo_20_cfa_info(obj_t env_4924)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 92 */
      {		/* Cfa/cinfo.scm 92 */
	 box_set__221_bglt aux_6462;
	 aux_6462 =
	    allocate_box_set__o_cinfo_236_cfa_info();
	 return
	    (obj_t) (aux_6462);
      }
   }
}



/* box-set!/o-cinfo? */
bool_t 
box_set__o_cinfo__167_cfa_info(obj_t obj_29)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 92 */
      return
	 is_a__118___object(obj_29, box_set__o_cinfo_6_cfa_info);
   }
}



/* _box-set!/o-cinfo? */
obj_t 
_box_set__o_cinfo__123_cfa_info(obj_t env_4961, obj_t obj_4962)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 92 */
      {		/* Cfa/cinfo.scm 92 */
	 bool_t aux_6466;
	 aux_6466 =
	    box_set__o_cinfo__167_cfa_info(obj_4962);
	 return
	    BBOOL(aux_6466);
      }
   }
}



/* widening-box-set!/o-cinfo */
box_set__o_cinfo_6_bglt 
widening_box_set__o_cinfo_49_cfa_info(approx_bglt approx_30)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 92 */
      {		/* Cfa/cinfo.scm 92 */
	 box_set__o_cinfo_6_bglt new1917_2938;
	 new1917_2938 =
	    ((box_set__o_cinfo_6_bglt) BREF(GC_MALLOC(sizeof(struct box_set__o_cinfo_6))));
	 ((((box_set__o_cinfo_6_bglt) CREF(new1917_2938))->approx) = ((approx_bglt) approx_30), BUNSPEC);
	 return new1917_2938;
      }
   }
}



/* _widening-box-set!/o-cinfo2780 */
obj_t 
_widening_box_set__o_cinfo2780_213_cfa_info(obj_t env_4963, obj_t approx_4964)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 92 */
      {		/* Cfa/cinfo.scm 92 */
	 box_set__o_cinfo_6_bglt aux_6471;
	 aux_6471 =
	    widening_box_set__o_cinfo_49_cfa_info(
	    (approx_bglt) (approx_4964));
	 return
	    (obj_t) (aux_6471);
      }
   }
}



/* make-box-set!/o-cinfo */
box_set__o_cinfo_6_bglt 
make_box_set__o_cinfo_60_cfa_info(obj_t loc_31, type_bglt type_32, var_bglt var_33, node_bglt value_34, approx_bglt approx_35)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 92 */
      {		/* Cfa/cinfo.scm 92 */
	 box_set__221_bglt aux1920_2940;
	 {	/* Cfa/cinfo.scm 92 */
	    box_set__221_bglt res2685_2956;
	    {	/* ./Ast/node.scm 768 */
	       box_set__221_bglt new1430_2948;
	       new1430_2948 =
		  ((box_set__221_bglt) BREF(GC_MALLOC(sizeof(struct box_set__221))));
	       {	/* ./Ast/node.scm 768 */
		  long arg2359_2949;
		  arg2359_2949 =
		     class_num_218___object(box_set__221_ast_node);
		  {	/* ./Ast/node.scm 768 */
		     obj_t obj_2954;
		     obj_2954 =
			(obj_t) (new1430_2948);
		     (((obj_t) CREF(obj_2954))->header = MAKE_HEADER(arg2359_2949, 0), BUNSPEC);
		  }
	       }
	       {	/* ./Ast/node.scm 768 */
		  object_bglt aux_6479;
		  aux_6479 =
		     (object_bglt) (new1430_2948);
		  OBJECT_WIDENING_SET(aux_6479, BFALSE);
	       }
	       ((((box_set__221_bglt) CREF(new1430_2948))->loc) = ((obj_t) loc_31), BUNSPEC);
	       ((((box_set__221_bglt) CREF(new1430_2948))->type) = ((type_bglt) type_32), BUNSPEC);
	       ((((box_set__221_bglt) CREF(new1430_2948))->var) = ((var_bglt) var_33), BUNSPEC);
	       ((((box_set__221_bglt) CREF(new1430_2948))->value) = ((node_bglt) value_34), BUNSPEC);
	       res2685_2956 = new1430_2948;
	    }
	    aux1920_2940 = res2685_2956;
	 }
	 {	/* Cfa/cinfo.scm 92 */
	    box_set__o_cinfo_6_bglt new1921_2941;
	    new1921_2941 =
	       ((box_set__o_cinfo_6_bglt) (aux1920_2940));
	    {	/* Cfa/cinfo.scm 92 */
	       long arg2271_2942;
	       arg2271_2942 =
		  class_num_218___object(box_set__o_cinfo_6_cfa_info);
	       {	/* Cfa/cinfo.scm 92 */
		  obj_t obj_2957;
		  obj_2957 =
		     (obj_t) (new1921_2941);
		  (((obj_t) CREF(obj_2957))->header = MAKE_HEADER(arg2271_2942, 0), BUNSPEC);
	       }
	    }
	    {	/* Cfa/cinfo.scm 92 */
	       box_set__o_cinfo_6_bglt arg2272_2943;
	       {	/* Cfa/cinfo.scm 92 */
		  box_set__o_cinfo_6_bglt res2686_2962;
		  {	/* Cfa/cinfo.scm 92 */
		     box_set__o_cinfo_6_bglt new1917_2960;
		     new1917_2960 =
			((box_set__o_cinfo_6_bglt) BREF(GC_MALLOC(sizeof(struct box_set__o_cinfo_6))));
		     ((((box_set__o_cinfo_6_bglt) CREF(new1917_2960))->approx) = ((approx_bglt) approx_35), BUNSPEC);
		     res2686_2962 = new1917_2960;
		  }
		  arg2272_2943 = res2686_2962;
	       }
	       {	/* Cfa/cinfo.scm 92 */
		  obj_t aux_6494;
		  object_bglt aux_6492;
		  aux_6494 =
		     (obj_t) (arg2272_2943);
		  aux_6492 =
		     (object_bglt) (new1921_2941);
		  OBJECT_WIDENING_SET(aux_6492, aux_6494);
	       }
	    }
	    return new1921_2941;
	 }
      }
   }
}



/* _make-box-set!/o-cinfo2781 */
obj_t 
_make_box_set__o_cinfo2781_191_cfa_info(obj_t env_4965, obj_t loc_4966, obj_t type_4967, obj_t var_4968, obj_t value_4969, obj_t approx_4970)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 92 */
      {		/* Cfa/cinfo.scm 92 */
	 box_set__o_cinfo_6_bglt aux_6497;
	 aux_6497 =
	    make_box_set__o_cinfo_60_cfa_info(loc_4966,
	    (type_bglt) (type_4967),
	    (var_bglt) (var_4968),
	    (node_bglt) (value_4969),
	    (approx_bglt) (approx_4970));
	 return
	    (obj_t) (aux_6497);
      }
   }
}



/* box-set!/o-cinfo-loc */
obj_t 
box_set__o_cinfo_loc_249_cfa_info(box_set__221_bglt obj_36)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 624 */
      return
	 (((box_set__221_bglt) CREF(obj_36))->loc);
   }
}



/* _box-set!/o-cinfo-loc2782 */
obj_t 
_box_set__o_cinfo_loc2782_255_cfa_info(obj_t env_4971, obj_t obj_4972)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 624 */
      return
	 box_set__o_cinfo_loc_249_cfa_info(
	 (box_set__221_bglt) (obj_4972));
   }
}



/* box-set!/o-cinfo-type-set! */
obj_t 
box_set__o_cinfo_type_set__107_cfa_info(box_set__221_bglt obj_37, type_bglt val1914_38)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 92 */
      return
	 ((((box_set__221_bglt) CREF(obj_37))->type) = ((type_bglt) val1914_38), BUNSPEC);
   }
}



/* _box-set!/o-cinfo-type-set!2783 */
obj_t 
_box_set__o_cinfo_type_set_2783_250_cfa_info(obj_t env_4973, obj_t obj_4974, obj_t val1914_4975)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 92 */
      return
	 box_set__o_cinfo_type_set__107_cfa_info(
	 (box_set__221_bglt) (obj_4974),
	 (type_bglt) (val1914_4975));
   }
}



/* box-set!/o-cinfo-type */
type_bglt 
box_set__o_cinfo_type_128_cfa_info(box_set__221_bglt obj_39)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 92 */
      return
	 (((box_set__221_bglt) CREF(obj_39))->type);
   }
}



/* _box-set!/o-cinfo-type2784 */
obj_t 
_box_set__o_cinfo_type2784_75_cfa_info(obj_t env_4976, obj_t obj_4977)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 92 */
      {		/* Cfa/cinfo.scm 92 */
	 type_bglt aux_6512;
	 aux_6512 =
	    box_set__o_cinfo_type_128_cfa_info(
	    (box_set__221_bglt) (obj_4977));
	 return
	    (obj_t) (aux_6512);
      }
   }
}



/* box-set!/o-cinfo-var-set! */
obj_t 
box_set__o_cinfo_var_set__7_cfa_info(box_set__221_bglt obj_40, var_bglt val1915_41)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 92 */
      return
	 ((((box_set__221_bglt) CREF(obj_40))->var) = ((var_bglt) val1915_41), BUNSPEC);
   }
}



/* _box-set!/o-cinfo-var-set!2785 */
obj_t 
_box_set__o_cinfo_var_set_2785_45_cfa_info(obj_t env_4978, obj_t obj_4979, obj_t val1915_4980)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 92 */
      return
	 box_set__o_cinfo_var_set__7_cfa_info(
	 (box_set__221_bglt) (obj_4979),
	 (var_bglt) (val1915_4980));
   }
}



/* box-set!/o-cinfo-var */
var_bglt 
box_set__o_cinfo_var_171_cfa_info(box_set__221_bglt obj_42)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 92 */
      return
	 (((box_set__221_bglt) CREF(obj_42))->var);
   }
}



/* _box-set!/o-cinfo-var2786 */
obj_t 
_box_set__o_cinfo_var2786_188_cfa_info(obj_t env_4981, obj_t obj_4982)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 92 */
      {		/* Cfa/cinfo.scm 92 */
	 var_bglt aux_6521;
	 aux_6521 =
	    box_set__o_cinfo_var_171_cfa_info(
	    (box_set__221_bglt) (obj_4982));
	 return
	    (obj_t) (aux_6521);
      }
   }
}



/* box-set!/o-cinfo-value-set! */
obj_t 
box_set__o_cinfo_value_set__181_cfa_info(box_set__221_bglt obj_43, node_bglt val1916_44)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 92 */
      return
	 ((((box_set__221_bglt) CREF(obj_43))->value) = ((node_bglt) val1916_44), BUNSPEC);
   }
}



/* _box-set!/o-cinfo-value-set!2787 */
obj_t 
_box_set__o_cinfo_value_set_2787_108_cfa_info(obj_t env_4983, obj_t obj_4984, obj_t val1916_4985)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 92 */
      return
	 box_set__o_cinfo_value_set__181_cfa_info(
	 (box_set__221_bglt) (obj_4984),
	 (node_bglt) (val1916_4985));
   }
}



/* box-set!/o-cinfo-value */
node_bglt 
box_set__o_cinfo_value_185_cfa_info(box_set__221_bglt obj_45)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 92 */
      return
	 (((box_set__221_bglt) CREF(obj_45))->value);
   }
}



/* _box-set!/o-cinfo-value2788 */
obj_t 
_box_set__o_cinfo_value2788_117_cfa_info(obj_t env_4986, obj_t obj_4987)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 92 */
      {		/* Cfa/cinfo.scm 92 */
	 node_bglt aux_6530;
	 aux_6530 =
	    box_set__o_cinfo_value_185_cfa_info(
	    (box_set__221_bglt) (obj_4987));
	 return
	    (obj_t) (aux_6530);
      }
   }
}



/* box-set!/o-cinfo-approx */
approx_bglt 
box_set__o_cinfo_approx_180_cfa_info(box_set__o_cinfo_6_bglt obj_46)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 92 */
      {
	 obj_t aux_6534;
	 {	/* Cfa/cinfo.scm 92 */
	    object_bglt aux_6535;
	    aux_6535 =
	       (object_bglt) (obj_46);
	    aux_6534 =
	       OBJECT_WIDENING(aux_6535);
	 }
	 return
	    (((box_set__o_cinfo_6_bglt) CREF(aux_6534))->approx);
      }
   }
}



/* _box-set!/o-cinfo-approx2789 */
obj_t 
_box_set__o_cinfo_approx2789_243_cfa_info(obj_t env_4988, obj_t obj_4989)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 92 */
      {		/* Cfa/cinfo.scm 92 */
	 approx_bglt aux_6539;
	 aux_6539 =
	    box_set__o_cinfo_approx_180_cfa_info(
	    (box_set__o_cinfo_6_bglt) (obj_4989));
	 return
	    (obj_t) (aux_6539);
      }
   }
}



/* allocate-box-ref/cinfo */
box_ref_242_bglt 
allocate_box_ref_cinfo_31_cfa_info()
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 91 */
      {		/* Cfa/cinfo.scm 91 */
	 box_ref_242_bglt new1907_1678;
	 new1907_1678 =
	    ((box_ref_242_bglt) BREF(GC_MALLOC(sizeof(struct box_ref_242))));
	 {	/* Cfa/cinfo.scm 91 */
	    long arg2273_1679;
	    arg2273_1679 =
	       class_num_218___object(box_ref_cinfo_214_cfa_info);
	    {	/* Cfa/cinfo.scm 91 */
	       obj_t obj_2963;
	       obj_2963 =
		  (obj_t) (new1907_1678);
	       (((obj_t) CREF(obj_2963))->header = MAKE_HEADER(arg2273_1679, 0), BUNSPEC);
	    }
	 }
	 {	/* Cfa/cinfo.scm 91 */
	    object_bglt aux_6547;
	    aux_6547 =
	       (object_bglt) (new1907_1678);
	    OBJECT_WIDENING_SET(aux_6547, BFALSE);
	 }
	 return new1907_1678;
      }
   }
}



/* _allocate-box-ref/cinfo */
obj_t 
_allocate_box_ref_cinfo_238_cfa_info(obj_t env_4923)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 91 */
      {		/* Cfa/cinfo.scm 91 */
	 box_ref_242_bglt aux_6550;
	 aux_6550 =
	    allocate_box_ref_cinfo_31_cfa_info();
	 return
	    (obj_t) (aux_6550);
      }
   }
}



/* box-ref/cinfo? */
bool_t 
box_ref_cinfo__23_cfa_info(obj_t obj_50)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 91 */
      return
	 is_a__118___object(obj_50, box_ref_cinfo_214_cfa_info);
   }
}



/* _box-ref/cinfo? */
obj_t 
_box_ref_cinfo__65_cfa_info(obj_t env_4990, obj_t obj_4991)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 91 */
      {		/* Cfa/cinfo.scm 91 */
	 bool_t aux_6554;
	 aux_6554 =
	    box_ref_cinfo__23_cfa_info(obj_4991);
	 return
	    BBOOL(aux_6554);
      }
   }
}



/* widening-box-ref/cinfo */
box_ref_cinfo_214_bglt 
widening_box_ref_cinfo_71_cfa_info(approx_bglt approx_51)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 91 */
      {		/* Cfa/cinfo.scm 91 */
	 box_ref_cinfo_214_bglt new1902_2965;
	 new1902_2965 =
	    ((box_ref_cinfo_214_bglt) BREF(GC_MALLOC(sizeof(struct box_ref_cinfo_214))));
	 ((((box_ref_cinfo_214_bglt) CREF(new1902_2965))->approx) = ((approx_bglt) approx_51), BUNSPEC);
	 return new1902_2965;
      }
   }
}



/* _widening-box-ref/cinfo2790 */
obj_t 
_widening_box_ref_cinfo2790_171_cfa_info(obj_t env_4992, obj_t approx_4993)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 91 */
      {		/* Cfa/cinfo.scm 91 */
	 box_ref_cinfo_214_bglt aux_6559;
	 aux_6559 =
	    widening_box_ref_cinfo_71_cfa_info(
	    (approx_bglt) (approx_4993));
	 return
	    (obj_t) (aux_6559);
      }
   }
}



/* make-box-ref/cinfo */
box_ref_cinfo_214_bglt 
make_box_ref_cinfo_128_cfa_info(obj_t loc_52, type_bglt type_53, obj_t side_effect__165_54, obj_t key_55, var_bglt var_56, approx_bglt approx_57)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 91 */
      {		/* Cfa/cinfo.scm 91 */
	 box_ref_242_bglt aux1905_2967;
	 {	/* Cfa/cinfo.scm 91 */
	    box_ref_242_bglt res2687_2985;
	    {	/* ./Ast/node.scm 764 */
	       box_ref_242_bglt new1419_2976;
	       new1419_2976 =
		  ((box_ref_242_bglt) BREF(GC_MALLOC(sizeof(struct box_ref_242))));
	       {	/* ./Ast/node.scm 764 */
		  long arg2361_2977;
		  arg2361_2977 =
		     class_num_218___object(box_ref_242_ast_node);
		  {	/* ./Ast/node.scm 764 */
		     obj_t obj_2983;
		     obj_2983 =
			(obj_t) (new1419_2976);
		     (((obj_t) CREF(obj_2983))->header = MAKE_HEADER(arg2361_2977, 0), BUNSPEC);
		  }
	       }
	       {	/* ./Ast/node.scm 764 */
		  object_bglt aux_6567;
		  aux_6567 =
		     (object_bglt) (new1419_2976);
		  OBJECT_WIDENING_SET(aux_6567, BFALSE);
	       }
	       ((((box_ref_242_bglt) CREF(new1419_2976))->loc) = ((obj_t) loc_52), BUNSPEC);
	       ((((box_ref_242_bglt) CREF(new1419_2976))->type) = ((type_bglt) type_53), BUNSPEC);
	       ((((box_ref_242_bglt) CREF(new1419_2976))->side_effect__165) = ((obj_t) side_effect__165_54), BUNSPEC);
	       ((((box_ref_242_bglt) CREF(new1419_2976))->key) = ((obj_t) key_55), BUNSPEC);
	       ((((box_ref_242_bglt) CREF(new1419_2976))->var) = ((var_bglt) var_56), BUNSPEC);
	       res2687_2985 = new1419_2976;
	    }
	    aux1905_2967 = res2687_2985;
	 }
	 {	/* Cfa/cinfo.scm 91 */
	    box_ref_cinfo_214_bglt new1906_2968;
	    new1906_2968 =
	       ((box_ref_cinfo_214_bglt) (aux1905_2967));
	    {	/* Cfa/cinfo.scm 91 */
	       long arg2274_2969;
	       arg2274_2969 =
		  class_num_218___object(box_ref_cinfo_214_cfa_info);
	       {	/* Cfa/cinfo.scm 91 */
		  obj_t obj_2986;
		  obj_2986 =
		     (obj_t) (new1906_2968);
		  (((obj_t) CREF(obj_2986))->header = MAKE_HEADER(arg2274_2969, 0), BUNSPEC);
	       }
	    }
	    {	/* Cfa/cinfo.scm 91 */
	       box_ref_cinfo_214_bglt arg2276_2970;
	       {	/* Cfa/cinfo.scm 91 */
		  box_ref_cinfo_214_bglt res2688_2991;
		  {	/* Cfa/cinfo.scm 91 */
		     box_ref_cinfo_214_bglt new1902_2989;
		     new1902_2989 =
			((box_ref_cinfo_214_bglt) BREF(GC_MALLOC(sizeof(struct box_ref_cinfo_214))));
		     ((((box_ref_cinfo_214_bglt) CREF(new1902_2989))->approx) = ((approx_bglt) approx_57), BUNSPEC);
		     res2688_2991 = new1902_2989;
		  }
		  arg2276_2970 = res2688_2991;
	       }
	       {	/* Cfa/cinfo.scm 91 */
		  obj_t aux_6583;
		  object_bglt aux_6581;
		  aux_6583 =
		     (obj_t) (arg2276_2970);
		  aux_6581 =
		     (object_bglt) (new1906_2968);
		  OBJECT_WIDENING_SET(aux_6581, aux_6583);
	       }
	    }
	    return new1906_2968;
	 }
      }
   }
}



/* _make-box-ref/cinfo2791 */
obj_t 
_make_box_ref_cinfo2791_237_cfa_info(obj_t env_4994, obj_t loc_4995, obj_t type_4996, obj_t side_effect__165_4997, obj_t key_4998, obj_t var_4999, obj_t approx_5000)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 91 */
      {		/* Cfa/cinfo.scm 91 */
	 box_ref_cinfo_214_bglt aux_6586;
	 aux_6586 =
	    make_box_ref_cinfo_128_cfa_info(loc_4995,
	    (type_bglt) (type_4996), side_effect__165_4997, key_4998,
	    (var_bglt) (var_4999),
	    (approx_bglt) (approx_5000));
	 return
	    (obj_t) (aux_6586);
      }
   }
}



/* box-ref/cinfo-loc */
obj_t 
box_ref_cinfo_loc_176_cfa_info(box_ref_242_bglt obj_58)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 624 */
      return
	 (((box_ref_242_bglt) CREF(obj_58))->loc);
   }
}



/* _box-ref/cinfo-loc2792 */
obj_t 
_box_ref_cinfo_loc2792_145_cfa_info(obj_t env_5001, obj_t obj_5002)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 624 */
      return
	 box_ref_cinfo_loc_176_cfa_info(
	 (box_ref_242_bglt) (obj_5002));
   }
}



/* box-ref/cinfo-type-set! */
obj_t 
box_ref_cinfo_type_set__65_cfa_info(box_ref_242_bglt obj_59, type_bglt val1898_60)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 91 */
      return
	 ((((box_ref_242_bglt) CREF(obj_59))->type) = ((type_bglt) val1898_60), BUNSPEC);
   }
}



/* _box-ref/cinfo-type-set!2793 */
obj_t 
_box_ref_cinfo_type_set_2793_113_cfa_info(obj_t env_5003, obj_t obj_5004, obj_t val1898_5005)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 91 */
      return
	 box_ref_cinfo_type_set__65_cfa_info(
	 (box_ref_242_bglt) (obj_5004),
	 (type_bglt) (val1898_5005));
   }
}



/* box-ref/cinfo-type */
type_bglt 
box_ref_cinfo_type_23_cfa_info(box_ref_242_bglt obj_61)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 91 */
      return
	 (((box_ref_242_bglt) CREF(obj_61))->type);
   }
}



/* _box-ref/cinfo-type2794 */
obj_t 
_box_ref_cinfo_type2794_132_cfa_info(obj_t env_5006, obj_t obj_5007)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 91 */
      {		/* Cfa/cinfo.scm 91 */
	 type_bglt aux_6600;
	 aux_6600 =
	    box_ref_cinfo_type_23_cfa_info(
	    (box_ref_242_bglt) (obj_5007));
	 return
	    (obj_t) (aux_6600);
      }
   }
}



/* box-ref/cinfo-side-effect?-set! */
obj_t 
box_ref_cinfo_side_effect__set__36_cfa_info(box_ref_242_bglt obj_62, obj_t val1899_63)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 632 */
      return
	 ((((box_ref_242_bglt) CREF(obj_62))->side_effect__165) = ((obj_t) val1899_63), BUNSPEC);
   }
}



/* _box-ref/cinfo-side-effect?-set!2795 */
obj_t 
_box_ref_cinfo_side_effect__set_2795_29_cfa_info(obj_t env_5008, obj_t obj_5009, obj_t val1899_5010)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 632 */
      return
	 box_ref_cinfo_side_effect__set__36_cfa_info(
	 (box_ref_242_bglt) (obj_5009), val1899_5010);
   }
}



/* box-ref/cinfo-side-effect? */
obj_t 
box_ref_cinfo_side_effect__63_cfa_info(box_ref_242_bglt obj_64)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 632 */
      return
	 (((box_ref_242_bglt) CREF(obj_64))->side_effect__165);
   }
}



/* _box-ref/cinfo-side-effect?2796 */
obj_t 
_box_ref_cinfo_side_effect_2796_143_cfa_info(obj_t env_5011, obj_t obj_5012)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 632 */
      return
	 box_ref_cinfo_side_effect__63_cfa_info(
	 (box_ref_242_bglt) (obj_5012));
   }
}



/* box-ref/cinfo-key-set! */
obj_t 
box_ref_cinfo_key_set__110_cfa_info(box_ref_242_bglt obj_65, obj_t val1900_66)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 636 */
      return
	 ((((box_ref_242_bglt) CREF(obj_65))->key) = ((obj_t) val1900_66), BUNSPEC);
   }
}



/* _box-ref/cinfo-key-set! */
obj_t 
_box_ref_cinfo_key_set__118_cfa_info(obj_t env_5013, obj_t obj_5014, obj_t val1900_5015)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 636 */
      return
	 box_ref_cinfo_key_set__110_cfa_info(
	 (box_ref_242_bglt) (obj_5014), val1900_5015);
   }
}



/* box-ref/cinfo-key */
obj_t 
box_ref_cinfo_key_199_cfa_info(box_ref_242_bglt obj_67)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 636 */
      return
	 (((box_ref_242_bglt) CREF(obj_67))->key);
   }
}



/* _box-ref/cinfo-key */
obj_t 
_box_ref_cinfo_key_241_cfa_info(obj_t env_5016, obj_t obj_5017)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 636 */
      return
	 box_ref_cinfo_key_199_cfa_info(
	 (box_ref_242_bglt) (obj_5017));
   }
}



/* box-ref/cinfo-var-set! */
obj_t 
box_ref_cinfo_var_set__56_cfa_info(box_ref_242_bglt obj_68, var_bglt val1901_69)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 91 */
      return
	 ((((box_ref_242_bglt) CREF(obj_68))->var) = ((var_bglt) val1901_69), BUNSPEC);
   }
}



/* _box-ref/cinfo-var-set!2797 */
obj_t 
_box_ref_cinfo_var_set_2797_195_cfa_info(obj_t env_5018, obj_t obj_5019, obj_t val1901_5020)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 91 */
      return
	 box_ref_cinfo_var_set__56_cfa_info(
	 (box_ref_242_bglt) (obj_5019),
	 (var_bglt) (val1901_5020));
   }
}



/* box-ref/cinfo-var */
var_bglt 
box_ref_cinfo_var_121_cfa_info(box_ref_242_bglt obj_70)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 91 */
      return
	 (((box_ref_242_bglt) CREF(obj_70))->var);
   }
}



/* _box-ref/cinfo-var2798 */
obj_t 
_box_ref_cinfo_var2798_240_cfa_info(obj_t env_5021, obj_t obj_5022)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 91 */
      {		/* Cfa/cinfo.scm 91 */
	 var_bglt aux_6621;
	 aux_6621 =
	    box_ref_cinfo_var_121_cfa_info(
	    (box_ref_242_bglt) (obj_5022));
	 return
	    (obj_t) (aux_6621);
      }
   }
}



/* box-ref/cinfo-approx */
approx_bglt 
box_ref_cinfo_approx_49_cfa_info(box_ref_cinfo_214_bglt obj_71)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 91 */
      {
	 obj_t aux_6625;
	 {	/* Cfa/cinfo.scm 91 */
	    object_bglt aux_6626;
	    aux_6626 =
	       (object_bglt) (obj_71);
	    aux_6625 =
	       OBJECT_WIDENING(aux_6626);
	 }
	 return
	    (((box_ref_cinfo_214_bglt) CREF(aux_6625))->approx);
      }
   }
}



/* _box-ref/cinfo-approx2799 */
obj_t 
_box_ref_cinfo_approx2799_73_cfa_info(obj_t env_5023, obj_t obj_5024)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 91 */
      {		/* Cfa/cinfo.scm 91 */
	 approx_bglt aux_6630;
	 aux_6630 =
	    box_ref_cinfo_approx_49_cfa_info(
	    (box_ref_cinfo_214_bglt) (obj_5024));
	 return
	    (obj_t) (aux_6630);
      }
   }
}



/* allocate-box-set!/cinfo */
box_set__221_bglt 
allocate_box_set__cinfo_232_cfa_info()
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 90 */
      {		/* Cfa/cinfo.scm 90 */
	 box_set__221_bglt new1891_1686;
	 new1891_1686 =
	    ((box_set__221_bglt) BREF(GC_MALLOC(sizeof(struct box_set__221))));
	 {	/* Cfa/cinfo.scm 90 */
	    long arg2277_1687;
	    arg2277_1687 =
	       class_num_218___object(box_set__cinfo_94_cfa_info);
	    {	/* Cfa/cinfo.scm 90 */
	       obj_t obj_2992;
	       obj_2992 =
		  (obj_t) (new1891_1686);
	       (((obj_t) CREF(obj_2992))->header = MAKE_HEADER(arg2277_1687, 0), BUNSPEC);
	    }
	 }
	 {	/* Cfa/cinfo.scm 90 */
	    object_bglt aux_6638;
	    aux_6638 =
	       (object_bglt) (new1891_1686);
	    OBJECT_WIDENING_SET(aux_6638, BFALSE);
	 }
	 return new1891_1686;
      }
   }
}



/* _allocate-box-set!/cinfo */
obj_t 
_allocate_box_set__cinfo_187_cfa_info(obj_t env_4922)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 90 */
      {		/* Cfa/cinfo.scm 90 */
	 box_set__221_bglt aux_6641;
	 aux_6641 =
	    allocate_box_set__cinfo_232_cfa_info();
	 return
	    (obj_t) (aux_6641);
      }
   }
}



/* box-set!/cinfo? */
bool_t 
box_set__cinfo__218_cfa_info(obj_t obj_75)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 90 */
      return
	 is_a__118___object(obj_75, box_set__cinfo_94_cfa_info);
   }
}



/* _box-set!/cinfo? */
obj_t 
_box_set__cinfo__142_cfa_info(obj_t env_5025, obj_t obj_5026)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 90 */
      {		/* Cfa/cinfo.scm 90 */
	 bool_t aux_6645;
	 aux_6645 =
	    box_set__cinfo__218_cfa_info(obj_5026);
	 return
	    BBOOL(aux_6645);
      }
   }
}



/* widening-box-set!/cinfo */
box_set__cinfo_94_bglt 
widening_box_set__cinfo_177_cfa_info(approx_bglt approx_76)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 90 */
      {		/* Cfa/cinfo.scm 90 */
	 box_set__cinfo_94_bglt new1886_2994;
	 new1886_2994 =
	    ((box_set__cinfo_94_bglt) BREF(GC_MALLOC(sizeof(struct box_set__cinfo_94))));
	 ((((box_set__cinfo_94_bglt) CREF(new1886_2994))->approx) = ((approx_bglt) approx_76), BUNSPEC);
	 return new1886_2994;
      }
   }
}



/* _widening-box-set!/cinfo2800 */
obj_t 
_widening_box_set__cinfo2800_31_cfa_info(obj_t env_5027, obj_t approx_5028)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 90 */
      {		/* Cfa/cinfo.scm 90 */
	 box_set__cinfo_94_bglt aux_6650;
	 aux_6650 =
	    widening_box_set__cinfo_177_cfa_info(
	    (approx_bglt) (approx_5028));
	 return
	    (obj_t) (aux_6650);
      }
   }
}



/* make-box-set!/cinfo */
box_set__cinfo_94_bglt 
make_box_set__cinfo_228_cfa_info(obj_t loc_77, type_bglt type_78, var_bglt var_79, node_bglt value_80, approx_bglt approx_81)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 90 */
      {		/* Cfa/cinfo.scm 90 */
	 box_set__221_bglt aux1889_2996;
	 {	/* Cfa/cinfo.scm 90 */
	    box_set__221_bglt res2689_3012;
	    {	/* ./Ast/node.scm 768 */
	       box_set__221_bglt new1430_3004;
	       new1430_3004 =
		  ((box_set__221_bglt) BREF(GC_MALLOC(sizeof(struct box_set__221))));
	       {	/* ./Ast/node.scm 768 */
		  long arg2359_3005;
		  arg2359_3005 =
		     class_num_218___object(box_set__221_ast_node);
		  {	/* ./Ast/node.scm 768 */
		     obj_t obj_3010;
		     obj_3010 =
			(obj_t) (new1430_3004);
		     (((obj_t) CREF(obj_3010))->header = MAKE_HEADER(arg2359_3005, 0), BUNSPEC);
		  }
	       }
	       {	/* ./Ast/node.scm 768 */
		  object_bglt aux_6658;
		  aux_6658 =
		     (object_bglt) (new1430_3004);
		  OBJECT_WIDENING_SET(aux_6658, BFALSE);
	       }
	       ((((box_set__221_bglt) CREF(new1430_3004))->loc) = ((obj_t) loc_77), BUNSPEC);
	       ((((box_set__221_bglt) CREF(new1430_3004))->type) = ((type_bglt) type_78), BUNSPEC);
	       ((((box_set__221_bglt) CREF(new1430_3004))->var) = ((var_bglt) var_79), BUNSPEC);
	       ((((box_set__221_bglt) CREF(new1430_3004))->value) = ((node_bglt) value_80), BUNSPEC);
	       res2689_3012 = new1430_3004;
	    }
	    aux1889_2996 = res2689_3012;
	 }
	 {	/* Cfa/cinfo.scm 90 */
	    box_set__cinfo_94_bglt new1890_2997;
	    new1890_2997 =
	       ((box_set__cinfo_94_bglt) (aux1889_2996));
	    {	/* Cfa/cinfo.scm 90 */
	       long arg2279_2998;
	       arg2279_2998 =
		  class_num_218___object(box_set__cinfo_94_cfa_info);
	       {	/* Cfa/cinfo.scm 90 */
		  obj_t obj_3013;
		  obj_3013 =
		     (obj_t) (new1890_2997);
		  (((obj_t) CREF(obj_3013))->header = MAKE_HEADER(arg2279_2998, 0), BUNSPEC);
	       }
	    }
	    {	/* Cfa/cinfo.scm 90 */
	       box_set__cinfo_94_bglt arg2280_2999;
	       {	/* Cfa/cinfo.scm 90 */
		  box_set__cinfo_94_bglt res2690_3018;
		  {	/* Cfa/cinfo.scm 90 */
		     box_set__cinfo_94_bglt new1886_3016;
		     new1886_3016 =
			((box_set__cinfo_94_bglt) BREF(GC_MALLOC(sizeof(struct box_set__cinfo_94))));
		     ((((box_set__cinfo_94_bglt) CREF(new1886_3016))->approx) = ((approx_bglt) approx_81), BUNSPEC);
		     res2690_3018 = new1886_3016;
		  }
		  arg2280_2999 = res2690_3018;
	       }
	       {	/* Cfa/cinfo.scm 90 */
		  obj_t aux_6673;
		  object_bglt aux_6671;
		  aux_6673 =
		     (obj_t) (arg2280_2999);
		  aux_6671 =
		     (object_bglt) (new1890_2997);
		  OBJECT_WIDENING_SET(aux_6671, aux_6673);
	       }
	    }
	    return new1890_2997;
	 }
      }
   }
}



/* _make-box-set!/cinfo2801 */
obj_t 
_make_box_set__cinfo2801_97_cfa_info(obj_t env_5029, obj_t loc_5030, obj_t type_5031, obj_t var_5032, obj_t value_5033, obj_t approx_5034)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 90 */
      {		/* Cfa/cinfo.scm 90 */
	 box_set__cinfo_94_bglt aux_6676;
	 aux_6676 =
	    make_box_set__cinfo_228_cfa_info(loc_5030,
	    (type_bglt) (type_5031),
	    (var_bglt) (var_5032),
	    (node_bglt) (value_5033),
	    (approx_bglt) (approx_5034));
	 return
	    (obj_t) (aux_6676);
      }
   }
}



/* box-set!/cinfo-loc */
obj_t 
box_set__cinfo_loc_149_cfa_info(box_set__221_bglt obj_82)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 624 */
      return
	 (((box_set__221_bglt) CREF(obj_82))->loc);
   }
}



/* _box-set!/cinfo-loc2802 */
obj_t 
_box_set__cinfo_loc2802_157_cfa_info(obj_t env_5035, obj_t obj_5036)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 624 */
      return
	 box_set__cinfo_loc_149_cfa_info(
	 (box_set__221_bglt) (obj_5036));
   }
}



/* box-set!/cinfo-type-set! */
obj_t 
box_set__cinfo_type_set__127_cfa_info(box_set__221_bglt obj_83, type_bglt val1883_84)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 90 */
      return
	 ((((box_set__221_bglt) CREF(obj_83))->type) = ((type_bglt) val1883_84), BUNSPEC);
   }
}



/* _box-set!/cinfo-type-set!2803 */
obj_t 
_box_set__cinfo_type_set_2803_239_cfa_info(obj_t env_5037, obj_t obj_5038, obj_t val1883_5039)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 90 */
      return
	 box_set__cinfo_type_set__127_cfa_info(
	 (box_set__221_bglt) (obj_5038),
	 (type_bglt) (val1883_5039));
   }
}



/* box-set!/cinfo-type */
type_bglt 
box_set__cinfo_type_226_cfa_info(box_set__221_bglt obj_85)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 90 */
      return
	 (((box_set__221_bglt) CREF(obj_85))->type);
   }
}



/* _box-set!/cinfo-type2804 */
obj_t 
_box_set__cinfo_type2804_252_cfa_info(obj_t env_5040, obj_t obj_5041)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 90 */
      {		/* Cfa/cinfo.scm 90 */
	 type_bglt aux_6691;
	 aux_6691 =
	    box_set__cinfo_type_226_cfa_info(
	    (box_set__221_bglt) (obj_5041));
	 return
	    (obj_t) (aux_6691);
      }
   }
}



/* box-set!/cinfo-var-set! */
obj_t 
box_set__cinfo_var_set__136_cfa_info(box_set__221_bglt obj_86, var_bglt val1884_87)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 90 */
      return
	 ((((box_set__221_bglt) CREF(obj_86))->var) = ((var_bglt) val1884_87), BUNSPEC);
   }
}



/* _box-set!/cinfo-var-set!2805 */
obj_t 
_box_set__cinfo_var_set_2805_221_cfa_info(obj_t env_5042, obj_t obj_5043, obj_t val1884_5044)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 90 */
      return
	 box_set__cinfo_var_set__136_cfa_info(
	 (box_set__221_bglt) (obj_5043),
	 (var_bglt) (val1884_5044));
   }
}



/* box-set!/cinfo-var */
var_bglt 
box_set__cinfo_var_126_cfa_info(box_set__221_bglt obj_88)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 90 */
      return
	 (((box_set__221_bglt) CREF(obj_88))->var);
   }
}



/* _box-set!/cinfo-var2806 */
obj_t 
_box_set__cinfo_var2806_123_cfa_info(obj_t env_5045, obj_t obj_5046)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 90 */
      {		/* Cfa/cinfo.scm 90 */
	 var_bglt aux_6700;
	 aux_6700 =
	    box_set__cinfo_var_126_cfa_info(
	    (box_set__221_bglt) (obj_5046));
	 return
	    (obj_t) (aux_6700);
      }
   }
}



/* box-set!/cinfo-value-set! */
obj_t 
box_set__cinfo_value_set__94_cfa_info(box_set__221_bglt obj_89, node_bglt val1885_90)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 90 */
      return
	 ((((box_set__221_bglt) CREF(obj_89))->value) = ((node_bglt) val1885_90), BUNSPEC);
   }
}



/* _box-set!/cinfo-value-set!2807 */
obj_t 
_box_set__cinfo_value_set_2807_175_cfa_info(obj_t env_5047, obj_t obj_5048, obj_t val1885_5049)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 90 */
      return
	 box_set__cinfo_value_set__94_cfa_info(
	 (box_set__221_bglt) (obj_5048),
	 (node_bglt) (val1885_5049));
   }
}



/* box-set!/cinfo-value */
node_bglt 
box_set__cinfo_value_36_cfa_info(box_set__221_bglt obj_91)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 90 */
      return
	 (((box_set__221_bglt) CREF(obj_91))->value);
   }
}



/* _box-set!/cinfo-value2808 */
obj_t 
_box_set__cinfo_value2808_85_cfa_info(obj_t env_5050, obj_t obj_5051)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 90 */
      {		/* Cfa/cinfo.scm 90 */
	 node_bglt aux_6709;
	 aux_6709 =
	    box_set__cinfo_value_36_cfa_info(
	    (box_set__221_bglt) (obj_5051));
	 return
	    (obj_t) (aux_6709);
      }
   }
}



/* box-set!/cinfo-approx */
approx_bglt 
box_set__cinfo_approx_234_cfa_info(box_set__cinfo_94_bglt obj_92)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 90 */
      {
	 obj_t aux_6713;
	 {	/* Cfa/cinfo.scm 90 */
	    object_bglt aux_6714;
	    aux_6714 =
	       (object_bglt) (obj_92);
	    aux_6713 =
	       OBJECT_WIDENING(aux_6714);
	 }
	 return
	    (((box_set__cinfo_94_bglt) CREF(aux_6713))->approx);
      }
   }
}



/* _box-set!/cinfo-approx2809 */
obj_t 
_box_set__cinfo_approx2809_141_cfa_info(obj_t env_5052, obj_t obj_5053)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 90 */
      {		/* Cfa/cinfo.scm 90 */
	 approx_bglt aux_6718;
	 aux_6718 =
	    box_set__cinfo_approx_234_cfa_info(
	    (box_set__cinfo_94_bglt) (obj_5053));
	 return
	    (obj_t) (aux_6718);
      }
   }
}



/* allocate-make-box/o-cinfo */
make_box_202_bglt 
allocate_make_box_o_cinfo_222_cfa_info()
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 87 */
      {		/* Cfa/cinfo.scm 87 */
	 make_box_202_bglt new1876_1694;
	 new1876_1694 =
	    ((make_box_202_bglt) BREF(GC_MALLOC(sizeof(struct make_box_202))));
	 {	/* Cfa/cinfo.scm 87 */
	    long arg2281_1695;
	    arg2281_1695 =
	       class_num_218___object(make_box_o_cinfo_96_cfa_info);
	    {	/* Cfa/cinfo.scm 87 */
	       obj_t obj_3019;
	       obj_3019 =
		  (obj_t) (new1876_1694);
	       (((obj_t) CREF(obj_3019))->header = MAKE_HEADER(arg2281_1695, 0), BUNSPEC);
	    }
	 }
	 {	/* Cfa/cinfo.scm 87 */
	    object_bglt aux_6726;
	    aux_6726 =
	       (object_bglt) (new1876_1694);
	    OBJECT_WIDENING_SET(aux_6726, BFALSE);
	 }
	 return new1876_1694;
      }
   }
}



/* _allocate-make-box/o-cinfo */
obj_t 
_allocate_make_box_o_cinfo_133_cfa_info(obj_t env_4921)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 87 */
      {		/* Cfa/cinfo.scm 87 */
	 make_box_202_bglt aux_6729;
	 aux_6729 =
	    allocate_make_box_o_cinfo_222_cfa_info();
	 return
	    (obj_t) (aux_6729);
      }
   }
}



/* make-box/o-cinfo? */
bool_t 
make_box_o_cinfo__221_cfa_info(obj_t obj_96)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 87 */
      return
	 is_a__118___object(obj_96, make_box_o_cinfo_96_cfa_info);
   }
}



/* _make-box/o-cinfo? */
obj_t 
_make_box_o_cinfo__52_cfa_info(obj_t env_5054, obj_t obj_5055)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 87 */
      {		/* Cfa/cinfo.scm 87 */
	 bool_t aux_6733;
	 aux_6733 =
	    make_box_o_cinfo__221_cfa_info(obj_5055);
	 return
	    BBOOL(aux_6733);
      }
   }
}



/* widening-make-box/o-cinfo */
make_box_o_cinfo_96_bglt 
widening_make_box_o_cinfo_32_cfa_info(approx_bglt approx_97, approx_bglt value_approx_19_98)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 87 */
      {		/* Cfa/cinfo.scm 87 */
	 make_box_o_cinfo_96_bglt new1870_3021;
	 new1870_3021 =
	    ((make_box_o_cinfo_96_bglt) BREF(GC_MALLOC(sizeof(struct make_box_o_cinfo_96))));
	 ((((make_box_o_cinfo_96_bglt) CREF(new1870_3021))->approx) = ((approx_bglt) approx_97), BUNSPEC);
	 ((((make_box_o_cinfo_96_bglt) CREF(new1870_3021))->value_approx_19) = ((approx_bglt) value_approx_19_98), BUNSPEC);
	 return new1870_3021;
      }
   }
}



/* _widening-make-box/o-cinfo2810 */
obj_t 
_widening_make_box_o_cinfo2810_191_cfa_info(obj_t env_5056, obj_t approx_5057, obj_t value_approx_19_5058)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 87 */
      {		/* Cfa/cinfo.scm 87 */
	 make_box_o_cinfo_96_bglt aux_6739;
	 aux_6739 =
	    widening_make_box_o_cinfo_32_cfa_info(
	    (approx_bglt) (approx_5057),
	    (approx_bglt) (value_approx_19_5058));
	 return
	    (obj_t) (aux_6739);
      }
   }
}



/* make-make-box/o-cinfo */
make_box_o_cinfo_96_bglt 
make_make_box_o_cinfo_242_cfa_info(obj_t loc_99, type_bglt type_100, obj_t side_effect__165_101, obj_t key_102, node_bglt value_103, approx_bglt approx_104, approx_bglt value_approx_19_105)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 87 */
      {		/* Cfa/cinfo.scm 87 */
	 make_box_202_bglt aux1874_3024;
	 {	/* Cfa/cinfo.scm 87 */
	    make_box_202_bglt res2691_3042;
	    {	/* ./Ast/node.scm 760 */
	       make_box_202_bglt new1407_3033;
	       new1407_3033 =
		  ((make_box_202_bglt) BREF(GC_MALLOC(sizeof(struct make_box_202))));
	       {	/* ./Ast/node.scm 760 */
		  long arg2363_3034;
		  arg2363_3034 =
		     class_num_218___object(make_box_202_ast_node);
		  {	/* ./Ast/node.scm 760 */
		     obj_t obj_3040;
		     obj_3040 =
			(obj_t) (new1407_3033);
		     (((obj_t) CREF(obj_3040))->header = MAKE_HEADER(arg2363_3034, 0), BUNSPEC);
		  }
	       }
	       {	/* ./Ast/node.scm 760 */
		  object_bglt aux_6748;
		  aux_6748 =
		     (object_bglt) (new1407_3033);
		  OBJECT_WIDENING_SET(aux_6748, BFALSE);
	       }
	       ((((make_box_202_bglt) CREF(new1407_3033))->loc) = ((obj_t) loc_99), BUNSPEC);
	       ((((make_box_202_bglt) CREF(new1407_3033))->type) = ((type_bglt) type_100), BUNSPEC);
	       ((((make_box_202_bglt) CREF(new1407_3033))->side_effect__165) = ((obj_t) side_effect__165_101), BUNSPEC);
	       ((((make_box_202_bglt) CREF(new1407_3033))->key) = ((obj_t) key_102), BUNSPEC);
	       ((((make_box_202_bglt) CREF(new1407_3033))->value) = ((node_bglt) value_103), BUNSPEC);
	       res2691_3042 = new1407_3033;
	    }
	    aux1874_3024 = res2691_3042;
	 }
	 {	/* Cfa/cinfo.scm 87 */
	    make_box_o_cinfo_96_bglt new1875_3025;
	    new1875_3025 =
	       ((make_box_o_cinfo_96_bglt) (aux1874_3024));
	    {	/* Cfa/cinfo.scm 87 */
	       long arg2282_3026;
	       arg2282_3026 =
		  class_num_218___object(make_box_o_cinfo_96_cfa_info);
	       {	/* Cfa/cinfo.scm 87 */
		  obj_t obj_3043;
		  obj_3043 =
		     (obj_t) (new1875_3025);
		  (((obj_t) CREF(obj_3043))->header = MAKE_HEADER(arg2282_3026, 0), BUNSPEC);
	       }
	    }
	    {	/* Cfa/cinfo.scm 87 */
	       make_box_o_cinfo_96_bglt arg2283_3027;
	       {	/* Cfa/cinfo.scm 87 */
		  make_box_o_cinfo_96_bglt res2692_3050;
		  {	/* Cfa/cinfo.scm 87 */
		     make_box_o_cinfo_96_bglt new1870_3047;
		     new1870_3047 =
			((make_box_o_cinfo_96_bglt) BREF(GC_MALLOC(sizeof(struct make_box_o_cinfo_96))));
		     ((((make_box_o_cinfo_96_bglt) CREF(new1870_3047))->approx) = ((approx_bglt) approx_104), BUNSPEC);
		     ((((make_box_o_cinfo_96_bglt) CREF(new1870_3047))->value_approx_19) = ((approx_bglt) value_approx_19_105), BUNSPEC);
		     res2692_3050 = new1870_3047;
		  }
		  arg2283_3027 = res2692_3050;
	       }
	       {	/* Cfa/cinfo.scm 87 */
		  obj_t aux_6765;
		  object_bglt aux_6763;
		  aux_6765 =
		     (obj_t) (arg2283_3027);
		  aux_6763 =
		     (object_bglt) (new1875_3025);
		  OBJECT_WIDENING_SET(aux_6763, aux_6765);
	       }
	    }
	    return new1875_3025;
	 }
      }
   }
}



/* _make-make-box/o-cinfo2811 */
obj_t 
_make_make_box_o_cinfo2811_50_cfa_info(obj_t env_5059, obj_t loc_5060, obj_t type_5061, obj_t side_effect__165_5062, obj_t key_5063, obj_t value_5064, obj_t approx_5065, obj_t value_approx_19_5066)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 87 */
      {		/* Cfa/cinfo.scm 87 */
	 make_box_o_cinfo_96_bglt aux_6768;
	 aux_6768 =
	    make_make_box_o_cinfo_242_cfa_info(loc_5060,
	    (type_bglt) (type_5061), side_effect__165_5062, key_5063,
	    (node_bglt) (value_5064),
	    (approx_bglt) (approx_5065),
	    (approx_bglt) (value_approx_19_5066));
	 return
	    (obj_t) (aux_6768);
      }
   }
}



/* make-box/o-cinfo-loc */
obj_t 
make_box_o_cinfo_loc_160_cfa_info(make_box_202_bglt obj_106)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 624 */
      return
	 (((make_box_202_bglt) CREF(obj_106))->loc);
   }
}



/* _make-box/o-cinfo-loc2812 */
obj_t 
_make_box_o_cinfo_loc2812_127_cfa_info(obj_t env_5067, obj_t obj_5068)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 624 */
      return
	 make_box_o_cinfo_loc_160_cfa_info(
	 (make_box_202_bglt) (obj_5068));
   }
}



/* make-box/o-cinfo-type-set! */
obj_t 
make_box_o_cinfo_type_set__41_cfa_info(make_box_202_bglt obj_107, type_bglt val1865_108)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 87 */
      return
	 ((((make_box_202_bglt) CREF(obj_107))->type) = ((type_bglt) val1865_108), BUNSPEC);
   }
}



/* _make-box/o-cinfo-type-set!2813 */
obj_t 
_make_box_o_cinfo_type_set_2813_55_cfa_info(obj_t env_5069, obj_t obj_5070, obj_t val1865_5071)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 87 */
      return
	 make_box_o_cinfo_type_set__41_cfa_info(
	 (make_box_202_bglt) (obj_5070),
	 (type_bglt) (val1865_5071));
   }
}



/* make-box/o-cinfo-type */
type_bglt 
make_box_o_cinfo_type_235_cfa_info(make_box_202_bglt obj_109)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 87 */
      return
	 (((make_box_202_bglt) CREF(obj_109))->type);
   }
}



/* _make-box/o-cinfo-type2814 */
obj_t 
_make_box_o_cinfo_type2814_18_cfa_info(obj_t env_5072, obj_t obj_5073)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 87 */
      {		/* Cfa/cinfo.scm 87 */
	 type_bglt aux_6783;
	 aux_6783 =
	    make_box_o_cinfo_type_235_cfa_info(
	    (make_box_202_bglt) (obj_5073));
	 return
	    (obj_t) (aux_6783);
      }
   }
}



/* make-box/o-cinfo-side-effect?-set! */
obj_t 
make_box_o_cinfo_side_effect__set__221_cfa_info(make_box_202_bglt obj_110, obj_t val1866_111)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 632 */
      return
	 ((((make_box_202_bglt) CREF(obj_110))->side_effect__165) = ((obj_t) val1866_111), BUNSPEC);
   }
}



/* _make-box/o-cinfo-side-effect?-set!2815 */
obj_t 
_make_box_o_cinfo_side_effect__set_2815_15_cfa_info(obj_t env_5074, obj_t obj_5075, obj_t val1866_5076)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 632 */
      return
	 make_box_o_cinfo_side_effect__set__221_cfa_info(
	 (make_box_202_bglt) (obj_5075), val1866_5076);
   }
}



/* make-box/o-cinfo-side-effect? */
obj_t 
make_box_o_cinfo_side_effect__220_cfa_info(make_box_202_bglt obj_112)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 632 */
      return
	 (((make_box_202_bglt) CREF(obj_112))->side_effect__165);
   }
}



/* _make-box/o-cinfo-side-effect?2816 */
obj_t 
_make_box_o_cinfo_side_effect_2816_232_cfa_info(obj_t env_5077, obj_t obj_5078)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 632 */
      return
	 make_box_o_cinfo_side_effect__220_cfa_info(
	 (make_box_202_bglt) (obj_5078));
   }
}



/* make-box/o-cinfo-key-set! */
obj_t 
make_box_o_cinfo_key_set__68_cfa_info(make_box_202_bglt obj_113, obj_t val1867_114)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 636 */
      return
	 ((((make_box_202_bglt) CREF(obj_113))->key) = ((obj_t) val1867_114), BUNSPEC);
   }
}



/* _make-box/o-cinfo-key-set! */
obj_t 
_make_box_o_cinfo_key_set__74_cfa_info(obj_t env_5079, obj_t obj_5080, obj_t val1867_5081)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 636 */
      return
	 make_box_o_cinfo_key_set__68_cfa_info(
	 (make_box_202_bglt) (obj_5080), val1867_5081);
   }
}



/* make-box/o-cinfo-key */
obj_t 
make_box_o_cinfo_key_140_cfa_info(make_box_202_bglt obj_115)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 636 */
      return
	 (((make_box_202_bglt) CREF(obj_115))->key);
   }
}



/* _make-box/o-cinfo-key2817 */
obj_t 
_make_box_o_cinfo_key2817_186_cfa_info(obj_t env_5082, obj_t obj_5083)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 636 */
      return
	 make_box_o_cinfo_key_140_cfa_info(
	 (make_box_202_bglt) (obj_5083));
   }
}



/* make-box/o-cinfo-value-set! */
obj_t 
make_box_o_cinfo_value_set__222_cfa_info(make_box_202_bglt obj_116, node_bglt val1868_117)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 87 */
      return
	 ((((make_box_202_bglt) CREF(obj_116))->value) = ((node_bglt) val1868_117), BUNSPEC);
   }
}



/* _make-box/o-cinfo-value-set!2818 */
obj_t 
_make_box_o_cinfo_value_set_2818_253_cfa_info(obj_t env_5084, obj_t obj_5085, obj_t val1868_5086)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 87 */
      return
	 make_box_o_cinfo_value_set__222_cfa_info(
	 (make_box_202_bglt) (obj_5085),
	 (node_bglt) (val1868_5086));
   }
}



/* make-box/o-cinfo-value */
node_bglt 
make_box_o_cinfo_value_153_cfa_info(make_box_202_bglt obj_118)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 87 */
      return
	 (((make_box_202_bglt) CREF(obj_118))->value);
   }
}



/* _make-box/o-cinfo-value2819 */
obj_t 
_make_box_o_cinfo_value2819_230_cfa_info(obj_t env_5087, obj_t obj_5088)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 87 */
      {		/* Cfa/cinfo.scm 87 */
	 node_bglt aux_6804;
	 aux_6804 =
	    make_box_o_cinfo_value_153_cfa_info(
	    (make_box_202_bglt) (obj_5088));
	 return
	    (obj_t) (aux_6804);
      }
   }
}



/* make-box/o-cinfo-approx-set! */
obj_t 
make_box_o_cinfo_approx_set__53_cfa_info(make_box_o_cinfo_96_bglt obj_119, approx_bglt val1869_120)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 87 */
      {
	 obj_t aux_6808;
	 {	/* Cfa/cinfo.scm 87 */
	    object_bglt aux_6809;
	    aux_6809 =
	       (object_bglt) (obj_119);
	    aux_6808 =
	       OBJECT_WIDENING(aux_6809);
	 }
	 return
	    ((((make_box_o_cinfo_96_bglt) CREF(aux_6808))->approx) = ((approx_bglt) val1869_120), BUNSPEC);
      }
   }
}



/* _make-box/o-cinfo-approx-set!2820 */
obj_t 
_make_box_o_cinfo_approx_set_2820_218_cfa_info(obj_t env_5089, obj_t obj_5090, obj_t val1869_5091)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 87 */
      return
	 make_box_o_cinfo_approx_set__53_cfa_info(
	 (make_box_o_cinfo_96_bglt) (obj_5090),
	 (approx_bglt) (val1869_5091));
   }
}



/* make-box/o-cinfo-approx */
approx_bglt 
make_box_o_cinfo_approx_146_cfa_info(make_box_o_cinfo_96_bglt obj_121)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 87 */
      {
	 obj_t aux_6816;
	 {	/* Cfa/cinfo.scm 87 */
	    object_bglt aux_6817;
	    aux_6817 =
	       (object_bglt) (obj_121);
	    aux_6816 =
	       OBJECT_WIDENING(aux_6817);
	 }
	 return
	    (((make_box_o_cinfo_96_bglt) CREF(aux_6816))->approx);
      }
   }
}



/* _make-box/o-cinfo-approx2821 */
obj_t 
_make_box_o_cinfo_approx2821_80_cfa_info(obj_t env_5092, obj_t obj_5093)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 87 */
      {		/* Cfa/cinfo.scm 87 */
	 approx_bglt aux_6821;
	 aux_6821 =
	    make_box_o_cinfo_approx_146_cfa_info(
	    (make_box_o_cinfo_96_bglt) (obj_5093));
	 return
	    (obj_t) (aux_6821);
      }
   }
}



/* make-box/o-cinfo-value-approx */
approx_bglt 
make_box_o_cinfo_value_approx_169_cfa_info(make_box_o_cinfo_96_bglt obj_122)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 89 */
      {
	 obj_t aux_6825;
	 {	/* Cfa/cinfo.scm 89 */
	    object_bglt aux_6826;
	    aux_6826 =
	       (object_bglt) (obj_122);
	    aux_6825 =
	       OBJECT_WIDENING(aux_6826);
	 }
	 return
	    (((make_box_o_cinfo_96_bglt) CREF(aux_6825))->value_approx_19);
      }
   }
}



/* _make-box/o-cinfo-value-approx2822 */
obj_t 
_make_box_o_cinfo_value_approx2822_53_cfa_info(obj_t env_5094, obj_t obj_5095)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 89 */
      {		/* Cfa/cinfo.scm 89 */
	 approx_bglt aux_6830;
	 aux_6830 =
	    make_box_o_cinfo_value_approx_169_cfa_info(
	    (make_box_o_cinfo_96_bglt) (obj_5095));
	 return
	    (obj_t) (aux_6830);
      }
   }
}



/* allocate-make-box/cinfo */
make_box_202_bglt 
allocate_make_box_cinfo_213_cfa_info()
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 86 */
      {		/* Cfa/cinfo.scm 86 */
	 make_box_202_bglt new1858_1703;
	 new1858_1703 =
	    ((make_box_202_bglt) BREF(GC_MALLOC(sizeof(struct make_box_202))));
	 {	/* Cfa/cinfo.scm 86 */
	    long arg2284_1704;
	    arg2284_1704 =
	       class_num_218___object(make_box_cinfo_127_cfa_info);
	    {	/* Cfa/cinfo.scm 86 */
	       obj_t obj_3051;
	       obj_3051 =
		  (obj_t) (new1858_1703);
	       (((obj_t) CREF(obj_3051))->header = MAKE_HEADER(arg2284_1704, 0), BUNSPEC);
	    }
	 }
	 {	/* Cfa/cinfo.scm 86 */
	    object_bglt aux_6838;
	    aux_6838 =
	       (object_bglt) (new1858_1703);
	    OBJECT_WIDENING_SET(aux_6838, BFALSE);
	 }
	 return new1858_1703;
      }
   }
}



/* _allocate-make-box/cinfo */
obj_t 
_allocate_make_box_cinfo_36_cfa_info(obj_t env_4920)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 86 */
      {		/* Cfa/cinfo.scm 86 */
	 make_box_202_bglt aux_6841;
	 aux_6841 =
	    allocate_make_box_cinfo_213_cfa_info();
	 return
	    (obj_t) (aux_6841);
      }
   }
}



/* make-box/cinfo? */
bool_t 
make_box_cinfo__176_cfa_info(obj_t obj_126)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 86 */
      return
	 is_a__118___object(obj_126, make_box_cinfo_127_cfa_info);
   }
}



/* _make-box/cinfo? */
obj_t 
_make_box_cinfo__189_cfa_info(obj_t env_5096, obj_t obj_5097)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 86 */
      {		/* Cfa/cinfo.scm 86 */
	 bool_t aux_6845;
	 aux_6845 =
	    make_box_cinfo__176_cfa_info(obj_5097);
	 return
	    BBOOL(aux_6845);
      }
   }
}



/* widening-make-box/cinfo */
make_box_cinfo_127_bglt 
widening_make_box_cinfo_240_cfa_info(approx_bglt approx_127)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 86 */
      {		/* Cfa/cinfo.scm 86 */
	 make_box_cinfo_127_bglt new1853_3053;
	 new1853_3053 =
	    ((make_box_cinfo_127_bglt) BREF(GC_MALLOC(sizeof(struct make_box_cinfo_127))));
	 ((((make_box_cinfo_127_bglt) CREF(new1853_3053))->approx) = ((approx_bglt) approx_127), BUNSPEC);
	 return new1853_3053;
      }
   }
}



/* _widening-make-box/cinfo2823 */
obj_t 
_widening_make_box_cinfo2823_164_cfa_info(obj_t env_5098, obj_t approx_5099)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 86 */
      {		/* Cfa/cinfo.scm 86 */
	 make_box_cinfo_127_bglt aux_6850;
	 aux_6850 =
	    widening_make_box_cinfo_240_cfa_info(
	    (approx_bglt) (approx_5099));
	 return
	    (obj_t) (aux_6850);
      }
   }
}



/* make-make-box/cinfo */
make_box_cinfo_127_bglt 
make_make_box_cinfo_79_cfa_info(obj_t loc_128, type_bglt type_129, obj_t side_effect__165_130, obj_t key_131, node_bglt value_132, approx_bglt approx_133)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 86 */
      {		/* Cfa/cinfo.scm 86 */
	 make_box_202_bglt aux1856_3055;
	 {	/* Cfa/cinfo.scm 86 */
	    make_box_202_bglt res2693_3073;
	    {	/* ./Ast/node.scm 760 */
	       make_box_202_bglt new1407_3064;
	       new1407_3064 =
		  ((make_box_202_bglt) BREF(GC_MALLOC(sizeof(struct make_box_202))));
	       {	/* ./Ast/node.scm 760 */
		  long arg2363_3065;
		  arg2363_3065 =
		     class_num_218___object(make_box_202_ast_node);
		  {	/* ./Ast/node.scm 760 */
		     obj_t obj_3071;
		     obj_3071 =
			(obj_t) (new1407_3064);
		     (((obj_t) CREF(obj_3071))->header = MAKE_HEADER(arg2363_3065, 0), BUNSPEC);
		  }
	       }
	       {	/* ./Ast/node.scm 760 */
		  object_bglt aux_6858;
		  aux_6858 =
		     (object_bglt) (new1407_3064);
		  OBJECT_WIDENING_SET(aux_6858, BFALSE);
	       }
	       ((((make_box_202_bglt) CREF(new1407_3064))->loc) = ((obj_t) loc_128), BUNSPEC);
	       ((((make_box_202_bglt) CREF(new1407_3064))->type) = ((type_bglt) type_129), BUNSPEC);
	       ((((make_box_202_bglt) CREF(new1407_3064))->side_effect__165) = ((obj_t) side_effect__165_130), BUNSPEC);
	       ((((make_box_202_bglt) CREF(new1407_3064))->key) = ((obj_t) key_131), BUNSPEC);
	       ((((make_box_202_bglt) CREF(new1407_3064))->value) = ((node_bglt) value_132), BUNSPEC);
	       res2693_3073 = new1407_3064;
	    }
	    aux1856_3055 = res2693_3073;
	 }
	 {	/* Cfa/cinfo.scm 86 */
	    make_box_cinfo_127_bglt new1857_3056;
	    new1857_3056 =
	       ((make_box_cinfo_127_bglt) (aux1856_3055));
	    {	/* Cfa/cinfo.scm 86 */
	       long arg2285_3057;
	       arg2285_3057 =
		  class_num_218___object(make_box_cinfo_127_cfa_info);
	       {	/* Cfa/cinfo.scm 86 */
		  obj_t obj_3074;
		  obj_3074 =
		     (obj_t) (new1857_3056);
		  (((obj_t) CREF(obj_3074))->header = MAKE_HEADER(arg2285_3057, 0), BUNSPEC);
	       }
	    }
	    {	/* Cfa/cinfo.scm 86 */
	       make_box_cinfo_127_bglt arg2286_3058;
	       {	/* Cfa/cinfo.scm 86 */
		  make_box_cinfo_127_bglt res2694_3079;
		  {	/* Cfa/cinfo.scm 86 */
		     make_box_cinfo_127_bglt new1853_3077;
		     new1853_3077 =
			((make_box_cinfo_127_bglt) BREF(GC_MALLOC(sizeof(struct make_box_cinfo_127))));
		     ((((make_box_cinfo_127_bglt) CREF(new1853_3077))->approx) = ((approx_bglt) approx_133), BUNSPEC);
		     res2694_3079 = new1853_3077;
		  }
		  arg2286_3058 = res2694_3079;
	       }
	       {	/* Cfa/cinfo.scm 86 */
		  obj_t aux_6874;
		  object_bglt aux_6872;
		  aux_6874 =
		     (obj_t) (arg2286_3058);
		  aux_6872 =
		     (object_bglt) (new1857_3056);
		  OBJECT_WIDENING_SET(aux_6872, aux_6874);
	       }
	    }
	    return new1857_3056;
	 }
      }
   }
}



/* _make-make-box/cinfo2824 */
obj_t 
_make_make_box_cinfo2824_251_cfa_info(obj_t env_5100, obj_t loc_5101, obj_t type_5102, obj_t side_effect__165_5103, obj_t key_5104, obj_t value_5105, obj_t approx_5106)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 86 */
      {		/* Cfa/cinfo.scm 86 */
	 make_box_cinfo_127_bglt aux_6877;
	 aux_6877 =
	    make_make_box_cinfo_79_cfa_info(loc_5101,
	    (type_bglt) (type_5102), side_effect__165_5103, key_5104,
	    (node_bglt) (value_5105),
	    (approx_bglt) (approx_5106));
	 return
	    (obj_t) (aux_6877);
      }
   }
}



/* make-box/cinfo-loc */
obj_t 
make_box_cinfo_loc_173_cfa_info(make_box_202_bglt obj_134)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 624 */
      return
	 (((make_box_202_bglt) CREF(obj_134))->loc);
   }
}



/* _make-box/cinfo-loc2825 */
obj_t 
_make_box_cinfo_loc2825_22_cfa_info(obj_t env_5107, obj_t obj_5108)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 624 */
      return
	 make_box_cinfo_loc_173_cfa_info(
	 (make_box_202_bglt) (obj_5108));
   }
}



/* make-box/cinfo-type-set! */
obj_t 
make_box_cinfo_type_set__156_cfa_info(make_box_202_bglt obj_135, type_bglt val1849_136)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 86 */
      return
	 ((((make_box_202_bglt) CREF(obj_135))->type) = ((type_bglt) val1849_136), BUNSPEC);
   }
}



/* _make-box/cinfo-type-set!2826 */
obj_t 
_make_box_cinfo_type_set_2826_199_cfa_info(obj_t env_5109, obj_t obj_5110, obj_t val1849_5111)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 86 */
      return
	 make_box_cinfo_type_set__156_cfa_info(
	 (make_box_202_bglt) (obj_5110),
	 (type_bglt) (val1849_5111));
   }
}



/* make-box/cinfo-type */
type_bglt 
make_box_cinfo_type_207_cfa_info(make_box_202_bglt obj_137)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 86 */
      return
	 (((make_box_202_bglt) CREF(obj_137))->type);
   }
}



/* _make-box/cinfo-type2827 */
obj_t 
_make_box_cinfo_type2827_75_cfa_info(obj_t env_5112, obj_t obj_5113)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 86 */
      {		/* Cfa/cinfo.scm 86 */
	 type_bglt aux_6891;
	 aux_6891 =
	    make_box_cinfo_type_207_cfa_info(
	    (make_box_202_bglt) (obj_5113));
	 return
	    (obj_t) (aux_6891);
      }
   }
}



/* make-box/cinfo-side-effect?-set! */
obj_t 
make_box_cinfo_side_effect__set__59_cfa_info(make_box_202_bglt obj_138, obj_t val1850_139)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 632 */
      return
	 ((((make_box_202_bglt) CREF(obj_138))->side_effect__165) = ((obj_t) val1850_139), BUNSPEC);
   }
}



/* _make-box/cinfo-side-effect?-set!2828 */
obj_t 
_make_box_cinfo_side_effect__set_2828_43_cfa_info(obj_t env_5114, obj_t obj_5115, obj_t val1850_5116)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 632 */
      return
	 make_box_cinfo_side_effect__set__59_cfa_info(
	 (make_box_202_bglt) (obj_5115), val1850_5116);
   }
}



/* make-box/cinfo-side-effect? */
obj_t 
make_box_cinfo_side_effect__155_cfa_info(make_box_202_bglt obj_140)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 632 */
      return
	 (((make_box_202_bglt) CREF(obj_140))->side_effect__165);
   }
}



/* _make-box/cinfo-side-effect?2829 */
obj_t 
_make_box_cinfo_side_effect_2829_211_cfa_info(obj_t env_5117, obj_t obj_5118)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 632 */
      return
	 make_box_cinfo_side_effect__155_cfa_info(
	 (make_box_202_bglt) (obj_5118));
   }
}



/* make-box/cinfo-key-set! */
obj_t 
make_box_cinfo_key_set__72_cfa_info(make_box_202_bglt obj_141, obj_t val1851_142)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 636 */
      return
	 ((((make_box_202_bglt) CREF(obj_141))->key) = ((obj_t) val1851_142), BUNSPEC);
   }
}



/* _make-box/cinfo-key-set! */
obj_t 
_make_box_cinfo_key_set__204_cfa_info(obj_t env_5119, obj_t obj_5120, obj_t val1851_5121)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 636 */
      return
	 make_box_cinfo_key_set__72_cfa_info(
	 (make_box_202_bglt) (obj_5120), val1851_5121);
   }
}



/* make-box/cinfo-key */
obj_t 
make_box_cinfo_key_12_cfa_info(make_box_202_bglt obj_143)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 636 */
      return
	 (((make_box_202_bglt) CREF(obj_143))->key);
   }
}



/* _make-box/cinfo-key */
obj_t 
_make_box_cinfo_key_44_cfa_info(obj_t env_5122, obj_t obj_5123)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 636 */
      return
	 make_box_cinfo_key_12_cfa_info(
	 (make_box_202_bglt) (obj_5123));
   }
}



/* make-box/cinfo-value-set! */
obj_t 
make_box_cinfo_value_set__204_cfa_info(make_box_202_bglt obj_144, node_bglt val1852_145)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 86 */
      return
	 ((((make_box_202_bglt) CREF(obj_144))->value) = ((node_bglt) val1852_145), BUNSPEC);
   }
}



/* _make-box/cinfo-value-set!2830 */
obj_t 
_make_box_cinfo_value_set_2830_42_cfa_info(obj_t env_5124, obj_t obj_5125, obj_t val1852_5126)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 86 */
      return
	 make_box_cinfo_value_set__204_cfa_info(
	 (make_box_202_bglt) (obj_5125),
	 (node_bglt) (val1852_5126));
   }
}



/* make-box/cinfo-value */
node_bglt 
make_box_cinfo_value_44_cfa_info(make_box_202_bglt obj_146)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 86 */
      return
	 (((make_box_202_bglt) CREF(obj_146))->value);
   }
}



/* _make-box/cinfo-value2831 */
obj_t 
_make_box_cinfo_value2831_209_cfa_info(obj_t env_5127, obj_t obj_5128)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 86 */
      {		/* Cfa/cinfo.scm 86 */
	 node_bglt aux_6912;
	 aux_6912 =
	    make_box_cinfo_value_44_cfa_info(
	    (make_box_202_bglt) (obj_5128));
	 return
	    (obj_t) (aux_6912);
      }
   }
}



/* make-box/cinfo-approx */
approx_bglt 
make_box_cinfo_approx_244_cfa_info(make_box_cinfo_127_bglt obj_147)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 86 */
      {
	 obj_t aux_6916;
	 {	/* Cfa/cinfo.scm 86 */
	    object_bglt aux_6917;
	    aux_6917 =
	       (object_bglt) (obj_147);
	    aux_6916 =
	       OBJECT_WIDENING(aux_6917);
	 }
	 return
	    (((make_box_cinfo_127_bglt) CREF(aux_6916))->approx);
      }
   }
}



/* _make-box/cinfo-approx2832 */
obj_t 
_make_box_cinfo_approx2832_148_cfa_info(obj_t env_5129, obj_t obj_5130)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 86 */
      {		/* Cfa/cinfo.scm 86 */
	 approx_bglt aux_6921;
	 aux_6921 =
	    make_box_cinfo_approx_244_cfa_info(
	    (make_box_cinfo_127_bglt) (obj_5130));
	 return
	    (obj_t) (aux_6921);
      }
   }
}



/* allocate-pre-make-box */
make_box_202_bglt 
allocate_pre_make_box_175_cfa_info()
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 85 */
      {		/* Cfa/cinfo.scm 85 */
	 make_box_202_bglt new1842_1711;
	 new1842_1711 =
	    ((make_box_202_bglt) BREF(GC_MALLOC(sizeof(struct make_box_202))));
	 {	/* Cfa/cinfo.scm 85 */
	    long arg2287_1712;
	    arg2287_1712 =
	       class_num_218___object(pre_make_box_186_cfa_info);
	    {	/* Cfa/cinfo.scm 85 */
	       obj_t obj_3080;
	       obj_3080 =
		  (obj_t) (new1842_1711);
	       (((obj_t) CREF(obj_3080))->header = MAKE_HEADER(arg2287_1712, 0), BUNSPEC);
	    }
	 }
	 {	/* Cfa/cinfo.scm 85 */
	    object_bglt aux_6929;
	    aux_6929 =
	       (object_bglt) (new1842_1711);
	    OBJECT_WIDENING_SET(aux_6929, BFALSE);
	 }
	 return new1842_1711;
      }
   }
}



/* _allocate-pre-make-box */
obj_t 
_allocate_pre_make_box_48_cfa_info(obj_t env_4919)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 85 */
      {		/* Cfa/cinfo.scm 85 */
	 make_box_202_bglt aux_6932;
	 aux_6932 =
	    allocate_pre_make_box_175_cfa_info();
	 return
	    (obj_t) (aux_6932);
      }
   }
}



/* pre-make-box? */
bool_t 
pre_make_box__245_cfa_info(obj_t obj_151)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 85 */
      return
	 is_a__118___object(obj_151, pre_make_box_186_cfa_info);
   }
}



/* _pre-make-box? */
obj_t 
_pre_make_box__20_cfa_info(obj_t env_5131, obj_t obj_5132)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 85 */
      {		/* Cfa/cinfo.scm 85 */
	 bool_t aux_6936;
	 aux_6936 =
	    pre_make_box__245_cfa_info(obj_5132);
	 return
	    BBOOL(aux_6936);
      }
   }
}



/* widening-pre-make-box */
pre_make_box_186_bglt 
widening_pre_make_box_219_cfa_info()
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 85 */
      {		/* Cfa/cinfo.scm 85 */

	 return
	    ((pre_make_box_186_bglt) BREF(GC_MALLOC(sizeof(struct pre_make_box_186))));
      }
   }
}



/* _widening-pre-make-box */
obj_t 
_widening_pre_make_box_226_cfa_info(obj_t env_5133)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 85 */
      {		/* Cfa/cinfo.scm 85 */
	 pre_make_box_186_bglt aux_6940;
	 aux_6940 =
	    widening_pre_make_box_219_cfa_info();
	 return
	    (obj_t) (aux_6940);
      }
   }
}



/* make-pre-make-box */
pre_make_box_186_bglt 
make_pre_make_box_82_cfa_info(obj_t loc_152, type_bglt type_153, obj_t side_effect__165_154, obj_t key_155, node_bglt value_156)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 85 */
      {		/* Cfa/cinfo.scm 85 */
	 make_box_202_bglt aux1840_3083;
	 {	/* Cfa/cinfo.scm 85 */
	    make_box_202_bglt res2695_3101;
	    {	/* ./Ast/node.scm 760 */
	       make_box_202_bglt new1407_3092;
	       new1407_3092 =
		  ((make_box_202_bglt) BREF(GC_MALLOC(sizeof(struct make_box_202))));
	       {	/* ./Ast/node.scm 760 */
		  long arg2363_3093;
		  arg2363_3093 =
		     class_num_218___object(make_box_202_ast_node);
		  {	/* ./Ast/node.scm 760 */
		     obj_t obj_3099;
		     obj_3099 =
			(obj_t) (new1407_3092);
		     (((obj_t) CREF(obj_3099))->header = MAKE_HEADER(arg2363_3093, 0), BUNSPEC);
		  }
	       }
	       {	/* ./Ast/node.scm 760 */
		  object_bglt aux_6947;
		  aux_6947 =
		     (object_bglt) (new1407_3092);
		  OBJECT_WIDENING_SET(aux_6947, BFALSE);
	       }
	       ((((make_box_202_bglt) CREF(new1407_3092))->loc) = ((obj_t) loc_152), BUNSPEC);
	       ((((make_box_202_bglt) CREF(new1407_3092))->type) = ((type_bglt) type_153), BUNSPEC);
	       ((((make_box_202_bglt) CREF(new1407_3092))->side_effect__165) = ((obj_t) side_effect__165_154), BUNSPEC);
	       ((((make_box_202_bglt) CREF(new1407_3092))->key) = ((obj_t) key_155), BUNSPEC);
	       ((((make_box_202_bglt) CREF(new1407_3092))->value) = ((node_bglt) value_156), BUNSPEC);
	       res2695_3101 = new1407_3092;
	    }
	    aux1840_3083 = res2695_3101;
	 }
	 {	/* Cfa/cinfo.scm 85 */
	    pre_make_box_186_bglt new1841_3084;
	    new1841_3084 =
	       ((pre_make_box_186_bglt) (aux1840_3083));
	    {	/* Cfa/cinfo.scm 85 */
	       long arg2288_3085;
	       arg2288_3085 =
		  class_num_218___object(pre_make_box_186_cfa_info);
	       {	/* Cfa/cinfo.scm 85 */
		  obj_t obj_3102;
		  obj_3102 =
		     (obj_t) (new1841_3084);
		  (((obj_t) CREF(obj_3102))->header = MAKE_HEADER(arg2288_3085, 0), BUNSPEC);
	       }
	    }
	    {	/* Cfa/cinfo.scm 85 */
	       obj_t aux_6961;
	       object_bglt aux_6959;
	       {	/* Cfa/cinfo.scm 85 */
		  pre_make_box_186_bglt aux_6962;
		  {	/* Cfa/cinfo.scm 85 */

		     aux_6962 =
			((pre_make_box_186_bglt) BREF(GC_MALLOC(sizeof(struct pre_make_box_186))));
		  }
		  aux_6961 =
		     (obj_t) (aux_6962);
	       }
	       aux_6959 =
		  (object_bglt) (new1841_3084);
	       OBJECT_WIDENING_SET(aux_6959, aux_6961);
	    }
	    return new1841_3084;
	 }
      }
   }
}



/* _make-pre-make-box2833 */
obj_t 
_make_pre_make_box2833_64_cfa_info(obj_t env_5134, obj_t loc_5135, obj_t type_5136, obj_t side_effect__165_5137, obj_t key_5138, obj_t value_5139)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 85 */
      {		/* Cfa/cinfo.scm 85 */
	 pre_make_box_186_bglt aux_6966;
	 aux_6966 =
	    make_pre_make_box_82_cfa_info(loc_5135,
	    (type_bglt) (type_5136), side_effect__165_5137, key_5138,
	    (node_bglt) (value_5139));
	 return
	    (obj_t) (aux_6966);
      }
   }
}



/* pre-make-box-loc */
obj_t 
pre_make_box_loc_183_cfa_info(make_box_202_bglt obj_157)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 624 */
      return
	 (((make_box_202_bglt) CREF(obj_157))->loc);
   }
}



/* _pre-make-box-loc2834 */
obj_t 
_pre_make_box_loc2834_157_cfa_info(obj_t env_5140, obj_t obj_5141)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 624 */
      return
	 pre_make_box_loc_183_cfa_info(
	 (make_box_202_bglt) (obj_5141));
   }
}



/* pre-make-box-type-set! */
obj_t 
pre_make_box_type_set__21_cfa_info(make_box_202_bglt obj_158, type_bglt val1834_159)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 85 */
      return
	 ((((make_box_202_bglt) CREF(obj_158))->type) = ((type_bglt) val1834_159), BUNSPEC);
   }
}



/* _pre-make-box-type-set!2835 */
obj_t 
_pre_make_box_type_set_2835_95_cfa_info(obj_t env_5142, obj_t obj_5143, obj_t val1834_5144)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 85 */
      return
	 pre_make_box_type_set__21_cfa_info(
	 (make_box_202_bglt) (obj_5143),
	 (type_bglt) (val1834_5144));
   }
}



/* pre-make-box-type */
type_bglt 
pre_make_box_type_57_cfa_info(make_box_202_bglt obj_160)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 85 */
      return
	 (((make_box_202_bglt) CREF(obj_160))->type);
   }
}



/* _pre-make-box-type2836 */
obj_t 
_pre_make_box_type2836_191_cfa_info(obj_t env_5145, obj_t obj_5146)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 85 */
      {		/* Cfa/cinfo.scm 85 */
	 type_bglt aux_6979;
	 aux_6979 =
	    pre_make_box_type_57_cfa_info(
	    (make_box_202_bglt) (obj_5146));
	 return
	    (obj_t) (aux_6979);
      }
   }
}



/* pre-make-box-side-effect?-set! */
obj_t 
pre_make_box_side_effect__set__136_cfa_info(make_box_202_bglt obj_161, obj_t val1835_162)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 632 */
      return
	 ((((make_box_202_bglt) CREF(obj_161))->side_effect__165) = ((obj_t) val1835_162), BUNSPEC);
   }
}



/* _pre-make-box-side-effect?-set!2837 */
obj_t 
_pre_make_box_side_effect__set_2837_191_cfa_info(obj_t env_5147, obj_t obj_5148, obj_t val1835_5149)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 632 */
      return
	 pre_make_box_side_effect__set__136_cfa_info(
	 (make_box_202_bglt) (obj_5148), val1835_5149);
   }
}



/* pre-make-box-side-effect? */
obj_t 
pre_make_box_side_effect__126_cfa_info(make_box_202_bglt obj_163)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 632 */
      return
	 (((make_box_202_bglt) CREF(obj_163))->side_effect__165);
   }
}



/* _pre-make-box-side-effect?2838 */
obj_t 
_pre_make_box_side_effect_2838_255_cfa_info(obj_t env_5150, obj_t obj_5151)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 632 */
      return
	 pre_make_box_side_effect__126_cfa_info(
	 (make_box_202_bglt) (obj_5151));
   }
}



/* pre-make-box-key-set! */
obj_t 
pre_make_box_key_set__46_cfa_info(make_box_202_bglt obj_164, obj_t val1836_165)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 636 */
      return
	 ((((make_box_202_bglt) CREF(obj_164))->key) = ((obj_t) val1836_165), BUNSPEC);
   }
}



/* _pre-make-box-key-set!2839 */
obj_t 
_pre_make_box_key_set_2839_81_cfa_info(obj_t env_5152, obj_t obj_5153, obj_t val1836_5154)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 636 */
      return
	 pre_make_box_key_set__46_cfa_info(
	 (make_box_202_bglt) (obj_5153), val1836_5154);
   }
}



/* pre-make-box-key */
obj_t 
pre_make_box_key_102_cfa_info(make_box_202_bglt obj_166)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 636 */
      return
	 (((make_box_202_bglt) CREF(obj_166))->key);
   }
}



/* _pre-make-box-key2840 */
obj_t 
_pre_make_box_key2840_195_cfa_info(obj_t env_5155, obj_t obj_5156)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 636 */
      return
	 pre_make_box_key_102_cfa_info(
	 (make_box_202_bglt) (obj_5156));
   }
}



/* pre-make-box-value-set! */
obj_t 
pre_make_box_value_set__57_cfa_info(make_box_202_bglt obj_167, node_bglt val1837_168)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 85 */
      return
	 ((((make_box_202_bglt) CREF(obj_167))->value) = ((node_bglt) val1837_168), BUNSPEC);
   }
}



/* _pre-make-box-value-set!2841 */
obj_t 
_pre_make_box_value_set_2841_45_cfa_info(obj_t env_5157, obj_t obj_5158, obj_t val1837_5159)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 85 */
      return
	 pre_make_box_value_set__57_cfa_info(
	 (make_box_202_bglt) (obj_5158),
	 (node_bglt) (val1837_5159));
   }
}



/* pre-make-box-value */
node_bglt 
pre_make_box_value_157_cfa_info(make_box_202_bglt obj_169)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 85 */
      return
	 (((make_box_202_bglt) CREF(obj_169))->value);
   }
}



/* _pre-make-box-value2842 */
obj_t 
_pre_make_box_value2842_59_cfa_info(obj_t env_5160, obj_t obj_5161)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 85 */
      {		/* Cfa/cinfo.scm 85 */
	 node_bglt aux_7000;
	 aux_7000 =
	    pre_make_box_value_157_cfa_info(
	    (make_box_202_bglt) (obj_5161));
	 return
	    (obj_t) (aux_7000);
      }
   }
}



/* allocate-jump-ex-it/cinfo */
jump_ex_it_184_bglt 
allocate_jump_ex_it_cinfo_167_cfa_info()
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 82 */
      {		/* Cfa/cinfo.scm 82 */
	 jump_ex_it_184_bglt new1827_1718;
	 new1827_1718 =
	    ((jump_ex_it_184_bglt) BREF(GC_MALLOC(sizeof(struct jump_ex_it_184))));
	 {	/* Cfa/cinfo.scm 82 */
	    long arg2290_1719;
	    arg2290_1719 =
	       class_num_218___object(jump_ex_it_cinfo_139_cfa_info);
	    {	/* Cfa/cinfo.scm 82 */
	       obj_t obj_3106;
	       obj_3106 =
		  (obj_t) (new1827_1718);
	       (((obj_t) CREF(obj_3106))->header = MAKE_HEADER(arg2290_1719, 0), BUNSPEC);
	    }
	 }
	 {	/* Cfa/cinfo.scm 82 */
	    object_bglt aux_7008;
	    aux_7008 =
	       (object_bglt) (new1827_1718);
	    OBJECT_WIDENING_SET(aux_7008, BFALSE);
	 }
	 return new1827_1718;
      }
   }
}



/* _allocate-jump-ex-it/cinfo */
obj_t 
_allocate_jump_ex_it_cinfo_34_cfa_info(obj_t env_4918)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 82 */
      {		/* Cfa/cinfo.scm 82 */
	 jump_ex_it_184_bglt aux_7011;
	 aux_7011 =
	    allocate_jump_ex_it_cinfo_167_cfa_info();
	 return
	    (obj_t) (aux_7011);
      }
   }
}



/* jump-ex-it/cinfo? */
bool_t 
jump_ex_it_cinfo__199_cfa_info(obj_t obj_173)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 82 */
      return
	 is_a__118___object(obj_173, jump_ex_it_cinfo_139_cfa_info);
   }
}



/* _jump-ex-it/cinfo? */
obj_t 
_jump_ex_it_cinfo__23_cfa_info(obj_t env_5162, obj_t obj_5163)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 82 */
      {		/* Cfa/cinfo.scm 82 */
	 bool_t aux_7015;
	 aux_7015 =
	    jump_ex_it_cinfo__199_cfa_info(obj_5163);
	 return
	    BBOOL(aux_7015);
      }
   }
}



/* widening-jump-ex-it/cinfo */
jump_ex_it_cinfo_139_bglt 
widening_jump_ex_it_cinfo_85_cfa_info(approx_bglt approx_174)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 82 */
      {		/* Cfa/cinfo.scm 82 */
	 jump_ex_it_cinfo_139_bglt new1822_3108;
	 new1822_3108 =
	    ((jump_ex_it_cinfo_139_bglt) BREF(GC_MALLOC(sizeof(struct jump_ex_it_cinfo_139))));
	 ((((jump_ex_it_cinfo_139_bglt) CREF(new1822_3108))->approx) = ((approx_bglt) approx_174), BUNSPEC);
	 return new1822_3108;
      }
   }
}



/* _widening-jump-ex-it/cinfo2843 */
obj_t 
_widening_jump_ex_it_cinfo2843_227_cfa_info(obj_t env_5164, obj_t approx_5165)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 82 */
      {		/* Cfa/cinfo.scm 82 */
	 jump_ex_it_cinfo_139_bglt aux_7020;
	 aux_7020 =
	    widening_jump_ex_it_cinfo_85_cfa_info(
	    (approx_bglt) (approx_5165));
	 return
	    (obj_t) (aux_7020);
      }
   }
}



/* make-jump-ex-it/cinfo */
jump_ex_it_cinfo_139_bglt 
make_jump_ex_it_cinfo_16_cfa_info(obj_t loc_175, type_bglt type_176, node_bglt exit_177, node_bglt value_178, approx_bglt approx_179)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 82 */
      {		/* Cfa/cinfo.scm 82 */
	 jump_ex_it_184_bglt aux1825_3110;
	 {	/* Cfa/cinfo.scm 82 */
	    jump_ex_it_184_bglt res2697_3126;
	    {	/* ./Ast/node.scm 753 */
	       jump_ex_it_184_bglt new1396_3118;
	       new1396_3118 =
		  ((jump_ex_it_184_bglt) BREF(GC_MALLOC(sizeof(struct jump_ex_it_184))));
	       {	/* ./Ast/node.scm 753 */
		  long arg2365_3119;
		  arg2365_3119 =
		     class_num_218___object(jump_ex_it_184_ast_node);
		  {	/* ./Ast/node.scm 753 */
		     obj_t obj_3124;
		     obj_3124 =
			(obj_t) (new1396_3118);
		     (((obj_t) CREF(obj_3124))->header = MAKE_HEADER(arg2365_3119, 0), BUNSPEC);
		  }
	       }
	       {	/* ./Ast/node.scm 753 */
		  object_bglt aux_7028;
		  aux_7028 =
		     (object_bglt) (new1396_3118);
		  OBJECT_WIDENING_SET(aux_7028, BFALSE);
	       }
	       ((((jump_ex_it_184_bglt) CREF(new1396_3118))->loc) = ((obj_t) loc_175), BUNSPEC);
	       ((((jump_ex_it_184_bglt) CREF(new1396_3118))->type) = ((type_bglt) type_176), BUNSPEC);
	       ((((jump_ex_it_184_bglt) CREF(new1396_3118))->exit) = ((node_bglt) exit_177), BUNSPEC);
	       ((((jump_ex_it_184_bglt) CREF(new1396_3118))->value) = ((node_bglt) value_178), BUNSPEC);
	       res2697_3126 = new1396_3118;
	    }
	    aux1825_3110 = res2697_3126;
	 }
	 {	/* Cfa/cinfo.scm 82 */
	    jump_ex_it_cinfo_139_bglt new1826_3111;
	    new1826_3111 =
	       ((jump_ex_it_cinfo_139_bglt) (aux1825_3110));
	    {	/* Cfa/cinfo.scm 82 */
	       long arg2291_3112;
	       arg2291_3112 =
		  class_num_218___object(jump_ex_it_cinfo_139_cfa_info);
	       {	/* Cfa/cinfo.scm 82 */
		  obj_t obj_3127;
		  obj_3127 =
		     (obj_t) (new1826_3111);
		  (((obj_t) CREF(obj_3127))->header = MAKE_HEADER(arg2291_3112, 0), BUNSPEC);
	       }
	    }
	    {	/* Cfa/cinfo.scm 82 */
	       jump_ex_it_cinfo_139_bglt arg2292_3113;
	       {	/* Cfa/cinfo.scm 82 */
		  jump_ex_it_cinfo_139_bglt res2698_3132;
		  {	/* Cfa/cinfo.scm 82 */
		     jump_ex_it_cinfo_139_bglt new1822_3130;
		     new1822_3130 =
			((jump_ex_it_cinfo_139_bglt) BREF(GC_MALLOC(sizeof(struct jump_ex_it_cinfo_139))));
		     ((((jump_ex_it_cinfo_139_bglt) CREF(new1822_3130))->approx) = ((approx_bglt) approx_179), BUNSPEC);
		     res2698_3132 = new1822_3130;
		  }
		  arg2292_3113 = res2698_3132;
	       }
	       {	/* Cfa/cinfo.scm 82 */
		  obj_t aux_7043;
		  object_bglt aux_7041;
		  aux_7043 =
		     (obj_t) (arg2292_3113);
		  aux_7041 =
		     (object_bglt) (new1826_3111);
		  OBJECT_WIDENING_SET(aux_7041, aux_7043);
	       }
	    }
	    return new1826_3111;
	 }
      }
   }
}



/* _make-jump-ex-it/cinfo2844 */
obj_t 
_make_jump_ex_it_cinfo2844_63_cfa_info(obj_t env_5166, obj_t loc_5167, obj_t type_5168, obj_t exit_5169, obj_t value_5170, obj_t approx_5171)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 82 */
      {		/* Cfa/cinfo.scm 82 */
	 jump_ex_it_cinfo_139_bglt aux_7046;
	 aux_7046 =
	    make_jump_ex_it_cinfo_16_cfa_info(loc_5167,
	    (type_bglt) (type_5168),
	    (node_bglt) (exit_5169),
	    (node_bglt) (value_5170),
	    (approx_bglt) (approx_5171));
	 return
	    (obj_t) (aux_7046);
      }
   }
}



/* jump-ex-it/cinfo-loc */
obj_t 
jump_ex_it_cinfo_loc_13_cfa_info(jump_ex_it_184_bglt obj_180)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 624 */
      return
	 (((jump_ex_it_184_bglt) CREF(obj_180))->loc);
   }
}



/* _jump-ex-it/cinfo-loc2845 */
obj_t 
_jump_ex_it_cinfo_loc2845_144_cfa_info(obj_t env_5172, obj_t obj_5173)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 624 */
      return
	 jump_ex_it_cinfo_loc_13_cfa_info(
	 (jump_ex_it_184_bglt) (obj_5173));
   }
}



/* jump-ex-it/cinfo-type-set! */
obj_t 
jump_ex_it_cinfo_type_set__231_cfa_info(jump_ex_it_184_bglt obj_181, type_bglt val1819_182)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 82 */
      return
	 ((((jump_ex_it_184_bglt) CREF(obj_181))->type) = ((type_bglt) val1819_182), BUNSPEC);
   }
}



/* _jump-ex-it/cinfo-type-set!2846 */
obj_t 
_jump_ex_it_cinfo_type_set_2846_233_cfa_info(obj_t env_5174, obj_t obj_5175, obj_t val1819_5176)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 82 */
      return
	 jump_ex_it_cinfo_type_set__231_cfa_info(
	 (jump_ex_it_184_bglt) (obj_5175),
	 (type_bglt) (val1819_5176));
   }
}



/* jump-ex-it/cinfo-type */
type_bglt 
jump_ex_it_cinfo_type_129_cfa_info(jump_ex_it_184_bglt obj_183)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 82 */
      return
	 (((jump_ex_it_184_bglt) CREF(obj_183))->type);
   }
}



/* _jump-ex-it/cinfo-type2847 */
obj_t 
_jump_ex_it_cinfo_type2847_201_cfa_info(obj_t env_5177, obj_t obj_5178)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 82 */
      {		/* Cfa/cinfo.scm 82 */
	 type_bglt aux_7061;
	 aux_7061 =
	    jump_ex_it_cinfo_type_129_cfa_info(
	    (jump_ex_it_184_bglt) (obj_5178));
	 return
	    (obj_t) (aux_7061);
      }
   }
}



/* jump-ex-it/cinfo-exit-set! */
obj_t 
jump_ex_it_cinfo_exit_set__81_cfa_info(jump_ex_it_184_bglt obj_184, node_bglt val1820_185)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 82 */
      return
	 ((((jump_ex_it_184_bglt) CREF(obj_184))->exit) = ((node_bglt) val1820_185), BUNSPEC);
   }
}



/* _jump-ex-it/cinfo-exit-set!2848 */
obj_t 
_jump_ex_it_cinfo_exit_set_2848_164_cfa_info(obj_t env_5179, obj_t obj_5180, obj_t val1820_5181)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 82 */
      return
	 jump_ex_it_cinfo_exit_set__81_cfa_info(
	 (jump_ex_it_184_bglt) (obj_5180),
	 (node_bglt) (val1820_5181));
   }
}



/* jump-ex-it/cinfo-exit */
node_bglt 
jump_ex_it_cinfo_exit_67_cfa_info(jump_ex_it_184_bglt obj_186)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 82 */
      return
	 (((jump_ex_it_184_bglt) CREF(obj_186))->exit);
   }
}



/* _jump-ex-it/cinfo-exit2849 */
obj_t 
_jump_ex_it_cinfo_exit2849_23_cfa_info(obj_t env_5182, obj_t obj_5183)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 82 */
      {		/* Cfa/cinfo.scm 82 */
	 node_bglt aux_7070;
	 aux_7070 =
	    jump_ex_it_cinfo_exit_67_cfa_info(
	    (jump_ex_it_184_bglt) (obj_5183));
	 return
	    (obj_t) (aux_7070);
      }
   }
}



/* jump-ex-it/cinfo-value-set! */
obj_t 
jump_ex_it_cinfo_value_set__150_cfa_info(jump_ex_it_184_bglt obj_187, node_bglt val1821_188)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 82 */
      return
	 ((((jump_ex_it_184_bglt) CREF(obj_187))->value) = ((node_bglt) val1821_188), BUNSPEC);
   }
}



/* _jump-ex-it/cinfo-value-set!2850 */
obj_t 
_jump_ex_it_cinfo_value_set_2850_59_cfa_info(obj_t env_5184, obj_t obj_5185, obj_t val1821_5186)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 82 */
      return
	 jump_ex_it_cinfo_value_set__150_cfa_info(
	 (jump_ex_it_184_bglt) (obj_5185),
	 (node_bglt) (val1821_5186));
   }
}



/* jump-ex-it/cinfo-value */
node_bglt 
jump_ex_it_cinfo_value_33_cfa_info(jump_ex_it_184_bglt obj_189)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 82 */
      return
	 (((jump_ex_it_184_bglt) CREF(obj_189))->value);
   }
}



/* _jump-ex-it/cinfo-value2851 */
obj_t 
_jump_ex_it_cinfo_value2851_45_cfa_info(obj_t env_5187, obj_t obj_5188)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 82 */
      {		/* Cfa/cinfo.scm 82 */
	 node_bglt aux_7079;
	 aux_7079 =
	    jump_ex_it_cinfo_value_33_cfa_info(
	    (jump_ex_it_184_bglt) (obj_5188));
	 return
	    (obj_t) (aux_7079);
      }
   }
}



/* jump-ex-it/cinfo-approx */
approx_bglt 
jump_ex_it_cinfo_approx_160_cfa_info(jump_ex_it_cinfo_139_bglt obj_190)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 82 */
      {
	 obj_t aux_7083;
	 {	/* Cfa/cinfo.scm 82 */
	    object_bglt aux_7084;
	    aux_7084 =
	       (object_bglt) (obj_190);
	    aux_7083 =
	       OBJECT_WIDENING(aux_7084);
	 }
	 return
	    (((jump_ex_it_cinfo_139_bglt) CREF(aux_7083))->approx);
      }
   }
}



/* _jump-ex-it/cinfo-approx2852 */
obj_t 
_jump_ex_it_cinfo_approx2852_36_cfa_info(obj_t env_5189, obj_t obj_5190)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 82 */
      {		/* Cfa/cinfo.scm 82 */
	 approx_bglt aux_7088;
	 aux_7088 =
	    jump_ex_it_cinfo_approx_160_cfa_info(
	    (jump_ex_it_cinfo_139_bglt) (obj_5190));
	 return
	    (obj_t) (aux_7088);
      }
   }
}



/* allocate-set-ex-it/cinfo */
set_ex_it_116_bglt 
allocate_set_ex_it_cinfo_32_cfa_info()
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 81 */
      {		/* Cfa/cinfo.scm 81 */
	 set_ex_it_116_bglt new1812_1726;
	 new1812_1726 =
	    ((set_ex_it_116_bglt) BREF(GC_MALLOC(sizeof(struct set_ex_it_116))));
	 {	/* Cfa/cinfo.scm 81 */
	    long arg2293_1727;
	    arg2293_1727 =
	       class_num_218___object(set_ex_it_cinfo_168_cfa_info);
	    {	/* Cfa/cinfo.scm 81 */
	       obj_t obj_3133;
	       obj_3133 =
		  (obj_t) (new1812_1726);
	       (((obj_t) CREF(obj_3133))->header = MAKE_HEADER(arg2293_1727, 0), BUNSPEC);
	    }
	 }
	 {	/* Cfa/cinfo.scm 81 */
	    object_bglt aux_7096;
	    aux_7096 =
	       (object_bglt) (new1812_1726);
	    OBJECT_WIDENING_SET(aux_7096, BFALSE);
	 }
	 return new1812_1726;
      }
   }
}



/* _allocate-set-ex-it/cinfo */
obj_t 
_allocate_set_ex_it_cinfo_22_cfa_info(obj_t env_4917)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 81 */
      {		/* Cfa/cinfo.scm 81 */
	 set_ex_it_116_bglt aux_7099;
	 aux_7099 =
	    allocate_set_ex_it_cinfo_32_cfa_info();
	 return
	    (obj_t) (aux_7099);
      }
   }
}



/* set-ex-it/cinfo? */
bool_t 
set_ex_it_cinfo__11_cfa_info(obj_t obj_194)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 81 */
      return
	 is_a__118___object(obj_194, set_ex_it_cinfo_168_cfa_info);
   }
}



/* _set-ex-it/cinfo? */
obj_t 
_set_ex_it_cinfo__175_cfa_info(obj_t env_5191, obj_t obj_5192)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 81 */
      {		/* Cfa/cinfo.scm 81 */
	 bool_t aux_7103;
	 aux_7103 =
	    set_ex_it_cinfo__11_cfa_info(obj_5192);
	 return
	    BBOOL(aux_7103);
      }
   }
}



/* widening-set-ex-it/cinfo */
set_ex_it_cinfo_168_bglt 
widening_set_ex_it_cinfo_59_cfa_info(approx_bglt approx_195)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 81 */
      {		/* Cfa/cinfo.scm 81 */
	 set_ex_it_cinfo_168_bglt new1807_3135;
	 new1807_3135 =
	    ((set_ex_it_cinfo_168_bglt) BREF(GC_MALLOC(sizeof(struct set_ex_it_cinfo_168))));
	 ((((set_ex_it_cinfo_168_bglt) CREF(new1807_3135))->approx) = ((approx_bglt) approx_195), BUNSPEC);
	 return new1807_3135;
      }
   }
}



/* _widening-set-ex-it/cinfo2853 */
obj_t 
_widening_set_ex_it_cinfo2853_220_cfa_info(obj_t env_5193, obj_t approx_5194)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 81 */
      {		/* Cfa/cinfo.scm 81 */
	 set_ex_it_cinfo_168_bglt aux_7108;
	 aux_7108 =
	    widening_set_ex_it_cinfo_59_cfa_info(
	    (approx_bglt) (approx_5194));
	 return
	    (obj_t) (aux_7108);
      }
   }
}



/* make-set-ex-it/cinfo */
set_ex_it_cinfo_168_bglt 
make_set_ex_it_cinfo_156_cfa_info(obj_t loc_196, type_bglt type_197, var_bglt var_198, node_bglt body_199, approx_bglt approx_200)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 81 */
      {		/* Cfa/cinfo.scm 81 */
	 set_ex_it_116_bglt aux1810_3137;
	 {	/* Cfa/cinfo.scm 81 */
	    set_ex_it_116_bglt res2699_3153;
	    {	/* ./Ast/node.scm 746 */
	       set_ex_it_116_bglt new1386_3145;
	       new1386_3145 =
		  ((set_ex_it_116_bglt) BREF(GC_MALLOC(sizeof(struct set_ex_it_116))));
	       {	/* ./Ast/node.scm 746 */
		  long arg2367_3146;
		  arg2367_3146 =
		     class_num_218___object(set_ex_it_116_ast_node);
		  {	/* ./Ast/node.scm 746 */
		     obj_t obj_3151;
		     obj_3151 =
			(obj_t) (new1386_3145);
		     (((obj_t) CREF(obj_3151))->header = MAKE_HEADER(arg2367_3146, 0), BUNSPEC);
		  }
	       }
	       {	/* ./Ast/node.scm 746 */
		  object_bglt aux_7116;
		  aux_7116 =
		     (object_bglt) (new1386_3145);
		  OBJECT_WIDENING_SET(aux_7116, BFALSE);
	       }
	       ((((set_ex_it_116_bglt) CREF(new1386_3145))->loc) = ((obj_t) loc_196), BUNSPEC);
	       ((((set_ex_it_116_bglt) CREF(new1386_3145))->type) = ((type_bglt) type_197), BUNSPEC);
	       ((((set_ex_it_116_bglt) CREF(new1386_3145))->var) = ((var_bglt) var_198), BUNSPEC);
	       ((((set_ex_it_116_bglt) CREF(new1386_3145))->body) = ((node_bglt) body_199), BUNSPEC);
	       res2699_3153 = new1386_3145;
	    }
	    aux1810_3137 = res2699_3153;
	 }
	 {	/* Cfa/cinfo.scm 81 */
	    set_ex_it_cinfo_168_bglt new1811_3138;
	    new1811_3138 =
	       ((set_ex_it_cinfo_168_bglt) (aux1810_3137));
	    {	/* Cfa/cinfo.scm 81 */
	       long arg2294_3139;
	       arg2294_3139 =
		  class_num_218___object(set_ex_it_cinfo_168_cfa_info);
	       {	/* Cfa/cinfo.scm 81 */
		  obj_t obj_3154;
		  obj_3154 =
		     (obj_t) (new1811_3138);
		  (((obj_t) CREF(obj_3154))->header = MAKE_HEADER(arg2294_3139, 0), BUNSPEC);
	       }
	    }
	    {	/* Cfa/cinfo.scm 81 */
	       set_ex_it_cinfo_168_bglt arg2295_3140;
	       {	/* Cfa/cinfo.scm 81 */
		  set_ex_it_cinfo_168_bglt res2700_3159;
		  {	/* Cfa/cinfo.scm 81 */
		     set_ex_it_cinfo_168_bglt new1807_3157;
		     new1807_3157 =
			((set_ex_it_cinfo_168_bglt) BREF(GC_MALLOC(sizeof(struct set_ex_it_cinfo_168))));
		     ((((set_ex_it_cinfo_168_bglt) CREF(new1807_3157))->approx) = ((approx_bglt) approx_200), BUNSPEC);
		     res2700_3159 = new1807_3157;
		  }
		  arg2295_3140 = res2700_3159;
	       }
	       {	/* Cfa/cinfo.scm 81 */
		  obj_t aux_7131;
		  object_bglt aux_7129;
		  aux_7131 =
		     (obj_t) (arg2295_3140);
		  aux_7129 =
		     (object_bglt) (new1811_3138);
		  OBJECT_WIDENING_SET(aux_7129, aux_7131);
	       }
	    }
	    return new1811_3138;
	 }
      }
   }
}



/* _make-set-ex-it/cinfo2854 */
obj_t 
_make_set_ex_it_cinfo2854_65_cfa_info(obj_t env_5195, obj_t loc_5196, obj_t type_5197, obj_t var_5198, obj_t body_5199, obj_t approx_5200)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 81 */
      {		/* Cfa/cinfo.scm 81 */
	 set_ex_it_cinfo_168_bglt aux_7134;
	 aux_7134 =
	    make_set_ex_it_cinfo_156_cfa_info(loc_5196,
	    (type_bglt) (type_5197),
	    (var_bglt) (var_5198),
	    (node_bglt) (body_5199),
	    (approx_bglt) (approx_5200));
	 return
	    (obj_t) (aux_7134);
      }
   }
}



/* set-ex-it/cinfo-loc */
obj_t 
set_ex_it_cinfo_loc_59_cfa_info(set_ex_it_116_bglt obj_201)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 624 */
      return
	 (((set_ex_it_116_bglt) CREF(obj_201))->loc);
   }
}



/* _set-ex-it/cinfo-loc2855 */
obj_t 
_set_ex_it_cinfo_loc2855_151_cfa_info(obj_t env_5201, obj_t obj_5202)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 624 */
      return
	 set_ex_it_cinfo_loc_59_cfa_info(
	 (set_ex_it_116_bglt) (obj_5202));
   }
}



/* set-ex-it/cinfo-type-set! */
obj_t 
set_ex_it_cinfo_type_set__35_cfa_info(set_ex_it_116_bglt obj_202, type_bglt val1804_203)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 81 */
      return
	 ((((set_ex_it_116_bglt) CREF(obj_202))->type) = ((type_bglt) val1804_203), BUNSPEC);
   }
}



/* _set-ex-it/cinfo-type-set!2856 */
obj_t 
_set_ex_it_cinfo_type_set_2856_16_cfa_info(obj_t env_5203, obj_t obj_5204, obj_t val1804_5205)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 81 */
      return
	 set_ex_it_cinfo_type_set__35_cfa_info(
	 (set_ex_it_116_bglt) (obj_5204),
	 (type_bglt) (val1804_5205));
   }
}



/* set-ex-it/cinfo-type */
type_bglt 
set_ex_it_cinfo_type_68_cfa_info(set_ex_it_116_bglt obj_204)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 81 */
      return
	 (((set_ex_it_116_bglt) CREF(obj_204))->type);
   }
}



/* _set-ex-it/cinfo-type2857 */
obj_t 
_set_ex_it_cinfo_type2857_188_cfa_info(obj_t env_5206, obj_t obj_5207)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 81 */
      {		/* Cfa/cinfo.scm 81 */
	 type_bglt aux_7149;
	 aux_7149 =
	    set_ex_it_cinfo_type_68_cfa_info(
	    (set_ex_it_116_bglt) (obj_5207));
	 return
	    (obj_t) (aux_7149);
      }
   }
}



/* set-ex-it/cinfo-var-set! */
obj_t 
set_ex_it_cinfo_var_set__245_cfa_info(set_ex_it_116_bglt obj_205, var_bglt val1805_206)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 81 */
      return
	 ((((set_ex_it_116_bglt) CREF(obj_205))->var) = ((var_bglt) val1805_206), BUNSPEC);
   }
}



/* _set-ex-it/cinfo-var-set!2858 */
obj_t 
_set_ex_it_cinfo_var_set_2858_160_cfa_info(obj_t env_5208, obj_t obj_5209, obj_t val1805_5210)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 81 */
      return
	 set_ex_it_cinfo_var_set__245_cfa_info(
	 (set_ex_it_116_bglt) (obj_5209),
	 (var_bglt) (val1805_5210));
   }
}



/* set-ex-it/cinfo-var */
var_bglt 
set_ex_it_cinfo_var_14_cfa_info(set_ex_it_116_bglt obj_207)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 81 */
      return
	 (((set_ex_it_116_bglt) CREF(obj_207))->var);
   }
}



/* _set-ex-it/cinfo-var2859 */
obj_t 
_set_ex_it_cinfo_var2859_52_cfa_info(obj_t env_5211, obj_t obj_5212)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 81 */
      {		/* Cfa/cinfo.scm 81 */
	 var_bglt aux_7158;
	 aux_7158 =
	    set_ex_it_cinfo_var_14_cfa_info(
	    (set_ex_it_116_bglt) (obj_5212));
	 return
	    (obj_t) (aux_7158);
      }
   }
}



/* set-ex-it/cinfo-body-set! */
obj_t 
set_ex_it_cinfo_body_set__25_cfa_info(set_ex_it_116_bglt obj_208, node_bglt val1806_209)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 81 */
      return
	 ((((set_ex_it_116_bglt) CREF(obj_208))->body) = ((node_bglt) val1806_209), BUNSPEC);
   }
}



/* _set-ex-it/cinfo-body-set!2860 */
obj_t 
_set_ex_it_cinfo_body_set_2860_199_cfa_info(obj_t env_5213, obj_t obj_5214, obj_t val1806_5215)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 81 */
      return
	 set_ex_it_cinfo_body_set__25_cfa_info(
	 (set_ex_it_116_bglt) (obj_5214),
	 (node_bglt) (val1806_5215));
   }
}



/* set-ex-it/cinfo-body */
node_bglt 
set_ex_it_cinfo_body_103_cfa_info(set_ex_it_116_bglt obj_210)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 81 */
      return
	 (((set_ex_it_116_bglt) CREF(obj_210))->body);
   }
}



/* _set-ex-it/cinfo-body2861 */
obj_t 
_set_ex_it_cinfo_body2861_99_cfa_info(obj_t env_5216, obj_t obj_5217)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 81 */
      {		/* Cfa/cinfo.scm 81 */
	 node_bglt aux_7167;
	 aux_7167 =
	    set_ex_it_cinfo_body_103_cfa_info(
	    (set_ex_it_116_bglt) (obj_5217));
	 return
	    (obj_t) (aux_7167);
      }
   }
}



/* set-ex-it/cinfo-approx */
approx_bglt 
set_ex_it_cinfo_approx_28_cfa_info(set_ex_it_cinfo_168_bglt obj_211)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 81 */
      {
	 obj_t aux_7171;
	 {	/* Cfa/cinfo.scm 81 */
	    object_bglt aux_7172;
	    aux_7172 =
	       (object_bglt) (obj_211);
	    aux_7171 =
	       OBJECT_WIDENING(aux_7172);
	 }
	 return
	    (((set_ex_it_cinfo_168_bglt) CREF(aux_7171))->approx);
      }
   }
}



/* _set-ex-it/cinfo-approx2862 */
obj_t 
_set_ex_it_cinfo_approx2862_120_cfa_info(obj_t env_5218, obj_t obj_5219)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 81 */
      {		/* Cfa/cinfo.scm 81 */
	 approx_bglt aux_7176;
	 aux_7176 =
	    set_ex_it_cinfo_approx_28_cfa_info(
	    (set_ex_it_cinfo_168_bglt) (obj_5219));
	 return
	    (obj_t) (aux_7176);
      }
   }
}



/* allocate-select/cinfo */
select_bglt 
allocate_select_cinfo_105_cfa_info()
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 80 */
      {		/* Cfa/cinfo.scm 80 */
	 select_bglt new1797_1734;
	 new1797_1734 =
	    ((select_bglt) BREF(GC_MALLOC(sizeof(struct select))));
	 {	/* Cfa/cinfo.scm 80 */
	    long arg2296_1735;
	    arg2296_1735 =
	       class_num_218___object(select_cinfo_150_cfa_info);
	    {	/* Cfa/cinfo.scm 80 */
	       obj_t obj_3160;
	       obj_3160 =
		  (obj_t) (new1797_1734);
	       (((obj_t) CREF(obj_3160))->header = MAKE_HEADER(arg2296_1735, 0), BUNSPEC);
	    }
	 }
	 {	/* Cfa/cinfo.scm 80 */
	    object_bglt aux_7184;
	    aux_7184 =
	       (object_bglt) (new1797_1734);
	    OBJECT_WIDENING_SET(aux_7184, BFALSE);
	 }
	 return new1797_1734;
      }
   }
}



/* _allocate-select/cinfo */
obj_t 
_allocate_select_cinfo_74_cfa_info(obj_t env_4916)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 80 */
      {		/* Cfa/cinfo.scm 80 */
	 select_bglt aux_7187;
	 aux_7187 =
	    allocate_select_cinfo_105_cfa_info();
	 return
	    (obj_t) (aux_7187);
      }
   }
}



/* select/cinfo? */
bool_t 
select_cinfo__151_cfa_info(obj_t obj_215)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 80 */
      return
	 is_a__118___object(obj_215, select_cinfo_150_cfa_info);
   }
}



/* _select/cinfo? */
obj_t 
_select_cinfo__186_cfa_info(obj_t env_5220, obj_t obj_5221)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 80 */
      {		/* Cfa/cinfo.scm 80 */
	 bool_t aux_7191;
	 aux_7191 =
	    select_cinfo__151_cfa_info(obj_5221);
	 return
	    BBOOL(aux_7191);
      }
   }
}



/* widening-select/cinfo */
select_cinfo_150_bglt 
widening_select_cinfo_152_cfa_info(approx_bglt approx_216)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 80 */
      {		/* Cfa/cinfo.scm 80 */
	 select_cinfo_150_bglt new1792_3162;
	 new1792_3162 =
	    ((select_cinfo_150_bglt) BREF(GC_MALLOC(sizeof(struct select_cinfo_150))));
	 ((((select_cinfo_150_bglt) CREF(new1792_3162))->approx) = ((approx_bglt) approx_216), BUNSPEC);
	 return new1792_3162;
      }
   }
}



/* _widening-select/cinfo2863 */
obj_t 
_widening_select_cinfo2863_4_cfa_info(obj_t env_5222, obj_t approx_5223)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 80 */
      {		/* Cfa/cinfo.scm 80 */
	 select_cinfo_150_bglt aux_7196;
	 aux_7196 =
	    widening_select_cinfo_152_cfa_info(
	    (approx_bglt) (approx_5223));
	 return
	    (obj_t) (aux_7196);
      }
   }
}



/* make-select/cinfo */
select_cinfo_150_bglt 
make_select_cinfo_178_cfa_info(obj_t loc_217, type_bglt type_218, obj_t side_effect__165_219, obj_t key_220, node_bglt test_221, obj_t clauses_222, type_bglt item_type_130_223, approx_bglt approx_224)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 80 */
      {		/* Cfa/cinfo.scm 80 */
	 select_bglt aux1795_3164;
	 {	/* Cfa/cinfo.scm 80 */
	    select_bglt res2701_3186;
	    {	/* ./Ast/node.scm 721 */
	       select_bglt new1343_3175;
	       new1343_3175 =
		  ((select_bglt) BREF(GC_MALLOC(sizeof(struct select))));
	       {	/* ./Ast/node.scm 721 */
		  long arg2373_3176;
		  arg2373_3176 =
		     class_num_218___object(select_ast_node);
		  {	/* ./Ast/node.scm 721 */
		     obj_t obj_3184;
		     obj_3184 =
			(obj_t) (new1343_3175);
		     (((obj_t) CREF(obj_3184))->header = MAKE_HEADER(arg2373_3176, 0), BUNSPEC);
		  }
	       }
	       {	/* ./Ast/node.scm 721 */
		  object_bglt aux_7204;
		  aux_7204 =
		     (object_bglt) (new1343_3175);
		  OBJECT_WIDENING_SET(aux_7204, BFALSE);
	       }
	       ((((select_bglt) CREF(new1343_3175))->loc) = ((obj_t) loc_217), BUNSPEC);
	       ((((select_bglt) CREF(new1343_3175))->type) = ((type_bglt) type_218), BUNSPEC);
	       ((((select_bglt) CREF(new1343_3175))->side_effect__165) = ((obj_t) side_effect__165_219), BUNSPEC);
	       ((((select_bglt) CREF(new1343_3175))->key) = ((obj_t) key_220), BUNSPEC);
	       ((((select_bglt) CREF(new1343_3175))->test) = ((node_bglt) test_221), BUNSPEC);
	       ((((select_bglt) CREF(new1343_3175))->clauses) = ((obj_t) clauses_222), BUNSPEC);
	       ((((select_bglt) CREF(new1343_3175))->item_type_130) = ((type_bglt) item_type_130_223), BUNSPEC);
	       res2701_3186 = new1343_3175;
	    }
	    aux1795_3164 = res2701_3186;
	 }
	 {	/* Cfa/cinfo.scm 80 */
	    select_cinfo_150_bglt new1796_3165;
	    new1796_3165 =
	       ((select_cinfo_150_bglt) (aux1795_3164));
	    {	/* Cfa/cinfo.scm 80 */
	       long arg2297_3166;
	       arg2297_3166 =
		  class_num_218___object(select_cinfo_150_cfa_info);
	       {	/* Cfa/cinfo.scm 80 */
		  obj_t obj_3187;
		  obj_3187 =
		     (obj_t) (new1796_3165);
		  (((obj_t) CREF(obj_3187))->header = MAKE_HEADER(arg2297_3166, 0), BUNSPEC);
	       }
	    }
	    {	/* Cfa/cinfo.scm 80 */
	       select_cinfo_150_bglt arg2298_3167;
	       {	/* Cfa/cinfo.scm 80 */
		  select_cinfo_150_bglt res2702_3192;
		  {	/* Cfa/cinfo.scm 80 */
		     select_cinfo_150_bglt new1792_3190;
		     new1792_3190 =
			((select_cinfo_150_bglt) BREF(GC_MALLOC(sizeof(struct select_cinfo_150))));
		     ((((select_cinfo_150_bglt) CREF(new1792_3190))->approx) = ((approx_bglt) approx_224), BUNSPEC);
		     res2702_3192 = new1792_3190;
		  }
		  arg2298_3167 = res2702_3192;
	       }
	       {	/* Cfa/cinfo.scm 80 */
		  obj_t aux_7222;
		  object_bglt aux_7220;
		  aux_7222 =
		     (obj_t) (arg2298_3167);
		  aux_7220 =
		     (object_bglt) (new1796_3165);
		  OBJECT_WIDENING_SET(aux_7220, aux_7222);
	       }
	    }
	    return new1796_3165;
	 }
      }
   }
}



/* _make-select/cinfo2864 */
obj_t 
_make_select_cinfo2864_67_cfa_info(obj_t env_5224, obj_t loc_5225, obj_t type_5226, obj_t side_effect__165_5227, obj_t key_5228, obj_t test_5229, obj_t clauses_5230, obj_t item_type_130_5231, obj_t approx_5232)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 80 */
      {		/* Cfa/cinfo.scm 80 */
	 select_cinfo_150_bglt aux_7225;
	 aux_7225 =
	    make_select_cinfo_178_cfa_info(loc_5225,
	    (type_bglt) (type_5226), side_effect__165_5227, key_5228,
	    (node_bglt) (test_5229), clauses_5230,
	    (type_bglt) (item_type_130_5231),
	    (approx_bglt) (approx_5232));
	 return
	    (obj_t) (aux_7225);
      }
   }
}



/* select/cinfo-loc */
obj_t 
select_cinfo_loc_246_cfa_info(select_bglt obj_225)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 624 */
      return
	 (((select_bglt) CREF(obj_225))->loc);
   }
}



/* _select/cinfo-loc2865 */
obj_t 
_select_cinfo_loc2865_85_cfa_info(obj_t env_5233, obj_t obj_5234)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 624 */
      return
	 select_cinfo_loc_246_cfa_info(
	 (select_bglt) (obj_5234));
   }
}



/* select/cinfo-type-set! */
obj_t 
select_cinfo_type_set__83_cfa_info(select_bglt obj_226, type_bglt val1788_227)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 80 */
      return
	 ((((select_bglt) CREF(obj_226))->type) = ((type_bglt) val1788_227), BUNSPEC);
   }
}



/* _select/cinfo-type-set!2866 */
obj_t 
_select_cinfo_type_set_2866_85_cfa_info(obj_t env_5235, obj_t obj_5236, obj_t val1788_5237)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 80 */
      return
	 select_cinfo_type_set__83_cfa_info(
	 (select_bglt) (obj_5236),
	 (type_bglt) (val1788_5237));
   }
}



/* select/cinfo-type */
type_bglt 
select_cinfo_type_249_cfa_info(select_bglt obj_228)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 80 */
      return
	 (((select_bglt) CREF(obj_228))->type);
   }
}



/* _select/cinfo-type2867 */
obj_t 
_select_cinfo_type2867_136_cfa_info(obj_t env_5238, obj_t obj_5239)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 80 */
      {		/* Cfa/cinfo.scm 80 */
	 type_bglt aux_7240;
	 aux_7240 =
	    select_cinfo_type_249_cfa_info(
	    (select_bglt) (obj_5239));
	 return
	    (obj_t) (aux_7240);
      }
   }
}



/* select/cinfo-side-effect?-set! */
obj_t 
select_cinfo_side_effect__set__150_cfa_info(select_bglt obj_229, obj_t val1789_230)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 632 */
      return
	 ((((select_bglt) CREF(obj_229))->side_effect__165) = ((obj_t) val1789_230), BUNSPEC);
   }
}



/* _select/cinfo-side-effect?-set!2868 */
obj_t 
_select_cinfo_side_effect__set_2868_197_cfa_info(obj_t env_5240, obj_t obj_5241, obj_t val1789_5242)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 632 */
      return
	 select_cinfo_side_effect__set__150_cfa_info(
	 (select_bglt) (obj_5241), val1789_5242);
   }
}



/* select/cinfo-side-effect? */
obj_t 
select_cinfo_side_effect__33_cfa_info(select_bglt obj_231)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 632 */
      return
	 (((select_bglt) CREF(obj_231))->side_effect__165);
   }
}



/* _select/cinfo-side-effect?2869 */
obj_t 
_select_cinfo_side_effect_2869_172_cfa_info(obj_t env_5243, obj_t obj_5244)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 632 */
      return
	 select_cinfo_side_effect__33_cfa_info(
	 (select_bglt) (obj_5244));
   }
}



/* select/cinfo-key-set! */
obj_t 
select_cinfo_key_set__126_cfa_info(select_bglt obj_232, obj_t val1790_233)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 636 */
      return
	 ((((select_bglt) CREF(obj_232))->key) = ((obj_t) val1790_233), BUNSPEC);
   }
}



/* _select/cinfo-key-set! */
obj_t 
_select_cinfo_key_set__141_cfa_info(obj_t env_5245, obj_t obj_5246, obj_t val1790_5247)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 636 */
      return
	 select_cinfo_key_set__126_cfa_info(
	 (select_bglt) (obj_5246), val1790_5247);
   }
}



/* select/cinfo-key */
obj_t 
select_cinfo_key_178_cfa_info(select_bglt obj_234)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 636 */
      return
	 (((select_bglt) CREF(obj_234))->key);
   }
}



/* _select/cinfo-key */
obj_t 
_select_cinfo_key_1_cfa_info(obj_t env_5248, obj_t obj_5249)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 636 */
      return
	 select_cinfo_key_178_cfa_info(
	 (select_bglt) (obj_5249));
   }
}



/* select/cinfo-test-set! */
obj_t 
select_cinfo_test_set__246_cfa_info(select_bglt obj_235, node_bglt val1791_236)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 80 */
      return
	 ((((select_bglt) CREF(obj_235))->test) = ((node_bglt) val1791_236), BUNSPEC);
   }
}



/* _select/cinfo-test-set!2870 */
obj_t 
_select_cinfo_test_set_2870_225_cfa_info(obj_t env_5250, obj_t obj_5251, obj_t val1791_5252)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 80 */
      return
	 select_cinfo_test_set__246_cfa_info(
	 (select_bglt) (obj_5251),
	 (node_bglt) (val1791_5252));
   }
}



/* select/cinfo-test */
node_bglt 
select_cinfo_test_124_cfa_info(select_bglt obj_237)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 80 */
      return
	 (((select_bglt) CREF(obj_237))->test);
   }
}



/* _select/cinfo-test2871 */
obj_t 
_select_cinfo_test2871_18_cfa_info(obj_t env_5253, obj_t obj_5254)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 80 */
      {		/* Cfa/cinfo.scm 80 */
	 node_bglt aux_7261;
	 aux_7261 =
	    select_cinfo_test_124_cfa_info(
	    (select_bglt) (obj_5254));
	 return
	    (obj_t) (aux_7261);
      }
   }
}



/* select/cinfo-clauses */
obj_t 
select_cinfo_clauses_111_cfa_info(select_bglt obj_238)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 725 */
      return
	 (((select_bglt) CREF(obj_238))->clauses);
   }
}



/* _select/cinfo-clauses2872 */
obj_t 
_select_cinfo_clauses2872_12_cfa_info(obj_t env_5255, obj_t obj_5256)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 725 */
      return
	 select_cinfo_clauses_111_cfa_info(
	 (select_bglt) (obj_5256));
   }
}



/* select/cinfo-item-type */
type_bglt 
select_cinfo_item_type_151_cfa_info(select_bglt obj_239)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 727 */
      return
	 (((select_bglt) CREF(obj_239))->item_type_130);
   }
}



/* _select/cinfo-item-type2873 */
obj_t 
_select_cinfo_item_type2873_27_cfa_info(obj_t env_5257, obj_t obj_5258)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 727 */
      {		/* ./Ast/node.scm 727 */
	 type_bglt aux_7269;
	 aux_7269 =
	    select_cinfo_item_type_151_cfa_info(
	    (select_bglt) (obj_5258));
	 return
	    (obj_t) (aux_7269);
      }
   }
}



/* select/cinfo-approx */
approx_bglt 
select_cinfo_approx_174_cfa_info(select_cinfo_150_bglt obj_240)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 80 */
      {
	 obj_t aux_7273;
	 {	/* Cfa/cinfo.scm 80 */
	    object_bglt aux_7274;
	    aux_7274 =
	       (object_bglt) (obj_240);
	    aux_7273 =
	       OBJECT_WIDENING(aux_7274);
	 }
	 return
	    (((select_cinfo_150_bglt) CREF(aux_7273))->approx);
      }
   }
}



/* _select/cinfo-approx2874 */
obj_t 
_select_cinfo_approx2874_228_cfa_info(obj_t env_5259, obj_t obj_5260)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 80 */
      {		/* Cfa/cinfo.scm 80 */
	 approx_bglt aux_7278;
	 aux_7278 =
	    select_cinfo_approx_174_cfa_info(
	    (select_cinfo_150_bglt) (obj_5260));
	 return
	    (obj_t) (aux_7278);
      }
   }
}



/* allocate-fail/cinfo */
fail_bglt 
allocate_fail_cinfo_138_cfa_info()
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 79 */
      {		/* Cfa/cinfo.scm 79 */
	 fail_bglt new1781_1742;
	 new1781_1742 =
	    ((fail_bglt) BREF(GC_MALLOC(sizeof(struct fail))));
	 {	/* Cfa/cinfo.scm 79 */
	    long arg2299_1743;
	    arg2299_1743 =
	       class_num_218___object(fail_cinfo_75_cfa_info);
	    {	/* Cfa/cinfo.scm 79 */
	       obj_t obj_3193;
	       obj_3193 =
		  (obj_t) (new1781_1742);
	       (((obj_t) CREF(obj_3193))->header = MAKE_HEADER(arg2299_1743, 0), BUNSPEC);
	    }
	 }
	 {	/* Cfa/cinfo.scm 79 */
	    object_bglt aux_7286;
	    aux_7286 =
	       (object_bglt) (new1781_1742);
	    OBJECT_WIDENING_SET(aux_7286, BFALSE);
	 }
	 return new1781_1742;
      }
   }
}



/* _allocate-fail/cinfo */
obj_t 
_allocate_fail_cinfo_247_cfa_info(obj_t env_4915)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 79 */
      {		/* Cfa/cinfo.scm 79 */
	 fail_bglt aux_7289;
	 aux_7289 =
	    allocate_fail_cinfo_138_cfa_info();
	 return
	    (obj_t) (aux_7289);
      }
   }
}



/* fail/cinfo? */
bool_t 
fail_cinfo__175_cfa_info(obj_t obj_244)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 79 */
      return
	 is_a__118___object(obj_244, fail_cinfo_75_cfa_info);
   }
}



/* _fail/cinfo? */
obj_t 
_fail_cinfo__61_cfa_info(obj_t env_5261, obj_t obj_5262)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 79 */
      {		/* Cfa/cinfo.scm 79 */
	 bool_t aux_7293;
	 aux_7293 =
	    fail_cinfo__175_cfa_info(obj_5262);
	 return
	    BBOOL(aux_7293);
      }
   }
}



/* widening-fail/cinfo */
fail_cinfo_75_bglt 
widening_fail_cinfo_81_cfa_info(approx_bglt approx_245)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 79 */
      {		/* Cfa/cinfo.scm 79 */
	 fail_cinfo_75_bglt new1776_3195;
	 new1776_3195 =
	    ((fail_cinfo_75_bglt) BREF(GC_MALLOC(sizeof(struct fail_cinfo_75))));
	 ((((fail_cinfo_75_bglt) CREF(new1776_3195))->approx) = ((approx_bglt) approx_245), BUNSPEC);
	 return new1776_3195;
      }
   }
}



/* _widening-fail/cinfo2875 */
obj_t 
_widening_fail_cinfo2875_121_cfa_info(obj_t env_5263, obj_t approx_5264)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 79 */
      {		/* Cfa/cinfo.scm 79 */
	 fail_cinfo_75_bglt aux_7298;
	 aux_7298 =
	    widening_fail_cinfo_81_cfa_info(
	    (approx_bglt) (approx_5264));
	 return
	    (obj_t) (aux_7298);
      }
   }
}



/* make-fail/cinfo */
fail_cinfo_75_bglt 
make_fail_cinfo_148_cfa_info(obj_t loc_246, type_bglt type_247, node_bglt proc_248, node_bglt msg_249, node_bglt obj_250, approx_bglt approx_251)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 79 */
      {		/* Cfa/cinfo.scm 79 */
	 fail_bglt aux1779_3197;
	 {	/* Cfa/cinfo.scm 79 */
	    fail_bglt res2703_3215;
	    {	/* ./Ast/node.scm 714 */
	       fail_bglt new1331_3206;
	       new1331_3206 =
		  ((fail_bglt) BREF(GC_MALLOC(sizeof(struct fail))));
	       {	/* ./Ast/node.scm 714 */
		  long arg2375_3207;
		  arg2375_3207 =
		     class_num_218___object(fail_ast_node);
		  {	/* ./Ast/node.scm 714 */
		     obj_t obj_3213;
		     obj_3213 =
			(obj_t) (new1331_3206);
		     (((obj_t) CREF(obj_3213))->header = MAKE_HEADER(arg2375_3207, 0), BUNSPEC);
		  }
	       }
	       {	/* ./Ast/node.scm 714 */
		  object_bglt aux_7306;
		  aux_7306 =
		     (object_bglt) (new1331_3206);
		  OBJECT_WIDENING_SET(aux_7306, BFALSE);
	       }
	       ((((fail_bglt) CREF(new1331_3206))->loc) = ((obj_t) loc_246), BUNSPEC);
	       ((((fail_bglt) CREF(new1331_3206))->type) = ((type_bglt) type_247), BUNSPEC);
	       ((((fail_bglt) CREF(new1331_3206))->proc) = ((node_bglt) proc_248), BUNSPEC);
	       ((((fail_bglt) CREF(new1331_3206))->msg) = ((node_bglt) msg_249), BUNSPEC);
	       ((((fail_bglt) CREF(new1331_3206))->obj) = ((node_bglt) obj_250), BUNSPEC);
	       res2703_3215 = new1331_3206;
	    }
	    aux1779_3197 = res2703_3215;
	 }
	 {	/* Cfa/cinfo.scm 79 */
	    fail_cinfo_75_bglt new1780_3198;
	    new1780_3198 =
	       ((fail_cinfo_75_bglt) (aux1779_3197));
	    {	/* Cfa/cinfo.scm 79 */
	       long arg2300_3199;
	       arg2300_3199 =
		  class_num_218___object(fail_cinfo_75_cfa_info);
	       {	/* Cfa/cinfo.scm 79 */
		  obj_t obj_3216;
		  obj_3216 =
		     (obj_t) (new1780_3198);
		  (((obj_t) CREF(obj_3216))->header = MAKE_HEADER(arg2300_3199, 0), BUNSPEC);
	       }
	    }
	    {	/* Cfa/cinfo.scm 79 */
	       fail_cinfo_75_bglt arg2301_3200;
	       {	/* Cfa/cinfo.scm 79 */
		  fail_cinfo_75_bglt res2704_3221;
		  {	/* Cfa/cinfo.scm 79 */
		     fail_cinfo_75_bglt new1776_3219;
		     new1776_3219 =
			((fail_cinfo_75_bglt) BREF(GC_MALLOC(sizeof(struct fail_cinfo_75))));
		     ((((fail_cinfo_75_bglt) CREF(new1776_3219))->approx) = ((approx_bglt) approx_251), BUNSPEC);
		     res2704_3221 = new1776_3219;
		  }
		  arg2301_3200 = res2704_3221;
	       }
	       {	/* Cfa/cinfo.scm 79 */
		  obj_t aux_7322;
		  object_bglt aux_7320;
		  aux_7322 =
		     (obj_t) (arg2301_3200);
		  aux_7320 =
		     (object_bglt) (new1780_3198);
		  OBJECT_WIDENING_SET(aux_7320, aux_7322);
	       }
	    }
	    return new1780_3198;
	 }
      }
   }
}



/* _make-fail/cinfo2876 */
obj_t 
_make_fail_cinfo2876_73_cfa_info(obj_t env_5265, obj_t loc_5266, obj_t type_5267, obj_t proc_5268, obj_t msg_5269, obj_t obj_5270, obj_t approx_5271)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 79 */
      {		/* Cfa/cinfo.scm 79 */
	 fail_cinfo_75_bglt aux_7325;
	 aux_7325 =
	    make_fail_cinfo_148_cfa_info(loc_5266,
	    (type_bglt) (type_5267),
	    (node_bglt) (proc_5268),
	    (node_bglt) (msg_5269),
	    (node_bglt) (obj_5270),
	    (approx_bglt) (approx_5271));
	 return
	    (obj_t) (aux_7325);
      }
   }
}



/* fail/cinfo-loc */
obj_t 
fail_cinfo_loc_64_cfa_info(fail_bglt obj_252)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 624 */
      return
	 (((fail_bglt) CREF(obj_252))->loc);
   }
}



/* _fail/cinfo-loc2877 */
obj_t 
_fail_cinfo_loc2877_16_cfa_info(obj_t env_5272, obj_t obj_5273)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 624 */
      return
	 fail_cinfo_loc_64_cfa_info(
	 (fail_bglt) (obj_5273));
   }
}



/* fail/cinfo-type-set! */
obj_t 
fail_cinfo_type_set__85_cfa_info(fail_bglt obj_253, type_bglt val1772_254)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 79 */
      return
	 ((((fail_bglt) CREF(obj_253))->type) = ((type_bglt) val1772_254), BUNSPEC);
   }
}



/* _fail/cinfo-type-set!2878 */
obj_t 
_fail_cinfo_type_set_2878_61_cfa_info(obj_t env_5274, obj_t obj_5275, obj_t val1772_5276)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 79 */
      return
	 fail_cinfo_type_set__85_cfa_info(
	 (fail_bglt) (obj_5275),
	 (type_bglt) (val1772_5276));
   }
}



/* fail/cinfo-type */
type_bglt 
fail_cinfo_type_26_cfa_info(fail_bglt obj_255)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 79 */
      return
	 (((fail_bglt) CREF(obj_255))->type);
   }
}



/* _fail/cinfo-type2879 */
obj_t 
_fail_cinfo_type2879_168_cfa_info(obj_t env_5277, obj_t obj_5278)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 79 */
      {		/* Cfa/cinfo.scm 79 */
	 type_bglt aux_7341;
	 aux_7341 =
	    fail_cinfo_type_26_cfa_info(
	    (fail_bglt) (obj_5278));
	 return
	    (obj_t) (aux_7341);
      }
   }
}



/* fail/cinfo-proc-set! */
obj_t 
fail_cinfo_proc_set__66_cfa_info(fail_bglt obj_256, node_bglt val1773_257)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 79 */
      return
	 ((((fail_bglt) CREF(obj_256))->proc) = ((node_bglt) val1773_257), BUNSPEC);
   }
}



/* _fail/cinfo-proc-set!2880 */
obj_t 
_fail_cinfo_proc_set_2880_220_cfa_info(obj_t env_5279, obj_t obj_5280, obj_t val1773_5281)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 79 */
      return
	 fail_cinfo_proc_set__66_cfa_info(
	 (fail_bglt) (obj_5280),
	 (node_bglt) (val1773_5281));
   }
}



/* fail/cinfo-proc */
node_bglt 
fail_cinfo_proc_58_cfa_info(fail_bglt obj_258)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 79 */
      return
	 (((fail_bglt) CREF(obj_258))->proc);
   }
}



/* _fail/cinfo-proc2881 */
obj_t 
_fail_cinfo_proc2881_18_cfa_info(obj_t env_5282, obj_t obj_5283)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 79 */
      {		/* Cfa/cinfo.scm 79 */
	 node_bglt aux_7350;
	 aux_7350 =
	    fail_cinfo_proc_58_cfa_info(
	    (fail_bglt) (obj_5283));
	 return
	    (obj_t) (aux_7350);
      }
   }
}



/* fail/cinfo-msg-set! */
obj_t 
fail_cinfo_msg_set__145_cfa_info(fail_bglt obj_259, node_bglt val1774_260)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 79 */
      return
	 ((((fail_bglt) CREF(obj_259))->msg) = ((node_bglt) val1774_260), BUNSPEC);
   }
}



/* _fail/cinfo-msg-set!2882 */
obj_t 
_fail_cinfo_msg_set_2882_185_cfa_info(obj_t env_5284, obj_t obj_5285, obj_t val1774_5286)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 79 */
      return
	 fail_cinfo_msg_set__145_cfa_info(
	 (fail_bglt) (obj_5285),
	 (node_bglt) (val1774_5286));
   }
}



/* fail/cinfo-msg */
node_bglt 
fail_cinfo_msg_186_cfa_info(fail_bglt obj_261)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 79 */
      return
	 (((fail_bglt) CREF(obj_261))->msg);
   }
}



/* _fail/cinfo-msg2883 */
obj_t 
_fail_cinfo_msg2883_50_cfa_info(obj_t env_5287, obj_t obj_5288)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 79 */
      {		/* Cfa/cinfo.scm 79 */
	 node_bglt aux_7359;
	 aux_7359 =
	    fail_cinfo_msg_186_cfa_info(
	    (fail_bglt) (obj_5288));
	 return
	    (obj_t) (aux_7359);
      }
   }
}



/* fail/cinfo-obj-set! */
obj_t 
fail_cinfo_obj_set__135_cfa_info(fail_bglt obj_262, node_bglt val1775_263)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 79 */
      return
	 ((((fail_bglt) CREF(obj_262))->obj) = ((node_bglt) val1775_263), BUNSPEC);
   }
}



/* _fail/cinfo-obj-set!2884 */
obj_t 
_fail_cinfo_obj_set_2884_198_cfa_info(obj_t env_5289, obj_t obj_5290, obj_t val1775_5291)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 79 */
      return
	 fail_cinfo_obj_set__135_cfa_info(
	 (fail_bglt) (obj_5290),
	 (node_bglt) (val1775_5291));
   }
}



/* fail/cinfo-obj */
node_bglt 
fail_cinfo_obj_134_cfa_info(fail_bglt obj_264)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 79 */
      return
	 (((fail_bglt) CREF(obj_264))->obj);
   }
}



/* _fail/cinfo-obj2885 */
obj_t 
_fail_cinfo_obj2885_174_cfa_info(obj_t env_5292, obj_t obj_5293)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 79 */
      {		/* Cfa/cinfo.scm 79 */
	 node_bglt aux_7368;
	 aux_7368 =
	    fail_cinfo_obj_134_cfa_info(
	    (fail_bglt) (obj_5293));
	 return
	    (obj_t) (aux_7368);
      }
   }
}



/* fail/cinfo-approx */
approx_bglt 
fail_cinfo_approx_11_cfa_info(fail_cinfo_75_bglt obj_265)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 79 */
      {
	 obj_t aux_7372;
	 {	/* Cfa/cinfo.scm 79 */
	    object_bglt aux_7373;
	    aux_7373 =
	       (object_bglt) (obj_265);
	    aux_7372 =
	       OBJECT_WIDENING(aux_7373);
	 }
	 return
	    (((fail_cinfo_75_bglt) CREF(aux_7372))->approx);
      }
   }
}



/* _fail/cinfo-approx2886 */
obj_t 
_fail_cinfo_approx2886_158_cfa_info(obj_t env_5294, obj_t obj_5295)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 79 */
      {		/* Cfa/cinfo.scm 79 */
	 approx_bglt aux_7377;
	 aux_7377 =
	    fail_cinfo_approx_11_cfa_info(
	    (fail_cinfo_75_bglt) (obj_5295));
	 return
	    (obj_t) (aux_7377);
      }
   }
}



/* allocate-conditional/cinfo */
conditional_bglt 
allocate_conditional_cinfo_71_cfa_info()
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 78 */
      {		/* Cfa/cinfo.scm 78 */
	 conditional_bglt new1765_1750;
	 new1765_1750 =
	    ((conditional_bglt) BREF(GC_MALLOC(sizeof(struct conditional))));
	 {	/* Cfa/cinfo.scm 78 */
	    long arg2302_1751;
	    arg2302_1751 =
	       class_num_218___object(conditional_cinfo_212_cfa_info);
	    {	/* Cfa/cinfo.scm 78 */
	       obj_t obj_3222;
	       obj_3222 =
		  (obj_t) (new1765_1750);
	       (((obj_t) CREF(obj_3222))->header = MAKE_HEADER(arg2302_1751, 0), BUNSPEC);
	    }
	 }
	 {	/* Cfa/cinfo.scm 78 */
	    object_bglt aux_7385;
	    aux_7385 =
	       (object_bglt) (new1765_1750);
	    OBJECT_WIDENING_SET(aux_7385, BFALSE);
	 }
	 return new1765_1750;
      }
   }
}



/* _allocate-conditional/cinfo */
obj_t 
_allocate_conditional_cinfo_139_cfa_info(obj_t env_4914)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 78 */
      {		/* Cfa/cinfo.scm 78 */
	 conditional_bglt aux_7388;
	 aux_7388 =
	    allocate_conditional_cinfo_71_cfa_info();
	 return
	    (obj_t) (aux_7388);
      }
   }
}



/* conditional/cinfo? */
bool_t 
conditional_cinfo__69_cfa_info(obj_t obj_269)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 78 */
      return
	 is_a__118___object(obj_269, conditional_cinfo_212_cfa_info);
   }
}



/* _conditional/cinfo? */
obj_t 
_conditional_cinfo__117_cfa_info(obj_t env_5296, obj_t obj_5297)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 78 */
      {		/* Cfa/cinfo.scm 78 */
	 bool_t aux_7392;
	 aux_7392 =
	    conditional_cinfo__69_cfa_info(obj_5297);
	 return
	    BBOOL(aux_7392);
      }
   }
}



/* widening-conditional/cinfo */
conditional_cinfo_212_bglt 
widening_conditional_cinfo_79_cfa_info(approx_bglt approx_270)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 78 */
      {		/* Cfa/cinfo.scm 78 */
	 conditional_cinfo_212_bglt new1760_3224;
	 new1760_3224 =
	    ((conditional_cinfo_212_bglt) BREF(GC_MALLOC(sizeof(struct conditional_cinfo_212))));
	 ((((conditional_cinfo_212_bglt) CREF(new1760_3224))->approx) = ((approx_bglt) approx_270), BUNSPEC);
	 return new1760_3224;
      }
   }
}



/* _widening-conditional/cinfo2887 */
obj_t 
_widening_conditional_cinfo2887_19_cfa_info(obj_t env_5298, obj_t approx_5299)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 78 */
      {		/* Cfa/cinfo.scm 78 */
	 conditional_cinfo_212_bglt aux_7397;
	 aux_7397 =
	    widening_conditional_cinfo_79_cfa_info(
	    (approx_bglt) (approx_5299));
	 return
	    (obj_t) (aux_7397);
      }
   }
}



/* make-conditional/cinfo */
conditional_cinfo_212_bglt 
make_conditional_cinfo_187_cfa_info(obj_t loc_271, type_bglt type_272, obj_t side_effect__165_273, obj_t key_274, node_bglt test_275, node_bglt true_276, node_bglt false_277, approx_bglt approx_278)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 78 */
      {		/* Cfa/cinfo.scm 78 */
	 conditional_bglt aux1763_3226;
	 {	/* Cfa/cinfo.scm 78 */
	    conditional_bglt res2705_3248;
	    {	/* ./Ast/node.scm 705 */
	       conditional_bglt new1317_3237;
	       new1317_3237 =
		  ((conditional_bglt) BREF(GC_MALLOC(sizeof(struct conditional))));
	       {	/* ./Ast/node.scm 705 */
		  long arg2377_3238;
		  arg2377_3238 =
		     class_num_218___object(conditional_ast_node);
		  {	/* ./Ast/node.scm 705 */
		     obj_t obj_3246;
		     obj_3246 =
			(obj_t) (new1317_3237);
		     (((obj_t) CREF(obj_3246))->header = MAKE_HEADER(arg2377_3238, 0), BUNSPEC);
		  }
	       }
	       {	/* ./Ast/node.scm 705 */
		  object_bglt aux_7405;
		  aux_7405 =
		     (object_bglt) (new1317_3237);
		  OBJECT_WIDENING_SET(aux_7405, BFALSE);
	       }
	       ((((conditional_bglt) CREF(new1317_3237))->loc) = ((obj_t) loc_271), BUNSPEC);
	       ((((conditional_bglt) CREF(new1317_3237))->type) = ((type_bglt) type_272), BUNSPEC);
	       ((((conditional_bglt) CREF(new1317_3237))->side_effect__165) = ((obj_t) side_effect__165_273), BUNSPEC);
	       ((((conditional_bglt) CREF(new1317_3237))->key) = ((obj_t) key_274), BUNSPEC);
	       ((((conditional_bglt) CREF(new1317_3237))->test) = ((node_bglt) test_275), BUNSPEC);
	       ((((conditional_bglt) CREF(new1317_3237))->true) = ((node_bglt) true_276), BUNSPEC);
	       ((((conditional_bglt) CREF(new1317_3237))->false) = ((node_bglt) false_277), BUNSPEC);
	       res2705_3248 = new1317_3237;
	    }
	    aux1763_3226 = res2705_3248;
	 }
	 {	/* Cfa/cinfo.scm 78 */
	    conditional_cinfo_212_bglt new1764_3227;
	    new1764_3227 =
	       ((conditional_cinfo_212_bglt) (aux1763_3226));
	    {	/* Cfa/cinfo.scm 78 */
	       long arg2303_3228;
	       arg2303_3228 =
		  class_num_218___object(conditional_cinfo_212_cfa_info);
	       {	/* Cfa/cinfo.scm 78 */
		  obj_t obj_3249;
		  obj_3249 =
		     (obj_t) (new1764_3227);
		  (((obj_t) CREF(obj_3249))->header = MAKE_HEADER(arg2303_3228, 0), BUNSPEC);
	       }
	    }
	    {	/* Cfa/cinfo.scm 78 */
	       conditional_cinfo_212_bglt arg2304_3229;
	       {	/* Cfa/cinfo.scm 78 */
		  conditional_cinfo_212_bglt res2706_3254;
		  {	/* Cfa/cinfo.scm 78 */
		     conditional_cinfo_212_bglt new1760_3252;
		     new1760_3252 =
			((conditional_cinfo_212_bglt) BREF(GC_MALLOC(sizeof(struct conditional_cinfo_212))));
		     ((((conditional_cinfo_212_bglt) CREF(new1760_3252))->approx) = ((approx_bglt) approx_278), BUNSPEC);
		     res2706_3254 = new1760_3252;
		  }
		  arg2304_3229 = res2706_3254;
	       }
	       {	/* Cfa/cinfo.scm 78 */
		  obj_t aux_7423;
		  object_bglt aux_7421;
		  aux_7423 =
		     (obj_t) (arg2304_3229);
		  aux_7421 =
		     (object_bglt) (new1764_3227);
		  OBJECT_WIDENING_SET(aux_7421, aux_7423);
	       }
	    }
	    return new1764_3227;
	 }
      }
   }
}



/* _make-conditional/cinfo2888 */
obj_t 
_make_conditional_cinfo2888_155_cfa_info(obj_t env_5300, obj_t loc_5301, obj_t type_5302, obj_t side_effect__165_5303, obj_t key_5304, obj_t test_5305, obj_t true_5306, obj_t false_5307, obj_t approx_5308)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 78 */
      {		/* Cfa/cinfo.scm 78 */
	 conditional_cinfo_212_bglt aux_7426;
	 aux_7426 =
	    make_conditional_cinfo_187_cfa_info(loc_5301,
	    (type_bglt) (type_5302), side_effect__165_5303, key_5304,
	    (node_bglt) (test_5305),
	    (node_bglt) (true_5306),
	    (node_bglt) (false_5307),
	    (approx_bglt) (approx_5308));
	 return
	    (obj_t) (aux_7426);
      }
   }
}



/* conditional/cinfo-loc */
obj_t 
conditional_cinfo_loc_197_cfa_info(conditional_bglt obj_279)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 624 */
      return
	 (((conditional_bglt) CREF(obj_279))->loc);
   }
}



/* _conditional/cinfo-loc2889 */
obj_t 
_conditional_cinfo_loc2889_186_cfa_info(obj_t env_5309, obj_t obj_5310)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 624 */
      return
	 conditional_cinfo_loc_197_cfa_info(
	 (conditional_bglt) (obj_5310));
   }
}



/* conditional/cinfo-type-set! */
obj_t 
conditional_cinfo_type_set__218_cfa_info(conditional_bglt obj_280, type_bglt val1754_281)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 78 */
      return
	 ((((conditional_bglt) CREF(obj_280))->type) = ((type_bglt) val1754_281), BUNSPEC);
   }
}



/* _conditional/cinfo-type-set!2890 */
obj_t 
_conditional_cinfo_type_set_2890_68_cfa_info(obj_t env_5311, obj_t obj_5312, obj_t val1754_5313)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 78 */
      return
	 conditional_cinfo_type_set__218_cfa_info(
	 (conditional_bglt) (obj_5312),
	 (type_bglt) (val1754_5313));
   }
}



/* conditional/cinfo-type */
type_bglt 
conditional_cinfo_type_74_cfa_info(conditional_bglt obj_282)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 78 */
      return
	 (((conditional_bglt) CREF(obj_282))->type);
   }
}



/* _conditional/cinfo-type2891 */
obj_t 
_conditional_cinfo_type2891_50_cfa_info(obj_t env_5314, obj_t obj_5315)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 78 */
      {		/* Cfa/cinfo.scm 78 */
	 type_bglt aux_7442;
	 aux_7442 =
	    conditional_cinfo_type_74_cfa_info(
	    (conditional_bglt) (obj_5315));
	 return
	    (obj_t) (aux_7442);
      }
   }
}



/* conditional/cinfo-side-effect?-set! */
obj_t 
conditional_cinfo_side_effect__set__214_cfa_info(conditional_bglt obj_283, obj_t val1755_284)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 632 */
      return
	 ((((conditional_bglt) CREF(obj_283))->side_effect__165) = ((obj_t) val1755_284), BUNSPEC);
   }
}



/* _conditional/cinfo-side-effect?-set!2892 */
obj_t 
_conditional_cinfo_side_effect__set_2892_133_cfa_info(obj_t env_5316, obj_t obj_5317, obj_t val1755_5318)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 632 */
      return
	 conditional_cinfo_side_effect__set__214_cfa_info(
	 (conditional_bglt) (obj_5317), val1755_5318);
   }
}



/* conditional/cinfo-side-effect? */
obj_t 
conditional_cinfo_side_effect__139_cfa_info(conditional_bglt obj_285)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 632 */
      return
	 (((conditional_bglt) CREF(obj_285))->side_effect__165);
   }
}



/* _conditional/cinfo-side-effect?2893 */
obj_t 
_conditional_cinfo_side_effect_2893_157_cfa_info(obj_t env_5319, obj_t obj_5320)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 632 */
      return
	 conditional_cinfo_side_effect__139_cfa_info(
	 (conditional_bglt) (obj_5320));
   }
}



/* conditional/cinfo-key-set! */
obj_t 
conditional_cinfo_key_set__171_cfa_info(conditional_bglt obj_286, obj_t val1756_287)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 636 */
      return
	 ((((conditional_bglt) CREF(obj_286))->key) = ((obj_t) val1756_287), BUNSPEC);
   }
}



/* _conditional/cinfo-key-set! */
obj_t 
_conditional_cinfo_key_set__114_cfa_info(obj_t env_5321, obj_t obj_5322, obj_t val1756_5323)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 636 */
      return
	 conditional_cinfo_key_set__171_cfa_info(
	 (conditional_bglt) (obj_5322), val1756_5323);
   }
}



/* conditional/cinfo-key */
obj_t 
conditional_cinfo_key_148_cfa_info(conditional_bglt obj_288)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 636 */
      return
	 (((conditional_bglt) CREF(obj_288))->key);
   }
}



/* _conditional/cinfo-key */
obj_t 
_conditional_cinfo_key_29_cfa_info(obj_t env_5324, obj_t obj_5325)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 636 */
      return
	 conditional_cinfo_key_148_cfa_info(
	 (conditional_bglt) (obj_5325));
   }
}



/* conditional/cinfo-test-set! */
obj_t 
conditional_cinfo_test_set__167_cfa_info(conditional_bglt obj_289, node_bglt val1757_290)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 78 */
      return
	 ((((conditional_bglt) CREF(obj_289))->test) = ((node_bglt) val1757_290), BUNSPEC);
   }
}



/* _conditional/cinfo-test-set!2894 */
obj_t 
_conditional_cinfo_test_set_2894_208_cfa_info(obj_t env_5326, obj_t obj_5327, obj_t val1757_5328)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 78 */
      return
	 conditional_cinfo_test_set__167_cfa_info(
	 (conditional_bglt) (obj_5327),
	 (node_bglt) (val1757_5328));
   }
}



/* conditional/cinfo-test */
node_bglt 
conditional_cinfo_test_91_cfa_info(conditional_bglt obj_291)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 78 */
      return
	 (((conditional_bglt) CREF(obj_291))->test);
   }
}



/* _conditional/cinfo-test2895 */
obj_t 
_conditional_cinfo_test2895_11_cfa_info(obj_t env_5329, obj_t obj_5330)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 78 */
      {		/* Cfa/cinfo.scm 78 */
	 node_bglt aux_7463;
	 aux_7463 =
	    conditional_cinfo_test_91_cfa_info(
	    (conditional_bglt) (obj_5330));
	 return
	    (obj_t) (aux_7463);
      }
   }
}



/* conditional/cinfo-true-set! */
obj_t 
conditional_cinfo_true_set__242_cfa_info(conditional_bglt obj_292, node_bglt val1758_293)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 78 */
      return
	 ((((conditional_bglt) CREF(obj_292))->true) = ((node_bglt) val1758_293), BUNSPEC);
   }
}



/* _conditional/cinfo-true-set!2896 */
obj_t 
_conditional_cinfo_true_set_2896_30_cfa_info(obj_t env_5331, obj_t obj_5332, obj_t val1758_5333)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 78 */
      return
	 conditional_cinfo_true_set__242_cfa_info(
	 (conditional_bglt) (obj_5332),
	 (node_bglt) (val1758_5333));
   }
}



/* conditional/cinfo-true */
node_bglt 
conditional_cinfo_true_183_cfa_info(conditional_bglt obj_294)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 78 */
      return
	 (((conditional_bglt) CREF(obj_294))->true);
   }
}



/* _conditional/cinfo-true2897 */
obj_t 
_conditional_cinfo_true2897_11_cfa_info(obj_t env_5334, obj_t obj_5335)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 78 */
      {		/* Cfa/cinfo.scm 78 */
	 node_bglt aux_7472;
	 aux_7472 =
	    conditional_cinfo_true_183_cfa_info(
	    (conditional_bglt) (obj_5335));
	 return
	    (obj_t) (aux_7472);
      }
   }
}



/* conditional/cinfo-false-set! */
obj_t 
conditional_cinfo_false_set__59_cfa_info(conditional_bglt obj_295, node_bglt val1759_296)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 78 */
      return
	 ((((conditional_bglt) CREF(obj_295))->false) = ((node_bglt) val1759_296), BUNSPEC);
   }
}



/* _conditional/cinfo-false-set!2898 */
obj_t 
_conditional_cinfo_false_set_2898_0_cfa_info(obj_t env_5336, obj_t obj_5337, obj_t val1759_5338)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 78 */
      return
	 conditional_cinfo_false_set__59_cfa_info(
	 (conditional_bglt) (obj_5337),
	 (node_bglt) (val1759_5338));
   }
}



/* conditional/cinfo-false */
node_bglt 
conditional_cinfo_false_155_cfa_info(conditional_bglt obj_297)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 78 */
      return
	 (((conditional_bglt) CREF(obj_297))->false);
   }
}



/* _conditional/cinfo-false2899 */
obj_t 
_conditional_cinfo_false2899_105_cfa_info(obj_t env_5339, obj_t obj_5340)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 78 */
      {		/* Cfa/cinfo.scm 78 */
	 node_bglt aux_7481;
	 aux_7481 =
	    conditional_cinfo_false_155_cfa_info(
	    (conditional_bglt) (obj_5340));
	 return
	    (obj_t) (aux_7481);
      }
   }
}



/* conditional/cinfo-approx */
approx_bglt 
conditional_cinfo_approx_37_cfa_info(conditional_cinfo_212_bglt obj_298)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 78 */
      {
	 obj_t aux_7485;
	 {	/* Cfa/cinfo.scm 78 */
	    object_bglt aux_7486;
	    aux_7486 =
	       (object_bglt) (obj_298);
	    aux_7485 =
	       OBJECT_WIDENING(aux_7486);
	 }
	 return
	    (((conditional_cinfo_212_bglt) CREF(aux_7485))->approx);
      }
   }
}



/* _conditional/cinfo-approx2900 */
obj_t 
_conditional_cinfo_approx2900_167_cfa_info(obj_t env_5341, obj_t obj_5342)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 78 */
      {		/* Cfa/cinfo.scm 78 */
	 approx_bglt aux_7490;
	 aux_7490 =
	    conditional_cinfo_approx_37_cfa_info(
	    (conditional_cinfo_212_bglt) (obj_5342));
	 return
	    (obj_t) (aux_7490);
      }
   }
}



/* allocate-setq/cinfo */
setq_bglt 
allocate_setq_cinfo_202_cfa_info()
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 77 */
      {		/* Cfa/cinfo.scm 77 */
	 setq_bglt new1747_1758;
	 new1747_1758 =
	    ((setq_bglt) BREF(GC_MALLOC(sizeof(struct setq))));
	 {	/* Cfa/cinfo.scm 77 */
	    long arg2305_1759;
	    arg2305_1759 =
	       class_num_218___object(setq_cinfo_191_cfa_info);
	    {	/* Cfa/cinfo.scm 77 */
	       obj_t obj_3255;
	       obj_3255 =
		  (obj_t) (new1747_1758);
	       (((obj_t) CREF(obj_3255))->header = MAKE_HEADER(arg2305_1759, 0), BUNSPEC);
	    }
	 }
	 {	/* Cfa/cinfo.scm 77 */
	    object_bglt aux_7498;
	    aux_7498 =
	       (object_bglt) (new1747_1758);
	    OBJECT_WIDENING_SET(aux_7498, BFALSE);
	 }
	 return new1747_1758;
      }
   }
}



/* _allocate-setq/cinfo */
obj_t 
_allocate_setq_cinfo_116_cfa_info(obj_t env_4913)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 77 */
      {		/* Cfa/cinfo.scm 77 */
	 setq_bglt aux_7501;
	 aux_7501 =
	    allocate_setq_cinfo_202_cfa_info();
	 return
	    (obj_t) (aux_7501);
      }
   }
}



/* setq/cinfo? */
bool_t 
setq_cinfo__121_cfa_info(obj_t obj_302)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 77 */
      return
	 is_a__118___object(obj_302, setq_cinfo_191_cfa_info);
   }
}



/* _setq/cinfo? */
obj_t 
_setq_cinfo__245_cfa_info(obj_t env_5343, obj_t obj_5344)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 77 */
      {		/* Cfa/cinfo.scm 77 */
	 bool_t aux_7505;
	 aux_7505 =
	    setq_cinfo__121_cfa_info(obj_5344);
	 return
	    BBOOL(aux_7505);
      }
   }
}



/* widening-setq/cinfo */
setq_cinfo_191_bglt 
widening_setq_cinfo_173_cfa_info(approx_bglt approx_303)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 77 */
      {		/* Cfa/cinfo.scm 77 */
	 setq_cinfo_191_bglt new1742_3257;
	 new1742_3257 =
	    ((setq_cinfo_191_bglt) BREF(GC_MALLOC(sizeof(struct setq_cinfo_191))));
	 ((((setq_cinfo_191_bglt) CREF(new1742_3257))->approx) = ((approx_bglt) approx_303), BUNSPEC);
	 return new1742_3257;
      }
   }
}



/* _widening-setq/cinfo2901 */
obj_t 
_widening_setq_cinfo2901_7_cfa_info(obj_t env_5345, obj_t approx_5346)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 77 */
      {		/* Cfa/cinfo.scm 77 */
	 setq_cinfo_191_bglt aux_7510;
	 aux_7510 =
	    widening_setq_cinfo_173_cfa_info(
	    (approx_bglt) (approx_5346));
	 return
	    (obj_t) (aux_7510);
      }
   }
}



/* make-setq/cinfo */
setq_cinfo_191_bglt 
make_setq_cinfo_232_cfa_info(obj_t loc_304, type_bglt type_305, var_bglt var_306, node_bglt value_307, approx_bglt approx_308)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 77 */
      {		/* Cfa/cinfo.scm 77 */
	 setq_bglt aux1745_3259;
	 {	/* Cfa/cinfo.scm 77 */
	    setq_bglt res2707_3275;
	    {	/* ./Ast/node.scm 698 */
	       setq_bglt new1304_3267;
	       new1304_3267 =
		  ((setq_bglt) BREF(GC_MALLOC(sizeof(struct setq))));
	       {	/* ./Ast/node.scm 698 */
		  long arg2379_3268;
		  arg2379_3268 =
		     class_num_218___object(setq_ast_node);
		  {	/* ./Ast/node.scm 698 */
		     obj_t obj_3273;
		     obj_3273 =
			(obj_t) (new1304_3267);
		     (((obj_t) CREF(obj_3273))->header = MAKE_HEADER(arg2379_3268, 0), BUNSPEC);
		  }
	       }
	       {	/* ./Ast/node.scm 698 */
		  object_bglt aux_7518;
		  aux_7518 =
		     (object_bglt) (new1304_3267);
		  OBJECT_WIDENING_SET(aux_7518, BFALSE);
	       }
	       ((((setq_bglt) CREF(new1304_3267))->loc) = ((obj_t) loc_304), BUNSPEC);
	       ((((setq_bglt) CREF(new1304_3267))->type) = ((type_bglt) type_305), BUNSPEC);
	       ((((setq_bglt) CREF(new1304_3267))->var) = ((var_bglt) var_306), BUNSPEC);
	       ((((setq_bglt) CREF(new1304_3267))->value) = ((node_bglt) value_307), BUNSPEC);
	       res2707_3275 = new1304_3267;
	    }
	    aux1745_3259 = res2707_3275;
	 }
	 {	/* Cfa/cinfo.scm 77 */
	    setq_cinfo_191_bglt new1746_3260;
	    new1746_3260 =
	       ((setq_cinfo_191_bglt) (aux1745_3259));
	    {	/* Cfa/cinfo.scm 77 */
	       long arg2306_3261;
	       arg2306_3261 =
		  class_num_218___object(setq_cinfo_191_cfa_info);
	       {	/* Cfa/cinfo.scm 77 */
		  obj_t obj_3276;
		  obj_3276 =
		     (obj_t) (new1746_3260);
		  (((obj_t) CREF(obj_3276))->header = MAKE_HEADER(arg2306_3261, 0), BUNSPEC);
	       }
	    }
	    {	/* Cfa/cinfo.scm 77 */
	       setq_cinfo_191_bglt arg2307_3262;
	       {	/* Cfa/cinfo.scm 77 */
		  setq_cinfo_191_bglt res2708_3281;
		  {	/* Cfa/cinfo.scm 77 */
		     setq_cinfo_191_bglt new1742_3279;
		     new1742_3279 =
			((setq_cinfo_191_bglt) BREF(GC_MALLOC(sizeof(struct setq_cinfo_191))));
		     ((((setq_cinfo_191_bglt) CREF(new1742_3279))->approx) = ((approx_bglt) approx_308), BUNSPEC);
		     res2708_3281 = new1742_3279;
		  }
		  arg2307_3262 = res2708_3281;
	       }
	       {	/* Cfa/cinfo.scm 77 */
		  obj_t aux_7533;
		  object_bglt aux_7531;
		  aux_7533 =
		     (obj_t) (arg2307_3262);
		  aux_7531 =
		     (object_bglt) (new1746_3260);
		  OBJECT_WIDENING_SET(aux_7531, aux_7533);
	       }
	    }
	    return new1746_3260;
	 }
      }
   }
}



/* _make-setq/cinfo2902 */
obj_t 
_make_setq_cinfo2902_99_cfa_info(obj_t env_5347, obj_t loc_5348, obj_t type_5349, obj_t var_5350, obj_t value_5351, obj_t approx_5352)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 77 */
      {		/* Cfa/cinfo.scm 77 */
	 setq_cinfo_191_bglt aux_7536;
	 aux_7536 =
	    make_setq_cinfo_232_cfa_info(loc_5348,
	    (type_bglt) (type_5349),
	    (var_bglt) (var_5350),
	    (node_bglt) (value_5351),
	    (approx_bglt) (approx_5352));
	 return
	    (obj_t) (aux_7536);
      }
   }
}



/* setq/cinfo-loc */
obj_t 
setq_cinfo_loc_179_cfa_info(setq_bglt obj_309)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 624 */
      return
	 (((setq_bglt) CREF(obj_309))->loc);
   }
}



/* _setq/cinfo-loc2903 */
obj_t 
_setq_cinfo_loc2903_164_cfa_info(obj_t env_5353, obj_t obj_5354)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 624 */
      return
	 setq_cinfo_loc_179_cfa_info(
	 (setq_bglt) (obj_5354));
   }
}



/* setq/cinfo-type-set! */
obj_t 
setq_cinfo_type_set__243_cfa_info(setq_bglt obj_310, type_bglt val1739_311)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 77 */
      return
	 ((((setq_bglt) CREF(obj_310))->type) = ((type_bglt) val1739_311), BUNSPEC);
   }
}



/* _setq/cinfo-type-set!2904 */
obj_t 
_setq_cinfo_type_set_2904_118_cfa_info(obj_t env_5355, obj_t obj_5356, obj_t val1739_5357)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 77 */
      return
	 setq_cinfo_type_set__243_cfa_info(
	 (setq_bglt) (obj_5356),
	 (type_bglt) (val1739_5357));
   }
}



/* setq/cinfo-type */
type_bglt 
setq_cinfo_type_65_cfa_info(setq_bglt obj_312)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 77 */
      return
	 (((setq_bglt) CREF(obj_312))->type);
   }
}



/* _setq/cinfo-type2905 */
obj_t 
_setq_cinfo_type2905_96_cfa_info(obj_t env_5358, obj_t obj_5359)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 77 */
      {		/* Cfa/cinfo.scm 77 */
	 type_bglt aux_7551;
	 aux_7551 =
	    setq_cinfo_type_65_cfa_info(
	    (setq_bglt) (obj_5359));
	 return
	    (obj_t) (aux_7551);
      }
   }
}



/* setq/cinfo-var-set! */
obj_t 
setq_cinfo_var_set__169_cfa_info(setq_bglt obj_313, var_bglt val1740_314)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 77 */
      return
	 ((((setq_bglt) CREF(obj_313))->var) = ((var_bglt) val1740_314), BUNSPEC);
   }
}



/* _setq/cinfo-var-set!2906 */
obj_t 
_setq_cinfo_var_set_2906_217_cfa_info(obj_t env_5360, obj_t obj_5361, obj_t val1740_5362)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 77 */
      return
	 setq_cinfo_var_set__169_cfa_info(
	 (setq_bglt) (obj_5361),
	 (var_bglt) (val1740_5362));
   }
}



/* setq/cinfo-var */
var_bglt 
setq_cinfo_var_51_cfa_info(setq_bglt obj_315)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 77 */
      return
	 (((setq_bglt) CREF(obj_315))->var);
   }
}



/* _setq/cinfo-var2907 */
obj_t 
_setq_cinfo_var2907_183_cfa_info(obj_t env_5363, obj_t obj_5364)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 77 */
      {		/* Cfa/cinfo.scm 77 */
	 var_bglt aux_7560;
	 aux_7560 =
	    setq_cinfo_var_51_cfa_info(
	    (setq_bglt) (obj_5364));
	 return
	    (obj_t) (aux_7560);
      }
   }
}



/* setq/cinfo-value-set! */
obj_t 
setq_cinfo_value_set__184_cfa_info(setq_bglt obj_316, node_bglt val1741_317)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 77 */
      return
	 ((((setq_bglt) CREF(obj_316))->value) = ((node_bglt) val1741_317), BUNSPEC);
   }
}



/* _setq/cinfo-value-set!2908 */
obj_t 
_setq_cinfo_value_set_2908_109_cfa_info(obj_t env_5365, obj_t obj_5366, obj_t val1741_5367)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 77 */
      return
	 setq_cinfo_value_set__184_cfa_info(
	 (setq_bglt) (obj_5366),
	 (node_bglt) (val1741_5367));
   }
}



/* setq/cinfo-value */
node_bglt 
setq_cinfo_value_181_cfa_info(setq_bglt obj_318)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 77 */
      return
	 (((setq_bglt) CREF(obj_318))->value);
   }
}



/* _setq/cinfo-value2909 */
obj_t 
_setq_cinfo_value2909_179_cfa_info(obj_t env_5368, obj_t obj_5369)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 77 */
      {		/* Cfa/cinfo.scm 77 */
	 node_bglt aux_7569;
	 aux_7569 =
	    setq_cinfo_value_181_cfa_info(
	    (setq_bglt) (obj_5369));
	 return
	    (obj_t) (aux_7569);
      }
   }
}



/* setq/cinfo-approx */
approx_bglt 
setq_cinfo_approx_141_cfa_info(setq_cinfo_191_bglt obj_319)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 77 */
      {
	 obj_t aux_7573;
	 {	/* Cfa/cinfo.scm 77 */
	    object_bglt aux_7574;
	    aux_7574 =
	       (object_bglt) (obj_319);
	    aux_7573 =
	       OBJECT_WIDENING(aux_7574);
	 }
	 return
	    (((setq_cinfo_191_bglt) CREF(aux_7573))->approx);
      }
   }
}



/* _setq/cinfo-approx2910 */
obj_t 
_setq_cinfo_approx2910_5_cfa_info(obj_t env_5370, obj_t obj_5371)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 77 */
      {		/* Cfa/cinfo.scm 77 */
	 approx_bglt aux_7578;
	 aux_7578 =
	    setq_cinfo_approx_141_cfa_info(
	    (setq_cinfo_191_bglt) (obj_5371));
	 return
	    (obj_t) (aux_7578);
      }
   }
}



/* allocate-pragma/cinfo */
pragma_bglt 
allocate_pragma_cinfo_134_cfa_info()
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 76 */
      {		/* Cfa/cinfo.scm 76 */
	 pragma_bglt new1732_1766;
	 new1732_1766 =
	    ((pragma_bglt) BREF(GC_MALLOC(sizeof(struct pragma))));
	 {	/* Cfa/cinfo.scm 76 */
	    long arg2308_1767;
	    arg2308_1767 =
	       class_num_218___object(pragma_cinfo_220_cfa_info);
	    {	/* Cfa/cinfo.scm 76 */
	       obj_t obj_3282;
	       obj_3282 =
		  (obj_t) (new1732_1766);
	       (((obj_t) CREF(obj_3282))->header = MAKE_HEADER(arg2308_1767, 0), BUNSPEC);
	    }
	 }
	 {	/* Cfa/cinfo.scm 76 */
	    object_bglt aux_7586;
	    aux_7586 =
	       (object_bglt) (new1732_1766);
	    OBJECT_WIDENING_SET(aux_7586, BFALSE);
	 }
	 return new1732_1766;
      }
   }
}



/* _allocate-pragma/cinfo */
obj_t 
_allocate_pragma_cinfo_82_cfa_info(obj_t env_4912)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 76 */
      {		/* Cfa/cinfo.scm 76 */
	 pragma_bglt aux_7589;
	 aux_7589 =
	    allocate_pragma_cinfo_134_cfa_info();
	 return
	    (obj_t) (aux_7589);
      }
   }
}



/* pragma/cinfo? */
bool_t 
pragma_cinfo__149_cfa_info(obj_t obj_323)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 76 */
      return
	 is_a__118___object(obj_323, pragma_cinfo_220_cfa_info);
   }
}



/* _pragma/cinfo? */
obj_t 
_pragma_cinfo__129_cfa_info(obj_t env_5372, obj_t obj_5373)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 76 */
      {		/* Cfa/cinfo.scm 76 */
	 bool_t aux_7593;
	 aux_7593 =
	    pragma_cinfo__149_cfa_info(obj_5373);
	 return
	    BBOOL(aux_7593);
      }
   }
}



/* widening-pragma/cinfo */
pragma_cinfo_220_bglt 
widening_pragma_cinfo_85_cfa_info(approx_bglt approx_324)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 76 */
      {		/* Cfa/cinfo.scm 76 */
	 pragma_cinfo_220_bglt new1727_3284;
	 new1727_3284 =
	    ((pragma_cinfo_220_bglt) BREF(GC_MALLOC(sizeof(struct pragma_cinfo_220))));
	 ((((pragma_cinfo_220_bglt) CREF(new1727_3284))->approx) = ((approx_bglt) approx_324), BUNSPEC);
	 return new1727_3284;
      }
   }
}



/* _widening-pragma/cinfo2911 */
obj_t 
_widening_pragma_cinfo2911_177_cfa_info(obj_t env_5374, obj_t approx_5375)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 76 */
      {		/* Cfa/cinfo.scm 76 */
	 pragma_cinfo_220_bglt aux_7598;
	 aux_7598 =
	    widening_pragma_cinfo_85_cfa_info(
	    (approx_bglt) (approx_5375));
	 return
	    (obj_t) (aux_7598);
      }
   }
}



/* make-pragma/cinfo */
pragma_cinfo_220_bglt 
make_pragma_cinfo_123_cfa_info(obj_t loc_325, type_bglt type_326, obj_t side_effect__165_327, obj_t key_328, obj_t format_329, obj_t args_330, approx_bglt approx_331)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 76 */
      {		/* Cfa/cinfo.scm 76 */
	 pragma_bglt aux1730_3286;
	 {	/* Cfa/cinfo.scm 76 */
	    pragma_bglt res2709_3306;
	    {	/* ./Ast/node.scm 688 */
	       pragma_bglt new1284_3296;
	       new1284_3296 =
		  ((pragma_bglt) BREF(GC_MALLOC(sizeof(struct pragma))));
	       {	/* ./Ast/node.scm 688 */
		  long arg2383_3297;
		  arg2383_3297 =
		     class_num_218___object(pragma_ast_node);
		  {	/* ./Ast/node.scm 688 */
		     obj_t obj_3304;
		     obj_3304 =
			(obj_t) (new1284_3296);
		     (((obj_t) CREF(obj_3304))->header = MAKE_HEADER(arg2383_3297, 0), BUNSPEC);
		  }
	       }
	       {	/* ./Ast/node.scm 688 */
		  object_bglt aux_7606;
		  aux_7606 =
		     (object_bglt) (new1284_3296);
		  OBJECT_WIDENING_SET(aux_7606, BFALSE);
	       }
	       ((((pragma_bglt) CREF(new1284_3296))->loc) = ((obj_t) loc_325), BUNSPEC);
	       ((((pragma_bglt) CREF(new1284_3296))->type) = ((type_bglt) type_326), BUNSPEC);
	       ((((pragma_bglt) CREF(new1284_3296))->side_effect__165) = ((obj_t) side_effect__165_327), BUNSPEC);
	       ((((pragma_bglt) CREF(new1284_3296))->key) = ((obj_t) key_328), BUNSPEC);
	       ((((pragma_bglt) CREF(new1284_3296))->format) = ((obj_t) format_329), BUNSPEC);
	       ((((pragma_bglt) CREF(new1284_3296))->args) = ((obj_t) args_330), BUNSPEC);
	       res2709_3306 = new1284_3296;
	    }
	    aux1730_3286 = res2709_3306;
	 }
	 {	/* Cfa/cinfo.scm 76 */
	    pragma_cinfo_220_bglt new1731_3287;
	    new1731_3287 =
	       ((pragma_cinfo_220_bglt) (aux1730_3286));
	    {	/* Cfa/cinfo.scm 76 */
	       long arg2309_3288;
	       arg2309_3288 =
		  class_num_218___object(pragma_cinfo_220_cfa_info);
	       {	/* Cfa/cinfo.scm 76 */
		  obj_t obj_3307;
		  obj_3307 =
		     (obj_t) (new1731_3287);
		  (((obj_t) CREF(obj_3307))->header = MAKE_HEADER(arg2309_3288, 0), BUNSPEC);
	       }
	    }
	    {	/* Cfa/cinfo.scm 76 */
	       pragma_cinfo_220_bglt arg2310_3289;
	       {	/* Cfa/cinfo.scm 76 */
		  pragma_cinfo_220_bglt res2710_3312;
		  {	/* Cfa/cinfo.scm 76 */
		     pragma_cinfo_220_bglt new1727_3310;
		     new1727_3310 =
			((pragma_cinfo_220_bglt) BREF(GC_MALLOC(sizeof(struct pragma_cinfo_220))));
		     ((((pragma_cinfo_220_bglt) CREF(new1727_3310))->approx) = ((approx_bglt) approx_331), BUNSPEC);
		     res2710_3312 = new1727_3310;
		  }
		  arg2310_3289 = res2710_3312;
	       }
	       {	/* Cfa/cinfo.scm 76 */
		  obj_t aux_7623;
		  object_bglt aux_7621;
		  aux_7623 =
		     (obj_t) (arg2310_3289);
		  aux_7621 =
		     (object_bglt) (new1731_3287);
		  OBJECT_WIDENING_SET(aux_7621, aux_7623);
	       }
	    }
	    return new1731_3287;
	 }
      }
   }
}



/* _make-pragma/cinfo2912 */
obj_t 
_make_pragma_cinfo2912_176_cfa_info(obj_t env_5376, obj_t loc_5377, obj_t type_5378, obj_t side_effect__165_5379, obj_t key_5380, obj_t format_5381, obj_t args_5382, obj_t approx_5383)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 76 */
      {		/* Cfa/cinfo.scm 76 */
	 pragma_cinfo_220_bglt aux_7626;
	 aux_7626 =
	    make_pragma_cinfo_123_cfa_info(loc_5377,
	    (type_bglt) (type_5378), side_effect__165_5379, key_5380, format_5381, args_5382,
	    (approx_bglt) (approx_5383));
	 return
	    (obj_t) (aux_7626);
      }
   }
}



/* pragma/cinfo-loc */
obj_t 
pragma_cinfo_loc_22_cfa_info(pragma_bglt obj_332)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 624 */
      return
	 (((pragma_bglt) CREF(obj_332))->loc);
   }
}



/* _pragma/cinfo-loc2913 */
obj_t 
_pragma_cinfo_loc2913_152_cfa_info(obj_t env_5384, obj_t obj_5385)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 624 */
      return
	 pragma_cinfo_loc_22_cfa_info(
	 (pragma_bglt) (obj_5385));
   }
}



/* pragma/cinfo-type-set! */
obj_t 
pragma_cinfo_type_set__38_cfa_info(pragma_bglt obj_333, type_bglt val1723_334)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 76 */
      return
	 ((((pragma_bglt) CREF(obj_333))->type) = ((type_bglt) val1723_334), BUNSPEC);
   }
}



/* _pragma/cinfo-type-set!2914 */
obj_t 
_pragma_cinfo_type_set_2914_52_cfa_info(obj_t env_5386, obj_t obj_5387, obj_t val1723_5388)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 76 */
      return
	 pragma_cinfo_type_set__38_cfa_info(
	 (pragma_bglt) (obj_5387),
	 (type_bglt) (val1723_5388));
   }
}



/* pragma/cinfo-type */
type_bglt 
pragma_cinfo_type_144_cfa_info(pragma_bglt obj_335)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 76 */
      return
	 (((pragma_bglt) CREF(obj_335))->type);
   }
}



/* _pragma/cinfo-type2915 */
obj_t 
_pragma_cinfo_type2915_46_cfa_info(obj_t env_5389, obj_t obj_5390)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 76 */
      {		/* Cfa/cinfo.scm 76 */
	 type_bglt aux_7639;
	 aux_7639 =
	    pragma_cinfo_type_144_cfa_info(
	    (pragma_bglt) (obj_5390));
	 return
	    (obj_t) (aux_7639);
      }
   }
}



/* pragma/cinfo-side-effect?-set! */
obj_t 
pragma_cinfo_side_effect__set__54_cfa_info(pragma_bglt obj_336, obj_t val1724_337)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 632 */
      return
	 ((((pragma_bglt) CREF(obj_336))->side_effect__165) = ((obj_t) val1724_337), BUNSPEC);
   }
}



/* _pragma/cinfo-side-effect?-set!2916 */
obj_t 
_pragma_cinfo_side_effect__set_2916_3_cfa_info(obj_t env_5391, obj_t obj_5392, obj_t val1724_5393)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 632 */
      return
	 pragma_cinfo_side_effect__set__54_cfa_info(
	 (pragma_bglt) (obj_5392), val1724_5393);
   }
}



/* pragma/cinfo-side-effect? */
obj_t 
pragma_cinfo_side_effect__231_cfa_info(pragma_bglt obj_338)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 632 */
      return
	 (((pragma_bglt) CREF(obj_338))->side_effect__165);
   }
}



/* _pragma/cinfo-side-effect?2917 */
obj_t 
_pragma_cinfo_side_effect_2917_92_cfa_info(obj_t env_5394, obj_t obj_5395)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 632 */
      return
	 pragma_cinfo_side_effect__231_cfa_info(
	 (pragma_bglt) (obj_5395));
   }
}



/* pragma/cinfo-key-set! */
obj_t 
pragma_cinfo_key_set__146_cfa_info(pragma_bglt obj_339, obj_t val1725_340)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 636 */
      return
	 ((((pragma_bglt) CREF(obj_339))->key) = ((obj_t) val1725_340), BUNSPEC);
   }
}



/* _pragma/cinfo-key-set! */
obj_t 
_pragma_cinfo_key_set__201_cfa_info(obj_t env_5396, obj_t obj_5397, obj_t val1725_5398)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 636 */
      return
	 pragma_cinfo_key_set__146_cfa_info(
	 (pragma_bglt) (obj_5397), val1725_5398);
   }
}



/* pragma/cinfo-key */
obj_t 
pragma_cinfo_key_115_cfa_info(pragma_bglt obj_341)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 636 */
      return
	 (((pragma_bglt) CREF(obj_341))->key);
   }
}



/* _pragma/cinfo-key */
obj_t 
_pragma_cinfo_key_170_cfa_info(obj_t env_5399, obj_t obj_5400)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 636 */
      return
	 pragma_cinfo_key_115_cfa_info(
	 (pragma_bglt) (obj_5400));
   }
}



/* pragma/cinfo-format */
obj_t 
pragma_cinfo_format_141_cfa_info(pragma_bglt obj_342)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 689 */
      return
	 (((pragma_bglt) CREF(obj_342))->format);
   }
}



/* _pragma/cinfo-format2918 */
obj_t 
_pragma_cinfo_format2918_148_cfa_info(obj_t env_5401, obj_t obj_5402)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 689 */
      return
	 pragma_cinfo_format_141_cfa_info(
	 (pragma_bglt) (obj_5402));
   }
}



/* pragma/cinfo-args-set! */
obj_t 
pragma_cinfo_args_set__20_cfa_info(pragma_bglt obj_343, obj_t val1726_344)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 76 */
      return
	 ((((pragma_bglt) CREF(obj_343))->args) = ((obj_t) val1726_344), BUNSPEC);
   }
}



/* _pragma/cinfo-args-set!2919 */
obj_t 
_pragma_cinfo_args_set_2919_169_cfa_info(obj_t env_5403, obj_t obj_5404, obj_t val1726_5405)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 76 */
      return
	 pragma_cinfo_args_set__20_cfa_info(
	 (pragma_bglt) (obj_5404), val1726_5405);
   }
}



/* pragma/cinfo-args */
obj_t 
pragma_cinfo_args_224_cfa_info(pragma_bglt obj_345)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 76 */
      return
	 (((pragma_bglt) CREF(obj_345))->args);
   }
}



/* _pragma/cinfo-args2920 */
obj_t 
_pragma_cinfo_args2920_117_cfa_info(obj_t env_5406, obj_t obj_5407)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 76 */
      return
	 pragma_cinfo_args_224_cfa_info(
	 (pragma_bglt) (obj_5407));
   }
}



/* pragma/cinfo-approx */
approx_bglt 
pragma_cinfo_approx_152_cfa_info(pragma_cinfo_220_bglt obj_346)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 76 */
      {
	 obj_t aux_7664;
	 {	/* Cfa/cinfo.scm 76 */
	    object_bglt aux_7665;
	    aux_7665 =
	       (object_bglt) (obj_346);
	    aux_7664 =
	       OBJECT_WIDENING(aux_7665);
	 }
	 return
	    (((pragma_cinfo_220_bglt) CREF(aux_7664))->approx);
      }
   }
}



/* _pragma/cinfo-approx2921 */
obj_t 
_pragma_cinfo_approx2921_32_cfa_info(obj_t env_5408, obj_t obj_5409)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 76 */
      {		/* Cfa/cinfo.scm 76 */
	 approx_bglt aux_7669;
	 aux_7669 =
	    pragma_cinfo_approx_152_cfa_info(
	    (pragma_cinfo_220_bglt) (obj_5409));
	 return
	    (obj_t) (aux_7669);
      }
   }
}



/* allocate-funcall/cinfo */
funcall_bglt 
allocate_funcall_cinfo_11_cfa_info()
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 71 */
      {		/* Cfa/cinfo.scm 71 */
	 funcall_bglt new1716_1774;
	 new1716_1774 =
	    ((funcall_bglt) BREF(GC_MALLOC(sizeof(struct funcall))));
	 {	/* Cfa/cinfo.scm 71 */
	    long arg2311_1775;
	    arg2311_1775 =
	       class_num_218___object(funcall_cinfo_75_cfa_info);
	    {	/* Cfa/cinfo.scm 71 */
	       obj_t obj_3313;
	       obj_3313 =
		  (obj_t) (new1716_1774);
	       (((obj_t) CREF(obj_3313))->header = MAKE_HEADER(arg2311_1775, 0), BUNSPEC);
	    }
	 }
	 {	/* Cfa/cinfo.scm 71 */
	    object_bglt aux_7677;
	    aux_7677 =
	       (object_bglt) (new1716_1774);
	    OBJECT_WIDENING_SET(aux_7677, BFALSE);
	 }
	 return new1716_1774;
      }
   }
}



/* _allocate-funcall/cinfo */
obj_t 
_allocate_funcall_cinfo_40_cfa_info(obj_t env_4911)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 71 */
      {		/* Cfa/cinfo.scm 71 */
	 funcall_bglt aux_7680;
	 aux_7680 =
	    allocate_funcall_cinfo_11_cfa_info();
	 return
	    (obj_t) (aux_7680);
      }
   }
}



/* funcall/cinfo? */
bool_t 
funcall_cinfo__175_cfa_info(obj_t obj_350)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 71 */
      return
	 is_a__118___object(obj_350, funcall_cinfo_75_cfa_info);
   }
}



/* _funcall/cinfo? */
obj_t 
_funcall_cinfo__59_cfa_info(obj_t env_5410, obj_t obj_5411)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 71 */
      {		/* Cfa/cinfo.scm 71 */
	 bool_t aux_7684;
	 aux_7684 =
	    funcall_cinfo__175_cfa_info(obj_5411);
	 return
	    BBOOL(aux_7684);
      }
   }
}



/* widening-funcall/cinfo */
funcall_cinfo_75_bglt 
widening_funcall_cinfo_88_cfa_info(approx_bglt approx_351, approx_bglt va_approx_63_352, bool_t arity_error_noticed__118_353, bool_t type_error_noticed__36_354)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 71 */
      {		/* Cfa/cinfo.scm 71 */
	 funcall_cinfo_75_bglt new1708_3315;
	 new1708_3315 =
	    ((funcall_cinfo_75_bglt) BREF(GC_MALLOC(sizeof(struct funcall_cinfo_75))));
	 ((((funcall_cinfo_75_bglt) CREF(new1708_3315))->approx) = ((approx_bglt) approx_351), BUNSPEC);
	 ((((funcall_cinfo_75_bglt) CREF(new1708_3315))->va_approx_63) = ((approx_bglt) va_approx_63_352), BUNSPEC);
	 ((((funcall_cinfo_75_bglt) CREF(new1708_3315))->arity_error_noticed__118) = ((bool_t) arity_error_noticed__118_353), BUNSPEC);
	 ((((funcall_cinfo_75_bglt) CREF(new1708_3315))->type_error_noticed__36) = ((bool_t) type_error_noticed__36_354), BUNSPEC);
	 return new1708_3315;
      }
   }
}



/* _widening-funcall/cinfo2922 */
obj_t 
_widening_funcall_cinfo2922_80_cfa_info(obj_t env_5412, obj_t approx_5413, obj_t va_approx_63_5414, obj_t arity_error_noticed__118_5415, obj_t type_error_noticed__36_5416)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 71 */
      {		/* Cfa/cinfo.scm 71 */
	 funcall_cinfo_75_bglt aux_7692;
	 aux_7692 =
	    widening_funcall_cinfo_88_cfa_info(
	    (approx_bglt) (approx_5413),
	    (approx_bglt) (va_approx_63_5414),
	    CBOOL(arity_error_noticed__118_5415),
	    CBOOL(type_error_noticed__36_5416));
	 return
	    (obj_t) (aux_7692);
      }
   }
}



/* make-funcall/cinfo */
funcall_cinfo_75_bglt 
make_funcall_cinfo_132_cfa_info(obj_t loc_355, type_bglt type_356, node_bglt fun_357, obj_t args_358, obj_t strength_359, approx_bglt approx_360, approx_bglt va_approx_63_361, bool_t arity_error_noticed__118_362, bool_t type_error_noticed__36_363)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 71 */
      {		/* Cfa/cinfo.scm 71 */
	 funcall_bglt aux1714_3320;
	 {	/* Cfa/cinfo.scm 71 */
	    funcall_bglt res2711_3338;
	    {	/* ./Ast/node.scm 677 */
	       funcall_bglt new1272_3329;
	       new1272_3329 =
		  ((funcall_bglt) BREF(GC_MALLOC(sizeof(struct funcall))));
	       {	/* ./Ast/node.scm 677 */
		  long arg2385_3330;
		  arg2385_3330 =
		     class_num_218___object(funcall_ast_node);
		  {	/* ./Ast/node.scm 677 */
		     obj_t obj_3336;
		     obj_3336 =
			(obj_t) (new1272_3329);
		     (((obj_t) CREF(obj_3336))->header = MAKE_HEADER(arg2385_3330, 0), BUNSPEC);
		  }
	       }
	       {	/* ./Ast/node.scm 677 */
		  object_bglt aux_7703;
		  aux_7703 =
		     (object_bglt) (new1272_3329);
		  OBJECT_WIDENING_SET(aux_7703, BFALSE);
	       }
	       ((((funcall_bglt) CREF(new1272_3329))->loc) = ((obj_t) loc_355), BUNSPEC);
	       ((((funcall_bglt) CREF(new1272_3329))->type) = ((type_bglt) type_356), BUNSPEC);
	       ((((funcall_bglt) CREF(new1272_3329))->fun) = ((node_bglt) fun_357), BUNSPEC);
	       ((((funcall_bglt) CREF(new1272_3329))->args) = ((obj_t) args_358), BUNSPEC);
	       ((((funcall_bglt) CREF(new1272_3329))->strength) = ((obj_t) strength_359), BUNSPEC);
	       res2711_3338 = new1272_3329;
	    }
	    aux1714_3320 = res2711_3338;
	 }
	 {	/* Cfa/cinfo.scm 71 */
	    funcall_cinfo_75_bglt new1715_3321;
	    new1715_3321 =
	       ((funcall_cinfo_75_bglt) (aux1714_3320));
	    {	/* Cfa/cinfo.scm 71 */
	       long arg2312_3322;
	       arg2312_3322 =
		  class_num_218___object(funcall_cinfo_75_cfa_info);
	       {	/* Cfa/cinfo.scm 71 */
		  obj_t obj_3339;
		  obj_3339 =
		     (obj_t) (new1715_3321);
		  (((obj_t) CREF(obj_3339))->header = MAKE_HEADER(arg2312_3322, 0), BUNSPEC);
	       }
	    }
	    {	/* Cfa/cinfo.scm 71 */
	       funcall_cinfo_75_bglt arg2313_3323;
	       {	/* Cfa/cinfo.scm 71 */
		  funcall_cinfo_75_bglt res2712_3350;
		  {	/* Cfa/cinfo.scm 71 */
		     funcall_cinfo_75_bglt new1708_3345;
		     new1708_3345 =
			((funcall_cinfo_75_bglt) BREF(GC_MALLOC(sizeof(struct funcall_cinfo_75))));
		     ((((funcall_cinfo_75_bglt) CREF(new1708_3345))->approx) = ((approx_bglt) approx_360), BUNSPEC);
		     ((((funcall_cinfo_75_bglt) CREF(new1708_3345))->va_approx_63) = ((approx_bglt) va_approx_63_361), BUNSPEC);
		     ((((funcall_cinfo_75_bglt) CREF(new1708_3345))->arity_error_noticed__118) = ((bool_t) arity_error_noticed__118_362), BUNSPEC);
		     ((((funcall_cinfo_75_bglt) CREF(new1708_3345))->type_error_noticed__36) = ((bool_t) type_error_noticed__36_363), BUNSPEC);
		     res2712_3350 = new1708_3345;
		  }
		  arg2313_3323 = res2712_3350;
	       }
	       {	/* Cfa/cinfo.scm 71 */
		  obj_t aux_7722;
		  object_bglt aux_7720;
		  aux_7722 =
		     (obj_t) (arg2313_3323);
		  aux_7720 =
		     (object_bglt) (new1715_3321);
		  OBJECT_WIDENING_SET(aux_7720, aux_7722);
	       }
	    }
	    return new1715_3321;
	 }
      }
   }
}



/* _make-funcall/cinfo2923 */
obj_t 
_make_funcall_cinfo2923_185_cfa_info(obj_t env_5417, obj_t loc_5418, obj_t type_5419, obj_t fun_5420, obj_t args_5421, obj_t strength_5422, obj_t approx_5423, obj_t va_approx_63_5424, obj_t arity_error_noticed__118_5425, obj_t type_error_noticed__36_5426)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 71 */
      {		/* Cfa/cinfo.scm 71 */
	 funcall_cinfo_75_bglt aux_7725;
	 aux_7725 =
	    make_funcall_cinfo_132_cfa_info(loc_5418,
	    (type_bglt) (type_5419),
	    (node_bglt) (fun_5420), args_5421, strength_5422,
	    (approx_bglt) (approx_5423),
	    (approx_bglt) (va_approx_63_5424),
	    CBOOL(arity_error_noticed__118_5425),
	    CBOOL(type_error_noticed__36_5426));
	 return
	    (obj_t) (aux_7725);
      }
   }
}



/* funcall/cinfo-loc */
obj_t 
funcall_cinfo_loc_64_cfa_info(funcall_bglt obj_364)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 624 */
      return
	 (((funcall_bglt) CREF(obj_364))->loc);
   }
}



/* _funcall/cinfo-loc2924 */
obj_t 
_funcall_cinfo_loc2924_64_cfa_info(obj_t env_5427, obj_t obj_5428)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 624 */
      return
	 funcall_cinfo_loc_64_cfa_info(
	 (funcall_bglt) (obj_5428));
   }
}



/* funcall/cinfo-type-set! */
obj_t 
funcall_cinfo_type_set__85_cfa_info(funcall_bglt obj_365, type_bglt val1702_366)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 71 */
      return
	 ((((funcall_bglt) CREF(obj_365))->type) = ((type_bglt) val1702_366), BUNSPEC);
   }
}



/* _funcall/cinfo-type-set!2925 */
obj_t 
_funcall_cinfo_type_set_2925_90_cfa_info(obj_t env_5429, obj_t obj_5430, obj_t val1702_5431)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 71 */
      return
	 funcall_cinfo_type_set__85_cfa_info(
	 (funcall_bglt) (obj_5430),
	 (type_bglt) (val1702_5431));
   }
}



/* funcall/cinfo-type */
type_bglt 
funcall_cinfo_type_26_cfa_info(funcall_bglt obj_367)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 71 */
      return
	 (((funcall_bglt) CREF(obj_367))->type);
   }
}



/* _funcall/cinfo-type2926 */
obj_t 
_funcall_cinfo_type2926_242_cfa_info(obj_t env_5432, obj_t obj_5433)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 71 */
      {		/* Cfa/cinfo.scm 71 */
	 type_bglt aux_7742;
	 aux_7742 =
	    funcall_cinfo_type_26_cfa_info(
	    (funcall_bglt) (obj_5433));
	 return
	    (obj_t) (aux_7742);
      }
   }
}



/* funcall/cinfo-fun-set! */
obj_t 
funcall_cinfo_fun_set__87_cfa_info(funcall_bglt obj_368, node_bglt val1703_369)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 71 */
      return
	 ((((funcall_bglt) CREF(obj_368))->fun) = ((node_bglt) val1703_369), BUNSPEC);
   }
}



/* _funcall/cinfo-fun-set!2927 */
obj_t 
_funcall_cinfo_fun_set_2927_96_cfa_info(obj_t env_5434, obj_t obj_5435, obj_t val1703_5436)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 71 */
      return
	 funcall_cinfo_fun_set__87_cfa_info(
	 (funcall_bglt) (obj_5435),
	 (node_bglt) (val1703_5436));
   }
}



/* funcall/cinfo-fun */
node_bglt 
funcall_cinfo_fun_73_cfa_info(funcall_bglt obj_370)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 71 */
      return
	 (((funcall_bglt) CREF(obj_370))->fun);
   }
}



/* _funcall/cinfo-fun2928 */
obj_t 
_funcall_cinfo_fun2928_37_cfa_info(obj_t env_5437, obj_t obj_5438)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 71 */
      {		/* Cfa/cinfo.scm 71 */
	 node_bglt aux_7751;
	 aux_7751 =
	    funcall_cinfo_fun_73_cfa_info(
	    (funcall_bglt) (obj_5438));
	 return
	    (obj_t) (aux_7751);
      }
   }
}



/* funcall/cinfo-args-set! */
obj_t 
funcall_cinfo_args_set__97_cfa_info(funcall_bglt obj_371, obj_t val1704_372)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 71 */
      return
	 ((((funcall_bglt) CREF(obj_371))->args) = ((obj_t) val1704_372), BUNSPEC);
   }
}



/* _funcall/cinfo-args-set!2929 */
obj_t 
_funcall_cinfo_args_set_2929_237_cfa_info(obj_t env_5439, obj_t obj_5440, obj_t val1704_5441)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 71 */
      return
	 funcall_cinfo_args_set__97_cfa_info(
	 (funcall_bglt) (obj_5440), val1704_5441);
   }
}



/* funcall/cinfo-args */
obj_t 
funcall_cinfo_args_85_cfa_info(funcall_bglt obj_373)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 71 */
      return
	 (((funcall_bglt) CREF(obj_373))->args);
   }
}



/* _funcall/cinfo-args2930 */
obj_t 
_funcall_cinfo_args2930_9_cfa_info(obj_t env_5442, obj_t obj_5443)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 71 */
      return
	 funcall_cinfo_args_85_cfa_info(
	 (funcall_bglt) (obj_5443));
   }
}



/* funcall/cinfo-strength-set! */
obj_t 
funcall_cinfo_strength_set__61_cfa_info(funcall_bglt obj_374, obj_t val1705_375)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 683 */
      return
	 ((((funcall_bglt) CREF(obj_374))->strength) = ((obj_t) val1705_375), BUNSPEC);
   }
}



/* _funcall/cinfo-strength-set!2931 */
obj_t 
_funcall_cinfo_strength_set_2931_178_cfa_info(obj_t env_5444, obj_t obj_5445, obj_t val1705_5446)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 683 */
      return
	 funcall_cinfo_strength_set__61_cfa_info(
	 (funcall_bglt) (obj_5445), val1705_5446);
   }
}



/* funcall/cinfo-strength */
obj_t 
funcall_cinfo_strength_95_cfa_info(funcall_bglt obj_376)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 683 */
      return
	 (((funcall_bglt) CREF(obj_376))->strength);
   }
}



/* _funcall/cinfo-strength2932 */
obj_t 
_funcall_cinfo_strength2932_36_cfa_info(obj_t env_5447, obj_t obj_5448)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 683 */
      return
	 funcall_cinfo_strength_95_cfa_info(
	 (funcall_bglt) (obj_5448));
   }
}



/* funcall/cinfo-approx */
approx_bglt 
funcall_cinfo_approx_11_cfa_info(funcall_cinfo_75_bglt obj_377)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 72 */
      {
	 obj_t aux_7767;
	 {	/* Cfa/cinfo.scm 72 */
	    object_bglt aux_7768;
	    aux_7768 =
	       (object_bglt) (obj_377);
	    aux_7767 =
	       OBJECT_WIDENING(aux_7768);
	 }
	 return
	    (((funcall_cinfo_75_bglt) CREF(aux_7767))->approx);
      }
   }
}



/* _funcall/cinfo-approx2933 */
obj_t 
_funcall_cinfo_approx2933_43_cfa_info(obj_t env_5449, obj_t obj_5450)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 72 */
      {		/* Cfa/cinfo.scm 72 */
	 approx_bglt aux_7772;
	 aux_7772 =
	    funcall_cinfo_approx_11_cfa_info(
	    (funcall_cinfo_75_bglt) (obj_5450));
	 return
	    (obj_t) (aux_7772);
      }
   }
}



/* funcall/cinfo-va-approx */
approx_bglt 
funcall_cinfo_va_approx_93_cfa_info(funcall_cinfo_75_bglt obj_378)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 73 */
      {
	 obj_t aux_7776;
	 {	/* Cfa/cinfo.scm 73 */
	    object_bglt aux_7777;
	    aux_7777 =
	       (object_bglt) (obj_378);
	    aux_7776 =
	       OBJECT_WIDENING(aux_7777);
	 }
	 return
	    (((funcall_cinfo_75_bglt) CREF(aux_7776))->va_approx_63);
      }
   }
}



/* _funcall/cinfo-va-approx2934 */
obj_t 
_funcall_cinfo_va_approx2934_237_cfa_info(obj_t env_5451, obj_t obj_5452)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 73 */
      {		/* Cfa/cinfo.scm 73 */
	 approx_bglt aux_7781;
	 aux_7781 =
	    funcall_cinfo_va_approx_93_cfa_info(
	    (funcall_cinfo_75_bglt) (obj_5452));
	 return
	    (obj_t) (aux_7781);
      }
   }
}



/* funcall/cinfo-arity-error-noticed?-set! */
obj_t 
funcall_cinfo_arity_error_noticed__set__137_cfa_info(funcall_cinfo_75_bglt obj_379, bool_t val1706_380)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 74 */
      {
	 obj_t aux_7785;
	 {	/* Cfa/cinfo.scm 74 */
	    object_bglt aux_7786;
	    aux_7786 =
	       (object_bglt) (obj_379);
	    aux_7785 =
	       OBJECT_WIDENING(aux_7786);
	 }
	 return
	    ((((funcall_cinfo_75_bglt) CREF(aux_7785))->arity_error_noticed__118) = ((bool_t) val1706_380), BUNSPEC);
      }
   }
}



/* _funcall/cinfo-arity-error-noticed?-set!2935 */
obj_t 
_funcall_cinfo_arity_error_noticed__set_2935_11_cfa_info(obj_t env_5453, obj_t obj_5454, obj_t val1706_5455)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 74 */
      return
	 funcall_cinfo_arity_error_noticed__set__137_cfa_info(
	 (funcall_cinfo_75_bglt) (obj_5454),
	 CBOOL(val1706_5455));
   }
}



/* funcall/cinfo-arity-error-noticed? */
bool_t 
funcall_cinfo_arity_error_noticed__251_cfa_info(funcall_cinfo_75_bglt obj_381)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 74 */
      {
	 obj_t aux_7793;
	 {	/* Cfa/cinfo.scm 74 */
	    object_bglt aux_7794;
	    aux_7794 =
	       (object_bglt) (obj_381);
	    aux_7793 =
	       OBJECT_WIDENING(aux_7794);
	 }
	 return
	    (((funcall_cinfo_75_bglt) CREF(aux_7793))->arity_error_noticed__118);
      }
   }
}



/* _funcall/cinfo-arity-error-noticed?2936 */
obj_t 
_funcall_cinfo_arity_error_noticed_2936_199_cfa_info(obj_t env_5456, obj_t obj_5457)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 74 */
      {		/* Cfa/cinfo.scm 74 */
	 bool_t aux_7798;
	 aux_7798 =
	    funcall_cinfo_arity_error_noticed__251_cfa_info(
	    (funcall_cinfo_75_bglt) (obj_5457));
	 return
	    BBOOL(aux_7798);
      }
   }
}



/* funcall/cinfo-type-error-noticed?-set! */
obj_t 
funcall_cinfo_type_error_noticed__set__27_cfa_info(funcall_cinfo_75_bglt obj_382, bool_t val1707_383)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 75 */
      {
	 obj_t aux_7802;
	 {	/* Cfa/cinfo.scm 75 */
	    object_bglt aux_7803;
	    aux_7803 =
	       (object_bglt) (obj_382);
	    aux_7802 =
	       OBJECT_WIDENING(aux_7803);
	 }
	 return
	    ((((funcall_cinfo_75_bglt) CREF(aux_7802))->type_error_noticed__36) = ((bool_t) val1707_383), BUNSPEC);
      }
   }
}



/* _funcall/cinfo-type-error-noticed?-set!2937 */
obj_t 
_funcall_cinfo_type_error_noticed__set_2937_206_cfa_info(obj_t env_5458, obj_t obj_5459, obj_t val1707_5460)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 75 */
      return
	 funcall_cinfo_type_error_noticed__set__27_cfa_info(
	 (funcall_cinfo_75_bglt) (obj_5459),
	 CBOOL(val1707_5460));
   }
}



/* funcall/cinfo-type-error-noticed? */
bool_t 
funcall_cinfo_type_error_noticed__56_cfa_info(funcall_cinfo_75_bglt obj_384)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 75 */
      {
	 obj_t aux_7810;
	 {	/* Cfa/cinfo.scm 75 */
	    object_bglt aux_7811;
	    aux_7811 =
	       (object_bglt) (obj_384);
	    aux_7810 =
	       OBJECT_WIDENING(aux_7811);
	 }
	 return
	    (((funcall_cinfo_75_bglt) CREF(aux_7810))->type_error_noticed__36);
      }
   }
}



/* _funcall/cinfo-type-error-noticed?2938 */
obj_t 
_funcall_cinfo_type_error_noticed_2938_155_cfa_info(obj_t env_5461, obj_t obj_5462)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 75 */
      {		/* Cfa/cinfo.scm 75 */
	 bool_t aux_7815;
	 aux_7815 =
	    funcall_cinfo_type_error_noticed__56_cfa_info(
	    (funcall_cinfo_75_bglt) (obj_5462));
	 return
	    BBOOL(aux_7815);
      }
   }
}



/* allocate-app-ly/cinfo */
app_ly_162_bglt 
allocate_app_ly_cinfo_200_cfa_info()
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 70 */
      {		/* Cfa/cinfo.scm 70 */
	 app_ly_162_bglt new1695_1785;
	 new1695_1785 =
	    ((app_ly_162_bglt) BREF(GC_MALLOC(sizeof(struct app_ly_162))));
	 {	/* Cfa/cinfo.scm 70 */
	    long arg2314_1786;
	    arg2314_1786 =
	       class_num_218___object(app_ly_cinfo_234_cfa_info);
	    {	/* Cfa/cinfo.scm 70 */
	       obj_t obj_3351;
	       obj_3351 =
		  (obj_t) (new1695_1785);
	       (((obj_t) CREF(obj_3351))->header = MAKE_HEADER(arg2314_1786, 0), BUNSPEC);
	    }
	 }
	 {	/* Cfa/cinfo.scm 70 */
	    object_bglt aux_7823;
	    aux_7823 =
	       (object_bglt) (new1695_1785);
	    OBJECT_WIDENING_SET(aux_7823, BFALSE);
	 }
	 return new1695_1785;
      }
   }
}



/* _allocate-app-ly/cinfo */
obj_t 
_allocate_app_ly_cinfo_17_cfa_info(obj_t env_4910)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 70 */
      {		/* Cfa/cinfo.scm 70 */
	 app_ly_162_bglt aux_7826;
	 aux_7826 =
	    allocate_app_ly_cinfo_200_cfa_info();
	 return
	    (obj_t) (aux_7826);
      }
   }
}



/* app-ly/cinfo? */
bool_t 
app_ly_cinfo__179_cfa_info(obj_t obj_388)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 70 */
      return
	 is_a__118___object(obj_388, app_ly_cinfo_234_cfa_info);
   }
}



/* _app-ly/cinfo? */
obj_t 
_app_ly_cinfo__202_cfa_info(obj_t env_5463, obj_t obj_5464)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 70 */
      {		/* Cfa/cinfo.scm 70 */
	 bool_t aux_7830;
	 aux_7830 =
	    app_ly_cinfo__179_cfa_info(obj_5464);
	 return
	    BBOOL(aux_7830);
      }
   }
}



/* widening-app-ly/cinfo */
app_ly_cinfo_234_bglt 
widening_app_ly_cinfo_231_cfa_info(approx_bglt approx_389)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 70 */
      {		/* Cfa/cinfo.scm 70 */
	 app_ly_cinfo_234_bglt new1690_3353;
	 new1690_3353 =
	    ((app_ly_cinfo_234_bglt) BREF(GC_MALLOC(sizeof(struct app_ly_cinfo_234))));
	 ((((app_ly_cinfo_234_bglt) CREF(new1690_3353))->approx) = ((approx_bglt) approx_389), BUNSPEC);
	 return new1690_3353;
      }
   }
}



/* _widening-app-ly/cinfo2939 */
obj_t 
_widening_app_ly_cinfo2939_88_cfa_info(obj_t env_5465, obj_t approx_5466)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 70 */
      {		/* Cfa/cinfo.scm 70 */
	 app_ly_cinfo_234_bglt aux_7835;
	 aux_7835 =
	    widening_app_ly_cinfo_231_cfa_info(
	    (approx_bglt) (approx_5466));
	 return
	    (obj_t) (aux_7835);
      }
   }
}



/* make-app-ly/cinfo */
app_ly_cinfo_234_bglt 
make_app_ly_cinfo_1_cfa_info(obj_t loc_390, type_bglt type_391, node_bglt fun_392, node_bglt arg_393, approx_bglt approx_394)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 70 */
      {		/* Cfa/cinfo.scm 70 */
	 app_ly_162_bglt aux1693_3355;
	 {	/* Cfa/cinfo.scm 70 */
	    app_ly_162_bglt res2713_3371;
	    {	/* ./Ast/node.scm 670 */
	       app_ly_162_bglt new1261_3363;
	       new1261_3363 =
		  ((app_ly_162_bglt) BREF(GC_MALLOC(sizeof(struct app_ly_162))));
	       {	/* ./Ast/node.scm 670 */
		  long arg2387_3364;
		  arg2387_3364 =
		     class_num_218___object(app_ly_162_ast_node);
		  {	/* ./Ast/node.scm 670 */
		     obj_t obj_3369;
		     obj_3369 =
			(obj_t) (new1261_3363);
		     (((obj_t) CREF(obj_3369))->header = MAKE_HEADER(arg2387_3364, 0), BUNSPEC);
		  }
	       }
	       {	/* ./Ast/node.scm 670 */
		  object_bglt aux_7843;
		  aux_7843 =
		     (object_bglt) (new1261_3363);
		  OBJECT_WIDENING_SET(aux_7843, BFALSE);
	       }
	       ((((app_ly_162_bglt) CREF(new1261_3363))->loc) = ((obj_t) loc_390), BUNSPEC);
	       ((((app_ly_162_bglt) CREF(new1261_3363))->type) = ((type_bglt) type_391), BUNSPEC);
	       ((((app_ly_162_bglt) CREF(new1261_3363))->fun) = ((node_bglt) fun_392), BUNSPEC);
	       ((((app_ly_162_bglt) CREF(new1261_3363))->arg) = ((node_bglt) arg_393), BUNSPEC);
	       res2713_3371 = new1261_3363;
	    }
	    aux1693_3355 = res2713_3371;
	 }
	 {	/* Cfa/cinfo.scm 70 */
	    app_ly_cinfo_234_bglt new1694_3356;
	    new1694_3356 =
	       ((app_ly_cinfo_234_bglt) (aux1693_3355));
	    {	/* Cfa/cinfo.scm 70 */
	       long arg2315_3357;
	       arg2315_3357 =
		  class_num_218___object(app_ly_cinfo_234_cfa_info);
	       {	/* Cfa/cinfo.scm 70 */
		  obj_t obj_3372;
		  obj_3372 =
		     (obj_t) (new1694_3356);
		  (((obj_t) CREF(obj_3372))->header = MAKE_HEADER(arg2315_3357, 0), BUNSPEC);
	       }
	    }
	    {	/* Cfa/cinfo.scm 70 */
	       app_ly_cinfo_234_bglt arg2316_3358;
	       {	/* Cfa/cinfo.scm 70 */
		  app_ly_cinfo_234_bglt res2714_3377;
		  {	/* Cfa/cinfo.scm 70 */
		     app_ly_cinfo_234_bglt new1690_3375;
		     new1690_3375 =
			((app_ly_cinfo_234_bglt) BREF(GC_MALLOC(sizeof(struct app_ly_cinfo_234))));
		     ((((app_ly_cinfo_234_bglt) CREF(new1690_3375))->approx) = ((approx_bglt) approx_394), BUNSPEC);
		     res2714_3377 = new1690_3375;
		  }
		  arg2316_3358 = res2714_3377;
	       }
	       {	/* Cfa/cinfo.scm 70 */
		  obj_t aux_7858;
		  object_bglt aux_7856;
		  aux_7858 =
		     (obj_t) (arg2316_3358);
		  aux_7856 =
		     (object_bglt) (new1694_3356);
		  OBJECT_WIDENING_SET(aux_7856, aux_7858);
	       }
	    }
	    return new1694_3356;
	 }
      }
   }
}



/* _make-app-ly/cinfo2940 */
obj_t 
_make_app_ly_cinfo2940_73_cfa_info(obj_t env_5467, obj_t loc_5468, obj_t type_5469, obj_t fun_5470, obj_t arg_5471, obj_t approx_5472)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 70 */
      {		/* Cfa/cinfo.scm 70 */
	 app_ly_cinfo_234_bglt aux_7861;
	 aux_7861 =
	    make_app_ly_cinfo_1_cfa_info(loc_5468,
	    (type_bglt) (type_5469),
	    (node_bglt) (fun_5470),
	    (node_bglt) (arg_5471),
	    (approx_bglt) (approx_5472));
	 return
	    (obj_t) (aux_7861);
      }
   }
}



/* app-ly/cinfo-loc */
obj_t 
app_ly_cinfo_loc_252_cfa_info(app_ly_162_bglt obj_395)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 624 */
      return
	 (((app_ly_162_bglt) CREF(obj_395))->loc);
   }
}



/* _app-ly/cinfo-loc2941 */
obj_t 
_app_ly_cinfo_loc2941_143_cfa_info(obj_t env_5473, obj_t obj_5474)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 624 */
      return
	 app_ly_cinfo_loc_252_cfa_info(
	 (app_ly_162_bglt) (obj_5474));
   }
}



/* app-ly/cinfo-type-set! */
obj_t 
app_ly_cinfo_type_set__211_cfa_info(app_ly_162_bglt obj_396, type_bglt val1687_397)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 70 */
      return
	 ((((app_ly_162_bglt) CREF(obj_396))->type) = ((type_bglt) val1687_397), BUNSPEC);
   }
}



/* _app-ly/cinfo-type-set!2942 */
obj_t 
_app_ly_cinfo_type_set_2942_95_cfa_info(obj_t env_5475, obj_t obj_5476, obj_t val1687_5477)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 70 */
      return
	 app_ly_cinfo_type_set__211_cfa_info(
	 (app_ly_162_bglt) (obj_5476),
	 (type_bglt) (val1687_5477));
   }
}



/* app-ly/cinfo-type */
type_bglt 
app_ly_cinfo_type_137_cfa_info(app_ly_162_bglt obj_398)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 70 */
      return
	 (((app_ly_162_bglt) CREF(obj_398))->type);
   }
}



/* _app-ly/cinfo-type2943 */
obj_t 
_app_ly_cinfo_type2943_141_cfa_info(obj_t env_5478, obj_t obj_5479)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 70 */
      {		/* Cfa/cinfo.scm 70 */
	 type_bglt aux_7876;
	 aux_7876 =
	    app_ly_cinfo_type_137_cfa_info(
	    (app_ly_162_bglt) (obj_5479));
	 return
	    (obj_t) (aux_7876);
      }
   }
}



/* app-ly/cinfo-fun-set! */
obj_t 
app_ly_cinfo_fun_set__61_cfa_info(app_ly_162_bglt obj_399, node_bglt val1688_400)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 70 */
      return
	 ((((app_ly_162_bglt) CREF(obj_399))->fun) = ((node_bglt) val1688_400), BUNSPEC);
   }
}



/* _app-ly/cinfo-fun-set!2944 */
obj_t 
_app_ly_cinfo_fun_set_2944_107_cfa_info(obj_t env_5480, obj_t obj_5481, obj_t val1688_5482)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 70 */
      return
	 app_ly_cinfo_fun_set__61_cfa_info(
	 (app_ly_162_bglt) (obj_5481),
	 (node_bglt) (val1688_5482));
   }
}



/* app-ly/cinfo-fun */
node_bglt 
app_ly_cinfo_fun_95_cfa_info(app_ly_162_bglt obj_401)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 70 */
      return
	 (((app_ly_162_bglt) CREF(obj_401))->fun);
   }
}



/* _app-ly/cinfo-fun2945 */
obj_t 
_app_ly_cinfo_fun2945_39_cfa_info(obj_t env_5483, obj_t obj_5484)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 70 */
      {		/* Cfa/cinfo.scm 70 */
	 node_bglt aux_7885;
	 aux_7885 =
	    app_ly_cinfo_fun_95_cfa_info(
	    (app_ly_162_bglt) (obj_5484));
	 return
	    (obj_t) (aux_7885);
      }
   }
}



/* app-ly/cinfo-arg-set! */
obj_t 
app_ly_cinfo_arg_set__121_cfa_info(app_ly_162_bglt obj_402, node_bglt val1689_403)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 70 */
      return
	 ((((app_ly_162_bglt) CREF(obj_402))->arg) = ((node_bglt) val1689_403), BUNSPEC);
   }
}



/* _app-ly/cinfo-arg-set!2946 */
obj_t 
_app_ly_cinfo_arg_set_2946_162_cfa_info(obj_t env_5485, obj_t obj_5486, obj_t val1689_5487)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 70 */
      return
	 app_ly_cinfo_arg_set__121_cfa_info(
	 (app_ly_162_bglt) (obj_5486),
	 (node_bglt) (val1689_5487));
   }
}



/* app-ly/cinfo-arg */
node_bglt 
app_ly_cinfo_arg_233_cfa_info(app_ly_162_bglt obj_404)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 70 */
      return
	 (((app_ly_162_bglt) CREF(obj_404))->arg);
   }
}



/* _app-ly/cinfo-arg2947 */
obj_t 
_app_ly_cinfo_arg2947_88_cfa_info(obj_t env_5488, obj_t obj_5489)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 70 */
      {		/* Cfa/cinfo.scm 70 */
	 node_bglt aux_7894;
	 aux_7894 =
	    app_ly_cinfo_arg_233_cfa_info(
	    (app_ly_162_bglt) (obj_5489));
	 return
	    (obj_t) (aux_7894);
      }
   }
}



/* app-ly/cinfo-approx */
approx_bglt 
app_ly_cinfo_approx_252_cfa_info(app_ly_cinfo_234_bglt obj_405)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 70 */
      {
	 obj_t aux_7898;
	 {	/* Cfa/cinfo.scm 70 */
	    object_bglt aux_7899;
	    aux_7899 =
	       (object_bglt) (obj_405);
	    aux_7898 =
	       OBJECT_WIDENING(aux_7899);
	 }
	 return
	    (((app_ly_cinfo_234_bglt) CREF(aux_7898))->approx);
      }
   }
}



/* _app-ly/cinfo-approx2948 */
obj_t 
_app_ly_cinfo_approx2948_16_cfa_info(obj_t env_5490, obj_t obj_5491)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 70 */
      {		/* Cfa/cinfo.scm 70 */
	 approx_bglt aux_7903;
	 aux_7903 =
	    app_ly_cinfo_approx_252_cfa_info(
	    (app_ly_cinfo_234_bglt) (obj_5491));
	 return
	    (obj_t) (aux_7903);
      }
   }
}



/* allocate-kwote/cinfo */
kwote_bglt 
allocate_kwote_cinfo_134_cfa_info()
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 69 */
      {		/* Cfa/cinfo.scm 69 */
	 kwote_bglt new1680_1793;
	 new1680_1793 =
	    ((kwote_bglt) BREF(GC_MALLOC(sizeof(struct kwote))));
	 {	/* Cfa/cinfo.scm 69 */
	    long arg2317_1794;
	    arg2317_1794 =
	       class_num_218___object(kwote_cinfo_48_cfa_info);
	    {	/* Cfa/cinfo.scm 69 */
	       obj_t obj_3378;
	       obj_3378 =
		  (obj_t) (new1680_1793);
	       (((obj_t) CREF(obj_3378))->header = MAKE_HEADER(arg2317_1794, 0), BUNSPEC);
	    }
	 }
	 {	/* Cfa/cinfo.scm 69 */
	    object_bglt aux_7911;
	    aux_7911 =
	       (object_bglt) (new1680_1793);
	    OBJECT_WIDENING_SET(aux_7911, BFALSE);
	 }
	 return new1680_1793;
      }
   }
}



/* _allocate-kwote/cinfo */
obj_t 
_allocate_kwote_cinfo_178_cfa_info(obj_t env_4909)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 69 */
      {		/* Cfa/cinfo.scm 69 */
	 kwote_bglt aux_7914;
	 aux_7914 =
	    allocate_kwote_cinfo_134_cfa_info();
	 return
	    (obj_t) (aux_7914);
      }
   }
}



/* kwote/cinfo? */
bool_t 
kwote_cinfo__51_cfa_info(obj_t obj_409)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 69 */
      return
	 is_a__118___object(obj_409, kwote_cinfo_48_cfa_info);
   }
}



/* _kwote/cinfo? */
obj_t 
_kwote_cinfo__102_cfa_info(obj_t env_5492, obj_t obj_5493)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 69 */
      {		/* Cfa/cinfo.scm 69 */
	 bool_t aux_7918;
	 aux_7918 =
	    kwote_cinfo__51_cfa_info(obj_5493);
	 return
	    BBOOL(aux_7918);
      }
   }
}



/* widening-kwote/cinfo */
kwote_cinfo_48_bglt 
widening_kwote_cinfo_42_cfa_info(approx_bglt approx_410)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 69 */
      {		/* Cfa/cinfo.scm 69 */
	 kwote_cinfo_48_bglt new1675_3380;
	 new1675_3380 =
	    ((kwote_cinfo_48_bglt) BREF(GC_MALLOC(sizeof(struct kwote_cinfo_48))));
	 ((((kwote_cinfo_48_bglt) CREF(new1675_3380))->approx) = ((approx_bglt) approx_410), BUNSPEC);
	 return new1675_3380;
      }
   }
}



/* _widening-kwote/cinfo2949 */
obj_t 
_widening_kwote_cinfo2949_69_cfa_info(obj_t env_5494, obj_t approx_5495)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 69 */
      {		/* Cfa/cinfo.scm 69 */
	 kwote_cinfo_48_bglt aux_7923;
	 aux_7923 =
	    widening_kwote_cinfo_42_cfa_info(
	    (approx_bglt) (approx_5495));
	 return
	    (obj_t) (aux_7923);
      }
   }
}



/* make-kwote/cinfo */
kwote_cinfo_48_bglt 
make_kwote_cinfo_77_cfa_info(obj_t loc_411, type_bglt type_412, obj_t value_413, approx_bglt approx_414)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 69 */
      {		/* Cfa/cinfo.scm 69 */
	 kwote_bglt aux1678_3382;
	 {	/* Cfa/cinfo.scm 69 */
	    kwote_bglt res2715_3396;
	    {	/* ./Ast/node.scm 652 */
	       kwote_bglt new1225_3389;
	       new1225_3389 =
		  ((kwote_bglt) BREF(GC_MALLOC(sizeof(struct kwote))));
	       {	/* ./Ast/node.scm 652 */
		  long arg2393_3390;
		  arg2393_3390 =
		     class_num_218___object(kwote_ast_node);
		  {	/* ./Ast/node.scm 652 */
		     obj_t obj_3394;
		     obj_3394 =
			(obj_t) (new1225_3389);
		     (((obj_t) CREF(obj_3394))->header = MAKE_HEADER(arg2393_3390, 0), BUNSPEC);
		  }
	       }
	       {	/* ./Ast/node.scm 652 */
		  object_bglt aux_7931;
		  aux_7931 =
		     (object_bglt) (new1225_3389);
		  OBJECT_WIDENING_SET(aux_7931, BFALSE);
	       }
	       ((((kwote_bglt) CREF(new1225_3389))->loc) = ((obj_t) loc_411), BUNSPEC);
	       ((((kwote_bglt) CREF(new1225_3389))->type) = ((type_bglt) type_412), BUNSPEC);
	       ((((kwote_bglt) CREF(new1225_3389))->value) = ((obj_t) value_413), BUNSPEC);
	       res2715_3396 = new1225_3389;
	    }
	    aux1678_3382 = res2715_3396;
	 }
	 {	/* Cfa/cinfo.scm 69 */
	    kwote_cinfo_48_bglt new1679_3383;
	    new1679_3383 =
	       ((kwote_cinfo_48_bglt) (aux1678_3382));
	    {	/* Cfa/cinfo.scm 69 */
	       long arg2318_3384;
	       arg2318_3384 =
		  class_num_218___object(kwote_cinfo_48_cfa_info);
	       {	/* Cfa/cinfo.scm 69 */
		  obj_t obj_3397;
		  obj_3397 =
		     (obj_t) (new1679_3383);
		  (((obj_t) CREF(obj_3397))->header = MAKE_HEADER(arg2318_3384, 0), BUNSPEC);
	       }
	    }
	    {	/* Cfa/cinfo.scm 69 */
	       kwote_cinfo_48_bglt arg2319_3385;
	       {	/* Cfa/cinfo.scm 69 */
		  kwote_cinfo_48_bglt res2716_3402;
		  {	/* Cfa/cinfo.scm 69 */
		     kwote_cinfo_48_bglt new1675_3400;
		     new1675_3400 =
			((kwote_cinfo_48_bglt) BREF(GC_MALLOC(sizeof(struct kwote_cinfo_48))));
		     ((((kwote_cinfo_48_bglt) CREF(new1675_3400))->approx) = ((approx_bglt) approx_414), BUNSPEC);
		     res2716_3402 = new1675_3400;
		  }
		  arg2319_3385 = res2716_3402;
	       }
	       {	/* Cfa/cinfo.scm 69 */
		  obj_t aux_7945;
		  object_bglt aux_7943;
		  aux_7945 =
		     (obj_t) (arg2319_3385);
		  aux_7943 =
		     (object_bglt) (new1679_3383);
		  OBJECT_WIDENING_SET(aux_7943, aux_7945);
	       }
	    }
	    return new1679_3383;
	 }
      }
   }
}



/* _make-kwote/cinfo2950 */
obj_t 
_make_kwote_cinfo2950_155_cfa_info(obj_t env_5496, obj_t loc_5497, obj_t type_5498, obj_t value_5499, obj_t approx_5500)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 69 */
      {		/* Cfa/cinfo.scm 69 */
	 kwote_cinfo_48_bglt aux_7948;
	 aux_7948 =
	    make_kwote_cinfo_77_cfa_info(loc_5497,
	    (type_bglt) (type_5498), value_5499,
	    (approx_bglt) (approx_5500));
	 return
	    (obj_t) (aux_7948);
      }
   }
}



/* kwote/cinfo-loc */
obj_t 
kwote_cinfo_loc_185_cfa_info(kwote_bglt obj_415)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 624 */
      return
	 (((kwote_bglt) CREF(obj_415))->loc);
   }
}



/* _kwote/cinfo-loc2951 */
obj_t 
_kwote_cinfo_loc2951_52_cfa_info(obj_t env_5501, obj_t obj_5502)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 624 */
      return
	 kwote_cinfo_loc_185_cfa_info(
	 (kwote_bglt) (obj_5502));
   }
}



/* kwote/cinfo-type-set! */
obj_t 
kwote_cinfo_type_set__163_cfa_info(kwote_bglt obj_416, type_bglt val1674_417)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 69 */
      return
	 ((((kwote_bglt) CREF(obj_416))->type) = ((type_bglt) val1674_417), BUNSPEC);
   }
}



/* _kwote/cinfo-type-set!2952 */
obj_t 
_kwote_cinfo_type_set_2952_45_cfa_info(obj_t env_5503, obj_t obj_5504, obj_t val1674_5505)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 69 */
      return
	 kwote_cinfo_type_set__163_cfa_info(
	 (kwote_bglt) (obj_5504),
	 (type_bglt) (val1674_5505));
   }
}



/* kwote/cinfo-type */
type_bglt 
kwote_cinfo_type_193_cfa_info(kwote_bglt obj_418)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 69 */
      return
	 (((kwote_bglt) CREF(obj_418))->type);
   }
}



/* _kwote/cinfo-type2953 */
obj_t 
_kwote_cinfo_type2953_68_cfa_info(obj_t env_5506, obj_t obj_5507)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 69 */
      {		/* Cfa/cinfo.scm 69 */
	 type_bglt aux_7961;
	 aux_7961 =
	    kwote_cinfo_type_193_cfa_info(
	    (kwote_bglt) (obj_5507));
	 return
	    (obj_t) (aux_7961);
      }
   }
}



/* kwote/cinfo-value */
obj_t 
kwote_cinfo_value_171_cfa_info(kwote_bglt obj_419)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 654 */
      return
	 (((kwote_bglt) CREF(obj_419))->value);
   }
}



/* _kwote/cinfo-value2954 */
obj_t 
_kwote_cinfo_value2954_71_cfa_info(obj_t env_5508, obj_t obj_5509)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 654 */
      return
	 kwote_cinfo_value_171_cfa_info(
	 (kwote_bglt) (obj_5509));
   }
}



/* kwote/cinfo-approx */
approx_bglt 
kwote_cinfo_approx_226_cfa_info(kwote_cinfo_48_bglt obj_420)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 69 */
      {
	 obj_t aux_7968;
	 {	/* Cfa/cinfo.scm 69 */
	    object_bglt aux_7969;
	    aux_7969 =
	       (object_bglt) (obj_420);
	    aux_7968 =
	       OBJECT_WIDENING(aux_7969);
	 }
	 return
	    (((kwote_cinfo_48_bglt) CREF(aux_7968))->approx);
      }
   }
}



/* _kwote/cinfo-approx2955 */
obj_t 
_kwote_cinfo_approx2955_234_cfa_info(obj_t env_5510, obj_t obj_5511)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 69 */
      {		/* Cfa/cinfo.scm 69 */
	 approx_bglt aux_7973;
	 aux_7973 =
	    kwote_cinfo_approx_226_cfa_info(
	    (kwote_cinfo_48_bglt) (obj_5511));
	 return
	    (obj_t) (aux_7973);
      }
   }
}



/* allocate-kwote/node */
kwote_bglt 
allocate_kwote_node_139_cfa_info()
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 68 */
      {		/* Cfa/cinfo.scm 68 */
	 kwote_bglt new1667_1801;
	 new1667_1801 =
	    ((kwote_bglt) BREF(GC_MALLOC(sizeof(struct kwote))));
	 {	/* Cfa/cinfo.scm 68 */
	    long arg2320_1802;
	    arg2320_1802 =
	       class_num_218___object(kwote_node_102_cfa_info);
	    {	/* Cfa/cinfo.scm 68 */
	       obj_t obj_3403;
	       obj_3403 =
		  (obj_t) (new1667_1801);
	       (((obj_t) CREF(obj_3403))->header = MAKE_HEADER(arg2320_1802, 0), BUNSPEC);
	    }
	 }
	 {	/* Cfa/cinfo.scm 68 */
	    object_bglt aux_7981;
	    aux_7981 =
	       (object_bglt) (new1667_1801);
	    OBJECT_WIDENING_SET(aux_7981, BFALSE);
	 }
	 return new1667_1801;
      }
   }
}



/* _allocate-kwote/node */
obj_t 
_allocate_kwote_node_49_cfa_info(obj_t env_4908)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 68 */
      {		/* Cfa/cinfo.scm 68 */
	 kwote_bglt aux_7984;
	 aux_7984 =
	    allocate_kwote_node_139_cfa_info();
	 return
	    (obj_t) (aux_7984);
      }
   }
}



/* kwote/node? */
bool_t 
kwote_node__206_cfa_info(obj_t obj_424)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 68 */
      return
	 is_a__118___object(obj_424, kwote_node_102_cfa_info);
   }
}



/* _kwote/node? */
obj_t 
_kwote_node__166_cfa_info(obj_t env_5512, obj_t obj_5513)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 68 */
      {		/* Cfa/cinfo.scm 68 */
	 bool_t aux_7988;
	 aux_7988 =
	    kwote_node__206_cfa_info(obj_5513);
	 return
	    BBOOL(aux_7988);
      }
   }
}



/* widening-kwote/node */
kwote_node_102_bglt 
widening_kwote_node_16_cfa_info(node_bglt node_425)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 68 */
      {		/* Cfa/cinfo.scm 68 */
	 kwote_node_102_bglt new1662_3405;
	 new1662_3405 =
	    ((kwote_node_102_bglt) BREF(GC_MALLOC(sizeof(struct kwote_node_102))));
	 ((((kwote_node_102_bglt) CREF(new1662_3405))->node) = ((node_bglt) node_425), BUNSPEC);
	 return new1662_3405;
      }
   }
}



/* _widening-kwote/node2956 */
obj_t 
_widening_kwote_node2956_153_cfa_info(obj_t env_5514, obj_t node_5515)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 68 */
      {		/* Cfa/cinfo.scm 68 */
	 kwote_node_102_bglt aux_7993;
	 aux_7993 =
	    widening_kwote_node_16_cfa_info(
	    (node_bglt) (node_5515));
	 return
	    (obj_t) (aux_7993);
      }
   }
}



/* make-kwote/node */
kwote_node_102_bglt 
make_kwote_node_13_cfa_info(obj_t loc_426, type_bglt type_427, obj_t value_428, node_bglt node_429)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 68 */
      {		/* Cfa/cinfo.scm 68 */
	 kwote_bglt aux1665_3407;
	 {	/* Cfa/cinfo.scm 68 */
	    kwote_bglt res2717_3421;
	    {	/* ./Ast/node.scm 652 */
	       kwote_bglt new1225_3414;
	       new1225_3414 =
		  ((kwote_bglt) BREF(GC_MALLOC(sizeof(struct kwote))));
	       {	/* ./Ast/node.scm 652 */
		  long arg2393_3415;
		  arg2393_3415 =
		     class_num_218___object(kwote_ast_node);
		  {	/* ./Ast/node.scm 652 */
		     obj_t obj_3419;
		     obj_3419 =
			(obj_t) (new1225_3414);
		     (((obj_t) CREF(obj_3419))->header = MAKE_HEADER(arg2393_3415, 0), BUNSPEC);
		  }
	       }
	       {	/* ./Ast/node.scm 652 */
		  object_bglt aux_8001;
		  aux_8001 =
		     (object_bglt) (new1225_3414);
		  OBJECT_WIDENING_SET(aux_8001, BFALSE);
	       }
	       ((((kwote_bglt) CREF(new1225_3414))->loc) = ((obj_t) loc_426), BUNSPEC);
	       ((((kwote_bglt) CREF(new1225_3414))->type) = ((type_bglt) type_427), BUNSPEC);
	       ((((kwote_bglt) CREF(new1225_3414))->value) = ((obj_t) value_428), BUNSPEC);
	       res2717_3421 = new1225_3414;
	    }
	    aux1665_3407 = res2717_3421;
	 }
	 {	/* Cfa/cinfo.scm 68 */
	    kwote_node_102_bglt new1666_3408;
	    new1666_3408 =
	       ((kwote_node_102_bglt) (aux1665_3407));
	    {	/* Cfa/cinfo.scm 68 */
	       long arg2321_3409;
	       arg2321_3409 =
		  class_num_218___object(kwote_node_102_cfa_info);
	       {	/* Cfa/cinfo.scm 68 */
		  obj_t obj_3422;
		  obj_3422 =
		     (obj_t) (new1666_3408);
		  (((obj_t) CREF(obj_3422))->header = MAKE_HEADER(arg2321_3409, 0), BUNSPEC);
	       }
	    }
	    {	/* Cfa/cinfo.scm 68 */
	       kwote_node_102_bglt arg2322_3410;
	       {	/* Cfa/cinfo.scm 68 */
		  kwote_node_102_bglt res2718_3427;
		  {	/* Cfa/cinfo.scm 68 */
		     kwote_node_102_bglt new1662_3425;
		     new1662_3425 =
			((kwote_node_102_bglt) BREF(GC_MALLOC(sizeof(struct kwote_node_102))));
		     ((((kwote_node_102_bglt) CREF(new1662_3425))->node) = ((node_bglt) node_429), BUNSPEC);
		     res2718_3427 = new1662_3425;
		  }
		  arg2322_3410 = res2718_3427;
	       }
	       {	/* Cfa/cinfo.scm 68 */
		  obj_t aux_8015;
		  object_bglt aux_8013;
		  aux_8015 =
		     (obj_t) (arg2322_3410);
		  aux_8013 =
		     (object_bglt) (new1666_3408);
		  OBJECT_WIDENING_SET(aux_8013, aux_8015);
	       }
	    }
	    return new1666_3408;
	 }
      }
   }
}



/* _make-kwote/node2957 */
obj_t 
_make_kwote_node2957_50_cfa_info(obj_t env_5516, obj_t loc_5517, obj_t type_5518, obj_t value_5519, obj_t node_5520)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 68 */
      {		/* Cfa/cinfo.scm 68 */
	 kwote_node_102_bglt aux_8018;
	 aux_8018 =
	    make_kwote_node_13_cfa_info(loc_5517,
	    (type_bglt) (type_5518), value_5519,
	    (node_bglt) (node_5520));
	 return
	    (obj_t) (aux_8018);
      }
   }
}



/* kwote/node-loc */
obj_t 
kwote_node_loc_4_cfa_info(kwote_bglt obj_430)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 624 */
      return
	 (((kwote_bglt) CREF(obj_430))->loc);
   }
}



/* _kwote/node-loc2958 */
obj_t 
_kwote_node_loc2958_66_cfa_info(obj_t env_5521, obj_t obj_5522)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 624 */
      return
	 kwote_node_loc_4_cfa_info(
	 (kwote_bglt) (obj_5522));
   }
}



/* kwote/node-type-set! */
obj_t 
kwote_node_type_set__67_cfa_info(kwote_bglt obj_431, type_bglt val1661_432)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 68 */
      return
	 ((((kwote_bglt) CREF(obj_431))->type) = ((type_bglt) val1661_432), BUNSPEC);
   }
}



/* _kwote/node-type-set!2959 */
obj_t 
_kwote_node_type_set_2959_77_cfa_info(obj_t env_5523, obj_t obj_5524, obj_t val1661_5525)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 68 */
      return
	 kwote_node_type_set__67_cfa_info(
	 (kwote_bglt) (obj_5524),
	 (type_bglt) (val1661_5525));
   }
}



/* kwote/node-type */
type_bglt 
kwote_node_type_31_cfa_info(kwote_bglt obj_433)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 68 */
      return
	 (((kwote_bglt) CREF(obj_433))->type);
   }
}



/* _kwote/node-type2960 */
obj_t 
_kwote_node_type2960_123_cfa_info(obj_t env_5526, obj_t obj_5527)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 68 */
      {		/* Cfa/cinfo.scm 68 */
	 type_bglt aux_8031;
	 aux_8031 =
	    kwote_node_type_31_cfa_info(
	    (kwote_bglt) (obj_5527));
	 return
	    (obj_t) (aux_8031);
      }
   }
}



/* kwote/node-value */
obj_t 
kwote_node_value_143_cfa_info(kwote_bglt obj_434)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 654 */
      return
	 (((kwote_bglt) CREF(obj_434))->value);
   }
}



/* _kwote/node-value2961 */
obj_t 
_kwote_node_value2961_201_cfa_info(obj_t env_5528, obj_t obj_5529)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 654 */
      return
	 kwote_node_value_143_cfa_info(
	 (kwote_bglt) (obj_5529));
   }
}



/* kwote/node-node */
node_bglt 
kwote_node_node_71_cfa_info(kwote_node_102_bglt obj_435)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 68 */
      {
	 obj_t aux_8038;
	 {	/* Cfa/cinfo.scm 68 */
	    object_bglt aux_8039;
	    aux_8039 =
	       (object_bglt) (obj_435);
	    aux_8038 =
	       OBJECT_WIDENING(aux_8039);
	 }
	 return
	    (((kwote_node_102_bglt) CREF(aux_8038))->node);
      }
   }
}



/* _kwote/node-node2962 */
obj_t 
_kwote_node_node2962_101_cfa_info(obj_t env_5530, obj_t obj_5531)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 68 */
      {		/* Cfa/cinfo.scm 68 */
	 node_bglt aux_8043;
	 aux_8043 =
	    kwote_node_node_71_cfa_info(
	    (kwote_node_102_bglt) (obj_5531));
	 return
	    (obj_t) (aux_8043);
      }
   }
}



/* allocate-atom/cinfo */
atom_bglt 
allocate_atom_cinfo_55_cfa_info()
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 67 */
      {		/* Cfa/cinfo.scm 67 */
	 atom_bglt new1654_1809;
	 new1654_1809 =
	    ((atom_bglt) BREF(GC_MALLOC(sizeof(struct atom))));
	 {	/* Cfa/cinfo.scm 67 */
	    long arg2323_1810;
	    arg2323_1810 =
	       class_num_218___object(atom_cinfo_155_cfa_info);
	    {	/* Cfa/cinfo.scm 67 */
	       obj_t obj_3428;
	       obj_3428 =
		  (obj_t) (new1654_1809);
	       (((obj_t) CREF(obj_3428))->header = MAKE_HEADER(arg2323_1810, 0), BUNSPEC);
	    }
	 }
	 {	/* Cfa/cinfo.scm 67 */
	    object_bglt aux_8051;
	    aux_8051 =
	       (object_bglt) (new1654_1809);
	    OBJECT_WIDENING_SET(aux_8051, BFALSE);
	 }
	 return new1654_1809;
      }
   }
}



/* _allocate-atom/cinfo */
obj_t 
_allocate_atom_cinfo_64_cfa_info(obj_t env_4907)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 67 */
      {		/* Cfa/cinfo.scm 67 */
	 atom_bglt aux_8054;
	 aux_8054 =
	    allocate_atom_cinfo_55_cfa_info();
	 return
	    (obj_t) (aux_8054);
      }
   }
}



/* atom/cinfo? */
bool_t 
atom_cinfo__127_cfa_info(obj_t obj_439)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 67 */
      return
	 is_a__118___object(obj_439, atom_cinfo_155_cfa_info);
   }
}



/* _atom/cinfo? */
obj_t 
_atom_cinfo__122_cfa_info(obj_t env_5532, obj_t obj_5533)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 67 */
      {		/* Cfa/cinfo.scm 67 */
	 bool_t aux_8058;
	 aux_8058 =
	    atom_cinfo__127_cfa_info(obj_5533);
	 return
	    BBOOL(aux_8058);
      }
   }
}



/* widening-atom/cinfo */
atom_cinfo_155_bglt 
widening_atom_cinfo_32_cfa_info(approx_bglt approx_440)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 67 */
      {		/* Cfa/cinfo.scm 67 */
	 atom_cinfo_155_bglt new1649_3430;
	 new1649_3430 =
	    ((atom_cinfo_155_bglt) BREF(GC_MALLOC(sizeof(struct atom_cinfo_155))));
	 ((((atom_cinfo_155_bglt) CREF(new1649_3430))->approx) = ((approx_bglt) approx_440), BUNSPEC);
	 return new1649_3430;
      }
   }
}



/* _widening-atom/cinfo2963 */
obj_t 
_widening_atom_cinfo2963_144_cfa_info(obj_t env_5534, obj_t approx_5535)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 67 */
      {		/* Cfa/cinfo.scm 67 */
	 atom_cinfo_155_bglt aux_8063;
	 aux_8063 =
	    widening_atom_cinfo_32_cfa_info(
	    (approx_bglt) (approx_5535));
	 return
	    (obj_t) (aux_8063);
      }
   }
}



/* make-atom/cinfo */
atom_cinfo_155_bglt 
make_atom_cinfo_25_cfa_info(obj_t loc_441, type_bglt type_442, obj_t value_443, approx_bglt approx_444)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 67 */
      {		/* Cfa/cinfo.scm 67 */
	 atom_bglt aux1652_3432;
	 {	/* Cfa/cinfo.scm 67 */
	    atom_bglt res2719_3446;
	    {	/* ./Ast/node.scm 639 */
	       atom_bglt new1202_3439;
	       new1202_3439 =
		  ((atom_bglt) BREF(GC_MALLOC(sizeof(struct atom))));
	       {	/* ./Ast/node.scm 639 */
		  long arg2399_3440;
		  arg2399_3440 =
		     class_num_218___object(atom_ast_node);
		  {	/* ./Ast/node.scm 639 */
		     obj_t obj_3444;
		     obj_3444 =
			(obj_t) (new1202_3439);
		     (((obj_t) CREF(obj_3444))->header = MAKE_HEADER(arg2399_3440, 0), BUNSPEC);
		  }
	       }
	       {	/* ./Ast/node.scm 639 */
		  object_bglt aux_8071;
		  aux_8071 =
		     (object_bglt) (new1202_3439);
		  OBJECT_WIDENING_SET(aux_8071, BFALSE);
	       }
	       ((((atom_bglt) CREF(new1202_3439))->loc) = ((obj_t) loc_441), BUNSPEC);
	       ((((atom_bglt) CREF(new1202_3439))->type) = ((type_bglt) type_442), BUNSPEC);
	       ((((atom_bglt) CREF(new1202_3439))->value) = ((obj_t) value_443), BUNSPEC);
	       res2719_3446 = new1202_3439;
	    }
	    aux1652_3432 = res2719_3446;
	 }
	 {	/* Cfa/cinfo.scm 67 */
	    atom_cinfo_155_bglt new1653_3433;
	    new1653_3433 =
	       ((atom_cinfo_155_bglt) (aux1652_3432));
	    {	/* Cfa/cinfo.scm 67 */
	       long arg2324_3434;
	       arg2324_3434 =
		  class_num_218___object(atom_cinfo_155_cfa_info);
	       {	/* Cfa/cinfo.scm 67 */
		  obj_t obj_3447;
		  obj_3447 =
		     (obj_t) (new1653_3433);
		  (((obj_t) CREF(obj_3447))->header = MAKE_HEADER(arg2324_3434, 0), BUNSPEC);
	       }
	    }
	    {	/* Cfa/cinfo.scm 67 */
	       atom_cinfo_155_bglt arg2325_3435;
	       {	/* Cfa/cinfo.scm 67 */
		  atom_cinfo_155_bglt res2720_3452;
		  {	/* Cfa/cinfo.scm 67 */
		     atom_cinfo_155_bglt new1649_3450;
		     new1649_3450 =
			((atom_cinfo_155_bglt) BREF(GC_MALLOC(sizeof(struct atom_cinfo_155))));
		     ((((atom_cinfo_155_bglt) CREF(new1649_3450))->approx) = ((approx_bglt) approx_444), BUNSPEC);
		     res2720_3452 = new1649_3450;
		  }
		  arg2325_3435 = res2720_3452;
	       }
	       {	/* Cfa/cinfo.scm 67 */
		  obj_t aux_8085;
		  object_bglt aux_8083;
		  aux_8085 =
		     (obj_t) (arg2325_3435);
		  aux_8083 =
		     (object_bglt) (new1653_3433);
		  OBJECT_WIDENING_SET(aux_8083, aux_8085);
	       }
	    }
	    return new1653_3433;
	 }
      }
   }
}



/* _make-atom/cinfo2964 */
obj_t 
_make_atom_cinfo2964_82_cfa_info(obj_t env_5536, obj_t loc_5537, obj_t type_5538, obj_t value_5539, obj_t approx_5540)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 67 */
      {		/* Cfa/cinfo.scm 67 */
	 atom_cinfo_155_bglt aux_8088;
	 aux_8088 =
	    make_atom_cinfo_25_cfa_info(loc_5537,
	    (type_bglt) (type_5538), value_5539,
	    (approx_bglt) (approx_5540));
	 return
	    (obj_t) (aux_8088);
      }
   }
}



/* atom/cinfo-loc */
obj_t 
atom_cinfo_loc_162_cfa_info(atom_bglt obj_445)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 624 */
      return
	 (((atom_bglt) CREF(obj_445))->loc);
   }
}



/* _atom/cinfo-loc2965 */
obj_t 
_atom_cinfo_loc2965_122_cfa_info(obj_t env_5541, obj_t obj_5542)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 624 */
      return
	 atom_cinfo_loc_162_cfa_info(
	 (atom_bglt) (obj_5542));
   }
}



/* atom/cinfo-type-set! */
obj_t 
atom_cinfo_type_set__31_cfa_info(atom_bglt obj_446, type_bglt val1647_447)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 67 */
      return
	 ((((atom_bglt) CREF(obj_446))->type) = ((type_bglt) val1647_447), BUNSPEC);
   }
}



/* _atom/cinfo-type-set!2966 */
obj_t 
_atom_cinfo_type_set_2966_94_cfa_info(obj_t env_5543, obj_t obj_5544, obj_t val1647_5545)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 67 */
      return
	 atom_cinfo_type_set__31_cfa_info(
	 (atom_bglt) (obj_5544),
	 (type_bglt) (val1647_5545));
   }
}



/* atom/cinfo-type */
type_bglt 
atom_cinfo_type_135_cfa_info(atom_bglt obj_448)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 67 */
      return
	 (((atom_bglt) CREF(obj_448))->type);
   }
}



/* _atom/cinfo-type2967 */
obj_t 
_atom_cinfo_type2967_147_cfa_info(obj_t env_5546, obj_t obj_5547)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 67 */
      {		/* Cfa/cinfo.scm 67 */
	 type_bglt aux_8101;
	 aux_8101 =
	    atom_cinfo_type_135_cfa_info(
	    (atom_bglt) (obj_5547));
	 return
	    (obj_t) (aux_8101);
      }
   }
}



/* atom/cinfo-value-set! */
obj_t 
atom_cinfo_value_set__32_cfa_info(atom_bglt obj_449, obj_t val1648_450)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 67 */
      return
	 ((((atom_bglt) CREF(obj_449))->value) = ((obj_t) val1648_450), BUNSPEC);
   }
}



/* _atom/cinfo-value-set!2968 */
obj_t 
_atom_cinfo_value_set_2968_229_cfa_info(obj_t env_5548, obj_t obj_5549, obj_t val1648_5550)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 67 */
      return
	 atom_cinfo_value_set__32_cfa_info(
	 (atom_bglt) (obj_5549), val1648_5550);
   }
}



/* atom/cinfo-value */
obj_t 
atom_cinfo_value_110_cfa_info(atom_bglt obj_451)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 67 */
      return
	 (((atom_bglt) CREF(obj_451))->value);
   }
}



/* _atom/cinfo-value2969 */
obj_t 
_atom_cinfo_value2969_57_cfa_info(obj_t env_5551, obj_t obj_5552)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 67 */
      return
	 atom_cinfo_value_110_cfa_info(
	 (atom_bglt) (obj_5552));
   }
}



/* atom/cinfo-approx */
approx_bglt 
atom_cinfo_approx_215_cfa_info(atom_cinfo_155_bglt obj_452)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 67 */
      {
	 obj_t aux_8111;
	 {	/* Cfa/cinfo.scm 67 */
	    object_bglt aux_8112;
	    aux_8112 =
	       (object_bglt) (obj_452);
	    aux_8111 =
	       OBJECT_WIDENING(aux_8112);
	 }
	 return
	    (((atom_cinfo_155_bglt) CREF(aux_8111))->approx);
      }
   }
}



/* _atom/cinfo-approx2970 */
obj_t 
_atom_cinfo_approx2970_76_cfa_info(obj_t env_5553, obj_t obj_5554)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 67 */
      {		/* Cfa/cinfo.scm 67 */
	 approx_bglt aux_8116;
	 aux_8116 =
	    atom_cinfo_approx_215_cfa_info(
	    (atom_cinfo_155_bglt) (obj_5554));
	 return
	    (obj_t) (aux_8116);
      }
   }
}



/* allocate-reshaped-global */
global_bglt 
allocate_reshaped_global_131_cfa_info()
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 64 */
      {		/* Cfa/cinfo.scm 64 */
	 global_bglt new1640_1817;
	 new1640_1817 =
	    ((global_bglt) BREF(GC_MALLOC(sizeof(struct global))));
	 {	/* Cfa/cinfo.scm 64 */
	    long arg2326_1818;
	    arg2326_1818 =
	       class_num_218___object(reshaped_global_160_cfa_info);
	    {	/* Cfa/cinfo.scm 64 */
	       obj_t obj_3453;
	       obj_3453 =
		  (obj_t) (new1640_1817);
	       (((obj_t) CREF(obj_3453))->header = MAKE_HEADER(arg2326_1818, 0), BUNSPEC);
	    }
	 }
	 {	/* Cfa/cinfo.scm 64 */
	    object_bglt aux_8124;
	    aux_8124 =
	       (object_bglt) (new1640_1817);
	    OBJECT_WIDENING_SET(aux_8124, BFALSE);
	 }
	 return new1640_1817;
      }
   }
}



/* _allocate-reshaped-global */
obj_t 
_allocate_reshaped_global_82_cfa_info(obj_t env_4906)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 64 */
      {		/* Cfa/cinfo.scm 64 */
	 global_bglt aux_8127;
	 aux_8127 =
	    allocate_reshaped_global_131_cfa_info();
	 return
	    (obj_t) (aux_8127);
      }
   }
}



/* reshaped-global? */
bool_t 
reshaped_global__139_cfa_info(obj_t obj_456)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 64 */
      return
	 is_a__118___object(obj_456, reshaped_global_160_cfa_info);
   }
}



/* _reshaped-global? */
obj_t 
_reshaped_global__169_cfa_info(obj_t env_5555, obj_t obj_5556)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 64 */
      {		/* Cfa/cinfo.scm 64 */
	 bool_t aux_8131;
	 aux_8131 =
	    reshaped_global__139_cfa_info(obj_5556);
	 return
	    BBOOL(aux_8131);
      }
   }
}



/* widening-reshaped-global */
reshaped_global_160_bglt 
widening_reshaped_global_26_cfa_info()
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 64 */
      {		/* Cfa/cinfo.scm 64 */

	 return
	    ((reshaped_global_160_bglt) BREF(GC_MALLOC(sizeof(struct reshaped_global_160))));
      }
   }
}



/* _widening-reshaped-global */
obj_t 
_widening_reshaped_global_191_cfa_info(obj_t env_5557)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 64 */
      {		/* Cfa/cinfo.scm 64 */
	 reshaped_global_160_bglt aux_8135;
	 aux_8135 =
	    widening_reshaped_global_26_cfa_info();
	 return
	    (obj_t) (aux_8135);
      }
   }
}



/* make-reshaped-global */
reshaped_global_160_bglt 
make_reshaped_global_202_cfa_info(obj_t id_457, obj_t name_458, type_bglt type_459, value_bglt value_460, obj_t access_461, obj_t fast_alpha_7_462, obj_t removable_463, long occurrence_464, obj_t module_465, obj_t import_466, bool_t evaluable__248_467, bool_t library__255_468, bool_t user__32_469, obj_t pragma_470, obj_t src_471)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 64 */
      {		/* Cfa/cinfo.scm 64 */
	 global_bglt aux1638_3456;
	 {	/* Cfa/cinfo.scm 64 */
	    global_bglt res2721_3494;
	    {	/* ./Ast/var.scm 510 */
	       global_bglt new1063_3475;
	       new1063_3475 =
		  ((global_bglt) BREF(GC_MALLOC(sizeof(struct global))));
	       {	/* ./Ast/var.scm 510 */
		  long arg2421_3476;
		  arg2421_3476 =
		     class_num_218___object(global_ast_var);
		  {	/* ./Ast/var.scm 510 */
		     obj_t obj_3492;
		     obj_3492 =
			(obj_t) (new1063_3475);
		     (((obj_t) CREF(obj_3492))->header = MAKE_HEADER(arg2421_3476, 0), BUNSPEC);
		  }
	       }
	       {	/* ./Ast/var.scm 510 */
		  object_bglt aux_8142;
		  aux_8142 =
		     (object_bglt) (new1063_3475);
		  OBJECT_WIDENING_SET(aux_8142, BFALSE);
	       }
	       ((((global_bglt) CREF(new1063_3475))->id) = ((obj_t) id_457), BUNSPEC);
	       ((((global_bglt) CREF(new1063_3475))->name) = ((obj_t) name_458), BUNSPEC);
	       ((((global_bglt) CREF(new1063_3475))->type) = ((type_bglt) type_459), BUNSPEC);
	       ((((global_bglt) CREF(new1063_3475))->value) = ((value_bglt) value_460), BUNSPEC);
	       ((((global_bglt) CREF(new1063_3475))->access) = ((obj_t) access_461), BUNSPEC);
	       ((((global_bglt) CREF(new1063_3475))->fast_alpha_7) = ((obj_t) fast_alpha_7_462), BUNSPEC);
	       ((((global_bglt) CREF(new1063_3475))->removable) = ((obj_t) removable_463), BUNSPEC);
	       ((((global_bglt) CREF(new1063_3475))->occurrence) = ((long) occurrence_464), BUNSPEC);
	       ((((global_bglt) CREF(new1063_3475))->module) = ((obj_t) module_465), BUNSPEC);
	       ((((global_bglt) CREF(new1063_3475))->import) = ((obj_t) import_466), BUNSPEC);
	       ((((global_bglt) CREF(new1063_3475))->evaluable__248) = ((bool_t) evaluable__248_467), BUNSPEC);
	       ((((global_bglt) CREF(new1063_3475))->library__255) = ((bool_t) library__255_468), BUNSPEC);
	       ((((global_bglt) CREF(new1063_3475))->user__32) = ((bool_t) user__32_469), BUNSPEC);
	       ((((global_bglt) CREF(new1063_3475))->pragma) = ((obj_t) pragma_470), BUNSPEC);
	       ((((global_bglt) CREF(new1063_3475))->src) = ((obj_t) src_471), BUNSPEC);
	       res2721_3494 = new1063_3475;
	    }
	    aux1638_3456 = res2721_3494;
	 }
	 {	/* Cfa/cinfo.scm 64 */
	    reshaped_global_160_bglt new1639_3457;
	    new1639_3457 =
	       ((reshaped_global_160_bglt) (aux1638_3456));
	    {	/* Cfa/cinfo.scm 64 */
	       long arg2327_3458;
	       arg2327_3458 =
		  class_num_218___object(reshaped_global_160_cfa_info);
	       {	/* Cfa/cinfo.scm 64 */
		  obj_t obj_3495;
		  obj_3495 =
		     (obj_t) (new1639_3457);
		  (((obj_t) CREF(obj_3495))->header = MAKE_HEADER(arg2327_3458, 0), BUNSPEC);
	       }
	    }
	    {	/* Cfa/cinfo.scm 64 */
	       obj_t aux_8166;
	       object_bglt aux_8164;
	       {	/* Cfa/cinfo.scm 64 */
		  reshaped_global_160_bglt aux_8167;
		  {	/* Cfa/cinfo.scm 64 */

		     aux_8167 =
			((reshaped_global_160_bglt) BREF(GC_MALLOC(sizeof(struct reshaped_global_160))));
		  }
		  aux_8166 =
		     (obj_t) (aux_8167);
	       }
	       aux_8164 =
		  (object_bglt) (new1639_3457);
	       OBJECT_WIDENING_SET(aux_8164, aux_8166);
	    }
	    return new1639_3457;
	 }
      }
   }
}



/* _make-reshaped-global2971 */
obj_t 
_make_reshaped_global2971_92_cfa_info(obj_t env_5558, obj_t id_5559, obj_t name_5560, obj_t type_5561, obj_t value_5562, obj_t access_5563, obj_t fast_alpha_7_5564, obj_t removable_5565, obj_t occurrence_5566, obj_t module_5567, obj_t import_5568, obj_t evaluable__248_5569, obj_t library__255_5570, obj_t user__32_5571, obj_t pragma_5572, obj_t src_5573)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 64 */
      {		/* Cfa/cinfo.scm 64 */
	 reshaped_global_160_bglt aux_8171;
	 aux_8171 =
	    make_reshaped_global_202_cfa_info(id_5559, name_5560,
	    (type_bglt) (type_5561),
	    (value_bglt) (value_5562), access_5563, fast_alpha_7_5564, removable_5565,
	    (long) CINT(occurrence_5566), module_5567, import_5568,
	    CBOOL(evaluable__248_5569),
	    CBOOL(library__255_5570),
	    CBOOL(user__32_5571), pragma_5572, src_5573);
	 return
	    (obj_t) (aux_8171);
      }
   }
}



/* reshaped-global-id */
obj_t 
reshaped_global_id_236_cfa_info(global_bglt obj_472)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 489 */
      return
	 (((global_bglt) CREF(obj_472))->id);
   }
}



/* _reshaped-global-id2972 */
obj_t 
_reshaped_global_id2972_26_cfa_info(obj_t env_5574, obj_t obj_5575)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 489 */
      return
	 reshaped_global_id_236_cfa_info(
	 (global_bglt) (obj_5575));
   }
}



/* reshaped-global-name-set! */
obj_t 
reshaped_global_name_set__33_cfa_info(global_bglt obj_473, obj_t val1624_474)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 491 */
      return
	 ((((global_bglt) CREF(obj_473))->name) = ((obj_t) val1624_474), BUNSPEC);
   }
}



/* _reshaped-global-name-set!2973 */
obj_t 
_reshaped_global_name_set_2973_23_cfa_info(obj_t env_5576, obj_t obj_5577, obj_t val1624_5578)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 491 */
      return
	 reshaped_global_name_set__33_cfa_info(
	 (global_bglt) (obj_5577), val1624_5578);
   }
}



/* reshaped-global-name */
obj_t 
reshaped_global_name_190_cfa_info(global_bglt obj_475)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 491 */
      return
	 (((global_bglt) CREF(obj_475))->name);
   }
}



/* _reshaped-global-name2974 */
obj_t 
_reshaped_global_name2974_143_cfa_info(obj_t env_5579, obj_t obj_5580)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 491 */
      return
	 reshaped_global_name_190_cfa_info(
	 (global_bglt) (obj_5580));
   }
}



/* reshaped-global-type-set! */
obj_t 
reshaped_global_type_set__56_cfa_info(global_bglt obj_476, type_bglt val1625_477)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 493 */
      return
	 ((((global_bglt) CREF(obj_476))->type) = ((type_bglt) val1625_477), BUNSPEC);
   }
}



/* _reshaped-global-type-set!2975 */
obj_t 
_reshaped_global_type_set_2975_43_cfa_info(obj_t env_5581, obj_t obj_5582, obj_t val1625_5583)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 493 */
      return
	 reshaped_global_type_set__56_cfa_info(
	 (global_bglt) (obj_5582),
	 (type_bglt) (val1625_5583));
   }
}



/* reshaped-global-type */
type_bglt 
reshaped_global_type_121_cfa_info(global_bglt obj_478)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 493 */
      return
	 (((global_bglt) CREF(obj_478))->type);
   }
}



/* _reshaped-global-type2976 */
obj_t 
_reshaped_global_type2976_28_cfa_info(obj_t env_5584, obj_t obj_5585)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 493 */
      {		/* ./Ast/var.scm 493 */
	 type_bglt aux_8194;
	 aux_8194 =
	    reshaped_global_type_121_cfa_info(
	    (global_bglt) (obj_5585));
	 return
	    (obj_t) (aux_8194);
      }
   }
}



/* reshaped-global-value-set! */
obj_t 
reshaped_global_value_set__202_cfa_info(global_bglt obj_479, value_bglt val1626_480)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 64 */
      return
	 ((((global_bglt) CREF(obj_479))->value) = ((value_bglt) val1626_480), BUNSPEC);
   }
}



/* _reshaped-global-value-set!2977 */
obj_t 
_reshaped_global_value_set_2977_126_cfa_info(obj_t env_5586, obj_t obj_5587, obj_t val1626_5588)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 64 */
      return
	 reshaped_global_value_set__202_cfa_info(
	 (global_bglt) (obj_5587),
	 (value_bglt) (val1626_5588));
   }
}



/* reshaped-global-value */
value_bglt 
reshaped_global_value_27_cfa_info(global_bglt obj_481)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 64 */
      return
	 (((global_bglt) CREF(obj_481))->value);
   }
}



/* _reshaped-global-value2978 */
obj_t 
_reshaped_global_value2978_206_cfa_info(obj_t env_5589, obj_t obj_5590)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 64 */
      {		/* Cfa/cinfo.scm 64 */
	 value_bglt aux_8203;
	 aux_8203 =
	    reshaped_global_value_27_cfa_info(
	    (global_bglt) (obj_5590));
	 return
	    (obj_t) (aux_8203);
      }
   }
}



/* reshaped-global-access-set! */
obj_t 
reshaped_global_access_set__53_cfa_info(global_bglt obj_482, obj_t val1627_483)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 497 */
      return
	 ((((global_bglt) CREF(obj_482))->access) = ((obj_t) val1627_483), BUNSPEC);
   }
}



/* _reshaped-global-access-set!2979 */
obj_t 
_reshaped_global_access_set_2979_29_cfa_info(obj_t env_5591, obj_t obj_5592, obj_t val1627_5593)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 497 */
      return
	 reshaped_global_access_set__53_cfa_info(
	 (global_bglt) (obj_5592), val1627_5593);
   }
}



/* reshaped-global-access */
obj_t 
reshaped_global_access_146_cfa_info(global_bglt obj_484)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 497 */
      return
	 (((global_bglt) CREF(obj_484))->access);
   }
}



/* _reshaped-global-access2980 */
obj_t 
_reshaped_global_access2980_133_cfa_info(obj_t env_5594, obj_t obj_5595)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 497 */
      return
	 reshaped_global_access_146_cfa_info(
	 (global_bglt) (obj_5595));
   }
}



/* reshaped-global-fast-alpha-set! */
obj_t 
reshaped_global_fast_alpha_set__126_cfa_info(global_bglt obj_485, obj_t val1628_486)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 504 */
      return
	 ((((global_bglt) CREF(obj_485))->fast_alpha_7) = ((obj_t) val1628_486), BUNSPEC);
   }
}



/* _reshaped-global-fast-alpha-set!2981 */
obj_t 
_reshaped_global_fast_alpha_set_2981_97_cfa_info(obj_t env_5596, obj_t obj_5597, obj_t val1628_5598)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 504 */
      return
	 reshaped_global_fast_alpha_set__126_cfa_info(
	 (global_bglt) (obj_5597), val1628_5598);
   }
}



/* reshaped-global-fast-alpha */
obj_t 
reshaped_global_fast_alpha_178_cfa_info(global_bglt obj_487)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 504 */
      return
	 (((global_bglt) CREF(obj_487))->fast_alpha_7);
   }
}



/* _reshaped-global-fast-alpha2982 */
obj_t 
_reshaped_global_fast_alpha2982_2_cfa_info(obj_t env_5599, obj_t obj_5600)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 504 */
      return
	 reshaped_global_fast_alpha_178_cfa_info(
	 (global_bglt) (obj_5600));
   }
}



/* reshaped-global-removable-set! */
obj_t 
reshaped_global_removable_set__53_cfa_info(global_bglt obj_488, obj_t val1629_489)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 506 */
      return
	 ((((global_bglt) CREF(obj_488))->removable) = ((obj_t) val1629_489), BUNSPEC);
   }
}



/* _reshaped-global-removable-set!2983 */
obj_t 
_reshaped_global_removable_set_2983_192_cfa_info(obj_t env_5601, obj_t obj_5602, obj_t val1629_5603)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 506 */
      return
	 reshaped_global_removable_set__53_cfa_info(
	 (global_bglt) (obj_5602), val1629_5603);
   }
}



/* reshaped-global-removable */
obj_t 
reshaped_global_removable_146_cfa_info(global_bglt obj_490)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 506 */
      return
	 (((global_bglt) CREF(obj_490))->removable);
   }
}



/* _reshaped-global-removable2984 */
obj_t 
_reshaped_global_removable2984_107_cfa_info(obj_t env_5604, obj_t obj_5605)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 506 */
      return
	 reshaped_global_removable_146_cfa_info(
	 (global_bglt) (obj_5605));
   }
}



/* reshaped-global-occurrence-set! */
obj_t 
reshaped_global_occurrence_set__92_cfa_info(global_bglt obj_491, long val1630_492)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 508 */
      return
	 ((((global_bglt) CREF(obj_491))->occurrence) = ((long) val1630_492), BUNSPEC);
   }
}



/* _reshaped-global-occurrence-set!2985 */
obj_t 
_reshaped_global_occurrence_set_2985_192_cfa_info(obj_t env_5606, obj_t obj_5607, obj_t val1630_5608)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 508 */
      return
	 reshaped_global_occurrence_set__92_cfa_info(
	 (global_bglt) (obj_5607),
	 (long) CINT(val1630_5608));
   }
}



/* reshaped-global-occurrence */
long 
reshaped_global_occurrence_72_cfa_info(global_bglt obj_493)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 508 */
      return
	 (((global_bglt) CREF(obj_493))->occurrence);
   }
}



/* _reshaped-global-occurrence2986 */
obj_t 
_reshaped_global_occurrence2986_61_cfa_info(obj_t env_5609, obj_t obj_5610)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 508 */
      {		/* ./Ast/var.scm 508 */
	 long aux_8230;
	 aux_8230 =
	    reshaped_global_occurrence_72_cfa_info(
	    (global_bglt) (obj_5610));
	 return
	    BINT(aux_8230);
      }
   }
}



/* reshaped-global-module */
obj_t 
reshaped_global_module_134_cfa_info(global_bglt obj_494)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 512 */
      return
	 (((global_bglt) CREF(obj_494))->module);
   }
}



/* _reshaped-global-module2987 */
obj_t 
_reshaped_global_module2987_48_cfa_info(obj_t env_5611, obj_t obj_5612)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 512 */
      return
	 reshaped_global_module_134_cfa_info(
	 (global_bglt) (obj_5612));
   }
}



/* reshaped-global-import-set! */
obj_t 
reshaped_global_import_set__167_cfa_info(global_bglt obj_495, obj_t val1631_496)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 514 */
      return
	 ((((global_bglt) CREF(obj_495))->import) = ((obj_t) val1631_496), BUNSPEC);
   }
}



/* _reshaped-global-import-set!2988 */
obj_t 
_reshaped_global_import_set_2988_212_cfa_info(obj_t env_5613, obj_t obj_5614, obj_t val1631_5615)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 514 */
      return
	 reshaped_global_import_set__167_cfa_info(
	 (global_bglt) (obj_5614), val1631_5615);
   }
}



/* reshaped-global-import */
obj_t 
reshaped_global_import_91_cfa_info(global_bglt obj_497)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 514 */
      return
	 (((global_bglt) CREF(obj_497))->import);
   }
}



/* _reshaped-global-import2989 */
obj_t 
_reshaped_global_import2989_163_cfa_info(obj_t env_5616, obj_t obj_5617)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 514 */
      return
	 reshaped_global_import_91_cfa_info(
	 (global_bglt) (obj_5617));
   }
}



/* reshaped-global-evaluable?-set! */
obj_t 
reshaped_global_evaluable__set__240_cfa_info(global_bglt obj_498, bool_t val1632_499)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 517 */
      return
	 ((((global_bglt) CREF(obj_498))->evaluable__248) = ((bool_t) val1632_499), BUNSPEC);
   }
}



/* _reshaped-global-evaluable?-set!2990 */
obj_t 
_reshaped_global_evaluable__set_2990_171_cfa_info(obj_t env_5618, obj_t obj_5619, obj_t val1632_5620)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 517 */
      return
	 reshaped_global_evaluable__set__240_cfa_info(
	 (global_bglt) (obj_5619),
	 CBOOL(val1632_5620));
   }
}



/* reshaped-global-evaluable? */
bool_t 
reshaped_global_evaluable__213_cfa_info(global_bglt obj_500)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 517 */
      return
	 (((global_bglt) CREF(obj_500))->evaluable__248);
   }
}



/* _reshaped-global-evaluable?2991 */
obj_t 
_reshaped_global_evaluable_2991_2_cfa_info(obj_t env_5621, obj_t obj_5622)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 517 */
      {		/* ./Ast/var.scm 517 */
	 bool_t aux_8248;
	 aux_8248 =
	    reshaped_global_evaluable__213_cfa_info(
	    (global_bglt) (obj_5622));
	 return
	    BBOOL(aux_8248);
      }
   }
}



/* reshaped-global-library?-set! */
obj_t 
reshaped_global_library__set__109_cfa_info(global_bglt obj_501, bool_t val1633_502)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 519 */
      return
	 ((((global_bglt) CREF(obj_501))->library__255) = ((bool_t) val1633_502), BUNSPEC);
   }
}



/* _reshaped-global-library?-set!2992 */
obj_t 
_reshaped_global_library__set_2992_245_cfa_info(obj_t env_5623, obj_t obj_5624, obj_t val1633_5625)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 519 */
      return
	 reshaped_global_library__set__109_cfa_info(
	 (global_bglt) (obj_5624),
	 CBOOL(val1633_5625));
   }
}



/* reshaped-global-library? */
bool_t 
reshaped_global_library__243_cfa_info(global_bglt obj_503)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 519 */
      return
	 (((global_bglt) CREF(obj_503))->library__255);
   }
}



/* _reshaped-global-library?2993 */
obj_t 
_reshaped_global_library_2993_186_cfa_info(obj_t env_5626, obj_t obj_5627)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 519 */
      {		/* ./Ast/var.scm 519 */
	 bool_t aux_8257;
	 aux_8257 =
	    reshaped_global_library__243_cfa_info(
	    (global_bglt) (obj_5627));
	 return
	    BBOOL(aux_8257);
      }
   }
}



/* reshaped-global-user?-set! */
obj_t 
reshaped_global_user__set__184_cfa_info(global_bglt obj_504, bool_t val1634_505)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 524 */
      return
	 ((((global_bglt) CREF(obj_504))->user__32) = ((bool_t) val1634_505), BUNSPEC);
   }
}



/* _reshaped-global-user?-set!2994 */
obj_t 
_reshaped_global_user__set_2994_92_cfa_info(obj_t env_5628, obj_t obj_5629, obj_t val1634_5630)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 524 */
      return
	 reshaped_global_user__set__184_cfa_info(
	 (global_bglt) (obj_5629),
	 CBOOL(val1634_5630));
   }
}



/* reshaped-global-user? */
bool_t 
reshaped_global_user__181_cfa_info(global_bglt obj_506)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 524 */
      return
	 (((global_bglt) CREF(obj_506))->user__32);
   }
}



/* _reshaped-global-user?2995 */
obj_t 
_reshaped_global_user_2995_142_cfa_info(obj_t env_5631, obj_t obj_5632)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 524 */
      {		/* ./Ast/var.scm 524 */
	 bool_t aux_8266;
	 aux_8266 =
	    reshaped_global_user__181_cfa_info(
	    (global_bglt) (obj_5632));
	 return
	    BBOOL(aux_8266);
      }
   }
}



/* reshaped-global-pragma */
obj_t 
reshaped_global_pragma_7_cfa_info(global_bglt obj_507)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 526 */
      return
	 (((global_bglt) CREF(obj_507))->pragma);
   }
}



/* _reshaped-global-pragma2996 */
obj_t 
_reshaped_global_pragma2996_199_cfa_info(obj_t env_5633, obj_t obj_5634)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 526 */
      return
	 reshaped_global_pragma_7_cfa_info(
	 (global_bglt) (obj_5634));
   }
}



/* reshaped-global-src-set! */
obj_t 
reshaped_global_src_set__220_cfa_info(global_bglt obj_508, obj_t val1635_509)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 64 */
      return
	 ((((global_bglt) CREF(obj_508))->src) = ((obj_t) val1635_509), BUNSPEC);
   }
}



/* _reshaped-global-src-set!2997 */
obj_t 
_reshaped_global_src_set_2997_68_cfa_info(obj_t env_5635, obj_t obj_5636, obj_t val1635_5637)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 64 */
      return
	 reshaped_global_src_set__220_cfa_info(
	 (global_bglt) (obj_5636), val1635_5637);
   }
}



/* reshaped-global-src */
obj_t 
reshaped_global_src_255_cfa_info(global_bglt obj_510)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 64 */
      return
	 (((global_bglt) CREF(obj_510))->src);
   }
}



/* _reshaped-global-src2998 */
obj_t 
_reshaped_global_src2998_228_cfa_info(obj_t env_5638, obj_t obj_5639)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 64 */
      return
	 reshaped_global_src_255_cfa_info(
	 (global_bglt) (obj_5639));
   }
}



/* allocate-reshaped-local */
local_bglt 
allocate_reshaped_local_100_cfa_info()
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 62 */
      {		/* Cfa/cinfo.scm 62 */
	 local_bglt new1617_1824;
	 new1617_1824 =
	    ((local_bglt) BREF(GC_MALLOC(sizeof(struct local))));
	 {	/* Cfa/cinfo.scm 62 */
	    long arg2329_1825;
	    arg2329_1825 =
	       class_num_218___object(reshaped_local_224_cfa_info);
	    {	/* Cfa/cinfo.scm 62 */
	       obj_t obj_3499;
	       obj_3499 =
		  (obj_t) (new1617_1824);
	       (((obj_t) CREF(obj_3499))->header = MAKE_HEADER(arg2329_1825, 0), BUNSPEC);
	    }
	 }
	 {	/* Cfa/cinfo.scm 62 */
	    object_bglt aux_8283;
	    aux_8283 =
	       (object_bglt) (new1617_1824);
	    OBJECT_WIDENING_SET(aux_8283, BFALSE);
	 }
	 return new1617_1824;
      }
   }
}



/* _allocate-reshaped-local */
obj_t 
_allocate_reshaped_local_17_cfa_info(obj_t env_4905)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 62 */
      {		/* Cfa/cinfo.scm 62 */
	 local_bglt aux_8286;
	 aux_8286 =
	    allocate_reshaped_local_100_cfa_info();
	 return
	    (obj_t) (aux_8286);
      }
   }
}



/* reshaped-local? */
bool_t 
reshaped_local__109_cfa_info(obj_t obj_514)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 62 */
      return
	 is_a__118___object(obj_514, reshaped_local_224_cfa_info);
   }
}



/* _reshaped-local? */
obj_t 
_reshaped_local__93_cfa_info(obj_t env_5640, obj_t obj_5641)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 62 */
      {		/* Cfa/cinfo.scm 62 */
	 bool_t aux_8290;
	 aux_8290 =
	    reshaped_local__109_cfa_info(obj_5641);
	 return
	    BBOOL(aux_8290);
      }
   }
}



/* widening-reshaped-local */
reshaped_local_224_bglt 
widening_reshaped_local_92_cfa_info(obj_t binding_value_3_515)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 62 */
      {		/* Cfa/cinfo.scm 62 */
	 reshaped_local_224_bglt new1612_3501;
	 new1612_3501 =
	    ((reshaped_local_224_bglt) BREF(GC_MALLOC(sizeof(struct reshaped_local_224))));
	 ((((reshaped_local_224_bglt) CREF(new1612_3501))->binding_value_3) = ((obj_t) binding_value_3_515), BUNSPEC);
	 return new1612_3501;
      }
   }
}



/* _widening-reshaped-local */
obj_t 
_widening_reshaped_local_170_cfa_info(obj_t env_5642, obj_t binding_value_3_5643)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 62 */
      {		/* Cfa/cinfo.scm 62 */
	 reshaped_local_224_bglt aux_8295;
	 aux_8295 =
	    widening_reshaped_local_92_cfa_info(binding_value_3_5643);
	 return
	    (obj_t) (aux_8295);
      }
   }
}



/* make-reshaped-local */
reshaped_local_224_bglt 
make_reshaped_local_12_cfa_info(obj_t id_516, obj_t name_517, type_bglt type_518, value_bglt value_519, obj_t access_520, obj_t fast_alpha_7_521, obj_t removable_522, long occurrence_523, bool_t user__32_524, long key_525, obj_t binding_value_3_526)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 62 */
      {		/* Cfa/cinfo.scm 62 */
	 local_bglt aux1615_3503;
	 {	/* Cfa/cinfo.scm 62 */
	    local_bglt res2723_3531;
	    {	/* ./Ast/var.scm 530 */
	       local_bglt new1089_3517;
	       new1089_3517 =
		  ((local_bglt) BREF(GC_MALLOC(sizeof(struct local))));
	       {	/* ./Ast/var.scm 530 */
		  long arg2419_3518;
		  arg2419_3518 =
		     class_num_218___object(local_ast_var);
		  {	/* ./Ast/var.scm 530 */
		     obj_t obj_3529;
		     obj_3529 =
			(obj_t) (new1089_3517);
		     (((obj_t) CREF(obj_3529))->header = MAKE_HEADER(arg2419_3518, 0), BUNSPEC);
		  }
	       }
	       {	/* ./Ast/var.scm 530 */
		  object_bglt aux_8302;
		  aux_8302 =
		     (object_bglt) (new1089_3517);
		  OBJECT_WIDENING_SET(aux_8302, BFALSE);
	       }
	       ((((local_bglt) CREF(new1089_3517))->id) = ((obj_t) id_516), BUNSPEC);
	       ((((local_bglt) CREF(new1089_3517))->name) = ((obj_t) name_517), BUNSPEC);
	       ((((local_bglt) CREF(new1089_3517))->type) = ((type_bglt) type_518), BUNSPEC);
	       ((((local_bglt) CREF(new1089_3517))->value) = ((value_bglt) value_519), BUNSPEC);
	       ((((local_bglt) CREF(new1089_3517))->access) = ((obj_t) access_520), BUNSPEC);
	       ((((local_bglt) CREF(new1089_3517))->fast_alpha_7) = ((obj_t) fast_alpha_7_521), BUNSPEC);
	       ((((local_bglt) CREF(new1089_3517))->removable) = ((obj_t) removable_522), BUNSPEC);
	       ((((local_bglt) CREF(new1089_3517))->occurrence) = ((long) occurrence_523), BUNSPEC);
	       ((((local_bglt) CREF(new1089_3517))->user__32) = ((bool_t) user__32_524), BUNSPEC);
	       ((((local_bglt) CREF(new1089_3517))->key) = ((long) key_525), BUNSPEC);
	       res2723_3531 = new1089_3517;
	    }
	    aux1615_3503 = res2723_3531;
	 }
	 {	/* Cfa/cinfo.scm 62 */
	    reshaped_local_224_bglt new1616_3504;
	    new1616_3504 =
	       ((reshaped_local_224_bglt) (aux1615_3503));
	    {	/* Cfa/cinfo.scm 62 */
	       long arg2330_3505;
	       arg2330_3505 =
		  class_num_218___object(reshaped_local_224_cfa_info);
	       {	/* Cfa/cinfo.scm 62 */
		  obj_t obj_3532;
		  obj_3532 =
		     (obj_t) (new1616_3504);
		  (((obj_t) CREF(obj_3532))->header = MAKE_HEADER(arg2330_3505, 0), BUNSPEC);
	       }
	    }
	    {	/* Cfa/cinfo.scm 62 */
	       reshaped_local_224_bglt arg2331_3506;
	       {	/* Cfa/cinfo.scm 62 */
		  reshaped_local_224_bglt res2724_3537;
		  {	/* Cfa/cinfo.scm 62 */
		     reshaped_local_224_bglt new1612_3535;
		     new1612_3535 =
			((reshaped_local_224_bglt) BREF(GC_MALLOC(sizeof(struct reshaped_local_224))));
		     ((((reshaped_local_224_bglt) CREF(new1612_3535))->binding_value_3) = ((obj_t) binding_value_3_526), BUNSPEC);
		     res2724_3537 = new1612_3535;
		  }
		  arg2331_3506 = res2724_3537;
	       }
	       {	/* Cfa/cinfo.scm 62 */
		  obj_t aux_8323;
		  object_bglt aux_8321;
		  aux_8323 =
		     (obj_t) (arg2331_3506);
		  aux_8321 =
		     (object_bglt) (new1616_3504);
		  OBJECT_WIDENING_SET(aux_8321, aux_8323);
	       }
	    }
	    return new1616_3504;
	 }
      }
   }
}



/* _make-reshaped-local2999 */
obj_t 
_make_reshaped_local2999_202_cfa_info(obj_t env_5644, obj_t id_5645, obj_t name_5646, obj_t type_5647, obj_t value_5648, obj_t access_5649, obj_t fast_alpha_7_5650, obj_t removable_5651, obj_t occurrence_5652, obj_t user__32_5653, obj_t key_5654, obj_t binding_value_3_5655)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 62 */
      {		/* Cfa/cinfo.scm 62 */
	 reshaped_local_224_bglt aux_8326;
	 aux_8326 =
	    make_reshaped_local_12_cfa_info(id_5645, name_5646,
	    (type_bglt) (type_5647),
	    (value_bglt) (value_5648), access_5649, fast_alpha_7_5650, removable_5651,
	    (long) CINT(occurrence_5652),
	    CBOOL(user__32_5653),
	    (long) CINT(key_5654), binding_value_3_5655);
	 return
	    (obj_t) (aux_8326);
      }
   }
}



/* reshaped-local-id */
obj_t 
reshaped_local_id_99_cfa_info(local_bglt obj_527)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 489 */
      return
	 (((local_bglt) CREF(obj_527))->id);
   }
}



/* _reshaped-local-id3000 */
obj_t 
_reshaped_local_id3000_56_cfa_info(obj_t env_5656, obj_t obj_5657)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 489 */
      return
	 reshaped_local_id_99_cfa_info(
	 (local_bglt) (obj_5657));
   }
}



/* reshaped-local-name-set! */
obj_t 
reshaped_local_name_set__115_cfa_info(local_bglt obj_528, obj_t val1604_529)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 491 */
      return
	 ((((local_bglt) CREF(obj_528))->name) = ((obj_t) val1604_529), BUNSPEC);
   }
}



/* _reshaped-local-name-set!3001 */
obj_t 
_reshaped_local_name_set_3001_16_cfa_info(obj_t env_5658, obj_t obj_5659, obj_t val1604_5660)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 491 */
      return
	 reshaped_local_name_set__115_cfa_info(
	 (local_bglt) (obj_5659), val1604_5660);
   }
}



/* reshaped-local-name */
obj_t 
reshaped_local_name_22_cfa_info(local_bglt obj_530)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 491 */
      return
	 (((local_bglt) CREF(obj_530))->name);
   }
}



/* _reshaped-local-name3002 */
obj_t 
_reshaped_local_name3002_125_cfa_info(obj_t env_5661, obj_t obj_5662)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 491 */
      return
	 reshaped_local_name_22_cfa_info(
	 (local_bglt) (obj_5662));
   }
}



/* reshaped-local-type-set! */
obj_t 
reshaped_local_type_set__241_cfa_info(local_bglt obj_531, type_bglt val1605_532)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 493 */
      return
	 ((((local_bglt) CREF(obj_531))->type) = ((type_bglt) val1605_532), BUNSPEC);
   }
}



/* _reshaped-local-type-set!3003 */
obj_t 
_reshaped_local_type_set_3003_238_cfa_info(obj_t env_5663, obj_t obj_5664, obj_t val1605_5665)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 493 */
      return
	 reshaped_local_type_set__241_cfa_info(
	 (local_bglt) (obj_5664),
	 (type_bglt) (val1605_5665));
   }
}



/* reshaped-local-type */
type_bglt 
reshaped_local_type_195_cfa_info(local_bglt obj_533)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 493 */
      return
	 (((local_bglt) CREF(obj_533))->type);
   }
}



/* _reshaped-local-type3004 */
obj_t 
_reshaped_local_type3004_251_cfa_info(obj_t env_5666, obj_t obj_5667)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 493 */
      {		/* ./Ast/var.scm 493 */
	 type_bglt aux_8348;
	 aux_8348 =
	    reshaped_local_type_195_cfa_info(
	    (local_bglt) (obj_5667));
	 return
	    (obj_t) (aux_8348);
      }
   }
}



/* reshaped-local-value-set! */
obj_t 
reshaped_local_value_set__28_cfa_info(local_bglt obj_534, value_bglt val1606_535)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 62 */
      return
	 ((((local_bglt) CREF(obj_534))->value) = ((value_bglt) val1606_535), BUNSPEC);
   }
}



/* _reshaped-local-value-set!3005 */
obj_t 
_reshaped_local_value_set_3005_6_cfa_info(obj_t env_5668, obj_t obj_5669, obj_t val1606_5670)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 62 */
      return
	 reshaped_local_value_set__28_cfa_info(
	 (local_bglt) (obj_5669),
	 (value_bglt) (val1606_5670));
   }
}



/* reshaped-local-value */
value_bglt 
reshaped_local_value_240_cfa_info(local_bglt obj_536)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 62 */
      return
	 (((local_bglt) CREF(obj_536))->value);
   }
}



/* _reshaped-local-value3006 */
obj_t 
_reshaped_local_value3006_248_cfa_info(obj_t env_5671, obj_t obj_5672)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 62 */
      {		/* Cfa/cinfo.scm 62 */
	 value_bglt aux_8357;
	 aux_8357 =
	    reshaped_local_value_240_cfa_info(
	    (local_bglt) (obj_5672));
	 return
	    (obj_t) (aux_8357);
      }
   }
}



/* reshaped-local-access-set! */
obj_t 
reshaped_local_access_set__128_cfa_info(local_bglt obj_537, obj_t val1607_538)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 497 */
      return
	 ((((local_bglt) CREF(obj_537))->access) = ((obj_t) val1607_538), BUNSPEC);
   }
}



/* _reshaped-local-access-set!3007 */
obj_t 
_reshaped_local_access_set_3007_153_cfa_info(obj_t env_5673, obj_t obj_5674, obj_t val1607_5675)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 497 */
      return
	 reshaped_local_access_set__128_cfa_info(
	 (local_bglt) (obj_5674), val1607_5675);
   }
}



/* reshaped-local-access */
obj_t 
reshaped_local_access_5_cfa_info(local_bglt obj_539)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 497 */
      return
	 (((local_bglt) CREF(obj_539))->access);
   }
}



/* _reshaped-local-access3008 */
obj_t 
_reshaped_local_access3008_115_cfa_info(obj_t env_5676, obj_t obj_5677)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 497 */
      return
	 reshaped_local_access_5_cfa_info(
	 (local_bglt) (obj_5677));
   }
}



/* reshaped-local-fast-alpha-set! */
obj_t 
reshaped_local_fast_alpha_set__175_cfa_info(local_bglt obj_540, obj_t val1608_541)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 504 */
      return
	 ((((local_bglt) CREF(obj_540))->fast_alpha_7) = ((obj_t) val1608_541), BUNSPEC);
   }
}



/* _reshaped-local-fast-alpha-set!3009 */
obj_t 
_reshaped_local_fast_alpha_set_3009_148_cfa_info(obj_t env_5678, obj_t obj_5679, obj_t val1608_5680)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 504 */
      return
	 reshaped_local_fast_alpha_set__175_cfa_info(
	 (local_bglt) (obj_5679), val1608_5680);
   }
}



/* reshaped-local-fast-alpha */
obj_t 
reshaped_local_fast_alpha_133_cfa_info(local_bglt obj_542)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 504 */
      return
	 (((local_bglt) CREF(obj_542))->fast_alpha_7);
   }
}



/* _reshaped-local-fast-alpha3010 */
obj_t 
_reshaped_local_fast_alpha3010_58_cfa_info(obj_t env_5681, obj_t obj_5682)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 504 */
      return
	 reshaped_local_fast_alpha_133_cfa_info(
	 (local_bglt) (obj_5682));
   }
}



/* reshaped-local-removable-set! */
obj_t 
reshaped_local_removable_set__25_cfa_info(local_bglt obj_543, obj_t val1609_544)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 506 */
      return
	 ((((local_bglt) CREF(obj_543))->removable) = ((obj_t) val1609_544), BUNSPEC);
   }
}



/* _reshaped-local-removable-set!3011 */
obj_t 
_reshaped_local_removable_set_3011_28_cfa_info(obj_t env_5683, obj_t obj_5684, obj_t val1609_5685)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 506 */
      return
	 reshaped_local_removable_set__25_cfa_info(
	 (local_bglt) (obj_5684), val1609_5685);
   }
}



/* reshaped-local-removable */
obj_t 
reshaped_local_removable_103_cfa_info(local_bglt obj_545)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 506 */
      return
	 (((local_bglt) CREF(obj_545))->removable);
   }
}



/* _reshaped-local-removable3012 */
obj_t 
_reshaped_local_removable3012_168_cfa_info(obj_t env_5686, obj_t obj_5687)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 506 */
      return
	 reshaped_local_removable_103_cfa_info(
	 (local_bglt) (obj_5687));
   }
}



/* reshaped-local-occurrence-set! */
obj_t 
reshaped_local_occurrence_set__7_cfa_info(local_bglt obj_546, long val1610_547)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 508 */
      return
	 ((((local_bglt) CREF(obj_546))->occurrence) = ((long) val1610_547), BUNSPEC);
   }
}



/* _reshaped-local-occurrence-set!3013 */
obj_t 
_reshaped_local_occurrence_set_3013_144_cfa_info(obj_t env_5688, obj_t obj_5689, obj_t val1610_5690)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 508 */
      return
	 reshaped_local_occurrence_set__7_cfa_info(
	 (local_bglt) (obj_5689),
	 (long) CINT(val1610_5690));
   }
}



/* reshaped-local-occurrence */
long 
reshaped_local_occurrence_171_cfa_info(local_bglt obj_548)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 508 */
      return
	 (((local_bglt) CREF(obj_548))->occurrence);
   }
}



/* _reshaped-local-occurrence3014 */
obj_t 
_reshaped_local_occurrence3014_246_cfa_info(obj_t env_5691, obj_t obj_5692)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 508 */
      {		/* ./Ast/var.scm 508 */
	 long aux_8384;
	 aux_8384 =
	    reshaped_local_occurrence_171_cfa_info(
	    (local_bglt) (obj_5692));
	 return
	    BINT(aux_8384);
      }
   }
}



/* reshaped-local-user?-set! */
obj_t 
reshaped_local_user__set__128_cfa_info(local_bglt obj_549, bool_t val1611_550)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 532 */
      return
	 ((((local_bglt) CREF(obj_549))->user__32) = ((bool_t) val1611_550), BUNSPEC);
   }
}



/* _reshaped-local-user?-set!3015 */
obj_t 
_reshaped_local_user__set_3015_24_cfa_info(obj_t env_5693, obj_t obj_5694, obj_t val1611_5695)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 532 */
      return
	 reshaped_local_user__set__128_cfa_info(
	 (local_bglt) (obj_5694),
	 CBOOL(val1611_5695));
   }
}



/* reshaped-local-user? */
bool_t 
reshaped_local_user__5_cfa_info(local_bglt obj_551)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 532 */
      return
	 (((local_bglt) CREF(obj_551))->user__32);
   }
}



/* _reshaped-local-user?3016 */
obj_t 
_reshaped_local_user_3016_191_cfa_info(obj_t env_5696, obj_t obj_5697)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 532 */
      {		/* ./Ast/var.scm 532 */
	 bool_t aux_8393;
	 aux_8393 =
	    reshaped_local_user__5_cfa_info(
	    (local_bglt) (obj_5697));
	 return
	    BBOOL(aux_8393);
      }
   }
}



/* reshaped-local-key */
long 
reshaped_local_key_22_cfa_info(local_bglt obj_552)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 534 */
      return
	 (((local_bglt) CREF(obj_552))->key);
   }
}



/* _reshaped-local-key3017 */
obj_t 
_reshaped_local_key3017_67_cfa_info(obj_t env_5698, obj_t obj_5699)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 534 */
      {		/* ./Ast/var.scm 534 */
	 long aux_8398;
	 aux_8398 =
	    reshaped_local_key_22_cfa_info(
	    (local_bglt) (obj_5699));
	 return
	    BINT(aux_8398);
      }
   }
}



/* reshaped-local-binding-value */
obj_t 
reshaped_local_binding_value_248_cfa_info(reshaped_local_224_bglt obj_553)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 63 */
      {
	 obj_t aux_8402;
	 {	/* Cfa/cinfo.scm 63 */
	    object_bglt aux_8403;
	    aux_8403 =
	       (object_bglt) (obj_553);
	    aux_8402 =
	       OBJECT_WIDENING(aux_8403);
	 }
	 return
	    (((reshaped_local_224_bglt) CREF(aux_8402))->binding_value_3);
      }
   }
}



/* _reshaped-local-binding-value3018 */
obj_t 
_reshaped_local_binding_value3018_38_cfa_info(obj_t env_5700, obj_t obj_5701)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 63 */
      return
	 reshaped_local_binding_value_248_cfa_info(
	 (reshaped_local_224_bglt) (obj_5701));
   }
}



/* allocate-sexit/cinfo */
sexit_bglt 
allocate_sexit_cinfo_160_cfa_info()
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 59 */
      {		/* Cfa/cinfo.scm 59 */
	 sexit_bglt new1597_1832;
	 new1597_1832 =
	    ((sexit_bglt) BREF(GC_MALLOC(sizeof(struct sexit))));
	 {	/* Cfa/cinfo.scm 59 */
	    long arg2332_1833;
	    arg2332_1833 =
	       class_num_218___object(sexit_cinfo_49_cfa_info);
	    {	/* Cfa/cinfo.scm 59 */
	       obj_t obj_3538;
	       obj_3538 =
		  (obj_t) (new1597_1832);
	       (((obj_t) CREF(obj_3538))->header = MAKE_HEADER(arg2332_1833, 0), BUNSPEC);
	    }
	 }
	 {	/* Cfa/cinfo.scm 59 */
	    object_bglt aux_8413;
	    aux_8413 =
	       (object_bglt) (new1597_1832);
	    OBJECT_WIDENING_SET(aux_8413, BFALSE);
	 }
	 return new1597_1832;
      }
   }
}



/* _allocate-sexit/cinfo */
obj_t 
_allocate_sexit_cinfo_64_cfa_info(obj_t env_4904)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 59 */
      {		/* Cfa/cinfo.scm 59 */
	 sexit_bglt aux_8416;
	 aux_8416 =
	    allocate_sexit_cinfo_160_cfa_info();
	 return
	    (obj_t) (aux_8416);
      }
   }
}



/* sexit/cinfo? */
bool_t 
sexit_cinfo__140_cfa_info(obj_t obj_557)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 59 */
      return
	 is_a__118___object(obj_557, sexit_cinfo_49_cfa_info);
   }
}



/* _sexit/cinfo? */
obj_t 
_sexit_cinfo__68_cfa_info(obj_t env_5702, obj_t obj_5703)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 59 */
      {		/* Cfa/cinfo.scm 59 */
	 bool_t aux_8420;
	 aux_8420 =
	    sexit_cinfo__140_cfa_info(obj_5703);
	 return
	    BBOOL(aux_8420);
      }
   }
}



/* widening-sexit/cinfo */
sexit_cinfo_49_bglt 
widening_sexit_cinfo_97_cfa_info(approx_bglt approx_558)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 59 */
      {		/* Cfa/cinfo.scm 59 */
	 sexit_cinfo_49_bglt new1592_3540;
	 new1592_3540 =
	    ((sexit_cinfo_49_bglt) BREF(GC_MALLOC(sizeof(struct sexit_cinfo_49))));
	 ((((sexit_cinfo_49_bglt) CREF(new1592_3540))->approx) = ((approx_bglt) approx_558), BUNSPEC);
	 return new1592_3540;
      }
   }
}



/* _widening-sexit/cinfo3019 */
obj_t 
_widening_sexit_cinfo3019_115_cfa_info(obj_t env_5704, obj_t approx_5705)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 59 */
      {		/* Cfa/cinfo.scm 59 */
	 sexit_cinfo_49_bglt aux_8425;
	 aux_8425 =
	    widening_sexit_cinfo_97_cfa_info(
	    (approx_bglt) (approx_5705));
	 return
	    (obj_t) (aux_8425);
      }
   }
}



/* make-sexit/cinfo */
sexit_cinfo_49_bglt 
make_sexit_cinfo_207_cfa_info(obj_t handler_559, bool_t detached__120_560, approx_bglt approx_561)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 59 */
      {		/* Cfa/cinfo.scm 59 */
	 sexit_bglt aux1595_3542;
	 {	/* Cfa/cinfo.scm 59 */
	    sexit_bglt res2725_3554;
	    {	/* ./Ast/var.scm 599 */
	       sexit_bglt new1179_3548;
	       new1179_3548 =
		  ((sexit_bglt) BREF(GC_MALLOC(sizeof(struct sexit))));
	       {	/* ./Ast/var.scm 599 */
		  long arg2405_3549;
		  arg2405_3549 =
		     class_num_218___object(sexit_ast_var);
		  {	/* ./Ast/var.scm 599 */
		     obj_t obj_3552;
		     obj_3552 =
			(obj_t) (new1179_3548);
		     (((obj_t) CREF(obj_3552))->header = MAKE_HEADER(arg2405_3549, 0), BUNSPEC);
		  }
	       }
	       {	/* ./Ast/var.scm 599 */
		  object_bglt aux_8433;
		  aux_8433 =
		     (object_bglt) (new1179_3548);
		  OBJECT_WIDENING_SET(aux_8433, BFALSE);
	       }
	       ((((sexit_bglt) CREF(new1179_3548))->handler) = ((obj_t) handler_559), BUNSPEC);
	       ((((sexit_bglt) CREF(new1179_3548))->detached__120) = ((bool_t) detached__120_560), BUNSPEC);
	       res2725_3554 = new1179_3548;
	    }
	    aux1595_3542 = res2725_3554;
	 }
	 {	/* Cfa/cinfo.scm 59 */
	    sexit_cinfo_49_bglt new1596_3543;
	    new1596_3543 =
	       ((sexit_cinfo_49_bglt) (aux1595_3542));
	    {	/* Cfa/cinfo.scm 59 */
	       long arg2333_3544;
	       arg2333_3544 =
		  class_num_218___object(sexit_cinfo_49_cfa_info);
	       {	/* Cfa/cinfo.scm 59 */
		  obj_t obj_3555;
		  obj_3555 =
		     (obj_t) (new1596_3543);
		  (((obj_t) CREF(obj_3555))->header = MAKE_HEADER(arg2333_3544, 0), BUNSPEC);
	       }
	    }
	    {	/* Cfa/cinfo.scm 59 */
	       sexit_cinfo_49_bglt arg2334_3545;
	       {	/* Cfa/cinfo.scm 59 */
		  sexit_cinfo_49_bglt res2726_3560;
		  {	/* Cfa/cinfo.scm 59 */
		     sexit_cinfo_49_bglt new1592_3558;
		     new1592_3558 =
			((sexit_cinfo_49_bglt) BREF(GC_MALLOC(sizeof(struct sexit_cinfo_49))));
		     ((((sexit_cinfo_49_bglt) CREF(new1592_3558))->approx) = ((approx_bglt) approx_561), BUNSPEC);
		     res2726_3560 = new1592_3558;
		  }
		  arg2334_3545 = res2726_3560;
	       }
	       {	/* Cfa/cinfo.scm 59 */
		  obj_t aux_8446;
		  object_bglt aux_8444;
		  aux_8446 =
		     (obj_t) (arg2334_3545);
		  aux_8444 =
		     (object_bglt) (new1596_3543);
		  OBJECT_WIDENING_SET(aux_8444, aux_8446);
	       }
	    }
	    return new1596_3543;
	 }
      }
   }
}



/* _make-sexit/cinfo3020 */
obj_t 
_make_sexit_cinfo3020_88_cfa_info(obj_t env_5706, obj_t handler_5707, obj_t detached__120_5708, obj_t approx_5709)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 59 */
      {		/* Cfa/cinfo.scm 59 */
	 sexit_cinfo_49_bglt aux_8449;
	 aux_8449 =
	    make_sexit_cinfo_207_cfa_info(handler_5707,
	    CBOOL(detached__120_5708),
	    (approx_bglt) (approx_5709));
	 return
	    (obj_t) (aux_8449);
      }
   }
}



/* sexit/cinfo-handler-set! */
obj_t 
sexit_cinfo_handler_set__65_cfa_info(sexit_bglt obj_562, obj_t val1590_563)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 59 */
      return
	 ((((sexit_bglt) CREF(obj_562))->handler) = ((obj_t) val1590_563), BUNSPEC);
   }
}



/* _sexit/cinfo-handler-set!3021 */
obj_t 
_sexit_cinfo_handler_set_3021_214_cfa_info(obj_t env_5710, obj_t obj_5711, obj_t val1590_5712)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 59 */
      return
	 sexit_cinfo_handler_set__65_cfa_info(
	 (sexit_bglt) (obj_5711), val1590_5712);
   }
}



/* sexit/cinfo-handler */
obj_t 
sexit_cinfo_handler_23_cfa_info(sexit_bglt obj_564)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 59 */
      return
	 (((sexit_bglt) CREF(obj_564))->handler);
   }
}



/* _sexit/cinfo-handler3022 */
obj_t 
_sexit_cinfo_handler3022_94_cfa_info(obj_t env_5713, obj_t obj_5714)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 59 */
      return
	 sexit_cinfo_handler_23_cfa_info(
	 (sexit_bglt) (obj_5714));
   }
}



/* sexit/cinfo-detached?-set! */
obj_t 
sexit_cinfo_detached__set__246_cfa_info(sexit_bglt obj_565, bool_t val1591_566)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 603 */
      return
	 ((((sexit_bglt) CREF(obj_565))->detached__120) = ((bool_t) val1591_566), BUNSPEC);
   }
}



/* _sexit/cinfo-detached?-set!3023 */
obj_t 
_sexit_cinfo_detached__set_3023_40_cfa_info(obj_t env_5715, obj_t obj_5716, obj_t val1591_5717)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 603 */
      return
	 sexit_cinfo_detached__set__246_cfa_info(
	 (sexit_bglt) (obj_5716),
	 CBOOL(val1591_5717));
   }
}



/* sexit/cinfo-detached? */
bool_t 
sexit_cinfo_detached__124_cfa_info(sexit_bglt obj_567)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 603 */
      return
	 (((sexit_bglt) CREF(obj_567))->detached__120);
   }
}



/* _sexit/cinfo-detached?3024 */
obj_t 
_sexit_cinfo_detached_3024_61_cfa_info(obj_t env_5718, obj_t obj_5719)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 603 */
      {		/* ./Ast/var.scm 603 */
	 bool_t aux_8465;
	 aux_8465 =
	    sexit_cinfo_detached__124_cfa_info(
	    (sexit_bglt) (obj_5719));
	 return
	    BBOOL(aux_8465);
      }
   }
}



/* sexit/cinfo-approx */
approx_bglt 
sexit_cinfo_approx_118_cfa_info(sexit_cinfo_49_bglt obj_568)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 59 */
      {
	 obj_t aux_8469;
	 {	/* Cfa/cinfo.scm 59 */
	    object_bglt aux_8470;
	    aux_8470 =
	       (object_bglt) (obj_568);
	    aux_8469 =
	       OBJECT_WIDENING(aux_8470);
	 }
	 return
	    (((sexit_cinfo_49_bglt) CREF(aux_8469))->approx);
      }
   }
}



/* _sexit/cinfo-approx3025 */
obj_t 
_sexit_cinfo_approx3025_89_cfa_info(obj_t env_5720, obj_t obj_5721)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 59 */
      {		/* Cfa/cinfo.scm 59 */
	 approx_bglt aux_8474;
	 aux_8474 =
	    sexit_cinfo_approx_118_cfa_info(
	    (sexit_cinfo_49_bglt) (obj_5721));
	 return
	    (obj_t) (aux_8474);
      }
   }
}



/* allocate-cvar/cinfo */
cvar_bglt 
allocate_cvar_cinfo_69_cfa_info()
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 56 */
      {		/* Cfa/cinfo.scm 56 */
	 cvar_bglt new1583_1840;
	 new1583_1840 =
	    ((cvar_bglt) BREF(GC_MALLOC(sizeof(struct cvar))));
	 {	/* Cfa/cinfo.scm 56 */
	    long arg2335_1841;
	    arg2335_1841 =
	       class_num_218___object(cvar_cinfo_53_cfa_info);
	    {	/* Cfa/cinfo.scm 56 */
	       obj_t obj_3561;
	       obj_3561 =
		  (obj_t) (new1583_1840);
	       (((obj_t) CREF(obj_3561))->header = MAKE_HEADER(arg2335_1841, 0), BUNSPEC);
	    }
	 }
	 {	/* Cfa/cinfo.scm 56 */
	    object_bglt aux_8482;
	    aux_8482 =
	       (object_bglt) (new1583_1840);
	    OBJECT_WIDENING_SET(aux_8482, BFALSE);
	 }
	 return new1583_1840;
      }
   }
}



/* _allocate-cvar/cinfo */
obj_t 
_allocate_cvar_cinfo_74_cfa_info(obj_t env_4903)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 56 */
      {		/* Cfa/cinfo.scm 56 */
	 cvar_bglt aux_8485;
	 aux_8485 =
	    allocate_cvar_cinfo_69_cfa_info();
	 return
	    (obj_t) (aux_8485);
      }
   }
}



/* cvar/cinfo? */
bool_t 
cvar_cinfo__125_cfa_info(obj_t obj_572)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 56 */
      return
	 is_a__118___object(obj_572, cvar_cinfo_53_cfa_info);
   }
}



/* _cvar/cinfo? */
obj_t 
_cvar_cinfo__113_cfa_info(obj_t env_5722, obj_t obj_5723)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 56 */
      {		/* Cfa/cinfo.scm 56 */
	 bool_t aux_8489;
	 aux_8489 =
	    cvar_cinfo__125_cfa_info(obj_5723);
	 return
	    BBOOL(aux_8489);
      }
   }
}



/* widening-cvar/cinfo */
cvar_cinfo_53_bglt 
widening_cvar_cinfo_54_cfa_info(approx_bglt approx_573)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 56 */
      {		/* Cfa/cinfo.scm 56 */
	 cvar_cinfo_53_bglt new1578_3563;
	 new1578_3563 =
	    ((cvar_cinfo_53_bglt) BREF(GC_MALLOC(sizeof(struct cvar_cinfo_53))));
	 ((((cvar_cinfo_53_bglt) CREF(new1578_3563))->approx) = ((approx_bglt) approx_573), BUNSPEC);
	 return new1578_3563;
      }
   }
}



/* _widening-cvar/cinfo3026 */
obj_t 
_widening_cvar_cinfo3026_143_cfa_info(obj_t env_5724, obj_t approx_5725)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 56 */
      {		/* Cfa/cinfo.scm 56 */
	 cvar_cinfo_53_bglt aux_8494;
	 aux_8494 =
	    widening_cvar_cinfo_54_cfa_info(
	    (approx_bglt) (approx_5725));
	 return
	    (obj_t) (aux_8494);
      }
   }
}



/* make-cvar/cinfo */
cvar_cinfo_53_bglt 
make_cvar_cinfo_209_cfa_info(bool_t macro__33_574, approx_bglt approx_575)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 56 */
      {		/* Cfa/cinfo.scm 56 */
	 cvar_bglt aux1581_3565;
	 {	/* Cfa/cinfo.scm 56 */
	    cvar_bglt res2727_3575;
	    {	/* ./Ast/var.scm 595 */
	       cvar_bglt new1173_3570;
	       new1173_3570 =
		  ((cvar_bglt) BREF(GC_MALLOC(sizeof(struct cvar))));
	       {	/* ./Ast/var.scm 595 */
		  long arg2407_3571;
		  arg2407_3571 =
		     class_num_218___object(cvar_ast_var);
		  {	/* ./Ast/var.scm 595 */
		     obj_t obj_3573;
		     obj_3573 =
			(obj_t) (new1173_3570);
		     (((obj_t) CREF(obj_3573))->header = MAKE_HEADER(arg2407_3571, 0), BUNSPEC);
		  }
	       }
	       {	/* ./Ast/var.scm 595 */
		  object_bglt aux_8502;
		  aux_8502 =
		     (object_bglt) (new1173_3570);
		  OBJECT_WIDENING_SET(aux_8502, BFALSE);
	       }
	       ((((cvar_bglt) CREF(new1173_3570))->macro__33) = ((bool_t) macro__33_574), BUNSPEC);
	       res2727_3575 = new1173_3570;
	    }
	    aux1581_3565 = res2727_3575;
	 }
	 {	/* Cfa/cinfo.scm 56 */
	    cvar_cinfo_53_bglt new1582_3566;
	    new1582_3566 =
	       ((cvar_cinfo_53_bglt) (aux1581_3565));
	    {	/* Cfa/cinfo.scm 56 */
	       long arg2336_3567;
	       arg2336_3567 =
		  class_num_218___object(cvar_cinfo_53_cfa_info);
	       {	/* Cfa/cinfo.scm 56 */
		  obj_t obj_3576;
		  obj_3576 =
		     (obj_t) (new1582_3566);
		  (((obj_t) CREF(obj_3576))->header = MAKE_HEADER(arg2336_3567, 0), BUNSPEC);
	       }
	    }
	    {	/* Cfa/cinfo.scm 56 */
	       cvar_cinfo_53_bglt arg2337_3568;
	       {	/* Cfa/cinfo.scm 56 */
		  cvar_cinfo_53_bglt res2728_3581;
		  {	/* Cfa/cinfo.scm 56 */
		     cvar_cinfo_53_bglt new1578_3579;
		     new1578_3579 =
			((cvar_cinfo_53_bglt) BREF(GC_MALLOC(sizeof(struct cvar_cinfo_53))));
		     ((((cvar_cinfo_53_bglt) CREF(new1578_3579))->approx) = ((approx_bglt) approx_575), BUNSPEC);
		     res2728_3581 = new1578_3579;
		  }
		  arg2337_3568 = res2728_3581;
	       }
	       {	/* Cfa/cinfo.scm 56 */
		  obj_t aux_8514;
		  object_bglt aux_8512;
		  aux_8514 =
		     (obj_t) (arg2337_3568);
		  aux_8512 =
		     (object_bglt) (new1582_3566);
		  OBJECT_WIDENING_SET(aux_8512, aux_8514);
	       }
	    }
	    return new1582_3566;
	 }
      }
   }
}



/* _make-cvar/cinfo3027 */
obj_t 
_make_cvar_cinfo3027_54_cfa_info(obj_t env_5726, obj_t macro__33_5727, obj_t approx_5728)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 56 */
      {		/* Cfa/cinfo.scm 56 */
	 cvar_cinfo_53_bglt aux_8517;
	 aux_8517 =
	    make_cvar_cinfo_209_cfa_info(
	    CBOOL(macro__33_5727),
	    (approx_bglt) (approx_5728));
	 return
	    (obj_t) (aux_8517);
      }
   }
}



/* cvar/cinfo-macro? */
bool_t 
cvar_cinfo_macro__62_cfa_info(cvar_bglt obj_576)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 597 */
      return
	 (((cvar_bglt) CREF(obj_576))->macro__33);
   }
}



/* _cvar/cinfo-macro?3028 */
obj_t 
_cvar_cinfo_macro_3028_11_cfa_info(obj_t env_5729, obj_t obj_5730)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 597 */
      {		/* ./Ast/var.scm 597 */
	 bool_t aux_8523;
	 aux_8523 =
	    cvar_cinfo_macro__62_cfa_info(
	    (cvar_bglt) (obj_5730));
	 return
	    BBOOL(aux_8523);
      }
   }
}



/* cvar/cinfo-approx */
approx_bglt 
cvar_cinfo_approx_12_cfa_info(cvar_cinfo_53_bglt obj_577)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 56 */
      {
	 obj_t aux_8527;
	 {	/* Cfa/cinfo.scm 56 */
	    object_bglt aux_8528;
	    aux_8528 =
	       (object_bglt) (obj_577);
	    aux_8527 =
	       OBJECT_WIDENING(aux_8528);
	 }
	 return
	    (((cvar_cinfo_53_bglt) CREF(aux_8527))->approx);
      }
   }
}



/* _cvar/cinfo-approx3029 */
obj_t 
_cvar_cinfo_approx3029_161_cfa_info(obj_t env_5731, obj_t obj_5732)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 56 */
      {		/* Cfa/cinfo.scm 56 */
	 approx_bglt aux_8532;
	 aux_8532 =
	    cvar_cinfo_approx_12_cfa_info(
	    (cvar_cinfo_53_bglt) (obj_5732));
	 return
	    (obj_t) (aux_8532);
      }
   }
}



/* allocate-svar/cinfo */
svar_bglt 
allocate_svar_cinfo_217_cfa_info()
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 50 */
      {		/* Cfa/cinfo.scm 50 */
	 svar_bglt new1571_1848;
	 new1571_1848 =
	    ((svar_bglt) BREF(GC_MALLOC(sizeof(struct svar))));
	 {	/* Cfa/cinfo.scm 50 */
	    long arg2338_1849;
	    arg2338_1849 =
	       class_num_218___object(svar_cinfo_166_cfa_info);
	    {	/* Cfa/cinfo.scm 50 */
	       obj_t obj_3582;
	       obj_3582 =
		  (obj_t) (new1571_1848);
	       (((obj_t) CREF(obj_3582))->header = MAKE_HEADER(arg2338_1849, 0), BUNSPEC);
	    }
	 }
	 {	/* Cfa/cinfo.scm 50 */
	    object_bglt aux_8540;
	    aux_8540 =
	       (object_bglt) (new1571_1848);
	    OBJECT_WIDENING_SET(aux_8540, BFALSE);
	 }
	 return new1571_1848;
      }
   }
}



/* _allocate-svar/cinfo */
obj_t 
_allocate_svar_cinfo_185_cfa_info(obj_t env_4902)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 50 */
      {		/* Cfa/cinfo.scm 50 */
	 svar_bglt aux_8543;
	 aux_8543 =
	    allocate_svar_cinfo_217_cfa_info();
	 return
	    (obj_t) (aux_8543);
      }
   }
}



/* svar/cinfo? */
bool_t 
svar_cinfo__59_cfa_info(obj_t obj_581)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 50 */
      return
	 is_a__118___object(obj_581, svar_cinfo_166_cfa_info);
   }
}



/* _svar/cinfo? */
obj_t 
_svar_cinfo__163_cfa_info(obj_t env_5733, obj_t obj_5734)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 50 */
      {		/* Cfa/cinfo.scm 50 */
	 bool_t aux_8547;
	 aux_8547 =
	    svar_cinfo__59_cfa_info(obj_5734);
	 return
	    BBOOL(aux_8547);
      }
   }
}



/* widening-svar/cinfo */
svar_cinfo_166_bglt 
widening_svar_cinfo_83_cfa_info(approx_bglt approx_582, bool_t clo_env__87_583)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 50 */
      {		/* Cfa/cinfo.scm 50 */
	 svar_cinfo_166_bglt new1565_3584;
	 new1565_3584 =
	    ((svar_cinfo_166_bglt) BREF(GC_MALLOC(sizeof(struct svar_cinfo_166))));
	 ((((svar_cinfo_166_bglt) CREF(new1565_3584))->approx) = ((approx_bglt) approx_582), BUNSPEC);
	 ((((svar_cinfo_166_bglt) CREF(new1565_3584))->clo_env__87) = ((bool_t) clo_env__87_583), BUNSPEC);
	 return new1565_3584;
      }
   }
}



/* _widening-svar/cinfo3030 */
obj_t 
_widening_svar_cinfo3030_209_cfa_info(obj_t env_5735, obj_t approx_5736, obj_t clo_env__87_5737)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 50 */
      {		/* Cfa/cinfo.scm 50 */
	 svar_cinfo_166_bglt aux_8553;
	 aux_8553 =
	    widening_svar_cinfo_83_cfa_info(
	    (approx_bglt) (approx_5736),
	    CBOOL(clo_env__87_5737));
	 return
	    (obj_t) (aux_8553);
      }
   }
}



/* make-svar/cinfo */
svar_cinfo_166_bglt 
make_svar_cinfo_148_cfa_info(obj_t loc_584, approx_bglt approx_585, bool_t clo_env__87_586)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 50 */
      {		/* Cfa/cinfo.scm 50 */
	 svar_bglt aux1569_3587;
	 {	/* Cfa/cinfo.scm 50 */
	    svar_bglt res2729_3597;
	    {	/* ./Ast/var.scm 579 */
	       svar_bglt new1161_3592;
	       new1161_3592 =
		  ((svar_bglt) BREF(GC_MALLOC(sizeof(struct svar))));
	       {	/* ./Ast/var.scm 579 */
		  long arg2411_3593;
		  arg2411_3593 =
		     class_num_218___object(svar_ast_var);
		  {	/* ./Ast/var.scm 579 */
		     obj_t obj_3595;
		     obj_3595 =
			(obj_t) (new1161_3592);
		     (((obj_t) CREF(obj_3595))->header = MAKE_HEADER(arg2411_3593, 0), BUNSPEC);
		  }
	       }
	       {	/* ./Ast/var.scm 579 */
		  object_bglt aux_8562;
		  aux_8562 =
		     (object_bglt) (new1161_3592);
		  OBJECT_WIDENING_SET(aux_8562, BFALSE);
	       }
	       ((((svar_bglt) CREF(new1161_3592))->loc) = ((obj_t) loc_584), BUNSPEC);
	       res2729_3597 = new1161_3592;
	    }
	    aux1569_3587 = res2729_3597;
	 }
	 {	/* Cfa/cinfo.scm 50 */
	    svar_cinfo_166_bglt new1570_3588;
	    new1570_3588 =
	       ((svar_cinfo_166_bglt) (aux1569_3587));
	    {	/* Cfa/cinfo.scm 50 */
	       long arg2339_3589;
	       arg2339_3589 =
		  class_num_218___object(svar_cinfo_166_cfa_info);
	       {	/* Cfa/cinfo.scm 50 */
		  obj_t obj_3598;
		  obj_3598 =
		     (obj_t) (new1570_3588);
		  (((obj_t) CREF(obj_3598))->header = MAKE_HEADER(arg2339_3589, 0), BUNSPEC);
	       }
	    }
	    {	/* Cfa/cinfo.scm 50 */
	       svar_cinfo_166_bglt arg2340_3590;
	       {	/* Cfa/cinfo.scm 50 */
		  svar_cinfo_166_bglt res2730_3605;
		  {	/* Cfa/cinfo.scm 50 */
		     svar_cinfo_166_bglt new1565_3602;
		     new1565_3602 =
			((svar_cinfo_166_bglt) BREF(GC_MALLOC(sizeof(struct svar_cinfo_166))));
		     ((((svar_cinfo_166_bglt) CREF(new1565_3602))->approx) = ((approx_bglt) approx_585), BUNSPEC);
		     ((((svar_cinfo_166_bglt) CREF(new1565_3602))->clo_env__87) = ((bool_t) clo_env__87_586), BUNSPEC);
		     res2730_3605 = new1565_3602;
		  }
		  arg2340_3590 = res2730_3605;
	       }
	       {	/* Cfa/cinfo.scm 50 */
		  obj_t aux_8575;
		  object_bglt aux_8573;
		  aux_8575 =
		     (obj_t) (arg2340_3590);
		  aux_8573 =
		     (object_bglt) (new1570_3588);
		  OBJECT_WIDENING_SET(aux_8573, aux_8575);
	       }
	    }
	    return new1570_3588;
	 }
      }
   }
}



/* _make-svar/cinfo3031 */
obj_t 
_make_svar_cinfo3031_143_cfa_info(obj_t env_5738, obj_t loc_5739, obj_t approx_5740, obj_t clo_env__87_5741)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 50 */
      {		/* Cfa/cinfo.scm 50 */
	 svar_cinfo_166_bglt aux_8578;
	 aux_8578 =
	    make_svar_cinfo_148_cfa_info(loc_5739,
	    (approx_bglt) (approx_5740),
	    CBOOL(clo_env__87_5741));
	 return
	    (obj_t) (aux_8578);
      }
   }
}



/* svar/cinfo-loc-set! */
obj_t 
svar_cinfo_loc_set__81_cfa_info(svar_bglt obj_587, obj_t val1563_588)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 581 */
      return
	 ((((svar_bglt) CREF(obj_587))->loc) = ((obj_t) val1563_588), BUNSPEC);
   }
}



/* _svar/cinfo-loc-set!3032 */
obj_t 
_svar_cinfo_loc_set_3032_170_cfa_info(obj_t env_5742, obj_t obj_5743, obj_t val1563_5744)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 581 */
      return
	 svar_cinfo_loc_set__81_cfa_info(
	 (svar_bglt) (obj_5743), val1563_5744);
   }
}



/* svar/cinfo-loc */
obj_t 
svar_cinfo_loc_67_cfa_info(svar_bglt obj_589)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 581 */
      return
	 (((svar_bglt) CREF(obj_589))->loc);
   }
}



/* _svar/cinfo-loc3033 */
obj_t 
_svar_cinfo_loc3033_82_cfa_info(obj_t env_5745, obj_t obj_5746)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 581 */
      return
	 svar_cinfo_loc_67_cfa_info(
	 (svar_bglt) (obj_5746));
   }
}



/* svar/cinfo-approx */
approx_bglt 
svar_cinfo_approx_144_cfa_info(svar_cinfo_166_bglt obj_590)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 51 */
      {
	 obj_t aux_8589;
	 {	/* Cfa/cinfo.scm 51 */
	    object_bglt aux_8590;
	    aux_8590 =
	       (object_bglt) (obj_590);
	    aux_8589 =
	       OBJECT_WIDENING(aux_8590);
	 }
	 return
	    (((svar_cinfo_166_bglt) CREF(aux_8589))->approx);
      }
   }
}



/* _svar/cinfo-approx3034 */
obj_t 
_svar_cinfo_approx3034_160_cfa_info(obj_t env_5747, obj_t obj_5748)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 51 */
      {		/* Cfa/cinfo.scm 51 */
	 approx_bglt aux_8594;
	 aux_8594 =
	    svar_cinfo_approx_144_cfa_info(
	    (svar_cinfo_166_bglt) (obj_5748));
	 return
	    (obj_t) (aux_8594);
      }
   }
}



/* svar/cinfo-clo-env?-set! */
obj_t 
svar_cinfo_clo_env__set__212_cfa_info(svar_cinfo_166_bglt obj_591, bool_t val1564_592)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 55 */
      {
	 obj_t aux_8598;
	 {	/* Cfa/cinfo.scm 55 */
	    object_bglt aux_8599;
	    aux_8599 =
	       (object_bglt) (obj_591);
	    aux_8598 =
	       OBJECT_WIDENING(aux_8599);
	 }
	 return
	    ((((svar_cinfo_166_bglt) CREF(aux_8598))->clo_env__87) = ((bool_t) val1564_592), BUNSPEC);
      }
   }
}



/* _svar/cinfo-clo-env?-set!3035 */
obj_t 
_svar_cinfo_clo_env__set_3035_110_cfa_info(obj_t env_5749, obj_t obj_5750, obj_t val1564_5751)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 55 */
      return
	 svar_cinfo_clo_env__set__212_cfa_info(
	 (svar_cinfo_166_bglt) (obj_5750),
	 CBOOL(val1564_5751));
   }
}



/* svar/cinfo-clo-env? */
bool_t 
svar_cinfo_clo_env__3_cfa_info(svar_cinfo_166_bglt obj_593)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 55 */
      {
	 obj_t aux_8606;
	 {	/* Cfa/cinfo.scm 55 */
	    object_bglt aux_8607;
	    aux_8607 =
	       (object_bglt) (obj_593);
	    aux_8606 =
	       OBJECT_WIDENING(aux_8607);
	 }
	 return
	    (((svar_cinfo_166_bglt) CREF(aux_8606))->clo_env__87);
      }
   }
}



/* _svar/cinfo-clo-env?3036 */
obj_t 
_svar_cinfo_clo_env_3036_74_cfa_info(obj_t env_5752, obj_t obj_5753)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 55 */
      {		/* Cfa/cinfo.scm 55 */
	 bool_t aux_8611;
	 aux_8611 =
	    svar_cinfo_clo_env__3_cfa_info(
	    (svar_cinfo_166_bglt) (obj_5753));
	 return
	    BBOOL(aux_8611);
      }
   }
}



/* allocate-pre-clo-env */
svar_bglt 
allocate_pre_clo_env_40_cfa_info()
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 49 */
      {		/* Cfa/cinfo.scm 49 */
	 svar_bglt new1556_1857;
	 new1556_1857 =
	    ((svar_bglt) BREF(GC_MALLOC(sizeof(struct svar))));
	 {	/* Cfa/cinfo.scm 49 */
	    long arg2341_1858;
	    arg2341_1858 =
	       class_num_218___object(pre_clo_env_191_cfa_info);
	    {	/* Cfa/cinfo.scm 49 */
	       obj_t obj_3606;
	       obj_3606 =
		  (obj_t) (new1556_1857);
	       (((obj_t) CREF(obj_3606))->header = MAKE_HEADER(arg2341_1858, 0), BUNSPEC);
	    }
	 }
	 {	/* Cfa/cinfo.scm 49 */
	    object_bglt aux_8619;
	    aux_8619 =
	       (object_bglt) (new1556_1857);
	    OBJECT_WIDENING_SET(aux_8619, BFALSE);
	 }
	 return new1556_1857;
      }
   }
}



/* _allocate-pre-clo-env */
obj_t 
_allocate_pre_clo_env_10_cfa_info(obj_t env_4901)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 49 */
      {		/* Cfa/cinfo.scm 49 */
	 svar_bglt aux_8622;
	 aux_8622 =
	    allocate_pre_clo_env_40_cfa_info();
	 return
	    (obj_t) (aux_8622);
      }
   }
}



/* pre-clo-env? */
bool_t 
pre_clo_env__121_cfa_info(obj_t obj_597)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 49 */
      return
	 is_a__118___object(obj_597, pre_clo_env_191_cfa_info);
   }
}



/* _pre-clo-env? */
obj_t 
_pre_clo_env__150_cfa_info(obj_t env_5754, obj_t obj_5755)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 49 */
      {		/* Cfa/cinfo.scm 49 */
	 bool_t aux_8626;
	 aux_8626 =
	    pre_clo_env__121_cfa_info(obj_5755);
	 return
	    BBOOL(aux_8626);
      }
   }
}



/* widening-pre-clo-env */
pre_clo_env_191_bglt 
widening_pre_clo_env_190_cfa_info()
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 49 */
      {		/* Cfa/cinfo.scm 49 */

	 return
	    ((pre_clo_env_191_bglt) BREF(GC_MALLOC(sizeof(struct pre_clo_env_191))));
      }
   }
}



/* _widening-pre-clo-env */
obj_t 
_widening_pre_clo_env_41_cfa_info(obj_t env_5756)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 49 */
      {		/* Cfa/cinfo.scm 49 */
	 pre_clo_env_191_bglt aux_8630;
	 aux_8630 =
	    widening_pre_clo_env_190_cfa_info();
	 return
	    (obj_t) (aux_8630);
      }
   }
}



/* make-pre-clo-env */
pre_clo_env_191_bglt 
make_pre_clo_env_164_cfa_info(obj_t loc_598)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 49 */
      {		/* Cfa/cinfo.scm 49 */
	 svar_bglt aux1554_3609;
	 {	/* Cfa/cinfo.scm 49 */
	    svar_bglt res2731_3619;
	    {	/* ./Ast/var.scm 579 */
	       svar_bglt new1161_3614;
	       new1161_3614 =
		  ((svar_bglt) BREF(GC_MALLOC(sizeof(struct svar))));
	       {	/* ./Ast/var.scm 579 */
		  long arg2411_3615;
		  arg2411_3615 =
		     class_num_218___object(svar_ast_var);
		  {	/* ./Ast/var.scm 579 */
		     obj_t obj_3617;
		     obj_3617 =
			(obj_t) (new1161_3614);
		     (((obj_t) CREF(obj_3617))->header = MAKE_HEADER(arg2411_3615, 0), BUNSPEC);
		  }
	       }
	       {	/* ./Ast/var.scm 579 */
		  object_bglt aux_8637;
		  aux_8637 =
		     (object_bglt) (new1161_3614);
		  OBJECT_WIDENING_SET(aux_8637, BFALSE);
	       }
	       ((((svar_bglt) CREF(new1161_3614))->loc) = ((obj_t) loc_598), BUNSPEC);
	       res2731_3619 = new1161_3614;
	    }
	    aux1554_3609 = res2731_3619;
	 }
	 {	/* Cfa/cinfo.scm 49 */
	    pre_clo_env_191_bglt new1555_3610;
	    new1555_3610 =
	       ((pre_clo_env_191_bglt) (aux1554_3609));
	    {	/* Cfa/cinfo.scm 49 */
	       long arg2342_3611;
	       arg2342_3611 =
		  class_num_218___object(pre_clo_env_191_cfa_info);
	       {	/* Cfa/cinfo.scm 49 */
		  obj_t obj_3620;
		  obj_3620 =
		     (obj_t) (new1555_3610);
		  (((obj_t) CREF(obj_3620))->header = MAKE_HEADER(arg2342_3611, 0), BUNSPEC);
	       }
	    }
	    {	/* Cfa/cinfo.scm 49 */
	       obj_t aux_8647;
	       object_bglt aux_8645;
	       {	/* Cfa/cinfo.scm 49 */
		  pre_clo_env_191_bglt aux_8648;
		  {	/* Cfa/cinfo.scm 49 */

		     aux_8648 =
			((pre_clo_env_191_bglt) BREF(GC_MALLOC(sizeof(struct pre_clo_env_191))));
		  }
		  aux_8647 =
		     (obj_t) (aux_8648);
	       }
	       aux_8645 =
		  (object_bglt) (new1555_3610);
	       OBJECT_WIDENING_SET(aux_8645, aux_8647);
	    }
	    return new1555_3610;
	 }
      }
   }
}



/* _make-pre-clo-env */
obj_t 
_make_pre_clo_env_110_cfa_info(obj_t env_5757, obj_t loc_5758)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 49 */
      {		/* Cfa/cinfo.scm 49 */
	 pre_clo_env_191_bglt aux_8652;
	 aux_8652 =
	    make_pre_clo_env_164_cfa_info(loc_5758);
	 return
	    (obj_t) (aux_8652);
      }
   }
}



/* pre-clo-env-loc-set! */
obj_t 
pre_clo_env_loc_set__78_cfa_info(svar_bglt obj_599, obj_t val1551_600)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 581 */
      return
	 ((((svar_bglt) CREF(obj_599))->loc) = ((obj_t) val1551_600), BUNSPEC);
   }
}



/* _pre-clo-env-loc-set!3037 */
obj_t 
_pre_clo_env_loc_set_3037_152_cfa_info(obj_t env_5759, obj_t obj_5760, obj_t val1551_5761)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 581 */
      return
	 pre_clo_env_loc_set__78_cfa_info(
	 (svar_bglt) (obj_5760), val1551_5761);
   }
}



/* pre-clo-env-loc */
obj_t 
pre_clo_env_loc_179_cfa_info(svar_bglt obj_601)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 581 */
      return
	 (((svar_bglt) CREF(obj_601))->loc);
   }
}



/* _pre-clo-env-loc3038 */
obj_t 
_pre_clo_env_loc3038_171_cfa_info(obj_t env_5762, obj_t obj_5763)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 581 */
      return
	 pre_clo_env_loc_179_cfa_info(
	 (svar_bglt) (obj_5763));
   }
}



/* allocate-scnst/cinfo */
scnst_bglt 
allocate_scnst_cinfo_156_cfa_info()
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 46 */
      {		/* Cfa/cinfo.scm 46 */
	 scnst_bglt new1544_1864;
	 new1544_1864 =
	    ((scnst_bglt) BREF(GC_MALLOC(sizeof(struct scnst))));
	 {	/* Cfa/cinfo.scm 46 */
	    long arg2344_1865;
	    arg2344_1865 =
	       class_num_218___object(scnst_cinfo_0_cfa_info);
	    {	/* Cfa/cinfo.scm 46 */
	       obj_t obj_3624;
	       obj_3624 =
		  (obj_t) (new1544_1864);
	       (((obj_t) CREF(obj_3624))->header = MAKE_HEADER(arg2344_1865, 0), BUNSPEC);
	    }
	 }
	 {	/* Cfa/cinfo.scm 46 */
	    object_bglt aux_8665;
	    aux_8665 =
	       (object_bglt) (new1544_1864);
	    OBJECT_WIDENING_SET(aux_8665, BFALSE);
	 }
	 return new1544_1864;
      }
   }
}



/* _allocate-scnst/cinfo */
obj_t 
_allocate_scnst_cinfo_162_cfa_info(obj_t env_4900)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 46 */
      {		/* Cfa/cinfo.scm 46 */
	 scnst_bglt aux_8668;
	 aux_8668 =
	    allocate_scnst_cinfo_156_cfa_info();
	 return
	    (obj_t) (aux_8668);
      }
   }
}



/* scnst/cinfo? */
bool_t 
scnst_cinfo__144_cfa_info(obj_t obj_605)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 46 */
      return
	 is_a__118___object(obj_605, scnst_cinfo_0_cfa_info);
   }
}



/* _scnst/cinfo? */
obj_t 
_scnst_cinfo__113_cfa_info(obj_t env_5764, obj_t obj_5765)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 46 */
      {		/* Cfa/cinfo.scm 46 */
	 bool_t aux_8672;
	 aux_8672 =
	    scnst_cinfo__144_cfa_info(obj_5765);
	 return
	    BBOOL(aux_8672);
      }
   }
}



/* widening-scnst/cinfo */
scnst_cinfo_0_bglt 
widening_scnst_cinfo_249_cfa_info(approx_bglt approx_606)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 46 */
      {		/* Cfa/cinfo.scm 46 */
	 scnst_cinfo_0_bglt new1539_3626;
	 new1539_3626 =
	    ((scnst_cinfo_0_bglt) BREF(GC_MALLOC(sizeof(struct scnst_cinfo_0))));
	 ((((scnst_cinfo_0_bglt) CREF(new1539_3626))->approx) = ((approx_bglt) approx_606), BUNSPEC);
	 return new1539_3626;
      }
   }
}



/* _widening-scnst/cinfo3039 */
obj_t 
_widening_scnst_cinfo3039_53_cfa_info(obj_t env_5766, obj_t approx_5767)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 46 */
      {		/* Cfa/cinfo.scm 46 */
	 scnst_cinfo_0_bglt aux_8677;
	 aux_8677 =
	    widening_scnst_cinfo_249_cfa_info(
	    (approx_bglt) (approx_5767));
	 return
	    (obj_t) (aux_8677);
      }
   }
}



/* make-scnst/cinfo */
scnst_cinfo_0_bglt 
make_scnst_cinfo_57_cfa_info(obj_t node_607, obj_t class_608, obj_t loc_609, approx_bglt approx_610)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 46 */
      {		/* Cfa/cinfo.scm 46 */
	 scnst_bglt aux1542_3628;
	 {	/* Cfa/cinfo.scm 46 */
	    scnst_bglt res2733_3642;
	    {	/* ./Ast/var.scm 583 */
	       scnst_bglt new1167_3635;
	       new1167_3635 =
		  ((scnst_bglt) BREF(GC_MALLOC(sizeof(struct scnst))));
	       {	/* ./Ast/var.scm 583 */
		  long arg2409_3636;
		  arg2409_3636 =
		     class_num_218___object(scnst_ast_var);
		  {	/* ./Ast/var.scm 583 */
		     obj_t obj_3640;
		     obj_3640 =
			(obj_t) (new1167_3635);
		     (((obj_t) CREF(obj_3640))->header = MAKE_HEADER(arg2409_3636, 0), BUNSPEC);
		  }
	       }
	       {	/* ./Ast/var.scm 583 */
		  object_bglt aux_8685;
		  aux_8685 =
		     (object_bglt) (new1167_3635);
		  OBJECT_WIDENING_SET(aux_8685, BFALSE);
	       }
	       ((((scnst_bglt) CREF(new1167_3635))->node) = ((obj_t) node_607), BUNSPEC);
	       ((((scnst_bglt) CREF(new1167_3635))->class) = ((obj_t) class_608), BUNSPEC);
	       ((((scnst_bglt) CREF(new1167_3635))->loc) = ((obj_t) loc_609), BUNSPEC);
	       res2733_3642 = new1167_3635;
	    }
	    aux1542_3628 = res2733_3642;
	 }
	 {	/* Cfa/cinfo.scm 46 */
	    scnst_cinfo_0_bglt new1543_3629;
	    new1543_3629 =
	       ((scnst_cinfo_0_bglt) (aux1542_3628));
	    {	/* Cfa/cinfo.scm 46 */
	       long arg2345_3630;
	       arg2345_3630 =
		  class_num_218___object(scnst_cinfo_0_cfa_info);
	       {	/* Cfa/cinfo.scm 46 */
		  obj_t obj_3643;
		  obj_3643 =
		     (obj_t) (new1543_3629);
		  (((obj_t) CREF(obj_3643))->header = MAKE_HEADER(arg2345_3630, 0), BUNSPEC);
	       }
	    }
	    {	/* Cfa/cinfo.scm 46 */
	       scnst_cinfo_0_bglt arg2346_3631;
	       {	/* Cfa/cinfo.scm 46 */
		  scnst_cinfo_0_bglt res2734_3648;
		  {	/* Cfa/cinfo.scm 46 */
		     scnst_cinfo_0_bglt new1539_3646;
		     new1539_3646 =
			((scnst_cinfo_0_bglt) BREF(GC_MALLOC(sizeof(struct scnst_cinfo_0))));
		     ((((scnst_cinfo_0_bglt) CREF(new1539_3646))->approx) = ((approx_bglt) approx_610), BUNSPEC);
		     res2734_3648 = new1539_3646;
		  }
		  arg2346_3631 = res2734_3648;
	       }
	       {	/* Cfa/cinfo.scm 46 */
		  obj_t aux_8699;
		  object_bglt aux_8697;
		  aux_8699 =
		     (obj_t) (arg2346_3631);
		  aux_8697 =
		     (object_bglt) (new1543_3629);
		  OBJECT_WIDENING_SET(aux_8697, aux_8699);
	       }
	    }
	    return new1543_3629;
	 }
      }
   }
}



/* _make-scnst/cinfo3040 */
obj_t 
_make_scnst_cinfo3040_74_cfa_info(obj_t env_5768, obj_t node_5769, obj_t class_5770, obj_t loc_5771, obj_t approx_5772)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 46 */
      {		/* Cfa/cinfo.scm 46 */
	 scnst_cinfo_0_bglt aux_8702;
	 aux_8702 =
	    make_scnst_cinfo_57_cfa_info(node_5769, class_5770, loc_5771,
	    (approx_bglt) (approx_5772));
	 return
	    (obj_t) (aux_8702);
      }
   }
}



/* scnst/cinfo-node */
obj_t 
scnst_cinfo_node_230_cfa_info(scnst_bglt obj_611)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 585 */
      return
	 (((scnst_bglt) CREF(obj_611))->node);
   }
}



/* _scnst/cinfo-node3041 */
obj_t 
_scnst_cinfo_node3041_91_cfa_info(obj_t env_5773, obj_t obj_5774)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 585 */
      return
	 scnst_cinfo_node_230_cfa_info(
	 (scnst_bglt) (obj_5774));
   }
}



/* scnst/cinfo-class-set! */
obj_t 
scnst_cinfo_class_set__149_cfa_info(scnst_bglt obj_612, obj_t val1537_613)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 587 */
      return
	 ((((scnst_bglt) CREF(obj_612))->class) = ((obj_t) val1537_613), BUNSPEC);
   }
}



/* _scnst/cinfo-class-set!3042 */
obj_t 
_scnst_cinfo_class_set_3042_195_cfa_info(obj_t env_5775, obj_t obj_5776, obj_t val1537_5777)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 587 */
      return
	 scnst_cinfo_class_set__149_cfa_info(
	 (scnst_bglt) (obj_5776), val1537_5777);
   }
}



/* scnst/cinfo-class */
obj_t 
scnst_cinfo_class_89_cfa_info(scnst_bglt obj_614)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 587 */
      return
	 (((scnst_bglt) CREF(obj_614))->class);
   }
}



/* _scnst/cinfo-class3043 */
obj_t 
_scnst_cinfo_class3043_119_cfa_info(obj_t env_5778, obj_t obj_5779)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 587 */
      return
	 scnst_cinfo_class_89_cfa_info(
	 (scnst_bglt) (obj_5779));
   }
}



/* scnst/cinfo-loc-set! */
obj_t 
scnst_cinfo_loc_set__10_cfa_info(scnst_bglt obj_615, obj_t val1538_616)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 593 */
      return
	 ((((scnst_bglt) CREF(obj_615))->loc) = ((obj_t) val1538_616), BUNSPEC);
   }
}



/* _scnst/cinfo-loc-set!3044 */
obj_t 
_scnst_cinfo_loc_set_3044_121_cfa_info(obj_t env_5780, obj_t obj_5781, obj_t val1538_5782)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 593 */
      return
	 scnst_cinfo_loc_set__10_cfa_info(
	 (scnst_bglt) (obj_5781), val1538_5782);
   }
}



/* scnst/cinfo-loc */
obj_t 
scnst_cinfo_loc_35_cfa_info(scnst_bglt obj_617)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 593 */
      return
	 (((scnst_bglt) CREF(obj_617))->loc);
   }
}



/* _scnst/cinfo-loc3045 */
obj_t 
_scnst_cinfo_loc3045_122_cfa_info(obj_t env_5783, obj_t obj_5784)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 593 */
      return
	 scnst_cinfo_loc_35_cfa_info(
	 (scnst_bglt) (obj_5784));
   }
}



/* scnst/cinfo-approx */
approx_bglt 
scnst_cinfo_approx_162_cfa_info(scnst_cinfo_0_bglt obj_618)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 46 */
      {
	 obj_t aux_8721;
	 {	/* Cfa/cinfo.scm 46 */
	    object_bglt aux_8722;
	    aux_8722 =
	       (object_bglt) (obj_618);
	    aux_8721 =
	       OBJECT_WIDENING(aux_8722);
	 }
	 return
	    (((scnst_cinfo_0_bglt) CREF(aux_8721))->approx);
      }
   }
}



/* _scnst/cinfo-approx3046 */
obj_t 
_scnst_cinfo_approx3046_113_cfa_info(obj_t env_5785, obj_t obj_5786)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 46 */
      {		/* Cfa/cinfo.scm 46 */
	 approx_bglt aux_8726;
	 aux_8726 =
	    scnst_cinfo_approx_162_cfa_info(
	    (scnst_cinfo_0_bglt) (obj_5786));
	 return
	    (obj_t) (aux_8726);
      }
   }
}



/* allocate-intern-sfun/cinfo */
sfun_bglt 
allocate_intern_sfun_cinfo_151_cfa_info()
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 41 */
      {		/* Cfa/cinfo.scm 41 */
	 sfun_bglt new1530_1872;
	 new1530_1872 =
	    ((sfun_bglt) BREF(GC_MALLOC(sizeof(struct sfun))));
	 {	/* Cfa/cinfo.scm 41 */
	    long arg2347_1873;
	    arg2347_1873 =
	       class_num_218___object(intern_sfun_cinfo_192_cfa_info);
	    {	/* Cfa/cinfo.scm 41 */
	       obj_t obj_3649;
	       obj_3649 =
		  (obj_t) (new1530_1872);
	       (((obj_t) CREF(obj_3649))->header = MAKE_HEADER(arg2347_1873, 0), BUNSPEC);
	    }
	 }
	 {	/* Cfa/cinfo.scm 41 */
	    object_bglt aux_8734;
	    aux_8734 =
	       (object_bglt) (new1530_1872);
	    OBJECT_WIDENING_SET(aux_8734, BFALSE);
	 }
	 return new1530_1872;
      }
   }
}



/* _allocate-intern-sfun/cinfo */
obj_t 
_allocate_intern_sfun_cinfo_249_cfa_info(obj_t env_4899)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 41 */
      {		/* Cfa/cinfo.scm 41 */
	 sfun_bglt aux_8737;
	 aux_8737 =
	    allocate_intern_sfun_cinfo_151_cfa_info();
	 return
	    (obj_t) (aux_8737);
      }
   }
}



/* intern-sfun/cinfo? */
bool_t 
intern_sfun_cinfo__209_cfa_info(obj_t obj_622)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 41 */
      return
	 is_a__118___object(obj_622, intern_sfun_cinfo_192_cfa_info);
   }
}



/* _intern-sfun/cinfo? */
obj_t 
_intern_sfun_cinfo__158_cfa_info(obj_t env_5787, obj_t obj_5788)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 41 */
      {		/* Cfa/cinfo.scm 41 */
	 bool_t aux_8741;
	 aux_8741 =
	    intern_sfun_cinfo__209_cfa_info(obj_5788);
	 return
	    BBOOL(aux_8741);
      }
   }
}



/* widening-intern-sfun/cinfo */
intern_sfun_cinfo_192_bglt 
widening_intern_sfun_cinfo_70_cfa_info(approx_bglt approx_623, long stamp_624)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 41 */
      {		/* Cfa/cinfo.scm 41 */
	 intern_sfun_cinfo_192_bglt new1524_3651;
	 new1524_3651 =
	    ((intern_sfun_cinfo_192_bglt) BREF(GC_MALLOC(sizeof(struct intern_sfun_cinfo_192))));
	 ((((intern_sfun_cinfo_192_bglt) CREF(new1524_3651))->approx) = ((approx_bglt) approx_623), BUNSPEC);
	 ((((intern_sfun_cinfo_192_bglt) CREF(new1524_3651))->stamp) = ((long) stamp_624), BUNSPEC);
	 return new1524_3651;
      }
   }
}



/* _widening-intern-sfun/cinfo3047 */
obj_t 
_widening_intern_sfun_cinfo3047_38_cfa_info(obj_t env_5789, obj_t approx_5790, obj_t stamp_5791)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 41 */
      {		/* Cfa/cinfo.scm 41 */
	 intern_sfun_cinfo_192_bglt aux_8747;
	 aux_8747 =
	    widening_intern_sfun_cinfo_70_cfa_info(
	    (approx_bglt) (approx_5790),
	    (long) CINT(stamp_5791));
	 return
	    (obj_t) (aux_8747);
      }
   }
}



/* make-intern-sfun/cinfo */
intern_sfun_cinfo_192_bglt 
make_intern_sfun_cinfo_198_cfa_info(long arity_625, obj_t side_effect__165_626, obj_t predicate_of_78_627, obj_t stack_allocator_172_628, bool_t top__138_629, obj_t the_closure_238_630, obj_t property_631, obj_t args_632, obj_t body_633, obj_t class_634, obj_t dsssl_keywords_243_635, obj_t loc_636, approx_bglt approx_637, long stamp_638)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 41 */
      {		/* Cfa/cinfo.scm 41 */
	 sfun_bglt aux1528_3654;
	 {	/* Cfa/cinfo.scm 41 */
	    sfun_bglt res2735_3686;
	    {	/* ./Ast/var.scm 550 */
	       sfun_bglt new1127_3670;
	       new1127_3670 =
		  ((sfun_bglt) BREF(GC_MALLOC(sizeof(struct sfun))));
	       {	/* ./Ast/var.scm 550 */
		  long arg2415_3671;
		  arg2415_3671 =
		     class_num_218___object(sfun_ast_var);
		  {	/* ./Ast/var.scm 550 */
		     obj_t obj_3684;
		     obj_3684 =
			(obj_t) (new1127_3670);
		     (((obj_t) CREF(obj_3684))->header = MAKE_HEADER(arg2415_3671, 0), BUNSPEC);
		  }
	       }
	       {	/* ./Ast/var.scm 550 */
		  object_bglt aux_8756;
		  aux_8756 =
		     (object_bglt) (new1127_3670);
		  OBJECT_WIDENING_SET(aux_8756, BFALSE);
	       }
	       ((((sfun_bglt) CREF(new1127_3670))->arity) = ((long) arity_625), BUNSPEC);
	       ((((sfun_bglt) CREF(new1127_3670))->side_effect__165) = ((obj_t) side_effect__165_626), BUNSPEC);
	       ((((sfun_bglt) CREF(new1127_3670))->predicate_of_78) = ((obj_t) predicate_of_78_627), BUNSPEC);
	       ((((sfun_bglt) CREF(new1127_3670))->stack_allocator_172) = ((obj_t) stack_allocator_172_628), BUNSPEC);
	       ((((sfun_bglt) CREF(new1127_3670))->top__138) = ((bool_t) top__138_629), BUNSPEC);
	       ((((sfun_bglt) CREF(new1127_3670))->the_closure_238) = ((obj_t) the_closure_238_630), BUNSPEC);
	       ((((sfun_bglt) CREF(new1127_3670))->property) = ((obj_t) property_631), BUNSPEC);
	       ((((sfun_bglt) CREF(new1127_3670))->args) = ((obj_t) args_632), BUNSPEC);
	       ((((sfun_bglt) CREF(new1127_3670))->body) = ((obj_t) body_633), BUNSPEC);
	       ((((sfun_bglt) CREF(new1127_3670))->class) = ((obj_t) class_634), BUNSPEC);
	       ((((sfun_bglt) CREF(new1127_3670))->dsssl_keywords_243) = ((obj_t) dsssl_keywords_243_635), BUNSPEC);
	       ((((sfun_bglt) CREF(new1127_3670))->loc) = ((obj_t) loc_636), BUNSPEC);
	       res2735_3686 = new1127_3670;
	    }
	    aux1528_3654 = res2735_3686;
	 }
	 {	/* Cfa/cinfo.scm 41 */
	    intern_sfun_cinfo_192_bglt new1529_3655;
	    new1529_3655 =
	       ((intern_sfun_cinfo_192_bglt) (aux1528_3654));
	    {	/* Cfa/cinfo.scm 41 */
	       long arg2348_3656;
	       arg2348_3656 =
		  class_num_218___object(intern_sfun_cinfo_192_cfa_info);
	       {	/* Cfa/cinfo.scm 41 */
		  obj_t obj_3687;
		  obj_3687 =
		     (obj_t) (new1529_3655);
		  (((obj_t) CREF(obj_3687))->header = MAKE_HEADER(arg2348_3656, 0), BUNSPEC);
	       }
	    }
	    {	/* Cfa/cinfo.scm 41 */
	       intern_sfun_cinfo_192_bglt arg2349_3657;
	       {	/* Cfa/cinfo.scm 41 */
		  intern_sfun_cinfo_192_bglt res2736_3694;
		  {	/* Cfa/cinfo.scm 41 */
		     intern_sfun_cinfo_192_bglt new1524_3691;
		     new1524_3691 =
			((intern_sfun_cinfo_192_bglt) BREF(GC_MALLOC(sizeof(struct intern_sfun_cinfo_192))));
		     ((((intern_sfun_cinfo_192_bglt) CREF(new1524_3691))->approx) = ((approx_bglt) approx_637), BUNSPEC);
		     ((((intern_sfun_cinfo_192_bglt) CREF(new1524_3691))->stamp) = ((long) stamp_638), BUNSPEC);
		     res2736_3694 = new1524_3691;
		  }
		  arg2349_3657 = res2736_3694;
	       }
	       {	/* Cfa/cinfo.scm 41 */
		  obj_t aux_8780;
		  object_bglt aux_8778;
		  aux_8780 =
		     (obj_t) (arg2349_3657);
		  aux_8778 =
		     (object_bglt) (new1529_3655);
		  OBJECT_WIDENING_SET(aux_8778, aux_8780);
	       }
	    }
	    return new1529_3655;
	 }
      }
   }
}



/* _make-intern-sfun/cinfo3048 */
obj_t 
_make_intern_sfun_cinfo3048_141_cfa_info(obj_t env_5792, obj_t arity_5793, obj_t side_effect__165_5794, obj_t predicate_of_78_5795, obj_t stack_allocator_172_5796, obj_t top__138_5797, obj_t the_closure_238_5798, obj_t property_5799, obj_t args_5800, obj_t body_5801, obj_t class_5802, obj_t dsssl_keywords_243_5803, obj_t loc_5804, obj_t approx_5805, obj_t stamp_5806)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 41 */
      {		/* Cfa/cinfo.scm 41 */
	 intern_sfun_cinfo_192_bglt aux_8783;
	 aux_8783 =
	    make_intern_sfun_cinfo_198_cfa_info(
	    (long) CINT(arity_5793), side_effect__165_5794, predicate_of_78_5795, stack_allocator_172_5796,
	    CBOOL(top__138_5797), the_closure_238_5798, property_5799, args_5800, body_5801, class_5802, dsssl_keywords_243_5803, loc_5804,
	    (approx_bglt) (approx_5805),
	    (long) CINT(stamp_5806));
	 return
	    (obj_t) (aux_8783);
      }
   }
}



/* intern-sfun/cinfo-arity */
long 
intern_sfun_cinfo_arity_6_cfa_info(sfun_bglt obj_639)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 538 */
      return
	 (((sfun_bglt) CREF(obj_639))->arity);
   }
}



/* _intern-sfun/cinfo-arity3049 */
obj_t 
_intern_sfun_cinfo_arity3049_55_cfa_info(obj_t env_5807, obj_t obj_5808)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 538 */
      {		/* ./Ast/var.scm 538 */
	 long aux_8791;
	 aux_8791 =
	    intern_sfun_cinfo_arity_6_cfa_info(
	    (sfun_bglt) (obj_5808));
	 return
	    BINT(aux_8791);
      }
   }
}



/* intern-sfun/cinfo-side-effect?-set! */
obj_t 
intern_sfun_cinfo_side_effect__set__189_cfa_info(sfun_bglt obj_640, obj_t val1512_641)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 540 */
      return
	 ((((sfun_bglt) CREF(obj_640))->side_effect__165) = ((obj_t) val1512_641), BUNSPEC);
   }
}



/* _intern-sfun/cinfo-side-effect?-set!3050 */
obj_t 
_intern_sfun_cinfo_side_effect__set_3050_102_cfa_info(obj_t env_5809, obj_t obj_5810, obj_t val1512_5811)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 540 */
      return
	 intern_sfun_cinfo_side_effect__set__189_cfa_info(
	 (sfun_bglt) (obj_5810), val1512_5811);
   }
}



/* intern-sfun/cinfo-side-effect? */
obj_t 
intern_sfun_cinfo_side_effect__206_cfa_info(sfun_bglt obj_642)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 540 */
      return
	 (((sfun_bglt) CREF(obj_642))->side_effect__165);
   }
}



/* _intern-sfun/cinfo-side-effect?3051 */
obj_t 
_intern_sfun_cinfo_side_effect_3051_57_cfa_info(obj_t env_5812, obj_t obj_5813)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 540 */
      return
	 intern_sfun_cinfo_side_effect__206_cfa_info(
	 (sfun_bglt) (obj_5813));
   }
}



/* intern-sfun/cinfo-predicate-of-set! */
obj_t 
intern_sfun_cinfo_predicate_of_set__1_cfa_info(sfun_bglt obj_643, obj_t val1513_644)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 542 */
      return
	 ((((sfun_bglt) CREF(obj_643))->predicate_of_78) = ((obj_t) val1513_644), BUNSPEC);
   }
}



/* _intern-sfun/cinfo-predicate-of-set!3052 */
obj_t 
_intern_sfun_cinfo_predicate_of_set_3052_3_cfa_info(obj_t env_5814, obj_t obj_5815, obj_t val1513_5816)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 542 */
      return
	 intern_sfun_cinfo_predicate_of_set__1_cfa_info(
	 (sfun_bglt) (obj_5815), val1513_5816);
   }
}



/* intern-sfun/cinfo-predicate-of */
obj_t 
intern_sfun_cinfo_predicate_of_250_cfa_info(sfun_bglt obj_645)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 542 */
      return
	 (((sfun_bglt) CREF(obj_645))->predicate_of_78);
   }
}



/* _intern-sfun/cinfo-predicate-of3053 */
obj_t 
_intern_sfun_cinfo_predicate_of3053_13_cfa_info(obj_t env_5817, obj_t obj_5818)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 542 */
      return
	 intern_sfun_cinfo_predicate_of_250_cfa_info(
	 (sfun_bglt) (obj_5818));
   }
}



/* intern-sfun/cinfo-stack-allocator-set! */
obj_t 
intern_sfun_cinfo_stack_allocator_set__130_cfa_info(sfun_bglt obj_646, obj_t val1514_647)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 544 */
      return
	 ((((sfun_bglt) CREF(obj_646))->stack_allocator_172) = ((obj_t) val1514_647), BUNSPEC);
   }
}



/* _intern-sfun/cinfo-stack-allocator-set!3054 */
obj_t 
_intern_sfun_cinfo_stack_allocator_set_3054_122_cfa_info(obj_t env_5819, obj_t obj_5820, obj_t val1514_5821)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 544 */
      return
	 intern_sfun_cinfo_stack_allocator_set__130_cfa_info(
	 (sfun_bglt) (obj_5820), val1514_5821);
   }
}



/* intern-sfun/cinfo-stack-allocator */
obj_t 
intern_sfun_cinfo_stack_allocator_82_cfa_info(sfun_bglt obj_648)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 544 */
      return
	 (((sfun_bglt) CREF(obj_648))->stack_allocator_172);
   }
}



/* _intern-sfun/cinfo-stack-allocator3055 */
obj_t 
_intern_sfun_cinfo_stack_allocator3055_135_cfa_info(obj_t env_5822, obj_t obj_5823)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 544 */
      return
	 intern_sfun_cinfo_stack_allocator_82_cfa_info(
	 (sfun_bglt) (obj_5823));
   }
}



/* intern-sfun/cinfo-top?-set! */
obj_t 
intern_sfun_cinfo_top__set__70_cfa_info(sfun_bglt obj_649, bool_t val1515_650)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 546 */
      return
	 ((((sfun_bglt) CREF(obj_649))->top__138) = ((bool_t) val1515_650), BUNSPEC);
   }
}



/* _intern-sfun/cinfo-top?-set!3056 */
obj_t 
_intern_sfun_cinfo_top__set_3056_140_cfa_info(obj_t env_5824, obj_t obj_5825, obj_t val1515_5826)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 546 */
      return
	 intern_sfun_cinfo_top__set__70_cfa_info(
	 (sfun_bglt) (obj_5825),
	 CBOOL(val1515_5826));
   }
}



/* intern-sfun/cinfo-top? */
bool_t 
intern_sfun_cinfo_top__47_cfa_info(sfun_bglt obj_651)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 546 */
      return
	 (((sfun_bglt) CREF(obj_651))->top__138);
   }
}



/* _intern-sfun/cinfo-top?3057 */
obj_t 
_intern_sfun_cinfo_top_3057_117_cfa_info(obj_t env_5827, obj_t obj_5828)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 546 */
      {		/* ./Ast/var.scm 546 */
	 bool_t aux_8818;
	 aux_8818 =
	    intern_sfun_cinfo_top__47_cfa_info(
	    (sfun_bglt) (obj_5828));
	 return
	    BBOOL(aux_8818);
      }
   }
}



/* intern-sfun/cinfo-the-closure-set! */
obj_t 
intern_sfun_cinfo_the_closure_set__54_cfa_info(sfun_bglt obj_652, obj_t val1516_653)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 548 */
      return
	 ((((sfun_bglt) CREF(obj_652))->the_closure_238) = ((obj_t) val1516_653), BUNSPEC);
   }
}



/* _intern-sfun/cinfo-the-closure-set!3058 */
obj_t 
_intern_sfun_cinfo_the_closure_set_3058_172_cfa_info(obj_t env_5829, obj_t obj_5830, obj_t val1516_5831)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 548 */
      return
	 intern_sfun_cinfo_the_closure_set__54_cfa_info(
	 (sfun_bglt) (obj_5830), val1516_5831);
   }
}



/* intern-sfun/cinfo-the-closure */
obj_t 
intern_sfun_cinfo_the_closure_231_cfa_info(sfun_bglt obj_654)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 548 */
      return
	 (((sfun_bglt) CREF(obj_654))->the_closure_238);
   }
}



/* _intern-sfun/cinfo-the-closure3059 */
obj_t 
_intern_sfun_cinfo_the_closure3059_177_cfa_info(obj_t env_5832, obj_t obj_5833)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 548 */
      return
	 intern_sfun_cinfo_the_closure_231_cfa_info(
	 (sfun_bglt) (obj_5833));
   }
}



/* intern-sfun/cinfo-property-set! */
obj_t 
intern_sfun_cinfo_property_set__111_cfa_info(sfun_bglt obj_655, obj_t val1517_656)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 552 */
      return
	 ((((sfun_bglt) CREF(obj_655))->property) = ((obj_t) val1517_656), BUNSPEC);
   }
}



/* _intern-sfun/cinfo-property-set!3060 */
obj_t 
_intern_sfun_cinfo_property_set_3060_59_cfa_info(obj_t env_5834, obj_t obj_5835, obj_t val1517_5836)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 552 */
      return
	 intern_sfun_cinfo_property_set__111_cfa_info(
	 (sfun_bglt) (obj_5835), val1517_5836);
   }
}



/* intern-sfun/cinfo-property */
obj_t 
intern_sfun_cinfo_property_154_cfa_info(sfun_bglt obj_657)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 552 */
      return
	 (((sfun_bglt) CREF(obj_657))->property);
   }
}



/* _intern-sfun/cinfo-property3061 */
obj_t 
_intern_sfun_cinfo_property3061_231_cfa_info(obj_t env_5837, obj_t obj_5838)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 552 */
      return
	 intern_sfun_cinfo_property_154_cfa_info(
	 (sfun_bglt) (obj_5838));
   }
}



/* intern-sfun/cinfo-args-set! */
obj_t 
intern_sfun_cinfo_args_set__79_cfa_info(sfun_bglt obj_658, obj_t val1518_659)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 554 */
      return
	 ((((sfun_bglt) CREF(obj_658))->args) = ((obj_t) val1518_659), BUNSPEC);
   }
}



/* _intern-sfun/cinfo-args-set!3062 */
obj_t 
_intern_sfun_cinfo_args_set_3062_110_cfa_info(obj_t env_5839, obj_t obj_5840, obj_t val1518_5841)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 554 */
      return
	 intern_sfun_cinfo_args_set__79_cfa_info(
	 (sfun_bglt) (obj_5840), val1518_5841);
   }
}



/* intern-sfun/cinfo-args */
obj_t 
intern_sfun_cinfo_args_90_cfa_info(sfun_bglt obj_660)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 554 */
      return
	 (((sfun_bglt) CREF(obj_660))->args);
   }
}



/* _intern-sfun/cinfo-args3063 */
obj_t 
_intern_sfun_cinfo_args3063_161_cfa_info(obj_t env_5842, obj_t obj_5843)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 554 */
      return
	 intern_sfun_cinfo_args_90_cfa_info(
	 (sfun_bglt) (obj_5843));
   }
}



/* intern-sfun/cinfo-body-set! */
obj_t 
intern_sfun_cinfo_body_set__86_cfa_info(sfun_bglt obj_661, obj_t val1519_662)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 556 */
      return
	 ((((sfun_bglt) CREF(obj_661))->body) = ((obj_t) val1519_662), BUNSPEC);
   }
}



/* _intern-sfun/cinfo-body-set!3064 */
obj_t 
_intern_sfun_cinfo_body_set_3064_241_cfa_info(obj_t env_5844, obj_t obj_5845, obj_t val1519_5846)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 556 */
      return
	 intern_sfun_cinfo_body_set__86_cfa_info(
	 (sfun_bglt) (obj_5845), val1519_5846);
   }
}



/* intern-sfun/cinfo-body */
obj_t 
intern_sfun_cinfo_body_52_cfa_info(sfun_bglt obj_663)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 556 */
      return
	 (((sfun_bglt) CREF(obj_663))->body);
   }
}



/* _intern-sfun/cinfo-body3065 */
obj_t 
_intern_sfun_cinfo_body3065_40_cfa_info(obj_t env_5847, obj_t obj_5848)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 556 */
      return
	 intern_sfun_cinfo_body_52_cfa_info(
	 (sfun_bglt) (obj_5848));
   }
}



/* intern-sfun/cinfo-class-set! */
obj_t 
intern_sfun_cinfo_class_set__85_cfa_info(sfun_bglt obj_664, obj_t val1520_665)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 558 */
      return
	 ((((sfun_bglt) CREF(obj_664))->class) = ((obj_t) val1520_665), BUNSPEC);
   }
}



/* _intern-sfun/cinfo-class-set!3066 */
obj_t 
_intern_sfun_cinfo_class_set_3066_64_cfa_info(obj_t env_5849, obj_t obj_5850, obj_t val1520_5851)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 558 */
      return
	 intern_sfun_cinfo_class_set__85_cfa_info(
	 (sfun_bglt) (obj_5850), val1520_5851);
   }
}



/* intern-sfun/cinfo-class */
obj_t 
intern_sfun_cinfo_class_26_cfa_info(sfun_bglt obj_666)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 558 */
      return
	 (((sfun_bglt) CREF(obj_666))->class);
   }
}



/* _intern-sfun/cinfo-class3067 */
obj_t 
_intern_sfun_cinfo_class3067_224_cfa_info(obj_t env_5852, obj_t obj_5853)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 558 */
      return
	 intern_sfun_cinfo_class_26_cfa_info(
	 (sfun_bglt) (obj_5853));
   }
}



/* intern-sfun/cinfo-dsssl-keywords-set! */
obj_t 
intern_sfun_cinfo_dsssl_keywords_set__175_cfa_info(sfun_bglt obj_667, obj_t val1521_668)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 564 */
      return
	 ((((sfun_bglt) CREF(obj_667))->dsssl_keywords_243) = ((obj_t) val1521_668), BUNSPEC);
   }
}



/* _intern-sfun/cinfo-dsssl-keywords-set!3068 */
obj_t 
_intern_sfun_cinfo_dsssl_keywords_set_3068_50_cfa_info(obj_t env_5854, obj_t obj_5855, obj_t val1521_5856)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 564 */
      return
	 intern_sfun_cinfo_dsssl_keywords_set__175_cfa_info(
	 (sfun_bglt) (obj_5855), val1521_5856);
   }
}



/* intern-sfun/cinfo-dsssl-keywords */
obj_t 
intern_sfun_cinfo_dsssl_keywords_133_cfa_info(sfun_bglt obj_669)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 564 */
      return
	 (((sfun_bglt) CREF(obj_669))->dsssl_keywords_243);
   }
}



/* _intern-sfun/cinfo-dsssl-keywords3069 */
obj_t 
_intern_sfun_cinfo_dsssl_keywords3069_120_cfa_info(obj_t env_5857, obj_t obj_5858)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 564 */
      return
	 intern_sfun_cinfo_dsssl_keywords_133_cfa_info(
	 (sfun_bglt) (obj_5858));
   }
}



/* intern-sfun/cinfo-loc-set! */
obj_t 
intern_sfun_cinfo_loc_set__209_cfa_info(sfun_bglt obj_670, obj_t val1522_671)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 569 */
      return
	 ((((sfun_bglt) CREF(obj_670))->loc) = ((obj_t) val1522_671), BUNSPEC);
   }
}



/* _intern-sfun/cinfo-loc-set!3070 */
obj_t 
_intern_sfun_cinfo_loc_set_3070_249_cfa_info(obj_t env_5859, obj_t obj_5860, obj_t val1522_5861)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 569 */
      return
	 intern_sfun_cinfo_loc_set__209_cfa_info(
	 (sfun_bglt) (obj_5860), val1522_5861);
   }
}



/* intern-sfun/cinfo-loc */
obj_t 
intern_sfun_cinfo_loc_54_cfa_info(sfun_bglt obj_672)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 569 */
      return
	 (((sfun_bglt) CREF(obj_672))->loc);
   }
}



/* _intern-sfun/cinfo-loc3071 */
obj_t 
_intern_sfun_cinfo_loc3071_216_cfa_info(obj_t env_5862, obj_t obj_5863)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 569 */
      return
	 intern_sfun_cinfo_loc_54_cfa_info(
	 (sfun_bglt) (obj_5863));
   }
}



/* intern-sfun/cinfo-approx */
approx_bglt 
intern_sfun_cinfo_approx_57_cfa_info(intern_sfun_cinfo_192_bglt obj_673)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 42 */
      {
	 obj_t aux_8864;
	 {	/* Cfa/cinfo.scm 42 */
	    object_bglt aux_8865;
	    aux_8865 =
	       (object_bglt) (obj_673);
	    aux_8864 =
	       OBJECT_WIDENING(aux_8865);
	 }
	 return
	    (((intern_sfun_cinfo_192_bglt) CREF(aux_8864))->approx);
      }
   }
}



/* _intern-sfun/cinfo-approx3072 */
obj_t 
_intern_sfun_cinfo_approx3072_159_cfa_info(obj_t env_5864, obj_t obj_5865)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 42 */
      {		/* Cfa/cinfo.scm 42 */
	 approx_bglt aux_8869;
	 aux_8869 =
	    intern_sfun_cinfo_approx_57_cfa_info(
	    (intern_sfun_cinfo_192_bglt) (obj_5865));
	 return
	    (obj_t) (aux_8869);
      }
   }
}



/* intern-sfun/cinfo-stamp-set! */
obj_t 
intern_sfun_cinfo_stamp_set__83_cfa_info(intern_sfun_cinfo_192_bglt obj_674, long val1523_675)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 43 */
      {
	 obj_t aux_8873;
	 {	/* Cfa/cinfo.scm 43 */
	    object_bglt aux_8874;
	    aux_8874 =
	       (object_bglt) (obj_674);
	    aux_8873 =
	       OBJECT_WIDENING(aux_8874);
	 }
	 return
	    ((((intern_sfun_cinfo_192_bglt) CREF(aux_8873))->stamp) = ((long) val1523_675), BUNSPEC);
      }
   }
}



/* _intern-sfun/cinfo-stamp-set!3073 */
obj_t 
_intern_sfun_cinfo_stamp_set_3073_246_cfa_info(obj_t env_5866, obj_t obj_5867, obj_t val1523_5868)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 43 */
      return
	 intern_sfun_cinfo_stamp_set__83_cfa_info(
	 (intern_sfun_cinfo_192_bglt) (obj_5867),
	 (long) CINT(val1523_5868));
   }
}



/* intern-sfun/cinfo-stamp */
long 
intern_sfun_cinfo_stamp_249_cfa_info(intern_sfun_cinfo_192_bglt obj_676)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 43 */
      {
	 obj_t aux_8881;
	 {	/* Cfa/cinfo.scm 43 */
	    object_bglt aux_8882;
	    aux_8882 =
	       (object_bglt) (obj_676);
	    aux_8881 =
	       OBJECT_WIDENING(aux_8882);
	 }
	 return
	    (((intern_sfun_cinfo_192_bglt) CREF(aux_8881))->stamp);
      }
   }
}



/* _intern-sfun/cinfo-stamp3074 */
obj_t 
_intern_sfun_cinfo_stamp3074_165_cfa_info(obj_t env_5869, obj_t obj_5870)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 43 */
      {		/* Cfa/cinfo.scm 43 */
	 long aux_8886;
	 aux_8886 =
	    intern_sfun_cinfo_stamp_249_cfa_info(
	    (intern_sfun_cinfo_192_bglt) (obj_5870));
	 return
	    BINT(aux_8886);
      }
   }
}



/* allocate-extern-sfun/cinfo */
sfun_bglt 
allocate_extern_sfun_cinfo_223_cfa_info()
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 40 */
      {		/* Cfa/cinfo.scm 40 */
	 sfun_bglt new1505_1881;
	 new1505_1881 =
	    ((sfun_bglt) BREF(GC_MALLOC(sizeof(struct sfun))));
	 {	/* Cfa/cinfo.scm 40 */
	    long arg2350_1882;
	    arg2350_1882 =
	       class_num_218___object(extern_sfun_cinfo_6_cfa_info);
	    {	/* Cfa/cinfo.scm 40 */
	       obj_t obj_3695;
	       obj_3695 =
		  (obj_t) (new1505_1881);
	       (((obj_t) CREF(obj_3695))->header = MAKE_HEADER(arg2350_1882, 0), BUNSPEC);
	    }
	 }
	 {	/* Cfa/cinfo.scm 40 */
	    object_bglt aux_8894;
	    aux_8894 =
	       (object_bglt) (new1505_1881);
	    OBJECT_WIDENING_SET(aux_8894, BFALSE);
	 }
	 return new1505_1881;
      }
   }
}



/* _allocate-extern-sfun/cinfo */
obj_t 
_allocate_extern_sfun_cinfo_234_cfa_info(obj_t env_4898)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 40 */
      {		/* Cfa/cinfo.scm 40 */
	 sfun_bglt aux_8897;
	 aux_8897 =
	    allocate_extern_sfun_cinfo_223_cfa_info();
	 return
	    (obj_t) (aux_8897);
      }
   }
}



/* extern-sfun/cinfo? */
bool_t 
extern_sfun_cinfo__167_cfa_info(obj_t obj_680)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 40 */
      return
	 is_a__118___object(obj_680, extern_sfun_cinfo_6_cfa_info);
   }
}



/* _extern-sfun/cinfo? */
obj_t 
_extern_sfun_cinfo__255_cfa_info(obj_t env_5871, obj_t obj_5872)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 40 */
      {		/* Cfa/cinfo.scm 40 */
	 bool_t aux_8901;
	 aux_8901 =
	    extern_sfun_cinfo__167_cfa_info(obj_5872);
	 return
	    BBOOL(aux_8901);
      }
   }
}



/* widening-extern-sfun/cinfo */
extern_sfun_cinfo_6_bglt 
widening_extern_sfun_cinfo_222_cfa_info(approx_bglt approx_681)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 40 */
      {		/* Cfa/cinfo.scm 40 */
	 extern_sfun_cinfo_6_bglt new1500_3697;
	 new1500_3697 =
	    ((extern_sfun_cinfo_6_bglt) BREF(GC_MALLOC(sizeof(struct extern_sfun_cinfo_6))));
	 ((((extern_sfun_cinfo_6_bglt) CREF(new1500_3697))->approx) = ((approx_bglt) approx_681), BUNSPEC);
	 return new1500_3697;
      }
   }
}



/* _widening-extern-sfun/cinfo3075 */
obj_t 
_widening_extern_sfun_cinfo3075_199_cfa_info(obj_t env_5873, obj_t approx_5874)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 40 */
      {		/* Cfa/cinfo.scm 40 */
	 extern_sfun_cinfo_6_bglt aux_8906;
	 aux_8906 =
	    widening_extern_sfun_cinfo_222_cfa_info(
	    (approx_bglt) (approx_5874));
	 return
	    (obj_t) (aux_8906);
      }
   }
}



/* make-extern-sfun/cinfo */
extern_sfun_cinfo_6_bglt 
make_extern_sfun_cinfo_180_cfa_info(long arity_682, obj_t side_effect__165_683, obj_t predicate_of_78_684, obj_t stack_allocator_172_685, bool_t top__138_686, obj_t the_closure_238_687, obj_t property_688, obj_t args_689, obj_t body_690, obj_t class_691, obj_t dsssl_keywords_243_692, obj_t loc_693, approx_bglt approx_694)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 40 */
      {		/* Cfa/cinfo.scm 40 */
	 sfun_bglt aux1503_3699;
	 {	/* Cfa/cinfo.scm 40 */
	    sfun_bglt res2737_3731;
	    {	/* ./Ast/var.scm 550 */
	       sfun_bglt new1127_3715;
	       new1127_3715 =
		  ((sfun_bglt) BREF(GC_MALLOC(sizeof(struct sfun))));
	       {	/* ./Ast/var.scm 550 */
		  long arg2415_3716;
		  arg2415_3716 =
		     class_num_218___object(sfun_ast_var);
		  {	/* ./Ast/var.scm 550 */
		     obj_t obj_3729;
		     obj_3729 =
			(obj_t) (new1127_3715);
		     (((obj_t) CREF(obj_3729))->header = MAKE_HEADER(arg2415_3716, 0), BUNSPEC);
		  }
	       }
	       {	/* ./Ast/var.scm 550 */
		  object_bglt aux_8914;
		  aux_8914 =
		     (object_bglt) (new1127_3715);
		  OBJECT_WIDENING_SET(aux_8914, BFALSE);
	       }
	       ((((sfun_bglt) CREF(new1127_3715))->arity) = ((long) arity_682), BUNSPEC);
	       ((((sfun_bglt) CREF(new1127_3715))->side_effect__165) = ((obj_t) side_effect__165_683), BUNSPEC);
	       ((((sfun_bglt) CREF(new1127_3715))->predicate_of_78) = ((obj_t) predicate_of_78_684), BUNSPEC);
	       ((((sfun_bglt) CREF(new1127_3715))->stack_allocator_172) = ((obj_t) stack_allocator_172_685), BUNSPEC);
	       ((((sfun_bglt) CREF(new1127_3715))->top__138) = ((bool_t) top__138_686), BUNSPEC);
	       ((((sfun_bglt) CREF(new1127_3715))->the_closure_238) = ((obj_t) the_closure_238_687), BUNSPEC);
	       ((((sfun_bglt) CREF(new1127_3715))->property) = ((obj_t) property_688), BUNSPEC);
	       ((((sfun_bglt) CREF(new1127_3715))->args) = ((obj_t) args_689), BUNSPEC);
	       ((((sfun_bglt) CREF(new1127_3715))->body) = ((obj_t) body_690), BUNSPEC);
	       ((((sfun_bglt) CREF(new1127_3715))->class) = ((obj_t) class_691), BUNSPEC);
	       ((((sfun_bglt) CREF(new1127_3715))->dsssl_keywords_243) = ((obj_t) dsssl_keywords_243_692), BUNSPEC);
	       ((((sfun_bglt) CREF(new1127_3715))->loc) = ((obj_t) loc_693), BUNSPEC);
	       res2737_3731 = new1127_3715;
	    }
	    aux1503_3699 = res2737_3731;
	 }
	 {	/* Cfa/cinfo.scm 40 */
	    extern_sfun_cinfo_6_bglt new1504_3700;
	    new1504_3700 =
	       ((extern_sfun_cinfo_6_bglt) (aux1503_3699));
	    {	/* Cfa/cinfo.scm 40 */
	       long arg2351_3701;
	       arg2351_3701 =
		  class_num_218___object(extern_sfun_cinfo_6_cfa_info);
	       {	/* Cfa/cinfo.scm 40 */
		  obj_t obj_3732;
		  obj_3732 =
		     (obj_t) (new1504_3700);
		  (((obj_t) CREF(obj_3732))->header = MAKE_HEADER(arg2351_3701, 0), BUNSPEC);
	       }
	    }
	    {	/* Cfa/cinfo.scm 40 */
	       extern_sfun_cinfo_6_bglt arg2352_3702;
	       {	/* Cfa/cinfo.scm 40 */
		  extern_sfun_cinfo_6_bglt res2738_3737;
		  {	/* Cfa/cinfo.scm 40 */
		     extern_sfun_cinfo_6_bglt new1500_3735;
		     new1500_3735 =
			((extern_sfun_cinfo_6_bglt) BREF(GC_MALLOC(sizeof(struct extern_sfun_cinfo_6))));
		     ((((extern_sfun_cinfo_6_bglt) CREF(new1500_3735))->approx) = ((approx_bglt) approx_694), BUNSPEC);
		     res2738_3737 = new1500_3735;
		  }
		  arg2352_3702 = res2738_3737;
	       }
	       {	/* Cfa/cinfo.scm 40 */
		  obj_t aux_8937;
		  object_bglt aux_8935;
		  aux_8937 =
		     (obj_t) (arg2352_3702);
		  aux_8935 =
		     (object_bglt) (new1504_3700);
		  OBJECT_WIDENING_SET(aux_8935, aux_8937);
	       }
	    }
	    return new1504_3700;
	 }
      }
   }
}



/* _make-extern-sfun/cinfo3076 */
obj_t 
_make_extern_sfun_cinfo3076_187_cfa_info(obj_t env_5875, obj_t arity_5876, obj_t side_effect__165_5877, obj_t predicate_of_78_5878, obj_t stack_allocator_172_5879, obj_t top__138_5880, obj_t the_closure_238_5881, obj_t property_5882, obj_t args_5883, obj_t body_5884, obj_t class_5885, obj_t dsssl_keywords_243_5886, obj_t loc_5887, obj_t approx_5888)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 40 */
      {		/* Cfa/cinfo.scm 40 */
	 extern_sfun_cinfo_6_bglt aux_8940;
	 aux_8940 =
	    make_extern_sfun_cinfo_180_cfa_info(
	    (long) CINT(arity_5876), side_effect__165_5877, predicate_of_78_5878, stack_allocator_172_5879,
	    CBOOL(top__138_5880), the_closure_238_5881, property_5882, args_5883, body_5884, class_5885, dsssl_keywords_243_5886, loc_5887,
	    (approx_bglt) (approx_5888));
	 return
	    (obj_t) (aux_8940);
      }
   }
}



/* extern-sfun/cinfo-arity */
long 
extern_sfun_cinfo_arity_43_cfa_info(sfun_bglt obj_695)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 538 */
      return
	 (((sfun_bglt) CREF(obj_695))->arity);
   }
}



/* _extern-sfun/cinfo-arity3077 */
obj_t 
_extern_sfun_cinfo_arity3077_249_cfa_info(obj_t env_5889, obj_t obj_5890)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 538 */
      {		/* ./Ast/var.scm 538 */
	 long aux_8947;
	 aux_8947 =
	    extern_sfun_cinfo_arity_43_cfa_info(
	    (sfun_bglt) (obj_5890));
	 return
	    BINT(aux_8947);
      }
   }
}



/* extern-sfun/cinfo-side-effect?-set! */
obj_t 
extern_sfun_cinfo_side_effect__set__111_cfa_info(sfun_bglt obj_696, obj_t val1489_697)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 540 */
      return
	 ((((sfun_bglt) CREF(obj_696))->side_effect__165) = ((obj_t) val1489_697), BUNSPEC);
   }
}



/* _extern-sfun/cinfo-side-effect?-set!3078 */
obj_t 
_extern_sfun_cinfo_side_effect__set_3078_108_cfa_info(obj_t env_5891, obj_t obj_5892, obj_t val1489_5893)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 540 */
      return
	 extern_sfun_cinfo_side_effect__set__111_cfa_info(
	 (sfun_bglt) (obj_5892), val1489_5893);
   }
}



/* extern-sfun/cinfo-side-effect? */
obj_t 
extern_sfun_cinfo_side_effect__154_cfa_info(sfun_bglt obj_698)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 540 */
      return
	 (((sfun_bglt) CREF(obj_698))->side_effect__165);
   }
}



/* _extern-sfun/cinfo-side-effect?3079 */
obj_t 
_extern_sfun_cinfo_side_effect_3079_78_cfa_info(obj_t env_5894, obj_t obj_5895)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 540 */
      return
	 extern_sfun_cinfo_side_effect__154_cfa_info(
	 (sfun_bglt) (obj_5895));
   }
}



/* extern-sfun/cinfo-predicate-of-set! */
obj_t 
extern_sfun_cinfo_predicate_of_set__5_cfa_info(sfun_bglt obj_699, obj_t val1490_700)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 542 */
      return
	 ((((sfun_bglt) CREF(obj_699))->predicate_of_78) = ((obj_t) val1490_700), BUNSPEC);
   }
}



/* _extern-sfun/cinfo-predicate-of-set!3080 */
obj_t 
_extern_sfun_cinfo_predicate_of_set_3080_197_cfa_info(obj_t env_5896, obj_t obj_5897, obj_t val1490_5898)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 542 */
      return
	 extern_sfun_cinfo_predicate_of_set__5_cfa_info(
	 (sfun_bglt) (obj_5897), val1490_5898);
   }
}



/* extern-sfun/cinfo-predicate-of */
obj_t 
extern_sfun_cinfo_predicate_of_245_cfa_info(sfun_bglt obj_701)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 542 */
      return
	 (((sfun_bglt) CREF(obj_701))->predicate_of_78);
   }
}



/* _extern-sfun/cinfo-predicate-of3081 */
obj_t 
_extern_sfun_cinfo_predicate_of3081_90_cfa_info(obj_t env_5899, obj_t obj_5900)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 542 */
      return
	 extern_sfun_cinfo_predicate_of_245_cfa_info(
	 (sfun_bglt) (obj_5900));
   }
}



/* extern-sfun/cinfo-stack-allocator-set! */
obj_t 
extern_sfun_cinfo_stack_allocator_set__23_cfa_info(sfun_bglt obj_702, obj_t val1491_703)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 544 */
      return
	 ((((sfun_bglt) CREF(obj_702))->stack_allocator_172) = ((obj_t) val1491_703), BUNSPEC);
   }
}



/* _extern-sfun/cinfo-stack-allocator-set!3082 */
obj_t 
_extern_sfun_cinfo_stack_allocator_set_3082_76_cfa_info(obj_t env_5901, obj_t obj_5902, obj_t val1491_5903)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 544 */
      return
	 extern_sfun_cinfo_stack_allocator_set__23_cfa_info(
	 (sfun_bglt) (obj_5902), val1491_5903);
   }
}



/* extern-sfun/cinfo-stack-allocator */
obj_t 
extern_sfun_cinfo_stack_allocator_17_cfa_info(sfun_bglt obj_704)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 544 */
      return
	 (((sfun_bglt) CREF(obj_704))->stack_allocator_172);
   }
}



/* _extern-sfun/cinfo-stack-allocator3083 */
obj_t 
_extern_sfun_cinfo_stack_allocator3083_83_cfa_info(obj_t env_5904, obj_t obj_5905)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 544 */
      return
	 extern_sfun_cinfo_stack_allocator_17_cfa_info(
	 (sfun_bglt) (obj_5905));
   }
}



/* extern-sfun/cinfo-top?-set! */
obj_t 
extern_sfun_cinfo_top__set__250_cfa_info(sfun_bglt obj_705, bool_t val1492_706)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 546 */
      return
	 ((((sfun_bglt) CREF(obj_705))->top__138) = ((bool_t) val1492_706), BUNSPEC);
   }
}



/* _extern-sfun/cinfo-top?-set!3084 */
obj_t 
_extern_sfun_cinfo_top__set_3084_123_cfa_info(obj_t env_5906, obj_t obj_5907, obj_t val1492_5908)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 546 */
      return
	 extern_sfun_cinfo_top__set__250_cfa_info(
	 (sfun_bglt) (obj_5907),
	 CBOOL(val1492_5908));
   }
}



/* extern-sfun/cinfo-top? */
bool_t 
extern_sfun_cinfo_top__212_cfa_info(sfun_bglt obj_707)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 546 */
      return
	 (((sfun_bglt) CREF(obj_707))->top__138);
   }
}



/* _extern-sfun/cinfo-top?3085 */
obj_t 
_extern_sfun_cinfo_top_3085_170_cfa_info(obj_t env_5909, obj_t obj_5910)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 546 */
      {		/* ./Ast/var.scm 546 */
	 bool_t aux_8974;
	 aux_8974 =
	    extern_sfun_cinfo_top__212_cfa_info(
	    (sfun_bglt) (obj_5910));
	 return
	    BBOOL(aux_8974);
      }
   }
}



/* extern-sfun/cinfo-the-closure-set! */
obj_t 
extern_sfun_cinfo_the_closure_set__203_cfa_info(sfun_bglt obj_708, obj_t val1493_709)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 548 */
      return
	 ((((sfun_bglt) CREF(obj_708))->the_closure_238) = ((obj_t) val1493_709), BUNSPEC);
   }
}



/* _extern-sfun/cinfo-the-closure-set!3086 */
obj_t 
_extern_sfun_cinfo_the_closure_set_3086_194_cfa_info(obj_t env_5911, obj_t obj_5912, obj_t val1493_5913)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 548 */
      return
	 extern_sfun_cinfo_the_closure_set__203_cfa_info(
	 (sfun_bglt) (obj_5912), val1493_5913);
   }
}



/* extern-sfun/cinfo-the-closure */
obj_t 
extern_sfun_cinfo_the_closure_159_cfa_info(sfun_bglt obj_710)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 548 */
      return
	 (((sfun_bglt) CREF(obj_710))->the_closure_238);
   }
}



/* _extern-sfun/cinfo-the-closure3087 */
obj_t 
_extern_sfun_cinfo_the_closure3087_249_cfa_info(obj_t env_5914, obj_t obj_5915)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 548 */
      return
	 extern_sfun_cinfo_the_closure_159_cfa_info(
	 (sfun_bglt) (obj_5915));
   }
}



/* extern-sfun/cinfo-property-set! */
obj_t 
extern_sfun_cinfo_property_set__166_cfa_info(sfun_bglt obj_711, obj_t val1494_712)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 552 */
      return
	 ((((sfun_bglt) CREF(obj_711))->property) = ((obj_t) val1494_712), BUNSPEC);
   }
}



/* _extern-sfun/cinfo-property-set!3088 */
obj_t 
_extern_sfun_cinfo_property_set_3088_67_cfa_info(obj_t env_5916, obj_t obj_5917, obj_t val1494_5918)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 552 */
      return
	 extern_sfun_cinfo_property_set__166_cfa_info(
	 (sfun_bglt) (obj_5917), val1494_5918);
   }
}



/* extern-sfun/cinfo-property */
obj_t 
extern_sfun_cinfo_property_112_cfa_info(sfun_bglt obj_713)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 552 */
      return
	 (((sfun_bglt) CREF(obj_713))->property);
   }
}



/* _extern-sfun/cinfo-property3089 */
obj_t 
_extern_sfun_cinfo_property3089_138_cfa_info(obj_t env_5919, obj_t obj_5920)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 552 */
      return
	 extern_sfun_cinfo_property_112_cfa_info(
	 (sfun_bglt) (obj_5920));
   }
}



/* extern-sfun/cinfo-args-set! */
obj_t 
extern_sfun_cinfo_args_set__187_cfa_info(sfun_bglt obj_714, obj_t val1495_715)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 554 */
      return
	 ((((sfun_bglt) CREF(obj_714))->args) = ((obj_t) val1495_715), BUNSPEC);
   }
}



/* _extern-sfun/cinfo-args-set!3090 */
obj_t 
_extern_sfun_cinfo_args_set_3090_10_cfa_info(obj_t env_5921, obj_t obj_5922, obj_t val1495_5923)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 554 */
      return
	 extern_sfun_cinfo_args_set__187_cfa_info(
	 (sfun_bglt) (obj_5922), val1495_5923);
   }
}



/* extern-sfun/cinfo-args */
obj_t 
extern_sfun_cinfo_args_4_cfa_info(sfun_bglt obj_716)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 554 */
      return
	 (((sfun_bglt) CREF(obj_716))->args);
   }
}



/* _extern-sfun/cinfo-args3091 */
obj_t 
_extern_sfun_cinfo_args3091_190_cfa_info(obj_t env_5924, obj_t obj_5925)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 554 */
      return
	 extern_sfun_cinfo_args_4_cfa_info(
	 (sfun_bglt) (obj_5925));
   }
}



/* extern-sfun/cinfo-body-set! */
obj_t 
extern_sfun_cinfo_body_set__15_cfa_info(sfun_bglt obj_717, obj_t val1496_718)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 556 */
      return
	 ((((sfun_bglt) CREF(obj_717))->body) = ((obj_t) val1496_718), BUNSPEC);
   }
}



/* _extern-sfun/cinfo-body-set!3092 */
obj_t 
_extern_sfun_cinfo_body_set_3092_110_cfa_info(obj_t env_5926, obj_t obj_5927, obj_t val1496_5928)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 556 */
      return
	 extern_sfun_cinfo_body_set__15_cfa_info(
	 (sfun_bglt) (obj_5927), val1496_5928);
   }
}



/* extern-sfun/cinfo-body */
obj_t 
extern_sfun_cinfo_body_232_cfa_info(sfun_bglt obj_719)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 556 */
      return
	 (((sfun_bglt) CREF(obj_719))->body);
   }
}



/* _extern-sfun/cinfo-body3093 */
obj_t 
_extern_sfun_cinfo_body3093_231_cfa_info(obj_t env_5929, obj_t obj_5930)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 556 */
      return
	 extern_sfun_cinfo_body_232_cfa_info(
	 (sfun_bglt) (obj_5930));
   }
}



/* extern-sfun/cinfo-class-set! */
obj_t 
extern_sfun_cinfo_class_set__12_cfa_info(sfun_bglt obj_720, obj_t val1497_721)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 558 */
      return
	 ((((sfun_bglt) CREF(obj_720))->class) = ((obj_t) val1497_721), BUNSPEC);
   }
}



/* _extern-sfun/cinfo-class-set!3094 */
obj_t 
_extern_sfun_cinfo_class_set_3094_243_cfa_info(obj_t env_5931, obj_t obj_5932, obj_t val1497_5933)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 558 */
      return
	 extern_sfun_cinfo_class_set__12_cfa_info(
	 (sfun_bglt) (obj_5932), val1497_5933);
   }
}



/* extern-sfun/cinfo-class */
obj_t 
extern_sfun_cinfo_class_204_cfa_info(sfun_bglt obj_722)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 558 */
      return
	 (((sfun_bglt) CREF(obj_722))->class);
   }
}



/* _extern-sfun/cinfo-class3095 */
obj_t 
_extern_sfun_cinfo_class3095_125_cfa_info(obj_t env_5934, obj_t obj_5935)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 558 */
      return
	 extern_sfun_cinfo_class_204_cfa_info(
	 (sfun_bglt) (obj_5935));
   }
}



/* extern-sfun/cinfo-dsssl-keywords-set! */
obj_t 
extern_sfun_cinfo_dsssl_keywords_set__212_cfa_info(sfun_bglt obj_723, obj_t val1498_724)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 564 */
      return
	 ((((sfun_bglt) CREF(obj_723))->dsssl_keywords_243) = ((obj_t) val1498_724), BUNSPEC);
   }
}



/* _extern-sfun/cinfo-dsssl-keywords-set!3096 */
obj_t 
_extern_sfun_cinfo_dsssl_keywords_set_3096_249_cfa_info(obj_t env_5936, obj_t obj_5937, obj_t val1498_5938)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 564 */
      return
	 extern_sfun_cinfo_dsssl_keywords_set__212_cfa_info(
	 (sfun_bglt) (obj_5937), val1498_5938);
   }
}



/* extern-sfun/cinfo-dsssl-keywords */
obj_t 
extern_sfun_cinfo_dsssl_keywords_3_cfa_info(sfun_bglt obj_725)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 564 */
      return
	 (((sfun_bglt) CREF(obj_725))->dsssl_keywords_243);
   }
}



/* _extern-sfun/cinfo-dsssl-keywords3097 */
obj_t 
_extern_sfun_cinfo_dsssl_keywords3097_20_cfa_info(obj_t env_5939, obj_t obj_5940)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 564 */
      return
	 extern_sfun_cinfo_dsssl_keywords_3_cfa_info(
	 (sfun_bglt) (obj_5940));
   }
}



/* extern-sfun/cinfo-loc-set! */
obj_t 
extern_sfun_cinfo_loc_set__83_cfa_info(sfun_bglt obj_726, obj_t val1499_727)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 569 */
      return
	 ((((sfun_bglt) CREF(obj_726))->loc) = ((obj_t) val1499_727), BUNSPEC);
   }
}



/* _extern-sfun/cinfo-loc-set!3098 */
obj_t 
_extern_sfun_cinfo_loc_set_3098_169_cfa_info(obj_t env_5941, obj_t obj_5942, obj_t val1499_5943)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 569 */
      return
	 extern_sfun_cinfo_loc_set__83_cfa_info(
	 (sfun_bglt) (obj_5942), val1499_5943);
   }
}



/* extern-sfun/cinfo-loc */
obj_t 
extern_sfun_cinfo_loc_249_cfa_info(sfun_bglt obj_728)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 569 */
      return
	 (((sfun_bglt) CREF(obj_728))->loc);
   }
}



/* _extern-sfun/cinfo-loc3099 */
obj_t 
_extern_sfun_cinfo_loc3099_188_cfa_info(obj_t env_5944, obj_t obj_5945)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 569 */
      return
	 extern_sfun_cinfo_loc_249_cfa_info(
	 (sfun_bglt) (obj_5945));
   }
}



/* extern-sfun/cinfo-approx */
approx_bglt 
extern_sfun_cinfo_approx_180_cfa_info(extern_sfun_cinfo_6_bglt obj_729)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 40 */
      {
	 obj_t aux_9020;
	 {	/* Cfa/cinfo.scm 40 */
	    object_bglt aux_9021;
	    aux_9021 =
	       (object_bglt) (obj_729);
	    aux_9020 =
	       OBJECT_WIDENING(aux_9021);
	 }
	 return
	    (((extern_sfun_cinfo_6_bglt) CREF(aux_9020))->approx);
      }
   }
}



/* _extern-sfun/cinfo-approx3100 */
obj_t 
_extern_sfun_cinfo_approx3100_201_cfa_info(obj_t env_5946, obj_t obj_5947)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 40 */
      {		/* Cfa/cinfo.scm 40 */
	 approx_bglt aux_9025;
	 aux_9025 =
	    extern_sfun_cinfo_approx_180_cfa_info(
	    (extern_sfun_cinfo_6_bglt) (obj_5947));
	 return
	    (obj_t) (aux_9025);
      }
   }
}



/* allocate-cfun/cinfo */
cfun_bglt 
allocate_cfun_cinfo_179_cfa_info()
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 39 */
      {		/* Cfa/cinfo.scm 39 */
	 cfun_bglt new1481_1889;
	 new1481_1889 =
	    ((cfun_bglt) BREF(GC_MALLOC(sizeof(struct cfun))));
	 {	/* Cfa/cinfo.scm 39 */
	    long arg2353_1890;
	    arg2353_1890 =
	       class_num_218___object(cfun_cinfo_200_cfa_info);
	    {	/* Cfa/cinfo.scm 39 */
	       obj_t obj_3738;
	       obj_3738 =
		  (obj_t) (new1481_1889);
	       (((obj_t) CREF(obj_3738))->header = MAKE_HEADER(arg2353_1890, 0), BUNSPEC);
	    }
	 }
	 {	/* Cfa/cinfo.scm 39 */
	    object_bglt aux_9033;
	    aux_9033 =
	       (object_bglt) (new1481_1889);
	    OBJECT_WIDENING_SET(aux_9033, BFALSE);
	 }
	 return new1481_1889;
      }
   }
}



/* _allocate-cfun/cinfo */
obj_t 
_allocate_cfun_cinfo_87_cfa_info(obj_t env_4897)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 39 */
      {		/* Cfa/cinfo.scm 39 */
	 cfun_bglt aux_9036;
	 aux_9036 =
	    allocate_cfun_cinfo_179_cfa_info();
	 return
	    (obj_t) (aux_9036);
      }
   }
}



/* cfun/cinfo? */
bool_t 
cfun_cinfo__10_cfa_info(obj_t obj_733)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 39 */
      return
	 is_a__118___object(obj_733, cfun_cinfo_200_cfa_info);
   }
}



/* _cfun/cinfo? */
obj_t 
_cfun_cinfo__48_cfa_info(obj_t env_5948, obj_t obj_5949)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 39 */
      {		/* Cfa/cinfo.scm 39 */
	 bool_t aux_9040;
	 aux_9040 =
	    cfun_cinfo__10_cfa_info(obj_5949);
	 return
	    BBOOL(aux_9040);
      }
   }
}



/* widening-cfun/cinfo */
cfun_cinfo_200_bglt 
widening_cfun_cinfo_224_cfa_info(approx_bglt approx_734)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 39 */
      {		/* Cfa/cinfo.scm 39 */
	 cfun_cinfo_200_bglt new1476_3740;
	 new1476_3740 =
	    ((cfun_cinfo_200_bglt) BREF(GC_MALLOC(sizeof(struct cfun_cinfo_200))));
	 ((((cfun_cinfo_200_bglt) CREF(new1476_3740))->approx) = ((approx_bglt) approx_734), BUNSPEC);
	 return new1476_3740;
      }
   }
}



/* _widening-cfun/cinfo3101 */
obj_t 
_widening_cfun_cinfo3101_148_cfa_info(obj_t env_5950, obj_t approx_5951)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 39 */
      {		/* Cfa/cinfo.scm 39 */
	 cfun_cinfo_200_bglt aux_9045;
	 aux_9045 =
	    widening_cfun_cinfo_224_cfa_info(
	    (approx_bglt) (approx_5951));
	 return
	    (obj_t) (aux_9045);
      }
   }
}



/* make-cfun/cinfo */
cfun_cinfo_200_bglt 
make_cfun_cinfo_44_cfa_info(long arity_735, obj_t side_effect__165_736, obj_t predicate_of_78_737, obj_t stack_allocator_172_738, bool_t top__138_739, obj_t the_closure_238_740, obj_t args_type_205_741, bool_t macro__33_742, bool_t infix__163_743, approx_bglt approx_744)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 39 */
      {		/* Cfa/cinfo.scm 39 */
	 cfun_bglt aux1479_3742;
	 {	/* Cfa/cinfo.scm 39 */
	    cfun_bglt res2739_3768;
	    {	/* ./Ast/var.scm 571 */
	       cfun_bglt new1148_3755;
	       new1148_3755 =
		  ((cfun_bglt) BREF(GC_MALLOC(sizeof(struct cfun))));
	       {	/* ./Ast/var.scm 571 */
		  long arg2413_3756;
		  arg2413_3756 =
		     class_num_218___object(cfun_ast_var);
		  {	/* ./Ast/var.scm 571 */
		     obj_t obj_3766;
		     obj_3766 =
			(obj_t) (new1148_3755);
		     (((obj_t) CREF(obj_3766))->header = MAKE_HEADER(arg2413_3756, 0), BUNSPEC);
		  }
	       }
	       {	/* ./Ast/var.scm 571 */
		  object_bglt aux_9053;
		  aux_9053 =
		     (object_bglt) (new1148_3755);
		  OBJECT_WIDENING_SET(aux_9053, BFALSE);
	       }
	       ((((cfun_bglt) CREF(new1148_3755))->arity) = ((long) arity_735), BUNSPEC);
	       ((((cfun_bglt) CREF(new1148_3755))->side_effect__165) = ((obj_t) side_effect__165_736), BUNSPEC);
	       ((((cfun_bglt) CREF(new1148_3755))->predicate_of_78) = ((obj_t) predicate_of_78_737), BUNSPEC);
	       ((((cfun_bglt) CREF(new1148_3755))->stack_allocator_172) = ((obj_t) stack_allocator_172_738), BUNSPEC);
	       ((((cfun_bglt) CREF(new1148_3755))->top__138) = ((bool_t) top__138_739), BUNSPEC);
	       ((((cfun_bglt) CREF(new1148_3755))->the_closure_238) = ((obj_t) the_closure_238_740), BUNSPEC);
	       ((((cfun_bglt) CREF(new1148_3755))->args_type_205) = ((obj_t) args_type_205_741), BUNSPEC);
	       ((((cfun_bglt) CREF(new1148_3755))->macro__33) = ((bool_t) macro__33_742), BUNSPEC);
	       ((((cfun_bglt) CREF(new1148_3755))->infix__163) = ((bool_t) infix__163_743), BUNSPEC);
	       res2739_3768 = new1148_3755;
	    }
	    aux1479_3742 = res2739_3768;
	 }
	 {	/* Cfa/cinfo.scm 39 */
	    cfun_cinfo_200_bglt new1480_3743;
	    new1480_3743 =
	       ((cfun_cinfo_200_bglt) (aux1479_3742));
	    {	/* Cfa/cinfo.scm 39 */
	       long arg2354_3744;
	       arg2354_3744 =
		  class_num_218___object(cfun_cinfo_200_cfa_info);
	       {	/* Cfa/cinfo.scm 39 */
		  obj_t obj_3769;
		  obj_3769 =
		     (obj_t) (new1480_3743);
		  (((obj_t) CREF(obj_3769))->header = MAKE_HEADER(arg2354_3744, 0), BUNSPEC);
	       }
	    }
	    {	/* Cfa/cinfo.scm 39 */
	       cfun_cinfo_200_bglt arg2355_3745;
	       {	/* Cfa/cinfo.scm 39 */
		  cfun_cinfo_200_bglt res2740_3774;
		  {	/* Cfa/cinfo.scm 39 */
		     cfun_cinfo_200_bglt new1476_3772;
		     new1476_3772 =
			((cfun_cinfo_200_bglt) BREF(GC_MALLOC(sizeof(struct cfun_cinfo_200))));
		     ((((cfun_cinfo_200_bglt) CREF(new1476_3772))->approx) = ((approx_bglt) approx_744), BUNSPEC);
		     res2740_3774 = new1476_3772;
		  }
		  arg2355_3745 = res2740_3774;
	       }
	       {	/* Cfa/cinfo.scm 39 */
		  obj_t aux_9073;
		  object_bglt aux_9071;
		  aux_9073 =
		     (obj_t) (arg2355_3745);
		  aux_9071 =
		     (object_bglt) (new1480_3743);
		  OBJECT_WIDENING_SET(aux_9071, aux_9073);
	       }
	    }
	    return new1480_3743;
	 }
      }
   }
}



/* _make-cfun/cinfo3102 */
obj_t 
_make_cfun_cinfo3102_0_cfa_info(obj_t env_5952, obj_t arity_5953, obj_t side_effect__165_5954, obj_t predicate_of_78_5955, obj_t stack_allocator_172_5956, obj_t top__138_5957, obj_t the_closure_238_5958, obj_t args_type_205_5959, obj_t macro__33_5960, obj_t infix__163_5961, obj_t approx_5962)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 39 */
      {		/* Cfa/cinfo.scm 39 */
	 cfun_cinfo_200_bglt aux_9076;
	 aux_9076 =
	    make_cfun_cinfo_44_cfa_info(
	    (long) CINT(arity_5953), side_effect__165_5954, predicate_of_78_5955, stack_allocator_172_5956,
	    CBOOL(top__138_5957), the_closure_238_5958, args_type_205_5959,
	    CBOOL(macro__33_5960),
	    CBOOL(infix__163_5961),
	    (approx_bglt) (approx_5962));
	 return
	    (obj_t) (aux_9076);
      }
   }
}



/* cfun/cinfo-arity */
long 
cfun_cinfo_arity_247_cfa_info(cfun_bglt obj_745)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 538 */
      return
	 (((cfun_bglt) CREF(obj_745))->arity);
   }
}



/* _cfun/cinfo-arity3103 */
obj_t 
_cfun_cinfo_arity3103_73_cfa_info(obj_t env_5963, obj_t obj_5964)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 538 */
      {		/* ./Ast/var.scm 538 */
	 long aux_9085;
	 aux_9085 =
	    cfun_cinfo_arity_247_cfa_info(
	    (cfun_bglt) (obj_5964));
	 return
	    BINT(aux_9085);
      }
   }
}



/* cfun/cinfo-side-effect?-set! */
obj_t 
cfun_cinfo_side_effect__set__194_cfa_info(cfun_bglt obj_746, obj_t val1470_747)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 540 */
      return
	 ((((cfun_bglt) CREF(obj_746))->side_effect__165) = ((obj_t) val1470_747), BUNSPEC);
   }
}



/* _cfun/cinfo-side-effect?-set!3104 */
obj_t 
_cfun_cinfo_side_effect__set_3104_38_cfa_info(obj_t env_5965, obj_t obj_5966, obj_t val1470_5967)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 540 */
      return
	 cfun_cinfo_side_effect__set__194_cfa_info(
	 (cfun_bglt) (obj_5966), val1470_5967);
   }
}



/* cfun/cinfo-side-effect? */
obj_t 
cfun_cinfo_side_effect__165_cfa_info(cfun_bglt obj_748)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 540 */
      return
	 (((cfun_bglt) CREF(obj_748))->side_effect__165);
   }
}



/* _cfun/cinfo-side-effect?3105 */
obj_t 
_cfun_cinfo_side_effect_3105_189_cfa_info(obj_t env_5968, obj_t obj_5969)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 540 */
      return
	 cfun_cinfo_side_effect__165_cfa_info(
	 (cfun_bglt) (obj_5969));
   }
}



/* cfun/cinfo-predicate-of-set! */
obj_t 
cfun_cinfo_predicate_of_set__153_cfa_info(cfun_bglt obj_749, obj_t val1471_750)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 542 */
      return
	 ((((cfun_bglt) CREF(obj_749))->predicate_of_78) = ((obj_t) val1471_750), BUNSPEC);
   }
}



/* _cfun/cinfo-predicate-of-set!3106 */
obj_t 
_cfun_cinfo_predicate_of_set_3106_47_cfa_info(obj_t env_5970, obj_t obj_5971, obj_t val1471_5972)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 542 */
      return
	 cfun_cinfo_predicate_of_set__153_cfa_info(
	 (cfun_bglt) (obj_5971), val1471_5972);
   }
}



/* cfun/cinfo-predicate-of */
obj_t 
cfun_cinfo_predicate_of_78_cfa_info(cfun_bglt obj_751)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 542 */
      return
	 (((cfun_bglt) CREF(obj_751))->predicate_of_78);
   }
}



/* _cfun/cinfo-predicate-of3107 */
obj_t 
_cfun_cinfo_predicate_of3107_190_cfa_info(obj_t env_5973, obj_t obj_5974)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 542 */
      return
	 cfun_cinfo_predicate_of_78_cfa_info(
	 (cfun_bglt) (obj_5974));
   }
}



/* cfun/cinfo-stack-allocator-set! */
obj_t 
cfun_cinfo_stack_allocator_set__152_cfa_info(cfun_bglt obj_752, obj_t val1472_753)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 544 */
      return
	 ((((cfun_bglt) CREF(obj_752))->stack_allocator_172) = ((obj_t) val1472_753), BUNSPEC);
   }
}



/* _cfun/cinfo-stack-allocator-set!3108 */
obj_t 
_cfun_cinfo_stack_allocator_set_3108_157_cfa_info(obj_t env_5975, obj_t obj_5976, obj_t val1472_5977)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 544 */
      return
	 cfun_cinfo_stack_allocator_set__152_cfa_info(
	 (cfun_bglt) (obj_5976), val1472_5977);
   }
}



/* cfun/cinfo-stack-allocator */
obj_t 
cfun_cinfo_stack_allocator_172_cfa_info(cfun_bglt obj_754)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 544 */
      return
	 (((cfun_bglt) CREF(obj_754))->stack_allocator_172);
   }
}



/* _cfun/cinfo-stack-allocator3109 */
obj_t 
_cfun_cinfo_stack_allocator3109_230_cfa_info(obj_t env_5978, obj_t obj_5979)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 544 */
      return
	 cfun_cinfo_stack_allocator_172_cfa_info(
	 (cfun_bglt) (obj_5979));
   }
}



/* cfun/cinfo-top?-set! */
obj_t 
cfun_cinfo_top__set__172_cfa_info(cfun_bglt obj_755, bool_t val1473_756)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 546 */
      return
	 ((((cfun_bglt) CREF(obj_755))->top__138) = ((bool_t) val1473_756), BUNSPEC);
   }
}



/* _cfun/cinfo-top?-set!3110 */
obj_t 
_cfun_cinfo_top__set_3110_80_cfa_info(obj_t env_5980, obj_t obj_5981, obj_t val1473_5982)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 546 */
      return
	 cfun_cinfo_top__set__172_cfa_info(
	 (cfun_bglt) (obj_5981),
	 CBOOL(val1473_5982));
   }
}



/* cfun/cinfo-top? */
bool_t 
cfun_cinfo_top__138_cfa_info(cfun_bglt obj_757)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 546 */
      return
	 (((cfun_bglt) CREF(obj_757))->top__138);
   }
}



/* _cfun/cinfo-top?3111 */
obj_t 
_cfun_cinfo_top_3111_22_cfa_info(obj_t env_5983, obj_t obj_5984)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 546 */
      {		/* ./Ast/var.scm 546 */
	 bool_t aux_9112;
	 aux_9112 =
	    cfun_cinfo_top__138_cfa_info(
	    (cfun_bglt) (obj_5984));
	 return
	    BBOOL(aux_9112);
      }
   }
}



/* cfun/cinfo-the-closure-set! */
obj_t 
cfun_cinfo_the_closure_set__73_cfa_info(cfun_bglt obj_758, obj_t val1474_759)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 548 */
      return
	 ((((cfun_bglt) CREF(obj_758))->the_closure_238) = ((obj_t) val1474_759), BUNSPEC);
   }
}



/* _cfun/cinfo-the-closure-set!3112 */
obj_t 
_cfun_cinfo_the_closure_set_3112_43_cfa_info(obj_t env_5985, obj_t obj_5986, obj_t val1474_5987)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 548 */
      return
	 cfun_cinfo_the_closure_set__73_cfa_info(
	 (cfun_bglt) (obj_5986), val1474_5987);
   }
}



/* cfun/cinfo-the-closure */
obj_t 
cfun_cinfo_the_closure_238_cfa_info(cfun_bglt obj_760)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 548 */
      return
	 (((cfun_bglt) CREF(obj_760))->the_closure_238);
   }
}



/* _cfun/cinfo-the-closure3113 */
obj_t 
_cfun_cinfo_the_closure3113_240_cfa_info(obj_t env_5988, obj_t obj_5989)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 548 */
      return
	 cfun_cinfo_the_closure_238_cfa_info(
	 (cfun_bglt) (obj_5989));
   }
}



/* cfun/cinfo-args-type */
obj_t 
cfun_cinfo_args_type_205_cfa_info(cfun_bglt obj_761)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 573 */
      return
	 (((cfun_bglt) CREF(obj_761))->args_type_205);
   }
}



/* _cfun/cinfo-args-type3114 */
obj_t 
_cfun_cinfo_args_type3114_135_cfa_info(obj_t env_5990, obj_t obj_5991)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 573 */
      return
	 cfun_cinfo_args_type_205_cfa_info(
	 (cfun_bglt) (obj_5991));
   }
}



/* cfun/cinfo-macro? */
bool_t 
cfun_cinfo_macro__33_cfa_info(cfun_bglt obj_762)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 575 */
      return
	 (((cfun_bglt) CREF(obj_762))->macro__33);
   }
}



/* _cfun/cinfo-macro?3115 */
obj_t 
_cfun_cinfo_macro_3115_10_cfa_info(obj_t env_5992, obj_t obj_5993)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 575 */
      {		/* ./Ast/var.scm 575 */
	 bool_t aux_9126;
	 aux_9126 =
	    cfun_cinfo_macro__33_cfa_info(
	    (cfun_bglt) (obj_5993));
	 return
	    BBOOL(aux_9126);
      }
   }
}



/* cfun/cinfo-infix?-set! */
obj_t 
cfun_cinfo_infix__set__3_cfa_info(cfun_bglt obj_763, bool_t val1475_764)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 577 */
      return
	 ((((cfun_bglt) CREF(obj_763))->infix__163) = ((bool_t) val1475_764), BUNSPEC);
   }
}



/* _cfun/cinfo-infix?-set!3116 */
obj_t 
_cfun_cinfo_infix__set_3116_180_cfa_info(obj_t env_5994, obj_t obj_5995, obj_t val1475_5996)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 577 */
      return
	 cfun_cinfo_infix__set__3_cfa_info(
	 (cfun_bglt) (obj_5995),
	 CBOOL(val1475_5996));
   }
}



/* cfun/cinfo-infix? */
bool_t 
cfun_cinfo_infix__163_cfa_info(cfun_bglt obj_765)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 577 */
      return
	 (((cfun_bglt) CREF(obj_765))->infix__163);
   }
}



/* _cfun/cinfo-infix?3117 */
obj_t 
_cfun_cinfo_infix_3117_134_cfa_info(obj_t env_5997, obj_t obj_5998)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 577 */
      {		/* ./Ast/var.scm 577 */
	 bool_t aux_9135;
	 aux_9135 =
	    cfun_cinfo_infix__163_cfa_info(
	    (cfun_bglt) (obj_5998));
	 return
	    BBOOL(aux_9135);
      }
   }
}



/* cfun/cinfo-approx */
approx_bglt 
cfun_cinfo_approx_232_cfa_info(cfun_cinfo_200_bglt obj_766)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 39 */
      {
	 obj_t aux_9139;
	 {	/* Cfa/cinfo.scm 39 */
	    object_bglt aux_9140;
	    aux_9140 =
	       (object_bglt) (obj_766);
	    aux_9139 =
	       OBJECT_WIDENING(aux_9140);
	 }
	 return
	    (((cfun_cinfo_200_bglt) CREF(aux_9139))->approx);
      }
   }
}



/* _cfun/cinfo-approx3118 */
obj_t 
_cfun_cinfo_approx3118_58_cfa_info(obj_t env_5999, obj_t obj_6000)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 39 */
      {		/* Cfa/cinfo.scm 39 */
	 approx_bglt aux_9144;
	 aux_9144 =
	    cfun_cinfo_approx_232_cfa_info(
	    (cfun_cinfo_200_bglt) (obj_6000));
	 return
	    (obj_t) (aux_9144);
      }
   }
}



/* allocate-approx */
approx_bglt 
allocate_approx_85_cfa_info()
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 22 */
      {		/* Cfa/cinfo.scm 22 */
	 approx_bglt new1447_1897;
	 new1447_1897 =
	    ((approx_bglt) BREF(GC_MALLOC(sizeof(struct approx))));
	 {	/* Cfa/cinfo.scm 22 */
	    long arg2356_1898;
	    arg2356_1898 =
	       class_num_218___object(approx_cfa_info);
	    {	/* Cfa/cinfo.scm 22 */
	       obj_t obj_3775;
	       obj_3775 =
		  (obj_t) (new1447_1897);
	       (((obj_t) CREF(obj_3775))->header = MAKE_HEADER(arg2356_1898, 0), BUNSPEC);
	    }
	 }
	 {	/* Cfa/cinfo.scm 22 */
	    object_bglt aux_9152;
	    aux_9152 =
	       (object_bglt) (new1447_1897);
	    OBJECT_WIDENING_SET(aux_9152, BFALSE);
	 }
	 return new1447_1897;
      }
   }
}



/* _allocate-approx */
obj_t 
_allocate_approx_254_cfa_info(obj_t env_4896)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 22 */
      {		/* Cfa/cinfo.scm 22 */
	 approx_bglt aux_9155;
	 aux_9155 =
	    allocate_approx_85_cfa_info();
	 return
	    (obj_t) (aux_9155);
      }
   }
}



/* approx? */
bool_t 
approx__114_cfa_info(obj_t obj_770)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 22 */
      return
	 is_a__118___object(obj_770, approx_cfa_info);
   }
}



/* _approx? */
obj_t 
_approx__184_cfa_info(obj_t env_6001, obj_t obj_6002)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 22 */
      {		/* Cfa/cinfo.scm 22 */
	 bool_t aux_9159;
	 aux_9159 =
	    approx__114_cfa_info(obj_6002);
	 return
	    BBOOL(aux_9159);
      }
   }
}



/* make-approx */
approx_bglt 
make_approx_172_cfa_info(type_bglt type_771, bool_t type_locked__184_772, obj_t allocs_773, bool_t top__138_774, long lost_stamp_114_775)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 22 */
      {		/* Cfa/cinfo.scm 22 */
	 approx_bglt new1440_3777;
	 new1440_3777 =
	    ((approx_bglt) BREF(GC_MALLOC(sizeof(struct approx))));
	 {	/* Cfa/cinfo.scm 22 */
	    long arg2357_3778;
	    arg2357_3778 =
	       class_num_218___object(approx_cfa_info);
	    {	/* Cfa/cinfo.scm 22 */
	       obj_t obj_3784;
	       obj_3784 =
		  (obj_t) (new1440_3777);
	       (((obj_t) CREF(obj_3784))->header = MAKE_HEADER(arg2357_3778, 0), BUNSPEC);
	    }
	 }
	 {	/* Cfa/cinfo.scm 22 */
	    object_bglt aux_9166;
	    aux_9166 =
	       (object_bglt) (new1440_3777);
	    OBJECT_WIDENING_SET(aux_9166, BFALSE);
	 }
	 ((((approx_bglt) CREF(new1440_3777))->type) = ((type_bglt) type_771), BUNSPEC);
	 ((((approx_bglt) CREF(new1440_3777))->type_locked__184) = ((bool_t) type_locked__184_772), BUNSPEC);
	 ((((approx_bglt) CREF(new1440_3777))->allocs) = ((obj_t) allocs_773), BUNSPEC);
	 ((((approx_bglt) CREF(new1440_3777))->top__138) = ((bool_t) top__138_774), BUNSPEC);
	 ((((approx_bglt) CREF(new1440_3777))->lost_stamp_114) = ((long) lost_stamp_114_775), BUNSPEC);
	 return new1440_3777;
      }
   }
}



/* _make-approx3119 */
obj_t 
_make_approx3119_236_cfa_info(obj_t env_6003, obj_t type_6004, obj_t type_locked__184_6005, obj_t allocs_6006, obj_t top__138_6007, obj_t lost_stamp_114_6008)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 22 */
      {		/* Cfa/cinfo.scm 22 */
	 approx_bglt aux_9174;
	 aux_9174 =
	    make_approx_172_cfa_info(
	    (type_bglt) (type_6004),
	    CBOOL(type_locked__184_6005), allocs_6006,
	    CBOOL(top__138_6007),
	    (long) CINT(lost_stamp_114_6008));
	 return
	    (obj_t) (aux_9174);
      }
   }
}



/* approx-type-set! */
obj_t 
approx_type_set__202_cfa_info(approx_bglt obj_776, type_bglt val1437_777)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 26 */
      return
	 ((((approx_bglt) CREF(obj_776))->type) = ((type_bglt) val1437_777), BUNSPEC);
   }
}



/* _approx-type-set!3120 */
obj_t 
_approx_type_set_3120_213_cfa_info(obj_t env_6009, obj_t obj_6010, obj_t val1437_6011)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 26 */
      return
	 approx_type_set__202_cfa_info(
	 (approx_bglt) (obj_6010),
	 (type_bglt) (val1437_6011));
   }
}



/* approx-type */
type_bglt 
approx_type_27_cfa_info(approx_bglt obj_778)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 26 */
      return
	 (((approx_bglt) CREF(obj_778))->type);
   }
}



/* _approx-type3121 */
obj_t 
_approx_type3121_83_cfa_info(obj_t env_6012, obj_t obj_6013)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 26 */
      {		/* Cfa/cinfo.scm 26 */
	 type_bglt aux_9186;
	 aux_9186 =
	    approx_type_27_cfa_info(
	    (approx_bglt) (obj_6013));
	 return
	    (obj_t) (aux_9186);
      }
   }
}



/* approx-type-locked? */
bool_t 
approx_type_locked__124_cfa_info(approx_bglt obj_779)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 30 */
      return
	 (((approx_bglt) CREF(obj_779))->type_locked__184);
   }
}



/* _approx-type-locked?3122 */
obj_t 
_approx_type_locked_3122_59_cfa_info(obj_t env_6014, obj_t obj_6015)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 30 */
      {		/* Cfa/cinfo.scm 30 */
	 bool_t aux_9191;
	 aux_9191 =
	    approx_type_locked__124_cfa_info(
	    (approx_bglt) (obj_6015));
	 return
	    BBOOL(aux_9191);
      }
   }
}



/* approx-allocs */
obj_t 
approx_allocs_203_cfa_info(approx_bglt obj_780)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 32 */
      return
	 (((approx_bglt) CREF(obj_780))->allocs);
   }
}



/* _approx-allocs3123 */
obj_t 
_approx_allocs3123_186_cfa_info(obj_t env_6016, obj_t obj_6017)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 32 */
      return
	 approx_allocs_203_cfa_info(
	 (approx_bglt) (obj_6017));
   }
}



/* approx-top?-set! */
obj_t 
approx_top__set__151_cfa_info(approx_bglt obj_781, bool_t val1438_782)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 34 */
      return
	 ((((approx_bglt) CREF(obj_781))->top__138) = ((bool_t) val1438_782), BUNSPEC);
   }
}



/* _approx-top?-set!3124 */
obj_t 
_approx_top__set_3124_85_cfa_info(obj_t env_6018, obj_t obj_6019, obj_t val1438_6020)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 34 */
      return
	 approx_top__set__151_cfa_info(
	 (approx_bglt) (obj_6019),
	 CBOOL(val1438_6020));
   }
}



/* approx-top? */
bool_t 
approx_top__34_cfa_info(approx_bglt obj_783)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 34 */
      return
	 (((approx_bglt) CREF(obj_783))->top__138);
   }
}



/* _approx-top?3125 */
obj_t 
_approx_top_3125_24_cfa_info(obj_t env_6021, obj_t obj_6022)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 34 */
      {		/* Cfa/cinfo.scm 34 */
	 bool_t aux_9203;
	 aux_9203 =
	    approx_top__34_cfa_info(
	    (approx_bglt) (obj_6022));
	 return
	    BBOOL(aux_9203);
      }
   }
}



/* approx-lost-stamp-set! */
obj_t 
approx_lost_stamp_set__114_cfa_info(approx_bglt obj_784, long val1439_785)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 36 */
      return
	 ((((approx_bglt) CREF(obj_784))->lost_stamp_114) = ((long) val1439_785), BUNSPEC);
   }
}



/* _approx-lost-stamp-set!3126 */
obj_t 
_approx_lost_stamp_set_3126_117_cfa_info(obj_t env_6023, obj_t obj_6024, obj_t val1439_6025)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 36 */
      return
	 approx_lost_stamp_set__114_cfa_info(
	 (approx_bglt) (obj_6024),
	 (long) CINT(val1439_6025));
   }
}



/* approx-lost-stamp */
long 
approx_lost_stamp_29_cfa_info(approx_bglt obj_786)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 36 */
      return
	 (((approx_bglt) CREF(obj_786))->lost_stamp_114);
   }
}



/* _approx-lost-stamp3127 */
obj_t 
_approx_lost_stamp3127_243_cfa_info(obj_t env_6026, obj_t obj_6027)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 36 */
      {		/* Cfa/cinfo.scm 36 */
	 long aux_9212;
	 aux_9212 =
	    approx_lost_stamp_29_cfa_info(
	    (approx_bglt) (obj_6027));
	 return
	    BINT(aux_9212);
      }
   }
}



/* method-init */
obj_t 
method_init_76_cfa_info()
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 14 */
      {		/* Cfa/cinfo.scm 14 */
	 obj_t object__struct_box_ref_o_cinfo1978_69_6092;
	 object__struct_box_ref_o_cinfo1978_69_6092 = proc3131_cfa_info;
	 add_method__1___object(object__struct_env_210___object, box_ref_o_cinfo_98_cfa_info, object__struct_box_ref_o_cinfo1978_69_6092);
      }
      {		/* Cfa/cinfo.scm 14 */
	 obj_t struct_object__object_box_ref_o_cinfo1980_207_6091;
	 struct_object__object_box_ref_o_cinfo1980_207_6091 = proc3132_cfa_info;
	 add_method__1___object(struct_object__object_env_209___object, box_ref_o_cinfo_98_cfa_info, struct_object__object_box_ref_o_cinfo1980_207_6091);
      }
      {		/* Cfa/cinfo.scm 14 */
	 obj_t object__struct_box_set__o_cinfo1982_221_6090;
	 object__struct_box_set__o_cinfo1982_221_6090 = proc3133_cfa_info;
	 add_method__1___object(object__struct_env_210___object, box_set__o_cinfo_6_cfa_info, object__struct_box_set__o_cinfo1982_221_6090);
      }
      {		/* Cfa/cinfo.scm 14 */
	 obj_t struct_object__object_box_set__o_cinfo1984_135_6089;
	 struct_object__object_box_set__o_cinfo1984_135_6089 = proc3134_cfa_info;
	 add_method__1___object(struct_object__object_env_209___object, box_set__o_cinfo_6_cfa_info, struct_object__object_box_set__o_cinfo1984_135_6089);
      }
      {		/* Cfa/cinfo.scm 14 */
	 obj_t object__struct_box_ref_cinfo1986_188_6088;
	 object__struct_box_ref_cinfo1986_188_6088 = proc3135_cfa_info;
	 add_method__1___object(object__struct_env_210___object, box_ref_cinfo_214_cfa_info, object__struct_box_ref_cinfo1986_188_6088);
      }
      {		/* Cfa/cinfo.scm 14 */
	 obj_t struct_object__object_box_ref_cinfo1988_119_6087;
	 struct_object__object_box_ref_cinfo1988_119_6087 = proc3136_cfa_info;
	 add_method__1___object(struct_object__object_env_209___object, box_ref_cinfo_214_cfa_info, struct_object__object_box_ref_cinfo1988_119_6087);
      }
      {		/* Cfa/cinfo.scm 14 */
	 obj_t object__struct_box_set__cinfo1990_126_6086;
	 object__struct_box_set__cinfo1990_126_6086 = proc3137_cfa_info;
	 add_method__1___object(object__struct_env_210___object, box_set__cinfo_94_cfa_info, object__struct_box_set__cinfo1990_126_6086);
      }
      {		/* Cfa/cinfo.scm 14 */
	 obj_t struct_object__object_box_set__cinfo1992_103_6085;
	 struct_object__object_box_set__cinfo1992_103_6085 = proc3138_cfa_info;
	 add_method__1___object(struct_object__object_env_209___object, box_set__cinfo_94_cfa_info, struct_object__object_box_set__cinfo1992_103_6085);
      }
      {		/* Cfa/cinfo.scm 14 */
	 obj_t object__struct_make_box_o_cinfo1994_50_6084;
	 object__struct_make_box_o_cinfo1994_50_6084 = proc3139_cfa_info;
	 add_method__1___object(object__struct_env_210___object, make_box_o_cinfo_96_cfa_info, object__struct_make_box_o_cinfo1994_50_6084);
      }
      {		/* Cfa/cinfo.scm 14 */
	 obj_t struct_object__object_make_box_o_cinfo1996_29_6083;
	 struct_object__object_make_box_o_cinfo1996_29_6083 = proc3140_cfa_info;
	 add_method__1___object(struct_object__object_env_209___object, make_box_o_cinfo_96_cfa_info, struct_object__object_make_box_o_cinfo1996_29_6083);
      }
      {		/* Cfa/cinfo.scm 14 */
	 obj_t object__struct_make_box_cinfo1998_55_6082;
	 object__struct_make_box_cinfo1998_55_6082 = proc3141_cfa_info;
	 add_method__1___object(object__struct_env_210___object, make_box_cinfo_127_cfa_info, object__struct_make_box_cinfo1998_55_6082);
      }
      {		/* Cfa/cinfo.scm 14 */
	 obj_t struct_object__object_make_box_cinfo2000_189_6081;
	 struct_object__object_make_box_cinfo2000_189_6081 = proc3142_cfa_info;
	 add_method__1___object(struct_object__object_env_209___object, make_box_cinfo_127_cfa_info, struct_object__object_make_box_cinfo2000_189_6081);
      }
      {		/* Cfa/cinfo.scm 14 */
	 obj_t object__struct_pre_make_box2002_179_6080;
	 object__struct_pre_make_box2002_179_6080 = proc3143_cfa_info;
	 add_method__1___object(object__struct_env_210___object, pre_make_box_186_cfa_info, object__struct_pre_make_box2002_179_6080);
      }
      {		/* Cfa/cinfo.scm 14 */
	 obj_t struct_object__object_pre_make_box2004_221_6079;
	 struct_object__object_pre_make_box2004_221_6079 = proc3144_cfa_info;
	 add_method__1___object(struct_object__object_env_209___object, pre_make_box_186_cfa_info, struct_object__object_pre_make_box2004_221_6079);
      }
      {		/* Cfa/cinfo.scm 14 */
	 obj_t object__struct_jump_ex_it_cinfo2006_111_6078;
	 object__struct_jump_ex_it_cinfo2006_111_6078 = proc3145_cfa_info;
	 add_method__1___object(object__struct_env_210___object, jump_ex_it_cinfo_139_cfa_info, object__struct_jump_ex_it_cinfo2006_111_6078);
      }
      {		/* Cfa/cinfo.scm 14 */
	 obj_t struct_object__object_jump_ex_it_cinfo2008_72_6077;
	 struct_object__object_jump_ex_it_cinfo2008_72_6077 = proc3146_cfa_info;
	 add_method__1___object(struct_object__object_env_209___object, jump_ex_it_cinfo_139_cfa_info, struct_object__object_jump_ex_it_cinfo2008_72_6077);
      }
      {		/* Cfa/cinfo.scm 14 */
	 obj_t object__struct_set_ex_it_cinfo2010_16_6076;
	 object__struct_set_ex_it_cinfo2010_16_6076 = proc3147_cfa_info;
	 add_method__1___object(object__struct_env_210___object, set_ex_it_cinfo_168_cfa_info, object__struct_set_ex_it_cinfo2010_16_6076);
      }
      {		/* Cfa/cinfo.scm 14 */
	 obj_t struct_object__object_set_ex_it_cinfo2012_163_6075;
	 struct_object__object_set_ex_it_cinfo2012_163_6075 = proc3148_cfa_info;
	 add_method__1___object(struct_object__object_env_209___object, set_ex_it_cinfo_168_cfa_info, struct_object__object_set_ex_it_cinfo2012_163_6075);
      }
      {		/* Cfa/cinfo.scm 14 */
	 obj_t object__struct_select_cinfo2014_57_6074;
	 object__struct_select_cinfo2014_57_6074 = proc3149_cfa_info;
	 add_method__1___object(object__struct_env_210___object, select_cinfo_150_cfa_info, object__struct_select_cinfo2014_57_6074);
      }
      {		/* Cfa/cinfo.scm 14 */
	 obj_t struct_object__object_select_cinfo2016_231_6073;
	 struct_object__object_select_cinfo2016_231_6073 = proc3150_cfa_info;
	 add_method__1___object(struct_object__object_env_209___object, select_cinfo_150_cfa_info, struct_object__object_select_cinfo2016_231_6073);
      }
      {		/* Cfa/cinfo.scm 14 */
	 obj_t object__struct_fail_cinfo2018_129_6072;
	 object__struct_fail_cinfo2018_129_6072 = proc3151_cfa_info;
	 add_method__1___object(object__struct_env_210___object, fail_cinfo_75_cfa_info, object__struct_fail_cinfo2018_129_6072);
      }
      {		/* Cfa/cinfo.scm 14 */
	 obj_t struct_object__object_fail_cinfo2020_217_6071;
	 struct_object__object_fail_cinfo2020_217_6071 = proc3152_cfa_info;
	 add_method__1___object(struct_object__object_env_209___object, fail_cinfo_75_cfa_info, struct_object__object_fail_cinfo2020_217_6071);
      }
      {		/* Cfa/cinfo.scm 14 */
	 obj_t object__struct_conditional_cinfo2022_5_6070;
	 object__struct_conditional_cinfo2022_5_6070 = proc3153_cfa_info;
	 add_method__1___object(object__struct_env_210___object, conditional_cinfo_212_cfa_info, object__struct_conditional_cinfo2022_5_6070);
      }
      {		/* Cfa/cinfo.scm 14 */
	 obj_t struct_object__object_conditional_cinfo2024_17_6069;
	 struct_object__object_conditional_cinfo2024_17_6069 = proc3154_cfa_info;
	 add_method__1___object(struct_object__object_env_209___object, conditional_cinfo_212_cfa_info, struct_object__object_conditional_cinfo2024_17_6069);
      }
      {		/* Cfa/cinfo.scm 14 */
	 obj_t object__struct_setq_cinfo2026_53_6068;
	 object__struct_setq_cinfo2026_53_6068 = proc3155_cfa_info;
	 add_method__1___object(object__struct_env_210___object, setq_cinfo_191_cfa_info, object__struct_setq_cinfo2026_53_6068);
      }
      {		/* Cfa/cinfo.scm 14 */
	 obj_t struct_object__object_setq_cinfo2028_8_6067;
	 struct_object__object_setq_cinfo2028_8_6067 = proc3156_cfa_info;
	 add_method__1___object(struct_object__object_env_209___object, setq_cinfo_191_cfa_info, struct_object__object_setq_cinfo2028_8_6067);
      }
      {		/* Cfa/cinfo.scm 14 */
	 obj_t object__struct_pragma_cinfo2030_152_6066;
	 object__struct_pragma_cinfo2030_152_6066 = proc3157_cfa_info;
	 add_method__1___object(object__struct_env_210___object, pragma_cinfo_220_cfa_info, object__struct_pragma_cinfo2030_152_6066);
      }
      {		/* Cfa/cinfo.scm 14 */
	 obj_t struct_object__object_pragma_cinfo2032_204_6065;
	 struct_object__object_pragma_cinfo2032_204_6065 = proc3158_cfa_info;
	 add_method__1___object(struct_object__object_env_209___object, pragma_cinfo_220_cfa_info, struct_object__object_pragma_cinfo2032_204_6065);
      }
      {		/* Cfa/cinfo.scm 14 */
	 obj_t object__struct_funcall_cinfo2034_224_6064;
	 object__struct_funcall_cinfo2034_224_6064 = proc3159_cfa_info;
	 add_method__1___object(object__struct_env_210___object, funcall_cinfo_75_cfa_info, object__struct_funcall_cinfo2034_224_6064);
      }
      {		/* Cfa/cinfo.scm 14 */
	 obj_t struct_object__object_funcall_cinfo2036_168_6063;
	 struct_object__object_funcall_cinfo2036_168_6063 = proc3160_cfa_info;
	 add_method__1___object(struct_object__object_env_209___object, funcall_cinfo_75_cfa_info, struct_object__object_funcall_cinfo2036_168_6063);
      }
      {		/* Cfa/cinfo.scm 14 */
	 obj_t object__struct_app_ly_cinfo2038_18_6062;
	 object__struct_app_ly_cinfo2038_18_6062 = proc3161_cfa_info;
	 add_method__1___object(object__struct_env_210___object, app_ly_cinfo_234_cfa_info, object__struct_app_ly_cinfo2038_18_6062);
      }
      {		/* Cfa/cinfo.scm 14 */
	 obj_t struct_object__object_app_ly_cinfo2040_212_6061;
	 struct_object__object_app_ly_cinfo2040_212_6061 = proc3162_cfa_info;
	 add_method__1___object(struct_object__object_env_209___object, app_ly_cinfo_234_cfa_info, struct_object__object_app_ly_cinfo2040_212_6061);
      }
      {		/* Cfa/cinfo.scm 14 */
	 obj_t object__struct_kwote_cinfo2042_186_6060;
	 object__struct_kwote_cinfo2042_186_6060 = proc3163_cfa_info;
	 add_method__1___object(object__struct_env_210___object, kwote_cinfo_48_cfa_info, object__struct_kwote_cinfo2042_186_6060);
      }
      {		/* Cfa/cinfo.scm 14 */
	 obj_t struct_object__object_kwote_cinfo2044_93_6059;
	 struct_object__object_kwote_cinfo2044_93_6059 = proc3164_cfa_info;
	 add_method__1___object(struct_object__object_env_209___object, kwote_cinfo_48_cfa_info, struct_object__object_kwote_cinfo2044_93_6059);
      }
      {		/* Cfa/cinfo.scm 14 */
	 obj_t object__struct_kwote_node2046_198_6058;
	 object__struct_kwote_node2046_198_6058 = proc3165_cfa_info;
	 add_method__1___object(object__struct_env_210___object, kwote_node_102_cfa_info, object__struct_kwote_node2046_198_6058);
      }
      {		/* Cfa/cinfo.scm 14 */
	 obj_t struct_object__object_kwote_node2048_129_6057;
	 struct_object__object_kwote_node2048_129_6057 = proc3166_cfa_info;
	 add_method__1___object(struct_object__object_env_209___object, kwote_node_102_cfa_info, struct_object__object_kwote_node2048_129_6057);
      }
      {		/* Cfa/cinfo.scm 14 */
	 obj_t object__struct_atom_cinfo2050_53_6056;
	 object__struct_atom_cinfo2050_53_6056 = proc3167_cfa_info;
	 add_method__1___object(object__struct_env_210___object, atom_cinfo_155_cfa_info, object__struct_atom_cinfo2050_53_6056);
      }
      {		/* Cfa/cinfo.scm 14 */
	 obj_t struct_object__object_atom_cinfo2052_76_6055;
	 struct_object__object_atom_cinfo2052_76_6055 = proc3168_cfa_info;
	 add_method__1___object(struct_object__object_env_209___object, atom_cinfo_155_cfa_info, struct_object__object_atom_cinfo2052_76_6055);
      }
      {		/* Cfa/cinfo.scm 14 */
	 obj_t object__struct_reshaped_global2054_140_6054;
	 object__struct_reshaped_global2054_140_6054 = proc3169_cfa_info;
	 add_method__1___object(object__struct_env_210___object, reshaped_global_160_cfa_info, object__struct_reshaped_global2054_140_6054);
      }
      {		/* Cfa/cinfo.scm 14 */
	 obj_t struct_object__object_reshaped_global2056_155_6053;
	 struct_object__object_reshaped_global2056_155_6053 = proc3170_cfa_info;
	 add_method__1___object(struct_object__object_env_209___object, reshaped_global_160_cfa_info, struct_object__object_reshaped_global2056_155_6053);
      }
      {		/* Cfa/cinfo.scm 14 */
	 obj_t object__struct_reshaped_local2058_214_6052;
	 object__struct_reshaped_local2058_214_6052 = proc3171_cfa_info;
	 add_method__1___object(object__struct_env_210___object, reshaped_local_224_cfa_info, object__struct_reshaped_local2058_214_6052);
      }
      {		/* Cfa/cinfo.scm 14 */
	 obj_t struct_object__object_reshaped_local2060_138_6051;
	 struct_object__object_reshaped_local2060_138_6051 = proc3172_cfa_info;
	 add_method__1___object(struct_object__object_env_209___object, reshaped_local_224_cfa_info, struct_object__object_reshaped_local2060_138_6051);
      }
      {		/* Cfa/cinfo.scm 14 */
	 obj_t object__struct_sexit_cinfo2062_20_6050;
	 object__struct_sexit_cinfo2062_20_6050 = proc3173_cfa_info;
	 add_method__1___object(object__struct_env_210___object, sexit_cinfo_49_cfa_info, object__struct_sexit_cinfo2062_20_6050);
      }
      {		/* Cfa/cinfo.scm 14 */
	 obj_t struct_object__object_sexit_cinfo2064_242_6049;
	 struct_object__object_sexit_cinfo2064_242_6049 = proc3174_cfa_info;
	 add_method__1___object(struct_object__object_env_209___object, sexit_cinfo_49_cfa_info, struct_object__object_sexit_cinfo2064_242_6049);
      }
      {		/* Cfa/cinfo.scm 14 */
	 obj_t object__struct_cvar_cinfo2066_213_6048;
	 object__struct_cvar_cinfo2066_213_6048 = proc3175_cfa_info;
	 add_method__1___object(object__struct_env_210___object, cvar_cinfo_53_cfa_info, object__struct_cvar_cinfo2066_213_6048);
      }
      {		/* Cfa/cinfo.scm 14 */
	 obj_t struct_object__object_cvar_cinfo2068_13_6047;
	 struct_object__object_cvar_cinfo2068_13_6047 = proc3176_cfa_info;
	 add_method__1___object(struct_object__object_env_209___object, cvar_cinfo_53_cfa_info, struct_object__object_cvar_cinfo2068_13_6047);
      }
      {		/* Cfa/cinfo.scm 14 */
	 obj_t object__struct_svar_cinfo2070_189_6046;
	 object__struct_svar_cinfo2070_189_6046 = proc3177_cfa_info;
	 add_method__1___object(object__struct_env_210___object, svar_cinfo_166_cfa_info, object__struct_svar_cinfo2070_189_6046);
      }
      {		/* Cfa/cinfo.scm 14 */
	 obj_t struct_object__object_svar_cinfo2072_159_6045;
	 struct_object__object_svar_cinfo2072_159_6045 = proc3178_cfa_info;
	 add_method__1___object(struct_object__object_env_209___object, svar_cinfo_166_cfa_info, struct_object__object_svar_cinfo2072_159_6045);
      }
      {		/* Cfa/cinfo.scm 14 */
	 obj_t object__struct_pre_clo_env2074_162_6044;
	 object__struct_pre_clo_env2074_162_6044 = proc3179_cfa_info;
	 add_method__1___object(object__struct_env_210___object, pre_clo_env_191_cfa_info, object__struct_pre_clo_env2074_162_6044);
      }
      {		/* Cfa/cinfo.scm 14 */
	 obj_t struct_object__object_pre_clo_env2076_139_6043;
	 struct_object__object_pre_clo_env2076_139_6043 = proc3180_cfa_info;
	 add_method__1___object(struct_object__object_env_209___object, pre_clo_env_191_cfa_info, struct_object__object_pre_clo_env2076_139_6043);
      }
      {		/* Cfa/cinfo.scm 14 */
	 obj_t object__struct_scnst_cinfo2078_132_6042;
	 object__struct_scnst_cinfo2078_132_6042 = proc3181_cfa_info;
	 add_method__1___object(object__struct_env_210___object, scnst_cinfo_0_cfa_info, object__struct_scnst_cinfo2078_132_6042);
      }
      {		/* Cfa/cinfo.scm 14 */
	 obj_t struct_object__object_scnst_cinfo2080_231_6041;
	 struct_object__object_scnst_cinfo2080_231_6041 = proc3182_cfa_info;
	 add_method__1___object(struct_object__object_env_209___object, scnst_cinfo_0_cfa_info, struct_object__object_scnst_cinfo2080_231_6041);
      }
      {		/* Cfa/cinfo.scm 14 */
	 obj_t object__struct_intern_sfun_cinfo2082_117_6040;
	 object__struct_intern_sfun_cinfo2082_117_6040 = proc3183_cfa_info;
	 add_method__1___object(object__struct_env_210___object, intern_sfun_cinfo_192_cfa_info, object__struct_intern_sfun_cinfo2082_117_6040);
      }
      {		/* Cfa/cinfo.scm 14 */
	 obj_t struct_object__object_intern_sfun_cinfo2084_8_6039;
	 struct_object__object_intern_sfun_cinfo2084_8_6039 = proc3184_cfa_info;
	 add_method__1___object(struct_object__object_env_209___object, intern_sfun_cinfo_192_cfa_info, struct_object__object_intern_sfun_cinfo2084_8_6039);
      }
      {		/* Cfa/cinfo.scm 14 */
	 obj_t object__struct_extern_sfun_cinfo2086_160_6038;
	 object__struct_extern_sfun_cinfo2086_160_6038 = proc3185_cfa_info;
	 add_method__1___object(object__struct_env_210___object, extern_sfun_cinfo_6_cfa_info, object__struct_extern_sfun_cinfo2086_160_6038);
      }
      {		/* Cfa/cinfo.scm 14 */
	 obj_t struct_object__object_extern_sfun_cinfo2088_95_6037;
	 struct_object__object_extern_sfun_cinfo2088_95_6037 = proc3186_cfa_info;
	 add_method__1___object(struct_object__object_env_209___object, extern_sfun_cinfo_6_cfa_info, struct_object__object_extern_sfun_cinfo2088_95_6037);
      }
      {		/* Cfa/cinfo.scm 14 */
	 obj_t object__struct_cfun_cinfo2090_55_6034;
	 object__struct_cfun_cinfo2090_55_6034 = proc3187_cfa_info;
	 add_method__1___object(object__struct_env_210___object, cfun_cinfo_200_cfa_info, object__struct_cfun_cinfo2090_55_6034);
      }
      {		/* Cfa/cinfo.scm 14 */
	 obj_t struct_object__object_cfun_cinfo2092_190_6030;
	 struct_object__object_cfun_cinfo2092_190_6030 = proc3188_cfa_info;
	 add_method__1___object(struct_object__object_env_209___object, cfun_cinfo_200_cfa_info, struct_object__object_cfun_cinfo2092_190_6030);
      }
      {		/* Cfa/cinfo.scm 14 */
	 obj_t object__struct_approx2094_141_6029;
	 object__struct_approx2094_141_6029 = proc3189_cfa_info;
	 add_method__1___object(object__struct_env_210___object, approx_cfa_info, object__struct_approx2094_141_6029);
      }
      {		/* Cfa/cinfo.scm 14 */
	 obj_t struct_object__object_approx2096_124_6028;
	 struct_object__object_approx2096_124_6028 = proc3190_cfa_info;
	 return
	    add_method__1___object(struct_object__object_env_209___object, approx_cfa_info, struct_object__object_approx2096_124_6028);
      }
   }
}



/* struct+object->object-approx2096 */
obj_t 
struct_object__object_approx2096_124_cfa_info(obj_t env_6093, obj_t o_6094, obj_t s_6095)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 22 */
      {
	 approx_bglt o_2895;
	 obj_t s_2896;
	 {	/* Cfa/cinfo.scm 22 */
	    approx_bglt aux_9276;
	    o_2895 =
	       (approx_bglt) (o_6094);
	    s_2896 = s_6095;
	    {	/* Cfa/cinfo.scm 22 */
	       obj_t aux_9279;
	       object_bglt aux_9277;
	       aux_9279 =
		  STRUCT_REF(s_2896, ((long) 0));
	       aux_9277 =
		  (object_bglt) (o_2895);
	       OBJECT_WIDENING_SET(aux_9277, aux_9279);
	    }
	    {	/* Cfa/cinfo.scm 22 */
	       type_bglt v1452_2900;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_9282;
		  aux_9282 =
		     STRUCT_REF(s_2896, ((long) 1));
		  v1452_2900 =
		     (type_bglt) (aux_9282);
	       }
	       ((((approx_bglt) CREF(o_2895))->type) = ((type_bglt) v1452_2900), BUNSPEC);
	    }
	    {	/* Cfa/cinfo.scm 22 */
	       bool_t v1456_2901;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_9286;
		  aux_9286 =
		     STRUCT_REF(s_2896, ((long) 2));
		  v1456_2901 =
		     CBOOL(aux_9286);
	       }
	       ((((approx_bglt) CREF(o_2895))->type_locked__184) = ((bool_t) v1456_2901), BUNSPEC);
	    }
	    {	/* Cfa/cinfo.scm 22 */
	       obj_t v1460_2902;
	       v1460_2902 =
		  STRUCT_REF(s_2896, ((long) 3));
	       ((((approx_bglt) CREF(o_2895))->allocs) = ((obj_t) v1460_2902), BUNSPEC);
	    }
	    {	/* Cfa/cinfo.scm 22 */
	       bool_t v1464_2903;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_9292;
		  aux_9292 =
		     STRUCT_REF(s_2896, ((long) 4));
		  v1464_2903 =
		     CBOOL(aux_9292);
	       }
	       ((((approx_bglt) CREF(o_2895))->top__138) = ((bool_t) v1464_2903), BUNSPEC);
	    }
	    {	/* Cfa/cinfo.scm 22 */
	       long v1468_2904;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_9296;
		  aux_9296 =
		     STRUCT_REF(s_2896, ((long) 5));
		  v1468_2904 =
		     (long) CINT(aux_9296);
	       }
	       ((((approx_bglt) CREF(o_2895))->lost_stamp_114) = ((long) v1468_2904), BUNSPEC);
	    }
	    aux_9276 = o_2895;
	    return
	       (obj_t) (aux_9276);
	 }
      }
   }
}



/* object->struct-approx2094 */
obj_t 
object__struct_approx2094_141_cfa_info(obj_t env_6096, obj_t obj1448_6097)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 22 */
      {
	 approx_bglt obj1448_2879;
	 obj1448_2879 =
	    (approx_bglt) (obj1448_6097);
	 {	/* Cfa/cinfo.scm 22 */
	    obj_t res1449_2882;
	    {	/* ./Llib/struct.scm 1415 */
	       obj_t aux_9302;
	       aux_9302 =
		  CNST_TABLE_REF(((long) 0));
	       res1449_2882 =
		  make_struct(aux_9302, ((long) 6), BUNSPEC);
	    }
	    STRUCT_SET(res1449_2882, ((long) 0), BFALSE);
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_9306;
	       {	/* Cfa/cinfo.scm 22 */
		  type_bglt aux_9307;
		  aux_9307 =
		     (((approx_bglt) CREF(obj1448_2879))->type);
		  aux_9306 =
		     (obj_t) (aux_9307);
	       }
	       STRUCT_SET(res1449_2882, ((long) 1), aux_9306);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_9311;
	       {	/* Cfa/cinfo.scm 22 */
		  bool_t aux_9312;
		  aux_9312 =
		     (((approx_bglt) CREF(obj1448_2879))->type_locked__184);
		  aux_9311 =
		     BBOOL(aux_9312);
	       }
	       STRUCT_SET(res1449_2882, ((long) 2), aux_9311);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_9316;
	       aux_9316 =
		  (((approx_bglt) CREF(obj1448_2879))->allocs);
	       STRUCT_SET(res1449_2882, ((long) 3), aux_9316);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_9319;
	       {	/* Cfa/cinfo.scm 22 */
		  bool_t aux_9320;
		  aux_9320 =
		     (((approx_bglt) CREF(obj1448_2879))->top__138);
		  aux_9319 =
		     BBOOL(aux_9320);
	       }
	       STRUCT_SET(res1449_2882, ((long) 4), aux_9319);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_9324;
	       {	/* Cfa/cinfo.scm 22 */
		  long aux_9325;
		  aux_9325 =
		     (((approx_bglt) CREF(obj1448_2879))->lost_stamp_114);
		  aux_9324 =
		     BINT(aux_9325);
	       }
	       STRUCT_SET(res1449_2882, ((long) 5), aux_9324);
	    }
	    return res1449_2882;
	 }
      }
   }
}



/* struct+object->object-cfun/cinfo2092 */
obj_t 
struct_object__object_cfun_cinfo2092_190_cfa_info(obj_t env_6098, obj_t o_6099, obj_t s_6100)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 39 */
      {
	 cfun_cinfo_200_bglt o_2867;
	 obj_t s_2868;
	 {	/* Cfa/cinfo.scm 39 */
	    cfun_cinfo_200_bglt aux_9330;
	    o_2867 =
	       (cfun_cinfo_200_bglt) (o_6099);
	    s_2868 = s_6100;
	    {

	       {	/* Cfa/cinfo.scm 39 */
		  obj_t old1486_2871;
		  obj_t aux1487_2872;
		  {	/* Cfa/cinfo.scm 39 */
		     obj_t next_method2091_5_2877;
		     next_method2091_5_2877 =
			find_super_class_method_167___object(
			(object_bglt) (o_2867), struct_object__object_env_209___object, cfun_cinfo_200_cfa_info);
		     if (
			PROCEDUREP(next_method2091_5_2877))
		       {	/* Cfa/cinfo.scm 39 */
			  old1486_2871 =
			     PROCEDURE_ENTRY(next_method2091_5_2877) (next_method2091_5_2877,
			     (obj_t) (o_2867), s_2868, BEOA);
		       }
		     else
		       {	/* Cfa/cinfo.scm 39 */
			  PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2091_5_2877);
			  {	/* Cfa/cinfo.scm 39 */
			     object_bglt aux_9339;
			     aux_9339 =
				struct_object__object_93___object(
				(object_bglt) (o_2867), s_2868);
			     old1486_2871 =
				(obj_t) (aux_9339);
			  }
		       }
		  }
		  aux1487_2872 =
		     STRUCT_REF(s_2868, ((long) 0));
		  {	/* Cfa/cinfo.scm 39 */
		     cfun_cinfo_200_bglt new1488_2873;
		     new1488_2873 =
			((cfun_cinfo_200_bglt) (old1486_2871));
		     {	/* Cfa/cinfo.scm 39 */
			long arg2666_2874;
			arg2666_2874 =
			   class_num_218___object(cfun_cinfo_200_cfa_info);
			{	/* Cfa/cinfo.scm 39 */
			   obj_t obj_4848;
			   obj_4848 =
			      (obj_t) (new1488_2873);
			   (((obj_t) CREF(obj_4848))->header = MAKE_HEADER(arg2666_2874, 0), BUNSPEC);
			}
		     }
		     {	/* Cfa/cinfo.scm 39 */
			cfun_cinfo_200_bglt arg2667_2875;
			{	/* Cfa/cinfo.scm 39 */
			   cfun_cinfo_200_bglt res2769_4855;
			   {	/* Cfa/cinfo.scm 39 */
			      approx_bglt approx_4852;
			      {		/* Cfa/cinfo.scm 39 */
				 obj_t aux_9348;
				 aux_9348 =
				    STRUCT_REF(aux1487_2872, ((long) 0));
				 approx_4852 =
				    (approx_bglt) (aux_9348);
			      }
			      {		/* Cfa/cinfo.scm 39 */
				 cfun_cinfo_200_bglt new1476_4853;
				 new1476_4853 =
				    ((cfun_cinfo_200_bglt) BREF(GC_MALLOC(sizeof(struct cfun_cinfo_200))));
				 ((((cfun_cinfo_200_bglt) CREF(new1476_4853))->approx) = ((approx_bglt) approx_4852), BUNSPEC);
				 res2769_4855 = new1476_4853;
			      }
			   }
			   arg2667_2875 = res2769_4855;
			}
			{	/* Cfa/cinfo.scm 39 */
			   obj_t aux_9355;
			   object_bglt aux_9353;
			   aux_9355 =
			      (obj_t) (arg2667_2875);
			   aux_9353 =
			      (object_bglt) (new1488_2873);
			   OBJECT_WIDENING_SET(aux_9353, aux_9355);
			}
		     }
		     aux_9330 = new1488_2873;
		  }
	       }
	    }
	    return
	       (obj_t) (aux_9330);
	 }
      }
   }
}



/* object->struct-cfun/cinfo2090 */
obj_t 
object__struct_cfun_cinfo2090_55_cfa_info(obj_t env_6101, obj_t obj1483_6102)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 39 */
      {
	 cfun_cinfo_200_bglt obj1483_2857;
	 obj1483_2857 =
	    (cfun_cinfo_200_bglt) (obj1483_6102);
	 {

	    {	/* Cfa/cinfo.scm 39 */
	       obj_t res1484_2860;
	       {	/* Cfa/cinfo.scm 39 */
		  obj_t next_method2089_15_2865;
		  next_method2089_15_2865 =
		     find_super_class_method_167___object(
		     (object_bglt) (obj1483_2857), object__struct_env_210___object, cfun_cinfo_200_cfa_info);
		  if (
		     PROCEDUREP(next_method2089_15_2865))
		    {	/* Cfa/cinfo.scm 39 */
		       res1484_2860 =
			  PROCEDURE_ENTRY(next_method2089_15_2865) (next_method2089_15_2865,
			  (obj_t) (obj1483_2857), BEOA);
		    }
		  else
		    {	/* Cfa/cinfo.scm 39 */
		       PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2089_15_2865);
		       res1484_2860 =
			  object__struct_50___object(
			  (object_bglt) (obj1483_2857));
		    }
	       }
	       {	/* Cfa/cinfo.scm 39 */
		  obj_t aux1485_2861;
		  {	/* ./Llib/struct.scm 1415 */
		     obj_t aux_9370;
		     aux_9370 =
			CNST_TABLE_REF(((long) 1));
		     aux1485_2861 =
			make_struct(aux_9370, ((long) 1), BUNSPEC);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_9373;
		     {	/* Cfa/cinfo.scm 39 */
			approx_bglt aux_9374;
			{
			   obj_t aux_9375;
			   {	/* Cfa/cinfo.scm 39 */
			      object_bglt aux_9376;
			      aux_9376 =
				 (object_bglt) (obj1483_2857);
			      aux_9375 =
				 OBJECT_WIDENING(aux_9376);
			   }
			   aux_9374 =
			      (((cfun_cinfo_200_bglt) CREF(aux_9375))->approx);
			}
			aux_9373 =
			   (obj_t) (aux_9374);
		     }
		     STRUCT_SET(aux1485_2861, ((long) 0), aux_9373);
		  }
		  STRUCT_SET(res1484_2860, ((long) 0), aux1485_2861);
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_9383;
		     aux_9383 =
			STRUCT_KEY(res1484_2860);
		     STRUCT_KEY_SET(aux1485_2861, aux_9383);
		  }
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_9386;
		     aux_9386 =
			CNST_TABLE_REF(((long) 1));
		     STRUCT_KEY_SET(res1484_2860, aux_9386);
		  }
		  return res1484_2860;
	       }
	    }
	 }
      }
   }
}



/* struct+object->object-extern-sfun/cinfo2088 */
obj_t 
struct_object__object_extern_sfun_cinfo2088_95_cfa_info(obj_t env_6103, obj_t o_6104, obj_t s_6105)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 40 */
      {
	 extern_sfun_cinfo_6_bglt o_2845;
	 obj_t s_2846;
	 {	/* Cfa/cinfo.scm 40 */
	    extern_sfun_cinfo_6_bglt aux_9390;
	    o_2845 =
	       (extern_sfun_cinfo_6_bglt) (o_6104);
	    s_2846 = s_6105;
	    {

	       {	/* Cfa/cinfo.scm 40 */
		  obj_t old1509_2849;
		  obj_t aux1510_2850;
		  {	/* Cfa/cinfo.scm 40 */
		     obj_t next_method2087_57_2855;
		     next_method2087_57_2855 =
			find_super_class_method_167___object(
			(object_bglt) (o_2845), struct_object__object_env_209___object, extern_sfun_cinfo_6_cfa_info);
		     if (
			PROCEDUREP(next_method2087_57_2855))
		       {	/* Cfa/cinfo.scm 40 */
			  old1509_2849 =
			     PROCEDURE_ENTRY(next_method2087_57_2855) (next_method2087_57_2855,
			     (obj_t) (o_2845), s_2846, BEOA);
		       }
		     else
		       {	/* Cfa/cinfo.scm 40 */
			  PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2087_57_2855);
			  {	/* Cfa/cinfo.scm 40 */
			     object_bglt aux_9399;
			     aux_9399 =
				struct_object__object_93___object(
				(object_bglt) (o_2845), s_2846);
			     old1509_2849 =
				(obj_t) (aux_9399);
			  }
		       }
		  }
		  aux1510_2850 =
		     STRUCT_REF(s_2846, ((long) 0));
		  {	/* Cfa/cinfo.scm 40 */
		     extern_sfun_cinfo_6_bglt new1511_2851;
		     new1511_2851 =
			((extern_sfun_cinfo_6_bglt) (old1509_2849));
		     {	/* Cfa/cinfo.scm 40 */
			long arg2658_2852;
			arg2658_2852 =
			   class_num_218___object(extern_sfun_cinfo_6_cfa_info);
			{	/* Cfa/cinfo.scm 40 */
			   obj_t obj_4819;
			   obj_4819 =
			      (obj_t) (new1511_2851);
			   (((obj_t) CREF(obj_4819))->header = MAKE_HEADER(arg2658_2852, 0), BUNSPEC);
			}
		     }
		     {	/* Cfa/cinfo.scm 40 */
			extern_sfun_cinfo_6_bglt arg2659_2853;
			{	/* Cfa/cinfo.scm 40 */
			   extern_sfun_cinfo_6_bglt res2768_4826;
			   {	/* Cfa/cinfo.scm 40 */
			      approx_bglt approx_4823;
			      {		/* Cfa/cinfo.scm 40 */
				 obj_t aux_9408;
				 aux_9408 =
				    STRUCT_REF(aux1510_2850, ((long) 0));
				 approx_4823 =
				    (approx_bglt) (aux_9408);
			      }
			      {		/* Cfa/cinfo.scm 40 */
				 extern_sfun_cinfo_6_bglt new1500_4824;
				 new1500_4824 =
				    ((extern_sfun_cinfo_6_bglt) BREF(GC_MALLOC(sizeof(struct extern_sfun_cinfo_6))));
				 ((((extern_sfun_cinfo_6_bglt) CREF(new1500_4824))->approx) = ((approx_bglt) approx_4823), BUNSPEC);
				 res2768_4826 = new1500_4824;
			      }
			   }
			   arg2659_2853 = res2768_4826;
			}
			{	/* Cfa/cinfo.scm 40 */
			   obj_t aux_9415;
			   object_bglt aux_9413;
			   aux_9415 =
			      (obj_t) (arg2659_2853);
			   aux_9413 =
			      (object_bglt) (new1511_2851);
			   OBJECT_WIDENING_SET(aux_9413, aux_9415);
			}
		     }
		     aux_9390 = new1511_2851;
		  }
	       }
	    }
	    return
	       (obj_t) (aux_9390);
	 }
      }
   }
}



/* object->struct-extern-sfun/cinfo2086 */
obj_t 
object__struct_extern_sfun_cinfo2086_160_cfa_info(obj_t env_6106, obj_t obj1506_6107)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 40 */
      {
	 extern_sfun_cinfo_6_bglt obj1506_2835;
	 obj1506_2835 =
	    (extern_sfun_cinfo_6_bglt) (obj1506_6107);
	 {

	    {	/* Cfa/cinfo.scm 40 */
	       obj_t res1507_2838;
	       {	/* Cfa/cinfo.scm 40 */
		  obj_t next_method2085_148_2843;
		  next_method2085_148_2843 =
		     find_super_class_method_167___object(
		     (object_bglt) (obj1506_2835), object__struct_env_210___object, extern_sfun_cinfo_6_cfa_info);
		  if (
		     PROCEDUREP(next_method2085_148_2843))
		    {	/* Cfa/cinfo.scm 40 */
		       res1507_2838 =
			  PROCEDURE_ENTRY(next_method2085_148_2843) (next_method2085_148_2843,
			  (obj_t) (obj1506_2835), BEOA);
		    }
		  else
		    {	/* Cfa/cinfo.scm 40 */
		       PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2085_148_2843);
		       res1507_2838 =
			  object__struct_50___object(
			  (object_bglt) (obj1506_2835));
		    }
	       }
	       {	/* Cfa/cinfo.scm 40 */
		  obj_t aux1508_2839;
		  {	/* ./Llib/struct.scm 1415 */
		     obj_t aux_9430;
		     aux_9430 =
			CNST_TABLE_REF(((long) 2));
		     aux1508_2839 =
			make_struct(aux_9430, ((long) 1), BUNSPEC);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_9433;
		     {	/* Cfa/cinfo.scm 40 */
			approx_bglt aux_9434;
			{
			   obj_t aux_9435;
			   {	/* Cfa/cinfo.scm 40 */
			      object_bglt aux_9436;
			      aux_9436 =
				 (object_bglt) (obj1506_2835);
			      aux_9435 =
				 OBJECT_WIDENING(aux_9436);
			   }
			   aux_9434 =
			      (((extern_sfun_cinfo_6_bglt) CREF(aux_9435))->approx);
			}
			aux_9433 =
			   (obj_t) (aux_9434);
		     }
		     STRUCT_SET(aux1508_2839, ((long) 0), aux_9433);
		  }
		  STRUCT_SET(res1507_2838, ((long) 0), aux1508_2839);
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_9443;
		     aux_9443 =
			STRUCT_KEY(res1507_2838);
		     STRUCT_KEY_SET(aux1508_2839, aux_9443);
		  }
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_9446;
		     aux_9446 =
			CNST_TABLE_REF(((long) 2));
		     STRUCT_KEY_SET(res1507_2838, aux_9446);
		  }
		  return res1507_2838;
	       }
	    }
	 }
      }
   }
}



/* struct+object->object-intern-sfun/cinfo2084 */
obj_t 
struct_object__object_intern_sfun_cinfo2084_8_cfa_info(obj_t env_6108, obj_t o_6109, obj_t s_6110)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 41 */
      {
	 intern_sfun_cinfo_192_bglt o_2822;
	 obj_t s_2823;
	 {	/* Cfa/cinfo.scm 41 */
	    intern_sfun_cinfo_192_bglt aux_9450;
	    o_2822 =
	       (intern_sfun_cinfo_192_bglt) (o_6109);
	    s_2823 = s_6110;
	    {

	       {	/* Cfa/cinfo.scm 41 */
		  obj_t old1534_2826;
		  obj_t aux1535_2827;
		  {	/* Cfa/cinfo.scm 41 */
		     obj_t next_method2083_49_2833;
		     next_method2083_49_2833 =
			find_super_class_method_167___object(
			(object_bglt) (o_2822), struct_object__object_env_209___object, intern_sfun_cinfo_192_cfa_info);
		     if (
			PROCEDUREP(next_method2083_49_2833))
		       {	/* Cfa/cinfo.scm 41 */
			  old1534_2826 =
			     PROCEDURE_ENTRY(next_method2083_49_2833) (next_method2083_49_2833,
			     (obj_t) (o_2822), s_2823, BEOA);
		       }
		     else
		       {	/* Cfa/cinfo.scm 41 */
			  PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2083_49_2833);
			  {	/* Cfa/cinfo.scm 41 */
			     object_bglt aux_9459;
			     aux_9459 =
				struct_object__object_93___object(
				(object_bglt) (o_2822), s_2823);
			     old1534_2826 =
				(obj_t) (aux_9459);
			  }
		       }
		  }
		  aux1535_2827 =
		     STRUCT_REF(s_2823, ((long) 0));
		  {	/* Cfa/cinfo.scm 41 */
		     intern_sfun_cinfo_192_bglt new1536_2828;
		     new1536_2828 =
			((intern_sfun_cinfo_192_bglt) (old1534_2826));
		     {	/* Cfa/cinfo.scm 41 */
			long arg2649_2829;
			arg2649_2829 =
			   class_num_218___object(intern_sfun_cinfo_192_cfa_info);
			{	/* Cfa/cinfo.scm 41 */
			   obj_t obj_4786;
			   obj_4786 =
			      (obj_t) (new1536_2828);
			   (((obj_t) CREF(obj_4786))->header = MAKE_HEADER(arg2649_2829, 0), BUNSPEC);
			}
		     }
		     {	/* Cfa/cinfo.scm 41 */
			intern_sfun_cinfo_192_bglt arg2650_2830;
			{	/* Cfa/cinfo.scm 41 */
			   intern_sfun_cinfo_192_bglt res2767_4797;
			   {	/* Cfa/cinfo.scm 41 */
			      approx_bglt approx_4792;
			      long stamp_4793;
			      {		/* Cfa/cinfo.scm 41 */
				 obj_t aux_9468;
				 aux_9468 =
				    STRUCT_REF(aux1535_2827, ((long) 0));
				 approx_4792 =
				    (approx_bglt) (aux_9468);
			      }
			      {		/* Cfa/cinfo.scm 41 */
				 obj_t aux_9471;
				 aux_9471 =
				    STRUCT_REF(aux1535_2827, ((long) 1));
				 stamp_4793 =
				    (long) CINT(aux_9471);
			      }
			      {		/* Cfa/cinfo.scm 41 */
				 intern_sfun_cinfo_192_bglt new1524_4794;
				 new1524_4794 =
				    ((intern_sfun_cinfo_192_bglt) BREF(GC_MALLOC(sizeof(struct intern_sfun_cinfo_192))));
				 ((((intern_sfun_cinfo_192_bglt) CREF(new1524_4794))->approx) = ((approx_bglt) approx_4792), BUNSPEC);
				 ((((intern_sfun_cinfo_192_bglt) CREF(new1524_4794))->stamp) = ((long) stamp_4793), BUNSPEC);
				 res2767_4797 = new1524_4794;
			      }
			   }
			   arg2650_2830 = res2767_4797;
			}
			{	/* Cfa/cinfo.scm 41 */
			   obj_t aux_9479;
			   object_bglt aux_9477;
			   aux_9479 =
			      (obj_t) (arg2650_2830);
			   aux_9477 =
			      (object_bglt) (new1536_2828);
			   OBJECT_WIDENING_SET(aux_9477, aux_9479);
			}
		     }
		     aux_9450 = new1536_2828;
		  }
	       }
	    }
	    return
	       (obj_t) (aux_9450);
	 }
      }
   }
}



/* object->struct-intern-sfun/cinfo2082 */
obj_t 
object__struct_intern_sfun_cinfo2082_117_cfa_info(obj_t env_6111, obj_t obj1531_6112)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 41 */
      {
	 intern_sfun_cinfo_192_bglt obj1531_2810;
	 obj1531_2810 =
	    (intern_sfun_cinfo_192_bglt) (obj1531_6112);
	 {

	    {	/* Cfa/cinfo.scm 41 */
	       obj_t res1532_2813;
	       {	/* Cfa/cinfo.scm 41 */
		  obj_t next_method2081_104_2820;
		  next_method2081_104_2820 =
		     find_super_class_method_167___object(
		     (object_bglt) (obj1531_2810), object__struct_env_210___object, intern_sfun_cinfo_192_cfa_info);
		  if (
		     PROCEDUREP(next_method2081_104_2820))
		    {	/* Cfa/cinfo.scm 41 */
		       res1532_2813 =
			  PROCEDURE_ENTRY(next_method2081_104_2820) (next_method2081_104_2820,
			  (obj_t) (obj1531_2810), BEOA);
		    }
		  else
		    {	/* Cfa/cinfo.scm 41 */
		       PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2081_104_2820);
		       res1532_2813 =
			  object__struct_50___object(
			  (object_bglt) (obj1531_2810));
		    }
	       }
	       {	/* Cfa/cinfo.scm 41 */
		  obj_t aux1533_2814;
		  {	/* ./Llib/struct.scm 1415 */
		     obj_t aux_9494;
		     aux_9494 =
			CNST_TABLE_REF(((long) 3));
		     aux1533_2814 =
			make_struct(aux_9494, ((long) 2), BUNSPEC);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_9497;
		     {	/* Cfa/cinfo.scm 41 */
			approx_bglt aux_9498;
			{
			   obj_t aux_9499;
			   {	/* Cfa/cinfo.scm 42 */
			      object_bglt aux_9500;
			      aux_9500 =
				 (object_bglt) (obj1531_2810);
			      aux_9499 =
				 OBJECT_WIDENING(aux_9500);
			   }
			   aux_9498 =
			      (((intern_sfun_cinfo_192_bglt) CREF(aux_9499))->approx);
			}
			aux_9497 =
			   (obj_t) (aux_9498);
		     }
		     STRUCT_SET(aux1533_2814, ((long) 0), aux_9497);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_9506;
		     {	/* Cfa/cinfo.scm 41 */
			long aux_9507;
			{
			   obj_t aux_9508;
			   {	/* Cfa/cinfo.scm 43 */
			      object_bglt aux_9509;
			      aux_9509 =
				 (object_bglt) (obj1531_2810);
			      aux_9508 =
				 OBJECT_WIDENING(aux_9509);
			   }
			   aux_9507 =
			      (((intern_sfun_cinfo_192_bglt) CREF(aux_9508))->stamp);
			}
			aux_9506 =
			   BINT(aux_9507);
		     }
		     STRUCT_SET(aux1533_2814, ((long) 1), aux_9506);
		  }
		  STRUCT_SET(res1532_2813, ((long) 0), aux1533_2814);
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_9516;
		     aux_9516 =
			STRUCT_KEY(res1532_2813);
		     STRUCT_KEY_SET(aux1533_2814, aux_9516);
		  }
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_9519;
		     aux_9519 =
			CNST_TABLE_REF(((long) 3));
		     STRUCT_KEY_SET(res1532_2813, aux_9519);
		  }
		  return res1532_2813;
	       }
	    }
	 }
      }
   }
}



/* struct+object->object-scnst/cinfo2080 */
obj_t 
struct_object__object_scnst_cinfo2080_231_cfa_info(obj_t env_6113, obj_t o_6114, obj_t s_6115)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 46 */
      {
	 scnst_cinfo_0_bglt o_2798;
	 obj_t s_2799;
	 {	/* Cfa/cinfo.scm 46 */
	    scnst_cinfo_0_bglt aux_9523;
	    o_2798 =
	       (scnst_cinfo_0_bglt) (o_6114);
	    s_2799 = s_6115;
	    {

	       {	/* Cfa/cinfo.scm 46 */
		  obj_t old1548_2802;
		  obj_t aux1549_2803;
		  {	/* Cfa/cinfo.scm 46 */
		     obj_t next_method2079_165_2808;
		     next_method2079_165_2808 =
			find_super_class_method_167___object(
			(object_bglt) (o_2798), struct_object__object_env_209___object, scnst_cinfo_0_cfa_info);
		     if (
			PROCEDUREP(next_method2079_165_2808))
		       {	/* Cfa/cinfo.scm 46 */
			  old1548_2802 =
			     PROCEDURE_ENTRY(next_method2079_165_2808) (next_method2079_165_2808,
			     (obj_t) (o_2798), s_2799, BEOA);
		       }
		     else
		       {	/* Cfa/cinfo.scm 46 */
			  PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2079_165_2808);
			  {	/* Cfa/cinfo.scm 46 */
			     object_bglt aux_9532;
			     aux_9532 =
				struct_object__object_93___object(
				(object_bglt) (o_2798), s_2799);
			     old1548_2802 =
				(obj_t) (aux_9532);
			  }
		       }
		  }
		  aux1549_2803 =
		     STRUCT_REF(s_2799, ((long) 0));
		  {	/* Cfa/cinfo.scm 46 */
		     scnst_cinfo_0_bglt new1550_2804;
		     new1550_2804 =
			((scnst_cinfo_0_bglt) (old1548_2802));
		     {	/* Cfa/cinfo.scm 46 */
			long arg2639_2805;
			arg2639_2805 =
			   class_num_218___object(scnst_cinfo_0_cfa_info);
			{	/* Cfa/cinfo.scm 46 */
			   obj_t obj_4753;
			   obj_4753 =
			      (obj_t) (new1550_2804);
			   (((obj_t) CREF(obj_4753))->header = MAKE_HEADER(arg2639_2805, 0), BUNSPEC);
			}
		     }
		     {	/* Cfa/cinfo.scm 46 */
			scnst_cinfo_0_bglt arg2640_2806;
			{	/* Cfa/cinfo.scm 46 */
			   scnst_cinfo_0_bglt res2766_4760;
			   {	/* Cfa/cinfo.scm 46 */
			      approx_bglt approx_4757;
			      {		/* Cfa/cinfo.scm 46 */
				 obj_t aux_9541;
				 aux_9541 =
				    STRUCT_REF(aux1549_2803, ((long) 0));
				 approx_4757 =
				    (approx_bglt) (aux_9541);
			      }
			      {		/* Cfa/cinfo.scm 46 */
				 scnst_cinfo_0_bglt new1539_4758;
				 new1539_4758 =
				    ((scnst_cinfo_0_bglt) BREF(GC_MALLOC(sizeof(struct scnst_cinfo_0))));
				 ((((scnst_cinfo_0_bglt) CREF(new1539_4758))->approx) = ((approx_bglt) approx_4757), BUNSPEC);
				 res2766_4760 = new1539_4758;
			      }
			   }
			   arg2640_2806 = res2766_4760;
			}
			{	/* Cfa/cinfo.scm 46 */
			   obj_t aux_9548;
			   object_bglt aux_9546;
			   aux_9548 =
			      (obj_t) (arg2640_2806);
			   aux_9546 =
			      (object_bglt) (new1550_2804);
			   OBJECT_WIDENING_SET(aux_9546, aux_9548);
			}
		     }
		     aux_9523 = new1550_2804;
		  }
	       }
	    }
	    return
	       (obj_t) (aux_9523);
	 }
      }
   }
}



/* object->struct-scnst/cinfo2078 */
obj_t 
object__struct_scnst_cinfo2078_132_cfa_info(obj_t env_6116, obj_t obj1545_6117)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 46 */
      {
	 scnst_cinfo_0_bglt obj1545_2788;
	 obj1545_2788 =
	    (scnst_cinfo_0_bglt) (obj1545_6117);
	 {

	    {	/* Cfa/cinfo.scm 46 */
	       obj_t res1546_2791;
	       {	/* Cfa/cinfo.scm 46 */
		  obj_t next_method2077_244_2796;
		  next_method2077_244_2796 =
		     find_super_class_method_167___object(
		     (object_bglt) (obj1545_2788), object__struct_env_210___object, scnst_cinfo_0_cfa_info);
		  if (
		     PROCEDUREP(next_method2077_244_2796))
		    {	/* Cfa/cinfo.scm 46 */
		       res1546_2791 =
			  PROCEDURE_ENTRY(next_method2077_244_2796) (next_method2077_244_2796,
			  (obj_t) (obj1545_2788), BEOA);
		    }
		  else
		    {	/* Cfa/cinfo.scm 46 */
		       PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2077_244_2796);
		       res1546_2791 =
			  object__struct_50___object(
			  (object_bglt) (obj1545_2788));
		    }
	       }
	       {	/* Cfa/cinfo.scm 46 */
		  obj_t aux1547_2792;
		  {	/* ./Llib/struct.scm 1415 */
		     obj_t aux_9563;
		     aux_9563 =
			CNST_TABLE_REF(((long) 4));
		     aux1547_2792 =
			make_struct(aux_9563, ((long) 1), BUNSPEC);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_9566;
		     {	/* Cfa/cinfo.scm 46 */
			approx_bglt aux_9567;
			{
			   obj_t aux_9568;
			   {	/* Cfa/cinfo.scm 46 */
			      object_bglt aux_9569;
			      aux_9569 =
				 (object_bglt) (obj1545_2788);
			      aux_9568 =
				 OBJECT_WIDENING(aux_9569);
			   }
			   aux_9567 =
			      (((scnst_cinfo_0_bglt) CREF(aux_9568))->approx);
			}
			aux_9566 =
			   (obj_t) (aux_9567);
		     }
		     STRUCT_SET(aux1547_2792, ((long) 0), aux_9566);
		  }
		  STRUCT_SET(res1546_2791, ((long) 0), aux1547_2792);
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_9576;
		     aux_9576 =
			STRUCT_KEY(res1546_2791);
		     STRUCT_KEY_SET(aux1547_2792, aux_9576);
		  }
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_9579;
		     aux_9579 =
			CNST_TABLE_REF(((long) 4));
		     STRUCT_KEY_SET(res1546_2791, aux_9579);
		  }
		  return res1546_2791;
	       }
	    }
	 }
      }
   }
}



/* struct+object->object-pre-clo-env2076 */
obj_t 
struct_object__object_pre_clo_env2076_139_cfa_info(obj_t env_6118, obj_t o_6119, obj_t s_6120)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 49 */
      {
	 pre_clo_env_191_bglt o_2777;
	 obj_t s_2778;
	 {	/* Cfa/cinfo.scm 49 */
	    pre_clo_env_191_bglt aux_9583;
	    o_2777 =
	       (pre_clo_env_191_bglt) (o_6119);
	    s_2778 = s_6120;
	    {

	       {	/* Cfa/cinfo.scm 49 */
		  obj_t old1560_2781;
		  {	/* Cfa/cinfo.scm 49 */
		     obj_t next_method2075_236_2786;
		     next_method2075_236_2786 =
			find_super_class_method_167___object(
			(object_bglt) (o_2777), struct_object__object_env_209___object, pre_clo_env_191_cfa_info);
		     if (
			PROCEDUREP(next_method2075_236_2786))
		       {	/* Cfa/cinfo.scm 49 */
			  old1560_2781 =
			     PROCEDURE_ENTRY(next_method2075_236_2786) (next_method2075_236_2786,
			     (obj_t) (o_2777), s_2778, BEOA);
		       }
		     else
		       {	/* Cfa/cinfo.scm 49 */
			  PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2075_236_2786);
			  {	/* Cfa/cinfo.scm 49 */
			     object_bglt aux_9592;
			     aux_9592 =
				struct_object__object_93___object(
				(object_bglt) (o_2777), s_2778);
			     old1560_2781 =
				(obj_t) (aux_9592);
			  }
		       }
		  }
		  {	/* Cfa/cinfo.scm 49 */
		     pre_clo_env_191_bglt new1562_2783;
		     new1562_2783 =
			((pre_clo_env_191_bglt) (old1560_2781));
		     {	/* Cfa/cinfo.scm 49 */
			long arg2632_2784;
			arg2632_2784 =
			   class_num_218___object(pre_clo_env_191_cfa_info);
			{	/* Cfa/cinfo.scm 49 */
			   obj_t obj_4728;
			   obj_4728 =
			      (obj_t) (new1562_2783);
			   (((obj_t) CREF(obj_4728))->header = MAKE_HEADER(arg2632_2784, 0), BUNSPEC);
			}
		     }
		     {	/* Cfa/cinfo.scm 49 */
			obj_t aux_9602;
			object_bglt aux_9600;
			{	/* Cfa/cinfo.scm 49 */
			   pre_clo_env_191_bglt aux_9603;
			   {	/* Cfa/cinfo.scm 49 */

			      aux_9603 =
				 ((pre_clo_env_191_bglt) BREF(GC_MALLOC(sizeof(struct pre_clo_env_191))));
			   }
			   aux_9602 =
			      (obj_t) (aux_9603);
			}
			aux_9600 =
			   (object_bglt) (new1562_2783);
			OBJECT_WIDENING_SET(aux_9600, aux_9602);
		     }
		     aux_9583 = new1562_2783;
		  }
	       }
	    }
	    return
	       (obj_t) (aux_9583);
	 }
      }
   }
}



/* object->struct-pre-clo-env2074 */
obj_t 
object__struct_pre_clo_env2074_162_cfa_info(obj_t env_6121, obj_t obj1557_6122)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 49 */
      {
	 pre_clo_env_191_bglt obj1557_2769;
	 obj1557_2769 =
	    (pre_clo_env_191_bglt) (obj1557_6122);
	 {

	    {	/* Cfa/cinfo.scm 49 */
	       obj_t res1558_2772;
	       {	/* Cfa/cinfo.scm 49 */
		  obj_t next_method2073_136_2775;
		  next_method2073_136_2775 =
		     find_super_class_method_167___object(
		     (object_bglt) (obj1557_2769), object__struct_env_210___object, pre_clo_env_191_cfa_info);
		  if (
		     PROCEDUREP(next_method2073_136_2775))
		    {	/* Cfa/cinfo.scm 49 */
		       res1558_2772 =
			  PROCEDURE_ENTRY(next_method2073_136_2775) (next_method2073_136_2775,
			  (obj_t) (obj1557_2769), BEOA);
		    }
		  else
		    {	/* Cfa/cinfo.scm 49 */
		       PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2073_136_2775);
		       res1558_2772 =
			  object__struct_50___object(
			  (object_bglt) (obj1557_2769));
		    }
	       }
	       {	/* Cfa/cinfo.scm 49 */
		  obj_t aux1559_2773;
		  {	/* ./Llib/struct.scm 1415 */
		     obj_t aux_9619;
		     aux_9619 =
			CNST_TABLE_REF(((long) 5));
		     aux1559_2773 =
			make_struct(aux_9619, ((long) 0), BUNSPEC);
		  }
		  STRUCT_SET(res1558_2772, ((long) 0), aux1559_2773);
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_9623;
		     aux_9623 =
			STRUCT_KEY(res1558_2772);
		     STRUCT_KEY_SET(aux1559_2773, aux_9623);
		  }
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_9626;
		     aux_9626 =
			CNST_TABLE_REF(((long) 5));
		     STRUCT_KEY_SET(res1558_2772, aux_9626);
		  }
		  return res1558_2772;
	       }
	    }
	 }
      }
   }
}



/* struct+object->object-svar/cinfo2072 */
obj_t 
struct_object__object_svar_cinfo2072_159_cfa_info(obj_t env_6123, obj_t o_6124, obj_t s_6125)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 50 */
      {
	 svar_cinfo_166_bglt o_2756;
	 obj_t s_2757;
	 {	/* Cfa/cinfo.scm 50 */
	    svar_cinfo_166_bglt aux_9630;
	    o_2756 =
	       (svar_cinfo_166_bglt) (o_6124);
	    s_2757 = s_6125;
	    {

	       {	/* Cfa/cinfo.scm 50 */
		  obj_t old1575_2760;
		  obj_t aux1576_2761;
		  {	/* Cfa/cinfo.scm 50 */
		     obj_t next_method2071_182_2767;
		     next_method2071_182_2767 =
			find_super_class_method_167___object(
			(object_bglt) (o_2756), struct_object__object_env_209___object, svar_cinfo_166_cfa_info);
		     if (
			PROCEDUREP(next_method2071_182_2767))
		       {	/* Cfa/cinfo.scm 50 */
			  old1575_2760 =
			     PROCEDURE_ENTRY(next_method2071_182_2767) (next_method2071_182_2767,
			     (obj_t) (o_2756), s_2757, BEOA);
		       }
		     else
		       {	/* Cfa/cinfo.scm 50 */
			  PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2071_182_2767);
			  {	/* Cfa/cinfo.scm 50 */
			     object_bglt aux_9639;
			     aux_9639 =
				struct_object__object_93___object(
				(object_bglt) (o_2756), s_2757);
			     old1575_2760 =
				(obj_t) (aux_9639);
			  }
		       }
		  }
		  aux1576_2761 =
		     STRUCT_REF(s_2757, ((long) 0));
		  {	/* Cfa/cinfo.scm 50 */
		     svar_cinfo_166_bglt new1577_2762;
		     new1577_2762 =
			((svar_cinfo_166_bglt) (old1575_2760));
		     {	/* Cfa/cinfo.scm 50 */
			long arg2625_2763;
			arg2625_2763 =
			   class_num_218___object(svar_cinfo_166_cfa_info);
			{	/* Cfa/cinfo.scm 50 */
			   obj_t obj_4699;
			   obj_4699 =
			      (obj_t) (new1577_2762);
			   (((obj_t) CREF(obj_4699))->header = MAKE_HEADER(arg2625_2763, 0), BUNSPEC);
			}
		     }
		     {	/* Cfa/cinfo.scm 50 */
			svar_cinfo_166_bglt arg2626_2764;
			{	/* Cfa/cinfo.scm 50 */
			   svar_cinfo_166_bglt res2764_4710;
			   {	/* Cfa/cinfo.scm 50 */
			      approx_bglt approx_4705;
			      bool_t clo_env__87_4706;
			      {		/* Cfa/cinfo.scm 50 */
				 obj_t aux_9648;
				 aux_9648 =
				    STRUCT_REF(aux1576_2761, ((long) 0));
				 approx_4705 =
				    (approx_bglt) (aux_9648);
			      }
			      {		/* Cfa/cinfo.scm 50 */
				 obj_t aux_9651;
				 aux_9651 =
				    STRUCT_REF(aux1576_2761, ((long) 1));
				 clo_env__87_4706 =
				    CBOOL(aux_9651);
			      }
			      {		/* Cfa/cinfo.scm 50 */
				 svar_cinfo_166_bglt new1565_4707;
				 new1565_4707 =
				    ((svar_cinfo_166_bglt) BREF(GC_MALLOC(sizeof(struct svar_cinfo_166))));
				 ((((svar_cinfo_166_bglt) CREF(new1565_4707))->approx) = ((approx_bglt) approx_4705), BUNSPEC);
				 ((((svar_cinfo_166_bglt) CREF(new1565_4707))->clo_env__87) = ((bool_t) clo_env__87_4706), BUNSPEC);
				 res2764_4710 = new1565_4707;
			      }
			   }
			   arg2626_2764 = res2764_4710;
			}
			{	/* Cfa/cinfo.scm 50 */
			   obj_t aux_9659;
			   object_bglt aux_9657;
			   aux_9659 =
			      (obj_t) (arg2626_2764);
			   aux_9657 =
			      (object_bglt) (new1577_2762);
			   OBJECT_WIDENING_SET(aux_9657, aux_9659);
			}
		     }
		     aux_9630 = new1577_2762;
		  }
	       }
	    }
	    return
	       (obj_t) (aux_9630);
	 }
      }
   }
}



/* object->struct-svar/cinfo2070 */
obj_t 
object__struct_svar_cinfo2070_189_cfa_info(obj_t env_6126, obj_t obj1572_6127)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 50 */
      {
	 svar_cinfo_166_bglt obj1572_2744;
	 obj1572_2744 =
	    (svar_cinfo_166_bglt) (obj1572_6127);
	 {

	    {	/* Cfa/cinfo.scm 50 */
	       obj_t res1573_2747;
	       {	/* Cfa/cinfo.scm 50 */
		  obj_t next_method2069_234_2754;
		  next_method2069_234_2754 =
		     find_super_class_method_167___object(
		     (object_bglt) (obj1572_2744), object__struct_env_210___object, svar_cinfo_166_cfa_info);
		  if (
		     PROCEDUREP(next_method2069_234_2754))
		    {	/* Cfa/cinfo.scm 50 */
		       res1573_2747 =
			  PROCEDURE_ENTRY(next_method2069_234_2754) (next_method2069_234_2754,
			  (obj_t) (obj1572_2744), BEOA);
		    }
		  else
		    {	/* Cfa/cinfo.scm 50 */
		       PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2069_234_2754);
		       res1573_2747 =
			  object__struct_50___object(
			  (object_bglt) (obj1572_2744));
		    }
	       }
	       {	/* Cfa/cinfo.scm 50 */
		  obj_t aux1574_2748;
		  {	/* ./Llib/struct.scm 1415 */
		     obj_t aux_9674;
		     aux_9674 =
			CNST_TABLE_REF(((long) 6));
		     aux1574_2748 =
			make_struct(aux_9674, ((long) 2), BUNSPEC);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_9677;
		     {	/* Cfa/cinfo.scm 50 */
			approx_bglt aux_9678;
			{
			   obj_t aux_9679;
			   {	/* Cfa/cinfo.scm 51 */
			      object_bglt aux_9680;
			      aux_9680 =
				 (object_bglt) (obj1572_2744);
			      aux_9679 =
				 OBJECT_WIDENING(aux_9680);
			   }
			   aux_9678 =
			      (((svar_cinfo_166_bglt) CREF(aux_9679))->approx);
			}
			aux_9677 =
			   (obj_t) (aux_9678);
		     }
		     STRUCT_SET(aux1574_2748, ((long) 0), aux_9677);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_9686;
		     {	/* Cfa/cinfo.scm 50 */
			bool_t aux_9687;
			{
			   obj_t aux_9688;
			   {	/* Cfa/cinfo.scm 55 */
			      object_bglt aux_9689;
			      aux_9689 =
				 (object_bglt) (obj1572_2744);
			      aux_9688 =
				 OBJECT_WIDENING(aux_9689);
			   }
			   aux_9687 =
			      (((svar_cinfo_166_bglt) CREF(aux_9688))->clo_env__87);
			}
			aux_9686 =
			   BBOOL(aux_9687);
		     }
		     STRUCT_SET(aux1574_2748, ((long) 1), aux_9686);
		  }
		  STRUCT_SET(res1573_2747, ((long) 0), aux1574_2748);
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_9696;
		     aux_9696 =
			STRUCT_KEY(res1573_2747);
		     STRUCT_KEY_SET(aux1574_2748, aux_9696);
		  }
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_9699;
		     aux_9699 =
			CNST_TABLE_REF(((long) 6));
		     STRUCT_KEY_SET(res1573_2747, aux_9699);
		  }
		  return res1573_2747;
	       }
	    }
	 }
      }
   }
}



/* struct+object->object-cvar/cinfo2068 */
obj_t 
struct_object__object_cvar_cinfo2068_13_cfa_info(obj_t env_6128, obj_t o_6129, obj_t s_6130)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 56 */
      {
	 cvar_cinfo_53_bglt o_2732;
	 obj_t s_2733;
	 {	/* Cfa/cinfo.scm 56 */
	    cvar_cinfo_53_bglt aux_9703;
	    o_2732 =
	       (cvar_cinfo_53_bglt) (o_6129);
	    s_2733 = s_6130;
	    {

	       {	/* Cfa/cinfo.scm 56 */
		  obj_t old1587_2736;
		  obj_t aux1588_2737;
		  {	/* Cfa/cinfo.scm 56 */
		     obj_t next_method2067_173_2742;
		     next_method2067_173_2742 =
			find_super_class_method_167___object(
			(object_bglt) (o_2732), struct_object__object_env_209___object, cvar_cinfo_53_cfa_info);
		     if (
			PROCEDUREP(next_method2067_173_2742))
		       {	/* Cfa/cinfo.scm 56 */
			  old1587_2736 =
			     PROCEDURE_ENTRY(next_method2067_173_2742) (next_method2067_173_2742,
			     (obj_t) (o_2732), s_2733, BEOA);
		       }
		     else
		       {	/* Cfa/cinfo.scm 56 */
			  PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2067_173_2742);
			  {	/* Cfa/cinfo.scm 56 */
			     object_bglt aux_9712;
			     aux_9712 =
				struct_object__object_93___object(
				(object_bglt) (o_2732), s_2733);
			     old1587_2736 =
				(obj_t) (aux_9712);
			  }
		       }
		  }
		  aux1588_2737 =
		     STRUCT_REF(s_2733, ((long) 0));
		  {	/* Cfa/cinfo.scm 56 */
		     cvar_cinfo_53_bglt new1589_2738;
		     new1589_2738 =
			((cvar_cinfo_53_bglt) (old1587_2736));
		     {	/* Cfa/cinfo.scm 56 */
			long arg2615_2739;
			arg2615_2739 =
			   class_num_218___object(cvar_cinfo_53_cfa_info);
			{	/* Cfa/cinfo.scm 56 */
			   obj_t obj_4666;
			   obj_4666 =
			      (obj_t) (new1589_2738);
			   (((obj_t) CREF(obj_4666))->header = MAKE_HEADER(arg2615_2739, 0), BUNSPEC);
			}
		     }
		     {	/* Cfa/cinfo.scm 56 */
			cvar_cinfo_53_bglt arg2616_2740;
			{	/* Cfa/cinfo.scm 56 */
			   cvar_cinfo_53_bglt res2763_4673;
			   {	/* Cfa/cinfo.scm 56 */
			      approx_bglt approx_4670;
			      {		/* Cfa/cinfo.scm 56 */
				 obj_t aux_9721;
				 aux_9721 =
				    STRUCT_REF(aux1588_2737, ((long) 0));
				 approx_4670 =
				    (approx_bglt) (aux_9721);
			      }
			      {		/* Cfa/cinfo.scm 56 */
				 cvar_cinfo_53_bglt new1578_4671;
				 new1578_4671 =
				    ((cvar_cinfo_53_bglt) BREF(GC_MALLOC(sizeof(struct cvar_cinfo_53))));
				 ((((cvar_cinfo_53_bglt) CREF(new1578_4671))->approx) = ((approx_bglt) approx_4670), BUNSPEC);
				 res2763_4673 = new1578_4671;
			      }
			   }
			   arg2616_2740 = res2763_4673;
			}
			{	/* Cfa/cinfo.scm 56 */
			   obj_t aux_9728;
			   object_bglt aux_9726;
			   aux_9728 =
			      (obj_t) (arg2616_2740);
			   aux_9726 =
			      (object_bglt) (new1589_2738);
			   OBJECT_WIDENING_SET(aux_9726, aux_9728);
			}
		     }
		     aux_9703 = new1589_2738;
		  }
	       }
	    }
	    return
	       (obj_t) (aux_9703);
	 }
      }
   }
}



/* object->struct-cvar/cinfo2066 */
obj_t 
object__struct_cvar_cinfo2066_213_cfa_info(obj_t env_6131, obj_t obj1584_6132)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 56 */
      {
	 cvar_cinfo_53_bglt obj1584_2722;
	 obj1584_2722 =
	    (cvar_cinfo_53_bglt) (obj1584_6132);
	 {

	    {	/* Cfa/cinfo.scm 56 */
	       obj_t res1585_2725;
	       {	/* Cfa/cinfo.scm 56 */
		  obj_t next_method2065_30_2730;
		  next_method2065_30_2730 =
		     find_super_class_method_167___object(
		     (object_bglt) (obj1584_2722), object__struct_env_210___object, cvar_cinfo_53_cfa_info);
		  if (
		     PROCEDUREP(next_method2065_30_2730))
		    {	/* Cfa/cinfo.scm 56 */
		       res1585_2725 =
			  PROCEDURE_ENTRY(next_method2065_30_2730) (next_method2065_30_2730,
			  (obj_t) (obj1584_2722), BEOA);
		    }
		  else
		    {	/* Cfa/cinfo.scm 56 */
		       PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2065_30_2730);
		       res1585_2725 =
			  object__struct_50___object(
			  (object_bglt) (obj1584_2722));
		    }
	       }
	       {	/* Cfa/cinfo.scm 56 */
		  obj_t aux1586_2726;
		  {	/* ./Llib/struct.scm 1415 */
		     obj_t aux_9743;
		     aux_9743 =
			CNST_TABLE_REF(((long) 7));
		     aux1586_2726 =
			make_struct(aux_9743, ((long) 1), BUNSPEC);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_9746;
		     {	/* Cfa/cinfo.scm 56 */
			approx_bglt aux_9747;
			{
			   obj_t aux_9748;
			   {	/* Cfa/cinfo.scm 56 */
			      object_bglt aux_9749;
			      aux_9749 =
				 (object_bglt) (obj1584_2722);
			      aux_9748 =
				 OBJECT_WIDENING(aux_9749);
			   }
			   aux_9747 =
			      (((cvar_cinfo_53_bglt) CREF(aux_9748))->approx);
			}
			aux_9746 =
			   (obj_t) (aux_9747);
		     }
		     STRUCT_SET(aux1586_2726, ((long) 0), aux_9746);
		  }
		  STRUCT_SET(res1585_2725, ((long) 0), aux1586_2726);
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_9756;
		     aux_9756 =
			STRUCT_KEY(res1585_2725);
		     STRUCT_KEY_SET(aux1586_2726, aux_9756);
		  }
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_9759;
		     aux_9759 =
			CNST_TABLE_REF(((long) 7));
		     STRUCT_KEY_SET(res1585_2725, aux_9759);
		  }
		  return res1585_2725;
	       }
	    }
	 }
      }
   }
}



/* struct+object->object-sexit/cinfo2064 */
obj_t 
struct_object__object_sexit_cinfo2064_242_cfa_info(obj_t env_6133, obj_t o_6134, obj_t s_6135)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 59 */
      {
	 sexit_cinfo_49_bglt o_2710;
	 obj_t s_2711;
	 {	/* Cfa/cinfo.scm 59 */
	    sexit_cinfo_49_bglt aux_9763;
	    o_2710 =
	       (sexit_cinfo_49_bglt) (o_6134);
	    s_2711 = s_6135;
	    {

	       {	/* Cfa/cinfo.scm 59 */
		  obj_t old1601_2714;
		  obj_t aux1602_2715;
		  {	/* Cfa/cinfo.scm 59 */
		     obj_t next_method2063_36_2720;
		     next_method2063_36_2720 =
			find_super_class_method_167___object(
			(object_bglt) (o_2710), struct_object__object_env_209___object, sexit_cinfo_49_cfa_info);
		     if (
			PROCEDUREP(next_method2063_36_2720))
		       {	/* Cfa/cinfo.scm 59 */
			  old1601_2714 =
			     PROCEDURE_ENTRY(next_method2063_36_2720) (next_method2063_36_2720,
			     (obj_t) (o_2710), s_2711, BEOA);
		       }
		     else
		       {	/* Cfa/cinfo.scm 59 */
			  PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2063_36_2720);
			  {	/* Cfa/cinfo.scm 59 */
			     object_bglt aux_9772;
			     aux_9772 =
				struct_object__object_93___object(
				(object_bglt) (o_2710), s_2711);
			     old1601_2714 =
				(obj_t) (aux_9772);
			  }
		       }
		  }
		  aux1602_2715 =
		     STRUCT_REF(s_2711, ((long) 0));
		  {	/* Cfa/cinfo.scm 59 */
		     sexit_cinfo_49_bglt new1603_2716;
		     new1603_2716 =
			((sexit_cinfo_49_bglt) (old1601_2714));
		     {	/* Cfa/cinfo.scm 59 */
			long arg2607_2717;
			arg2607_2717 =
			   class_num_218___object(sexit_cinfo_49_cfa_info);
			{	/* Cfa/cinfo.scm 59 */
			   obj_t obj_4637;
			   obj_4637 =
			      (obj_t) (new1603_2716);
			   (((obj_t) CREF(obj_4637))->header = MAKE_HEADER(arg2607_2717, 0), BUNSPEC);
			}
		     }
		     {	/* Cfa/cinfo.scm 59 */
			sexit_cinfo_49_bglt arg2608_2718;
			{	/* Cfa/cinfo.scm 59 */
			   sexit_cinfo_49_bglt res2762_4644;
			   {	/* Cfa/cinfo.scm 59 */
			      approx_bglt approx_4641;
			      {		/* Cfa/cinfo.scm 59 */
				 obj_t aux_9781;
				 aux_9781 =
				    STRUCT_REF(aux1602_2715, ((long) 0));
				 approx_4641 =
				    (approx_bglt) (aux_9781);
			      }
			      {		/* Cfa/cinfo.scm 59 */
				 sexit_cinfo_49_bglt new1592_4642;
				 new1592_4642 =
				    ((sexit_cinfo_49_bglt) BREF(GC_MALLOC(sizeof(struct sexit_cinfo_49))));
				 ((((sexit_cinfo_49_bglt) CREF(new1592_4642))->approx) = ((approx_bglt) approx_4641), BUNSPEC);
				 res2762_4644 = new1592_4642;
			      }
			   }
			   arg2608_2718 = res2762_4644;
			}
			{	/* Cfa/cinfo.scm 59 */
			   obj_t aux_9788;
			   object_bglt aux_9786;
			   aux_9788 =
			      (obj_t) (arg2608_2718);
			   aux_9786 =
			      (object_bglt) (new1603_2716);
			   OBJECT_WIDENING_SET(aux_9786, aux_9788);
			}
		     }
		     aux_9763 = new1603_2716;
		  }
	       }
	    }
	    return
	       (obj_t) (aux_9763);
	 }
      }
   }
}



/* object->struct-sexit/cinfo2062 */
obj_t 
object__struct_sexit_cinfo2062_20_cfa_info(obj_t env_6136, obj_t obj1598_6137)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 59 */
      {
	 sexit_cinfo_49_bglt obj1598_2700;
	 obj1598_2700 =
	    (sexit_cinfo_49_bglt) (obj1598_6137);
	 {

	    {	/* Cfa/cinfo.scm 59 */
	       obj_t res1599_2703;
	       {	/* Cfa/cinfo.scm 59 */
		  obj_t next_method2061_188_2708;
		  next_method2061_188_2708 =
		     find_super_class_method_167___object(
		     (object_bglt) (obj1598_2700), object__struct_env_210___object, sexit_cinfo_49_cfa_info);
		  if (
		     PROCEDUREP(next_method2061_188_2708))
		    {	/* Cfa/cinfo.scm 59 */
		       res1599_2703 =
			  PROCEDURE_ENTRY(next_method2061_188_2708) (next_method2061_188_2708,
			  (obj_t) (obj1598_2700), BEOA);
		    }
		  else
		    {	/* Cfa/cinfo.scm 59 */
		       PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2061_188_2708);
		       res1599_2703 =
			  object__struct_50___object(
			  (object_bglt) (obj1598_2700));
		    }
	       }
	       {	/* Cfa/cinfo.scm 59 */
		  obj_t aux1600_2704;
		  {	/* ./Llib/struct.scm 1415 */
		     obj_t aux_9803;
		     aux_9803 =
			CNST_TABLE_REF(((long) 8));
		     aux1600_2704 =
			make_struct(aux_9803, ((long) 1), BUNSPEC);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_9806;
		     {	/* Cfa/cinfo.scm 59 */
			approx_bglt aux_9807;
			{
			   obj_t aux_9808;
			   {	/* Cfa/cinfo.scm 59 */
			      object_bglt aux_9809;
			      aux_9809 =
				 (object_bglt) (obj1598_2700);
			      aux_9808 =
				 OBJECT_WIDENING(aux_9809);
			   }
			   aux_9807 =
			      (((sexit_cinfo_49_bglt) CREF(aux_9808))->approx);
			}
			aux_9806 =
			   (obj_t) (aux_9807);
		     }
		     STRUCT_SET(aux1600_2704, ((long) 0), aux_9806);
		  }
		  STRUCT_SET(res1599_2703, ((long) 0), aux1600_2704);
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_9816;
		     aux_9816 =
			STRUCT_KEY(res1599_2703);
		     STRUCT_KEY_SET(aux1600_2704, aux_9816);
		  }
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_9819;
		     aux_9819 =
			CNST_TABLE_REF(((long) 8));
		     STRUCT_KEY_SET(res1599_2703, aux_9819);
		  }
		  return res1599_2703;
	       }
	    }
	 }
      }
   }
}



/* struct+object->object-reshaped-local2060 */
obj_t 
struct_object__object_reshaped_local2060_138_cfa_info(obj_t env_6138, obj_t o_6139, obj_t s_6140)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 62 */
      {
	 reshaped_local_224_bglt o_2688;
	 obj_t s_2689;
	 {	/* Cfa/cinfo.scm 62 */
	    reshaped_local_224_bglt aux_9823;
	    o_2688 =
	       (reshaped_local_224_bglt) (o_6139);
	    s_2689 = s_6140;
	    {

	       {	/* Cfa/cinfo.scm 62 */
		  obj_t old1621_2692;
		  obj_t aux1622_2693;
		  {	/* Cfa/cinfo.scm 62 */
		     obj_t next_method2059_179_2698;
		     next_method2059_179_2698 =
			find_super_class_method_167___object(
			(object_bglt) (o_2688), struct_object__object_env_209___object, reshaped_local_224_cfa_info);
		     if (
			PROCEDUREP(next_method2059_179_2698))
		       {	/* Cfa/cinfo.scm 62 */
			  old1621_2692 =
			     PROCEDURE_ENTRY(next_method2059_179_2698) (next_method2059_179_2698,
			     (obj_t) (o_2688), s_2689, BEOA);
		       }
		     else
		       {	/* Cfa/cinfo.scm 62 */
			  PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2059_179_2698);
			  {	/* Cfa/cinfo.scm 62 */
			     object_bglt aux_9832;
			     aux_9832 =
				struct_object__object_93___object(
				(object_bglt) (o_2688), s_2689);
			     old1621_2692 =
				(obj_t) (aux_9832);
			  }
		       }
		  }
		  aux1622_2693 =
		     STRUCT_REF(s_2689, ((long) 0));
		  {	/* Cfa/cinfo.scm 62 */
		     reshaped_local_224_bglt new1623_2694;
		     new1623_2694 =
			((reshaped_local_224_bglt) (old1621_2692));
		     {	/* Cfa/cinfo.scm 62 */
			long arg2599_2695;
			arg2599_2695 =
			   class_num_218___object(reshaped_local_224_cfa_info);
			{	/* Cfa/cinfo.scm 62 */
			   obj_t obj_4608;
			   obj_4608 =
			      (obj_t) (new1623_2694);
			   (((obj_t) CREF(obj_4608))->header = MAKE_HEADER(arg2599_2695, 0), BUNSPEC);
			}
		     }
		     {	/* Cfa/cinfo.scm 62 */
			reshaped_local_224_bglt arg2600_2696;
			{	/* Cfa/cinfo.scm 62 */
			   obj_t arg2601_2697;
			   arg2601_2697 =
			      STRUCT_REF(aux1622_2693, ((long) 0));
			   {	/* Cfa/cinfo.scm 62 */
			      reshaped_local_224_bglt res2761_4615;
			      {		/* Cfa/cinfo.scm 62 */
				 reshaped_local_224_bglt new1612_4613;
				 new1612_4613 =
				    ((reshaped_local_224_bglt) BREF(GC_MALLOC(sizeof(struct reshaped_local_224))));
				 ((((reshaped_local_224_bglt) CREF(new1612_4613))->binding_value_3) = ((obj_t) arg2601_2697), BUNSPEC);
				 res2761_4615 = new1612_4613;
			      }
			      arg2600_2696 = res2761_4615;
			   }
			}
			{	/* Cfa/cinfo.scm 62 */
			   obj_t aux_9846;
			   object_bglt aux_9844;
			   aux_9846 =
			      (obj_t) (arg2600_2696);
			   aux_9844 =
			      (object_bglt) (new1623_2694);
			   OBJECT_WIDENING_SET(aux_9844, aux_9846);
			}
		     }
		     aux_9823 = new1623_2694;
		  }
	       }
	    }
	    return
	       (obj_t) (aux_9823);
	 }
      }
   }
}



/* object->struct-reshaped-local2058 */
obj_t 
object__struct_reshaped_local2058_214_cfa_info(obj_t env_6141, obj_t obj1618_6142)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 62 */
      {
	 reshaped_local_224_bglt obj1618_2678;
	 obj1618_2678 =
	    (reshaped_local_224_bglt) (obj1618_6142);
	 {

	    {	/* Cfa/cinfo.scm 62 */
	       obj_t res1619_2681;
	       {	/* Cfa/cinfo.scm 62 */
		  obj_t next_method2057_215_2686;
		  next_method2057_215_2686 =
		     find_super_class_method_167___object(
		     (object_bglt) (obj1618_2678), object__struct_env_210___object, reshaped_local_224_cfa_info);
		  if (
		     PROCEDUREP(next_method2057_215_2686))
		    {	/* Cfa/cinfo.scm 62 */
		       res1619_2681 =
			  PROCEDURE_ENTRY(next_method2057_215_2686) (next_method2057_215_2686,
			  (obj_t) (obj1618_2678), BEOA);
		    }
		  else
		    {	/* Cfa/cinfo.scm 62 */
		       PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2057_215_2686);
		       res1619_2681 =
			  object__struct_50___object(
			  (object_bglt) (obj1618_2678));
		    }
	       }
	       {	/* Cfa/cinfo.scm 62 */
		  obj_t aux1620_2682;
		  {	/* ./Llib/struct.scm 1415 */
		     obj_t aux_9861;
		     aux_9861 =
			CNST_TABLE_REF(((long) 9));
		     aux1620_2682 =
			make_struct(aux_9861, ((long) 1), BUNSPEC);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_9864;
		     {
			obj_t aux_9865;
			{	/* Cfa/cinfo.scm 63 */
			   object_bglt aux_9866;
			   aux_9866 =
			      (object_bglt) (obj1618_2678);
			   aux_9865 =
			      OBJECT_WIDENING(aux_9866);
			}
			aux_9864 =
			   (((reshaped_local_224_bglt) CREF(aux_9865))->binding_value_3);
		     }
		     STRUCT_SET(aux1620_2682, ((long) 0), aux_9864);
		  }
		  STRUCT_SET(res1619_2681, ((long) 0), aux1620_2682);
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_9872;
		     aux_9872 =
			STRUCT_KEY(res1619_2681);
		     STRUCT_KEY_SET(aux1620_2682, aux_9872);
		  }
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_9875;
		     aux_9875 =
			CNST_TABLE_REF(((long) 9));
		     STRUCT_KEY_SET(res1619_2681, aux_9875);
		  }
		  return res1619_2681;
	       }
	    }
	 }
      }
   }
}



/* struct+object->object-reshaped-global2056 */
obj_t 
struct_object__object_reshaped_global2056_155_cfa_info(obj_t env_6143, obj_t o_6144, obj_t s_6145)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 64 */
      {
	 reshaped_global_160_bglt o_2667;
	 obj_t s_2668;
	 {	/* Cfa/cinfo.scm 64 */
	    reshaped_global_160_bglt aux_9879;
	    o_2667 =
	       (reshaped_global_160_bglt) (o_6144);
	    s_2668 = s_6145;
	    {

	       {	/* Cfa/cinfo.scm 64 */
		  obj_t old1644_2671;
		  {	/* Cfa/cinfo.scm 64 */
		     obj_t next_method2055_53_2676;
		     next_method2055_53_2676 =
			find_super_class_method_167___object(
			(object_bglt) (o_2667), struct_object__object_env_209___object, reshaped_global_160_cfa_info);
		     if (
			PROCEDUREP(next_method2055_53_2676))
		       {	/* Cfa/cinfo.scm 64 */
			  old1644_2671 =
			     PROCEDURE_ENTRY(next_method2055_53_2676) (next_method2055_53_2676,
			     (obj_t) (o_2667), s_2668, BEOA);
		       }
		     else
		       {	/* Cfa/cinfo.scm 64 */
			  PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2055_53_2676);
			  {	/* Cfa/cinfo.scm 64 */
			     object_bglt aux_9888;
			     aux_9888 =
				struct_object__object_93___object(
				(object_bglt) (o_2667), s_2668);
			     old1644_2671 =
				(obj_t) (aux_9888);
			  }
		       }
		  }
		  {	/* Cfa/cinfo.scm 64 */
		     reshaped_global_160_bglt new1646_2673;
		     new1646_2673 =
			((reshaped_global_160_bglt) (old1644_2671));
		     {	/* Cfa/cinfo.scm 64 */
			long arg2592_2674;
			arg2592_2674 =
			   class_num_218___object(reshaped_global_160_cfa_info);
			{	/* Cfa/cinfo.scm 64 */
			   obj_t obj_4583;
			   obj_4583 =
			      (obj_t) (new1646_2673);
			   (((obj_t) CREF(obj_4583))->header = MAKE_HEADER(arg2592_2674, 0), BUNSPEC);
			}
		     }
		     {	/* Cfa/cinfo.scm 64 */
			obj_t aux_9898;
			object_bglt aux_9896;
			{	/* Cfa/cinfo.scm 64 */
			   reshaped_global_160_bglt aux_9899;
			   {	/* Cfa/cinfo.scm 64 */

			      aux_9899 =
				 ((reshaped_global_160_bglt) BREF(GC_MALLOC(sizeof(struct reshaped_global_160))));
			   }
			   aux_9898 =
			      (obj_t) (aux_9899);
			}
			aux_9896 =
			   (object_bglt) (new1646_2673);
			OBJECT_WIDENING_SET(aux_9896, aux_9898);
		     }
		     aux_9879 = new1646_2673;
		  }
	       }
	    }
	    return
	       (obj_t) (aux_9879);
	 }
      }
   }
}



/* object->struct-reshaped-global2054 */
obj_t 
object__struct_reshaped_global2054_140_cfa_info(obj_t env_6146, obj_t obj1641_6147)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 64 */
      {
	 reshaped_global_160_bglt obj1641_2659;
	 obj1641_2659 =
	    (reshaped_global_160_bglt) (obj1641_6147);
	 {

	    {	/* Cfa/cinfo.scm 64 */
	       obj_t res1642_2662;
	       {	/* Cfa/cinfo.scm 64 */
		  obj_t next_method2053_109_2665;
		  next_method2053_109_2665 =
		     find_super_class_method_167___object(
		     (object_bglt) (obj1641_2659), object__struct_env_210___object, reshaped_global_160_cfa_info);
		  if (
		     PROCEDUREP(next_method2053_109_2665))
		    {	/* Cfa/cinfo.scm 64 */
		       res1642_2662 =
			  PROCEDURE_ENTRY(next_method2053_109_2665) (next_method2053_109_2665,
			  (obj_t) (obj1641_2659), BEOA);
		    }
		  else
		    {	/* Cfa/cinfo.scm 64 */
		       PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2053_109_2665);
		       res1642_2662 =
			  object__struct_50___object(
			  (object_bglt) (obj1641_2659));
		    }
	       }
	       {	/* Cfa/cinfo.scm 64 */
		  obj_t aux1643_2663;
		  {	/* ./Llib/struct.scm 1415 */
		     obj_t aux_9915;
		     aux_9915 =
			CNST_TABLE_REF(((long) 10));
		     aux1643_2663 =
			make_struct(aux_9915, ((long) 0), BUNSPEC);
		  }
		  STRUCT_SET(res1642_2662, ((long) 0), aux1643_2663);
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_9919;
		     aux_9919 =
			STRUCT_KEY(res1642_2662);
		     STRUCT_KEY_SET(aux1643_2663, aux_9919);
		  }
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_9922;
		     aux_9922 =
			CNST_TABLE_REF(((long) 10));
		     STRUCT_KEY_SET(res1642_2662, aux_9922);
		  }
		  return res1642_2662;
	       }
	    }
	 }
      }
   }
}



/* struct+object->object-atom/cinfo2052 */
obj_t 
struct_object__object_atom_cinfo2052_76_cfa_info(obj_t env_6148, obj_t o_6149, obj_t s_6150)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 67 */
      {
	 atom_cinfo_155_bglt o_2647;
	 obj_t s_2648;
	 {	/* Cfa/cinfo.scm 67 */
	    atom_cinfo_155_bglt aux_9926;
	    o_2647 =
	       (atom_cinfo_155_bglt) (o_6149);
	    s_2648 = s_6150;
	    {

	       {	/* Cfa/cinfo.scm 67 */
		  obj_t old1658_2651;
		  obj_t aux1659_2652;
		  {	/* Cfa/cinfo.scm 67 */
		     obj_t next_method2051_180_2657;
		     next_method2051_180_2657 =
			find_super_class_method_167___object(
			(object_bglt) (o_2647), struct_object__object_env_209___object, atom_cinfo_155_cfa_info);
		     if (
			PROCEDUREP(next_method2051_180_2657))
		       {	/* Cfa/cinfo.scm 67 */
			  old1658_2651 =
			     PROCEDURE_ENTRY(next_method2051_180_2657) (next_method2051_180_2657,
			     (obj_t) (o_2647), s_2648, BEOA);
		       }
		     else
		       {	/* Cfa/cinfo.scm 67 */
			  PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2051_180_2657);
			  {	/* Cfa/cinfo.scm 67 */
			     object_bglt aux_9935;
			     aux_9935 =
				struct_object__object_93___object(
				(object_bglt) (o_2647), s_2648);
			     old1658_2651 =
				(obj_t) (aux_9935);
			  }
		       }
		  }
		  aux1659_2652 =
		     STRUCT_REF(s_2648, ((long) 0));
		  {	/* Cfa/cinfo.scm 67 */
		     atom_cinfo_155_bglt new1660_2653;
		     new1660_2653 =
			((atom_cinfo_155_bglt) (old1658_2651));
		     {	/* Cfa/cinfo.scm 67 */
			long arg2586_2654;
			arg2586_2654 =
			   class_num_218___object(atom_cinfo_155_cfa_info);
			{	/* Cfa/cinfo.scm 67 */
			   obj_t obj_4558;
			   obj_4558 =
			      (obj_t) (new1660_2653);
			   (((obj_t) CREF(obj_4558))->header = MAKE_HEADER(arg2586_2654, 0), BUNSPEC);
			}
		     }
		     {	/* Cfa/cinfo.scm 67 */
			atom_cinfo_155_bglt arg2587_2655;
			{	/* Cfa/cinfo.scm 67 */
			   atom_cinfo_155_bglt res2759_4565;
			   {	/* Cfa/cinfo.scm 67 */
			      approx_bglt approx_4562;
			      {		/* Cfa/cinfo.scm 67 */
				 obj_t aux_9944;
				 aux_9944 =
				    STRUCT_REF(aux1659_2652, ((long) 0));
				 approx_4562 =
				    (approx_bglt) (aux_9944);
			      }
			      {		/* Cfa/cinfo.scm 67 */
				 atom_cinfo_155_bglt new1649_4563;
				 new1649_4563 =
				    ((atom_cinfo_155_bglt) BREF(GC_MALLOC(sizeof(struct atom_cinfo_155))));
				 ((((atom_cinfo_155_bglt) CREF(new1649_4563))->approx) = ((approx_bglt) approx_4562), BUNSPEC);
				 res2759_4565 = new1649_4563;
			      }
			   }
			   arg2587_2655 = res2759_4565;
			}
			{	/* Cfa/cinfo.scm 67 */
			   obj_t aux_9951;
			   object_bglt aux_9949;
			   aux_9951 =
			      (obj_t) (arg2587_2655);
			   aux_9949 =
			      (object_bglt) (new1660_2653);
			   OBJECT_WIDENING_SET(aux_9949, aux_9951);
			}
		     }
		     aux_9926 = new1660_2653;
		  }
	       }
	    }
	    return
	       (obj_t) (aux_9926);
	 }
      }
   }
}



/* object->struct-atom/cinfo2050 */
obj_t 
object__struct_atom_cinfo2050_53_cfa_info(obj_t env_6151, obj_t obj1655_6152)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 67 */
      {
	 atom_cinfo_155_bglt obj1655_2637;
	 obj1655_2637 =
	    (atom_cinfo_155_bglt) (obj1655_6152);
	 {

	    {	/* Cfa/cinfo.scm 67 */
	       obj_t res1656_2640;
	       {	/* Cfa/cinfo.scm 67 */
		  obj_t next_method2049_249_2645;
		  next_method2049_249_2645 =
		     find_super_class_method_167___object(
		     (object_bglt) (obj1655_2637), object__struct_env_210___object, atom_cinfo_155_cfa_info);
		  if (
		     PROCEDUREP(next_method2049_249_2645))
		    {	/* Cfa/cinfo.scm 67 */
		       res1656_2640 =
			  PROCEDURE_ENTRY(next_method2049_249_2645) (next_method2049_249_2645,
			  (obj_t) (obj1655_2637), BEOA);
		    }
		  else
		    {	/* Cfa/cinfo.scm 67 */
		       PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2049_249_2645);
		       res1656_2640 =
			  object__struct_50___object(
			  (object_bglt) (obj1655_2637));
		    }
	       }
	       {	/* Cfa/cinfo.scm 67 */
		  obj_t aux1657_2641;
		  {	/* ./Llib/struct.scm 1415 */
		     obj_t aux_9966;
		     aux_9966 =
			CNST_TABLE_REF(((long) 11));
		     aux1657_2641 =
			make_struct(aux_9966, ((long) 1), BUNSPEC);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_9969;
		     {	/* Cfa/cinfo.scm 67 */
			approx_bglt aux_9970;
			{
			   obj_t aux_9971;
			   {	/* Cfa/cinfo.scm 67 */
			      object_bglt aux_9972;
			      aux_9972 =
				 (object_bglt) (obj1655_2637);
			      aux_9971 =
				 OBJECT_WIDENING(aux_9972);
			   }
			   aux_9970 =
			      (((atom_cinfo_155_bglt) CREF(aux_9971))->approx);
			}
			aux_9969 =
			   (obj_t) (aux_9970);
		     }
		     STRUCT_SET(aux1657_2641, ((long) 0), aux_9969);
		  }
		  STRUCT_SET(res1656_2640, ((long) 0), aux1657_2641);
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_9979;
		     aux_9979 =
			STRUCT_KEY(res1656_2640);
		     STRUCT_KEY_SET(aux1657_2641, aux_9979);
		  }
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_9982;
		     aux_9982 =
			CNST_TABLE_REF(((long) 11));
		     STRUCT_KEY_SET(res1656_2640, aux_9982);
		  }
		  return res1656_2640;
	       }
	    }
	 }
      }
   }
}



/* struct+object->object-kwote/node2048 */
obj_t 
struct_object__object_kwote_node2048_129_cfa_info(obj_t env_6153, obj_t o_6154, obj_t s_6155)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 68 */
      {
	 kwote_node_102_bglt o_2625;
	 obj_t s_2626;
	 {	/* Cfa/cinfo.scm 68 */
	    kwote_node_102_bglt aux_9986;
	    o_2625 =
	       (kwote_node_102_bglt) (o_6154);
	    s_2626 = s_6155;
	    {

	       {	/* Cfa/cinfo.scm 68 */
		  obj_t old1671_2629;
		  obj_t aux1672_2630;
		  {	/* Cfa/cinfo.scm 68 */
		     obj_t next_method2047_231_2635;
		     next_method2047_231_2635 =
			find_super_class_method_167___object(
			(object_bglt) (o_2625), struct_object__object_env_209___object, kwote_node_102_cfa_info);
		     if (
			PROCEDUREP(next_method2047_231_2635))
		       {	/* Cfa/cinfo.scm 68 */
			  old1671_2629 =
			     PROCEDURE_ENTRY(next_method2047_231_2635) (next_method2047_231_2635,
			     (obj_t) (o_2625), s_2626, BEOA);
		       }
		     else
		       {	/* Cfa/cinfo.scm 68 */
			  PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2047_231_2635);
			  {	/* Cfa/cinfo.scm 68 */
			     object_bglt aux_9995;
			     aux_9995 =
				struct_object__object_93___object(
				(object_bglt) (o_2625), s_2626);
			     old1671_2629 =
				(obj_t) (aux_9995);
			  }
		       }
		  }
		  aux1672_2630 =
		     STRUCT_REF(s_2626, ((long) 0));
		  {	/* Cfa/cinfo.scm 68 */
		     kwote_node_102_bglt new1673_2631;
		     new1673_2631 =
			((kwote_node_102_bglt) (old1671_2629));
		     {	/* Cfa/cinfo.scm 68 */
			long arg2578_2632;
			arg2578_2632 =
			   class_num_218___object(kwote_node_102_cfa_info);
			{	/* Cfa/cinfo.scm 68 */
			   obj_t obj_4529;
			   obj_4529 =
			      (obj_t) (new1673_2631);
			   (((obj_t) CREF(obj_4529))->header = MAKE_HEADER(arg2578_2632, 0), BUNSPEC);
			}
		     }
		     {	/* Cfa/cinfo.scm 68 */
			kwote_node_102_bglt arg2579_2633;
			{	/* Cfa/cinfo.scm 68 */
			   kwote_node_102_bglt res2758_4536;
			   {	/* Cfa/cinfo.scm 68 */
			      node_bglt node_4533;
			      {		/* Cfa/cinfo.scm 68 */
				 obj_t aux_10004;
				 aux_10004 =
				    STRUCT_REF(aux1672_2630, ((long) 0));
				 node_4533 =
				    (node_bglt) (aux_10004);
			      }
			      {		/* Cfa/cinfo.scm 68 */
				 kwote_node_102_bglt new1662_4534;
				 new1662_4534 =
				    ((kwote_node_102_bglt) BREF(GC_MALLOC(sizeof(struct kwote_node_102))));
				 ((((kwote_node_102_bglt) CREF(new1662_4534))->node) = ((node_bglt) node_4533), BUNSPEC);
				 res2758_4536 = new1662_4534;
			      }
			   }
			   arg2579_2633 = res2758_4536;
			}
			{	/* Cfa/cinfo.scm 68 */
			   obj_t aux_10011;
			   object_bglt aux_10009;
			   aux_10011 =
			      (obj_t) (arg2579_2633);
			   aux_10009 =
			      (object_bglt) (new1673_2631);
			   OBJECT_WIDENING_SET(aux_10009, aux_10011);
			}
		     }
		     aux_9986 = new1673_2631;
		  }
	       }
	    }
	    return
	       (obj_t) (aux_9986);
	 }
      }
   }
}



/* object->struct-kwote/node2046 */
obj_t 
object__struct_kwote_node2046_198_cfa_info(obj_t env_6156, obj_t obj1668_6157)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 68 */
      {
	 kwote_node_102_bglt obj1668_2615;
	 obj1668_2615 =
	    (kwote_node_102_bglt) (obj1668_6157);
	 {

	    {	/* Cfa/cinfo.scm 68 */
	       obj_t res1669_2618;
	       {	/* Cfa/cinfo.scm 68 */
		  obj_t next_method2045_19_2623;
		  next_method2045_19_2623 =
		     find_super_class_method_167___object(
		     (object_bglt) (obj1668_2615), object__struct_env_210___object, kwote_node_102_cfa_info);
		  if (
		     PROCEDUREP(next_method2045_19_2623))
		    {	/* Cfa/cinfo.scm 68 */
		       res1669_2618 =
			  PROCEDURE_ENTRY(next_method2045_19_2623) (next_method2045_19_2623,
			  (obj_t) (obj1668_2615), BEOA);
		    }
		  else
		    {	/* Cfa/cinfo.scm 68 */
		       PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2045_19_2623);
		       res1669_2618 =
			  object__struct_50___object(
			  (object_bglt) (obj1668_2615));
		    }
	       }
	       {	/* Cfa/cinfo.scm 68 */
		  obj_t aux1670_2619;
		  {	/* ./Llib/struct.scm 1415 */
		     obj_t aux_10026;
		     aux_10026 =
			CNST_TABLE_REF(((long) 12));
		     aux1670_2619 =
			make_struct(aux_10026, ((long) 1), BUNSPEC);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_10029;
		     {	/* Cfa/cinfo.scm 68 */
			node_bglt aux_10030;
			{
			   obj_t aux_10031;
			   {	/* Cfa/cinfo.scm 68 */
			      object_bglt aux_10032;
			      aux_10032 =
				 (object_bglt) (obj1668_2615);
			      aux_10031 =
				 OBJECT_WIDENING(aux_10032);
			   }
			   aux_10030 =
			      (((kwote_node_102_bglt) CREF(aux_10031))->node);
			}
			aux_10029 =
			   (obj_t) (aux_10030);
		     }
		     STRUCT_SET(aux1670_2619, ((long) 0), aux_10029);
		  }
		  STRUCT_SET(res1669_2618, ((long) 0), aux1670_2619);
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_10039;
		     aux_10039 =
			STRUCT_KEY(res1669_2618);
		     STRUCT_KEY_SET(aux1670_2619, aux_10039);
		  }
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_10042;
		     aux_10042 =
			CNST_TABLE_REF(((long) 12));
		     STRUCT_KEY_SET(res1669_2618, aux_10042);
		  }
		  return res1669_2618;
	       }
	    }
	 }
      }
   }
}



/* struct+object->object-kwote/cinfo2044 */
obj_t 
struct_object__object_kwote_cinfo2044_93_cfa_info(obj_t env_6158, obj_t o_6159, obj_t s_6160)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 69 */
      {
	 kwote_cinfo_48_bglt o_2603;
	 obj_t s_2604;
	 {	/* Cfa/cinfo.scm 69 */
	    kwote_cinfo_48_bglt aux_10046;
	    o_2603 =
	       (kwote_cinfo_48_bglt) (o_6159);
	    s_2604 = s_6160;
	    {

	       {	/* Cfa/cinfo.scm 69 */
		  obj_t old1684_2607;
		  obj_t aux1685_2608;
		  {	/* Cfa/cinfo.scm 69 */
		     obj_t next_method2043_217_2613;
		     next_method2043_217_2613 =
			find_super_class_method_167___object(
			(object_bglt) (o_2603), struct_object__object_env_209___object, kwote_cinfo_48_cfa_info);
		     if (
			PROCEDUREP(next_method2043_217_2613))
		       {	/* Cfa/cinfo.scm 69 */
			  old1684_2607 =
			     PROCEDURE_ENTRY(next_method2043_217_2613) (next_method2043_217_2613,
			     (obj_t) (o_2603), s_2604, BEOA);
		       }
		     else
		       {	/* Cfa/cinfo.scm 69 */
			  PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2043_217_2613);
			  {	/* Cfa/cinfo.scm 69 */
			     object_bglt aux_10055;
			     aux_10055 =
				struct_object__object_93___object(
				(object_bglt) (o_2603), s_2604);
			     old1684_2607 =
				(obj_t) (aux_10055);
			  }
		       }
		  }
		  aux1685_2608 =
		     STRUCT_REF(s_2604, ((long) 0));
		  {	/* Cfa/cinfo.scm 69 */
		     kwote_cinfo_48_bglt new1686_2609;
		     new1686_2609 =
			((kwote_cinfo_48_bglt) (old1684_2607));
		     {	/* Cfa/cinfo.scm 69 */
			long arg2570_2610;
			arg2570_2610 =
			   class_num_218___object(kwote_cinfo_48_cfa_info);
			{	/* Cfa/cinfo.scm 69 */
			   obj_t obj_4500;
			   obj_4500 =
			      (obj_t) (new1686_2609);
			   (((obj_t) CREF(obj_4500))->header = MAKE_HEADER(arg2570_2610, 0), BUNSPEC);
			}
		     }
		     {	/* Cfa/cinfo.scm 69 */
			kwote_cinfo_48_bglt arg2571_2611;
			{	/* Cfa/cinfo.scm 69 */
			   kwote_cinfo_48_bglt res2757_4507;
			   {	/* Cfa/cinfo.scm 69 */
			      approx_bglt approx_4504;
			      {		/* Cfa/cinfo.scm 69 */
				 obj_t aux_10064;
				 aux_10064 =
				    STRUCT_REF(aux1685_2608, ((long) 0));
				 approx_4504 =
				    (approx_bglt) (aux_10064);
			      }
			      {		/* Cfa/cinfo.scm 69 */
				 kwote_cinfo_48_bglt new1675_4505;
				 new1675_4505 =
				    ((kwote_cinfo_48_bglt) BREF(GC_MALLOC(sizeof(struct kwote_cinfo_48))));
				 ((((kwote_cinfo_48_bglt) CREF(new1675_4505))->approx) = ((approx_bglt) approx_4504), BUNSPEC);
				 res2757_4507 = new1675_4505;
			      }
			   }
			   arg2571_2611 = res2757_4507;
			}
			{	/* Cfa/cinfo.scm 69 */
			   obj_t aux_10071;
			   object_bglt aux_10069;
			   aux_10071 =
			      (obj_t) (arg2571_2611);
			   aux_10069 =
			      (object_bglt) (new1686_2609);
			   OBJECT_WIDENING_SET(aux_10069, aux_10071);
			}
		     }
		     aux_10046 = new1686_2609;
		  }
	       }
	    }
	    return
	       (obj_t) (aux_10046);
	 }
      }
   }
}



/* object->struct-kwote/cinfo2042 */
obj_t 
object__struct_kwote_cinfo2042_186_cfa_info(obj_t env_6161, obj_t obj1681_6162)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 69 */
      {
	 kwote_cinfo_48_bglt obj1681_2593;
	 obj1681_2593 =
	    (kwote_cinfo_48_bglt) (obj1681_6162);
	 {

	    {	/* Cfa/cinfo.scm 69 */
	       obj_t res1682_2596;
	       {	/* Cfa/cinfo.scm 69 */
		  obj_t next_method2041_129_2601;
		  next_method2041_129_2601 =
		     find_super_class_method_167___object(
		     (object_bglt) (obj1681_2593), object__struct_env_210___object, kwote_cinfo_48_cfa_info);
		  if (
		     PROCEDUREP(next_method2041_129_2601))
		    {	/* Cfa/cinfo.scm 69 */
		       res1682_2596 =
			  PROCEDURE_ENTRY(next_method2041_129_2601) (next_method2041_129_2601,
			  (obj_t) (obj1681_2593), BEOA);
		    }
		  else
		    {	/* Cfa/cinfo.scm 69 */
		       PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2041_129_2601);
		       res1682_2596 =
			  object__struct_50___object(
			  (object_bglt) (obj1681_2593));
		    }
	       }
	       {	/* Cfa/cinfo.scm 69 */
		  obj_t aux1683_2597;
		  {	/* ./Llib/struct.scm 1415 */
		     obj_t aux_10086;
		     aux_10086 =
			CNST_TABLE_REF(((long) 13));
		     aux1683_2597 =
			make_struct(aux_10086, ((long) 1), BUNSPEC);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_10089;
		     {	/* Cfa/cinfo.scm 69 */
			approx_bglt aux_10090;
			{
			   obj_t aux_10091;
			   {	/* Cfa/cinfo.scm 69 */
			      object_bglt aux_10092;
			      aux_10092 =
				 (object_bglt) (obj1681_2593);
			      aux_10091 =
				 OBJECT_WIDENING(aux_10092);
			   }
			   aux_10090 =
			      (((kwote_cinfo_48_bglt) CREF(aux_10091))->approx);
			}
			aux_10089 =
			   (obj_t) (aux_10090);
		     }
		     STRUCT_SET(aux1683_2597, ((long) 0), aux_10089);
		  }
		  STRUCT_SET(res1682_2596, ((long) 0), aux1683_2597);
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_10099;
		     aux_10099 =
			STRUCT_KEY(res1682_2596);
		     STRUCT_KEY_SET(aux1683_2597, aux_10099);
		  }
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_10102;
		     aux_10102 =
			CNST_TABLE_REF(((long) 13));
		     STRUCT_KEY_SET(res1682_2596, aux_10102);
		  }
		  return res1682_2596;
	       }
	    }
	 }
      }
   }
}



/* struct+object->object-app-ly/cinfo2040 */
obj_t 
struct_object__object_app_ly_cinfo2040_212_cfa_info(obj_t env_6163, obj_t o_6164, obj_t s_6165)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 70 */
      {
	 app_ly_cinfo_234_bglt o_2581;
	 obj_t s_2582;
	 {	/* Cfa/cinfo.scm 70 */
	    app_ly_cinfo_234_bglt aux_10106;
	    o_2581 =
	       (app_ly_cinfo_234_bglt) (o_6164);
	    s_2582 = s_6165;
	    {

	       {	/* Cfa/cinfo.scm 70 */
		  obj_t old1699_2585;
		  obj_t aux1700_2586;
		  {	/* Cfa/cinfo.scm 70 */
		     obj_t next_method2039_226_2591;
		     next_method2039_226_2591 =
			find_super_class_method_167___object(
			(object_bglt) (o_2581), struct_object__object_env_209___object, app_ly_cinfo_234_cfa_info);
		     if (
			PROCEDUREP(next_method2039_226_2591))
		       {	/* Cfa/cinfo.scm 70 */
			  old1699_2585 =
			     PROCEDURE_ENTRY(next_method2039_226_2591) (next_method2039_226_2591,
			     (obj_t) (o_2581), s_2582, BEOA);
		       }
		     else
		       {	/* Cfa/cinfo.scm 70 */
			  PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2039_226_2591);
			  {	/* Cfa/cinfo.scm 70 */
			     object_bglt aux_10115;
			     aux_10115 =
				struct_object__object_93___object(
				(object_bglt) (o_2581), s_2582);
			     old1699_2585 =
				(obj_t) (aux_10115);
			  }
		       }
		  }
		  aux1700_2586 =
		     STRUCT_REF(s_2582, ((long) 0));
		  {	/* Cfa/cinfo.scm 70 */
		     app_ly_cinfo_234_bglt new1701_2587;
		     new1701_2587 =
			((app_ly_cinfo_234_bglt) (old1699_2585));
		     {	/* Cfa/cinfo.scm 70 */
			long arg2562_2588;
			arg2562_2588 =
			   class_num_218___object(app_ly_cinfo_234_cfa_info);
			{	/* Cfa/cinfo.scm 70 */
			   obj_t obj_4471;
			   obj_4471 =
			      (obj_t) (new1701_2587);
			   (((obj_t) CREF(obj_4471))->header = MAKE_HEADER(arg2562_2588, 0), BUNSPEC);
			}
		     }
		     {	/* Cfa/cinfo.scm 70 */
			app_ly_cinfo_234_bglt arg2563_2589;
			{	/* Cfa/cinfo.scm 70 */
			   app_ly_cinfo_234_bglt res2756_4478;
			   {	/* Cfa/cinfo.scm 70 */
			      approx_bglt approx_4475;
			      {		/* Cfa/cinfo.scm 70 */
				 obj_t aux_10124;
				 aux_10124 =
				    STRUCT_REF(aux1700_2586, ((long) 0));
				 approx_4475 =
				    (approx_bglt) (aux_10124);
			      }
			      {		/* Cfa/cinfo.scm 70 */
				 app_ly_cinfo_234_bglt new1690_4476;
				 new1690_4476 =
				    ((app_ly_cinfo_234_bglt) BREF(GC_MALLOC(sizeof(struct app_ly_cinfo_234))));
				 ((((app_ly_cinfo_234_bglt) CREF(new1690_4476))->approx) = ((approx_bglt) approx_4475), BUNSPEC);
				 res2756_4478 = new1690_4476;
			      }
			   }
			   arg2563_2589 = res2756_4478;
			}
			{	/* Cfa/cinfo.scm 70 */
			   obj_t aux_10131;
			   object_bglt aux_10129;
			   aux_10131 =
			      (obj_t) (arg2563_2589);
			   aux_10129 =
			      (object_bglt) (new1701_2587);
			   OBJECT_WIDENING_SET(aux_10129, aux_10131);
			}
		     }
		     aux_10106 = new1701_2587;
		  }
	       }
	    }
	    return
	       (obj_t) (aux_10106);
	 }
      }
   }
}



/* object->struct-app-ly/cinfo2038 */
obj_t 
object__struct_app_ly_cinfo2038_18_cfa_info(obj_t env_6166, obj_t obj1696_6167)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 70 */
      {
	 app_ly_cinfo_234_bglt obj1696_2571;
	 obj1696_2571 =
	    (app_ly_cinfo_234_bglt) (obj1696_6167);
	 {

	    {	/* Cfa/cinfo.scm 70 */
	       obj_t res1697_2574;
	       {	/* Cfa/cinfo.scm 70 */
		  obj_t next_method2037_43_2579;
		  next_method2037_43_2579 =
		     find_super_class_method_167___object(
		     (object_bglt) (obj1696_2571), object__struct_env_210___object, app_ly_cinfo_234_cfa_info);
		  if (
		     PROCEDUREP(next_method2037_43_2579))
		    {	/* Cfa/cinfo.scm 70 */
		       res1697_2574 =
			  PROCEDURE_ENTRY(next_method2037_43_2579) (next_method2037_43_2579,
			  (obj_t) (obj1696_2571), BEOA);
		    }
		  else
		    {	/* Cfa/cinfo.scm 70 */
		       PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2037_43_2579);
		       res1697_2574 =
			  object__struct_50___object(
			  (object_bglt) (obj1696_2571));
		    }
	       }
	       {	/* Cfa/cinfo.scm 70 */
		  obj_t aux1698_2575;
		  {	/* ./Llib/struct.scm 1415 */
		     obj_t aux_10146;
		     aux_10146 =
			CNST_TABLE_REF(((long) 14));
		     aux1698_2575 =
			make_struct(aux_10146, ((long) 1), BUNSPEC);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_10149;
		     {	/* Cfa/cinfo.scm 70 */
			approx_bglt aux_10150;
			{
			   obj_t aux_10151;
			   {	/* Cfa/cinfo.scm 70 */
			      object_bglt aux_10152;
			      aux_10152 =
				 (object_bglt) (obj1696_2571);
			      aux_10151 =
				 OBJECT_WIDENING(aux_10152);
			   }
			   aux_10150 =
			      (((app_ly_cinfo_234_bglt) CREF(aux_10151))->approx);
			}
			aux_10149 =
			   (obj_t) (aux_10150);
		     }
		     STRUCT_SET(aux1698_2575, ((long) 0), aux_10149);
		  }
		  STRUCT_SET(res1697_2574, ((long) 0), aux1698_2575);
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_10159;
		     aux_10159 =
			STRUCT_KEY(res1697_2574);
		     STRUCT_KEY_SET(aux1698_2575, aux_10159);
		  }
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_10162;
		     aux_10162 =
			CNST_TABLE_REF(((long) 14));
		     STRUCT_KEY_SET(res1697_2574, aux_10162);
		  }
		  return res1697_2574;
	       }
	    }
	 }
      }
   }
}



/* struct+object->object-funcall/cinfo2036 */
obj_t 
struct_object__object_funcall_cinfo2036_168_cfa_info(obj_t env_6168, obj_t o_6169, obj_t s_6170)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 71 */
      {
	 funcall_cinfo_75_bglt o_2556;
	 obj_t s_2557;
	 {	/* Cfa/cinfo.scm 71 */
	    funcall_cinfo_75_bglt aux_10166;
	    o_2556 =
	       (funcall_cinfo_75_bglt) (o_6169);
	    s_2557 = s_6170;
	    {

	       {	/* Cfa/cinfo.scm 71 */
		  obj_t old1720_2560;
		  obj_t aux1721_2561;
		  {	/* Cfa/cinfo.scm 71 */
		     obj_t next_method2035_204_2569;
		     next_method2035_204_2569 =
			find_super_class_method_167___object(
			(object_bglt) (o_2556), struct_object__object_env_209___object, funcall_cinfo_75_cfa_info);
		     if (
			PROCEDUREP(next_method2035_204_2569))
		       {	/* Cfa/cinfo.scm 71 */
			  old1720_2560 =
			     PROCEDURE_ENTRY(next_method2035_204_2569) (next_method2035_204_2569,
			     (obj_t) (o_2556), s_2557, BEOA);
		       }
		     else
		       {	/* Cfa/cinfo.scm 71 */
			  PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2035_204_2569);
			  {	/* Cfa/cinfo.scm 71 */
			     object_bglt aux_10175;
			     aux_10175 =
				struct_object__object_93___object(
				(object_bglt) (o_2556), s_2557);
			     old1720_2560 =
				(obj_t) (aux_10175);
			  }
		       }
		  }
		  aux1721_2561 =
		     STRUCT_REF(s_2557, ((long) 0));
		  {	/* Cfa/cinfo.scm 71 */
		     funcall_cinfo_75_bglt new1722_2562;
		     new1722_2562 =
			((funcall_cinfo_75_bglt) (old1720_2560));
		     {	/* Cfa/cinfo.scm 71 */
			long arg2551_2563;
			arg2551_2563 =
			   class_num_218___object(funcall_cinfo_75_cfa_info);
			{	/* Cfa/cinfo.scm 71 */
			   obj_t obj_4430;
			   obj_4430 =
			      (obj_t) (new1722_2562);
			   (((obj_t) CREF(obj_4430))->header = MAKE_HEADER(arg2551_2563, 0), BUNSPEC);
			}
		     }
		     {	/* Cfa/cinfo.scm 71 */
			funcall_cinfo_75_bglt arg2552_2564;
			{	/* Cfa/cinfo.scm 71 */
			   funcall_cinfo_75_bglt res2755_4449;
			   {	/* Cfa/cinfo.scm 71 */
			      approx_bglt approx_4440;
			      approx_bglt va_approx_63_4441;
			      bool_t arity_error_noticed__118_4442;
			      bool_t type_error_noticed__36_4443;
			      {		/* Cfa/cinfo.scm 71 */
				 obj_t aux_10184;
				 aux_10184 =
				    STRUCT_REF(aux1721_2561, ((long) 0));
				 approx_4440 =
				    (approx_bglt) (aux_10184);
			      }
			      {		/* Cfa/cinfo.scm 71 */
				 obj_t aux_10187;
				 aux_10187 =
				    STRUCT_REF(aux1721_2561, ((long) 1));
				 va_approx_63_4441 =
				    (approx_bglt) (aux_10187);
			      }
			      {		/* Cfa/cinfo.scm 71 */
				 obj_t aux_10190;
				 aux_10190 =
				    STRUCT_REF(aux1721_2561, ((long) 2));
				 arity_error_noticed__118_4442 =
				    CBOOL(aux_10190);
			      }
			      {		/* Cfa/cinfo.scm 71 */
				 obj_t aux_10193;
				 aux_10193 =
				    STRUCT_REF(aux1721_2561, ((long) 3));
				 type_error_noticed__36_4443 =
				    CBOOL(aux_10193);
			      }
			      {		/* Cfa/cinfo.scm 71 */
				 funcall_cinfo_75_bglt new1708_4444;
				 new1708_4444 =
				    ((funcall_cinfo_75_bglt) BREF(GC_MALLOC(sizeof(struct funcall_cinfo_75))));
				 ((((funcall_cinfo_75_bglt) CREF(new1708_4444))->approx) = ((approx_bglt) approx_4440), BUNSPEC);
				 ((((funcall_cinfo_75_bglt) CREF(new1708_4444))->va_approx_63) = ((approx_bglt) va_approx_63_4441), BUNSPEC);
				 ((((funcall_cinfo_75_bglt) CREF(new1708_4444))->arity_error_noticed__118) = ((bool_t) arity_error_noticed__118_4442), BUNSPEC);
				 ((((funcall_cinfo_75_bglt) CREF(new1708_4444))->type_error_noticed__36) = ((bool_t) type_error_noticed__36_4443), BUNSPEC);
				 res2755_4449 = new1708_4444;
			      }
			   }
			   arg2552_2564 = res2755_4449;
			}
			{	/* Cfa/cinfo.scm 71 */
			   obj_t aux_10203;
			   object_bglt aux_10201;
			   aux_10203 =
			      (obj_t) (arg2552_2564);
			   aux_10201 =
			      (object_bglt) (new1722_2562);
			   OBJECT_WIDENING_SET(aux_10201, aux_10203);
			}
		     }
		     aux_10166 = new1722_2562;
		  }
	       }
	    }
	    return
	       (obj_t) (aux_10166);
	 }
      }
   }
}



/* object->struct-funcall/cinfo2034 */
obj_t 
object__struct_funcall_cinfo2034_224_cfa_info(obj_t env_6171, obj_t obj1717_6172)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 71 */
      {
	 funcall_cinfo_75_bglt obj1717_2540;
	 obj1717_2540 =
	    (funcall_cinfo_75_bglt) (obj1717_6172);
	 {

	    {	/* Cfa/cinfo.scm 71 */
	       obj_t res1718_2543;
	       {	/* Cfa/cinfo.scm 71 */
		  obj_t next_method2033_212_2554;
		  next_method2033_212_2554 =
		     find_super_class_method_167___object(
		     (object_bglt) (obj1717_2540), object__struct_env_210___object, funcall_cinfo_75_cfa_info);
		  if (
		     PROCEDUREP(next_method2033_212_2554))
		    {	/* Cfa/cinfo.scm 71 */
		       res1718_2543 =
			  PROCEDURE_ENTRY(next_method2033_212_2554) (next_method2033_212_2554,
			  (obj_t) (obj1717_2540), BEOA);
		    }
		  else
		    {	/* Cfa/cinfo.scm 71 */
		       PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2033_212_2554);
		       res1718_2543 =
			  object__struct_50___object(
			  (object_bglt) (obj1717_2540));
		    }
	       }
	       {	/* Cfa/cinfo.scm 71 */
		  obj_t aux1719_2544;
		  {	/* ./Llib/struct.scm 1415 */
		     obj_t aux_10218;
		     aux_10218 =
			CNST_TABLE_REF(((long) 15));
		     aux1719_2544 =
			make_struct(aux_10218, ((long) 4), BUNSPEC);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_10221;
		     {	/* Cfa/cinfo.scm 71 */
			approx_bglt aux_10222;
			{
			   obj_t aux_10223;
			   {	/* Cfa/cinfo.scm 72 */
			      object_bglt aux_10224;
			      aux_10224 =
				 (object_bglt) (obj1717_2540);
			      aux_10223 =
				 OBJECT_WIDENING(aux_10224);
			   }
			   aux_10222 =
			      (((funcall_cinfo_75_bglt) CREF(aux_10223))->approx);
			}
			aux_10221 =
			   (obj_t) (aux_10222);
		     }
		     STRUCT_SET(aux1719_2544, ((long) 0), aux_10221);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_10230;
		     {	/* Cfa/cinfo.scm 71 */
			approx_bglt aux_10231;
			{
			   obj_t aux_10232;
			   {	/* Cfa/cinfo.scm 73 */
			      object_bglt aux_10233;
			      aux_10233 =
				 (object_bglt) (obj1717_2540);
			      aux_10232 =
				 OBJECT_WIDENING(aux_10233);
			   }
			   aux_10231 =
			      (((funcall_cinfo_75_bglt) CREF(aux_10232))->va_approx_63);
			}
			aux_10230 =
			   (obj_t) (aux_10231);
		     }
		     STRUCT_SET(aux1719_2544, ((long) 1), aux_10230);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_10239;
		     {	/* Cfa/cinfo.scm 71 */
			bool_t aux_10240;
			{
			   obj_t aux_10241;
			   {	/* Cfa/cinfo.scm 74 */
			      object_bglt aux_10242;
			      aux_10242 =
				 (object_bglt) (obj1717_2540);
			      aux_10241 =
				 OBJECT_WIDENING(aux_10242);
			   }
			   aux_10240 =
			      (((funcall_cinfo_75_bglt) CREF(aux_10241))->arity_error_noticed__118);
			}
			aux_10239 =
			   BBOOL(aux_10240);
		     }
		     STRUCT_SET(aux1719_2544, ((long) 2), aux_10239);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_10248;
		     {	/* Cfa/cinfo.scm 71 */
			bool_t aux_10249;
			{
			   obj_t aux_10250;
			   {	/* Cfa/cinfo.scm 75 */
			      object_bglt aux_10251;
			      aux_10251 =
				 (object_bglt) (obj1717_2540);
			      aux_10250 =
				 OBJECT_WIDENING(aux_10251);
			   }
			   aux_10249 =
			      (((funcall_cinfo_75_bglt) CREF(aux_10250))->type_error_noticed__36);
			}
			aux_10248 =
			   BBOOL(aux_10249);
		     }
		     STRUCT_SET(aux1719_2544, ((long) 3), aux_10248);
		  }
		  STRUCT_SET(res1718_2543, ((long) 0), aux1719_2544);
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_10258;
		     aux_10258 =
			STRUCT_KEY(res1718_2543);
		     STRUCT_KEY_SET(aux1719_2544, aux_10258);
		  }
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_10261;
		     aux_10261 =
			CNST_TABLE_REF(((long) 15));
		     STRUCT_KEY_SET(res1718_2543, aux_10261);
		  }
		  return res1718_2543;
	       }
	    }
	 }
      }
   }
}



/* struct+object->object-pragma/cinfo2032 */
obj_t 
struct_object__object_pragma_cinfo2032_204_cfa_info(obj_t env_6173, obj_t o_6174, obj_t s_6175)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 76 */
      {
	 pragma_cinfo_220_bglt o_2528;
	 obj_t s_2529;
	 {	/* Cfa/cinfo.scm 76 */
	    pragma_cinfo_220_bglt aux_10265;
	    o_2528 =
	       (pragma_cinfo_220_bglt) (o_6174);
	    s_2529 = s_6175;
	    {

	       {	/* Cfa/cinfo.scm 76 */
		  obj_t old1736_2532;
		  obj_t aux1737_2533;
		  {	/* Cfa/cinfo.scm 76 */
		     obj_t next_method2031_220_2538;
		     next_method2031_220_2538 =
			find_super_class_method_167___object(
			(object_bglt) (o_2528), struct_object__object_env_209___object, pragma_cinfo_220_cfa_info);
		     if (
			PROCEDUREP(next_method2031_220_2538))
		       {	/* Cfa/cinfo.scm 76 */
			  old1736_2532 =
			     PROCEDURE_ENTRY(next_method2031_220_2538) (next_method2031_220_2538,
			     (obj_t) (o_2528), s_2529, BEOA);
		       }
		     else
		       {	/* Cfa/cinfo.scm 76 */
			  PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2031_220_2538);
			  {	/* Cfa/cinfo.scm 76 */
			     object_bglt aux_10274;
			     aux_10274 =
				struct_object__object_93___object(
				(object_bglt) (o_2528), s_2529);
			     old1736_2532 =
				(obj_t) (aux_10274);
			  }
		       }
		  }
		  aux1737_2533 =
		     STRUCT_REF(s_2529, ((long) 0));
		  {	/* Cfa/cinfo.scm 76 */
		     pragma_cinfo_220_bglt new1738_2534;
		     new1738_2534 =
			((pragma_cinfo_220_bglt) (old1736_2532));
		     {	/* Cfa/cinfo.scm 76 */
			long arg2537_2535;
			arg2537_2535 =
			   class_num_218___object(pragma_cinfo_220_cfa_info);
			{	/* Cfa/cinfo.scm 76 */
			   obj_t obj_4389;
			   obj_4389 =
			      (obj_t) (new1738_2534);
			   (((obj_t) CREF(obj_4389))->header = MAKE_HEADER(arg2537_2535, 0), BUNSPEC);
			}
		     }
		     {	/* Cfa/cinfo.scm 76 */
			pragma_cinfo_220_bglt arg2538_2536;
			{	/* Cfa/cinfo.scm 76 */
			   pragma_cinfo_220_bglt res2754_4396;
			   {	/* Cfa/cinfo.scm 76 */
			      approx_bglt approx_4393;
			      {		/* Cfa/cinfo.scm 76 */
				 obj_t aux_10283;
				 aux_10283 =
				    STRUCT_REF(aux1737_2533, ((long) 0));
				 approx_4393 =
				    (approx_bglt) (aux_10283);
			      }
			      {		/* Cfa/cinfo.scm 76 */
				 pragma_cinfo_220_bglt new1727_4394;
				 new1727_4394 =
				    ((pragma_cinfo_220_bglt) BREF(GC_MALLOC(sizeof(struct pragma_cinfo_220))));
				 ((((pragma_cinfo_220_bglt) CREF(new1727_4394))->approx) = ((approx_bglt) approx_4393), BUNSPEC);
				 res2754_4396 = new1727_4394;
			      }
			   }
			   arg2538_2536 = res2754_4396;
			}
			{	/* Cfa/cinfo.scm 76 */
			   obj_t aux_10290;
			   object_bglt aux_10288;
			   aux_10290 =
			      (obj_t) (arg2538_2536);
			   aux_10288 =
			      (object_bglt) (new1738_2534);
			   OBJECT_WIDENING_SET(aux_10288, aux_10290);
			}
		     }
		     aux_10265 = new1738_2534;
		  }
	       }
	    }
	    return
	       (obj_t) (aux_10265);
	 }
      }
   }
}



/* object->struct-pragma/cinfo2030 */
obj_t 
object__struct_pragma_cinfo2030_152_cfa_info(obj_t env_6176, obj_t obj1733_6177)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 76 */
      {
	 pragma_cinfo_220_bglt obj1733_2518;
	 obj1733_2518 =
	    (pragma_cinfo_220_bglt) (obj1733_6177);
	 {

	    {	/* Cfa/cinfo.scm 76 */
	       obj_t res1734_2521;
	       {	/* Cfa/cinfo.scm 76 */
		  obj_t next_method2029_6_2526;
		  next_method2029_6_2526 =
		     find_super_class_method_167___object(
		     (object_bglt) (obj1733_2518), object__struct_env_210___object, pragma_cinfo_220_cfa_info);
		  if (
		     PROCEDUREP(next_method2029_6_2526))
		    {	/* Cfa/cinfo.scm 76 */
		       res1734_2521 =
			  PROCEDURE_ENTRY(next_method2029_6_2526) (next_method2029_6_2526,
			  (obj_t) (obj1733_2518), BEOA);
		    }
		  else
		    {	/* Cfa/cinfo.scm 76 */
		       PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2029_6_2526);
		       res1734_2521 =
			  object__struct_50___object(
			  (object_bglt) (obj1733_2518));
		    }
	       }
	       {	/* Cfa/cinfo.scm 76 */
		  obj_t aux1735_2522;
		  {	/* ./Llib/struct.scm 1415 */
		     obj_t aux_10305;
		     aux_10305 =
			CNST_TABLE_REF(((long) 16));
		     aux1735_2522 =
			make_struct(aux_10305, ((long) 1), BUNSPEC);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_10308;
		     {	/* Cfa/cinfo.scm 76 */
			approx_bglt aux_10309;
			{
			   obj_t aux_10310;
			   {	/* Cfa/cinfo.scm 76 */
			      object_bglt aux_10311;
			      aux_10311 =
				 (object_bglt) (obj1733_2518);
			      aux_10310 =
				 OBJECT_WIDENING(aux_10311);
			   }
			   aux_10309 =
			      (((pragma_cinfo_220_bglt) CREF(aux_10310))->approx);
			}
			aux_10308 =
			   (obj_t) (aux_10309);
		     }
		     STRUCT_SET(aux1735_2522, ((long) 0), aux_10308);
		  }
		  STRUCT_SET(res1734_2521, ((long) 0), aux1735_2522);
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_10318;
		     aux_10318 =
			STRUCT_KEY(res1734_2521);
		     STRUCT_KEY_SET(aux1735_2522, aux_10318);
		  }
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_10321;
		     aux_10321 =
			CNST_TABLE_REF(((long) 16));
		     STRUCT_KEY_SET(res1734_2521, aux_10321);
		  }
		  return res1734_2521;
	       }
	    }
	 }
      }
   }
}



/* struct+object->object-setq/cinfo2028 */
obj_t 
struct_object__object_setq_cinfo2028_8_cfa_info(obj_t env_6178, obj_t o_6179, obj_t s_6180)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 77 */
      {
	 setq_cinfo_191_bglt o_2506;
	 obj_t s_2507;
	 {	/* Cfa/cinfo.scm 77 */
	    setq_cinfo_191_bglt aux_10325;
	    o_2506 =
	       (setq_cinfo_191_bglt) (o_6179);
	    s_2507 = s_6180;
	    {

	       {	/* Cfa/cinfo.scm 77 */
		  obj_t old1751_2510;
		  obj_t aux1752_2511;
		  {	/* Cfa/cinfo.scm 77 */
		     obj_t next_method2027_113_2516;
		     next_method2027_113_2516 =
			find_super_class_method_167___object(
			(object_bglt) (o_2506), struct_object__object_env_209___object, setq_cinfo_191_cfa_info);
		     if (
			PROCEDUREP(next_method2027_113_2516))
		       {	/* Cfa/cinfo.scm 77 */
			  old1751_2510 =
			     PROCEDURE_ENTRY(next_method2027_113_2516) (next_method2027_113_2516,
			     (obj_t) (o_2506), s_2507, BEOA);
		       }
		     else
		       {	/* Cfa/cinfo.scm 77 */
			  PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2027_113_2516);
			  {	/* Cfa/cinfo.scm 77 */
			     object_bglt aux_10334;
			     aux_10334 =
				struct_object__object_93___object(
				(object_bglt) (o_2506), s_2507);
			     old1751_2510 =
				(obj_t) (aux_10334);
			  }
		       }
		  }
		  aux1752_2511 =
		     STRUCT_REF(s_2507, ((long) 0));
		  {	/* Cfa/cinfo.scm 77 */
		     setq_cinfo_191_bglt new1753_2512;
		     new1753_2512 =
			((setq_cinfo_191_bglt) (old1751_2510));
		     {	/* Cfa/cinfo.scm 77 */
			long arg2529_2513;
			arg2529_2513 =
			   class_num_218___object(setq_cinfo_191_cfa_info);
			{	/* Cfa/cinfo.scm 77 */
			   obj_t obj_4360;
			   obj_4360 =
			      (obj_t) (new1753_2512);
			   (((obj_t) CREF(obj_4360))->header = MAKE_HEADER(arg2529_2513, 0), BUNSPEC);
			}
		     }
		     {	/* Cfa/cinfo.scm 77 */
			setq_cinfo_191_bglt arg2530_2514;
			{	/* Cfa/cinfo.scm 77 */
			   setq_cinfo_191_bglt res2753_4367;
			   {	/* Cfa/cinfo.scm 77 */
			      approx_bglt approx_4364;
			      {		/* Cfa/cinfo.scm 77 */
				 obj_t aux_10343;
				 aux_10343 =
				    STRUCT_REF(aux1752_2511, ((long) 0));
				 approx_4364 =
				    (approx_bglt) (aux_10343);
			      }
			      {		/* Cfa/cinfo.scm 77 */
				 setq_cinfo_191_bglt new1742_4365;
				 new1742_4365 =
				    ((setq_cinfo_191_bglt) BREF(GC_MALLOC(sizeof(struct setq_cinfo_191))));
				 ((((setq_cinfo_191_bglt) CREF(new1742_4365))->approx) = ((approx_bglt) approx_4364), BUNSPEC);
				 res2753_4367 = new1742_4365;
			      }
			   }
			   arg2530_2514 = res2753_4367;
			}
			{	/* Cfa/cinfo.scm 77 */
			   obj_t aux_10350;
			   object_bglt aux_10348;
			   aux_10350 =
			      (obj_t) (arg2530_2514);
			   aux_10348 =
			      (object_bglt) (new1753_2512);
			   OBJECT_WIDENING_SET(aux_10348, aux_10350);
			}
		     }
		     aux_10325 = new1753_2512;
		  }
	       }
	    }
	    return
	       (obj_t) (aux_10325);
	 }
      }
   }
}



/* object->struct-setq/cinfo2026 */
obj_t 
object__struct_setq_cinfo2026_53_cfa_info(obj_t env_6181, obj_t obj1748_6182)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 77 */
      {
	 setq_cinfo_191_bglt obj1748_2496;
	 obj1748_2496 =
	    (setq_cinfo_191_bglt) (obj1748_6182);
	 {

	    {	/* Cfa/cinfo.scm 77 */
	       obj_t res1749_2499;
	       {	/* Cfa/cinfo.scm 77 */
		  obj_t next_method2025_21_2504;
		  next_method2025_21_2504 =
		     find_super_class_method_167___object(
		     (object_bglt) (obj1748_2496), object__struct_env_210___object, setq_cinfo_191_cfa_info);
		  if (
		     PROCEDUREP(next_method2025_21_2504))
		    {	/* Cfa/cinfo.scm 77 */
		       res1749_2499 =
			  PROCEDURE_ENTRY(next_method2025_21_2504) (next_method2025_21_2504,
			  (obj_t) (obj1748_2496), BEOA);
		    }
		  else
		    {	/* Cfa/cinfo.scm 77 */
		       PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2025_21_2504);
		       res1749_2499 =
			  object__struct_50___object(
			  (object_bglt) (obj1748_2496));
		    }
	       }
	       {	/* Cfa/cinfo.scm 77 */
		  obj_t aux1750_2500;
		  {	/* ./Llib/struct.scm 1415 */
		     obj_t aux_10365;
		     aux_10365 =
			CNST_TABLE_REF(((long) 17));
		     aux1750_2500 =
			make_struct(aux_10365, ((long) 1), BUNSPEC);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_10368;
		     {	/* Cfa/cinfo.scm 77 */
			approx_bglt aux_10369;
			{
			   obj_t aux_10370;
			   {	/* Cfa/cinfo.scm 77 */
			      object_bglt aux_10371;
			      aux_10371 =
				 (object_bglt) (obj1748_2496);
			      aux_10370 =
				 OBJECT_WIDENING(aux_10371);
			   }
			   aux_10369 =
			      (((setq_cinfo_191_bglt) CREF(aux_10370))->approx);
			}
			aux_10368 =
			   (obj_t) (aux_10369);
		     }
		     STRUCT_SET(aux1750_2500, ((long) 0), aux_10368);
		  }
		  STRUCT_SET(res1749_2499, ((long) 0), aux1750_2500);
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_10378;
		     aux_10378 =
			STRUCT_KEY(res1749_2499);
		     STRUCT_KEY_SET(aux1750_2500, aux_10378);
		  }
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_10381;
		     aux_10381 =
			CNST_TABLE_REF(((long) 17));
		     STRUCT_KEY_SET(res1749_2499, aux_10381);
		  }
		  return res1749_2499;
	       }
	    }
	 }
      }
   }
}



/* struct+object->object-conditional/cinfo2024 */
obj_t 
struct_object__object_conditional_cinfo2024_17_cfa_info(obj_t env_6183, obj_t o_6184, obj_t s_6185)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 78 */
      {
	 conditional_cinfo_212_bglt o_2484;
	 obj_t s_2485;
	 {	/* Cfa/cinfo.scm 78 */
	    conditional_cinfo_212_bglt aux_10385;
	    o_2484 =
	       (conditional_cinfo_212_bglt) (o_6184);
	    s_2485 = s_6185;
	    {

	       {	/* Cfa/cinfo.scm 78 */
		  obj_t old1769_2488;
		  obj_t aux1770_2489;
		  {	/* Cfa/cinfo.scm 78 */
		     obj_t next_method2023_225_2494;
		     next_method2023_225_2494 =
			find_super_class_method_167___object(
			(object_bglt) (o_2484), struct_object__object_env_209___object, conditional_cinfo_212_cfa_info);
		     if (
			PROCEDUREP(next_method2023_225_2494))
		       {	/* Cfa/cinfo.scm 78 */
			  old1769_2488 =
			     PROCEDURE_ENTRY(next_method2023_225_2494) (next_method2023_225_2494,
			     (obj_t) (o_2484), s_2485, BEOA);
		       }
		     else
		       {	/* Cfa/cinfo.scm 78 */
			  PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2023_225_2494);
			  {	/* Cfa/cinfo.scm 78 */
			     object_bglt aux_10394;
			     aux_10394 =
				struct_object__object_93___object(
				(object_bglt) (o_2484), s_2485);
			     old1769_2488 =
				(obj_t) (aux_10394);
			  }
		       }
		  }
		  aux1770_2489 =
		     STRUCT_REF(s_2485, ((long) 0));
		  {	/* Cfa/cinfo.scm 78 */
		     conditional_cinfo_212_bglt new1771_2490;
		     new1771_2490 =
			((conditional_cinfo_212_bglt) (old1769_2488));
		     {	/* Cfa/cinfo.scm 78 */
			long arg2520_2491;
			arg2520_2491 =
			   class_num_218___object(conditional_cinfo_212_cfa_info);
			{	/* Cfa/cinfo.scm 78 */
			   obj_t obj_4331;
			   obj_4331 =
			      (obj_t) (new1771_2490);
			   (((obj_t) CREF(obj_4331))->header = MAKE_HEADER(arg2520_2491, 0), BUNSPEC);
			}
		     }
		     {	/* Cfa/cinfo.scm 78 */
			conditional_cinfo_212_bglt arg2521_2492;
			{	/* Cfa/cinfo.scm 78 */
			   conditional_cinfo_212_bglt res2752_4338;
			   {	/* Cfa/cinfo.scm 78 */
			      approx_bglt approx_4335;
			      {		/* Cfa/cinfo.scm 78 */
				 obj_t aux_10403;
				 aux_10403 =
				    STRUCT_REF(aux1770_2489, ((long) 0));
				 approx_4335 =
				    (approx_bglt) (aux_10403);
			      }
			      {		/* Cfa/cinfo.scm 78 */
				 conditional_cinfo_212_bglt new1760_4336;
				 new1760_4336 =
				    ((conditional_cinfo_212_bglt) BREF(GC_MALLOC(sizeof(struct conditional_cinfo_212))));
				 ((((conditional_cinfo_212_bglt) CREF(new1760_4336))->approx) = ((approx_bglt) approx_4335), BUNSPEC);
				 res2752_4338 = new1760_4336;
			      }
			   }
			   arg2521_2492 = res2752_4338;
			}
			{	/* Cfa/cinfo.scm 78 */
			   obj_t aux_10410;
			   object_bglt aux_10408;
			   aux_10410 =
			      (obj_t) (arg2521_2492);
			   aux_10408 =
			      (object_bglt) (new1771_2490);
			   OBJECT_WIDENING_SET(aux_10408, aux_10410);
			}
		     }
		     aux_10385 = new1771_2490;
		  }
	       }
	    }
	    return
	       (obj_t) (aux_10385);
	 }
      }
   }
}



/* object->struct-conditional/cinfo2022 */
obj_t 
object__struct_conditional_cinfo2022_5_cfa_info(obj_t env_6186, obj_t obj1766_6187)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 78 */
      {
	 conditional_cinfo_212_bglt obj1766_2474;
	 obj1766_2474 =
	    (conditional_cinfo_212_bglt) (obj1766_6187);
	 {

	    {	/* Cfa/cinfo.scm 78 */
	       obj_t res1767_2477;
	       {	/* Cfa/cinfo.scm 78 */
		  obj_t next_method2021_251_2482;
		  next_method2021_251_2482 =
		     find_super_class_method_167___object(
		     (object_bglt) (obj1766_2474), object__struct_env_210___object, conditional_cinfo_212_cfa_info);
		  if (
		     PROCEDUREP(next_method2021_251_2482))
		    {	/* Cfa/cinfo.scm 78 */
		       res1767_2477 =
			  PROCEDURE_ENTRY(next_method2021_251_2482) (next_method2021_251_2482,
			  (obj_t) (obj1766_2474), BEOA);
		    }
		  else
		    {	/* Cfa/cinfo.scm 78 */
		       PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2021_251_2482);
		       res1767_2477 =
			  object__struct_50___object(
			  (object_bglt) (obj1766_2474));
		    }
	       }
	       {	/* Cfa/cinfo.scm 78 */
		  obj_t aux1768_2478;
		  {	/* ./Llib/struct.scm 1415 */
		     obj_t aux_10425;
		     aux_10425 =
			CNST_TABLE_REF(((long) 18));
		     aux1768_2478 =
			make_struct(aux_10425, ((long) 1), BUNSPEC);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_10428;
		     {	/* Cfa/cinfo.scm 78 */
			approx_bglt aux_10429;
			{
			   obj_t aux_10430;
			   {	/* Cfa/cinfo.scm 78 */
			      object_bglt aux_10431;
			      aux_10431 =
				 (object_bglt) (obj1766_2474);
			      aux_10430 =
				 OBJECT_WIDENING(aux_10431);
			   }
			   aux_10429 =
			      (((conditional_cinfo_212_bglt) CREF(aux_10430))->approx);
			}
			aux_10428 =
			   (obj_t) (aux_10429);
		     }
		     STRUCT_SET(aux1768_2478, ((long) 0), aux_10428);
		  }
		  STRUCT_SET(res1767_2477, ((long) 0), aux1768_2478);
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_10438;
		     aux_10438 =
			STRUCT_KEY(res1767_2477);
		     STRUCT_KEY_SET(aux1768_2478, aux_10438);
		  }
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_10441;
		     aux_10441 =
			CNST_TABLE_REF(((long) 18));
		     STRUCT_KEY_SET(res1767_2477, aux_10441);
		  }
		  return res1767_2477;
	       }
	    }
	 }
      }
   }
}



/* struct+object->object-fail/cinfo2020 */
obj_t 
struct_object__object_fail_cinfo2020_217_cfa_info(obj_t env_6188, obj_t o_6189, obj_t s_6190)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 79 */
      {
	 fail_cinfo_75_bglt o_2462;
	 obj_t s_2463;
	 {	/* Cfa/cinfo.scm 79 */
	    fail_cinfo_75_bglt aux_10445;
	    o_2462 =
	       (fail_cinfo_75_bglt) (o_6189);
	    s_2463 = s_6190;
	    {

	       {	/* Cfa/cinfo.scm 79 */
		  obj_t old1785_2466;
		  obj_t aux1786_2467;
		  {	/* Cfa/cinfo.scm 79 */
		     obj_t next_method2019_194_2472;
		     next_method2019_194_2472 =
			find_super_class_method_167___object(
			(object_bglt) (o_2462), struct_object__object_env_209___object, fail_cinfo_75_cfa_info);
		     if (
			PROCEDUREP(next_method2019_194_2472))
		       {	/* Cfa/cinfo.scm 79 */
			  old1785_2466 =
			     PROCEDURE_ENTRY(next_method2019_194_2472) (next_method2019_194_2472,
			     (obj_t) (o_2462), s_2463, BEOA);
		       }
		     else
		       {	/* Cfa/cinfo.scm 79 */
			  PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2019_194_2472);
			  {	/* Cfa/cinfo.scm 79 */
			     object_bglt aux_10454;
			     aux_10454 =
				struct_object__object_93___object(
				(object_bglt) (o_2462), s_2463);
			     old1785_2466 =
				(obj_t) (aux_10454);
			  }
		       }
		  }
		  aux1786_2467 =
		     STRUCT_REF(s_2463, ((long) 0));
		  {	/* Cfa/cinfo.scm 79 */
		     fail_cinfo_75_bglt new1787_2468;
		     new1787_2468 =
			((fail_cinfo_75_bglt) (old1785_2466));
		     {	/* Cfa/cinfo.scm 79 */
			long arg2512_2469;
			arg2512_2469 =
			   class_num_218___object(fail_cinfo_75_cfa_info);
			{	/* Cfa/cinfo.scm 79 */
			   obj_t obj_4302;
			   obj_4302 =
			      (obj_t) (new1787_2468);
			   (((obj_t) CREF(obj_4302))->header = MAKE_HEADER(arg2512_2469, 0), BUNSPEC);
			}
		     }
		     {	/* Cfa/cinfo.scm 79 */
			fail_cinfo_75_bglt arg2513_2470;
			{	/* Cfa/cinfo.scm 79 */
			   fail_cinfo_75_bglt res2751_4309;
			   {	/* Cfa/cinfo.scm 79 */
			      approx_bglt approx_4306;
			      {		/* Cfa/cinfo.scm 79 */
				 obj_t aux_10463;
				 aux_10463 =
				    STRUCT_REF(aux1786_2467, ((long) 0));
				 approx_4306 =
				    (approx_bglt) (aux_10463);
			      }
			      {		/* Cfa/cinfo.scm 79 */
				 fail_cinfo_75_bglt new1776_4307;
				 new1776_4307 =
				    ((fail_cinfo_75_bglt) BREF(GC_MALLOC(sizeof(struct fail_cinfo_75))));
				 ((((fail_cinfo_75_bglt) CREF(new1776_4307))->approx) = ((approx_bglt) approx_4306), BUNSPEC);
				 res2751_4309 = new1776_4307;
			      }
			   }
			   arg2513_2470 = res2751_4309;
			}
			{	/* Cfa/cinfo.scm 79 */
			   obj_t aux_10470;
			   object_bglt aux_10468;
			   aux_10470 =
			      (obj_t) (arg2513_2470);
			   aux_10468 =
			      (object_bglt) (new1787_2468);
			   OBJECT_WIDENING_SET(aux_10468, aux_10470);
			}
		     }
		     aux_10445 = new1787_2468;
		  }
	       }
	    }
	    return
	       (obj_t) (aux_10445);
	 }
      }
   }
}



/* object->struct-fail/cinfo2018 */
obj_t 
object__struct_fail_cinfo2018_129_cfa_info(obj_t env_6191, obj_t obj1782_6192)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 79 */
      {
	 fail_cinfo_75_bglt obj1782_2452;
	 obj1782_2452 =
	    (fail_cinfo_75_bglt) (obj1782_6192);
	 {

	    {	/* Cfa/cinfo.scm 79 */
	       obj_t res1783_2455;
	       {	/* Cfa/cinfo.scm 79 */
		  obj_t next_method2017_64_2460;
		  next_method2017_64_2460 =
		     find_super_class_method_167___object(
		     (object_bglt) (obj1782_2452), object__struct_env_210___object, fail_cinfo_75_cfa_info);
		  if (
		     PROCEDUREP(next_method2017_64_2460))
		    {	/* Cfa/cinfo.scm 79 */
		       res1783_2455 =
			  PROCEDURE_ENTRY(next_method2017_64_2460) (next_method2017_64_2460,
			  (obj_t) (obj1782_2452), BEOA);
		    }
		  else
		    {	/* Cfa/cinfo.scm 79 */
		       PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2017_64_2460);
		       res1783_2455 =
			  object__struct_50___object(
			  (object_bglt) (obj1782_2452));
		    }
	       }
	       {	/* Cfa/cinfo.scm 79 */
		  obj_t aux1784_2456;
		  {	/* ./Llib/struct.scm 1415 */
		     obj_t aux_10485;
		     aux_10485 =
			CNST_TABLE_REF(((long) 19));
		     aux1784_2456 =
			make_struct(aux_10485, ((long) 1), BUNSPEC);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_10488;
		     {	/* Cfa/cinfo.scm 79 */
			approx_bglt aux_10489;
			{
			   obj_t aux_10490;
			   {	/* Cfa/cinfo.scm 79 */
			      object_bglt aux_10491;
			      aux_10491 =
				 (object_bglt) (obj1782_2452);
			      aux_10490 =
				 OBJECT_WIDENING(aux_10491);
			   }
			   aux_10489 =
			      (((fail_cinfo_75_bglt) CREF(aux_10490))->approx);
			}
			aux_10488 =
			   (obj_t) (aux_10489);
		     }
		     STRUCT_SET(aux1784_2456, ((long) 0), aux_10488);
		  }
		  STRUCT_SET(res1783_2455, ((long) 0), aux1784_2456);
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_10498;
		     aux_10498 =
			STRUCT_KEY(res1783_2455);
		     STRUCT_KEY_SET(aux1784_2456, aux_10498);
		  }
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_10501;
		     aux_10501 =
			CNST_TABLE_REF(((long) 19));
		     STRUCT_KEY_SET(res1783_2455, aux_10501);
		  }
		  return res1783_2455;
	       }
	    }
	 }
      }
   }
}



/* struct+object->object-select/cinfo2016 */
obj_t 
struct_object__object_select_cinfo2016_231_cfa_info(obj_t env_6193, obj_t o_6194, obj_t s_6195)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 80 */
      {
	 select_cinfo_150_bglt o_2440;
	 obj_t s_2441;
	 {	/* Cfa/cinfo.scm 80 */
	    select_cinfo_150_bglt aux_10505;
	    o_2440 =
	       (select_cinfo_150_bglt) (o_6194);
	    s_2441 = s_6195;
	    {

	       {	/* Cfa/cinfo.scm 80 */
		  obj_t old1801_2444;
		  obj_t aux1802_2445;
		  {	/* Cfa/cinfo.scm 80 */
		     obj_t next_method2015_72_2450;
		     next_method2015_72_2450 =
			find_super_class_method_167___object(
			(object_bglt) (o_2440), struct_object__object_env_209___object, select_cinfo_150_cfa_info);
		     if (
			PROCEDUREP(next_method2015_72_2450))
		       {	/* Cfa/cinfo.scm 80 */
			  old1801_2444 =
			     PROCEDURE_ENTRY(next_method2015_72_2450) (next_method2015_72_2450,
			     (obj_t) (o_2440), s_2441, BEOA);
		       }
		     else
		       {	/* Cfa/cinfo.scm 80 */
			  PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2015_72_2450);
			  {	/* Cfa/cinfo.scm 80 */
			     object_bglt aux_10514;
			     aux_10514 =
				struct_object__object_93___object(
				(object_bglt) (o_2440), s_2441);
			     old1801_2444 =
				(obj_t) (aux_10514);
			  }
		       }
		  }
		  aux1802_2445 =
		     STRUCT_REF(s_2441, ((long) 0));
		  {	/* Cfa/cinfo.scm 80 */
		     select_cinfo_150_bglt new1803_2446;
		     new1803_2446 =
			((select_cinfo_150_bglt) (old1801_2444));
		     {	/* Cfa/cinfo.scm 80 */
			long arg2504_2447;
			arg2504_2447 =
			   class_num_218___object(select_cinfo_150_cfa_info);
			{	/* Cfa/cinfo.scm 80 */
			   obj_t obj_4273;
			   obj_4273 =
			      (obj_t) (new1803_2446);
			   (((obj_t) CREF(obj_4273))->header = MAKE_HEADER(arg2504_2447, 0), BUNSPEC);
			}
		     }
		     {	/* Cfa/cinfo.scm 80 */
			select_cinfo_150_bglt arg2505_2448;
			{	/* Cfa/cinfo.scm 80 */
			   select_cinfo_150_bglt res2750_4280;
			   {	/* Cfa/cinfo.scm 80 */
			      approx_bglt approx_4277;
			      {		/* Cfa/cinfo.scm 80 */
				 obj_t aux_10523;
				 aux_10523 =
				    STRUCT_REF(aux1802_2445, ((long) 0));
				 approx_4277 =
				    (approx_bglt) (aux_10523);
			      }
			      {		/* Cfa/cinfo.scm 80 */
				 select_cinfo_150_bglt new1792_4278;
				 new1792_4278 =
				    ((select_cinfo_150_bglt) BREF(GC_MALLOC(sizeof(struct select_cinfo_150))));
				 ((((select_cinfo_150_bglt) CREF(new1792_4278))->approx) = ((approx_bglt) approx_4277), BUNSPEC);
				 res2750_4280 = new1792_4278;
			      }
			   }
			   arg2505_2448 = res2750_4280;
			}
			{	/* Cfa/cinfo.scm 80 */
			   obj_t aux_10530;
			   object_bglt aux_10528;
			   aux_10530 =
			      (obj_t) (arg2505_2448);
			   aux_10528 =
			      (object_bglt) (new1803_2446);
			   OBJECT_WIDENING_SET(aux_10528, aux_10530);
			}
		     }
		     aux_10505 = new1803_2446;
		  }
	       }
	    }
	    return
	       (obj_t) (aux_10505);
	 }
      }
   }
}



/* object->struct-select/cinfo2014 */
obj_t 
object__struct_select_cinfo2014_57_cfa_info(obj_t env_6196, obj_t obj1798_6197)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 80 */
      {
	 select_cinfo_150_bglt obj1798_2430;
	 obj1798_2430 =
	    (select_cinfo_150_bglt) (obj1798_6197);
	 {

	    {	/* Cfa/cinfo.scm 80 */
	       obj_t res1799_2433;
	       {	/* Cfa/cinfo.scm 80 */
		  obj_t next_method2013_245_2438;
		  next_method2013_245_2438 =
		     find_super_class_method_167___object(
		     (object_bglt) (obj1798_2430), object__struct_env_210___object, select_cinfo_150_cfa_info);
		  if (
		     PROCEDUREP(next_method2013_245_2438))
		    {	/* Cfa/cinfo.scm 80 */
		       res1799_2433 =
			  PROCEDURE_ENTRY(next_method2013_245_2438) (next_method2013_245_2438,
			  (obj_t) (obj1798_2430), BEOA);
		    }
		  else
		    {	/* Cfa/cinfo.scm 80 */
		       PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2013_245_2438);
		       res1799_2433 =
			  object__struct_50___object(
			  (object_bglt) (obj1798_2430));
		    }
	       }
	       {	/* Cfa/cinfo.scm 80 */
		  obj_t aux1800_2434;
		  {	/* ./Llib/struct.scm 1415 */
		     obj_t aux_10545;
		     aux_10545 =
			CNST_TABLE_REF(((long) 20));
		     aux1800_2434 =
			make_struct(aux_10545, ((long) 1), BUNSPEC);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_10548;
		     {	/* Cfa/cinfo.scm 80 */
			approx_bglt aux_10549;
			{
			   obj_t aux_10550;
			   {	/* Cfa/cinfo.scm 80 */
			      object_bglt aux_10551;
			      aux_10551 =
				 (object_bglt) (obj1798_2430);
			      aux_10550 =
				 OBJECT_WIDENING(aux_10551);
			   }
			   aux_10549 =
			      (((select_cinfo_150_bglt) CREF(aux_10550))->approx);
			}
			aux_10548 =
			   (obj_t) (aux_10549);
		     }
		     STRUCT_SET(aux1800_2434, ((long) 0), aux_10548);
		  }
		  STRUCT_SET(res1799_2433, ((long) 0), aux1800_2434);
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_10558;
		     aux_10558 =
			STRUCT_KEY(res1799_2433);
		     STRUCT_KEY_SET(aux1800_2434, aux_10558);
		  }
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_10561;
		     aux_10561 =
			CNST_TABLE_REF(((long) 20));
		     STRUCT_KEY_SET(res1799_2433, aux_10561);
		  }
		  return res1799_2433;
	       }
	    }
	 }
      }
   }
}



/* struct+object->object-set-ex-it/cinfo2012 */
obj_t 
struct_object__object_set_ex_it_cinfo2012_163_cfa_info(obj_t env_6198, obj_t o_6199, obj_t s_6200)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 81 */
      {
	 set_ex_it_cinfo_168_bglt o_2418;
	 obj_t s_2419;
	 {	/* Cfa/cinfo.scm 81 */
	    set_ex_it_cinfo_168_bglt aux_10565;
	    o_2418 =
	       (set_ex_it_cinfo_168_bglt) (o_6199);
	    s_2419 = s_6200;
	    {

	       {	/* Cfa/cinfo.scm 81 */
		  obj_t old1816_2422;
		  obj_t aux1817_2423;
		  {	/* Cfa/cinfo.scm 81 */
		     obj_t next_method2011_122_2428;
		     next_method2011_122_2428 =
			find_super_class_method_167___object(
			(object_bglt) (o_2418), struct_object__object_env_209___object, set_ex_it_cinfo_168_cfa_info);
		     if (
			PROCEDUREP(next_method2011_122_2428))
		       {	/* Cfa/cinfo.scm 81 */
			  old1816_2422 =
			     PROCEDURE_ENTRY(next_method2011_122_2428) (next_method2011_122_2428,
			     (obj_t) (o_2418), s_2419, BEOA);
		       }
		     else
		       {	/* Cfa/cinfo.scm 81 */
			  PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2011_122_2428);
			  {	/* Cfa/cinfo.scm 81 */
			     object_bglt aux_10574;
			     aux_10574 =
				struct_object__object_93___object(
				(object_bglt) (o_2418), s_2419);
			     old1816_2422 =
				(obj_t) (aux_10574);
			  }
		       }
		  }
		  aux1817_2423 =
		     STRUCT_REF(s_2419, ((long) 0));
		  {	/* Cfa/cinfo.scm 81 */
		     set_ex_it_cinfo_168_bglt new1818_2424;
		     new1818_2424 =
			((set_ex_it_cinfo_168_bglt) (old1816_2422));
		     {	/* Cfa/cinfo.scm 81 */
			long arg2496_2425;
			arg2496_2425 =
			   class_num_218___object(set_ex_it_cinfo_168_cfa_info);
			{	/* Cfa/cinfo.scm 81 */
			   obj_t obj_4244;
			   obj_4244 =
			      (obj_t) (new1818_2424);
			   (((obj_t) CREF(obj_4244))->header = MAKE_HEADER(arg2496_2425, 0), BUNSPEC);
			}
		     }
		     {	/* Cfa/cinfo.scm 81 */
			set_ex_it_cinfo_168_bglt arg2497_2426;
			{	/* Cfa/cinfo.scm 81 */
			   set_ex_it_cinfo_168_bglt res2749_4251;
			   {	/* Cfa/cinfo.scm 81 */
			      approx_bglt approx_4248;
			      {		/* Cfa/cinfo.scm 81 */
				 obj_t aux_10583;
				 aux_10583 =
				    STRUCT_REF(aux1817_2423, ((long) 0));
				 approx_4248 =
				    (approx_bglt) (aux_10583);
			      }
			      {		/* Cfa/cinfo.scm 81 */
				 set_ex_it_cinfo_168_bglt new1807_4249;
				 new1807_4249 =
				    ((set_ex_it_cinfo_168_bglt) BREF(GC_MALLOC(sizeof(struct set_ex_it_cinfo_168))));
				 ((((set_ex_it_cinfo_168_bglt) CREF(new1807_4249))->approx) = ((approx_bglt) approx_4248), BUNSPEC);
				 res2749_4251 = new1807_4249;
			      }
			   }
			   arg2497_2426 = res2749_4251;
			}
			{	/* Cfa/cinfo.scm 81 */
			   obj_t aux_10590;
			   object_bglt aux_10588;
			   aux_10590 =
			      (obj_t) (arg2497_2426);
			   aux_10588 =
			      (object_bglt) (new1818_2424);
			   OBJECT_WIDENING_SET(aux_10588, aux_10590);
			}
		     }
		     aux_10565 = new1818_2424;
		  }
	       }
	    }
	    return
	       (obj_t) (aux_10565);
	 }
      }
   }
}



/* object->struct-set-ex-it/cinfo2010 */
obj_t 
object__struct_set_ex_it_cinfo2010_16_cfa_info(obj_t env_6201, obj_t obj1813_6202)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 81 */
      {
	 set_ex_it_cinfo_168_bglt obj1813_2408;
	 obj1813_2408 =
	    (set_ex_it_cinfo_168_bglt) (obj1813_6202);
	 {

	    {	/* Cfa/cinfo.scm 81 */
	       obj_t res1814_2411;
	       {	/* Cfa/cinfo.scm 81 */
		  obj_t next_method2009_133_2416;
		  next_method2009_133_2416 =
		     find_super_class_method_167___object(
		     (object_bglt) (obj1813_2408), object__struct_env_210___object, set_ex_it_cinfo_168_cfa_info);
		  if (
		     PROCEDUREP(next_method2009_133_2416))
		    {	/* Cfa/cinfo.scm 81 */
		       res1814_2411 =
			  PROCEDURE_ENTRY(next_method2009_133_2416) (next_method2009_133_2416,
			  (obj_t) (obj1813_2408), BEOA);
		    }
		  else
		    {	/* Cfa/cinfo.scm 81 */
		       PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2009_133_2416);
		       res1814_2411 =
			  object__struct_50___object(
			  (object_bglt) (obj1813_2408));
		    }
	       }
	       {	/* Cfa/cinfo.scm 81 */
		  obj_t aux1815_2412;
		  {	/* ./Llib/struct.scm 1415 */
		     obj_t aux_10605;
		     aux_10605 =
			CNST_TABLE_REF(((long) 21));
		     aux1815_2412 =
			make_struct(aux_10605, ((long) 1), BUNSPEC);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_10608;
		     {	/* Cfa/cinfo.scm 81 */
			approx_bglt aux_10609;
			{
			   obj_t aux_10610;
			   {	/* Cfa/cinfo.scm 81 */
			      object_bglt aux_10611;
			      aux_10611 =
				 (object_bglt) (obj1813_2408);
			      aux_10610 =
				 OBJECT_WIDENING(aux_10611);
			   }
			   aux_10609 =
			      (((set_ex_it_cinfo_168_bglt) CREF(aux_10610))->approx);
			}
			aux_10608 =
			   (obj_t) (aux_10609);
		     }
		     STRUCT_SET(aux1815_2412, ((long) 0), aux_10608);
		  }
		  STRUCT_SET(res1814_2411, ((long) 0), aux1815_2412);
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_10618;
		     aux_10618 =
			STRUCT_KEY(res1814_2411);
		     STRUCT_KEY_SET(aux1815_2412, aux_10618);
		  }
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_10621;
		     aux_10621 =
			CNST_TABLE_REF(((long) 21));
		     STRUCT_KEY_SET(res1814_2411, aux_10621);
		  }
		  return res1814_2411;
	       }
	    }
	 }
      }
   }
}



/* struct+object->object-jump-ex-it/cinfo2008 */
obj_t 
struct_object__object_jump_ex_it_cinfo2008_72_cfa_info(obj_t env_6203, obj_t o_6204, obj_t s_6205)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 82 */
      {
	 jump_ex_it_cinfo_139_bglt o_2396;
	 obj_t s_2397;
	 {	/* Cfa/cinfo.scm 82 */
	    jump_ex_it_cinfo_139_bglt aux_10625;
	    o_2396 =
	       (jump_ex_it_cinfo_139_bglt) (o_6204);
	    s_2397 = s_6205;
	    {

	       {	/* Cfa/cinfo.scm 82 */
		  obj_t old1831_2400;
		  obj_t aux1832_2401;
		  {	/* Cfa/cinfo.scm 82 */
		     obj_t next_method2007_35_2406;
		     next_method2007_35_2406 =
			find_super_class_method_167___object(
			(object_bglt) (o_2396), struct_object__object_env_209___object, jump_ex_it_cinfo_139_cfa_info);
		     if (
			PROCEDUREP(next_method2007_35_2406))
		       {	/* Cfa/cinfo.scm 82 */
			  old1831_2400 =
			     PROCEDURE_ENTRY(next_method2007_35_2406) (next_method2007_35_2406,
			     (obj_t) (o_2396), s_2397, BEOA);
		       }
		     else
		       {	/* Cfa/cinfo.scm 82 */
			  PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2007_35_2406);
			  {	/* Cfa/cinfo.scm 82 */
			     object_bglt aux_10634;
			     aux_10634 =
				struct_object__object_93___object(
				(object_bglt) (o_2396), s_2397);
			     old1831_2400 =
				(obj_t) (aux_10634);
			  }
		       }
		  }
		  aux1832_2401 =
		     STRUCT_REF(s_2397, ((long) 0));
		  {	/* Cfa/cinfo.scm 82 */
		     jump_ex_it_cinfo_139_bglt new1833_2402;
		     new1833_2402 =
			((jump_ex_it_cinfo_139_bglt) (old1831_2400));
		     {	/* Cfa/cinfo.scm 82 */
			long arg2488_2403;
			arg2488_2403 =
			   class_num_218___object(jump_ex_it_cinfo_139_cfa_info);
			{	/* Cfa/cinfo.scm 82 */
			   obj_t obj_4215;
			   obj_4215 =
			      (obj_t) (new1833_2402);
			   (((obj_t) CREF(obj_4215))->header = MAKE_HEADER(arg2488_2403, 0), BUNSPEC);
			}
		     }
		     {	/* Cfa/cinfo.scm 82 */
			jump_ex_it_cinfo_139_bglt arg2489_2404;
			{	/* Cfa/cinfo.scm 82 */
			   jump_ex_it_cinfo_139_bglt res2748_4222;
			   {	/* Cfa/cinfo.scm 82 */
			      approx_bglt approx_4219;
			      {		/* Cfa/cinfo.scm 82 */
				 obj_t aux_10643;
				 aux_10643 =
				    STRUCT_REF(aux1832_2401, ((long) 0));
				 approx_4219 =
				    (approx_bglt) (aux_10643);
			      }
			      {		/* Cfa/cinfo.scm 82 */
				 jump_ex_it_cinfo_139_bglt new1822_4220;
				 new1822_4220 =
				    ((jump_ex_it_cinfo_139_bglt) BREF(GC_MALLOC(sizeof(struct jump_ex_it_cinfo_139))));
				 ((((jump_ex_it_cinfo_139_bglt) CREF(new1822_4220))->approx) = ((approx_bglt) approx_4219), BUNSPEC);
				 res2748_4222 = new1822_4220;
			      }
			   }
			   arg2489_2404 = res2748_4222;
			}
			{	/* Cfa/cinfo.scm 82 */
			   obj_t aux_10650;
			   object_bglt aux_10648;
			   aux_10650 =
			      (obj_t) (arg2489_2404);
			   aux_10648 =
			      (object_bglt) (new1833_2402);
			   OBJECT_WIDENING_SET(aux_10648, aux_10650);
			}
		     }
		     aux_10625 = new1833_2402;
		  }
	       }
	    }
	    return
	       (obj_t) (aux_10625);
	 }
      }
   }
}



/* object->struct-jump-ex-it/cinfo2006 */
obj_t 
object__struct_jump_ex_it_cinfo2006_111_cfa_info(obj_t env_6206, obj_t obj1828_6207)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 82 */
      {
	 jump_ex_it_cinfo_139_bglt obj1828_2386;
	 obj1828_2386 =
	    (jump_ex_it_cinfo_139_bglt) (obj1828_6207);
	 {

	    {	/* Cfa/cinfo.scm 82 */
	       obj_t res1829_2389;
	       {	/* Cfa/cinfo.scm 82 */
		  obj_t next_method2005_95_2394;
		  next_method2005_95_2394 =
		     find_super_class_method_167___object(
		     (object_bglt) (obj1828_2386), object__struct_env_210___object, jump_ex_it_cinfo_139_cfa_info);
		  if (
		     PROCEDUREP(next_method2005_95_2394))
		    {	/* Cfa/cinfo.scm 82 */
		       res1829_2389 =
			  PROCEDURE_ENTRY(next_method2005_95_2394) (next_method2005_95_2394,
			  (obj_t) (obj1828_2386), BEOA);
		    }
		  else
		    {	/* Cfa/cinfo.scm 82 */
		       PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2005_95_2394);
		       res1829_2389 =
			  object__struct_50___object(
			  (object_bglt) (obj1828_2386));
		    }
	       }
	       {	/* Cfa/cinfo.scm 82 */
		  obj_t aux1830_2390;
		  {	/* ./Llib/struct.scm 1415 */
		     obj_t aux_10665;
		     aux_10665 =
			CNST_TABLE_REF(((long) 22));
		     aux1830_2390 =
			make_struct(aux_10665, ((long) 1), BUNSPEC);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_10668;
		     {	/* Cfa/cinfo.scm 82 */
			approx_bglt aux_10669;
			{
			   obj_t aux_10670;
			   {	/* Cfa/cinfo.scm 82 */
			      object_bglt aux_10671;
			      aux_10671 =
				 (object_bglt) (obj1828_2386);
			      aux_10670 =
				 OBJECT_WIDENING(aux_10671);
			   }
			   aux_10669 =
			      (((jump_ex_it_cinfo_139_bglt) CREF(aux_10670))->approx);
			}
			aux_10668 =
			   (obj_t) (aux_10669);
		     }
		     STRUCT_SET(aux1830_2390, ((long) 0), aux_10668);
		  }
		  STRUCT_SET(res1829_2389, ((long) 0), aux1830_2390);
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_10678;
		     aux_10678 =
			STRUCT_KEY(res1829_2389);
		     STRUCT_KEY_SET(aux1830_2390, aux_10678);
		  }
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_10681;
		     aux_10681 =
			CNST_TABLE_REF(((long) 22));
		     STRUCT_KEY_SET(res1829_2389, aux_10681);
		  }
		  return res1829_2389;
	       }
	    }
	 }
      }
   }
}



/* struct+object->object-pre-make-box2004 */
obj_t 
struct_object__object_pre_make_box2004_221_cfa_info(obj_t env_6208, obj_t o_6209, obj_t s_6210)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 85 */
      {
	 pre_make_box_186_bglt o_2375;
	 obj_t s_2376;
	 {	/* Cfa/cinfo.scm 85 */
	    pre_make_box_186_bglt aux_10685;
	    o_2375 =
	       (pre_make_box_186_bglt) (o_6209);
	    s_2376 = s_6210;
	    {

	       {	/* Cfa/cinfo.scm 85 */
		  obj_t old1846_2379;
		  {	/* Cfa/cinfo.scm 85 */
		     obj_t next_method2003_252_2384;
		     next_method2003_252_2384 =
			find_super_class_method_167___object(
			(object_bglt) (o_2375), struct_object__object_env_209___object, pre_make_box_186_cfa_info);
		     if (
			PROCEDUREP(next_method2003_252_2384))
		       {	/* Cfa/cinfo.scm 85 */
			  old1846_2379 =
			     PROCEDURE_ENTRY(next_method2003_252_2384) (next_method2003_252_2384,
			     (obj_t) (o_2375), s_2376, BEOA);
		       }
		     else
		       {	/* Cfa/cinfo.scm 85 */
			  PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2003_252_2384);
			  {	/* Cfa/cinfo.scm 85 */
			     object_bglt aux_10694;
			     aux_10694 =
				struct_object__object_93___object(
				(object_bglt) (o_2375), s_2376);
			     old1846_2379 =
				(obj_t) (aux_10694);
			  }
		       }
		  }
		  {	/* Cfa/cinfo.scm 85 */
		     pre_make_box_186_bglt new1848_2381;
		     new1848_2381 =
			((pre_make_box_186_bglt) (old1846_2379));
		     {	/* Cfa/cinfo.scm 85 */
			long arg2481_2382;
			arg2481_2382 =
			   class_num_218___object(pre_make_box_186_cfa_info);
			{	/* Cfa/cinfo.scm 85 */
			   obj_t obj_4190;
			   obj_4190 =
			      (obj_t) (new1848_2381);
			   (((obj_t) CREF(obj_4190))->header = MAKE_HEADER(arg2481_2382, 0), BUNSPEC);
			}
		     }
		     {	/* Cfa/cinfo.scm 85 */
			obj_t aux_10704;
			object_bglt aux_10702;
			{	/* Cfa/cinfo.scm 85 */
			   pre_make_box_186_bglt aux_10705;
			   {	/* Cfa/cinfo.scm 85 */

			      aux_10705 =
				 ((pre_make_box_186_bglt) BREF(GC_MALLOC(sizeof(struct pre_make_box_186))));
			   }
			   aux_10704 =
			      (obj_t) (aux_10705);
			}
			aux_10702 =
			   (object_bglt) (new1848_2381);
			OBJECT_WIDENING_SET(aux_10702, aux_10704);
		     }
		     aux_10685 = new1848_2381;
		  }
	       }
	    }
	    return
	       (obj_t) (aux_10685);
	 }
      }
   }
}



/* object->struct-pre-make-box2002 */
obj_t 
object__struct_pre_make_box2002_179_cfa_info(obj_t env_6211, obj_t obj1843_6212)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 85 */
      {
	 pre_make_box_186_bglt obj1843_2367;
	 obj1843_2367 =
	    (pre_make_box_186_bglt) (obj1843_6212);
	 {

	    {	/* Cfa/cinfo.scm 85 */
	       obj_t res1844_2370;
	       {	/* Cfa/cinfo.scm 85 */
		  obj_t next_method2001_54_2373;
		  next_method2001_54_2373 =
		     find_super_class_method_167___object(
		     (object_bglt) (obj1843_2367), object__struct_env_210___object, pre_make_box_186_cfa_info);
		  if (
		     PROCEDUREP(next_method2001_54_2373))
		    {	/* Cfa/cinfo.scm 85 */
		       res1844_2370 =
			  PROCEDURE_ENTRY(next_method2001_54_2373) (next_method2001_54_2373,
			  (obj_t) (obj1843_2367), BEOA);
		    }
		  else
		    {	/* Cfa/cinfo.scm 85 */
		       PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2001_54_2373);
		       res1844_2370 =
			  object__struct_50___object(
			  (object_bglt) (obj1843_2367));
		    }
	       }
	       {	/* Cfa/cinfo.scm 85 */
		  obj_t aux1845_2371;
		  {	/* ./Llib/struct.scm 1415 */
		     obj_t aux_10721;
		     aux_10721 =
			CNST_TABLE_REF(((long) 23));
		     aux1845_2371 =
			make_struct(aux_10721, ((long) 0), BUNSPEC);
		  }
		  STRUCT_SET(res1844_2370, ((long) 0), aux1845_2371);
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_10725;
		     aux_10725 =
			STRUCT_KEY(res1844_2370);
		     STRUCT_KEY_SET(aux1845_2371, aux_10725);
		  }
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_10728;
		     aux_10728 =
			CNST_TABLE_REF(((long) 23));
		     STRUCT_KEY_SET(res1844_2370, aux_10728);
		  }
		  return res1844_2370;
	       }
	    }
	 }
      }
   }
}



/* struct+object->object-make-box/cinfo2000 */
obj_t 
struct_object__object_make_box_cinfo2000_189_cfa_info(obj_t env_6213, obj_t o_6214, obj_t s_6215)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 86 */
      {
	 make_box_cinfo_127_bglt o_2355;
	 obj_t s_2356;
	 {	/* Cfa/cinfo.scm 86 */
	    make_box_cinfo_127_bglt aux_10732;
	    o_2355 =
	       (make_box_cinfo_127_bglt) (o_6214);
	    s_2356 = s_6215;
	    {

	       {	/* Cfa/cinfo.scm 86 */
		  obj_t old1862_2359;
		  obj_t aux1863_2360;
		  {	/* Cfa/cinfo.scm 86 */
		     obj_t next_method1999_98_2365;
		     next_method1999_98_2365 =
			find_super_class_method_167___object(
			(object_bglt) (o_2355), struct_object__object_env_209___object, make_box_cinfo_127_cfa_info);
		     if (
			PROCEDUREP(next_method1999_98_2365))
		       {	/* Cfa/cinfo.scm 86 */
			  old1862_2359 =
			     PROCEDURE_ENTRY(next_method1999_98_2365) (next_method1999_98_2365,
			     (obj_t) (o_2355), s_2356, BEOA);
		       }
		     else
		       {	/* Cfa/cinfo.scm 86 */
			  PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method1999_98_2365);
			  {	/* Cfa/cinfo.scm 86 */
			     object_bglt aux_10741;
			     aux_10741 =
				struct_object__object_93___object(
				(object_bglt) (o_2355), s_2356);
			     old1862_2359 =
				(obj_t) (aux_10741);
			  }
		       }
		  }
		  aux1863_2360 =
		     STRUCT_REF(s_2356, ((long) 0));
		  {	/* Cfa/cinfo.scm 86 */
		     make_box_cinfo_127_bglt new1864_2361;
		     new1864_2361 =
			((make_box_cinfo_127_bglt) (old1862_2359));
		     {	/* Cfa/cinfo.scm 86 */
			long arg2475_2362;
			arg2475_2362 =
			   class_num_218___object(make_box_cinfo_127_cfa_info);
			{	/* Cfa/cinfo.scm 86 */
			   obj_t obj_4165;
			   obj_4165 =
			      (obj_t) (new1864_2361);
			   (((obj_t) CREF(obj_4165))->header = MAKE_HEADER(arg2475_2362, 0), BUNSPEC);
			}
		     }
		     {	/* Cfa/cinfo.scm 86 */
			make_box_cinfo_127_bglt arg2476_2363;
			{	/* Cfa/cinfo.scm 86 */
			   make_box_cinfo_127_bglt res2746_4172;
			   {	/* Cfa/cinfo.scm 86 */
			      approx_bglt approx_4169;
			      {		/* Cfa/cinfo.scm 86 */
				 obj_t aux_10750;
				 aux_10750 =
				    STRUCT_REF(aux1863_2360, ((long) 0));
				 approx_4169 =
				    (approx_bglt) (aux_10750);
			      }
			      {		/* Cfa/cinfo.scm 86 */
				 make_box_cinfo_127_bglt new1853_4170;
				 new1853_4170 =
				    ((make_box_cinfo_127_bglt) BREF(GC_MALLOC(sizeof(struct make_box_cinfo_127))));
				 ((((make_box_cinfo_127_bglt) CREF(new1853_4170))->approx) = ((approx_bglt) approx_4169), BUNSPEC);
				 res2746_4172 = new1853_4170;
			      }
			   }
			   arg2476_2363 = res2746_4172;
			}
			{	/* Cfa/cinfo.scm 86 */
			   obj_t aux_10757;
			   object_bglt aux_10755;
			   aux_10757 =
			      (obj_t) (arg2476_2363);
			   aux_10755 =
			      (object_bglt) (new1864_2361);
			   OBJECT_WIDENING_SET(aux_10755, aux_10757);
			}
		     }
		     aux_10732 = new1864_2361;
		  }
	       }
	    }
	    return
	       (obj_t) (aux_10732);
	 }
      }
   }
}



/* object->struct-make-box/cinfo1998 */
obj_t 
object__struct_make_box_cinfo1998_55_cfa_info(obj_t env_6216, obj_t obj1859_6217)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 86 */
      {
	 make_box_cinfo_127_bglt obj1859_2345;
	 obj1859_2345 =
	    (make_box_cinfo_127_bglt) (obj1859_6217);
	 {

	    {	/* Cfa/cinfo.scm 86 */
	       obj_t res1860_2348;
	       {	/* Cfa/cinfo.scm 86 */
		  obj_t next_method1997_20_2353;
		  next_method1997_20_2353 =
		     find_super_class_method_167___object(
		     (object_bglt) (obj1859_2345), object__struct_env_210___object, make_box_cinfo_127_cfa_info);
		  if (
		     PROCEDUREP(next_method1997_20_2353))
		    {	/* Cfa/cinfo.scm 86 */
		       res1860_2348 =
			  PROCEDURE_ENTRY(next_method1997_20_2353) (next_method1997_20_2353,
			  (obj_t) (obj1859_2345), BEOA);
		    }
		  else
		    {	/* Cfa/cinfo.scm 86 */
		       PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method1997_20_2353);
		       res1860_2348 =
			  object__struct_50___object(
			  (object_bglt) (obj1859_2345));
		    }
	       }
	       {	/* Cfa/cinfo.scm 86 */
		  obj_t aux1861_2349;
		  {	/* ./Llib/struct.scm 1415 */
		     obj_t aux_10772;
		     aux_10772 =
			CNST_TABLE_REF(((long) 24));
		     aux1861_2349 =
			make_struct(aux_10772, ((long) 1), BUNSPEC);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_10775;
		     {	/* Cfa/cinfo.scm 86 */
			approx_bglt aux_10776;
			{
			   obj_t aux_10777;
			   {	/* Cfa/cinfo.scm 86 */
			      object_bglt aux_10778;
			      aux_10778 =
				 (object_bglt) (obj1859_2345);
			      aux_10777 =
				 OBJECT_WIDENING(aux_10778);
			   }
			   aux_10776 =
			      (((make_box_cinfo_127_bglt) CREF(aux_10777))->approx);
			}
			aux_10775 =
			   (obj_t) (aux_10776);
		     }
		     STRUCT_SET(aux1861_2349, ((long) 0), aux_10775);
		  }
		  STRUCT_SET(res1860_2348, ((long) 0), aux1861_2349);
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_10785;
		     aux_10785 =
			STRUCT_KEY(res1860_2348);
		     STRUCT_KEY_SET(aux1861_2349, aux_10785);
		  }
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_10788;
		     aux_10788 =
			CNST_TABLE_REF(((long) 24));
		     STRUCT_KEY_SET(res1860_2348, aux_10788);
		  }
		  return res1860_2348;
	       }
	    }
	 }
      }
   }
}



/* struct+object->object-make-box/o-cinfo1996 */
obj_t 
struct_object__object_make_box_o_cinfo1996_29_cfa_info(obj_t env_6218, obj_t o_6219, obj_t s_6220)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 87 */
      {
	 make_box_o_cinfo_96_bglt o_2332;
	 obj_t s_2333;
	 {	/* Cfa/cinfo.scm 87 */
	    make_box_o_cinfo_96_bglt aux_10792;
	    o_2332 =
	       (make_box_o_cinfo_96_bglt) (o_6219);
	    s_2333 = s_6220;
	    {

	       {	/* Cfa/cinfo.scm 87 */
		  obj_t old1880_2336;
		  obj_t aux1881_2337;
		  {	/* Cfa/cinfo.scm 87 */
		     obj_t next_method1995_24_2343;
		     next_method1995_24_2343 =
			find_super_class_method_167___object(
			(object_bglt) (o_2332), struct_object__object_env_209___object, make_box_o_cinfo_96_cfa_info);
		     if (
			PROCEDUREP(next_method1995_24_2343))
		       {	/* Cfa/cinfo.scm 87 */
			  old1880_2336 =
			     PROCEDURE_ENTRY(next_method1995_24_2343) (next_method1995_24_2343,
			     (obj_t) (o_2332), s_2333, BEOA);
		       }
		     else
		       {	/* Cfa/cinfo.scm 87 */
			  PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method1995_24_2343);
			  {	/* Cfa/cinfo.scm 87 */
			     object_bglt aux_10801;
			     aux_10801 =
				struct_object__object_93___object(
				(object_bglt) (o_2332), s_2333);
			     old1880_2336 =
				(obj_t) (aux_10801);
			  }
		       }
		  }
		  aux1881_2337 =
		     STRUCT_REF(s_2333, ((long) 0));
		  {	/* Cfa/cinfo.scm 87 */
		     make_box_o_cinfo_96_bglt new1882_2338;
		     new1882_2338 =
			((make_box_o_cinfo_96_bglt) (old1880_2336));
		     {	/* Cfa/cinfo.scm 87 */
			long arg2466_2339;
			arg2466_2339 =
			   class_num_218___object(make_box_o_cinfo_96_cfa_info);
			{	/* Cfa/cinfo.scm 87 */
			   obj_t obj_4132;
			   obj_4132 =
			      (obj_t) (new1882_2338);
			   (((obj_t) CREF(obj_4132))->header = MAKE_HEADER(arg2466_2339, 0), BUNSPEC);
			}
		     }
		     {	/* Cfa/cinfo.scm 87 */
			make_box_o_cinfo_96_bglt arg2467_2340;
			{	/* Cfa/cinfo.scm 87 */
			   make_box_o_cinfo_96_bglt res2745_4143;
			   {	/* Cfa/cinfo.scm 87 */
			      approx_bglt approx_4138;
			      approx_bglt value_approx_19_4139;
			      {		/* Cfa/cinfo.scm 87 */
				 obj_t aux_10810;
				 aux_10810 =
				    STRUCT_REF(aux1881_2337, ((long) 0));
				 approx_4138 =
				    (approx_bglt) (aux_10810);
			      }
			      {		/* Cfa/cinfo.scm 87 */
				 obj_t aux_10813;
				 aux_10813 =
				    STRUCT_REF(aux1881_2337, ((long) 1));
				 value_approx_19_4139 =
				    (approx_bglt) (aux_10813);
			      }
			      {		/* Cfa/cinfo.scm 87 */
				 make_box_o_cinfo_96_bglt new1870_4140;
				 new1870_4140 =
				    ((make_box_o_cinfo_96_bglt) BREF(GC_MALLOC(sizeof(struct make_box_o_cinfo_96))));
				 ((((make_box_o_cinfo_96_bglt) CREF(new1870_4140))->approx) = ((approx_bglt) approx_4138), BUNSPEC);
				 ((((make_box_o_cinfo_96_bglt) CREF(new1870_4140))->value_approx_19) = ((approx_bglt) value_approx_19_4139), BUNSPEC);
				 res2745_4143 = new1870_4140;
			      }
			   }
			   arg2467_2340 = res2745_4143;
			}
			{	/* Cfa/cinfo.scm 87 */
			   obj_t aux_10821;
			   object_bglt aux_10819;
			   aux_10821 =
			      (obj_t) (arg2467_2340);
			   aux_10819 =
			      (object_bglt) (new1882_2338);
			   OBJECT_WIDENING_SET(aux_10819, aux_10821);
			}
		     }
		     aux_10792 = new1882_2338;
		  }
	       }
	    }
	    return
	       (obj_t) (aux_10792);
	 }
      }
   }
}



/* object->struct-make-box/o-cinfo1994 */
obj_t 
object__struct_make_box_o_cinfo1994_50_cfa_info(obj_t env_6221, obj_t obj1877_6222)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 87 */
      {
	 make_box_o_cinfo_96_bglt obj1877_2320;
	 obj1877_2320 =
	    (make_box_o_cinfo_96_bglt) (obj1877_6222);
	 {

	    {	/* Cfa/cinfo.scm 87 */
	       obj_t res1878_2323;
	       {	/* Cfa/cinfo.scm 87 */
		  obj_t next_method1993_92_2330;
		  next_method1993_92_2330 =
		     find_super_class_method_167___object(
		     (object_bglt) (obj1877_2320), object__struct_env_210___object, make_box_o_cinfo_96_cfa_info);
		  if (
		     PROCEDUREP(next_method1993_92_2330))
		    {	/* Cfa/cinfo.scm 87 */
		       res1878_2323 =
			  PROCEDURE_ENTRY(next_method1993_92_2330) (next_method1993_92_2330,
			  (obj_t) (obj1877_2320), BEOA);
		    }
		  else
		    {	/* Cfa/cinfo.scm 87 */
		       PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method1993_92_2330);
		       res1878_2323 =
			  object__struct_50___object(
			  (object_bglt) (obj1877_2320));
		    }
	       }
	       {	/* Cfa/cinfo.scm 87 */
		  obj_t aux1879_2324;
		  {	/* ./Llib/struct.scm 1415 */
		     obj_t aux_10836;
		     aux_10836 =
			CNST_TABLE_REF(((long) 25));
		     aux1879_2324 =
			make_struct(aux_10836, ((long) 2), BUNSPEC);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_10839;
		     {	/* Cfa/cinfo.scm 87 */
			approx_bglt aux_10840;
			{
			   obj_t aux_10841;
			   {	/* Cfa/cinfo.scm 87 */
			      object_bglt aux_10842;
			      aux_10842 =
				 (object_bglt) (obj1877_2320);
			      aux_10841 =
				 OBJECT_WIDENING(aux_10842);
			   }
			   aux_10840 =
			      (((make_box_o_cinfo_96_bglt) CREF(aux_10841))->approx);
			}
			aux_10839 =
			   (obj_t) (aux_10840);
		     }
		     STRUCT_SET(aux1879_2324, ((long) 0), aux_10839);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_10848;
		     {	/* Cfa/cinfo.scm 87 */
			approx_bglt aux_10849;
			{
			   obj_t aux_10850;
			   {	/* Cfa/cinfo.scm 89 */
			      object_bglt aux_10851;
			      aux_10851 =
				 (object_bglt) (obj1877_2320);
			      aux_10850 =
				 OBJECT_WIDENING(aux_10851);
			   }
			   aux_10849 =
			      (((make_box_o_cinfo_96_bglt) CREF(aux_10850))->value_approx_19);
			}
			aux_10848 =
			   (obj_t) (aux_10849);
		     }
		     STRUCT_SET(aux1879_2324, ((long) 1), aux_10848);
		  }
		  STRUCT_SET(res1878_2323, ((long) 0), aux1879_2324);
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_10858;
		     aux_10858 =
			STRUCT_KEY(res1878_2323);
		     STRUCT_KEY_SET(aux1879_2324, aux_10858);
		  }
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_10861;
		     aux_10861 =
			CNST_TABLE_REF(((long) 25));
		     STRUCT_KEY_SET(res1878_2323, aux_10861);
		  }
		  return res1878_2323;
	       }
	    }
	 }
      }
   }
}



/* struct+object->object-box-set!/cinfo1992 */
obj_t 
struct_object__object_box_set__cinfo1992_103_cfa_info(obj_t env_6223, obj_t o_6224, obj_t s_6225)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 90 */
      {
	 box_set__cinfo_94_bglt o_2308;
	 obj_t s_2309;
	 {	/* Cfa/cinfo.scm 90 */
	    box_set__cinfo_94_bglt aux_10865;
	    o_2308 =
	       (box_set__cinfo_94_bglt) (o_6224);
	    s_2309 = s_6225;
	    {

	       {	/* Cfa/cinfo.scm 90 */
		  obj_t old1895_2312;
		  obj_t aux1896_2313;
		  {	/* Cfa/cinfo.scm 90 */
		     obj_t next_method1991_17_2318;
		     next_method1991_17_2318 =
			find_super_class_method_167___object(
			(object_bglt) (o_2308), struct_object__object_env_209___object, box_set__cinfo_94_cfa_info);
		     if (
			PROCEDUREP(next_method1991_17_2318))
		       {	/* Cfa/cinfo.scm 90 */
			  old1895_2312 =
			     PROCEDURE_ENTRY(next_method1991_17_2318) (next_method1991_17_2318,
			     (obj_t) (o_2308), s_2309, BEOA);
		       }
		     else
		       {	/* Cfa/cinfo.scm 90 */
			  PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method1991_17_2318);
			  {	/* Cfa/cinfo.scm 90 */
			     object_bglt aux_10874;
			     aux_10874 =
				struct_object__object_93___object(
				(object_bglt) (o_2308), s_2309);
			     old1895_2312 =
				(obj_t) (aux_10874);
			  }
		       }
		  }
		  aux1896_2313 =
		     STRUCT_REF(s_2309, ((long) 0));
		  {	/* Cfa/cinfo.scm 90 */
		     box_set__cinfo_94_bglt new1897_2314;
		     new1897_2314 =
			((box_set__cinfo_94_bglt) (old1895_2312));
		     {	/* Cfa/cinfo.scm 90 */
			long arg2456_2315;
			arg2456_2315 =
			   class_num_218___object(box_set__cinfo_94_cfa_info);
			{	/* Cfa/cinfo.scm 90 */
			   obj_t obj_4099;
			   obj_4099 =
			      (obj_t) (new1897_2314);
			   (((obj_t) CREF(obj_4099))->header = MAKE_HEADER(arg2456_2315, 0), BUNSPEC);
			}
		     }
		     {	/* Cfa/cinfo.scm 90 */
			box_set__cinfo_94_bglt arg2457_2316;
			{	/* Cfa/cinfo.scm 90 */
			   box_set__cinfo_94_bglt res2744_4106;
			   {	/* Cfa/cinfo.scm 90 */
			      approx_bglt approx_4103;
			      {		/* Cfa/cinfo.scm 90 */
				 obj_t aux_10883;
				 aux_10883 =
				    STRUCT_REF(aux1896_2313, ((long) 0));
				 approx_4103 =
				    (approx_bglt) (aux_10883);
			      }
			      {		/* Cfa/cinfo.scm 90 */
				 box_set__cinfo_94_bglt new1886_4104;
				 new1886_4104 =
				    ((box_set__cinfo_94_bglt) BREF(GC_MALLOC(sizeof(struct box_set__cinfo_94))));
				 ((((box_set__cinfo_94_bglt) CREF(new1886_4104))->approx) = ((approx_bglt) approx_4103), BUNSPEC);
				 res2744_4106 = new1886_4104;
			      }
			   }
			   arg2457_2316 = res2744_4106;
			}
			{	/* Cfa/cinfo.scm 90 */
			   obj_t aux_10890;
			   object_bglt aux_10888;
			   aux_10890 =
			      (obj_t) (arg2457_2316);
			   aux_10888 =
			      (object_bglt) (new1897_2314);
			   OBJECT_WIDENING_SET(aux_10888, aux_10890);
			}
		     }
		     aux_10865 = new1897_2314;
		  }
	       }
	    }
	    return
	       (obj_t) (aux_10865);
	 }
      }
   }
}



/* object->struct-box-set!/cinfo1990 */
obj_t 
object__struct_box_set__cinfo1990_126_cfa_info(obj_t env_6226, obj_t obj1892_6227)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 90 */
      {
	 box_set__cinfo_94_bglt obj1892_2298;
	 obj1892_2298 =
	    (box_set__cinfo_94_bglt) (obj1892_6227);
	 {

	    {	/* Cfa/cinfo.scm 90 */
	       obj_t res1893_2301;
	       {	/* Cfa/cinfo.scm 90 */
		  obj_t next_method1989_216_2306;
		  next_method1989_216_2306 =
		     find_super_class_method_167___object(
		     (object_bglt) (obj1892_2298), object__struct_env_210___object, box_set__cinfo_94_cfa_info);
		  if (
		     PROCEDUREP(next_method1989_216_2306))
		    {	/* Cfa/cinfo.scm 90 */
		       res1893_2301 =
			  PROCEDURE_ENTRY(next_method1989_216_2306) (next_method1989_216_2306,
			  (obj_t) (obj1892_2298), BEOA);
		    }
		  else
		    {	/* Cfa/cinfo.scm 90 */
		       PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method1989_216_2306);
		       res1893_2301 =
			  object__struct_50___object(
			  (object_bglt) (obj1892_2298));
		    }
	       }
	       {	/* Cfa/cinfo.scm 90 */
		  obj_t aux1894_2302;
		  {	/* ./Llib/struct.scm 1415 */
		     obj_t aux_10905;
		     aux_10905 =
			CNST_TABLE_REF(((long) 26));
		     aux1894_2302 =
			make_struct(aux_10905, ((long) 1), BUNSPEC);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_10908;
		     {	/* Cfa/cinfo.scm 90 */
			approx_bglt aux_10909;
			{
			   obj_t aux_10910;
			   {	/* Cfa/cinfo.scm 90 */
			      object_bglt aux_10911;
			      aux_10911 =
				 (object_bglt) (obj1892_2298);
			      aux_10910 =
				 OBJECT_WIDENING(aux_10911);
			   }
			   aux_10909 =
			      (((box_set__cinfo_94_bglt) CREF(aux_10910))->approx);
			}
			aux_10908 =
			   (obj_t) (aux_10909);
		     }
		     STRUCT_SET(aux1894_2302, ((long) 0), aux_10908);
		  }
		  STRUCT_SET(res1893_2301, ((long) 0), aux1894_2302);
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_10918;
		     aux_10918 =
			STRUCT_KEY(res1893_2301);
		     STRUCT_KEY_SET(aux1894_2302, aux_10918);
		  }
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_10921;
		     aux_10921 =
			CNST_TABLE_REF(((long) 26));
		     STRUCT_KEY_SET(res1893_2301, aux_10921);
		  }
		  return res1893_2301;
	       }
	    }
	 }
      }
   }
}



/* struct+object->object-box-ref/cinfo1988 */
obj_t 
struct_object__object_box_ref_cinfo1988_119_cfa_info(obj_t env_6228, obj_t o_6229, obj_t s_6230)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 91 */
      {
	 box_ref_cinfo_214_bglt o_2286;
	 obj_t s_2287;
	 {	/* Cfa/cinfo.scm 91 */
	    box_ref_cinfo_214_bglt aux_10925;
	    o_2286 =
	       (box_ref_cinfo_214_bglt) (o_6229);
	    s_2287 = s_6230;
	    {

	       {	/* Cfa/cinfo.scm 91 */
		  obj_t old1911_2290;
		  obj_t aux1912_2291;
		  {	/* Cfa/cinfo.scm 91 */
		     obj_t next_method1987_63_2296;
		     next_method1987_63_2296 =
			find_super_class_method_167___object(
			(object_bglt) (o_2286), struct_object__object_env_209___object, box_ref_cinfo_214_cfa_info);
		     if (
			PROCEDUREP(next_method1987_63_2296))
		       {	/* Cfa/cinfo.scm 91 */
			  old1911_2290 =
			     PROCEDURE_ENTRY(next_method1987_63_2296) (next_method1987_63_2296,
			     (obj_t) (o_2286), s_2287, BEOA);
		       }
		     else
		       {	/* Cfa/cinfo.scm 91 */
			  PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method1987_63_2296);
			  {	/* Cfa/cinfo.scm 91 */
			     object_bglt aux_10934;
			     aux_10934 =
				struct_object__object_93___object(
				(object_bglt) (o_2286), s_2287);
			     old1911_2290 =
				(obj_t) (aux_10934);
			  }
		       }
		  }
		  aux1912_2291 =
		     STRUCT_REF(s_2287, ((long) 0));
		  {	/* Cfa/cinfo.scm 91 */
		     box_ref_cinfo_214_bglt new1913_2292;
		     new1913_2292 =
			((box_ref_cinfo_214_bglt) (old1911_2290));
		     {	/* Cfa/cinfo.scm 91 */
			long arg2448_2293;
			arg2448_2293 =
			   class_num_218___object(box_ref_cinfo_214_cfa_info);
			{	/* Cfa/cinfo.scm 91 */
			   obj_t obj_4070;
			   obj_4070 =
			      (obj_t) (new1913_2292);
			   (((obj_t) CREF(obj_4070))->header = MAKE_HEADER(arg2448_2293, 0), BUNSPEC);
			}
		     }
		     {	/* Cfa/cinfo.scm 91 */
			box_ref_cinfo_214_bglt arg2449_2294;
			{	/* Cfa/cinfo.scm 91 */
			   box_ref_cinfo_214_bglt res2743_4077;
			   {	/* Cfa/cinfo.scm 91 */
			      approx_bglt approx_4074;
			      {		/* Cfa/cinfo.scm 91 */
				 obj_t aux_10943;
				 aux_10943 =
				    STRUCT_REF(aux1912_2291, ((long) 0));
				 approx_4074 =
				    (approx_bglt) (aux_10943);
			      }
			      {		/* Cfa/cinfo.scm 91 */
				 box_ref_cinfo_214_bglt new1902_4075;
				 new1902_4075 =
				    ((box_ref_cinfo_214_bglt) BREF(GC_MALLOC(sizeof(struct box_ref_cinfo_214))));
				 ((((box_ref_cinfo_214_bglt) CREF(new1902_4075))->approx) = ((approx_bglt) approx_4074), BUNSPEC);
				 res2743_4077 = new1902_4075;
			      }
			   }
			   arg2449_2294 = res2743_4077;
			}
			{	/* Cfa/cinfo.scm 91 */
			   obj_t aux_10950;
			   object_bglt aux_10948;
			   aux_10950 =
			      (obj_t) (arg2449_2294);
			   aux_10948 =
			      (object_bglt) (new1913_2292);
			   OBJECT_WIDENING_SET(aux_10948, aux_10950);
			}
		     }
		     aux_10925 = new1913_2292;
		  }
	       }
	    }
	    return
	       (obj_t) (aux_10925);
	 }
      }
   }
}



/* object->struct-box-ref/cinfo1986 */
obj_t 
object__struct_box_ref_cinfo1986_188_cfa_info(obj_t env_6231, obj_t obj1908_6232)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 91 */
      {
	 box_ref_cinfo_214_bglt obj1908_2276;
	 obj1908_2276 =
	    (box_ref_cinfo_214_bglt) (obj1908_6232);
	 {

	    {	/* Cfa/cinfo.scm 91 */
	       obj_t res1909_2279;
	       {	/* Cfa/cinfo.scm 91 */
		  obj_t next_method1985_37_2284;
		  next_method1985_37_2284 =
		     find_super_class_method_167___object(
		     (object_bglt) (obj1908_2276), object__struct_env_210___object, box_ref_cinfo_214_cfa_info);
		  if (
		     PROCEDUREP(next_method1985_37_2284))
		    {	/* Cfa/cinfo.scm 91 */
		       res1909_2279 =
			  PROCEDURE_ENTRY(next_method1985_37_2284) (next_method1985_37_2284,
			  (obj_t) (obj1908_2276), BEOA);
		    }
		  else
		    {	/* Cfa/cinfo.scm 91 */
		       PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method1985_37_2284);
		       res1909_2279 =
			  object__struct_50___object(
			  (object_bglt) (obj1908_2276));
		    }
	       }
	       {	/* Cfa/cinfo.scm 91 */
		  obj_t aux1910_2280;
		  {	/* ./Llib/struct.scm 1415 */
		     obj_t aux_10965;
		     aux_10965 =
			CNST_TABLE_REF(((long) 27));
		     aux1910_2280 =
			make_struct(aux_10965, ((long) 1), BUNSPEC);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_10968;
		     {	/* Cfa/cinfo.scm 91 */
			approx_bglt aux_10969;
			{
			   obj_t aux_10970;
			   {	/* Cfa/cinfo.scm 91 */
			      object_bglt aux_10971;
			      aux_10971 =
				 (object_bglt) (obj1908_2276);
			      aux_10970 =
				 OBJECT_WIDENING(aux_10971);
			   }
			   aux_10969 =
			      (((box_ref_cinfo_214_bglt) CREF(aux_10970))->approx);
			}
			aux_10968 =
			   (obj_t) (aux_10969);
		     }
		     STRUCT_SET(aux1910_2280, ((long) 0), aux_10968);
		  }
		  STRUCT_SET(res1909_2279, ((long) 0), aux1910_2280);
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_10978;
		     aux_10978 =
			STRUCT_KEY(res1909_2279);
		     STRUCT_KEY_SET(aux1910_2280, aux_10978);
		  }
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_10981;
		     aux_10981 =
			CNST_TABLE_REF(((long) 27));
		     STRUCT_KEY_SET(res1909_2279, aux_10981);
		  }
		  return res1909_2279;
	       }
	    }
	 }
      }
   }
}



/* struct+object->object-box-set!/o-cinfo1984 */
obj_t 
struct_object__object_box_set__o_cinfo1984_135_cfa_info(obj_t env_6233, obj_t o_6234, obj_t s_6235)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 92 */
      {
	 box_set__o_cinfo_6_bglt o_2264;
	 obj_t s_2265;
	 {	/* Cfa/cinfo.scm 92 */
	    box_set__o_cinfo_6_bglt aux_10985;
	    o_2264 =
	       (box_set__o_cinfo_6_bglt) (o_6234);
	    s_2265 = s_6235;
	    {

	       {	/* Cfa/cinfo.scm 92 */
		  obj_t old1926_2268;
		  obj_t aux1927_2269;
		  {	/* Cfa/cinfo.scm 92 */
		     obj_t next_method1983_39_2274;
		     next_method1983_39_2274 =
			find_super_class_method_167___object(
			(object_bglt) (o_2264), struct_object__object_env_209___object, box_set__o_cinfo_6_cfa_info);
		     if (
			PROCEDUREP(next_method1983_39_2274))
		       {	/* Cfa/cinfo.scm 92 */
			  old1926_2268 =
			     PROCEDURE_ENTRY(next_method1983_39_2274) (next_method1983_39_2274,
			     (obj_t) (o_2264), s_2265, BEOA);
		       }
		     else
		       {	/* Cfa/cinfo.scm 92 */
			  PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method1983_39_2274);
			  {	/* Cfa/cinfo.scm 92 */
			     object_bglt aux_10994;
			     aux_10994 =
				struct_object__object_93___object(
				(object_bglt) (o_2264), s_2265);
			     old1926_2268 =
				(obj_t) (aux_10994);
			  }
		       }
		  }
		  aux1927_2269 =
		     STRUCT_REF(s_2265, ((long) 0));
		  {	/* Cfa/cinfo.scm 92 */
		     box_set__o_cinfo_6_bglt new1928_2270;
		     new1928_2270 =
			((box_set__o_cinfo_6_bglt) (old1926_2268));
		     {	/* Cfa/cinfo.scm 92 */
			long arg2440_2271;
			arg2440_2271 =
			   class_num_218___object(box_set__o_cinfo_6_cfa_info);
			{	/* Cfa/cinfo.scm 92 */
			   obj_t obj_4041;
			   obj_4041 =
			      (obj_t) (new1928_2270);
			   (((obj_t) CREF(obj_4041))->header = MAKE_HEADER(arg2440_2271, 0), BUNSPEC);
			}
		     }
		     {	/* Cfa/cinfo.scm 92 */
			box_set__o_cinfo_6_bglt arg2441_2272;
			{	/* Cfa/cinfo.scm 92 */
			   box_set__o_cinfo_6_bglt res2742_4048;
			   {	/* Cfa/cinfo.scm 92 */
			      approx_bglt approx_4045;
			      {		/* Cfa/cinfo.scm 92 */
				 obj_t aux_11003;
				 aux_11003 =
				    STRUCT_REF(aux1927_2269, ((long) 0));
				 approx_4045 =
				    (approx_bglt) (aux_11003);
			      }
			      {		/* Cfa/cinfo.scm 92 */
				 box_set__o_cinfo_6_bglt new1917_4046;
				 new1917_4046 =
				    ((box_set__o_cinfo_6_bglt) BREF(GC_MALLOC(sizeof(struct box_set__o_cinfo_6))));
				 ((((box_set__o_cinfo_6_bglt) CREF(new1917_4046))->approx) = ((approx_bglt) approx_4045), BUNSPEC);
				 res2742_4048 = new1917_4046;
			      }
			   }
			   arg2441_2272 = res2742_4048;
			}
			{	/* Cfa/cinfo.scm 92 */
			   obj_t aux_11010;
			   object_bglt aux_11008;
			   aux_11010 =
			      (obj_t) (arg2441_2272);
			   aux_11008 =
			      (object_bglt) (new1928_2270);
			   OBJECT_WIDENING_SET(aux_11008, aux_11010);
			}
		     }
		     aux_10985 = new1928_2270;
		  }
	       }
	    }
	    return
	       (obj_t) (aux_10985);
	 }
      }
   }
}



/* object->struct-box-set!/o-cinfo1982 */
obj_t 
object__struct_box_set__o_cinfo1982_221_cfa_info(obj_t env_6236, obj_t obj1923_6237)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 92 */
      {
	 box_set__o_cinfo_6_bglt obj1923_2254;
	 obj1923_2254 =
	    (box_set__o_cinfo_6_bglt) (obj1923_6237);
	 {

	    {	/* Cfa/cinfo.scm 92 */
	       obj_t res1924_2257;
	       {	/* Cfa/cinfo.scm 92 */
		  obj_t next_method1981_146_2262;
		  next_method1981_146_2262 =
		     find_super_class_method_167___object(
		     (object_bglt) (obj1923_2254), object__struct_env_210___object, box_set__o_cinfo_6_cfa_info);
		  if (
		     PROCEDUREP(next_method1981_146_2262))
		    {	/* Cfa/cinfo.scm 92 */
		       res1924_2257 =
			  PROCEDURE_ENTRY(next_method1981_146_2262) (next_method1981_146_2262,
			  (obj_t) (obj1923_2254), BEOA);
		    }
		  else
		    {	/* Cfa/cinfo.scm 92 */
		       PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method1981_146_2262);
		       res1924_2257 =
			  object__struct_50___object(
			  (object_bglt) (obj1923_2254));
		    }
	       }
	       {	/* Cfa/cinfo.scm 92 */
		  obj_t aux1925_2258;
		  {	/* ./Llib/struct.scm 1415 */
		     obj_t aux_11025;
		     aux_11025 =
			CNST_TABLE_REF(((long) 28));
		     aux1925_2258 =
			make_struct(aux_11025, ((long) 1), BUNSPEC);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_11028;
		     {	/* Cfa/cinfo.scm 92 */
			approx_bglt aux_11029;
			{
			   obj_t aux_11030;
			   {	/* Cfa/cinfo.scm 92 */
			      object_bglt aux_11031;
			      aux_11031 =
				 (object_bglt) (obj1923_2254);
			      aux_11030 =
				 OBJECT_WIDENING(aux_11031);
			   }
			   aux_11029 =
			      (((box_set__o_cinfo_6_bglt) CREF(aux_11030))->approx);
			}
			aux_11028 =
			   (obj_t) (aux_11029);
		     }
		     STRUCT_SET(aux1925_2258, ((long) 0), aux_11028);
		  }
		  STRUCT_SET(res1924_2257, ((long) 0), aux1925_2258);
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_11038;
		     aux_11038 =
			STRUCT_KEY(res1924_2257);
		     STRUCT_KEY_SET(aux1925_2258, aux_11038);
		  }
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_11041;
		     aux_11041 =
			CNST_TABLE_REF(((long) 28));
		     STRUCT_KEY_SET(res1924_2257, aux_11041);
		  }
		  return res1924_2257;
	       }
	    }
	 }
      }
   }
}



/* struct+object->object-box-ref/o-cinfo1980 */
obj_t 
struct_object__object_box_ref_o_cinfo1980_207_cfa_info(obj_t env_6238, obj_t o_6239, obj_t s_6240)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 93 */
      {
	 box_ref_o_cinfo_98_bglt o_2242;
	 obj_t s_2243;
	 {	/* Cfa/cinfo.scm 93 */
	    box_ref_o_cinfo_98_bglt aux_11045;
	    o_2242 =
	       (box_ref_o_cinfo_98_bglt) (o_6239);
	    s_2243 = s_6240;
	    {

	       {	/* Cfa/cinfo.scm 93 */
		  obj_t old1943_2246;
		  obj_t aux1944_2247;
		  {	/* Cfa/cinfo.scm 93 */
		     obj_t next_method1979_170_2252;
		     next_method1979_170_2252 =
			find_super_class_method_167___object(
			(object_bglt) (o_2242), struct_object__object_env_209___object, box_ref_o_cinfo_98_cfa_info);
		     if (
			PROCEDUREP(next_method1979_170_2252))
		       {	/* Cfa/cinfo.scm 93 */
			  old1943_2246 =
			     PROCEDURE_ENTRY(next_method1979_170_2252) (next_method1979_170_2252,
			     (obj_t) (o_2242), s_2243, BEOA);
		       }
		     else
		       {	/* Cfa/cinfo.scm 93 */
			  PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method1979_170_2252);
			  {	/* Cfa/cinfo.scm 93 */
			     object_bglt aux_11054;
			     aux_11054 =
				struct_object__object_93___object(
				(object_bglt) (o_2242), s_2243);
			     old1943_2246 =
				(obj_t) (aux_11054);
			  }
		       }
		  }
		  aux1944_2247 =
		     STRUCT_REF(s_2243, ((long) 0));
		  {	/* Cfa/cinfo.scm 93 */
		     box_ref_o_cinfo_98_bglt new1945_2248;
		     new1945_2248 =
			((box_ref_o_cinfo_98_bglt) (old1943_2246));
		     {	/* Cfa/cinfo.scm 93 */
			long arg2432_2249;
			arg2432_2249 =
			   class_num_218___object(box_ref_o_cinfo_98_cfa_info);
			{	/* Cfa/cinfo.scm 93 */
			   obj_t obj_4012;
			   obj_4012 =
			      (obj_t) (new1945_2248);
			   (((obj_t) CREF(obj_4012))->header = MAKE_HEADER(arg2432_2249, 0), BUNSPEC);
			}
		     }
		     {	/* Cfa/cinfo.scm 93 */
			box_ref_o_cinfo_98_bglt arg2433_2250;
			{	/* Cfa/cinfo.scm 93 */
			   box_ref_o_cinfo_98_bglt res2741_4019;
			   {	/* Cfa/cinfo.scm 93 */
			      approx_bglt approx_4016;
			      {		/* Cfa/cinfo.scm 93 */
				 obj_t aux_11063;
				 aux_11063 =
				    STRUCT_REF(aux1944_2247, ((long) 0));
				 approx_4016 =
				    (approx_bglt) (aux_11063);
			      }
			      {		/* Cfa/cinfo.scm 93 */
				 box_ref_o_cinfo_98_bglt new1933_4017;
				 new1933_4017 =
				    ((box_ref_o_cinfo_98_bglt) BREF(GC_MALLOC(sizeof(struct box_ref_o_cinfo_98))));
				 ((((box_ref_o_cinfo_98_bglt) CREF(new1933_4017))->approx) = ((approx_bglt) approx_4016), BUNSPEC);
				 res2741_4019 = new1933_4017;
			      }
			   }
			   arg2433_2250 = res2741_4019;
			}
			{	/* Cfa/cinfo.scm 93 */
			   obj_t aux_11070;
			   object_bglt aux_11068;
			   aux_11070 =
			      (obj_t) (arg2433_2250);
			   aux_11068 =
			      (object_bglt) (new1945_2248);
			   OBJECT_WIDENING_SET(aux_11068, aux_11070);
			}
		     }
		     aux_11045 = new1945_2248;
		  }
	       }
	    }
	    return
	       (obj_t) (aux_11045);
	 }
      }
   }
}



/* object->struct-box-ref/o-cinfo1978 */
obj_t 
object__struct_box_ref_o_cinfo1978_69_cfa_info(obj_t env_6241, obj_t obj1940_6242)
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 93 */
      {
	 box_ref_o_cinfo_98_bglt obj1940_2232;
	 obj1940_2232 =
	    (box_ref_o_cinfo_98_bglt) (obj1940_6242);
	 {

	    {	/* Cfa/cinfo.scm 93 */
	       obj_t res1941_2235;
	       {	/* Cfa/cinfo.scm 93 */
		  obj_t next_method1977_119_2240;
		  next_method1977_119_2240 =
		     find_super_class_method_167___object(
		     (object_bglt) (obj1940_2232), object__struct_env_210___object, box_ref_o_cinfo_98_cfa_info);
		  if (
		     PROCEDUREP(next_method1977_119_2240))
		    {	/* Cfa/cinfo.scm 93 */
		       res1941_2235 =
			  PROCEDURE_ENTRY(next_method1977_119_2240) (next_method1977_119_2240,
			  (obj_t) (obj1940_2232), BEOA);
		    }
		  else
		    {	/* Cfa/cinfo.scm 93 */
		       PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method1977_119_2240);
		       res1941_2235 =
			  object__struct_50___object(
			  (object_bglt) (obj1940_2232));
		    }
	       }
	       {	/* Cfa/cinfo.scm 93 */
		  obj_t aux1942_2236;
		  {	/* ./Llib/struct.scm 1415 */
		     obj_t aux_11085;
		     aux_11085 =
			CNST_TABLE_REF(((long) 29));
		     aux1942_2236 =
			make_struct(aux_11085, ((long) 1), BUNSPEC);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_11088;
		     {	/* Cfa/cinfo.scm 93 */
			approx_bglt aux_11089;
			{
			   obj_t aux_11090;
			   {	/* Cfa/cinfo.scm 93 */
			      object_bglt aux_11091;
			      aux_11091 =
				 (object_bglt) (obj1940_2232);
			      aux_11090 =
				 OBJECT_WIDENING(aux_11091);
			   }
			   aux_11089 =
			      (((box_ref_o_cinfo_98_bglt) CREF(aux_11090))->approx);
			}
			aux_11088 =
			   (obj_t) (aux_11089);
		     }
		     STRUCT_SET(aux1942_2236, ((long) 0), aux_11088);
		  }
		  STRUCT_SET(res1941_2235, ((long) 0), aux1942_2236);
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_11098;
		     aux_11098 =
			STRUCT_KEY(res1941_2235);
		     STRUCT_KEY_SET(aux1942_2236, aux_11098);
		  }
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_11101;
		     aux_11101 =
			CNST_TABLE_REF(((long) 29));
		     STRUCT_KEY_SET(res1941_2235, aux_11101);
		  }
		  return res1941_2235;
	       }
	    }
	 }
      }
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_cfa_info()
{
   AN_OBJECT;
   {	/* Cfa/cinfo.scm 14 */
      module_initialization_70_type_type(((long) 0), "CFA_INFO");
      module_initialization_70_type_cache(((long) 0), "CFA_INFO");
      module_initialization_70_ast_var(((long) 0), "CFA_INFO");
      return
	 module_initialization_70_ast_node(((long) 0), "CFA_INFO");
   }
}
