/*===========================================================================*/
/*   (Cfa/cinfo2.scm)                                                        */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;

typedef struct approx
  {
     header_t header;
     obj_t widening;
     struct type *type;
     bool_t type_locked__184;
     obj_t allocs;
     bool_t top__138;
     long lost_stamp_114;
  }
      *approx_bglt;

typedef struct cfun_cinfo_200
  {
     struct approx *approx;
  }
              *cfun_cinfo_200_bglt;

typedef struct extern_sfun_cinfo_6
  {
     struct approx *approx;
  }
                   *extern_sfun_cinfo_6_bglt;

typedef struct intern_sfun_cinfo_192
  {
     struct approx *approx;
     long stamp;
  }
                     *intern_sfun_cinfo_192_bglt;

typedef struct scnst_cinfo_0
  {
     struct approx *approx;
  }
             *scnst_cinfo_0_bglt;

typedef struct pre_clo_env_191
  {
     char dummy;
  }
               *pre_clo_env_191_bglt;

typedef struct svar_cinfo_166
  {
     struct approx *approx;
     bool_t clo_env__87;
  }
              *svar_cinfo_166_bglt;

typedef struct cvar_cinfo_53
  {
     struct approx *approx;
  }
             *cvar_cinfo_53_bglt;

typedef struct sexit_cinfo_49
  {
     struct approx *approx;
  }
              *sexit_cinfo_49_bglt;

typedef struct reshaped_local_224
  {
     obj_t binding_value_3;
  }
                  *reshaped_local_224_bglt;

typedef struct reshaped_global_160
  {
     char dummy;
  }
                   *reshaped_global_160_bglt;

typedef struct atom_cinfo_155
  {
     struct approx *approx;
  }
              *atom_cinfo_155_bglt;

typedef struct kwote_node_102
  {
     struct node *node;
  }
              *kwote_node_102_bglt;

typedef struct kwote_cinfo_48
  {
     struct approx *approx;
  }
              *kwote_cinfo_48_bglt;

typedef struct app_ly_cinfo_234
  {
     struct approx *approx;
  }
                *app_ly_cinfo_234_bglt;

typedef struct funcall_cinfo_75
  {
     struct approx *approx;
     struct approx *va_approx_63;
     bool_t arity_error_noticed__118;
     bool_t type_error_noticed__36;
  }
                *funcall_cinfo_75_bglt;

typedef struct pragma_cinfo_220
  {
     struct approx *approx;
  }
                *pragma_cinfo_220_bglt;

typedef struct setq_cinfo_191
  {
     struct approx *approx;
  }
              *setq_cinfo_191_bglt;

typedef struct conditional_cinfo_212
  {
     struct approx *approx;
  }
                     *conditional_cinfo_212_bglt;

typedef struct fail_cinfo_75
  {
     struct approx *approx;
  }
             *fail_cinfo_75_bglt;

typedef struct select_cinfo_150
  {
     struct approx *approx;
  }
                *select_cinfo_150_bglt;

typedef struct set_ex_it_cinfo_168
  {
     struct approx *approx;
  }
                   *set_ex_it_cinfo_168_bglt;

typedef struct jump_ex_it_cinfo_139
  {
     struct approx *approx;
  }
                    *jump_ex_it_cinfo_139_bglt;

typedef struct pre_make_box_186
  {
     char dummy;
  }
                *pre_make_box_186_bglt;

typedef struct make_box_cinfo_127
  {
     struct approx *approx;
  }
                  *make_box_cinfo_127_bglt;

typedef struct make_box_o_cinfo_96
  {
     struct approx *approx;
     struct approx *value_approx_19;
  }
                   *make_box_o_cinfo_96_bglt;

typedef struct box_set__cinfo_94
  {
     struct approx *approx;
  }
                 *box_set__cinfo_94_bglt;

typedef struct box_ref_cinfo_214
  {
     struct approx *approx;
  }
                 *box_ref_cinfo_214_bglt;

typedef struct box_set__o_cinfo_6
  {
     struct approx *approx;
  }
                  *box_set__o_cinfo_6_bglt;

typedef struct box_ref_o_cinfo_98
  {
     struct approx *approx;
  }
                  *box_ref_o_cinfo_98_bglt;

typedef struct pre_make_procedure_app_60
  {
     struct variable *owner;
  }
                         *pre_make_procedure_app_60_bglt;

typedef struct pre_procedure_ref_app_85
  {
     char dummy;
  }
                        *pre_procedure_ref_app_85_bglt;

typedef struct pre_procedure_set__app_208
  {
     char dummy;
  }
                          *pre_procedure_set__app_208_bglt;

typedef struct make_procedure_app_48
  {
     struct approx *approx;
     long values_approx_len_106;
     struct approx **values_approx_79;
     long lost_stamp_114;
     bool_t x_t__142;
     bool_t x;
     bool_t t;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
  }
                     *make_procedure_app_48_bglt;

typedef struct procedure_ref_app_49
  {
     struct approx *approx;
  }
                    *procedure_ref_app_49_bglt;

typedef struct procedure_set__app_32
  {
     struct approx *approx;
  }
                     *procedure_set__app_32_bglt;

typedef struct pre_make_vector_app_251
  {
     struct variable *owner;
  }
                       *pre_make_vector_app_251_bglt;

typedef struct pre_create_vector_app_162
  {
     struct variable *owner;
  }
                         *pre_create_vector_app_162_bglt;

typedef struct pre_vector_ref_app_208
  {
     char dummy;
  }
                      *pre_vector_ref_app_208_bglt;

typedef struct pre_vector_set__app_211
  {
     char dummy;
  }
                       *pre_vector_set__app_211_bglt;

typedef struct make_vector_app_205
  {
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
     bool_t seen__39;
  }
                   *make_vector_app_205_bglt;

typedef struct create_vector_app_150
  {
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
     bool_t seen__39;
  }
                     *create_vector_app_150_bglt;

typedef struct vector_ref_app_195
  {
     struct approx *approx;
  }
                  *vector_ref_app_195_bglt;

typedef struct vector_set__app_21
  {
     struct approx *approx;
  }
                  *vector_set__app_21_bglt;

typedef struct pre_make_struct_app_218
  {
     struct variable *owner;
  }
                       *pre_make_struct_app_218_bglt;

typedef struct pre_struct_ref_app_207
  {
     char dummy;
  }
                      *pre_struct_ref_app_207_bglt;

typedef struct pre_struct_set__app_116
  {
     char dummy;
  }
                       *pre_struct_set__app_116_bglt;

typedef struct make_struct_app_214
  {
     struct approx *approx;
     struct approx *value_approx_19;
     long lost_stamp_114;
     struct variable *owner;
     bool_t stackable__42;
     obj_t stack_stamp_31;
  }
                   *make_struct_app_214_bglt;

typedef struct struct_ref_app_73
  {
     struct approx *approx;
  }
                 *struct_ref_app_73_bglt;

typedef struct struct_set__app_162
  {
     struct approx *approx;
  }
                   *struct_set__app_162_bglt;


static obj_t _pre_vector_set__app_fun_set__189_cfa_info2(obj_t, obj_t, obj_t);
static obj_t _make_create_vector_app_218_cfa_info2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t make_procedure_app_stack_info_60_cfa_info2(app_bglt);
extern variable_bglt make_struct_app_owner_33_cfa_info2(make_struct_app_214_bglt);
extern app_bglt allocate_pre_make_vector_app_231_cfa_info2();
extern obj_t vector_set__app_stack_info_174_cfa_info2(app_bglt);
static obj_t _make_procedure_app_x_t__234_cfa_info2(obj_t, obj_t);
static obj_t _pre_procedure_set__app_fun_238_cfa_info2(obj_t, obj_t);
static obj_t _struct_ref_app_stack_info_96_cfa_info2(obj_t, obj_t);
static obj_t _create_vector_app_seen__64_cfa_info2(obj_t, obj_t);
static obj_t _pre_procedure_set__app_args_set__34_cfa_info2(obj_t, obj_t, obj_t);
extern obj_t struct_set__app_type_set__172_cfa_info2(app_bglt, type_bglt);
static obj_t _widening_pre_vector_ref_app_135_cfa_info2(obj_t);
static obj_t _vector_set__app_args_set__11_cfa_info2(obj_t, obj_t, obj_t);
static obj_t method_init_76_cfa_info2();
static obj_t _make_vector_app_approx_98_cfa_info2(obj_t, obj_t);
static obj_t _make_pre_struct_ref_app_219_cfa_info2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t _make_pre_make_vector_app_64_cfa_info2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t struct_set__app_loc_83_cfa_info2(app_bglt);
static obj_t object__struct_vector_ref_app2204_84_cfa_info2(obj_t, obj_t);
extern obj_t make_vector_app_lost_stamp_set__132_cfa_info2(make_vector_app_205_bglt, long);
static obj_t _make_vector_app_seen__50_cfa_info2(obj_t, obj_t);
extern obj_t pre_vector_ref_app_loc_154_cfa_info2(app_bglt);
extern obj_t pre_make_vector_app_fun_set__108_cfa_info2(app_bglt, var_bglt);
extern var_bglt pre_make_vector_app_fun_151_cfa_info2(app_bglt);
extern obj_t make_procedure_app_key_144_cfa_info2(app_bglt);
static obj_t _procedure_ref_app_approx_193_cfa_info2(obj_t, obj_t);
static obj_t _create_vector_app_stack_stamp_set__88_cfa_info2(obj_t, obj_t, obj_t);
static obj_t _pre_procedure_set__app_args_86_cfa_info2(obj_t, obj_t);
static obj_t _make_procedure_app_key_set_2904_180_cfa_info2(obj_t, obj_t, obj_t);
static obj_t _create_vector_app_owner_147_cfa_info2(obj_t, obj_t);
extern obj_t struct_ref_app_side_effect__151_cfa_info2(app_bglt);
extern obj_t make_procedure_app_stack_stamp_100_cfa_info2(make_procedure_app_48_bglt);
extern app_bglt allocate_make_vector_app_226_cfa_info2();
extern bool_t make_struct_app_stackable__22_cfa_info2(make_struct_app_214_bglt);
extern obj_t make_struct_app_approx_set__191_cfa_info2(make_struct_app_214_bglt, approx_bglt);
static obj_t _create_vector_app_stackable__232_cfa_info2(obj_t, obj_t);
extern obj_t pre_struct_ref_app_side_effect__set__16_cfa_info2(app_bglt, obj_t);
extern obj_t make_struct_app_key_set__110_cfa_info2(app_bglt, obj_t);
extern obj_t struct_set__app_key_92_cfa_info2(app_bglt);
static obj_t _make_procedure_app_side_effect__232_cfa_info2(obj_t, obj_t);
static obj_t struct_object__object_make_vector_app2214_23_cfa_info2(obj_t, obj_t, obj_t);
extern var_bglt pre_make_procedure_app_fun_199_cfa_info2(app_bglt);
extern obj_t pre_vector_set__app_side_effect__17_cfa_info2(app_bglt);
static obj_t _struct_set__app_args_set__240_cfa_info2(obj_t, obj_t, obj_t);
extern approx_bglt create_vector_app_approx_174_cfa_info2(create_vector_app_150_bglt);
static obj_t _make_vector_app_owner_231_cfa_info2(obj_t, obj_t);
extern obj_t pre_vector_ref_app_key_59_cfa_info2(app_bglt);
extern type_bglt make_struct_app_type_23_cfa_info2(app_bglt);
static obj_t _pre_make_procedure_app_side_effect__18_cfa_info2(obj_t, obj_t);
extern type_bglt vector_set__app_type_116_cfa_info2(app_bglt);
extern obj_t pre_procedure_set__app_side_effect__40_cfa_info2(app_bglt);
static obj_t _make_procedure_app_x_t__set__129_cfa_info2(obj_t, obj_t, obj_t);
static obj_t _allocate_pre_create_vector_app_171_cfa_info2(obj_t);
extern obj_t struct_ref_app_args_190_cfa_info2(app_bglt);
static obj_t _make_struct_set__app_236_cfa_info2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t pre_make_struct_app_side_effect__189_cfa_info2(app_bglt);
obj_t pre_struct_set__app_116_cfa_info2 = BUNSPEC;
extern obj_t make_vector_app_stackable__set__110_cfa_info2(make_vector_app_205_bglt, bool_t);
extern obj_t struct_set__app_args_163_cfa_info2(app_bglt);
static obj_t _allocate_pre_make_procedure_app_108_cfa_info2(obj_t);
extern obj_t make_struct_app_loc_176_cfa_info2(app_bglt);
extern bool_t struct_set__app__191_cfa_info2(obj_t);
extern pre_vector_ref_app_208_bglt make_pre_vector_ref_app_82_cfa_info2(obj_t, type_bglt, obj_t, obj_t, var_bglt, obj_t, obj_t);
static obj_t _pre_make_vector_app_args_80_cfa_info2(obj_t, obj_t);
static obj_t _create_vector_app_approx_set__24_cfa_info2(obj_t, obj_t, obj_t);
extern bool_t vector_ref_app__203_cfa_info2(obj_t);
static obj_t _pre_vector_ref_app_args_set__174_cfa_info2(obj_t, obj_t, obj_t);
static obj_t _pre_procedure_set__app_stack_info_set__185_cfa_info2(obj_t, obj_t, obj_t);
extern app_bglt allocate_pre_vector_set__app_20_cfa_info2();
extern obj_t make_struct_app_stack_info_set__189_cfa_info2(app_bglt, obj_t);
static obj_t _pre_make_procedure_app_args_121_cfa_info2(obj_t, obj_t);
static obj_t _create_vector_app_loc_52_cfa_info2(obj_t, obj_t);
extern bool_t pre_create_vector_app__191_cfa_info2(obj_t);
extern pre_struct_set__app_116_bglt widening_pre_struct_set__app_140_cfa_info2();
static obj_t _make_pre_vector_set__app_51_cfa_info2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern var_bglt make_procedure_app_fun_101_cfa_info2(app_bglt);
extern obj_t create_vector_app_stack_stamp_set__220_cfa_info2(create_vector_app_150_bglt, obj_t);
static obj_t _widening_create_vector_app2887_17_cfa_info2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t _pre_struct_ref_app_loc_255_cfa_info2(obj_t, obj_t);
extern obj_t pre_vector_set__app_loc_126_cfa_info2(app_bglt);
static obj_t _make_make_struct_app_137_cfa_info2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
obj_t pre_make_struct_app_218_cfa_info2 = BUNSPEC;
static obj_t _make_struct_app_fun_set__143_cfa_info2(obj_t, obj_t, obj_t);
extern obj_t make_vector_app_fun_set__56_cfa_info2(app_bglt, var_bglt);
extern obj_t pre_struct_ref_app_side_effect__198_cfa_info2(app_bglt);
extern obj_t make_struct_app_key_199_cfa_info2(app_bglt);
static obj_t _make_procedure_app_approx_set__151_cfa_info2(obj_t, obj_t, obj_t);
static obj_t _make_procedure_app_owner_91_cfa_info2(obj_t, obj_t);
extern vector_ref_app_195_bglt widening_vector_ref_app_88_cfa_info2(approx_bglt);
extern procedure_ref_app_49_bglt make_procedure_ref_app_197_cfa_info2(obj_t, type_bglt, obj_t, obj_t, var_bglt, obj_t, obj_t, approx_bglt);
static obj_t object__struct_pre_make_vector_app2228_114_cfa_info2(obj_t, obj_t);
static obj_t _procedure_ref_app_fun_set__32_cfa_info2(obj_t, obj_t, obj_t);
static obj_t _pre_procedure_ref_app_loc_210_cfa_info2(obj_t, obj_t);
obj_t pre_create_vector_app_162_cfa_info2 = BUNSPEC;
static obj_t _vector_ref_app_type_64_cfa_info2(obj_t, obj_t);
extern obj_t pre_vector_set__app_stack_info_set__9_cfa_info2(app_bglt, obj_t);
static obj_t _pre_make_struct_app_stack_info_136_cfa_info2(obj_t, obj_t);
extern var_bglt struct_set__app_fun_107_cfa_info2(app_bglt);
static obj_t _make_struct_app_stack_stamp_set__239_cfa_info2(obj_t, obj_t, obj_t);
extern obj_t pre_vector_set__app_stack_info_98_cfa_info2(app_bglt);
extern obj_t procedure_set__app_type_set__29_cfa_info2(app_bglt, type_bglt);
static obj_t _create_vector_app_key_171_cfa_info2(obj_t, obj_t);
static obj_t _make_procedure_set__app_65_cfa_info2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern app_bglt allocate_vector_set__app_126_cfa_info2();
extern bool_t pre_vector_set__app__39_cfa_info2(obj_t);
extern var_bglt pre_vector_ref_app_fun_8_cfa_info2(app_bglt);
extern pre_make_struct_app_218_bglt widening_pre_make_struct_app_228_cfa_info2(variable_bglt);
extern obj_t pre_make_vector_app_stack_info_set__175_cfa_info2(app_bglt, obj_t);
extern long make_procedure_app_lost_stamp_58_cfa_info2(make_procedure_app_48_bglt);
static obj_t _procedure_set__app_stack_info_94_cfa_info2(obj_t, obj_t);
static obj_t _pre_struct_ref_app_key2879_31_cfa_info2(obj_t, obj_t);
extern obj_t pre_vector_set__app_key_243_cfa_info2(app_bglt);
extern obj_t pre_make_procedure_app_stack_info_161_cfa_info2(app_bglt);
extern obj_t pre_make_struct_app_args_set__137_cfa_info2(app_bglt, obj_t);
static obj_t _widening_make_procedure_app2903_110_cfa_info2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t pre_make_vector_app_type_set__223_cfa_info2(app_bglt, type_bglt);
static obj_t _struct_set__app_stack_info_135_cfa_info2(obj_t, obj_t);
extern obj_t make_procedure_app_args_set__42_cfa_info2(app_bglt, obj_t);
static obj_t _pre_make_struct_app_key_set__46_cfa_info2(obj_t, obj_t, obj_t);
extern obj_t pre_vector_ref_app_args_207_cfa_info2(app_bglt);
static obj_t _pre_make_struct_app_type_57_cfa_info2(obj_t, obj_t);
static obj_t _pre_make_vector_app__65_cfa_info2(obj_t, obj_t);
static obj_t _pre_vector_ref_app_type_244_cfa_info2(obj_t, obj_t);
extern obj_t struct_ref_app_fun_set__15_cfa_info2(app_bglt, var_bglt);
static obj_t _pre_vector_set__app_type_156_cfa_info2(obj_t, obj_t);
extern obj_t procedure_ref_app_key_set__89_cfa_info2(app_bglt, obj_t);
extern obj_t pre_procedure_ref_app_stack_info_22_cfa_info2(app_bglt);
extern obj_t make_procedure_app_x_set__126_cfa_info2(make_procedure_app_48_bglt, bool_t);
extern obj_t procedure_ref_app_stack_info_set__100_cfa_info2(app_bglt, obj_t);
extern object_bglt struct_object__object_93___object(object_bglt, obj_t);
extern variable_bglt pre_create_vector_app_owner_119_cfa_info2(pre_create_vector_app_162_bglt);
static obj_t _pre_procedure_ref_app__123_cfa_info2(obj_t, obj_t);
static obj_t _pre_struct_set__app_args_129_cfa_info2(obj_t, obj_t);
extern obj_t pre_procedure_set__app_stack_info_set__151_cfa_info2(app_bglt, obj_t);
extern obj_t add_method__1___object(obj_t, obj_t, obj_t);
extern obj_t pre_procedure_set__app_loc_154_cfa_info2(app_bglt);
extern approx_bglt procedure_set__app_approx_70_cfa_info2(procedure_set__app_32_bglt);
extern obj_t pre_create_vector_app_args_163_cfa_info2(app_bglt);
static obj_t _make_procedure_app__219_cfa_info2(obj_t, obj_t);
extern approx_bglt make_vector_app_value_approx_202_cfa_info2(make_vector_app_205_bglt);
static obj_t _make_pre_make_procedure_app_8_cfa_info2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern var_bglt make_struct_app_fun_76_cfa_info2(app_bglt);
static obj_t _create_vector_app_type_100_cfa_info2(obj_t, obj_t);
extern pre_make_vector_app_251_bglt make_pre_make_vector_app_107_cfa_info2(obj_t, type_bglt, obj_t, obj_t, var_bglt, obj_t, obj_t, variable_bglt);
extern obj_t pre_create_vector_app_stack_info_137_cfa_info2(app_bglt);
static obj_t _make_vector_app_type_115_cfa_info2(obj_t, obj_t);
static obj_t _pre_vector_ref_app_fun_set__225_cfa_info2(obj_t, obj_t, obj_t);
static obj_t _vector_set__app_approx_118_cfa_info2(obj_t, obj_t);
static obj_t _struct_ref_app_type_set__133_cfa_info2(obj_t, obj_t, obj_t);
extern obj_t make_procedure_app_side_effect__185_cfa_info2(app_bglt);
extern obj_t pre_make_struct_app_fun_set__18_cfa_info2(app_bglt, var_bglt);
static obj_t _allocate_pre_make_vector_app_80_cfa_info2(obj_t);
static obj_t _create_vector_app_fun_195_cfa_info2(obj_t, obj_t);
extern variable_bglt pre_make_procedure_app_owner_169_cfa_info2(pre_make_procedure_app_60_bglt);
extern approx_bglt procedure_ref_app_approx_118_cfa_info2(procedure_ref_app_49_bglt);
obj_t pre_procedure_set__app_208_cfa_info2 = BUNSPEC;
extern obj_t make_struct_app_stack_stamp_197_cfa_info2(make_struct_app_214_bglt);
extern struct_ref_app_73_bglt make_struct_ref_app_97_cfa_info2(obj_t, type_bglt, obj_t, obj_t, var_bglt, obj_t, obj_t, approx_bglt);
extern app_bglt allocate_procedure_ref_app_165_cfa_info2();
extern obj_t pre_vector_set__app_type_set__58_cfa_info2(app_bglt, type_bglt);
extern obj_t pre_make_procedure_app_type_set__46_cfa_info2(app_bglt, type_bglt);
extern struct_set__app_162_bglt widening_struct_set__app_221_cfa_info2(approx_bglt);
static obj_t _pre_create_vector_app_stack_info_set__170_cfa_info2(obj_t, obj_t, obj_t);
static obj_t _pre_struct_ref_app_fun_118_cfa_info2(obj_t, obj_t);
extern var_bglt pre_vector_set__app_fun_157_cfa_info2(app_bglt);
static obj_t _pre_vector_ref_app_key_set_2893_33_cfa_info2(obj_t, obj_t, obj_t);
extern obj_t pre_procedure_set__app_key_59_cfa_info2(app_bglt);
extern app_bglt allocate_pre_make_procedure_app_4_cfa_info2();
extern obj_t procedure_set__app_loc_37_cfa_info2(app_bglt);
extern obj_t find_super_class_method_167___object(object_bglt, obj_t, obj_t);
extern obj_t create_vector_app_args_44_cfa_info2(app_bglt);
static obj_t _pre_make_procedure_app__252_cfa_info2(obj_t, obj_t);
extern obj_t pre_procedure_ref_app_stack_info_set__115_cfa_info2(app_bglt, obj_t);
static obj_t _pre_make_vector_app_fun_set__159_cfa_info2(obj_t, obj_t, obj_t);
static obj_t _procedure_ref_app_key2902_254_cfa_info2(obj_t, obj_t);
static obj_t _pre_procedure_ref_app_fun_224_cfa_info2(obj_t, obj_t);
extern obj_t pre_procedure_set__app_args_set__156_cfa_info2(app_bglt, obj_t);
static obj_t _pre_vector_ref_app_side_effect__11_cfa_info2(obj_t, obj_t);
extern obj_t vector_ref_app_loc_223_cfa_info2(app_bglt);
static obj_t _struct_ref_app_approx_29_cfa_info2(obj_t, obj_t);
extern approx_bglt make_procedure_app_values_approx_ref_67_cfa_info2(make_procedure_app_48_bglt, long);
static obj_t _create_vector_app_stack_stamp_254_cfa_info2(obj_t, obj_t);
static obj_t struct_object__object_make_procedure_app2242_168_cfa_info2(obj_t, obj_t, obj_t);
extern obj_t pre_procedure_ref_app_args_98_cfa_info2(app_bglt);
obj_t struct_set__app_162_cfa_info2 = BUNSPEC;
obj_t vector_ref_app_195_cfa_info2 = BUNSPEC;
static obj_t _procedure_ref_app_type_117_cfa_info2(obj_t, obj_t);
extern app_bglt allocate_pre_struct_ref_app_69_cfa_info2();
extern pre_create_vector_app_162_bglt make_pre_create_vector_app_207_cfa_info2(obj_t, type_bglt, obj_t, obj_t, var_bglt, obj_t, obj_t, variable_bglt);
extern make_struct_app_214_bglt widening_make_struct_app_51_cfa_info2(approx_bglt, approx_bglt, long, variable_bglt, bool_t, obj_t);
static obj_t struct_object__object_vector_set__app2202_239_cfa_info2(obj_t, obj_t, obj_t);
static obj_t object__struct_pre_struct_ref_app2192_6_cfa_info2(obj_t, obj_t);
extern obj_t pre_make_vector_app_args_212_cfa_info2(app_bglt);
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t make_procedure_app_stack_stamp_set__40_cfa_info2(make_procedure_app_48_bglt, obj_t);
static obj_t _allocate_make_procedure_app_241_cfa_info2(obj_t);
extern obj_t pre_struct_set__app_type_set__207_cfa_info2(app_bglt, type_bglt);
static obj_t _procedure_set__app_key2899_177_cfa_info2(obj_t, obj_t);
static obj_t _pre_make_procedure_app_stack_info_105_cfa_info2(obj_t, obj_t);
extern pre_make_procedure_app_60_bglt widening_pre_make_procedure_app_11_cfa_info2(variable_bglt);
extern obj_t procedure_set__app_key_241_cfa_info2(app_bglt);
static obj_t _widening_pre_make_struct_app2880_148_cfa_info2(obj_t, obj_t);
extern bool_t make_procedure_app_stackable__92_cfa_info2(make_procedure_app_48_bglt);
static obj_t _make_procedure_app_stack_stamp_199_cfa_info2(obj_t, obj_t);
extern obj_t vector_ref_app_key_24_cfa_info2(app_bglt);
extern pre_vector_set__app_211_bglt make_pre_vector_set__app_26_cfa_info2(obj_t, type_bglt, obj_t, obj_t, var_bglt, obj_t, obj_t);
extern obj_t procedure_ref_app_loc_250_cfa_info2(app_bglt);
static obj_t struct_object__object_pre_make_procedure_app2254_182_cfa_info2(obj_t, obj_t, obj_t);
obj_t make_struct_app_214_cfa_info2 = BUNSPEC;
static obj_t struct_object__object_pre_vector_ref_app2222_114_cfa_info2(obj_t, obj_t, obj_t);
extern obj_t procedure_ref_app_args_118_cfa_info2(app_bglt);
extern obj_t pre_struct_ref_app_type_set__101_cfa_info2(app_bglt, type_bglt);
extern obj_t vector_ref_app_stack_info_set__142_cfa_info2(app_bglt, obj_t);
extern make_procedure_app_48_bglt widening_make_procedure_app_45_cfa_info2(approx_bglt, long, approx_bglt, long, bool_t, bool_t, bool_t, variable_bglt, bool_t, obj_t);
extern obj_t pre_struct_set__app_loc_71_cfa_info2(app_bglt);
extern type_bglt procedure_set__app_type_50_cfa_info2(app_bglt);
static obj_t _allocate_pre_vector_set__app_63_cfa_info2(obj_t);
static obj_t _procedure_ref_app_stack_info_set__26_cfa_info2(obj_t, obj_t, obj_t);
static obj_t _struct_set__app_type_189_cfa_info2(obj_t, obj_t);
static obj_t object__struct_make_vector_app2212_75_cfa_info2(obj_t, obj_t);
static obj_t _make_struct_app__44_cfa_info2(obj_t, obj_t);
extern obj_t module_initialization_70_cfa_info2(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_cfa_info(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern var_bglt pre_procedure_set__app_fun_8_cfa_info2(app_bglt);
static obj_t _make_vector_app_stack_info_46_cfa_info2(obj_t, obj_t);
static obj_t _procedure_set__app__159_cfa_info2(obj_t, obj_t);
extern obj_t make_struct_app_fun_set__249_cfa_info2(app_bglt, var_bglt);
extern obj_t pre_procedure_ref_app_side_effect__set__159_cfa_info2(app_bglt, obj_t);
extern variable_bglt make_procedure_app_owner_38_cfa_info2(make_procedure_app_48_bglt);
static obj_t object__struct_procedure_ref_app2236_175_cfa_info2(obj_t, obj_t);
extern pre_procedure_set__app_208_bglt make_pre_procedure_set__app_49_cfa_info2(obj_t, type_bglt, obj_t, obj_t, var_bglt, obj_t, obj_t);
obj_t pre_struct_ref_app_207_cfa_info2 = BUNSPEC;
extern obj_t pre_procedure_ref_app_key_set__34_cfa_info2(app_bglt, obj_t);
static obj_t _struct_ref_app_type_252_cfa_info2(obj_t, obj_t);
static obj_t _widening_pre_struct_set__app_119_cfa_info2(obj_t);
extern bool_t create_vector_app__151_cfa_info2(obj_t);
extern obj_t make_vector_app_side_effect__209_cfa_info2(app_bglt);
static obj_t _vector_ref_app__210_cfa_info2(obj_t, obj_t);
static obj_t _pre_struct_ref_app__54_cfa_info2(obj_t, obj_t);
extern obj_t vector_ref_app_side_effect__111_cfa_info2(app_bglt);
static obj_t _pre_procedure_ref_app_type_set__111_cfa_info2(obj_t, obj_t, obj_t);
static obj_t _vector_ref_app_type_set__190_cfa_info2(obj_t, obj_t, obj_t);
static obj_t _pre_create_vector_app_type_set__81_cfa_info2(obj_t, obj_t, obj_t);
extern obj_t procedure_ref_app_key_147_cfa_info2(app_bglt);
static obj_t object__struct_pre_vector_set__app2216_102_cfa_info2(obj_t, obj_t);
extern obj_t struct_set__app_side_effect__159_cfa_info2(app_bglt);
static obj_t _make_struct_app_lost_stamp_set__243_cfa_info2(obj_t, obj_t, obj_t);
extern obj_t procedure_ref_app_side_effect__178_cfa_info2(app_bglt);
extern obj_t pre_struct_set__app_key_246_cfa_info2(app_bglt);
static obj_t _pre_make_vector_app_owner_96_cfa_info2(obj_t, obj_t);
static obj_t _allocate_create_vector_app_246_cfa_info2(obj_t);
static obj_t _pre_make_struct_app_type_set__21_cfa_info2(obj_t, obj_t, obj_t);
static obj_t _procedure_set__app_type_set__16_cfa_info2(obj_t, obj_t, obj_t);
extern var_bglt procedure_set__app_fun_41_cfa_info2(app_bglt);
obj_t procedure_ref_app_49_cfa_info2 = BUNSPEC;
static obj_t _pre_procedure_set__app__169_cfa_info2(obj_t, obj_t);
extern type_bglt make_procedure_app_type_193_cfa_info2(app_bglt);
static obj_t _pre_vector_set__app_key2892_212_cfa_info2(obj_t, obj_t);
static obj_t _widening_pre_make_procedure_app2909_172_cfa_info2(obj_t, obj_t);
static obj_t _struct_set__app_stack_info_set__31_cfa_info2(obj_t, obj_t, obj_t);
extern obj_t pre_struct_ref_app_args_87_cfa_info2(app_bglt);
extern type_bglt pre_make_struct_app_type_250_cfa_info2(app_bglt);
static obj_t _struct_ref_app_loc_25_cfa_info2(obj_t, obj_t);
static obj_t _pre_struct_ref_app_type_66_cfa_info2(obj_t, obj_t);
extern var_bglt vector_ref_app_fun_217_cfa_info2(app_bglt);
static obj_t _make_procedure_app_fun_set__92_cfa_info2(obj_t, obj_t, obj_t);
extern type_bglt pre_vector_set__app_type_92_cfa_info2(app_bglt);
extern obj_t pre_make_struct_app_loc_207_cfa_info2(app_bglt);
static obj_t _pre_struct_set__app_stack_info_set__234_cfa_info2(obj_t, obj_t, obj_t);
extern variable_bglt pre_make_struct_app_owner_50_cfa_info2(pre_make_struct_app_218_bglt);
static obj_t _pre_vector_set__app_stack_info_11_cfa_info2(obj_t, obj_t);
static obj_t _pre_create_vector_app_loc_79_cfa_info2(obj_t, obj_t);
extern obj_t make_struct_app_stack_stamp_set__112_cfa_info2(make_struct_app_214_bglt, obj_t);
extern obj_t pre_struct_set__app_args_53_cfa_info2(app_bglt);
static obj_t _make_struct_app_args_135_cfa_info2(obj_t, obj_t);
extern struct_set__app_162_bglt make_struct_set__app_96_cfa_info2(obj_t, type_bglt, obj_t, obj_t, var_bglt, obj_t, obj_t, approx_bglt);
static obj_t _vector_set__app_args_118_cfa_info2(obj_t, obj_t);
static obj_t _create_vector_app_fun_set__241_cfa_info2(obj_t, obj_t, obj_t);
extern long make_procedure_app_values_approx_len_202_cfa_info2(make_procedure_app_48_bglt);
static obj_t _make_procedure_app_stack_info_set__180_cfa_info2(obj_t, obj_t, obj_t);
static obj_t _make_procedure_app_args_set__120_cfa_info2(obj_t, obj_t, obj_t);
static obj_t _procedure_set__app_args_0_cfa_info2(obj_t, obj_t);
extern app_bglt allocate_procedure_set__app_12_cfa_info2();
extern obj_t struct_ref_app_type_set__226_cfa_info2(app_bglt, type_bglt);
extern app_bglt allocate_struct_ref_app_224_cfa_info2();
extern long class_num_218___object(obj_t);
extern obj_t pre_vector_ref_app_side_effect__40_cfa_info2(app_bglt);
static obj_t _make_struct_app_stackable__set__138_cfa_info2(obj_t, obj_t, obj_t);
static obj_t _make_procedure_app_t_set__41_cfa_info2(obj_t, obj_t, obj_t);
extern obj_t struct_ref_app_stack_info_set__87_cfa_info2(app_bglt, obj_t);
static obj_t _pre_vector_ref_app_stack_info_125_cfa_info2(obj_t, obj_t);
static obj_t _pre_make_vector_app_args_set__164_cfa_info2(obj_t, obj_t, obj_t);
extern approx_bglt vector_ref_app_approx_240_cfa_info2(vector_ref_app_195_bglt);
static obj_t _make_vector_app_value_approx_28_cfa_info2(obj_t, obj_t);
static obj_t _widening_procedure_set__app2897_196_cfa_info2(obj_t, obj_t);
extern obj_t procedure_ref_app_type_set__61_cfa_info2(app_bglt, type_bglt);
extern obj_t pre_make_struct_app_key_253_cfa_info2(app_bglt);
extern var_bglt procedure_ref_app_fun_180_cfa_info2(app_bglt);
extern obj_t create_vector_app_type_set__83_cfa_info2(app_bglt, type_bglt);
static obj_t _make_vector_app_stack_stamp_set__172_cfa_info2(obj_t, obj_t, obj_t);
static obj_t _pre_create_vector_app_type_67_cfa_info2(obj_t, obj_t);
static obj_t _pre_create_vector_app_key_224_cfa_info2(obj_t, obj_t);
extern type_bglt vector_ref_app_type_35_cfa_info2(app_bglt);
extern make_struct_app_214_bglt make_make_struct_app_186_cfa_info2(obj_t, type_bglt, obj_t, obj_t, var_bglt, obj_t, obj_t, approx_bglt, approx_bglt, long, variable_bglt, bool_t, obj_t);
extern obj_t pre_vector_ref_app_type_set__203_cfa_info2(app_bglt, type_bglt);
extern var_bglt pre_struct_set__app_fun_114_cfa_info2(app_bglt);
static obj_t _make_vector_app_seen__set__29_cfa_info2(obj_t, obj_t, obj_t);
static obj_t _make_make_vector_app_59_cfa_info2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern procedure_ref_app_49_bglt widening_procedure_ref_app_88_cfa_info2(approx_bglt);
obj_t pre_make_vector_app_251_cfa_info2 = BUNSPEC;
static obj_t _vector_ref_app_side_effect__set__129_cfa_info2(obj_t, obj_t, obj_t);
static obj_t _pre_make_struct_app_fun_set__105_cfa_info2(obj_t, obj_t, obj_t);
static obj_t _procedure_set__app_fun_set__233_cfa_info2(obj_t, obj_t, obj_t);
static obj_t _pre_make_procedure_app_owner_124_cfa_info2(obj_t, obj_t);
static obj_t _make_vector_app_approx_set__9_cfa_info2(obj_t, obj_t, obj_t);
extern obj_t create_vector_app_key_set__126_cfa_info2(app_bglt, obj_t);
extern obj_t procedure_ref_app_fun_set__2_cfa_info2(app_bglt, var_bglt);
extern obj_t pre_vector_ref_app_key_set__8_cfa_info2(app_bglt, obj_t);
extern obj_t make_struct_app_type_set__65_cfa_info2(app_bglt, type_bglt);
extern approx_bglt make_struct_app_value_approx_246_cfa_info2(make_struct_app_214_bglt);
static obj_t _procedure_ref_app__14_cfa_info2(obj_t, obj_t);
obj_t procedure_set__app_32_cfa_info2 = BUNSPEC;
extern obj_t create_vector_app_approx_set__132_cfa_info2(create_vector_app_150_bglt, approx_bglt);
static obj_t _make_procedure_app_args_200_cfa_info2(obj_t, obj_t);
extern obj_t create_vector_app_stack_info_set__169_cfa_info2(app_bglt, obj_t);
extern bool_t make_struct_app__23_cfa_info2(obj_t);
static obj_t _pre_struct_ref_app_fun_set__11_cfa_info2(obj_t, obj_t, obj_t);
extern pre_make_vector_app_251_bglt widening_pre_make_vector_app_235_cfa_info2(variable_bglt);
extern obj_t procedure_ref_app_side_effect__set__126_cfa_info2(app_bglt, obj_t);
static obj_t struct_object__object_struct_set__app2178_127_cfa_info2(obj_t, obj_t, obj_t);
static obj_t _pre_struct_ref_app_stack_info_45_cfa_info2(obj_t, obj_t);
extern obj_t make_procedure_app_stack_info_set__230_cfa_info2(app_bglt, obj_t);
extern bool_t make_vector_app_seen__62_cfa_info2(make_vector_app_205_bglt);
static obj_t _vector_set__app__140_cfa_info2(obj_t, obj_t);
static obj_t _pre_vector_set__app_side_effect__set__216_cfa_info2(obj_t, obj_t, obj_t);
static obj_t _pre_vector_set__app_args_set__6_cfa_info2(obj_t, obj_t, obj_t);
static obj_t _allocate_pre_vector_ref_app_31_cfa_info2(obj_t);
static obj_t _make_vector_app_lost_stamp_194_cfa_info2(obj_t, obj_t);
static obj_t _widening_pre_struct_ref_app_117_cfa_info2(obj_t);
static obj_t _pre_struct_set__app__221_cfa_info2(obj_t, obj_t);
static obj_t _pre_procedure_ref_app_type_154_cfa_info2(obj_t, obj_t);
extern obj_t struct_set__app_stack_info_137_cfa_info2(app_bglt);
static obj_t _make_vector_app_loc_189_cfa_info2(obj_t, obj_t);
extern bool_t pre_make_vector_app__111_cfa_info2(obj_t);
static obj_t imported_modules_init_94_cfa_info2();
static obj_t _struct_ref_app_fun_240_cfa_info2(obj_t, obj_t);
extern bool_t make_procedure_app__51_cfa_info2(obj_t);
extern obj_t pre_procedure_ref_app_type_set__15_cfa_info2(app_bglt, type_bglt);
extern obj_t pre_create_vector_app_type_set__172_cfa_info2(app_bglt, type_bglt);
static obj_t object__struct_pre_make_procedure_app2252_27_cfa_info2(obj_t, obj_t);
extern var_bglt pre_make_struct_app_fun_214_cfa_info2(app_bglt);
static obj_t _struct_set__app_approx_83_cfa_info2(obj_t, obj_t);
static obj_t _make_struct_app_args_set__31_cfa_info2(obj_t, obj_t, obj_t);
extern obj_t vector_ref_app_stack_info_39_cfa_info2(app_bglt);
extern approx_bglt create_vector_app_value_approx_116_cfa_info2(create_vector_app_150_bglt);
static obj_t _pre_create_vector_app_fun_133_cfa_info2(obj_t, obj_t);
extern pre_vector_ref_app_208_bglt widening_pre_vector_ref_app_50_cfa_info2();
extern obj_t make_vector_app_args_set__241_cfa_info2(app_bglt, obj_t);
extern obj_t make_struct_app_lost_stamp_set__51_cfa_info2(make_struct_app_214_bglt, long);
extern obj_t pre_create_vector_app_stack_info_set__211_cfa_info2(app_bglt, obj_t);
static obj_t _make_vector_app_type_set__146_cfa_info2(obj_t, obj_t, obj_t);
static obj_t struct_object__object_procedure_set__app2234_125_cfa_info2(obj_t, obj_t, obj_t);
static obj_t _widening_make_vector_app2889_122_cfa_info2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern type_bglt make_vector_app_type_150_cfa_info2(app_bglt);
static obj_t _make_make_procedure_app_59_cfa_info2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t _procedure_set__app_key_set_2898_103_cfa_info2(obj_t, obj_t, obj_t);
extern obj_t procedure_set__app_stack_info_212_cfa_info2(app_bglt);
extern variable_bglt make_vector_app_owner_193_cfa_info2(make_vector_app_205_bglt);
extern obj_t pre_create_vector_app_side_effect__set__203_cfa_info2(app_bglt, obj_t);
static obj_t _pre_struct_ref_app_type_set__215_cfa_info2(obj_t, obj_t, obj_t);
static obj_t _widening_pre_create_vector_app2895_55_cfa_info2(obj_t, obj_t);
static obj_t _make_vector_set__app_54_cfa_info2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t _pre_make_procedure_app_key_set__107_cfa_info2(obj_t, obj_t, obj_t);
extern obj_t struct_set__app_stack_info_set__211_cfa_info2(app_bglt, obj_t);
obj_t pre_vector_set__app_211_cfa_info2 = BUNSPEC;
extern obj_t vector_ref_app_type_set__10_cfa_info2(app_bglt, type_bglt);
static obj_t struct_object__object_pre_procedure_ref_app2250_42_cfa_info2(obj_t, obj_t, obj_t);
static obj_t _pre_vector_ref_app_side_effect__set__248_cfa_info2(obj_t, obj_t, obj_t);
static obj_t object__struct_vector_set__app2200_231_cfa_info2(obj_t, obj_t);
static obj_t _pre_struct_set__app_args_set__231_cfa_info2(obj_t, obj_t, obj_t);
static obj_t _pre_procedure_set__app_key_set_2905_12_cfa_info2(obj_t, obj_t, obj_t);
static obj_t _make_vector_app_key_198_cfa_info2(obj_t, obj_t);
static obj_t struct_object__object_struct_ref_app2182_41_cfa_info2(obj_t, obj_t, obj_t);
static obj_t struct_object__object_make_struct_app2186_246_cfa_info2(obj_t, obj_t, obj_t);
static obj_t _procedure_ref_app_args_set__247_cfa_info2(obj_t, obj_t, obj_t);
static obj_t _procedure_set__app_side_effect__112_cfa_info2(obj_t, obj_t);
static obj_t _pre_make_vector_app_loc_37_cfa_info2(obj_t, obj_t);
extern obj_t pre_procedure_set__app_args_207_cfa_info2(app_bglt);
extern approx_bglt make_struct_app_approx_49_cfa_info2(make_struct_app_214_bglt);
static obj_t _create_vector_app_args_set__48_cfa_info2(obj_t, obj_t, obj_t);
static obj_t object__struct_pre_struct_set__app2188_114_cfa_info2(obj_t, obj_t);
static obj_t _make_vector_app_key_set_2890_13_cfa_info2(obj_t, obj_t, obj_t);
static obj_t _pre_make_procedure_app_side_effect__set__237_cfa_info2(obj_t, obj_t, obj_t);
extern bool_t make_procedure_app_x_t__146_cfa_info2(make_procedure_app_48_bglt);
extern bool_t create_vector_app_seen__3_cfa_info2(create_vector_app_150_bglt);
static obj_t _pre_procedure_ref_app_side_effect__set__26_cfa_info2(obj_t, obj_t, obj_t);
static obj_t _pre_procedure_set__app_side_effect__59_cfa_info2(obj_t, obj_t);
static obj_t _pre_make_struct_app_side_effect__set__136_cfa_info2(obj_t, obj_t, obj_t);
static obj_t _vector_ref_app_stack_info_set__176_cfa_info2(obj_t, obj_t, obj_t);
static obj_t _pre_vector_ref_app_stack_info_set__99_cfa_info2(obj_t, obj_t, obj_t);
static obj_t _make_procedure_app_approx_34_cfa_info2(obj_t, obj_t);
static obj_t _make_vector_app_side_effect__105_cfa_info2(obj_t, obj_t);
extern obj_t create_vector_app_loc_246_cfa_info2(app_bglt);
extern pre_vector_set__app_211_bglt widening_pre_vector_set__app_251_cfa_info2();
extern pre_struct_ref_app_207_bglt make_pre_struct_ref_app_240_cfa_info2(obj_t, type_bglt, obj_t, obj_t, var_bglt, obj_t, obj_t);
extern obj_t struct_ref_app_stack_info_73_cfa_info2(app_bglt);
static obj_t struct_object__object_pre_procedure_set__app2246_44_cfa_info2(obj_t, obj_t, obj_t);
extern app_bglt allocate_pre_procedure_ref_app_138_cfa_info2();
static obj_t _make_procedure_app_side_effect__set__15_cfa_info2(obj_t, obj_t, obj_t);
extern obj_t pre_struct_set__app_key_set__234_cfa_info2(app_bglt, obj_t);
static obj_t _struct_set__app_key_set_2869_207_cfa_info2(obj_t, obj_t, obj_t);
static obj_t _pre_procedure_set__app_type_set__205_cfa_info2(obj_t, obj_t, obj_t);
extern obj_t vector_set__app_args_set__4_cfa_info2(app_bglt, obj_t);
extern obj_t vector_set__app_side_effect__60_cfa_info2(app_bglt);
static obj_t _vector_ref_app_fun_set__206_cfa_info2(obj_t, obj_t, obj_t);
static obj_t _allocate_vector_ref_app_194_cfa_info2(obj_t);
static obj_t _vector_set__app_type_set__61_cfa_info2(obj_t, obj_t, obj_t);
static obj_t _struct_set__app_side_effect__200_cfa_info2(obj_t, obj_t);
extern obj_t make_struct_app_stackable__set__115_cfa_info2(make_struct_app_214_bglt, bool_t);
static obj_t _widening_struct_ref_app2871_224_cfa_info2(obj_t, obj_t);
static obj_t _create_vector_app_stack_info_set__184_cfa_info2(obj_t, obj_t, obj_t);
extern create_vector_app_150_bglt make_create_vector_app_136_cfa_info2(obj_t, type_bglt, obj_t, obj_t, var_bglt, obj_t, obj_t, approx_bglt, approx_bglt, long, variable_bglt, bool_t, obj_t, bool_t);
static obj_t _make_procedure_app_loc_42_cfa_info2(obj_t, obj_t);
static obj_t _pre_procedure_ref_app_key_set_2907_153_cfa_info2(obj_t, obj_t, obj_t);
static obj_t _pre_make_vector_app_key_241_cfa_info2(obj_t, obj_t);
static obj_t _procedure_ref_app_key_set_2901_89_cfa_info2(obj_t, obj_t, obj_t);
static obj_t object__struct_create_vector_app2208_188_cfa_info2(obj_t, obj_t);
extern obj_t make_struct_app_side_effect__63_cfa_info2(app_bglt);
extern obj_t pre_create_vector_app_key_set__58_cfa_info2(app_bglt, obj_t);
extern obj_t pre_procedure_ref_app_fun_set__152_cfa_info2(app_bglt, var_bglt);
static obj_t _pre_procedure_set__app_type_192_cfa_info2(obj_t, obj_t);
static obj_t struct_object__object_pre_make_vector_app2230_243_cfa_info2(obj_t, obj_t, obj_t);
extern make_vector_app_205_bglt widening_make_vector_app_39_cfa_info2(approx_bglt, approx_bglt, long, variable_bglt, bool_t, obj_t, bool_t);
extern obj_t pre_make_procedure_app_args_217_cfa_info2(app_bglt);
extern approx_bglt make_vector_app_approx_58_cfa_info2(make_vector_app_205_bglt);
static obj_t _procedure_ref_app_side_effect__202_cfa_info2(obj_t, obj_t);
extern variable_bglt create_vector_app_owner_226_cfa_info2(create_vector_app_150_bglt);
static obj_t _pre_procedure_ref_app_side_effect__173_cfa_info2(obj_t, obj_t);
extern obj_t app_ast_node;
static obj_t _pre_make_procedure_app_args_set__56_cfa_info2(obj_t, obj_t, obj_t);
extern obj_t create_vector_app_key_178_cfa_info2(app_bglt);
static obj_t _vector_set__app_stack_info_set__100_cfa_info2(obj_t, obj_t, obj_t);
extern struct_ref_app_73_bglt widening_struct_ref_app_158_cfa_info2(approx_bglt);
obj_t pre_make_procedure_app_60_cfa_info2 = BUNSPEC;
static obj_t object__struct_pre_make_struct_app2196_73_cfa_info2(obj_t, obj_t);
static obj_t library_modules_init_112_cfa_info2();
static obj_t _pre_vector_set__app_stack_info_set__248_cfa_info2(obj_t, obj_t, obj_t);
extern obj_t make_procedure_app_key_set__38_cfa_info2(app_bglt, obj_t);
static obj_t _make_struct_app_stack_info_146_cfa_info2(obj_t, obj_t);
static obj_t _make_vector_app_fun_245_cfa_info2(obj_t, obj_t);
static obj_t _make_vector_app_stack_stamp_138_cfa_info2(obj_t, obj_t);
extern bool_t vector_set__app__15_cfa_info2(obj_t);
extern bool_t procedure_set__app__65_cfa_info2(obj_t);
static obj_t _pre_struct_set__app_key2877_203_cfa_info2(obj_t, obj_t);
static obj_t _make_vector_app_stack_info_set__207_cfa_info2(obj_t, obj_t, obj_t);
static obj_t _make_vector_app_stackable__177_cfa_info2(obj_t, obj_t);
static obj_t _pre_vector_ref_app_loc_114_cfa_info2(obj_t, obj_t);
obj_t make_vector_app_205_cfa_info2 = BUNSPEC;
extern obj_t struct_set__app_args_set__3_cfa_info2(app_bglt, obj_t);
extern obj_t create_vector_app_stack_stamp_255_cfa_info2(create_vector_app_150_bglt);
static obj_t _make_procedure_app_key_248_cfa_info2(obj_t, obj_t);
extern type_bglt struct_ref_app_type_202_cfa_info2(app_bglt);
static obj_t _struct_set__app_type_set__106_cfa_info2(obj_t, obj_t, obj_t);
extern type_bglt struct_set__app_type_138_cfa_info2(app_bglt);
static obj_t _pre_procedure_set__app_side_effect__set__8_cfa_info2(obj_t, obj_t, obj_t);
extern obj_t pre_struct_set__app_stack_info_177_cfa_info2(app_bglt);
static obj_t _pre_make_vector_app_stack_info_set__250_cfa_info2(obj_t, obj_t, obj_t);
static obj_t _pre_make_vector_app_type_50_cfa_info2(obj_t, obj_t);
extern obj_t pre_vector_ref_app_stack_info_set__151_cfa_info2(app_bglt, obj_t);
extern bool_t pre_struct_ref_app__163_cfa_info2(obj_t);
static obj_t _make_vector_ref_app_226_cfa_info2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t make_vector_app_stack_info_168_cfa_info2(app_bglt);
extern obj_t make_struct(obj_t, long, obj_t);
extern obj_t create_vector_app_side_effect__33_cfa_info2(app_bglt);
static obj_t _pre_make_procedure_app_type_166_cfa_info2(obj_t, obj_t);
static obj_t _pre_struct_set__app_side_effect__set__221_cfa_info2(obj_t, obj_t, obj_t);
extern obj_t pre_make_struct_app_stack_info_set__82_cfa_info2(app_bglt, obj_t);
static obj_t _procedure_set__app_side_effect__set__166_cfa_info2(obj_t, obj_t, obj_t);
static obj_t _pre_vector_ref_app_type_set__185_cfa_info2(obj_t, obj_t, obj_t);
static obj_t _struct_ref_app_stack_info_set__154_cfa_info2(obj_t, obj_t, obj_t);
static obj_t _pre_struct_ref_app_stack_info_set__255_cfa_info2(obj_t, obj_t, obj_t);
static obj_t _pre_make_vector_app_fun_41_cfa_info2(obj_t, obj_t);
extern obj_t struct_set__app_key_set__58_cfa_info2(app_bglt, obj_t);
static obj_t _make_struct_app_value_approx_167_cfa_info2(obj_t, obj_t);
extern obj_t create_vector_app_side_effect__set__150_cfa_info2(app_bglt, obj_t);
extern obj_t make_vector_app_stack_stamp_set__141_cfa_info2(make_vector_app_205_bglt, obj_t);
extern obj_t pre_procedure_ref_app_side_effect__41_cfa_info2(app_bglt);
extern app_bglt allocate_create_vector_app_89_cfa_info2();
extern obj_t procedure_set__app_key_set__118_cfa_info2(app_bglt, obj_t);
extern var_bglt create_vector_app_fun_92_cfa_info2(app_bglt);
static obj_t _allocate_struct_set__app_138_cfa_info2(obj_t);
static obj_t toplevel_init_63_cfa_info2();
extern vector_set__app_21_bglt widening_vector_set__app_138_cfa_info2(approx_bglt);
extern obj_t vector_ref_app_side_effect__set__180_cfa_info2(app_bglt, obj_t);
extern obj_t pre_vector_set__app_key_set__109_cfa_info2(app_bglt, obj_t);
static obj_t _make_pre_procedure_ref_app_208_cfa_info2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t pre_make_procedure_app_key_set__101_cfa_info2(app_bglt, obj_t);
extern procedure_set__app_32_bglt make_procedure_set__app_42_cfa_info2(obj_t, type_bglt, obj_t, obj_t, var_bglt, obj_t, obj_t, approx_bglt);
extern obj_t pre_procedure_ref_app_loc_169_cfa_info2(app_bglt);
extern obj_t pre_procedure_set__app_stack_info_34_cfa_info2(app_bglt);
extern obj_t procedure_ref_app_stack_info_176_cfa_info2(app_bglt);
static obj_t _pre_create_vector_app__32_cfa_info2(obj_t, obj_t);
static obj_t object__struct_struct_ref_app2180_75_cfa_info2(obj_t, obj_t);
extern obj_t pre_struct_ref_app_key_set__138_cfa_info2(app_bglt, obj_t);
extern obj_t vector_set__app_side_effect__set__230_cfa_info2(app_bglt, obj_t);
extern pre_procedure_ref_app_85_bglt widening_pre_procedure_ref_app_236_cfa_info2();
extern obj_t procedure_set__app_side_effect__120_cfa_info2(app_bglt);
extern pre_make_procedure_app_60_bglt make_pre_make_procedure_app_142_cfa_info2(obj_t, type_bglt, obj_t, obj_t, var_bglt, obj_t, obj_t, variable_bglt);
extern obj_t make_struct_app_args_183_cfa_info2(app_bglt);
static obj_t _make_procedure_app_fun_72_cfa_info2(obj_t, obj_t);
extern obj_t pre_struct_ref_app_loc_17_cfa_info2(app_bglt);
static obj_t _make_procedure_app_values_approx_set__126_cfa_info2(obj_t, obj_t, obj_t, obj_t);
extern obj_t vector_set__app_args_237_cfa_info2(app_bglt);
static obj_t _vector_set__app_loc_250_cfa_info2(obj_t, obj_t);
extern obj_t create_vector(long);
extern obj_t create_vector_app_fun_set__58_cfa_info2(app_bglt, var_bglt);
extern obj_t pre_vector_ref_app_fun_set__200_cfa_info2(app_bglt, var_bglt);
extern obj_t open_input_string(obj_t);
extern obj_t create_vector_app_stack_info_51_cfa_info2(app_bglt);
extern approx_bglt struct_ref_app_approx_125_cfa_info2(struct_ref_app_73_bglt);
obj_t vector_set__app_21_cfa_info2 = BUNSPEC;
static obj_t _make_struct_app_owner_239_cfa_info2(obj_t, obj_t);
static obj_t _struct_ref_app_side_effect__set__219_cfa_info2(obj_t, obj_t, obj_t);
static obj_t _make_pre_vector_ref_app_92_cfa_info2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t _allocate_make_struct_app_151_cfa_info2(obj_t);
static obj_t _pre_procedure_ref_app_key2908_96_cfa_info2(obj_t, obj_t);
static obj_t _struct_ref_app_key_set_2872_176_cfa_info2(obj_t, obj_t, obj_t);
static obj_t _make_procedure_ref_app_227_cfa_info2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t pre_make_struct_app_type_set__1_cfa_info2(app_bglt, type_bglt);
extern type_bglt pre_vector_ref_app_type_159_cfa_info2(app_bglt);
static obj_t _vector_set__app_key2883_59_cfa_info2(obj_t, obj_t);
static obj_t object__struct_struct_set__app2176_75_cfa_info2(obj_t, obj_t);
static obj_t _struct_ref_app_side_effect__158_cfa_info2(obj_t, obj_t);
static obj_t _widening_vector_set__app2881_128_cfa_info2(obj_t, obj_t);
static obj_t object__struct_make_procedure_app2240_197_cfa_info2(obj_t, obj_t);
static obj_t _struct_set__app_fun_set__251_cfa_info2(obj_t, obj_t, obj_t);
extern obj_t pre_procedure_ref_app_key_86_cfa_info2(app_bglt);
static obj_t _make_struct_app_approx_set__178_cfa_info2(obj_t, obj_t, obj_t);
static obj_t _make_procedure_app_x_209_cfa_info2(obj_t, obj_t);
obj_t struct_ref_app_73_cfa_info2 = BUNSPEC;
extern obj_t make_procedure_app_type_set__163_cfa_info2(app_bglt, type_bglt);
static obj_t _make_procedure_app_t_235_cfa_info2(obj_t, obj_t);
extern obj_t pre_struct_ref_app_stack_info_set__163_cfa_info2(app_bglt, obj_t);
static obj_t _pre_struct_set__app_type_235_cfa_info2(obj_t, obj_t);
static obj_t _pre_vector_ref_app_fun_218_cfa_info2(obj_t, obj_t);
extern obj_t pre_struct_ref_app_key_6_cfa_info2(app_bglt);
extern type_bglt pre_create_vector_app_type_138_cfa_info2(app_bglt);
extern make_vector_app_205_bglt make_make_vector_app_32_cfa_info2(obj_t, type_bglt, obj_t, obj_t, var_bglt, obj_t, obj_t, approx_bglt, approx_bglt, long, variable_bglt, bool_t, obj_t, bool_t);
extern obj_t make_vector_app_seen__set__213_cfa_info2(make_vector_app_205_bglt, bool_t);
static obj_t _create_vector_app_value_approx_26_cfa_info2(obj_t, obj_t);
static obj_t _pre_vector_set__app_loc_128_cfa_info2(obj_t, obj_t);
extern obj_t pre_procedure_set__app_key_set__8_cfa_info2(app_bglt, obj_t);
extern obj_t pre_vector_set__app_side_effect__set__23_cfa_info2(app_bglt, obj_t);
static obj_t _pre_create_vector_app_side_effect__set__231_cfa_info2(obj_t, obj_t, obj_t);
static obj_t _make_procedure_app_stack_stamp_set__110_cfa_info2(obj_t, obj_t, obj_t);
extern obj_t procedure_set__app_args_set__164_cfa_info2(app_bglt, obj_t);
static obj_t object__struct_pre_procedure_set__app2244_179_cfa_info2(obj_t, obj_t);
static obj_t _pre_make_vector_app_side_effect__120_cfa_info2(obj_t, obj_t);
extern obj_t vector_set__app_stack_info_set__132_cfa_info2(app_bglt, obj_t);
static obj_t _pre_struct_set__app_key_set_2876_203_cfa_info2(obj_t, obj_t, obj_t);
static obj_t _vector_ref_app_args_111_cfa_info2(obj_t, obj_t);
static obj_t _pre_make_vector_app_side_effect__set__24_cfa_info2(obj_t, obj_t, obj_t);
extern obj_t make_struct_app_side_effect__set__36_cfa_info2(app_bglt, obj_t);
extern obj_t pre_make_procedure_app_side_effect__30_cfa_info2(app_bglt);
static obj_t _make_struct_app_lost_stamp_65_cfa_info2(obj_t, obj_t);
extern obj_t pre_make_vector_app_stack_info_133_cfa_info2(app_bglt);
static obj_t _pre_struct_set__app_side_effect__220_cfa_info2(obj_t, obj_t);
static obj_t object__struct_pre_vector_ref_app2220_118_cfa_info2(obj_t, obj_t);
static obj_t _vector_set__app_key_set_2882_126_cfa_info2(obj_t, obj_t, obj_t);
extern bool_t pre_procedure_ref_app__89_cfa_info2(obj_t);
extern obj_t make_vector_app_stack_info_set__239_cfa_info2(app_bglt, obj_t);
static obj_t _widening_pre_vector_set__app_64_cfa_info2(obj_t);
extern app_bglt allocate_make_procedure_app_115_cfa_info2();
extern obj_t pre_vector_ref_app_stack_info_34_cfa_info2(app_bglt);
extern obj_t pre_make_vector_app_args_set__250_cfa_info2(app_bglt, obj_t);
extern obj_t vector_set__app_key_set__63_cfa_info2(app_bglt, obj_t);
extern obj_t make_vector_app_loc_140_cfa_info2(app_bglt);
static obj_t _procedure_set__app_stack_info_set__157_cfa_info2(obj_t, obj_t, obj_t);
static obj_t _vector_set__app_side_effect__178_cfa_info2(obj_t, obj_t);
static obj_t _pre_vector_ref_app__133_cfa_info2(obj_t, obj_t);
extern type_bglt create_vector_app_type_249_cfa_info2(app_bglt);
static obj_t struct_object__object_procedure_ref_app2238_38_cfa_info2(obj_t, obj_t, obj_t);
extern bool_t pre_make_procedure_app__25_cfa_info2(obj_t);
static obj_t _pre_make_procedure_app_fun_set__36_cfa_info2(obj_t, obj_t, obj_t);
static obj_t struct_object__object_pre_create_vector_app2226_157_cfa_info2(obj_t, obj_t, obj_t);
static obj_t _make_struct_app_key_set_2875_235_cfa_info2(obj_t, obj_t, obj_t);
static obj_t object__struct_make_struct_app2184_126_cfa_info2(obj_t, obj_t);
extern bool_t pre_struct_set__app__46_cfa_info2(obj_t);
extern approx_bglt vector_set__app_approx_61_cfa_info2(vector_set__app_21_bglt);
extern long make_vector_app_lost_stamp_174_cfa_info2(make_vector_app_205_bglt);
static obj_t _pre_make_procedure_app_loc_53_cfa_info2(obj_t, obj_t);
static obj_t _make_struct_app_side_effect__240_cfa_info2(obj_t, obj_t);
static obj_t _allocate_pre_procedure_ref_app_105_cfa_info2(obj_t);
extern type_bglt pre_procedure_ref_app_type_232_cfa_info2(app_bglt);
static obj_t struct_object__object_pre_vector_set__app2218_143_cfa_info2(obj_t, obj_t, obj_t);
static obj_t _make_procedure_app_stack_info_111_cfa_info2(obj_t, obj_t);
static obj_t _make_procedure_app_x_set__75_cfa_info2(obj_t, obj_t, obj_t);
extern var_bglt pre_procedure_ref_app_fun_172_cfa_info2(app_bglt);
static obj_t _pre_struct_ref_app_side_effect__set__91_cfa_info2(obj_t, obj_t, obj_t);
static obj_t _make_procedure_app_lost_stamp_set__118_cfa_info2(obj_t, obj_t, obj_t);
static obj_t _pre_make_struct_app_args_7_cfa_info2(obj_t, obj_t);
obj_t create_vector_app_150_cfa_info2 = BUNSPEC;
static obj_t _pre_vector_ref_app_args_84_cfa_info2(obj_t, obj_t);
static obj_t _pre_procedure_set__app_stack_info_244_cfa_info2(obj_t, obj_t);
extern obj_t pre_procedure_set__app_type_set__203_cfa_info2(app_bglt, type_bglt);
static obj_t object__struct_pre_procedure_ref_app2248_200_cfa_info2(obj_t, obj_t);
static obj_t _pre_vector_set__app_args_216_cfa_info2(obj_t, obj_t);
extern bool_t struct_ref_app__100_cfa_info2(obj_t);
static obj_t _struct_ref_app_fun_set__28_cfa_info2(obj_t, obj_t, obj_t);
extern app_bglt allocate_pre_struct_set__app_186_cfa_info2();
static obj_t _vector_set__app_side_effect__set__126_cfa_info2(obj_t, obj_t, obj_t);
static obj_t _procedure_set__app_approx_20_cfa_info2(obj_t, obj_t);
extern var_bglt pre_struct_ref_app_fun_229_cfa_info2(app_bglt);
static obj_t _make_vector_app__161_cfa_info2(obj_t, obj_t);
extern obj_t pre_struct_set__app_fun_set__90_cfa_info2(app_bglt, var_bglt);
static obj_t _vector_set__app_fun_180_cfa_info2(obj_t, obj_t);
static obj_t _vector_ref_app_key2886_186_cfa_info2(obj_t, obj_t);
extern type_bglt pre_make_vector_app_type_229_cfa_info2(app_bglt);
extern obj_t pre_make_struct_app_side_effect__set__106_cfa_info2(app_bglt, obj_t);
extern obj_t create_vector_app_seen__set__212_cfa_info2(create_vector_app_150_bglt, bool_t);
static obj_t _struct_ref_app_args_set__245_cfa_info2(obj_t, obj_t, obj_t);
static obj_t _pre_create_vector_app_key_set__20_cfa_info2(obj_t, obj_t, obj_t);
static obj_t _pre_procedure_ref_app_fun_set__20_cfa_info2(obj_t, obj_t, obj_t);
obj_t make_procedure_app_48_cfa_info2 = BUNSPEC;
extern obj_t make_vector_app_key_103_cfa_info2(app_bglt);
static obj_t _make_pre_struct_set__app_92_cfa_info2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t _procedure_set__app_loc_232_cfa_info2(obj_t, obj_t);
extern obj_t pre_struct_ref_app_stack_info_193_cfa_info2(app_bglt);
static obj_t _create_vector_app_args_132_cfa_info2(obj_t, obj_t);
static obj_t _make_vector_app_args_191_cfa_info2(obj_t, obj_t);
extern vector_set__app_21_bglt make_vector_set__app_24_cfa_info2(obj_t, type_bglt, obj_t, obj_t, var_bglt, obj_t, obj_t, approx_bglt);
extern obj_t pre_vector_set__app_args_set__202_cfa_info2(app_bglt, obj_t);
static obj_t _pre_make_procedure_app_key_128_cfa_info2(obj_t, obj_t);
extern obj_t pre_make_procedure_app_side_effect__set__13_cfa_info2(app_bglt, obj_t);
extern obj_t pre_make_procedure_app_args_set__119_cfa_info2(app_bglt, obj_t);
extern obj_t pre_create_vector_app_fun_set__208_cfa_info2(app_bglt, var_bglt);
extern type_bglt procedure_ref_app_type_95_cfa_info2(app_bglt);
extern obj_t vector_ref_app_key_set__80_cfa_info2(app_bglt, obj_t);
static obj_t _pre_make_struct_app__245_cfa_info2(obj_t, obj_t);
static obj_t _pre_procedure_set__app_fun_set__73_cfa_info2(obj_t, obj_t, obj_t);
static obj_t _vector_set__app_fun_set__2_cfa_info2(obj_t, obj_t, obj_t);
extern app_bglt allocate_pre_make_struct_app_64_cfa_info2();
static obj_t _vector_set__app_stack_info_176_cfa_info2(obj_t, obj_t);
extern obj_t struct_set__app_side_effect__set__203_cfa_info2(app_bglt, obj_t);
obj_t pre_procedure_ref_app_85_cfa_info2 = BUNSPEC;
extern obj_t register_class__225___object(obj_t, obj_t, obj_t, long, obj_t, obj_t, obj_t);
extern obj_t procedure_set__app_stack_info_set__250_cfa_info2(app_bglt, obj_t);
extern app_bglt allocate_struct_set__app_3_cfa_info2();
extern obj_t create_vector_app_lost_stamp_set__92_cfa_info2(create_vector_app_150_bglt, long);
static obj_t _pre_create_vector_app_owner_163_cfa_info2(obj_t, obj_t);
static obj_t _pre_vector_set__app_fun_206_cfa_info2(obj_t, obj_t);
static obj_t _create_vector_app_key_set_2888_204_cfa_info2(obj_t, obj_t, obj_t);
static obj_t _pre_struct_set__app_stack_info_246_cfa_info2(obj_t, obj_t);
static obj_t _make_pre_make_struct_app_249_cfa_info2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern long create_vector_app_lost_stamp_72_cfa_info2(create_vector_app_150_bglt);
static obj_t _pre_make_procedure_app_stack_info_set__44_cfa_info2(obj_t, obj_t, obj_t);
extern obj_t make_procedure_app_fun_set__162_cfa_info2(app_bglt, var_bglt);
static obj_t _make_procedure_app_stackable__set__122_cfa_info2(obj_t, obj_t, obj_t);
static obj_t _vector_ref_app_loc_62_cfa_info2(obj_t, obj_t);
static obj_t _allocate_pre_procedure_set__app_24_cfa_info2(obj_t);
extern create_vector_app_150_bglt widening_create_vector_app_230_cfa_info2(approx_bglt, approx_bglt, long, variable_bglt, bool_t, obj_t, bool_t);
static obj_t _create_vector_app_side_effect__114_cfa_info2(obj_t, obj_t);
static obj_t _pre_create_vector_app_side_effect__129_cfa_info2(obj_t, obj_t);
extern obj_t make_procedure_app_lost_stamp_set__66_cfa_info2(make_procedure_app_48_bglt, long);
static obj_t _make_struct_app_side_effect__set__28_cfa_info2(obj_t, obj_t, obj_t);
static obj_t _struct_set__app_loc_220_cfa_info2(obj_t, obj_t);
static obj_t _procedure_ref_app_args_55_cfa_info2(obj_t, obj_t);
extern obj_t pre_struct_set__app_args_set__238_cfa_info2(app_bglt, obj_t);
static obj_t _make_struct_app_stack_stamp_168_cfa_info2(obj_t, obj_t);
extern var_bglt make_vector_app_fun_121_cfa_info2(app_bglt);
extern bool_t pre_procedure_set__app__184_cfa_info2(obj_t);
extern variable_bglt pre_make_vector_app_owner_220_cfa_info2(pre_make_vector_app_251_bglt);
extern app_bglt allocate_make_struct_app_180_cfa_info2();
static obj_t _make_struct_app_stackable__6_cfa_info2(obj_t, obj_t);
static obj_t _procedure_ref_app_stack_info_173_cfa_info2(obj_t, obj_t);
extern obj_t pre_struct_set__app_side_effect__set__33_cfa_info2(app_bglt, obj_t);
extern type_bglt pre_struct_ref_app_type_242_cfa_info2(app_bglt);
extern obj_t pre_struct_ref_app_args_set__168_cfa_info2(app_bglt, obj_t);
static obj_t _pre_make_procedure_app_fun_63_cfa_info2(obj_t, obj_t);
static obj_t _widening_pre_procedure_set__app_89_cfa_info2(obj_t);
extern obj_t struct_set__app_fun_set__208_cfa_info2(app_bglt, var_bglt);
static obj_t object_init_111_cfa_info2();
static obj_t _widening_struct_set__app2868_104_cfa_info2(obj_t, obj_t);
extern obj_t make_struct_app_stack_info_206_cfa_info2(app_bglt);
extern obj_t struct_ref_app_loc_11_cfa_info2(app_bglt);
extern vector_ref_app_195_bglt make_vector_ref_app_105_cfa_info2(obj_t, type_bglt, obj_t, obj_t, var_bglt, obj_t, obj_t, approx_bglt);
extern obj_t pre_procedure_set__app_side_effect__set__95_cfa_info2(app_bglt, obj_t);
extern type_bglt pre_struct_set__app_type_46_cfa_info2(app_bglt);
static obj_t _create_vector_app_stack_info_181_cfa_info2(obj_t, obj_t);
static obj_t _make_struct_app_type_134_cfa_info2(obj_t, obj_t);
extern obj_t create_vector_app_stackable__set__21_cfa_info2(create_vector_app_150_bglt, bool_t);
extern bool_t make_vector_app_stackable__199_cfa_info2(make_vector_app_205_bglt);
static obj_t _vector_set__app_type_95_cfa_info2(obj_t, obj_t);
extern obj_t procedure_set__app_fun_set__159_cfa_info2(app_bglt, var_bglt);
static obj_t _widening_pre_procedure_ref_app_214_cfa_info2(obj_t);
extern obj_t pre_make_vector_app_key_set__238_cfa_info2(app_bglt, obj_t);
extern obj_t make_vector_app_approx_set__66_cfa_info2(make_vector_app_205_bglt, approx_bglt);
static obj_t _procedure_ref_app_side_effect__set__226_cfa_info2(obj_t, obj_t, obj_t);
extern obj_t procedure_set__app_args_80_cfa_info2(app_bglt);
static obj_t _pre_struct_set__app_loc_160_cfa_info2(obj_t, obj_t);
extern obj_t pre_create_vector_app_loc_83_cfa_info2(app_bglt);
static obj_t _procedure_set__app_type_198_cfa_info2(obj_t, obj_t);
static obj_t _struct_set__app_args_213_cfa_info2(obj_t, obj_t);
extern obj_t pre_vector_set__app_fun_set__57_cfa_info2(app_bglt, var_bglt);
extern obj_t pre_make_procedure_app_fun_set__110_cfa_info2(app_bglt, var_bglt);
static obj_t _create_vector_app__45_cfa_info2(obj_t, obj_t);
extern obj_t make_procedure_app_stackable__set__58_cfa_info2(make_procedure_app_48_bglt, bool_t);
static obj_t _allocate_pre_struct_ref_app_15_cfa_info2(obj_t);
static obj_t _pre_procedure_ref_app_args_set__233_cfa_info2(obj_t, obj_t, obj_t);
static obj_t _vector_ref_app_args_set__180_cfa_info2(obj_t, obj_t, obj_t);
extern obj_t pre_vector_ref_app_side_effect__set__95_cfa_info2(app_bglt, obj_t);
static obj_t _pre_create_vector_app_args_set__12_cfa_info2(obj_t, obj_t, obj_t);
static obj_t _procedure_set__app_fun_119_cfa_info2(obj_t, obj_t);
static obj_t _make_procedure_app_type_set__206_cfa_info2(obj_t, obj_t, obj_t);
extern obj_t pre_struct_ref_app_fun_set__223_cfa_info2(app_bglt, var_bglt);
static obj_t _struct_ref_app_args_14_cfa_info2(obj_t, obj_t);
extern bool_t make_vector_app__222_cfa_info2(obj_t);
extern obj_t pre_create_vector_app_side_effect__159_cfa_info2(app_bglt);
static obj_t _make_struct_app_loc_141_cfa_info2(obj_t, obj_t);
extern obj_t struct_ref_app_side_effect__set__108_cfa_info2(app_bglt, obj_t);
static obj_t _make_procedure_app_lost_stamp_241_cfa_info2(obj_t, obj_t);
extern obj_t make_procedure_app_t_set__133_cfa_info2(make_procedure_app_48_bglt, bool_t);
extern obj_t struct_ref_app_key_250_cfa_info2(app_bglt);
static obj_t _pre_make_struct_app_args_set__178_cfa_info2(obj_t, obj_t, obj_t);
extern obj_t make_procedure_app_values_approx_set__111_cfa_info2(make_procedure_app_48_bglt, long, approx_bglt);
static obj_t _procedure_set__app_args_set__91_cfa_info2(obj_t, obj_t, obj_t);
static obj_t _struct_set__app_key2870_7_cfa_info2(obj_t, obj_t);
static obj_t _pre_vector_set__app_key_set_2891_172_cfa_info2(obj_t, obj_t, obj_t);
extern app_bglt allocate_pre_vector_ref_app_241_cfa_info2();
extern obj_t pre_make_procedure_app_stack_info_set__177_cfa_info2(app_bglt, obj_t);
extern pre_struct_ref_app_207_bglt widening_pre_struct_ref_app_19_cfa_info2();
static obj_t _pre_make_vector_app_type_set__29_cfa_info2(obj_t, obj_t, obj_t);
static obj_t _struct_set__app_side_effect__set__120_cfa_info2(obj_t, obj_t, obj_t);
extern obj_t make_procedure_app_side_effect__set__181_cfa_info2(app_bglt, obj_t);
static obj_t struct_object__object_pre_struct_ref_app2194_102_cfa_info2(obj_t, obj_t, obj_t);
static obj_t _pre_procedure_set__app_key2906_82_cfa_info2(obj_t, obj_t);
static obj_t _widening_pre_make_vector_app2896_63_cfa_info2(obj_t, obj_t);
extern obj_t make_vector_app_side_effect__set__75_cfa_info2(app_bglt, obj_t);
extern obj_t pre_create_vector_app_key_92_cfa_info2(app_bglt);
static obj_t object__struct_procedure_set__app2232_251_cfa_info2(obj_t, obj_t);
static obj_t _pre_vector_set__app_side_effect__191_cfa_info2(obj_t, obj_t);
static obj_t _widening_make_struct_app2874_8_cfa_info2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t _create_vector_app_lost_stamp_set__201_cfa_info2(obj_t, obj_t, obj_t);
static obj_t _vector_ref_app_fun_19_cfa_info2(obj_t, obj_t);
extern obj_t make_procedure_app_args_93_cfa_info2(app_bglt);
static obj_t _make_procedure_app_type_19_cfa_info2(obj_t, obj_t);
static obj_t _make_pre_procedure_set__app_211_cfa_info2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t vector_set__app_loc_147_cfa_info2(app_bglt);
static obj_t _pre_make_struct_app_owner_0_cfa_info2(obj_t, obj_t);
static obj_t struct_object__object_pre_struct_set__app2190_189_cfa_info2(obj_t, obj_t, obj_t);
static obj_t _vector_ref_app_key_set_2885_104_cfa_info2(obj_t, obj_t, obj_t);
extern pre_procedure_ref_app_85_bglt make_pre_procedure_ref_app_17_cfa_info2(obj_t, type_bglt, obj_t, obj_t, var_bglt, obj_t, obj_t);
extern obj_t pre_make_struct_app_args_251_cfa_info2(app_bglt);
static obj_t _pre_struct_ref_app_args_2_cfa_info2(obj_t, obj_t);
extern bool_t procedure_ref_app__140_cfa_info2(obj_t);
static obj_t _pre_make_struct_app_side_effect__126_cfa_info2(obj_t, obj_t);
extern obj_t pre_make_vector_app_side_effect__69_cfa_info2(app_bglt);
static obj_t _make_struct_app_key_133_cfa_info2(obj_t, obj_t);
extern obj_t pre_vector_set__app_args_27_cfa_info2(app_bglt);
extern app_bglt allocate_pre_create_vector_app_95_cfa_info2();
static obj_t _make_procedure_app_values_approx_ref_196_cfa_info2(obj_t, obj_t, obj_t);
static obj_t _pre_vector_set__app__223_cfa_info2(obj_t, obj_t);
static obj_t _pre_make_struct_app_loc_183_cfa_info2(obj_t, obj_t);
extern bool_t create_vector_app_stackable__57_cfa_info2(create_vector_app_150_bglt);
extern obj_t pre_procedure_set__app_fun_set__200_cfa_info2(app_bglt, var_bglt);
static obj_t _vector_ref_app_side_effect__234_cfa_info2(obj_t, obj_t);
static obj_t _struct_set__app_fun_99_cfa_info2(obj_t, obj_t);
static obj_t _pre_make_vector_app_stack_info_212_cfa_info2(obj_t, obj_t);
static obj_t _procedure_ref_app_loc_33_cfa_info2(obj_t, obj_t);
extern obj_t struct_ref_app_args_set__33_cfa_info2(app_bglt, obj_t);
extern obj_t pre_struct_set__app_side_effect__190_cfa_info2(app_bglt);
extern obj_t read___reader(obj_t);
extern pre_struct_set__app_116_bglt make_pre_struct_set__app_188_cfa_info2(obj_t, type_bglt, obj_t, obj_t, var_bglt, obj_t, obj_t);
obj_t pre_vector_ref_app_208_cfa_info2 = BUNSPEC;
extern obj_t make_procedure_app_x_t__set__53_cfa_info2(make_procedure_app_48_bglt, bool_t);
static obj_t struct_object__object_vector_ref_app2206_54_cfa_info2(obj_t, obj_t, obj_t);
static obj_t _make_vector_app_lost_stamp_set__176_cfa_info2(obj_t, obj_t, obj_t);
extern obj_t procedure_ref_app_args_set__11_cfa_info2(app_bglt, obj_t);
static obj_t _allocate_make_vector_app_18_cfa_info2(obj_t);
static obj_t _widening_procedure_ref_app2900_64_cfa_info2(obj_t, obj_t);
static obj_t _allocate_pre_struct_set__app_93_cfa_info2(obj_t);
extern app_bglt allocate_pre_procedure_set__app_97_cfa_info2();
extern obj_t create_vector_app_args_set__204_cfa_info2(app_bglt, obj_t);
static obj_t _pre_vector_set__app_type_set__170_cfa_info2(obj_t, obj_t, obj_t);
extern obj_t pre_make_vector_app_side_effect__set__39_cfa_info2(app_bglt, obj_t);
extern obj_t make_vector_app_key_set__25_cfa_info2(app_bglt, obj_t);
extern obj_t vector_set__app_key_77_cfa_info2(app_bglt);
static obj_t _allocate_struct_ref_app_88_cfa_info2(obj_t);
static obj_t _pre_vector_ref_app_key2894_92_cfa_info2(obj_t, obj_t);
static obj_t _pre_struct_set__app_fun_set__239_cfa_info2(obj_t, obj_t, obj_t);
extern obj_t pre_vector_ref_app_args_set__156_cfa_info2(app_bglt, obj_t);
static obj_t _create_vector_app_seen__set__190_cfa_info2(obj_t, obj_t, obj_t);
extern bool_t make_procedure_app_x_178_cfa_info2(make_procedure_app_48_bglt);
extern bool_t make_procedure_app_t_252_cfa_info2(make_procedure_app_48_bglt);
extern obj_t vector_set__app_fun_set__135_cfa_info2(app_bglt, var_bglt);
static obj_t _create_vector_app_approx_120_cfa_info2(obj_t, obj_t);
extern var_bglt struct_ref_app_fun_232_cfa_info2(app_bglt);
static obj_t struct_object__object_create_vector_app2210_100_cfa_info2(obj_t, obj_t, obj_t);
static obj_t _pre_make_struct_app_key_102_cfa_info2(obj_t, obj_t);
static obj_t _create_vector_app_stackable__set__15_cfa_info2(obj_t, obj_t, obj_t);
static obj_t _pre_procedure_set__app_loc_10_cfa_info2(obj_t, obj_t);
static obj_t _pre_create_vector_app_args_204_cfa_info2(obj_t, obj_t);
extern obj_t make_procedure_app_approx_set__127_cfa_info2(make_procedure_app_48_bglt, approx_bglt);
extern obj_t vector_ref_app_args_194_cfa_info2(app_bglt);
static obj_t _struct_ref_app__47_cfa_info2(obj_t, obj_t);
extern obj_t make_struct_app_args_set__242_cfa_info2(app_bglt, obj_t);
static obj_t _pre_struct_set__app_fun_168_cfa_info2(obj_t, obj_t);
extern var_bglt pre_create_vector_app_fun_107_cfa_info2(app_bglt);
static obj_t _make_struct_app_type_set__135_cfa_info2(obj_t, obj_t, obj_t);
extern make_procedure_app_48_bglt make_make_procedure_app_99_cfa_info2(obj_t, type_bglt, obj_t, obj_t, var_bglt, obj_t, obj_t, approx_bglt, long, approx_bglt, long, bool_t, bool_t, bool_t, variable_bglt, bool_t, obj_t);
extern pre_make_struct_app_218_bglt make_pre_make_struct_app_250_cfa_info2(obj_t, type_bglt, obj_t, obj_t, var_bglt, obj_t, obj_t, variable_bglt);
extern obj_t procedure_set__app_side_effect__set__24_cfa_info2(app_bglt, obj_t);
extern obj_t pre_make_struct_app_stack_info_182_cfa_info2(app_bglt);
extern obj_t make_vector_app_type_set__45_cfa_info2(app_bglt, type_bglt);
static obj_t struct_object__object_pre_make_struct_app2198_56_cfa_info2(obj_t, obj_t, obj_t);
static obj_t _widening_vector_ref_app2884_167_cfa_info2(obj_t, obj_t);
static obj_t object__struct_pre_create_vector_app2224_199_cfa_info2(obj_t, obj_t);
static obj_t _allocate_pre_make_struct_app_85_cfa_info2(obj_t);
static obj_t _allocate_procedure_set__app_204_cfa_info2(obj_t);
extern pre_procedure_set__app_208_bglt widening_pre_procedure_set__app_124_cfa_info2();
extern obj_t pre_struct_set__app_stack_info_set__52_cfa_info2(app_bglt, obj_t);
extern obj_t pre_make_vector_app_loc_212_cfa_info2(app_bglt);
extern bool_t pre_vector_ref_app__184_cfa_info2(obj_t);
extern type_bglt pre_procedure_set__app_type_159_cfa_info2(app_bglt);
extern approx_bglt struct_set__app_approx_154_cfa_info2(struct_set__app_162_bglt);
static obj_t _make_struct_app_fun_42_cfa_info2(obj_t, obj_t);
static obj_t _allocate_procedure_ref_app_56_cfa_info2(obj_t);
extern obj_t object__struct_50___object(object_bglt);
extern long make_struct_app_lost_stamp_13_cfa_info2(make_struct_app_214_bglt);
static obj_t _pre_create_vector_app_fun_set__175_cfa_info2(obj_t, obj_t, obj_t);
static obj_t _create_vector_app_lost_stamp_170_cfa_info2(obj_t, obj_t);
static obj_t _pre_struct_set__app_type_set__41_cfa_info2(obj_t, obj_t, obj_t);
extern obj_t struct_ref_app_key_set__1_cfa_info2(app_bglt, obj_t);
static obj_t _make_vector_app_stackable__set__52_cfa_info2(obj_t, obj_t, obj_t);
static obj_t _procedure_ref_app_type_set__17_cfa_info2(obj_t, obj_t, obj_t);
static obj_t _create_vector_app_type_set__40_cfa_info2(obj_t, obj_t, obj_t);
static obj_t require_initialization_114_cfa_info2 = BUNSPEC;
static obj_t _make_vector_app_side_effect__set__44_cfa_info2(obj_t, obj_t, obj_t);
static obj_t _make_struct_ref_app_133_cfa_info2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t _make_procedure_app_stackable__130_cfa_info2(obj_t, obj_t);
extern procedure_set__app_32_bglt widening_procedure_set__app_138_cfa_info2(approx_bglt);
static obj_t _make_struct_app_stack_info_set__53_cfa_info2(obj_t, obj_t, obj_t);
static obj_t _make_vector_app_fun_set__5_cfa_info2(obj_t, obj_t, obj_t);
extern obj_t pre_procedure_ref_app_args_set__9_cfa_info2(app_bglt, obj_t);
extern obj_t make_vector_app_stack_stamp_1_cfa_info2(make_vector_app_205_bglt);
extern obj_t vector_ref_app_fun_set__119_cfa_info2(app_bglt, var_bglt);
extern obj_t pre_create_vector_app_args_set__3_cfa_info2(app_bglt, obj_t);
extern approx_bglt make_procedure_app_approx_226_cfa_info2(make_procedure_app_48_bglt);
extern app_bglt allocate_vector_ref_app_0_cfa_info2();
static obj_t _struct_ref_app_key2873_86_cfa_info2(obj_t, obj_t);
extern obj_t pre_make_procedure_app_loc_229_cfa_info2(app_bglt);
static obj_t _pre_procedure_ref_app_stack_info_230_cfa_info2(obj_t, obj_t);
static obj_t _pre_procedure_ref_app_args_119_cfa_info2(obj_t, obj_t);
extern var_bglt vector_set__app_fun_134_cfa_info2(app_bglt);
static obj_t _pre_make_struct_app_stack_info_set__155_cfa_info2(obj_t, obj_t, obj_t);
static obj_t _vector_ref_app_stack_info_194_cfa_info2(obj_t, obj_t);
static obj_t _struct_set__app__165_cfa_info2(obj_t, obj_t);
static obj_t _make_vector_app_args_set__216_cfa_info2(obj_t, obj_t, obj_t);
extern obj_t pre_make_vector_app_key_53_cfa_info2(app_bglt);
extern obj_t vector_set__app_type_set__199_cfa_info2(app_bglt, type_bglt);
static obj_t _allocate_vector_set__app_158_cfa_info2(obj_t);
static obj_t _pre_make_struct_app_fun_203_cfa_info2(obj_t, obj_t);
static obj_t _make_struct_app_approx_7_cfa_info2(obj_t, obj_t);
extern obj_t pre_make_struct_app_key_set__227_cfa_info2(app_bglt, obj_t);
static obj_t _pre_struct_ref_app_key_set_2878_242_cfa_info2(obj_t, obj_t, obj_t);
static obj_t _make_pre_create_vector_app_126_cfa_info2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t _pre_create_vector_app_stack_info_156_cfa_info2(obj_t, obj_t);
static obj_t _vector_ref_app_approx_209_cfa_info2(obj_t, obj_t);
extern type_bglt pre_make_procedure_app_type_102_cfa_info2(app_bglt);
static obj_t _procedure_ref_app_fun_110_cfa_info2(obj_t, obj_t);
static obj_t _pre_struct_ref_app_args_set__179_cfa_info2(obj_t, obj_t, obj_t);
extern pre_create_vector_app_162_bglt widening_pre_create_vector_app_57_cfa_info2(variable_bglt);
static obj_t _pre_struct_ref_app_side_effect__0_cfa_info2(obj_t, obj_t);
extern obj_t vector_ref_app_args_set__176_cfa_info2(app_bglt, obj_t);
static obj_t _create_vector_app_side_effect__set__90_cfa_info2(obj_t, obj_t, obj_t);
static obj_t _make_procedure_app_values_approx_len_157_cfa_info2(obj_t, obj_t);
static obj_t cnst_init_137_cfa_info2();
static obj_t _pre_procedure_ref_app_stack_info_set__160_cfa_info2(obj_t, obj_t, obj_t);
extern obj_t make_vector_app_args_195_cfa_info2(app_bglt);
extern obj_t make_vector(long, obj_t);
static obj_t _pre_make_procedure_app_type_set__252_cfa_info2(obj_t, obj_t, obj_t);
extern obj_t pre_make_procedure_app_key_242_cfa_info2(app_bglt);
static obj_t _pre_make_vector_app_key_set__118_cfa_info2(obj_t, obj_t, obj_t);
extern obj_t make_procedure_app_loc_185_cfa_info2(app_bglt);
extern bool_t pre_make_struct_app__0_cfa_info2(obj_t);
static obj_t __cnst[21];

DEFINE_EXPORT_PROCEDURE(pre_make_struct_app_side_effect__env_214_cfa_info2, _pre_make_struct_app_side_effect__126_cfa_info22958, _pre_make_struct_app_side_effect__126_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_create_vector_app_fun_env_23_cfa_info2, _pre_create_vector_app_fun_133_cfa_info22959, _pre_create_vector_app_fun_133_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(procedure_set__app_stack_info_env_145_cfa_info2, _procedure_set__app_stack_info_94_cfa_info22960, _procedure_set__app_stack_info_94_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(create_vector_app_lost_stamp_env_13_cfa_info2, _create_vector_app_lost_stamp_170_cfa_info22961, _create_vector_app_lost_stamp_170_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_vector_set__app_fun_env_24_cfa_info2, _pre_vector_set__app_fun_206_cfa_info22962, _pre_vector_set__app_fun_206_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(procedure_set__app_fun_set__env_139_cfa_info2, _procedure_set__app_fun_set__233_cfa_info22963, _procedure_set__app_fun_set__233_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_vector_app_side_effect__env_78_cfa_info2, _make_vector_app_side_effect__105_cfa_info22964, _make_vector_app_side_effect__105_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(widening_vector_set__app_env_67_cfa_info2, _widening_vector_set__app2881_128_cfa_info22965, _widening_vector_set__app2881_128_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_make_struct_app_env_196_cfa_info2, _make_make_struct_app_137_cfa_info22966, _make_make_struct_app_137_cfa_info2, 0L, 13);
DEFINE_EXPORT_PROCEDURE(procedure_ref_app_args_env_220_cfa_info2, _procedure_ref_app_args_55_cfa_info22967, _procedure_ref_app_args_55_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(allocate_pre_make_procedure_app_env_235_cfa_info2, _allocate_pre_make_procedure_app_108_cfa_info22968, _allocate_pre_make_procedure_app_108_cfa_info2, 0L, 0);
DEFINE_EXPORT_PROCEDURE(pre_procedure_set__app_type_set__env_223_cfa_info2, _pre_procedure_set__app_type_set__205_cfa_info22969, _pre_procedure_set__app_type_set__205_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(vector_ref_app_side_effect__set__env_154_cfa_info2, _vector_ref_app_side_effect__set__129_cfa_info22970, _vector_ref_app_side_effect__set__129_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(struct_ref_app_key_env_150_cfa_info2, _struct_ref_app_key2873_86_cfa_info22971, _struct_ref_app_key2873_86_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_vector_app_type_set__env_125_cfa_info2, _make_vector_app_type_set__146_cfa_info22972, _make_vector_app_type_set__146_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(widening_pre_make_struct_app_env_140_cfa_info2, _widening_pre_make_struct_app2880_148_cfa_info22973, _widening_pre_make_struct_app2880_148_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_struct_app_loc_env_239_cfa_info2, _make_struct_app_loc_141_cfa_info22974, _make_struct_app_loc_141_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(procedure_ref_app_side_effect__set__env_178_cfa_info2, _procedure_ref_app_side_effect__set__226_cfa_info22975, _procedure_ref_app_side_effect__set__226_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(struct_ref_app__env_189_cfa_info2, _struct_ref_app__47_cfa_info22976, _struct_ref_app__47_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(allocate_procedure_set__app_env_74_cfa_info2, _allocate_procedure_set__app_204_cfa_info22977, _allocate_procedure_set__app_204_cfa_info2, 0L, 0);
DEFINE_EXPORT_PROCEDURE(struct_set__app__env_2_cfa_info2, _struct_set__app__165_cfa_info22978, _struct_set__app__165_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(allocate_pre_create_vector_app_env_147_cfa_info2, _allocate_pre_create_vector_app_171_cfa_info22979, _allocate_pre_create_vector_app_171_cfa_info2, 0L, 0);
DEFINE_EXPORT_PROCEDURE(vector_ref_app_type_set__env_71_cfa_info2, _vector_ref_app_type_set__190_cfa_info22980, _vector_ref_app_type_set__190_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pre_procedure_set__app_stack_info_env_70_cfa_info2, _pre_procedure_set__app_stack_info_244_cfa_info22981, _pre_procedure_set__app_stack_info_244_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_make_struct_app_fun_env_103_cfa_info2, _pre_make_struct_app_fun_203_cfa_info22982, _pre_make_struct_app_fun_203_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(vector_set__app_key_set__env_111_cfa_info2, _vector_set__app_key_set_2882_126_cfa_info22983, _vector_set__app_key_set_2882_126_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(create_vector_app_owner_env_222_cfa_info2, _create_vector_app_owner_147_cfa_info22984, _create_vector_app_owner_147_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_make_struct_app_type_set__env_233_cfa_info2, _pre_make_struct_app_type_set__21_cfa_info22985, _pre_make_struct_app_type_set__21_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_struct_app_key_set__env_128_cfa_info2, _make_struct_app_key_set_2875_235_cfa_info22986, _make_struct_app_key_set_2875_235_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pre_struct_ref_app_side_effect__set__env_165_cfa_info2, _pre_struct_ref_app_side_effect__set__91_cfa_info22987, _pre_struct_ref_app_side_effect__set__91_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pre_vector_ref_app_loc_env_58_cfa_info2, _pre_vector_ref_app_loc_114_cfa_info22988, _pre_vector_ref_app_loc_114_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(create_vector_app_type_env_215_cfa_info2, _create_vector_app_type_100_cfa_info22989, _create_vector_app_type_100_cfa_info2, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2952_cfa_info2, struct_object__object_pre_make_procedure_app2254_182_cfa_info22990, struct_object__object_pre_make_procedure_app2254_182_cfa_info2, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2951_cfa_info2, object__struct_pre_make_procedure_app2252_27_cfa_info22991, object__struct_pre_make_procedure_app2252_27_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_vector_ref_app_type_env_139_cfa_info2, _pre_vector_ref_app_type_244_cfa_info22992, _pre_vector_ref_app_type_244_cfa_info2, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2949_cfa_info2, object__struct_pre_procedure_ref_app2248_200_cfa_info22993, object__struct_pre_procedure_ref_app2248_200_cfa_info2, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2950_cfa_info2, struct_object__object_pre_procedure_ref_app2250_42_cfa_info22994, struct_object__object_pre_procedure_ref_app2250_42_cfa_info2, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2948_cfa_info2, struct_object__object_pre_procedure_set__app2246_44_cfa_info22995, struct_object__object_pre_procedure_set__app2246_44_cfa_info2, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2947_cfa_info2, object__struct_pre_procedure_set__app2244_179_cfa_info22996, object__struct_pre_procedure_set__app2244_179_cfa_info2, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2946_cfa_info2, struct_object__object_make_procedure_app2242_168_cfa_info22997, struct_object__object_make_procedure_app2242_168_cfa_info2, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2945_cfa_info2, object__struct_make_procedure_app2240_197_cfa_info22998, object__struct_make_procedure_app2240_197_cfa_info2, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2944_cfa_info2, struct_object__object_procedure_ref_app2238_38_cfa_info22999, struct_object__object_procedure_ref_app2238_38_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(create_vector_app_key_env_204_cfa_info2, _create_vector_app_key_171_cfa_info23000, _create_vector_app_key_171_cfa_info2, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2943_cfa_info2, object__struct_procedure_ref_app2236_175_cfa_info23001, object__struct_procedure_ref_app2236_175_cfa_info2, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2942_cfa_info2, struct_object__object_procedure_set__app2234_125_cfa_info23002, struct_object__object_procedure_set__app2234_125_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pre_make_procedure_app_fun_set__env_128_cfa_info2, _pre_make_procedure_app_fun_set__36_cfa_info23003, _pre_make_procedure_app_fun_set__36_cfa_info2, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2941_cfa_info2, object__struct_procedure_set__app2232_251_cfa_info23004, object__struct_procedure_set__app2232_251_cfa_info2, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2939_cfa_info2, object__struct_pre_make_vector_app2228_114_cfa_info23005, object__struct_pre_make_vector_app2228_114_cfa_info2, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2940_cfa_info2, struct_object__object_pre_make_vector_app2230_243_cfa_info23006, struct_object__object_pre_make_vector_app2230_243_cfa_info2, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2938_cfa_info2, struct_object__object_pre_create_vector_app2226_157_cfa_info23007, struct_object__object_pre_create_vector_app2226_157_cfa_info2, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2937_cfa_info2, object__struct_pre_create_vector_app2224_199_cfa_info23008, object__struct_pre_create_vector_app2224_199_cfa_info2, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2936_cfa_info2, struct_object__object_pre_vector_ref_app2222_114_cfa_info23009, struct_object__object_pre_vector_ref_app2222_114_cfa_info2, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2935_cfa_info2, object__struct_pre_vector_ref_app2220_118_cfa_info23010, object__struct_pre_vector_ref_app2220_118_cfa_info2, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2934_cfa_info2, struct_object__object_pre_vector_set__app2218_143_cfa_info23011, struct_object__object_pre_vector_set__app2218_143_cfa_info2, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2933_cfa_info2, object__struct_pre_vector_set__app2216_102_cfa_info23012, object__struct_pre_vector_set__app2216_102_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_struct_app_owner_env_63_cfa_info2, _make_struct_app_owner_239_cfa_info23013, _make_struct_app_owner_239_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_procedure_app_stack_info_env_46_cfa_info2, _make_procedure_app_stack_info_111_cfa_info23014, _make_procedure_app_stack_info_111_cfa_info2, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2932_cfa_info2, struct_object__object_make_vector_app2214_23_cfa_info23015, struct_object__object_make_vector_app2214_23_cfa_info2, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2931_cfa_info2, object__struct_make_vector_app2212_75_cfa_info23016, object__struct_make_vector_app2212_75_cfa_info2, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2929_cfa_info2, object__struct_create_vector_app2208_188_cfa_info23017, object__struct_create_vector_app2208_188_cfa_info2, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2930_cfa_info2, struct_object__object_create_vector_app2210_100_cfa_info23018, struct_object__object_create_vector_app2210_100_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(widening_procedure_set__app_env_67_cfa_info2, _widening_procedure_set__app2897_196_cfa_info23019, _widening_procedure_set__app2897_196_cfa_info2, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2928_cfa_info2, struct_object__object_vector_ref_app2206_54_cfa_info23020, struct_object__object_vector_ref_app2206_54_cfa_info2, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2927_cfa_info2, object__struct_vector_ref_app2204_84_cfa_info23021, object__struct_vector_ref_app2204_84_cfa_info2, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2926_cfa_info2, struct_object__object_vector_set__app2202_239_cfa_info23022, struct_object__object_vector_set__app2202_239_cfa_info2, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2925_cfa_info2, object__struct_vector_set__app2200_231_cfa_info23023, object__struct_vector_set__app2200_231_cfa_info2, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2924_cfa_info2, struct_object__object_pre_make_struct_app2198_56_cfa_info23024, struct_object__object_pre_make_struct_app2198_56_cfa_info2, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2923_cfa_info2, object__struct_pre_make_struct_app2196_73_cfa_info23025, object__struct_pre_make_struct_app2196_73_cfa_info2, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2922_cfa_info2, struct_object__object_pre_struct_ref_app2194_102_cfa_info23026, struct_object__object_pre_struct_ref_app2194_102_cfa_info2, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2921_cfa_info2, object__struct_pre_struct_ref_app2192_6_cfa_info23027, object__struct_pre_struct_ref_app2192_6_cfa_info2, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2919_cfa_info2, object__struct_pre_struct_set__app2188_114_cfa_info23028, object__struct_pre_struct_set__app2188_114_cfa_info2, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2920_cfa_info2, struct_object__object_pre_struct_set__app2190_189_cfa_info23029, struct_object__object_pre_struct_set__app2190_189_cfa_info2, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2918_cfa_info2, struct_object__object_make_struct_app2186_246_cfa_info23030, struct_object__object_make_struct_app2186_246_cfa_info2, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2917_cfa_info2, object__struct_make_struct_app2184_126_cfa_info23031, object__struct_make_struct_app2184_126_cfa_info2, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2916_cfa_info2, struct_object__object_struct_ref_app2182_41_cfa_info23032, struct_object__object_struct_ref_app2182_41_cfa_info2, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2915_cfa_info2, object__struct_struct_ref_app2180_75_cfa_info23033, object__struct_struct_ref_app2180_75_cfa_info2, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2914_cfa_info2, struct_object__object_struct_set__app2178_127_cfa_info23034, struct_object__object_struct_set__app2178_127_cfa_info2, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2913_cfa_info2, object__struct_struct_set__app2176_75_cfa_info23035, object__struct_struct_set__app2176_75_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_vector_ref_app_args_set__env_108_cfa_info2, _pre_vector_ref_app_args_set__174_cfa_info23036, _pre_vector_ref_app_args_set__174_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_procedure_app_key_env_243_cfa_info2, _make_procedure_app_key_248_cfa_info23037, _make_procedure_app_key_248_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_vector_app_stack_stamp_env_233_cfa_info2, _make_vector_app_stack_stamp_138_cfa_info23038, _make_vector_app_stack_stamp_138_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_procedure_ref_app_args_set__env_107_cfa_info2, _pre_procedure_ref_app_args_set__233_cfa_info23039, _pre_procedure_ref_app_args_set__233_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(procedure_set__app_key_env_180_cfa_info2, _procedure_set__app_key2899_177_cfa_info23040, _procedure_set__app_key2899_177_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(widening_pre_create_vector_app_env_240_cfa_info2, _widening_pre_create_vector_app2895_55_cfa_info23041, _widening_pre_create_vector_app2895_55_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_vector_app_seen__env_3_cfa_info2, _make_vector_app_seen__50_cfa_info23042, _make_vector_app_seen__50_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_vector_set__app_side_effect__env_195_cfa_info2, _pre_vector_set__app_side_effect__191_cfa_info23043, _pre_vector_set__app_side_effect__191_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(vector_set__app_stack_info_env_156_cfa_info2, _vector_set__app_stack_info_176_cfa_info23044, _vector_set__app_stack_info_176_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_vector_app_stack_info_env_132_cfa_info2, _make_vector_app_stack_info_46_cfa_info23045, _make_vector_app_stack_info_46_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(vector_ref_app_loc_env_126_cfa_info2, _vector_ref_app_loc_62_cfa_info23046, _vector_ref_app_loc_62_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(struct_ref_app_stack_info_set__env_234_cfa_info2, _struct_ref_app_stack_info_set__154_cfa_info23047, _struct_ref_app_stack_info_set__154_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(struct_set__app_side_effect__env_139_cfa_info2, _struct_set__app_side_effect__200_cfa_info23048, _struct_set__app_side_effect__200_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(create_vector_app_key_set__env_178_cfa_info2, _create_vector_app_key_set_2888_204_cfa_info23049, _create_vector_app_key_set_2888_204_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pre_make_vector_app_loc_env_145_cfa_info2, _pre_make_vector_app_loc_37_cfa_info23050, _pre_make_vector_app_loc_37_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_create_vector_app_owner_env_51_cfa_info2, _pre_create_vector_app_owner_163_cfa_info23051, _pre_create_vector_app_owner_163_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_make_procedure_app_stack_info_env_53_cfa_info2, _pre_make_procedure_app_stack_info_105_cfa_info23052, _pre_make_procedure_app_stack_info_105_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_vector_ref_app__env_161_cfa_info2, _pre_vector_ref_app__133_cfa_info23053, _pre_vector_ref_app__133_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_procedure_app_x_t__env_211_cfa_info2, _make_procedure_app_x_t__234_cfa_info23054, _make_procedure_app_x_t__234_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_vector_app_key_env_21_cfa_info2, _make_vector_app_key_198_cfa_info23055, _make_vector_app_key_198_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_struct_ref_app_env_247_cfa_info2, _make_struct_ref_app_133_cfa_info23056, _make_struct_ref_app_133_cfa_info2, 0L, 8);
DEFINE_EXPORT_PROCEDURE(make_struct_app_stack_stamp_set__env_202_cfa_info2, _make_struct_app_stack_stamp_set__239_cfa_info23057, _make_struct_app_stack_stamp_set__239_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_procedure_app_type_set__env_255_cfa_info2, _make_procedure_app_type_set__206_cfa_info23058, _make_procedure_app_type_set__206_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pre_procedure_ref_app_args_env_65_cfa_info2, _pre_procedure_ref_app_args_119_cfa_info23059, _pre_procedure_ref_app_args_119_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(allocate_procedure_ref_app_env_35_cfa_info2, _allocate_procedure_ref_app_56_cfa_info23060, _allocate_procedure_ref_app_56_cfa_info2, 0L, 0);
DEFINE_EXPORT_PROCEDURE(pre_create_vector_app__env_2_cfa_info2, _pre_create_vector_app__32_cfa_info23061, _pre_create_vector_app__32_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_procedure_ref_app_key_set__env_70_cfa_info2, _pre_procedure_ref_app_key_set_2907_153_cfa_info23062, _pre_procedure_ref_app_key_set_2907_153_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(struct_set__app_type_set__env_224_cfa_info2, _struct_set__app_type_set__106_cfa_info23063, _struct_set__app_type_set__106_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_struct_app_stack_info_env_227_cfa_info2, _make_struct_app_stack_info_146_cfa_info23064, _make_struct_app_stack_info_146_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(procedure_set__app_stack_info_set__env_150_cfa_info2, _procedure_set__app_stack_info_set__157_cfa_info23065, _procedure_set__app_stack_info_set__157_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_pre_struct_set__app_env_14_cfa_info2, _make_pre_struct_set__app_92_cfa_info23066, _make_pre_struct_set__app_92_cfa_info2, 0L, 7);
DEFINE_EXPORT_PROCEDURE(procedure_ref_app_type_set__env_205_cfa_info2, _procedure_ref_app_type_set__17_cfa_info23067, _procedure_ref_app_type_set__17_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(procedure_set__app_key_set__env_220_cfa_info2, _procedure_set__app_key_set_2898_103_cfa_info23068, _procedure_set__app_key_set_2898_103_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_vector_app_value_approx_env_69_cfa_info2, _make_vector_app_value_approx_28_cfa_info23069, _make_vector_app_value_approx_28_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_make_vector_app_type_set__env_126_cfa_info2, _pre_make_vector_app_type_set__29_cfa_info23070, _pre_make_vector_app_type_set__29_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pre_struct_set__app_type_env_28_cfa_info2, _pre_struct_set__app_type_235_cfa_info23071, _pre_struct_set__app_type_235_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(widening_struct_set__app_env_4_cfa_info2, _widening_struct_set__app2868_104_cfa_info23072, _widening_struct_set__app2868_104_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(create_vector_app__env_101_cfa_info2, _create_vector_app__45_cfa_info23073, _create_vector_app__45_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(struct_ref_app_side_effect__set__env_26_cfa_info2, _struct_ref_app_side_effect__set__219_cfa_info23074, _struct_ref_app_side_effect__set__219_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(create_vector_app_stack_info_env_181_cfa_info2, _create_vector_app_stack_info_181_cfa_info23075, _create_vector_app_stack_info_181_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_create_vector_app_type_env_67_cfa_info2, _pre_create_vector_app_type_67_cfa_info23076, _pre_create_vector_app_type_67_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(struct_set__app_stack_info_env_77_cfa_info2, _struct_set__app_stack_info_135_cfa_info23077, _struct_set__app_stack_info_135_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_procedure_ref_app__env_133_cfa_info2, _pre_procedure_ref_app__123_cfa_info23078, _pre_procedure_ref_app__123_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_procedure_ref_app_fun_env_224_cfa_info2, _pre_procedure_ref_app_fun_224_cfa_info23079, _pre_procedure_ref_app_fun_224_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(struct_set__app_loc_env_245_cfa_info2, _struct_set__app_loc_220_cfa_info23080, _struct_set__app_loc_220_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_create_vector_app_side_effect__set__env_223_cfa_info2, _pre_create_vector_app_side_effect__set__231_cfa_info23081, _pre_create_vector_app_side_effect__set__231_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pre_make_procedure_app_key_env_200_cfa_info2, _pre_make_procedure_app_key_128_cfa_info23082, _pre_make_procedure_app_key_128_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_make_vector_app__env_190_cfa_info2, _pre_make_vector_app__65_cfa_info23083, _pre_make_vector_app__65_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_procedure_app_type_env_149_cfa_info2, _make_procedure_app_type_19_cfa_info23084, _make_procedure_app_type_19_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_pre_make_struct_app_env_150_cfa_info2, _make_pre_make_struct_app_249_cfa_info23085, _make_pre_make_struct_app_249_cfa_info2, 0L, 8);
DEFINE_EXPORT_PROCEDURE(make_make_procedure_app_env_184_cfa_info2, _make_make_procedure_app_59_cfa_info23086, _make_make_procedure_app_59_cfa_info2, 0L, 17);
DEFINE_EXPORT_PROCEDURE(pre_procedure_set__app_key_env_119_cfa_info2, _pre_procedure_set__app_key2906_82_cfa_info23087, _pre_procedure_set__app_key2906_82_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_struct_set__app_fun_env_16_cfa_info2, _pre_struct_set__app_fun_168_cfa_info23088, _pre_struct_set__app_fun_168_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_make_procedure_app_key_set__env_25_cfa_info2, _pre_make_procedure_app_key_set__107_cfa_info23089, _pre_make_procedure_app_key_set__107_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pre_make_procedure_app_side_effect__set__env_34_cfa_info2, _pre_make_procedure_app_side_effect__set__237_cfa_info23090, _pre_make_procedure_app_side_effect__set__237_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(procedure_ref_app__env_143_cfa_info2, _procedure_ref_app__14_cfa_info23091, _procedure_ref_app__14_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_vector_app_approx_set__env_86_cfa_info2, _make_vector_app_approx_set__9_cfa_info23092, _make_vector_app_approx_set__9_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(struct_ref_app_side_effect__env_101_cfa_info2, _struct_ref_app_side_effect__158_cfa_info23093, _struct_ref_app_side_effect__158_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_vector_set__app_side_effect__set__env_241_cfa_info2, _pre_vector_set__app_side_effect__set__216_cfa_info23094, _pre_vector_set__app_side_effect__set__216_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(widening_make_struct_app_env_181_cfa_info2, _widening_make_struct_app2874_8_cfa_info23095, _widening_make_struct_app2874_8_cfa_info2, 0L, 6);
DEFINE_EXPORT_PROCEDURE(allocate_pre_procedure_set__app_env_247_cfa_info2, _allocate_pre_procedure_set__app_24_cfa_info23096, _allocate_pre_procedure_set__app_24_cfa_info2, 0L, 0);
DEFINE_EXPORT_PROCEDURE(pre_create_vector_app_fun_set__env_54_cfa_info2, _pre_create_vector_app_fun_set__175_cfa_info23097, _pre_create_vector_app_fun_set__175_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(create_vector_app_args_env_43_cfa_info2, _create_vector_app_args_132_cfa_info23098, _create_vector_app_args_132_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_make_vector_app_side_effect__env_84_cfa_info2, _pre_make_vector_app_side_effect__120_cfa_info23099, _pre_make_vector_app_side_effect__120_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_vector_ref_app_args_env_8_cfa_info2, _pre_vector_ref_app_args_84_cfa_info23100, _pre_vector_ref_app_args_84_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_pre_vector_ref_app_env_106_cfa_info2, _make_pre_vector_ref_app_92_cfa_info23101, _make_pre_vector_ref_app_92_cfa_info2, 0L, 7);
DEFINE_EXPORT_PROCEDURE(pre_make_vector_app_side_effect__set__env_230_cfa_info2, _pre_make_vector_app_side_effect__set__24_cfa_info23102, _pre_make_vector_app_side_effect__set__24_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(struct_set__app_type_env_67_cfa_info2, _struct_set__app_type_189_cfa_info23103, _struct_set__app_type_189_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(widening_procedure_ref_app_env_168_cfa_info2, _widening_procedure_ref_app2900_64_cfa_info23104, _widening_procedure_ref_app2900_64_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(procedure_set__app_args_set__env_208_cfa_info2, _procedure_set__app_args_set__91_cfa_info23105, _procedure_set__app_args_set__91_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_procedure_app_stack_stamp_set__env_170_cfa_info2, _make_procedure_app_stack_stamp_set__110_cfa_info23106, _make_procedure_app_stack_stamp_set__110_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(procedure_set__app_type_env_210_cfa_info2, _procedure_set__app_type_198_cfa_info23107, _procedure_set__app_type_198_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(procedure_ref_app_key_env_177_cfa_info2, _procedure_ref_app_key2902_254_cfa_info23108, _procedure_ref_app_key2902_254_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(procedure_ref_app_stack_info_env_239_cfa_info2, _procedure_ref_app_stack_info_173_cfa_info23109, _procedure_ref_app_stack_info_173_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(vector_set__app_args_set__env_235_cfa_info2, _vector_set__app_args_set__11_cfa_info23110, _vector_set__app_args_set__11_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pre_make_vector_app_stack_info_set__env_176_cfa_info2, _pre_make_vector_app_stack_info_set__250_cfa_info23111, _pre_make_vector_app_stack_info_set__250_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pre_make_vector_app_fun_set__env_26_cfa_info2, _pre_make_vector_app_fun_set__159_cfa_info23112, _pre_make_vector_app_fun_set__159_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pre_vector_set__app_type_env_29_cfa_info2, _pre_vector_set__app_type_156_cfa_info23113, _pre_vector_set__app_type_156_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_make_procedure_app_type_env_153_cfa_info2, _pre_make_procedure_app_type_166_cfa_info23114, _pre_make_procedure_app_type_166_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_procedure_app_stack_info_set__env_253_cfa_info2, _make_procedure_app_stack_info_set__180_cfa_info23115, _make_procedure_app_stack_info_set__180_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(vector_set__app_side_effect__set__env_253_cfa_info2, _vector_set__app_side_effect__set__126_cfa_info23116, _vector_set__app_side_effect__set__126_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pre_vector_ref_app_stack_info_set__env_101_cfa_info2, _pre_vector_ref_app_stack_info_set__99_cfa_info23117, _pre_vector_ref_app_stack_info_set__99_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pre_struct_ref_app_type_env_200_cfa_info2, _pre_struct_ref_app_type_66_cfa_info23118, _pre_struct_ref_app_type_66_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(vector_ref_app_stack_info_env_230_cfa_info2, _vector_ref_app_stack_info_194_cfa_info23119, _vector_ref_app_stack_info_194_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_struct_set__app_fun_set__env_237_cfa_info2, _pre_struct_set__app_fun_set__239_cfa_info23120, _pre_struct_set__app_fun_set__239_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pre_struct_set__app_type_set__env_8_cfa_info2, _pre_struct_set__app_type_set__41_cfa_info23121, _pre_struct_set__app_type_set__41_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pre_struct_ref_app__env_255_cfa_info2, _pre_struct_ref_app__54_cfa_info23122, _pre_struct_ref_app__54_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_procedure_app_stackable__set__env_81_cfa_info2, _make_procedure_app_stackable__set__122_cfa_info23123, _make_procedure_app_stackable__set__122_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(allocate_pre_make_vector_app_env_198_cfa_info2, _allocate_pre_make_vector_app_80_cfa_info23124, _allocate_pre_make_vector_app_80_cfa_info2, 0L, 0);
DEFINE_EXPORT_PROCEDURE(make_vector_app_side_effect__set__env_163_cfa_info2, _make_vector_app_side_effect__set__44_cfa_info23125, _make_vector_app_side_effect__set__44_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pre_struct_set__app__env_28_cfa_info2, _pre_struct_set__app__221_cfa_info23126, _pre_struct_set__app__221_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_create_vector_app_args_set__env_221_cfa_info2, _pre_create_vector_app_args_set__12_cfa_info23127, _pre_create_vector_app_args_set__12_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_pre_make_procedure_app_env_160_cfa_info2, _make_pre_make_procedure_app_8_cfa_info23128, _make_pre_make_procedure_app_8_cfa_info2, 0L, 8);
DEFINE_EXPORT_PROCEDURE(pre_create_vector_app_key_env_29_cfa_info2, _pre_create_vector_app_key_224_cfa_info23129, _pre_create_vector_app_key_224_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_make_struct_app_owner_env_210_cfa_info2, _pre_make_struct_app_owner_0_cfa_info23130, _pre_make_struct_app_owner_0_cfa_info2, 0L, 1);
extern obj_t struct_object__object_env_209___object;
DEFINE_EXPORT_PROCEDURE(allocate_vector_ref_app_env_93_cfa_info2, _allocate_vector_ref_app_194_cfa_info23131, _allocate_vector_ref_app_194_cfa_info2, 0L, 0);
DEFINE_EXPORT_PROCEDURE(pre_struct_ref_app_loc_env_195_cfa_info2, _pre_struct_ref_app_loc_255_cfa_info23132, _pre_struct_ref_app_loc_255_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_vector_set__app_key_env_20_cfa_info2, _pre_vector_set__app_key2892_212_cfa_info23133, _pre_vector_set__app_key2892_212_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_procedure_app_owner_env_162_cfa_info2, _make_procedure_app_owner_91_cfa_info23134, _make_procedure_app_owner_91_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_procedure_ref_app_side_effect__set__env_139_cfa_info2, _pre_procedure_ref_app_side_effect__set__26_cfa_info23135, _pre_procedure_ref_app_side_effect__set__26_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(struct_set__app_approx_env_58_cfa_info2, _struct_set__app_approx_83_cfa_info23136, _struct_set__app_approx_83_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_procedure_set__app_type_env_139_cfa_info2, _pre_procedure_set__app_type_192_cfa_info23137, _pre_procedure_set__app_type_192_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_vector_app_stack_stamp_set__env_232_cfa_info2, _make_vector_app_stack_stamp_set__172_cfa_info23138, _make_vector_app_stack_stamp_set__172_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(struct_ref_app_args_set__env_63_cfa_info2, _struct_ref_app_args_set__245_cfa_info23139, _struct_ref_app_args_set__245_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pre_struct_set__app_args_env_92_cfa_info2, _pre_struct_set__app_args_129_cfa_info23140, _pre_struct_set__app_args_129_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_struct_set__app_side_effect__env_188_cfa_info2, _pre_struct_set__app_side_effect__220_cfa_info23141, _pre_struct_set__app_side_effect__220_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(vector_ref_app_approx_env_95_cfa_info2, _vector_ref_app_approx_209_cfa_info23142, _vector_ref_app_approx_209_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(vector_set__app_fun_env_199_cfa_info2, _vector_set__app_fun_180_cfa_info23143, _vector_set__app_fun_180_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(struct_ref_app_loc_env_186_cfa_info2, _struct_ref_app_loc_25_cfa_info23144, _struct_ref_app_loc_25_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(allocate_create_vector_app_env_133_cfa_info2, _allocate_create_vector_app_246_cfa_info23145, _allocate_create_vector_app_246_cfa_info2, 0L, 0);
DEFINE_EXPORT_PROCEDURE(pre_create_vector_app_args_env_255_cfa_info2, _pre_create_vector_app_args_204_cfa_info23146, _pre_create_vector_app_args_204_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(procedure_set__app_approx_env_79_cfa_info2, _procedure_set__app_approx_20_cfa_info23147, _procedure_set__app_approx_20_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_vector_set__app_stack_info_set__env_107_cfa_info2, _pre_vector_set__app_stack_info_set__248_cfa_info23148, _pre_vector_set__app_stack_info_set__248_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(vector_set__app_type_env_159_cfa_info2, _vector_set__app_type_95_cfa_info23149, _vector_set__app_type_95_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_make_struct_app_key_env_31_cfa_info2, _pre_make_struct_app_key_102_cfa_info23150, _pre_make_struct_app_key_102_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_make_struct_app_stack_info_set__env_106_cfa_info2, _pre_make_struct_app_stack_info_set__155_cfa_info23151, _pre_make_struct_app_stack_info_set__155_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pre_make_procedure_app_type_set__env_28_cfa_info2, _pre_make_procedure_app_type_set__252_cfa_info23152, _pre_make_procedure_app_type_set__252_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(create_vector_app_type_set__env_245_cfa_info2, _create_vector_app_type_set__40_cfa_info23153, _create_vector_app_type_set__40_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pre_vector_set__app_stack_info_env_65_cfa_info2, _pre_vector_set__app_stack_info_11_cfa_info23154, _pre_vector_set__app_stack_info_11_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_make_vector_app_stack_info_env_248_cfa_info2, _pre_make_vector_app_stack_info_212_cfa_info23155, _pre_make_vector_app_stack_info_212_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_procedure_app_args_env_209_cfa_info2, _make_procedure_app_args_200_cfa_info23156, _make_procedure_app_args_200_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_procedure_app_values_approx_len_env_69_cfa_info2, _make_procedure_app_values_approx_len_157_cfa_info23157, _make_procedure_app_values_approx_len_157_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(struct_ref_app_approx_env_217_cfa_info2, _struct_ref_app_approx_29_cfa_info23158, _struct_ref_app_approx_29_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_struct_app_args_set__env_200_cfa_info2, _make_struct_app_args_set__31_cfa_info23159, _make_struct_app_args_set__31_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pre_create_vector_app_key_set__env_81_cfa_info2, _pre_create_vector_app_key_set__20_cfa_info23160, _pre_create_vector_app_key_set__20_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_struct_app_fun_env_22_cfa_info2, _make_struct_app_fun_42_cfa_info23161, _make_struct_app_fun_42_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_vector_app_stack_info_set__env_251_cfa_info2, _make_vector_app_stack_info_set__207_cfa_info23162, _make_vector_app_stack_info_set__207_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(create_vector_app_loc_env_50_cfa_info2, _create_vector_app_loc_52_cfa_info23163, _create_vector_app_loc_52_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_create_vector_app_stack_info_env_77_cfa_info2, _pre_create_vector_app_stack_info_156_cfa_info23164, _pre_create_vector_app_stack_info_156_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_vector_app_stackable__set__env_128_cfa_info2, _make_vector_app_stackable__set__52_cfa_info23165, _make_vector_app_stackable__set__52_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pre_vector_set__app_args_set__env_69_cfa_info2, _pre_vector_set__app_args_set__6_cfa_info23166, _pre_vector_set__app_args_set__6_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(vector_ref_app_type_env_44_cfa_info2, _vector_ref_app_type_64_cfa_info23167, _vector_ref_app_type_64_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_pre_procedure_ref_app_env_195_cfa_info2, _make_pre_procedure_ref_app_208_cfa_info23168, _make_pre_procedure_ref_app_208_cfa_info2, 0L, 7);
DEFINE_EXPORT_PROCEDURE(make_procedure_app_loc_env_203_cfa_info2, _make_procedure_app_loc_42_cfa_info23169, _make_procedure_app_loc_42_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(struct_set__app_args_env_255_cfa_info2, _struct_set__app_args_213_cfa_info23170, _struct_set__app_args_213_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_vector_ref_app_stack_info_env_70_cfa_info2, _pre_vector_ref_app_stack_info_125_cfa_info23171, _pre_vector_ref_app_stack_info_125_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_make_struct_app_stack_info_env_127_cfa_info2, _pre_make_struct_app_stack_info_136_cfa_info23172, _pre_make_struct_app_stack_info_136_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(procedure_set__app_side_effect__set__env_6_cfa_info2, _procedure_set__app_side_effect__set__166_cfa_info23173, _procedure_set__app_side_effect__set__166_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(procedure_set__app_loc_env_121_cfa_info2, _procedure_set__app_loc_232_cfa_info23174, _procedure_set__app_loc_232_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_make_vector_app_key_set__env_75_cfa_info2, _pre_make_vector_app_key_set__118_cfa_info23175, _pre_make_vector_app_key_set__118_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(vector_ref_app_side_effect__env_190_cfa_info2, _vector_ref_app_side_effect__234_cfa_info23176, _vector_ref_app_side_effect__234_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_procedure_set__app_env_73_cfa_info2, _make_procedure_set__app_65_cfa_info23177, _make_procedure_set__app_65_cfa_info2, 0L, 8);
DEFINE_EXPORT_PROCEDURE(allocate_pre_struct_ref_app_env_84_cfa_info2, _allocate_pre_struct_ref_app_15_cfa_info23178, _allocate_pre_struct_ref_app_15_cfa_info2, 0L, 0);
DEFINE_EXPORT_PROCEDURE(pre_vector_ref_app_fun_env_130_cfa_info2, _pre_vector_ref_app_fun_218_cfa_info23179, _pre_vector_ref_app_fun_218_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_procedure_set__app__env_161_cfa_info2, _pre_procedure_set__app__169_cfa_info23180, _pre_procedure_set__app__169_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_struct_ref_app_type_set__env_25_cfa_info2, _pre_struct_ref_app_type_set__215_cfa_info23181, _pre_struct_ref_app_type_set__215_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(procedure_set__app_args_env_134_cfa_info2, _procedure_set__app_args_0_cfa_info23182, _procedure_set__app_args_0_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(allocate_make_vector_app_env_222_cfa_info2, _allocate_make_vector_app_18_cfa_info23183, _allocate_make_vector_app_18_cfa_info2, 0L, 0);
DEFINE_EXPORT_PROCEDURE(pre_struct_set__app_key_set__env_144_cfa_info2, _pre_struct_set__app_key_set_2876_203_cfa_info23184, _pre_struct_set__app_key_set_2876_203_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pre_vector_set__app_args_env_64_cfa_info2, _pre_vector_set__app_args_216_cfa_info23185, _pre_vector_set__app_args_216_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_make_procedure_app_args_env_152_cfa_info2, _pre_make_procedure_app_args_121_cfa_info23186, _pre_make_procedure_app_args_121_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_struct_ref_app_args_env_234_cfa_info2, _pre_struct_ref_app_args_2_cfa_info23187, _pre_struct_ref_app_args_2_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_vector_app_approx_env_81_cfa_info2, _make_vector_app_approx_98_cfa_info23188, _make_vector_app_approx_98_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_vector_app_loc_env_143_cfa_info2, _make_vector_app_loc_189_cfa_info23189, _make_vector_app_loc_189_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(struct_ref_app_fun_set__env_27_cfa_info2, _struct_ref_app_fun_set__28_cfa_info23190, _struct_ref_app_fun_set__28_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pre_struct_set__app_stack_info_env_7_cfa_info2, _pre_struct_set__app_stack_info_246_cfa_info23191, _pre_struct_set__app_stack_info_246_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(widening_pre_struct_ref_app_env_102_cfa_info2, _widening_pre_struct_ref_app_117_cfa_info23192, _widening_pre_struct_ref_app_117_cfa_info2, 0L, 0);
DEFINE_EXPORT_PROCEDURE(vector_ref_app_fun_env_152_cfa_info2, _vector_ref_app_fun_19_cfa_info23193, _vector_ref_app_fun_19_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_vector_set__app_fun_set__env_240_cfa_info2, _pre_vector_set__app_fun_set__189_cfa_info23194, _pre_vector_set__app_fun_set__189_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(widening_create_vector_app_env_253_cfa_info2, _widening_create_vector_app2887_17_cfa_info23195, _widening_create_vector_app2887_17_cfa_info2, 0L, 7);
DEFINE_EXPORT_PROCEDURE(allocate_pre_vector_set__app_env_49_cfa_info2, _allocate_pre_vector_set__app_63_cfa_info23196, _allocate_pre_vector_set__app_63_cfa_info2, 0L, 0);
DEFINE_EXPORT_PROCEDURE(pre_make_vector_app_fun_env_101_cfa_info2, _pre_make_vector_app_fun_41_cfa_info23197, _pre_make_vector_app_fun_41_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_make_procedure_app__env_47_cfa_info2, _pre_make_procedure_app__252_cfa_info23198, _pre_make_procedure_app__252_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_procedure_set__app_fun_set__env_68_cfa_info2, _pre_procedure_set__app_fun_set__73_cfa_info23199, _pre_procedure_set__app_fun_set__73_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(vector_set__app_stack_info_set__env_104_cfa_info2, _vector_set__app_stack_info_set__100_cfa_info23200, _vector_set__app_stack_info_set__100_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pre_make_struct_app_fun_set__env_90_cfa_info2, _pre_make_struct_app_fun_set__105_cfa_info23201, _pre_make_struct_app_fun_set__105_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_struct_app_stack_info_set__env_214_cfa_info2, _make_struct_app_stack_info_set__53_cfa_info23202, _make_struct_app_stack_info_set__53_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pre_procedure_set__app_args_set__env_108_cfa_info2, _pre_procedure_set__app_args_set__34_cfa_info23203, _pre_procedure_set__app_args_set__34_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(widening_struct_ref_app_env_48_cfa_info2, _widening_struct_ref_app2871_224_cfa_info23204, _widening_struct_ref_app2871_224_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_make_struct_app_side_effect__set__env_17_cfa_info2, _pre_make_struct_app_side_effect__set__136_cfa_info23205, _pre_make_struct_app_side_effect__set__136_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pre_make_vector_app_type_env_218_cfa_info2, _pre_make_vector_app_type_50_cfa_info23206, _pre_make_vector_app_type_50_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(widening_pre_make_procedure_app_env_186_cfa_info2, _widening_pre_make_procedure_app2909_172_cfa_info23207, _widening_pre_make_procedure_app2909_172_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_procedure_app_x_env_204_cfa_info2, _make_procedure_app_x_209_cfa_info23208, _make_procedure_app_x_209_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_vector_app_args_set__env_180_cfa_info2, _make_vector_app_args_set__216_cfa_info23209, _make_vector_app_args_set__216_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_procedure_app_x_set__env_178_cfa_info2, _make_procedure_app_x_set__75_cfa_info23210, _make_procedure_app_x_set__75_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pre_procedure_ref_app_stack_info_env_98_cfa_info2, _pre_procedure_ref_app_stack_info_230_cfa_info23211, _pre_procedure_ref_app_stack_info_230_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_procedure_set__app_args_env_8_cfa_info2, _pre_procedure_set__app_args_86_cfa_info23212, _pre_procedure_set__app_args_86_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_procedure_app_lost_stamp_set__env_86_cfa_info2, _make_procedure_app_lost_stamp_set__118_cfa_info23213, _make_procedure_app_lost_stamp_set__118_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(procedure_ref_app_approx_env_220_cfa_info2, _procedure_ref_app_approx_193_cfa_info23214, _procedure_ref_app_approx_193_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_struct_app_stackable__set__env_172_cfa_info2, _make_struct_app_stackable__set__138_cfa_info23215, _make_struct_app_stackable__set__138_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pre_procedure_ref_app_key_env_138_cfa_info2, _pre_procedure_ref_app_key2908_96_cfa_info23216, _pre_procedure_ref_app_key2908_96_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_struct_app_stack_stamp_env_244_cfa_info2, _make_struct_app_stack_stamp_168_cfa_info23217, _make_struct_app_stack_stamp_168_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(vector_ref_app_args_set__env_239_cfa_info2, _vector_ref_app_args_set__180_cfa_info23218, _vector_ref_app_args_set__180_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_procedure_ref_app_env_244_cfa_info2, _make_procedure_ref_app_227_cfa_info23219, _make_procedure_ref_app_227_cfa_info2, 0L, 8);
DEFINE_EXPORT_PROCEDURE(create_vector_app_approx_env_156_cfa_info2, _create_vector_app_approx_120_cfa_info23220, _create_vector_app_approx_120_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(procedure_ref_app_side_effect__env_204_cfa_info2, _procedure_ref_app_side_effect__202_cfa_info23221, _procedure_ref_app_side_effect__202_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_pre_procedure_set__app_env_110_cfa_info2, _make_pre_procedure_set__app_211_cfa_info23222, _make_pre_procedure_set__app_211_cfa_info2, 0L, 7);
DEFINE_EXPORT_PROCEDURE(pre_struct_ref_app_fun_set__env_126_cfa_info2, _pre_struct_ref_app_fun_set__11_cfa_info23223, _pre_struct_ref_app_fun_set__11_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pre_struct_set__app_key_env_50_cfa_info2, _pre_struct_set__app_key2877_203_cfa_info23224, _pre_struct_set__app_key2877_203_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(vector_set__app_args_env_30_cfa_info2, _vector_set__app_args_118_cfa_info23225, _vector_set__app_args_118_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_make_struct_app_args_set__env_77_cfa_info2, _pre_make_struct_app_args_set__178_cfa_info23226, _pre_make_struct_app_args_set__178_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_struct_app_side_effect__set__env_174_cfa_info2, _make_struct_app_side_effect__set__28_cfa_info23227, _make_struct_app_side_effect__set__28_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pre_make_procedure_app_loc_env_218_cfa_info2, _pre_make_procedure_app_loc_53_cfa_info23228, _pre_make_procedure_app_loc_53_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(create_vector_app_side_effect__env_63_cfa_info2, _create_vector_app_side_effect__114_cfa_info23229, _create_vector_app_side_effect__114_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_struct_ref_app_stack_info_set__env_255_cfa_info2, _pre_struct_ref_app_stack_info_set__255_cfa_info23230, _pre_struct_ref_app_stack_info_set__255_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pre_procedure_set__app_loc_env_58_cfa_info2, _pre_procedure_set__app_loc_10_cfa_info23231, _pre_procedure_set__app_loc_10_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(create_vector_app_seen__env_221_cfa_info2, _create_vector_app_seen__64_cfa_info23232, _create_vector_app_seen__64_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_make_procedure_app_side_effect__env_193_cfa_info2, _pre_make_procedure_app_side_effect__18_cfa_info23233, _pre_make_procedure_app_side_effect__18_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_vector_ref_app_env_166_cfa_info2, _make_vector_ref_app_226_cfa_info23234, _make_vector_ref_app_226_cfa_info2, 0L, 8);
DEFINE_EXPORT_PROCEDURE(struct_set__app_fun_env_23_cfa_info2, _struct_set__app_fun_99_cfa_info23235, _struct_set__app_fun_99_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_procedure_set__app_side_effect__env_170_cfa_info2, _pre_procedure_set__app_side_effect__59_cfa_info23236, _pre_procedure_set__app_side_effect__59_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_procedure_app_stackable__env_29_cfa_info2, _make_procedure_app_stackable__130_cfa_info23237, _make_procedure_app_stackable__130_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_struct_app__env_241_cfa_info2, _make_struct_app__44_cfa_info23238, _make_struct_app__44_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(vector_set__app__env_27_cfa_info2, _vector_set__app__140_cfa_info23239, _vector_set__app__140_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_vector_app_type_env_9_cfa_info2, _make_vector_app_type_115_cfa_info23240, _make_vector_app_type_115_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(vector_ref_app_args_env_246_cfa_info2, _vector_ref_app_args_111_cfa_info23241, _vector_ref_app_args_111_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_vector_app_stackable__env_206_cfa_info2, _make_vector_app_stackable__177_cfa_info23242, _make_vector_app_stackable__177_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(procedure_ref_app_loc_env_150_cfa_info2, _procedure_ref_app_loc_33_cfa_info23243, _procedure_ref_app_loc_33_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_procedure_app_args_set__env_73_cfa_info2, _make_procedure_app_args_set__120_cfa_info23244, _make_procedure_app_args_set__120_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_vector_app_owner_env_149_cfa_info2, _make_vector_app_owner_231_cfa_info23245, _make_vector_app_owner_231_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_procedure_app_fun_set__env_197_cfa_info2, _make_procedure_app_fun_set__92_cfa_info23246, _make_procedure_app_fun_set__92_cfa_info2, 0L, 2);
DEFINE_STRING(string2953_cfa_info2, string2953_cfa_info23247, "DONE STRUCT-SET!-APP STRUCT-REF-APP MAKE-STRUCT-APP PRE-STRUCT-SET!-APP PRE-STRUCT-REF-APP PRE-MAKE-STRUCT-APP VECTOR-SET!-APP VECTOR-REF-APP CREATE-VECTOR-APP MAKE-VECTOR-APP PRE-VECTOR-SET!-APP PRE-VECTOR-REF-APP PRE-CREATE-VECTOR-APP PRE-MAKE-VECTOR-APP PROCEDURE-SET!-APP PROCEDURE-REF-APP MAKE-PROCEDURE-APP PRE-PROCEDURE-SET!-APP PRE-PROCEDURE-REF-APP PRE-MAKE-PROCEDURE-APP ", 381);
DEFINE_EXPORT_PROCEDURE(make_make_vector_app_env_250_cfa_info2, _make_make_vector_app_59_cfa_info23248, _make_make_vector_app_59_cfa_info2, 0L, 14);
DEFINE_EXPORT_PROCEDURE(struct_ref_app_key_set__env_233_cfa_info2, _struct_ref_app_key_set_2872_176_cfa_info23249, _struct_ref_app_key_set_2872_176_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(struct_set__app_args_set__env_221_cfa_info2, _struct_set__app_args_set__240_cfa_info23250, _struct_set__app_args_set__240_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(allocate_vector_set__app_env_178_cfa_info2, _allocate_vector_set__app_158_cfa_info23251, _allocate_vector_set__app_158_cfa_info2, 0L, 0);
DEFINE_EXPORT_PROCEDURE(pre_vector_ref_app_type_set__env_223_cfa_info2, _pre_vector_ref_app_type_set__185_cfa_info23252, _pre_vector_ref_app_type_set__185_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_vector_app_lost_stamp_set__env_104_cfa_info2, _make_vector_app_lost_stamp_set__176_cfa_info23253, _make_vector_app_lost_stamp_set__176_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(create_vector_app_stack_stamp_set__env_155_cfa_info2, _create_vector_app_stack_stamp_set__88_cfa_info23254, _create_vector_app_stack_stamp_set__88_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pre_vector_set__app_key_set__env_45_cfa_info2, _pre_vector_set__app_key_set_2891_172_cfa_info23255, _pre_vector_set__app_key_set_2891_172_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(procedure_ref_app_args_set__env_186_cfa_info2, _procedure_ref_app_args_set__247_cfa_info23256, _procedure_ref_app_args_set__247_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(struct_ref_app_type_env_69_cfa_info2, _struct_ref_app_type_252_cfa_info23257, _struct_ref_app_type_252_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(struct_ref_app_stack_info_env_83_cfa_info2, _struct_ref_app_stack_info_96_cfa_info23258, _struct_ref_app_stack_info_96_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_procedure_ref_app_type_set__env_27_cfa_info2, _pre_procedure_ref_app_type_set__111_cfa_info23259, _pre_procedure_ref_app_type_set__111_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(widening_pre_make_vector_app_env_201_cfa_info2, _widening_pre_make_vector_app2896_63_cfa_info23260, _widening_pre_make_vector_app2896_63_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_procedure_set__app_key_set__env_130_cfa_info2, _pre_procedure_set__app_key_set_2905_12_cfa_info23261, _pre_procedure_set__app_key_set_2905_12_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_pre_create_vector_app_env_8_cfa_info2, _make_pre_create_vector_app_126_cfa_info23262, _make_pre_create_vector_app_126_cfa_info2, 0L, 8);
DEFINE_EXPORT_PROCEDURE(pre_make_vector_app_args_set__env_150_cfa_info2, _pre_make_vector_app_args_set__164_cfa_info23263, _pre_make_vector_app_args_set__164_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pre_make_struct_app_key_set__env_129_cfa_info2, _pre_make_struct_app_key_set__46_cfa_info23264, _pre_make_struct_app_key_set__46_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pre_create_vector_app_loc_env_245_cfa_info2, _pre_create_vector_app_loc_79_cfa_info23265, _pre_create_vector_app_loc_79_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_struct_app_stackable__env_98_cfa_info2, _make_struct_app_stackable__6_cfa_info23266, _make_struct_app_stackable__6_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(allocate_pre_struct_set__app_env_196_cfa_info2, _allocate_pre_struct_set__app_93_cfa_info23267, _allocate_pre_struct_set__app_93_cfa_info2, 0L, 0);
DEFINE_EXPORT_PROCEDURE(make_procedure_app_values_approx_set__env_190_cfa_info2, _make_procedure_app_values_approx_set__126_cfa_info23268, _make_procedure_app_values_approx_set__126_cfa_info2, 0L, 3);
DEFINE_EXPORT_PROCEDURE(pre_vector_set__app_loc_env_178_cfa_info2, _pre_vector_set__app_loc_128_cfa_info23269, _pre_vector_set__app_loc_128_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_struct_app_approx_set__env_2_cfa_info2, _make_struct_app_approx_set__178_cfa_info23270, _make_struct_app_approx_set__178_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pre_make_struct_app_type_env_150_cfa_info2, _pre_make_struct_app_type_57_cfa_info23271, _pre_make_struct_app_type_57_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_procedure_ref_app_stack_info_set__env_172_cfa_info2, _pre_procedure_ref_app_stack_info_set__160_cfa_info23272, _pre_procedure_ref_app_stack_info_set__160_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pre_make_vector_app_args_env_145_cfa_info2, _pre_make_vector_app_args_80_cfa_info23273, _pre_make_vector_app_args_80_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(vector_set__app_key_env_169_cfa_info2, _vector_set__app_key2883_59_cfa_info23274, _vector_set__app_key2883_59_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_struct_set__app_side_effect__set__env_63_cfa_info2, _pre_struct_set__app_side_effect__set__221_cfa_info23275, _pre_struct_set__app_side_effect__set__221_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(create_vector_app_stackable__env_240_cfa_info2, _create_vector_app_stackable__232_cfa_info23276, _create_vector_app_stackable__232_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_struct_ref_app_fun_env_218_cfa_info2, _pre_struct_ref_app_fun_118_cfa_info23277, _pre_struct_ref_app_fun_118_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_struct_ref_app_key_set__env_67_cfa_info2, _pre_struct_ref_app_key_set_2878_242_cfa_info23278, _pre_struct_ref_app_key_set_2878_242_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_procedure_app_side_effect__env_203_cfa_info2, _make_procedure_app_side_effect__232_cfa_info23279, _make_procedure_app_side_effect__232_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(procedure_set__app_side_effect__env_192_cfa_info2, _procedure_set__app_side_effect__112_cfa_info23280, _procedure_set__app_side_effect__112_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_procedure_app_side_effect__set__env_60_cfa_info2, _make_procedure_app_side_effect__set__15_cfa_info23281, _make_procedure_app_side_effect__set__15_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(create_vector_app_value_approx_env_159_cfa_info2, _create_vector_app_value_approx_26_cfa_info23282, _create_vector_app_value_approx_26_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_make_struct_app_loc_env_8_cfa_info2, _pre_make_struct_app_loc_183_cfa_info23283, _pre_make_struct_app_loc_183_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(allocate_pre_make_struct_app_env_41_cfa_info2, _allocate_pre_make_struct_app_85_cfa_info23284, _allocate_pre_make_struct_app_85_cfa_info2, 0L, 0);
DEFINE_EXPORT_PROCEDURE(procedure_ref_app_stack_info_set__env_189_cfa_info2, _procedure_ref_app_stack_info_set__26_cfa_info23285, _procedure_ref_app_stack_info_set__26_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_struct_app_approx_env_110_cfa_info2, _make_struct_app_approx_7_cfa_info23286, _make_struct_app_approx_7_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_struct_app_key_env_206_cfa_info2, _make_struct_app_key_133_cfa_info23287, _make_struct_app_key_133_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_struct_ref_app_side_effect__env_207_cfa_info2, _pre_struct_ref_app_side_effect__0_cfa_info23288, _pre_struct_ref_app_side_effect__0_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_vector_app_fun_set__env_88_cfa_info2, _make_vector_app_fun_set__5_cfa_info23289, _make_vector_app_fun_set__5_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(vector_ref_app_fun_set__env_51_cfa_info2, _vector_ref_app_fun_set__206_cfa_info23290, _vector_ref_app_fun_set__206_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_struct_app_lost_stamp_set__env_181_cfa_info2, _make_struct_app_lost_stamp_set__243_cfa_info23291, _make_struct_app_lost_stamp_set__243_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pre_struct_set__app_stack_info_set__env_59_cfa_info2, _pre_struct_set__app_stack_info_set__234_cfa_info23292, _pre_struct_set__app_stack_info_set__234_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(widening_pre_procedure_set__app_env_55_cfa_info2, _widening_pre_procedure_set__app_89_cfa_info23293, _widening_pre_procedure_set__app_89_cfa_info2, 0L, 0);
DEFINE_EXPORT_PROCEDURE(struct_ref_app_fun_env_96_cfa_info2, _struct_ref_app_fun_240_cfa_info23294, _struct_ref_app_fun_240_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(struct_set__app_fun_set__env_54_cfa_info2, _struct_set__app_fun_set__251_cfa_info23295, _struct_set__app_fun_set__251_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pre_create_vector_app_stack_info_set__env_219_cfa_info2, _pre_create_vector_app_stack_info_set__170_cfa_info23296, _pre_create_vector_app_stack_info_set__170_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(struct_set__app_side_effect__set__env_223_cfa_info2, _struct_set__app_side_effect__set__120_cfa_info23297, _struct_set__app_side_effect__set__120_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(procedure_ref_app_fun_set__env_146_cfa_info2, _procedure_ref_app_fun_set__32_cfa_info23298, _procedure_ref_app_fun_set__32_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_procedure_app_values_approx_ref_env_109_cfa_info2, _make_procedure_app_values_approx_ref_196_cfa_info23299, _make_procedure_app_values_approx_ref_196_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_create_vector_app_env_137_cfa_info2, _make_create_vector_app_218_cfa_info23300, _make_create_vector_app_218_cfa_info2, 0L, 14);
DEFINE_EXPORT_PROCEDURE(pre_procedure_set__app_stack_info_set__env_101_cfa_info2, _pre_procedure_set__app_stack_info_set__185_cfa_info23301, _pre_procedure_set__app_stack_info_set__185_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_struct_app_type_env_241_cfa_info2, _make_struct_app_type_134_cfa_info23302, _make_struct_app_type_134_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_vector_ref_app_key_env_119_cfa_info2, _pre_vector_ref_app_key2894_92_cfa_info23303, _pre_vector_ref_app_key2894_92_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_vector_app_args_env_57_cfa_info2, _make_vector_app_args_191_cfa_info23304, _make_vector_app_args_191_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_procedure_app_key_set__env_162_cfa_info2, _make_procedure_app_key_set_2904_180_cfa_info23305, _make_procedure_app_key_set_2904_180_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pre_struct_set__app_args_set__env_75_cfa_info2, _pre_struct_set__app_args_set__231_cfa_info23306, _pre_struct_set__app_args_set__231_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(create_vector_app_stack_info_set__env_182_cfa_info2, _create_vector_app_stack_info_set__184_cfa_info23307, _create_vector_app_stack_info_set__184_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(create_vector_app_fun_env_29_cfa_info2, _create_vector_app_fun_195_cfa_info23308, _create_vector_app_fun_195_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_struct_ref_app_stack_info_env_149_cfa_info2, _pre_struct_ref_app_stack_info_45_cfa_info23309, _pre_struct_ref_app_stack_info_45_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_vector_ref_app_fun_set__env_68_cfa_info2, _pre_vector_ref_app_fun_set__225_cfa_info23310, _pre_vector_ref_app_fun_set__225_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_struct_app_side_effect__env_111_cfa_info2, _make_struct_app_side_effect__240_cfa_info23311, _make_struct_app_side_effect__240_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_procedure_app_x_t__set__env_92_cfa_info2, _make_procedure_app_x_t__set__129_cfa_info23312, _make_procedure_app_x_t__set__129_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(procedure_set__app__env_32_cfa_info2, _procedure_set__app__159_cfa_info23313, _procedure_set__app__159_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(vector_ref_app_key_env_6_cfa_info2, _vector_ref_app_key2886_186_cfa_info23314, _vector_ref_app_key2886_186_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(create_vector_app_stackable__set__env_123_cfa_info2, _create_vector_app_stackable__set__15_cfa_info23315, _create_vector_app_stackable__set__15_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_procedure_app_fun_env_25_cfa_info2, _make_procedure_app_fun_72_cfa_info23316, _make_procedure_app_fun_72_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(allocate_struct_set__app_env_221_cfa_info2, _allocate_struct_set__app_138_cfa_info23317, _allocate_struct_set__app_138_cfa_info2, 0L, 0);
DEFINE_EXPORT_PROCEDURE(procedure_set__app_fun_env_66_cfa_info2, _procedure_set__app_fun_119_cfa_info23318, _procedure_set__app_fun_119_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_make_vector_app_key_env_92_cfa_info2, _pre_make_vector_app_key_241_cfa_info23319, _pre_make_vector_app_key_241_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(procedure_set__app_type_set__env_117_cfa_info2, _procedure_set__app_type_set__16_cfa_info23320, _procedure_set__app_type_set__16_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(struct_ref_app_args_env_188_cfa_info2, _struct_ref_app_args_14_cfa_info23321, _struct_ref_app_args_14_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_vector_set__app_env_6_cfa_info2, _make_vector_set__app_54_cfa_info23322, _make_vector_set__app_54_cfa_info2, 0L, 8);
DEFINE_EXPORT_PROCEDURE(vector_set__app_type_set__env_206_cfa_info2, _vector_set__app_type_set__61_cfa_info23323, _vector_set__app_type_set__61_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_pre_make_vector_app_env_23_cfa_info2, _make_pre_make_vector_app_64_cfa_info23324, _make_pre_make_vector_app_64_cfa_info2, 0L, 8);
DEFINE_EXPORT_PROCEDURE(widening_pre_vector_set__app_env_173_cfa_info2, _widening_pre_vector_set__app_64_cfa_info23325, _widening_pre_vector_set__app_64_cfa_info2, 0L, 0);
DEFINE_EXPORT_PROCEDURE(make_vector_app_seen__set__env_36_cfa_info2, _make_vector_app_seen__set__29_cfa_info23326, _make_vector_app_seen__set__29_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(create_vector_app_stack_stamp_env_194_cfa_info2, _create_vector_app_stack_stamp_254_cfa_info23327, _create_vector_app_stack_stamp_254_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_procedure_app_t_set__env_248_cfa_info2, _make_procedure_app_t_set__41_cfa_info23328, _make_procedure_app_t_set__41_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_pre_struct_ref_app_env_95_cfa_info2, _make_pre_struct_ref_app_219_cfa_info23329, _make_pre_struct_ref_app_219_cfa_info2, 0L, 7);
DEFINE_EXPORT_PROCEDURE(make_vector_app_fun_env_100_cfa_info2, _make_vector_app_fun_245_cfa_info23330, _make_vector_app_fun_245_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_procedure_app__env_181_cfa_info2, _make_procedure_app__219_cfa_info23331, _make_procedure_app__219_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(allocate_make_procedure_app_env_172_cfa_info2, _allocate_make_procedure_app_241_cfa_info23332, _allocate_make_procedure_app_241_cfa_info2, 0L, 0);
DEFINE_EXPORT_PROCEDURE(pre_make_struct_app_args_env_173_cfa_info2, _pre_make_struct_app_args_7_cfa_info23333, _pre_make_struct_app_args_7_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_make_struct_app__env_93_cfa_info2, _pre_make_struct_app__245_cfa_info23334, _pre_make_struct_app__245_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(allocate_pre_procedure_ref_app_env_67_cfa_info2, _allocate_pre_procedure_ref_app_105_cfa_info23335, _allocate_pre_procedure_ref_app_105_cfa_info2, 0L, 0);
DEFINE_EXPORT_PROCEDURE(pre_vector_set__app__env_230_cfa_info2, _pre_vector_set__app__223_cfa_info23336, _pre_vector_set__app__223_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_make_procedure_app_args_set__env_51_cfa_info2, _pre_make_procedure_app_args_set__56_cfa_info23337, _pre_make_procedure_app_args_set__56_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(widening_make_vector_app_env_230_cfa_info2, _widening_make_vector_app2889_122_cfa_info23338, _widening_make_vector_app2889_122_cfa_info2, 0L, 7);
DEFINE_EXPORT_PROCEDURE(struct_set__app_stack_info_set__env_219_cfa_info2, _struct_set__app_stack_info_set__31_cfa_info23339, _struct_set__app_stack_info_set__31_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_procedure_app_stack_stamp_env_189_cfa_info2, _make_procedure_app_stack_stamp_199_cfa_info23340, _make_procedure_app_stack_stamp_199_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_procedure_ref_app_loc_env_182_cfa_info2, _pre_procedure_ref_app_loc_210_cfa_info23341, _pre_procedure_ref_app_loc_210_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(create_vector_app_args_set__env_236_cfa_info2, _create_vector_app_args_set__48_cfa_info23342, _create_vector_app_args_set__48_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(allocate_make_struct_app_env_154_cfa_info2, _allocate_make_struct_app_151_cfa_info23343, _allocate_make_struct_app_151_cfa_info2, 0L, 0);
DEFINE_EXPORT_PROCEDURE(pre_make_vector_app_owner_env_155_cfa_info2, _pre_make_vector_app_owner_96_cfa_info23344, _pre_make_vector_app_owner_96_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_create_vector_app_type_set__env_224_cfa_info2, _pre_create_vector_app_type_set__81_cfa_info23345, _pre_create_vector_app_type_set__81_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(procedure_ref_app_type_env_147_cfa_info2, _procedure_ref_app_type_117_cfa_info23346, _procedure_ref_app_type_117_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(vector_ref_app_stack_info_set__env_160_cfa_info2, _vector_ref_app_stack_info_set__176_cfa_info23347, _vector_ref_app_stack_info_set__176_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_vector_app_key_set__env_47_cfa_info2, _make_vector_app_key_set_2890_13_cfa_info23348, _make_vector_app_key_set_2890_13_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(allocate_pre_vector_ref_app_env_180_cfa_info2, _allocate_pre_vector_ref_app_31_cfa_info23349, _allocate_pre_vector_ref_app_31_cfa_info2, 0L, 0);
DEFINE_EXPORT_PROCEDURE(vector_ref_app_key_set__env_134_cfa_info2, _vector_ref_app_key_set_2885_104_cfa_info23350, _vector_ref_app_key_set_2885_104_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pre_struct_set__app_loc_env_136_cfa_info2, _pre_struct_set__app_loc_160_cfa_info23351, _pre_struct_set__app_loc_160_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(widening_make_procedure_app_env_125_cfa_info2, _widening_make_procedure_app2903_110_cfa_info23352, _widening_make_procedure_app2903_110_cfa_info2, 0L, 10);
DEFINE_EXPORT_PROCEDURE(struct_ref_app_type_set__env_222_cfa_info2, _struct_ref_app_type_set__133_cfa_info23353, _struct_ref_app_type_set__133_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pre_make_procedure_app_stack_info_set__env_7_cfa_info2, _pre_make_procedure_app_stack_info_set__44_cfa_info23354, _pre_make_procedure_app_stack_info_set__44_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(struct_set__app_key_set__env_81_cfa_info2, _struct_set__app_key_set_2869_207_cfa_info23355, _struct_set__app_key_set_2869_207_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(procedure_ref_app_key_set__env_133_cfa_info2, _procedure_ref_app_key_set_2901_89_cfa_info23356, _procedure_ref_app_key_set_2901_89_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(struct_set__app_key_env_29_cfa_info2, _struct_set__app_key2870_7_cfa_info23357, _struct_set__app_key2870_7_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(vector_set__app_side_effect__env_46_cfa_info2, _vector_set__app_side_effect__178_cfa_info23358, _vector_set__app_side_effect__178_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(vector_ref_app__env_223_cfa_info2, _vector_ref_app__210_cfa_info23359, _vector_ref_app__210_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(widening_pre_procedure_ref_app_env_94_cfa_info2, _widening_pre_procedure_ref_app_214_cfa_info23360, _widening_pre_procedure_ref_app_214_cfa_info2, 0L, 0);
DEFINE_EXPORT_PROCEDURE(allocate_struct_ref_app_env_33_cfa_info2, _allocate_struct_ref_app_88_cfa_info23361, _allocate_struct_ref_app_88_cfa_info2, 0L, 0);
DEFINE_EXPORT_PROCEDURE(pre_make_procedure_app_owner_env_182_cfa_info2, _pre_make_procedure_app_owner_124_cfa_info23362, _pre_make_procedure_app_owner_124_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_procedure_app_lost_stamp_env_81_cfa_info2, _make_procedure_app_lost_stamp_241_cfa_info23363, _make_procedure_app_lost_stamp_241_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(widening_pre_vector_ref_app_env_210_cfa_info2, _widening_pre_vector_ref_app_135_cfa_info23364, _widening_pre_vector_ref_app_135_cfa_info2, 0L, 0);
DEFINE_EXPORT_PROCEDURE(pre_make_procedure_app_fun_env_206_cfa_info2, _pre_make_procedure_app_fun_63_cfa_info23365, _pre_make_procedure_app_fun_63_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(create_vector_app_seen__set__env_145_cfa_info2, _create_vector_app_seen__set__190_cfa_info23366, _create_vector_app_seen__set__190_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pre_vector_ref_app_side_effect__env_170_cfa_info2, _pre_vector_ref_app_side_effect__11_cfa_info23367, _pre_vector_ref_app_side_effect__11_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(vector_set__app_fun_set__env_18_cfa_info2, _vector_set__app_fun_set__2_cfa_info23368, _vector_set__app_fun_set__2_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_procedure_app_t_env_175_cfa_info2, _make_procedure_app_t_235_cfa_info23369, _make_procedure_app_t_235_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_struct_ref_app_args_set__env_132_cfa_info2, _pre_struct_ref_app_args_set__179_cfa_info23370, _pre_struct_ref_app_args_set__179_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pre_procedure_set__app_fun_env_130_cfa_info2, _pre_procedure_set__app_fun_238_cfa_info23371, _pre_procedure_set__app_fun_238_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_vector_ref_app_side_effect__set__env_147_cfa_info2, _pre_vector_ref_app_side_effect__set__248_cfa_info23372, _pre_vector_ref_app_side_effect__set__248_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_procedure_app_approx_env_222_cfa_info2, _make_procedure_app_approx_34_cfa_info23373, _make_procedure_app_approx_34_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_struct_app_args_env_122_cfa_info2, _make_struct_app_args_135_cfa_info23374, _make_struct_app_args_135_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(vector_set__app_approx_env_205_cfa_info2, _vector_set__app_approx_118_cfa_info23375, _vector_set__app_approx_118_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_struct_app_fun_set__env_215_cfa_info2, _make_struct_app_fun_set__143_cfa_info23376, _make_struct_app_fun_set__143_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(widening_vector_ref_app_env_168_cfa_info2, _widening_vector_ref_app2884_167_cfa_info23377, _widening_vector_ref_app2884_167_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_struct_app_type_set__env_32_cfa_info2, _make_struct_app_type_set__135_cfa_info23378, _make_struct_app_type_set__135_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_struct_app_value_approx_env_50_cfa_info2, _make_struct_app_value_approx_167_cfa_info23379, _make_struct_app_value_approx_167_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_vector_ref_app_key_set__env_130_cfa_info2, _pre_vector_ref_app_key_set_2893_33_cfa_info23380, _pre_vector_ref_app_key_set_2893_33_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_vector_app_lost_stamp_env_156_cfa_info2, _make_vector_app_lost_stamp_194_cfa_info23381, _make_vector_app_lost_stamp_194_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(create_vector_app_side_effect__set__env_9_cfa_info2, _create_vector_app_side_effect__set__90_cfa_info23382, _create_vector_app_side_effect__set__90_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pre_vector_set__app_type_set__env_81_cfa_info2, _pre_vector_set__app_type_set__170_cfa_info23383, _pre_vector_set__app_type_set__170_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pre_procedure_ref_app_side_effect__env_66_cfa_info2, _pre_procedure_ref_app_side_effect__173_cfa_info23384, _pre_procedure_ref_app_side_effect__173_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_vector_app__env_97_cfa_info2, _make_vector_app__161_cfa_info23385, _make_vector_app__161_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(create_vector_app_approx_set__env_104_cfa_info2, _create_vector_app_approx_set__24_cfa_info23386, _create_vector_app_approx_set__24_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_struct_set__app_env_158_cfa_info2, _make_struct_set__app_236_cfa_info23387, _make_struct_set__app_236_cfa_info2, 0L, 8);
DEFINE_EXPORT_PROCEDURE(procedure_ref_app_fun_env_154_cfa_info2, _procedure_ref_app_fun_110_cfa_info23388, _procedure_ref_app_fun_110_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(create_vector_app_fun_set__env_81_cfa_info2, _create_vector_app_fun_set__241_cfa_info23389, _create_vector_app_fun_set__241_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pre_procedure_set__app_side_effect__set__env_147_cfa_info2, _pre_procedure_set__app_side_effect__set__8_cfa_info23390, _pre_procedure_set__app_side_effect__set__8_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pre_procedure_ref_app_type_env_96_cfa_info2, _pre_procedure_ref_app_type_154_cfa_info23391, _pre_procedure_ref_app_type_154_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_struct_app_lost_stamp_env_34_cfa_info2, _make_struct_app_lost_stamp_65_cfa_info23392, _make_struct_app_lost_stamp_65_cfa_info2, 0L, 1);
extern obj_t object__struct_env_210___object;
DEFINE_EXPORT_PROCEDURE(pre_create_vector_app_side_effect__env_139_cfa_info2, _pre_create_vector_app_side_effect__129_cfa_info23393, _pre_create_vector_app_side_effect__129_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_procedure_app_approx_set__env_254_cfa_info2, _make_procedure_app_approx_set__151_cfa_info23394, _make_procedure_app_approx_set__151_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(widening_pre_struct_set__app_env_143_cfa_info2, _widening_pre_struct_set__app_119_cfa_info23395, _widening_pre_struct_set__app_119_cfa_info2, 0L, 0);
DEFINE_EXPORT_PROCEDURE(create_vector_app_lost_stamp_set__env_29_cfa_info2, _create_vector_app_lost_stamp_set__201_cfa_info23396, _create_vector_app_lost_stamp_set__201_cfa_info2, 0L, 2);
DEFINE_EXPORT_PROCEDURE(pre_struct_ref_app_key_env_15_cfa_info2, _pre_struct_ref_app_key2879_31_cfa_info23397, _pre_struct_ref_app_key2879_31_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_pre_vector_set__app_env_252_cfa_info2, _make_pre_vector_set__app_51_cfa_info23398, _make_pre_vector_set__app_51_cfa_info2, 0L, 7);
DEFINE_EXPORT_PROCEDURE(vector_set__app_loc_env_177_cfa_info2, _vector_set__app_loc_250_cfa_info23399, _vector_set__app_loc_250_cfa_info2, 0L, 1);
DEFINE_EXPORT_PROCEDURE(pre_procedure_ref_app_fun_set__env_114_cfa_info2, _pre_procedure_ref_app_fun_set__20_cfa_info23400, _pre_procedure_ref_app_fun_set__20_cfa_info2, 0L, 2);



/* module-initialization */
obj_t 
module_initialization_70_cfa_info2(long checksum_6573, char *from_6574)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_cfa_info2))
	{
	   require_initialization_114_cfa_info2 =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_cfa_info2();
	   cnst_init_137_cfa_info2();
	   imported_modules_init_94_cfa_info2();
	   object_init_111_cfa_info2();
	   method_init_76_cfa_info2();
	   toplevel_init_63_cfa_info2();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_cfa_info2()
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 15 */
      module_initialization_70___object(((long) 0), "CFA_INFO2");
      module_initialization_70___reader(((long) 0), "CFA_INFO2");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_cfa_info2()
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 15 */
      {		/* Cfa/cinfo2.scm 15 */
	 obj_t cnst_port_138_6566;
	 cnst_port_138_6566 =
	    open_input_string(string2953_cfa_info2);
	 {
	    long i_6567;
	    i_6567 = ((long) 20);
	  loop_6568:
	    {	/* Cfa/cinfo2.scm 15 */
	       bool_t test2954_6569;
	       test2954_6569 =
		  (i_6567 == ((long) -1));
	       if (test2954_6569)
		 {	/* Cfa/cinfo2.scm 15 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Cfa/cinfo2.scm 15 */
		    {	/* Cfa/cinfo2.scm 15 */
		       obj_t arg2955_6570;
		       {	/* Cfa/cinfo2.scm 15 */
			  obj_t list2956_6571;
			  list2956_6571 =
			     MAKE_PAIR(cnst_port_138_6566, BNIL);
			  arg2955_6570 =
			     read___reader(list2956_6571);
		       }
		       CNST_TABLE_SET(i_6567, arg2955_6570);
		    }
		    {	/* Cfa/cinfo2.scm 15 */
		       int aux_6572;
		       {	/* Cfa/cinfo2.scm 15 */
			  long aux_6592;
			  aux_6592 =
			     (i_6567 - ((long) 1));
			  aux_6572 =
			     (int) (aux_6592);
		       }
		       {
			  long i_6595;
			  i_6595 =
			     (long) (aux_6572);
			  i_6567 = i_6595;
			  goto loop_6568;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_cfa_info2()
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 15 */
      return BUNSPEC;
   }
}



/* object-init */
obj_t 
object_init_111_cfa_info2()
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 15 */
      {		/* Cfa/cinfo2.scm 15 */
	 obj_t arg2255_2158;
	 obj_t arg2256_2159;
	 obj_t arg2259_2162;
	 arg2255_2158 =
	    CNST_TABLE_REF(((long) 0));
	 arg2256_2159 = app_ast_node;
	 {	/* Cfa/cinfo2.scm 15 */
	    obj_t v2155_2163;
	    v2155_2163 =
	       create_vector(((long) 0));
	    arg2259_2162 = v2155_2163;
	 }
	 pre_make_procedure_app_60_cfa_info2 =
	    register_class__225___object(arg2255_2158, arg2256_2159, allocate_pre_make_procedure_app_env_235_cfa_info2, ((long) 58299), BUNSPEC, BFALSE, arg2259_2162);
      }
      {		/* Cfa/cinfo2.scm 15 */
	 obj_t arg2260_2164;
	 obj_t arg2261_2165;
	 obj_t arg2265_2168;
	 arg2260_2164 =
	    CNST_TABLE_REF(((long) 1));
	 arg2261_2165 = app_ast_node;
	 {	/* Cfa/cinfo2.scm 15 */
	    obj_t v2156_2169;
	    v2156_2169 =
	       create_vector(((long) 0));
	    arg2265_2168 = v2156_2169;
	 }
	 pre_procedure_ref_app_85_cfa_info2 =
	    register_class__225___object(arg2260_2164, arg2261_2165, allocate_pre_procedure_ref_app_env_67_cfa_info2, ((long) 29725), BUNSPEC, BFALSE, arg2265_2168);
      }
      {		/* Cfa/cinfo2.scm 15 */
	 obj_t arg2266_2170;
	 obj_t arg2267_2171;
	 obj_t arg2270_2174;
	 arg2266_2170 =
	    CNST_TABLE_REF(((long) 2));
	 arg2267_2171 = app_ast_node;
	 {	/* Cfa/cinfo2.scm 15 */
	    obj_t v2157_2175;
	    v2157_2175 =
	       create_vector(((long) 0));
	    arg2270_2174 = v2157_2175;
	 }
	 pre_procedure_set__app_208_cfa_info2 =
	    register_class__225___object(arg2266_2170, arg2267_2171, allocate_pre_procedure_set__app_env_247_cfa_info2, ((long) 15565), BUNSPEC, BFALSE, arg2270_2174);
      }
      {		/* Cfa/cinfo2.scm 15 */
	 obj_t arg2271_2176;
	 obj_t arg2272_2177;
	 obj_t arg2276_2180;
	 arg2271_2176 =
	    CNST_TABLE_REF(((long) 3));
	 arg2272_2177 = app_ast_node;
	 {	/* Cfa/cinfo2.scm 15 */
	    obj_t v2158_2181;
	    v2158_2181 =
	       create_vector(((long) 0));
	    arg2276_2180 = v2158_2181;
	 }
	 make_procedure_app_48_cfa_info2 =
	    register_class__225___object(arg2271_2176, arg2272_2177, allocate_make_procedure_app_env_172_cfa_info2, ((long) 5541), BUNSPEC, BFALSE, arg2276_2180);
      }
      {		/* Cfa/cinfo2.scm 15 */
	 obj_t arg2277_2182;
	 obj_t arg2279_2183;
	 obj_t arg2282_2186;
	 arg2277_2182 =
	    CNST_TABLE_REF(((long) 4));
	 arg2279_2183 = app_ast_node;
	 {	/* Cfa/cinfo2.scm 15 */
	    obj_t v2159_2187;
	    v2159_2187 =
	       create_vector(((long) 0));
	    arg2282_2186 = v2159_2187;
	 }
	 procedure_ref_app_49_cfa_info2 =
	    register_class__225___object(arg2277_2182, arg2279_2183, allocate_procedure_ref_app_env_35_cfa_info2, ((long) 6233), BUNSPEC, BFALSE, arg2282_2186);
      }
      {		/* Cfa/cinfo2.scm 15 */
	 obj_t arg2283_2188;
	 obj_t arg2284_2189;
	 obj_t arg2287_2192;
	 arg2283_2188 =
	    CNST_TABLE_REF(((long) 5));
	 arg2284_2189 = app_ast_node;
	 {	/* Cfa/cinfo2.scm 15 */
	    obj_t v2160_2193;
	    v2160_2193 =
	       create_vector(((long) 0));
	    arg2287_2192 = v2160_2193;
	 }
	 procedure_set__app_32_cfa_info2 =
	    register_class__225___object(arg2283_2188, arg2284_2189, allocate_procedure_set__app_env_74_cfa_info2, ((long) 39689), BUNSPEC, BFALSE, arg2287_2192);
      }
      {		/* Cfa/cinfo2.scm 15 */
	 obj_t arg2288_2194;
	 obj_t arg2289_2195;
	 obj_t arg2292_2198;
	 arg2288_2194 =
	    CNST_TABLE_REF(((long) 6));
	 arg2289_2195 = app_ast_node;
	 {	/* Cfa/cinfo2.scm 15 */
	    obj_t v2161_2199;
	    v2161_2199 =
	       create_vector(((long) 0));
	    arg2292_2198 = v2161_2199;
	 }
	 pre_make_vector_app_251_cfa_info2 =
	    register_class__225___object(arg2288_2194, arg2289_2195, allocate_pre_make_vector_app_env_198_cfa_info2, ((long) 52733), BUNSPEC, BFALSE, arg2292_2198);
      }
      {		/* Cfa/cinfo2.scm 15 */
	 obj_t arg2293_2200;
	 obj_t arg2294_2201;
	 obj_t arg2297_2204;
	 arg2293_2200 =
	    CNST_TABLE_REF(((long) 7));
	 arg2294_2201 = app_ast_node;
	 {	/* Cfa/cinfo2.scm 15 */
	    obj_t v2162_2205;
	    v2162_2205 =
	       create_vector(((long) 0));
	    arg2297_2204 = v2162_2205;
	 }
	 pre_create_vector_app_162_cfa_info2 =
	    register_class__225___object(arg2293_2200, arg2294_2201, allocate_pre_create_vector_app_env_147_cfa_info2, ((long) 6683), BUNSPEC, BFALSE, arg2297_2204);
      }
      {		/* Cfa/cinfo2.scm 15 */
	 obj_t arg2298_2206;
	 obj_t arg2299_2207;
	 obj_t arg2302_2210;
	 arg2298_2206 =
	    CNST_TABLE_REF(((long) 8));
	 arg2299_2207 = app_ast_node;
	 {	/* Cfa/cinfo2.scm 15 */
	    obj_t v2163_2211;
	    v2163_2211 =
	       create_vector(((long) 0));
	    arg2302_2210 = v2163_2211;
	 }
	 pre_vector_ref_app_208_cfa_info2 =
	    register_class__225___object(arg2298_2206, arg2299_2207, allocate_pre_vector_ref_app_env_180_cfa_info2, ((long) 12767), BUNSPEC, BFALSE, arg2302_2210);
      }
      {		/* Cfa/cinfo2.scm 15 */
	 obj_t arg2303_2212;
	 obj_t arg2304_2213;
	 obj_t arg2307_2216;
	 arg2303_2212 =
	    CNST_TABLE_REF(((long) 9));
	 arg2304_2213 = app_ast_node;
	 {	/* Cfa/cinfo2.scm 15 */
	    obj_t v2164_2217;
	    v2164_2217 =
	       create_vector(((long) 0));
	    arg2307_2216 = v2164_2217;
	 }
	 pre_vector_set__app_211_cfa_info2 =
	    register_class__225___object(arg2303_2212, arg2304_2213, allocate_pre_vector_set__app_env_49_cfa_info2, ((long) 59551), BUNSPEC, BFALSE, arg2307_2216);
      }
      {		/* Cfa/cinfo2.scm 15 */
	 obj_t arg2308_2218;
	 obj_t arg2309_2219;
	 obj_t arg2312_2222;
	 arg2308_2218 =
	    CNST_TABLE_REF(((long) 10));
	 arg2309_2219 = app_ast_node;
	 {	/* Cfa/cinfo2.scm 15 */
	    obj_t v2165_2223;
	    v2165_2223 =
	       create_vector(((long) 0));
	    arg2312_2222 = v2165_2223;
	 }
	 make_vector_app_205_cfa_info2 =
	    register_class__225___object(arg2308_2218, arg2309_2219, allocate_make_vector_app_env_222_cfa_info2, ((long) 9488), BUNSPEC, BFALSE, arg2312_2222);
      }
      {		/* Cfa/cinfo2.scm 15 */
	 obj_t arg2313_2224;
	 obj_t arg2314_2225;
	 obj_t arg2317_2228;
	 arg2313_2224 =
	    CNST_TABLE_REF(((long) 11));
	 arg2314_2225 = app_ast_node;
	 {	/* Cfa/cinfo2.scm 15 */
	    obj_t v2166_2229;
	    v2166_2229 =
	       create_vector(((long) 0));
	    arg2317_2228 = v2166_2229;
	 }
	 create_vector_app_150_cfa_info2 =
	    register_class__225___object(arg2313_2224, arg2314_2225, allocate_create_vector_app_env_133_cfa_info2, ((long) 46782), BUNSPEC, BFALSE, arg2317_2228);
      }
      {		/* Cfa/cinfo2.scm 15 */
	 obj_t arg2318_2230;
	 obj_t arg2319_2231;
	 obj_t arg2322_2234;
	 arg2318_2230 =
	    CNST_TABLE_REF(((long) 12));
	 arg2319_2231 = app_ast_node;
	 {	/* Cfa/cinfo2.scm 15 */
	    obj_t v2167_2235;
	    v2167_2235 =
	       create_vector(((long) 0));
	    arg2322_2234 = v2167_2235;
	 }
	 vector_ref_app_195_cfa_info2 =
	    register_class__225___object(arg2318_2230, arg2319_2231, allocate_vector_ref_app_env_93_cfa_info2, ((long) 12027), BUNSPEC, BFALSE, arg2322_2234);
      }
      {		/* Cfa/cinfo2.scm 15 */
	 obj_t arg2323_2236;
	 obj_t arg2324_2237;
	 obj_t arg2327_2240;
	 arg2323_2236 =
	    CNST_TABLE_REF(((long) 13));
	 arg2324_2237 = app_ast_node;
	 {	/* Cfa/cinfo2.scm 15 */
	    obj_t v2168_2241;
	    v2168_2241 =
	       create_vector(((long) 0));
	    arg2327_2240 = v2168_2241;
	 }
	 vector_set__app_21_cfa_info2 =
	    register_class__225___object(arg2323_2236, arg2324_2237, allocate_vector_set__app_env_178_cfa_info2, ((long) 54427), BUNSPEC, BFALSE, arg2327_2240);
      }
      {		/* Cfa/cinfo2.scm 15 */
	 obj_t arg2328_2242;
	 obj_t arg2329_2243;
	 obj_t arg2332_2246;
	 arg2328_2242 =
	    CNST_TABLE_REF(((long) 14));
	 arg2329_2243 = app_ast_node;
	 {	/* Cfa/cinfo2.scm 15 */
	    obj_t v2169_2247;
	    v2169_2247 =
	       create_vector(((long) 0));
	    arg2332_2246 = v2169_2247;
	 }
	 pre_make_struct_app_218_cfa_info2 =
	    register_class__225___object(arg2328_2242, arg2329_2243, allocate_pre_make_struct_app_env_41_cfa_info2, ((long) 59951), BUNSPEC, BFALSE, arg2332_2246);
      }
      {		/* Cfa/cinfo2.scm 15 */
	 obj_t arg2333_2248;
	 obj_t arg2334_2249;
	 obj_t arg2337_2252;
	 arg2333_2248 =
	    CNST_TABLE_REF(((long) 15));
	 arg2334_2249 = app_ast_node;
	 {	/* Cfa/cinfo2.scm 15 */
	    obj_t v2170_2253;
	    v2170_2253 =
	       create_vector(((long) 0));
	    arg2337_2252 = v2170_2253;
	 }
	 pre_struct_ref_app_207_cfa_info2 =
	    register_class__225___object(arg2333_2248, arg2334_2249, allocate_pre_struct_ref_app_env_84_cfa_info2, ((long) 2929), BUNSPEC, BFALSE, arg2337_2252);
      }
      {		/* Cfa/cinfo2.scm 15 */
	 obj_t arg2338_2254;
	 obj_t arg2339_2255;
	 obj_t arg2342_2258;
	 arg2338_2254 =
	    CNST_TABLE_REF(((long) 16));
	 arg2339_2255 = app_ast_node;
	 {	/* Cfa/cinfo2.scm 15 */
	    obj_t v2171_2259;
	    v2171_2259 =
	       create_vector(((long) 0));
	    arg2342_2258 = v2171_2259;
	 }
	 pre_struct_set__app_116_cfa_info2 =
	    register_class__225___object(arg2338_2254, arg2339_2255, allocate_pre_struct_set__app_env_196_cfa_info2, ((long) 36545), BUNSPEC, BFALSE, arg2342_2258);
      }
      {		/* Cfa/cinfo2.scm 15 */
	 obj_t arg2343_2260;
	 obj_t arg2344_2261;
	 obj_t arg2347_2264;
	 arg2343_2260 =
	    CNST_TABLE_REF(((long) 17));
	 arg2344_2261 = app_ast_node;
	 {	/* Cfa/cinfo2.scm 15 */
	    obj_t v2172_2265;
	    v2172_2265 =
	       create_vector(((long) 0));
	    arg2347_2264 = v2172_2265;
	 }
	 make_struct_app_214_cfa_info2 =
	    register_class__225___object(arg2343_2260, arg2344_2261, allocate_make_struct_app_env_154_cfa_info2, ((long) 19688), BUNSPEC, BFALSE, arg2347_2264);
      }
      {		/* Cfa/cinfo2.scm 15 */
	 obj_t arg2348_2266;
	 obj_t arg2349_2267;
	 obj_t arg2352_2270;
	 arg2348_2266 =
	    CNST_TABLE_REF(((long) 18));
	 arg2349_2267 = app_ast_node;
	 {	/* Cfa/cinfo2.scm 15 */
	    obj_t v2173_2271;
	    v2173_2271 =
	       create_vector(((long) 0));
	    arg2352_2270 = v2173_2271;
	 }
	 struct_ref_app_73_cfa_info2 =
	    register_class__225___object(arg2348_2266, arg2349_2267, allocate_struct_ref_app_env_33_cfa_info2, ((long) 1901), BUNSPEC, BFALSE, arg2352_2270);
      }
      {		/* Cfa/cinfo2.scm 15 */
	 obj_t arg2353_2272;
	 obj_t arg2354_2273;
	 obj_t arg2357_2276;
	 arg2353_2272 =
	    CNST_TABLE_REF(((long) 19));
	 arg2354_2273 = app_ast_node;
	 {	/* Cfa/cinfo2.scm 15 */
	    obj_t v2174_2277;
	    v2174_2277 =
	       create_vector(((long) 0));
	    arg2357_2276 = v2174_2277;
	 }
	 struct_set__app_162_cfa_info2 =
	    register_class__225___object(arg2353_2272, arg2354_2273, allocate_struct_set__app_env_221_cfa_info2, ((long) 32509), BUNSPEC, BFALSE, arg2357_2276);
      }
      return BUNSPEC;
   }
}



/* allocate-struct-set!-app */
app_bglt 
allocate_struct_set__app_3_cfa_info2()
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 130 */
      {		/* Cfa/cinfo2.scm 130 */
	 app_bglt new2148_2278;
	 new2148_2278 =
	    ((app_bglt) BREF(GC_MALLOC(sizeof(struct app))));
	 {	/* Cfa/cinfo2.scm 130 */
	    long arg2358_2279;
	    arg2358_2279 =
	       class_num_218___object(struct_set__app_162_cfa_info2);
	    {	/* Cfa/cinfo2.scm 130 */
	       obj_t obj_3538;
	       obj_3538 =
		  (obj_t) (new2148_2278);
	       (((obj_t) CREF(obj_3538))->header = MAKE_HEADER(arg2358_2279, 0), BUNSPEC);
	    }
	 }
	 {	/* Cfa/cinfo2.scm 130 */
	    object_bglt aux_6661;
	    aux_6661 =
	       (object_bglt) (new2148_2278);
	    OBJECT_WIDENING_SET(aux_6661, BFALSE);
	 }
	 return new2148_2278;
      }
   }
}



/* _allocate-struct-set!-app */
obj_t 
_allocate_struct_set__app_138_cfa_info2(obj_t env_5330)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 130 */
      {		/* Cfa/cinfo2.scm 130 */
	 app_bglt aux_6664;
	 aux_6664 =
	    allocate_struct_set__app_3_cfa_info2();
	 return
	    (obj_t) (aux_6664);
      }
   }
}



/* struct-set!-app? */
bool_t 
struct_set__app__191_cfa_info2(obj_t obj_4)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 130 */
      return
	 is_a__118___object(obj_4, struct_set__app_162_cfa_info2);
   }
}



/* _struct-set!-app? */
obj_t 
_struct_set__app__165_cfa_info2(obj_t env_5331, obj_t obj_5332)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 130 */
      {		/* Cfa/cinfo2.scm 130 */
	 bool_t aux_6668;
	 aux_6668 =
	    struct_set__app__191_cfa_info2(obj_5332);
	 return
	    BBOOL(aux_6668);
      }
   }
}



/* widening-struct-set!-app */
struct_set__app_162_bglt 
widening_struct_set__app_221_cfa_info2(approx_bglt approx_5)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 130 */
      {		/* Cfa/cinfo2.scm 130 */
	 struct_set__app_162_bglt new2143_3540;
	 new2143_3540 =
	    ((struct_set__app_162_bglt) BREF(GC_MALLOC(sizeof(struct struct_set__app_162))));
	 ((((struct_set__app_162_bglt) CREF(new2143_3540))->approx) = ((approx_bglt) approx_5), BUNSPEC);
	 return new2143_3540;
      }
   }
}



/* _widening-struct-set!-app2868 */
obj_t 
_widening_struct_set__app2868_104_cfa_info2(obj_t env_5333, obj_t approx_5334)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 130 */
      {		/* Cfa/cinfo2.scm 130 */
	 struct_set__app_162_bglt aux_6673;
	 aux_6673 =
	    widening_struct_set__app_221_cfa_info2(
	    (approx_bglt) (approx_5334));
	 return
	    (obj_t) (aux_6673);
      }
   }
}



/* make-struct-set!-app */
struct_set__app_162_bglt 
make_struct_set__app_96_cfa_info2(obj_t loc_6, type_bglt type_7, obj_t side_effect__165_8, obj_t key_9, var_bglt fun_10, obj_t args_11, obj_t stack_info_255_12, approx_bglt approx_13)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 130 */
      {		/* Cfa/cinfo2.scm 130 */
	 app_bglt aux2146_3542;
	 {	/* Cfa/cinfo2.scm 130 */
	    app_bglt res2807_3564;
	    {	/* ./Ast/node.scm 698 */
	       app_bglt new1248_3553;
	       new1248_3553 =
		  ((app_bglt) BREF(GC_MALLOC(sizeof(struct app))));
	       {	/* ./Ast/node.scm 698 */
		  long arg2541_3554;
		  arg2541_3554 =
		     class_num_218___object(app_ast_node);
		  {	/* ./Ast/node.scm 698 */
		     obj_t obj_3562;
		     obj_3562 =
			(obj_t) (new1248_3553);
		     (((obj_t) CREF(obj_3562))->header = MAKE_HEADER(arg2541_3554, 0), BUNSPEC);
		  }
	       }
	       {	/* ./Ast/node.scm 698 */
		  object_bglt aux_6681;
		  aux_6681 =
		     (object_bglt) (new1248_3553);
		  OBJECT_WIDENING_SET(aux_6681, BFALSE);
	       }
	       ((((app_bglt) CREF(new1248_3553))->loc) = ((obj_t) loc_6), BUNSPEC);
	       ((((app_bglt) CREF(new1248_3553))->type) = ((type_bglt) type_7), BUNSPEC);
	       ((((app_bglt) CREF(new1248_3553))->side_effect__165) = ((obj_t) side_effect__165_8), BUNSPEC);
	       ((((app_bglt) CREF(new1248_3553))->key) = ((obj_t) key_9), BUNSPEC);
	       ((((app_bglt) CREF(new1248_3553))->fun) = ((var_bglt) fun_10), BUNSPEC);
	       ((((app_bglt) CREF(new1248_3553))->args) = ((obj_t) args_11), BUNSPEC);
	       ((((app_bglt) CREF(new1248_3553))->stack_info_255) = ((obj_t) stack_info_255_12), BUNSPEC);
	       res2807_3564 = new1248_3553;
	    }
	    aux2146_3542 = res2807_3564;
	 }
	 {	/* Cfa/cinfo2.scm 130 */
	    struct_set__app_162_bglt new2147_3543;
	    new2147_3543 =
	       ((struct_set__app_162_bglt) (aux2146_3542));
	    {	/* Cfa/cinfo2.scm 130 */
	       long arg2359_3544;
	       arg2359_3544 =
		  class_num_218___object(struct_set__app_162_cfa_info2);
	       {	/* Cfa/cinfo2.scm 130 */
		  obj_t obj_3565;
		  obj_3565 =
		     (obj_t) (new2147_3543);
		  (((obj_t) CREF(obj_3565))->header = MAKE_HEADER(arg2359_3544, 0), BUNSPEC);
	       }
	    }
	    {	/* Cfa/cinfo2.scm 130 */
	       struct_set__app_162_bglt arg2360_3545;
	       {	/* Cfa/cinfo2.scm 130 */
		  struct_set__app_162_bglt res2808_3570;
		  {	/* Cfa/cinfo2.scm 130 */
		     struct_set__app_162_bglt new2143_3568;
		     new2143_3568 =
			((struct_set__app_162_bglt) BREF(GC_MALLOC(sizeof(struct struct_set__app_162))));
		     ((((struct_set__app_162_bglt) CREF(new2143_3568))->approx) = ((approx_bglt) approx_13), BUNSPEC);
		     res2808_3570 = new2143_3568;
		  }
		  arg2360_3545 = res2808_3570;
	       }
	       {	/* Cfa/cinfo2.scm 130 */
		  obj_t aux_6699;
		  object_bglt aux_6697;
		  aux_6699 =
		     (obj_t) (arg2360_3545);
		  aux_6697 =
		     (object_bglt) (new2147_3543);
		  OBJECT_WIDENING_SET(aux_6697, aux_6699);
	       }
	    }
	    return new2147_3543;
	 }
      }
   }
}



/* _make-struct-set!-app */
obj_t 
_make_struct_set__app_236_cfa_info2(obj_t env_5335, obj_t loc_5336, obj_t type_5337, obj_t side_effect__165_5338, obj_t key_5339, obj_t fun_5340, obj_t args_5341, obj_t stack_info_255_5342, obj_t approx_5343)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 130 */
      {		/* Cfa/cinfo2.scm 130 */
	 struct_set__app_162_bglt aux_6702;
	 aux_6702 =
	    make_struct_set__app_96_cfa_info2(loc_5336,
	    (type_bglt) (type_5337), side_effect__165_5338, key_5339,
	    (var_bglt) (fun_5340), args_5341, stack_info_255_5342,
	    (approx_bglt) (approx_5343));
	 return
	    (obj_t) (aux_6702);
      }
   }
}



/* struct-set!-app-loc */
obj_t 
struct_set__app_loc_83_cfa_info2(app_bglt obj_14)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 661 */
      return
	 (((app_bglt) CREF(obj_14))->loc);
   }
}



/* _struct-set!-app-loc */
obj_t 
_struct_set__app_loc_220_cfa_info2(obj_t env_5344, obj_t obj_5345)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 661 */
      return
	 struct_set__app_loc_83_cfa_info2(
	 (app_bglt) (obj_5345));
   }
}



/* struct-set!-app-type-set! */
obj_t 
struct_set__app_type_set__172_cfa_info2(app_bglt obj_15, type_bglt val2137_16)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 130 */
      return
	 ((((app_bglt) CREF(obj_15))->type) = ((type_bglt) val2137_16), BUNSPEC);
   }
}



/* _struct-set!-app-type-set! */
obj_t 
_struct_set__app_type_set__106_cfa_info2(obj_t env_5346, obj_t obj_5347, obj_t val2137_5348)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 130 */
      return
	 struct_set__app_type_set__172_cfa_info2(
	 (app_bglt) (obj_5347),
	 (type_bglt) (val2137_5348));
   }
}



/* struct-set!-app-type */
type_bglt 
struct_set__app_type_138_cfa_info2(app_bglt obj_17)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 130 */
      return
	 (((app_bglt) CREF(obj_17))->type);
   }
}



/* _struct-set!-app-type */
obj_t 
_struct_set__app_type_189_cfa_info2(obj_t env_5349, obj_t obj_5350)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 130 */
      {		/* Cfa/cinfo2.scm 130 */
	 type_bglt aux_6716;
	 aux_6716 =
	    struct_set__app_type_138_cfa_info2(
	    (app_bglt) (obj_5350));
	 return
	    (obj_t) (aux_6716);
      }
   }
}



/* struct-set!-app-side-effect?-set! */
obj_t 
struct_set__app_side_effect__set__203_cfa_info2(app_bglt obj_18, obj_t val2138_19)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 669 */
      return
	 ((((app_bglt) CREF(obj_18))->side_effect__165) = ((obj_t) val2138_19), BUNSPEC);
   }
}



/* _struct-set!-app-side-effect?-set! */
obj_t 
_struct_set__app_side_effect__set__120_cfa_info2(obj_t env_5351, obj_t obj_5352, obj_t val2138_5353)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 669 */
      return
	 struct_set__app_side_effect__set__203_cfa_info2(
	 (app_bglt) (obj_5352), val2138_5353);
   }
}



/* struct-set!-app-side-effect? */
obj_t 
struct_set__app_side_effect__159_cfa_info2(app_bglt obj_20)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 669 */
      return
	 (((app_bglt) CREF(obj_20))->side_effect__165);
   }
}



/* _struct-set!-app-side-effect? */
obj_t 
_struct_set__app_side_effect__200_cfa_info2(obj_t env_5354, obj_t obj_5355)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 669 */
      return
	 struct_set__app_side_effect__159_cfa_info2(
	 (app_bglt) (obj_5355));
   }
}



/* struct-set!-app-key-set! */
obj_t 
struct_set__app_key_set__58_cfa_info2(app_bglt obj_21, obj_t val2139_22)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 673 */
      return
	 ((((app_bglt) CREF(obj_21))->key) = ((obj_t) val2139_22), BUNSPEC);
   }
}



/* _struct-set!-app-key-set!2869 */
obj_t 
_struct_set__app_key_set_2869_207_cfa_info2(obj_t env_5356, obj_t obj_5357, obj_t val2139_5358)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 673 */
      return
	 struct_set__app_key_set__58_cfa_info2(
	 (app_bglt) (obj_5357), val2139_5358);
   }
}



/* struct-set!-app-key */
obj_t 
struct_set__app_key_92_cfa_info2(app_bglt obj_23)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 673 */
      return
	 (((app_bglt) CREF(obj_23))->key);
   }
}



/* _struct-set!-app-key2870 */
obj_t 
_struct_set__app_key2870_7_cfa_info2(obj_t env_5359, obj_t obj_5360)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 673 */
      return
	 struct_set__app_key_92_cfa_info2(
	 (app_bglt) (obj_5360));
   }
}



/* struct-set!-app-fun-set! */
obj_t 
struct_set__app_fun_set__208_cfa_info2(app_bglt obj_24, var_bglt val2140_25)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 130 */
      return
	 ((((app_bglt) CREF(obj_24))->fun) = ((var_bglt) val2140_25), BUNSPEC);
   }
}



/* _struct-set!-app-fun-set! */
obj_t 
_struct_set__app_fun_set__251_cfa_info2(obj_t env_5361, obj_t obj_5362, obj_t val2140_5363)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 130 */
      return
	 struct_set__app_fun_set__208_cfa_info2(
	 (app_bglt) (obj_5362),
	 (var_bglt) (val2140_5363));
   }
}



/* struct-set!-app-fun */
var_bglt 
struct_set__app_fun_107_cfa_info2(app_bglt obj_26)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 130 */
      return
	 (((app_bglt) CREF(obj_26))->fun);
   }
}



/* _struct-set!-app-fun */
obj_t 
_struct_set__app_fun_99_cfa_info2(obj_t env_5364, obj_t obj_5365)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 130 */
      {		/* Cfa/cinfo2.scm 130 */
	 var_bglt aux_6737;
	 aux_6737 =
	    struct_set__app_fun_107_cfa_info2(
	    (app_bglt) (obj_5365));
	 return
	    (obj_t) (aux_6737);
      }
   }
}



/* struct-set!-app-args-set! */
obj_t 
struct_set__app_args_set__3_cfa_info2(app_bglt obj_27, obj_t val2141_28)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 130 */
      return
	 ((((app_bglt) CREF(obj_27))->args) = ((obj_t) val2141_28), BUNSPEC);
   }
}



/* _struct-set!-app-args-set! */
obj_t 
_struct_set__app_args_set__240_cfa_info2(obj_t env_5366, obj_t obj_5367, obj_t val2141_5368)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 130 */
      return
	 struct_set__app_args_set__3_cfa_info2(
	 (app_bglt) (obj_5367), val2141_5368);
   }
}



/* struct-set!-app-args */
obj_t 
struct_set__app_args_163_cfa_info2(app_bglt obj_29)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 130 */
      return
	 (((app_bglt) CREF(obj_29))->args);
   }
}



/* _struct-set!-app-args */
obj_t 
_struct_set__app_args_213_cfa_info2(obj_t env_5369, obj_t obj_5370)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 130 */
      return
	 struct_set__app_args_163_cfa_info2(
	 (app_bglt) (obj_5370));
   }
}



/* struct-set!-app-stack-info-set! */
obj_t 
struct_set__app_stack_info_set__211_cfa_info2(app_bglt obj_30, obj_t val2142_31)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 704 */
      return
	 ((((app_bglt) CREF(obj_30))->stack_info_255) = ((obj_t) val2142_31), BUNSPEC);
   }
}



/* _struct-set!-app-stack-info-set! */
obj_t 
_struct_set__app_stack_info_set__31_cfa_info2(obj_t env_5371, obj_t obj_5372, obj_t val2142_5373)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 704 */
      return
	 struct_set__app_stack_info_set__211_cfa_info2(
	 (app_bglt) (obj_5372), val2142_5373);
   }
}



/* struct-set!-app-stack-info */
obj_t 
struct_set__app_stack_info_137_cfa_info2(app_bglt obj_32)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 704 */
      return
	 (((app_bglt) CREF(obj_32))->stack_info_255);
   }
}



/* _struct-set!-app-stack-info */
obj_t 
_struct_set__app_stack_info_135_cfa_info2(obj_t env_5374, obj_t obj_5375)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 704 */
      return
	 struct_set__app_stack_info_137_cfa_info2(
	 (app_bglt) (obj_5375));
   }
}



/* struct-set!-app-approx */
approx_bglt 
struct_set__app_approx_154_cfa_info2(struct_set__app_162_bglt obj_33)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 130 */
      {
	 obj_t aux_6753;
	 {	/* Cfa/cinfo2.scm 130 */
	    object_bglt aux_6754;
	    aux_6754 =
	       (object_bglt) (obj_33);
	    aux_6753 =
	       OBJECT_WIDENING(aux_6754);
	 }
	 return
	    (((struct_set__app_162_bglt) CREF(aux_6753))->approx);
      }
   }
}



/* _struct-set!-app-approx */
obj_t 
_struct_set__app_approx_83_cfa_info2(obj_t env_5376, obj_t obj_5377)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 130 */
      {		/* Cfa/cinfo2.scm 130 */
	 approx_bglt aux_6758;
	 aux_6758 =
	    struct_set__app_approx_154_cfa_info2(
	    (struct_set__app_162_bglt) (obj_5377));
	 return
	    (obj_t) (aux_6758);
      }
   }
}



/* allocate-struct-ref-app */
app_bglt 
allocate_struct_ref_app_224_cfa_info2()
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 129 */
      {		/* Cfa/cinfo2.scm 129 */
	 app_bglt new2130_2286;
	 new2130_2286 =
	    ((app_bglt) BREF(GC_MALLOC(sizeof(struct app))));
	 {	/* Cfa/cinfo2.scm 129 */
	    long arg2361_2287;
	    arg2361_2287 =
	       class_num_218___object(struct_ref_app_73_cfa_info2);
	    {	/* Cfa/cinfo2.scm 129 */
	       obj_t obj_3571;
	       obj_3571 =
		  (obj_t) (new2130_2286);
	       (((obj_t) CREF(obj_3571))->header = MAKE_HEADER(arg2361_2287, 0), BUNSPEC);
	    }
	 }
	 {	/* Cfa/cinfo2.scm 129 */
	    object_bglt aux_6766;
	    aux_6766 =
	       (object_bglt) (new2130_2286);
	    OBJECT_WIDENING_SET(aux_6766, BFALSE);
	 }
	 return new2130_2286;
      }
   }
}



/* _allocate-struct-ref-app */
obj_t 
_allocate_struct_ref_app_88_cfa_info2(obj_t env_5329)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 129 */
      {		/* Cfa/cinfo2.scm 129 */
	 app_bglt aux_6769;
	 aux_6769 =
	    allocate_struct_ref_app_224_cfa_info2();
	 return
	    (obj_t) (aux_6769);
      }
   }
}



/* struct-ref-app? */
bool_t 
struct_ref_app__100_cfa_info2(obj_t obj_37)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 129 */
      return
	 is_a__118___object(obj_37, struct_ref_app_73_cfa_info2);
   }
}



/* _struct-ref-app? */
obj_t 
_struct_ref_app__47_cfa_info2(obj_t env_5378, obj_t obj_5379)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 129 */
      {		/* Cfa/cinfo2.scm 129 */
	 bool_t aux_6773;
	 aux_6773 =
	    struct_ref_app__100_cfa_info2(obj_5379);
	 return
	    BBOOL(aux_6773);
      }
   }
}



/* widening-struct-ref-app */
struct_ref_app_73_bglt 
widening_struct_ref_app_158_cfa_info2(approx_bglt approx_38)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 129 */
      {		/* Cfa/cinfo2.scm 129 */
	 struct_ref_app_73_bglt new2125_3573;
	 new2125_3573 =
	    ((struct_ref_app_73_bglt) BREF(GC_MALLOC(sizeof(struct struct_ref_app_73))));
	 ((((struct_ref_app_73_bglt) CREF(new2125_3573))->approx) = ((approx_bglt) approx_38), BUNSPEC);
	 return new2125_3573;
      }
   }
}



/* _widening-struct-ref-app2871 */
obj_t 
_widening_struct_ref_app2871_224_cfa_info2(obj_t env_5380, obj_t approx_5381)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 129 */
      {		/* Cfa/cinfo2.scm 129 */
	 struct_ref_app_73_bglt aux_6778;
	 aux_6778 =
	    widening_struct_ref_app_158_cfa_info2(
	    (approx_bglt) (approx_5381));
	 return
	    (obj_t) (aux_6778);
      }
   }
}



/* make-struct-ref-app */
struct_ref_app_73_bglt 
make_struct_ref_app_97_cfa_info2(obj_t loc_39, type_bglt type_40, obj_t side_effect__165_41, obj_t key_42, var_bglt fun_43, obj_t args_44, obj_t stack_info_255_45, approx_bglt approx_46)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 129 */
      {		/* Cfa/cinfo2.scm 129 */
	 app_bglt aux2128_3575;
	 {	/* Cfa/cinfo2.scm 129 */
	    app_bglt res2809_3597;
	    {	/* ./Ast/node.scm 698 */
	       app_bglt new1248_3586;
	       new1248_3586 =
		  ((app_bglt) BREF(GC_MALLOC(sizeof(struct app))));
	       {	/* ./Ast/node.scm 698 */
		  long arg2541_3587;
		  arg2541_3587 =
		     class_num_218___object(app_ast_node);
		  {	/* ./Ast/node.scm 698 */
		     obj_t obj_3595;
		     obj_3595 =
			(obj_t) (new1248_3586);
		     (((obj_t) CREF(obj_3595))->header = MAKE_HEADER(arg2541_3587, 0), BUNSPEC);
		  }
	       }
	       {	/* ./Ast/node.scm 698 */
		  object_bglt aux_6786;
		  aux_6786 =
		     (object_bglt) (new1248_3586);
		  OBJECT_WIDENING_SET(aux_6786, BFALSE);
	       }
	       ((((app_bglt) CREF(new1248_3586))->loc) = ((obj_t) loc_39), BUNSPEC);
	       ((((app_bglt) CREF(new1248_3586))->type) = ((type_bglt) type_40), BUNSPEC);
	       ((((app_bglt) CREF(new1248_3586))->side_effect__165) = ((obj_t) side_effect__165_41), BUNSPEC);
	       ((((app_bglt) CREF(new1248_3586))->key) = ((obj_t) key_42), BUNSPEC);
	       ((((app_bglt) CREF(new1248_3586))->fun) = ((var_bglt) fun_43), BUNSPEC);
	       ((((app_bglt) CREF(new1248_3586))->args) = ((obj_t) args_44), BUNSPEC);
	       ((((app_bglt) CREF(new1248_3586))->stack_info_255) = ((obj_t) stack_info_255_45), BUNSPEC);
	       res2809_3597 = new1248_3586;
	    }
	    aux2128_3575 = res2809_3597;
	 }
	 {	/* Cfa/cinfo2.scm 129 */
	    struct_ref_app_73_bglt new2129_3576;
	    new2129_3576 =
	       ((struct_ref_app_73_bglt) (aux2128_3575));
	    {	/* Cfa/cinfo2.scm 129 */
	       long arg2362_3577;
	       arg2362_3577 =
		  class_num_218___object(struct_ref_app_73_cfa_info2);
	       {	/* Cfa/cinfo2.scm 129 */
		  obj_t obj_3598;
		  obj_3598 =
		     (obj_t) (new2129_3576);
		  (((obj_t) CREF(obj_3598))->header = MAKE_HEADER(arg2362_3577, 0), BUNSPEC);
	       }
	    }
	    {	/* Cfa/cinfo2.scm 129 */
	       struct_ref_app_73_bglt arg2363_3578;
	       {	/* Cfa/cinfo2.scm 129 */
		  struct_ref_app_73_bglt res2810_3603;
		  {	/* Cfa/cinfo2.scm 129 */
		     struct_ref_app_73_bglt new2125_3601;
		     new2125_3601 =
			((struct_ref_app_73_bglt) BREF(GC_MALLOC(sizeof(struct struct_ref_app_73))));
		     ((((struct_ref_app_73_bglt) CREF(new2125_3601))->approx) = ((approx_bglt) approx_46), BUNSPEC);
		     res2810_3603 = new2125_3601;
		  }
		  arg2363_3578 = res2810_3603;
	       }
	       {	/* Cfa/cinfo2.scm 129 */
		  obj_t aux_6804;
		  object_bglt aux_6802;
		  aux_6804 =
		     (obj_t) (arg2363_3578);
		  aux_6802 =
		     (object_bglt) (new2129_3576);
		  OBJECT_WIDENING_SET(aux_6802, aux_6804);
	       }
	    }
	    return new2129_3576;
	 }
      }
   }
}



/* _make-struct-ref-app */
obj_t 
_make_struct_ref_app_133_cfa_info2(obj_t env_5382, obj_t loc_5383, obj_t type_5384, obj_t side_effect__165_5385, obj_t key_5386, obj_t fun_5387, obj_t args_5388, obj_t stack_info_255_5389, obj_t approx_5390)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 129 */
      {		/* Cfa/cinfo2.scm 129 */
	 struct_ref_app_73_bglt aux_6807;
	 aux_6807 =
	    make_struct_ref_app_97_cfa_info2(loc_5383,
	    (type_bglt) (type_5384), side_effect__165_5385, key_5386,
	    (var_bglt) (fun_5387), args_5388, stack_info_255_5389,
	    (approx_bglt) (approx_5390));
	 return
	    (obj_t) (aux_6807);
      }
   }
}



/* struct-ref-app-loc */
obj_t 
struct_ref_app_loc_11_cfa_info2(app_bglt obj_47)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 661 */
      return
	 (((app_bglt) CREF(obj_47))->loc);
   }
}



/* _struct-ref-app-loc */
obj_t 
_struct_ref_app_loc_25_cfa_info2(obj_t env_5391, obj_t obj_5392)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 661 */
      return
	 struct_ref_app_loc_11_cfa_info2(
	 (app_bglt) (obj_5392));
   }
}



/* struct-ref-app-type-set! */
obj_t 
struct_ref_app_type_set__226_cfa_info2(app_bglt obj_48, type_bglt val2119_49)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 129 */
      return
	 ((((app_bglt) CREF(obj_48))->type) = ((type_bglt) val2119_49), BUNSPEC);
   }
}



/* _struct-ref-app-type-set! */
obj_t 
_struct_ref_app_type_set__133_cfa_info2(obj_t env_5393, obj_t obj_5394, obj_t val2119_5395)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 129 */
      return
	 struct_ref_app_type_set__226_cfa_info2(
	 (app_bglt) (obj_5394),
	 (type_bglt) (val2119_5395));
   }
}



/* struct-ref-app-type */
type_bglt 
struct_ref_app_type_202_cfa_info2(app_bglt obj_50)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 129 */
      return
	 (((app_bglt) CREF(obj_50))->type);
   }
}



/* _struct-ref-app-type */
obj_t 
_struct_ref_app_type_252_cfa_info2(obj_t env_5396, obj_t obj_5397)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 129 */
      {		/* Cfa/cinfo2.scm 129 */
	 type_bglt aux_6821;
	 aux_6821 =
	    struct_ref_app_type_202_cfa_info2(
	    (app_bglt) (obj_5397));
	 return
	    (obj_t) (aux_6821);
      }
   }
}



/* struct-ref-app-side-effect?-set! */
obj_t 
struct_ref_app_side_effect__set__108_cfa_info2(app_bglt obj_51, obj_t val2120_52)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 669 */
      return
	 ((((app_bglt) CREF(obj_51))->side_effect__165) = ((obj_t) val2120_52), BUNSPEC);
   }
}



/* _struct-ref-app-side-effect?-set! */
obj_t 
_struct_ref_app_side_effect__set__219_cfa_info2(obj_t env_5398, obj_t obj_5399, obj_t val2120_5400)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 669 */
      return
	 struct_ref_app_side_effect__set__108_cfa_info2(
	 (app_bglt) (obj_5399), val2120_5400);
   }
}



/* struct-ref-app-side-effect? */
obj_t 
struct_ref_app_side_effect__151_cfa_info2(app_bglt obj_53)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 669 */
      return
	 (((app_bglt) CREF(obj_53))->side_effect__165);
   }
}



/* _struct-ref-app-side-effect? */
obj_t 
_struct_ref_app_side_effect__158_cfa_info2(obj_t env_5401, obj_t obj_5402)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 669 */
      return
	 struct_ref_app_side_effect__151_cfa_info2(
	 (app_bglt) (obj_5402));
   }
}



/* struct-ref-app-key-set! */
obj_t 
struct_ref_app_key_set__1_cfa_info2(app_bglt obj_54, obj_t val2121_55)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 673 */
      return
	 ((((app_bglt) CREF(obj_54))->key) = ((obj_t) val2121_55), BUNSPEC);
   }
}



/* _struct-ref-app-key-set!2872 */
obj_t 
_struct_ref_app_key_set_2872_176_cfa_info2(obj_t env_5403, obj_t obj_5404, obj_t val2121_5405)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 673 */
      return
	 struct_ref_app_key_set__1_cfa_info2(
	 (app_bglt) (obj_5404), val2121_5405);
   }
}



/* struct-ref-app-key */
obj_t 
struct_ref_app_key_250_cfa_info2(app_bglt obj_56)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 673 */
      return
	 (((app_bglt) CREF(obj_56))->key);
   }
}



/* _struct-ref-app-key2873 */
obj_t 
_struct_ref_app_key2873_86_cfa_info2(obj_t env_5406, obj_t obj_5407)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 673 */
      return
	 struct_ref_app_key_250_cfa_info2(
	 (app_bglt) (obj_5407));
   }
}



/* struct-ref-app-fun-set! */
obj_t 
struct_ref_app_fun_set__15_cfa_info2(app_bglt obj_57, var_bglt val2122_58)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 129 */
      return
	 ((((app_bglt) CREF(obj_57))->fun) = ((var_bglt) val2122_58), BUNSPEC);
   }
}



/* _struct-ref-app-fun-set! */
obj_t 
_struct_ref_app_fun_set__28_cfa_info2(obj_t env_5408, obj_t obj_5409, obj_t val2122_5410)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 129 */
      return
	 struct_ref_app_fun_set__15_cfa_info2(
	 (app_bglt) (obj_5409),
	 (var_bglt) (val2122_5410));
   }
}



/* struct-ref-app-fun */
var_bglt 
struct_ref_app_fun_232_cfa_info2(app_bglt obj_59)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 129 */
      return
	 (((app_bglt) CREF(obj_59))->fun);
   }
}



/* _struct-ref-app-fun */
obj_t 
_struct_ref_app_fun_240_cfa_info2(obj_t env_5411, obj_t obj_5412)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 129 */
      {		/* Cfa/cinfo2.scm 129 */
	 var_bglt aux_6842;
	 aux_6842 =
	    struct_ref_app_fun_232_cfa_info2(
	    (app_bglt) (obj_5412));
	 return
	    (obj_t) (aux_6842);
      }
   }
}



/* struct-ref-app-args-set! */
obj_t 
struct_ref_app_args_set__33_cfa_info2(app_bglt obj_60, obj_t val2123_61)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 129 */
      return
	 ((((app_bglt) CREF(obj_60))->args) = ((obj_t) val2123_61), BUNSPEC);
   }
}



/* _struct-ref-app-args-set! */
obj_t 
_struct_ref_app_args_set__245_cfa_info2(obj_t env_5413, obj_t obj_5414, obj_t val2123_5415)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 129 */
      return
	 struct_ref_app_args_set__33_cfa_info2(
	 (app_bglt) (obj_5414), val2123_5415);
   }
}



/* struct-ref-app-args */
obj_t 
struct_ref_app_args_190_cfa_info2(app_bglt obj_62)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 129 */
      return
	 (((app_bglt) CREF(obj_62))->args);
   }
}



/* _struct-ref-app-args */
obj_t 
_struct_ref_app_args_14_cfa_info2(obj_t env_5416, obj_t obj_5417)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 129 */
      return
	 struct_ref_app_args_190_cfa_info2(
	 (app_bglt) (obj_5417));
   }
}



/* struct-ref-app-stack-info-set! */
obj_t 
struct_ref_app_stack_info_set__87_cfa_info2(app_bglt obj_63, obj_t val2124_64)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 704 */
      return
	 ((((app_bglt) CREF(obj_63))->stack_info_255) = ((obj_t) val2124_64), BUNSPEC);
   }
}



/* _struct-ref-app-stack-info-set! */
obj_t 
_struct_ref_app_stack_info_set__154_cfa_info2(obj_t env_5418, obj_t obj_5419, obj_t val2124_5420)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 704 */
      return
	 struct_ref_app_stack_info_set__87_cfa_info2(
	 (app_bglt) (obj_5419), val2124_5420);
   }
}



/* struct-ref-app-stack-info */
obj_t 
struct_ref_app_stack_info_73_cfa_info2(app_bglt obj_65)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 704 */
      return
	 (((app_bglt) CREF(obj_65))->stack_info_255);
   }
}



/* _struct-ref-app-stack-info */
obj_t 
_struct_ref_app_stack_info_96_cfa_info2(obj_t env_5421, obj_t obj_5422)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 704 */
      return
	 struct_ref_app_stack_info_73_cfa_info2(
	 (app_bglt) (obj_5422));
   }
}



/* struct-ref-app-approx */
approx_bglt 
struct_ref_app_approx_125_cfa_info2(struct_ref_app_73_bglt obj_66)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 129 */
      {
	 obj_t aux_6858;
	 {	/* Cfa/cinfo2.scm 129 */
	    object_bglt aux_6859;
	    aux_6859 =
	       (object_bglt) (obj_66);
	    aux_6858 =
	       OBJECT_WIDENING(aux_6859);
	 }
	 return
	    (((struct_ref_app_73_bglt) CREF(aux_6858))->approx);
      }
   }
}



/* _struct-ref-app-approx */
obj_t 
_struct_ref_app_approx_29_cfa_info2(obj_t env_5423, obj_t obj_5424)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 129 */
      {		/* Cfa/cinfo2.scm 129 */
	 approx_bglt aux_6863;
	 aux_6863 =
	    struct_ref_app_approx_125_cfa_info2(
	    (struct_ref_app_73_bglt) (obj_5424));
	 return
	    (obj_t) (aux_6863);
      }
   }
}



/* allocate-make-struct-app */
app_bglt 
allocate_make_struct_app_180_cfa_info2()
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 114 */
      {		/* Cfa/cinfo2.scm 114 */
	 app_bglt new2112_2294;
	 new2112_2294 =
	    ((app_bglt) BREF(GC_MALLOC(sizeof(struct app))));
	 {	/* Cfa/cinfo2.scm 114 */
	    long arg2364_2295;
	    arg2364_2295 =
	       class_num_218___object(make_struct_app_214_cfa_info2);
	    {	/* Cfa/cinfo2.scm 114 */
	       obj_t obj_3604;
	       obj_3604 =
		  (obj_t) (new2112_2294);
	       (((obj_t) CREF(obj_3604))->header = MAKE_HEADER(arg2364_2295, 0), BUNSPEC);
	    }
	 }
	 {	/* Cfa/cinfo2.scm 114 */
	    object_bglt aux_6871;
	    aux_6871 =
	       (object_bglt) (new2112_2294);
	    OBJECT_WIDENING_SET(aux_6871, BFALSE);
	 }
	 return new2112_2294;
      }
   }
}



/* _allocate-make-struct-app */
obj_t 
_allocate_make_struct_app_151_cfa_info2(obj_t env_5328)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 114 */
      {		/* Cfa/cinfo2.scm 114 */
	 app_bglt aux_6874;
	 aux_6874 =
	    allocate_make_struct_app_180_cfa_info2();
	 return
	    (obj_t) (aux_6874);
      }
   }
}



/* make-struct-app? */
bool_t 
make_struct_app__23_cfa_info2(obj_t obj_70)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 114 */
      return
	 is_a__118___object(obj_70, make_struct_app_214_cfa_info2);
   }
}



/* _make-struct-app? */
obj_t 
_make_struct_app__44_cfa_info2(obj_t env_5425, obj_t obj_5426)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 114 */
      {		/* Cfa/cinfo2.scm 114 */
	 bool_t aux_6878;
	 aux_6878 =
	    make_struct_app__23_cfa_info2(obj_5426);
	 return
	    BBOOL(aux_6878);
      }
   }
}



/* widening-make-struct-app */
make_struct_app_214_bglt 
widening_make_struct_app_51_cfa_info2(approx_bglt approx_71, approx_bglt value_approx_19_72, long lost_stamp_114_73, variable_bglt owner_74, bool_t stackable__42_75, obj_t stack_stamp_31_76)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 114 */
      {		/* Cfa/cinfo2.scm 114 */
	 make_struct_app_214_bglt new2102_3606;
	 new2102_3606 =
	    ((make_struct_app_214_bglt) BREF(GC_MALLOC(sizeof(struct make_struct_app_214))));
	 ((((make_struct_app_214_bglt) CREF(new2102_3606))->approx) = ((approx_bglt) approx_71), BUNSPEC);
	 ((((make_struct_app_214_bglt) CREF(new2102_3606))->value_approx_19) = ((approx_bglt) value_approx_19_72), BUNSPEC);
	 ((((make_struct_app_214_bglt) CREF(new2102_3606))->lost_stamp_114) = ((long) lost_stamp_114_73), BUNSPEC);
	 ((((make_struct_app_214_bglt) CREF(new2102_3606))->owner) = ((variable_bglt) owner_74), BUNSPEC);
	 ((((make_struct_app_214_bglt) CREF(new2102_3606))->stackable__42) = ((bool_t) stackable__42_75), BUNSPEC);
	 ((((make_struct_app_214_bglt) CREF(new2102_3606))->stack_stamp_31) = ((obj_t) stack_stamp_31_76), BUNSPEC);
	 return new2102_3606;
      }
   }
}



/* _widening-make-struct-app2874 */
obj_t 
_widening_make_struct_app2874_8_cfa_info2(obj_t env_5427, obj_t approx_5428, obj_t value_approx_19_5429, obj_t lost_stamp_114_5430, obj_t owner_5431, obj_t stackable__42_5432, obj_t stack_stamp_31_5433)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 114 */
      {		/* Cfa/cinfo2.scm 114 */
	 make_struct_app_214_bglt aux_6888;
	 aux_6888 =
	    widening_make_struct_app_51_cfa_info2(
	    (approx_bglt) (approx_5428),
	    (approx_bglt) (value_approx_19_5429),
	    (long) CINT(lost_stamp_114_5430),
	    (variable_bglt) (owner_5431),
	    CBOOL(stackable__42_5432), stack_stamp_31_5433);
	 return
	    (obj_t) (aux_6888);
      }
   }
}



/* make-make-struct-app */
make_struct_app_214_bglt 
make_make_struct_app_186_cfa_info2(obj_t loc_77, type_bglt type_78, obj_t side_effect__165_79, obj_t key_80, var_bglt fun_81, obj_t args_82, obj_t stack_info_255_83, approx_bglt approx_84, approx_bglt value_approx_19_85, long lost_stamp_114_86, variable_bglt owner_87, bool_t stackable__42_88, obj_t stack_stamp_31_89)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 114 */
      {		/* Cfa/cinfo2.scm 114 */
	 app_bglt aux2110_3613;
	 {	/* Cfa/cinfo2.scm 114 */
	    app_bglt res2811_3635;
	    {	/* ./Ast/node.scm 698 */
	       app_bglt new1248_3624;
	       new1248_3624 =
		  ((app_bglt) BREF(GC_MALLOC(sizeof(struct app))));
	       {	/* ./Ast/node.scm 698 */
		  long arg2541_3625;
		  arg2541_3625 =
		     class_num_218___object(app_ast_node);
		  {	/* ./Ast/node.scm 698 */
		     obj_t obj_3633;
		     obj_3633 =
			(obj_t) (new1248_3624);
		     (((obj_t) CREF(obj_3633))->header = MAKE_HEADER(arg2541_3625, 0), BUNSPEC);
		  }
	       }
	       {	/* ./Ast/node.scm 698 */
		  object_bglt aux_6900;
		  aux_6900 =
		     (object_bglt) (new1248_3624);
		  OBJECT_WIDENING_SET(aux_6900, BFALSE);
	       }
	       ((((app_bglt) CREF(new1248_3624))->loc) = ((obj_t) loc_77), BUNSPEC);
	       ((((app_bglt) CREF(new1248_3624))->type) = ((type_bglt) type_78), BUNSPEC);
	       ((((app_bglt) CREF(new1248_3624))->side_effect__165) = ((obj_t) side_effect__165_79), BUNSPEC);
	       ((((app_bglt) CREF(new1248_3624))->key) = ((obj_t) key_80), BUNSPEC);
	       ((((app_bglt) CREF(new1248_3624))->fun) = ((var_bglt) fun_81), BUNSPEC);
	       ((((app_bglt) CREF(new1248_3624))->args) = ((obj_t) args_82), BUNSPEC);
	       ((((app_bglt) CREF(new1248_3624))->stack_info_255) = ((obj_t) stack_info_255_83), BUNSPEC);
	       res2811_3635 = new1248_3624;
	    }
	    aux2110_3613 = res2811_3635;
	 }
	 {	/* Cfa/cinfo2.scm 114 */
	    make_struct_app_214_bglt new2111_3614;
	    new2111_3614 =
	       ((make_struct_app_214_bglt) (aux2110_3613));
	    {	/* Cfa/cinfo2.scm 114 */
	       long arg2365_3615;
	       arg2365_3615 =
		  class_num_218___object(make_struct_app_214_cfa_info2);
	       {	/* Cfa/cinfo2.scm 114 */
		  obj_t obj_3636;
		  obj_3636 =
		     (obj_t) (new2111_3614);
		  (((obj_t) CREF(obj_3636))->header = MAKE_HEADER(arg2365_3615, 0), BUNSPEC);
	       }
	    }
	    {	/* Cfa/cinfo2.scm 114 */
	       make_struct_app_214_bglt arg2366_3616;
	       {	/* Cfa/cinfo2.scm 114 */
		  make_struct_app_214_bglt res2812_3651;
		  {	/* Cfa/cinfo2.scm 114 */
		     make_struct_app_214_bglt new2102_3644;
		     new2102_3644 =
			((make_struct_app_214_bglt) BREF(GC_MALLOC(sizeof(struct make_struct_app_214))));
		     ((((make_struct_app_214_bglt) CREF(new2102_3644))->approx) = ((approx_bglt) approx_84), BUNSPEC);
		     ((((make_struct_app_214_bglt) CREF(new2102_3644))->value_approx_19) = ((approx_bglt) value_approx_19_85), BUNSPEC);
		     ((((make_struct_app_214_bglt) CREF(new2102_3644))->lost_stamp_114) = ((long) lost_stamp_114_86), BUNSPEC);
		     ((((make_struct_app_214_bglt) CREF(new2102_3644))->owner) = ((variable_bglt) owner_87), BUNSPEC);
		     ((((make_struct_app_214_bglt) CREF(new2102_3644))->stackable__42) = ((bool_t) stackable__42_88), BUNSPEC);
		     ((((make_struct_app_214_bglt) CREF(new2102_3644))->stack_stamp_31) = ((obj_t) stack_stamp_31_89), BUNSPEC);
		     res2812_3651 = new2102_3644;
		  }
		  arg2366_3616 = res2812_3651;
	       }
	       {	/* Cfa/cinfo2.scm 114 */
		  obj_t aux_6923;
		  object_bglt aux_6921;
		  aux_6923 =
		     (obj_t) (arg2366_3616);
		  aux_6921 =
		     (object_bglt) (new2111_3614);
		  OBJECT_WIDENING_SET(aux_6921, aux_6923);
	       }
	    }
	    return new2111_3614;
	 }
      }
   }
}



/* _make-make-struct-app */
obj_t 
_make_make_struct_app_137_cfa_info2(obj_t env_5434, obj_t loc_5435, obj_t type_5436, obj_t side_effect__165_5437, obj_t key_5438, obj_t fun_5439, obj_t args_5440, obj_t stack_info_255_5441, obj_t approx_5442, obj_t value_approx_19_5443, obj_t lost_stamp_114_5444, obj_t owner_5445, obj_t stackable__42_5446, obj_t stack_stamp_31_5447)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 114 */
      {		/* Cfa/cinfo2.scm 114 */
	 make_struct_app_214_bglt aux_6926;
	 aux_6926 =
	    make_make_struct_app_186_cfa_info2(loc_5435,
	    (type_bglt) (type_5436), side_effect__165_5437, key_5438,
	    (var_bglt) (fun_5439), args_5440, stack_info_255_5441,
	    (approx_bglt) (approx_5442),
	    (approx_bglt) (value_approx_19_5443),
	    (long) CINT(lost_stamp_114_5444),
	    (variable_bglt) (owner_5445),
	    CBOOL(stackable__42_5446), stack_stamp_31_5447);
	 return
	    (obj_t) (aux_6926);
      }
   }
}



/* make-struct-app-loc */
obj_t 
make_struct_app_loc_176_cfa_info2(app_bglt obj_90)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 661 */
      return
	 (((app_bglt) CREF(obj_90))->loc);
   }
}



/* _make-struct-app-loc */
obj_t 
_make_struct_app_loc_141_cfa_info2(obj_t env_5448, obj_t obj_5449)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 661 */
      return
	 make_struct_app_loc_176_cfa_info2(
	 (app_bglt) (obj_5449));
   }
}



/* make-struct-app-type-set! */
obj_t 
make_struct_app_type_set__65_cfa_info2(app_bglt obj_91, type_bglt val2092_92)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 114 */
      return
	 ((((app_bglt) CREF(obj_91))->type) = ((type_bglt) val2092_92), BUNSPEC);
   }
}



/* _make-struct-app-type-set! */
obj_t 
_make_struct_app_type_set__135_cfa_info2(obj_t env_5450, obj_t obj_5451, obj_t val2092_5452)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 114 */
      return
	 make_struct_app_type_set__65_cfa_info2(
	 (app_bglt) (obj_5451),
	 (type_bglt) (val2092_5452));
   }
}



/* make-struct-app-type */
type_bglt 
make_struct_app_type_23_cfa_info2(app_bglt obj_93)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 114 */
      return
	 (((app_bglt) CREF(obj_93))->type);
   }
}



/* _make-struct-app-type */
obj_t 
_make_struct_app_type_134_cfa_info2(obj_t env_5453, obj_t obj_5454)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 114 */
      {		/* Cfa/cinfo2.scm 114 */
	 type_bglt aux_6944;
	 aux_6944 =
	    make_struct_app_type_23_cfa_info2(
	    (app_bglt) (obj_5454));
	 return
	    (obj_t) (aux_6944);
      }
   }
}



/* make-struct-app-side-effect?-set! */
obj_t 
make_struct_app_side_effect__set__36_cfa_info2(app_bglt obj_94, obj_t val2093_95)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 669 */
      return
	 ((((app_bglt) CREF(obj_94))->side_effect__165) = ((obj_t) val2093_95), BUNSPEC);
   }
}



/* _make-struct-app-side-effect?-set! */
obj_t 
_make_struct_app_side_effect__set__28_cfa_info2(obj_t env_5455, obj_t obj_5456, obj_t val2093_5457)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 669 */
      return
	 make_struct_app_side_effect__set__36_cfa_info2(
	 (app_bglt) (obj_5456), val2093_5457);
   }
}



/* make-struct-app-side-effect? */
obj_t 
make_struct_app_side_effect__63_cfa_info2(app_bglt obj_96)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 669 */
      return
	 (((app_bglt) CREF(obj_96))->side_effect__165);
   }
}



/* _make-struct-app-side-effect? */
obj_t 
_make_struct_app_side_effect__240_cfa_info2(obj_t env_5458, obj_t obj_5459)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 669 */
      return
	 make_struct_app_side_effect__63_cfa_info2(
	 (app_bglt) (obj_5459));
   }
}



/* make-struct-app-key-set! */
obj_t 
make_struct_app_key_set__110_cfa_info2(app_bglt obj_97, obj_t val2094_98)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 673 */
      return
	 ((((app_bglt) CREF(obj_97))->key) = ((obj_t) val2094_98), BUNSPEC);
   }
}



/* _make-struct-app-key-set!2875 */
obj_t 
_make_struct_app_key_set_2875_235_cfa_info2(obj_t env_5460, obj_t obj_5461, obj_t val2094_5462)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 673 */
      return
	 make_struct_app_key_set__110_cfa_info2(
	 (app_bglt) (obj_5461), val2094_5462);
   }
}



/* make-struct-app-key */
obj_t 
make_struct_app_key_199_cfa_info2(app_bglt obj_99)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 673 */
      return
	 (((app_bglt) CREF(obj_99))->key);
   }
}



/* _make-struct-app-key */
obj_t 
_make_struct_app_key_133_cfa_info2(obj_t env_5463, obj_t obj_5464)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 673 */
      return
	 make_struct_app_key_199_cfa_info2(
	 (app_bglt) (obj_5464));
   }
}



/* make-struct-app-fun-set! */
obj_t 
make_struct_app_fun_set__249_cfa_info2(app_bglt obj_100, var_bglt val2095_101)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 114 */
      return
	 ((((app_bglt) CREF(obj_100))->fun) = ((var_bglt) val2095_101), BUNSPEC);
   }
}



/* _make-struct-app-fun-set! */
obj_t 
_make_struct_app_fun_set__143_cfa_info2(obj_t env_5465, obj_t obj_5466, obj_t val2095_5467)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 114 */
      return
	 make_struct_app_fun_set__249_cfa_info2(
	 (app_bglt) (obj_5466),
	 (var_bglt) (val2095_5467));
   }
}



/* make-struct-app-fun */
var_bglt 
make_struct_app_fun_76_cfa_info2(app_bglt obj_102)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 114 */
      return
	 (((app_bglt) CREF(obj_102))->fun);
   }
}



/* _make-struct-app-fun */
obj_t 
_make_struct_app_fun_42_cfa_info2(obj_t env_5468, obj_t obj_5469)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 114 */
      {		/* Cfa/cinfo2.scm 114 */
	 var_bglt aux_6965;
	 aux_6965 =
	    make_struct_app_fun_76_cfa_info2(
	    (app_bglt) (obj_5469));
	 return
	    (obj_t) (aux_6965);
      }
   }
}



/* make-struct-app-args-set! */
obj_t 
make_struct_app_args_set__242_cfa_info2(app_bglt obj_103, obj_t val2096_104)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 114 */
      return
	 ((((app_bglt) CREF(obj_103))->args) = ((obj_t) val2096_104), BUNSPEC);
   }
}



/* _make-struct-app-args-set! */
obj_t 
_make_struct_app_args_set__31_cfa_info2(obj_t env_5470, obj_t obj_5471, obj_t val2096_5472)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 114 */
      return
	 make_struct_app_args_set__242_cfa_info2(
	 (app_bglt) (obj_5471), val2096_5472);
   }
}



/* make-struct-app-args */
obj_t 
make_struct_app_args_183_cfa_info2(app_bglt obj_105)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 114 */
      return
	 (((app_bglt) CREF(obj_105))->args);
   }
}



/* _make-struct-app-args */
obj_t 
_make_struct_app_args_135_cfa_info2(obj_t env_5473, obj_t obj_5474)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 114 */
      return
	 make_struct_app_args_183_cfa_info2(
	 (app_bglt) (obj_5474));
   }
}



/* make-struct-app-stack-info-set! */
obj_t 
make_struct_app_stack_info_set__189_cfa_info2(app_bglt obj_106, obj_t val2097_107)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 704 */
      return
	 ((((app_bglt) CREF(obj_106))->stack_info_255) = ((obj_t) val2097_107), BUNSPEC);
   }
}



/* _make-struct-app-stack-info-set! */
obj_t 
_make_struct_app_stack_info_set__53_cfa_info2(obj_t env_5475, obj_t obj_5476, obj_t val2097_5477)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 704 */
      return
	 make_struct_app_stack_info_set__189_cfa_info2(
	 (app_bglt) (obj_5476), val2097_5477);
   }
}



/* make-struct-app-stack-info */
obj_t 
make_struct_app_stack_info_206_cfa_info2(app_bglt obj_108)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 704 */
      return
	 (((app_bglt) CREF(obj_108))->stack_info_255);
   }
}



/* _make-struct-app-stack-info */
obj_t 
_make_struct_app_stack_info_146_cfa_info2(obj_t env_5478, obj_t obj_5479)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 704 */
      return
	 make_struct_app_stack_info_206_cfa_info2(
	 (app_bglt) (obj_5479));
   }
}



/* make-struct-app-approx-set! */
obj_t 
make_struct_app_approx_set__191_cfa_info2(make_struct_app_214_bglt obj_109, approx_bglt val2098_110)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 114 */
      {
	 obj_t aux_6981;
	 {	/* Cfa/cinfo2.scm 114 */
	    object_bglt aux_6982;
	    aux_6982 =
	       (object_bglt) (obj_109);
	    aux_6981 =
	       OBJECT_WIDENING(aux_6982);
	 }
	 return
	    ((((make_struct_app_214_bglt) CREF(aux_6981))->approx) = ((approx_bglt) val2098_110), BUNSPEC);
      }
   }
}



/* _make-struct-app-approx-set! */
obj_t 
_make_struct_app_approx_set__178_cfa_info2(obj_t env_5480, obj_t obj_5481, obj_t val2098_5482)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 114 */
      return
	 make_struct_app_approx_set__191_cfa_info2(
	 (make_struct_app_214_bglt) (obj_5481),
	 (approx_bglt) (val2098_5482));
   }
}



/* make-struct-app-approx */
approx_bglt 
make_struct_app_approx_49_cfa_info2(make_struct_app_214_bglt obj_111)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 114 */
      {
	 obj_t aux_6989;
	 {	/* Cfa/cinfo2.scm 114 */
	    object_bglt aux_6990;
	    aux_6990 =
	       (object_bglt) (obj_111);
	    aux_6989 =
	       OBJECT_WIDENING(aux_6990);
	 }
	 return
	    (((make_struct_app_214_bglt) CREF(aux_6989))->approx);
      }
   }
}



/* _make-struct-app-approx */
obj_t 
_make_struct_app_approx_7_cfa_info2(obj_t env_5483, obj_t obj_5484)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 114 */
      {		/* Cfa/cinfo2.scm 114 */
	 approx_bglt aux_6994;
	 aux_6994 =
	    make_struct_app_approx_49_cfa_info2(
	    (make_struct_app_214_bglt) (obj_5484));
	 return
	    (obj_t) (aux_6994);
      }
   }
}



/* make-struct-app-value-approx */
approx_bglt 
make_struct_app_value_approx_246_cfa_info2(make_struct_app_214_bglt obj_112)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 118 */
      {
	 obj_t aux_6998;
	 {	/* Cfa/cinfo2.scm 118 */
	    object_bglt aux_6999;
	    aux_6999 =
	       (object_bglt) (obj_112);
	    aux_6998 =
	       OBJECT_WIDENING(aux_6999);
	 }
	 return
	    (((make_struct_app_214_bglt) CREF(aux_6998))->value_approx_19);
      }
   }
}



/* _make-struct-app-value-approx */
obj_t 
_make_struct_app_value_approx_167_cfa_info2(obj_t env_5485, obj_t obj_5486)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 118 */
      {		/* Cfa/cinfo2.scm 118 */
	 approx_bglt aux_7003;
	 aux_7003 =
	    make_struct_app_value_approx_246_cfa_info2(
	    (make_struct_app_214_bglt) (obj_5486));
	 return
	    (obj_t) (aux_7003);
      }
   }
}



/* make-struct-app-lost-stamp-set! */
obj_t 
make_struct_app_lost_stamp_set__51_cfa_info2(make_struct_app_214_bglt obj_113, long val2099_114)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 120 */
      {
	 obj_t aux_7007;
	 {	/* Cfa/cinfo2.scm 120 */
	    object_bglt aux_7008;
	    aux_7008 =
	       (object_bglt) (obj_113);
	    aux_7007 =
	       OBJECT_WIDENING(aux_7008);
	 }
	 return
	    ((((make_struct_app_214_bglt) CREF(aux_7007))->lost_stamp_114) = ((long) val2099_114), BUNSPEC);
      }
   }
}



/* _make-struct-app-lost-stamp-set! */
obj_t 
_make_struct_app_lost_stamp_set__243_cfa_info2(obj_t env_5487, obj_t obj_5488, obj_t val2099_5489)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 120 */
      return
	 make_struct_app_lost_stamp_set__51_cfa_info2(
	 (make_struct_app_214_bglt) (obj_5488),
	 (long) CINT(val2099_5489));
   }
}



/* make-struct-app-lost-stamp */
long 
make_struct_app_lost_stamp_13_cfa_info2(make_struct_app_214_bglt obj_115)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 120 */
      {
	 obj_t aux_7015;
	 {	/* Cfa/cinfo2.scm 120 */
	    object_bglt aux_7016;
	    aux_7016 =
	       (object_bglt) (obj_115);
	    aux_7015 =
	       OBJECT_WIDENING(aux_7016);
	 }
	 return
	    (((make_struct_app_214_bglt) CREF(aux_7015))->lost_stamp_114);
      }
   }
}



/* _make-struct-app-lost-stamp */
obj_t 
_make_struct_app_lost_stamp_65_cfa_info2(obj_t env_5490, obj_t obj_5491)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 120 */
      {		/* Cfa/cinfo2.scm 120 */
	 long aux_7020;
	 aux_7020 =
	    make_struct_app_lost_stamp_13_cfa_info2(
	    (make_struct_app_214_bglt) (obj_5491));
	 return
	    BINT(aux_7020);
      }
   }
}



/* make-struct-app-owner */
variable_bglt 
make_struct_app_owner_33_cfa_info2(make_struct_app_214_bglt obj_116)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 122 */
      {
	 obj_t aux_7024;
	 {	/* Cfa/cinfo2.scm 122 */
	    object_bglt aux_7025;
	    aux_7025 =
	       (object_bglt) (obj_116);
	    aux_7024 =
	       OBJECT_WIDENING(aux_7025);
	 }
	 return
	    (((make_struct_app_214_bglt) CREF(aux_7024))->owner);
      }
   }
}



/* _make-struct-app-owner */
obj_t 
_make_struct_app_owner_239_cfa_info2(obj_t env_5492, obj_t obj_5493)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 122 */
      {		/* Cfa/cinfo2.scm 122 */
	 variable_bglt aux_7029;
	 aux_7029 =
	    make_struct_app_owner_33_cfa_info2(
	    (make_struct_app_214_bglt) (obj_5493));
	 return
	    (obj_t) (aux_7029);
      }
   }
}



/* make-struct-app-stackable?-set! */
obj_t 
make_struct_app_stackable__set__115_cfa_info2(make_struct_app_214_bglt obj_117, bool_t val2100_118)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 125 */
      {
	 obj_t aux_7033;
	 {	/* Cfa/cinfo2.scm 125 */
	    object_bglt aux_7034;
	    aux_7034 =
	       (object_bglt) (obj_117);
	    aux_7033 =
	       OBJECT_WIDENING(aux_7034);
	 }
	 return
	    ((((make_struct_app_214_bglt) CREF(aux_7033))->stackable__42) = ((bool_t) val2100_118), BUNSPEC);
      }
   }
}



/* _make-struct-app-stackable?-set! */
obj_t 
_make_struct_app_stackable__set__138_cfa_info2(obj_t env_5494, obj_t obj_5495, obj_t val2100_5496)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 125 */
      return
	 make_struct_app_stackable__set__115_cfa_info2(
	 (make_struct_app_214_bglt) (obj_5495),
	 CBOOL(val2100_5496));
   }
}



/* make-struct-app-stackable? */
bool_t 
make_struct_app_stackable__22_cfa_info2(make_struct_app_214_bglt obj_119)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 125 */
      {
	 obj_t aux_7041;
	 {	/* Cfa/cinfo2.scm 125 */
	    object_bglt aux_7042;
	    aux_7042 =
	       (object_bglt) (obj_119);
	    aux_7041 =
	       OBJECT_WIDENING(aux_7042);
	 }
	 return
	    (((make_struct_app_214_bglt) CREF(aux_7041))->stackable__42);
      }
   }
}



/* _make-struct-app-stackable? */
obj_t 
_make_struct_app_stackable__6_cfa_info2(obj_t env_5497, obj_t obj_5498)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 125 */
      {		/* Cfa/cinfo2.scm 125 */
	 bool_t aux_7046;
	 aux_7046 =
	    make_struct_app_stackable__22_cfa_info2(
	    (make_struct_app_214_bglt) (obj_5498));
	 return
	    BBOOL(aux_7046);
      }
   }
}



/* make-struct-app-stack-stamp-set! */
obj_t 
make_struct_app_stack_stamp_set__112_cfa_info2(make_struct_app_214_bglt obj_120, obj_t val2101_121)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 127 */
      {
	 obj_t aux_7050;
	 {	/* Cfa/cinfo2.scm 127 */
	    object_bglt aux_7051;
	    aux_7051 =
	       (object_bglt) (obj_120);
	    aux_7050 =
	       OBJECT_WIDENING(aux_7051);
	 }
	 return
	    ((((make_struct_app_214_bglt) CREF(aux_7050))->stack_stamp_31) = ((obj_t) val2101_121), BUNSPEC);
      }
   }
}



/* _make-struct-app-stack-stamp-set! */
obj_t 
_make_struct_app_stack_stamp_set__239_cfa_info2(obj_t env_5499, obj_t obj_5500, obj_t val2101_5501)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 127 */
      return
	 make_struct_app_stack_stamp_set__112_cfa_info2(
	 (make_struct_app_214_bglt) (obj_5500), val2101_5501);
   }
}



/* make-struct-app-stack-stamp */
obj_t 
make_struct_app_stack_stamp_197_cfa_info2(make_struct_app_214_bglt obj_122)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 127 */
      {
	 obj_t aux_7057;
	 {	/* Cfa/cinfo2.scm 127 */
	    object_bglt aux_7058;
	    aux_7058 =
	       (object_bglt) (obj_122);
	    aux_7057 =
	       OBJECT_WIDENING(aux_7058);
	 }
	 return
	    (((make_struct_app_214_bglt) CREF(aux_7057))->stack_stamp_31);
      }
   }
}



/* _make-struct-app-stack-stamp */
obj_t 
_make_struct_app_stack_stamp_168_cfa_info2(obj_t env_5502, obj_t obj_5503)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 127 */
      return
	 make_struct_app_stack_stamp_197_cfa_info2(
	 (make_struct_app_214_bglt) (obj_5503));
   }
}



/* allocate-pre-struct-set!-app */
app_bglt 
allocate_pre_struct_set__app_186_cfa_info2()
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 112 */
      {		/* Cfa/cinfo2.scm 112 */
	 app_bglt new2085_2307;
	 new2085_2307 =
	    ((app_bglt) BREF(GC_MALLOC(sizeof(struct app))));
	 {	/* Cfa/cinfo2.scm 112 */
	    long arg2367_2308;
	    arg2367_2308 =
	       class_num_218___object(pre_struct_set__app_116_cfa_info2);
	    {	/* Cfa/cinfo2.scm 112 */
	       obj_t obj_3652;
	       obj_3652 =
		  (obj_t) (new2085_2307);
	       (((obj_t) CREF(obj_3652))->header = MAKE_HEADER(arg2367_2308, 0), BUNSPEC);
	    }
	 }
	 {	/* Cfa/cinfo2.scm 112 */
	    object_bglt aux_7068;
	    aux_7068 =
	       (object_bglt) (new2085_2307);
	    OBJECT_WIDENING_SET(aux_7068, BFALSE);
	 }
	 return new2085_2307;
      }
   }
}



/* _allocate-pre-struct-set!-app */
obj_t 
_allocate_pre_struct_set__app_93_cfa_info2(obj_t env_5327)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 112 */
      {		/* Cfa/cinfo2.scm 112 */
	 app_bglt aux_7071;
	 aux_7071 =
	    allocate_pre_struct_set__app_186_cfa_info2();
	 return
	    (obj_t) (aux_7071);
      }
   }
}



/* pre-struct-set!-app? */
bool_t 
pre_struct_set__app__46_cfa_info2(obj_t obj_126)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 112 */
      return
	 is_a__118___object(obj_126, pre_struct_set__app_116_cfa_info2);
   }
}



/* _pre-struct-set!-app? */
obj_t 
_pre_struct_set__app__221_cfa_info2(obj_t env_5504, obj_t obj_5505)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 112 */
      {		/* Cfa/cinfo2.scm 112 */
	 bool_t aux_7075;
	 aux_7075 =
	    pre_struct_set__app__46_cfa_info2(obj_5505);
	 return
	    BBOOL(aux_7075);
      }
   }
}



/* widening-pre-struct-set!-app */
pre_struct_set__app_116_bglt 
widening_pre_struct_set__app_140_cfa_info2()
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 112 */
      {		/* Cfa/cinfo2.scm 112 */

	 return
	    ((pre_struct_set__app_116_bglt) BREF(GC_MALLOC(sizeof(struct pre_struct_set__app_116))));
      }
   }
}



/* _widening-pre-struct-set!-app */
obj_t 
_widening_pre_struct_set__app_119_cfa_info2(obj_t env_5506)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 112 */
      {		/* Cfa/cinfo2.scm 112 */
	 pre_struct_set__app_116_bglt aux_7079;
	 aux_7079 =
	    widening_pre_struct_set__app_140_cfa_info2();
	 return
	    (obj_t) (aux_7079);
      }
   }
}



/* make-pre-struct-set!-app */
pre_struct_set__app_116_bglt 
make_pre_struct_set__app_188_cfa_info2(obj_t loc_127, type_bglt type_128, obj_t side_effect__165_129, obj_t key_130, var_bglt fun_131, obj_t args_132, obj_t stack_info_255_133)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 112 */
      {		/* Cfa/cinfo2.scm 112 */
	 app_bglt aux2083_3655;
	 {	/* Cfa/cinfo2.scm 112 */
	    app_bglt res2813_3677;
	    {	/* ./Ast/node.scm 698 */
	       app_bglt new1248_3666;
	       new1248_3666 =
		  ((app_bglt) BREF(GC_MALLOC(sizeof(struct app))));
	       {	/* ./Ast/node.scm 698 */
		  long arg2541_3667;
		  arg2541_3667 =
		     class_num_218___object(app_ast_node);
		  {	/* ./Ast/node.scm 698 */
		     obj_t obj_3675;
		     obj_3675 =
			(obj_t) (new1248_3666);
		     (((obj_t) CREF(obj_3675))->header = MAKE_HEADER(arg2541_3667, 0), BUNSPEC);
		  }
	       }
	       {	/* ./Ast/node.scm 698 */
		  object_bglt aux_7086;
		  aux_7086 =
		     (object_bglt) (new1248_3666);
		  OBJECT_WIDENING_SET(aux_7086, BFALSE);
	       }
	       ((((app_bglt) CREF(new1248_3666))->loc) = ((obj_t) loc_127), BUNSPEC);
	       ((((app_bglt) CREF(new1248_3666))->type) = ((type_bglt) type_128), BUNSPEC);
	       ((((app_bglt) CREF(new1248_3666))->side_effect__165) = ((obj_t) side_effect__165_129), BUNSPEC);
	       ((((app_bglt) CREF(new1248_3666))->key) = ((obj_t) key_130), BUNSPEC);
	       ((((app_bglt) CREF(new1248_3666))->fun) = ((var_bglt) fun_131), BUNSPEC);
	       ((((app_bglt) CREF(new1248_3666))->args) = ((obj_t) args_132), BUNSPEC);
	       ((((app_bglt) CREF(new1248_3666))->stack_info_255) = ((obj_t) stack_info_255_133), BUNSPEC);
	       res2813_3677 = new1248_3666;
	    }
	    aux2083_3655 = res2813_3677;
	 }
	 {	/* Cfa/cinfo2.scm 112 */
	    pre_struct_set__app_116_bglt new2084_3656;
	    new2084_3656 =
	       ((pre_struct_set__app_116_bglt) (aux2083_3655));
	    {	/* Cfa/cinfo2.scm 112 */
	       long arg2368_3657;
	       arg2368_3657 =
		  class_num_218___object(pre_struct_set__app_116_cfa_info2);
	       {	/* Cfa/cinfo2.scm 112 */
		  obj_t obj_3678;
		  obj_3678 =
		     (obj_t) (new2084_3656);
		  (((obj_t) CREF(obj_3678))->header = MAKE_HEADER(arg2368_3657, 0), BUNSPEC);
	       }
	    }
	    {	/* Cfa/cinfo2.scm 112 */
	       obj_t aux_7102;
	       object_bglt aux_7100;
	       {	/* Cfa/cinfo2.scm 112 */
		  pre_struct_set__app_116_bglt aux_7103;
		  {	/* Cfa/cinfo2.scm 112 */

		     aux_7103 =
			((pre_struct_set__app_116_bglt) BREF(GC_MALLOC(sizeof(struct pre_struct_set__app_116))));
		  }
		  aux_7102 =
		     (obj_t) (aux_7103);
	       }
	       aux_7100 =
		  (object_bglt) (new2084_3656);
	       OBJECT_WIDENING_SET(aux_7100, aux_7102);
	    }
	    return new2084_3656;
	 }
      }
   }
}



/* _make-pre-struct-set!-app */
obj_t 
_make_pre_struct_set__app_92_cfa_info2(obj_t env_5507, obj_t loc_5508, obj_t type_5509, obj_t side_effect__165_5510, obj_t key_5511, obj_t fun_5512, obj_t args_5513, obj_t stack_info_255_5514)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 112 */
      {		/* Cfa/cinfo2.scm 112 */
	 pre_struct_set__app_116_bglt aux_7107;
	 aux_7107 =
	    make_pre_struct_set__app_188_cfa_info2(loc_5508,
	    (type_bglt) (type_5509), side_effect__165_5510, key_5511,
	    (var_bglt) (fun_5512), args_5513, stack_info_255_5514);
	 return
	    (obj_t) (aux_7107);
      }
   }
}



/* pre-struct-set!-app-loc */
obj_t 
pre_struct_set__app_loc_71_cfa_info2(app_bglt obj_134)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 661 */
      return
	 (((app_bglt) CREF(obj_134))->loc);
   }
}



/* _pre-struct-set!-app-loc */
obj_t 
_pre_struct_set__app_loc_160_cfa_info2(obj_t env_5515, obj_t obj_5516)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 661 */
      return
	 pre_struct_set__app_loc_71_cfa_info2(
	 (app_bglt) (obj_5516));
   }
}



/* pre-struct-set!-app-type-set! */
obj_t 
pre_struct_set__app_type_set__207_cfa_info2(app_bglt obj_135, type_bglt val2075_136)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 112 */
      return
	 ((((app_bglt) CREF(obj_135))->type) = ((type_bglt) val2075_136), BUNSPEC);
   }
}



/* _pre-struct-set!-app-type-set! */
obj_t 
_pre_struct_set__app_type_set__41_cfa_info2(obj_t env_5517, obj_t obj_5518, obj_t val2075_5519)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 112 */
      return
	 pre_struct_set__app_type_set__207_cfa_info2(
	 (app_bglt) (obj_5518),
	 (type_bglt) (val2075_5519));
   }
}



/* pre-struct-set!-app-type */
type_bglt 
pre_struct_set__app_type_46_cfa_info2(app_bglt obj_137)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 112 */
      return
	 (((app_bglt) CREF(obj_137))->type);
   }
}



/* _pre-struct-set!-app-type */
obj_t 
_pre_struct_set__app_type_235_cfa_info2(obj_t env_5520, obj_t obj_5521)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 112 */
      {		/* Cfa/cinfo2.scm 112 */
	 type_bglt aux_7120;
	 aux_7120 =
	    pre_struct_set__app_type_46_cfa_info2(
	    (app_bglt) (obj_5521));
	 return
	    (obj_t) (aux_7120);
      }
   }
}



/* pre-struct-set!-app-side-effect?-set! */
obj_t 
pre_struct_set__app_side_effect__set__33_cfa_info2(app_bglt obj_138, obj_t val2076_139)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 669 */
      return
	 ((((app_bglt) CREF(obj_138))->side_effect__165) = ((obj_t) val2076_139), BUNSPEC);
   }
}



/* _pre-struct-set!-app-side-effect?-set! */
obj_t 
_pre_struct_set__app_side_effect__set__221_cfa_info2(obj_t env_5522, obj_t obj_5523, obj_t val2076_5524)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 669 */
      return
	 pre_struct_set__app_side_effect__set__33_cfa_info2(
	 (app_bglt) (obj_5523), val2076_5524);
   }
}



/* pre-struct-set!-app-side-effect? */
obj_t 
pre_struct_set__app_side_effect__190_cfa_info2(app_bglt obj_140)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 669 */
      return
	 (((app_bglt) CREF(obj_140))->side_effect__165);
   }
}



/* _pre-struct-set!-app-side-effect? */
obj_t 
_pre_struct_set__app_side_effect__220_cfa_info2(obj_t env_5525, obj_t obj_5526)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 669 */
      return
	 pre_struct_set__app_side_effect__190_cfa_info2(
	 (app_bglt) (obj_5526));
   }
}



/* pre-struct-set!-app-key-set! */
obj_t 
pre_struct_set__app_key_set__234_cfa_info2(app_bglt obj_141, obj_t val2077_142)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 673 */
      return
	 ((((app_bglt) CREF(obj_141))->key) = ((obj_t) val2077_142), BUNSPEC);
   }
}



/* _pre-struct-set!-app-key-set!2876 */
obj_t 
_pre_struct_set__app_key_set_2876_203_cfa_info2(obj_t env_5527, obj_t obj_5528, obj_t val2077_5529)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 673 */
      return
	 pre_struct_set__app_key_set__234_cfa_info2(
	 (app_bglt) (obj_5528), val2077_5529);
   }
}



/* pre-struct-set!-app-key */
obj_t 
pre_struct_set__app_key_246_cfa_info2(app_bglt obj_143)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 673 */
      return
	 (((app_bglt) CREF(obj_143))->key);
   }
}



/* _pre-struct-set!-app-key2877 */
obj_t 
_pre_struct_set__app_key2877_203_cfa_info2(obj_t env_5530, obj_t obj_5531)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 673 */
      return
	 pre_struct_set__app_key_246_cfa_info2(
	 (app_bglt) (obj_5531));
   }
}



/* pre-struct-set!-app-fun-set! */
obj_t 
pre_struct_set__app_fun_set__90_cfa_info2(app_bglt obj_144, var_bglt val2078_145)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 112 */
      return
	 ((((app_bglt) CREF(obj_144))->fun) = ((var_bglt) val2078_145), BUNSPEC);
   }
}



/* _pre-struct-set!-app-fun-set! */
obj_t 
_pre_struct_set__app_fun_set__239_cfa_info2(obj_t env_5532, obj_t obj_5533, obj_t val2078_5534)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 112 */
      return
	 pre_struct_set__app_fun_set__90_cfa_info2(
	 (app_bglt) (obj_5533),
	 (var_bglt) (val2078_5534));
   }
}



/* pre-struct-set!-app-fun */
var_bglt 
pre_struct_set__app_fun_114_cfa_info2(app_bglt obj_146)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 112 */
      return
	 (((app_bglt) CREF(obj_146))->fun);
   }
}



/* _pre-struct-set!-app-fun */
obj_t 
_pre_struct_set__app_fun_168_cfa_info2(obj_t env_5535, obj_t obj_5536)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 112 */
      {		/* Cfa/cinfo2.scm 112 */
	 var_bglt aux_7141;
	 aux_7141 =
	    pre_struct_set__app_fun_114_cfa_info2(
	    (app_bglt) (obj_5536));
	 return
	    (obj_t) (aux_7141);
      }
   }
}



/* pre-struct-set!-app-args-set! */
obj_t 
pre_struct_set__app_args_set__238_cfa_info2(app_bglt obj_147, obj_t val2079_148)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 112 */
      return
	 ((((app_bglt) CREF(obj_147))->args) = ((obj_t) val2079_148), BUNSPEC);
   }
}



/* _pre-struct-set!-app-args-set! */
obj_t 
_pre_struct_set__app_args_set__231_cfa_info2(obj_t env_5537, obj_t obj_5538, obj_t val2079_5539)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 112 */
      return
	 pre_struct_set__app_args_set__238_cfa_info2(
	 (app_bglt) (obj_5538), val2079_5539);
   }
}



/* pre-struct-set!-app-args */
obj_t 
pre_struct_set__app_args_53_cfa_info2(app_bglt obj_149)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 112 */
      return
	 (((app_bglt) CREF(obj_149))->args);
   }
}



/* _pre-struct-set!-app-args */
obj_t 
_pre_struct_set__app_args_129_cfa_info2(obj_t env_5540, obj_t obj_5541)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 112 */
      return
	 pre_struct_set__app_args_53_cfa_info2(
	 (app_bglt) (obj_5541));
   }
}



/* pre-struct-set!-app-stack-info-set! */
obj_t 
pre_struct_set__app_stack_info_set__52_cfa_info2(app_bglt obj_150, obj_t val2080_151)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 704 */
      return
	 ((((app_bglt) CREF(obj_150))->stack_info_255) = ((obj_t) val2080_151), BUNSPEC);
   }
}



/* _pre-struct-set!-app-stack-info-set! */
obj_t 
_pre_struct_set__app_stack_info_set__234_cfa_info2(obj_t env_5542, obj_t obj_5543, obj_t val2080_5544)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 704 */
      return
	 pre_struct_set__app_stack_info_set__52_cfa_info2(
	 (app_bglt) (obj_5543), val2080_5544);
   }
}



/* pre-struct-set!-app-stack-info */
obj_t 
pre_struct_set__app_stack_info_177_cfa_info2(app_bglt obj_152)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 704 */
      return
	 (((app_bglt) CREF(obj_152))->stack_info_255);
   }
}



/* _pre-struct-set!-app-stack-info */
obj_t 
_pre_struct_set__app_stack_info_246_cfa_info2(obj_t env_5545, obj_t obj_5546)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 704 */
      return
	 pre_struct_set__app_stack_info_177_cfa_info2(
	 (app_bglt) (obj_5546));
   }
}



/* allocate-pre-struct-ref-app */
app_bglt 
allocate_pre_struct_ref_app_69_cfa_info2()
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 111 */
      {		/* Cfa/cinfo2.scm 111 */
	 app_bglt new2068_2314;
	 new2068_2314 =
	    ((app_bglt) BREF(GC_MALLOC(sizeof(struct app))));
	 {	/* Cfa/cinfo2.scm 111 */
	    long arg2370_2315;
	    arg2370_2315 =
	       class_num_218___object(pre_struct_ref_app_207_cfa_info2);
	    {	/* Cfa/cinfo2.scm 111 */
	       obj_t obj_3682;
	       obj_3682 =
		  (obj_t) (new2068_2314);
	       (((obj_t) CREF(obj_3682))->header = MAKE_HEADER(arg2370_2315, 0), BUNSPEC);
	    }
	 }
	 {	/* Cfa/cinfo2.scm 111 */
	    object_bglt aux_7161;
	    aux_7161 =
	       (object_bglt) (new2068_2314);
	    OBJECT_WIDENING_SET(aux_7161, BFALSE);
	 }
	 return new2068_2314;
      }
   }
}



/* _allocate-pre-struct-ref-app */
obj_t 
_allocate_pre_struct_ref_app_15_cfa_info2(obj_t env_5326)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 111 */
      {		/* Cfa/cinfo2.scm 111 */
	 app_bglt aux_7164;
	 aux_7164 =
	    allocate_pre_struct_ref_app_69_cfa_info2();
	 return
	    (obj_t) (aux_7164);
      }
   }
}



/* pre-struct-ref-app? */
bool_t 
pre_struct_ref_app__163_cfa_info2(obj_t obj_156)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 111 */
      return
	 is_a__118___object(obj_156, pre_struct_ref_app_207_cfa_info2);
   }
}



/* _pre-struct-ref-app? */
obj_t 
_pre_struct_ref_app__54_cfa_info2(obj_t env_5547, obj_t obj_5548)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 111 */
      {		/* Cfa/cinfo2.scm 111 */
	 bool_t aux_7168;
	 aux_7168 =
	    pre_struct_ref_app__163_cfa_info2(obj_5548);
	 return
	    BBOOL(aux_7168);
      }
   }
}



/* widening-pre-struct-ref-app */
pre_struct_ref_app_207_bglt 
widening_pre_struct_ref_app_19_cfa_info2()
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 111 */
      {		/* Cfa/cinfo2.scm 111 */

	 return
	    ((pre_struct_ref_app_207_bglt) BREF(GC_MALLOC(sizeof(struct pre_struct_ref_app_207))));
      }
   }
}



/* _widening-pre-struct-ref-app */
obj_t 
_widening_pre_struct_ref_app_117_cfa_info2(obj_t env_5549)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 111 */
      {		/* Cfa/cinfo2.scm 111 */
	 pre_struct_ref_app_207_bglt aux_7172;
	 aux_7172 =
	    widening_pre_struct_ref_app_19_cfa_info2();
	 return
	    (obj_t) (aux_7172);
      }
   }
}



/* make-pre-struct-ref-app */
pre_struct_ref_app_207_bglt 
make_pre_struct_ref_app_240_cfa_info2(obj_t loc_157, type_bglt type_158, obj_t side_effect__165_159, obj_t key_160, var_bglt fun_161, obj_t args_162, obj_t stack_info_255_163)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 111 */
      {		/* Cfa/cinfo2.scm 111 */
	 app_bglt aux2066_3685;
	 {	/* Cfa/cinfo2.scm 111 */
	    app_bglt res2815_3707;
	    {	/* ./Ast/node.scm 698 */
	       app_bglt new1248_3696;
	       new1248_3696 =
		  ((app_bglt) BREF(GC_MALLOC(sizeof(struct app))));
	       {	/* ./Ast/node.scm 698 */
		  long arg2541_3697;
		  arg2541_3697 =
		     class_num_218___object(app_ast_node);
		  {	/* ./Ast/node.scm 698 */
		     obj_t obj_3705;
		     obj_3705 =
			(obj_t) (new1248_3696);
		     (((obj_t) CREF(obj_3705))->header = MAKE_HEADER(arg2541_3697, 0), BUNSPEC);
		  }
	       }
	       {	/* ./Ast/node.scm 698 */
		  object_bglt aux_7179;
		  aux_7179 =
		     (object_bglt) (new1248_3696);
		  OBJECT_WIDENING_SET(aux_7179, BFALSE);
	       }
	       ((((app_bglt) CREF(new1248_3696))->loc) = ((obj_t) loc_157), BUNSPEC);
	       ((((app_bglt) CREF(new1248_3696))->type) = ((type_bglt) type_158), BUNSPEC);
	       ((((app_bglt) CREF(new1248_3696))->side_effect__165) = ((obj_t) side_effect__165_159), BUNSPEC);
	       ((((app_bglt) CREF(new1248_3696))->key) = ((obj_t) key_160), BUNSPEC);
	       ((((app_bglt) CREF(new1248_3696))->fun) = ((var_bglt) fun_161), BUNSPEC);
	       ((((app_bglt) CREF(new1248_3696))->args) = ((obj_t) args_162), BUNSPEC);
	       ((((app_bglt) CREF(new1248_3696))->stack_info_255) = ((obj_t) stack_info_255_163), BUNSPEC);
	       res2815_3707 = new1248_3696;
	    }
	    aux2066_3685 = res2815_3707;
	 }
	 {	/* Cfa/cinfo2.scm 111 */
	    pre_struct_ref_app_207_bglt new2067_3686;
	    new2067_3686 =
	       ((pre_struct_ref_app_207_bglt) (aux2066_3685));
	    {	/* Cfa/cinfo2.scm 111 */
	       long arg2371_3687;
	       arg2371_3687 =
		  class_num_218___object(pre_struct_ref_app_207_cfa_info2);
	       {	/* Cfa/cinfo2.scm 111 */
		  obj_t obj_3708;
		  obj_3708 =
		     (obj_t) (new2067_3686);
		  (((obj_t) CREF(obj_3708))->header = MAKE_HEADER(arg2371_3687, 0), BUNSPEC);
	       }
	    }
	    {	/* Cfa/cinfo2.scm 111 */
	       obj_t aux_7195;
	       object_bglt aux_7193;
	       {	/* Cfa/cinfo2.scm 111 */
		  pre_struct_ref_app_207_bglt aux_7196;
		  {	/* Cfa/cinfo2.scm 111 */

		     aux_7196 =
			((pre_struct_ref_app_207_bglt) BREF(GC_MALLOC(sizeof(struct pre_struct_ref_app_207))));
		  }
		  aux_7195 =
		     (obj_t) (aux_7196);
	       }
	       aux_7193 =
		  (object_bglt) (new2067_3686);
	       OBJECT_WIDENING_SET(aux_7193, aux_7195);
	    }
	    return new2067_3686;
	 }
      }
   }
}



/* _make-pre-struct-ref-app */
obj_t 
_make_pre_struct_ref_app_219_cfa_info2(obj_t env_5550, obj_t loc_5551, obj_t type_5552, obj_t side_effect__165_5553, obj_t key_5554, obj_t fun_5555, obj_t args_5556, obj_t stack_info_255_5557)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 111 */
      {		/* Cfa/cinfo2.scm 111 */
	 pre_struct_ref_app_207_bglt aux_7200;
	 aux_7200 =
	    make_pre_struct_ref_app_240_cfa_info2(loc_5551,
	    (type_bglt) (type_5552), side_effect__165_5553, key_5554,
	    (var_bglt) (fun_5555), args_5556, stack_info_255_5557);
	 return
	    (obj_t) (aux_7200);
      }
   }
}



/* pre-struct-ref-app-loc */
obj_t 
pre_struct_ref_app_loc_17_cfa_info2(app_bglt obj_164)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 661 */
      return
	 (((app_bglt) CREF(obj_164))->loc);
   }
}



/* _pre-struct-ref-app-loc */
obj_t 
_pre_struct_ref_app_loc_255_cfa_info2(obj_t env_5558, obj_t obj_5559)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 661 */
      return
	 pre_struct_ref_app_loc_17_cfa_info2(
	 (app_bglt) (obj_5559));
   }
}



/* pre-struct-ref-app-type-set! */
obj_t 
pre_struct_ref_app_type_set__101_cfa_info2(app_bglt obj_165, type_bglt val2058_166)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 111 */
      return
	 ((((app_bglt) CREF(obj_165))->type) = ((type_bglt) val2058_166), BUNSPEC);
   }
}



/* _pre-struct-ref-app-type-set! */
obj_t 
_pre_struct_ref_app_type_set__215_cfa_info2(obj_t env_5560, obj_t obj_5561, obj_t val2058_5562)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 111 */
      return
	 pre_struct_ref_app_type_set__101_cfa_info2(
	 (app_bglt) (obj_5561),
	 (type_bglt) (val2058_5562));
   }
}



/* pre-struct-ref-app-type */
type_bglt 
pre_struct_ref_app_type_242_cfa_info2(app_bglt obj_167)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 111 */
      return
	 (((app_bglt) CREF(obj_167))->type);
   }
}



/* _pre-struct-ref-app-type */
obj_t 
_pre_struct_ref_app_type_66_cfa_info2(obj_t env_5563, obj_t obj_5564)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 111 */
      {		/* Cfa/cinfo2.scm 111 */
	 type_bglt aux_7213;
	 aux_7213 =
	    pre_struct_ref_app_type_242_cfa_info2(
	    (app_bglt) (obj_5564));
	 return
	    (obj_t) (aux_7213);
      }
   }
}



/* pre-struct-ref-app-side-effect?-set! */
obj_t 
pre_struct_ref_app_side_effect__set__16_cfa_info2(app_bglt obj_168, obj_t val2059_169)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 669 */
      return
	 ((((app_bglt) CREF(obj_168))->side_effect__165) = ((obj_t) val2059_169), BUNSPEC);
   }
}



/* _pre-struct-ref-app-side-effect?-set! */
obj_t 
_pre_struct_ref_app_side_effect__set__91_cfa_info2(obj_t env_5565, obj_t obj_5566, obj_t val2059_5567)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 669 */
      return
	 pre_struct_ref_app_side_effect__set__16_cfa_info2(
	 (app_bglt) (obj_5566), val2059_5567);
   }
}



/* pre-struct-ref-app-side-effect? */
obj_t 
pre_struct_ref_app_side_effect__198_cfa_info2(app_bglt obj_170)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 669 */
      return
	 (((app_bglt) CREF(obj_170))->side_effect__165);
   }
}



/* _pre-struct-ref-app-side-effect? */
obj_t 
_pre_struct_ref_app_side_effect__0_cfa_info2(obj_t env_5568, obj_t obj_5569)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 669 */
      return
	 pre_struct_ref_app_side_effect__198_cfa_info2(
	 (app_bglt) (obj_5569));
   }
}



/* pre-struct-ref-app-key-set! */
obj_t 
pre_struct_ref_app_key_set__138_cfa_info2(app_bglt obj_171, obj_t val2060_172)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 673 */
      return
	 ((((app_bglt) CREF(obj_171))->key) = ((obj_t) val2060_172), BUNSPEC);
   }
}



/* _pre-struct-ref-app-key-set!2878 */
obj_t 
_pre_struct_ref_app_key_set_2878_242_cfa_info2(obj_t env_5570, obj_t obj_5571, obj_t val2060_5572)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 673 */
      return
	 pre_struct_ref_app_key_set__138_cfa_info2(
	 (app_bglt) (obj_5571), val2060_5572);
   }
}



/* pre-struct-ref-app-key */
obj_t 
pre_struct_ref_app_key_6_cfa_info2(app_bglt obj_173)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 673 */
      return
	 (((app_bglt) CREF(obj_173))->key);
   }
}



/* _pre-struct-ref-app-key2879 */
obj_t 
_pre_struct_ref_app_key2879_31_cfa_info2(obj_t env_5573, obj_t obj_5574)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 673 */
      return
	 pre_struct_ref_app_key_6_cfa_info2(
	 (app_bglt) (obj_5574));
   }
}



/* pre-struct-ref-app-fun-set! */
obj_t 
pre_struct_ref_app_fun_set__223_cfa_info2(app_bglt obj_174, var_bglt val2061_175)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 111 */
      return
	 ((((app_bglt) CREF(obj_174))->fun) = ((var_bglt) val2061_175), BUNSPEC);
   }
}



/* _pre-struct-ref-app-fun-set! */
obj_t 
_pre_struct_ref_app_fun_set__11_cfa_info2(obj_t env_5575, obj_t obj_5576, obj_t val2061_5577)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 111 */
      return
	 pre_struct_ref_app_fun_set__223_cfa_info2(
	 (app_bglt) (obj_5576),
	 (var_bglt) (val2061_5577));
   }
}



/* pre-struct-ref-app-fun */
var_bglt 
pre_struct_ref_app_fun_229_cfa_info2(app_bglt obj_176)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 111 */
      return
	 (((app_bglt) CREF(obj_176))->fun);
   }
}



/* _pre-struct-ref-app-fun */
obj_t 
_pre_struct_ref_app_fun_118_cfa_info2(obj_t env_5578, obj_t obj_5579)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 111 */
      {		/* Cfa/cinfo2.scm 111 */
	 var_bglt aux_7234;
	 aux_7234 =
	    pre_struct_ref_app_fun_229_cfa_info2(
	    (app_bglt) (obj_5579));
	 return
	    (obj_t) (aux_7234);
      }
   }
}



/* pre-struct-ref-app-args-set! */
obj_t 
pre_struct_ref_app_args_set__168_cfa_info2(app_bglt obj_177, obj_t val2062_178)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 111 */
      return
	 ((((app_bglt) CREF(obj_177))->args) = ((obj_t) val2062_178), BUNSPEC);
   }
}



/* _pre-struct-ref-app-args-set! */
obj_t 
_pre_struct_ref_app_args_set__179_cfa_info2(obj_t env_5580, obj_t obj_5581, obj_t val2062_5582)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 111 */
      return
	 pre_struct_ref_app_args_set__168_cfa_info2(
	 (app_bglt) (obj_5581), val2062_5582);
   }
}



/* pre-struct-ref-app-args */
obj_t 
pre_struct_ref_app_args_87_cfa_info2(app_bglt obj_179)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 111 */
      return
	 (((app_bglt) CREF(obj_179))->args);
   }
}



/* _pre-struct-ref-app-args */
obj_t 
_pre_struct_ref_app_args_2_cfa_info2(obj_t env_5583, obj_t obj_5584)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 111 */
      return
	 pre_struct_ref_app_args_87_cfa_info2(
	 (app_bglt) (obj_5584));
   }
}



/* pre-struct-ref-app-stack-info-set! */
obj_t 
pre_struct_ref_app_stack_info_set__163_cfa_info2(app_bglt obj_180, obj_t val2063_181)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 704 */
      return
	 ((((app_bglt) CREF(obj_180))->stack_info_255) = ((obj_t) val2063_181), BUNSPEC);
   }
}



/* _pre-struct-ref-app-stack-info-set! */
obj_t 
_pre_struct_ref_app_stack_info_set__255_cfa_info2(obj_t env_5585, obj_t obj_5586, obj_t val2063_5587)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 704 */
      return
	 pre_struct_ref_app_stack_info_set__163_cfa_info2(
	 (app_bglt) (obj_5586), val2063_5587);
   }
}



/* pre-struct-ref-app-stack-info */
obj_t 
pre_struct_ref_app_stack_info_193_cfa_info2(app_bglt obj_182)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 704 */
      return
	 (((app_bglt) CREF(obj_182))->stack_info_255);
   }
}



/* _pre-struct-ref-app-stack-info */
obj_t 
_pre_struct_ref_app_stack_info_45_cfa_info2(obj_t env_5588, obj_t obj_5589)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 704 */
      return
	 pre_struct_ref_app_stack_info_193_cfa_info2(
	 (app_bglt) (obj_5589));
   }
}



/* allocate-pre-make-struct-app */
app_bglt 
allocate_pre_make_struct_app_64_cfa_info2()
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 108 */
      {		/* Cfa/cinfo2.scm 108 */
	 app_bglt new2051_2321;
	 new2051_2321 =
	    ((app_bglt) BREF(GC_MALLOC(sizeof(struct app))));
	 {	/* Cfa/cinfo2.scm 108 */
	    long arg2373_2322;
	    arg2373_2322 =
	       class_num_218___object(pre_make_struct_app_218_cfa_info2);
	    {	/* Cfa/cinfo2.scm 108 */
	       obj_t obj_3712;
	       obj_3712 =
		  (obj_t) (new2051_2321);
	       (((obj_t) CREF(obj_3712))->header = MAKE_HEADER(arg2373_2322, 0), BUNSPEC);
	    }
	 }
	 {	/* Cfa/cinfo2.scm 108 */
	    object_bglt aux_7254;
	    aux_7254 =
	       (object_bglt) (new2051_2321);
	    OBJECT_WIDENING_SET(aux_7254, BFALSE);
	 }
	 return new2051_2321;
      }
   }
}



/* _allocate-pre-make-struct-app */
obj_t 
_allocate_pre_make_struct_app_85_cfa_info2(obj_t env_5325)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 108 */
      {		/* Cfa/cinfo2.scm 108 */
	 app_bglt aux_7257;
	 aux_7257 =
	    allocate_pre_make_struct_app_64_cfa_info2();
	 return
	    (obj_t) (aux_7257);
      }
   }
}



/* pre-make-struct-app? */
bool_t 
pre_make_struct_app__0_cfa_info2(obj_t obj_186)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 108 */
      return
	 is_a__118___object(obj_186, pre_make_struct_app_218_cfa_info2);
   }
}



/* _pre-make-struct-app? */
obj_t 
_pre_make_struct_app__245_cfa_info2(obj_t env_5590, obj_t obj_5591)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 108 */
      {		/* Cfa/cinfo2.scm 108 */
	 bool_t aux_7261;
	 aux_7261 =
	    pre_make_struct_app__0_cfa_info2(obj_5591);
	 return
	    BBOOL(aux_7261);
      }
   }
}



/* widening-pre-make-struct-app */
pre_make_struct_app_218_bglt 
widening_pre_make_struct_app_228_cfa_info2(variable_bglt owner_187)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 108 */
      {		/* Cfa/cinfo2.scm 108 */
	 pre_make_struct_app_218_bglt new2046_3714;
	 new2046_3714 =
	    ((pre_make_struct_app_218_bglt) BREF(GC_MALLOC(sizeof(struct pre_make_struct_app_218))));
	 ((((pre_make_struct_app_218_bglt) CREF(new2046_3714))->owner) = ((variable_bglt) owner_187), BUNSPEC);
	 return new2046_3714;
      }
   }
}



/* _widening-pre-make-struct-app2880 */
obj_t 
_widening_pre_make_struct_app2880_148_cfa_info2(obj_t env_5592, obj_t owner_5593)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 108 */
      {		/* Cfa/cinfo2.scm 108 */
	 pre_make_struct_app_218_bglt aux_7266;
	 aux_7266 =
	    widening_pre_make_struct_app_228_cfa_info2(
	    (variable_bglt) (owner_5593));
	 return
	    (obj_t) (aux_7266);
      }
   }
}



/* make-pre-make-struct-app */
pre_make_struct_app_218_bglt 
make_pre_make_struct_app_250_cfa_info2(obj_t loc_188, type_bglt type_189, obj_t side_effect__165_190, obj_t key_191, var_bglt fun_192, obj_t args_193, obj_t stack_info_255_194, variable_bglt owner_195)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 108 */
      {		/* Cfa/cinfo2.scm 108 */
	 app_bglt aux2049_3716;
	 {	/* Cfa/cinfo2.scm 108 */
	    app_bglt res2817_3738;
	    {	/* ./Ast/node.scm 698 */
	       app_bglt new1248_3727;
	       new1248_3727 =
		  ((app_bglt) BREF(GC_MALLOC(sizeof(struct app))));
	       {	/* ./Ast/node.scm 698 */
		  long arg2541_3728;
		  arg2541_3728 =
		     class_num_218___object(app_ast_node);
		  {	/* ./Ast/node.scm 698 */
		     obj_t obj_3736;
		     obj_3736 =
			(obj_t) (new1248_3727);
		     (((obj_t) CREF(obj_3736))->header = MAKE_HEADER(arg2541_3728, 0), BUNSPEC);
		  }
	       }
	       {	/* ./Ast/node.scm 698 */
		  object_bglt aux_7274;
		  aux_7274 =
		     (object_bglt) (new1248_3727);
		  OBJECT_WIDENING_SET(aux_7274, BFALSE);
	       }
	       ((((app_bglt) CREF(new1248_3727))->loc) = ((obj_t) loc_188), BUNSPEC);
	       ((((app_bglt) CREF(new1248_3727))->type) = ((type_bglt) type_189), BUNSPEC);
	       ((((app_bglt) CREF(new1248_3727))->side_effect__165) = ((obj_t) side_effect__165_190), BUNSPEC);
	       ((((app_bglt) CREF(new1248_3727))->key) = ((obj_t) key_191), BUNSPEC);
	       ((((app_bglt) CREF(new1248_3727))->fun) = ((var_bglt) fun_192), BUNSPEC);
	       ((((app_bglt) CREF(new1248_3727))->args) = ((obj_t) args_193), BUNSPEC);
	       ((((app_bglt) CREF(new1248_3727))->stack_info_255) = ((obj_t) stack_info_255_194), BUNSPEC);
	       res2817_3738 = new1248_3727;
	    }
	    aux2049_3716 = res2817_3738;
	 }
	 {	/* Cfa/cinfo2.scm 108 */
	    pre_make_struct_app_218_bglt new2050_3717;
	    new2050_3717 =
	       ((pre_make_struct_app_218_bglt) (aux2049_3716));
	    {	/* Cfa/cinfo2.scm 108 */
	       long arg2374_3718;
	       arg2374_3718 =
		  class_num_218___object(pre_make_struct_app_218_cfa_info2);
	       {	/* Cfa/cinfo2.scm 108 */
		  obj_t obj_3739;
		  obj_3739 =
		     (obj_t) (new2050_3717);
		  (((obj_t) CREF(obj_3739))->header = MAKE_HEADER(arg2374_3718, 0), BUNSPEC);
	       }
	    }
	    {	/* Cfa/cinfo2.scm 108 */
	       pre_make_struct_app_218_bglt arg2375_3719;
	       {	/* Cfa/cinfo2.scm 108 */
		  pre_make_struct_app_218_bglt res2818_3744;
		  {	/* Cfa/cinfo2.scm 108 */
		     pre_make_struct_app_218_bglt new2046_3742;
		     new2046_3742 =
			((pre_make_struct_app_218_bglt) BREF(GC_MALLOC(sizeof(struct pre_make_struct_app_218))));
		     ((((pre_make_struct_app_218_bglt) CREF(new2046_3742))->owner) = ((variable_bglt) owner_195), BUNSPEC);
		     res2818_3744 = new2046_3742;
		  }
		  arg2375_3719 = res2818_3744;
	       }
	       {	/* Cfa/cinfo2.scm 108 */
		  obj_t aux_7292;
		  object_bglt aux_7290;
		  aux_7292 =
		     (obj_t) (arg2375_3719);
		  aux_7290 =
		     (object_bglt) (new2050_3717);
		  OBJECT_WIDENING_SET(aux_7290, aux_7292);
	       }
	    }
	    return new2050_3717;
	 }
      }
   }
}



/* _make-pre-make-struct-app */
obj_t 
_make_pre_make_struct_app_249_cfa_info2(obj_t env_5594, obj_t loc_5595, obj_t type_5596, obj_t side_effect__165_5597, obj_t key_5598, obj_t fun_5599, obj_t args_5600, obj_t stack_info_255_5601, obj_t owner_5602)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 108 */
      {		/* Cfa/cinfo2.scm 108 */
	 pre_make_struct_app_218_bglt aux_7295;
	 aux_7295 =
	    make_pre_make_struct_app_250_cfa_info2(loc_5595,
	    (type_bglt) (type_5596), side_effect__165_5597, key_5598,
	    (var_bglt) (fun_5599), args_5600, stack_info_255_5601,
	    (variable_bglt) (owner_5602));
	 return
	    (obj_t) (aux_7295);
      }
   }
}



/* pre-make-struct-app-loc */
obj_t 
pre_make_struct_app_loc_207_cfa_info2(app_bglt obj_196)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 661 */
      return
	 (((app_bglt) CREF(obj_196))->loc);
   }
}



/* _pre-make-struct-app-loc */
obj_t 
_pre_make_struct_app_loc_183_cfa_info2(obj_t env_5603, obj_t obj_5604)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 661 */
      return
	 pre_make_struct_app_loc_207_cfa_info2(
	 (app_bglt) (obj_5604));
   }
}



/* pre-make-struct-app-type-set! */
obj_t 
pre_make_struct_app_type_set__1_cfa_info2(app_bglt obj_197, type_bglt val2040_198)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 108 */
      return
	 ((((app_bglt) CREF(obj_197))->type) = ((type_bglt) val2040_198), BUNSPEC);
   }
}



/* _pre-make-struct-app-type-set! */
obj_t 
_pre_make_struct_app_type_set__21_cfa_info2(obj_t env_5605, obj_t obj_5606, obj_t val2040_5607)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 108 */
      return
	 pre_make_struct_app_type_set__1_cfa_info2(
	 (app_bglt) (obj_5606),
	 (type_bglt) (val2040_5607));
   }
}



/* pre-make-struct-app-type */
type_bglt 
pre_make_struct_app_type_250_cfa_info2(app_bglt obj_199)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 108 */
      return
	 (((app_bglt) CREF(obj_199))->type);
   }
}



/* _pre-make-struct-app-type */
obj_t 
_pre_make_struct_app_type_57_cfa_info2(obj_t env_5608, obj_t obj_5609)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 108 */
      {		/* Cfa/cinfo2.scm 108 */
	 type_bglt aux_7309;
	 aux_7309 =
	    pre_make_struct_app_type_250_cfa_info2(
	    (app_bglt) (obj_5609));
	 return
	    (obj_t) (aux_7309);
      }
   }
}



/* pre-make-struct-app-side-effect?-set! */
obj_t 
pre_make_struct_app_side_effect__set__106_cfa_info2(app_bglt obj_200, obj_t val2041_201)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 669 */
      return
	 ((((app_bglt) CREF(obj_200))->side_effect__165) = ((obj_t) val2041_201), BUNSPEC);
   }
}



/* _pre-make-struct-app-side-effect?-set! */
obj_t 
_pre_make_struct_app_side_effect__set__136_cfa_info2(obj_t env_5610, obj_t obj_5611, obj_t val2041_5612)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 669 */
      return
	 pre_make_struct_app_side_effect__set__106_cfa_info2(
	 (app_bglt) (obj_5611), val2041_5612);
   }
}



/* pre-make-struct-app-side-effect? */
obj_t 
pre_make_struct_app_side_effect__189_cfa_info2(app_bglt obj_202)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 669 */
      return
	 (((app_bglt) CREF(obj_202))->side_effect__165);
   }
}



/* _pre-make-struct-app-side-effect? */
obj_t 
_pre_make_struct_app_side_effect__126_cfa_info2(obj_t env_5613, obj_t obj_5614)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 669 */
      return
	 pre_make_struct_app_side_effect__189_cfa_info2(
	 (app_bglt) (obj_5614));
   }
}



/* pre-make-struct-app-key-set! */
obj_t 
pre_make_struct_app_key_set__227_cfa_info2(app_bglt obj_203, obj_t val2042_204)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 673 */
      return
	 ((((app_bglt) CREF(obj_203))->key) = ((obj_t) val2042_204), BUNSPEC);
   }
}



/* _pre-make-struct-app-key-set! */
obj_t 
_pre_make_struct_app_key_set__46_cfa_info2(obj_t env_5615, obj_t obj_5616, obj_t val2042_5617)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 673 */
      return
	 pre_make_struct_app_key_set__227_cfa_info2(
	 (app_bglt) (obj_5616), val2042_5617);
   }
}



/* pre-make-struct-app-key */
obj_t 
pre_make_struct_app_key_253_cfa_info2(app_bglt obj_205)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 673 */
      return
	 (((app_bglt) CREF(obj_205))->key);
   }
}



/* _pre-make-struct-app-key */
obj_t 
_pre_make_struct_app_key_102_cfa_info2(obj_t env_5618, obj_t obj_5619)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 673 */
      return
	 pre_make_struct_app_key_253_cfa_info2(
	 (app_bglt) (obj_5619));
   }
}



/* pre-make-struct-app-fun-set! */
obj_t 
pre_make_struct_app_fun_set__18_cfa_info2(app_bglt obj_206, var_bglt val2043_207)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 108 */
      return
	 ((((app_bglt) CREF(obj_206))->fun) = ((var_bglt) val2043_207), BUNSPEC);
   }
}



/* _pre-make-struct-app-fun-set! */
obj_t 
_pre_make_struct_app_fun_set__105_cfa_info2(obj_t env_5620, obj_t obj_5621, obj_t val2043_5622)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 108 */
      return
	 pre_make_struct_app_fun_set__18_cfa_info2(
	 (app_bglt) (obj_5621),
	 (var_bglt) (val2043_5622));
   }
}



/* pre-make-struct-app-fun */
var_bglt 
pre_make_struct_app_fun_214_cfa_info2(app_bglt obj_208)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 108 */
      return
	 (((app_bglt) CREF(obj_208))->fun);
   }
}



/* _pre-make-struct-app-fun */
obj_t 
_pre_make_struct_app_fun_203_cfa_info2(obj_t env_5623, obj_t obj_5624)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 108 */
      {		/* Cfa/cinfo2.scm 108 */
	 var_bglt aux_7330;
	 aux_7330 =
	    pre_make_struct_app_fun_214_cfa_info2(
	    (app_bglt) (obj_5624));
	 return
	    (obj_t) (aux_7330);
      }
   }
}



/* pre-make-struct-app-args-set! */
obj_t 
pre_make_struct_app_args_set__137_cfa_info2(app_bglt obj_209, obj_t val2044_210)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 108 */
      return
	 ((((app_bglt) CREF(obj_209))->args) = ((obj_t) val2044_210), BUNSPEC);
   }
}



/* _pre-make-struct-app-args-set! */
obj_t 
_pre_make_struct_app_args_set__178_cfa_info2(obj_t env_5625, obj_t obj_5626, obj_t val2044_5627)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 108 */
      return
	 pre_make_struct_app_args_set__137_cfa_info2(
	 (app_bglt) (obj_5626), val2044_5627);
   }
}



/* pre-make-struct-app-args */
obj_t 
pre_make_struct_app_args_251_cfa_info2(app_bglt obj_211)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 108 */
      return
	 (((app_bglt) CREF(obj_211))->args);
   }
}



/* _pre-make-struct-app-args */
obj_t 
_pre_make_struct_app_args_7_cfa_info2(obj_t env_5628, obj_t obj_5629)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 108 */
      return
	 pre_make_struct_app_args_251_cfa_info2(
	 (app_bglt) (obj_5629));
   }
}



/* pre-make-struct-app-stack-info-set! */
obj_t 
pre_make_struct_app_stack_info_set__82_cfa_info2(app_bglt obj_212, obj_t val2045_213)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 704 */
      return
	 ((((app_bglt) CREF(obj_212))->stack_info_255) = ((obj_t) val2045_213), BUNSPEC);
   }
}



/* _pre-make-struct-app-stack-info-set! */
obj_t 
_pre_make_struct_app_stack_info_set__155_cfa_info2(obj_t env_5630, obj_t obj_5631, obj_t val2045_5632)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 704 */
      return
	 pre_make_struct_app_stack_info_set__82_cfa_info2(
	 (app_bglt) (obj_5631), val2045_5632);
   }
}



/* pre-make-struct-app-stack-info */
obj_t 
pre_make_struct_app_stack_info_182_cfa_info2(app_bglt obj_214)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 704 */
      return
	 (((app_bglt) CREF(obj_214))->stack_info_255);
   }
}



/* _pre-make-struct-app-stack-info */
obj_t 
_pre_make_struct_app_stack_info_136_cfa_info2(obj_t env_5633, obj_t obj_5634)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 704 */
      return
	 pre_make_struct_app_stack_info_182_cfa_info2(
	 (app_bglt) (obj_5634));
   }
}



/* pre-make-struct-app-owner */
variable_bglt 
pre_make_struct_app_owner_50_cfa_info2(pre_make_struct_app_218_bglt obj_215)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 110 */
      {
	 obj_t aux_7346;
	 {	/* Cfa/cinfo2.scm 110 */
	    object_bglt aux_7347;
	    aux_7347 =
	       (object_bglt) (obj_215);
	    aux_7346 =
	       OBJECT_WIDENING(aux_7347);
	 }
	 return
	    (((pre_make_struct_app_218_bglt) CREF(aux_7346))->owner);
      }
   }
}



/* _pre-make-struct-app-owner */
obj_t 
_pre_make_struct_app_owner_0_cfa_info2(obj_t env_5635, obj_t obj_5636)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 110 */
      {		/* Cfa/cinfo2.scm 110 */
	 variable_bglt aux_7351;
	 aux_7351 =
	    pre_make_struct_app_owner_50_cfa_info2(
	    (pre_make_struct_app_218_bglt) (obj_5636));
	 return
	    (obj_t) (aux_7351);
      }
   }
}



/* allocate-vector-set!-app */
app_bglt 
allocate_vector_set__app_126_cfa_info2()
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 105 */
      {		/* Cfa/cinfo2.scm 105 */
	 app_bglt new2033_2329;
	 new2033_2329 =
	    ((app_bglt) BREF(GC_MALLOC(sizeof(struct app))));
	 {	/* Cfa/cinfo2.scm 105 */
	    long arg2376_2330;
	    arg2376_2330 =
	       class_num_218___object(vector_set__app_21_cfa_info2);
	    {	/* Cfa/cinfo2.scm 105 */
	       obj_t obj_3745;
	       obj_3745 =
		  (obj_t) (new2033_2329);
	       (((obj_t) CREF(obj_3745))->header = MAKE_HEADER(arg2376_2330, 0), BUNSPEC);
	    }
	 }
	 {	/* Cfa/cinfo2.scm 105 */
	    object_bglt aux_7359;
	    aux_7359 =
	       (object_bglt) (new2033_2329);
	    OBJECT_WIDENING_SET(aux_7359, BFALSE);
	 }
	 return new2033_2329;
      }
   }
}



/* _allocate-vector-set!-app */
obj_t 
_allocate_vector_set__app_158_cfa_info2(obj_t env_5324)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 105 */
      {		/* Cfa/cinfo2.scm 105 */
	 app_bglt aux_7362;
	 aux_7362 =
	    allocate_vector_set__app_126_cfa_info2();
	 return
	    (obj_t) (aux_7362);
      }
   }
}



/* vector-set!-app? */
bool_t 
vector_set__app__15_cfa_info2(obj_t obj_219)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 105 */
      return
	 is_a__118___object(obj_219, vector_set__app_21_cfa_info2);
   }
}



/* _vector-set!-app? */
obj_t 
_vector_set__app__140_cfa_info2(obj_t env_5637, obj_t obj_5638)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 105 */
      {		/* Cfa/cinfo2.scm 105 */
	 bool_t aux_7366;
	 aux_7366 =
	    vector_set__app__15_cfa_info2(obj_5638);
	 return
	    BBOOL(aux_7366);
      }
   }
}



/* widening-vector-set!-app */
vector_set__app_21_bglt 
widening_vector_set__app_138_cfa_info2(approx_bglt approx_220)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 105 */
      {		/* Cfa/cinfo2.scm 105 */
	 vector_set__app_21_bglt new2028_3747;
	 new2028_3747 =
	    ((vector_set__app_21_bglt) BREF(GC_MALLOC(sizeof(struct vector_set__app_21))));
	 ((((vector_set__app_21_bglt) CREF(new2028_3747))->approx) = ((approx_bglt) approx_220), BUNSPEC);
	 return new2028_3747;
      }
   }
}



/* _widening-vector-set!-app2881 */
obj_t 
_widening_vector_set__app2881_128_cfa_info2(obj_t env_5639, obj_t approx_5640)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 105 */
      {		/* Cfa/cinfo2.scm 105 */
	 vector_set__app_21_bglt aux_7371;
	 aux_7371 =
	    widening_vector_set__app_138_cfa_info2(
	    (approx_bglt) (approx_5640));
	 return
	    (obj_t) (aux_7371);
      }
   }
}



/* make-vector-set!-app */
vector_set__app_21_bglt 
make_vector_set__app_24_cfa_info2(obj_t loc_221, type_bglt type_222, obj_t side_effect__165_223, obj_t key_224, var_bglt fun_225, obj_t args_226, obj_t stack_info_255_227, approx_bglt approx_228)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 105 */
      {		/* Cfa/cinfo2.scm 105 */
	 app_bglt aux2031_3749;
	 {	/* Cfa/cinfo2.scm 105 */
	    app_bglt res2819_3771;
	    {	/* ./Ast/node.scm 698 */
	       app_bglt new1248_3760;
	       new1248_3760 =
		  ((app_bglt) BREF(GC_MALLOC(sizeof(struct app))));
	       {	/* ./Ast/node.scm 698 */
		  long arg2541_3761;
		  arg2541_3761 =
		     class_num_218___object(app_ast_node);
		  {	/* ./Ast/node.scm 698 */
		     obj_t obj_3769;
		     obj_3769 =
			(obj_t) (new1248_3760);
		     (((obj_t) CREF(obj_3769))->header = MAKE_HEADER(arg2541_3761, 0), BUNSPEC);
		  }
	       }
	       {	/* ./Ast/node.scm 698 */
		  object_bglt aux_7379;
		  aux_7379 =
		     (object_bglt) (new1248_3760);
		  OBJECT_WIDENING_SET(aux_7379, BFALSE);
	       }
	       ((((app_bglt) CREF(new1248_3760))->loc) = ((obj_t) loc_221), BUNSPEC);
	       ((((app_bglt) CREF(new1248_3760))->type) = ((type_bglt) type_222), BUNSPEC);
	       ((((app_bglt) CREF(new1248_3760))->side_effect__165) = ((obj_t) side_effect__165_223), BUNSPEC);
	       ((((app_bglt) CREF(new1248_3760))->key) = ((obj_t) key_224), BUNSPEC);
	       ((((app_bglt) CREF(new1248_3760))->fun) = ((var_bglt) fun_225), BUNSPEC);
	       ((((app_bglt) CREF(new1248_3760))->args) = ((obj_t) args_226), BUNSPEC);
	       ((((app_bglt) CREF(new1248_3760))->stack_info_255) = ((obj_t) stack_info_255_227), BUNSPEC);
	       res2819_3771 = new1248_3760;
	    }
	    aux2031_3749 = res2819_3771;
	 }
	 {	/* Cfa/cinfo2.scm 105 */
	    vector_set__app_21_bglt new2032_3750;
	    new2032_3750 =
	       ((vector_set__app_21_bglt) (aux2031_3749));
	    {	/* Cfa/cinfo2.scm 105 */
	       long arg2377_3751;
	       arg2377_3751 =
		  class_num_218___object(vector_set__app_21_cfa_info2);
	       {	/* Cfa/cinfo2.scm 105 */
		  obj_t obj_3772;
		  obj_3772 =
		     (obj_t) (new2032_3750);
		  (((obj_t) CREF(obj_3772))->header = MAKE_HEADER(arg2377_3751, 0), BUNSPEC);
	       }
	    }
	    {	/* Cfa/cinfo2.scm 105 */
	       vector_set__app_21_bglt arg2378_3752;
	       {	/* Cfa/cinfo2.scm 105 */
		  vector_set__app_21_bglt res2820_3777;
		  {	/* Cfa/cinfo2.scm 105 */
		     vector_set__app_21_bglt new2028_3775;
		     new2028_3775 =
			((vector_set__app_21_bglt) BREF(GC_MALLOC(sizeof(struct vector_set__app_21))));
		     ((((vector_set__app_21_bglt) CREF(new2028_3775))->approx) = ((approx_bglt) approx_228), BUNSPEC);
		     res2820_3777 = new2028_3775;
		  }
		  arg2378_3752 = res2820_3777;
	       }
	       {	/* Cfa/cinfo2.scm 105 */
		  obj_t aux_7397;
		  object_bglt aux_7395;
		  aux_7397 =
		     (obj_t) (arg2378_3752);
		  aux_7395 =
		     (object_bglt) (new2032_3750);
		  OBJECT_WIDENING_SET(aux_7395, aux_7397);
	       }
	    }
	    return new2032_3750;
	 }
      }
   }
}



/* _make-vector-set!-app */
obj_t 
_make_vector_set__app_54_cfa_info2(obj_t env_5641, obj_t loc_5642, obj_t type_5643, obj_t side_effect__165_5644, obj_t key_5645, obj_t fun_5646, obj_t args_5647, obj_t stack_info_255_5648, obj_t approx_5649)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 105 */
      {		/* Cfa/cinfo2.scm 105 */
	 vector_set__app_21_bglt aux_7400;
	 aux_7400 =
	    make_vector_set__app_24_cfa_info2(loc_5642,
	    (type_bglt) (type_5643), side_effect__165_5644, key_5645,
	    (var_bglt) (fun_5646), args_5647, stack_info_255_5648,
	    (approx_bglt) (approx_5649));
	 return
	    (obj_t) (aux_7400);
      }
   }
}



/* vector-set!-app-loc */
obj_t 
vector_set__app_loc_147_cfa_info2(app_bglt obj_229)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 661 */
      return
	 (((app_bglt) CREF(obj_229))->loc);
   }
}



/* _vector-set!-app-loc */
obj_t 
_vector_set__app_loc_250_cfa_info2(obj_t env_5650, obj_t obj_5651)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 661 */
      return
	 vector_set__app_loc_147_cfa_info2(
	 (app_bglt) (obj_5651));
   }
}



/* vector-set!-app-type-set! */
obj_t 
vector_set__app_type_set__199_cfa_info2(app_bglt obj_230, type_bglt val2022_231)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 105 */
      return
	 ((((app_bglt) CREF(obj_230))->type) = ((type_bglt) val2022_231), BUNSPEC);
   }
}



/* _vector-set!-app-type-set! */
obj_t 
_vector_set__app_type_set__61_cfa_info2(obj_t env_5652, obj_t obj_5653, obj_t val2022_5654)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 105 */
      return
	 vector_set__app_type_set__199_cfa_info2(
	 (app_bglt) (obj_5653),
	 (type_bglt) (val2022_5654));
   }
}



/* vector-set!-app-type */
type_bglt 
vector_set__app_type_116_cfa_info2(app_bglt obj_232)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 105 */
      return
	 (((app_bglt) CREF(obj_232))->type);
   }
}



/* _vector-set!-app-type */
obj_t 
_vector_set__app_type_95_cfa_info2(obj_t env_5655, obj_t obj_5656)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 105 */
      {		/* Cfa/cinfo2.scm 105 */
	 type_bglt aux_7414;
	 aux_7414 =
	    vector_set__app_type_116_cfa_info2(
	    (app_bglt) (obj_5656));
	 return
	    (obj_t) (aux_7414);
      }
   }
}



/* vector-set!-app-side-effect?-set! */
obj_t 
vector_set__app_side_effect__set__230_cfa_info2(app_bglt obj_233, obj_t val2023_234)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 669 */
      return
	 ((((app_bglt) CREF(obj_233))->side_effect__165) = ((obj_t) val2023_234), BUNSPEC);
   }
}



/* _vector-set!-app-side-effect?-set! */
obj_t 
_vector_set__app_side_effect__set__126_cfa_info2(obj_t env_5657, obj_t obj_5658, obj_t val2023_5659)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 669 */
      return
	 vector_set__app_side_effect__set__230_cfa_info2(
	 (app_bglt) (obj_5658), val2023_5659);
   }
}



/* vector-set!-app-side-effect? */
obj_t 
vector_set__app_side_effect__60_cfa_info2(app_bglt obj_235)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 669 */
      return
	 (((app_bglt) CREF(obj_235))->side_effect__165);
   }
}



/* _vector-set!-app-side-effect? */
obj_t 
_vector_set__app_side_effect__178_cfa_info2(obj_t env_5660, obj_t obj_5661)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 669 */
      return
	 vector_set__app_side_effect__60_cfa_info2(
	 (app_bglt) (obj_5661));
   }
}



/* vector-set!-app-key-set! */
obj_t 
vector_set__app_key_set__63_cfa_info2(app_bglt obj_236, obj_t val2024_237)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 673 */
      return
	 ((((app_bglt) CREF(obj_236))->key) = ((obj_t) val2024_237), BUNSPEC);
   }
}



/* _vector-set!-app-key-set!2882 */
obj_t 
_vector_set__app_key_set_2882_126_cfa_info2(obj_t env_5662, obj_t obj_5663, obj_t val2024_5664)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 673 */
      return
	 vector_set__app_key_set__63_cfa_info2(
	 (app_bglt) (obj_5663), val2024_5664);
   }
}



/* vector-set!-app-key */
obj_t 
vector_set__app_key_77_cfa_info2(app_bglt obj_238)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 673 */
      return
	 (((app_bglt) CREF(obj_238))->key);
   }
}



/* _vector-set!-app-key2883 */
obj_t 
_vector_set__app_key2883_59_cfa_info2(obj_t env_5665, obj_t obj_5666)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 673 */
      return
	 vector_set__app_key_77_cfa_info2(
	 (app_bglt) (obj_5666));
   }
}



/* vector-set!-app-fun-set! */
obj_t 
vector_set__app_fun_set__135_cfa_info2(app_bglt obj_239, var_bglt val2025_240)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 105 */
      return
	 ((((app_bglt) CREF(obj_239))->fun) = ((var_bglt) val2025_240), BUNSPEC);
   }
}



/* _vector-set!-app-fun-set! */
obj_t 
_vector_set__app_fun_set__2_cfa_info2(obj_t env_5667, obj_t obj_5668, obj_t val2025_5669)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 105 */
      return
	 vector_set__app_fun_set__135_cfa_info2(
	 (app_bglt) (obj_5668),
	 (var_bglt) (val2025_5669));
   }
}



/* vector-set!-app-fun */
var_bglt 
vector_set__app_fun_134_cfa_info2(app_bglt obj_241)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 105 */
      return
	 (((app_bglt) CREF(obj_241))->fun);
   }
}



/* _vector-set!-app-fun */
obj_t 
_vector_set__app_fun_180_cfa_info2(obj_t env_5670, obj_t obj_5671)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 105 */
      {		/* Cfa/cinfo2.scm 105 */
	 var_bglt aux_7435;
	 aux_7435 =
	    vector_set__app_fun_134_cfa_info2(
	    (app_bglt) (obj_5671));
	 return
	    (obj_t) (aux_7435);
      }
   }
}



/* vector-set!-app-args-set! */
obj_t 
vector_set__app_args_set__4_cfa_info2(app_bglt obj_242, obj_t val2026_243)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 105 */
      return
	 ((((app_bglt) CREF(obj_242))->args) = ((obj_t) val2026_243), BUNSPEC);
   }
}



/* _vector-set!-app-args-set! */
obj_t 
_vector_set__app_args_set__11_cfa_info2(obj_t env_5672, obj_t obj_5673, obj_t val2026_5674)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 105 */
      return
	 vector_set__app_args_set__4_cfa_info2(
	 (app_bglt) (obj_5673), val2026_5674);
   }
}



/* vector-set!-app-args */
obj_t 
vector_set__app_args_237_cfa_info2(app_bglt obj_244)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 105 */
      return
	 (((app_bglt) CREF(obj_244))->args);
   }
}



/* _vector-set!-app-args */
obj_t 
_vector_set__app_args_118_cfa_info2(obj_t env_5675, obj_t obj_5676)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 105 */
      return
	 vector_set__app_args_237_cfa_info2(
	 (app_bglt) (obj_5676));
   }
}



/* vector-set!-app-stack-info-set! */
obj_t 
vector_set__app_stack_info_set__132_cfa_info2(app_bglt obj_245, obj_t val2027_246)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 704 */
      return
	 ((((app_bglt) CREF(obj_245))->stack_info_255) = ((obj_t) val2027_246), BUNSPEC);
   }
}



/* _vector-set!-app-stack-info-set! */
obj_t 
_vector_set__app_stack_info_set__100_cfa_info2(obj_t env_5677, obj_t obj_5678, obj_t val2027_5679)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 704 */
      return
	 vector_set__app_stack_info_set__132_cfa_info2(
	 (app_bglt) (obj_5678), val2027_5679);
   }
}



/* vector-set!-app-stack-info */
obj_t 
vector_set__app_stack_info_174_cfa_info2(app_bglt obj_247)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 704 */
      return
	 (((app_bglt) CREF(obj_247))->stack_info_255);
   }
}



/* _vector-set!-app-stack-info */
obj_t 
_vector_set__app_stack_info_176_cfa_info2(obj_t env_5680, obj_t obj_5681)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 704 */
      return
	 vector_set__app_stack_info_174_cfa_info2(
	 (app_bglt) (obj_5681));
   }
}



/* vector-set!-app-approx */
approx_bglt 
vector_set__app_approx_61_cfa_info2(vector_set__app_21_bglt obj_248)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 105 */
      {
	 obj_t aux_7451;
	 {	/* Cfa/cinfo2.scm 105 */
	    object_bglt aux_7452;
	    aux_7452 =
	       (object_bglt) (obj_248);
	    aux_7451 =
	       OBJECT_WIDENING(aux_7452);
	 }
	 return
	    (((vector_set__app_21_bglt) CREF(aux_7451))->approx);
      }
   }
}



/* _vector-set!-app-approx */
obj_t 
_vector_set__app_approx_118_cfa_info2(obj_t env_5682, obj_t obj_5683)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 105 */
      {		/* Cfa/cinfo2.scm 105 */
	 approx_bglt aux_7456;
	 aux_7456 =
	    vector_set__app_approx_61_cfa_info2(
	    (vector_set__app_21_bglt) (obj_5683));
	 return
	    (obj_t) (aux_7456);
      }
   }
}



/* allocate-vector-ref-app */
app_bglt 
allocate_vector_ref_app_0_cfa_info2()
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 104 */
      {		/* Cfa/cinfo2.scm 104 */
	 app_bglt new2015_2337;
	 new2015_2337 =
	    ((app_bglt) BREF(GC_MALLOC(sizeof(struct app))));
	 {	/* Cfa/cinfo2.scm 104 */
	    long arg2379_2338;
	    arg2379_2338 =
	       class_num_218___object(vector_ref_app_195_cfa_info2);
	    {	/* Cfa/cinfo2.scm 104 */
	       obj_t obj_3778;
	       obj_3778 =
		  (obj_t) (new2015_2337);
	       (((obj_t) CREF(obj_3778))->header = MAKE_HEADER(arg2379_2338, 0), BUNSPEC);
	    }
	 }
	 {	/* Cfa/cinfo2.scm 104 */
	    object_bglt aux_7464;
	    aux_7464 =
	       (object_bglt) (new2015_2337);
	    OBJECT_WIDENING_SET(aux_7464, BFALSE);
	 }
	 return new2015_2337;
      }
   }
}



/* _allocate-vector-ref-app */
obj_t 
_allocate_vector_ref_app_194_cfa_info2(obj_t env_5323)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 104 */
      {		/* Cfa/cinfo2.scm 104 */
	 app_bglt aux_7467;
	 aux_7467 =
	    allocate_vector_ref_app_0_cfa_info2();
	 return
	    (obj_t) (aux_7467);
      }
   }
}



/* vector-ref-app? */
bool_t 
vector_ref_app__203_cfa_info2(obj_t obj_252)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 104 */
      return
	 is_a__118___object(obj_252, vector_ref_app_195_cfa_info2);
   }
}



/* _vector-ref-app? */
obj_t 
_vector_ref_app__210_cfa_info2(obj_t env_5684, obj_t obj_5685)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 104 */
      {		/* Cfa/cinfo2.scm 104 */
	 bool_t aux_7471;
	 aux_7471 =
	    vector_ref_app__203_cfa_info2(obj_5685);
	 return
	    BBOOL(aux_7471);
      }
   }
}



/* widening-vector-ref-app */
vector_ref_app_195_bglt 
widening_vector_ref_app_88_cfa_info2(approx_bglt approx_253)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 104 */
      {		/* Cfa/cinfo2.scm 104 */
	 vector_ref_app_195_bglt new2010_3780;
	 new2010_3780 =
	    ((vector_ref_app_195_bglt) BREF(GC_MALLOC(sizeof(struct vector_ref_app_195))));
	 ((((vector_ref_app_195_bglt) CREF(new2010_3780))->approx) = ((approx_bglt) approx_253), BUNSPEC);
	 return new2010_3780;
      }
   }
}



/* _widening-vector-ref-app2884 */
obj_t 
_widening_vector_ref_app2884_167_cfa_info2(obj_t env_5686, obj_t approx_5687)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 104 */
      {		/* Cfa/cinfo2.scm 104 */
	 vector_ref_app_195_bglt aux_7476;
	 aux_7476 =
	    widening_vector_ref_app_88_cfa_info2(
	    (approx_bglt) (approx_5687));
	 return
	    (obj_t) (aux_7476);
      }
   }
}



/* make-vector-ref-app */
vector_ref_app_195_bglt 
make_vector_ref_app_105_cfa_info2(obj_t loc_254, type_bglt type_255, obj_t side_effect__165_256, obj_t key_257, var_bglt fun_258, obj_t args_259, obj_t stack_info_255_260, approx_bglt approx_261)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 104 */
      {		/* Cfa/cinfo2.scm 104 */
	 app_bglt aux2013_3782;
	 {	/* Cfa/cinfo2.scm 104 */
	    app_bglt res2821_3804;
	    {	/* ./Ast/node.scm 698 */
	       app_bglt new1248_3793;
	       new1248_3793 =
		  ((app_bglt) BREF(GC_MALLOC(sizeof(struct app))));
	       {	/* ./Ast/node.scm 698 */
		  long arg2541_3794;
		  arg2541_3794 =
		     class_num_218___object(app_ast_node);
		  {	/* ./Ast/node.scm 698 */
		     obj_t obj_3802;
		     obj_3802 =
			(obj_t) (new1248_3793);
		     (((obj_t) CREF(obj_3802))->header = MAKE_HEADER(arg2541_3794, 0), BUNSPEC);
		  }
	       }
	       {	/* ./Ast/node.scm 698 */
		  object_bglt aux_7484;
		  aux_7484 =
		     (object_bglt) (new1248_3793);
		  OBJECT_WIDENING_SET(aux_7484, BFALSE);
	       }
	       ((((app_bglt) CREF(new1248_3793))->loc) = ((obj_t) loc_254), BUNSPEC);
	       ((((app_bglt) CREF(new1248_3793))->type) = ((type_bglt) type_255), BUNSPEC);
	       ((((app_bglt) CREF(new1248_3793))->side_effect__165) = ((obj_t) side_effect__165_256), BUNSPEC);
	       ((((app_bglt) CREF(new1248_3793))->key) = ((obj_t) key_257), BUNSPEC);
	       ((((app_bglt) CREF(new1248_3793))->fun) = ((var_bglt) fun_258), BUNSPEC);
	       ((((app_bglt) CREF(new1248_3793))->args) = ((obj_t) args_259), BUNSPEC);
	       ((((app_bglt) CREF(new1248_3793))->stack_info_255) = ((obj_t) stack_info_255_260), BUNSPEC);
	       res2821_3804 = new1248_3793;
	    }
	    aux2013_3782 = res2821_3804;
	 }
	 {	/* Cfa/cinfo2.scm 104 */
	    vector_ref_app_195_bglt new2014_3783;
	    new2014_3783 =
	       ((vector_ref_app_195_bglt) (aux2013_3782));
	    {	/* Cfa/cinfo2.scm 104 */
	       long arg2380_3784;
	       arg2380_3784 =
		  class_num_218___object(vector_ref_app_195_cfa_info2);
	       {	/* Cfa/cinfo2.scm 104 */
		  obj_t obj_3805;
		  obj_3805 =
		     (obj_t) (new2014_3783);
		  (((obj_t) CREF(obj_3805))->header = MAKE_HEADER(arg2380_3784, 0), BUNSPEC);
	       }
	    }
	    {	/* Cfa/cinfo2.scm 104 */
	       vector_ref_app_195_bglt arg2381_3785;
	       {	/* Cfa/cinfo2.scm 104 */
		  vector_ref_app_195_bglt res2822_3810;
		  {	/* Cfa/cinfo2.scm 104 */
		     vector_ref_app_195_bglt new2010_3808;
		     new2010_3808 =
			((vector_ref_app_195_bglt) BREF(GC_MALLOC(sizeof(struct vector_ref_app_195))));
		     ((((vector_ref_app_195_bglt) CREF(new2010_3808))->approx) = ((approx_bglt) approx_261), BUNSPEC);
		     res2822_3810 = new2010_3808;
		  }
		  arg2381_3785 = res2822_3810;
	       }
	       {	/* Cfa/cinfo2.scm 104 */
		  obj_t aux_7502;
		  object_bglt aux_7500;
		  aux_7502 =
		     (obj_t) (arg2381_3785);
		  aux_7500 =
		     (object_bglt) (new2014_3783);
		  OBJECT_WIDENING_SET(aux_7500, aux_7502);
	       }
	    }
	    return new2014_3783;
	 }
      }
   }
}



/* _make-vector-ref-app */
obj_t 
_make_vector_ref_app_226_cfa_info2(obj_t env_5688, obj_t loc_5689, obj_t type_5690, obj_t side_effect__165_5691, obj_t key_5692, obj_t fun_5693, obj_t args_5694, obj_t stack_info_255_5695, obj_t approx_5696)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 104 */
      {		/* Cfa/cinfo2.scm 104 */
	 vector_ref_app_195_bglt aux_7505;
	 aux_7505 =
	    make_vector_ref_app_105_cfa_info2(loc_5689,
	    (type_bglt) (type_5690), side_effect__165_5691, key_5692,
	    (var_bglt) (fun_5693), args_5694, stack_info_255_5695,
	    (approx_bglt) (approx_5696));
	 return
	    (obj_t) (aux_7505);
      }
   }
}



/* vector-ref-app-loc */
obj_t 
vector_ref_app_loc_223_cfa_info2(app_bglt obj_262)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 661 */
      return
	 (((app_bglt) CREF(obj_262))->loc);
   }
}



/* _vector-ref-app-loc */
obj_t 
_vector_ref_app_loc_62_cfa_info2(obj_t env_5697, obj_t obj_5698)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 661 */
      return
	 vector_ref_app_loc_223_cfa_info2(
	 (app_bglt) (obj_5698));
   }
}



/* vector-ref-app-type-set! */
obj_t 
vector_ref_app_type_set__10_cfa_info2(app_bglt obj_263, type_bglt val2004_264)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 104 */
      return
	 ((((app_bglt) CREF(obj_263))->type) = ((type_bglt) val2004_264), BUNSPEC);
   }
}



/* _vector-ref-app-type-set! */
obj_t 
_vector_ref_app_type_set__190_cfa_info2(obj_t env_5699, obj_t obj_5700, obj_t val2004_5701)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 104 */
      return
	 vector_ref_app_type_set__10_cfa_info2(
	 (app_bglt) (obj_5700),
	 (type_bglt) (val2004_5701));
   }
}



/* vector-ref-app-type */
type_bglt 
vector_ref_app_type_35_cfa_info2(app_bglt obj_265)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 104 */
      return
	 (((app_bglt) CREF(obj_265))->type);
   }
}



/* _vector-ref-app-type */
obj_t 
_vector_ref_app_type_64_cfa_info2(obj_t env_5702, obj_t obj_5703)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 104 */
      {		/* Cfa/cinfo2.scm 104 */
	 type_bglt aux_7519;
	 aux_7519 =
	    vector_ref_app_type_35_cfa_info2(
	    (app_bglt) (obj_5703));
	 return
	    (obj_t) (aux_7519);
      }
   }
}



/* vector-ref-app-side-effect?-set! */
obj_t 
vector_ref_app_side_effect__set__180_cfa_info2(app_bglt obj_266, obj_t val2005_267)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 669 */
      return
	 ((((app_bglt) CREF(obj_266))->side_effect__165) = ((obj_t) val2005_267), BUNSPEC);
   }
}



/* _vector-ref-app-side-effect?-set! */
obj_t 
_vector_ref_app_side_effect__set__129_cfa_info2(obj_t env_5704, obj_t obj_5705, obj_t val2005_5706)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 669 */
      return
	 vector_ref_app_side_effect__set__180_cfa_info2(
	 (app_bglt) (obj_5705), val2005_5706);
   }
}



/* vector-ref-app-side-effect? */
obj_t 
vector_ref_app_side_effect__111_cfa_info2(app_bglt obj_268)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 669 */
      return
	 (((app_bglt) CREF(obj_268))->side_effect__165);
   }
}



/* _vector-ref-app-side-effect? */
obj_t 
_vector_ref_app_side_effect__234_cfa_info2(obj_t env_5707, obj_t obj_5708)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 669 */
      return
	 vector_ref_app_side_effect__111_cfa_info2(
	 (app_bglt) (obj_5708));
   }
}



/* vector-ref-app-key-set! */
obj_t 
vector_ref_app_key_set__80_cfa_info2(app_bglt obj_269, obj_t val2006_270)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 673 */
      return
	 ((((app_bglt) CREF(obj_269))->key) = ((obj_t) val2006_270), BUNSPEC);
   }
}



/* _vector-ref-app-key-set!2885 */
obj_t 
_vector_ref_app_key_set_2885_104_cfa_info2(obj_t env_5709, obj_t obj_5710, obj_t val2006_5711)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 673 */
      return
	 vector_ref_app_key_set__80_cfa_info2(
	 (app_bglt) (obj_5710), val2006_5711);
   }
}



/* vector-ref-app-key */
obj_t 
vector_ref_app_key_24_cfa_info2(app_bglt obj_271)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 673 */
      return
	 (((app_bglt) CREF(obj_271))->key);
   }
}



/* _vector-ref-app-key2886 */
obj_t 
_vector_ref_app_key2886_186_cfa_info2(obj_t env_5712, obj_t obj_5713)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 673 */
      return
	 vector_ref_app_key_24_cfa_info2(
	 (app_bglt) (obj_5713));
   }
}



/* vector-ref-app-fun-set! */
obj_t 
vector_ref_app_fun_set__119_cfa_info2(app_bglt obj_272, var_bglt val2007_273)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 104 */
      return
	 ((((app_bglt) CREF(obj_272))->fun) = ((var_bglt) val2007_273), BUNSPEC);
   }
}



/* _vector-ref-app-fun-set! */
obj_t 
_vector_ref_app_fun_set__206_cfa_info2(obj_t env_5714, obj_t obj_5715, obj_t val2007_5716)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 104 */
      return
	 vector_ref_app_fun_set__119_cfa_info2(
	 (app_bglt) (obj_5715),
	 (var_bglt) (val2007_5716));
   }
}



/* vector-ref-app-fun */
var_bglt 
vector_ref_app_fun_217_cfa_info2(app_bglt obj_274)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 104 */
      return
	 (((app_bglt) CREF(obj_274))->fun);
   }
}



/* _vector-ref-app-fun */
obj_t 
_vector_ref_app_fun_19_cfa_info2(obj_t env_5717, obj_t obj_5718)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 104 */
      {		/* Cfa/cinfo2.scm 104 */
	 var_bglt aux_7540;
	 aux_7540 =
	    vector_ref_app_fun_217_cfa_info2(
	    (app_bglt) (obj_5718));
	 return
	    (obj_t) (aux_7540);
      }
   }
}



/* vector-ref-app-args-set! */
obj_t 
vector_ref_app_args_set__176_cfa_info2(app_bglt obj_275, obj_t val2008_276)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 104 */
      return
	 ((((app_bglt) CREF(obj_275))->args) = ((obj_t) val2008_276), BUNSPEC);
   }
}



/* _vector-ref-app-args-set! */
obj_t 
_vector_ref_app_args_set__180_cfa_info2(obj_t env_5719, obj_t obj_5720, obj_t val2008_5721)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 104 */
      return
	 vector_ref_app_args_set__176_cfa_info2(
	 (app_bglt) (obj_5720), val2008_5721);
   }
}



/* vector-ref-app-args */
obj_t 
vector_ref_app_args_194_cfa_info2(app_bglt obj_277)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 104 */
      return
	 (((app_bglt) CREF(obj_277))->args);
   }
}



/* _vector-ref-app-args */
obj_t 
_vector_ref_app_args_111_cfa_info2(obj_t env_5722, obj_t obj_5723)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 104 */
      return
	 vector_ref_app_args_194_cfa_info2(
	 (app_bglt) (obj_5723));
   }
}



/* vector-ref-app-stack-info-set! */
obj_t 
vector_ref_app_stack_info_set__142_cfa_info2(app_bglt obj_278, obj_t val2009_279)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 704 */
      return
	 ((((app_bglt) CREF(obj_278))->stack_info_255) = ((obj_t) val2009_279), BUNSPEC);
   }
}



/* _vector-ref-app-stack-info-set! */
obj_t 
_vector_ref_app_stack_info_set__176_cfa_info2(obj_t env_5724, obj_t obj_5725, obj_t val2009_5726)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 704 */
      return
	 vector_ref_app_stack_info_set__142_cfa_info2(
	 (app_bglt) (obj_5725), val2009_5726);
   }
}



/* vector-ref-app-stack-info */
obj_t 
vector_ref_app_stack_info_39_cfa_info2(app_bglt obj_280)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 704 */
      return
	 (((app_bglt) CREF(obj_280))->stack_info_255);
   }
}



/* _vector-ref-app-stack-info */
obj_t 
_vector_ref_app_stack_info_194_cfa_info2(obj_t env_5727, obj_t obj_5728)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 704 */
      return
	 vector_ref_app_stack_info_39_cfa_info2(
	 (app_bglt) (obj_5728));
   }
}



/* vector-ref-app-approx */
approx_bglt 
vector_ref_app_approx_240_cfa_info2(vector_ref_app_195_bglt obj_281)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 104 */
      {
	 obj_t aux_7556;
	 {	/* Cfa/cinfo2.scm 104 */
	    object_bglt aux_7557;
	    aux_7557 =
	       (object_bglt) (obj_281);
	    aux_7556 =
	       OBJECT_WIDENING(aux_7557);
	 }
	 return
	    (((vector_ref_app_195_bglt) CREF(aux_7556))->approx);
      }
   }
}



/* _vector-ref-app-approx */
obj_t 
_vector_ref_app_approx_209_cfa_info2(obj_t env_5729, obj_t obj_5730)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 104 */
      {		/* Cfa/cinfo2.scm 104 */
	 approx_bglt aux_7561;
	 aux_7561 =
	    vector_ref_app_approx_240_cfa_info2(
	    (vector_ref_app_195_bglt) (obj_5730));
	 return
	    (obj_t) (aux_7561);
      }
   }
}



/* allocate-create-vector-app */
app_bglt 
allocate_create_vector_app_89_cfa_info2()
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 87 */
      {		/* Cfa/cinfo2.scm 87 */
	 app_bglt new1997_2345;
	 new1997_2345 =
	    ((app_bglt) BREF(GC_MALLOC(sizeof(struct app))));
	 {	/* Cfa/cinfo2.scm 87 */
	    long arg2382_2346;
	    arg2382_2346 =
	       class_num_218___object(create_vector_app_150_cfa_info2);
	    {	/* Cfa/cinfo2.scm 87 */
	       obj_t obj_3811;
	       obj_3811 =
		  (obj_t) (new1997_2345);
	       (((obj_t) CREF(obj_3811))->header = MAKE_HEADER(arg2382_2346, 0), BUNSPEC);
	    }
	 }
	 {	/* Cfa/cinfo2.scm 87 */
	    object_bglt aux_7569;
	    aux_7569 =
	       (object_bglt) (new1997_2345);
	    OBJECT_WIDENING_SET(aux_7569, BFALSE);
	 }
	 return new1997_2345;
      }
   }
}



/* _allocate-create-vector-app */
obj_t 
_allocate_create_vector_app_246_cfa_info2(obj_t env_5322)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 87 */
      {		/* Cfa/cinfo2.scm 87 */
	 app_bglt aux_7572;
	 aux_7572 =
	    allocate_create_vector_app_89_cfa_info2();
	 return
	    (obj_t) (aux_7572);
      }
   }
}



/* create-vector-app? */
bool_t 
create_vector_app__151_cfa_info2(obj_t obj_285)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 87 */
      return
	 is_a__118___object(obj_285, create_vector_app_150_cfa_info2);
   }
}



/* _create-vector-app? */
obj_t 
_create_vector_app__45_cfa_info2(obj_t env_5731, obj_t obj_5732)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 87 */
      {		/* Cfa/cinfo2.scm 87 */
	 bool_t aux_7576;
	 aux_7576 =
	    create_vector_app__151_cfa_info2(obj_5732);
	 return
	    BBOOL(aux_7576);
      }
   }
}



/* widening-create-vector-app */
create_vector_app_150_bglt 
widening_create_vector_app_230_cfa_info2(approx_bglt approx_286, approx_bglt value_approx_19_287, long lost_stamp_114_288, variable_bglt owner_289, bool_t stackable__42_290, obj_t stack_stamp_31_291, bool_t seen__39_292)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 87 */
      {		/* Cfa/cinfo2.scm 87 */
	 create_vector_app_150_bglt new1986_3813;
	 new1986_3813 =
	    ((create_vector_app_150_bglt) BREF(GC_MALLOC(sizeof(struct create_vector_app_150))));
	 ((((create_vector_app_150_bglt) CREF(new1986_3813))->approx) = ((approx_bglt) approx_286), BUNSPEC);
	 ((((create_vector_app_150_bglt) CREF(new1986_3813))->value_approx_19) = ((approx_bglt) value_approx_19_287), BUNSPEC);
	 ((((create_vector_app_150_bglt) CREF(new1986_3813))->lost_stamp_114) = ((long) lost_stamp_114_288), BUNSPEC);
	 ((((create_vector_app_150_bglt) CREF(new1986_3813))->owner) = ((variable_bglt) owner_289), BUNSPEC);
	 ((((create_vector_app_150_bglt) CREF(new1986_3813))->stackable__42) = ((bool_t) stackable__42_290), BUNSPEC);
	 ((((create_vector_app_150_bglt) CREF(new1986_3813))->stack_stamp_31) = ((obj_t) stack_stamp_31_291), BUNSPEC);
	 ((((create_vector_app_150_bglt) CREF(new1986_3813))->seen__39) = ((bool_t) seen__39_292), BUNSPEC);
	 return new1986_3813;
      }
   }
}



/* _widening-create-vector-app2887 */
obj_t 
_widening_create_vector_app2887_17_cfa_info2(obj_t env_5733, obj_t approx_5734, obj_t value_approx_19_5735, obj_t lost_stamp_114_5736, obj_t owner_5737, obj_t stackable__42_5738, obj_t stack_stamp_31_5739, obj_t seen__39_5740)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 87 */
      {		/* Cfa/cinfo2.scm 87 */
	 create_vector_app_150_bglt aux_7587;
	 aux_7587 =
	    widening_create_vector_app_230_cfa_info2(
	    (approx_bglt) (approx_5734),
	    (approx_bglt) (value_approx_19_5735),
	    (long) CINT(lost_stamp_114_5736),
	    (variable_bglt) (owner_5737),
	    CBOOL(stackable__42_5738), stack_stamp_31_5739,
	    CBOOL(seen__39_5740));
	 return
	    (obj_t) (aux_7587);
      }
   }
}



/* make-create-vector-app */
create_vector_app_150_bglt 
make_create_vector_app_136_cfa_info2(obj_t loc_293, type_bglt type_294, obj_t side_effect__165_295, obj_t key_296, var_bglt fun_297, obj_t args_298, obj_t stack_info_255_299, approx_bglt approx_300, approx_bglt value_approx_19_301, long lost_stamp_114_302, variable_bglt owner_303, bool_t stackable__42_304, obj_t stack_stamp_31_305, bool_t seen__39_306)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 87 */
      {		/* Cfa/cinfo2.scm 87 */
	 app_bglt aux1995_3821;
	 {	/* Cfa/cinfo2.scm 87 */
	    app_bglt res2823_3843;
	    {	/* ./Ast/node.scm 698 */
	       app_bglt new1248_3832;
	       new1248_3832 =
		  ((app_bglt) BREF(GC_MALLOC(sizeof(struct app))));
	       {	/* ./Ast/node.scm 698 */
		  long arg2541_3833;
		  arg2541_3833 =
		     class_num_218___object(app_ast_node);
		  {	/* ./Ast/node.scm 698 */
		     obj_t obj_3841;
		     obj_3841 =
			(obj_t) (new1248_3832);
		     (((obj_t) CREF(obj_3841))->header = MAKE_HEADER(arg2541_3833, 0), BUNSPEC);
		  }
	       }
	       {	/* ./Ast/node.scm 698 */
		  object_bglt aux_7600;
		  aux_7600 =
		     (object_bglt) (new1248_3832);
		  OBJECT_WIDENING_SET(aux_7600, BFALSE);
	       }
	       ((((app_bglt) CREF(new1248_3832))->loc) = ((obj_t) loc_293), BUNSPEC);
	       ((((app_bglt) CREF(new1248_3832))->type) = ((type_bglt) type_294), BUNSPEC);
	       ((((app_bglt) CREF(new1248_3832))->side_effect__165) = ((obj_t) side_effect__165_295), BUNSPEC);
	       ((((app_bglt) CREF(new1248_3832))->key) = ((obj_t) key_296), BUNSPEC);
	       ((((app_bglt) CREF(new1248_3832))->fun) = ((var_bglt) fun_297), BUNSPEC);
	       ((((app_bglt) CREF(new1248_3832))->args) = ((obj_t) args_298), BUNSPEC);
	       ((((app_bglt) CREF(new1248_3832))->stack_info_255) = ((obj_t) stack_info_255_299), BUNSPEC);
	       res2823_3843 = new1248_3832;
	    }
	    aux1995_3821 = res2823_3843;
	 }
	 {	/* Cfa/cinfo2.scm 87 */
	    create_vector_app_150_bglt new1996_3822;
	    new1996_3822 =
	       ((create_vector_app_150_bglt) (aux1995_3821));
	    {	/* Cfa/cinfo2.scm 87 */
	       long arg2383_3823;
	       arg2383_3823 =
		  class_num_218___object(create_vector_app_150_cfa_info2);
	       {	/* Cfa/cinfo2.scm 87 */
		  obj_t obj_3844;
		  obj_3844 =
		     (obj_t) (new1996_3822);
		  (((obj_t) CREF(obj_3844))->header = MAKE_HEADER(arg2383_3823, 0), BUNSPEC);
	       }
	    }
	    {	/* Cfa/cinfo2.scm 87 */
	       create_vector_app_150_bglt arg2384_3824;
	       {	/* Cfa/cinfo2.scm 87 */
		  create_vector_app_150_bglt res2824_3861;
		  {	/* Cfa/cinfo2.scm 87 */
		     create_vector_app_150_bglt new1986_3853;
		     new1986_3853 =
			((create_vector_app_150_bglt) BREF(GC_MALLOC(sizeof(struct create_vector_app_150))));
		     ((((create_vector_app_150_bglt) CREF(new1986_3853))->approx) = ((approx_bglt) approx_300), BUNSPEC);
		     ((((create_vector_app_150_bglt) CREF(new1986_3853))->value_approx_19) = ((approx_bglt) value_approx_19_301), BUNSPEC);
		     ((((create_vector_app_150_bglt) CREF(new1986_3853))->lost_stamp_114) = ((long) lost_stamp_114_302), BUNSPEC);
		     ((((create_vector_app_150_bglt) CREF(new1986_3853))->owner) = ((variable_bglt) owner_303), BUNSPEC);
		     ((((create_vector_app_150_bglt) CREF(new1986_3853))->stackable__42) = ((bool_t) stackable__42_304), BUNSPEC);
		     ((((create_vector_app_150_bglt) CREF(new1986_3853))->stack_stamp_31) = ((obj_t) stack_stamp_31_305), BUNSPEC);
		     ((((create_vector_app_150_bglt) CREF(new1986_3853))->seen__39) = ((bool_t) seen__39_306), BUNSPEC);
		     res2824_3861 = new1986_3853;
		  }
		  arg2384_3824 = res2824_3861;
	       }
	       {	/* Cfa/cinfo2.scm 87 */
		  obj_t aux_7624;
		  object_bglt aux_7622;
		  aux_7624 =
		     (obj_t) (arg2384_3824);
		  aux_7622 =
		     (object_bglt) (new1996_3822);
		  OBJECT_WIDENING_SET(aux_7622, aux_7624);
	       }
	    }
	    return new1996_3822;
	 }
      }
   }
}



/* _make-create-vector-app */
obj_t 
_make_create_vector_app_218_cfa_info2(obj_t env_5741, obj_t loc_5742, obj_t type_5743, obj_t side_effect__165_5744, obj_t key_5745, obj_t fun_5746, obj_t args_5747, obj_t stack_info_255_5748, obj_t approx_5749, obj_t value_approx_19_5750, obj_t lost_stamp_114_5751, obj_t owner_5752, obj_t stackable__42_5753, obj_t stack_stamp_31_5754, obj_t seen__39_5755)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 87 */
      {		/* Cfa/cinfo2.scm 87 */
	 create_vector_app_150_bglt aux_7627;
	 aux_7627 =
	    make_create_vector_app_136_cfa_info2(loc_5742,
	    (type_bglt) (type_5743), side_effect__165_5744, key_5745,
	    (var_bglt) (fun_5746), args_5747, stack_info_255_5748,
	    (approx_bglt) (approx_5749),
	    (approx_bglt) (value_approx_19_5750),
	    (long) CINT(lost_stamp_114_5751),
	    (variable_bglt) (owner_5752),
	    CBOOL(stackable__42_5753), stack_stamp_31_5754,
	    CBOOL(seen__39_5755));
	 return
	    (obj_t) (aux_7627);
      }
   }
}



/* create-vector-app-loc */
obj_t 
create_vector_app_loc_246_cfa_info2(app_bglt obj_307)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 661 */
      return
	 (((app_bglt) CREF(obj_307))->loc);
   }
}



/* _create-vector-app-loc */
obj_t 
_create_vector_app_loc_52_cfa_info2(obj_t env_5756, obj_t obj_5757)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 661 */
      return
	 create_vector_app_loc_246_cfa_info2(
	 (app_bglt) (obj_5757));
   }
}



/* create-vector-app-type-set! */
obj_t 
create_vector_app_type_set__83_cfa_info2(app_bglt obj_308, type_bglt val1975_309)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 87 */
      return
	 ((((app_bglt) CREF(obj_308))->type) = ((type_bglt) val1975_309), BUNSPEC);
   }
}



/* _create-vector-app-type-set! */
obj_t 
_create_vector_app_type_set__40_cfa_info2(obj_t env_5758, obj_t obj_5759, obj_t val1975_5760)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 87 */
      return
	 create_vector_app_type_set__83_cfa_info2(
	 (app_bglt) (obj_5759),
	 (type_bglt) (val1975_5760));
   }
}



/* create-vector-app-type */
type_bglt 
create_vector_app_type_249_cfa_info2(app_bglt obj_310)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 87 */
      return
	 (((app_bglt) CREF(obj_310))->type);
   }
}



/* _create-vector-app-type */
obj_t 
_create_vector_app_type_100_cfa_info2(obj_t env_5761, obj_t obj_5762)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 87 */
      {		/* Cfa/cinfo2.scm 87 */
	 type_bglt aux_7646;
	 aux_7646 =
	    create_vector_app_type_249_cfa_info2(
	    (app_bglt) (obj_5762));
	 return
	    (obj_t) (aux_7646);
      }
   }
}



/* create-vector-app-side-effect?-set! */
obj_t 
create_vector_app_side_effect__set__150_cfa_info2(app_bglt obj_311, obj_t val1976_312)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 669 */
      return
	 ((((app_bglt) CREF(obj_311))->side_effect__165) = ((obj_t) val1976_312), BUNSPEC);
   }
}



/* _create-vector-app-side-effect?-set! */
obj_t 
_create_vector_app_side_effect__set__90_cfa_info2(obj_t env_5763, obj_t obj_5764, obj_t val1976_5765)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 669 */
      return
	 create_vector_app_side_effect__set__150_cfa_info2(
	 (app_bglt) (obj_5764), val1976_5765);
   }
}



/* create-vector-app-side-effect? */
obj_t 
create_vector_app_side_effect__33_cfa_info2(app_bglt obj_313)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 669 */
      return
	 (((app_bglt) CREF(obj_313))->side_effect__165);
   }
}



/* _create-vector-app-side-effect? */
obj_t 
_create_vector_app_side_effect__114_cfa_info2(obj_t env_5766, obj_t obj_5767)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 669 */
      return
	 create_vector_app_side_effect__33_cfa_info2(
	 (app_bglt) (obj_5767));
   }
}



/* create-vector-app-key-set! */
obj_t 
create_vector_app_key_set__126_cfa_info2(app_bglt obj_314, obj_t val1977_315)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 673 */
      return
	 ((((app_bglt) CREF(obj_314))->key) = ((obj_t) val1977_315), BUNSPEC);
   }
}



/* _create-vector-app-key-set!2888 */
obj_t 
_create_vector_app_key_set_2888_204_cfa_info2(obj_t env_5768, obj_t obj_5769, obj_t val1977_5770)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 673 */
      return
	 create_vector_app_key_set__126_cfa_info2(
	 (app_bglt) (obj_5769), val1977_5770);
   }
}



/* create-vector-app-key */
obj_t 
create_vector_app_key_178_cfa_info2(app_bglt obj_316)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 673 */
      return
	 (((app_bglt) CREF(obj_316))->key);
   }
}



/* _create-vector-app-key */
obj_t 
_create_vector_app_key_171_cfa_info2(obj_t env_5771, obj_t obj_5772)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 673 */
      return
	 create_vector_app_key_178_cfa_info2(
	 (app_bglt) (obj_5772));
   }
}



/* create-vector-app-fun-set! */
obj_t 
create_vector_app_fun_set__58_cfa_info2(app_bglt obj_317, var_bglt val1978_318)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 87 */
      return
	 ((((app_bglt) CREF(obj_317))->fun) = ((var_bglt) val1978_318), BUNSPEC);
   }
}



/* _create-vector-app-fun-set! */
obj_t 
_create_vector_app_fun_set__241_cfa_info2(obj_t env_5773, obj_t obj_5774, obj_t val1978_5775)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 87 */
      return
	 create_vector_app_fun_set__58_cfa_info2(
	 (app_bglt) (obj_5774),
	 (var_bglt) (val1978_5775));
   }
}



/* create-vector-app-fun */
var_bglt 
create_vector_app_fun_92_cfa_info2(app_bglt obj_319)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 87 */
      return
	 (((app_bglt) CREF(obj_319))->fun);
   }
}



/* _create-vector-app-fun */
obj_t 
_create_vector_app_fun_195_cfa_info2(obj_t env_5776, obj_t obj_5777)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 87 */
      {		/* Cfa/cinfo2.scm 87 */
	 var_bglt aux_7667;
	 aux_7667 =
	    create_vector_app_fun_92_cfa_info2(
	    (app_bglt) (obj_5777));
	 return
	    (obj_t) (aux_7667);
      }
   }
}



/* create-vector-app-args-set! */
obj_t 
create_vector_app_args_set__204_cfa_info2(app_bglt obj_320, obj_t val1979_321)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 87 */
      return
	 ((((app_bglt) CREF(obj_320))->args) = ((obj_t) val1979_321), BUNSPEC);
   }
}



/* _create-vector-app-args-set! */
obj_t 
_create_vector_app_args_set__48_cfa_info2(obj_t env_5778, obj_t obj_5779, obj_t val1979_5780)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 87 */
      return
	 create_vector_app_args_set__204_cfa_info2(
	 (app_bglt) (obj_5779), val1979_5780);
   }
}



/* create-vector-app-args */
obj_t 
create_vector_app_args_44_cfa_info2(app_bglt obj_322)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 87 */
      return
	 (((app_bglt) CREF(obj_322))->args);
   }
}



/* _create-vector-app-args */
obj_t 
_create_vector_app_args_132_cfa_info2(obj_t env_5781, obj_t obj_5782)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 87 */
      return
	 create_vector_app_args_44_cfa_info2(
	 (app_bglt) (obj_5782));
   }
}



/* create-vector-app-stack-info-set! */
obj_t 
create_vector_app_stack_info_set__169_cfa_info2(app_bglt obj_323, obj_t val1980_324)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 704 */
      return
	 ((((app_bglt) CREF(obj_323))->stack_info_255) = ((obj_t) val1980_324), BUNSPEC);
   }
}



/* _create-vector-app-stack-info-set! */
obj_t 
_create_vector_app_stack_info_set__184_cfa_info2(obj_t env_5783, obj_t obj_5784, obj_t val1980_5785)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 704 */
      return
	 create_vector_app_stack_info_set__169_cfa_info2(
	 (app_bglt) (obj_5784), val1980_5785);
   }
}



/* create-vector-app-stack-info */
obj_t 
create_vector_app_stack_info_51_cfa_info2(app_bglt obj_325)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 704 */
      return
	 (((app_bglt) CREF(obj_325))->stack_info_255);
   }
}



/* _create-vector-app-stack-info */
obj_t 
_create_vector_app_stack_info_181_cfa_info2(obj_t env_5786, obj_t obj_5787)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 704 */
      return
	 create_vector_app_stack_info_51_cfa_info2(
	 (app_bglt) (obj_5787));
   }
}



/* create-vector-app-approx-set! */
obj_t 
create_vector_app_approx_set__132_cfa_info2(create_vector_app_150_bglt obj_326, approx_bglt val1981_327)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 87 */
      {
	 obj_t aux_7683;
	 {	/* Cfa/cinfo2.scm 87 */
	    object_bglt aux_7684;
	    aux_7684 =
	       (object_bglt) (obj_326);
	    aux_7683 =
	       OBJECT_WIDENING(aux_7684);
	 }
	 return
	    ((((create_vector_app_150_bglt) CREF(aux_7683))->approx) = ((approx_bglt) val1981_327), BUNSPEC);
      }
   }
}



/* _create-vector-app-approx-set! */
obj_t 
_create_vector_app_approx_set__24_cfa_info2(obj_t env_5788, obj_t obj_5789, obj_t val1981_5790)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 87 */
      return
	 create_vector_app_approx_set__132_cfa_info2(
	 (create_vector_app_150_bglt) (obj_5789),
	 (approx_bglt) (val1981_5790));
   }
}



/* create-vector-app-approx */
approx_bglt 
create_vector_app_approx_174_cfa_info2(create_vector_app_150_bglt obj_328)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 87 */
      {
	 obj_t aux_7691;
	 {	/* Cfa/cinfo2.scm 87 */
	    object_bglt aux_7692;
	    aux_7692 =
	       (object_bglt) (obj_328);
	    aux_7691 =
	       OBJECT_WIDENING(aux_7692);
	 }
	 return
	    (((create_vector_app_150_bglt) CREF(aux_7691))->approx);
      }
   }
}



/* _create-vector-app-approx */
obj_t 
_create_vector_app_approx_120_cfa_info2(obj_t env_5791, obj_t obj_5792)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 87 */
      {		/* Cfa/cinfo2.scm 87 */
	 approx_bglt aux_7696;
	 aux_7696 =
	    create_vector_app_approx_174_cfa_info2(
	    (create_vector_app_150_bglt) (obj_5792));
	 return
	    (obj_t) (aux_7696);
      }
   }
}



/* create-vector-app-value-approx */
approx_bglt 
create_vector_app_value_approx_116_cfa_info2(create_vector_app_150_bglt obj_329)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 91 */
      {
	 obj_t aux_7700;
	 {	/* Cfa/cinfo2.scm 91 */
	    object_bglt aux_7701;
	    aux_7701 =
	       (object_bglt) (obj_329);
	    aux_7700 =
	       OBJECT_WIDENING(aux_7701);
	 }
	 return
	    (((create_vector_app_150_bglt) CREF(aux_7700))->value_approx_19);
      }
   }
}



/* _create-vector-app-value-approx */
obj_t 
_create_vector_app_value_approx_26_cfa_info2(obj_t env_5793, obj_t obj_5794)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 91 */
      {		/* Cfa/cinfo2.scm 91 */
	 approx_bglt aux_7705;
	 aux_7705 =
	    create_vector_app_value_approx_116_cfa_info2(
	    (create_vector_app_150_bglt) (obj_5794));
	 return
	    (obj_t) (aux_7705);
      }
   }
}



/* create-vector-app-lost-stamp-set! */
obj_t 
create_vector_app_lost_stamp_set__92_cfa_info2(create_vector_app_150_bglt obj_330, long val1982_331)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 93 */
      {
	 obj_t aux_7709;
	 {	/* Cfa/cinfo2.scm 93 */
	    object_bglt aux_7710;
	    aux_7710 =
	       (object_bglt) (obj_330);
	    aux_7709 =
	       OBJECT_WIDENING(aux_7710);
	 }
	 return
	    ((((create_vector_app_150_bglt) CREF(aux_7709))->lost_stamp_114) = ((long) val1982_331), BUNSPEC);
      }
   }
}



/* _create-vector-app-lost-stamp-set! */
obj_t 
_create_vector_app_lost_stamp_set__201_cfa_info2(obj_t env_5795, obj_t obj_5796, obj_t val1982_5797)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 93 */
      return
	 create_vector_app_lost_stamp_set__92_cfa_info2(
	 (create_vector_app_150_bglt) (obj_5796),
	 (long) CINT(val1982_5797));
   }
}



/* create-vector-app-lost-stamp */
long 
create_vector_app_lost_stamp_72_cfa_info2(create_vector_app_150_bglt obj_332)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 93 */
      {
	 obj_t aux_7717;
	 {	/* Cfa/cinfo2.scm 93 */
	    object_bglt aux_7718;
	    aux_7718 =
	       (object_bglt) (obj_332);
	    aux_7717 =
	       OBJECT_WIDENING(aux_7718);
	 }
	 return
	    (((create_vector_app_150_bglt) CREF(aux_7717))->lost_stamp_114);
      }
   }
}



/* _create-vector-app-lost-stamp */
obj_t 
_create_vector_app_lost_stamp_170_cfa_info2(obj_t env_5798, obj_t obj_5799)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 93 */
      {		/* Cfa/cinfo2.scm 93 */
	 long aux_7722;
	 aux_7722 =
	    create_vector_app_lost_stamp_72_cfa_info2(
	    (create_vector_app_150_bglt) (obj_5799));
	 return
	    BINT(aux_7722);
      }
   }
}



/* create-vector-app-owner */
variable_bglt 
create_vector_app_owner_226_cfa_info2(create_vector_app_150_bglt obj_333)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 95 */
      {
	 obj_t aux_7726;
	 {	/* Cfa/cinfo2.scm 95 */
	    object_bglt aux_7727;
	    aux_7727 =
	       (object_bglt) (obj_333);
	    aux_7726 =
	       OBJECT_WIDENING(aux_7727);
	 }
	 return
	    (((create_vector_app_150_bglt) CREF(aux_7726))->owner);
      }
   }
}



/* _create-vector-app-owner */
obj_t 
_create_vector_app_owner_147_cfa_info2(obj_t env_5800, obj_t obj_5801)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 95 */
      {		/* Cfa/cinfo2.scm 95 */
	 variable_bglt aux_7731;
	 aux_7731 =
	    create_vector_app_owner_226_cfa_info2(
	    (create_vector_app_150_bglt) (obj_5801));
	 return
	    (obj_t) (aux_7731);
      }
   }
}



/* create-vector-app-stackable?-set! */
obj_t 
create_vector_app_stackable__set__21_cfa_info2(create_vector_app_150_bglt obj_334, bool_t val1983_335)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 98 */
      {
	 obj_t aux_7735;
	 {	/* Cfa/cinfo2.scm 98 */
	    object_bglt aux_7736;
	    aux_7736 =
	       (object_bglt) (obj_334);
	    aux_7735 =
	       OBJECT_WIDENING(aux_7736);
	 }
	 return
	    ((((create_vector_app_150_bglt) CREF(aux_7735))->stackable__42) = ((bool_t) val1983_335), BUNSPEC);
      }
   }
}



/* _create-vector-app-stackable?-set! */
obj_t 
_create_vector_app_stackable__set__15_cfa_info2(obj_t env_5802, obj_t obj_5803, obj_t val1983_5804)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 98 */
      return
	 create_vector_app_stackable__set__21_cfa_info2(
	 (create_vector_app_150_bglt) (obj_5803),
	 CBOOL(val1983_5804));
   }
}



/* create-vector-app-stackable? */
bool_t 
create_vector_app_stackable__57_cfa_info2(create_vector_app_150_bglt obj_336)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 98 */
      {
	 obj_t aux_7743;
	 {	/* Cfa/cinfo2.scm 98 */
	    object_bglt aux_7744;
	    aux_7744 =
	       (object_bglt) (obj_336);
	    aux_7743 =
	       OBJECT_WIDENING(aux_7744);
	 }
	 return
	    (((create_vector_app_150_bglt) CREF(aux_7743))->stackable__42);
      }
   }
}



/* _create-vector-app-stackable? */
obj_t 
_create_vector_app_stackable__232_cfa_info2(obj_t env_5805, obj_t obj_5806)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 98 */
      {		/* Cfa/cinfo2.scm 98 */
	 bool_t aux_7748;
	 aux_7748 =
	    create_vector_app_stackable__57_cfa_info2(
	    (create_vector_app_150_bglt) (obj_5806));
	 return
	    BBOOL(aux_7748);
      }
   }
}



/* create-vector-app-stack-stamp-set! */
obj_t 
create_vector_app_stack_stamp_set__220_cfa_info2(create_vector_app_150_bglt obj_337, obj_t val1984_338)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 100 */
      {
	 obj_t aux_7752;
	 {	/* Cfa/cinfo2.scm 100 */
	    object_bglt aux_7753;
	    aux_7753 =
	       (object_bglt) (obj_337);
	    aux_7752 =
	       OBJECT_WIDENING(aux_7753);
	 }
	 return
	    ((((create_vector_app_150_bglt) CREF(aux_7752))->stack_stamp_31) = ((obj_t) val1984_338), BUNSPEC);
      }
   }
}



/* _create-vector-app-stack-stamp-set! */
obj_t 
_create_vector_app_stack_stamp_set__88_cfa_info2(obj_t env_5807, obj_t obj_5808, obj_t val1984_5809)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 100 */
      return
	 create_vector_app_stack_stamp_set__220_cfa_info2(
	 (create_vector_app_150_bglt) (obj_5808), val1984_5809);
   }
}



/* create-vector-app-stack-stamp */
obj_t 
create_vector_app_stack_stamp_255_cfa_info2(create_vector_app_150_bglt obj_339)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 100 */
      {
	 obj_t aux_7759;
	 {	/* Cfa/cinfo2.scm 100 */
	    object_bglt aux_7760;
	    aux_7760 =
	       (object_bglt) (obj_339);
	    aux_7759 =
	       OBJECT_WIDENING(aux_7760);
	 }
	 return
	    (((create_vector_app_150_bglt) CREF(aux_7759))->stack_stamp_31);
      }
   }
}



/* _create-vector-app-stack-stamp */
obj_t 
_create_vector_app_stack_stamp_254_cfa_info2(obj_t env_5810, obj_t obj_5811)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 100 */
      return
	 create_vector_app_stack_stamp_255_cfa_info2(
	 (create_vector_app_150_bglt) (obj_5811));
   }
}



/* create-vector-app-seen?-set! */
obj_t 
create_vector_app_seen__set__212_cfa_info2(create_vector_app_150_bglt obj_340, bool_t val1985_341)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 103 */
      {
	 obj_t aux_7766;
	 {	/* Cfa/cinfo2.scm 103 */
	    object_bglt aux_7767;
	    aux_7767 =
	       (object_bglt) (obj_340);
	    aux_7766 =
	       OBJECT_WIDENING(aux_7767);
	 }
	 return
	    ((((create_vector_app_150_bglt) CREF(aux_7766))->seen__39) = ((bool_t) val1985_341), BUNSPEC);
      }
   }
}



/* _create-vector-app-seen?-set! */
obj_t 
_create_vector_app_seen__set__190_cfa_info2(obj_t env_5812, obj_t obj_5813, obj_t val1985_5814)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 103 */
      return
	 create_vector_app_seen__set__212_cfa_info2(
	 (create_vector_app_150_bglt) (obj_5813),
	 CBOOL(val1985_5814));
   }
}



/* create-vector-app-seen? */
bool_t 
create_vector_app_seen__3_cfa_info2(create_vector_app_150_bglt obj_342)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 103 */
      {
	 obj_t aux_7774;
	 {	/* Cfa/cinfo2.scm 103 */
	    object_bglt aux_7775;
	    aux_7775 =
	       (object_bglt) (obj_342);
	    aux_7774 =
	       OBJECT_WIDENING(aux_7775);
	 }
	 return
	    (((create_vector_app_150_bglt) CREF(aux_7774))->seen__39);
      }
   }
}



/* _create-vector-app-seen? */
obj_t 
_create_vector_app_seen__64_cfa_info2(obj_t env_5815, obj_t obj_5816)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 103 */
      {		/* Cfa/cinfo2.scm 103 */
	 bool_t aux_7779;
	 aux_7779 =
	    create_vector_app_seen__3_cfa_info2(
	    (create_vector_app_150_bglt) (obj_5816));
	 return
	    BBOOL(aux_7779);
      }
   }
}



/* allocate-make-vector-app */
app_bglt 
allocate_make_vector_app_226_cfa_info2()
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 63 */
      {		/* Cfa/cinfo2.scm 63 */
	 app_bglt new1968_2359;
	 new1968_2359 =
	    ((app_bglt) BREF(GC_MALLOC(sizeof(struct app))));
	 {	/* Cfa/cinfo2.scm 63 */
	    long arg2385_2360;
	    arg2385_2360 =
	       class_num_218___object(make_vector_app_205_cfa_info2);
	    {	/* Cfa/cinfo2.scm 63 */
	       obj_t obj_3862;
	       obj_3862 =
		  (obj_t) (new1968_2359);
	       (((obj_t) CREF(obj_3862))->header = MAKE_HEADER(arg2385_2360, 0), BUNSPEC);
	    }
	 }
	 {	/* Cfa/cinfo2.scm 63 */
	    object_bglt aux_7787;
	    aux_7787 =
	       (object_bglt) (new1968_2359);
	    OBJECT_WIDENING_SET(aux_7787, BFALSE);
	 }
	 return new1968_2359;
      }
   }
}



/* _allocate-make-vector-app */
obj_t 
_allocate_make_vector_app_18_cfa_info2(obj_t env_5321)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 63 */
      {		/* Cfa/cinfo2.scm 63 */
	 app_bglt aux_7790;
	 aux_7790 =
	    allocate_make_vector_app_226_cfa_info2();
	 return
	    (obj_t) (aux_7790);
      }
   }
}



/* make-vector-app? */
bool_t 
make_vector_app__222_cfa_info2(obj_t obj_346)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 63 */
      return
	 is_a__118___object(obj_346, make_vector_app_205_cfa_info2);
   }
}



/* _make-vector-app? */
obj_t 
_make_vector_app__161_cfa_info2(obj_t env_5817, obj_t obj_5818)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 63 */
      {		/* Cfa/cinfo2.scm 63 */
	 bool_t aux_7794;
	 aux_7794 =
	    make_vector_app__222_cfa_info2(obj_5818);
	 return
	    BBOOL(aux_7794);
      }
   }
}



/* widening-make-vector-app */
make_vector_app_205_bglt 
widening_make_vector_app_39_cfa_info2(approx_bglt approx_347, approx_bglt value_approx_19_348, long lost_stamp_114_349, variable_bglt owner_350, bool_t stackable__42_351, obj_t stack_stamp_31_352, bool_t seen__39_353)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 63 */
      {		/* Cfa/cinfo2.scm 63 */
	 make_vector_app_205_bglt new1957_3864;
	 new1957_3864 =
	    ((make_vector_app_205_bglt) BREF(GC_MALLOC(sizeof(struct make_vector_app_205))));
	 ((((make_vector_app_205_bglt) CREF(new1957_3864))->approx) = ((approx_bglt) approx_347), BUNSPEC);
	 ((((make_vector_app_205_bglt) CREF(new1957_3864))->value_approx_19) = ((approx_bglt) value_approx_19_348), BUNSPEC);
	 ((((make_vector_app_205_bglt) CREF(new1957_3864))->lost_stamp_114) = ((long) lost_stamp_114_349), BUNSPEC);
	 ((((make_vector_app_205_bglt) CREF(new1957_3864))->owner) = ((variable_bglt) owner_350), BUNSPEC);
	 ((((make_vector_app_205_bglt) CREF(new1957_3864))->stackable__42) = ((bool_t) stackable__42_351), BUNSPEC);
	 ((((make_vector_app_205_bglt) CREF(new1957_3864))->stack_stamp_31) = ((obj_t) stack_stamp_31_352), BUNSPEC);
	 ((((make_vector_app_205_bglt) CREF(new1957_3864))->seen__39) = ((bool_t) seen__39_353), BUNSPEC);
	 return new1957_3864;
      }
   }
}



/* _widening-make-vector-app2889 */
obj_t 
_widening_make_vector_app2889_122_cfa_info2(obj_t env_5819, obj_t approx_5820, obj_t value_approx_19_5821, obj_t lost_stamp_114_5822, obj_t owner_5823, obj_t stackable__42_5824, obj_t stack_stamp_31_5825, obj_t seen__39_5826)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 63 */
      {		/* Cfa/cinfo2.scm 63 */
	 make_vector_app_205_bglt aux_7805;
	 aux_7805 =
	    widening_make_vector_app_39_cfa_info2(
	    (approx_bglt) (approx_5820),
	    (approx_bglt) (value_approx_19_5821),
	    (long) CINT(lost_stamp_114_5822),
	    (variable_bglt) (owner_5823),
	    CBOOL(stackable__42_5824), stack_stamp_31_5825,
	    CBOOL(seen__39_5826));
	 return
	    (obj_t) (aux_7805);
      }
   }
}



/* make-make-vector-app */
make_vector_app_205_bglt 
make_make_vector_app_32_cfa_info2(obj_t loc_354, type_bglt type_355, obj_t side_effect__165_356, obj_t key_357, var_bglt fun_358, obj_t args_359, obj_t stack_info_255_360, approx_bglt approx_361, approx_bglt value_approx_19_362, long lost_stamp_114_363, variable_bglt owner_364, bool_t stackable__42_365, obj_t stack_stamp_31_366, bool_t seen__39_367)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 63 */
      {		/* Cfa/cinfo2.scm 63 */
	 app_bglt aux1966_3872;
	 {	/* Cfa/cinfo2.scm 63 */
	    app_bglt res2825_3894;
	    {	/* ./Ast/node.scm 698 */
	       app_bglt new1248_3883;
	       new1248_3883 =
		  ((app_bglt) BREF(GC_MALLOC(sizeof(struct app))));
	       {	/* ./Ast/node.scm 698 */
		  long arg2541_3884;
		  arg2541_3884 =
		     class_num_218___object(app_ast_node);
		  {	/* ./Ast/node.scm 698 */
		     obj_t obj_3892;
		     obj_3892 =
			(obj_t) (new1248_3883);
		     (((obj_t) CREF(obj_3892))->header = MAKE_HEADER(arg2541_3884, 0), BUNSPEC);
		  }
	       }
	       {	/* ./Ast/node.scm 698 */
		  object_bglt aux_7818;
		  aux_7818 =
		     (object_bglt) (new1248_3883);
		  OBJECT_WIDENING_SET(aux_7818, BFALSE);
	       }
	       ((((app_bglt) CREF(new1248_3883))->loc) = ((obj_t) loc_354), BUNSPEC);
	       ((((app_bglt) CREF(new1248_3883))->type) = ((type_bglt) type_355), BUNSPEC);
	       ((((app_bglt) CREF(new1248_3883))->side_effect__165) = ((obj_t) side_effect__165_356), BUNSPEC);
	       ((((app_bglt) CREF(new1248_3883))->key) = ((obj_t) key_357), BUNSPEC);
	       ((((app_bglt) CREF(new1248_3883))->fun) = ((var_bglt) fun_358), BUNSPEC);
	       ((((app_bglt) CREF(new1248_3883))->args) = ((obj_t) args_359), BUNSPEC);
	       ((((app_bglt) CREF(new1248_3883))->stack_info_255) = ((obj_t) stack_info_255_360), BUNSPEC);
	       res2825_3894 = new1248_3883;
	    }
	    aux1966_3872 = res2825_3894;
	 }
	 {	/* Cfa/cinfo2.scm 63 */
	    make_vector_app_205_bglt new1967_3873;
	    new1967_3873 =
	       ((make_vector_app_205_bglt) (aux1966_3872));
	    {	/* Cfa/cinfo2.scm 63 */
	       long arg2386_3874;
	       arg2386_3874 =
		  class_num_218___object(make_vector_app_205_cfa_info2);
	       {	/* Cfa/cinfo2.scm 63 */
		  obj_t obj_3895;
		  obj_3895 =
		     (obj_t) (new1967_3873);
		  (((obj_t) CREF(obj_3895))->header = MAKE_HEADER(arg2386_3874, 0), BUNSPEC);
	       }
	    }
	    {	/* Cfa/cinfo2.scm 63 */
	       make_vector_app_205_bglt arg2387_3875;
	       {	/* Cfa/cinfo2.scm 63 */
		  make_vector_app_205_bglt res2826_3912;
		  {	/* Cfa/cinfo2.scm 63 */
		     make_vector_app_205_bglt new1957_3904;
		     new1957_3904 =
			((make_vector_app_205_bglt) BREF(GC_MALLOC(sizeof(struct make_vector_app_205))));
		     ((((make_vector_app_205_bglt) CREF(new1957_3904))->approx) = ((approx_bglt) approx_361), BUNSPEC);
		     ((((make_vector_app_205_bglt) CREF(new1957_3904))->value_approx_19) = ((approx_bglt) value_approx_19_362), BUNSPEC);
		     ((((make_vector_app_205_bglt) CREF(new1957_3904))->lost_stamp_114) = ((long) lost_stamp_114_363), BUNSPEC);
		     ((((make_vector_app_205_bglt) CREF(new1957_3904))->owner) = ((variable_bglt) owner_364), BUNSPEC);
		     ((((make_vector_app_205_bglt) CREF(new1957_3904))->stackable__42) = ((bool_t) stackable__42_365), BUNSPEC);
		     ((((make_vector_app_205_bglt) CREF(new1957_3904))->stack_stamp_31) = ((obj_t) stack_stamp_31_366), BUNSPEC);
		     ((((make_vector_app_205_bglt) CREF(new1957_3904))->seen__39) = ((bool_t) seen__39_367), BUNSPEC);
		     res2826_3912 = new1957_3904;
		  }
		  arg2387_3875 = res2826_3912;
	       }
	       {	/* Cfa/cinfo2.scm 63 */
		  obj_t aux_7842;
		  object_bglt aux_7840;
		  aux_7842 =
		     (obj_t) (arg2387_3875);
		  aux_7840 =
		     (object_bglt) (new1967_3873);
		  OBJECT_WIDENING_SET(aux_7840, aux_7842);
	       }
	    }
	    return new1967_3873;
	 }
      }
   }
}



/* _make-make-vector-app */
obj_t 
_make_make_vector_app_59_cfa_info2(obj_t env_5827, obj_t loc_5828, obj_t type_5829, obj_t side_effect__165_5830, obj_t key_5831, obj_t fun_5832, obj_t args_5833, obj_t stack_info_255_5834, obj_t approx_5835, obj_t value_approx_19_5836, obj_t lost_stamp_114_5837, obj_t owner_5838, obj_t stackable__42_5839, obj_t stack_stamp_31_5840, obj_t seen__39_5841)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 63 */
      {		/* Cfa/cinfo2.scm 63 */
	 make_vector_app_205_bglt aux_7845;
	 aux_7845 =
	    make_make_vector_app_32_cfa_info2(loc_5828,
	    (type_bglt) (type_5829), side_effect__165_5830, key_5831,
	    (var_bglt) (fun_5832), args_5833, stack_info_255_5834,
	    (approx_bglt) (approx_5835),
	    (approx_bglt) (value_approx_19_5836),
	    (long) CINT(lost_stamp_114_5837),
	    (variable_bglt) (owner_5838),
	    CBOOL(stackable__42_5839), stack_stamp_31_5840,
	    CBOOL(seen__39_5841));
	 return
	    (obj_t) (aux_7845);
      }
   }
}



/* make-vector-app-loc */
obj_t 
make_vector_app_loc_140_cfa_info2(app_bglt obj_368)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 661 */
      return
	 (((app_bglt) CREF(obj_368))->loc);
   }
}



/* _make-vector-app-loc */
obj_t 
_make_vector_app_loc_189_cfa_info2(obj_t env_5842, obj_t obj_5843)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 661 */
      return
	 make_vector_app_loc_140_cfa_info2(
	 (app_bglt) (obj_5843));
   }
}



/* make-vector-app-type-set! */
obj_t 
make_vector_app_type_set__45_cfa_info2(app_bglt obj_369, type_bglt val1946_370)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 63 */
      return
	 ((((app_bglt) CREF(obj_369))->type) = ((type_bglt) val1946_370), BUNSPEC);
   }
}



/* _make-vector-app-type-set! */
obj_t 
_make_vector_app_type_set__146_cfa_info2(obj_t env_5844, obj_t obj_5845, obj_t val1946_5846)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 63 */
      return
	 make_vector_app_type_set__45_cfa_info2(
	 (app_bglt) (obj_5845),
	 (type_bglt) (val1946_5846));
   }
}



/* make-vector-app-type */
type_bglt 
make_vector_app_type_150_cfa_info2(app_bglt obj_371)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 63 */
      return
	 (((app_bglt) CREF(obj_371))->type);
   }
}



/* _make-vector-app-type */
obj_t 
_make_vector_app_type_115_cfa_info2(obj_t env_5847, obj_t obj_5848)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 63 */
      {		/* Cfa/cinfo2.scm 63 */
	 type_bglt aux_7864;
	 aux_7864 =
	    make_vector_app_type_150_cfa_info2(
	    (app_bglt) (obj_5848));
	 return
	    (obj_t) (aux_7864);
      }
   }
}



/* make-vector-app-side-effect?-set! */
obj_t 
make_vector_app_side_effect__set__75_cfa_info2(app_bglt obj_372, obj_t val1947_373)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 669 */
      return
	 ((((app_bglt) CREF(obj_372))->side_effect__165) = ((obj_t) val1947_373), BUNSPEC);
   }
}



/* _make-vector-app-side-effect?-set! */
obj_t 
_make_vector_app_side_effect__set__44_cfa_info2(obj_t env_5849, obj_t obj_5850, obj_t val1947_5851)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 669 */
      return
	 make_vector_app_side_effect__set__75_cfa_info2(
	 (app_bglt) (obj_5850), val1947_5851);
   }
}



/* make-vector-app-side-effect? */
obj_t 
make_vector_app_side_effect__209_cfa_info2(app_bglt obj_374)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 669 */
      return
	 (((app_bglt) CREF(obj_374))->side_effect__165);
   }
}



/* _make-vector-app-side-effect? */
obj_t 
_make_vector_app_side_effect__105_cfa_info2(obj_t env_5852, obj_t obj_5853)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 669 */
      return
	 make_vector_app_side_effect__209_cfa_info2(
	 (app_bglt) (obj_5853));
   }
}



/* make-vector-app-key-set! */
obj_t 
make_vector_app_key_set__25_cfa_info2(app_bglt obj_375, obj_t val1948_376)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 673 */
      return
	 ((((app_bglt) CREF(obj_375))->key) = ((obj_t) val1948_376), BUNSPEC);
   }
}



/* _make-vector-app-key-set!2890 */
obj_t 
_make_vector_app_key_set_2890_13_cfa_info2(obj_t env_5854, obj_t obj_5855, obj_t val1948_5856)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 673 */
      return
	 make_vector_app_key_set__25_cfa_info2(
	 (app_bglt) (obj_5855), val1948_5856);
   }
}



/* make-vector-app-key */
obj_t 
make_vector_app_key_103_cfa_info2(app_bglt obj_377)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 673 */
      return
	 (((app_bglt) CREF(obj_377))->key);
   }
}



/* _make-vector-app-key */
obj_t 
_make_vector_app_key_198_cfa_info2(obj_t env_5857, obj_t obj_5858)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 673 */
      return
	 make_vector_app_key_103_cfa_info2(
	 (app_bglt) (obj_5858));
   }
}



/* make-vector-app-fun-set! */
obj_t 
make_vector_app_fun_set__56_cfa_info2(app_bglt obj_378, var_bglt val1949_379)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 63 */
      return
	 ((((app_bglt) CREF(obj_378))->fun) = ((var_bglt) val1949_379), BUNSPEC);
   }
}



/* _make-vector-app-fun-set! */
obj_t 
_make_vector_app_fun_set__5_cfa_info2(obj_t env_5859, obj_t obj_5860, obj_t val1949_5861)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 63 */
      return
	 make_vector_app_fun_set__56_cfa_info2(
	 (app_bglt) (obj_5860),
	 (var_bglt) (val1949_5861));
   }
}



/* make-vector-app-fun */
var_bglt 
make_vector_app_fun_121_cfa_info2(app_bglt obj_380)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 63 */
      return
	 (((app_bglt) CREF(obj_380))->fun);
   }
}



/* _make-vector-app-fun */
obj_t 
_make_vector_app_fun_245_cfa_info2(obj_t env_5862, obj_t obj_5863)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 63 */
      {		/* Cfa/cinfo2.scm 63 */
	 var_bglt aux_7885;
	 aux_7885 =
	    make_vector_app_fun_121_cfa_info2(
	    (app_bglt) (obj_5863));
	 return
	    (obj_t) (aux_7885);
      }
   }
}



/* make-vector-app-args-set! */
obj_t 
make_vector_app_args_set__241_cfa_info2(app_bglt obj_381, obj_t val1950_382)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 63 */
      return
	 ((((app_bglt) CREF(obj_381))->args) = ((obj_t) val1950_382), BUNSPEC);
   }
}



/* _make-vector-app-args-set! */
obj_t 
_make_vector_app_args_set__216_cfa_info2(obj_t env_5864, obj_t obj_5865, obj_t val1950_5866)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 63 */
      return
	 make_vector_app_args_set__241_cfa_info2(
	 (app_bglt) (obj_5865), val1950_5866);
   }
}



/* make-vector-app-args */
obj_t 
make_vector_app_args_195_cfa_info2(app_bglt obj_383)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 63 */
      return
	 (((app_bglt) CREF(obj_383))->args);
   }
}



/* _make-vector-app-args */
obj_t 
_make_vector_app_args_191_cfa_info2(obj_t env_5867, obj_t obj_5868)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 63 */
      return
	 make_vector_app_args_195_cfa_info2(
	 (app_bglt) (obj_5868));
   }
}



/* make-vector-app-stack-info-set! */
obj_t 
make_vector_app_stack_info_set__239_cfa_info2(app_bglt obj_384, obj_t val1951_385)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 704 */
      return
	 ((((app_bglt) CREF(obj_384))->stack_info_255) = ((obj_t) val1951_385), BUNSPEC);
   }
}



/* _make-vector-app-stack-info-set! */
obj_t 
_make_vector_app_stack_info_set__207_cfa_info2(obj_t env_5869, obj_t obj_5870, obj_t val1951_5871)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 704 */
      return
	 make_vector_app_stack_info_set__239_cfa_info2(
	 (app_bglt) (obj_5870), val1951_5871);
   }
}



/* make-vector-app-stack-info */
obj_t 
make_vector_app_stack_info_168_cfa_info2(app_bglt obj_386)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 704 */
      return
	 (((app_bglt) CREF(obj_386))->stack_info_255);
   }
}



/* _make-vector-app-stack-info */
obj_t 
_make_vector_app_stack_info_46_cfa_info2(obj_t env_5872, obj_t obj_5873)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 704 */
      return
	 make_vector_app_stack_info_168_cfa_info2(
	 (app_bglt) (obj_5873));
   }
}



/* make-vector-app-approx-set! */
obj_t 
make_vector_app_approx_set__66_cfa_info2(make_vector_app_205_bglt obj_387, approx_bglt val1952_388)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 63 */
      {
	 obj_t aux_7901;
	 {	/* Cfa/cinfo2.scm 63 */
	    object_bglt aux_7902;
	    aux_7902 =
	       (object_bglt) (obj_387);
	    aux_7901 =
	       OBJECT_WIDENING(aux_7902);
	 }
	 return
	    ((((make_vector_app_205_bglt) CREF(aux_7901))->approx) = ((approx_bglt) val1952_388), BUNSPEC);
      }
   }
}



/* _make-vector-app-approx-set! */
obj_t 
_make_vector_app_approx_set__9_cfa_info2(obj_t env_5874, obj_t obj_5875, obj_t val1952_5876)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 63 */
      return
	 make_vector_app_approx_set__66_cfa_info2(
	 (make_vector_app_205_bglt) (obj_5875),
	 (approx_bglt) (val1952_5876));
   }
}



/* make-vector-app-approx */
approx_bglt 
make_vector_app_approx_58_cfa_info2(make_vector_app_205_bglt obj_389)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 63 */
      {
	 obj_t aux_7909;
	 {	/* Cfa/cinfo2.scm 63 */
	    object_bglt aux_7910;
	    aux_7910 =
	       (object_bglt) (obj_389);
	    aux_7909 =
	       OBJECT_WIDENING(aux_7910);
	 }
	 return
	    (((make_vector_app_205_bglt) CREF(aux_7909))->approx);
      }
   }
}



/* _make-vector-app-approx */
obj_t 
_make_vector_app_approx_98_cfa_info2(obj_t env_5877, obj_t obj_5878)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 63 */
      {		/* Cfa/cinfo2.scm 63 */
	 approx_bglt aux_7914;
	 aux_7914 =
	    make_vector_app_approx_58_cfa_info2(
	    (make_vector_app_205_bglt) (obj_5878));
	 return
	    (obj_t) (aux_7914);
      }
   }
}



/* make-vector-app-value-approx */
approx_bglt 
make_vector_app_value_approx_202_cfa_info2(make_vector_app_205_bglt obj_390)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 67 */
      {
	 obj_t aux_7918;
	 {	/* Cfa/cinfo2.scm 67 */
	    object_bglt aux_7919;
	    aux_7919 =
	       (object_bglt) (obj_390);
	    aux_7918 =
	       OBJECT_WIDENING(aux_7919);
	 }
	 return
	    (((make_vector_app_205_bglt) CREF(aux_7918))->value_approx_19);
      }
   }
}



/* _make-vector-app-value-approx */
obj_t 
_make_vector_app_value_approx_28_cfa_info2(obj_t env_5879, obj_t obj_5880)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 67 */
      {		/* Cfa/cinfo2.scm 67 */
	 approx_bglt aux_7923;
	 aux_7923 =
	    make_vector_app_value_approx_202_cfa_info2(
	    (make_vector_app_205_bglt) (obj_5880));
	 return
	    (obj_t) (aux_7923);
      }
   }
}



/* make-vector-app-lost-stamp-set! */
obj_t 
make_vector_app_lost_stamp_set__132_cfa_info2(make_vector_app_205_bglt obj_391, long val1953_392)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 69 */
      {
	 obj_t aux_7927;
	 {	/* Cfa/cinfo2.scm 69 */
	    object_bglt aux_7928;
	    aux_7928 =
	       (object_bglt) (obj_391);
	    aux_7927 =
	       OBJECT_WIDENING(aux_7928);
	 }
	 return
	    ((((make_vector_app_205_bglt) CREF(aux_7927))->lost_stamp_114) = ((long) val1953_392), BUNSPEC);
      }
   }
}



/* _make-vector-app-lost-stamp-set! */
obj_t 
_make_vector_app_lost_stamp_set__176_cfa_info2(obj_t env_5881, obj_t obj_5882, obj_t val1953_5883)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 69 */
      return
	 make_vector_app_lost_stamp_set__132_cfa_info2(
	 (make_vector_app_205_bglt) (obj_5882),
	 (long) CINT(val1953_5883));
   }
}



/* make-vector-app-lost-stamp */
long 
make_vector_app_lost_stamp_174_cfa_info2(make_vector_app_205_bglt obj_393)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 69 */
      {
	 obj_t aux_7935;
	 {	/* Cfa/cinfo2.scm 69 */
	    object_bglt aux_7936;
	    aux_7936 =
	       (object_bglt) (obj_393);
	    aux_7935 =
	       OBJECT_WIDENING(aux_7936);
	 }
	 return
	    (((make_vector_app_205_bglt) CREF(aux_7935))->lost_stamp_114);
      }
   }
}



/* _make-vector-app-lost-stamp */
obj_t 
_make_vector_app_lost_stamp_194_cfa_info2(obj_t env_5884, obj_t obj_5885)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 69 */
      {		/* Cfa/cinfo2.scm 69 */
	 long aux_7940;
	 aux_7940 =
	    make_vector_app_lost_stamp_174_cfa_info2(
	    (make_vector_app_205_bglt) (obj_5885));
	 return
	    BINT(aux_7940);
      }
   }
}



/* make-vector-app-owner */
variable_bglt 
make_vector_app_owner_193_cfa_info2(make_vector_app_205_bglt obj_394)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 71 */
      {
	 obj_t aux_7944;
	 {	/* Cfa/cinfo2.scm 71 */
	    object_bglt aux_7945;
	    aux_7945 =
	       (object_bglt) (obj_394);
	    aux_7944 =
	       OBJECT_WIDENING(aux_7945);
	 }
	 return
	    (((make_vector_app_205_bglt) CREF(aux_7944))->owner);
      }
   }
}



/* _make-vector-app-owner */
obj_t 
_make_vector_app_owner_231_cfa_info2(obj_t env_5886, obj_t obj_5887)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 71 */
      {		/* Cfa/cinfo2.scm 71 */
	 variable_bglt aux_7949;
	 aux_7949 =
	    make_vector_app_owner_193_cfa_info2(
	    (make_vector_app_205_bglt) (obj_5887));
	 return
	    (obj_t) (aux_7949);
      }
   }
}



/* make-vector-app-stackable?-set! */
obj_t 
make_vector_app_stackable__set__110_cfa_info2(make_vector_app_205_bglt obj_395, bool_t val1954_396)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 74 */
      {
	 obj_t aux_7953;
	 {	/* Cfa/cinfo2.scm 74 */
	    object_bglt aux_7954;
	    aux_7954 =
	       (object_bglt) (obj_395);
	    aux_7953 =
	       OBJECT_WIDENING(aux_7954);
	 }
	 return
	    ((((make_vector_app_205_bglt) CREF(aux_7953))->stackable__42) = ((bool_t) val1954_396), BUNSPEC);
      }
   }
}



/* _make-vector-app-stackable?-set! */
obj_t 
_make_vector_app_stackable__set__52_cfa_info2(obj_t env_5888, obj_t obj_5889, obj_t val1954_5890)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 74 */
      return
	 make_vector_app_stackable__set__110_cfa_info2(
	 (make_vector_app_205_bglt) (obj_5889),
	 CBOOL(val1954_5890));
   }
}



/* make-vector-app-stackable? */
bool_t 
make_vector_app_stackable__199_cfa_info2(make_vector_app_205_bglt obj_397)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 74 */
      {
	 obj_t aux_7961;
	 {	/* Cfa/cinfo2.scm 74 */
	    object_bglt aux_7962;
	    aux_7962 =
	       (object_bglt) (obj_397);
	    aux_7961 =
	       OBJECT_WIDENING(aux_7962);
	 }
	 return
	    (((make_vector_app_205_bglt) CREF(aux_7961))->stackable__42);
      }
   }
}



/* _make-vector-app-stackable? */
obj_t 
_make_vector_app_stackable__177_cfa_info2(obj_t env_5891, obj_t obj_5892)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 74 */
      {		/* Cfa/cinfo2.scm 74 */
	 bool_t aux_7966;
	 aux_7966 =
	    make_vector_app_stackable__199_cfa_info2(
	    (make_vector_app_205_bglt) (obj_5892));
	 return
	    BBOOL(aux_7966);
      }
   }
}



/* make-vector-app-stack-stamp-set! */
obj_t 
make_vector_app_stack_stamp_set__141_cfa_info2(make_vector_app_205_bglt obj_398, obj_t val1955_399)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 76 */
      {
	 obj_t aux_7970;
	 {	/* Cfa/cinfo2.scm 76 */
	    object_bglt aux_7971;
	    aux_7971 =
	       (object_bglt) (obj_398);
	    aux_7970 =
	       OBJECT_WIDENING(aux_7971);
	 }
	 return
	    ((((make_vector_app_205_bglt) CREF(aux_7970))->stack_stamp_31) = ((obj_t) val1955_399), BUNSPEC);
      }
   }
}



/* _make-vector-app-stack-stamp-set! */
obj_t 
_make_vector_app_stack_stamp_set__172_cfa_info2(obj_t env_5893, obj_t obj_5894, obj_t val1955_5895)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 76 */
      return
	 make_vector_app_stack_stamp_set__141_cfa_info2(
	 (make_vector_app_205_bglt) (obj_5894), val1955_5895);
   }
}



/* make-vector-app-stack-stamp */
obj_t 
make_vector_app_stack_stamp_1_cfa_info2(make_vector_app_205_bglt obj_400)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 76 */
      {
	 obj_t aux_7977;
	 {	/* Cfa/cinfo2.scm 76 */
	    object_bglt aux_7978;
	    aux_7978 =
	       (object_bglt) (obj_400);
	    aux_7977 =
	       OBJECT_WIDENING(aux_7978);
	 }
	 return
	    (((make_vector_app_205_bglt) CREF(aux_7977))->stack_stamp_31);
      }
   }
}



/* _make-vector-app-stack-stamp */
obj_t 
_make_vector_app_stack_stamp_138_cfa_info2(obj_t env_5896, obj_t obj_5897)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 76 */
      return
	 make_vector_app_stack_stamp_1_cfa_info2(
	 (make_vector_app_205_bglt) (obj_5897));
   }
}



/* make-vector-app-seen?-set! */
obj_t 
make_vector_app_seen__set__213_cfa_info2(make_vector_app_205_bglt obj_401, bool_t val1956_402)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 86 */
      {
	 obj_t aux_7984;
	 {	/* Cfa/cinfo2.scm 86 */
	    object_bglt aux_7985;
	    aux_7985 =
	       (object_bglt) (obj_401);
	    aux_7984 =
	       OBJECT_WIDENING(aux_7985);
	 }
	 return
	    ((((make_vector_app_205_bglt) CREF(aux_7984))->seen__39) = ((bool_t) val1956_402), BUNSPEC);
      }
   }
}



/* _make-vector-app-seen?-set! */
obj_t 
_make_vector_app_seen__set__29_cfa_info2(obj_t env_5898, obj_t obj_5899, obj_t val1956_5900)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 86 */
      return
	 make_vector_app_seen__set__213_cfa_info2(
	 (make_vector_app_205_bglt) (obj_5899),
	 CBOOL(val1956_5900));
   }
}



/* make-vector-app-seen? */
bool_t 
make_vector_app_seen__62_cfa_info2(make_vector_app_205_bglt obj_403)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 86 */
      {
	 obj_t aux_7992;
	 {	/* Cfa/cinfo2.scm 86 */
	    object_bglt aux_7993;
	    aux_7993 =
	       (object_bglt) (obj_403);
	    aux_7992 =
	       OBJECT_WIDENING(aux_7993);
	 }
	 return
	    (((make_vector_app_205_bglt) CREF(aux_7992))->seen__39);
      }
   }
}



/* _make-vector-app-seen? */
obj_t 
_make_vector_app_seen__50_cfa_info2(obj_t env_5901, obj_t obj_5902)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 86 */
      {		/* Cfa/cinfo2.scm 86 */
	 bool_t aux_7997;
	 aux_7997 =
	    make_vector_app_seen__62_cfa_info2(
	    (make_vector_app_205_bglt) (obj_5902));
	 return
	    BBOOL(aux_7997);
      }
   }
}



/* allocate-pre-vector-set!-app */
app_bglt 
allocate_pre_vector_set__app_20_cfa_info2()
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 61 */
      {		/* Cfa/cinfo2.scm 61 */
	 app_bglt new1939_2373;
	 new1939_2373 =
	    ((app_bglt) BREF(GC_MALLOC(sizeof(struct app))));
	 {	/* Cfa/cinfo2.scm 61 */
	    long arg2388_2374;
	    arg2388_2374 =
	       class_num_218___object(pre_vector_set__app_211_cfa_info2);
	    {	/* Cfa/cinfo2.scm 61 */
	       obj_t obj_3913;
	       obj_3913 =
		  (obj_t) (new1939_2373);
	       (((obj_t) CREF(obj_3913))->header = MAKE_HEADER(arg2388_2374, 0), BUNSPEC);
	    }
	 }
	 {	/* Cfa/cinfo2.scm 61 */
	    object_bglt aux_8005;
	    aux_8005 =
	       (object_bglt) (new1939_2373);
	    OBJECT_WIDENING_SET(aux_8005, BFALSE);
	 }
	 return new1939_2373;
      }
   }
}



/* _allocate-pre-vector-set!-app */
obj_t 
_allocate_pre_vector_set__app_63_cfa_info2(obj_t env_5320)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 61 */
      {		/* Cfa/cinfo2.scm 61 */
	 app_bglt aux_8008;
	 aux_8008 =
	    allocate_pre_vector_set__app_20_cfa_info2();
	 return
	    (obj_t) (aux_8008);
      }
   }
}



/* pre-vector-set!-app? */
bool_t 
pre_vector_set__app__39_cfa_info2(obj_t obj_407)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 61 */
      return
	 is_a__118___object(obj_407, pre_vector_set__app_211_cfa_info2);
   }
}



/* _pre-vector-set!-app? */
obj_t 
_pre_vector_set__app__223_cfa_info2(obj_t env_5903, obj_t obj_5904)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 61 */
      {		/* Cfa/cinfo2.scm 61 */
	 bool_t aux_8012;
	 aux_8012 =
	    pre_vector_set__app__39_cfa_info2(obj_5904);
	 return
	    BBOOL(aux_8012);
      }
   }
}



/* widening-pre-vector-set!-app */
pre_vector_set__app_211_bglt 
widening_pre_vector_set__app_251_cfa_info2()
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 61 */
      {		/* Cfa/cinfo2.scm 61 */

	 return
	    ((pre_vector_set__app_211_bglt) BREF(GC_MALLOC(sizeof(struct pre_vector_set__app_211))));
      }
   }
}



/* _widening-pre-vector-set!-app */
obj_t 
_widening_pre_vector_set__app_64_cfa_info2(obj_t env_5905)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 61 */
      {		/* Cfa/cinfo2.scm 61 */
	 pre_vector_set__app_211_bglt aux_8016;
	 aux_8016 =
	    widening_pre_vector_set__app_251_cfa_info2();
	 return
	    (obj_t) (aux_8016);
      }
   }
}



/* make-pre-vector-set!-app */
pre_vector_set__app_211_bglt 
make_pre_vector_set__app_26_cfa_info2(obj_t loc_408, type_bglt type_409, obj_t side_effect__165_410, obj_t key_411, var_bglt fun_412, obj_t args_413, obj_t stack_info_255_414)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 61 */
      {		/* Cfa/cinfo2.scm 61 */
	 app_bglt aux1937_3916;
	 {	/* Cfa/cinfo2.scm 61 */
	    app_bglt res2827_3938;
	    {	/* ./Ast/node.scm 698 */
	       app_bglt new1248_3927;
	       new1248_3927 =
		  ((app_bglt) BREF(GC_MALLOC(sizeof(struct app))));
	       {	/* ./Ast/node.scm 698 */
		  long arg2541_3928;
		  arg2541_3928 =
		     class_num_218___object(app_ast_node);
		  {	/* ./Ast/node.scm 698 */
		     obj_t obj_3936;
		     obj_3936 =
			(obj_t) (new1248_3927);
		     (((obj_t) CREF(obj_3936))->header = MAKE_HEADER(arg2541_3928, 0), BUNSPEC);
		  }
	       }
	       {	/* ./Ast/node.scm 698 */
		  object_bglt aux_8023;
		  aux_8023 =
		     (object_bglt) (new1248_3927);
		  OBJECT_WIDENING_SET(aux_8023, BFALSE);
	       }
	       ((((app_bglt) CREF(new1248_3927))->loc) = ((obj_t) loc_408), BUNSPEC);
	       ((((app_bglt) CREF(new1248_3927))->type) = ((type_bglt) type_409), BUNSPEC);
	       ((((app_bglt) CREF(new1248_3927))->side_effect__165) = ((obj_t) side_effect__165_410), BUNSPEC);
	       ((((app_bglt) CREF(new1248_3927))->key) = ((obj_t) key_411), BUNSPEC);
	       ((((app_bglt) CREF(new1248_3927))->fun) = ((var_bglt) fun_412), BUNSPEC);
	       ((((app_bglt) CREF(new1248_3927))->args) = ((obj_t) args_413), BUNSPEC);
	       ((((app_bglt) CREF(new1248_3927))->stack_info_255) = ((obj_t) stack_info_255_414), BUNSPEC);
	       res2827_3938 = new1248_3927;
	    }
	    aux1937_3916 = res2827_3938;
	 }
	 {	/* Cfa/cinfo2.scm 61 */
	    pre_vector_set__app_211_bglt new1938_3917;
	    new1938_3917 =
	       ((pre_vector_set__app_211_bglt) (aux1937_3916));
	    {	/* Cfa/cinfo2.scm 61 */
	       long arg2389_3918;
	       arg2389_3918 =
		  class_num_218___object(pre_vector_set__app_211_cfa_info2);
	       {	/* Cfa/cinfo2.scm 61 */
		  obj_t obj_3939;
		  obj_3939 =
		     (obj_t) (new1938_3917);
		  (((obj_t) CREF(obj_3939))->header = MAKE_HEADER(arg2389_3918, 0), BUNSPEC);
	       }
	    }
	    {	/* Cfa/cinfo2.scm 61 */
	       obj_t aux_8039;
	       object_bglt aux_8037;
	       {	/* Cfa/cinfo2.scm 61 */
		  pre_vector_set__app_211_bglt aux_8040;
		  {	/* Cfa/cinfo2.scm 61 */

		     aux_8040 =
			((pre_vector_set__app_211_bglt) BREF(GC_MALLOC(sizeof(struct pre_vector_set__app_211))));
		  }
		  aux_8039 =
		     (obj_t) (aux_8040);
	       }
	       aux_8037 =
		  (object_bglt) (new1938_3917);
	       OBJECT_WIDENING_SET(aux_8037, aux_8039);
	    }
	    return new1938_3917;
	 }
      }
   }
}



/* _make-pre-vector-set!-app */
obj_t 
_make_pre_vector_set__app_51_cfa_info2(obj_t env_5906, obj_t loc_5907, obj_t type_5908, obj_t side_effect__165_5909, obj_t key_5910, obj_t fun_5911, obj_t args_5912, obj_t stack_info_255_5913)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 61 */
      {		/* Cfa/cinfo2.scm 61 */
	 pre_vector_set__app_211_bglt aux_8044;
	 aux_8044 =
	    make_pre_vector_set__app_26_cfa_info2(loc_5907,
	    (type_bglt) (type_5908), side_effect__165_5909, key_5910,
	    (var_bglt) (fun_5911), args_5912, stack_info_255_5913);
	 return
	    (obj_t) (aux_8044);
      }
   }
}



/* pre-vector-set!-app-loc */
obj_t 
pre_vector_set__app_loc_126_cfa_info2(app_bglt obj_415)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 661 */
      return
	 (((app_bglt) CREF(obj_415))->loc);
   }
}



/* _pre-vector-set!-app-loc */
obj_t 
_pre_vector_set__app_loc_128_cfa_info2(obj_t env_5914, obj_t obj_5915)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 661 */
      return
	 pre_vector_set__app_loc_126_cfa_info2(
	 (app_bglt) (obj_5915));
   }
}



/* pre-vector-set!-app-type-set! */
obj_t 
pre_vector_set__app_type_set__58_cfa_info2(app_bglt obj_416, type_bglt val1929_417)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 61 */
      return
	 ((((app_bglt) CREF(obj_416))->type) = ((type_bglt) val1929_417), BUNSPEC);
   }
}



/* _pre-vector-set!-app-type-set! */
obj_t 
_pre_vector_set__app_type_set__170_cfa_info2(obj_t env_5916, obj_t obj_5917, obj_t val1929_5918)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 61 */
      return
	 pre_vector_set__app_type_set__58_cfa_info2(
	 (app_bglt) (obj_5917),
	 (type_bglt) (val1929_5918));
   }
}



/* pre-vector-set!-app-type */
type_bglt 
pre_vector_set__app_type_92_cfa_info2(app_bglt obj_418)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 61 */
      return
	 (((app_bglt) CREF(obj_418))->type);
   }
}



/* _pre-vector-set!-app-type */
obj_t 
_pre_vector_set__app_type_156_cfa_info2(obj_t env_5919, obj_t obj_5920)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 61 */
      {		/* Cfa/cinfo2.scm 61 */
	 type_bglt aux_8057;
	 aux_8057 =
	    pre_vector_set__app_type_92_cfa_info2(
	    (app_bglt) (obj_5920));
	 return
	    (obj_t) (aux_8057);
      }
   }
}



/* pre-vector-set!-app-side-effect?-set! */
obj_t 
pre_vector_set__app_side_effect__set__23_cfa_info2(app_bglt obj_419, obj_t val1930_420)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 669 */
      return
	 ((((app_bglt) CREF(obj_419))->side_effect__165) = ((obj_t) val1930_420), BUNSPEC);
   }
}



/* _pre-vector-set!-app-side-effect?-set! */
obj_t 
_pre_vector_set__app_side_effect__set__216_cfa_info2(obj_t env_5921, obj_t obj_5922, obj_t val1930_5923)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 669 */
      return
	 pre_vector_set__app_side_effect__set__23_cfa_info2(
	 (app_bglt) (obj_5922), val1930_5923);
   }
}



/* pre-vector-set!-app-side-effect? */
obj_t 
pre_vector_set__app_side_effect__17_cfa_info2(app_bglt obj_421)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 669 */
      return
	 (((app_bglt) CREF(obj_421))->side_effect__165);
   }
}



/* _pre-vector-set!-app-side-effect? */
obj_t 
_pre_vector_set__app_side_effect__191_cfa_info2(obj_t env_5924, obj_t obj_5925)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 669 */
      return
	 pre_vector_set__app_side_effect__17_cfa_info2(
	 (app_bglt) (obj_5925));
   }
}



/* pre-vector-set!-app-key-set! */
obj_t 
pre_vector_set__app_key_set__109_cfa_info2(app_bglt obj_422, obj_t val1931_423)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 673 */
      return
	 ((((app_bglt) CREF(obj_422))->key) = ((obj_t) val1931_423), BUNSPEC);
   }
}



/* _pre-vector-set!-app-key-set!2891 */
obj_t 
_pre_vector_set__app_key_set_2891_172_cfa_info2(obj_t env_5926, obj_t obj_5927, obj_t val1931_5928)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 673 */
      return
	 pre_vector_set__app_key_set__109_cfa_info2(
	 (app_bglt) (obj_5927), val1931_5928);
   }
}



/* pre-vector-set!-app-key */
obj_t 
pre_vector_set__app_key_243_cfa_info2(app_bglt obj_424)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 673 */
      return
	 (((app_bglt) CREF(obj_424))->key);
   }
}



/* _pre-vector-set!-app-key2892 */
obj_t 
_pre_vector_set__app_key2892_212_cfa_info2(obj_t env_5929, obj_t obj_5930)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 673 */
      return
	 pre_vector_set__app_key_243_cfa_info2(
	 (app_bglt) (obj_5930));
   }
}



/* pre-vector-set!-app-fun-set! */
obj_t 
pre_vector_set__app_fun_set__57_cfa_info2(app_bglt obj_425, var_bglt val1932_426)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 61 */
      return
	 ((((app_bglt) CREF(obj_425))->fun) = ((var_bglt) val1932_426), BUNSPEC);
   }
}



/* _pre-vector-set!-app-fun-set! */
obj_t 
_pre_vector_set__app_fun_set__189_cfa_info2(obj_t env_5931, obj_t obj_5932, obj_t val1932_5933)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 61 */
      return
	 pre_vector_set__app_fun_set__57_cfa_info2(
	 (app_bglt) (obj_5932),
	 (var_bglt) (val1932_5933));
   }
}



/* pre-vector-set!-app-fun */
var_bglt 
pre_vector_set__app_fun_157_cfa_info2(app_bglt obj_427)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 61 */
      return
	 (((app_bglt) CREF(obj_427))->fun);
   }
}



/* _pre-vector-set!-app-fun */
obj_t 
_pre_vector_set__app_fun_206_cfa_info2(obj_t env_5934, obj_t obj_5935)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 61 */
      {		/* Cfa/cinfo2.scm 61 */
	 var_bglt aux_8078;
	 aux_8078 =
	    pre_vector_set__app_fun_157_cfa_info2(
	    (app_bglt) (obj_5935));
	 return
	    (obj_t) (aux_8078);
      }
   }
}



/* pre-vector-set!-app-args-set! */
obj_t 
pre_vector_set__app_args_set__202_cfa_info2(app_bglt obj_428, obj_t val1933_429)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 61 */
      return
	 ((((app_bglt) CREF(obj_428))->args) = ((obj_t) val1933_429), BUNSPEC);
   }
}



/* _pre-vector-set!-app-args-set! */
obj_t 
_pre_vector_set__app_args_set__6_cfa_info2(obj_t env_5936, obj_t obj_5937, obj_t val1933_5938)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 61 */
      return
	 pre_vector_set__app_args_set__202_cfa_info2(
	 (app_bglt) (obj_5937), val1933_5938);
   }
}



/* pre-vector-set!-app-args */
obj_t 
pre_vector_set__app_args_27_cfa_info2(app_bglt obj_430)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 61 */
      return
	 (((app_bglt) CREF(obj_430))->args);
   }
}



/* _pre-vector-set!-app-args */
obj_t 
_pre_vector_set__app_args_216_cfa_info2(obj_t env_5939, obj_t obj_5940)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 61 */
      return
	 pre_vector_set__app_args_27_cfa_info2(
	 (app_bglt) (obj_5940));
   }
}



/* pre-vector-set!-app-stack-info-set! */
obj_t 
pre_vector_set__app_stack_info_set__9_cfa_info2(app_bglt obj_431, obj_t val1934_432)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 704 */
      return
	 ((((app_bglt) CREF(obj_431))->stack_info_255) = ((obj_t) val1934_432), BUNSPEC);
   }
}



/* _pre-vector-set!-app-stack-info-set! */
obj_t 
_pre_vector_set__app_stack_info_set__248_cfa_info2(obj_t env_5941, obj_t obj_5942, obj_t val1934_5943)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 704 */
      return
	 pre_vector_set__app_stack_info_set__9_cfa_info2(
	 (app_bglt) (obj_5942), val1934_5943);
   }
}



/* pre-vector-set!-app-stack-info */
obj_t 
pre_vector_set__app_stack_info_98_cfa_info2(app_bglt obj_433)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 704 */
      return
	 (((app_bglt) CREF(obj_433))->stack_info_255);
   }
}



/* _pre-vector-set!-app-stack-info */
obj_t 
_pre_vector_set__app_stack_info_11_cfa_info2(obj_t env_5944, obj_t obj_5945)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 704 */
      return
	 pre_vector_set__app_stack_info_98_cfa_info2(
	 (app_bglt) (obj_5945));
   }
}



/* allocate-pre-vector-ref-app */
app_bglt 
allocate_pre_vector_ref_app_241_cfa_info2()
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 60 */
      {		/* Cfa/cinfo2.scm 60 */
	 app_bglt new1922_2380;
	 new1922_2380 =
	    ((app_bglt) BREF(GC_MALLOC(sizeof(struct app))));
	 {	/* Cfa/cinfo2.scm 60 */
	    long arg2391_2381;
	    arg2391_2381 =
	       class_num_218___object(pre_vector_ref_app_208_cfa_info2);
	    {	/* Cfa/cinfo2.scm 60 */
	       obj_t obj_3943;
	       obj_3943 =
		  (obj_t) (new1922_2380);
	       (((obj_t) CREF(obj_3943))->header = MAKE_HEADER(arg2391_2381, 0), BUNSPEC);
	    }
	 }
	 {	/* Cfa/cinfo2.scm 60 */
	    object_bglt aux_8098;
	    aux_8098 =
	       (object_bglt) (new1922_2380);
	    OBJECT_WIDENING_SET(aux_8098, BFALSE);
	 }
	 return new1922_2380;
      }
   }
}



/* _allocate-pre-vector-ref-app */
obj_t 
_allocate_pre_vector_ref_app_31_cfa_info2(obj_t env_5319)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 60 */
      {		/* Cfa/cinfo2.scm 60 */
	 app_bglt aux_8101;
	 aux_8101 =
	    allocate_pre_vector_ref_app_241_cfa_info2();
	 return
	    (obj_t) (aux_8101);
      }
   }
}



/* pre-vector-ref-app? */
bool_t 
pre_vector_ref_app__184_cfa_info2(obj_t obj_437)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 60 */
      return
	 is_a__118___object(obj_437, pre_vector_ref_app_208_cfa_info2);
   }
}



/* _pre-vector-ref-app? */
obj_t 
_pre_vector_ref_app__133_cfa_info2(obj_t env_5946, obj_t obj_5947)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 60 */
      {		/* Cfa/cinfo2.scm 60 */
	 bool_t aux_8105;
	 aux_8105 =
	    pre_vector_ref_app__184_cfa_info2(obj_5947);
	 return
	    BBOOL(aux_8105);
      }
   }
}



/* widening-pre-vector-ref-app */
pre_vector_ref_app_208_bglt 
widening_pre_vector_ref_app_50_cfa_info2()
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 60 */
      {		/* Cfa/cinfo2.scm 60 */

	 return
	    ((pre_vector_ref_app_208_bglt) BREF(GC_MALLOC(sizeof(struct pre_vector_ref_app_208))));
      }
   }
}



/* _widening-pre-vector-ref-app */
obj_t 
_widening_pre_vector_ref_app_135_cfa_info2(obj_t env_5948)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 60 */
      {		/* Cfa/cinfo2.scm 60 */
	 pre_vector_ref_app_208_bglt aux_8109;
	 aux_8109 =
	    widening_pre_vector_ref_app_50_cfa_info2();
	 return
	    (obj_t) (aux_8109);
      }
   }
}



/* make-pre-vector-ref-app */
pre_vector_ref_app_208_bglt 
make_pre_vector_ref_app_82_cfa_info2(obj_t loc_438, type_bglt type_439, obj_t side_effect__165_440, obj_t key_441, var_bglt fun_442, obj_t args_443, obj_t stack_info_255_444)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 60 */
      {		/* Cfa/cinfo2.scm 60 */
	 app_bglt aux1920_3946;
	 {	/* Cfa/cinfo2.scm 60 */
	    app_bglt res2829_3968;
	    {	/* ./Ast/node.scm 698 */
	       app_bglt new1248_3957;
	       new1248_3957 =
		  ((app_bglt) BREF(GC_MALLOC(sizeof(struct app))));
	       {	/* ./Ast/node.scm 698 */
		  long arg2541_3958;
		  arg2541_3958 =
		     class_num_218___object(app_ast_node);
		  {	/* ./Ast/node.scm 698 */
		     obj_t obj_3966;
		     obj_3966 =
			(obj_t) (new1248_3957);
		     (((obj_t) CREF(obj_3966))->header = MAKE_HEADER(arg2541_3958, 0), BUNSPEC);
		  }
	       }
	       {	/* ./Ast/node.scm 698 */
		  object_bglt aux_8116;
		  aux_8116 =
		     (object_bglt) (new1248_3957);
		  OBJECT_WIDENING_SET(aux_8116, BFALSE);
	       }
	       ((((app_bglt) CREF(new1248_3957))->loc) = ((obj_t) loc_438), BUNSPEC);
	       ((((app_bglt) CREF(new1248_3957))->type) = ((type_bglt) type_439), BUNSPEC);
	       ((((app_bglt) CREF(new1248_3957))->side_effect__165) = ((obj_t) side_effect__165_440), BUNSPEC);
	       ((((app_bglt) CREF(new1248_3957))->key) = ((obj_t) key_441), BUNSPEC);
	       ((((app_bglt) CREF(new1248_3957))->fun) = ((var_bglt) fun_442), BUNSPEC);
	       ((((app_bglt) CREF(new1248_3957))->args) = ((obj_t) args_443), BUNSPEC);
	       ((((app_bglt) CREF(new1248_3957))->stack_info_255) = ((obj_t) stack_info_255_444), BUNSPEC);
	       res2829_3968 = new1248_3957;
	    }
	    aux1920_3946 = res2829_3968;
	 }
	 {	/* Cfa/cinfo2.scm 60 */
	    pre_vector_ref_app_208_bglt new1921_3947;
	    new1921_3947 =
	       ((pre_vector_ref_app_208_bglt) (aux1920_3946));
	    {	/* Cfa/cinfo2.scm 60 */
	       long arg2392_3948;
	       arg2392_3948 =
		  class_num_218___object(pre_vector_ref_app_208_cfa_info2);
	       {	/* Cfa/cinfo2.scm 60 */
		  obj_t obj_3969;
		  obj_3969 =
		     (obj_t) (new1921_3947);
		  (((obj_t) CREF(obj_3969))->header = MAKE_HEADER(arg2392_3948, 0), BUNSPEC);
	       }
	    }
	    {	/* Cfa/cinfo2.scm 60 */
	       obj_t aux_8132;
	       object_bglt aux_8130;
	       {	/* Cfa/cinfo2.scm 60 */
		  pre_vector_ref_app_208_bglt aux_8133;
		  {	/* Cfa/cinfo2.scm 60 */

		     aux_8133 =
			((pre_vector_ref_app_208_bglt) BREF(GC_MALLOC(sizeof(struct pre_vector_ref_app_208))));
		  }
		  aux_8132 =
		     (obj_t) (aux_8133);
	       }
	       aux_8130 =
		  (object_bglt) (new1921_3947);
	       OBJECT_WIDENING_SET(aux_8130, aux_8132);
	    }
	    return new1921_3947;
	 }
      }
   }
}



/* _make-pre-vector-ref-app */
obj_t 
_make_pre_vector_ref_app_92_cfa_info2(obj_t env_5949, obj_t loc_5950, obj_t type_5951, obj_t side_effect__165_5952, obj_t key_5953, obj_t fun_5954, obj_t args_5955, obj_t stack_info_255_5956)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 60 */
      {		/* Cfa/cinfo2.scm 60 */
	 pre_vector_ref_app_208_bglt aux_8137;
	 aux_8137 =
	    make_pre_vector_ref_app_82_cfa_info2(loc_5950,
	    (type_bglt) (type_5951), side_effect__165_5952, key_5953,
	    (var_bglt) (fun_5954), args_5955, stack_info_255_5956);
	 return
	    (obj_t) (aux_8137);
      }
   }
}



/* pre-vector-ref-app-loc */
obj_t 
pre_vector_ref_app_loc_154_cfa_info2(app_bglt obj_445)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 661 */
      return
	 (((app_bglt) CREF(obj_445))->loc);
   }
}



/* _pre-vector-ref-app-loc */
obj_t 
_pre_vector_ref_app_loc_114_cfa_info2(obj_t env_5957, obj_t obj_5958)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 661 */
      return
	 pre_vector_ref_app_loc_154_cfa_info2(
	 (app_bglt) (obj_5958));
   }
}



/* pre-vector-ref-app-type-set! */
obj_t 
pre_vector_ref_app_type_set__203_cfa_info2(app_bglt obj_446, type_bglt val1912_447)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 60 */
      return
	 ((((app_bglt) CREF(obj_446))->type) = ((type_bglt) val1912_447), BUNSPEC);
   }
}



/* _pre-vector-ref-app-type-set! */
obj_t 
_pre_vector_ref_app_type_set__185_cfa_info2(obj_t env_5959, obj_t obj_5960, obj_t val1912_5961)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 60 */
      return
	 pre_vector_ref_app_type_set__203_cfa_info2(
	 (app_bglt) (obj_5960),
	 (type_bglt) (val1912_5961));
   }
}



/* pre-vector-ref-app-type */
type_bglt 
pre_vector_ref_app_type_159_cfa_info2(app_bglt obj_448)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 60 */
      return
	 (((app_bglt) CREF(obj_448))->type);
   }
}



/* _pre-vector-ref-app-type */
obj_t 
_pre_vector_ref_app_type_244_cfa_info2(obj_t env_5962, obj_t obj_5963)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 60 */
      {		/* Cfa/cinfo2.scm 60 */
	 type_bglt aux_8150;
	 aux_8150 =
	    pre_vector_ref_app_type_159_cfa_info2(
	    (app_bglt) (obj_5963));
	 return
	    (obj_t) (aux_8150);
      }
   }
}



/* pre-vector-ref-app-side-effect?-set! */
obj_t 
pre_vector_ref_app_side_effect__set__95_cfa_info2(app_bglt obj_449, obj_t val1913_450)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 669 */
      return
	 ((((app_bglt) CREF(obj_449))->side_effect__165) = ((obj_t) val1913_450), BUNSPEC);
   }
}



/* _pre-vector-ref-app-side-effect?-set! */
obj_t 
_pre_vector_ref_app_side_effect__set__248_cfa_info2(obj_t env_5964, obj_t obj_5965, obj_t val1913_5966)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 669 */
      return
	 pre_vector_ref_app_side_effect__set__95_cfa_info2(
	 (app_bglt) (obj_5965), val1913_5966);
   }
}



/* pre-vector-ref-app-side-effect? */
obj_t 
pre_vector_ref_app_side_effect__40_cfa_info2(app_bglt obj_451)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 669 */
      return
	 (((app_bglt) CREF(obj_451))->side_effect__165);
   }
}



/* _pre-vector-ref-app-side-effect? */
obj_t 
_pre_vector_ref_app_side_effect__11_cfa_info2(obj_t env_5967, obj_t obj_5968)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 669 */
      return
	 pre_vector_ref_app_side_effect__40_cfa_info2(
	 (app_bglt) (obj_5968));
   }
}



/* pre-vector-ref-app-key-set! */
obj_t 
pre_vector_ref_app_key_set__8_cfa_info2(app_bglt obj_452, obj_t val1914_453)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 673 */
      return
	 ((((app_bglt) CREF(obj_452))->key) = ((obj_t) val1914_453), BUNSPEC);
   }
}



/* _pre-vector-ref-app-key-set!2893 */
obj_t 
_pre_vector_ref_app_key_set_2893_33_cfa_info2(obj_t env_5969, obj_t obj_5970, obj_t val1914_5971)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 673 */
      return
	 pre_vector_ref_app_key_set__8_cfa_info2(
	 (app_bglt) (obj_5970), val1914_5971);
   }
}



/* pre-vector-ref-app-key */
obj_t 
pre_vector_ref_app_key_59_cfa_info2(app_bglt obj_454)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 673 */
      return
	 (((app_bglt) CREF(obj_454))->key);
   }
}



/* _pre-vector-ref-app-key2894 */
obj_t 
_pre_vector_ref_app_key2894_92_cfa_info2(obj_t env_5972, obj_t obj_5973)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 673 */
      return
	 pre_vector_ref_app_key_59_cfa_info2(
	 (app_bglt) (obj_5973));
   }
}



/* pre-vector-ref-app-fun-set! */
obj_t 
pre_vector_ref_app_fun_set__200_cfa_info2(app_bglt obj_455, var_bglt val1915_456)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 60 */
      return
	 ((((app_bglt) CREF(obj_455))->fun) = ((var_bglt) val1915_456), BUNSPEC);
   }
}



/* _pre-vector-ref-app-fun-set! */
obj_t 
_pre_vector_ref_app_fun_set__225_cfa_info2(obj_t env_5974, obj_t obj_5975, obj_t val1915_5976)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 60 */
      return
	 pre_vector_ref_app_fun_set__200_cfa_info2(
	 (app_bglt) (obj_5975),
	 (var_bglt) (val1915_5976));
   }
}



/* pre-vector-ref-app-fun */
var_bglt 
pre_vector_ref_app_fun_8_cfa_info2(app_bglt obj_457)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 60 */
      return
	 (((app_bglt) CREF(obj_457))->fun);
   }
}



/* _pre-vector-ref-app-fun */
obj_t 
_pre_vector_ref_app_fun_218_cfa_info2(obj_t env_5977, obj_t obj_5978)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 60 */
      {		/* Cfa/cinfo2.scm 60 */
	 var_bglt aux_8171;
	 aux_8171 =
	    pre_vector_ref_app_fun_8_cfa_info2(
	    (app_bglt) (obj_5978));
	 return
	    (obj_t) (aux_8171);
      }
   }
}



/* pre-vector-ref-app-args-set! */
obj_t 
pre_vector_ref_app_args_set__156_cfa_info2(app_bglt obj_458, obj_t val1916_459)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 60 */
      return
	 ((((app_bglt) CREF(obj_458))->args) = ((obj_t) val1916_459), BUNSPEC);
   }
}



/* _pre-vector-ref-app-args-set! */
obj_t 
_pre_vector_ref_app_args_set__174_cfa_info2(obj_t env_5979, obj_t obj_5980, obj_t val1916_5981)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 60 */
      return
	 pre_vector_ref_app_args_set__156_cfa_info2(
	 (app_bglt) (obj_5980), val1916_5981);
   }
}



/* pre-vector-ref-app-args */
obj_t 
pre_vector_ref_app_args_207_cfa_info2(app_bglt obj_460)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 60 */
      return
	 (((app_bglt) CREF(obj_460))->args);
   }
}



/* _pre-vector-ref-app-args */
obj_t 
_pre_vector_ref_app_args_84_cfa_info2(obj_t env_5982, obj_t obj_5983)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 60 */
      return
	 pre_vector_ref_app_args_207_cfa_info2(
	 (app_bglt) (obj_5983));
   }
}



/* pre-vector-ref-app-stack-info-set! */
obj_t 
pre_vector_ref_app_stack_info_set__151_cfa_info2(app_bglt obj_461, obj_t val1917_462)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 704 */
      return
	 ((((app_bglt) CREF(obj_461))->stack_info_255) = ((obj_t) val1917_462), BUNSPEC);
   }
}



/* _pre-vector-ref-app-stack-info-set! */
obj_t 
_pre_vector_ref_app_stack_info_set__99_cfa_info2(obj_t env_5984, obj_t obj_5985, obj_t val1917_5986)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 704 */
      return
	 pre_vector_ref_app_stack_info_set__151_cfa_info2(
	 (app_bglt) (obj_5985), val1917_5986);
   }
}



/* pre-vector-ref-app-stack-info */
obj_t 
pre_vector_ref_app_stack_info_34_cfa_info2(app_bglt obj_463)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 704 */
      return
	 (((app_bglt) CREF(obj_463))->stack_info_255);
   }
}



/* _pre-vector-ref-app-stack-info */
obj_t 
_pre_vector_ref_app_stack_info_125_cfa_info2(obj_t env_5987, obj_t obj_5988)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 704 */
      return
	 pre_vector_ref_app_stack_info_34_cfa_info2(
	 (app_bglt) (obj_5988));
   }
}



/* allocate-pre-create-vector-app */
app_bglt 
allocate_pre_create_vector_app_95_cfa_info2()
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 57 */
      {		/* Cfa/cinfo2.scm 57 */
	 app_bglt new1905_2387;
	 new1905_2387 =
	    ((app_bglt) BREF(GC_MALLOC(sizeof(struct app))));
	 {	/* Cfa/cinfo2.scm 57 */
	    long arg2394_2388;
	    arg2394_2388 =
	       class_num_218___object(pre_create_vector_app_162_cfa_info2);
	    {	/* Cfa/cinfo2.scm 57 */
	       obj_t obj_3973;
	       obj_3973 =
		  (obj_t) (new1905_2387);
	       (((obj_t) CREF(obj_3973))->header = MAKE_HEADER(arg2394_2388, 0), BUNSPEC);
	    }
	 }
	 {	/* Cfa/cinfo2.scm 57 */
	    object_bglt aux_8191;
	    aux_8191 =
	       (object_bglt) (new1905_2387);
	    OBJECT_WIDENING_SET(aux_8191, BFALSE);
	 }
	 return new1905_2387;
      }
   }
}



/* _allocate-pre-create-vector-app */
obj_t 
_allocate_pre_create_vector_app_171_cfa_info2(obj_t env_5318)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 57 */
      {		/* Cfa/cinfo2.scm 57 */
	 app_bglt aux_8194;
	 aux_8194 =
	    allocate_pre_create_vector_app_95_cfa_info2();
	 return
	    (obj_t) (aux_8194);
      }
   }
}



/* pre-create-vector-app? */
bool_t 
pre_create_vector_app__191_cfa_info2(obj_t obj_467)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 57 */
      return
	 is_a__118___object(obj_467, pre_create_vector_app_162_cfa_info2);
   }
}



/* _pre-create-vector-app? */
obj_t 
_pre_create_vector_app__32_cfa_info2(obj_t env_5989, obj_t obj_5990)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 57 */
      {		/* Cfa/cinfo2.scm 57 */
	 bool_t aux_8198;
	 aux_8198 =
	    pre_create_vector_app__191_cfa_info2(obj_5990);
	 return
	    BBOOL(aux_8198);
      }
   }
}



/* widening-pre-create-vector-app */
pre_create_vector_app_162_bglt 
widening_pre_create_vector_app_57_cfa_info2(variable_bglt owner_468)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 57 */
      {		/* Cfa/cinfo2.scm 57 */
	 pre_create_vector_app_162_bglt new1900_3975;
	 new1900_3975 =
	    ((pre_create_vector_app_162_bglt) BREF(GC_MALLOC(sizeof(struct pre_create_vector_app_162))));
	 ((((pre_create_vector_app_162_bglt) CREF(new1900_3975))->owner) = ((variable_bglt) owner_468), BUNSPEC);
	 return new1900_3975;
      }
   }
}



/* _widening-pre-create-vector-app2895 */
obj_t 
_widening_pre_create_vector_app2895_55_cfa_info2(obj_t env_5991, obj_t owner_5992)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 57 */
      {		/* Cfa/cinfo2.scm 57 */
	 pre_create_vector_app_162_bglt aux_8203;
	 aux_8203 =
	    widening_pre_create_vector_app_57_cfa_info2(
	    (variable_bglt) (owner_5992));
	 return
	    (obj_t) (aux_8203);
      }
   }
}



/* make-pre-create-vector-app */
pre_create_vector_app_162_bglt 
make_pre_create_vector_app_207_cfa_info2(obj_t loc_469, type_bglt type_470, obj_t side_effect__165_471, obj_t key_472, var_bglt fun_473, obj_t args_474, obj_t stack_info_255_475, variable_bglt owner_476)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 57 */
      {		/* Cfa/cinfo2.scm 57 */
	 app_bglt aux1903_3977;
	 {	/* Cfa/cinfo2.scm 57 */
	    app_bglt res2831_3999;
	    {	/* ./Ast/node.scm 698 */
	       app_bglt new1248_3988;
	       new1248_3988 =
		  ((app_bglt) BREF(GC_MALLOC(sizeof(struct app))));
	       {	/* ./Ast/node.scm 698 */
		  long arg2541_3989;
		  arg2541_3989 =
		     class_num_218___object(app_ast_node);
		  {	/* ./Ast/node.scm 698 */
		     obj_t obj_3997;
		     obj_3997 =
			(obj_t) (new1248_3988);
		     (((obj_t) CREF(obj_3997))->header = MAKE_HEADER(arg2541_3989, 0), BUNSPEC);
		  }
	       }
	       {	/* ./Ast/node.scm 698 */
		  object_bglt aux_8211;
		  aux_8211 =
		     (object_bglt) (new1248_3988);
		  OBJECT_WIDENING_SET(aux_8211, BFALSE);
	       }
	       ((((app_bglt) CREF(new1248_3988))->loc) = ((obj_t) loc_469), BUNSPEC);
	       ((((app_bglt) CREF(new1248_3988))->type) = ((type_bglt) type_470), BUNSPEC);
	       ((((app_bglt) CREF(new1248_3988))->side_effect__165) = ((obj_t) side_effect__165_471), BUNSPEC);
	       ((((app_bglt) CREF(new1248_3988))->key) = ((obj_t) key_472), BUNSPEC);
	       ((((app_bglt) CREF(new1248_3988))->fun) = ((var_bglt) fun_473), BUNSPEC);
	       ((((app_bglt) CREF(new1248_3988))->args) = ((obj_t) args_474), BUNSPEC);
	       ((((app_bglt) CREF(new1248_3988))->stack_info_255) = ((obj_t) stack_info_255_475), BUNSPEC);
	       res2831_3999 = new1248_3988;
	    }
	    aux1903_3977 = res2831_3999;
	 }
	 {	/* Cfa/cinfo2.scm 57 */
	    pre_create_vector_app_162_bglt new1904_3978;
	    new1904_3978 =
	       ((pre_create_vector_app_162_bglt) (aux1903_3977));
	    {	/* Cfa/cinfo2.scm 57 */
	       long arg2395_3979;
	       arg2395_3979 =
		  class_num_218___object(pre_create_vector_app_162_cfa_info2);
	       {	/* Cfa/cinfo2.scm 57 */
		  obj_t obj_4000;
		  obj_4000 =
		     (obj_t) (new1904_3978);
		  (((obj_t) CREF(obj_4000))->header = MAKE_HEADER(arg2395_3979, 0), BUNSPEC);
	       }
	    }
	    {	/* Cfa/cinfo2.scm 57 */
	       pre_create_vector_app_162_bglt arg2396_3980;
	       {	/* Cfa/cinfo2.scm 57 */
		  pre_create_vector_app_162_bglt res2832_4005;
		  {	/* Cfa/cinfo2.scm 57 */
		     pre_create_vector_app_162_bglt new1900_4003;
		     new1900_4003 =
			((pre_create_vector_app_162_bglt) BREF(GC_MALLOC(sizeof(struct pre_create_vector_app_162))));
		     ((((pre_create_vector_app_162_bglt) CREF(new1900_4003))->owner) = ((variable_bglt) owner_476), BUNSPEC);
		     res2832_4005 = new1900_4003;
		  }
		  arg2396_3980 = res2832_4005;
	       }
	       {	/* Cfa/cinfo2.scm 57 */
		  obj_t aux_8229;
		  object_bglt aux_8227;
		  aux_8229 =
		     (obj_t) (arg2396_3980);
		  aux_8227 =
		     (object_bglt) (new1904_3978);
		  OBJECT_WIDENING_SET(aux_8227, aux_8229);
	       }
	    }
	    return new1904_3978;
	 }
      }
   }
}



/* _make-pre-create-vector-app */
obj_t 
_make_pre_create_vector_app_126_cfa_info2(obj_t env_5993, obj_t loc_5994, obj_t type_5995, obj_t side_effect__165_5996, obj_t key_5997, obj_t fun_5998, obj_t args_5999, obj_t stack_info_255_6000, obj_t owner_6001)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 57 */
      {		/* Cfa/cinfo2.scm 57 */
	 pre_create_vector_app_162_bglt aux_8232;
	 aux_8232 =
	    make_pre_create_vector_app_207_cfa_info2(loc_5994,
	    (type_bglt) (type_5995), side_effect__165_5996, key_5997,
	    (var_bglt) (fun_5998), args_5999, stack_info_255_6000,
	    (variable_bglt) (owner_6001));
	 return
	    (obj_t) (aux_8232);
      }
   }
}



/* pre-create-vector-app-loc */
obj_t 
pre_create_vector_app_loc_83_cfa_info2(app_bglt obj_477)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 661 */
      return
	 (((app_bglt) CREF(obj_477))->loc);
   }
}



/* _pre-create-vector-app-loc */
obj_t 
_pre_create_vector_app_loc_79_cfa_info2(obj_t env_6002, obj_t obj_6003)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 661 */
      return
	 pre_create_vector_app_loc_83_cfa_info2(
	 (app_bglt) (obj_6003));
   }
}



/* pre-create-vector-app-type-set! */
obj_t 
pre_create_vector_app_type_set__172_cfa_info2(app_bglt obj_478, type_bglt val1894_479)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 57 */
      return
	 ((((app_bglt) CREF(obj_478))->type) = ((type_bglt) val1894_479), BUNSPEC);
   }
}



/* _pre-create-vector-app-type-set! */
obj_t 
_pre_create_vector_app_type_set__81_cfa_info2(obj_t env_6004, obj_t obj_6005, obj_t val1894_6006)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 57 */
      return
	 pre_create_vector_app_type_set__172_cfa_info2(
	 (app_bglt) (obj_6005),
	 (type_bglt) (val1894_6006));
   }
}



/* pre-create-vector-app-type */
type_bglt 
pre_create_vector_app_type_138_cfa_info2(app_bglt obj_480)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 57 */
      return
	 (((app_bglt) CREF(obj_480))->type);
   }
}



/* _pre-create-vector-app-type */
obj_t 
_pre_create_vector_app_type_67_cfa_info2(obj_t env_6007, obj_t obj_6008)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 57 */
      {		/* Cfa/cinfo2.scm 57 */
	 type_bglt aux_8246;
	 aux_8246 =
	    pre_create_vector_app_type_138_cfa_info2(
	    (app_bglt) (obj_6008));
	 return
	    (obj_t) (aux_8246);
      }
   }
}



/* pre-create-vector-app-side-effect?-set! */
obj_t 
pre_create_vector_app_side_effect__set__203_cfa_info2(app_bglt obj_481, obj_t val1895_482)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 669 */
      return
	 ((((app_bglt) CREF(obj_481))->side_effect__165) = ((obj_t) val1895_482), BUNSPEC);
   }
}



/* _pre-create-vector-app-side-effect?-set! */
obj_t 
_pre_create_vector_app_side_effect__set__231_cfa_info2(obj_t env_6009, obj_t obj_6010, obj_t val1895_6011)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 669 */
      return
	 pre_create_vector_app_side_effect__set__203_cfa_info2(
	 (app_bglt) (obj_6010), val1895_6011);
   }
}



/* pre-create-vector-app-side-effect? */
obj_t 
pre_create_vector_app_side_effect__159_cfa_info2(app_bglt obj_483)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 669 */
      return
	 (((app_bglt) CREF(obj_483))->side_effect__165);
   }
}



/* _pre-create-vector-app-side-effect? */
obj_t 
_pre_create_vector_app_side_effect__129_cfa_info2(obj_t env_6012, obj_t obj_6013)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 669 */
      return
	 pre_create_vector_app_side_effect__159_cfa_info2(
	 (app_bglt) (obj_6013));
   }
}



/* pre-create-vector-app-key-set! */
obj_t 
pre_create_vector_app_key_set__58_cfa_info2(app_bglt obj_484, obj_t val1896_485)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 673 */
      return
	 ((((app_bglt) CREF(obj_484))->key) = ((obj_t) val1896_485), BUNSPEC);
   }
}



/* _pre-create-vector-app-key-set! */
obj_t 
_pre_create_vector_app_key_set__20_cfa_info2(obj_t env_6014, obj_t obj_6015, obj_t val1896_6016)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 673 */
      return
	 pre_create_vector_app_key_set__58_cfa_info2(
	 (app_bglt) (obj_6015), val1896_6016);
   }
}



/* pre-create-vector-app-key */
obj_t 
pre_create_vector_app_key_92_cfa_info2(app_bglt obj_486)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 673 */
      return
	 (((app_bglt) CREF(obj_486))->key);
   }
}



/* _pre-create-vector-app-key */
obj_t 
_pre_create_vector_app_key_224_cfa_info2(obj_t env_6017, obj_t obj_6018)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 673 */
      return
	 pre_create_vector_app_key_92_cfa_info2(
	 (app_bglt) (obj_6018));
   }
}



/* pre-create-vector-app-fun-set! */
obj_t 
pre_create_vector_app_fun_set__208_cfa_info2(app_bglt obj_487, var_bglt val1897_488)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 57 */
      return
	 ((((app_bglt) CREF(obj_487))->fun) = ((var_bglt) val1897_488), BUNSPEC);
   }
}



/* _pre-create-vector-app-fun-set! */
obj_t 
_pre_create_vector_app_fun_set__175_cfa_info2(obj_t env_6019, obj_t obj_6020, obj_t val1897_6021)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 57 */
      return
	 pre_create_vector_app_fun_set__208_cfa_info2(
	 (app_bglt) (obj_6020),
	 (var_bglt) (val1897_6021));
   }
}



/* pre-create-vector-app-fun */
var_bglt 
pre_create_vector_app_fun_107_cfa_info2(app_bglt obj_489)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 57 */
      return
	 (((app_bglt) CREF(obj_489))->fun);
   }
}



/* _pre-create-vector-app-fun */
obj_t 
_pre_create_vector_app_fun_133_cfa_info2(obj_t env_6022, obj_t obj_6023)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 57 */
      {		/* Cfa/cinfo2.scm 57 */
	 var_bglt aux_8267;
	 aux_8267 =
	    pre_create_vector_app_fun_107_cfa_info2(
	    (app_bglt) (obj_6023));
	 return
	    (obj_t) (aux_8267);
      }
   }
}



/* pre-create-vector-app-args-set! */
obj_t 
pre_create_vector_app_args_set__3_cfa_info2(app_bglt obj_490, obj_t val1898_491)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 57 */
      return
	 ((((app_bglt) CREF(obj_490))->args) = ((obj_t) val1898_491), BUNSPEC);
   }
}



/* _pre-create-vector-app-args-set! */
obj_t 
_pre_create_vector_app_args_set__12_cfa_info2(obj_t env_6024, obj_t obj_6025, obj_t val1898_6026)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 57 */
      return
	 pre_create_vector_app_args_set__3_cfa_info2(
	 (app_bglt) (obj_6025), val1898_6026);
   }
}



/* pre-create-vector-app-args */
obj_t 
pre_create_vector_app_args_163_cfa_info2(app_bglt obj_492)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 57 */
      return
	 (((app_bglt) CREF(obj_492))->args);
   }
}



/* _pre-create-vector-app-args */
obj_t 
_pre_create_vector_app_args_204_cfa_info2(obj_t env_6027, obj_t obj_6028)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 57 */
      return
	 pre_create_vector_app_args_163_cfa_info2(
	 (app_bglt) (obj_6028));
   }
}



/* pre-create-vector-app-stack-info-set! */
obj_t 
pre_create_vector_app_stack_info_set__211_cfa_info2(app_bglt obj_493, obj_t val1899_494)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 704 */
      return
	 ((((app_bglt) CREF(obj_493))->stack_info_255) = ((obj_t) val1899_494), BUNSPEC);
   }
}



/* _pre-create-vector-app-stack-info-set! */
obj_t 
_pre_create_vector_app_stack_info_set__170_cfa_info2(obj_t env_6029, obj_t obj_6030, obj_t val1899_6031)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 704 */
      return
	 pre_create_vector_app_stack_info_set__211_cfa_info2(
	 (app_bglt) (obj_6030), val1899_6031);
   }
}



/* pre-create-vector-app-stack-info */
obj_t 
pre_create_vector_app_stack_info_137_cfa_info2(app_bglt obj_495)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 704 */
      return
	 (((app_bglt) CREF(obj_495))->stack_info_255);
   }
}



/* _pre-create-vector-app-stack-info */
obj_t 
_pre_create_vector_app_stack_info_156_cfa_info2(obj_t env_6032, obj_t obj_6033)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 704 */
      return
	 pre_create_vector_app_stack_info_137_cfa_info2(
	 (app_bglt) (obj_6033));
   }
}



/* pre-create-vector-app-owner */
variable_bglt 
pre_create_vector_app_owner_119_cfa_info2(pre_create_vector_app_162_bglt obj_496)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 59 */
      {
	 obj_t aux_8283;
	 {	/* Cfa/cinfo2.scm 59 */
	    object_bglt aux_8284;
	    aux_8284 =
	       (object_bglt) (obj_496);
	    aux_8283 =
	       OBJECT_WIDENING(aux_8284);
	 }
	 return
	    (((pre_create_vector_app_162_bglt) CREF(aux_8283))->owner);
      }
   }
}



/* _pre-create-vector-app-owner */
obj_t 
_pre_create_vector_app_owner_163_cfa_info2(obj_t env_6034, obj_t obj_6035)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 59 */
      {		/* Cfa/cinfo2.scm 59 */
	 variable_bglt aux_8288;
	 aux_8288 =
	    pre_create_vector_app_owner_119_cfa_info2(
	    (pre_create_vector_app_162_bglt) (obj_6035));
	 return
	    (obj_t) (aux_8288);
      }
   }
}



/* allocate-pre-make-vector-app */
app_bglt 
allocate_pre_make_vector_app_231_cfa_info2()
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 54 */
      {		/* Cfa/cinfo2.scm 54 */
	 app_bglt new1887_2395;
	 new1887_2395 =
	    ((app_bglt) BREF(GC_MALLOC(sizeof(struct app))));
	 {	/* Cfa/cinfo2.scm 54 */
	    long arg2397_2396;
	    arg2397_2396 =
	       class_num_218___object(pre_make_vector_app_251_cfa_info2);
	    {	/* Cfa/cinfo2.scm 54 */
	       obj_t obj_4006;
	       obj_4006 =
		  (obj_t) (new1887_2395);
	       (((obj_t) CREF(obj_4006))->header = MAKE_HEADER(arg2397_2396, 0), BUNSPEC);
	    }
	 }
	 {	/* Cfa/cinfo2.scm 54 */
	    object_bglt aux_8296;
	    aux_8296 =
	       (object_bglt) (new1887_2395);
	    OBJECT_WIDENING_SET(aux_8296, BFALSE);
	 }
	 return new1887_2395;
      }
   }
}



/* _allocate-pre-make-vector-app */
obj_t 
_allocate_pre_make_vector_app_80_cfa_info2(obj_t env_5317)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 54 */
      {		/* Cfa/cinfo2.scm 54 */
	 app_bglt aux_8299;
	 aux_8299 =
	    allocate_pre_make_vector_app_231_cfa_info2();
	 return
	    (obj_t) (aux_8299);
      }
   }
}



/* pre-make-vector-app? */
bool_t 
pre_make_vector_app__111_cfa_info2(obj_t obj_500)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 54 */
      return
	 is_a__118___object(obj_500, pre_make_vector_app_251_cfa_info2);
   }
}



/* _pre-make-vector-app? */
obj_t 
_pre_make_vector_app__65_cfa_info2(obj_t env_6036, obj_t obj_6037)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 54 */
      {		/* Cfa/cinfo2.scm 54 */
	 bool_t aux_8303;
	 aux_8303 =
	    pre_make_vector_app__111_cfa_info2(obj_6037);
	 return
	    BBOOL(aux_8303);
      }
   }
}



/* widening-pre-make-vector-app */
pre_make_vector_app_251_bglt 
widening_pre_make_vector_app_235_cfa_info2(variable_bglt owner_501)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 54 */
      {		/* Cfa/cinfo2.scm 54 */
	 pre_make_vector_app_251_bglt new1882_4008;
	 new1882_4008 =
	    ((pre_make_vector_app_251_bglt) BREF(GC_MALLOC(sizeof(struct pre_make_vector_app_251))));
	 ((((pre_make_vector_app_251_bglt) CREF(new1882_4008))->owner) = ((variable_bglt) owner_501), BUNSPEC);
	 return new1882_4008;
      }
   }
}



/* _widening-pre-make-vector-app2896 */
obj_t 
_widening_pre_make_vector_app2896_63_cfa_info2(obj_t env_6038, obj_t owner_6039)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 54 */
      {		/* Cfa/cinfo2.scm 54 */
	 pre_make_vector_app_251_bglt aux_8308;
	 aux_8308 =
	    widening_pre_make_vector_app_235_cfa_info2(
	    (variable_bglt) (owner_6039));
	 return
	    (obj_t) (aux_8308);
      }
   }
}



/* make-pre-make-vector-app */
pre_make_vector_app_251_bglt 
make_pre_make_vector_app_107_cfa_info2(obj_t loc_502, type_bglt type_503, obj_t side_effect__165_504, obj_t key_505, var_bglt fun_506, obj_t args_507, obj_t stack_info_255_508, variable_bglt owner_509)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 54 */
      {		/* Cfa/cinfo2.scm 54 */
	 app_bglt aux1885_4010;
	 {	/* Cfa/cinfo2.scm 54 */
	    app_bglt res2833_4032;
	    {	/* ./Ast/node.scm 698 */
	       app_bglt new1248_4021;
	       new1248_4021 =
		  ((app_bglt) BREF(GC_MALLOC(sizeof(struct app))));
	       {	/* ./Ast/node.scm 698 */
		  long arg2541_4022;
		  arg2541_4022 =
		     class_num_218___object(app_ast_node);
		  {	/* ./Ast/node.scm 698 */
		     obj_t obj_4030;
		     obj_4030 =
			(obj_t) (new1248_4021);
		     (((obj_t) CREF(obj_4030))->header = MAKE_HEADER(arg2541_4022, 0), BUNSPEC);
		  }
	       }
	       {	/* ./Ast/node.scm 698 */
		  object_bglt aux_8316;
		  aux_8316 =
		     (object_bglt) (new1248_4021);
		  OBJECT_WIDENING_SET(aux_8316, BFALSE);
	       }
	       ((((app_bglt) CREF(new1248_4021))->loc) = ((obj_t) loc_502), BUNSPEC);
	       ((((app_bglt) CREF(new1248_4021))->type) = ((type_bglt) type_503), BUNSPEC);
	       ((((app_bglt) CREF(new1248_4021))->side_effect__165) = ((obj_t) side_effect__165_504), BUNSPEC);
	       ((((app_bglt) CREF(new1248_4021))->key) = ((obj_t) key_505), BUNSPEC);
	       ((((app_bglt) CREF(new1248_4021))->fun) = ((var_bglt) fun_506), BUNSPEC);
	       ((((app_bglt) CREF(new1248_4021))->args) = ((obj_t) args_507), BUNSPEC);
	       ((((app_bglt) CREF(new1248_4021))->stack_info_255) = ((obj_t) stack_info_255_508), BUNSPEC);
	       res2833_4032 = new1248_4021;
	    }
	    aux1885_4010 = res2833_4032;
	 }
	 {	/* Cfa/cinfo2.scm 54 */
	    pre_make_vector_app_251_bglt new1886_4011;
	    new1886_4011 =
	       ((pre_make_vector_app_251_bglt) (aux1885_4010));
	    {	/* Cfa/cinfo2.scm 54 */
	       long arg2398_4012;
	       arg2398_4012 =
		  class_num_218___object(pre_make_vector_app_251_cfa_info2);
	       {	/* Cfa/cinfo2.scm 54 */
		  obj_t obj_4033;
		  obj_4033 =
		     (obj_t) (new1886_4011);
		  (((obj_t) CREF(obj_4033))->header = MAKE_HEADER(arg2398_4012, 0), BUNSPEC);
	       }
	    }
	    {	/* Cfa/cinfo2.scm 54 */
	       pre_make_vector_app_251_bglt arg2399_4013;
	       {	/* Cfa/cinfo2.scm 54 */
		  pre_make_vector_app_251_bglt res2834_4038;
		  {	/* Cfa/cinfo2.scm 54 */
		     pre_make_vector_app_251_bglt new1882_4036;
		     new1882_4036 =
			((pre_make_vector_app_251_bglt) BREF(GC_MALLOC(sizeof(struct pre_make_vector_app_251))));
		     ((((pre_make_vector_app_251_bglt) CREF(new1882_4036))->owner) = ((variable_bglt) owner_509), BUNSPEC);
		     res2834_4038 = new1882_4036;
		  }
		  arg2399_4013 = res2834_4038;
	       }
	       {	/* Cfa/cinfo2.scm 54 */
		  obj_t aux_8334;
		  object_bglt aux_8332;
		  aux_8334 =
		     (obj_t) (arg2399_4013);
		  aux_8332 =
		     (object_bglt) (new1886_4011);
		  OBJECT_WIDENING_SET(aux_8332, aux_8334);
	       }
	    }
	    return new1886_4011;
	 }
      }
   }
}



/* _make-pre-make-vector-app */
obj_t 
_make_pre_make_vector_app_64_cfa_info2(obj_t env_6040, obj_t loc_6041, obj_t type_6042, obj_t side_effect__165_6043, obj_t key_6044, obj_t fun_6045, obj_t args_6046, obj_t stack_info_255_6047, obj_t owner_6048)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 54 */
      {		/* Cfa/cinfo2.scm 54 */
	 pre_make_vector_app_251_bglt aux_8337;
	 aux_8337 =
	    make_pre_make_vector_app_107_cfa_info2(loc_6041,
	    (type_bglt) (type_6042), side_effect__165_6043, key_6044,
	    (var_bglt) (fun_6045), args_6046, stack_info_255_6047,
	    (variable_bglt) (owner_6048));
	 return
	    (obj_t) (aux_8337);
      }
   }
}



/* pre-make-vector-app-loc */
obj_t 
pre_make_vector_app_loc_212_cfa_info2(app_bglt obj_510)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 661 */
      return
	 (((app_bglt) CREF(obj_510))->loc);
   }
}



/* _pre-make-vector-app-loc */
obj_t 
_pre_make_vector_app_loc_37_cfa_info2(obj_t env_6049, obj_t obj_6050)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 661 */
      return
	 pre_make_vector_app_loc_212_cfa_info2(
	 (app_bglt) (obj_6050));
   }
}



/* pre-make-vector-app-type-set! */
obj_t 
pre_make_vector_app_type_set__223_cfa_info2(app_bglt obj_511, type_bglt val1876_512)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 54 */
      return
	 ((((app_bglt) CREF(obj_511))->type) = ((type_bglt) val1876_512), BUNSPEC);
   }
}



/* _pre-make-vector-app-type-set! */
obj_t 
_pre_make_vector_app_type_set__29_cfa_info2(obj_t env_6051, obj_t obj_6052, obj_t val1876_6053)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 54 */
      return
	 pre_make_vector_app_type_set__223_cfa_info2(
	 (app_bglt) (obj_6052),
	 (type_bglt) (val1876_6053));
   }
}



/* pre-make-vector-app-type */
type_bglt 
pre_make_vector_app_type_229_cfa_info2(app_bglt obj_513)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 54 */
      return
	 (((app_bglt) CREF(obj_513))->type);
   }
}



/* _pre-make-vector-app-type */
obj_t 
_pre_make_vector_app_type_50_cfa_info2(obj_t env_6054, obj_t obj_6055)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 54 */
      {		/* Cfa/cinfo2.scm 54 */
	 type_bglt aux_8351;
	 aux_8351 =
	    pre_make_vector_app_type_229_cfa_info2(
	    (app_bglt) (obj_6055));
	 return
	    (obj_t) (aux_8351);
      }
   }
}



/* pre-make-vector-app-side-effect?-set! */
obj_t 
pre_make_vector_app_side_effect__set__39_cfa_info2(app_bglt obj_514, obj_t val1877_515)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 669 */
      return
	 ((((app_bglt) CREF(obj_514))->side_effect__165) = ((obj_t) val1877_515), BUNSPEC);
   }
}



/* _pre-make-vector-app-side-effect?-set! */
obj_t 
_pre_make_vector_app_side_effect__set__24_cfa_info2(obj_t env_6056, obj_t obj_6057, obj_t val1877_6058)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 669 */
      return
	 pre_make_vector_app_side_effect__set__39_cfa_info2(
	 (app_bglt) (obj_6057), val1877_6058);
   }
}



/* pre-make-vector-app-side-effect? */
obj_t 
pre_make_vector_app_side_effect__69_cfa_info2(app_bglt obj_516)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 669 */
      return
	 (((app_bglt) CREF(obj_516))->side_effect__165);
   }
}



/* _pre-make-vector-app-side-effect? */
obj_t 
_pre_make_vector_app_side_effect__120_cfa_info2(obj_t env_6059, obj_t obj_6060)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 669 */
      return
	 pre_make_vector_app_side_effect__69_cfa_info2(
	 (app_bglt) (obj_6060));
   }
}



/* pre-make-vector-app-key-set! */
obj_t 
pre_make_vector_app_key_set__238_cfa_info2(app_bglt obj_517, obj_t val1878_518)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 673 */
      return
	 ((((app_bglt) CREF(obj_517))->key) = ((obj_t) val1878_518), BUNSPEC);
   }
}



/* _pre-make-vector-app-key-set! */
obj_t 
_pre_make_vector_app_key_set__118_cfa_info2(obj_t env_6061, obj_t obj_6062, obj_t val1878_6063)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 673 */
      return
	 pre_make_vector_app_key_set__238_cfa_info2(
	 (app_bglt) (obj_6062), val1878_6063);
   }
}



/* pre-make-vector-app-key */
obj_t 
pre_make_vector_app_key_53_cfa_info2(app_bglt obj_519)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 673 */
      return
	 (((app_bglt) CREF(obj_519))->key);
   }
}



/* _pre-make-vector-app-key */
obj_t 
_pre_make_vector_app_key_241_cfa_info2(obj_t env_6064, obj_t obj_6065)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 673 */
      return
	 pre_make_vector_app_key_53_cfa_info2(
	 (app_bglt) (obj_6065));
   }
}



/* pre-make-vector-app-fun-set! */
obj_t 
pre_make_vector_app_fun_set__108_cfa_info2(app_bglt obj_520, var_bglt val1879_521)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 54 */
      return
	 ((((app_bglt) CREF(obj_520))->fun) = ((var_bglt) val1879_521), BUNSPEC);
   }
}



/* _pre-make-vector-app-fun-set! */
obj_t 
_pre_make_vector_app_fun_set__159_cfa_info2(obj_t env_6066, obj_t obj_6067, obj_t val1879_6068)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 54 */
      return
	 pre_make_vector_app_fun_set__108_cfa_info2(
	 (app_bglt) (obj_6067),
	 (var_bglt) (val1879_6068));
   }
}



/* pre-make-vector-app-fun */
var_bglt 
pre_make_vector_app_fun_151_cfa_info2(app_bglt obj_522)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 54 */
      return
	 (((app_bglt) CREF(obj_522))->fun);
   }
}



/* _pre-make-vector-app-fun */
obj_t 
_pre_make_vector_app_fun_41_cfa_info2(obj_t env_6069, obj_t obj_6070)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 54 */
      {		/* Cfa/cinfo2.scm 54 */
	 var_bglt aux_8372;
	 aux_8372 =
	    pre_make_vector_app_fun_151_cfa_info2(
	    (app_bglt) (obj_6070));
	 return
	    (obj_t) (aux_8372);
      }
   }
}



/* pre-make-vector-app-args-set! */
obj_t 
pre_make_vector_app_args_set__250_cfa_info2(app_bglt obj_523, obj_t val1880_524)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 54 */
      return
	 ((((app_bglt) CREF(obj_523))->args) = ((obj_t) val1880_524), BUNSPEC);
   }
}



/* _pre-make-vector-app-args-set! */
obj_t 
_pre_make_vector_app_args_set__164_cfa_info2(obj_t env_6071, obj_t obj_6072, obj_t val1880_6073)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 54 */
      return
	 pre_make_vector_app_args_set__250_cfa_info2(
	 (app_bglt) (obj_6072), val1880_6073);
   }
}



/* pre-make-vector-app-args */
obj_t 
pre_make_vector_app_args_212_cfa_info2(app_bglt obj_525)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 54 */
      return
	 (((app_bglt) CREF(obj_525))->args);
   }
}



/* _pre-make-vector-app-args */
obj_t 
_pre_make_vector_app_args_80_cfa_info2(obj_t env_6074, obj_t obj_6075)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 54 */
      return
	 pre_make_vector_app_args_212_cfa_info2(
	 (app_bglt) (obj_6075));
   }
}



/* pre-make-vector-app-stack-info-set! */
obj_t 
pre_make_vector_app_stack_info_set__175_cfa_info2(app_bglt obj_526, obj_t val1881_527)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 704 */
      return
	 ((((app_bglt) CREF(obj_526))->stack_info_255) = ((obj_t) val1881_527), BUNSPEC);
   }
}



/* _pre-make-vector-app-stack-info-set! */
obj_t 
_pre_make_vector_app_stack_info_set__250_cfa_info2(obj_t env_6076, obj_t obj_6077, obj_t val1881_6078)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 704 */
      return
	 pre_make_vector_app_stack_info_set__175_cfa_info2(
	 (app_bglt) (obj_6077), val1881_6078);
   }
}



/* pre-make-vector-app-stack-info */
obj_t 
pre_make_vector_app_stack_info_133_cfa_info2(app_bglt obj_528)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 704 */
      return
	 (((app_bglt) CREF(obj_528))->stack_info_255);
   }
}



/* _pre-make-vector-app-stack-info */
obj_t 
_pre_make_vector_app_stack_info_212_cfa_info2(obj_t env_6079, obj_t obj_6080)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 704 */
      return
	 pre_make_vector_app_stack_info_133_cfa_info2(
	 (app_bglt) (obj_6080));
   }
}



/* pre-make-vector-app-owner */
variable_bglt 
pre_make_vector_app_owner_220_cfa_info2(pre_make_vector_app_251_bglt obj_529)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 56 */
      {
	 obj_t aux_8388;
	 {	/* Cfa/cinfo2.scm 56 */
	    object_bglt aux_8389;
	    aux_8389 =
	       (object_bglt) (obj_529);
	    aux_8388 =
	       OBJECT_WIDENING(aux_8389);
	 }
	 return
	    (((pre_make_vector_app_251_bglt) CREF(aux_8388))->owner);
      }
   }
}



/* _pre-make-vector-app-owner */
obj_t 
_pre_make_vector_app_owner_96_cfa_info2(obj_t env_6081, obj_t obj_6082)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 56 */
      {		/* Cfa/cinfo2.scm 56 */
	 variable_bglt aux_8393;
	 aux_8393 =
	    pre_make_vector_app_owner_220_cfa_info2(
	    (pre_make_vector_app_251_bglt) (obj_6082));
	 return
	    (obj_t) (aux_8393);
      }
   }
}



/* allocate-procedure-set!-app */
app_bglt 
allocate_procedure_set__app_12_cfa_info2()
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 51 */
      {		/* Cfa/cinfo2.scm 51 */
	 app_bglt new1869_2403;
	 new1869_2403 =
	    ((app_bglt) BREF(GC_MALLOC(sizeof(struct app))));
	 {	/* Cfa/cinfo2.scm 51 */
	    long arg2400_2404;
	    arg2400_2404 =
	       class_num_218___object(procedure_set__app_32_cfa_info2);
	    {	/* Cfa/cinfo2.scm 51 */
	       obj_t obj_4039;
	       obj_4039 =
		  (obj_t) (new1869_2403);
	       (((obj_t) CREF(obj_4039))->header = MAKE_HEADER(arg2400_2404, 0), BUNSPEC);
	    }
	 }
	 {	/* Cfa/cinfo2.scm 51 */
	    object_bglt aux_8401;
	    aux_8401 =
	       (object_bglt) (new1869_2403);
	    OBJECT_WIDENING_SET(aux_8401, BFALSE);
	 }
	 return new1869_2403;
      }
   }
}



/* _allocate-procedure-set!-app */
obj_t 
_allocate_procedure_set__app_204_cfa_info2(obj_t env_5316)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 51 */
      {		/* Cfa/cinfo2.scm 51 */
	 app_bglt aux_8404;
	 aux_8404 =
	    allocate_procedure_set__app_12_cfa_info2();
	 return
	    (obj_t) (aux_8404);
      }
   }
}



/* procedure-set!-app? */
bool_t 
procedure_set__app__65_cfa_info2(obj_t obj_533)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 51 */
      return
	 is_a__118___object(obj_533, procedure_set__app_32_cfa_info2);
   }
}



/* _procedure-set!-app? */
obj_t 
_procedure_set__app__159_cfa_info2(obj_t env_6083, obj_t obj_6084)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 51 */
      {		/* Cfa/cinfo2.scm 51 */
	 bool_t aux_8408;
	 aux_8408 =
	    procedure_set__app__65_cfa_info2(obj_6084);
	 return
	    BBOOL(aux_8408);
      }
   }
}



/* widening-procedure-set!-app */
procedure_set__app_32_bglt 
widening_procedure_set__app_138_cfa_info2(approx_bglt approx_534)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 51 */
      {		/* Cfa/cinfo2.scm 51 */
	 procedure_set__app_32_bglt new1864_4041;
	 new1864_4041 =
	    ((procedure_set__app_32_bglt) BREF(GC_MALLOC(sizeof(struct procedure_set__app_32))));
	 ((((procedure_set__app_32_bglt) CREF(new1864_4041))->approx) = ((approx_bglt) approx_534), BUNSPEC);
	 return new1864_4041;
      }
   }
}



/* _widening-procedure-set!-app2897 */
obj_t 
_widening_procedure_set__app2897_196_cfa_info2(obj_t env_6085, obj_t approx_6086)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 51 */
      {		/* Cfa/cinfo2.scm 51 */
	 procedure_set__app_32_bglt aux_8413;
	 aux_8413 =
	    widening_procedure_set__app_138_cfa_info2(
	    (approx_bglt) (approx_6086));
	 return
	    (obj_t) (aux_8413);
      }
   }
}



/* make-procedure-set!-app */
procedure_set__app_32_bglt 
make_procedure_set__app_42_cfa_info2(obj_t loc_535, type_bglt type_536, obj_t side_effect__165_537, obj_t key_538, var_bglt fun_539, obj_t args_540, obj_t stack_info_255_541, approx_bglt approx_542)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 51 */
      {		/* Cfa/cinfo2.scm 51 */
	 app_bglt aux1867_4043;
	 {	/* Cfa/cinfo2.scm 51 */
	    app_bglt res2835_4065;
	    {	/* ./Ast/node.scm 698 */
	       app_bglt new1248_4054;
	       new1248_4054 =
		  ((app_bglt) BREF(GC_MALLOC(sizeof(struct app))));
	       {	/* ./Ast/node.scm 698 */
		  long arg2541_4055;
		  arg2541_4055 =
		     class_num_218___object(app_ast_node);
		  {	/* ./Ast/node.scm 698 */
		     obj_t obj_4063;
		     obj_4063 =
			(obj_t) (new1248_4054);
		     (((obj_t) CREF(obj_4063))->header = MAKE_HEADER(arg2541_4055, 0), BUNSPEC);
		  }
	       }
	       {	/* ./Ast/node.scm 698 */
		  object_bglt aux_8421;
		  aux_8421 =
		     (object_bglt) (new1248_4054);
		  OBJECT_WIDENING_SET(aux_8421, BFALSE);
	       }
	       ((((app_bglt) CREF(new1248_4054))->loc) = ((obj_t) loc_535), BUNSPEC);
	       ((((app_bglt) CREF(new1248_4054))->type) = ((type_bglt) type_536), BUNSPEC);
	       ((((app_bglt) CREF(new1248_4054))->side_effect__165) = ((obj_t) side_effect__165_537), BUNSPEC);
	       ((((app_bglt) CREF(new1248_4054))->key) = ((obj_t) key_538), BUNSPEC);
	       ((((app_bglt) CREF(new1248_4054))->fun) = ((var_bglt) fun_539), BUNSPEC);
	       ((((app_bglt) CREF(new1248_4054))->args) = ((obj_t) args_540), BUNSPEC);
	       ((((app_bglt) CREF(new1248_4054))->stack_info_255) = ((obj_t) stack_info_255_541), BUNSPEC);
	       res2835_4065 = new1248_4054;
	    }
	    aux1867_4043 = res2835_4065;
	 }
	 {	/* Cfa/cinfo2.scm 51 */
	    procedure_set__app_32_bglt new1868_4044;
	    new1868_4044 =
	       ((procedure_set__app_32_bglt) (aux1867_4043));
	    {	/* Cfa/cinfo2.scm 51 */
	       long arg2401_4045;
	       arg2401_4045 =
		  class_num_218___object(procedure_set__app_32_cfa_info2);
	       {	/* Cfa/cinfo2.scm 51 */
		  obj_t obj_4066;
		  obj_4066 =
		     (obj_t) (new1868_4044);
		  (((obj_t) CREF(obj_4066))->header = MAKE_HEADER(arg2401_4045, 0), BUNSPEC);
	       }
	    }
	    {	/* Cfa/cinfo2.scm 51 */
	       procedure_set__app_32_bglt arg2402_4046;
	       {	/* Cfa/cinfo2.scm 51 */
		  procedure_set__app_32_bglt res2836_4071;
		  {	/* Cfa/cinfo2.scm 51 */
		     procedure_set__app_32_bglt new1864_4069;
		     new1864_4069 =
			((procedure_set__app_32_bglt) BREF(GC_MALLOC(sizeof(struct procedure_set__app_32))));
		     ((((procedure_set__app_32_bglt) CREF(new1864_4069))->approx) = ((approx_bglt) approx_542), BUNSPEC);
		     res2836_4071 = new1864_4069;
		  }
		  arg2402_4046 = res2836_4071;
	       }
	       {	/* Cfa/cinfo2.scm 51 */
		  obj_t aux_8439;
		  object_bglt aux_8437;
		  aux_8439 =
		     (obj_t) (arg2402_4046);
		  aux_8437 =
		     (object_bglt) (new1868_4044);
		  OBJECT_WIDENING_SET(aux_8437, aux_8439);
	       }
	    }
	    return new1868_4044;
	 }
      }
   }
}



/* _make-procedure-set!-app */
obj_t 
_make_procedure_set__app_65_cfa_info2(obj_t env_6087, obj_t loc_6088, obj_t type_6089, obj_t side_effect__165_6090, obj_t key_6091, obj_t fun_6092, obj_t args_6093, obj_t stack_info_255_6094, obj_t approx_6095)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 51 */
      {		/* Cfa/cinfo2.scm 51 */
	 procedure_set__app_32_bglt aux_8442;
	 aux_8442 =
	    make_procedure_set__app_42_cfa_info2(loc_6088,
	    (type_bglt) (type_6089), side_effect__165_6090, key_6091,
	    (var_bglt) (fun_6092), args_6093, stack_info_255_6094,
	    (approx_bglt) (approx_6095));
	 return
	    (obj_t) (aux_8442);
      }
   }
}



/* procedure-set!-app-loc */
obj_t 
procedure_set__app_loc_37_cfa_info2(app_bglt obj_543)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 661 */
      return
	 (((app_bglt) CREF(obj_543))->loc);
   }
}



/* _procedure-set!-app-loc */
obj_t 
_procedure_set__app_loc_232_cfa_info2(obj_t env_6096, obj_t obj_6097)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 661 */
      return
	 procedure_set__app_loc_37_cfa_info2(
	 (app_bglt) (obj_6097));
   }
}



/* procedure-set!-app-type-set! */
obj_t 
procedure_set__app_type_set__29_cfa_info2(app_bglt obj_544, type_bglt val1858_545)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 51 */
      return
	 ((((app_bglt) CREF(obj_544))->type) = ((type_bglt) val1858_545), BUNSPEC);
   }
}



/* _procedure-set!-app-type-set! */
obj_t 
_procedure_set__app_type_set__16_cfa_info2(obj_t env_6098, obj_t obj_6099, obj_t val1858_6100)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 51 */
      return
	 procedure_set__app_type_set__29_cfa_info2(
	 (app_bglt) (obj_6099),
	 (type_bglt) (val1858_6100));
   }
}



/* procedure-set!-app-type */
type_bglt 
procedure_set__app_type_50_cfa_info2(app_bglt obj_546)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 51 */
      return
	 (((app_bglt) CREF(obj_546))->type);
   }
}



/* _procedure-set!-app-type */
obj_t 
_procedure_set__app_type_198_cfa_info2(obj_t env_6101, obj_t obj_6102)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 51 */
      {		/* Cfa/cinfo2.scm 51 */
	 type_bglt aux_8456;
	 aux_8456 =
	    procedure_set__app_type_50_cfa_info2(
	    (app_bglt) (obj_6102));
	 return
	    (obj_t) (aux_8456);
      }
   }
}



/* procedure-set!-app-side-effect?-set! */
obj_t 
procedure_set__app_side_effect__set__24_cfa_info2(app_bglt obj_547, obj_t val1859_548)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 669 */
      return
	 ((((app_bglt) CREF(obj_547))->side_effect__165) = ((obj_t) val1859_548), BUNSPEC);
   }
}



/* _procedure-set!-app-side-effect?-set! */
obj_t 
_procedure_set__app_side_effect__set__166_cfa_info2(obj_t env_6103, obj_t obj_6104, obj_t val1859_6105)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 669 */
      return
	 procedure_set__app_side_effect__set__24_cfa_info2(
	 (app_bglt) (obj_6104), val1859_6105);
   }
}



/* procedure-set!-app-side-effect? */
obj_t 
procedure_set__app_side_effect__120_cfa_info2(app_bglt obj_549)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 669 */
      return
	 (((app_bglt) CREF(obj_549))->side_effect__165);
   }
}



/* _procedure-set!-app-side-effect? */
obj_t 
_procedure_set__app_side_effect__112_cfa_info2(obj_t env_6106, obj_t obj_6107)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 669 */
      return
	 procedure_set__app_side_effect__120_cfa_info2(
	 (app_bglt) (obj_6107));
   }
}



/* procedure-set!-app-key-set! */
obj_t 
procedure_set__app_key_set__118_cfa_info2(app_bglt obj_550, obj_t val1860_551)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 673 */
      return
	 ((((app_bglt) CREF(obj_550))->key) = ((obj_t) val1860_551), BUNSPEC);
   }
}



/* _procedure-set!-app-key-set!2898 */
obj_t 
_procedure_set__app_key_set_2898_103_cfa_info2(obj_t env_6108, obj_t obj_6109, obj_t val1860_6110)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 673 */
      return
	 procedure_set__app_key_set__118_cfa_info2(
	 (app_bglt) (obj_6109), val1860_6110);
   }
}



/* procedure-set!-app-key */
obj_t 
procedure_set__app_key_241_cfa_info2(app_bglt obj_552)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 673 */
      return
	 (((app_bglt) CREF(obj_552))->key);
   }
}



/* _procedure-set!-app-key2899 */
obj_t 
_procedure_set__app_key2899_177_cfa_info2(obj_t env_6111, obj_t obj_6112)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 673 */
      return
	 procedure_set__app_key_241_cfa_info2(
	 (app_bglt) (obj_6112));
   }
}



/* procedure-set!-app-fun-set! */
obj_t 
procedure_set__app_fun_set__159_cfa_info2(app_bglt obj_553, var_bglt val1861_554)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 51 */
      return
	 ((((app_bglt) CREF(obj_553))->fun) = ((var_bglt) val1861_554), BUNSPEC);
   }
}



/* _procedure-set!-app-fun-set! */
obj_t 
_procedure_set__app_fun_set__233_cfa_info2(obj_t env_6113, obj_t obj_6114, obj_t val1861_6115)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 51 */
      return
	 procedure_set__app_fun_set__159_cfa_info2(
	 (app_bglt) (obj_6114),
	 (var_bglt) (val1861_6115));
   }
}



/* procedure-set!-app-fun */
var_bglt 
procedure_set__app_fun_41_cfa_info2(app_bglt obj_555)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 51 */
      return
	 (((app_bglt) CREF(obj_555))->fun);
   }
}



/* _procedure-set!-app-fun */
obj_t 
_procedure_set__app_fun_119_cfa_info2(obj_t env_6116, obj_t obj_6117)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 51 */
      {		/* Cfa/cinfo2.scm 51 */
	 var_bglt aux_8477;
	 aux_8477 =
	    procedure_set__app_fun_41_cfa_info2(
	    (app_bglt) (obj_6117));
	 return
	    (obj_t) (aux_8477);
      }
   }
}



/* procedure-set!-app-args-set! */
obj_t 
procedure_set__app_args_set__164_cfa_info2(app_bglt obj_556, obj_t val1862_557)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 51 */
      return
	 ((((app_bglt) CREF(obj_556))->args) = ((obj_t) val1862_557), BUNSPEC);
   }
}



/* _procedure-set!-app-args-set! */
obj_t 
_procedure_set__app_args_set__91_cfa_info2(obj_t env_6118, obj_t obj_6119, obj_t val1862_6120)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 51 */
      return
	 procedure_set__app_args_set__164_cfa_info2(
	 (app_bglt) (obj_6119), val1862_6120);
   }
}



/* procedure-set!-app-args */
obj_t 
procedure_set__app_args_80_cfa_info2(app_bglt obj_558)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 51 */
      return
	 (((app_bglt) CREF(obj_558))->args);
   }
}



/* _procedure-set!-app-args */
obj_t 
_procedure_set__app_args_0_cfa_info2(obj_t env_6121, obj_t obj_6122)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 51 */
      return
	 procedure_set__app_args_80_cfa_info2(
	 (app_bglt) (obj_6122));
   }
}



/* procedure-set!-app-stack-info-set! */
obj_t 
procedure_set__app_stack_info_set__250_cfa_info2(app_bglt obj_559, obj_t val1863_560)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 704 */
      return
	 ((((app_bglt) CREF(obj_559))->stack_info_255) = ((obj_t) val1863_560), BUNSPEC);
   }
}



/* _procedure-set!-app-stack-info-set! */
obj_t 
_procedure_set__app_stack_info_set__157_cfa_info2(obj_t env_6123, obj_t obj_6124, obj_t val1863_6125)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 704 */
      return
	 procedure_set__app_stack_info_set__250_cfa_info2(
	 (app_bglt) (obj_6124), val1863_6125);
   }
}



/* procedure-set!-app-stack-info */
obj_t 
procedure_set__app_stack_info_212_cfa_info2(app_bglt obj_561)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 704 */
      return
	 (((app_bglt) CREF(obj_561))->stack_info_255);
   }
}



/* _procedure-set!-app-stack-info */
obj_t 
_procedure_set__app_stack_info_94_cfa_info2(obj_t env_6126, obj_t obj_6127)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 704 */
      return
	 procedure_set__app_stack_info_212_cfa_info2(
	 (app_bglt) (obj_6127));
   }
}



/* procedure-set!-app-approx */
approx_bglt 
procedure_set__app_approx_70_cfa_info2(procedure_set__app_32_bglt obj_562)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 51 */
      {
	 obj_t aux_8493;
	 {	/* Cfa/cinfo2.scm 51 */
	    object_bglt aux_8494;
	    aux_8494 =
	       (object_bglt) (obj_562);
	    aux_8493 =
	       OBJECT_WIDENING(aux_8494);
	 }
	 return
	    (((procedure_set__app_32_bglt) CREF(aux_8493))->approx);
      }
   }
}



/* _procedure-set!-app-approx */
obj_t 
_procedure_set__app_approx_20_cfa_info2(obj_t env_6128, obj_t obj_6129)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 51 */
      {		/* Cfa/cinfo2.scm 51 */
	 approx_bglt aux_8498;
	 aux_8498 =
	    procedure_set__app_approx_70_cfa_info2(
	    (procedure_set__app_32_bglt) (obj_6129));
	 return
	    (obj_t) (aux_8498);
      }
   }
}



/* allocate-procedure-ref-app */
app_bglt 
allocate_procedure_ref_app_165_cfa_info2()
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 50 */
      {		/* Cfa/cinfo2.scm 50 */
	 app_bglt new1851_2411;
	 new1851_2411 =
	    ((app_bglt) BREF(GC_MALLOC(sizeof(struct app))));
	 {	/* Cfa/cinfo2.scm 50 */
	    long arg2403_2412;
	    arg2403_2412 =
	       class_num_218___object(procedure_ref_app_49_cfa_info2);
	    {	/* Cfa/cinfo2.scm 50 */
	       obj_t obj_4072;
	       obj_4072 =
		  (obj_t) (new1851_2411);
	       (((obj_t) CREF(obj_4072))->header = MAKE_HEADER(arg2403_2412, 0), BUNSPEC);
	    }
	 }
	 {	/* Cfa/cinfo2.scm 50 */
	    object_bglt aux_8506;
	    aux_8506 =
	       (object_bglt) (new1851_2411);
	    OBJECT_WIDENING_SET(aux_8506, BFALSE);
	 }
	 return new1851_2411;
      }
   }
}



/* _allocate-procedure-ref-app */
obj_t 
_allocate_procedure_ref_app_56_cfa_info2(obj_t env_5315)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 50 */
      {		/* Cfa/cinfo2.scm 50 */
	 app_bglt aux_8509;
	 aux_8509 =
	    allocate_procedure_ref_app_165_cfa_info2();
	 return
	    (obj_t) (aux_8509);
      }
   }
}



/* procedure-ref-app? */
bool_t 
procedure_ref_app__140_cfa_info2(obj_t obj_566)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 50 */
      return
	 is_a__118___object(obj_566, procedure_ref_app_49_cfa_info2);
   }
}



/* _procedure-ref-app? */
obj_t 
_procedure_ref_app__14_cfa_info2(obj_t env_6130, obj_t obj_6131)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 50 */
      {		/* Cfa/cinfo2.scm 50 */
	 bool_t aux_8513;
	 aux_8513 =
	    procedure_ref_app__140_cfa_info2(obj_6131);
	 return
	    BBOOL(aux_8513);
      }
   }
}



/* widening-procedure-ref-app */
procedure_ref_app_49_bglt 
widening_procedure_ref_app_88_cfa_info2(approx_bglt approx_567)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 50 */
      {		/* Cfa/cinfo2.scm 50 */
	 procedure_ref_app_49_bglt new1846_4074;
	 new1846_4074 =
	    ((procedure_ref_app_49_bglt) BREF(GC_MALLOC(sizeof(struct procedure_ref_app_49))));
	 ((((procedure_ref_app_49_bglt) CREF(new1846_4074))->approx) = ((approx_bglt) approx_567), BUNSPEC);
	 return new1846_4074;
      }
   }
}



/* _widening-procedure-ref-app2900 */
obj_t 
_widening_procedure_ref_app2900_64_cfa_info2(obj_t env_6132, obj_t approx_6133)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 50 */
      {		/* Cfa/cinfo2.scm 50 */
	 procedure_ref_app_49_bglt aux_8518;
	 aux_8518 =
	    widening_procedure_ref_app_88_cfa_info2(
	    (approx_bglt) (approx_6133));
	 return
	    (obj_t) (aux_8518);
      }
   }
}



/* make-procedure-ref-app */
procedure_ref_app_49_bglt 
make_procedure_ref_app_197_cfa_info2(obj_t loc_568, type_bglt type_569, obj_t side_effect__165_570, obj_t key_571, var_bglt fun_572, obj_t args_573, obj_t stack_info_255_574, approx_bglt approx_575)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 50 */
      {		/* Cfa/cinfo2.scm 50 */
	 app_bglt aux1849_4076;
	 {	/* Cfa/cinfo2.scm 50 */
	    app_bglt res2837_4098;
	    {	/* ./Ast/node.scm 698 */
	       app_bglt new1248_4087;
	       new1248_4087 =
		  ((app_bglt) BREF(GC_MALLOC(sizeof(struct app))));
	       {	/* ./Ast/node.scm 698 */
		  long arg2541_4088;
		  arg2541_4088 =
		     class_num_218___object(app_ast_node);
		  {	/* ./Ast/node.scm 698 */
		     obj_t obj_4096;
		     obj_4096 =
			(obj_t) (new1248_4087);
		     (((obj_t) CREF(obj_4096))->header = MAKE_HEADER(arg2541_4088, 0), BUNSPEC);
		  }
	       }
	       {	/* ./Ast/node.scm 698 */
		  object_bglt aux_8526;
		  aux_8526 =
		     (object_bglt) (new1248_4087);
		  OBJECT_WIDENING_SET(aux_8526, BFALSE);
	       }
	       ((((app_bglt) CREF(new1248_4087))->loc) = ((obj_t) loc_568), BUNSPEC);
	       ((((app_bglt) CREF(new1248_4087))->type) = ((type_bglt) type_569), BUNSPEC);
	       ((((app_bglt) CREF(new1248_4087))->side_effect__165) = ((obj_t) side_effect__165_570), BUNSPEC);
	       ((((app_bglt) CREF(new1248_4087))->key) = ((obj_t) key_571), BUNSPEC);
	       ((((app_bglt) CREF(new1248_4087))->fun) = ((var_bglt) fun_572), BUNSPEC);
	       ((((app_bglt) CREF(new1248_4087))->args) = ((obj_t) args_573), BUNSPEC);
	       ((((app_bglt) CREF(new1248_4087))->stack_info_255) = ((obj_t) stack_info_255_574), BUNSPEC);
	       res2837_4098 = new1248_4087;
	    }
	    aux1849_4076 = res2837_4098;
	 }
	 {	/* Cfa/cinfo2.scm 50 */
	    procedure_ref_app_49_bglt new1850_4077;
	    new1850_4077 =
	       ((procedure_ref_app_49_bglt) (aux1849_4076));
	    {	/* Cfa/cinfo2.scm 50 */
	       long arg2404_4078;
	       arg2404_4078 =
		  class_num_218___object(procedure_ref_app_49_cfa_info2);
	       {	/* Cfa/cinfo2.scm 50 */
		  obj_t obj_4099;
		  obj_4099 =
		     (obj_t) (new1850_4077);
		  (((obj_t) CREF(obj_4099))->header = MAKE_HEADER(arg2404_4078, 0), BUNSPEC);
	       }
	    }
	    {	/* Cfa/cinfo2.scm 50 */
	       procedure_ref_app_49_bglt arg2405_4079;
	       {	/* Cfa/cinfo2.scm 50 */
		  procedure_ref_app_49_bglt res2838_4104;
		  {	/* Cfa/cinfo2.scm 50 */
		     procedure_ref_app_49_bglt new1846_4102;
		     new1846_4102 =
			((procedure_ref_app_49_bglt) BREF(GC_MALLOC(sizeof(struct procedure_ref_app_49))));
		     ((((procedure_ref_app_49_bglt) CREF(new1846_4102))->approx) = ((approx_bglt) approx_575), BUNSPEC);
		     res2838_4104 = new1846_4102;
		  }
		  arg2405_4079 = res2838_4104;
	       }
	       {	/* Cfa/cinfo2.scm 50 */
		  obj_t aux_8544;
		  object_bglt aux_8542;
		  aux_8544 =
		     (obj_t) (arg2405_4079);
		  aux_8542 =
		     (object_bglt) (new1850_4077);
		  OBJECT_WIDENING_SET(aux_8542, aux_8544);
	       }
	    }
	    return new1850_4077;
	 }
      }
   }
}



/* _make-procedure-ref-app */
obj_t 
_make_procedure_ref_app_227_cfa_info2(obj_t env_6134, obj_t loc_6135, obj_t type_6136, obj_t side_effect__165_6137, obj_t key_6138, obj_t fun_6139, obj_t args_6140, obj_t stack_info_255_6141, obj_t approx_6142)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 50 */
      {		/* Cfa/cinfo2.scm 50 */
	 procedure_ref_app_49_bglt aux_8547;
	 aux_8547 =
	    make_procedure_ref_app_197_cfa_info2(loc_6135,
	    (type_bglt) (type_6136), side_effect__165_6137, key_6138,
	    (var_bglt) (fun_6139), args_6140, stack_info_255_6141,
	    (approx_bglt) (approx_6142));
	 return
	    (obj_t) (aux_8547);
      }
   }
}



/* procedure-ref-app-loc */
obj_t 
procedure_ref_app_loc_250_cfa_info2(app_bglt obj_576)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 661 */
      return
	 (((app_bglt) CREF(obj_576))->loc);
   }
}



/* _procedure-ref-app-loc */
obj_t 
_procedure_ref_app_loc_33_cfa_info2(obj_t env_6143, obj_t obj_6144)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 661 */
      return
	 procedure_ref_app_loc_250_cfa_info2(
	 (app_bglt) (obj_6144));
   }
}



/* procedure-ref-app-type-set! */
obj_t 
procedure_ref_app_type_set__61_cfa_info2(app_bglt obj_577, type_bglt val1840_578)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 50 */
      return
	 ((((app_bglt) CREF(obj_577))->type) = ((type_bglt) val1840_578), BUNSPEC);
   }
}



/* _procedure-ref-app-type-set! */
obj_t 
_procedure_ref_app_type_set__17_cfa_info2(obj_t env_6145, obj_t obj_6146, obj_t val1840_6147)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 50 */
      return
	 procedure_ref_app_type_set__61_cfa_info2(
	 (app_bglt) (obj_6146),
	 (type_bglt) (val1840_6147));
   }
}



/* procedure-ref-app-type */
type_bglt 
procedure_ref_app_type_95_cfa_info2(app_bglt obj_579)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 50 */
      return
	 (((app_bglt) CREF(obj_579))->type);
   }
}



/* _procedure-ref-app-type */
obj_t 
_procedure_ref_app_type_117_cfa_info2(obj_t env_6148, obj_t obj_6149)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 50 */
      {		/* Cfa/cinfo2.scm 50 */
	 type_bglt aux_8561;
	 aux_8561 =
	    procedure_ref_app_type_95_cfa_info2(
	    (app_bglt) (obj_6149));
	 return
	    (obj_t) (aux_8561);
      }
   }
}



/* procedure-ref-app-side-effect?-set! */
obj_t 
procedure_ref_app_side_effect__set__126_cfa_info2(app_bglt obj_580, obj_t val1841_581)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 669 */
      return
	 ((((app_bglt) CREF(obj_580))->side_effect__165) = ((obj_t) val1841_581), BUNSPEC);
   }
}



/* _procedure-ref-app-side-effect?-set! */
obj_t 
_procedure_ref_app_side_effect__set__226_cfa_info2(obj_t env_6150, obj_t obj_6151, obj_t val1841_6152)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 669 */
      return
	 procedure_ref_app_side_effect__set__126_cfa_info2(
	 (app_bglt) (obj_6151), val1841_6152);
   }
}



/* procedure-ref-app-side-effect? */
obj_t 
procedure_ref_app_side_effect__178_cfa_info2(app_bglt obj_582)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 669 */
      return
	 (((app_bglt) CREF(obj_582))->side_effect__165);
   }
}



/* _procedure-ref-app-side-effect? */
obj_t 
_procedure_ref_app_side_effect__202_cfa_info2(obj_t env_6153, obj_t obj_6154)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 669 */
      return
	 procedure_ref_app_side_effect__178_cfa_info2(
	 (app_bglt) (obj_6154));
   }
}



/* procedure-ref-app-key-set! */
obj_t 
procedure_ref_app_key_set__89_cfa_info2(app_bglt obj_583, obj_t val1842_584)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 673 */
      return
	 ((((app_bglt) CREF(obj_583))->key) = ((obj_t) val1842_584), BUNSPEC);
   }
}



/* _procedure-ref-app-key-set!2901 */
obj_t 
_procedure_ref_app_key_set_2901_89_cfa_info2(obj_t env_6155, obj_t obj_6156, obj_t val1842_6157)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 673 */
      return
	 procedure_ref_app_key_set__89_cfa_info2(
	 (app_bglt) (obj_6156), val1842_6157);
   }
}



/* procedure-ref-app-key */
obj_t 
procedure_ref_app_key_147_cfa_info2(app_bglt obj_585)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 673 */
      return
	 (((app_bglt) CREF(obj_585))->key);
   }
}



/* _procedure-ref-app-key2902 */
obj_t 
_procedure_ref_app_key2902_254_cfa_info2(obj_t env_6158, obj_t obj_6159)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 673 */
      return
	 procedure_ref_app_key_147_cfa_info2(
	 (app_bglt) (obj_6159));
   }
}



/* procedure-ref-app-fun-set! */
obj_t 
procedure_ref_app_fun_set__2_cfa_info2(app_bglt obj_586, var_bglt val1843_587)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 50 */
      return
	 ((((app_bglt) CREF(obj_586))->fun) = ((var_bglt) val1843_587), BUNSPEC);
   }
}



/* _procedure-ref-app-fun-set! */
obj_t 
_procedure_ref_app_fun_set__32_cfa_info2(obj_t env_6160, obj_t obj_6161, obj_t val1843_6162)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 50 */
      return
	 procedure_ref_app_fun_set__2_cfa_info2(
	 (app_bglt) (obj_6161),
	 (var_bglt) (val1843_6162));
   }
}



/* procedure-ref-app-fun */
var_bglt 
procedure_ref_app_fun_180_cfa_info2(app_bglt obj_588)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 50 */
      return
	 (((app_bglt) CREF(obj_588))->fun);
   }
}



/* _procedure-ref-app-fun */
obj_t 
_procedure_ref_app_fun_110_cfa_info2(obj_t env_6163, obj_t obj_6164)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 50 */
      {		/* Cfa/cinfo2.scm 50 */
	 var_bglt aux_8582;
	 aux_8582 =
	    procedure_ref_app_fun_180_cfa_info2(
	    (app_bglt) (obj_6164));
	 return
	    (obj_t) (aux_8582);
      }
   }
}



/* procedure-ref-app-args-set! */
obj_t 
procedure_ref_app_args_set__11_cfa_info2(app_bglt obj_589, obj_t val1844_590)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 50 */
      return
	 ((((app_bglt) CREF(obj_589))->args) = ((obj_t) val1844_590), BUNSPEC);
   }
}



/* _procedure-ref-app-args-set! */
obj_t 
_procedure_ref_app_args_set__247_cfa_info2(obj_t env_6165, obj_t obj_6166, obj_t val1844_6167)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 50 */
      return
	 procedure_ref_app_args_set__11_cfa_info2(
	 (app_bglt) (obj_6166), val1844_6167);
   }
}



/* procedure-ref-app-args */
obj_t 
procedure_ref_app_args_118_cfa_info2(app_bglt obj_591)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 50 */
      return
	 (((app_bglt) CREF(obj_591))->args);
   }
}



/* _procedure-ref-app-args */
obj_t 
_procedure_ref_app_args_55_cfa_info2(obj_t env_6168, obj_t obj_6169)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 50 */
      return
	 procedure_ref_app_args_118_cfa_info2(
	 (app_bglt) (obj_6169));
   }
}



/* procedure-ref-app-stack-info-set! */
obj_t 
procedure_ref_app_stack_info_set__100_cfa_info2(app_bglt obj_592, obj_t val1845_593)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 704 */
      return
	 ((((app_bglt) CREF(obj_592))->stack_info_255) = ((obj_t) val1845_593), BUNSPEC);
   }
}



/* _procedure-ref-app-stack-info-set! */
obj_t 
_procedure_ref_app_stack_info_set__26_cfa_info2(obj_t env_6170, obj_t obj_6171, obj_t val1845_6172)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 704 */
      return
	 procedure_ref_app_stack_info_set__100_cfa_info2(
	 (app_bglt) (obj_6171), val1845_6172);
   }
}



/* procedure-ref-app-stack-info */
obj_t 
procedure_ref_app_stack_info_176_cfa_info2(app_bglt obj_594)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 704 */
      return
	 (((app_bglt) CREF(obj_594))->stack_info_255);
   }
}



/* _procedure-ref-app-stack-info */
obj_t 
_procedure_ref_app_stack_info_173_cfa_info2(obj_t env_6173, obj_t obj_6174)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 704 */
      return
	 procedure_ref_app_stack_info_176_cfa_info2(
	 (app_bglt) (obj_6174));
   }
}



/* procedure-ref-app-approx */
approx_bglt 
procedure_ref_app_approx_118_cfa_info2(procedure_ref_app_49_bglt obj_595)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 50 */
      {
	 obj_t aux_8598;
	 {	/* Cfa/cinfo2.scm 50 */
	    object_bglt aux_8599;
	    aux_8599 =
	       (object_bglt) (obj_595);
	    aux_8598 =
	       OBJECT_WIDENING(aux_8599);
	 }
	 return
	    (((procedure_ref_app_49_bglt) CREF(aux_8598))->approx);
      }
   }
}



/* _procedure-ref-app-approx */
obj_t 
_procedure_ref_app_approx_193_cfa_info2(obj_t env_6175, obj_t obj_6176)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 50 */
      {		/* Cfa/cinfo2.scm 50 */
	 approx_bglt aux_8603;
	 aux_8603 =
	    procedure_ref_app_approx_118_cfa_info2(
	    (procedure_ref_app_49_bglt) (obj_6176));
	 return
	    (obj_t) (aux_8603);
      }
   }
}



/* allocate-make-procedure-app */
app_bglt 
allocate_make_procedure_app_115_cfa_info2()
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 30 */
      {		/* Cfa/cinfo2.scm 30 */
	 app_bglt new1829_2419;
	 new1829_2419 =
	    ((app_bglt) BREF(GC_MALLOC(sizeof(struct app))));
	 {	/* Cfa/cinfo2.scm 30 */
	    long arg2406_2420;
	    arg2406_2420 =
	       class_num_218___object(make_procedure_app_48_cfa_info2);
	    {	/* Cfa/cinfo2.scm 30 */
	       obj_t obj_4105;
	       obj_4105 =
		  (obj_t) (new1829_2419);
	       (((obj_t) CREF(obj_4105))->header = MAKE_HEADER(arg2406_2420, 0), BUNSPEC);
	    }
	 }
	 {	/* Cfa/cinfo2.scm 30 */
	    object_bglt aux_8611;
	    aux_8611 =
	       (object_bglt) (new1829_2419);
	    OBJECT_WIDENING_SET(aux_8611, BFALSE);
	 }
	 return new1829_2419;
      }
   }
}



/* _allocate-make-procedure-app */
obj_t 
_allocate_make_procedure_app_241_cfa_info2(obj_t env_5314)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 30 */
      {		/* Cfa/cinfo2.scm 30 */
	 app_bglt aux_8614;
	 aux_8614 =
	    allocate_make_procedure_app_115_cfa_info2();
	 return
	    (obj_t) (aux_8614);
      }
   }
}



/* make-procedure-app? */
bool_t 
make_procedure_app__51_cfa_info2(obj_t obj_599)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 30 */
      return
	 is_a__118___object(obj_599, make_procedure_app_48_cfa_info2);
   }
}



/* _make-procedure-app? */
obj_t 
_make_procedure_app__219_cfa_info2(obj_t env_6177, obj_t obj_6178)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 30 */
      {		/* Cfa/cinfo2.scm 30 */
	 bool_t aux_8618;
	 aux_8618 =
	    make_procedure_app__51_cfa_info2(obj_6178);
	 return
	    BBOOL(aux_8618);
      }
   }
}



/* widening-make-procedure-app */
make_procedure_app_48_bglt 
widening_make_procedure_app_45_cfa_info2(approx_bglt approx_600, long values_approx_len_106_601, approx_bglt values_approx_79_602, long lost_stamp_114_603, bool_t x_t__142_604, bool_t x_605, bool_t t_606, variable_bglt owner_607, bool_t stackable__42_608, obj_t stack_stamp_31_609)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 30 */
      {		/* Cfa/cinfo2.scm 30 */
	 make_procedure_app_48_bglt new1815_4107;
	 new1815_4107 =
	    ((make_procedure_app_48_bglt) BREF(GC_MALLOC(sizeof(struct make_procedure_app_48))));
	 ((((make_procedure_app_48_bglt) CREF(new1815_4107))->approx) = ((approx_bglt) approx_600), BUNSPEC);
	 ((((make_procedure_app_48_bglt) CREF(new1815_4107))->values_approx_len_106) = ((long) values_approx_len_106_601), BUNSPEC);
	 ((((make_procedure_app_48_bglt) CREF(new1815_4107))->values_approx_79) = ((approx_bglt *)
	       GC_MALLOC(sizeof(struct approx) * values_approx_len_106_601)), BUNSPEC);
	 {
	    long i1816_4119;
	    i1816_4119 = ((long) 0);
	  loop1819_4118:
	    if (
	       (i1816_4119 == values_approx_len_106_601))
	      {		/* Cfa/cinfo2.scm 30 */
		 CNST_TABLE_REF(((long) 20));
	      }
	    else
	      {		/* Cfa/cinfo2.scm 30 */
		 ((((make_procedure_app_48_bglt) CREF(new1815_4107))->values_approx_79)[i1816_4119] = ((approx_bglt) values_approx_79_602), BUNSPEC);
		 {
		    long i1816_8630;
		    i1816_8630 =
		       (i1816_4119 + ((long) 1));
		    i1816_4119 = i1816_8630;
		    goto loop1819_4118;
		 }
	      }
	 }
	 ((((make_procedure_app_48_bglt) CREF(new1815_4107))->lost_stamp_114) = ((long) lost_stamp_114_603), BUNSPEC);
	 ((((make_procedure_app_48_bglt) CREF(new1815_4107))->x_t__142) = ((bool_t) x_t__142_604), BUNSPEC);
	 ((((make_procedure_app_48_bglt) CREF(new1815_4107))->x) = ((bool_t) x_605), BUNSPEC);
	 ((((make_procedure_app_48_bglt) CREF(new1815_4107))->t) = ((bool_t) t_606), BUNSPEC);
	 ((((make_procedure_app_48_bglt) CREF(new1815_4107))->owner) = ((variable_bglt) owner_607), BUNSPEC);
	 ((((make_procedure_app_48_bglt) CREF(new1815_4107))->stackable__42) = ((bool_t) stackable__42_608), BUNSPEC);
	 ((((make_procedure_app_48_bglt) CREF(new1815_4107))->stack_stamp_31) = ((obj_t) stack_stamp_31_609), BUNSPEC);
	 return new1815_4107;
      }
   }
}



/* _widening-make-procedure-app2903 */
obj_t 
_widening_make_procedure_app2903_110_cfa_info2(obj_t env_6179, obj_t approx_6180, obj_t values_approx_len_106_6181, obj_t values_approx_79_6182, obj_t lost_stamp_114_6183, obj_t x_t__142_6184, obj_t x_6185, obj_t t_6186, obj_t owner_6187, obj_t stackable__42_6188, obj_t stack_stamp_31_6189)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 30 */
      {		/* Cfa/cinfo2.scm 30 */
	 make_procedure_app_48_bglt aux_8639;
	 aux_8639 =
	    widening_make_procedure_app_45_cfa_info2(
	    (approx_bglt) (approx_6180),
	    (long) CINT(values_approx_len_106_6181),
	    (approx_bglt) (values_approx_79_6182),
	    (long) CINT(lost_stamp_114_6183),
	    CBOOL(x_t__142_6184),
	    CBOOL(x_6185),
	    CBOOL(t_6186),
	    (variable_bglt) (owner_6187),
	    CBOOL(stackable__42_6188), stack_stamp_31_6189);
	 return
	    (obj_t) (aux_8639);
      }
   }
}



/* make-make-procedure-app */
make_procedure_app_48_bglt 
make_make_procedure_app_99_cfa_info2(obj_t loc_610, type_bglt type_611, obj_t side_effect__165_612, obj_t key_613, var_bglt fun_614, obj_t args_615, obj_t stack_info_255_616, approx_bglt approx_617, long values_approx_len_106_618, approx_bglt values_approx_79_619, long lost_stamp_114_620, bool_t x_t__142_621, bool_t x_622, bool_t t_623, variable_bglt owner_624, bool_t stackable__42_625, obj_t stack_stamp_31_626)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 30 */
      {		/* Cfa/cinfo2.scm 30 */
	 app_bglt aux1827_4126;
	 {	/* Cfa/cinfo2.scm 30 */
	    app_bglt res2839_4148;
	    {	/* ./Ast/node.scm 698 */
	       app_bglt new1248_4137;
	       new1248_4137 =
		  ((app_bglt) BREF(GC_MALLOC(sizeof(struct app))));
	       {	/* ./Ast/node.scm 698 */
		  long arg2541_4138;
		  arg2541_4138 =
		     class_num_218___object(app_ast_node);
		  {	/* ./Ast/node.scm 698 */
		     obj_t obj_4146;
		     obj_4146 =
			(obj_t) (new1248_4137);
		     (((obj_t) CREF(obj_4146))->header = MAKE_HEADER(arg2541_4138, 0), BUNSPEC);
		  }
	       }
	       {	/* ./Ast/node.scm 698 */
		  object_bglt aux_8655;
		  aux_8655 =
		     (object_bglt) (new1248_4137);
		  OBJECT_WIDENING_SET(aux_8655, BFALSE);
	       }
	       ((((app_bglt) CREF(new1248_4137))->loc) = ((obj_t) loc_610), BUNSPEC);
	       ((((app_bglt) CREF(new1248_4137))->type) = ((type_bglt) type_611), BUNSPEC);
	       ((((app_bglt) CREF(new1248_4137))->side_effect__165) = ((obj_t) side_effect__165_612), BUNSPEC);
	       ((((app_bglt) CREF(new1248_4137))->key) = ((obj_t) key_613), BUNSPEC);
	       ((((app_bglt) CREF(new1248_4137))->fun) = ((var_bglt) fun_614), BUNSPEC);
	       ((((app_bglt) CREF(new1248_4137))->args) = ((obj_t) args_615), BUNSPEC);
	       ((((app_bglt) CREF(new1248_4137))->stack_info_255) = ((obj_t) stack_info_255_616), BUNSPEC);
	       res2839_4148 = new1248_4137;
	    }
	    aux1827_4126 = res2839_4148;
	 }
	 {	/* Cfa/cinfo2.scm 30 */
	    make_procedure_app_48_bglt new1828_4127;
	    new1828_4127 =
	       ((make_procedure_app_48_bglt) (aux1827_4126));
	    {	/* Cfa/cinfo2.scm 30 */
	       long arg2409_4128;
	       arg2409_4128 =
		  class_num_218___object(make_procedure_app_48_cfa_info2);
	       {	/* Cfa/cinfo2.scm 30 */
		  obj_t obj_4149;
		  obj_4149 =
		     (obj_t) (new1828_4127);
		  (((obj_t) CREF(obj_4149))->header = MAKE_HEADER(arg2409_4128, 0), BUNSPEC);
	       }
	    }
	    {	/* Cfa/cinfo2.scm 30 */
	       make_procedure_app_48_bglt arg2410_4129;
	       {	/* Cfa/cinfo2.scm 30 */
		  make_procedure_app_48_bglt res2840_4180;
		  {	/* Cfa/cinfo2.scm 30 */
		     make_procedure_app_48_bglt new1815_4161;
		     new1815_4161 =
			((make_procedure_app_48_bglt) BREF(GC_MALLOC(sizeof(struct make_procedure_app_48))));
		     ((((make_procedure_app_48_bglt) CREF(new1815_4161))->approx) = ((approx_bglt) approx_617), BUNSPEC);
		     ((((make_procedure_app_48_bglt) CREF(new1815_4161))->values_approx_len_106) = ((long) values_approx_len_106_618), BUNSPEC);
		     ((((make_procedure_app_48_bglt) CREF(new1815_4161))->values_approx_79) = ((approx_bglt *)
			   GC_MALLOC(sizeof(struct approx) * values_approx_len_106_618)), BUNSPEC);
		     {
			long i1816_4173;
			i1816_4173 = ((long) 0);
		      loop1819_4172:
			if (
			   (i1816_4173 == values_approx_len_106_618))
			  {	/* Cfa/cinfo2.scm 30 */
			     CNST_TABLE_REF(((long) 20));
			  }
			else
			  {	/* Cfa/cinfo2.scm 30 */
			     ((((make_procedure_app_48_bglt) CREF(new1815_4161))->values_approx_79)[i1816_4173] = ((approx_bglt) values_approx_79_619), BUNSPEC);
			     {
				long i1816_8678;
				i1816_8678 =
				   (i1816_4173 + ((long) 1));
				i1816_4173 = i1816_8678;
				goto loop1819_4172;
			     }
			  }
		     }
		     ((((make_procedure_app_48_bglt) CREF(new1815_4161))->lost_stamp_114) = ((long) lost_stamp_114_620), BUNSPEC);
		     ((((make_procedure_app_48_bglt) CREF(new1815_4161))->x_t__142) = ((bool_t) x_t__142_621), BUNSPEC);
		     ((((make_procedure_app_48_bglt) CREF(new1815_4161))->x) = ((bool_t) x_622), BUNSPEC);
		     ((((make_procedure_app_48_bglt) CREF(new1815_4161))->t) = ((bool_t) t_623), BUNSPEC);
		     ((((make_procedure_app_48_bglt) CREF(new1815_4161))->owner) = ((variable_bglt) owner_624), BUNSPEC);
		     ((((make_procedure_app_48_bglt) CREF(new1815_4161))->stackable__42) = ((bool_t) stackable__42_625), BUNSPEC);
		     ((((make_procedure_app_48_bglt) CREF(new1815_4161))->stack_stamp_31) = ((obj_t) stack_stamp_31_626), BUNSPEC);
		     res2840_4180 = new1815_4161;
		  }
		  arg2410_4129 = res2840_4180;
	       }
	       {	/* Cfa/cinfo2.scm 30 */
		  obj_t aux_8689;
		  object_bglt aux_8687;
		  aux_8689 =
		     (obj_t) (arg2410_4129);
		  aux_8687 =
		     (object_bglt) (new1828_4127);
		  OBJECT_WIDENING_SET(aux_8687, aux_8689);
	       }
	    }
	    return new1828_4127;
	 }
      }
   }
}



/* _make-make-procedure-app */
obj_t 
_make_make_procedure_app_59_cfa_info2(obj_t env_6190, obj_t loc_6191, obj_t type_6192, obj_t side_effect__165_6193, obj_t key_6194, obj_t fun_6195, obj_t args_6196, obj_t stack_info_255_6197, obj_t approx_6198, obj_t values_approx_len_106_6199, obj_t values_approx_79_6200, obj_t lost_stamp_114_6201, obj_t x_t__142_6202, obj_t x_6203, obj_t t_6204, obj_t owner_6205, obj_t stackable__42_6206, obj_t stack_stamp_31_6207)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 30 */
      {		/* Cfa/cinfo2.scm 30 */
	 make_procedure_app_48_bglt aux_8692;
	 aux_8692 =
	    make_make_procedure_app_99_cfa_info2(loc_6191,
	    (type_bglt) (type_6192), side_effect__165_6193, key_6194,
	    (var_bglt) (fun_6195), args_6196, stack_info_255_6197,
	    (approx_bglt) (approx_6198),
	    (long) CINT(values_approx_len_106_6199),
	    (approx_bglt) (values_approx_79_6200),
	    (long) CINT(lost_stamp_114_6201),
	    CBOOL(x_t__142_6202),
	    CBOOL(x_6203),
	    CBOOL(t_6204),
	    (variable_bglt) (owner_6205),
	    CBOOL(stackable__42_6206), stack_stamp_31_6207);
	 return
	    (obj_t) (aux_8692);
      }
   }
}



/* make-procedure-app-loc */
obj_t 
make_procedure_app_loc_185_cfa_info2(app_bglt obj_627)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 661 */
      return
	 (((app_bglt) CREF(obj_627))->loc);
   }
}



/* _make-procedure-app-loc */
obj_t 
_make_procedure_app_loc_42_cfa_info2(obj_t env_6208, obj_t obj_6209)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 661 */
      return
	 make_procedure_app_loc_185_cfa_info2(
	 (app_bglt) (obj_6209));
   }
}



/* make-procedure-app-type-set! */
obj_t 
make_procedure_app_type_set__163_cfa_info2(app_bglt obj_628, type_bglt val1801_629)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 30 */
      return
	 ((((app_bglt) CREF(obj_628))->type) = ((type_bglt) val1801_629), BUNSPEC);
   }
}



/* _make-procedure-app-type-set! */
obj_t 
_make_procedure_app_type_set__206_cfa_info2(obj_t env_6210, obj_t obj_6211, obj_t val1801_6212)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 30 */
      return
	 make_procedure_app_type_set__163_cfa_info2(
	 (app_bglt) (obj_6211),
	 (type_bglt) (val1801_6212));
   }
}



/* make-procedure-app-type */
type_bglt 
make_procedure_app_type_193_cfa_info2(app_bglt obj_630)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 30 */
      return
	 (((app_bglt) CREF(obj_630))->type);
   }
}



/* _make-procedure-app-type */
obj_t 
_make_procedure_app_type_19_cfa_info2(obj_t env_6213, obj_t obj_6214)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 30 */
      {		/* Cfa/cinfo2.scm 30 */
	 type_bglt aux_8714;
	 aux_8714 =
	    make_procedure_app_type_193_cfa_info2(
	    (app_bglt) (obj_6214));
	 return
	    (obj_t) (aux_8714);
      }
   }
}



/* make-procedure-app-side-effect?-set! */
obj_t 
make_procedure_app_side_effect__set__181_cfa_info2(app_bglt obj_631, obj_t val1802_632)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 669 */
      return
	 ((((app_bglt) CREF(obj_631))->side_effect__165) = ((obj_t) val1802_632), BUNSPEC);
   }
}



/* _make-procedure-app-side-effect?-set! */
obj_t 
_make_procedure_app_side_effect__set__15_cfa_info2(obj_t env_6215, obj_t obj_6216, obj_t val1802_6217)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 669 */
      return
	 make_procedure_app_side_effect__set__181_cfa_info2(
	 (app_bglt) (obj_6216), val1802_6217);
   }
}



/* make-procedure-app-side-effect? */
obj_t 
make_procedure_app_side_effect__185_cfa_info2(app_bglt obj_633)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 669 */
      return
	 (((app_bglt) CREF(obj_633))->side_effect__165);
   }
}



/* _make-procedure-app-side-effect? */
obj_t 
_make_procedure_app_side_effect__232_cfa_info2(obj_t env_6218, obj_t obj_6219)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 669 */
      return
	 make_procedure_app_side_effect__185_cfa_info2(
	 (app_bglt) (obj_6219));
   }
}



/* make-procedure-app-key-set! */
obj_t 
make_procedure_app_key_set__38_cfa_info2(app_bglt obj_634, obj_t val1803_635)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 673 */
      return
	 ((((app_bglt) CREF(obj_634))->key) = ((obj_t) val1803_635), BUNSPEC);
   }
}



/* _make-procedure-app-key-set!2904 */
obj_t 
_make_procedure_app_key_set_2904_180_cfa_info2(obj_t env_6220, obj_t obj_6221, obj_t val1803_6222)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 673 */
      return
	 make_procedure_app_key_set__38_cfa_info2(
	 (app_bglt) (obj_6221), val1803_6222);
   }
}



/* make-procedure-app-key */
obj_t 
make_procedure_app_key_144_cfa_info2(app_bglt obj_636)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 673 */
      return
	 (((app_bglt) CREF(obj_636))->key);
   }
}



/* _make-procedure-app-key */
obj_t 
_make_procedure_app_key_248_cfa_info2(obj_t env_6223, obj_t obj_6224)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 673 */
      return
	 make_procedure_app_key_144_cfa_info2(
	 (app_bglt) (obj_6224));
   }
}



/* make-procedure-app-fun-set! */
obj_t 
make_procedure_app_fun_set__162_cfa_info2(app_bglt obj_637, var_bglt val1804_638)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 30 */
      return
	 ((((app_bglt) CREF(obj_637))->fun) = ((var_bglt) val1804_638), BUNSPEC);
   }
}



/* _make-procedure-app-fun-set! */
obj_t 
_make_procedure_app_fun_set__92_cfa_info2(obj_t env_6225, obj_t obj_6226, obj_t val1804_6227)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 30 */
      return
	 make_procedure_app_fun_set__162_cfa_info2(
	 (app_bglt) (obj_6226),
	 (var_bglt) (val1804_6227));
   }
}



/* make-procedure-app-fun */
var_bglt 
make_procedure_app_fun_101_cfa_info2(app_bglt obj_639)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 30 */
      return
	 (((app_bglt) CREF(obj_639))->fun);
   }
}



/* _make-procedure-app-fun */
obj_t 
_make_procedure_app_fun_72_cfa_info2(obj_t env_6228, obj_t obj_6229)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 30 */
      {		/* Cfa/cinfo2.scm 30 */
	 var_bglt aux_8735;
	 aux_8735 =
	    make_procedure_app_fun_101_cfa_info2(
	    (app_bglt) (obj_6229));
	 return
	    (obj_t) (aux_8735);
      }
   }
}



/* make-procedure-app-args-set! */
obj_t 
make_procedure_app_args_set__42_cfa_info2(app_bglt obj_640, obj_t val1805_641)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 30 */
      return
	 ((((app_bglt) CREF(obj_640))->args) = ((obj_t) val1805_641), BUNSPEC);
   }
}



/* _make-procedure-app-args-set! */
obj_t 
_make_procedure_app_args_set__120_cfa_info2(obj_t env_6230, obj_t obj_6231, obj_t val1805_6232)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 30 */
      return
	 make_procedure_app_args_set__42_cfa_info2(
	 (app_bglt) (obj_6231), val1805_6232);
   }
}



/* make-procedure-app-args */
obj_t 
make_procedure_app_args_93_cfa_info2(app_bglt obj_642)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 30 */
      return
	 (((app_bglt) CREF(obj_642))->args);
   }
}



/* _make-procedure-app-args */
obj_t 
_make_procedure_app_args_200_cfa_info2(obj_t env_6233, obj_t obj_6234)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 30 */
      return
	 make_procedure_app_args_93_cfa_info2(
	 (app_bglt) (obj_6234));
   }
}



/* make-procedure-app-stack-info-set! */
obj_t 
make_procedure_app_stack_info_set__230_cfa_info2(app_bglt obj_643, obj_t val1806_644)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 704 */
      return
	 ((((app_bglt) CREF(obj_643))->stack_info_255) = ((obj_t) val1806_644), BUNSPEC);
   }
}



/* _make-procedure-app-stack-info-set! */
obj_t 
_make_procedure_app_stack_info_set__180_cfa_info2(obj_t env_6235, obj_t obj_6236, obj_t val1806_6237)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 704 */
      return
	 make_procedure_app_stack_info_set__230_cfa_info2(
	 (app_bglt) (obj_6236), val1806_6237);
   }
}



/* make-procedure-app-stack-info */
obj_t 
make_procedure_app_stack_info_60_cfa_info2(app_bglt obj_645)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 704 */
      return
	 (((app_bglt) CREF(obj_645))->stack_info_255);
   }
}



/* _make-procedure-app-stack-info */
obj_t 
_make_procedure_app_stack_info_111_cfa_info2(obj_t env_6238, obj_t obj_6239)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 704 */
      return
	 make_procedure_app_stack_info_60_cfa_info2(
	 (app_bglt) (obj_6239));
   }
}



/* make-procedure-app-approx-set! */
obj_t 
make_procedure_app_approx_set__127_cfa_info2(make_procedure_app_48_bglt obj_646, approx_bglt val1807_647)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 30 */
      {
	 obj_t aux_8751;
	 {	/* Cfa/cinfo2.scm 30 */
	    object_bglt aux_8752;
	    aux_8752 =
	       (object_bglt) (obj_646);
	    aux_8751 =
	       OBJECT_WIDENING(aux_8752);
	 }
	 return
	    ((((make_procedure_app_48_bglt) CREF(aux_8751))->approx) = ((approx_bglt) val1807_647), BUNSPEC);
      }
   }
}



/* _make-procedure-app-approx-set! */
obj_t 
_make_procedure_app_approx_set__151_cfa_info2(obj_t env_6240, obj_t obj_6241, obj_t val1807_6242)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 30 */
      return
	 make_procedure_app_approx_set__127_cfa_info2(
	 (make_procedure_app_48_bglt) (obj_6241),
	 (approx_bglt) (val1807_6242));
   }
}



/* make-procedure-app-approx */
approx_bglt 
make_procedure_app_approx_226_cfa_info2(make_procedure_app_48_bglt obj_648)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 30 */
      {
	 obj_t aux_8759;
	 {	/* Cfa/cinfo2.scm 30 */
	    object_bglt aux_8760;
	    aux_8760 =
	       (object_bglt) (obj_648);
	    aux_8759 =
	       OBJECT_WIDENING(aux_8760);
	 }
	 return
	    (((make_procedure_app_48_bglt) CREF(aux_8759))->approx);
      }
   }
}



/* _make-procedure-app-approx */
obj_t 
_make_procedure_app_approx_34_cfa_info2(obj_t env_6243, obj_t obj_6244)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 30 */
      {		/* Cfa/cinfo2.scm 30 */
	 approx_bglt aux_8764;
	 aux_8764 =
	    make_procedure_app_approx_226_cfa_info2(
	    (make_procedure_app_48_bglt) (obj_6244));
	 return
	    (obj_t) (aux_8764);
      }
   }
}



/* make-procedure-app-values-approx-len */
long 
make_procedure_app_values_approx_len_202_cfa_info2(make_procedure_app_48_bglt obj_649)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 34 */
      {
	 obj_t aux_8768;
	 {	/* Cfa/cinfo2.scm 34 */
	    object_bglt aux_8769;
	    aux_8769 =
	       (object_bglt) (obj_649);
	    aux_8768 =
	       OBJECT_WIDENING(aux_8769);
	 }
	 return
	    (((make_procedure_app_48_bglt) CREF(aux_8768))->values_approx_len_106);
      }
   }
}



/* _make-procedure-app-values-approx-len */
obj_t 
_make_procedure_app_values_approx_len_157_cfa_info2(obj_t env_6245, obj_t obj_6246)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 34 */
      {		/* Cfa/cinfo2.scm 34 */
	 long aux_8773;
	 aux_8773 =
	    make_procedure_app_values_approx_len_202_cfa_info2(
	    (make_procedure_app_48_bglt) (obj_6246));
	 return
	    BINT(aux_8773);
      }
   }
}



/* make-procedure-app-values-approx-set! */
obj_t 
make_procedure_app_values_approx_set__111_cfa_info2(make_procedure_app_48_bglt obj_650, long index_651, approx_bglt val1808_652)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 34 */
      {
	 obj_t aux_8777;
	 {	/* Cfa/cinfo2.scm 34 */
	    object_bglt aux_8778;
	    aux_8778 =
	       (object_bglt) (obj_650);
	    aux_8777 =
	       OBJECT_WIDENING(aux_8778);
	 }
	 return
	    ((((make_procedure_app_48_bglt) CREF(aux_8777))->values_approx_79)[index_651] = ((approx_bglt) val1808_652), BUNSPEC);
      }
   }
}



/* _make-procedure-app-values-approx-set! */
obj_t 
_make_procedure_app_values_approx_set__126_cfa_info2(obj_t env_6247, obj_t obj_6248, obj_t index_6249, obj_t val1808_6250)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 34 */
      return
	 make_procedure_app_values_approx_set__111_cfa_info2(
	 (make_procedure_app_48_bglt) (obj_6248),
	 (long) CINT(index_6249),
	 (approx_bglt) (val1808_6250));
   }
}



/* make-procedure-app-values-approx-ref */
approx_bglt 
make_procedure_app_values_approx_ref_67_cfa_info2(make_procedure_app_48_bglt obj_653, long index_654)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 34 */
      {
	 obj_t aux_8786;
	 {	/* Cfa/cinfo2.scm 34 */
	    object_bglt aux_8787;
	    aux_8787 =
	       (object_bglt) (obj_653);
	    aux_8786 =
	       OBJECT_WIDENING(aux_8787);
	 }
	 return
	    (((make_procedure_app_48_bglt) CREF(aux_8786))->values_approx_79)[index_654];
      }
   }
}



/* _make-procedure-app-values-approx-ref */
obj_t 
_make_procedure_app_values_approx_ref_196_cfa_info2(obj_t env_6251, obj_t obj_6252, obj_t index_6253)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 34 */
      {		/* Cfa/cinfo2.scm 34 */
	 approx_bglt aux_8791;
	 aux_8791 =
	    make_procedure_app_values_approx_ref_67_cfa_info2(
	    (make_procedure_app_48_bglt) (obj_6252),
	    (long) CINT(index_6253));
	 return
	    (obj_t) (aux_8791);
      }
   }
}



/* make-procedure-app-lost-stamp-set! */
obj_t 
make_procedure_app_lost_stamp_set__66_cfa_info2(make_procedure_app_48_bglt obj_655, long val1809_656)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 38 */
      {
	 obj_t aux_8796;
	 {	/* Cfa/cinfo2.scm 38 */
	    object_bglt aux_8797;
	    aux_8797 =
	       (object_bglt) (obj_655);
	    aux_8796 =
	       OBJECT_WIDENING(aux_8797);
	 }
	 return
	    ((((make_procedure_app_48_bglt) CREF(aux_8796))->lost_stamp_114) = ((long) val1809_656), BUNSPEC);
      }
   }
}



/* _make-procedure-app-lost-stamp-set! */
obj_t 
_make_procedure_app_lost_stamp_set__118_cfa_info2(obj_t env_6254, obj_t obj_6255, obj_t val1809_6256)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 38 */
      return
	 make_procedure_app_lost_stamp_set__66_cfa_info2(
	 (make_procedure_app_48_bglt) (obj_6255),
	 (long) CINT(val1809_6256));
   }
}



/* make-procedure-app-lost-stamp */
long 
make_procedure_app_lost_stamp_58_cfa_info2(make_procedure_app_48_bglt obj_657)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 38 */
      {
	 obj_t aux_8804;
	 {	/* Cfa/cinfo2.scm 38 */
	    object_bglt aux_8805;
	    aux_8805 =
	       (object_bglt) (obj_657);
	    aux_8804 =
	       OBJECT_WIDENING(aux_8805);
	 }
	 return
	    (((make_procedure_app_48_bglt) CREF(aux_8804))->lost_stamp_114);
      }
   }
}



/* _make-procedure-app-lost-stamp */
obj_t 
_make_procedure_app_lost_stamp_241_cfa_info2(obj_t env_6257, obj_t obj_6258)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 38 */
      {		/* Cfa/cinfo2.scm 38 */
	 long aux_8809;
	 aux_8809 =
	    make_procedure_app_lost_stamp_58_cfa_info2(
	    (make_procedure_app_48_bglt) (obj_6258));
	 return
	    BINT(aux_8809);
      }
   }
}



/* make-procedure-app-x-t?-set! */
obj_t 
make_procedure_app_x_t__set__53_cfa_info2(make_procedure_app_48_bglt obj_658, bool_t val1810_659)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 40 */
      {
	 obj_t aux_8813;
	 {	/* Cfa/cinfo2.scm 40 */
	    object_bglt aux_8814;
	    aux_8814 =
	       (object_bglt) (obj_658);
	    aux_8813 =
	       OBJECT_WIDENING(aux_8814);
	 }
	 return
	    ((((make_procedure_app_48_bglt) CREF(aux_8813))->x_t__142) = ((bool_t) val1810_659), BUNSPEC);
      }
   }
}



/* _make-procedure-app-x-t?-set! */
obj_t 
_make_procedure_app_x_t__set__129_cfa_info2(obj_t env_6259, obj_t obj_6260, obj_t val1810_6261)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 40 */
      return
	 make_procedure_app_x_t__set__53_cfa_info2(
	 (make_procedure_app_48_bglt) (obj_6260),
	 CBOOL(val1810_6261));
   }
}



/* make-procedure-app-x-t? */
bool_t 
make_procedure_app_x_t__146_cfa_info2(make_procedure_app_48_bglt obj_660)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 40 */
      {
	 obj_t aux_8821;
	 {	/* Cfa/cinfo2.scm 40 */
	    object_bglt aux_8822;
	    aux_8822 =
	       (object_bglt) (obj_660);
	    aux_8821 =
	       OBJECT_WIDENING(aux_8822);
	 }
	 return
	    (((make_procedure_app_48_bglt) CREF(aux_8821))->x_t__142);
      }
   }
}



/* _make-procedure-app-x-t? */
obj_t 
_make_procedure_app_x_t__234_cfa_info2(obj_t env_6262, obj_t obj_6263)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 40 */
      {		/* Cfa/cinfo2.scm 40 */
	 bool_t aux_8826;
	 aux_8826 =
	    make_procedure_app_x_t__146_cfa_info2(
	    (make_procedure_app_48_bglt) (obj_6263));
	 return
	    BBOOL(aux_8826);
      }
   }
}



/* make-procedure-app-x-set! */
obj_t 
make_procedure_app_x_set__126_cfa_info2(make_procedure_app_48_bglt obj_661, bool_t val1811_662)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 41 */
      {
	 obj_t aux_8830;
	 {	/* Cfa/cinfo2.scm 41 */
	    object_bglt aux_8831;
	    aux_8831 =
	       (object_bglt) (obj_661);
	    aux_8830 =
	       OBJECT_WIDENING(aux_8831);
	 }
	 return
	    ((((make_procedure_app_48_bglt) CREF(aux_8830))->x) = ((bool_t) val1811_662), BUNSPEC);
      }
   }
}



/* _make-procedure-app-x-set! */
obj_t 
_make_procedure_app_x_set__75_cfa_info2(obj_t env_6264, obj_t obj_6265, obj_t val1811_6266)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 41 */
      return
	 make_procedure_app_x_set__126_cfa_info2(
	 (make_procedure_app_48_bglt) (obj_6265),
	 CBOOL(val1811_6266));
   }
}



/* make-procedure-app-x */
bool_t 
make_procedure_app_x_178_cfa_info2(make_procedure_app_48_bglt obj_663)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 41 */
      {
	 obj_t aux_8838;
	 {	/* Cfa/cinfo2.scm 41 */
	    object_bglt aux_8839;
	    aux_8839 =
	       (object_bglt) (obj_663);
	    aux_8838 =
	       OBJECT_WIDENING(aux_8839);
	 }
	 return
	    (((make_procedure_app_48_bglt) CREF(aux_8838))->x);
      }
   }
}



/* _make-procedure-app-x */
obj_t 
_make_procedure_app_x_209_cfa_info2(obj_t env_6267, obj_t obj_6268)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 41 */
      {		/* Cfa/cinfo2.scm 41 */
	 bool_t aux_8843;
	 aux_8843 =
	    make_procedure_app_x_178_cfa_info2(
	    (make_procedure_app_48_bglt) (obj_6268));
	 return
	    BBOOL(aux_8843);
      }
   }
}



/* make-procedure-app-t-set! */
obj_t 
make_procedure_app_t_set__133_cfa_info2(make_procedure_app_48_bglt obj_664, bool_t val1812_665)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 42 */
      {
	 obj_t aux_8847;
	 {	/* Cfa/cinfo2.scm 42 */
	    object_bglt aux_8848;
	    aux_8848 =
	       (object_bglt) (obj_664);
	    aux_8847 =
	       OBJECT_WIDENING(aux_8848);
	 }
	 return
	    ((((make_procedure_app_48_bglt) CREF(aux_8847))->t) = ((bool_t) val1812_665), BUNSPEC);
      }
   }
}



/* _make-procedure-app-t-set! */
obj_t 
_make_procedure_app_t_set__41_cfa_info2(obj_t env_6269, obj_t obj_6270, obj_t val1812_6271)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 42 */
      return
	 make_procedure_app_t_set__133_cfa_info2(
	 (make_procedure_app_48_bglt) (obj_6270),
	 CBOOL(val1812_6271));
   }
}



/* make-procedure-app-t */
bool_t 
make_procedure_app_t_252_cfa_info2(make_procedure_app_48_bglt obj_666)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 42 */
      {
	 obj_t aux_8855;
	 {	/* Cfa/cinfo2.scm 42 */
	    object_bglt aux_8856;
	    aux_8856 =
	       (object_bglt) (obj_666);
	    aux_8855 =
	       OBJECT_WIDENING(aux_8856);
	 }
	 return
	    (((make_procedure_app_48_bglt) CREF(aux_8855))->t);
      }
   }
}



/* _make-procedure-app-t */
obj_t 
_make_procedure_app_t_235_cfa_info2(obj_t env_6272, obj_t obj_6273)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 42 */
      {		/* Cfa/cinfo2.scm 42 */
	 bool_t aux_8860;
	 aux_8860 =
	    make_procedure_app_t_252_cfa_info2(
	    (make_procedure_app_48_bglt) (obj_6273));
	 return
	    BBOOL(aux_8860);
      }
   }
}



/* make-procedure-app-owner */
variable_bglt 
make_procedure_app_owner_38_cfa_info2(make_procedure_app_48_bglt obj_667)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 44 */
      {
	 obj_t aux_8864;
	 {	/* Cfa/cinfo2.scm 44 */
	    object_bglt aux_8865;
	    aux_8865 =
	       (object_bglt) (obj_667);
	    aux_8864 =
	       OBJECT_WIDENING(aux_8865);
	 }
	 return
	    (((make_procedure_app_48_bglt) CREF(aux_8864))->owner);
      }
   }
}



/* _make-procedure-app-owner */
obj_t 
_make_procedure_app_owner_91_cfa_info2(obj_t env_6274, obj_t obj_6275)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 44 */
      {		/* Cfa/cinfo2.scm 44 */
	 variable_bglt aux_8869;
	 aux_8869 =
	    make_procedure_app_owner_38_cfa_info2(
	    (make_procedure_app_48_bglt) (obj_6275));
	 return
	    (obj_t) (aux_8869);
      }
   }
}



/* make-procedure-app-stackable?-set! */
obj_t 
make_procedure_app_stackable__set__58_cfa_info2(make_procedure_app_48_bglt obj_668, bool_t val1813_669)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 47 */
      {
	 obj_t aux_8873;
	 {	/* Cfa/cinfo2.scm 47 */
	    object_bglt aux_8874;
	    aux_8874 =
	       (object_bglt) (obj_668);
	    aux_8873 =
	       OBJECT_WIDENING(aux_8874);
	 }
	 return
	    ((((make_procedure_app_48_bglt) CREF(aux_8873))->stackable__42) = ((bool_t) val1813_669), BUNSPEC);
      }
   }
}



/* _make-procedure-app-stackable?-set! */
obj_t 
_make_procedure_app_stackable__set__122_cfa_info2(obj_t env_6276, obj_t obj_6277, obj_t val1813_6278)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 47 */
      return
	 make_procedure_app_stackable__set__58_cfa_info2(
	 (make_procedure_app_48_bglt) (obj_6277),
	 CBOOL(val1813_6278));
   }
}



/* make-procedure-app-stackable? */
bool_t 
make_procedure_app_stackable__92_cfa_info2(make_procedure_app_48_bglt obj_670)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 47 */
      {
	 obj_t aux_8881;
	 {	/* Cfa/cinfo2.scm 47 */
	    object_bglt aux_8882;
	    aux_8882 =
	       (object_bglt) (obj_670);
	    aux_8881 =
	       OBJECT_WIDENING(aux_8882);
	 }
	 return
	    (((make_procedure_app_48_bglt) CREF(aux_8881))->stackable__42);
      }
   }
}



/* _make-procedure-app-stackable? */
obj_t 
_make_procedure_app_stackable__130_cfa_info2(obj_t env_6279, obj_t obj_6280)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 47 */
      {		/* Cfa/cinfo2.scm 47 */
	 bool_t aux_8886;
	 aux_8886 =
	    make_procedure_app_stackable__92_cfa_info2(
	    (make_procedure_app_48_bglt) (obj_6280));
	 return
	    BBOOL(aux_8886);
      }
   }
}



/* make-procedure-app-stack-stamp-set! */
obj_t 
make_procedure_app_stack_stamp_set__40_cfa_info2(make_procedure_app_48_bglt obj_671, obj_t val1814_672)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 49 */
      {
	 obj_t aux_8890;
	 {	/* Cfa/cinfo2.scm 49 */
	    object_bglt aux_8891;
	    aux_8891 =
	       (object_bglt) (obj_671);
	    aux_8890 =
	       OBJECT_WIDENING(aux_8891);
	 }
	 return
	    ((((make_procedure_app_48_bglt) CREF(aux_8890))->stack_stamp_31) = ((obj_t) val1814_672), BUNSPEC);
      }
   }
}



/* _make-procedure-app-stack-stamp-set! */
obj_t 
_make_procedure_app_stack_stamp_set__110_cfa_info2(obj_t env_6281, obj_t obj_6282, obj_t val1814_6283)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 49 */
      return
	 make_procedure_app_stack_stamp_set__40_cfa_info2(
	 (make_procedure_app_48_bglt) (obj_6282), val1814_6283);
   }
}



/* make-procedure-app-stack-stamp */
obj_t 
make_procedure_app_stack_stamp_100_cfa_info2(make_procedure_app_48_bglt obj_673)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 49 */
      {
	 obj_t aux_8897;
	 {	/* Cfa/cinfo2.scm 49 */
	    object_bglt aux_8898;
	    aux_8898 =
	       (object_bglt) (obj_673);
	    aux_8897 =
	       OBJECT_WIDENING(aux_8898);
	 }
	 return
	    (((make_procedure_app_48_bglt) CREF(aux_8897))->stack_stamp_31);
      }
   }
}



/* _make-procedure-app-stack-stamp */
obj_t 
_make_procedure_app_stack_stamp_199_cfa_info2(obj_t env_6284, obj_t obj_6285)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 49 */
      return
	 make_procedure_app_stack_stamp_100_cfa_info2(
	 (make_procedure_app_48_bglt) (obj_6285));
   }
}



/* allocate-pre-procedure-set!-app */
app_bglt 
allocate_pre_procedure_set__app_97_cfa_info2()
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 28 */
      {		/* Cfa/cinfo2.scm 28 */
	 app_bglt new1794_2440;
	 new1794_2440 =
	    ((app_bglt) BREF(GC_MALLOC(sizeof(struct app))));
	 {	/* Cfa/cinfo2.scm 28 */
	    long arg2411_2441;
	    arg2411_2441 =
	       class_num_218___object(pre_procedure_set__app_208_cfa_info2);
	    {	/* Cfa/cinfo2.scm 28 */
	       obj_t obj_4181;
	       obj_4181 =
		  (obj_t) (new1794_2440);
	       (((obj_t) CREF(obj_4181))->header = MAKE_HEADER(arg2411_2441, 0), BUNSPEC);
	    }
	 }
	 {	/* Cfa/cinfo2.scm 28 */
	    object_bglt aux_8908;
	    aux_8908 =
	       (object_bglt) (new1794_2440);
	    OBJECT_WIDENING_SET(aux_8908, BFALSE);
	 }
	 return new1794_2440;
      }
   }
}



/* _allocate-pre-procedure-set!-app */
obj_t 
_allocate_pre_procedure_set__app_24_cfa_info2(obj_t env_5313)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 28 */
      {		/* Cfa/cinfo2.scm 28 */
	 app_bglt aux_8911;
	 aux_8911 =
	    allocate_pre_procedure_set__app_97_cfa_info2();
	 return
	    (obj_t) (aux_8911);
      }
   }
}



/* pre-procedure-set!-app? */
bool_t 
pre_procedure_set__app__184_cfa_info2(obj_t obj_677)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 28 */
      return
	 is_a__118___object(obj_677, pre_procedure_set__app_208_cfa_info2);
   }
}



/* _pre-procedure-set!-app? */
obj_t 
_pre_procedure_set__app__169_cfa_info2(obj_t env_6286, obj_t obj_6287)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 28 */
      {		/* Cfa/cinfo2.scm 28 */
	 bool_t aux_8915;
	 aux_8915 =
	    pre_procedure_set__app__184_cfa_info2(obj_6287);
	 return
	    BBOOL(aux_8915);
      }
   }
}



/* widening-pre-procedure-set!-app */
pre_procedure_set__app_208_bglt 
widening_pre_procedure_set__app_124_cfa_info2()
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 28 */
      {		/* Cfa/cinfo2.scm 28 */

	 return
	    ((pre_procedure_set__app_208_bglt) BREF(GC_MALLOC(sizeof(struct pre_procedure_set__app_208))));
      }
   }
}



/* _widening-pre-procedure-set!-app */
obj_t 
_widening_pre_procedure_set__app_89_cfa_info2(obj_t env_6288)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 28 */
      {		/* Cfa/cinfo2.scm 28 */
	 pre_procedure_set__app_208_bglt aux_8919;
	 aux_8919 =
	    widening_pre_procedure_set__app_124_cfa_info2();
	 return
	    (obj_t) (aux_8919);
      }
   }
}



/* make-pre-procedure-set!-app */
pre_procedure_set__app_208_bglt 
make_pre_procedure_set__app_49_cfa_info2(obj_t loc_678, type_bglt type_679, obj_t side_effect__165_680, obj_t key_681, var_bglt fun_682, obj_t args_683, obj_t stack_info_255_684)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 28 */
      {		/* Cfa/cinfo2.scm 28 */
	 app_bglt aux1792_4184;
	 {	/* Cfa/cinfo2.scm 28 */
	    app_bglt res2841_4206;
	    {	/* ./Ast/node.scm 698 */
	       app_bglt new1248_4195;
	       new1248_4195 =
		  ((app_bglt) BREF(GC_MALLOC(sizeof(struct app))));
	       {	/* ./Ast/node.scm 698 */
		  long arg2541_4196;
		  arg2541_4196 =
		     class_num_218___object(app_ast_node);
		  {	/* ./Ast/node.scm 698 */
		     obj_t obj_4204;
		     obj_4204 =
			(obj_t) (new1248_4195);
		     (((obj_t) CREF(obj_4204))->header = MAKE_HEADER(arg2541_4196, 0), BUNSPEC);
		  }
	       }
	       {	/* ./Ast/node.scm 698 */
		  object_bglt aux_8926;
		  aux_8926 =
		     (object_bglt) (new1248_4195);
		  OBJECT_WIDENING_SET(aux_8926, BFALSE);
	       }
	       ((((app_bglt) CREF(new1248_4195))->loc) = ((obj_t) loc_678), BUNSPEC);
	       ((((app_bglt) CREF(new1248_4195))->type) = ((type_bglt) type_679), BUNSPEC);
	       ((((app_bglt) CREF(new1248_4195))->side_effect__165) = ((obj_t) side_effect__165_680), BUNSPEC);
	       ((((app_bglt) CREF(new1248_4195))->key) = ((obj_t) key_681), BUNSPEC);
	       ((((app_bglt) CREF(new1248_4195))->fun) = ((var_bglt) fun_682), BUNSPEC);
	       ((((app_bglt) CREF(new1248_4195))->args) = ((obj_t) args_683), BUNSPEC);
	       ((((app_bglt) CREF(new1248_4195))->stack_info_255) = ((obj_t) stack_info_255_684), BUNSPEC);
	       res2841_4206 = new1248_4195;
	    }
	    aux1792_4184 = res2841_4206;
	 }
	 {	/* Cfa/cinfo2.scm 28 */
	    pre_procedure_set__app_208_bglt new1793_4185;
	    new1793_4185 =
	       ((pre_procedure_set__app_208_bglt) (aux1792_4184));
	    {	/* Cfa/cinfo2.scm 28 */
	       long arg2412_4186;
	       arg2412_4186 =
		  class_num_218___object(pre_procedure_set__app_208_cfa_info2);
	       {	/* Cfa/cinfo2.scm 28 */
		  obj_t obj_4207;
		  obj_4207 =
		     (obj_t) (new1793_4185);
		  (((obj_t) CREF(obj_4207))->header = MAKE_HEADER(arg2412_4186, 0), BUNSPEC);
	       }
	    }
	    {	/* Cfa/cinfo2.scm 28 */
	       obj_t aux_8942;
	       object_bglt aux_8940;
	       {	/* Cfa/cinfo2.scm 28 */
		  pre_procedure_set__app_208_bglt aux_8943;
		  {	/* Cfa/cinfo2.scm 28 */

		     aux_8943 =
			((pre_procedure_set__app_208_bglt) BREF(GC_MALLOC(sizeof(struct pre_procedure_set__app_208))));
		  }
		  aux_8942 =
		     (obj_t) (aux_8943);
	       }
	       aux_8940 =
		  (object_bglt) (new1793_4185);
	       OBJECT_WIDENING_SET(aux_8940, aux_8942);
	    }
	    return new1793_4185;
	 }
      }
   }
}



/* _make-pre-procedure-set!-app */
obj_t 
_make_pre_procedure_set__app_211_cfa_info2(obj_t env_6289, obj_t loc_6290, obj_t type_6291, obj_t side_effect__165_6292, obj_t key_6293, obj_t fun_6294, obj_t args_6295, obj_t stack_info_255_6296)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 28 */
      {		/* Cfa/cinfo2.scm 28 */
	 pre_procedure_set__app_208_bglt aux_8947;
	 aux_8947 =
	    make_pre_procedure_set__app_49_cfa_info2(loc_6290,
	    (type_bglt) (type_6291), side_effect__165_6292, key_6293,
	    (var_bglt) (fun_6294), args_6295, stack_info_255_6296);
	 return
	    (obj_t) (aux_8947);
      }
   }
}



/* pre-procedure-set!-app-loc */
obj_t 
pre_procedure_set__app_loc_154_cfa_info2(app_bglt obj_685)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 661 */
      return
	 (((app_bglt) CREF(obj_685))->loc);
   }
}



/* _pre-procedure-set!-app-loc */
obj_t 
_pre_procedure_set__app_loc_10_cfa_info2(obj_t env_6297, obj_t obj_6298)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 661 */
      return
	 pre_procedure_set__app_loc_154_cfa_info2(
	 (app_bglt) (obj_6298));
   }
}



/* pre-procedure-set!-app-type-set! */
obj_t 
pre_procedure_set__app_type_set__203_cfa_info2(app_bglt obj_686, type_bglt val1784_687)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 28 */
      return
	 ((((app_bglt) CREF(obj_686))->type) = ((type_bglt) val1784_687), BUNSPEC);
   }
}



/* _pre-procedure-set!-app-type-set! */
obj_t 
_pre_procedure_set__app_type_set__205_cfa_info2(obj_t env_6299, obj_t obj_6300, obj_t val1784_6301)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 28 */
      return
	 pre_procedure_set__app_type_set__203_cfa_info2(
	 (app_bglt) (obj_6300),
	 (type_bglt) (val1784_6301));
   }
}



/* pre-procedure-set!-app-type */
type_bglt 
pre_procedure_set__app_type_159_cfa_info2(app_bglt obj_688)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 28 */
      return
	 (((app_bglt) CREF(obj_688))->type);
   }
}



/* _pre-procedure-set!-app-type */
obj_t 
_pre_procedure_set__app_type_192_cfa_info2(obj_t env_6302, obj_t obj_6303)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 28 */
      {		/* Cfa/cinfo2.scm 28 */
	 type_bglt aux_8960;
	 aux_8960 =
	    pre_procedure_set__app_type_159_cfa_info2(
	    (app_bglt) (obj_6303));
	 return
	    (obj_t) (aux_8960);
      }
   }
}



/* pre-procedure-set!-app-side-effect?-set! */
obj_t 
pre_procedure_set__app_side_effect__set__95_cfa_info2(app_bglt obj_689, obj_t val1785_690)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 669 */
      return
	 ((((app_bglt) CREF(obj_689))->side_effect__165) = ((obj_t) val1785_690), BUNSPEC);
   }
}



/* _pre-procedure-set!-app-side-effect?-set! */
obj_t 
_pre_procedure_set__app_side_effect__set__8_cfa_info2(obj_t env_6304, obj_t obj_6305, obj_t val1785_6306)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 669 */
      return
	 pre_procedure_set__app_side_effect__set__95_cfa_info2(
	 (app_bglt) (obj_6305), val1785_6306);
   }
}



/* pre-procedure-set!-app-side-effect? */
obj_t 
pre_procedure_set__app_side_effect__40_cfa_info2(app_bglt obj_691)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 669 */
      return
	 (((app_bglt) CREF(obj_691))->side_effect__165);
   }
}



/* _pre-procedure-set!-app-side-effect? */
obj_t 
_pre_procedure_set__app_side_effect__59_cfa_info2(obj_t env_6307, obj_t obj_6308)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 669 */
      return
	 pre_procedure_set__app_side_effect__40_cfa_info2(
	 (app_bglt) (obj_6308));
   }
}



/* pre-procedure-set!-app-key-set! */
obj_t 
pre_procedure_set__app_key_set__8_cfa_info2(app_bglt obj_692, obj_t val1786_693)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 673 */
      return
	 ((((app_bglt) CREF(obj_692))->key) = ((obj_t) val1786_693), BUNSPEC);
   }
}



/* _pre-procedure-set!-app-key-set!2905 */
obj_t 
_pre_procedure_set__app_key_set_2905_12_cfa_info2(obj_t env_6309, obj_t obj_6310, obj_t val1786_6311)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 673 */
      return
	 pre_procedure_set__app_key_set__8_cfa_info2(
	 (app_bglt) (obj_6310), val1786_6311);
   }
}



/* pre-procedure-set!-app-key */
obj_t 
pre_procedure_set__app_key_59_cfa_info2(app_bglt obj_694)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 673 */
      return
	 (((app_bglt) CREF(obj_694))->key);
   }
}



/* _pre-procedure-set!-app-key2906 */
obj_t 
_pre_procedure_set__app_key2906_82_cfa_info2(obj_t env_6312, obj_t obj_6313)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 673 */
      return
	 pre_procedure_set__app_key_59_cfa_info2(
	 (app_bglt) (obj_6313));
   }
}



/* pre-procedure-set!-app-fun-set! */
obj_t 
pre_procedure_set__app_fun_set__200_cfa_info2(app_bglt obj_695, var_bglt val1787_696)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 28 */
      return
	 ((((app_bglt) CREF(obj_695))->fun) = ((var_bglt) val1787_696), BUNSPEC);
   }
}



/* _pre-procedure-set!-app-fun-set! */
obj_t 
_pre_procedure_set__app_fun_set__73_cfa_info2(obj_t env_6314, obj_t obj_6315, obj_t val1787_6316)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 28 */
      return
	 pre_procedure_set__app_fun_set__200_cfa_info2(
	 (app_bglt) (obj_6315),
	 (var_bglt) (val1787_6316));
   }
}



/* pre-procedure-set!-app-fun */
var_bglt 
pre_procedure_set__app_fun_8_cfa_info2(app_bglt obj_697)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 28 */
      return
	 (((app_bglt) CREF(obj_697))->fun);
   }
}



/* _pre-procedure-set!-app-fun */
obj_t 
_pre_procedure_set__app_fun_238_cfa_info2(obj_t env_6317, obj_t obj_6318)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 28 */
      {		/* Cfa/cinfo2.scm 28 */
	 var_bglt aux_8981;
	 aux_8981 =
	    pre_procedure_set__app_fun_8_cfa_info2(
	    (app_bglt) (obj_6318));
	 return
	    (obj_t) (aux_8981);
      }
   }
}



/* pre-procedure-set!-app-args-set! */
obj_t 
pre_procedure_set__app_args_set__156_cfa_info2(app_bglt obj_698, obj_t val1788_699)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 28 */
      return
	 ((((app_bglt) CREF(obj_698))->args) = ((obj_t) val1788_699), BUNSPEC);
   }
}



/* _pre-procedure-set!-app-args-set! */
obj_t 
_pre_procedure_set__app_args_set__34_cfa_info2(obj_t env_6319, obj_t obj_6320, obj_t val1788_6321)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 28 */
      return
	 pre_procedure_set__app_args_set__156_cfa_info2(
	 (app_bglt) (obj_6320), val1788_6321);
   }
}



/* pre-procedure-set!-app-args */
obj_t 
pre_procedure_set__app_args_207_cfa_info2(app_bglt obj_700)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 28 */
      return
	 (((app_bglt) CREF(obj_700))->args);
   }
}



/* _pre-procedure-set!-app-args */
obj_t 
_pre_procedure_set__app_args_86_cfa_info2(obj_t env_6322, obj_t obj_6323)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 28 */
      return
	 pre_procedure_set__app_args_207_cfa_info2(
	 (app_bglt) (obj_6323));
   }
}



/* pre-procedure-set!-app-stack-info-set! */
obj_t 
pre_procedure_set__app_stack_info_set__151_cfa_info2(app_bglt obj_701, obj_t val1789_702)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 704 */
      return
	 ((((app_bglt) CREF(obj_701))->stack_info_255) = ((obj_t) val1789_702), BUNSPEC);
   }
}



/* _pre-procedure-set!-app-stack-info-set! */
obj_t 
_pre_procedure_set__app_stack_info_set__185_cfa_info2(obj_t env_6324, obj_t obj_6325, obj_t val1789_6326)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 704 */
      return
	 pre_procedure_set__app_stack_info_set__151_cfa_info2(
	 (app_bglt) (obj_6325), val1789_6326);
   }
}



/* pre-procedure-set!-app-stack-info */
obj_t 
pre_procedure_set__app_stack_info_34_cfa_info2(app_bglt obj_703)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 704 */
      return
	 (((app_bglt) CREF(obj_703))->stack_info_255);
   }
}



/* _pre-procedure-set!-app-stack-info */
obj_t 
_pre_procedure_set__app_stack_info_244_cfa_info2(obj_t env_6327, obj_t obj_6328)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 704 */
      return
	 pre_procedure_set__app_stack_info_34_cfa_info2(
	 (app_bglt) (obj_6328));
   }
}



/* allocate-pre-procedure-ref-app */
app_bglt 
allocate_pre_procedure_ref_app_138_cfa_info2()
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 27 */
      {		/* Cfa/cinfo2.scm 27 */
	 app_bglt new1777_2447;
	 new1777_2447 =
	    ((app_bglt) BREF(GC_MALLOC(sizeof(struct app))));
	 {	/* Cfa/cinfo2.scm 27 */
	    long arg2414_2448;
	    arg2414_2448 =
	       class_num_218___object(pre_procedure_ref_app_85_cfa_info2);
	    {	/* Cfa/cinfo2.scm 27 */
	       obj_t obj_4211;
	       obj_4211 =
		  (obj_t) (new1777_2447);
	       (((obj_t) CREF(obj_4211))->header = MAKE_HEADER(arg2414_2448, 0), BUNSPEC);
	    }
	 }
	 {	/* Cfa/cinfo2.scm 27 */
	    object_bglt aux_9001;
	    aux_9001 =
	       (object_bglt) (new1777_2447);
	    OBJECT_WIDENING_SET(aux_9001, BFALSE);
	 }
	 return new1777_2447;
      }
   }
}



/* _allocate-pre-procedure-ref-app */
obj_t 
_allocate_pre_procedure_ref_app_105_cfa_info2(obj_t env_5312)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 27 */
      {		/* Cfa/cinfo2.scm 27 */
	 app_bglt aux_9004;
	 aux_9004 =
	    allocate_pre_procedure_ref_app_138_cfa_info2();
	 return
	    (obj_t) (aux_9004);
      }
   }
}



/* pre-procedure-ref-app? */
bool_t 
pre_procedure_ref_app__89_cfa_info2(obj_t obj_707)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 27 */
      return
	 is_a__118___object(obj_707, pre_procedure_ref_app_85_cfa_info2);
   }
}



/* _pre-procedure-ref-app? */
obj_t 
_pre_procedure_ref_app__123_cfa_info2(obj_t env_6329, obj_t obj_6330)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 27 */
      {		/* Cfa/cinfo2.scm 27 */
	 bool_t aux_9008;
	 aux_9008 =
	    pre_procedure_ref_app__89_cfa_info2(obj_6330);
	 return
	    BBOOL(aux_9008);
      }
   }
}



/* widening-pre-procedure-ref-app */
pre_procedure_ref_app_85_bglt 
widening_pre_procedure_ref_app_236_cfa_info2()
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 27 */
      {		/* Cfa/cinfo2.scm 27 */

	 return
	    ((pre_procedure_ref_app_85_bglt) BREF(GC_MALLOC(sizeof(struct pre_procedure_ref_app_85))));
      }
   }
}



/* _widening-pre-procedure-ref-app */
obj_t 
_widening_pre_procedure_ref_app_214_cfa_info2(obj_t env_6331)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 27 */
      {		/* Cfa/cinfo2.scm 27 */
	 pre_procedure_ref_app_85_bglt aux_9012;
	 aux_9012 =
	    widening_pre_procedure_ref_app_236_cfa_info2();
	 return
	    (obj_t) (aux_9012);
      }
   }
}



/* make-pre-procedure-ref-app */
pre_procedure_ref_app_85_bglt 
make_pre_procedure_ref_app_17_cfa_info2(obj_t loc_708, type_bglt type_709, obj_t side_effect__165_710, obj_t key_711, var_bglt fun_712, obj_t args_713, obj_t stack_info_255_714)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 27 */
      {		/* Cfa/cinfo2.scm 27 */
	 app_bglt aux1775_4214;
	 {	/* Cfa/cinfo2.scm 27 */
	    app_bglt res2843_4236;
	    {	/* ./Ast/node.scm 698 */
	       app_bglt new1248_4225;
	       new1248_4225 =
		  ((app_bglt) BREF(GC_MALLOC(sizeof(struct app))));
	       {	/* ./Ast/node.scm 698 */
		  long arg2541_4226;
		  arg2541_4226 =
		     class_num_218___object(app_ast_node);
		  {	/* ./Ast/node.scm 698 */
		     obj_t obj_4234;
		     obj_4234 =
			(obj_t) (new1248_4225);
		     (((obj_t) CREF(obj_4234))->header = MAKE_HEADER(arg2541_4226, 0), BUNSPEC);
		  }
	       }
	       {	/* ./Ast/node.scm 698 */
		  object_bglt aux_9019;
		  aux_9019 =
		     (object_bglt) (new1248_4225);
		  OBJECT_WIDENING_SET(aux_9019, BFALSE);
	       }
	       ((((app_bglt) CREF(new1248_4225))->loc) = ((obj_t) loc_708), BUNSPEC);
	       ((((app_bglt) CREF(new1248_4225))->type) = ((type_bglt) type_709), BUNSPEC);
	       ((((app_bglt) CREF(new1248_4225))->side_effect__165) = ((obj_t) side_effect__165_710), BUNSPEC);
	       ((((app_bglt) CREF(new1248_4225))->key) = ((obj_t) key_711), BUNSPEC);
	       ((((app_bglt) CREF(new1248_4225))->fun) = ((var_bglt) fun_712), BUNSPEC);
	       ((((app_bglt) CREF(new1248_4225))->args) = ((obj_t) args_713), BUNSPEC);
	       ((((app_bglt) CREF(new1248_4225))->stack_info_255) = ((obj_t) stack_info_255_714), BUNSPEC);
	       res2843_4236 = new1248_4225;
	    }
	    aux1775_4214 = res2843_4236;
	 }
	 {	/* Cfa/cinfo2.scm 27 */
	    pre_procedure_ref_app_85_bglt new1776_4215;
	    new1776_4215 =
	       ((pre_procedure_ref_app_85_bglt) (aux1775_4214));
	    {	/* Cfa/cinfo2.scm 27 */
	       long arg2415_4216;
	       arg2415_4216 =
		  class_num_218___object(pre_procedure_ref_app_85_cfa_info2);
	       {	/* Cfa/cinfo2.scm 27 */
		  obj_t obj_4237;
		  obj_4237 =
		     (obj_t) (new1776_4215);
		  (((obj_t) CREF(obj_4237))->header = MAKE_HEADER(arg2415_4216, 0), BUNSPEC);
	       }
	    }
	    {	/* Cfa/cinfo2.scm 27 */
	       obj_t aux_9035;
	       object_bglt aux_9033;
	       {	/* Cfa/cinfo2.scm 27 */
		  pre_procedure_ref_app_85_bglt aux_9036;
		  {	/* Cfa/cinfo2.scm 27 */

		     aux_9036 =
			((pre_procedure_ref_app_85_bglt) BREF(GC_MALLOC(sizeof(struct pre_procedure_ref_app_85))));
		  }
		  aux_9035 =
		     (obj_t) (aux_9036);
	       }
	       aux_9033 =
		  (object_bglt) (new1776_4215);
	       OBJECT_WIDENING_SET(aux_9033, aux_9035);
	    }
	    return new1776_4215;
	 }
      }
   }
}



/* _make-pre-procedure-ref-app */
obj_t 
_make_pre_procedure_ref_app_208_cfa_info2(obj_t env_6332, obj_t loc_6333, obj_t type_6334, obj_t side_effect__165_6335, obj_t key_6336, obj_t fun_6337, obj_t args_6338, obj_t stack_info_255_6339)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 27 */
      {		/* Cfa/cinfo2.scm 27 */
	 pre_procedure_ref_app_85_bglt aux_9040;
	 aux_9040 =
	    make_pre_procedure_ref_app_17_cfa_info2(loc_6333,
	    (type_bglt) (type_6334), side_effect__165_6335, key_6336,
	    (var_bglt) (fun_6337), args_6338, stack_info_255_6339);
	 return
	    (obj_t) (aux_9040);
      }
   }
}



/* pre-procedure-ref-app-loc */
obj_t 
pre_procedure_ref_app_loc_169_cfa_info2(app_bglt obj_715)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 661 */
      return
	 (((app_bglt) CREF(obj_715))->loc);
   }
}



/* _pre-procedure-ref-app-loc */
obj_t 
_pre_procedure_ref_app_loc_210_cfa_info2(obj_t env_6340, obj_t obj_6341)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 661 */
      return
	 pre_procedure_ref_app_loc_169_cfa_info2(
	 (app_bglt) (obj_6341));
   }
}



/* pre-procedure-ref-app-type-set! */
obj_t 
pre_procedure_ref_app_type_set__15_cfa_info2(app_bglt obj_716, type_bglt val1767_717)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 27 */
      return
	 ((((app_bglt) CREF(obj_716))->type) = ((type_bglt) val1767_717), BUNSPEC);
   }
}



/* _pre-procedure-ref-app-type-set! */
obj_t 
_pre_procedure_ref_app_type_set__111_cfa_info2(obj_t env_6342, obj_t obj_6343, obj_t val1767_6344)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 27 */
      return
	 pre_procedure_ref_app_type_set__15_cfa_info2(
	 (app_bglt) (obj_6343),
	 (type_bglt) (val1767_6344));
   }
}



/* pre-procedure-ref-app-type */
type_bglt 
pre_procedure_ref_app_type_232_cfa_info2(app_bglt obj_718)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 27 */
      return
	 (((app_bglt) CREF(obj_718))->type);
   }
}



/* _pre-procedure-ref-app-type */
obj_t 
_pre_procedure_ref_app_type_154_cfa_info2(obj_t env_6345, obj_t obj_6346)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 27 */
      {		/* Cfa/cinfo2.scm 27 */
	 type_bglt aux_9053;
	 aux_9053 =
	    pre_procedure_ref_app_type_232_cfa_info2(
	    (app_bglt) (obj_6346));
	 return
	    (obj_t) (aux_9053);
      }
   }
}



/* pre-procedure-ref-app-side-effect?-set! */
obj_t 
pre_procedure_ref_app_side_effect__set__159_cfa_info2(app_bglt obj_719, obj_t val1768_720)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 669 */
      return
	 ((((app_bglt) CREF(obj_719))->side_effect__165) = ((obj_t) val1768_720), BUNSPEC);
   }
}



/* _pre-procedure-ref-app-side-effect?-set! */
obj_t 
_pre_procedure_ref_app_side_effect__set__26_cfa_info2(obj_t env_6347, obj_t obj_6348, obj_t val1768_6349)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 669 */
      return
	 pre_procedure_ref_app_side_effect__set__159_cfa_info2(
	 (app_bglt) (obj_6348), val1768_6349);
   }
}



/* pre-procedure-ref-app-side-effect? */
obj_t 
pre_procedure_ref_app_side_effect__41_cfa_info2(app_bglt obj_721)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 669 */
      return
	 (((app_bglt) CREF(obj_721))->side_effect__165);
   }
}



/* _pre-procedure-ref-app-side-effect? */
obj_t 
_pre_procedure_ref_app_side_effect__173_cfa_info2(obj_t env_6350, obj_t obj_6351)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 669 */
      return
	 pre_procedure_ref_app_side_effect__41_cfa_info2(
	 (app_bglt) (obj_6351));
   }
}



/* pre-procedure-ref-app-key-set! */
obj_t 
pre_procedure_ref_app_key_set__34_cfa_info2(app_bglt obj_722, obj_t val1769_723)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 673 */
      return
	 ((((app_bglt) CREF(obj_722))->key) = ((obj_t) val1769_723), BUNSPEC);
   }
}



/* _pre-procedure-ref-app-key-set!2907 */
obj_t 
_pre_procedure_ref_app_key_set_2907_153_cfa_info2(obj_t env_6352, obj_t obj_6353, obj_t val1769_6354)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 673 */
      return
	 pre_procedure_ref_app_key_set__34_cfa_info2(
	 (app_bglt) (obj_6353), val1769_6354);
   }
}



/* pre-procedure-ref-app-key */
obj_t 
pre_procedure_ref_app_key_86_cfa_info2(app_bglt obj_724)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 673 */
      return
	 (((app_bglt) CREF(obj_724))->key);
   }
}



/* _pre-procedure-ref-app-key2908 */
obj_t 
_pre_procedure_ref_app_key2908_96_cfa_info2(obj_t env_6355, obj_t obj_6356)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 673 */
      return
	 pre_procedure_ref_app_key_86_cfa_info2(
	 (app_bglt) (obj_6356));
   }
}



/* pre-procedure-ref-app-fun-set! */
obj_t 
pre_procedure_ref_app_fun_set__152_cfa_info2(app_bglt obj_725, var_bglt val1770_726)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 27 */
      return
	 ((((app_bglt) CREF(obj_725))->fun) = ((var_bglt) val1770_726), BUNSPEC);
   }
}



/* _pre-procedure-ref-app-fun-set! */
obj_t 
_pre_procedure_ref_app_fun_set__20_cfa_info2(obj_t env_6357, obj_t obj_6358, obj_t val1770_6359)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 27 */
      return
	 pre_procedure_ref_app_fun_set__152_cfa_info2(
	 (app_bglt) (obj_6358),
	 (var_bglt) (val1770_6359));
   }
}



/* pre-procedure-ref-app-fun */
var_bglt 
pre_procedure_ref_app_fun_172_cfa_info2(app_bglt obj_727)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 27 */
      return
	 (((app_bglt) CREF(obj_727))->fun);
   }
}



/* _pre-procedure-ref-app-fun */
obj_t 
_pre_procedure_ref_app_fun_224_cfa_info2(obj_t env_6360, obj_t obj_6361)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 27 */
      {		/* Cfa/cinfo2.scm 27 */
	 var_bglt aux_9074;
	 aux_9074 =
	    pre_procedure_ref_app_fun_172_cfa_info2(
	    (app_bglt) (obj_6361));
	 return
	    (obj_t) (aux_9074);
      }
   }
}



/* pre-procedure-ref-app-args-set! */
obj_t 
pre_procedure_ref_app_args_set__9_cfa_info2(app_bglt obj_728, obj_t val1771_729)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 27 */
      return
	 ((((app_bglt) CREF(obj_728))->args) = ((obj_t) val1771_729), BUNSPEC);
   }
}



/* _pre-procedure-ref-app-args-set! */
obj_t 
_pre_procedure_ref_app_args_set__233_cfa_info2(obj_t env_6362, obj_t obj_6363, obj_t val1771_6364)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 27 */
      return
	 pre_procedure_ref_app_args_set__9_cfa_info2(
	 (app_bglt) (obj_6363), val1771_6364);
   }
}



/* pre-procedure-ref-app-args */
obj_t 
pre_procedure_ref_app_args_98_cfa_info2(app_bglt obj_730)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 27 */
      return
	 (((app_bglt) CREF(obj_730))->args);
   }
}



/* _pre-procedure-ref-app-args */
obj_t 
_pre_procedure_ref_app_args_119_cfa_info2(obj_t env_6365, obj_t obj_6366)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 27 */
      return
	 pre_procedure_ref_app_args_98_cfa_info2(
	 (app_bglt) (obj_6366));
   }
}



/* pre-procedure-ref-app-stack-info-set! */
obj_t 
pre_procedure_ref_app_stack_info_set__115_cfa_info2(app_bglt obj_731, obj_t val1772_732)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 704 */
      return
	 ((((app_bglt) CREF(obj_731))->stack_info_255) = ((obj_t) val1772_732), BUNSPEC);
   }
}



/* _pre-procedure-ref-app-stack-info-set! */
obj_t 
_pre_procedure_ref_app_stack_info_set__160_cfa_info2(obj_t env_6367, obj_t obj_6368, obj_t val1772_6369)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 704 */
      return
	 pre_procedure_ref_app_stack_info_set__115_cfa_info2(
	 (app_bglt) (obj_6368), val1772_6369);
   }
}



/* pre-procedure-ref-app-stack-info */
obj_t 
pre_procedure_ref_app_stack_info_22_cfa_info2(app_bglt obj_733)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 704 */
      return
	 (((app_bglt) CREF(obj_733))->stack_info_255);
   }
}



/* _pre-procedure-ref-app-stack-info */
obj_t 
_pre_procedure_ref_app_stack_info_230_cfa_info2(obj_t env_6370, obj_t obj_6371)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 704 */
      return
	 pre_procedure_ref_app_stack_info_22_cfa_info2(
	 (app_bglt) (obj_6371));
   }
}



/* allocate-pre-make-procedure-app */
app_bglt 
allocate_pre_make_procedure_app_4_cfa_info2()
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 24 */
      {		/* Cfa/cinfo2.scm 24 */
	 app_bglt new1759_2454;
	 new1759_2454 =
	    ((app_bglt) BREF(GC_MALLOC(sizeof(struct app))));
	 {	/* Cfa/cinfo2.scm 24 */
	    long arg2417_2455;
	    arg2417_2455 =
	       class_num_218___object(pre_make_procedure_app_60_cfa_info2);
	    {	/* Cfa/cinfo2.scm 24 */
	       obj_t obj_4241;
	       obj_4241 =
		  (obj_t) (new1759_2454);
	       (((obj_t) CREF(obj_4241))->header = MAKE_HEADER(arg2417_2455, 0), BUNSPEC);
	    }
	 }
	 {	/* Cfa/cinfo2.scm 24 */
	    object_bglt aux_9094;
	    aux_9094 =
	       (object_bglt) (new1759_2454);
	    OBJECT_WIDENING_SET(aux_9094, BFALSE);
	 }
	 return new1759_2454;
      }
   }
}



/* _allocate-pre-make-procedure-app */
obj_t 
_allocate_pre_make_procedure_app_108_cfa_info2(obj_t env_5311)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 24 */
      {		/* Cfa/cinfo2.scm 24 */
	 app_bglt aux_9097;
	 aux_9097 =
	    allocate_pre_make_procedure_app_4_cfa_info2();
	 return
	    (obj_t) (aux_9097);
      }
   }
}



/* pre-make-procedure-app? */
bool_t 
pre_make_procedure_app__25_cfa_info2(obj_t obj_737)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 24 */
      return
	 is_a__118___object(obj_737, pre_make_procedure_app_60_cfa_info2);
   }
}



/* _pre-make-procedure-app? */
obj_t 
_pre_make_procedure_app__252_cfa_info2(obj_t env_6372, obj_t obj_6373)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 24 */
      {		/* Cfa/cinfo2.scm 24 */
	 bool_t aux_9101;
	 aux_9101 =
	    pre_make_procedure_app__25_cfa_info2(obj_6373);
	 return
	    BBOOL(aux_9101);
      }
   }
}



/* widening-pre-make-procedure-app */
pre_make_procedure_app_60_bglt 
widening_pre_make_procedure_app_11_cfa_info2(variable_bglt owner_738)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 24 */
      {		/* Cfa/cinfo2.scm 24 */
	 pre_make_procedure_app_60_bglt new1754_4243;
	 new1754_4243 =
	    ((pre_make_procedure_app_60_bglt) BREF(GC_MALLOC(sizeof(struct pre_make_procedure_app_60))));
	 ((((pre_make_procedure_app_60_bglt) CREF(new1754_4243))->owner) = ((variable_bglt) owner_738), BUNSPEC);
	 return new1754_4243;
      }
   }
}



/* _widening-pre-make-procedure-app2909 */
obj_t 
_widening_pre_make_procedure_app2909_172_cfa_info2(obj_t env_6374, obj_t owner_6375)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 24 */
      {		/* Cfa/cinfo2.scm 24 */
	 pre_make_procedure_app_60_bglt aux_9106;
	 aux_9106 =
	    widening_pre_make_procedure_app_11_cfa_info2(
	    (variable_bglt) (owner_6375));
	 return
	    (obj_t) (aux_9106);
      }
   }
}



/* make-pre-make-procedure-app */
pre_make_procedure_app_60_bglt 
make_pre_make_procedure_app_142_cfa_info2(obj_t loc_739, type_bglt type_740, obj_t side_effect__165_741, obj_t key_742, var_bglt fun_743, obj_t args_744, obj_t stack_info_255_745, variable_bglt owner_746)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 24 */
      {		/* Cfa/cinfo2.scm 24 */
	 app_bglt aux1757_4245;
	 {	/* Cfa/cinfo2.scm 24 */
	    app_bglt res2845_4267;
	    {	/* ./Ast/node.scm 698 */
	       app_bglt new1248_4256;
	       new1248_4256 =
		  ((app_bglt) BREF(GC_MALLOC(sizeof(struct app))));
	       {	/* ./Ast/node.scm 698 */
		  long arg2541_4257;
		  arg2541_4257 =
		     class_num_218___object(app_ast_node);
		  {	/* ./Ast/node.scm 698 */
		     obj_t obj_4265;
		     obj_4265 =
			(obj_t) (new1248_4256);
		     (((obj_t) CREF(obj_4265))->header = MAKE_HEADER(arg2541_4257, 0), BUNSPEC);
		  }
	       }
	       {	/* ./Ast/node.scm 698 */
		  object_bglt aux_9114;
		  aux_9114 =
		     (object_bglt) (new1248_4256);
		  OBJECT_WIDENING_SET(aux_9114, BFALSE);
	       }
	       ((((app_bglt) CREF(new1248_4256))->loc) = ((obj_t) loc_739), BUNSPEC);
	       ((((app_bglt) CREF(new1248_4256))->type) = ((type_bglt) type_740), BUNSPEC);
	       ((((app_bglt) CREF(new1248_4256))->side_effect__165) = ((obj_t) side_effect__165_741), BUNSPEC);
	       ((((app_bglt) CREF(new1248_4256))->key) = ((obj_t) key_742), BUNSPEC);
	       ((((app_bglt) CREF(new1248_4256))->fun) = ((var_bglt) fun_743), BUNSPEC);
	       ((((app_bglt) CREF(new1248_4256))->args) = ((obj_t) args_744), BUNSPEC);
	       ((((app_bglt) CREF(new1248_4256))->stack_info_255) = ((obj_t) stack_info_255_745), BUNSPEC);
	       res2845_4267 = new1248_4256;
	    }
	    aux1757_4245 = res2845_4267;
	 }
	 {	/* Cfa/cinfo2.scm 24 */
	    pre_make_procedure_app_60_bglt new1758_4246;
	    new1758_4246 =
	       ((pre_make_procedure_app_60_bglt) (aux1757_4245));
	    {	/* Cfa/cinfo2.scm 24 */
	       long arg2418_4247;
	       arg2418_4247 =
		  class_num_218___object(pre_make_procedure_app_60_cfa_info2);
	       {	/* Cfa/cinfo2.scm 24 */
		  obj_t obj_4268;
		  obj_4268 =
		     (obj_t) (new1758_4246);
		  (((obj_t) CREF(obj_4268))->header = MAKE_HEADER(arg2418_4247, 0), BUNSPEC);
	       }
	    }
	    {	/* Cfa/cinfo2.scm 24 */
	       pre_make_procedure_app_60_bglt arg2419_4248;
	       {	/* Cfa/cinfo2.scm 24 */
		  pre_make_procedure_app_60_bglt res2846_4273;
		  {	/* Cfa/cinfo2.scm 24 */
		     pre_make_procedure_app_60_bglt new1754_4271;
		     new1754_4271 =
			((pre_make_procedure_app_60_bglt) BREF(GC_MALLOC(sizeof(struct pre_make_procedure_app_60))));
		     ((((pre_make_procedure_app_60_bglt) CREF(new1754_4271))->owner) = ((variable_bglt) owner_746), BUNSPEC);
		     res2846_4273 = new1754_4271;
		  }
		  arg2419_4248 = res2846_4273;
	       }
	       {	/* Cfa/cinfo2.scm 24 */
		  obj_t aux_9132;
		  object_bglt aux_9130;
		  aux_9132 =
		     (obj_t) (arg2419_4248);
		  aux_9130 =
		     (object_bglt) (new1758_4246);
		  OBJECT_WIDENING_SET(aux_9130, aux_9132);
	       }
	    }
	    return new1758_4246;
	 }
      }
   }
}



/* _make-pre-make-procedure-app */
obj_t 
_make_pre_make_procedure_app_8_cfa_info2(obj_t env_6376, obj_t loc_6377, obj_t type_6378, obj_t side_effect__165_6379, obj_t key_6380, obj_t fun_6381, obj_t args_6382, obj_t stack_info_255_6383, obj_t owner_6384)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 24 */
      {		/* Cfa/cinfo2.scm 24 */
	 pre_make_procedure_app_60_bglt aux_9135;
	 aux_9135 =
	    make_pre_make_procedure_app_142_cfa_info2(loc_6377,
	    (type_bglt) (type_6378), side_effect__165_6379, key_6380,
	    (var_bglt) (fun_6381), args_6382, stack_info_255_6383,
	    (variable_bglt) (owner_6384));
	 return
	    (obj_t) (aux_9135);
      }
   }
}



/* pre-make-procedure-app-loc */
obj_t 
pre_make_procedure_app_loc_229_cfa_info2(app_bglt obj_747)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 661 */
      return
	 (((app_bglt) CREF(obj_747))->loc);
   }
}



/* _pre-make-procedure-app-loc */
obj_t 
_pre_make_procedure_app_loc_53_cfa_info2(obj_t env_6385, obj_t obj_6386)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 661 */
      return
	 pre_make_procedure_app_loc_229_cfa_info2(
	 (app_bglt) (obj_6386));
   }
}



/* pre-make-procedure-app-type-set! */
obj_t 
pre_make_procedure_app_type_set__46_cfa_info2(app_bglt obj_748, type_bglt val1748_749)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 24 */
      return
	 ((((app_bglt) CREF(obj_748))->type) = ((type_bglt) val1748_749), BUNSPEC);
   }
}



/* _pre-make-procedure-app-type-set! */
obj_t 
_pre_make_procedure_app_type_set__252_cfa_info2(obj_t env_6387, obj_t obj_6388, obj_t val1748_6389)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 24 */
      return
	 pre_make_procedure_app_type_set__46_cfa_info2(
	 (app_bglt) (obj_6388),
	 (type_bglt) (val1748_6389));
   }
}



/* pre-make-procedure-app-type */
type_bglt 
pre_make_procedure_app_type_102_cfa_info2(app_bglt obj_750)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 24 */
      return
	 (((app_bglt) CREF(obj_750))->type);
   }
}



/* _pre-make-procedure-app-type */
obj_t 
_pre_make_procedure_app_type_166_cfa_info2(obj_t env_6390, obj_t obj_6391)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 24 */
      {		/* Cfa/cinfo2.scm 24 */
	 type_bglt aux_9149;
	 aux_9149 =
	    pre_make_procedure_app_type_102_cfa_info2(
	    (app_bglt) (obj_6391));
	 return
	    (obj_t) (aux_9149);
      }
   }
}



/* pre-make-procedure-app-side-effect?-set! */
obj_t 
pre_make_procedure_app_side_effect__set__13_cfa_info2(app_bglt obj_751, obj_t val1749_752)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 669 */
      return
	 ((((app_bglt) CREF(obj_751))->side_effect__165) = ((obj_t) val1749_752), BUNSPEC);
   }
}



/* _pre-make-procedure-app-side-effect?-set! */
obj_t 
_pre_make_procedure_app_side_effect__set__237_cfa_info2(obj_t env_6392, obj_t obj_6393, obj_t val1749_6394)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 669 */
      return
	 pre_make_procedure_app_side_effect__set__13_cfa_info2(
	 (app_bglt) (obj_6393), val1749_6394);
   }
}



/* pre-make-procedure-app-side-effect? */
obj_t 
pre_make_procedure_app_side_effect__30_cfa_info2(app_bglt obj_753)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 669 */
      return
	 (((app_bglt) CREF(obj_753))->side_effect__165);
   }
}



/* _pre-make-procedure-app-side-effect? */
obj_t 
_pre_make_procedure_app_side_effect__18_cfa_info2(obj_t env_6395, obj_t obj_6396)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 669 */
      return
	 pre_make_procedure_app_side_effect__30_cfa_info2(
	 (app_bglt) (obj_6396));
   }
}



/* pre-make-procedure-app-key-set! */
obj_t 
pre_make_procedure_app_key_set__101_cfa_info2(app_bglt obj_754, obj_t val1750_755)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 673 */
      return
	 ((((app_bglt) CREF(obj_754))->key) = ((obj_t) val1750_755), BUNSPEC);
   }
}



/* _pre-make-procedure-app-key-set! */
obj_t 
_pre_make_procedure_app_key_set__107_cfa_info2(obj_t env_6397, obj_t obj_6398, obj_t val1750_6399)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 673 */
      return
	 pre_make_procedure_app_key_set__101_cfa_info2(
	 (app_bglt) (obj_6398), val1750_6399);
   }
}



/* pre-make-procedure-app-key */
obj_t 
pre_make_procedure_app_key_242_cfa_info2(app_bglt obj_756)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 673 */
      return
	 (((app_bglt) CREF(obj_756))->key);
   }
}



/* _pre-make-procedure-app-key */
obj_t 
_pre_make_procedure_app_key_128_cfa_info2(obj_t env_6400, obj_t obj_6401)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 673 */
      return
	 pre_make_procedure_app_key_242_cfa_info2(
	 (app_bglt) (obj_6401));
   }
}



/* pre-make-procedure-app-fun-set! */
obj_t 
pre_make_procedure_app_fun_set__110_cfa_info2(app_bglt obj_757, var_bglt val1751_758)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 24 */
      return
	 ((((app_bglt) CREF(obj_757))->fun) = ((var_bglt) val1751_758), BUNSPEC);
   }
}



/* _pre-make-procedure-app-fun-set! */
obj_t 
_pre_make_procedure_app_fun_set__36_cfa_info2(obj_t env_6402, obj_t obj_6403, obj_t val1751_6404)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 24 */
      return
	 pre_make_procedure_app_fun_set__110_cfa_info2(
	 (app_bglt) (obj_6403),
	 (var_bglt) (val1751_6404));
   }
}



/* pre-make-procedure-app-fun */
var_bglt 
pre_make_procedure_app_fun_199_cfa_info2(app_bglt obj_759)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 24 */
      return
	 (((app_bglt) CREF(obj_759))->fun);
   }
}



/* _pre-make-procedure-app-fun */
obj_t 
_pre_make_procedure_app_fun_63_cfa_info2(obj_t env_6405, obj_t obj_6406)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 24 */
      {		/* Cfa/cinfo2.scm 24 */
	 var_bglt aux_9170;
	 aux_9170 =
	    pre_make_procedure_app_fun_199_cfa_info2(
	    (app_bglt) (obj_6406));
	 return
	    (obj_t) (aux_9170);
      }
   }
}



/* pre-make-procedure-app-args-set! */
obj_t 
pre_make_procedure_app_args_set__119_cfa_info2(app_bglt obj_760, obj_t val1752_761)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 24 */
      return
	 ((((app_bglt) CREF(obj_760))->args) = ((obj_t) val1752_761), BUNSPEC);
   }
}



/* _pre-make-procedure-app-args-set! */
obj_t 
_pre_make_procedure_app_args_set__56_cfa_info2(obj_t env_6407, obj_t obj_6408, obj_t val1752_6409)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 24 */
      return
	 pre_make_procedure_app_args_set__119_cfa_info2(
	 (app_bglt) (obj_6408), val1752_6409);
   }
}



/* pre-make-procedure-app-args */
obj_t 
pre_make_procedure_app_args_217_cfa_info2(app_bglt obj_762)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 24 */
      return
	 (((app_bglt) CREF(obj_762))->args);
   }
}



/* _pre-make-procedure-app-args */
obj_t 
_pre_make_procedure_app_args_121_cfa_info2(obj_t env_6410, obj_t obj_6411)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 24 */
      return
	 pre_make_procedure_app_args_217_cfa_info2(
	 (app_bglt) (obj_6411));
   }
}



/* pre-make-procedure-app-stack-info-set! */
obj_t 
pre_make_procedure_app_stack_info_set__177_cfa_info2(app_bglt obj_763, obj_t val1753_764)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 704 */
      return
	 ((((app_bglt) CREF(obj_763))->stack_info_255) = ((obj_t) val1753_764), BUNSPEC);
   }
}



/* _pre-make-procedure-app-stack-info-set! */
obj_t 
_pre_make_procedure_app_stack_info_set__44_cfa_info2(obj_t env_6412, obj_t obj_6413, obj_t val1753_6414)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 704 */
      return
	 pre_make_procedure_app_stack_info_set__177_cfa_info2(
	 (app_bglt) (obj_6413), val1753_6414);
   }
}



/* pre-make-procedure-app-stack-info */
obj_t 
pre_make_procedure_app_stack_info_161_cfa_info2(app_bglt obj_765)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 704 */
      return
	 (((app_bglt) CREF(obj_765))->stack_info_255);
   }
}



/* _pre-make-procedure-app-stack-info */
obj_t 
_pre_make_procedure_app_stack_info_105_cfa_info2(obj_t env_6415, obj_t obj_6416)
{
   AN_OBJECT;
   {	/* ./Ast/node.scm 704 */
      return
	 pre_make_procedure_app_stack_info_161_cfa_info2(
	 (app_bglt) (obj_6416));
   }
}



/* pre-make-procedure-app-owner */
variable_bglt 
pre_make_procedure_app_owner_169_cfa_info2(pre_make_procedure_app_60_bglt obj_766)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 26 */
      {
	 obj_t aux_9186;
	 {	/* Cfa/cinfo2.scm 26 */
	    object_bglt aux_9187;
	    aux_9187 =
	       (object_bglt) (obj_766);
	    aux_9186 =
	       OBJECT_WIDENING(aux_9187);
	 }
	 return
	    (((pre_make_procedure_app_60_bglt) CREF(aux_9186))->owner);
      }
   }
}



/* _pre-make-procedure-app-owner */
obj_t 
_pre_make_procedure_app_owner_124_cfa_info2(obj_t env_6417, obj_t obj_6418)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 26 */
      {		/* Cfa/cinfo2.scm 26 */
	 variable_bglt aux_9191;
	 aux_9191 =
	    pre_make_procedure_app_owner_169_cfa_info2(
	    (pre_make_procedure_app_60_bglt) (obj_6418));
	 return
	    (obj_t) (aux_9191);
      }
   }
}



/* method-init */
obj_t 
method_init_76_cfa_info2()
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 15 */
      {		/* Cfa/cinfo2.scm 15 */
	 obj_t object__struct_struct_set__app2176_75_6463;
	 object__struct_struct_set__app2176_75_6463 = proc2913_cfa_info2;
	 add_method__1___object(object__struct_env_210___object, struct_set__app_162_cfa_info2, object__struct_struct_set__app2176_75_6463);
      }
      {		/* Cfa/cinfo2.scm 15 */
	 obj_t struct_object__object_struct_set__app2178_127_6462;
	 struct_object__object_struct_set__app2178_127_6462 = proc2914_cfa_info2;
	 add_method__1___object(struct_object__object_env_209___object, struct_set__app_162_cfa_info2, struct_object__object_struct_set__app2178_127_6462);
      }
      {		/* Cfa/cinfo2.scm 15 */
	 obj_t object__struct_struct_ref_app2180_75_6461;
	 object__struct_struct_ref_app2180_75_6461 = proc2915_cfa_info2;
	 add_method__1___object(object__struct_env_210___object, struct_ref_app_73_cfa_info2, object__struct_struct_ref_app2180_75_6461);
      }
      {		/* Cfa/cinfo2.scm 15 */
	 obj_t struct_object__object_struct_ref_app2182_41_6460;
	 struct_object__object_struct_ref_app2182_41_6460 = proc2916_cfa_info2;
	 add_method__1___object(struct_object__object_env_209___object, struct_ref_app_73_cfa_info2, struct_object__object_struct_ref_app2182_41_6460);
      }
      {		/* Cfa/cinfo2.scm 15 */
	 obj_t object__struct_make_struct_app2184_126_6459;
	 object__struct_make_struct_app2184_126_6459 = proc2917_cfa_info2;
	 add_method__1___object(object__struct_env_210___object, make_struct_app_214_cfa_info2, object__struct_make_struct_app2184_126_6459);
      }
      {		/* Cfa/cinfo2.scm 15 */
	 obj_t struct_object__object_make_struct_app2186_246_6458;
	 struct_object__object_make_struct_app2186_246_6458 = proc2918_cfa_info2;
	 add_method__1___object(struct_object__object_env_209___object, make_struct_app_214_cfa_info2, struct_object__object_make_struct_app2186_246_6458);
      }
      {		/* Cfa/cinfo2.scm 15 */
	 obj_t object__struct_pre_struct_set__app2188_114_6457;
	 object__struct_pre_struct_set__app2188_114_6457 = proc2919_cfa_info2;
	 add_method__1___object(object__struct_env_210___object, pre_struct_set__app_116_cfa_info2, object__struct_pre_struct_set__app2188_114_6457);
      }
      {		/* Cfa/cinfo2.scm 15 */
	 obj_t struct_object__object_pre_struct_set__app2190_189_6456;
	 struct_object__object_pre_struct_set__app2190_189_6456 = proc2920_cfa_info2;
	 add_method__1___object(struct_object__object_env_209___object, pre_struct_set__app_116_cfa_info2, struct_object__object_pre_struct_set__app2190_189_6456);
      }
      {		/* Cfa/cinfo2.scm 15 */
	 obj_t object__struct_pre_struct_ref_app2192_6_6455;
	 object__struct_pre_struct_ref_app2192_6_6455 = proc2921_cfa_info2;
	 add_method__1___object(object__struct_env_210___object, pre_struct_ref_app_207_cfa_info2, object__struct_pre_struct_ref_app2192_6_6455);
      }
      {		/* Cfa/cinfo2.scm 15 */
	 obj_t struct_object__object_pre_struct_ref_app2194_102_6454;
	 struct_object__object_pre_struct_ref_app2194_102_6454 = proc2922_cfa_info2;
	 add_method__1___object(struct_object__object_env_209___object, pre_struct_ref_app_207_cfa_info2, struct_object__object_pre_struct_ref_app2194_102_6454);
      }
      {		/* Cfa/cinfo2.scm 15 */
	 obj_t object__struct_pre_make_struct_app2196_73_6453;
	 object__struct_pre_make_struct_app2196_73_6453 = proc2923_cfa_info2;
	 add_method__1___object(object__struct_env_210___object, pre_make_struct_app_218_cfa_info2, object__struct_pre_make_struct_app2196_73_6453);
      }
      {		/* Cfa/cinfo2.scm 15 */
	 obj_t struct_object__object_pre_make_struct_app2198_56_6452;
	 struct_object__object_pre_make_struct_app2198_56_6452 = proc2924_cfa_info2;
	 add_method__1___object(struct_object__object_env_209___object, pre_make_struct_app_218_cfa_info2, struct_object__object_pre_make_struct_app2198_56_6452);
      }
      {		/* Cfa/cinfo2.scm 15 */
	 obj_t object__struct_vector_set__app2200_231_6451;
	 object__struct_vector_set__app2200_231_6451 = proc2925_cfa_info2;
	 add_method__1___object(object__struct_env_210___object, vector_set__app_21_cfa_info2, object__struct_vector_set__app2200_231_6451);
      }
      {		/* Cfa/cinfo2.scm 15 */
	 obj_t struct_object__object_vector_set__app2202_239_6450;
	 struct_object__object_vector_set__app2202_239_6450 = proc2926_cfa_info2;
	 add_method__1___object(struct_object__object_env_209___object, vector_set__app_21_cfa_info2, struct_object__object_vector_set__app2202_239_6450);
      }
      {		/* Cfa/cinfo2.scm 15 */
	 obj_t object__struct_vector_ref_app2204_84_6449;
	 object__struct_vector_ref_app2204_84_6449 = proc2927_cfa_info2;
	 add_method__1___object(object__struct_env_210___object, vector_ref_app_195_cfa_info2, object__struct_vector_ref_app2204_84_6449);
      }
      {		/* Cfa/cinfo2.scm 15 */
	 obj_t struct_object__object_vector_ref_app2206_54_6448;
	 struct_object__object_vector_ref_app2206_54_6448 = proc2928_cfa_info2;
	 add_method__1___object(struct_object__object_env_209___object, vector_ref_app_195_cfa_info2, struct_object__object_vector_ref_app2206_54_6448);
      }
      {		/* Cfa/cinfo2.scm 15 */
	 obj_t object__struct_create_vector_app2208_188_6447;
	 object__struct_create_vector_app2208_188_6447 = proc2929_cfa_info2;
	 add_method__1___object(object__struct_env_210___object, create_vector_app_150_cfa_info2, object__struct_create_vector_app2208_188_6447);
      }
      {		/* Cfa/cinfo2.scm 15 */
	 obj_t struct_object__object_create_vector_app2210_100_6446;
	 struct_object__object_create_vector_app2210_100_6446 = proc2930_cfa_info2;
	 add_method__1___object(struct_object__object_env_209___object, create_vector_app_150_cfa_info2, struct_object__object_create_vector_app2210_100_6446);
      }
      {		/* Cfa/cinfo2.scm 15 */
	 obj_t object__struct_make_vector_app2212_75_6445;
	 object__struct_make_vector_app2212_75_6445 = proc2931_cfa_info2;
	 add_method__1___object(object__struct_env_210___object, make_vector_app_205_cfa_info2, object__struct_make_vector_app2212_75_6445);
      }
      {		/* Cfa/cinfo2.scm 15 */
	 obj_t struct_object__object_make_vector_app2214_23_6444;
	 struct_object__object_make_vector_app2214_23_6444 = proc2932_cfa_info2;
	 add_method__1___object(struct_object__object_env_209___object, make_vector_app_205_cfa_info2, struct_object__object_make_vector_app2214_23_6444);
      }
      {		/* Cfa/cinfo2.scm 15 */
	 obj_t object__struct_pre_vector_set__app2216_102_6443;
	 object__struct_pre_vector_set__app2216_102_6443 = proc2933_cfa_info2;
	 add_method__1___object(object__struct_env_210___object, pre_vector_set__app_211_cfa_info2, object__struct_pre_vector_set__app2216_102_6443);
      }
      {		/* Cfa/cinfo2.scm 15 */
	 obj_t struct_object__object_pre_vector_set__app2218_143_6442;
	 struct_object__object_pre_vector_set__app2218_143_6442 = proc2934_cfa_info2;
	 add_method__1___object(struct_object__object_env_209___object, pre_vector_set__app_211_cfa_info2, struct_object__object_pre_vector_set__app2218_143_6442);
      }
      {		/* Cfa/cinfo2.scm 15 */
	 obj_t object__struct_pre_vector_ref_app2220_118_6441;
	 object__struct_pre_vector_ref_app2220_118_6441 = proc2935_cfa_info2;
	 add_method__1___object(object__struct_env_210___object, pre_vector_ref_app_208_cfa_info2, object__struct_pre_vector_ref_app2220_118_6441);
      }
      {		/* Cfa/cinfo2.scm 15 */
	 obj_t struct_object__object_pre_vector_ref_app2222_114_6440;
	 struct_object__object_pre_vector_ref_app2222_114_6440 = proc2936_cfa_info2;
	 add_method__1___object(struct_object__object_env_209___object, pre_vector_ref_app_208_cfa_info2, struct_object__object_pre_vector_ref_app2222_114_6440);
      }
      {		/* Cfa/cinfo2.scm 15 */
	 obj_t object__struct_pre_create_vector_app2224_199_6439;
	 object__struct_pre_create_vector_app2224_199_6439 = proc2937_cfa_info2;
	 add_method__1___object(object__struct_env_210___object, pre_create_vector_app_162_cfa_info2, object__struct_pre_create_vector_app2224_199_6439);
      }
      {		/* Cfa/cinfo2.scm 15 */
	 obj_t struct_object__object_pre_create_vector_app2226_157_6438;
	 struct_object__object_pre_create_vector_app2226_157_6438 = proc2938_cfa_info2;
	 add_method__1___object(struct_object__object_env_209___object, pre_create_vector_app_162_cfa_info2, struct_object__object_pre_create_vector_app2226_157_6438);
      }
      {		/* Cfa/cinfo2.scm 15 */
	 obj_t object__struct_pre_make_vector_app2228_114_6437;
	 object__struct_pre_make_vector_app2228_114_6437 = proc2939_cfa_info2;
	 add_method__1___object(object__struct_env_210___object, pre_make_vector_app_251_cfa_info2, object__struct_pre_make_vector_app2228_114_6437);
      }
      {		/* Cfa/cinfo2.scm 15 */
	 obj_t struct_object__object_pre_make_vector_app2230_243_6436;
	 struct_object__object_pre_make_vector_app2230_243_6436 = proc2940_cfa_info2;
	 add_method__1___object(struct_object__object_env_209___object, pre_make_vector_app_251_cfa_info2, struct_object__object_pre_make_vector_app2230_243_6436);
      }
      {		/* Cfa/cinfo2.scm 15 */
	 obj_t object__struct_procedure_set__app2232_251_6435;
	 object__struct_procedure_set__app2232_251_6435 = proc2941_cfa_info2;
	 add_method__1___object(object__struct_env_210___object, procedure_set__app_32_cfa_info2, object__struct_procedure_set__app2232_251_6435);
      }
      {		/* Cfa/cinfo2.scm 15 */
	 obj_t struct_object__object_procedure_set__app2234_125_6434;
	 struct_object__object_procedure_set__app2234_125_6434 = proc2942_cfa_info2;
	 add_method__1___object(struct_object__object_env_209___object, procedure_set__app_32_cfa_info2, struct_object__object_procedure_set__app2234_125_6434);
      }
      {		/* Cfa/cinfo2.scm 15 */
	 obj_t object__struct_procedure_ref_app2236_175_6433;
	 object__struct_procedure_ref_app2236_175_6433 = proc2943_cfa_info2;
	 add_method__1___object(object__struct_env_210___object, procedure_ref_app_49_cfa_info2, object__struct_procedure_ref_app2236_175_6433);
      }
      {		/* Cfa/cinfo2.scm 15 */
	 obj_t struct_object__object_procedure_ref_app2238_38_6432;
	 struct_object__object_procedure_ref_app2238_38_6432 = proc2944_cfa_info2;
	 add_method__1___object(struct_object__object_env_209___object, procedure_ref_app_49_cfa_info2, struct_object__object_procedure_ref_app2238_38_6432);
      }
      {		/* Cfa/cinfo2.scm 15 */
	 obj_t object__struct_make_procedure_app2240_197_6431;
	 object__struct_make_procedure_app2240_197_6431 = proc2945_cfa_info2;
	 add_method__1___object(object__struct_env_210___object, make_procedure_app_48_cfa_info2, object__struct_make_procedure_app2240_197_6431);
      }
      {		/* Cfa/cinfo2.scm 15 */
	 obj_t struct_object__object_make_procedure_app2242_168_6430;
	 struct_object__object_make_procedure_app2242_168_6430 = proc2946_cfa_info2;
	 add_method__1___object(struct_object__object_env_209___object, make_procedure_app_48_cfa_info2, struct_object__object_make_procedure_app2242_168_6430);
      }
      {		/* Cfa/cinfo2.scm 15 */
	 obj_t object__struct_pre_procedure_set__app2244_179_6429;
	 object__struct_pre_procedure_set__app2244_179_6429 = proc2947_cfa_info2;
	 add_method__1___object(object__struct_env_210___object, pre_procedure_set__app_208_cfa_info2, object__struct_pre_procedure_set__app2244_179_6429);
      }
      {		/* Cfa/cinfo2.scm 15 */
	 obj_t struct_object__object_pre_procedure_set__app2246_44_6428;
	 struct_object__object_pre_procedure_set__app2246_44_6428 = proc2948_cfa_info2;
	 add_method__1___object(struct_object__object_env_209___object, pre_procedure_set__app_208_cfa_info2, struct_object__object_pre_procedure_set__app2246_44_6428);
      }
      {		/* Cfa/cinfo2.scm 15 */
	 obj_t object__struct_pre_procedure_ref_app2248_200_6427;
	 object__struct_pre_procedure_ref_app2248_200_6427 = proc2949_cfa_info2;
	 add_method__1___object(object__struct_env_210___object, pre_procedure_ref_app_85_cfa_info2, object__struct_pre_procedure_ref_app2248_200_6427);
      }
      {		/* Cfa/cinfo2.scm 15 */
	 obj_t struct_object__object_pre_procedure_ref_app2250_42_6426;
	 struct_object__object_pre_procedure_ref_app2250_42_6426 = proc2950_cfa_info2;
	 add_method__1___object(struct_object__object_env_209___object, pre_procedure_ref_app_85_cfa_info2, struct_object__object_pre_procedure_ref_app2250_42_6426);
      }
      {		/* Cfa/cinfo2.scm 15 */
	 obj_t object__struct_pre_make_procedure_app2252_27_6423;
	 object__struct_pre_make_procedure_app2252_27_6423 = proc2951_cfa_info2;
	 add_method__1___object(object__struct_env_210___object, pre_make_procedure_app_60_cfa_info2, object__struct_pre_make_procedure_app2252_27_6423);
      }
      {		/* Cfa/cinfo2.scm 15 */
	 obj_t struct_object__object_pre_make_procedure_app2254_182_6419;
	 struct_object__object_pre_make_procedure_app2254_182_6419 = proc2952_cfa_info2;
	 return
	    add_method__1___object(struct_object__object_env_209___object, pre_make_procedure_app_60_cfa_info2, struct_object__object_pre_make_procedure_app2254_182_6419);
      }
   }
}



/* struct+object->object-pre-make-procedure-app2254 */
obj_t 
struct_object__object_pre_make_procedure_app2254_182_cfa_info2(obj_t env_6464, obj_t o_6465, obj_t s_6466)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 24 */
      {
	 pre_make_procedure_app_60_bglt o_3526;
	 obj_t s_3527;
	 {	/* Cfa/cinfo2.scm 24 */
	    pre_make_procedure_app_60_bglt aux_9235;
	    o_3526 =
	       (pre_make_procedure_app_60_bglt) (o_6465);
	    s_3527 = s_6466;
	    {

	       {	/* Cfa/cinfo2.scm 24 */
		  obj_t old1764_3530;
		  obj_t aux1765_3531;
		  {	/* Cfa/cinfo2.scm 24 */
		     obj_t next_method2253_132_3536;
		     next_method2253_132_3536 =
			find_super_class_method_167___object(
			(object_bglt) (o_3526), struct_object__object_env_209___object, pre_make_procedure_app_60_cfa_info2);
		     if (
			PROCEDUREP(next_method2253_132_3536))
		       {	/* Cfa/cinfo2.scm 24 */
			  old1764_3530 =
			     PROCEDURE_ENTRY(next_method2253_132_3536) (next_method2253_132_3536,
			     (obj_t) (o_3526), s_3527, BEOA);
		       }
		     else
		       {	/* Cfa/cinfo2.scm 24 */
			  PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2253_132_3536);
			  {	/* Cfa/cinfo2.scm 24 */
			     object_bglt aux_9244;
			     aux_9244 =
				struct_object__object_93___object(
				(object_bglt) (o_3526), s_3527);
			     old1764_3530 =
				(obj_t) (aux_9244);
			  }
		       }
		  }
		  aux1765_3531 =
		     STRUCT_REF(s_3527, ((long) 0));
		  {	/* Cfa/cinfo2.scm 24 */
		     pre_make_procedure_app_60_bglt new1766_3532;
		     new1766_3532 =
			((pre_make_procedure_app_60_bglt) (old1764_3530));
		     {	/* Cfa/cinfo2.scm 24 */
			long arg2803_3533;
			arg2803_3533 =
			   class_num_218___object(pre_make_procedure_app_60_cfa_info2);
			{	/* Cfa/cinfo2.scm 24 */
			   obj_t obj_5301;
			   obj_5301 =
			      (obj_t) (new1766_3532);
			   (((obj_t) CREF(obj_5301))->header = MAKE_HEADER(arg2803_3533, 0), BUNSPEC);
			}
		     }
		     {	/* Cfa/cinfo2.scm 24 */
			pre_make_procedure_app_60_bglt arg2804_3534;
			{	/* Cfa/cinfo2.scm 24 */
			   pre_make_procedure_app_60_bglt res2867_5308;
			   {	/* Cfa/cinfo2.scm 24 */
			      variable_bglt owner_5305;
			      {		/* Cfa/cinfo2.scm 24 */
				 obj_t aux_9253;
				 aux_9253 =
				    STRUCT_REF(aux1765_3531, ((long) 0));
				 owner_5305 =
				    (variable_bglt) (aux_9253);
			      }
			      {		/* Cfa/cinfo2.scm 24 */
				 pre_make_procedure_app_60_bglt new1754_5306;
				 new1754_5306 =
				    ((pre_make_procedure_app_60_bglt) BREF(GC_MALLOC(sizeof(struct pre_make_procedure_app_60))));
				 ((((pre_make_procedure_app_60_bglt) CREF(new1754_5306))->owner) = ((variable_bglt) owner_5305), BUNSPEC);
				 res2867_5308 = new1754_5306;
			      }
			   }
			   arg2804_3534 = res2867_5308;
			}
			{	/* Cfa/cinfo2.scm 24 */
			   obj_t aux_9260;
			   object_bglt aux_9258;
			   aux_9260 =
			      (obj_t) (arg2804_3534);
			   aux_9258 =
			      (object_bglt) (new1766_3532);
			   OBJECT_WIDENING_SET(aux_9258, aux_9260);
			}
		     }
		     aux_9235 = new1766_3532;
		  }
	       }
	    }
	    return
	       (obj_t) (aux_9235);
	 }
      }
   }
}



/* object->struct-pre-make-procedure-app2252 */
obj_t 
object__struct_pre_make_procedure_app2252_27_cfa_info2(obj_t env_6467, obj_t obj1761_6468)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 24 */
      {
	 pre_make_procedure_app_60_bglt obj1761_3516;
	 obj1761_3516 =
	    (pre_make_procedure_app_60_bglt) (obj1761_6468);
	 {

	    {	/* Cfa/cinfo2.scm 24 */
	       obj_t res1762_3519;
	       {	/* Cfa/cinfo2.scm 24 */
		  obj_t next_method2251_97_3524;
		  next_method2251_97_3524 =
		     find_super_class_method_167___object(
		     (object_bglt) (obj1761_3516), object__struct_env_210___object, pre_make_procedure_app_60_cfa_info2);
		  if (
		     PROCEDUREP(next_method2251_97_3524))
		    {	/* Cfa/cinfo2.scm 24 */
		       res1762_3519 =
			  PROCEDURE_ENTRY(next_method2251_97_3524) (next_method2251_97_3524,
			  (obj_t) (obj1761_3516), BEOA);
		    }
		  else
		    {	/* Cfa/cinfo2.scm 24 */
		       PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2251_97_3524);
		       res1762_3519 =
			  object__struct_50___object(
			  (object_bglt) (obj1761_3516));
		    }
	       }
	       {	/* Cfa/cinfo2.scm 24 */
		  obj_t aux1763_3520;
		  {	/* ./Llib/struct.scm 1415 */
		     obj_t aux_9275;
		     aux_9275 =
			CNST_TABLE_REF(((long) 0));
		     aux1763_3520 =
			make_struct(aux_9275, ((long) 1), BUNSPEC);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_9278;
		     {	/* Cfa/cinfo2.scm 24 */
			variable_bglt aux_9279;
			{
			   obj_t aux_9280;
			   {	/* Cfa/cinfo2.scm 26 */
			      object_bglt aux_9281;
			      aux_9281 =
				 (object_bglt) (obj1761_3516);
			      aux_9280 =
				 OBJECT_WIDENING(aux_9281);
			   }
			   aux_9279 =
			      (((pre_make_procedure_app_60_bglt) CREF(aux_9280))->owner);
			}
			aux_9278 =
			   (obj_t) (aux_9279);
		     }
		     STRUCT_SET(aux1763_3520, ((long) 0), aux_9278);
		  }
		  STRUCT_SET(res1762_3519, ((long) 0), aux1763_3520);
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_9288;
		     aux_9288 =
			STRUCT_KEY(res1762_3519);
		     STRUCT_KEY_SET(aux1763_3520, aux_9288);
		  }
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_9291;
		     aux_9291 =
			CNST_TABLE_REF(((long) 0));
		     STRUCT_KEY_SET(res1762_3519, aux_9291);
		  }
		  return res1762_3519;
	       }
	    }
	 }
      }
   }
}



/* struct+object->object-pre-procedure-ref-app2250 */
obj_t 
struct_object__object_pre_procedure_ref_app2250_42_cfa_info2(obj_t env_6469, obj_t o_6470, obj_t s_6471)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 27 */
      {
	 pre_procedure_ref_app_85_bglt o_3505;
	 obj_t s_3506;
	 {	/* Cfa/cinfo2.scm 27 */
	    pre_procedure_ref_app_85_bglt aux_9295;
	    o_3505 =
	       (pre_procedure_ref_app_85_bglt) (o_6470);
	    s_3506 = s_6471;
	    {

	       {	/* Cfa/cinfo2.scm 27 */
		  obj_t old1781_3509;
		  {	/* Cfa/cinfo2.scm 27 */
		     obj_t next_method2249_228_3514;
		     next_method2249_228_3514 =
			find_super_class_method_167___object(
			(object_bglt) (o_3505), struct_object__object_env_209___object, pre_procedure_ref_app_85_cfa_info2);
		     if (
			PROCEDUREP(next_method2249_228_3514))
		       {	/* Cfa/cinfo2.scm 27 */
			  old1781_3509 =
			     PROCEDURE_ENTRY(next_method2249_228_3514) (next_method2249_228_3514,
			     (obj_t) (o_3505), s_3506, BEOA);
		       }
		     else
		       {	/* Cfa/cinfo2.scm 27 */
			  PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2249_228_3514);
			  {	/* Cfa/cinfo2.scm 27 */
			     object_bglt aux_9304;
			     aux_9304 =
				struct_object__object_93___object(
				(object_bglt) (o_3505), s_3506);
			     old1781_3509 =
				(obj_t) (aux_9304);
			  }
		       }
		  }
		  {	/* Cfa/cinfo2.scm 27 */
		     pre_procedure_ref_app_85_bglt new1783_3511;
		     new1783_3511 =
			((pre_procedure_ref_app_85_bglt) (old1781_3509));
		     {	/* Cfa/cinfo2.scm 27 */
			long arg2796_3512;
			arg2796_3512 =
			   class_num_218___object(pre_procedure_ref_app_85_cfa_info2);
			{	/* Cfa/cinfo2.scm 27 */
			   obj_t obj_5276;
			   obj_5276 =
			      (obj_t) (new1783_3511);
			   (((obj_t) CREF(obj_5276))->header = MAKE_HEADER(arg2796_3512, 0), BUNSPEC);
			}
		     }
		     {	/* Cfa/cinfo2.scm 27 */
			obj_t aux_9314;
			object_bglt aux_9312;
			{	/* Cfa/cinfo2.scm 27 */
			   pre_procedure_ref_app_85_bglt aux_9315;
			   {	/* Cfa/cinfo2.scm 27 */

			      aux_9315 =
				 ((pre_procedure_ref_app_85_bglt) BREF(GC_MALLOC(sizeof(struct pre_procedure_ref_app_85))));
			   }
			   aux_9314 =
			      (obj_t) (aux_9315);
			}
			aux_9312 =
			   (object_bglt) (new1783_3511);
			OBJECT_WIDENING_SET(aux_9312, aux_9314);
		     }
		     aux_9295 = new1783_3511;
		  }
	       }
	    }
	    return
	       (obj_t) (aux_9295);
	 }
      }
   }
}



/* object->struct-pre-procedure-ref-app2248 */
obj_t 
object__struct_pre_procedure_ref_app2248_200_cfa_info2(obj_t env_6472, obj_t obj1778_6473)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 27 */
      {
	 pre_procedure_ref_app_85_bglt obj1778_3497;
	 obj1778_3497 =
	    (pre_procedure_ref_app_85_bglt) (obj1778_6473);
	 {

	    {	/* Cfa/cinfo2.scm 27 */
	       obj_t res1779_3500;
	       {	/* Cfa/cinfo2.scm 27 */
		  obj_t next_method2247_171_3503;
		  next_method2247_171_3503 =
		     find_super_class_method_167___object(
		     (object_bglt) (obj1778_3497), object__struct_env_210___object, pre_procedure_ref_app_85_cfa_info2);
		  if (
		     PROCEDUREP(next_method2247_171_3503))
		    {	/* Cfa/cinfo2.scm 27 */
		       res1779_3500 =
			  PROCEDURE_ENTRY(next_method2247_171_3503) (next_method2247_171_3503,
			  (obj_t) (obj1778_3497), BEOA);
		    }
		  else
		    {	/* Cfa/cinfo2.scm 27 */
		       PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2247_171_3503);
		       res1779_3500 =
			  object__struct_50___object(
			  (object_bglt) (obj1778_3497));
		    }
	       }
	       {	/* Cfa/cinfo2.scm 27 */
		  obj_t aux1780_3501;
		  {	/* ./Llib/struct.scm 1415 */
		     obj_t aux_9331;
		     aux_9331 =
			CNST_TABLE_REF(((long) 1));
		     aux1780_3501 =
			make_struct(aux_9331, ((long) 0), BUNSPEC);
		  }
		  STRUCT_SET(res1779_3500, ((long) 0), aux1780_3501);
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_9335;
		     aux_9335 =
			STRUCT_KEY(res1779_3500);
		     STRUCT_KEY_SET(aux1780_3501, aux_9335);
		  }
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_9338;
		     aux_9338 =
			CNST_TABLE_REF(((long) 1));
		     STRUCT_KEY_SET(res1779_3500, aux_9338);
		  }
		  return res1779_3500;
	       }
	    }
	 }
      }
   }
}



/* struct+object->object-pre-procedure-set!-app2246 */
obj_t 
struct_object__object_pre_procedure_set__app2246_44_cfa_info2(obj_t env_6474, obj_t o_6475, obj_t s_6476)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 28 */
      {
	 pre_procedure_set__app_208_bglt o_3486;
	 obj_t s_3487;
	 {	/* Cfa/cinfo2.scm 28 */
	    pre_procedure_set__app_208_bglt aux_9342;
	    o_3486 =
	       (pre_procedure_set__app_208_bglt) (o_6475);
	    s_3487 = s_6476;
	    {

	       {	/* Cfa/cinfo2.scm 28 */
		  obj_t old1798_3490;
		  {	/* Cfa/cinfo2.scm 28 */
		     obj_t next_method2245_11_3495;
		     next_method2245_11_3495 =
			find_super_class_method_167___object(
			(object_bglt) (o_3486), struct_object__object_env_209___object, pre_procedure_set__app_208_cfa_info2);
		     if (
			PROCEDUREP(next_method2245_11_3495))
		       {	/* Cfa/cinfo2.scm 28 */
			  old1798_3490 =
			     PROCEDURE_ENTRY(next_method2245_11_3495) (next_method2245_11_3495,
			     (obj_t) (o_3486), s_3487, BEOA);
		       }
		     else
		       {	/* Cfa/cinfo2.scm 28 */
			  PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2245_11_3495);
			  {	/* Cfa/cinfo2.scm 28 */
			     object_bglt aux_9351;
			     aux_9351 =
				struct_object__object_93___object(
				(object_bglt) (o_3486), s_3487);
			     old1798_3490 =
				(obj_t) (aux_9351);
			  }
		       }
		  }
		  {	/* Cfa/cinfo2.scm 28 */
		     pre_procedure_set__app_208_bglt new1800_3492;
		     new1800_3492 =
			((pre_procedure_set__app_208_bglt) (old1798_3490));
		     {	/* Cfa/cinfo2.scm 28 */
			long arg2791_3493;
			arg2791_3493 =
			   class_num_218___object(pre_procedure_set__app_208_cfa_info2);
			{	/* Cfa/cinfo2.scm 28 */
			   obj_t obj_5255;
			   obj_5255 =
			      (obj_t) (new1800_3492);
			   (((obj_t) CREF(obj_5255))->header = MAKE_HEADER(arg2791_3493, 0), BUNSPEC);
			}
		     }
		     {	/* Cfa/cinfo2.scm 28 */
			obj_t aux_9361;
			object_bglt aux_9359;
			{	/* Cfa/cinfo2.scm 28 */
			   pre_procedure_set__app_208_bglt aux_9362;
			   {	/* Cfa/cinfo2.scm 28 */

			      aux_9362 =
				 ((pre_procedure_set__app_208_bglt) BREF(GC_MALLOC(sizeof(struct pre_procedure_set__app_208))));
			   }
			   aux_9361 =
			      (obj_t) (aux_9362);
			}
			aux_9359 =
			   (object_bglt) (new1800_3492);
			OBJECT_WIDENING_SET(aux_9359, aux_9361);
		     }
		     aux_9342 = new1800_3492;
		  }
	       }
	    }
	    return
	       (obj_t) (aux_9342);
	 }
      }
   }
}



/* object->struct-pre-procedure-set!-app2244 */
obj_t 
object__struct_pre_procedure_set__app2244_179_cfa_info2(obj_t env_6477, obj_t obj1795_6478)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 28 */
      {
	 pre_procedure_set__app_208_bglt obj1795_3478;
	 obj1795_3478 =
	    (pre_procedure_set__app_208_bglt) (obj1795_6478);
	 {

	    {	/* Cfa/cinfo2.scm 28 */
	       obj_t res1796_3481;
	       {	/* Cfa/cinfo2.scm 28 */
		  obj_t next_method2243_239_3484;
		  next_method2243_239_3484 =
		     find_super_class_method_167___object(
		     (object_bglt) (obj1795_3478), object__struct_env_210___object, pre_procedure_set__app_208_cfa_info2);
		  if (
		     PROCEDUREP(next_method2243_239_3484))
		    {	/* Cfa/cinfo2.scm 28 */
		       res1796_3481 =
			  PROCEDURE_ENTRY(next_method2243_239_3484) (next_method2243_239_3484,
			  (obj_t) (obj1795_3478), BEOA);
		    }
		  else
		    {	/* Cfa/cinfo2.scm 28 */
		       PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2243_239_3484);
		       res1796_3481 =
			  object__struct_50___object(
			  (object_bglt) (obj1795_3478));
		    }
	       }
	       {	/* Cfa/cinfo2.scm 28 */
		  obj_t aux1797_3482;
		  {	/* ./Llib/struct.scm 1415 */
		     obj_t aux_9378;
		     aux_9378 =
			CNST_TABLE_REF(((long) 2));
		     aux1797_3482 =
			make_struct(aux_9378, ((long) 0), BUNSPEC);
		  }
		  STRUCT_SET(res1796_3481, ((long) 0), aux1797_3482);
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_9382;
		     aux_9382 =
			STRUCT_KEY(res1796_3481);
		     STRUCT_KEY_SET(aux1797_3482, aux_9382);
		  }
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_9385;
		     aux_9385 =
			CNST_TABLE_REF(((long) 2));
		     STRUCT_KEY_SET(res1796_3481, aux_9385);
		  }
		  return res1796_3481;
	       }
	    }
	 }
      }
   }
}



/* struct+object->object-make-procedure-app2242 */
obj_t 
struct_object__object_make_procedure_app2242_168_cfa_info2(obj_t env_6479, obj_t o_6480, obj_t s_6481)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 30 */
      {
	 make_procedure_app_48_bglt o_3457;
	 obj_t s_3458;
	 {	/* Cfa/cinfo2.scm 30 */
	    make_procedure_app_48_bglt aux_9389;
	    o_3457 =
	       (make_procedure_app_48_bglt) (o_6480);
	    s_3458 = s_6481;
	    {

	       {	/* Cfa/cinfo2.scm 30 */
		  obj_t old1837_3461;
		  obj_t aux1838_3462;
		  {	/* Cfa/cinfo2.scm 30 */
		     obj_t next_method2241_242_3476;
		     next_method2241_242_3476 =
			find_super_class_method_167___object(
			(object_bglt) (o_3457), struct_object__object_env_209___object, make_procedure_app_48_cfa_info2);
		     if (
			PROCEDUREP(next_method2241_242_3476))
		       {	/* Cfa/cinfo2.scm 30 */
			  old1837_3461 =
			     PROCEDURE_ENTRY(next_method2241_242_3476) (next_method2241_242_3476,
			     (obj_t) (o_3457), s_3458, BEOA);
		       }
		     else
		       {	/* Cfa/cinfo2.scm 30 */
			  PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2241_242_3476);
			  {	/* Cfa/cinfo2.scm 30 */
			     object_bglt aux_9398;
			     aux_9398 =
				struct_object__object_93___object(
				(object_bglt) (o_3457), s_3458);
			     old1837_3461 =
				(obj_t) (aux_9398);
			  }
		       }
		  }
		  aux1838_3462 =
		     STRUCT_REF(s_3458, ((long) 0));
		  {	/* Cfa/cinfo2.scm 30 */
		     make_procedure_app_48_bglt new1839_3463;
		     new1839_3463 =
			((make_procedure_app_48_bglt) (old1837_3461));
		     {	/* Cfa/cinfo2.scm 30 */
			long arg2775_3464;
			arg2775_3464 =
			   class_num_218___object(make_procedure_app_48_cfa_info2);
			{	/* Cfa/cinfo2.scm 30 */
			   obj_t obj_5186;
			   obj_5186 =
			      (obj_t) (new1839_3463);
			   (((obj_t) CREF(obj_5186))->header = MAKE_HEADER(arg2775_3464, 0), BUNSPEC);
			}
		     }
		     {	/* Cfa/cinfo2.scm 30 */
			make_procedure_app_48_bglt arg2776_3465;
			{	/* Cfa/cinfo2.scm 30 */
			   obj_t arg2787_3475;
			   arg2787_3475 =
			      STRUCT_REF(aux1838_3462, ((long) 9));
			   {	/* Cfa/cinfo2.scm 30 */
			      make_procedure_app_48_bglt res2864_5237;
			      {		/* Cfa/cinfo2.scm 30 */
				 approx_bglt approx_5208;
				 long values_approx_len_106_5209;
				 approx_bglt values_approx_79_5210;
				 long lost_stamp_114_5211;
				 bool_t x_t__142_5212;
				 bool_t x_5213;
				 bool_t t_5214;
				 variable_bglt owner_5215;
				 bool_t stackable__42_5216;
				 {	/* Cfa/cinfo2.scm 30 */
				    obj_t aux_9408;
				    aux_9408 =
				       STRUCT_REF(aux1838_3462, ((long) 0));
				    approx_5208 =
				       (approx_bglt) (aux_9408);
				 }
				 {	/* Cfa/cinfo2.scm 30 */
				    obj_t aux_9411;
				    aux_9411 =
				       STRUCT_REF(aux1838_3462, ((long) 1));
				    values_approx_len_106_5209 =
				       (long) CINT(aux_9411);
				 }
				 {	/* Cfa/cinfo2.scm 30 */
				    obj_t aux_9414;
				    aux_9414 =
				       STRUCT_REF(aux1838_3462, ((long) 2));
				    values_approx_79_5210 =
				       (approx_bglt) (aux_9414);
				 }
				 {	/* Cfa/cinfo2.scm 30 */
				    obj_t aux_9417;
				    aux_9417 =
				       STRUCT_REF(aux1838_3462, ((long) 3));
				    lost_stamp_114_5211 =
				       (long) CINT(aux_9417);
				 }
				 {	/* Cfa/cinfo2.scm 30 */
				    obj_t aux_9420;
				    aux_9420 =
				       STRUCT_REF(aux1838_3462, ((long) 4));
				    x_t__142_5212 =
				       CBOOL(aux_9420);
				 }
				 {	/* Cfa/cinfo2.scm 30 */
				    obj_t aux_9423;
				    aux_9423 =
				       STRUCT_REF(aux1838_3462, ((long) 5));
				    x_5213 =
				       CBOOL(aux_9423);
				 }
				 {	/* Cfa/cinfo2.scm 30 */
				    obj_t aux_9426;
				    aux_9426 =
				       STRUCT_REF(aux1838_3462, ((long) 6));
				    t_5214 =
				       CBOOL(aux_9426);
				 }
				 {	/* Cfa/cinfo2.scm 30 */
				    obj_t aux_9429;
				    aux_9429 =
				       STRUCT_REF(aux1838_3462, ((long) 7));
				    owner_5215 =
				       (variable_bglt) (aux_9429);
				 }
				 {	/* Cfa/cinfo2.scm 30 */
				    obj_t aux_9432;
				    aux_9432 =
				       STRUCT_REF(aux1838_3462, ((long) 8));
				    stackable__42_5216 =
				       CBOOL(aux_9432);
				 }
				 {	/* Cfa/cinfo2.scm 30 */
				    make_procedure_app_48_bglt new1815_5218;
				    new1815_5218 =
				       ((make_procedure_app_48_bglt) BREF(GC_MALLOC(sizeof(struct make_procedure_app_48))));
				    ((((make_procedure_app_48_bglt) CREF(new1815_5218))->approx) = ((approx_bglt) approx_5208), BUNSPEC);
				    ((((make_procedure_app_48_bglt) CREF(new1815_5218))->values_approx_len_106) = ((long) values_approx_len_106_5209), BUNSPEC);
				    ((((make_procedure_app_48_bglt) CREF(new1815_5218))->values_approx_79) = ((approx_bglt *)
					  GC_MALLOC(sizeof(struct approx) * values_approx_len_106_5209)), BUNSPEC);
				    {
				       long i1816_5230;
				       i1816_5230 = ((long) 0);
				     loop1819_5229:
				       if (
					  (i1816_5230 == values_approx_len_106_5209))
					 {	/* Cfa/cinfo2.scm 30 */
					    CNST_TABLE_REF(((long) 20));
					 }
				       else
					 {	/* Cfa/cinfo2.scm 30 */
					    ((((make_procedure_app_48_bglt) CREF(new1815_5218))->values_approx_79)[i1816_5230] = ((approx_bglt) values_approx_79_5210), BUNSPEC);
					    {
					       long i1816_9444;
					       i1816_9444 =
						  (i1816_5230 + ((long) 1));
					       i1816_5230 = i1816_9444;
					       goto loop1819_5229;
					    }
					 }
				    }
				    ((((make_procedure_app_48_bglt) CREF(new1815_5218))->lost_stamp_114) = ((long) lost_stamp_114_5211), BUNSPEC);
				    ((((make_procedure_app_48_bglt) CREF(new1815_5218))->x_t__142) = ((bool_t) x_t__142_5212), BUNSPEC);
				    ((((make_procedure_app_48_bglt) CREF(new1815_5218))->x) = ((bool_t) x_5213), BUNSPEC);
				    ((((make_procedure_app_48_bglt) CREF(new1815_5218))->t) = ((bool_t) t_5214), BUNSPEC);
				    ((((make_procedure_app_48_bglt) CREF(new1815_5218))->owner) = ((variable_bglt) owner_5215), BUNSPEC);
				    ((((make_procedure_app_48_bglt) CREF(new1815_5218))->stackable__42) = ((bool_t) stackable__42_5216), BUNSPEC);
				    ((((make_procedure_app_48_bglt) CREF(new1815_5218))->stack_stamp_31) = ((obj_t) arg2787_3475), BUNSPEC);
				    res2864_5237 = new1815_5218;
				 }
			      }
			      arg2776_3465 = res2864_5237;
			   }
			}
			{	/* Cfa/cinfo2.scm 30 */
			   obj_t aux_9455;
			   object_bglt aux_9453;
			   aux_9455 =
			      (obj_t) (arg2776_3465);
			   aux_9453 =
			      (object_bglt) (new1839_3463);
			   OBJECT_WIDENING_SET(aux_9453, aux_9455);
			}
		     }
		     aux_9389 = new1839_3463;
		  }
	       }
	    }
	    return
	       (obj_t) (aux_9389);
	 }
      }
   }
}



/* object->struct-make-procedure-app2240 */
obj_t 
object__struct_make_procedure_app2240_197_cfa_info2(obj_t env_6482, obj_t obj1830_6483)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 30 */
      {
	 make_procedure_app_48_bglt obj1830_3423;
	 obj1830_3423 =
	    (make_procedure_app_48_bglt) (obj1830_6483);
	 {

	    {	/* Cfa/cinfo2.scm 30 */
	       obj_t res1831_3426;
	       {	/* Cfa/cinfo2.scm 30 */
		  obj_t next_method2239_250_3455;
		  next_method2239_250_3455 =
		     find_super_class_method_167___object(
		     (object_bglt) (obj1830_3423), object__struct_env_210___object, make_procedure_app_48_cfa_info2);
		  if (
		     PROCEDUREP(next_method2239_250_3455))
		    {	/* Cfa/cinfo2.scm 30 */
		       res1831_3426 =
			  PROCEDURE_ENTRY(next_method2239_250_3455) (next_method2239_250_3455,
			  (obj_t) (obj1830_3423), BEOA);
		    }
		  else
		    {	/* Cfa/cinfo2.scm 30 */
		       PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2239_250_3455);
		       res1831_3426 =
			  object__struct_50___object(
			  (object_bglt) (obj1830_3423));
		    }
	       }
	       {	/* Cfa/cinfo2.scm 30 */
		  obj_t aux1832_3427;
		  {	/* ./Llib/struct.scm 1415 */
		     obj_t aux_9470;
		     aux_9470 =
			CNST_TABLE_REF(((long) 3));
		     aux1832_3427 =
			make_struct(aux_9470, ((long) 10), BUNSPEC);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_9473;
		     {	/* Cfa/cinfo2.scm 30 */
			approx_bglt aux_9474;
			{
			   obj_t aux_9475;
			   {	/* Cfa/cinfo2.scm 30 */
			      object_bglt aux_9476;
			      aux_9476 =
				 (object_bglt) (obj1830_3423);
			      aux_9475 =
				 OBJECT_WIDENING(aux_9476);
			   }
			   aux_9474 =
			      (((make_procedure_app_48_bglt) CREF(aux_9475))->approx);
			}
			aux_9473 =
			   (obj_t) (aux_9474);
		     }
		     STRUCT_SET(aux1832_3427, ((long) 0), aux_9473);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_9482;
		     {	/* Cfa/cinfo2.scm 30 */
			long aux_9483;
			{
			   obj_t aux_9484;
			   {	/* Cfa/cinfo2.scm 34 */
			      object_bglt aux_9485;
			      aux_9485 =
				 (object_bglt) (obj1830_3423);
			      aux_9484 =
				 OBJECT_WIDENING(aux_9485);
			   }
			   aux_9483 =
			      (((make_procedure_app_48_bglt) CREF(aux_9484))->values_approx_len_106);
			}
			aux_9482 =
			   BINT(aux_9483);
		     }
		     STRUCT_SET(aux1832_3427, ((long) 1), aux_9482);
		  }
		  {	/* Cfa/cinfo2.scm 30 */
		     long len1836_3432;
		     {
			obj_t aux_9491;
			{	/* Cfa/cinfo2.scm 34 */
			   object_bglt aux_9492;
			   aux_9492 =
			      (object_bglt) (obj1830_3423);
			   aux_9491 =
			      OBJECT_WIDENING(aux_9492);
			}
			len1836_3432 =
			   (((make_procedure_app_48_bglt) CREF(aux_9491))->values_approx_len_106);
		     }
		     {	/* Cfa/cinfo2.scm 30 */
			obj_t vec1833_3433;
			vec1833_3433 =
			   make_vector(len1836_3432, BUNSPEC);
			{
			   long j1834_3434;
			   j1834_3434 = ((long) 0);
			 loop1835_3435:
			   if (
			      (j1834_3434 == len1836_3432))
			     {	/* ./Llib/struct.scm 1463 */
				obj_t x_6565;
				x_6565 =
				   STRUCT_SET(aux1832_3427, ((long) 2), vec1833_3433);
				BUNSPEC;
			     }
			   else
			     {	/* Cfa/cinfo2.scm 30 */
				{	/* ./Ieee/vector.scm 8468 */
				   obj_t aux_9500;
				   {	/* Cfa/cinfo2.scm 30 */
				      approx_bglt aux_9501;
				      {
					 obj_t aux_9502;
					 {	/* Cfa/cinfo2.scm 34 */
					    object_bglt aux_9503;
					    aux_9503 =
					       (object_bglt) (obj1830_3423);
					    aux_9502 =
					       OBJECT_WIDENING(aux_9503);
					 }
					 aux_9501 =
					    (((make_procedure_app_48_bglt) CREF(aux_9502))->values_approx_79)[j1834_3434];
				      }
				      aux_9500 =
					 (obj_t) (aux_9501);
				   }
				   VECTOR_SET(vec1833_3433, j1834_3434, aux_9500);
				}
				{
				   long j1834_9509;
				   j1834_9509 =
				      (j1834_3434 + ((long) 1));
				   j1834_3434 = j1834_9509;
				   goto loop1835_3435;
				}
			     }
			}
		     }
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_9511;
		     {	/* Cfa/cinfo2.scm 30 */
			long aux_9512;
			{
			   obj_t aux_9513;
			   {	/* Cfa/cinfo2.scm 38 */
			      object_bglt aux_9514;
			      aux_9514 =
				 (object_bglt) (obj1830_3423);
			      aux_9513 =
				 OBJECT_WIDENING(aux_9514);
			   }
			   aux_9512 =
			      (((make_procedure_app_48_bglt) CREF(aux_9513))->lost_stamp_114);
			}
			aux_9511 =
			   BINT(aux_9512);
		     }
		     STRUCT_SET(aux1832_3427, ((long) 3), aux_9511);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_9520;
		     {	/* Cfa/cinfo2.scm 30 */
			bool_t aux_9521;
			{
			   obj_t aux_9522;
			   {	/* Cfa/cinfo2.scm 40 */
			      object_bglt aux_9523;
			      aux_9523 =
				 (object_bglt) (obj1830_3423);
			      aux_9522 =
				 OBJECT_WIDENING(aux_9523);
			   }
			   aux_9521 =
			      (((make_procedure_app_48_bglt) CREF(aux_9522))->x_t__142);
			}
			aux_9520 =
			   BBOOL(aux_9521);
		     }
		     STRUCT_SET(aux1832_3427, ((long) 4), aux_9520);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_9529;
		     {	/* Cfa/cinfo2.scm 30 */
			bool_t aux_9530;
			{
			   obj_t aux_9531;
			   {	/* Cfa/cinfo2.scm 41 */
			      object_bglt aux_9532;
			      aux_9532 =
				 (object_bglt) (obj1830_3423);
			      aux_9531 =
				 OBJECT_WIDENING(aux_9532);
			   }
			   aux_9530 =
			      (((make_procedure_app_48_bglt) CREF(aux_9531))->x);
			}
			aux_9529 =
			   BBOOL(aux_9530);
		     }
		     STRUCT_SET(aux1832_3427, ((long) 5), aux_9529);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_9538;
		     {	/* Cfa/cinfo2.scm 30 */
			bool_t aux_9539;
			{
			   obj_t aux_9540;
			   {	/* Cfa/cinfo2.scm 42 */
			      object_bglt aux_9541;
			      aux_9541 =
				 (object_bglt) (obj1830_3423);
			      aux_9540 =
				 OBJECT_WIDENING(aux_9541);
			   }
			   aux_9539 =
			      (((make_procedure_app_48_bglt) CREF(aux_9540))->t);
			}
			aux_9538 =
			   BBOOL(aux_9539);
		     }
		     STRUCT_SET(aux1832_3427, ((long) 6), aux_9538);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_9547;
		     {	/* Cfa/cinfo2.scm 30 */
			variable_bglt aux_9548;
			{
			   obj_t aux_9549;
			   {	/* Cfa/cinfo2.scm 44 */
			      object_bglt aux_9550;
			      aux_9550 =
				 (object_bglt) (obj1830_3423);
			      aux_9549 =
				 OBJECT_WIDENING(aux_9550);
			   }
			   aux_9548 =
			      (((make_procedure_app_48_bglt) CREF(aux_9549))->owner);
			}
			aux_9547 =
			   (obj_t) (aux_9548);
		     }
		     STRUCT_SET(aux1832_3427, ((long) 7), aux_9547);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_9556;
		     {	/* Cfa/cinfo2.scm 30 */
			bool_t aux_9557;
			{
			   obj_t aux_9558;
			   {	/* Cfa/cinfo2.scm 47 */
			      object_bglt aux_9559;
			      aux_9559 =
				 (object_bglt) (obj1830_3423);
			      aux_9558 =
				 OBJECT_WIDENING(aux_9559);
			   }
			   aux_9557 =
			      (((make_procedure_app_48_bglt) CREF(aux_9558))->stackable__42);
			}
			aux_9556 =
			   BBOOL(aux_9557);
		     }
		     STRUCT_SET(aux1832_3427, ((long) 8), aux_9556);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_9565;
		     {
			obj_t aux_9566;
			{	/* Cfa/cinfo2.scm 49 */
			   object_bglt aux_9567;
			   aux_9567 =
			      (object_bglt) (obj1830_3423);
			   aux_9566 =
			      OBJECT_WIDENING(aux_9567);
			}
			aux_9565 =
			   (((make_procedure_app_48_bglt) CREF(aux_9566))->stack_stamp_31);
		     }
		     STRUCT_SET(aux1832_3427, ((long) 9), aux_9565);
		  }
		  STRUCT_SET(res1831_3426, ((long) 0), aux1832_3427);
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_9573;
		     aux_9573 =
			STRUCT_KEY(res1831_3426);
		     STRUCT_KEY_SET(aux1832_3427, aux_9573);
		  }
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_9576;
		     aux_9576 =
			CNST_TABLE_REF(((long) 3));
		     STRUCT_KEY_SET(res1831_3426, aux_9576);
		  }
		  return res1831_3426;
	       }
	    }
	 }
      }
   }
}



/* struct+object->object-procedure-ref-app2238 */
obj_t 
struct_object__object_procedure_ref_app2238_38_cfa_info2(obj_t env_6484, obj_t o_6485, obj_t s_6486)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 50 */
      {
	 procedure_ref_app_49_bglt o_3411;
	 obj_t s_3412;
	 {	/* Cfa/cinfo2.scm 50 */
	    procedure_ref_app_49_bglt aux_9580;
	    o_3411 =
	       (procedure_ref_app_49_bglt) (o_6485);
	    s_3412 = s_6486;
	    {

	       {	/* Cfa/cinfo2.scm 50 */
		  obj_t old1855_3415;
		  obj_t aux1856_3416;
		  {	/* Cfa/cinfo2.scm 50 */
		     obj_t next_method2237_95_3421;
		     next_method2237_95_3421 =
			find_super_class_method_167___object(
			(object_bglt) (o_3411), struct_object__object_env_209___object, procedure_ref_app_49_cfa_info2);
		     if (
			PROCEDUREP(next_method2237_95_3421))
		       {	/* Cfa/cinfo2.scm 50 */
			  old1855_3415 =
			     PROCEDURE_ENTRY(next_method2237_95_3421) (next_method2237_95_3421,
			     (obj_t) (o_3411), s_3412, BEOA);
		       }
		     else
		       {	/* Cfa/cinfo2.scm 50 */
			  PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2237_95_3421);
			  {	/* Cfa/cinfo2.scm 50 */
			     object_bglt aux_9589;
			     aux_9589 =
				struct_object__object_93___object(
				(object_bglt) (o_3411), s_3412);
			     old1855_3415 =
				(obj_t) (aux_9589);
			  }
		       }
		  }
		  aux1856_3416 =
		     STRUCT_REF(s_3412, ((long) 0));
		  {	/* Cfa/cinfo2.scm 50 */
		     procedure_ref_app_49_bglt new1857_3417;
		     new1857_3417 =
			((procedure_ref_app_49_bglt) (old1855_3415));
		     {	/* Cfa/cinfo2.scm 50 */
			long arg2746_3418;
			arg2746_3418 =
			   class_num_218___object(procedure_ref_app_49_cfa_info2);
			{	/* Cfa/cinfo2.scm 50 */
			   obj_t obj_5111;
			   obj_5111 =
			      (obj_t) (new1857_3417);
			   (((obj_t) CREF(obj_5111))->header = MAKE_HEADER(arg2746_3418, 0), BUNSPEC);
			}
		     }
		     {	/* Cfa/cinfo2.scm 50 */
			procedure_ref_app_49_bglt arg2747_3419;
			{	/* Cfa/cinfo2.scm 50 */
			   procedure_ref_app_49_bglt res2862_5118;
			   {	/* Cfa/cinfo2.scm 50 */
			      approx_bglt approx_5115;
			      {		/* Cfa/cinfo2.scm 50 */
				 obj_t aux_9598;
				 aux_9598 =
				    STRUCT_REF(aux1856_3416, ((long) 0));
				 approx_5115 =
				    (approx_bglt) (aux_9598);
			      }
			      {		/* Cfa/cinfo2.scm 50 */
				 procedure_ref_app_49_bglt new1846_5116;
				 new1846_5116 =
				    ((procedure_ref_app_49_bglt) BREF(GC_MALLOC(sizeof(struct procedure_ref_app_49))));
				 ((((procedure_ref_app_49_bglt) CREF(new1846_5116))->approx) = ((approx_bglt) approx_5115), BUNSPEC);
				 res2862_5118 = new1846_5116;
			      }
			   }
			   arg2747_3419 = res2862_5118;
			}
			{	/* Cfa/cinfo2.scm 50 */
			   obj_t aux_9605;
			   object_bglt aux_9603;
			   aux_9605 =
			      (obj_t) (arg2747_3419);
			   aux_9603 =
			      (object_bglt) (new1857_3417);
			   OBJECT_WIDENING_SET(aux_9603, aux_9605);
			}
		     }
		     aux_9580 = new1857_3417;
		  }
	       }
	    }
	    return
	       (obj_t) (aux_9580);
	 }
      }
   }
}



/* object->struct-procedure-ref-app2236 */
obj_t 
object__struct_procedure_ref_app2236_175_cfa_info2(obj_t env_6487, obj_t obj1852_6488)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 50 */
      {
	 procedure_ref_app_49_bglt obj1852_3401;
	 obj1852_3401 =
	    (procedure_ref_app_49_bglt) (obj1852_6488);
	 {

	    {	/* Cfa/cinfo2.scm 50 */
	       obj_t res1853_3404;
	       {	/* Cfa/cinfo2.scm 50 */
		  obj_t next_method2235_35_3409;
		  next_method2235_35_3409 =
		     find_super_class_method_167___object(
		     (object_bglt) (obj1852_3401), object__struct_env_210___object, procedure_ref_app_49_cfa_info2);
		  if (
		     PROCEDUREP(next_method2235_35_3409))
		    {	/* Cfa/cinfo2.scm 50 */
		       res1853_3404 =
			  PROCEDURE_ENTRY(next_method2235_35_3409) (next_method2235_35_3409,
			  (obj_t) (obj1852_3401), BEOA);
		    }
		  else
		    {	/* Cfa/cinfo2.scm 50 */
		       PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2235_35_3409);
		       res1853_3404 =
			  object__struct_50___object(
			  (object_bglt) (obj1852_3401));
		    }
	       }
	       {	/* Cfa/cinfo2.scm 50 */
		  obj_t aux1854_3405;
		  {	/* ./Llib/struct.scm 1415 */
		     obj_t aux_9620;
		     aux_9620 =
			CNST_TABLE_REF(((long) 4));
		     aux1854_3405 =
			make_struct(aux_9620, ((long) 1), BUNSPEC);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_9623;
		     {	/* Cfa/cinfo2.scm 50 */
			approx_bglt aux_9624;
			{
			   obj_t aux_9625;
			   {	/* Cfa/cinfo2.scm 50 */
			      object_bglt aux_9626;
			      aux_9626 =
				 (object_bglt) (obj1852_3401);
			      aux_9625 =
				 OBJECT_WIDENING(aux_9626);
			   }
			   aux_9624 =
			      (((procedure_ref_app_49_bglt) CREF(aux_9625))->approx);
			}
			aux_9623 =
			   (obj_t) (aux_9624);
		     }
		     STRUCT_SET(aux1854_3405, ((long) 0), aux_9623);
		  }
		  STRUCT_SET(res1853_3404, ((long) 0), aux1854_3405);
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_9633;
		     aux_9633 =
			STRUCT_KEY(res1853_3404);
		     STRUCT_KEY_SET(aux1854_3405, aux_9633);
		  }
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_9636;
		     aux_9636 =
			CNST_TABLE_REF(((long) 4));
		     STRUCT_KEY_SET(res1853_3404, aux_9636);
		  }
		  return res1853_3404;
	       }
	    }
	 }
      }
   }
}



/* struct+object->object-procedure-set!-app2234 */
obj_t 
struct_object__object_procedure_set__app2234_125_cfa_info2(obj_t env_6489, obj_t o_6490, obj_t s_6491)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 51 */
      {
	 procedure_set__app_32_bglt o_3389;
	 obj_t s_3390;
	 {	/* Cfa/cinfo2.scm 51 */
	    procedure_set__app_32_bglt aux_9640;
	    o_3389 =
	       (procedure_set__app_32_bglt) (o_6490);
	    s_3390 = s_6491;
	    {

	       {	/* Cfa/cinfo2.scm 51 */
		  obj_t old1873_3393;
		  obj_t aux1874_3394;
		  {	/* Cfa/cinfo2.scm 51 */
		     obj_t next_method2233_54_3399;
		     next_method2233_54_3399 =
			find_super_class_method_167___object(
			(object_bglt) (o_3389), struct_object__object_env_209___object, procedure_set__app_32_cfa_info2);
		     if (
			PROCEDUREP(next_method2233_54_3399))
		       {	/* Cfa/cinfo2.scm 51 */
			  old1873_3393 =
			     PROCEDURE_ENTRY(next_method2233_54_3399) (next_method2233_54_3399,
			     (obj_t) (o_3389), s_3390, BEOA);
		       }
		     else
		       {	/* Cfa/cinfo2.scm 51 */
			  PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2233_54_3399);
			  {	/* Cfa/cinfo2.scm 51 */
			     object_bglt aux_9649;
			     aux_9649 =
				struct_object__object_93___object(
				(object_bglt) (o_3389), s_3390);
			     old1873_3393 =
				(obj_t) (aux_9649);
			  }
		       }
		  }
		  aux1874_3394 =
		     STRUCT_REF(s_3390, ((long) 0));
		  {	/* Cfa/cinfo2.scm 51 */
		     procedure_set__app_32_bglt new1875_3395;
		     new1875_3395 =
			((procedure_set__app_32_bglt) (old1873_3393));
		     {	/* Cfa/cinfo2.scm 51 */
			long arg2737_3396;
			arg2737_3396 =
			   class_num_218___object(procedure_set__app_32_cfa_info2);
			{	/* Cfa/cinfo2.scm 51 */
			   obj_t obj_5082;
			   obj_5082 =
			      (obj_t) (new1875_3395);
			   (((obj_t) CREF(obj_5082))->header = MAKE_HEADER(arg2737_3396, 0), BUNSPEC);
			}
		     }
		     {	/* Cfa/cinfo2.scm 51 */
			procedure_set__app_32_bglt arg2739_3397;
			{	/* Cfa/cinfo2.scm 51 */
			   procedure_set__app_32_bglt res2861_5089;
			   {	/* Cfa/cinfo2.scm 51 */
			      approx_bglt approx_5086;
			      {		/* Cfa/cinfo2.scm 51 */
				 obj_t aux_9658;
				 aux_9658 =
				    STRUCT_REF(aux1874_3394, ((long) 0));
				 approx_5086 =
				    (approx_bglt) (aux_9658);
			      }
			      {		/* Cfa/cinfo2.scm 51 */
				 procedure_set__app_32_bglt new1864_5087;
				 new1864_5087 =
				    ((procedure_set__app_32_bglt) BREF(GC_MALLOC(sizeof(struct procedure_set__app_32))));
				 ((((procedure_set__app_32_bglt) CREF(new1864_5087))->approx) = ((approx_bglt) approx_5086), BUNSPEC);
				 res2861_5089 = new1864_5087;
			      }
			   }
			   arg2739_3397 = res2861_5089;
			}
			{	/* Cfa/cinfo2.scm 51 */
			   obj_t aux_9665;
			   object_bglt aux_9663;
			   aux_9665 =
			      (obj_t) (arg2739_3397);
			   aux_9663 =
			      (object_bglt) (new1875_3395);
			   OBJECT_WIDENING_SET(aux_9663, aux_9665);
			}
		     }
		     aux_9640 = new1875_3395;
		  }
	       }
	    }
	    return
	       (obj_t) (aux_9640);
	 }
      }
   }
}



/* object->struct-procedure-set!-app2232 */
obj_t 
object__struct_procedure_set__app2232_251_cfa_info2(obj_t env_6492, obj_t obj1870_6493)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 51 */
      {
	 procedure_set__app_32_bglt obj1870_3379;
	 obj1870_3379 =
	    (procedure_set__app_32_bglt) (obj1870_6493);
	 {

	    {	/* Cfa/cinfo2.scm 51 */
	       obj_t res1871_3382;
	       {	/* Cfa/cinfo2.scm 51 */
		  obj_t next_method2231_252_3387;
		  next_method2231_252_3387 =
		     find_super_class_method_167___object(
		     (object_bglt) (obj1870_3379), object__struct_env_210___object, procedure_set__app_32_cfa_info2);
		  if (
		     PROCEDUREP(next_method2231_252_3387))
		    {	/* Cfa/cinfo2.scm 51 */
		       res1871_3382 =
			  PROCEDURE_ENTRY(next_method2231_252_3387) (next_method2231_252_3387,
			  (obj_t) (obj1870_3379), BEOA);
		    }
		  else
		    {	/* Cfa/cinfo2.scm 51 */
		       PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2231_252_3387);
		       res1871_3382 =
			  object__struct_50___object(
			  (object_bglt) (obj1870_3379));
		    }
	       }
	       {	/* Cfa/cinfo2.scm 51 */
		  obj_t aux1872_3383;
		  {	/* ./Llib/struct.scm 1415 */
		     obj_t aux_9680;
		     aux_9680 =
			CNST_TABLE_REF(((long) 5));
		     aux1872_3383 =
			make_struct(aux_9680, ((long) 1), BUNSPEC);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_9683;
		     {	/* Cfa/cinfo2.scm 51 */
			approx_bglt aux_9684;
			{
			   obj_t aux_9685;
			   {	/* Cfa/cinfo2.scm 51 */
			      object_bglt aux_9686;
			      aux_9686 =
				 (object_bglt) (obj1870_3379);
			      aux_9685 =
				 OBJECT_WIDENING(aux_9686);
			   }
			   aux_9684 =
			      (((procedure_set__app_32_bglt) CREF(aux_9685))->approx);
			}
			aux_9683 =
			   (obj_t) (aux_9684);
		     }
		     STRUCT_SET(aux1872_3383, ((long) 0), aux_9683);
		  }
		  STRUCT_SET(res1871_3382, ((long) 0), aux1872_3383);
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_9693;
		     aux_9693 =
			STRUCT_KEY(res1871_3382);
		     STRUCT_KEY_SET(aux1872_3383, aux_9693);
		  }
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_9696;
		     aux_9696 =
			CNST_TABLE_REF(((long) 5));
		     STRUCT_KEY_SET(res1871_3382, aux_9696);
		  }
		  return res1871_3382;
	       }
	    }
	 }
      }
   }
}



/* struct+object->object-pre-make-vector-app2230 */
obj_t 
struct_object__object_pre_make_vector_app2230_243_cfa_info2(obj_t env_6494, obj_t o_6495, obj_t s_6496)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 54 */
      {
	 pre_make_vector_app_251_bglt o_3367;
	 obj_t s_3368;
	 {	/* Cfa/cinfo2.scm 54 */
	    pre_make_vector_app_251_bglt aux_9700;
	    o_3367 =
	       (pre_make_vector_app_251_bglt) (o_6495);
	    s_3368 = s_6496;
	    {

	       {	/* Cfa/cinfo2.scm 54 */
		  obj_t old1891_3371;
		  obj_t aux1892_3372;
		  {	/* Cfa/cinfo2.scm 54 */
		     obj_t next_method2229_56_3377;
		     next_method2229_56_3377 =
			find_super_class_method_167___object(
			(object_bglt) (o_3367), struct_object__object_env_209___object, pre_make_vector_app_251_cfa_info2);
		     if (
			PROCEDUREP(next_method2229_56_3377))
		       {	/* Cfa/cinfo2.scm 54 */
			  old1891_3371 =
			     PROCEDURE_ENTRY(next_method2229_56_3377) (next_method2229_56_3377,
			     (obj_t) (o_3367), s_3368, BEOA);
		       }
		     else
		       {	/* Cfa/cinfo2.scm 54 */
			  PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2229_56_3377);
			  {	/* Cfa/cinfo2.scm 54 */
			     object_bglt aux_9709;
			     aux_9709 =
				struct_object__object_93___object(
				(object_bglt) (o_3367), s_3368);
			     old1891_3371 =
				(obj_t) (aux_9709);
			  }
		       }
		  }
		  aux1892_3372 =
		     STRUCT_REF(s_3368, ((long) 0));
		  {	/* Cfa/cinfo2.scm 54 */
		     pre_make_vector_app_251_bglt new1893_3373;
		     new1893_3373 =
			((pre_make_vector_app_251_bglt) (old1891_3371));
		     {	/* Cfa/cinfo2.scm 54 */
			long arg2729_3374;
			arg2729_3374 =
			   class_num_218___object(pre_make_vector_app_251_cfa_info2);
			{	/* Cfa/cinfo2.scm 54 */
			   obj_t obj_5053;
			   obj_5053 =
			      (obj_t) (new1893_3373);
			   (((obj_t) CREF(obj_5053))->header = MAKE_HEADER(arg2729_3374, 0), BUNSPEC);
			}
		     }
		     {	/* Cfa/cinfo2.scm 54 */
			pre_make_vector_app_251_bglt arg2730_3375;
			{	/* Cfa/cinfo2.scm 54 */
			   pre_make_vector_app_251_bglt res2860_5060;
			   {	/* Cfa/cinfo2.scm 54 */
			      variable_bglt owner_5057;
			      {		/* Cfa/cinfo2.scm 54 */
				 obj_t aux_9718;
				 aux_9718 =
				    STRUCT_REF(aux1892_3372, ((long) 0));
				 owner_5057 =
				    (variable_bglt) (aux_9718);
			      }
			      {		/* Cfa/cinfo2.scm 54 */
				 pre_make_vector_app_251_bglt new1882_5058;
				 new1882_5058 =
				    ((pre_make_vector_app_251_bglt) BREF(GC_MALLOC(sizeof(struct pre_make_vector_app_251))));
				 ((((pre_make_vector_app_251_bglt) CREF(new1882_5058))->owner) = ((variable_bglt) owner_5057), BUNSPEC);
				 res2860_5060 = new1882_5058;
			      }
			   }
			   arg2730_3375 = res2860_5060;
			}
			{	/* Cfa/cinfo2.scm 54 */
			   obj_t aux_9725;
			   object_bglt aux_9723;
			   aux_9725 =
			      (obj_t) (arg2730_3375);
			   aux_9723 =
			      (object_bglt) (new1893_3373);
			   OBJECT_WIDENING_SET(aux_9723, aux_9725);
			}
		     }
		     aux_9700 = new1893_3373;
		  }
	       }
	    }
	    return
	       (obj_t) (aux_9700);
	 }
      }
   }
}



/* object->struct-pre-make-vector-app2228 */
obj_t 
object__struct_pre_make_vector_app2228_114_cfa_info2(obj_t env_6497, obj_t obj1888_6498)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 54 */
      {
	 pre_make_vector_app_251_bglt obj1888_3357;
	 obj1888_3357 =
	    (pre_make_vector_app_251_bglt) (obj1888_6498);
	 {

	    {	/* Cfa/cinfo2.scm 54 */
	       obj_t res1889_3360;
	       {	/* Cfa/cinfo2.scm 54 */
		  obj_t next_method2227_30_3365;
		  next_method2227_30_3365 =
		     find_super_class_method_167___object(
		     (object_bglt) (obj1888_3357), object__struct_env_210___object, pre_make_vector_app_251_cfa_info2);
		  if (
		     PROCEDUREP(next_method2227_30_3365))
		    {	/* Cfa/cinfo2.scm 54 */
		       res1889_3360 =
			  PROCEDURE_ENTRY(next_method2227_30_3365) (next_method2227_30_3365,
			  (obj_t) (obj1888_3357), BEOA);
		    }
		  else
		    {	/* Cfa/cinfo2.scm 54 */
		       PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2227_30_3365);
		       res1889_3360 =
			  object__struct_50___object(
			  (object_bglt) (obj1888_3357));
		    }
	       }
	       {	/* Cfa/cinfo2.scm 54 */
		  obj_t aux1890_3361;
		  {	/* ./Llib/struct.scm 1415 */
		     obj_t aux_9740;
		     aux_9740 =
			CNST_TABLE_REF(((long) 6));
		     aux1890_3361 =
			make_struct(aux_9740, ((long) 1), BUNSPEC);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_9743;
		     {	/* Cfa/cinfo2.scm 54 */
			variable_bglt aux_9744;
			{
			   obj_t aux_9745;
			   {	/* Cfa/cinfo2.scm 56 */
			      object_bglt aux_9746;
			      aux_9746 =
				 (object_bglt) (obj1888_3357);
			      aux_9745 =
				 OBJECT_WIDENING(aux_9746);
			   }
			   aux_9744 =
			      (((pre_make_vector_app_251_bglt) CREF(aux_9745))->owner);
			}
			aux_9743 =
			   (obj_t) (aux_9744);
		     }
		     STRUCT_SET(aux1890_3361, ((long) 0), aux_9743);
		  }
		  STRUCT_SET(res1889_3360, ((long) 0), aux1890_3361);
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_9753;
		     aux_9753 =
			STRUCT_KEY(res1889_3360);
		     STRUCT_KEY_SET(aux1890_3361, aux_9753);
		  }
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_9756;
		     aux_9756 =
			CNST_TABLE_REF(((long) 6));
		     STRUCT_KEY_SET(res1889_3360, aux_9756);
		  }
		  return res1889_3360;
	       }
	    }
	 }
      }
   }
}



/* struct+object->object-pre-create-vector-app2226 */
obj_t 
struct_object__object_pre_create_vector_app2226_157_cfa_info2(obj_t env_6499, obj_t o_6500, obj_t s_6501)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 57 */
      {
	 pre_create_vector_app_162_bglt o_3345;
	 obj_t s_3346;
	 {	/* Cfa/cinfo2.scm 57 */
	    pre_create_vector_app_162_bglt aux_9760;
	    o_3345 =
	       (pre_create_vector_app_162_bglt) (o_6500);
	    s_3346 = s_6501;
	    {

	       {	/* Cfa/cinfo2.scm 57 */
		  obj_t old1909_3349;
		  obj_t aux1910_3350;
		  {	/* Cfa/cinfo2.scm 57 */
		     obj_t next_method2225_173_3355;
		     next_method2225_173_3355 =
			find_super_class_method_167___object(
			(object_bglt) (o_3345), struct_object__object_env_209___object, pre_create_vector_app_162_cfa_info2);
		     if (
			PROCEDUREP(next_method2225_173_3355))
		       {	/* Cfa/cinfo2.scm 57 */
			  old1909_3349 =
			     PROCEDURE_ENTRY(next_method2225_173_3355) (next_method2225_173_3355,
			     (obj_t) (o_3345), s_3346, BEOA);
		       }
		     else
		       {	/* Cfa/cinfo2.scm 57 */
			  PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2225_173_3355);
			  {	/* Cfa/cinfo2.scm 57 */
			     object_bglt aux_9769;
			     aux_9769 =
				struct_object__object_93___object(
				(object_bglt) (o_3345), s_3346);
			     old1909_3349 =
				(obj_t) (aux_9769);
			  }
		       }
		  }
		  aux1910_3350 =
		     STRUCT_REF(s_3346, ((long) 0));
		  {	/* Cfa/cinfo2.scm 57 */
		     pre_create_vector_app_162_bglt new1911_3351;
		     new1911_3351 =
			((pre_create_vector_app_162_bglt) (old1909_3349));
		     {	/* Cfa/cinfo2.scm 57 */
			long arg2720_3352;
			arg2720_3352 =
			   class_num_218___object(pre_create_vector_app_162_cfa_info2);
			{	/* Cfa/cinfo2.scm 57 */
			   obj_t obj_5024;
			   obj_5024 =
			      (obj_t) (new1911_3351);
			   (((obj_t) CREF(obj_5024))->header = MAKE_HEADER(arg2720_3352, 0), BUNSPEC);
			}
		     }
		     {	/* Cfa/cinfo2.scm 57 */
			pre_create_vector_app_162_bglt arg2721_3353;
			{	/* Cfa/cinfo2.scm 57 */
			   pre_create_vector_app_162_bglt res2859_5031;
			   {	/* Cfa/cinfo2.scm 57 */
			      variable_bglt owner_5028;
			      {		/* Cfa/cinfo2.scm 57 */
				 obj_t aux_9778;
				 aux_9778 =
				    STRUCT_REF(aux1910_3350, ((long) 0));
				 owner_5028 =
				    (variable_bglt) (aux_9778);
			      }
			      {		/* Cfa/cinfo2.scm 57 */
				 pre_create_vector_app_162_bglt new1900_5029;
				 new1900_5029 =
				    ((pre_create_vector_app_162_bglt) BREF(GC_MALLOC(sizeof(struct pre_create_vector_app_162))));
				 ((((pre_create_vector_app_162_bglt) CREF(new1900_5029))->owner) = ((variable_bglt) owner_5028), BUNSPEC);
				 res2859_5031 = new1900_5029;
			      }
			   }
			   arg2721_3353 = res2859_5031;
			}
			{	/* Cfa/cinfo2.scm 57 */
			   obj_t aux_9785;
			   object_bglt aux_9783;
			   aux_9785 =
			      (obj_t) (arg2721_3353);
			   aux_9783 =
			      (object_bglt) (new1911_3351);
			   OBJECT_WIDENING_SET(aux_9783, aux_9785);
			}
		     }
		     aux_9760 = new1911_3351;
		  }
	       }
	    }
	    return
	       (obj_t) (aux_9760);
	 }
      }
   }
}



/* object->struct-pre-create-vector-app2224 */
obj_t 
object__struct_pre_create_vector_app2224_199_cfa_info2(obj_t env_6502, obj_t obj1906_6503)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 57 */
      {
	 pre_create_vector_app_162_bglt obj1906_3335;
	 obj1906_3335 =
	    (pre_create_vector_app_162_bglt) (obj1906_6503);
	 {

	    {	/* Cfa/cinfo2.scm 57 */
	       obj_t res1907_3338;
	       {	/* Cfa/cinfo2.scm 57 */
		  obj_t next_method2223_188_3343;
		  next_method2223_188_3343 =
		     find_super_class_method_167___object(
		     (object_bglt) (obj1906_3335), object__struct_env_210___object, pre_create_vector_app_162_cfa_info2);
		  if (
		     PROCEDUREP(next_method2223_188_3343))
		    {	/* Cfa/cinfo2.scm 57 */
		       res1907_3338 =
			  PROCEDURE_ENTRY(next_method2223_188_3343) (next_method2223_188_3343,
			  (obj_t) (obj1906_3335), BEOA);
		    }
		  else
		    {	/* Cfa/cinfo2.scm 57 */
		       PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2223_188_3343);
		       res1907_3338 =
			  object__struct_50___object(
			  (object_bglt) (obj1906_3335));
		    }
	       }
	       {	/* Cfa/cinfo2.scm 57 */
		  obj_t aux1908_3339;
		  {	/* ./Llib/struct.scm 1415 */
		     obj_t aux_9800;
		     aux_9800 =
			CNST_TABLE_REF(((long) 7));
		     aux1908_3339 =
			make_struct(aux_9800, ((long) 1), BUNSPEC);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_9803;
		     {	/* Cfa/cinfo2.scm 57 */
			variable_bglt aux_9804;
			{
			   obj_t aux_9805;
			   {	/* Cfa/cinfo2.scm 59 */
			      object_bglt aux_9806;
			      aux_9806 =
				 (object_bglt) (obj1906_3335);
			      aux_9805 =
				 OBJECT_WIDENING(aux_9806);
			   }
			   aux_9804 =
			      (((pre_create_vector_app_162_bglt) CREF(aux_9805))->owner);
			}
			aux_9803 =
			   (obj_t) (aux_9804);
		     }
		     STRUCT_SET(aux1908_3339, ((long) 0), aux_9803);
		  }
		  STRUCT_SET(res1907_3338, ((long) 0), aux1908_3339);
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_9813;
		     aux_9813 =
			STRUCT_KEY(res1907_3338);
		     STRUCT_KEY_SET(aux1908_3339, aux_9813);
		  }
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_9816;
		     aux_9816 =
			CNST_TABLE_REF(((long) 7));
		     STRUCT_KEY_SET(res1907_3338, aux_9816);
		  }
		  return res1907_3338;
	       }
	    }
	 }
      }
   }
}



/* struct+object->object-pre-vector-ref-app2222 */
obj_t 
struct_object__object_pre_vector_ref_app2222_114_cfa_info2(obj_t env_6504, obj_t o_6505, obj_t s_6506)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 60 */
      {
	 pre_vector_ref_app_208_bglt o_3324;
	 obj_t s_3325;
	 {	/* Cfa/cinfo2.scm 60 */
	    pre_vector_ref_app_208_bglt aux_9820;
	    o_3324 =
	       (pre_vector_ref_app_208_bglt) (o_6505);
	    s_3325 = s_6506;
	    {

	       {	/* Cfa/cinfo2.scm 60 */
		  obj_t old1926_3328;
		  {	/* Cfa/cinfo2.scm 60 */
		     obj_t next_method2221_36_3333;
		     next_method2221_36_3333 =
			find_super_class_method_167___object(
			(object_bglt) (o_3324), struct_object__object_env_209___object, pre_vector_ref_app_208_cfa_info2);
		     if (
			PROCEDUREP(next_method2221_36_3333))
		       {	/* Cfa/cinfo2.scm 60 */
			  old1926_3328 =
			     PROCEDURE_ENTRY(next_method2221_36_3333) (next_method2221_36_3333,
			     (obj_t) (o_3324), s_3325, BEOA);
		       }
		     else
		       {	/* Cfa/cinfo2.scm 60 */
			  PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2221_36_3333);
			  {	/* Cfa/cinfo2.scm 60 */
			     object_bglt aux_9829;
			     aux_9829 =
				struct_object__object_93___object(
				(object_bglt) (o_3324), s_3325);
			     old1926_3328 =
				(obj_t) (aux_9829);
			  }
		       }
		  }
		  {	/* Cfa/cinfo2.scm 60 */
		     pre_vector_ref_app_208_bglt new1928_3330;
		     new1928_3330 =
			((pre_vector_ref_app_208_bglt) (old1926_3328));
		     {	/* Cfa/cinfo2.scm 60 */
			long arg2713_3331;
			arg2713_3331 =
			   class_num_218___object(pre_vector_ref_app_208_cfa_info2);
			{	/* Cfa/cinfo2.scm 60 */
			   obj_t obj_4999;
			   obj_4999 =
			      (obj_t) (new1928_3330);
			   (((obj_t) CREF(obj_4999))->header = MAKE_HEADER(arg2713_3331, 0), BUNSPEC);
			}
		     }
		     {	/* Cfa/cinfo2.scm 60 */
			obj_t aux_9839;
			object_bglt aux_9837;
			{	/* Cfa/cinfo2.scm 60 */
			   pre_vector_ref_app_208_bglt aux_9840;
			   {	/* Cfa/cinfo2.scm 60 */

			      aux_9840 =
				 ((pre_vector_ref_app_208_bglt) BREF(GC_MALLOC(sizeof(struct pre_vector_ref_app_208))));
			   }
			   aux_9839 =
			      (obj_t) (aux_9840);
			}
			aux_9837 =
			   (object_bglt) (new1928_3330);
			OBJECT_WIDENING_SET(aux_9837, aux_9839);
		     }
		     aux_9820 = new1928_3330;
		  }
	       }
	    }
	    return
	       (obj_t) (aux_9820);
	 }
      }
   }
}



/* object->struct-pre-vector-ref-app2220 */
obj_t 
object__struct_pre_vector_ref_app2220_118_cfa_info2(obj_t env_6507, obj_t obj1923_6508)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 60 */
      {
	 pre_vector_ref_app_208_bglt obj1923_3316;
	 obj1923_3316 =
	    (pre_vector_ref_app_208_bglt) (obj1923_6508);
	 {

	    {	/* Cfa/cinfo2.scm 60 */
	       obj_t res1924_3319;
	       {	/* Cfa/cinfo2.scm 60 */
		  obj_t next_method2219_164_3322;
		  next_method2219_164_3322 =
		     find_super_class_method_167___object(
		     (object_bglt) (obj1923_3316), object__struct_env_210___object, pre_vector_ref_app_208_cfa_info2);
		  if (
		     PROCEDUREP(next_method2219_164_3322))
		    {	/* Cfa/cinfo2.scm 60 */
		       res1924_3319 =
			  PROCEDURE_ENTRY(next_method2219_164_3322) (next_method2219_164_3322,
			  (obj_t) (obj1923_3316), BEOA);
		    }
		  else
		    {	/* Cfa/cinfo2.scm 60 */
		       PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2219_164_3322);
		       res1924_3319 =
			  object__struct_50___object(
			  (object_bglt) (obj1923_3316));
		    }
	       }
	       {	/* Cfa/cinfo2.scm 60 */
		  obj_t aux1925_3320;
		  {	/* ./Llib/struct.scm 1415 */
		     obj_t aux_9856;
		     aux_9856 =
			CNST_TABLE_REF(((long) 8));
		     aux1925_3320 =
			make_struct(aux_9856, ((long) 0), BUNSPEC);
		  }
		  STRUCT_SET(res1924_3319, ((long) 0), aux1925_3320);
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_9860;
		     aux_9860 =
			STRUCT_KEY(res1924_3319);
		     STRUCT_KEY_SET(aux1925_3320, aux_9860);
		  }
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_9863;
		     aux_9863 =
			CNST_TABLE_REF(((long) 8));
		     STRUCT_KEY_SET(res1924_3319, aux_9863);
		  }
		  return res1924_3319;
	       }
	    }
	 }
      }
   }
}



/* struct+object->object-pre-vector-set!-app2218 */
obj_t 
struct_object__object_pre_vector_set__app2218_143_cfa_info2(obj_t env_6509, obj_t o_6510, obj_t s_6511)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 61 */
      {
	 pre_vector_set__app_211_bglt o_3305;
	 obj_t s_3306;
	 {	/* Cfa/cinfo2.scm 61 */
	    pre_vector_set__app_211_bglt aux_9867;
	    o_3305 =
	       (pre_vector_set__app_211_bglt) (o_6510);
	    s_3306 = s_6511;
	    {

	       {	/* Cfa/cinfo2.scm 61 */
		  obj_t old1943_3309;
		  {	/* Cfa/cinfo2.scm 61 */
		     obj_t next_method2217_72_3314;
		     next_method2217_72_3314 =
			find_super_class_method_167___object(
			(object_bglt) (o_3305), struct_object__object_env_209___object, pre_vector_set__app_211_cfa_info2);
		     if (
			PROCEDUREP(next_method2217_72_3314))
		       {	/* Cfa/cinfo2.scm 61 */
			  old1943_3309 =
			     PROCEDURE_ENTRY(next_method2217_72_3314) (next_method2217_72_3314,
			     (obj_t) (o_3305), s_3306, BEOA);
		       }
		     else
		       {	/* Cfa/cinfo2.scm 61 */
			  PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2217_72_3314);
			  {	/* Cfa/cinfo2.scm 61 */
			     object_bglt aux_9876;
			     aux_9876 =
				struct_object__object_93___object(
				(object_bglt) (o_3305), s_3306);
			     old1943_3309 =
				(obj_t) (aux_9876);
			  }
		       }
		  }
		  {	/* Cfa/cinfo2.scm 61 */
		     pre_vector_set__app_211_bglt new1945_3311;
		     new1945_3311 =
			((pre_vector_set__app_211_bglt) (old1943_3309));
		     {	/* Cfa/cinfo2.scm 61 */
			long arg2708_3312;
			arg2708_3312 =
			   class_num_218___object(pre_vector_set__app_211_cfa_info2);
			{	/* Cfa/cinfo2.scm 61 */
			   obj_t obj_4978;
			   obj_4978 =
			      (obj_t) (new1945_3311);
			   (((obj_t) CREF(obj_4978))->header = MAKE_HEADER(arg2708_3312, 0), BUNSPEC);
			}
		     }
		     {	/* Cfa/cinfo2.scm 61 */
			obj_t aux_9886;
			object_bglt aux_9884;
			{	/* Cfa/cinfo2.scm 61 */
			   pre_vector_set__app_211_bglt aux_9887;
			   {	/* Cfa/cinfo2.scm 61 */

			      aux_9887 =
				 ((pre_vector_set__app_211_bglt) BREF(GC_MALLOC(sizeof(struct pre_vector_set__app_211))));
			   }
			   aux_9886 =
			      (obj_t) (aux_9887);
			}
			aux_9884 =
			   (object_bglt) (new1945_3311);
			OBJECT_WIDENING_SET(aux_9884, aux_9886);
		     }
		     aux_9867 = new1945_3311;
		  }
	       }
	    }
	    return
	       (obj_t) (aux_9867);
	 }
      }
   }
}



/* object->struct-pre-vector-set!-app2216 */
obj_t 
object__struct_pre_vector_set__app2216_102_cfa_info2(obj_t env_6512, obj_t obj1940_6513)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 61 */
      {
	 pre_vector_set__app_211_bglt obj1940_3297;
	 obj1940_3297 =
	    (pre_vector_set__app_211_bglt) (obj1940_6513);
	 {

	    {	/* Cfa/cinfo2.scm 61 */
	       obj_t res1941_3300;
	       {	/* Cfa/cinfo2.scm 61 */
		  obj_t next_method2215_64_3303;
		  next_method2215_64_3303 =
		     find_super_class_method_167___object(
		     (object_bglt) (obj1940_3297), object__struct_env_210___object, pre_vector_set__app_211_cfa_info2);
		  if (
		     PROCEDUREP(next_method2215_64_3303))
		    {	/* Cfa/cinfo2.scm 61 */
		       res1941_3300 =
			  PROCEDURE_ENTRY(next_method2215_64_3303) (next_method2215_64_3303,
			  (obj_t) (obj1940_3297), BEOA);
		    }
		  else
		    {	/* Cfa/cinfo2.scm 61 */
		       PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2215_64_3303);
		       res1941_3300 =
			  object__struct_50___object(
			  (object_bglt) (obj1940_3297));
		    }
	       }
	       {	/* Cfa/cinfo2.scm 61 */
		  obj_t aux1942_3301;
		  {	/* ./Llib/struct.scm 1415 */
		     obj_t aux_9903;
		     aux_9903 =
			CNST_TABLE_REF(((long) 9));
		     aux1942_3301 =
			make_struct(aux_9903, ((long) 0), BUNSPEC);
		  }
		  STRUCT_SET(res1941_3300, ((long) 0), aux1942_3301);
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_9907;
		     aux_9907 =
			STRUCT_KEY(res1941_3300);
		     STRUCT_KEY_SET(aux1942_3301, aux_9907);
		  }
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_9910;
		     aux_9910 =
			CNST_TABLE_REF(((long) 9));
		     STRUCT_KEY_SET(res1941_3300, aux_9910);
		  }
		  return res1941_3300;
	       }
	    }
	 }
      }
   }
}



/* struct+object->object-make-vector-app2214 */
obj_t 
struct_object__object_make_vector_app2214_23_cfa_info2(obj_t env_6514, obj_t o_6515, obj_t s_6516)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 63 */
      {
	 make_vector_app_205_bglt o_3279;
	 obj_t s_3280;
	 {	/* Cfa/cinfo2.scm 63 */
	    make_vector_app_205_bglt aux_9914;
	    o_3279 =
	       (make_vector_app_205_bglt) (o_6515);
	    s_3280 = s_6516;
	    {

	       {	/* Cfa/cinfo2.scm 63 */
		  obj_t old1972_3283;
		  obj_t aux1973_3284;
		  {	/* Cfa/cinfo2.scm 63 */
		     obj_t next_method2213_122_3295;
		     next_method2213_122_3295 =
			find_super_class_method_167___object(
			(object_bglt) (o_3279), struct_object__object_env_209___object, make_vector_app_205_cfa_info2);
		     if (
			PROCEDUREP(next_method2213_122_3295))
		       {	/* Cfa/cinfo2.scm 63 */
			  old1972_3283 =
			     PROCEDURE_ENTRY(next_method2213_122_3295) (next_method2213_122_3295,
			     (obj_t) (o_3279), s_3280, BEOA);
		       }
		     else
		       {	/* Cfa/cinfo2.scm 63 */
			  PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2213_122_3295);
			  {	/* Cfa/cinfo2.scm 63 */
			     object_bglt aux_9923;
			     aux_9923 =
				struct_object__object_93___object(
				(object_bglt) (o_3279), s_3280);
			     old1972_3283 =
				(obj_t) (aux_9923);
			  }
		       }
		  }
		  aux1973_3284 =
		     STRUCT_REF(s_3280, ((long) 0));
		  {	/* Cfa/cinfo2.scm 63 */
		     make_vector_app_205_bglt new1974_3285;
		     new1974_3285 =
			((make_vector_app_205_bglt) (old1972_3283));
		     {	/* Cfa/cinfo2.scm 63 */
			long arg2696_3286;
			arg2696_3286 =
			   class_num_218___object(make_vector_app_205_cfa_info2);
			{	/* Cfa/cinfo2.scm 63 */
			   obj_t obj_4929;
			   obj_4929 =
			      (obj_t) (new1974_3285);
			   (((obj_t) CREF(obj_4929))->header = MAKE_HEADER(arg2696_3286, 0), BUNSPEC);
			}
		     }
		     {	/* Cfa/cinfo2.scm 63 */
			make_vector_app_205_bglt arg2697_3287;
			{	/* Cfa/cinfo2.scm 63 */
			   obj_t arg2703_3293;
			   arg2703_3293 =
			      STRUCT_REF(aux1973_3284, ((long) 5));
			   {	/* Cfa/cinfo2.scm 63 */
			      make_vector_app_205_bglt res2856_4960;
			      {		/* Cfa/cinfo2.scm 63 */
				 approx_bglt approx_4945;
				 approx_bglt value_approx_19_4946;
				 long lost_stamp_114_4947;
				 variable_bglt owner_4948;
				 bool_t stackable__42_4949;
				 bool_t seen__39_4951;
				 {	/* Cfa/cinfo2.scm 63 */
				    obj_t aux_9933;
				    aux_9933 =
				       STRUCT_REF(aux1973_3284, ((long) 0));
				    approx_4945 =
				       (approx_bglt) (aux_9933);
				 }
				 {	/* Cfa/cinfo2.scm 63 */
				    obj_t aux_9936;
				    aux_9936 =
				       STRUCT_REF(aux1973_3284, ((long) 1));
				    value_approx_19_4946 =
				       (approx_bglt) (aux_9936);
				 }
				 {	/* Cfa/cinfo2.scm 63 */
				    obj_t aux_9939;
				    aux_9939 =
				       STRUCT_REF(aux1973_3284, ((long) 2));
				    lost_stamp_114_4947 =
				       (long) CINT(aux_9939);
				 }
				 {	/* Cfa/cinfo2.scm 63 */
				    obj_t aux_9942;
				    aux_9942 =
				       STRUCT_REF(aux1973_3284, ((long) 3));
				    owner_4948 =
				       (variable_bglt) (aux_9942);
				 }
				 {	/* Cfa/cinfo2.scm 63 */
				    obj_t aux_9945;
				    aux_9945 =
				       STRUCT_REF(aux1973_3284, ((long) 4));
				    stackable__42_4949 =
				       CBOOL(aux_9945);
				 }
				 {	/* Cfa/cinfo2.scm 63 */
				    obj_t aux_9948;
				    aux_9948 =
				       STRUCT_REF(aux1973_3284, ((long) 6));
				    seen__39_4951 =
				       CBOOL(aux_9948);
				 }
				 {	/* Cfa/cinfo2.scm 63 */
				    make_vector_app_205_bglt new1957_4952;
				    new1957_4952 =
				       ((make_vector_app_205_bglt) BREF(GC_MALLOC(sizeof(struct make_vector_app_205))));
				    ((((make_vector_app_205_bglt) CREF(new1957_4952))->approx) = ((approx_bglt) approx_4945), BUNSPEC);
				    ((((make_vector_app_205_bglt) CREF(new1957_4952))->value_approx_19) = ((approx_bglt) value_approx_19_4946), BUNSPEC);
				    ((((make_vector_app_205_bglt) CREF(new1957_4952))->lost_stamp_114) = ((long) lost_stamp_114_4947), BUNSPEC);
				    ((((make_vector_app_205_bglt) CREF(new1957_4952))->owner) = ((variable_bglt) owner_4948), BUNSPEC);
				    ((((make_vector_app_205_bglt) CREF(new1957_4952))->stackable__42) = ((bool_t) stackable__42_4949), BUNSPEC);
				    ((((make_vector_app_205_bglt) CREF(new1957_4952))->stack_stamp_31) = ((obj_t) arg2703_3293), BUNSPEC);
				    ((((make_vector_app_205_bglt) CREF(new1957_4952))->seen__39) = ((bool_t) seen__39_4951), BUNSPEC);
				    res2856_4960 = new1957_4952;
				 }
			      }
			      arg2697_3287 = res2856_4960;
			   }
			}
			{	/* Cfa/cinfo2.scm 63 */
			   obj_t aux_9961;
			   object_bglt aux_9959;
			   aux_9961 =
			      (obj_t) (arg2697_3287);
			   aux_9959 =
			      (object_bglt) (new1974_3285);
			   OBJECT_WIDENING_SET(aux_9959, aux_9961);
			}
		     }
		     aux_9914 = new1974_3285;
		  }
	       }
	    }
	    return
	       (obj_t) (aux_9914);
	 }
      }
   }
}



/* object->struct-make-vector-app2212 */
obj_t 
object__struct_make_vector_app2212_75_cfa_info2(obj_t env_6517, obj_t obj1969_6518)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 63 */
      {
	 make_vector_app_205_bglt obj1969_3257;
	 obj1969_3257 =
	    (make_vector_app_205_bglt) (obj1969_6518);
	 {

	    {	/* Cfa/cinfo2.scm 63 */
	       obj_t res1970_3260;
	       {	/* Cfa/cinfo2.scm 63 */
		  obj_t next_method2211_245_3277;
		  next_method2211_245_3277 =
		     find_super_class_method_167___object(
		     (object_bglt) (obj1969_3257), object__struct_env_210___object, make_vector_app_205_cfa_info2);
		  if (
		     PROCEDUREP(next_method2211_245_3277))
		    {	/* Cfa/cinfo2.scm 63 */
		       res1970_3260 =
			  PROCEDURE_ENTRY(next_method2211_245_3277) (next_method2211_245_3277,
			  (obj_t) (obj1969_3257), BEOA);
		    }
		  else
		    {	/* Cfa/cinfo2.scm 63 */
		       PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2211_245_3277);
		       res1970_3260 =
			  object__struct_50___object(
			  (object_bglt) (obj1969_3257));
		    }
	       }
	       {	/* Cfa/cinfo2.scm 63 */
		  obj_t aux1971_3261;
		  {	/* ./Llib/struct.scm 1415 */
		     obj_t aux_9976;
		     aux_9976 =
			CNST_TABLE_REF(((long) 10));
		     aux1971_3261 =
			make_struct(aux_9976, ((long) 7), BUNSPEC);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_9979;
		     {	/* Cfa/cinfo2.scm 63 */
			approx_bglt aux_9980;
			{
			   obj_t aux_9981;
			   {	/* Cfa/cinfo2.scm 63 */
			      object_bglt aux_9982;
			      aux_9982 =
				 (object_bglt) (obj1969_3257);
			      aux_9981 =
				 OBJECT_WIDENING(aux_9982);
			   }
			   aux_9980 =
			      (((make_vector_app_205_bglt) CREF(aux_9981))->approx);
			}
			aux_9979 =
			   (obj_t) (aux_9980);
		     }
		     STRUCT_SET(aux1971_3261, ((long) 0), aux_9979);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_9988;
		     {	/* Cfa/cinfo2.scm 63 */
			approx_bglt aux_9989;
			{
			   obj_t aux_9990;
			   {	/* Cfa/cinfo2.scm 67 */
			      object_bglt aux_9991;
			      aux_9991 =
				 (object_bglt) (obj1969_3257);
			      aux_9990 =
				 OBJECT_WIDENING(aux_9991);
			   }
			   aux_9989 =
			      (((make_vector_app_205_bglt) CREF(aux_9990))->value_approx_19);
			}
			aux_9988 =
			   (obj_t) (aux_9989);
		     }
		     STRUCT_SET(aux1971_3261, ((long) 1), aux_9988);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_9997;
		     {	/* Cfa/cinfo2.scm 63 */
			long aux_9998;
			{
			   obj_t aux_9999;
			   {	/* Cfa/cinfo2.scm 69 */
			      object_bglt aux_10000;
			      aux_10000 =
				 (object_bglt) (obj1969_3257);
			      aux_9999 =
				 OBJECT_WIDENING(aux_10000);
			   }
			   aux_9998 =
			      (((make_vector_app_205_bglt) CREF(aux_9999))->lost_stamp_114);
			}
			aux_9997 =
			   BINT(aux_9998);
		     }
		     STRUCT_SET(aux1971_3261, ((long) 2), aux_9997);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_10006;
		     {	/* Cfa/cinfo2.scm 63 */
			variable_bglt aux_10007;
			{
			   obj_t aux_10008;
			   {	/* Cfa/cinfo2.scm 71 */
			      object_bglt aux_10009;
			      aux_10009 =
				 (object_bglt) (obj1969_3257);
			      aux_10008 =
				 OBJECT_WIDENING(aux_10009);
			   }
			   aux_10007 =
			      (((make_vector_app_205_bglt) CREF(aux_10008))->owner);
			}
			aux_10006 =
			   (obj_t) (aux_10007);
		     }
		     STRUCT_SET(aux1971_3261, ((long) 3), aux_10006);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_10015;
		     {	/* Cfa/cinfo2.scm 63 */
			bool_t aux_10016;
			{
			   obj_t aux_10017;
			   {	/* Cfa/cinfo2.scm 74 */
			      object_bglt aux_10018;
			      aux_10018 =
				 (object_bglt) (obj1969_3257);
			      aux_10017 =
				 OBJECT_WIDENING(aux_10018);
			   }
			   aux_10016 =
			      (((make_vector_app_205_bglt) CREF(aux_10017))->stackable__42);
			}
			aux_10015 =
			   BBOOL(aux_10016);
		     }
		     STRUCT_SET(aux1971_3261, ((long) 4), aux_10015);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_10024;
		     {
			obj_t aux_10025;
			{	/* Cfa/cinfo2.scm 76 */
			   object_bglt aux_10026;
			   aux_10026 =
			      (object_bglt) (obj1969_3257);
			   aux_10025 =
			      OBJECT_WIDENING(aux_10026);
			}
			aux_10024 =
			   (((make_vector_app_205_bglt) CREF(aux_10025))->stack_stamp_31);
		     }
		     STRUCT_SET(aux1971_3261, ((long) 5), aux_10024);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_10031;
		     {	/* Cfa/cinfo2.scm 63 */
			bool_t aux_10032;
			{
			   obj_t aux_10033;
			   {	/* Cfa/cinfo2.scm 86 */
			      object_bglt aux_10034;
			      aux_10034 =
				 (object_bglt) (obj1969_3257);
			      aux_10033 =
				 OBJECT_WIDENING(aux_10034);
			   }
			   aux_10032 =
			      (((make_vector_app_205_bglt) CREF(aux_10033))->seen__39);
			}
			aux_10031 =
			   BBOOL(aux_10032);
		     }
		     STRUCT_SET(aux1971_3261, ((long) 6), aux_10031);
		  }
		  STRUCT_SET(res1970_3260, ((long) 0), aux1971_3261);
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_10041;
		     aux_10041 =
			STRUCT_KEY(res1970_3260);
		     STRUCT_KEY_SET(aux1971_3261, aux_10041);
		  }
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_10044;
		     aux_10044 =
			CNST_TABLE_REF(((long) 10));
		     STRUCT_KEY_SET(res1970_3260, aux_10044);
		  }
		  return res1970_3260;
	       }
	    }
	 }
      }
   }
}



/* struct+object->object-create-vector-app2210 */
obj_t 
struct_object__object_create_vector_app2210_100_cfa_info2(obj_t env_6519, obj_t o_6520, obj_t s_6521)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 87 */
      {
	 create_vector_app_150_bglt o_3239;
	 obj_t s_3240;
	 {	/* Cfa/cinfo2.scm 87 */
	    create_vector_app_150_bglt aux_10048;
	    o_3239 =
	       (create_vector_app_150_bglt) (o_6520);
	    s_3240 = s_6521;
	    {

	       {	/* Cfa/cinfo2.scm 87 */
		  obj_t old2001_3243;
		  obj_t aux2002_3244;
		  {	/* Cfa/cinfo2.scm 87 */
		     obj_t next_method2209_248_3255;
		     next_method2209_248_3255 =
			find_super_class_method_167___object(
			(object_bglt) (o_3239), struct_object__object_env_209___object, create_vector_app_150_cfa_info2);
		     if (
			PROCEDUREP(next_method2209_248_3255))
		       {	/* Cfa/cinfo2.scm 87 */
			  old2001_3243 =
			     PROCEDURE_ENTRY(next_method2209_248_3255) (next_method2209_248_3255,
			     (obj_t) (o_3239), s_3240, BEOA);
		       }
		     else
		       {	/* Cfa/cinfo2.scm 87 */
			  PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2209_248_3255);
			  {	/* Cfa/cinfo2.scm 87 */
			     object_bglt aux_10057;
			     aux_10057 =
				struct_object__object_93___object(
				(object_bglt) (o_3239), s_3240);
			     old2001_3243 =
				(obj_t) (aux_10057);
			  }
		       }
		  }
		  aux2002_3244 =
		     STRUCT_REF(s_3240, ((long) 0));
		  {	/* Cfa/cinfo2.scm 87 */
		     create_vector_app_150_bglt new2003_3245;
		     new2003_3245 =
			((create_vector_app_150_bglt) (old2001_3243));
		     {	/* Cfa/cinfo2.scm 87 */
			long arg2670_3246;
			arg2670_3246 =
			   class_num_218___object(create_vector_app_150_cfa_info2);
			{	/* Cfa/cinfo2.scm 87 */
			   obj_t obj_4852;
			   obj_4852 =
			      (obj_t) (new2003_3245);
			   (((obj_t) CREF(obj_4852))->header = MAKE_HEADER(arg2670_3246, 0), BUNSPEC);
			}
		     }
		     {	/* Cfa/cinfo2.scm 87 */
			create_vector_app_150_bglt arg2671_3247;
			{	/* Cfa/cinfo2.scm 87 */
			   obj_t arg2677_3253;
			   arg2677_3253 =
			      STRUCT_REF(aux2002_3244, ((long) 5));
			   {	/* Cfa/cinfo2.scm 87 */
			      create_vector_app_150_bglt res2855_4883;
			      {		/* Cfa/cinfo2.scm 87 */
				 approx_bglt approx_4868;
				 approx_bglt value_approx_19_4869;
				 long lost_stamp_114_4870;
				 variable_bglt owner_4871;
				 bool_t stackable__42_4872;
				 bool_t seen__39_4874;
				 {	/* Cfa/cinfo2.scm 87 */
				    obj_t aux_10067;
				    aux_10067 =
				       STRUCT_REF(aux2002_3244, ((long) 0));
				    approx_4868 =
				       (approx_bglt) (aux_10067);
				 }
				 {	/* Cfa/cinfo2.scm 87 */
				    obj_t aux_10070;
				    aux_10070 =
				       STRUCT_REF(aux2002_3244, ((long) 1));
				    value_approx_19_4869 =
				       (approx_bglt) (aux_10070);
				 }
				 {	/* Cfa/cinfo2.scm 87 */
				    obj_t aux_10073;
				    aux_10073 =
				       STRUCT_REF(aux2002_3244, ((long) 2));
				    lost_stamp_114_4870 =
				       (long) CINT(aux_10073);
				 }
				 {	/* Cfa/cinfo2.scm 87 */
				    obj_t aux_10076;
				    aux_10076 =
				       STRUCT_REF(aux2002_3244, ((long) 3));
				    owner_4871 =
				       (variable_bglt) (aux_10076);
				 }
				 {	/* Cfa/cinfo2.scm 87 */
				    obj_t aux_10079;
				    aux_10079 =
				       STRUCT_REF(aux2002_3244, ((long) 4));
				    stackable__42_4872 =
				       CBOOL(aux_10079);
				 }
				 {	/* Cfa/cinfo2.scm 87 */
				    obj_t aux_10082;
				    aux_10082 =
				       STRUCT_REF(aux2002_3244, ((long) 6));
				    seen__39_4874 =
				       CBOOL(aux_10082);
				 }
				 {	/* Cfa/cinfo2.scm 87 */
				    create_vector_app_150_bglt new1986_4875;
				    new1986_4875 =
				       ((create_vector_app_150_bglt) BREF(GC_MALLOC(sizeof(struct create_vector_app_150))));
				    ((((create_vector_app_150_bglt) CREF(new1986_4875))->approx) = ((approx_bglt) approx_4868), BUNSPEC);
				    ((((create_vector_app_150_bglt) CREF(new1986_4875))->value_approx_19) = ((approx_bglt) value_approx_19_4869), BUNSPEC);
				    ((((create_vector_app_150_bglt) CREF(new1986_4875))->lost_stamp_114) = ((long) lost_stamp_114_4870), BUNSPEC);
				    ((((create_vector_app_150_bglt) CREF(new1986_4875))->owner) = ((variable_bglt) owner_4871), BUNSPEC);
				    ((((create_vector_app_150_bglt) CREF(new1986_4875))->stackable__42) = ((bool_t) stackable__42_4872), BUNSPEC);
				    ((((create_vector_app_150_bglt) CREF(new1986_4875))->stack_stamp_31) = ((obj_t) arg2677_3253), BUNSPEC);
				    ((((create_vector_app_150_bglt) CREF(new1986_4875))->seen__39) = ((bool_t) seen__39_4874), BUNSPEC);
				    res2855_4883 = new1986_4875;
				 }
			      }
			      arg2671_3247 = res2855_4883;
			   }
			}
			{	/* Cfa/cinfo2.scm 87 */
			   obj_t aux_10095;
			   object_bglt aux_10093;
			   aux_10095 =
			      (obj_t) (arg2671_3247);
			   aux_10093 =
			      (object_bglt) (new2003_3245);
			   OBJECT_WIDENING_SET(aux_10093, aux_10095);
			}
		     }
		     aux_10048 = new2003_3245;
		  }
	       }
	    }
	    return
	       (obj_t) (aux_10048);
	 }
      }
   }
}



/* object->struct-create-vector-app2208 */
obj_t 
object__struct_create_vector_app2208_188_cfa_info2(obj_t env_6522, obj_t obj1998_6523)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 87 */
      {
	 create_vector_app_150_bglt obj1998_3217;
	 obj1998_3217 =
	    (create_vector_app_150_bglt) (obj1998_6523);
	 {

	    {	/* Cfa/cinfo2.scm 87 */
	       obj_t res1999_3220;
	       {	/* Cfa/cinfo2.scm 87 */
		  obj_t next_method2207_123_3237;
		  next_method2207_123_3237 =
		     find_super_class_method_167___object(
		     (object_bglt) (obj1998_3217), object__struct_env_210___object, create_vector_app_150_cfa_info2);
		  if (
		     PROCEDUREP(next_method2207_123_3237))
		    {	/* Cfa/cinfo2.scm 87 */
		       res1999_3220 =
			  PROCEDURE_ENTRY(next_method2207_123_3237) (next_method2207_123_3237,
			  (obj_t) (obj1998_3217), BEOA);
		    }
		  else
		    {	/* Cfa/cinfo2.scm 87 */
		       PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2207_123_3237);
		       res1999_3220 =
			  object__struct_50___object(
			  (object_bglt) (obj1998_3217));
		    }
	       }
	       {	/* Cfa/cinfo2.scm 87 */
		  obj_t aux2000_3221;
		  {	/* ./Llib/struct.scm 1415 */
		     obj_t aux_10110;
		     aux_10110 =
			CNST_TABLE_REF(((long) 11));
		     aux2000_3221 =
			make_struct(aux_10110, ((long) 7), BUNSPEC);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_10113;
		     {	/* Cfa/cinfo2.scm 87 */
			approx_bglt aux_10114;
			{
			   obj_t aux_10115;
			   {	/* Cfa/cinfo2.scm 87 */
			      object_bglt aux_10116;
			      aux_10116 =
				 (object_bglt) (obj1998_3217);
			      aux_10115 =
				 OBJECT_WIDENING(aux_10116);
			   }
			   aux_10114 =
			      (((create_vector_app_150_bglt) CREF(aux_10115))->approx);
			}
			aux_10113 =
			   (obj_t) (aux_10114);
		     }
		     STRUCT_SET(aux2000_3221, ((long) 0), aux_10113);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_10122;
		     {	/* Cfa/cinfo2.scm 87 */
			approx_bglt aux_10123;
			{
			   obj_t aux_10124;
			   {	/* Cfa/cinfo2.scm 91 */
			      object_bglt aux_10125;
			      aux_10125 =
				 (object_bglt) (obj1998_3217);
			      aux_10124 =
				 OBJECT_WIDENING(aux_10125);
			   }
			   aux_10123 =
			      (((create_vector_app_150_bglt) CREF(aux_10124))->value_approx_19);
			}
			aux_10122 =
			   (obj_t) (aux_10123);
		     }
		     STRUCT_SET(aux2000_3221, ((long) 1), aux_10122);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_10131;
		     {	/* Cfa/cinfo2.scm 87 */
			long aux_10132;
			{
			   obj_t aux_10133;
			   {	/* Cfa/cinfo2.scm 93 */
			      object_bglt aux_10134;
			      aux_10134 =
				 (object_bglt) (obj1998_3217);
			      aux_10133 =
				 OBJECT_WIDENING(aux_10134);
			   }
			   aux_10132 =
			      (((create_vector_app_150_bglt) CREF(aux_10133))->lost_stamp_114);
			}
			aux_10131 =
			   BINT(aux_10132);
		     }
		     STRUCT_SET(aux2000_3221, ((long) 2), aux_10131);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_10140;
		     {	/* Cfa/cinfo2.scm 87 */
			variable_bglt aux_10141;
			{
			   obj_t aux_10142;
			   {	/* Cfa/cinfo2.scm 95 */
			      object_bglt aux_10143;
			      aux_10143 =
				 (object_bglt) (obj1998_3217);
			      aux_10142 =
				 OBJECT_WIDENING(aux_10143);
			   }
			   aux_10141 =
			      (((create_vector_app_150_bglt) CREF(aux_10142))->owner);
			}
			aux_10140 =
			   (obj_t) (aux_10141);
		     }
		     STRUCT_SET(aux2000_3221, ((long) 3), aux_10140);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_10149;
		     {	/* Cfa/cinfo2.scm 87 */
			bool_t aux_10150;
			{
			   obj_t aux_10151;
			   {	/* Cfa/cinfo2.scm 98 */
			      object_bglt aux_10152;
			      aux_10152 =
				 (object_bglt) (obj1998_3217);
			      aux_10151 =
				 OBJECT_WIDENING(aux_10152);
			   }
			   aux_10150 =
			      (((create_vector_app_150_bglt) CREF(aux_10151))->stackable__42);
			}
			aux_10149 =
			   BBOOL(aux_10150);
		     }
		     STRUCT_SET(aux2000_3221, ((long) 4), aux_10149);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_10158;
		     {
			obj_t aux_10159;
			{	/* Cfa/cinfo2.scm 100 */
			   object_bglt aux_10160;
			   aux_10160 =
			      (object_bglt) (obj1998_3217);
			   aux_10159 =
			      OBJECT_WIDENING(aux_10160);
			}
			aux_10158 =
			   (((create_vector_app_150_bglt) CREF(aux_10159))->stack_stamp_31);
		     }
		     STRUCT_SET(aux2000_3221, ((long) 5), aux_10158);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_10165;
		     {	/* Cfa/cinfo2.scm 87 */
			bool_t aux_10166;
			{
			   obj_t aux_10167;
			   {	/* Cfa/cinfo2.scm 103 */
			      object_bglt aux_10168;
			      aux_10168 =
				 (object_bglt) (obj1998_3217);
			      aux_10167 =
				 OBJECT_WIDENING(aux_10168);
			   }
			   aux_10166 =
			      (((create_vector_app_150_bglt) CREF(aux_10167))->seen__39);
			}
			aux_10165 =
			   BBOOL(aux_10166);
		     }
		     STRUCT_SET(aux2000_3221, ((long) 6), aux_10165);
		  }
		  STRUCT_SET(res1999_3220, ((long) 0), aux2000_3221);
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_10175;
		     aux_10175 =
			STRUCT_KEY(res1999_3220);
		     STRUCT_KEY_SET(aux2000_3221, aux_10175);
		  }
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_10178;
		     aux_10178 =
			CNST_TABLE_REF(((long) 11));
		     STRUCT_KEY_SET(res1999_3220, aux_10178);
		  }
		  return res1999_3220;
	       }
	    }
	 }
      }
   }
}



/* struct+object->object-vector-ref-app2206 */
obj_t 
struct_object__object_vector_ref_app2206_54_cfa_info2(obj_t env_6524, obj_t o_6525, obj_t s_6526)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 104 */
      {
	 vector_ref_app_195_bglt o_3205;
	 obj_t s_3206;
	 {	/* Cfa/cinfo2.scm 104 */
	    vector_ref_app_195_bglt aux_10182;
	    o_3205 =
	       (vector_ref_app_195_bglt) (o_6525);
	    s_3206 = s_6526;
	    {

	       {	/* Cfa/cinfo2.scm 104 */
		  obj_t old2019_3209;
		  obj_t aux2020_3210;
		  {	/* Cfa/cinfo2.scm 104 */
		     obj_t next_method2205_152_3215;
		     next_method2205_152_3215 =
			find_super_class_method_167___object(
			(object_bglt) (o_3205), struct_object__object_env_209___object, vector_ref_app_195_cfa_info2);
		     if (
			PROCEDUREP(next_method2205_152_3215))
		       {	/* Cfa/cinfo2.scm 104 */
			  old2019_3209 =
			     PROCEDURE_ENTRY(next_method2205_152_3215) (next_method2205_152_3215,
			     (obj_t) (o_3205), s_3206, BEOA);
		       }
		     else
		       {	/* Cfa/cinfo2.scm 104 */
			  PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2205_152_3215);
			  {	/* Cfa/cinfo2.scm 104 */
			     object_bglt aux_10191;
			     aux_10191 =
				struct_object__object_93___object(
				(object_bglt) (o_3205), s_3206);
			     old2019_3209 =
				(obj_t) (aux_10191);
			  }
		       }
		  }
		  aux2020_3210 =
		     STRUCT_REF(s_3206, ((long) 0));
		  {	/* Cfa/cinfo2.scm 104 */
		     vector_ref_app_195_bglt new2021_3211;
		     new2021_3211 =
			((vector_ref_app_195_bglt) (old2019_3209));
		     {	/* Cfa/cinfo2.scm 104 */
			long arg2650_3212;
			arg2650_3212 =
			   class_num_218___object(vector_ref_app_195_cfa_info2);
			{	/* Cfa/cinfo2.scm 104 */
			   obj_t obj_4799;
			   obj_4799 =
			      (obj_t) (new2021_3211);
			   (((obj_t) CREF(obj_4799))->header = MAKE_HEADER(arg2650_3212, 0), BUNSPEC);
			}
		     }
		     {	/* Cfa/cinfo2.scm 104 */
			vector_ref_app_195_bglt arg2651_3213;
			{	/* Cfa/cinfo2.scm 104 */
			   vector_ref_app_195_bglt res2854_4806;
			   {	/* Cfa/cinfo2.scm 104 */
			      approx_bglt approx_4803;
			      {		/* Cfa/cinfo2.scm 104 */
				 obj_t aux_10200;
				 aux_10200 =
				    STRUCT_REF(aux2020_3210, ((long) 0));
				 approx_4803 =
				    (approx_bglt) (aux_10200);
			      }
			      {		/* Cfa/cinfo2.scm 104 */
				 vector_ref_app_195_bglt new2010_4804;
				 new2010_4804 =
				    ((vector_ref_app_195_bglt) BREF(GC_MALLOC(sizeof(struct vector_ref_app_195))));
				 ((((vector_ref_app_195_bglt) CREF(new2010_4804))->approx) = ((approx_bglt) approx_4803), BUNSPEC);
				 res2854_4806 = new2010_4804;
			      }
			   }
			   arg2651_3213 = res2854_4806;
			}
			{	/* Cfa/cinfo2.scm 104 */
			   obj_t aux_10207;
			   object_bglt aux_10205;
			   aux_10207 =
			      (obj_t) (arg2651_3213);
			   aux_10205 =
			      (object_bglt) (new2021_3211);
			   OBJECT_WIDENING_SET(aux_10205, aux_10207);
			}
		     }
		     aux_10182 = new2021_3211;
		  }
	       }
	    }
	    return
	       (obj_t) (aux_10182);
	 }
      }
   }
}



/* object->struct-vector-ref-app2204 */
obj_t 
object__struct_vector_ref_app2204_84_cfa_info2(obj_t env_6527, obj_t obj2016_6528)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 104 */
      {
	 vector_ref_app_195_bglt obj2016_3195;
	 obj2016_3195 =
	    (vector_ref_app_195_bglt) (obj2016_6528);
	 {

	    {	/* Cfa/cinfo2.scm 104 */
	       obj_t res2017_3198;
	       {	/* Cfa/cinfo2.scm 104 */
		  obj_t next_method2203_120_3203;
		  next_method2203_120_3203 =
		     find_super_class_method_167___object(
		     (object_bglt) (obj2016_3195), object__struct_env_210___object, vector_ref_app_195_cfa_info2);
		  if (
		     PROCEDUREP(next_method2203_120_3203))
		    {	/* Cfa/cinfo2.scm 104 */
		       res2017_3198 =
			  PROCEDURE_ENTRY(next_method2203_120_3203) (next_method2203_120_3203,
			  (obj_t) (obj2016_3195), BEOA);
		    }
		  else
		    {	/* Cfa/cinfo2.scm 104 */
		       PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2203_120_3203);
		       res2017_3198 =
			  object__struct_50___object(
			  (object_bglt) (obj2016_3195));
		    }
	       }
	       {	/* Cfa/cinfo2.scm 104 */
		  obj_t aux2018_3199;
		  {	/* ./Llib/struct.scm 1415 */
		     obj_t aux_10222;
		     aux_10222 =
			CNST_TABLE_REF(((long) 12));
		     aux2018_3199 =
			make_struct(aux_10222, ((long) 1), BUNSPEC);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_10225;
		     {	/* Cfa/cinfo2.scm 104 */
			approx_bglt aux_10226;
			{
			   obj_t aux_10227;
			   {	/* Cfa/cinfo2.scm 104 */
			      object_bglt aux_10228;
			      aux_10228 =
				 (object_bglt) (obj2016_3195);
			      aux_10227 =
				 OBJECT_WIDENING(aux_10228);
			   }
			   aux_10226 =
			      (((vector_ref_app_195_bglt) CREF(aux_10227))->approx);
			}
			aux_10225 =
			   (obj_t) (aux_10226);
		     }
		     STRUCT_SET(aux2018_3199, ((long) 0), aux_10225);
		  }
		  STRUCT_SET(res2017_3198, ((long) 0), aux2018_3199);
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_10235;
		     aux_10235 =
			STRUCT_KEY(res2017_3198);
		     STRUCT_KEY_SET(aux2018_3199, aux_10235);
		  }
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_10238;
		     aux_10238 =
			CNST_TABLE_REF(((long) 12));
		     STRUCT_KEY_SET(res2017_3198, aux_10238);
		  }
		  return res2017_3198;
	       }
	    }
	 }
      }
   }
}



/* struct+object->object-vector-set!-app2202 */
obj_t 
struct_object__object_vector_set__app2202_239_cfa_info2(obj_t env_6529, obj_t o_6530, obj_t s_6531)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 105 */
      {
	 vector_set__app_21_bglt o_3183;
	 obj_t s_3184;
	 {	/* Cfa/cinfo2.scm 105 */
	    vector_set__app_21_bglt aux_10242;
	    o_3183 =
	       (vector_set__app_21_bglt) (o_6530);
	    s_3184 = s_6531;
	    {

	       {	/* Cfa/cinfo2.scm 105 */
		  obj_t old2037_3187;
		  obj_t aux2038_3188;
		  {	/* Cfa/cinfo2.scm 105 */
		     obj_t next_method2201_203_3193;
		     next_method2201_203_3193 =
			find_super_class_method_167___object(
			(object_bglt) (o_3183), struct_object__object_env_209___object, vector_set__app_21_cfa_info2);
		     if (
			PROCEDUREP(next_method2201_203_3193))
		       {	/* Cfa/cinfo2.scm 105 */
			  old2037_3187 =
			     PROCEDURE_ENTRY(next_method2201_203_3193) (next_method2201_203_3193,
			     (obj_t) (o_3183), s_3184, BEOA);
		       }
		     else
		       {	/* Cfa/cinfo2.scm 105 */
			  PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2201_203_3193);
			  {	/* Cfa/cinfo2.scm 105 */
			     object_bglt aux_10251;
			     aux_10251 =
				struct_object__object_93___object(
				(object_bglt) (o_3183), s_3184);
			     old2037_3187 =
				(obj_t) (aux_10251);
			  }
		       }
		  }
		  aux2038_3188 =
		     STRUCT_REF(s_3184, ((long) 0));
		  {	/* Cfa/cinfo2.scm 105 */
		     vector_set__app_21_bglt new2039_3189;
		     new2039_3189 =
			((vector_set__app_21_bglt) (old2037_3187));
		     {	/* Cfa/cinfo2.scm 105 */
			long arg2642_3190;
			arg2642_3190 =
			   class_num_218___object(vector_set__app_21_cfa_info2);
			{	/* Cfa/cinfo2.scm 105 */
			   obj_t obj_4770;
			   obj_4770 =
			      (obj_t) (new2039_3189);
			   (((obj_t) CREF(obj_4770))->header = MAKE_HEADER(arg2642_3190, 0), BUNSPEC);
			}
		     }
		     {	/* Cfa/cinfo2.scm 105 */
			vector_set__app_21_bglt arg2643_3191;
			{	/* Cfa/cinfo2.scm 105 */
			   vector_set__app_21_bglt res2853_4777;
			   {	/* Cfa/cinfo2.scm 105 */
			      approx_bglt approx_4774;
			      {		/* Cfa/cinfo2.scm 105 */
				 obj_t aux_10260;
				 aux_10260 =
				    STRUCT_REF(aux2038_3188, ((long) 0));
				 approx_4774 =
				    (approx_bglt) (aux_10260);
			      }
			      {		/* Cfa/cinfo2.scm 105 */
				 vector_set__app_21_bglt new2028_4775;
				 new2028_4775 =
				    ((vector_set__app_21_bglt) BREF(GC_MALLOC(sizeof(struct vector_set__app_21))));
				 ((((vector_set__app_21_bglt) CREF(new2028_4775))->approx) = ((approx_bglt) approx_4774), BUNSPEC);
				 res2853_4777 = new2028_4775;
			      }
			   }
			   arg2643_3191 = res2853_4777;
			}
			{	/* Cfa/cinfo2.scm 105 */
			   obj_t aux_10267;
			   object_bglt aux_10265;
			   aux_10267 =
			      (obj_t) (arg2643_3191);
			   aux_10265 =
			      (object_bglt) (new2039_3189);
			   OBJECT_WIDENING_SET(aux_10265, aux_10267);
			}
		     }
		     aux_10242 = new2039_3189;
		  }
	       }
	    }
	    return
	       (obj_t) (aux_10242);
	 }
      }
   }
}



/* object->struct-vector-set!-app2200 */
obj_t 
object__struct_vector_set__app2200_231_cfa_info2(obj_t env_6532, obj_t obj2034_6533)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 105 */
      {
	 vector_set__app_21_bglt obj2034_3173;
	 obj2034_3173 =
	    (vector_set__app_21_bglt) (obj2034_6533);
	 {

	    {	/* Cfa/cinfo2.scm 105 */
	       obj_t res2035_3176;
	       {	/* Cfa/cinfo2.scm 105 */
		  obj_t next_method2199_227_3181;
		  next_method2199_227_3181 =
		     find_super_class_method_167___object(
		     (object_bglt) (obj2034_3173), object__struct_env_210___object, vector_set__app_21_cfa_info2);
		  if (
		     PROCEDUREP(next_method2199_227_3181))
		    {	/* Cfa/cinfo2.scm 105 */
		       res2035_3176 =
			  PROCEDURE_ENTRY(next_method2199_227_3181) (next_method2199_227_3181,
			  (obj_t) (obj2034_3173), BEOA);
		    }
		  else
		    {	/* Cfa/cinfo2.scm 105 */
		       PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2199_227_3181);
		       res2035_3176 =
			  object__struct_50___object(
			  (object_bglt) (obj2034_3173));
		    }
	       }
	       {	/* Cfa/cinfo2.scm 105 */
		  obj_t aux2036_3177;
		  {	/* ./Llib/struct.scm 1415 */
		     obj_t aux_10282;
		     aux_10282 =
			CNST_TABLE_REF(((long) 13));
		     aux2036_3177 =
			make_struct(aux_10282, ((long) 1), BUNSPEC);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_10285;
		     {	/* Cfa/cinfo2.scm 105 */
			approx_bglt aux_10286;
			{
			   obj_t aux_10287;
			   {	/* Cfa/cinfo2.scm 105 */
			      object_bglt aux_10288;
			      aux_10288 =
				 (object_bglt) (obj2034_3173);
			      aux_10287 =
				 OBJECT_WIDENING(aux_10288);
			   }
			   aux_10286 =
			      (((vector_set__app_21_bglt) CREF(aux_10287))->approx);
			}
			aux_10285 =
			   (obj_t) (aux_10286);
		     }
		     STRUCT_SET(aux2036_3177, ((long) 0), aux_10285);
		  }
		  STRUCT_SET(res2035_3176, ((long) 0), aux2036_3177);
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_10295;
		     aux_10295 =
			STRUCT_KEY(res2035_3176);
		     STRUCT_KEY_SET(aux2036_3177, aux_10295);
		  }
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_10298;
		     aux_10298 =
			CNST_TABLE_REF(((long) 13));
		     STRUCT_KEY_SET(res2035_3176, aux_10298);
		  }
		  return res2035_3176;
	       }
	    }
	 }
      }
   }
}



/* struct+object->object-pre-make-struct-app2198 */
obj_t 
struct_object__object_pre_make_struct_app2198_56_cfa_info2(obj_t env_6534, obj_t o_6535, obj_t s_6536)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 108 */
      {
	 pre_make_struct_app_218_bglt o_3161;
	 obj_t s_3162;
	 {	/* Cfa/cinfo2.scm 108 */
	    pre_make_struct_app_218_bglt aux_10302;
	    o_3161 =
	       (pre_make_struct_app_218_bglt) (o_6535);
	    s_3162 = s_6536;
	    {

	       {	/* Cfa/cinfo2.scm 108 */
		  obj_t old2055_3165;
		  obj_t aux2056_3166;
		  {	/* Cfa/cinfo2.scm 108 */
		     obj_t next_method2197_180_3171;
		     next_method2197_180_3171 =
			find_super_class_method_167___object(
			(object_bglt) (o_3161), struct_object__object_env_209___object, pre_make_struct_app_218_cfa_info2);
		     if (
			PROCEDUREP(next_method2197_180_3171))
		       {	/* Cfa/cinfo2.scm 108 */
			  old2055_3165 =
			     PROCEDURE_ENTRY(next_method2197_180_3171) (next_method2197_180_3171,
			     (obj_t) (o_3161), s_3162, BEOA);
		       }
		     else
		       {	/* Cfa/cinfo2.scm 108 */
			  PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2197_180_3171);
			  {	/* Cfa/cinfo2.scm 108 */
			     object_bglt aux_10311;
			     aux_10311 =
				struct_object__object_93___object(
				(object_bglt) (o_3161), s_3162);
			     old2055_3165 =
				(obj_t) (aux_10311);
			  }
		       }
		  }
		  aux2056_3166 =
		     STRUCT_REF(s_3162, ((long) 0));
		  {	/* Cfa/cinfo2.scm 108 */
		     pre_make_struct_app_218_bglt new2057_3167;
		     new2057_3167 =
			((pre_make_struct_app_218_bglt) (old2055_3165));
		     {	/* Cfa/cinfo2.scm 108 */
			long arg2634_3168;
			arg2634_3168 =
			   class_num_218___object(pre_make_struct_app_218_cfa_info2);
			{	/* Cfa/cinfo2.scm 108 */
			   obj_t obj_4741;
			   obj_4741 =
			      (obj_t) (new2057_3167);
			   (((obj_t) CREF(obj_4741))->header = MAKE_HEADER(arg2634_3168, 0), BUNSPEC);
			}
		     }
		     {	/* Cfa/cinfo2.scm 108 */
			pre_make_struct_app_218_bglt arg2635_3169;
			{	/* Cfa/cinfo2.scm 108 */
			   pre_make_struct_app_218_bglt res2852_4748;
			   {	/* Cfa/cinfo2.scm 108 */
			      variable_bglt owner_4745;
			      {		/* Cfa/cinfo2.scm 108 */
				 obj_t aux_10320;
				 aux_10320 =
				    STRUCT_REF(aux2056_3166, ((long) 0));
				 owner_4745 =
				    (variable_bglt) (aux_10320);
			      }
			      {		/* Cfa/cinfo2.scm 108 */
				 pre_make_struct_app_218_bglt new2046_4746;
				 new2046_4746 =
				    ((pre_make_struct_app_218_bglt) BREF(GC_MALLOC(sizeof(struct pre_make_struct_app_218))));
				 ((((pre_make_struct_app_218_bglt) CREF(new2046_4746))->owner) = ((variable_bglt) owner_4745), BUNSPEC);
				 res2852_4748 = new2046_4746;
			      }
			   }
			   arg2635_3169 = res2852_4748;
			}
			{	/* Cfa/cinfo2.scm 108 */
			   obj_t aux_10327;
			   object_bglt aux_10325;
			   aux_10327 =
			      (obj_t) (arg2635_3169);
			   aux_10325 =
			      (object_bglt) (new2057_3167);
			   OBJECT_WIDENING_SET(aux_10325, aux_10327);
			}
		     }
		     aux_10302 = new2057_3167;
		  }
	       }
	    }
	    return
	       (obj_t) (aux_10302);
	 }
      }
   }
}



/* object->struct-pre-make-struct-app2196 */
obj_t 
object__struct_pre_make_struct_app2196_73_cfa_info2(obj_t env_6537, obj_t obj2052_6538)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 108 */
      {
	 pre_make_struct_app_218_bglt obj2052_3151;
	 obj2052_3151 =
	    (pre_make_struct_app_218_bglt) (obj2052_6538);
	 {

	    {	/* Cfa/cinfo2.scm 108 */
	       obj_t res2053_3154;
	       {	/* Cfa/cinfo2.scm 108 */
		  obj_t next_method2195_109_3159;
		  next_method2195_109_3159 =
		     find_super_class_method_167___object(
		     (object_bglt) (obj2052_3151), object__struct_env_210___object, pre_make_struct_app_218_cfa_info2);
		  if (
		     PROCEDUREP(next_method2195_109_3159))
		    {	/* Cfa/cinfo2.scm 108 */
		       res2053_3154 =
			  PROCEDURE_ENTRY(next_method2195_109_3159) (next_method2195_109_3159,
			  (obj_t) (obj2052_3151), BEOA);
		    }
		  else
		    {	/* Cfa/cinfo2.scm 108 */
		       PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2195_109_3159);
		       res2053_3154 =
			  object__struct_50___object(
			  (object_bglt) (obj2052_3151));
		    }
	       }
	       {	/* Cfa/cinfo2.scm 108 */
		  obj_t aux2054_3155;
		  {	/* ./Llib/struct.scm 1415 */
		     obj_t aux_10342;
		     aux_10342 =
			CNST_TABLE_REF(((long) 14));
		     aux2054_3155 =
			make_struct(aux_10342, ((long) 1), BUNSPEC);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_10345;
		     {	/* Cfa/cinfo2.scm 108 */
			variable_bglt aux_10346;
			{
			   obj_t aux_10347;
			   {	/* Cfa/cinfo2.scm 110 */
			      object_bglt aux_10348;
			      aux_10348 =
				 (object_bglt) (obj2052_3151);
			      aux_10347 =
				 OBJECT_WIDENING(aux_10348);
			   }
			   aux_10346 =
			      (((pre_make_struct_app_218_bglt) CREF(aux_10347))->owner);
			}
			aux_10345 =
			   (obj_t) (aux_10346);
		     }
		     STRUCT_SET(aux2054_3155, ((long) 0), aux_10345);
		  }
		  STRUCT_SET(res2053_3154, ((long) 0), aux2054_3155);
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_10355;
		     aux_10355 =
			STRUCT_KEY(res2053_3154);
		     STRUCT_KEY_SET(aux2054_3155, aux_10355);
		  }
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_10358;
		     aux_10358 =
			CNST_TABLE_REF(((long) 14));
		     STRUCT_KEY_SET(res2053_3154, aux_10358);
		  }
		  return res2053_3154;
	       }
	    }
	 }
      }
   }
}



/* struct+object->object-pre-struct-ref-app2194 */
obj_t 
struct_object__object_pre_struct_ref_app2194_102_cfa_info2(obj_t env_6539, obj_t o_6540, obj_t s_6541)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 111 */
      {
	 pre_struct_ref_app_207_bglt o_3140;
	 obj_t s_3141;
	 {	/* Cfa/cinfo2.scm 111 */
	    pre_struct_ref_app_207_bglt aux_10362;
	    o_3140 =
	       (pre_struct_ref_app_207_bglt) (o_6540);
	    s_3141 = s_6541;
	    {

	       {	/* Cfa/cinfo2.scm 111 */
		  obj_t old2072_3144;
		  {	/* Cfa/cinfo2.scm 111 */
		     obj_t next_method2193_53_3149;
		     next_method2193_53_3149 =
			find_super_class_method_167___object(
			(object_bglt) (o_3140), struct_object__object_env_209___object, pre_struct_ref_app_207_cfa_info2);
		     if (
			PROCEDUREP(next_method2193_53_3149))
		       {	/* Cfa/cinfo2.scm 111 */
			  old2072_3144 =
			     PROCEDURE_ENTRY(next_method2193_53_3149) (next_method2193_53_3149,
			     (obj_t) (o_3140), s_3141, BEOA);
		       }
		     else
		       {	/* Cfa/cinfo2.scm 111 */
			  PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2193_53_3149);
			  {	/* Cfa/cinfo2.scm 111 */
			     object_bglt aux_10371;
			     aux_10371 =
				struct_object__object_93___object(
				(object_bglt) (o_3140), s_3141);
			     old2072_3144 =
				(obj_t) (aux_10371);
			  }
		       }
		  }
		  {	/* Cfa/cinfo2.scm 111 */
		     pre_struct_ref_app_207_bglt new2074_3146;
		     new2074_3146 =
			((pre_struct_ref_app_207_bglt) (old2072_3144));
		     {	/* Cfa/cinfo2.scm 111 */
			long arg2627_3147;
			arg2627_3147 =
			   class_num_218___object(pre_struct_ref_app_207_cfa_info2);
			{	/* Cfa/cinfo2.scm 111 */
			   obj_t obj_4716;
			   obj_4716 =
			      (obj_t) (new2074_3146);
			   (((obj_t) CREF(obj_4716))->header = MAKE_HEADER(arg2627_3147, 0), BUNSPEC);
			}
		     }
		     {	/* Cfa/cinfo2.scm 111 */
			obj_t aux_10381;
			object_bglt aux_10379;
			{	/* Cfa/cinfo2.scm 111 */
			   pre_struct_ref_app_207_bglt aux_10382;
			   {	/* Cfa/cinfo2.scm 111 */

			      aux_10382 =
				 ((pre_struct_ref_app_207_bglt) BREF(GC_MALLOC(sizeof(struct pre_struct_ref_app_207))));
			   }
			   aux_10381 =
			      (obj_t) (aux_10382);
			}
			aux_10379 =
			   (object_bglt) (new2074_3146);
			OBJECT_WIDENING_SET(aux_10379, aux_10381);
		     }
		     aux_10362 = new2074_3146;
		  }
	       }
	    }
	    return
	       (obj_t) (aux_10362);
	 }
      }
   }
}



/* object->struct-pre-struct-ref-app2192 */
obj_t 
object__struct_pre_struct_ref_app2192_6_cfa_info2(obj_t env_6542, obj_t obj2069_6543)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 111 */
      {
	 pre_struct_ref_app_207_bglt obj2069_3132;
	 obj2069_3132 =
	    (pre_struct_ref_app_207_bglt) (obj2069_6543);
	 {

	    {	/* Cfa/cinfo2.scm 111 */
	       obj_t res2070_3135;
	       {	/* Cfa/cinfo2.scm 111 */
		  obj_t next_method2191_215_3138;
		  next_method2191_215_3138 =
		     find_super_class_method_167___object(
		     (object_bglt) (obj2069_3132), object__struct_env_210___object, pre_struct_ref_app_207_cfa_info2);
		  if (
		     PROCEDUREP(next_method2191_215_3138))
		    {	/* Cfa/cinfo2.scm 111 */
		       res2070_3135 =
			  PROCEDURE_ENTRY(next_method2191_215_3138) (next_method2191_215_3138,
			  (obj_t) (obj2069_3132), BEOA);
		    }
		  else
		    {	/* Cfa/cinfo2.scm 111 */
		       PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2191_215_3138);
		       res2070_3135 =
			  object__struct_50___object(
			  (object_bglt) (obj2069_3132));
		    }
	       }
	       {	/* Cfa/cinfo2.scm 111 */
		  obj_t aux2071_3136;
		  {	/* ./Llib/struct.scm 1415 */
		     obj_t aux_10398;
		     aux_10398 =
			CNST_TABLE_REF(((long) 15));
		     aux2071_3136 =
			make_struct(aux_10398, ((long) 0), BUNSPEC);
		  }
		  STRUCT_SET(res2070_3135, ((long) 0), aux2071_3136);
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_10402;
		     aux_10402 =
			STRUCT_KEY(res2070_3135);
		     STRUCT_KEY_SET(aux2071_3136, aux_10402);
		  }
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_10405;
		     aux_10405 =
			CNST_TABLE_REF(((long) 15));
		     STRUCT_KEY_SET(res2070_3135, aux_10405);
		  }
		  return res2070_3135;
	       }
	    }
	 }
      }
   }
}



/* struct+object->object-pre-struct-set!-app2190 */
obj_t 
struct_object__object_pre_struct_set__app2190_189_cfa_info2(obj_t env_6544, obj_t o_6545, obj_t s_6546)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 112 */
      {
	 pre_struct_set__app_116_bglt o_3121;
	 obj_t s_3122;
	 {	/* Cfa/cinfo2.scm 112 */
	    pre_struct_set__app_116_bglt aux_10409;
	    o_3121 =
	       (pre_struct_set__app_116_bglt) (o_6545);
	    s_3122 = s_6546;
	    {

	       {	/* Cfa/cinfo2.scm 112 */
		  obj_t old2089_3125;
		  {	/* Cfa/cinfo2.scm 112 */
		     obj_t next_method2189_193_3130;
		     next_method2189_193_3130 =
			find_super_class_method_167___object(
			(object_bglt) (o_3121), struct_object__object_env_209___object, pre_struct_set__app_116_cfa_info2);
		     if (
			PROCEDUREP(next_method2189_193_3130))
		       {	/* Cfa/cinfo2.scm 112 */
			  old2089_3125 =
			     PROCEDURE_ENTRY(next_method2189_193_3130) (next_method2189_193_3130,
			     (obj_t) (o_3121), s_3122, BEOA);
		       }
		     else
		       {	/* Cfa/cinfo2.scm 112 */
			  PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2189_193_3130);
			  {	/* Cfa/cinfo2.scm 112 */
			     object_bglt aux_10418;
			     aux_10418 =
				struct_object__object_93___object(
				(object_bglt) (o_3121), s_3122);
			     old2089_3125 =
				(obj_t) (aux_10418);
			  }
		       }
		  }
		  {	/* Cfa/cinfo2.scm 112 */
		     pre_struct_set__app_116_bglt new2091_3127;
		     new2091_3127 =
			((pre_struct_set__app_116_bglt) (old2089_3125));
		     {	/* Cfa/cinfo2.scm 112 */
			long arg2622_3128;
			arg2622_3128 =
			   class_num_218___object(pre_struct_set__app_116_cfa_info2);
			{	/* Cfa/cinfo2.scm 112 */
			   obj_t obj_4695;
			   obj_4695 =
			      (obj_t) (new2091_3127);
			   (((obj_t) CREF(obj_4695))->header = MAKE_HEADER(arg2622_3128, 0), BUNSPEC);
			}
		     }
		     {	/* Cfa/cinfo2.scm 112 */
			obj_t aux_10428;
			object_bglt aux_10426;
			{	/* Cfa/cinfo2.scm 112 */
			   pre_struct_set__app_116_bglt aux_10429;
			   {	/* Cfa/cinfo2.scm 112 */

			      aux_10429 =
				 ((pre_struct_set__app_116_bglt) BREF(GC_MALLOC(sizeof(struct pre_struct_set__app_116))));
			   }
			   aux_10428 =
			      (obj_t) (aux_10429);
			}
			aux_10426 =
			   (object_bglt) (new2091_3127);
			OBJECT_WIDENING_SET(aux_10426, aux_10428);
		     }
		     aux_10409 = new2091_3127;
		  }
	       }
	    }
	    return
	       (obj_t) (aux_10409);
	 }
      }
   }
}



/* object->struct-pre-struct-set!-app2188 */
obj_t 
object__struct_pre_struct_set__app2188_114_cfa_info2(obj_t env_6547, obj_t obj2086_6548)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 112 */
      {
	 pre_struct_set__app_116_bglt obj2086_3113;
	 obj2086_3113 =
	    (pre_struct_set__app_116_bglt) (obj2086_6548);
	 {

	    {	/* Cfa/cinfo2.scm 112 */
	       obj_t res2087_3116;
	       {	/* Cfa/cinfo2.scm 112 */
		  obj_t next_method2187_232_3119;
		  next_method2187_232_3119 =
		     find_super_class_method_167___object(
		     (object_bglt) (obj2086_3113), object__struct_env_210___object, pre_struct_set__app_116_cfa_info2);
		  if (
		     PROCEDUREP(next_method2187_232_3119))
		    {	/* Cfa/cinfo2.scm 112 */
		       res2087_3116 =
			  PROCEDURE_ENTRY(next_method2187_232_3119) (next_method2187_232_3119,
			  (obj_t) (obj2086_3113), BEOA);
		    }
		  else
		    {	/* Cfa/cinfo2.scm 112 */
		       PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2187_232_3119);
		       res2087_3116 =
			  object__struct_50___object(
			  (object_bglt) (obj2086_3113));
		    }
	       }
	       {	/* Cfa/cinfo2.scm 112 */
		  obj_t aux2088_3117;
		  {	/* ./Llib/struct.scm 1415 */
		     obj_t aux_10445;
		     aux_10445 =
			CNST_TABLE_REF(((long) 16));
		     aux2088_3117 =
			make_struct(aux_10445, ((long) 0), BUNSPEC);
		  }
		  STRUCT_SET(res2087_3116, ((long) 0), aux2088_3117);
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_10449;
		     aux_10449 =
			STRUCT_KEY(res2087_3116);
		     STRUCT_KEY_SET(aux2088_3117, aux_10449);
		  }
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_10452;
		     aux_10452 =
			CNST_TABLE_REF(((long) 16));
		     STRUCT_KEY_SET(res2087_3116, aux_10452);
		  }
		  return res2087_3116;
	       }
	    }
	 }
      }
   }
}



/* struct+object->object-make-struct-app2186 */
obj_t 
struct_object__object_make_struct_app2186_246_cfa_info2(obj_t env_6549, obj_t o_6550, obj_t s_6551)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 114 */
      {
	 make_struct_app_214_bglt o_3096;
	 obj_t s_3097;
	 {	/* Cfa/cinfo2.scm 114 */
	    make_struct_app_214_bglt aux_10456;
	    o_3096 =
	       (make_struct_app_214_bglt) (o_6550);
	    s_3097 = s_6551;
	    {

	       {	/* Cfa/cinfo2.scm 114 */
		  obj_t old2116_3100;
		  obj_t aux2117_3101;
		  {	/* Cfa/cinfo2.scm 114 */
		     obj_t next_method2185_108_3111;
		     next_method2185_108_3111 =
			find_super_class_method_167___object(
			(object_bglt) (o_3096), struct_object__object_env_209___object, make_struct_app_214_cfa_info2);
		     if (
			PROCEDUREP(next_method2185_108_3111))
		       {	/* Cfa/cinfo2.scm 114 */
			  old2116_3100 =
			     PROCEDURE_ENTRY(next_method2185_108_3111) (next_method2185_108_3111,
			     (obj_t) (o_3096), s_3097, BEOA);
		       }
		     else
		       {	/* Cfa/cinfo2.scm 114 */
			  PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2185_108_3111);
			  {	/* Cfa/cinfo2.scm 114 */
			     object_bglt aux_10465;
			     aux_10465 =
				struct_object__object_93___object(
				(object_bglt) (o_3096), s_3097);
			     old2116_3100 =
				(obj_t) (aux_10465);
			  }
		       }
		  }
		  aux2117_3101 =
		     STRUCT_REF(s_3097, ((long) 0));
		  {	/* Cfa/cinfo2.scm 114 */
		     make_struct_app_214_bglt new2118_3102;
		     new2118_3102 =
			((make_struct_app_214_bglt) (old2116_3100));
		     {	/* Cfa/cinfo2.scm 114 */
			long arg2611_3103;
			arg2611_3103 =
			   class_num_218___object(make_struct_app_214_cfa_info2);
			{	/* Cfa/cinfo2.scm 114 */
			   obj_t obj_4650;
			   obj_4650 =
			      (obj_t) (new2118_3102);
			   (((obj_t) CREF(obj_4650))->header = MAKE_HEADER(arg2611_3103, 0), BUNSPEC);
			}
		     }
		     {	/* Cfa/cinfo2.scm 114 */
			make_struct_app_214_bglt arg2612_3104;
			{	/* Cfa/cinfo2.scm 114 */
			   obj_t arg2618_3110;
			   arg2618_3110 =
			      STRUCT_REF(aux2117_3101, ((long) 5));
			   {	/* Cfa/cinfo2.scm 114 */
			      make_struct_app_214_bglt res2849_4677;
			      {		/* Cfa/cinfo2.scm 114 */
				 approx_bglt approx_4664;
				 approx_bglt value_approx_19_4665;
				 long lost_stamp_114_4666;
				 variable_bglt owner_4667;
				 bool_t stackable__42_4668;
				 {	/* Cfa/cinfo2.scm 114 */
				    obj_t aux_10475;
				    aux_10475 =
				       STRUCT_REF(aux2117_3101, ((long) 0));
				    approx_4664 =
				       (approx_bglt) (aux_10475);
				 }
				 {	/* Cfa/cinfo2.scm 114 */
				    obj_t aux_10478;
				    aux_10478 =
				       STRUCT_REF(aux2117_3101, ((long) 1));
				    value_approx_19_4665 =
				       (approx_bglt) (aux_10478);
				 }
				 {	/* Cfa/cinfo2.scm 114 */
				    obj_t aux_10481;
				    aux_10481 =
				       STRUCT_REF(aux2117_3101, ((long) 2));
				    lost_stamp_114_4666 =
				       (long) CINT(aux_10481);
				 }
				 {	/* Cfa/cinfo2.scm 114 */
				    obj_t aux_10484;
				    aux_10484 =
				       STRUCT_REF(aux2117_3101, ((long) 3));
				    owner_4667 =
				       (variable_bglt) (aux_10484);
				 }
				 {	/* Cfa/cinfo2.scm 114 */
				    obj_t aux_10487;
				    aux_10487 =
				       STRUCT_REF(aux2117_3101, ((long) 4));
				    stackable__42_4668 =
				       CBOOL(aux_10487);
				 }
				 {	/* Cfa/cinfo2.scm 114 */
				    make_struct_app_214_bglt new2102_4670;
				    new2102_4670 =
				       ((make_struct_app_214_bglt) BREF(GC_MALLOC(sizeof(struct make_struct_app_214))));
				    ((((make_struct_app_214_bglt) CREF(new2102_4670))->approx) = ((approx_bglt) approx_4664), BUNSPEC);
				    ((((make_struct_app_214_bglt) CREF(new2102_4670))->value_approx_19) = ((approx_bglt) value_approx_19_4665), BUNSPEC);
				    ((((make_struct_app_214_bglt) CREF(new2102_4670))->lost_stamp_114) = ((long) lost_stamp_114_4666), BUNSPEC);
				    ((((make_struct_app_214_bglt) CREF(new2102_4670))->owner) = ((variable_bglt) owner_4667), BUNSPEC);
				    ((((make_struct_app_214_bglt) CREF(new2102_4670))->stackable__42) = ((bool_t) stackable__42_4668), BUNSPEC);
				    ((((make_struct_app_214_bglt) CREF(new2102_4670))->stack_stamp_31) = ((obj_t) arg2618_3110), BUNSPEC);
				    res2849_4677 = new2102_4670;
				 }
			      }
			      arg2612_3104 = res2849_4677;
			   }
			}
			{	/* Cfa/cinfo2.scm 114 */
			   obj_t aux_10499;
			   object_bglt aux_10497;
			   aux_10499 =
			      (obj_t) (arg2612_3104);
			   aux_10497 =
			      (object_bglt) (new2118_3102);
			   OBJECT_WIDENING_SET(aux_10497, aux_10499);
			}
		     }
		     aux_10456 = new2118_3102;
		  }
	       }
	    }
	    return
	       (obj_t) (aux_10456);
	 }
      }
   }
}



/* object->struct-make-struct-app2184 */
obj_t 
object__struct_make_struct_app2184_126_cfa_info2(obj_t env_6552, obj_t obj2113_6553)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 114 */
      {
	 make_struct_app_214_bglt obj2113_3076;
	 obj2113_3076 =
	    (make_struct_app_214_bglt) (obj2113_6553);
	 {

	    {	/* Cfa/cinfo2.scm 114 */
	       obj_t res2114_3079;
	       {	/* Cfa/cinfo2.scm 114 */
		  obj_t next_method2183_137_3094;
		  next_method2183_137_3094 =
		     find_super_class_method_167___object(
		     (object_bglt) (obj2113_3076), object__struct_env_210___object, make_struct_app_214_cfa_info2);
		  if (
		     PROCEDUREP(next_method2183_137_3094))
		    {	/* Cfa/cinfo2.scm 114 */
		       res2114_3079 =
			  PROCEDURE_ENTRY(next_method2183_137_3094) (next_method2183_137_3094,
			  (obj_t) (obj2113_3076), BEOA);
		    }
		  else
		    {	/* Cfa/cinfo2.scm 114 */
		       PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2183_137_3094);
		       res2114_3079 =
			  object__struct_50___object(
			  (object_bglt) (obj2113_3076));
		    }
	       }
	       {	/* Cfa/cinfo2.scm 114 */
		  obj_t aux2115_3080;
		  {	/* ./Llib/struct.scm 1415 */
		     obj_t aux_10514;
		     aux_10514 =
			CNST_TABLE_REF(((long) 17));
		     aux2115_3080 =
			make_struct(aux_10514, ((long) 6), BUNSPEC);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_10517;
		     {	/* Cfa/cinfo2.scm 114 */
			approx_bglt aux_10518;
			{
			   obj_t aux_10519;
			   {	/* Cfa/cinfo2.scm 114 */
			      object_bglt aux_10520;
			      aux_10520 =
				 (object_bglt) (obj2113_3076);
			      aux_10519 =
				 OBJECT_WIDENING(aux_10520);
			   }
			   aux_10518 =
			      (((make_struct_app_214_bglt) CREF(aux_10519))->approx);
			}
			aux_10517 =
			   (obj_t) (aux_10518);
		     }
		     STRUCT_SET(aux2115_3080, ((long) 0), aux_10517);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_10526;
		     {	/* Cfa/cinfo2.scm 114 */
			approx_bglt aux_10527;
			{
			   obj_t aux_10528;
			   {	/* Cfa/cinfo2.scm 118 */
			      object_bglt aux_10529;
			      aux_10529 =
				 (object_bglt) (obj2113_3076);
			      aux_10528 =
				 OBJECT_WIDENING(aux_10529);
			   }
			   aux_10527 =
			      (((make_struct_app_214_bglt) CREF(aux_10528))->value_approx_19);
			}
			aux_10526 =
			   (obj_t) (aux_10527);
		     }
		     STRUCT_SET(aux2115_3080, ((long) 1), aux_10526);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_10535;
		     {	/* Cfa/cinfo2.scm 114 */
			long aux_10536;
			{
			   obj_t aux_10537;
			   {	/* Cfa/cinfo2.scm 120 */
			      object_bglt aux_10538;
			      aux_10538 =
				 (object_bglt) (obj2113_3076);
			      aux_10537 =
				 OBJECT_WIDENING(aux_10538);
			   }
			   aux_10536 =
			      (((make_struct_app_214_bglt) CREF(aux_10537))->lost_stamp_114);
			}
			aux_10535 =
			   BINT(aux_10536);
		     }
		     STRUCT_SET(aux2115_3080, ((long) 2), aux_10535);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_10544;
		     {	/* Cfa/cinfo2.scm 114 */
			variable_bglt aux_10545;
			{
			   obj_t aux_10546;
			   {	/* Cfa/cinfo2.scm 122 */
			      object_bglt aux_10547;
			      aux_10547 =
				 (object_bglt) (obj2113_3076);
			      aux_10546 =
				 OBJECT_WIDENING(aux_10547);
			   }
			   aux_10545 =
			      (((make_struct_app_214_bglt) CREF(aux_10546))->owner);
			}
			aux_10544 =
			   (obj_t) (aux_10545);
		     }
		     STRUCT_SET(aux2115_3080, ((long) 3), aux_10544);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_10553;
		     {	/* Cfa/cinfo2.scm 114 */
			bool_t aux_10554;
			{
			   obj_t aux_10555;
			   {	/* Cfa/cinfo2.scm 125 */
			      object_bglt aux_10556;
			      aux_10556 =
				 (object_bglt) (obj2113_3076);
			      aux_10555 =
				 OBJECT_WIDENING(aux_10556);
			   }
			   aux_10554 =
			      (((make_struct_app_214_bglt) CREF(aux_10555))->stackable__42);
			}
			aux_10553 =
			   BBOOL(aux_10554);
		     }
		     STRUCT_SET(aux2115_3080, ((long) 4), aux_10553);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_10562;
		     {
			obj_t aux_10563;
			{	/* Cfa/cinfo2.scm 127 */
			   object_bglt aux_10564;
			   aux_10564 =
			      (object_bglt) (obj2113_3076);
			   aux_10563 =
			      OBJECT_WIDENING(aux_10564);
			}
			aux_10562 =
			   (((make_struct_app_214_bglt) CREF(aux_10563))->stack_stamp_31);
		     }
		     STRUCT_SET(aux2115_3080, ((long) 5), aux_10562);
		  }
		  STRUCT_SET(res2114_3079, ((long) 0), aux2115_3080);
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_10570;
		     aux_10570 =
			STRUCT_KEY(res2114_3079);
		     STRUCT_KEY_SET(aux2115_3080, aux_10570);
		  }
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_10573;
		     aux_10573 =
			CNST_TABLE_REF(((long) 17));
		     STRUCT_KEY_SET(res2114_3079, aux_10573);
		  }
		  return res2114_3079;
	       }
	    }
	 }
      }
   }
}



/* struct+object->object-struct-ref-app2182 */
obj_t 
struct_object__object_struct_ref_app2182_41_cfa_info2(obj_t env_6554, obj_t o_6555, obj_t s_6556)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 129 */
      {
	 struct_ref_app_73_bglt o_3064;
	 obj_t s_3065;
	 {	/* Cfa/cinfo2.scm 129 */
	    struct_ref_app_73_bglt aux_10577;
	    o_3064 =
	       (struct_ref_app_73_bglt) (o_6555);
	    s_3065 = s_6556;
	    {

	       {	/* Cfa/cinfo2.scm 129 */
		  obj_t old2134_3068;
		  obj_t aux2135_3069;
		  {	/* Cfa/cinfo2.scm 129 */
		     obj_t next_method2181_74_3074;
		     next_method2181_74_3074 =
			find_super_class_method_167___object(
			(object_bglt) (o_3064), struct_object__object_env_209___object, struct_ref_app_73_cfa_info2);
		     if (
			PROCEDUREP(next_method2181_74_3074))
		       {	/* Cfa/cinfo2.scm 129 */
			  old2134_3068 =
			     PROCEDURE_ENTRY(next_method2181_74_3074) (next_method2181_74_3074,
			     (obj_t) (o_3064), s_3065, BEOA);
		       }
		     else
		       {	/* Cfa/cinfo2.scm 129 */
			  PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2181_74_3074);
			  {	/* Cfa/cinfo2.scm 129 */
			     object_bglt aux_10586;
			     aux_10586 =
				struct_object__object_93___object(
				(object_bglt) (o_3064), s_3065);
			     old2134_3068 =
				(obj_t) (aux_10586);
			  }
		       }
		  }
		  aux2135_3069 =
		     STRUCT_REF(s_3065, ((long) 0));
		  {	/* Cfa/cinfo2.scm 129 */
		     struct_ref_app_73_bglt new2136_3070;
		     new2136_3070 =
			((struct_ref_app_73_bglt) (old2134_3068));
		     {	/* Cfa/cinfo2.scm 129 */
			long arg2593_3071;
			arg2593_3071 =
			   class_num_218___object(struct_ref_app_73_cfa_info2);
			{	/* Cfa/cinfo2.scm 129 */
			   obj_t obj_4601;
			   obj_4601 =
			      (obj_t) (new2136_3070);
			   (((obj_t) CREF(obj_4601))->header = MAKE_HEADER(arg2593_3071, 0), BUNSPEC);
			}
		     }
		     {	/* Cfa/cinfo2.scm 129 */
			struct_ref_app_73_bglt arg2594_3072;
			{	/* Cfa/cinfo2.scm 129 */
			   struct_ref_app_73_bglt res2848_4608;
			   {	/* Cfa/cinfo2.scm 129 */
			      approx_bglt approx_4605;
			      {		/* Cfa/cinfo2.scm 129 */
				 obj_t aux_10595;
				 aux_10595 =
				    STRUCT_REF(aux2135_3069, ((long) 0));
				 approx_4605 =
				    (approx_bglt) (aux_10595);
			      }
			      {		/* Cfa/cinfo2.scm 129 */
				 struct_ref_app_73_bglt new2125_4606;
				 new2125_4606 =
				    ((struct_ref_app_73_bglt) BREF(GC_MALLOC(sizeof(struct struct_ref_app_73))));
				 ((((struct_ref_app_73_bglt) CREF(new2125_4606))->approx) = ((approx_bglt) approx_4605), BUNSPEC);
				 res2848_4608 = new2125_4606;
			      }
			   }
			   arg2594_3072 = res2848_4608;
			}
			{	/* Cfa/cinfo2.scm 129 */
			   obj_t aux_10602;
			   object_bglt aux_10600;
			   aux_10602 =
			      (obj_t) (arg2594_3072);
			   aux_10600 =
			      (object_bglt) (new2136_3070);
			   OBJECT_WIDENING_SET(aux_10600, aux_10602);
			}
		     }
		     aux_10577 = new2136_3070;
		  }
	       }
	    }
	    return
	       (obj_t) (aux_10577);
	 }
      }
   }
}



/* object->struct-struct-ref-app2180 */
obj_t 
object__struct_struct_ref_app2180_75_cfa_info2(obj_t env_6557, obj_t obj2131_6558)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 129 */
      {
	 struct_ref_app_73_bglt obj2131_3054;
	 obj2131_3054 =
	    (struct_ref_app_73_bglt) (obj2131_6558);
	 {

	    {	/* Cfa/cinfo2.scm 129 */
	       obj_t res2132_3057;
	       {	/* Cfa/cinfo2.scm 129 */
		  obj_t next_method2179_5_3062;
		  next_method2179_5_3062 =
		     find_super_class_method_167___object(
		     (object_bglt) (obj2131_3054), object__struct_env_210___object, struct_ref_app_73_cfa_info2);
		  if (
		     PROCEDUREP(next_method2179_5_3062))
		    {	/* Cfa/cinfo2.scm 129 */
		       res2132_3057 =
			  PROCEDURE_ENTRY(next_method2179_5_3062) (next_method2179_5_3062,
			  (obj_t) (obj2131_3054), BEOA);
		    }
		  else
		    {	/* Cfa/cinfo2.scm 129 */
		       PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2179_5_3062);
		       res2132_3057 =
			  object__struct_50___object(
			  (object_bglt) (obj2131_3054));
		    }
	       }
	       {	/* Cfa/cinfo2.scm 129 */
		  obj_t aux2133_3058;
		  {	/* ./Llib/struct.scm 1415 */
		     obj_t aux_10617;
		     aux_10617 =
			CNST_TABLE_REF(((long) 18));
		     aux2133_3058 =
			make_struct(aux_10617, ((long) 1), BUNSPEC);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_10620;
		     {	/* Cfa/cinfo2.scm 129 */
			approx_bglt aux_10621;
			{
			   obj_t aux_10622;
			   {	/* Cfa/cinfo2.scm 129 */
			      object_bglt aux_10623;
			      aux_10623 =
				 (object_bglt) (obj2131_3054);
			      aux_10622 =
				 OBJECT_WIDENING(aux_10623);
			   }
			   aux_10621 =
			      (((struct_ref_app_73_bglt) CREF(aux_10622))->approx);
			}
			aux_10620 =
			   (obj_t) (aux_10621);
		     }
		     STRUCT_SET(aux2133_3058, ((long) 0), aux_10620);
		  }
		  STRUCT_SET(res2132_3057, ((long) 0), aux2133_3058);
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_10630;
		     aux_10630 =
			STRUCT_KEY(res2132_3057);
		     STRUCT_KEY_SET(aux2133_3058, aux_10630);
		  }
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_10633;
		     aux_10633 =
			CNST_TABLE_REF(((long) 18));
		     STRUCT_KEY_SET(res2132_3057, aux_10633);
		  }
		  return res2132_3057;
	       }
	    }
	 }
      }
   }
}



/* struct+object->object-struct-set!-app2178 */
obj_t 
struct_object__object_struct_set__app2178_127_cfa_info2(obj_t env_6559, obj_t o_6560, obj_t s_6561)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 130 */
      {
	 struct_set__app_162_bglt o_3042;
	 obj_t s_3043;
	 {	/* Cfa/cinfo2.scm 130 */
	    struct_set__app_162_bglt aux_10637;
	    o_3042 =
	       (struct_set__app_162_bglt) (o_6560);
	    s_3043 = s_6561;
	    {

	       {	/* Cfa/cinfo2.scm 130 */
		  obj_t old2152_3046;
		  obj_t aux2153_3047;
		  {	/* Cfa/cinfo2.scm 130 */
		     obj_t next_method2177_137_3052;
		     next_method2177_137_3052 =
			find_super_class_method_167___object(
			(object_bglt) (o_3042), struct_object__object_env_209___object, struct_set__app_162_cfa_info2);
		     if (
			PROCEDUREP(next_method2177_137_3052))
		       {	/* Cfa/cinfo2.scm 130 */
			  old2152_3046 =
			     PROCEDURE_ENTRY(next_method2177_137_3052) (next_method2177_137_3052,
			     (obj_t) (o_3042), s_3043, BEOA);
		       }
		     else
		       {	/* Cfa/cinfo2.scm 130 */
			  PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2177_137_3052);
			  {	/* Cfa/cinfo2.scm 130 */
			     object_bglt aux_10646;
			     aux_10646 =
				struct_object__object_93___object(
				(object_bglt) (o_3042), s_3043);
			     old2152_3046 =
				(obj_t) (aux_10646);
			  }
		       }
		  }
		  aux2153_3047 =
		     STRUCT_REF(s_3043, ((long) 0));
		  {	/* Cfa/cinfo2.scm 130 */
		     struct_set__app_162_bglt new2154_3048;
		     new2154_3048 =
			((struct_set__app_162_bglt) (old2152_3046));
		     {	/* Cfa/cinfo2.scm 130 */
			long arg2585_3049;
			arg2585_3049 =
			   class_num_218___object(struct_set__app_162_cfa_info2);
			{	/* Cfa/cinfo2.scm 130 */
			   obj_t obj_4572;
			   obj_4572 =
			      (obj_t) (new2154_3048);
			   (((obj_t) CREF(obj_4572))->header = MAKE_HEADER(arg2585_3049, 0), BUNSPEC);
			}
		     }
		     {	/* Cfa/cinfo2.scm 130 */
			struct_set__app_162_bglt arg2586_3050;
			{	/* Cfa/cinfo2.scm 130 */
			   struct_set__app_162_bglt res2847_4579;
			   {	/* Cfa/cinfo2.scm 130 */
			      approx_bglt approx_4576;
			      {		/* Cfa/cinfo2.scm 130 */
				 obj_t aux_10655;
				 aux_10655 =
				    STRUCT_REF(aux2153_3047, ((long) 0));
				 approx_4576 =
				    (approx_bglt) (aux_10655);
			      }
			      {		/* Cfa/cinfo2.scm 130 */
				 struct_set__app_162_bglt new2143_4577;
				 new2143_4577 =
				    ((struct_set__app_162_bglt) BREF(GC_MALLOC(sizeof(struct struct_set__app_162))));
				 ((((struct_set__app_162_bglt) CREF(new2143_4577))->approx) = ((approx_bglt) approx_4576), BUNSPEC);
				 res2847_4579 = new2143_4577;
			      }
			   }
			   arg2586_3050 = res2847_4579;
			}
			{	/* Cfa/cinfo2.scm 130 */
			   obj_t aux_10662;
			   object_bglt aux_10660;
			   aux_10662 =
			      (obj_t) (arg2586_3050);
			   aux_10660 =
			      (object_bglt) (new2154_3048);
			   OBJECT_WIDENING_SET(aux_10660, aux_10662);
			}
		     }
		     aux_10637 = new2154_3048;
		  }
	       }
	    }
	    return
	       (obj_t) (aux_10637);
	 }
      }
   }
}



/* object->struct-struct-set!-app2176 */
obj_t 
object__struct_struct_set__app2176_75_cfa_info2(obj_t env_6562, obj_t obj2149_6563)
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 130 */
      {
	 struct_set__app_162_bglt obj2149_3032;
	 obj2149_3032 =
	    (struct_set__app_162_bglt) (obj2149_6563);
	 {

	    {	/* Cfa/cinfo2.scm 130 */
	       obj_t res2150_3035;
	       {	/* Cfa/cinfo2.scm 130 */
		  obj_t next_method2175_74_3040;
		  next_method2175_74_3040 =
		     find_super_class_method_167___object(
		     (object_bglt) (obj2149_3032), object__struct_env_210___object, struct_set__app_162_cfa_info2);
		  if (
		     PROCEDUREP(next_method2175_74_3040))
		    {	/* Cfa/cinfo2.scm 130 */
		       res2150_3035 =
			  PROCEDURE_ENTRY(next_method2175_74_3040) (next_method2175_74_3040,
			  (obj_t) (obj2149_3032), BEOA);
		    }
		  else
		    {	/* Cfa/cinfo2.scm 130 */
		       PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2175_74_3040);
		       res2150_3035 =
			  object__struct_50___object(
			  (object_bglt) (obj2149_3032));
		    }
	       }
	       {	/* Cfa/cinfo2.scm 130 */
		  obj_t aux2151_3036;
		  {	/* ./Llib/struct.scm 1415 */
		     obj_t aux_10677;
		     aux_10677 =
			CNST_TABLE_REF(((long) 19));
		     aux2151_3036 =
			make_struct(aux_10677, ((long) 1), BUNSPEC);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_10680;
		     {	/* Cfa/cinfo2.scm 130 */
			approx_bglt aux_10681;
			{
			   obj_t aux_10682;
			   {	/* Cfa/cinfo2.scm 130 */
			      object_bglt aux_10683;
			      aux_10683 =
				 (object_bglt) (obj2149_3032);
			      aux_10682 =
				 OBJECT_WIDENING(aux_10683);
			   }
			   aux_10681 =
			      (((struct_set__app_162_bglt) CREF(aux_10682))->approx);
			}
			aux_10680 =
			   (obj_t) (aux_10681);
		     }
		     STRUCT_SET(aux2151_3036, ((long) 0), aux_10680);
		  }
		  STRUCT_SET(res2150_3035, ((long) 0), aux2151_3036);
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_10690;
		     aux_10690 =
			STRUCT_KEY(res2150_3035);
		     STRUCT_KEY_SET(aux2151_3036, aux_10690);
		  }
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_10693;
		     aux_10693 =
			CNST_TABLE_REF(((long) 19));
		     STRUCT_KEY_SET(res2150_3035, aux_10693);
		  }
		  return res2150_3035;
	       }
	    }
	 }
      }
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_cfa_info2()
{
   AN_OBJECT;
   {	/* Cfa/cinfo2.scm 15 */
      module_initialization_70_type_type(((long) 0), "CFA_INFO2");
      module_initialization_70_type_cache(((long) 0), "CFA_INFO2");
      module_initialization_70_ast_var(((long) 0), "CFA_INFO2");
      module_initialization_70_ast_node(((long) 0), "CFA_INFO2");
      return
	 module_initialization_70_cfa_info(((long) 0), "CFA_INFO2");
   }
}
