/*===========================================================================*/
/*   (Cgen/capp.scm)                                                         */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;

typedef struct cop
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
   *cop_bglt;

typedef struct clabel
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     obj_t name;
     bool_t used__226;
     obj_t body;
  }
      *clabel_bglt;

typedef struct cgoto
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct clabel *label;
  }
     *cgoto_bglt;

typedef struct block
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *body;
  }
     *block_bglt;

typedef struct creturn
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *value;
  }
       *creturn_bglt;

typedef struct cvoid
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *value;
  }
     *cvoid_bglt;

typedef struct catom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     obj_t value;
  }
     *catom_bglt;

typedef struct varc
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct variable *variable;
  }
    *varc_bglt;

typedef struct cpragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     obj_t format;
     obj_t args;
  }
       *cpragma_bglt;

typedef struct ccast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct cop *arg;
  }
     *ccast_bglt;

typedef struct csequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     bool_t c_exp__163;
     obj_t cops;
  }
         *csequence_bglt;

typedef struct nop
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
   *nop_bglt;

typedef struct stop
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *value;
  }
    *stop_bglt;

typedef struct csetq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct varc *var;
     struct cop *value;
  }
     *csetq_bglt;

typedef struct cif
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *test;
     struct cop *true;
     struct cop *false;
  }
   *cif_bglt;

typedef struct local_var_164
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     obj_t vars;
  }
             *local_var_164_bglt;

typedef struct cfuncall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *fun;
     obj_t args;
     obj_t strength;
  }
        *cfuncall_bglt;

typedef struct capply
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *fun;
     struct cop *arg;
  }
      *capply_bglt;

typedef struct capp
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *fun;
     obj_t args;
  }
    *capp_bglt;

typedef struct cfail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *proc;
     struct cop *msg;
     struct cop *obj;
  }
     *cfail_bglt;

typedef struct cswitch
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *test;
     obj_t clauses;
  }
       *cswitch_bglt;

typedef struct cmake_box_177
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *value;
  }
             *cmake_box_177_bglt;

typedef struct cbox_ref_44
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *var;
  }
           *cbox_ref_44_bglt;

typedef struct cbox_set__132
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *var;
     struct cop *value;
  }
             *cbox_set__132_bglt;

typedef struct cset_ex_it_123
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *exit;
     struct cop *jump_value_221;
     struct cop *body;
  }
              *cset_ex_it_123_bglt;

typedef struct cjump_ex_it_131
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *exit;
     struct cop *value;
  }
               *cjump_ex_it_131_bglt;

typedef struct sfun_c_188
  {
     struct clabel *label;
     bool_t integrated;
  }
          *sfun_c_188_bglt;

typedef struct bdb_block_21
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *body;
  }
            *bdb_block_21_bglt;


static obj_t method_init_76_cgen_capp();
extern obj_t block_cgen_cop;
extern obj_t funcall_ast_node;
extern setq_bglt node_setq_243_cgen_cgen(variable_bglt, node_bglt);
extern obj_t var_ast_node;
extern obj_t add_method__1___object(obj_t, obj_t, obj_t);
extern obj_t global_ast_var;
extern local_bglt make_local_svar_name_219_cgen_cgen(obj_t, type_bglt);
extern obj_t _obj__252_type_cache;
extern obj_t block_kont_197_cgen_cgen(obj_t, obj_t);
static obj_t node_sfun_non_tail_app__cop_176_cgen_capp(variable_bglt, app_bglt, obj_t);
extern obj_t _id_kont__126_cgen_cgen;
extern obj_t varc_cgen_cop;
extern obj_t local_var_164_cgen_cop;
extern obj_t last_pair_93___r4_pairs_and_lists_6_3(obj_t);
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t catom_cgen_cop;
extern obj_t cgoto_cgen_cop;
extern obj_t module_initialization_70_cgen_capp(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_tools(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_ast_local(long, char *);
extern obj_t module_initialization_70_effect_effect(long, char *);
extern obj_t module_initialization_70_cgen_emit(long, char *);
extern obj_t module_initialization_70_cgen_cop(long, char *);
extern obj_t module_initialization_70_cgen_cgen(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t _the_global__73_cgen_cgen;
extern obj_t csetq_cgen_cop;
static obj_t node_cfun_non_tail_app__cop_38_cgen_capp(variable_bglt, app_bglt, obj_t);
extern obj_t _return_kont__110_cgen_cgen;
extern long class_num_218___object(obj_t);
extern obj_t stop_cgen_cop;
static obj_t imported_modules_init_94_cgen_capp();
extern obj_t app_ly_162_ast_node;
static obj_t node__cop_app1711_176_cgen_capp(obj_t, obj_t, obj_t);
static obj_t node__cop_app_ly1707_225_cgen_capp(obj_t, obj_t, obj_t);
extern obj_t app_ast_node;
static obj_t library_modules_init_112_cgen_capp();
static obj_t toplevel_init_63_cgen_capp();
extern obj_t capp_cgen_cop;
extern obj_t open_input_string(obj_t);
extern obj_t sfun_ast_var;
static obj_t node_tail_app__cop_48_cgen_capp(variable_bglt, app_bglt, obj_t);
extern obj_t local_ast_var;
extern obj_t csequence_cgen_cop;
extern cop_bglt bdb_let_var_254_cgen_cgen(cop_bglt, obj_t);
extern obj_t _procedure__226_type_cache;
extern obj_t _stop_kont__121_cgen_cgen;
extern obj_t read___reader(obj_t);
extern cop_bglt node__cop_142_cgen_cgen(node_bglt, obj_t);
static obj_t require_initialization_114_cgen_capp = BUNSPEC;
extern obj_t capply_cgen_cop;
static obj_t node__cop_funcall1709_218_cgen_capp(obj_t, obj_t, obj_t);
static obj_t cnst_init_137_cgen_capp();
extern obj_t reverse__39___r4_pairs_and_lists_6_3(obj_t);
extern obj_t cfuncall_cgen_cop;
static obj_t __cnst[2];

DEFINE_STATIC_PROCEDURE(proc2306_cgen_capp, node__cop_app1711_176_cgen_capp2312, node__cop_app1711_176_cgen_capp, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2305_cgen_capp, node__cop_funcall1709_218_cgen_capp2313, node__cop_funcall1709_218_cgen_capp, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2304_cgen_capp, node__cop_app_ly1707_225_cgen_capp2314, node__cop_app_ly1707_225_cgen_capp, 0L, 2);
extern obj_t node__cop_env_160_cgen_cgen;
DEFINE_STRING(string2307_cgen_capp, string2307_cgen_capp2315, "FUN AUX ", 8);



/* module-initialization */
obj_t 
module_initialization_70_cgen_capp(long checksum_2928, char *from_2929)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_cgen_capp))
	{
	   require_initialization_114_cgen_capp =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_cgen_capp();
	   cnst_init_137_cgen_capp();
	   imported_modules_init_94_cgen_capp();
	   method_init_76_cgen_capp();
	   toplevel_init_63_cgen_capp();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_cgen_capp()
{
   AN_OBJECT;
   {	/* Cgen/capp.scm 14 */
      module_initialization_70___object(((long) 0), "CGEN_CAPP");
      module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "CGEN_CAPP");
      module_initialization_70___reader(((long) 0), "CGEN_CAPP");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_cgen_capp()
{
   AN_OBJECT;
   {	/* Cgen/capp.scm 14 */
      {		/* Cgen/capp.scm 14 */
	 obj_t cnst_port_138_2921;
	 cnst_port_138_2921 =
	    open_input_string(string2307_cgen_capp);
	 {
	    long i_2922;
	    i_2922 = ((long) 1);
	  loop_2923:
	    {	/* Cgen/capp.scm 14 */
	       bool_t test2308_2924;
	       test2308_2924 =
		  (i_2922 == ((long) -1));
	       if (test2308_2924)
		 {	/* Cgen/capp.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Cgen/capp.scm 14 */
		    {	/* Cgen/capp.scm 14 */
		       obj_t arg2309_2925;
		       {	/* Cgen/capp.scm 14 */
			  obj_t list2310_2926;
			  list2310_2926 =
			     MAKE_PAIR(cnst_port_138_2921, BNIL);
			  arg2309_2925 =
			     read___reader(list2310_2926);
		       }
		       CNST_TABLE_SET(i_2922, arg2309_2925);
		    }
		    {	/* Cgen/capp.scm 14 */
		       int aux_2927;
		       {	/* Cgen/capp.scm 14 */
			  long aux_2947;
			  aux_2947 =
			     (i_2922 - ((long) 1));
			  aux_2927 =
			     (int) (aux_2947);
		       }
		       {
			  long i_2950;
			  i_2950 =
			     (long) (aux_2927);
			  i_2922 = i_2950;
			  goto loop_2923;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_cgen_capp()
{
   AN_OBJECT;
   {	/* Cgen/capp.scm 14 */
      return BUNSPEC;
   }
}



/* node-sfun-non-tail-app->cop */
obj_t 
node_sfun_non_tail_app__cop_176_cgen_capp(variable_bglt var_10, app_bglt node_11, obj_t kont_12)
{
   AN_OBJECT;
   {	/* Cgen/capp.scm 221 */
      {		/* Cgen/capp.scm 222 */
	 obj_t args_998;
	 {	/* Cgen/capp.scm 222 */
	    sfun_bglt obj_1982;
	    {	/* Cgen/capp.scm 222 */
	       value_bglt aux_2952;
	       aux_2952 =
		  (((variable_bglt) CREF(var_10))->value);
	       obj_1982 =
		  (sfun_bglt) (aux_2952);
	    }
	    args_998 =
	       (((sfun_bglt) CREF(obj_1982))->args);
	 }
	 {	/* Cgen/capp.scm 222 */
	    obj_t args_type_205_999;
	    {	/* Cgen/capp.scm 224 */
	       bool_t test1770_1068;
	       test1770_1068 =
		  NULLP(args_998);
	       if (test1770_1068)
		 {	/* Cgen/capp.scm 224 */
		    args_type_205_999 = BNIL;
		 }
	       else
		 {	/* Cgen/capp.scm 226 */
		    bool_t test1771_1069;
		    test1771_1069 =
		       is_a__118___object(
		       CAR(args_998), local_ast_var);
		    if (test1771_1069)
		      {		/* Cgen/capp.scm 226 */
			 if (test1770_1068)
			   {	/* Cgen/capp.scm 227 */
			      args_type_205_999 = BNIL;
			   }
			 else
			   {	/* Cgen/capp.scm 227 */
			      obj_t head1676_1072;
			      {		/* ./Ieee/pair-list.scm 5689 */
				 obj_t aux_2962;
				 {	/* Cgen/capp.scm 227 */
				    type_bglt aux_2963;
				    {	/* Cgen/capp.scm 227 */
				       local_bglt obj_1988;
				       {	/* Cgen/capp.scm 227 */
					  obj_t aux_2964;
					  aux_2964 =
					     CAR(args_998);
					  obj_1988 =
					     (local_bglt) (aux_2964);
				       }
				       aux_2963 =
					  (((local_bglt) CREF(obj_1988))->type);
				    }
				    aux_2962 =
				       (obj_t) (aux_2963);
				 }
				 head1676_1072 =
				    MAKE_PAIR(aux_2962, BNIL);
			      }
			      {
				 obj_t l1674_1073;
				 obj_t tail1677_1074;
				 l1674_1073 =
				    CDR(args_998);
				 tail1677_1074 = head1676_1072;
			       lname1675_1075:
				 if (
				    NULLP(l1674_1073))
				   {	/* Cgen/capp.scm 227 */
				      args_type_205_999 = head1676_1072;
				   }
				 else
				   {	/* Cgen/capp.scm 227 */
				      obj_t newtail1678_1078;
				      {		/* ./Ieee/pair-list.scm 5689 */
					 obj_t aux_2972;
					 {	/* Cgen/capp.scm 227 */
					    type_bglt aux_2973;
					    {	/* Cgen/capp.scm 227 */
					       local_bglt obj_1994;
					       {	/* Cgen/capp.scm 227 */
						  obj_t aux_2974;
						  aux_2974 =
						     CAR(l1674_1073);
						  obj_1994 =
						     (local_bglt) (aux_2974);
					       }
					       aux_2973 =
						  (((local_bglt) CREF(obj_1994))->type);
					    }
					    aux_2972 =
					       (obj_t) (aux_2973);
					 }
					 newtail1678_1078 =
					    MAKE_PAIR(aux_2972, BNIL);
				      }
				      SET_CDR(tail1677_1074, newtail1678_1078);
				      {
					 obj_t tail1677_2983;
					 obj_t l1674_2981;
					 l1674_2981 =
					    CDR(l1674_1073);
					 tail1677_2983 = newtail1678_1078;
					 tail1677_1074 = tail1677_2983;
					 l1674_1073 = l1674_2981;
					 goto lname1675_1075;
				      }
				   }
			      }
			   }
		      }
		    else
		      {		/* Cgen/capp.scm 226 */
			 args_type_205_999 = args_998;
		      }
		 }
	    }
	    {
	       cop_bglt cop_1061;
	       local_bglt aux_1062;
	       {	/* Cgen/capp.scm 230 */

		  {
		     obj_t old_actuals_174_1001;
		     obj_t args_type_205_1002;
		     obj_t new_actuals_73_1003;
		     local_bglt aux_1004;
		     obj_t auxs_1005;
		     obj_t exps_1006;
		     {	/* Cgen/capp.scm 233 */
			obj_t arg1714_1008;
			local_bglt arg1716_1010;
			arg1714_1008 =
			   (((app_bglt) CREF(node_11))->args);
			arg1716_1010 =
			   make_local_svar_name_219_cgen_cgen(
			   CNST_TABLE_REF(((long) 0)),
			   (type_bglt) (_obj__252_type_cache));
			old_actuals_174_1001 = arg1714_1008;
			args_type_205_1002 = args_type_205_999;
			new_actuals_73_1003 = BNIL;
			aux_1004 = arg1716_1010;
			auxs_1005 = BNIL;
			exps_1006 = BNIL;
		      loop_1007:
			if (
			   NULLP(old_actuals_174_1001))
			  {	/* Cgen/capp.scm 239 */
			     if (
				NULLP(auxs_1005))
			       {	/* Cgen/capp.scm 242 */
				  capp_bglt arg1721_1015;
				  {	/* Cgen/capp.scm 242 */
				     obj_t arg1722_1016;
				     cop_bglt arg1723_1017;
				     obj_t arg1724_1018;
				     {	/* Cgen/capp.scm 242 */
					node_bglt obj_2003;
					obj_2003 =
					   (node_bglt) (node_11);
					arg1722_1016 =
					   (((node_bglt) CREF(obj_2003))->loc);
				     }
				     {	/* Cgen/capp.scm 243 */
					node_bglt aux_2995;
					{	/* Cgen/capp.scm 243 */
					   var_bglt aux_2996;
					   aux_2996 =
					      (((app_bglt) CREF(node_11))->fun);
					   aux_2995 =
					      (node_bglt) (aux_2996);
					}
					arg1723_1017 =
					   node__cop_142_cgen_cgen(aux_2995, _id_kont__126_cgen_cgen);
				     }
				     arg1724_1018 =
					reverse__39___r4_pairs_and_lists_6_3(new_actuals_73_1003);
				     {	/* Cgen/capp.scm 241 */
					capp_bglt res2245_2015;
					{	/* ./Cgen/cop.scm 1506 */
					   capp_bglt new1557_2008;
					   new1557_2008 =
					      ((capp_bglt) BREF(GC_MALLOC(sizeof(struct capp))));
					   {	/* ./Cgen/cop.scm 1506 */
					      long arg1940_2009;
					      arg1940_2009 =
						 class_num_218___object(capp_cgen_cop);
					      {		/* ./Cgen/cop.scm 1506 */
						 obj_t obj_2013;
						 obj_2013 =
						    (obj_t) (new1557_2008);
						 (((obj_t) CREF(obj_2013))->header = MAKE_HEADER(arg1940_2009, 0), BUNSPEC);
					      }
					   }
					   {	/* ./Cgen/cop.scm 1506 */
					      object_bglt aux_3005;
					      aux_3005 =
						 (object_bglt) (new1557_2008);
					      OBJECT_WIDENING_SET(aux_3005, BFALSE);
					   }
					   ((((capp_bglt) CREF(new1557_2008))->loc) = ((obj_t) arg1722_1016), BUNSPEC);
					   ((((capp_bglt) CREF(new1557_2008))->fun) = ((cop_bglt) arg1723_1017), BUNSPEC);
					   ((((capp_bglt) CREF(new1557_2008))->args) = ((obj_t) arg1724_1018), BUNSPEC);
					   res2245_2015 = new1557_2008;
					}
					arg1721_1015 = res2245_2015;
				     }
				  }
				  return
				     PROCEDURE_ENTRY(kont_12) (kont_12,
				     (obj_t) (arg1721_1015), BEOA);
			       }
			     else
			       {	/* Cgen/capp.scm 249 */
				  obj_t loc_1020;
				  loc_1020 =
				     (((app_bglt) CREF(node_11))->loc);
				  {	/* Cgen/capp.scm 250 */
				     csequence_bglt arg1727_1022;
				     {	/* Cgen/capp.scm 252 */
					obj_t arg1729_1024;
					{	/* Cgen/capp.scm 256 */
					   local_var_164_bglt arg1730_1025;
					   csequence_bglt arg1731_1026;
					   obj_t arg1732_1027;
					   {	/* Cgen/capp.scm 256 */
					      local_var_164_bglt res2246_2025;
					      {		/* ./Cgen/cop.scm 1494 */
						 local_var_164_bglt new1536_2019;
						 new1536_2019 =
						    ((local_var_164_bglt) BREF(GC_MALLOC(sizeof(struct local_var_164))));
						 {	/* ./Cgen/cop.scm 1494 */
						    long arg1946_2020;
						    arg1946_2020 =
						       class_num_218___object(local_var_164_cgen_cop);
						    {	/* ./Cgen/cop.scm 1494 */
						       obj_t obj_2023;
						       obj_2023 =
							  (obj_t) (new1536_2019);
						       (((obj_t) CREF(obj_2023))->header = MAKE_HEADER(arg1946_2020, 0), BUNSPEC);
						    }
						 }
						 {	/* ./Cgen/cop.scm 1494 */
						    object_bglt aux_3019;
						    aux_3019 =
						       (object_bglt) (new1536_2019);
						    OBJECT_WIDENING_SET(aux_3019, BFALSE);
						 }
						 ((((local_var_164_bglt) CREF(new1536_2019))->loc) = ((obj_t) loc_1020), BUNSPEC);
						 ((((local_var_164_bglt) CREF(new1536_2019))->vars) = ((obj_t) auxs_1005), BUNSPEC);
						 res2246_2025 = new1536_2019;
					      }
					      arg1730_1025 = res2246_2025;
					   }
					   {	/* Cgen/capp.scm 259 */
					      csequence_bglt res2247_2036;
					      {		/* ./Cgen/cop.scm 1476 */
						 csequence_bglt new1503_2029;
						 new1503_2029 =
						    ((csequence_bglt) BREF(GC_MALLOC(sizeof(struct csequence))));
						 {	/* ./Cgen/cop.scm 1476 */
						    long arg1957_2030;
						    arg1957_2030 =
						       class_num_218___object(csequence_cgen_cop);
						    {	/* ./Cgen/cop.scm 1476 */
						       obj_t obj_2034;
						       obj_2034 =
							  (obj_t) (new1503_2029);
						       (((obj_t) CREF(obj_2034))->header = MAKE_HEADER(arg1957_2030, 0), BUNSPEC);
						    }
						 }
						 {	/* ./Cgen/cop.scm 1476 */
						    object_bglt aux_3028;
						    aux_3028 =
						       (object_bglt) (new1503_2029);
						    OBJECT_WIDENING_SET(aux_3028, BFALSE);
						 }
						 ((((csequence_bglt) CREF(new1503_2029))->loc) = ((obj_t) loc_1020), BUNSPEC);
						 ((((csequence_bglt) CREF(new1503_2029))->c_exp__163) = ((bool_t) ((bool_t) 0)), BUNSPEC);
						 ((((csequence_bglt) CREF(new1503_2029))->cops) = ((obj_t) exps_1006), BUNSPEC);
						 res2247_2036 = new1503_2029;
					      }
					      arg1731_1026 = res2247_2036;
					   }
					   {	/* Cgen/capp.scm 262 */
					      capp_bglt arg1741_1035;
					      {		/* Cgen/capp.scm 262 */
						 cop_bglt arg1743_1037;
						 obj_t arg1744_1038;
						 {	/* Cgen/capp.scm 264 */
						    node_bglt aux_3034;
						    {	/* Cgen/capp.scm 264 */
						       var_bglt aux_3035;
						       aux_3035 =
							  (((app_bglt) CREF(node_11))->fun);
						       aux_3034 =
							  (node_bglt) (aux_3035);
						    }
						    arg1743_1037 =
						       node__cop_142_cgen_cgen(aux_3034, _id_kont__126_cgen_cgen);
						 }
						 arg1744_1038 =
						    reverse__39___r4_pairs_and_lists_6_3(new_actuals_73_1003);
						 {	/* Cgen/capp.scm 262 */
						    capp_bglt res2248_2048;
						    {	/* ./Cgen/cop.scm 1506 */
						       capp_bglt new1557_2041;
						       new1557_2041 =
							  ((capp_bglt) BREF(GC_MALLOC(sizeof(struct capp))));
						       {	/* ./Cgen/cop.scm 1506 */
							  long arg1940_2042;
							  arg1940_2042 =
							     class_num_218___object(capp_cgen_cop);
							  {	/* ./Cgen/cop.scm 1506 */
							     obj_t obj_2046;
							     obj_2046 =
								(obj_t) (new1557_2041);
							     (((obj_t) CREF(obj_2046))->header = MAKE_HEADER(arg1940_2042, 0), BUNSPEC);
							  }
						       }
						       {	/* ./Cgen/cop.scm 1506 */
							  object_bglt aux_3044;
							  aux_3044 =
							     (object_bglt) (new1557_2041);
							  OBJECT_WIDENING_SET(aux_3044, BFALSE);
						       }
						       ((((capp_bglt) CREF(new1557_2041))->loc) = ((obj_t) loc_1020), BUNSPEC);
						       ((((capp_bglt) CREF(new1557_2041))->fun) = ((cop_bglt) arg1743_1037), BUNSPEC);
						       ((((capp_bglt) CREF(new1557_2041))->args) = ((obj_t) arg1744_1038), BUNSPEC);
						       res2248_2048 = new1557_2041;
						    }
						    arg1741_1035 = res2248_2048;
						 }
					      }
					      arg1732_1027 =
						 PROCEDURE_ENTRY(kont_12) (kont_12,
						 (obj_t) (arg1741_1035), BEOA);
					   }
					   {	/* Cgen/capp.scm 254 */
					      obj_t list1733_1028;
					      {		/* Cgen/capp.scm 254 */
						 obj_t arg1734_1029;
						 {	/* Cgen/capp.scm 254 */
						    obj_t arg1735_1030;
						    arg1735_1030 =
						       MAKE_PAIR(arg1732_1027, BNIL);
						    {	/* Cgen/capp.scm 254 */
						       obj_t aux_3054;
						       aux_3054 =
							  (obj_t) (arg1731_1026);
						       arg1734_1029 =
							  MAKE_PAIR(aux_3054, arg1735_1030);
						    }
						 }
						 {	/* Cgen/capp.scm 254 */
						    obj_t aux_3057;
						    aux_3057 =
						       (obj_t) (arg1730_1025);
						    list1733_1028 =
						       MAKE_PAIR(aux_3057, arg1734_1029);
						 }
					      }
					      arg1729_1024 = list1733_1028;
					   }
					}
					{	/* Cgen/capp.scm 252 */
					   csequence_bglt res2249_2060;
					   {	/* ./Cgen/cop.scm 1476 */
					      csequence_bglt new1503_2053;
					      new1503_2053 =
						 ((csequence_bglt) BREF(GC_MALLOC(sizeof(struct csequence))));
					      {		/* ./Cgen/cop.scm 1476 */
						 long arg1957_2054;
						 arg1957_2054 =
						    class_num_218___object(csequence_cgen_cop);
						 {	/* ./Cgen/cop.scm 1476 */
						    obj_t obj_2058;
						    obj_2058 =
						       (obj_t) (new1503_2053);
						    (((obj_t) CREF(obj_2058))->header = MAKE_HEADER(arg1957_2054, 0), BUNSPEC);
						 }
					      }
					      {		/* ./Cgen/cop.scm 1476 */
						 object_bglt aux_3064;
						 aux_3064 =
						    (object_bglt) (new1503_2053);
						 OBJECT_WIDENING_SET(aux_3064, BFALSE);
					      }
					      ((((csequence_bglt) CREF(new1503_2053))->loc) = ((obj_t) loc_1020), BUNSPEC);
					      ((((csequence_bglt) CREF(new1503_2053))->c_exp__163) = ((bool_t) ((bool_t) 0)), BUNSPEC);
					      ((((csequence_bglt) CREF(new1503_2053))->cops) = ((obj_t) arg1729_1024), BUNSPEC);
					      res2249_2060 = new1503_2053;
					   }
					   arg1727_1022 = res2249_2060;
					}
				     }
				     {	/* Cgen/capp.scm 250 */
					block_bglt res2250_2069;
					{	/* Cgen/capp.scm 250 */
					   cop_bglt body_2062;
					   body_2062 =
					      (cop_bglt) (arg1727_1022);
					   {	/* ./Cgen/cop.scm 1453 */
					      block_bglt new1459_2063;
					      new1459_2063 =
						 ((block_bglt) BREF(GC_MALLOC(sizeof(struct block))));
					      {		/* ./Cgen/cop.scm 1453 */
						 long arg1971_2064;
						 arg1971_2064 =
						    class_num_218___object(block_cgen_cop);
						 {	/* ./Cgen/cop.scm 1453 */
						    obj_t obj_2067;
						    obj_2067 =
						       (obj_t) (new1459_2063);
						    (((obj_t) CREF(obj_2067))->header = MAKE_HEADER(arg1971_2064, 0), BUNSPEC);
						 }
					      }
					      {		/* ./Cgen/cop.scm 1453 */
						 object_bglt aux_3075;
						 aux_3075 =
						    (object_bglt) (new1459_2063);
						 OBJECT_WIDENING_SET(aux_3075, BFALSE);
					      }
					      ((((block_bglt) CREF(new1459_2063))->loc) = ((obj_t) loc_1020), BUNSPEC);
					      ((((block_bglt) CREF(new1459_2063))->body) = ((cop_bglt) body_2062), BUNSPEC);
					      res2250_2069 = new1459_2063;
					   }
					}
					return
					   (obj_t) (res2250_2069);
				     }
				  }
			       }
			  }
			else
			  {	/* Cgen/capp.scm 267 */
			     cop_bglt cop_1040;
			     {	/* Cgen/capp.scm 267 */
				setq_bglt arg1765_1059;
				{	/* Cgen/capp.scm 267 */
				   node_bglt aux_3081;
				   {	/* Cgen/capp.scm 267 */
				      obj_t aux_3083;
				      aux_3083 =
					 CAR(old_actuals_174_1001);
				      aux_3081 =
					 (node_bglt) (aux_3083);
				   }
				   arg1765_1059 =
				      node_setq_243_cgen_cgen(
				      (variable_bglt) (aux_1004), aux_3081);
				}
				cop_1040 =
				   node__cop_142_cgen_cgen(
				   (node_bglt) (arg1765_1059), _id_kont__126_cgen_cgen);
			     }
			     {	/* Cgen/capp.scm 268 */
				bool_t test_3089;
				cop_1061 = cop_1040;
				aux_1062 = aux_1004;
				{	/* Cgen/capp.scm 231 */
				   bool_t _andtest_1679_1064;
				   _andtest_1679_1064 =
				      is_a__118___object(
				      (obj_t) (cop_1061), csetq_cgen_cop);
				   if (_andtest_1679_1064)
				     {	/* ./Ieee/equiv.scm 5508 */
					obj_t aux_3099;
					obj_t aux_3093;
					aux_3099 =
					   (obj_t) (aux_1062);
					{	/* Cgen/capp.scm 232 */
					   variable_bglt aux_3094;
					   {	/* Cgen/capp.scm 232 */
					      varc_bglt arg1769_1066;
					      {		/* Cgen/capp.scm 232 */
						 csetq_bglt obj_2100;
						 obj_2100 =
						    (csetq_bglt) (cop_1061);
						 arg1769_1066 =
						    (((csetq_bglt) CREF(obj_2100))->var);
					      }
					      aux_3094 =
						 (((varc_bglt) CREF(arg1769_1066))->variable);
					   }
					   aux_3093 =
					      (obj_t) (aux_3094);
					}
					test_3089 =
					   (aux_3093 == aux_3099);
				     }
				   else
				     {	/* Cgen/capp.scm 231 */
					test_3089 = ((bool_t) 0)
					   ;
				     }
				}
				if (test_3089)
				  {	/* Cgen/capp.scm 269 */
				     obj_t arg1747_1042;
				     obj_t arg1748_1043;
				     obj_t arg1749_1044;
				     arg1747_1042 =
					CDR(old_actuals_174_1001);
				     arg1748_1043 =
					CDR(args_type_205_1002);
				     {	/* ./Ieee/pair-list.scm 5689 */
					obj_t aux_3104;
					{	/* Cgen/capp.scm 271 */
					   cop_bglt aux_3105;
					   {	/* Cgen/capp.scm 271 */
					      csetq_bglt obj_2073;
					      obj_2073 =
						 (csetq_bglt) (cop_1040);
					      aux_3105 =
						 (((csetq_bglt) CREF(obj_2073))->value);
					   }
					   aux_3104 =
					      (obj_t) (aux_3105);
					}
					arg1749_1044 =
					   MAKE_PAIR(aux_3104, new_actuals_73_1003);
				     }
				     {
					obj_t new_actuals_73_3112;
					obj_t args_type_205_3111;
					obj_t old_actuals_174_3110;
					old_actuals_174_3110 = arg1747_1042;
					args_type_205_3111 = arg1748_1043;
					new_actuals_73_3112 = arg1749_1044;
					new_actuals_73_1003 = new_actuals_73_3112;
					args_type_205_1002 = args_type_205_3111;
					old_actuals_174_1001 = old_actuals_174_3110;
					goto loop_1007;
				     }
				  }
				else
				  {	/* Cgen/capp.scm 268 */
				     {	/* Cgen/capp.scm 276 */
					type_bglt val1082_2078;
					{	/* Cgen/capp.scm 276 */
					   obj_t aux_3113;
					   aux_3113 =
					      CAR(args_type_205_1002);
					   val1082_2078 =
					      (type_bglt) (aux_3113);
					}
					((((local_bglt) CREF(aux_1004))->type) = ((type_bglt) val1082_2078), BUNSPEC);
				     }
				     {	/* Cgen/capp.scm 277 */
					obj_t arg1752_1047;
					obj_t arg1753_1048;
					obj_t arg1754_1049;
					local_bglt arg1755_1050;
					obj_t arg1756_1051;
					obj_t arg1758_1052;
					arg1752_1047 =
					   CDR(old_actuals_174_1001);
					arg1753_1048 =
					   CDR(args_type_205_1002);
					{	/* Cgen/capp.scm 280 */
					   varc_bglt arg1759_1053;
					   {	/* Cgen/capp.scm 280 */
					      obj_t arg1760_1054;
					      {		/* Cgen/capp.scm 280 */
						 node_bglt obj_2082;
						 {	/* Cgen/capp.scm 280 */
						    obj_t aux_3119;
						    aux_3119 =
						       CAR(old_actuals_174_1001);
						    obj_2082 =
						       (node_bglt) (aux_3119);
						 }
						 arg1760_1054 =
						    (((node_bglt) CREF(obj_2082))->loc);
					      }
					      {		/* Cgen/capp.scm 279 */
						 varc_bglt res2251_2091;
						 {	/* Cgen/capp.scm 279 */
						    variable_bglt variable_2084;
						    variable_2084 =
						       (variable_bglt) (aux_1004);
						    {	/* ./Cgen/cop.scm 1465 */
						       varc_bglt new1483_2085;
						       new1483_2085 =
							  ((varc_bglt) BREF(GC_MALLOC(sizeof(struct varc))));
						       {	/* ./Cgen/cop.scm 1465 */
							  long arg1963_2086;
							  arg1963_2086 =
							     class_num_218___object(varc_cgen_cop);
							  {	/* ./Cgen/cop.scm 1465 */
							     obj_t obj_2089;
							     obj_2089 =
								(obj_t) (new1483_2085);
							     (((obj_t) CREF(obj_2089))->header = MAKE_HEADER(arg1963_2086, 0), BUNSPEC);
							  }
						       }
						       {	/* ./Cgen/cop.scm 1465 */
							  object_bglt aux_3128;
							  aux_3128 =
							     (object_bglt) (new1483_2085);
							  OBJECT_WIDENING_SET(aux_3128, BFALSE);
						       }
						       ((((varc_bglt) CREF(new1483_2085))->loc) = ((obj_t) arg1760_1054), BUNSPEC);
						       ((((varc_bglt) CREF(new1483_2085))->variable) = ((variable_bglt) variable_2084), BUNSPEC);
						       res2251_2091 = new1483_2085;
						    }
						 }
						 arg1759_1053 = res2251_2091;
					      }
					   }
					   {	/* ./Ieee/pair-list.scm 5689 */
					      obj_t aux_3133;
					      aux_3133 =
						 (obj_t) (arg1759_1053);
					      arg1754_1049 =
						 MAKE_PAIR(aux_3133, new_actuals_73_1003);
					   }
					}
					{	/* Cgen/capp.scm 283 */
					   type_bglt aux_3136;
					   {	/* Cgen/capp.scm 283 */
					      obj_t aux_3138;
					      aux_3138 =
						 CAR(args_type_205_1002);
					      aux_3136 =
						 (type_bglt) (aux_3138);
					   }
					   arg1755_1050 =
					      make_local_svar_name_219_cgen_cgen(
					      CNST_TABLE_REF(((long) 0)), aux_3136);
					}
					{	/* ./Ieee/pair-list.scm 5689 */
					   obj_t aux_3142;
					   aux_3142 =
					      (obj_t) (aux_1004);
					   arg1756_1051 =
					      MAKE_PAIR(aux_3142, auxs_1005);
					}
					{	/* ./Ieee/pair-list.scm 5689 */
					   obj_t aux_3145;
					   aux_3145 =
					      (obj_t) (cop_1040);
					   arg1758_1052 =
					      MAKE_PAIR(aux_3145, exps_1006);
					}
					{
					   obj_t exps_3153;
					   obj_t auxs_3152;
					   local_bglt aux_3151;
					   obj_t new_actuals_73_3150;
					   obj_t args_type_205_3149;
					   obj_t old_actuals_174_3148;
					   old_actuals_174_3148 = arg1752_1047;
					   args_type_205_3149 = arg1753_1048;
					   new_actuals_73_3150 = arg1754_1049;
					   aux_3151 = arg1755_1050;
					   auxs_3152 = arg1756_1051;
					   exps_3153 = arg1758_1052;
					   exps_1006 = exps_3153;
					   auxs_1005 = auxs_3152;
					   aux_1004 = aux_3151;
					   new_actuals_73_1003 = new_actuals_73_3150;
					   args_type_205_1002 = args_type_205_3149;
					   old_actuals_174_1001 = old_actuals_174_3148;
					   goto loop_1007;
					}
				     }
				  }
			     }
			  }
		     }
		  }
	       }
	    }
	 }
      }
   }
}



/* node-cfun-non-tail-app->cop */
obj_t 
node_cfun_non_tail_app__cop_38_cgen_capp(variable_bglt var_13, app_bglt node_14, obj_t kont_15)
{
   AN_OBJECT;
   {	/* Cgen/capp.scm 293 */
      {		/* Cgen/capp.scm 294 */
	 obj_t args_type_205_1088;
	 {	/* Cgen/capp.scm 294 */
	    cfun_bglt obj_2105;
	    {	/* Cgen/capp.scm 294 */
	       value_bglt aux_3154;
	       aux_3154 =
		  (((variable_bglt) CREF(var_13))->value);
	       obj_2105 =
		  (cfun_bglt) (aux_3154);
	    }
	    args_type_205_1088 =
	       (((cfun_bglt) CREF(obj_2105))->args_type_205);
	 }
	 {
	    cop_bglt cop_1155;
	    local_bglt aux_1156;
	    {
	       obj_t old_actuals_174_1090;
	       obj_t args_type_205_1091;
	       obj_t new_actuals_73_1092;
	       local_bglt aux_1093;
	       obj_t auxs_1094;
	       obj_t exps_1095;
	       {	/* Cgen/capp.scm 300 */
		  obj_t arg1784_1097;
		  local_bglt arg1786_1099;
		  arg1784_1097 =
		     (((app_bglt) CREF(node_14))->args);
		  arg1786_1099 =
		     make_local_svar_name_219_cgen_cgen(
		     CNST_TABLE_REF(((long) 0)),
		     (type_bglt) (_obj__252_type_cache));
		  old_actuals_174_1090 = arg1784_1097;
		  args_type_205_1091 = args_type_205_1088;
		  new_actuals_73_1092 = BNIL;
		  aux_1093 = arg1786_1099;
		  auxs_1094 = BNIL;
		  exps_1095 = BNIL;
		loop_1096:
		  if (
		     NULLP(old_actuals_174_1090))
		    {	/* Cgen/capp.scm 306 */
		       if (
			  NULLP(auxs_1094))
			 {	/* Cgen/capp.scm 309 */
			    capp_bglt arg1791_1104;
			    {	/* Cgen/capp.scm 309 */
			       obj_t arg1792_1105;
			       cop_bglt arg1793_1106;
			       obj_t arg1794_1107;
			       {	/* Cgen/capp.scm 309 */
				  node_bglt obj_2109;
				  obj_2109 =
				     (node_bglt) (node_14);
				  arg1792_1105 =
				     (((node_bglt) CREF(obj_2109))->loc);
			       }
			       {	/* Cgen/capp.scm 310 */
				  node_bglt aux_3168;
				  {	/* Cgen/capp.scm 310 */
				     var_bglt aux_3169;
				     aux_3169 =
					(((app_bglt) CREF(node_14))->fun);
				     aux_3168 =
					(node_bglt) (aux_3169);
				  }
				  arg1793_1106 =
				     node__cop_142_cgen_cgen(aux_3168, _id_kont__126_cgen_cgen);
			       }
			       arg1794_1107 =
				  reverse__39___r4_pairs_and_lists_6_3(new_actuals_73_1092);
			       {	/* Cgen/capp.scm 308 */
				  capp_bglt res2252_2121;
				  {	/* ./Cgen/cop.scm 1506 */
				     capp_bglt new1557_2114;
				     new1557_2114 =
					((capp_bglt) BREF(GC_MALLOC(sizeof(struct capp))));
				     {	/* ./Cgen/cop.scm 1506 */
					long arg1940_2115;
					arg1940_2115 =
					   class_num_218___object(capp_cgen_cop);
					{	/* ./Cgen/cop.scm 1506 */
					   obj_t obj_2119;
					   obj_2119 =
					      (obj_t) (new1557_2114);
					   (((obj_t) CREF(obj_2119))->header = MAKE_HEADER(arg1940_2115, 0), BUNSPEC);
					}
				     }
				     {	/* ./Cgen/cop.scm 1506 */
					object_bglt aux_3178;
					aux_3178 =
					   (object_bglt) (new1557_2114);
					OBJECT_WIDENING_SET(aux_3178, BFALSE);
				     }
				     ((((capp_bglt) CREF(new1557_2114))->loc) = ((obj_t) arg1792_1105), BUNSPEC);
				     ((((capp_bglt) CREF(new1557_2114))->fun) = ((cop_bglt) arg1793_1106), BUNSPEC);
				     ((((capp_bglt) CREF(new1557_2114))->args) = ((obj_t) arg1794_1107), BUNSPEC);
				     res2252_2121 = new1557_2114;
				  }
				  arg1791_1104 = res2252_2121;
			       }
			    }
			    return
			       PROCEDURE_ENTRY(kont_15) (kont_15,
			       (obj_t) (arg1791_1104), BEOA);
			 }
		       else
			 {	/* Cgen/capp.scm 316 */
			    obj_t loc_1109;
			    loc_1109 =
			       (((app_bglt) CREF(node_14))->loc);
			    {	/* Cgen/capp.scm 317 */
			       csequence_bglt arg1797_1111;
			       {	/* Cgen/capp.scm 319 */
				  obj_t arg1800_1113;
				  {	/* Cgen/capp.scm 323 */
				     local_var_164_bglt arg1801_1114;
				     csequence_bglt arg1802_1115;
				     obj_t arg1803_1116;
				     {	/* Cgen/capp.scm 323 */
					local_var_164_bglt res2253_2131;
					{	/* ./Cgen/cop.scm 1494 */
					   local_var_164_bglt new1536_2125;
					   new1536_2125 =
					      ((local_var_164_bglt) BREF(GC_MALLOC(sizeof(struct local_var_164))));
					   {	/* ./Cgen/cop.scm 1494 */
					      long arg1946_2126;
					      arg1946_2126 =
						 class_num_218___object(local_var_164_cgen_cop);
					      {		/* ./Cgen/cop.scm 1494 */
						 obj_t obj_2129;
						 obj_2129 =
						    (obj_t) (new1536_2125);
						 (((obj_t) CREF(obj_2129))->header = MAKE_HEADER(arg1946_2126, 0), BUNSPEC);
					      }
					   }
					   {	/* ./Cgen/cop.scm 1494 */
					      object_bglt aux_3192;
					      aux_3192 =
						 (object_bglt) (new1536_2125);
					      OBJECT_WIDENING_SET(aux_3192, BFALSE);
					   }
					   ((((local_var_164_bglt) CREF(new1536_2125))->loc) = ((obj_t) loc_1109), BUNSPEC);
					   ((((local_var_164_bglt) CREF(new1536_2125))->vars) = ((obj_t) auxs_1094), BUNSPEC);
					   res2253_2131 = new1536_2125;
					}
					arg1801_1114 = res2253_2131;
				     }
				     {	/* Cgen/capp.scm 326 */
					csequence_bglt res2254_2142;
					{	/* ./Cgen/cop.scm 1476 */
					   csequence_bglt new1503_2135;
					   new1503_2135 =
					      ((csequence_bglt) BREF(GC_MALLOC(sizeof(struct csequence))));
					   {	/* ./Cgen/cop.scm 1476 */
					      long arg1957_2136;
					      arg1957_2136 =
						 class_num_218___object(csequence_cgen_cop);
					      {		/* ./Cgen/cop.scm 1476 */
						 obj_t obj_2140;
						 obj_2140 =
						    (obj_t) (new1503_2135);
						 (((obj_t) CREF(obj_2140))->header = MAKE_HEADER(arg1957_2136, 0), BUNSPEC);
					      }
					   }
					   {	/* ./Cgen/cop.scm 1476 */
					      object_bglt aux_3201;
					      aux_3201 =
						 (object_bglt) (new1503_2135);
					      OBJECT_WIDENING_SET(aux_3201, BFALSE);
					   }
					   ((((csequence_bglt) CREF(new1503_2135))->loc) = ((obj_t) loc_1109), BUNSPEC);
					   ((((csequence_bglt) CREF(new1503_2135))->c_exp__163) = ((bool_t) ((bool_t) 0)), BUNSPEC);
					   ((((csequence_bglt) CREF(new1503_2135))->cops) = ((obj_t) exps_1095), BUNSPEC);
					   res2254_2142 = new1503_2135;
					}
					arg1802_1115 = res2254_2142;
				     }
				     {	/* Cgen/capp.scm 329 */
					capp_bglt arg1812_1124;
					{	/* Cgen/capp.scm 329 */
					   cop_bglt arg1814_1126;
					   obj_t arg1815_1127;
					   {	/* Cgen/capp.scm 331 */
					      node_bglt aux_3207;
					      {		/* Cgen/capp.scm 331 */
						 var_bglt aux_3208;
						 aux_3208 =
						    (((app_bglt) CREF(node_14))->fun);
						 aux_3207 =
						    (node_bglt) (aux_3208);
					      }
					      arg1814_1126 =
						 node__cop_142_cgen_cgen(aux_3207, _id_kont__126_cgen_cgen);
					   }
					   arg1815_1127 =
					      reverse__39___r4_pairs_and_lists_6_3(new_actuals_73_1092);
					   {	/* Cgen/capp.scm 329 */
					      capp_bglt res2255_2154;
					      {		/* ./Cgen/cop.scm 1506 */
						 capp_bglt new1557_2147;
						 new1557_2147 =
						    ((capp_bglt) BREF(GC_MALLOC(sizeof(struct capp))));
						 {	/* ./Cgen/cop.scm 1506 */
						    long arg1940_2148;
						    arg1940_2148 =
						       class_num_218___object(capp_cgen_cop);
						    {	/* ./Cgen/cop.scm 1506 */
						       obj_t obj_2152;
						       obj_2152 =
							  (obj_t) (new1557_2147);
						       (((obj_t) CREF(obj_2152))->header = MAKE_HEADER(arg1940_2148, 0), BUNSPEC);
						    }
						 }
						 {	/* ./Cgen/cop.scm 1506 */
						    object_bglt aux_3217;
						    aux_3217 =
						       (object_bglt) (new1557_2147);
						    OBJECT_WIDENING_SET(aux_3217, BFALSE);
						 }
						 ((((capp_bglt) CREF(new1557_2147))->loc) = ((obj_t) loc_1109), BUNSPEC);
						 ((((capp_bglt) CREF(new1557_2147))->fun) = ((cop_bglt) arg1814_1126), BUNSPEC);
						 ((((capp_bglt) CREF(new1557_2147))->args) = ((obj_t) arg1815_1127), BUNSPEC);
						 res2255_2154 = new1557_2147;
					      }
					      arg1812_1124 = res2255_2154;
					   }
					}
					arg1803_1116 =
					   PROCEDURE_ENTRY(kont_15) (kont_15,
					   (obj_t) (arg1812_1124), BEOA);
				     }
				     {	/* Cgen/capp.scm 321 */
					obj_t list1804_1117;
					{	/* Cgen/capp.scm 321 */
					   obj_t arg1805_1118;
					   {	/* Cgen/capp.scm 321 */
					      obj_t arg1806_1119;
					      arg1806_1119 =
						 MAKE_PAIR(arg1803_1116, BNIL);
					      {		/* Cgen/capp.scm 321 */
						 obj_t aux_3227;
						 aux_3227 =
						    (obj_t) (arg1802_1115);
						 arg1805_1118 =
						    MAKE_PAIR(aux_3227, arg1806_1119);
					      }
					   }
					   {	/* Cgen/capp.scm 321 */
					      obj_t aux_3230;
					      aux_3230 =
						 (obj_t) (arg1801_1114);
					      list1804_1117 =
						 MAKE_PAIR(aux_3230, arg1805_1118);
					   }
					}
					arg1800_1113 = list1804_1117;
				     }
				  }
				  {	/* Cgen/capp.scm 319 */
				     csequence_bglt res2256_2166;
				     {	/* ./Cgen/cop.scm 1476 */
					csequence_bglt new1503_2159;
					new1503_2159 =
					   ((csequence_bglt) BREF(GC_MALLOC(sizeof(struct csequence))));
					{	/* ./Cgen/cop.scm 1476 */
					   long arg1957_2160;
					   arg1957_2160 =
					      class_num_218___object(csequence_cgen_cop);
					   {	/* ./Cgen/cop.scm 1476 */
					      obj_t obj_2164;
					      obj_2164 =
						 (obj_t) (new1503_2159);
					      (((obj_t) CREF(obj_2164))->header = MAKE_HEADER(arg1957_2160, 0), BUNSPEC);
					   }
					}
					{	/* ./Cgen/cop.scm 1476 */
					   object_bglt aux_3237;
					   aux_3237 =
					      (object_bglt) (new1503_2159);
					   OBJECT_WIDENING_SET(aux_3237, BFALSE);
					}
					((((csequence_bglt) CREF(new1503_2159))->loc) = ((obj_t) loc_1109), BUNSPEC);
					((((csequence_bglt) CREF(new1503_2159))->c_exp__163) = ((bool_t) ((bool_t) 0)), BUNSPEC);
					((((csequence_bglt) CREF(new1503_2159))->cops) = ((obj_t) arg1800_1113), BUNSPEC);
					res2256_2166 = new1503_2159;
				     }
				     arg1797_1111 = res2256_2166;
				  }
			       }
			       {	/* Cgen/capp.scm 317 */
				  block_bglt res2257_2175;
				  {	/* Cgen/capp.scm 317 */
				     cop_bglt body_2168;
				     body_2168 =
					(cop_bglt) (arg1797_1111);
				     {	/* ./Cgen/cop.scm 1453 */
					block_bglt new1459_2169;
					new1459_2169 =
					   ((block_bglt) BREF(GC_MALLOC(sizeof(struct block))));
					{	/* ./Cgen/cop.scm 1453 */
					   long arg1971_2170;
					   arg1971_2170 =
					      class_num_218___object(block_cgen_cop);
					   {	/* ./Cgen/cop.scm 1453 */
					      obj_t obj_2173;
					      obj_2173 =
						 (obj_t) (new1459_2169);
					      (((obj_t) CREF(obj_2173))->header = MAKE_HEADER(arg1971_2170, 0), BUNSPEC);
					   }
					}
					{	/* ./Cgen/cop.scm 1453 */
					   object_bglt aux_3248;
					   aux_3248 =
					      (object_bglt) (new1459_2169);
					   OBJECT_WIDENING_SET(aux_3248, BFALSE);
					}
					((((block_bglt) CREF(new1459_2169))->loc) = ((obj_t) loc_1109), BUNSPEC);
					((((block_bglt) CREF(new1459_2169))->body) = ((cop_bglt) body_2168), BUNSPEC);
					res2257_2175 = new1459_2169;
				     }
				  }
				  return
				     (obj_t) (res2257_2175);
			       }
			    }
			 }
		    }
		  else
		    {	/* Cgen/capp.scm 334 */
		       cop_bglt cop_1129;
		       {	/* Cgen/capp.scm 334 */
			  setq_bglt arg1843_1152;
			  {	/* Cgen/capp.scm 334 */
			     node_bglt aux_3254;
			     {	/* Cgen/capp.scm 334 */
				obj_t aux_3256;
				aux_3256 =
				   CAR(old_actuals_174_1090);
				aux_3254 =
				   (node_bglt) (aux_3256);
			     }
			     arg1843_1152 =
				node_setq_243_cgen_cgen(
				(variable_bglt) (aux_1093), aux_3254);
			  }
			  cop_1129 =
			     node__cop_142_cgen_cgen(
			     (node_bglt) (arg1843_1152), _id_kont__126_cgen_cgen);
		       }
		       {	/* Cgen/capp.scm 335 */
			  bool_t test_3262;
			  cop_1155 = cop_1129;
			  aux_1156 = aux_1093;
			  {	/* Cgen/capp.scm 296 */
			     bool_t _andtest_1687_1158;
			     _andtest_1687_1158 =
				is_a__118___object(
				(obj_t) (cop_1155), csetq_cgen_cop);
			     if (_andtest_1687_1158)
			       {	/* Cgen/capp.scm 297 */
				  bool_t test_3266;
				  {	/* ./Ieee/equiv.scm 5508 */
				     obj_t aux_3273;
				     obj_t aux_3267;
				     aux_3273 =
					(obj_t) (aux_1156);
				     {	/* Cgen/capp.scm 297 */
					variable_bglt aux_3268;
					{	/* Cgen/capp.scm 297 */
					   varc_bglt arg1850_1164;
					   {	/* Cgen/capp.scm 297 */
					      csetq_bglt obj_2210;
					      obj_2210 =
						 (csetq_bglt) (cop_1155);
					      arg1850_1164 =
						 (((csetq_bglt) CREF(obj_2210))->var);
					   }
					   aux_3268 =
					      (((varc_bglt) CREF(arg1850_1164))->variable);
					}
					aux_3267 =
					   (obj_t) (aux_3268);
				     }
				     test_3266 =
					(aux_3267 == aux_3273);
				  }
				  if (test_3266)
				    {	/* Cgen/capp.scm 298 */
				       bool_t _ortest_1689_1160;
				       {	/* ./Cgen/cop.scm 1462 */
					  obj_t aux_3276;
					  {	/* Cgen/capp.scm 298 */
					     cop_bglt aux_3277;
					     {	/* Cgen/capp.scm 298 */
						csetq_bglt obj_2214;
						obj_2214 =
						   (csetq_bglt) (cop_1155);
						aux_3277 =
						   (((csetq_bglt) CREF(obj_2214))->value);
					     }
					     aux_3276 =
						(obj_t) (aux_3277);
					  }
					  _ortest_1689_1160 =
					     is_a__118___object(aux_3276, catom_cgen_cop);
				       }
				       if (_ortest_1689_1160)
					 {	/* Cgen/capp.scm 298 */
					    test_3262 = _ortest_1689_1160
					       ;
					 }
				       else
					 {	/* ./Cgen/cop.scm 1465 */
					    obj_t aux_3283;
					    {	/* Cgen/capp.scm 299 */
					       cop_bglt aux_3284;
					       {	/* Cgen/capp.scm 299 */
						  csetq_bglt obj_2216;
						  obj_2216 =
						     (csetq_bglt) (cop_1155);
						  aux_3284 =
						     (((csetq_bglt) CREF(obj_2216))->value);
					       }
					       aux_3283 =
						  (obj_t) (aux_3284);
					    }
					    test_3262 =
					       is_a__118___object(aux_3283, varc_cgen_cop);
					 }
				    }
				  else
				    {	/* Cgen/capp.scm 297 */
				       test_3262 = ((bool_t) 0)
					  ;
				    }
			       }
			     else
			       {	/* Cgen/capp.scm 296 */
				  test_3262 = ((bool_t) 0)
				     ;
			       }
			  }
			  if (test_3262)
			    {	/* Cgen/capp.scm 336 */
			       obj_t arg1818_1131;
			       obj_t arg1820_1132;
			       obj_t arg1821_1133;
			       arg1818_1131 =
				  CDR(old_actuals_174_1090);
			       {	/* Cgen/capp.scm 337 */
				  bool_t test_3290;
				  {	/* ./Ieee/pair-list.scm 5912 */
				     obj_t aux_3291;
				     aux_3291 =
					CDR(args_type_205_1091);
				     test_3290 =
					NULLP(aux_3291);
				  }
				  if (test_3290)
				    {	/* Cgen/capp.scm 337 */
				       arg1820_1132 = args_type_205_1091;
				    }
				  else
				    {	/* Cgen/capp.scm 337 */
				       arg1820_1132 =
					  CDR(args_type_205_1091);
				    }
			       }
			       {	/* ./Ieee/pair-list.scm 5689 */
				  obj_t aux_3295;
				  {	/* Cgen/capp.scm 340 */
				     cop_bglt aux_3296;
				     {	/* Cgen/capp.scm 340 */
					csetq_bglt obj_2181;
					obj_2181 =
					   (csetq_bglt) (cop_1129);
					aux_3296 =
					   (((csetq_bglt) CREF(obj_2181))->value);
				     }
				     aux_3295 =
					(obj_t) (aux_3296);
				  }
				  arg1821_1133 =
				     MAKE_PAIR(aux_3295, new_actuals_73_1092);
			       }
			       {
				  obj_t new_actuals_73_3303;
				  obj_t args_type_205_3302;
				  obj_t old_actuals_174_3301;
				  old_actuals_174_3301 = arg1818_1131;
				  args_type_205_3302 = arg1820_1132;
				  new_actuals_73_3303 = arg1821_1133;
				  new_actuals_73_1092 = new_actuals_73_3303;
				  args_type_205_1091 = args_type_205_3302;
				  old_actuals_174_1090 = old_actuals_174_3301;
				  goto loop_1096;
			       }
			    }
			  else
			    {	/* Cgen/capp.scm 335 */
			       {	/* Cgen/capp.scm 345 */
				  type_bglt val1082_2186;
				  {	/* Cgen/capp.scm 345 */
				     obj_t aux_3304;
				     aux_3304 =
					CAR(args_type_205_1091);
				     val1082_2186 =
					(type_bglt) (aux_3304);
				  }
				  ((((local_bglt) CREF(aux_1093))->type) = ((type_bglt) val1082_2186), BUNSPEC);
			       }
			       {	/* Cgen/capp.scm 346 */
				  obj_t arg1826_1138;
				  obj_t arg1827_1139;
				  obj_t arg1828_1140;
				  local_bglt arg1830_1141;
				  obj_t arg1831_1142;
				  obj_t arg1832_1143;
				  arg1826_1138 =
				     CDR(old_actuals_174_1090);
				  {	/* Cgen/capp.scm 347 */
				     bool_t test_3309;
				     {	/* ./Ieee/pair-list.scm 5912 */
					obj_t aux_3310;
					aux_3310 =
					   CDR(args_type_205_1091);
					test_3309 =
					   NULLP(aux_3310);
				     }
				     if (test_3309)
				       {	/* Cgen/capp.scm 347 */
					  arg1827_1139 = args_type_205_1091;
				       }
				     else
				       {	/* Cgen/capp.scm 347 */
					  arg1827_1139 =
					     CDR(args_type_205_1091);
				       }
				  }
				  {	/* Cgen/capp.scm 351 */
				     varc_bglt arg1835_1146;
				     {	/* Cgen/capp.scm 351 */
					obj_t arg1836_1147;
					{	/* Cgen/capp.scm 351 */
					   node_bglt obj_2192;
					   {	/* Cgen/capp.scm 351 */
					      obj_t aux_3314;
					      aux_3314 =
						 CAR(old_actuals_174_1090);
					      obj_2192 =
						 (node_bglt) (aux_3314);
					   }
					   arg1836_1147 =
					      (((node_bglt) CREF(obj_2192))->loc);
					}
					{	/* Cgen/capp.scm 350 */
					   varc_bglt res2258_2201;
					   {	/* Cgen/capp.scm 350 */
					      variable_bglt variable_2194;
					      variable_2194 =
						 (variable_bglt) (aux_1093);
					      {		/* ./Cgen/cop.scm 1465 */
						 varc_bglt new1483_2195;
						 new1483_2195 =
						    ((varc_bglt) BREF(GC_MALLOC(sizeof(struct varc))));
						 {	/* ./Cgen/cop.scm 1465 */
						    long arg1963_2196;
						    arg1963_2196 =
						       class_num_218___object(varc_cgen_cop);
						    {	/* ./Cgen/cop.scm 1465 */
						       obj_t obj_2199;
						       obj_2199 =
							  (obj_t) (new1483_2195);
						       (((obj_t) CREF(obj_2199))->header = MAKE_HEADER(arg1963_2196, 0), BUNSPEC);
						    }
						 }
						 {	/* ./Cgen/cop.scm 1465 */
						    object_bglt aux_3323;
						    aux_3323 =
						       (object_bglt) (new1483_2195);
						    OBJECT_WIDENING_SET(aux_3323, BFALSE);
						 }
						 ((((varc_bglt) CREF(new1483_2195))->loc) = ((obj_t) arg1836_1147), BUNSPEC);
						 ((((varc_bglt) CREF(new1483_2195))->variable) = ((variable_bglt) variable_2194), BUNSPEC);
						 res2258_2201 = new1483_2195;
					      }
					   }
					   arg1835_1146 = res2258_2201;
					}
				     }
				     {	/* ./Ieee/pair-list.scm 5689 */
					obj_t aux_3328;
					aux_3328 =
					   (obj_t) (arg1835_1146);
					arg1828_1140 =
					   MAKE_PAIR(aux_3328, new_actuals_73_1092);
				     }
				  }
				  {	/* Cgen/capp.scm 354 */
				     type_bglt aux_3331;
				     {	/* Cgen/capp.scm 354 */
					obj_t aux_3333;
					aux_3333 =
					   CAR(args_type_205_1091);
					aux_3331 =
					   (type_bglt) (aux_3333);
				     }
				     arg1830_1141 =
					make_local_svar_name_219_cgen_cgen(
					CNST_TABLE_REF(((long) 0)), aux_3331);
				  }
				  {	/* ./Ieee/pair-list.scm 5689 */
				     obj_t aux_3337;
				     aux_3337 =
					(obj_t) (aux_1093);
				     arg1831_1142 =
					MAKE_PAIR(aux_3337, auxs_1094);
				  }
				  {	/* ./Ieee/pair-list.scm 5689 */
				     obj_t aux_3340;
				     aux_3340 =
					(obj_t) (cop_1129);
				     arg1832_1143 =
					MAKE_PAIR(aux_3340, exps_1095);
				  }
				  {
				     obj_t exps_3348;
				     obj_t auxs_3347;
				     local_bglt aux_3346;
				     obj_t new_actuals_73_3345;
				     obj_t args_type_205_3344;
				     obj_t old_actuals_174_3343;
				     old_actuals_174_3343 = arg1826_1138;
				     args_type_205_3344 = arg1827_1139;
				     new_actuals_73_3345 = arg1828_1140;
				     aux_3346 = arg1830_1141;
				     auxs_3347 = arg1831_1142;
				     exps_3348 = arg1832_1143;
				     exps_1095 = exps_3348;
				     auxs_1094 = auxs_3347;
				     aux_1093 = aux_3346;
				     new_actuals_73_1092 = new_actuals_73_3345;
				     args_type_205_1091 = args_type_205_3344;
				     old_actuals_174_1090 = old_actuals_174_3343;
				     goto loop_1096;
				  }
			       }
			    }
		       }
		    }
	       }
	    }
	 }
      }
   }
}



/* node-tail-app->cop */
obj_t 
node_tail_app__cop_48_cgen_capp(variable_bglt var_16, app_bglt node_17, obj_t kont_18)
{
   AN_OBJECT;
   {	/* Cgen/capp.scm 366 */
      {		/* Cgen/capp.scm 367 */
	 clabel_bglt label_1166;
	 obj_t args_1167;
	 obj_t loc_1168;
	 {	/* Cgen/capp.scm 367 */
	    sfun_c_188_bglt obj_2219;
	    {	/* Cgen/capp.scm 367 */
	       value_bglt aux_3349;
	       aux_3349 =
		  (((variable_bglt) CREF(var_16))->value);
	       obj_2219 =
		  (sfun_c_188_bglt) (aux_3349);
	    }
	    {
	       obj_t aux_3352;
	       {	/* ./Cgen/cop.scm 1539 */
		  object_bglt aux_3353;
		  aux_3353 =
		     (object_bglt) (obj_2219);
		  aux_3352 =
		     OBJECT_WIDENING(aux_3353);
	       }
	       label_1166 =
		  (((sfun_c_188_bglt) CREF(aux_3352))->label);
	    }
	 }
	 {	/* Cgen/capp.scm 368 */
	    sfun_bglt obj_2221;
	    {	/* Cgen/capp.scm 368 */
	       value_bglt aux_3357;
	       aux_3357 =
		  (((variable_bglt) CREF(var_16))->value);
	       obj_2221 =
		  (sfun_bglt) (aux_3357);
	    }
	    args_1167 =
	       (((sfun_bglt) CREF(obj_2221))->args);
	 }
	 {	/* Cgen/capp.scm 369 */
	    node_bglt obj_2222;
	    obj_2222 =
	       (node_bglt) (node_17);
	    loc_1168 =
	       (((node_bglt) CREF(obj_2222))->loc);
	 }
	 {	/* Cgen/capp.scm 370 */
	    bool_t test_3363;
	    {	/* Cgen/capp.scm 370 */
	       sfun_c_188_bglt obj_2224;
	       {	/* Cgen/capp.scm 370 */
		  value_bglt aux_3364;
		  aux_3364 =
		     (((variable_bglt) CREF(var_16))->value);
		  obj_2224 =
		     (sfun_c_188_bglt) (aux_3364);
	       }
	       {
		  obj_t aux_3367;
		  {	/* ./Cgen/cop.scm 1538 */
		     object_bglt aux_3368;
		     aux_3368 =
			(object_bglt) (obj_2224);
		     aux_3367 =
			OBJECT_WIDENING(aux_3368);
		  }
		  test_3363 =
		     (((sfun_c_188_bglt) CREF(aux_3367))->integrated);
	       }
	    }
	    if (test_3363)
	      {		/* Cgen/capp.scm 370 */
		 if (
		    NULLP(args_1167))
		   {	/* Cgen/capp.scm 392 */
		      ((((clabel_bglt) CREF(label_1166))->used__226) = ((bool_t) ((bool_t) 1)), BUNSPEC);
		      {		/* Cgen/capp.scm 395 */
			 cgoto_bglt res2259_2236;
			 {	/* ./Cgen/cop.scm 1450 */
			    cgoto_bglt new1453_2230;
			    new1453_2230 =
			       ((cgoto_bglt) BREF(GC_MALLOC(sizeof(struct cgoto))));
			    {	/* ./Cgen/cop.scm 1450 */
			       long arg1973_2231;
			       arg1973_2231 =
				  class_num_218___object(cgoto_cgen_cop);
			       {	/* ./Cgen/cop.scm 1450 */
				  obj_t obj_2234;
				  obj_2234 =
				     (obj_t) (new1453_2230);
				  (((obj_t) CREF(obj_2234))->header = MAKE_HEADER(arg1973_2231, 0), BUNSPEC);
			       }
			    }
			    {	/* ./Cgen/cop.scm 1450 */
			       object_bglt aux_3379;
			       aux_3379 =
				  (object_bglt) (new1453_2230);
			       OBJECT_WIDENING_SET(aux_3379, BFALSE);
			    }
			    ((((cgoto_bglt) CREF(new1453_2230))->loc) = ((obj_t) loc_1168), BUNSPEC);
			    ((((cgoto_bglt) CREF(new1453_2230))->label) = ((clabel_bglt) label_1166), BUNSPEC);
			    res2259_2236 = new1453_2230;
			 }
			 return
			    (obj_t) (res2259_2236);
		      }
		   }
		 else
		   {
		      obj_t args_1173;
		      obj_t actuals_1174;
		      obj_t auxs_1175;
		      obj_t seq1_1176;
		      obj_t seq2_1177;
		      {		/* Cgen/capp.scm 399 */
			 obj_t arg1855_1179;
			 obj_t arg1858_1182;
			 arg1855_1179 =
			    (((app_bglt) CREF(node_17))->args);
			 {	/* Cgen/capp.scm 402 */
			    cgoto_bglt arg1859_1183;
			    ((((clabel_bglt) CREF(label_1166))->used__226) = ((bool_t) ((bool_t) 1)), BUNSPEC);
			    {	/* Cgen/capp.scm 404 */
			       cgoto_bglt res2260_2248;
			       {	/* ./Cgen/cop.scm 1450 */
				  cgoto_bglt new1453_2242;
				  new1453_2242 =
				     ((cgoto_bglt) BREF(GC_MALLOC(sizeof(struct cgoto))));
				  {	/* ./Cgen/cop.scm 1450 */
				     long arg1973_2243;
				     arg1973_2243 =
					class_num_218___object(cgoto_cgen_cop);
				     {	/* ./Cgen/cop.scm 1450 */
					obj_t obj_2246;
					obj_2246 =
					   (obj_t) (new1453_2242);
					(((obj_t) CREF(obj_2246))->header = MAKE_HEADER(arg1973_2243, 0), BUNSPEC);
				     }
				  }
				  {	/* ./Cgen/cop.scm 1450 */
				     object_bglt aux_3391;
				     aux_3391 =
					(object_bglt) (new1453_2242);
				     OBJECT_WIDENING_SET(aux_3391, BFALSE);
				  }
				  ((((cgoto_bglt) CREF(new1453_2242))->loc) = ((obj_t) loc_1168), BUNSPEC);
				  ((((cgoto_bglt) CREF(new1453_2242))->label) = ((clabel_bglt) label_1166), BUNSPEC);
				  res2260_2248 = new1453_2242;
			       }
			       arg1859_1183 = res2260_2248;
			    }
			    {	/* Cgen/capp.scm 402 */
			       obj_t list1860_1184;
			       {	/* Cgen/capp.scm 402 */
				  obj_t aux_3396;
				  aux_3396 =
				     (obj_t) (arg1859_1183);
				  list1860_1184 =
				     MAKE_PAIR(aux_3396, BNIL);
			       }
			       arg1858_1182 = list1860_1184;
			    }
			 }
			 args_1173 = args_1167;
			 actuals_1174 = arg1855_1179;
			 auxs_1175 = BNIL;
			 seq1_1176 = BNIL;
			 seq2_1177 = arg1858_1182;
		       loop_1178:
			 if (
			    NULLP(args_1173))
			   {	/* Cgen/capp.scm 407 */
			      {		/* Cgen/capp.scm 409 */
				 bool_t test1864_1188;
				 {	/* Cgen/capp.scm 409 */
				    obj_t obj_2251;
				    obj_2251 = seq1_1176;
				    test1864_1188 =
				       NULLP(obj_2251);
				 }
				 if (test1864_1188)
				   {	/* Cgen/capp.scm 409 */
				      seq1_1176 = seq2_1177;
				   }
				 else
				   {	/* Cgen/capp.scm 409 */
				      seq1_1176 =
					 reverse__39___r4_pairs_and_lists_6_3(seq1_1176);
				      {		/* Cgen/capp.scm 413 */
					 obj_t arg1865_1189;
					 arg1865_1189 =
					    last_pair_93___r4_pairs_and_lists_6_3(seq1_1176);
					 SET_CDR(arg1865_1189, seq2_1177);
				      }
				   }
			      }
			      {		/* Cgen/capp.scm 416 */
				 cop_bglt arg1866_1190;
				 {	/* Cgen/capp.scm 416 */
				    csequence_bglt arg1867_1191;
				    {	/* Cgen/capp.scm 416 */
				       obj_t arg1869_1193;
				       {	/* Cgen/capp.scm 418 */
					  local_var_164_bglt arg1870_1194;
					  {	/* Cgen/capp.scm 418 */
					     local_var_164_bglt res2261_2262;
					     {	/* ./Cgen/cop.scm 1494 */
						local_var_164_bglt new1536_2256;
						new1536_2256 =
						   ((local_var_164_bglt) BREF(GC_MALLOC(sizeof(struct local_var_164))));
						{	/* ./Cgen/cop.scm 1494 */
						   long arg1946_2257;
						   arg1946_2257 =
						      class_num_218___object(local_var_164_cgen_cop);
						   {	/* ./Cgen/cop.scm 1494 */
						      obj_t obj_2260;
						      obj_2260 =
							 (obj_t) (new1536_2256);
						      (((obj_t) CREF(obj_2260))->header = MAKE_HEADER(arg1946_2257, 0), BUNSPEC);
						   }
						}
						{	/* ./Cgen/cop.scm 1494 */
						   object_bglt aux_3410;
						   aux_3410 =
						      (object_bglt) (new1536_2256);
						   OBJECT_WIDENING_SET(aux_3410, BFALSE);
						}
						((((local_var_164_bglt) CREF(new1536_2256))->loc) = ((obj_t) loc_1168), BUNSPEC);
						((((local_var_164_bglt) CREF(new1536_2256))->vars) = ((obj_t) auxs_1175), BUNSPEC);
						res2261_2262 = new1536_2256;
					     }
					     arg1870_1194 = res2261_2262;
					  }
					  {	/* Cgen/capp.scm 418 */
					     obj_t obj2_2264;
					     obj2_2264 = seq1_1176;
					     {	/* ./Ieee/pair-list.scm 5689 */
						obj_t aux_3415;
						aux_3415 =
						   (obj_t) (arg1870_1194);
						arg1869_1193 =
						   MAKE_PAIR(aux_3415, obj2_2264);
					     }
					  }
				       }
				       {	/* Cgen/capp.scm 416 */
					  csequence_bglt res2262_2275;
					  {	/* ./Cgen/cop.scm 1476 */
					     csequence_bglt new1503_2268;
					     new1503_2268 =
						((csequence_bglt) BREF(GC_MALLOC(sizeof(struct csequence))));
					     {	/* ./Cgen/cop.scm 1476 */
						long arg1957_2269;
						arg1957_2269 =
						   class_num_218___object(csequence_cgen_cop);
						{	/* ./Cgen/cop.scm 1476 */
						   obj_t obj_2273;
						   obj_2273 =
						      (obj_t) (new1503_2268);
						   (((obj_t) CREF(obj_2273))->header = MAKE_HEADER(arg1957_2269, 0), BUNSPEC);
						}
					     }
					     {	/* ./Cgen/cop.scm 1476 */
						object_bglt aux_3422;
						aux_3422 =
						   (object_bglt) (new1503_2268);
						OBJECT_WIDENING_SET(aux_3422, BFALSE);
					     }
					     ((((csequence_bglt) CREF(new1503_2268))->loc) = ((obj_t) loc_1168), BUNSPEC);
					     ((((csequence_bglt) CREF(new1503_2268))->c_exp__163) = ((bool_t) ((bool_t) 0)), BUNSPEC);
					     ((((csequence_bglt) CREF(new1503_2268))->cops) = ((obj_t) arg1869_1193), BUNSPEC);
					     res2262_2275 = new1503_2268;
					  }
					  arg1867_1191 = res2262_2275;
				       }
				    }
				    arg1866_1190 =
				       bdb_let_var_254_cgen_cgen(
				       (cop_bglt) (arg1867_1191), loc_1168);
				 }
				 return
				    block_kont_197_cgen_cgen(
				    (obj_t) (arg1866_1190), BFALSE);
			      }
			   }
			 else
			   {	/* Cgen/capp.scm 424 */
			      obj_t arg_1197;
			      obj_t act_1198;
			      arg_1197 =
				 CAR(args_1173);
			      act_1198 =
				 CAR(actuals_1174);
			      {		/* Cgen/capp.scm 429 */
				 bool_t test1873_1199;
				 {	/* Cgen/capp.scm 429 */
				    bool_t test1895_1221;
				    test1895_1221 =
				       is_a__118___object(act_1198, var_ast_node);
				    if (test1895_1221)
				      {		/* ./Ieee/equiv.scm 5508 */
					 obj_t aux_3436;
					 {	/* Cgen/capp.scm 429 */
					    variable_bglt aux_3437;
					    {	/* Cgen/capp.scm 429 */
					       var_bglt obj_2279;
					       obj_2279 =
						  (var_bglt) (act_1198);
					       aux_3437 =
						  (((var_bglt) CREF(obj_2279))->variable);
					    }
					    aux_3436 =
					       (obj_t) (aux_3437);
					 }
					 test1873_1199 =
					    (arg_1197 == aux_3436);
				      }
				    else
				      {		/* Cgen/capp.scm 429 */
					 test1873_1199 = ((bool_t) 0);
				      }
				 }
				 if (test1873_1199)
				   {
				      obj_t actuals_3445;
				      obj_t args_3443;
				      args_3443 =
					 CDR(args_1173);
				      actuals_3445 =
					 CDR(actuals_1174);
				      actuals_1174 = actuals_3445;
				      args_1173 = args_3443;
				      goto loop_1178;
				   }
				 else
				   {	/* Cgen/capp.scm 435 */
				      local_bglt aux_1202;
				      {		/* Cgen/capp.scm 435 */
					 type_bglt aux_3450;
					 obj_t aux_3447;
					 {	/* Cgen/capp.scm 437 */
					    local_bglt obj_2285;
					    obj_2285 =
					       (local_bglt) (arg_1197);
					    aux_3450 =
					       (((local_bglt) CREF(obj_2285))->type);
					 }
					 {	/* Cgen/capp.scm 436 */
					    local_bglt obj_2284;
					    obj_2284 =
					       (local_bglt) (arg_1197);
					    aux_3447 =
					       (((local_bglt) CREF(obj_2284))->id);
					 }
					 aux_1202 =
					    make_local_svar_name_219_cgen_cgen(aux_3447, aux_3450);
				      }
				      {		/* Cgen/capp.scm 438 */
					 obj_t arg1876_1203;
					 obj_t arg1877_1204;
					 obj_t arg1879_1205;
					 obj_t arg1880_1206;
					 obj_t arg1881_1207;
					 arg1876_1203 =
					    CDR(args_1173);
					 arg1877_1204 =
					    CDR(actuals_1174);
					 {	/* ./Ieee/pair-list.scm 5689 */
					    obj_t aux_3456;
					    aux_3456 =
					       (obj_t) (aux_1202);
					    arg1879_1205 =
					       MAKE_PAIR(aux_3456, auxs_1175);
					 }
					 {	/* Cgen/capp.scm 441 */
					    cop_bglt arg1882_1208;
					    {	/* Cgen/capp.scm 441 */
					       setq_bglt arg1883_1209;
					       arg1883_1209 =
						  node_setq_243_cgen_cgen(
						  (variable_bglt) (aux_1202),
						  (node_bglt) (act_1198));
					       arg1882_1208 =
						  node__cop_142_cgen_cgen(
						  (node_bglt) (arg1883_1209), _stop_kont__121_cgen_cgen);
					    }
					    {	/* Cgen/capp.scm 441 */
					       obj_t obj2_2291;
					       obj2_2291 = seq1_1176;
					       {	/* ./Ieee/pair-list.scm 5689 */
						  obj_t aux_3464;
						  aux_3464 =
						     (obj_t) (arg1882_1208);
						  arg1880_1206 =
						     MAKE_PAIR(aux_3464, obj2_2291);
					       }
					    }
					 }
					 {	/* Cgen/capp.scm 446 */
					    stop_bglt arg1884_1210;
					    {	/* Cgen/capp.scm 446 */
					       obj_t arg1885_1211;
					       csetq_bglt arg1886_1212;
					       {	/* Cgen/capp.scm 446 */
						  node_bglt obj_2292;
						  obj_2292 =
						     (node_bglt) (act_1198);
						  arg1885_1211 =
						     (((node_bglt) CREF(obj_2292))->loc);
					       }
					       {	/* Cgen/capp.scm 447 */
						  varc_bglt arg1888_1214;
						  varc_bglt arg1889_1215;
						  {	/* Cgen/capp.scm 450 */
						     varc_bglt res2263_2301;
						     {	/* Cgen/capp.scm 450 */
							obj_t loc_2293;
							variable_bglt variable_2294;
							loc_2293 = BFALSE;
							variable_2294 =
							   (variable_bglt) (arg_1197);
							{	/* ./Cgen/cop.scm 1465 */
							   varc_bglt new1483_2295;
							   new1483_2295 =
							      ((varc_bglt) BREF(GC_MALLOC(sizeof(struct varc))));
							   {	/* ./Cgen/cop.scm 1465 */
							      long arg1963_2296;
							      arg1963_2296 =
								 class_num_218___object(varc_cgen_cop);
							      {		/* ./Cgen/cop.scm 1465 */
								 obj_t obj_2299;
								 obj_2299 =
								    (obj_t) (new1483_2295);
								 (((obj_t) CREF(obj_2299))->header = MAKE_HEADER(arg1963_2296, 0), BUNSPEC);
							      }
							   }
							   {	/* ./Cgen/cop.scm 1465 */
							      object_bglt aux_3474;
							      aux_3474 =
								 (object_bglt) (new1483_2295);
							      OBJECT_WIDENING_SET(aux_3474, loc_2293);
							   }
							   ((((varc_bglt) CREF(new1483_2295))->loc) = ((obj_t) loc_2293), BUNSPEC);
							   ((((varc_bglt) CREF(new1483_2295))->variable) = ((variable_bglt) variable_2294), BUNSPEC);
							   res2263_2301 = new1483_2295;
							}
						     }
						     arg1888_1214 = res2263_2301;
						  }
						  {	/* Cgen/capp.scm 453 */
						     obj_t arg1891_1217;
						     {	/* Cgen/capp.scm 453 */
							node_bglt obj_2302;
							obj_2302 =
							   (node_bglt) (act_1198);
							arg1891_1217 =
							   (((node_bglt) CREF(obj_2302))->loc);
						     }
						     {	/* Cgen/capp.scm 452 */
							varc_bglt res2264_2311;
							{	/* Cgen/capp.scm 452 */
							   variable_bglt variable_2304;
							   variable_2304 =
							      (variable_bglt) (aux_1202);
							   {	/* ./Cgen/cop.scm 1465 */
							      varc_bglt new1483_2305;
							      new1483_2305 =
								 ((varc_bglt) BREF(GC_MALLOC(sizeof(struct varc))));
							      {		/* ./Cgen/cop.scm 1465 */
								 long arg1963_2306;
								 arg1963_2306 =
								    class_num_218___object(varc_cgen_cop);
								 {	/* ./Cgen/cop.scm 1465 */
								    obj_t obj_2309;
								    obj_2309 =
								       (obj_t) (new1483_2305);
								    (((obj_t) CREF(obj_2309))->header = MAKE_HEADER(arg1963_2306, 0), BUNSPEC);
								 }
							      }
							      {		/* ./Cgen/cop.scm 1465 */
								 object_bglt aux_3486;
								 aux_3486 =
								    (object_bglt) (new1483_2305);
								 OBJECT_WIDENING_SET(aux_3486, BFALSE);
							      }
							      ((((varc_bglt) CREF(new1483_2305))->loc) = ((obj_t) arg1891_1217), BUNSPEC);
							      ((((varc_bglt) CREF(new1483_2305))->variable) = ((variable_bglt) variable_2304), BUNSPEC);
							      res2264_2311 = new1483_2305;
							   }
							}
							arg1889_1215 = res2264_2311;
						     }
						  }
						  {	/* Cgen/capp.scm 447 */
						     csetq_bglt res2265_2322;
						     {	/* Cgen/capp.scm 447 */
							cop_bglt value_2314;
							value_2314 =
							   (cop_bglt) (arg1889_1215);
							{	/* ./Cgen/cop.scm 1485 */
							   csetq_bglt new1521_2315;
							   new1521_2315 =
							      ((csetq_bglt) BREF(GC_MALLOC(sizeof(struct csetq))));
							   {	/* ./Cgen/cop.scm 1485 */
							      long arg1951_2316;
							      arg1951_2316 =
								 class_num_218___object(csetq_cgen_cop);
							      {		/* ./Cgen/cop.scm 1485 */
								 obj_t obj_2320;
								 obj_2320 =
								    (obj_t) (new1521_2315);
								 (((obj_t) CREF(obj_2320))->header = MAKE_HEADER(arg1951_2316, 0), BUNSPEC);
							      }
							   }
							   {	/* ./Cgen/cop.scm 1485 */
							      object_bglt aux_3496;
							      aux_3496 =
								 (object_bglt) (new1521_2315);
							      OBJECT_WIDENING_SET(aux_3496, BFALSE);
							   }
							   ((((csetq_bglt) CREF(new1521_2315))->loc) = ((obj_t) loc_1168), BUNSPEC);
							   ((((csetq_bglt) CREF(new1521_2315))->var) = ((varc_bglt) arg1888_1214), BUNSPEC);
							   ((((csetq_bglt) CREF(new1521_2315))->value) = ((cop_bglt) value_2314), BUNSPEC);
							   res2265_2322 = new1521_2315;
							}
						     }
						     arg1886_1212 = res2265_2322;
						  }
					       }
					       {	/* Cgen/capp.scm 445 */
						  stop_bglt res2266_2331;
						  {	/* Cgen/capp.scm 445 */
						     cop_bglt value_2324;
						     value_2324 =
							(cop_bglt) (arg1886_1212);
						     {	/* ./Cgen/cop.scm 1482 */
							stop_bglt new1515_2325;
							new1515_2325 =
							   ((stop_bglt) BREF(GC_MALLOC(sizeof(struct stop))));
							{	/* ./Cgen/cop.scm 1482 */
							   long arg1953_2326;
							   arg1953_2326 =
							      class_num_218___object(stop_cgen_cop);
							   {	/* ./Cgen/cop.scm 1482 */
							      obj_t obj_2329;
							      obj_2329 =
								 (obj_t) (new1515_2325);
							      (((obj_t) CREF(obj_2329))->header = MAKE_HEADER(arg1953_2326, 0), BUNSPEC);
							   }
							}
							{	/* ./Cgen/cop.scm 1482 */
							   object_bglt aux_3507;
							   aux_3507 =
							      (object_bglt) (new1515_2325);
							   OBJECT_WIDENING_SET(aux_3507, BFALSE);
							}
							((((stop_bglt) CREF(new1515_2325))->loc) = ((obj_t) arg1885_1211), BUNSPEC);
							((((stop_bglt) CREF(new1515_2325))->value) = ((cop_bglt) value_2324), BUNSPEC);
							res2266_2331 = new1515_2325;
						     }
						  }
						  arg1884_1210 = res2266_2331;
					       }
					    }
					    {	/* ./Ieee/pair-list.scm 5689 */
					       obj_t aux_3512;
					       aux_3512 =
						  (obj_t) (arg1884_1210);
					       arg1881_1207 =
						  MAKE_PAIR(aux_3512, seq2_1177);
					    }
					 }
					 {
					    obj_t seq2_3519;
					    obj_t seq1_3518;
					    obj_t auxs_3517;
					    obj_t actuals_3516;
					    obj_t args_3515;
					    args_3515 = arg1876_1203;
					    actuals_3516 = arg1877_1204;
					    auxs_3517 = arg1879_1205;
					    seq1_3518 = arg1880_1206;
					    seq2_3519 = arg1881_1207;
					    seq2_1177 = seq2_3519;
					    seq1_1176 = seq1_3518;
					    auxs_1175 = auxs_3517;
					    actuals_1174 = actuals_3516;
					    args_1173 = args_3515;
					    goto loop_1178;
					 }
				      }
				   }
			      }
			   }
		      }
		   }
	      }
	    else
	      {		/* Cgen/capp.scm 370 */
		 {	/* Cgen/capp.scm 372 */
		    sfun_c_188_bglt obj_2335;
		    {	/* Cgen/capp.scm 372 */
		       value_bglt aux_3520;
		       aux_3520 =
			  (((variable_bglt) CREF(var_16))->value);
		       obj_2335 =
			  (sfun_c_188_bglt) (aux_3520);
		    }
		    {
		       obj_t aux_3523;
		       {	/* ./Cgen/cop.scm 1538 */
			  object_bglt aux_3524;
			  aux_3524 =
			     (object_bglt) (obj_2335);
			  aux_3523 =
			     OBJECT_WIDENING(aux_3524);
		       }
		       ((((sfun_c_188_bglt) CREF(aux_3523))->integrated) = ((bool_t) ((bool_t) 1)), BUNSPEC);
		    }
		 }
		 {	/* Cgen/capp.scm 373 */
		    cop_bglt body_1224;
		    {	/* Cgen/capp.scm 373 */
		       node_bglt aux_3528;
		       {	/* Cgen/capp.scm 373 */
			  obj_t aux_3529;
			  {	/* Cgen/capp.scm 373 */
			     sfun_bglt obj_2338;
			     {	/* Cgen/capp.scm 373 */
				value_bglt aux_3530;
				{	/* Cgen/capp.scm 373 */
				   local_bglt obj_2337;
				   obj_2337 =
				      (local_bglt) (var_16);
				   aux_3530 =
				      (((local_bglt) CREF(obj_2337))->value);
				}
				obj_2338 =
				   (sfun_bglt) (aux_3530);
			     }
			     aux_3529 =
				(((sfun_bglt) CREF(obj_2338))->body);
			  }
			  aux_3528 =
			     (node_bglt) (aux_3529);
		       }
		       body_1224 =
			  node__cop_142_cgen_cgen(aux_3528, kont_18);
		    }
		    {	/* Cgen/capp.scm 374 */
		       obj_t val1444_2340;
		       val1444_2340 =
			  (obj_t) (body_1224);
		       ((((clabel_bglt) CREF(label_1166))->body) = ((obj_t) val1444_2340), BUNSPEC);
		    }
		    if (
		       NULLP(args_1167))
		      {		/* Cgen/capp.scm 375 */
			 return
			    (obj_t) (label_1166);
		      }
		    else
		      {
			 obj_t formals_1226;
			 obj_t actuals_1227;
			 obj_t seq_1228;
			 {	/* Cgen/capp.scm 377 */
			    csequence_bglt aux_3542;
			    formals_1226 = args_1167;
			    actuals_1227 =
			       (((app_bglt) CREF(node_17))->args);
			    seq_1228 = BNIL;
			  loop_1229:
			    if (
			       NULLP(formals_1226))
			      {		/* Cgen/capp.scm 381 */
				 obj_t arg1903_1234;
				 {	/* Cgen/capp.scm 383 */
				    obj_t arg1904_1235;
				    {	/* ./Ieee/pair-list.scm 5689 */
				       obj_t aux_3545;
				       aux_3545 =
					  (obj_t) (label_1166);
				       arg1904_1235 =
					  MAKE_PAIR(aux_3545, seq_1228);
				    }
				    arg1903_1234 =
				       reverse__39___r4_pairs_and_lists_6_3(arg1904_1235);
				 }
				 {	/* Cgen/capp.scm 381 */
				    csequence_bglt res2267_2356;
				    {	/* ./Cgen/cop.scm 1476 */
				       csequence_bglt new1503_2349;
				       new1503_2349 =
					  ((csequence_bglt) BREF(GC_MALLOC(sizeof(struct csequence))));
				       {	/* ./Cgen/cop.scm 1476 */
					  long arg1957_2350;
					  arg1957_2350 =
					     class_num_218___object(csequence_cgen_cop);
					  {	/* ./Cgen/cop.scm 1476 */
					     obj_t obj_2354;
					     obj_2354 =
						(obj_t) (new1503_2349);
					     (((obj_t) CREF(obj_2354))->header = MAKE_HEADER(arg1957_2350, 0), BUNSPEC);
					  }
				       }
				       {	/* ./Cgen/cop.scm 1476 */
					  object_bglt aux_3553;
					  aux_3553 =
					     (object_bglt) (new1503_2349);
					  OBJECT_WIDENING_SET(aux_3553, BFALSE);
				       }
				       ((((csequence_bglt) CREF(new1503_2349))->loc) = ((obj_t) loc_1168), BUNSPEC);
				       ((((csequence_bglt) CREF(new1503_2349))->c_exp__163) = ((bool_t) ((bool_t) 0)), BUNSPEC);
				       ((((csequence_bglt) CREF(new1503_2349))->cops) = ((obj_t) arg1903_1234), BUNSPEC);
				       res2267_2356 = new1503_2349;
				    }
				    aux_3542 = res2267_2356;
				 }
			      }
			    else
			      {		/* Cgen/capp.scm 384 */
				 obj_t arg1905_1236;
				 obj_t arg1906_1237;
				 obj_t arg1907_1238;
				 arg1905_1236 =
				    CDR(formals_1226);
				 arg1906_1237 =
				    CDR(actuals_1227);
				 {	/* Cgen/capp.scm 386 */
				    cop_bglt arg1909_1239;
				    {	/* Cgen/capp.scm 386 */
				       setq_bglt arg1910_1240;
				       {	/* Cgen/capp.scm 386 */
					  node_bglt aux_3565;
					  variable_bglt aux_3561;
					  {	/* Cgen/capp.scm 386 */
					     obj_t aux_3566;
					     aux_3566 =
						CAR(actuals_1227);
					     aux_3565 =
						(node_bglt) (aux_3566);
					  }
					  {	/* Cgen/capp.scm 386 */
					     obj_t aux_3562;
					     aux_3562 =
						CAR(formals_1226);
					     aux_3561 =
						(variable_bglt) (aux_3562);
					  }
					  arg1910_1240 =
					     node_setq_243_cgen_cgen(aux_3561, aux_3565);
				       }
				       arg1909_1239 =
					  node__cop_142_cgen_cgen(
					  (node_bglt) (arg1910_1240), _stop_kont__121_cgen_cgen);
				    }
				    {	/* ./Ieee/pair-list.scm 5689 */
				       obj_t aux_3572;
				       aux_3572 =
					  (obj_t) (arg1909_1239);
				       arg1907_1238 =
					  MAKE_PAIR(aux_3572, seq_1228);
				    }
				 }
				 {
				    obj_t seq_3577;
				    obj_t actuals_3576;
				    obj_t formals_3575;
				    formals_3575 = arg1905_1236;
				    actuals_3576 = arg1906_1237;
				    seq_3577 = arg1907_1238;
				    seq_1228 = seq_3577;
				    actuals_1227 = actuals_3576;
				    formals_1226 = formals_3575;
				    goto loop_1229;
				 }
			      }
			    return
			       (obj_t) (aux_3542);
			 }
		      }
		 }
	      }
	 }
      }
   }
}



/* method-init */
obj_t 
method_init_76_cgen_capp()
{
   AN_OBJECT;
   {	/* Cgen/capp.scm 14 */
      {		/* Cgen/capp.scm 14 */
	 obj_t node__cop_app_ly1707_225_2908;
	 node__cop_app_ly1707_225_2908 = proc2304_cgen_capp;
	 add_method__1___object(node__cop_env_160_cgen_cgen, app_ly_162_ast_node, node__cop_app_ly1707_225_2908);
      }
      {		/* Cgen/capp.scm 14 */
	 obj_t node__cop_funcall1709_218_2907;
	 node__cop_funcall1709_218_2907 = proc2305_cgen_capp;
	 add_method__1___object(node__cop_env_160_cgen_cgen, funcall_ast_node, node__cop_funcall1709_218_2907);
      }
      {		/* Cgen/capp.scm 14 */
	 obj_t node__cop_app1711_176_2906;
	 node__cop_app1711_176_2906 = proc2306_cgen_capp;
	 return
	    add_method__1___object(node__cop_env_160_cgen_cgen, app_ast_node, node__cop_app1711_176_2906);
      }
   }
}



/* node->cop-app1711 */
obj_t 
node__cop_app1711_176_cgen_capp(obj_t env_2909, obj_t node_2910, obj_t kont_2911)
{
   AN_OBJECT;
   {	/* Cgen/capp.scm 194 */
      {
	 app_bglt node_1963;
	 obj_t kont_1964;
	 node_1963 =
	    (app_bglt) (node_2910);
	 kont_1964 = kont_2911;
	 {	/* Cgen/capp.scm 198 */
	    variable_bglt var_1968;
	    {	/* Cgen/capp.scm 198 */
	       var_bglt arg2243_1974;
	       arg2243_1974 =
		  (((app_bglt) CREF(node_1963))->fun);
	       var_1968 =
		  (((var_bglt) CREF(arg2243_1974))->variable);
	    }
	    {	/* Cgen/capp.scm 199 */
	       bool_t test2239_1969;
	       {	/* Cgen/capp.scm 199 */
		  bool_t test2240_1970;
		  test2240_1970 =
		     is_a__118___object(
		     (obj_t) (var_1968), global_ast_var);
		  if (test2240_1970)
		    {	/* Cgen/capp.scm 200 */
		       bool_t _ortest_1673_1971;
		       {	/* Cgen/capp.scm 200 */
			  bool_t test2242_1973;
			  {	/* Cgen/capp.scm 200 */
			     obj_t obj2_2896;
			     obj2_2896 = _the_global__73_cgen_cgen;
			     {	/* ./Ieee/equiv.scm 5508 */
				obj_t aux_3588;
				aux_3588 =
				   (obj_t) (var_1968);
				test2242_1973 =
				   (aux_3588 == obj2_2896);
			     }
			  }
			  if (test2242_1973)
			    {	/* Cgen/capp.scm 200 */
			       _ortest_1673_1971 = ((bool_t) 0);
			    }
			  else
			    {	/* Cgen/capp.scm 200 */
			       _ortest_1673_1971 = ((bool_t) 1);
			    }
		       }
		       if (_ortest_1673_1971)
			 {	/* Cgen/capp.scm 200 */
			    test2239_1969 = _ortest_1673_1971;
			 }
		       else
			 {	/* Cgen/capp.scm 201 */
			    bool_t test2241_1972;
			    {	/* Cgen/capp.scm 201 */
			       obj_t obj2_2898;
			       obj2_2898 = _return_kont__110_cgen_cgen;
			       test2241_1972 =
				  (kont_1964 == obj2_2898);
			    }
			    if (test2241_1972)
			      {		/* Cgen/capp.scm 201 */
				 test2239_1969 = ((bool_t) 0);
			      }
			    else
			      {		/* Cgen/capp.scm 201 */
				 test2239_1969 = ((bool_t) 1);
			      }
			 }
		    }
		  else
		    {	/* Cgen/capp.scm 199 */
		       test2239_1969 = ((bool_t) 0);
		    }
	       }
	       if (test2239_1969)
		 {	/* Cgen/capp.scm 199 */
		    {	/* Cgen/capp.scm 214 */
		       bool_t test1712_2902;
		       {	/* ./Ast/var.scm 1110 */
			  obj_t aux_3596;
			  {	/* Cgen/capp.scm 214 */
			     value_bglt aux_3597;
			     aux_3597 =
				(((variable_bglt) CREF(var_1968))->value);
			     aux_3596 =
				(obj_t) (aux_3597);
			  }
			  test1712_2902 =
			     is_a__118___object(aux_3596, sfun_ast_var);
		       }
		       if (test1712_2902)
			 {	/* Cgen/capp.scm 214 */
			    return
			       node_sfun_non_tail_app__cop_176_cgen_capp(var_1968, node_1963, kont_1964);
			 }
		       else
			 {	/* Cgen/capp.scm 214 */
			    return
			       node_cfun_non_tail_app__cop_38_cgen_capp(var_1968, node_1963, kont_1964);
			 }
		    }
		 }
	       else
		 {	/* Cgen/capp.scm 199 */
		    return
		       node_tail_app__cop_48_cgen_capp(var_1968, node_1963, kont_1964);
		 }
	    }
	 }
      }
   }
}



/* node->cop-funcall1709 */
obj_t 
node__cop_funcall1709_218_cgen_capp(obj_t env_2912, obj_t node_2913, obj_t kont_2914)
{
   AN_OBJECT;
   {	/* Cgen/capp.scm 112 */
      {
	 funcall_bglt node_1867;
	 obj_t kont_1868;
	 node_1867 =
	    (funcall_bglt) (node_2913);
	 kont_1868 = kont_2914;
	 {
	    obj_t old_actuals_174_1872;
	    obj_t new_actuals_73_1873;
	    local_bglt aux_1874;
	    obj_t auxs_1875;
	    obj_t exps_1876;
	    {	/* Cgen/capp.scm 116 */
	       obj_t arg2151_1878;
	       local_bglt arg2154_1880;
	       arg2151_1878 =
		  (((funcall_bglt) CREF(node_1867))->args);
	       arg2154_1880 =
		  make_local_svar_name_219_cgen_cgen(
		  CNST_TABLE_REF(((long) 0)),
		  (type_bglt) (_obj__252_type_cache));
	       old_actuals_174_1872 = arg2151_1878;
	       new_actuals_73_1873 = BNIL;
	       aux_1874 = arg2154_1880;
	       auxs_1875 = BNIL;
	       exps_1876 = BNIL;
	     loop_1877:
	       if (
		  NULLP(old_actuals_174_1872))
		 {	/* Cgen/capp.scm 122 */
		    local_bglt aux_1884;
		    aux_1884 =
		       make_local_svar_name_219_cgen_cgen(
		       CNST_TABLE_REF(((long) 0)),
		       (type_bglt) (_obj__252_type_cache));
		    {	/* Cgen/capp.scm 122 */
		       cop_bglt cop_1885;
		       {	/* Cgen/capp.scm 123 */
			  setq_bglt arg2215_1940;
			  arg2215_1940 =
			     node_setq_243_cgen_cgen(
			     (variable_bglt) (aux_1884),
			     (((funcall_bglt) CREF(node_1867))->fun));
			  cop_1885 =
			     node__cop_142_cgen_cgen(
			     (node_bglt) (arg2215_1940), _id_kont__126_cgen_cgen);
		       }
		       {	/* Cgen/capp.scm 123 */

			  {	/* Cgen/capp.scm 124 */
			     bool_t test2158_1886;
			     {	/* Cgen/capp.scm 124 */
				bool_t test2210_1935;
				test2210_1935 =
				   is_a__118___object(
				   (obj_t) (cop_1885), csetq_cgen_cop);
				if (test2210_1935)
				  {	/* Cgen/capp.scm 125 */
				     bool_t test2211_1936;
				     {	/* ./Ast/node.scm 1204 */
					obj_t aux_3623;
					{	/* Cgen/capp.scm 125 */
					   node_bglt aux_3624;
					   aux_3624 =
					      (((funcall_bglt) CREF(node_1867))->fun);
					   aux_3623 =
					      (obj_t) (aux_3624);
					}
					test2211_1936 =
					   is_a__118___object(aux_3623, var_ast_node);
				     }
				     if (test2211_1936)
				       {	/* ./Ieee/equiv.scm 5508 */
					  obj_t aux_3635;
					  obj_t aux_3629;
					  aux_3635 =
					     (obj_t) (aux_1884);
					  {	/* Cgen/capp.scm 126 */
					     variable_bglt aux_3630;
					     {	/* Cgen/capp.scm 126 */
						varc_bglt arg2213_1938;
						{	/* Cgen/capp.scm 126 */
						   csetq_bglt obj_2709;
						   obj_2709 =
						      (csetq_bglt) (cop_1885);
						   arg2213_1938 =
						      (((csetq_bglt) CREF(obj_2709))->var);
						}
						aux_3630 =
						   (((varc_bglt) CREF(arg2213_1938))->variable);
					     }
					     aux_3629 =
						(obj_t) (aux_3630);
					  }
					  test2158_1886 =
					     (aux_3629 == aux_3635);
				       }
				     else
				       {	/* Cgen/capp.scm 125 */
					  test2158_1886 = ((bool_t) 0);
				       }
				  }
				else
				  {	/* Cgen/capp.scm 124 */
				     test2158_1886 = ((bool_t) 0);
				  }
			     }
			     if (test2158_1886)
			       {	/* Cgen/capp.scm 127 */
				  cop_bglt cfun_1887;
				  {	/* Cgen/capp.scm 127 */
				     csetq_bglt obj_2713;
				     obj_2713 =
					(csetq_bglt) (cop_1885);
				     cfun_1887 =
					(((csetq_bglt) CREF(obj_2713))->value);
				  }
				  if (
				     NULLP(auxs_1875))
				    {	/* Cgen/capp.scm 129 */
				       cfuncall_bglt arg2160_1889;
				       {	/* Cgen/capp.scm 129 */
					  obj_t arg2162_1890;
					  obj_t arg2164_1892;
					  obj_t arg2165_1893;
					  arg2162_1890 =
					     (((funcall_bglt) CREF(node_1867))->loc);
					  arg2164_1892 =
					     reverse__39___r4_pairs_and_lists_6_3(new_actuals_73_1873);
					  arg2165_1893 =
					     (((funcall_bglt) CREF(node_1867))->strength);
					  {	/* Cgen/capp.scm 129 */
					     cfuncall_bglt res2288_2729;
					     {	/* ./Cgen/cop.scm 1497 */
						cfuncall_bglt new1542_2721;
						new1542_2721 =
						   ((cfuncall_bglt) BREF(GC_MALLOC(sizeof(struct cfuncall))));
						{	/* ./Cgen/cop.scm 1497 */
						   long arg1944_2722;
						   arg1944_2722 =
						      class_num_218___object(cfuncall_cgen_cop);
						   {	/* ./Cgen/cop.scm 1497 */
						      obj_t obj_2727;
						      obj_2727 =
							 (obj_t) (new1542_2721);
						      (((obj_t) CREF(obj_2727))->header = MAKE_HEADER(arg1944_2722, 0), BUNSPEC);
						   }
						}
						{	/* ./Cgen/cop.scm 1497 */
						   object_bglt aux_3650;
						   aux_3650 =
						      (object_bglt) (new1542_2721);
						   OBJECT_WIDENING_SET(aux_3650, BFALSE);
						}
						((((cfuncall_bglt) CREF(new1542_2721))->loc) = ((obj_t) arg2162_1890), BUNSPEC);
						((((cfuncall_bglt) CREF(new1542_2721))->fun) = ((cop_bglt) cfun_1887), BUNSPEC);
						((((cfuncall_bglt) CREF(new1542_2721))->args) = ((obj_t) arg2164_1892), BUNSPEC);
						((((cfuncall_bglt) CREF(new1542_2721))->strength) = ((obj_t) arg2165_1893), BUNSPEC);
						res2288_2729 = new1542_2721;
					     }
					     arg2160_1889 = res2288_2729;
					  }
				       }
				       return
					  PROCEDURE_ENTRY(kont_1868) (kont_1868,
					  (obj_t) (arg2160_1889), BEOA);
				    }
				  else
				    {	/* Cgen/capp.scm 134 */
				       obj_t arg2166_1894;
				       csequence_bglt arg2167_1895;
				       arg2166_1894 =
					  (((funcall_bglt) CREF(node_1867))->loc);
				       {	/* Cgen/capp.scm 136 */
					  obj_t arg2168_1896;
					  obj_t arg2169_1897;
					  arg2168_1896 =
					     (((funcall_bglt) CREF(node_1867))->loc);
					  {	/* Cgen/capp.scm 140 */
					     local_var_164_bglt arg2170_1898;
					     csequence_bglt arg2171_1899;
					     obj_t arg2172_1900;
					     {	/* Cgen/capp.scm 140 */
						obj_t arg2176_1904;
						arg2176_1904 =
						   (((funcall_bglt) CREF(node_1867))->loc);
						{	/* Cgen/capp.scm 140 */
						   local_var_164_bglt res2289_2741;
						   {	/* ./Cgen/cop.scm 1494 */
						      local_var_164_bglt new1536_2735;
						      new1536_2735 =
							 ((local_var_164_bglt) BREF(GC_MALLOC(sizeof(struct local_var_164))));
						      {		/* ./Cgen/cop.scm 1494 */
							 long arg1946_2736;
							 arg1946_2736 =
							    class_num_218___object(local_var_164_cgen_cop);
							 {	/* ./Cgen/cop.scm 1494 */
							    obj_t obj_2739;
							    obj_2739 =
							       (obj_t) (new1536_2735);
							    (((obj_t) CREF(obj_2739))->header = MAKE_HEADER(arg1946_2736, 0), BUNSPEC);
							 }
						      }
						      {		/* ./Cgen/cop.scm 1494 */
							 object_bglt aux_3667;
							 aux_3667 =
							    (object_bglt) (new1536_2735);
							 OBJECT_WIDENING_SET(aux_3667, BFALSE);
						      }
						      ((((local_var_164_bglt) CREF(new1536_2735))->loc) = ((obj_t) arg2176_1904), BUNSPEC);
						      ((((local_var_164_bglt) CREF(new1536_2735))->vars) = ((obj_t) auxs_1875), BUNSPEC);
						      res2289_2741 = new1536_2735;
						   }
						   arg2170_1898 = res2289_2741;
						}
					     }
					     {	/* Cgen/capp.scm 143 */
						obj_t arg2178_1906;
						arg2178_1906 =
						   (((funcall_bglt) CREF(node_1867))->loc);
						{	/* Cgen/capp.scm 143 */
						   csequence_bglt res2290_2753;
						   {	/* ./Cgen/cop.scm 1476 */
						      csequence_bglt new1503_2746;
						      new1503_2746 =
							 ((csequence_bglt) BREF(GC_MALLOC(sizeof(struct csequence))));
						      {		/* ./Cgen/cop.scm 1476 */
							 long arg1957_2747;
							 arg1957_2747 =
							    class_num_218___object(csequence_cgen_cop);
							 {	/* ./Cgen/cop.scm 1476 */
							    obj_t obj_2751;
							    obj_2751 =
							       (obj_t) (new1503_2746);
							    (((obj_t) CREF(obj_2751))->header = MAKE_HEADER(arg1957_2747, 0), BUNSPEC);
							 }
						      }
						      {		/* ./Cgen/cop.scm 1476 */
							 object_bglt aux_3677;
							 aux_3677 =
							    (object_bglt) (new1503_2746);
							 OBJECT_WIDENING_SET(aux_3677, BFALSE);
						      }
						      ((((csequence_bglt) CREF(new1503_2746))->loc) = ((obj_t) arg2178_1906), BUNSPEC);
						      ((((csequence_bglt) CREF(new1503_2746))->c_exp__163) = ((bool_t) ((bool_t) 0)), BUNSPEC);
						      ((((csequence_bglt) CREF(new1503_2746))->cops) = ((obj_t) exps_1876), BUNSPEC);
						      res2290_2753 = new1503_2746;
						   }
						   arg2171_1899 = res2290_2753;
						}
					     }
					     {	/* Cgen/capp.scm 146 */
						cfuncall_bglt arg2180_1908;
						{	/* Cgen/capp.scm 146 */
						   obj_t arg2181_1909;
						   obj_t arg2184_1911;
						   obj_t arg2185_1912;
						   arg2181_1909 =
						      (((funcall_bglt) CREF(node_1867))->loc);
						   arg2184_1911 =
						      reverse__39___r4_pairs_and_lists_6_3(new_actuals_73_1873);
						   arg2185_1912 =
						      (((funcall_bglt) CREF(node_1867))->strength);
						   {	/* Cgen/capp.scm 146 */
						      cfuncall_bglt res2291_2768;
						      {		/* ./Cgen/cop.scm 1497 */
							 cfuncall_bglt new1542_2760;
							 new1542_2760 =
							    ((cfuncall_bglt) BREF(GC_MALLOC(sizeof(struct cfuncall))));
							 {	/* ./Cgen/cop.scm 1497 */
							    long arg1944_2761;
							    arg1944_2761 =
							       class_num_218___object(cfuncall_cgen_cop);
							    {	/* ./Cgen/cop.scm 1497 */
							       obj_t obj_2766;
							       obj_2766 =
								  (obj_t) (new1542_2760);
							       (((obj_t) CREF(obj_2766))->header = MAKE_HEADER(arg1944_2761, 0), BUNSPEC);
							    }
							 }
							 {	/* ./Cgen/cop.scm 1497 */
							    object_bglt aux_3690;
							    aux_3690 =
							       (object_bglt) (new1542_2760);
							    OBJECT_WIDENING_SET(aux_3690, BFALSE);
							 }
							 ((((cfuncall_bglt) CREF(new1542_2760))->loc) = ((obj_t) arg2181_1909), BUNSPEC);
							 ((((cfuncall_bglt) CREF(new1542_2760))->fun) = ((cop_bglt) cfun_1887), BUNSPEC);
							 ((((cfuncall_bglt) CREF(new1542_2760))->args) = ((obj_t) arg2184_1911), BUNSPEC);
							 ((((cfuncall_bglt) CREF(new1542_2760))->strength) = ((obj_t) arg2185_1912), BUNSPEC);
							 res2291_2768 = new1542_2760;
						      }
						      arg2180_1908 = res2291_2768;
						   }
						}
						arg2172_1900 =
						   PROCEDURE_ENTRY(kont_1868) (kont_1868,
						   (obj_t) (arg2180_1908), BEOA);
					     }
					     {	/* Cgen/capp.scm 138 */
						obj_t list2173_1901;
						{	/* Cgen/capp.scm 138 */
						   obj_t arg2174_1902;
						   {	/* Cgen/capp.scm 138 */
						      obj_t arg2175_1903;
						      arg2175_1903 =
							 MAKE_PAIR(arg2172_1900, BNIL);
						      {		/* Cgen/capp.scm 138 */
							 obj_t aux_3701;
							 aux_3701 =
							    (obj_t) (arg2171_1899);
							 arg2174_1902 =
							    MAKE_PAIR(aux_3701, arg2175_1903);
						      }
						   }
						   {	/* Cgen/capp.scm 138 */
						      obj_t aux_3704;
						      aux_3704 =
							 (obj_t) (arg2170_1898);
						      list2173_1901 =
							 MAKE_PAIR(aux_3704, arg2174_1902);
						   }
						}
						arg2169_1897 = list2173_1901;
					     }
					  }
					  {	/* Cgen/capp.scm 136 */
					     csequence_bglt res2292_2780;
					     {	/* ./Cgen/cop.scm 1476 */
						csequence_bglt new1503_2773;
						new1503_2773 =
						   ((csequence_bglt) BREF(GC_MALLOC(sizeof(struct csequence))));
						{	/* ./Cgen/cop.scm 1476 */
						   long arg1957_2774;
						   arg1957_2774 =
						      class_num_218___object(csequence_cgen_cop);
						   {	/* ./Cgen/cop.scm 1476 */
						      obj_t obj_2778;
						      obj_2778 =
							 (obj_t) (new1503_2773);
						      (((obj_t) CREF(obj_2778))->header = MAKE_HEADER(arg1957_2774, 0), BUNSPEC);
						   }
						}
						{	/* ./Cgen/cop.scm 1476 */
						   object_bglt aux_3711;
						   aux_3711 =
						      (object_bglt) (new1503_2773);
						   OBJECT_WIDENING_SET(aux_3711, BFALSE);
						}
						((((csequence_bglt) CREF(new1503_2773))->loc) = ((obj_t) arg2168_1896), BUNSPEC);
						((((csequence_bglt) CREF(new1503_2773))->c_exp__163) = ((bool_t) ((bool_t) 0)), BUNSPEC);
						((((csequence_bglt) CREF(new1503_2773))->cops) = ((obj_t) arg2169_1897), BUNSPEC);
						res2292_2780 = new1503_2773;
					     }
					     arg2167_1895 = res2292_2780;
					  }
				       }
				       {	/* Cgen/capp.scm 134 */
					  block_bglt res2293_2789;
					  {	/* Cgen/capp.scm 134 */
					     cop_bglt body_2782;
					     body_2782 =
						(cop_bglt) (arg2167_1895);
					     {	/* ./Cgen/cop.scm 1453 */
						block_bglt new1459_2783;
						new1459_2783 =
						   ((block_bglt) BREF(GC_MALLOC(sizeof(struct block))));
						{	/* ./Cgen/cop.scm 1453 */
						   long arg1971_2784;
						   arg1971_2784 =
						      class_num_218___object(block_cgen_cop);
						   {	/* ./Cgen/cop.scm 1453 */
						      obj_t obj_2787;
						      obj_2787 =
							 (obj_t) (new1459_2783);
						      (((obj_t) CREF(obj_2787))->header = MAKE_HEADER(arg1971_2784, 0), BUNSPEC);
						   }
						}
						{	/* ./Cgen/cop.scm 1453 */
						   object_bglt aux_3722;
						   aux_3722 =
						      (object_bglt) (new1459_2783);
						   OBJECT_WIDENING_SET(aux_3722, BFALSE);
						}
						((((block_bglt) CREF(new1459_2783))->loc) = ((obj_t) arg2166_1894), BUNSPEC);
						((((block_bglt) CREF(new1459_2783))->body) = ((cop_bglt) body_2782), BUNSPEC);
						res2293_2789 = new1459_2783;
					     }
					  }
					  return
					     (obj_t) (res2293_2789);
				       }
				    }
			       }
			     else
			       {	/* Cgen/capp.scm 152 */
				  obj_t arg2187_1914;
				  csequence_bglt arg2188_1915;
				  arg2187_1914 =
				     (((funcall_bglt) CREF(node_1867))->loc);
				  {	/* Cgen/capp.scm 154 */
				     obj_t arg2189_1916;
				     obj_t arg2190_1917;
				     arg2189_1916 =
					(((funcall_bglt) CREF(node_1867))->loc);
				     {	/* Cgen/capp.scm 158 */
					local_var_164_bglt arg2191_1918;
					csequence_bglt arg2192_1919;
					obj_t arg2193_1920;
					{	/* Cgen/capp.scm 158 */
					   obj_t arg2198_1924;
					   obj_t arg2199_1925;
					   arg2198_1924 =
					      (((funcall_bglt) CREF(node_1867))->loc);
					   {	/* ./Ieee/pair-list.scm 5689 */
					      obj_t aux_3731;
					      aux_3731 =
						 (obj_t) (aux_1884);
					      arg2199_1925 =
						 MAKE_PAIR(aux_3731, auxs_1875);
					   }
					   {	/* Cgen/capp.scm 158 */
					      local_var_164_bglt res2294_2803;
					      {		/* ./Cgen/cop.scm 1494 */
						 local_var_164_bglt new1536_2797;
						 new1536_2797 =
						    ((local_var_164_bglt) BREF(GC_MALLOC(sizeof(struct local_var_164))));
						 {	/* ./Cgen/cop.scm 1494 */
						    long arg1946_2798;
						    arg1946_2798 =
						       class_num_218___object(local_var_164_cgen_cop);
						    {	/* ./Cgen/cop.scm 1494 */
						       obj_t obj_2801;
						       obj_2801 =
							  (obj_t) (new1536_2797);
						       (((obj_t) CREF(obj_2801))->header = MAKE_HEADER(arg1946_2798, 0), BUNSPEC);
						    }
						 }
						 {	/* ./Cgen/cop.scm 1494 */
						    object_bglt aux_3738;
						    aux_3738 =
						       (object_bglt) (new1536_2797);
						    OBJECT_WIDENING_SET(aux_3738, BFALSE);
						 }
						 ((((local_var_164_bglt) CREF(new1536_2797))->loc) = ((obj_t) arg2198_1924), BUNSPEC);
						 ((((local_var_164_bglt) CREF(new1536_2797))->vars) = ((obj_t) arg2199_1925), BUNSPEC);
						 res2294_2803 = new1536_2797;
					      }
					      arg2191_1918 = res2294_2803;
					   }
					}
					{	/* Cgen/capp.scm 161 */
					   obj_t arg2200_1926;
					   obj_t arg2201_1927;
					   arg2200_1926 =
					      (((funcall_bglt) CREF(node_1867))->loc);
					   {	/* ./Ieee/pair-list.scm 5689 */
					      obj_t aux_3744;
					      aux_3744 =
						 (obj_t) (cop_1885);
					      arg2201_1927 =
						 MAKE_PAIR(aux_3744, exps_1876);
					   }
					   {	/* Cgen/capp.scm 161 */
					      csequence_bglt res2295_2817;
					      {		/* ./Cgen/cop.scm 1476 */
						 csequence_bglt new1503_2810;
						 new1503_2810 =
						    ((csequence_bglt) BREF(GC_MALLOC(sizeof(struct csequence))));
						 {	/* ./Cgen/cop.scm 1476 */
						    long arg1957_2811;
						    arg1957_2811 =
						       class_num_218___object(csequence_cgen_cop);
						    {	/* ./Cgen/cop.scm 1476 */
						       obj_t obj_2815;
						       obj_2815 =
							  (obj_t) (new1503_2810);
						       (((obj_t) CREF(obj_2815))->header = MAKE_HEADER(arg1957_2811, 0), BUNSPEC);
						    }
						 }
						 {	/* ./Cgen/cop.scm 1476 */
						    object_bglt aux_3751;
						    aux_3751 =
						       (object_bglt) (new1503_2810);
						    OBJECT_WIDENING_SET(aux_3751, BFALSE);
						 }
						 ((((csequence_bglt) CREF(new1503_2810))->loc) = ((obj_t) arg2200_1926), BUNSPEC);
						 ((((csequence_bglt) CREF(new1503_2810))->c_exp__163) = ((bool_t) ((bool_t) 0)), BUNSPEC);
						 ((((csequence_bglt) CREF(new1503_2810))->cops) = ((obj_t) arg2201_1927), BUNSPEC);
						 res2295_2817 = new1503_2810;
					      }
					      arg2192_1919 = res2295_2817;
					   }
					}
					{	/* Cgen/capp.scm 164 */
					   cfuncall_bglt arg2202_1928;
					   {	/* Cgen/capp.scm 164 */
					      obj_t arg2203_1929;
					      varc_bglt arg2204_1930;
					      obj_t arg2206_1931;
					      obj_t arg2207_1932;
					      arg2203_1929 =
						 (((funcall_bglt) CREF(node_1867))->loc);
					      {		/* Cgen/capp.scm 166 */
						 obj_t arg2208_1933;
						 arg2208_1933 =
						    (((funcall_bglt) CREF(node_1867))->loc);
						 {	/* Cgen/capp.scm 166 */
						    varc_bglt res2296_2828;
						    {	/* Cgen/capp.scm 166 */
						       variable_bglt variable_2821;
						       variable_2821 =
							  (variable_bglt) (aux_1884);
						       {	/* ./Cgen/cop.scm 1465 */
							  varc_bglt new1483_2822;
							  new1483_2822 =
							     ((varc_bglt) BREF(GC_MALLOC(sizeof(struct varc))));
							  {	/* ./Cgen/cop.scm 1465 */
							     long arg1963_2823;
							     arg1963_2823 =
								class_num_218___object(varc_cgen_cop);
							     {	/* ./Cgen/cop.scm 1465 */
								obj_t obj_2826;
								obj_2826 =
								   (obj_t) (new1483_2822);
								(((obj_t) CREF(obj_2826))->header = MAKE_HEADER(arg1963_2823, 0), BUNSPEC);
							     }
							  }
							  {	/* ./Cgen/cop.scm 1465 */
							     object_bglt aux_3764;
							     aux_3764 =
								(object_bglt) (new1483_2822);
							     OBJECT_WIDENING_SET(aux_3764, BFALSE);
							  }
							  ((((varc_bglt) CREF(new1483_2822))->loc) = ((obj_t) arg2208_1933), BUNSPEC);
							  ((((varc_bglt) CREF(new1483_2822))->variable) = ((variable_bglt) variable_2821), BUNSPEC);
							  res2296_2828 = new1483_2822;
						       }
						    }
						    arg2204_1930 = res2296_2828;
						 }
					      }
					      arg2206_1931 =
						 reverse__39___r4_pairs_and_lists_6_3(new_actuals_73_1873);
					      arg2207_1932 =
						 (((funcall_bglt) CREF(node_1867))->strength);
					      {		/* Cgen/capp.scm 164 */
						 cfuncall_bglt res2297_2842;
						 {	/* Cgen/capp.scm 164 */
						    cop_bglt fun_2831;
						    fun_2831 =
						       (cop_bglt) (arg2204_1930);
						    {	/* ./Cgen/cop.scm 1497 */
						       cfuncall_bglt new1542_2834;
						       new1542_2834 =
							  ((cfuncall_bglt) BREF(GC_MALLOC(sizeof(struct cfuncall))));
						       {	/* ./Cgen/cop.scm 1497 */
							  long arg1944_2835;
							  arg1944_2835 =
							     class_num_218___object(cfuncall_cgen_cop);
							  {	/* ./Cgen/cop.scm 1497 */
							     obj_t obj_2840;
							     obj_2840 =
								(obj_t) (new1542_2834);
							     (((obj_t) CREF(obj_2840))->header = MAKE_HEADER(arg1944_2835, 0), BUNSPEC);
							  }
						       }
						       {	/* ./Cgen/cop.scm 1497 */
							  object_bglt aux_3776;
							  aux_3776 =
							     (object_bglt) (new1542_2834);
							  OBJECT_WIDENING_SET(aux_3776, BFALSE);
						       }
						       ((((cfuncall_bglt) CREF(new1542_2834))->loc) = ((obj_t) arg2203_1929), BUNSPEC);
						       ((((cfuncall_bglt) CREF(new1542_2834))->fun) = ((cop_bglt) fun_2831), BUNSPEC);
						       ((((cfuncall_bglt) CREF(new1542_2834))->args) = ((obj_t) arg2206_1931), BUNSPEC);
						       ((((cfuncall_bglt) CREF(new1542_2834))->strength) = ((obj_t) arg2207_1932), BUNSPEC);
						       res2297_2842 = new1542_2834;
						    }
						 }
						 arg2202_1928 = res2297_2842;
					      }
					   }
					   arg2193_1920 =
					      PROCEDURE_ENTRY(kont_1868) (kont_1868,
					      (obj_t) (arg2202_1928), BEOA);
					}
					{	/* Cgen/capp.scm 156 */
					   obj_t list2194_1921;
					   {	/* Cgen/capp.scm 156 */
					      obj_t arg2195_1922;
					      {		/* Cgen/capp.scm 156 */
						 obj_t arg2197_1923;
						 arg2197_1923 =
						    MAKE_PAIR(arg2193_1920, BNIL);
						 {	/* Cgen/capp.scm 156 */
						    obj_t aux_3787;
						    aux_3787 =
						       (obj_t) (arg2192_1919);
						    arg2195_1922 =
						       MAKE_PAIR(aux_3787, arg2197_1923);
						 }
					      }
					      {		/* Cgen/capp.scm 156 */
						 obj_t aux_3790;
						 aux_3790 =
						    (obj_t) (arg2191_1918);
						 list2194_1921 =
						    MAKE_PAIR(aux_3790, arg2195_1922);
					      }
					   }
					   arg2190_1917 = list2194_1921;
					}
				     }
				     {	/* Cgen/capp.scm 154 */
					csequence_bglt res2298_2854;
					{	/* ./Cgen/cop.scm 1476 */
					   csequence_bglt new1503_2847;
					   new1503_2847 =
					      ((csequence_bglt) BREF(GC_MALLOC(sizeof(struct csequence))));
					   {	/* ./Cgen/cop.scm 1476 */
					      long arg1957_2848;
					      arg1957_2848 =
						 class_num_218___object(csequence_cgen_cop);
					      {		/* ./Cgen/cop.scm 1476 */
						 obj_t obj_2852;
						 obj_2852 =
						    (obj_t) (new1503_2847);
						 (((obj_t) CREF(obj_2852))->header = MAKE_HEADER(arg1957_2848, 0), BUNSPEC);
					      }
					   }
					   {	/* ./Cgen/cop.scm 1476 */
					      object_bglt aux_3797;
					      aux_3797 =
						 (object_bglt) (new1503_2847);
					      OBJECT_WIDENING_SET(aux_3797, BFALSE);
					   }
					   ((((csequence_bglt) CREF(new1503_2847))->loc) = ((obj_t) arg2189_1916), BUNSPEC);
					   ((((csequence_bglt) CREF(new1503_2847))->c_exp__163) = ((bool_t) ((bool_t) 0)), BUNSPEC);
					   ((((csequence_bglt) CREF(new1503_2847))->cops) = ((obj_t) arg2190_1917), BUNSPEC);
					   res2298_2854 = new1503_2847;
					}
					arg2188_1915 = res2298_2854;
				     }
				  }
				  {	/* Cgen/capp.scm 152 */
				     block_bglt res2299_2863;
				     {	/* Cgen/capp.scm 152 */
					cop_bglt body_2856;
					body_2856 =
					   (cop_bglt) (arg2188_1915);
					{	/* ./Cgen/cop.scm 1453 */
					   block_bglt new1459_2857;
					   new1459_2857 =
					      ((block_bglt) BREF(GC_MALLOC(sizeof(struct block))));
					   {	/* ./Cgen/cop.scm 1453 */
					      long arg1971_2858;
					      arg1971_2858 =
						 class_num_218___object(block_cgen_cop);
					      {		/* ./Cgen/cop.scm 1453 */
						 obj_t obj_2861;
						 obj_2861 =
						    (obj_t) (new1459_2857);
						 (((obj_t) CREF(obj_2861))->header = MAKE_HEADER(arg1971_2858, 0), BUNSPEC);
					      }
					   }
					   {	/* ./Cgen/cop.scm 1453 */
					      object_bglt aux_3808;
					      aux_3808 =
						 (object_bglt) (new1459_2857);
					      OBJECT_WIDENING_SET(aux_3808, BFALSE);
					   }
					   ((((block_bglt) CREF(new1459_2857))->loc) = ((obj_t) arg2187_1914), BUNSPEC);
					   ((((block_bglt) CREF(new1459_2857))->body) = ((cop_bglt) body_2856), BUNSPEC);
					   res2299_2863 = new1459_2857;
					}
				     }
				     return
					(obj_t) (res2299_2863);
				  }
			       }
			  }
		       }
		    }
		 }
	       else
		 {	/* Cgen/capp.scm 171 */
		    cop_bglt cop_1942;
		    {	/* Cgen/capp.scm 171 */
		       setq_bglt arg2236_1959;
		       {	/* Cgen/capp.scm 171 */
			  node_bglt aux_3814;
			  {	/* Cgen/capp.scm 171 */
			     obj_t aux_3816;
			     aux_3816 =
				CAR(old_actuals_174_1872);
			     aux_3814 =
				(node_bglt) (aux_3816);
			  }
			  arg2236_1959 =
			     node_setq_243_cgen_cgen(
			     (variable_bglt) (aux_1874), aux_3814);
		       }
		       cop_1942 =
			  node__cop_142_cgen_cgen(
			  (node_bglt) (arg2236_1959), _id_kont__126_cgen_cgen);
		    }
		    {	/* Cgen/capp.scm 173 */
		       bool_t test2217_1943;
		       {	/* Cgen/capp.scm 173 */
			  bool_t test2232_1956;
			  test2232_1956 =
			     is_a__118___object(
			     (obj_t) (cop_1942), csetq_cgen_cop);
			  if (test2232_1956)
			    {	/* ./Ieee/equiv.scm 5508 */
			       obj_t aux_3831;
			       obj_t aux_3825;
			       aux_3831 =
				  (obj_t) (aux_1874);
			       {	/* Cgen/capp.scm 174 */
				  variable_bglt aux_3826;
				  {	/* Cgen/capp.scm 174 */
				     varc_bglt arg2234_1958;
				     {	/* Cgen/capp.scm 174 */
					csetq_bglt obj_2866;
					obj_2866 =
					   (csetq_bglt) (cop_1942);
					arg2234_1958 =
					   (((csetq_bglt) CREF(obj_2866))->var);
				     }
				     aux_3826 =
					(((varc_bglt) CREF(arg2234_1958))->variable);
				  }
				  aux_3825 =
				     (obj_t) (aux_3826);
			       }
			       test2217_1943 =
				  (aux_3825 == aux_3831);
			    }
			  else
			    {	/* Cgen/capp.scm 173 */
			       test2217_1943 = ((bool_t) 0);
			    }
		       }
		       if (test2217_1943)
			 {	/* Cgen/capp.scm 176 */
			    obj_t arg2219_1944;
			    obj_t arg2220_1945;
			    arg2219_1944 =
			       CDR(old_actuals_174_1872);
			    {	/* ./Ieee/pair-list.scm 5689 */
			       obj_t aux_3836;
			       {	/* Cgen/capp.scm 177 */
				  cop_bglt aux_3837;
				  {	/* Cgen/capp.scm 177 */
				     csetq_bglt obj_2871;
				     obj_2871 =
					(csetq_bglt) (cop_1942);
				     aux_3837 =
					(((csetq_bglt) CREF(obj_2871))->value);
				  }
				  aux_3836 =
				     (obj_t) (aux_3837);
			       }
			       arg2220_1945 =
				  MAKE_PAIR(aux_3836, new_actuals_73_1873);
			    }
			    {
			       obj_t new_actuals_73_3843;
			       obj_t old_actuals_174_3842;
			       old_actuals_174_3842 = arg2219_1944;
			       new_actuals_73_3843 = arg2220_1945;
			       new_actuals_73_1873 = new_actuals_73_3843;
			       old_actuals_174_1872 = old_actuals_174_3842;
			       goto loop_1877;
			    }
			 }
		       else
			 {	/* Cgen/capp.scm 173 */
			    {	/* Cgen/capp.scm 182 */
			       obj_t arg2223_1947;
			       obj_t arg2224_1948;
			       local_bglt arg2225_1949;
			       obj_t arg2226_1950;
			       obj_t arg2227_1951;
			       arg2223_1947 =
				  CDR(old_actuals_174_1872);
			       {	/* Cgen/capp.scm 184 */
				  varc_bglt arg2228_1952;
				  {	/* Cgen/capp.scm 184 */
				     obj_t arg2229_1953;
				     {	/* Cgen/capp.scm 184 */
					node_bglt obj_2876;
					{	/* Cgen/capp.scm 184 */
					   obj_t aux_3845;
					   aux_3845 =
					      CAR(old_actuals_174_1872);
					   obj_2876 =
					      (node_bglt) (aux_3845);
					}
					arg2229_1953 =
					   (((node_bglt) CREF(obj_2876))->loc);
				     }
				     {	/* Cgen/capp.scm 183 */
					varc_bglt res2300_2885;
					{	/* Cgen/capp.scm 183 */
					   variable_bglt variable_2878;
					   variable_2878 =
					      (variable_bglt) (aux_1874);
					   {	/* ./Cgen/cop.scm 1465 */
					      varc_bglt new1483_2879;
					      new1483_2879 =
						 ((varc_bglt) BREF(GC_MALLOC(sizeof(struct varc))));
					      {		/* ./Cgen/cop.scm 1465 */
						 long arg1963_2880;
						 arg1963_2880 =
						    class_num_218___object(varc_cgen_cop);
						 {	/* ./Cgen/cop.scm 1465 */
						    obj_t obj_2883;
						    obj_2883 =
						       (obj_t) (new1483_2879);
						    (((obj_t) CREF(obj_2883))->header = MAKE_HEADER(arg1963_2880, 0), BUNSPEC);
						 }
					      }
					      {		/* ./Cgen/cop.scm 1465 */
						 object_bglt aux_3854;
						 aux_3854 =
						    (object_bglt) (new1483_2879);
						 OBJECT_WIDENING_SET(aux_3854, BFALSE);
					      }
					      ((((varc_bglt) CREF(new1483_2879))->loc) = ((obj_t) arg2229_1953), BUNSPEC);
					      ((((varc_bglt) CREF(new1483_2879))->variable) = ((variable_bglt) variable_2878), BUNSPEC);
					      res2300_2885 = new1483_2879;
					   }
					}
					arg2228_1952 = res2300_2885;
				     }
				  }
				  {	/* ./Ieee/pair-list.scm 5689 */
				     obj_t aux_3859;
				     aux_3859 =
					(obj_t) (arg2228_1952);
				     arg2224_1948 =
					MAKE_PAIR(aux_3859, new_actuals_73_1873);
				  }
			       }
			       arg2225_1949 =
				  make_local_svar_name_219_cgen_cgen(
				  CNST_TABLE_REF(((long) 0)),
				  (type_bglt) (_obj__252_type_cache));
			       {	/* ./Ieee/pair-list.scm 5689 */
				  obj_t aux_3865;
				  aux_3865 =
				     (obj_t) (aux_1874);
				  arg2226_1950 =
				     MAKE_PAIR(aux_3865, auxs_1875);
			       }
			       {	/* ./Ieee/pair-list.scm 5689 */
				  obj_t aux_3868;
				  aux_3868 =
				     (obj_t) (cop_1942);
				  arg2227_1951 =
				     MAKE_PAIR(aux_3868, exps_1876);
			       }
			       {
				  obj_t exps_3875;
				  obj_t auxs_3874;
				  local_bglt aux_3873;
				  obj_t new_actuals_73_3872;
				  obj_t old_actuals_174_3871;
				  old_actuals_174_3871 = arg2223_1947;
				  new_actuals_73_3872 = arg2224_1948;
				  aux_3873 = arg2225_1949;
				  auxs_3874 = arg2226_1950;
				  exps_3875 = arg2227_1951;
				  exps_1876 = exps_3875;
				  auxs_1875 = auxs_3874;
				  aux_1874 = aux_3873;
				  new_actuals_73_1873 = new_actuals_73_3872;
				  old_actuals_174_1872 = old_actuals_174_3871;
				  goto loop_1877;
			       }
			    }
			 }
		    }
		 }
	    }
	 }
      }
   }
}



/* node->cop-app-ly1707 */
obj_t 
node__cop_app_ly1707_225_cgen_capp(obj_t env_2915, obj_t node_2916, obj_t kont_2917)
{
   AN_OBJECT;
   {	/* Cgen/capp.scm 32 */
      {
	 app_ly_162_bglt node_1762;
	 obj_t kont_1763;
	 node_1762 =
	    (app_ly_162_bglt) (node_2916);
	 kont_1763 = kont_2917;
	 {	/* Cgen/capp.scm 36 */
	    node_bglt value_1767;
	    value_1767 =
	       (((app_ly_162_bglt) CREF(node_1762))->arg);
	    {	/* Cgen/capp.scm 36 */
	       local_bglt vaux_1768;
	       vaux_1768 =
		  make_local_svar_name_219_cgen_cgen(
		  CNST_TABLE_REF(((long) 0)),
		  (type_bglt) (_obj__252_type_cache));
	       {	/* Cgen/capp.scm 37 */
		  cop_bglt vcop_1769;
		  {	/* Cgen/capp.scm 38 */
		     setq_bglt arg2149_1864;
		     arg2149_1864 =
			node_setq_243_cgen_cgen(
			(variable_bglt) (vaux_1768), value_1767);
		     vcop_1769 =
			node__cop_142_cgen_cgen(
			(node_bglt) (arg2149_1864), _id_kont__126_cgen_cgen);
		  }
		  {	/* Cgen/capp.scm 38 */
		     node_bglt fun_1770;
		     fun_1770 =
			(((app_ly_162_bglt) CREF(node_1762))->fun);
		     {	/* Cgen/capp.scm 39 */
			local_bglt faux_1771;
			faux_1771 =
			   make_local_svar_name_219_cgen_cgen(
			   CNST_TABLE_REF(((long) 1)),
			   (type_bglt) (_procedure__226_type_cache));
			{	/* Cgen/capp.scm 40 */
			   cop_bglt fcop_1772;
			   {	/* Cgen/capp.scm 41 */
			      setq_bglt arg2148_1863;
			      arg2148_1863 =
				 node_setq_243_cgen_cgen(
				 (variable_bglt) (faux_1771), fun_1770);
			      fcop_1772 =
				 node__cop_142_cgen_cgen(
				 (node_bglt) (arg2148_1863), _id_kont__126_cgen_cgen);
			   }
			   {	/* Cgen/capp.scm 41 */

			      {		/* Cgen/capp.scm 43 */
				 bool_t test2050_1773;
				 {	/* Cgen/capp.scm 43 */
				    bool_t test2138_1856;
				    test2138_1856 =
				       is_a__118___object(
				       (obj_t) (vcop_1769), csetq_cgen_cop);
				    if (test2138_1856)
				      {		/* Cgen/capp.scm 43 */
					 bool_t test_3896;
					 {	/* ./Ieee/equiv.scm 5508 */
					    obj_t aux_3903;
					    obj_t aux_3897;
					    aux_3903 =
					       (obj_t) (vaux_1768);
					    {	/* Cgen/capp.scm 43 */
					       variable_bglt aux_3898;
					       {	/* Cgen/capp.scm 43 */
						  varc_bglt arg2146_1862;
						  {	/* Cgen/capp.scm 43 */
						     csetq_bglt obj_2451;
						     obj_2451 =
							(csetq_bglt) (vcop_1769);
						     arg2146_1862 =
							(((csetq_bglt) CREF(obj_2451))->var);
						  }
						  aux_3898 =
						     (((varc_bglt) CREF(arg2146_1862))->variable);
					       }
					       aux_3897 =
						  (obj_t) (aux_3898);
					    }
					    test_3896 =
					       (aux_3897 == aux_3903);
					 }
					 if (test_3896)
					   {	/* Cgen/capp.scm 44 */
					      bool_t test2140_1858;
					      test2140_1858 =
						 is_a__118___object(
						 (obj_t) (fcop_1772), csetq_cgen_cop);
					      if (test2140_1858)
						{	/* ./Ieee/equiv.scm 5508 */
						   obj_t aux_3915;
						   obj_t aux_3909;
						   aux_3915 =
						      (obj_t) (faux_1771);
						   {	/* Cgen/capp.scm 44 */
						      variable_bglt aux_3910;
						      {		/* Cgen/capp.scm 44 */
							 varc_bglt arg2144_1860;
							 {	/* Cgen/capp.scm 44 */
							    csetq_bglt obj_2456;
							    obj_2456 =
							       (csetq_bglt) (fcop_1772);
							    arg2144_1860 =
							       (((csetq_bglt) CREF(obj_2456))->var);
							 }
							 aux_3910 =
							    (((varc_bglt) CREF(arg2144_1860))->variable);
						      }
						      aux_3909 =
							 (obj_t) (aux_3910);
						   }
						   test2050_1773 =
						      (aux_3909 == aux_3915);
						}
					      else
						{	/* Cgen/capp.scm 44 */
						   test2050_1773 = ((bool_t) 0);
						}
					   }
					 else
					   {	/* Cgen/capp.scm 43 */
					      test2050_1773 = ((bool_t) 0);
					   }
				      }
				    else
				      {		/* Cgen/capp.scm 43 */
					 test2050_1773 = ((bool_t) 0);
				      }
				 }
				 if (test2050_1773)
				   {	/* Cgen/capp.scm 43 */
				      {		/* Cgen/capp.scm 45 */
					 capply_bglt arg2051_1774;
					 {	/* Cgen/capp.scm 45 */
					    obj_t arg2052_1775;
					    cop_bglt arg2053_1776;
					    cop_bglt arg2054_1777;
					    arg2052_1775 =
					       (((app_ly_162_bglt) CREF(node_1762))->loc);
					    {	/* Cgen/capp.scm 47 */
					       csetq_bglt obj_2461;
					       obj_2461 =
						  (csetq_bglt) (fcop_1772);
					       arg2053_1776 =
						  (((csetq_bglt) CREF(obj_2461))->value);
					    }
					    {	/* Cgen/capp.scm 48 */
					       csetq_bglt obj_2462;
					       obj_2462 =
						  (csetq_bglt) (vcop_1769);
					       arg2054_1777 =
						  (((csetq_bglt) CREF(obj_2462))->value);
					    }
					    {	/* Cgen/capp.scm 45 */
					       capply_bglt res2268_2473;
					       {	/* ./Cgen/cop.scm 1502 */
						  capply_bglt new1550_2466;
						  new1550_2466 =
						     ((capply_bglt) BREF(GC_MALLOC(sizeof(struct capply))));
						  {	/* ./Cgen/cop.scm 1502 */
						     long arg1942_2467;
						     arg1942_2467 =
							class_num_218___object(capply_cgen_cop);
						     {	/* ./Cgen/cop.scm 1502 */
							obj_t obj_2471;
							obj_2471 =
							   (obj_t) (new1550_2466);
							(((obj_t) CREF(obj_2471))->header = MAKE_HEADER(arg1942_2467, 0), BUNSPEC);
						     }
						  }
						  {	/* ./Cgen/cop.scm 1502 */
						     object_bglt aux_3928;
						     aux_3928 =
							(object_bglt) (new1550_2466);
						     OBJECT_WIDENING_SET(aux_3928, BFALSE);
						  }
						  ((((capply_bglt) CREF(new1550_2466))->loc) = ((obj_t) arg2052_1775), BUNSPEC);
						  ((((capply_bglt) CREF(new1550_2466))->fun) = ((cop_bglt) arg2053_1776), BUNSPEC);
						  ((((capply_bglt) CREF(new1550_2466))->arg) = ((cop_bglt) arg2054_1777), BUNSPEC);
						  res2268_2473 = new1550_2466;
					       }
					       arg2051_1774 = res2268_2473;
					    }
					 }
					 return
					    PROCEDURE_ENTRY(kont_1763) (kont_1763,
					    (obj_t) (arg2051_1774), BEOA);
				      }
				   }
				 else
				   {	/* Cgen/capp.scm 49 */
				      bool_t test2055_1778;
				      {		/* Cgen/capp.scm 49 */
					 bool_t test2135_1853;
					 test2135_1853 =
					    is_a__118___object(
					    (obj_t) (vcop_1769), csetq_cgen_cop);
					 if (test2135_1853)
					   {	/* ./Ieee/equiv.scm 5508 */
					      obj_t aux_3946;
					      obj_t aux_3940;
					      aux_3946 =
						 (obj_t) (vaux_1768);
					      {		/* Cgen/capp.scm 49 */
						 variable_bglt aux_3941;
						 {	/* Cgen/capp.scm 49 */
						    varc_bglt arg2137_1855;
						    {	/* Cgen/capp.scm 49 */
						       csetq_bglt obj_2475;
						       obj_2475 =
							  (csetq_bglt) (vcop_1769);
						       arg2137_1855 =
							  (((csetq_bglt) CREF(obj_2475))->var);
						    }
						    aux_3941 =
						       (((varc_bglt) CREF(arg2137_1855))->variable);
						 }
						 aux_3940 =
						    (obj_t) (aux_3941);
					      }
					      test2055_1778 =
						 (aux_3940 == aux_3946);
					   }
					 else
					   {	/* Cgen/capp.scm 49 */
					      test2055_1778 = ((bool_t) 0);
					   }
				      }
				      if (test2055_1778)
					{	/* Cgen/capp.scm 49 */
					   {	/* Cgen/capp.scm 50 */
					      obj_t arg2056_1779;
					      csequence_bglt arg2057_1780;
					      arg2056_1779 =
						 (((app_ly_162_bglt) CREF(node_1762))->loc);
					      {		/* Cgen/capp.scm 52 */
						 obj_t arg2058_1781;
						 obj_t arg2059_1782;
						 arg2058_1781 =
						    (((app_ly_162_bglt) CREF(node_1762))->loc);
						 {	/* Cgen/capp.scm 56 */
						    local_var_164_bglt arg2060_1783;
						    csequence_bglt arg2061_1784;
						    obj_t arg2062_1785;
						    {	/* Cgen/capp.scm 56 */
						       obj_t arg2066_1789;
						       obj_t arg2067_1790;
						       arg2066_1789 =
							  (((app_ly_162_bglt) CREF(node_1762))->loc);
						       {	/* Cgen/capp.scm 58 */
							  obj_t list2068_1791;
							  {	/* Cgen/capp.scm 58 */
							     obj_t aux_3953;
							     aux_3953 =
								(obj_t) (faux_1771);
							     list2068_1791 =
								MAKE_PAIR(aux_3953, BNIL);
							  }
							  arg2067_1790 = list2068_1791;
						       }
						       {	/* Cgen/capp.scm 56 */
							  local_var_164_bglt res2269_2491;
							  {	/* ./Cgen/cop.scm 1494 */
							     local_var_164_bglt new1536_2485;
							     new1536_2485 =
								((local_var_164_bglt) BREF(GC_MALLOC(sizeof(struct local_var_164))));
							     {	/* ./Cgen/cop.scm 1494 */
								long arg1946_2486;
								arg1946_2486 =
								   class_num_218___object(local_var_164_cgen_cop);
								{	/* ./Cgen/cop.scm 1494 */
								   obj_t obj_2489;
								   obj_2489 =
								      (obj_t) (new1536_2485);
								   (((obj_t) CREF(obj_2489))->header = MAKE_HEADER(arg1946_2486, 0), BUNSPEC);
								}
							     }
							     {	/* ./Cgen/cop.scm 1494 */
								object_bglt aux_3960;
								aux_3960 =
								   (object_bglt) (new1536_2485);
								OBJECT_WIDENING_SET(aux_3960, BFALSE);
							     }
							     ((((local_var_164_bglt) CREF(new1536_2485))->loc) = ((obj_t) arg2066_1789), BUNSPEC);
							     ((((local_var_164_bglt) CREF(new1536_2485))->vars) = ((obj_t) arg2067_1790), BUNSPEC);
							     res2269_2491 = new1536_2485;
							  }
							  arg2060_1783 = res2269_2491;
						       }
						    }
						    {	/* Cgen/capp.scm 59 */
						       obj_t arg2069_1792;
						       obj_t arg2070_1793;
						       arg2069_1792 =
							  (((app_ly_162_bglt) CREF(node_1762))->loc);
						       {	/* Cgen/capp.scm 61 */
							  obj_t list2071_1794;
							  {	/* Cgen/capp.scm 61 */
							     obj_t aux_3966;
							     aux_3966 =
								(obj_t) (fcop_1772);
							     list2071_1794 =
								MAKE_PAIR(aux_3966, BNIL);
							  }
							  arg2070_1793 = list2071_1794;
						       }
						       {	/* Cgen/capp.scm 59 */
							  csequence_bglt res2270_2504;
							  {	/* ./Cgen/cop.scm 1476 */
							     csequence_bglt new1503_2497;
							     new1503_2497 =
								((csequence_bglt) BREF(GC_MALLOC(sizeof(struct csequence))));
							     {	/* ./Cgen/cop.scm 1476 */
								long arg1957_2498;
								arg1957_2498 =
								   class_num_218___object(csequence_cgen_cop);
								{	/* ./Cgen/cop.scm 1476 */
								   obj_t obj_2502;
								   obj_2502 =
								      (obj_t) (new1503_2497);
								   (((obj_t) CREF(obj_2502))->header = MAKE_HEADER(arg1957_2498, 0), BUNSPEC);
								}
							     }
							     {	/* ./Cgen/cop.scm 1476 */
								object_bglt aux_3973;
								aux_3973 =
								   (object_bglt) (new1503_2497);
								OBJECT_WIDENING_SET(aux_3973, BFALSE);
							     }
							     ((((csequence_bglt) CREF(new1503_2497))->loc) = ((obj_t) arg2069_1792), BUNSPEC);
							     ((((csequence_bglt) CREF(new1503_2497))->c_exp__163) = ((bool_t) ((bool_t) 0)), BUNSPEC);
							     ((((csequence_bglt) CREF(new1503_2497))->cops) = ((obj_t) arg2070_1793), BUNSPEC);
							     res2270_2504 = new1503_2497;
							  }
							  arg2061_1784 = res2270_2504;
						       }
						    }
						    {	/* Cgen/capp.scm 62 */
						       capply_bglt arg2072_1795;
						       {	/* Cgen/capp.scm 62 */
							  obj_t arg2073_1796;
							  varc_bglt arg2074_1797;
							  cop_bglt arg2076_1798;
							  arg2073_1796 =
							     (((app_ly_162_bglt) CREF(node_1762))->loc);
							  {	/* Cgen/capp.scm 64 */
							     obj_t arg2077_1799;
							     arg2077_1799 =
								(((app_ly_162_bglt) CREF(node_1762))->loc);
							     {	/* Cgen/capp.scm 64 */
								varc_bglt res2271_2515;
								{	/* Cgen/capp.scm 64 */
								   variable_bglt variable_2508;
								   variable_2508 =
								      (variable_bglt) (faux_1771);
								   {	/* ./Cgen/cop.scm 1465 */
								      varc_bglt new1483_2509;
								      new1483_2509 =
									 ((varc_bglt) BREF(GC_MALLOC(sizeof(struct varc))));
								      {		/* ./Cgen/cop.scm 1465 */
									 long arg1963_2510;
									 arg1963_2510 =
									    class_num_218___object(varc_cgen_cop);
									 {	/* ./Cgen/cop.scm 1465 */
									    obj_t obj_2513;
									    obj_2513 =
									       (obj_t) (new1483_2509);
									    (((obj_t) CREF(obj_2513))->header = MAKE_HEADER(arg1963_2510, 0), BUNSPEC);
									 }
								      }
								      {		/* ./Cgen/cop.scm 1465 */
									 object_bglt aux_3986;
									 aux_3986 =
									    (object_bglt) (new1483_2509);
									 OBJECT_WIDENING_SET(aux_3986, BFALSE);
								      }
								      ((((varc_bglt) CREF(new1483_2509))->loc) = ((obj_t) arg2077_1799), BUNSPEC);
								      ((((varc_bglt) CREF(new1483_2509))->variable) = ((variable_bglt) variable_2508), BUNSPEC);
								      res2271_2515 = new1483_2509;
								   }
								}
								arg2074_1797 = res2271_2515;
							     }
							  }
							  {	/* Cgen/capp.scm 67 */
							     csetq_bglt obj_2516;
							     obj_2516 =
								(csetq_bglt) (vcop_1769);
							     arg2076_1798 =
								(((csetq_bglt) CREF(obj_2516))->value);
							  }
							  {	/* Cgen/capp.scm 62 */
							     capply_bglt res2272_2527;
							     {	/* Cgen/capp.scm 62 */
								cop_bglt fun_2518;
								fun_2518 =
								   (cop_bglt) (arg2074_1797);
								{	/* ./Cgen/cop.scm 1502 */
								   capply_bglt new1550_2520;
								   new1550_2520 =
								      ((capply_bglt) BREF(GC_MALLOC(sizeof(struct capply))));
								   {	/* ./Cgen/cop.scm 1502 */
								      long arg1942_2521;
								      arg1942_2521 =
									 class_num_218___object(capply_cgen_cop);
								      {		/* ./Cgen/cop.scm 1502 */
									 obj_t obj_2525;
									 obj_2525 =
									    (obj_t) (new1550_2520);
									 (((obj_t) CREF(obj_2525))->header = MAKE_HEADER(arg1942_2521, 0), BUNSPEC);
								      }
								   }
								   {	/* ./Cgen/cop.scm 1502 */
								      object_bglt aux_3998;
								      aux_3998 =
									 (object_bglt) (new1550_2520);
								      OBJECT_WIDENING_SET(aux_3998, BFALSE);
								   }
								   ((((capply_bglt) CREF(new1550_2520))->loc) = ((obj_t) arg2073_1796), BUNSPEC);
								   ((((capply_bglt) CREF(new1550_2520))->fun) = ((cop_bglt) fun_2518), BUNSPEC);
								   ((((capply_bglt) CREF(new1550_2520))->arg) = ((cop_bglt) arg2076_1798), BUNSPEC);
								   res2272_2527 = new1550_2520;
								}
							     }
							     arg2072_1795 = res2272_2527;
							  }
						       }
						       arg2062_1785 =
							  PROCEDURE_ENTRY(kont_1763) (kont_1763,
							  (obj_t) (arg2072_1795), BEOA);
						    }
						    {	/* Cgen/capp.scm 54 */
						       obj_t list2063_1786;
						       {	/* Cgen/capp.scm 54 */
							  obj_t arg2064_1787;
							  {	/* Cgen/capp.scm 54 */
							     obj_t arg2065_1788;
							     arg2065_1788 =
								MAKE_PAIR(arg2062_1785, BNIL);
							     {	/* Cgen/capp.scm 54 */
								obj_t aux_4008;
								aux_4008 =
								   (obj_t) (arg2061_1784);
								arg2064_1787 =
								   MAKE_PAIR(aux_4008, arg2065_1788);
							     }
							  }
							  {	/* Cgen/capp.scm 54 */
							     obj_t aux_4011;
							     aux_4011 =
								(obj_t) (arg2060_1783);
							     list2063_1786 =
								MAKE_PAIR(aux_4011, arg2064_1787);
							  }
						       }
						       arg2059_1782 = list2063_1786;
						    }
						 }
						 {	/* Cgen/capp.scm 52 */
						    csequence_bglt res2273_2539;
						    {	/* ./Cgen/cop.scm 1476 */
						       csequence_bglt new1503_2532;
						       new1503_2532 =
							  ((csequence_bglt) BREF(GC_MALLOC(sizeof(struct csequence))));
						       {	/* ./Cgen/cop.scm 1476 */
							  long arg1957_2533;
							  arg1957_2533 =
							     class_num_218___object(csequence_cgen_cop);
							  {	/* ./Cgen/cop.scm 1476 */
							     obj_t obj_2537;
							     obj_2537 =
								(obj_t) (new1503_2532);
							     (((obj_t) CREF(obj_2537))->header = MAKE_HEADER(arg1957_2533, 0), BUNSPEC);
							  }
						       }
						       {	/* ./Cgen/cop.scm 1476 */
							  object_bglt aux_4018;
							  aux_4018 =
							     (object_bglt) (new1503_2532);
							  OBJECT_WIDENING_SET(aux_4018, BFALSE);
						       }
						       ((((csequence_bglt) CREF(new1503_2532))->loc) = ((obj_t) arg2058_1781), BUNSPEC);
						       ((((csequence_bglt) CREF(new1503_2532))->c_exp__163) = ((bool_t) ((bool_t) 0)), BUNSPEC);
						       ((((csequence_bglt) CREF(new1503_2532))->cops) = ((obj_t) arg2059_1782), BUNSPEC);
						       res2273_2539 = new1503_2532;
						    }
						    arg2057_1780 = res2273_2539;
						 }
					      }
					      {		/* Cgen/capp.scm 50 */
						 block_bglt res2274_2548;
						 {	/* Cgen/capp.scm 50 */
						    cop_bglt body_2541;
						    body_2541 =
						       (cop_bglt) (arg2057_1780);
						    {	/* ./Cgen/cop.scm 1453 */
						       block_bglt new1459_2542;
						       new1459_2542 =
							  ((block_bglt) BREF(GC_MALLOC(sizeof(struct block))));
						       {	/* ./Cgen/cop.scm 1453 */
							  long arg1971_2543;
							  arg1971_2543 =
							     class_num_218___object(block_cgen_cop);
							  {	/* ./Cgen/cop.scm 1453 */
							     obj_t obj_2546;
							     obj_2546 =
								(obj_t) (new1459_2542);
							     (((obj_t) CREF(obj_2546))->header = MAKE_HEADER(arg1971_2543, 0), BUNSPEC);
							  }
						       }
						       {	/* ./Cgen/cop.scm 1453 */
							  object_bglt aux_4029;
							  aux_4029 =
							     (object_bglt) (new1459_2542);
							  OBJECT_WIDENING_SET(aux_4029, BFALSE);
						       }
						       ((((block_bglt) CREF(new1459_2542))->loc) = ((obj_t) arg2056_1779), BUNSPEC);
						       ((((block_bglt) CREF(new1459_2542))->body) = ((cop_bglt) body_2541), BUNSPEC);
						       res2274_2548 = new1459_2542;
						    }
						 }
						 return
						    (obj_t) (res2274_2548);
					      }
					   }
					}
				      else
					{	/* Cgen/capp.scm 68 */
					   bool_t test2079_1801;
					   {	/* Cgen/capp.scm 68 */
					      bool_t test2132_1850;
					      test2132_1850 =
						 is_a__118___object(
						 (obj_t) (fcop_1772), csetq_cgen_cop);
					      if (test2132_1850)
						{	/* ./Ieee/equiv.scm 5508 */
						   obj_t aux_4044;
						   obj_t aux_4038;
						   aux_4044 =
						      (obj_t) (faux_1771);
						   {	/* Cgen/capp.scm 68 */
						      variable_bglt aux_4039;
						      {		/* Cgen/capp.scm 68 */
							 varc_bglt arg2134_1852;
							 {	/* Cgen/capp.scm 68 */
							    csetq_bglt obj_2550;
							    obj_2550 =
							       (csetq_bglt) (fcop_1772);
							    arg2134_1852 =
							       (((csetq_bglt) CREF(obj_2550))->var);
							 }
							 aux_4039 =
							    (((varc_bglt) CREF(arg2134_1852))->variable);
						      }
						      aux_4038 =
							 (obj_t) (aux_4039);
						   }
						   test2079_1801 =
						      (aux_4038 == aux_4044);
						}
					      else
						{	/* Cgen/capp.scm 68 */
						   test2079_1801 = ((bool_t) 0);
						}
					   }
					   if (test2079_1801)
					     {	/* Cgen/capp.scm 68 */
						{	/* Cgen/capp.scm 69 */
						   obj_t arg2080_1802;
						   csequence_bglt arg2081_1803;
						   arg2080_1802 =
						      (((app_ly_162_bglt) CREF(node_1762))->loc);
						   {	/* Cgen/capp.scm 71 */
						      obj_t arg2082_1804;
						      obj_t arg2083_1805;
						      arg2082_1804 =
							 (((app_ly_162_bglt) CREF(node_1762))->loc);
						      {		/* Cgen/capp.scm 75 */
							 local_var_164_bglt arg2084_1806;
							 csequence_bglt arg2085_1807;
							 obj_t arg2086_1808;
							 {	/* Cgen/capp.scm 75 */
							    obj_t arg2091_1812;
							    obj_t arg2092_1813;
							    arg2091_1812 =
							       (((app_ly_162_bglt) CREF(node_1762))->loc);
							    {	/* Cgen/capp.scm 77 */
							       obj_t list2093_1814;
							       {	/* Cgen/capp.scm 77 */
								  obj_t aux_4051;
								  aux_4051 =
								     (obj_t) (vaux_1768);
								  list2093_1814 =
								     MAKE_PAIR(aux_4051, BNIL);
							       }
							       arg2092_1813 = list2093_1814;
							    }
							    {	/* Cgen/capp.scm 75 */
							       local_var_164_bglt res2275_2566;
							       {	/* ./Cgen/cop.scm 1494 */
								  local_var_164_bglt new1536_2560;
								  new1536_2560 =
								     ((local_var_164_bglt) BREF(GC_MALLOC(sizeof(struct local_var_164))));
								  {	/* ./Cgen/cop.scm 1494 */
								     long arg1946_2561;
								     arg1946_2561 =
									class_num_218___object(local_var_164_cgen_cop);
								     {	/* ./Cgen/cop.scm 1494 */
									obj_t obj_2564;
									obj_2564 =
									   (obj_t) (new1536_2560);
									(((obj_t) CREF(obj_2564))->header = MAKE_HEADER(arg1946_2561, 0), BUNSPEC);
								     }
								  }
								  {	/* ./Cgen/cop.scm 1494 */
								     object_bglt aux_4058;
								     aux_4058 =
									(object_bglt) (new1536_2560);
								     OBJECT_WIDENING_SET(aux_4058, BFALSE);
								  }
								  ((((local_var_164_bglt) CREF(new1536_2560))->loc) = ((obj_t) arg2091_1812), BUNSPEC);
								  ((((local_var_164_bglt) CREF(new1536_2560))->vars) = ((obj_t) arg2092_1813), BUNSPEC);
								  res2275_2566 = new1536_2560;
							       }
							       arg2084_1806 = res2275_2566;
							    }
							 }
							 {	/* Cgen/capp.scm 78 */
							    obj_t arg2094_1815;
							    obj_t arg2095_1816;
							    arg2094_1815 =
							       (((app_ly_162_bglt) CREF(node_1762))->loc);
							    {	/* Cgen/capp.scm 80 */
							       obj_t list2096_1817;
							       {	/* Cgen/capp.scm 80 */
								  obj_t aux_4064;
								  aux_4064 =
								     (obj_t) (vcop_1769);
								  list2096_1817 =
								     MAKE_PAIR(aux_4064, BNIL);
							       }
							       arg2095_1816 = list2096_1817;
							    }
							    {	/* Cgen/capp.scm 78 */
							       csequence_bglt res2276_2579;
							       {	/* ./Cgen/cop.scm 1476 */
								  csequence_bglt new1503_2572;
								  new1503_2572 =
								     ((csequence_bglt) BREF(GC_MALLOC(sizeof(struct csequence))));
								  {	/* ./Cgen/cop.scm 1476 */
								     long arg1957_2573;
								     arg1957_2573 =
									class_num_218___object(csequence_cgen_cop);
								     {	/* ./Cgen/cop.scm 1476 */
									obj_t obj_2577;
									obj_2577 =
									   (obj_t) (new1503_2572);
									(((obj_t) CREF(obj_2577))->header = MAKE_HEADER(arg1957_2573, 0), BUNSPEC);
								     }
								  }
								  {	/* ./Cgen/cop.scm 1476 */
								     object_bglt aux_4071;
								     aux_4071 =
									(object_bglt) (new1503_2572);
								     OBJECT_WIDENING_SET(aux_4071, BFALSE);
								  }
								  ((((csequence_bglt) CREF(new1503_2572))->loc) = ((obj_t) arg2094_1815), BUNSPEC);
								  ((((csequence_bglt) CREF(new1503_2572))->c_exp__163) = ((bool_t) ((bool_t) 0)), BUNSPEC);
								  ((((csequence_bglt) CREF(new1503_2572))->cops) = ((obj_t) arg2095_1816), BUNSPEC);
								  res2276_2579 = new1503_2572;
							       }
							       arg2085_1807 = res2276_2579;
							    }
							 }
							 {	/* Cgen/capp.scm 81 */
							    capply_bglt arg2098_1818;
							    {	/* Cgen/capp.scm 81 */
							       obj_t arg2099_1819;
							       cop_bglt arg2100_1820;
							       varc_bglt arg2101_1821;
							       arg2099_1819 =
								  (((app_ly_162_bglt) CREF(node_1762))->loc);
							       {	/* Cgen/capp.scm 83 */
								  csetq_bglt obj_2581;
								  obj_2581 =
								     (csetq_bglt) (fcop_1772);
								  arg2100_1820 =
								     (((csetq_bglt) CREF(obj_2581))->value);
							       }
							       {	/* Cgen/capp.scm 84 */
								  obj_t arg2103_1822;
								  arg2103_1822 =
								     (((app_ly_162_bglt) CREF(node_1762))->loc);
								  {	/* Cgen/capp.scm 84 */
								     varc_bglt res2277_2591;
								     {	/* Cgen/capp.scm 84 */
									variable_bglt variable_2584;
									variable_2584 =
									   (variable_bglt) (vaux_1768);
									{	/* ./Cgen/cop.scm 1465 */
									   varc_bglt new1483_2585;
									   new1483_2585 =
									      ((varc_bglt) BREF(GC_MALLOC(sizeof(struct varc))));
									   {	/* ./Cgen/cop.scm 1465 */
									      long arg1963_2586;
									      arg1963_2586 =
										 class_num_218___object(varc_cgen_cop);
									      {		/* ./Cgen/cop.scm 1465 */
										 obj_t obj_2589;
										 obj_2589 =
										    (obj_t) (new1483_2585);
										 (((obj_t) CREF(obj_2589))->header = MAKE_HEADER(arg1963_2586, 0), BUNSPEC);
									      }
									   }
									   {	/* ./Cgen/cop.scm 1465 */
									      object_bglt aux_4086;
									      aux_4086 =
										 (object_bglt) (new1483_2585);
									      OBJECT_WIDENING_SET(aux_4086, BFALSE);
									   }
									   ((((varc_bglt) CREF(new1483_2585))->loc) = ((obj_t) arg2103_1822), BUNSPEC);
									   ((((varc_bglt) CREF(new1483_2585))->variable) = ((variable_bglt) variable_2584), BUNSPEC);
									   res2277_2591 = new1483_2585;
									}
								     }
								     arg2101_1821 = res2277_2591;
								  }
							       }
							       {	/* Cgen/capp.scm 81 */
								  capply_bglt res2278_2602;
								  {	/* Cgen/capp.scm 81 */
								     cop_bglt arg_2594;
								     arg_2594 =
									(cop_bglt) (arg2101_1821);
								     {	/* ./Cgen/cop.scm 1502 */
									capply_bglt new1550_2595;
									new1550_2595 =
									   ((capply_bglt) BREF(GC_MALLOC(sizeof(struct capply))));
									{	/* ./Cgen/cop.scm 1502 */
									   long arg1942_2596;
									   arg1942_2596 =
									      class_num_218___object(capply_cgen_cop);
									   {	/* ./Cgen/cop.scm 1502 */
									      obj_t obj_2600;
									      obj_2600 =
										 (obj_t) (new1550_2595);
									      (((obj_t) CREF(obj_2600))->header = MAKE_HEADER(arg1942_2596, 0), BUNSPEC);
									   }
									}
									{	/* ./Cgen/cop.scm 1502 */
									   object_bglt aux_4096;
									   aux_4096 =
									      (object_bglt) (new1550_2595);
									   OBJECT_WIDENING_SET(aux_4096, BFALSE);
									}
									((((capply_bglt) CREF(new1550_2595))->loc) = ((obj_t) arg2099_1819), BUNSPEC);
									((((capply_bglt) CREF(new1550_2595))->fun) = ((cop_bglt) arg2100_1820), BUNSPEC);
									((((capply_bglt) CREF(new1550_2595))->arg) = ((cop_bglt) arg_2594), BUNSPEC);
									res2278_2602 = new1550_2595;
								     }
								  }
								  arg2098_1818 = res2278_2602;
							       }
							    }
							    arg2086_1808 =
							       PROCEDURE_ENTRY(kont_1763) (kont_1763,
							       (obj_t) (arg2098_1818), BEOA);
							 }
							 {	/* Cgen/capp.scm 73 */
							    obj_t list2087_1809;
							    {	/* Cgen/capp.scm 73 */
							       obj_t arg2088_1810;
							       {	/* Cgen/capp.scm 73 */
								  obj_t arg2090_1811;
								  arg2090_1811 =
								     MAKE_PAIR(arg2086_1808, BNIL);
								  {	/* Cgen/capp.scm 73 */
								     obj_t aux_4106;
								     aux_4106 =
									(obj_t) (arg2085_1807);
								     arg2088_1810 =
									MAKE_PAIR(aux_4106, arg2090_1811);
								  }
							       }
							       {	/* Cgen/capp.scm 73 */
								  obj_t aux_4109;
								  aux_4109 =
								     (obj_t) (arg2084_1806);
								  list2087_1809 =
								     MAKE_PAIR(aux_4109, arg2088_1810);
							       }
							    }
							    arg2083_1805 = list2087_1809;
							 }
						      }
						      {		/* Cgen/capp.scm 71 */
							 csequence_bglt res2279_2614;
							 {	/* ./Cgen/cop.scm 1476 */
							    csequence_bglt new1503_2607;
							    new1503_2607 =
							       ((csequence_bglt) BREF(GC_MALLOC(sizeof(struct csequence))));
							    {	/* ./Cgen/cop.scm 1476 */
							       long arg1957_2608;
							       arg1957_2608 =
								  class_num_218___object(csequence_cgen_cop);
							       {	/* ./Cgen/cop.scm 1476 */
								  obj_t obj_2612;
								  obj_2612 =
								     (obj_t) (new1503_2607);
								  (((obj_t) CREF(obj_2612))->header = MAKE_HEADER(arg1957_2608, 0), BUNSPEC);
							       }
							    }
							    {	/* ./Cgen/cop.scm 1476 */
							       object_bglt aux_4116;
							       aux_4116 =
								  (object_bglt) (new1503_2607);
							       OBJECT_WIDENING_SET(aux_4116, BFALSE);
							    }
							    ((((csequence_bglt) CREF(new1503_2607))->loc) = ((obj_t) arg2082_1804), BUNSPEC);
							    ((((csequence_bglt) CREF(new1503_2607))->c_exp__163) = ((bool_t) ((bool_t) 0)), BUNSPEC);
							    ((((csequence_bglt) CREF(new1503_2607))->cops) = ((obj_t) arg2083_1805), BUNSPEC);
							    res2279_2614 = new1503_2607;
							 }
							 arg2081_1803 = res2279_2614;
						      }
						   }
						   {	/* Cgen/capp.scm 69 */
						      block_bglt res2280_2623;
						      {		/* Cgen/capp.scm 69 */
							 cop_bglt body_2616;
							 body_2616 =
							    (cop_bglt) (arg2081_1803);
							 {	/* ./Cgen/cop.scm 1453 */
							    block_bglt new1459_2617;
							    new1459_2617 =
							       ((block_bglt) BREF(GC_MALLOC(sizeof(struct block))));
							    {	/* ./Cgen/cop.scm 1453 */
							       long arg1971_2618;
							       arg1971_2618 =
								  class_num_218___object(block_cgen_cop);
							       {	/* ./Cgen/cop.scm 1453 */
								  obj_t obj_2621;
								  obj_2621 =
								     (obj_t) (new1459_2617);
								  (((obj_t) CREF(obj_2621))->header = MAKE_HEADER(arg1971_2618, 0), BUNSPEC);
							       }
							    }
							    {	/* ./Cgen/cop.scm 1453 */
							       object_bglt aux_4127;
							       aux_4127 =
								  (object_bglt) (new1459_2617);
							       OBJECT_WIDENING_SET(aux_4127, BFALSE);
							    }
							    ((((block_bglt) CREF(new1459_2617))->loc) = ((obj_t) arg2080_1802), BUNSPEC);
							    ((((block_bglt) CREF(new1459_2617))->body) = ((cop_bglt) body_2616), BUNSPEC);
							    res2280_2623 = new1459_2617;
							 }
						      }
						      return
							 (obj_t) (res2280_2623);
						   }
						}
					     }
					   else
					     {	/* Cgen/capp.scm 68 */
						{	/* Cgen/capp.scm 88 */
						   obj_t arg2105_1824;
						   csequence_bglt arg2106_1825;
						   arg2105_1824 =
						      (((app_ly_162_bglt) CREF(node_1762))->loc);
						   {	/* Cgen/capp.scm 90 */
						      obj_t arg2107_1826;
						      obj_t arg2108_1827;
						      arg2107_1826 =
							 (((app_ly_162_bglt) CREF(node_1762))->loc);
						      {		/* Cgen/capp.scm 94 */
							 local_var_164_bglt arg2109_1828;
							 csequence_bglt arg2110_1829;
							 obj_t arg2111_1830;
							 {	/* Cgen/capp.scm 94 */
							    obj_t arg2115_1834;
							    obj_t arg2116_1835;
							    arg2115_1834 =
							       (((app_ly_162_bglt) CREF(node_1762))->loc);
							    {	/* Cgen/capp.scm 96 */
							       obj_t list2117_1836;
							       {	/* Cgen/capp.scm 96 */
								  obj_t arg2118_1837;
								  {	/* Cgen/capp.scm 96 */
								     obj_t aux_4136;
								     aux_4136 =
									(obj_t) (vaux_1768);
								     arg2118_1837 =
									MAKE_PAIR(aux_4136, BNIL);
								  }
								  {	/* Cgen/capp.scm 96 */
								     obj_t aux_4139;
								     aux_4139 =
									(obj_t) (faux_1771);
								     list2117_1836 =
									MAKE_PAIR(aux_4139, arg2118_1837);
								  }
							       }
							       arg2116_1835 = list2117_1836;
							    }
							    {	/* Cgen/capp.scm 94 */
							       local_var_164_bglt res2281_2636;
							       {	/* ./Cgen/cop.scm 1494 */
								  local_var_164_bglt new1536_2630;
								  new1536_2630 =
								     ((local_var_164_bglt) BREF(GC_MALLOC(sizeof(struct local_var_164))));
								  {	/* ./Cgen/cop.scm 1494 */
								     long arg1946_2631;
								     arg1946_2631 =
									class_num_218___object(local_var_164_cgen_cop);
								     {	/* ./Cgen/cop.scm 1494 */
									obj_t obj_2634;
									obj_2634 =
									   (obj_t) (new1536_2630);
									(((obj_t) CREF(obj_2634))->header = MAKE_HEADER(arg1946_2631, 0), BUNSPEC);
								     }
								  }
								  {	/* ./Cgen/cop.scm 1494 */
								     object_bglt aux_4146;
								     aux_4146 =
									(object_bglt) (new1536_2630);
								     OBJECT_WIDENING_SET(aux_4146, BFALSE);
								  }
								  ((((local_var_164_bglt) CREF(new1536_2630))->loc) = ((obj_t) arg2115_1834), BUNSPEC);
								  ((((local_var_164_bglt) CREF(new1536_2630))->vars) = ((obj_t) arg2116_1835), BUNSPEC);
								  res2281_2636 = new1536_2630;
							       }
							       arg2109_1828 = res2281_2636;
							    }
							 }
							 {	/* Cgen/capp.scm 97 */
							    obj_t arg2119_1838;
							    obj_t arg2120_1839;
							    arg2119_1838 =
							       (((app_ly_162_bglt) CREF(node_1762))->loc);
							    {	/* Cgen/capp.scm 99 */
							       obj_t list2121_1840;
							       {	/* Cgen/capp.scm 99 */
								  obj_t arg2122_1841;
								  {	/* Cgen/capp.scm 99 */
								     obj_t aux_4152;
								     aux_4152 =
									(obj_t) (vcop_1769);
								     arg2122_1841 =
									MAKE_PAIR(aux_4152, BNIL);
								  }
								  {	/* Cgen/capp.scm 99 */
								     obj_t aux_4155;
								     aux_4155 =
									(obj_t) (fcop_1772);
								     list2121_1840 =
									MAKE_PAIR(aux_4155, arg2122_1841);
								  }
							       }
							       arg2120_1839 = list2121_1840;
							    }
							    {	/* Cgen/capp.scm 97 */
							       csequence_bglt res2282_2649;
							       {	/* ./Cgen/cop.scm 1476 */
								  csequence_bglt new1503_2642;
								  new1503_2642 =
								     ((csequence_bglt) BREF(GC_MALLOC(sizeof(struct csequence))));
								  {	/* ./Cgen/cop.scm 1476 */
								     long arg1957_2643;
								     arg1957_2643 =
									class_num_218___object(csequence_cgen_cop);
								     {	/* ./Cgen/cop.scm 1476 */
									obj_t obj_2647;
									obj_2647 =
									   (obj_t) (new1503_2642);
									(((obj_t) CREF(obj_2647))->header = MAKE_HEADER(arg1957_2643, 0), BUNSPEC);
								     }
								  }
								  {	/* ./Cgen/cop.scm 1476 */
								     object_bglt aux_4162;
								     aux_4162 =
									(object_bglt) (new1503_2642);
								     OBJECT_WIDENING_SET(aux_4162, BFALSE);
								  }
								  ((((csequence_bglt) CREF(new1503_2642))->loc) = ((obj_t) arg2119_1838), BUNSPEC);
								  ((((csequence_bglt) CREF(new1503_2642))->c_exp__163) = ((bool_t) ((bool_t) 0)), BUNSPEC);
								  ((((csequence_bglt) CREF(new1503_2642))->cops) = ((obj_t) arg2120_1839), BUNSPEC);
								  res2282_2649 = new1503_2642;
							       }
							       arg2110_1829 = res2282_2649;
							    }
							 }
							 {	/* Cgen/capp.scm 100 */
							    capply_bglt arg2123_1842;
							    {	/* Cgen/capp.scm 100 */
							       obj_t arg2124_1843;
							       varc_bglt arg2125_1844;
							       varc_bglt arg2126_1845;
							       arg2124_1843 =
								  (((app_ly_162_bglt) CREF(node_1762))->loc);
							       {	/* Cgen/capp.scm 102 */
								  obj_t arg2127_1846;
								  arg2127_1846 =
								     (((app_ly_162_bglt) CREF(node_1762))->loc);
								  {	/* Cgen/capp.scm 102 */
								     varc_bglt res2283_2660;
								     {	/* Cgen/capp.scm 102 */
									variable_bglt variable_2653;
									variable_2653 =
									   (variable_bglt) (faux_1771);
									{	/* ./Cgen/cop.scm 1465 */
									   varc_bglt new1483_2654;
									   new1483_2654 =
									      ((varc_bglt) BREF(GC_MALLOC(sizeof(struct varc))));
									   {	/* ./Cgen/cop.scm 1465 */
									      long arg1963_2655;
									      arg1963_2655 =
										 class_num_218___object(varc_cgen_cop);
									      {		/* ./Cgen/cop.scm 1465 */
										 obj_t obj_2658;
										 obj_2658 =
										    (obj_t) (new1483_2654);
										 (((obj_t) CREF(obj_2658))->header = MAKE_HEADER(arg1963_2655, 0), BUNSPEC);
									      }
									   }
									   {	/* ./Cgen/cop.scm 1465 */
									      object_bglt aux_4175;
									      aux_4175 =
										 (object_bglt) (new1483_2654);
									      OBJECT_WIDENING_SET(aux_4175, BFALSE);
									   }
									   ((((varc_bglt) CREF(new1483_2654))->loc) = ((obj_t) arg2127_1846), BUNSPEC);
									   ((((varc_bglt) CREF(new1483_2654))->variable) = ((variable_bglt) variable_2653), BUNSPEC);
									   res2283_2660 = new1483_2654;
									}
								     }
								     arg2125_1844 = res2283_2660;
								  }
							       }
							       {	/* Cgen/capp.scm 105 */
								  obj_t arg2129_1848;
								  arg2129_1848 =
								     (((app_ly_162_bglt) CREF(node_1762))->loc);
								  {	/* Cgen/capp.scm 105 */
								     varc_bglt res2284_2670;
								     {	/* Cgen/capp.scm 105 */
									variable_bglt variable_2663;
									variable_2663 =
									   (variable_bglt) (vaux_1768);
									{	/* ./Cgen/cop.scm 1465 */
									   varc_bglt new1483_2664;
									   new1483_2664 =
									      ((varc_bglt) BREF(GC_MALLOC(sizeof(struct varc))));
									   {	/* ./Cgen/cop.scm 1465 */
									      long arg1963_2665;
									      arg1963_2665 =
										 class_num_218___object(varc_cgen_cop);
									      {		/* ./Cgen/cop.scm 1465 */
										 obj_t obj_2668;
										 obj_2668 =
										    (obj_t) (new1483_2664);
										 (((obj_t) CREF(obj_2668))->header = MAKE_HEADER(arg1963_2665, 0), BUNSPEC);
									      }
									   }
									   {	/* ./Cgen/cop.scm 1465 */
									      object_bglt aux_4186;
									      aux_4186 =
										 (object_bglt) (new1483_2664);
									      OBJECT_WIDENING_SET(aux_4186, BFALSE);
									   }
									   ((((varc_bglt) CREF(new1483_2664))->loc) = ((obj_t) arg2129_1848), BUNSPEC);
									   ((((varc_bglt) CREF(new1483_2664))->variable) = ((variable_bglt) variable_2663), BUNSPEC);
									   res2284_2670 = new1483_2664;
									}
								     }
								     arg2126_1845 = res2284_2670;
								  }
							       }
							       {	/* Cgen/capp.scm 100 */
								  capply_bglt res2285_2681;
								  {	/* Cgen/capp.scm 100 */
								     cop_bglt fun_2672;
								     cop_bglt arg_2673;
								     fun_2672 =
									(cop_bglt) (arg2125_1844);
								     arg_2673 =
									(cop_bglt) (arg2126_1845);
								     {	/* ./Cgen/cop.scm 1502 */
									capply_bglt new1550_2674;
									new1550_2674 =
									   ((capply_bglt) BREF(GC_MALLOC(sizeof(struct capply))));
									{	/* ./Cgen/cop.scm 1502 */
									   long arg1942_2675;
									   arg1942_2675 =
									      class_num_218___object(capply_cgen_cop);
									   {	/* ./Cgen/cop.scm 1502 */
									      obj_t obj_2679;
									      obj_2679 =
										 (obj_t) (new1550_2674);
									      (((obj_t) CREF(obj_2679))->header = MAKE_HEADER(arg1942_2675, 0), BUNSPEC);
									   }
									}
									{	/* ./Cgen/cop.scm 1502 */
									   object_bglt aux_4197;
									   aux_4197 =
									      (object_bglt) (new1550_2674);
									   OBJECT_WIDENING_SET(aux_4197, BFALSE);
									}
									((((capply_bglt) CREF(new1550_2674))->loc) = ((obj_t) arg2124_1843), BUNSPEC);
									((((capply_bglt) CREF(new1550_2674))->fun) = ((cop_bglt) fun_2672), BUNSPEC);
									((((capply_bglt) CREF(new1550_2674))->arg) = ((cop_bglt) arg_2673), BUNSPEC);
									res2285_2681 = new1550_2674;
								     }
								  }
								  arg2123_1842 = res2285_2681;
							       }
							    }
							    arg2111_1830 =
							       PROCEDURE_ENTRY(kont_1763) (kont_1763,
							       (obj_t) (arg2123_1842), BEOA);
							 }
							 {	/* Cgen/capp.scm 92 */
							    obj_t list2112_1831;
							    {	/* Cgen/capp.scm 92 */
							       obj_t arg2113_1832;
							       {	/* Cgen/capp.scm 92 */
								  obj_t arg2114_1833;
								  arg2114_1833 =
								     MAKE_PAIR(arg2111_1830, BNIL);
								  {	/* Cgen/capp.scm 92 */
								     obj_t aux_4207;
								     aux_4207 =
									(obj_t) (arg2110_1829);
								     arg2113_1832 =
									MAKE_PAIR(aux_4207, arg2114_1833);
								  }
							       }
							       {	/* Cgen/capp.scm 92 */
								  obj_t aux_4210;
								  aux_4210 =
								     (obj_t) (arg2109_1828);
								  list2112_1831 =
								     MAKE_PAIR(aux_4210, arg2113_1832);
							       }
							    }
							    arg2108_1827 = list2112_1831;
							 }
						      }
						      {		/* Cgen/capp.scm 90 */
							 csequence_bglt res2286_2693;
							 {	/* ./Cgen/cop.scm 1476 */
							    csequence_bglt new1503_2686;
							    new1503_2686 =
							       ((csequence_bglt) BREF(GC_MALLOC(sizeof(struct csequence))));
							    {	/* ./Cgen/cop.scm 1476 */
							       long arg1957_2687;
							       arg1957_2687 =
								  class_num_218___object(csequence_cgen_cop);
							       {	/* ./Cgen/cop.scm 1476 */
								  obj_t obj_2691;
								  obj_2691 =
								     (obj_t) (new1503_2686);
								  (((obj_t) CREF(obj_2691))->header = MAKE_HEADER(arg1957_2687, 0), BUNSPEC);
							       }
							    }
							    {	/* ./Cgen/cop.scm 1476 */
							       object_bglt aux_4217;
							       aux_4217 =
								  (object_bglt) (new1503_2686);
							       OBJECT_WIDENING_SET(aux_4217, BFALSE);
							    }
							    ((((csequence_bglt) CREF(new1503_2686))->loc) = ((obj_t) arg2107_1826), BUNSPEC);
							    ((((csequence_bglt) CREF(new1503_2686))->c_exp__163) = ((bool_t) ((bool_t) 0)), BUNSPEC);
							    ((((csequence_bglt) CREF(new1503_2686))->cops) = ((obj_t) arg2108_1827), BUNSPEC);
							    res2286_2693 = new1503_2686;
							 }
							 arg2106_1825 = res2286_2693;
						      }
						   }
						   {	/* Cgen/capp.scm 88 */
						      block_bglt res2287_2702;
						      {		/* Cgen/capp.scm 88 */
							 cop_bglt body_2695;
							 body_2695 =
							    (cop_bglt) (arg2106_1825);
							 {	/* ./Cgen/cop.scm 1453 */
							    block_bglt new1459_2696;
							    new1459_2696 =
							       ((block_bglt) BREF(GC_MALLOC(sizeof(struct block))));
							    {	/* ./Cgen/cop.scm 1453 */
							       long arg1971_2697;
							       arg1971_2697 =
								  class_num_218___object(block_cgen_cop);
							       {	/* ./Cgen/cop.scm 1453 */
								  obj_t obj_2700;
								  obj_2700 =
								     (obj_t) (new1459_2696);
								  (((obj_t) CREF(obj_2700))->header = MAKE_HEADER(arg1971_2697, 0), BUNSPEC);
							       }
							    }
							    {	/* ./Cgen/cop.scm 1453 */
							       object_bglt aux_4228;
							       aux_4228 =
								  (object_bglt) (new1459_2696);
							       OBJECT_WIDENING_SET(aux_4228, BFALSE);
							    }
							    ((((block_bglt) CREF(new1459_2696))->loc) = ((obj_t) arg2105_1824), BUNSPEC);
							    ((((block_bglt) CREF(new1459_2696))->body) = ((cop_bglt) body_2695), BUNSPEC);
							    res2287_2702 = new1459_2696;
							 }
						      }
						      return
							 (obj_t) (res2287_2702);
						   }
						}
					     }
					}
				   }
			      }
			   }
			}
		     }
		  }
	       }
	    }
	 }
      }
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_cgen_capp()
{
   AN_OBJECT;
   {	/* Cgen/capp.scm 14 */
      module_initialization_70_tools_trace(((long) 0), "CGEN_CAPP");
      module_initialization_70_tools_error(((long) 0), "CGEN_CAPP");
      module_initialization_70_tools_shape(((long) 0), "CGEN_CAPP");
      module_initialization_70_type_type(((long) 0), "CGEN_CAPP");
      module_initialization_70_type_tools(((long) 0), "CGEN_CAPP");
      module_initialization_70_type_cache(((long) 0), "CGEN_CAPP");
      module_initialization_70_ast_var(((long) 0), "CGEN_CAPP");
      module_initialization_70_ast_node(((long) 0), "CGEN_CAPP");
      module_initialization_70_ast_local(((long) 0), "CGEN_CAPP");
      module_initialization_70_effect_effect(((long) 0), "CGEN_CAPP");
      module_initialization_70_cgen_emit(((long) 0), "CGEN_CAPP");
      module_initialization_70_cgen_cop(((long) 0), "CGEN_CAPP");
      return
	 module_initialization_70_cgen_cgen(((long) 0), "CGEN_CAPP");
   }
}
